package bibles

func LA_NVBSE_LoadInfo(CurrentBible *Bible) {
	CurrentBible.SetInfo("la.nvbse", "Nova Vulgata (Bibliorum Sacrorum Editio)")
	CurrentBible.AddBook("VPGN", "Genesis")
	CurrentBible.AddBook("VPEX", "Exodus")
	CurrentBible.AddBook("VPLV", "Leviticus")
	CurrentBible.AddBook("VPNM", "Numeri")
	CurrentBible.AddBook("VPDT", "Deuteronomii")
	CurrentBible.AddBook("VHIE", "Iosue")
	CurrentBible.AddBook("VHID", "Iudicum")
	CurrentBible.AddBook("VHRT", "Ruth")
	CurrentBible.AddBook("VH1S", "I Samuelis")
	CurrentBible.AddBook("VH2S", "II Samuelis")
	CurrentBible.AddBook("VH1R", "I Regum")
	CurrentBible.AddBook("VH2R", "II Regum")
	CurrentBible.AddBook("VH1P", "I Paralipomenon")
	CurrentBible.AddBook("VH2P", "II Paralipomenon")
	CurrentBible.AddBook("VHED", "Esdrae")
	CurrentBible.AddBook("VHNH", "Nehemiae")
	CurrentBible.AddBook("VHTB", "Thobis")
	CurrentBible.AddBook("VHIH", "Iudith")
	CurrentBible.AddBook("VHET", "Esther")
	CurrentBible.AddBook("VSIB", "Iob")
	CurrentBible.AddBook("VSPS", "Psalmorum")
	CurrentBible.AddBook("VSPR", "Proverbiorum")
	CurrentBible.AddBook("VSEE", "Ecclesiastes")
	CurrentBible.AddBook("VSCC", "Canticum Canticorum")
	CurrentBible.AddBook("VSSP", "Sapientiae")
	CurrentBible.AddBook("VSEI", "Ecclesiasticus")
	CurrentBible.AddBook("VMIS", "Isaiae")
	CurrentBible.AddBook("VMIE", "Ieremiae")
	CurrentBible.AddBook("VMLM", "Lamentationes")
	CurrentBible.AddBook("VMBR", "Baruch")
	CurrentBible.AddBook("VMEZ", "Ezechielis")
	CurrentBible.AddBook("VMDN", "Danielis")
	CurrentBible.AddBook("VNOS", "Osee")
	CurrentBible.AddBook("VNIL", "Ioel")
	CurrentBible.AddBook("VNAM", "Amos")
	CurrentBible.AddBook("VNAB", "Abdiae")
	CurrentBible.AddBook("VNIN", "Ionae")
	CurrentBible.AddBook("VNMI", "Michaeae")
	CurrentBible.AddBook("VNNH", "Nahum")
	CurrentBible.AddBook("VNHA", "Habacuc")
	CurrentBible.AddBook("VNSO", "Sophoniae")
	CurrentBible.AddBook("VNAG", "Aggaei")
	CurrentBible.AddBook("VNZA", "Zachariae")
	CurrentBible.AddBook("VNML", "Malachiae")
	CurrentBible.AddBook("VH1M", "I Maccabaeorum")
	CurrentBible.AddBook("VH2M", "II Maccabaeorum")
	CurrentBible.AddBook("NEMT", "Matthaeum")
	CurrentBible.AddBook("NEMC", "Marcum")
	CurrentBible.AddBook("NELC", "Lucam")
	CurrentBible.AddBook("NEIO", "Ioannem")
	CurrentBible.AddBook("NTAA", "Actus Apostolorum")
	CurrentBible.AddBook("NPRM", "Romanos")
	CurrentBible.AddBook("NP1C", "I Corinthios")
	CurrentBible.AddBook("NP2C", "II Corinthios")
	CurrentBible.AddBook("NPGA", "Galatas")
	CurrentBible.AddBook("NPEP", "Ephesios")
	CurrentBible.AddBook("NPPP", "Philippenses")
	CurrentBible.AddBook("NPCL", "Colossenses")
	CurrentBible.AddBook("NP1E", "I Thessalonicenses")
	CurrentBible.AddBook("NP2E", "II Thessalonicenses")
	CurrentBible.AddBook("NP1I", "I Timotheum")
	CurrentBible.AddBook("NP2I", "II Timotheum")
	CurrentBible.AddBook("NPTT", "Titum")
	CurrentBible.AddBook("NPPM", "Philemonem")
	CurrentBible.AddBook("NTHB", "Hebraeos")
	CurrentBible.AddBook("NCIB", "Iacobi")
	CurrentBible.AddBook("NC1P", "I Petri")
	CurrentBible.AddBook("NC2P", "II Petri")
	CurrentBible.AddBook("NC1I", "I Ioannis")
	CurrentBible.AddBook("NC2I", "II Ioannis")
	CurrentBible.AddBook("NC3I", "III Ioannis")
	CurrentBible.AddBook("NCID", "Iudae")
	CurrentBible.AddBook("NTAI", "Apocalypsis Ioannis")
}

func LA_NVBSE_LoadBooks(CurrentBible *Bible) {
	for x := range CurrentBible.Codes {
		var cb *Book = NewBook(CurrentBible.Codes[x], CurrentBible.Names[x])
		switch CurrentBible.Codes[x] {
		case "VPGN":
			LA_NVBSE_LoadVPGNChapters(cb)
		case "VPEX":
			LA_NVBSE_LoadVPEXChapters(cb)
		case "VPLV":
			LA_NVBSE_LoadVPLVChapters(cb)
		case "VPNM":
			LA_NVBSE_LoadVPNMChapters(cb)
		case "VPDT":
			LA_NVBSE_LoadVPDTChapters(cb)
		case "VHIE":
			LA_NVBSE_LoadVHIEChapters(cb)
		case "VHID":
			LA_NVBSE_LoadVHIDChapters(cb)
		case "VH1S":
			LA_NVBSE_LoadVH1SChapters(cb)
		case "VH2S":
			LA_NVBSE_LoadVH2SChapters(cb)
		case "VH1R":
			LA_NVBSE_LoadVH1RChapters(cb)
		case "VH2R":
			LA_NVBSE_LoadVH2RChapters(cb)
		case "VH1P":
			LA_NVBSE_LoadVH1PChapters(cb)
		case "VH2P":
			LA_NVBSE_LoadVH2PChapters(cb)
		case "VHED":
			LA_NVBSE_LoadVHEDChapters(cb)
		case "VHNH":
			LA_NVBSE_LoadVHNHChapters(cb)
		case "VH1M":
			LA_NVBSE_LoadVH1MChapters(cb)
		case "VH2M":
			LA_NVBSE_LoadVH2MChapters(cb)
		case "VMIS":
			LA_NVBSE_LoadVMISChapters(cb)
		case "VMIE":
			LA_NVBSE_LoadVMIEChapters(cb)
		case "VMEZ":
			LA_NVBSE_LoadVMEZChapters(cb)
		case "VNOS":
			LA_NVBSE_LoadVNOSChapters(cb)
		case "VNIL":
			LA_NVBSE_LoadVNILChapters(cb)
		case "VNAM":
			LA_NVBSE_LoadVNAMChapters(cb)
		case "VNAB":
			LA_NVBSE_LoadVNABChapters(cb)
		case "VNIN":
			LA_NVBSE_LoadVNINChapters(cb)
		case "VNMI":
			LA_NVBSE_LoadVNMIChapters(cb)
		case "VNNH":
			LA_NVBSE_LoadVNNHChapters(cb)
		case "VNHA":
			LA_NVBSE_LoadVNHAChapters(cb)
		case "VNSO":
			LA_NVBSE_LoadVNSOChapters(cb)
		case "VNAG":
			LA_NVBSE_LoadVNAGChapters(cb)
		case "VNZA":
			LA_NVBSE_LoadVNZAChapters(cb)
		case "VNML":
			LA_NVBSE_LoadVNMLChapters(cb)
		case "VMDN":
			LA_NVBSE_LoadVMDNChapters(cb)
		case "VSIB":
			LA_NVBSE_LoadVSIBChapters(cb)
		case "VSPR":
			LA_NVBSE_LoadVSPRChapters(cb)
		case "VSEE":
			LA_NVBSE_LoadVSEEChapters(cb)
		case "VSCC":
			LA_NVBSE_LoadVSCCChapters(cb)
		case "VHRT":
			LA_NVBSE_LoadVHRTChapters(cb)
		case "VMLM":
			LA_NVBSE_LoadVMLMChapters(cb)
		case "VHET":
			LA_NVBSE_LoadVHETChapters(cb)
		case "VHTB":
			LA_NVBSE_LoadVHTBChapters(cb)
		case "VHIH":
			LA_NVBSE_LoadVHIHChapters(cb)
		case "VMBR":
			LA_NVBSE_LoadVMBRChapters(cb)
		case "VSSP":
			LA_NVBSE_LoadVSSPChapters(cb)
		case "VSEI":
			LA_NVBSE_LoadVSEIChapters(cb)
		case "VSPS":
			LA_NVBSE_LoadVSPSChapters(cb)
		case "NEMT":
			LA_NVBSE_LoadNEMTChapters(cb)
		case "NEMC":
			LA_NVBSE_LoadNEMCChapters(cb)
		case "NELC":
			LA_NVBSE_LoadNELCChapters(cb)
		case "NEIO":
			LA_NVBSE_LoadNEIOChapters(cb)
		case "NTAA":
			LA_NVBSE_LoadNTAAChapters(cb)
		case "NPRM":
			LA_NVBSE_LoadNPRMChapters(cb)
		case "NP1C":
			LA_NVBSE_LoadNP1CChapters(cb)
		case "NP2C":
			LA_NVBSE_LoadNP2CChapters(cb)
		case "NPGA":
			LA_NVBSE_LoadNPGAChapters(cb)
		case "NPEP":
			LA_NVBSE_LoadNPEPChapters(cb)
		case "NPPP":
			LA_NVBSE_LoadNPPPChapters(cb)
		case "NPCL":
			LA_NVBSE_LoadNPCLChapters(cb)
		case "NPPM":
			LA_NVBSE_LoadNPPMChapters(cb)
		case "NP1E":
			LA_NVBSE_LoadNP1EChapters(cb)
		case "NP2E":
			LA_NVBSE_LoadNP2EChapters(cb)
		case "NP1I":
			LA_NVBSE_LoadNP1IChapters(cb)
		case "NP2I":
			LA_NVBSE_LoadNP2IChapters(cb)
		case "NPTT":
			LA_NVBSE_LoadNPTTChapters(cb)
		case "NTHB":
			LA_NVBSE_LoadNTHBChapters(cb)
		case "NCIB":
			LA_NVBSE_LoadNCIBChapters(cb)
		case "NC1P":
			LA_NVBSE_LoadNC1PChapters(cb)
		case "NC2P":
			LA_NVBSE_LoadNC2PChapters(cb)
		case "NCID":
			LA_NVBSE_LoadNCIDChapters(cb)
		case "NC1I":
			LA_NVBSE_LoadNC1IChapters(cb)
		case "NC2I":
			LA_NVBSE_LoadNC2IChapters(cb)
		case "NC3I":
			LA_NVBSE_LoadNC3IChapters(cb)
		case "NTAI":
			LA_NVBSE_LoadNTAIChapters(cb)
		}
		CurrentBible.Books = append(CurrentBible.Books, *cb)
	}
}

func LA_NVBSE_LoadNC1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Quod fuit ab initio, quod audi vimus, quod vidimus oculis no stris, quod perspeximus, et manus nostrae contrectaverunt de verbo vitae"
,"2":"- et vita apparuit, et vidimus et testamur et annuntiamus vobis vitam aeternam, quae erat coram Patre et apparuit nobis -"
,"3":"quod vidimus et audivimus, annuntiamus et vobis, ut et vos communionem habeatis nobiscum. Communio autem nostra est cum Patre et cum Filio eius Iesu Christo."
,"4":"Et haec scribimus nos, ut gaudium nostrum sit plenum."
,"5":"Et haec est annuntiatio, quam audivimus ab eo et annuntiamus vobis, quoniam Deus lux est, et tenebrae in eo non sunt ullae."
,"6":"Si dixerimus quoniam communionem habemus cum eo, et in tenebris ambulamus, mentimur et non facimus veritatem;"
,"7":"si autem in luce ambulemus, sicut ipse est in luce, communionem habemus ad invicem, et sanguis Iesu Filii eius mundat nos ab omni peccato."
,"8":"Si dixerimus quoniam peccatum non habemus, nosmetipsos seducimus, et veritas in nobis non est."
,"9":"Si confiteamur peccata nostra, fidelis est et iustus, ut remittat nobis peccata et emundet nos ab omni iniustitia."
,"10":"Si dixerimus quoniam non peccavimus, mendacem facimus eum, et verbum eius non est in nobis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Filioli mei, haec scribo vobis, ut non peccetis. Sed si quis pecca verit, advocatum habemus ad Patrem, Iesum Christum iustum;"
,"2":"et ipse est propitiatio pro peccatis nostris, non pro nostris autem tantum sed etiam pro totius mundi."
,"3":"Et in hoc cognoscimus quoniam novimus eum: si mandata eius servemus."
,"4":"Qui dicit: ' Novi eum ', et mandata eius non servat, mendax est, et in isto veritas non est;"
,"5":"qui autem servat verbum eius, vere in hoc caritas Dei consummata est. In hoc cognoscimus quoniam in ipso sumus."
,"6":"Qui dicit se in ipso manere, debet, sicut ille ambulavit, et ipse ambulare."
,"7":"Carissimi, non mandatum novum scribo vobis sed mandatum vetus, quod habuistis ab initio: mandatum vetus est verbum, quod audistis."
,"8":"Verumtamen mandatum novum scribo vobis, quod est verum in ipso et in vobis, quoniam tenebrae transeunt, et lumen verum iam lucet."
,"9":"Qui dicit se in luce esse, et fratrem suum odit, in tenebris est usque adhuc."
,"10":"Qui diligit fratrem suum, in lumine manet, et scandalum ei non est;"
,"11":"qui autem odit fratrem suum, in tenebris est et in tenebris ambulat et nescit quo vadat, quoniam tenebrae obcaecaverunt oculos eius."
,"12":"Scribo vobis, filioli: Remissa sunt vobis peccata propter nomen eius."
,"13":"Scribo vobis, patres: Nostis eum, qui ab initio est. Scribo vobis, adulescentes: Vicistis Malignum."
,"14":"Scripsi vobis, parvuli: Nostis Patrem. Scripsi vobis, patres: Nostis eum, qui ab initio est. Scripsi vobis, adulescentes: Fortes estis, et verbum Dei in vobis manet, et vicistis Malignum."
,"15":"Nolite diligere mundum neque ea, quae in mundo sunt. Si quis diligit mundum, non est caritas Patris in eo;"
,"16":"quoniam omne, quod est in mundo, concupiscentia carnis et concupiscentia oculorum et iactantia divitiarum, non est ex Patre, sed ex mundo est."
,"17":"Et mundus transit, et concupiscentia eius; qui autem facit voluntatem Dei, manet in aeternum."
,"18":"Filioli, novissima hora est; et sicut audistis quia antichristus venit, ita nunc antichristi multi adsunt, unde cognoscimus quoniam novissima hora est."
,"19":"Ex nobis prodierunt, sed non erant ex nobis, nam si fuissent ex nobis, permansissent nobiscum; sed ut manifestaretur quoniam illi omnes non sunt ex nobis."
,"20":"Sed vos unctionem habetis a Sancto et scitis omnes."
,"21":"Non scripsi vobis quasi nescientibus veritatem sed quasi scientibus eam, et quoniam omne mendacium ex veritate non est."
,"22":"Quis est mendax, nisi is qui negat quoniam Iesus est Christus? Hic est antichristus, qui negat Patrem et Filium."
,"23":"Omnis, qui negat Filium, nec Patrem habet; qui confitetur Filium, et Patrem habet."
,"24":"Vos, quod audistis ab initio, in vobis permaneat; si in vobis permanserit, quod ab initio audistis, et vos in Filio et in Patre manebitis."
,"25":"Et haec est repromissio, quam ipse pollicitus est nobis: vitam aeternam."
,"26":"Haec scripsi vobis de eis, qui seducunt vos."
,"27":"Et vos, unctionem, quam accepistis ab eo, manet in vobis, et non necesse habetis, ut aliquis doceat vos; sed sicut unctio ipsius docet vos de omnibus, et verum est, et non est mendacium, et, sicut docuit vos, manetis in eo."
,"28":"Et nunc, filioli, manete in eo, ut, cum apparuerit, habeamus fiduciam et non confundamur ab eo in adventu eius."
,"29":"Si scitis quoniam iustus est, scitote quoniam et omnis, qui facit iustitiam, ex ipso natus est."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Videte qualem caritatem dedit nobis Pater, ut filii Dei nomine mur, et sumus! Propter hoc mundus non cognoscit nos, quia non cognovit eum."
,"2":"Carissimi, nunc filii Dei sumus, et nondum manifestatum est quid erimus; scimus quoniam, cum ipse apparuerit, similes ei erimus, quoniam videbimus eum, sicuti est."
,"3":"Et omnis, qui habet spem hanc in eo, purificat se, sicut ille purus est."
,"4":"Omnis, qui facit peccatum, et iniquitatem facit, quia peccatum est iniquitas."
,"5":"Et scitis quoniam ille apparuit, ut peccata tolleret, et peccatum in eo non est."
,"6":"Omnis, qui in eo manet, non peccat; omnis, qui peccat, non vidit eum nec novit eum."
,"7":"Filioli, nemo vos seducat. Qui facit iustitiam, iustus est, sicut ille iustus est;"
,"8":"qui facit peccatum, ex Diabolo est, quoniam a principio Diabolus peccat. Propter hoc apparuit Filius Dei, ut dissolvat opera Diaboli."
,"9":"Omnis, qui natus est ex Deo, peccatum non facit, quoniam semen ipsius in eo manet; et non potest peccare, quoniam ex Deo natus est."
,"10":"In hoc manifesti sunt filii Dei et filii Diaboli: omnis, qui non facit iustitiam, non est ex Deo, et qui non diligit fratrem suum."
,"11":"Quoniam haec est annuntiatio, quam audistis ab initio, ut diligamus alterutrum."
,"12":"Non sicut Cain: ex Maligno erat et occidit fratrem suum. Et propter quid occidit eum? Quoniam opera eius maligna erant, fratris autem eius iusta."
,"13":"Nolite mirari, fratres, si odit vos mundus."
,"14":"Nos scimus quoniam transivimus de morte in vitam, quoniam diligimus fratres; qui non diligit, manet in morte."
,"15":"Omnis, qui odit fratrem suum, homicida est, et scitis quoniam omnis homicida non habet vitam aeternam in semetipso manentem."
,"16":"In hoc novimus caritatem, quoniam ille pro nobis animam suam posuit; et nos debemus pro fratribus animas ponere."
,"17":"Qui habuerit substantiam mundi et viderit fratrem suum necesse habere et clauserit viscera sua ab eo, quomodo caritas Dei manet in eo?"
,"18":"Filioli, non diligamus verbo nec lingua sed in opere et veritate."
,"19":"In hoc cognoscemus quoniam ex veritate sumus, et in conspectu eius placabimus corda nostra,"
,"20":"quoniam si reprehenderit nos cor, maior est Deus corde nostro et cognoscit omnia."
,"21":"Carissimi, si cor nostrum non reprehenderit nos, fiduciam habemus ad Deum"
,"22":"et, quodcumque petierimus, accipimus ab eo, quoniam mandata eius custodimus et ea, quae sunt placita coram eo, facimus."
,"23":"Et hoc est mandatum eius, ut credamus nomini Filii eius Iesu Christi et diligamus alterutrum, sicut dedit mandatum nobis."
,"24":"Et, qui servat mandata eius, in ipso manet, et ipse in eo; et in hoc cognoscimus quoniam manet in nobis, ex Spiritu, quem nobis dedit."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Carissimi, nolite omni spiritui credere, sed probate spiritus si ex Deo sint, quoniam multi pseudoprophetae prodierunt in mundum."
,"2":"In hoc cognoscitis Spiritum Dei: omnis spiritus, qui confitetur Iesum Christum in carne venisse, ex Deo est."
,"3":"Et omnis spiritus, qui non confitetur Iesum, ex Deo non est; et hoc est antichristi, quod audistis quoniam venit, et nunc iam in mundo est."
,"4":"Vos ex Deo estis, filioli, et vicistis eos, quoniam maior est, qui in vobis est, quam qui in mundo."
,"5":"Ipsi ex mundo sunt; ideo ex mundo loquuntur, et mundus eos audit."
,"6":"Nos ex Deo sumus. Qui cognoscit Deum, audit nos; qui non est ex Deo, non audit nos. Ex hoc cognoscimus Spiritum veritatis et spiritum erroris."
,"7":"Carissimi, diligamus invicem, quoniam caritas ex Deo est; et omnis, qui diligit, ex Deo natus est et cognoscit Deum."
,"8":"Qui non diligit, non cognovit Deum, quoniam Deus caritas est."
,"9":"In hoc apparuit caritas Dei in nobis, quoniam Filium suum unigenitum misit Deus in mundum, ut vivamus per eum."
,"10":"In hoc est caritas, non quasi nos dilexerimus Deum, sed quoniam ipse dilexit nos et misit Filium suum propitiationem pro peccatis nostris."
,"11":"Carissimi, si sic Deus dilexit nos, et nos debemus alterutrum diligere."
,"12":"Deum nemo vidit umquam; si diligamus invicem, Deus in nobis manet, et caritas eius in nobis consummata est."
,"13":"In hoc cognoscimus quoniam in ipso manemus, et ipse in nobis, quoniam de Spiritu suo dedit nobis."
,"14":"Et nos vidimus et testificamur quoniam Pater misit Filium salvatorem mundi."
,"15":"Quisque confessus fuerit: ' Iesus est Filius Dei ', Deus in ipso manet, et ipse in Deo."
,"16":"Et nos, qui credidimus, novimus caritatem, quam habet Deus in nobis. Deus caritas est; et, qui manet in caritate, in Deo manet, et Deus in eo manet."
,"17":"In hoc consummata est caritas nobiscum, ut fiduciam habeamus in die iudicii; quia sicut ille est, et nos sumus in hoc mundo."
,"18":"Timor non est in caritate, sed perfecta caritas foras mittit timorem, quoniam timor poenam habet; qui autem timet, non est consummatus in caritate."
,"19":"Nos diligimus, quoniam ipse prior dilexit nos."
,"20":"Si quis dixerit: ' Diligo Deum ', et fratrem suum oderit, mendax est; qui enim non diligit fratrem suum, quem videt, Deum, quem non videt, non potest diligere."
,"21":"Et hoc mandatum habemus ab eo, ut, qui diligit Deum, diligat et fratrem suum."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Omnis, qui credit quoniam Iesus est Christus, ex Deo natus est; et omnis, qui diligit Deum, qui genuit, diligit et eum, qui natus est ex eo."
,"2":"In hoc cognoscimus quoniam diligimus natos Dei, cum Deum diligamus et mandata eius faciamus."
,"3":"Haec est enim caritas Dei, ut mandata eius servemus; et mandata eius gravia non sunt,"
,"4":"quoniam omne, quod natum est ex Deo, vincit mundum; et haec est victoria, quae vicit mundum: fides nostra."
,"5":"Quis est qui vincit mundum, nisi qui credit quoniam Iesus est Filius Dei?"
,"6":"Hic est, qui venit per aquam et sanguinem, Iesus Christus; non in aqua solum sed in aqua et in sanguine. Et Spiritus est, qui testificatur, quoniam Spiritus est veritas."
,"7":"Quia tres sunt, qui testificantur:"
,"8":"Spiritus et aqua et sanguis; et hi tres in unum sunt."
,"9":"Si testimonium hominum accipimus, testimonium Dei maius est, quoniam hoc est testimonium Dei, quia testificatus est de Filio suo."
,"10":"Qui credit in Filium Dei, habet testimonium in se. Qui non credit Deo, mendacem facit eum, quoniam non credidit in testimonium, quod testificatus est Deus de Filio suo."
,"11":"Et hoc est testimonium, quoniam vitam aeternam dedit nobis Deus, et haec vita in Filio eius est."
,"12":"Qui habet Filium, habet vitam; qui non habet Filium Dei, vitam non habet."
,"13":"Haec scripsi vobis, ut sciatis quoniam vitam habetis aeternam, qui creditis in nomen Filii Dei."
,"14":"Et haec est fiducia, quam habemus ad eum, quia si quid petierimus secundum voluntatem eius, audit nos."
,"15":"Et si scimus quoniam audit nos, quidquid petierimus, scimus quoniam habemus petitiones, quas postulavimus ab eo."
,"16":"Si quis videt fratrem suum peccare peccatum non ad mortem, petet, et dabit ei Deus vitam, peccantibus non ad mortem. Est peccatum ad mortem; non pro illo dico, ut roget."
,"17":"Omnis iniustitia peccatum est, et est peccatum non ad mortem."
,"18":"Scimus quoniam omnis, qui natus est ex Deo, non peccat, sed ille, qui genitus est ex Deo, conservat eum, et Malignus non tangit eum."
,"19":"Scimus quoniam ex Deo sumus, et mundus totus in Maligno positus est."
,"20":"Et scimus quoniam Filius Dei venit et dedit nobis sensum, ut cognoscamus eum, qui verus est; et sumus in eo, qui verus est, in Filio eius Iesu Christo. Hic est qui verus est, Deus et vita aeterna."
,"21":"Filioli, custodite vos a simulacris!"
}`)

}
func LA_NVBSE_LoadNC1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Petrus apostolus Iesu Christi electis advenis dispersionis Pon ti, Galatiae, Cappadociae, Asiae et Bithyniae,"
,"2":"secundum praescientiam Dei Patris, in sanctificatione Spiritus, in oboedientiam et aspersionem sanguinis Iesu Christi: gratia vobis et pax multiplicetur."
,"3":"Benedictus Deus et Pater Domini nostri Iesu Christi, qui secundum magnam misericordiam suam regeneravit nos in spem vivam per resurrectionem Iesu Christi ex mortuis,"
,"4":"in hereditatem incorruptibilem et incontaminatam et immarcescibilem, conservatam in caelis propter vos,"
,"5":"qui in virtute Dei custodimini per fidem in salutem, paratam revelari in tempore novissimo."
,"6":"In quo exsultatis, modicum nunc si oportet contristati in variis tentationibus,"
,"7":"ut probatio vestrae fidei multo pretiosior auro, quod perit, per ignem quidem probato, inveniatur in laudem et gloriam et honorem in revelatione Iesu Christi."
,"8":"Quem cum non videritis, diligitis; in quem nunc non videntes, credentes autem, exsultatis laetitia inenarrabili et glorificata,"
,"9":"reportantes finem fidei vestrae salutem animarum."
,"10":"De qua salute exquisierunt atque scrutati sunt prophetae, qui de futura in vos gratia prophetaverunt,"
,"11":"scrutantes in quod vel quale tempus significaret, qui erat in eis Spiritus Christi, praenuntians eas, quae in Christo sunt, passiones et posteriores glorias;"
,"12":"quibus revelatum est quia non sibi ipsis, vobis autem ministrabant ea, quae nunc nuntiata sunt vobis per eos, qui evangelizaverunt vos, Spiritu Sancto misso de caelo, in quae desiderant angeli prospicere."
,"13":"Propter quod succincti lumbos mentis vestrae, sobrii, perfecte sperate in eam, quae offertur vobis, gratiam in revelatione Iesu Christi."
,"14":"Quasi filii oboedientiae, non configurati prioribus in ignorantia vestra desideriis,"
,"15":"sed secundum eum, qui vocavit vos, sanctum, et ipsi sancti in omni conversatione sitis,"
,"16":"quoniam scriptum est: ' Sancti eritis, quia ego sanctus sum '."
,"17":"Et si Patrem invocatis eum, qui sine acceptione personarum iudicat secundum uniuscuiusque opus, in timore incolatus vestri tempore conversamini,"
,"18":"scientes quod non corruptibilibus argento vel auro redempti estis de vana vestra conversatione a patribus tradita,"
,"19":"sed pretioso sanguine quasi Agni incontaminati et immaculati Christi,"
,"20":"praecogniti quidem ante constitutionem mundi, manifestati autem novissimis temporibus propter vos,"
,"21":"qui per ipsum fideles estis in Deum, qui suscitavit eum a mortuis et dedit ei gloriam, ut fides vestra et spes esset in Deum."
,"22":"Animas vestras castificantes in oboedientia veritatis ad fraternitatis amorem non fictum, ex corde invicem diligite attentius,"
,"23":"renati non ex semine corruptibili sed incorruptibili per verbum Dei vivum et permanens:"
,"24":"quia,omnis caro ut fenum, et omnis gloria eius tamquam flos feni. Exaruit fenum, et flos decidit;"
,"25":"verbum autem Domini manet in aeternum. Hoc est autem verbum, quod evangelizatum est in vos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Deponentes igitur omnem ma litiam et omnem dolum et simu lationes et invidias et omnes detractiones,"
,"2":"sicut modo geniti infantes, rationale sine dolo lac concupiscite, ut in eo crescatis in salutem,"
,"3":"si gustastis quoniam dulcis Dominus."
,"4":"Ad quem accedentes, lapidem vivum, ab hominibus quidem reprobatum, coram Deo autem electum, pretiosum,"
,"5":"et ipsi tamquam lapides vivi aedificamini domus spiritalis in sacerdotium sanctum offerre spiritales hostias acceptabiles Deo per Iesum Christum."
,"6":"Propter quod continet Scriptura: ' Ecce pono in Sion lapidem angularem, electum, pretiosum; et, qui credit in eo, non confundetur '."
,"7":"Vobis igitur honor credentibus; non credentibus autem,' Lapis, quem reprobaverunt aedificantes, hic factus est in caput anguli '"
,"8":"et ' lapis offensionis et petra scandali '; qui offendunt verbo non credentes, in quod et positi sunt."
,"9":"Vos autem genus electum, regale sacerdotium, gens sancta, populus in acquisitionem, ut virtutes annuntietis eius, qui de tenebris vos vocavit in admirabile lumen suum:"
,"10":"qui aliquando non populus, nunc autem populus Dei; qui non consecuti misericordiam, nunc autem misericordiam consecuti."
,"11":"Carissimi, obsecro tamquam advenas et peregrinos abstinere vos a carnalibus desideriis, quae militant adversus animam;"
,"12":"conversationem vestram inter gentes habentes bonam, ut in eo, quod detrectant de vobis tamquam de malefactoribus, ex bonis operibus considerantes glorificent Deum in die visitationis."
,"13":"Subiecti estote omni humanae creaturae propter Dominum: sive regi quasi praecellenti"
,"14":"sive ducibus tamquam ab eo missis ad vindictam malefactorum, laudem vero bonorum;"
,"15":"quia sic est voluntas Dei, ut benefacientes obmutescere faciatis imprudentium hominum ignorantiam,"
,"16":"quasi liberi, et non quasi velamen habentes malitiae libertatem, sed sicut servi Dei."
,"17":"Omnes honorate, fraternitatem diligite, Deum timete, regem honorificate."
,"18":"Servi, subditi estote in omni timore dominis, non tantum bonis et modestis sed etiam pravis."
,"19":"Haec est enim gratia, si propter conscientiam Dei sustinet quis tristitias, patiens iniuste."
,"20":"Quae enim gloria est, si peccantes et colaphizati sustinetis? Sed si benefacientes et patientes sustinetis, haec est gratia apud Deum."
,"21":"In hoc enim vocati estis, quia,et Christus passus est pro vobis, vobis relinquens exemplum, ut sequamini vestigia eius:"
,"22":"qui peccatum non fecit, nec inventus est dolus in ore ipsius;"
,"23":"qui cum malediceretur, non remaledicebat; cum pateretur, non comminabatur, commendabat autem iuste iudicanti;"
,"24":"qui peccata nostra ipse pertulit,in corpore suo super lignum, ut peccatis mortui iustitiae viveremus; cuius livore sanati estis."
,"25":"Eratis enim sicut oves errantes, sed conversi estis nunc ad pastorem et episcopum animarum vestrarum."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Similiter mulieres subditae sint suis viris, ut et si qui non cre dunt verbo, per mulierum conversationem sine verbo lucrifiant,"
,"2":"considerantes castam in timore conversationem vestram;"
,"3":"quarum sit non extrinsecus capillaturae aut circumdationis auri aut indumenti vestimentorum cultus,"
,"4":"sed qui absconditus cordis est homo, in incorruptibilitate mitis et quieti spiritus, qui est in conspectu Dei locuples."
,"5":"Sic enim aliquando et sanctae mulieres sperantes in Deo ornabant se subiectae propriis viris,"
,"6":"sicut Sara oboediebat Abrahae dominum eum vocans: cuius estis filiae benefacientes et non timentes ullam perturbationem."
,"7":"Viri similiter cohabitantes secundum scientiam quasi infirmiori vaso muliebri impertientes honorem, tamquam et coheredibus gratiae vitae, uti ne impediantur orationes vestrae."
,"8":"In fine autem omnes unanimes, compatientes, fraternitatis amatores, misericordes, humiles,"
,"9":"non reddentes malum pro malo vel maledictum pro maledicto, sed e contrario benedicentes, quia in hoc vocati estis, ut benedictionem hereditate accipiatis."
,"10":"' Qui enim vult vitam diligere,et videre dies bonos, coerceat linguam suam a malo,"
,"11":"et labia eius ne loquantur dolum; declinet autem a malo et faciat bonum, inquirat pacem et persequatur eam."
,"12":"Quia oculi Domini super iustos, et aures eius in preces eorum; vultus autem Domini super facientes mala '."
,"13":"Et quis est qui vobis noceat, si boni aemulatores fueritis?"
,"14":"Sed et si patimini propter iustitiam, beati! Timorem autem eorum ne timueritis et non conturbemini,"
,"15":"Dominum autem Christum sanctificate in cordibus vestris, parati semper ad defensionem omni poscenti vos rationem de ea, quae in vobis est spe;"
,"16":"sed cum mansuetudine et timore, conscientiam habentes bonam, ut in quo de vobis detrectatur, confundantur, qui calumniantur vestram bonam in Christo conversationem."
,"17":"Melius est enim benefacientes, si velit voluntas Dei, pati quam malefacientes."
,"18":"Quia et Christus semel pro peccatis passus est, iustus pro iniustis, ut vos adduceret ad Deum, mortificatus quidem carne, vivificatus autem Spiritu:"
,"19":"in quo et his, qui in carcere erant, spiritibus adveniens praedicavit,"
,"20":"qui increduli fuerant aliquando, quando exspectabat Dei patientia in diebus Noe, cum fabricaretur arca, in qua pauci, id est octo animae, salvae factae sunt per aquam."
,"21":"Cuius antitypum, baptisma, et vos nunc salvos facit, non carnis depositio sordium sed conscientiae bonae rogatio in Deum, per resurrectionem Iesu Christi,"
,"22":"qui est in dextera Dei, profectus in caelum, subiectis sibi angelis et potestatibus et virtutibus."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Christo igitur passo in carne, et vos eadem cogitatione armami ni, quia, qui passus est carne, desiit a peccato;"
,"2":"ut iam non hominum concupiscentiis sed voluntate Dei, quod reliquum est in carne vivat temporis."
,"3":"Sufficit enim praeteritum tempus ad voluntatem gentium consummandam, vobis, qui ambulastis in luxuriis, concupiscentiis, vinolentiis, comissationibus, potationibus et illicitis idolorum cultibus."
,"4":"In quo mirantur non concurrentibus vobis in eandem luxuriae effusionem, blasphemantes;"
,"5":"qui reddent rationem ei, qui paratus est iudicare vivos et mortuos."
,"6":"Propter hoc enim et mortuis evangelizatum est, ut iudicentur quidem secundum homines carne, vivant autem secundum Deum Spiritu."
,"7":"Omnium autem finis appropinquavit. Estote itaque prudentes et vigilate in orationibus."
,"8":"Ante omnia mutuam in vosmetipsos caritatem continuam habentes, quia caritas operit multitudinem peccatorum;"
,"9":"hospitales invicem sine murmuratione;"
,"10":"unusquisque, sicut accepit donationem, in alterutrum illam administrantes, sicut boni dispensatores multiformis gratiae Dei."
,"11":"Si quis loquitur, quasi sermones Dei; si quis ministrat, tamquam ex virtute, quam largitur Deus, ut in omnibus glorificetur Deus per Iesum Christum: cui est gloria et imperium in saecula saeculorum. Amen."
,"12":"Carissimi, nolite mirari in fervore, qui ad tentationem vobis fit, quasi novi aliquid vobis contingat,"
,"13":"sed, quemadmodum communicatis Christi passionibus, gaudete, ut et in revelatione gloriae eius gaudeatis exsultantes."
,"14":"Si exprobramini in nomine Christi, beati, quoniam Spiritus gloriae et Dei super vos requiescit."
,"15":"Nemo enim vestrum patiatur quasi homicida aut fur aut maleficus aut alienorum speculator;"
,"16":"si autem ut christianus, non erubescat, glorificet autem Deum in isto nomine."
,"17":"Quoniam tempus est, ut incipiat iudicium a domo Dei; si autem primum a nobis, qui finis eorum, qui non credunt Dei evangelio?"
,"18":"' Et si iustus vix salvatur, impius et peccator ubi parebit? '."
,"19":"Itaque et hi, qui patiuntur secundum voluntatem Dei, fideli Creatori commendent animas suas in benefacto."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Seniores ergo, qui in vobis sunt, obsecro, consenior et testis Chri sti passionum, qui et eius, quae in futuro revelanda est, gloriae communicator:"
,"2":"Pascite, qui est in vobis, gregem Dei, providentes non coacto sed spontanee secundum Deum, neque turpis lucri gratia sed voluntarie,"
,"3":"neque ut dominantes in cleris sed formae facti gregis."
,"4":"Et cum apparuerit Princeps pastorum, percipietis immarcescibilem gloriae coro nam."
,"5":"Similiter, adulescentes, subditi estote senioribus. Omnes autem invicem humilitatem induite, quia,Deus superbis resistit, humilibus autem dat gratiam."
,"6":"Humiliamini igitur sub potenti manu Dei, ut vos exaltet in tempore,"
,"7":"omnem sollicitudinem vestram proicientes in eum, quoniam ipsi cura est de vobis."
,"8":"Sobrii estote, vigilate. Adversarius vester Diabolus tamquam leo rugiens circuit quaerens quem devoret."
,"9":"Cui resistite fortes fide, scientes eadem passionum ei, quae in mundo est, vestrae fraternitati fieri."
,"10":"Deus autem omnis gratiae, qui vocavit vos in aeternam suam gloriam in Christo Iesu, modicum passos ipse perficiet, confirmabit, solidabit, fundabit."
,"11":"Ipsi imperium in saecula saeculorum. Amen."
,"12":"Per Silvanum vobis fidelem fratrem, ut arbitror, breviter scripsi, obsecrans et contestans hanc esse veram gratiam Dei; in qua state."
,"13":"Salutat vos, quae est in Babylone, coelecta et Marcus filius meus."
,"14":"Salutate invicem in osculo caritatis. Pax vobis omnibus, qui estis in Christo. "
}`)

}
func LA_NVBSE_LoadNC2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Presbyter electae dominae et filiis eius, quos ego diligo in veritate, et non ego solus, sed et omnes, qui noverunt veritatem,"
,"2":"propter veritatem, quae permanet in nobis et nobiscum erit in sempiternum."
,"3":"Erit nobiscum gratia, misericordia, pax a Deo Patre et a Iesu Christo, Filio Patris, in veritate et caritate."
,"4":"Gavisus sum valde, quoniam inveni de filiis tuis ambulantes in veritate, sicut mandatum accepimus a Patre."
,"5":"Et nunc rogo te, domina, non tamquam mandatum novum scribens tibi, sed quod habuimus ab initio, ut diligamus alterutrum."
,"6":"Et haec est caritas, ut ambulemus secundum mandata eius; hoc mandatum est, quemadmodum audistis ab initio, ut in eo ambuletis."
,"7":"Quoniam multi seductores prodierunt in mundum, qui non confitentur Iesum Christum venientem in carne; hic est seductor et antichristus."
,"8":"Videte vosmetipsos, ne perdatis, quae operati estis, sed ut mercedem plenam accipiatis."
,"9":"Omnis, qui ultra procedit et non manet in doctrina Christi, Deum non habet; qui permanet in doctri na, hic et Patrem et Filium habet."
,"10":"Si quis venit ad vos et hanc doctrinam non affert, nolite accipere eum in domum nec ' Ave ' ei dixeritis;"
,"11":"qui enim dicit illi: ' Ave ', communicat operibus illius malignis."
,"12":"Plura habens vobis scribere, nolui per chartam et atramentum; spero enim me futurum apud vos, et os ad os loqui, ut gaudium nostrum plenum sit."
,"13":"Salutant te filii sororis tuae electae."
}`)

}
func LA_NVBSE_LoadNC2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Simon Petrus servus et apo stolus Iesu Christi his, qui coae qualem nobis sortiti sunt fidem in iustitia Dei nostri et salvatoris Iesu Christi:"
,"2":"gratia vobis et pax multiplicetur in cognitione Dei et Iesu Domini nostri."
,"3":"Quomodo omnia nobis divinae virtutis suae ad vitam et pietatem donatae per cognitionem eius, qui vocavit nos propria gloria et virtute,"
,"4":"per quae pretiosa et maxima nobis promissa donata sunt, ut per haec efficiamini divinae consortes naturae, fugientes eam, quae in mundo est in concupiscentia, corruptionem;"
,"5":"et propter hoc ipsum curam omnem subinferentes ministrate in fide vestra virtutem, in virtute autem scientiam,"
,"6":"in scientia autem continentiam, in continentia autem patientiam, in patientia autem pietatem,"
,"7":"in pietate autem amorem fraternitatis, in amore autem fraternitatis caritatem."
,"8":"Haec enim vobis, cum adsint et abundent, non vacuos nec sine fructu vos constituunt in Domini nostri Iesu Christi cognitionem;"
,"9":"cui enim non praesto sunt haec, caecus est et nihil procul cernens, oblivionem accipiens purgationis veterum suorum delictorum."
,"10":"Quapropter, fratres, magis satagite, ut firmam vestram vocationem et electionem faciatis. Haec enim facientes non offendetis aliquando;"
,"11":"sic enim abundanter ministrabitur vobis introitus in aeternum regnum Domini nostri et salvatoris Iesu Christi."
,"12":"Propter quod incipiam vos semper commonere de his, et quidem scientes et confirmatos in praesenti veritate."
,"13":"Iustum autem arbitror, quamdiu sum in hoc tabernaculo, suscitare vos in commonitione,"
,"14":"certus quod velox est depositio tabernaculi mei, secundum quod et Dominus noster Iesus Christus significavit mihi;"
,"15":"dabo autem operam et frequenter habere vos post obitum meum, ut horum memoriam faciatis."
,"16":"Non enim captiosas fabulas secuti notam fecimus vobis Domini nostri Iesu Christi virtutem et adventum, sed speculatores facti illius magnitudinis."
,"17":"Accipiens enim a Deo Patre honorem et gloriam, voce prolata ad eum huiuscemodi a magnifica gloria: ' Filius meus, dilectus meus hic est, in quo ego mihi complacui ';"
,"18":"et hanc vocem nos audivimus de caelo prolatam, cum essemus cum ipso in monte sancto."
,"19":"Et habemus firmiorem propheticum sermonem, cui bene facitis attendentes quasi lucernae lucenti in caliginoso loco, donec dies illucescat, et lucifer oriatur in cordibus vestris,"
,"20":"hoc primum intellegentes quod omnis prophetia Scripturae propria interpretatione non fit;"
,"21":"non enim voluntate humana prolata est prophetia aliquando, sed a Spiritu Sancto ducti locuti sunt a Deo homines."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Fuerunt vero et pseudopro phetae in populo, sicut et in vo bis erunt magistri mendaces, qui introducent sectas perditionis et eum, qui emit eos, Dominatorem negantes superducent sibi celerem perditionem."
,"2":"Et multi sequentur eorum luxurias, propter quos via veritatis blasphemabitur;"
,"3":"et in avaritia fictis verbis de vobis negotiabuntur. Quibus iudicium iam olim non cessat, et perditio eorum non dormitat."
,"4":"Si enim Deus angelis peccantibus non pepercit, sed rudentibus inferni detractos in tartarum tradidit in iudicium reservatos:"
,"5":"et originali mundo non pepercit, sed octavum Noe iustitiae praeconem custodivit diluvium mundo impiorum inducens;"
,"6":"et civitates Sodomae et Gomorrae in cinerem redigens eversione damnavit, exemplum ponens eorum, quae sunt impiis futura:"
,"7":"et iustum Lot oppressum a nefandorum luxuria conversationis eruit:"
,"8":"aspectu enim et auditu iustus habitans apud eos, de die in diem animam iustam iniquis operibus cruciabat."
,"9":"Novit Dominus pios de tentatione eripere, iniquos vero in diem iudicii puniendos reservare,"
,"10":"maxime autem eos, qui post carnem in concupiscentia immunditiae ambulant dominationemque contemnunt. Audaces, superbi, glorias non metuunt blasphemantes, "
,"11":"ubi angeli fortitudine et virtute cum sint maiores, non portant adversum illas coram Domino iudicium blasphemiae."
,"12":"Hi vero, velut irrationabilia animalia naturaliter genita in captionem et in corruptionem, in his, quae ignorant, blasphemantes, in corruptione sua et corrumpentur"
,"13":"inviti percipientes mercedem iniustitiae; voluptatem existimantes diei delicias, coinquinationes et maculae deliciis affluentes, in voluptatibus suis luxuriantes vobiscum,"
,"14":"oculos habentes plenos adulterae et incessabiles delicti, pellicientes animas instabiles, cor exercitatum avaritiae habentes, maledictionis filii;"
,"15":"derelinquentes rectam viam erraverunt, secuti viam Balaam ex Bosor, qui mercedem iniquitatis amavit,"
,"16":"correptionem vero habuit suae praevaricationis; subiugale mutum in hominis voce loquens prohibuit prophetae insipientiam."
,"17":"Hi sunt fontes sine aqua, et nebulae turbine exagitatae, quibus caligo tenebrarum reservatur."
,"18":"Superba enim vanitatis loquentes pelliciunt in concupiscentiis carnis luxuriis illos, qui paululum effugiunt eos, qui in errore conversantur,"
,"19":"libertatem illis promittentes, cum ipsi servi sint corruptionis; a quo enim quis superatus est, huius servus est."
,"20":"Si enim refugientes coinquinationes mundi in cognitione Domini nostri et Salvatoris Iesu Christi his rursus implicati superantur, facta sunt eis posteriora deteriora prioribus."
,"21":"Melius enim erat illis non cognoscere viam iustitiae, quam post agnitionem retrorsum converti ab eo, quod illis traditum est, sancto mandato."
,"22":"Contigit enim eis illud veri proverbii: ' Canis reversus ad suum vomitum ', et ' Sus lota in volutabro luti '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hanc vobis, carissimi, iam se cundam scribo epistulam, in quibus excito vestram in commonitione sinceram mentem,"
,"2":"ut memores sitis eorum, quae praedicta sunt verborum a sanctis prophetis, et ab apostolis traditi vobis praecepti Domini et Salvatoris;"
,"3":"hoc primum scientes, quod venient in novissimis diebus in illusione illudentes, iuxta proprias concupiscentias suas ambulantes,"
,"4":"dicentes: ' Ubi est promissio adventus eius? Ex quo enim patres dormierunt, omnia sic perseverant ab initio creaturae '."
,"5":"Latet enim eos hoc volentes, quod caeli erant prius, et terra de aqua et per aquam consistens Dei verbo,"
,"6":"per quae ille tunc mundus aqua inundatus periit;"
,"7":"caeli autem, qui nunc sunt, et terra eodem verbo repositi sunt igni, servati in diem iudicii et perditionis impiorum hominum."
,"8":"Unum vero hoc non lateat vos, carissimi, quia unus dies apud Dominum sicut mille anni, et mille anni sicut dies unus."
,"9":"Non tardat Dominus promissionem, sicut quidam tarditatem existimant, sed patienter agit in vos nolens aliquos perire, sed omnes ad paenitentiam reverti."
,"10":"Adveniet autem dies Domini ut fur, in qua caeli magno impetu transient, elementa vero calore solventur, et terra et opera, quae in ea invenientur."
,"11":"Cum haec omnia ita dissolvenda sint, quales oportet esse vos in sanctis conversationibus et pietatibus,"
,"12":"exspectantes et properantes adventum diei Dei, propter quam caeli ardentes solventur, et elementa ignis ardore tabescent!"
,"13":"Novos vero caelos et terram novam secundum promissum ipsius exspectamus, in quibus iustitia habitat."
,"14":"Propter quod, carissimi, haec exspectantes satagite immaculati et inviolati ei inveniri in pace;"
,"15":"et Domini nostri longanimitatem, salutem arbitramini, sicut et carissimus frater noster Paulus secundum datam sibi sapientiam scripsit vobis,"
,"16":"sicut et in omnibus epistulis loquens in eis de his; in quibus sunt quaedam difficilia intellectu, quae indocti et instabiles depravant, sicut et ceteras Scripturas, ad suam ipsorum perditionem."
,"17":"Vos igitur, dilecti, praescientes custodite, ne iniquorum errore simul abducti excidatis a propria firmitate;"
,"18":"crescite vero in gratia et in cognitione Domini nostri et Salvatoris Iesu Christi. Ipsi gloria et nunc et in diem aeternitatis. Amen."
}`)

}
func LA_NVBSE_LoadNC3IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Presbyter Gaio carissimo, quem ego diligo in veritate."
,"2":"Carissime, in omnibus exopto prospere te agere et valere, sicut prospere agit anima tua."
,"3":"Nam gavisus sum valde, venientibus fratribus et testimonium perhibentibus veritati tuae, quomodo tu in veritate ambules."
,"4":"Maius horum non habeo gaudium, quam ut audiam filios meos in veritate ambulare."
,"5":"Carissime, fideliter facis, quidquid operaris in fratres et hoc in peregrinos,"
,"6":"qui testimonium reddiderunt caritati tuae in conspectu ecclesiae. Bene facies subveniens illis in via digne Deo;"
,"7":"pro nomine enim profecti sunt, nihil accipientes a gentilibus."
,"8":"Nos ergo debemus sublevare huiusmodi, ut cooperatores simus veritatis."
,"9":"Scripsi aliquid ecclesiae; sed is qui amat primatum gerere in eis, Diotrephes, non recipit nos."
,"10":"Propter hoc, si venero, commonebo eius opera, quae facit verbis malignis garriens in nos; et quasi non ei ista sufficiant, nec ipse suscipit fratres et eos, qui cu piunt, prohibet et de ecclesia eicit."
,"11":"Carissime, noli imitari malum, sed quod bonum est. Qui benefacit, ex Deo est; qui malefacit, non vidit Deum."
,"12":"Demetrio testimonium redditur ab omnibus et ab ipsa veritate; sed et nos testimonium perhibemus, et scis quoniam testimonium nostrum verum est."
,"13":"Multa habui scribere tibi, sed nolo per atramentum et calamum scribere tibi;"
,"14":"spero autem protinus te videre, et os ad os loquemur."
,"15":"Pax tibi. Salutant te amici. Saluta amicos nominatim."
}`)

}
func LA_NVBSE_LoadNCIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Iacobus, Dei et Domini Iesu Christi servus, duodecim tribu bus, quae sunt in dispersione, salutem."
,"2":"Omne gaudium existimate, fratres mei, cum in tentationibus variis incideritis,"
,"3":"scientes quod probatio fidei vestrae patientiam operatur;"
,"4":"patientia autem opus perfectum habeat, ut sitis perfecti et integri, in nullo deficientes."
,"5":"Si quis autem vestrum indiget sapientia, postulet a Deo, qui dat omnibus affluenter et non improperat, et dabitur ei."
,"6":"Postulet autem in fide nihil haesitans; qui enim haesitat, similis est fluctui maris, qui a vento movetur et circumfertur."
,"7":"Non ergo aestimet homo ille quod accipiat aliquid a Domino,"
,"8":"vir duplex animo, inconstans in omnibus viis suis."
,"9":"Glorietur autem frater humilis in exaltatione sua,"
,"10":"dives autem in humilitate sua, quoniam sicut flos feni transibit."
,"11":"Exortus est enim sol cum ardore et arefecit fenum, et flos eius decidit, et decor vultus eius deperiit; ita et dives in itineribus suis marcescet."
,"12":"Beatus vir, qui suffert tentationem, quia, cum probatus fuerit, accipiet coronam vitae, quam repromisit Deus diligentibus se."
,"13":"Nemo, cum tentatur, dicat: ' A Deo tentor '; Deus enim non tentatur malis, ipse autem neminem tentat."
,"14":"Unusquisque vero tentatur a concupiscentia sua abstractus et illectus;"
,"15":"dein concupiscentia, cum conceperit, parit peccatum; peccatum vero, cum consummatum fuerit, generat mortem."
,"16":"Nolite errare, fratres mei dilectissimi."
,"17":"Omne datum optimum et omne donum perfectum de sursum est, descendens a Patre luminum, apud quem non est transmutatio nec vicissitudinis obumbratio."
,"18":"Voluntarie genuit nos verbo veritatis, ut simus primitiae quaedam creaturae eius."
,"19":"Scitis, fratres mei dilecti. Sit autem omnis homo velox ad audiendum, tardus autem ad loquendum et tardus ad iram;"
,"20":"ira enim viri iustitiam Dei non operatur."
,"21":"Propter quod abicientes omnem immunditiam et abundantiam malitiae, in mansuetudine suscipite insitum verbum, quod potest salvare animas vestras."
,"22":"Estote autem factores verbi et non auditores tantum fallentes vosmetipsos."
,"23":"Quia si quis auditor est verbi et non factor, hic comparabitur viro consideranti vultum nativitatis suae in speculo;"
,"24":"consideravit enim se et abiit, et statim oblitus est qualis fuerit."
,"25":"Qui autem perspexerit in lege perfecta libertatis et permanserit, non auditor obliviosus factus sed factor operis, hic beatus in facto suo erit."
,"26":"Si quis putat se religiosum esse, non freno circumducens linguam suam sed seducens cor suum, huius vana est religio."
,"27":"Religio munda et immaculata apud Deum et Patrem haec est: visitare pupillos et viduas in tribulatione eorum, immaculatum se custodire ab hoc saeculo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Fratres mei, nolite in persona rum acceptione habere fidem Domini nostri Iesu Christi gloriae."
,"2":"Etenim, si introierit in synagogam vestram vir aureum anulum habens in veste candida, introierit autem et pauper in sordido habitu,"
,"3":"et intendatis in eum, qui indutus est veste praeclara, et dixeritis: ' Tu sede hic bene ', pauperi autem dicatis: ' Tu sta illic aut sede sub scabello meo ';"
,"4":"nonne iudicatis apud vosmetipsos et facti estis iudices cogitationum iniquarum?"
,"5":"Audite, fratres mei dilectissimi. Nonne Deus elegit, qui pauperes sunt mundo, divites in fide et heredes regni, quod repromisit diligentibus se?"
,"6":"Vos autem exhonorastis pauperem. Nonne divites opprimunt vos et ipsi trahunt vos ad iudicia?"
,"7":"Nonne ipsi blasphemant bonum nomen, quod invocatum est super vos?"
,"8":"Si tamen legem perficitis regalem secundum Scripturam: ' Diliges proximum tuum sicut teipsum ', bene facitis;"
,"9":"si autem personas accipitis, peccatum operamini, redarguti a lege quasi transgressores."
,"10":"Quicumque autem totam legem servaverit, offendat autem in uno, factus est omnium reus."
,"11":"Qui enim dixit: ' Non moechaberis ', dixit et: ' Non occides '; quod si non moecharis, occidis autem, factus es transgressor legis."
,"12":"Sic loquimini et sic facite sicut per legem libertatis iudicandi."
,"13":"Iudicium enim sine misericordia illi, qui non fecit misericordiam; superexsultat misericordia iudicio."
,"14":"Quid proderit, fratres mei, si fidem quis dicat se habere, opera autem non habeat? Numquid poterit fides salvare eum?"
,"15":"Si frater aut soror nudi sunt et indigent victu cotidiano,"
,"16":"dicat autem aliquis de vobis illis: ' Ite in pace, calefacimini et saturamini ', non dederitis autem eis, quae necessaria sunt corporis, quid proderit?"
,"17":"Sic et fides, si non habeat opera, mortua est in semetipsa."
,"18":"Sed dicet quis: ' Tu fidem habes, et ego opera habeo '. Ostende mihi fidem tuam sine operibus, et ego tibi ostendam ex operibus meis fidem."
,"19":"Tu credis quoniam unus est Deus? Bene facis; et daemones credunt et contremiscunt!"
,"20":"Vis autem scire, o homo inanis, quoniam fides sine operibus otiosa est?"
,"21":"Abraham, pater noster, nonne ex operibus iustificatus est offerens Isaac filium suum super altare?"
,"22":"Vides quoniam fides cooperabatur operibus illius, et ex operibus fides consummata est;"
,"23":"et suppleta est Scriptura dicens: ' Credidit Abraham Deo, et reputatum est illi ad iustitiam ', et amicus Dei appellatus est."
,"24":"Videtis quoniam ex operibus iustificatur homo et non ex fide tantum."
,"25":"Similiter autem et Rahab, meretrix nonne ex operibus iustificata est suscipiens nuntios et alia via eiciens?"
,"26":"Sicut enim corpus sine spiritu emortuum est, ita et fides sine operibus mortua est."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Nolite plures magistri fieri, fra tres mei, scientes quoniam maius iudicium accipiemus."
,"2":"In multis enim offendimus omnes. Si quis in verbo non offendit, hic perfectus est vir, potens etiam freno circumducere totum corpus."
,"3":"Si autem equorum frenos in ora mittimus ad oboediendum nobis, et omne corpus illorum circumferimus."
,"4":"Ecce et naves, cum tam magnae sint et a ventis validis minentur, circumferuntur a minimo gubernaculo, ubi impetus dirigentis voluerit;"
,"5":"ita et lingua modicum quidem membrum est et magna exsultat. Ecce quantus ignis quam magnam silvam incendit!"
,"6":"Et lingua ignis est, universitas iniquitatis; lingua constituitur in membris nostris, quae maculat totum corpus et inflammat rotam nativitatis et inflammatur a gehenna."
,"7":"Omnis enim natura et bestiarum et volucrum et serpentium et etiam cetorum domatur et domita est a natura humana;"
,"8":"linguam autem nullus hominum domare potest, inquietum malum, plena veneno mortifero."
,"9":"In ipsa benedicimus Dominum et Patrem et in ipsa maledicimus homines, qui ad similitudinem Dei facti sunt;"
,"10":"ex ipso ore procedit benedictio et maledictio. Non oportet, fratres mei, haec ita fieri."
,"11":"Numquid fons de eodem foramine emanat dulcem et amaram aquam?"
,"12":"Numquid potest, fratres mei, ficus olivas facere, aut vitis ficus? Neque salsa dulcem potest facere aquam."
,"13":"Quis sapiens et disciplinatus inter vos? Ostendat ex bona conversatione operationem suam in mansuetudine sapientiae."
,"14":"Quod si zelum amarum habetis et contentiones in cordibus vestris, nolite gloriari et mendaces esse adversus veritatem."
,"15":"Non est ista sapientia desursum descendens, sed terrena, animalis, diabolica;"
,"16":"ubi enim zelus et contentio, ibi inconstantia et omne opus pravum."
,"17":"Quae autem desursum est sapientia primum quidem pudica est, deinde pacifica, modesta, suadibilis, plena misericordia et fructibus bonis, non iudicans, sine simulatione;"
,"18":"fructus autem iustitiae in pace seminatur facientibus pacem."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Unde bella et unde lites in vobis? Nonne hinc, ex concupi scentiis vestris, quae militant in membris vestris?"
,"2":"Concupiscitis et non habetis; occiditis et zelatis et non potestis adipisci; litigatis et belligeratis. Non habetis, propter quod non postulatis;"
,"3":"petitis et non accipitis, eo quod male petitis, ut in concupiscentiis vestris insumatis."
,"4":"Adulteri, nescitis quia amicitia huius mundi inimica est Dei?,Quicumque ergo voluerit amicus esse saeculi huius, inimicus Dei constituitur. "
,"5":"Aut putatis quia inaniter Scriptura dicat: ' Ad invidiam concupiscit Spiritus, qui inhabitat in nobis? '."
,"6":"Maiorem autem dat gratiam; propter quod dicit: ' Deus superbis resistit, humilibus autem dat gratiam '."
,"7":"Subicimini igitur Deo; resistite autem Diabolo, et fugiet a vobis."
,"8":"Appropiate Deo, et appropinquabit vobis. Emundate manus, peccatores; et purificate corda, duplices animo."
,"9":"Miseri estote et lugete et plorate; risus vester in luctum convertatur, et gaudium in maerorem."
,"10":"Humiliamini in conspectu Domini, et exaltabit vos."
,"11":"Nolite detrahere alterutrum, fratres; qui detrahit fratri, aut qui iudicat fratrem suum, detrahit legi et iudicat legem; si autem iudicas legem, non es factor legis sed iudex."
,"12":"Unus est legislator et iudex, qui potest salvare et perdere; tu autem quis es, qui iudicas proximum?"
,"13":"Age nunc, qui dicitis: ' Hodie aut crastino ibimus in illam civitatem et faciemus quidem ibi annum et mercabimur et lucrum faciemus ';"
,"14":"qui ignoratis, quae erit in crastinum vita vestra! Vapor enim estis ad modicum parens, deinceps exterminatur;"
,"15":"pro eo ut dicatis: ' Si Dominus voluerit, et vivemus et faciemus hoc aut illud '."
,"16":"Nunc autem gloriamini in superbiis vestris; omnis gloriatio talis maligna est."
,"17":"Scienti igitur bonum facere et non facienti, peccatum est illi!"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Age nunc, divites, plorate ulu lantes in miseriis, quae adve nient vobis."
,"2":"Divitiae vestrae putrefactae sunt, et vestimenta vestra a tineis comesta sunt,"
,"3":"aurum et argentum vestrum aeruginavit, et aerugo eorum in testimonium vobis erit et manducabit carnes vestras sicut ignis: thesaurizastis in novissimis diebus."
,"4":"Ecce merces operariorum, qui messuerunt regiones vestras, quae fraudata est a vobis, clamat, et clamores eorum, qui messuerunt, in aures Domini Sabaoth introierunt."
,"5":"Epulati estis super terram et in luxuriis fuistis, enutristis corda vestra in die occisionis."
,"6":"Addixistis, occidistis iustum. Non resistit vobis."
,"7":"Patientes igitur estote, fratres, usque ad adventum Domini. Ecce agricola exspectat pretiosum fructum terrae, patienter ferens, donec accipiat imbrem temporaneum et serotinum."
,"8":"Patientes estote, et vos, confirmate corda vestra, quoniam adventus Domini appropinquavit."
,"9":"Nolite ingemiscere, fratres, in alterutrum, ut non iudicemini; ecce iudex ante ianuam assistit."
,"10":"Exemplum accipite, fratres, laboris et patientiae prophetas, qui locuti sunt in nomine Domini."
,"11":"Ecce beatificamus eos, qui sustinuerunt; sufferentiam Iob audistis et finem Domini vidistis, quoniam misericors est Dominus et miserator."
,"12":"Ante omnia autem, fratres mei, nolite iurare neque per caelum neque per terram, neque aliud quodcumque iuramentum; sit autem vestrum ' Est ' est, et ' Non ' non, uti non sub iudicio decidatis."
,"13":"Tristatur aliquis vestrum? Oret. Aequo animo est? Psallat."
,"14":"Infirmatur quis in vobis? Advocet presbyteros ecclesiae, et orent super eum, unguentes eum oleo in nomine Domini."
,"15":"Et oratio fidei salvabit infirmum, et allevabit eum Dominus; et si peccata operatus fuerit, dimittentur ei."
,"16":"Confitemini ergo alterutrum peccata et orate pro invicem, ut sanemini. Multum enim valet deprecatio iusti operans."
,"17":"Elias homo erat similis nobis passibilis et oratione oravit, ut non plueret, et non pluit super terram annos tres et menses sex;"
,"18":"et rursum oravit, et caelum dedit pluviam, et terra germinavit fructum suum."
,"19":"Fratres mei, si quis ex vobis erraverit a veritate, et converterit quis eum,"
,"20":"scire debet quoniam, qui converti fecerit peccatorem ab errore viae eius, salvabit animam suam a morte et operiet multitudinem peccatorum."
}`)

}
func LA_NVBSE_LoadNCIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Iudas Iesu Christi servus, frater autem Iacobi, his qui sunt vocati, in Deo Patre dilecti et Christo Iesu conservati:"
,"2":"misericordia vobis et pax et caritas adimpleatur."
,"3":"Carissimi, omnem sollicitudinem faciens scribendi vobis de communi nostra salute, necesse habui scribere vobis, deprecans certare pro semel tradita sanctis fide."
,"4":"Subintroierunt enim quidam homines, qui olim praescripti sunt in hoc iudicium, impii, Dei nostri gratiam transferentes in luxuriam, et solum Dominatorem et Dominum nostrum Iesum Christum negantes."
,"5":"Commonere autem vos volo, scientes vos omnia, quoniam Dominus semel populum de terra Aegypti salvans, secundo eos, qui non crediderunt, perdidit;"
,"6":"angelos vero, qui non servaverunt suum principatum, sed dereliquerunt suum domicilium, in iudicium magni diei vinculis aeternis sub caligine reservavit."
,"7":"Sicut Sodoma et Gomorra et finitimae civitates, simili modo exfornicatae et abeuntes post carnem alteram, factae sunt exemplum, ignis aeterni poenam sustinentes."
,"8":"Similiter vero et hi somniantes carnem quidem maculant, dominationem autem spernunt, glorias autem blasphemant."
,"9":"Cum Michael archangelus cum Diabolo disputans altercaretur de Moysis corpore, non est ausus iudicium inferre blasphemiae, sed dixit: ' Increpet te Dominus! '."
,"10":"Hi autem, quaecumque quidem ignorant, blasphemant; quaecumque autem naturaliter tamquam muta animalia norunt, in his corrumpuntur."
,"11":"Vae illis, quia via Cain abierunt et errore Balaam mercede effusi sunt et contradictione Core perierunt!"
,"12":"Hi sunt in agapis vestris maculae, convivantes sine timore, semetipsos pascentes; nubes sine aqua, quae a ventis circumferuntur; arbores autumnales infructuosae bis mortuae, eradicatae;"
,"13":"fluctus feri maris despumantes suas confusiones; sidera errantia, quibus procella tenebrarum in aeternum servata est."
,"14":"Prophetavit autem et his septimus ab Adam Henoch dicens: ' Ecce venit Dominus in sanctis milibus suis"
,"15":"facere iudicium contra omnes et arguere omnem animam de omnibus operibus impietatis eorum, quibus impie egerunt, et de omnibus duris, quae locuti sunt contra eum peccatores impii '."
,"16":"Hi sunt murmuratores, querelosi, secundum concupiscentias suas ambulantes, et os illorum loquitur superba, mirantes personas quaestus causa."
,"17":"Vos autem, carissimi, memores estote verborum, quae praedicta sunt ab apostolis Domini nostri Iesu Christi,"
,"18":"quoniam dicebant vobis: ' In novissimo tempore venient illusores, secundum suas concupiscentias ambulantes impietatum'."
,"19":"Hi sunt qui segregant, animales, Spiritum non habentes."
,"20":"Vos autem, carissimi, superaedificantes vosmetipsos sanctissimae vestrae fidei, in Spiritu Sancto orantes,"
,"21":"ipsos vos in dilectione Dei servate, exspectantes misericordiam Domini nostri Iesu Christi in vitam aeternam."
,"22":"Et his quidem miseremini disputantibus;"
,"23":"illos vero salvate de igne rapientes; aliis autem miseremini in timore, odientes et eam, quae carnalis est, maculatam tunicam."
,"24":"Ei autem, qui potest vos conservare sine peccato et constituere ante conspectum gloriae suae immaculatos in exsultatione,"
,"25":"soli Deo salvatori nostro per Iesum Christum Dominum nostrum gloria, magnificentia, imperium et potestas ante omne saeculum et nunc et in omnia saecula. Amen."
}`)

}
func LA_NVBSE_LoadNEIOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In principio erat Verbum, et Verbum erat apud Deum, et Deus erat Verbum."
,"2":"Hoc erat in principio apud Deum."
,"3":"Omnia per ipsum facta sunt, et sine ipso factum est nihil, quod factum est;"
,"4":"in ipso vita erat, et vita erat lux hominum,"
,"5":"et lux in tenebris lucet, et tenebrae eam non comprehenderunt."
,"6":"Fuit homo missus a Deo, cui nomen erat Ioannes;"
,"7":"hic venit in testimonium, ut testimonium perhiberet de lumine, ut omnes crederent per illum."
,"8":"Non erat ille lux, sed ut testimonium perhiberet de lumine."
,"9":"Erat lux vera, quae illuminat omnem hominem, veniens in mundum."
,"10":"In mundo erat, et mundus per ipsum factus est, et mundus eum non cognovit."
,"11":"In propria venit, et sui eum non receperunt."
,"12":"Quotquot autem acceperunt eum, dedit eis potestatem filios Dei fieri, his, qui credunt in nomine eius,"
,"13":"qui non ex sanguinibus neque ex voluntate carnis neque ex voluntate viri, sed ex Deo nati sunt."
,"14":"Et Verbum caro factum est et habitavit in nobis; et vidimus gloriam eius, gloriam quasi Unigeniti a Patre, plenum gratiae et veritatis."
,"15":"Ioannes testimonium perhibet de ipso et clamat dicens: ' Hic erat, quem dixi: Qui post me venturus est, ante me factus est, quia prior me erat '."
,"16":"Et de plenitudine eius nos omnes accepimus, et gratiam pro gratia;"
,"17":"quia lex per Moysen data est, gratia et veritas per Iesum Christum facta est."
,"18":"Deum nemo vidit umquam; unigenitus Deus, qui est in sinum Patris, ipse enarravit."
,"19":"Et hoc est testimonium Ioannis, quando miserunt ad eum Iudaei ab Hierosolymis sacerdotes et Levitas, ut interrogarent eum: ' Tu quis es? '."
,"20":"Et confessus est et non negavit; et confessus est: ' Non sum ego Christus '."
,"21":"Et interrogaverunt eum: ' Quid ergo? Elias es tu? '. Et dicit: ' Non sum '. ' Propheta es tu? '. Et respondit: ' Non '."
,"22":"Dixerunt ergo ei: ' Quis es? Ut responsum demus his, qui miserunt nos. Quid dicis de teipso? '."
,"23":"Ait: ' Ego vox clamantis in deserto: 'Dirigite viam Domini', sicut dixit Isaias propheta '. "
,"24":"Et qui missi fuerant, erant ex pharisaeis;"
,"25":"et interrogaverunt eum et dixerunt ei: ' Quid ergo baptizas, si tu non es Christus neque Elias neque propheta? '."
,"26":"Respondit eis Ioannes dicens: ' Ego baptizo in aqua; medius vestrum stat, quem vos non scitis,"
,"27":"qui post me venturus est, cuius ego non sum dignus, ut solvam eius corrigiam calceamenti '."
,"28":"Haec in Bethania facta sunt trans Iordanem, ubi erat Ioannes baptizans."
,"29":"Altera die videt Iesum venientem ad se et ait: ' Ecce agnus Dei, qui tollit peccatum mundi."
,"30":"Hic est, de quo dixi: Post me venit vir, qui ante me factus est, quia prior me erat."
,"31":"Et ego nesciebam eum, sed ut manifestetur Israel, propterea veni ego in aqua baptizans '."
,"32":"Et testimonium perhibuit Ioannes dicens: ' Vidi Spiritum descendentem quasi columbam de caelo, et mansit super eum;"
,"33":"et ego nesciebam eum, sed, qui misit me baptizare in aqua, ille mihi dixit: 'Super quem videris Spiritum descendentem et manentem super eum, hic est qui baptizat in Spiritu Sancto'."
,"34":"Et ego vidi et testimonium perhibui quia hic est Filius Dei '."
,"35":"Altera die iterum stabat Ioannes et ex discipulis eius duo,"
,"36":"et respiciens Iesum ambulantem dicit: ' Ecce agnus Dei '."
,"37":"Et audierunt eum duo discipuli loquentem et secuti sunt Iesum."
,"38":"Conversus autem Iesus et videns eos sequentes se dicit eis: ' Quid quaeritis? '. Qui dixerunt ei: ' Rabbi - quod dicitur interpretatum Magister - ubi manes? '."
,"39":"Dicit eis: ' Venite et videbitis '. Venerunt ergo et viderunt, ubi maneret, et apud eum manserunt die illo; hora erat quasi decima."
,"40":"Erat Andreas, frater Simonis Petri, unus ex duobus, qui audierant ab Ioanne et secuti fuerant eum."
,"41":"Invenit hic primum fratrem suum Simonem et dicit ei: ' Invenimus Messiam ' - quod est interpretatum Christus C;"
,"42":"adduxit eum ad Iesum. Intuitus eum Iesus dixit: ' Tu es Simon filius Ioannis; tu vocaberis Cephas ' - quod interpretatur Petrus C."
,"43":"In crastinum voluit exire in Galilaeam et invenit Philippum. Et dicit ei Iesus: ' Sequere me '."
,"44":"Erat autem Philippus a Bethsaida, civitate Andreae et Petri."
,"45":"Invenit Philippus Nathanael et dicit ei: ' Quem scripsit Moyses in Lege et Prophetae invenimus, Iesum filium Ioseph a Nazareth '."
,"46":"Et dixit ei Nathanael: ' A Nazareth potest aliquid boni esse? '. Dicit ei Philippus: ' Veni et vide '."
,"47":"Vidit Iesus Nathanael venientem ad se et dicit de eo: ' Ecce vere Israelita, in quo dolus non est '."
,"48":"Dicit ei Nathanael: ' Unde me nosti? '. Respondit Iesus et dixit ei: ' Priusquam te Philippus vocaret, cum esses sub ficu, vidi te '."
,"49":"Respondit ei Nathanael: ' Rabbi, tu es Filius Dei, tu rex es Israel! '."
,"50":"Respondit Iesus et dixit ei: ' Quia dixi tibi: Vidi te sub ficu, credis? Maiora his videbis '."
,"51":"Et dicit ei: ' Amen, amen dico vobis: Videbitis caelum apertum et angelos Dei ascendentes et descendentes supra Filium hominis '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et die tertio nuptiae factae sunt in Cana Galilaeae, et erat mater Iesu ibi;"
,"2":"vocatus est autem et Iesus et discipuli eius ad nuptias."
,"3":"Et deficiente vino, dicit mater Iesu ad eum: ' Vinum non habent '."
,"4":"Et dicit ei Iesus: ' Quid mihi et tibi, mulier? Nondum venit hora mea '."
,"5":"Dicit mater eius ministris: ' Quodcumque dixerit vobis, facite '."
,"6":"Erant autem ibi lapideae hydriae sex positae secundum purificationem Iudaeorum, capientes singulae metretas binas vel ternas."
,"7":"Dicit eis Iesus: ' Implete hydrias aqua '. Et impleverunt eas usque ad summum."
,"8":"Et dicit eis: ' Haurite nunc et ferte architriclino '. Illi autem tulerunt."
,"9":"Ut autem gustavit architriclinus aquam vinum factam et non sciebat unde esset, ministri autem sciebant, qui haurierant aquam, vocat sponsum architriclinus"
,"10":"et dicit ei: ' Omnis homo primum bonum vinum ponit et, cum inebriati fuerint, id quod deterius est; tu servasti bonum vinum usque adhuc '."
,"11":"Hoc fecit initium signorum Iesus in Cana Galilaeae et manifestavit gloriam suam, et crediderunt in eum discipuli eius."
,"12":"Post hoc descendit Capharnaum ipse et mater eius et fratres eius et discipuli eius, et ibi manserunt non multis diebus."
,"13":"Et prope erat Pascha Iudaeorum, et ascendit Hierosolymam Iesus."
,"14":"Et invenit in templo vendentes boves et oves et columbas, et nummularios sedentes;"
,"15":"et cum fecisset flagellum de funiculis, omnes eiecit de templo, oves quoque et boves, et nummulariorum effudit aes et mensas subvertit;"
,"16":"et his, qui columbas vendebant, dixit: ' Auferte ista hinc! Nolite facere domum Patris mei domum negotiationis '."
,"17":"Recordati sunt discipuli eius quia scriptum est: ' Zelus domus tuae comedit me '."
,"18":"Responderunt ergo Iudaei et dixerunt ei: ' Quod signum ostendis nobis, quia haec facis? '."
,"19":"Respondit Iesus et dixit eis: ' Solvite templum hoc, et in tribus diebus excitabo illud '."
,"20":"Dixerunt ergo Iudaei: ' Quadraginta et sex annis aedificatum est templum hoc, et tu tribus diebus excitabis illud? '."
,"21":"Ille autem dicebat de templo corporis sui."
,"22":"Cum ergo resurrexisset a mortuis, recordati sunt discipuli eius quia hoc dicebat, et crediderunt Scripturae et sermoni, quem dixit Iesus."
,"23":"Cum autem esset Hierosolymis in Pascha, in die festo, multi crediderunt in nomine eius, videntes signa eius, quae faciebat."
,"24":"Ipse autem Iesus non credebat semetipsum eis, eo quod ipse nosset omnes,"
,"25":"et quia opus ei non erat, ut quis testimonium perhiberet de homine; ipse enim sciebat quid esset in homine."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Erat autem homo ex pharisaeis, Nicodemus nomine, princeps Iudaeorum;"
,"2":"hic venit ad eum nocte et dixit ei: ' Rabbi, scimus quia a Deo venisti magister; nemo enim potest haec signa facere, quae tu facis, nisi fuerit Deus cum eo '."
,"3":"Respondit Iesus et dixit ei: ' Amen, amen dico tibi: Nisi quis natus fuerit desuper, non potest videre regnum Dei '."
,"4":"Dicit ad eum Nicodemus: ' Quomodo potest homo nasci, cum senex sit? Numquid potest in ventrem matris suae iterato introire et nasci? '."
,"5":"Respondit Iesus: ' Amen, amen dico tibi: Nisi quis natus fuerit ex aqua et Spiritu, non potest introire in regnum Dei."
,"6":"Quod natum est ex carne, caro est; et, quod natum est ex Spiritu, spiritus est."
,"7":"Non mireris quia dixi tibi: Oportet vos nasci denuo."
,"8":"Spiritus, ubi vult, spirat, et vocem eius audis, sed non scis unde veniat et quo vadat; sic est omnis, qui natus est ex Spiritu '."
,"9":"Respondit Nicodemus et dixit ei: ' Quomodo possunt haec fieri? '."
,"10":"Respondit Iesus et dixit ei: ' Tu es magister Israel et haec ignoras?"
,"11":"Amen, amen dico tibi: Quod scimus, loquimur et, quod vidimus, testamur; et testimonium nostrum non accipitis."
,"12":"Si terrena dixi vobis, et non creditis, quomodo, si dixero vobis caelestia, credetis?"
,"13":"Et nemo ascendit in caelum, nisi qui descendit de caelo, Filius hominis."
,"14":"Et sicut Moyses exaltavit serpentem in deserto, ita exaltari oportet Filium hominis,"
,"15":"ut omnis, qui credit, in ipso habeat vitam aeternam '."
,"16":"Sic enim dilexit Deus mundum, ut Filium suum unigenitum daret, ut omnis, qui credit in eum, non pereat, sed habeat vitam aeternam."
,"17":"Non enim misit Deus Filium in mundum, ut iudicet mundum, sed ut salvetur mundus per ipsum."
,"18":"Qui credit in eum, non iudicatur; qui autem non credit, iam iudicatus est, quia non credidit in nomen Unigeniti Filii Dei."
,"19":"Hoc est autem iudicium: Lux venit in mundum, et dilexerunt homines magis tenebras quam lucem; erant enim eorum mala opera."
,"20":"Omnis enim, qui mala agit, odit lucem et non venit ad lucem, ut non arguantur opera eius;"
,"21":"qui autem facit veritatem, venit ad lucem, ut manifestentur eius opera, quia in Deo sunt facta."
,"22":"Post haec venit Iesus et discipuli eius in Iudaeam terram, et illic demorabatur cum eis et baptizabat."
,"23":"Erat autem et Ioannes baptizans in Enon iuxta Salim, quia aquae multae erant illic, et adveniebant et baptizabantur;"
,"24":"nondum enim missus fuerat in carcerem Ioannes."
,"25":"Facta est ergo quaestio ex discipulis Ioannis cum Iudaeo de purificatione."
,"26":"Et venerunt ad Ioannem et dixerunt ei: ' Rabbi, qui erat tecum trans Iordanem, cui tu testimonium perhibuisti, ecce hic baptizat, et omnes veniunt ad eum! '."
,"27":"Respondit Ioannes et dixit: ' Non potest homo accipere quidquam, nisi fuerit ei datum de caelo."
,"28":"Ipsi vos mihi testimonium perhibetis, quod dixerim: Non sum ego Christus, sed: Missus sum ante illum."
,"29":"Qui habet sponsam, sponsus est; amicus autem sponsi, qui stat et audit eum, gaudio gaudet propter vocem sponsi. Hoc ergo gaudium meum impletum est."
,"30":"Illum oportet crescere, me autem minui '."
,"31":"Qui de sursum venit, supra omnes est; qui est de terra, de terra est et de terra loquitur. Qui de caelo venit, supra omnes est;"
,"32":"et quod vidit et audivit, hoc testatur, et testimonium eius nemo accipit."
,"33":"Qui accipit eius testimonium, signavit quia Deus verax est."
,"34":"Quem enim misit Deus, verba Dei loquitur; non enim ad mensuram dat Spiritum."
,"35":"Pater diligit Filium et omnia dedit in manu eius."
,"36":"Qui credit in Filium, habet vitam aeternam; qui autem incredulus est Filio, non videbit vitam, sed ira Dei manet super eum."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ut ergo cognovit Iesus quia audierunt pharisaei quia Iesus plures discipulos facit et baptizat quam Ioannes"
,"2":"- quamquam Iesus ipse non baptizaret sed discipuli eius -"
,"3":"reliquit Iudaeam et abiit iterum in Galilaeam."
,"4":"Oportebat autem eum transire per Samariam."
,"5":"Venit ergo in civitatem Samariae, quae dicitur Sichar, iuxta praedium, quod dedit Iacob Ioseph filio suo;"
,"6":"erat autem ibi fons Iacob. Iesus ergo fatigatus ex itinere sedebat sic super fontem; hora erat quasi sexta."
,"7":"Venit mulier de Samaria haurire aquam. Dicit ei Iesus: ' Da mihi bibere ';"
,"8":"discipuli enim eius abierant in civitatem, ut cibos emerent."
,"9":"Dicit ergo ei mulier illa Samaritana: ' Quomodo tu, Iudaeus cum sis, bibere a me poscis, quae sum mulier Samaritana? '. Non enim coutuntur Iudaei Samaritanis."
,"10":"Respondit Iesus et dixit ei: ' Si scires donum Dei, et quis est, qui dicit tibi: 'Da mihi bibere', tu forsitan petisses ab eo, et dedisset tibi aquam vivam '."
,"11":"Dicit ei mulier: ' Domine, neque in quo haurias habes, et puteus altus est; unde ergo habes aquam vivam?"
,"12":"Numquid tu maior es patre nostro Iacob, qui dedit nobis puteum, et ipse ex eo bibit et filii eius et pecora eius? '."
,"13":"Respondit Iesus et dixit ei: ' Omnis, qui bibit ex aqua hac, sitiet iterum;"
,"14":"qui autem biberit ex aqua, quam ego dabo ei, non sitiet in aeternum; sed aqua, quam dabo ei, fiet in eo fons aquae salientis in vitam aeternam '."
,"15":"Dicit ad eum mulier: ' Domine, da mihi hanc aquam, ut non sitiam neque veniam huc haurire '."
,"16":"Dicit ei: ' Vade, voca virum tuum et veni huc '."
,"17":"Respondit mulier et dixit ei: ' Non habeo virum '. Dicit ei Iesus: ' Bene dixisti: 'Non habeo virum';"
,"18":"quinque enim viros habuisti, et nunc, quem habes, non est tuus vir. Hoc vere dixisti '."
,"19":"Dicit ei mulier: ' Domine, video quia propheta es tu."
,"20":"Patres nostri in monte hoc adoraverunt, et vos dicitis quia in Hierosolymis est locus, ubi adorare oportet '."
,"21":"Dicit ei Iesus: ' Crede mihi, mulier, quia venit hora, quando neque in monte hoc neque in Hierosolymis adorabitis Patrem."
,"22":"Vos adoratis, quod nescitis; nos adoramus, quod scimus, quia salus ex Iudaeis est."
,"23":"Sed venit hora, et nunc est, quando veri adoratores adorabunt Patrem in Spiritu et veritate; nam et Pater tales quaerit, qui adorent eum."
,"24":"Spiritus est Deus, et eos, qui adorant eum, in Spiritu et veritate oportet adorare '."
,"25":"Dicit ei mulier: ' Scio quia Messias venit - qui dicitur Christus C; cum venerit ille, nobis annuntiabit omnia '."
,"26":"Dicit ei Iesus: ' Ego sum, qui loquor tecum '."
,"27":"Et continuo venerunt discipuli eius et mirabantur quia cum muliere loquebatur; nemo tamen dixit: ' Quid quaeris aut quid loqueris cum ea? '."
,"28":"Reliquit ergo hydriam suam mulier et abiit in civitatem et dicit illis hominibus:"
,"29":"' Venite, videte hominem, qui dixit mihi omnia, quaecumque feci; numquid ipse est Christus? '."
,"30":"Exierunt de civitate et veniebant ad eum."
,"31":"Interea rogabant eum discipuli dicentes: ' Rabbi, manduca '."
,"32":"Ille autem dixit eis: ' Ego cibum habeo manducare, quem vos nescitis '."
,"33":"Dicebant ergo discipuli ad invicem: ' Numquid aliquis attulit ei manducare? '."
,"34":"Dicit eis Iesus: ' Meus cibus est, ut faciam voluntatem eius, qui misit me, et ut perficiam opus eius."
,"35":"Nonne vos dicitis: 'Adhuc quattuor menses sunt, et messis venit'? Ecce dico vobis: Levate oculos vestros et videte regiones, quia albae sunt ad messem! Iam"
,"36":"qui metit, mercedem accipit et congregat fructum in vitam aeternam, ut et qui seminat, simul gaudeat et qui metit."
,"37":"In hoc enim est verbum verum: Alius est qui seminat, et alius est qui metit."
,"38":"Ego misi vos metere, quod vos non laborastis; alii laboraverunt, et vos in laborem eorum introistis '."
,"39":"Ex civitate autem illa multi crediderunt in eum Samaritanorum propter verbum mulieris testimonium perhibentis: ' Dixit mihi omnia, quaecumque feci! '."
,"40":"Cum venissent ergo ad illum Samaritani, rogaverunt eum, ut apud ipsos maneret; et mansit ibi duos dies."
,"41":"Et multo plures crediderunt propter sermonem eius;"
,"42":"et mulieri dicebant: ' Iam non propter tuam loquelam credimus; ipsi enim audivimus et scimus quia hic est vere Salvator mundi! '."
,"43":"Post duos autem dies exiit inde in Galilaeam;"
,"44":"ipse enim Iesus testimonium perhibuit, quia propheta in sua patria honorem non habet."
,"45":"Cum ergo venisset in Galilaeam, exceperunt eum Galilaei, cum omnia vidissent, quae fecerat Hierosolymis in die festo; et ipsi enim venerant in diem festum."
,"46":"Venit ergo iterum in Cana Galilaeae, ubi fecit aquam vinum. Et erat quidam regius, cuius filius infirmabatur Capharnaum;"
,"47":"hic, cum audisset quia Iesus advenerit a Iudaea in Galilaeam, abiit ad eum et rogabat, ut descenderet et sanaret filium eius; incipiebat enim mori."
,"48":"Dixit ergo Iesus ad eum: ' Nisi signa et prodigia videritis, non credetis '."
,"49":"Dicit ad eum regius: ' Domine, descende priusquam moriatur puer meus '."
,"50":"Dicit ei Iesus: ' Vade. Filius tuus vivit '. Credidit homo sermoni, quem dixit ei Iesus, et ibat."
,"51":"Iam autem eo descendente, servi eius occurrerunt ei dicentes quia puer eius vivit."
,"52":"Interrogabat ergo horam ab eis, in qua melius habuerit. Dixerunt ergo ei: ' Heri hora septima reliquit eum febris '."
,"53":"Cognovit ergo pater quia illa hora erat, in qua dixit ei Iesus: ' Filius tuus vivit ', et credidit ipse et domus eius tota."
,"54":"Hoc iterum secundum signum fecit Iesus, cum venisset a Iudaea in Galilaeam."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Post haec erat dies festus Iu daeorum, et ascendit Iesus Hie rosolymam."
,"2":"Est autem Hierosolymis, super Probatica, piscina, quae cognominatur Hebraice,Bethsatha, quinque porticus habens. "
,"3":"In his iacebat multitudo languentium, caecorum, claudorum, aridorum. (4) 5 Erat autem quidam homo ibi triginta et octo annos habens in infirmitate sua. "
,"6":"Hunc cum vidisset Iesus iacentem, et cognovisset quia multum iam tempus habet, dicit ei: ' Vis sanus fieri? '."
,"7":"Respondit ei languidus: ' Domine, hominem non habeo, ut, cum turbata fuerit aqua, mittat me in piscinam; dum autem venio ego, alius ante me descendit '."
,"8":"Dicit ei Iesus: ' Surge, tolle grabatum tuum et ambula '."
,"9":"Et statim sanus factus est homo et sustulit grabatum suum et ambulabat. Erat autem sabbatum in illo die. "
,"10":"Dicebant ergo Iudaei illi, qui sanatus fuerat: ' Sabbatum est, et non licet tibi tollere grabatum tuum '."
,"11":"Ille autem respondit eis: ' Qui me fecit sanum, ille mihi dixit: 'Tolle grabatum tuum et ambula' '."
,"12":"Interrogaverunt eum: ' Quis est ille homo, qui dixit tibi: 'Tolle et ambula'? '."
,"13":"Is autem, qui sanus fuerat effectus, nesciebat quis esset; Iesus enim declinavit a turba constituta in loco."
,"14":"Postea invenit eum Iesus in templo et dixit illi: ' Ecce sanus factus es; iam noli peccare, ne deterius tibi aliquid contingat '."
,"15":"Abiit ille homo et nuntiavit Iudaeis quia Iesus esset, qui fecit eum sanum."
,"16":"Et propterea persequebantur Iudaei Iesum, quia haec faciebat in sabbato."
,"17":"Iesus autem respondit eis: ' Pater meus usque modo operatur, et ego operor '."
,"18":"Propterea ergo magis quaerebant eum Iudaei interficere, quia non solum solvebat sabbatum, sed et Patrem suum dicebat Deum, aequalem se faciens Deo."
,"19":"Respondit itaque Iesus et dixit eis: ' Amen, amen dico vobis: Non potest Filius a se facere quidquam, nisi quod viderit Patrem facientem; quaecumque enim ille faciat, haec et Filius similiter facit."
,"20":"Pater enim diligit Filium et omnia demonstrat ei, quae ipse facit, et maiora his demonstrabit ei opera, ut vos miremini."
,"21":"Sicut enim Pater suscitat mortuos et vivificat, sic et Filius, quos vult, vivificat."
,"22":"Neque enim Pater iudicat quemquam, sed iudicium omne dedit Filio,"
,"23":"ut omnes honorificent Filium, sicut honorificant Patrem. Qui non honorificat Filium, non honorificat Patrem, qui misit illum."
,"24":"Amen, amen dico vobis: Qui verbum meum audit et credit ei, qui misit me, habet vitam aeternam et in iudicium non venit, sed transiit a morte in vitam."
,"25":"Amen, amen dico vobis: Venit hora, et nunc est, quando mortui audient vocem Filii Dei et, qui audierint, vivent."
,"26":"Sicut enim Pater habet vitam in semetipso, sic dedit et Filio vitam habere in semetipso;"
,"27":"et potestatem dedit ei iudicium facere, quia Filius hominis est."
,"28":"Nolite mirari hoc, quia venit hora, in qua omnes, qui in monumentis sunt, audient vocem eius;"
,"29":"et procedent, qui bona fecerunt, in resurrectionem vitae, qui vero mala egerunt, in resurrectionem iudicii."
,"30":"Non possum ego a meipso facere quidquam; sicut audio, iudico, et iudicium meum iustum est, quia non quaero voluntatem meam, sed voluntatem eius, qui misit me."
,"31":"Si ego testimonium perhibeo de meipso, testimonium meum non est verum;"
,"32":"alius est, qui testimonium perhibet de me, et scio quia verum est testimonium, quod perhibet de me."
,"33":"Vos misistis ad Ioannem, et testimonium perhibuit veritati;"
,"34":"ego autem non ab homine testimonium accipio, sed haec dico, ut vos salvi sitis."
,"35":"Ille erat lucerna ardens et lucens; vos autem voluistis exsultare ad horam in luce eius."
,"36":"Ego autem habeo testimonium maius Ioanne; opera enim, quae dedit mihi Pater, ut perficiam ea, ipsa opera, quae ego facio, testimonium perhibent de me, quia Pater me misit;"
,"37":"et, qui misit me, Pater, ipse testimonium perhibuit de me. Neque vocem eius umquam audistis neque speciem eius vidistis;"
,"38":"et verbum eius non habetis in vobis manens, quia, quem misit ille, huic vos non creditis."
,"39":"Scrutamini Scripturas, quia vos putatis in ipsis vitam aeternam habere; et illae sunt, quae testimonium perhibent de me."
,"40":"Et non vultis venire ad me, ut vitam habeatis."
,"41":"Gloriam ab hominibus non accipio,"
,"42":"sed cognovi vos, quia dilectionem Dei non habetis in vobis."
,"43":"Ego veni in nomine Patris mei, et non accipitis me; si alius venerit in nomine suo, illum accipietis."
,"44":"Quomodo potestis vos credere, qui gloriam ab invicem accipitis, et gloriam, quae a solo est Deo, non quaeritis?"
,"45":"Nolite putare quia ego accusaturus sim vos apud Patrem; est qui accuset vos: Moyses, in quo vos speratis."
,"46":"Si enim crederetis Moysi, crederetis forsitan et mihi; de me enim ille scripsit."
,"47":"Si autem illius litteris non creditis, quomodo meis verbis credetis? '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Post haec abiit Iesus trans mare Galilaeae, quod est Tiberiadis."
,"2":"Et sequebatur eum multitudo magna, quia videbant signa, quae faciebat super his, qui infirmabantur."
,"3":"Subiit autem in montem Iesus et ibi sedebat cum discipulis suis."
,"4":"Erat autem proximum Pascha, dies festus Iudaeorum."
,"5":"Cum sublevasset ergo oculos Iesus et vidisset quia multitudo magna venit ad eum, dicit ad Philippum: ' Unde ememus panes, ut manducent hi? '."
,"6":"Hoc autem dicebat tentans eum; ipse enim sciebat quid esset facturus."
,"7":"Respondit ei Philippus: ' Ducentorum denariorum panes non sufficiunt eis, ut unusquisque modicum quid accipiat! '."
,"8":"Dicit ei unus ex discipulis eius, Andreas frater Simonis Petri:"
,"9":"' Est puer hic, qui habet quinque panes hordeaceos et duos pisces; sed haec quid sunt propter tantos? '."
,"10":"Dixit Iesus: ' Facite homines discumbere '. Erat autem fenum multum in loco. Discubuerunt ergo viri numero quasi quinque milia."
,"11":"Accepit ergo panes Iesus et, cum gratias egisset, distribuit discumbentibus; similiter et ex piscibus, quantum volebant."
,"12":"Ut autem impleti sunt, dicit discipulis suis: ' Colligite, quae superaverunt, fragmenta, ne quid pereat '."
,"13":"Collegerunt ergo et impleverunt duodecim cophinos fragmentorum ex quinque panibus hordeaceis, quae superfuerunt his, qui manducaverunt."
,"14":"Illi ergo homines, cum vidissent quod fecerat signum, dicebant: ' Hic est vere propheta, qui venit in mundum! '."
,"15":"Iesus ergo, cum cognovisset quia venturi essent, ut raperent eum et facerent eum regem, secessit iterum in montem ipse solus."
,"16":"Ut autem sero factum est, descenderunt discipuli eius ad mare"
,"17":"et, cum ascendissent navem, veniebant trans mare in Capharnaum. Et tenebrae iam factae erant, et nondum venerat ad eos Iesus."
,"18":"Mare autem, vento magno flante, exsurgebat."
,"19":"Cum remigassent ergo quasi stadia viginti quinque aut triginta, vident Iesum ambulantem super mare et proximum navi fieri, et timuerunt."
,"20":"Ille autem dicit eis: ' Ego sum, nolite timere! '."
,"21":"Volebant ergo accipere eum in navem, et statim fuit navis ad terram, in quam ibant."
,"22":"Altera die turba, quae stabat trans mare, vidit quia navicula alia non erat ibi, nisi una, et quia non introisset cum discipulis suis Iesus in navem, sed soli discipuli eius abiissent;"
,"23":"aliae supervenerunt naves a Tiberiade iuxta locum, ubi manducaverant panem, gratias agente Domino."
,"24":"Cum ergo vidisset turba quia Iesus non esset ibi neque discipuli eius, ascenderunt ipsi naviculas et venerunt Capharnaum quaerentes Iesum."
,"25":"Et cum invenissent eum trans mare, dixerunt ei: ' Rabbi, quando huc venisti? '."
,"26":"Respondit eis Iesus et dixit: ' Amen, amen dico vobis: Quaeritis me, non quia vidistis signa, sed quia manducastis ex panibus et saturati estis."
,"27":"Operamini non cibum, qui perit, sed cibum, qui permanet in vitam aeternam, quem Filius hominis vobis dabit; hunc enim Pater signavit Deus! '."
,"28":"Dixerunt ergo ad eum: ' Quid faciemus, ut operemur opera Dei? '."
,"29":"Respondit Iesus et dixit eis: ' Hoc est opus Dei, ut credatis in eum, quem misit ille '."
,"30":"Dixerunt ergo ei: ' Quod ergo tu facis signum, ut videamus et credamus tibi? Quid operaris?"
,"31":"Patres nostri manna manducaverunt in deserto, sicut scriptum est: 'Panem de caelo dedit eis manducare' '."
,"32":"Dixit ergo eis Iesus: ' Amen, amen dico vobis: Non Moyses dedit vobis panem de caelo, sed Pater meus dat vobis panem de caelo verum;"
,"33":"panis enim Dei est, qui descendit de caelo et dat vitam mundo '."
,"34":"Dixerunt ergo ad eum: ' Domine, semper da nobis panem hunc '."
,"35":"Dixit eis Iesus: ' Ego sum panis vitae. Qui venit ad me, non esuriet; et, qui credit in me, non sitiet umquam."
,"36":"Sed dixi vobis, quia et vidistis me et non creditis."
,"37":"Omne, quod dat mihi Pater, ad me veniet; et eum, qui venit ad me, non eiciam foras,"
,"38":"quia descendi de caelo, non ut faciam voluntatem meam sed voluntatem eius, qui misit me."
,"39":"Haec est autem voluntas eius, qui misit me, ut omne, quod dedit mihi, non perdam ex eo, sed resuscitem illud in novissimo die."
,"40":"Haec est enim voluntas Patris mei, ut omnis, qui videt Filium et credit in eum, habeat vitam aeternam; et resuscitabo ego eum in novissimo die '."
,"41":"Murmurabant ergo Iudaei de illo, quia dixisset: ' Ego sum panis, qui de caelo descendi ',"
,"42":"et dicebant: ' Nonne hic est Iesus filius Ioseph, cuius nos novimus patrem et matrem? Quomodo dicit nunc: 'De caelo descendi'? '."
,"43":"Respondit Iesus et dixit eis: ' Nolite murmurare in invicem."
,"44":"Nemo potest venire ad me, nisi Pater, qui misit me, traxerit eum; et ego resuscitabo eum in novissimo die."
,"45":"Est scriptum in Prophetis: 'Et erunt omnes docibiles Dei '. Omnis, qui audivit a Patre et didicit, venit ad me."
,"46":"Non quia Patrem vidit quisquam, nisi is qui est a Deo, hic vidit Patrem."
,"47":"Amen, amen dico vobis: Qui credit, habet vitam aeternam."
,"48":"Ego sum panis vitae."
,"49":"Patres vestri manducaverunt in deserto manna et mortui sunt."
,"50":"Hic est panis de caelo descendens, ut, si quis ex ipso manducaverit, non moriatur."
,"51":"Ego sum panis vivus, qui de caelo descendi. Si quis manducaverit ex hoc pane, vivet in aeternum; panis autem, quem ego dabo, caro mea est pro mundi vita '."
,"52":"Litigabant ergo Iudaei ad invicem dicentes: ' Quomodo potest hic nobis carnem suam dare ad manducandum? '."
,"53":"Dixit ergo eis Iesus: ' Amen, amen dico vobis: Nisi manducaveritis carnem Filii hominis et biberitis eius sanguinem, non habetis vitam in vobismetipsis."
,"54":"Qui manducat meam carnem et bibit meum sanguinem, habet vitam aeternam; et ego resuscitabo eum in novissimo die."
,"55":"Caro enim mea verus est cibus, et sanguis meus verus est potus."
,"56":"Qui manducat meam carnem et bibit meum sanguinem, in me manet, et ego in illo."
,"57":"Sicut misit me vivens Pater, et ego vivo propter Patrem; et, qui manducat me, et ipse vivet propter me."
,"58":"Hic est panis, qui de caelo descendit, non sicut manducaverunt patres et mortui sunt; qui manducat hunc panem, vivet in aeternum '."
,"59":"Haec dixit in synagoga docens in Capharnaum."
,"60":"Multi ergo audientes ex discipulis eius dixerunt: ' Durus est hic sermo! Quis potest eum audire? '."
,"61":"Sciens autem Iesus apud semetipsum quia murmurarent de hoc discipuli eius, dixit eis: ' Hoc vos scandalizat?"
,"62":"Si ergo videritis Filium hominis ascendentem, ubi erat prius?"
,"63":"Spiritus est, qui vivificat, caro non prodest quidquam; verba, quae ego locutus sum vobis, Spiritus sunt et vita sunt."
,"64":"Sed sunt quidam ex vobis, qui non credunt '. Sciebat enim ab initio Iesus, qui essent non credentes, et quis traditurus esset eum."
,"65":"Et dicebat: ' Propterea dixi vobis: Nemo potest venire ad me, nisi fuerit ei datum a Patre '."
,"66":"Ex hoc multi discipulorum eius abierunt retro et iam non cum illo ambulabant."
,"67":"Dixit ergo Iesus ad Duodecim: ' Numquid et vos vultis abire? '."
,"68":"Respondit ei Simon Petrus: ' Domine, ad quem ibimus? Verba vitae aeternae habes;"
,"69":"et nos credidimus et cognovimus quia tu es Sanctus Dei '."
,"70":"Respondit eis Iesus: ' Nonne ego vos Duodecim elegi? Et ex vobis unus Diabolus est '."
,"71":"Dicebat autem Iudam Simonis Iscariotis; hic enim erat traditurus eum, cum esset unus ex Duodecim."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Et post haec ambulabat Iesus in Galilaeam; non enim volebat in Iudaeam ambulare, quia quaerebant eum Iudaei interficere."
,"2":"Erat autem in proximo dies festus Iudaeorum, Scenopegia."
,"3":"Dixerunt ergo ad eum fratres eius: ' Transi hinc et vade in Iudaeam, ut et discipuli tui videant opera tua, quae facis."
,"4":"Nemo quippe in occulto quid facit et quaerit ipse in palam esse. Si haec facis, manifesta teipsum mundo '."
,"5":"Neque enim fratres eius credebant in eum."
,"6":"Dicit ergo eis Iesus: ' Tempus meum nondum adest, tempus autem vestrum semer est paratum."
,"7":"Non potest mundus odisse vos; me autem odit, quia ego testimonium perhibeo de illo, quia opera eius mala sunt."
,"8":"Vos ascendite ad diem festum; ego non ascendo ad diem festum istum, quia meum tempus nondum impletum est '."
,"9":"Haec autem cum dixisset, ipse mansit in Galilaea."
,"10":"Ut autem ascenderunt fratres eius ad diem festum, tunc et ipse ascendit, non manifeste sed quasi in occulto."
,"11":"Iudaei ergo quaerebant eum in die festo et dicebant: ' Ubi est ille? '."
,"12":"Et murmur multus de eo erat in turba. Alii quidem dicebant: ' Bonus est! '; alii autem dicebant: ' Non, sed seducit turbam! '."
,"13":"Nemo tamen palam loquebatur de illo propter metum Iudaeorum."
,"14":"Iam autem die festo mediante, ascendit Iesus in templum et docebat."
,"15":"Mirabantur ergo Iudaei dicentes: ' Quomodo hic litteras scit, cum non didicerit? '."
,"16":"Respondit ergo eis Iesus et dixit: ' Mea doctrina non est mea sed eius, qui misit me."
,"17":"Si quis voluerit voluntatem eius facere, cognoscet de doctrina utrum ex Deo sit, an ego a meipso loquar."
,"18":"Qui a semetipso loquitur, gloriam propriam quaerit; qui autem quaerit gloriam eius, qui misit illum, hic verax est, et iniustitia in illo non est."
,"19":"Nonne Moyses dedit vobis legem? Et nemo ex vobis facit legem. Quid me quaeritis interficere? '."
,"20":"Respondit turba: ' Daemonium habes! Quis te quaerit interficere? '."
,"21":"Respondit Iesus et dixit eis: ' Unum opus feci, et omnes miramini."
,"22":"Propterea Moyses dedit vobis circumcisionem - non quia ex Moyse est sed ex patribus - et in sabbato circumciditis hominem."
,"23":"Si circumcisionem accipit homo in sabbato, ut non solvatur lex Moysis, mihi indignamini, quia totum hominem sanum feci in sabbato?"
,"24":"Nolite iudicare secundum faciem, sed iustum iudicium iudicate '."
,"25":"Dicebant ergo quidam ex Hierosolymitis: ' Nonne hic est, quem quaerunt interficere?"
,"26":"Et ecce palam loquitur, et nihil ei dicunt. Numquid vere cognoverunt principes quia hic est Christus?"
,"27":"Sed hunc scimus unde sit, Christus autem cum venerit, nemo scit unde sit '."
,"28":"Clamavit ergo docens in templo Iesus et dicens: ' Et me scitis et unde sim scitis. Et a meipso non veni, sed est verus, qui misit me, quem vos non scitis."
,"29":"Ego scio eum, quia ab ipso sum, et ipse me misit '."
,"30":"Quaerebant ergo eum apprehendere, et nemo misit in illum manus, quia nondum venerat hora eius."
,"31":"De turba autem multi crediderunt in eum et dicebant: ' Christus cum venerit, numquid plura signa faciet quam quae hic fecit? '."
,"32":"Audierunt pharisaei turbam murmurantem de illo haec et miserunt pontifices et pharisaei ministros, ut apprehenderent eum."
,"33":"Dixit ergo Iesus: ' Adhuc modicum tempus vobiscum sum et vado ad eum, qui misit me."
,"34":"Quaeretis me et non invenietis; et ubi sum ego, vos non potestis venire '."
,"35":"Dixerunt ergo Iudaei ad seipsos: ' Quo hic iturus est, quia nos non inveniemus eum? Numquid in dispersionem Graecorum iturus est et docturus Graecos?"
,"36":"Quis est hic sermo, quem dixit: 'Quaeretis me et non invenietis' et: 'Ubi sum ego, vos non potestis venire'? '."
,"37":"In novissimo autem die magno festivitatis stabat Iesus et clamavit dicens: ' Si quis sitit, veniat ad me et bibat,"
,"38":"qui credit in me. Sicut dixit Scriptura, flumina de ventre eius fluent aquae vivae '."
,"39":"Hoc autem dixit de Spiritu, quem accepturi erant qui crediderant in eum. Nondum enim erat Spiritus, quia Iesus nondum fuerat glorificatus."
,"40":"Ex illa ergo turba, cum audissent hos sermones, dicebant: ' Hic est vere propheta! ';"
,"41":"alii dicebant: ' Hic est Christus! '; quidam autem dicebant: ' Numquid a Galilaea Christus venit?"
,"42":"Nonne Scriptura dixit: 'Ex semine David et de Bethlehem castello, ubi erat David, venit Christus'? '."
,"43":"Dissensio itaque facta est in turba propter eum."
,"44":"Quidam autem ex ipsis volebant apprehendere eum, sed nemo misit super illum manus."
,"45":"Venerunt ergo ministri ad pontifices et pharisaeos; et dixerunt eis illi: ' Quare non adduxistis eum? '."
,"46":"Responderunt ministri: ' Numquam sic locutus est homo '."
,"47":"Responderunt ergo eis pharisaei: ' Numquid et vos seducti estis?"
,"48":"Numquid aliquis ex principibus credidit in eum aut ex pharisaeis?"
,"49":"Sed turba haec, quae non novit legem, maledicti sunt! '."
,"50":"Dicit Nicodemus ad eos, ille qui venit ad eum antea, qui unus erat ex ipsis:"
,"51":"' Numquid lex nostra iudicat hominem, nisi audierit ab ipso prius et cognoverit quid faciat? '."
,"52":"Responderunt et dixerunt ei: ' Numquid et tu ex Galilaea es? Scrutare et vide quia propheta a Galilaea non surgit! '."
,"53":"Et reversi sunt unusquisque in domum suam."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Iesus autem perrexit in montem Oliveti."
,"2":"Diluculo autem iterum venit in templum, et omnis populus veniebat ad eum, et sedens docebat eos."
,"3":"Adducunt autem scribae et pharisaei mulierem in adulterio deprehensam et statuerunt eam in medio"
,"4":"et dicunt ei: ' Magister, haec mulier manifesto deprehensa est in adulterio."
,"5":"In lege autem Moyses mandavit nobis huiusmodi lapidare; tu ergo quid dicis? '."
,"6":"Hoc autem dicebant tentantes eum, ut possent accusare eum. Iesus autem inclinans se deorsum digito scribebat in terra."
,"7":"Cum autem perseverarent interrogantes eum, erexit se et dixit eis: ' Qui sine peccato est vestrum, primus in illam lapidem mittat ';"
,"8":"et iterum se inclinans scribebat in terra."
,"9":"Audientes autem unus post unum exibant, incipientes a senioribus, et remansit solus, et mulier in medio stans."
,"10":"Erigens autem se Iesus dixit ei: ' Mulier, ubi sunt? Nemo te condemnavit? '."
,"11":"Quae dixit: ' Nemo, Domine '. Dixit autem Iesus: ' Nec ego te condemno; vade et amplius iam noli peccare '."
,"12":"Iterum ergo locutus est eis Iesus dicens: ' Ego sum lux mundi; qui sequitur me, non ambulabit in tenebris, sed habebit lucem vitae '."
,"13":"Dixerunt ergo ei pharisaei: ' Tu de teipso testimonium perhibes; testimonium tuum non est verum '."
,"14":"Respondit Iesus et dixit eis: ' Et si ego testimonium perhibeo de meipso, verum est testimonium meum, quia scio unde veni et quo vado; vos autem nescitis unde venio aut quo vado."
,"15":"Vos secundum carnem iudicatis, ego non iudico quemquam."
,"16":"Et si iudico ego, iudicium meum verum est, quia solus non sum, sed ego et, qui me misit, Pater."
,"17":"Sed et in lege vestra scriptum est, quia duorum hominum testimonium verum est."
,"18":"Ego sum, qui testimonium perhibeo de meipso, et testimonium perhibet de me, qui misit me, Pater '."
,"19":"Dicebant ergo ei: ' Ubi est Pater tuus? '. Respondit Iesus: ' Neque me scitis neque Patrem meum; si me sciretis, forsitan et Patrem meum sciretis '."
,"20":"Haec verba locutus est in gazophylacio docens in templo; et nemo apprehendit eum, quia necdum venerat hora eius."
,"21":"Dixit ergo iterum eis: ' Ego vado, et quaeretis me et in peccato vestro moriemini! Quo ego vado, vos non potestis venire '."
,"22":"Dicebant ergo Iudaei: ' Numquid interficiet semetipsum, quia dicit: 'Quo ego vado, vos non potestis venire'? '."
,"23":"Et dicebat eis: ' Vos de deorsum estis, ego de supernis sum; vos de mundo hoc estis, ego non sum de hoc mundo."
,"24":"Dixi ergo vobis quia moriemini in peccatis vestris; si enim non credideritis quia ego sum, moriemini in peccatis vestris '."
,"25":"Dicebant ergo ei: ' Tu quis es? '. Dixit eis Iesus: ' In principio: id quod et loquor vobis!"
,"26":"Multa habeo de vobis loqui et iudicare; sed, qui misit me, verax est, et ego, quae audivi ab eo, haec loquor ad mundum '."
,"27":"Non cognoverunt quia Patrem eis dicebat."
,"28":"Dixit ergo eis Iesus: ' Cum exaltaveritis Filium hominis, tunc cognoscetis quia ego sum et a meipso facio nihil, sed, sicut docuit me Pater, haec loquor."
,"29":"Et qui me misit, mecum est; non reliquit me solum, quia ego, quae placita sunt ei, facio semper '."
,"30":"Haec illo loquente, multi crediderunt in eum."
,"31":"Dicebat ergo Iesus ad eos, qui crediderunt ei, Iudaeos: ' Si vos manseritis in sermone meo, vere discipuli mei estis"
,"32":"et cognoscetis veritatem, et veritas liberabit vos '."
,"33":"Responderunt ei: ' Semen Abrahae sumus et nemini servivimus umquam! Quomodo tu dicis: 'Liberi fietis'? '."
,"34":"Respondit eis Iesus: ' Amen, amen dico vobis: Omnis, qui facit peccatum, servus est peccati."
,"35":"Servus autem non manet in domo in aeternum; filius manet in aeternum."
,"36":"Si ergo Filius vos liberaverit, vere liberi eritis."
,"37":"Scio quia semen Abrahae estis; sed quaeritis me interficere, quia sermo meus non capit in vobis."
,"38":"Ego, quae vidi apud Patrem, loquor; et vos ergo, quae audivistis a patre, facitis '."
,"39":"Responderunt et dixerunt ei: ' Pater noster Abraham est '. Dicit eis Iesus: ' Si filii Abrahae essetis, opera Abrahae faceretis."
,"40":"Nunc autem quaeritis me interficere, hominem, qui veritatem vobis locutus sum, quam audivi a Deo; hoc Abraham non fecit."
,"41":"Vos facitis opera patris vestri '. Dixerunt itaque ei: ' Nos ex fornicatione non sumus nati; unum patrem habemus Deum! '."
,"42":"Dixit eis Iesus: ' Si Deus pater vester esset, diligeretis me; ego enim ex Deo processi et veni; neque enim a meipso veni, sed ille me misit."
,"43":"Quare loquelam meam non cognoscitis? Quia non potestis audire sermonem meum."
,"44":"Vos ex patre Diabolo estis et desideria patris vestri vultis facere. Ille homicida erat ab initio et in veritate non stabat, quia non est veritas in eo. Cum loquitur mendacium, ex propriis loquitur, quia mendax est et pater eius."
,"45":"Ego autem quia veritatem dico, non creditis mihi."
,"46":"Quis ex vobis arguit me de peccato? Si veritatem dico, quare vos non creditis mihi?"
,"47":"Qui est ex Deo, verba Dei audit; propterea vos non auditis, quia ex Deo non estis '."
,"48":"Responderunt Iudaei et dixerunt ei: ' Nonne bene dicimus nos, quia Samaritanus es tu et daemonium habes? '."
,"49":"Respondit Iesus: ' Ego daemonium non habeo, sed honorifico Patrem meum, et vos inhonoratis me."
,"50":"Ego autem non quaero gloriam meam; est qui quaerit et iudicat."
,"51":"Amen, amen dico vobis: Si quis sermonem meum servaverit, mortem non videbit in aeternum '."
,"52":"Dixerunt ergo ei Iudaei: ' Nunc cognovimus quia daemonium habes. Abraham mortuus est et prophetae, et tu dicis: 'Si quis sermonem meum servaverit, non gustabit mortem in aeternum'."
,"53":"Numquid tu maior es patre nostro Abraham, qui mortuus est? Et prophetae mortui sunt! Quem teipsum facis? '."
,"54":"Respondit Iesus: ' Si ego glorifico meipsum, gloria mea nihil est; est Pater meus, qui glorificat me, quem vos dicitis: 'Deus noster est!',"
,"55":"et non cognovistis eum. Ego autem novi eum. Et si dixero: Non scio eum, ero similis vobis, mendax; sed scio eum et sermonem eius servo."
,"56":"Abraham pater vester exsultavit, ut videret diem meum; et vidit et gavisus est '."
,"57":"Dixerunt ergo Iudaei ad eum: ' Quinquaginta annos nondum habes et Abraham vidisti? '."
,"58":"Dixit eis Iesus: ' Amen, amen dico vobis: Antequam Abraham fieret, ego sum '."
,"59":"Tulerunt ergo lapides, ut iacerent in eum; Iesus autem abscondit se et exivit de templo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et praeteriens vidit hominem caecum a nativitate."
,"2":"Et interro gaverunt eum discipuli sui dicentes: ' Rabbi, quis peccavit, hic aut parentes eius, ut caecus nasceretur? '."
,"3":"Respondit Iesus: ' Neque hic peccavit neque parentes eius, sed ut manifestentur opera Dei in illo."
,"4":"Nos oportet operari opera eius, qui misit me, donec dies est; venit nox, quando nemo potest operari."
,"5":"Quamdiu in mundo sum, lux sum mundi '."
,"6":"Haec cum dixisset, exspuit in terram et fecit lutum ex sputo et linivit lutum super oculos eius"
,"7":"et dixit ei: ' Vade, lava in natatoria Siloae! ' - quod interpretatur Missus C. Abiit ergo et lavit et venit videns."
,"8":"Itaque vicini et, qui videbant eum prius quia mendicus erat, dicebant: ' Nonne hic est, qui sedebat et mendicabat? ';"
,"9":"alii dicebant: ' Hic est! '; alii dicebant: ' Nequaquam, sed similis est eius! '. Ille dicebat: ' Ego sum! '."
,"10":"Dicebant ergo ei: ' Quomodo igitur aperti sunt oculi tibi? '."
,"11":"Respondit ille: ' Homo, qui dicitur Iesus, lutum fecit et unxit oculos meos et dixit mihi: 'Vade ad Siloam et lava! '. Abii ergo et lavi et vidi '."
,"12":"Et dixerunt ei: ' Ubi est ille? '. Ait: ' Nescio '."
,"13":"Adducunt eum ad pharisaeos, qui caecus fuerat."
,"14":"Erat autem sabbatum, in qua die lutum fecit Iesus et aperuit oculos eius."
,"15":"Iterum ergo interrogabant et eum pharisaei quomodo vidisset. Ille autem dixit eis: ' Lutum posuit super oculos meos, et lavi et video '."
,"16":"Dicebant ergo ex pharisaeis quidam: ' Non est hic homo a Deo, quia sabbatum non custodit! '; alii autem dicebant: ' Quomodo potest homo peccator haec signa facere? '. Et schisma erat in eis."
,"17":"Dicunt ergo caeco iterum: ' Tu quid dicis de eo quia aperuit oculos tuos? '. Ille autem dixit: ' Propheta est! '."
,"18":"Non crediderunt ergo Iudaei de illo quia caecus fuisset et vidisset, donec vocaverunt parentes eius, qui viderat."
,"19":"Et interrogaverunt eos dicentes: ' Hic est filius vester, quem vos dicitis quia caecus natus est? Quomodo ergo nunc videt? '."
,"20":"Responderunt ergo parentes eius et dixerunt: ' Scimus quia hic est filius noster et quia caecus natus est."
,"21":"Quomodo autem nunc videat nescimus, aut quis eius aperuit oculos nos nescimus; ipsum interrogate. Aetatem habet; ipse de se loquetur! '."
,"22":"Haec dixerunt parentes eius, quia timebant Iudaeos; iam enim conspiraverant Iudaei, ut, si quis eum confiteretur Christum, extra synagogam fieret."
,"23":"Propterea parentes eius dixerunt: ' Aetatem habet; ipsum interrogate! '."
,"24":"Vocaverunt ergo rursum hominem, qui fuerat caecus, et dixerunt ei: ' Da gloriam Deo! Nos scimus quia hic homo peccator est '."
,"25":"Respondit ergo ille: ' Si peccator est nescio; unum scio quia, caecus cum essem, modo video '."
,"26":"Dixerunt ergo illi: ' Quid fecit tibi? Quomodo aperuit oculos tuos? '."
,"27":"Respondit eis: ' Dixi vobis iam, et non audistis; quid iterum vultis audire? Numquid et vos vultis discipuli eius fieri? '."
,"28":"Et maledixerunt ei et dixerunt: ' Tu discipulus illius es, nos autem Moysis discipuli sumus."
,"29":"Nos scimus quia Moysi locutus est Deus; hunc autem nescimus unde sit '."
,"30":"Respondit homo et dixit eis: ' In hoc enim mirabile est, quia vos nescitis unde sit, et aperuit meos oculos!"
,"31":"Scimus quia peccatores Deus non audit; sed, si quis Dei cultor est et voluntatem eius facit, hunc exaudit."
,"32":"A saeculo non est auditum quia aperuit quis oculos caeci nati;"
,"33":"nisi esset hic a Deo, non poterat facere quidquam '."
,"34":"Responderunt et dixerunt ei: ' In peccatis tu natus es totus et tu doces nos? '. Et eiecerunt eum foras."
,"35":"Audivit Iesus quia eiecerunt eum foras et, cum invenisset eum, dixit ei: ' Tu credis in Filium hominis? '."
,"36":"Respondit ille et dixit: ' Et quis est, Domine, ut credam in eum? '."
,"37":"Dixit ei Iesus: ' Et vidisti eum; et, qui loquitur tecum, ipse est '."
,"38":"At ille ait: ' Credo, Domine! '; et adoravit eum."
,"39":"Et dixit Iesus: ' In iudicium ego in hunc mundum veni, ut, qui non vident, videant, et, qui vident, caeci fiant '."
,"40":"Audierunt haec ex pharisaeis, qui cum ipso erant, et dixerunt ei: ' Numquid et nos caeci sumus? '."
,"41":"Dixit eis Iesus: ' Si caeci essetis, non haberetis peccatum. Nunc vero dicitis: 'Videmus!'; peccatum vestrum manet '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"' Amen, amen dico vobis: Qui non intrat per ostium in ovile ovium, sed ascendit aliunde, ille fur est et latro;"
,"2":"qui autem intrat per ostium, pastor est ovium."
,"3":"Huic ostiarius aperit, et oves vocem eius audiunt, et proprias oves vocat nominatim et educit eas."
,"4":"Cum proprias omnes emiserit, ante eas vadit, et oves illum sequuntur, quia sciunt vocem eius;"
,"5":"alienum autem non sequentur, sed fugient ab eo, quia non noverunt vocem alienorum '."
,"6":"Hoc proverbium dixit eis Iesus; illi autem non cognoverunt quid esset, quod loquebatur eis."
,"7":"Dixit ergo iterum Iesus: ' Amen, amen dico vobis: Ego sum ostium ovium."
,"8":"Omnes, quotquot venerunt ante me, fures sunt et latrones, sed non audierunt eos oves."
,"9":"Ego sum ostium; per me, si quis introierit, salvabitur et ingredietur et egredietur et pascua inveniet."
,"10":"Fur non venit, nisi ut furetur et mactet et perdat; ego veni, ut vitam habeant et abundantius habeant."
,"11":"Ego sum pastor bonus; bonus pastor animam suam ponit pro ovibus;"
,"12":"mercennarius et, qui non est pastor, cuius non sunt oves propriae, videt lupum venientem et dimittit oves et fugit - et lupus rapit eas et dispergit -"
,"13":"quia mercennarius est et non pertinet ad eum de ovibus."
,"14":"Ego sum pastor bonus et cognosco meas, et cognoscunt me meae,"
,"15":"sicut cognoscit me Pater, et ego cognosco Patrem; et animam meam pono pro ovibus."
,"16":"Et alias oves habeo, quae non sunt ex hoc ovili, et illas oportet me adducere, et vocem meam audient et fient unus grex, unus pastor."
,"17":"Propterea me Pater diligit, quia ego pono animam meam, ut iterum sumam eam."
,"18":"Nemo tollit eam a me, sed ego pono eam a meipso. Potestatem habeo ponendi eam et potestatem habeo iterum sumendi eam. Hoc mandatum accepi a Patre meo '."
,"19":"Dissensio iterum facta est inter Iudaeos propter sermones hos."
,"20":"Dicebant autem multi ex ipsis: ' Daemonium habet et insanit! Quid eum auditis? '."
,"21":"Alii dicebant: ' Haec verba non sunt daemonium habentis! Numquid daemonium potest caecorum oculos aperire? '."
,"22":"Facta sunt tunc Encaenia in Hierosolymis. Hiems erat;"
,"23":"et ambulabat Iesus in templo in porticu Salomonis."
,"24":"Circumdederunt ergo eum Iudaei et dicebant ei: ' Quousque animam nostram tollis? Si tu es Christus, dic nobis palam! '."
,"25":"Respondit eis Iesus: ' Dixi vobis, et non creditis; opera, quae ego facio in nomine Patris mei, haec testimonium perhibent de me."
,"26":"Sed vos non creditis, quia non estis ex ovibus meis."
,"27":"Oves meae vocem meam audiunt, et ego cognosco eas, et sequuntur me;"
,"28":"et ego vitam aeternam do eis, et non peribunt in aeternum, et non rapiet eas quisquam de manu mea."
,"29":"Pater meus quod dedit mihi, maius omnibus est, et nemo potest rapere de manu Patris."
,"30":"Ego et Pater unum sumus '."
,"31":"Sustulerunt iterum lapides Iudaei, ut lapidarent eum."
,"32":"Respondit eis Iesus: ' Multa opera bona ostendi vobis ex Patre; propter quod eorum opus me lapidatis? '."
,"33":"Responderunt ei Iudaei: ' De bono opere non lapidamus te sed de blasphemia, et quia tu, homo cum sis, facis teipsum Deum '."
,"34":"Respondit eis Iesus: ' Nonne scriptum est in lege vestra: 'Ego dixi: Dii estis?'."
,"35":"Si illos dixit deos, ad quos sermo Dei factus est, et non potest solvi Scriptura,"
,"36":"quem Pater sanctificavit et misit in mundum, vos dicitis: 'Blasphemas!', quia dixi: Filius Dei sum?"
,"37":"Si non facio opera Patris mei, nolite credere mihi;"
,"38":"si autem facio, et si mihi non vultis credere, operibus credite, ut cognoscatis et sciatis quia in me est Pater, et ego in Patre '."
,"39":"Quaerebant ergo iterum eum prehendere; et exivit de manibus eorum."
,"40":"Et abiit iterum trans Iordanem in eum locum, ubi erat Ioannes baptizans primum, et mansit illic."
,"41":"Et multi venerunt ad eum et dicebant: ' Ioannes quidem signum fecit nullum; omnia autem, quaecumque dixit Ioannes de hoc, vera erant '."
,"42":"Et multi crediderunt in eum illic."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Erat autem quidam lan guens Lazarus a Bethania, de castello Mariae et Marthae sororis eius."
,"2":"Maria autem erat, quae unxit Dominum unguento et extersit pedes eius capillis suis, cuius frater Lazarus infirmabatur."
,"3":"Miserunt ergo sorores ad eum dicentes: ' Domine, ecce, quem amas, infirmatur '."
,"4":"Audiens autem Iesus dixit: ' Infirmitas haec non est ad mortem sed pro gloria Dei, ut glorificetur Filius Dei per eam '."
,"5":"Diligebat autem Iesus Martham et sororem eius et Lazarum."
,"6":"Ut ergo audivit quia infirmabatur, tunc quidem mansit in loco, in quo erat, duobus diebus;"
,"7":"deinde post hoc dicit discipulis: ' Eamus in Iudaeam iterum '."
,"8":"Dicunt ei discipuli: ' Rabbi, nunc quaerebant te Iudaei lapidare, et iterum vadis illuc? '."
,"9":"Respondit Iesus: ' Nonne duodecim horae sunt diei? Si quis ambulaverit in die, non offendit, quia lucem huius mundi videt;"
,"10":"si quis autem ambulaverit in nocte, offendit, quia lux non est in eo '."
,"11":"Haec ait et post hoc dicit eis: ' Lazarus amicus noster dormit, sed vado, ut a somno exsuscitem eum '."
,"12":"Dixerunt ergo ei discipuli: ' Domine, si dormit, salvus erit '."
,"13":"Dixerat autem Iesus de morte eius, illi autem putaverunt quia de dormitione somni diceret."
,"14":"Tunc ergo dixit eis Iesus manifeste: ' Lazarus mortuus est,"
,"15":"et gaudeo propter vos, ut credatis, quoniam non eram ibi; sed eamus ad eum '."
,"16":"Dixit ergo Thomas, qui dicitur Didymus, ad condiscipulos: ' Eamus et nos, ut moriamur cum eo! '."
,"17":"Venit itaque Iesus et invenit eum quattuor dies iam in monumento habentem."
,"18":"Erat autem Bethania iuxta Hierosolymam quasi stadiis quindecim."
,"19":"Multi autem ex Iudaeis venerant ad Martham et Mariam, ut consolarentur eas de fratre."
,"20":"Martha ergo ut audivit quia Iesus venit, occurrit illi; Maria autem domi sedebat."
,"21":"Dixit ergo Martha ad Iesum: ' Domine, si fuisses hic, frater meus non esset mortuus!"
,"22":"Sed et nunc scio quia, quaecumque poposceris a Deo, dabit tibi Deus '."
,"23":"Dicit illi Iesus: ' Resurget frater tuus '."
,"24":"Dicit ei Martha: ' Scio quia resurget in resurrectione in novissimo die '."
,"25":"Dixit ei Iesus: ' Ego sum resurrectio et vita. Qui credit in me, etsi mortuus fuerit, vivet;"
,"26":"et omnis, qui vivit et credit in me, non morietur in aeternum. Credis hoc? '."
,"27":"Ait illi: ' Utique, Domine; ego credidi quia tu es Christus Filius Dei, qui in mundum venisti '."
,"28":"Et cum haec dixisset, abiit et vocavit Mariam sororem suam silentio dicens: ' Magister adest et vocat te '."
,"29":"Illa autem ut audivit, surrexit cito et venit ad eum;"
,"30":"nondum enim venerat Iesus in castellum, sed erat adhuc in illo loco, ubi occurrerat ei Martha."
,"31":"Iudaei igitur, qui erant cum ea in domo et consolabantur eam, cum vidissent Mariam quia cito surrexit et exiit, secuti sunt eam putantes: ' Vadit ad monumentum, ut ploret ibi '."
,"32":"Maria ergo, cum venisset ubi erat Iesus, videns eum cecidit ad pedes eius dicens ei: ' Domine, si fuisses hic, non esset mortuus frater meus! '."
,"33":"Iesus ergo, ut vidit eam plorantem et Iudaeos, qui venerant cum ea, plorantes, fremuit spiritu et turbavit seipsum"
,"34":"et dixit: ' Ubi posuistis eum? '. Dicunt ei: ' Domine, veni et vide '."
,"35":"Lacrimatus est Iesus."
,"36":"Dicebant ergo Iudaei: ' Ecce quomodo amabat eum! '."
,"37":"Quidam autem dixerunt ex ipsis: ' Non poterat hic, qui aperuit oculos caeci, facere, ut et hic non moreretur? '."
,"38":"Iesus ergo rursum fremens in semetipso, venit ad monumentum; erat autem spelunca, et lapis superpositus erat ei."
,"39":"Ait Iesus: ' Tollite lapidem! '. Dicit ei Martha, soror eius, qui mortuus fuerat: ' Domine, iam foetet; quatriduanus enim est! '."
,"40":"Dicit ei Iesus: ' Nonne dixi tibi quoniam, si credideris, videbis gloriam Dei? '."
,"41":"Tulerunt ergo lapidem. Iesus autem, elevatis sursum oculis, dixit: ' Pater, gratias ago tibi quoniam audisti me."
,"42":"Ego autem sciebam quia semper me audis, sed propter populum, qui circumstat, dixi, ut credant quia tu me misisti '."
,"43":"Et haec cum dixisset, voce magna clamavit: ' Lazare, veni foras! '."
,"44":"Prodiit, qui fuerat mortuus, ligatus pedes et manus institis; et facies illius sudario erat ligata. Dicit Iesus eis: ' Solvite eum et sinite eum abire '."
,"45":"Multi ergo ex Iudaeis, qui venerant ad Mariam et viderant, quae fecit, crediderunt in eum;"
,"46":"quidam autem ex ipsis abierunt ad pharisaeos et dixerunt eis, quae fecit Iesus."
,"47":"Collegerunt ergo pontifices et pharisaei concilium et dicebant: ' Quid facimus, quia hic homo multa signa facit?"
,"48":"Si dimittimus eum sic, omnes credent in eum, et venient Romani et tollent nostrum et locum et gentem! '."
,"49":"Unus autem ex ipsis, Caiphas, cum esset pontifex anni illius, dixit eis: ' Vos nescitis quidquam"
,"50":"nec cogitatis quia expedit vobis, ut unus moriatur homo pro populo, et non tota gens pereat! '."
,"51":"Hoc autem a semetipso non dixit; sed, cum esset pontifex anni illius, prophetavit quia Iesus moriturus erat pro gente"
,"52":"et non tantum pro gente, sed et ut filios Dei, qui erant dispersi, congregaret in unum."
,"53":"Ab illo ergo die cogitaverunt, ut interficerent eum."
,"54":"Iesus ergo iam non in palam ambulabat apud Iudaeos, sed abiit inde in regionem iuxta desertum, in civitatem, quae dicitur Ephraim, et ibi morabatur cum discipulis."
,"55":"Proximum autem erat Pascha Iudaeorum, et ascenderunt multi Hierosolymam de regione ante Pascha, ut sanctificarent seipsos."
,"56":"Quaerebant ergo Iesum et colloquebantur ad invicem in templo stantes: ' Quid videtur vobis? Numquid veniet ad diem festum? '."
,"57":"Dederant autem pontifices et pharisaei mandatum, ut, si quis cognoverit, ubi sit, indicet, ut apprehendant eum."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Iesus ergo ante sex dies Paschae venit Bethaniam, ubi erat Lazarus, quem suscitavit a mortuis Iesus."
,"2":"Fecerunt ergo ei cenam ibi, et Martha ministrabat, Lazarus vero unus erat ex discumbentibus cum eo."
,"3":"Maria ergo accepit libram unguenti nardi puri, pretiosi, et unxit pedes Iesu et extersit capillis suis pedes eius; domus autem impleta est ex odore unguenti."
,"4":"Dicit autem Iudas Iscariotes, unus ex discipulis eius, qui erat eum traditurus:"
,"5":"' Quare hoc unguentum non veniit trecentis denariis et datum est egenis? '."
,"6":"Dixit autem hoc, non quia de egenis pertinebat ad eum, sed quia fur erat et, loculos habens, ea, quae mittebantur, portabat."
,"7":"Dixit ergo Iesus: ' Sine illam, ut in diem sepulturae meae servet illud."
,"8":"Pauperes enim semper habetis vobiscum, me autem non semper habetis '."
,"9":"Cognovit ergo turba multa ex Iudaeis quia illic est, et venerunt non propter Iesum tantum, sed ut et Lazarum viderent, quem suscitavit a mortuis."
,"10":"Cogitaverunt autem principes sacerdotum, ut et Lazarum interficerent,"
,"11":"quia multi propter illum abibant ex Iudaeis et credebant in Iesum."
,"12":"In crastinum turba multa, quae venerat ad diem festum, cum audissent quia venit Iesus Hierosolymam,"
,"13":"acceperunt ramos palmarum et processerunt obviam ei et clamabant: ' Hosanna!,Benedictus, qui venit in nomine Domini, et rex Israel! '."
,"14":"Invenit autem Iesus asellum et sedit super eum, sicut scriptum est:"
,"15":"' Noli timere, filia Sion. Ecce rex tuus venit,sedens super pullum asinae '."
,"16":"Haec non cognoverunt discipuli eius primum, sed quando glorificatus est Iesus, tunc recordati sunt quia haec erant scripta de eo, et haec fecerunt ei."
,"17":"Testimonium ergo perhibebat turba, quae erat cum eo, quando Lazarum vocavit de monumento et suscitavit eum a mortuis."
,"18":"Propterea et obviam venit ei turba, quia audierunt eum fecisse hoc signum."
,"19":"Pharisaei ergo dixerunt ad semetipsos: ' Videtis quia nihil proficitis? Ecce mundus post eum abiit! '."
,"20":"Erant autem Graeci quidam ex his, qui ascenderant, ut adorarent in die festo;"
,"21":"hi ergo accesserunt ad Philippum, qui erat a Bethsaida Galilaeae, et rogabant eum dicentes: ' Domine, volumus Iesum videre '."
,"22":"Venit Philippus et dicit Andreae; venit Andreas et Philippus et dicunt Iesu."
,"23":"Iesus autem respondet eis dicens: ' Venit hora, ut glorificetur Filius hominis."
,"24":"Amen, amen dico vobis: Nisi granum frumenti cadens in terram mortuum fuerit, ipsum solum manet; si autem mortuum fuerit, multum fructum affert."
,"25":"Qui amat animam suam, perdit eam; et, qui odit animam suam in hoc mundo, in vitam aeternam custodiet eam."
,"26":"Si quis mihi ministrat, me sequatur, et ubi sum ego, illic et minister meus erit; si quis mihi ministraverit, honorificabit eum Pater."
,"27":"Nunc anima mea turbata est. Et quid dicam? Pater, salvifica me ex hora hac? Sed propterea veni in horam hanc."
,"28":"Pater, glorifica tuum nomen! '. Venit ergo vox de caelo: ' Et glorificavi et iterum glorificabo '."
,"29":"Turba ergo, quae stabat et audierat, dicebat tonitruum factum esse; alii dicebant: ' Angelus ei locutus est '."
,"30":"Respondit Iesus et dixit: ' Non propter me vox haec facta est sed propter vos."
,"31":"Nunc iudicium est huius mundi, nunc princeps huius mundi eicietur foras;"
,"32":"et ego, si exaltatus fuero a terra, omnes traham ad meipsum '."
,"33":"Hoc autem dicebat significans, qua morte esset moriturus."
,"34":"Respondit ergo ei turba: ' Nos audivimus ex Lege, quia Christus manet in aeternum; et quomodo tu dicis: 'Oportet exaltari Filium hominis'? Quis est iste Filius hominis? '."
,"35":"Dixit ergo eis Iesus: ' Adhuc modicum tempus lumen in vobis est. Ambulate, dum lucem habetis, ut non tenebrae vos comprehendant; et, qui ambulat in tenebris, nescit quo vadat."
,"36":"Dum lucem habetis, credite in lucem, ut filii lucis fiatis '. Haec locutus est Iesus et abiit et abscondit se ab eis."
,"37":"Cum autem tanta signa fecisset coram eis, non credebant in eum,"
,"38":"ut sermo Isaiae prophetae impleretur, quem dixit: ' Domine, quis credidit auditui nostro, et brachium Domini cui revelatum est? '."
,"39":"Propterea non poterant credere, quia iterum dixit Isaias:"
,"40":"' Excaecavit oculos eorum,et induravit eorum cor, ut non videant oculis,et intellegant corde et convertantur, et sanem eos '."
,"41":"Haec dixit Isaias, quia vidit gloriam eius et locutus est de eo."
,"42":"Verumtamen et ex principibus multi crediderunt in eum, sed propter pharisaeos non confitebantur, ut de synagoga non eicerentur;"
,"43":"dilexerunt enim gloriam hominum magis quam gloriam Dei."
,"44":"Iesus autem clamavit et dixit: ' Qui credit in me, non credit in me sed in eum, qui misit me;"
,"45":"et, qui videt me, videt eum, qui misit me."
,"46":"Ego lux in mundum veni, ut omnis, qui credit in me, in tenebris non maneat."
,"47":"Et si quis audierit verba mea et non custodierit, ego non iudico eum; non enim veni, ut iudicem mundum, sed ut salvificem mundum."
,"48":"Qui spernit me et non accipit verba mea, habet, qui iudicet eum: sermo, quem locutus sum, ille iudicabit eum in novissimo die,"
,"49":"quia ego ex meipso non sum locutus, sed, qui misit me, Pater, ipse mihi mandatum dedit quid dicam et quid loquar."
,"50":"Et scio quia mandatum eius vita aeterna est. Quae ergo ego loquor, sicut dixit mihi Pater, sic loquor '."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Ante diem autem festum Pa schae, sciens Iesus quia venit eius hora, ut transeat ex hoc mundo ad Patrem, cum dilexisset suos, qui erant in mundo, in finem dilexit eos."
,"2":"Et in cena, cum Diabolus iam misisset in corde, ut traderet eum Iudas Simonis Iscariotis,"
,"3":"sciens quia omnia dedit ei Pater in manus, et quia a Deo exivit et ad Deum vadit,"
,"4":"surgit a cena et ponit vestimenta sua et, cum accepisset linteum, praecinxit se."
,"5":"Deinde mittit aquam in pelvem et coepit lavare pedes discipulorum et extergere linteo, quo erat praecinctus."
,"6":"Venit ergo ad Simonem Petrum. Dicit ei: ' Domine, tu mihi lavas pedes? '."
,"7":"Respondit Iesus et dixit ei: ' Quod ego facio, tu nescis modo, scies autem postea '."
,"8":"Dicit ei Petrus: ' Non lavabis mihi pedes in aeternum! '. Respondit Iesus ei: ' Si non lavero te, non habes partem mecum '."
,"9":"Dicit ei Simon Petrus: ' Domine, non tantum pedes meos sed et manus et caput! '."
,"10":"Dicit ei Iesus: ' Qui lotus est, non indiget nisi ut pedes lavet, sed est mundus totus; et vos mundi estis sed non omnes '."
,"11":"Sciebat enim quisnam esset, qui traderet eum; propterea dixit: ' Non estis mundi omnes '."
,"12":"Postquam ergo lavit pedes eorum et accepit vestimenta sua, cum recubuisset iterum, dixit eis: ' Scitis quid fecerim vobis?"
,"13":"Vos vocatis me: 'Magister' et: 'Domine', et bene dicitis; sum etenim."
,"14":"Si ergo ego lavi vestros pedes, Dominus et Magister, et vos debetis alter alterius lavare pedes."
,"15":"Exemplum enim dedi vobis, ut, quemadmodum ego feci vobis, et vos faciatis."
,"16":"Amen, amen dico vobis: Non est servus maior domino suo, neque apostolus maior eo, qui misit illum."
,"17":"Si haec scitis, beati estis, si facitis ea."
,"18":"Non de omnibus vobis dico, ego scio, quos elegerim, sed ut impleatur Scriptura: 'Qui manducat meum panem, levavit contra me calcaneum suum'."
,"19":"Amodo dico vobis priusquam fiat, ut credatis, cum factum fuerit, quia ego sum."
,"20":"Amen, amen dico vobis: Qui accipit, si quem misero, me accipit; qui autem me accipit, accipit eum, qui me misit '."
,"21":"Cum haec dixisset Iesus, turbatus est spiritu et protestatus est et dixit: ' Amen, amen dico vobis: Unus ex vobis tradet me '."
,"22":"Aspiciebant ad invicem discipuli, haesitantes de quo diceret."
,"23":"Erat recumbens unus ex discipulis eius in sinu Iesu, quem diligebat Iesus."
,"24":"Innuit ergo huic Simon Petrus, ut interrogaret: ' Quis est, de quo dicit? '."
,"25":"Cum ergo recumberet ille ita supra pectus Iesu, dicit ei: ' Domine, quis est? '."
,"26":"Respondet Iesus: ' Ille est, cui ego intinctam buccellam porrexero '. Cum ergo intinxisset buccellam, dat Iudae Simonis Iscariotis."
,"27":"Et post buccellam tunc introivit in illum Satanas. Dicit ergo ei Iesus: ' Quod facis, fac citius '."
,"28":"Hoc autem nemo scivit discumbentium ad quid dixerit ei;"
,"29":"quidam enim putabant quia loculos habebat Iudas, quia dicit ei Iesus: ' Eme ea, quae opus sunt nobis ad diem festum ', aut egenis ut aliquid daret."
,"30":"Cum ergo accepisset ille buccellam, exivit continuo; erat autem nox."
,"31":"Cum ergo exisset, dicit Iesus: ' Nunc clarificatus est Filius hominis, et Deus clarificatus est in eo;"
,"32":"si Deus clarificatus est in eo, et Deus clarificabit eum in semetipso et continuo clarificabit eum."
,"33":"Filioli, adhuc modicum vobiscum sum; quaeretis me, et sicut dixi Iudaeis: Quo ego vado, vos non potestis venire, et vobis dico modo."
,"34":"Mandatum novum do vobis, ut diligatis invicem; sicut dilexi vos, ut et vos diligatis invicem."
,"35":"In hoc cognoscent omnes quia mei discipuli estis: si dilectionem habueritis ad invicem '."
,"36":"Dicit ei Simon Petrus: ' Domine, quo vadis? '. Respondit Iesus: ' Quo vado, non potes me modo sequi, sequeris autem postea '."
,"37":"Dicit ei Petrus: ' Domine, quare non possum te sequi modo? Animam meam pro te ponam '."
,"38":"Respondet Iesus: ' Animam tuam pro me pones? Amen, amen dico tibi: Non cantabit gallus, donec me ter neges."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Non turbetur cor vestrum. Creditis in Deum et in me credite."
,"2":"In domo Patris mei mansiones multae sunt; si quo minus, dixissem vobis, quia vado parare vobis locum?"
,"3":"Et si abiero et praeparavero vobis locum, iterum venio et accipiam vos ad meipsum, ut, ubi sum ego, et vos sitis."
,"4":"Et quo ego vado, scitis viam '."
,"5":"Dicit ei Thomas: ' Domine, nescimus quo vadis; quomodo possumus viam scire? '."
,"6":"Dicit ei Iesus: ' Ego sum via et veritas et vita; nemo venit ad Patrem nisi per me."
,"7":"Si cognovistis me, et Patrem meum utique cognoscetis; et amodo cognoscitis eum et vidistis eum '."
,"8":"Dicit ei Philippus: ' Domine, ostende nobis Patrem, et sufficit nobis '."
,"9":"Dicit ei Iesus: ' Tanto tempore vobiscum sum, et non cognovisti me, Philippe? Qui vidit me, vidit Patrem. Quomodo tu dicis: 'Ostende nobis Patrem'?"
,"10":"Non credis quia ego in Patre, et Pater in me est? Verba, quae ego loquor vobis, a meipso non loquor; Pater autem in me manens facit opera sua."
,"11":"Credite mihi quia ego in Patre, et Pater in me est; alioquin propter opera ipsa credite."
,"12":"Amen, amen dico vobis: Qui credit in me, opera, quae ego facio, et ipse faciet et maiora horum faciet, quia ego ad Patrem vado."
,"13":"Et quodcumque petieritis in nomine meo, hoc faciam, ut glorificetur Pater in Filio;"
,"14":"si quid petieritis me in nomine meo, ego faciam."
,"15":"Si diligitis me, mandata mea servabitis;"
,"16":"et ego rogabo Patrem, et alium Paraclitum dabit vobis, ut maneat vobiscum in aeternum,"
,"17":"Spiritum veritatis, quem mundus non potest accipere, quia non videt eum nec cognoscit. Vos cognoscitis eum, quia apud vos manet; et in vobis erit."
,"18":"Non relinquam vos orphanos; venio ad vos."
,"19":"Adhuc modicum, et mundus me iam non videt; vos autem videtis me, quia ego vivo et vos vivetis."
,"20":"In illo die vos cognoscetis quia ego sum in Patre meo, et vos in me, et ego in vobis."
,"21":"Qui habet mandata mea et servat ea, ille est, qui diligit me; qui autem diligit me, diligetur a Patre meo, et ego diligam eum et manifestabo ei meipsum '."
,"22":"Dicit ei Iudas, non ille Iscariotes: ' Domine, et quid factum est, quia nobis manifestaturus es teipsum et non mundo? '."
,"23":"Respondit Iesus et dixit ei: ' Si quis diligit me, sermonem meum servabit, et Pater meus diliget eum, et ad eum veniemus et mansionem apud eum faciemus;"
,"24":"qui non diligit me, sermones meos non servat. Et sermo, quem auditis, non est meus, sed eius qui misit me, Patris."
,"25":"Haec locutus sum vobis apud vos manens."
,"26":"Paraclitus autem, Spiritus Sanctus, quem mittet Pater in nomine meo, ille vos docebit omnia et suggeret vobis omnia, quae dixi vobis."
,"27":"Pacem relinquo vobis, pacem meam do vobis; non quomodo mundus dat, ego do vobis. Non turbetur cor vestrum neque formidet."
,"28":"Audistis quia ego dixi vobis: Vado et venio ad vos. Si diligeretis me, gauderetis quia vado ad Patrem, quia Pater maior me est."
,"29":"Et nunc dixi vobis, priusquam fiat, ut, cum factum fuerit, credatis."
,"30":"Iam non multa loquar vobiscum, venit enim princeps mundi et in me non habet quidquam;"
,"31":"sed, ut cognoscat mundus quia diligo Patrem, et sicut mandatum dedit mihi Pater, sic facio. Surgite, eamus hinc."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Ego sum vitis vera, et Pater meus agricola est."
,"2":"Omnem palmitem in me non ferentem fructum tollit eum; et omnem, qui fert fructum, purgat eum, ut fructum plus afferat."
,"3":"Iam vos mundi estis propter sermonem, quem locutus sum vobis."
,"4":"Manete in me, et ego in vobis. Sicut palmes non potest ferre fructum a semetipso, nisi manserit in vite, sic nec vos, nisi in me manseritis."
,"5":"Ego sum vitis, vos palmites. Qui manet in me, et ego in eo, hic fert fructum multum, quia sine me nihil potestis facere."
,"6":"Si quis in me non manserit, missus est foras sicut palmes et aruit; et colligunt eos et in ignem mittunt, et ardent."
,"7":"Si manseritis in me, et verba mea in vobis manserint, quodcumque volueritis, petite, et fiet vobis."
,"8":"In hoc clarificatus est Pater meus, ut fructum multum afferatis et efficiamini mei discipuli."
,"9":"Sicut dilexit me Pater, et ego dilexi vos; manete in dilectione mea."
,"10":"Si praecepta mea servaveritis, manebitis in dilectione mea, sicut ego Patris mei praecepta servavi et maneo in eius dilectione."
,"11":"Haec locutus sum vobis, ut gaudium meum in vobis sit, et gaudium vestrum impleatur."
,"12":"Hoc est praeceptum meum, ut diligatis invicem, sicut dilexi vos;"
,"13":"maiorem hac dilectionem nemo habet, ut animam suam quis ponat pro amicis suis."
,"14":"Vos amici mei estis, si feceritis, quae ego praecipio vobis."
,"15":"Iam non dico vos servos, quia servus nescit quid facit dominus eius; vos autem dixi amicos, quia omnia, quae audivi a Patre meo, nota feci vobis."
,"16":"Non vos me elegistis, sed ego elegi vos et posui vos, ut vos eatis et fructum afferatis, et fructus vester maneat, ut quodcumque petieritis Patrem in nomine meo, det vobis."
,"17":"Haec mando vobis, ut diligatis invicem."
,"18":"Si mundus vos odit, scitote quia me priorem vobis odio habuit."
,"19":"Si de mundo essetis, mundus, quod suum est, diligeret; quia vero de mundo non estis, sed ego elegi vos de mundo, propterea odit vos mundus."
,"20":"Mementote sermonis, quem ego dixi vobis: Non est servus maior domino suo. Si me persecuti sunt, et vos persequentur; si sermonem meum servaverunt, et vestrum servabunt."
,"21":"Sed haec omnia facient vobis propter nomen meum, quia nesciunt eum, qui misit me."
,"22":"Si non venissem et locutus fuissem eis, peccatum non haberent; nunc autem excusationem non habent de peccato suo."
,"23":"Qui me odit et Patrem meum odit."
,"24":"Si opera non fecissem in eis, quae nemo alius fecit, peccatum non haberent; nunc autem et viderunt et oderunt et me et Patrem meum."
,"25":"Sed ut impleatur sermo, qui in lege eorum scriptus est: 'Odio me habuerunt gratis'."
,"26":"Cum autem venerit Paraclitus, quem ego mittam vobis a Patre, Spiritum veritatis, qui a Patre procedit, ille testimonium perhibebit de me;"
,"27":"sed et vos testimonium perhibetis, quia ab initio mecum estis."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Haec locutus sum vobis, ut non scandalizemini."
,"2":"Absque synagogis facient vos; sed venit hora, ut omnis, qui interficit vos, arbitretur obsequium se praestare Deo."
,"3":"Et haec facient, quia non noverunt Patrem neque me."
,"4":"Sed haec locutus sum vobis, ut, cum venerit hora eorum, reminiscamini eorum, quia ego dixi vobis. Haec autem vobis ab initio non dixi, quia vobiscum eram."
,"5":"At nunc vado ad eum, qui me misit, et nemo ex vobis interrogat me: 'Quo vadis?'."
,"6":"Sed quia haec locutus sum vobis, tristitia implevit cor vestrum."
,"7":"Sed ego veritatem dico vobis: Expedit vobis, ut ego vadam. Si enim non abiero, Paraclitus non veniet ad vos; si autem abiero, mittam eum ad vos."
,"8":"Et cum venerit ille, arguet mundum de peccato et de iustitia et de iudicio:"
,"9":"de peccato quidem, quia non credunt in me;"
,"10":"de iustitia vero, quia ad Patrem vado, et iam non videtis me;"
,"11":"de iudicio autem, quia princeps mundi huius iudicatus est."
,"12":"Adhuc multa habeo vobis dicere, sed non potestis portare modo."
,"13":"Cum autem venerit ille, Spiritus veritatis, deducet vos in omnem veritatem; non enim loquetur a semetipso, sed quaecumque audiet, loquetur et, quae ventura sunt, annuntiabit vobis."
,"14":"Ille me clarificabit, quia de meo accipiet et annuntiabit vobis."
,"15":"Omnia, quaecumque habet Pater, mea sunt; propterea dixi quia de meo accipit et annuntiabit vobis."
,"16":"Modicum, et iam non videtis me; et iterum modicum, et videbitis me '."
,"17":"Dixerunt ergo ex discipulis eius ad invicem: ' Quid est hoc, quod dicit nobis: 'Modicum, et non videtis me; et iterum modicum, et videbitis me' et: 'Vado ad Patrem'? '."
,"18":"Dicebant ergo: ' Quid est hoc, quod dicit: 'Modicum'? Nescimus quid loquitur '."
,"19":"Cognovit Iesus quia volebant eum interrogare et dixit eis: ' De hoc quaeritis inter vos, quia dixi: 'Modicum, et non videtis me; et iterum modicum, et videbitis me'?"
,"20":"Amen, amen dico vobis quia plorabitis et flebitis vos, mundus autem gaudebit; vos contristabimini, sed tristitia vestra vertetur in gaudium."
,"21":"Mulier, cum parit, tristitiam habet, quia venit hora eius; cum autem pepererit puerum, iam non meminit pressurae propter gaudium, quia natus est homo in mundum."
,"22":"Et vos igitur nunc quidem tristitiam habetis; iterum autem videbo vos, et gaudebit cor vestrum, et gaudium vestrum nemo tollit a vobis."
,"23":"Et in illo die me non rogabitis quidquam. Amen, amen dico vobis: Si quid petieritis Patrem in nomine meo, dabit vobis. "
,"24":"Usque modo non petistis quidquam in nomine meo. Petite et accipietis, ut gaudium vestrum sit plenum."
,"25":"Haec in proverbiis locutus sum vobis; venit hora, cum iam non in proverbiis loquar vobis, sed palam de Patre annuntiabo vobis."
,"26":"Illo die in nomine meo petetis, et non dico vobis quia ego rogabo Patrem de vobis;"
,"27":"ipse enim Pater amat vos, quia vos me amastis et credidistis quia ego a Deo exivi."
,"28":"Exivi a Patre et veni in mundum; iterum relinquo mundum et vado ad Patrem '."
,"29":"Dicunt discipuli eius: ' Ecce nunc palam loqueris, et proverbium nullum dicis."
,"30":"Nunc scimus quia scis omnia, et non opus est tibi, ut quis te interroget; in hoc credimus quia a Deo existi '."
,"31":"Respondit eis Iesus: ' Modo creditis?"
,"32":"Ecce venit hora et iam venit, ut dispergamini unusquisque in propria et me solum relinquatis; et non sum solus, quia Pater mecum est."
,"33":"Haec locutus sum vobis, ut in me pacem habeatis; in mundo pressuram habetis, sed confidite, ego vici mundum '."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Haec locutus est Iesus; et, sublevatis oculis suis in cae lum, dixit: ' Pater, venit hora: clarifica Filium tuum, ut Filius clarificet te,"
,"2":"sicut dedisti ei potestatem omnis carnis, ut omne, quod dedisti ei, det eis vitam aeternam."
,"3":"Haec est autem vita aeterna, ut cognoscant te solum verum Deum et, quem misisti, Iesum Christum."
,"4":"Ego te clarificavi super terram; opus consummavi, quod dedisti mihi, ut faciam;"
,"5":"et nunc clarifica me tu, Pater, apud temetipsum claritate, quam habebam, priusquam mundus esset, apud te."
,"6":"Manifestavi nomen tuum hominibus, quos dedisti mihi de mundo. Tui erant, et mihi eos dedisti, et sermonem tuum servaverunt."
,"7":"Nunc cognoverunt quia omnia, quae dedisti mihi, abs te sunt,"
,"8":"quia verba, quae dedisti mihi, dedi eis; et ipsi acceperunt et cognoverunt vere quia a te exivi et crediderunt quia tu me misisti."
,"9":"Ego pro eis rogo; non pro mundo rogo, sed pro his, quos dedisti mihi, quia tui sunt;"
,"10":"et mea omnia tua sunt, et tua mea; et clarificatus sum in eis."
,"11":"Et iam non sum in mundo, et hi in mundo sunt, et ego ad te venio. Pater sancte, serva eos in nomine tuo, quod dedisti mihi, ut sint unum sicut nos. "
,"12":"Cum essem cum eis, ego servabam eos in nomine tuo, quod dedisti mihi, et custodivi, et nemo ex his periit, nisi filius perditionis, ut Scriptura impleatur."
,"13":"Nunc autem ad te venio et haec loquor in mundo, ut habeant gaudium meum impletum in semetipsis."
,"14":"Ego dedi eis sermonem tuum, et mundus odio eos habuit, quia non sunt de mundo, sicut ego non sum de mundo."
,"15":"Non rogo, ut tollas eos de mundo, sed ut serves eos ex Malo."
,"16":"De mundo non sunt, sicut ego non sum de mundo."
,"17":"Sanctifica eos in veritate; sermo tuus veritas est."
,"18":"Sicut me misisti in mundum, et ego misi eos in mundum;"
,"19":"et pro eis ego sanctifico meipsum, ut sint et ipsi sanctificati in veritate."
,"20":"Non pro his autem rogo tantum, sed et pro eis, qui credituri sunt per verbum eorum in me,"
,"21":"ut omnes unum sint, sicut tu, Pater, in me et ego in te, ut et ipsi in nobis unum sint; ut mundus credat quia tu me misisti."
,"22":"Et ego claritatem, quam dedisti mihi, dedi illis, ut sint unum, sicut nos unum sumus;"
,"23":"ego in eis, et tu in me, ut sint consummati in unum; ut cognoscat mundus, quia tu me misisti et dilexisti eos, sicut me dilexisti."
,"24":"Pater, quod dedisti mihi, volo, ut ubi ego sum, et illi sint mecum, ut videant claritatem meam, quam dedisti mihi, quia dilexisti me ante constitutionem mundi."
,"25":"Pater iuste, et mundus te non cognovit; ego autem te cognovi, et hi cognoverunt quia tu me misisti;"
,"26":"et notum feci eis nomen tuum et notum faciam, ut dilectio, qua dilexisti me, in ipsis sit, et ego in ipsis '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Haec cum dixisset Iesus, egressus est cum discipulis suis trans torrentem Cedron, ubi erat hortus, in quem introivit ipse et discipuli eius."
,"2":"Sciebat autem et Iudas, qui tradebat eum, locum, quia frequenter Iesus convenerat illuc cum discipulis suis."
,"3":"Iudas ergo, cum accepisset cohortem et a pontificibus et pharisaeis ministros, venit illuc cum lanternis et facibus et armis."
,"4":"Iesus itaque sciens omnia, quae ventura erant super eum, processit et dicit eis: ' Quem quaeritis? '."
,"5":"Responderunt ei: ' Iesum Nazarenum '. Dicit eis: ' Ego sum! '. Stabat autem et Iudas, qui tradebat eum, cum ipsis."
,"6":"Ut ergo dixit eis: ' Ego sum! ', abierunt retrorsum et ceciderunt in terram."
,"7":"Iterum ergo eos interrogavit: ' Quem quaeritis? '. Illi autem dixerunt: ' Iesum Nazarenum '."
,"8":"Respondit Iesus: ' Dixi vobis: Ego sum! Si ergo me quaeritis, sinite hos abire ',"
,"9":"ut impleretur sermo, quem dixit: ' Quos dedisti mihi, non perdidi ex ipsis quemquam '."
,"10":"Simon ergo Petrus, habens gladium, eduxit eum et percussit pontificis servum et abscidit eius auriculam dextram. Erat autem nomen servo Malchus."
,"11":"Dixit ergo Iesus Petro: ' Mitte gladium in vaginam; calicem, quem dedit mihi Pater, non bibam illum? '."
,"12":"Cohors ergo et tribunus et ministri Iudaeorum comprehenderunt Iesum et ligaverunt eum"
,"13":"et adduxerunt ad Annam primum; erat enim socer Caiphae, qui erat pontifex anni illius."
,"14":"Erat autem Caiphas, qui consilium dederat Iudaeis: ' Expedit unum hominem mori pro populo '."
,"15":"Sequebatur autem Iesum Simon Petrus et alius discipulus. Discipulus autem ille erat notus pontifici et introivit cum Iesu in atrium pontificis;"
,"16":"Petrus autem stabat ad ostium foris. Exivit ergo discipulus alius, qui erat notus pontifici, et dixit ostiariae et introduxit Petrum."
,"17":"Dicit ergo Petro ancilla ostiaria: ' Numquid et tu ex discipulis es hominis istius? '. Dicit ille: ' Non sum! '."
,"18":"Stabant autem servi et ministri, qui prunas fecerant, quia frigus erat, et calefaciebant se; erat autem cum eis et Petrus stans et calefaciens se."
,"19":"Pontifex ergo interrogavit Iesum de discipulis suis et de doctrina eius."
,"20":"Respondit ei Iesus: ' Ego palam locutus sum mundo; ego semper docui in synagoga et in templo, quo omnes Iudaei conveniunt, et in occulto locutus sum nihil."
,"21":"Quid me interrogas? Interroga eos, qui audierunt quid locutus sum ipsis; ecce hi sciunt, quae dixerim ego '."
,"22":"Haec autem cum dixisset, unus assistens ministrorum dedit alapam Iesu dicens: ' Sic respondes pontifici? '."
,"23":"Respondit ei Iesus: ' Si male locutus sum, testimonium perhibe de malo; si autem bene, quid me caedis? '."
,"24":"Misit ergo eum Annas ligatum ad Caipham pontificem."
,"25":"Erat autem Simon Petrus stans et calefaciens se. Dixerunt ergo ei: ' Numquid et tu ex discipulis eius es? '. Negavit ille et dixit: ' Non sum! '."
,"26":"Dicit unus ex servis pontificis, cognatus eius, cuius abscidit Petrus auriculam: ' Nonne ego te vidi in horto cum illo? '."
,"27":"Iterum ergo negavit Petrus; et statim gallus cantavit."
,"28":"Adducunt ergo Iesum a Caipha in praetorium. Erat autem mane. Et ipsi non introierunt in praetorium, ut non contaminarentur, sed manducarent Pascha."
,"29":"Exivit ergo Pilatus ad eos foras et dicit: ' Quam accusationem affertis adversus hominem hunc? '."
,"30":"Responderunt et dixerunt ei: ' Si non esset hic malefactor, non tibi tradidissemus eum '."
,"31":"Dixit ergo eis Pilatus: ' Accipite eum vos et secundum legem vestram iudicate eum! '. Dixerunt ei Iudaei: ' Nobis non licet interficere quemquam ',"
,"32":"ut sermo Iesu impleretur, quem dixit, significans qua esset morte moriturus."
,"33":"Introivit ergo iterum in praetorium Pilatus et vocavit Iesum et dixit ei: ' Tu es rex Iudaeorum? '."
,"34":"Respondit Iesus: ' A temetipso tu hoc dicis, an alii tibi dixerunt de me? '."
,"35":"Respondit Pilatus: ' Numquid ego Iudaeus sum? Gens tua et pontifices tradiderunt te mihi; quid fecisti? '."
,"36":"Respondit Iesus: ' Regnum meum non est de mundo hoc; si ex hoc mundo esset regnum meum, ministri mei decertarent, ut non traderer Iudaeis; nunc autem meum regnum non est hinc '."
,"37":"Dixit itaque ei Pilatus: ' Ergo rex es tu? '. Respondit Iesus: ' Tu dicis quia rex sum. Ego in hoc natus sum et ad hoc veni in mundum, ut testimonium perhibeam veritati; omnis, qui est ex veritate, audit meam vocem '."
,"38":"Dicit ei Pilatus: ' Quid est veritas? '. Et cum hoc dixisset, iterum exivit ad Iudaeos et dicit eis: ' Ego nullam invenio in eo causam."
,"39":"Est autem consuetudo vobis, ut unum dimittam vobis in Pascha; vultis ergo dimittam vobis regem Iudaeorum? '."
,"40":"Clamaverunt ergo rursum dicentes: ' Non hunc sed Barabbam! '. Erat autem Barabbas latro."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Tunc ergo apprehendit Pi latus Iesum et flagellavit."
,"2":"Et milites, plectentes coronam de spinis, imposuerunt capiti eius et veste purpurea circumdederunt eum;"
,"3":"et veniebant ad eum et dicebant: ' Ave, rex Iudaeorum! ', et dabant ei alapas."
,"4":"Et exiit iterum Pilatus foras et dicit eis: ' Ecce adduco vobis eum foras, ut cognoscatis quia in eo invenio causam nullam '."
,"5":"Exiit ergo Iesus foras, portans spineam coronam et purpureum vestimentum. Et dicit eis: ' Ecce homo! '."
,"6":"Cum ergo vidissent eum pontifices et ministri, clamaverunt dicentes: ' Crucifige, crucifige! '. Dicit eis Pilatus: ' Accipite eum vos et crucifigite; ego enim non invenio in eo causam '."
,"7":"Responderunt ei Iudaei: ' Nos legem habemus, et secundum legem debet mori, quia Filium Dei se fecit '."
,"8":"Cum ergo audisset Pilatus hunc sermonem, magis timuit"
,"9":"et ingressus est praetorium iterum et dicit ad Iesum: ' Unde es tu? '. Iesus autem responsum non dedit ei."
,"10":"Dicit ergo ei Pilatus: ' Mihi non loqueris? Nescis quia potestatem habeo dimittere te et potestatem habeo crucifigere te? '."
,"11":"Respondit Iesus: ' Non haberes potestatem adversum me ullam, nisi tibi esset datum desuper; propterea, qui tradidit me tibi, maius peccatum habet '."
,"12":"Exinde quaerebat Pilatus dimittere eum; Iudaei autem clamabant dicentes: ' Si hunc dimittis, non es amicus Caesaris! Omnis, qui se regem facit, contradicit Caesari '."
,"13":"Pilatus ergo, cum audisset hos sermones, adduxit foras Iesum et sedit pro tribunali in locum, qui dicitur Lithostrotos, Hebraice autem Gabbatha."
,"14":"Erat autem Parasceve Paschae, hora erat quasi sexta. Et dicit Iudaeis: ' Ecce rex vester! '."
,"15":"Clamaverunt ergo illi: ' Tolle, tolle, crucifige eum! '. Dicit eis Pilatus: ' Regem vestrum crucifigam? '. Responderunt pontifices: ' Non habemus regem, nisi Caesarem '."
,"16":"Tunc ergo tradidit eis illum, ut crucifigeretur. Susceperunt ergo Iesum."
,"17":"Et baiulans sibi crucem exivit in eum, qui dicitur Calvariae locum, quod Hebraice dicitur Golgotha,"
,"18":"ubi eum crucifixerunt et cum eo alios duos hinc et hinc, medium autem Iesum."
,"19":"Scripsit autem et titulum Pilatus et posuit super crucem; erat autem scriptum: ' Iesus Nazarenus Rex Iudaeorum '."
,"20":"Hunc ergo titulum multi legerunt Iudaeorum, quia prope civitatem erat locus, ubi crucifixus est Iesus; et erat scriptum Hebraice, Latine, Graece."
,"21":"Dicebant ergo Pilato pontifices Iudaeorum: ' Noli scribere: Rex Iudaeorum, sed: Ipse dixit: 'Rex sum Iudaeorum' '."
,"22":"Respondit Pilatus: ' Quod scripsi, scripsi! '."
,"23":"Milites ergo cum crucifixissent Iesum, acceperunt vestimenta eius et fecerunt quattuor partes, unicuique militi partem, et tunicam. Erat autem tunica inconsutilis, desuper contexta per totum."
,"24":"Dixerunt ergo ad invicem: ' Non scindamus eam, sed sortiamur de illa, cuius sit ', ut Scriptura impleatur dicens: ' Partiti sunt vestimenta mea sibi,et in vestem meam miserunt sortem '. Et milites quidem haec fecerunt."
,"25":"Stabant autem iuxta crucem Iesu mater eius et soror matris eius, Maria Cleopae, et Maria Magdalene."
,"26":"Cum vidisset ergo Iesus matrem et discipulum stantem, quem diligebat, dicit matri: ' Mulier, ecce filius tuus '."
,"27":"Deinde dicit discipulo: ' Ecce mater tua '. Et ex illa hora accepit eam discipulus in sua."
,"28":"Post hoc sciens Iesus quia iam omnia consummata sunt, ut consummaretur Scriptura, dicit: ' Sitio '."
,"29":"Vas positum erat aceto plenum; spongiam ergo plenam aceto hyssopo circumponentes, obtulerunt ori eius."
,"30":"Cum ergo accepisset acetum, Iesus dixit: ' Consummatum est! '. Et inclinato capite tradidit spiritum."
,"31":"Iudaei ergo, quoniam Parasceve erat, ut non remanerent in cruce corpora sabbato, erat enim magnus dies illius sabbati, rogaverunt Pilatum, ut frangerentur eorum crura, et tollerentur."
,"32":"Venerunt ergo milites et primi quidem fregerunt crura et alterius, qui crucifixus est cum eo;"
,"33":"ad Iesum autem cum venissent, ut viderunt eum iam mortuum, non fregerunt eius crura,"
,"34":"sed unus militum lancea latus eius aperuit, et continuo exivit sanguis et aqua."
,"35":"Et qui vidit, testimonium perhibuit, et verum est eius testimonium, et ille scit quia vera dicit, ut et vos credatis."
,"36":"Facta sunt enim haec, ut Scriptura impleatur: ' Os non comminuetur eius ',"
,"37":"et iterum alia Scriptura dicit: ' Videbunt in quem transfixerunt '."
,"38":"Post haec autem rogavit Pilatum Ioseph ab Arimathaea, qui erat discipulus Iesu, occultus autem propter metum Iudaeorum, ut tolleret corpus Iesu; et permisit Pilatus. Venit ergo et tulit corpus eius."
,"39":"Venit autem et Nicodemus, qui venerat ad eum nocte primum, ferens mixturam myrrhae et aloes quasi libras centum."
,"40":"Acceperunt ergo corpus Iesu et ligaverunt illud linteis cum aromatibus, sicut mos Iudaeis est sepelire."
,"41":"Erat autem in loco, ubi crucifixus est, hortus, et in horto monumentum novum, in quo nondum quisquam positus erat."
,"42":"Ibi ergo propter Parascevem Iudaeorum, quia iuxta erat monumentum, posuerunt Iesum."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Prima autem sabbatorum Maria Magdalene venit ma ne, cum adhuc tenebrae essent, ad monumentum et videt lapidem sublatum a monumento."
,"2":"Currit ergo et venit ad Simonem Petrum et ad alium discipulum, quem amabat Iesus, et dicit eis: ' Tulerunt Dominum de monumento, et nescimus, ubi posuerunt eum! '."
,"3":"Exiit ergo Petrus et ille alius discipulus, et veniebant ad monumentum."
,"4":"Currebant autem duo simul, et ille alius discipulus praecucurrit citius Petro et venit primus ad monumentum;"
,"5":"et cum se inclinasset, videt posita linteamina, non tamen introivit."
,"6":"Venit ergo et Simon Petrus sequens eum et introivit in monumentum; et videt linteamina posita"
,"7":"et sudarium, quod fuerat super caput eius, non cum linteaminibus positum, sed separatim involutum in unum locum."
,"8":"Tunc ergo introivit et alter discipulus, qui venerat primus ad monumentum, et vidit et credidit."
,"9":"Nondum enim sciebant Scripturam, quia oportet eum a mortuis resurgere."
,"10":"Abierunt ergo iterum ad semetipsos discipuli."
,"11":"Maria autem stabat ad monumentum foris plorans. Dum ergo fleret, inclinavit se in monumentum"
,"12":"et videt duos angelos in albis sedentes, unum ad caput et unum ad pedes, ubi positum fuerat corpus Iesu."
,"13":"Et dicunt ei illi: ' Mulier, quid ploras? '. Dicit eis: ' Tulerunt Dominum meum, et nescio, ubi posuerunt eum '."
,"14":"Haec cum dixisset, conversa est retrorsum et videt Iesum stantem; et non sciebat quia Iesus est."
,"15":"Dicit ei Iesus: ' Mulier, quid ploras? Quem quaeris? '. Illa, existimans quia hortulanus esset, dicit ei: ' Domine, si tu sustulisti eum, dicito mihi, ubi posuisti eum, et ego eum tollam '."
,"16":"Dicit ei Iesus: ' Maria! '. Conversa illa dicit ei Hebraice: ' Rabbuni! ' - quod dicitur Magister C."
,"17":"Dicit ei Iesus: ' Iam noli me tenere, nondum enim ascendi ad Patrem; vade autem ad fratres meos et dic eis: Ascendo ad Patrem meum et Patrem vestrum, et Deum meum et Deum vestrum '."
,"18":"Venit Maria Magdalene annuntians discipulis: ' Vidi Dominum! ', et quia haec dixit ei."
,"19":"Cum esset ergo sero die illa prima sabbatorum, et fores essent clausae, ubi erant discipuli, propter metum Iudaeorum, venit Iesus et stetit in medio et dicit eis: ' Pax vobis! '."
,"20":"Et hoc cum dixisset, ostendit eis manus et latus. Gavisi sunt ergo discipuli, viso Domino."
,"21":"Dixit ergo eis iterum: ' Pax vobis! Sicut misit me Pater, et ego mitto vos '."
,"22":"Et cum hoc dixisset, insufflavit et dicit eis: ' Accipite Spiritum Sanctum."
,"23":"Quorum remiseritis peccata, remissa sunt eis; quorum retinueritis, retenta sunt '."
,"24":"Thomas autem, unus ex Duodecim, qui dicitur Didymus, non erat cum eis, quando venit Iesus."
,"25":"Dicebant ergo ei alii discipuli: ' Vidimus Dominum! '. Ille autem dixit eis: ' Nisi videro in manibus eius signum clavorum et mittam digitum meum in signum clavorum et mittam manum meam in latus eius, non credam '."
,"26":"Et post dies octo iterum erant discipuli eius intus, et Thomas cum eis. Venit Iesus ianuis clausis et stetit in medio et dixit: ' Pax vobis! '."
,"27":"Deinde dicit Thomae: ' Infer digitum tuum huc et vide manus meas et affer manum tuam et mitte in latus meum; et noli fieri incredulus sed fidelis! '."
,"28":"Respondit Thomas et dixit ei: ' Dominus meus et Deus meus! '."
,"29":"Dicit ei Iesus: ' Quia vidisti me, credidisti. Beati, qui non viderunt et crediderunt! '."
,"30":"Multa quidem et alia signa fecit Iesus in conspectu discipulorum suorum, quae non sunt scripta in libro hoc;"
,"31":"haec autem scripta sunt, ut credatis quia Iesus est Christus Filius Dei et ut credentes vitam habeatis in nomine eius."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Postea manifestavit se ite rum Iesus discipulis ad mare Tiberiadis; manifestavit autem sic."
,"2":"Erant simul Simon Petrus et Thomas, qui dicitur Didymus, et Nathanael, qui erat a Cana Galilaeae, et filii Zebedaei et alii ex discipulis eius duo."
,"3":"Dicit eis Simon Petrus: ' Vado piscari '. Dicunt ei: ' Venimus et nos tecum '. Exierunt et ascenderunt in navem; et illa nocte nihil prendiderunt."
,"4":"Mane autem iam facto, stetit Iesus in litore; non tamen sciebant discipuli quia Iesus est."
,"5":"Dicit ergo eis Iesus: ' Pueri, numquid pulmentarium habetis? '. Responderunt ei: ' Non '."
,"6":"Ille autem dixit eis: ' Mittite in dexteram navigii rete et invenietis '. Miserunt ergo et iam non valebant illud trahere a multitudine piscium."
,"7":"Dicit ergo discipulus ille, quem diligebat Iesus, Petro: ' Dominus est! '. Simon ergo Petrus, cum audisset quia Dominus est, tunicam succinxit se, erat enim nudus, et misit se in mare;"
,"8":"alii autem discipuli navigio venerunt, non enim longe erant a terra, sed quasi cubitis ducentis, trahentes rete piscium."
,"9":"Ut ergo descenderunt in terram, vident prunas positas et piscem superpositum et panem."
,"10":"Dicit eis Iesus: ' Afferte de piscibus, quos prendidistis nunc '."
,"11":"Ascendit ergo Simon Petrus et traxit rete in terram, plenum magnis piscibus centum quinquaginta tribus; et cum tanti essent, non est scissum rete."
,"12":"Dicit eis Iesus: ' Venite, prandete '. Nemo autem audebat discipulorum interrogare eum: ' Tu quis es? ', scientes quia Dominus est."
,"13":"Venit Iesus et accipit panem et dat eis et piscem similiter."
,"14":"Hoc iam tertio manifestatus est Iesus discipulis, cum resurrexisset a mortuis."
,"15":"Cum ergo prandissent, dicit Simoni Petro Iesus: ' Simon Ioannis, diligis me plus his? '. Dicit ei: ' Etiam, Domine, tu scis quia amo te '. Dicit ei: ' Pasce agnos meos '."
,"16":"Dicit ei iterum secundo: ' Simon Ioannis, diligis me? '. Ait illi: ' Etiam, Domine, tu scis quia amo te '. Dicit ei: ' Pasce oves meas '."
,"17":"Dicit ei tertio: ' Simon Ioannis, amas me? '. Contristatus est Petrus quia dixit ei tertio: ' Amas me? ', et dicit ei: ' Domine, tu omnia scis, tu cognoscis quia amo te '. Dicit ei: ' Pasce oves meas."
,"18":"Amen, amen dico tibi: Cum esses iunior, cingebas teipsum et ambulabas, ubi volebas; cum autem senueris, extendes manus tuas, et alius te cinget et ducet, quo non vis '."
,"19":"Hoc autem dixit significans qua morte clarificaturus esset Deum. Et hoc cum dixisset, dicit ei: ' Sequere me '."
,"20":"Conversus Petrus videt illum discipulum, quem diligebat Iesus, sequentem, qui et recubuit in cena super pectus eius et dixit: ' Domine, quis est qui tradit te? '."
,"21":"Hunc ergo cum vidisset Petrus, dicit Iesu: ' Domine, hic autem quid? '."
,"22":"Dicit ei Iesus: ' Si eum volo manere donec veniam, quid ad te? Tu me sequere '."
,"23":"Exivit ergo sermo iste in fratres, quia discipulus ille non moritur. Non autem dixit ei Iesus: ' Non moritur ', sed: ' Si eum volo manere donec veniam, quid ad te? '."
,"24":"Hic est discipulus, qui testimonium perhibet de his et scripsit haec; et scimus quia verum est testimonium eius."
,"25":"Sunt autem et alia multa, quae fecit Iesus; quae, si scribantur per singula, nec ipsum arbitror mundum capere eos, qui scribendi sunt, libros."
}`)

}
func LA_NVBSE_LoadNELCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Quoniam quidem multi conati sunt ordinare narrationem, quae in nobis completae sunt, rerum,"
,"2":"sicut tradiderunt nobis, qui ab initio ipsi viderunt et ministri fuerunt verbi,"
,"3":"visum est et mihi, adsecuto a principio omnia, diligenter ex ordine tibi scribere, optime Theophile,"
,"4":"ut cognoscas eorum verborum, de quibus eruditus es, firmitatem."
,"5":"Fuit in diebus Herodis regis Iudaeae sacerdos quidam nomine Zacharias de vice Abiae, et uxor illi de filiabus Aaron, et nomen eius Elisabeth."
,"6":"Erant autem iusti ambo ante Deum, incedentes in omnibus mandatis et iustificationibus Domini, irreprehensibiles."
,"7":"Et non erat illis filius, eo quod esset Elisabeth sterilis, et ambo processissent in diebus suis."
,"8":"Factum est autem, cum sacerdotio fungeretur in ordine vicis suae ante Deum,"
,"9":"secundum consuetudinem sacerdotii sorte exiit, ut incensum poneret ingressus in templum Domini;"
,"10":"et omnis multitudo erat populi orans foris hora incensi."
,"11":"Apparuit autem illi angelus Domini stans a dextris altaris incensi;"
,"12":"et Zacharias turbatus est videns, et timor irruit super eum."
,"13":"Ait autem ad illum angelus: ' Ne timeas, Zacharia, quoniam exaudita est deprecatio tua, et uxor tua Elisabeth pariet tibi filium, et vocabis nomen eius Ioannem."
,"14":"Et erit gaudium tibi et exsultatio, et multi in nativitate eius gaudebunt:"
,"15":"erit enim magnus coram Domino et vinum et siceram non bibet et Spiritu Sancto replebitur adhuc ex utero matris suae"
,"16":"et multos filiorum Israel convertet ad Dominum Deum ipsorum."
,"17":"Et ipse praecedet ante illum in spiritu et virtute Eliae, ut convertat corda patrum in filios et incredibiles ad prudentiam iustorum, parare Domino plebem perfectam '."
,"18":"Et dixit Zacharias ad angelum: ' Unde hoc sciam? Ego enim sum senex, et uxor mea processit in diebus suis '."
,"19":"Et respondens angelus dixit ei: ' Ego sum Gabriel, qui adsto ante Deum, et missus sum loqui ad te et haec tibi evangelizare."
,"20":"Et ecce: eris tacens et non poteris loqui usque in diem, quo haec fiant, pro eo quod non credidisti verbis meis, quae implebuntur in tempore suo '."
,"21":"Et erat plebs exspectans Zachariam, et mirabantur quod tardaret ipse in templo."
,"22":"Egressus autem non poterat loqui ad illos, et cognoverunt quod visionem vidisset in templo; et ipse erat innuens illis et permansit mutus."
,"23":"Et factum est, ut impleti sunt dies officii eius, abiit in domum suam."
,"24":"Post hos autem dies concepit Elisabeth uxor eius et occultabat se mensibus quinque dicens:"
,"25":"' Sic mihi fecit Dominus in diebus, quibus respexit auferre opprobrium meum inter homines '."
,"26":"In mense autem sexto missus est angelus Gabriel a Deo in civitatem Galilaeae, cui nomen Nazareth,"
,"27":"ad virginem desponsatam viro, cui nomen erat Ioseph de domo David, et nomen virginis Maria."
,"28":"Et ingressus ad eam dixit: ' Ave, gratia plena, Dominus tecum '."
,"29":"Ipsa autem turbata est in sermone eius et cogitabat qualis esset ista salutatio."
,"30":"Et ait angelus ei: ' Ne timeas, Maria; invenisti enim gratiam apud Deum."
,"31":"Et ecce concipies in utero et paries filium et vocabis nomen eius Iesum."
,"32":"Hic erit magnus et Filius Altissimi vocabitur, et dabit illi Dominus Deus sedem David patris eius,"
,"33":"et regnabit super domum Iacob in aeternum, et regni eius non erit finis '."
,"34":"Dixit autem Maria ad angelum: ' Quomodo fiet istud, quoniam virum non cognosco? '."
,"35":"Et respondens angelus dixit ei: ' Spiritus Sanctus superveniet in te, et virtus Altissimi obumbrabit tibi: ideoque et quod nascetur sanctum, vocabitur Filius Dei."
,"36":"Et ecce Elisabeth cognata tua et ipsa concepit filium in senecta sua, et hic mensis est sextus illi, quae vocatur sterilis,"
,"37":"quia non erit impossibile apud Deum omne verbum '."
,"38":"Dixit autem Maria: ' Ecce ancilla Domini; fiat mihi secundum verbum tuum '. Et discessit ab illa angelus."
,"39":"Exsurgens autem Maria in diebus illis abiit in montana cum festinatione in civitatem Iudae"
,"40":"et intravit in domum Zachariae et salutavit Elisabeth."
,"41":"Et factum est, ut audivit salutationem Mariae Elisabeth, exsultavit infans in utero eius, et repleta est Spiritu Sancto Elisabeth"
,"42":"et exclamavit voce magna et dixit: ' Benedicta tu inter mulieres, et benedictus fructus ventris tui."
,"43":"Et unde hoc mihi, ut veniat mater Domini mei ad me?"
,"44":"Ecce enim ut facta est vox salutationis tuae in auribus meis, exsultavit in gaudio infans in utero meo."
,"45":"Et beata, quae credidit, quoniam perficientur ea, quae dicta sunt ei a Domino '."
,"46":"Et ait Maria: ' Magnificat anima mea Dominum,"
,"47":"et exsultavit spiritus meus in Deo salvatore meo,"
,"48":"quia respexit humilitatem ancillae suae. Ecce enim ex hoc beatam me dicent omnes generationes,"
,"49":"quia fecit mihi magna, qui potens est, et sanctum nomen eius,"
,"50":"et misericordia eius in progenies et progenies,timentibus eum."
,"51":"Fecit potentiam in brachio suo, dispersit superbos mente cordis sui;"
,"52":"deposuit potentes de sede,et exaltavit humiles;"
,"53":"esurientes implevit bonis,et divites dimisit inanes."
,"54":"Suscepit Israel puerum suum, recordatus misericordiae,"
,"55":"sicut locutus est ad patres nostros, Abraham et semini eius in saecula '."
,"56":"Mansit autem Maria cum illa quasi mensibus tribus et reversa est in domum suam."
,"57":"Elisabeth autem impletum est tempus pariendi, et peperit filium."
,"58":"Et audierunt vicini et cognati eius quia magnificavit Dominus misericordiam suam cum illa, et congratulabantur ei."
,"59":"Et factum est, in die octavo venerunt circumcidere puerum et vocabant eum nomine patris eius, Zachariam."
,"60":"Et respondens mater eius dixit: ' Nequaquam, sed vocabitur Ioannes '."
,"61":"Et dixerunt ad illam: ' Nemo est in cognatione tua, qui vocetur hoc nomine '."
,"62":"Innuebant autem patri eius quem vellet vocari eum."
,"63":"Et postulans pugillarem scripsit dicens: ' Ioannes est nomen eius '. Et mirati sunt universi."
,"64":"Apertum est autem ilico os eius et lingua eius, et loquebatur benedicens Deum."
,"65":"Et factus est timor super omnes vicinos eorum, et super omnia montana Iudaeae divulgabantur omnia verba haec."
,"66":"Et posuerunt omnes, qui audierant, in corde suo dicentes: ' Quid putas puer iste erit? '. Etenim manus Domini erat cum illo."
,"67":"Et Zacharias pater eius impletus est Spiritu Sancto et prophetavit dicens:"
,"68":"' Benedictus Dominus, Deus Israel, quia visitavit et fecit redemptionem plebi suae"
,"69":"et erexit cornu salutis nobis,in domo David pueri sui,"
,"70":"sicut locutus est per os sanctorum, qui a saeculo sunt, prophetarum eius,"
,"71":"salutem ex inimicis nostris,et de manu omnium, qui oderunt nos;"
,"72":"ad faciendam misericordiam cum patribus nostris,et memorari testamenti sui sancti,"
,"73":"iusiurandum, quod iuravit ad Abraham patrem nostrum, daturum se nobis,"
,"74":"ut sine timore, de manu inimicorum liberati, serviamus illi"
,"75":"in sanctitate et iustitia coram ipso,omnibus diebus nostris."
,"76":"Et tu, puer, propheta Altissimi vocaberis: praeibis enim ante faciem Domini parare vias eius,"
,"77":"ad dandam scientiam salutis plebi eius,in remissionem peccatorum eorum,"
,"78":"per viscera misericordiae Dei nostri, in quibus visitabit nos oriens ex alto,"
,"79":"illuminare his, qui in tenebris et in umbra mortis sedent, ad dirigendos pedes nostros in viam pacis '."
,"80":"Puer autem crescebat et confortabatur spiritu et erat in deserto usque in diem ostensionis suae ad Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Factum est autem, in diebus il lis exiit edictum a Caesare Au gusto, ut describeretur universus orbis."
,"2":"Haec descriptio prima facta est praeside Syriae Quirino."
,"3":"Et ibant omnes, ut profiterentur, singuli in suam civitatem."
,"4":"Ascendit autem et Ioseph a Galilaea de civitate Nazareth in Iudaeam in civitatem David, quae vocatur Bethlehem, eo quod esset de domo et familia David,"
,"5":"ut profiteretur cum Maria desponsata sibi, uxore praegnante."
,"6":"Factum est autem, cum essent ibi, impleti sunt dies, ut pareret,"
,"7":"et peperit filium suum primogenitum; et pannis eum involvit et reclinavit eum in praesepio, quia non erat eis locus in deversorio."
,"8":"Et pastores erant in regione eadem vigilantes et custodientes vigilias noctis supra gregem suum."
,"9":"Et angelus Domini stetit iuxta illos, et claritas Domini circumfulsit illos, et timuerunt timore magno."
,"10":"Et dixit illis angelus: ' Nolite timere; ecce enim evangelizo vobis gaudium magnum, quod erit omni populo,"
,"11":"quia natus est vobis hodie Salvator, qui est Christus Dominus, in civitate David."
,"12":"Et hoc vobis signum: invenietis infantem pannis involutum et positum in praesepio '."
,"13":"Et subito facta est cum angelo multitudo militiae caelestis laudantium Deum et dicentium:"
,"14":"' Gloria in altissimis Deo, et super terram pax in hominibus bonae voluntatis '."
,"15":"Et factum est, ut discesserunt ab eis angeli in caelum, pastores loquebantur ad invicem: ' Transeamus usque Bethlehem et videamus hoc verbum, quod factum est, quod Dominus ostendit nobis '."
,"16":"Et venerunt festinantes et invenerunt Mariam et Ioseph et infantem positum in praesepio."
,"17":"Videntes autem notum fecerunt verbum, quod dictum erat illis de puero hoc."
,"18":"Et omnes, qui audierunt, mirati sunt de his, quae dicta erant a pastoribus ad ipsos."
,"19":"Maria autem conservabat omnia verba haec conferens in corde suo."
,"20":"Et reversi sunt pastores glorificantes et laudantes Deum in omnibus, quae audierant et viderant, sicut dictum est ad illos."
,"21":"Et postquam consummati sunt dies octo, ut circumcideretur, vocatum est nomen eius Iesus, quod vocatum est ab angelo, priusquam in utero conciperetur."
,"22":"Et postquam impleti sunt dies purgationis eorum secundum legem Moysis, tulerunt illum in Hierosolymam, ut sisterent Domino,"
,"23":"sicut scriptum est in lege Domini: ' Omne masculinum adaperiens vulvam sanctum Domino vocabitur ',"
,"24":"et ut darent hostiam secundum quod dictum est in lege Domini: par turturum aut duos pullos columbarum."
,"25":"Et ecce homo erat in Ierusalem, cui nomen Simeon, et homo iste iustus et timoratus, exspectans consolationem Israel, et Spiritus Sanctus erat super eum;"
,"26":"et responsum acceperat ab Spiritu Sancto non visurum se mortem nisi prius videret Christum Domini."
,"27":"Et venit in Spiritu in templum. Et cum inducerent puerum Iesum parentes eius, ut facerent secundum consuetudinem legis pro eo,"
,"28":"et ipse accepit eum in ulnas suas et benedixit Deum et dixit:"
,"29":"' Nunc dimittis servum tuum, Domine, secundum verbum tuum in pace,"
,"30":"quia viderunt oculi mei,salutare tuum,"
,"31":"quod parasti,ante faciem omnium populorum,"
,"32":"lumen ad revelationem gentium,et gloriam plebis tuae Israel '."
,"33":"Et erat pater eius et mater mirantes super his, quae dicebantur de illo."
,"34":"Et benedixit illis Simeon et dixit ad Mariam matrem eius: ' Ecce positus est hic in ruinam et resurrectionem multorum in Israel et in signum, cui contradicetur"
,"35":"- et tuam ipsius animam pertransiet gladius - ut revelentur ex multis cordibus cogitationes '."
,"36":"Et erat Anna prophetissa, filia Phanuel, de tribu Aser. Haec processerat in diebus multis et vixerat cum viro annis septem a virginitate sua;"
,"37":"et haec vidua usque ad annos octoginta quattuor, quae non discedebat de templo, ieiuniis et obsecrationibus serviens nocte ac die."
,"38":"Et haec ipsa hora superveniens confitebatur Deo et loquebatur de illo omnibus, qui exspectabant redemptionem Ierusalem."
,"39":"Et ut perfecerunt omnia secundum legem Domini, reversi sunt in Galilaeam in civitatem suam Nazareth."
,"40":"Puer autem crescebat et confortabatur plenus sapientia; et gratia Dei erat super illum."
,"41":"Et ibant parentes eius per omnes annos in Ierusalem in die festo Paschae."
,"42":"Et cum factus esset annorum duodecim, ascendentibus illis secundum consuetudinem diei festi,"
,"43":"consummatisque diebus, cum redirent, remansit puer Iesus in Ierusalem, et non cognoverunt parentes eius."
,"44":"Existimantes autem illum esse in comitatu, venerunt iter diei et requirebant eum inter cognatos et notos;"
,"45":"et non invenientes regressi sunt in Ierusalem requirentes eum."
,"46":"Et factum est, post triduum invenerunt illum in templo sedentem in medio doctorum, audientem illos et interrogantem eos;"
,"47":"stupebant autem omnes, qui eum audiebant, super prudentia et responsis eius."
,"48":"Et videntes eum admirati sunt, et dixit Mater cius ad illum: ' Fili, quid fecisti nobis sic? Ecce pater tuus et ego dolentes quaerebamus te '."
,"49":"Et ait ad illos: ' Quid est quod me quaerebatis? Nesciebatis quia in his, quae Patris mei sunt, oportet me esse? '."
,"50":"Et ipsi non intellexerunt verbum, quod locutus est ad illos."
,"51":"Et descendit cum eis et venit Nazareth et erat subditus illis. Et mater eius conservabat omnia verba in corde suo."
,"52":"Et Iesus proficiebat sapientia et aetate et gratia apud Deum et homines."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Anno autem quinto decimo im perii Tiberii Caesaris, procu rante Pontio Pilato Iudaeam, tetrarcha autem Galilaeae Herode, Philippo autem fratre eius tetrarcha Ituraeae et Trachonitidis regionis, et Lysania Abilinae tetrarcha,"
,"2":"sub principe sacerdotum Anna et Caipha, factum est verbum Dei super Ioannem Zachariae filium in deserto."
,"3":"Et venit in omnem regionem circa Iordanem praedicans baptismum paenitentiae in remissionem peccatorum,"
,"4":"sicut scriptum est in libro sermonum Isaiae prophetae: ' Vox clamantis in deserto: 'Parate viam Domini, rectas facite semitas eius."
,"5":"Omnis vallis implebitur, et omnis mons et collis humiliabitur; et erunt prava in directa, et aspera in vias planas:"
,"6":"et videbit omnis caro salutare Dei' '."
,"7":"Dicebat ergo ad turbas, quae exibant, ut baptizarentur ab ipso: ' Genimina viperarum, quis ostendit vobis fugere a ventura ira?"
,"8":"Facite ergo fructus dignos paenitentiae et ne coeperitis dicere in vobis ipsis: 'Patrem habemus Abraham'; dico enim vobis quia potest Deus de lapidibus istis suscitare Abrahae filios."
,"9":"Iam enim et securis ad radicem arborum posita est; omnis ergo arbor non faciens fructum bonum exciditur et in ignem mittitur '."
,"10":"Et interrogabant eum turbae dicentes: ' Quid ergo faciemus? '."
,"11":"Respondens autem dicebat illis: ' Qui habet duas tunicas, det non habenti; et, qui habet escas, similiter faciat '."
,"12":"Venerunt autem et publicani, ut baptizarentur, et dixerunt ad illum: ' Magister, quid faciemus? '."
,"13":"At ille dixit ad eos: ' Nihil amplius quam constitutum est vobis, faciatis '."
,"14":"Interrogabant autem eum et milites dicentes: ' Quid faciemus et nos? '. Et ait illis: ' Neminem concutiatis neque calumniam faciatis et contenti estote stipendiis vestris '."
,"15":"Existimante autem populo et cogitantibus omnibus in cordibus suis de Ioanne, ne forte ipse esset Christus,"
,"16":"respondit Ioannes dicens omnibus: ' Ego quidem aqua baptizo vos. Venit autem fortior me, cuius non sum dignus solvere corrigiam calceamentorum eius: ipse vos baptizabit in Spiritu Sancto et igni;"
,"17":"cuius ventilabrum in manu eius ad purgandam aream suam et ad congregandum triticum in horreum suum, paleas autem comburet igni inexstinguibili '."
,"18":"Multa quidem et alia exhortans evangelizabat populum."
,"19":"Herodes autem tetrarcha, cum corriperetur ab illo de Herodiade uxore fratris sui et de omnibus malis, quae fecit Herodes,"
,"20":"adiecit et hoc supra omnia et inclusit Ioannem in carcere."
,"21":"Factum est autem, cum baptizaretur omnis populus, et Iesu baptizato et orante, apertum est caelum,"
,"22":"et descendit Spiritus Sanctus corporali specie sicut columba super ipsum; et vox de caelo facta est: ' Tu es Filius meus dilectus; in te complacui mihi '."
,"23":"Et ipse Iesus erat incipiens quasi annorum triginta, ut putabatur, filius Ioseph, qui fuit Heli,"
,"24":"qui fuit Matthat, qui fuit Levi, qui fuit Melchi, qui fuit Iannae, qui fuit Ioseph,"
,"25":"qui fuit Matthathiae, qui fuit Amos, qui fuit Nahum, qui fuit Esli, qui fuit Naggae,"
,"26":"qui fuit Maath, qui fuit Matthathiae, qui fuit Semei, qui fuit Iosech, qui fuit Ioda,"
,"27":"qui fuit Ioanna, qui fuit Resa, qui fuit Zorobabel, qui fuit Salathiel, qui fuit Neri,"
,"28":"qui fuit Melchi, qui fuit Addi, qui fuit Cosam, qui fuit Elmadam, qui fuit Her,"
,"29":"qui fuit Iesu, qui fuit Eliezer, qui fuit Iorim, qui fuit Matthat, qui fuit Levi,"
,"30":"qui fuit Simeon, qui fuit Iudae, qui fuit Ioseph, qui fuit Iona, qui fuit Eliachim,"
,"31":"qui fuit Melea, qui fuit Menna, qui fuit Matthatha, qui fuit Nathan, qui fuit David,"
,"32":"qui fuit Iesse, qui fuit Obed, qui fuit Booz, qui fuit Salmon, qui fuit Naasson,"
,"33":"qui fuit Aminadab, qui fuit Admin, qui fuit Arni, qui fuit Esrom, qui fuit Phares, qui fuit Iudae,"
,"34":"qui fuit Iacob, qui fuit Isaac, qui fuit Abrahae, qui fuit Thare, qui fuit Nachor,"
,"35":"qui fuit Seruch, qui fuit Ragau, qui fuit Phaleg, qui fuit Heber, qui fuit Sala,"
,"36":"qui fuit Cainan, qui fuit Arphaxad, qui fuit Sem, qui fuit Noe, qui fuit Lamech,"
,"37":"qui fuit Mathusala, qui fuit Henoch, qui fuit Iared, qui fuit Malaleel, qui fuit Cainan,"
,"38":"qui fuit Enos, qui fuit Seth, qui fuit Adam, qui fuit Dei."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Iesus autem plenus Spiritu Sancto regressus est ab Iordane et agebatur in Spiritu in deserto"
,"2":"diebus quadraginta et tentabatur a Diabolo. Et nihil manducavit in diebus illis et, consummatis illis, esuriit."
,"3":"Dixit autem illi Diabolus: ' Si Filius Dei es, dic lapidi huic, ut panis fiat '."
,"4":"Et respondit ad illum Iesus: ' Scriptum est: 'Non in pane solo vivet homo' '."
,"5":"Et sustulit illum et ostendit illi omnia regna orbis terrae in momento temporis;"
,"6":"et ait ei Diabolus: ' Tibi dabo potestatem hanc universam et gloriam illorum, quia mihi tradita est, et, cui volo, do illam:"
,"7":"tu ergo, si adoraveris coram me, erit tua omnis '."
,"8":"Et respondens Iesus dixit illi: ' Scriptum est: 'Dominum Deum tuum adorabis et illi soli servies' '."
,"9":"Duxit autem illum in Ierusalem et statuit eum supra pinnam templi et dixit illi: ' Si Filius Dei es, mitte te hinc deorsum."
,"10":"Scriptum est enim: 'Angelis suis mandabit de te, ut conservent te'"
,"11":"et: 'In manibus tollent te, ne forte offendas ad lapidem pedem tuum' '."
,"12":"Et respondens Iesus ait illi: ' Dictum est: 'Non tentabis Dominum Deum tuum' '."
,"13":"Et consummata omni tentatione, Diabolus recessit ab illo usque ad tempus."
,"14":"Et regressus est Iesus in virtute Spiritus in Galilaeam. Et fama exiit per universam regionem de illo."
,"15":"Et ipse docebat in synagogis eorum et magnificabatur ab omnibus."
,"16":"Et venit Nazareth, ubi erat nutritus, et intravit secundum consuetudinem suam die sabbati in synagogam et surrexit legere."
,"17":"Et tradi tus est illi liber prophetae Isaiae; et,ut revolvit librum, invenit locum, ubi scriptum erat:"
,"18":"' Spiritus Domini super me; propter quod unxit me,evangelizare pauperibus, misit me praedicare captivis remissionem,et caecis visum, dimittere confractos in remissione,"
,"19":"praedicare annum Domini acceptum '."
,"20":"Et cum plicuisset librum, reddidit ministro et sedit; et omnium in synagoga oculi erant intendentes in eum."
,"21":"Coepit autem dicere ad illos: ' Hodie impleta est haec Scriptura in auribus vestris '."
,"22":"Et omnes testimonium illi dabant et mirabantur in verbis gratiae, quae procedebant de ore ipsius, et dicebant: ' Nonne hic filius est Ioseph? '."
,"23":"Et ait illis: ' Utique dicetis mihi hanc similitudinem: 'Medice, cura teipsum; quanta audivimus facta in Capharnaum, fac et hic in patria tua' '."
,"24":"Ait autem: ' Amen dico vobis: Nemo propheta acceptus est in patria sua."
,"25":"In veritate autem dico vobis: Multae viduae erant in diebus Eliae in Israel, quando clausum est caelum annis tribus et mensibus sex, cum facta est fames magna in omni terra;"
,"26":"et ad nullam illarum missus est Elias nisi in Sarepta Sidoniae ad mulierem viduam."
,"27":"Et multi leprosi erant in Israel sub Eliseo propheta; et nemo eorum mundatus est nisi Naaman Syrus '."
,"28":"Et repleti sunt omnes in synagoga ira haec audientes;"
,"29":"et surrexerunt et eiecerunt illum extra civitatem et duxerunt illum usque ad supercilium montis, supra quem civitas illorum erat aedificata, ut praecipitarent eum."
,"30":"Ipse autem transiens per medium illorum ibat."
,"31":"Et descendit in Capharnaum civitatem Galilaeae. Et docebat illos sabbatis;"
,"32":"et stupebant in doctrina eius, quia in potestate erat sermo ipsius."
,"33":"Et in synagoga erat homo habens spiritum daemonii immundi; et exclamavit voce magna:"
,"34":"' Sine; quid nobis et tibi, Iesu Nazarene? Venisti perdere nos? Scio te qui sis: Sanctus Dei '."
,"35":"Et increpavit illi Iesus dicens: ' Obmutesce et exi ab illo! '. Et cum proiecisset illum daemonium in medium, exiit ab illo nihilque illum nocuit."
,"36":"Et factus est pavor in omnibus; et colloquebantur ad invicem dicentes: ' Quod est hoc verbum, quia in potestate et virtute imperat immundis spiritibus, et exeunt? '."
,"37":"Et divulgabatur fama de illo in omnem locum regionis."
,"38":"Surgens autem de synagoga introivit in domum Simonis. Socrus autem Simonis tenebatur magna febri; et rogaverunt illum pro ea."
,"39":"Et stans super illam imperavit febri, et dimisit illam; et continuo surgens ministrabat illis."
,"40":"Cum sol autem occidisset, omnes, qui habebant infirmos variis languoribus, ducebant illos ad eum; at ille singulis manus imponens curabat eos."
,"41":"Exibant autem daemonia a multis clamantia et dicentia: ' Tu es Filius Dei '. Et increpans non sinebat ea loqui, quia sciebant ipsum esse Christum."
,"42":"Facta autem die, egressus ibat in desertum locum; et turbae requirebant eum et venerunt usque ad ipsum et detinebant illum, ne discederet ab eis."
,"43":"Quibus ille ait: ' Et aliis civitatibus oportet me evangelizare regnum Dei, quia ideo missus sum '."
,"44":"Et erat praedicans in synagogis Iudaeae."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Factum est autem, cum turba urgeret illum et audiret verbum Dei, et ipse stabat secus stagnum Genesareth"
,"2":"et vidit duas naves stantes secus stagnum; piscatores autem descenderant de illis et lavabant retia."
,"3":"Ascendens autem in unam navem, quae erat Simonis, rogavit eum a terra reducere pusillum; et sedens docebat de navicula turbas."
,"4":"Ut cessavit autem loqui, dixit ad Simonem: ' Duc in altum et laxate retia vestra in capturam '."
,"5":"Et respondens Simon dixit: ' Praeceptor, per totam noctem laborantes nihil cepimus; in verbo autem tuo laxabo retia '."
,"6":"Et cum hoc fecissent, concluserunt piscium multitudinem copiosam; rumpebantur autem retia eorum."
,"7":"Et annuerunt sociis, qui erant in alia navi, ut venirent et adiuvarent eos; et venerunt et impleverunt ambas naviculas, ita ut mergerentur."
,"8":"Quod cum videret Simon Petrus, procidit ad genua Iesu dicens: ' Exi a me, quia homo peccator sum, Domine '."
,"9":"Stupor enim circumdederat eum et omnes, qui cum illo erant, in captura piscium, quos ceperant;"
,"10":"similiter autem et Iacobum et Ioannem, filios Zebedaei, qui erant socii Simonis. Et ait ad Simonem Iesus: ' Noli timere; ex hoc iam homines eris capiens '."
,"11":"Et subductis ad terram navibus, relictis omnibus, secuti sunt illum."
,"12":"Et factum est, cum esset in una civitatum, et ecce vir plenus lepra; et videns Iesum et procidens in faciem rogavit eum dicens: ' Domine, si vis, potes me mundare '."
,"13":"Et extendens manum tetigit illum dicens: ' Volo, mundare! '; et confestim lepra discessit ab illo."
,"14":"Et ipse praecepit illi, ut nemini diceret, sed: ' Vade, ostende te sacerdoti et offer pro emundatione tua, sicut praecepit Moyses, in testimonium illis '."
,"15":"Perambulabat autem magis sermo de illo, et conveniebant turbae multae, ut audirent et curarentur ab infirmitatibus suis;"
,"16":"ipse autem secedebat in desertis et orabat."
,"17":"Et factum est, in una dierum, et ipse erat docens, et erant pharisaei sedentes et legis doctores, qui venerant ex omni castello Galilaeae et Iudaeae et Ierusalem; et virtus Domini erat ei ad sanandum."
,"18":"Et ecce viri portantes in lecto hominem, qui erat paralyticus, et quaerebant eum inferre et ponere ante eum."
,"19":"Et non invenientes qua parte illum inferrent prae turba, ascenderunt supra tectum et per tegulas summiserunt illum cum lectulo in medium ante Iesum."
,"20":"Quorum fidem ut vidit, dixit: ' Homo, remittuntur tibi peccata tua '."
,"21":"Et coeperunt cogitare scribae et pharisaei dicentes: ' Quis est hic, qui loquitur blasphemias? Quis potest dimittere peccata nisi solus Deus? '."
,"22":"Ut cognovit autem Iesus cogitationes eorum, respondens dixit ad illos: ' Quid cogitatis in cordibus vestris?"
,"23":"Quid est facilius, dicere: 'Dimittuntur tibi peccata tua', an dicere: 'Surge et ambula'?"
,"24":"Ut autem sciatis quia Filius hominis potestatem habet in terra dimittere peccata - ait paralytico - : Tibi dico: Surge, tolle lectulum tuum et vade in domum tuam '."
,"25":"Et confestim surgens coram illis tulit, in quo iacebat, et abiit in domum suam magnificans Deum."
,"26":"Et stupor apprehendit omnes, et magnificabant Deum; et repleti sunt timore dicentes: ' Vidimus mirabilia hodie '."
,"27":"Et post haec exiit et vidit publicanum nomine Levi sedentem ad teloneum et ait illi: ' Sequere me '."
,"28":"Et relictis omnibus, surgens secutus est eum."
,"29":"Et fecit ei convivium magnum Levi in domo sua; et erat turba multa publicanorum et aliorum, qui cum illis erant discumbentes."
,"30":"Et murmurabant pharisaei et scribae eorum adversus discipulos eius dicentes: ' Quare cum publicanis et peccatoribus manducatis et bibitis? '."
,"31":"Et respondens Iesus dixit ad illos: ' Non egent, qui sani sunt, medico, sed qui male habent."
,"32":"Non veni vocare iustos sed peccatores in paenitentiam '."
,"33":"At illi dixerunt ad eum: ' Discipuli Ioannis ieiunant frequenter et obsecrationes faciunt, similiter et pharisaeorum; tui autem edunt et bibunt '."
,"34":"Quibus Iesus ait: ' Numquid potestis convivas nuptiarum, dum cum illis est sponsus, facere ieiunare?"
,"35":"Venient autem dies; et cum ablatus fuerit ab illis sponsus, tunc ieiunabunt in illis diebus '."
,"36":"Dicebat autem et similitudinem ad illos: ' Nemo abscindit commissuram a vestimento novo et immittit in vestimentum vetus; alioquin et novum rumpet, et veteri non conveniet commissura a novo."
,"37":"Et nemo mittit vinum novum in utres veteres; alioquin rumpet vinum novum utres et ipsum effundetur, et utres peribunt;"
,"38":"sed vinum novum in utres novos mittendum est."
,"39":"Et nemo bibens vetus vult novum; dicit enim: 'Vetus melius est!' '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Factum est autem in sabbato, cum transiret per sata, et velle bant discipuli eius spicas et manducabant confricantes manibus."
,"2":"Quidam autem pharisaeorum dixerunt: ' Quid facitis, quod non licet in sabbatis? '."
,"3":"Et respondens Iesus ad eos dixit: ' Nec hoc legistis, quod fecit David, cum esurisset ipse et qui cum eo erant?"
,"4":"Quomodo intravit in domum Dei et panes propositionis sumpsit et manducavit et dedit his, qui cum ipso erant, quos non licet manducare nisi tantum sacerdotibus? '."
,"5":"Et dicebat illis: ' Dominus est sabbati Filius hominis '."
,"6":"Factum est autem in alio sabbato, ut intraret in synagogam et doceret; et erat ibi homo, et manus eius dextra erat arida."
,"7":"Observabant autem illum scribae et pharisaei, si sabbato curaret, ut invenirent accusare illum."
,"8":"Ipse vero sciebat cogitationes eorum et ait homini, qui habebat manum aridam: ' Surge et sta in medium '. Et surgens stetit."
,"9":"Ait autem ad illos Iesus: ' Interrogo vos, si licet sabbato bene facere an male; animam salvam facere an perdere? '."
,"10":"Et circumspectis omnibus illis, dixit illi: ' Extende manum tuam '. Et fecit; et restituta est manus eius."
,"11":"Ipsi autem repleti sunt insipientia et colloquebantur ad invicem quidnam facerent Iesu."
,"12":"Factum est autem in illis diebus, exiit in montem orare et erat pernoctans in oratione Dei."
,"13":"Et cum dies factus esset, vocavit discipulos suos et elegit Duodecim ex ipsis, quos et apostolos nominavit:"
,"14":"Simonem, quem et cognominavit Petrum, et Andream fratrem eius et Iacobum et Ioannem et Philippum et Bartholomaeum"
,"15":"et Matthaeum et Thomam et Iacobum Alphaei et Simonem, qui vocatur Zelotes,"
,"16":"et Iudam Iacobi et Iudam Iscarioth, qui fuit proditor."
,"17":"Et descendens cum illis stetit in loco campestri, et turba multa discipulorum eius, et multitudo copiosa plebis ab omni Iudaea et Ierusalem et maritima Tyri et Sidonis,"
,"18":"qui venerunt, ut audirent eum et sanarentur a languoribus suis; et, qui vexabantur a spiritibus immundis, curabantur."
,"19":"Et omnis turba quaerebant eum tangere, quia virtus de illo exibat et sanabat omnes."
,"20":"Et ipse, elevatis oculis suis in discipulos suos, dicebat: ' Beati pauperes, quia vestrum est regnum Dei."
,"21":"Beati, qui nunc esuritis, quia saturabimini. Beati, qui nunc fletis, quia ridebitis."
,"22":"Beati eritis, cum vos oderint homines et cum separaverint vos et exprobraverint et eiecerint nomen vestrum tamquam malum propter Filium hominis."
,"23":"Gaudete in illa die et exsultate, ecce enim merces vestra multa in caelo; secundum haec enim faciebant prophetis patres eorum."
,"24":"Verumtamen vae vobis divitibus, quia habetis consolationem vestram!"
,"25":"Vae vobis, qui saturati estis nunc, quia esurietis!,Vae vobis, qui ridetis nunc, quia lugebitis et flebitis!"
,"26":"Vae, cum bene vobis dixerint omnes homines! Secundum haec enim faciebant pseudoprophetis patres eorum."
,"27":"Sed vobis dico, qui auditis: Diligite inimicos vestros, bene facite his, qui vos oderunt;"
,"28":"benedicite male dicentibus vobis, orate pro calumniantibus vos."
,"29":"Ei, qui te percutit in maxillam, praebe et alteram; et ab eo, qui aufert tibi vestimentum, etiam tunicam noli prohibere."
,"30":"Omni petenti te tribue; et ab eo, qui aufert, quae tua sunt, ne repetas."
,"31":"Et prout vultis, ut faciant vobis homines, facite illis similiter."
,"32":"Et si diligitis eos, qui vos diligunt, quae vobis est gratia? Nam et peccatores diligentes se diligunt."
,"33":"Et si bene feceritis his, qui vobis bene faciunt, quae vobis est gratia? Si quidem et peccatores idem faciunt."
,"34":"Et si mutuum dederitis his, a quibus speratis recipere, quae vobis gratia est? Nam et peccatores peccatoribus fenerantur, ut recipiant aequalia."
,"35":"Verumtamen diligite inimicos vestros et bene facite et mutuum date nihil desperantes; et erit merces vestra multa, et eritis filii Altissimi, quia ipse benignus est super ingratos et malos."
,"36":"Estote misericordes, sicut et Pater vester misericors est."
,"37":"Et nolite iudicare et non iudicabimini; et nolite condemnare et non condemnabimini. Dimittite et dimittemini;"
,"38":"date, et dabitur vobis: mensuram bonam, confertam, coagitatam, supereffluentem dabunt in sinum vestrum; eadem quippe mensura, qua mensi fueritis, remetietur vobis '."
,"39":"Dixit autem illis et similitudinem: ' Numquid potest caecus caecum ducere? Nonne ambo in foveam cadent?"
,"40":"Non est discipulus super magistrum; perfectus autem omnis erit sicut magister eius."
,"41":"Quid autem vides festucam in oculo fratris tui, trabem autem, quae in oculo tuo est, non consideras?"
,"42":"Quomodo potes dicere fratri tuo: 'Frater, sine eiciam festucam, quae est in oculo tuo', ipse in oculo tuo trabem non videns? Hypocrita, eice primum trabem de oculo tuo et tunc perspicies, ut educas festucam, quae est in oculo fratris tui."
,"43":"Non est enim arbor bona faciens fructum malum, neque iterum arbor mala faciens fructum bonum."
,"44":"Unaquaeque enim arbor de fructu suo cognoscitur; neque enim de spinis colligunt ficus, neque de rubo vindemiant uvam."
,"45":"Bonus homo de bono thesauro cordis profert bonum, et malus homo de malo profert malum: ex abundantia enim cordis os eius loquitur."
,"46":"Quid autem vocatis me: 'Domine, Domine', et non facitis, quae dico?"
,"47":"Omnis, qui venit ad me et audit sermones meos et facit eos, ostendam vobis cui similis sit:"
,"48":"similis est homini aedificanti domum, qui fodit in altum et posuit fundamentum supra petram; inundatione autem facta, illisum est flumen domui illi et non potuit eam movere; bene enim aedificata erat."
,"49":"Qui autem audivit et non fecit, similis est homini aedificanti domum suam supra terram sine fundamento; in quam illisus est fluvius, et continuo cecidit, et facta est ruina domus illius magna '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cum autem implesset omnia verba sua in aures plebis, intra vit Capharnaum."
,"2":"Centurionis autem cuiusdam servus male habens erat moriturus, qui illi erat pretiosus."
,"3":"Et cum audisset de Iesu, misit ad eum seniores Iudaeorum rogans eum, ut veniret et salvaret servum eius."
,"4":"At illi cum venissent ad Iesum, rogabant eum sollicite dicentes: ' Dignus est, ut hoc illi praestes:"
,"5":"diligit enim gentem nostram et synagogam ipse aedificavit nobis '."
,"6":"Iesus autem ibat cum illis. At cum iam non longe esset a domo, misit centurio amicos dicens ei: ' Domine, noli vexari; non enim dignus sum, ut sub tectum meum intres,"
,"7":"propter quod et meipsum non sum dignum arbitratus, ut venirem ad te; sed dic verbo, et sanetur puer meus."
,"8":"Nam et ego homo sum sub potestate constitutus, habens sub me milites, et dico huic: 'Vade', et vadit; et alii: 'Veni', et venit; et servo meo: 'Fac hoc', et facit '."
,"9":"Quo audito, Iesus miratus est eum et conversus sequentibus se turbis dixit: ' Dico vobis, nec in Israel tantam fidem inveni! '."
,"10":"Et reversi, qui missi fuerant, domum, invenerunt servum sanum."
,"11":"Et factum est, deinceps ivit in civitatem, quae vocatur Naim, et ibant cum illo discipuli eius et turba copiosa."
,"12":"Cum autem appropinquaret portae civitatis, et ecce defunctus efferebatur filius unicus matri suae; et haec vidua erat, et turba civitatis multa cum illa."
,"13":"Quam cum vidisset Dominus, misericordia motus super ea dixit illi: ' Noli flere! '."
,"14":"Et accessit et tetigit loculum; hi autem, qui portabant, steterunt. Et ait: ' Adulescens, tibi dico: Surge! '."
,"15":"Et resedit, qui erat mortuus, et coepit loqui; et dedit illum matri suae."
,"16":"Accepit autem omnes timor, et magnificabant Deum dicentes: ' Propheta magnus surrexit in nobis ' et: ' Deus visitavit plebem suam '."
,"17":"Et exiit hic sermo in universam Iudaeam de eo et omnem circa regionem."
,"18":"Et nuntiaverunt Ioanni discipuli eius de omnibus his."
,"19":"Et convocavit duos de discipulis suis Ioannes et misit ad Dominum dicens: ' Tu es qui venturus es, an alium exspectamus? '."
,"20":"Cum autem venissent ad eum viri, dixerunt: ' Ioannes Baptista misit nos ad te dicens: 'Tu es qui venturus es, an alium exspectamus?' '."
,"21":"In ipsa hora curavit multos a languoribus et plagis et spiritibus malis et caecis multis donavit visum."
,"22":"Et respondens dixit illis: ' Euntes nuntiate Ioanni, quae vidistis et audistis: caeci vident, claudi ambulant, leprosi mundantur et surdi audiunt, mortui resurgunt, pauperes evangelizantur;"
,"23":"et beatus est, quicumque non fuerit scandalizatus in me '."
,"24":"Et cum discessissent nuntii Ioannis, coepit dicere de Ioanne ad turbas: ' Quid existis in desertum videre? Arundinem vento moveri?"
,"25":"Sed quid existis videre? Hominem mollibus vestimentis indutum? Ecce, qui in veste pretiosa sunt et deliciis, in domibus regum sunt."
,"26":"Sed quid existis videre? Prophetam? Utique, dico vobis, et plus quam prophetam."
,"27":"Hic est, de quo scriptum est: 'Ecce mitto angelum meum ante faciem tuam, qui praeparabit viam tuam ante te'."
,"28":"Dico vobis: Maior inter natos mulierum Ioanne nemo est; qui autem minor est in regno Dei, maior est illo."
,"29":"Et omnis populus audiens et publicani iustificaverunt Deum, baptizati baptismo Ioannis;"
,"30":"pharisaei autem et legis periti consilium Dei spreverunt in semetipsos, non baptizati ab eo."
,"31":"Cui ergo similes dicam homines generationis huius, et cui similes sunt?"
,"32":"Similes sunt pueris sedentibus in foro et loquentibus ad invicem, quod dicit: 'Cantavimus vobis tibiis, et non saltastis; lamentavimus, et non plorastis!'."
,"33":"Venit enim Ioannes Baptista neque manducans panem neque bibens vinum, et dicitis: 'Daemonium habet!';"
,"34":"venit Filius hominis manducans et bibens, et dicitis: 'Ecce homo devorator et bibens vinum, amicus publicanorum et peccatorum!'."
,"35":"Et iustificata est sapientia ab omnibus filiis suis '."
,"36":"Rogabat autem illum quidam de pharisaeis, ut manducaret cum illo; et ingressus domum pharisaei discubuit."
,"37":"Et ecce mulier, quae erat in civitate peccatrix, ut cognovit quod accubuit in domo pharisaei, attulit alabastrum unguenti;"
,"38":"et stans retro secus pedes eius flens lacrimis coepit rigare pedes eius et capillis capitis sui tergebat, et osculabatur pedes eius et unguento ungebat."
,"39":"Videns autem pharisaeus, qui vocaverat eum, ait intra se dicens: ' Hic si esset propheta, sciret utique quae et qualis mulier, quae tangit eum, quia peccatrix est '."
,"40":"Et respondens Iesus dixit ad illum: ' Simon, habeo tibi aliquid dicere '. At ille ait: ' Magister, dic '."
,"41":"' Duo debitores erant cuidam feneratori: unus debebat denarios quingentos, alius quinquaginta."
,"42":"Non habentibus illis, unde redderent, donavit utrisque. Quis ergo eorum plus diliget eum? '."
,"43":"Respondens Simon dixit: ' Aestimo quia is, cui plus donavit '. At ille dixit ei: ' Recte iudicasti '."
,"44":"Et conversus ad mulierem, dixit Simoni: ' Vides hanc mulierem? Intravi in domum tuam: aquam pedibus meis non dedisti; haec autem lacrimis rigavit pedes meos et capillis suis tersit."
,"45":"Osculum mihi non dedisti; haec autem, ex quo intravi, non cessavit osculari pedes meos."
,"46":"Oleo caput meum non unxisti; haec autem unguento unxit pedes meos."
,"47":"Propter quod dico tibi: Remissa sunt peccata eius multa, quoniam dilexit multum; cui autem minus dimittitur, minus diligit '."
,"48":"Dixit autem ad illam: ' Remissa sunt peccata tua '."
,"49":"Et coeperunt, qui simul accumbebant, dicere intra se: ' Quis est hic, qui etiam peccata dimittit?'."
,"50":"Dixit autem ad mulierem: ' Fides tua te salvam fecit; vade in pace! '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Et factum est deinceps, et ipse iter faciebat per civitatem et ca stellum praedicans et evangelizans regnum Dei; et Duodecim cum illo"
,"2":"et mulieres aliquae, quae erant curatae ab spiritibus malignis et infirmitatibus: Maria, quae vocatur Magdalene, de qua daemonia septem exierant,"
,"3":"et Ioanna uxor Chuza, procuratoris Herodis, et Susanna et aliae multae, quae ministrabant eis de facultatibus suis."
,"4":"Cum autem turba plurima conveniret, et de singulis civitatibus properarent ad eum, dixit per similitudinem:"
,"5":"' Exiit, qui seminat, seminare semen suum. Et dum seminat ipse, aliud cecidit secus viam et conculcatum est, et volucres caeli comederunt illud."
,"6":"Et aliud cecidit super petram et natum aruit, quia non habebat umorem."
,"7":"Et aliud cecidit inter spinas, et simul exortae spinae suffocaverunt illud."
,"8":"Et aliud cecidit in terram bonam et ortum fecit fructum centuplum '. Haec dicens clamabat: ' Qui habet aures audiendi, audiat '."
,"9":"Interrogabant autem eum discipuli eius, quae esset haec parabola."
,"10":"Quibus ipse dixit: ' Vobis datum est nosse mysteria regni Dei, ceteris autem in parabolis, ut videntes non videant et audientes non intellegant."
,"11":"Est autem haec parabola: Semen est verbum Dei."
,"12":"Qui autem secus viam, sunt qui audiunt; deinde venit Diabolus et tollit verbum de corde eorum, ne credentes salvi fiant."
,"13":"Qui autem supra petram: qui cum audierint, cum gaudio suscipiunt verbum; et hi radices non habent, qui ad tempus credunt, et in tempore tentationis recedunt."
,"14":"Quod autem in spinis cecidit: hi sunt, qui audierunt et a sollicitudinibus et divitiis et voluptatibus vitae euntes suffocantur et non referunt fructum."
,"15":"Quod autem in bonam terram: hi sunt, qui in corde bono et optimo audientes verbum retinent et fructum afferunt in patientia."
,"16":"Nemo autem lucernam accendens operit eam vaso aut subtus lectum ponit, sed supra candelabrum ponit, ut intrantes videant lumen."
,"17":"Non enim est occultum, quod non manifestetur, nec absconditum, quod non cognoscatur et in palam veniat."
,"18":"Videte ergo quomodo audiatis: qui enim habet, dabitur illi; et, quicumque non habet, etiam quod putat se habere, auferetur ab illo '."
,"19":"Venerunt autem ad illum mater et fratres eius, et non poterant adire ad eum prae turba."
,"20":"Et nuntiatum est illi: ' Mater tua et fratres tui stant foris volentes te videre '."
,"21":"Qui respondens dixit ad eos: ' Mater mea et fratres mei hi sunt, qui verbum Dei audiunt et faciunt '."
,"22":"Factum est autem in una dierum, et ipse ascendit in navem et discipuli eius, et ait ad illos: ' Transfretemus trans stagnum '. Et ascenderunt."
,"23":"Navigantibus autem illis, obdormivit. Et descendit procella venti in stagnum, et complebantur et periclitabantur."
,"24":"Accedentes autem suscitaverunt eum dicentes: ' Praeceptor, praeceptor, perimus! '. At ille surgens increpavit ventum et tempestatem aquae, et cessaverunt, et facta est tranquillitas."
,"25":"Dixit autem illis: ' Ubi est fides vestra? '. Qui timentes mirati sunt dicentes ad invicem: ' Quis putas hic est, quia et ventis imperat et aquae, et oboediunt ei? '."
,"26":"Enavigaverunt autem ad regionem Gergesenorum, quae est contra Galilaeam."
,"27":"Et cum egressus esset ad terram, occurrit illi vir quidam de civitate, qui habebat daemonia et iam tempore multo vestimento non induebatur neque in domo manebat sed in monumentis."
,"28":"Is ut vidit Iesum, exclamans procidit ante illum et voce magna dixit: ' Quid mihi et tibi est, Iesu, Fili Dei Altissimi? Obsecro te, ne me torqueas '."
,"29":"Praecipiebat enim spiritui immundo, ut exiret ab homine. Multis enim temporibus arripiebat illum, vinciebatur catenis et compedibus custoditus; et ruptis vinculis, agebatur a daemonio in deserta."
,"30":"Interrogavit autem illum Iesus dicens: ' Quod tibi nomen est? '. At ille dixit: ' Legio ', quia intraverunt daemonia multa in eum."
,"31":"Et rogabant eum, ne imperaret illis, ut in abyssum irent."
,"32":"Erat autem ibi grex porcorum multorum pascentium in monte; et rogaverunt eum, ut permitteret eis in illos ingredi. Et permisit illis."
,"33":"Exierunt ergo daemonia ab homine et intraverunt in porcos, et impetu abiit grex per praeceps in stagnum et suffocatus est."
,"34":"Quod ut viderunt factum, qui pascebant, fugerunt et nuntiaverunt in civitatem et in villas."
,"35":"Exierunt autem videre, quod factum est, et venerunt ad Iesum et invenerunt hominem sedentem, a quo daemonia exierant, vestitum ac sana mente ad pedes Iesu et timuerunt."
,"36":"Nuntiaverunt autem illis hi, qui viderant, quomodo sanus factus esset, qui a daemonio vexabatur."
,"37":"Et rogaverunt illum omnis multitudo regionis Gergesenorum, ut discederet ab ipsis, quia timore magno tenebantur. Ipse autem ascendens navem reversus est."
,"38":"Et rogabat illum vir, a quo daemonia exierant, ut cum eo esset. Dimisit autem eum dicens:"
,"39":"' Redi domum tuam et narra quanta tibi fecit Deus '. Et abiit per universam civitatem praedicans quanta illi fecisset Iesus."
,"40":"Cum autem rediret Iesus, excepit illum turba; erant enim omnes exspectantes eum."
,"41":"Et ecce venit vir, cui nomen Iairus, et ipse princeps synagogae erat, et cecidit ad pedes Iesu rogans eum, ut intraret in domum eius,"
,"42":"quia filia unica erat illi fere annorum duodecim, et haec moriebatur. Et dum iret, a turbis comprimebatur."
,"43":"Et mulier quaedam erat in fluxu sanguinis ab annis duodecim, quae in medicos erogaverat omnem substantiam suam nec ab ullo potuit curari;"
,"44":"accessit retro et tetigit fimbriam vestimenti eius, et confestim stetit fluxus sanguinis eius."
,"45":"Et ait Iesus: ' Quis est, qui me tetigit? '. Negantibus autem omnibus, dixit Petrus: ' Praeceptor, turbae te comprimunt et affligunt '."
,"46":"At dixit Iesus: ' Tetigit me aliquis; nam et ego novi virtutem de me exisse '."
,"47":"Videns autem mulier quia non latuit, tremens venit et procidit ante eum et ob quam causam tetigerit eum indicavit coram omni populo et quemadmodum confestim sanata sit."
,"48":"At ipse dixit illi: ' Filia, fides tua te salvam fecit. Vade in pace '."
,"49":"Adhuc illo loquente, venit quidam e domo principis synagogae dicens: ' Mortua est filia tua; noli amplius vexare magistrum '."
,"50":"Iesus autem, audito hoc verbo, respondit ei: ' Noli timere; crede tantum, et salva erit '."
,"51":"Et cum venisset domum, non permisit intrare secum quemquam nisi Petrum et Ioannem et Iacobum et patrem puellae et matrem."
,"52":"Flebant autem omnes et plangebant illam. At ille dixit: ' Nolite flere; non est enim mortua, sed dormit '."
,"53":"Et deridebant eum scientes quia mortua esset."
,"54":"Ipse autem tenens manum eius clamavit dicens: ' Puella, surge! '."
,"55":"Et reversus est spiritus eius, et surrexit continuo; et iussit illi dari manducare."
,"56":"Et stupuerunt parentes eius, quibus praecepit, ne alicui dicerent, quod factum erat."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Convocatis autem Duodecim, dedit illis virtutem et potesta tem super omnia daemonia, et ut languores curarent,"
,"2":"et misit illos praedicare regnum Dei et sanare infirmos;"
,"3":"et ait ad illos: ' Nihil tuleritis in via, neque virgam neque peram neque panem neque pecuniam, neque duas tunicas habeatis."
,"4":"Et in quamcumque domum intraveritis, ibi manete et inde exite."
,"5":"Et quicumque non receperint vos, exeuntes de civitate illa pulverem pedum vestrorum excutite in testimonium supra illos '."
,"6":"Egressi autem circumibant per castella evangelizantes et curantes ubique."
,"7":"Audivit autem Herodes tetrarcha omnia, quae fiebant, et haesitabat, eo quod diceretur a quibusdam: ' Ioannes surrexit a mortuis ';"
,"8":"a quibusdam vero: ' Elias apparuit '; ab aliis autem: ' Propheta unus de antiquis surrexit '."
,"9":"Et ait Herodes: ' Ioannem ego decollavi; quis autem est iste, de quo audio ego talia? '. Et quaerebat videre eum."
,"10":"Et reversi apostoli narraverunt illi, quaecumque fecerunt. Et assumptis illis, secessit seorsum ad civitatem, quae vocatur Bethsaida."
,"11":"Quod cum cognovissent turbae, secutae sunt illum. Et excepit illos et loquebatur illis de regno Dei et eos, qui cura indigebant, sanabat."
,"12":"Dies autem coeperat declinare; et accedentes Duodecim dixerunt illi: ' Dimitte turbam, ut euntes in castella villasque, quae circa sunt, divertant et inveniant escas, quia hic in loco deserto sumus '."
,"13":"Ait autem ad illos: ' Vos date illis manducare '. At illi dixerunt: ' Non sunt nobis plus quam quinque panes et duo pisces, nisi forte nos eamus et emamus in omnem hanc turbam escas '."
,"14":"Erant enim fere viri quinque milia. Ait autem ad discipulos suos: ' Facite illos discumbere per convivia ad quinquagenos '."
,"15":"Et ita fecerunt et discumbere fecerunt omnes."
,"16":"Acceptis autem quinque panibus et duobus piscibus, respexit in caelum et benedixit illis et fregit et dabat discipulis suis, ut ponerent ante turbam."
,"17":"Et manducaverunt et saturati sunt omnes; et sublatum est, quod superfuit illis, fragmentorum cophini duodecim."
,"18":"Et factum est, cum solus esset orans, erant cum illo discipuli, et interrogavit illos dicens: ' Quem me dicunt esse turbae? '."
,"19":"At illi responderunt et dixerunt: ' Ioannem Baptistam, alii autem Eliam, alii vero: Propheta unus de prioribus surrexit '."
,"20":"Dixit autem illis: ' Vos autem quem me esse dicitis? '. Respondens Petrus dixit: ' Christum Dei '."
,"21":"At ille increpans illos praecepit, ne cui dicerent hoc,"
,"22":"dicens: ' Oportet Filium hominis multa pati et reprobari a senioribus et principibus sacerdotum et scribis et occidi et tertia die resurgere '."
,"23":"Dicebat autem ad omnes: ' Si quis vult post me venire, abneget semetipsum et tollat crucem suam cotidie et sequatur me."
,"24":"Qui enim voluerit animam suam salvam facere, perdet illam; qui autem perdiderit animam suam propter me, hic salvam faciet illam."
,"25":"Quid enim proficit homo, si lucretur universum mundum, se autem ipsum perdat vel detrimentum sui faciat?"
,"26":"Nam qui me erubuerit et meos sermones, hunc Filius hominis erubescet, cum venerit in gloria sua et Patris et sanctorum angelorum."
,"27":"Dico autem vobis vere: Sunt aliqui hic stantes, qui non gustabunt mortem, donec videant regnum Dei '."
,"28":"Factum est autem post haec verba fere dies octo, et assumpsit Petrum et Ioannem et Iacobum et ascendit in montem, ut oraret."
,"29":"Et facta est, dum oraret, species vultus eius altera, et vestitus eius albus, refulgens."
,"30":"Et ecce duo viri loquebantur cum illo, et erant Moyses et Elias,"
,"31":"qui visi in gloria dicebant exodum eius, quam completurus erat in Ierusalem."
,"32":"Petrus vero et qui cum illo gravati erant somno; et evigilantes viderunt gloriam eius et duos viros, qui stabant cum illo."
,"33":"Et factum est, cum discederent ab illo, ait Petrus ad Iesum: ' Praeceptor, bonum est nos hic esse; et faciamus tria tabernacula: unum tibi et unum Moysi et unum Eliae ', nesciens quid diceret."
,"34":"Haec autem illo loquente, facta est nubes et obumbravit eos; et timuerunt intrantibus illis in nubem."
,"35":"Et vox facta est de nube dicens: ' Hic est Filius meus electus; ipsum audite '."
,"36":"Et dum fieret vox, inventus est Iesus solus. Et ipsi tacuerunt et nemini dixerunt in illis diebus quidquam ex his, quae viderant."
,"37":"Factum est autem in sequenti die, descendentibus illis de monte, occurrit illi turba multa."
,"38":"Et ecce vir de turba exclamavit dicens: ' Magister, obsecro te, respice in filium meum, quia unicus est mihi;"
,"39":"et ecce spiritus apprehendit illum, et subito clamat, et dissipat eum cum spuma et vix discedit ab eo dilanians eum;"
,"40":"et rogavi discipulos tuos, ut eicerent illum, et non potuerunt '."
,"41":"Respondens autem Iesus dixit: ' O generatio infidelis et perversa, usquequo ero apud vos et patiar vos? Adduc huc filium tuum '."
,"42":"Et cum accederet, elisit illum daemonium et dissipavit. Et increpavit Iesus spiritum immundum et sanavit puerum et reddidit illum patri eius."
,"43":"Stupebant autem omnes in magnitudine Dei. Omnibusque mirantibus in omnibus, quae faciebat, dixit ad discipulos suos: "
,"44":"' Ponite vos in auribus vestris sermones istos: Filius enim hominis futurum est ut tradatur in manus hominum '."
,"45":"At illi ignorabant verbum istud, et erat velatum ante eos, ut non sentirent illud, et time bant interrogare eum de hoc verbo."
,"46":"Intravit autem cogitatio in eos, quis eorum maior esset."
,"47":"At Iesus sciens cogitationem cordis illorum, apprehendens puerum statuit eum secus se"
,"48":"et ait illis: ' Quicumque susceperit puerum istum in nomine meo, me recipit; et, quicumque me receperit, recipit eum, qui me misit; nam qui minor est inter omnes vos, hic maior est '."
,"49":"Respondens autem Ioannes dixit: ' Praeceptor, vidimus quendam in nomine tuo eicientem daemonia et prohibuimus eum, quia non sequitur nobiscum '."
,"50":"Et ait ad illum Iesus: ' Nolite prohibere; qui enim non est adversus vos, pro vobis est '."
,"51":"Factum est autem, dum complerentur dies assumptionis eius, et ipse faciem suam firmavit, ut iret Ierusalem,"
,"52":"et misit nuntios ante conspectum suum. Et euntes intraverunt in castellum Samaritanorum, ut pararent illi."
,"53":"Et non receperunt eum, quia facies eius erat euntis Ierusalem."
,"54":"Cum vidissent autem discipuli Iacobus et Ioannes, dixerunt: ' Domine, vis dicamus, ut ignis descendat de caelo et consumat illos? '."
,"55":"Et conversus increpavit illos."
,"56":"Et ierunt in aliud castellum."
,"57":"Et euntibus illis in via, dixit quidam ad illum: ' Sequar te, quocumque ieris '."
,"58":"Et ait illi Iesus: ' Vulpes foveas habent, et volucres caeli nidos, Filius autem hominis non habet, ubi caput reclinet '."
,"59":"Ait autem ad alterum: ' Sequere me '. Ille autem dixit: ' Domine, permitte mihi primum ire et sepelire patrem meum '."
,"60":"Dixitque ei Iesus: ' Sine, ut mortui sepeliant mortuos suos; tu autem vade, annuntia regnum Dei '."
,"61":"Et ait alter: ' Sequar te, Domine, sed primum permitte mihi renuntiare his, qui domi sunt '."
,"62":"Ait ad illum Iesus: ' Nemo mittens manum suam in aratrum et aspiciens retro, aptus est regno Dei '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Post haec autem designavit Dominus alios septuaginta duos et misit illos binos ante faciem suam in omnem civitatem et locum, quo erat ipse venturus."
,"2":"Et dicebat illis: ' Messis quidem multa, operarii autem pauci; rogate ergo Dominum messis, ut mittat operarios in messem suam."
,"3":"Ite; ecce ego mitto vos sicut agnos inter lupos."
,"4":"Nolite portare sacculum neque peram neque calceamenta et neminem per viam salutaveritis."
,"5":"In quamcumque domum intraveritis, primum dicite: 'Pax huic domui'."
,"6":"Et si ibi fuerit filius pacis, requiescet super illam pax vestra; sin autem, ad vos revertetur."
,"7":"In eadem autem domo manete edentes et bibentes, quae apud illos sunt: dignus enim est operarius mercede sua. Nolite transire de domo in domum."
,"8":"Et in quamcumque civitatem intraveritis, et susceperint vos, manducate, quae apponuntur vobis,"
,"9":"et curate infirmos, qui in illa sunt, et dicite illis: 'Appropinquavit in vos regnum Dei'."
,"10":"In quamcumque civitatem intraveritis, et non receperint vos, exeuntes in plateas eius dicite:"
,"11":"'Etiam pulverem, qui adhaesit nobis ad pedes de civitate vestra, extergimus in vos; tamen hoc scitote, quia appropinquavit regnum Dei'."
,"12":"Dico vobis quia Sodomis in die illa remissius erit quam illi civitati."
,"13":"Vae tibi, Chorazin! Vae tibi, Bethsaida! Quia si in Tyro et Sidone factae fuissent virtutes, quae in vobis factae sunt, olim in cilicio et cinere sedentes paeniterent."
,"14":"Verumtamen Tyro et Sidoni remissius erit in iudicio quam vobis."
,"15":"Et tu, Capharnaum, numquid usque in caelum exaltaberis? Usque ad infernum demergeris!"
,"16":"Qui vos audit, me audit; et, qui vos spernit, me spernit; qui autem me spernit, spernit eum, qui me misit '."
,"17":"Reversi sunt autem septuaginta duo cum gaudio dicentes: ' Domine, etiam daemonia subiciuntur nobis in nomine tuo! '."
,"18":"Et ait illis: ' Videbam Satanam sicut fulgur de caelo cadentem."
,"19":"Ecce dedi vobis potestatem calcandi supra serpentes et scorpiones et supra omnem virtutem inimici; et nihil vobis nocebit."
,"20":"Verumtamen in hoc nolite gaudere, quia spiritus vobis subiciuntur; gaudete autem quod nomina vestra scripta sunt in caelis '."
,"21":"In ipsa hora exsultavit Spiritu Sancto et dixit: ' Confiteor tibi, Pater, Domine caeli et terrae, quod abscondisti haec a sapientibus et prudentibus et revelasti ea parvulis; etiam, Pater, quia sic placuit ante te."
,"22":"Omnia mihi tradita sunt a Patre meo; et nemo scit qui sit Filius, nisi Pater, et qui sit Pater, nisi Filius et cui voluerit Filius revelare '."
,"23":"Et conversus ad discipulos seorsum dixit: ' Beati oculi, qui vident, quae videtis."
,"24":"Dico enim vobis: Multi prophetae et reges voluerunt videre, quae vos videtis, et non viderunt, et audire, quae auditis, et non audierunt '."
,"25":"Et ecce quidam legis peritus surrexit tentans illum dicens: ' Magister, quid faciendo vitam aeternam possidebo? '."
,"26":"At ille dixit ad eum: ' In Lege quid scriptum est? Quomodo legis? '."
,"27":"Ille autem respondens dixit: ' Diliges Dominum Deum tuum ex toto corde tuo et ex tota anima tua et ex omnibus viribus tuis et ex omni mente tua et proximum tuum sicut teipsum '."
,"28":"Dixitque illi: ' Recte respondisti; hoc fac et vives '."
,"29":"Ille autem, volens iustificare seipsum, dixit ad Iesum: ' Et quis est meus proximus? '."
,"30":"Suscipiens autem Iesus dixit: ' Homo quidam descendebat ab Ierusalem in Iericho et incidit in latrones, qui etiam despoliaverunt eum et, plagis impositis, abierunt, semivivo relicto."
,"31":"Accidit autem, ut sacerdos quidam descenderet eadem via et, viso illo, praeterivit;"
,"32":"similiter et Levita, cum esset secus locum et videret eum, pertransiit."
,"33":"Samaritanus autem quidam iter faciens, venit secus eum et videns eum misericordia motus est,"
,"34":"et appropians alligavit vulnera eius infundens oleum et vinum; et imponens illum in iumentum suum duxit in stabulum et curam eius egit."
,"35":"Et altera die protulit duos denarios et dedit stabulario et ait: 'Curam illius habe, et, quodcumque supererogaveris, ego, cum rediero, reddam tibi'."
,"36":"Quis horum trium videtur tibi proximus fuisse illi, qui incidit in latrones? '."
,"37":"At ille dixit: ' Qui fecit misericordiam in illum '. Et ait illi Iesus: ' Vade et tu fac similiter '."
,"38":"Cum autem irent, ipse intravit in quoddam castellum, et mulier quaedam Martha nomine excepit illum."
,"39":"Et huic erat soror nomine Maria, quae etiam sedens secus pedes Domini audiebat verbum illius."
,"40":"Martha autem satagebat circa frequens ministerium; quae stetit et ait: ' Domine, non est tibi curae quod soror mea reliquit me solam ministrare? Dic ergo illi, ut me adiuvet '."
,"41":"Et respondens dixit illi Dominus: ' Martha, Martha, sollicita es et turbaris erga plurima,"
,"42":"porro unum est necessarium; Maria enim optimam partem elegit, quae non auferetur ab ea '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et factum est cum esset in loco quodam orans, ut cessa vit, dixit unus ex discipulis eius ad eum: ' Domine, doce nos orare, sicut et Ioannes docuit discipulos suos '."
,"2":"Et ait illis: ' Cum oratis, dicite: Pater, sanctificetur nomen tuum, adveniat regnum tuum;"
,"3":"panem nostrum cotidianum da nobis cotidie,"
,"4":"et dimitte nobis peccata nostra, si quidem et ipsi dimittimus omni debenti nobis, et ne nos inducas in tentationem '."
,"5":"Et ait ad illos: ' Quis vestrum habebit amicum et ibit ad illum media nocte et dicet illi: 'Amice, commoda mihi tres panes,"
,"6":"quoniam amicus meus venit de via ad me, et non habeo, quod ponam ante illum';"
,"7":"et ille de intus respondens dicat: 'Noli mihi molestus esse; iam ostium clausum est, et pueri mei mecum sunt in cubili; non possum surgere et dare tibi'."
,"8":"Dico vobis: Et si non dabit illi surgens, eo quod amicus eius sit, propter improbitatem tamen eius surget et dabit illi, quotquot habet necessarios."
,"9":"Et ego vobis dico: Petite, et dabitur vobis; quaerite, et invenietis; pulsate, et aperietur vobis."
,"10":"Omnis enim qui petit, accipit; et, qui quaerit, invenit; et pulsanti aperietur."
,"11":"Quem autem ex vobis patrem filius petierit piscem, numquid pro pisce serpentem dabit illi?"
,"12":"Aut si petierit ovum, numquid porriget illi scorpionem?"
,"13":"Si ergo vos, cum sitis mali, nostis dona bona dare filiis vestris, quanto magis Pater de caelo dabit Spiritum Sanctum petentibus se '."
,"14":"Et erat eiciens daemonium, et illud erat mutum; et factum est, cum daemonium exisset, locutus est mutus. Et admiratae sunt turbae;"
,"15":"quidam autem ex eis dixerunt: ' In Beelzebul principe daemoniorum eicit daemonia '."
,"16":"Et alii tentantes signum de caelo quaerebant ab eo."
,"17":"Ipse autem sciens cogitationes eorum dixit eis: ' Omne regnum in seipsum divisum desolatur, et domus supra domum cadit."
,"18":"Si autem et Satanas in seipsum divisus est, quomodo stabit regnum ipsius? Quia dicitis in Beelzebul eicere me daemonia."
,"19":"Si autem ego in Beelzebul eicio daemonia, filii vestri in quo eiciunt? Ideo ipsi iudices vestri erunt."
,"20":"Porro si in digito Dei eicio daemonia, profecto pervenit in vos regnum Dei."
,"21":"Cum fortis armatus custodit atrium suum, in pace sunt ea, quae possidet;"
,"22":"si autem fortior illo superveniens vicerit eum, universa arma eius auferet, in quibus confidebat, et spolia eius distribuet."
,"23":"Qui non est mecum, adversum me est; et, qui non colligit mecum, dispergit."
,"24":"Cum immundus spiritus exierit de homine, perambulat per loca inaquosa quaerens requiem; et non inveniens dicit: 'Revertar in domum meam unde exivi'."
,"25":"Et cum venerit, invenit scopis mundatam et exornatam."
,"26":"Et tunc vadit et assumit septem alios spiritus nequiores se, et ingressi habitant ibi; et sunt novissima hominis illius peiora prioribus '."
,"27":"Factum est autem, cum haec diceret, extollens vocem quaedam mulier de turba dixit illi: ' Beatus venter, qui te portavit, et ubera, quae suxisti! '."
,"28":"At ille dixit: ' Quinimmo beati, qui audiunt verbum Dei et custodiunt! '."
,"29":"Turbis autem concurrentibus, coepit dicere: ' Generatio haec generatio nequam est; signum quaerit, et signum non dabitur illi, nisi signum Ionae."
,"30":"Nam sicut Ionas fuit signum Ninevitis, ita erit et Filius hominis generationi isti."
,"31":"Regina austri surget in iudicio cum viris generationis huius et condemnabit illos, quia venit a finibus terrae audire sapientiam Salomonis, et ecce plus Salomone hic."
,"32":"Viri Ninevitae surgent in iudicio cum generatione hac et condemnabunt illam, quia paenitentiam egerunt ad praedicationem Ionae, et ecce plus Iona hic."
,"33":"Nemo lucernam accendit et in abscondito ponit neque sub modio sed supra candelabrum, ut, qui ingrediuntur, lumen videant."
,"34":"Lucerna corporis est oculus tuus. Si oculus tuus fuerit simplex, totum corpus tuum lucidum erit; si autem nequam fuerit, etiam corpus tuum tenebrosum erit."
,"35":"Vide ergo, ne lumen, quod in te est, tenebrae sint."
,"36":"Si ergo corpus tuum totum lucidum fuerit non habens aliquam partem tenebrarum, erit lucidum totum, sicut quando lucerna in fulgore suo illuminat te '."
,"37":"Et cum loqueretur, rogavit illum quidam pharisaeus, ut pranderet apud se; et ingressus recubuit."
,"38":"Pharisaeus autem videns miratus est quod non baptizatus esset ante prandium."
,"39":"Et ait Dominus ad illum: ' Nunc vos pharisaei, quod de foris est calicis et catini, mundatis; quod autem intus est vestrum, plenum est rapina et iniquitate."
,"40":"Stulti! Nonne, qui fecit, quod de foris est, etiam id, quod de intus est, fecit?"
,"41":"Verumtamen, quae insunt, date eleemosynam; et ecce omnia munda sunt vobis."
,"42":"Sed vae vobis pharisaeis, quia decimatis mentam et rutam et omne holus et praeteritis iudicium et caritatem Dei! Haec autem oportuit facere et illa non omittere."
,"43":"Vae vobis pharisaeis, quia diligitis primam cathedram in synagogis et salutationes in foro!"
,"44":"Vae vobis, quia estis ut monumenta, quae non parent, et homines ambulantes supra nesciunt! '."
,"45":"Respondens autem quidam ex legis peritis ait illi: ' Magister, haec dicens etiam nobis contumeliam facis '."
,"46":"At ille ait: ' Et vobis legis peritis: Vae, quia oneratis homines oneribus, quae portari non possunt, et ipsi uno digito vestro non tangitis sarcinas!"
,"47":"Vae vobis, quia aedificatis monumenta prophetarum, patres autem vestri occiderunt illos!"
,"48":"Profecto testificamini et consentitis operibus patrum vestrorum, quoniam ipsi quidem eos occiderunt, vos autem aedificatis."
,"49":"Propterea et sapientia Dei dixit: Mittam ad illos prophetas et apostolos, et ex illis occident et persequentur,"
,"50":"ut requiratur sanguis omnium prophetarum, qui effusus est a constitutione mundi, a generatione ista,"
,"51":"a sanguine Abel usque ad sanguinem Zachariae, qui periit inter altare et aedem. Ita dico vobis: Requiretur ab hac generatione."
,"52":"Vae vobis legis peritis, quia tulistis clavem scientiae! Ipsi non introistis et eos, qui introibant, prohibuistis '."
,"53":"Cum autem inde exisset, coeperunt scribae et pharisaei graviter insistere et eum allicere in sermone de multis"
,"54":"insidiantes ei, ut caperent aliquid ex ore eius."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Interea multis turbis cir cumstantibus, ita ut se invi cem conculcarent, coepit dicere ad discipulos suos primum: ' Attendite a fermento pharisaeorum, quod est hypocrisis."
,"2":"Nihil autem opertum est, quod non reveletur, neque absconditum, quod non sciatur."
,"3":"Quoniam, quae in tenebris dixistis, in lumine audientur; et, quod in aurem locuti estis in cubiculis, praedicabitur in tectis."
,"4":"Dico autem vobis amicis meis: Ne terreamini ab his, qui occidunt corpus et post haec non habent amplius, quod faciant."
,"5":"Ostendam autem vobis quem timeatis: Timete eum, qui postquam occiderit, habet potestatem mittere in gehennam. Ita dico vobis: Hunc timete."
,"6":"Nonne quinque passeres veneunt dipundio? Et unus ex illis non est in oblivione coram Deo."
,"7":"Sed et capilli capitis vestri omnes numerati sunt. Nolite timere; multis passeribus pluris estis."
,"8":"Dico autem vobis: Omnis, quicumque confessus fuerit in me coram hominibus, et Filius hominis confitebitur in illo coram angelis Dei;"
,"9":"qui autem negaverit me coram hominibus, denegabitur coram angelis Dei."
,"10":"Et omnis, qui dicet verbum in Filium hominis, remittetur illi; ei autem, qui in Spiritum Sanctum blasphemaverit, non remittetur."
,"11":"Cum autem inducent vos in synagogas et ad magistratus et potestates, nolite solliciti esse qualiter aut quid respondeatis aut quid dicatis:"
,"12":"Spiritus enim Sanctus docebit vos in ipsa hora, quae oporteat dicere '."
,"13":"Ait autem quidam ei de turba: ' Magister, dic fratri meo, ut dividat mecum hereditatem '."
,"14":"At ille dixit ei: ' Homo, quis me constituit iudicem aut divisorem super vos? '."
,"15":"Dixitque ad illos: ' Videte et cavete ab omni avaritia, quia si cui res abundant, vita eius non est ex his, quae possidet '."
,"16":"Dixit autem similitudinem ad illos dicens: ' Hominis cuiusdam divitis uberes fructus ager attulit."
,"17":"Et cogitabat intra se dicens: 'Quid faciam, quod non habeo, quo congregem fructus meos?'."
,"18":"Et dixit: 'Hoc faciam: destruam horrea mea et maiora aedificabo et illuc congregabo omne triticum et bona mea;"
,"19":"et dicam animae meae: Anima, habes multa bona posita in annos plurimos; requiesce, comede, bibe, epulare'."
,"20":"Dixit autem illi Deus: 'Stulte! Hac nocte animam tuam repetunt a te; quae autem parasti, cuius erunt?'."
,"21":"Sic est qui sibi thesaurizat et non fit in Deum dives '."
,"22":"Dixitque ad discipulos suos: ' Ideo dico vobis: nolite solliciti esse animae quid manducetis, neque corpori quid vestiamini."
,"23":"Anima enim plus est quam esca, et corpus quam vestimentum."
,"24":"Considerate corvos, quia non seminant neque metunt, quibus non est cellarium neque horreum, et Deus pascit illos; quanto magis vos pluris estis volucribus."
,"25":"Quis autem vestrum cogitando potest adicere ad aetatem suam cubitum?"
,"26":"Si ergo neque, quod minimum est, potestis, quid de ceteris solliciti estis?"
,"27":"Considerate lilia quomodo crescunt: non laborant neque nent; dico autem vobis: Nec Salomon in omni gloria sua vestiebatur sicut unum ex istis."
,"28":"Si autem fenum, quod hodie in agro est et cras in clibanum mittitur, Deus sic vestit, quanto magis vos, pusillae fidei."
,"29":"Et vos nolite quaerere quid manducetis aut quid bibatis et nolite solliciti esse."
,"30":"Haec enim omnia gentes mundi quaerunt; Pater autem vester scit quoniam his indigetis."
,"31":"Verumtamen quaerite regnum eius; et haec adicientur vobis."
,"32":"Noli timere, pusillus grex, quia complacuit Patri vestro dare vobis regnum."
,"33":"Vendite, quae possidetis, et date eleemosynam. Facite vobis sacculos, qui non veterescunt, thesaurum non deficientem in caelis, quo fur non appropiat, neque tinea corrumpit;"
,"34":"ubi enim thesaurus vester est, ibi et cor vestrum erit."
,"35":"Sint lumbi vestri praecincti et lucernae ardentes,"
,"36":"et vos similes hominibus exspectantibus dominum suum, quando revertatur a nuptiis, ut, cum venerit et pulsaverit, confestim aperiant ei."
,"37":"Beati, servi illi, quos, cum venerit dominus, invenerit vigilantes. Amen dico vobis, quod praecinget se et faciet illos discumbere et transiens ministrabit illis."
,"38":"Et si venerit in secunda vigilia, et si in tertia vigilia venerit, et ita invenerit, beati sunt illi."
,"39":"Hoc autem scitote, quia, si sciret pater familias, qua hora fur veniret, non sineret perfodi domum suam."
,"40":"Et vos estote parati, quia, qua hora non putatis, Filius hominis venit '."
,"41":"Ait autem Petrus: ' Domine, ad nos dicis hanc parabolam an et ad omnes? '."
,"42":"Et dixit Dominus: ' Quis putas est fidelis dispensator et prudens, quem constituet dominus super familiam suam, ut det illis in tempore tritici mensuram?"
,"43":"Beatus ille servus, quem, cum venerit dominus eius, invenerit ita facientem."
,"44":"Vere dico vobis: Supra omnia, quae possidet, constituet illum."
,"45":"Quod si dixerit servus ille in corde suo: 'Moram facit dominus meus venire', et coeperit percutere pueros et ancillas et edere et bibere et inebriari,"
,"46":"veniet dominus servi illius in die, qua non sperat, et hora, qua nescit, et dividet eum partemque eius cum infidelibus ponet."
,"47":"Ille autem servus, qui cognovit voluntatem domini sui et non praeparavit vel non fecit secundum voluntatem eius, vapulabit multis;"
,"48":"qui autem non cognovit et fecit digna plagis, vapulabit paucis. Omni autem, cui multum datum est, multum quaeretur ab eo; et cui commendaverunt multum, plus petent ab eo."
,"49":"Ignem veni mittere in terram et quid volo? Si iam accensus esset!"
,"50":"Baptisma autem habeo baptizari et quomodo coartor, usque dum perficiatur!"
,"51":"Putatis quia pacem veni dare in terram? Non, dico vobis, sed separationem."
,"52":"Erunt enim ex hoc quinque in domo una divisi: tres in duo, et duo in tres;"
,"53":"dividentur pater in filium et filius in patrem, mater in filiam et filia in matrem, socrus in nurum suam et nurus in socrum '."
,"54":"Dicebat autem et ad turbas: ' Cum videritis nubem orientem ab occasu, statim dicitis: 'Nimbus venit', et ita fit;"
,"55":"et cum austrum flantem, dicitis: 'Aestus erit', et fit."
,"56":"Hypocritae, faciem terrae et caeli nostis probare, hoc autem tempus quomodo nescitis probare?"
,"57":"Quid autem et a vobis ipsis non iudicatis, quod iustum est?"
,"58":"Cum autem vadis cum adversario tuo ad principem, in via da operam liberari ab illo, ne forte trahat te apud iudicem, et iudex tradat te exactori, et exactor mittat te in carcerem."
,"59":"Dico tibi: Non exies inde, donec etiam novissimum minutum reddas '."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Aderant autem quidam ipso in tempore nuntiantes illi de Galilaeis, quorum sanguinem Pilatus miscuit cum sacrificiis eorum."
,"2":"Et respondens dixit illis: ' Putatis quod hi Galilaei prae omnibus Galilaeis peccatores fuerunt, quia talia passi sunt?"
,"3":"Non, dico vobis, sed, nisi paenitentiam egeritis, omnes similiter peribitis."
,"4":"Vel illi decem et octo, supra quos cecidit turris in Siloam et occidit eos, putatis quia et ipsi debitores fuerunt praeter omnes homines habitantes in Ierusalem?"
,"5":"Non, dico vobis, sed, si non paenitentiam egeritis, omnes similiter peribitis '."
,"6":"Dicebat autem hanc similitudinem: ' Arborem fici habebat quidam plantatam in vinea sua et venit quaerens fructum in illa et non invenit."
,"7":"Dixit autem ad cultorem vineae: 'Ecce anni tres sunt, ex quo venio quaerens fructum in ficulnea hac et non invenio. Succide ergo illam. Ut quid etiam terram evacuat?'."
,"8":"At ille respondens dicit illi: 'Domine, dimitte illam et hoc anno, usque dum fodiam circa illam et mittam stercora,"
,"9":"et si quidem fecerit fructum in futurum; sin autem succides eam' '."
,"10":"Erat autem docens in una synagogarum sabbatis."
,"11":"Et ecce mulier, quae habebat spiritum infirmitatis annis decem et octo et erat inclinata nec omnino poterat sursum respicere."
,"12":"Quam cum vidisset Iesus, vocavit et ait illi: ' Mulier, dimissa es ab infirmitate tua ',"
,"13":"et imposuit illi manus; et confestim erecta est et glorificabat Deum."
,"14":"Respondens autem archisynagogus, indignans quia sabbato curasset Iesus, dicebat turbae: ' Sex dies sunt, in quibus oportet operari; in his ergo venite et curamini et non in die sabbati '."
,"15":"Respondit autem ad illum Dominus et dixit: ' Hypocritae, unusquisque vestrum sabbato non solvit bovem suum aut asinum a praesepio et ducit adaquare?"
,"16":"Hanc autem filiam Abrahae, quam alligavit Satanas ecce decem et octo annis, non oportuit solvi a vinculo isto die sabbati? '."
,"17":"Et cum haec diceret, erubescebant omnes adversarii eius, et omnis populus gaudebat in universis, quae gloriose fiebant ab eo."
,"18":"Dicebat ergo: ' Cui simile est regnum Dei, et cui simile existimabo illud?"
,"19":"Simile est grano sinapis, quod acceptum homo misit in hortum suum, et crevit et factum est in arborem, et volucres caeli requieverunt in ramis eius '."
,"20":"Et iterum dixit: ' Cui simile aestimabo regnum Dei?"
,"21":"Simile est fermento, quod acceptum mulier abscondit in farinae sata tria, donec fermentaretur totum '."
,"22":"Et ibat per civitates et castella docens et iter faciens in Hierosolymam."
,"23":"Ait autem illi quidam: ' Domine, pauci sunt, qui salvantur? '. Ipse autem dixit ad illos:"
,"24":"' Contendite intrare per angustam portam, quia multi, dico vobis, quaerent intrare et non poterunt."
,"25":"Cum autem surrexerit pater familias et clauserit ostium, et incipietis foris stare et pulsare ostium dicentes: 'Domine, aperi nobis'; et respondens dicet vobis: 'Nescio vos unde sitis'."
,"26":"Tunc incipietis dicere: 'Manducavimus coram te et bibimus, et in plateis nostris docuisti';"
,"27":"et dicet loquens vobis: 'Nescio vos unde sitis; discedite a me, omnes operarii iniquitatis'."
,"28":"Ibi erit fletus et stridor dentium, cum videritis Abraham et Isaac et Iacob et omnes prophetas in regno Dei, vos autem expelli foras."
,"29":"Et venient ab oriente et occidente et aquilone et austro et accumbent in regno Dei."
,"30":"Et ecce sunt novissimi, qui erunt primi, et sunt primi, qui erunt novissimi '."
,"31":"In ipsa hora accesserunt quidam pharisaeorum dicentes illi: ' Exi et vade hinc, quia Herodes vult te occidere '."
,"32":"Et ait illis: ' Ite, dicite vulpi illi: 'Ecce eicio daemonia et sanitates perficio hodie et cras et tertia consummor."
,"33":"Verumtamen oportet me hodie et cras et sequenti ambulare, quia non capit prophetam perire extra Ierusalem'."
,"34":"Ierusalem, Ierusalem, quae occidis prophetas et lapidas eos, qui missi sunt ad te, quotiens volui congregare filios tuos, quemadmodum avis nidum suum sub pinnis, et noluistis."
,"35":"Ecce relinquitur vobis domus vestra. Dico autem vobis: Non videbitis me, donec veniat cum dicetis: 'Benedictus, qui venit in nomine Domini' '."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Et factum est, cum intraret in domum cuiusdam princi pis pharisaeorum sabbato manducare panem, et ipsi observabant eum."
,"2":"Et ecce homo quidam hydropicus erat ante illum."
,"3":"Et respondens Iesus dixit ad legis peritos et pharisaeos dicens: ' Licet sabbato curare an non? '."
,"4":"At illi tacuerunt. Ipse vero apprehensum sanavit eum ac dimisit."
,"5":"Et ad illos dixit: ' Cuius vestrum filius aut bos in puteum cadet, et non continuo extrahet illum die sabbati? '."
,"6":"Et non poterant ad haec respondere illi."
,"7":"Dicebat autem ad invitatos parabolam, intendens quomodo primos accubitus eligerent, dicens ad illos:"
,"8":"' Cum invitatus fueris ab aliquo ad nuptias, non discumbas in primo loco, ne forte honoratior te sit invitatus ab eo,"
,"9":"et veniens is qui te et illum vocavit, dicat tibi: 'Da huic locum'; et tunc incipias cum rubore novissimum locum tenere."
,"10":"Sed cum vocatus fueris, vade, recumbe in novissimo loco, ut, cum venerit qui te invitavit, dicat tibi: 'Amice, ascende superius'; tunc erit tibi gloria coram omnibus simul discumbentibus."
,"11":"Quia omnis, qui se exaltat, humiliabitur; et, qui se humiliat, exaltabitur '."
,"12":"Dicebat autem et ei, qui se invitaverat: ' Cum facis prandium aut cenam, noli vocare amicos tuos neque fratres tuos neque cognatos neque vicinos divites, ne forte et ipsi te reinvitent, et fiat tibi retributio."
,"13":"Sed cum facis convivium, voca pauperes, debiles, claudos, caecos;"
,"14":"et beatus eris, quia non habent retribuere tibi. Retribuetur enim tibi in resurrectione iustorum '."
,"15":"Haec cum audisset quidam de simul discumbentibus, dixit illi: ' Beatus, qui manducabit panem in regno Dei '."
,"16":"At ipse dixit ei: ' Homo quidam fecit cenam magnam et vocavit multos;"
,"17":"et misit servum suum hora cenae dicere invitatis: 'Venite, quia iam paratum est'."
,"18":"Et coeperunt simul omnes excusare. Primus dixit ei: 'Villam emi et necesse habeo exire et videre illam; rogo te, habe me excusatum'."
,"19":"Et alter dixit: 'Iuga boum emi quinque et eo probare illa; rogo te, habe me excusatum'."
,"20":"Et alius dixit: 'Uxorem duxi et ideo non possum venire'."
,"21":"Et reversus servus nuntiavit haec domino suo. Tunc iratus pater familias dixit servo suo: 'Exi cito in plateas et vicos civitatis et pauperes ac debiles et caecos et claudos introduc huc'."
,"22":"Et ait servus: 'Domine, factum est, ut imperasti, et adhuc locus est'."
,"23":"Et ait dominus servo: 'Exi in vias et saepes, et compelle intrare, ut impleatur domus mea."
,"24":"Dico autem vobis, quod nemo virorum illorum, qui vocati sunt, gustabit cenam meam' '."
,"25":"Ibant autem turbae multae cum eo; et conversus dixit ad illos:"
,"26":"' Si quis venit ad me et non odit patrem suum et matrem et uxorem et filios et fratres et sorores, adhuc et animam suam, non potest esse meus discipulus."
,"27":"Et, qui non baiulat crucem suam et venit post me, non potest esse meus discipulus."
,"28":"Quis enim ex vobis volens turrem aedificare, non prius sedens computat sumptus, si habet ad perficiendum?"
,"29":"Ne, posteaquam posuerit fundamentum et non potuerit perficere, omnes, qui vident, incipiant illudere ei"
,"30":"dicentes: 'Hic homo coepit aedificare et non potuit consummare'."
,"31":"Aut quis rex, iturus committere bellum adversus alium regem, non sedens prius cogitat, si possit cum decem milibus occurrere ei, qui cum viginti milibus venit ad se?"
,"32":"Alioquin, adhuc illo longe agente, legationem mittens rogat ea, quae pacis sunt."
,"33":"Sic ergo omnis ex vobis, qui non renuntiat omnibus, quae possidet, non potest meus esse discipulus."
,"34":"Bonum est sal; si autem sal quoque evanuerit, in quo condietur?"
,"35":"Neque in terram neque in sterquilinium utile est, sed foras proiciunt illud. Qui habet aures audiendi, audiat '."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Erant autem appropinquan tes ei omnes publicani et pec catores, ut audirent illum."
,"2":"Et murmurabant pharisaei et scribae dicentes: ' Hic peccatores recipit et manducat cum illis '."
,"3":"Et ait ad illos parabolam istam dicens:"
,"4":"' Quis ex vobis homo, qui habet centum oves et si perdiderit unam ex illis, nonne dimittit nonaginta novem in deserto et vadit ad illam, quae perierat, donec inveniat illam?"
,"5":"Et cum invenerit eam, imponit in umeros suos gaudens"
,"6":"et veniens domum convocat amicos et vicinos dicens illis: 'Congratulamini mihi, quia inveni ovem meam, quae perierat'."
,"7":"Dico vobis: Ita gaudium erit in caelo super uno peccatore paenitentiam agente quam super nonaginta novem iustis, qui non indigent paenitentia."
,"8":"Aut quae mulier habens drachmas decem, si perdiderit drachmam unam, nonne accendit lucernam et everrit domum et quaerit diligenter, donec inveniat?"
,"9":"Et cum invenerit, convocat amicas et vicinas dicens: 'Congratulamini mihi, quia inveni drachmam, quam perdideram'."
,"10":"Ita dico vobis: Gaudium fit coram angelis Dei super uno peccatore paenitentiam agente '."
,"11":"Ait autem: ' Homo quidam habebat duos filios."
,"12":"Et dixit adulescentior ex illis patri: 'Pater, da mihi portionem substantiae, quae me contingit'. Et divisit illis substantiam."
,"13":"Et non post multos dies, congregatis omnibus, adulescentior filius peregre profectus est in regionem longinquam et ibi dissipavit substantiam suam vivendo luxuriose."
,"14":"Et postquam omnia consummasset, facta est fames valida in regione illa, et ipse coepit egere."
,"15":"Et abiit et adhaesit uni civium regionis illius, et misit illum in villam suam, ut pasceret porcos;"
,"16":"et cupiebat saturari de siliquis, quas porci manducabant, et nemo illi dabat."
,"17":"In se autem reversus dixit: 'Quanti mercennarii patris mei abundant panibus, ego autem hic fame pereo."
,"18":"Surgam et ibo ad patrem meum et dicam illi: Pater, peccavi in caelum et coram te"
,"19":"et iam non sum dignus vocari filius tuus; fac me sicut unum de mercennariis tuis'."
,"20":"Et surgens venit ad patrem suum. Cum autem adhuc longe esset, vidit illum pater ipsius et misericordia motus est et accurrens cecidit supra collum eius et osculatus est illum. "
,"21":"Dixitque ei filius: 'Pater, peccavi in caelum et coram te; iam non sum dignus vocari filius tuus'."
,"22":"Dixit autem pater ad servos suos: 'Cito proferte stolam primam et induite illum et date anulum in manum eius et calceamenta in pedes"
,"23":"et adducite vitulum saginatum, occidite et manducemus et epulemur,"
,"24":"quia hic filius meus mortuus erat et revixit, perierat et inventus est'. Et coeperunt epulari."
,"25":"Erat autem filius eius senior in agro et, cum veniret et appropinquaret domui, audivit symphoniam et choros"
,"26":"et vocavit unum de servis et interrogavit quae haec essent."
,"27":"Isque dixit illi: 'Frater tuus venit, et occidit pater tuus vitulum saginatum, quia salvum illum recepit'."
,"28":"Indignatus est autem et nolebat introire. Pater ergo illius egressus coepit rogare illum."
,"29":"At ille respondens dixit patri suo: 'Ecce tot annis servio tibi et numquam mandatum tuum praeterii, et numquam dedisti mihi haedum, ut cum amicis meis epularer;"
,"30":"sed postquam filius tuus hic, qui devoravit substantiam tuam cum meretricibus, venit, occidisti illi vitulum saginatum'."
,"31":"At ipse dixit illi: 'Fili, tu semper mecum es, et omnia mea tua sunt;"
,"32":"epulari autem et gaudere oportebat, quia frater tuus hic mortuus erat et revixit, perierat et inventus est' '."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Dicebat autem et ad disci pulos: ' Homo quidam erat dives, qui habebat vilicum, et hic diffamatus est apud illum quasi dissipasset bona ipsius."
,"2":"Et vocavit illum et ait illi: 'Quid hoc audio de te? Redde rationem vilicationis tuae; iam enim non poteris vilicare'."
,"3":"Ait autem vilicus intra se: 'Quid faciam, quia dominus meus aufert a me vilicationem? Fodere non valeo, mendicare erubesco."
,"4":"Scio quid faciam, ut, cum amotus fuero a vilicatione, recipiant me in domos suas'."
,"5":"Convocatis itaque singulis debitoribus domini sui, dicebat primo: 'Quantum debes domino meo?'."
,"6":"At ille dixit: 'Centum cados olei'. Dixitque illi: 'Accipe cautionem tuam et sede cito, scribe quinquaginta'."
,"7":"Deinde alii dixit: 'Tu vero quantum debes?'. Qui ait: 'Centum coros tritici'. Ait illi: 'Accipe litteras tuas et scribe octoginta'."
,"8":"Et laudavit dominus vilicum iniquitatis, quia prudenter fecisset, quia filii huius saeculi prudentiores filiis lucis in generatione sua sunt."
,"9":"Et ego vobis dico: Facite vobis amicos de mammona iniquitatis, ut, cum defecerit, recipiant vos in aeterna tabernacula."
,"10":"Qui fidelis est in minimo, et in maiori fidelis est; et, qui in modico iniquus est, et in maiori iniquus est."
,"11":"Si ergo in iniquo mammona fideles non fuistis, quod verum est, quis credet vobis?"
,"12":"Et si in alieno fideles non fuistis, quod vestrum est, quis dabit vobis?"
,"13":"Nemo servus potest duobus dominis servire: aut enim unum odiet et alterum diliget, aut uni adhaerebit et alterum contemnet. Non potestis Deo servire et mammonae '."
,"14":"Audiebant autem omnia haec pharisaei, qui erant avari, et deridebant illum."
,"15":"Et ait illis: ' Vos estis, qui iustificatis vos coram hominibus; Deus autem novit corda vestra, quia, quod hominibus altum est, abominatio est ante Deum."
,"16":"Lex et Prophetae usque ad Ioannem; ex tunc regnum Dei evangelizatur, et omnis in illud vim facit."
,"17":"Facilius est autem caelum et terram praeterire, quam de Lege unum apicem cadere."
,"18":"Omnis, qui dimittit uxorem suam et ducit alteram, moechatur; et, qui dimissam a viro ducit, moechatur."
,"19":"Homo quidam erat dives et induebatur purpura et bysso et epulabatur cotidie splendide."
,"20":"Quidam autem pauper nomine Lazarus iacebat ad ianuam eius ulceribus plenus"
,"21":"et cupiens saturari de his, quae cadebant de mensa divitis; sed et canes veniebant et lingebant ulcera eius."
,"22":"Factum est autem ut moreretur pauper et portaretur ab angelis in sinum Abrahae; mortuus est autem et dives et sepultus est."
,"23":"Et in inferno elevans oculos suos, cum esset in tormentis, videbat Abraham a longe et Lazarum in sinu eius."
,"24":"Et ipse clamans dixit: 'Pater Abraham, miserere mei et mitte Lazarum, ut intingat extremum digiti sui in aquam, ut refrigeret linguam meam, quia crucior in hac flamma'."
,"25":"At dixit Abraham: 'Fili, recordare quia recepisti bona tua in vita tua, et Lazarus similiter mala; nunc autem hic consolatur, tu vero cruciaris."
,"26":"Et in his omnibus inter nos et vos chaos magnum firmatum est, ut hi, qui volunt hinc transire ad vos, non possint, neque inde ad nos transmeare'."
,"27":"Et ait: 'Rogo ergo te, Pater, ut mittas eum in domum patris mei"
,"28":"- habeo enim quinque fratres - ut testetur illis, ne et ipsi veniant in locum hunc tormentorum'."
,"29":"Ait autem Abraham: 'Habent Moysen et Prophetas; audiant illos'."
,"30":"At ille dixit: 'Non, pater Abraham, sed si quis ex mortuis ierit ad eos, paenitentiam agent'."
,"31":"Ait autem illi: 'Si Moysen et Prophetas non audiunt, neque si quis ex mortuis resurrexerit, credent' '."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Et ad discipulos suos ait: ' Impossibile est ut non ve niant scandala; vae autem illi, per quem veniunt!"
,"2":"Utilius est illi, si lapis molaris imponatur circa collum eius et proiciatur in mare, quam ut scandalizet unum de pusillis istis."
,"3":"Attendite vobis!,Si peccaverit frater tuus, increpa illum et, si paenitentiam egerit, dimitte illi; "
,"4":"et si septies in die peccaverit in te et septies conversus fuerit ad te dicens: 'Paenitet me', dimittes illi '."
,"5":"Et dixerunt apostoli Domino: ' Adauge nobis fidem! '."
,"6":"Dixit autem Dominus: ' Si haberetis fidem sicut granum sinapis, diceretis huic arbori moro: 'Eradicare et transplantare in mare', et oboediret vobis."
,"7":"Quis autem vestrum habens servum arantem aut pascentem, qui regresso de agro dicet illi: 'Statim transi, recumbe',"
,"8":"et non dicet ei: 'Para, quod cenem, et praecinge te et ministra mihi, donec manducem et bibam, et post haec tu manducabis et bibes'?"
,"9":"Numquid gratiam habet servo illi, quia fecit, quae praecepta sunt?"
,"10":"Sic et vos, cum feceritis omnia, quae praecepta sunt vobis, dicite: 'Servi inutiles sumus; quod debuimus facere, fecimus' '."
,"11":"Et factum est, dum iret in Ierusalem, et ipse transibat per mediam Samariam et Galilaeam."
,"12":"Et cum ingrederetur quoddam castellum, occurrerunt ei decem viri leprosi, qui steterunt a longe"
,"13":"et levaverunt vocem dicentes: ' Iesu praeceptor, miserere nostri! '."
,"14":"Quos ut vidit, dixit: ' Ite, ostendite vos sacerdotibus '. Et factum est, dum irent, mundati sunt."
,"15":"Unus autem ex illis, ut vidit quia sanatus est, regressus est cum magna voce magnificans Deum"
,"16":"et cecidit in faciem ante pedes eius gratias agens ei; et hic erat Samaritanus."
,"17":"Respondens autem Iesus dixit: ' Nonne decem mundati sunt? Et novem ubi sunt?"
,"18":"Non sunt inventi qui redirent, ut darent gloriam Deo, nisi hic alienigena? '."
,"19":"Et ait illi: ' Surge, vade; fides tua te salvum fecit '."
,"20":"Interrogatus autem a pharisaeis: ' Quando venit regnum Dei? ', respondit eis et dixit: ' Non venit regnum Dei cum observatione,"
,"21":"neque dicent: 'Ecce hic' aut: 'Illic'; ecce enim regnum Dei intra vos est '."
,"22":"Et ait ad discipulos: ' Venient dies, quando desideretis videre unum diem Filii hominis et non videbitis."
,"23":"Et dicent vobis: 'Ecce hic', 'Ecce illic'; nolite ire neque sectemini."
,"24":"Nam sicut fulgur coruscans de sub caelo in ea, quae sub caelo sunt, fulget, ita erit Filius hominis in die sua."
,"25":"Primum autem oportet illum multa pati et reprobari a generatione hac."
,"26":"Et sicut factum est in diebus Noe, ita erit et in diebus Filii hominis:"
,"27":"edebant, bibebant, uxores ducebant, dabantur ad nuptias, usque in diem, qua intravit Noe in arcam, et venit diluvium et perdidit omnes."
,"28":"Similiter sicut factum est in diebus Lot: edebant, bibebant, emebant, vendebant, plantabant, aedificabant;"
,"29":"qua die autem exiit Lot a Sodomis, pluit ignem et sulphur de caelo et omnes perdidit."
,"30":"Secundum haec erit, qua die Filius hominis revelabitur."
,"31":"In illa die, qui fuerit in tecto, et vasa eius in domo, ne descendat tollere illa; et, qui in agro, similiter non redeat retro."
,"32":"Memores estote uxoris Lot."
,"33":"Quicumque quaesierit animam suam salvam facere, perdet illam; et, quicumque perdiderit illam, vivificabit eam."
,"34":"Dico vobis: Illa nocte erunt duo in lecto uno: unus assumetur, et alter relinquetur; "
,"35":"duae erunt molentes in unum: una assumetur, et altera relinquetur '. (36) 37 Respondentes dicunt illi: ' Ubi, Domine? '. Qui dixit eis: ' Ubicumque fuerit corpus, illuc congregabuntur et aquilae '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Dicebat autem parabolam ad illos, quoniam oportet semper orare et non deficere,"
,"2":"dicens: ' Iudex quidam erat in quadam civitate, qui Deum non timebat et hominem non reverebatur."
,"3":"Vidua autem erat in civitate illa et veniebat ad eum dicens: 'Vindica me de adversario meo'."
,"4":"Et nolebat per multum tempus; post haec autem dixit intra se: 'Etsi Deum non timeo nec hominem revereor,"
,"5":"tamen quia molesta est mihi haec vidua, vindicabo illam, ne in novissimo veniens suggillet me' '."
,"6":"Ait autem Dominus: ' Audite quid iudex iniquitatis dicit;"
,"7":"Deus autem non faciet vindictam electorum suorum clamantium ad se die ac nocte, et patientiam habebit in illis?"
,"8":"Dico vobis: Cito faciet vindictam illorum. Verumtamen Filius hominis veniens, putas, inveniet fidem in terra? '."
,"9":"Dixit autem et ad quosdam, qui in se confidebant tamquam iusti et aspernabantur ceteros, parabolam istam:"
,"10":"' Duo homines ascenderunt in templum, ut orarent: unus pharisaeus et alter publicanus."
,"11":"Pharisaeus stans haec apud se orabat: 'Deus, gratias ago tibi, quia non sum sicut ceteri hominum, raptores, iniusti, adulteri, velut etiam hic publicanus;"
,"12":"ieiuno bis in sabbato, decimas do omnium, quae possideo'."
,"13":"Et publicanus a longe stans nolebat nec oculos ad caelum levare, sed percutiebat pectus suum dicens: 'Deus, propitius esto mihi peccatori'."
,"14":"Dico vobis: Descendit hic iustificatus in domum suam ab illo. Quia omnis, qui se exaltat, humiliabitur; et, qui se humiliat, exaltabitur '."
,"15":"Afferebant autem ad illum et infantes, ut eos tangeret; quod cum viderent, discipuli increpabant illos."
,"16":"Iesus autem convocans illos dixit: ' Sinite pueros venire ad me et nolite eos vetare; talium est enim regnum Dei."
,"17":"Amen dico vobis: Quicumque non acceperit regnum Dei sicut puer, non intrabit in illud '."
,"18":"Et interrogavit eum quidam princeps dicens: ' Magister bone, quid faciens vitam aeternam possidebo? '."
,"19":"Dixit autem ei Iesus: ' Quid me dicis bonum? Nemo bonus nisi solus Deus."
,"20":"Mandata nosti: non moechaberis, non occides, non furtum facies, non falsum testimonium dices, honora patrem tuum et matrem '."
,"21":"Qui ait: ' Haec omnia custodivi a iuventute '."
,"22":"Quo audito, Iesus ait ei: ' Adhuc unum tibi deest: omnia, quaecumque habes, vende et da pauperibus et habebis thesaurum in caelo: et veni, sequere me '."
,"23":"His ille auditis, contristatus est, quia dives erat valde."
,"24":"Videns autem illum Iesus tristem factum dixit: ' Quam difficile, qui pecunias habent, in regnum Dei intrant."
,"25":"Facilius est enim camelum per foramen acus transire, quam divitem intrare in regnum Dei '."
,"26":"Et dixerunt, qui audiebant: ' Et quis potest salvus fieri? '."
,"27":"Ait autem illis: ' Quae impossibilia sunt apud homi nes, possibilia sunt apud Deum '."
,"28":"Ait autem Petrus: ' Ecce nos dimisimus nostra et secuti sumus te '."
,"29":"Qui dixit eis: ' Amen dico vobis: Nemo est, qui reliquit domum aut uxorem aut fratres aut parentes aut filios propter regnum Dei,"
,"30":"et non recipiat multo plura in hoc tempore et in saeculo venturo vitam aeternam '."
,"31":"Assumpsit autem Duodecim et ait illis: ' Ecce ascendimus Ierusalem, et consummabuntur omnia, quae scripta sunt per Prophetas de Filio hominis:"
,"32":"tradetur enim gentibus et illudetur et contumeliis afficietur et conspuetur;"
,"33":"et, postquam flagellaverint, occident eum, et die tertia resurget '."
,"34":"Et ipsi nihil horum intellexerunt; et erat verbum istud absconditum ab eis, et non intellegebant, quae dicebantur."
,"35":"Factum est autem, cum appropinquaret Iericho, caecus quidam sedebat secus viam mendicans."
,"36":"Et cum audiret turbam praetereuntem, interrogabat quid hoc esset."
,"37":"Dixerunt autem ei: ' Iesus Nazarenus transit '."
,"38":"Et clamavit dicens: ' Iesu, fili David, miserere mei! '."
,"39":"Et qui praeibant, increpabant eum, ut taceret; ipse vero multo magis clamabat: ' Fili David, miserere mei! '."
,"40":"Stans autem Iesus iussit illum adduci ad se. Et cum appropinquasset, interrogavit illum:"
,"41":"' Quid tibi vis faciam? '. At ille dixit: ' Domine, ut videam '."
,"42":"Et Iesus dixit illi: ' Respice! Fides tua te salvum fecit '."
,"43":"Et confestim vidit et sequebatur illum magnificans Deum. Et omnis plebs, ut vidit, dedit laudem Deo."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Et ingressus perambulabat Iericho."
,"2":"Et ecce vir nomine Zacchaeus, et hic erat princeps publicanorum et ipse dives."
,"3":"Et quaerebat videre Iesum, quis esset, et non poterat prae turba, quia statura pusillus erat."
,"4":"Et praecurrens ascendit in arborem sycomorum, ut videret illum, quia inde erat transiturus."
,"5":"Et cum venisset ad locum, suspiciens Iesus dixit ad eum: ' Zacchaee, festinans descende, nam hodie in domo tua oportet me manere '."
,"6":"Et festinans descendit et excepit illum gaudens."
,"7":"Et cum viderent, omnes murmurabant dicentes: ' Ad hominem peccatorem divertit! '."
,"8":"Stans autem Zacchaeus dixit ad Dominum: ' Ecce dimidium bonorum meorum, Domine, do pauperibus et, si quid aliquem defraudavi, reddo quadruplum '."
,"9":"Ait autem Iesus ad eum: ' Hodie salus domui huic facta est, eo quod et ipse filius sit Abrahae;"
,"10":"venit enim Filius hominis quaerere et salvum facere, quod perierat '."
,"11":"Haec autem illis audientibus, adiciens dixit parabolam, eo quod esset prope Ierusalem, et illi existimarent quod confestim regnum Dei manifestaretur."
,"12":"Dixit ergo: ' Homo quidam nobilis abiit in regionem longinquam accipere sibi regnum et reverti."
,"13":"Vocatis autem decem servis suis, dedit illis decem minas et ait ad illos: 'Negotiamini, dum venio'."
,"14":"Cives autem eius oderant illum et miserunt legationem post illum dicentes: 'Nolumus hunc regnare super nos!'."
,"15":"Et factum est ut rediret, accepto regno, et iussit ad se vocari servos illos, quibus dedit pecuniam, ut sciret quantum negotiati essent."
,"16":"Venit autem primus dicens: 'Domine, mina tua decem minas acquisivit'."
,"17":"Et ait illi: 'Euge, bone serve; quia in modico fidelis fuisti, esto potestatem habens supra decem civitates'."
,"18":"Et alter venit dicens: 'Mina tua, domine, fecit quinque minas'."
,"19":"Et huic ait: 'Et tu esto supra quinque civitates'."
,"20":"Et alter venit dicens: 'Domine, ecce mina tua, quam habui repositam in sudario;"
,"21":"timui enim te, quia homo austerus es: tollis, quod non posuisti, et metis, quod non seminasti'."
,"22":"Dicit ei: 'De ore tuo te iudico, serve nequam! Sciebas quod ego austerus homo sum, tollens quod non posui et metens quod non seminavi?"
,"23":"Et quare non dedisti pecuniam meam ad mensam? Et ego veniens cum usuris utique exegissem illud'."
,"24":"Et adstantibus dixit: 'Auferte ab illo minam et date illi, qui decem minas habet'."
,"25":"Et dixerunt ei: 'Domine, habet decem minas!'."
,"26":"Dico vobis: 'Omni habenti dabitur; ab eo autem, qui non habet, et, quod habet, auferetur."
,"27":"Verumtamen inimicos meos illos, qui noluerunt me regnare super se, adducite huc et interficite ante me! '."
,"28":"Et his dictis, praecedebat ascendens Hierosolymam."
,"29":"Et factum est, cum appropinquasset ad Bethfage et Bethaniam, ad montem, qui vocatur Oliveti, misit duos discipulos"
,"30":"dicens: ' Ite in castellum, quod contra est, in quod introeuntes invenietis pullum asinae alligatum, cui nemo umquam hominum sedit; solvite illum et adducite."
,"31":"Et si quis vos interrogaverit: 'Quare solvitis?', sic dicetis: 'Dominus eum necessarium habet' '."
,"32":"Abierunt autem, qui missi erant, et invenerunt, sicut dixit illis."
,"33":"Solventibus autem illis pullum, dixerunt domini eius ad illos: ' Quid solvitis pullum? '."
,"34":"At illi dixerunt: ' Dominus eum necessarium habet '."
,"35":"Et duxerunt illum ad Iesum; et iactantes vestimenta sua supra pullum, imposuerunt Iesum."
,"36":"Eunte autem illo, substernebant vestimenta sua in via."
,"37":"Et cum appropinquaret iam ad descensum montis Oliveti, coeperunt omnis multitudo discipulorum gaudentes laudare Deum voce magna super omnibus, quas viderant, virtutibus"
,"38":"dicentes: ' Benedictus, qui venit rex in nomine Domini!,Pax in caelo, et gloria in excelsis! '."
,"39":"Et quidam pharisaeorum de turbis dixerunt ad illum: ' Magister, increpa discipulos tuos! '."
,"40":"Et respondens dixit: ' Dico vobis: Si hi tacuerint, lapides clamabunt! '."
,"41":"Et ut appropinquavit, videns civitatem flevit super illam"
,"42":"dicens: ' Si cognovisses et tu in hac die, quae ad pacem tibi! Nunc autem abscondita sunt ab oculis tuis."
,"43":"Quia venient dies in te, et circumdabunt te inimici tui vallo et obsidebunt te et coangustabunt te undique"
,"44":"et ad terram prosternent te et filios tuos, qui in te sunt, et non relinquent in te lapidem super lapidem, eo quod non cognoveris tempus visitationis tuae '."
,"45":"Et ingressus in templum, coepit eicere vendentes"
,"46":"dicens illis: ' Scriptum est: 'Et erit domus mea domus orationis'. Vos autem fecistis illam speluncam latronum '."
,"47":"Et erat docens cotidie in templo. Principes autem sacerdotum et scribae et principes plebis quaerebant illum perdere"
,"48":"et non inveniebant quid facerent; omnis enim populus suspensus erat audiens illum."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Et factum est in una dierum, docente illo populum in tem plo et evangelizante, supervenerunt principes sacerdotum et scribae cum senioribus"
,"2":"et aiunt dicentes ad illum: ' Dic nobis: In qua potestate haec facis, aut quis est qui dedit tibi hanc potestatem? '."
,"3":"Respondens autem dixit ad illos: ' Interrogabo vos et ego verbum; et dicite mihi:"
,"4":"Baptismum Ioannis de caelo erat an ex hominibus? '."
,"5":"At illi cogitabant inter se dicentes: ' Si dixerimus: 'De caelo', dicet: 'Quare non credidistis illi?;"
,"6":"si autem dixerimus: 'Ex hominibus', plebs universa lapidabit nos; certi sunt enim Ioannem prophetam esse '."
,"7":"Et responderunt se nescire unde esset."
,"8":"Et Iesus ait illis: ' Neque ego dico vobis in qua potestate haec facio '."
,"9":"Coepit autem dicere ad plebem parabolam hanc: ' Homo plantavit vineam et locavit eam colonis et ipse peregre fuit multis temporibus."
,"10":"Et in tempore misit ad cultores servum, ut de fructu vineae darent illi; cultores autem caesum dimiserunt eum inanem."
,"11":"Et addidit alterum servum mittere; illi autem hunc quoque caedentes et afficientes contumelia dimiserunt inanem."
,"12":"Et addidit tertium mittere; qui et illum vulnerantes eiecerunt."
,"13":"Dixit autem dominus vineae: 'Quid faciam? Mittam filium meum dilectum; forsitan hunc verebuntur'."
,"14":"Quem cum vidissent coloni, cogitaverunt inter se dicentes: 'Hic est heres. Occidamus illum, ut nostra fiat hereditas'."
,"15":"Et eiectum illum extra vineam occiderunt. Quid ergo faciet illis dominus vineae?"
,"16":"Veniet et perdet colonos istos et dabit vineam aliis '. Quo audito, dixerunt: ' Absit! '. "
,"17":"Ille autem aspiciens eos ait: ' Quid est ergo hoc, quod scriptum est: 'Lapidem quem reprobaverunt aedificantes, hic factus est in caput anguli'?"
,"18":"Omnis, qui ceciderit supra illum lapidem, conquassabitur; supra quem autem ceciderit, comminuet illum '."
,"19":"Et quaerebant scribae et principes sacerdotum mittere in illum manus in illa hora et timuerunt populum; cognoverunt enim quod ad ipsos dixerit similitudinem istam."
,"20":"Et observantes miserunt insidiatores, qui se iustos simularent, ut caperent eum in sermone, et sic traderent illum principatui et potestati praesidis."
,"21":"Et interrogaverunt illum dicentes: ' Magister, scimus quia recte dicis et doces et non accipis personam, sed in veritate viam Dei doces."
,"22":"Licet nobis dare tributum Caesari an non? '."
,"23":"Considerans autem dolum illorum dixit ad eos:"
,"24":"' Ostendite mihi denarium. Cuius habet imaginem et inscriptionem? '."
,"25":"At illi dixerunt: ' Caesaris '. Et ait illis: ' Reddite ergo, quae Caesaris sunt, Caesari et, quae Dei sunt, Deo '."
,"26":"Et non potuerunt verbum eius reprehendere coram plebe et mirati in responso eius tacuerunt."
,"27":"Accesserunt autem quidam sadducaeorum, qui negant esse resurrectionem, et interrogaverunt eum"
,"28":"dicentes: ' Magister, Moyses scripsit nobis, si frater alicuius mortuus fuerit habens uxorem et hic sine filiis fuerit, ut accipiat eam frater eius uxorem et suscitet semen fratri suo."
,"29":"Septem ergo fratres erant: et primus accepit uxorem et mortuus est sine filiis;"
,"30":"et sequens"
,"31":"et tertius accepit illam, similiter autem et septem non reliquerunt filios et mortui sunt."
,"32":"Novissima mortua est et mulier."
,"33":"Mulier ergo in resurrectione cuius eorum erit uxor? Si quidem septem habuerunt eam uxorem '."
,"34":"Et ait illis Iesus: ' Filii saeculi huius nubunt et traduntur ad nuptias;"
,"35":"illi autem, qui digni habentur saeculo illo et resurrectione ex mortuis, neque nubunt neque ducunt uxores."
,"36":"Neque enim ultra mori possunt: aequales enim angelis sunt et filii sunt Dei, cum sint filii resurrectionis."
,"37":"Quia vero resurgant mortui, et Moyses ostendit secus rubum, sicut dicit: 'Dominum Deum Abraham et Deum Isaac et Deum Iacob'."
,"38":"Deus autem non est mortuorum sed vivorum: omnes enim vivunt ei '."
,"39":"Respondentes autem quidam scribarum dixerunt: ' Magister, bene dixisti '."
,"40":"Et amplius non audebant eum quidquam interrogare."
,"41":"Dixit autem ad illos: ' Quomodo dicunt Christum filium David esse?"
,"42":"Ipse enim David dicit in libro Psalmorum: 'Dixit Dominus Domino meo: Sede a dextris meis,"
,"43":"donec ponam inimicos tuos scabellum pedum tuorum'."
,"44":"David ergo Dominum illum vocat; et quomodo filius eius est? '."
,"45":"Audiente autem omni populo, dixit discipulis suis:"
,"46":"' Attendite a scribis, qui volunt ambulare in stolis et amant salutationes in foro et primas cathedras in synagogis et primos discubitus in conviviis,"
,"47":"qui devorant domos viduarum et simulant longam orationem. Hi accipient damnationem maiorem '."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Respiciens autem vidit eos, qui mittebant munera sua in gazophylacium, divites."
,"2":"Vidit autem quandam viduam pauperculam mittentem illuc minuta duo"
,"3":"et dixit: ' Vere dico vobis: Vidua haec pauper plus quam omnes misit."
,"4":"Nam omnes hi ex abundantia sua miserunt in munera; haec autem ex inopia sua omnem victum suum, quem habebat, misit '."
,"5":"Et quibusdam dicentibus de templo, quod lapidibus bonis et donis ornatum, esset dixit:"
,"6":"' Haec quae videtis, venient dies, in quibus non relinquetur lapis super lapidem, qui non destruatur '."
,"7":"Interrogaverunt autem illum dicentes: ' Praeceptor, quando ergo haec erunt, et quod signum, cum fieri incipient? '."
,"8":"Qui dixit: ' Videte, ne seducamini. Multi enim venient in nomine meo dicentes: 'Ego sum' et: 'Tempus appropinquavit'. Nolite ergo ire post illos."
,"9":"Cum autem audieritis proelia et seditiones, nolite terreri; oportet enim primum haec fieri, sed non statim finis '."
,"10":"Tunc dicebat illis: ' Surget gens contra gentem, et regnum adversus regnum;"
,"11":"et terrae motus magni et per loca fames et pestilentiae erunt, terroresque et de caelo signa magna erunt."
,"12":"Sed ante haec omnia inicient vobis manus suas et persequentur tradentes in synagogas et custodias, et trahemini ad reges et praesides propter nomen meum;"
,"13":"continget autem vobis in testimonium."
,"14":"Ponite ergo in cordibus vestris non praemeditari quemadmodum respondeatis;"
,"15":"ego enim dabo vobis os et sapientiam, cui non poterunt resistere vel contradicere omnes adversarii vestri."
,"16":"Trademini autem et a parentibus et fratribus et cognatis et amicis, et morte afficient ex vobis,"
,"17":"et eritis odio omnibus propter nomen meum."
,"18":"Et capillus de capite vestro non peribit."
,"19":"In patientia vestra possidebitis animas vestras."
,"20":"Cum autem videritis circumdari ab exercitu Ierusalem, tunc scitote quia appropinquavit desolatio eius."
,"21":"Tunc, qui in Iudaea sunt, fugiant in montes; et, qui in medio eius, discedant; et, qui in regionibus, non intrent in eam."
,"22":"Quia dies ultionis hi sunt, ut impleantur omnia, quae scripta sunt."
,"23":"Vae autem praegnantibus et nutrientibus in illis diebus! Erit enim pressura magna super terram et ira populo huic,"
,"24":"et cadent in ore gladii et captivi ducentur in omnes gentes, et Ierusalem calcabitur a gentibus, donec impleantur tempora nationum."
,"25":"Et erunt signa in sole et luna et stellis, et super terram pressura gentium prae confusione sonitus maris et fluctuum,"
,"26":"arescentibus hominibus prae timore et exspectatione eorum, quae supervenient orbi, nam virtutes caelorum movebuntur."
,"27":"Et tunc videbunt Filium hominis venientem in nube cum potestate et gloria magna."
,"28":"His autem fieri incipientibus, respicite et levate capita vestra, quoniam appropinquat redemptio vestra '."
,"29":"Et dixit illis similitudinem: ' Videte ficulneam et omnes arbores:"
,"30":"cum iam germinaverint, videntes vosmetipsi scitis quia iam prope est aestas."
,"31":"Ita et vos, cum videritis haec fieri, scitote quoniam prope est regnum Dei."
,"32":"Amen dico vobis: Non praeteribit generatio haec, donec omnia fiant."
,"33":"Caelum et terra transibunt, verba autem mea non transibunt."
,"34":"Attendite autem vobis, ne forte graventur corda vestra in crapula et ebrietate et curis huius vitae, et superveniat in vos repentina dies illa;"
,"35":"tamquam laqueus enim superveniet in omnes, qui sedent super faciem omnis terrae."
,"36":"Vigilate itaque omni tempore orantes, ut possitis fugere ista omnia, quae futura sunt, et stare ante Filium hominis '."
,"37":"Erat autem diebus docens in templo, noctibus vero exiens morabatur in monte, qui vocatur Oliveti."
,"38":"Et omnis populus manicabat ad eum in templo audire eum."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Appropinquabat autem dies festus Azymorum, qui dici tur Pascha."
,"2":"Et quaerebant principes sacerdotum et scribae quomodo eum interficerent; timebant vero plebem."
,"3":"Intravit autem Satanas in Iudam, qui cognominabatur Iscarioth, unum de Duodecim;"
,"4":"et abiit et locutus est cum principibus sacerdotum et magistratibus, quemadmodum illum traderet eis."
,"5":"Et gavisi sunt et pacti sunt pecuniam illi dare."
,"6":"Et spopondit et quaerebat opportunitatem, ut eis traderet illum sine turba."
,"7":"Venit autem dies Azymorum, in qua necesse erat occidi Pascha."
,"8":"Et misit Petrum et Ioannem dicens: ' Euntes parate nobis Pascha, ut manducemus '."
,"9":"At illi dixerunt ei: 'Ubi vis paremus? '."
,"10":"Et dixit ad eos: ' Ecce, introeuntibus vobis in civitatem, occurret vobis homo amphoram aquae portans; sequimini eum in domum, in quam intrat."
,"11":"Et dicetis patri familias domus: 'Dicit tibi Magister: Ubi est deversorium, ubi Pascha cum discipulis meis manducem?'."
,"12":"Ipse vobis ostendet cenaculum magnum stratum; ibi parate '."
,"13":"Euntes autem invenerunt, sicut dixit illis, et paraverunt Pascha."
,"14":"Et cum facta esset hora, discubuit, et apostoli cum eo."
,"15":"Et ait illis: ' Desiderio desideravi hoc Pascha manducare vobiscum, antequam patiar."
,"16":"Dico enim vobis: Non manducabo illud, donec impleatur in regno Dei '."
,"17":"Et accepto calice, gratias egit et dixit: ' Accipite hoc et dividite inter vos."
,"18":"Dico enim vobis: Non bibam amodo de generatione vitis, donec regnum Dei veniat '."
,"19":"Et accepto pane, gratias egit et fregit et dedit eis dicens: ' Hoc est corpus meum, quod pro vobis datur. Hoc facite in meam commemorationem '."
,"20":"Similiter et calicem, postquam cenavit, dicens: ' Hic calix novum testamentum est in sanguine meo, qui pro vobis funditur."
,"21":"Verumtamen ecce manus tradentis me mecum est in mensa;"
,"22":"et quidem Filius hominis, secundum quod definitum est, vadit; verumtamen vae illi homini, per quem traditur! '."
,"23":"Et ipsi coeperunt quaerere inter se, quis esset ex eis, qui hoc facturus esset."
,"24":"Facta est autem et contentio inter eos, quis eorum videretur esse maior."
,"25":"Dixit autem eis: ' Reges gentium dominantur eorum; et, qui potestatem habent super eos, benefici vocantur."
,"26":"Vos autem non sic, sed qui maior est in vobis, fiat sicut iunior; et, qui praecessor est, sicut ministrator."
,"27":"Nam quis maior est: qui recumbit, an qui ministrat? Nonne qui recumbit? Ego autem in medio vestrum sum, sicut qui ministrat."
,"28":"Vos autem estis, qui permansistis mecum in tentationibus meis;"
,"29":"et ego dispono vobis, sicut disposuit mihi Pater meus regnum,"
,"30":"ut edatis et bibatis super mensam meam in regno meo et sedeatis super thronos iudicantes duodecim tribus Israel."
,"31":"Simon, Simon, ecce Satanas expetivit vos, ut cribraret sicut triticum;"
,"32":"ego autem rogavi pro te, ut non deficiat fides tua. Et tu, aliquando conversus, confirma fratres tuos '."
,"33":"Qui dixit ei: ' Domine, tecum paratus sum et in carcerem et in mortem ire '."
,"34":"Et ille dixit: ' Dico tibi, Petre, non cantabit hodie gallus, donec ter abneges nosse me '."
,"35":"Et dixit eis: ' Quando misi vos sine sacculo et pera et calceamentis, numquid aliquid defuit vobis? '. At illi dixerunt: ' Nihil '."
,"36":"Dixit ergo eis: ' Sed nunc, qui habet sacculum, tollat, similiter et peram; et, qui non habet, vendat tunicam suam et emat gladium."
,"37":"Dico enim vobis: Hoc, quod scriptum est, oportet impleri in me, illud: 'Cum iniustis deputatus est'. Etenim ea, quae sunt de me, adimpletionem habent '."
,"38":"At illi dixerunt: ' Domine, ecce gladii duo hic '. At ille dixit eis: ' Satis est '."
,"39":"Et egressus ibat secundum consuetudinem in montem Olivarum; secuti sunt autem illum et discipuli."
,"40":"Et cum pervenisset ad locum, dixit illis: ' Orate, ne intretis in tentationem '."
,"41":"Et ipse avulsus est ab eis, quantum iactus est lapidis, et, positis genibus, orabat"
,"42":"dicens: ' Pater, si vis, transfer calicem istum a me; verumtamen non mea voluntas sed tua fiat '."
,"43":"Apparuit autem illi angelus de caelo confortans eum. Et factus in agonia prolixius orabat."
,"44":"Et factus est sudor eius sicut guttae sanguinis decurrentis in terram."
,"45":"Et cum surrexisset ab oratione et venisset ad discipulos, invenit eos dormientes prae tristitia"
,"46":"et ait illis: ' Quid dormitis? Surgite; orate, ne intretis in tentationem '."
,"47":"Adhuc eo loquente, ecce turba; et, qui vocabatur Iudas, unus de Duodecim, antecedebat eos et appropinquavit Iesu, ut oscularetur eum."
,"48":"Iesus autem dixit ei: ' Iuda, osculo Filium hominis tradis? '."
,"49":"Videntes autem hi, qui circa ipsum erant, quod futurum erat, dixerunt: ' Domine, si percutimus in gladio? '."
,"50":"Et percussit unus ex illis servum principis sacerdotum et amputavit auriculam eius dextram."
,"51":"Respondens autem Iesus ait: ' Sinite usque huc! '. Et cum tetigisset auriculam eius, sanavit eum."
,"52":"Dixit autem Iesus ad eos, qui venerant ad se principes sacerdotum et magistratus templi et seniores: ' Quasi ad latronem existis cum gladiis et fustibus?"
,"53":"Cum cotidie vobiscum fuerim in templo, non extendistis manus in me; sed haec est hora vestra et potestas tenebrarum '."
,"54":"Comprehendentes autem eum, duxerunt et introduxerunt in domum principis sacerdotum. Petrus vero sequebatur a longe."
,"55":"Accenso autem igni in medio atrio et circumsedentibus illis, sedebat Petrus in medio eorum."
,"56":"Quem cum vidisset ancilla quaedam sedentem ad lumen et eum fuisset intuita, dixit:"
,"57":"' Et hic cum illo erat! '. At ille negavit eum dicens:"
,"58":"' Mulier, non novi illum! '. Et post pusillum alius videns eum dixit: ' Et tu de illis es! '. Petrus vero ait: ' O homo, non sum! '."
,"59":"Et intervallo facto quasi horae unius, alius quidam affirmabat dicens: ' Vere et hic cum illo erat, nam et Galilaeus est! '."
,"60":"Et ait Petrus: ' Homo, nescio quid dicis! '. Et continuo adhuc illo loquente cantavit gallus."
,"61":"Et conversus Dominus respexit Petrum; et recordatus est Petrus verbi Domini, sicut dixit ei: ' Priusquam gallus cantet hodie, ter me negabis '."
,"62":"Et egressus foras flevit amare."
,"63":"Et viri, qui tenebant illum, illudebant ei caedentes;"
,"64":"et velaverunt eum et interrogabant eum dicentes: ' Prophetiza: Quis est, qui te percussit? '."
,"65":"Et alia multa blasphemantes dicebant in eum."
,"66":"Et ut factus est dies, convenerunt seniores plebis et principes sacerdotum et scribae et duxerunt illum in concilium suum"
,"67":"dicentes: ' Si tu es Christus, dic nobis '. Et ait illis: ' Si vobis dixero, non credetis;"
,"68":"si autem interrogavero, non respondebitis mihi."
,"69":"Ex hoc autem erit Filius hominis sedens a dextris virtutis Dei '."
,"70":"Dixerunt autem omnes: ' Tu ergo es Filius Dei? '. Qui ait ad illos: ' Vos dicitis quia ego sum '."
,"71":"At illi dixerunt: ' Quid adhuc desideramus testimonium? Ipsi enim audivimus de ore eius! '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Et surgens omnis multitudo eorum duxerunt illum ad Pi latum."
,"2":"Coeperunt autem accusare illum dicentes: ' Hunc invenimus subvertentem gentem nostram et prohibentem tributa dare Caesari et dicentem se Christum regem esse '."
,"3":"Pilatus autem interrogavit eum dicens: ' Tu es rex Iudaeorum? '. At ille respondens ait: ' Tu dicis '."
,"4":"Ait autem Pilatus ad principes sacerdotum et turbas: ' Nihil invenio causae in hoc homine '."
,"5":"At illi invalescebant dicentes: ' Commovet populum docens per universam Iudaeam et in cipiens a Galilaea usque huc! '."
,"6":"Pilatus autem audiens interrogavit si homo Galilaeus esset;"
,"7":"et ut cognovit quod de Herodis potestate esset, remisit eum ad Herodem, qui et ipse Hierosolymis erat illis diebus."
,"8":"Herodes autem, viso Iesu, gavisus est valde; erat enim cupiens ex multo tempore videre eum, eo quod audiret de illo et sperabat signum aliquod videre ab eo fieri."
,"9":"Interrogabat autem illum multis sermonibus; at ipse nihil illi respondebat."
,"10":"Stabant etiam principes sacerdotum et scribae constanter accusantes eum."
,"11":"Sprevit autem illum Herodes cum exercitu suo et illusit indutum veste alba et remisit ad Pilatum."
,"12":"Facti sunt autem amici inter se Herodes et Pilatus in ipsa die; nam antea inimici erant ad invicem."
,"13":"Pilatus autem, convocatis principibus sacerdotum et magistratibus et plebe,"
,"14":"dixit ad illos: ' Obtulistis mihi hunc hominem quasi avertentem populum, et ecce ego coram vobis interrogans nullam causam inveni in homine isto ex his, in quibus eum accusatis,"
,"15":"sed,neque Herodes; remisit enim illum ad nos. Et ecce nihil dignum morte actum est ei. "
,"16":"Emendatum ergo illum dimittam '. (17) 18 Exclamavit autem universa turba dicens: ' Tolle hunc et dimitte nobis Barabbam! ', "
,"19":"qui erat propter seditionem quandam factam in civitate et homicidium missus in carcerem."
,"20":"Iterum autem Pilatus locutus est ad illos volens dimittere Iesum,"
,"21":"at illi succlamabant dicentes: ' Crucifige, crucifige illum! '."
,"22":"Ille autem tertio dixit ad illos: ' Quid enim mali fecit iste? Nullam causam mortis invenio in eo; corripiam ergo illum et dimittam '."
,"23":"At illi instabant vocibus magnis postulantes, ut crucifigeretur, et invalescebant voces eorum."
,"24":"Et Pilatus adiudicavit fieri petitionem eorum:"
,"25":"dimisit autem eum, qui propter seditionem et homicidium missus fuerat in carcerem, quem petebant; Iesum vero tradidit voluntati eorum."
,"26":"Et cum abducerent eum, apprehenderunt Simonem quendam Cyrenensem venientem de villa et imposuerunt illi crucem portare post Iesum."
,"27":"Sequebatur autem illum multa turba populi et mulierum, quae plangebant et lamentabant eum."
,"28":"Conversus autem ad illas Iesus dixit: ' Filiae Ierusalem, nolite flere super me, sed super vos ipsas flete et super filios vestros,"
,"29":"quoniam ecce venient dies, in quibus dicent: 'Beatae steriles et ventres, qui non genuerunt, et ubera, quae non lactaverunt!'."
,"30":"Tunc incipient dicere montibus: 'Cadite super nos!', et collibus: 'Operite nos!',"
,"31":"quia si in viridi ligno haec faciunt, in arido quid fiet? '."
,"32":"Ducebantur autem et alii duo nequam cum eo, ut interficerentur."
,"33":"Et postquam venerunt in locum, qui vocatur Calvariae, ibi crucifixerunt eum et latrones, unum a dextris et alterum a sinistris."
,"34":"Iesus autem dicebat: ' Pater, dimitte illis, non enim sciunt quid faciunt '. Dividentes vero vestimenta eius miserunt sortes. "
,"35":"Et stabat populus exspectans. Et deridebant illum et principes dicentes: ' Alios salvos fecit; se salvum faciat, si hic est Christus Dei electus! '."
,"36":"Illudebant autem ei et milites accedentes, acetum offerentes illi"
,"37":"et dicentes: ' Si tu es rex Iudaeorum, salvum te fac! '."
,"38":"Erat autem et superscriptio super illum: ' Hic est rex Iudaeorum '."
,"39":"Unus autem de his, qui pendebant, latronibus blasphemabat eum dicens: ' Nonne tu es Christus? Salvum fac temetipsum et nos! '."
,"40":"Respondens autem alter increpabat illum dicens: ' Neque tu times Deum, quod in eadem damnatione es?"
,"41":"Et nos quidem iuste, nam digna factis recipimus! Hic vero nihil mali gessit '."
,"42":"Et dicebat: ' Iesu, memento mei, cum veneris in regnum tuum '."
,"43":"Et dixit illi: ' Amen dico tibi: Hodie mecum eris in paradiso '."
,"44":"Et erat iam fere hora sexta, et tenebrae factae sunt in universa terra usque in horam nonam,"
,"45":"et obscuratus est sol, et velum templi scissum est medium."
,"46":"Et clamans voce magna Iesus ait: ' Pater, in manus tuas commendo spiritum meum '; et haec dicens exspiravit."
,"47":"Videns autem centurio, quod factum fuerat, glorificavit Deum dicens: ' Vere hic homo iustus erat! '."
,"48":"Et omnis turba eorum, qui simul aderant ad spectaculum istud et videbant, quae fiebant, percutientes pectora sua revertebantur."
,"49":"Stabant autem omnes noti eius a longe et mulieres, quae secutae erant eum a Galilaea, haec videntes."
,"50":"Et ecce vir nomine Ioseph, qui erat decurio, vir bonus et iustus"
,"51":"Chic non consenserat consilio et actibus eorum - ab Arimathaea civitate Iudaeorum, qui exspectabat regnum Dei,"
,"52":"hic accessit ad Pilatum et petiit corpus Iesu"
,"53":"et depositum involvit sindone et posuit eum in monumento exciso, in quo nondum quisquam positus fuerat."
,"54":"Et dies erat Parasceves, et sabbatum illucescebat."
,"55":"Subsecutae autem mulieres, quae cum ipso venerant de Galilaea, viderunt monumentum et quemadmodum positum erat corpus eius;"
,"56":"et revertentes paraverunt aromata et unguenta et sabbato quidem siluerunt secundum mandatum."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Prima autem sabbatorum, valde diluculo venerunt ad monumentum portantes, quae paraverant, aromata."
,"2":"Et invenerunt lapidem revolutum a monumento;"
,"3":"et ingressae non invenerunt corpus Domini Iesu."
,"4":"Et factum est, dum mente haesitarent de isto, ecce duo viri steterunt secus illas in veste fulgenti."
,"5":"Cum timerent autem et declinarent vultum in terram, dixerunt ad illas: ' Quid quaeritis viventem cum mortuis?"
,"6":"Non est hic, sed surrexit. Recordamini qualiter locutus est vobis, cum adhuc in Galilaea esset,"
,"7":"dicens: 'Oportet Filium hominis tradi in manus hominum peccatorum et crucifigi et die tertia resurgere' '."
,"8":"Et recordatae sunt verborum eius"
,"9":"et regressae a monumento nuntiaverunt haec omnia illis Undecim et ceteris omnibus."
,"10":"Erat autem Maria Magdalene et Ioanna et Maria Iacobi; et ceterae cum eis dicebant ad apostolos haec."
,"11":"Et visa sunt ante illos sicut deliramentum verba ista, et non credebant illis."
,"12":"Petrus autem surgens cucurrit ad monumentum et procumbens videt linteamina sola; et rediit ad sua mirans, quod factum fuerat."
,"13":"Et ecce duo ex illis ibant ipsa die in castellum, quod erat in spatio stadiorum sexaginta ab Ierusalem nomine Emmaus;"
,"14":"et ipsi loquebantur ad invicem de his omnibus, quae acciderant."
,"15":"Et factum est, dum fabularentur et secum quaererent, et ipse Iesus appropinquans ibat cum illis;"
,"16":"oculi autem illorum tenebantur, ne eum agnoscerent."
,"17":"Et ait ad illos: ' Qui sunt hi sermones, quos confertis ad invicem ambulantes? '. Et steterunt tristes."
,"18":"Et respondens unus, cui nomen Cleopas, dixit ei: ' Tu solus peregrinus es in Ierusalem et non cognovisti, quae facta sunt in illa his diebus? '."
,"19":"Quibus ille dixit: ' Quae? '. Et illi dixerunt ei: ' De Iesu Nazareno, qui fuit vir propheta, potens in opere et sermone coram Deo et omni populo;"
,"20":"et quomodo eum tradiderunt summi sacerdotes et principes nostri in damnationem mortis et crucifixerunt eum."
,"21":"Nos autem sperabamus, quia ipse esset redempturus Israel; at nunc super haec omnia tertia dies hodie quod haec facta sunt."
,"22":"Sed et mulieres quaedam ex nostris terruerunt nos, quae ante lucem fuerunt ad monumentum"
,"23":"et, non invento corpore eius, venerunt dicentes se etiam visionem angelorum vidisse, qui dicunt eum vivere."
,"24":"Et abierunt quidam ex nostris ad monumentum et ita invenerunt, sicut mulieres dixerunt, ipsum vero non viderunt '."
,"25":"Et ipse dixit ad eos: ' O stulti et tardi corde ad credendum in omnibus, quae locuti sunt Prophetae!"
,"26":"Nonne haec oportuit pati Christum et intrare in gloriam suam? '."
,"27":"Et incipiens a Moyse et omnibus Prophetis interpretabatur illis in omnibus Scripturis, quae de ipso erant."
,"28":"Et appropinquaverunt castello, quo ibant, et ipse se finxit longius ire."
,"29":"Et coegerunt illum dicentes: ' Mane nobiscum, quoniam advesperascit, et inclinata est iam dies '. Et intravit, ut maneret cum illis."
,"30":"Et factum est, dum recumberet cum illis, accepit panem et benedixit ac fregit et porrigebat illis."
,"31":"Et aperti sunt oculi eorum, et cognoverunt eum; et ipse evanuit ab eis."
,"32":"Et dixerunt ad invicem: ' Nonne cor nostrum ardens erat in nobis, dum loqueretur nobis in via et aperiret nobis Scripturas? '."
,"33":"Et surgentes eadem hora regressi sunt in Ierusalem et invenerunt congregatos Undecim et eos, qui cum ipsis erant,"
,"34":"dicentes: ' Surrexit Dominus vere et apparuit Simoni '."
,"35":"Et ipsi narrabant, quae gesta erant in via, et quomodo cognoverunt eum in fractione panis."
,"36":"Dum haec autem loquuntur, ipse stetit in medio eorum et dicit eis: ' Pax vobis! '."
,"37":"Conturbati vero et conterriti existimabant se spiritum videre."
,"38":"Et dixit eis: ' Quid turbati estis, et quare cogitationes ascendunt in corda vestra?"
,"39":"Videte manus meas et pedes meos, quia ipse ego sum! Palpate me et videte, quia spiritus carnem et ossa non habet, sicut me videtis habere '."
,"40":"Et cum hoc dixisset, ostendit eis manus et pedes."
,"41":"Adhuc autem illis non credentibus prae gaudio et mirantibus, dixit eis: ' Habetis hic aliquid, quod manducetur? '."
,"42":"At illi obtulerunt ei partem piscis assi."
,"43":"Et sumens, coram eis manducavit."
,"44":"Et dixit ad eos: ' Haec sunt verba, quae locutus sum ad vos, cum adhuc essem vobiscum, quoniam necesse est impleri omnia, quae scripta sunt in Lege Moysis et Prophetis et Psalmis de me '."
,"45":"Tunc aperuit illis sensum, ut intellegerent Scripturas."
,"46":"Et dixit eis: ' Sic scriptum est, Christum pati et resurgere a mortuis die tertia,"
,"47":"et praedicari in nomine eius paenitentiam in remissionem peccatorum in omnes gentes, incipientibus ab Ierusalem."
,"48":"Vos estis testes horum."
,"49":"Et ecce ego mitto promissum Patris mei in vos; vos autem sedete in civitate, quoadusque induamini virtutem ex alto '."
,"50":"Eduxit autem eos foras usque in Bethaniam et, elevatis manibus suis, benedixit eis."
,"51":"Et factum est, dum benediceret illis, recessit ab eis et ferebatur in caelum."
,"52":"Et ipsi adoraverunt eum et regressi sunt in Ierusalem cum gaudio magno"
,"53":"et erant semper in templo benedicentes Deum."
}`)

}
func LA_NVBSE_LoadNEMCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Initium evangelii Iesu Christi Filii Dei."
,"2":"Sicut scriptum est in Isaia propheta: ' Ecce mitto angelum meum ante faciem tuam, qui praeparabit viam tuam;"
,"3":"vox clamantis in deserto: 'Parate viam Domini, rectas facite semitas eius' ',"
,"4":"fuit Ioannes Baptista in deserto praedicans baptismum paenitentiae in remissionem peccatorum."
,"5":"Et egrediebatur ad illum omnis Iudaeae regio et Hierosolymitae universi et baptizabantur ab illo in Iordane flumine confitentes peccata sua."
,"6":"Et erat Ioannes vestitus pilis cameli, et zona pellicea circa lumbos eius, et locustas et mel silvestre edebat."
,"7":"Et praedicabat dicens: ' Venit fortior me post me, cuius non sum dignus procumbens solvere corrigiam calceamentorum eius."
,"8":"Ego baptizavi vos aqua; ille vero baptizabit vos in Spiritu Sancto '."
,"9":"Et factum est in diebus illis, venit Iesus a Nazareth Galilaeae et baptizatus est in Iordane ab Ioanne."
,"10":"Et statim ascendens de aqua vidit apertos caelos et Spiritum tamquam columbam descendentem in ipsum;"
,"11":"et vox facta est de caelis: ' Tu es Filius meus dilectus; in te complacui '."
,"12":"Et statim Spiritus expellit eum in desertum."
,"13":"Et erat in deserto quadraginta diebus et tentabatur a Satana; eratque cum bestiis, et angeli ministrabant illi."
,"14":"Postquam autem traditus est Ioannes, venit Iesus in Galilaeam praedicans evangelium Dei"
,"15":"et dicens: ' Impletum est tempus, et appropinquavit regnum Dei; paenitemini et credite evangelio '."
,"16":"Et praeteriens secus mare Galilaeae vidit Simonem et Andream fratrem Simonis mittentes in mare; erant enim piscatores."
,"17":"Et dixit eis Iesus: ' Venite post me, et faciam vos fieri piscatores hominum '."
,"18":"Et protinus, relictis retibus, secuti sunt eum."
,"19":"Et progressus pusillum vidit Iacobum Zebedaei et Ioannem fratrem eius, et ipsos in navi componentes retia,"
,"20":"et statim vocavit illos. Et, relicto patre suo Zebedaeo in navi cum mercennariis, abierunt post eum."
,"21":"Et ingrediuntur Capharnaum. Et statim sabbatis ingressus synagogam docebat."
,"22":"Et stupebant super doctrina eius: erat enim docens eos quasi potestatem habens et non sicut scribae."
,"23":"Et statim erat in synagoga eorum homo in spiritu immundo; et exclamavit"
,"24":"dicens: ' Quid nobis et tibi, Iesu Nazarene? Venisti perdere nos? Scio qui sis: Sanctus Dei '."
,"25":"Et comminatus est ei Iesus dicens: ' Obmutesce et exi de homine! '."
,"26":"Et discerpens eum spiritus immundus et exclamans voce magna exivit ab eo."
,"27":"Et mirati sunt omnes, ita ut conquirerent inter se dicentes: ' Quidnam est hoc? Doctrina nova cum potestate; et spiritibus immundis imperat, et oboediunt ei '."
,"28":"Et processit rumor eius statim ubique in omnem regionem Galilaeae."
,"29":"Et protinus egredientes de synagoga venerunt in domum Simonis et Andreae cum Iacobo et Ioanne."
,"30":"Socrus autem Simonis decumbebat febricitans; et statim dicunt ei de illa."
,"31":"Et accedens elevavit eam apprehensa manu; et dimisit eam febris, et ministrabat eis."
,"32":"Vespere autem facto, cum occidisset sol, afferebant ad eum omnes male habentes et daemonia habentes;"
,"33":"et erat omnis civitas congregata ad ianuam."
,"34":"Et curavit multos, qui vexabantur variis languoribus, et daemonia multa eiecit et non sinebat loqui daemonia, quoniam sciebant eum."
,"35":"Et diluculo valde mane surgens egressus est et abiit in desertum locum ibique orabat."
,"36":"Et persecutus est eum Simon et qui cum illo erant;"
,"37":"et cum invenissent eum, dixerunt ei: ' Omnes quaerunt te! '."
,"38":"Et ait illis: ' Eamus alibi in proximos vicos, ut et ibi praedicem: ad hoc enim veni '."
,"39":"Et venit praedicans in synagogis eorum per omnem Galilaeam et daemonia eiciens."
,"40":"Et venit ad eum leprosus deprecans eum et genu flectens et dicens ei: ' Si vis, potes me mundare '."
,"41":"Et misertus extendens manum suam tetigit eum et ait illi: ' Volo, mundare! ';"
,"42":"et statim discessit ab eo lepra, et mundatus est."
,"43":"Et infremuit in eum statimque eiecit illum"
,"44":"et dicit ei: 'Vide, nemini quidquam dixeris; sed vade, ostende te sacerdoti et offer pro emundatione tua, quae praecepit Moyses, in testimonium illis '."
,"45":"At ille egressus coepit praedicare multum et diffamare sermonem, ita ut iam non posset manifesto in civitatem introire, sed foris in desertis locis erat; et conveniebant ad eum undique."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et iterum intravit Capharnaum post dies, et auditum est quod in domo esset."
,"2":"Et convenerunt multi, ita ut non amplius caperentur neque ad ianuam, et loquebatur eis verbum."
,"3":"Et veniunt ferentes ad eum paralyticum, qui a quattuor portabatur."
,"4":"Et cum non possent offerre eum illi prae turba, nudaverunt tectum, ubi erat, et perfodientes summittunt grabatum, in quo paralyticus iacebat."
,"5":"Cum vidisset autem Iesus fidem illorum, ait paralytico: ' Fili, dimittuntur peccata tua '."
,"6":"Erant autem illic quidam de scribis sedentes et cogitantes in cordibus suis:"
,"7":"' Quid hic sic loquitur? Blasphemat! Quis potest dimittere peccata nisi solus Deus? '."
,"8":"Quo statim cognito Iesus spiritu suo quia sic cogitarent intra se, dicit illis: ' Quid ista cogitatis in cordibus vestris?"
,"9":"Quid est facilius, dicere paralytico: 'Dimittuntur peccata tua', an dicere: 'Surge et tolle grabatum tuum et ambula'?"
,"10":"Ut autem sciatis quia potestatem habet Filius hominis interra dimittendi peccata - ait paralytico - :"
,"11":"Tibi dico: Surge, tolle grabatum tuum et vade in domum tuam '."
,"12":"Et surrexit et protinus sublato grabato abiit coram omnibus, ita ut admirarentur omnes et glorificarent Deum dicentes: ' Numquam sic vidimus! '."
,"13":"Et egressus est rursus ad mare; omnisque turba veniebat ad eum, et docebat eos."
,"14":"Et cum praeteriret, vidit Levin Alphaei sedentem ad teloneum et ait illi: ' Sequere me '. Et surgens secutus est eum."
,"15":"Et factum est, cum accumberet in domo illius, et multi publicani et peccatores simul discumbebant cum Iesu et discipulis eius; erant enim multi et sequebantur eum."
,"16":"Et scribae pharisaeorum, videntes quia manducaret cum peccatoribus et publicanis, dicebant discipulis eius: ' Quare cum publicanis et peccatoribus manducat? '."
,"17":"Et Iesus hoc audito ait illis: ' Non necesse habent sani medicum, sed qui male habent; non veni vocare iustos sed peccatores '."
,"18":"Et erant discipuli Ioannis et pharisaei ieiunantes. Et veniunt et dicunt illi: ' Cur discipuli Ioannis et discipuli pharisaeorum ieiunant, tui autem discipuli non ieiunant? '."
,"19":"Et ait illis Iesus: ' Numquid possunt convivae nuptiarum, quamdiu sponsus cum illis est, ieiunare? Quanto tempore habent secum sponsum, non possunt ieiunare;"
,"20":"venient autem dies, cum auferetur ab eis sponsus, et tunc ieiunabunt in illa die."
,"21":"Nemo assumentum panni rudis assuit vestimento veteri; alioquin supplementum aufert aliquid ab eo, novum a veteri, et peior scissura fit."
,"22":"Et nemo mittit vinum novellum in utres veteres, alioquin dirumpet vinum utres et vinum perit et utres; sed vinum novum in utres novos '."
,"23":"Et factum est, cum ipse sabbatis ambularet per sata, discipuli eius coeperunt praegredi vellentes spicas."
,"24":"Pharisaei autem dicebant ei: ' Ecce, quid faciunt sabbatis, quod non licet? '."
,"25":"Et ait illis: ' Numquam legistis quid fecerit David, quando necessitatem habuit et esuriit ipse et qui cum eo erant?"
,"26":"Quomodo introivit in domum Dei sub Abiathar principe sacerdotum et panes propositionis manducavit, quos non licet manducare nisi sacerdotibus, et dedit etiam eis, qui cum eo erant? '."
,"27":"Et dicebat eis: ' Sabbatum propter hominem factum est, et non homo propter sabbatum;"
,"28":"itaque dominus est Filius hominis etiam sabbati '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et introivit iterum in synago gam. Et erat ibi homo habens manum aridam;"
,"2":"et observabant eum, si sabbatis curaret illum, ut accusarent eum."
,"3":"Et ait homini habenti manum aridam: ' Surge in medium '."
,"4":"Et dicit eis: ' Licet sabbatis bene facere an male? Animam salvam facere an perdere? '. At illi tacebant."
,"5":"Et circumspiciens eos cum ira, contristatus super caecitate cordis eorum, dicit homini: ' Extende manum '. Et extendit, et restituta est manus eius."
,"6":"Et exeuntes pharisaei statim cum herodianis consilium faciebant adversus eum quomodo eum perderent."
,"7":"Et Iesus cum discipulis suis secessit ad mare. Et multa turba a Galilaea secuta est et a Iudaea"
,"8":"et ab Hierosolymis et ab Idumaea; et, qui trans Iordanem et circa Tyrum et Sidonem, multitudo magna, audientes, quae faciebat, venerunt ad eum."
,"9":"Et dixit discipulis suis, ut navicula sibi praesto esset propter turbam, ne comprimerent eum."
,"10":"Multos enim sanavit, ita ut irruerent in eum, ut illum tangerent, quotquot habebant plagas."
,"11":"Et spiritus immundi, cum illum videbant, procidebant ei et clamabant dicentes: ' Tu es Filius Dei! '."
,"12":"Et vehementer comminabatur eis, ne manifestarent illum."
,"13":"Et ascendit in montem et vocat ad se, quos voluit ipse, et venerunt ad eum."
,"14":"Et fecit Duodecim, ut essent cum illo, et ut mitteret eos praedicare"
,"15":"habentes potestatem eiciendi daemonia:"
,"16":"et imposuit Simoni nomen Petrum;"
,"17":"et Iacobum Zebedaei et Ioannem fratrem Iacobi, et imposuit eis nomina Boanerges, quod est Filii tonitrui;"
,"18":"et Andream et Philippum et Bartholomaeum et Matthaeum et Thomam et Iacobum Alphaei et Thaddaeum et Simonem Chananaeum"
,"19":"et Iudam Iscarioth, qui et tradidit illum."
,"20":"Et venit ad domum; et convenit iterum turba, ita ut non possent neque panem manducare."
,"21":"Et cum audissent sui, exierunt tenere eum; dicebant enim: ' In furorem versus est '."
,"22":"Et scribae, qui ab Hierosolymis descenderant, dicebant: ' Beelzebul habet ' et: ' In principe daemonum eicit daemonia '."
,"23":"Et convocatis eis, in parabolis dicebat illis: ' Quomodo potest Satanas Satanam eicere?"
,"24":"Et si regnum in se dividatur, non potest stare regnum illud;"
,"25":"et si domus in semetipsam dispertiatur, non poterit domus illa stare."
,"26":"Et si Satanas consurrexit in semetipsum et dispertitus est, non potest stare, sed finem habet."
,"27":"Nemo autem potest in domum fortis ingressus vasa eius diripere, nisi prius fortem alliget; et tunc domum eius diripiet."
,"28":"Amen dico vobis: Omnia dimittentur filiis hominum peccata et blasphemiae, quibus blasphemaverint;"
,"29":"qui autem blasphemaverit in Spiritum Sanctum, non habet remissionem in aeternum, sed reus est aeterni delicti '."
,"30":"Quoniam dicebant: ' Spiritum immundum habet '."
,"31":"Et venit mater eius et fratres eius, et foris stantes miserunt ad eum vocantes eum."
,"32":"Et sedebat circa eum turba, et dicunt ei: ' Ecce mater tua et fratres tui et sorores tuae foris quaerunt te '."
,"33":"Et respondens eis ait: ' Quae est mater mea et fratres mei? '."
,"34":"Et circumspiciens eos, qui in circuitu eius sedebant, ait: ' Ecce mater mea et fratres mei."
,"35":"Qui enim fecerit voluntatem Dei, hic frater meus et soror mea et mater est '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et iterum coepit docere ad ma re. Et congregatur ad eum tur ba plurima, ita ut in navem ascendens sederet in mari, et omnis turba circa mare super terram erant."
,"2":"Et docebat eos in parabolis multa et dicebat illis in doctrina sua:"
,"3":"' Audite. Ecce exiit seminans ad seminandum."
,"4":"Et factum est, dum seminat, aliud cecidit circa viam, et venerunt volucres et comederunt illud."
,"5":"Aliud cecidit super petrosa, ubi non habebat terram multam, et statim exortum est, quoniam non habebat altitudinem terrae;"
,"6":"et quando exortus est sol, exaestuavit et, eo quod non haberet radicem, exaruit."
,"7":"Et aliud cecidit in spinas, et ascenderunt spinae et suffocaverunt illud, et fructum non dedit."
,"8":"Et alia ceciderunt in terram bonam et dabant fructum: ascendebant et crescebant et afferebant unum triginta et unum sexaginta et unum centum '."
,"9":"Et dicebat: ' Qui habet aures audiendi, audiat '."
,"10":"Et cum esset singularis, interrogaverunt eum hi, qui circa eum erant cum Duodecim, parabolas."
,"11":"Et dicebat eis: ' Vobis datum est mysterium regni Dei; illis autem, qui foris sunt, in parabolis omnia fiunt,"
,"12":"ut videntes videant et non videant, et audientes audiant et non intellegant, ne quando convertantur, et dimittatur eis '."
,"13":"Et ait illis: ' Nescitis parabolam hanc, et quomodo omnes parabolas cognoscetis?"
,"14":"Qui seminat, verbum seminat."
,"15":"Hi autem sunt, qui circa viam, ubi seminatur verbum: et cum audierint, confestim venit Satanas et aufert verbum, quod seminatum est in eos."
,"16":"Et hi sunt, qui super petrosa seminantur: qui cum audierint verbum, statim cum gaudio accipiunt illud"
,"17":"et non habent radicem in se, sed temporales sunt; deinde orta tribulatione vel persecutione propter verbum, confestim scandalizantur."
,"18":"Et alii sunt, qui in spinis seminantur: hi sunt, qui verbum audierunt,"
,"19":"et aerumnae saeculi et deceptio divitiarum et circa reliqua concupiscentiae introeuntes suffocant verbum, et sine fructu efficitur."
,"20":"Et hi sunt, qui super terram bonam seminati sunt: qui audiunt verbum et suscipiunt et fructificant unum triginta et unum sexaginta et unum centum '."
,"21":"Et dicebat illis: ' Numquid venit lucerna, ut sub modio ponatur aut sub lecto? Nonne ut super candelabrum ponatur?"
,"22":"Non enim est aliquid absconditum, nisi ut manifestetur, nec factum est occultum, nisi ut in palam veniat."
,"23":"Si quis habet aures audiendi, audiat '."
,"24":"Et dicebat illis: ' Videte quid audiatis. In qua mensura mensi fueritis, remetietur vobis et adicietur vobis."
,"25":"Qui enim habet, dabitur illi; et, qui non habet, etiam quod habet, auferetur ab illo '."
,"26":"Et dicebat: ' Sic est regnum Dei, quemadmodum si homo iaciat sementem in terram"
,"27":"et dormiat et exsurgat nocte ac die, et semen germinet et increscat, dum nescit ille."
,"28":"Ultro terra fructificat primum herbam, deinde spicam, deinde plenum frumentum in spica."
,"29":"Et cum se produxerit fructus, statim mittit falcem, quoniam adest messis '."
,"30":"Et dicebat: ' Quomodo assimilabimus regnum Dei aut in qua parabola ponemus illud?"
,"31":"Sicut granum sinapis, quod cum seminatum fuerit in terra, minus est omnibus seminibus, quae sunt in terra;"
,"32":"et cum seminatum fuerit, ascendit et fit maius omnibus holeribus et facit ramos magnos, ita ut possint sub umbra eius aves caeli habitare '."
,"33":"Et talibus multis parabolis loquebatur eis verbum, prout poterant audire;"
,"34":"sine parabola autem non loquebatur eis. Seorsum autem discipulis suis disserebat omnia."
,"35":"Et ait illis illa die, cum sero esset factum: ' Transeamus contra '."
,"36":"Et dimittentes turbam, assumunt eum, ut erat in navi; et aliae naves erant cum illo."
,"37":"Et exoritur procella magna venti, et fluctus se mittebant in navem, ita ut iam impleretur navis."
,"38":"Et erat ipse in puppi supra cervical dormiens; et excitant eum et dicunt ei: ' Magister, non ad te pertinet quia perimus? '."
,"39":"Et exsurgens comminatus est vento et dixit mari: ' Tace, obmutesce! '. Et cessavit ventus, et facta est tranquillitas magna."
,"40":"Et ait illis: ' Quid timidi estis? Necdum habetis fidem? '."
,"41":"Et timuerunt magno timore et dicebant ad alterutrum: ' Quis putas est iste, quia et ventus et mare oboediunt ei? '."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et venerunt trans fretum maris in regionem Gerasenorum."
,"2":"Et exeunte eo de navi, statim occurrit ei de monumentis homo in spiritu immundo,"
,"3":"qui domicilium habebat in monumentis; et neque catenis iam quisquam eum poterat ligare,"
,"4":"quoniam saepe compedibus et catenis vinctus dirupisset catenas et compedes comminuisset, et nemo poterat eum domare;"
,"5":"et semper nocte ac die in monumentis et in montibus erat clamans et concidens se lapidibus."
,"6":"Et videns Iesum a longe cucurrit et adoravit eum"
,"7":"et clamans voce magna dicit: ' Quid mihi et tibi, Iesu, fili Dei Altissimi? Adiuro te per Deum, ne me torqueas '."
,"8":"Dicebat enim illi: ' Exi, spiritus immunde, ab homine '."
,"9":"Et interrogabat eum: ' Quod tibi nomen est? '. Et dicit ei: ' Legio nomen mihi est, quia multi sumus '."
,"10":"Et deprecabatur eum multum, ne se expelleret extra regionem."
,"11":"Erat autem ibi circa montem grex porcorum magnus pascens;"
,"12":"et deprecati sunt eum dicentes: ' Mitte nos in porcos, ut in eos introeamus '."
,"13":"Et concessit eis. Et exeuntes spiritus immundi introierunt in porcos. Et magno impetu grex ruit per praecipitium in mare, ad duo milia, et suffocabantur in mari."
,"14":"Qui autem pascebant eos, fugerunt et nuntiaverunt in civitatem et in agros; et egressi sunt videre quid esset facti."
,"15":"Et veniunt ad Iesum; et vident illum, qui a daemonio vexabatur, sedentem, vestitum et sanae mentis, eum qui legionem habuerat, et timuerunt."
,"16":"Et qui viderant, narraverunt illis qualiter factum esset ei, qui daemonium habuerat, et de porcis."
,"17":"Et rogare eum coeperunt, ut discederet a finibus eorum."
,"18":"Cumque ascenderet navem, qui daemonio vexatus fuerat, deprecabatur eum, ut esset cum illo."
,"19":"Et non admisit eum, sed ait illi: ' Vade in domum tuam ad tuos et annuntia illis quanta tibi Dominus fecerit et misertus sit tui '."
,"20":"Et abiit et coepit praedicare in Decapoli quanta sibi fecisset Iesus, et omnes mirabantur."
,"21":"Et cum transcendisset Iesus in navi rursus trans fretum, convenit turba multa ad illum, et erat circa mare."
,"22":"Et venit quidam de archisynagogis nomine Iairus et videns eum procidit ad pedes eius"
,"23":"et deprecatur eum multum dicens: ' Filiola mea in extremis est; veni, impone manus super eam, ut salva sit et vivat '."
,"24":"Et abiit cum illo. Et sequebatur eum turba multa et comprimebant illum."
,"25":"Et mulier, quae erat in profluvio sanguinis annis duodecim"
,"26":"et fuerat multa perpessa a compluribus medicis et erogaverat omnia sua nec quidquam profecerat, sed magis deterius habebat,"
,"27":"cum audisset de Iesu, venit in turba retro et tetigit vestimentum eius;"
,"28":"dicebat enim: ' Si vel vestimenta eius tetigero, salva ero '."
,"29":"Et confestim siccatus est fons sanguinis eius, et sensit corpore quod sanata esset a plaga."
,"30":"Et statim Iesus cognoscens in semetipso virtutem, quae exierat de eo, conversus ad turbam aiebat: ' Quis tetigit vestimenta mea? '."
,"31":"Et dicebant ei discipuli sui: ' Vides turbam comprimentem te et dicis: 'Quis me tetigit?' '."
,"32":"Et circumspiciebat videre eam, quae hoc fecerat."
,"33":"Mulier autem timens et tremens, sciens quod factum esset in se, venit et procidit ante eum et dixit ei omnem veritatem."
,"34":"Ille autem dixit ei: ' Filia, fides tua te salvam fecit. Vade in pace et esto sana a plaga tua '."
,"35":"Adhuc eo loquente, veniunt ab archisynagogo dicentes: ' Filia tua mortua est; quid ultra vexas magistrum? '."
,"36":"Iesus autem, verbo, quod dicebatur, audito, ait archisynagogo: ' Noli timere; tantummodo crede! '."
,"37":"Et non admisit quemquam sequi se nisi Petrum et Iacobum et Ioannem fratrem Iacobi."
,"38":"Et veniunt ad domum archisynagogi; et videt tumultum et flentes et eiulantes multum,"
,"39":"et ingressus ait eis: ' Quid turbamini et ploratis? Puella non est mortua, sed dormit '."
,"40":"Et irridebant eum. Ipse vero, eiectis omnibus, assumit patrem puellae et matrem et, qui secum erant, et ingreditur, ubi erat puella;"
,"41":"et tenens manum puellae ait illi: ' Talitha, qum! ' - quod est interpretatum: ' Puella, tibi dico: Surge! ' -."
,"42":"Et confestim surrexit puella et ambulabat; erat enim annorum duodecim. Et obstupuerunt continuo stupore magno."
,"43":"Et praecepit illis vehementer, ut nemo id sciret, et dixit dari illi manducare."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et egressus est inde et venit in patriam suam, et sequuntur il lum discipuli sui."
,"2":"Et facto sabbato, coepit in synagoga docere; et multi audientes admirabantur dicentes: ' Unde huic haec, et quae est sapientia, quae data est illi, et virtutes tales, quae per manus eius efficiuntur?"
,"3":"Nonne iste est faber, filius Mariae et frater Iacobi et Iosetis et Iudae et Simonis? Et nonne sorores eius hic nobiscum sunt? '. Et scandalizabantur in illo."
,"4":"Et dicebat eis Iesus: ' Non est propheta sine honore nisi in patria sua et in cognatione sua et in domo sua '."
,"5":"Et non poterat ibi virtutem ullam facere, nisi paucos infirmos impositis manibus curavit;"
,"6":"et mirabatur propter incredulitatem eorum. Et circumibat castella in circuitu docens."
,"7":"Et convocat Duodecim et coepit eos mittere binos et dabat illis potestatem in spiritus immundos;"
,"8":"et praecepit eis, ne quid tollerent in via nisi virgam tantum: non panem, non peram neque in zona aes,"
,"9":"sed ut calcearentur sandaliis et ne induerentur duabus tunicis."
,"10":"Et dicebat eis: ' Quocumque introieritis in domum, illic manete, donec exeatis inde."
,"11":"Et quicumque locus non receperit vos nec audierint vos, exeuntes inde excutite pulverem de pedibus vestris in testimonium illis '."
,"12":"Et exeuntes praedicaverunt, ut paenitentiam agerent;"
,"13":"et daemonia multa eiciebant et ungebant oleo multos aegrotos et sanabant."
,"14":"Et audivit Herodes rex; manifestum enim factum est nomen eius. Et dicebant: ' Ioannes Baptista resurrexit a mortuis, et propterea inoperantur virtutes in illo '."
,"15":"Alii autem dicebant: ' Elias est '. Alii vero dicebant: ' Propheta est, quasi unus ex prophetis '."
,"16":"Quo audito, Herodes aiebat: ' Quem ego decollavi Ioannem, hic resurrexit! '."
,"17":"Ipse enim Herodes misit ac tenuit Ioannem et vinxit eum in carcere propter Herodiadem uxorem Philippi fratris sui, quia duxerat eam."
,"18":"Dicebat enim Ioannes Herodi: ' Non licet tibi habere uxorem fratris tui '."
,"19":"Herodias autem insidiabatur illi et volebat occidere eum nec poterat:"
,"20":"Herodes enim metuebat Ioannem, sciens eum virum iustum et sanctum, et custodiebat eum, et, audito eo, multum haesitabat et libenter eum audiebat."
,"21":"Et cum dies opportunus accidisset, quo Herodes natali suo cenam fecit principibus suis et tribunis et primis Galilaeae,"
,"22":"cumque introisset filia ipsius Herodiadis et saltasset, placuit Herodi simulque recumbentibus. Rex ait puellae: ' Pete a me, quod vis, et dabo tibi '."
,"23":"Et iuravit illi multum: ' Quidquid petieris a me, dabo tibi, usque ad dimidium regni mei '."
,"24":"Quae cum exisset, dixit matri suae: ' Quid petam? '. At illa dixit: ' Caput Ioannis Baptistae '."
,"25":"Cumque introisset statim cum festinatione ad regem, petivit dicens: ' Volo ut protinus des mihi in disco caput Ioannis Baptistae '."
,"26":"Et contristatus rex, propter iusiurandum et propter recumbentes noluit eam decipere;"
,"27":"et statim misso spiculatore rex praecepit afferri caput eius. Et abiens decollavit eum in carcere"
,"28":"et attulit caput eius in disco; et dedit illud puellae, et puella dedit illud matri suae."
,"29":"Quo audito, discipuli eius venerunt et tulerunt corpus eius et posuerunt illud in monumento."
,"30":"Et convenientes apostoli ad Iesum renuntiaverunt illi omnia, quae egerant et docuerant."
,"31":"Et ait illis: ' Venite vos ipsi seorsum in desertum locum et requiescite pusillum '. Erant enim, qui veniebant et redibant, multi, et nec manducandi spatium habebant."
,"32":"Et abierunt in navi in desertum locum seorsum."
,"33":"Et viderunt eos abeuntes et cognoverunt multi; et pedestre de omnibus civitatibus concurrerunt illuc et praevenerunt eos."
,"34":"Et exiens vidit multam turbam et misertus est super eos, quia erant sicut oves non habentes pastorem, et coepit docere illos multa."
,"35":"Et cum iam hora multa facta esset, accesserunt discipuli eius dicentes: ' Desertus est locus hic, et hora iam est multa;"
,"36":"dimitte illos, ut euntes in villas et vicos in circuitu emant sibi, quod manducent '."
,"37":"Respondens autem ait illis: ' Date illis vos manducare '. Et dicunt ei: ' Euntes emamus denariis ducentis panes et dabimus eis manducare? '."
,"38":"Et dicit eis: ' Quot panes habetis? Ite, videte '. Et cum cognovissent, dicunt: ' Quinque et duos pisces '."
,"39":"Et praecepit illis, ut accumbere facerent omnes secundum contubernia super viride fenum."
,"40":"Et discubuerunt secundum areas per centenos et per quinquagenos."
,"41":"Et acceptis quinque panibus et duobus piscibus, intuens in caelum benedixit et fregit panes et dabat discipulis suis, ut ponerent ante eos; et duos pisces divisit omnibus."
,"42":"Et manducaverunt omnes et saturati sunt;"
,"43":"et sustulerunt fragmenta duodecim cophinos plenos, et de piscibus."
,"44":"Et erant, qui manducaverunt panes, quinque milia virorum."
,"45":"Et statim coegit discipulos suos ascendere navem, ut praecederent trans fretum ad Bethsaidam, dum ipse dimitteret populum."
,"46":"Et cum dimisisset eos, abiit in montem orare."
,"47":"Et cum sero factum esset, erat navis in medio mari, et ipse solus in terra."
,"48":"Et videns eos laborantes in remigando, erat enim ventus contrarius eis, circa quartam vigiliam noctis venit ad eos ambulans super mare et volebat praeterire eos."
,"49":"At illi, ut viderunt eum ambulantem super mare, putaverunt phantasma esse et exclamaverunt;"
,"50":"omnes enim eum viderunt et conturbati sunt. Statim autem locutus est cum eis et dicit illis: ' Confidite, ego sum; nolite timere! '."
,"51":"Et ascendit ad illos in navem, et cessavit ventus. Et valde nimis intra se stupebant;"
,"52":"non enim intellexerant de panibus, sed erat cor illorum obcaecatum."
,"53":"Et cum transfretassent in terram, pervenerunt Gennesaret et applicuerunt."
,"54":"Cumque egressi essent de navi, continuo cognoverunt eum"
,"55":"et percurrentes universam regionem illam coeperunt in grabatis eos, qui se male habebant, circumferre, ubi audiebant eum esse."
,"56":"Et quocumque introibat in vicos aut in civitates vel in villas, in plateis ponebant infirmos; et deprecabantur eum, ut vel fimbriam vestimenti eius tangerent; et, quotquot tangebant eum, salvi fiebant."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Et conveniunt ad eum pharisaei et quidam de scribis venientes ab Hierosolymis;"
,"2":"et cum vidissent quosdam ex discipulis eius communibus manibus, id est non lotis, manducare panes"
,"3":"- pharisaei enim et omnes Iudaei, nisi pugillo lavent manus, non manducant, tenentes traditionem seniorum;"
,"4":"et a foro nisi baptizentur, non comedunt; et alia multa sunt, quae acceperunt servanda: baptismata calicum et urceorum et aeramentorum et lectorum -"
,"5":"et interrogant eum pharisaei et scribae: ' Quare discipuli tui non ambulant iuxta traditionem seniorum, sed communibus manibus manducant panem? '."
,"6":"At ille dixit eis: ' Bene prophetavit Isaias de vobis hypocritis, sicut scriptum est: 'Populus hic labiis me honorat, cor autem eorum longe est a me;"
,"7":"in vanum autem me colunt,docentes doctrinas praecepta hominum'."
,"8":"Relinquentes mandatum Dei tenetis traditionem hominum '."
,"9":"Et dicebat illis: ' Bene irritum facitis praeceptum Dei, ut traditionem vestram servetis."
,"10":"Moyses enim dixit: 'Honora patrem tuum et matrem tuam' et: 'Qui maledixerit patri aut matri, morte moriatur';"
,"11":"vos autem dicitis: 'Si dixerit homo patri aut matri: Corban, quod est donum, quodcumque ex me tibi profuerit',"
,"12":"ultra non permittitis ei facere quidquam patri aut matri"
,"13":"rescindentes verbum Dei per traditionem vestram, quam tradidistis; et similia huiusmodi multa facitis '."
,"14":"Et advocata iterum turba, dicebat illis: ' Audite me, omnes, et intellegite:"
,"15":"Nihil est extra hominem introiens in eum, quod possit,eum coinquinare; sed quae de homine procedunt, illa sunt, quae coinquinant hominem! '. (16) 17 Et cum introisset in domum a turba, interrogabant eum discipuli eius parabolam. "
,"18":"Et ait illis: ' Sic et vos imprudentes estis? Non intellegitis quia omne extrinsecus introiens in hominem non potest eum coinquinare,"
,"19":"quia non introit in cor eius sed in ventrem et in secessum exit? ', purgans omnes escas."
,"20":"Dicebat autem: ' Quod de homine exit, illud coinquinat hominem;"
,"21":"ab intus enim de corde hominum cogitationes malae procedunt, fornicationes, furta, homicidia,"
,"22":"adulteria, avaritiae, nequitiae, dolus, impudicitia, oculus malus, blasphemia, superbia, stultitia:"
,"23":"omnia haec mala ab intus procedunt et coinquinant hominem '."
,"24":"Inde autem surgens abiit in fines Tyri et Sidonis. Et ingressus domum neminem voluit scire et non potuit latere."
,"25":"Sed statim ut audivit de eo mulier, cuius habebat filia spiritum immundum, veniens procidit ad pedes eius."
,"26":"Erat autem mulier Graeca, Syrophoenissa genere. Et rogabat eum, ut daemonium eiceret de filia eius."
,"27":"Et dicebat illi: ' Sine prius saturari filios; non est enim bonum sumere panem filiorum et mittere catellis '."
,"28":"At illa respondit et dicit ei: ' Domine, etiam catelli sub mensa comedunt de micis puerorum '."
,"29":"Et ait illi: ' Propter hunc sermonem vade; exiit daemonium de filia tua '."
,"30":"Et cum abisset domum suam, invenit puellam iacentem supra lectum et daemonium exisse."
,"31":"Et iterum exiens de finibus Tyri venit per Sidonem ad mare Galilaeae inter medios fines Decapoleos."
,"32":"Et adducunt ei surdum et mutum et deprecantur eum, ut imponat illi manum."
,"33":"Et apprehendens eum de turba seorsum misit digitos suos in auriculas eius et exspuens tetigit linguam eius"
,"34":"et suspiciens in caelum ingemuit et ait illi: ' Effetha ', quod est: ' Adaperire '."
,"35":"Et statim apertae sunt aures eius, et solutum est vinculum linguae eius, et loquebatur recte."
,"36":"Et praecepit illis, ne cui dicerent; quanto autem eis praecipiebat, tanto magis plus praedicabant."
,"37":"Et eo amplius admirabantur dicentes: ' Bene omnia fecit, et surdos facit audire et mutos loqui! '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"In illis diebus iterum cum turba multa esset nec haberent, quod manducarent, convocatis discipulis, ait illis:"
,"2":"' Misereor super turbam, quia iam triduo sustinent me nec habent, quod manducent;"
,"3":"et si dimisero eos ieiunos in domum suam, deficient in via; et quidam ex eis de longe venerunt '."
,"4":"Et responderunt ei discipuli sui: ' Unde istos poterit quis hic saturare panibus in solitudine? '."
,"5":"Et interrogabat eos: ' Quot panes habetis? '. Qui dixerunt: ' Septem '."
,"6":"Et praecipit turbae discumbere supra terram; et accipiens septem panes, gratias agens fregit et dabat discipulis suis, ut apponerent; et apposuerunt turbae."
,"7":"Et habebant pisciculos paucos; et benedicens eos, iussit hos quoque apponi."
,"8":"Et manducaverunt et saturati sunt; et sustulerunt, quod superaverat de fragmentis, septem sportas."
,"9":"Erant autem quasi quattuor milia. Et dimisit eos."
,"10":"Et statim ascendens navem cum discipulis suis venit in partes Dalmanutha."
,"11":"Et exierunt pharisaei et coeperunt conquirere cum eo quaerentes ab illo signum de caelo, tentantes eum."
,"12":"Et ingemiscens spiritu suo ait: ' Quid generatio ista quaerit signum? Amen dico vobis: Non dabitur generationi isti signum '."
,"13":"Et dimittens eos, iterum ascendens abiit trans fretum."
,"14":"Et obliti sunt sumere panes et nisi unum panem non habebant secum in navi."
,"15":"Et praecipiebat eis dicens: ' Videte, cavete a fermento pharisaeorum et fermento Herodis! '."
,"16":"Et disputabant ad invicem, quia panes non haberent."
,"17":"Quo cognito, ait illis: ' Quid disputatis, quia panes non habetis? Nondum cognoscitis nec intellegitis? Caecatum habetis cor vestrum?"
,"18":"Oculos habentes non videtis, et aures habentes non auditis? Nec recordamini,"
,"19":"quando quinque panes fregi in quinque milia, quot cophinos fragmentorum plenos sustulistis? '. Dicunt ei: ' Duodecim '."
,"20":"' Quando illos septem in quattuor milia, quot sportas plenas fragmentorum tulistis? '. Et dicunt ei: ' Septem '."
,"21":"Et dicebat eis: ' Nondum intellegitis? '."
,"22":"Et veniunt Bethsaida. Et adducunt ei caecum et rogant eum, ut illum tangat."
,"23":"Et apprehendens manum caeci eduxit eum extra vicum; et exspuens in oculos eius, impositis manibus ei, interrogabat eum: ' Vides aliquid? '."
,"24":"Et aspiciens dicebat: ' Video homines, quia velut arbores video ambulantes '."
,"25":"Deinde iterum imposuit manus super oculos eius; et coepit videre et restitutus est et videbat clare omnia."
,"26":"Et misit illum in domum suam dicens: ' Nec in vicum introieris '."
,"27":"Et egressus est Iesus et discipuli eius in castella Caesareae Philippi; et in via interrogabat discipulos suos dicens eis: ' Quem me dicunt esse homines? '."
,"28":"Qui responderunt illi dicentcs: ' Ioannem Baptistam, alii Eliam, alii vero unum de prophetis '."
,"29":"Et ipse interrogabat eos: ' Vos vero quem me dicitis esse? '. Respondens Petrus ait ei: ' Tu es Christus '."
,"30":"Et comminatus est eis, ne cui dicerent de illo."
,"31":"Et coepit docere illos: ' Oportet Filium hominis multa pati et reprobari a senioribus et a summis sacerdotibus et scribis et occidi et post tres dies resurgere ';"
,"32":"et palam verbum loquebatur. Et apprehendens eum Petrus coepit increpare eum."
,"33":"Qui conversus et videns discipulos suos comminatus est Petro et dicit: ' Vade retro me, Satana, quoniam non sapis, quae Dei sunt, sed quae sunt hominum '."
,"34":"Et convocata turba cum discipulis suis, dixit eis: ' Si quis vult post me sequi, deneget semetipsum et tollat crucem suam et sequatur me."
,"35":"Qui enim voluerit animam suam salvam facere, perdet eam; qui autem perdiderit animam suam propter me et evangelium, salvam eam faciet."
,"36":"Quid enim prodest homini, si lucretur mundum totum et detrimentum faciat animae suae?"
,"37":"Quid enim dabit homo commutationem pro anima sua?"
,"38":"Qui enim me confusus fuerit et mea verba in generatione ista adultera et peccatrice, et Filius hominis confundetur eum, cum venerit in gloria Patris sui cum angelis sanctis '."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et dicebat illis: ' Amen dico vobis: Sunt quidam de hic stan tibus, qui non gustabunt mortem, donec videant regnum Dei venisse in virtute '."
,"2":"Et post dies sex assumit Iesus Petrum et Iacobum et Ioannem, et ducit illos in montem excelsum seorsum solos. Et transfiguratus est coram ipsis;"
,"3":"et vestimenta eius facta sunt splendentia, candida nimis, qualia fullo super terram non potest tam candida facere."
,"4":"Et apparuit illis Elias cum Moyse, et erant loquentes cum Iesu."
,"5":"Et respondens Petrus ait Iesu: ' Rabbi, bonum est nos hic esse; et faciamus tria tabernacula: tibi unum et Moysi unum et Eliae unum '."
,"6":"Non enim sciebat quid responderet; erant enim exterriti."
,"7":"Et facta est nubes obumbrans eos, et venit vox de nube: ' Hic est Filius meus dilectus; audite illum '."
,"8":"Et statim circumspicientes neminem amplius viderunt nisi Iesum tantum secum."
,"9":"Et descendentibus illis de monte, praecepit illis, ne cui, quae vidissent, narrarent, nisi cum Filius hominis a mortuis resurrexerit."
,"10":"Et verbum continuerunt apud se, conquirentes quid esset illud: ' a mortuis resurgere '."
,"11":"Et interrogabant eum dicentes: ' Quid ergo dicunt scribae quia Eliam oporteat venire primum? '."
,"12":"Qui ait illis: ' Elias veniens primo, restituit omnia; et quomodo scriptum est super Filio hominis, ut multa patiatur et contemnatur?"
,"13":"Sed dico vobis: Et Elias venit; et fecerunt illi, quaecumque volebant, sicut scriptum est de eo '."
,"14":"Et venientes ad discipulos viderunt turbam magnam circa eos et scribas conquirentes cum illis."
,"15":"Et confestim omnis populus videns eum stupefactus est, et accurrentes salutabant eum."
,"16":"Et interrogavit eos: ' Quid inter vos conquiritis? '."
,"17":"Et respondit ei unus de turba: ' Magister, attuli filium meum ad te habentem spiritum mutum;"
,"18":"et ubicumque eum apprehenderit, allidit eum, et spumat et stridet dentibus et arescit. Et dixi discipulis tuis, ut eicerent illum, et non potuerunt '."
,"19":"Qui respondens eis dicit: ' O generatio incredula, quamdiu apud vos ero? Quamdiu vos patiar? Afferte illum ad me '."
,"20":"Et attulerunt illum ad eum. Et cum vidisset illum, spiritus statim conturbavit eum; et corruens in terram volutabatur spumans."
,"21":"Et interrogavit patrem eius: ' Quantum temporis est, ex quo hoc ei accidit? '. At ille ait: ' Ab infantia;"
,"22":"et frequenter eum etiam in ignem et in aquas misit, ut eum perderet; sed si quid potes, adiuva nos, misertus nostri '."
,"23":"Iesus autem ait illi: ' 'Si potes!'. Omnia possibilia credenti '."
,"24":"Et continuo exclamans pater pueri aiebat: ' Credo; adiuva incredulitatem meam '."
,"25":"Et cum videret Iesus concurrentem turbam, comminatus est spiritui immundo dicens illi: ' Mute et surde spiritus, ego tibi praecipio: Exi ab eo et amplius ne introeas in eum '."
,"26":"Et clamans et multum discerpens eum exiit; et factus est sicut mortuus, ita ut multi dicerent: ' Mortuus est! '."
,"27":"Iesus autem tenens manum eius elevavit illum, et surrexit."
,"28":"Et cum introisset in domum, discipuli eius secreto interrogabant eum: ' Quare nos non potuimus eicere eum? '."
,"29":"Et dixit illis: ' Hoc genus in nullo potest exire nisi in oratione '."
,"30":"Et inde profecti peragrabant Galilaeam; nec volebat quemquam scire."
,"31":"Docebat enim discipulos suos et dicebat illis: ' Filius hominis traditur in manus hominum, et occident eum, et occisus post tres dies resurget '."
,"32":"At illi ignorabant verbum et timebant eum interrogare."
,"33":"Et venerunt Capharnaum. Qui cum domi esset, interrogabat eos: ' Quid in via tractabatis? '."
,"34":"At illi tacebant. Siquidem inter se in via disputaverant, quis esset maior."
,"35":"Et residens vocavit Duodecim et ait illis: ' Si quis vult primus esse, erit omnium novissimus et omnium minister '."
,"36":"Et accipiens puerum, statuit eum in medio eorum; quem ut complexus esset, ait illis:"
,"37":"' Quisquis unum ex huiusmodi pueris receperit in nomine meo, me recipit; et, quicumque me susceperit, non me suscipit, sed eum qui me misit '."
,"38":"Dixit illi Ioannes: ' Magister, vidimus quendam in nomine tuo eicientem daemonia, et prohibebamus eum, quia non sequebatur nos '."
,"39":"Iesus autem ait: ' Nolite prohibere eum. Nemo est enim, qui faciat virtutem in nomine meo et possit cito male loqui de me;"
,"40":"qui enim non est adversum nos, pro nobis est."
,"41":"Quisquis enim potum dederit vobis calicem aquae in nomine, quia Christi estis, amen dico vobis: Non perdet mercedem suam."
,"42":"Et quisquis scandalizaverit unum ex his pusillis credentibus in me, bonum est ei magis, ut circumdetur mola asinaria collo eius, et in mare mittatur."
,"43":"Et si scandalizaverit te manus tua, abscide illam: bonum est tibi debilem introire in vitam, quam duas manus habentem ire in,gehennam, in ignem inexstinguibilem. (44) 45 Et si pes tuus te scandalizat, amputa illum: bonum est tibi claudum introire in vitam, quam duos pedes habentem mitti in gehennam. (46) 47 Et si oculus tuus scandalizat te, eice eum: bonum est tibi luscum introire in regnum Dei, quam duos oculos habentem mitti in gehennam, "
,"48":"ubi vermis eorum non moritur, et ignis non exstinguitur;"
,"49":"omnis enim igne salietur."
,"50":"Bonum est sal; quod si sal insulsum fuerit, in quo illud condietis? Habete in vobis sal et pacem habete inter vos '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Et inde exsurgens venit in fines Iudaeae ultra Iorda nem; et conveniunt iterum turbae ad eum, et, sicut consueverat, iterum docebat illos."
,"2":"Et accedentes pharisaei interrogabant eum, si licet viro uxorem dimittere, tentantes eum."
,"3":"At ille respondens dixit eis: ' Quid vobis praecepit Moyses? '."
,"4":"Qui dixerunt: ' Moyses permisit libellum repudii scribere et dimittere '."
,"5":"Iesus autem ait eis: ' Ad duritiam cordis vestri scripsit vobis praeceptum istud."
,"6":"Ab initio autem creaturae masculum et feminam fecit eos."
,"7":"Propter hoc relinquet homo patrem suum et matrem et adhaerebit ad uxorern suam,"
,"8":"et erunt duo in carne una; itaque iam non sunt duo sed una caro."
,"9":"Quod ergo Deus coniunxit, homo non separet '."
,"10":"Et domo iterum discipuli de hoc interrogabant eum."
,"11":"Et dicit illis: ' Quicumque dimiserit uxorem suam et aliam duxerit, adulterium committit in eam;"
,"12":"et si ipsa dimiserit virum suum et alii nupserit, moechatur '."
,"13":"Et offerebant illi parvulos, ut tangeret illos; discipuli autem comminabantur eis."
,"14":"At videns Iesus, indigne tulit et ait illis: ' Sinite parvulos venire ad me. Ne prohibueritis eos; talium est enim regnum Dei."
,"15":"Amen dico vobis: Quisquis non receperit regnum Dei velut parvulus, non intrabit in illud '."
,"16":"Et complexans eos benedicebat imponens manus super illos."
,"17":"Et cum egrederetur in viam, accurrens quidam et, genu flexo ante eum, rogabat eum: ' Magister bone, quid faciam ut vitam aeternam percipiam? '."
,"18":"Iesus autem dixit ei: ' Quid me dicis bonum? Nemo bonus, nisi unus Deus."
,"19":"Praecepta nosti: ne occidas, ne adulteres, ne fureris, ne falsum testimonium dixeris, ne fraudem feceris, honora patrem tuum et matrem '."
,"20":"Ille autem dixit ei: ' Magister, haec omnia conservavi a iuventute mea '."
,"21":"Iesus autem intuitus eum dilexit eum et dixit illi: ' Unum tibi deest: vade, quaecumque habes, vende et da pauperibus et habebis thesaurum in caelo; et veni, sequere me '."
,"22":"Qui contristatus in hoc verbo, abiit maerens: erat enim habens possessiones multas."
,"23":"Et circumspiciens Iesus ait discipulis suis: ' Quam difficile, qui pecunias habent, in regnum Dei introibunt '."
,"24":"Discipuli autem obstupescebant in verbis eius. At Iesus rursus respondens ait illis: ' Filii, quam diffficile est in regnum Dei introire."
,"25":"Facilius est camelum per foramen acus transire quam divitem intrare in regnum Dei '."
,"26":"Qui magis admirabantur dicentes ad semetipsos: ' Et quis potest salvus fieri? '."
,"27":"Intuens illos Iesus ait: ' Apud homines impossibile est sed non apud Deum: omnia enim possibilia sunt apud Deum '."
,"28":"Coepit Petrus ei dicere: ' Ecce nos dimisimus omnia et secuti sumus te '."
,"29":"Ait Iesus: ' Amen dico vobis: Nemo est, qui reliquerit domum aut fratres aut sorores aut matrem aut patrem aut filios aut agros propter me et propter evangelium,"
,"30":"qui non accipiat centies tantum nunc in tempore hoc, domos et fratres et sorores et matres et filios et agros cum persecutionibus, et in saeculo futuro vitam aeternam."
,"31":"Multi autem erunt primi novissimi, et novissimi primi '."
,"32":"Erant autem in via ascendentes in Hierosolymam, et praecedebat illos Iesus, et stupebant; illi autem sequentes timebant. Et assumens iterum Duodecim coepit illis dicere, quae essent ei eventura:"
,"33":"' Ecce ascendimus in Hierosolymam; et Filius hominis tradetur principibus sacerdotum et scribis, et damnabunt eum morte et tradent eum gentibus"
,"34":"et illudent ei et conspuent eum et flagellabunt eum et interficient eum, et post tres dies resurget '."
,"35":"Et accedunt ad eum Iacobus et Ioannes filii Zebedaei dicentes ei: ' Magister, volumus, ut quodcumque petierimus a te, facias nobis '."
,"36":"At ille dixit eis: ' Quid vultis, ut faciam vobis? '."
,"37":"Illi autem dixerunt ei: ' Da nobis, ut unus ad dexteram tuam et alius ad sinistram sedeamus in gloria tua '."
,"38":"Iesus autem ait eis: ' Nescitis quid petatis. Potestis bibere calicem, quem ego bibo, aut baptismum, quo ego baptizor, baptizari? '."
,"39":"At illi dixerunt ei: ' Possumus '. Iesus autem ait eis: ' Calicem quidem, quem ego bibo, bibetis et baptismum, quo ego baptizor, baptizabimini;"
,"40":"sedere autem ad dexteram meam vel ad sinistram non est meum dare, sed quibus paratum est '."
,"41":"Et audientes decem coeperunt indignari de Iacobo et Ioanne."
,"42":"Et vocans eos Iesus ait illis: ' Scitis quia hi, qui videntur principari gentibus, dominantur eis, et principes eorum potestatem habent ipsorum."
,"43":"Non ita est autem in vobis, sed quicumque voluerit fieri maior inter vos, erit vester minister;"
,"44":"et, quicumque voluerit in vobis primus esse, erit omnium servus;"
,"45":"nam et Filius hominis non venit, ut ministraretur ei, sed ut ministraret et daret animam suam redemptionem pro multis '."
,"46":"Et veniunt Ierichum. Et proficiscente eo de Iericho et discipulis eius et plurima multitudine, filius Timaei Bartimaeus caecus sedebat iuxta viam mendicans."
,"47":"Qui cum audisset quia Iesus Nazarenus est, coepit clamare et dicere: ' Fili David Iesu, miserere mei! '."
,"48":"Et comminabantur ei multi, ut taceret; at ille multo magis clamabat: ' Fili David, miserere mei! '."
,"49":"Et stans Iesus dixit: ' Vocate illum '. Et vocant caecum dicentes ei: ' Animaequior esto. Surge, vocat te '."
,"50":"Qui, proiecto vestimento suo, exsiliens venit ad Iesum."
,"51":"Et respondens ei Iesus dixit: ' Quid vis tibi faciam? '. Caecus autem dixit ei: ' Rabboni, ut videam '."
,"52":"Et Iesus ait illi: ' Vade; fides tua te salvum fecit '. Et confestim vidit et sequebatur eum in via."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et cum appropinquarent Hierosolymae, Bethphage et Bethaniae ad montem Olivarum, mittit duos ex discipulis suis"
,"2":"et ait illis: ' Ite in castellum, quod est contra vos, et statim introeuntes illud invenietis pullum ligatum, super quem nemo adhuc hominum sedit; solvite illum et adducite."
,"3":"Et si quis vobis dixerit: 'Quid facitis hoc?', dicite: 'Domino necessarius est, et continuo illum remittit iterum huc' '."
,"4":"Et abeuntes invenerunt pullum ligatum ante ianuam foris in bivio et solvunt eum."
,"5":"Et quidam de illic stantibus dicebant illis: ' Quid facitis solventes pullum? '."
,"6":"Qui dixerunt eis, sicut dixerat Iesus; et dimiserunt eis."
,"7":"Et ducunt pullum ad Iesum et imponunt illi vestimenta sua; et sedit super eum."
,"8":"Et multi vestimenta sua straverunt in via, alii autem frondes, quas exciderant in agris."
,"9":"Et qui praeibant et qui sequebantur, clamabant: ' Hosanna! Benedictus, qui venit in nomine Domini!"
,"10":"Benedictum, quod venit regnum patris nostri David! Hosanna in excelsis! '."
,"11":"Et introivit Hierosolymam in templum; et circumspectis omnibus, cum iam vespera esset hora, exivit in Bethaniam cum Duodecim."
,"12":"Et altera die cum exirent a Bethania, esuriit."
,"13":"Cumque vidisset a longe ficum habentem folia, venit si quid forte inveniret in ea; et cum venisset ad eam, nihil invenit praeter folia: non enim erat tempus ficorum."
,"14":"Et respondens dixit ei: ' Iam non amplius in aeternum quisquam fructum ex te manducet '. Et audiebant discipuli eius."
,"15":"Et veniunt Hierosolymam. Et cum introisset in templum, coepit eicere vendentes et ementes in templo et mensas nummulariorum et cathedras vendentium columbas evertit;"
,"16":"et non sinebat, ut quisquam vas transferret per templum."
,"17":"Et docebat dicens eis: ' Non scriptum est: 'Domus mea domus orationis vocabitur omnibus gentibus'? Vos autem fecistis eam speluncam latronum '."
,"18":"Quo audito, principes sacerdotum et scribae quaerebant quomodo eum perderent; timebant enim eum, quoniam universa turba admirabatur super doctrina eius."
,"19":"Et cum vespera facta esset, egrediebantur de civitate."
,"20":"Et cum mane transirent, viderunt ficum aridam factam a radicibus."
,"21":"Et recordatus Petrus dicit ei: ' Rabbi, ecce ficus, cui maledixisti, aruit '."
,"22":"Et respondens Iesus ait illis: ' Habete fidem Dei!"
,"23":"Amen dico vobis: Quicumque dixerit huic monti: 'Tollere et mittere in mare', et non haesitaverit in corde suo, sed crediderit quia, quod dixerit, fiat, fiet ei."
,"24":"Propterea dico vobis: Omnia, quaecumque orantes petitis, credite quia iam accepistis, et erunt vobis."
,"25":"Et cum statis in oratione, dimittite, si quid habetis adversus aliquem, ut et,Pater vester, qui in caelis est, dimittat vobis peccata vestra '. (26) 27 Et veniunt rursus Hierosolymam. Et cum ambularet in templo, accedunt ad eum summi sacerdotes et scribae et seniores "
,"28":"et dicebant illi: ' In qua potestate haec facis? Vel quis tibi dedit hanc potestatem, ut ista facias? '."
,"29":"Iesus autem ait illis: ' Interrogabo vos unum verbum, et respondete mihi; et dicam vobis, in qua potestate haec faciam:"
,"30":"Baptismum Ioannis de caelo erat an ex hominibus? Respondete mihi '."
,"31":"At illi cogitabant secum dicentes: ' Si dixerimus: 'De caelo', dicet: 'Quare ergo non credidistis ei?';"
,"32":"si autem dixerimus: 'Ex hominibus?' '. Timebant populum: omnes enim habebant Ioannem quia vere propheta esset."
,"33":"Et respondentes dicunt Iesu: ' Nescimus '. Et Iesus ait illis: ' Neque ego dico vobis in qua potestate haec faciam '."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Et coepit illis in parabolis loqui: ' Vineam pastinavit ho mo et circumdedit saepem et fodit lacum et aedificavit turrim et locavit eam agricolis et peregre profectus est."
,"2":"Et misit ad agricolas in tempore servum, ut ab agricolis acciperet de fructu vineae;"
,"3":"qui apprehensum eum caeciderunt et dimiserunt vacuum."
,"4":"Et iterum misit ad illos alium servum; et illum in capite vulneraverunt et contumeliis affecerunt."
,"5":"Et alium misit, et illum occiderunt, et plures alios, quosdam caedentes, alios vero occidentes."
,"6":"Adhuc unum habebat, filium dilectum. Misit illum ad eos novissimum dicens: 'Reverebuntur filium meum'."
,"7":"Coloni autem illi dixerunt ad invicem: 'Hic est heres. Venite, occidamus eum, et nostra erit hereditas'."
,"8":"Et apprehendentes eum occiderunt et eiecerunt extra vineam."
,"9":"Quid ergo faciet dominus vineae? Veniet et perdet colonos et dabit vineam aliis."
,"10":"Nec Scripturam hanc legistis: 'Lapidem quem reprobaverunt aedificantes, hic factus est in caput anguli;"
,"11":"a Domino factum est istud,et est mirabile in oculis nostris'? '."
,"12":"Et quaerebant eum tenere et timuerunt turbam; cognoverunt enim quoniam ad eos parabolam hanc dixerit. Et relicto eo abierunt."
,"13":"Et mittunt ad eum quosdam ex pharisaeis et herodianis, ut eum caperent in verbo."
,"14":"Qui venientes dicunt ei: ' Magister, scimus quia verax es et non curas quemquam; nec enim vides in faciem hominum, sed in veritate viam Dei doces. Licet dare tributum Caesari an non? Dabimus an non dabimus? '."
,"15":"Qui sciens versutiam eorum ait illis: ' Quid me tentatis? Afferte mihi denarium, ut videam '."
,"16":"At illi attulerunt. Et ait illis: ' Cuius est imago haec et inscriptio? '. Illi autem dixerunt ei: ' Caesaris '."
,"17":"Iesus autem dixit illis: ' Quae sunt Caesaris, reddite Caesari et, quae sunt Dei, Deo '. Et mirabantur super eo."
,"18":"Et veniunt ad eum sadducaei, qui dicunt resurrectionem non esse, et interrogabant eum dicentes:"
,"19":"' Magister, Moyses nobis scripsit, ut si cuius frater mortuus fuerit et reliquerit uxorem et filium non reliquerit, accipiat frater eius uxorem et resuscitet semen fratri suo."
,"20":"Septem fratres erant: et primus accepit uxorem et moriens non reliquit semen;"
,"21":"et secundus accepit eam et mortuus est, non relicto semine; et tertius similiter;"
,"22":"et septem non reliquerunt semen. Novissima omnium defuncta est et mulier."
,"23":"In resurrectione, cum resurrexerint, cuius de his erit uxor? Septem enim habuerunt eam uxorem '."
,"24":"Ait illis Iesus: ' Non ideo erratis, quia non scitis Scripturas neque virtutem Dei?"
,"25":"Cum enim a mortuis resurrexerint, neque nubent neque nubentur, sed sunt sicut angeli in caelis."
,"26":"De mortuis autem quod resurgant, non legistis in libro Moysis super rubum, quomodo dixerit illi Deus inquiens: 'Ego sum Deus Abraham et Deus Isaac et Deus Iacob'?"
,"27":"Non est Deus mortuorum sed vivorum! Multum erratis '."
,"28":"Et accessit unus de scribis, qui audierat illos conquirentes, videns quoniam bene illis responderit, interrogavit eum: ' Quod est primum omnium mandatum? '."
,"29":"Iesus respondit: ' Primum est: 'Audi, Israel: Dominus Deus noster Dominus unus est,"
,"30":"et diliges Dominum Deum tuum ex toto corde tuo et ex tota anima tua et ex tota mente tua et ex tota virtute tua'."
,"31":"Secundum est illud: 'Diliges proximum tuum tamquam teipsum'. Maius horum aliud mandatum non est '."
,"32":"Et ait illi scriba: ' Bene, Magister, in veritate dixisti: 'Unus est, et non est alius praeter eum;"
,"33":"et diligere eum ex toto corde et ex toto intellectu et ex tota fortitudine' et: 'Diligere proximum tamquam seipsum' maius est omnibus holocautomatibus et sacrificiis '."
,"34":"Et Iesus videns quod sapienter respondisset, dixit illi: ' Non es longe a regno Dei '. Et nemo iam audebat eum interrogare."
,"35":"Et respondens Iesus dicebat docens in templo: ' Quomodo dicunt scribae Christum filium esse David?"
,"36":"Ipse David dixit in Spiritu Sancto: 'Dixit Dominus Domino meo: Sede a dextris meis, donec ponam inimicos tuos sub pedibus tuis'."
,"37":"Ipse David dicit eum Dominum, et unde est filius eius? '. Et multa turba eum libenter audiebat."
,"38":"Et dicebat in doctrina sua: ' Cavete a scribis, qui volunt in stolis ambulare et salutari in foro"
,"39":"et in primis cathedris sedere in synagogis et primos discubitus in cenis;"
,"40":"qui devorant domos viduarum et ostentant prolixas orationes. Hi accipient amplius iudicium '."
,"41":"Et sedens contra gazophylacium aspiciebat quomodo turba iactaret aes in gazophylacium; et multi divites iactabant multa."
,"42":"Et cum venisset una vidua pauper, misit duo minuta, quod est quadrans."
,"43":"Et convocans discipulos suos ait illis: ' Amen dico vobis: Vidua haec pauper plus omnibus misit, qui miserunt in gazophylacium:"
,"44":"Omnes enim ex eo, quod abundabat illis, miserunt; haec vero de penuria sua omnia, quae habuit, misit, totum victum suum '."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Et cum egrederetur de tem plo, ait illi unus ex discipulis suis: ' Magister, aspice quales lapides et quales structurae '."
,"2":"Et Iesus ait illi: ' Vides has magnas aedificationes? Hic non relinquetur lapis super lapidem, qui non destruatur '."
,"3":"Et cum sederet in montem Olivarum contra templum, interrogabat eum separatim Petrus et Iacobus et Ioannes et Andreas:"
,"4":"' Dic nobis: Quando ista erunt, et quod signum erit, quando haec omnia incipient consummari? '."
,"5":"Iesus autem coepit dicere illis: ' Videte, ne quis vos seducat."
,"6":"Multi venient in nomine meo dicentes: 'Ego sum', et multos seducent."
,"7":"Cum audieritis autem bella et opiniones bellorum, ne timueritis; oportet fieri sed nondum finis."
,"8":"Exsurget enim gens super gentem, et regnum super regnum, erunt terrae motus per loca, erunt fames; initium dolorum haec."
,"9":"Videte autem vosmetipsos. Tradent vos conciliis, et in synagogis vapulabitis et ante praesides et reges stabitis propter me in testimonium illis."
,"10":"Et in omnes gentes primum oportet praedicari evangelium."
,"11":"Et cum duxerint vos tradentes, nolite praecogitare quid loquamini, sed, quod datum vobis fuerit in illa hora, id loquimini: non enim estis vos loquentes sed Spiritus Sanctus."
,"12":"Et tradet frater fratrem in mortem, et pater filium; et consurgent filii in parentes et morte afficient eos;"
,"13":"et eritis odio omnibus propter nomen meum. Qui autem sustinuerit in finem, hic salvus erit."
,"14":"Cum autem videritis abominationem desolationis stantem, ubi non debet, qui legit, intellegat: tunc, qui in Iudaea sunt, fugiant in montes;"
,"15":"qui autem super tectum, ne descendat nec introeat, ut tollat quid de domo sua;"
,"16":"et, qui in agro erit, non revertatur retro tollere vestimentum suum."
,"17":"Vae autem praegnantibus et nutrientibus in illis diebus!"
,"18":"Orate vero, ut hieme non fiat:"
,"19":"erunt enim dies illi tribulatio talis, qualis non fuit ab initio creaturae, quam condidit Deus, usque nunc, neque fiet."
,"20":"Et nisi breviasset Dominus dies, non fuisset salva omnis caro. Sed propter electos, quos elegit, breviavit dies."
,"21":"Et tunc, si quis vobis dixerit: 'Ecce hic est Christus, ecce illic', ne credideritis."
,"22":"Exsurgent enim pseudochristi et pseudoprophetae et dabunt signa et portenta ad seducendos, si potest fieri, electos."
,"23":"Vos autem videte; praedixi vobis omnia."
,"24":"Sed in illis diebus post tribulationem illam sol contenebrabitur, et luna non dabit splendorem suum,"
,"25":"et erunt stellae de caelo decidentes, et virtutes, quae sunt in caelis, movebuntur."
,"26":"Et tunc videbunt Filium hominis venientem in nubibus cum virtute multa et gloria."
,"27":"Et tunc mittet angelos et congregabit electos suos a quattuor ventis, a summo terrae usque ad summum caeli."
,"28":"A ficu autem discite parabolam: cum iam ramus eius tener fuerit et germinaverit folia, cognoscitis quia in proximo sit aestas."
,"29":"Sic et vos, cum videritis haec fieri, scitote quod in proximo sit in ostiis."
,"30":"Amen dico vobis: Non transiet generatio haec, donec omnia ista fiant."
,"31":"Caelum et terra transibunt, verba autem mea non transibunt."
,"32":"De die autem illo vel hora nemo scit, neque angeli in caelo neque Filius, nisi Pater."
,"33":"Videte, vigilate; nescitis enim, quando tempus sit."
,"34":"Sicut homo, qui peregre profectus reliquit domum suam et dedit servis suis potestatem, unicuique opus suum, ianitori quoque praecepit, ut vigilaret."
,"35":"Vigilate ergo; nescitis enim quando dominus domus veniat, sero an media nocte an galli cantu an mane;"
,"36":"ne, cum venerit repente, inveniat vos dormientes."
,"37":"Quod autem vobis dico, omnibus dico: Vigilate! '."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Erat autem Pascha et Azy ma post biduum. Et quaerebant summi sacerdotes et scribae, quomodo eum dolo tenerent et occiderent;"
,"2":"dicebant enim: ' Non in die festo, ne forte tumultus fieret populi '."
,"3":"Et cum esset Bethaniae in domo Simonis leprosi et recumberet, venit mulier habens alabastrum unguenti nardi puri pretiosi; fracto alabastro, effudit super caput eius."
,"4":"Erant autem quidam indigne ferentes intra semetipsos: ' Ut quid perditio ista unguenti facta est?"
,"5":"Poterat enim unguentum istud veniri plus quam trecentis denariis et dari pauperibus '. Et fremebant in eam."
,"6":"Iesus autem dixit: ' Sinite eam; quid illi molesti estis? Bonum opus operata est in me."
,"7":"Semper enim pauperes habetis vobiscum et, cum volueritis, potestis illis bene facere; me autem non semper habetis."
,"8":"Quod habuit, operata est: praevenit ungere corpus meum in sepulturam."
,"9":"Amen autem dico vobis: Ubicumque praedicatum fuerit evangelium in universum mundum, et, quod fecit haec, narrabitur in memoriam eius '."
,"10":"Et Iudas Iscarioth, unus de Duodecim, abiit ad summos sacerdotes, ut proderet eum illis."
,"11":"Qui audientes gavisi sunt et promiserunt ei pecuniam se daturos. Et quaerebat quomodo illum opportune traderet."
,"12":"Et primo die Azymorum, quando Pascha immolabant, dicunt ei discipuli eius: ' Quo vis eamus et paremus, ut manduces Pascha? '."
,"13":"Et mittit duos ex discipulis suis et dicit eis: ' Ite in civitatem, et occurret vobis homo lagoenam aquae baiulans; sequimini eum"
,"14":"et, quocumque introierit, dicite domino domus: 'Magister dicit: Ubi est refectio mea, ubi Pascha cum discipulis meis manducem?'."
,"15":"Et ipse vobis demonstrabit cenaculum grande stratum paratum; et illic parate nobis '."
,"16":"Et abierunt discipuli et venerunt in civitatem et invenerunt, sicut dixerat illis, et paraverunt Pascha."
,"17":"Et vespere facto, venit cum Duodecim."
,"18":"Et discumbentibus eis et manducantibus, ait Iesus: ' Amen dico vobis: Unus ex vobis me tradet, qui manducat mecum '."
,"19":"Coeperunt contristari et dicere ei singillatim: ' Numquid ego? '."
,"20":"Qui ait illis: ' Unus ex Duodecim, qui intingit mecum in catino."
,"21":"Nam Filius quidem hominis vadit, sicut scriptum est de eo. Vae autem homini illi, per quem Filius hominis traditur! Bonum est ei, si non esset natus homo ille '."
,"22":"Et manducantibus illis, accepit panem et benedicens fregit et dedit eis et ait: ' Sumite: hoc est corpus meum '."
,"23":"Et accepto calice, gratias agens dedit eis; et biberunt ex illo omnes."
,"24":"Et ait illis: ' Hic est sanguis meus novi testamenti, qui pro multis effunditur."
,"25":"Amen dico vobis: Iam non bibam de genimine vitis usque in diem illum, cum illud bibam novum in regno Dei '."
,"26":"Et hymno dicto, exierunt in montem Olivarum."
,"27":"Et ait eis Iesus: ' Omnes scandalizabimini, quia scriptum est: 'Percutiam pastorem, et dispergentur oves'."
,"28":"Sed posteaquam resurrexero, praecedam vos in Galilaeam '."
,"29":"Petrus autem ait ei: ' Et si omnes scandalizati fuerint, sed non ego '."
,"30":"Et ait illi Iesus: ' Amen dico tibi: Tu hodie, in nocte hac, priusquam bis gallus vocem dederit, ter me es negaturus '."
,"31":"At ille amplius loquebatur: ' Et si oportuerit me commori tibi, non te negabo '. Similiter autem et omnes dicebant."
,"32":"Et veniunt in praedium, cui nomen Gethsemani; et ait discipulis suis: ' Sedete hic, donec orem '."
,"33":"Et assumit Petrum et Iacobum et Ioannem secum et coepit pavere et taedere;"
,"34":"et ait illis: ' Tristis est anima mea usque ad mortem; sustinete hic et vigilate '."
,"35":"Et cum processisset paululum, procidebat super terram et orabat, ut, si fieri posset, transiret ab eo hora;"
,"36":"et dicebat: ' Abba, Pater! Omnia tibi possibilia sunt. Transfer calicem hunc a me; sed non quod ego volo, sed quod tu '."
,"37":"Et venit et invenit eos dormientes; et ait Petro: ' Simon, dormis? Non potuisti una hora vigilare?"
,"38":"Vigilate et orate, ut non intretis in tentationem; spiritus quidem promptus, caro vero infirma '."
,"39":"Et iterum abiens oravit, eundem sermonem dicens."
,"40":"Et veniens denuo invenit eos dormientes; erant enim oculi illorum ingravati, et ignorabant quid responderent ei."
,"41":"Et venit tertio et ait illis: ' Dormite iam et requiescite? Sufficit, venit hora: ecce traditur Filius hominis in manus peccatorum."
,"42":"Surgite, eamus; ecce, qui me tradit, prope est '."
,"43":"Et confestim, adhuc eo loquente, venit Iudas unus ex Duodecim, et cum illo turba cum gladiis et lignis a summis sacerdotibus et scribis et senioribus."
,"44":"Dederat autem traditor eius signum eis dicens: ' Quemcumque osculatus fuero, ipse est; tenete eum et ducite caute '."
,"45":"Et cum venisset, statim accedens ad eum ait: ' Rabbi '; et osculatus est eum."
,"46":"At illi manus iniecerunt in eum et tenuerunt eum."
,"47":"Unus autem quidam de circumstantibus educens gladium percussit servum summi sacerdotis et amputavit illi auriculam."
,"48":"Et respondens Iesus ait illis: ' Tamquam ad latronem existis cum gladiis et lignis comprehendere me?"
,"49":"Cotidie eram apud vos in templo docens, et non me tenuistis; sed adimpleantur Scripturae '."
,"50":"Et relinquentes eum omnes fugerunt."
,"51":"Et adulescens quidam sequebatur eum amictus sindone super nudo, et tenent eum;"
,"52":"at ille, reiecta sindone, nudus profugit."
,"53":"Et adduxerunt Iesum ad summum sacerdotem; et conveniunt omnes summi sacerdotes et seniores et scribae."
,"54":"Et Petrus a longe secutus est eum usque intro in atrium summi sacerdotis et sedebat cum ministris et calefaciebat se ad ignem."
,"55":"Summi vero sacerdotes et omne concilium quaerebant adversus Iesum testimonium, ut eum morte afficerent, nec inveniebant."
,"56":"Multi enim testimonium falsum dicebant adversus eum, et convenientia testimonia non erant."
,"57":"Et quidam surgentes falsum testimonium ferebant adversus eum dicentes:"
,"58":"' Nos audivimus eum dicentem: 'Ego dissolvam templum hoc manu factum et intra triduum aliud non manu factum aedificabo' '."
,"59":"Et ne ita quidem conveniens erat testimonium illorum."
,"60":"Et exsurgens summus sacerdos in medium interrogavit Iesum dicens: ' Non respondes quidquam ad ea, quae isti testantur adversum te? '."
,"61":"Ille autem tacebat et nihil respondit. Rursum summus sacerdos interrogabat eum et dicit ei: ' Tu es Christus filius Benedicti? '."
,"62":"Iesus autem dixit: ' Ego sum, et videbitis Filium hominis a dextris sedentem Virtutis et venientem cum nubibus caeli '."
,"63":"Summus autem sacerdos scindens vestimenta sua ait: ' Quid adhuc necessarii sunt nobis testes?"
,"64":"Audistis blasphemiam. Quid vobis videtur? '. Qui omnes condemnaverunt eum esse reum mortis."
,"65":"Et coeperunt quidam conspuere eum et velare faciem eius et colaphis eum caedere et dicere ei: ' Prophetiza '; et ministri alapis eum caedebant."
,"66":"Et cum esset Petrus in atrio deorsum, venit una ex ancillis summi sacerdotis"
,"67":"et, cum vidisset Petrum calefacientem se, aspiciens illum ait: ' Et tu cum hoc Nazareno, Iesu, eras! '."
,"68":"At ille negavit dicens: ' Neque scio neque novi quid tu dicas! '. Et exiit foras ante atrium, et gallus cantavit."
,"69":"Et ancilla, cum vidisset illum, rursus coepit dicere circumstantibus: ' Hic ex illis est! '."
,"70":"At ille iterum negabat. Et post pusillum rursus, qui astabant, dicebant Petro: ' Vere ex illis es, nam et Galilaeus es '."
,"71":"Ille autem coepit anathematizare et iurare: ' Nescio hominem istum, quem dicitis! '."
,"72":"Et statim iterum gallus cantavit; et recordatus est Petrus verbi, sicut dixerat ei Iesus: ' Priusquam gallus cantet bis, ter me negabis '. Et coepit flere."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Et confestim mane consilium facientes summi sacerdotes cum senioribus et scribis, id est universum concilium, vincientes Iesum duxerunt et tradiderunt Pilato."
,"2":"Et interrogavit eum Pilatus: ' Tu es rex Iudaeorum? '. At ille respondens ait illi: ' Tu dicis '."
,"3":"Et accusabant eum summi sacerdotes in multis."
,"4":"Pilatus autem rursum interrogabat eum dicens: ' Non respondes quidquam? Vide in quantis te accusant '."
,"5":"Iesus autem amplius nihil respondit, ita ut miraretur Pilatus."
,"6":"Per diem autem festum dimittere solebat illis unum ex vinctis, quem peterent."
,"7":"Erat autem qui dicebatur Barabbas, vinctus cum seditiosis, qui in seditione fecerant homicidium."
,"8":"Et cum ascendisset turba, coepit rogare, sicut faciebat illis."
,"9":"Pilatus autem respondit eis et dixit: ' Vultis dimittam vobis regem Iudaeorum? '."
,"10":"Sciebat enim quod per invidiam tradidissent eum summi sacerdotes."
,"11":"Pontifices autem concitaverunt turbam, ut magis Barabbam dimitteret eis."
,"12":"Pilatus autem iterum respondens aiebat illis: ' Quid ergo vultis faciam regi Iudaeorum? '."
,"13":"At illi iterum clamaverunt: ' Crucifige eum! '."
,"14":"Pilatus vero dicebat eis: ' Quid enim mali fecit? '. At illi magis clamaverunt: ' Crucifige eum! '."
,"15":"Pilatus autem, volens populo satisfacere, dimisit illis Barabbam et tradidit Iesum flagellis caesum, ut crucifigeretur."
,"16":"Milites autem duxerunt eum intro in atrium, quod est praetorium, et convocant totam cohortem."
,"17":"Et induunt eum purpuram et imponunt ei plectentes spineam coronam;"
,"18":"et coeperunt salutare eum: ' Ave, rex Iudaeorum! ',"
,"19":"et percutiebant caput eius arundine et conspuebant eum et ponentes genua adorabant eum."
,"20":"Et postquam illuserunt ei, exuerunt illum purpuram et induerunt eum vestimentis suis. Et educunt illum, ut crucifigerent eum."
,"21":"Et angariant praetereuntem quempiam Simonem Cyrenaeum venientem de villa, patrem Alexandri et Rufi, ut tolleret crucem eius."
,"22":"Et perducunt illum in Golgotha locum, quod est interpretatum Calvariae locus."
,"23":"Et dabant ei myrrhatum vinum; ille autem non accepit."
,"24":"Et crucifigunt eum et dividunt vestimenta eius, mittentes sortem super eis, quis quid tolleret."
,"25":"Erat autem hora tertia, et crucifixerunt eum."
,"26":"Et erat titulus causae eius inscriptus: ' Rex Iudaeorum '."
,"27":"Et cum eo crucifigunt duos latrones, unum a dextris et alium a,sinistris eius. (28) 29 Et praetereuntes blasphemabant eum moventes capita sua et dicentes: ' Vah, qui destruit templum et in tribus diebus aedificat; "
,"30":"salvum fac temetipsum descendens de cruce! '."
,"31":"Similiter et summi sacerdotes ludentes ad alterutrum cum scribis dicebant: ' Alios salvos fecit, seipsum non potest salvum facere."
,"32":"Christus rex Israel descendat nunc de cruce, ut videamus et credamus '. Etiam qui cum eo crucifixi erant, conviciabantur ei."
,"33":"Et, facta hora sexta, tenebrae factae sunt per totam terram usque in horam nonam."
,"34":"Et hora nona exclamavit Iesus voce magna: ' Heloi, Heloi, lema sabacthani? ', quod est interpretatum: ' Deus meus, Deus meus, ut quid dereliquisti me? '."
,"35":"Et quidam de circumstantibus audientes dicebant: ' Ecce, Eliam vocat '."
,"36":"Currens autem unus et implens spongiam aceto circumponensque calamo potum dabat ei dicens: ' Sinite, videamus, si veniat Elias ad deponendum eum '."
,"37":"Iesus autem, emissa voce magna, exspiravit."
,"38":"Et velum templi scissum est in duo a sursum usque deorsum."
,"39":"Videns autem centurio, qui ex adverso stabat, quia sic clamans exspirasset, ait: ' Vere homo hic Filius Dei erat '."
,"40":"Erant autem et mulieres de longe aspicientes, inter quas et Maria Magdalene et Maria Iacobi minoris et Iosetis mater et Salome,"
,"41":"quae, cum esset in Galilaea, sequebantur eum et ministrabant ei, et aliae multae, quae simul cum eo ascenderant Hierosolymam."
,"42":"Et cum iam sero esset factum, quia erat Parasceve, quod est ante sabbatum,"
,"43":"venit Ioseph ab Arimathaea nobilis decurio, qui et ipse erat exspectans regnum Dei, et audacter introivit ad Pilatum et petiit corpus Iesu."
,"44":"Pilatus autem miratus est si iam obisset, et, accersito centurione, interrogavit eum si iam mortuus esset,"
,"45":"et, cum cognovisset a centurione, donavit corpus Ioseph."
,"46":"Is autem mercatus sindonem et deponens eum involvit sindone et posuit eum in monumento, quod erat excisum de petra, et advolvit lapidem ad ostium monumenti."
,"47":"Maria autem Magdalene et Maria Iosetis aspiciebant, ubi positus esset."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Et cum transisset sabbatum, Maria Magdalene et Maria Iacobi et Salome emerunt aromata, ut venientes ungerent eum."
,"2":"Et valde mane, prima sabbatorum, veniunt ad monumentum, orto iam sole."
,"3":"Et dicebant ad invicem: ' Quis revolvet nobis lapidem ab ostio monumenti? '."
,"4":"Et respicientes vident revolutum lapidem; erat quippe magnus valde."
,"5":"Et introeuntes in monumentum viderunt iuvenem sedentem in dextris, coopertum stola candida, et obstupuerunt."
,"6":"Qui dicit illis: ' Nolite expavescere! Iesum quaeritis Nazarenum crucifixum. Surrexit, non est hic; ecce locus, ubi posuerunt eum."
,"7":"Sed ite, dicite discipulis eius et Petro: 'Praecedit vos in Galilaeam. Ibi eum videbitis, sicut dixit vobis' '."
,"8":"Et exeuntes fugerunt de monumento; invaserat enim eas tremor et pavor, et nemini quidquam dixerunt, timebant enim."
,"9":"Surgens autem mane, prima sabbati, apparuit primo Mariae Magdalenae, de qua eiecerat septem daemonia."
,"10":"Illa vadens nuntiavit his, qui cum eo fuerant, lugentibus et flentibus;"
,"11":"et illi audientes quia viveret et visus esset ab ea, non crediderunt."
,"12":"Post haec autem duobus ex eis ambulantibus ostensus est in alia effigie euntibus in villam;"
,"13":"et illi euntes nuntiaverunt ceteris, nec illis crediderunt."
,"14":"Novissime recumbentibus illis Undecim apparuit, et exprobravit incredulitatem illorum et duritiam cordis, quia his, qui viderant eum resuscitatum, non crediderant."
,"15":"Et dixit eis: ' Euntes in mundum universum praedicate evangelium omni creaturae."
,"16":"Qui crediderit et baptizatus fuerit, salvus erit; qui vero non crediderit, condemnabitur."
,"17":"Signa autem eos, qui crediderint, haec sequentur: in nomine meo daemonia eicient, linguis loquentur novis,"
,"18":"serpentes tollent, et, si mortiferum quid biberint, non eos nocebit, super aegrotos manus imponent, et bene habebunt '."
,"19":"Et Dominus quidem Iesus, postquam locutus est eis, assumptus est in caelum et sedit a dextris Dei."
,"20":"Illi autem profecti praedicaverunt ubique, Domino cooperante et sermonem confirmante, sequentibus signis."
}`)

}
func LA_NVBSE_LoadNEMTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Liber generationis Iesu Christi filii David filii Abraham."
,"2":"Abraham genuit Isaac, Isaac autem genuit Iacob, Iacob autem genuit Iudam et fratres eius,"
,"3":"Iudas autem genuit Phares et Zara de Thamar, Phares autem genuit Esrom, Esrom autem genuit Aram,"
,"4":"Aram autem genuit Aminadab, Aminadab autem genuit Naasson, Naasson autem genuit Salmon,"
,"5":"Salmon autem genuit Booz de Rahab, Booz autem genuit Obed ex Ruth, Obed autem genuit Iesse,"
,"6":"Iesse autem genuit David regem. David autem genuit Salomonem ex ea, quae fuit Uriae, "
,"7":"Salomon autem genuit Roboam, Roboam autem genuit Abiam, Abia autem genuit Asa,"
,"8":"Asa autem genuit Iosaphat, Iosaphat autem genuit Ioram, Ioram autem genuit Oziam,"
,"9":"Ozias autem genuit Ioatham, Ioatham autem genuit Achaz, Achaz autem genuit Ezechiam,"
,"10":"Ezechias autem genuit Manassen, Manasses autem genuit Amon, Amon autem genuit Iosiam,"
,"11":"Iosias autem genuit Iechoniam et fratres eius in transmigratione Babylonis."
,"12":"Et post transmigrationem Babylonis Iechonias genuit Salathiel, Salathiel autem genuit Zorobabel,"
,"13":"Zorobabel autem genuit Abiud, Abiud autem genuit Eliachim, Eliachim autem genuit Azor,"
,"14":"Azor autem genuit Sadoc, Sadoc autem genuit Achim, Achim autem genuit Eliud,"
,"15":"Eliud autem genuit Eleazar, Eleazar autem genuit Matthan, Matthan autem genuit Iacob,"
,"16":"Iacob autem genuit Ioseph virum Mariae, de qua natus est Iesus, qui vocatur Christus."
,"17":"Omnes ergo generationes ab Abraham usque ad David generationes quattuordecim; et a David usque ad transmigrationem Babylonis generationes quattuordecim; et a transmigratione Babylonis usque ad Christum generationes quattuordecim."
,"18":"Iesu Christi autem generatio sic erat. Cum esset desponsata mater eius Maria Ioseph, antequam convenirent inventa est in utero habens de Spiritu Sancto."
,"19":"Ioseph autem vir eius, cum esset iustus et nollet eam traducere, voluit occulte dimittere eam."
,"20":"Haec autem eo cogitante, ecce angelus Domini in somnis apparuit ei dicens: ' Ioseph fili David, noli timere accipere Mariam coniugem tuam. Quod enim in ea natum est, de Spiritu Sancto est;"
,"21":"pariet autem filium, et vocabis nomen eius Iesum: ipse enim salvum faciet populum suum a peccatis eorum '."
,"22":"Hoc autem totum factum est, ut adimpleretur id, quod dictum est a Domino per prophetam dicentem:"
,"23":"' Ecce, virgo in utero habebit et pariet filium, et vocabunt nomen eius Emmanuel ', quod est interpretatum Nobiscum Deus."
,"24":"Exsurgens autem Ioseph a somno fecit, sicut praecepit ei angelus Domini, et accepit coniugem suam;"
,"25":"et non cognoscebat eam, donec peperit filium, et vocavit nomen eius Iesum."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Cum autem natus esset Iesus in Bethlehem Iudaeae in diebus Herodis regis, ecce Magi ab oriente venerunt Hierosolymam"
,"2":"dicentes: ' Ubi est, qui natus est, rex Iudaeorum? Vidimus enim stellam eius in oriente et venimus adorare eum '."
,"3":"Audiens autem Herodes rex turbatus est et omnis Hierosolyma cum illo;"
,"4":"et congregans omnes principes sacerdotum et scribas populi, sciscitabatur ab eis ubi Christus nasceretur."
,"5":"At illi dixerunt ei: ' In Bethlehem Iudaeae. Sic enim scriptum est per prophetam:"
,"6":"'Et tu, Bethlehem terra Iudae, nequaquam minima es in principibus Iudae; ex te enim exiet dux, qui reget populum meum Israel' '."
,"7":"Tunc Herodes, clam vocatis Magis, diligenter didicit ab eis tempus stellae, quae apparuit eis;"
,"8":"et mittens illos in Bethlehem dixit: ' Ite et interrogate diligenter de puero; et cum inveneritis, renuntiate mihi, ut et ego veniens adorem eum '."
,"9":"Qui cum audissent regem, abierunt. Et ecce stella, quam viderant in oriente, antecedebat eos, usque dum veniens staret supra, ubi erat puer."
,"10":"Videntes autem stellam gavisi sunt gaudio magno valde."
,"11":"Et intrantes domum viderunt puerum cum Maria matre eius, et procidentes adoraverunt eum; et apertis thesauris suis, obtulerunt ei munera, aurum et tus et myrrham."
,"12":"Et responso accepto in somnis, ne redirent ad Herodem, per aliam viam reversi sunt in regionem suam."
,"13":"Qui cum recessissent, ecce angelus Domini apparet in somnis Ioseph dicens: ' Surge et accipe puerum et matrem eius et fuge in Aegyptum et esto ibi, usque dum dicam tibi; futurum est enim ut Herodes quaerat puerum ad perdendum eum '."
,"14":"Qui consurgens accepit puerum et matrem eius nocte et recessit in Aegyptum"
,"15":"et erat ibi usque ad obitum Herodis, ut adimpleretur, quod dictum est a Domino per prophetam dicentem: ' Ex Aegypto vocavi filium meum '."
,"16":"Tunc Herodes videns quoniam illusus esset a Magis, iratus est valde et mittens occidit omnes pueros, qui erant in Bethlehem et in omnibus finibus eius, a bimatu et infra, secundum tempus, quod exquisierat a Magis."
,"17":"Tunc adimpletum est, quod dictum est per Ieremiam prophetam dicentem:"
,"18":"' Vox in Rama audita est, ploratus et ululatus multus: Rachel plorans filios suos, et noluit consolari, quia non sunt '."
,"19":"Defuncto autem Herode, ecce apparet angelus Domini in somnis Ioseph in Aegypto"
,"20":"dicens: ' Surge et accipe puerum et matrem eius et vade in terram Israel; defuncti sunt enim, qui quaerebant animam pueri '."
,"21":"Qui surgens accepit puerum et matrem eius et venit in terram Israel."
,"22":"Audiens autem quia Archelaus regnaret in Iudaea pro Herode patre suo, timuit illuc ire; et admonitus in somnis, secessit in partes Galilaeae"
,"23":"et veniens habitavit in civitate, quae vocatur Nazareth, ut adimpleretur, quod dictum est per Prophetas: ' Nazaraeus vocabitur '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"In diebus autem illis venit Ioannes Baptista praedicans in deserto Iudaeae"
,"2":"et dicens: ' Paenitentiam agite; appropinquavit enim regnum caelorum '."
,"3":"Hic est enim, qui dictus est per Isaiam prophetam dicentem: ' Vox clamantis in deserto: 'Parate viam Domini, rectas facite semitas eius!' '."
,"4":"Ipse autem Ioannes habebat vestimentum de pilis cameli et zonam pelliceam circa lumbos suos; esca autem eius erat locustae et mel silvestre."
,"5":"Tunc exibat ad eum Hierosolyma et omnis Iudaea et omnis regio circa Iordanem,"
,"6":"et baptizabantur in Iordane flumine ab eo, confitentes peccata sua."
,"7":"Videns autem multos pharisaeorum et sadducaeorum venientes ad baptismum suum, dixit eis: ' Progenies viperarum, quis demonstravit vobis fugere a futura ira?"
,"8":"Facite ergo fructum dignum paenitentiae"
,"9":"et ne velitis dicere intra vos: 'Patrem habemus Abraham'; dico enim vobis quoniam potest Deus de lapidibus istis suscitare Abrahae filios."
,"10":"Iam enim securis ad radicem arborum posita est; omnis ergo arbor, quae non facit fructum bonum, exciditur et in ignem mittitur."
,"11":"Ego quidem vos baptizo in aqua in paenitentiam; qui autem post me venturus est, fortior me est, cuius non sum dignus calceamenta portare; ipse vos baptizabit in Spiritu Sancto et igni,"
,"12":"cuius ventilabrum in manu sua, et permundabit aream suam et congregabit triticum suum in horreum, paleas autem comburet igni inexstinguibili '."
,"13":"Tunc venit Iesus a Galilaea in Iordanem ad Ioannem, ut baptizaretur ab eo."
,"14":"Ioannes autem prohibebat eum dicens: ' Ego a te debeo baptizari, et tu venis ad me? '."
,"15":"Respondens autem Iesus dixit ei: ' Sine modo, sic enim decet nos implere omnem iustitiam '. Tunc dimittit eum."
,"16":"Baptizatus autem Iesus, confestim ascendit de aqua; et ecce aperti sunt ei caeli, et vidit Spiritum Dei descendentem sicut columbam et venientem super se."
,"17":"Et ecce vox de caelis dicens: 'Hic est Filius meus dilectus, in quo,mihi complacui '. "
}`)
	CurrentBook.AddChapter(4, `{
"1":"Tunc Iesus ductus est in de sertum a Spiritu, ut tentaretur a Diabolo."
,"2":"Et cum ieiunasset quadraginta diebus et quadraginta noctibus, postea esuriit."
,"3":"Et accedens tentator dixit ei: ' Si Filius Dei es, dic, ut lapides isti panes fiant '."
,"4":"Qui respondens dixit: ' Scriptum est: 'Non in pane solo vivet homo, sed in omni verbo, quod procedit de ore Dei' '."
,"5":"Tunc assumit eum Diabolus in sanctam civitatem et statuit eum supra pinnaculum templi"
,"6":"et dicit ei: ' Si Filius Dei es, mitte te deorsum. Scriptum est enim: 'Angelis suis mandabit de te, et in manibus tollent te, ne forte offendas ad lapidem pedem tuum' '."
,"7":"Ait illi Iesus: ' Rursum scriptum est: 'Non tentabis Dominum Deum tuum' '."
,"8":"Iterum assumit eum Diabolus in montem excelsum valde et ostendit ei omnia regna mundi et gloriam eorum"
,"9":"et dicit illi: ' Haec tibi omnia dabo, si cadens adoraveris me'."
,"10":"Tunc dicit ei Iesus: ' Vade, Satanas! Scriptum est enim: 'Dominum Deum tuum adorabis,et illi soli servies' '."
,"11":"Tunc reliquit eum Diabolus, et ecce angeli accesserunt et ministrabant ei."
,"12":"Cum autem audisset quod Ioannes traditus esset, secessit in Galilaeam."
,"13":"Et relicta Nazareth, venit et habitavit in Capharnaum maritimam"
,"14":"in finibus Zabulon et Nephthali, ut impleretur, quod dictum est per Isaiam prophetam dicentem:"
,"15":"' Terra Zabulon et terra Nephthali, ad viam maris, trans Iordanem, Galilaea gentium;"
,"16":"populus, qui sedebat in tenebris, lucem vidit magnam, et sedentibus in regione et umbra mortis,lux orta est eis '."
,"17":"Exinde coepit Iesus praedicare et dicere: ' Paenitentiam agite; appropinquavit enim regnum caelorum '."
,"18":"Ambulans autem iuxta mare Galilaeae, vidit duos fratres, Simonem, qui vocatur Petrus, et Andream fratrem eius, mittentes rete in mare; erant enim piscatores."
,"19":"Et ait illis: ' Venite post me, et faciam vos piscatores hominum '."
,"20":"At illi continuo, relictis retibus, secuti sunt eum."
,"21":"Et procedens inde vidit alios duos fratres, Iacobum Zebedaei et Ioannem fratrem eius, in navi cum Zebedaeo patre eorum reficientes retia sua; et vocavit eos."
,"22":"Illi autem statim, relicta navi et patre suo, secuti sunt eum."
,"23":"Et circumibat Iesus totam Galilaeam, docens in synagogis eorum et praedicans evangelium regni et sanans omnem languorem et omnem infirmitatem in populo."
,"24":"Et abiit opinio eius in totam Syriam; et obtulerunt ei omnes male habentes, variis languoribus et tormentis comprehensos, et qui daemonia habebant, et lunaticos et paralyticos, et curavit eos."
,"25":"Et secutae sunt eum turbae multae de Galilaea et Decapoli et Hierosolymis et Iudaea et de trans Iordanem."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Videns autem turbas, ascendit in montem; et cum sedisset, ac cesserunt ad eum discipuli eius;"
,"2":"et aperiens os suum docebat eos dicens:"
,"3":"' Beati pauperes spiritu, quoniam ipsorum est regnum caelorum."
,"4":"Beati, qui lugent, quoniam ipsi consolabuntur."
,"5":"Beati mites, quoniam ipsi possidebunt terram."
,"6":"Beati, qui esuriunt et sitiunt iustitiam, quoniam ipsi saturabuntur."
,"7":"Beati misericordes, quia ipsi misericordiam consequentur."
,"8":"Beati mundo corde, quoniam ipsi Deum videbunt."
,"9":"Beati pacifici, quoniam filii Dei vocabuntur."
,"10":"Beati, qui persecutionem patiuntur propter iustitiam, quoniam ipsorum est regnum caelorum."
,"11":"Beati estis cum maledixerint vobis et persecuti vos fuerint et dixerint omne malum adversum vos, mentientes, propter me."
,"12":"Gaudete et exsultate, quoniam merces vestra copiosa est in caelis; sic enim persecuti sunt prophetas, qui fuerunt ante vos."
,"13":"Vos estis sal terrae; quod si sal evanuerit, in quo salietur? Ad nihilum valet ultra, nisi ut mittatur foras et conculcetur ab hominibus."
,"14":"Vos estis lux mundi. Non potest civitas abscondi supra montem posita;"
,"15":"neque accendunt lucernam et ponunt eam sub modio, sed super candelabrum, ut luceat omnibus, qui in domo sunt."
,"16":"Sic luceat lux vestra coram hominibus, ut videant vestra bona opera et glorificent Patrem vestrum, qui in caelis est."
,"17":"Nolite putare quoniam veni solvere Legem aut Prophetas; non veni solvere, sed adimplere."
,"18":"Amen quippe dico vobis: Donec transeat caelum et terra, iota unum aut unus apex non praeteribit a Lege, donec omnia fiant."
,"19":"Qui ergo solverit unum de mandatis istis minimis et docuerit sic homines, minimus vocabitur in regno caelorum; qui autem fecerit et docuerit, hic magnus vocabitur in regno caelorum."
,"20":"Dico enim vobis: Nisi abundaverit iustitia vestra plus quam scribarum et pharisaeorum, non intrabitis in regnum caelorum."
,"21":"Audistis quia dictum est antiquis: 'Non occides; qui autem occiderit, reus erit iudicio'."
,"22":"Ego autem dico vobis: Omnis, qui irascitur fratri suo, reus erit iudicio; qui autem dixerit fratri suo: 'Racha', reus erit concilio; qui autem dixerit: 'Fatue', reus erit gehennae ignis."
,"23":"Si ergo offeres munus tuum ad altare, et ibi recordatus fueris quia frater tuus habet aliquid adversum te,"
,"24":"relinque ibi munus tuum ante altare et vade, prius, reconciliare fratri tuo et tunc veniens offer munus tuum."
,"25":"Esto consentiens adversario tuo cito, dum es in via cum eo, ne forte tradat te adversarius iudici, et iudex tradat te ministro, et in carcerem mittaris."
,"26":"Amen dico tibi: Non exies inde, donec reddas novissimum quadrantem."
,"27":"Audistis quia dictum est: 'Non moechaberis'."
,"28":"Ego autem dico vobis: Omnis, qui viderit mulierem ad concupiscendum eam, iam moechatus est eam in corde suo."
,"29":"Quod si oculus tuus dexter scandalizat te, erue eum et proice abs te; expedit enim tibi, ut pereat unum membrorum tuorum, quam totum corpus tuum mittatur in gehennam."
,"30":"Et si dextera manus tua scandalizat te, abscide eam et proice abs te; expedit enim tibi, ut pereat unum membrorum tuorum, quam totum corpus tuum abeat in gehennam."
,"31":"Dictum est autem: 'Quicumque dimiserit uxorem suam, det illi libellum repudii'."
,"32":"Ego autem dico vobis: Omnis, qui dimiserit uxorem suam, excepta fornicationis causa, facit eam moechari; et, qui dimissam duxerit, adulterat."
,"33":"Iterum audistis quia dictum est antiquis: 'Non periurabis; reddes autem Domino iuramenta tua'."
,"34":"Ego autem dico vobis: Non iurare omnino, neque per caelum, quia thronus Dei est,"
,"35":"neque per terram, quia scabellum est pedum eius, neque per Hierosolymam, quia civitas est magni Regis;"
,"36":"neque per caput tuum iuraveris, quia non potes unum capillum album facere aut nigrum."
,"37":"Sit autem sermo vester: 'Est, est', 'Non, non'; quod autem his abundantius est, a Malo est."
,"38":"Audistis quia dictum est: 'Oculum pro oculo et dentem pro dente'."
,"39":"Ego autem dico vobis: Non resistere malo; sed si quis te percusserit in dextera maxilla tua, praebe illi et alteram;"
,"40":"et ei, qui vult tecum iudicio contendere et tunicam tuam tollere, remitte ei et pallium;"
,"41":"et quicumque te angariaverit mille passus, vade cum illo duo."
,"42":"Qui petit a te, da ei; et volenti mutuari a te, ne avertaris."
,"43":"Audistis quia dictum est: 'Diliges proximum tuum et odio habebis inimicum tuum'."
,"44":"Ego autem dico vobis: Diligite inimicos vestros et orate pro persequentibus vos,"
,"45":"ut sitis filii Patris vestri, qui in caelis est, quia solem suum oriri facit super malos et bonos et pluit super iustos et iniustos."
,"46":"Si enim dilexeritis eos, qui vos diligunt, quam mercedem habetis? Nonne et publicani hoc faciunt?"
,"47":"Et si salutaveritis fratres vestros tantum, quid amplius facitis? Nonne et ethnici hoc faciunt?"
,"48":"Estote ergo vos perfecti, sicut Pater vester caelestis perfectus est."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Attendite, ne iustitiam vestram faciatis coram hominibus, ut vi deamini ab eis; alioquin mercedem non habetis apud Patrem vestrum, qui in caelis est."
,"2":"Cum ergo facies eleemosynam, noli tuba canere ante te, sicut hypocritae faciunt in synagogis et in vicis, ut honorificentur ab hominibus. Amen dico vobis: Receperunt mercedem suam."
,"3":"Te autem faciente eleemosynam, nesciat sinistra tua quid faciat dextera tua,"
,"4":"ut sit eleemosyna tua in abscondito, et Pater tuus, qui videt in abscondito, reddet tibi."
,"5":"Et cum oratis, non eritis sicut hypocritae, qui amant in synagogis et in angulis platearum stantes orare, ut videantur ab hominibus. Amen dico vobis: Receperunt mercedem suam."
,"6":"Tu autem cum orabis, intra in cubiculum tuum et, clauso ostio tuo, ora Patrem tuum, qui est in abscondito; et Pater tuus, qui videt in abscondito, reddet tibi."
,"7":"Orantes autem nolite multum loqui sicut ethnici; putant enim quia in multiloquio suo exaudiantur."
,"8":"Nolite ergo assimilari eis; scit enim Pater vester, quibus opus sit vobis, antequam petatis eum."
,"9":"Sic ergo vos orabitis: Pater noster, qui es in caelis, sanctificetur nomen tuum,"
,"10":"adveniat regnum tuum, fiat voluntas tua, sicut in caelo, et in terra."
,"11":"Panem nostrum supersubstantialem da nobis hodie;"
,"12":"et dimitte nobis debita nostra, sicut et nos dimittimus debitoribus nostris;"
,"13":"et ne inducas nos in tentationem, sed libera nos a Malo."
,"14":"Si enim dimiseritis hominibus peccata eorum, dimittet et vobis Pater vester caelestis;"
,"15":"si autem non dimiseritis hominibus, nec Pater vester dimittet peccata vestra."
,"16":"Cum autem ieiunatis, nolite fieri sicut hypocritae tristes; demoliuntur enim facies suas, ut pareant hominibus ieiunantes. Amen dico vobis: Receperunt mercedem suam."
,"17":"Tu autem cum ieiunas, unge caput tuum et faciem tuam lava,"
,"18":"ne videaris hominibus ieiunans sed Patri tuo, qui est in abscondito; et Pater tuus, qui videt in abscondito, reddet tibi."
,"19":"Nolite thesaurizare vobis thesauros in terra, ubi aerugo et tinea demolitur, et ubi fures effodiunt et furantur;"
,"20":"thesaurizate autem vobis thesauros in caelo, ubi neque aerugo neque tinea demolitur, et ubi fures non effodiunt nec furantur;"
,"21":"ubi enim est thesaurus tuus, ibi erit et cor tuum."
,"22":"Lucerna corporis est oculus. Si ergo fuerit oculus tuus simplex, totum corpus tuum lucidum erit;"
,"23":"si autem oculus tuus nequam fuerit, totum corpus tuum tenebrosum erit. Si ergo lumen, quod in te est, tene brae sunt, tenebrae quantae erunt!"
,"24":"Nemo potest duobus dominis servire: aut enim unum odio habebit et alterum diliget, aut unum sustinebit et alterum contemnet; non potestis Deo servire et mammonae."
,"25":"Ideo dico vobis: Ne solliciti sitis animae vestrae quid manducetis, neque corpori vestro quid induamini. Nonne anima plus est quam esca, et corpus quam vestimentum?"
,"26":"Respicite volatilia caeli, quoniam non serunt neque metunt neque congregant in horrea, et Pater vester caelestis pascit illa. Nonne vos magis pluris estis illis?"
,"27":"Quis autem vestrum cogitans potest adicere ad aetatem suam cubitum unum?"
,"28":"Et de vestimento quid solliciti estis? Considerate lilia agri quomodo crescunt: non laborant neque nent."
,"29":"Dico autem vobis quoniam nec Salomon in omni gloria sua coopertus est sicut unum ex istis."
,"30":"Si autem fenum agri, quod hodie est et cras in clibanum mittitur, Deus sic vestit, quanto magis vos, modicae fidei?"
,"31":"Nolite ergo solliciti esse dicentes: 'Quid manducabimus?', aut: 'Quid bibemus?', aut: 'Quo operiemur?'."
,"32":"Haec enim omnia gentes inquirunt; scit enim Pater vester caelestis quia his omnibus indigetis."
,"33":"Quaerite autem primum regnum Dei et iustitiam eius, et haec omnia adicientur vobis."
,"34":"Nolite ergo esse solliciti in crastinum; crastinus enim dies sollicitus erit sibi ipse. Sufficit diei malitia sua."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Nolite iudicare, ut non iudice mini;"
,"2":"in quo enim iudicio iudi caveritis, iudicabimini, et in qua mensura mensi fueritis, metietur vobis."
,"3":"Quid autem vides festucam in oculo fratris tui, et trabem in oculo tuo non vides?"
,"4":"Aut quomodo dices fratri tuo: 'Sine, eiciam festucam de oculo tuo', et ecce trabes est in oculo tuo?"
,"5":"Hypocrita, eice primum trabem de oculo tuo, et tunc videbis eicere festucam de oculo fratris tui."
,"6":"Nolite dare sanctum canibus neque mittatis margaritas vestras ante porcos, ne forte conculcent eas pedibus suis et conversi dirumpant vos."
,"7":"Petite, et dabitur vobis; quaerite et invenietis; pulsate, et aperietur vobis."
,"8":"Omnis enim qui petit, accipit; et, qui quaerit, invenit; et pulsanti aperietur."
,"9":"Aut quis est ex vobis homo, quem si petierit filius suus panem, numquid lapidem porriget ei?"
,"10":"Aut si piscem petierit, numquid serpentem porriget ei?"
,"11":"Si ergo vos, cum sitis mali, nostis dona bona dare filiis vestris, quanto magis Pater vester, qui in caelis est, dabit bona petentibus se."
,"12":"Omnia ergo, quaecumque vultis ut faciant vobis homines, ita et vos facite eis; haec est enim Lex et Prophetae."
,"13":"Intrate per angustam portam, quia lata porta et spatiosa via, quae ducit ad perditionem, et multi sunt, qui intrant per eam;"
,"14":"quam angusta porta et arta via, quae ducit ad vitam, et pauci sunt, qui inveniunt eam!"
,"15":"Attendite a falsis prophetis, qui veniunt ad vos in vestimentis ovium, intrinsecus autem sunt lupi rapaces."
,"16":"A fructibus eorum cognoscetis eos; numquid colligunt de spinis uvas aut de tribulis ficus?"
,"17":"Sic omnis arbor bona fructus bonos facit, mala autem arbor fructus malos facit;"
,"18":"non potest arbor bona fructus malos facere, neque arbor mala fructus bonos facere."
,"19":"Omnis arbor, quae non facit fructum bonum, exciditur et in ignem mittitur."
,"20":"Igitur ex fructibus eorum cognoscetis eos."
,"21":"Non omnis, qui dicit mihi: 'Domine, Domine', intrabit in regnum caelorum, sed qui facit voluntatem Patris mei, qui in caelis est."
,"22":"Multi dicent mihi in illa die: 'Domine, Domine, nonne in tuo nomine prophetavimus, et in tuo nomine daemonia eiecimus, et in tuo nomine virtutes multas fecimus?'."
,"23":"Et tunc confitebor illis: Numquam novi vos; discedite a me, qui operamini iniquitatem."
,"24":"Omnis ergo, qui audit verba mea haec et facit ea, assimilabitur viro sapienti, qui aedificavit domum suam supra petram."
,"25":"Et descendit pluvia, et venerunt flumina, et flaverunt venti et irruerunt in domum illam, et non cecidit; fundata enim erat supra petram."
,"26":"Et omnis, qui audit verba mea haec et non facit ea, similis erit viro stulto, qui aedificavit domum suam supra arenam."
,"27":"Et descendit pluvia, et venerunt flumina, et flaverunt venti et irruerunt in domum illam, et cecidit, et fuit ruina eius magna '."
,"28":"Et factum est, cum consummasset Iesus verba haec, admirabantur turbae super doctrinam eius;"
,"29":"erat enim docens eos sicut potestatem habens, et non sicut scribae eorum."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Cum autem descendisset de monte, secutae sunt eum turbae multae."
,"2":"Et ecce leprosus veniens adorabat eum dicens: ' Domine, si vis, potes me mundare '."
,"3":"Et extendens manum, tetigit eum dicens: ' Volo, mundare! '; et confestim mundata est lepra eius."
,"4":"Et ait illi Iesus: ' Vide, nemini dixeris; sed vade, ostende te sacerdoti et offer munus, quod praecepit Moyses, in testimonium illis '."
,"5":"Cum autem introisset Capharnaum, accessit ad eum centurio rogans eum"
,"6":"et dicens: ' Domine, puer meus iacet in domo paralyticus et male torquetur '."
,"7":"Et ait illi: ' Ego veniam et curabo eum '."
,"8":"Et respondens centurio ait: ' Domine, non sum dignus, ut intres sub tectum meum, sed tantum dic verbo, et sanabitur puer meus."
,"9":"Nam et ego homo sum sub potestate, habens sub me milites, et dico huic: 'Vade', et vadit; et alii: 'Veni', et venit; et servo meo: 'Fac hoc', et facit'."
,"10":"Audiens autem Iesus, miratus est et sequentibus se dixit: 'Amen dico vobis: Apud nullum inveni tantam fidem in Israel!"
,"11":"Dico autem vobis quod multi ab oriente et occidente venient et recumbent cum Abraham et Isaac et Iacob in regno caelorum;"
,"12":"filii autem regni eicientur in tenebras exteriores: ibi erit fletus et stridor dentium '."
,"13":"Et dixit Iesus centurioni: ' Vade; sicut credidisti, fiat tibi '. Et sanatus est puer in hora illa."
,"14":"Et cum venisset Iesus in domum Petri, vidit socrum eius iacentem et febricitantem;"
,"15":"et tetigit manum eius, et dimisit eam febris; et surrexit et ministrabat ei."
,"16":"Vespere autem facto, obtulerunt ei multos daemonia habentes; et eiciebat spiritus verbo et omnes male habentes curavit,"
,"17":"ut adimpleretur, quod dictum est per Isaiam prophetam dicentem: ' Ipse infirmitates nostras accepit,et aegrotationes portavit '."
,"18":"Videns autem Iesus turbas multas circum se, iussit ire trans fretum."
,"19":"Et accedens unus scriba ait illi: ' Magister, sequar te, quocumque ieris '."
,"20":"Et dicit ei Iesus: ' Vulpes foveas habent, et volucres caeli tabernacula, Filius autem hominis non habet, ubi caput reclinet '."
,"21":"Alius autem de discipulis eius ait illi: 'Domine, permitte me primum ire et sepelire patrem meum '."
,"22":"Iesus autem ait illi: ' Sequere me et dimitte mortuos sepelire mortuos suos '."
,"23":"Et ascendente eo in naviculam, secuti sunt eum discipuli eius."
,"24":"Et ecce motus magnus factus est in mari, ita ut navicula operiretur fluctibus; ipse vero dormiebat."
,"25":"Et accesserunt et suscitaverunt eum dicentes: ' Domine, salva nos, perimus! '."
,"26":"Et dicit eis: ' Quid timidi estis, modicae fidei? '. Tunc surgens increpavit ventis et mari, et facta est tranquillitas magna."
,"27":"Porro homines mirati sunt dicentes: ' Qualis est hic, quia et venti et mare oboediunt ei? '."
,"28":"Et cum venisset trans fretum in regionem Gadarenorum, occurrerunt ei duo habentes daemonia, de monumentis exeuntes, saevi nimis, ita ut nemo posset transire per viam illam."
,"29":"Et ecce clamaverunt dicentes: ' Quid nobis et tibi, Fili Dei? Venisti huc ante tempus torquere nos? '."
,"30":"Erat autem longe ab illis grex porcorum multorum pascens."
,"31":"Daemones autem rogabant eum dicentes: ' Si eicis nos, mitte nos in gregem porcorum '."
,"32":"Et ait illis: ' Ite '. Et illi exeuntes abierunt in porcos; et ecce impetu abiit totus grex per praeceps in mare, et mortui sunt in aquis."
,"33":"Pastores autem fugerunt et venientes in civitatem nuntiaverunt omnia et de his, qui daemonia habuerant."
,"34":"Et ecce tota civitas exiit obviam Iesu, et viso eo rogabant, ut transiret a finibus eorum."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et ascendens in naviculam transfretavit et venit in civita tem suam."
,"2":"Et ecce offerebant ei paralyticum iacentem in lecto. Et videns Iesus fidem illorum, dixit paralytico: ' Confide, fili; remittuntur peccata tua '."
,"3":"Et ecce quidam de scribis dixerunt intra se: ' Hic blasphemat '."
,"4":"Et cum vidisset Iesus cogitationes eorum, dixit: ' Ut quid cogitatis mala in cordibus vestris?"
,"5":"Quid enim est facilius, dicere: 'Dimittuntur peccata tua', aut dicere: 'Surge et ambula'?"
,"6":"Ut sciatis autem quoniam Filius hominis habet potestatem in terra dimittendi peccata - tunc ait paralytico - : Surge, tolle lectum tuum et vade in domum tuam '."
,"7":"Et surrexit et abiit in domum suam."
,"8":"Videntes autem turbae timuerunt et glorificaverunt Deum, qui dedit potestatem talem hominibus."
,"9":"Et cum transiret inde Iesus, vidit hominem sedentem in teloneo, Matthaeum nomine, et ait illi: 'Sequere me'. Et surgens secutus est eum."
,"10":"Et factum est, discumbente eo in domo, ecce multi publicani et peccatores venientes simul discumbebant cum Iesu et discipulis eius."
,"11":"Et videntes pharisaei dicebant discipulis eius: ' Quare cum publicanis et peccatoribus manducat magister vester? '."
,"12":"At ille audiens ait: ' Non est opus valentibus medico sed male habentibus."
,"13":"Euntes autem discite quid est: 'Misericordiam volo et non sacrificium'. Non enim veni vocare iustos sed peccatores '."
,"14":"Tunc accedunt ad eum discipuli Ioannis dicentes: ' Quare nos et pharisaei ieiunamus frequenter, discipuli autem tui non ieiunant? '."
,"15":"Et ait illis Iesus: ' Numquid possunt convivae nuptiarum lugere, quamdiu cum illis est sponsus? Venient autem dies, cum auferetur ab eis sponsus, et tunc ieiunabunt."
,"16":"Nemo autem immittit commissuram panni rudis in vestimentum vetus; tollit enim supplementum eius a vestimento, et peior scissura fit."
,"17":"Neque mittunt vinum novum in utres veteres, alioquin rumpuntur utres, et vinum effunditur, et utres pereunt; sed vinum novum in utres novos mittunt, et ambo conservantur '."
,"18":"Haec illo loquente ad eos, ecce princeps unus accessit et adorabat eum dicens: ' Filia mea modo defuncta est; sed veni, impone manum tuam super eam, et vivet '."
,"19":"Et surgens Iesus sequebatur eum et discipuli eius."
,"20":"Et ecce mulier, quae sanguinis fluxum patiebatur duodecim annis, accessit retro et tetigit fimbriam vestimenti eius."
,"21":"Dicebat enim intra se: ' Si tetigero tantum vestimentum eius, salva ero '."
,"22":"At Iesus conversus et videns eam dixit: ' Confide, filia; fides tua te salvam fecit '. Et salva facta est mulier ex illa hora."
,"23":"Et cum venisset Iesus in domum principis et vidisset tibicines et turbam tumultuantem,"
,"24":"dicebat: ' Recedite; non est enim mortua puella, sed dormit '. Et deridebant eum."
,"25":"At cum eiecta esset turba, intravit et tenuit manum eius, et surrexit puella."
,"26":"Et exiit fama haec in universam terram illam."
,"27":"Et transeunte inde Iesu, secuti sunt eum duo caeci clamantes et dicentes: ' Miserere nostri, fili David! '."
,"28":"Cum autem venisset domum, accesserunt ad eum caeci, et dicit eis Iesus: ' Creditis quia possum hoc facere? '. Dicunt ei: 'Utique, Domine'."
,"29":"Tunc tetigit oculos eorum dicens: 'Secundum fidem vestram fiat vobis'."
,"30":"Et aperti sunt oculi illorum. Et comminatus est illis Iesus dicens: ' Videte, ne quis sciat '."
,"31":"Illi autem exeuntes diffamaverunt eum in universa terra illa."
,"32":"Egressis autem illis, ecce obtulerunt ei hominem mutum, daemonium habentem."
,"33":"Et eiecto daemone, locutus est mutus. Et miratae sunt turbae dicentes: ' Numquam apparuit sic in Israel! '."
,"34":"Pharisaei autem dicebant: ' In principe daemoniorum eicit daemones '."
,"35":"Et circumibat Iesus civitates omnes et castella, docens in synagogis eorum et praedicans evangelium regni et curans omnem languorem et omnem infirmitatem."
,"36":"Videns autem turbas, misertus est eis, quia erant vexati et iacentes sicut oves non habentes pastorem."
,"37":"Tunc dicit discipulis suis: ' Messis quidem multa, operarii autem pauci;"
,"38":"rogate ergo Dominum messis, ut mittat operarios in messem suam '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Et convocatis Duodecim di scipulis suis, dedit illis pote statem spirituum immundorum, ut eicerent eos et curarent omnem languorem et omnem infirmitatem."
,"2":"Duodecim autem apostolorum nomina sunt haec: primus Simon, qui dicitur Petrus, et Andreas frater eius, et Iacobus Zebedaei et Ioannes frater eius,"
,"3":"Philippus et Bartholomaeus, Thomas et Matthaeus publicanus, Iacobus Alphaei et Thaddaeus,"
,"4":"Simon Chananaeus et Iudas Iscariotes, qui et tradidit eum."
,"5":"Hos Duodecim misit Iesus praecipiens eis et dicens: ' In viam gentium ne abieritis et in civitates Samaritanorum ne intraveritis;"
,"6":"sed potius ite ad oves, quae perierunt domus Israel."
,"7":"Euntes autem praedicate dicentes: 'Appropinquavit regnum caelorum'."
,"8":"Infirmos curate, mortuos suscitate, leprosos mundate, daemones eicite; gratis accepistis, gratis date."
,"9":"Nolite possidere aurum neque argentum neque pecuniam in zonis vestris,"
,"10":"non peram in via neque duas tunicas neque calceamenta neque virgam; dignus enim est operarius cibo suo."
,"11":"In quamcumque civitatem aut castellum intraveritis, interrogate quis in ea dignus sit; et ibi manete donec exeatis."
,"12":"Intrantes autem in domum, salutate eam;"
,"13":"et si quidem fuerit domus digna, veniat pax vestra super eam; si autem non fuerit digna, pax vestra ad vos revertatur."
,"14":"Et quicumque non receperit vos neque audierit sermones vestros, exeuntes foras de domo vel de civitate illa, excutite pulverem de pedibus vestris."
,"15":"Amen dico vobis: Tolerabilius erit terrae Sodomorum et Gomorraeorum in die iudicii quam illi civitati."
,"16":"Ecce ego mitto vos sicut oves in medio luporum; estote ergo prudentes sicut serpentes et simplices sicut columbae."
,"17":"Cavete autem ab hominibus; tradent enim vos in conciliis, et in synagogis suis flagellabunt vos;"
,"18":"et ad praesides et ad reges ducemini propter me in testimonium illis et gentibus."
,"19":"Cum autem tradent vos, nolite cogitare quomodo aut quid loquamini; dabitur enim vobis in illa hora quid loquamini."
,"20":"Non enim vos estis, qui loquimini, sed Spiritus Patris vestri, qui loquitur in vobis."
,"21":"Tradet autem frater fratrem in mortem, et pater filium; et insurgent filii in parentes et morte eos afficient."
,"22":"Et eritis odio omnibus propter nomen meum; qui autem perseveraverit in finem, hic salvus erit."
,"23":"Cum autem persequentur vos in civitate ista, fugite in aliam; amen enim dico vobis: Non consummabitis civitates Israel, donec veniat Filius hominis."
,"24":"Non est discipulus super magistrum nec servus super dominum suum."
,"25":"Sufficit discipulo, ut sit sicut magister eius, et servus sicut dominus eius. Si patrem familias Beelzebul vocaverunt, quanto magis domesticos eius!"
,"26":"Ne ergo timueritis eos. Nihil enim est opertum, quod non revelabitur, et occultum, quod non scietur."
,"27":"Quod dico vobis in tenebris, dicite in lumine; et, quod in aure auditis, praedicate super tecta."
,"28":"Et nolite timere eos, qui occidunt corpus, animam autem non possunt occidere; sed potius eum timete, qui potest et animam et corpus perdere in gehenna."
,"29":"Nonne duo passeres asse veneunt? Et unus ex illis non cadet super terram sine Patre vestro."
,"30":"Vestri autem et capilli capitis omnes numerati sunt."
,"31":"Nolite ergo timere; multis passeribus meliores estis vos."
,"32":"Omnis ergo qui confitebitur me coram hominibus, confitebor et ego eum coram Patre meo, qui est in caelis;"
,"33":"qui autem negaverit me coram hominibus, negabo et ego eum coram Patre meo, qui est in caelis."
,"34":"Nolite arbitrari quia venerim mittere pacem in terram; non veni pacem mittere sed gladium."
,"35":"Veni enim separare,hominem adversus patrem suum,et filiam adversus matrem suam,et nurum adversus socrum suam:"
,"36":"et inimici hominis domestici eius."
,"37":"Qui amat patrem aut matrem plus quam me, non est me dignus; et, qui amat filium aut filiam super me, non est me dignus;"
,"38":"et, qui non accipit crucem suam et sequitur me, non est me dignus."
,"39":"Qui invenerit animam suam, perdet illam; et, qui perdiderit animam suam propter me, inveniet eam."
,"40":"Qui recipit vos, me recipit; et, qui me recipit, recipit eum, qui me misit."
,"41":"Qui recipit prophetam in nomine prophetae, mercedem prophetae accipiet; et, qui recipit iustum in nomine iusti, mercedem iusti accipiet."
,"42":"Et, quicumque potum dederit uni ex minimis istis calicem aquae frigidae tantum in nomine discipuli, amen dico vobis: Non perdet mercedem suam '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et factum est, cum consum masset Iesus praecipiens Duodecim discipulis suis, transiit inde, ut doceret et praedicaret in civitatibus eorum."
,"2":"Ioannes autem, cum audisset in vinculis opera Christi, mittens per discipulos suos"
,"3":"ait illi: ' Tu es qui venturus es, an alium exspectamus? '."
,"4":"Et respondens Iesus ait illis: ' Euntes renuntiate Ioanni, quae auditis et videtis:"
,"5":"caeci vident et claudi ambulant, leprosi mundantur et surdi audiunt et mortui resurgunt et pauperes evangelizantur;"
,"6":"et beatus est, qui non fuerit scandalizatus in me '."
,"7":"Illis autem abeuntibus, coepit Iesus dicere ad turbas de Ioanne: ' Quid existis in desertum videre? Arundinem vento agitatam?"
,"8":"Sed quid existis videre? Hominem mollibus vestitum? Ecce, qui mollibus vestiuntur, in domibus regum sunt."
,"9":"Sed quid existis videre? Prophetam? Etiam, dico vobis, et plus quam prophetam."
,"10":"Hic est, de quo scriptum est: 'Ecce ego mitto angelum meum ante faciem tuam, qui praeparabit viam tuam ante te'."
,"11":"Amen dico vobis: Non surrexit inter natos mulierum maior Ioanne Baptista; qui autem minor est in regno caelorum, maior est illo."
,"12":"A diebus autem Ioannis Baptistae usque nunc regnum caelorum vim patitur, et violenti rapiunt illud."
,"13":"Omnes enim Prophetae et Lex usque ad Ioannem prophetaverunt;"
,"14":"et si vultis recipere, ipse est Elias, qui venturus est."
,"15":"Qui habet aures, audiat."
,"16":"Cui autem similem aestimabo generationem istam? Similis est pueris sedentibus in foro, qui clamantes coaequalibus"
,"17":"dicunt: 'Cecinimus vobis, et non saltastis; lamentavimus, et non planxistis'."
,"18":"Venit enim Ioannes neque manducans neque bibens, et dicunt: 'Daemonium habet!';"
,"19":"venit Filius hominis manducans et bibens, et dicunt: 'Ecce homo vorax et potator vini, publicanorum amicus et peccatorum!'. Et iustificata est sapientia ab operibus suis '."
,"20":"Tunc coepit exprobrare civitatibus, in quibus factae sunt plurimae virtutes eius, quia non egissent paenitentiam:"
,"21":"' Vae tibi, Chorazin! Vae tibi, Bethsaida! Quia si in Tyro et Sidone factae essent virtutes, quae factae sunt in vobis, olim in cilicio et cinere paenitentiam egissent."
,"22":"Verumtamen dico vobis: Tyro et Sidoni remissius erit in die iudicii quam vobis."
,"23":"Et tu, Capharnaum, numquid usque in caelum exaltaberis? Usque in infernum descendes! Quia si in Sodomis factae fuissent virtutes, quae factae sunt in te, mansissent usque in hunc diem."
,"24":"Verumtamen dico vobis: Terrae Sodomorum remissius erit in die iudicii quam tibi '."
,"25":"In illo tempore respondens Iesus dixit: ' Confiteor tibi, Pater, Domine caeli et terrae, quia abscondisti haec a sapientibus et prudentibus et revelasti ea parvulis."
,"26":"Ita, Pater, quoniam sic fuit placitum ante te."
,"27":"Omnia mihi tradita sunt a Patre meo; et nemo novit Filium nisi Pater, neque Patrem quis novit nisi Filius et cui voluerit Filius revelare."
,"28":"Venite ad me, omnes, qui laboratis et onerati estis, et ego reficiam vos."
,"29":"Tollite iugum meum super vos et discite a me, quia mitis sum et humilis corde, et invenietis requiem animabus vestris."
,"30":"Iugum enim meum suave, et onus meum leve est '."
}`)
	CurrentBook.AddChapter(12, `{
"1":"In illo tempore abiit Iesus sabbatis per sata; discipuli autem eius esurierunt et coeperunt vellere spicas et manducare."
,"2":"Pharisaei autem videntes dixerunt ei: ' Ecce discipuli tui faciunt, quod non licet facere sabbato '."
,"3":"At ille dixit eis: ' Non legistis quid fecerit David, quando esuriit, et qui cum eo erant?"
,"4":"Quomodo intravit in domum Dei et panes propositionis comedit, quod non licebat ei edere neque his, qui cum eo erant, nisi solis sacerdotibus?"
,"5":"Aut non legistis in Lege quia sabbatis sacerdotes in templo sabbatum violant et sine crimine sunt?"
,"6":"Dico autem vobis quia templo maior est hic."
,"7":"Si autem sciretis quid est: 'Misericordiam volo et non sacrificium', numquam condemnassetis innocentes."
,"8":"Dominus est enim Filius hominis sabbati '."
,"9":"Et cum inde transisset, venit in synagogam eorum;"
,"10":"et ecce homo manum habens aridam. Et interrogabant eum dicentes: ' Licet sabbatis curare? ', ut accusarent eum."
,"11":"Ipse autem dixit illis: ' Quis erit ex vobis homo, qui habeat ovem unam et, si ceciderit haec sabbatis in foveam, nonne tenebit et levabit eam?"
,"12":"Quanto igitur melior est homo ove! Itaque licet sabbatis bene facere '."
,"13":"Tunc ait homini: ' Extende manum tuam '. Et extendit, et restituta est sana sicut altera."
,"14":"Exeuntes autem pharisaei consilium faciebant adversus eum, quomodo eum perderent."
,"15":"Iesus autem sciens secessit inde. Et secuti sunt eum multi, et curavit eos omnes"
,"16":"et comminatus est eis, ne manifestum eum facerent,"
,"17":"ut adimpleretur, quod dictum est per Isaiam prophetam dicentem:"
,"18":"' Ecce puer meus, quem elegi, dilectus meus, in quo bene placuit animae meae; ponam Spiritum meum super eum, et iudicium gentibus nuntiabit."
,"19":"Non contendet neque clamabit, neque audiet aliquis in plateis vocem eius."
,"20":"Arundinem quassatam non confringet,et linum fumigans non exstinguet, donec eiciat ad victoriam iudicium;"
,"21":"et in nomine eius gentes sperabunt '."
,"22":"Tunc oblatus est ei daemonium habens, caecus et mutus, et curavit eum, ita ut mutus loqueretur et videret."
,"23":"Et stupebant omnes turbae et dicebant: ' Numquid hic est filius David? '."
,"24":"Pharisaei autem audientes dixerunt: ' Hic non eicit daemones nisi in Beelzebul, principe daemonum '."
,"25":"Sciens autem cogitationes eorum dixit eis: ' Omne regnum divisum contra se desolatur, et omnis civitas vel domus divisa contra se non stabit."
,"26":"Et si Satanas Satanam eicit, adversus se divisus est; quomodo ergo stabit regnum eius?"
,"27":"Et si ego in Beelzebul eicio daemones, filii vestri in quo eiciunt? Ideo ipsi iudices erunt vestri."
,"28":"Si autem in Spiritu Dei ego eicio daemones, igitur pervenit in vos regnum Dei."
,"29":"Aut quomodo potest quisquam intrare in domum fortis et vasa eius diripere, nisi prius alligaverit fortem? Et tunc domum illius diripiet."
,"30":"Qui non est mecum, contra me est; et, qui non congregat mecum, spargit."
,"31":"Ideo dico vobis: Omne peccatum et blasphemia remittetur hominibus, Spiritus autem blasphemia non remittetur."
,"32":"Et quicumque dixerit verbum contra Filium hominis, remittetur ei; qui autem dixerit contra Spiritum Sanctum, non remittetur ei neque in hoc saeculo neque in futuro."
,"33":"Aut facite arborem bonam et fructum eius bonum, aut facite arborem malam et fructum eius malum: si quidem ex fructu arbor agnoscitur."
,"34":"Progenies viperarum, quomodo potestis bona loqui, cum sitis mali? Ex abundantia enim cordis os loquitur."
,"35":"Bonus homo de bono thesauro profert bona, et malus homo de malo thesauro profert mala."
,"36":"Dico autem vobis: Omne verbum otiosum, quod locuti fuerint homines, reddent rationem de eo in die iudicii:"
,"37":"ex verbis enim tuis iustificaberis, et ex verbis tuis condemnaberis '."
,"38":"Tunc responderunt ei quidam de scribis et pharisaeis dicentes: ' Magister, volumus a te signum videre '."
,"39":"Qui respondens ait illis: ' Generatio mala et adultera signum requirit; et signum non dabitur ei, nisi signum Ionae prophetae."
,"40":"Sicut enim fuit Ionas in ventre ceti tribus diebus et tribus noctibus, sic erit Filius hominis in corde terrae tribus diebus et tribus noctibus."
,"41":"Viri Ninevitae surgent in iudicio cum generatione ista et condemnabunt eam, quia paenitentiam egerunt in praedicatione Ionae; et ecce plus quam Iona hic!"
,"42":"Regina austri surget in iudicio cum generatione ista et condemnabit eam, quia venit a finibus terrae audire sapientiam Salomonis; et ecce plus quam Salomon hic!"
,"43":"Cum autem immundus spiritus exierit ab homine, ambulat per loca arida quaerens requiem et non invenit."
,"44":"Tunc dicit: 'Revertar in domum meam unde exivi'; et veniens invenit vacantem, scopis mundatam et ornatam."
,"45":"Tunc vadit et assumit secum septem alios spiritus nequiores se, et intrantes habitant ibi; et fiunt novissima hominis illius peiora prioribus. Sic erit et generationi huic pessimae '."
,"46":"Adhuc eo loquente ad turbas, ecce mater et fratres eius stabant foris quaerentes loqui ei."
,"47":"Dixit autem ei quidam: ' Ecce mater tua et fratres tui foris stant quaerentes loqui tecum '."
,"48":"At ille respondens dicenti sibi ait: ' Quae est mater mea, et qui sunt fratres mei? '."
,"49":"Et extendens manum suam in discipulos suos dixit: ' Ecce mater mea et fratres mei."
,"50":"Quicumque enim fecerit voluntatem Patris mei, qui in caelis est, ipse meus frater et soror et mater est '."
}`)
	CurrentBook.AddChapter(13, `{
"1":"In illo die exiens Iesus de domo sedebat secus mare;"
,"2":"et congregatae sunt ad eum turbae multae, ita ut in naviculam ascendens sederet, et omnis turba stabat in litore."
,"3":"Et locutus est eis multa in parabolis dicens: ' Ecce exiit, qui seminat, seminare."
,"4":"Et dum seminat, quaedam ceciderunt secus viam, et venerunt volucres et comederunt ea."
,"5":"Alia autem ceciderunt in petrosa, ubi non habebant terram multam, et continuo exorta sunt, quia non habebant altitudinem terrae;"
,"6":"sole autem orto, aestuaverunt et, quia non habebant radicem, aruerunt."
,"7":"Alia autem ceciderunt in spinas, et creverunt spinae et suffocaverunt ea."
,"8":"Alia vero ceciderunt in terram bonam et dabant fructum: aliud centesimum, aliud sexagesimum, aliud tricesimum."
,"9":"Qui habet aures, audiat '."
,"10":"Et accedentes discipuli dixerunt ei: ' Quare in parabolis loqueris eis? '."
,"11":"Qui respondens ait illis: ' Quia vobis datum est nosse mysteria regni caelorum, illis autem non est datum."
,"12":"Qui enim habet, dabitur ei, et abundabit; qui autem non habet, et quod habet, auferetur ab eo."
,"13":"Ideo in parabolis loquor eis, quia videntes non vident et audientes non audiunt neque intellegunt;"
,"14":"et adimpletur eis prophetia Isaiae dicens: 'Auditu audietis et non intellegetis,et videntes videbitis et non videbitis."
,"15":"Incrassatum est enim cor populi huius, et auribus graviter audierunt,et oculos suos clauserunt, ne quando oculis videant,et auribus audiant,et corde intellegant et convertantur, et sanem eos'."
,"16":"Vestri autem beati oculi, quia vident, et aures vestrae, quia audiunt."
,"17":"Amen quippe dico vobis: Multi prophetae et iusti cupierunt videre, quae videtis, et non viderunt, et audire, quae auditis, et non audierunt!"
,"18":"Vos ergo audite parabolam seminantis."
,"19":"Omnis, qui audit verbum regni et non intellegit, venit Malus et rapit, quod seminatum est in corde eius; hic est, qui secus viam seminatus est."
,"20":"Qui autem supra petrosa seminatus est, hic est, qui verbum audit et continuo cum gaudio accipit illud,"
,"21":"non habet autem in se radicem, sed est temporalis; facta autem tribulatione vel persecutione propter verbum, continuo scandalizatur."
,"22":"Qui autem est seminatus in spinis, hic est, qui verbum audit, et sollicitudo saeculi et fallacia divitiarum suffocat verbum, et sine fructu efficitur."
,"23":"Qui vero in terra bona seminatus est, hic est, qui audit verbum et intellegit et fructum affert et facit aliud quidem centum, aliud autem sexaginta, porro aliud triginta '."
,"24":"Aliam parabolam proposuit illis dicens: ' Simile factum est regnum caelorum homini, qui seminavit bonum semen in agro suo."
,"25":"Cum autem dormirent homines, venit inimicus eius et superseminavit zizania in medio tritici et abiit."
,"26":"Cum autem crevisset herba et fructum fecisset, tunc apparuerunt et zizania."
,"27":"Accedentes autem servi patris familias dixerunt ei: 'Domine, nonne bonum semen seminasti in agro tuo? Unde ergo habet zizania?'."
,"28":"Et ait illis: 'Inimicus homo hoc fecit'. Servi autem dicunt ei: 'Vis, imus et colligimus ea?'."
,"29":"Et ait: 'Non; ne forte colligentes zizania eradicetis simul cum eis triticum,"
,"30":"sinite utraque crescere usque ad messem. Et in tempore messis dicam messoribus: Colligite primum zizania et alligate ea in fasciculos ad comburendum ea, triticum autem congregate in horreum meum' '."
,"31":"Aliam parabolam proposuit eis dicens: ' Simile est regnum caelorum grano sinapis, quod accipiens homo seminavit in agro suo."
,"32":"Quod minimum quidem est omnibus seminibus; cum autem creverit, maius est holeribus et fit arbor, ita ut volucres caeli veniant et habitent in ramis eius '."
,"33":"Aliam parabolam locutus est eis: ' Simile est regnum caelorum fermento, quod acceptum mulier abscondit in farinae satis tribus, donec fermentatum est totum '."
,"34":"Haec omnia locutus est Iesus in parabolis ad turbas; et sine parabola nihil loquebatur eis,"
,"35":"ut adimpleretur, quod dictum erat per prophetam dicentem: ' Aperiam in parabolis os meum, eructabo abscondita a constitutione mundi '."
,"36":"Tunc, dimissis turbis, venit in domum, et accesserunt ad eum discipuli eius dicentes: ' Dissere nobis parabolam zizaniorum agri '."
,"37":"Qui respondens ait: ' Qui seminat bonum semen, est Filius hominis;"
,"38":"ager autem est mundus; bonum vero semen, hi sunt filii regni; zizania autem filii sunt Mali;"
,"39":"inimicus autem, qui seminavit ea, est Diabolus; messis vero consummatio saeculi est; messores autem angeli sunt."
,"40":"Sicut ergo colliguntur zizania et igni comburuntur, sic erit in consummatione saeculi:"
,"41":"mittet Filius hominis angelos suos, et colligent de regno eius omnia scandala et eos, qui faciunt iniquitatem,"
,"42":"et mittent eos in caminum ignis; ibi erit fletus et stridor dentium."
,"43":"Tunc iusti fulgebunt sicut sol in regno Pa tris eorum. Qui habet aures, audiat."
,"44":"Simile est regnum caelorum thesauro abscondito in agro; quem qui invenit homo abscondit et prae gaudio illius vadit et vendit universa, quae habet, et emit agrum illum."
,"45":"Iterum simile est regnum caelorum homini negotiatori quaerenti bonas margaritas."
,"46":"Inventa autem una pretiosa margarita, abiit et vendidit omnia, quae habuit, et emit eam."
,"47":"Iterum simile est regnum caelorum sagenae missae in mare et ex omni genere congreganti;"
,"48":"quam, cum impleta esset, educentes secus litus et sedentes collegerunt bonos in vasa, malos autem foras miserunt."
,"49":"Sic erit in consummatione saeculi: exibunt angeli et separabunt malos de medio iustorum"
,"50":"et mittent eos in caminum ignis; ibi erit fletus et stridor dentium."
,"51":"Intellexistis haec omnia? '. Dicunt ei: ' Etiam '."
,"52":"Ait autem illis: ' Ideo omnis scriba doctus in regno caelorum similis est homini patri familias, qui profert de thesauro suo nova et vetera '."
,"53":"Et factum est, cum consummasset Iesus parabolas istas, transiit inde."
,"54":"Et veniens in patriam suam, docebat eos in synagoga eorum, ita ut mirarentur et dicerent: ' Unde huic sapientia haec et virtutes?"
,"55":"Nonne hic est fabri filius? Nonne mater eius dicitur Maria, et fratres eius Iacobus et Ioseph et Simon et Iudas?"
,"56":"Et sorores eius nonne omnes apud nos sunt? Unde ergo huic omnia ista? '."
,"57":"Et scandalizabantur in eo. Iesus autem dixit eis: ' Non est propheta sine honore nisi in patria et in domo sua '."
,"58":"Et non fecit ibi virtutes multas propter incredulitatem illorum."
}`)
	CurrentBook.AddChapter(14, `{
"1":"In illo tempore audivit He rodes tetrarcha famam Iesu"
,"2":"et ait pueris suis: ' Hic est Ioannes Baptista; ipse surrexit a mortuis, et ideo virtutes operantur in eo '."
,"3":"Herodes enim tenuit Ioannem et alligavit eum et posuit in carcere propter Herodiadem uxorem Philippi fratris sui."
,"4":"Dicebat enim illi Ioannes: ' Non licet tibi habere eam '."
,"5":"Et volens illum occidere, timuit populum, quia sicut prophetam eum habebant."
,"6":"Die autem natalis Herodis saltavit filia Herodiadis in medio et placuit Herodi,"
,"7":"unde cum iuramento pollicitus est ei dare, quodcumque postulasset."
,"8":"At illa, praemonita a matre sua: ' Da mihi, inquit, hic in disco caput Ioannis Baptistae '."
,"9":"Et contristatus rex propter iuramentum et eos, qui pariter recumbebant, iussit dari"
,"10":"misitque et decollavit Ioannem in carcere;"
,"11":"et allatum est caput eius in disco et datum est puellae, et tulit matri suae."
,"12":"Et accedentes discipuli eius tulerunt corpus et sepelierunt illud et venientes nuntiaverunt Iesu."
,"13":"Quod cum audisset Iesus, secessit inde in navicula in locum desertum seorsum; et cum audissent, turbae secutae sunt eum pedestres de civitatibus."
,"14":"Et exiens vidit turbam multam et misertus est eorum et curavit languidos eorum."
,"15":"Vespere autem facto, accesserunt ad eum discipuli dicentes: ' Desertus est locus, et hora iam praeteriit; dimitte turbas, ut euntes in castella emant sibi escas '."
,"16":"Iesus autem dixit eis: ' Non habent necesse ire; date illis vos manducare '."
,"17":"Illi autem dicunt ei: ' Non habemus hic nisi quinque panes et duos pisces '."
,"18":"Qui ait: ' Afferte illos mihi huc '."
,"19":"Et cum iussisset turbas discumbere supra fenum, acceptis quinque panibus et duobus piscibus, aspiciens in caelum benedixit et fregit et dedit discipulis panes, discipuli autem turbis."
,"20":"Et manducaverunt omnes et saturati sunt; et tulerunt reliquias fragmentorum duodecim cophinos plenos."
,"21":"Manducantium autem fuit numerus fere quinque milia virorum, exceptis mulieribus et parvulis."
,"22":"Et statim iussit discipulos ascendere in naviculam et praecedere eum trans fretum, donec dimitteret turbas."
,"23":"Et dimissis turbis, ascendit in montem solus orare. Vespere autem facto, solus erat ibi."
,"24":"Navicula autem iam multis stadiis a terra distabat, fluctibus iactata; erat enim contrarius ventus."
,"25":"Quarta autem vigilia noctis venit ad eos ambulans supra mare."
,"26":"Discipuli autem, videntes eum supra mare ambulantem, turbati sunt dicentes: ' Phantasma est ', et prae timore clamaverunt."
,"27":"Statimque Iesus locutus est eis dicens: ' Habete fiduciam, ego sum; nolite timere! '."
,"28":"Respondens autem ei Petrus dixit: ' Domine, si tu es, iube me venire ad te super aquas '."
,"29":"At ipse ait: ' Veni! '. Et descendens Petrus de navicula ambulavit super aquas et venit ad Iesum."
,"30":"Videns vero ventum validum timuit et, cum coepisset mergi, clamavit dicens: ' Domine, salvum me fac! '."
,"31":"Continuo autem Iesus extendens manum apprehendit eum et ait illi: ' Modicae fidei, quare dubitasti? '."
,"32":"Et cum ascendissent in naviculam, cessavit ventus."
,"33":"Qui autem in navicula erant, adoraverunt eum dicentes: ' Vere Filius Dei es! '."
,"34":"Et cum transfretassent, venerunt in terram Gennesaret."
,"35":"Et cum cognovissent eum viri loci illius, miserunt in universam regionem illam et obtulerunt ei omnes male habentes,"
,"36":"et rogabant eum, ut vel fimbriam vestimenti eius tangerent; et, quicumque tetigerunt, salvi facti sunt."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Tunc accedunt ad Iesum ab Hierosolymis pharisaei et scribae dicentes:"
,"2":"' Quare discipuli tui transgrediuntur traditionem seniorum? Non enim lavant manus suas, cum panem manducant '."
,"3":"Ipse autem respondens ait illis: ' Quare et vos transgredimini mandatum Dei propter traditionem vestram?"
,"4":"Nam Deus dixit: 'Honora patrem tuum et matrem' et: 'Qui maledixerit patri vel matri, morte moriatur'."
,"5":"Vos autem dicitis: 'Quicumque dixerit patri vel matri: Munus est, quodcumque ex me profuerit,"
,"6":"non honorificabit patrem suum'; et irritum fecistis verbum Dei propter traditionem vestram."
,"7":"Hypocritae! Bene prophetavit de vobis Isaias dicens:"
,"8":"'Populus hic labiis me honorat, cor autem eorum longe est a me;"
,"9":"sine causa autem colunt me,docentes doctrinas mandata homi num' '."
,"10":"Et convocata ad se turba, dixit eis: ' Audite et intellegite:"
,"11":"Non quod intrat in os, coinquinat hominem; sed quod procedit ex ore, hoc coinquinat hominem! '."
,"12":"Tunc accedentes discipuli dicunt ei: ' Scis quia pharisaei, audito verbo, scandalizati sunt? '."
,"13":"At ille respondens ait: ' Omnis plantatio, quam non plantavit Pater meus caelestis, eradicabitur."
,"14":"Sinite illos: caeci sunt, duces caecorum. Caecus autem si caeco ducatum praestet, ambo in foveam cadent '."
,"15":"Respondens autem Petrus dixit ei: ' Edissere nobis parabolam istam '."
,"16":"At ille dixit: ' Adhuc et vos sine intellectu estis?"
,"17":"Non intellegitis quia omne quod in os intrat, in ventrem vadit et in secessum emittitur?"
,"18":"Quae autem procedunt de ore, de corde exeunt, et ea coinquinant hominem."
,"19":"De corde enim exeunt cogitationes malae, homicidia, adulteria, fornicationes, furta, falsa testimonia, blasphemiae."
,"20":"Haec sunt, quae coinquinant hominem; non lotis autem manibus manducare non coinquinat hominem '."
,"21":"Et egressus inde Iesus, secessit in partes Tyri et Sidonis."
,"22":"Et ecce mulier Chananaea a finibus illis egressa clamavit dicens: ' Miserere mei, Domine, fili David! Filia mea male a daemonio vexatur '."
,"23":"Qui non respondit ei verbum. Et accedentes discipuli eius rogabant eum dicentes: ' Dimitte eam, quia clamat post nos '. "
,"24":"Ipse autem respondens ait: ' Non sum missus nisi ad oves, quae perierunt domus Israel '."
,"25":"At illa venit et adoravit eum dicens: ' Domine, adiuva me! '."
,"26":"Qui respondens ait: ' Non est bonum sumere panem filiorum et mittere catellis '."
,"27":"At illa dixit: ' Etiam, Domine, nam et catelli edunt de micis, quae cadunt de mensa dominorum suorum '."
,"28":"Tunc respondens Iesus ait illi: ' O mulier, magna est fides tua! Fiat tibi, sicut vis '. Et sanata est filia illius ex illa hora."
,"29":"Et cum transisset inde, Iesus venit secus mare Galilaeae et ascendens in montem sedebat ibi."
,"30":"Et accesserunt ad eum turbae multae habentes secum claudos, caecos, debiles, mutos et alios multos et proiecerunt eos ad pedes eius, et curavit eos,"
,"31":"ita ut turba miraretur videntes mutos loquentes, debiles sanos et claudos ambulantes et caecos videntes. Et magnificabant Deum Israel."
,"32":"Iesus autem convocatis discipulis suis dixit: ' Misereor turbae, quia triduo iam perseverant mecum et non habent, quod manducent; et dimittere eos ieiunos nolo, ne forte deficiant in via '."
,"33":"Et dicunt ei discipuli: ' Unde nobis in deserto panes tantos, ut saturemus turbam tantam? '."
,"34":"Et ait illis Iesus: ' Quot panes habetis? '. At illi dixerunt: ' Septem et paucos pisciculos '."
,"35":"Et praecepit turbae, ut discumberet super terram;"
,"36":"et accipiens septem panes et pisces et gratias agens fregit et dedit discipulis, discipuli autem turbis."
,"37":"Et comederunt omnes et saturati sunt; et, quod superfuit de fragmentis, tulerunt septem sportas plenas."
,"38":"Erant autem, qui manducaverant, quattuor milia hominum extra mulieres et parvulos."
,"39":"Et dimissis turbis, ascendit in naviculam et venit in fines Magadan."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Et accesserunt ad eum pharisaei et sadducaei tentantes et rogaverunt eum, ut signum de caelo ostenderet eis."
,"2":"At ille respondens ait eis: ' Facto vespere dicitis: 'Serenum erit, rubicundum est enim caelum';"
,"3":"et mane: 'Hodie tempestas, rutilat enim triste caelum'. Faciem quidem caeli diiudicare nostis, signa autem temporum non potestis."
,"4":"Generatio mala et adultera signum quaerit, et signum non dabitur ei, nisi signum Ionae '. Et, relictis illis, abiit."
,"5":"Et cum venissent discipuli trans fretum, obliti sunt panes accipere."
,"6":"Iesus autem dixit illis: ' Intuemini et cavete a fermento pharisaeorum et sadducaeorum '."
,"7":"At illi cogitabant inter se dicentes: ' Panes non accepimus!'."
,"8":"Sciens autem Iesus dixit: ' Quid cogitatis inter vos, modicae fidei, quia panes non habetis?"
,"9":"Nondum intellegitis neque recordamini quinque panum quinque milium hominum, et quot cophinos sumpsistis?"
,"10":"Neque septem panum quattuor milium hominum, et quot sportas sumpsistis?"
,"11":"Quomodo non intellegitis quia non de panibus dixi vobis? Sed cavete a fermento pharisaeorum et sadducaeorum '."
,"12":"Tunc intellexerunt quia non dixerit cavendum a fermento panum sed a doctrina pharisaeorum et sadducaeorum."
,"13":"Venit autem Iesus in partes Caesareae Philippi et interrogabat discipulos suos dicens: ' Quem dicunt homines esse Filium hominis?'."
,"14":"At illi dixerunt: ' Alii Ioannem Baptistam, alii autem Eliam, alii vero Ieremiam, aut unum ex prophetis '."
,"15":"Dicit illis: ' Vos autem quem me esse dicitis? '."
,"16":"Respondens Simon Petrus dixit: ' Tu es Christus, Filius Dei vivi '."
,"17":"Respondens autem Iesus dixit ei: ' Beatus es, Simon Bariona, quia caro et sanguis non revelavit tibi sed Pater meus, qui in caelis est."
,"18":"Et ego dico tibi: Tu es Petrus, et super hanc petram aedificabo Ecclesiam meam; et portae inferi non praevalebunt adversum eam."
,"19":"Tibi dabo claves regni caelorum; et quodcumque ligaveris super terram, erit ligatum in caelis, et quodcumque solveris super terram, erit solutum in caelis '."
,"20":"Tunc praecepit discipulis, ut nemini dicerent quia ipse esset Christus."
,"21":"Exinde coepit Iesus ostendere discipulis suis quia oporteret eum ire Hierosolymam et multa pati a senioribus et principibus sacerdotum et scribis et occidi et tertia die resurgere."
,"22":"Et assumens eum Petrus coepit increpare illum dicens: ' Absit a te, Domine; non erit tibi hoc '."
,"23":"Qui conversus dixit Petro: ' Vade post me, Satana! Scandalum es mihi, quia non sapis ea, quae Dei sunt, sed ea, quae hominum! '."
,"24":"Tunc Iesus dixit discipulis suis: ' Si quis vult post me venire, abneget semetipsum et tollat crucem suam et sequatur me."
,"25":"Qui enim voluerit animam suam salvam facere, perdet eam; qui autem perdiderit animam suam propter me, inveniet eam."
,"26":"Quid enim prodest homini, si mundum universum lucretur, animae vero suae detrimentum patiatur? Aut quam dabit homo commutationem pro anima sua?"
,"27":"Filius enim hominis venturus est in gloria Patris sui cum angelis suis, et tunc reddet unicuique secundum opus eius."
,"28":"Amen dico vobis: Sunt quidam de hic stantibus, qui non gustabunt mortem, donec videant Filium hominis venientem in regno suo '."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Et post dies sex assumit Iesus Petrum et Iacobum et Ioan nem fratrem eius et ducit illos in montem excelsum seorsum."
,"2":"Et transfiguratus est ante eos; et resplenduit facies eius sicut sol, vestimenta autem eius facta sunt alba sicut lux."
,"3":"Et ecce apparuit illis Moyses et Elias cum eo loquentes."
,"4":"Respondens autem Petrus dixit ad Iesum: ' Domine, bonum est nos hic esse. Si vis, faciam hic tria tabernacula: tibi unum et Moysi unum et Eliae unum '."
,"5":"Adhuc eo loquente, ecce nubes lucida obumbravit eos; et ecce vox de nube dicens: ' Hic est Filius meus dilectus, in quo mihi bene complacui; ipsum audite '."
,"6":"Et audientes discipuli ceciderunt in faciem suam et timuerunt valde."
,"7":"Et accessit Iesus et tetigit eos dixitque eis: ' Surgite et nolite timere '."
,"8":"Levantes autem oculos suos, neminem viderunt nisi solum Iesum."
,"9":"Et descendentibus illis de monte, praecepit eis Iesus dicens: ' Nemini dixeritis visionem, donec Filius hominis a mortuis resurgat '."
,"10":"Et interrogaverunt eum discipuli dicentes: ' Quid ergo scribae dicunt quod Eliam oporteat primum venire? '."
,"11":"At ille respondens ait: ' Elias quidem venturus est et restituet omnia."
,"12":"Dico autem vobis quia Elias iam venit, et non cognoverunt eum, sed fecerunt in eo, quaecumque voluerunt; sic et Filius hominis passurus est ab eis '."
,"13":"Tunc intellexerunt discipuli quia de Ioanne Baptista dixisset eis."
,"14":"Et cum venissent ad turbam, accessit ad eum homo genibus provolutus ante eum"
,"15":"et dicens: ' Domine, miserere filii mei, quia lunaticus est et male patitur; nam saepe cadit in ignem et crebro in aquam."
,"16":"Et obtuli eum discipulis tuis, et non potuerunt curare eum '."
,"17":"Respondens autem Iesus ait: ' O generatio incredula et perversa, quousque ero vobiscum? Usquequo patiar vos? Afferte huc illum ad me '."
,"18":"Et increpavit eum Iesus, et exiit ab eo daemonium, et curatus est puer ex illa hora."
,"19":"Tunc accesserunt discipuli ad Iesum secreto et dixerunt: ' Quare nos non potuimus eicere illum? '."
,"20":"Ille autem dicit illis: ' Propter modicam fidem vestram. Amen quippe dico vobis: Si habueritis fidem sicut,granum sinapis, dicetis monti huic: 'Transi hinc illuc!', et transibit, et nihil impossibile erit vobis '. (21) 22 Conversantibus autem eis in Galilaea, dixit illis Iesus: ' Filius hominis tradendus est in manus hominum, "
,"23":"et occident eum, et tertio die resurget '. Et contristati sunt vehementer."
,"24":"Et cum venissent Capharnaum, accesserunt, qui didrachma accipiebant, ad Petrum et dixerunt: ' Magister vester non solvit didrachma? '."
,"25":"Ait: ' Etiam'. Et cum intrasset domum, praevenit eum Iesus dicens: ' Quid tibi videtur, Simon? Reges terrae a quibus accipiunt tributum vel censum? A filiis suis an ab alienis? '."
,"26":"Cum autem ille dixisset: ' Ab alienis ', dixit illi Iesus: ' Ergo liberi sunt filii."
,"27":"Ut autem non scandalizemus eos, vade ad mare et mitte hamum; et eum piscem, qui primus ascenderit, tolle; et, aperto ore, eius invenies staterem. Illum sumens, da eis pro me et te '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"In illa hora accesserunt di scipuli ad Iesum dicentes: ' Quis putas maior est in regno caelorum? '."
,"2":"Et advocans parvulum, statuit eum in medio eorum"
,"3":"et dixit: ' Amen dico vobis: Nisi conversi fueritis et efiiciamini sicut parvuli, non intrabitis in regnum caelorum."
,"4":"Quicumque ergo humiliaverit se sicut parvulus iste, hic est maior in regno caelorum."
,"5":"Et, qui susceperit unum parvulum talem in nomine meo, me suscipit."
,"6":"Qui autem scandalizaverit unum de pusillis istis, qui in me credunt, expedit ei, ut suspendatur mola asinaria in collo eius et demergatur in profundum maris."
,"7":"Vae mundo ab scandalis! Necesse est enim ut veniant scandala; verumtamen vae homini, per quem scandalum venit!"
,"8":"Si autem manus tua vel pes tuus scandalizat te, abscide eum et proice abs te: bonum tibi est ad vitam ingredi debilem vel claudum, quam duas manus vel duos pedes habentem mitti in ignem aeternum."
,"9":"Et si oculus tuus scandalizat te, erue eum et proice abs te: bonum tibi est unoculum in vitam intrare, quam duos oculos habentem mitti in gehennam ignis."
,"10":"Videte, ne contemnatis unum ex his pusillis; dico enim vobis quia angeli eorum in caelis semper,vident faciem Patris mei, qui in caelis est. (11) 12 Quid vobis videtur? Si fuerint alicui centum oves, et erraverit una ex eis, nonne relinquet nonaginta novem in montibus et vadit quaerere eam, quae erravit? "
,"13":"Et si contigerit ut inveniat eam, amen dico vobis quia gaudebit super eam magis quam super nonaginta novem, quae non erraverunt."
,"14":"Sic non est voluntas ante Patrem vestrum, qui in caelis est, ut pereat unus de pusillis istis."
,"15":"Si autem peccaverit in te frater tuus, vade, corripe eum inter te et ipsum solum. Si te audierit, lucratus es fratrem tuum;"
,"16":"si autem non audierit, adhibe tecum adhuc unum vel duos, ut in ore duorum testium vel trium stet omne verbum;"
,"17":"quod si noluerit audire eos, dic ecclesiae; si autem et ecclesiam noluerit audire, sit tibi sicut ethnicus et publicanus."
,"18":"Amen dico vobis: Quaecumque alligaveritis super terram, erunt ligata in caelo; et, quaecumque solveritis super terram, erunt soluta in caelo."
,"19":"Iterum dico vobis: Si duo ex vobis consenserint super terram de omni re, quamcumque petierint, fiet illis a Patre meo, qui in caelis est."
,"20":"Ubi enim sunt duo vel tres congregati in nomine meo, ibi sum in medio eorum '."
,"21":"Tunc accedens Petrus dixit ei: ' Domine, quotiens peccabit in me frater meus, et dimittam ei? Usque septies? '."
,"22":"Dicit illi Iesus: ' Non dico tibi usque septies sed usque septuagies septies."
,"23":"Ideo assimilatum est regnum caelorum homini regi, qui voluit rationem ponere cum servis suis."
,"24":"Et cum coepisset rationem ponere, oblatus est ei unus, qui debebat decem milia talenta."
,"25":"Cum autem non haberet, unde redderet, iussit eum dominus venumdari et uxorem et filios et omnia, quae habebat, et reddi."
,"26":"Procidens igitur servus ille adorabat eum dicens: 'Patientiam habe in me, et omnia reddam tibi'."
,"27":"Misertus autem dominus servi illius dimisit eum et debitum dimisit ei."
,"28":"Egressus autem servus ille invenit unum de conservis suis, qui debebat ei centum denarios, et tenens suffocabat eum dicens: 'Redde, quod debes!'."
,"29":"Procidens igitur conservus eius rogabat eum dicens: 'Patientiam habe in me, et reddam tibi'."
,"30":"Ille autem noluit, sed abiit et misit eum in carcerem, donec redderet debitum."
,"31":"Videntes autem conservi eius, quae fiebant, contristati sunt valde et venerunt et narraverunt domino suo omnia, quae facta erant."
,"32":"Tunc vocavit illum dominus suus et ait illi: 'Serve nequam, omne debitum illud dimisi tibi, quoniam rogasti me;"
,"33":"non oportuit et te misereri conservi tui, sicut et ego tui misertus sum?'."
,"34":"Et iratus dominus eius tradidit eum tortoribus, quoadusque redderet universum debitum."
,"35":"Sic et Pater meus caelestis faciet vobis, si non remiseritis unusquisque fratri suo de cordibus vestris '."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Et factum est, cum consum masset Iesus sermones istos, migravit a Galilaea et venit in fines Iudaeae trans Iordanem."
,"2":"Et secutae sunt eum turbae multae, et curavit eos ibi."
,"3":"Et accesserunt ad eum pharisaei tentantes eum et dicentes: ' Licet homini dimittere uxorem suam quacumque ex causa? '."
,"4":"Qui respondens ait: ' Non legistis quia, qui creavit ab initio, masculum et feminam fecit eos"
,"5":"et dixit: 'Propter hoc dimittet homo patrem et matrem et adhaerebit uxori suae, et erunt duo in carne una?'."
,"6":"Itaque iam non sunt duo sed una caro. Quod ergo Deus coniunxit, homo non separet '."
,"7":"Dicunt illi: ' Quid ergo Moyses mandavit dari libellum repudii et dimittere? '."
,"8":"Ait illis: ' Moyses ad duritiam cordis vestri permisit vobis dimittere uxores vestras; ab initio autem non sic fuit."
,"9":"Dico autem vobis quia quicumque dimiserit uxorem suam, nisi ob fornicationem, et aliam duxerit, moechatur '."
,"10":"Dicunt ei discipuli eius: ' Si ita est causa hominis cum uxore, non expedit nubere '."
,"11":"Qui dixit eis: ' Non omnes capiunt verbum istud, sed quibus datum est."
,"12":"Sunt enim eunuchi, qui de matris utero sic nati sunt; et sunt eunuchi, qui facti sunt ab hominibus; et sunt eunuchi, qui seipsos castraverunt propter regnum caelorum. Qui potest capere, capiat '."
,"13":"Tunc oblati sunt ei parvuli, ut manus eis imponeret et oraret; discipuli autem increpabant eis."
,"14":"Iesus vero ait: ' Sinite parvulos et nolite eos prohibere ad me venire; talium est enim regnum caelorum '."
,"15":"Et cum imposuisset eis manus, abiit inde."
,"16":"Et ecce unus accedens ait illi: ' Magister, quid boni faciam, ut habeam vitam aeternam? '. Qui dixit ei:"
,"17":"' Quid me interrogas de bono? Unus est bonus. Si autem vis ad vitam ingredi, serva mandata '."
,"18":"Dicit illi: ' Quae? '. Iesus autem dixit: ' Non homicidium facies, non adulterabis, non facies furtum, non falsum testimonium dices,"
,"19":"honora patrem et matrem et diliges proximum tuum sicut teipsum '."
,"20":"Dicit illi adulescens: ' Omnia haec custodivi. Quid adhuc mihi deest? '."
,"21":"Ait illi Iesus: ' Si vis perfectus esse, vade, vende, quae habes, et da pauperibus, et habebis thesaurum in caelo; et veni, sequere me '."
,"22":"Cum audisset autem adulescens verbum, abiit tristis; erat enim habens multas possessiones."
,"23":"Iesus autem dixit discipulis suis: ' Amen dico vobis: Dives difficile intrabit in regnum caelorum."
,"24":"Et iterum dico vobis: Facilius est camelum per foramen acus transire, quam divitem intrare in regnum Dei '."
,"25":"Auditis autem his, discipuli mirabantur valde dicentes: ' Quis ergo poterit salvus esse? '."
,"26":"Aspiciens autem Iesus dixit illis: ' Apud homines hoc impossibile est, apud Deum autem omnia possibilia sunt '."
,"27":"Tunc respondens Petrus dixit ei: ' Ecce nos reliquimus omnia et secuti sumus te. Quid ergo erit nobis? '."
,"28":"Iesus autem dixit illis: ' Amen dico vobis quod vos, qui secuti estis me, in regeneratione, cum sederit Filius hominis in throno gloriae suae, sedebitis et vos super thronos duodecim, iudicantes duodecim tribus Israel."
,"29":"Et omnis, qui reliquit domos vel fratres aut sorores aut patrem aut matrem aut filios aut agros propter nomen meum, centuplum accipiet et vitam aeternam possidebit."
,"30":"Multi autem erunt primi novissimi, et novissimi primi."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Simile est enim regnum cae lorum homini patri familias, qui exiit primo mane conducere operarios in vineam suam;"
,"2":"conventione autem facta cum operariis ex denario diurno, misit eos in vineam suam."
,"3":"Et egressus circa horam tertiam vidit alios stantes in foro otiosos"
,"4":"et illis dixit: 'Ite et vos in vineam; et, quod iustum fuerit, dabo vobis'."
,"5":"Illi autem abierunt. Iterum autem exiit circa sextam et nonam horam et fecit similiter."
,"6":"Circa undecimam vero exiit et invenit alios stantes et dicit illis: 'Quid hic statis tota die otiosi?'."
,"7":"Dicunt ei: 'Quia nemo nos conduxit'. Dicit illis: 'Ite et vos in vineam'."
,"8":"Cum sero autem factum esset, dicit dominus vineae procuratori suo: ' Voca operarios et redde illis mercedem incipiens a novissimis usque ad primos '."
,"9":"Et cum venissent, qui circa undecimam horam venerant, acceperunt singuli denarium."
,"10":"Venientes autem primi arbitrati sunt quod plus essent accepturi; acceperunt autem et ipsi singuli denarium."
,"11":"Accipientes autem murmurabant adversus patrem familias"
,"12":"dicentes: 'Hi novissimi una hora fecerunt, et pares illos nobis fecisti, qui portavimus pondus diei et aestum!'."
,"13":"At ille respondens uni eorum dixit: 'Amice, non facio tibi iniuriam; nonne ex denario convenisti mecum?"
,"14":"Tolle, quod tuum est, et vade; volo autem et huic novissimo dare sicut et tibi."
,"15":"Aut non licet mihi, quod volo, facere de meis? An oculus tuus nequam est, quia ego bonus sum?'."
,"16":"Sic erunt novissimi primi, et primi novissimi '."
,"17":"Et ascendens Iesus Hierosolymam assumpsit Duodecim discipulos secreto et ait illis in via:"
,"18":"' Ecce ascendimus Hierosolymam, et Filius hominis tradetur principibus sacerdotum et scribis, et condemnabunt eum morte"
,"19":"et tradent eum gentibus ad illudendum et flagellandum et crucifigendum, et tertia die resurget '."
,"20":"Tunc accessit ad eum mater filiorum Zebedaei cum filiis suis, adorans et petens aliquid ab eo."
,"21":"Qui dixit ei: ' Quid vis? '. Ait illi: ' Dic ut sedeant hi duo filii mei unus ad dexteram tuam et unus ad sinistram in regno tuo '."
,"22":"Respondens autem Iesus dixit: ' Nescitis quid petatis. Potestis bibere calicem, quem ego bibiturus sum? '. Dicunt ei: ' Possumus '."
,"23":"Ait illis: ' Calicem quidem meum bibetis, sedere autem ad dexteram meam et sinistram non est meum dare illud, sed quibus paratum est a Patre meo '."
,"24":"Et audientes decem indignati sunt de duobus fratribus."
,"25":"Iesus autem vocavit eos ad se et ait: ' Scitis quia principes gentium dominantur eorum et, qui magni sunt, potestatem exercent in eos."
,"26":"Non ita erit inter vos, sed quicumque voluerit inter vos magnus fieri, erit vester minister;"
,"27":"et, quicumque voluerit inter vos primus esse, erit vester servus;"
,"28":"sicut Filius hominis non venit ministrari sed ministrare et dare animam suam redemptionem pro multis '."
,"29":"Et egredientibus illis ab Iericho, secuta est eum turba multa."
,"30":"Et ecce duo caeci sedentes secus viam audierunt quia Iesus transiret et clamaverunt dicentes: ' Domine, miserere nostri, fili David! '."
,"31":"Turba autem increpabat eos, ut tacerent; at illi magis clamabant dicentes: ' Domine, miserere nostri, fili David! '."
,"32":"Et stetit Iesus et vocavit eos et ait: ' Quid vultis, ut faciam vobis?'."
,"33":"Dicunt illi: ' Domine, ut aperiantur oculi nostri '."
,"34":"Misertus autem Iesus, tetigit oculos eorum; et confestim viderunt et secuti sunt eum."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Et cum appropinquassent Hierosolymis et venissent Bethfage, ad montem Oliveti, tunc Iesus misit duos discipulos"
,"2":"dicens eis: ' Ite in castellum, quod contra vos est, et statim invenietis asinam alligatam et pullum cum ea; solvite et adducite mihi."
,"3":"Et si quis vobis aliquid dixerit, dicite: 'Dominus eos necessarios habet', et confestim dimittet eos '."
,"4":"Hoc autem factum est, ut impleretur, quod dictum est per prophetam dicentem:"
,"5":"' Dicite filiae Sion: Ecce Rex tuus venit tibi, mansuetus et sedens super asinam,et super pullum filium subiugalis '."
,"6":"Euntes autem discipuli fecerunt, sicut praecepit illis Iesus,"
,"7":"et adduxerunt asinam et pullum; et imposuerunt super eis vestimenta sua, et sedit super ea."
,"8":"Plurima autem turba straverunt vestimenta sua in via; alii autem caedebant ramos de arboribus et sternebant in via."
,"9":"Turbae autem, quae praecedebant eum et quae sequebantur, clamabant dicentes: ' Hosanna filio David! Benedictus, qui venit in nomine Domini! Hosanna in altissimis! '."
,"10":"Et cum intrasset Hierosolymam, commota est universa civitas dicens: ' Quis est hic?'."
,"11":"Turbae autem dicebant: ' Hic est Iesus propheta a Nazareth Galilaeae '."
,"12":"Et intravit Iesus in templum et eiciebat omnes vendentes et ementes in templo, et mensas nummulariorum evertit et cathedras vendentium columbas,"
,"13":"et dicit eis: ' Scriptum est: 'Domus mea domus orationis vocabitur'. Vos autem facitis eam speluncam latronum '."
,"14":"Et accesserunt ad eum caeci et claudi in templo, et sanavit eos."
,"15":"Videntes autem principes sacerdotum et scribae mirabilia, quae fecit, et pueros clamantes in templo et dicentes: ' Hosanna filio David ', indignati sunt"
,"16":"et dixerunt ei: ' Audis quid isti dicant? '. Iesus autem dicit eis: ' Utique; numquam legistis: 'Ex ore infantium et lactantium perfecisti laudem'? '."
,"17":"Et relictis illis, abiit foras extra civitatem in Bethaniam ibique mansit."
,"18":"Mane autem revertens in civitatem, esuriit."
,"19":"Et videns fici arborem unam secus viam, venit ad eam; et nihil invenit in ea nisi folia tantum et ait illi: ' Numquam ex te fructus nascatur in sempiternum '. Et arefacta est continuo ficulnea."
,"20":"Et videntes discipuli mirati sunt dicentes: ' Quomodo continuo aruit ficulnea? '."
,"21":"Respondens autem Iesus ait eis: ' Amen dico vobis: Si habueritis fidem et non haesitaveritis, non solum de ficulnea facietis, sed et si monti huic dixeritis: 'Tolle et iacta te in mare', fiet."
,"22":"Et omnia, quaecumque petieritis in oratione credentes, accipietis '."
,"23":"Et cum venisset in templum, accesserunt ad eum docentem principes sacerdotum et seniores populi dicentes: ' In qua potestate haec facis? Et quis tibi dedit hanc potestatem? '."
,"24":"Respondens autem Iesus dixit illis: ' Interrogabo vos et ego unum sermonem, quem si dixeritis mihi, et ego vobis dicam, in qua potestate haec facio:"
,"25":"Baptismum Ioannis unde erat? A caelo an ex hominibus? '. At illi cogitabant inter se dicentes: ' Si dixerimus: 'E caelo', dicet nobis: 'Quare ergo non credidistis illi?';"
,"26":"si autem dixerimus: 'Ex hominibus', timemus turbam; omnes enim habent Ioannem sicut prophetam '."
,"27":"Et respondentes Iesu dixerunt: ' Nescimus '. Ait illis et ipse: ' Nec ego dico vobis in qua potestate haec facio '."
,"28":"' Quid autem vobis videtur? Homo quidam habebat duos filios. Et accedens ad primum dixit: 'Fili, vade hodie, operare in vinea'."
,"29":"Ille autem respondens ait: 'Nolo'; postea autem paenitentia motus abiit."
,"30":"Accedens autem ad alterum dixit similiter. At ille respondens ait: 'Eo, domine'; et non ivit."
,"31":"Quis ex duobus fecit voluntatem patris? '. Dicunt: ' Primus '. Dicit illis Iesus: ' Amen dico vobis: Publicani et meretrices praecedunt vos in regnum Dei."
,"32":"Venit enim ad vos Ioannes in via iustitiae, et non credidistis ei; publicani autem et meretrices crediderunt ei. Vos autem videntes nec paenitentiam habuistis postea, ut crederetis ei."
,"33":"Aliam parabolam audite. Homo erat pater familias, qui plantavit vineam et saepem circumdedit ei et fodit in ea torcular et aedificavit turrim et locavit eam agricolis et peregre profectus est."
,"34":"Cum autem tempus fructuum appropinquasset, misit servos suos ad agricolas, ut acciperent fructus eius."
,"35":"Et agricolae, apprehensis servis eius, alium ceciderunt, alium occiderunt, alium vero lapidaverunt."
,"36":"Iterum misit alios servos plures prioribus, et fecerunt illis similiter."
,"37":"Novissime autem misit ad eos filium suum dicens: 'Verebuntur filium meum'."
,"38":"Agricolae autem videntes filium dixerunt intra se: 'Hic est heres. Venite, occidamus eum et habebimus hereditatem eius'."
,"39":"Et apprehensum eum eiecerunt extra vineam et occiderunt."
,"40":"Cum ergo venerit dominus vineae, quid faciet agricolis illis? '."
,"41":"Aiunt illi: ' Malos male perdet et vineam locabit aliis agricolis, qui reddant ei fructum temporibus suis '."
,"42":"Dicit illis Iesus: ' Numquam legistis in Scripturis: 'Lapidem quem reprobaverunt aedificantes, hic factus est in caput anguli; a Domino factum est istud,et est mirabile in oculis nostris' ?"
,"43":"Ideo dico vobis quia auferetur a vobis regnum Dei et dabitur genti facienti fructus eius."
,"44":"Et, qui ceciderit super lapidem istum confringetur; super quem vero ceciderit, conteret eum '."
,"45":"Et cum audissent principes sacerdotum et pharisaei parabolas eius, cognoverunt quod de ipsis diceret;"
,"46":"et quaerentes eum tenere, timuerunt turbas, quoniam sicut prophetam eum habebant."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Et respondens Iesus dixit ite rum in parabolis eis dicens:"
,"2":"' Simile factum est regnum caelorum homini regi, qui fecit nuptias filio suo."
,"3":"Et misit servos suos vocare invitatos ad nuptias, et nolebant venire."
,"4":"Iterum misit alios servos dicens: 'Dicite invitatis: Ecce prandium meum paravi, tauri mei et altilia occisa, et omnia parata; venite ad nuptias'."
,"5":"Illi autem neglexerunt et abierunt, alius in villam suam, alius vero ad negotiationem suam;"
,"6":"reliqui vero tenuerunt servos eius et contumelia affectos occiderunt."
,"7":"Rex autem iratus est et, missis exercitibus suis, perdidit homicidas illos et civitatem illorum succendit."
,"8":"Tunc ait servis suis: 'Nuptiae quidem paratae sunt, sed qui invitati erant, non fuerunt digni;"
,"9":"ite ergo ad exitus viarum, et quoscumque inveneritis, vocate ad nuptias'."
,"10":"Et egressi servi illi in vias, congregaverunt omnes, quos invenerunt, malos et bonos; et impletae sunt nuptiae discumbentium."
,"11":"Intravit autem rex, ut videret discumbentes, et vidit ibi hominem non vestitum veste nuptiali"
,"12":"et ait illi: 'Amice, quomodo huc intrasti, non habens vestem nuptialem?'. At ille obmutuit."
,"13":"Tunc dixit rex ministris: 'Ligate pedes eius et manus et mittite eum in tenebras exteriores: ibi erit fletus et stridor dentium'."
,"14":"Multi enim sunt vocati, pauci vero electi '."
,"15":"Tunc abeuntes pharisaei consilium inierunt, ut caperent eum in sermone."
,"16":"Et mittunt ei discipulos suos cum herodianis dicentes: ' Magister, scimus quia verax es et viam Dei in veritate doces, et non est tibi cura de aliquo; non enim respicis personam hominum."
,"17":"Dic ergo nobis quid tibi videatur: Licet censum dare Caesari an non? '."
,"18":"Cognita autem Iesus nequitia eorum, ait: ' Quid me tentatis, hypocritae?"
,"19":"Ostendite mihi nomisma census '. At illi obtulerunt ei denarium."
,"20":"Et ait illis: ' Cuius est imago haec et suprascriptio? '."
,"21":"Dicunt ei: ' Caesaris '. Tunc ait illis: ' Reddite ergo, quae sunt Caesaris, Caesari et, quae sunt Dei, Deo '."
,"22":"Et audientes mirati sunt et, relicto eo, abierunt."
,"23":"In illo die accesserunt ad eum sadducaei, qui dicunt non esse resurrectionem, et interrogaverunt eum"
,"24":"dicentes: ' Magister, Moyses dixit, si quis mortuus fuerit non habens filios, ut ducat frater eius uxorem illius et suscitet semen fratri suo."
,"25":"Erant autem apud nos septem fratres: et primus, uxore ducta, defunctus est et non habens semen reliquit uxorem suam fratri suo;"
,"26":"similiter secundus et tertius usque ad septimum."
,"27":"Novissime autem omnium mulier defuncta est."
,"28":"In resurrectione ergo cuius erit de septem uxor? Omnes enim habuerunt eam '."
,"29":"Respondens autem Iesus ait illis: ' Erratis nescientes Scripturas neque virtutem Dei;"
,"30":"in resurrectione enim neque nubent neque nubentur, sed sunt sicut angeli in caelo."
,"31":"De resurrectione autem mortuorum non legistis, quod dictum est vobis a Deo dicente:"
,"32":"'Ego sum Deus Abraham et Deus Isaac et Deus Iacob'? Non est Deus mortuorum sed viventium '."
,"33":"Et audientes turbae mirabantur in doctrina eius."
,"34":"Pharisaei autem audientes quod silentium imposuisset sadducaeis, convenerunt in unum."
,"35":"Et interrogavit unus ex eis legis doctor tentans eum:"
,"36":"' Magister, quod est mandatum magnum in Lege? '."
,"37":"Ait autem illi: ' Diliges Dominum Deum tuum in toto corde tuo et in tota anima tua et in tota mente tua:"
,"38":"hoc est magnum et primum mandatum."
,"39":"Secundum autem simile est huic: Diliges proximum tuum sicut teipsum."
,"40":"In his duobus mandatis universa Lex pendet et Prophetae '."
,"41":"Congregatis autem pharisaeis, interrogavit eos Iesus"
,"42":"dicens: ' Quid vobis videtur de Christo? Cuius filius est? '. Dicunt ei: ' David '."
,"43":"Ait illis: ' Quomodo ergo David in Spiritu vocat eum Dominum dicens:"
,"44":"'Dixit Dominus Domino meo: Sede a dextris meis, donec ponam inimicos tuos sub pedibus tuis'?"
,"45":"Si ergo David vocat eum Dominum, quomodo filius eius est? '."
,"46":"Et nemo poterat respondere ei verbum, neque ausus fuit quisquam ex illa die eum amplius interrogare."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Tunc Iesus locutus est ad turbas et ad discipulos suos"
,"2":"dicens: ' Super cathedram Moysis sederunt scribae et pharisaei."
,"3":"Omnia ergo, quaecumque dixerint vobis, facite et servate; secundum opera vero eorum nolite facere: dicunt enim et non faciunt."
,"4":"Alligant autem onera gravia et importabilia et imponunt in umeros hominum, ipsi autem digito suo nolunt ea movere."
,"5":"Omnia vero opera sua faciunt, ut videantur ab hominibus: dilatant enim phylacteria sua et magnificant fimbrias,"
,"6":"amant autem primum recubitum in cenis et primas cathedras in synagogis"
,"7":"et salutationes in foro et vocari ab hominibus Rabbi."
,"8":"Vos autem nolite vocari Rabbi; unus enim est Magister vester, omnes autem vos fratres estis."
,"9":"Et Patrem nolite vocare vobis super terram, unus enim est Pater vester, caelestis."
,"10":"Nec vocemini Magistri, quia Magister vester unus est, Christus."
,"11":"Qui maior est vestrum, erit minister vester."
,"12":"Qui autem se exaltaverit, humiliabitur; et, qui se humiliaverit, exaltabitur."
,"13":"Vae autem vobis, scribae et pharisaei hypocritae, quia clauditis regnum caelorum ante homines! Vos,enim non intratis nec introeuntes sinitis intrare. (14) 15 Vae vobis, scribae et pharisaei hypocritae, quia circuitis mare et aridam, ut faciatis unum proselytum, et cum fuerit factus, facitis eum filium gehennae duplo quam vos!"
,"16":"Vae vobis, duces caeci, qui dicitis: 'Quicumque iuraverit per templum, nihil est; quicumque autem iuraverit in auro templi, debet'."
,"17":"Stulti et caeci! Quid enim maius est: aurum an templum, quod sanctificat aurum?"
,"18":"Et: 'Quicumque iuraverit in altari, nihil est; quicumque autem iuraverit in dono, quod est super illud, debet'."
,"19":"Caeci! Quid enim maius est: donum an altare, quod sanctificat donum?"
,"20":"Qui ergo iuraverit in altari, iurat in eo et in omnibus, quae super illud sunt;"
,"21":"et, qui iuraverit in templo, iurat in illo et in eo, qui inhabitat in ipso;"
,"22":"et, qui iuraverit in caelo, iurat in throno Dei et in eo, qui sedet super eum."
,"23":"Vae vobis, scribae et pharisaei hypocritae, quia decimatis mentam et anethum et cyminum et reliquistis, quae graviora sunt legis: iudicium et misericordiam et fidem! Haec oportuit facere et illa non omittere."
,"24":"Duces caeci, excolantes culicem, camelum autem glutientes."
,"25":"Vae vobis, scribae et pharisaei hypocritae, quia mundatis, quod de foris est calicis et paropsidis, intus autem pleni sunt rapina et immunditia!"
,"26":"Pharisaee caece, munda prius, quod intus est calicis, ut fiat et id, quod de foris eius est, mundum."
,"27":"Vae vobis, scribae et pharisaei hypocritae, quia similes estis sepulcris dealbatis, quae a foris quidem parent speciosa, intus vero plena sunt ossibus mortuorum et omni spurcitia!"
,"28":"Sic et vos a foris quidem paretis hominibus iusti, intus autem pleni estis hypocrisi et iniquitate."
,"29":"Vae vobis, scribae et pharisaei hypocritae, qui aedificatis sepulcra prophetarum et ornatis monumenta iustorum"
,"30":"et dicitis: 'Si fuissemus in diebus patrum nostrorum, non essemus socii eorum in sanguine prophetarum'!"
,"31":"Itaque testimonio estis vobismetipsis quia filii estis eorum, qui prophetas occiderunt."
,"32":"Et vos implete mensuram patrum vestrorum."
,"33":"Serpentes, genimina viperarum, quomodo fugietis a iudicio gehennae?"
,"34":"Ideo ecce ego mitto ad vos prophetas et sapientes et scribas; ex illis occidetis et crucifigetis et ex eis flagellabitis in synagogis vestris et persequemini de civitate in civitatem,"
,"35":"ut veniat super vos omnis sanguis iustus, qui effusus est super terram a sanguine Abel iusti usque ad sanguinem Zachariae filii Barachiae, quem occidistis inter templum et altare."
,"36":"Amen dico vobis: Venient haec omnia super generationem istam."
,"37":"Ierusalem, Ierusalem, quae occidis prophetas et lapidas eos, qui ad te missi sunt, quotiens volui congregare filios tuos, quemadmodum gallina congregat pullos suos sub alas, et noluistis!"
,"38":"Ecce relinquitur vobis domus vestra deserta!"
,"39":"Dico enim vobis: Non me videbitis amodo, donec dicatis: 'Benedictus, qui venit in nomine Dominil' '."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Et egressus Iesus de templo ibat, et accesserunt discipuli eius, ut ostenderent ei aedificationes templi;"
,"2":"ipse autem respondens dixit eis: ' Non videtis haec omnia? Amen dico vobis: Non relinquetur hic lapis super lapidem, qui non destruetur '."
,"3":"Sedente autem eo super montem Oliveti, accesserunt ad eum discipuli secreto dicentes: ' Dic nobis: Quando haec erunt, et quod signum adventus tui et consummationis saeculi? '."
,"4":"Et respondens Iesus dixit eis: ' Videte, ne quis vos seducat."
,"5":"Multi enim venient in nomine meo dicentes: 'Ego sum Christus', et multos seducent."
,"6":"Audituri enim estis proelia et opiniones proeliorum. Videte, ne turbemini; oportet enim fieri, sed nondum est finis."
,"7":"Consurget enim gens in gentem, et regnum in regnum, et erunt fames et terrae motus per loca;"
,"8":"haec autem omnia initia sunt dolorum."
,"9":"Tunc tradent vos in tribulationem et occident vos, et eritis odio omnibus gentibus propter nomen meum."
,"10":"Et tunc scandalizabuntur multi et invicem tradent et odio habebunt invicem;"
,"11":"et multi pseudoprophetae surgent et seducent multos."
,"12":"Et, quoniam abundavit iniquitas, refrigescet caritas multorum;"
,"13":"qui autem permanserit usque in finem, hic salvus erit."
,"14":"Et praedicabitur hoc evangelium regni in universo orbe in testimonium omnibus gentibus; et tunc veniet consummatio."
,"15":"Cum ergo videritis abominationem desolationis, quae dicta est a Daniele propheta, stantem in loco sancto, qui legit, intellegat:"
,"16":"tunc qui in Iudaea sunt, fugiant ad montes;"
,"17":"qui in tecto, non descendat tollere aliquid de domo sua;"
,"18":"et, qui in agro, non revertatur tollere pallium suum."
,"19":"Vae autem praegnantibus et nutrientibus in illis diebus!"
,"20":"Orate autem, ut non fiat fuga vestra hieme vel sabbato:"
,"21":"erit enim tunc tribulatio magna, qualis non fuit ab initio mundi usque modo neque fiet."
,"22":"Et nisi breviati fuissent dies illi, non fieret salva omnis caro; sed propter electos breviabuntur dies illi."
,"23":"Tunc si quis vobis dixerit: 'Ecce hic Christus' aut: 'Hic', nolite credere."
,"24":"Surgent enim pseudochristi et pseudoprophetae et dabunt signa magna et prodigia, ita ut in errorem inducantur, si fieri potest, etiam electi."
,"25":"Ecce praedixi vobis."
,"26":"Si ergo dixerint vobis: 'Ecce in deserto est', nolite exire; 'Ecce in penetralibus', nolite credere;"
,"27":"sicut enim fulgur exit ab oriente et paret usque in occidentem, ita erit adventus Filii hominis."
,"28":"Ubicumque fuerit corpus, illuc congregabuntur aquilae."
,"29":"Statim autem post tribulationem dierum illorum, sol obscurabitur, et luna non dabit lumen suum, et stellae cadent de caelo, et virtutes caelorum commovebuntur."
,"30":"Et tunc parebit signum Filii hominis in caelo, et tunc plangent omnes tribus terrae et videbunt Filium hominis venientem in nubibus caeli cum virtute et gloria multa;"
,"31":"et mittet angelos suos cum tuba magna, et congregabunt electos eius a quattuor ventis, a summis caelorum usque ad terminos eorum."
,"32":"Ab arbore autem fici discite parabolam: cum iam ramus eius tener fuerit, et folia nata, scitis quia prope est aestas."
,"33":"Ita et vos, cum videritis haec omnia, scitote quia prope est in ianuis."
,"34":"Amen dico vobis: Non praeteribit haec generatio, donec omnia haec fiant."
,"35":"Caelum et terra transibunt, verba vero mea non praeteribunt."
,"36":"De die autem illa et hora nemo scit, neque angeli caelorum neque Filius, nisi Pater solus."
,"37":"Sicut enim dies Noe, ita erit adventus Filii hominis."
,"38":"Sicut enim erant in diebus ante diluvium comedentes et bibentes, nubentes et nuptum tradentes, usque ad eum diem, quo introivit in arcam Noe,"
,"39":"et non cognoverunt, donec venit diluvium et tulit omnes, ita erit et adventus Filii hominis."
,"40":"Tunc duo erunt in agro: unus assumitur, et unus relinquitur;"
,"41":"duae molentes in mola: una assumitur, et una relinquitur."
,"42":"Vigilate ergo, quia nescitis qua die Dominus vester venturus sit."
,"43":"Illud autem scitote quoniam si sciret pater familias qua hora fur venturus esset, vigilaret utique et non sineret perfodi domum suam."
,"44":"Ideo et vos estote parati, quia, qua nescitis hora, Filius hominis venturus est."
,"45":"Quis putas est fidelis servus et prudens, quem constituit dominus supra familiam suam, ut det illis cibum in tempore?"
,"46":"Beatus ille servus, quem cum venerit dominus eius, invenerit sic facientem."
,"47":"Amen dico vobis quoniam super omnia bona sua constituet eum."
,"48":"Si autem dixerit malus servus ille in corde suo: 'Moram facit dominus meus venire',"
,"49":"et coeperit percutere conservos suos, manducet autem et bibat cum ebriis,"
,"50":"veniet dominus servi illius in die, qua non sperat, et in hora, qua ignorat,"
,"51":"et dividet eum partemque eius ponet cum hypocritis; illic erit fletus et stridor dentium."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Tunc simile erit regnum cae lorum decem virginibus, quae accipientes lampades suas exierunt obviam sponso."
,"2":"Quinque autem ex eis erant fatuae, et quinque prudentes."
,"3":"Fatuae enim, acceptis lampadibus suis, non sumpserunt oleum secum;"
,"4":"prudentes vero acceperunt oleum in vasis cum lampadibus suis."
,"5":"Moram autem faciente sponso, dormitaverunt omnes et dormierunt."
,"6":"Media autem nocte clamor factus est: 'Ecce sponsus! Exite obviam ei'."
,"7":"Tunc surrexerunt omnes virgines illae et ornaverunt lampades suas."
,"8":"Fatuae autem sapientibus dixerunt: 'Date nobis de oleo vestro, quia lampades nostrae exstinguuntur'."
,"9":"Responderunt prudentes dicentes: 'Ne forte non sufficiat nobis et vobis, ite potius ad vendentes et emite vobis'."
,"10":"Dum autem irent emere, venit sponsus, et quae paratae erant, intraverunt cum eo ad nuptias; et clausa est ianua."
,"11":"Novissime autem veniunt et reliquae virgines dicentes: 'Domine, domine, aperi nobis'."
,"12":"At ille respondens ait: 'Amen dico vobis: Nescio vos'."
,"13":"Vigilate itaque, quia nescitis diem neque horam."
,"14":"Sicut enim homo peregre proficiscens vocavit servos suos et tradidit illis bona sua."
,"15":"Et uni dedit quinque talenta, alii autem duo, alii vero unum, unicuique secundum propriam virtutem, et profectus est. Statim"
,"16":"abiit, qui quinque talenta acceperat, et operatus est in eis et lucratus est alia quinque;"
,"17":"similiter qui duo acceperat, lucratus est alia duo."
,"18":"Qui autem unum acceperat, abiens fodit in terra et abscondit pecuniam domini sui."
,"19":"Post multum vero temporis venit dominus servorum illorum et ponit rationem cum eis."
,"20":"Et accedens, qui quinque talenta acceperat, obtulit alia quinque talenta dicens: 'Domine, quinque talenta tradidisti mihi; ecce alia quinque superlucratus sum'."
,"21":"Ait illi dominus eius: 'Euge, serve bone et fidelis. Super pauca fuisti fidelis; supra multa te constituam: intra in gaudium domini tui'."
,"22":"Accessit autem et qui duo talenta acceperat, et ait: 'Domine, duo talenta tradidisti mihi; ecce alia duo lucratus sum'."
,"23":"Ait illi dominus eius: 'Euge, serve bone et fidelis. Super pauca fuisti fidelis; supra multa te constituam: intra in gaudium domini tui'."
,"24":"Accedens autem et qui unum talentum acceperat, ait: 'Domine, novi te quia homo durus es: metis, ubi non seminasti, et congregas, ubi non sparsisti;"
,"25":"et timens abii et abscondi talentum tuum in terra. Ecce habes, quod tuum est'."
,"26":"Respondens autem dominus eius dixit ei: 'Serve male et piger! Sciebas quia meto, ubi non seminavi, et congrego, ubi non sparsi?"
,"27":"Oportuit ergo te mittere pecuniam meam nummulariis, et veniens ego recepissem, quod meum est cum usura."
,"28":"Tollite itaque ab eo talentum et date ei, qui habet decem talenta:"
,"29":"omni enim habenti dabitur, et abundabit; ei autem, qui non habet, et quod habet, auferetur ab eo."
,"30":"Et inutilem servum eicite in tenebras exteriores: illic erit fletus et stridor dentium'."
,"31":"Cum autem venerit Filius hominis in gloria sua, et omnes angeli cum eo, tunc sedebit super thronum gloriae suae."
,"32":"Et congregabuntur ante eum omnes gentes; et separabit eos ab invicem, sicut pastor segregat oves ab haedis,"
,"33":"et statuet oves quidem a dextris suis, haedos autem a sinistris."
,"34":"Tunc dicet Rex his, qui a dextris eius erunt: 'Venite, benedicti Patris mei; possidete paratum vobis regnum a constitutione mundi."
,"35":"Esurivi enim, et dedistis mihi manducare; sitivi, et dedistis mihi bibere; hospes eram, et collegistis me;"
,"36":"nudus, et operuistis me; infirmus, et visitastis me; in carcere eram, et venistis ad me'."
,"37":"Tunc respondebunt ei iusti dicentes: 'Domine, quando te vidimus esurientem et pavimus, aut sitientem et dedimus tibi potum?"
,"38":"Quando autem te vidimus hospitem et collegimus, aut nudum et cooperuimus?"
,"39":"Quando autem te vidimus infirmum aut in carcere et venimus ad te?'."
,"40":"Et respondens Rex dicet illis: 'Amen dico vobis: Quamdiu fecistis uni de his fratribus meis minimis, mihi fecistis'."
,"41":"Tunc dicet et his, qui a sinistris erunt: 'Discedite a me, maledicti, in ignem aeternum, qui praeparatus est Diabolo et angelis eius."
,"42":"Esurivi enim, et non dedistis mihi manducare; sitivi, et non dedistis mihi potum;"
,"43":"hospes eram, et non collegistis me; nudus, et non operuistis me; infirmus et in carcere, et non visitastis me'."
,"44":"Tunc respondebunt et ipsi dicentes: 'Domine, quando te vidimus esurientem aut sitientem aut hospitem aut nudum aut infirmum vel in carcere et non ministravimus tibi?'."
,"45":"Tunc respondebit illis dicens: 'Amen dico vobis: Quamdiu non fecistis uni de minimis his, nec mihi fecistis'."
,"46":"Et ibunt hi in supplicium aeternum, iusti autem in vitam aeternam '."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Et factum est, cum consum masset Iesus sermones hos omnes, dixit discipulis suis:"
,"2":"' Scitis quia post biduum Pascha fiet, et Filius hominis traditur, ut crucifigatur '."
,"3":"Tunc congregati sunt principes sacerdotum et seniores populi in aulam principis sacerdotum, qui dicebatur Caiphas,"
,"4":"et consilium fecerunt, ut Iesum dolo tenerent et occiderent;"
,"5":"dicebant autem: ' Non in die festo, ne tumultus fiat in populo '."
,"6":"Cum autem esset Iesus in Bethania, in domo Simonis leprosi,"
,"7":"accessit ad eum mulier habens alabastrum unguenti pretiosi et effudit super caput ipsius recumbentis."
,"8":"Videntes autem discipuli, indignati sunt dicentes: ' Ut quid perditio haec?"
,"9":"Potuit enim istud venumdari multo et dari pauperibus '."
,"10":"Sciens autem Iesus ait illis: ' Quid molesti estis mulieri? Opus enim bonum operata est in me;"
,"11":"nam semper pauperes habetis vobiscum, me autem non semper habetis."
,"12":"Mittens enim haec unguentum hoc supra corpus meum, ad sepeliendum me fecit."
,"13":"Amen dico vobis: Ubicumque praedicatum fuerit hoc evangelium in toto mundo, dicetur et quod haec fecit in memoriam eius '."
,"14":"Tunc abiit unus de Duodecim, qui dicebatur Iudas Iscariotes, ad principes sacerdotum"
,"15":"et ait: ' Quid vultis mihi dare, et ego vobis eum tradam? '. At illi constituerunt ei triginta argenteos."
,"16":"Et exinde quaerebat opportunitatem, ut eum traderet."
,"17":"Prima autem Azymorum accesserunt discipuli ad Iesum dicentes: ' Ubi vis paremus tibi comedere Pascha? '."
,"18":"Ille autem dixit: ' Ite in civitatem ad quendam et dicite ei: 'Magister dicit: Tempus meum prope est; apud te facio Pascha cum discipulis meis' '."
,"19":"Et fecerunt discipuli, sicut constituit illis Iesus, et paraverunt Pascha."
,"20":"Vespere autem facto, discumbebat cum Duodecim."
,"21":"Et edentibus illis, dixit: ' Amen dico vobis: Unus vestrum me traditurus est '."
,"22":"Et contristati valde, coeperunt singuli dicere ei: ' Numquid ego sum, Domine? '."
,"23":"At ipse respondens ait: ' Qui intingit mecum manum in paropside, hic me tradet."
,"24":"Filius quidem hominis vadit, sicut scriptum est de illo; vae autem homini illi, per quem Filius hominis traditur! Bonum erat ei, si natus non fuisset homo ille '."
,"25":"Respondens autem Iudas, qui tradidit eum, dixit: ' Numquid ego sum, Rabbi? '. Ait illi: ' Tu dixisti '."
,"26":"Cenantibus autem eis, accepit Iesus panem et benedixit ac fregit deditque discipulis et ait: ' Accipite, comedite: hoc est corpus meum '."
,"27":"Et accipiens calicem, gratias egit et dedit illis dicens: ' Bibite ex hoc omnes:"
,"28":"hic est enim sanguis meus novi testamenti, qui pro multis effunditur in remissionem peccatorum."
,"29":"Dico autem vobis: Non bibam amodo de hoc genimine vitis usque in diem illum, cum illud bibam vobiscum novum in regno Patris mei '."
,"30":"Et hymno dicto, exierunt in montem Oliveti."
,"31":"Tunc dicit illis Iesus: ' Omnes vos scandalum patiemini in me in ista nocte. Scriptum est enim: 'Percutiam pastorem, et dispergentur oves gregis'."
,"32":"Postquam autem resurrexero, praecedam vos in Galilaeam '."
,"33":"Respondens autem Petrus ait illi: ' Et si omnes scandalizati fuerint in te, ego numquam scandalizabor '."
,"34":"Ait illi Iesus: ' Amen dico tibi: In hac nocte, antequam gallus cantet, ter me negabis '."
,"35":"Ait illi Petrus: ' Etiam si oportuerit me mori tecum, non te negabo '. Similiter et omnes discipuli dixerunt."
,"36":"Tunc venit Iesus cum illis in praedium, quod dicitur Gethsemani. Et dicit discipulis: ' Sedete hic, donec vadam illuc et orem '."
,"37":"Et assumpto Petro et duobus filiis Zebedaei, coepit contristari et maestus esse."
,"38":"Tunc ait illis: ' Tristis est anima mea usque ad mortem; sustinete hic et vigilate mecum '."
,"39":"Et progressus pusillum, procidit in faciem suam orans et dicens: ' Pater mi, si possibile est, transeat a me calix iste; verumtamen non sicut ego volo, sed sicut tu '."
,"40":"Et venit ad discipulos et invenit eos dormientes; et dicit Petro: ' Sic non potuistis una hora vigilare mecum?"
,"41":"Vigilate et orate, ut non intretis in tentationem; spiritus quidem promptus est, caro autem infirma '."
,"42":"Iterum secundo abiit et oravit dicens: ' Pater mi, si non potest hoc transire, nisi bibam illud, fiat voluntas tua '."
,"43":"Et venit iterum et invenit eos dormientes: erant enim oculi eorum gravati."
,"44":"Et relictis illis, iterum abiit et oravit tertio, eundem sermonem iterum dicens."
,"45":"Tunc venit ad discipulos et dicit illis: ' Dormite iam et requiescite; ecce appropinquavit hora, et Filius hominis traditur in manus peccatorum."
,"46":"Surgite, eamus; ecce appropinquavit, qui me tradit '."
,"47":"Et adhuc ipso loquente, ecce Iudas, unus de Duodecim, venit, et cum eo turba multa cum gladiis et fustibus, missi a principibus sacerdotum et senioribus populi."
,"48":"Qui autem tradidit eum, dedit illis signum dicens: ' Quemcumque osculatus fuero, ipse est; tenete eum! '."
,"49":"Et confestim accedens ad Iesum dixit: ' Ave, Rabbi! ' et osculatus est eum."
,"50":"Iesus autem dixit illi: ' Amice, ad quod venisti! '. Tunc accesserunt et manus iniecerunt in Iesum et tenuerunt eum."
,"51":"Et ecce unus ex his, qui erant cum Iesu, extendens manum exemit gladium suum et percutiens servum principis sacerdotum amputavit auriculam eius."
,"52":"Tunc ait illi Iesus: ' Converte gladium tuum in locum suum. Omnes enim, qui acceperint gladium, gladio peribunt."
,"53":"An putas quia non possum rogare Patrem meum, et exhibebit mihi modo plus quam duodecim legiones angelorum?"
,"54":"Quomodo ergo implebuntur Scripturae quia sic oportet fieri? '."
,"55":"In illa hora dixit Iesus turbis: ' Tamquam ad latronem existis cum gladiis et fustibus comprehendere me? Cotidie sedebam docens in templo, et non me tenuistis '."
,"56":"Hoc autem totum factum est, ut implerentur scripturae Prophetarum. Tunc discipuli omnes, relicto eo, fugerunt."
,"57":"Illi autem tenentes Iesum duxerunt ad Caipham principem sacerdotum, ubi scribae et seniores convenerant."
,"58":"Petrus autem sequebatur eum a longe usque in aulam principis sacerdotum; et ingressus intro sede bat cum ministris, ut videret finem."
,"59":"Principes autem sacerdotum et omne concilium quaerebant falsum testimonium contra Iesum, ut eum morti traderent,"
,"60":"et non invenerunt, cum multi falsi testes accessissent. Novissime autem venientes duo"
,"61":"dixerunt: ' Hic dixit: 'Possum destruere templum Dei et post triduum aedificare illud' '."
,"62":"Et surgens princeps sacerdotum ait illi: ' Nihil respondes? Quid isti adversum te testificantur? '."
,"63":"Iesus autem tacebat. Et princeps sacerdotum ait illi: ' Adiuro te per Deum vivum, ut dicas nobis, si tu es Christus Filius Dei '."
,"64":"Dicit illi Iesus: ' Tu dixisti. Verumtamen dico vobis: Amodo videbitis Filium hominis sedentem a dextris Virtutis et venientem in nubibus caeli '."
,"65":"Tunc princeps sacerdotum scidit vestimenta sua dicens: ' Blasphemavit! Quid adhuc egemus testibus? Ecce nunc audistis blasphemiam."
,"66":"Quid vobis videtur? '. Illi autem respondentes dixerunt: ' Reus est mortis! '."
,"67":"Tunc exspuerunt in faciem eius et colaphis eum ceciderunt; alii autem palmas in faciem ei dederunt"
,"68":"dicentes: ' Prophetiza nobis, Christe: Quis est, qui te percussit? '."
,"69":"Petrus vero sedebat foris in atrio; et accessit ad eum una ancilla dicens: ' Et tu cum Iesu Galilaeo eras! '."
,"70":"At ille negavit coram omnibus dicens: ' Nescio quid dicis! '."
,"71":"Exeunte autem illo ad ianuam, vidit eum alia et ait his, qui erant ibi: ' Hic erat cum Iesu Nazareno! '."
,"72":"Et iterum negavit cum iuramento: ' Non novi hominem! '."
,"73":"Post pusillum autem accesserunt, qui stabant, et dixerunt Petro: ' Vere et tu ex illis es, nam et loquela tua manifestum te facit '."
,"74":"Tunc coepit detestari et iurare: ' Non novi hominem! '. Et continuo gallus cantavit;"
,"75":"et recordatus est Petrus verbi Iesu, quod dixerat: ' Priusquam gallus cantet, ter me negabis '. Et egressus foras ploravit amare."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Mane autem facto, consi lium inierunt omnes princi pes sacerdotum et seniores populi adversus Iesum, ut eum morti traderent."
,"2":"Et vinctum adduxerunt eum et tradiderunt Pilato praesidi."
,"3":"Tunc videns Iudas, qui eum tradidit, quod damnatus esset, paenitentia ductus, rettulit triginta argenteos principibus sacerdotum et senioribus"
,"4":"dicens: ' Peccavi tradens sanguinem innocentem '. At illi dixerunt: ' Quid ad nos? Tu videris! '."
,"5":"Et proiectis argenteis in templo, recessit et abiens laqueo se suspendit."
,"6":"Principes autem sacerdotum, acceptis argenteis, dixerunt: ' Non licet mittere eos in corbanam, quia pretium sanguinis est '."
,"7":"Consilio autem inito, emerunt ex illis agrum Figuli in sepulturam peregrinorum."
,"8":"Propter hoc vocatus est ager ille ager Sanguinis usque in hodiernum diem."
,"9":"Tunc impletum est quod dictum est per Ieremiam prophetam di centem: ' Et acceperunt triginta argenteos, pretium appretiati quem appretiaverunt a filiis Israel,"
,"10":"et dederunt eos in agrum Figuli, sicut constituit mihi Dominus '."
,"11":"Iesus autem stetit ante praesidem; et interrogavit eum praeses dicens: ' Tu es Rex Iudaeorum? '. Dixit autem Iesus: ' Tu dicis '."
,"12":"Et cum accusaretur a principibus sacerdotum et senioribus, nihil respondit."
,"13":"Tunc dicit illi Pilatus: ' Non audis quanta adversum te dicant testimonia? '."
,"14":"Et non respondit ei ad ullum verbum, ita ut miraretur praeses vehementer."
,"15":"Per diem autem sollemnem consueverat praeses dimittere turbae unum vinctum, quem voluissent."
,"16":"Habebant autem tunc vinctum insignem, qui dicebatur Barabbas."
,"17":"Congregatis ergo illis dixit Pilatus: ' Quem vultis dimittam vobis: Barabbam an Iesum, qui dicitur Christus? '."
,"18":"Sciebat enim quod per invidiam tradidissent eum."
,"19":"Sedente autem illo pro tribunali, misit ad illum uxor eius dicens: ' Nihil tibi et iusto illi. Multa enim passa sum hodie per visum propter eum '."
,"20":"Principes autem sacerdotum et seniores persuaserunt turbis, ut peterent Barabbam, Iesum vero perderent."
,"21":"Respondens autem praeses ait illis: ' Quem vultis vobis de duobus dimittam? '. At illi dixerunt: ' Barabbam! '."
,"22":"Dicit illis Pilatus: ' Quid igitur faciam de Iesu, qui dicitur Christus? '. Dicunt omnes: ' Crucifigatur! '."
,"23":"Ait autem: ' Quid enim mali fecit? '. At illi magis clamabant dicentes: ' Crucifigatur! '."
,"24":"Videns autem Pilatus quia nihil proficeret, sed magis tumultus fieret, accepta aqua, lavit manus coram turba dicens: ' Innocens ego sum a sanguine hoc; vos videritis! '."
,"25":"Et respondens universus populus dixit: ' Sanguis eius super nos et super filios nostros '."
,"26":"Tunc dimisit illis Barabbam; Iesum autem flagellatum tradidit, ut crucifigeretur."
,"27":"Tunc milites praesidis suscipientes Iesum in praetorio congregaverunt ad eum universam cohortem."
,"28":"Et exuentes eum, clamydem coccineam circumdederunt ei"
,"29":"et plectentes coronam de spinis posuerunt super caput eius et arundinem in dextera eius et, genu flexo ante eum, illudebant ei dicentes: ' Ave, rex Iudaeorum! '."
,"30":"Et exspuentes in eum acceperunt arundinem et percutiebant caput eius."
,"31":"Et postquam illuserunt ei, exuerunt eum clamyde et induerunt eum vestimentis eius et duxerunt eum, ut crucifigerent."
,"32":"Exeuntes autem invenerunt hominem Cyrenaeum nomine Simonem; hunc angariaverunt, ut tolleret crucem eius."
,"33":"Et venerunt in locum, qui dicitur Golgotha, quod est Calvariae locus,"
,"34":"et dederunt ei vinum bibere cum felle mixtum; et cum gustasset, noluit bibere."
,"35":"Postquam autem crucifixerunt eum, diviserunt vestimenta eius sortem mittentes"
,"36":"et sedentes servabant eum ibi."
,"37":"Et imposuerunt super caput eius causam ipsius scriptam: ' Hic est Iesus Rex Iudaeorum '."
,"38":"Tunc crucifiguntur cum eo duo latrones: unus a dextris, et unus a sinistris."
,"39":"Praetereuntes autem blasphemabant eum moventes capita sua"
,"40":"et dicentes: ' Qui destruis templum et in triduo illud reaedificas, salva temetipsum; si Filius Dei es, descende de cruce! '."
,"41":"Similiter et principes sacerdotum illudentes cum scribis et senioribus dicebant:"
,"42":"' Alios salvos fecit, seipsum non potest salvum facere. Rex Israel est; descendat nunc de cruce, et credemus in eum."
,"43":"Confidit in Deo; liberet nunc, si vult eum. Dixit enim: 'Dei Filius sum' '."
,"44":"Idipsum autem et latrones, qui crucifixi erant cum eo, improperabant ei."
,"45":"A sexta autem hora tenebrae factae sunt super universam terram usque ad horam nonam."
,"46":"Et circa horam nonam clamavit Iesus voce magna dicens: ' Eli, Eli, lema sabacthani? ', hoc est: ' Deus meus, Deus meus, ut quid dereliquisti me? '."
,"47":"Quidam autem ex illic stantibus audientes dicebant: ' Eliam vocat iste '."
,"48":"Et continuo currens unus ex eis acceptam spongiam implevit aceto et imposuit arundini et dabat ei bibere."
,"49":"Ceteri vero dicebant: ' Sine, videamus an veniat Elias liberans eum '."
,"50":"Iesus autem iterum clamans voce magna emisit spiritum."
,"51":"Et ecce velum templi scissum est a summo usque deorsum in duas partes, et terra mota est, et petrae scissae sunt;"
,"52":"et monumenta aperta sunt, et multa corpora sanctorum, qui dormierant, surrexerunt"
,"53":"et exeuntes de monumentis post resurrectionem eius venerunt in sanctam civitatem et apparuerunt multis."
,"54":"Centurio autem et, qui cum eo erant custodientes Iesum, viso terrae motu et his, quae fiebant, timuerunt valde dicentes: ' Vere Dei Filius erat iste! '."
,"55":"Erant autem ibi mulieres multae a longe aspicientes, quae secutae erant Iesum a Galilaea ministrantes ei;"
,"56":"inter quas erat Maria Magdalene et Maria Iacobi et Ioseph mater et mater filiorum Zebedaei."
,"57":"Cum sero autem factum esset, venit homo dives ab Arimathaea nomine Ioseph, qui et ipse discipulus erat Iesu."
,"58":"Hic accessit ad Pilatum et petiit corpus Iesu. Tunc Pilatus iussit reddi."
,"59":"Et accepto corpore, Ioseph involvit illud in sindone munda"
,"60":"et posuit illud in monumento suo novo, quod exciderat in petra, et advolvit saxum magnum ad ostium monumenti et abiit."
,"61":"Erat autem ibi Maria Magdalene et altera Maria sedentes contra sepulcrum."
,"62":"Altera autem die, quae est post Parascevem, convenerunt principes sacerdotum et pharisaei ad Pilatum"
,"63":"dicentes: ' Domine, recordati sumus quia seductor ille dixit adhuc vivens: 'Post tres dies resurgam'."
,"64":"Iube ergo custodiri sepulcrum usque in diem tertium, ne forte veniant discipuli eius et furentur eum et dicant plebi: 'Surrexit a mortuis', et erit novissimus error peior priore '."
,"65":"Ait illis Pilatus: ' Habetis custodiam; ite, custodite, sicut scitis '."
,"66":"Illi autem abeuntes munierunt sepulcrum, signantes lapidem, cum custodia."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Sero autem post sabbatum, cum illucesceret in primam sabbati, venit Maria Magdalene et altera Maria videre sepulcrum."
,"2":"Et ecce terrae motus factus est magnus: angelus enim Domini descendit de caelo et accedens revolvit lapidem et sedebat super eum."
,"3":"Erat autem aspectus eius sicut fulgur, et vestimentum eius candidum sicut nix."
,"4":"Prae timore autem eius exterriti sunt custodes et facti sunt velut mortui."
,"5":"Respondens autem angelus dixit mulieribus: ' Nolite timere vos! Scio enim quod Iesum, qui crucifixus est, quaeritis."
,"6":"Non est hic: surrexit enim, sicut dixit. Venite, videte locum, ubi positus erat."
,"7":"Et cito euntes dicite discipulis eius: 'Surrexit a mortuis et ecce praecedit vos in Galilaeam; ibi eum videbitis'. Ecce dixi vobis '."
,"8":"Et exeuntes cito de monumento cum timore et magno gaudio cucurrerunt nuntiare discipulis eius."
,"9":"Et ecce Iesus occurrit illis dicens: ' Avete '. Illae autem accesserunt et tenuerunt pedes eius et adoraverunt eum."
,"10":"Tunc ait illis Iesus: ' Nolite timere; ite, nuntiate fratribus meis, ut eant in Galilaeam et ibi me videbunt '."
,"11":"Quae cum abiissent, ecce quidam de custodia venerunt in civitatem et nuntiaverunt principibus sacerdotum omnia, quae facta fuerant."
,"12":"Et congregati cum senioribus, consilio accepto, pecuniam copiosam dederunt militibus"
,"13":"dicentes: ' Dicite: 'Discipuli eius nocte venerunt et furati sunt eum, nobis dormientibus'."
,"14":"Et si hoc auditum fuerit a praeside, nos suadebimus ei et securos vos faciemus '."
,"15":"At illi, accepta pecunia, fecerunt, sicut erant docti. Et divulgatum est verbum istud apud Iudaeos usque in hodiernum diem."
,"16":"Undecim autem discipuli abierunt in Galilaeam, in montem ubi constituerat illis Iesus,"
,"17":"et videntes eum adoraverunt; quidam autem dubitaverunt."
,"18":"Et accedens Iesus locutus est eis dicens: ' Data est mihi omnis potestas in caelo et in terra."
,"19":"Euntes ergo docete omnes gentes, baptizantes eos in nomine Patris et Filii et Spiritus Sancti,"
,"20":"docentes eos servare omnia, quaecumque mandavi vobis. Et ecce ego vobiscum sum omnibus diebus usque ad consummationem saeculi '."
}`)

}
func LA_NVBSE_LoadNP1CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus, vocatus apostolus Christi Iesu per voluntatem Dei, et Sosthenes frater"
,"2":"ecclesiae Dei, quae est Corinthi, sanctificatis in Christo Iesu, vocatis sanctis cum omnibus, qui invocant nomen Domini nostri Iesu Christi in omni loco ipsorum et nostro:"
,"3":"gratia vobis et pax a Deo Patre nostro et Domino Iesu Christo."
,"4":"Gratias ago Deo meo semper pro vobis in gratia Dei, quae data est vobis in Christo Iesu,"
,"5":"quia in omnibus divites facti estis in illo, in omni verbo et in omni scientia,"
,"6":"sicut testimonium Christi confirmatum est in vobis,"
,"7":"ita ut nihil vobis desit in ulla donatione, exspectantibus revelationem Domini nostri Iesu Christi;"
,"8":"qui et confirmabit vos usque ad finem sine crimine in die Domini nostri Iesu Christi."
,"9":"Fidelis Deus, per quem vocati estis in communionem Filii eius Iesu Christi Domini nostri."
,"10":"Obsecro autem vos, fratres, per nomen Domini nostri Iesu Christi, ut idipsum dicatis omnes, et non sint in vobis schismata, sitis autem perfecti in eodem sensu et in eadem sententia."
,"11":"Significatum est enim mihi de vobis, fratres mei, ab his, qui sunt Chloes, quia contentiones inter vos sunt."
,"12":"Hoc autem dico, quod unusquisque vestrum dicit: ' Ego quidem sum Pauli ', ' Ego autem Apollo ', ' Ego vero Cephae ', ' Ego autem Christi '."
,"13":"Divisus est Christus? Numquid Paulus crucifixus est pro vobis, aut in nomine Pauli baptizati estis?"
,"14":"Gratias ago Deo quod neminem vestrum baptizavi, nisi Crispum et Gaium,"
,"15":"ne quis dicat quod in nomine meo baptizati sitis."
,"16":"Baptizavi autem et Stephanae domum; ceterum nescio si quem alium baptizaverim."
,"17":"Non enim misit me Christus baptizare, sed evangelizare; non in sapientia verbi, ut non evacuetur crux Christi."
,"18":"Verbum enim crucis pereuntibus quidem stultitia est; his autem, qui salvi fiunt, id est nobis, virtus Dei est."
,"19":"Scriptum est enim: ' Perdam sapientiam sapientium,et prudentiam prudentium reprobabo '."
,"20":"Ubi sapiens? Ubi scriba? Ubi conquisitor huius saeculi? Nonne stultam fecit Deus sapientiam huius mundi?"
,"21":"Nam quia in Dei sapientia non cognovit mundus per sapientiam Deum, placuit Deo per stultitiam praedicationis salvos facere credentes."
,"22":"Quoniam et Iudaei signa petunt, et Graeci sapientiam quaerunt,"
,"23":"nos autem praedicamus Christum crucifixum, Iudaeis quidem scandalum, gentibus autem stultitiam;"
,"24":"ipsis autem vocatis, Iudaeis atque Graecis, Christum Dei virtutem et Dei sapientiam;"
,"25":"quia quod stultum est Dei, sapientius est hominibus, et, quod infirmum est Dei, fortius est hominibus."
,"26":"Videte enim vocationem vestram, fratres; quia non multi sapientes secundum carnem, non multi potentes, non multi nobiles;"
,"27":"sed, quae stulta sunt mundi, elegit Deus, ut confundat sapientes, et infirma mundi elegit Deus, ut confundat fortia,"
,"28":"et ignobilia mundi et contemptibilia elegit Deus, quae non sunt, ut ea, quae sunt, destrueret,"
,"29":"ut non glorietur omnis caro in conspectu Dei."
,"30":"Ex ipso autem vos estis in Christo Iesu, qui factus est sapientia nobis a Deo et iustitia et sanctificatio et redemptio,"
,"31":"ut quemadmodum scriptum est: ' Qui gloriatur, in Domino glorietur '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et ego, cum venissem ad vos, fratres, veni non per sublimita tem sermonis aut sapientiae annuntians vobis mysterium Dei."
,"2":"Non enim iudicavi scire me aliquid inter vos nisi Iesum Christum et hunc crucifixum."
,"3":"Et ego in infirmitate et timore et tremore multo fui apud vos,"
,"4":"et sermo meus et praedicatio mea non in persuasibilibus sapientiae verbis sed in ostensione Spiritus et virtutis,"
,"5":"ut fides vestra non sit in sapientia hominum sed in virtute Dei."
,"6":"Sapientiam autem loquimur inter perfectos, sapientiam vero non huius saeculi neque principum huius saeculi, qui destruuntur,"
,"7":"sed loquimur Dei sapientiam in mysterio, quae abscondita est, quam praedestinavit Deus ante saecula in gloriam nostram,"
,"8":"quam nemo principum huius saeculi cognovit; si enim cognovissent, numquam Dominum gloriae crucifixissent."
,"9":"Sed sicut scriptum est: ' Quod oculus non vidit, nec auris audivit, nec in cor hominis ascendit, quae praeparavit Deus his, qui diligunt illum '."
,"10":"Nobis autem revelavit Deus per Spiritum; Spiritus enim omnia scrutatur, etiam profunda Dei."
,"11":"Quis enim scit hominum, quae sint hominis, nisi spiritus hominis, qui in ipso est? Ita et, quae Dei sunt, nemo cognovit nisi Spiritus Dei."
,"12":"Nos autem non spiritum mundi accepimus, sed Spiritum, qui ex Deo est, ut sciamus, quae a Deo donata sunt nobis;"
,"13":"quae et loquimur non in doctis humanae sapientiae sed in doctis Spiritus verbis, spiritalibus spiritalia comparantes."
,"14":"Animalis autem homo non percipit, quae sunt Spiritus Dei, stultitia enim sunt illi, et non potest intellegere, quia spiritaliter examinantur;"
,"15":"spiritalis autem iudicat omnia, et ipse a nemine iudicatur."
,"16":"Quis enim cognovit sensum Domini, qui instruat eum?,Nos autem sensum Christi habemus."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et ego, fratres, non potui vobis loqui quasi spiritalibus sed qua si carnalibus, tamquam parvulis in Christo."
,"2":"Lac vobis potum dedi, non escam, nondum enim poteratis. Sed ne nunc quidem potestis,"
,"3":"adhuc enim estis carnales. Cum enim sit inter vos zelus et contentio, nonne carnales estis et secundum hominem ambulatis?"
,"4":"Cum enim quis dicit: ' Ego quidem sum Pauli ', alius autem: ' Ego Apollo ', nonne homines estis?"
,"5":"Quid igitur est Apollo? Quid vero Paulus? Ministri, per quos credidistis, et unicuique sicut Dominus dedit."
,"6":"Ego plantavi, Apollo rigavit, sed Deus incrementum dedit;"
,"7":"itaque neque qui plantat, est aliquid, neque qui rigat, sed qui incrementum dat, Deus."
,"8":"Qui plantat autem et qui rigat unum sunt; unusquisque autem propriam mercedem accipiet secundum suum laborem."
,"9":"Dei enim sumus adiutores: Dei agri cultura estis, Dei aedificatio estis."
,"10":"Secundum gratiam Dei, quae data est mihi, ut sapiens architectus fundamentum posui; alius autem superaedificat. Unusquisque autem videat quomodo superaedificet;"
,"11":"fundamentum enim aliud nemo potest ponere praeter id, quod positum est, qui est Iesus Christus."
,"12":"Si quis autem superaedificat supra fundamentum aurum, argentum, lapides pretiosos, ligna, fenum, stipulam,"
,"13":"uniuscuiusque opus manifestum erit; dies enim declarabit: quia in igne revelatur, et uniuscuiusque opus quale sit ignis probabit."
,"14":"Si cuius opus manserit, quod superaedificavit, mercedem accipiet;"
,"15":"si cuius opus arserit, detrimentum patietur, ipse autem salvus erit, sic tamen quasi per ignem."
,"16":"Nescitis quia templum Dei estis, et Spiritus Dei habitat in vobis?"
,"17":"Si quis autem templum Dei everterit, evertet illum Deus; templum enim Dei sanctum est, quod estis vos."
,"18":"Nemo se seducat; si quis videtur sapiens esse inter vos in hoc saeculo, stultus fiat, ut sit sapiens."
,"19":"Sapientia enim huius mundi stultitia est apud Deum. Scriptum est enim: ' Qui apprehendit sapientes in astutia eorum ';"
,"20":"et iterum: ' Dominus novit cogitationes sapientium, quoniam vanae sunt '."
,"21":"Itaque nemo glorietur in hominibus. Omnia enim vestra sunt,"
,"22":"sive Paulus sive Apollo sive Cephas sive mundus sive vita sive mors sive praesentia sive futura, omnia enim vestra sunt,"
,"23":"vos autem Christi, Christus autem Dei."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Sic nos existimet homo ut mi nistros Christi et dispensatores mysteriorum Dei."
,"2":"Hic iam quaeritur inter dispensatores, ut fidelis quis inveniatur."
,"3":"Mihi autem pro minimo est, ut a vobis iudicer aut ab humano die. Sed neque meipsum iudico;"
,"4":"nihil enim mihi conscius sum, sed non in hoc iustificatus sum. Qui autem iudicat me, Dominus est!"
,"5":"Itaque nolite ante tempus quidquam iudicare, quoadusque veniat Dominus, qui et illuminabit abscondita tenebrarum et manifestabit consilia cordium; et tunc laus erit unicuique a Deo."
,"6":"Haec autem, fratres, transfiguravi in me et Apollo propter vos, ut in nobis discatis illud: ' Ne supra quae scripta sunt ', ne unus pro alio inflemini adversus alterum."
,"7":"Quis enim te discernit? Quid autem habes, quod non accepisti? Si autem accepisti, quid gloriaris, quasi non acceperis?"
,"8":"Iam saturati estis, iam divites facti estis. Sine nobis regnastis; et utinam regnaretis, ut et nos vobiscum regnaremus."
,"9":"Puto enim, Deus nos apostolos novissimos ostendit tamquam morti destinatos, quia spectaculum facti sumus mundo et angelis et hominibus."
,"10":"Nos stulti propter Christum, vos autem prudentes in Christo; nos infirmi, vos autem fortes; vos gloriosi, nos autem ignobiles."
,"11":"Usque in hanc horam et esurimus et sitimus et nudi sumus et colaphis caedimur et instabiles sumus"
,"12":"et laboramus operantes manibus nostris; maledicti benedicimus, persecutionem passi sustinemus,"
,"13":"blasphemati obsecramus; tamquam purgamenta mundi facti sumus, omnium peripsema, usque adhuc."
,"14":"Non ut confundam vos, haec scribo, sed ut quasi filios meos carissimos moneam;"
,"15":"nam si decem milia paedagogorum habeatis in Christo, sed non multos patres, nam in Christo Iesu per evangelium ego vos genui."
,"16":"Rogo ergo vos: imitatorcs mei estote!"
,"17":"Ideo misi ad vos Timotheum, qui est filius meus carissimus et fidelis in Domino, qui vos commonefaciat vias meas, quae sunt in Christo, sicut ubique in omni ecclesia doceo."
,"18":"Tamquam non venturus sim ad vos, sic inflati sunt quidam;"
,"19":"veniam autem cito ad vos, si Dominus voluerit, et cognoscam non sermonem eorum, qui inflati sunt, sed virtutem;"
,"20":"non enim in sermone est regnum Dei sed in virtute."
,"21":"Quid vultis? In virga veniam ad vos an in caritate et spiritu mansuetudinis?"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Omnino auditur inter vos for nicatio, et talis fornicatio qualis nec inter gentes, ita ut uxorem patris aliquis habeat."
,"2":"Et vos inflati estis et non magis luctum habuistis, ut tollatur de medio vestrum, qui hoc opus fecit?"
,"3":"Ego quidem absens corpore, praesens autem spiritu, iam iudicavi ut praesens eum, qui sic operatus est,"
,"4":"in nomine Domini nostri Iesu, congregatis vobis et meo spiritu cum virtute Domini nostri Iesu,"
,"5":"tradere huiusmodi Satanae in interitum carnis, ut spiritus salvus sit in die Domini."
,"6":"Non bona gloriatio vestra. Nescitis quia modicum fermentum totam massam corrumpit?"
,"7":"Expurgate vetus fermentum, ut sitis nova consparsio, sicut estis azymi. Etenim Pascha nostrum immolatus est Christus!"
,"8":"Itaque festa celebremus, non in fermento veteri neque in fermento malitiae et nequitiae, sed in azymis sinceritatis et veritatis."
,"9":"Scripsi vobis in epistula: Ne commisceamini fornicariis."
,"10":"Non utique fornicariis huius mundi aut avaris aut rapacibus aut idolis servientibus, alioquin debueratis de hoc mundo exisse!"
,"11":"Nunc autem scripsi vobis non commisceri, si is, qui frater nominatur, est fornicator aut avarus aut idolis serviens aut maledicus aut ebriosus aut rapax; cum eiusmodi nec cibum sumere."
,"12":"Quid enim mihi de his, qui foris sunt, iudicare? Nonne de his, qui intus sunt, vos iudicatis?"
,"13":"Nam eos, qui foris sunt, Deus iudicabit. Auferte malum ex vobis ipsis!"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Audet aliquis vestrum habens negotium adversus alterum iu dicari apud iniquos et non apud sanctos?"
,"2":"An nescitis quoniam sancti de mundo iudicabunt? Et si in vobis iudicabitur mundus, indigni estis minimis iudiciis?"
,"3":"Nescitis quoniam angelos iudicabimus, quanto magis saecularia?"
,"4":"Saecularia igitur iudicia si habueritis, contemptibiles, qui sunt in ecclesia, illos constituite ad iudicandum?"
,"5":"Ad verecundiam vestram dico! Sic non est inter vos sapiens quisquam, qui possit iudicare inter fratrem suum?"
,"6":"Sed frater cum fratre iudicio contendit, et hoc apud infideles?"
,"7":"Iam quidem omnino defectio est vobis, quod iudicia habetis inter vosmetipsos! Quare non magis iniuriam accipitis, quare non magis fraudem patimini?"
,"8":"Sed vos iniuriam facitis et fraudatis, et hoc fratribus!"
,"9":"An nescitis quia iniqui regnum Dei non possidebunt? Nolite errare: neque fornicarii neque idolis servientes neque adulteri neque molles neque masculorum concubitores"
,"10":"neque fures neque avari, non ebriosi, non maledici, non rapaces regnum Dei possidebunt."
,"11":"Et haec quidam fuistis. Sed abluti estis, sed sanctificati estis, sed iustificati estis in nomine Domini Iesu Christi et in Spiritu Dei nostri!"
,"12":"' Omnia mihi licent! '. Sed non omnia expediunt. ' Omnia mihi licent! '. Sed ego sub nullius redigar potestate."
,"13":"' Esca ventri, et venter escis! '. Deus autem et hunc et has destruet. Corpus autem non fornicationi sed Domino, et Dominus corpori;"
,"14":"Deus vero et Dominum suscitavit et nos suscitabit per virtutem suam."
,"15":"Nescitis quoniam corpora vestra membra Christi sunt? Tollens ergo membra Christi faciam membra meretricis? Absit!"
,"16":"An nescitis quoniam, qui adhaeret meretrici, unum corpus est? ' Erunt enim, inquit, duo in carne una '."
,"17":"Qui autem adhaeret Domino, unus Spiritus est."
,"18":"Fugite fornicationem! Omne peccatum, quodcumque fecerit homo, extra corpus est; qui autem fornicatur, in corpus suum peccat."
,"19":"An nescitis quoniam corpus vestrum templum est Spiritus Sancti, qui in vobis est, quem habetis a Deo, et non estis vestri?"
,"20":"Empti enim estis pretio! Glorificate ergo Deum in corpore vestro."
}`)
	CurrentBook.AddChapter(7, `{
"1":"De quibus autem scripsistis, bo num est homini mulierem non non tangere;"
,"2":"propter fornicationes autem unusquisque suam uxorem habeat, et unaquaeque suum virum habeat."
,"3":"Uxori vir debitum reddat; similiter autem et uxor viro."
,"4":"Mulier sui corporis potestatem non habet sed vir; similiter autem et vir sui corporis potestatem non habet sed mulier."
,"5":"Nolite fraudare invicem, nisi forte ex consensu ad tempus, ut vacetis orationi et iterum sitis in idipsum, ne tentet vos Satanas propter incontinentiam vestram."
,"6":"Hoc autem dico secundum indulgentiam, non secundum imperium."
,"7":"Volo autem omnes homines esse sicut meipsum; sed unusquisque proprium habet donum ex Deo: alius quidem sic, alius vero sic."
,"8":"Dico autem innuptis et viduis: Bonum est illis si sic maneant, sicut et ego;"
,"9":"quod si non se continent, nubant. Melius est enim nubere quam uri."
,"10":"His autem, qui matrimonio iuncti sunt, praecipio, non ego sed Dominus, uxorem a viro non discedere"
,"11":"- quod si discesserit, maneat innupta aut viro suo reconcilietur - et virum uxorem non dimittere."
,"12":"Ceteris autem ego dico, non Dominus: Si quis frater uxorem habet infidelem, et haec consentit habitare cum illo, non dimittat illam;"
,"13":"et si qua mulier habet virum infidelem, et hic consentit habitare cum illa, non dimittat virum."
,"14":"Sanctificatus est enim vir infidelis in muliere, et sanctificata est mulier infidelis in fratre. Alioquin filii vestri immundi essent; nunc autem sancti sunt."
,"15":"Quod si infidelis discedit, discedat. Non est enim servituti subiectus frater aut soror in eiusmodi; in pace autem vocavit nos Deus."
,"16":"Quid enim scis, mulier, si virum salvum facies? Aut quid scis, vir, si mulierem salvam facies?"
,"17":"Nisi unicuique, sicut divisit Dominus, unumquemque, sicut vocavit Deus, ita ambulet; et sic in omnibus ecclesiis doceo."
,"18":"Circumcisus aliquis vocatus est? Non adducat praeputium! In praeputio aliquis vocatus est? Non circumcidatur!"
,"19":"Circumcisio nihil est, et praeputium nihil est, sed observatio mandatorum Dei."
,"20":"Unusquisque, in qua vocatione vocatus est, in ea permaneat."
,"21":"Servus vocatus es? Non sit tibi curae; sed et si potes liber fieri, magis utere!"
,"22":"Qui enim in Domino vocatus est servus, libertus est Domini; similiter, qui liber vocatus est, servus est Christi!"
,"23":"Pretio empti estis! Nolite fieri servi hominum."
,"24":"Unusquisque, in quo vocatus est, fratres, in hoc maneat apud Deum."
,"25":"De virginibus autem praeceptum Domini non habeo; consilium autem do, tamquam misericordiam consecutus a Domino, ut sim fidelis."
,"26":"Existimo ergo hoc bonum esse propter instantem necessitatem, quoniam bonum est homini sic esse."
,"27":"Alligatus es uxori? Noli quaerere solutionem. Solutus es ab uxore? Noli quaerere uxorem."
,"28":"Si autem acceperis uxorem, non peccasti; et si nupserit virgo, non peccavit. Tribulationem tamen carnis habebunt huiusmodi, ego autem vobis parco."
,"29":"Hoc itaque dico, fratres, tempus breviatum est; reliquum est, ut et qui habent uxores, tamquam non habentes sint,"
,"30":"et qui flent, tamquam non flentes, et qui gaudent, tamquam non gaudentes, et qui emunt, tamquam non possidentes,"
,"31":"et qui utuntur hoc mundo, tamquam non abutentes; praeterit enim figura huius mundi."
,"32":"Volo autem vos sine sollicitudine esse. Qui sine uxore est, sollicitus est, quae Domini sunt, quomodo placeat Domino;"
,"33":"qui autem cum uxore est, sollicitus est, quae sunt mundi, quomodo placeat uxori,"
,"34":"et divisus est. Et mulier innupta et virgo cogitat, quae Domini sunt, ut sit sancta et corpore et spiritu; quae autem nupta est, cogitat, quae sunt mundi, quomodo placeat viro."
,"35":"Porro hoc ad utilitatem vestram dico, non ut laqueum vobis iniciam, sed ad id quod honestum est, et ut assidue cum Domino sitis sine distractione."
,"36":"Si quis autem turpem se videri existimat super virgine sua, quod sit superadulta, et ita oportet fieri, quod vult, faciat; non peccat: nubant."
,"37":"Qui autem statuit in corde suo firmus, non habens necessitatem, potestatem autem habet suae voluntatis, et hoc iudicavit in corde suo servare virginem suam, bene faciet;"
,"38":"igitur et, qui matrimonio iungit virginem suam, bene facit; et, qui non iungit, melius faciet."
,"39":"Mulier alligata est, quanto tempore vir eius vivit; quod si dormierit vir eius, libera est, cui vult nubere, tantum in Domino."
,"40":"Beatior autem erit, si sic permanserit secundum meum consilium; puto autem quod et ego Spiritum Dei habeo."
}`)
	CurrentBook.AddChapter(8, `{
"1":"De idolothytis autem, scimus quia omnes scientiam habemus. Scientia inflat, caritas vero aedificat."
,"2":"Si quis se existimat scire aliquid, nondum cognovit, quemadmodum oporteat eum scire;"
,"3":"si quis autem diligit Deum, hic cognitus est ab eo."
,"4":"De esu igitur idolothytorum, scimus quia nullum idolum est in mundo, et quod nullus deus nisi Unus."
,"5":"Nam et si sunt, qui dicantur dii sive in caelo sive in terra, si quidem sunt dii multi et domini multi,"
,"6":"nobis tamen unus Deus Pater, ex quo omnia et nos in illum, et unus Dominus Iesus Christus, per quem omnia et nos per ipsum."
,"7":"Sed non in omnibus est scientia; quidam autem consuetudine usque nunc idoli quasi idolothytum manducant, et conscientia ipsorum, cum sit infirma, polluitur."
,"8":"Esca autem nos non commendat Deo; neque si non manducaverimus, deficiemus, neque si manducaverimus, abundabimus."
,"9":"Videte autem, ne forte haec licentia vestra offendiculum fiat infirmis."
,"10":"Si enim quis viderit eum, qui habet scientiam, in idolio recumbentem, nonne conscientia eius, cum sit infirma, aedificabitur ad manducandum idolothyta?"
,"11":"Peribit enim infirmus in tua scientia, frater, propter quem Christus mortuus est!"
,"12":"Sic autem peccantes in fratres et percutientes conscientiam eorum infirmam, in Christum peccatis."
,"13":"Quapropter si esca scandalizat fratrem meum, non manducabo carnem in aeternum, ne fratrem meum scandalizem."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Non sum liber? Non sum apo stolus? Nonne Iesum Dominum nostrum vidi? Non opus meum vos estis in Domino?"
,"2":"Si aliis non sum apostolus, sed tamen vobis sum; nam signaculum apostolatus mei vos estis in Domino."
,"3":"Mea defensio apud eos, qui me interrogant, haec est."
,"4":"Numquid non habemus potestatem manducandi et bibendi?"
,"5":"Numquid non habemus potestatem sororem mulierem circumducendi, sicut et ceteri apostoli et fratres Domini et Cephas?"
,"6":"Aut solus ego et Barnabas non habemus potestatem non operandi?"
,"7":"Quis militat suis stipendiis umquam? Quis plantat vineam et fructum eius non edit? Aut quis pascit gregem et de lacte gregis non manducat?"
,"8":"Numquid secundum hominem haec dico? An et lex haec non dicit?"
,"9":"Scriptum est enim in Lege Moysis: ' Non alligabis os bovi trituranti '. Numquid de bobus cura est Deo?"
,"10":"An propter nos utique dicit? Nam propter nos scripta sunt, quoniam debet in spe, qui arat, arare; et, qui triturat, in spe fructus percipiendi."
,"11":"Si nos vobis spiritalia seminavimus, magnum est, si nos carnalia vestra metamus?"
,"12":"Si alii potestatis vestrae participes sunt, non potius nos? Sed non usi sumus hac potestate, sed omnia sustinemus, ne quod offendiculum demus evangelio Christi."
,"13":"Nescitis quoniam, qui sacra operantur, quae de sacrario sunt, edunt; qui altari deserviunt, cum altari participantur?"
,"14":"Ita et Dominus ordinavit his, qui evangelium annuntiant, de evangelio vivere."
,"15":"Ego autem nullo horum usus sum. Non scripsi autem haec, ut ita fiant in me; bonum est enim mihi magis mori quam ut gloriam meam quis evacuet."
,"16":"Nam si evangelizavero, non est mihi gloria; necessitas enim mihi incumbit. Vae enim mihi est, si non evangelizavero!"
,"17":"Si enim volens hoc ago, mercedem habeo; si autem invitus, dispensatio mihi credita est."
,"18":"Quae est ergo merces mea? Ut evangelium praedicans sine sumptu ponam evangelium, ut non abutar potestate mea in evangelio."
,"19":"Nam cum liber essem ex omnibus, omnium me servum feci, ut plures lucri facerem."
,"20":"Et factus sum Iudaeis tamquam Iudaeus, ut Iudaeos lucrarer; his, qui sub lege sunt, quasi sub lege essem, cum ipse non essem sub lege, ut eos, qui sub lege erant, lucri facerem;"
,"21":"his, qui sine lege erant, tamquam sine lege essem, cum sine lege Dei non essem, sed in lege essem Christi, ut lucri facerem eos, qui sine lege erant;"
,"22":"factus sum infirmis infirmus, ut infirmos lucri facerem; omnibus omnia factus sum, ut aliquos utique facerem salvos."
,"23":"Omnia autem facio propter evangelium, ut comparticeps eius efficiar."
,"24":"Nescitis quod hi, qui in stadio currunt, omnes quidem currunt, sed unus accipit bravium? Sic currite, ut comprehendatis."
,"25":"Omnis autem, qui in agone contendit, ab omnibus se abstinet; et illi quidem, ut corruptibilem coronam accipiant, nos autem incorruptam."
,"26":"Ego igitur sic curro non quasi in incertum, sic pugno non quasi aerem verberans;"
,"27":"sed castigo corpus meum et in servitutem redigo, ne forte, cum aliis praedicaverim, ipse reprobus efficiar."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Nolo enim vos ignorare, fra tres, quoniam patres nostri omnes sub nube fuerunt et omnes mare transierunt"
,"2":"et omnes in Moyse baptizati sunt in nube et in mari"
,"3":"et omnes eandem escam spiritalem manducaverunt"
,"4":"et omnes eundem potum spiritalem biberunt; bibebant autem de spiritali, consequente eos, petra; petra autem erat Christus."
,"5":"Sed non in pluribus eorum complacuit sibi Deus, nam prostrati sunt in deserto."
,"6":"Haec autem figurae fuerunt nostrae, ut non simus concupiscentes malorum, sicut et illi concupierunt."
,"7":"Neque idolorum cultores efficiamini, sicut quidam ex ipsis; quemadmodum scriptum est: ' Sedit populus manducare et bibere, et surrexerunt ludere '."
,"8":"Neque fornicemur, sicut quidam ex ipsis fornicati sunt, et ceciderunt una die viginti tria milia."
,"9":"Neque tentemus Christum, sicut quidam eorum tentaverunt et a serpentibus perierunt."
,"10":"Neque murmuraveritis, sicut quidam eorum murmuraverunt et perierunt ab exterminatore."
,"11":"Haec autem in figura contingebant illis; scripta sunt autem ad correptionem nostram, in quos fines saeculorum devenerunt."
,"12":"Itaque, qui se existimat stare, videat, ne cadat."
,"13":"Tentatio vos non apprehendit nisi humana; fidelis autem Deus, qui non patietur vos tentari super id quod potestis, sed faciet cum tentatione etiam proventum, ut possitis sustinere."
,"14":"Propter quod, carissimi mihi, fugite ab idolorum cultura."
,"15":"Ut prudentibus loquor; vos iudicate, quod dico:"
,"16":"Calix benedictionis, cui benedicimus, nonne communicatio sanguinis Christi est? Et panis, quem frangimus, nonne communicatio corporis Christi est?"
,"17":"Quoniam unus panis, unum corpus multi sumus, omnes enim de uno pane participamur."
,"18":"Videte Israel secundum carnem: nonne, qui edunt hostias, communicantes sunt altari?"
,"19":"Quid ergo dico? Quod idolothytum sit aliquid? Aut quod idolum sit aliquid?"
,"20":"Sed, quae immolant, daemoniis immolant et non Deo; nolo autem vos communicantes fieri daemoniis."
,"21":"Non potestis calicem Domini bibere et calicem daemoniorum; non potestis mensae Domini participes esse et mensae daemoniorum."
,"22":"An aemulamur Dominum? Numquid fortiores illo sumus?"
,"23":"' Omnia licent! '. Sed non omnia expediunt. ' Omnia licent! '. Sed non omnia aedificant."
,"24":"Nemo, quod suum est, quaerat, sed quod alterius."
,"25":"Omne, quod in macello venit, manducate, nihil interrogantes propter conscientiam;"
,"26":"Domini enim est terra, et plenitudo eius."
,"27":"Si quis vocat vos infidelium, et vultis ire, omne, quod vobis apponitur, manducate, nihil interrogantes propter conscientiam."
,"28":"Si quis autem vobis dixerit: ' Hoc immolaticium est idolis ', nolite manducare, propter illum, qui indicavit, et propter conscientiam;"
,"29":"conscientiam autem dico non tuam ipsius sed alterius. Ut quid enim libertas mea iudicatur ab alia conscientia?"
,"30":"Si ego cum gratia participo, quid blasphemor pro eo, quod gratias ago?"
,"31":"Sive ergo manducatis sive bibitis sive aliud quid facitis, omnia in gloriam Dei facite."
,"32":"Sine offensione estote Iudaeis et Graecis et ecclesiae Dei,"
,"33":"sicut et ego per omnia omnibus placeo, non quaerens, quod mihi utile est, sed quod multis, ut salvi fiant."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Imitatores mei estote, sicut et ego Christi."
,"2":"Laudo autem vos quod omnia mei memores estis et, sicut tradidi vobis, traditiones meas tenetis."
,"3":"Volo autem vos scire quod omnis viri caput Christus est, caput autem mulieris vir, caput vero Christi Deus."
,"4":"Omnis vir orans aut prophetans velato capite deturpat caput suum;"
,"5":"omnis autem mulier orans aut prophetans non velato capite deturpat caput suum; unum est enim atque si decalvetur."
,"6":"Nam si non velatur mulier, et tondeatur! Si vero turpe est mulieri tonderi aut decalvari, veletur."
,"7":"Vir quidem non debet velare caput, quoniam imago et gloria est Dei; mulier autem gloria viri est."
,"8":"Non enim vir ex muliere est, sed mulier ex viro;"
,"9":"etenim non est creatus vir propter mulierem, sed mulier propter virum."
,"10":"Ideo debet mulier potestatem habere supra caput propter angelos."
,"11":"Verumtamen neque mulier sine viro, neque vir sine muliere in Domino;"
,"12":"nam sicut mulier de viro, ita et vir per mulierem, omnia autem ex Deo."
,"13":"In vobis ipsi iudicate: Decet mulierem non velatam orare Deum?"
,"14":"Nec ipsa natura docet vos quod vir quidem, si comam nutriat, ignominia est illi;"
,"15":"mulier vero, si comam nutriat, gloria est illi? Quoniam coma pro velamine ei data est."
,"16":"Si quis autem videtur contentiosus esse, nos talem consuetudinem non habemus, neque ecclesiae Dei."
,"17":"Hoc autem praecipio, non laudans quod non in melius sed in deterius convenitis."
,"18":"Primum quidem convenientibus vobis in ecclesia, audio scissuras inter vos esse et ex parte credo."
,"19":"Nam oportet et haereses inter vos esse, ut et, qui probati sunt, manifesti fiant in vobis."
,"20":"Convenientibus ergo vobis in unum, non est dominicam cenam manducare;"
,"21":"unusquisque enim suam cenam praesumit in manducando, et alius quidem esurit, alius autem ebrius est."
,"22":"Numquid domos non habetis ad manducandum et bibendum? Aut ecclesiam Dei contemnitis et confunditis eos, qui non habent? Quid dicam vobis? Laudabo vos? In hoc non laudo!"
,"23":"Ego enim accepi a Domino, quod et tradidi vobis, quoniam Dominus Iesus, in qua nocte tradebatur, accepit panem"
,"24":"et gratias agens fregit et dixit: ' Hoc est corpus meum, quod pro vobis est; hoc facite in meam commemorationem ';"
,"25":"similiter et calicem, postquam cenatum est, dicens: ' Hic calix novum testamentum est in meo sanguine; hoc facite, quotiescumque bibetis, in meam commemorationem '."
,"26":"Quotiescumque enim manducabitis panem hunc et calicem bibetis, mortem Domini annuntiatis, donec veniat."
,"27":"Itaque, quicumque manducaverit panem vel biberit calicem Domini indigne, reus erit corporis et sanguinis Domini."
,"28":"Probet autem seipsum homo, et sic de pane illo edat et de calice bibat;"
,"29":"qui enim manducat et bibit, iudicium sibi manducat et bibit non diiudicans corpus."
,"30":"Ideo inter vos multi infirmi et imbecilles et dormiunt multi."
,"31":"Quod si nosmetipsos diiudicaremus, non utique iudicaremur;"
,"32":"dum iudicamur autem, a Domino corripimur, ut non cum hoc mundo damnemur"
,"33":"Itaque, fratres mei, cum convenitis ad manducandum, invicem exspectate."
,"34":"Si quis esurit, domi manducet, ut non in iudicium conveniatis. Cetera autem, cum venero, disponam."
}`)
	CurrentBook.AddChapter(12, `{
"1":"De spiritalibus autem, fra tres, nolo vos ignorare."
,"2":"Scitis quoniam, cum gentes essetis, ad simulacra muta, prout ducebamini, euntes."
,"3":"Ideo notum vobis facio quod nemo in Spiritu Dei loquens dicit: ' Anathema Iesus! '; et nemo potest dicere: ' Dominus Iesus ', nisi in Spiritu Sancto."
,"4":"Divisiones vero gratiarum sunt, idem autem Spiritus;"
,"5":"et divisiones ministrationum sunt, idem autem Dominus;"
,"6":"et divisiones operationum sunt, idem vero Deus, qui operatur omnia in omnibus."
,"7":"Unicuique autem datur manifestatio Spiritus ad utilitatem."
,"8":"Alii quidem per Spiritum datur sermo sapientiae, alii autem sermo scientiae secundum eundem Spiritum,"
,"9":"alteri fides in eodem Spiritu, alii donationes sanitatum in uno Spiritu,"
,"10":"alii operationes virtutum, alii prophetatio, alii discretio spirituum, alii genera linguarum, alii interpretatio linguarum;"
,"11":"haec autem omnia operatur unus et idem Spiritus, dividens singulis prout vult."
,"12":"Sicut enim corpus unum est et membra habet multa, omnia autem membra corporis, cum sint multa, unum corpus sunt, ita et Christus;"
,"13":"etenim in uno Spiritu omnes nos in unum corpus baptizati sumus, sive Iudaei sive Graeci sive servi sive liberi, et omnes unum Spiritum potati sumus."
,"14":"Nam et corpus non est unum membrum sed multa."
,"15":"Si dixerit pes: 'Non sum manus, non sum de corpore ', non ideo non est de corpore;"
,"16":"et si dixerit auris: ' Non sum oculus, non sum de corpore ', non ideo non est de corpore."
,"17":"Si totum corpus oculus est, ubi auditus? Si totum auditus, ubi odoratus?"
,"18":"Nunc autem posuit Deus membra, unumquodque eorum in corpore, sicut voluit."
,"19":"Quod si essent omnia unum membrum, ubi corpus?"
,"20":"Nunc autem multa quidem membra, unum autem corpus."
,"21":"Non potest dicere oculus manui: ' Non es mihi necessaria! '; aut iterum caput pedibus: ' Non estis mihi necessarii! '."
,"22":"Sed multo magis, quae videntur membra corporis infirmiora esse, necessaria sunt;"
,"23":"et, quae putamus ignobiliora membra esse corporis, his honorem abundantiorem circumdamus; et, quae inhonesta sunt nostra, abundantiorem honestatem habent,"
,"24":"honesta autem nostra nullius egent. Sed Deus temperavit corpus, ei, cui deerat, abundantiorem tribuendo honorem,"
,"25":"ut non sit schisma in corpore, sed idipsum pro invicem sollicita sint membra."
,"26":"Et sive patitur unum membrum, compatiuntur omnia membra; sive glorificatur unum membrum, congaudent omnia membra."
,"27":"Vos autem estis corpus Christi et membra ex parte."
,"28":"Et quosdam quidem posuit Deus in ecclesia primum apostolos, secundo prophetas, tertio doctores, deinde virtutes, exinde donationes curationum, opitulationes, gubernationes, genera linguarum."
,"29":"Numquid omnes apostoli? Numquid omnes prophetae? Numquid omnes doctores? Numquid omnes virtutes?"
,"30":"Numquid omnes donationes habent curationum? Numquid omnes linguis loquuntur? Numquid omnes interpretantur?"
,"31":"Aemulamini autem charismata maiora. Et adhuc excellentiorem viam vobis demonstro."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Si linguis hominum loquar et angelorum, caritatem au tem non habeam, factus sum velut aes sonans aut cymbalum tinniens."
,"2":"Et si habuero prophetiam et noverim mysteria omnia et omnem scientiam, et si habuero omnem fidem, ita ut montes transferam, caritatem autem non habuero, nihil sum."
,"3":"Et si distribuero in cibos omnes facultates meas et si tradidero corpus meum, ut glorier, caritatem autem non habuero, nihil mihi prodest."
,"4":"Caritas patiens est, benigna est caritas, non aemulatur, non agit superbe, non inflatur,"
,"5":"non est ambitiosa, non quaerit, quae sua sunt, non irritatur, non cogitat malum,"
,"6":"non gaudet super iniquitatem, congaudet autem veritati;"
,"7":"omnia suffert, omnia credit, omnia sperat, omnia sustinet."
,"8":"Caritas numquam excidit. Sive prophetiae, evacuabuntur; sive linguae, cessabunt; sive scientia, destruetur."
,"9":"Ex parte enim cognoscimus et ex parte prophetamus;"
,"10":"cum autem venerit, quod perfectum est, evacuabitur, quod ex parte est."
,"11":"Cum essem parvulus, loquebar ut parvulus, sapiebam ut parvulus, cogitabam ut parvulus; quando factus sum vir, evacuavi, quae erant parvuli."
,"12":"Videmus enim nunc per speculum in aenigmate, tunc autem facie ad faciem; nunc cognosco ex parte, tunc autem cognoscam, sicut et cognitus sum."
,"13":"Nunc autem manet fides, spes, caritas, tria haec; maior autem ex his est caritas."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sectamini caritatem, aemu lamini spiritalia, magis au tem, ut prophetetis."
,"2":"Qui enim loquitur lingua, non hominibus loquitur sed Deo; nemo enim audit, spiritu autem loquitur mysteria."
,"3":"Qui autem prophetat, hominibus loquitur aedificationem et exhortationem et consolationes."
,"4":"Qui loquitur lingua, semetipsum aedificat; qui autem prophetat, ecclesiam aedificat."
,"5":"Volo autem omnes vos loqui linguis, magis autem prophetare; maior autem est qui prophetat, quam qui loquitur linguis, nisi forte interpretetur, ut ecclesia aedificationem accipiat."
,"6":"Nunc autem, fratres, si venero ad vos linguis loquens, quid vobis prodero, nisi vobis loquar aut in revelatione aut in scientia aut in prophetia aut in doctrina?"
,"7":"Tamen, quae sine anima sunt vocem dantia, sive tibia sive cithara, nisi distinctionem sonituum dederint, quomodo scietur quod tibia canitur, aut quod citharizatur?"
,"8":"Etenim si incertam vocem det tuba, quis parabit se ad bellum?"
,"9":"Ita et vos per linguam nisi manifestum sermonem dederitis, quomodo scietur id, quod dicitur? Eritis enim in aera loquentes."
,"10":"Tam multa, ut puta, genera linguarum sunt in mundo, et nihil sine voce est."
,"11":"Si ergo nesciero virtutem vocis, ero ei, qui loquitur, barbarus; et, qui loquitur, mihi barbarus."
,"12":"Sic et vos, quoniam aemulatores estis spirituum, ad aedificationem ecclesiae quaerite, ut abundetis."
,"13":"Et ideo, qui loquitur lingua, oret, ut interpretetur."
,"14":"Nam si orem lingua, spiritus meus orat, mens autem mea sine fructu est."
,"15":"Quid ergo est? Orabo spiritu, orabo et mente; psallam spiritu, psallam et mente."
,"16":"Ceterum si benedixeris in spiritu, qui supplet locum idiotae, quomodo dicet ' Amen! ' super tuam benedictionem, quoniam quid dicas nescit?"
,"17":"Nam tu quidem bene gratias agis, sed alter non aedificatur."
,"18":"Gratias ago Deo, quod omnium vestrum magis linguis loquor;"
,"19":"sed in ecclesia volo quinque verba sensu meo loqui, ut et alios instruam, quam decem milia verborum in lingua."
,"20":"Fratres, nolite pueri effici sensibus, sed malitia parvuli estote; sensibus autem perfecti estote."
,"21":"In lege scriptum est: ' In aliis linguis et in labiis aliorum,loquar populo huic, et nec sic exaudient me ', dicit Dominus. "
,"22":"Itaque linguae in signum sunt non fidelibus sed infidelibus, prophetia autem non infidelibus sed fidelibus."
,"23":"Si ergo conveniat universa ecclesia in unum, et omnes linguis loquantur, intrent autem idiotae aut infideles, nonne dicent quod insanitis?"
,"24":"Si autem omnes prophetent, intret autem quis infidelis vel idiota, convincitur ab omnibus, diiudicatur ab omnibus,"
,"25":"occulta cordis eius manifesta fiunt; et ita cadens in faciem adorabit Deum pronuntians: ' Vere Deus in vobis est! '."
,"26":"Quid ergo est, fratres? Cum convenitis, unusquisque psalmum habet, doctrinam habet, apocalypsim habet, linguam habet, interpretationem habet: omnia ad aedificationem fiant."
,"27":"Sive lingua quis loquitur, secundum duos aut ut multum tres, et per partes, et unus interpretetur;"
,"28":"si autem non fuerit interpres, taceat in ecclesia, sibi autem loquatur et Deo."
,"29":"Prophetae duo aut tres dicant, et ceteri diiudicent;"
,"30":"quod si alii revelatum fuerit sedenti, prior taceat."
,"31":"Potestis enim omnes per singulos prophetare, ut omnes discant, et omnes exhortentur;"
,"32":"et spiritus prophetarum prophetis subiecti sunt;"
,"33":"non enim est dissensionis Deus sed pacis. Sicut in omnibus ecclesiis sanctorum, "
,"34":"mulieres in ecclesiis taceant, non enim permittitur eis loqui; sed subditae sint, sicut et Lex dicit."
,"35":"Si quid autem volunt discere, domi viros suos interrogent; turpe est enim mulieri loqui in ecclesia."
,"36":"An a vobis verbum Dei processit aut in vos solos pervenit?"
,"37":"Si quis videtur propheta esse aut spiritalis, cognoscat, quae scribo vobis, quia Domini est mandatum."
,"38":"Si quis autem ignorat, ignorabitur."
,"39":"Itaque, fratres mei, aemulamini prophetare et loqui linguis nolite prohibere;"
,"40":"omnia autem honeste et secundum ordinem fiant."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Notum autem vobis facio, fratres, evangelium, quod evangelizavi vobis, quod et accepistis, in quo et statis,"
,"2":"per quod et salvamini, qua ratione evangelizaverim vobis, si tenetis, nisi si frustra credidistis!"
,"3":"Tradidi enim vobis in primis, quod et accepi, quoniam Christus mortuus est pro peccatis nostris secundum Scripturas"
,"4":"et quia sepultus est et quia suscitatus est tertia die secundum Scripturas"
,"5":"et quia visus est Cephae et post haec Duodecim;"
,"6":"deinde visus est plus quam quingentis fratribus simul, ex quibus plures manent usque adhuc, quidam autem dormierunt;"
,"7":"deinde visus est Iacobo, deinde apostolis omnibus;"
,"8":"novissime autem omnium, tamquam abortivo, visus est et mihi."
,"9":"Ego enim sum minimus apostolorum, qui non sum dignus vocari apostolus, quoniam persecutus sum ecclesiam Dei;"
,"10":"gratia autem Dei sum id, quod sum, et gratia eius in me vacua non fuit, sed abundantius illis omnibus laboravi; non ego autem, sed gratia Dei mecum."
,"11":"Igitur sive ego sive illi, sic praedicamus, et sic credidistis."
,"12":"Si autem Christus praedicatur quod suscitatus est a mortuis, quomodo quidam dicunt in vobis quoniam resurrectio mortuorum non est?"
,"13":"Si autem resurrectio mortuorum non est, neque Christus suscitatus est!"
,"14":"Si autem Christus non suscitatus est, inanis est ergo praedicatio nostra, inanis est et fides vestra;"
,"15":"invenimur autem et falsi testes Dei, quoniam testimonium diximus adversus Deum quod suscitaverit Christum, quem non suscitavit, si revera mortui non resurgunt."
,"16":"Nam si mortui non resurgunt, neque Christus resurrexit;"
,"17":"quod si Christus non resurrexit, stulta est fides vestra; adhuc estis in peccatis vestris."
,"18":"Ergo et, qui dormierunt in Christo, perierunt."
,"19":"Si in hac vita tantum in Christo sperantes sumus, miserabiliores sumus omnibus hominibus."
,"20":"Nunc autem Christus resurrexit a mortuis, primitiae dormientium."
,"21":"Quoniam enim per hominem mors, et per hominem resurrectio mortuorum:"
,"22":"sicut enim in Adam omnes moriuntur, ita et in Christo omnes vivificabuntur."
,"23":"Unusquisque autem in suo ordine: primitiae Christus; deinde hi, qui sunt Christi, in adventu eius;"
,"24":"deinde finis, cum tradiderit regnum Deo et Patri, cum evacuaverit omnem principatum et omnem potestatem et virtutem."
,"25":"Oportet autem illum regnare, donec ponat omnes inimicos sub pedibus eius."
,"26":"Novissima autem inimica destruetur mors;"
,"27":"omnia enim subiecit sub pedibus eius. Cum autem dicat: 'Omnia subiecta sunt', sine dubio praeter eum, qui subiecit ei omnia."
,"28":"Cum autem subiecta fuerint illi omnia, tunc ipse Filius subiectus erit illi, qui sibi subiecit omnia, ut sit Deus omnia in omnibus."
,"29":"Alioquin quid facient, qui baptizantur pro mortuis? Si omnino mortui non resurgunt, ut quid et baptizantur pro illis?"
,"30":"Ut quid et nos periclitamur omni hora?"
,"31":"Cotidie morior, utique per vestram gloriationem, fratres, quam habeo in Christo Iesu Domino nostro!"
,"32":"Si secundum hominem ad bestias pugnavi Ephesi, quid mihi prodest? Si mortui non resurgunt, manducemus et bibamus, cras enim moriemur."
,"33":"Noli te seduci: ' Corrumpunt mores bonos colloquia mala '."
,"34":"Evigilate iuste et nolite peccare! Ignorantiam enim Dei quidam ha bent; ad reverentiam vobis loquor."
,"35":"Sed dicet aliquis: ' Quomodo resurgunt mortui? Quali autem corpore veniunt? '."
,"36":"Insipiens! Tu, quod seminas, non vivificatur, nisi prius moriatur;"
,"37":"et, quod seminas, non corpus, quod futurum est, seminas sed nudum granum, ut puta tritici aut alicuius ceterorum."
,"38":"Deus autem dat illi corpus sicut voluit, et unicuique seminum proprium corpus."
,"39":"Non omnis caro eadem caro, sed alia hominum, alia caro pecorum, alia caro volucrum, alia autem piscium."
,"40":"Et corpora caelestia et corpora terrestria, sed alia quidem caelestium gloria, alia autem terrestrium."
,"41":"Alia claritas solis, alia claritas lunae et alia claritas stellarum; stella enim a stella differt in claritate."
,"42":"Sic et resurrectio mortuorum: seminatur in corruptione, resurgit in incorruptione;"
,"43":"seminatur in ignobilitate, resurgit in gloria; seminatur in infirmitate, resurgit in virtute;"
,"44":"seminatur corpus animale, resurgit corpus spiritale. Si est corpus animale, est et spiritale. "
,"45":"Sic et scriptum est: ' Factus est primus homo Adam in animam viventem '; novissimus Adam in Spiritum vivificantem."
,"46":"Sed non prius, quod spiritale est, sed quod animale est; deinde quod spiritale."
,"47":"Primus homo de terra terrenus, secundus homo de caelo."
,"48":"Qualis terrenus, tales et terreni, et qualis caelestis, tales et caelestes;"
,"49":"et sicut portavimus imaginem terreni, portabimus et imaginem caelestis."
,"50":"Hoc autem dico, fratres, quoniam caro et sanguis regnum Dei possidere non possunt, neque corruptio incorruptelam possidebit."
,"51":"Ecce mysterium vobis dico: Non omnes quidem dormiemus, sed omnes immutabimur,"
,"52":"in momento, in ictu oculi, in novissima tuba; canet enim, et mortui suscitabuntur incorrupti, et nos immutabimur."
,"53":"Oportet enim corruptibile hoc induere incorruptelam, et mortale induere immortalitatem."
,"54":"Cum autem corruptibile hoc induerit incorruptelam, et mortale hoc induerit immortalitatem, tunc fiet sermo, qui scriptus est: ' Absorpta est mors in victoria."
,"55":"Ubi est, mors, victoria tua?,Ubi est, mors, stimulus tuus? '."
,"56":"Stimulus autem mortis peccatum est, virtus vero peccati lex."
,"57":"Deo autem gratias, qui dedit nobis victoriam per Dominum nostrum Iesum Christum."
,"58":"Itaque, fratres mei dilecti, stabiles estote, immobiles, abundantes in opere Domini semper, scientes quod labor vester non est inanis in Domino."
}`)
	CurrentBook.AddChapter(16, `{
"1":"De collectis autem, quae fiunt in sanctos, sicut ordina vi ecclesiis Galatiae, ita et vos facite."
,"2":"Per primam sabbati unusquisque vestrum apud se ponat recondens, quod ei beneplacuerit, ut non, cum venero, tunc collectae fiant."
,"3":"Cum autem praesens fuero, quos probaveritis, per epistulas hos mittam perferre gratiam vestram in Ierusalem;"
,"4":"quod si dignum fuerit, ut et ego eam, mecum ibunt."
,"5":"Veniam autem ad vos, cum Macedoniam pertransiero, nam Macedoniam pertransibo;"
,"6":"apud vos autem forsitan manebo vel etiam hiemabo, ut vos me deducatis, quocumque iero."
,"7":"Nolo enim vos modo in transitu videre; spero enim me aliquantum temporis manere apud vos, si Dominus permiserit."
,"8":"Permanebo autem Ephesi usque ad Pentecosten;"
,"9":"ostium enim mihi apertum est magnum et efficax, et adversarii multi."
,"10":"Si autem venerit Timotheus, videte, ut sine timore sit apud vos, opus enim Domini operatur, sicut et ego;"
,"11":"ne quis ergo illum spernat. Deducite autem illum in pace, ut veniat ad me; exspecto enim illum cum fratribus."
,"12":"De Apollo autem fratre, multum rogavi eum, ut veniret ad vos cum fratribus, et utique non fuit voluntas, ut nunc veniret; veniet autem, cum ei opportunum fuerit."
,"13":"Vigilate, state in fide, viriliter agite, confortamini;"
,"14":"omnia vestra in caritate fiant."
,"15":"Obsecro autem vos, fratres: nostis domum Stephanae, quoniam sunt primitiae Achaiae et in ministerium sanctorum ordinaverunt seipsos;"
,"16":"ut et vos subditi sitis eiusmodi et omni cooperanti et laboranti."
,"17":"Gaudeo autem in praesentia Stephanae et Fortunati et Achaici, quoniam id quod vobis deerat, ipsi suppleverunt;"
,"18":"refecerunt enim et meum spiritum et vestrum. Cognoscite ergo, qui eiusmodi sunt."
,"19":"Salutant vos ecclesiae Asiae. Salutant vos in Domino multum Aquila et Prisca cum domestica sua ecclesia."
,"20":"Salutant vos fratres omnes. Salutate invicem in osculo sancto."
,"21":"Salutatio mea manu Pauli."
,"22":"Si quis non amat Dominum, sit anathema. Marana tha!"
,"23":"Gratia Domini Iesu vobiscum."
,"24":"Caritas mea cum omnibus vobis in Christo Iesu."
}`)

}
func LA_NVBSE_LoadNP1EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus et Silvanus et Timo theus ecclesiae Thessalonicen sium in Deo Patre et Domino Iesu Christo: gratia vobis et pax."
,"2":"Gratias agimus Deo semper pro omnibus vobis, memoriam facientes in orationibus nostris, sine intermissione;"
,"3":"memores operis fidei vestrae et laboris caritatis et sustinentiae spei Domini nostri Iesu Christi ante Deum et Patrem nostrum;"
,"4":"scientes, fratres, dilecti a Deo, electionem vestram,"
,"5":"quia evangelium nostrum non fuit ad vos in sermone tantum sed et in virtute et in Spiritu Sancto et in plenitudine multa, sicut scitis quales fuerimus vobis propter vos."
,"6":"Et vos imitatores nostri facti estis et Domini, excipientes verbum in tribulatione multa cum gaudio Spiritus Sancti,"
,"7":"ita ut facti sitis forma omnibus credentibus in Macedonia et in Achaia."
,"8":"A vobis enim diffamatus est sermo Domini non solum in Macedonia et in Achaia, sed in omni loco fides vestra, quae est ad Deum, profecta est, ita ut non sit nobis necesse quidquam loqui;"
,"9":"ipsi enim de nobis annuntiant qualem introitum habuerimus ad vos, et quomodo conversi estis ad Deum a simulacris, servire Deo vivo et vero"
,"10":"et exspectare Filium eius de caelis, quem suscitavit ex mortuis, Iesum, qui eripit nos ab ira ventura."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Nam ipsi scitis, fratres, introi tum nostrum ad vos, quia non inanis fuit;"
,"2":"sed ante passi et contumeliis affecti, sicut scitis, in Philippis, fiduciam habuimus in Deo nostro loqui ad vos evangelium Dei in multa sollicitudine."
,"3":"Exhortatio enim nostra non ex errore neque ex immunditia neque in dolo,"
,"4":"sed sicut probati sumus a Deo, ut crederetur nobis evangelium, ita loquimur non quasi hominibus placentes, sed Deo, qui probat corda nostra."
,"5":"Neque enim aliquando fuimus in sermone adulationis, sicut scitis, neque sub praetextu avaritiae, Deus testis,"
,"6":"nec quaerentes ab hominibus gloriam, neque a vobis neque ab aliis;"
,"7":"cum possemus oneri esse ut Christi apostoli, sed facti sumus parvuli in medio vestrum, tamquam si nutrix foveat filios suos;"
,"8":"ita desiderantes vos, cupide volebamus tradere vobis non solum evangelium Dei sed etiam animas nostras, quoniam carissimi nobis facti estis."
,"9":"Memores enim estis, fratres, laboris nostri et fatigationis; nocte et die operantes, ne quem vestrum gravaremus, praedicavimus in vobis evangelium Dei."
,"10":"Vos testes estis et Deus, quam sancte et iuste et sine querela vobis, qui credidistis, fuimus;"
,"11":"sicut scitis qualiter unumquemque vestrum, tamquam pater filios suos,"
,"12":"deprecantes vos et consolantes testificati sumus, ut ambularetis digne Deo, qui vocat vos in suum regnum et gloriam."
,"13":"Ideo et nos gratias agimus Deo sine intermissione, quoniam cum accepissetis a nobis verbum auditus Dei, accepistis non ut verbum hominum sed, sicut est vere, verbum Dei, quod et operatur in vobis, qui creditis."
,"14":"Vos enim imitatores facti estis, fratres, ecclesiarum Dei, quae sunt in Iudaea in Christo Iesu; quia eadem passi estis et vos a contribulibus vestris, sicut et ipsi a Iudaeis,"
,"15":"qui et Dominum occiderunt Iesum et prophetas et nos persecuti sunt et Deo non placent et omnibus hominibus adversantur,"
,"16":"prohibentes nos gentibus loqui, ut salvae fiant, ut impleant peccata sua semper. Pervenit autem ira Dei super illos usque in finem."
,"17":"Nos autem, fratres, desolati a vobis ad tempus horae, facie non corde, abundantius festinavimus faciem vestram videre cum multo desiderio."
,"18":"Propter quod voluimus venire ad vos, ego quidem Paulus et semel et iterum; et impedivit nos Satanas."
,"19":"Quae est enim nostra spes aut gaudium aut corona gloriae - nonne et vos - ante Dominum nostrum Iesum in adventu eius?"
,"20":"Vos enim estis gloria nostra et gaudium."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Propter quod non sustinentes amplius, placuit nobis, ut relin queremur Athenis soli,"
,"2":"et misimus Timotheum, fratrem nostrum et cooperatorem Dei in evangelio Christi, ad confirmandos vos et exhortandos pro fide vestra,"
,"3":"ut nemo turbetur in tribulationibus istis. Ipsi enim scitis quod in hoc positi sumus;"
,"4":"nam et cum apud vos essemus, praedicebamus vobis passuros nos tribulationes, sicut et factum est et scitis."
,"5":"Propterea et ego amplius non sustinens, misi ad cognoscendam fidem vestram, ne forte tentaverit vos is qui tentat, et inanis fiat labor noster."
,"6":"Nunc autem, veniente Timotheo ad nos a vobis et annuntiante nobis fidem et caritatem vestram, et quia memoriam nostri habetis bonam semper, desiderantes nos videre, sicut nos quoque vos;"
,"7":"ideo consolati sumus, fratres, propter vos in omni necessitate et tribulatione nostra per vestram fidem;"
,"8":"quoniam nunc vivimus, si vos statis in Domino."
,"9":"Quam enim gratiarum actionem possumus Deo retribuere pro vobis in omni gaudio, quo gaudemus propter vos ante Deum nostrum,"
,"10":"nocte et die abundantius orantes, ut videamus faciem vestram et compleamus ea, quae desunt fidei vestrae?"
,"11":"Ipse autem Deus et Pater noster et Dominus noster Iesus dirigat viam nostram ad vos;"
,"12":"vos autem Dominus abundare et superabundare faciat caritate in invicem et in omnes, quemadmodum et nos in vos;"
,"13":"ad confirmanda corda vestra sine querela in sanctitate ante Deum et Patrem nostrum, in adventu Domini nostri Iesu cum omnibus sanctis eius. Amen."
}`)
	CurrentBook.AddChapter(4, `{
"1":"De cetero ergo, fratres, rogamus vos et obsecramus in Domino Iesu, ut - quemadmodum accepistis a nobis quomodo vos oporteat ambulare et placere Deo, sicut et ambulatis - ut abundetis magis."
,"2":"Scitis enim, quae praecepta dederimus vobis per Dominum Iesum."
,"3":"Haec est enim voluntas Dei, sanctificatio vestra,"
,"4":"ut abstineatis a fornicatione; ut sciat unusquisque vestrum suum vas possidere in sanctificatione et honore,"
,"5":"non in passione desiderii, sicut et gentes, quae ignorant Deum;"
,"6":"ut ne quis supergrediatur neque circumveniat in negotio fratrem suum, quoniam vindex est Dominus de his omnibus, sicut et praediximus vobis et testificati sumus."
,"7":"Non enim vocavit nos Deus in immunditiam sed in sanctificationem."
,"8":"Itaque, qui spernit, non hominem spernit sed Deum, qui etiam dat Spiritum suum Sanctum in vos."
,"9":"De caritate autem fraternitatis non necesse habetis, ut vobis scribam; ipsi enim vos a Deo edocti estis, ut diligatis invicem;"
,"10":"etenim facitis illud in omnes fratres in universa Macedonia. Rogamus autem vos, fratres, ut abundetis magis;"
,"11":"et operam detis, ut quieti sitis et ut vestrum negotium agatis et operemini manibus vestris, sicut praecipimus vobis;"
,"12":"ut honeste ambuletis ad eos, qui foris sunt, et nullius aliquid desideretis."
,"13":"Nolumus autem vos ignorare, fratres, de dormientibus, ut non contristemini sicut et ceteri, qui spem non habent."
,"14":"Si enim credimus quod Iesus mortuus est et resurrexit, ita et Deus eos, qui dormierunt, per Iesum adducet cum eo."
,"15":"Hoc enim vobis dicimus in verbo Domini, quia nos, qui vivimus, qui relinquimur in adventum Domini, non praeveniemus eos, qui dormierunt;"
,"16":"quoniam ipse Dominus in iussu, in voce archangeli et in tuba Dei descendet de caelo, et mortui, qui in Christo sunt, resurgent primi;"
,"17":"deinde nos, qui vivimus, qui relinquimur, simul rapiemur cum illis in nubibus obviam Domino in aera, et sic semper cum Domino erimus."
,"18":"Itaque consolamini invicem in verbis istis."
}`)
	CurrentBook.AddChapter(5, `{
"1":"De temporibus autem et mo mentis, fratres, non indigetis, ut scribatur vobis;"
,"2":"ipsi enim diligenter scitis quia dies Domini, sicut fur in nocte, ita veniet."
,"3":"Cum enim dixerint: ' Pax et securitas ', tunc repentinus eis superveniet interitus, sicut dolor in utero habenti, et non effugient."
,"4":"Vos autem, fratres, non estis in tenebris, ut vos dies ille tamquam fur comprehendat;"
,"5":"omnes enim vos filii lucis estis et filii diei. Non sumus noctis neque tenebrarum;"
,"6":"igitur non dormiamus sicut ceteri, sed vigilemus et sobrii simus."
,"7":"Qui enim dormiunt, nocte dormiunt; et, qui ebrii sunt, nocte inebriantur."
,"8":"Nos autem, qui diei sumus, sobrii simus, induti loricam fidei et caritatis et galeam spem salutis;"
,"9":"quoniam non posuit nos Deus in iram sed in acquisitionem salutis per Dominum nostrum Iesum Christum,"
,"10":"qui mortuus est pro nobis, ut sive vigilemus sive dormiamus, simul cum illo vivamus."
,"11":"Propter quod consolamini invicem et aedificate alterutrum, sicut et facitis."
,"12":"Rogamus autem vos, fratres, ut noveritis eos, qui laborant inter vos et praesunt vobis in Domino et monent vos,"
,"13":"ut habeatis illos superabundanter in caritate propter opus illorum. Pacem habete inter vos."
,"14":"Hortamur autem vos, fratres: corripite inquietos, consolamini pusillanimes, suscipite infirmos, longanimes estote ad omnes."
,"15":"Videte, ne quis malum pro malo alicui reddat, sed semper, quod bonum est, sectamini et in invicem et in omnes."
,"16":"Semper gaudete,"
,"17":"sine intermissione orate,"
,"18":"in omnibus gratias agite; haec enim voluntas Dei est in Christo Iesu erga vos."
,"19":"Spiritum nolite exstinguere,"
,"20":"prophetias nolite spernere;"
,"21":"omnia autem probate, quod bonum est tenete,"
,"22":"ab omni specie mala abstinete vos."
,"23":"Ipse autem Deus pacis sanctificet vos per omnia, et integer spiritus vester et anima et corpus sine querela in adventu Domini nostri Iesu Christi servetur."
,"24":"Fidelis est, qui vocat vos, qui etiam faciet."
,"25":"Fratres, orate etiam pro nobis."
,"26":"Salutate fratres omnes in osculo sancto."
,"27":"Adiuro vos per Dominum, ut legatur epistula omnibus fratribus."
,"28":"Gratia Domini nostri Iesu Christi vobiscum."
}`)

}
func LA_NVBSE_LoadNP1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus, apostolus Christi Iesu secundum praeceptum Dei sal vatoris nostri et Christi Iesu spei nostrae,"
,"2":"Timotheo germano filio in fide: gratia, misericordia, pax a Deo Patre et Christo Iesu Domino nostro."
,"3":"Sicut rogavi te, ut remaneres Ephesi, cum irem in Macedoniam, ut praeciperes quibusdam, ne aliter docerent"
,"4":"neque intenderent fabulis et genealogiis interminatis, quae quaestiones praestant magis quam dispensationem Dei, quae est in fide;"
,"5":"finis autem praecepti est caritas de corde puro et conscientia bona et fide non ficta,"
,"6":"a quibus quidam aberrantes conversi sunt in vaniloquium,"
,"7":"volentes esse legis doctores, non intellegentes neque quae loquuntur neque de quibus affirmant."
,"8":"Scimus autem quia bona est lex, si quis ea legitime utatur,"
,"9":"sciens hoc quia iusto lex non est posita sed iniustis et non subiectis, impiis et peccatoribus, sceleratis et contaminatis, patricidis et matricidis, homicidis,"
,"10":"fornicariis, masculorum concubitoribus, plagiariis, mendacibus, periuris et si quid aliud sanae doctrinae adversatur,"
,"11":"secundum evangelium gloriae beati Dei, quod creditum est mihi."
,"12":"Gratiam habeo ei, qui me confortavit, Christo Iesu Domino nostro, quia fidelem me existimavit ponens in ministerio,"
,"13":"qui prius fui blasphemus et persecutor et contumeliosus; sed misericordiam consecutus sum, quia ignorans feci in incredulitate;"
,"14":"superabundavit autem gratia Domini nostri cum fide et dilectione, quae sunt in Christo Iesu."
,"15":"Fidelis sermo et omni acceptione dignus: Christus Iesus venit in mundum peccatores salvos facere; quorum primus ego sum,"
,"16":"sed ideo misericordiam consecutus sum, ut in me primo ostenderet Christus Iesus omnem longanimitatem, ad informationem eorum, qui credituri sunt illi in vitam aeternam."
,"17":"Regi autem saeculorum, incorruptibili, invisibili, soli Deo honor et gloria in saecula saeculorum. Amen."
,"18":"Hoc praeceptum commendo tibi, fili Timothee, secundum praecedentes super te prophetias, ut milites in illis bonam militiam"
,"19":"habens fidem et bonam conscientiam, quam quidam repellentes circa fidem naufragaverunt;"
,"20":"ex quibus est Hymenaeus et Alexander, quos tradidi Satanae, ut discant non blasphemare."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Obsecro igitur primo omnium fieri obsecrationes, orationes, postulationes, gratiarum actiones pro omnibus hominibus,"
,"2":"pro regibus et omnibus, qui in sublimitate sunt, ut quietam et tranquillam vitam agamus in omni pietate et castitate."
,"3":"Hoc bonum est et acceptum coram salvatore nostro Deo,"
,"4":"qui omnes homines vult salvos fieri et ad agnitionem veritatis venire."
,"5":"Unus enim Deus, unus et mediator Dei et hominum, homo Christus Iesus,"
,"6":"qui dedit redemptionem semetipsum pro omnibus, testimonium temporibus suis;"
,"7":"in quod positus sum ego praedicator et apostolus - veritatem dico, non mentior - doctor gentium in fide et veritate."
,"8":"Volo ergo viros orare in omni loco levantes puras manus sine ira et disceptatione;"
,"9":"similiter et mulieres in habitu ornato cum verecundia et sobrietate ornantes se, non in tortis crinibus et auro aut margaritis vel veste pretiosa,"
,"10":"sed, quod decet mulieres, profitentes pietatem per opera bona."
,"11":"Mulier in tranquillitate discat cum omni subiectione;"
,"12":"docere autem mulieri non permitto neque dominari in virum, sed esse in tranquillitate."
,"13":"Adam enim primus formatus est, deinde Eva;"
,"14":"et Adam non est seductus, mulier autem seducta in praevaricatione fuit."
,"15":"Salvabitur autem per filiorum generationem, si permanserint in fide et dilectione et sanctificatione cum sobrietate."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Fidelis sermo: si quis episco patum appetit, bonum opus de siderat."
,"2":"Oportet ergo episcopum irreprehensibilem esse, unius uxoris virum, sobrium, prudentem, ornatum, hospitalem, doctorem,"
,"3":"non vinolentum, non percussorem sed modestum, non litigiosum, non cupidum,"
,"4":"suae domui bene praepositum, filios habentem in subiectione cum omni castitate"
,"5":"- si quis autem domui suae praeesse nescit, quomodo ecclesiae Dei curam habebit? C,"
,"6":"non neophytum, ne in superbia elatus in iudicium incidat Diaboli."
,"7":"Oportet autem illum et testimonium habere bonum ab his, qui foris sunt, ut non in opprobrium incidat et laqueum Diaboli."
,"8":"Diaconos similiter pudicos, non bilingues, non multo vino deditos, non turpe lucrum sectantes,"
,"9":"habentes mysterium fidei in conscientia pura."
,"10":"Et hi autem probentur primum, deinde ministrent nullum crimen habentes."
,"11":"Mulieres similiter pudicas, non detrahentes, sobrias, fideles in omnibus."
,"12":"Diaconi sint unius uxoris viri, qui filiis suis bene praesint et suis domibus;"
,"13":"qui enim bene ministraverint, gradum sibi bonum acquirent et multam fiduciam in fide, quae est in Christo Iesu."
,"14":"Haec tibi scribo sperans venire ad te cito;"
,"15":"si autem tardavero, ut scias quomodo oporteat in domo Dei conversari, quae est ecclesia Dei vivi, columna et firmamentum veritatis."
,"16":"Et omnium confessione magnum est pietatis mysterium: Qui manifestatus est in carne, iustificatus est in Spiritu, apparuit angelis, praedicatus est in gentibus, creditus est in mumdo, assumptus est in gloria."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Spiritus autem manifeste dicit, quia in novissimis temporibus discedent quidam a fide, attendentes spiritibus seductoribus et doctrinis daemoniorum,"
,"2":"in hypocrisi loquentium mendacium et cauteriatam habentium suam conscientiam,"
,"3":"prohibentium nubere, abstinere a cibis, quos Deus creavit ad percipiendum cum gratiarum actione fidelibus et his, qui cognoverunt veritatem."
,"4":"Quia omnis creatura Dei bona, et nihil reiciendum, quod cum gratiarum actione percipitur;"
,"5":"sanctificatur enim per verbum Dei et orationem."
,"6":"Haec proponens fratribus bonus eris minister Christi Iesu, enutritus verbis fidei et bonae doctrinae, quam assecutus es;"
,"7":"profanas autem et aniles fabulas devita. Exerce teipsum ad pietatem; "
,"8":"nam corporalis exercitatio ad modicum utilis est, pietas autem ad omnia utilis est promissionem habens vitae, quae nunc est, et futurae."
,"9":"Fidelis sermo et omni acceptione dignus:"
,"10":"in hoc enim laboramus et certamus, quia sperantes sumus in Deum vivum, qui est salvator omnium hominum, maxime fidelium."
,"11":"Praecipe haec et doce."
,"12":"Nemo adulescentiam tuam contemnat; sed exemplum esto fidelium in verbo, in conversatione, in caritate, in fide, in castitate."
,"13":"Dum venio, attende lectioni, exhortationi, doctrinae."
,"14":"Noli neglegere donationem, quae in te est, quae data est tibi per prophetiam cum impositione manuum presbyterii."
,"15":"Haec meditare, in his esto, ut profectus tuus manifestus sit omnibus."
,"16":"Attende tibi et doctrinae; insta in illis; hoc enim faciens et teipsum salvum facies et eos, qui te audiunt."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Seniorem ne increpaveris, sed obsecra ut patrem, iuvenes ut fratres,"
,"2":"anus ut matres, iuvenculas ut sorores in omni castitate."
,"3":"Viduas honora, quae vere viduae sunt."
,"4":"Si qua autem vidua filios aut nepotes habet, discant primum domum suam pie regere et mutuam vicem reddere parentibus; hoc enim acceptum est coram Deo."
,"5":"Quae autem vere vidua est et desolata, sperat in Deum et instat obsecrationibus et orationibus nocte ac die;"
,"6":"nam quae in deliciis est vivens, mortua est."
,"7":"Et haec praecipe, ut irreprehensibiles sint."
,"8":"Si quis autem suorum et maxime domesticorum curam non habet, fidem negavit et est infideli deterior."
,"9":"Vidua adscribatur non minus sexaginta annorum, quae fuerit unius viri uxor,"
,"10":"in operibus bonis testimonium habens: si filios educavit, si hospitio recepit, si sanctorum pedes lavit, si tribulationem patientibus subministravit, si omne opus bonum subsecuta est."
,"11":"Adulescentiores autem viduas devita; cum enim luxuriatae fuerint adversus Christum, nubere volunt,"
,"12":"habentes damnationem, quia primam fidem irritam fecerunt;"
,"13":"simul autem et otiosae discunt circumire domos, non solum otiosae sed et verbosae et curiosae, loquentes quae non oportet."
,"14":"Volo ergo iuniores nubere, filios procreare, dominas domus esse, nullam occasionem dare adversario maledicti gratia;"
,"15":"iam enim quaedam conversae sunt retro Satanam."
,"16":"Si qua fidelis habet viduas, subministret illis, et non gravetur ecclesia, ut his, quae vere viduae sunt, sufficiat."
,"17":"Qui bene praesunt presbyteri, duplici honore digni habeantur, maxime qui laborant in verbo et doctrina;"
,"18":"dicit enim Scriptura: ' Non infrenabis os bovi trituranti ' et: ' Dignus operarius mercede sua '."
,"19":"Adversus presbyterum accusationem noli recipere, nisi sub duobus vel tribus testibus."
,"20":"Peccantes coram omnibus argue, ut et ceteri timorem habeant."
,"21":"Testificor coram Deo et Christo Iesu et electis angelis, ut haec custodias sine praeiudicio nihil faciens in aliquam partem declinando."
,"22":"Manus cito nemini imposueris neque communicaveris peccatis alienis; teipsum castum custodi."
,"23":"Noli adhuc aquam bibere, sed vino modico utere propter stomachum et frequentes tuas infirmitates."
,"24":"Quorundam hominum peccata manifesta sunt praecedentia ad iudicium, quosdam autem et subsequuntur;"
,"25":"similiter et facta bona manifesta sunt, et, quae aliter se habent, abscondi non possunt."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Quicumque sunt sub iugo, servi dominos suos omni honore di gnos arbitrentur, ne nomen Dei et doctrina blasphemetur."
,"2":"Qui autem fideles habent dominos, non contemnant, quia fratres sunt, sed magis serviant, quia fideles sunt et dilecti, qui beneficii participes sunt. Haec doce et exhortare."
,"3":"Si quis aliter docet et non accedit sanis sermonibus Domini nostri Iesu Christi et ei, quae secundum pietatem est, doctrinae,"
,"4":"superbus est, nihil sciens, sed languens circa quaestiones et pugnas verborum, ex quibus oriuntur invidiae, contentiones, blasphemiae, suspiciones malae,"
,"5":"conflictationes hominum mente corruptorum et qui veritate privati sunt, existimantium quaestum esse pietatem."
,"6":"Est autem quaestus magnus pietas cum sufficientia."
,"7":"Nihil enim intulimus in mundum, quia nec auferre quid possumus;"
,"8":"habentes autem alimenta et quibus tegamur, his contenti erimus."
,"9":"Nam qui volunt divites fieri, incidunt in tentationem et laqueum et desideria multa stulta et nociva, quae mergunt homines in interitum et perditionem;"
,"10":"radix enim omnium malorum est cupiditas, quam quidam appetentes erraverunt a fide et inseruerunt se doloribus multis."
,"11":"Tu autem, o homo Dei, haec fuge; sectare vero iustitiam, pietatem, fidem, caritatem, patientiam, mansuetudinem."
,"12":"Certa bonum certamen fidei, apprehende vitam aeternam, ad quam vocatus es, et confessus es bonam confessionem coram multis testibus."
,"13":"Praecipio tibi coram Deo, qui vivificat omnia, et Christo Iesu, qui testimonium reddidit sub Pontio Pilato bonam confessionem,"
,"14":"ut serves mandatum sine macula irreprehensibile usque in adventum Domini nostri Iesu Christi,"
,"15":"quem suis temporibus ostendet beatus et solus potens, Rex regnantium et Dominus dominantium,"
,"16":"qui solus habet immortalitatem, lucem habitans inaccessibilem, quem vidit nullus hominum nec videre potest; cui honor et imperium sempiternum. Amen."
,"17":"Divitibus huius saeculi praecipe non superbe sapere neque sperare in incerto divitiarum sed in Deo, qui praestat nobis omnia abunde ad fruendum,"
,"18":"bene agere, divites fieri in operibus bonis, facile tribuere, communicare,"
,"19":"thesaurizare sibi fundamentum bonum in futurum, ut apprehendant veram vitam."
,"20":"O Timothee, depositum custodi, devitans profanas vocum novitates et oppositiones falsi nominis scientiae,"
,"21":"quam quidam profitentes circa fidem aberraverunt. Gratia vobiscum."
}`)

}
func LA_NVBSE_LoadNP2CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus, apostolus Christi Iesu per voluntatem Dei, et Timo theus frater ecclesiae Dei, quae est Corinthi, cum sanctis omnibus, qui sunt in universa Achaia:"
,"2":"gratia vobis et pax a Deo Patre nostro et Domino Iesu Christo."
,"3":"Benedictus Deus et Pater Domini nostri Iesu Christi, Pater misericordiarum et Deus totius consolationis,"
,"4":"qui consolatur nos in omni tribulatione nostra, ut possimus et ipsi consolari eos, qui in omni pressura sunt, per exhortationem, qua exhortamur et ipsi a Deo;"
,"5":"quoniam, sicut abundant passiones Christi in nobis, ita per Christum abundat et consolatio nostra."
,"6":"Sive autem tribulamur, pro vestra exhortatione et salute; sive exhortamur, pro vestra exhortatione, quae operatur in tolerantia earundem passionum, quas et nos patimur."
,"7":"Et spes nostra firma pro vobis, scientes quoniam, sicut socii passionum estis, sic eritis et consolationis."
,"8":"Non enim volumus ignorare vos, fratres, de tribulatione nostra, quae facta est in Asia, quoniam supra modum gravati sumus supra virtutem, ita ut taederet nos etiam vivere;"
,"9":"sed ipsi in nobis ipsis responsum mortis habuimus, ut non simus fidentes in nobis sed in Deo, qui suscitat mortuos:"
,"10":"qui de tanta morte eripuit nos et eruet, in quem speramus, et adhuc eripiet;"
,"11":"adiuvantibus et vobis in oratione pro nobis, ut propter eam, quae ex multis personis in nos est, donationem, per multos gratiae agantur pro nobis."
,"12":"Nam gloria nostra haec est, testimonium conscientiae nostrae, quod in simplicitate et sinceritate Dei et non in sapientia carnali, sed in gratia Dei conversati sumus in mundo, abundantius autem ad vos."
,"13":"Non enim alia scribimus vobis quam quae legitis aut etiam cognoscitis; spero autem quod usque in finem cognoscetis,"
,"14":"sicut et cognovistis nos ex parte, quia gloria vestra sumus, sicut et vos nostra in die Domini nostri Iesu."
,"15":"Et hac confidentia volui prius venire ad vos, ut secundam gratiam haberetis,"
,"16":"et per vos transire in Macedoniam et iterum a Macedonia venire ad vos et a vobis deduci in Iudaeam."
,"17":"Cum hoc ergo voluissem, numquid levitate usus sum? Aut, quae cogito, secundum carnem cogito, ut sit apud me ' Est, est ' et ' Non, non '?"
,"18":"Fidelis autem Deus, quia sermo noster, qui fit apud vos, non est ' Est ' et ' Non '!"
,"19":"Dei enim Filius Iesus Christus, qui in vobis per nos praedicatus est, per me et Silvanum et Timotheum, non fuit ' Est ' et ' Non ', sed ' Est ' in illo fuit."
,"20":"Quotquot enim promissiones Dei sunt, in illo ' Est '; ideo et per ipsum ' Amen ' Deo ad gloriam per nos."
,"21":"Qui autem confirmat nos vobiscum in Christum et qui unxit nos, Deus,"
,"22":"et qui signavit nos et dedit arrabonem Spiritus in cordibus nostris."
,"23":"Ego autem testem Deum invoco in animam meam, quod parcens vobis non veni ultra Corinthum."
,"24":"Non quia dominamur fidei vestrae, sed adiutores sumus gaudii vestri, nam fide stetistis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Statui autem hoc ipse apud me, ne iterum in tristitia venirem ad vos;"
,"2":"si enim ego contristo vos, et quis est qui me laetificet, nisi qui contristatur ex me?"
,"3":"Et hoc ipsum scripsi, ut non, cum venero, tristitiam habeam de quibus oportebat me gaudere, confidens in omnibus vobis, quia meum gaudium omnium vestrum est."
,"4":"Nam ex multa tribulatione et angustia cordis scripsi vobis per multas lacrimas, non ut contristemini, sed ut sciatis quam carita tem habeo abundantius in vos."
,"5":"Si quis autem contristavit, non me contristavit, sed ex parte, ut non onerem, omnes vos."
,"6":"Sufficit illi, qui eiusmodi est, obiurgatio haec, quae fit a pluribus,"
,"7":"ita ut e contra magis donetis et consolemini, ne forte abundantiore tristitia absorbeatur, qui eiusmodi est."
,"8":"Propter quod obsecro vos, ut confirmetis in illum caritatem;"
,"9":"ideo enim et scripsi, ut cognoscam probationem vestram, an in omnibus oboedientes sitis."
,"10":"Cui autem aliquid donatis, et ego; nam et ego, quod donavi, si quid donavi, propter vos in persona Christi,"
,"11":"ut non circumveniamur a Satana; non enim ignoramus cogitationes eius."
,"12":"Cum venissem autem Troadem ob evangelium Christi, et ostium mihi apertum esset in Domino,"
,"13":"non habui requiem spiritui meo, eo quod non invenerim Titum fratrem meum, sed valefaciens eis profectus sum in Macedoniam."
,"14":"Deo autem gratias, qui semper triumphat nos in Christo et odorem notitiae suae manifestat per nos in omni loco."
,"15":"Quia Christi bonus odor sumus Deo in his, qui salvi fiunt, et in his, qui pereunt:"
,"16":"aliis quidem odor ex morte in mortem, aliis autem odor ex vita in vitam. Et ad haec quis idoneus?"
,"17":"Non enim sumus sicut plurimi adulterantes verbum Dei, sed sicut ex sinceritate, sed sicut ex Deo coram Deo in Christo loquimur."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Incipimus iterum nosmetipsos commendare? Aut numquid egemus, sicut quidam, commendaticiis epistulis ad vos aut ex vobis?"
,"2":"Epistula nostra vos estis, scripta in cordibus nostris, quae scitur et legitur ab omnibus hominibus;"
,"3":"manifestati quoniam epistula estis Christi ministrata a nobis, scripta non atramento sed Spiritu Dei vivi, non in tabulis lapideis sed in tabulis cordis carnalibus."
,"4":"Fiduciam autem talem habemus per Christum ad Deum."
,"5":"Non quod sufficientes simus cogitare aliquid a nobis quasi ex nobis, sed sufficientia nostra ex Deo est,"
,"6":"qui et idoneos nos fecit ministros Novi Testamenti, non litterae sed Spiritus: littera enim occidit, Spiritus autem vivificat."
,"7":"Quod si ministratio mortis, litteris deformata in lapidibus, fuit in gloria, ita ut non possent intendere filii Israel in faciem Moysis propter gloriam vultus eius, quae evacuatur,"
,"8":"quomodo non magis ministratio Spiritus erit in gloria?"
,"9":"Nam si ministerium damnationis gloria est, multo magis abundat ministerium iustitiae in gloria."
,"10":"Nam nec glorificatum est, quod claruit in hac parte, propter excellentem gloriam;"
,"11":"si enim, quod evacuatur, per gloriam est, multo magis, quod manet, in gloria est."
,"12":"Habentes igitur talem spem multa fiducia utimur,"
,"13":"et non sicut Moyses: ponebat velamen super faciem suam, ut non intenderent filii Israel in finem illius quod evacuatur."
,"14":"Sed obtusi sunt sensus eorum. Usque in hodiernum enim diem idipsum velamen in lectione Veteris Testamenti manet non revelatum, quoniam in Christo evacuatur;"
,"15":"sed usque in hodiernum diem, cum legitur Moyses, velamen est positum super cor eorum."
,"16":"Quando autem conversus fuerit ad Dominum, aufertur velamen."
,"17":"Dominus autem Spiritus est; ubi autem Spiritus Domini, ibi libertas."
,"18":"Nos vero omnes revelata facie gloriam Domini speculantes, in eandem imaginem transformamur a claritate in clarita tem tamquam a Domini Spiritu."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ideo habentes hanc ministra tionem, iuxta quod misericor diam consecuti sumus, non deficimus,"
,"2":"sed abdicavimus occulta dedecoris non ambulantes in astutia neque adulterantes verbum Dei, sed in manifestatione veritatis commendantes nosmetipsos ad omnem conscientiam hominum coram Deo."
,"3":"Quod si etiam velatum est evangelium nostrum, in his, qui pereunt, est velatum;"
,"4":"in quibus deus huius saeculi excaecavit mentes infidelium, ut non fulgeat illuminatio evangelii gloriae Christi, qui est imago Dei."
,"5":"Non enim nosmetipsos praedicamus sed Iesum Christum Dominum; nos autem servos vestros per Iesum."
,"6":"Quoniam Deus, qui dixit: ' De tenebris lux splendescat ', ipse illuxit in cordibus nostris ad illuminationem scientiae claritatis Dei in facie Iesu Christi."
,"7":"Habemus autem thesaurum istum in vasis fictilibus, ut sublimitas sit virtutis Dei et non ex nobis."
,"8":"In omnibus tribulationem patimur, sed non angustiamur; aporiamur, sed non destituimur;"
,"9":"persecutionem patimur, sed non derelinquimur; deicimur, sed non perimus;"
,"10":"semper mortificationem Iesu in corpore circumferentes, ut et vita Iesu in corpore nostro manifestetur."
,"11":"Semper enim nos, qui vivimus, in mortem tradimur propter Iesum, ut et vita Iesu manifestetur in carne nostra mortali."
,"12":"Ergo mors in nobis operatur, vita autem in vobis."
,"13":"Habentes autem eundem spiritum fidei, sicut scriptum est: ' Credidi, propter quod locutus sum ', et nos credimus, propter quod et loquimur,"
,"14":"scientes quoniam, qui suscitavit Dominum Iesum, et nos cum Iesu suscitabit et constituet vobiscum."
,"15":"Omnia enim propter vos, ut gratia abundans per multos gratiarum actionem abundare faciat in gloriam Dei."
,"16":"Propter quod non deficimus, sed licet is, qui foris est, noster homo corrumpitur, tamen is, qui intus est, noster renovatur de die in diem."
,"17":"Id enim, quod in praesenti est, leve tribulationis nostrae supra modum in sublimitatem aeternum gloriae pondus operatur nobis,"
,"18":"non contemplantibus nobis, quae videntur, sed quae non videntur; quae enim videntur, temporalia sunt, quae autem non videntur, aeterna sunt."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Scimus enim quoniam, si terre stris domus nostra huius taber naculi dissolvatur, aedificationem ex Deo habemus domum non manufactam, aeternam in caelis."
,"2":"Nam et in hoc ingemiscimus, habitationem nostram, quae de caelo est, superindui cupientes,"
,"3":"si tamen et exspoliati, non nudi inveniamur."
,"4":"Nam et, qui sumus in tabernaculo, ingemiscimus gravati, eo quod nolumus exspoliari, sed supervestiri, ut absorbeatur, quod mortale est, a vita."
,"5":"Qui autem effecit nos in hoc ipsum, Deus, qui dedit nobis arrabonem Spiritus."
,"6":"Audentes igitur semper et scientes quoniam, dum praesentes sumus in corpore, peregrinamur a Domino;"
,"7":"per fidem enim ambulamus et non per speciem."
,"8":"Audemus autem et bonam voluntatem habemus magis peregrinari a corpore et praesentes esse ad Dominum."
,"9":"Et ideo contendimus sive praesentes sive absentes placere illi."
,"10":"Omnes enim nos manifestari oportet ante tribunal Christi, ut referat unusquisque pro eis, quae per corpus gessit, sive bonum sive malum."
,"11":"Scientes ergo timorem Domini hominibus suademus, Deo autem manifesti sumus; spero autem et in conscientiis vestris manifestos nos esse."
,"12":"Non iterum nos commendamus vobis, sed occasionem damus vobis gloriandi pro nobis, ut habeatis ad eos, qui in facie gloriantur et non in corde."
,"13":"Sive enim mente excedimus, Deo; sive sobrii sumus, vobis."
,"14":"Caritas enim Christi urget nos, aestimantes, hoc, quoniam, si unus pro omnibus mortuus est, ergo omnes mortui sunt;"
,"15":"et pro omnibus mortuus est, ut et, qui vivunt, iam non sibi vivant, sed ei, qui pro ipsis mortuus est et resurrexit."
,"16":"Itaque nos ex hoc neminem novimus secundum carnem; et si cognovimus secundum carnem Christum, sed nunc iam non novimus."
,"17":"Si quis ergo in Christo, nova creatura; vetera transierunt, ecce, facta sunt nova."
,"18":"Omnia autem ex Deo, qui reconciliavit nos sibi per Christum et dedit nobis ministerium reconciliationis,"
,"19":"quoniam quidem Deus erat in Christo mundum reconcilians sibi, non reputans illis delicta ipsorum; et posuit in nobis verbum reconciliationis."
,"20":"Pro Christo ergo legatione fungimur, tamquam Deo exhortante per nos. Obsecramus pro Christo, reconciliamini Deo."
,"21":"Eum, qui non noverat peccatum, pro nobis peccatum fecit, ut nos efficeremur iustitia Dei in ipso."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Adiuvantes autem et exhor tamur, ne in vacuum gratiam Dei recipiatis"
,"2":"- ait enim: ' Tempore accepto exaudivi te,et in die salutis adiuvi te '; ecce nunc tempus acceptabile, ecce nunc dies salutis - "
,"3":"nemini dantes ullam offensionem, ut non vituperetur ministerium,"
,"4":"sed in omnibus exhibentes nosmetipsos sicut Dei ministros in multa patientia, in tribulationibus, in necessitatibus, in angustiis,"
,"5":"in plagis, in carceribus, in seditionibus, in laboribus, in vigiliis, in ieiuniis,"
,"6":"in castitate, in scientia, in longanimitate, in suavitate, in Spiritu Sancto, in caritate non ficta,"
,"7":"in verbo veritatis, in virtute Dei; per arma iustitiae a dextris et sinistris,"
,"8":"per gloriam et ignobilitatem, per infamiam et bonam famam; ut seductores, et veraces;"
,"9":"sicut qui ignoti, et cogniti; quasi morientes, et ecce vivimus; ut castigati, et non mortificati;"
,"10":"quasi tristes, semper autem gaudentes; sicut egentes, multos autem locupletantes; tamquam nihil habentes, et omnia possidentes."
,"11":"Os nostrum patet ad vos, o Corinthii, cor nostrum dilatatum est."
,"12":"Non angustiamini in nobis, sed angustiamini in visceribus vestris;"
,"13":"eandem autem habentes remunerationem, tamquam filiis dico, dilatamini et vos."
,"14":"Nolite iugum ducere cum infidelibus! Quae enim participatio iustitiae cum iniquitate? Aut quae societas luci ad tenebras?"
,"15":"Quae autem conventio Christi cum Beliar, aut quae pars fideli cum infideli?"
,"16":"Qui autem consensus templo Dei cum idolis? Vos enim estis templum Dei vivi; sicut dicit Deus: ' Inhabitabo in illis et inambulabo,et ero illorum Deus, et ipsi erunt mihi populus."
,"17":"Propter quod exite de medio eorum,et separamini, dicit Dominus, et immundum ne tetigeritis; et ego recipiam vos"
,"18":"et ero vobis in Patrem, et vos eritis mihi in filios et filias, dicit Dominus omnipotens '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Has igitur habentes promissio nes, carissimi, mundemus nos ab omni inquinamento carnis et spiritus, perficientes sanctificationem in timore Dei."
,"2":"Capite nos! Neminem laesimus, neminem corrupimus, neminem circumvenimus."
,"3":"Non ad condemnationem dico; praedixi enim quod in cordibus nostris estis ad commoriendum et ad convivendum."
,"4":"Multa mihi fiducia est apud vos, multa mihi gloriatio pro vobis; repletus sum consolatione, superabundo gaudio in omni tribulatione nostra."
,"5":"Nam et cum venissemus Macedoniam, nullam requiem habuit caro nostra, sed omnem tribulationem passi: foris pugnae, intus timores."
,"6":"Sed qui consolatur humiles, consolatus est nos Deus in adventu Titi;"
,"7":"non solum autem in adventu eius sed etiam in solacio, quo consolatus est in vobis, referens nobis vestrum desiderium, vestrum fletum, vestram aemulationem pro me, ita ut magis gauderem."
,"8":"Quoniam etsi contristavi vos in epistula, non me paenitet; etsi paeniteret - video quod epistula illa, etsi ad horam, vos contristavit -"
,"9":"nunc gaudeo, non quia contristati estis, sed quia contristati estis ad paenitentiam; contristati enim estis secundum Deum, ut in nullo detrimentum patiamini ex nobis."
,"10":"Quae enim secundum Deum tristitia, paenitentiam in salutem stabilem operatur; saeculi autem tristitia mortem operatur."
,"11":"Ecce enim hoc ipsum secundum Deum contristari: quantam in vobis operatum est sollicitudinem, sed defensionem, sed indignationem, sed timorem, sed desiderium, sed aemulationem, sed vindictam! In omnibus exhibuistis vos incontaminatos esse negotio."
,"12":"Igitur etsi scripsi vobis, non propter eum, qui fecit iniuriam, nec propter eum, qui passus est, sed ad manifestandam sollicitudinem vestram, quam pro nobis habetis, ad vos coram Deo."
,"13":"Ideo consolati sumus. In consolatione autem nostra abundantius magis gavisi sumus super gaudium Titi, quia refectus est spiritus eius ab omnibus vobis; "
,"14":"et si quid apud illum de vobis gloriatus sum, non sum confusus, sed sicut omnia vobis in veritate locuti sumus, ita et gloriatio nostra, quae fuit ad Titum, veritas facta est."
,"15":"Et viscera eius abundantius in vos sunt, reminiscentis omnium vestrum oboedientiam, quomodo cum timore et tremore excepistis eum."
,"16":"Gaudeo quod in omnibus confido in vobis."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Notam autem facimus vobis, fratres, gratiam Dei, quae data est in ecclesiis Macedoniae,"
,"2":"quod in multo experimento tribulationis abundantia gaudii ipsorum et altissima paupertas eorum abundavit in divitias simplicitatis eorum;"
,"3":"quia secundum virtutem, testimonium reddo, et supra virtutem voluntarii fuerunt"
,"4":"cum multa exhortatione obsecrantes nos gratiam et communicationem ministerii, quod fit in sanctos."
,"5":"Et non sicut speravimus, sed semetipsos dederunt primum Domino, deinde nobis per voluntatem Dei,"
,"6":"ita ut rogaremus Titum, ut, quemadmodum coepit, ita et perficiat in vos etiam gratiam istam."
,"7":"Sed sicut in omnibus abundatis, fide et sermone et scientia et omni sollicitudine et caritate ex nobis in vobis, ut et in hac gratia abundetis."
,"8":"Non quasi imperans dico, sed per aliorum sollicitudinem etiam vestrae caritatis ingenitum bonum comprobans;"
,"9":"scitis enim gratiam Domini nostri Iesu Christi, quoniam propter vos egenus factus est, cum esset dives, ut illius inopia vos divites essetis."
,"10":"Et consilium in hoc do. Hoc enim vobis utile est, qui non solum facere, sed et velle coepistis ab anno priore;"
,"11":"nunc vero et facto perficite, ut, quemadmodum promptus est animus velle, ita sit et perficere ex eo, quod habetis."
,"12":"Si enim voluntas prompta est, secundum id quod habet, accepta est, non secundum quod non habet."
,"13":"Non enim, ut aliis sit remissio, vobis autem tribulatio; sed ex aequalitate"
,"14":"in praesenti tempore vestra abundantia illorum inopiam suppleat, ut et illorum abundantia vestram inopiam suppleat, ut fiat aequalitas, sicut scriptum est:"
,"15":"' Qui multum, non abundavit; et, qui modicum, non minoravit '."
,"16":"Gratias autem Deo, qui dedit eandem sollicitudinem pro vobis in corde Titi,"
,"17":"quoniam exhortationem quidem suscepit, sed, cum sollicitior esset, sua voluntate profectus est ad vos."
,"18":"Misimus etiam cum illo fratrem, cuius laus est in evangelio per omnes ecclesias"
,"19":"- non solum autem, sed et ordinatus ab ecclesiis comes noster cum hac gratia, quae ministratur a nobis ad Domini gloriam et destinatam voluntatem nostram -"
,"20":"devitantes hoc, ne quis nos vituperet in hac plenitudine, quae ministratur a nobis;"
,"21":"providemus enim bona non solum coram Domino sed etiam coram hominibus."
,"22":"Misimus autem cum illis et fratrem nostrum, quem probavimus in multis saepe sollicitum esse, nunc autem multo sollicitiorem, confidentia multa in vos."
,"23":"Sive pro Tito, est socius meus et in vos adiutor; sive fratres nostri, apostoli ecclesiarum, gloria Christi."
,"24":"Ostensionem ergo, quae est caritatis vestrae et nostrae gloriationis pro vobis, in illos ostendite in faciem ecclesiarum."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Nam de ministerio, quod fit in sanctos, superfluum est mihi scribere vobis;"
,"2":"scio enim promptum animum vestrum, pro quo de vobis glorior apud Macedonas, quoniam Achaia parata est ab anno praeterito, et vestra aemulatio provocavit plurimos."
,"3":"Misi autem fratres, ut ne, quod gloriamur de vobis, evacuetur in hac parte, ut, quemadmodum dixi, parati sitis,"
,"4":"ne, cum venerint mecum Macedones et invenerint vos imparatos, erubescamus nos, ut non dicam vos, in hac substantia."
,"5":"Necessarium ergo existimavi rogare fratres, ut praeveniant ad vos et praeparent repromissam benedictionem vestram, ut haec sit parata sic quasi benedictio, non quasi avaritia."
,"6":"Hoc autem: qui parce seminat, parce et metet; et, qui seminat in benedictionibus, in benedictionibus et metet."
,"7":"Unusquisque prout destinavit corde suo, non ex tristitia aut ex necessitate; hilarem enim datorem diligit Deus."
,"8":"Potens est autem Deus omnem gratiam abundare facere in vobis, ut, in omnibus semper omnem sufficientiam habentes, abundetis in omne opus bonum,"
,"9":"sicut scriptum est: ' Dispersit, dedit pauperibus; iustitia eius manet in aeternum '."
,"10":"Qui autem administrat semen seminanti, et panem ad manducandum praestabit et multiplicabit semen vestrum et augebit incrementa frugum iustitiae vestrae."
,"11":"In omnibus locupletati in omnem simplicitatem, quae operatur per nos gratiarum actionem Deo"
,"12":"- quoniam ministerium huius officii non solum supplet ea, quae desunt sanctis, sed etiam abundat per multas gratiarum actiones Deo -"
,"13":"per probationem ministerii huius glorificantes Deum in oboedientia confessionis vestrae in evangelium Christi et simplicitate communionis in illos et in omnes,"
,"14":"et ipsorum obsecratione pro vobis, desiderantium vos propter eminentem gratiam Dei in vobis."
,"15":"Gratias Deo super inenarrabili dono eius."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Ipse autem ego Paulus obse cro vos per mansuetudinem et modestiam Christi, qui in facie quidem humilis inter vos, absens autem confido in vobis;"
,"2":"rogo autem, ne praesens audeam per eam confidentiam, quae existimo audere in quosdam, qui arbitrantur nos tamquam secundum carnem ambulemus."
,"3":"In carne enim ambulantes, non secundum carnem militamus"
,"4":"- nam arma militiae nostrae non carnalia sed potentia Deo ad destructionem munitionum - consilia destruentes"
,"5":"et omnem altitudinem extollentem se adversus scientiam Dei, et in captivitatem redigentes omnem intellectum in obsequium Christi,"
,"6":"et in promptu habentes ulcisci omnem inoboedientiam, cum impleta fuerit vestra oboedientia."
,"7":"Quae secundum faciem sunt, videte. Si quis confidit sibi Christi se esse, hoc cogitet iterum apud se, quia sicut ipse Christi est, ita et nos."
,"8":"Nam et si amplius aliquid gloriatus fuero de potestate nostra, quam dedit Dominus in aedificationem et non in destructionem vestram, non erubescam,"
,"9":"ut non existimer tamquam terrere vos per epistulas;"
,"10":"quoniam quidem ' Epistulae - inquiunt - graves sunt et fortes, praesentia autem corporis infirma, et sermo contemptibilis '."
,"11":"Hoc cogitet, qui eiusmodi est, quia quales sumus verbo per epistulas absentes, tales et praesentes in facto."
,"12":"Non enim audemus inserere aut comparare nos quibusdam, qui seipsos commendant; sed ipsi se in semetipsis metientes et comparantes semetipsos sibi, non intellegunt."
,"13":"Nos autem non ultra mensuram gloriabimur sed secundum mensuram regulae, quam impertitus est nobis Deus, mensuram pertingendi usque ad vos."
,"14":"Non enim quasi non pertingentes ad vos superextendimus nosmetipsos, usque ad vos enim pervenimus in evangelio Christi;"
,"15":"non ultra mensuram gloriantes in alienis laboribus, spem autem habentes, crescente fide vestra, in vobis magnificari secundum regulam nostram in abundantiam,"
,"16":"ad evangelizandum in iis, quae ultra vos sunt, et non in aliena regula gloriari in his, quae praeparata sunt."
,"17":"Qui autem gloriatur, in Domino glorietur;"
,"18":"non enim qui seipsum commendat, ille probatus est, sed quem Dominus commendat."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Utinam sustineretis modi cum quid insipientiae meae; sed et supportate me!"
,"2":"Aemulor enim vos Dei aemulatione; despondi enim vos uni viro virginem castam exhibere Christo."
,"3":"Timeo autem, ne, sicut serpens Evam seduxit astutia sua, ita corrumpantur sensus vestri a simplicitate et castitate, quae est in Christum."
,"4":"Nam si is qui venit, alium Christum praedicat, quem non praedicavimus, aut alium Spiritum accipitis, quem non accepistis, aut aliud evangelium, quod non recepistis, recte pateremini."
,"5":"Existimo enim nihil me minus fecisse magnis apostolis;"
,"6":"nam etsi imperitus sermone, sed non scientia, in omni autem manifestantes in omnibus ad vos."
,"7":"Aut numquid peccatum feci meipsum humilians, ut vos exaltemini, quoniam gratis evangelium Dei evangelizavi vobis?"
,"8":"Alias ecclesias exspoliavi accipiens stipendium ad ministerium vestrum"
,"9":"et, cum essem apud vos et egerem, nulli onerosus fui; nam, quod mihi deerat, suppleverunt fratres, qui venerunt a Macedonia; et in omnibus sine onere me vobis servavi et servabo."
,"10":"Est veritas Christi in me, quoniam haec gloria non infringetur in me in regionibus Achaiae."
,"11":"Quare? Quia non diligo vos? Deus scit!"
,"12":"Quod autem facio et faciam, ut amputem occasionem eorum, qui volunt occasionem, ut in quo gloriantur, inveniantur sicut et nos."
,"13":"Nam eiusmodi pseudoapostoli, operarii subdoli, transfigurantes se in apostolos Christi."
,"14":"Et non mirum, ipse enim Satanas transfigurat se in angelum lucis;"
,"15":"non est ergo magnum, si et ministri eius transfigurentur velut ministri iustitiae, quorum finis erit secundum opera ipsorum."
,"16":"Iterum dico, ne quis me putet insipientem esse; alioquin velut insipientem accipite me, ut et ego modicum quid glorier."
,"17":"Quod loquor, non loquor secundum Dominum, sed quasi in insipientia, in hac substantia gloriationis."
,"18":"Quoniam multi gloriantur secundum carnem, et ego gloriabor."
,"19":"Libenter enim suffertis insipientes, cum sitis ipsi sapientes;"
,"20":"sustinetis enim, si quis vos in servitutem redigit, si quis devorat, si quis accipit, si quis extollitur, si quis in faciem vos caedit."
,"21":"Secundum ignobilitatem dico, quasi nos infirmi fuerimus; in quo quis audet, in insipientia dico, audeo et ego."
,"22":"Hebraei sunt? Et ego. Israelitae sunt? Et ego. Semen Abrahae sunt? Et ego."
,"23":"Ministri Christi sunt? Minus sapiens dico, plus ego: in laboribus plurimis, in carceribus abundantius, in plagis supra modum, in mortibus frequenter;"
,"24":"a Iudaeis quinquies quadragenas una minus accepi,"
,"25":"ter virgis caesus sum, semel lapidatus sum, ter naufragium feci, nocte et die in profundo maris fui;"
,"26":"in itineribus saepe, periculis fluminum, periculis latronum, periculis ex genere, periculis ex gentibus, periculis in civitate, periculis in solitudine, periculis in mari, periculis in falsis fratribus;"
,"27":"in labore et aerumna, in vigiliis saepe, in fame et siti, in ieiuniis frequenter, in frigore et nuditate;"
,"28":"praeter illa, quae extrinsecus sunt, instantia mea cotidiana, sollicitudo omnium ecclesiarum."
,"29":"Quis infirmatur, et non infirmor? Quis scandalizatur, et ego non uror?"
,"30":"Si gloriari oportet, quae infirmitatis meae sunt, gloriabor."
,"31":"Deus et Pater Domini Iesu scit, qui est benedictus in saecula, quod non mentior."
,"32":"Damasci praepositus gentis Aretae regis custodiebat civitatem Damascenorum, ut me comprehenderet;"
,"33":"et per fenestram in sporta dimissus sum per murum et effugi manus eius."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Gloriari oportet; non expedit quidem, veniam autem ad visiones et revelationes Domini."
,"2":"Scio hominem in Christo ante annos quattuordecim - sive in corpore nescio, sive extra corpus nescio, Deus scit - raptum eiusmodi usque ad tertium caelum."
,"3":"Et scio huiusmodi hominem - sive in corpore sive extra corpus nescio, Deus scit -"
,"4":"quoniam raptus est in paradisum et audivit arcana verba, quae non licet homini loqui."
,"5":"Pro eiusmodi gloriabor; pro me autem nihil gloriabor nisi in infirmitatibus meis."
,"6":"Nam, et si voluero gloriari, non ero insipiens, veritatem enim dicam; parco autem, ne quis in me existimet supra id, quod videt me aut audit ex me,"
,"7":"et ex magnitudine revelationum. Propter quod, ne extollar, datus est mihi stimulus carni, angelus Satanae, ut me colaphizet, ne extollar."
,"8":"Propter quod ter Dominum rogavi, ut discederet a me;"
,"9":"et dixit mihi: ' Sufficit tibi gratia mea, nam virtus in infirmitate perficitur '. Libentissime igitur potius gloriabor in infirmitatibus meis, ut inhabitet in me virtus Christi."
,"10":"Propter quod placeo mihi in infirmitatibus, in contumeliis, in necessitatibus, in persecutionibus et in angustiis, pro Christo; cum enim infirmor, tunc potens sum."
,"11":"Factus sum insipiens. Vos me coegistis; ego enim debui a vobis commendari. Nihil enim minus fui ab his, qui sunt supra modum apostoli, tametsi nihil sum;"
,"12":"signa tamen apostoli facta sunt super vos in omni patientia, signis quoque et prodigiis et virtutibus."
,"13":"Quid est enim quod minus habuistis prae ceteris ecclesiis, nisi quod ego ipse non gravavi vos? Donate mihi hanc iniuriam."
,"14":"Ecce tertio hoc paratus sum venire ad vos et non ero gravis vobis; non enim quaero, quae vestra sunt, sed vos; nec enim debent filii parentibus thesaurizare, sed parentes filiis."
,"15":"Ego autem libentissime impendam et superimpendar ipse pro animabus vestris. Si plus vos diligo, minus diligar?"
,"16":"Esto quidem, ego vos non gravavi; sed cum essem astutus, dolo vos cepi."
,"17":"Numquid per aliquem eorum, quos misi ad vos, circumveni vos?"
,"18":"Rogavi Titum et misi cum illo fratrem; numquid Titus vos circumvenit? Nonne eodem spiritu ambulavimus? Nonne iisdem vestigiis?"
,"19":"Olim putatis quod excusemus nos apud vos? Coram Deo in Christo loquimur; omnia autem, carissimi, propter vestram aedificationem."
,"20":"Timeo enim, ne forte, cum venero, non quales volo, inveniam vos, et ego inveniar a vobis, qualem non vultis; ne forte contentiones, aemulationes, animositates, dissensiones, detractiones, susurrationes, inflationes, seditiones sint;"
,"21":"ne iterum, cum venero, humiliet me Deus meus apud vos, et lugeam multos ex his, qui ante peccaverunt et non egerunt paenitentiam super immunditia et fornicatione et impudicitia, quam gesserunt."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Ecce tertio hoc venio ad vos; in ore duorum vel trium testium stabit omne verbum."
,"2":"Praedixi et praedico, ut praesens bis et nunc absens his, qui ante peccaverunt, et ceteris omnibus, quoniam, si venero iterum, non parcam,"
,"3":"quoniam experimentum quaeritis eius, qui in me loquitur, Christi, qui in vos non infirmatur, sed potens est in vobis."
,"4":"Nam etsi crucifixus est ex infirmitate, sed vivit ex virtute Dei. Nam et nos infirmi sumus in illo, sed vivemus cum eo ex virtute Dei in vos."
,"5":"Vosmetipsos tentate, si estis in fide; ipsi vos probate. An non cognoscitis vos ipsos, quia Iesus Christus in vobis est? Nisi forte reprobi estis."
,"6":"Spero autem quod cognoscetis quia nos non sumus reprobi."
,"7":"Oramus autem Deum, ut nihil mali faciatis, non ut nos probati pareamus, sed ut vos, quod bonum est, faciatis, nos autem ut reprobi simus."
,"8":"Non enim possumus aliquid adversus veritatem, sed pro veritate."
,"9":"Gaudemus enim, quando nos infirmi sumus, vos autem potentes estis; hoc et oramus, vestram consummationem."
,"10":"Ideo haec absens scribo, ut non praesens durius agam secundum potestatem, quam Dominus dedit mihi in aedificationem et non in destructionem."
,"11":"De cetero, fratres, gaudete, perfecti estote, exhortamini invicem, idem sapite, pacem habete, et Deus dilectionis et pacis erit vobiscum."
,"12":"Salutate invicem in osculo sancto. Salutant vos sancti omnes."
,"13":"Gratia Domini Iesu Christi et caritas Dei et communicatio Sancti Spiritus cum omnibus vobis."
}`)

}
func LA_NVBSE_LoadNP2EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus et Silvanus et Timo theus ecclesiae Thessalonicen sium in Deo Patre nostro et Domino Iesu Christo:"
,"2":"gratia vobis et pax a Deo Patre nostro et Domino Iesu Christo."
,"3":"Gratias agere debemus Deo semper pro vobis, fratres, sicut dignum est, quoniam supercrescit fides vestra, et abundat caritas uniuscuiusque omnium vestrum in invicem,"
,"4":"ita ut et nos ipsi in vobis gloriemur in ecclesiis Dei pro patientia vestra et fide in omnibus persecutionibus vestris et tribulationibus, quas sustinetis,"
,"5":"indicium iusti iudicii Dei, ut digni habeamini regno Dei, pro quo et patimini;"
,"6":"si quidem iustum est apud Deum retribuere tribulationem his, qui vos tribulant,"
,"7":"et vobis, qui tribulamini, requiem nobiscum in revelatione Domini Iesu de caelo cum angelis virtutis eius,"
,"8":"in igne flammae, dantis vindictam his, qui non noverunt Deum et qui non oboediunt evangelio Domini nostri Iesu;"
,"9":"qui poenas dabunt interitu aeterno a facie Domini et a gloria virtutis eius,"
,"10":"cum venerit glorificari in sanctis suis et admirabilis fieri in omnibus, qui crediderunt; quia creditum est testimonium nostrum super vos in die illo."
,"11":"Ad quod etiam oramus semper pro vobis, ut dignetur vos vocatione sua Deus noster et impleat omnem voluntatem bonitatis et opus fidei in virtute;"
,"12":"ut glorificetur nomen Domini nostri Iesu Christi in vobis, et vos in illo, secundum gratiam Dei nostri et Domini Iesu Christi."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Rogamus autem vos, fratres, circa adventum Domini nostri Iesu Christi et nostram congregationem in ipsum,"
,"2":"ut non cito moveamini a sensu neque terreamini, neque per spiritum neque per verbum neque per epistulam tamquam per nos, quasi instet dies Domini."
,"3":"Ne quis vos seducat ullo modo; quoniam, nisi venerit discessio primum, et revelatus fuerit homo iniquitatis, filius perditionis,"
,"4":"qui adversatur et extollitur supra omne, quod dicitur Deus aut quod colitur, ita ut in templo Dei sedeat, ostendens se quia sit Deus."
,"5":"Non retinetis quod, cum adhuc essem apud vos, haec dicebam vobis?"
,"6":"Et nunc quid detineat scitis, ut ipse reveletur in suo tempore."
,"7":"Nam mysterium iam operatur iniquitatis; tantum qui tenet nunc, donec de medio fiat."
,"8":"Et tunc revelabitur ille iniquus, quem Dominus Iesus interficiet spiritu oris sui et destruet illustratione adventus sui,"
,"9":"eum, cuius est adventus secundum operationem Satanae in omni virtute et signis et prodigiis mendacibus"
,"10":"et in omni seductione iniquitatis his, qui pereunt, eo quod caritatem veritatis non receperunt, ut salvi fierent."
,"11":"Et ideo mittit illis Deus operationem erroris, ut credant mendacio,"
,"12":"ut iudicentur omnes, qui non crediderunt veritati, sed consenserunt iniquitati."
,"13":"Nos autem debemus gratias agere Deo semper pro vobis, fratres, dilecti a Domino, quod elegerit vos Deus primitias in salutem, in sanctificatione Spiritus et fide veritatis;"
,"14":"ad quod et vocavit vos per evangelium nostrum in acquisitionem gloriae Domini nostri Iesu Christi."
,"15":"Itaque, fratres, state et tenete traditiones, quas didicistis sive per sermonem sive per epistulam nostram."
,"16":"Ipse autem Dominus noster Iesus Christus et Deus Pater noster, qui dilexit nos et dedit consolationem aeternam et spem bonam in gratia,"
,"17":"consoletur corda vestra et confirmet in omni opere et sermone bono."
}`)
	CurrentBook.AddChapter(3, `{
"1":"De cetero, fratres, orate pro nobis, ut sermo Domini currat et glorificetur sicut et apud vos,"
,"2":"et ut liberemur ab importunis et malis hominibus; non enim omnium est fides."
,"3":"Fidelis autem Dominus est, qui confirmabit vos et custodiet a Malo."
,"4":"Confidimus autem de vobis in Domino, quoniam, quae praecipimus, et facitis et facietis."
,"5":"Dominus autem dirigat corda vestra in caritatem Dei et patientiam Christi."
,"6":"Praecipimus autem vobis, fratres, in nomine Domini nostri Iesu Christi, ut subtrahatis vos ab omni fratre ambulante inordinate et non secundum traditionem, quam acceperunt a nobis."
,"7":"Ipsi enim scitis quemadmodum oporteat imitari nos, quoniam non inordinati fuimus inter vos"
,"8":"neque gratìs panem manducavimus ab aliquo sed in labore et fatigatione, nocte et die operantes, ne quem vestrum gravaremus;"
,"9":"non quasi non habuerimus potestatem, sed ut nosmetipsos formam daremus vobis ad imitandum nos."
,"10":"Nam et cum essemus apud vos, hoc praecipiebamus vobis: Si quis non vult operari, nec manducet."
,"11":"Audimus enim inter vos quosdam ambulare inordinate, nihil operantes sed curiose agentes;"
,"12":"his autem, qui eiusmodi sunt, praecipimus et obsecramus in Domino Iesu Christo, ut cum quiete operantes suum panem manducent."
,"13":"Vos autem, fratres, nolite deficere benefacientes."
,"14":"Quod si quis non oboedit verbo nostro per epistulam, hunc notate, non commisceamini cum illo, ut confundatur;"
,"15":"et nolite quasi inimicum existimare, sed corripite ut fratrem."
,"16":"Ipse autem Dominus pacis det vobis pacem sempiternam in omni modo. Dominus cum omnibus vobis."
,"17":"Salutatio mea manu Pauli, quod est signum in omni epistula; ita scribo."
,"18":"Gratia Domini nostri Iesu Christi cum omnibus vobis."
}`)

}
func LA_NVBSE_LoadNP2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus, apostolus Christi Iesu per voluntatem Dei secundum promissionem vitae, quae est in Christo Iesu,"
,"2":"Timotheo carissimo filio: gratia, misericordia, pax a Deo Patre et Christo Iesu Domino nostro."
,"3":"Gratias ago Deo, cui servio a progenitoribus in conscientia pura, quod sine intermissione habeo tui memoriam in orationibus meis nocte ac die"
,"4":"desiderans te videre, memor lacrimarum tuarum, ut gaudio implear,"
,"5":"recordationem accipiens eius fidei, quae est in te non ficta, quae et habitavit primum in avia tua Loide et matre tua Eunice, certus sum autem quod et in te."
,"6":"Propter quam causam admoneo te, ut resuscites donationem Dei, quae est in te per impositionem manuum mearum;"
,"7":"non enim dedit nobis Deus Spiritum timoris sed virtutis et dilectionis et sobrietatis."
,"8":"Noli itaque erubescere testimonium Domini nostri neque me vinctum eius, sed collabora evangelio secundum virtutem Dei,"
,"9":"qui nos salvos fecit et vocavit vocatione sancta, non secundum opera nostra sed secundum propositum suum et gratiam, quae data est nobis in Christo Iesu ante tempora saecularia;"
,"10":"manifestata autem nunc per illustrationem salvatoris nostri Iesu Christi, qui destruxit quidem mortem, illuminavit autem vitam et incorruptionem per evangelium,"
,"11":"in quo positus sum ego praedicator et apostolus et doctor."
,"12":"Ob quam causam etiam haec patior, sed non confundor; scio enim, cui credidi, et certus sum quia potens est depositum meum servare in illum diem."
,"13":"Formam habe sanorum verborum, quae a me audisti, in fide et dilectione, quae sunt in Christo Iesu;"
,"14":"bonum depositum custodi per Spiritum Sanctum, qui habitat in nobis."
,"15":"Scis hoc, quod aversi sunt a me omnes, qui in Asia sunt, ex quibus est Phygelus et Hermogenes."
,"16":"Det misericordiam Dominus Onesiphori domui, quia saepe me refrigeravit et catenam meam non erubuit;"
,"17":"sed cum Romam venisset, sollicite me quaesivit et invenit"
,"18":"- det illi Dominus invenire misericordiam a Domino in illa die - et quanta Ephesi ministravit, melius tu nosti."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tu ergo, fili mi, confortare in gratia, quae est in Christo Iesu;"
,"2":"et quae audisti a me per multos testes, haec commenda fidelibus hominibus, qui idonei erunt et alios docere."
,"3":"Collabora sicut bonus miles Christi Iesu."
,"4":"Nemo militans implicat se saeculi negotiis, ut ei placeat, qui eum elegit;"
,"5":"si autem certat quis agone, non coronatur nisi legitime certaverit."
,"6":"Laborantem agricolam oportet primum de fructibus accipere."
,"7":"Intellege, quae dico; dabit enim tibi Dominus in omnibus intellectum."
,"8":"Memor esto Iesum Christum resuscitatum esse a mortuis, ex semine David, secundum evangelium meum,"
,"9":"in quo laboro usque ad vincula quasi male operans; sed verbum Dei non est alligatum!"
,"10":"Ideo omnia sustineo propter electos, ut et ipsi salutem consequantur, quae est in Christo Iesu cum gloria aeterna."
,"11":"Fidelis sermo, Nam, si commortui sumus, et convivemus;"
,"12":"si sustinemus, et conregnabimus; si negabimus, et ille negabit nos;"
,"13":"si non credimus, ille fidelis manet, negare enim seipsum non potest."
,"14":"Haec commone testificans coram Deo verbis non contendere: in nihil utile est, nisi ad subversionem audientium."
,"15":"Sollicite cura teipsum probabilem exhibere Deo, operarium inconfusibilem, recte tractantem verbum veritatis."
,"16":"Profana autem inaniloquia devita, magis enim proficient ad impietatem,"
,"17":"et sermo eorum ut cancer serpit; ex quibus est Hymenaeus et Philetus,"
,"18":"qui circa veritatem aberraverunt dicentes resurrectionem iam factam, et subvertunt quorundam fidem."
,"19":"Sed firmum fundamentum Dei stat habens signaculum hoc: Cognovit Dominus, qui sunt eius, et: Discedat ab iniquitate omnis, qui nominat nomen Domini."
,"20":"In magna autem domo non solum sunt vasa aurea et argentea sed et lignea et fictilia, et quaedam quidem in honorem, quaedam autem in ignominiam;"
,"21":"si quis ergo emundaverit se ab istis, erit vas in honorem, sanctificatum, utile Domino, ad omne opus bonum paratum."
,"22":"Iuvenilia autem desideria fuge, sectare vero iustitiam, fidem, caritatem, pacem cum his, qui invocant Dominum de corde puro."
,"23":"Stultas autem et sine disciplina quaestiones devita, sciens quia generant lites;"
,"24":"servum autem Domini non oportet litigare, sed mansuetum esse ad omnes, aptum ad docendum, patientem,"
,"25":"cum mansuetudine corripientem eos, qui resistunt, si quando det illis Deus paenitentiam ad cognoscendam veritatem,"
,"26":"et resipiscant a Diaboli laqueo, a quo capti tenentur ad ipsius voluntatem."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hoc autem scito, quod in no vissimis diebus instabunt tem pora periculosa."
,"2":"Erunt enim homines seipsos amantes, cupidi, elati, superbi, blasphemi, parentibus inoboedientes, ingrati, scelesti,"
,"3":"sine affectione, sine foedere, criminatores, incontinentes, immites, sine benignitate,"
,"4":"proditores, protervi, tumidi, voluptatum amatores magis quam Dei,"
,"5":"habentes speciem quidem pietatis, virtutem autem eius abnegantes; et hos devita."
,"6":"Ex his enim sunt, qui penetrant domos et captivas ducunt mulierculas oneratas peccatis, quae ducuntur variis concupiscentiis,"
,"7":"semper discentes et numquam ad scientiam veritatis pervenire valentes."
,"8":"Quemadmodum autem Iannes et Iambres restiterunt Moysi, ita et hi resistunt veritati, homines corrupti mente, reprobi circa fidem;"
,"9":"sed ultra non proficient, insipientia enim eorum manifesta erit omnibus, sicut et illorum fuit."
,"10":"Tu autem assecutus es meam doctrinam, institutionem, propositum, fidem, longanimitatem, dilectionem, patientiam,"
,"11":"persecutiones, passiones, qualia mihi facta sunt Antiochiae, Iconii, Lystris, quales persecutiones sustinui; et ex omnibus me eripuit Dominus."
,"12":"Et omnes, qui volunt pie vivere in Christo Iesu, persecutionem patientur;"
,"13":"mali autem homines et seductores proficient in peius, in errorem mittentes et errantes."
,"14":"Tu vero permane in his, quae didicisti et credita sunt tibi, sciens a quibus didiceris,"
,"15":"et quia ab infantia Sacras Litteras nosti, quae te possunt instruere ad salutem per fidem, quae est in Christo Iesu."
,"16":"Omnis Scriptura divinitus inspirata est et utilis ad docendum, ad arguendum, ad corrigendum, ad erudiendum in iustitia,"
,"17":"ut perfectus sit homo Dei, ad omne opus bonum instructus."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Testificor coram Deo et Christo Iesu, qui iudicaturus est vivos ac mortuos, per adventum ipsius et regnum eius:"
,"2":"praedica verbum, insta opportune, importune, argue, increpa, obsecra in omni longanimitate et doctrina."
,"3":"Erit enim tempus, cum sanam doctrinam non sustinebunt, sed ad sua desideria coacervabunt sibi magistros prurientes auribus,"
,"4":"et a veritate quidem auditum avertent, ad fabulas autem convertentur."
,"5":"Tu vero vigila in omnibus, labora, opus fac evangelistae, ministerium tuum imple."
,"6":"Ego enim iam delibor, et tempus meae resolutionis instat."
,"7":"Bonum certamen certavi, cursum consummavi, fidem servavi;"
,"8":"in reliquo reposita est mihi iustitiae corona, quam reddet mihi Dominus in illa die, iustus iudex, non solum autem mihi sed et omnibus, qui diligunt adventum eius."
,"9":"Festina venire ad me cito."
,"10":"Demas enim me dereliquit diligens hoc saeculum et abiit Thessalonicam, Crescens in Galatiam, Titus in Dalmatiam;"
,"11":"Lucas est mecum solus. Marcum assumens adduc tecum, est enim mihi utilis in ministerium."
,"12":"Tychicum autem misi Ephesum."
,"13":"Paenulam, quam reliqui Troade apud Carpum, veniens affer, et libros, maxime autem membranas."
,"14":"Alexander aerarius multa mala mihi ostendit. Reddet ei Dominus secundum opera eius;"
,"15":"quem et tu devita, valde enim restitit verbis nostris."
,"16":"In prima mea defensione nemo mihi affuit, sed omnes me dereliquerunt. Non illis reputetur;"
,"17":"Dominus autem mihi astitit et confortavit me, ut per me praedicatio impleatur, et audiant omnes gentes; et liberatus sum de ore leonis."
,"18":"Liberabit me Dominus ab omni opere malo et salvum faciet in regnum suum caeleste; cui gloria in saecula saeculorum. Amen."
,"19":"Saluta Priscam et Aquilam et Onesiphori domum."
,"20":"Erastus remansit Corinthi, Trophimum autem reliqui infirmum Mileti."
,"21":"Festina ante hiemem venire. Salutat te Eubulus et Pudens et Linus et Claudia et fratres omnes."
,"22":"Dominus cum spiritu tuo. Gratia vobiscum."
}`)

}
func LA_NVBSE_LoadNPCLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus, apostolus Christi Iesu per voluntatem Dei, et Timo theus frater"
,"2":"his, qui sunt Colossis, sanctis et fidelibus fratribus in Christo: gratia vobis et pax a Deo Patre nostro."
,"3":"Gratias agimus Deo Patri Domini nostri Iesu Christi semper pro vobis orantes,"
,"4":"audientes fidem vestram in Christo Iesu et dilectionem, quam habetis in sanctos omnes,"
,"5":"propter spem, quae reposita est vobis in caelis, quam ante audistis in verbo veritatis evangelii,"
,"6":"quod pervenit ad vos, sicut et in universo mundo est fructificans et crescens, sicut et in vobis, ex ea die, qua audistis et cognovistis gratiam Dei in veritate;"
,"7":"sicut didicistis ab Epaphra carissimo conservo nostro, qui est fidelis pro nobis minister Christi,"
,"8":"qui etiam manifestavit nobis dilectionem vestram in Spiritu."
,"9":"Ideo et nos, ex qua die audivimus, non cessamus pro vobis orantes et postulantes, ut impleamini agnitione voluntatis eius in omni sapientia et intellectu spiritali,"
,"10":"ut ambuletis digne Domino per omnia placentes, in omni opere bono fructificantes et crescentes in scientia Dei,"
,"11":"in omni virtute confortati secundum potentiam claritatis eius in omnem patientiam et longanimitatem, cum gaudio"
,"12":"gratias agentes Patri, qui idoneos vos fecit in partem sortis sanctorum in lumine;"
,"13":"qui eripuit nos de potestate tenebrarum,et transtulit in regnum Filii dilectionis suae,"
,"14":"in quo habemus redemptionem, remissionem peccatorum;"
,"15":"qui est imago Dei invisibilis, primogenitus omnis creaturae,"
,"16":"quia in ipso condita sunt universa in caelis et in terra, visibilia et invisibilia, sive throni sive dominationes,sive principatus sive potestates. Omnia per ipsum et in ipsum creata sunt,"
,"17":"et ipse est ante omnia, et omnia in ipso constant."
,"18":"Et ipse est caput corporis ecclesiae; qui est principium, primogenitus ex mortuis, ut sit in omnibus ipse primatum tenens,"
,"19":"quia in ipso complacuit omnem plenitudinem habitare"
,"20":"et per eum reconciliare omnia in ipsum, pacificans per sanguinem crucis eius, sive quae in terris sive quae in caelis sunt."
,"21":"Et vos, cum essetis aliquando alienati et inimici sensu in operibus malis,"
,"22":"nunc autem reconciliavit in corpore carnis eius per mortem exhibere vos sanctos et immaculatos et irreprehensibiles coram ipso;"
,"23":"si tamen permanetis in fide fundati et stabiles et immobiles a spe evangelii, quod audistis, quod praedicatum est in universa creatura, quae sub caelo est, cuius factus sum ego Paulus minister."
,"24":"Nunc gaudeo in passionibus pro vobis et adimpleo, ea quae desunt passionum Christi in carne mea pro corpore eius, quod est ecclesia,"
,"25":"cuius factus sum ego minister secundum dispensationem Dei, quae data est mihi in vos, ut impleam verbum Dei;"
,"26":"mysterium, quod absconditum fuit a saeculis et generationibus, nunc autem manifestatum est sanctis eius,"
,"27":"quibus voluit Deus notas facere divitias gloriae mysterii huius in gentibus, quod est Christus in vobis, spes gloriae;"
,"28":"quem nos annuntiamus, commonentes omnem hominem et docentes omnem hominem in omni sapientia, ut exhibeamus omnem hominem perfectum in Christo;"
,"29":"ad quod et laboro certando secundum operationem eius, quae operatur in me in virtute."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Volo enim vos scire qualem sollicitudinem habeam pro vo bis et pro his, qui sunt Laodiciae, et quicumque non viderunt faciem meam in carne,"
,"2":"ut consolentur corda ipsorum instructi in caritate et in omnes divitias plenitudinis intellectus, in agnitionem mysterii Dei, Christi,"
,"3":"in quo sunt omnes thesauri sapientiae et scientiae absconditi."
,"4":"Hoc dico, ut nemo vos decipiat in subtilitate sermonum."
,"5":"Nam etsi corpore absens sum, sed spiritu vobiscum sum, gaudens et videns ordinem vestrum et firmamentum eius, quae in Christum est, fidei vestrae."
,"6":"Sicut ergo accepistis Christum Iesum Dominum, in ipso ambulate,"
,"7":"radicati et superaedificati in ipso et confirmati fide, sicut didicistis, abundantes in gratiarum actione."
,"8":"Videte, ne quis vos depraedetur per philosophiam et inanem fallaciam secundum traditionem hominum, secundum elementa mundi et non secundum Christum;"
,"9":"quia in ipso inhabitat omnis plenitudo divinitatis corporaliter,"
,"10":"et estis in illo repleti, qui est caput omnis principatus et potestatis;"
,"11":"in quo et circumcisi estis circumcisione non manufacta in exspoliatione corporis carnis, in circumcisione Christi;"
,"12":"consepulti ei in baptismo, in quo et conresuscitati estis per fidem operationis Dei, qui suscitavit illum a mortuis;"
,"13":"et vos, cum mortui essetis in delictis et praeputio carnis vestrae, convivificavit cum illo, donans nobis omnia delicta,"
,"14":"delens, quod adversum nos erat, chirographum decretis, quod erat contrarium nobis, et ipsum tulit de medio affigens illud cruci;"
,"15":"exspolians principatus et potestates traduxit confidenter, triumphans illos in semetipso."
,"16":"Nemo ergo vos iudicet in cibo aut in potu aut ex parte diei festi aut neomeniae aut sabbatorum,"
,"17":"quae sunt umbra futurorum, corpus autem Christi."
,"18":"Nemo vos bravio defraudet complacens sibi in humilitate et religione angelorum propter ea, quae vidit, ingrediens, frustra inflatus sensu carnis suae"
,"19":"et non tenens caput, ex quo totum corpus per nexus et coniunctiones subministratum et compaginatum crescit in augmentum Dei."
,"20":"Si mortui estis cum Christo ab elementis mundi, quid tamquam viventes in mundo decretis subicimini:"
,"21":"' Ne tetigeris neque gustaveris neque contrectaveris ',"
,"22":"quae sunt omnia in corruptionem ipso usu secundum praecepta et doctrinas hominum?"
,"23":"Quae sunt rationem quidem habentia sapientiae in superstitione et humilitate, et non parcendo corpori, non in honore aliquo ad saturitatem carnis."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Igitur, si conresurrexistis Chri sto, quae sursum sunt quaerite, ubi Christus est in dextera Dei sedens;"
,"2":"quae sursum sunt sapite, non quae supra terram."
,"3":"Mortui enim estis, et vita vestra abscondita est cum Christo in Deo!"
,"4":"Cum Christus apparuerit, vita vestra, tunc et vos apparebitis cum ipso in gloria."
,"5":"Mortificate ergo membra, quae sunt super terram: fornicationem, immunditiam, libidinem, concupiscentiam malam et avaritiam, quae est simulacrorum servitus,"
,"6":"propter quae venit ira Dei super filios incredulitatis;"
,"7":"in quibus et vos ambulastis aliquando, cum viveretis in illis."
,"8":"Nunc autem deponite et vos omnia: iram, indignationem, malitiam, blasphemiam, turpem sermonem de ore vestro;"
,"9":"nolite mentiri invicem, qui exuistis vos veterem hominem cum actibus eius"
,"10":"et induistis novum, eum, qui renovatur in agnitionem secundum imaginem eius, qui creavit eum,"
,"11":"ubi non est Graecus et Iudaeus, circumcisio et praeputium, barbarus, Scytha, servus, liber, sed omnia et in omnibus Christus."
,"12":"Induite vos ergo, sicut electi Dei, sancti et dilecti, viscera misericordiae, benignitatem, humilitatem, mansuetudinem, longanimitatem,"
,"13":"supportantes invicem et donantes vobis ipsis, si quis adversus aliquem habet querelam; sicut et Dominus donavit vobis, ita et vos;"
,"14":"super omnia autem haec: caritatem, quod est vinculum perfectionis."
,"15":"Et pax Christi dominetur in cordibus vestris, ad quam et vocati estis in uno corpore. Et grati estote."
,"16":"Verbum Christi habitet in vobis abundanter, in omni sapientia docentes et commonentes vosmetipsos psalmis, hymnis, canticis spiritalibus, in gratia cantantes in cordibus vestris Deo;"
,"17":"et omne, quodcumque facitis in verbo aut in opere, omnia in nomine Domini Iesu gratias agentes Deo Patri per ipsum."
,"18":"Mulieres, subditae estote viris, sicut oportet in Domino."
,"19":"Viri, diligite uxores et nolite amari esse ad illas."
,"20":"Filii, oboedite parentibus per omnia; hoc enim placitum est in Domino."
,"21":"Patres, nolite ad indignationem provocare filios vestros, ut non pusillo animo fiant."
,"22":"Servi, oboedite per omnia dominis carnalibus, non ad oculum servientes, quasi hominibus placentes, sed in simplicitate cordis, timentes Dominum."
,"23":"Quodcumque facitis, ex animo operamini sicut Domino et non hominibus,"
,"24":"scientes quod a Domino accipietis retributionem hereditatis. Domino Christo servite;"
,"25":"qui enim iniuriam facit, recipiet id quod inique gessit, et non est personarum acceptio."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Domini, quod iustum est et aequum, servis praestate, scien tes quoniam et vos Dominum habetis in caelo."
,"2":"Orationi instate, vigilantes in ea in gratiarum actione,"
,"3":"orantes simul et pro nobis, ut Deus aperiat nobis ostium sermonis ad loquendum mysterium Christi, propter quod etiam vinctus sum,"
,"4":"ut manifestem illud, ita ut oportet me loqui."
,"5":"In sapientia ambulate ad eos, qui foris sunt, tempus redimentes."
,"6":"Sermo vester semper sit in gratia, sale conditus, ut sciatis quomodo oporteat vos unicuique respondere."
,"7":"Quae circa me sunt, omnia vobis nota faciet Tychicus, carissimus frater et fidelis minister et conservus in Domino,"
,"8":"quem misi ad vos ad hoc ipsum, ut cognoscatis, quae circa nos sunt, et consoletur corda vestra,"
,"9":"cum Onesimo fideli et carissimo fratre, qui est ex vobis; omnia, quae hic aguntur, nota facient vobis."
,"10":"Salutat vos Aristarchus concaptivus meus et Marcus consobrinus Barnabae, de quo accepistis mandata - si venerit ad vos, excipite illum -"
,"11":"et Iesus, qui dicitur Iustus, qui sunt ex circumcisione; hi soli adiutores in regno Dei, qui mihi fuerunt solacio."
,"12":"Salutat vos Epaphras, qui ex vobis est, servus Christi Iesu, semper certans pro vobis in orationibus, ut stetis perfecti et impleti in omni voluntate Dei."
,"13":"Testimonium enim illi perhibeo, quod habet multum laborem pro vobis et pro his, qui sunt Laodiciae et qui Hierapoli."
,"14":"Salutat vos Lucas, medicus carissimus, et Demas."
,"15":"Salutate fratres, qui sunt Laodiciae, et Nympham et, quae in domo eius est, ecclesiam."
,"16":"Et cum lecta fuerit apud vos epistula, facite ut et in Laodicensium ecclesia legatur, et eam, quae ex Laodicia est, vos quoque legatis."
,"17":"Et dicite Archippo: ' Vide ministerium, quod accepisti in Domino, ut illud impleas '."
,"18":"Salutatio mea manu Pauli. Memores estote vinculorum meorum. Gratia vobiscum."
}`)

}
func LA_NVBSE_LoadNPEPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus, apostolus Christi Iesu per voluntatem Dei, sanctis, qui sunt Ephesi, et fidelibus in Christo Iesu:"
,"2":"gratia vobis et pax a Deo Patre nostro et Domino Iesu Christo."
,"3":"Benedictus Deus et Pater Domini nostri Iesu Christi, qui benedixit nos in omni benedictione spiritali in caelestibus in Christo,"
,"4":"sicut elegit nos in ipso ante mundi constitutionem, ut essemus sancti et immaculati in conspectu eius in caritate;"
,"5":"qui praedestinavit nos in adoptionem filiorum,per Iesum Christum in ipsum, secundum beneplacitum voluntatis suae,"
,"6":"in laudem gloriae gratiae suae, in qua gratificavit nos in Dilecto,"
,"7":"in quo habemus redemptionem per sanguinem eius, remissionem peccatorum, secundum divitias gratiae eius,"
,"8":"quam superabundare fecit in nobis,in omni sapientia et prudentia,"
,"9":"notum faciens nobis mysterium voluntatis suae, secundum beneplacitum eius, quod proposuit in eo,"
,"10":"in dispensationem plenitudinis temporum: recapitulare omnia in Christo, quae in caelis et quae in terra, in ipso;"
,"11":"in quo etiam sorte vocati sumus, praedestinati secundum propositum eius, qui omnia operatur secundum consilium voluntatis suae,"
,"12":"ut simus in laudem gloriae eius, qui ante speravimus in Christo;"
,"13":"in quo et vos cum audissetis verbum veritatis, evangelium salutis vestrae, in quo et credentes signati estis Spiritu promissionis Sancto,"
,"14":"qui est arrabo hereditatis nostrae in redemptionem acquisitionis, in laudem gloriae ipsius."
,"15":"Propterea et ego audiens fidem vestram, quae est in Domino Iesu, et dilectionem in omnes sanctos,"
,"16":"non cesso gratias agens pro vobis memoriam faciens in orationibus meis,"
,"17":"ut Deus Domini nostri Iesu Christi, Pater gloriae, det vobis Spiritum sapientiae et revelationis in agnitione eius,"
,"18":"illuminatos oculos cordis vestri, ut sciatis quae sit spes vocationis eius, quae divitiae gloriae hereditatis eius in sanctis,"
,"19":"et quae sit supereminens magnitudo virtutis eius in nos, qui credimus, secundum operationem potentiae virtutis eius,"
,"20":"quam operatus est in Christo, suscitans illum a mortuis et constituens ad dexteram suam in caelestibus"
,"21":"supra omnem principatum et potestatem et virtutem et dominationem et omne nomen, quod nominatur non solum in hoc saeculo sed et in futuro;"
,"22":"et omnia subiecit sub pedibus eius et ipsum dedit caput supra omnia ecclesiae,"
,"23":"quae est corpus ipsius, plenitudo eius, qui omnia in omnibus adimpletur."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et vos, cum essetis mortui de lictis et peccatis vestris,"
,"2":"in qui bus aliquando ambulastis secundum saeculum mundi huius, secundum principem potestatis aeris, spiritus, qui nunc operatur in filios diffidentiae;"
,"3":"in quibus et nos omnes aliquando conversati sumus in concupiscentiis carnis nostrae, facientes voluntates carnis et cogitationum, et eramus natura filii irae, sicut et ceteri."
,"4":"Deus autem, qui dives est in misericordia, propter nimiam caritatem suam, qua dilexit nos,"
,"5":"et cum essemus mortui peccatis, convivificavit nos Christo - gratia estis salvati -"
,"6":"et conresuscitavit et consedere fecit in caelestibus in Christo Iesu,"
,"7":"ut ostenderet in saeculis supervenientibus abundantes divitias gratiae suae in bonitate super nos in Christo Iesu."
,"8":"Gratia enim estis salvati per fidem; et hoc non ex vobis, Dei donum est:"
,"9":"non ex operibus, ut ne quis glorietur."
,"10":"Ipsius enim sumus factura, creati in Christo Iesu in opera bona, quae praeparavit Deus, ut in illis ambulemus."
,"11":"Propter quod memores estote, quod aliquando vos gentes in carne, qui dicimini praeputium ab ea, quae dicitur circumcisio in carne manufacta,"
,"12":"quia eratis illo in tempore sine Christo, alienati a conversatione Israel et extranei testamentorum promissionis, spem non habentes et sine Deo in mundo."
,"13":"Nunc autem in Christo Iesu vos, qui aliquando eratis longe, facti estis prope in sanguine Christi."
,"14":"Ipse est enim pax nostra, qui fecit utraque unum et medium parietem maceriae solvit, inimicitiam, in carne sua,"
,"15":"legem mandatorum in decretis evacuans, ut duos condat in semetipso in unum novum hominem, faciens pacem,"
,"16":"et reconciliet ambos in uno corpore Deo per crucem, interficiens inimicitiam in semetipso."
,"17":"Et veniens evangelizavit pacem vobis, qui longe fuistis, et pacem his, qui prope;"
,"18":"quoniam per ipsum habemus accessum ambo in uno Spiritu ad Patrem."
,"19":"Ergo iam non estis extranei et advenae, sed estis concives sanctorum et domestici Dei,"
,"20":"superaedificati super fundamentum apostolorum et prophetarum, ipso summo angulari lapide Christo Iesu,"
,"21":"in quo omnis aedificatio compacta crescit in templum sanctum in Domino,"
,"22":"in quo et vos coaedificamini in habitaculum Dei in Spiritu."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Huius rei gratia, ego Paulus, vinctus Christi Iesu pro vobis gentibus -"
,"2":"si tamen audistis dispensationem gratiae Dei, quae data est mihi pro vobis,"
,"3":"quoniam secundum revelationem notum mihi factum est mysterium, sicut supra scripsi in brevi,"
,"4":"prout potestis legentes intellegere prudentiam meam in mysterio Christi,"
,"5":"quod aliis generationibus non innotuit filiis hominum, sicuti nunc revelatum est sanctis apostolis eius et prophetis in Spiritu,"
,"6":"esse gentes coheredes et concorporales et comparticipes promissionis in Christo Iesu per evangelium,"
,"7":"cuius factus sum minister secundum donum gratiae Dei, quae data est mihi secundum operationem virtutis eius."
,"8":"Mihi omnium sanctorum minimo data est gratia haec: gentibus evangelizare investigabiles divitias Christi"
,"9":"et illuminare omnes, quae sit dispensatio mysterii absconditi a saeculis in Deo, qui omnia creavit,"
,"10":"ut innotescat nunc principatibus et potestatibus in caelestibus per ecclesiam multiformis sapientia Dei,"
,"11":"secundum propositum saeculorum, quod fecit in Christo Iesu Domino nostro,"
,"12":"in quo habemus fiduciam et accessum in confidentia per fidem eius."
,"13":"Propter quod peto, ne deficiatis in tribulationibus meis pro vobis, quae est gloria vestra."
,"14":"Huius rei gratia flecto genua mea ad Patrem,"
,"15":"ex quo omnis paternitas in caelis et in terra nominatur,"
,"16":"ut det vobis secundum divitias gloriae suae virtute corroborari per Spiritum eius in interiorem hominem,"
,"17":"habitare Christum per fidem in cordibus vestris, in caritate radicati et fundati,"
,"18":"ut valeatis comprehendere cum omnibus sanctis quae sit latitudo et longitudo et sublimitas et profundum,"
,"19":"scire etiam supereminentem scientiae caritatem Christi, ut impleamini in omnem plenitudinem Dei."
,"20":"Ei autem, qui potens est supra omnia facere superabundanter quam petimus aut intellegimus, secundum virtutem, quae operatur in nobis,"
,"21":"ipsi gloria in ecclesia et in Christo Iesu in omnes generationes saeculi saeculorum. Amen."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Obsecro itaque vos ego, vinctus in Domino, ut digne ambuletis vocatione, qua vocati estis,"
,"2":"cum omni humilitate et mansuetudine, cum longanimitate, supportantes invicem in caritate,"
,"3":"solliciti servare unitatem spiritus in vinculo pacis;"
,"4":"unum corpus et unus Spiritus, sicut et vocati estis in una spe vocationis vestrae;"
,"5":"unus Dominus, una fides, unum baptisma;"
,"6":"unus Deus et Pater omnium, qui super omnes et per omnia et in omnibus."
,"7":"Unicuique autem nostrum data est gratia secundum mensuram donationis Christi."
,"8":"Propter quod dicit: ' Ascendens in altum captivam duxit captivitatem, dedit dona hominibus '."
,"9":"Illud autem ' ascendit ' quid est, nisi quia et descendit in inferiores partes terrae?"
,"10":"Qui descendit, ipse est et qui ascendit super omnes caelos, ut impleret omnia."
,"11":"Et ipse dedit quosdam quidem apostolos, quosdam autem prophetas, alios vero evangelistas, alios autem pastores et doctores"
,"12":"ad instructionem sanctorum in opus ministerii, in aedificationem corporis Christi,"
,"13":"donec occurramus omnes in unitatem fidei et agnitionis Filii Dei, in virum perfectum, in mensuram aetatis plenitudinis Christi,"
,"14":"ut iam non simus parvuli fluctuantes et circumacti omni vento doctrinae in fallacia hominum, in astutia ad circumventionem erroris;"
,"15":"veritatem autem facientes in caritate crescamus in illum per omnia, qui est caput Christus,"
,"16":"ex quo totum corpus compactum et conexum per omnem iuncturam subministrationis secundum operationem in mensura uniuscuiusque partis augmentum corporis facit in aedificationem sui in caritate."
,"17":"Hoc igitur dico et testificor in Domino, ut iam non ambuletis, sicut et gentes ambulant in vanitate sensus sui"
,"18":"tenebris obscuratum habentes intellectum, alienati a vita Dei propter ignorantiam, quae est in illis propter caecitatem cordis ipsorum;"
,"19":"qui indolentes semetipsos tradiderunt impudicitiae in operationem immunditiae omnis in avaritia."
,"20":"Vos autem non ita didicistis Christum,"
,"21":"si tamen illum audistis et in ipso edocti estis, sicut est veritas in Iesu:"
,"22":"deponere vos secundum pristinam conversationem veterem hominem, qui corrumpitur secundum desideria erroris,"
,"23":"renovari autem spiritu mentis vestrae"
,"24":"et induere novum hominem, qui secundum Deum creatus est in iustitia et sanctitate veritatis."
,"25":"Propter quod deponentes mendacium loquimini veritatem unusquisque cum proximo suo, quoniam sumus invicem membra."
,"26":"Irascimini et nolite peccare; sol non occidat super iracundiam vestram,"
,"27":"et nolite locum dare Diabolo."
,"28":"Qui furabatur, iam non furetur, magis autem laboret operando manibus bonum, ut habeat unde tribuat necessitatem patienti."
,"29":"Omnis sermo malus ex ore vestro non procedat, sed si quis bonus ad aedificationem opportunitatis, ut det gratiam audientibus."
,"30":"Et nolite contristare Spiritum Sanctum Dei, in quo signati estis in diem redemptionis."
,"31":"Omnis amaritudo et ira et indignatio et clamor et blasphemia tollatur a vobis cum omni malitia."
,"32":"Estote autem invicem benigni, misericordes, donantes invicem, sicut et Deus in Christo donavit vobis."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Estote ergo imitatores Dei, sicut filii carissimi,"
,"2":"et ambulate in dilectione, sicut et Christus dilexit nos et tradidit seipsum pro nobis oblationem et hostiam Deo in odorem suavitatis."
,"3":"Fornicatio autem et omnis immunditia aut avaritia nec nominetur in vobis, sicut decet sanctos,"
,"4":"et turpitudo et stultiloquium aut scurrilitas, quae non decent, sed magis gratiarum actio."
,"5":"Hoc enim scitote intellegentes quod omnis fornicator aut immundus aut avarus, id est idolorum cultor, non habet hereditatem in regno Christi et Dei."
,"6":"Nemo vos decipiat inanibus verbis; propter haec enim venit ira Dei in filios diffidentiae."
,"7":"Nolite ergo effici comparticipes eorum;"
,"8":"eratis enim aliquando tenebrae, nunc autem lux in Domino. Ut filii lucis ambulate"
,"9":"- fructus enim lucis est in omni bonitate et iustitia et veritate -"
,"10":"probantes quid sit beneplacitum Domino;"
,"11":"et nolite communicare operibus infructuosis tenebrarum, magis autem et redarguite;"
,"12":"quae enim in occulto fiunt ab ipsis, turpe est et dicere;"
,"13":"omnia autem, quae arguuntur, a lumine manifestantur,"
,"14":"omne enim, quod manifestatur, lumen est. Propter quod dicit: ' Surge, qui dormis, et exsurge a mortuis, et illuminabit te Christus '."
,"15":"Videte itaque caute quomodo ambuletis, non quasi insipientes sed ut sapientes,"
,"16":"redimentes tempus, quoniam dies mali sunt."
,"17":"Propterea nolite fieri imprudentes, sed intellegite, quae sit voluntas Domini."
,"18":"Et nolite inebriari vino, in quo est luxuria, sed implemini Spiritu"
,"19":"loquentes vobismetipsis in psalmis et hymnis et canticis spiritalibus, cantantes et psallentes in cordibus vestris Domino."
,"20":"Gratias agentes semper pro omnibus in nomine Domini nostri Iesu Christi Deo et Patri,"
,"21":"subiecti invicem in timore Christi."
,"22":"Mulieres viris suis sicut Domino,"
,"23":"quoniam vir caput est mulieris, sicut et Christus caput est ecclesiae, ipse salvator corporis."
,"24":"Sed ut ecclesia subiecta est Christo, ita et mulieres viris in omnibus."
,"25":"Viri, diligite uxores, sicut et Christus dilexit ecclesiam et seipsum tradidit pro ea,"
,"26":"ut illam sanctificaret mundans lavacro aquae in verbo,"
,"27":"ut exhiberet ipse sibi gloriosam ecclesiam non habentem maculam aut rugam aut aliquid eiusmodi, sed ut sit sancta et immaculata."
,"28":"Ita et viri debent diligere uxores suas ut corpora sua. Qui suam uxorem diligit, seipsum diligit;"
,"29":"nemo enim umquam carnem suam odio habuit, sed nutrit et fovet eam sicut et Christus ecclesiam,"
,"30":"quia membra sumus corporis eius."
,"31":"Propter hoc relinquet homo patrem et matrem et adhaerebit uxori suae, et erunt duo in carne una."
,"32":"Mysterium hoc magnum est; ego autem dico de Christo et ecclesia!"
,"33":"Verumtamen et vos singuli unusquisque suam uxorem sicut seipsum diligat; uxor autem timeat virum."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Filii, oboedite parentibus vestris in Domino; hoc enim est iu stum."
,"2":"Honora patrem tuum et matrem, quod est mandatum primum cum promissione,"
,"3":"ut bene sit tibi, et sis longaevus super terram."
,"4":"Et, patres, nolite ad iracundiam provocare filios vestros, sed educate illos in disciplina et correptione Domini."
,"5":"Servi, oboedite dominis carnalibus cum timore et tremore, in simplicitate cordis vestri, sicut Christo;"
,"6":"non ad oculum servientes, quasi hominibus placentes, sed ut servi Christi facientes voluntatem Dei ex animo;"
,"7":"cum bona voluntate servientes, sicut Domino et non hominibus,"
,"8":"scientes quoniam unusquisque, si quid fecerit bonum, hoc percipiet a Domino, sive servus sive liber."
,"9":"Et, domini, eadem facite illis, remittentes minas, scientes quia et illorum et vester Dominus est in caelis, et personarum acceptio non est apud eum."
,"10":"De cetero confortamini in Domino et in potentia virtutis eius."
,"11":"Induite armaturam Dei, ut possitis stare adversus insidias Diaboli."
,"12":"Quia non est nobis colluctatio adversus sanguinem et carnem sed adversus principatus, adversus potestates, adversus mundi rectores tenebrarum harum, adversus spiritalia nequitiae in caelestibus."
,"13":"Propterea accipite armaturam Dei, ut possitis resistere in die malo et, omnibus perfectis, stare."
,"14":"State ergo succincti lumbos vestros in veritate et induti loricam iustitiae"
,"15":"et calceati pedes in praeparatione evangelii pacis,"
,"16":"inomnibus sumentes scutum fidei, in quo possitis omnia tela Maligni ignea exstinguere;"
,"17":"et galeam salutis assumite et gladium Spiritus, quod est verbum Dei;"
,"18":"per omnem orationem et obsecrationem orantes omni tempore in Spiritu, et in ipso vigilantes in omni instantia et obsecratione pro omnibus sanctis"
,"19":"et pro me, ut detur mihi sermo in aperitione oris mei cum fiducia notum facere mysterium evangelii,"
,"20":"pro quo legatione fungor in catena, ut in ipso audeam, prout oportet me, loqui."
,"21":"Ut autem et vos sciatis, quae circa me sunt, quid agam, omnia nota vobis faciet Tychicus, carissimus frater et fidelis minister in Domino,"
,"22":"quem misi ad vos in hoc ipsum, ut cognoscatis, quae circa nos sunt, et consoletur corda vestra."
,"23":"Pax fratribus et caritas cum fide a Deo Patre et Domino Iesu Christo."
,"24":"Gratia cum omnibus, qui diligunt Dominum nostrum Iesum Christum in incorruptione."
}`)

}
func LA_NVBSE_LoadNPGAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus apostolus, non ab ho minibus neque per hominem, sed per Iesum Christum et Deum Patrem, qui suscitavit eum a mortuis,"
,"2":"et, qui mecum sunt, omnes fratres ecclesiis Galatiae:"
,"3":"gratia vobis et pax a Deo Patre nostro et Domino Iesu Christo,"
,"4":"qui dedit semetipsum pro peccatis nostris, ut eriperet nos de praesenti saeculo nequam secundum voluntatem Dei et Patris nostri,"
,"5":"cui gloria in saecula saeculorum. Amen."
,"6":"Miror quod tam cito transferimini ab eo, qui vos vocavit in gratia Christi, in aliud evangelium;"
,"7":"quod non est aliud, nisi sunt aliqui, qui vos conturbant et volunt convertere evangelium Christi."
,"8":"Sed licet nos aut angelus de caelo evangelizet vobis praeterquam quod evangelizavimus vobis, anathema sit!"
,"9":"Sicut praediximus, et nunc iterum dico: Si quis vobis evangelizaverit praeter id, quod accepistis, anathema sit!"
,"10":"Modo enim hominibus suadeo aut Deo? Aut quaero hominibus placere? Si adhuc hominibus placerem, Christi servus non essem!"
,"11":"Notum enim vobis facio, fratres, evangelium, quod evangelizatum est a me, quia non est secundum hominem;"
,"12":"neque enim ego ab homine accepi illud neque didici sed per revelationem Iesu Christi."
,"13":"Audistis enim conversationem meam aliquando in Iudaismo, quoniam supra modum persequebar ecclesiam Dei et expugnabam illam;"
,"14":"et proficiebam in Iudaismo supra multos coaetaneos in genere meo, abundantius aemulator exsistens paternarum mearum traditionum."
,"15":"Cum autem placuit Deo, qui me segregavit de utero matris meae et vocavit per gratiam suam,"
,"16":"ut revelaret Filium suum in me, ut evangelizarem illum in gentibus, continuo non contuli cum carne et sanguine"
,"17":"neque ascendi Hierosolymam ad antecessores meos apostolos; sed abii in Arabiam et iterum reversus sum Damascum."
,"18":"Deinde post annos tres, ascendi Hierosolymam videre Cepham et mansi apud eum diebus quindecim;"
,"19":"alium autem apostolorum non vidi, nisi Iacobum fratrem Domini."
,"20":"Quae autem scribo vobis, ecce coram Deo quia non mentior."
,"21":"Deinde veni in partes Syriae et Ciliciae."
,"22":"Eram autem ignotus facie ecclesiis Iudaeae, quae sunt in Christo;"
,"23":"tantum autem auditum habebant: ' Qui persequebatur nos aliquando, nunc evangelizat fidem, quam aliquando expugnabat ',"
,"24":"et in me glorificabant Deum."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Deinde post annos quattuor decim, iterum ascendi Hieroso lymam cum Barnaba, assumpto et Tito;"
,"2":"ascendi autem secundum revelationem; et contuli cum illis evangelium, quod praedico in gentibus, seorsum autem his, qui observabantur, ne forte in vacuum currerem aut cucurrissem."
,"3":"Sed neque Titus, qui mecum erat, cum esset Graecus, compulsus est circumcidi."
,"4":"Sed propter subintroductos falsos fratres, qui subintroierunt explorare libertatem nostram, quam habemus in Christo Iesu, ut nos in servitutem redigerent;"
,"5":"quibus neque ad horam cessimus subicientes nos, ut veritas evangelii permaneat apud vos."
,"6":"Ab his autem, qui videbantur esse aliquid - quales aliquando fuerint, nihil mea interest; Deus personam hominis non accipit - mihi enim, qui observabantur, nihil contulerunt,"
,"7":"sed e contra, cum vidissent quod creditum est mihi evangelium praeputii, sicut Petro circumcisionis"
,"8":"- qui enim operatus est Petro in apostolatum circumcisionis, operatus est et mihi inter gentes -"
,"9":"et cum cognovissent gratiam, quae data est mihi, Iacobus et Cephas et Ioannes, qui videbantur columnae esse, dexteras dederunt mihi et Barnabae communionis, ut nos in gentes, ipsi autem in circumcisionem;"
,"10":"tantum ut pauperum memores essemus, quod etiam sollicitus fui hoc ipsum facere."
,"11":"Cum autem venisset Cephas Antiochiam, in faciem ei restiti, quia reprehensibilis erat."
,"12":"Prius enim quam venirent quidam ab Iacobo, cum gentibus comedebat; cum autem venissent, subtrahebat et segregabat se, timens eos, qui ex circumcisione erant."
,"13":"Et simulationi eius consenserunt ceteri Iudaei, ita ut et Barnabas simul abduceretur illorum simulatione."
,"14":"Sed cum vidissem quod non recte ambularent ad veritatem evangelii, dixi Cephae coram omnibus: ' Si tu, cum Iudaeus sis, gentiliter et non Iudaice vivis, quomodo gentes cogis iudaizare? '."
,"15":"Nos natura Iudaei et non ex gentibus peccatores,"
,"16":"scientes autem quod non iustificatur homo ex operibus legis, nisi per fidem Iesu Christi, et nos in Christum Iesum credidimus, ut iustificemur ex fide Christi et non ex operibus legis, quoniam ex operibus legis non iustificabitur omnis caro."
,"17":"Quodsi quaerentes iustificari in Christo, inventi sumus et ipsi peccatores, numquid Christus peccati minister est? Absit!"
,"18":"Si enim, quae destruxi, haec iterum aedifico, praevaricatorem me constituo."
,"19":"Ego enim per legem legi mortuus sum, ut Deo vivam. Christo confixus sum cruci;"
,"20":"vivo autem iam non ego, vivit vero in me Christus; quod autem nunc vivo in carne, in fide vivo Filii Dei, qui dilexit me et tradidit seipsum pro me."
,"21":"Non irritam facio gratiam Dei; si enim per legem iustitia, ergo Christus gratis mortuus est."
}`)
	CurrentBook.AddChapter(3, `{
"1":"O insensati Galatae, quis vos fascinavit, ante quorum oculos Iesus Christus descriptus est crucifixus?"
,"2":"Hoc solum volo a vobis discere: Ex operibus legis Spiritum accepistis an ex auditu fidei?"
,"3":"Sic stulti estis? Cum Spiritu coeperitis, nunc carne consummamini?"
,"4":"Tanta passi estis sine causa? Si tamen et sine causa!"
,"5":"Qui ergo tribuit vobis Spiritum et operatur virtutes in vobis, ex operibus legis an ex auditu fidei?"
,"6":"Sicut Abraham credidit Deo, et reputatum est ei ad iustitiam."
,"7":"Cognoscitis ergo quia qui ex fide sunt, hi sunt filii Abrahae."
,"8":"Providens autem Scriptura, quia ex fide iustificat gentes Deus, praenuntiavit Abrahae: 'Benedicentur in te omnes gentes'."
,"9":"Igitur, qui ex fide sunt, benedi cuntur cum fideli Abraham."
,"10":"Quicumque enim ex operibus legis sunt, sub maledicto sunt; scriptum est enim: ' Maledictus omnis, qui non permanserit in omnibus, quae scripta sunt in libro legis, ut faciat ea '."
,"11":"Quoniam autem in lege nemo iustificatur apud Deum manifestum est, quia iustus ex fide vivet;"
,"12":"lex autem non est ex fide; sed, qui fecerit ea, vivet in illis."
,"13":"Christus nos redemit de maledicto legis factus pro nobis maledictum, quia scriptum est: ' Maledictus omnis, qui pendet in ligno ',"
,"14":"ut in gentes benedictio Abrahae fieret in Christo Iesu, ut promissionem Spiritus accipiamus per fidem."
,"15":"Fratres, secundum hominem dico, tamen hominis confirmatum testamentum nemo irritum facit aut superordinat."
,"16":"Abrahae autem dictae sunt promissiones et semini eius. Non dicit: ' Et seminibus ', quasi in multis, sed quasi in uno: 'Et semini tuo', qui est Christus."
,"17":"Hoc autem dico: Testamentum confirmatum a Deo, quae post quadringentos et triginta annos facta est lex, non irritum facit ad evacuandam promissionem."
,"18":"Nam si ex lege hereditas, iam non ex promissione; Abrahae autem per promissionem donavit Deus."
,"19":"Quid igitur lex? Propter transgressiones apposita est, donec veniret semen, cui promissum est, ordinata per angelos in manu mediatoris."
,"20":"Mediator autem unius non est, Deus autem unus est."
,"21":"Lex ergo adversus promissa Dei? Absit. Si enim data esset lex, quae posset vivificare, vere ex lege esset iustitia."
,"22":"Sed conclusit Scriptura omnia sub peccato, ut promissio ex fide Iesu Christi daretur credentibus."
,"23":"Prius autem quam veniret fides, sub lege custodiebamur conclusi in eam fidem, quae revelanda erat."
,"24":"Itaque lex paedagogus noster fuit in Christum, ut ex fide iustificemur;"
,"25":"at ubi venit fides, iam non sumus sub paedagogo."
,"26":"Omnes enim filii Dei estis per fidem in Christo Iesu."
,"27":"Quicumque enim in Christum baptizati estis, Christum induistis:"
,"28":"non est Iudaeus neque Graecus, non est servus neque liber, non est masculus et femina; omnes enim vos unus estis in Christo Iesu."
,"29":"Si autem vos Christi, ergo Abrahae semen estis, secundum promissionem heredes."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Dico autem: Quanto tempore heres parvulus est, nihil differt a servo, cum sit dominus omnium,"
,"2":"sed sub tutoribus est et actoribus usque ad praefinitum tempus a patre."
,"3":"Ita et nos, cum essemus parvuli, sub elementis mundi eramus servientes;"
,"4":"at ubi venit plenitudo temporis, misit Deus Filium suum, factum ex muliere, factum sub lege,"
,"5":"ut eos, qui sub lege erant, redimeret, ut adoptionem filiorum reciperemus."
,"6":"Quoniam autem estis filii, misit Deus Spiritum Filii sui in corda nostra clamantem: ' Abba, Pater! '."
,"7":"Itaque iam non es servus sed filius; quod si filius, et heres per Deum."
,"8":"Sed tunc quidem ignorantes Deum, his, qui natura non sunt dii, servistis;"
,"9":"nunc autem, cum cognoveritis Deum, immo cogniti sitis a Deo, quomodo convertimini iterum ad infirma et egena elementa, quibus rursus ut antea servire vultis?"
,"10":"Dies observatis et menses et tempora et annos!"
,"11":"Timeo vos, ne forte sine causa laboraverim in vobis."
,"12":"Estote sicut ego, quia et ego sicut vos; fratres, obsecro vos. Nihil me laesistis;"
,"13":"scitis autem quia per infirmitatem carnis pridem vobis evangelizavi,"
,"14":"et tentationem vestram in carne mea non sprevistis neque respuistis, sed sicut angelum Dei excepistis me, sicut Christum Iesum."
,"15":"Ubi est ergo beatitudo vestra? Testimonium enim perhibeo vobis, quia, si fieri posset, oculos vestros eruissetis et dedissetis mihi."
,"16":"Ergo inimicus vobis factus sum, verum dicens vobis?"
,"17":"Aemulantur vos non bene, sed excludere vos volunt, ut illos aemulemini."
,"18":"Bonum est autem aemulari in bono semper, et non tantum cum praesens sum apud vos,"
,"19":"filioli mei, quos iterum parturio, donec formetur Christus in vobis!"
,"20":"Vellem autem esse apud vos modo et mutare vocem meam, quoniam incertus sum in vobis."
,"21":"Dicite mihi, qui sub lege vultis esse: Legem non auditis?"
,"22":"Scriptum est enim quoniam Abraham duos filios habuit, unum de ancilla et unum de libera."
,"23":"Sed qui de ancilla, secundum carnem natus est; qui autem de libera, per promissionem."
,"24":"Quae sunt per allegoriam dicta; ipsae enim sunt duo Testamenta, unum quidem a monte Sinai, in servitutem generans, quod est Agar."
,"25":"Illud vero Agar mons est Sinai in Arabia, respondet autem Ierusalem, quae nunc est; servit enim cum filiis suis."
,"26":"Illa autem, quae sursum est Ierusalem, libera est, quae est mater nostra;"
,"27":"scriptum est enim: ' Laetare, sterilis, quae non paris, erumpe et exclama, quae non parturis, quia multi filii desertae,magis quam eius, quae habet virum '."
,"28":"Vos autem, fratres, secundum Isaac promissionis filii estis."
,"29":"Sed quomodo tunc, qui secundum carnem natus fuerat, persequebatur eum, qui secundum spiritum, ita et nunc."
,"30":"Sed quid dicit Scriptura? ' Eice ancillam et filium eius; non enim heres erit filius ancillae cum filio liberae '."
,"31":"Itaque, fratres, non sumus ancillae filii sed liberae."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Hac libertate nos Christus liberavit; state igitur et nolite iterum iugo servitutis detineri."
,"2":"Ecce ego Paulus dico vobis quoniam, si circumcidamini, Christus vobis nihil proderit."
,"3":"Testificor autem rursum omni homini circumcidenti se quoniam debitor est universae legis faciendae."
,"4":"Evacuati estis a Christo, qui in lege iustificamini, a gratia excidistis."
,"5":"Nos enim Spiritu ex fide spem iustitiae exspectamus."
,"6":"Nam in Christo Iesu neque circumcisio aliquid valet neque praeputium, sed fides, quae per caritatem operatur."
,"7":"Currebatis bene; quis vos impedivit veritati non oboedire?"
,"8":"Haec persuasio non est ex eo, qui vocat vos."
,"9":"Modicum fermentum totam massam corrumpit."
,"10":"Ego confido in vobis in Domino, quod nihil aliud sapietis; qui autem conturbat vos, portabit iudicium, quicumque est ille."
,"11":"Ego autem, fratres, si circumcisionem adhuc praedico, quid adhuc persecutionem patior? Ergo evacuatum est scandalum crucis."
,"12":"Utinam et abscidantur, qui vos conturbant!"
,"13":"Vos enim in libertatem vocati estis, fratres; tantum ne libertatem in occasionem detis carni, sed per caritatem servite invicem."
,"14":"Omnis enim lex in uno sermone impletur, in hoc: Diliges proximum tuum sicut teipsum."
,"15":"Quod si invicem mordetis et devoratis, videte, ne ab invicem consumamini!"
,"16":"Dico autem: Spiritu ambulate et concupiscentiam carnis ne perfeceritis."
,"17":"Caro enim concupiscit adversus Spiritum, Spiritus autem adversus carnem; haec enim invicem adversantur, ut non, quaecumque vultis, illa faciatis."
,"18":"Quod si Spiritu ducimini, non estis sub lege."
,"19":"Manifesta autem sunt opera carnis, quae sunt fornicatio, immunditia, luxuria,"
,"20":"idolorum servitus, veneficia, inimicitiae, contentiones, aemulationes, irae, rixae, dissensiones, sectae,"
,"21":"invidiae, ebrietates, comissationes et his similia; quae praedico vobis, sicut praedixi, quoniam, qui talia agunt, regnum Dei non consequentur."
,"22":"Fructus autem Spiritus est caritas, gaudium, pax, longanimitas, benignitas, bonitas, fides,"
,"23":"mansuetudo, continentia; adversus huiusmodi non est lex."
,"24":"Qui autem sunt Christi Iesu, carnem crucifixerunt cum vitiis et concupiscentiis."
,"25":"Si vivimus Spiritu, Spiritu et ambulemus."
,"26":"Non efficiamur inanis gloriae cupidi, invicem provocantes, invicem invidentes."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Fratres, et si praeoccupatus fuerit homo in aliquo delicto, vos, qui spiritales estis, huiusmodi instruite in spiritu lenitatis, considerans teipsum, ne et tu tenteris."
,"2":"Alter alterius onera portate et sic adimplebitis legem Christi."
,"3":"Nam si quis existimat se aliquid esse, cum sit nihil, ipse se seducit;"
,"4":"opus autem suum probet unusquisque et sic in semetipso tantum gloriationem habebit et non in altero."
,"5":"Unusquisque enim onus suum portabit."
,"6":"Communicet autem is, qui catechizatur verbum, ei qui se catechizat, in omnibus bonis."
,"7":"Nolite errare: Deus non irridetur. Quae enim seminaverit homo, haec et metet;"
,"8":"quoniam, qui seminat in carne sua, de carne metet corruptionem; qui autem seminat in Spiritu, de Spiritu metet vitam aeternam."
,"9":"Bonum autem facientes infatigabiles, tempore enim suo metemus non deficientes."
,"10":"Ergo dum tempus habemus, operemur bonum ad omnes, maxime autem ad domesticos fidei."
,"11":"Videte qualibus litteris scripsi vobis mea manu."
,"12":"Quicumque volunt placere in carne, hi cogunt vos circumcidi, tantum ut crucis Christi persecutionem non patiantur;"
,"13":"neque enim, qui circumciduntur, legem custodiunt, sed volunt vos circumcidi, ut in carne vestra glorientur."
,"14":"Mihi autem absit gloriari, nisi in cruce Domini nostri Iesu Christi, per quem mihi mundus crucifixus est, et ego mundo."
,"15":"Neque enim circumcisio aliquid est neque praeputium sed nova creatura."
,"16":"Et quicumque hanc regulam secuti fuerint, pax super illos et misericordia et super Israel Dei."
,"17":"De cetero nemo mihi molestus sit; ego enim stigmata Iesu in super corpore meo porto."
,"18":"Gratia Domini nostri Iesu Christi cum spiritu vestro, fratres. Amen."
}`)

}
func LA_NVBSE_LoadNPPMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus vinctus Christi Iesu et Timotheus frater Philemoni dilecto et adiutori nostro"
,"2":"et Apphiae sorori et Archippo commilitoni nostro et ecclesiae, quae in domo tua est:"
,"3":"gratia vobis et pax a Deo Patre nostro et Domino Iesu Christo."
,"4":"Gratias ago Deo meo semper memoriam tui faciens in orationibus meis,"
,"5":"audiens caritatem tuam et fidem, quam habes in Dominum Iesum et in omnes sanctos,"
,"6":"ut communio fidei tuae evidens fiat in agnitione omnis boni, quod est in nobis in Christum;"
,"7":"gaudium enim magnum habui et consolationem in caritate tua, quia viscera sanctorum requieverunt per te, frater."
,"8":"Propter quod multam fiduciam habens in Christo imperandi tibi, quod ad rem pertinet,"
,"9":"propter caritatem magis obsecro, cum sim talis ut Paulus senex, nunc autem et vinctus Christi Iesu;"
,"10":"obsecro te de meo filio, quem genui in vinculis, Onesimo,"
,"11":"qui tibi aliquando inutilis fuit, nunc autem et tibi et mihi utilis,"
,"12":"quem remisi tibi: eum, hoc est viscera mea;"
,"13":"quem ego volueram mecum detinere, ut pro te mihi ministraret in vinculis evangelii."
,"14":"Sine consilio autem tuo nihil volui facere, uti ne velut ex necessitate bonum tuum esset sed voluntarium."
,"15":"Forsitan enim ideo discessit ad horam, ut aeternum illum reciperes,"
,"16":"iam non ut servum sed plus servo, carissimum fratrem, maxime mihi, quanto autem magis tibi et in carne et in Domino."
,"17":"Si ergo habes me socium, suscipe illum sicut me."
,"18":"Si autem aliquid nocuit tibi aut debet, hoc mihi imputa."
,"19":"Ego Paulus scripsi mea manu, ego reddam; ut non dicam tibi quod et teipsum mihi debes."
,"20":"Ita, frater! Ego te fruar in Domino; refice viscera mea in Christo!"
,"21":"Confidens oboedientia tua scripsi tibi, sciens quoniam et super id, quod dico, facies."
,"22":"Simul autem et para mihi hospitium, nam spero per orationes vestras donari me vobis."
,"23":"Salutat te Epaphras, concaptivus meus in Christo Iesu,"
,"24":"Marcus, Aristarchus, Demas, Lucas, adiutores mei."
,"25":"Gratia Domini Iesu Christi cum spiritu vestro."
}`)

}
func LA_NVBSE_LoadNPPPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus et Timotheus servi Christi Iesu omnibus sanctis in Christo Iesu, qui sunt Philippis, cum episcopis et diaconis:"
,"2":"gratia vobis et pax a Deo Patre nostro et Domino Iesu Christo."
,"3":"Gratias ago Deo meo in omni memoria vestri,"
,"4":"semper in omni oratione mea pro omnibus vobis cum gaudio deprecationem faciens"
,"5":"super communione vestra in evangelio a prima die usque nunc;"
,"6":"confidens hoc ipsum, quia, qui coepit in vobis opus bonum, perficiet usque in diem Christi Iesu;"
,"7":"sicut est mihi iustum hoc sentire pro omnibus vobis, eo quod habeam in corde vos et in vinculis meis et in defensione et confirmatione evangelii socios gratiae meae omnes vos esse."
,"8":"Testis enim mihi Deus, quomodo cupiam omnes vos in visceribus Christi Iesu."
,"9":"Et hoc oro, ut caritas vestra magis ac magis abundet in scientia et omni sensu,"
,"10":"ut probetis potiora, ut sitis sinceri et sine offensa in diem Christi,"
,"11":"repleti fructu iustitiae, qui est per Iesum Christum, in gloriam et laudem Dei."
,"12":"Scire autem vos volo, fratres, quia, quae circa me sunt, magis ad profectum venerunt evangelii,"
,"13":"ita ut vincula mea manifesta fierent in Christo in omni praetorio et in ceteris omnibus;"
,"14":"et plures e fratribus in Domino confidentes vinculis meis, abundantius audere sine timore verbum loqui."
,"15":"Quidam quidem et propter invidiam et contentionem, quidam autem et propter bonam voluntatem Christum praedicant;"
,"16":"hi quidem ex caritate scientes quoniam in defensionem evangelii positus sum,"
,"17":"illi autem ex contentione Christum annuntiant, non sincere, existimantes pressuram se suscitare vinculis meis."
,"18":"Quid enim? Dum omni modo, sive sub obtentu sive in veritate, Christus annuntietur, et in hoc gaudeo; sed et gaudebo,"
,"19":"scio enim quia hoc mihi proveniet in salutem per vestram orationem et subministrationem Spiritus Iesu Christi,"
,"20":"secundum exspectationem et spem meam quia in nullo confundar, sed in omni fiducia, sicut semper et nunc, magnificabitur Christus in corpore meo, sive per vitam sive per mortem."
,"21":"Mihi enim vivere Christus est et mori lucrum."
,"22":"Quod si vivere in carne, hic mihi fructus operis est, et quid eligam ignoro."
,"23":"Coartor autem ex his duobus: desiderium habens dissolvi et cum Christo esse, multo magis melius;"
,"24":"permanere autem in carne, magis necessarium est propter vos."
,"25":"Et hoc confidens, scio quia manebo et permanebo omnibus vobis ad profectum vestrum et gaudium fidei,"
,"26":"ut gloriatio vestra abundet in Christo Iesu in me, per meum adventum iterum ad vos."
,"27":"Tantum digne evangelio Christi conversamini, ut sive cum venero et videro vos, sive absens audiam de vobis quia statis in uno Spiritu unanimes, concertantes fide evangelii;"
,"28":"et in nullo perterriti ab adversariis, quod est illis indicium perditionis, vobis autem salutis, et hoc a Deo;"
,"29":"quia vobis hoc donatum est pro Christo, non solum ut in eum credatis, sed ut etiam pro illo patiamini"
,"30":"idem certamen habentes, quale vidistis in me et nunc auditis in me."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Si qua ergo consolatio in Christo, si quod solacium cari tatis, si qua communio spiritus, si quae viscera et miserationes,"
,"2":"implete gaudium meum, ut idem sapiatis, eandem caritatem habentes, unanimes, id ipsum sapientes;"
,"3":"nihil per contentionem neque per inanem gloriam, sed in humilitate superiores sibi invicem arbitrantes;"
,"4":"non, quae sua sunt, singuli considerantes, sed et ea, quae aliorum."
,"5":"Hoc sentite in vobis, quod et in Christo Iesu:"
,"6":"qui cum in forma Dei esset, non rapinam arbitratus est esse se aequalem Deo,"
,"7":"sed semetipsum exinanivit formam servi accipiens, in similitudinem hominum factus; et habitu inventus ut homo,"
,"8":"humiliavit semetipsum factus oboediens usque ad mortem, mortem autem crucis."
,"9":"Propter quod et Deus illum exaltavit,et donavit illi nomen, quod est super omne nomen,"
,"10":"ut in nomine Iesu omne genu flectatur,caelestium et terrestrium et infernorum,"
,"11":"et omnis lingua confiteatur,' Dominus Iesus Christus! ', in gloriam Dei Patris."
,"12":"Itaque, carissimi mei, sicut semper oboedistis, non ut in praesentia mei tantum sed multo magis nunc in absentia mea, cum metu et tremore vestram salutem operamini;"
,"13":"Deus est enim, qui operatur in vobis et velle et perficere pro suo beneplacito."
,"14":"Omnia facite sine murmurationibus et haesitationibus,"
,"15":"ut efficiamini sine querela et simplices, filii Dei sine reprehensione in medio generationis pravae et perversae, inter quos lucetis sicut luminaria in mundo,"
,"16":"verbum vitae firmiter tenentes ad gloriam meam in die Christi, quia non in vacuum cucurri neque in vacuum laboravi."
,"17":"Sed et si delibor supra sacrificium et obsequium fidei vestrae, gaudeo et congaudeo omnibus vobis;"
,"18":"idipsum autem et vos gaudete et congaudete mihi."
,"19":"Spero autem in Domino Iesu Timotheum cito me mittere ad vos, ut et ego bono animo sim, cognitis, quae circa vos sunt."
,"20":"Neminem enim habeo tam unanimem, qui sincere pro vobis sollicitus sit;"
,"21":"omnes enim sua quaerunt, non quae sunt Iesu Christi."
,"22":"Probationem autem eius cognoscitis, quoniam sicut patri filius mecum servivit in evangelium."
,"23":"Hunc igitur spero me mittere, mox ut videro, quae circa me sunt;"
,"24":"confido autem in Domino, quoniam et ipse cito veniam."
,"25":"Necessarium autem existimavi Epaphroditum fratrem et cooperatorem et commilitonem meum, vestrum autem apostolum et ministrum necessitatis meae, mittere ad vos,"
,"26":"quoniam omnes vos desiderabat et maestus erat, propterea quod audieratis illum infirmatum."
,"27":"Nam et infirmatus est usque ad mortem, sed Deus misertus est eius; non solum autem eius, verum et mei, ne tristitiam super tristitiam haberem."
,"28":"Festinantius ergo misi illum, ut, viso eo, iterum gaudeatis, et ego sine tristitia sim."
,"29":"Excipite itaque illum in Domino cum omni gaudio et eiusmodi cum honore habetote,"
,"30":"quoniam propter opus Christi usque ad mortem accessit in interitum tradens animam suam, ut suppleret id, quod vobis deerat ministerii erga me."
}`)
	CurrentBook.AddChapter(3, `{
"1":"De cetero, fratres mei, gaudete in Domino. Eadem vobis scribe re mihi quidem non pigrum, vobis autem securum."
,"2":"Videte canes, videte malos operarios, videte concisionem!"
,"3":"Nos enim sumus circumcisio, qui Spiritu Dei servimus et gloriamur in Christo Iesu et non in carne fiduciam habentes,"
,"4":"quamquam ego habeam confidentiam et in carne. Si quis alius videtur confidere in carne, ego magis:"
,"5":"circumcisus octava die, ex genere Israel, de tribu Beniamin, Hebraeus ex Hebraeis, secundum legem pharisaeus,"
,"6":"secundum aemulationem persequens ecclesiam, secundum iustitiam, quae in lege est, conversatus sine querela."
,"7":"Sed, quae mihi erant lucra, haec arbitratus sum propter Christum detrimentum."
,"8":"Verumtamen existimo omnia detrimentum esse propter eminentiam scientiae Christi Iesu Domini mei, propter quem omnia detrimentum feci et arbitror ut stercora, ut Christum lucrifaciam"
,"9":"et inveniar in illo non habens meam iustitiam, quae ex lege est, sed illam, quae per fidem est Christi, quae ex Deo est iustitia in fide;"
,"10":"ad cognoscendum illum et virtutem resurrectionis eius et communionem passionum illius, conformans me morti eius,"
,"11":"si quo modo occurram ad resurrectionem, quae est ex mortuis."
,"12":"Non quod iam acceperim aut iam perfectus sim; persequor autem si umquam comprehendam, sicut et comprehensus sum a Christo Iesu."
,"13":"Fratres, ego me non arbitror comprehendisse; unum autem: quae quidem retro sunt, obliviscens, ad ea vero, quae ante sunt, extendens me"
,"14":"ad destinatum persequor, ad bravium supernae vocationis Dei in Christo Iesu."
,"15":"Quicumque ergo perfecti, hoc sentiamus; et si quid aliter sapitis, et hoc vobis Deus revelabit;"
,"16":"verumtamen, ad quod pervenimus, in eodem ambulemus."
,"17":"Coimitatores mei estote, fratres, et observate eos, qui ita ambulant, sicut habetis formam nos."
,"18":"Multi enim ambulant, quos saepe dicebam vobis, nunc autem et flens dico, inimicos crucis Christi,"
,"19":"quorum finis interitus, quorum deus venter et gloria in confusione ipsorum, qui terrena sapiunt."
,"20":"Noster enim municipatus in caelis est, unde etiam salvatorem exspectamus Dominum Iesum Christum,"
,"21":"qui transfigurabit corpus humilitatis nostrae, ut illud conforme faciat corpori gloriae suae secundum operationem, qua possit etiam subicere sibi omnia."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Itaque, fratres mei carissimi et desideratissimi, gaudium et co rona mea, sic state in Domino, carissimi!"
,"2":"Evodiam rogo et Syntychen deprecor idipsum sapere in Domino."
,"3":"Etiam rogo et te, germane compar, adiuva illas, quae mecum concertaverunt in evangelio cum Clemente et ceteris adiutoribus meis, quorum nomina sunt in libro vitae."
,"4":"Gaudete in Domino semper. Iterum dico: Gaudete!"
,"5":"Modestia vestra nota sit omnibus hominibus. Dominus prope."
,"6":"Nihil solliciti sitis, sed in omnibus oratione et obsecratione cum gratiarum actione petitiones vestrae innotescant apud Deum."
,"7":"Et pax Dei, quae exsuperat omnem sensum, custodiet corda vestra et intellegentias vestras in Christo Iesu."
,"8":"De cetero, fratres, quaecumque sunt vera, quaecumque pudica, quaecumque iusta, quaecumque casta, quaecumque amabilia, quaecumque bonae famae, si qua virtus et si qua laus, haec cogitate;"
,"9":"quae et didicistis et accepistis et audistis et vidistis in me, haec agite; et Deus pacis erit vobiscum."
,"10":"Gavisus sum autem in Domino vehementer, quoniam tandem aliquando refloruistis pro me sentire, sicut et sentiebatis, opportunitate autem carebatis."
,"11":"Non quasi propter penuriam dico, ego enim didici, in quibus sum, sufficiens esse."
,"12":"Scio et humiliari, scio et abundare; ubique et in omnibus institutus sum et satiari et esurire et abundare et penuriam pati."
,"13":"Omnia possum in eo, qui me confortat."
,"14":"Verumtamen bene fecistis communicantes tribulationi meae."
,"15":"Scitis autem et vos, Philippenses, quod in principio evangelii, quando profectus sum a Macedonia, nulla mihi ecclesia communicavit in ratione dati et accepti, nisi vos soli;"
,"16":"quia et Thessalonicam et semel et bis in usum mihi misistis."
,"17":"Non quia quaero datum, sed requiro fructum, qui abundet in rationem vestram."
,"18":"Accepi autem omnia et abundo; repletus sum acceptis ab Epaphrodito, quae misistis odorem suavitatis, hostiam acceptam, placentem Deo."
,"19":"Deus autem meus implebit omne desiderium vestrum secundum divitias suas in gloria in Christo Iesu."
,"20":"Deo autem et Patri nostro gloria in saecula saeculorum. Amen."
,"21":"Salutate omnem sanctum in Christo Iesu. Salutant vos, qui mecum sunt, fratres."
,"22":"Salutant vos omnes sancti, maxime autem, qui de Caesaris domo sunt."
,"23":"Gratia Domini Iesu Christi cum spiritu vestro. Amen."
}`)

}
func LA_NVBSE_LoadNPRMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus servus Christi Iesu, vo catus apostolus, segregatus in evangelium Dei,"
,"2":"quod ante promiserat per prophetas suos in Scripturis sanctis"
,"3":"de Filio suo, qui factus est ex semine David secundum carnem,"
,"4":"qui constitutus est Filius Dei in virtute secundum Spiritum sanctificationis ex resurrectione mortuorum, Iesu Christo Domino nostro,"
,"5":"per quem accepimus gratiam et apostolatum ad oboeditionem fidei in omnibus gentibus pro nomine eius,"
,"6":"in quibus estis et vos vocati Iesu Christi,"
,"7":"omnibus, qui sunt Romae dilectis Dei, vocatis sanctis: gratia vobis et pax a Deo Patre nostro et Domino Iesu Christo."
,"8":"Primum quidem gratias ago Deo meo per Iesum Christum pro omnibus vobis, quia fides vestra annuntiatur in universo mundo;"
,"9":"testis enim mihi est Deus, cui servio in spiritu meo in evangelio Filii eius, quomodo sine intermissione memoriam vestri faciam"
,"10":"semper in orationibus meis obsecrans, si quo modo tandem aliquando prosperum iter habeam in voluntate Dei veniendi ad vos."
,"11":"Desidero enim videre vos, ut aliquid impertiar gratiae vobis spiritalis ad confirmandos vos,"
,"12":"id est una vobiscum consolari per eam, quae invicem est, fidem vestram atque meam."
,"13":"Nolo autem vos ignorare, fratres, quia saepe proposui venire ad vos et prohibitus sum usque adhuc, ut aliquem fructum habeam et in vobis, sicut et in ceteris gentibus."
,"14":"Graecis ac barbaris, sapientibus et insipientibus debitor sum."
,"15":"Itaque, quod in me est, promptus sum et vobis, qui Romae estis, evangelizare."
,"16":"Non enim erubesco evangelium: virtus enim Dei est in salutem omni credenti, Iudaeo primum et Graeco."
,"17":"Iustitia enim Dei in eo revelatur ex fide in fidem, sicut scriptum est: ' Iustus autem ex fide vivet '."
,"18":"Revelatur enim ira Dei de caelo super omnem impietatem et iniustitiam hominum, qui veritatem in iniustitia detinent,"
,"19":"quia, quod noscibile est Dei, manifestum est in illis; Deus enim illis manifestavit."
,"20":"Invisibilia enim ipsius a creatura mundi per ea, quae facta sunt, intellecta conspiciuntur, sempiterna eius et virtus et divinitas, ut sint inexcusabiles;"
,"21":"quia, cum cognovissent Deum, non sicut Deum glorificaverunt aut gratias egerunt, sed evanuerunt in cogitationibus suis, et obscuratum est insipiens cor eorum."
,"22":"Dicentes se esse sapientes, stulti facti sunt,"
,"23":"et mutaverunt gloriam incorruptibilis Dei in similitudinem imaginis corruptibilis hominis et volucrum et quadrupedum et serpentium."
,"24":"Propter quod tradidit illos Deus in concupiscentiis cordis eorum in immunditiam, ut ignominia afficiant corpora sua in semetipsis,"
,"25":"qui commutaverunt veritatem Dei in mendacio et coluerunt et servierunt creaturae potius quam Creatori, qui est benedictus in saecula. Amen."
,"26":"Propterea tradidit illos Deus in passiones ignominiae. Nam et feminae eorum immutaverunt naturalem usum in eum, qui est contra naturam;"
,"27":"similiter et masculi, relicto naturali usu feminae, exarserunt in desideriis suis in invicem, masculi in masculos turpitudinem operantes et mercedem, quam oportuit, erroris sui in semetipsis recipientes."
,"28":"Et sicut non probaverunt Deum habere in notitia, tradidit eos Deus in reprobum sensum, ut faciant, quae non conveniunt,"
,"29":"repletos omni iniquitate, malitia, avaritia, nequitia, plenos invidia, homicidio, contentione, dolo, malignitate, susurrones,"
,"30":"detractores, Deo odibiles, contumeliosos, superbos, elatos, inventores malorum, parentibus non oboedientes,"
,"31":"insipientes, incompositos, sine affectione, sine misericordia."
,"32":"Qui cum iudicium Dei cognovissent, quoniam qui talia agunt, digni sunt morte, non solum ea faciunt, sed et consentiunt facientibus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Propter quod inexcusabilis es, o homo omnis, qui iudicas. In quo enim iudicas alterum, teipsum condemnas; eadem enim agis, qui iudicas."
,"2":"Scimus enim quoniam iudicium Dei est secundum veritatem in eos, qui talia agunt."
,"3":"Existimas autem hoc, o homo, qui iudicas eos, qui talia agunt, et facis ea, quia tu effugies iudicium Dei?"
,"4":"An divitias benignitatis eius et patientiae et longanimitatis contemnis, ignorans quoniam benignitas Dei ad paenitentiam te adducit?"
,"5":"Secundum duritiam autem tuam et impaenitens cor thesaurizas tibi iram in die irae et revelationis iusti iudicii Dei,"
,"6":"qui reddet unicuique secundum opera eius:"
,"7":"his quidem, qui secundum patientiam boni operis gloriam et honorem et incorruptionem quaerunt, vitam aeternam;"
,"8":"his autem, qui ex contentione et non oboediunt veritati, oboediunt autem iniquitati, ira et indignatio."
,"9":"Tribulatio et angustia in omnem animam hominis operantis malum, Iudaei primum et Graeci;"
,"10":"gloria autem et honor et pax omni operanti bonum, Iudaeo primum et Graeco."
,"11":"Non est enim personarum acceptio apud Deum!"
,"12":"Quicumque enim sine lege peccaverunt, sine lege et peribunt; et, quicumque in lege peccaverunt, per legem iudicabuntur."
,"13":"Non enim auditores legis iusti sunt apud Deum, sed factores legis iustificabuntur."
,"14":"Cum enim gentes, quae legem non habent, naturaliter, quae legis sunt, faciunt, eiusmodi legem non habentes ipsi sibi sunt lex;"
,"15":"qui ostendunt opus legis scriptum in cordibus suis, testimonium simul reddente illis conscientia ipsorum, et inter se invicem cogitationibus accusantibus aut etiam defendentibus,"
,"16":"in die, cum iudicabit Deus occulta hominum secundum evangelium meum per Christum Iesum."
,"17":"Si autem tu Iudaeus cognominaris et requiescis in lege et gloriaris in Deo,"
,"18":"et nosti Voluntatem et discernis potiora instructus per legem,"
,"19":"et confidis teipsum ducem esse caecorum, lumen eorum, qui in tenebris sunt,"
,"20":"eruditorem insipientium, magistrum infantium, habentem formam scientiae et veritatis in lege."
,"21":"Qui ergo alium doces, teipsum non doces? Qui praedicas non furandum, furaris?"
,"22":"Qui dicis non moechandum, moecharis? Qui abominaris idola, templa spolias?"
,"23":"Qui in lege gloriaris, per praevaricationem legis Deum inhonoras?"
,"24":"' Nomen enim Dei propter vos blasphematur inter gentes ', sicut scriptum est."
,"25":"Circumcisio quidem prodest, si legem observes; si autem praevaricator legis sis, circumcisio tua praeputium facta est."
,"26":"Si igitur praeputium iustitias legis custodiat, nonne praeputium illius in circumcisionem reputabitur?"
,"27":"Et iudicabit, quod ex natura est praeputium legem consummans, te, qui per litteram et circumcisionem praevaricator legis es."
,"28":"Non enim qui manifesto Iudaeus est, neque quae manifesto in carne circumcisio,"
,"29":"sed qui in abscondito Iudaeus est, et circumcisio cordis in spiritu non littera, cuius laus non ex hominibus sed ex Deo est."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Quid ergo amplius est Iudaeo, aut quae utilitas circumcisionis?"
,"2":"Multum per omnem modum. Primum quidem, quia credita sunt illis eloquia Dei."
,"3":"Quid enim, si quidam non crediderunt? Numquid incredulitas illorum fidem Dei evacuabit?"
,"4":"Absit! Exstet autem Deus verax, omnis autem homo mendax, sicut scriptum est: ' Ut iustificeris in sermonibus tuis et vincas cum iudicaris '."
,"5":"Si autem iniustitia nostra iustitiam Dei commendat, quid dicemus? Numquid iniustus Deus, qui infert iram? Secundum hominem dico."
,"6":"Absit! Alioquin quomodo iudicabit Deus mundum?"
,"7":"Si enim veritas Dei in meo mendacio abundavit in gloriam ipsius, quid adhuc et ego tamquam peccator iudicor?"
,"8":"Et non, sicut blasphemamur, et sicut aiunt quidam nos dicere: ' Faciamus mala, ut veniant bona '? Quorum damnatio iusta est."
,"9":"Quid igitur? Praecellimus eos? Nequaquam! Antea enim causati sumus Iudaeos et Graecos omnes sub peccato esse,"
,"10":"sicut scriptum est: ' Non est iustus quisquam,"
,"11":"non est intellegens, non est requirens Deum."
,"12":"Omnes declinaverunt, simul inutiles facti sunt; non est qui faciat bonum, non est usque ad unum."
,"13":"Sepulcrum patens est guttur eorum, linguis suis dolose agebant, venenum aspidum sub labiis eorum,"
,"14":"quorum os maledictione et amaritudine plenum est;"
,"15":"veloces pedes eorum ad effundendum sanguinem,"
,"16":"contritio et infelicitas in viis eorum,"
,"17":"et viam pacis non cognoverunt."
,"18":"Non est timor Dei ante oculos eorum '."
,"19":"Scimus autem quoniam, quaecumque lex loquitur, his, qui in lege sunt, loquitur, ut omne os obstruatur, et obnoxius fiat omnis mundus Deo;"
,"20":"quia ex operibus legis non iustificabitur omnis caro coram illo, per legem enim cognitio peccati."
,"21":"Nunc autem sine lege iustitia Dei manifestata est, testificata a Lege et Prophetis,"
,"22":"iustitia autem Dei per fidem Iesu Christi, in omnes, qui credunt. Non enim est distinctio:"
,"23":"omnes enim peccaverunt et egent gloria Dei,"
,"24":"iustificati gratis per gratiam ipsius per redemptionem, quae est in Christo Iesu;"
,"25":"quem proposuit Deus propitiatorium per fidem in sanguine ipsius ad ostensionem iustitiae suae, cum praetermisisset praecedentia delicta"
,"26":"in sustentatione Dei, ad ostensionem iustitiae eius in hoc tempore, ut sit ipse iustus et iustificans eum, qui ex fide est Iesu."
,"27":"Ubi est ergo gloriatio? Exclusa est. Per quam legem? Operum? Non, sed per legem fidei."
,"28":"Arbitramur enim iustificari hominem per fidem sine operibus legis."
,"29":"An Iudaeorum Deus tantum? Nonne et gentium? Immo et gentium,"
,"30":"quoniam quidem unus Deus, qui iustificabit circumcisionem ex fide et praeputium per fidem."
,"31":"Legem ergo destruimus per fidem? Absit, sed legem statuimus."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quid ergo dicemus invenisse Abraham progenitorem no strum secundum carnem?"
,"2":"Si enim Abraham ex operibus iustificatus est, habet gloriam sed non apud Deum."
,"3":"Quid enim Scriptura dicit? ' Credidit autem Abraham Deo, et reputatum est illi ad iustitiam '."
,"4":"Ei autem, qui operatur, merces non reputatur secundum gratiam sed secundum debitum;"
,"5":"ei vero, qui non operatur, sed credit in eum, qui iustificat impium, reputatur fides eius ad iustitiam,"
,"6":"sicut et David dicit beatitudinem hominis, cui Deus reputat iustitiam sine operibus:"
,"7":"' Beati, quorum remissae sunt iniquitates, et quorum tecta sunt peccata."
,"8":"Beatus vir, cui non imputabit Dominus peccatum '."
,"9":"Beatitudo ergo haec in circumcisione an etiam in praeputio? Dicimus enim: ' Reputata est Abrahae fides ad iustitiam '."
,"10":"Quomodo ergo reputata est? In circumcisione an in praeputio? Non in circumcisione sed in praeputio:"
,"11":"et signum accepit circumcisionis, signaculum iustitiae fidei, quae fuit in praeputio, ut esset pater omnium credentium per praeputium, ut reputetur illis iustitia,"
,"12":"et pater circumcisionis his non tantum, qui ex circumcisione sunt, sed et qui sectantur vestigia eius, quae fuit in praeputio, fidei patris nostri Abrahae."
,"13":"Non enim per legem promissio Abrahae aut semini eius, ut heres esset mundi, sed per iustitiam fidei;"
,"14":"si enim qui ex lege heredes sunt, exinanita est fides, et abolita est promissio."
,"15":"Lex enim iram operatur; ubi autem non est lex, nec praevaricatio."
,"16":"Ideo ex fide, ut secundum gratiam, ut firma sit promissio omni semini, non ei, qui ex lege est solum, sed et ei, qui ex fide est Abrahae - qui est pater omnium nostrum,"
,"17":"sicut scriptum est: ' Patrem multarum gentium posui te ' C, ante Deum, cui credidit, qui vivificat mortuos et vocat ea, quae non sunt, quasi sint;"
,"18":"qui contra spem in spe credidit, ut fieret pater multarum gentium, secundum quod dictum est: ' Sic erit semen tuum '."
,"19":"Et non infirmatus fide consideravit corpus suum iam emortuum, cum fere centum annorum esset, et emortuam vulvam Sarae;"
,"20":"in repromissione autem Dei non haesitavit diffidentia, sed confortatus est fide, dans gloriam Deo,"
,"21":"et plenissime sciens quia, quod promisit, potens est et facere."
,"22":"Ideo et reputatum est illi ad iustitiam."
,"23":"Non est autem scriptum tantum propter ipsum: reputatum est illi,"
,"24":"sed et propter nos, quibus reputabitur, credentibus in eum, qui suscitavit Iesum Dominum nostrum a mortuis,"
,"25":"qui traditus est propter delicta nostra et suscitatus est propter iustificationem nostram."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Iustificati igitur ex fide, pacem habemus ad Deum per Domi num nostrum Iesum Christum,"
,"2":"per quem et accessum habemus fide in gratiam istam, in qua stamus et gloriamur in spe gloriae Dei."
,"3":"Non solum autem, sed et gloriamur in tribulationibus, scientes quod tribulatio patientiam operatur,"
,"4":"patientia autem probationem, probatio vero spem;"
,"5":"spes autem non confundit, quia caritas Dei diffusa est in cordibus nostris per Spiritum Sanctum, qui datus est nobis."
,"6":"Adhuc enim Christus, cum adhuc infirmi essemus, secundum tempus pro impiis mortuus est."
,"7":"Vix enim pro iusto quis moritur; nam pro bono forsitan quis et audeat mori."
,"8":"Commendat autem suam caritatem Deus in nos, quoniam, cum adhuc peccatores essemus, Christus pro nobis mortuus est."
,"9":"Multo igitur magis iustificati nunc in sanguine ipsius, salvi erimus ab ira per ipsum!"
,"10":"Si enim, cum inimici essemus, reconciliati sumus Deo per mortem Filii eius, multo magis reconciliati salvi erimus in vita ipsius;"
,"11":"non solum autem, sed et gloriamur in Deo per Dominum nostrum Iesum Christum, per quem nunc reconciliationem accepimus."
,"12":"Propterea, sicut per unum hominem peccatum in hunc mundum intravit, et per peccatum mors, et ita in omnes homines mors pertransiit, eo quod omnes peccaverunt."
,"13":"Usque ad legem enim peccatum erat in mundo; peccatum autem non imputatur, cum lex non est,"
,"14":"sed regnavit mors ab Adam usque ad Moysen etiam in eos, qui non peccaverunt in similitudine praevaricationis Adae, qui est figura futuri."
,"15":"Sed non sicut delictum, ita et donum; si enim unius delicto multi mortui sunt, multo magis gratia Dei et donum in gratia unius hominis Iesu Christi in multos abundavit."
,"16":"Et non sicut per unum, qui peccavit, ita et donum; nam iudicium ex uno in condemnationem, gratia autem ex multis delictis in iustificationem."
,"17":"Si enim unius delicto mors regnavit per unum, multo magis, qui abundantiam gratiae et donationis iustitiae accipiunt, in vita regnabunt per unum Iesum Christum."
,"18":"Igitur sicut per unius delictum in omnes homines in condemnationem, sic et per unius iustitiam in omnes homines in iustificationem vitae;"
,"19":"sicut enim per inoboedientiam unius hominis peccatores constituti sunt multi, ita et per unius oboeditionem iusti constituentur multi."
,"20":"Lex autem subintravit, ut abundaret delictum; ubi autem abundavit peccatum, superabundavit gratia,"
,"21":"ut sicut regnavit peccatum in morte, ita et gratia regnet per iustitiam in vitam aeternam per Iesum Christum Dominum nostrum."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Quid ergo dicemus? Perma nebimus in peccato, ut gratia abundet?"
,"2":"Absit! Qui enim mortui sumus peccato, quomodo adhuc vivemus in illo?"
,"3":"An ignoratis quia, quicumque baptizati sumus in Christum Iesum, in mortem ipsius baptizati sumus?"
,"4":"Consepulti ergo sumus cum illo per baptismum in mortem, ut quemadmodum suscitatus est Christus a mortuis per gloriam Patris, ita et nos in novitate vitae ambulemus."
,"5":"Si enim complantati facti sumus similitudini mortis eius, sed et resurrectionis erimus;"
,"6":"hoc scientes quia vetus homo noster simul crucifixus est, ut destruatur corpus peccati, ut ultra non serviamus peccato."
,"7":"Qui enim mortuus est, iustificatus est a peccato."
,"8":"Si autem mortui sumus cum Christo, credimus quia simul etiam vivemus cum eo;"
,"9":"scientes quod Christus suscitatus ex mortuis iam non moritur, mors illi ultra non dominatur."
,"10":"Quod enim mortuus est, peccato mortuus est semel; quod autem vivit, vivit Deo."
,"11":"Ita et vos existimate vos mortuos quidem esse peccato, viventes autem Deo in Christo Iesu."
,"12":"Non ergo regnet peccatum in vestro mortali corpore, ut oboediatis concupiscentiis eius,"
,"13":"neque exhibeatis membra vestra arma iniustitiae peccato, sed exhibete vos Deo tamquam ex mortuis viventes et membra vestra arma iustitiae Deo."
,"14":"Peccatum enim vobis non dominabitur; non enim sub lege estis sed sub gratia."
,"15":"Quid ergo? Peccabimus, quoniam non sumus sub lege sed sub gratia? Absit!"
,"16":"Nescitis quoniam, cui exhibetis vos servos ad oboedientiam, servi estis eius, cui oboeditis, sive peccati ad mortem, sive oboeditionis ad iustitiam?"
,"17":"Gratias autem Deo quod fuistis servi peccati, oboedistis autem ex corde in eam formam doctrinae, in quam traditi estis,"
,"18":"liberati autem a peccato servi facti estis iustitiae."
,"19":"Humanum dico propter infirmitatem carnis vestrae. Sicut enim exhibuistis membra vestra servientia immunditiae et iniquitati ad iniquitatem, ita nunc exhibete membra vestra servientia iustitiae ad sanctificationem."
,"20":"Cum enim servi essetis peccati, liberi eratis iustitiae."
,"21":"Quem ergo fructum habebatis tunc, in quibus nunc erubescitis? Nam finis illorum mors!"
,"22":"Nunc vero liberati a peccato, servi autem facti Deo, habetis fructum vestrum in sanctificationem, finem vero vitam aeternam!"
,"23":"Stipendia enim peccati mors, donum autem Dei vita aeterna in Christo Iesu Domino nostro."
}`)
	CurrentBook.AddChapter(7, `{
"1":"An ignoratis, fratres - scienti bus enim legem loquor - quia lex in homine dominatur, quanto tempore vivit?"
,"2":"Nam quae sub viro est mulier, viventi viro alligata est lege; si autem mortuus fuerit vir, soluta est a lege viri."
,"3":"Igitur, vivente viro, vocabitur adultera, si fuerit alterius viri; si autem mortuus fuerit vir, libera est a lege, ut non sit adultera, si fuerit alterius viri."
,"4":"Itaque, fratres mei, et vos mortificati estis legi per corpus Christi, ut sitis alterius, eius qui ex mortuis suscitatus est, ut fructificaremus Deo."
,"5":"Cum enim essemus in carne, passiones peccatorum, quae per legem sunt, operabantur in membris nostris, ut fructificarent morti;"
,"6":"nunc autem soluti sumus a lege, mortui ei, in qua detinebamur, ita ut serviamus in novitate Spiritus et non in vetustate litterae."
,"7":"Quid ergo dicemus? Lex peccatum est? Absit! Sed peccatum non cognovi, nisi per legem; nam concupiscentiam nescirem, nisi lex diceret: ' Non concupisces '."
,"8":"Occasione autem accepta, peccatum per mandatum operatum est in me omnem concupiscentiam; sine lege enim peccatum mortuum erat."
,"9":"Ego autem vivebam sine lege aliquando; sed, cum venisset mandatum, peccatum revixit,"
,"10":"ego autem mortuus sum; et inventum est mihi mandatum, quod erat ad vitam, hoc esse ad mortem;"
,"11":"nam peccatum, occasione accepta, per mandatum seduxit me et per illud occidit."
,"12":"Itaque lex quidem sancta, et mandatum sanctum et iustum et bonum."
,"13":"Quod ergo bonum est, mihi factum est mors? Absit! Sed peccatum, ut appareat peccatum, per bonum mihi operatum est mortem; ut fiat supra modum peccans peccatum per mandatum."
,"14":"Scimus enim quod lex spiritalis est; ego autem carnalis sum, venumdatus sub peccato."
,"15":"Quod enim operor, non intellego; non enim, quod volo, hoc ago, sed quod odi, illud facio."
,"16":"Si autem, quod nolo, illud facio, consentio legi quoniam bona."
,"17":"Nunc autem iam non ego operor illud, sed, quod habitat in me, peccatum."
,"18":"Scio enim quia non habitat in me, hoc est in carne mea, bonum; nam velle adiacet mihi, operari autem bonum, non!"
,"19":"Non enim, quod volo bonum, facio, sed, quod nolo malum, hoc ago."
,"20":"Si autem, quod nolo, illud facio, iam non ego operor illud, sed, quod habitat in me, peccatum."
,"21":"Invenio igitur hanc legem volenti mihi facere bonum, quoniam mihi malum adiacet."
,"22":"Condelector enim legi Dei secundum interiorem hominem;"
,"23":"video autem aliam legem in membris meis repugnantem legi mentis meae et captivantem me in lege peccati, quae est in membris meis."
,"24":"Infelix ego homo! Quis me liberabit de corpore mortis huius?"
,"25":"Gratias autem Deo per Iesum Christum Dominum nostrum! Igitur ego ipse mente servio legi Dei, carne autem legi peccati."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Nihil ergo nunc damnationis est his, qui sunt in Christo Iesu;"
,"2":"lex enim Spiritus vitae in Christo Iesu liberavit te a lege peccati et mortis."
,"3":"Nam, quod impossibile erat legi, in quo infirmabatur per carnem, Deus Filium suum mittens in similitudine carnis peccati et pro peccato, damnavit peccatum in carne,"
,"4":"ut iustitia legis impleretur in nobis, qui non secundum carnem ambulamus sed secundum Spiritum."
,"5":"Qui enim secundum carnem sunt, quae carnis sunt, sapiunt; qui vero secundum Spiritum, quae sunt Spiritus."
,"6":"Nam sapientia carnis mors, sapientia autem Spiritus vita et pax;"
,"7":"quoniam sapientia carnis inimicitia est in Deum, legi enim Dei non subicitur nec enim potest."
,"8":"Qui autem in carne sunt, Deo placere non possunt."
,"9":"Vos autem in carne non estis sed in Spiritu, si tamen Spiritus Dei habitat in vobis. Si quis autem Spiritum Christi non habet, hic non est eius."
,"10":"Si autem Christus in vobis est, corpus quidem mortuum est propter peccatum, Spiritus vero vita propter iustitiam."
,"11":"Quod si Spiritus eius, qui suscitavit Iesum a mortuis, habitat in vobis, qui suscitavit Christum a mortuis vivificabit et mortalia corpora vestra per inhabitantem Spiritum suum in vobis."
,"12":"Ergo, fratres, debitores sumus non carni, ut secundum carnem vivamus."
,"13":"Si enim secundum carnem vixeritis, moriemini; si autem Spiritu opera corporis mortificatis, vivetis."
,"14":"Quicumque enim Spiritu Dei aguntur, hi filii Dei sunt."
,"15":"Non enim accepistis spiritum servitutis iterum in timorem, sed accepistis Spiritum adoptionis filiorum, in quo clamamus: ' Abba, Pater! '."
,"16":"Ipse Spiritus testimonium reddit una cum spiritu nostro, quod sumus filii Dei."
,"17":"Si autem filii, et heredes: heredes quidem Dei, coheredes autem Christi, si tamen compatimur, ut et conglorificemur."
,"18":"Existimo enim quod non sunt condignae passiones huius temporis ad futuram gloriam, quae revelanda est in nobis."
,"19":"Nam exspectatio creaturae revelationem filiorum Dei exspectat;"
,"20":"vanitati enim creatura subiecta est, non volens sed propter eum, qui subiecit, in spem,"
,"21":"quia et ipsa creatura liberabitur a servitute corruptionis in libertatem gloriae filiorum Dei."
,"22":"Scimus enim quod omnis creatura congemiscit et comparturit usque adhuc;"
,"23":"non solum autem, sed et nos ipsi primitias Spiritus habentes, et ipsi intra nos gemimus adoptionem filiorum exspectantes, redemptionem corporis nostri."
,"24":"Spe enim salvi facti sumus; spes autem, quae videtur, non est spes; nam, quod videt, quis sperat?"
,"25":"Si autem, quod non videmus, speramus, per patientiam exspectamus."
,"26":"Similiter autem et Spiritus adiuvat infirmitatem nostram; nam quid oremus, sicut oportet, nescimus, sed ipse Spiritus interpellat gemitibus inenarrabilibus;"
,"27":"qui autem scrutatur corda, scit quid desideret Spiritus, quia secundum Deum postulat pro sanctis."
,"28":"Scimus autem quoniam diligentibus Deum omnia cooperantur in bonum, his, qui secundum propositum vocati sunt."
,"29":"Nam, quos praescivit, et praedestinavit conformes fieri imaginis Filii eius, ut sit ipse primogenitus in multis fratribus;"
,"30":"quos autem praedestinavit, hos et vocavit; et quos vocavit, hos et iustificavit; quos autem iustificavit, illos et glorificavit."
,"31":"Quid ergo dicemus ad haec? Si Deus pro nobis, quis contra nos?"
,"32":"Qui Filio suo non pepercit, sed pro nobis omnibus tradidit illum, quomodo non etiam cum illo omnia nobis donabit?"
,"33":"Quis accusabit adversus electos Dei? Deus, qui iustificat?"
,"34":"Quis est qui condemnet? Christus Iesus, qui mortuus est, immo qui suscitatus est, qui et est ad dexteram Dei, qui etiam interpellat pro nobis?"
,"35":"Quis nos separabit a caritate Christi? Tribulatio an angustia an persecutio an fames an nuditas an periculum an gladius?"
,"36":"Sicut scriptum est: ' Propter te mortificamur tota die, aestimati sumus ut oves occisionis '."
,"37":"Sed in his omnibus supervincimus per eum, qui dilexit nos."
,"38":"Certus sum enim quia neque mors neque vita neque angeli neque principatus neque instantia neque futura neque virtutes"
,"39":"neque altitudo neque profundum neque alia quaelibet creatura poterit nos separare a caritate Dei, quae est in Christo Iesu Domino nostro."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Veritatem dico in Christo, non mentior, testimonium mihi per hibente conscientia mea in Spiritu Sancto,"
,"2":"quoniam tristitia est mihi magna, et continuus dolor cordi meo."
,"3":"Optarem enim ipse ego anathema esse a Christo pro fratribus meis, cognatis meis secundum carnem,"
,"4":"qui sunt Israelitae, quorum adoptio est filiorum et gloria et testamenta et legislatio et cultus et promissiones,"
,"5":"quorum sunt patres, et ex quibus Christus secundum carnem: qui est super omnia Deus benedictus in saecula. Amen."
,"6":"Non autem quod exciderit verbum Dei. Non enim omnes, qui ex Israel, hi sunt Israel;"
,"7":"neque quia semen sunt Abrahae, omnes filii, sed: ' In Isaac vocabitur tibi semen '."
,"8":"Id est, non qui filii carnis, hi filii Dei, sed qui filii sunt promissionis, aestimantur semen;"
,"9":"promissionis enim verbum hoc est: ' Secundum hoc tempus veniam, et erit Sarae filius '."
,"10":"Non solum autem, sed et Rebecca ex uno concubitum habens, Isaac patre nostro;"
,"11":"cum enim nondum nati fuissent aut aliquid egissent bonum aut malum, ut secundum electionem propositum Dei maneret,"
,"12":"non ex operibus sed ex vocante dictum est ei: ' Maior serviet minori ';"
,"13":"sicut scriptum est: ' Iacob dilexi, Esau autem odio habui '."
,"14":"Quid ergo dicemus? Numquid iniustitia apud Deum? Absit!"
,"15":"Moysi enim dicit: ' Miserebor, cuius misereor, et misericordiam praestabo, cui misericordiam praesto '."
,"16":"Igitur non volentis neque currentis sed miserentis Dei."
,"17":"Dicit enim Scriptura pharaoni: ' In hoc ipsum excitavi te, ut ostendam in te virtutem meam, et ut annuntietur nomen meum in universa terra '."
,"18":"Ergo, cuius vult, miseretur et, quem vult, indurat."
,"19":"Dices itaque mihi: ' Quid ergo adhuc queritur? Voluntati enim eius quis restitit? '."
,"20":"O homo, sed tu quis es, qui respondeas Deo? Numquid dicet figmentum ei, qui se finxit: ' Quid me fecisti sic? '."
,"21":"An non habet potestatem figulus luti ex eadem massa facere aliud quidem vas in honorem, aliud vero in ignominiam?"
,"22":"Quod si volens Deus ostendere iram et notam facere potentiam suam, sustinuit in multa patientia vasa irae aptata in interitum;"
,"23":"et ut ostenderet divitias gloriae suae in vasa misericordiae, quae praeparavit in gloriam,"
,"24":"quos et vocavit nos non solum ex Iudaeis sed etiam ex gentibus?"
,"25":"Sicut et in Osee dicit: ' Vocabo Non plebem meam Plebem meam,et Non dilectam Dilectam. "
,"26":"Et erit: in loco, ubi dictum est eis: 'Non plebs mea vos', ibi vocabuntur Filii Dei vivi '."
,"27":"Isaias autem clamat pro Israel: ' Si fuerit numerus filiorum Israel tamquam arena maris, reliquiae salvae fient."
,"28":"Verbum enim consummans et brevians faciet Dominus super terram '."
,"29":"Et sicut praedixit Isaias: ' Nisi Dominus Sabaoth reliquisset nobis semen, sicut Sodoma facti essemus,et sicut Gomorra similes fuissemus '."
,"30":"Quid ergo dicemus? Quod gentes, quae non sectabantur iustitiam, apprehenderunt iustitiam, iustitiam autem, quae ex fide est;"
,"31":"Israel vero sectans legem iustitiae in legem non pervenit."
,"32":"Quare? Quia non ex fide sed quasi ex operibus; offenderunt in lapidem offensionis,"
,"33":"sicut scriptum est: ' Ecce pono in Sion lapidem offensionis et petram scandali; et, qui credit in eo, non confundetur '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Fratres, voluntas quidem cordis mei et obsecratio ad Deum pro illis in salutem."
,"2":"Testimonium enim perhibeo illis quod aemulationem Dei habent sed non secundum scientiam;"
,"3":"ignorantes enim Dei iustitiam et suam iustitiam quaerentes statuere, iustitiae Dei non sunt subiecti;"
,"4":"finis enim legis Christus ad iustitiam omni credenti."
,"5":"Moyses enim scribit de iustitia, quae ex lege est: ' Qui fecerit homo, vivet in eis '."
,"6":"Quae autem ex fide est iustitia, sic dicit: ' Ne dixeris in corde tuo: Quis ascendet in caelum?', id est Christum deducere;"
,"7":"aut: ' Quis descendet in abyssum? ', hoc est Christum ex mortuis revocare."
,"8":"Sed quid dicit? ' Prope te est verbum, in ore tuo et in corde tuo '; hoc est verbum fidei, quod praedicamus."
,"9":"Quia si confitearis in ore tuo: ' Dominum Iesum! ', et in corde tuo credideris quod Deus illum excitavit ex mortuis, salvus eris."
,"10":"Corde enim creditur ad iustitiam, ore autem confessio fit in salutem."
,"11":"Dicit enim Scriptura: ' Omnis, qui credit in illo, non confundetur '."
,"12":"Non enim est distinctio Iudaei et Graeci, nam idem Dominus omnium, dives in omnes, qui invocant illum:"
,"13":"Omnis enim, quicumque invocaverit nomen Domini, salvus erit."
,"14":"Quomodo ergo invocabunt, in quem non crediderunt? Aut quomodo credent ei, quem non audierunt? Quomodo autem audient sine praedicante?"
,"15":"Quomodo vero praedicabunt nisi mittantur? Sicut scriptum est: ' Quam speciosi pedes evangelizantium bona '."
,"16":"Sed non omnes oboedierunt evangelio; Isaias enim dicit: ' Domine, quis credidit auditui nostro? '. "
,"17":"Ergo fides ex auditu, auditus autem per verbum Christi."
,"18":"Sed dico: Numquid non audierunt? Quin immo, in omnem terram exiit sonus eorum, et in fines orbis terrae verba eorum."
,"19":"Sed dico: Numquid Israel non cognovit? Primus Moyses dicit: ' Ego ad aemulationem vos adducam per Non gentem: per gentem insipientem ad iram vos provocabo '."
,"20":"Isaias autem audet et dicit: ' Inventus sum in non quaerentibus me; palam apparui his, qui me non interrogabant '."
,"21":"Ad Israel autem dicit: ' Tota die expandi manus meas ad populum non credentem et contradicentem '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Dico ergo: Numquid repulit Deus populum suum? Absit! Nam et ego Israelita sum, ex semine Abraham, tribu Beniamin."
,"2":"Non reppulit Deus plebem suam, quam praescivit. An nescitis in Elia quid dicit Scriptura? Quemadmodum interpellat Deum adversus Israel:"
,"3":"' Domine, prophetas tuos occiderunt, altaria tua suffoderunt, et ego relictus sum solus, et quaerunt animam meam '."
,"4":"Sed quid dicit illi responsum divinum?,' Reliqui mihi septem milia virorum, qui non curvaverunt genu Baal '."
,"5":"Sic ergo et in hoc tempore reliquiae secundum electionem gratiae factae sunt."
,"6":"Si autem gratia, iam non ex operibus, alioquin gratia iam non est gratia."
,"7":"Quid ergo? Quod quaerit Israel, hoc non est consecutus, electio autem consecuta est; ceteri vero excaecati sunt,"
,"8":"sicut scriptum est: ' Dedit illis Deus spiritum soporis, oculos, ut non videant, et aures, ut non audiant, usque in hodiernum diem '."
,"9":"Et David dicit: ' Fiat mensa eorum in laqueum et in captionem,et in scandalum et in retributionem illis. "
,"10":"Obscurentur oculi eorum, ne videant, et dorsum illorum semper incurva! '."
,"11":"Dico ergo: Numquid sic offenderunt, ut caderent? Absit! Sed illorum casu salus gentibus, ut illi ad aemulationem adducantur."
,"12":"Quod si casus illorum divitiae sunt mundi, et deminutio eorum divitiae gentium, quanto magis plenitudo eorum!"
,"13":"Vobis autem dico gentibus: Quantum quidem ego sum gentium apostolus, ministerium meum honorifico,"
,"14":"si quo modo ad aemulandum provocem carnem meam et salvos faciam aliquos ex illis."
,"15":"Si enim amissio eorum reconciliatio est mundi, quae assumptio, nisi vita ex mortuis?"
,"16":"Quod si primitiae sanctae sunt, et massa; et si radix sancta, et rami."
,"17":"Quod si aliqui ex ramis fracti sunt, tu autem, cum oleaster esses, insertus es in illis et consocius radicis pinguedinis olivae factus es,"
,"18":"noli gloriari adversus ramos; quod si gloriaris, non tu radicem portas, sed radix te."
,"19":"Dices ergo: ' Fracti sunt rami, ut ego inserar '."
,"20":"Bene; incredulitate fracti sunt, tu autem fide stas. Noli altum sapere, sed time:"
,"21":"si enim Deus naturalibus ramis non pepercit, ne forte nec tibi parcat."
,"22":"Vide ergo bonitatem et severitatem Dei: in eos quidem, qui ceciderunt, severitatem; in te autem bonitatem Dei, si permanseris in bonitate, alioquin et tu excideris."
,"23":"Sed et illi, si non permanserint in incredulitate, inserentur; potens est enim Deus iterum inserere illos!"
,"24":"Nam si tu ex naturali excisus es oleastro et contra naturam insertus es in bonam olivam, quanto magis hi, qui secundum naturam sunt, inserentur suae olivae."
,"25":"Nolo enim vos ignorare, fratres, mysterium hoc, ut non sitis vobis ipsis sapientes, quia caecitas ex parte contigit in Israel, donec plenitudo gentium intraret,"
,"26":"et sic omnis Israel salvus fiet, sicut scriptum est: ' Veniet ex Sion, qui eripiat, avertet impietates ab Iacob;"
,"27":"et hoc illis a me testamentum, cum abstulero peccata eorum '."
,"28":"Secundum evangelium quidem inimici propter vos, secundum electionem autem carissimi propter patres;"
,"29":"sine paenitentia enim sunt dona et vocatio Dei!"
,"30":"Sicut enim aliquando vos non credidistis Deo, nunc autem misericordiam consecuti estis propter illorum incredulitatem,"
,"31":"ita et isti nunc non crediderunt propter vestram misericordiam, ut et ipsi nunc misericordiam consequantur."
,"32":"Conclusit enim Deus omnes in incredulitatem, ut omnium misereatur!"
,"33":"O altitudo divitiarum et sapientiae et scientiae Dei! Quam incomprehensibilia sunt iudicia eius, et investigabiles viae eius!"
,"34":"Quis enim cognovit sensum Domini?,Aut quis consiliarius eius fuit?"
,"35":"Aut quis prior dedit illi, et retribuetur ei?"
,"36":"Quoniam ex ipso et per ipsum et in ipsum omnia. Ipsi gloria in saecula. Amen."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Obsecro itaque vos, fratres, per misericordiam Dei, ut exhibeatis corpora vestra hostiam viventem, sanctam, Deo placentem, rationabile obsequium vestrum;"
,"2":"et nolite conformari huic saeculo, sed transformamini renovatione mentis, ut probetis quid sit voluntas Dei, quid bonum et bene placens et perfectum."
,"3":"Dico enim per gratiam, quae data est mihi, omnibus, qui sunt inter vos, non altius sapere quam oportet sapere, sed sapere ad sobrietatem, unicuique sicut Deus divisit mensuram fidei."
,"4":"Sicut enim in uno corpore multa membra habemus, omnia autem membra non eundem actum habent,"
,"5":"ita multi unum corpus sumus in Christo, singuli autem alter alterius membra."
,"6":"Habentes autem donationes secundum gratiam, quae data est nobis, differentes: sive prophetiam, secundum rationem fidei;"
,"7":"sive ministerium, in ministrando; sive qui docet, in doctrina;"
,"8":"sive qui exhortatur, in exhortando; qui tribuit, in simplicitate; qui praeest, in sollicitudine; qui miseretur, in hilaritate."
,"9":"Dilectio sine simulatione. Odientes malum, adhaerentes bono;"
,"10":"caritate fraternitatis invicem diligentes, honore invicem praevenientes,"
,"11":"sollicitudine non pigri, spiritu ferventes, Domino servientes,"
,"12":"spe gaudentes, in tribulatione patientes, orationi instantes,"
,"13":"necessitatibus sanctorum communicantes, hospitalitatem sectantes."
,"14":"Benedicite persequentibus; benedicite et nolite maledicere!"
,"15":"Gaudere cum gaudentibus, flere cum flentibus."
,"16":"Idipsum invicem sentientes, non alta sapientes, sed humilibus consentientes. Nolite esse prudentes apud vosmetipsos."
,"17":"Nulli malum pro malo reddentes; providentes bona coram omnibus hominibus;"
,"18":"si fieri potest, quod ex vobis est, cum omnibus hominibus pacem habentes;"
,"19":"non vosmetipsos vindicantes, carissimi, sed date locum irae, scriptum est enim: ' Mihi vindicta, ego retribuam ', dicit Dominus."
,"20":"Sed si esurierit inimicus tuus, ciba illum; si sitit, potum da illi. Hoc enim faciens, carbones ignis congeres super caput eius."
,"21":"Noli vinci a malo, sed vince in bono malum."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Omnis anima potestatibus sublimioribus subdita sit. Non est enim potestas nisi a Deo; quae autem sunt, a Deo ordinatae sunt."
,"2":"Itaque, qui resistit potestati, Dei ordinationi resistit; qui autem resistunt ipsi, sibi damnationem acquirent."
,"3":"Nam principes non sunt timori bono operi sed malo. Vis autem non timere potestatem? Bonum fac, et habebis laudem ex illa;"
,"4":"Dei enim ministra est tibi in bonum. Si autem malum feceris, time; non enim sine causa gladium portat; Dei enim ministra est, vindex in iram ei, qui malum agit."
,"5":"Ideo necesse est subditos esse, non solum propter iram sed et propter conscientiam."
,"6":"Ideo enim et tributa praestatis; ministri enim Dei sunt in hoc ipsum instantes."
,"7":"Reddite omnibus debita: cui tributum tributum, cui vectigal vectigal, cui timorem timorem, cui honorem honorem."
,"8":"Nemini quidquam debeatis, nisi ut invicem diligatis: qui enim diligit proximum, legem implevit."
,"9":"Nam: Non adulterabis, Non occides, Non furaberis, Non concupisces, et si quod est aliud mandatum, in hoc verbo recapitulatur: Diliges proximum tuum tamquam teipsum."
,"10":"Dilectio proximo malum non operatur; plenitudo ergo legis est dilectio."
,"11":"Et hoc scientes tempus, quia hora est iam vos de somno surgere; nunc enim propior est nobis salus quam cum credidimus."
,"12":"Nox processit, dies autem appropiavit. Abiciamus ergo opera tenebrarum et induamur arma lucis."
,"13":"Sicut in die honeste ambulemus: non in comissationibus et ebrietatibus, non in cubilibus et impudicitiis, non in contentione et aemulatione;"
,"14":"sed induite Dominum Iesum Christum et carnis curam ne feceritis in concupiscentiis."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Infirmum autem in fide assumite, non in disceptatio nibus cogitationum."
,"2":"Alius enim credit manducare omnia; qui autem infirmus est, holus manducat."
,"3":"Is qui manducat, non manducantem non spernat; et, qui non manducat, manducantem non iudicet, Deus enim illum assumpsit."
,"4":"Tu quis es, qui iudices alienum servum? Suo domino stat aut cadit; stabit autem, potens est enim Dominus statuere illum."
,"5":"Nam alius iudicat inter diem et diem, alius iudicat omnem diem; unusquisque in suo sensu abundet."
,"6":"Qui sapit diem, Domino sapit; et, qui manducat, Domino manducat, gratias enim agit Deo; et, qui non manducat, Domino non manducat et gratias agit Deo."
,"7":"Nemo enim nostrum sibi vivit, et nemo sibi moritur; 8 sive enim vivimus, Domino vivimus, sive morimur, Domino morimur. Sive ergo vivimus, sive morimur, Domini sumus."
,"9":"In hoc enim Christus et mortuus est et vixit, ut et mortuorum et vivorum dominetur."
,"10":"Tu autem, quid iudicas fratrem tuum? Aut tu, quare spernis fratrem tuum? Omnes enim stabimus ante tribunal Dei;"
,"11":"scriptum est enim: ' Vivo ego, dicit Dominus, mihi flectetur omne genu, et omnis lingua confitebitur Deo '."
,"12":"Itaque unusquisque nostrum pro se rationem reddet Deo."
,"13":"Non ergo amplius invicem iudicemus, sed hoc iudicate magis, ne ponatis offendiculum fratri vel scandalum."
,"14":"Scio et certus sum in Domino Iesu, quia nihil commune per seipsum, nisi ei, qui existimat quid commune esse, illi commune est."
,"15":"Si enim propter cibum frater tuus contristatur, iam non secundum caritatem ambulas. Noli cibo tuo illum perdere, pro quo Christus mortuus est!"
,"16":"Non ergo blasphemetur bonum vestrum!"
,"17":"Non est enim regnum Dei esca et potus, sed iustitia et pax et gaudium in Spiritu Sancto;"
,"18":"qui enim in hoc servit Christo, placet Deo et probatus est hominibus."
,"19":"Itaque, quae pacis sunt, sectemur et quae aedificationis sunt in invicem."
,"20":"Noli propter escam destruere opus Dei! Omnia quidem munda sunt, sed malum est homini, qui per offendiculum manducat."
,"21":"Bonum est non manducare carnem et non bibere vinum neque id, in quo frater tuus offendit."
,"22":"Tu, quam fidem habes, penes temetipsum habe coram Deo. Beatus, qui non iudicat semetipsum in eo quod probat."
,"23":"Qui autem discernit si manducaverit, damnatus est, quia non ex fide; omne autem, quod non ex fide, peccatum est."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Debemus autem nos fir miores imbecillitates infir morum sustinere et non nobis placere."
,"2":"Unusquisque nostrum proximo placeat in bonum ad aedificationem;"
,"3":"etenim Christus non sibi placuit, sed sicut scriptum est: ' Improperia improperantium tibi ceciderunt super me '."
,"4":"Quaecumque enim antea scripta sunt, ad nostram doctrinam scripta sunt, ut per patientiam et consolationem Scripturarum spem habeamus."
,"5":"Deus autem patientiae et solacii det vobis idipsum sapere in alterutrum secundum Christum Iesum,"
,"6":"ut unanimes uno ore glorificetis Deum et Patrem Domini nostri Iesu Christi."
,"7":"Propter quod suscipite invicem, sicut et Christus suscepit vos, in gloriam Dei."
,"8":"Dico enim Christum ministrum fuisse circumcisionis propter veritatem Dei ad confirmandas promissiones patrum;"
,"9":"gentes autem propter misericordiam glorificare Deum, sicut scriptum est: ' Propter hoc confitebor tibi in gentibus et nomini tuo cantabo '."
,"10":"Et iterum dicit: ' Laetamini, gentes, cum plebe eius '."
,"11":"Et iterum: ' Laudate, omnes gentes, Dominum, et magnificent eum omnes populi '."
,"12":"Et rursus Isaias ait: ' Erit radix Iesse, et qui exsurget regere gentes: in eo gentes sperabunt '."
,"13":"Deus autem spei repleat vos omni gaudio et pace in credendo, ut abundetis in spe in virtute Spiritus Sancti."
,"14":"Certus sum autem, fratres mei, et ego ipse de vobis, quoniam et ipsi pleni estis bonitate, repleti omni scientia, ita ut possitis et alterutrum monere."
,"15":"Audacius autem scripsi vobis ex parte, tamquam in memoriam vos reducens propter gratiam, quae data est mihi a Deo,"
,"16":"ut sim minister Christi Iesu ad gentes, consecrans evangelium Dei, ut fiat oblatio gentium accepta, sanctificata in Spiritu Sancto."
,"17":"Habeo igitur gloriationem in Christo Iesu ad Deum;"
,"18":"non enim audebo aliquid loqui eorum, quae per me non effecit Christus in oboedientiam gentium, verbo et factis,"
,"19":"in virtute signorum et prodigiorum, in virtute Spiritus, ita ut ab Ierusalem et per circuitum usque in Illyricum repleverim evangelium Christi,"
,"20":"sic autem contendens praedicare evangelium, non ubi nominatus est Christus, ne super alienum fundamentum aedificarem,"
,"21":"sed sicut scriptum est: ' Quibus non est annuntiatum de eo, videbunt; et, qui non audierunt, intellegent '."
,"22":"Propter quod et impediebar plurimum venire ad vos;"
,"23":"nunc vero ulterius locum non habens in his regionibus, cupiditatem autem habens veniendi ad vos ex multis iam annis,"
,"24":"cum in Hispaniam proficisci coepero, spero enim quod praeteriens videam vos et a vobis deducar illuc, si vobis primum ex parte fruitus fuero."
,"25":"Nunc autem proficiscor in Ierusalem ministrare sanctis;"
,"26":"probaverunt enim Macedonia et Achaia communicationem aliquam facere in pauperes sanctorum, qui sunt in Ierusalem."
,"27":"Placuit enim eis, et debitores sunt eorum; nam si spiritalibus eorum communicaverunt gentes, debent et in carnalibus ministrare eis."
,"28":"Hoc igitur cum consummavero et assignavero eis fructum hunc, proficiscar per vos in Hispaniam;"
,"29":"scio autem quoniam veniens ad vos, in abundantia benedictionis Christi veniam."
,"30":"Obsecro autem vos, fratres, per Dominum nostrum Iesum Christum et per caritatem Spiritus, ut concertemini mecum in orationibus pro me ad Deum,"
,"31":"ut liberer ab infidelibus, qui sunt in Iudaea, et ministerium meum pro Ierusalem acceptum sit sanctis,"
,"32":"ut veniens ad vos in gaudio per voluntatem Dei refrigerer vobiscum."
,"33":"Deus autem pacis sit cum omnibus vobis. Amen."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Commendo autem vobis Phoebem sororem nostram, quae est ministra ecclesiae, quae est Cenchreis,"
,"2":"ut eam suscipiatis in Domino digne sanctis et assistatis ei in quocumque negotio vestri indiguerit; etenim ipsa astitit multis et mihi ipsi."
,"3":"Salutate Priscam et Aquilam adiutores meos in Christo Iesu,"
,"4":"qui pro anima mea suas cervices supposuerunt, quibus non solus ego gratias ago sed et cunctae ecclesiae gentium;"
,"5":"et domesticam eorum ecclesiam. Salutate Epaenetum dilectum mihi, primitias Asiae in Christo. "
,"6":"Salutate Mariam, quae multum laboravit in vobis."
,"7":"Salutate Andronicum et Iuniam cognatos meos et concaptivos meos, qui sunt nobiles in apostolis, qui et ante me fuerunt in Christo."
,"8":"Salutate Ampliatum dilectissimum mihi in Domino."
,"9":"Salutate Urbanum adiutorem nostrum in Christo et Stachyn dilectum meum."
,"10":"Salutate Apellem probatum in Christo. Salutate eos, qui sunt ex Aristobuli."
,"11":"Salutate Herodionem cognatum meum. Salutate eos, qui sunt ex Narcissi, qui sunt in Domino."
,"12":"Salutate Tryphaenam et Tryphosam, quae laborant in Domino. Salutate Persidam carissimam, quae multum laboravit in Domino."
,"13":"Salutate Rufum electum in Domino et matrem eius et meam."
,"14":"Salutate Asyncritum, Phlegonta, Hermen, Patrobam, Hermam et, qui cum eis sunt, fratres."
,"15":"Salutate Philologum et Iuliam, Nereum et sororem eius et Olympam et omnes, qui cum eis sunt, sanctos."
,"16":"Salutate invicem in osculo sancto. Salutant vos omnes ecclesiae Christi."
,"17":"Rogo autem vos, fratres, ut observetis eos, qui dissensiones et offendicula praeter doctrinam, quam vos didicistis, faciunt, et declinate ab illis;"
,"18":"huiusmodi enim Domino nostro Christo non serviunt sed suo ventri, et per dulces sermones et benedictiones seducunt corda innocentium."
,"19":"Vestra enim oboedientia ad omnes pervenit; gaudeo igitur in vobis, sed volo vos sapientes esse in bono et simplices in malo."
,"20":"Deus autem pacis conteret Satanam sub pedibus vestris velociter. Gratia Domini nostri Iesu vobiscum."
,"21":"Salutat vos Timotheus adiutor meus et Lucius et Iason et Sosipater cognati mei."
,"22":"Saluto vos ego Tertius, qui scripsi epistulam in Domino."
,"23":"Salutat vos Gaius hospes meus et universae ecclesiae. Salutat vos Erastus arcarius civitatis et Quartus frater. (24) 25 Ei autem, qui potens est vos confirmare iuxta evangelium meum et praedicationem Iesu Christi secundum revelationem mysterii temporibus aeternis taciti, "
,"26":"manifestati autem nunc, et per scripturas Prophetarum secundum praeceptum aeterni Dei ad oboeditionem fidei in cunctis gentibus patefacti,"
,"27":"soli sapienti Deo per Iesum Christum, cui gloria in saecula. Amen."
}`)

}
func LA_NVBSE_LoadNPTTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulus servus Dei, apostolus autem Iesu Christi secundum fi dem electorum Dei et agnitionem veritatis, quae secundum pietatem est"
,"2":"in spem vitae aeternae, quam promisit, qui non mentitur, Deus ante tempora saecularia;"
,"3":"manifestavit autem temporibus suis verbum suum in praedicatione, quae credita est mihi secundum praeceptum salvatoris nostri Dei,"
,"4":"Tito germano filio secundum communem fidem: gratia et pax a Deo Patre et Christo Iesu salvatore nostro."
,"5":"Huius rei gratia reliqui te Cretae, ut ea, quae desunt, corrigas et constituas per civitates presbyteros, sicut ego tibi disposui,"
,"6":"si quis sine crimine est, unius uxoris vir, filios habens fideles, non in accusatione luxuriae aut non subiectos."
,"7":"Oportet enim episcopum sine crimine esse sicut Dei dispensatorem, non superbum, non iracundum, non vinolentum, non percussorem, non turpis lucri cupidum,"
,"8":"sed hospitalem, benignum, sobrium, iustum, sanctum, continentem,"
,"9":"amplectentem eum, qui secundum doctrinam est, fidelem sermonem, ut potens sit et exhortari in doctrina sana et eos, qui contradicunt, arguere."
,"10":"Sunt enim multi et non subiecti, vaniloqui et seductores, maxime qui de circumcisione sunt,"
,"11":"quibus oportet silentium imponere, quia universas domos subvertunt docentes, quae non oportet, turpis lucri gratia."
,"12":"Dixit quidam ex illis, proprius ipsorum propheta: ' Cretenses semper mendaces, malae bestiae, ventres pigri '."
,"13":"Testimonium hoc verum est. Quam ob causam increpa illos dure, ut sani sint in fide,"
,"14":"non intendentes Iudaicis fabulis et mandatis hominum aversantium veritatem."
,"15":"Omnia munda mundis; coinquinatis autem et infidelibus nihil mundum, sed inquinatae sunt eorum et mens et conscientia."
,"16":"Confitentur se nosse Deum, factis autem negant, cum sunt abominati et inoboedientes et ad omne opus bonum reprobi."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tu autem loquere, quae decent sanam doctrinam."
,"2":"Senes, ut sobrii sint, pudici, prudentes, sani fide, dilectione, patientia."
,"3":"Anus similiter in habitu sanctae, non criminatrices, non vino multo deditae, bene docentes,"
,"4":"ut prudentiam doceant adulescentulas, ut viros suos ament, filios diligant,"
,"5":"prudentes sint, castae, domus curam habentes, benignae, subditae suis viris, ut non blasphemetur verbum Dei."
,"6":"Iuvenes similiter hortare, ut sobrii sint."
,"7":"In omnibus teipsum praebens exemplum bonorum operum, in doctrina integritatem, gravitatem,"
,"8":"in verbo sano irreprehensibilem, ut is, qui ex adverso est, vereatur, nihil habens malum dicere de nobis."
,"9":"Servos dominis suis subditos esse in omnibus, placentes esse, non contradicentes,"
,"10":"non fraudantes, sed omnem fidem bonam ostendentes, ut doctrinam salutaris nostri Dei ornent in omnibus."
,"11":"Apparuit enim gratia Dei salutaris omnibus hominibus"
,"12":"erudiens nos, ut abnegantes impietatem et saecularia desideria sobrie et iuste et pie vivamus in hoc saeculo,"
,"13":"exspectantes beatam spem et adventum gloriae magni Dei et salvatoris nostri Iesu Christi;"
,"14":"qui dedit semetipsum pro nobis, ut nos redimeret ab omni iniquitate et mundaret sibi populum peculiarem, sectatorem bonorum operum."
,"15":"Haec loquere et exhortare et argue cum omni imperio. Nemo te contemnat!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Admone illos principibus, pote statibus subditos esse, dicto oboedire, ad omne opus bonum paratos esse,"
,"2":"neminem blasphemare, non litigiosos esse, modestos, omnem ostendentes mansuetudinem ad omnes homines."
,"3":"Eramus enim et nos aliquando insipientes, inoboedientes, errantes, servientes concupiscentiis et voluptatibus variis, in malitia et invidia agentes, odibiles, odientes invicem."
,"4":"Cum autem benignitas et humanitas apparuit salvatoris nostri Dei,"
,"5":"non ex operibus iustitiae, quae fecimus nos, sed secundum suam misericordiam salvos nos fecit per lavacrum regenerationis et renovationis Spiritus Sancti,"
,"6":"quem effudit super nos abunde per Iesum Christum salvatorem nostrum,"
,"7":"ut iustificati gratia ipsius heredes simus secundum spem vitae aeternae."
,"8":"Fidelis sermo, et volo te de his confirmare, ut curent bonis operibus praeesse, qui crediderunt Deo. Haec sunt bona et utilia hominibus;"
,"9":"stultas autem quaestiones et genealogias et contentiones et pugnas circa legem devita, sunt enim inutiles et vanae."
,"10":"Haereticum hominem post unam et secundam correptionem devita,"
,"11":"sciens quia subversus est, qui eiusmodi est, et delinquit, proprio iudicio condemnatus."
,"12":"Cum misero ad te Artemam aut Tychicum, festina ad me venire Nicopolim; ibi enim statui hiemare."
,"13":"Zenam legis peritum et Apollo sollicite instrue, ut nihil illis desit."
,"14":"Discant autem et nostri bonis operibus praeesse ad usus necessarios, ut non sint infructuosi."
,"15":"Salutant te, qui mecum sunt, omnes. Saluta, qui nos amant in fide. Gratia cum omnibus vobis."
}`)

}
func LA_NVBSE_LoadNTAAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Primum quidem sermonem feci de omnibus, o Theophile, quae coepit Iesus facere et docere,"
,"2":"usque in diem, qua, cum praecepisset apostolis per Spiritum Sanctum, quos elegit, assumptus est;"
,"3":"quibus et praebuit seipsum vivum post passionem suam in multis argumentis, per dies quadraginta apparens eis et loquens ea, quae sunt de regno Dei."
,"4":"Et convescens praecepit eis ab Hierosolymis ne discederent, sed exspectarent promissionem Patris: ' Quam audistis a me,"
,"5":"quia Ioannes quidem baptizavit aqua, vos autem baptizabimini in Spiritu Sancto non post multos hos dies '."
,"6":"Igitur qui convenerant, interrogabant eum dicentes: ' Domine, si in tempore hoc restitues regnum Israeli? '."
,"7":"Dixit autem eis: ' Non est vestrum nosse tempora vel momenta, quae Pater posuit in sua potestate,"
,"8":"sed accipietis virtutem, superveniente Sancto Spiritu in vos, et eritis mihi testes et in Ierusalem et in omni Iudaea et Samaria et usque ad ultimum terrae '."
,"9":"Et cum haec dixisset, videntibus illis, elevatus est, et nubes suscepit eum ab oculis eorum."
,"10":"Cumque intuerentur in caelum, eunte illo, ecce duo viri astiterunt iuxta illos in vestibus albis,"
,"11":"qui et dixerunt: ' Viri Galilaei, quid statis aspicientes in caelum? Hic Iesus, qui assumptus est a vobis in caelum, sic veniet quemadmodum vidistis eum euntem in caelum '."
,"12":"Tunc reversi sunt in Ierusalem a monte, qui vocatur Oliveti, qui est iuxta Ierusalem sabbati habens iter."
,"13":"Et cum introissent, in cenaculum ascenderunt, ubi manebant et Petrus et Ioannes et Iacobus et Andreas, Philippus et Thomas, Bartholomaeus et Matthaeus, Iacobus Alphaei et Simon Zelotes et Iudas Iacobi."
,"14":"Hi omnes erant perseverantes unanimiter in oratione cum mulieribus et Maria matre Iesu et fratribus eius."
,"15":"Et in diebus illis exsurgens Petrus in medio fratrum dixit - erat autem turba hominum simul fere centum viginti C:"
,"16":"' Viri fratres, oportebat impleri Scripturam, quam praedixit Spiritus Sanctus per os David de Iuda, qui fuit dux eorum, qui comprehenderunt Iesum,"
,"17":"quia connumeratus erat in nobis et sortitus est sortem ministerii huius."
,"18":"Hic quidem possedit agrum de mercede iniquitatis; et pronus factus crepuit medius, et diffusa sunt omnia viscera eius."
,"19":"Et notum factum est omnibus habitantibus Ierusalem, ita ut appellaretur ager ille lingua eorum Aceldamach, hoc est ager Sanguinis."
,"20":"Scriptum est enim in libro Psalmorum: 'Fiat commoratío eius deserta, et non sit qui inhabitet in ea',et: 'Episcopatum eius accipiat alius'."
,"21":"Oportet ergo ex his viris, qui nobiscum congregati erant in omni tempore, quo intravit et exivit inter nos Dominus Iesus,"
,"22":"incipiens a baptismate Ioannis usque in diem, qua assumptus est a nobis, testem resurrectionis eius nobiscum fieri unum ex istis '."
,"23":"Et statuerunt duos, Ioseph, qui vocabatur Barsabbas, qui cognominatus est Iustus, et Matthiam."
,"24":"Et orantes dixerunt: ' Tu, Domine, qui corda nosti omnium, ostende quem elegeris ex his duobus unum"
,"25":"accipere locum ministerii huius et apostolatus, de quo praevaricatus est Iudas, ut abiret in locum suum '."
,"26":"Et dederunt sortes eis, et cecidit sors super Matthiam, et annumeratus est cum undecim apostolis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et cum compleretur dies Pen tecostes, erant omnes pariter in eodem loco."
,"2":"Et factus est repente de caelo sonus tamquam advenientis spiritus vehementis et replevit totam domum, ubi erant sedentes."
,"3":"Et apparuerunt illis dispertitae linguae tamquam ignis, seditque supra singulos eorum;"
,"4":"et repleti sunt omnes Spiritu Sancto et coeperunt loqui aliis linguis, prout Spiritus dabat eloqui illis."
,"5":"Erant autem in Ierusalem habitantes Iudaei, viri religiosi ex omni natione, quae sub caelo est;"
,"6":"facta autem hac voce, convenit multitudo et confusa est, quoniam audiebat unusquisque lingua sua illos loquentes."
,"7":"Stupebant autem et mirabantur dicentes: ' Nonne ecce omnes isti, qui loquuntur, Galilaei sunt?"
,"8":"Et quomodo nos audimus unusquisque propria lingua nostra, in qua nati sumus?"
,"9":"Parthi et Medi et Elamitae et qui habitant Mesopotamiam, Iudaeam quoque et Cappadociam, Pontum et Asiam,"
,"10":"Phrygiam quoque et Pamphyliam, Aegyptum et partes Libyae, quae est circa Cyrenem, et advenae Romani,"
,"11":"Iudaei quoque et proselyti, Cretes et Arabes, audimus loquentes eos nostris linguis magnalia Dei '."
,"12":"Stupebant autem omnes et haesitabant ad invicem dicentes: ' Quidnam hoc vult esse? ';"
,"13":"alii autem irridentes dicebant: ' Musto pleni sunt isti '."
,"14":"Stans autem Petrus cum Undecim levavit vocem suam et locutus est eis: ' Viri Iudaei et qui habitatis Ierusalem universi, hoc vobis notum sit, et auribus percipite verba mea."
,"15":"Non enim, sicut vos aestimatis, hi ebrii sunt, est enim hora diei tertia;"
,"16":"sed hoc est, quod dictum est per prophetam Ioel:"
,"17":"'Et erit: in novissimis diebus, dicit Deus, effundam de Spiritu meo super omnem carnem, et prophetabunt filii vestri et filiae vestrae, et iuvenes vestri visiones videbunt, et seniores vestri somnia somniabunt;"
,"18":"et quidem super servos meos et super ancillas meas,in diebus illis effundam de Spiritu meo, et prophetabunt."
,"19":"Et dabo prodigia in caelo sursum et signa in terra deorsum, sanguinem et ignem et vaporem fumi;"
,"20":"sol convertetur in tenebras, et luna in sanguinem, antequam veniat dies Domini,magnus et manifestus."
,"21":"Et erit: omnis quicumque invocaverit nomen Domini, salvus erit'."
,"22":"Viri Israelitae, audite verba haec: Iesum Nazarenum, virum approbatum a Deo apud vos virtutibus et prodigiis et signis, quae fecit per illum Deus in medio vestri, sicut ipsi scitis,"
,"23":"hunc definito consilio et praescientia Dei traditum per manum iniquorum affigentes interemistis,"
,"24":"quem Deus suscitavit, solutis doloribus mortis, iuxta quod impossibile erat teneri illum ab ea."
,"25":"David enim dicit circa eum: 'Providebam Dominum coram me semper, quoniam a dextris meis est, ne commovear."
,"26":"Propter hoc laetatum est cor meum, et exsultavit lingua mea; insuper et caro mea requiescet in spe."
,"27":"Quoniam non derelinques animam meam in inferno,neque dabis Sanctum tuum videre corruptionem."
,"28":"Notas fecisti mihi vias vitae, replebis me iucunditate cum facie tua'."
,"29":"Viri fratres, liceat audenter dicere ad vos de patriarcha David, quoniam et defunctus est et sepultus est, et sepulcrum eius est apud nos usque in hodiernum diem;"
,"30":"propheta igitur cum esset et sciret quia iure iurando iurasset illi Deus de fructu lumbi eius sedere super sedem eius,"
,"31":"providens locutus est de resurrectione Christi, quia neque derelictus est in inferno, neque caro eius vidit corruptionem."
,"32":"Hunc Iesum resuscitavit Deus, cuius omnes nos testes sumus."
,"33":"Dextera igitur Dei exaltatus, et promissione Spiritus Sancti accepta a Patre, effudit hunc, quem vos videtis et auditis."
,"34":"Non enim David ascendit in caelos; dicit autem ipse: 'Dixit Dominus Domino meo: Sede a dextris meis,"
,"35":"donec ponam inimicos tuos scabellum pedum tuorum'."
,"36":"Certissime ergo sciat omnis domus Israel quia et Dominum eum et Christum Deus fecit, hunc Iesum, quem vos crucifixistis '."
,"37":"His auditis, compuncti sunt corde et dixerunt ad Petrum et reliquos apostolos: ' Quid faciemus, viri fratres? '."
,"38":"Petrus vero ad illos: ' Paenitentiam, inquit, agite, et baptizetur unusquisque vestrum in nomine Iesu Christi in remissionem peccatorum vestrorum, et accipietis donum Sancti Spiritus;"
,"39":"vobis enim est repromissio et filiis vestris et omnibus, qui longe sunt, quoscumque advocaverit Dominus Deus noster '."
,"40":"Aliis etiam verbis pluribus testificatus est et exhortabatur eos dicens: ' Salvamini a generatione ista prava '."
,"41":"Qui ergo, recepto sermone eius, baptizati sunt; et appositae sunt in il la die animae circiter tria milia."
,"42":"Erant autem perseverantes in doctrina apostolorum et communicatione, in fractione panis et orationibus."
,"43":"Fiebat autem omni animae timor; multa quoque prodigia et signa per apostolos fiebant."
,"44":"Omnes autem, qui crediderant, erant pariter et habebant omnia communia;"
,"45":"et possessiones et substantias vendebant et dividebant illas omnibus, prout cuique opus erat;"
,"46":"cotidie quoque perdurantes unanimiter in templo et frangentes circa domos panem, sumebant cibum cum exsultatione et simplicitate cordis,"
,"47":"collaudantes Deum et habentes gratiam ad omnem plebem. Dominus autem augebat, qui salvi fierent cotidie in idipsum."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Petrus autem et Ioannes ascen debant in templum ad horam orationis nonam."
,"2":"Et quidam vir, qui erat claudus ex utero matris suae, baiulabatur; quem ponebant cotidie ad portam templi, quae dicitur Speciosa, ut peteret eleemosynam ab introeuntibus in templum;"
,"3":"is cum vidisset Petrum et Ioannem incipientes introire in templum, rogabat, ut eleemosynam acciperet."
,"4":"Intuens autem in eum Petrus cum Ioanne dixit: ' Respice in nos '."
,"5":"At ille intendebat in eos, sperans se aliquid accepturum ab eis."
,"6":"Petrus autem dixit: ' Argentum et aurum non est mihi; quod autem habeo, hoc tibi do: In nomine Iesu Christi Nazareni surge et ambula! '."
,"7":"Et apprehensa ei manu dextera, allevavit eum; et protinus consolidatae sunt bases eius et tali,"
,"8":"et exsiliens stetit et ambulabat; et intravit cum illis in templum, ambulans et exsiliens et laudans Deum."
,"9":"Et vidit omnis populus eum ambulantem et laudantem Deum;"
,"10":"cognoscebant autem illum quoniam ipse erat, qui ad eleemosynam sedebat ad Speciosam portam templi, et impleti sunt stupore et exstasi in eo, quod contigerat illi."
,"11":"Cum teneret autem Petrum et Ioannem, concurrit omnis populus ad eos ad porticum, qui appellatur Salomonis, stupentes."
,"12":"Videns autem Petrus respondit ad populum: ' Viri Israelitae, quid miramini in hoc aut nos quid intuemini, quasi nostra virtute aut pietate fecerimus hunc ambulare?"
,"13":"Deus Abraham et Deus Isaac et Deus Iacob, Deus patrum nostrorum, glorificavit puerum suum Iesum, quem vos quidem tradidistis et negastis ante faciem Pilati, iudicante illo dimitti;"
,"14":"vos autem Sanctum et Iustum negastis et petistis virum homicidam donari vobis,"
,"15":"ducem vero vitae interfecistis, quem Deus suscitavit a mortuis, cuius nos testes sumus."
,"16":"Et in fide nominis eius hunc, quem videtis et nostis, confirmavit nomen eius; et fides, quae per eum est, dedit huic integritatem istam in conspectu omnium vestrum."
,"17":"Et nunc, fratres, scio quia per ignorantiam fecistis, sicut et principes vestri; 18 Deus autem, quae praenuntiavit per os omnium Prophetarum pati Christum suum, implevit sic."
,"19":"Paenitemini igitur et convertimini, ut deleantur vestra peccata,"
,"20":"ut veniant tempora refrigerii a conspectu Domini, et mittat eum, qui praedestinatus est vobis Christus, Iesum,"
,"21":"quem oportet caelum quidem suscipere usque in tempora restitutionis omnium, quae locutus est Deus per os sanctorum a saeculo suorum prophetarum."
,"22":"Moyses quidem dixit: 'Prophetam vobis suscitabit Dominus Deus vester de fratribus vestris tamquam me; ipsum audietis iuxta omnia, quaecumque locutus fuerit vobis."
,"23":"Erit autem: omnis anima, quae non audierit prophetam illum, exterminabitur de plebe'."
,"24":"Et omnes prophetae a Samuel et deinceps quotquot locuti sunt, etiam annuntiaverunt dies istos."
,"25":"Vos estis filii prophetarum et testamenti, quod disposuit Deus ad patres vestros dicens ad Abraham: 'Et in semine tuo benedicentur omnes familiae terrae'."
,"26":"Vobis primum Deus suscitans Puerum suum, misit eum benedicentem vobis in avertendo unumquemque a nequitiis vestris '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Loquentibus autem illis ad populum, supervenerunt eis sa cerdotes et magistratus templi et sadducaei,"
,"2":"dolentes quod docerent populum et annuntiarent in Iesu resurrectionem ex mortuis;"
,"3":"et iniecerunt in eos manus et posuerunt in custodiam in crastinum; erat enim iam vespera."
,"4":"Multi autem eorum, qui audierant verbum, crediderunt; et factus est numerus virorum quinque milia."
,"5":"Factum est autem in crastinum, ut congregarentur principes eorum et seniores et scribae in Ierusalem,"
,"6":"et Annas princeps sacerdotum et Caiphas et Ioannes et Alexander et quotquot erant de genere sacerdotali,"
,"7":"et statuentes eos in medio interrogabant: ' In qua virtute aut in quo nomine fecistis hoc vos? '."
,"8":"Tunc Petrus repletus Spiritu Sancto dixit ad eos: ' Principes populi et seniores,"
,"9":"si nos hodie diiudicamur in benefacto hominis infirmi, in quo iste salvus factus est,"
,"10":"notum sit omnibus vobis et omni plebi Israel quia in nomine Iesu Christi Nazareni, quem vos crucifixistis, quem Deus suscitavit a mortuis, in hoc iste astat coram vobis sanus."
,"11":"Hic est,lapis, qui reprobatus est a vobis aedificatoribus, qui factus est in caput anguli."
,"12":"Et non est in alio aliquo salus, nec enim nomen aliud est sub caelo datum in hominibus, in quo oportet nos salvos fieri '."
,"13":"Videntes autem Petri fiduciam et Ioannis, et comperto quod homines essent sine litteris et idiotae, admirabantur et cognoscebant eos quoniam cum Iesu fuerant;"
,"14":"hominem quoque videntes stantem cum eis, qui curatus fuerat, nihil poterant contradicere."
,"15":"Iubentes autem eos foras extra concilium secedere, conferebant ad invicem"
,"16":"dicentes: ' Quid faciemus hominibus istis? Quoniam quidem notum signum factum est per eos omnibus habitantibus in Ierusalem manifestum, et non possumus negare;"
,"17":"sed ne amplius divulgetur in populum, comminemur eis, ne ultra loquantur in nomine hoc ulli hominum '."
,"18":"Et vocantes eos denuntiaverunt, ne omnino loquerentur neque docerent in nomine Iesu."
,"19":"Petrus vero et Ioannes respondentes dixerunt ad eos: ' Si iustum est in conspectu Dei vos potius audire quam Deum, iudicate;"
,"20":"non enim possumus nos, quae vidimus et audivimus, non loqui '."
,"21":"At illi ultra comminantes dimiserunt eos, nequaquam invenientes, quomodo punirent eos, propter populum, quia omnes glorificabant Deum in eo, quod acciderat;"
,"22":"annorum enim erat amplius quadraginta homo, in quo factum erat signum istud sanitatis."
,"23":"Dimissi autem venerunt ad suos et annuntiaverunt quanta ad eos principes sacerdotum et seniores dixissent."
,"24":"Qui cum audissent, unanimiter levaverunt vocem ad Deum et dixerunt: ' Domine, tu, qui fecisti caelum et terram et mare et omnia, quae in eis sunt,"
,"25":"qui Spiritu Sancto per os patris nostri David pueri tui dixisti: 'Quare fremuerunt gentes, et populi meditati sunt inania?"
,"26":"Astiterunt reges terrae, et principes convenerunt in unum,adversus Dominum et adversus Christum eius'."
,"27":"Convenerunt enim vere in civitate ista adversus sanctum puerum tuum Iesum, quem unxisti, Herodes et Pontius Pilatus cum gentibus et populis Israel"
,"28":"facere, quaecumque manus tua et consilium praedestinavit fieri."
,"29":"Et nunc, Domine, respice in minas eorum et da servis tuis cum omni fiducia loqui verbum tuum, 30 in eo quod manum tuam extendas ad sanitatem et signa et prodigia facienda per nomen sancti pueri tui Iesu '."
,"31":"Et cum orassent, motus est locus, in quo erant congregati, et repleti sunt omnes Sancto Spiritu et loquebantur verbum Dei cum fiducia."
,"32":"Multitudinis autem credentium erat cor et anima una, nec quisquam eorum, quae possidebant, aliquid suum esse dicebat, sed erant illis omnia communia."
,"33":"Et virtute magna reddebant apostoli testimonium resurrectionis Domini Iesu, et gratia magna erat super omnibus illis."
,"34":"Neque enim quisquam egens erat inter illos; quotquot enim possessores agrorum aut domorum erant, vendentes afferebant pretia eorum, quae vendebant,"
,"35":"et ponebant ante pedes apostolorum; dividebatur autem singulis, prout cuique opus erat."
,"36":"Ioseph autem, qui cognominatus est Barnabas ab apostolis - quod est interpretatum filius Consolationis - Levites, Cyprius genere,"
,"37":"cum haberet agrum, vendidit et attulit pecuniam et posuit ante pedes apostolorum."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Vir autem quidam nomine Ananias cum Sapphira uxore sua vendidit agrum"
,"2":"et subtraxit de pretio, conscia quoque uxore, et afferens partem quandam ad pedes apostolorum posuit."
,"3":"Dixit autem Petrus: ' Anania, cur implevit Satanas cor tuum mentiri te Spiritui Sancto et subtrahere de pretio agri?"
,"4":"Nonne manens tibi manebat et venumdatum in tua erat potestate? Quare posuisti in corde tuo hanc rem? Non es mentitus hominibus sed Deo! '."
,"5":"Audiens autem Ananias haec verba cecidit et exspiravit; et factus est timor magnus in omnes audientes."
,"6":"Surgentes autem iuvenes involverunt eum et efferentes sepelierunt."
,"7":"Factum est autem quasi horarum trium spatium, et uxor ipsius nesciens, quod factum fuerat, introivit."
,"8":"Respondit autem ei Petrus: ' Dic mihi, si tanti agrum vendidistis? '. At illa dixit: ' Etiam, tanti '."
,"9":"Petrus autem ad eam: ' Quid est quod convenit vobis tentare Spiritum Domini? Ecce pedes eorum, qui sepelierunt virum tuum, ad ostium, et efferent te '."
,"10":"Confestim cecidit ante pedes eius et exspiravit; intrantes autem iuvenes invenerunt illam mortuam et efferentes sepelierunt ad virum suum."
,"11":"Et factus est timor magnus super universam ecclesiam et in omnes, qui audierunt haec."
,"12":"Per manus autem apostolorum fiebant signa et prodigia multa in plebe; et erant unanimiter omnes in porticu Salomonis."
,"13":"Ceterorum autem nemo audebat coniungere se illis, sed magnificabat eos populus;"
,"14":"magis autem addebantur credentes Domino multitudines virorum ac mulierum,"
,"15":"ita ut et in plateas efferrent infirmos et ponerent in lectulis et grabatis, ut, veniente Petro, saltem umbra illius obumbraret quemquam eorum."
,"16":"Concurrebat autem et multitudo vicinarum civitatum Ierusalem, afferentes aegros et vexatos ab spiritibus immundis, qui curabantur omnes."
,"17":"Exsurgens autem princeps sacerdotum et omnes, qui cum illo erant, quae est haeresis sadducaeorum, repleti sunt zelo"
,"18":"et iniecerunt manus in apostolos et posuerunt illos in custodia publica."
,"19":"Angelus autem Domini per noctem aperuit ianuas carceris et educens eos dixit:"
,"20":"' Ite et stantes loquimini in templo plebi omnia verba vitae huius '."
,"21":"Qui cum audissent, intraverunt diluculo in templum et docebant. Adveniens autem princeps sacerdotum et, qui cum eo erant, convocaverunt concilium et omnes seniores filiorum Israel et miserunt in carcerem, ut adducerentur illi. "
,"22":"Cum venissent autem ministri, non invenerunt illos in carcere; reversi autem nuntiaverunt"
,"23":"dicentes: ' Carcerem invenimus clausum cum omni diligentia et custodes stantes ad ianuas; aperientes autem intus neminem invenimus! '."
,"24":"Ut audierunt autem hos sermones, magistratus templi et principes sacerdotum ambigebant de illis quidnam fieret illud."
,"25":"Adveniens autem quidam nuntiavit eis: ' Ecce viri, quos posuistis in carcere, sunt in templo stantes et docentes populum '."
,"26":"Tunc abiens magistratus cum ministris adducebat illos, non per vim; timebant enim populum, ne lapidarentur."
,"27":"Et cum adduxissent illos, statuerunt in concilio. Et interrogavit eos princeps sacerdotum"
,"28":"dicens: ' Nonne praecipiendo praecepimus vobis, ne doceretis in nomine isto? Et ecce replevistis Ierusalem doctrina vestra et vultis inducere super nos sanguinem hominis istius '."
,"29":"Respondens autem Petrus et apostoli dixerunt: ' Oboedire oportet Deo magis quam hominibus."
,"30":"Deus patrum nostrorum suscitavit Iesum, quem vos interemistis suspendentes in ligno;"
,"31":"hunc Deus Ducem et Salvatorem exaltavit dextera sua ad dandam paenitentiam Israel et remissionem peccatorum."
,"32":"Et nos sumus testes horum verborum, et Spiritus Sanctus, quem dedit Deus oboedientibus sibi '."
,"33":"Haec cum audissent, dissecabantur et volebant interficere illos."
,"34":"Surgens autem quidam in concilio pharisaeus nomine Gamaliel, legis doctor honorabilis universae plebi, iussit foras ad breve homines fieri"
,"35":"dixitque ad illos: ' Viri Israelitae, attendite vobis super hominibus istis quid acturi sitis."
,"36":"Ante hos enim dies exstitit Theudas dicens esse se aliquem, cui consensit virorum numerus circiter quadringentorum; qui occisus est, et omnes, quicumque credebant ei, dissipati sunt et redacti sunt ad nihilum."
,"37":"Post hunc exstitit Iudas Galilaeus in diebus census et avertit populum post se; et ipse periit, et omnes, quotquot consentiebant ei, dispersi sunt."
,"38":"Et nunc dico vobis: Discedite ab hominibus istis et sinite illos. Quoniam si est ex hominibus consilium hoc aut opus hoc, dissolvetur;"
,"39":"si vero ex Deo est, non poteritis dissolvere eos, ne forte et adversus Deum pugnantes inveniamini! '. Consenserunt autem illi "
,"40":"et convocantes apostolos, caesis denuntiaverunt, ne loquerentur in nomine Iesu, et dimiserunt eos."
,"41":"Et illi quidem ibant gaudentes a conspectu concilii, quoniam digni habiti sunt pro nomine contumeliam pati;"
,"42":"et omni die in templo et circa domos non cessabant docentes et evangelizantes Christum, Iesum."
}`)
	CurrentBook.AddChapter(6, `{
"1":"In diebus autem illis, crescente numero discipulorum, factus est murmur Graecorum adversus Hebraeos, eo quod neglegerentur in ministerio cotidiano viduae eorum."
,"2":"Convocantes autem Duodecim multitudinem discipulorum, dixerunt: ' Non est aequum nos derelinquentes verbum Dei ministrare mensis;"
,"3":"considerate vero, fratres, viros ex vobis boni testimonii septem plenos Spiritu et sapientia, quos constituemus super hoc opus;"
,"4":"nos vero orationi et ministerio verbi instantes erimus '."
,"5":"Et placuit sermo coram omni multitudine; et elegerunt Stephanum, virum plenum fide et Spiritu Sancto, et Philippum et Prochorum et Nicanorem et Timonem et Parmenam et Nicolaum proselytum Antiochenum,"
,"6":"quos statuerunt ante conspectum apostolorum, et orantes imposuerunt eis manus."
,"7":"Et verbum Dei crescebat, et multiplicabatur numerus discipulorum in Ierusalem valde; multa etiam turba sacerdotum oboediebat fidei."
,"8":"Stephanus autem plenus gratia et virtute faciebat prodigia et signa magna in populo."
,"9":"Surrexerunt autem quidam de synagoga, quae appellatur Libertinorum et Cyrenensium et Alexandrinorum et eorum, qui erant a Cilicia et Asia, disputantes cum Stephano;"
,"10":"et non poterant resistere sapientiae et Spiritui, quo loquebatur."
,"11":"Tunc submiserunt viros, qui dicerent: ' Audivimus eum dicentem verba blasphema in Moysen et Deum ';"
,"12":"et commoverunt plebem et seniores et scribas, et concurrentes rapuerunt eum et adduxerunt in concilium"
,"13":"et statuerunt testes falsos dicentes: ' Homo iste non cessat loqui verba adversus locum sanctum et Legem;"
,"14":"audivimus enim eum dicentem quoniam Iesus Nazarenus hic destruet locum istum et mutabit consuetudines, quas tradidit nobis Moyses '."
,"15":"Et intuentes eum omnes, qui sedebant in concilio, viderunt faciem eius tamquam faciem angeli."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Dixit autem princeps sacerdo tum: ' Si haec ita se habent? '."
,"2":"Qui ait: ' Viri fratres et patres, audite. Deus gloriae apparuit patri nostro Abraham, cum esset in Mesopotamia, priusquam moraretur in Charran,"
,"3":"et dixit ad illum: 'Exi de terra tua et de cognatione tua et veni in terram, quam tibi monstravero'."
,"4":"Tunc egressus de terra Chaldaeorum habitavit in Charran. Et inde, postquam mortuus est pater eius, transtulit illum in terram istam, in qua nunc vos habitatis;"
,"5":"et non dedit illi hereditatem in ea nec passum pedis et repromisit dare illi eam in possessionem et semini eius post ipsum, cum non haberet filium."
,"6":"Locutus est autem sic Deus: 'Erit semen eius accola in terra aliena, et servituti eos subicient et male tractabunt annis quadringentis;"
,"7":"et gentem, cui servierint, iudicabo ego, dixit Deus; et post haec exibunt et deservient mihi in loco isto'."
,"8":"Et dedit illi testamentum circumcisionis; et sic genuit Isaac et circumcidit eum die octava, et Isaac Iacob, et Iacob duodecim patriarchas."
,"9":"Et patriarchae aemulantes Ioseph vendiderunt in Aegyptum; et erat Deus cum eo"
,"10":"et eripuit eum ex omnibus tribulationibus eius et dedit ei gratiam et sapientiam in conspectu pharaonis regis Aegypti; et constituit eum praepositum super Aegyptum et super omnem domum suam."
,"11":"Venit autem fames in universam Aegyptum et Chanaan et tribulatio magna, et non inveniebant cibos patres nostri."
,"12":"Cum audisset autem Iacob esse frumentum in Aegypto, misit patres nostros primum;"
,"13":"et in secundo cognitus est Ioseph a fratribus suis, et manifestatum est pharaoni genus Ioseph."
,"14":"Mittens autem Ioseph accersivit Iacob patrem suum et omnem cognationem in animabus septuaginta quinque;"
,"15":"et descendit Iacob in Aegyptum. Et defunctus est ipse et patres nostri;"
,"16":"et translati sunt in Sichem et positi sunt in sepulcro, quod emit Abraham pretio argenti a filiis Hemmor in Sichem."
,"17":"Cum appropinquaret autem tempus repromissionis, quam confessus erat Deus Abrahae, crevit populus et multiplicatus est in Aegypto,"
,"18":"quoadusque surrexit rex alius super Aegypto, qui non sciebat Ioseph."
,"19":"Hic circumveniens genus nostrum, afflixit patres, ut exponerent infantes suos, ne vivi servarentur."
,"20":"Eodem tempore natus est Moyses et erat formosus coram Deo; qui nutritus est tribus mensibus in domo patris."
,"21":"Exposito autem illo, sustulit eum filia pharaonis et enutrivit eum sibi in filium;"
,"22":"et eruditus est Moyses in omni sapientia Aegyptiorum; et erat potens in verbis et in operibus suis."
,"23":"Cum autem impleretur ei quadraginta annorum tempus, ascendit in cor eius, ut visitaret fratres suos filios Israel."
,"24":"Et cum vidisset quendam iniuriam patientem, vindicavit et fecit ultionem ei, qui opprimebatur, percusso Aegyptio."
,"25":"Existimabat autem intellegere fratres, quoniam Deus per manum ipsius daret salutem illis; at illi non intellexerunt."
,"26":"Atque sequenti die apparuit illis litigantibus et reconciliabat eos in pacem dicens: 'Viri, fratres estis; ut quid nocetis alterutrum?'."
,"27":"Qui autem iniuriam faciebat proximo, reppulit eum dicens: 'Quis te constituit principem et iudicem super nos?"
,"28":"Numquid interficere me tu vis, quemadmodum interfecisti heri Aegyptium?'."
,"29":"Fugit autem Moyses propter verbum istud; et factus est advena in terra Madian, ubi generavit filios duos."
,"30":"Et expletis annis quadraginta, apparuit illi in deserto montis Sinai angelus in ignis flamma rubi."
,"31":"Moyses autem videns admirabatur visum; accedente autem illo, ut consideraret, facta est vox Domini:"
,"32":"'Ego Deus patrum tuorum, Deus Abraham et Isaac et Iacob'. Tremefactus autem Moyses non audebat considerare."
,"33":"Dixit autem illi Dominus: 'Solve calceamentum pedum tuorum; locus enim, in quo stas, terra sancta est."
,"34":"Videns vidi afflictionem populi mei, qui est in Aegypto, et gemitum eorum audivi et descendi liberare eos; et nunc veni, mittam te in Aegyptum'."
,"35":"Hunc Moysen, quem negaverunt dicentes: 'Quis te constituit principem et iudicem?', hunc Deus et principem et redemptorem misit cum manu angeli, qui apparuit illi in rubo."
,"36":"Hic eduxit illos faciens prodigia et signa in terra Aegypti et in Rubro mari et in deserto annis quadraginta."
,"37":"Hic est Moyses, qui dixit filiis Israel: 'Prophetam vobis suscitabit Deus de fratribus vestris tamquam me'."
,"38":"Hic est qui fuit in ecclesia in solitudine cum angelo, qui loquebatur ei in monte Sinai, et cum patribus nostris; qui accepit verba viva dare nobis;"
,"39":"cui noluerunt oboedire patres nostri, sed reppulerunt et aversi sunt in cordibus suis in Aegyptum"
,"40":"dicentes ad Aaron: 'Fac nobis deos, qui praecedant nos; Moyses enim hic, qui eduxit nos de terra Aegypti, nescimus quid factum sit ei'."
,"41":"Et vitulum fecerunt in illis diebus et obtulerunt hostiam simulacro et laetabantur in operibus manuum suarum."
,"42":"Convertit autem Deus et tradidit eos servire militiae caeli, sicut scriptum est in libro Prophetarum: 'Numquid victimas et hostias obtulistis mihi,annis quadraginta in deserto, domus Israel?"
,"43":"Et suscepistis tabernaculum Moloch,et sidus dei vestri Rhaephan, figuras, quas fecistis ad adorandum eas. Et transferam vos trans Babylonem'."
,"44":"Tabernaculum testimonii erat patribus nostris in deserto, sicut disposuit, qui loquebatur ad Moysen, ut faceret illud secundum formam, quam viderat;"
,"45":"quod et induxerunt suscipientes patres nostri cum Iesu in possessionem gentium, quas expulit Deus a facie patrum nostrorum, usque in diebus David,"
,"46":"qui invenit gratiam ante Deum et petiit, ut inveniret tabernaculum domui Iacob."
,"47":"Salomon autem aedificavit illi domum."
,"48":"Sed non Altissimus in manufactis habitat, sicut propheta dicit:"
,"49":"'Caelum mihi thronus est, terra autem scabellum pedum meorum. Quam domum aedificabitis mihi, dicit Dominus, aut quis locus requietionis meae?"
,"50":"Nonne manus mea fecit haec omnia?'."
,"51":"Duri cervice et incircumcisi cordibus et auribus, vos semper Spiritui Sancto resistitis; sicut patres vestri, et vos."
,"52":"Quem prophetarum non sunt persecuti patres vestri? Et occiderunt eos, qui praenuntiabant de adventu Iusti, cuius vos nunc proditores et homicidae fuistis,"
,"53":"qui accepistis legem in dispositionibus angelorum et non custodistis '."
,"54":"Audientes autem haec, dissecabantur cordibus suis et stridebant dentibus in eum."
,"55":"Cum autem esset plenus Spiritu Sancto, intendens in caelum vidit gloriam Dei et Iesum stantem a dextris Dei"
,"56":"et ait: ' Ecce video caelos apertos et Filium hominis a dextris stantem Dei '."
,"57":"Exclamantes autem voce magna continuerunt aures suas et impetum fecerunt unanimiter in eum"
,"58":"et eicientes extra civitatem lapidabant. Et testes deposuerunt vestimenta sua secus pedes adulescentis, qui vocabatur Saulus."
,"59":"Et lapidabant Stephanum invocantem et dicentem: ' Domine Iesu, suscipe spiritum meum '."
,"60":"Positis autem genibus clamavit voce magna: ' Domine, ne statuas illis hoc peccatum '; et cum hoc dixisset, obdormivit."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Saulus autem erat consentiens neci eius. Facta est autem in illa die persecutio magna in ecclesiam, quae erat Hierosolymis; et omnes dispersi sunt per regiones Iudaeae et Samariae praeter apostolos."
,"2":"Sepelierunt autem Stephanum viri timorati et fecerunt planctum magnum super illum."
,"3":"Saulus vero devastabat ecclesiam, per domos intrans et trahens viros ac mulieres tradebat in custodiam."
,"4":"Igitur qui dispersi erant, pertransierunt evangelizantes verbum."
,"5":"Philippus autem descendens in civitatem Samariae praedicabat illis Christum."
,"6":"Intendebant autem turbae his, quae a Philippo dicebantur, unanimiter, audientes et videntes signa, quae faciebat:"
,"7":"ex multis enim eorum, qui habebant spiritus immundos, clamantes voce magna exibant; multi autem paralytici et claudi curati sunt."
,"8":"Factum est autem magnum gaudium in illa civitate."
,"9":"Vir autem quidam nomine Simon iampridem erat in civitate magias faciens et dementans gentem Samariae, dicens esse se aliquem magnum;"
,"10":"cui attendebant omnes a minimo usque ad maximum dicentes: ' Hic est virtus Dei, quae vocatur Magna '."
,"11":"Attendebant autem eum, propter quod multo tempore magiis dementasset eos."
,"12":"Cum vero credidissent Philippo evangelizanti de regno Dei et nomine Iesu Christi, baptizabantur viri ac mulieres."
,"13":"Tunc Simon et ipse credidit et, cum baptizatus esset, adhaerebat Philippo; videns etiam signa et virtutes magnas fieri stupens admirabatur."
,"14":"Cum autem audissent apostoli, qui erant Hierosolymis, quia recepit Samaria verbum Dei, miserunt ad illos Petrum et Ioannem;"
,"15":"qui cum descendissent, oraverunt pro ipsis, ut acciperent Spiritum Sanctum:"
,"16":"nondum enim super quemquam illorum venerat, sed baptizati tantum erant in nomine Domini Iesu."
,"17":"Tunc imposuerunt manus super illos, et accipiebant Spiritum Sanctum."
,"18":"Cum vidisset autem Simon quia per impositionem manuum apostolorum daretur Spiritus, obtulit eis pecuniam"
,"19":"dicens: ' Date et mihi hanc potestatem, ut cuicumque imposuero manus, accipiat Spiritum Sanctum '."
,"20":"Petrus autem dixit ad eum: ' Argentum tuum tecum sit in perditionem, quoniam donum Dei existimasti pecunia possideri!"
,"21":"Non est tibi pars neque sors in verbo isto; cor enim tuum non est rectum coram Deo."
,"22":"Paenitentiam itaque age ab hac nequitia tua et roga Dominum, si forte remittatur tibi haec cogitatio cordis tui;"
,"23":"in felle enim amaritudinis et obligatione iniquitatis video te esse '."
,"24":"Respondens autem Simon dixit: ' Precamini vos pro me ad Dominum, ut nihil veniat super me horum, quae dixistis '."
,"25":"Et illi quidem testificati et locuti verbum Domini, redibant Hierosolymam et multis vicis Samaritanorum evangelizabant."
,"26":"Angelus autem Domini locutus est ad Philippum dicens: ' Surge et vade contra meridianum ad viam, quae descendit ab Ierusalem in Gazam; haec est deserta '."
,"27":"Et surgens abiit; et ecce vir Aethiops eunuchus potens Candacis reginae Aethiopum, qui erat super omnem gazam eius, qui venerat adorare in Ierusalem"
,"28":"et revertebatur sedens super currum suum et legebat prophetam Isaiam."
,"29":"Dixit autem Spiritus Philippo: ' Accede et adiunge te ad currum istum '."
,"30":"Accurrens autem Philippus audivit illum legentem Isaiam prophetam et dixit: ' Putasne intellegis, quae legis? '."
,"31":"Qui ait: ' Et quomodo possum, si non aliquis ostenderit mihi? '. Rogavitque Philippum, ut ascenderet et sederet secum."
,"32":"Locus autem Scripturae, quem legebat, erat hic: ' Tamquam ovis ad occisionem ductus est,et sicut agnus coram tondente se sine voce, sic non aperit os suum."
,"33":"In humilitate eius iudicium eius sublatum est. Generationem illius quis enarrabit?,Quoniam tollitur de terra vita eius '."
,"34":"Respondens autem eunuchus Philippo dixit: ' Obsecro te, de quo propheta dicit hoc? De se an de alio aliquo? '."
,"35":"Aperiens autem Philippus os suum et incipiens a Scriptura ista, evangelizavit illi Iesum."
,"36":"Et dum irent per viam, venerunt ad quandam aquam; et ait eunuchus: ' Ecce aqua; quid prohibet me baptizari? '. (37) 38 Et iussit stare currum; et descenderunt uterque in aquam Philippus et eunuchus, et baptizavit eum. "
,"39":"Cum autem ascendissent de aqua, Spiritus Domini rapuit Philippum, et amplius non vidit eum eunuchus; ibat autem per viam suam gaudens."
,"40":"Philippus autem inventus est in Azoto et pertransiens evangelizabat civitatibus cunctis, donec veniret Caesaream."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Saulus autem, adhuc spirans minarum et caedis in discipulos Domini, accessit ad principem sacerdotum"
,"2":"et petiit ab eo epistulas in Damascum ad synagogas, ut, si quos invenisset huius viae viros ac mulieres, vinctos perduceret in Ierusalem."
,"3":"Et cum iter faceret, contigit ut appropinquaret Damasco; et subito circumfulsit eum lux de caelo,"
,"4":"et cadens in terram audivit vocem dicentem sibi: ' Saul, Saul, quid me persequeris? '."
,"5":"Qui dixit: ' Quis es, Domine? '. Et ille: ' Ego sum Iesus, quem tu persequeris!"
,"6":"Sed surge et ingredere civitatem, et dicetur tibi quid te oporteat facere '."
,"7":"Viri autem illi, qui comitabantur cum eo, stabant stupefacti, audientes quidem vocem, neminem autem videntes."
,"8":"Surrexit autem Saulus de terra; apertisque oculis, nihil videbat; ad manus autem illum trahentes introduxerunt Damascum."
,"9":"Et erat tribus diebus non videns et non manducavit neque bibit."
,"10":"Erat autem quidam discipulus Damasci nomine Ananias; et dixit ad illum in visu Dominus: ' Anania '. At ille ait: ' Ecce ego, Domine '."
,"11":"Et Dominus ad illum: ' Surgens vade in vicum, qui vocatur Rectus, et quaere in domo Iudae Saulum nomine Tarsensem; ecce enim orat"
,"12":"et vidit virum Ananiam nomine introeuntem et imponentem sibi manus, ut visum recipiat '."
,"13":"Respondit autem Ananias: ' Domine, audivi a multis de viro hoc, quanta mala sanctis tuis fecerit in Ierusalem;"
,"14":"et hic habet potestatem a principibus sacerdotum alligandi omnes, qui invocant nomen tuum '."
,"15":"Dixit autem ad eum Dominus: ' Vade, quoniam vas electionis est mihi iste, ut portet nomen meum coram gentibus et regibus et filiis Israel;"
,"16":"ego enim ostendam illi quanta oporteat eum pro nomine meo pati '."
,"17":"Et abiit Ananias; et introivit in domum et imponens ei manus dixit: ' Saul frater, Dominus misit me, Iesus qui apparuit tibi in via, qua veniebas, ut videas et implearis Spiritu Sancto '."
,"18":"Et confestim ceciderunt ab oculis eius tamquam squamae, et visum recepit. Et surgens baptizatus est"
,"19":"et, cum accepisset cibum, confortatus est. Fuit autem cum discipulis, qui erant Damasci, per dies aliquot; "
,"20":"et continuo in synagogis praedicabat Iesum, quoniam hic est Filius Dei."
,"21":"Stupebant autem omnes, qui audiebant, et dicebant: ' Nonne hic est, qui expugnabat in Ierusalem eos, qui invocabant nomen istud, et huc ad hoc venerat, ut vinctos illos duceret ad principes sacerdotum? '."
,"22":"Saulus autem magis convalescebat et confundebat Iudaeos, qui habitabant Damasci, affirmans quoniam hic est Christus."
,"23":"Cum implerentur autem dies multi, consilium fecerunt Iudaei, ut eum interficerent;"
,"24":"notae autem factae sunt Saulo insidiae eorum. Custodiebant autem et portas die ac nocte, ut eum interficerent;"
,"25":"accipientes autem discipuli eius nocte per murum dimiserunt eum submittentes in sporta."
,"26":"Cum autem venisset in Ierusalem, tentabat iungere se discipulis; et omnes timebant eum, non credentes quia esset discipulus."
,"27":"Barnabas autem apprehensum illum duxit ad apostolos et narravit illis quomodo in via vidisset Dominum, et quia locutus est ei, et quomodo in Damasco fiducialiter egerit in nomine Iesu."
,"28":"Et erat cum illis intrans et exiens in Ierusalem, fiducialiter agens in nomine Domini."
,"29":"Loquebatur quoque et disputabat cum Graecis; illi autem quaerebant occidere eum."
,"30":"Quod cum cognovissent, fratres deduxerunt eum Caesaream et dimiserunt Tarsum."
,"31":"Ecclesia quidem per totam Iudaeam et Galilaeam et Samariam habebat pacem; aedificabatur et ambulabat in timore Domini et consolatione Sancti Spiritus crescebat."
,"32":"Factum est autem Petrum, dum pertransiret universos, devenire et ad sanctos, qui habitabant Lyddae."
,"33":"Invenit autem ibi hominem quendam nomine Aeneam ab annis octo iacentem in grabato, qui erat paralyticus."
,"34":"Et ait illi Petrus: ' Aenea, sanat te Iesus Christus; surge et sterne tibi '. Et continuo surrexit."
,"35":"Et viderunt illum omnes, qui inhabitabant Lyddam et Saron, qui conversi sunt ad Dominum."
,"36":"In Ioppe autem erat quaedam discipula nomine Tabitha, quae interpretata dicitur Dorcas; haec erat plena operibus bonis et eleemosynis, quas faciebat."
,"37":"Factum est autem in diebus illis ut infirmata moreretur; quam cum lavissent, posuerunt in cenaculo."
,"38":"Cum autem prope esset Lydda ab Ioppe, discipuli audientes quia Petrus esset in ea, miserunt duos viros ad eum rogantes: ' Ne pigriteris venire usque ad nos! '."
,"39":"Exsurgens autem Petrus venit cum illis; et cum advenisset, duxerunt illum in cenaculum; et circumsteterunt illum omnes viduae flentes et ostendentes tunicas et vestes, quas faciebat Dorcas, cum esset cum illis."
,"40":"Eiectis autem omnibus foras Petrus, et ponens genua oravit et conversus ad corpus dixit: ' Tabitha, surge! '. At illa aperuit oculos suos et, viso Petro, resedit."
,"41":"Dans autem illi manum erexit eam et, cum vocasset sanctos et viduas, exhibuit eam vivam."
,"42":"Notum autem factum est per universam Ioppen, et crediderunt multi in Domino."
,"43":"Factum est autem, ut dies multos moraretur in Ioppe apud quendam Simonem coriarium."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Vir autem quidam in Cae sarea nomine Cornelius, cen turio cohortis, quae dicitur Italica,"
,"2":"religiosus et timens Deum cum omni domo sua, faciens eleemosynas multas plebi et deprecans Deum semper,"
,"3":"vidit in visu manifeste quasi hora nona diei angelum Dei introeuntem ad se et dicentem sibi: ' Corneli '."
,"4":"At ille intuens eum et timore correptus dixit: ' Quid est, domine? '. Dixit autem illi: ' Orationes tuae et eleemosynae tuae ascenderunt in memoriam in conspectu Dei."
,"5":"Et nunc mitte viros in Ioppen et accersi Simonem quendam, qui cognominatur Petrus;"
,"6":"hic hospitatur apud Simonem quendam coriarium, cui est domus iuxta mare '."
,"7":"Ut autem discessit angelus, qui loquebatur illi, cum vocasset duos domesticos suos et militem religiosum ex his, qui illi parebant,"
,"8":"et narrasset illis omnia, misit illos in Ioppen."
,"9":"Postera autem die, iter illis facientibus et appropinquantibus civitati, ascendit Petrus super tectum, ut oraret circa horam sextam."
,"10":"Et cum esuriret, voluit gustare; parantibus autem eis, cecidit super eum mentis excessus,"
,"11":"et videt caelum apertum et descendens vas quoddam velut linteum magnum quattuor initiis submitti in terram,"
,"12":"in quo erant omnia quadrupedia et serpentia terrae et volatilia caeli."
,"13":"Et facta est vox ad eum: ' Surge, Petre, occide et manduca! '."
,"14":"Ait autem Petrus: ' Nequaquam, Domine, quia numquam manducavi omne commune et immundum '."
,"15":"Et vox iterum secundo ad eum: ' Quae Deus purificavit, ne tu commune dixeris '."
,"16":"Hoc autem factum est per ter, et statim receptum est vas in caelum."
,"17":"Et dum intra se haesitaret Petrus quidnam esset visio, quam vidisset, ecce viri, qui missi erant a Cornelio, inquirentes domum Simonis astiterunt ad ianuam"
,"18":"et, cum vocassent, interrogabant si Simon, qui cognominatur Petrus, illic haberet hospitium."
,"19":"Petro autem cogitante de visione, dixit Spiritus ei: ' Ecce viri tres quaerunt te;"
,"20":"surge itaque et descende et vade cum eis nihil dubitans, quia ego misi illos '."
,"21":"Descendens autem Petrus ad viros dixit: ' Ecce ego sum, quem quaeritis; quae causa est, propter quam venistis? '."
,"22":"Qui dixerunt: ' Cornelius centurio, vir iustus et timens Deum et testimonium habens ab universa gente Iudaeorum, responsum accepit ab angelo sancto accersire te in domum suam et audire verba abs te '."
,"23":"Invitans igitur eos recepit hospitio. Sequenti autem die, surgens profectus est cum eis, et quidam ex fratribus ab Ioppe comitati sunt eum. "
,"24":"Altera autem die introivit Caesaream; Cornelius vero exspectabat illos, convocatis cognatis suis et necessariis amicis."
,"25":"Et factum est, cum introisset Petrus, obvius ei Cornelius procidens ad pedes adoravit."
,"26":"Petrus vero levavit eum dicens: ' Surge, et ego ipse homo sum '."
,"27":"Et loquens cum illo intravit et invenit multos, qui convenerant;"
,"28":"dixitque ad illos: ' Vos scitis quomodo illicitum sit viro Iudaeo coniungi aut accedere ad alienigenam. Et mihi ostendit Deus neminem communem aut immundum dicere hominem;"
,"29":"propter quod sine dubitatione veni accersitus. Interrogo ergo quam ob causam accersistis me '."
,"30":"Et Cornelius ait: ' A nudius quarta die usque in hanc horam orans eram hora nona in domo mea, et ecce vir stetit ante me in veste candida"
,"31":"et ait: 'Corneli, exaudita est oratio tua, et eleemosynae tuae commemoratae sunt in conspectu Dei."
,"32":"Mitte ergo in Ioppen et accersi Simonem, qui cognominatur Petrus; hic hospitatur in domo Simonis coriarii iuxta mare'."
,"33":"Confestim igitur misi ad te, et tu bene fecisti veniendo. Nunc ergo omnes nos in conspectu Dei adsumus audire omnia, quaecumque tibi praecepta sunt a Domino '."
,"34":"Aperiens autem Petrus os dixit: ' In veritate comperio quoniam non est personarum acceptor Deus,"
,"35":"sed in omni gente, qui timet eum et operatur iustitiam, acceptus est illi."
,"36":"Verbum misit filiis Israel evangelizans pacem per Iesum Christum; hic est omnium Dominus."
,"37":"Vos scitis quod factum est verbum per universam Iudaeam incipiens a Galilaea post baptismum, quod praedicavit Ioannes:"
,"38":"Iesum a Nazareth, quomodo unxit eum Deus Spiritu Sancto et virtute, qui pertransivit benefaciendo et sanando omnes oppressos a Diabolo, quoniam Deus erat cum illo."
,"39":"Et nos testes sumus omnium, quae fecit in regione Iudaeorum et Ierusalem; quem et occiderunt suspendentes in ligno."
,"40":"Hunc Deus suscitavit tertia die et dedit eum manifestum fieri"
,"41":"non omni populo, sed testibus praeordinatis a Deo, nobis, qui manducavimus et bibimus cum illo postquam resurrexit a mortuis;"
,"42":"et praecepit nobis praedicare populo et testificari quia ipse est, qui constitutus est a Deo iudex vivorum et mortuorum."
,"43":"Huic omnes Prophetae testimonium perhibent remissionem peccatorum accipere per nomen eius omnes, qui credunt in eum '."
,"44":"Adhuc loquente Petro verba haec, cecidit Spiritus Sanctus super omnes, qui audiebant verbum."
,"45":"Et obstupuerunt, qui ex circumcisione fideles, qui venerant cum Petro, quia et in nationes gratia Spiritus Sancti effusa est;"
,"46":"audiebant enim illos loquentes linguis et magnificantes Deum. Tunc respondit Petrus:"
,"47":"' Numquid aquam quis prohibere potest, ut non baptizentur hi, qui Spiritum Sanctum acceperunt sicut et nos? '."
,"48":"Et iussit eos in nomine Iesu Christi baptizari. Tunc rogaverunt eum, ut maneret aliquot diebus."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Audierunt autem apostoli et fratres, qui erant in Iudaea, quoniam et gentes receperunt verbum Dei."
,"2":"Cum ascendisset autem Petrus in Ierusalem, disceptabant adversus illum, qui erant ex circumcisione,"
,"3":"dicentes: ' Introisti ad viros praeputium habentes et manducasti cum illis! '."
,"4":"Incipiens autem Petrus exponebat illis ex ordine dicens:"
,"5":"' Ego eram in civitate Ioppe orans et vidi in excessu mentis visionem, descendens vas quoddam velut linteum magnum quattuor initiis submitti de caelo et venit usque ad me;"
,"6":"in quod intuens considerabam et vidi quadrupedia terrae et bestias et reptilia et volatilia caeli."
,"7":"Audivi autem et vocem dicentem mihi: 'Surgens, Petre, occide et manduca!'."
,"8":"Dixi autem: Nequaquam, Domine, quia commune aut immundum numquam introivit in os meum."
,"9":"Respondit autem vox secundo de caelo: 'Quae Deus mundavit, tu ne commune dixeris'."
,"10":"Hoc autem factum est per ter, et retracta sunt rursum omnia in caelum."
,"11":"Et ecce confestim tres viri astiterunt in domo, in qua eramus, missi a Caesarea ad me."
,"12":"Dixit autem Spiritus mihi, ut irem cum illis nihil haesitans. Venerunt autem mecum et sex fratres isti, et ingressi sumus in domum viri."
,"13":"Narravit autem nobis quomodo vidisset angelum ad domum suam stantem et dicentem: 'Mitte in Ioppen et accersi Simonem, qui cognominatur Petrus,"
,"14":"qui loquetur tibi verba, in quibus salvus eris tu et universa domus tua'."
,"15":"Cum autem coepissem loqui, decidit Spiritus Sanctus super eos, sicut et super nos in initio."
,"16":"Recordatus sum autem verbi Domini, sicut dicebat: 'Ioannes quidem baptizavit aqua, vos autem baptizabimini in Spiritu Sancto'."
,"17":"Si ergo aequale donum dedit illis Deus sicut et nobis, qui credidimus in Dominum Iesum Christum, ego quis eram qui possem prohibere Deum? '."
,"18":"His autem auditis, acquieverunt et glorificaverunt Deum dicentes: ' Ergo et gentibus Deus paenitentiam ad vitam dedit '."
,"19":"Et illi quidem, qui dispersi fuerant a tribulatione, quae facta fuerat sub Stephano, perambulaverunt usque Phoenicen et Cyprum et Antiochiam, nemini loquentes verbum; nisi solis Iudaeis."
,"20":"Erant autem quidam ex eis viri Cyprii et Cyrenaei, qui, cum introissent Antiochiam, loquebantur et ad Graecos evangelizantes Dominum Iesum."
,"21":"Et erat manus Domini cum eis; multusque numerus credentium conversus est ad Dominum."
,"22":"Auditus est autem sermo in auribus ecclesiae, quae erat in Ierusalem, super istis, et miserunt Barnabam usque Antiochiam;"
,"23":"qui cum pervenisset et vidisset gratiam Dei, gavisus est et hortabatur omnes proposito cordis permanere in Domino,"
,"24":"quia erat vir bonus et plenus Spiritu Sancto et fide. Et apposita est turba multa Domino."
,"25":"Profectus est autem Tarsum, ut quaereret Saulum;"
,"26":"quem cum invenisset, perduxit Antiochiam. Factum est autem eis, ut annum totum conversarentur in ecclesia et docerent turbam multam, et cognominarentur primum Antiochiae discipuli Christiani."
,"27":"In his autem diebus supervenerunt ab Hierosolymis prophetae Antiochiam;"
,"28":"et surgens unus ex eis nomine Agabus significavit per Spiritum famem magnam futuram in universo orbe terrarum; quae facta est sub Claudio."
,"29":"Discipuli autem, prout quis habebat, proposuerunt singuli eorum in ministerium mittere habitantibus in Iudaea fratribus;"
,"30":"quod et fecerunt, mittentes ad presbyteros per manum Barnabae et Sauli."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Illo autem tempore, misit Herodes rex manus, ut affli geret quosdam de ecclesia."
,"2":"Occidit autem Iacobum fratrem Ioannis gladio."
,"3":"Videns autem quia placeret Iudaeis, apposuit apprehendere et Petrum - erant autem dies Azymorum -"
,"4":"quem cum apprehendisset, misit in carcerem tradens quattuor quaternionibus militum custodire eum, volens post Pascha producere eum populo."
,"5":"Et Petrus quidem servabatur in carcere; oratio autem fiebat sine intermissione ab ecclesia ad Deum pro eo."
,"6":"Cum autem producturus eum esset Herodes, in ipsa nocte erat Petrus dormiens inter duos milites vinctus catenis duabus, et custodes ante ostium custodiebant carcerem."
,"7":"Et ecce angelus Domini astitit, et lumen refulsit in habitaculo; percusso autem latere Petri, suscitavit eum dicens: ' Surge velociter! '. Et ceciderunt catenae de manibus eius."
,"8":"Dixit autem angelus ad eum: ' Praecingere et calcea te sandalia tua! '. Et fecit sic. Et dicit illi: ' Circumda tibi vestimentum tuum et sequere me! '."
,"9":"Et exiens sequebatur et nesciebat quia verum est, quod fiebat per angelum; aestimabat autem se visum videre."
,"10":"Transeuntes autem primam custodiam et secundam venerunt ad portam ferream, quae ducit ad civitatem, quae ultro aperta est eis, et exeuntes processerunt vicum unum, et continuo discessit angelus ab eo."
,"11":"Et Petrus ad se reversus dixit: ' Nunc scio vere quia misit Dominus angelum suum et eripuit me de manu Herodis et de omni exspectatione plebis Iudaeorum '."
,"12":"Consideransque venit ad domum Mariae matris Ioannis, qui cognominatur Marcus, ubi erant multi congregati et orantes."
,"13":"Pulsante autem eo ostium ianuae, processit puella ad audiendum, nomine Rhode;"
,"14":"et ut cognovit vocem Petri, prae gaudio non aperuit ianuam, sed intro currens nuntiavit stare Petrum ante ianuam."
,"15":"At illi dixerunt ad eam: ' Insanis! '. Illa autem affirmabat sic se habere. Illi autem dicebant: ' Angelus eius est '."
,"16":"Petrus autem perseverabat pulsans; cum autem aperuissent, viderunt eum et obstupuerunt."
,"17":"Annuens autem eis manu, ut tacerent, enarravit quomodo Dominus eduxisset eum de carcere dixitque: ' Nuntiate Iacobo ct fratribus haec '. Et egressus abiit in alium locum."
,"18":"Facta autem die, erat non parva turbatio inter milites, quidnam de Petro factum esset."
,"19":"Herodes autem, cum requisisset eum et non invenisset, interrogatis custodibus, iussit eos abduci; descendensque a Iudaea in Caesaream ibi commorabatur."
,"20":"Erat autem iratus Tyriis et Sidoniis; at illi unanimes venerunt ad eum et, persuaso Blasto, qui erat super cubiculum regis, postulabant pacem, eo quod aleretur regio eorum ab annona regis."
,"21":"Statuto autem die, Herodes, vestitus veste regia, sedens pro tribunalicontionabatur ad eos;"
,"22":"populus autem acclamabat: ' Dei vox et non hominis! '."
,"23":"Confestim autem percussit eum angelus Domini, eo quod non dedisset gloriam Deo; et consumptus a vermibus exspiravit."
,"24":"Verbum autem Dei crescebat et multiplicabatur."
,"25":"Barnabas autem et Saulus reversi sunt in Ierusalem expleto ministerio, assumpto Ioanne, qui cognominatus est Marcus."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Erant autem in ecclesia, quae erat Antiochiae, pro phetae et doctores: Barnabas et Simeon, qui vocabatur Niger, et Lucius Cyrenensis et Manaen, qui erat Herodis tetrarchae collactaneus, et Saulus."
,"2":"Ministrantibus autem illis Domino et ieiunantibus, dixit Spiritus Sanctus: ' Separate mihi Barnabam et Saulum in opus, ad quod vocavi eos '."
,"3":"Tunc ieiunantes et orantes imponentesque eis manus dimiserunt illos."
,"4":"Et ipsi quidem missi ab Spiritu Sancto devenerunt Seleuciam et inde navigaverunt Cyprum"
,"5":"et, cum venissent Salamina, praedicabant verbum Dei in synagogis Iudaeorum; habebant autem et Ioannem ministrum."
,"6":"Et cum perambulassent universam insulam usque Paphum, invenerunt quendam virum magum pseudoprophetam Iudaeum, cui nomen Bariesu,"
,"7":"qui erat cum proconsule Sergio Paulo, viro prudente. Hic, accitis Barnaba et Saulo, quaesivit audire verbum Dei;"
,"8":"resistebat autem illis Elymas, magus, sic enim interpretatur nomen eius, quaerens avertere proconsulem a fide."
,"9":"Saulus autem, qui et Paulus, repletus Spiritu Sancto, intuens in eum"
,"10":"dixit: ' O plene omni dolo et omni fallacia, fili Diaboli, inimice omnis iustitiae, non desines subvertere vias Domini rectas?"
,"11":"Et nunc, ecce manus Domini super te; et eris caecus, non videns solem usque ad tempus '. Et confestim cecidit in eum caligo et tenebrae, et circumiens quaerebat, qui eum manum darent."
,"12":"Tunc proconsul, cum vidisset factum, credidit admirans super doctrinam Domini."
,"13":"Et cum a Papho navigassent, qui erant cum Paulo, venerunt Pergen Pamphyliae; Ioannes autem discedens ab eis reversus est Hierosolymam."
,"14":"Illi vero pertranseuntes, a Perge venerunt Antiochiam Pisidiae, et ingressi synagogam die sabbatorum sederunt."
,"15":"Post lectionem autem Legis et Prophetarum, miserunt principes synagogae ad eos dicentes: ' Viri fratres, si quis est in vobis sermo exhortationis ad plebem, dicite! '."
,"16":"Surgens autem Paulus et manu silentium indicens ait: ' Viri Israelitae et qui timetis Deum, audite."
,"17":"Deus plebis huius Israel elegit patres nostros et plebem exaltavit, cum essent incolae in terra Aegypti, et in brachio excelso eduxit eos ex ea;"
,"18":"et per quadraginta fere annorum tempus mores eorum sustinuit in deserto;"
,"19":"et destruens gentes septem in terra Chanaan sorte distribuit terram eorum,"
,"20":"quasi quadringentos et quinquaginta annos. Et post haec dedit iudices usque ad Samuel prophetam."
,"21":"Et exinde postulaverunt regem, et dedit illis Deus Saul filium Cis, virum de tribu Beniamin, annis quadraginta."
,"22":"Et amoto illo, suscitavit illis David in regem, cui et testimonium perhibens dixit: 'Inveni David filium Iesse, virum secundum cor meum, qui faciet omnes voluntates meas'."
,"23":"Huius Deus ex semine secundum promissionem eduxit Israel salvatorem Iesum,"
,"24":"praedicante Ioanne ante adventum eius baptismum paenitentiae omni populo Israel."
,"25":"Cum impleret autem Ioannes cursum suum, dicebat: 'Quid me arbitramini esse? Non sum ego; sed ecce venit post me, cuius non sum dignus calceamenta pedum solvere'."
,"26":"Viri fratres, filii generis Abraham et qui in vobis timent Deum, nobis verbum salutis huius missum est."
,"27":"Qui enim habitabant Ierusalem et principes eorum, hunc ignorantes et voces Prophetarum, quae per omne sabbatum leguntur, iudicantes impleverunt;"
,"28":"et nullam causam mortis invenientes petierunt a Pilato, ut interficeretur;"
,"29":"cumque consummassent omnia, quae de eo scripta erant, deponentes eum de ligno posuerunt in monumento."
,"30":"Deus vero suscitavit eum a mortuis;"
,"31":"qui visus est per dies multos his, qui simul ascenderant cum eo de Galilaea in Ierusalem, qui nunc sunt testes eius ad plebem."
,"32":"Et nos vobis evangelizamus eam, quae ad patres promissio facta est,"
,"33":"quoniam hanc Deus adimplevit filiis eorum, nobis resuscitans Iesum, sicut et in Psalmo secundo scriptum est: 'Filius meus es tu; ego hodie genui te'."
,"34":"Quod autem suscitaverit eum a mortuis, amplius iam non reversurum in corruptionem, ita dixit: 'Dabo vobis sancta David fidelia'."
,"35":"Ideoque et in alio dicit: 'Non dabis Sanctum tuum videre corruptionem'."
,"36":"David enim sua generatione cum administrasset voluntati Dei, dormivit et appositus est ad patres suos et vidit corruptionem;"
,"37":"quem vero Deus suscitavit, non vidit corruptionem."
,"38":"Notum igitur sit vobis, viri fratres, quia per hunc vobis remissio peccatorum annuntiatur; ab omnibus, quibus non potuistis in lege Moysi iustificari,"
,"39":"in hoc omnis, qui credit, iustificatur."
,"40":"Videte ergo, ne superveniat, quod dictum est in Prophetis:"
,"41":"'Videte, contemptores, et admiramini et disperdimini, quia opus operor ego in diebus vestris, opus, quod non credetis, si quis enarraverit vobis!' '."
,"42":"Exeuntibus autem illis, rogabant, ut sequenti sabbato loquerentur sibi verba haec."
,"43":"Cumque dimissa esset synagoga, secuti sunt multi Iudaeorum et colentium proselytorum Paulum et Barnabam, qui loquentes suadebant eis, ut permanerent in gratia Dei."
,"44":"Sequenti vero sabbato paene universa civitas convenit audire verbum Domini."
,"45":"Videntes autem turbas Iudaei, repleti sunt zelo; et contradicebant his, quae a Paulo dicebantur, blasphemantes."
,"46":"Tunc audenter Paulus et Barnabas dixerunt: ' Vobis oportebat primum loqui verbum Dei; sed quoniam repellitis illud et indignos vos iudicatis aeternae vitae, ecce convertimur ad gentes."
,"47":"Sic enim praecepit nobis Dominus: 'Posui te in lumen gentium, ut sis in salutem usque ad extremum terrae' '."
,"48":"Audientes autem gentes gaudebant et glorificabant verbum Domini, et crediderunt, quotquot erant praeordinati ad vitam aeternam;"
,"49":"ferebatur autem verbum Domini per universam regionem."
,"50":"Iudaei autem concitaverunt honestas inter colentes mulieres et primos civitatis et excitaverunt persecutionem in Paulum et Barnabam et eiecerunt eos de finibus suis."
,"51":"At illi, excusso pulvere pedum in eos, venerunt Iconium;"
,"52":"discipuli quoque replebantur gaudio et Spiritu Sancto."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Factum est autem Iconii, ut eodem modo introirent syna gogam Iudaeorum et ita loquerentur, ut crederet Iudaeorum et Graecorum copiosa multitudo."
,"2":"Qui vero increduli fuerunt Iudaei, suscitaverunt et exacerbaverunt animas gentium adversus fratres."
,"3":"Multo igitur tempore demorati sunt, fiducialiter agentes in Domino, testimonium perhibente verbo gratiae suae, dante signa et prodigia fieri per manus eorum."
,"4":"Divisa est autem multitudo civitatis: et quidam quidem erant cum Iudaeis, quidam vero cum apostolis."
,"5":"Cum autem factus esset impetus gentilium et Iudaeorum cum principibus suis, ut contumeliis afficerent et lapidarent eos,"
,"6":"intellegentes confugerunt ad civitates Lycaoniae, Lystram et Derben et ad regionem in circuitu"
,"7":"et ibi evangelizantes erant."
,"8":"Et quidam vir in Lystris infirmus pedibus sedebat, claudus ex utero matris suae, qui numquam ambulaverat."
,"9":"Hic audivit Paulum loquentem; qui intuitus eum et videns quia haberet fidem, ut salvus fieret,"
,"10":"dixit magna voce: ' Surge super pedes tuos rectus! '. Et exsilivit et ambulabat."
,"11":"Turbae autem cum vidissent, quod fecerat Paulus, levaverunt vocem suam Lycaonice dicentes: ' Dii similes facti hominibus descenderunt ad nos! ';"
,"12":"et vocabant Barnabam Iovem, Paulum vero Mercurium, quoniam ipse erat dux verbi."
,"13":"Sacerdos quoque templi Iovis, quod erat ante civitatem, tauros et coronas ad ianuas afferens cum populis, volebat sacrificare."
,"14":"Quod ubi audierunt apostoli Barnabas et Paulus, conscissis tunicis suis, exsilierunt in turbam clamantes"
,"15":"et dicentes: ' Viri, quid haec facitis? Et nos mortales sumus similes vobis homines, evangelizantes vobis ab his vanis converti ad Deum vivum, qui fecit caelum et terram et mare et omnia, quae in eis sunt."
,"16":"Qui in praeteritis generationibus permisit omnes gentes ambulare in viis suis;"
,"17":"et quidem non sine testimonio semetipsum reliquit benefaciens, de caelo dans vobis pluvias et tempora fructifera, implens cibo et laetitia corda vestra '."
,"18":"Et haec dicentes vix sedaverunt turbas, ne sibi immolarent."
,"19":"Supervenerunt autem ab Antiochia et Iconio Iudaei et persuasis turbis lapidantesque Paulum trahebant extra civitatem aestimantes eum mortuum esse."
,"20":"Circumdantibus autem eum discipulis, surgens intravit civitatem. Et postera die profectus est cum Barnaba in Derben."
,"21":"Cumque evangelizassent civitati illi et docuissent multos, reversi sunt Lystram et Iconium et Antiochiam"
,"22":"confirmantes animas discipulorum, exhortantes, ut permanerent in fide, et quoniam per multas tribulationes oportet nos intrare in regnum Dei."
,"23":"Et cum ordinassent illis per singulas ecclesias presbyteros et orassent cum ieiunationibus, commendaverunt eos Domino, in quem crediderant."
,"24":"Transeuntesque Pisidiam venerunt Pamphyliam;"
,"25":"et loquentes in Perge verbum descenderunt in Attaliam."
,"26":"Et inde navigaverunt Antiochiam, unde erant traditi gratiae Dei in opus, quod compleverunt."
,"27":"Cum autem venissent et congregassent ecclesiam, rettulerunt quanta fecisset Deus cum illis et quia aperuisset gentibus ostium fidei."
,"28":"Morati sunt autem tempus non modicum cum discipulis."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Et quidam descendentes de Iudaea docebant fratres: ' Nisi circumcidamini secundum morem Moysis, non potestis salvi fieri '."
,"2":"Facta autem seditione et conquisitione non minima Paulo et Barnabae adversum illos, statuerunt, ut ascenderent Paulus et Barnabas et quidam alii ex illis ad apostolos et presbyteros in Ierusalem super hac quaestione."
,"3":"Illi igitur deducti ab ecclesia pertransiebant Phoenicen et Samariam narrantes conversionem gentium et faciebant gaudium magnum omnibus fratribus."
,"4":"Cum autem venissent Hierosolymam, suscepti sunt ab ecclesia et apostolis et presbyteris et annuntiaverunt quanta Deus fecisset cum illis."
,"5":"Surrexerunt autem quidam de haeresi pharisaeorum, qui crediderant, dicentes: ' Oportet circumcidere eos, praecipere quoque servare legem Moysis! '."
,"6":"Conveneruntque apostoli et presbyteri videre de verbo hoc."
,"7":"Cum autem magna conquisitio fieret, surgens Petrus dixit ad eos: ' Viri fratres, vos scitis quoniam ab antiquis diebus in vobis elegit Deus per os meum audire gentes verbum evangelii et credere;"
,"8":"et qui novit corda, Deus, testimonium perhibuit illis dans Spiritum Sanctum sicut et nobis;"
,"9":"et nihil discrevit inter nos et illos fide purificans corda eorum."
,"10":"Nunc ergo quid tentatis Deum imponere iugum super cervicem discipulorum, quod neque patres nostri neque nos portare potuimus?"
,"11":"Sed per gratiam Domini Iesu credimus salvari quemadmodum et illi '."
,"12":"Tacuit autem omnis multitudo, et audiebant Barnabam et Paulum narrantes quanta fecisset Deus signa et prodigia in gentibus per eos."
,"13":"Et postquam tacuerunt, respondit Iacobus dicens: ' Viri fratres, audite me."
,"14":"Simeon narravit quemadmodum primum Deus visitavit sumere ex gentibus populum nomini suo;"
,"15":"et huic concordant verba Prophetarum, sicut scriptum est:"
,"16":"'Post haec revertar,et reaedificabo tabernaculum David, quod decidit, et diruta eius reaedificabo et erigam illud."
,"17":"ut requirant reliqui hominum Dominum,et omnes gentes, super quas invocatum est nomen meum, dicit Dominus faciens haec 18 nota a saeculo'."
,"19":"Propter quod ego iudico non inquietari eos, qui ex gentibus convertuntur ad Deum,"
,"20":"sed scribere ad eos, ut abstineant se a contaminationibus simulacrorum et fornicatione et suffocato et sanguine."
,"21":"Moyses enim a generationibus antiquis habet in singulis civitatibus, qui eum praedicent in synagogis, ubi per omne sabbatum legitur '."
,"22":"Tunc placuit apostolis et presbyteris cum omni ecclesia electos viros ex eis mittere Antiochiam cum Paulo et Barnaba: Iudam, qui cognominatur Barsabbas, et Silam, viros primos in fratribus,"
,"23":"scribentes per manum eorum: ' Apostoli et presbyteri fratres his, qui sunt Antiochiae et Syriae et Ciliciae, fratribus ex gentibus, salutem!"
,"24":"Quoniam audivimus quia quidam ex nobis, quibus non mandavimus, exeuntes turbaverunt vos verbis evertentes animas vestras,"
,"25":"placuit nobis collectis in unum eligere viros et mittere ad vos cum carissimis nobis Barnaba et Paulo,"
,"26":"hominibus, qui tradiderunt animas suas pro nomine Domini nostri Iesu Christi."
,"27":"Misimus ergo Iudam et Silam, qui et ipsi verbis referent eadem."
,"28":"Visum est enim Spiritui Sancto et nobis nihil ultra imponere vobis oneris quam haec necessario:"
,"29":"abstinere ab idolothytis et sanguine et suffocatis et fornicatione; a quibus custodientes vos bene agetis. Valete '."
,"30":"Illi igitur dimissi descenderunt Antiochiam et, congregata multitudine, tradiderunt epistulam;"
,"31":"quam cum legissent, gavisi sunt super consolatione."
,"32":"Iudas quoque et Silas, cum et ipsi essent prophetae, verbo plurimo consolati sunt fratres et confirmaverunt."
,"33":"Facto autem tempore, dimissi sunt cum pace a fratribus ad eos, qui miserant illos. (34) 35 Paulus autem et Barnabas demorabantur Antiochiae docentes et evangelizantes cum aliis pluribus verbum Domini."
,"36":"Post aliquot autem dies dixit ad Barnabam Paulus: ' Revertentes visitemus fratres per universas civitates, in quibus praedicavimus verbum Domini, quomodo se habeant '."
,"37":"Barnabas autem volebat secum assumere et Ioannem, qui cognominatur Marcus;"
,"38":"Paulus autem iudicabat eum, qui discessisset ab eis a Pamphylia et non isset cum eis in opus, non debere recipi eum."
,"39":"Facta est autem exacerbatio, ita ut discederent ab invicem, et Barnabas, assumpto Marco, navigaret Cyprum."
,"40":"Paulus vero, electo Sila, profectus est, traditus gratiae Domini a fratribus;"
,"41":"perambulabat autem Syriam et Ciliciam confirmans ecclesias."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Pervenit autem in Derben et Lystram. Et ecce discipulus quidam erat ibi nomine Timotheus, filius mulieris Iudaeae fidelis, patre autem Graeco;"
,"2":"huic testimonium reddebant, qui in Lystris erant et Iconii fratres."
,"3":"Hunc voluit Paulus secum proficisci et assumens circumcidit eum propter Iudaeos, qui erant in illis locis; sciebant enim omnes quod pater eius Graecus esset."
,"4":"Cum autem pertransirent civitates, tradebant eis custodire dogmata, quae erant decreta ab apostolis et presbyteris, qui essent Hierosolymis."
,"5":"Ecclesiae quidem confirmabantur fide et abundabant numero cotidie."
,"6":"Transierunt autem Phrygiam et Galatiae regionem, vetati a Sancto Spiritu loqui verbum in Asia;"
,"7":"cum venissent autem circa Mysiam, tentabant ire Bithyniam, et non permisit eos Spiritus Iesu;"
,"8":"cum autem praeterissent Mysiam, descenderunt Troadem."
,"9":"Et visio per noctem Paulo ostensa est: vir Macedo quidam erat stans et deprecans eum et dicens: ' Transiens in Macedoniam, adiuva nos! '."
,"10":"Ut autem visum vidit, statim quaesivimus proficisci in Macedoniam, certi facti quia vocasset nos Deus evangelizare eis."
,"11":"Navigantes autem a Troade recto cursu venimus Samothraciam et sequenti die Neapolim"
,"12":"et inde Philippos, quae est prima partis Macedoniae civitas, colonia. Eramus autem in hac urbe diebus aliquot commorantes."
,"13":"Die autem sabbatorum egressi sumus foras portam iuxta flumen, ubi putabamus orationem esse, et sedentes loquebamur mulieribus, quae convenerant."
,"14":"Et quaedam mulier nomine Lydia, purpuraria civitatis Thyatirenorum colens Deum, audiebat, cuius Dominus aperuit cor intendere his, quae dicebantur a Paulo."
,"15":"Cum autem baptizata esset et domus eius, deprecata est dicens: ' Si iudicastis me fidelem Domino esse, introite in domum meam et manete '; et coegit nos."
,"16":"Factum est autem, euntibus nobis ad orationem, puellam quandam habentem spiritum pythonem obviare nobis, quae quaestum magnum praestabat dominis suis divinando."
,"17":"Haec subsecuta Paulum et nos clamabat dicens: ' Isti homines servi Dei Altissimi sunt, qui annuntiant vobis viam salutis '."
,"18":"Hoc autem faciebat multis diebus. Dolens autem Paulus et conversus spiritui dixit: ' Praecipio tibi in nomine Iesu Christi exire ab ea '; et exiit eadem hora."
,"19":"Videntes autem domini eius quia exivit spes quaestus eorum, apprehendentes Paulum et Silam traxerunt in forum ad principes;"
,"20":"et producentes eos magistratibus dixerunt: ' Hi homines conturbant civitatem nostram, cum sint Iudaei,"
,"21":"et annuntiant mores, quos non licet nobis suscipere neque facere, cum simus Romani '."
,"22":"Et concurrit plebs adversus eos; et magistratus, scissis tunicis eorum, iusserunt virgis caedi"
,"23":"et, cum multas plagas eis imposuissent, miserunt eos in carcerem, praecipientes custodi, ut caute custodiret eos;"
,"24":"qui cum tale praeceptum accepisset, misit eos in interiorem carcerem et pedes eorum strinxit in ligno."
,"25":"Media autem nocte, Paulus et Silas orantes laudabant Deum, et audiebant eos, qui in custodia erant;"
,"26":"subito vero terraemotus factus est magnus, ita ut moverentur fundamenta carceris, et aperta sunt statim ostia omnia, et universorum vincula soluta sunt."
,"27":"Expergefactus autem custos carceris et videns apertas ianuas carceris, evaginato gladio volebat se interficere, aestimans fugisse vinctos."
,"28":"Clamavit autem Paulus magna voce dicens: ' Nihil feceris tibi mali; universi enim hic sumus '."
,"29":"Petitoque lumine, intro cucurrit et tremefactus procidit Paulo et Silae;"
,"30":"et producens eos foras ait: ' Domini, quid me oportet facere, ut salvus fiam? '."
,"31":"At illi dixerunt: ' Crede in Domino Iesu et salvus eris tu et domus tua '."
,"32":"Et locuti sunt ei verbum Domini cum omnibus, qui erant in domo eius."
,"33":"Et tollens eos in illa hora noctis lavit eos a plagis, et baptizatus est ipse et omnes eius continuo;"
,"34":"cumque perduxisset eos in domum, apposuit mensam et laetatus est cum omni domo sua credens Deo."
,"35":"Et cum dies factus esset, miserunt magistratus lictores dicentes: ' Dimitte homines illos! '."
,"36":"Nuntiavit autem custos carceris verba haec Paulo: ' Miserunt magistratus, ut dimittamini; nunc igitur exeuntes ite in pace '."
,"37":"Paulus autem dixit eis: ' Caesos nos publice, indemnatos, cum homines Romani essemus, miserunt in carcerem; et nunc occulte nos eiciunt? Non ita, sed veniant et ipsi nos educant '."
,"38":"Nuntiaverunt autem magistratibus lictores verba haec. Timueruntque audito quod Romani essent;"
,"39":"et venientes deprecati sunt eos et educentes rogabant, ut egrederentur urbem."
,"40":"Exeuntes autem de carcere introierunt ad Lydiam et, visis fratribus, consolati sunt eos et profecti sunt."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Cum autem perambulassent Amphipolim et Apolloniam, venerunt Thessalonicam, ubi erat synagoga Iudaeorum."
,"2":"Secundum consuetudinem autem suam Paulus introivit ad eos et per sabbata tria disserebat eis de Scripturis"
,"3":"adaperiens et comprobans quia Christum oportebat pati et resurgere a mortuis, et: ' Hic est Christus, Iesus, quem ego annuntio vobis '."
,"4":"Et quidam ex eis crediderunt et adiuncti sunt Paulo et Silae et de colentibus Graecis multitudo magna et mulieres nobiles non paucae."
,"5":"Zelantes autem Iudaei assumentesque de foro viros quosdam malos et turba facta concitaverunt civitatem; et assistentes domui Iasonis quaerebant eos producere in populum."
,"6":"Et cum non invenissent eos, trahebant Iasonem et quosdam fratres ad politarchas clamantes: ' Qui orbem concitaverunt, isti et huc venerunt,"
,"7":"quos suscepit Iason; et hi omnes contra decreta Caesaris faciunt, regem alium dicentes esse, Iesum '."
,"8":"Concitaverunt autem plebem et politarchas audientes haec;"
,"9":"et accepto satis ab Iasone et a ceteris, dimiserunt eos."
,"10":"Fratres vero confestim per noctem dimiserunt Paulum et Silam in Beroeam; qui cum advenissent, in synagogam Iudaeorum introierunt."
,"11":"Hi autem erant nobiliores eorum, qui sunt Thessalonicae, qui susceperunt verbum cum omni aviditate, cotidie scrutantes Scripturas, si haec ita se haberent."
,"12":"Et multi quidem crediderunt ex eis et Graecarum mulierum honestarum et virorum non pauci."
,"13":"Cum autem cognovissent in Thessalonica Iudaei quia et Beroeae annuntiatum est a Paulo verbum Dei, venerunt et illuc commoventes et turbantes multitudinem."
,"14":"Statimque tunc Paulum dimiserunt fratres, ut iret usque ad mare; Silas autem et Timotheus remanserunt ibi."
,"15":"Qui autem deducebant Paulum, perduxerunt usque Athenas; et accepto mandato ad Silam et Timotheum, ut quam celerrime venirent ad illum, profecti sunt."
,"16":"Paulus autem cum Athenis eos exspectaret, irritabatur spiritus eius in ipso videns idololatriae deditam civitatem."
,"17":"Disputabat igitur in synagoga cum Iudaeis et colentibus et in foro per omnes dies ad eos, qui aderant."
,"18":"Quidam autem ex Epicureis et Stoicis philosophi disserebant cum eo. Et quidam dicebant: ' Quid vult seminiverbius hic dicere? '; alii vero: ' Novorum daemoniorum videtur annuntiator esse ', quia Iesum et resurrectionem evangelizabat."
,"19":"Et apprehensum eum ad Areopagum duxerunt dicentes: ' Possumus scire quae est haec nova, quae a te dicitur, doctrina?"
,"20":"Mira enim quaedam infers auribus nostris; volumus ergo scire quidnam velint haec esse '."
,"21":"Athenienses autem omnes et advenae hospites ad nihil aliud vacabant nisi aut dicere aut audire aliquid novi."
,"22":"Stans autem Paulus in medio Areopagi ait: ' Viri Athenienses, per omnia quasi superstitiosiores vos video;"
,"23":"praeteriens enim et videns simulacra vestra inveni et aram, in qua scriptum erat: 'Ignoto deo'. Quod ergo ignorantes colitis, hoc ego annuntio vobis."
,"24":"Deus, qui fecit mundum et omnia, quae in eo sunt, hic, caeli et terrae cum sit Dominus, non in manufactis templis inhabitat"
,"25":"nec manibus humanis colitur indigens aliquo, cum ipse det omnibus vitam et inspirationem et omnia;"
,"26":"fecitque ex uno omne genus hominum inhabitare super universam faciem terrae, definiens statuta tempora et terminos habitationis eorum,"
,"27":"quaerere Deum, si forte attrectent eum et inveniant, quamvis non longe sit ab unoquoque nostrum."
,"28":"In ipso enim vivimus et movemur et sumus, sicut et quidam vestrum poetarum dixerunt: 'Ipsius enim et genus sumus'."
,"29":"Genus ergo cum simus Dei, non debemus aestimare auro aut argento aut lapidi, sculpturae artis et cogitationis hominis, divinum esse simile."
,"30":"Et tempora quidem ignorantiae despiciens Deus, nunc annuntiat hominibus, ut omnes ubique paenitentiam agant,"
,"31":"eo quod statuit diem, in qua iudicaturus est orbem in iustitia in viro, quem constituit, fidem praebens omnibus suscitans eum a mortuis '."
,"32":"Cum audissent autem resurrectionem mortuorum, quidam quidem irridebant, quidam vero dixerunt: ' Audiemus te de hoc iterum '."
,"33":"Sic Paulus exivit de medio eorum."
,"34":"Quidam vero viri adhaerentes ei crediderunt; in quibus et Dionysius Areopagita et mulier nomine Damaris et alii cum eis."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Post haec discedens ab Athe nis venit Corinthum."
,"2":"Et in veniens quendam Iudaeum nomine Aquilam, Ponticum genere, qui nuper venerat ab Italia, et Priscillam uxorem eius, eo quod praecepisset Claudius discedere omnes Iudaeos a Roma, accessit ad eos"
,"3":"et, quia eiusdem erat artis, manebat apud eos et operabatur; erant autem scenofactoriae artis."
,"4":"Disputabat autem in synagoga per omne sabbatum suadebatque Iudaeis et Graecis."
,"5":"Cum venissent autem de Macedonia Silas et Timotheus, instabat verbo Paulus testificans Iudaeis esse Christum Iesum."
,"6":"Contradicentibus autem eis et blasphemantibus, excutiens vestimenta dixit ad eos: ' Sanguis vester super caput vestrum! Mundus ego. Ex hoc nunc ad gentes vadam '."
,"7":"Et migrans inde intravit in domum cuiusdam nomine Titi Iusti, colentis Deum, cuius domus erat coniuncta synagogae."
,"8":"Crispus autem archisynagogus credidit Domino cum omni domo sua, et multi Corinthiorum audientes credebant et baptizabantur."
,"9":"Dixit autem Dominus nocte per visionem Paulo: ' Noli timere, sed loquere et ne taceas,"
,"10":"quia ego sum tecum, et nemo apponetur tibi, ut noceat te, quoniam populus est mihi multus in hac civitate '."
,"11":"Sedit autem annum et sex menses docens apud eos verbum Dei."
,"12":"Gallione autem proconsule Achaiae, insurrexerunt uno animo Iudaei in Paulum et adduxerunt eum ad tribunal"
,"13":"dicentes: ' Contra legem hic persuadet hominibus colere Deum '."
,"14":"Incipiente autem Paulo aperire os, dixit Gallio ad Iudaeos: ' Si quidem esset iniquum aliquid aut facinus pessimum, o Iudaei, merito vos sustinerem;"
,"15":"si vero quaestiones sunt de verbo et nominibus et lege vestra, vos ipsi videritis; iudex ego horum nolo esse '."
,"16":"Et minavit eos a tribunali."
,"17":"Apprehendentes autem omnes Sosthenen, principem synagogae, percutiebant ante tribunal; et nihil horum Gallioni curae erat."
,"18":"Paulus vero, cum adhuc sustinuisset dies multos, fratribus valefaciens navigabat Syriam, et cum eo Priscilla et Aquila, qui sibi totonderat in Cenchreis caput; habebat enim votum."
,"19":"Deveneruntque Ephesum, et illos ibi reliquit; ipse vero ingressus synagogam disputabat cum Iudaeis."
,"20":"Rogantibus autem eis, ut ampliore tempore maneret, non consensit,"
,"21":"sed valefaciens et dicens: ' Iterum revertar ad vos Deo volente ', navigavit ab Epheso;"
,"22":"et descendens Caesaream ascendit et salutavit ecclesiam et descendit Antiochiam."
,"23":"Et facto ibi aliquanto tempore, profectus est perambulans ex ordine Galaticam regionem et Phrygiam, confirmans omnes discipulos."
,"24":"Iudaeus autem quidam Apollo nomine, Alexandrinus natione, vir eloquens, devenit Ephesum, potens in Scripturis."
,"25":"Hic erat catechizatus viam Domini; et fervens spiritu loquebatur et docebat diligenter ea, quae sunt de Iesu, sciens tantum baptisma Ioannis."
,"26":"Hic ergo coepit fiducialiter agere in synagoga; quem cum audissent Priscilla et Aquila, assumpserunt eum et diligentius exposuerunt ei viam Dei."
,"27":"Cum autem vellet transire in Achaiam, exhortati fratres scripserunt discipulis, ut susciperent eum; qui cum venisset, contulit multum his, qui crediderant per gratiam;"
,"28":"vehementer enim Iudaeos revincebat publice, ostendens per Scripturas esse Christum Iesum."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Factum est autem, cum Apollo esset Corinthi, ut Paulus, peragratis superioribus partibus, veniret Ephesum et inveniret quosdam discipulos;"
,"2":"dixitque ad eos: ' Si Spiritum Sanctum accepistis credentes? '. At illi ad eum: ' Sed neque, si Spiritus Sanctus est, audivimus '."
,"3":"Ille vero ait: ' In quo ergo baptizati estis? '. Qui dixerunt: ' In Ioannis baptismate '."
,"4":"Dixit autem Paulus: ' Ioannes baptizavit baptisma paenitentiae, populo dicens in eum, qui venturus esset post ipsum ut crederent, hoc est in Iesum '."
,"5":"His auditis, baptizati sunt in nomine Domini Iesu;"
,"6":"et cum imposuisset illis manus Paulus, venit Spiritus Sanctus super eos, et loquebantur linguis et prophetabant."
,"7":"Erant autem omnes viri fere duodecim."
,"8":"Introgressus autem synagogam cum fiducia loquebatur per tres menses disputans et suadens de regno Dei."
,"9":"Cum autem quidam indurarentur et non crederent maledicentes viam coram multitudine, discedens ab eis segregavit discipulos, cotidie disputans in schola Tyranni."
,"10":"Hoc autem factum est per biennium, ita ut omnes, qui habitabant in Asia, audirent verbum Domini, Iudaei atque Graeci."
,"11":"Virtutesque non quaslibet Deus faciebat per manus Pauli,"
,"12":"ita ut etiam super languidos deferrentur a corpore eius sudaria vel semicinctia, et recederent ab eis languores, et spiritus nequam egrederentur."
,"13":"Tentaverunt autem quidam et de circumeuntibus Iudaeis exorcistis invocare super eos, qui habebant spiritus malos, nomen Domini Iesu dicentes: ' Adiuro vos per Iesum, quem Paulus praedicat '."
,"14":"Erant autem cuiusdam Scevae Iudaei principis sacerdotum septem filii, qui hoc faciebant."
,"15":"Respondens autem spiritus nequam dixit eis: ' Iesum novi et Paulum scio; vos autem qui estis? '."
,"16":"Et insiliens homo in eos, in quo erat spiritus malus, dominatus amborum invaluit contra eos, ita ut nudi et vulnerati effugerent de domo illa."
,"17":"Hoc autem notum factum est omnibus Iudaeis atque Graecis, qui habitabant Ephesi, et cecidit timor super omnes illos, et magnificabatur nomen Domini Iesu."
,"18":"Multique credentium veniebant confitentes et annuntiantes actus suos."
,"19":"Multi autem ex his, qui fuerant curiosa sectati, conferentes libros combusserunt coram omnibus; et computaverunt pretia illorum et invenerunt argenti quinquaginta milia."
,"20":"Ita fortiter verbum Domini crescebat et convalescebat."
,"21":"His autem expletis, proposuit Paulus in Spiritu, transita Macedonia et Achaia, ire Hierosolymam, dicens: ' Postquam fuero ibi, oportet me et Romam videre '."
,"22":"Mittens autem in Macedoniam duos ex ministrantibus sibi, Timotheum et Erastum, ipse remansit ad tempus in Asia."
,"23":"Facta est autem in illo tempore turbatio non minima de via."
,"24":"Demetrius enim quidam nomine, argentarius, faciens aedes argenteas Dianae praestabat artificibus non modicum quaestum;"
,"25":"quos congregans et eos, qui eiusmodi erant opifices, dixit: ' Viri, scitis quia de hoc artificio acquisitio est nobis;"
,"26":"et videtis et auditis quia non solum Ephesi, sed paene totius Asiae Paulus hic suadens avertit multam turbam dicens quoniam non sunt dii, qui manibus fiunt."
,"27":"Non solum autem haec periclitatur nobis pars in redargutionem venire, sed et magnae deae Dianae templum in nihilum reputari, et destrui incipiet maiestas eius, quam tota Asia et orbis colit '."
,"28":"His auditis, repleti sunt ira et clamabant dicentes: ' Magna Diana Ephesiorum! ';"
,"29":"et impleta est civitas confusione, et impetum fecerunt uno animo in theatrum, rapto Gaio et Aristarcho Macedonibus, comitibus Pauli."
,"30":"Paulo autem volente intrare in populum, non permiserunt discipuli;"
,"31":"quidam autem de Asiarchis, qui erant amici eius, miserunt ad eum rogantes, ne se daret in theatrum."
,"32":"Alii autem aliud clamabant; erat enim ecclesia confusa, et plures nesciebant qua ex causa convenissent."
,"33":"De turba autem instruxerunt Alexandrum, propellentibus eum Iudaeis; Alexander ergo, manu silentio postulato, volebat rationem reddere populo."
,"34":"Quem ut cognoverunt Iudaeum esse, vox facta est una omnium quasi per horas duas clamantium: ' Magna Diana Ephesiorum '."
,"35":"Et cum sedasset scriba turbam, dixit: ' Viri Ephesii, quis enim est hominum, qui nesciat Ephesiorum civitatem cultricem esse magnae Dianae et simulacri a Iove delapsi?"
,"36":"Cum ergo his contradici non possit, oportet vos sedatos esse et nihil temere agere."
,"37":"Adduxistis enim homines istos neque sacrilegos neque blasphemantes deam nostram."
,"38":"Quod si Demetrius et, qui cum eo sunt, artifices habent adversus aliquem causam, conventus forenses aguntur, et proconsules sunt: accusent invicem."
,"39":"Si quid autem ulterius quaeritis, in legitima ecclesia poterit absolvi."
,"40":"Nam et periclitamur argui seditionis hodiernae, cum nullus obnoxius sit, de quo non possimus reddere rationem concursus istius '. Et cum haec dixisset, dimisit ecclesiam."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Postquam autem cessavit tumultus, accersitis Paulus discipulis et exhortatus eos, valedixit et profectus est, ut iret in Macedoniam."
,"2":"Cum autem perambulasset partes illas et exhortatus eos fuisset multo sermone, venit ad Graeciam;"
,"3":"cumque fecisset menses tres, factae sunt illi insidiae a Iudaeis navigaturo in Syriam, habuitque consilium, ut reverteretur per Macedoniam."
,"4":"Comitabatur autem eum Sopater Pyrrhi Beroeensis, Thessalonicensium vero Aristarchus et Secundus et Gaius Derbeus et Timotheus, Asiani vero Tychicus et Trophimus."
,"5":"Hi cum praecessissent, sustinebant nos Troade;"
,"6":"nos vero navigavimus post dies Azymorum a Philippis et venimus ad eos Troadem in diebus quinque, ubi demorati sumus diebus septem."
,"7":"In una autem sabbatorum, cum convenissemus ad frangendum panem, Paulus disputabat eis, profecturus in crastinum, protraxitque sermonem usque in mediam noctem."
,"8":"Erant autem lampades copiosae in cenaculo, ubi eramus congregati;"
,"9":"sedens autem quidam adulescens nomine Eutychus super fenestram, cum mergeretur somno gravi, disputante diutius Paulo, eductus somno cecidit de tertio cenaculo deorsum et sublatus est mortuus."
,"10":"Cum descendisset autem Paulus, incubuit super eum et complexus dixit: ' Nolite turbari, anima enim ipsius in eo est! '."
,"11":"Ascendens autem frangensque panem et gustans satisque allocutus usque in lucem, sic profectus est."
,"12":"Adduxerunt autem puerum viventem et consolati sunt non minime."
,"13":"Nos autem praecedentes navi enavigavimus in Asson, inde suscepturi Paulum; sic enim disposuerat volens ipse per terram iter facere."
,"14":"Cum autem convenisset nos in Asson, assumpto eo, venimus Mitylenen"
,"15":"et inde navigantes sequenti die pervenimus contra Chium et alia applicuimus Samum et sequenti venimus Miletum."
,"16":"Proposuerat enim Paulus transnavigare Ephesum, ne qua mora illi fieret in Asia; festinabat enim, si possibile sibi esset, ut diem Pentecosten faceret Hierosolymis."
,"17":"A Mileto autem mittens Ephesum convocavit presbyteros ecclesiae."
,"18":"Qui cum venissent ad eum, dixit eis: ' Vos scitis a prima die, qua ingressus sum in Asiam, qualiter vobiscum per omne tempus fuerim,"
,"19":"serviens Domino cum omni humilitate et lacrimis et tentationibus, quae mihi acciderunt in insidiis Iudaeorum;"
,"20":"quomodo nihil subtraxerim utilium, quominus annuntiarem vobis et docerem vos publice et per domos,"
,"21":"testificans Iudaeis atque Graecis in Deum paenitentiam et fidem in Dominum nostrum Iesum."
,"22":"Et nunc ecce alligatus ego Spiritu vado in Ierusalem, quae in ea eventura sint mihi ignorans,"
,"23":"nisi quod Spiritus Sanctus per omnes civitates protestatur mihi dicens quoniam vincula et tribulationes me manent."
,"24":"Sed nihili facio animam meam pretiosam mihi, dummodo consummem cursum meum et ministerium, quod accepi a Domino Iesu, testificari evangelium gratiae Dei."
,"25":"Et nunc ecce ego scio quia amplius non videbitis faciem meam vos omnes, per quos transivi praedicans regnum;"
,"26":"quapropter contestor vos hodierna die, quia mundus sum a sanguine omnium;"
,"27":"non enim subterfugi, quominus annuntiarem omne consilium Dei vobis."
,"28":"Attendite vobis et universo gregi, in quo vos Spiritus Sanctus posuit episcopos, pascere ecclesiam Dei, quam acquisivit sanguine suo."
,"29":"Ego scio quoniam intrabunt post discessionem meam lupi graves in vos non parcentes gregi;"
,"30":"et ex vobis ipsis exsurgent viri loquentes perversa, ut abstrahant discipulos post se."
,"31":"Propter quod vigilate, memoria retinentes quoniam per triennium nocte et die non cessavi cum lacrimis monens unumquemque vestrum."
,"32":"Et nunc commendo vos Deo et verbo gratiae ipsius, qui potens est aedificare et dare hereditatem in sanctificatis omnibus."
,"33":"Argentum aut aurum aut vestem nullius concupivi;"
,"34":"ipsi scitis quoniam ad ea, quae mihi opus erant et his, qui mecum sunt, ministraverunt manus istae."
,"35":"Omnia ostendi vobis quoniam sic laborantes oportet suscipere infirmos, ac meminisse verborum Domini Iesu, quoniam ipse dixit: 'Beatius est magis dare quam accipere!' '."
,"36":"Et cum haec dixisset, positis genibus suis, cum omnibus illis oravit."
,"37":"Magnus autem fletus factus est omnium; et procumbentes super collum Pauli osculabantur eum"
,"38":"dolentes maxime in verbo, quod dixerat, quoniam amplius faciem eius non essent visuri. Et deducebant eum ad navem."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Cum autem factum esset, ut navigaremus abstracti ab eis, recto cursu venimus Cho et sequenti die Rhodum et inde Patara;"
,"2":"et cum invenissemus navem transfretantem in Phoenicen, ascendentes navigavimus."
,"3":"Cum paruissemus autem Cypro, et relinquentes eam ad sinistram navigabamus in Syriam et venimus Tyrum, ibi enim navis erat expositura onus."
,"4":"Inventis autem discipulis, mansimus ibi diebus septem; qui Paulo dicebant per Spiritum, ne iret Hierosolymam."
,"5":"Et explicitis diebus, profecti ibamus, deducentibus nos omnibus cum uxoribus et filiis usque foras civitatem; et positis genibus in litore orantes,"
,"6":"valefecimus invicem et ascendimus in navem; illi autem redierunt in sua."
,"7":"Nos vero, navigatione explicita, a Tyro devenimus Ptolemaida et, salutatis fratribus, mansimus die una apud illos."
,"8":"Alia autem die profecti venimus Caesaream et intrantes in domum Philippi evangelistae, qui erat de septem, mansimus apud eum."
,"9":"Huic autem erant filiae quattuor virgines prophetantes."
,"10":"Et cum moraremur plures dies, supervenit quidam a Iudaea propheta nomine Agabus;"
,"11":"is cum venisset ad nos et tulisset zonam Pauli, alligans sibi pedes et manus dixit: ' Haec dicit Spiritus Sanctus: Virum, cuius est zona haec, sic alligabunt in Ierusalem Iudaei et tradent in manus gentium '."
,"12":"Quod cum audissemus, rogabamus nos et, qui loci illius erant, ne ipse ascenderet Ierusalem."
,"13":"Tunc respondit Paulus: ' Quid facitis flentes et affligentes cor meum? Ego enim non solum alligari sed et mori in Ierusalem paratus sum propter nomen Domini Iesu '."
,"14":"Et cum ei suadere non possemus, quievimus dicentes: ' Domini voluntas fiat! '."
,"15":"Post dies autem istos praeparati ascendebamus Hierosolymam;"
,"16":"venerunt autem et ex discipulis a Caesarea nobiscum adducentes apud quem hospitaremur, Mnasonem quendam Cyprium, antiquum discipulum."
,"17":"Et cum venissemus Hierosolymam, libenter exceperunt nos fratres."
,"18":"Sequenti autem die introibat Paulus nobiscum ad Iacobum, omnesque collecti sunt presbyteri."
,"19":"Quos cum salutasset, narrabat per singula, quae fecisset Deus in gentibus per ministerium ipsius."
,"20":"At illi cum audissent, glorificabant Deum dixeruntque ei: ' Vides, frater, quot milia sint in Iudaeis, qui crediderunt, et omnes aemulatores sunt legis;"
,"21":"audierunt autem de te quia discessionem doceas a Moyse omnes, qui per gentes sunt, Iudaeos, dicens non debere circumcidere eos filios suos neque secundum consuetudines ambulare."
,"22":"Quid ergo est? Utique audient te supervenisse."
,"23":"Hoc ergo fac, quod tibi dicimus. Sunt nobis viri quattuor votum habentes super se;"
,"24":"his assumptis, sanctifica te cum illis et impende pro illis, ut radant capita, et scient omnes quia, quae de te audierunt, nihil sunt, sed ambulas et ipse custodiens legem."
,"25":"De his autem, qui crediderunt, gentibus nos scripsimus iudicantes, ut abstineant ab idolothyto et sanguine et suffocato et fornicatione '."
,"26":"Tunc Paulus, assumptis viris, postera die purificatus cum illis intravit in templum annuntians expletionem dierum purificationis, donec offerretur pro unoquoque eorum oblatio."
,"27":"Dum autem septem dies consummarentur, hi, qui de Asia erant, Iudaei cum vidissent eum in templo, concitaverunt omnem turbam et iniecerunt ei manus"
,"28":"clamantes: ' Viri Israelitae, adiuvate! Hic est homo, qui adversus populum et legem et locum hunc omnes ubique docens, insuper et Graecos induxit in templum et polluit sanctum locum istum '."
,"29":"Viderant enim Trophimum Ephesium in civitate cum ipso, quem aestimabant quoniam in templum induxisset Paulus."
,"30":"Commotaque est civitas tota, et facta est concursio populi, et apprehendentes Paulum trahebant eum extra templum, et statim clausae sunt ianuae."
,"31":"Quaerentibus autem eum occidere, nuntiatum est tribuno cohortis quia tota confunditur Ierusalem,"
,"32":"qui statim, assumptis militibus et centurionibus, decucurrit ad illos; qui cum vidissent tribunum et milites, cessaverunt percutere Paulum."
,"33":"Tunc accedens tribunus apprehendit eum et iussit alligari catenis duabus et interrogabat quis esset et quid fecisset."
,"34":"Alii autem aliud clamabant in turba; et cum non posset certum cognoscere prae tumultu, iussit duci eum in castra."
,"35":"Et cum venisset ad gradus, contigit ut portaretur a militibus propter vim turbae;"
,"36":"sequebatur enim multitudo populi clamantes: ' Tolle eum! '."
,"37":"Et cum coepisset induci in castra, Paulus dicit tribuno: ' Si licet mihi loqui aliquid ad te? '. Qui dixit: ' Graece nosti?"
,"38":"Nonne tu es Aegyptius, qui ante hos dies tumultum concitasti et eduxisti in desertum quattuor milia virorum sicariorum? '."
,"39":"Et dixit Paulus: ' Ego homo sum quidem Iudaeus a Tarso Ciliciae, non ignotae civitatis municeps; rogo autem te, permitte mihi loqui ad populum '."
,"40":"Et cum ille permisisset, Paulus stans in gradibus annuit manu ad plebem et, magno silentio facto, allocutus est Hebraea lingua dicens:"
}`)
	CurrentBook.AddChapter(22, `{
"1":"' Viri fratres et patres, audi te a me, quam ad vos nunc reddo, rationem '."
,"2":"Cum audissent autem quia Hebraea lingua loquebatur ad illos, magis praestiterunt silentium. Et dixit:"
,"3":"' Ego sum vir Iudaeus, natus Tarso Ciliciae, enutritus autem in ista civitate, secus pedes Gamaliel eruditus iuxta veritatem paternae legis, aemulator Dei, sicut et vos omnes estis hodie."
,"4":"Qui hanc viam persecutus sum usque ad mortem, alligans et tradens in custodias viros ac mulieres,"
,"5":"sicut et princeps sacerdotum testimonium mihi reddit et omne concilium; a quibus et epistulas accipiens ad fratres, Damascum pergebam, ut adducerem et eos, qui ibi essent, vinctos in Ierusalem, uti punirentur."
,"6":"Factum est autem, eunte me et appropinquante Damasco, circa mediam diem subito de caelo circumfulsit me lux copiosa;"
,"7":"et decidi in terram et audivi vocem dicentem mihi: 'Saul, Saul, quid me persequeris?'."
,"8":"Ego autem respondi: 'Quis es, Domine?'. Dixitque ad me: 'Ego sum Iesus Nazarenus, quem tu persequeris'."
,"9":"Et, qui mecum erant, lumen quidem viderunt, vocem autem non audierunt eius, qui loquebatur mecum."
,"10":"Et dixi: 'Quid faciam, Domine?'. Dominus autem dixit ad me: 'Surgens vade Damascum, et ibi tibi dicetur de omnibus, quae statutum est tibi, ut faceres'."
,"11":"Et cum non viderem prae claritate luminis illius, ad manum deductus a comitibus veni Damascum."
,"12":"Ananias autem quidam vir religiosus secundum legem, testimonium habens ab omnibus habitantibus Iudaeis,"
,"13":"veniens ad me et astans dixit mihi: 'Saul frater, respice!'. Et ego eadem hora respexi in eum."
,"14":"At ille dixit: 'Deus patrum nostrorum praeordinavit te, ut cognosceres voluntatem eius et videres Iustum et audires vocem ex ore eius,"
,"15":"quia eris testis illi ad omnes homines eorum, quae vidisti et audisti."
,"16":"Et nunc quid moraris? Exsurgens baptizare et ablue peccata tua, invocato nomine ipsius'."
,"17":"Factum est autem, revertenti mihi in Ierusalem et oranti in templo fieri me in stupore mentis"
,"18":"et videre illum dicentem mihi: 'Festina et exi velociter ex Ierusalem, quoniam non recipient testimonium tuum de me'."
,"19":"Et ego dixi: 'Domine, ipsi sciunt quia ego eram concludens in carcerem et caedens per synagogas eos, qui credebant in te;"
,"20":"et cum funderetur sanguis Stephani testis tui, et ipse astabam et consentiebam et custodiebam vestimenta interficientium illum'."
,"21":"Et dixit ad me: 'Vade, quoniam ego in nationes longe mittam te' '."
,"22":"Audiebant autem eum usque ad hoc verbum et levaverunt vocem suam dicentes: ' Tolle de terra eiusmodi, non enim fas est eum vivere! '."
,"23":"Vociferantibus autem eis et proicientibus vestimenta sua et pulverem iactantibus in aerem,"
,"24":"iussit tribunus induci eum in castra dicens flagellis eum interrogari, ut sciret propter quam causam sic acclamarent ei."
,"25":"Et cum astrinxissent eum loris, dixit astanti centurioni Paulus: ' Si hominem Romanum et indemnatum licet vobis flagellare? '."
,"26":"Quo audito, centurio accedens ad tribunum nuntiavit dicens: ' Quid acturus es? Hic enim homo Romanus est '."
,"27":"Accedens autem tribunus dixit illi: ' Dic mihi, tu Romanus es? '. At ille dixit: ' Etiam '."
,"28":"Et respondit tribunus: ' Ego multa summa civitatem hanc consecutus sum '. Et Paulus ait: ' Ego autem et natus sum '."
,"29":"Protinus ergo discesserunt ab illo, qui eum interrogaturi erant; tribunus quoque timuit, postquam rescivit quia Romanus esset, et quia alligasset eum."
,"30":"Postera autem die, volens scire diligenter qua ex causa accusaretur a Iudaeis, solvit eum et iussit principes sacerdotum convenire et omne concilium et producens Paulum statuit coram illis."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Intendens autem concilium Paulus ait: ' Viri fratres, ego omni conscientia bona conversatus sum ante Deum usque in hodiernum diem '."
,"2":"Princeps autem sacerdotum Ananias praecepit astantibus sibi percutere os eius."
,"3":"Tunc Paulus ad eum dixit: ' Percutiet te Deus, paries dealbate! Et tu sedes iudicans me secundum legem et contra legem iubes me percuti? '."
,"4":"Et, qui astabant, dixerunt: ' Summum sacerdotem Dei maledicis?'."
,"5":"Dixit autem Paulus: ' Nesciebam, fratres, quia princeps est sacerdotum; scriptum est enim: 'Principem populi tui non maledices' '."
,"6":"Sciens autem Paulus quia una pars esset sadducaeorum, et altera pharisaeorum, exclamabat in concilio: ' Viri fratres, ego pharisaeus sum, filius pharisaeorum; de spe et resurrectione mortuorum ego iudicor '."
,"7":"Et cum haec diceret, facta est dissensio inter pharisaeos et sadducaeos; et divisa est multitudo."
,"8":"Sadducaei enim dicunt non esse resurrectionem neque angelum neque spiritum; pharisaei autem utrumque confitentur."
,"9":"Factus est autem clamor magnus; et surgentes scribae quidam partis pharisaeorum pugnabant dicentes: ' Nihil mali invenimus in homine isto: quod si spiritus locutus est ei aut angelus ';"
,"10":"et cum magna dissensio facta esset, timens tribunus ne discerperetur Paulus ab ipsis, iussit milites descendere, ut raperent eum de medio eorum ac deducerent in castra."
,"11":"Sequenti autem nocte, assistens ei Dominus ait: ' Constans esto! Sicut enim testificatus es, quae sunt de me, in Ierusalem, sic te oportet et Romae testificari '."
,"12":"Facta autem die, faciebant concursum Iudaei et devoverunt se dicentes neque manducaturos neque bibituros, donec occiderent Paulum."
,"13":"Erant autem plus quam quadraginta, qui hanc coniurationem fecerant;"
,"14":"qui accedentes ad principes sacerdotum et seniores dixerunt: ' Devotione devovimus nos nihil gustaturos, donec occidamus Paulum."
,"15":"Nunc ergo vos notum facite tribuno cum concilio, ut producat illum ad vos, tamquam aliquid certius cognituri de eo; nos vero, priusquam appropiet, parati sumus interficere illum '."
,"16":"Quod cum audisset filius sororis Pauli insidias, venit et intravit in castra nuntiavitque Paulo."
,"17":"Vocans autem Paulus ad se unum ex centurionibus ait: ' Adulescentem hunc perduc ad tribunum, habet enim aliquid indicare illi '."
,"18":"Et ille quidem assumens eum duxit ad tribunum et ait: ' Vinctus Paulus vocans rogavit me hunc adulescentem perducere ad te, habentem aliquid loqui tibi '."
,"19":"Apprehendens autem tribunus manum illius, secessit cum eo seorsum et interrogabat: ' Quid est, quod habes indicare mihi? '."
,"20":"Ille autem dixit: ' Iudaei constituerunt rogare te, ut crastina die Paulum producas in concilium, quasi aliquid certius inquisiturum sit de illo."
,"21":"Tu ergo ne credideris illis; insidiantur enim ei ex eis viri amplius quadraginta, qui se devoverunt non manducare neque bibere, donec interficiant eum; et nunc parati sunt exspectantes promissum tuum '."
,"22":"Tribunus igitur dimisit adulescentem praecipiens, ne cui eloqueretur quoniam ' haec nota mihi fecisti '."
,"23":"Et vocatis duobus centurionibus, dixit: ' Parate milites ducentos, ut eant usque Caesaream, et equites septuaginta et lancearios ducentos, a tertia hora noctis,"
,"24":"et iumenta praeparate ', ut imponentes Paulum salvum perducerent ad Felicem praesidem,"
,"25":"scribens epistulam habentem formam hanc:"
,"26":"' Claudius Lysias optimo praesidi Felici salutem."
,"27":"Virum hunc comprehensum a Iudaeis et incipientem interfici ab eis, superveniens cum exercitu eripui, cognito quia Romanus est."
,"28":"Volensque scire causam, propter quam accusabant illum, deduxi in concilium eorum;"
,"29":"quem inveni accusari de quaestionibus legis ipsorum, nihil vero dignum morte aut vinculis habentem crimen."
,"30":"Et cum mihi perlatum esset de insidiis, quae in virum pararentur, confestim misi ad te denuntians et accusatoribus, ut dicant adversum eum apud te '."
,"31":"Milites ergo, secundum praeceptum sibi assumentes Paulum, duxerunt per noctem in Antipatridem;"
,"32":"et postera die, dimissis equitibus, ut abirent cum eo, reversi sunt ad castra."
,"33":"Qui cum venissent Caesaream et tradidissent epistulam praesidi, statuerunt ante illum et Paulum."
,"34":"Cum legisset autem et interrogasset de qua provincia esset, et cognoscens quia de Cilicia:"
,"35":"' Audiam te, inquit, cum et accusatores tui venerint '; iussitque in praetorio Herodis custodiri eum."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Post quinque autem dies, descendit princeps sacerdo tum Ananias cum senioribus quibusdam et Tertullo quodam oratore, qui adierunt praesidem adversus Paulum."
,"2":"Et citato eo, coepit accusare Tertullus dicens: ' Cum in multa pace agamus per te, et multa corrigantur genti huic per tuam providentiam,"
,"3":"semper et ubique suscipimus, optime Felix, cum omni gratiarum actione."
,"4":"Ne diutius autem te protraham, oro, breviter audias nos pro tua clementia."
,"5":"Invenimus enim hunc hominem pestiferum et concitantem seditiones omnibus Iudaeis, qui sunt in universo orbe, et auctorem seditionis sectae Nazarenorum,"
,"6":"qui etiam templum violare conatus est, quem et apprehendimus, (7) 8 a quo poteris ipse diiudicans de omnibus istis cognoscere, de quibus nos accusamus eum '. "
,"9":"Adiecerunt autem et Iudaei dicentes haec ita se habere."
,"10":"Respondit autem Paulus, annuente sibi praeside dicere: ' Ex multis annis esse te iudicem genti huic sciens bono animo de causa mea rationem reddam,"
,"11":"cum possis cognoscere quia non plus sunt dies mihi quam duodecim, ex quo ascendi adorare in Ierusalem,"
,"12":"et neque in templo invenerunt me cum aliquo disputantem aut concursum facientem turbae neque in synagogis neque in civitate,"
,"13":"neque probare possunt tibi, de quibus nunc accusant me."
,"14":"Confiteor autem hoc tibi, quod secundum viam, quam dicunt haeresim, sic deservio patrio Deo credens omnibus, quae secundum Legem sunt et in Prophetis scripta,"
,"15":"spem habens in Deum, quam et hi ipsi exspectant, resurrectionem futuram iustorum et iniquorum."
,"16":"In hoc et ipse studeo sine offendiculo conscientiam habere ad Deum et ad homines semper."
,"17":"Post annos autem plures, eleemosynas facturus in gentem meam veni et oblationes;"
,"18":"in quibus invenerunt me purificatum in templo, non cum turba neque cum tumultu;"
,"19":"quidam autem ex Asia Iudaei, quos oportebat apud te praesto esse et accusare, si quid haberent adversum me;"
,"20":"aut hi ipsi dicant quid invenerint iniquitatis, cum starem in concilio,"
,"21":"nisi de una hac voce, qua clamavi inter eos stans: De resurrectione mortuorum ego iudicor hodie apud vos! '."
,"22":"Distulit autem illos Felix certissime sciens ea, quae de hac via sunt, dicens: ' Cum tribunus Lysias descenderit, cognoscam causam vestram ',"
,"23":"iubens centurioni custodiri eum et habere mitigationem, nec quemquam prohibere de suis ministrare ei."
,"24":"Post aliquot autem dies, adveniens Felix cum Drusilla uxore sua, quae erat Iudaea, vocavit Paulum et audivit ab eo de fide, quae est in Christum Iesum."
,"25":"Disputante autem illo de iustitia et continentia et de iudicio futuro, timefactus Felix respondit: ' Quod nunc attinet, vade; tempore autem opportuno accersiam te ',"
,"26":"simul et sperans quia pecunia daretur sibi a Paulo; propter quod et frequenter accersiens eum loquebatur cum eo."
,"27":"Biennio autem expleto, accepit successorem Felix Porcium Festum; volensque gratiam praestare Iudaeis, Felix reliquit Paulum vinctum."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Festus ergo cum venisset in provinciam, post triduum ascendit Hierosolymam a Caesarea;"
,"2":"adieruntque eum principes sacerdotum et primi Iudaeorum adversus Paulum, et rogabant eum"
,"3":"postulantes gratiam adversum eum, ut iuberet perduci eum in Ierusalem, insidias tendentes, ut eum interficerent in via."
,"4":"Festus igitur respondit servari Paulum in Caesarea, se autem maturius profecturum:"
,"5":"' Qui ergo in vobis, ait, potentes sunt, descendentes simul, si quod est in viro crimen, accusent eum '."
,"6":"Demoratus autem inter eos dies non amplius quam octo aut decem, descendit Caesaream; et altera die sedit pro tribunali et iussit Paulum adduci."
,"7":"Qui cum perductus esset, circumsteterunt eum, qui ab Hierosolyma descenderant, Iudaei, multas et graves causas obicientes, quas non poterant probare,"
,"8":"Paulo rationem reddente: ' Neque in legem Iudaeorum neque in templum neque in Caesarem quidquam peccavi '."
,"9":"Festus autem volens Iudaeis gratiam praestare, respondens Paulo dixit: ' Vis Hierosolymam ascendere et ibi de his iudicari apud me? '."
,"10":"Dixit autem Paulus: ' Ad tribunal Caesaris sto, ubi me oportet iudicari. Iudaeis nihil nocui, sicut et tu melius nosti."
,"11":"Si ergo iniuste egi et dignum morte aliquid feci, non recuso mori; si vero nihil est eorum, quae hi accusant me, nemo potest me illis donare. Caesarem appello! '."
,"12":"Tunc Festus cum consilio locutus respondit: ' Caesarem appellasti; ad Caesarem ibis '."
,"13":"Et cum dies aliquot transacti essent, Agrippa rex et Berenice descenderunt Caesaream et salutaverunt Festum."
,"14":"Et cum dies plures ibi demorarentur, Festus regi indicavit de Paulo dicens: ' Vir quidam est derelictus a Felice vinctus,"
,"15":"de quo, cum essem Hierosolymis, adierunt me principes sacerdotum et seniores Iudaeorum postulantes adversus illum damnationem;"
,"16":"ad quos respondi, quia non est consuetudo Romanis donare aliquem hominem, priusquam is, qui accusatur, praesentes habeat accusatores locumque defendendi se ab accusatione accipiat."
,"17":"Cum ergo huc convenissent, sine ulla dilatione sequenti die sedens pro tribunali iussi adduci virum;"
,"18":"de quo, cum stetissent accusatores, nullam causam deferebant, de quibus ego suspicabar malis;"
,"19":"quaestiones vero quasdam de sua superstitione habebant adversus eum et de quodam Iesu defuncto, quem affirmabat Paulus vivere."
,"20":"Haesitans autem ego de huiusmodi quaestione, dicebam si vellet ire Hierosolymam et ibi iudicari de istis."
,"21":"Paulo autem appellante, ut servaretur ad Augusti cognitionem, iussi servari eum, donec mittam eum ad Caesarem '."
,"22":"Agrippa autem ad Festum: ' Volebam et ipse hominem audire! '. ' Cras, inquit, audies eum '."
,"23":"Altera autem die, cum venisset Agrippa et Berenice cum multa ambitione, et introissent in auditorium cum tribunis et viris principalibus civitatis, et iubente Festo, adductus est Paulus."
,"24":"Et dicit Festus: ' Agrippa rex et omnes, qui simul adestis nobiscum viri, videtis hunc, de quo omnis multitudo Iudaeorum interpellavit me Hierosolymis et hic, clamantes non oportere eum vivere amplius."
,"25":"Ego vero comperi nihil dignum eum morte fecisse, ipso autem hoc appellante Augustum, iudicavi mittere."
,"26":"De quo quid certum scribam domino, non habeo; propter quod produxi eum ad vos et maxime ad te, rex Agrippa, ut, interrogatione facta, habeam quid scribam;"
,"27":"sine ratione enim mihi videtur mittere vinctum et causas eius non significare '."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Agrippa vero ad Paulum ait: ' Permittitur tibi loqui pro temetipso '. Tunc Paulus, extenta manu, coepit rationem reddere:"
,"2":"' De omnibus, quibus accusor a Iudaeis, rex Agrippa, aestimo me beatum, apud te cum sim defensurus me hodie,"
,"3":"maxime te sciente omnia, quae apud Iudaeos sunt consuetudines et quaestiones; propter quod, obsecro, patienter me audias."
,"4":"Et quidem vitam meam a iuventute, quae ab initio fuit in gente mea et in Hierosolymis, noverunt omnes Iudaei;"
,"5":"praescientes me ab initio, si velint testimonium perhibere, quoniam secundum diligentissimam sectam nostrae religionis vixi pharisaeus."
,"6":"Et nunc propter spem eius, quae ad patres nostros repromissionis facta est a Deo, sto iudicio subiectus,"
,"7":"in quam duodecim tribus nostrae cum perseverantia nocte ac die deservientes sperant devenire; de qua spe accusor a Iudaeis, rex!"
,"8":"Quid incredibile iudicatur apud vos, si Deus mortuos suscitat?"
,"9":"Et ego quidem existimaveram me adversus nomen Iesu Nazareni debere multa contraria agere;"
,"10":"quod et feci Hierosolymis, et multos sanctorum ego in carceribus inclusi, a principibus sacerdotum potestate accepta, et cum occiderentur, detuli sententiam;"
,"11":"et per omnes synagogas frequenter puniens eos compellebam blasphemare, et abundantius insaniens in eos persequebar usque in exteras civitates."
,"12":"In quibus, dum irem Damascum cum potestate et permissu principum sacerdotum,"
,"13":"die media in via vidi, rex, de caelo supra splendorem solis circumfulgens me lumen et eos, qui mecum simul ibant;"
,"14":"omnesque nos cum decidissemus in terram, audivi vocem loquentem mihi Hebraica lingua: 'Saul, Saul, quid me persequeris? Durum est tibi contra stimulum calcitrare'."
,"15":"Ego autem dixi: 'Quis es, Domine?'. Dominus autem dixit: 'Ego sum Iesus, quem tu persequeris."
,"16":"Sed exsurge et sta super pedes tuos; ad hoc enim apparui tibi, ut constituam te ministrum et testem eorum, quae vidisti, et eorum, quibus apparebo tibi,"
,"17":"eripiens te de populo et de gentibus, in quas ego mitto te"
,"18":"aperire oculos eorum, ut convertantur a tenebris ad lucem et de potestate Satanae ad Deum, ut accipiant remissionem peccatorum et sortem inter sanctificatos per fidem, quae est in me'."
,"19":"Unde, rex Agrippa, non fui incredulus caelestis visionis,"
,"20":"sed his, qui sunt Damasci primum et Hierosolymis, et in omnem regionem Iudaeae et gentibus annuntiabam, ut paenitentiam agerent et converterentur ad Deum digna paenitentiae opera facientes."
,"21":"Hac ex causa me Iudaei, cum essem in templo comprehensum, tentabant interficere."
,"22":"Auxilium igitur assecutus a Deo usque in hodiernum diem sto testificans minori atque maiori, nihil extra dicens quam ea, quae Prophetae sunt locuti futura esse et Moyses:"
,"23":"si passibilis Christus, si primus ex resurrectione mortuorum lumen annuntiaturus est populo et gentibus '."
,"24":"Sic autem eo rationem reddente, Festus magna voce dixit: ' Insanis, Paule; multae te litterae ad insaniam convertunt! '."
,"25":"At Paulus: ' Non insanio, inquit, optime Feste, sed veritatis et sobrietatis verba eloquor."
,"26":"Scit enim de his rex, ad quem et audenter loquor; latere enim eum nihil horum arbitror, neque enim in angulo hoc gestum est."
,"27":"Credis, rex Agrippa, Prophetis? Scio quia credis '."
,"28":"Agrippa autem ad Paulum: ' In modico suades me Christianum fieri! '."
,"29":"Et Paulus: ' Optarem apud Deum et in modico et in magno non tantum te sed et omnes hos, qui audiunt me hodie, fieri tales, qualis et ego sum, exceptis vinculis his! '."
,"30":"Et exsurrexit rex et praeses et Berenice et qui assidebant eis;"
,"31":"et cum secessissent, loquebantur ad invicem dicentes: ' Nihil morte aut vinculis dignum quid facit homo iste '."
,"32":"Agrippa autem Festo dixit: ' Dimitti poterat homo hic, si non appellasset Caesarem '."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Ut autem iudicatum est na vigare nos in Italiam, tradiderunt et Paulum et quosdam alios vinctos centurioni nomine Iulio, cohortis Augustae."
,"2":"Ascendentes autem navem Hadramyttenam, incipientem navigare circa Asiae loca, sustulimus, perseverante nobiscum Aristarcho Macedone Thessalonicensi;"
,"3":"sequenti autem die, devenimus Sidonem, et humane tractans Iulius Paulum permisit ad amicos ire et curam sui agere."
,"4":"Et inde cum sustulissemus, subnavigavimus Cypro, propterea quod essent venti contrarii;"
,"5":"et pelagus Ciliciae et Pamphyliae navigantes venimus Myram, quae est Lyciae."
,"6":"Et ibi inveniens centurio navem Alexandrinam navigantem in Italiam transposuit nos in eam."
,"7":"Et cum multis diebus tarde navigaremus et vix devenissemus contra Cnidum, prohibente nos vento, subnavigavimus Cretae secundum Salmonem;"
,"8":"et vix iuxta eam navigantes venimus in locum quendam, qui vocatur Boni Portus, cui iuxta erat civitas Lasaea."
,"9":"Multo autem tempore peracto, et cum iam non esset tuta navigatio, eo quod et ieiunium iam praeterisset, monebat Paulus"
,"10":"dicens eis: ' Viri, video quoniam cum iniuria et multo damno non solum oneris et navis sed etiam animarum nostrarum incipit esse navigatio '."
,"11":"Centurio autem gubernatori et nauclero magis credebat quam his, quae a Paulo dicebantur."
,"12":"Et cum aptus portus non esset ad hiemandum, plurimi statuerunt consilium enavigare inde, si quo modo possent devenientes Phoenicen hiemare, portum Cretae respicientem ad africum et ad caurum."
,"13":"Aspirante autem austro, aestimantes propositum se tenere, cum sustulissent, propius legebant Cretam."
,"14":"Non post multum autem misit se contra ipsam ventus typhonicus, qui vocatur euroaquilo;"
,"15":"cumque arrepta esset navis et non posset conari in ventum, data nave flatibus, ferebamur."
,"16":"Insulam autem quandam decurrentes, quae vocatur Cauda, potuimus vix obtinere scapham,"
,"17":"qua sublata, adiutoriis utebantur accingentes navem; et timentes, ne in Syrtim inciderent, submisso vase, sic ferebantur."
,"18":"Valide autem nobis tempestate iactatis, sequenti die iactum fecerunt"
,"19":"et tertia die suis manibus armamenta navis proiecerunt."
,"20":"Neque sole autem neque sideribus apparentibus per plures dies, et tempestate non exigua imminente, iam auferebatur spes omnis salutis nostrae."
,"21":"Et cum multa ieiunatio fuisset, tunc stans Paulus in medio eorum dixit: ' Oportebat quidem, o viri, audito me, non tollere a Creta lucrique facere iniuriam hanc et iacturam."
,"22":"Et nunc suadeo vobis bono animo esse, nulla enim amissio animae erit ex vobis praeterquam navis;"
,"23":"astitit enim mihi hac nocte angelus Dei, cuius sum ego, cui et deservio,"
,"24":"dicens: 'Ne timeas, Paule; Caesari te oportet assistere, et ecce donavit tibi Deus omnes, qui navigant tecum'."
,"25":"Propter quod bono animo estote, viri; credo enim Deo, quia sic erit, quemadmodum dictum est mihi."
,"26":"In insulam autem quandam oportet nos incidere '."
,"27":"Sed posteaquam quarta decima nox supervenit, cum ferremur in Hadria, circa mediam noctem suspicabantur nautae apparere sibi aliquam regionem."
,"28":"Qui submittentes bolidem invenerunt passus viginti; et pusillum inde separati et rursum submittentes invenerunt passus quindecim;"
,"29":"timentes autem, ne in aspera loca incideremus, de puppi mittentes ancoras quattuor optabant diem fieri."
,"30":"Nautis vero quaerentibus fugere de navi, cum demisissent scapham in mare sub obtentu, quasi a prora inciperent ancoras extendere,"
,"31":"dixit Paulus centurioni et militibus: ' Nisi hi in navi manserint, vos salvi fieri non potestis '."
,"32":"Tunc absciderunt milites funes scaphae et passi sunt eam excidere."
,"33":"Donec autem lux inciperet fieri, rogabat Paulus omnes sumere cibum dicens: ' Quarta decima hodie die exspectantes ieiuni permanetis nihil accipientes;"
,"34":"propter quod rogo vos accipere cibum, hoc enim pro salute vestra est, quia nullius vestrum capillus de capite peribit '."
,"35":"Et cum haec dixisset et sumpsisset panem, gratias egit Deo in conspectu omnium et, cum fregisset, coepit manducare."
,"36":"Animaequiores autem facti omnes et ipsi assumpserunt cibum."
,"37":"Eramus vero universae animae in navi ducentae septuaginta sex."
,"38":"Et satiati cibo alleviabant navem iactantes triticum in mare."
,"39":"Cum autem dies factus esset, terram non agnoscebant; sinum vero quendam considerabant habentem litus, in quem cogitabant, si possent, eicere navem."
,"40":"Et cum ancoras abstulissent, committebant mari simul laxantes iuncturas gubernaculorum et, levato artemone, secundum flatum aurae tendebant ad litus."
,"41":"Et cum incidissent in locum dithalassum, impegerunt navem; et prora quidem fixa manebat immobilis, puppis vero solvebatur a vi fluctuum."
,"42":"Militum autem consilium fuit, ut custodias occiderent, ne quis, cum enatasset, effugeret;"
,"43":"centurio autem volens servare Paulum prohibuit eos a consilio iussitque eos, qui possent natare, mittere se primos et ad terram exire"
,"44":"et ceteros, quosdam in tabulis, quosdam vero super ea, quae de navi essent; et sic factum est ut omnes evaderent ad terram."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Et cum evasissemus, tunc cognovimus quia Melita in sula vocatur."
,"2":"Barbari vero praestabant non modicam humanitatem nobis; accensa enim pyra, suscipiebant nos omnes propter imbrem, qui imminebat, et frigus."
,"3":"Cum congregasset autem Paulus sarmentorum aliquantam multitudinem et imposuisset super ignem, vipera, a calore cum processisset, invasit manum eius."
,"4":"Ut vero viderunt barbari pendentem bestiam de manu eius, ad invicem dicebant: ' Utique homicida est homo hic, qui cum evaserit de mari, Ultio non permisit vivere '."
,"5":"Et ille quidem excutiens bestiam in ignem, nihil mali passus est;"
,"6":"at illi exspectabant eum in tumorem convertendum aut subito casurum et mori. Diu autem illis exspectantibus et videntibus nihil mali in eo fieri, convertentes se dicebant eum esse deum."
,"7":"In locis autem illis erant praedia principis insulae nomine Publii, qui nos suscipiens triduo benigne hospitio recepit."
,"8":"Contigit autem patrem Publii febribus et dysenteria vexatum iacere, ad quem Paulus intravit et, cum orasset et imposuisset ei manus, sanavit eum."
,"9":"Quo facto, et ceteri, qui in insula habebant infirmitates, accedebant et curabantur;"
,"10":"qui etiam multis honoribus nos honoraverunt et navigantibus imposuerunt, quae necessaria erant."
,"11":"Post menses autem tres, navigavimus in navi Alexandrina, quae in insula hiemaverat, cui erat insigne Castorum."
,"12":"Et cum venissemus Syracusam, mansimus ibi triduo;"
,"13":"inde solventes devenimus Rhegium. Et post unum diem, superveniente austro, secunda die venimus Puteolos,"
,"14":"ubi, inventis fratribus, rogati sumus manere apud eos dies septem; et sic venimus Romam."
,"15":"Et inde cum audissent de nobis fratres, occurrerunt nobis usque ad Appii Forum et Tres Tabernas; quos cum vidisset Paulus, gratias agens Deo, accepit fiduciam."
,"16":"Cum introissemus autem Romam, permissum est Paulo manere sibimet cum custodiente se milite."
,"17":"Factum est autem, ut post tertium diem convocaret primos Iudaeorum; cumque convenissent dicebat eis: ' Ego, viri fratres, nihil adversus plebem faciens aut mores paternos, vinctus ab Hierosolymis traditus sum in manus Romanorum,"
,"18":"qui cum interrogationem de me habuissent, volebant dimittere, eo quod nulla causa esset mortis in me;"
,"19":"contradicentibus autem Iudaeis, coactus sum appellare Caesarem, non quasi gentem meam habens aliquid accusare."
,"20":"Propter hanc igitur causam rogavi vos videre et alloqui; propter spem enim Israel catena hac circumdatus sum '."
,"21":"At illi dixerunt ad eum: ' Nos neque litteras accepimus de te a Iudaea, neque adveniens aliquis fratrum nuntiavit aut locutus est quid de te malum."
,"22":"Rogamus autem a te audire quae sentis; nam de secta hac notum est nobis quia ubique ei contradicitur '."
,"23":"Cum constituissent autem illi diem, venerunt ad eum in hospitium plures, quibus exponebat testificans regnum Dei suadensque eos de Iesu ex Lege Moysis et Prophetis a mane usque ad vesperam."
,"24":"Et quidam credebant his, quae dicebantur, quidam vero non credebant;"
,"25":"cumque invicem non essent consentientes, discedebant, dicente Paulo unum verbum: ' Bene Spiritus Sanctus locutus est per Isaiam prophetam ad patres vestros"
,"26":"dicens: 'Vade ad populum istum et dic: Auditu audietis et non intellegetis, et videntes videbitis et non perspicietis."
,"27":"Incrassatum est enim cor populi huius, et auribus graviter audierunt,et oculos suos compresserunt, ne forte videant oculis,et auribus audiant,et corde intellegant et convertantur, et sanabo illos'."
,"28":"Notum ergo sit vobis quoniam gentibus missum est hoc salutare Dei; ipsi et audient! '. (29) 30 Mansit autem biennio toto in suo conducto; et suscipiebat omnes, qui ingrediebantur ad eum, "
,"31":"praedicans regnum Dei et docens quae sunt de Domino Iesu Christo cum omni fiducia sine prohibitione."
}`)

}
func LA_NVBSE_LoadNTAIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Apocalypsis Iesu Christi, quam dedit illi Deus palam facere ser vis suis, quae oportet fieri cito, et significavit mittens per angelum suum servo suo Ioanni,"
,"2":"qui testificatus est verbum Dei et testimonium Iesu Christi, quaecumque vidit."
,"3":"Beatus, qui legit et qui audiunt verba prophetiae et servant ea, quae in ea scripta sunt; tempus enim prope est."
,"4":"Ioannes septem ecclesiis, quae sunt in Asia: Gratia vobis et pax ab eo, qui est et qui erat et qui venturus est, et a septem spiritibus, qui in conspectu throni eius sunt,"
,"5":"et ab Iesu Christo, qui est testis fidelis, primogenitus mortuorum et princeps regum terrae. Ei, qui diligit nos et solvit nos a peccatis nostris in sanguine suo "
,"6":"et fecit nos regnum, sacerdotes Deo et Patri suo, ipsi gloria et imperium in saecula saeculorum. Amen."
,"7":"Ecce venit cum nubibus, et videbit eum omnis oculus et qui eum pupugerunt, et plangent se super eum omnes tribus terrae. Etiam, amen."
,"8":"Ego sum Alpha et Omega, dicit Dominus Deus, qui est et qui erat et qui venturus est, Omnipotens."
,"9":"Ego Ioannes, frater vester et particeps in tribulatione et regno et patientia in Iesu, fui in insula, quae appellatur Patmos, propter verbum Dei et testimonium Iesu."
,"10":"Fui in spiritu in dominica die et audivi post me vocem magnam tamquam tubae"
,"11":"dicentis: ' Quod vides, scribe in libro et mitte septem ecclesiis: Ephesum et Smyrnam et Pergamum et Thyatiram et Sardis et Philadelphiam et Laodiciam '."
,"12":"Et conversus sum, ut viderem vocem, quae loquebatur mecum; et conversus vidi septem candelabra aurea"
,"13":"et in medio candelabrorum quasi Filium hominis, vestitum podere et praecinctum ad mamillas zonam auream;"
,"14":"caput autem eius et capilli erant candidi tamquam lana alba, tamquam nix, et oculi eius velut flamma ignis,"
,"15":"et pedes eius similes orichalco sicut in camino ardenti, et vox illius tamquam vox aquarum multarum,"
,"16":"et habebat in dextera manu sua stellas septem, et de ore eius gladius anceps acutus exibat, et facies eius sicut sol lucet in virtute sua."
,"17":"Et cum vidissem eum, cecidi ad pedes eius tamquam mortuus; et posuit dexteram suam super me dicens: ' Noli timere! Ego sum primus et novissimus,"
,"18":"et vivens et fui mortuus et ecce sum vivens in saecula saeculorum et habeo claves mortis et inferni."
,"19":"Scribe ergo, quae vidisti et quae sunt et quae oportet fieri post haec."
,"20":"Mysterium septem stellarum, quas vidisti ad dexteram meam, et septem candelabra aurea: septem stellae, angeli sunt septem ecclesiarum; et candelabra septem, septem ecclesiae sunt."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Angelo ecclesiae, quae est Ephesi, scribe: Haec dicit, qui tenet septem stellas in dextera sua, qui ambulat in medio septem candelabrorum aureorum: "
,"2":"Scio opera tua et laborem et patientiam tuam, et quia non potes sustinere malos et tentasti eos, qui se dicunt apostolos et non sunt, et invenisti eos mendaces;"
,"3":"et patientiam habes et sustinuisti propter nomen meum et non defecisti."
,"4":"Sed habeo adversus te quod caritatem tuam primam reliquisti."
,"5":"Memor esto itaque unde excideris, et age paenitentiam et prima opera fac; sin autem, venio tibi et movebo candelabrum tuum de loco suo, nisi paenitentiam egeris."
,"6":"Sed hoc habes, quia odisti facta Nicolaitarum, quae et ego odi."
,"7":"Qui habet aurem, audiat quid Spiritus dicat ecclesiis. Vincenti dabo ei edere de ligno vitae, quod est in paradiso Dei."
,"8":"Et angelo ecclesiae, quae est Smyrnae, scribe: Haec dicit Primus et Novissimus, qui fuit mortuus et vixit: "
,"9":"Scio tribulationem tuam et paupertatem tuam - sed dives es - et blasphemiam ab his, qui se dicunt Iudaeos esse et non sunt, sed sunt synagoga Satanae."
,"10":"Nihil horum timeas, quae passurus es. Ecce missurus est Diabolus ex vobis in carcerem, ut tentemini, et habebitis tribulationem diebus decem. Esto fidelis usque ad mortem, et dabo tibi coronam vitae."
,"11":"Qui habet aurem, audiat quid Spiritus dicat ecclesiis. Qui vicerit, non laedetur a morte secunda."
,"12":"Et angelo ecclesiae, quae est Pergami, scribe: Haec dicit, qui habet romphaeam ancipitem acutam: "
,"13":"Scio, ubi habitas, ubi thronus est Satanae, et tenes nomen meum et non negasti fidem meam et in diebus Antipas, testis meus fidelis, qui occisus est apud vos, ubi Satanas habitat."
,"14":"Sed habeo adversus te pauca, quia habes illic tenentes doctrinam Balaam, qui docebat Balac mittere scandalum coram filiis Israel, edere idolothyta et fornicari;"
,"15":"ita habes et tu tenentes doctrinam Nicolaitarum similiter."
,"16":"Ergo paenitentiam age; si quo minus, venio tibi cito et pugnabo cum illis in gladio oris mei."
,"17":"Qui habet aurem, audiat quid Spiritus dicat ecclesiis. Vincenti dabo ei de manna abscondito et dabo illi calculum candidum, et in calculo nomen novum scriptum, quod nemo scit, nisi qui accipit."
,"18":"Et angelo ecclesiae, quae est Thyatirae, scribe: Haec dicit Filius Dei, qui habet oculos ut flammam ignis, et pedes eius similes orichalco:"
,"19":"Novi opera tua et caritatem et fidem et ministerium et patientiam tuam et opera tua novissima plura prioribus."
,"20":"Sed habeo adversus te, quia permittis mulierem Iezabel, quae se dicit prophetissam, et docet et seducit servos meos fornicari et manducare idolothyta."
,"21":"Et dedi illi tempus, ut paenitentiam ageret, et non vult paeniteri a fornicatione sua."
,"22":"Ecce mitto eam in lectum et, qui moechantur cum ea, in tribulationem magnam, nisi paenitentiam egerint ab operibus eius."
,"23":"Et filios eius interficiam in morte, et scient omnes ecclesiae quia ego sum scrutans renes et corda, et dabo unicuique vestrum secundum opera vestra."
,"24":"Vobis autem dico ceteris, qui Thyatirae estis, quicumque non habent doctrinam hanc, qui non cognoverunt altitudines Satanae, quemadmodum dicunt, non mittam super vos aliud pondus;"
,"25":"tamen id quod habetis, tenete, donec veniam."
,"26":"Et, qui vicerit et qui custodierit usque in finem opera mea, dabo illi potestatem super gentes,"
,"27":"et reget illas in virga ferrea, tamquam vasa fictilia confringentur,"
,"28":"sicut et ego accepi a Patre meo, et dabo illi stellam matutinam."
,"29":"Qui habet aurem, audiat quid Spiritus dicat ecclesiis."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et angelo ecclesiae, quae est Sardis, scribe: Haec dicit, qui habet septem spiritus Dei et septem stellas: Scio opera tua, quia nomen habes quod vivas, et mortuus es. "
,"2":"Esto vigilans et confirma cetera, quae moritura erant, non enim invenio opera tua plena coram Deo meo;"
,"3":"in mente ergo habe qualiter acceperis et audieris, et serva et paenitentiam age. Si ergo non vigilaveris, veniam tamquam fur, et nescies qua hora veniam ad te."
,"4":"Sed habes pauca nomina in Sardis, qui non inquinaverunt vestimenta sua et ambulabunt mecum in albis, quia digni sunt."
,"5":"Qui vicerit, sic vestietur vestimentis albis, et non delebo nomen eius de libro vitae et confitebor nomen eius coram Patre meo et coram angelis eius."
,"6":"Qui habet aurem, audiat quid Spiritus dicat ecclesiis."
,"7":"Et angelo ecclesiae, quae est Philadelphiae, scribe: Haec dicit Sanctus, Verus, qui habet clavem David, qui aperit, et nemo claudet; et claudit, et nemo aperit: "
,"8":"Scio opera tua - ecce dedi coram te ostium apertum, quod nemo potest claudere - quia modicam habes virtutem, et servasti verbum meum et non negasti nomen meum."
,"9":"Ecce dabo de synagoga Satanae, qui dicunt se Iudaeos esse et non sunt, sed mentiuntur; ecce faciam illos, ut veniant et adorent ante pedes tuos et scient quia ego dilexi te."
,"10":"Quoniam servasti verbum patientiae meae, et ego te servabo ab hora tentationis, quae ventura est super orbem universum tentare habitantes in terra."
,"11":"Venio cito; tene quod habes, ut nemo accipiat coronam tuam."
,"12":"Qui vicerit, faciam illum columnam in templo Dei mei, et foras non egredietur amplius; et scribam super eum nomen Dei mei et nomen civitatis Dei mei, novae Ierusalem, quae descendit de caelo a Deo meo, et nomen meum novum."
,"13":"Qui habet aurem, audiat quid Spiritus dicat ecclesiis."
,"14":"Et angelo ecclesiae, quae est Laodiciae, scribe: Haec dicit Amen, testis fidelis et verus, principium creaturae Dei: "
,"15":"Scio opera tua, quia neque frigidus es neque calidus. Utinam frigidus esses aut calidus!"
,"16":"Sic quia tepidus es et nec calidus nec frigidus, incipiam te evomere ex ore meo."
,"17":"Quia dicis: 'Dives sum et locupletatus et nullius egeo', et nescis quia tu es miser et miserabilis et pauper et caecus et nudus,"
,"18":"suadeo tibi emere a me aurum igne probatum, ut locuples fias et vestimentis albis induaris, et non appareat confusio nuditatis tuae, et collyrium ad inunguendum oculos tuos, ut videas."
,"19":"Ego, quos amo, arguo et castigo. Aemulare ergo et paenitentiam age."
,"20":"Ecce sto ad ostium et pulso. Si quis audierit vocem meam et aperuerit ianuam, introibo ad illum et cenabo cum illo, et ipse mecum."
,"21":"Qui vicerit, dabo ei sedere mecum in throno meo, sicut et ego vici et sedi cum Patre meo in throno eius."
,"22":"Qui habet aurem, audiat quid Spiritus dicat ecclesiis '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Post haec vidi: et ecce ostium apertum in caelo, et vox prima, quam audivi, tamquam tubae loquentis mecum dicens: ' Ascende huc, et ostendam tibi, quae oportet fieri post haec '."
,"2":"Statim fui in spiritu: et ecce thronus positus erat in caelo; et supra thronum sedens;"
,"3":"et, qui sedebat, similis erat aspectu lapidi iaspidi et sardino; et iris erat in circuitu throni, aspectu similis smaragdo."
,"4":"Et in circuitu throni, viginti quattuor thronos, et super thronos viginti quattuor seniores sedentes, circumamictos vestimentis albis, et super capita eorum coronas aureas."
,"5":"Et de throno procedunt fulgura et voces et tonitrua; et septem lampades ignis ardentes ante thronum, quae sunt septem spiritus Dei;"
,"6":"et in conspectu throni tamquam mare vitreum simile crystallo. Et in medio throni et in circuitu throni quattuor animalia, plena oculis ante et retro:"
,"7":"et animal primum simile leoni, et secundum animal simile vitulo, et tertium animal habens faciem quasi hominis, et quartum animal simile aquilae volanti."
,"8":"Et quattuor animalia singula eorum habebant alas senas, in circuitu et intus plenae sunt oculis; et requiem non habent die et nocte dicentia: ' Sanctus, sanctus, sanctus Dominus, Deus omnipotens, qui erat et qui est et qui venturus est! '."
,"9":"Et cum darent illa animalia gloriam et honorem et gratiarum actionem sedenti super thronum, viventi in saecula saeculorum,"
,"10":"procidebant viginti quattuor seniores ante sedentem in throno et adorabant viventem in saecula saeculorum et mittebant coronas suas ante thronum dicentes:"
,"11":"' Dignus es, Domine et Deus noster, accipere gloriam et honorem et virtutem, quia tu creasti omnia, et propter voluntatem tuam erant et creata sunt '."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et vidi in dextera sedentis super thronum librum scriptum intus et foris, signatum sigillis septem."
,"2":"Et vidi angelum fortem praedicantem voce magna: ' Quis est dignus aperire librum et solvere signacula eius? '."
,"3":"Et nemo poterat in caelo neque in terra neque subtus terram aperire librum neque respicere illum."
,"4":"Et ego flebam multum, quoniam nemo dignus inventus est aperire librum nec respicere eum."
,"5":"Et unus de senioribus dicit mihi: ' Ne fleveris; ecce vicit leo de tribu Iudae, radix David, aperire librum et septem signacula eius '."
,"6":"Et vidi in medio throni et quattuor animalium et in medio seniorum Agnum stantem tamquam occisum, habentem cornua septem et oculos septem, qui sunt septem spiritus Dei missi in omnem terram."
,"7":"Et venit et accepit de dextera sedentis in throno."
,"8":"Et cum accepisset librum, quattuor animalia et viginti quattuor seniores ceciderunt coram Agno, habentes singuli citharas et phialas aureas plenas incensorum, quae sunt orationes sanctorum."
,"9":"Et cantant novum canticum dicentes: ' Dignus es accipere librum,et aperire signacula eius, quoniam occisus es et redemisti Deo in sanguine tuo,ex omni tribu et lingua et populo et natione;"
,"10":"et fecisti eos Deo nostro regnum et sacerdotes, et regnabunt super terram '."
,"11":"Et vidi et audivi vocem angelorum multorum in circuitu throni et animalium et seniorum, et erat numerus eorum myriades myriadum et milia milium,"
,"12":"dicentium voce magna: ' Dignus est Agnus, qui occisus est, accipere virtutem et divitias et sapientiam,et fortitudinem et honorem et gloriam et benedictionem '."
,"13":"Et omnem creaturam, quae in caelo est et super terram et sub terra et super mare et quae in eis omnia, audivi dicentes: 'Sedenti super thronum et Agno benedictio et honor et gloria et potestas in saecula saeculorum '."
,"14":"Et quattuor animalia dicebant: ' Amen '; et seniores ceciderunt et adoraverunt."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et vidi, cum aperuisset Agnus unum de septem sigillis, et audi vi unum de quattuor animalibus dicens tamquam voce tonitrui: ' Veni '."
,"2":"Et vidi: et ecce equus albus; et, qui sedebat super illum, habebat arcum, et data est ei corona, et exivit vincens et ut vinceret."
,"3":"Et cum aperuisset sigillum secundum, audivi secundum animal dicens: ' Veni '."
,"4":"Et exivit alius equus rufus; et, qui sedebat super illum, datum est ei, ut sumeret pacem de terra, et ut invicem se interficiant; et datus est illi gladius magnus."
,"5":"Et cum aperuisset sigillum tertium, audivi tertium animal dicens: ' Veni '. Et vidi: et ecce equus niger; et, qui sedebat super eum, habebat stateram in manu sua."
,"6":"Et audivi tamquam vocem in medio quattuor animalium dicentem: ' Bilibris tritici denario, et tres bilibres hordei denario; et oleum et vinum ne laeseris '."
,"7":"Et cum aperuisset sigillum quartum, audivi vocem quarti animalis dicentis: ' Veni '."
,"8":"Et vidi: et ecce equus pallidus; et, qui sedebat desuper, nomen illi Mors, et Infernus sequebatur eum; et data est illis potestas super quartam partem terrae interficere gladio et fame et morte et a bestiis terrae."
,"9":"Et cum aperuisset quintum sigillum, vidi subtus altare animas interfectorum propter verbum Dei et propter testimonium, quod habebant."
,"10":"Et clamaverunt voce magna dicentes: ' Usquequo, Domine, sanctus et verus, non iudicas et vindicas sanguinem nostrum de his, qui habitant in terra? '."
,"11":"Et datae sunt illis singulae stolae albae; et dictum est illis, ut requiescant tempus adhuc modicum, donec impleantur et conservi eorum et fratres eorum, qui interficiendi sunt sicut et illi."
,"12":"Et vidi, cum aperuisset sigillum sextum, et terraemotus factus est magnus, et sol factus est niger tamquam saccus cilicinus, et luna tota facta est sicut sanguis,"
,"13":"et stellae caeli ceciderunt in terram, sicut ficus mittit grossos suos, cum vento magno movetur,"
,"14":"et caelum recessit sicut liber involutus, et omnis mons et insula de locis suis motae sunt."
,"15":"Et reges terrae et magnates et tribuni et divites et fortes et omnis servus et liber absconderunt se in speluncis et in petris montium;"
,"16":"et dicunt montibus et petris: ' Cadite super nos et abscondite nos a facie sedentis super thronum et ab ira Agni,"
,"17":"quoniam venit dies magnus irae ipsorum, et quis poterit stare? '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Post haec vidi quattuor angelos stantes super quattuor angulos terrae tenentes quattuor ventos terrae, ne flaret ventus super terram neque super mare neque in ullam arborem."
,"2":"Et vidi alterum angelum ascendentem ab ortu solis, habentem sigillum Dei vivi; et clamavit voce magna quattuor angelis, quibus datum est nocere terrae et mari,"
,"3":"dicens: ' Nolite nocere terrae neque mari neque arboribus, quoadusque signemus servos Dei nostri in frontibus eorum '."
,"4":"Et audivi numerum signatorum, centum quadraginta quattuor milia signati ex omni tribu filiorum Israel:"
,"5":"ex tribu Iudae duodecim milia signati, ex tribu Ruben duodecim milia, ex tribu Gad duodecim milia,"
,"6":"ex tribu Aser duodecim milia, ex tribu Nephthali duodecim milia, ex tribu Manasse duodecim milia,"
,"7":"ex tribu Simeon duodecim milia, ex tribu Levi duodecim milia, ex tribu Issachar duodecim milia,"
,"8":"ex tribu Zabulon duodecim milia, ex tribu Ioseph duodecim milia, ex tribu Beniamin duodecim milia signati."
,"9":"Post haec vidi: et ecce turba magna, quam dinumerare nemo poterat, ex omnibus gentibus et tribubus et populis et linguis stantes ante thronum et in conspectu Agni, amicti stolis albis, et palmae in manibus eorum;"
,"10":"et clamant voce magna dicentes: ' Salus Deo nostro, qui sedet super thronum, et Agno '."
,"11":"Et omnes angeli stabant in circuitu throni et seniorum et quattuor animalium, et ceciderunt in conspectu throni in facies suas et adoraverunt Deum"
,"12":"dicentes: ' Amen! Benedictio et gloria et sapientia et gratiarum actio et honor et virtus et fortitudo Deo nostro in saecula saeculorum. Amen '."
,"13":"Et respondit unus de senioribus dicens mihi: ' Hi, qui amicti sunt stolis albis, qui sunt et unde venerunt? '."
,"14":"Et dixi illi: ' Domine mi, tu scis '. Et dixit mihi: ' Hi sunt qui veniunt de tribulatione magna et laverunt stolas suas et dealbaverunt eas in sanguine Agni."
,"15":"Ideo sunt ante thronum Dei et serviunt ei die ac nocte in templo eius; et, qui sedet in throno, habitabit super illos."
,"16":"Non esurient amplius neque sitient amplius, neque cadet super illos sol neque ullus aestus,"
,"17":"quoniam Agnus, qui in medio throni est, pascet illos et deducet eos ad vitae fontes aquarum, et absterget Deus omnem lacrimam ex oculis eorum '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Et cum aperuisset sigillum septimum, factum est silentium in caelo quasi media hora."
,"2":"Et vidi septem angelos, qui stant in conspectu Dei, et datae sunt illis septem tubae."
,"3":"Et alius angelus venit et stetit ante altare habens turibulum aureum, et data sunt illi incensa multa, ut daret orationibus sanctorum omnium super altare aureum, quod est ante thronum."
,"4":"Et ascendit fumus incensorum de orationibus sanctorum de manu angeli coram Deo."
,"5":"Et accepit angelus turibulum et implevit illud de igne altaris et misit in terram; et facta sunt tonitrua et voces et fulgura et terraemotus."
,"6":"Et septem angeli, qui habebant septem tubas, paraverunt se, ut tuba canerent."
,"7":"Et primus tuba cecinit. Et facta est grando et ignis mixta in sanguine, et missum est in terram: et tertia pars terrae combusta est, et tertia pars arborum combusta est, et omne fenum viride combustum est."
,"8":"Et secundus angelus tuba cecinit. Et tamquam mons magnus igne ardens missus est in mare: et facta est tertia pars maris sanguis,"
,"9":"et mortua est tertia pars creaturarum, quae in mari sunt, quae habent animas, et tertia pars navium interiit."
,"10":"Et tertius angelus tuba cecinit. Et cecidit de caelo stella magna ardens tamquam facula et cecidit super tertiam partem fluminum et super fontes aquarum."
,"11":"Et nomen stellae dicitur Absinthius. Et facta est tertia pars aquarum in absinthium, et multi hominum mortui sunt de aquis, quia amarae factae sunt."
,"12":"Et quartus angelus tuba cecinit. Et percussa est tertia pars solis et tertia pars lunae et tertia pars stellarum, ut obscuraretur tertia pars eorum, et diei non luceret pars tertia, et nox similiter."
,"13":"Et vidi et audivi unam aquilam volantem per medium caelum dicentem voce magna: ' Vae, vae, vae habitantibus in terra de ceteris vocibus tubae trium angelorum, qui tuba canituri sunt!'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et quintus angelus tuba cecinit. Et vidi stellam de caelo cecidis se in terram, et data est illi clavis putei abyssi."
,"2":"Et aperuit puteum abyssi, et ascendit fumus ex puteo sicut fumus fornacis magnae; et obscuratus est sol et aer de fumo putei."
,"3":"Et de fumo exierunt locustae in terram, et data est illis potestas, sicut habent potestatem scorpiones terrae."
,"4":"Et dictum est illis, ne laederent fenum terrae neque omne viride neque omnem arborem, nisi tantum homines, qui non habent signum Dei in frontibus."
,"5":"Et datum est illis, ne occiderent eos, sed ut cruciarentur mensibus quinque; et cruciatus eorum ut cruciatus scorpii, cum percutit hominem."
,"6":"Et in diebus illis quaerent homines mortem et non invenient eam; et desiderabunt mori, et fugit mors ab ipsis."
,"7":"Et similitudines locustarum similes equis paratis in proelium, et super capita earum tamquam coronae similes auro, et facies earum sicut facies hominum;"
,"8":"et habebant capillos sicut capillos mulierum, et dentes earum sicut leonum erant,"
,"9":"et habebant loricas sicut loricas ferreas, et vox alarum earum sicut vox curruum equorum multorum currentium in bellum."
,"10":"Et habent caudas similes scorpionibus et aculeos, et in caudis earum potestas earum nocere hominibus mensibus quinque."
,"11":"Habent super se regem angelum abyssi, cui nomen Hebraice Abaddon et Graece nomen habet Apollyon."
,"12":"Vae unum abiit. Ecce veniunt adhuc duo vae post haec."
,"13":"Et sextus angelus tuba cecinit. Et audivi vocem unam ex cornibus altaris aurei, quod est ante Deum,"
,"14":"dicentem sexto angelo, qui habebat tubam: ' Solve quattuor angelos, qui alligati sunt super flumen magnum Euphraten '."
,"15":"Et soluti sunt quattuor angeli, qui parati erant in horam et diem et mensem et annum, ut occiderent tertiam partem hominum."
,"16":"Et numerus equestris exercitus vicies milies dena milia; audivi numerum eorum."
,"17":"Et ita vidi equos in visione et, qui sedebant super eos, habentes loricas igneas et hyacinthinas et sulphureas; et capita equorum erant tamquam capita leonum, et de ore ipsorum procedit ignis et fumus et sulphur."
,"18":"Ab his tribus plagis occisa est tertia pars hominum, de igne et fumo et sulphure, quod procedebat ex ore ipsorum."
,"19":"Potestas enim equorum in ore eorum est et in caudis eorum; nam caudae illorum similes serpentibus habentes capita, et in his nocent."
,"20":"Et ceteri homines, qui non sunt occisi in his plagis neque paenitentiam egerunt de operibus manuum suarum, ut non adorarent daemonia et simulacra aurea et argentea et aerea et lapidea et lignea, quae neque videre possunt neque audire neque ambulare,"
,"21":"et non egerunt paenitentiam ab homicidiis suis neque a veneficiis suis neque a fornicatione sua neque a furtis suis."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Et vidi alium angelum for tem descendentem de caelo amictum nube, et iris super caput, et facies eius erat ut sol, et pedes eius tamquam columnae ignis;"
,"2":"et habebat in manu sua libellum apertum. Et posuit pedem suum dexterum supra mare, sinistrum autem super terram,"
,"3":"et clamavit voce magna, quemadmodum cum leo rugit. Et cum clamasset, locuta sunt septem tonitrua voces suas."
,"4":"Et cum locuta fuissent septem tonitrua, scripturus eram; et audivi vocem de caelo dicentem: ' Signa, quae locuta sunt septem tonitrua, et noli ea scribere '."
,"5":"Et angelus, quem vidi stantem supra mare et supra terram, levavit manum suam dexteram ad caelum"
,"6":"et iuravit per Viventem in saecula saeculorum, qui creavit caelum et ea, quae in illo sunt, et terram et ea, quae in ea sunt, et mare et ea, quae in eo sunt: ' Tempus amplius non erit,"
,"7":"sed in diebus vocis septimi angeli, cum coeperit tuba canere, et consummatum est mysterium Dei, sicut evangelizavit servis suis prophetis '."
,"8":"Et vox, quam audivi de caelo, iterum loquentem mecum et dicentem: ' Vade, accipe librum apertum de manu angeli stantis supra mare et supra terram '."
,"9":"Et abii ad angelum dicens ei, ut daret mihi libellum. Et dicit mihi: ' Accipe et devora illum; et faciet amaricare ventrem tuum, sed in ore tuo erit dulcis tamquam mel '."
,"10":"Et accepi libellum de manu angeli et devoravi eum, et erat in ore meo tamquam mel dulcis; et cum devorassem eum, amaricatus est venter meus."
,"11":"Et dicunt mihi: ' Oportet te iterum prophetare super populis et gentibus et linguis et regibus multis '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et datus est mihi calamus similis virgae dicens: ' Surge et metire templum Dei et altare et adorantes in eo."
,"2":"Atrium autem, quod est foris templum, eice foras et ne metiaris illud, quoniam datum est gentibus, et civitatem sanctam calcabunt mensibus quadraginta duobus."
,"3":"Et dabo duobus testibus meis, et prophetabunt diebus mille ducentis sexaginta amicti saccis '."
,"4":"Hi sunt duae olivae et duo candelabra in conspectu Domini terrae stantes."
,"5":"Et si quis eis vult nocere, ignis exit de ore illorum et devorat inimicos eorum; et si quis voluerit eos laedere, sic oportet eum occidi."
,"6":"Hi habent potestatem claudendi caelum, ne pluat pluvia diebus prophetiae ipsorum; et potestatem habent super aquas convertendi eas in sanguinem et percutere terram omni plaga, quotienscumque voluerint."
,"7":"Et cum finierint testimonium suum, bestia, quae ascendit de abysso, faciet adversus illos bellum et vincet eos et occidet illos."
,"8":"Et corpus eorum in platea civitatis magnae, quae vocatur spiritaliter Sodoma et Aegyptus, ubi et Dominus eorum crucifixus est;"
,"9":"et vident de populis et tribubus et linguis et gentibus corpus eorum per tres dies et dimidium, et corpora eorum non sinunt poni in monumento."
,"10":"Et inhabitantes terram gaudent super illis et iucundantur et munera mittent invicem, quoniam hi duo prophetae cruciaverunt eos, qui inhabitant super terram."
,"11":"Et post dies tres et dimidium spiritus vitae a Deo intravit in eos, et steterunt super pedes suos; et timor magnus cecidit super eos, qui videbant eos."
,"12":"Et audierunt vocem magnam de caelo dicentem illis: ' Ascendite huc '; et ascenderunt in caelum in nube, et viderunt illos inimici eorum."
,"13":"Et in illa hora factus est terraemotus magnus, et decima pars civitatis cecidit, et occisi sunt in terraemotu nomina hominum septem milia, et reliqui in timorem sunt missi et dederunt gloriam Deo caeli."
,"14":"Vae secundum abiit; ecce vae tertium venit cito."
,"15":"Et septimus angelus tuba cecinit, et factae sunt voces magnae in caelo dicentes: ' Factum est regnum huius mundi Domini nostri et Christi eius, et regnabit in saecula saeculorum '."
,"16":"Et viginti quattuor seniores, qui in conspectu Dei sedent in thronis suis, ceciderunt super facies suas et adoraverunt Deum"
,"17":"dicentes: ' Gratias agimus tibi, Domine, Deus omnipotens, qui es et qui eras, quia accepisti virtutem tuam magnam et regnasti."
,"18":"Et iratae sunt gentes, et advenit ira tua, et tempus mortuorum iudicari,et reddere mercedem servis tuis prophetis et sanctis,et timentibus nomen tuum, pusillis et magnis, et exterminare eos, qui exterminant terram '."
,"19":"Et apertum est templum Dei in caelo, et visa est arca testamenti eius in templo eius; et facta sunt fulgura et voces et terraemotus et grando magna."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Et signum magnum appa ruit in caelo: mulier amicta sole, et luna sub pedibus eius, et super caput eius corona stellarum duodecim;"
,"2":"et in utero habens, et clamat parturiens et cruciatur, ut pariat."
,"3":"Et visum est aliud signum in caelo: et ecce draco rufus magnus, habens capita septem et cornua decem, et super capita sua septem diademata;"
,"4":"et cauda eius trahit tertiam partem stellarum caeli et misit eas in terram. Et draco stetit ante mulierem, quae erat paritura, ut, cum peperisset, filium eius devoraret."
,"5":"Et peperit filium, masculum, qui recturus est omnes gentes in virga ferrea; et raptus est filius eius ad Deum et ad thronum eius."
,"6":"Et mulier fugit in desertum, ubi habet locum paratum a Deo, ut ibi pascant illam diebus mille ducentis sexaginta."
,"7":"Et factum est proelium in caelo, Michael et angeli eius, ut proeliarentur cum dracone. Et draco pugnavit et angeli eius,"
,"8":"et non valuit, neque locus inventus est eorum amplius in caelo."
,"9":"Et proiectus est draco ille magnus, serpens antiquus, qui vocatur Diabolus et Satanas, qui seducit universum orbem; proiectus est in terram, et angeli eius cum illo proiecti sunt."
,"10":"Et audivi vocem magnam in caelo dicentem: ' Nunc facta est salus et virtus et regnum Dei nostri,et potestas Christi eius, quia proiectus est accusator fratrum nostrorum, qui accusabat illos ante conspectum Dei nostri die ac nocte."
,"11":"Et ipsi vicerunt illum propter sanguinem Agni,et propter verbum testimonii sui; et non dilexerunt animam suam,usque ad mortem."
,"12":"Propterea laetamini, caeli,et qui habitatis in eis. Vae terrae et mari, quia descendit Diabolus ad vos habens iram magnam, sciens quod modicum tempus habet! '."
,"13":"Et postquam vidit draco quod proiectus est in terram, persecutus est mulierem, quae peperit masculum."
,"14":"Et datae sunt mulieri duae alae aquilae magnae, ut volaret in desertum in locum suum, ubi alitur per tempus et tempora et dimidium temporis a facie serpentis."
,"15":"Et misit serpens ex ore suo post mulierem aquam tamquam flumen, ut eam faceret trahi a flumine."
,"16":"Et adiuvit terra mulierem, et aperuit terra os suum et absorbuit flumen, quod misit draco de ore suo."
,"17":"Et iratus est draco in mulierem et abiit facere proelium cum reliquis de semine eius, qui custodiunt mandata Dei et habent testimonium Iesu."
,"18":"Et stetit super arenam maris."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Et vidi de mari bestiam ascendentem, habentem cor nua decem et capita septem, et super cornua eius decem diademata, et super capita eius nomina blasphemiae."
,"2":"Et bestia, quam vidi, similis erat pardo, et pedes eius sicut ursi, et os eius sicut os leonis. Et dedit illi draco virtutem suam et thronum suum et potestatem magnam."
,"3":"Et unum de capitibus suis quasi occisum in mortem, et plaga mortis eius curata est. Et admirata est universa terra post bestiam, "
,"4":"et adoraverunt draconem, quia dedit potestatem bestiae, et adoraverunt bestiam dicentes: ' Quis similis bestiae, et quis potest pugnare cum ea? '."
,"5":"Et datum est ei os loquens magna et blasphemias, et data est illi potestas facere menses quadraginta duos."
,"6":"Et aperuit os suum in blasphemias ad Deum, blasphemare nomen eius et tabernaculum eius, eos, qui in caelo habitant."
,"7":"Et datum est illi bellum facere cum sanctis et vincere illos, et data est ei potestas super omnem tribum et populum et linguam et gentem."
,"8":"Et adorabunt eum omnes, qui inhabitant terram, cuiuscumque non est scriptum nomen in libro vitae Agni, qui occisus est, ab origine mundi."
,"9":"Si quis habet aurem, audiat:"
,"10":"Si quis in captivitatem, in captivitatem vadit; si quis in gladio debet occidi, oportet eum in gladio occidi. Hic est patientia et fides sanctorum."
,"11":"Et vidi aliam bestiam ascendentem de terra, et habebat cornua duo similia agni, et loquebatur sicut draco."
,"12":"Et potestatem prioris bestiae omnem facit in conspectu eius. Et facit terram et inhabitantes in ea adorare bestiam primam, cuius curata est plaga mortis."
,"13":"Et facit signa magna, ut etiam ignem faciat de caelo descendere in terram in conspectu hominum."
,"14":"Et seducit habitantes terram propter signa, quae data sunt illi facere in conspectu bestiae, dicens habitantibus in terra, ut faciant imaginem bestiae, quae habet plagam gladii et vixit."
,"15":"Et datum est illi, ut daret spiritum imagini bestiae, ut et loquatur imago bestiae; et faciat, ut quicumque non adoraverint imaginem bestiae, occidantur."
,"16":"Et facit omnes pusillos et magnos et divites et pauperes et liberos et servos accipere characterem in dextera manu sua aut in frontibus suis,"
,"17":"et ne quis possit emere aut vendere, nisi qui habet characterem, nomen bestiae aut numerum nominis eius."
,"18":"Hic sapientia est: qui habet intellectum, computet numerum bestiae; numerus enim hominis est: et numerus eius est sescenti sexaginta sex."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Et vidi: et ecce Agnus stans supra montem Sion, et cum illo centum quadraginta quattuor milia, habentes nomen eius et nomen Patris eius scriptum in frontibus suis."
,"2":"Et audivi vocem de caelo tamquam vocem aquarum multarum et tamquam vocem tonitrui magni; et vox, quam audivi, sicut citharoedorum citharizantium in citharis suis."
,"3":"Et cantant quasi canticum novum ante thronum et ante quattuor animalia et seniores. Et nemo poterat discere canticum, nisi illa centum quadraginta quattuor milia, qui empti sunt de terra."
,"4":"Hi sunt qui cum mulieribus non sunt coinquinati, virgines enim sunt. Hi qui sequuntur Agnum, quocumque abierit. Hi empti sunt ex hominibus primitiae Deo et Agno;"
,"5":"et in ore ipsorum non est inventum mendacium: sine macula sunt."
,"6":"Et vidi alterum angelum volantem per medium caelum, habentem evangelium aeternum, ut evangelizaret super sedentes in terra et super omnem gentem et tribum et linguam et populum;"
,"7":"dicens magna voce: ' Timete Deum et date illi gloriam, quia venit hora iudicii eius; et adorate eum, qui fecit caelum et terram et mare et fontes aquarum '."
,"8":"Et alius angelus secutus est dicens: ' Cecidit, cecidit Babylon illa magna, quae a vino irae fornicationis suae potionavit omnes gentes! '."
,"9":"Et alius angelus tertius secutus est illos dicens voce magna: ' Si quis adoraverit bestiam et imaginem eius et acceperit characterem in fronte sua aut in manu sua,"
,"10":"et hic bibet de vino irae Dei, quod mixtum est mero in calice irae ipsius, et cruciabitur igne et sulphure in conspectu angelorum sanctorum et ante conspectum Agni."
,"11":"Et fumus tormentorum eorum in saecula saeculorum ascendit, nec habent requiem die ac nocte, qui adoraverunt bestiam et imaginem eius, et si quis acceperit characterem nominis eius '."
,"12":"Hic patientia sanctorum est, qui custodiunt mandata Dei et fidem Iesu."
,"13":"Et audivi vocem de caelo dicentem: ' Scribe: Beati mortui, qui in Domino moriuntur amodo. Etiam, dicit Spiritus, ut requiescant a laboribus suis; opera enim illorum sequuntur illos '."
,"14":"Et vidi: et ecce nubem candidam, et supra nubem sedentem quasi Filium hominis, habentem super caput suum coronam auream et in manu sua falcem acutam."
,"15":"Et alter angelus exivit de templo clamans voce magna ad sedentem super nubem: ' Mitte falcem tuam et mete, quia venit hora, ut metatur, quoniam aruit messis terrae '."
,"16":"Et misit, qui sedebat supra nubem, falcem suam in terram, et messa est terra."
,"17":"Et alius angelus exivit de templo, quod est in caelo, habens et ipse falcem acutam."
,"18":"Et alius angelus de altari, habens potestatem supra ignem, et clamavit voce magna ad eum, qui habebat falcem acutam, dicens: ' Mitte falcem tuam acutam et vindemia botros vineae terrae, quoniam maturae sunt uvae eius '."
,"19":"Et misit angelus falcem suam in terram et vindemiavit vineam terrae et misit in lacum irae Dei magnum."
,"20":"Et calcatus est lacus extra civitatem, et exivit sanguis de lacu usque ad frenos equorum per stadia mille sescenta."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Et vidi aliud signum in caelo magnum et mirabile: angelos septem habentes plagas septem novissimas, quoniam in illis consummata est ira Dei."
,"2":"Et vidi tamquam mare vitreum mixtum igne; et eos, qui vicerunt bestiam et imaginem illius et numerum nominis eius, stantes supra mare vitreum, habentes citharas Dei."
,"3":"Et cantant canticum Moysis servi Dei et canticum Agni dicentes: ' Magna et mirabilia opera tua, Domine, Deus omnipotens; iustae et verae viae tuae, Rex gentium!"
,"4":"Quis non timebit, Domine, et glorificabit nomen tuum?,Quia solus Sanctus, quoniam omnes gentes venient,et adorabunt in conspectu tuo, quoniam iudicia tua manifestata sunt '."
,"5":"Et post haec vidi: et apertum est templum tabernaculi testimonii in caelo,"
,"6":"et exierunt septem angeli habentes septem plagas de templo, vestiti lino mundo candido et praecincti circa pectora zonis aureis."
,"7":"Et unum ex quattuor animalibus dedit septem angelis septem phialas aureas plenas iracundiae Dei viventis in saecula saeculorum."
,"8":"Et impletum est templum fumo de gloria Dei et de virtute eius; et nemo poterat introire in templum, donec consummarentur septem plagae septem angelorum."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Et audivi vocem magnam de templo dicentem septem an gelis: ' Ite et effundite septem phialas irae Dei in terram '."
,"2":"Et abiit primus et effudit phialam suam in terram; et factum est vulnus saevum ac pessimum in homines, qui habebant characterem bestiae, et eos, qui adorabant imaginem eius."
,"3":"Et secundus effudit phialam suam in mare; et factus est sanguis tamquam mortui, et omnis anima vivens mortua est, quae est in mari."
,"4":"Et tertius effudit phialam suam in flumina et in fontes aquarum; et factus est sanguis."
,"5":"Et audivi angelum aquarum dicentem: ' Iustus es, qui es et qui eras, Sanctus, quia haec iudicasti;"
,"6":"quia sanguinem sanctorum et prophetarum fuderunt, et sanguinem eis dedisti bibere: digni sunt! '."
,"7":"Et audivi altare dicens: ' Etiam, Domine, Deus omnipotens, vera et iusta iudicia tua! '."
,"8":"Et quartus effudit phialam suam in solem; et datum est illi aestu afficere homines in igne."
,"9":"Et aestuaverunt homines aestu magno; et blasphemaverunt nomen Dei habentis potestatem super has plagas et non egerunt paenitentiam, ut darent illi gloriam."
,"10":"Et quintus effudit phialam suam super thronum bestiae; et factum est regnum eius tenebrosum, et commanducaverunt linguas suas prae dolore"
,"11":"et blasphemaverunt Deum caeli prae doloribus suis et vulneribus suis et non egerunt paenitentiam ex operibus suis."
,"12":"Et sextus effudit phialam suam super flumen illud magnum Euphraten; et exsiccata est aqua eius, ut praepararetur via regibus, qui sunt ab ortu solis."
,"13":"Et vidi de ore draconis et de ore bestiae et de ore pseudoprophetae spiritus tres immundos velut ranas;"
,"14":"sunt enim spiritus daemoniorum facientes signa, qui procedunt ad reges universi orbis congregare illos in proelium diei magni Dei omnipotentis."
,"15":"Ecce venio sicut fur. Beatus, qui vigilat et custodit vestimenta sua, ne nudus ambulet, et videant turpitudinem eius."
,"16":"Et congregavit illos in locum, qui vocatur Hebraice Harmagedon."
,"17":"Et septimus effudit phialam suam in aerem; et exivit vox magna de templo a throno dicens: ' Factum est! '."
,"18":"Et facta sunt fulgura et voces et tonitrua, et terraemotus factus est magnus, qualis numquam fuit, ex quo homo fuit super terram, talis terraemotus sic magnus."
,"19":"Et facta est civitas magna in tres partes, et civitates gentium ceciderunt. Et Babylon magna venit in memoriam ante Deum dare ei calicem vini indignationis irae eius."
,"20":"Et omnis insula fugit, et montes non sunt inventi."
,"21":"Et grando magna sicut talentum descendit de caelo in homines; et blasphemaverunt homines Deum propter plagam grandinis, quoniam magna est plaga eius nimis."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Et venit unus de septem angelis, qui habebant septem phialas, et locutus est mecum dicens: ' Veni, ostendam tibi damnationem meretricis magnae, quae sedet super aquas multas,"
,"2":"cum qua fornicati sunt reges terrae, et inebriati sunt, qui inhabitant terram, de vino prostitutionis eius '."
,"3":"Et abstulit me in desertum in spiritu. Et vidi mulierem sedentem super bestiam coccineam, plenam nominibus blasphemiae, habentem capita septem et cornua decem."
,"4":"Et mulier erat circumdata purpura et coccino, et inaurata auro et lapide pretioso et margaritis, habens poculum aureum in manu sua plenum abominationibus et immunditiis fornicationis eius;"
,"5":"et in fronte eius nomen scriptum, mysterium: ' Babylon magna, mater fornicationum et abominationum terrae '."
,"6":"Et vidi mulierem ebriam de sanguine sanctorum et de sanguine martyrum Iesu. Et miratus sum, cum vidissem illam, admiratione magna."
,"7":"Et dixit mihi angelus. ' Quare miraris? Ego tibi dicam mysterium mulieris et bestiae, quae portat eam, quae habet capita septem et decem cornua:"
,"8":"bestia, quam vidisti, fuit et non est, et ascensura est de abysso et in interitum ibit. Et mirabuntur inhabitantes terram, quorum non sunt scripta nomina in libro vitae a constitutione mundi, videntes bestiam, quia erat et non est et aderit."
,"9":"Hic est sensus, qui habet sapientiam. Septem capita, septem montes sunt, super quos mulier sedet. Et reges septem sunt:"
,"10":"quinque ceciderunt, unus est, alius nondum venit; et, cum venerit, oportet illum breve tempus manere."
,"11":"Et bestia, quae erat et non est, et is octavus est et de septem est et in interitum vadit."
,"12":"Et decem cornua, quae vidisti, decem reges sunt, qui regnum nondum acceperunt, sed potestatem tamquam reges una hora accipiunt cum bestia."
,"13":"Hi unum consilium habent et virtutem et potestatem suam bestiae tradunt."
,"14":"Hi cum Agno pugnabunt; et Agnus vincet illos, quoniam Dominus dominorum est et Rex regum, et qui cum illo sunt vocati et electi et fideles '."
,"15":"Et dicit mihi: ' Aquae, quas vidisti, ubi meretrix sedet, populi et turbae sunt et gentes et linguae."
,"16":"Et decem cornua, quae vidisti, et bestia, hi odient fornicariam et desolatam facient illam et nudam, et carnes eius manducabunt et ipsam igne concremabunt;"
,"17":"Deus enim dedit in corda eorum, ut faciant, quod illi placitum est, et faciant unum consilium et dent regnum suum bestiae, donec consummentur verba Dei."
,"18":"Et mulier, quam vidisti, est civitas magna, quae habet regnum super reges terrae '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Post haec vidi alium ange lum descendentem de caelo, habentem potestatem magnam; et terra illuminata est a claritate eius."
,"2":"Et clamavit in forti voce dicens: ' Cecidit, cecidit Babylon magna et facta est habitatio daemoniorum et custodia omnis spiritus immundi et custodia omnis bestiae immundae et odibilis;"
,"3":"quia de vino irae fornicationis eius biberunt omnes gentes, et reges terrae cum illa fornicati sunt, et mercatores terrae de virtute deliciarum eius divites facti sunt! '."
,"4":"Et audivi aliam vocem de caelo dicentem: ' Exite de illa, populus meus, ut ne comparticipes sitis peccatorum eius et de plagis eius non accipiatis,"
,"5":"quoniam pervenerunt peccata eius usque ad caelum, et recordatus est Deus iniquitatum eius."
,"6":"Reddite illi, sicut et ipsa reddidit, et duplicate duplicia secundum opera eius; in poculo, quo miscuit, miscete illi duplum."
,"7":"Quantum glorificavit se et in deliciis fuit, tantum date illi tormentum et luctum. Quia in corde suo dicit: 'Sedeo regina et vidua non sum et luctum non videbo',"
,"8":"ideo in una die venient plagae eius, mors et luctus et fames, et igne comburetur, quia fortis est Dominus Deus, qui iudicavit illam '."
,"9":"Et flebunt et plangent se super illam reges terrae, qui cum illa fornicati sunt et in deliciis vixerunt, cum viderint fumum incendii eius,"
,"10":"longe stantes propter timorem tormentorum eius, dicentes: ' Vae, vae, civitas illa magna, Babylon, civitas illa fortis, quoniam una hora venit iudicium tuum! '."
,"11":"Et negotiatores terrae flent et lugent super illam, quoniam mercem eorum nemo emit amplius:"
,"12":"mercem auri et argenti et lapidis pretiosi et margaritarum, et byssi et purpurae et serici et cocci, et omne lignum thyinum et omnia vasa eboris et omnia vasa de ligno pretiosissimo et aeramento et ferro et marmore,"
,"13":"et cinnamomum et amomum et odoramenta et unguenta et tus, et vinum et oleum et similam et triticum, et iumenta et oves et equorum et raedarum, et mancipiorum et animas hominum."
,"14":"Et fructus tui, desiderium animae, discesserunt a te, et omnia pinguia et clara perierunt a te, et amplius illa iam non invenient."
,"15":"Mercatores horum, qui divites facti sunt ab ea, longe stabunt propter timorem tormentorum eius flentes ac lugentes,"
,"16":"dicentes: ' Vae, vae, civitas illa magna, quae amicta erat byssino et purpura et cocco, et deaurata auro et lapide pretioso et margarita,"
,"17":"quoniam una hora desolatae sunt tantae divitiae! '. Et omnis gubernator et omnis, qui in locum navigat, et nautae et, quotquot maria operantur, longe steterunt "
,"18":"et clamabant, videntes fumum incendii eius, dicentes: ' Quae similis civitati huic magnae? '."
,"19":"Et miserunt pulverem super capita sua et clamabant, flentes et lugentes, dicentes: ' Vae, vae, civitas illa magna, in qua divites facti sunt omnes, qui habent naves in mari, de opibus eius, quoniam una hora desolata est!"
,"20":"Exsulta super eam, caelum, et sancti et apostoli et prophetae, quoniam iudicavit Deus iudicium vestrum de illa! '."
,"21":"Et sustulit unus angelus fortis lapidem quasi molarem magnum et misit in mare dicens: 'Impetu sic mittetur Babylon magna illa civitas et ultra iam non invenietur."
,"22":"Et vox citharoedorum et musicorum et tibia canentium et tuba non audietur in te amplius, et omnis artifex omnis artis non invenietur in te amplius, et vox molae non audietur in te amplius,"
,"23":"et lux lucernae non lucebit tibi amplius, et vox sponsi et sponsae non audietur in te amplius; quia mercatores tui erant magnates terrae, quia in veneficiis tuis erraverunt omnes gentes,"
,"24":"et in ea sanguis prophetarum et sanctorum inventus est et omnium, qui interfecti sunt in terra! '."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Post haec audivi quasi vo cem magnam turbae multae in caelo dicentium: ' Alleluia!,Salus et gloria et virtus Deo nostro, "
,"2":"quia vera et iusta iudicia eius; quia iudicavit de meretrice magna, quae corrupit terram in prostitutione sua, et vindicavit sanguinem servorum suorum de manibus eius! '."
,"3":"Et iterum dixerunt: ' Alleluia! Et fumus eius ascendit in saecula saeculorum! '."
,"4":"Et ceciderunt seniores viginti quattuor et quattuor animalia et adoraverunt Deum sedentem super thronum dicentes: ' Amen. Alleluia '."
,"5":"Et vox de throno exivit dicens: ' Laudem dicite Deo nostro, omnes servi eius,et qui timetis eum, pusilli et magni! '."
,"6":"Et audivi quasi vocem turbae magnae et sicut vocem aquarum multarum et sicut vocem tonitruum magnorum dicentium: ' Alleluia, quoniam regnavit Dominus, Deus noster omnipotens."
,"7":"Gaudeamus et exsultemus et demus gloriam ei, quia venerunt nuptiae Agni, et uxor eius praeparavit se."
,"8":"Et datum est illi, ut cooperiat se byssino splendenti mundo: byssinum enim iustificationes sunt sanctorum '."
,"9":"Et dicit mihi: ' Scribe: Beati, qui ad cenam nuptiarum Agni vocati sunt! '. Et dicit mihi: ' Haec verba Dei vera sunt '."
,"10":"Et cecidi ante pedes eius, ut adorarem eum. Et dicit mihi: ' Vide, ne feceris! Conservus tuus sum et fratrum tuorum habentium testimonium Iesu. Deum adora. Testimonium enim Iesu est spiritus prophetiae '."
,"11":"Et vidi caelum apertum: et ecce equus albus; et, qui sedebat super eum, vocabatur Fidelis et Verax, et in iustitia iudicat et pugnat."
,"12":"Oculi autem eius sicut flamma ignis, et in capite eius diademata multa, habens nomen scriptum, quod nemo novit nisi ipse;"
,"13":"et vestitus veste aspersa sanguine, et vocatur nomen eius Verbum Dei."
,"14":"Et exercitus, qui sunt in caelo, sequebantur eum in equis albis, vestiti byssino albo mundo."
,"15":"Et de ore ipsius procedit gladius acutus, ut in ipso percutiat gentes, et ipse reget eos in virga ferrea; et ipse calcat torcular vini furoris irae Dei omnipotentis."
,"16":"Et habet super vestimentum et super femur suum nomen scriptum: Rex regum et Dominus dominorum."
,"17":"Et vidi unum angelum stantem in sole, et clamavit voce magna dicens omnibus avibus, quae volabant per medium caeli: 'Venite, congregamini ad cenam magnam Dei,"
,"18":"ut manducetis carnes regum et carnes tribunorum et carnes fortium et carnes equorum et sedentium in ipsis et carnes omnium liberorum ac servorum et pusillorum ac magnorum '."
,"19":"Et vidi bestiam et reges terrae et exercitus eorum congregatos ad faciendum proelium cum illo, qui sedebat super equum, et cum exercitu eius."
,"20":"Et apprehensa est bestia et cum illa pseudopropheta, qui fecit signa coram ipsa, quibus seduxit eos, qui acceperunt characterem bestiae et qui adorant imaginem eius; vivi missi sunt hi duo in stagnum ignis ardentis sulphure."
,"21":"Et ceteri occisi sunt in gladio sedentis super equum, qui procedit de ore ipsius, et omnes aves saturatae sunt carnibus eorum."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Et vidi angelum descen dentem de caelo habentem clavem abyssi et catenam magnam in manu sua."
,"2":"Et apprehendit draconem, serpentem antiquum, qui est Diabolus et Satanas, et ligavit eum per annos mille;"
,"3":"et misit eum in abyssum et clausit et signavit super illum, ut non seducat amplius gentes, donec consummentur mille anni; post haec oportet illum solvi modico tempore."
,"4":"Et vidi thronos, et sederunt super eos, et iudicium datum est illis; et animas decollatorum propter testimonium Iesu et propter verbum Dei, et qui non adoraverunt bestiam neque imaginem eius nec acceperunt characterem in frontibus et in manibus suis; et vixerunt et regnaverunt cum Christo mille annis."
,"5":"Ceteri mortuorum non vixerunt, donec consummentur mille anni. Haec est resurrectio prima."
,"6":"Beatus et sanctus, qui habet partem in resurrectione prima! In his secunda mors non habet potestatem, sed erunt sacerdotes Dei et Christi et regnabunt cum illo mille annis."
,"7":"Et cum consummati fuerint mille anni, solvetur Satanas de carcere suo"
,"8":"et exibit seducere gentes, quae sunt in quattuor angulis terrae, Gog et Magog; congregare eos in proelium, quorum numerus est sicut arena maris."
,"9":"Et ascenderunt super latitudinem terrae et circumierunt castra sanctorum et civitatem dilectam. Et descendit ignis de caelo et devoravit eos;"
,"10":"et Diabolus, qui seducebat eos, missus est in stagnum ignis et sulphuris, ubi et bestia et pseudopropheta, et cruciabuntur die ac nocte in saecula saeculorum."
,"11":"Et vidi thronum magnum candidum et sedentem super eum, a cuius aspectu fugit terra et caelum, et locus non est inventus eis."
,"12":"Et vidi mortuos, magnos et pusillos, stantes in conspectu throni; et libri aperti sunt. Et alius liber apertus est, qui est vitae; et iudicati sunt mortui ex his, quae scripta erant in libris, secundum opera ipsorum."
,"13":"Et dedit mare mortuos, qui in eo erant, et mors et infernus dederunt mortuos, qui in ipsis erant; et iudicati sunt singuli secundum opera ipsorum."
,"14":"Et mors et infernus missi sunt in stagnum ignis. Haec mors secunda est, stagnum ignis."
,"15":"Et si quis non est inventus in libro vitae scriptus, missus est in stagnum ignis."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Et vidi caelum novum et ter ram novam; primum enim caelum et prima terra abierunt, et mare iam non est."
,"2":"Et civitatem sanctam Ierusalem novam vidi descendentem de caelo a Deo, paratam sicut sponsam ornatam viro suo."
,"3":"Et audivi vocem magnam de throno dicentem: 'Ecce tabernaculum Dei cum hominibus! Et habitabit cum eis, et ipsi populi eius erunt, et ipse Deus cum eis erit eorum Deus;"
,"4":"et absterget omnem lacrimam ab oculis eorum, et mors ultra non erit, neque luctus neque clamor neque dolor erit ultra, quia prima abierunt '."
,"5":"Et dixit, qui sedebat super throno: ' Ecce nova facio omnia '. Et dicit: ' Scribe: Haec verba fidelia sunt et vera '."
,"6":"Et dixit mihi: ' Facta sunt! Ego sum Alpha et Omega, principium et finis. Ego sitienti dabo de fonte aquae vivae gratis."
,"7":"Qui vicerit, hereditabit haec, et ero illi Deus, et ille erit mihi filius."
,"8":"Timidis autem et incredulis et exsecratis et homicidis et fornicatoribus et veneficis et idololatris et omnibus mendacibus, pars illorum erit in stagno ardenti igne et sulphure, quod est mors secunda '."
,"9":"Et venit unus de septem angelis habentibus septem phialas plenas septem plagis novissimis et locutus est mecum dicens: ' Veni, ostendam tibi sponsam uxorem Agni '."
,"10":"Et sustulit me in spiritu super montem magnum et altum et ostendit mihi civitatem sanctam Ierusalem descendentem de caelo a Deo,"
,"11":"habentem claritatem Dei; lumen eius simile lapidi pretiosissimo, tamquam lapidi iaspidi, in modum crystalli;"
,"12":"et habebat murum magnum et altum et habebat portas duodecim et super portas angelos duodecim et nomina inscripta, quae sunt duodecim tribuum filiorum Israel."
,"13":"Ab oriente portae tres, et ab aquilone portae tres, et ab austro portae tres, et ab occasu portae tres;"
,"14":"et murus civitatis habens fundamenta duodecim, et super ipsis duodecim nomina duodecim apostolorum Agni."
,"15":"Et, qui loquebatur mecum, habebat mensuram arundinem auream, ut metiretur civitatem et portas eius et murum eius."
,"16":"Et civitas in quadro posita est, et longitudo eius tanta est quanta et latitudo. Et mensus est civitatem arundine per stadia duodecim milia; longitudo et latitudo et altitudo eius aequales sunt."
,"17":"Et mensus est murum eius centum quadraginta quattuor cubitorum, mensura hominis, quae est angeli."
,"18":"Et erat structura muri eius ex iaspide, ipsa vero civitas aurum mundum simile vitro mundo."
,"19":"Fundamenta muri civitatis omni lapide pretioso ornata: fundamentum primum iaspis, secundus sapphirus, tertius chalcedonius, quartus smaragdus,"
,"20":"quintus sardonyx, sextus sardinus, septimus chrysolithus, octavus beryllus, nonus topazius, decimus chrysoprasus, undecimus hyacinthus, duodecimus amethystus."
,"21":"Et duodecim portae duodecim margaritae sunt, et singulae portae erant ex singulis margaritis. Et platea civitatis aurum mundum tamquam vitrum perlucidum."
,"22":"Et templum non vidi in ea: Dominus enim, Deus omnipotens, templum illius est, et Agnus."
,"23":"Et civitas non eget sole neque luna, ut luceant ei, nam claritas Dei illuminavit eam, et lucerna eius est Agnus."
,"24":"Et ambulabunt gentes per lumen eius, et reges terrae afferunt gloriam suam in illam;"
,"25":"et portae eius non claudentur per diem, nox enim non erit illic;"
,"26":"et afferent gloriam et divitias gentium in illam."
,"27":"Nec intrabit in ea aliquid coinquinatum et faciens abominationem et mendacium, nisi qui scripti sunt in libro vitae Agni."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Et ostendit mihi fluvium aquae vitae splendidum tamquam crystallum, procedentem de throno Dei et Agni."
,"2":"In medio plateae eius et fluminis ex utraque parte lignum vitae afferens fructus duodecim, per menses singulos reddens fructum suum; et folia ligni ad sanitatem gentium."
,"3":"Et omne maledictum non erit amplius. Et thronus Dei et Agni in illa erit; et servi eius servient illi"
,"4":"et videbunt faciem eius, et nomen eius in frontibus eorum."
,"5":"Et nox ultra non erit, et non egent lumine lucernae neque lumine solis, quoniam Dominus Deus illuminabit super illos, et regnabunt in saecula saeculorum."
,"6":"Et dixit mihi: ' Haec verba fidelissima et vera sunt, et Dominus, Deus spirituum prophetarum, misit angelum suum ostendere servis suis, quae oportet fieri cito."
,"7":"Et ecce venio velociter. Beatus, qui servat verba prophetiae libri huius '."
,"8":"Et ego Ioannes, qui audivi et vidi haec. Et postquam audissem et vidissem, cecidi, ut adorarem ante pedes angeli, qui mihi haec ostendebat."
,"9":"Et dicit mihi: ' Vide, ne feceris. Conservus tuus sum et fratrum tuorum prophetarum et eorum, qui servant verba libri huius; Deum adora! '."
,"10":"Et dicit mihi: ' Ne signaveris verba prophetiae libri huius; tempus enim prope est!"
,"11":"Qui nocet, noceat adhuc; et, qui sordidus est, sordescat adhuc; et iustus iustitiam faciat adhuc; et sanctus sanctificetur adhuc."
,"12":"Ecce venio cito, et merces mea mecum est, reddere unicuique sicut opus eius est."
,"13":"Ego Alpha et Omega, primus et novissimus, principium et finis."
,"14":"Beati, qui lavant stolas suas, ut sit potestas eorum super lignum vitae, et per portas intrent in civitatem."
,"15":"Foris canes et venefici et impudici et homicidae et idolis servientes et omnis, qui amat et facit mendacium!"
,"16":"Ego Iesus misi angelum meum testificari vobis haec super ecclesiis. Ego sum radix et genus David, stella splendida matutina '."
,"17":"Et Spiritus et sponsa dicunt: ' Veni! '. Et, qui audit, dicat: ' Veni! '. Et, qui sitit, veniat; qui vult, accipiat aquam vitae gratis."
,"18":"Contestor ego omni audienti verba prophetiae libri huius: Si quis apposuerit ad haec, apponet Deus super illum plagas scriptas in libro isto;"
,"19":"et si quis abstulerit de verbis libri prophetiae huius, auferet Deus partem eius de ligno vitae et de civitate sancta, de his, quae scripta sunt in libro isto."
,"20":"Dicit, qui testimonium perhibet istorum: ' Etiam, venio cito '. ' Amen. Veni, Domine Iesu! '."
,"21":"Gratia Domini Iesu cum omnibus."
}`)

}
func LA_NVBSE_LoadNTHBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Multifariam et multis modis olim Deus locutus patribus in prophetis,"
,"2":"in novissimis his diebus locutus est nobis in Filio, quem constituit heredem universorum, per quem fecit et saecula;"
,"3":"qui, cum sit splendor gloriae et figura substantiae eius et portet omnia verbo virtutis suae, purgatione peccatorum facta, consedit ad dexteram maiestatis in excelsis,"
,"4":"tanto melior angelis effectus, quanto differentius prae illis nomen hereditavit."
,"5":"Cui enim dixit aliquando angelorum: ' Filius meus es tu; ego hodie genui te ',et rursum: ' Ego ero illi in patrem, et ipse erit mihi in filium '?"
,"6":"Cum autem iterum introducit primogenitum in orbem terrae, dicit: ' Et adorent eum omnes angeli Dei '."
,"7":"Et ad angelos quidem dicit: ' Qui facit angelos suos spiritus,et ministros suos flammam ignis ';"
,"8":"ad Filium autem: ' Thronus tuus, Deus, in saeculum saeculi, et virga aequitatis virga regni tui."
,"9":"Dilexisti iustitiam et odisti iniquitatem, propterea unxit te Deus, Deus tuus, oleo exsultationis prae participibus tuis ' "
,"10":"et: ' Tu in principio, Domine, terram fundasti; et opera manuum tuarum sunt caeli."
,"11":"Ipsi peribunt, tu autem permanes; et omnes ut vestimentum veterascent,"
,"12":"et velut amictum involves eos, sicut vestimentum et mutabuntur. Tu autem idem es, et anni tui non deficient '."
,"13":"Ad quem autem angelorum dixit aliquando: ' Sede a dextris meis, donec ponam inimicos tuos scabellum pedum tuorum '?"
,"14":"Nonne omnes sunt administratorii spiritus, qui in ministerium mittuntur propter eos, qui hereditatem capient salutis?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Propterea abundantius oportet observare nos ea, quae audivi mus, ne forte praeterfluamus."
,"2":"Si enim, qui per angelos dictus est, sermo factus est firmus, et omnis praevaricatio et inoboedientia accepit iustam mercedis retributionem,"
,"3":"quomodo nos effugiemus, si tantam neglexerimus salutem? Quae, cum initium accepisset enarrari per Dominum, ab eis, qui audierunt, in nos confirmata est,"
,"4":"contestante Deo signis et portentis et variis virtutibus et Spiritus Sancti distributionibus secundum suam voluntatem."
,"5":"Non enim angelis subiecit orbem terrae futurum, de quo loquimur."
,"6":"Testatus est autem in quodam loco quis dicens: ' Quid est homo, quod memor es eius, aut filius hominis, quoniam visitas eum?"
,"7":"Minuisti eum paulo minus ab angelis, gloria et honore coronasti eum,"
,"8":"omnia subiecisti sub pedibus eius '. In eo enim quod ei omnia subiecit, nihil dimisit non subiectibile ei. Nunc autem necdum videmus omnia subiecta ei; "
,"9":"eum autem, qui paulo minus ab angelis minoratus est, videmus Iesum propter passionem mortis gloria et honore coronatum, ut gratia Dei pro omnibus gustaverit mortem."
,"10":"Decebat enim eum, propter quem omnia et per quem omnia, qui multos filios in gloriam adduxit, ducem salutis eorum per passiones consummare."
,"11":"Qui enim sanctificat et qui sanctificantur, ex uno omnes; propter quam causam non erubescit fratres eos vocare"
,"12":"dicens: ' Nuntiabo nomen tuum fratribus meis, in medio ecclesiae laudabo te';"
,"13":"et iterum: ' Ego ero fidens in eum '; et iterum: ' Ecce ego et pueri, quos mihi dedit Deus '."
,"14":"Quia ergo pueri communicaverunt sanguini et carni, et ipse similiter participavit iisdem, ut per mortem destrueret eum, qui habebat mortis imperium, id est Diabolum,"
,"15":"et liberaret eos, qui timore mortis per totam vitam obnoxii erant servituti."
,"16":"Nusquam enim angelos apprehendit, sed semen Abrahae apprehendit."
,"17":"Unde debuit per omnia fratribus similari, ut misericors fieret et fidelis pontifex in iis, quae sunt ad Deum, ut repropitiaret delicta populi; "
,"18":"in quo enim passus est ipse tentatus, po tens est eis, qui tentantur, auxiliari."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Unde, fratres sancti, vocationis caelestis participes, considerate apostolum et pontificem confessionis nostrae Iesum,"
,"2":"qui fidelis est ei, qui fecit illum, sicut et Moyses in tota domo illius."
,"3":"Amplioris enim gloriae iste prae Moyse dignus est habitus, quanto ampliorem honorem habet quam domus, qui fabricavit illam."
,"4":"Omnis namque domus fabricatur ab aliquo; qui autem omnia fabricavit, Deus est."
,"5":"Et Moyses quidem fidelis erat in tota domo eius tamquam famulus in testimonium eorum, quae dicenda erant,"
,"6":"Christus vero tamquam Filius super domum illius; cuius domus sumus nos, si fiduciam et gloriationem spei retineamus."
,"7":"Quapropter, sicut dicit Spiritus Sanctus: ' Hodie, si vocem eius audieritis,"
,"8":"nolite obdurare corda vestra sicut in exacerbatione, secundum diem tentationis in deserto,"
,"9":"ubi tentaverunt me patres vestri in probatione,et viderunt opera mea "
,"10":"quadraginta annos. Propter quod infensus fui generationi huic et dixi: Semper errant corde. Ipsi autem non cognoverunt vias meas;"
,"11":"sicut icut iuravi in ira mea: Non introibunt in requiem meam '."
,"12":"Videte, fratres, ne forte sit in aliquo vestrum cor malum incredulitatis discedendi a Deo vivo,"
,"13":"sed adhortamini vosmetipsos per singulos dies, donec illud ' hodie ' vocatur, ut non obduretur quis ex vobis fallacia peccati;"
,"14":"participes enim Christi effecti sumus, si tamen initium substantiae usque ad finem firmum retineamus,"
,"15":"dum dicitur: ' Hodie, si vocem eius audieritis, nolite obdurare corda vestra quemadmodum in illa exacerbatione '."
,"16":"Qui sunt enim qui audientes exacerbaverunt? Nonne universi, qui profecti sunt ab Aegypto per Moysen?"
,"17":"Quibus autem infensus fuit quadraginta annos? Nonne illis, qui peccaverunt, quorum membra ceciderunt in deserto?"
,"18":"Quibus autem iuravit non introire in requiem ipsius, nisi illis, qui increduli fuerunt?"
,"19":"Et videmus quia non potuerunt introire propter incredulitatem."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Timeamus ergo, ne forte, relicta pollicitatione introeundi in re quiem eius, existimetur aliquis ex vobis deesse;"
,"2":"etenim et nobis evangelizatum est quemadmodum et illis, sed non profuit illis sermo auditus, non commixtis fide cum iis, qui audierant."
,"3":"Ingredimur enim in requiem, qui credidimus, quemadmodum dixit: ' Sicut iuravi in ira mea: Non introibunt in requiem meam ', et quidem operibus ab institutione mundi factis. "
,"4":"Dixit enim quodam loco de die septima sic: 'Et requievit Deus die septima ab omnibus operibus suis ';"
,"5":"et in isto rursum: ' Non introibunt in requiem meam '."
,"6":"Quoniam ergo superest quosdam introire in illam, et hi, quibus prioribus evangelizatum est, non introierunt propter inoboedientiam,"
,"7":"iterum terminat diem quendam, ' Hodie ', in David dicendo post tantum temporis, sicut supra dictum est: ' Hodie, si vocem eius audieritis, nolite obdurare corda vestra '."
,"8":"Nam, si eis Iesus requiem praestitisset, non de alio loqueretur posthac die."
,"9":"Itaque relinquitur sabbatismus populo Dei;"
,"10":"qui enim ingressus est in requiem eius, etiam ipse requievit ab operibus suis, sicut a suis Deus."
,"11":"Festinemus ergo ingredi in illam requiem, ut ne in idipsum quis incidat inoboedientiae exemplum."
,"12":"Vivus est enim Dei sermo et efficax et penetrabilior omni gladio ancipiti et pertingens usque ad divisionem animae ac spiritus, compagum quoque et medullarum, et discretor cogitationum et intentionum cordis;"
,"13":"et non est creatura invisibilis in conspectu eius, omnia autem nuda et aperta sunt oculis eius, ad quem nobis sermo."
,"14":"Habentes ergo pontificem magnum, qui penetravit caelos, Iesum Filium Dei, teneamus confessionem."
,"15":"Non enim habemus pontificem, qui non possit compati infirmitatibus nostris, tentatum autem per omnia secundum similitudinem absque peccato;"
,"16":"adeamus ergo cum fiducia ad thronum gratiae, ut misericordiam consequamur et gratiam inveniamus in auxilium opportunum."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Omnis namque pontifex ex hominibus assumptus pro homi nibus constituitur in his, quae sunt ad Deum, ut offerat dona et sacrificia pro peccatis;"
,"2":"qui aeque condolere possit his, qui ignorant et errant, quoniam et ipse circumdatus est infirmitate"
,"3":"et propter eam debet, quemadmodum et pro populo, ita etiam pro semetipso offerre pro peccatis."
,"4":"Nec quisquam sumit sibi illum honorem, sed qui vocatur a Deo tamquam et Aaron."
,"5":"Sic et Christus non semetipsum glorificavit, ut pontifex fieret, sed qui locutus est ad eum: ' Filius meus es tu; ego hodie genui te ';"
,"6":"quemadmodum et in alio dicit: ' Tu es sacerdos in aeternum secundum ordinem Melchisedech '."
,"7":"Qui in diebus carnis suae, preces supplicationesque ad eum, qui possit salvum illum a morte facere, cum clamore valido et lacrimis offerens et exauditus pro sua reverentia,"
,"8":"et quidem cum esset Filius, didicit ex his, quae passus est, oboedientiam;"
,"9":"et, consummatus, factus est omnibus oboedientibus sibi auctor salutis aeternae,"
,"10":"appellatus a Deo pontifex iuxta ordinem Melchisedech."
,"11":"De quo grandis nobis sermo et ininterpretabilis ad dicendum, quoniam segnes facti estis ad audiendum."
,"12":"Etenim cum deberetis magistri esse propter tempus, rursum indigetis, ut vos doceat aliquis elementa exordii sermonum Dei, et facti estis, quibus lacte opus sit, non solido cibo."
,"13":"Omnis enim, qui lactis est particeps, expers est sermonis iustitiae, parvulus enim est;"
,"14":"perfectorum autem est solidus cibus, eorum, qui pro consuetudine exercitatos habent sensus ad discretionem boni ac mali."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Quapropter praetermittentes inchoationis Christi sermonem ad perfectionem feramur, non rursum iacientes fundamentum paenitentiae ab operibus mortuis et fidei ad Deum,"
,"2":"baptismatum doctrinae, impositionis quoque manuum, ac resurrectionis mortuorum et iudicii aeterni."
,"3":"Et hoc faciemus, si quidem permiserit Deus."
,"4":"Impossibile est enim eos, qui semel sunt illuminati, gustaverunt etiam donum caeleste et participes sunt facti Spiritus Sancti"
,"5":"et bonum gustaverunt Dei verbum virtutesque saeculi venturi"
,"6":"et prolapsi sunt, rursus renovari ad paenitentiam, rursum crucifigentes sibimetipsis Filium Dei et ostentui habentes."
,"7":"Terra enim saepe venientem super se bibens imbrem et generans herbam opportunam illis, propter quos et colitur, accipit benedictionem a Deo;"
,"8":"proferens autem spinas ac tribulos reproba est et maledicto proxima, cuius finis in combustionem."
,"9":"Confidimus autem de vobis, dilectissimi, meliora et viciniora saluti, tametsi ita loquimur;"
,"10":"non enim iniustus Deus, ut obliviscatur operis vestri et dilectionis, quam ostendistis nomini ipsius, qui ministrastis sanctis et ministratis."
,"11":"Cupimus autem unumquemque vestrum eandem ostentare sollicitudinem ad expletionem spei usque in finem,"
,"12":"ut non segnes efficiamini, verum imitatores eorum, qui fide et patientia hereditant promissiones."
,"13":"Abrahae namque promittens Deus, quoniam neminem habuit, per quem iuraret maiorem, iuravit per semetipsum"
,"14":"dicens: ' Utique benedicens benedicam te et multiplicans multiplicabo te ';"
,"15":"et sic longanimiter ferens adeptus est repromissionem."
,"16":"Homines enim per maiorem sui iurant, et omnis controversiae eorum finis ad confirmationem est iuramentum;"
,"17":"in quo abundantius volens Deus ostendere pollicitationis heredibus immobilitatem consilii sui, se interposuit iure iurando,"
,"18":"ut per duas res immobiles, in quibus impossibile est mentiri Deum, fortissimum solacium habeamus, qui confugimus ad tenendam propositam spem;"
,"19":"quam sicut ancoram habemus animae, tutam ac firmam et incedentem usque in interiora velaminis,"
,"20":"ubi praecursor pro nobis introivit Iesus, secundum ordinem Melchisedech pontifex factus in aeternum."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Hic enim Melchisedech, rex Salem, sacerdos Dei summi, qui ob viavit Abrahae regresso a caede regum et benedixit ei,"
,"2":"cui et decimam omnium divisit Abraham, primum quidem, qui interpretatur rex iustitiae, deinde autem et rex Salem, quod est rex Pacis,"
,"3":"sine patre, sine matre, sine genealogia, neque initium dierum neque finem vitae habens, assimilatus autem Filio Dei, manet sacerdos in perpetuum."
,"4":"Intuemini autem quantus sit hic, cui et decimam dedit de praecipuis Abraham patriarcha."
,"5":"Et illi quidem, qui de filiis Levi sacerdotium accipiunt, mandatum habent decimas sumere a populo secundum legem, id est a fratribus suis, quamquam et ipsi exierunt de lumbis Abrahae;"
,"6":"hic autem, cuius generatio non annumeratur in eis, decimam sumpsit ab Abraham et eum, qui habebat repromissiones, benedixit."
,"7":"Sine ulla autem contradictione, quod minus est, a meliore benedicitur."
,"8":"Et hic quidem decimas morientes homines sumunt; ibi autem testimonium accipiens quia vivit."
,"9":"Et, ut ita dictum sit, per Abraham et Levi, qui decimas accipit, decimatus est;"
,"10":"adhuc enim in lumbis patris erat, quando obviavit ei Melchisedech."
,"11":"Si ergo consummatio per sacerdotium leviticum erat, populus enim sub ipso legem accepit, quid adhuc necessarium secundum ordinem Melchisedech alium surgere sacerdotem et non secundum ordinem Aaron dici?"
,"12":"Translato enim sacerdotio, necesse est, ut et legis translatio fiat."
,"13":"De quo enim haec dicuntur, ex alia tribu est, ex qua nullus altari praesto fuit;"
,"14":"manifestum enim quod ex Iuda ortus sit Dominus noster, in quam tribum nihil de sacerdotibus Moyses locutus est."
,"15":"Et amplius adhuc manifestum est, si secundum similitudinem Melchisedech exsurgit alius sacerdos,"
,"16":"qui non secundum legem mandati carnalis factus est sed secundum virtutem vitae insolubilis,"
,"17":"testimonium enim accipit: ' Tu es sacerdos in aeternum secundum ordinem Melchisedech '."
,"18":"Reprobatio quidem fit praecedentis mandati propter infirmitatem eius et inutilitatem,"
,"19":"nihil enim ad perfectum adduxit lex; introductio vero melioris spei, per quam proximamus ad Deum."
,"20":"Et quantum non est sine iure iurando; illi quidem sine iure iurando sacerdotes facti sunt,"
,"21":"hic autem cum iure iurando per eum, qui dicit ad illum: ' Iuravit Dominus et non paenitebit eum: Tu es sacerdos in aeternum ',"
,"22":"in tantum et melioris testamenti sponsor factus est Iesus."
,"23":"Et illi quidem plures facti sunt sacerdotes, idcirco quod morte prohibebantur permanere;"
,"24":"hic autem eo quod manet in aeternum, intransgressibile habet sacerdotium;"
,"25":"unde et salvare in perpetuum potest accedentes per semetipsum ad Deum, semper vivens ad interpellandum pro eis."
,"26":"Talis enim et decebat ut nobis esset pontifex, sanctus, innocens, impollutus, segregatus a peccatoribus et excelsior caelis factus;"
,"27":"qui non habet necessitatem cotidie, quemadmodum pontifices, prius pro suis delictis hostias offerre, deinde pro populi; hoc enim fecit semel semetipsum offerendo."
,"28":"Lex enim homines constituit pontifices infirmitatem habentes; sermo autem iuris iurandi, quod post legem est, Filium in aeternum consummatum."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Caput autem super ea, quae dicuntur: talem habemus ponti ficem, qui consedit in dextera throni Maiestatis in caelis,"
,"2":"sanctorum minister et tabernaculi veri, quod fixit Dominus, non homo."
,"3":"Omnis enim pontifex ad offerenda munera et hostias constituitur; unde necesse erat et hunc habere aliquid, quod offerret."
,"4":"Si ergo esset super terram, nec esset sacerdos, cum sint qui offerant secundum legem munera;"
,"5":"qui figurae et umbrae deserviunt caelestium, sicut responsum est Moysi, cum consummaturus esset tabernaculum: ' Vide enim, inquit, omnia facies secundum exemplar, quod tibi ostensum est in monte '."
,"6":"Nunc autem differentius sortitus est ministerium, quanto et melioris testamenti mediator est, quod in melioribus repromissionibus sancitum est."
,"7":"Nam si illud prius culpa vacasset, non secundi locus inquireretur;"
,"8":"vituperans enim eos dicit: ' Ecce dies veniunt, dicit Dominus, et consummabo super domum Israel et super domum Iudae testamentum novum;"
,"9":"non secundum testamentum, quod feci patribus eorum in die, qua apprehendi manum illorum, ut educerem illos de terra Aegypti; quoniam ipsi non permanserunt in testamento meo, et ego neglexi eos, dicit Dominus."
,"10":"Quia hoc est testamentum, quod testabor domui Israel post dies illos, dicit Dominus, dando leges meas in mentem eorum, et in corde eorum superscribam eas; et ero eis in Deum, et ipsi erunt mihi in populum."
,"11":"Et non docebit unusquisque civem suum, et unusquisque fratrem suum dicens: 'Cognosce Dominum'; quoniam omnes scient me, a minore usque ad maiorem eorum,"
,"12":"quia propitius ero iniquitatibus eorum et peccatorum illorum iam non memorabor '."
,"13":"Dicendo ' novum ' veteravit prius; quod autem antiquatur et senescit, prope interitum est."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Habuit ergo et prius praecepta cultus et Sanctum huius saeculi."
,"2":"Tabernaculum enim praeparatum est primum, in quo inerat candelabrum et mensa et propositio panum, quod dicitur Sancta;"
,"3":"post secundum autem velamentum, tabernaculum, quod dicitur Sancta Sanctorum,"
,"4":"aureum habens turibulum et arcam testamenti circumtectam ex omni parte auro, in qua urna aurea habens manna et virga Aaron, quae fronduerat, et tabulae testamenti,"
,"5":"superque eam cherubim gloriae obumbrantia propitiatorium; de quibus non est modo dicendum per singula."
,"6":"His vero ita praeparatis, in prius quidem tabernaculum semper intrant sacerdotes sacrorum officia consummantes;"
,"7":"in secundum autem semel in anno solus pontifex, non sine sanguine, quem offert pro suis et populi ignorantiis;"
,"8":"hoc significante Spiritu Sancto, nondum propalatam esse sanctorum viam, adhuc priore tabernaculo habente statum;"
,"9":"quae parabola est temporis instantis, iuxta quam munera et hostiae offeruntur, quae non possunt iuxta conscientiam perfectum facere servientem,"
,"10":"solummodo in cibis et in potibus et variis baptismis, quae sunt praecepta carnis usque ad tempus correctionis imposita."
,"11":"Christus autem cum advenit pontifex futurorum bonorum, per amplius et perfectius tabernaculum, non manufactum, id est non huius creationis,"
,"12":"neque per sanguinem hircorum et vitulorum sed per proprium sanguinem introivit semel in Sancta, aeterna redemptione inventa."
,"13":"Si enim sanguis hircorum et taurorum et cinis vitulae aspersus inquinatos sanctificat ad emundationem carnis,"
,"14":"quanto magis sanguis Christi, qui per Spiritum aeternum semetipsum obtulit immaculatum Deo, emundabit conscientiam nostram ab operibus mortuis ad serviendum Deo viventi."
,"15":"Et ideo novi testamenti mediator est, ut, morte intercedente in redemptionem earum praevaricationum, quae erant sub priore testamento, repromissionem accipiant, qui vocati sunt aeternae hereditatis."
,"16":"Ubi enim testamentum, mors necesse est afferatur testatoris;"
,"17":"testamentum autem in mortuis est confirmatum, nondum enim valet, dum vivit, qui testatus est."
,"18":"Unde ne prius quidem sine sanguine dedicatum est;"
,"19":"enuntiato enim omni mandato secundum legem a Moyse universo populo, accipiens sanguinem vitulorum et hircorum cum aqua et lana coccinea et hyssopo, ipsum librum et omnem populum aspersit"
,"20":"dicens: ' Hic sanguis testamenti, quod mandavit ad vos Deus ';"
,"21":"etiam tabernaculum et omnia vasa ministerii sanguine similiter aspersit."
,"22":"Et omnia paene in sanguine mundantur secundum legem, et sine sanguinis effusione non fit remissio."
,"23":"Necesse erat ergo figuras quidem caelestium his mundari, ipsa autem caelestia melioribus hostiis quam istis."
,"24":"Non enim in manufacta Sancta Christus introivit, quae sunt similitudo verorum, sed in ipsum caelum, ut appareat nunc vultui Dei pro nobis;"
,"25":"neque ut saepe offerat semetipsum, quemadmodum pontifex intrat in Sancta per singulos annos in sanguine alieno."
,"26":"Alioquin oportebat eum frequenter pati ab origine mundi; nunc autem semel in consummatione saeculorum ad destitutionem peccati per sacrificium sui manifestatus est."
,"27":"Et quemadmodum statutum est hominibus semel mori, post hoc autem iudicium,"
,"28":"sic et Christus, semel oblatus ad multorum auferenda peccata, secundo sine peccato apparebit exspectantibus se in salutem."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Umbram enim habens lex bonorum futurorum, non ip sam imaginem rerum, per singulos annos iisdem ipsis hostiis, quas offerunt indesinenter, numquam potest accedentes perfectos facere."
,"2":"Alioquin nonne cessassent offerri, ideo quod nullam haberent ultra conscientiam peccatorum cultores semel mundati?"
,"3":"Sed in ipsis commemoratio peccatorum per singulos annos fit."
,"4":"Impossibile enim est sanguinem taurorum et hircorum auferre peccata."
,"5":"Ideo ingrediens mundum dicit: ' Hostiam et oblationem noluisti, corpus autem aptasti mihi;"
,"6":"holocautomata et sacrificia pro peccato,non tibi placuerunt."
,"7":"Tunc dixi: Ecce venio, in capitulo libri scriptum est de me, ut faciam, Deus, voluntatem tuam '."
,"8":"Superius dicens: ' Hostias et oblationes et holocautomata et sacrificia pro peccato noluisti, nec placuerunt tibi ', quae secundum legem offeruntur,"
,"9":"tunc dixit: ' Ecce venio, ut faciam voluntatem tuam '. Aufert primum, ut secundum statuat;"
,"10":"in qua voluntate sanctificati sumus per oblationem corporis Christi Iesu in semel."
,"11":"Et omnis quidem sacerdos stat cotidie ministrans et easdem saepe offerens hostias, quae numquam possunt auferre peccata."
,"12":"Hic autem, una pro peccatis oblata hostia, in sempiternum consedit in dextera Dei,"
,"13":"de cetero exspectans, donec ponantur inimici eius scabellum pedum eius;"
,"14":"una enim oblatione consummavit in sempiternum eos, qui sanctificantur."
,"15":"Testificatur autem nobis et Spiritus Sanctus; postquam enim dixit:"
,"16":"' Hoc est testamentum, quod testabor ad illos post dies illos, dicit Dominus, dando leges meas in cordibus eorum, et in mente eorum superscribam eas;"
,"17":"et peccatorum eorum et iniquitatum eorum iam non recordabor amplius '."
,"18":"Ubi autem horum remissio, iam non oblatio pro peccato."
,"19":"Habentes itaque, fratres, fiduciam in introitum Sanctorum in sanguine Iesu,"
,"20":"quam initiavit nobis viam novam et viventem per velamen, id est carnem suam,"
,"21":"et sacerdotem magnum super domum Dei,"
,"22":"accedamus cum vero corde in plenitudine fidei, aspersi corda a conscientia mala et abluti corpus aqua munda;"
,"23":"teneamus spei confessionem indeclinabilem, fidelis enim est, qui repromisit;"
,"24":"et consideremus invicem in provocationem caritatis et bonorum operum,"
,"25":"non deserentes congregationem nostram, sicut est consuetudinis quibusdam, sed exhortantes, et tanto magis quanto videtis appropinquantem diem."
,"26":"Voluntarie enim peccantibus nobis, post acceptam notitiam veritatis, iam non relinquitur pro peccatis hostia,"
,"27":"terribilis autem quaedam exspectatio iudicii, et ignis aemulatio, quae consumptura est adversarios."
,"28":"Irritam quis faciens legem Moysis, sine ulla miseratione duobus vel tribus testibus moritur;"
,"29":"quanto deteriora putatis merebitur supplicia, qui Filium Dei conculcaverit et sanguinem testamenti communem duxerit, in quo sanctificatus est, et Spiritui gratiae contumeliam fecerit?"
,"30":"Scimus enim eum, qui dixit: ' Mihi vindicta, ego retribuam '; et iterum: ' Iudicabit Dominus populum suum '."
,"31":"Horrendum est incidere in manus Dei viventis."
,"32":"Rememoramini autem pristinos dies, in quibus illuminati magnum certamen sustinuistis passionum,"
,"33":"in altero quidem opprobriis et tribulationibus spectaculum facti, in altero autem socii taliter conversantium effecti;"
,"34":"nam et vinctis compassi estis et rapinam bonorum vestrorum cum gaudio suscepistis, cognoscentes vos habere meliorem substantiam et manentem."
,"35":"Nolite itaque abicere confidentiam vestram, quae magnam habet remunerationem;"
,"36":"patientia enim vobis necessaria est, ut voluntatem Dei facientes reportetis promissionem."
,"37":"Adhuc enim modicum quantulum, qui venturus est, veniet et non tardabit."
,"38":"Iustus autem meus ex fide vivet; quod si subtraxerit se, non sibi complacet in eo anima mea."
,"39":"Nos autem non sumus subtractionis in perditionem, sed fidei in acquisitionem animae."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Est autem fides sperando rum substantia, rerum argu mentum non apparentium."
,"2":"In hac enim testimonium consecuti sunt seniores."
,"3":"Fide intellegimus aptata esse saecula verbo Dei, ut ex invisibilibus visibilia facta sint."
,"4":"Fide ampliorem hostiam Abel quam Cain obtulit Deo, per quam testimonium consecutus est esse iustus, testimonium perhibente muneribus eius Deo; et per illam defunctus adhuc loquitur."
,"5":"Fide Henoch translatus est, ne videret mortem, et non inveniebatur, quia transtulit illum Deus; ante translationem enim testimonium accepit placuisse Deo."
,"6":"Sine fide autem impossibile placere; credere enim oportet accedentem ad Deum quia est et inquirentibus se remunerator fit."
,"7":"Fide Noe, responso accepto de his, quae adhuc non videbantur, reveritus aptavit arcam in salutem domus suae; per quam damnavit mundum, et iustitiae, quae secundum fidem est, heres est institutus."
,"8":"Fide vocatus Abraham oboedivit in locum exire, quem accepturus erat in hereditatem; et exivit nesciens quo iret."
,"9":"Fide peregrinatus est in terra promissionis tamquam in aliena, in casulis habitando cum Isaac et Iacob, coheredibus promissionis eiusdem;"
,"10":"exspectabat enim fundamenta habentem civitatem, cuius artifex et conditor Deus."
,"11":"Fide - et ipsa Sara sterilis - virtutem in conceptionem seminis accepit etiam praeter tempus aetatis, quoniam fidelem credidit esse, qui promiserat;"
,"12":"propter quod et ab uno orti sunt, et hoc emortuo, tamquam sidera caeli in multitudine, et sicut arena, quae est ad oram maris, innumerabilis."
,"13":"Iuxta fidem defuncti sunt omnes isti, non acceptis promissionibus, sed a longe eas aspicientes et salutantes, et confitentes quia peregrini et hospites sunt supra terram;"
,"14":"qui enim haec dicunt, significant se patriam inquirere."
,"15":"Et si quidem illius meminissent, de qua exierant, habebant utique tempus revertendi;"
,"16":"nunc autem meliorem appetunt, id est caelestem. Ideo non confunditur Deus vocari Deus eorum, paravit enim illis civitatem."
,"17":"Fide obtulit Abraham Isaac, cum tentaretur; et unigenitum offerebat ille, qui susceperat promissiones,"
,"18":"ad quem dictum erat: ' In Isaac vocabitur tibi semen ',"
,"19":"arbitratus quia et a mortuis suscitare potens est Deus; unde eum et in parabola reportavit."
,"20":"Fide et de futuris benedixit Isaac Iacob et Esau."
,"21":"Fide Iacob moriens singulis filiorum Ioseph benedixit et adoravit super fastigium virgae suae."
,"22":"Fide Ioseph moriens de profectione filiorum Israel memoratus est et de ossibus suis mandavit."
,"23":"Fide Moyses natus occultatus est mensibus tribus a parentibus suis, eo quod vidissent formosum infantem et non timuerunt regis edictum."
,"24":"Fide Moyses grandis factus negavit se dici filium filiae pharaonis,"
,"25":"magis eligens affligi cum populo Dei quam temporalem peccati habere iucunditatem,"
,"26":"maiores divitias aestimans thesauris Aegypti improperium Christi; aspiciebat enim in remunerationem."
,"27":"Fide reliquit Aegyptum non veritus animositatem regis, invisibilem enim tamquam videns sustinuit."
,"28":"Fide celebravit Pascha et sanguinis effusionem, ne, qui vastabat primogenita, tangeret ea."
,"29":"Fide transierunt mare Rubrum tamquam per aridam terram, quod experti Aegyptii devorati sunt."
,"30":"Fide muri Iericho ruerunt circuiti diebus septem."
,"31":"Fide Rahab meretrix non periit cum incredulis, quia exceperat exploratores cum pace."
,"32":"Et quid adhuc dicam? Deficiet enim me tempus enarrantem de Gedeon, Barac, Samson, Iephte, David et Samuel atque prophetis,"
,"33":"qui per fidem devicerunt regna, operati sunt iustitiam, adepti sunt repromissiones, obturaverunt ora leonum,"
,"34":"exstinxerunt impetum ignis, effugerunt aciem gladii, convaluerunt de infirmitate, fortes facti sunt in bello, castra verterunt exterorum;"
,"35":"acceperunt mulieres de resurrectione mortuos suos; alii autem distenti sunt, non suscipientes redemptionem, ut meliorem invenirent resurrectionem;"
,"36":"alii vero ludibria et verbera experti sunt, insuper et vincula et carcerem;"
,"37":"lapidati sunt, secti sunt, in occisione gladii mortui sunt, circumierunt in melotis, in pellibus caprinis, egentes, angustiati, afflicti,"
,"38":"quibus dignus non erat mundus, in solitudinibus errantes et montibus et speluncis et in cavernis terrae."
,"39":"Et hi omnes testimonium per fidem consecuti non reportaverunt promissionem,"
,"40":"Deo pro nobis melius aliquid providente, ut ne sine nobis consummarentur."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Ideoque et nos tantam ha bentes circumpositam nobis nubem testium, deponentes omne pondus et circumstans nos peccatum, per patientiam curramus propositum nobis certamen,"
,"2":"aspicientes in ducem fidei et consummatorem Iesum, qui pro gaudio sibi proposito sustinuit crucem, confusione contempta, atque in dextera throni Dei sedet."
,"3":"Recogitate enim eum, qui talem sustinuit a peccatoribus adversum semetipsum contradictionem, ut ne fatigemini animis vestris deficientes."
,"4":"Nondum usque ad sanguinem restitistis adversus peccatum repugnantes;"
,"5":"et obliti estis exhortationis, quae vobis tamquam filiis loquitur: ' Fili mi, noli neglegere disciplinam Domini,neque deficias, dum ab eo argueris:"
,"6":"quem enim diligit, Dominus castigat, flagellat autem omnem filium, quem recipit '."
,"7":"Ad disciplinam suffertis; tamquam filios vos tractat Deus. Quis enim filius, quem non corripit pater?"
,"8":"Quod si extra disciplinam estis, cuius participes facti sunt omnes, ergo adulterini et non filii estis!"
,"9":"Deinde patres quidem carnis nostrae habebamus eruditores et reverebamur; non multo magis obtemperabimus Patri spirituum et vivemus?"
,"10":"Et illi quidem ad tempus paucorum dierum, secundum quod videbatur illis, castigabant; hic autem ad id, quod utile est ad participandam sanctitatem eius."
,"11":"Omnis autem disciplina in praesenti quidem videtur non esse gaudii sed maeroris; postea autem fructum pacificum exercitatis per eam reddit iustitiae."
,"12":"Propter quod remissas manus et soluta genua erigite"
,"13":"et gressus rectos facite pedibus vestris, ut, quod claudum est, non extorqueatur, magis autem sanetur."
,"14":"Pacem sectamini cum omnibus et sanctificationem, sine qua nemo videbit Dominum,"
,"15":"providentes, ne quis desit gratiae Dei, ne qua radix amaritudinis sursum germinans perturbet, et per illam inquinentur multi;"
,"16":"ne quis fornicator aut profanus ut Esau, qui propter unam escam vendidit primogenita sua."
,"17":"Scitis enim quoniam et postea cupiens hereditare benedictionem reprobatus est; non enim invenit paenitentiae locum, quamquam cum lacrimis inquisisset eam."
,"18":"Non enim accessistis ad tractabilem et ardentem ignem et turbinem et caliginem et procellam"
,"19":"et tubae sonum et vocem verborum, quam qui audierunt, recusaverunt, ne ultra eis fieret verbum;"
,"20":"non enim portabant mandatum: ' Et si bestia tetigerit montem, lapidabitur';"
,"21":"et ita terribile erat, quod videbatur, Moyses dixit: ' Exterritus sum et tremebundus '."
,"22":"Sed accessistis ad Sion montem et civitatem Dei viventis, Ierusalem caelestem, et multa milia angelorum, frequentiam"
,"23":"et ecclesiam primogenitorum, qui conscripti sunt in caelis, et iudicem Deum omnium et spiritus iustorum, qui consummati sunt,"
,"24":"et testamenti novi mediatorem Iesum et sanguinem aspersionis, melius loquentem quam Abel."
,"25":"Videte, ne recusetis loquentem; si enim illi non effugerunt recusantes eum, qui super terram loquebatur, multo magis nos, qui de caelis loquentem avertimus;"
,"26":"cuius vox movit terram tunc, modo autem pronuntiavit dicens: ' Adhuc semel ego movebo non solum terram sed et caelum '."
,"27":"Hoc autem ' adhuc semel ' declarat mobilium translationem tamquam factorum, ut maneant ea, quae sunt immobilia."
,"28":"Itaque, regnum immobile suscipientes, habeamus gratiam, per quam serviamus placentes Deo cum reverentia et metu;"
,"29":"etenim Deus noster ignis consumens est."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Caritas fraternitatis maneat."
,"2":"Hospitalitatem nolite obli visci; per hanc enim quidam nescientes hospitio receperunt angelos."
,"3":"Mementote vinctorum tamquam simul vincti, laborantium tamquam et ipsi in corpore morantes."
,"4":"Honorabile conubium in omnibus, et torus immaculatus; fornicatores enim et adulteros iudicabit Deus."
,"5":"Sint mores sine avaritia; contenti praesentibus. Ipse enim dixit: ' Non te deseram neque derelinquam ',"
,"6":"ita ut confidenter dicamus: ' Dominus mihi adiutor est, non timebo; quid faciet mihi homo? '."
,"7":"Mementote praepositorum vestrorum, qui vobis locuti sunt verbum Dei; quorum intuentes exitum conversationis, imitamini fidem."
,"8":"Iesus Christus heri et hodie idem, et in saecula!"
,"9":"Doctrinis variis et peregrinis nolite abduci; optimum enim est gratia stabiliri cor, non escis, quae non profuerunt ambulantibus in eis."
,"10":"Habemus altare, de quo edere non habent potestatem, qui tabernaculo deserviunt."
,"11":"Quorum enim animalium infertur sanguis pro peccato in Sancta per pontificem, horum corpora cremantur extra castra."
,"12":"Propter quod et Iesus, ut sanctificaret per suum sanguinem populum, extra portam passus est."
,"13":"Exeamus igitur ad eum extra castra, improperium eius portantes;"
,"14":"non enim habemus hic manentem civitatem, sed futuram inquirimus."
,"15":"Per ipsum ergo offeramus hostiam laudis semper Deo, id est fructum labiorum confitentium nomini eius."
,"16":"Beneficientiae autem et communionis nolite oblivisci; talibus enim hostiis oblectatur Deus."
,"17":"Oboedite praepositis vestris et subiacete eis; ipsi enim pervigilant pro animabus vestris quasi rationem reddituri, ut cum gaudio hoc faciant et non gementes; hoc enim non expedit vobis."
,"18":"Orate pro nobis; confidimus enim quia bonam conscientiam habemus, in omnibus bene volentes conversari."
,"19":"Amplius autem deprecor vos hoc facere, ut quo celerius restituar vobis."
,"20":"Deus autem pacis, qui eduxit de mortuis pastorem magnum ovium in sanguine testamenti aeterni, Dominum nostrum Iesum,"
,"21":"aptet vos in omni bono, ut faciatis voluntatem eius, faciens in nobis, quod placeat coram se per Iesum Christum, cui gloria in saecula saeculorum. Amen."
,"22":"Rogo autem vos, fratres, sufferte sermonem exhortationis; etenim perpaucis scripsi vobis."
,"23":"Cognoscite fratrem nostrum Timotheum dimissum esse; cum quo, si celerius venerit, videbo vos."
,"24":"Salutate omnes praepositos vestros et omnes sanctos. Salutant vos, qui de Italia sunt."
,"25":"Gratia cum omnibus vobis."
}`)

}
func LA_NVBSE_LoadVH1MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Et factum est, postquam per cussit Alexander Philippi Mace do, qui prius regnavit in Graecia, egressus de terra Cetthim, Darium regem Persarum et Medorum,"
,"2":"constituit proelia multa et obtinuit munitiones et interfecit reges terrae;"
,"3":"et pertransiit usque ad fines terrae et accepit spolia multitudinis gentium, et siluit terra in conspectu eius, et exaltatum est et elevatum est cor eius."
,"4":"Et congregavit virtutem fortem nimis et obtinuit regiones gentium et tyrannos, et facti sunt illi in tributum."
,"5":"Et post haec decidit in lectum et cognovit quia moreretur;"
,"6":"et vocavit pueros suos nobiles, qui secum erant nutriti a iuventute, et divisit illis regnum suum, cum adhuc viveret."
,"7":"Et regnavit Alexander annis duodecim et mortuus est."
,"8":"Et obtinuerunt pueri eius regnum, unusquisque in loco suo;"
,"9":"et imposuerunt omnes sibi diademata post mortem eius, et filii eorum post eos annis multis. Et multiplicata sunt mala in terra."
,"10":"Et exiit ex eis radix peccatrix, Antiochus Epiphanes filius Antiochi regis, qui fuerat Romae obses, et regnavit in anno centesimo tricesimo septimo regni Graecorum."
,"11":"In diebus illis exierunt ex Israel filii iniqui et suaserunt multis dicentes: ' Eamus et disponamus testamentum cum gentibus, quae circa nos sunt, quia, ex quo recessimus ab eis, invenerunt nos multa mala '."
,"12":"Et bonus visus est sermo in oculis eorum;"
,"13":"et destinaverunt aliqui de populo et abierunt ad regem, et dedit illis potestatem, ut facerent iustitias gentium."
,"14":"Et aedificaverunt gymnasium in Hierosolymis secundum leges nationum;"
,"15":"et fecerunt sibi praeputia et recesserunt a testamento sancto et iuncti sunt nationibus et venumdati sunt, ut facerent malum."
,"16":"Et paratum est regnum in conspectu Antiochi, et coepit regnare in terra Aegypti, ut regnaret super duo regna."
,"17":"Et intravit in Aegyptum in multitudine gravi, in curribus et elephantis et equitibus et navium multitudine;"
,"18":"et constituit bellum adversus Ptolemaeum regem Aegypti, et veritus est Ptolemaeus a facie eius et fugit, et ceciderunt vulnerati multi."
,"19":"Et comprehenderunt civitates munitas in terra Aegypti, et accepit spolia terrae Aegypti."
,"20":"Et reversus est Antiochus, postquam percussit Aegyptum in centesimo et quadragesimo tertio anno, et ascendit ad Israel et ad Hierosolyma in multitudine gravi"
,"21":"et intravit in sanctificationem cum superbia et accepit altare aureum et candelabrum luminis et universa vasa eius"
,"22":"et mensam propositionis et libatoria et phialas et pateras aureas et velum et coronas et ornamentum aureum, quod in facie templi erat; et comminuit omnia."
,"23":"Et accepit argentum et aurum et vasa concupiscibilia et accepit thesauros occultos, quos invenit;"
,"24":"et, sublatis omnibus, abiit in terram suam et fecit caedem hominum et locutus est superbia magna."
,"25":"Et factus est planctus magnus in Israel et in omni loco eorum;"
,"26":"et ingemuerunt principes et seniores, virgines et iuvenes infirmati sunt, et speciositas mulierum immutata est,"
,"27":"omnis maritus sumpsit lamentum, et, quae sedebat in toro maritali, lugebat;"
,"28":"et commota est terra super habitantes in ea, et universa domus Iacob induit confusionem."
,"29":"Et post duos annos dierum misit rex principem tributorum in civitates Iudae et venit Ierusalem cum turba magna;"
,"30":"et locutus est ad eos verba pacifica in dolo, et crediderunt ei. Et irruit super civitatem repente et percussit eam plaga magna et perdidit populum multum ex Israel."
,"31":"Et accepit spolia civitatis et succendit eam igne et destruxit domos eius et muros eius in circuitu;"
,"32":"et captivas duxerunt mulieres et natos et pecora possederunt."
,"33":"Et aedificaverunt civitatem David muro magno et firmo et turribus firmis; et facta est illis in arcem."
,"34":"Et posuerunt illic gentem peccatricem, viros iniquos, et convaluerunt in ea;"
,"35":"et posuerunt arma et escas et, congregatis spoliis Ierusalem, reposuerunt illic; et facti sunt in laqueum magnum."
,"36":"Et factum est hoc ad insidias sanctificationi et in diabolum malum in Israel semper;"
,"37":"et effuderunt sanguinem innocentem per circuitum sanctificationis et contaminaverunt sanctificationem."
,"38":"Et fugerunt habitatores Ierusalem propter eos, et facta est habitatio exterorum, et facta est extera semini suo; et nati eius reliquerunt eam."
,"39":"Sanctificatio eius desolata est sicut solitudo, dies festi eius conversi sunt in luctum, sabbata eius in opprobrium, honor eius in nihilum."
,"40":"Secundum gloriam eius multiplicata est ignominia eius, et sublimitas eius conversa est in luctum."
,"41":"Et scripsit rex Antiochus omni regno suo, ut essent universi populus unus,"
,"42":"et relinqueret unusquisque legem suam. Et receperunt omnes gentes secundum verbum regis Antiochi;"
,"43":"et multi ex Israel consenserunt cultui eius et sacrificaverunt idolis et coinquinaverunt sabbatum."
,"44":"Et misit rex libros per manus nuntiorum in Ierusalem et in civitates Iudae, ut sequerentur leges gentium terrae,"
,"45":"et prohibere holocausta et sacrificia et placationes fieri in templo Dei et contaminare sabbata et dies sollemnes"
,"46":"et polluere sancta et sanctos,"
,"47":"instruere aras et templa et idola et immolare porcina et pecora communia"
,"48":"et relinquere filios suos incircumcisos et polluere animas eorum in omni immundo et abominatione,"
,"49":"ita ut obliviscerentur legem et immutarent omnes iustificationes;"
,"50":"et, quicumque non fecerit secundum verbum regis Antiochi, morietur."
,"51":"Secundum omnia verba haec scripsit omni regno suo et praeposuit consideratores super omnem populum et mandavit civitatibus Iudae immolare per civitatem et civitatem."
,"52":"Et congregati sunt multi de populo ad eos, omnes, qui dereliquerant legem Domini, et fecerunt mala in terra;"
,"53":"et posuerunt Israel in abditis et in absconditis fugitivorum locis."
,"54":"Die quinta decima mensis Casleu, quinto et quadragesimo et centesimo anno, aedificavit abominationem desolationis super altare; et per civitates Iudae in circuitu aedificaverunt aras"
,"55":"et ante ianuas domorum et in plateis sacrificabant."
,"56":"Et libros legis, quos invenerunt, combusserunt igne scindentes eos;"
,"57":"et ubicumque inveniebatur apud aliquem liber testamenti, et si quis consentiebat legi, constitutio regis interficiebat eum."
,"58":"In virtute sua faciebant haec Israeli, omnibus, qui inveniebantur in omni mense et mense in civitatibus."
,"59":"Et quinta et vicesima die mensis sacrificabant super aram, quae erat super altare;"
,"60":"et mulieres, quae circumciderant filios suos, interficiebant secundum iussum"
,"61":"- et suspendebant infantes a cervicibus eorum - et domos eorum et eos, qui circumciderant illos."
,"62":"Et multi in Israel obtinuerunt et confortati sunt apud se, ut non manducarent immunda,"
,"63":"et elegerunt mori, ut non polluerentur escis et non profanarent testamentum sanctum, et moriebantur."
,"64":"Et facta est ira magna super Israel valde."
}`)
	CurrentBook.AddChapter(2, `{
"1":"In diebus illis surrexit Mattha thias filius Ioannis filii Simeonis sacerdos ex filiis Ioarib ab Ierusalem et consedit in Modin."
,"2":"Et habebat filios quinque: Ioannem, qui cognominabatur Gaddis,"
,"3":"et Simonem, qui vocabatur Thasi,"
,"4":"et Iudam, qui vocabatur Maccabaeus,"
,"5":"et Eleazarum, qui vocabatur Abaran, et Ionathan, qui vocabatur Apphus."
,"6":"Et vidit blasphemias, quae fiebant in Iuda et in Ierusalem,"
,"7":"et dixit: ' Vae mihi! Ut quid natus sum videre contritionem populi mei et contritionem civitatis sanctae? Et sederunt illic, cum daretur ea in manibus inimicorum, sanctificatio in manu extraneorum."
,"8":"Factum est templum eius sicut homo ignobilis,"
,"9":"vasa gloriae eius captiva abducta sunt, trucidati sunt parvuli eius in plateis eius, iuvenes eius in gladio inimicorum."
,"10":"Quae gens non hereditavit regnum eius et non obtinuit spolia eius?"
,"11":"Omnis ornatus eius ablatus est; quae erat libera, facta est ancilla."
,"12":"Et ecce sancta nostra et pulchritudo nostra et gloria nostra desolata est, et polluerunt ea gentes."
,"13":"Ut quid nobis adhuc vita? '."
,"14":"Et scidit vestimenta sua Matthathias et filii eius et operuerunt se ciliciis et planxerunt valde."
,"15":"Et venerunt, qui ex rege compellebant discessionem, in civitatem Modin, ut sacrificarent."
,"16":"Et multi de Israel accesserunt ad eos, et Matthathias et filii eius congregati sunt."
,"17":"Et responderunt, qui missi erant a rege, et dixerunt Matthathiae: ' Princeps et nobilis et magnus es in hac civitate et confirmatus filiis et fratribus."
,"18":"Nunc accede primus et fac iussum regis, sicut fecerunt omnes gentes et viri Iudae et qui remanserunt in Ierusalem, et eris tu et filii tui inter amicos regis et tu et filii tui glorificabimini et argento et auro et muneribus multis '."
,"19":"Et respondit Matthathias et dixit magna voce: ' Etsi omnes gentes, quae in domo regni sunt, regi oboediunt, ut discedat unusquisque ab officio patrum suorum, et consentiunt mandatis eius,"
,"20":"et ego et filii mei et fratres mei ibimus in testamento patrum nostrorum."
,"21":"Propitius sit nobis Dominus, ne derelinquamus legem et iustificationes."
,"22":"Non audiemus verba regis, ut praetereamus officium nostrum dextra vel sinistra '."
,"23":"Et, ut cessavit loqui verba haec, accessit quidam Iudaeus in omnium oculis sacrificare super aram in Modin secundum iussum regis."
,"24":"Et vidit Matthathias et zelatus est, et contremuerunt renes eius; et attulit iram secundum iudicium et insiliens trucidavit eum super aram."
,"25":"Et virum regis, qui cogebat immolare, occidit in ipso tempore et aram destruxit;"
,"26":"et zelatus est legem, sicut fecit Phinees Zambri filio Salom."
,"27":"Et exclamavit Matthathias voce magna in civitate dicens: ' Omnis, qui zelum habet legis statuens testamentum, exeat post me '."
,"28":"Et fugit ipse et filii eius in montes, et reliquerunt quaecumque habebant in civitate."
,"29":"Tunc descenderunt multi quaerentes iustitiam et iudicium in desertum, ut sederent ibi,"
,"30":"ipsi et filii eorum et mulieres eorum et pecora eorum, quoniam induraverant super eos mala."
,"31":"Et renuntiatum est viris regis et exercitui, qui erat in Ierusalem civitate David, quoniam descenderunt viri quidam, qui dissipaverant mandatum regis, in loca occulta in deserto."
,"32":"Et cucurrerunt post illos multi, et deprehendentes eos applicaverunt contra eos et constituerunt adversus eos proelium in die sabbatorum"
,"33":"et dixerunt ad eos: ' Usque hoc nunc! Exite et facite secundum verbum regis et vivetis '."
,"34":"Et dixerunt: ' Non exibimus neque faciemus verbum regis, ut polluamus diem sabbatorum '."
,"35":"Et concitaverunt adversus eos proelium."
,"36":"Et non responderunt eis nec lapidem miserunt in eos nec oppilaverunt loca occulta"
,"37":"dicentes: ' Moriamur omnes in simplicitate nostra, et testes erunt super nos caelum et terra quod iniuste perditis nos '."
,"38":"Et insurrexerunt in eos in bello sabbatis; et mortui sunt ipsi et uxores eorum et filii eorum et pecora eorum usque ad mille animas hominum."
,"39":"Et cognovit Matthathias et amici eius et luctum habuerunt super eos valde;"
,"40":"et dixit vir proximo suo: ' Si omnes fecerimus, sicut fratres nostri fecerunt, et non pugnaverimus adversus gentes pro animabus nostris et iustificationibus nostris, nunc citius disperdent nos a terra '."
,"41":"Et cogitaverunt in die illa dicentes: ' Omnis homo, quicumque venerit ad nos in bello die sabbatorum, pugnemus adversus eum et non moriemur omnes, sicut mortui sunt fratres nostri in occultis '."
,"42":"Tunc congregata est ad eos synagoga Asidaeorum fortis viribus ex Israel, omnis voluntarius in lege;"
,"43":"et omnes, qui fugiebant a malis, additi sunt ad eos et facti sunt illis ad firmamentum."
,"44":"Et constituerunt exercitum et percusserunt peccatores in ira sua et viros iniquos in indignatione sua; et ceteri fugerunt ad nationes, ut se liberarent."
,"45":"Et circuivit Matthathias et amici eius, et destruxerunt aras;"
,"46":"et circumciderunt pueros incircumcisos, quotquot invenerunt in finibus Israel, in fortitudine."
,"47":"Et persecuti sunt filios superbiae, et prosperatum est opus in manu eorum;"
,"48":"et obtinuerunt legem de manu gentium et de manu regum et non dederunt cornu peccatori."
,"49":"Et appropinquaverunt dies Matthathiae moriendi, et dixit filiis suis: ' Nunc confirmata est superbia et castigatio et tempus eversionis et ira indignationis."
,"50":"Nunc, o filii, aemulatores estote legis; et date animas vestras pro testamento patrum vestrorum."
,"51":"Et mementote operum patrum, quae fecerunt in generationibus suis, et accipietis gloriam magnam et nomen aeternum."
,"52":"Abraham, nonne in tentatione inventus est fidelis, et reputatum est ei ad iustitiam?"
,"53":"Ioseph in tempore angustiae suae custodivit mandatum et factus est dominus Aegypti."
,"54":"Phinees pater noster zelando zelum Dei accepit testamentum sacerdotii aeterni."
,"55":"Iosue, dum implet verbum, factus est iudex in Israel."
,"56":"Chaleb, dum testificatur in ecclesia, accepit hereditatem."
,"57":"David in sua misericordia consecutus est sedem regni in saecula."
,"58":"Elias, dum zelat zelum legis, receptus est in caelum."
,"59":"Ananias et Azarias et Misael credentes liberati sunt de flamma."
,"60":"Daniel in sua simplicitate liberatus est de ore leonum."
,"61":"Et ita cogitate per generationem et generationem, quia omnes, qui sperant in eum, non infirmabuntur."
,"62":"Et a verbis viri peccatoris ne timueritis, quia gloria eius in stercora et in vermes;"
,"63":"hodie extolletur et cras non invenietur, quia conversus est in pulverem suam, et cogitatio eius peribit."
,"64":"Filii, confortamini et viriliter agite in lege, quia in ipsa gloriosi eritis."
,"65":"Et ecce Simon frater vester, scio quod vir consilii est: ipsum audite semper; ipse erit vobis pater."
,"66":"Et Iudas Maccabaeus fortis viribus a iuventute sua erit vobis princeps militiae; et ipse pugnabit bellum populi."
,"67":"Et adducetis ad vos omnes factores legis et vindicate vindictam populi vestri;"
,"68":"retribuite retributionem gentibus et intendite in praeceptum legis '."
,"69":"Et benedixit eos et appositus est ad patres suos."
,"70":"Et defunctus est anno centesimo et quadragesimo sexto; et sepultus est in sepulcris patrum suorum in Modin, et planxerunt eum omnis Israel planctu magno."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et surrexit Iudas, qui vocaba tur Maccabaeus, filius eius pro eo."
,"2":"Et adiuvabant eum omnes fratres eius et universi, qui se coniunxerant patri eius; et proeliabantur proelium Israel cum laetitia."
,"3":"Et dilatavit gloriam populo suo et induit se loricam sicut gigas et succinxit se arma bellica sua et proelia constituit protegens castra gladio."
,"4":"Similis factus est leoni in operibus suis et sicut catulus leonis rugiens in venationem;"
,"5":"et persecutus est iniquos perscrutans et eos, qui conturbabant populum suum, succendit."
,"6":"Et subducti sunt iniqui prae timore eius, et omnes operarii iniquitatis conturbati sunt; et prosperata est salus in manu eius."
,"7":"Et exacerbabat reges multos; et laetificabat Iacob in operibus suis, et in saeculum memoria eius in benedictionem."
,"8":"Et perambulavit in civitatibus Iudae et disperdidit impios ex ea et avertit iram ab Israel;"
,"9":"et nominatus est usque ad ultimum terrae et congregavit pereuntes."
,"10":"Et congregavit Apollonius gentes et a Samaria virtutem magnam ad bellandum contra Israel."
,"11":"Et cognovit Iudas et exiit obviam illi; et percussit eum et occidit, et ceciderunt vulnerati multi, et reliqui fugerunt."
,"12":"Et acceperunt spolia eorum, et gladium Apollonii accepit Iudas; et erat pugnans in eo omnibus diebus."
,"13":"Et audivit Seron, princeps exercitus Syriae, quod congregavit Iudas congregationem et convocationem fidelium secum et egredientium in proelium,"
,"14":"et ait: ' Faciam mihi nomen et glorificabor in regno et debellabo Iudam et eos, qui cum ipso sunt, qui spernunt verbum regis '."
,"15":"Et accessit, et ascendit cum eo exercitus impiorum fortis auxiliari ei, ut faceret vindictam in filios Israel."
,"16":"Et appropinquavit usque ad ascensum Bethoron, et exivit Iudas obviam illi cum paucis."
,"17":"Ut autem viderunt exercitum venientem sibi obviam dixerunt Iudae: ' Quomodo poterimus pauci pugnare contra multitudinem tantam, fortem, et nos fatigati sumus ieiunio hodie? '."
,"18":"Et ait Iudas: ' Facile est concludi multos in manibus paucorum; et non est differentia in conspectu caeli liberare in multis aut in paucis,"
,"19":"quoniam non in multitudine exercitus victoria belli, sed de caelo fortitudo est."
,"20":"Ipsi veniunt ad nos in multitudine contumeliae et iniquitatis, ut disperdant nos et uxores nostras et filios nostros et ut spolient nos;"
,"21":"nos vero pugnamus pro animabus nostris et pro legitimis nostris,"
,"22":"et ipse Dominus conteret eos ante faciem nostram; vos autem ne timueritis eos '."
,"23":"Ut cessavit autem loqui, insiluit in eos subito; et contritus est Seron et exercitus eius in conspectu ipsius."
,"24":"Et persequebantur eum in descensu Bethoron usque ad campum, et ceciderunt ex eis octingenti viri; reliqui autem fugerunt in terram Philisthim."
,"25":"Et coepit timor Iudae ac fratrum eius, et formido cecidit super gentes in circuitu eorum;"
,"26":"et pervenit ad regem nomen eius, et de proeliis Iudae narrabant omnes gentes."
,"27":"Ut audivit autem Antiochus sermones istos, iratus est animo; et misit et congregavit exercitum universi regni sui, castra fortia valde."
,"28":"Et aperuit aerarium suum et dedit stipendia exercitui in annum et mandavit illis, ut essent parati ad omnia."
,"29":"Et vidit quod defecit pecunia de thesauris suis, et tributa regionis modica propter dissensionem et plagam, quam fecit in terra, ut tolleret legitima, quae erant a primis diebus;"
,"30":"et timuit, ne non haberet ut semel et bis in sumptus et donaria, quae dederat antea larga manu, et abundaverat super reges, qui ante eum fuerant."
,"31":"Et consternatus erat animo valde et cogitavit ire in Persidem et accipere tributa regionum et congregare argentum multum."
,"32":"Et reliquit Lysiam hominem nobilem de genere regali super negotia regia a flumine Euphrate usque ad fines Aegypti"
,"33":"et ut nutriret Antiochum filium suum, donec rediret."
,"34":"Et tradidit ei dimidium exercitum et elephantos et mandavit ei de omnibus, quae volebat, et de inhabitantibus Iudaeam et Ierusalem,"
,"35":"ut mitteret ad eos exercitum ad conterendam et exstirpandam virtutem Israel et reliquias Ierusalem et auferendam memoriam eorum de loco,"
,"36":"et ut constitueret habitatores filios alienigenas in omnibus finibus eorum et sorte distribueret terram eorum."
,"37":"Et rex assumpsit dimidium exercitum residuum et exivit ab Antiochia de civitate regni sui anno centesimo et quadragesimo septimo et transfretavit Euphratem flumen et perambulabat superiores regiones."
,"38":"Et elegit Lysias Ptolemaeum filium Dorymeni et Nicanorem et Gorgiam viros potentes ex amicis regis"
,"39":"et misit cum eis quadraginta milia virorum et septem milia equitum, ut venirent in terram Iudae et disperderent eam secundum verbum regis."
,"40":"Et processerunt cum universa virtute sua; et venerunt et applicaverunt prope Emmaus in terra campestri."
,"41":"Et audierunt mercatores regionis nomen eorum et acceperunt argentum et aurum multum valde et compedes et venerunt in castra, ut acciperent filios Israel in servos, et additi sunt ad eos exercitus Syriae et terrae alienigenarum."
,"42":"Et vidit Iudas et fratres eius quia multiplicata sunt mala, et exercitus applicabant ad fines eorum, et cognoverunt verba regis, quae mandavit facere populo in interitum et consummationem."
,"43":"Et dixerunt unusquisque ad proximum suum: ' Erigamus deiectionem populi nostri et pugnemus pro populo nostro et sanctis nostris '."
,"44":"Et congregatus est conventus, ut essent parati in proelium et ut orarent et peterent misericordiam et miserationes."
,"45":"Et Ierusalem non habitabatur sicut desertum; non erat qui ingrederetur et egrederetur de natis eius, et sanctum conculcabatur, et filii alienigenarum erant in arce; ibi erat habitatio gentibus. Et ablata est voluptas a Iacob, et defecit tibia et cithara."
,"46":"Et congregati sunt et venerunt in Maspha contra Ierusalem, quia in Maspha erat antea locus orationis Israeli;"
,"47":"et ieiunaverunt illa die et induerunt se ciliciis et cinerem imposuerunt capiti suo et disciderunt vestimenta sua"
,"48":"et expanderunt librum Legis, de quibus scrutabantur gentes similitudines simulacrorum suorum;"
,"49":"et attulerunt ornamenta sacerdotalia et primitias et decimas et suscitaverunt nazaraeos, qui impleverunt dies,"
,"50":"et clamaverunt voce in caelum dicentes: ' Quid faciemus istis et quo eos ducemus?"
,"51":"Et sancta tua conculcata sunt et contaminata, et sacerdotes tui in luctu et humiliatione;"
,"52":"et ecce nationes convenerunt adversum nos, ut nos disperdant: tu scis, quae cogitant in nos."
,"53":"Quomodo poterimus subsistere ante faciem eorum, nisi tu adiuves nos?'."
,"54":"Et tubis bucinaverunt et clamaverunt voce magna."
,"55":"Et post haec constituit Iudas duces populi, tribunos et centuriones et pentacontarchos et decuriones"
,"56":"et dixit his, qui aedificabant domos et sponsabant uxores et plantabant vineas, et formidolosis, ut redirent unusquisque in domum suam secundum legem."
,"57":"Et moverunt castra et collocaverunt ad austrum Emmaum."
,"58":"Et ait Iudas: ' Accingimini et estote filii potentes et estote parati in mane, ut pugnetis adversus nationes has, quae convenerunt adversus nos disperdere nos et sancta nostra;"
,"59":"quoniam melius est nos mori in bello quam respicere mala gentis nostrae et sanctorum."
,"60":"Sicut autem fuerit voluntas in caelo, sic faciet '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et assumpsit Gorgias quinque milia virorum et mille equites electos, et moverunt castra nocte,"
,"2":"ut applicarent ad castra Iudaeorum et percuterent eos subito; et, qui erant ex arce, erant illis duces."
,"3":"Et audivit Iudas et surrexit ipse et potentes percutere exercitum regis, qui erat in Emmaus,"
,"4":"dum adhuc dispersus esset exercitus a castris."
,"5":"Et venit Gorgias in castra Iudae noctu et neminem invenit; et quaerebat eos in montibus, quoniam dixit: ' Fugiunt hi a nobis '."
,"6":"Et simul ut dies factus est, apparuit Iudas in campo cum tribus milibus virorum, tantum quod tegumenta et gladios non habebant ut volebant."
,"7":"Et viderunt castra gentium valida et loricatos et equitatus in circuitu eorum, et hi docti ad proelium."
,"8":"Et ait Iudas viris, qui secum erant: ' Ne timueritis multitudinem eorum et impetum eorum ne formidetis;"
,"9":"mementote qualiter salvi facti sunt patres nostri in mari Rubro, cum sequeretur eos pharao cum exercitu."
,"10":"Et nunc clamemus in caelum, si miserebitur nostri et memor erit testamenti patrum nostrorum et conteret exercitum istum ante faciem nostram hodie;"
,"11":"et scient omnes gentes quia est, qui redimat et liberet Israel '."
,"12":"Et levaverunt alienigenae oculos suos et viderunt eos venientes ex adverso"
,"13":"et exierunt de castris in proelium. Et tuba cecinerunt hi, qui erant cum Iuda,"
,"14":"et commiserunt bellum; et contritae sunt gentes et fugerunt in campum."
,"15":"Novissimi autem omnes ceciderunt in gladio, et persecuti sunt eos usque Gazeron et usque in campos Idumaeae et Azoti et Iamniae; et ceciderunt ex illis usque ad tria milia virorum."
,"16":"Et reversus est Iudas et exercitus eius a persecutione eorum;"
,"17":"dixitque ad populum: ' Non concupiscatis spolia, quia bellum contra nos est,"
,"18":"et Gorgias et exercitus eius prope nos in monte, sed state nunc contra inimicos nostros et expugnate eos et post haec accipite spolia confidenter '."
,"19":"Et, adhuc loquente Iuda haec, apparuit pars quaedam prospiciens de monte."
,"20":"Et vidit quod in fugam conversi sunt sui, et succenderunt castra; fumus enim, qui videbatur, declarabat, quod factum est."
,"21":"Quibus illi conspectis, timuerunt valde; aspicientes vero et Iudae exercitum in campo paratum ad proelium"
,"22":"fugerunt omnes in terram alienigenarum."
,"23":"Et Iudas reversus est ad spolia castrorum; et acceperunt aurum multum et argentum et hyacinthum et purpuram marinam et opes magnas."
,"24":"Et conversi hymnum canebant et benedicebant in caelum: ' Quoniam bonum, quoniam in saeculum misericordia eius '."
,"25":"Et facta est salus magna in Israel in die illa."
,"26":"Quicumque autem alienigenarum evaserunt, venerunt et nuntiaverunt Lysiae universa, quae acciderant;"
,"27":"quibus ille auditis, consternatus est et animo deficiebat, quod non, qualia voluit, talia contigerant in Israel, et, qualia mandaverat ei rex, evenerant."
,"28":"Et sequenti anno congregavit virorum electorum sexaginta milia et equitum quinque milia, ut debellaret eos."
,"29":"Et venerunt in Idumaeam et castra posuerunt in Bethsuris; et occurrit illis Iudas cum decem milibus viris."
,"30":"Et vidit exercitum fortem et oravit et dixit: ' Benedictus es, Salvator Israel, qui contrivisti impetum potentis in manu servi tui David et tradidisti castra alienigenarum in manu Ionathae filii Saul et armigeri eius."
,"31":"Conclude exercitum istum in manu populi tui Israel, et confundantur in exercitu suo et equitibus suis."
,"32":"Da illis formidinem et tabefac audaciam virtutis eorum, et commoveantur contritione sua;"
,"33":"deice illos gladio diligentium te, et collaudent te omnes, qui noverunt nomen tuum, in hymnis '."
,"34":"Et commiserunt invicem proelium, et ceciderunt de exercitu Lysiae quinque milia virorum et prociderunt ex adverso eorum."
,"35":"Videns autem Lysias factam eversionem exercitus sui, Iudae vero audaciam et quemadmodum parati sunt aut vivere aut mori fortiter, abiit Antiochiam et colligebat externos, ut multo numero rursus venirent in Iudaeam."
,"36":"Dixit autem Iudas et fratres eius: ' Ecce contriti sunt inimici nostri; ascendamus mundare sancta et renovare '."
,"37":"Et congregatus est omnis exercitus, et ascenderunt in montem Sion."
,"38":"Et viderunt sanctificationem desertam et altare profanatum et portas exustas et in atriis virgulta nata, sicut in saltu vel in uno ex montibus, et pastophoria diruta."
,"39":"Et sciderunt vestimenta sua et planxerunt planctu magno et imposuerunt cinerem"
,"40":"et ceciderunt in faciem super terram et exclamaverunt tubis signorum et clamaverunt in caelum."
,"41":"Tunc ordinavit Iudas viros, ut pugnarent adversus eos, qui erant in arce, donec mundaret sancta."
,"42":"Et elegit sacerdotes sine macula voluntatem habentes in lege;"
,"43":"et mundaverunt sancta et tulerunt lapides contaminationis in locum immundum."
,"44":"Et cogitaverunt de altari holocaustorum, quod profanatum erat, quid de eo facerent."
,"45":"Et incidit illis consilium bonum, ut destruerent illud, ne umquam illis esset in opprobrium, quia contaminaverunt illud gentes; et demoliti sunt altare"
,"46":"et reposuerunt lapides in monte domus in loco apto, quoadusque veniret propheta, ut responderet de eis."
,"47":"Et acceperunt lapides integros secundum legem et aedificaverunt altare novum secundum illud, quod fuit prius."
,"48":"Et aedificaverunt sancta et, quae intra domum erant, et atria sanctificaverunt."
,"49":"Et fecerunt vasa sancta nova et intulerunt candelabrum et altare incensorum et mensam in templum."
,"50":"Et incenderunt super altare et accenderunt lucernas, quae super candelabrum erant et lucebant in templo,"
,"51":"et posuerunt super mensam panes et appenderunt vela et consummaverunt omnia opera, quae fecerant."
,"52":"Et ante lucem surrexerunt quinta et vicesima die mensis noni - hic est mensis Casleu - centesimi quadragesimi octavi anni"
,"53":"et obtulerunt sacrificium secundum legem super altare holocaustorum novum, quod fecerunt;"
,"54":"secundum tempus et secundum diem, in qua contaminaverunt illud gentes, in ipsa renovatum est in canticis et citharis et cinyris et cymbalis."
,"55":"Et cecidit omnis populus in faciem, et adoraverunt et benedixerunt in caelum eum, qui prosperavit eis;"
,"56":"et fecerunt dedicationem altaris diebus octo et obtulerunt holocausta cum laetitia et sacrificaverunt sacrificium salutaris et laudis"
,"57":"et ornaverunt faciem templi coronis aureis et scutulis et dedicaverunt portas et pastophoria et imposuerunt eis ianuas."
,"58":"Et facta est laetitia in populo magna valde, et aversum est opprobrium gentium."
,"59":"Et statuit Iudas et fratres eius et universa ecclesia Israel, ut agantur dies dedicationis altaris in temporibus suis ab anno in annum per dies octo, a quinta et vicesima die mensis Casleu, cum laetitia et gaudio."
,"60":"Et aedificaverunt in tempore illo montem Sion per circuitum muros altos et turres firmas, ne quando venirent gentes et conculcarent ea, sicut antea fecerunt."
,"61":"Et collocavit illic exercitum, ut servarent eum, et munivit eum ad custodiendam Bethsuram, ut haberet populus munitionem contra faciem Idumaeae."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et factum est, ut audierunt gen tes in circuitu quia aedificatum est altare, et dedicatum est sanctuarium sicut prius, iratae sunt valde"
,"2":"et cogitabant tollere genus Iacob, qui erant inter eos, et coeperunt occidere in populo et persequi."
,"3":"Et bellabat Iudas adversus filios Esau in Idumaea, in Acrabattane, quia circumsedebant Israel; et percussit eos plaga magna, compressit eos et cepit spolia eorum."
,"4":"Et recordatus est malitiam filiorum Bean, qui erant populo in laqueum et in scandalum insidiantes eis in viis."
,"5":"Et conclusi sunt ab eo in turribus, et applicuit ad eos et anathematizavit eos et incendit turres eius igne cum omnibus, qui intus erant."
,"6":"Et transivit ad filios Ammon et invenit manum fortem et populum copiosum et Timotheum ducem ipsorum."
,"7":"Et commisit cum eis proelia multa, et contriti sunt in conspectu eius, et percussit eos."
,"8":"Et cepit Iazer et filias eius et reversus est in Iudaeam."
,"9":"Et congregatae sunt gentes, quae sunt in Galaad, adversus Israel, qui erant in finibus eorum, ut tollerent eos; et fugerunt in Datheman munitionem"
,"10":"et miserunt litteras ad Iudam et fratres eius dicentes: ' Congregatae sunt adversum nos gentes per circuitum, ut nos auferant,"
,"11":"et parant venire et occupare munitionem, in quam confugimus, et Timotheus est dux exercitus eorum."
,"12":"Nunc ergo veni et eripe nos de manibus eorum, quia cecidit multitudo de nobis,"
,"13":"et omnes fratres nostri, qui erant in locis Tubin, interfecti sunt, et captivas duxerunt uxores eorum et natos et sarcinas et peremerunt illic fere mille viros '."
,"14":"Adhuc epistulae legebantur, et ecce alii nuntii venerunt de Galilaea, conscissis tunicis, nuntiantes secundum verba haec,"
,"15":"dicentes convenisse adversum se a Ptolemaida et Tyro et Sidone et omnem Galilaeam alienigenarum, ut nos consumant."
,"16":"Ut audivit autem Iudas et populus sermones istos, convenit ecclesia magna cogitare quid facerent fratribus suis, qui in tribulatione erant et expugnabantur ab eis."
,"17":"Dixitque Iudas Simoni fratri suo: ' Elige tibi viros et vade et libera fratres tuos, qui sunt in Galilaea; ego autem et frater meus Ionathas ibimus in Galaaditim '."
,"18":"Et reliquit Iosephum filium Zachariae et Azariam ducem populi cum residuo exercitu in Iudaea ad custodiam."
,"19":"Et praecepit illis dicens: ' Praeestote populo huic et nolite bellum committere adversum gentes, donec revertamur '."
,"20":"Et partiti sunt Simoni virorum tria milia, ut iret in Galilaeam, Iudae autem octo milia in Galaaditim."
,"21":"Et abiit Simon in Galilaeam et commisit proelia multa cum gentibus; et contritae sunt gentes a facie eius,"
,"22":"et persecutus est eos usque ad portam Ptolemaidis, et ceciderunt de gentibus fere tria milia virorum, et accepit spolia eorum."
,"23":"Et assumpsit eos, qui erant de Galilaea et in Arbattis, cum uxoribus et natis et omnibus, quae erant illis, et adduxit in Iudaeam cum laetitia magna."
,"24":"Et Iudas Maccabaeus et Ionathas frater eius transierunt Iordanem et abierunt viam trium dierum in deserto;"
,"25":"et occurrerunt Nabathaeis et obviaverunt eis pacifice et narraverunt eis omnia, quae acciderant fratribus eorum in Galaaditide,"
,"26":"et quia multi ex eis comprehensi sunt in Bosora et Bosor in Alimis, Chaspho, Maced et Carnain; hae omnes civitates munitae et magnae."
,"27":"Et in ceteris civitatibus Galaaditidis tenentur comprehensi; in crastinum constituerunt admovere ad munitiones et comprehendere et tollere omnes eos in una die."
,"28":"Et convertit Iudas et exercitus eius viam in desertum Bosora repente et occupavit civitatem et occidit omnem masculum in ore gladii et accepit omnia spolia eorum et succendit eam igne;"
,"29":"et profectus est inde nocte, et ibant usque ad munitionem."
,"30":"Et factum est diluculo, cum levassent oculos suos, ecce populus multus, cuius non erat numerus, portantes scalas et machinas, ut comprehenderent munitionem, et expugnabant eos."
,"31":"Et vidit Iudas quia coepit bellum, et clamor civitatis ascendit ad caelum sicut tuba et clamor magnus;"
,"32":"et dixit viris exercitus: ' Pugnate hodie pro fratribus nostris '."
,"33":"Et exiit tribus ordinibus post eos, et exclamaverunt tubis et clamaverunt in oratione."
,"34":"Et cognoverunt castra Timothei quia Maccabaeus est, et refugerunt a facie eius; et percussit eos plaga magna, et ceciderunt ex eis in die illa fere octo milia virorum."
,"35":"Et divertit Iudas in Maspha et expugnavit et cepit eam. Et occidit omnem masculinum eius et sumpsit spolia eius et succendit eam igne."
,"36":"Inde perrexit et cepit Chaspho, Maced et Bosor et reliquas civitates Galaaditidis."
,"37":"Post haec autem verba congregavit Timotheus exercitum alium et castra posuit contra Raphon trans torrentem."
,"38":"Et misit Iudas speculari exercitum, et renuntiaverunt ei dicentes: ' Convenerunt ad eum omnes gentes, quae in circuitu nostro sunt, exercitus multus nimis;"
,"39":"et Arabas conduxit in auxilium sibi, et castra posuerunt trans torrentem, parati ad te venire in proelium '. Et abiit Iudas obviam illis."
,"40":"Et ait Timotheus principibus exercitus sui: ' Cum appropinquaverit Iudas et exercitus eius ad torrentem aquae, si transierit ad nos prior, non poterimus sustinere eum, quia potens poterit adversum nos;"
,"41":"si vero timuerit transire et posuerit castra ultra flumen, transfretemus ad eos et poterimus adversus illum '."
,"42":"Ut autem appropinquavit Iudas ad torrentem aquae, statuit scribas populi secus torrentem et mandavit eis dicens: ' Neminem hominum reliqueritis, sed veniant omnes in proelium '."
,"43":"Et transfretavit ad illos prior, et omnis populus post eum. Et contritae sunt omnes gentes a facie eorum et proiecerunt arma sua et fugerunt ad fanum in Carnain."
,"44":"Et occupaverunt ipsam civitatem et fanum succenderunt igne cum omnibus, qui erant in ipso; et oppressa est Carnain et non potuit sustinere contra faciem Iudae."
,"45":"Et congregavit Iudas universum Israel, qui erant in Galaaditide, a minimo usque ad maximum et uxores eorum et natos et sarcinas, exercitum magnum valde, ut venirent in terram Iudae."
,"46":"Et venerunt usque Ephron. Et haec civitas magna in via, munita valde; non erat declinare ab ea dextera vel sinistra, sed per mediam iter erat."
,"47":"Et incluserunt se, qui erant in civitate, et obstruxerunt portas lapidibus. Et misit ad eos Iudas verbis pacificis"
,"48":"dicens: ' Transeamus per terram vestram, ut eamus in terram nostram, et nemo vobis nocebit; tantum pedibus transibimus '. Et nolebant eis aperire."
,"49":"Et praecepit Iudas praedicare in castris, ut applicarent se unusquisque in quo erat loco."
,"50":"Et applicuerunt se viri virtutis, et oppugnavit civitatem illam tota die et tota nocte; et tradita est civitas in manu eius."
,"51":"Et peremit omnem masculinum in ore gladii et eradicavit eam et accepit spolia eius et transivit per civitatem super interfectos."
,"52":"Et transgressi sunt Iordanem in campum magnum contra faciem Bethsan."
,"53":"Et erat Iudas congregans extremos et exhortabatur populum per totam viam, donec veniret in terram Iudae."
,"54":"Et ascenderunt in montem Sion cum laetitia et gaudio et obtulerunt holocausta, quod nemo ex eis cecidisset, donec reverterentur in pace."
,"55":"Et in diebus, quibus erat Iudas et Ionathas in terra Galaad, et Simon frater eius in Galilaea contra faciem Ptolemaidis,"
,"56":"audivit Iosephus Zachariae filius et Azarias princeps virtutis res bene gestas et proelia, quae fecerunt,"
,"57":"et dixerunt: ' Faciamus et ipsi nobis nomen et eamus pugnare adversus gentes, quae in circuitu nostro sunt '."
,"58":"Et nuntiaverunt his, qui erant de exercitu suo, et abierunt ad Iamniam."
,"59":"Et exivit Gorgias de civitate et viri eius obviam illis in pugnam;"
,"60":"et fugati sunt Iosephus et Azarias et impulsi sunt usque in fines Iudaeae, et ceciderunt illo die de populo Israel ad duo milia viri; et facta est fuga magna in populo,"
,"61":"quia non audie runt Iudam et fratres eius existimantes fortiter se facturos."
,"62":"Ipsi autem non erant de semine virorum illorum, per quorum manum salus data est Israel."
,"63":"Et vir Iudas et fratres eius magnificati sunt valde in conspectu omnis Israel et gentium omnium, ubi audiebatur nomen eorum;"
,"64":"et conveniebant ad eos fausta acclamantes."
,"65":"Et exivit Iudas et fratres eius et expugnabant filios Esau in terra, quae ad austrum est. Et percussit Hebron et filias eius et destruxit munitiones eius et turres eius succendit in circuitu."
,"66":"Et movit castra, ut iret in terram alienigenarum, et perambulabat Maresam."
,"67":"In die illa ceciderunt sacerdotes in bello, dum volunt fortiter facere, dum sine consilio exeunt in proelium."
,"68":"Et declinavit Iudas in Azotum terram alienigenarum et diruit aras eorum et sculptilia deorum ipsorum succendit igne et expoliavit exuvias civitatum. Et reversus est in terram Iudae."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et rex Antiochus perambulabat superiores regiones et audivit esse Elymaida in Perside civitatem gloriosam divitiis argento et auro"
,"2":"templumque in ea locuples valde et illic velamina aurea et loricae et scuta, quae reliquit ibi Alexander Philippi rex Macedo, qui regnavit primus in Graecia."
,"3":"Et venit et quaerebat capere civitatem et depraedari eam et non potuit, quoniam innotuit sermo his, qui erant in civitate."
,"4":"Et restiterunt ei in proelium. Et fugit inde et abiit cum tristitia magna, ut reverteretur in Babyloniam."
,"5":"Et venit, qui nuntiaret ei in Perside quia fugata sunt castra, quae iverant in terram Iudae,"
,"6":"et quia abiit Lysias cum virtute forti in primis et fugatus est a facie eorum, et invaluerunt armis et viribus et spoliis multis, quae ceperunt de castris quae exciderunt,"
,"7":"et quia diruerunt abominationem, quam aedificaverat super altare, quod erat in Ierusalem, et sanctificationem sicut prius circumdederunt muris excelsis et Bethsuram civitatem eius."
,"8":"Et factum est, ut audivit rex sermones istos, expavit et commotus est valde et decidit in lectum et incidit in languorem prae tristitia, quia non factum est ei, sicut cogitabat."
,"9":"Et erat illic per dies multos, quia renovata est in eo tristitia magna, et arbitratus est se mori."
,"10":"Et vocavit omnes amicos suos et dixit illis: ' Recessit somnus ab oculis meis, et concidi corde prae sollicitudine"
,"11":"et dixi in corde meo: Quousque tribulationis deveni et tempestatis magnae, in qua nunc sum? Quia iucundus eram et dilectus in potestate mea!"
,"12":"Nunc vero reminiscor malorum, quae feci in Ierusalem, unde et abstuli omnia vasa aurea et argentea, quae erant in ea, et misi auferre habitantes Iudam sine causa."
,"13":"Cognovi quia propterea invenerunt me mala ista; et ecce pereo tristitia magna in terra aliena '."
,"14":"Et vocavit Philippum, unum de amicis suis, et praeposuit eum super universum regnum suum;"
,"15":"et dedit ei diadema et stolam suam et anulum, ut adduceret Antiochum filium suum et nutriret eum, ut regnaret."
,"16":"Et mortuus est illic Antiochus rex anno centesimo quadragesimo nono."
,"17":"Et cognovit Lysias quoniam mortuus est rex, et constituit regnare Antiochum filium eius pro eo, quem nutrivit adulescentiorem; et vocavit nomen eius Eupatorem."
,"18":"Et hi, qui erant in arce, concluserant Israel in circuitu sanctorum et quaerebant eis mala semper et firmamentum gentium."
,"19":"Et cogitavit Iudas disperdere eos et convocavit universum populum, ut obsiderent eos."
,"20":"Et convenerunt simul et obsederunt eos anno centesimo quinquagesimo et fecerunt ballistas et machinas."
,"21":"Et exierunt quidam ex eis, qui obsidebantur, et adiunxerunt se illis aliqui impii ex Israel"
,"22":"et abierunt ad regem et dixerunt: ' Quousque non facis iudicium et vindicabis fratres nostros?"
,"23":"Nos decrevimus servire patri tuo et ambulare in praeceptis eius et obsequi edictis eius;"
,"24":"et filii populi nostri propter hoc obsederunt arcem et alienabant se a nobis, et, quicumque inveniebantur ex nobis, interficiebantur, et hereditates nostrae diripiebantur."
,"25":"Et non ad nos tantum extenderunt manum sed et in omnes fines suos;"
,"26":"et ecce applicuerunt hodie ad arcem in Ierusalem occupare eam et sancta et Bethsuram munierunt."
,"27":"Et, nisi praeveneris eos velocius, maiora quam haec facient, et non poteris continere eos '."
,"28":"Et iratus est rex, ut audivit, et convocavit omnes amicos suos et principes exercitus sui et eos, qui super vehicula erant;"
,"29":"sed et de regnis aliis et de insulis maritimis venerunt ad eum exercitus conducticii."
,"30":"Et erat numerus exercitus eius centum milia peditum et viginti milia equitum, et elephanti triginta duo docti ad proelium."
,"31":"Et venerunt per Idumaeam et applicuerunt ad Bethsuram. Et pugnaverunt dies multos et fecerunt machinas et exierunt et succenderunt eas igne et pugnaverunt viriliter."
,"32":"Et recessit Iudas ab arce et movit castra ad Bethzacharam contra castra regis."
,"33":"Et surrexit rex ante lucem et excitavit exercitum in impetu suo contra viam Bethzacharam, et comparaverunt se exercitus in proelium et tubis cecinerunt"
,"34":"et elephantis ostenderunt sanguinem uvae et mori ad acuendos eos in proelium."
,"35":"Et diviserunt bestias per legiones, et astiterunt singulis elephantis mille viri in loricis concatenatis, et galeae aereae in capitibus eorum, et quingenti equites ordinati unicuique bestiae electi."
,"36":"Hi ante tempus, ubicumque erat bestia, ibi erant et, quocumque ibat, ibant; non discedebant ab ea."
,"37":"Et turres ligneae super eos firmae, protectae super singulas bestias, praecinctae super eas machinis, et super singulas viri virtutis quattuor, qui pugnabant desuper, et Indus eius."
,"38":"Et residuos equites hinc et inde statuit in duas partes exercitus excitaturos et protecturos in legionibus."
,"39":"Et, ut refulsit sol in clipeos aureos et aereos, resplenduerunt montes ab eis et resplenduerunt sicut lampades ignis."
,"40":"Et distincta est pars exercitus regis super montes excelsos, et quidam per loca humilia; et ibant caute et ordinate."
,"41":"Et commovebantur omnes audientes vocem multitudinis et incessum turbae et collisionem armorum; erat enim exercitus magnus valde et fortis."
,"42":"Et appropiavit Iudas et exercitus eius in proelium, et ceciderunt de exercitu regis sescenti viri."
,"43":"Et vidit Eleazar Abaran unam de bestiis loricatam loricis regis, et erat eminens super ceteras bestias, et visum est ei quod in ea esset rex;"
,"44":"et dedit se, ut liberaret populum suum et acquireret sibi nomen aeternum."
,"45":"Et cucurrit ad eam audacter, in medio legionis interficiens a dextris et a sinistris, et findebantur ab eo huc atque illuc;"
,"46":"et ivit sub elephantum et supposuit se ei et occidit eum; et cecidit in terram super ipsum, et mortuus est illic."
,"47":"Et videntes virtutem regni et impetum exercituum diverterunt se ab eis."
,"48":"Qui autem erant de castris regis, ascenderunt obviam illis in Ierusalem, et applicuit rex ad Iudaeam et montem Sion."
,"49":"Et fecit pacem cum his, qui erant in Bethsura; et exierunt de civitate, quia non erant eis ibi alimenta, eo quod conclusi essent in ea, quia sabbatum erat terrae."
,"50":"Et comprehendit rex Bethsuram et constituit illic custodiam servare eam."
,"51":"Et applicuit castra ad locum sanctificationis dies multos; et statuit illic ballistas et machinas et ignis iacula et tormenta ad lapides iactandos et scorpios ad mittendas sagittas et fundibula."
,"52":"Fecerunt autem et ipsi machinas adversus machinas eorum et pugnaverunt dies multos;"
,"53":"escae autem non erant in horreis, eo quod septimus annus esset, et, qui evaserant in Iudaeam de gentibus, consumpserant reliquias repositionis."
,"54":"Et remanserunt in sanctis viri pauci, quoniam obtinuerat eos fames, et dispersi sunt unusquisque in locum suum."
,"55":"Et audivit Lysias quod Philippus, quem constituerat rex Antiochus, cum adhuc viveret, ut nutriret Antiochum filium suum ut regnaret,"
,"56":"reversus esset a Perside et Media, et exercitus, qui abierat cum ipso, et quia quaerebat suscipere regni negotia."
,"57":"Festinavit et significavit ire dixitque ad regem et duces exercitus et viros: ' Deficimus cotidie, et esca nobis modica est, et locus, quem obsidemus, est munitus, et incumbunt nobis negotia regni."
,"58":"Nunc itaque demus dextras hominibus istis et faciamus cum illis pacem et cum omni gente eorum"
,"59":"et constituamus illis, ut ambulent in legitimis suis sicut prius; propter legitima enim ipsorum, quae dispersimus, irati sunt et fecerunt omnia haec '."
,"60":"Et placuit sermo in conspectu regis et principum, et misit ad eos pacem facere, et receperunt illam."
,"61":"Et iuravit illis rex et principes. His condicionibus exierunt de munitione."
,"62":"Et intravit rex in montem Sion et vidit munitionem loci et rupit iuramentum, quod iuravit, et mandavit destruere murum in gyro."
,"63":"Et discessit festinanter et reversus est Antiochiam; et invenit Philippum dominantem civitati et pugnavit adversus eum et occupavit civitatem per vim."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Anno centesimo quinquagesimo primo exiit Demetrius Seleuci filius a Roma; et ascendit cum paucis viris in civitatem maritimam et regnavit illic."
,"2":"Et factum est, ut ingressus est domum regni patrum suorum, comprehendit exercitus Antiochum et Lysiam, ut adduceret eos ad eum."
,"3":"Et res ei innotuit, et ait: ' Nolite mihi ostendere facies eorum '."
,"4":"Et occidit eos exercitus, et sedit Demetrius super sedem regni sui."
,"5":"Et venerunt ad eum viri iniqui et impii ex Israel, et Alcimus dux erat eorum, qui volebat fieri sacerdos;"
,"6":"et accusaverunt populum apud regem dicentes: ' Perdidit Iudas et fratres eius omnes amicos tuos et nos dispersit de terra nostra;"
,"7":"nunc ergo mitte virum, cui credis, ut eat et videat exterminium omne, quod fecit nobis et regioni regis, et puniat eos et omnes adiutores eorum '."
,"8":"Et elegit rex ex amicis suis Bacchidem, qui dominabatur trans flumen, magnum in regno et fidelem regi. Et misit eum"
,"9":"et Alcimum impium et constituit ei sacerdotium et mandavit ei facere ultionem in filios Israel."
,"10":"Et surrexerunt et venerunt cum exercitu magno in terram Iudae; et misit nuntios ad Iudam et ad fratres eius verbis pacificis in dolo."
,"11":"Et non intenderunt sermonibus eorum; viderunt enim quia venerunt cum exercitu magno."
,"12":"Et convenerunt ad Alcimum et Bacchidem congregatio scribarum requirere iusta;"
,"13":"et primi Asidaei erant in filiis Israel et exquirebant ab eis pacem."
,"14":"Dixerunt enim: ' Homo sacerdos de semine Aaron venit et non decipiet nos '."
,"15":"Et locutus est cum eis verba pacifica et iuravit illis dicens: ' Non inferemus vobis malum neque amicis vestris '."
,"16":"Et crediderunt ei. Et comprehendit ex eis sexaginta viros et occidit eos in una die, secundum verbum quod scripsit:"
,"17":"' Carnes sanctorum tuorum et sanguinem ipsorum effuderunt in circuitu Ierusalem, et non erat qui sepeliret '."
,"18":"Et incubuit timor eorum et tremor in omnem populum, quia dixerunt: ' Non est in eis veritas et iudicium; transgressi sunt enim constitutum et iusiurandum, quod iuraverunt '."
,"19":"Et movit Bacchides ab Ierusalem et applicuit in Bethzaith; et misit et comprehendit multos ex eis, qui ad se refugerant, et quosdam de populo mactavit in puteum magnum."
,"20":"Et commisit regionem Alcimo et reliquit cum eo auxilium in adiutorium ipsi; et abiit Bacchides ad regem."
,"21":"Et contendebat Alcimus pro principatu sacerdotii sui;"
,"22":"et convenerunt ad eum omnes, qui perturbabant populum suum, et obtinuerunt terram Iudae et fecerunt plagam magnam in Israel."
,"23":"Et vidit Iudas omnem malitiam, quam fecit Alcimus et, qui cum eo erant, filiis Israel multo plus quam gentes;"
,"24":"et exiit in omnes fines Iudaeae in circuitu et fecit vindictam in viros desertores, et cessaverunt ultra exire in regionem."
,"25":"Ut vidit autem Alcimus quod praevaluit Iudas et, qui cum eo erant, et cognovit quia non potest sustinere eos; et regressus est ad regem et accusavit eos criminibus."
,"26":"Et misit rex Nicanorem unum ex principibus suis nobilioribus, qui oderat et inimicitias exercebat contra Israel; et mandavit ei evertere populum."
,"27":"Et venit Nicanor in Ierusalem cum exercitu magno et misit ad Iudam et ad fratres eius verbis pacificis cum dolo"
,"28":"dicens: ' Non sit pugna inter me et vos; veniam cum viris paucis, ut videam facies vestras cum pace '."
,"29":"Et venit ad Iudam, et salutaverunt se invicem pacifice, et hostes parati erant rapere Iudam."
,"30":"Et innotuit sermo Iudae quoniam cum dolo venerat ad eum, et conterritus est ab eo et amplius noluit videre faciem eius."
,"31":"Et cognovit Nicanor quoniam denudatum est consilium eius et exivit obviam Iudae in pugnam iuxta Chapharsalama;"
,"32":"et ceciderunt de Nicanoris exercitu fere quingenti viri, et fugerunt in civitatem David."
,"33":"Et post haec verba ascendit Nicanor in montem Sion; et exierunt quidam ex sacerdotibus de sanctis et quidam ex senioribus populi salutare eum pacifice et demonstrare ei holocaustum, quod offerebatur pro rege."
,"34":"Et irridens sprevit eos et polluit eos et locutus est superbe"
,"35":"et iuravit cum ira dicens: ' Nisi traditus fuerit Iudas et exercitus eius in manus meas continuo, et erit, si regressus fuero in pace, succendam domum istam '. Et exiit cum ira magna."
,"36":"Et intraverunt sacerdotes et steterunt ante faciem altaris et templi et flentes dixerunt:"
,"37":"' Tu elegisti domum istam ad invocandum nomen tuum super eam, ut esset domus orationis et obsecrationis populo tuo;"
,"38":"fac vindictam in homine isto et exercitu eius, et cadant in gladio. Memento blasphemias eorum et ne dederis eis mansionem '."
,"39":"Et exiit Nicanor ab Ierusalem et applicuit ad Bethoron; et occurrit illi exercitus Syriae."
,"40":"Et Iudas applicuit in Hadasa cum tribus milibus viris. Et oravit Iudas et dixit:"
,"41":"' Qui missi erant a rege, cum male locuti sunt; exiit angelus et percussit in eis centum octoginta quinque milia."
,"42":"Sic contere exercitum istum in conspectu nostro hodie, et sciant ceteri quia male locutus est super sancta tua, et iudica illum secundum malitiam illius '."
,"43":"Et commiserunt exercitus proelium tertia decima die mensis Adar; et contrita sunt castra Nicanoris, et cecidit ipse primus in proelio."
,"44":"Ut autem vidit exercitus eius quia cecidit Nicanor, proiecerunt arma et fugerunt."
,"45":"Et persecuti sunt eos viam unius diei ab Hadasa usquequo veniatur in Gazara et tubis cecinerunt post eos cum significationibus."
,"46":"Et exierunt de omnibus castellis Iudaeae in circuitu et ventilabant eos et conversi sunt ad eos; et ceciderunt omnes gladio, et non est relictus ex eis nec unus."
,"47":"Et acceperunt spolia eorum et praedam et caput Nicanoris amputaverunt et dexteram eius, quam extenderat superbe, et attulerunt et suspenderunt contra Ierusalem."
,"48":"Et laetatus est populus valde; et egerunt diem illam in laetitia magna"
,"49":"et constituerunt agere omnibus annis diem istam tertia decima die Adar."
,"50":"Et siluit terra Iudae dies paucos."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Et audivit Iudas nomen Roma norum quia sunt potentes viri bus et consentiunt omnibus, quae postulantur ab eis, et, quicumque accesserint ad eos, statuerunt cum eis amicitiam,"
,"2":"et quia sunt potentes viribus. Et narraverunt proelia eorum et virtutes bonas, quas fecerunt in Galatia, quia obtinuerunt eos et duxerunt eos sub tributum,"
,"3":"et quanta fecerunt in regione Hispaniae, quod in potestatem redegerunt metalla argenti et auri, quae illic sunt;"
,"4":"et possederunt omnem locum consilio suo et patientia - et locus erat longe distans ab eis - et reges, qui supervenerant eis ab extremis terrae, donec contriverunt eos et percusserunt eos plaga magna; ceteri autem dant eis tributum omnibus annis;"
,"5":"et Philippum et Persea Citiorum regem et, quotquot adversum eos arma tulerant, contriverunt in bello et obtinuerunt eos;"
,"6":"et Antiochum magnum regem Asiae, qui eis pugnam intulerat habens centum viginti elephantos et equitatum et currus et exercitum magnum valde, contritum ab eis,"
,"7":"et ceperunt eum vivum et statuerunt, ut eis daret ipse et, qui regnarent post ipsum, tributum magnum et daret obsides et constitutum;"
,"8":"et regionem Indorum et Mediam et Lydiam et de optimis regionibus eorum et acceptas eas ab illo dederunt Eumeni regi;"
,"9":"et quia, qui erant de Hellade, voluerunt ire et tollere eos, et innotuit sermo his,"
,"10":"et miserunt ad eos ducem unum et pugnaverunt contra illos et ceciderunt ex eis multi et captivas duxerunt uxores eorum et filios et diripuerunt eos et terram eorum possederunt et destruxerunt munitiones eorum et in servitutem illos redegerunt usque in hunc diem;"
,"11":"et residua regna et insulas, quae aliquando restiterant illis, exterminaverunt et in potestatem redegerunt;"
,"12":"cum amicis autem suis et, qui in ipsis requiem habebant, conservaverunt amicitiam; et obtinuerunt reges, qui prope et qui longe erant; et, quicumque audiebant nomen eorum, timebant eos;"
,"13":"quibus vero vellent auxilio esse et regnare, regnabant; quos autem vellent, amovebant; et exaltati sunt valde."
,"14":"Et in omnibus istis nemo portabat diadema nec induebatur purpura, ut magnificaretur in ea;"
,"15":"et curiam fecerunt sibi, et cotidie consulebant trecenti et viginti consulentes semper de multitudine, ut quiete agerent;"
,"16":"et committunt uni homini regnare eis per singulos annos et dominari universae terrae suae, et omnes oboediunt uni, et non est invidia neque zelus inter eos."
,"17":"Et elegit Iudas Eupolemum filium Ioannis filii Accos et Iasonem filium Eleazari et misit eos Romam constituere cum illis amicitiam et societatem"
,"18":"et ut auferrent ab eis iugum, quia viderunt quod regnum Graecorum in servitutem premeret Israel."
,"19":"Et abierunt Romam - et via multa valde - et introierunt curiam et responderunt et dixerunt:"
,"20":"' Iudas Maccabaeus et fratres eius et populus Iudaeorum miserunt nos ad vos statuere vobiscum societatem et pacem et conscribere nos socios et amicos vestros '."
,"21":"Et placuit sermo in conspectu eorum."
,"22":"Et hoc est rescriptum epistulae, quam rescripserunt in tabulis aereis et miserunt in Ierusalem, ut esset apud eos ibi memoriale pacis et societatis:"
,"23":"' Bene sit Romanis et genti Iudaeorum in mari et in terra in aeternum, gladiusque et hostis procul sit ab eis."
,"24":"Quod si institerit bellum Romanis prius aut omnibus sociis eorum in omni dominatione eorum,"
,"25":"auxilium feret gens Iudaeorum, prout tempus dictaverit illis, corde pleno"
,"26":"et proeliantibus non dabunt neque subministrabunt triticum, arma, argentum, naves, sicut placuit Romae; et custodient mandata eorum, nihil accipientes."
,"27":"Similiter autem et si genti Iudaeorum prius acciderit bellum, adiuvabunt Romani ex animo, prout eis tempus permiserit;"
,"28":"et adiuvantibus non dabitur triticum, arma, argentum, naves, sicut placuit Romae; et custodient mandata haec absque dolo."
,"29":"Secundum haec verba ita constituerunt Romani populo Iudaeorum."
,"30":"Quod si post haec verba cogitaverint hi aut illi addere aut demere, facient ex proposito suo; et, quaecumque addiderint vel dempserint, rata erunt."
,"31":"Et de malis, quae Demetrius rex fecit in eos, scripsimus ei dicentes: 'Quare gravasti iugum tuum super amicos nostros, socios Iudaeos?"
,"32":"Si ergo iterum adierint nos adversum te, faciemus illis iudicium et pugnabimus tecum mari terraque' '."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et audivit Demetrius quia ce cidit Nicanor et exercitus eius in proelio et apposuit Bacchidem et Alcimum rursum mittere in terram Iudaeae et dextrum cornu cum illis."
,"2":"Et abierunt viam, quae ducit in Galgala, et castra posuerunt in Masaloth, quae est in Arbelis, et occupaverunt eam et peremerunt animas hominum multas."
,"3":"Et mense primo anni centesimi et quinquagesimi secundi applicuerunt ad Ierusalem;"
,"4":"et surrexerunt et abierunt in Bereth in viginti milibus virorum et duobus milibus equitum."
,"5":"Et Iudas posuerat castra in Elasa, et tria milia viri electi cum eo;"
,"6":"et viderunt multitudinem exercitus quia multi sunt et timuerunt valde; et multi subtraxerunt se de castris, et non remanserunt ex eis nisi octingenti viri."
,"7":"Et vidit Iudas quod defluxit exercitus suus, et bellum perurgebat eum; et confractus est corde, quia non habebat tempus congregandi eos,"
,"8":"et dissolutus est. Et dixit his, qui residui erant: ' Surgamus et ascendamus ad adversarios nostros, si poterimus pugnare adversus eos '."
,"9":"Et avertebant eum dicentes: ' Non poterimus, sed liberemus animas nostras modo et revertamur nos et fratres nostri et pugnabimus adversus eos; nos autem pauci sumus '."
,"10":"Et ait Iudas: ' Absit istam rem facere, ut fugiamus ab eis; et si appropiavit tempus nostrum, et moriamur in virtute propter fratres nostros et non inferamus crimen gloriae nostrae '."
,"11":"Et movit exercitus de castris, et steterunt illis obviam; et divisi sunt equites in duas partes, et fundibularii et sagittarii praeibant exercitum, et primi certaminis omnes potentes."
,"12":"Bacchides autem erat in dextro cornu; et proximavit legio ex duabus partibus, et clamabant tubis; et clamaverunt hi, qui erant ex parte Iudae, etiam ipsi in tubis;"
,"13":"et commota est terra a voce exercituum; et commissum est proelium a mane usque ad vesperam."
,"14":"Et vidit Iudas quod Bacchides et firmior pars exercitus erat in dextris, et convenerunt cum ipso omnes constantes corde;"
,"15":"et contrita est dextera pars ab eis, et persecutus est eos usque ad montem Azoti."
,"16":"Et, qui in sinistro cornu erant, viderunt quod contritum est dextrum cornu, et secuti sunt post Iudam et eos, qui cum ipso erant, a tergo."
,"17":"Et ingravatum est proelium, et ceciderunt vulnerati multi ex his et ex illis;"
,"18":"et Iudas cecidit, et ceteri fugerunt."
,"19":"Et Ionathas et Simon tulerunt Iudam fratrem suum et sepelierunt eum in sepulcro patrum suorum in Modin."
,"20":"Et fleverunt eum et planxerunt omnis populus Israel planctu magno et lugebant dies multos"
,"21":"et dixerunt: ' Quomodo cecidit potens, qui salvum faciebat populum Israel! '."
,"22":"Et cetera verborum Iudae et bellorum et virtutum, quas fecit, et magnitudinis eius non sunt descripta; multa enim erant valde."
,"23":"Et factum est, post obitum Iudae emerserunt iniqui in omnibus finibus Israel, et exorti sunt omnes, qui operabantur iniquitatem."
,"24":"In diebus illis facta est fames magna valde, et tradidit se regio cum ipsis."
,"25":"Et elegit Bacchides viros impios et constituit eos dominos regionis;"
,"26":"et exquirebant et perscrutabantur amicos Iudae et adducebant eos ad Bacchidem, et vindicabat in illos et illudebat."
,"27":"Et facta est tribulatio magna in Israel, qualis non fuit ex die, qua non est visus propheta illis."
,"28":"Et congregati sunt omnes amici Iudae et dixerunt Ionathae:"
,"29":"' Ex quo frater tuus Iudas defunctus est, et vir similis ei non est, qui exeat contra inimicos et Bacchidem et eos, qui inimici sunt gentis nostrae;"
,"30":"nunc itaque te hodie elegimus esse pro eo nobis in principem et ducem ad bellandum bellum nostrum '."
,"31":"Et suscepit Ionathas tempore illo principatum et surrexit loco Iudae fratris sui."
,"32":"Et cognovit Bacchides et quaerebat eum occidere;"
,"33":"et cognovit Ionathas et Simon frater eius et omnes, qui cum eo erant, et fugerunt in desertum Thecue et consederunt ad aquam lacus Asphar."
,"34":"Et cognovit Bacchides die sabbatorum et venit ipse et omnis exercitus eius trans Iordanem."
,"35":"Et Ionathas misit fratrem suum ducem populi et rogavit Nabathaeos amicos suos, ut commodarent illis apparatum suum, qui erat copiosus."
,"36":"Et exierunt filii Iambri ex Medaba et comprehenderunt Ioannem et omnia, quae habebat, et abierunt habentes ea."
,"37":"Post haec verba renuntiatum est Ionathae et Simoni fratri eius quia filii Iambri faciunt nuptias magnas et ducunt sponsam ex Nadabath filiam unius de magnis principibus Chanaan cum ambitione magna."
,"38":"Et recordati sunt sanguinis Ioannis fratris sui et ascenderunt et absconderunt se sub tegumento montis;"
,"39":"et elevaverunt oculos suos et viderunt: et ecce tumultus et apparatus multus, et sponsus processit et amici eius et fratres eius obviam illis cum tympanis et musicis et armis multis."
,"40":"Et surrexerunt ad eos ex insidiis et occiderunt eos, et ceciderunt vulnerati multi; et residui fugerunt in montes, et acceperunt omnia spolia eorum."
,"41":"Et conversae sunt nuptiae in luctum, et vox musicorum ipsorum in lamentum."
,"42":"Et vindicaverunt vindictam sanguinis fratris sui et reversi sunt ad ripam Iordanis."
,"43":"Et audivit Bacchides et venit die sabbatorum usque ad oram Iordanis in virtute magna."
,"44":"Et dixit ad suos Ionathas: ' Surgamus et pugnemus pro animabus nostris; non est enim hodie sicut heri et nudiustertius:"
,"45":"ecce enim bellum ex adverso nostrum, aqua vero Iordanis hinc et inde, et paludes et saltus, et non est locus divertendi."
,"46":"Nunc ergo clamate in caelum, ut liberemini de manu inimicorum vestrorum '. Et commissum est bellum."
,"47":"Et extendit Ionathas manum suam percutere Bacchidem, et divertit ab eo retro."
,"48":"Et dissiliit Ionathas et, qui cum eo erant, in Iordanem et transnataverunt in ulteriora; et non transierunt ad eos Iordanem."
,"49":"Et ceciderunt de parte Bacchidis die illa mille viri. Et reversi sunt in Ierusalem."
,"50":"Et aedificaverunt civitates munitas in Iudaea: munitionem, quae erat in Iericho, et Emmaus et Bethoron et Bethel et Thamnata et Pharathon et Tephon muris excelsis et portis et seris;"
,"51":"et posuit custodiam in eis, ut inimicitias exercerent in Israel."
,"52":"Et munivit civitatem Bethsuram et Gazaram et arcem et posuit in eis auxilia et apparatum escarum."
,"53":"Et accepit filios principum regionis obsides et posuit eos in arce in Ierusalem in custodia."
,"54":"Et anno centesimo quinquagesimo tertio, mense secundo, praecepit Alcimus destrui murum atrii sanctorum interioris et destruxit opera prophetarum. Et coepit destruere."
,"55":"In tempore illo percussus est Alcimus, et impedita sunt opera illius; et occlusum est os eius, et dissolutus est nec ultra poterat loqui verbum et mandare de domo sua;"
,"56":"et mortuus est Alcimus in tempore illo cum tormento magno."
,"57":"Et vidit Bacchides quoniam mortuus est Alcimus et reversus est ad regem; et siluit terra Iudae annis duobus."
,"58":"Et cogitaverunt omnes iniqui dicentes: ' Ecce Ionathas et, qui cum eo sunt, in silentio habitant confidentes; nunc ergo adducamus Bacchidem, et comprehendet eos omnes una nocte '."
,"59":"Et abierunt et consilium ei dederunt."
,"60":"Et surrexit, ut veniret cum exercitu multo, et misit occulte epistulas sociis suis, qui erant in Iudaea, ut comprehenderent Ionathan et eos, qui cum eo erant; et non potuerunt, quia innotuit eis consilium eorum."
,"61":"Et apprehenderunt de viris regionis, qui principes erant malitiae, quinquaginta viros et occiderunt eos."
,"62":"Et secessit Ionathas et Simon et, qui cum eo erant, in Bethbasi, quae est in deserto; et exstruxit diruta eius, et firmaverunt eam."
,"63":"Et cognovit Bacchides et congregavit universam multitudinem suam et his, qui de Iudaea erant, denuntiavit;"
,"64":"et venit et castra posuit ad Bethbasi et oppugnavit eam dies multos et fecit machinas."
,"65":"Et reliquit Ionathas Simonem fratrem suum in civitate et exiit in regionem et venit cum numero;"
,"66":"et percussit Odomera et fratres eius et filios Phasiron in tabernaculo ipsorum et coepit caedere et crescere in virtutibus."
,"67":"Simon vero et, qui cum ipso erant, exierunt de civitate et succenderunt machinas"
,"68":"et pugnaverunt contra Bacchidem, et contritus est ab eis, et afflixerunt eum valde, quoniam consilium eius et adventus eius erat inanis."
,"69":"Et iratus est animo contra viros iniquos, qui ei consilium dederant, ut veniret in regionem, et multos ex eis occiderunt; et cogitaverunt abire in regionem eius."
,"70":"Et cognovit Ionathas et misit ad eum legatos componere pacem cum ipso et reddere ei captivitatem."
,"71":"Et accepit et fecit secundum verba eius et iuravit se nihil facturum ei mali omnibus diebus vitae eius;"
,"72":"et reddidit ei captivitatem, quam prius erat praedatus de terra Iudae, et conversus abiit in terram suam et non apposuit amplius venire in fines eius."
,"73":"Et cessavit gladius ex Israel, et habitavit Ionathas in Machmas; et coepit Ionathas ibi iudicare populum et exterminabat impios ex Israel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Et anno centesimo sexage simo ascendit Alexander An tiochi filius, Epiphanes, et occupavit Ptolemaidam; et receperunt eum, et regnavit illic."
,"2":"Et audivit Demetrius rex et congregavit exercitum copiosum valde et exivit obviam illi in proelium."
,"3":"Et misit Demetrius epistulam ad Ionathan verbis pacificis, ut magnificaret eum."
,"4":"Dixit enim: ' Anticipemus facere pacem cum eo, priusquam faciat cum Alexandro adversum nos;"
,"5":"recordabitur enim omnium malorum, quae consummavimus in eum et in fratrem eius et in gentem eius '."
,"6":"Et dedit ei potestatem congregare exercitum et fabrificare arma et esse ipsum socium eius; et obsides, qui erant in arce, dixit tradi ei."
,"7":"Et venit Ionathas in Ierusalem et legit epistulas in auditu omnis populi et eorum, qui in arce erant;"
,"8":"et timuerunt timore magno, cum audirent quoniam dedit ei rex potestatem congregandi exercitum."
,"9":"Et tradiderunt, qui erant in arce, Ionathae obsides, et reddidit eos parentibus ipsorum."
,"10":"Et habitavit Ionathas in Ierusalem et coepit aedificare et innovare civitatem;"
,"11":"et dixit facientibus opera, ut exstruerent muros et montem Sion in circuitu lapidibus quadratis ad munitionem: et ita fecerunt."
,"12":"Et fugerunt alienigenae, qui erant in munitionibus, quas Bacchides aedificaverat,"
,"13":"et reliquit unusquisque locum suum et abiit in terram suam;"
,"14":"tantum in Bethsura remanserunt aliqui ex his, qui reliquerant legem et praecepta; erat enim ad refugium."
,"15":"Et audivit Alexander rex promissa, quae misit Demetrius Ionathae, et narraverunt ei proelia et virtutes, quas ipse fecit et fratres eius, et labores, quos habuerunt."
,"16":"Et ait: ' Numquid inveniemus aliquem virum talem? Et nunc faciemus eum amicum et socium nostrum '."
,"17":"Et scripsit epistulam et misit ei secundum haec verba dicens:"
,"18":"' Rex Alexander fratri Ionathae salutem."
,"19":"Audivimus de te quod vir potens es viribus et aptus es, ut sis amicus noster;"
,"20":"et nunc constituimus te hodie summum sacerdotem gentis tuae, et ut amicus voceris regis - et misit ei purpuram et coronam auream - et, quae nostra sunt, sentias nobiscum et conserves amicitias ad nos '."
,"21":"Et induit se Ionathas stola sancta septimo mense, anno centesimo sexagesimo, in die sollemni Scenopegiae; et congregavit exercitum et fecit arma copiosa."
,"22":"Et audivit Demetrius verba ista et contristatus est nimis et ait:"
,"23":"' Quid hoc fecimus quod praeoccupavit nos Alexander apprehendere amicitiam Iudaeorum ad firmamentum?"
,"24":"Scribam et ego illis verba deprecatoria et dignitates et dona, ut sint mecum in adiutorium '."
,"25":"Et misit eis secundum haec verba: ' Rex Demetrius genti Iudaeorum salutem."
,"26":"Quoniam servastis ad nos pactum et mansistis in amicitia nostra et non accessistis ad inimicos nostros, audivimus et gavisi sumus."
,"27":"Et nunc perseverate adhuc conservare ad nos fidem, et retribuemus vobis bona pro his, quae facitis nobiscum,"
,"28":"et remittemus vobis praestationes multas et dabimus vobis donationes."
,"29":"Et nunc absolvo vos et remitto Iudaeos a tributis et pretio salis et a coronis;"
,"30":"et pro tertia parte seminis et pro dimidia parte fructus ligni, quod debetur mihi accipere, remitto ex hodierno die et deinceps accipere a terra Iudae et a tribus regionibus, quae additae sunt illi ex Samaritide et Galilaea, ex hodierna die et in totum tempus;"
,"31":"et Ierusalem sit sancta et libera et fines eius et decimae et tributa."
,"32":"Remitto etiam potestatem arcis, quae est in Ierusalem, et do eam summo sacerdoti, ut constituat in ea viros, quoscumque ipse elegerit, qui custodiant eam."
,"33":"Et omnem animam Iudaeorum, quae captiva est a terra Iudae in omni regno meo, relinquo liberam gratis, et omnes a tributis solvantur etiam pecorum suorum."
,"34":"Et omnes dies sollemnes et sabbata et neomeniae et dies decreti et tres dies ante diem sollemnem et tres dies post diem sollemnem sint omnes immunitatis et remissionis omnibus Iudaeis, qui sunt in regno meo;"
,"35":"et nemo habebit potestatem agere et perturbare aliquem illorum de omni causa."
,"36":"Et ascribantur ex Iudaeis in exercitu regis ad triginta milia virorum, et dabuntur illis copiae, ut oportet omnibus exercitibus regis."
,"37":"Et ex eis constituentur, qui sint in munitionibus regis magnis, et ex his constituentur super negotia regni, quae aguntur ex fide, et praepositi eorum et principes sint ex eis et ambulent in legibus suis, sicut praecepit rex in terra Iudae."
,"38":"Et tres regiones, quae additae sunt Iudaeae ex regione Samariae, addatur Iudaeae reputari, ut sint sub uno et non oboediant alii potestati, nisi summi sacerdotis."
,"39":"Ptolemaida et confines eius dedi donum sanctis, quae sunt in Ierusalem, ad necessarios sumptus sanctis."
,"40":"Et ego do singulis annis quindecim milia siclorum argenti de rationibus regis ex locis, quae me contingunt;"
,"41":"et omne, quod reliquum fuerit, quod non reddiderant, qui super negotia erant, annis prioribus, ex hoc dabunt in opera domus."
,"42":"Et super haec quinque milia siclorum argenti, quanta accipiebant de sanctorum ratione per singulos annos, et haec remittuntur eo quod ipsa ad sacerdotes pertineant, qui ministerio funguntur."
,"43":"Et quicumque confugerint in templum, quod est Hierosolymis, et in omnibus finibus eius debentes regalia et quamlibet rem, dimittantur, et universa, quae sunt eis in regno meo."
,"44":"Et ad aedificanda vel restauranda opera sanctorum sumptus dabitur de ratione regis;"
,"45":"et ad exstruendos muros Ierusalem et communiendum in circuitu sumptus dabitur de ratione regis et ad construendos muros in Iudaea '."
,"46":"Ut audivit autem Ionathas et populus sermones istos, non crediderunt eis nec receperunt, quia recordati sunt malitiae magnae, quam fecerat in Israel et tribulaverat eos valde."
,"47":"Et complacuit eis in Alexandro, quia ipse fuerat eis princeps sermonum pacis, et ipsi auxilium ferebant omnibus diebus."
,"48":"Et congregavit rex Alexander exercitum magnum et admovit castra contra Demetrium."
,"49":"Et commiserunt proelium duo reges, et fugit exercitus Alexandri, et insecutus est eum Demetrius et praevaluit adversus eos;"
,"50":"et confirmavit proelium nimis, donec occidit sol, et cecidit Demetrius in die illa."
,"51":"Et misit Alexander ad Ptolemaeum regem Aegypti legatos secundum haec verba dicens:"
,"52":"' Quoniam regressus sum in regnum meum et sedi in sede patrum meorum et obtinui principatum et contrivi Demetrium et possedi regionem nostram"
,"53":"et commisi pugnam cum eo, et contritus est ipse et castra eius a nobis, et sedimus in sede regni eius;"
,"54":"et nunc statuamus ad invicem amicitiam, et da mihi filiam tuam uxorem, et ego ero gener tuus et dabo tibi dona et ipsi digna te '."
,"55":"Et respondit rex Ptolemaeus dicens: ' Felix dies, in qua reversus es ad terram patrum tuorum et sedisti in sede regni eorum!"
,"56":"Et nunc faciam tibi, quae scripsisti, sed occurre in Ptolemaidam, ut videamus invicem nos, et socer fiam tibi, sicut dixisti '."
,"57":"Et exivit Ptolemaeus de Aegypto, ipse et Cleopatra filia eius, et venit Ptolemaidam anno centesimo sexagesimo secundo."
,"58":"Et occurrit ei Alexander rex, et dedit ei Cleopatram filiam suam et fecit nuptias eius Ptolemaidae sicut reges in magna gloria."
,"59":"Et scripsit rex Alexander Ionathae, ut veniret obviam sibi."
,"60":"Et abiit cum gloria Ptolemaidam et occurrit ibi duobus regibus et dedit illis argentum multum et aurum et dona et invenit gratiam in conspectu eorum."
,"61":"Et convenerunt adversus eum viri pestilentes ex Israel, viri iniqui interpellantes adversus eum; et non intendit ad eos rex."
,"62":"Et iussit rex, et exspoliaverunt Ionathan vestibus suis et induerunt eum purpura; et ita fecerunt. Et collocavit eum rex sedere secum."
,"63":"Dixitque principibus suis: ' Exite cum eo in medium civitatis et praedicate, ut nemo adversus eum interpellet de ullo negotio, nec quisquam ei molestus sit de ulla ratione '."
,"64":"Et factum est, ut viderunt, qui interpellabant gloriam eius, quae praedicabatur, et opertum eum purpura, fugerunt omnes."
,"65":"Et magnificavit eum rex et scripsit eum inter primos amicos et posuit eum ducem et participem principatus."
,"66":"Et reversus est Ionathas in Ierusalem cum pace et laetitia."
,"67":"In anno centesimo sexagesimo quinto venit Demetrius filius Demetrii a Creta in terram patrum suorum;"
,"68":"et audivit Alexander rex et contristatus est valde et reversus est Antiochiam."
,"69":"Et constituit Demetrius rex Apollonium, qui praeerat Coelesyriae, et congregavit exercitum magnum; et accessit ad Iamniam et misit ad Ionathan summum sacerdotem"
,"70":"dicens: ' Tu omnino solus resistis nobis; ego autem factus sum in derisum et in opprobrium propter te; et quare tu potestatem adversum nos exerces in montibus?"
,"71":"Nunc ergo si confidis in virtutibus tuis, descende ad nos in campum, et comparemus illic invicem, quia mecum est virtus civitatum."
,"72":"Interroga et disce quis sum ego et ceteri, qui auxilio sunt nobis, et dicunt: 'Non potest stare pes vester ante faciem nostram, quia bis in fugam conversi sunt patres tui in terra sua'."
,"73":"Et nunc non poteris sustinere equitatum et exercitum talem in campo, ubi non est lapis neque silex neque locus fugiendi '."
,"74":"Ut audivit autem Ionathas sermones Apollonii, motus est animo et elegit decem milia virorum et exiit ab Ierusalem, et occurrit ei Simon frater eius in adiutorium."
,"75":"Et applicuit castra in Ioppen; et excluserunt eum, qui erant de civitate, quia custodia Apollonii in Ioppe erat, et oppugnaverunt eam."
,"76":"Et exterriti, qui erant in civitate, aperuerunt ei, et obtinuit Ionathas Ioppen."
,"77":"Et audivit Apollonius et admovit tria milia equitum et exercitum multum. Et abiit Azotum tamquam iter faciens et statim exiit in campum, eo quod haberet multitudinem equitum et confideret in eis."
,"78":"Et insecutus est eum Ionathas in Azotum, et exercitus commiserunt proelium."
,"79":"Et reliquit Apollonius mille equites post eos occulte."
,"80":"Et cognovit Ionathas quoniam insidiae sunt post se; et circuierunt castra eius et iecerunt iacula in populum a mane usque ad vesperam."
,"81":"Populus autem stabat, sicut praeceperat Ionathas, et laboraverunt equi eorum."
,"82":"Et eiecit Simon exercitum suum et commisit contra legionem; equites enim fatigati erant. Et contriti sunt ab eo et fugerunt,"
,"83":"et equi dispersi sunt in campo et fugerunt in Azotum et intraverunt in Bethdagon idolum suum, ut ibi se liberarent."
,"84":"Et succendit Ionathas Azotum et civitates, quae erant in circuitu eius, et accepit spolia eorum et templum Dagon et omnes, qui fugerunt in illud, succendit igne."
,"85":"Et fuerunt, qui ceciderunt gladio cum his qui succensi sunt, fere octo milia virorum."
,"86":"Et movit inde Ionathas castra et applicuit ad Ascalonem, et exierunt de civitate obviam illi in magna gloria."
,"87":"Et reversus est Ionathas in Ierusalem cum suis habentibus spolia multa."
,"88":"Et factum est, ut audivit Alexander rex sermones istos, et addidit adhuc glorificare Ionathan"
,"89":"et misit ei fibulam auream, sicut consuetudo est dari cognatis regum, et dedit ei Accaron et omnes fines eius in possessionem."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et rex Aegypti congregavit exercitum sicut arena, quae est circa oram maris, et naves multas et quaerebat obtinere regnum Alexandri dolo et addere illud regno suo."
,"2":"Et exiit in Syriam verbis pacificis, et aperiebant ei civitates et occurrebant ei, quia mandaverat Alexander rex exire ei obviam, eo quod socer suus esset."
,"3":"Cum autem introiret civitatem, Ptolemaeus ponebat custodias militum in singulis civitatibus."
,"4":"Et, ut appropiavit Azoto, ostenderunt ei templum Dagon succensum et Azotum et suburbana eius demolita et corpora proiecta et combustos, quos combusserat in bello; fecerant enim tumulos eorum in via eius."
,"5":"Et narraverunt regi, quae fecit Ionathas, ut vituperarent eum; et tacuit rex."
,"6":"Et occurrit Ionathas regi in Ioppen cum gloria, et invicem se salutaverunt et dormierunt illic."
,"7":"Et abiit Ionathas cum rege usque ad fluvium, qui vocatur Eleutherus, et reversus est in Ierusalem."
,"8":"Rex autem Ptolemaeus obtinuit dominium civitatum maritimarum usque Seleuciam maritimam et cogitabat in Alexandrum consilia mala."
,"9":"Et misit legatos ad Demetrium dicens: ' Veni, componamus inter nos pactum, et dabo tibi filiam meam, quam habet Alexander, et regnabis in regno patris tui;"
,"10":"paenitet enim me quod dederim illi filiam meam: quaesivit enim me occidere '."
,"11":"Et vituperavit eum, propterea quod concupisceret regnum eius."
,"12":"Et abstulit filiam suam et dedit eam Demetrio et alienavit se ab Alexandro, et manifestatae sunt inimicitiae eorum."
,"13":"Et intravit Ptolemaeus Antiochiam et imposuit duo diademata capiti suo, Aegypti et Asiae."
,"14":"Alexander autem rex erat in Cilicia illis temporibus, quia rebellabant, qui erant de locis illis;"
,"15":"et audivit Alexander et venit ad eum in bello. Et produxit Ptolemaeus exercitum et occurrit ei in manu valida et fugavit eum."
,"16":"Et fugit Alexander in Arabiam, ut ibi protegeretur; rex autem Ptolemaeus exaltatus est."
,"17":"Et abstulit Zabdiel Arabs caput Alexandri et misit Ptolemaeo."
,"18":"Et rex Ptolemaeus mortuus est in die tertia; et qui erant in munitionibus, perierunt ab his, qui erant in munitionibus."
,"19":"Et regnavit Demetrius anno centesimo sexagesimo septimo."
,"20":"In diebus illis congregavit Ionathas eos, qui erant de Iudaea, ut expugnarent arcem, quae est in Ierusalem; et fecerunt contra eam machinas multas."
,"21":"Et abierunt quidam, qui oderant gentem suam, viri iniqui ad regem et renuntiaverunt ei quod Ionathas obsideret arcem."
,"22":"Et audiens iratus est et statim, ut audivit, movit castra et venit ad Ptolemaidam et scripsit Ionathae, ne obsideret arcem et ut occurreret sibi ad colloquium in Ptolemaidam festinato."
,"23":"Ut audivit autem Ionathas, iussit obsidere et elegit de senioribus Israel et de sacerdotibus et dedit se periculo"
,"24":"et accepit argentum et aurum et vestem et alia xenia multa et abiit ad regem in Ptolemaidam et invenit gratiam in conspectu eius."
,"25":"Et interpellabant adversus eum quidam iniqui ex gente sua."
,"26":"Et fecit ei rex, sicut fecerant ei qui ante eum fuerant, et exaltavit eum in conspectu omnium amicorum suorum"
,"27":"et statuit ei principatum sacerdotii et, quaecumque alia habuit prius pretiosa, et fecit eum principem primorum amicorum."
,"28":"Et postulavit Ionathas a rege, ut immunem faceret Iudaeam et tres toparchias et Samaritidem, et promisit ei talenta trecenta."
,"29":"Et consensit rex et scripsit Ionathae epistulas de his omnibus hunc modum continentes:"
,"30":"' Rex Demetrius fratri Ionathae salutem et genti Iudaeorum."
,"31":"Exemplum epistulae, quam scripsimus Lastheni parenti nostro de vobis, scripsimus et ad vos, ut sciretis:"
,"32":"'Rex Demetrius Lastheni patri salutem."
,"33":"Genti Iudaeorum amicis nostris et conservantibus, quae iusta sunt apud nos, decrevimus benefacere propter benignitatem ipsorum, quam erga nos habent."
,"34":"Statuimus ergo illis fines Iudaeae et tres regiones, Apherema et Lydda et Ramathaim, quae additae sunt Iudaeae ex Samaritide, et omnia confinia earum, omnibus sacrificantibus in Hierosolymis, pro regalibus, quae ab eis prius accipiebat rex per singulos annos de fructibus terrae et pomorum;"
,"35":"et alia, quae ad nos pertinent ex hoc tempore decimarum et tributorum pertinentium ad nos, et salis stagna et pertinentes ad nos coronas, omnia ipsis concedimus."
,"36":"Et nihil horum irritum erit ex hoc et in omne tempus."
,"37":"Nunc ergo curate facere horum exemplum, et detur Ionathae et ponatur in monte sancto in loco celebri' '."
,"38":"Et videns Demetrius rex quod siluit terra in conspectu suo, et nihil ei resistit, dimisit totum exercitum suum, unumquemque in locum suum, excepto peregrino exercitu, quem contraxit ab insulis gentium; et inimici erant ei omnes exercitus patrum eius."
,"39":"Tryphon autem erat quidam partium Alexandri prius et vidit quoniam omnis exercitus murmurabat contra Demetrium et ivit ad Imalcue Arabem, qui nutriebat Antiochum filium Alexandri;"
,"40":"et assidebat ei, ut traderet eum ipsi, ut regnaret loco patris sui. Et enuntiavit ei quanta constituerat Demetrius et inimicitias exercituum eius adversus illum; et mansit ibi diebus multis."
,"41":"Et misit Ionathas ad Demetrium regem, ut eiceret eos, qui in arce erant in Ierusalem et qui in praesidiis erant, quia impugnabant Israel."
,"42":"Et misit Demetrius ad Ionathan dicens: ' Non haec tantum faciam tibi et genti tuae, sed gloria illustrabo te et gentem tuam, cum fuerit opportunum;"
,"43":"nunc ergo recte feceris, si miseris in auxilium mihi viros, quia discessit omnis exercitus meus '."
,"44":"Et misit ei Ionathas tria milia virorum fortium Antiochiam, et venerunt ad regem, et delectatus est rex in adventu eorum."
,"45":"Et convenerunt, qui erant de civitate, centum viginti milia virorum, et volebant interficere regem;"
,"46":"et fugit rex in aulam, et occupaverunt, qui erant de civitate, itinera civitatis et coeperunt pugnare."
,"47":"Et vocavit rex Iudaeos in auxilium, et convenerunt omnes simul ad eum et dispersi sunt per civitatem; et occiderunt in illa die centum milia hominum."
,"48":"Et succenderunt civitatem et ceperunt spolia multa in die illa et liberaverunt regem."
,"49":"Et viderunt, qui erant de civitate, quod obtinuissent Iudaei civitatem, sicut volebant, et infirmati sunt mente sua et clamaverunt ad regem cum precibus dicentes:"
,"50":"' Da nobis dextras, et cessent Iudaei oppugnare nos et civitatem '."
,"51":"Et proiecerunt arma sua et fecerunt pacem; et glorificati sunt Iudaei in conspectu regis et in conspectu omnium, qui erant in regno eius, et nominati sunt in regno et regressi sunt in Ierusalem habentes spolia multa."
,"52":"Et sedit Demetrius rex in sede regni sui, et siluit terra in conspectu eius."
,"53":"Et mentitus est omnia, quaecumque dixit, et abalienavit se a Ionatha et non retribuit ei secundum beneficia, quae sibi tribuerat, et vexabat eum valde."
,"54":"Post haec autem reversus est Tryphon, et Antiochus cum eo puer adulescentior; et regnavit et imposuit sibi diadema."
,"55":"Et congregati sunt ad eum omnes exercitus, quos disperserat Demetrius, et pugnaverunt contra eum, et fugit et terga vertit."
,"56":"Et accepit Tryphon bestias et obtinuit Antiochiam."
,"57":"Et scripsit Antiochus adulescentior Ionathae dicens: ' Constituo tibi summum sacerdotium et constituo te super quattuor regiones et ut sis de amicis regis '."
,"58":"Et misit illi vasa aurea et ministerium et dedit ei potestatem bibendi in auro et esse in purpura et habere fibulam auream."
,"59":"Et Simonem fratrem eius constituit ducem a descensu Tyri usque ad fines Aegypti."
,"60":"Et exiit Ionathas et perambulabat trans flumen et in civitatibus, et congregatus est ad eum omnis exercitus Syriae in auxilium; et venit Ascalonem, et occurrerunt ei honorifice de civitate."
,"61":"Et abiit inde Gazam, et concluserunt, qui erant Gazae; et obsedit eam et succendit, quae erant in circuitu civitatis, et praedatus est ea."
,"62":"Et rogaverunt Gazenses Ionathan, et dedit illis dexteram et accepit filios principum eorum obsides et misit illos in Ierusalem; et perambulavit regionem usque Damascum."
,"63":"Et audivit Ionathas quod aderant principes Demetrii in Cades, quae est in Galilaea, cum exercitu multo volentes eum removere a negotio;"
,"64":"et occurrit illis, fratrem autem suum Simonem reliquit in regione."
,"65":"Et applicuit Simon ad Bethsuram et expugnabat eam diebus multis et conclusit eos."
,"66":"Et postulaverunt ab eo dextras accipere, et dedit illis; et eiecit eos inde et cepit civitatem et posuit in ea praesidium."
,"67":"Et Ionathas et castra eius applicuerunt ad aquam Gennesar et ante lucem vigilaverunt in campo Asor."
,"68":"Et ecce castra alienigenarum occurrebant ei in campo et tendebant ei insidias in montibus; ipsi autem occurrerunt ex adverso."
,"69":"Insidiae vero exsurrexerunt de locis suis et commiserunt proelium."
,"70":"Et fugerunt, qui erant ex parte Ionathae omnes, et nemo relictus est ex eis, nisi Matthathias filius Absalomi et Iudas filius Chalphi princeps militiae exercitus."
,"71":"Et scidit Ionathas vestimenta sua et posuit terram in capite suo et oravit."
,"72":"Et reversus est ad eos in proelium et convertit eos in fugam; et fugerunt."
,"73":"Et viderunt, qui fugiebant partis illius, et reversi sunt ad eum et insequebantur cum eo usque Cades, usque ad castra ipsorum, et applicuerunt illic."
,"74":"Et ceciderunt de alienigenis in die illa tria milia virorum; et reversus est Ionathas in Ierusalem."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Et vidit Ionathas quia tem pus eum adiuvat; et elegit vi ros et misit Romam statuere et renovare cum eis amicitiam;"
,"2":"et ad Spartiatas et ad alia loca misit epistulas secundum eadem."
,"3":"Et abierunt Romam et intraverunt curiam et dixerunt: 'Ionathas summus sacerdos et gens Iudaeorum miserunt nos renovare amicitiam et societatem secundum pristinum'."
,"4":"Et dederunt illis epistulas ad ipsos per loca, ut deducerent eos in terram Iudae cum pace."
,"5":"Et hoc est exemplum epistularum, quas scripsit Ionathas Spartiatis:"
,"6":"' Ionathas summus sacerdos et seniores gentis et sacerdotes et reliquus populus Iudaeorum Spartiatis fratribus salutem."
,"7":"Iampridem missae erant epistulae ad Oniam summum sacerdotem ab Ario, qui regnabat apud vos, quoniam estis fratres nostri, sicut rescriptum continet, quod subiectum est."
,"8":"Et suscepit Onias virum, qui missus fuerat, cum honore; et accepit epistulas, in quibus significabatur de societate et amicitia."
,"9":"Nos igitur, cum nullo horum indigeremus, exhortationem habentes sanctos libros, qui sunt in manibus nostris,"
,"10":"tentavimus mittere ad vos renovare fraternitatem et amicitiam, ne forte alieni efficiamur a vobis; multa enim tempora transierunt, ex quo misistis ad nos."
,"11":"Nos ergo in omni tempore sine intermissione in diebus sollemnibus et ceteris, quibus oportet, memores sumus vestri in sacrificiis, quae offerimus, et in obsecrationibus, sicut fas est et decet meminisse fratrum."
,"12":"Laetamur itaque de gloria vestra."
,"13":"Nos autem circumdederunt multae tribulationes et multa proelia; et impugnaverunt nos reges, qui sunt in circuitu nostro."
,"14":"Noluimus ergo vobis molesti esse et ceteris sociis et amicis nostris in his proeliis;"
,"15":"habemus enim de caelo auxilium, quod nos adiuvat, et liberati sumus nos ab inimicis nostris, et humiliati sunt inimici nostri."
,"16":"Elegimus itaque Numenium Antiochi filium et Antipatrem Iasonis filium et misimus ad Romanos renovare cum eis amicitiam et societatem pristinam;"
,"17":"mandavimus itaque eis, ut veniant etiam ad vos et salutent vos et reddant vobis epistulas nostras de innovatione et fraternitate nostra."
,"18":"Et nunc bene facietis respondentes nobis ad haec '."
,"19":"Et hoc est rescriptum epistularum, quas miserunt Oniae:"
,"20":"' Arius rex Spartiatarum Oniae sacerdoti magno salutem."
,"21":"Inventum est in scriptura de Spartiatis et Iudaeis quoniam sunt fratres et quod sunt de genere Abraham."
,"22":"Et nunc, ex quo haec cognovimus, bene facietis scribentes nobis de pace vestra."
,"23":"Sed et nos rescribimus vobis. Pecora vestra et possessiones vestrae nostrae sunt; et, quae nostra, vestra sunt. Mandamus itaque, ut annuntient vobis secundum haec '."
,"24":"Et audivit Ionathas quoniam regressi sunt principes Demetrii cum exercitu multo supra quam prius pugnare adversus eum."
,"25":"Et exiit ab Ierusalem et occurrit eis in Amathitem regionem; non enim dedit eis spatium, ut ingrederentur regionem eius."
,"26":"Et misit speculatores in castra eorum, et reversi renuntiaverunt ei quod ita constituunt supervenire illis nocte."
,"27":"Cum occidisset autem sol, praecepit Ionathas suis vigilare et esse in armis paratos ad pugnam tota nocte; et emisit custodes per circuitum castrorum."
,"28":"Et audierunt adversarii quod paratus est Ionathas cum suis in bellum, et timuerunt et formidaverunt in corde suo et accenderunt focos in castris suis."
,"29":"Ionathas autem et, qui cum eo erant, non cognoverunt usque mane; videbant enim luminaria ardentia."
,"30":"Et insecutus est eos Ionathas et non comprehendit eos; transierant enim flumen Eleutherum."
,"31":"Et divertit Ionathas ad Arabas, qui vocantur Zabadaei, et percussit eos et accepit spolia eorum."
,"32":"Et iunxit et venit Damascum et perambulabat omnem regionem illam."
,"33":"Simon autem exiit et venit usque ad Ascalonem et ad proxima praesidia et declinavit in Ioppen et occupavit eam;"
,"34":"audivit enim quod vellent praesidium tradere partibus Demetrii, et posuit ibi custodes, ut custodirent eam."
,"35":"Et reversus est Ionathas et convocavit seniores populi et cogitavit cum eis aedificare praesidia in Iudaea"
,"36":"et altius extollere muros Ierusalem et exaltare altitudinem magnam inter medium arcis et civitatis, ut separaret eam a civitate, ut esset ipsa singulariter, ut neque emant neque vendant."
,"37":"Et convenerunt, ut aedificarent civitatem; et cecidit de muro, qui erat super torrentem a subsolano, et reparavit eum, qui vocatur Chaphenatha."
,"38":"Et Simon aedificavit Adida in Sephela et munivit eam et imposuit portas et seras."
,"39":"Et quaesivit Tryphon regnare Asiae et imponere sibi diadema et extendere manum in Antiochum regem."
,"40":"Et veritus est, ne forte non permitteret eum Ionathas et ne forte pugnaret adversus eum, et quaerebat comprehendere eum et occidere et exsurgens abiit in Bethsan."
,"41":"Et exivit Ionathas obviam illi cum quadraginta milibus virorum electorum in proelium et venit Bethsan."
,"42":"Et vidit Tryphon quia venit cum exercitu multo et extendere in eum manus timuit"
,"43":"et excepit eum cum honore et commendavit eum omnibus amicis suis et dedit ei munera et praecepit exercitibus suis, ut oboedirent ei sicut sibi."
,"44":"Et dixit Ionathae: ' Ut quid vexasti universum populum, cum bellum nobis non sit?"
,"45":"Et nunc remitte eos in domos suas. Elige autem tibi viros paucos, qui tecum sint, et veni mecum Ptolemaidam, et tradam eam tibi et reliqua praesidia et reliquum exercitum et universos praepositos negotiis et conversus abibo; propterea enim veni '."
,"46":"Et credidit ei et fecit, sicut dixit, et dimisit exercitum, et abierunt in terram Iudae."
,"47":"Retinuit autem secum tria milia virorum, ex quibus remisit in Galilaeam duo milia; mille autem venerunt cum eo."
,"48":"Ut autem intravit Ptolemaidam Ionathas, clauserunt portas Ptolemenses et comprehenderunt eum; et omnes, qui cum eo intraverant, gladio interfecerunt."
,"49":"Et misit Tryphon exercitum et equites in Galilaeam et in campum magnum, ut perderent omnes socios Ionathae."
,"50":"At illi, cum cognovissent quia comprehensus est Ionathas et periit, et omnes, qui cum eo erant, hortati sunt semetipsos et ibant conglobati parati in proelium."
,"51":"Et videntes hi, qui insecuti fuerant, quia pro anima res est illis, reversi sunt;"
,"52":"illi autem venerunt omnes cum pace in terram Iudae et planxerunt Ionathan et eos, qui cum ipso fuerant, et timuerunt valde; et luxit Israel luctu magno."
,"53":"Et quaesierunt omnes gentes, quae erant in circuitu eorum, conterere eos; dixerunt enim:"
,"54":"'Non habent principem et adiuvantem; nunc ergo expugnemus illos et tollamus de hominibus memoriam eorum '."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Et audivit Simon quod con gregavit Tryphon exercitum copiosum, ut veniret in terram Iudae et attereret eam."
,"2":"Videns quia in tremore populus est et in timore, ascendit Ierusalem et congregavit populum"
,"3":"et exhortatus est eos et dixit illis: ' Vos scitis quanta ego et fratres mei et domus patris mei fecimus pro legibus et pro sanctis proelia et angustias quales vidimus."
,"4":"Horum gratia perierunt fratres mei omnes propter Israel, et relictus sum ego solus."
,"5":"Et nunc non mihi contingat parcere animae meae in omni tempore tribulationis; non enim melior sum fratribus meis."
,"6":"Vindicabo tamen gentem meam et sancta, uxores quoque et natos vestros, quia congregatae sunt universae gentes conterere nos inimicitiae gratia '."
,"7":"Et accensus est spiritus populi, simul ut audivit sermones istos,"
,"8":"et responderunt voce magna dicentes: ' Tu es dux noster loco Iudae et Ionathae fratris tui;"
,"9":"pugna proelium nostrum, et omnia, quaecumque dixeris nobis, faciemus '."
,"10":"Et congregans omnes viros bellatores acceleravit consummare universos muros Ierusalem et munivit eam in gyro."
,"11":"Et misit Ionathan filium Absalomi et cum eo exercitum magnum in Ioppen et, eiectis his, qui erant in ea, remansit illic in ea."
,"12":"Et movit Tryphon a Ptolemaida cum exercitu multo, ut veniret in terram Iudae, et Ionathas cum eo in custodia."
,"13":"Simon autem applicuit in Adidis contra faciem campi."
,"14":"Et ut cognovit Tryphon quia surrexit Simon loco fratris sui Ionathae et quia commissurus esset cum eo proelium, misit ad eum legatos"
,"15":"dicens: ' Pro argento, quod debebat frater tuus Ionathas fisco regis propter negotia, quae habuit, detinuimus eum;"
,"16":"et nunc mitte argenti talenta centum et duos filios eius obsides, ut non dimissus fugiat a nobis, et remittemus eum '."
,"17":"Et cognovit Simon quia cum dolo loquuntur secum; misit tamen accipere argentum et pueros, ne inimicitiam magnam sumeret ad populum,"
,"18":"qui dicerent: ' Quia non misit ei argentum et pueros, periit '."
,"19":"Et misit pueros et centum talenta. Et mentitus est et non dimisit Ionathan;"
,"20":"et post haec venit Tryphon intrare in regionem, ut contereret eam, et gyraverunt per viam, quae ducit Adoram. Et Simon et castra eius ambulabant in omnem locum, quocumque ibant."
,"21":"Qui autem in arce erant, miserunt ad Tryphonem legatos urgentes eum, ut veniret ad eos per desertum et mitteret illis alimonias."
,"22":"Et paravit Tryphon omnem equitatum suum, ut veniret; et in illa nocte fuit nix multa valde, et non venit propter nivem et discessit et abiit in Galaaditim."
,"23":"Et cum appropinquasset Bascaman, occidit Ionathan, et sepultus est illic;"
,"24":"et convertit Tryphon et abiit in terram suam."
,"25":"Et misit Simon et accepit ossa Ionathae fratris sui et sepelivit eum in Modin civitate patrum eius."
,"26":"Et planxerunt eum omnis Israel planctu magno et luxerunt eum dies multos."
,"27":"Et aedificavit Simon super sepulcrum patris sui et fratrum suorum et exaltavit illud visu, lapide polito retro et ante;"
,"28":"et statuit septem pyramidas, unam contra unam, patri et matri et quattuor fratribus."
,"29":"Et his fecit machinamenta circumponens columnas magnas et super columnas arma ad memoriam aeternam et iuxta arma naves sculptas, quae viderentur ab omnibus navigantibus mare."
,"30":"Hoc est sepulcrum, quod fecit in Modin, usque in hunc diem."
,"31":"Tryphon autem iter faciebat dolo cum Antiocho rege adulescentiore et occidit eum"
,"32":"et regnavit loco eius et imposuit sibi diadema Asiae et fecit plagam magnam in terra."
,"33":"Et aedificavit Simon praesidia Iudaeae muniens ea turribus excelsis et muris magnis et portis et seris; et posuit alimenta in munitionibus."
,"34":"Et elegit Simon viros et misit ad Demetrium regem, ut faceret remissionem regioni, quia actus omnes Tryphonis fuerant rapinae."
,"35":"Et Demetrius rex ad verba ista respondit ei et scripsit epistulam talem:"
,"36":"' Rex Demetrius Simoni summo sacerdoti et amico regum et senioribus et genti Iudaeorum salutem."
,"37":"Coronam auream et baen, quam misistis, suscepimus; et parati sumus facere vobiscum pacem magnam et scribere praepositis regis remittere vobis, quae indulsimus."
,"38":"Quaecumque enim constituimus vobis, constant; munitiones, quas aedificastis, vobis sint."
,"39":"Remittimus quoque ignorantias et peccata usque in hodiernum diem et coronam, quam debebatis; et, si quid aliud erat tributarium in Ierusalem, iam non sit tributarium."
,"40":"Et, si qui ex vobis apti sunt conscribi inter nostros, conscribantur, et sit inter nos pax '."
,"41":"Anno centesimo septuagesimo ablatum est iugum gentium ab Israel."
,"42":"Et coepit populus Israel scribere in conscriptionibus et commutationibus: ' Anno primo sub Simone summo sacerdote magno duce et principe Iudaeorum '."
,"43":"In diebus illis applicuit Simon ad Gazaram et circumdedit eam castris et fecit machinam et applicuit ad civitatem et percussit turrim unam et comprehendit."
,"44":"Et eruperant, qui erant intra machinam, in civitatem; et factus est motus magnus in civitate."
,"45":"Et ascenderunt, qui erant in civitate, cum uxoribus et filiis supra murum, scissis tunicis suis, et clamaverunt voce magna postulantes a Simone dextras sibi dari"
,"46":"et dixerunt: ' Non nobis reddas secundum malitias nostras sed secundum misericordiam tuam '."
,"47":"Et consensit illis Simon et non debellavit eos; eiecit tamen eos de civitate et mundavit aedes, in quibus fuerant simulacra, et tunc intravit in eam canens et benedicens."
,"48":"Et, eiecta ab ea omni immunditia, collocavit in ea viros, qui legem facerent, et munivit eam et aedificavit sibi habitationem."
,"49":"Qui autem erant in arce Ierusalem, prohibebantur egredi et ingredi regionem et emere ac vendere; et esurierunt valde, et multi ex eis fame perierunt."
,"50":"Et clamaverunt ad Simonem, ut dextras acciperent, et dedit illis et eiecit eos inde et mundavit arcem a contaminationibus."
,"51":"Et intraverunt in eam tertia et vicesima die secundi mensis, anno centesimo septuagesimo primo, cum laude et ramis palmarum et cinyris et cymbalis et nablis et hymnis et canticis, quia contritus est inimicus magnus ex Israel."
,"52":"Et constituit, ut omnibus annis agerentur dies hi cum laetitia."
,"53":"Et munivit montem templi, qui erat secus arcem, et habitavit ibi ipse et qui cum eo erant."
,"54":"Et vidit Simon Ioannem filium suum quod vir esset et posuit eum ducem virtutum universarum; et habitavit in Gazaris."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Anno centesimo septuagesi mo secundo congregavit rex Demetrius exercitum suum et abiit in Mediam ad contrahenda sibi auxilia, ut expugnaret Tryphonem."
,"2":"Et audivit Arsaces rex Persidis et Mediae, quia intravit Demetrius confines suos, et misit unum de principibus suis, ut comprehenderet eum vivum."
,"3":"Et abiit et percussit castra Demetrii et comprehendit eum et duxit eum ad Arsacem et posuit eum in custodiam."
,"4":"Et siluit terra Iudae omnibus diebus Simonis; et quaesivit bona genti suae, et placuit illis potestas eius, et gloria eius omnibus diebus."
,"5":"Et cum omni gloria sua,accepit Ioppen in portum,et fecit introitum insulis maris."
,"6":"Et dilatavit fines gentis suae,et obtinuit regionem."
,"7":"Et congregavit captivitatem multam et dominatus est Gazarae et Bethsurae et arci; et abstulit immunditias ex ea, et non erat qui resisteret ei."
,"8":"Et unusquisque colebat terram suam cum pace; et terra dabat fructus suos, et ligna camporum fructum suum."
,"9":"Seniores in plateis sedebant, omnes de bonis communiter tractabant, et iuvenes induebant se gloriam,et stolas belli."
,"10":"Et civitatibus tribuebat alimonias et constituebat eas, ut essent vasa munitionis, quoadusque nominatum est nomen gloriae eius,usque ad extremum terrae."
,"11":"Fecit pacem super terram, et laetatus est Israel laetitia magna."
,"12":"Et sedit unusquisque sub vite sua,et sub ficulnea sua, et non erat qui eos terreret."
,"13":"Defecit impugnans eos super terram; reges contriti sunt in diebus illis."
,"14":"Et confirmavit omnes humiles populi sui,et legem exquisivit et abstulit omnem iniquum et malum."
,"15":"Sancta glorificavit,et multiplicavit vasa sanctorum."
,"16":"Et auditum est Romae quia defunctus esset Ionathas, et usque in Spartiatas, et contristati sunt valde."
,"17":"Ut audierunt autem quod Simon frater eius factus esset summus sacerdos loco eius, et ipse obtineret regionem et civitates in ea,"
,"18":"scripserunt ad eum in tabulis aereis, ut renovarent cum eo amicitias et societatem, quam fecerant cum Iuda et cum Ionatha fratribus eius;"
,"19":"et lectae sunt in conspectu ecclesiae in Ierusalem. Et hoc exemplum epistularum, quas Spartiatae miserunt:"
,"20":"' Spartianorum principes et civitas Simoni sacerdoti magno et senioribus et sacerdotibus et reliquo populo Iudaeorum fratribus salutem."
,"21":"Legati, qui missi sunt ad populum nostrum, nuntiaverunt nobis de vestra gloria et honore, et gavisi sumus in introitu eorum"
,"22":"et scripsimus, quae ab eis erant dicta in conciliis populi sic: 'Numenius Antiochi et Antipater Iasonis filius, legati Iudaeorum, venerunt ad nos renovantes nobiscum amicitiam'."
,"23":"Et placuit populo excipere viros gloriose et ponere exemplum sermonum eorum in segregatis populi libris, ut sit ad memoriam populo Spartiatarum. Exemplum autem horum scripsimus Simoni magno sacerdoti '."
,"24":"Post haec autem misit Simon Numenium Romam habentem clipeum aureum magnum pondo minarum mille ad statuendam cum eis societatem."
,"25":"Cum autem audisset populus sermones istos, dixerunt: ' Quam gratiarum actionem reddemus Simoni et filiis eius?"
,"26":"Invaluit enim ipse et fratres eius et domus patris eius et expugnavit inimicos Israel ab eis; et statuerunt ei libertatem '. Et descripserunt in tabulis aereis et posuerunt in titulis in monte Sion."
,"27":"Et hoc est exemplum scripturae: ' Octava decima die Elul, anno centesimo septuagesimo secundo, anno tertio sub Simone sacerdote magno, in Asaramel,"
,"28":"in conventu magno sacerdotum et populi et principum gentis et seniorum regionis nota facta sunt nobis haec:"
,"29":"Quoniam frequenter facta sunt proelia in regione, Simon autem filius Matthathiae, filius ex filiis Ioarib, et fratres eius dederunt se periculo et restiterunt adversariis gentis suae, ut starent sancta ipsorum et lex; et gloria magna glorificaverunt gentem suam."
,"30":"Et congregavit Ionathas gentem suam et factus est illis sacerdos magnus et appositus est ad populum suum."
,"31":"Et voluerunt inimici eorum calcare et atterere regionem ipsorum et extendere manus in sancta eorum."
,"32":"Tunc restitit Simon et pugnavit pro gente sua et erogavit pecunias multas et armavit viros virtutis gentis suae et dedit illis stipendia."
,"33":"Et munivit civitates Iudaeae et Bethsuram, quae erat in finibus Iudaeae, ubi erant arma hostium antea, et posuit illic praesidium viros Iudaeos;"
,"34":"et Ioppen munivit, quae erat ad mare, et Gazaram, quae est in finibus Azoti, in qua hostes antea habitabant, et collocavit illic Iudaeos et, quaecumque apta erant ad correptionem eorum, posuit in eis."
,"35":"Et vidit populus fidem Simonis et gloriam, quam cogitabat facere genti suae; et posuerunt eum ducem suum et principem sacerdotum, eo quod ipse fecerat haec omnia et iustitiam et fidem, quam conservavit genti suae, et exquisivit omni modo exaltare populum suum."
,"36":"Et in diebus eius prosperatum est in manibus eius, ut tollerentur gentes de regione ipsorum et, qui in civitate David erant in Ierusalem, qui fecerant sibi arcem, de qua procedebant et contaminabant omnia, quae in circuitu sanctorum sunt, et inferebant plagam magnam castitati;"
,"37":"et collocavit in ea viros Iudaeos et munivit eam ad tutamentum regionis et civitatis et exaltavit muros Ierusalem."
,"38":"Et rex Demetrius statuit illi summum sacerdotium secundum haec"
,"39":"et fecit eum amicum suum et glorificavit eum gloria magna."
,"40":"Audivit enim quod appellati sunt Iudaei a Romanis amici et socii et fratres, et quia susceperunt legatos Simonis gloriose;"
,"41":"et quia Iudaei et sacerdotes consenserunt eum esse ducem suum et summum sacerdotem in aeternum, donec surgat propheta fidelis,"
,"42":"et ut sit super eos dux, et ut cura esset illi pro sanctis, ut constitueret per eum super opera eorum et super regionem et super arma et super praesidia;"
,"43":"et cura sit illi de sanctis, et ut audiatur ab omnibus; et scribantur in nomine eius omnes conscriptiones in regione, et ut operiatur purpura et aurum portet;"
,"44":"et ne liceat ulli ex populo et ex sacerdotibus irritum facere aliquid horum et contradicere his, quae ab eo dicuntur, aut convocare conventum in regione sine ipso et vestiri purpura et uti fibula aurea;"
,"45":"qui autem fecerit extra haec aut irritum fecerit aliquid horum, reus erit."
,"46":"Et complacuit omni populo statuere Simoni facere secundum verba ista."
,"47":"Et suscepit Simon et placuit ei, ut summo sacerdotio fungeretur et esset dux et princeps gentis Iudaeorum et sacerdotum et praeesset omnibus '."
,"48":"Et scripturam istam dixerunt ponere in tabulis aereis et ponere eas in peribolo sanctorum in loco celebri;"
,"49":"exemplum autem eorum ponere in aerario, ut habeat Simon et filii eius."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Et misit rex Antiochus filius Demetrii epistulas ab insulis maris Simoni sacerdoti et principi gentis Iudaeorum et universae genti,"
,"2":"et erant continentes hunc modum: ' Rex Antiochus Simoni sacerdoti magno et gentis principi et genti Iudaeorum salutem."
,"3":"Quoniam quidam pestilentes obtinuerunt regnum patrum nostrorum, volo autem vindicare regnum, ut restituam illud, sicut erat antea, delectumque feci multitudinis exercitus et feci naves bellicas;"
,"4":"volo autem procedere per regionem, ut ulciscar in eos, qui corruperunt regionem nostram et qui desolaverunt civitates multas in regno meo."
,"5":"Nunc ergo statuo tibi omnes oblationes, quas remiserunt tibi ante me reges, et quaecumque alia dona remiserunt tibi."
,"6":"Et permisi tibi facere monetam propriam numisma regioni tuae;"
,"7":"Ierusalem autem et sancta esse libera, et omnia arma, quae fabricatus es, et praesidia, quae construxisti, quae tenes, maneant tibi;"
,"8":"et omne debitum regis, et quae futura sunt regi ex hoc et in totum tempus, remittantur tibi."
,"9":"Cum autem obtinuerimus regnum nostrum, glorificabimus te et gentem tuam et templum gloria magna, ita ut manifestetur gloria vestra in universa terra '."
,"10":"Anno centesimo septuagesimo quarto exiit Antiochus in terram patrum suorum, et convenerunt ad eum omnes exercitus, ita ut pauci relicti essent cum Tryphone."
,"11":"Et insecutus est eum Antiochus rex, et venit Doram fugiens, quae est ad mare;"
,"12":"sciebat enim quod congregata sunt mala in eum, et reliquit eum exercitus."
,"13":"Et applicuit Antiochus ad Doram cum centum viginti milibus virorum belligeratorum et octo milibus equitum"
,"14":"et circuivit civitatem, et naves a mari accesserunt; et vexabat civitatem a terra et mari et neminem sinebat ingredi vel egredi."
,"15":"Venit autem Numenius et, qui cum eo fuerant, ab urbe Roma habentes epistulas regibus et regionibus scriptas, in quibus continebantur haec:"
,"16":"'Lucius consul Romanorum Ptolemaeo regi salutem."
,"17":"Legati Iudaeorum venerunt ad nos amici nostri et socii renovantes pristinam amicitiam et societatem, missi a Simone principe sacerdotum et populo Iudaeorum."
,"18":"Attulerunt autem et clipeum aureum minarum mille."
,"19":"Placuit itaque nobis scribere regibus et regionibus, ut non exquirant illis mala neque impugnent eos et civitates eorum et regionem eorum et ut non ferant auxilium pugnantibus adversus eos."
,"20":"Visum autem est nobis accipere ab eis clipeum."
,"21":"Si qui ergo pestilentes refugerunt de regione ipsorum ad vos, tradite eos Simoni principi sacerdotum, ut vindicet in eos secundum legem suam '."
,"22":"Haec eadem scripsit Demetrio regi et Attalo et Ariarathae et Arsacae"
,"23":"et in omnes regiones et Sampsacae et Spartiatis et in Delum et in Myndum et in Sicyonem et in Carida et in Samum et in Pamphyliam et in Lyciam et in Alicarnassum et in Rhodum et in Phaselidam et in Cho et in Siden et in Aradon et in Gortynam et Cnidum et Cyprum et Cyrenen."
,"24":"Exemplum autem eorum scripserunt Simoni principi sacerdotum et populo Iudaeorum."
,"25":"Antiochus autem rex applicuit castra in Doram in secunda die admovens ei semper manus et machinas faciens et conclusit Tryphonem, ne exiret aut introiret."
,"26":"Et misit ad eum Simon duo milia virorum electorum in auxilium et argentum et aurum et vasa copiosa."
,"27":"Et noluit ea accipere, sed rupit omnia, quae pactus est cum eo antea, et alienavit se ab eo."
,"28":"Et misit ad eum Athenobium unum de amicis suis, ut tractaret cum ipso dicens: ' Vos tenetis Ioppen et Gazaram et arcem, quae est in Ierusalem, civitates regni mei;"
,"29":"fines earum desolastis et fecistis plagam magnam in terra et dominati estis per loca multa in regno meo."
,"30":"Nunc ergo tradite civitates, quas occupastis, et tributa locorum, in quibus dominati estis extra fines Iudaeae;"
,"31":"sin autem, date pro illis quingenta talenta argenti, et exterminii, quod exterminastis, et tributorum civitatum alia talenta quingenta; sin autem, veniemus et expugnabimus vos'."
,"32":"Et venit Athenobius amicus regis in Ierusalem et vidit gloriam Simonis et claritatem in auro et argento et apparatum copiosum et obstupuit et rettulit ei verba regis."
,"33":"Et respondit ei Simon et dixit ei: ' Neque alienam terram sumpsimus neque aliena detinemus sed hereditatem patrum nostrorum, quae iniuste ab inimicis nostris aliquo tempore possessa est."
,"34":"Nos vero tempus habentes vindicamus hereditatem patrum nostrorum;"
,"35":"nam de Ioppe et Gazara, quae expostulas, ipsae faciebant in populo plagam magnam et in regione nostra: horum damus talenta centum '. Et non respondit ei verbum."
,"36":"Reversus autem cum ira ad regem renuntiavit ei verba ista et gloriam Simonis et universa, quae vidit; et iratus est rex ira magna."
,"37":"Tryphon autem ascendit in navem et fugit in Orthosiam."
,"38":"Et constituit rex Cendebaeum ducem maritimum et exercitum peditum et equitum dedit illi;"
,"39":"et mandavit illi movere castra contra faciem Iudaeae et mandavit ei aedificare Cedron et obstruere portas civitatis et ut debellaret populum. Rex autem persequebatur Tryphonem."
,"40":"Et pervenit Cendebaeus Iamniam et coepit irritare plebem et conculcare Iudaeam et captivare populum et interficere."
,"41":"Et aedificavit Cedron et collocavit illic equites et exercitum, ut egressi perambularent vias Iudaeae, sicut constituit ei rex."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Et ascendit Ioannes de Ga zaris et nuntiavit Simoni pa tri suo, quae fecit Cendebaeus."
,"2":"Et vocavit Simon duos filios seniores, Iudam et Ioannem, et ait illis: ' Ego et fratres mei et domus patris mei expugnavimus hostes Israel ab adulescentia usque in hunc diem, et prosperatum est in manibus nostris liberare Israel saepius."
,"3":"Nunc autem senui, vos autem in misericordia sufficientes estis in annis; estote loco meo et fratris mei et egressi pugnate pro gente nostra; auxilium vero de caelo vobiscum sit '."
,"4":"Et elegit de regione viginti milia virorum belligeratorum et equites; et profecti sunt ad Cendebaeum et dormierunt in Modin"
,"5":"et surrexerunt mane et abierunt in campum. Et ecce exercitus copiosus in obviam illis peditum et equitum, et fluvius torrens erat inter medium ipsorum."
,"6":"Et admovit castra contra faciem eorum ipse et populus eius et vidit populum trepidantem ad transfretandum torrentem; et transfretavit primus, et viderunt eum viri et transierunt post eum."
,"7":"Et divisit populum, et equites in medio peditum; erat autem equitatus adversariorum copiosus nimis."
,"8":"Et exclamaverunt tubis, et in fugam conversus est Cendebaeus et castra eius, et ceciderunt ex eis multi vulnerati; residui autem in munitionem fugerunt."
,"9":"Tunc vulneratus est Iudas frater Ioannis; Ioannes autem insecutus est eos, donec venit Cedron, quam aedificavit."
,"10":"Et fugerunt usque ad turres, quae erant in agris Azoti, et succendit eas igni; et ceciderunt ex illis duo milia virorum. Et reversus est in Iudaeam in pace."
,"11":"Et Ptolemaeus filius Abubi constitutus erat dux in campo Iericho et habebat argentum et aurum multum;"
,"12":"erat enim gener summi sacerdotis."
,"13":"Et exaltatum est cor eius, et volebat obtinere regionem et cogitabat dolum adversus Simonem et filios eius, ut tolleret eos."
,"14":"Simon autem perambulans civitates, quae erant in regione, et sollicitudinem gerens earum descendit in Iericho ipse et Matthathias et Iudas filii eius, anno centesimo septuagesimo septimo, mense undecimo, hic est mensis Sabath."
,"15":"Et suscepit eos filius Abubi in munitiunculam, quae vocatur Doc, cum dolo, quam aedificavit; et fecit eis convivium magnum et abscondit illic viros."
,"16":"Et, cum inebriatus esset Simon et filii eius, surrexit Ptolemaeus cum suis et sumpserunt arma sua et intraverunt in convivium et occiderunt eum et duos filios eius et quosdam pueros eius."
,"17":"Et fecit deceptionem magnam et reddidit mala pro bonis."
,"18":"Et scripsit haec Ptolemaeus et misit regi, ut mitteret ei exercitum in auxilium et traderet ei civitates et regionem."
,"19":"Et misit alios in Gazaram tollere Ioannem; et tribunis misit epistulas, ut venirent ad se, et daret eis argentum et aurum et dona."
,"20":"Et alios misit occupare Ierusalem et montem templi."
,"21":"Et praecurrens quidam nuntiavit Ioanni in Gazara quia periit pater eius et fratres eius et quia: ' Misit te quoque interfici '."
,"22":"Ut audivit autem, vehementer expavit et comprehendit viros, qui venerant perdere eum, et occidit eos; cognovit enim quia quaerebant eum perdere."
,"23":"Et cetera sermonum Ioannis et bellorum eius et bonarum virtutum, quibus fortiter gessit, et aedificii murorum, quos exstruxit, et rerum gestarum eius,"
,"24":"ecce haec scripta sunt in libro dierum sacerdotii eius, ex quo factus est princeps sacerdotum post patrem suum."
}`)

}
func LA_NVBSE_LoadVH1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Adam, Seth, Enos,"
,"2":"Cainan, Malaleel, Iared,"
,"3":"Henoch, Ma thusala, Lamech,"
,"4":"Noe, Sem, Cham et Iapheth."
,"5":"Filii Iapheth: Gomer, Magog, Madai et Iavan, Thubal, Mosoch, Thiras."
,"6":"Porro filii Gomer: Aschenez et Riphath et Thogorma."
,"7":"Filii autem Iavan: Elisa et Tharsis, Getthim et Rodanim."
,"8":"Filii Cham: Chus et Mesraim, Phut et Chanaan."
,"9":"Filii autem Chus: Saba et Hevila, Sabatha et Regma et Sabathacha. Porro filii Regma: Saba et Dedan."
,"10":"Chus autem genuit Nemrod; iste coepit esse potens in terra."
,"11":"Mesraim vero genuit Ludim et Anamim et Laabim et Nephthuim,"
,"12":"Phetrusim quoque et Chasluim, de quibus egressi sunt Philisthim e Caphtorim."
,"13":"Chanaan vero genuit Sidonem primogenitum, Heth,"
,"14":"Iebusaeum quoque et Amorraeum et Gergesaeum"
,"15":"Hevaeumque et Aracaeum et Sinaeum,"
,"16":"Aradium quoque et Samaraeum et Emathaeum."
,"17":"Filii Sem: Elam et Assur et Arphaxad et Lud et Aram. Filii autem Aram: Us et Hul et Gether et Mes."
,"18":"Arphaxad autem genuit Sala, qui et ipse genuit Heber."
,"19":"Porro Heber nati sunt duo filii: nomen uni Phaleg, quia in diebus eius divisa est terra, et nomen fratris eius Iectan."
,"20":"Iectan autem genuit Elmodad et Saleph et Asarmoth et Iare,"
,"21":"Adoram quoque et Uzal et Decla,"
,"22":"Ebal etiam et Abimael et Saba necnon"
,"23":"et Ophir et Hevila et Iobab; omnes isti filii Iectan."
,"24":"Sem, Arphaxad, Sala,"
,"25":"Heber, Phaleg, Reu,"
,"26":"Seruch, Nachor, Thare,"
,"27":"Abram: iste est Abraham."
,"28":"Filii autem Abraham: Isaac et Ismael."
,"29":"Et hae generationes eorum: primogenitus Ismaelis Nabaioth et Cedar et Adbeel et Mabsam,"
,"30":"Masma et Duma, Massa, Hadad et Thema,"
,"31":"Iethur, Naphis, Cedma; hi sunt filii Ismaelis."
,"32":"Filii autem Ceturae concubinae Abraham, quos genuit: Zamran, Iecsan, Madan, Madian, Iesboc, Sue. Porro filii Iecsan: Saba et Dedan. Filii autem Dedan: Assurim et Latusim et Loommim."
,"33":"Filii autem Madian: Epha et Opher et Henoch et Abida et Eldaa. Omnes hi filii Ceturae."
,"34":"Generavit autem Abraham Isaac, cuius fuerunt filii Esau et Israel."
,"35":"Filii Esau: Eliphaz, Rahuel, Iehus, Ialam, Core."
,"36":"Filii Eliphaz: Theman, Omar, Sepho, Gatham, Cenez, Thamna, Amalec."
,"37":"Filii Rahuel: Nahath, Zara, Samma, Meza."
,"38":"Filii Seir: Lotan, Sobal, Sebeon, Ana, Dison, Eser, Disan."
,"39":"Filii Lotan: Hori, Hemam; soror autem Lotan fuit Thamna."
,"40":"Filii Sobal: Alvan et Manahath et Ebal et Sepho et Onam. Filii Sebeon: Aia et Ana."
,"41":"Filii Ana: Dison. Filii Dison: Hemdan et Eseban et Iethran et Charran."
,"42":"Filii Eser: Bilhan et Zavan et Iacan. Filii Disan: Us et Aran."
,"43":"Isti sunt reges, qui imperaverunt in terra Edom, antequam esset rex super filios Israel: Bela filius Beor, et nomen civitatis eius Denaba."
,"44":"Mortuus est autem Bela, et regnavit pro eo Iobab filius Zarae de Bosra."
,"45":"Cumque et Iobab fuisset mortuus, regnavit pro eo Husam de terra Themanorum."
,"46":"Obiit quoque et Husam, et regnavit pro eo Adad filius Badad, qui percussit Madian in terra Moab; et nomen civitatis eius Avith."
,"47":"Cumque et Adad fuisset mortuus, regnavit pro eo Semla de Masreca."
,"48":"Sed et Semla mortuus est; et regnavit pro eo Saul de Rohoboth, quae iuxta amnem sita est."
,"49":"Mortuo quoque Saul, regnavit pro eo Baalhanan filius Achobor."
,"50":"Sed et hic mortuus est, et regnavit pro eo Adad, cuius urbis fuit nomen Phau; et appellata est uxor eius Meetabel filia Matred filiae Mezaab."
,"51":"Adad autem mortuo, duces pro regibus in Edom esse coeperunt: dux Thamna, dux Alva, dux Ietheth,"
,"52":"dux Oolibama, dux Ela, dux Phinon,"
,"53":"dux Cenez, dux Theman, dux Mabsar,"
,"54":"dux Magdiel, dux Iram. Hi duces Edom."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Filii autem Israel: Ruben, Simeon, Levi, Iuda, Issachar et Zabulon,"
,"2":"Dan, Ioseph, Beniamin, Nephthali, Gad, Aser."
,"3":"Filii Iudae: Her, Onan et Sela; hi tres nati sunt ei de filia Sue Chananitide. Fuit autem Her primogenitus Iudae malus coram Domino, et occidit eum."
,"4":"Thamar autem nurus eius peperit ei Phares et Zara; omnes ergo filii Iudae quinque."
,"5":"Filii autem Phares: Esrom et Hamul."
,"6":"Filii quoque Zarae: Zamri et Ethan et Heman, Chalchol quoque et Darda; simul quinque."
,"7":"Filii Charmi: Achar, qui turbavit Israel et peccavit in furto anathematis."
,"8":"Filii Ethan: Azarias."
,"9":"Filii autem Esrom, qui nati sunt ei: Ierameel et Aram et Chaleb."
,"10":"Porro Aram genuit Aminadab, Aminadab autem genuit Naasson principem filiorum Iudae,"
,"11":"Naasson quoque genuit Salmon, de quo ortus est Booz."
,"12":"Booz vero genuit Obed, qui et ipse genuit Isai."
,"13":"Isai autem genuit primogenitum Eliab, secundum Abinadab, tertium Samma,"
,"14":"quartum Nathanael, quintum Raddai,"
,"15":"sextum Asom, septimum David."
,"16":"Quorum sorores fuerunt: Sarvia et Abigail; filii Sarviae: Abisai, Ioab et Asael, tres."
,"17":"Abigail autem genuit Amasa, cuius pater fuit Iether Ismaelites."
,"18":"Chaleb vero filius Esrom genuit de uxore sua nomine Azuba, de qua nati sunt Ierioth, Ieser et Sobab et Ardon."
,"19":"Cumque mortua fuisset Azuba, accepit uxorem Chaleb Ephratha, quae peperit ei Hur."
,"20":"Porro Hur genuit Uri, et Uri genuit Beseleel."
,"21":"Post haec ingressus est Esrom ad filiam Machir patris Galaad et accepit eam, cum ipse esset annorum sexaginta; quae peperit ei Segub."
,"22":"Sed et Segub genuit Iair, qui possedit viginti tres civitates in terra Galaad."
,"23":"Cepitque Gesur et Aram oppida Iair ipsis et Canath et viculos eius sexaginta civitates. Omnes isti filii Machir patris Galaad."
,"24":"Cum autem mortuus esset Esrom, ingressus est Chaleb ad Ephratha uxorem Esrom patris sui. Habuit quoque Esrom uxorem Abia, quae peperit ei Ashur patrem Thecue."
,"25":"Nati sunt autem filii Ierameel primogeniti Esrom: Ram primogenitus eius et Buna et Aran et Asom et Ahia."
,"26":"Duxit quoque uxorem alteram Ierameel nomine Atara, quae fuit mater Onam."
,"27":"Sed et filii Ram primogeniti Ierameel fuerunt: Moos et Iamin et Acar."
,"28":"Onam autem habuit filios: Sammai et Iada. Filii autem Sammai: Nadab et Abisur."
,"29":"Nomen vero uxoris Abisur Abiail, quae peperit ei Ahobban et Molid."
,"30":"Filii autem Nadab fuerunt Saled et Apphaim; mortuus est autem Saled absque liberis."
,"31":"Filius vero Apphaim: Iesi, qui Iesi genuit Sesan; porro Sesan genuit Oholai."
,"32":"Filii autem Iada fratris Semmei: Iether et Ionathan; sed et Iether mortuus est absque liberis."
,"33":"Porro Ionathan genuit Phaleth et Ziza. Isti fuerunt filii Ierameel."
,"34":"Sesan autem non habuit filios sed filias et servum Aegyptium nomine Ieraa;"
,"35":"deditque ei filiam suam uxorem, quae peperit ei Eththei."
,"36":"Eththei autem genuit Nathan, et Nathan genuit Zabad;"
,"37":"Zabad quoque genuit Ophlal, et Ophlal genuit Obed."
,"38":"Obed genuit Iehu, Iehu genuit Azariam;"
,"39":"Azarias genuit Helles, Helles genuit Elasa."
,"40":"Elasa genuit Sisamoi, Sisamoi genuit Sellum;"
,"41":"Sellum genuit Iecemiam, Iecemias genuit Elisama."
,"42":"Filii autem Chaleb fratris Ierameel: Mesa primogenitus eius, ipse est pater Ziph; et filius eius Maresa pater Hebron."
,"43":"Porro filii Hebron: Core et Thapphua et Recem et Samma;"
,"44":"Samma autem genuit Raham patrem Iercaam, et Recem genuit Sammai."
,"45":"Filius Sammai: Maon, et Maon pater Bethsur."
,"46":"Epha autem concubina Chaleb peperit Charran et Mosa et Gezez; porro Charran genuit Gezez."
,"47":"Filii Iahaddai: Regem et Iotham et Gesan et Phalet et Epha et Saaph."
,"48":"Concubina Chaleb Maacha peperit Saber et Tharana."
,"49":"Genuit autem Saaph pater Madmena Sue patrem Machbena et patrem Gabaa. Filia vero Chaleb fuit Achsa."
,"50":"Hi erant filii Chaleb. Filii Hur primogeniti Ephratha: Sobal pater Cariathiarim, "
,"51":"Salmon pater Bethlehem, Hariph pater Bethgader."
,"52":"Fuerunt autem filii Sobal patris Cariathiarim Raaia, dimidium Manahat"
,"53":"et cognationes Cariathiarim: Iethraei et Phutaei et Sumathaei et Maseraei. Ex his egressi sunt Saraitae et Esthaolitae."
,"54":"Filii Salmon: Bethlehem et Netophathitae, Atarothbethioab et dimidium Manahat de Saraa,"
,"55":"cognationes quoque de Cariathsepher habitantes in Iabes: Therathaei, Semathaei et Suchathaei. Hi sunt Cinaei, qui orti sunt de Ammath patre domus Rechab."
}`)
	CurrentBook.AddChapter(3, `{
"1":"David vero hos habuit filios, qui ei nati sunt in Hebron: primoge nitum Amnon ex Achinoam Iezrahelitide, secundum Daniel de Abigail de Carmel,"
,"2":"tertium Absalom filium Maacha filiae Tholmai regis Gesur, quartum Adoniam filium Haggith,"
,"3":"quintum Saphatiam ex Abital, sextum Iethraam de Egla uxore sua."
,"4":"Sex ergo nati sunt ei in Hebron, ubi regnavit septem annis et sex mensibus. Triginta autem et tribus annis regnavit in Ierusalem."
,"5":"Porro in Ierusalem nati sunt ei filii: Samua et Sobab et Nathan et Salomon, quattuor de Bethsabee filia Ammiel;"
,"6":"Iebahar quoque et Elisama et Eliphalet"
,"7":"et Noga et Napheg et Iaphia"
,"8":"necnon Elisama et Eliada et Eliphalet, novem."
,"9":"Omnes hi filii David absque filiis concubinarum; habueruntque sororem Thamar."
,"10":"Filius autem Salomonis Roboam, cuius Abia filius genuit Asa; de hoc quoque natus est Iosaphat"
,"11":"pater Ioram; qui Ioram genuit Ochoziam, ex quo ortus est Ioas."
,"12":"Et huius Amasias filius genuit Azariam, porro Azariae filius Ioatham"
,"13":"procreavit Achaz patrem Ezechiae, de quo natus est Manasses."
,"14":"Sed et Manasses genuit Amon patrem Iosiae;"
,"15":"filii autem Iosiae fuerunt: primogenitus Iohanan, secundus Ioachim, tertius Sedecias, quartus Sellum."
,"16":"Filii Ioachim: Iechonias filius eius, Sedecias filius eius."
,"17":"Filii Iechoniae captivi fuerunt: Salathiel filius eius,"
,"18":"Melchiram, Phadaia, Senasser et Iecemias, Hosama et Nadabias."
,"19":"De Phadaia orti sunt Zorobabel et Semei. Zorobabel genuit Mosollam, Hananiam et Salomith sororem eorum"
,"20":"Hasabamque et Ohol et Barachiam et Hasadiam, Iosabhesed, quinque."
,"21":"Filii autem Hananiae: Pheltias, Iesaias, Raphaia, Arnan, Abdia et Sechenias."
,"22":"Filii Secheniae: Semeia et Hattus et Igal et Baria et Naaria et Saphat, sex numero."
,"23":"Filii Naariae: Elioenai et Ezechias et Ezricam, tres."
,"24":"Filii Elioenai: Odovia et Eliasib et Pheleia et Accub et Iohanan et Dalaia et Anani, septem."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Filii Iudae: Phares, Esrom et Charmi et Hur et Sobal."
,"2":"Reaia vero filius Sobal genuit Iahath, de quo nati sunt Ahumai et Laad; hae cognationes Saraitarum."
,"3":"Et ista stirps Etam: Iezrahel et Iesema et Iedebos, nomenque sororis eorum Asalelphuni."
,"4":"Phanuel autem pater Gedor et Ezer pater Hosa; isti sunt filii Hur primogeniti Ephratha patris Bethlehem."
,"5":"Ashur vero patris Thecue erant duae uxores: Halaa et Naara."
,"6":"Peperit autem ei Naara Oozam et Hepher et Themani et Ahasthari; isti sunt filii Naara."
,"7":"Porro filii Halaa: Sereth et Sohar et Ethnan."
,"8":"Cos autem genuit Anob et Sobeba et cognationes Aharehel filii Arum."
,"9":"Fuit autem Iabes inclitus prae fratribus suis; et mater eius vocavit nomen illius Iabes dicens: ' Quia peperi eum in dolore '."
,"10":"Invocavit vero Iabes Deum Israel dicens: ' Si benedicens benedixeris mihi et dilataveris terminos meos, et fuerit manus tua mecum, et feceris me a malitia non opprimi! '. Et praestitit Deus quae precatus est."
,"11":"Chelub autem frater Suaa genuit Mahir, qui fuit pater Esthon."
,"12":"Porro Esthon genuit Bethrapha et Phasea et Tehinna patrem Hirnaas (id est urbis Naas); hi sunt viri Recha."
,"13":"Filii autem Cenez: Othoniel et Saraia; porro filii Othoniel: Hathath et Maonathi."
,"14":"Maonathi genuit Ophra, Saraia autem genuit Ioab patrem Geharasim (id est vallis Artificum); ibi quippe artifices erant."
,"15":"Filii vero Chaleb filii Iephonne: Hir et Ela et Naham; filius quoque Ela: Cenez."
,"16":"Filii quoque Iallelel: Ziph et Zipha, Thiria et Asarel."
,"17":"Et filii Ezra: Iether et Mered et Epher et Ialon. Et genuit Iether Mariam et Sammai et Iesba patrem Esthemo."
,"18a":"Hi autem sunt filii Bethiae filiae pharaonis, quam accepit Mered:"
,"18b":"peperit Iared patrem Gedor et Heber patrem Socho et Iecuthiel patrem Zanoa."
,"19":"Filii autem uxoris eius Iudaicae sororis Naham patris Ceilae: Dalaia et Simeon pater Ioman. Filii autem Naham patris Ceilae: Garmitae et Esthemo Maachathitarum."
,"20":"Filii quoque Simon: Ammon et Rinna, Benhanan et Thilon. Et filii Iesi: Zoheth et Benzoheth."
,"21":"Filii Sela filii Iudae: Her pater Lecha et Laada pater Maresa et cognationes domus operantium byssum in Bethasbea"
,"22":"et Iochim virique Chozeba et Ioas et Saraph, qui principes fuerunt in Moab et qui reversi sunt in Bethlehem; hae autem sunt res veteres."
,"23":"Hi sunt figuli habitantes Netaim et Gedera; apud regem in operibus eius commorati sunt ibi."
,"24":"Filii Simeon: Namuel et Iamin, Iarib, Zara, Saul;"
,"25":"Sellum filius eius, Mabsam filius eius, Masma filius eius."
,"26":"Filii Masma: Hamuel filius eius, Zacchur filius eius, Semei filius eius."
,"27":"Filii Semei sedecim et filiae sex; fratres autem eius non habuerunt filios multos, et universa cognatio eorum non potuit adaequare summam filiorum Iudae."
,"28":"Habitaverunt autem in Bersabee et Molada et Asarsual"
,"29":"et in Bilha et in Esem et in Tholad"
,"30":"et in Bathuel et in Horma et in Siceleg"
,"31":"et in Bethmarchaboth et in Asarsusim et in Bethberai et in Saarim; hae civitates eorum usque ad regem David."
,"32":"Villae quoque eorum: Etam et Ain, Remmon et Thochen et Asan, civitates quinque."
,"33":"Et universi viculi eorum per circuitum civitatum istarum usque ad Baal; haec est habitatio eorum et genealogia."
,"34":"Masobab quoque et Iemlech et Iosa filius Amasiae"
,"35":"et Ioel et Iehu filius Iosabiae filii Saraiae filii Asiel"
,"36":"et Elioenai et Iacoba et Isuhaia et Asaia et Adiel et Isimiel et Banaia,"
,"37":"Ziza quoque filius Sephei filii Allon filii Iedaia filii Semri filii Samaia."
,"38":"Isti nominatim inscripti erant principes in cognationibus suis; et familiae eorum expansae sunt vehementer,"
,"39":"et profecti sunt ad introitum Gedor usque ad orientem vallis, ut quaererent pascua gregibus suis."
,"40":"Inveneruntque pascuas uberes et valde bonas et terram latissimam et quietam et fertilem, in qua ante habitaverunt de stirpe Cham."
,"41":"Hi ergo venerunt, qui inscripti erant nominatim, in diebus Ezechiae regis Iudae, et percusserunt tabernacula eorum et Meunitas, qui inventi fuerunt ibi, et deleverunt eos usque in praesentem diem habitaveruntque pro eis, quoniam uberrimas ibidem pascuas reppererunt."
,"42":"De filiis quoque Simeon abierunt in montem Seir viri quingenti habentes principes Pheltiam et Naariam et Raphaiam et Oziel filios Iesi"
,"43":"et percusserunt reliquias, quae evadere potuerant Amalecitarum, et habitaverunt ibi pro eis usque ad diem hanc."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Filii quoque Ruben primogeniti Israel: ipse quippe fuit primoge nitus eius, sed, cum violasset torum patris sui, data sunt primogenita eius filiis Ioseph filii Israel, ut non computaretur in primogenitum,"
,"2":"quia Iuda erat quidem fortissimus inter fratres suos et de stirpe eius principes germinati sunt, primogenita autem reputata sunt Ioseph."
,"3":"Filii ergo Ruben primogeniti Israel: Henoch et Phallu, Hesron et Charmi."
,"4":"Filii Ioel: Semeia filius eius, Gog filius eius, Semei filius eius,"
,"5":"Micha filius eius, Reaia filius eius, Baal filius eius,"
,"6":"Beera filius eius, quem captivum duxit Theglathphalasar rex Assyriorum, et fuit princeps in tribu Ruben."
,"7":"Fratres autem eius in cognationibus eius, quando numerabantur in genealogiis suis, erant: caput Iehiel, deinde Zacharias;"
,"8":"porro Bela filius Azaz filii Samma filii Ioel, ipse habitavit in Aroer usque ad Nabo et Baalmeon."
,"9":"Contra orientalem quoque plagam habitavit usque ad introitum eremi, quae est inde a flumine Euphrate; multum quippe gregum eorum numerus creverat in terra Galaad."
,"10":"In diebus autem Saul proeliati sunt contra Agarenos et interfecerunt illos; habitaveruntque pro eis in tabernaculis eorum in omni plaga, quae respicit ad orientem Galaad."
,"11":"Filii vero Gad e regione eorum habitaverunt in terra Basan usque Salcha:"
,"12":"Ioel in capite et Sapham secundus, porro Ianai et Saphat in Basan;"
,"13":"fratres vero eorum secundum familias suas: Michael et Mosollam et Seba et Iorai et Iachan et Zie et Heber, septem."
,"14":"Hi filii Abihail filii Huri filii Iaroe filii Galaad filii Michael filii Iesesi filii Ieddo filii Buz."
,"15":"Ahi filius Abdiel filii Guni princeps familiarum eorum."
,"16":"Et habitaverunt in Galaad et in Basan et in viculis eius et in cunctis suburbanis Saron usque ad terminos."
,"17":"Omnes hi numerati sunt in diebus Ioatham regis Iudae et in diebus Ieroboam regis Israel."
,"18":"Filii Ruben et Gad et dimidiae tribus Manasse viri bellatores scuta portantes et gladios et tendentes arcum eruditique ad proelia, quadraginta quattuor milia et septingenti sexaginta procedentes ad pugnam;"
,"19":"dimicaverunt contra Agarenos et Ituraeos et Naphisaeos et Nodabaeos."
,"20":"Et datum est eis auxilium, traditique sunt in manus eorum Agareni et universi, qui fuerant cum eis, quia Deum invocaverunt cum proeliarentur, et exaudivit eos, eo quod credidissent in eum."
,"21":"Ceperuntque omnia, quae possederant, camelorum quinquaginta milia et ovium ducenta quinquaginta milia, asinos duo milia et animas hominum centum milia;"
,"22":"vulnerati autem multi corruerunt; fuit enim bellum Domini. Habitaveruntque pro eis usque ad transmigrationem."
,"23":"Filii quoque dimidiae tribus Manasse possederunt terram a Basan usque Baalhermon et Sanir et montem Hermon; ingens quippe numerus erat."
,"24":"Et hi fuerunt principes familiarum eorum: Epher et Iesi et Eliel et Azriel et Ieremia et Odovia et Iediel; viri bellatores fortissimi et nominati, duces in familiis suis."
,"25":"Reliquerunt autem Deum patrum suorum et fornicati sunt post deos populorum terrae, quos abstulit Deus coram eis."
,"26":"Et suscitavit Deus Israel spiritum Phul regis Assyriorum et spiritum Theglathphalasar regis Assur; et transtulit Ruben et Gad et dimidium tribus Manasse et adduxit eos in Hala et Habor et Ara et fluvium Gozan usque ad diem hanc."
,"27":"Filii Levi: Gerson, Caath, Merari."
,"28":"Filii Caath: Amram, Isaar, Hebron et Oziel."
,"29":"Filii Amram: Aaron, Moyses et Maria. Filii Aaron: Nadab et Abiu, Eleazar et Ithamar."
,"30":"Eleazar genuit Phinees, et Phinees genuit Abisue;"
,"31":"Abisue vero genuit Bocci, et Bocci genuit Ozi."
,"32":"Ozi genuit Zaraiam, et Zaraias genuit Meraioth,"
,"33":"porro Meraioth genuit Amariam, et Amarias genuit Achitob;"
,"34":"Achitob genuit Sadoc, Sadoc genuit Achimaas,"
,"35":"Achimaas genuit Azariam, Azarias genuit Iohanan;"
,"36":"Iohanan genuit Azariam: ipse est qui sacerdotio functus est in domo, quam aedificavit Salomon in Ierusalem."
,"37":"Genuit autem Azarias Amariam, et Amarias genuit Achitob,"
,"38":"Achitob genuit Sadoc, et Sadoc genuit Sellum;"
,"39":"Sellum genuit Helciam, et Helcias genuit Azariam."
,"40":"Azarias genuit Saraiam, et Saraias genuit Iosedec;"
,"41":"porro Iosedec egressus est, quando transtulit Dominus Iudam et Ierusalem per manus Nabuchodonosor."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Filii ergo Levi: Gerson, Caath et Merari."
,"2":"Et haec nomina filio rum Gerson: Lobni et Semei."
,"3":"Filii Caath: Amram et Isaar et Hebron et Oziel."
,"4":"Filii Merari: Moholi et Musi. Hae autem cognationes Levi secundum familias eorum: "
,"5":"Gerson, Lobni filius eius, Iahath filius eius, Zimma filius eius,"
,"6":"Ioah filius eius, Addo filius eius, Zara filius eius, Iethrai filius eius."
,"7":"Filii Caath: Aminadab filius eius, Core filius eius, Asir filius eius,"
,"8":"Elcana filius eius, Abiasaph filius eius, Asir filius eius,"
,"9":"Thahath filius eius, Uriel filius eius, Ozias filius eius, Saul filius eius."
,"10":"Filii Elcana: Amasai et Achimoth,"
,"11":"Elcana filius eius, Sophai filius eius, Nahath filius eius,"
,"12":"Eliab filius eius, Ieroham filius eius, Elcana filius eius, Samuel filius eius."
,"13":"Filii Samuel: primogenitus Ioel et secundus Abia."
,"14":"Filii autem Merari: Moholi, Lobni filius eius, Semei filius eius, Oza filius eius,"
,"15":"Samaa filius eius, Haggia filius eius, Asaia filius eius."
,"16":"Isti sunt, quos constituit David super cantum domus Domini, ex quo collocata est arca;"
,"17":"et ministrabant coram habitatione tabernaculi conventus canentes, donec aedificaret Salomon domum Domini in Ierusalem; stabant autem iuxta ordinem suum in ministerio."
,"18":"Hi vero sunt, qui assistebant cum filiis suis. De filiis Caath: Heman cantor filius Ioel filii Samuel"
,"19":"filii Elcana filii Ieroham filii Eliel filii Thohu"
,"20":"filii Suph filii Elcana filii Mahath filii Amasai"
,"21":"filii Elcana filii Ioel filii Azariae filii Sophoniae"
,"22":"filii Thahath filii Asir filii Abiasaph filii Core"
,"23":"filii Isaar filii Caath filii Levi filii Israel."
,"24":"Et frater eius Asaph, qui stabat a dextris eius, Asaph filius Barachiae filii Samaa"
,"25":"filii Michael filii Basaiae filii Melchiae"
,"26":"filii Athnai filii Zara filii Adaia"
,"27":"filii Ethan filii Zimma filii Semei"
,"28":"filii Iahath filii Gerson filii Levi."
,"29":"Filii autem Merari fratres eorum ad sinistram: Ethan filius Cusi filii Abdi filii Melluch"
,"30":"filii Hasabiae filii Amasiae filii Helciae"
,"31":"filii Amsi filii Bani filii Somer"
,"32":"filii Moholi filii Musi filii Merari filii Levi."
,"33":"Fratres quoque eorum Levitae, qui ordinati sunt in cunctum ministerium habitaculi domus Domini;"
,"34":"Aaron vero et filii eius adolebant super altare holocausti et super altare thymiamatis in omne opus sancti sanctorum, et ut expiarent pro Israel, iuxta omnia quae praecepit Moyses servus Dei."
,"35":"Hi sunt autem filii Aaron: Eleazar filius eius, Phinees filius eius, Abisue filius eius,"
,"36":"Bocci filius eius, Ozi filius eius, Zaraia filius eius,"
,"37":"Meraioth filius eius, Amarias filius eius, Achitob filius eius,"
,"38":"Sadoc filius eius, Achimaas filius eius."
,"39":"Et haec habitacula eorum per castra atque confinia, filiorum scilicet Aaron ex cognatione Caathitarum; ipsis enim sorte contigerat."
,"40":"Dederunt igitur eis Hebron in terra Iudae et suburbana eius per circuitum;"
,"41":"agros autem civitatis et villas Chaleb filio Iephonne."
,"42":"Porro filiis Aaron dederunt civitatem ad confugiendum: Hebron et Lobna et suburbana eius,"
,"43":"Iether quoque et Esthemo cum suburbanis eius, sed et Helon et Dabir cum suburbanis suis,"
,"44":"Asan quoque et Iutta et Bethsames et suburbana earum;"
,"45":"de tribu autem Beniamin: Gabaon et Gabaa et suburbana earum et Almath cum suburbanis suis, Anathoth quoque cum suburbanis suis: omnes civitates tredecim, singulae per cognationes suas."
,"46":"Filiis autem Caath residuis de cognatione sua dederunt ex tribu Ephraim et ex tribu Dan et ex dimidia tribu Manasse in possessionem urbes decem."
,"47":"Porro filiis Gerson per cognationes suas de tribu Issachar et de tribu Aser et de tribu Nephthali et de tribu Manasse in Basan urbes tredecim."
,"48":"Filiis autem Merari per cognationes suas de tribu Ruben et de tribu Gad et de tribu Zabulon dederunt sorte civitates duodecim."
,"49":"Dederunt quoque filii Israel Levitis civitates et suburbana earum;"
,"50":"dederuntque per sortem ex tribu filiorum Iudae et ex tribu filiorum Simeon et ex tribu filiorum Beniamin urbes has, quas vocaverunt nominibus suis."
,"51":"Et his, qui erant ex cognationibus filiorum Caath, fuerunt civitates in terminis eorum de tribu Ephraim."
,"52":"Dederunt ergo eis urbem ad confugiendum: Sichem cum suburbanis suis in monte Ephraim et Gazer cum suburbanis suis,"
,"53":"Iecmaam quoque cum suburbanis suis et Bethoron similiter;"
,"54":"necnon et Aialon cum suburbanis suis et Gethremmon in eundem modum."
,"55":"Porro ex dimidia tribu Manasse Thanach et suburbana eius, Ieblaam et suburbana eius, his videlicet qui de cognationibus filiorum Caath reliqui erant."
,"56":"Filiis autem Gerson de cognationibus dimidiae tribus Manasse: Golan in Basan et suburbana eius et Astharoth cum suburbanis suis."
,"57":"De tribu Issachar Cedes et suburbana illius et Dabereth cum suburbanis suis,"
,"58":"Ramoth quoque et suburbana illius et Anem cum suburbanis suis."
,"59":"De tribu vero Aser: Masal cum suburbanis suis et Abdon similiter,"
,"60":"Hucoc quoque et suburbana eius et Rohob cum suburbanis suis."
,"61":"Porro de tribu Nephthali: Cedes in Galilaea et suburbana eius, Hamon cum suburbanis suis et Cariathaim et suburbana eius."
,"62":"Filiis autem Merari residuis de tribu Zabulon: Remmon et suburbana eius et Thabor cum suburbanis suis."
,"63":"Trans Iordanem quoque ex adverso Iericho, contra orientem Iordanis de tribu Ruben: Bosor in solitudine cum suburbanis suis et Iasa cum suburbanis suis,"
,"64":"Cademoth quoque et suburbana eius et Mephaath cum suburbanis suis."
,"65":"Necnon et de tribu Gad: Ramoth in Galaad et suburbana eius et Mahanaim cum suburbanis suis,"
,"66":"sed et Hesebon cum suburbanis eius, et Iazer cum suburbanis suis."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Porro filii Issachar: Thola et Phua, Iasub et Semron, quat tuor."
,"2":"Filii Thola: Ozi et Raphaia et Ieriel et Iemai et Iebsem et Samuel, principes familiarum suarum; de stirpe Thola viri fortissimi numerati sunt iuxta genealogias suas in diebus David viginti duo milia sescenti."
,"3":"Filii Ozi: Izrahia, de quo nati sunt Michael et Obadia et Ioel et Iesia, quinque principes omnes."
,"4":"Cumque eis erant secundum genealogias familiarum suarum turmae accinctae ad proelium, viri fortissimi, triginta sex milia; multas enim habuere uxores et filios."
,"5":"Fratresque eorum per omnes cognationes Issachar robustissimi ad pugnandum octoginta septem milia numerati sunt."
,"6":"Filii Beniamin: Bela et Bochor et Iedihel, tres."
,"7":"Filii Bela: Esebon et Ozi et Oziel et Ierimoth et Urai, quinque principes familiarum et ad pugnandum robustissimi; numerus autem eorum viginti duo milia et triginta quattuor."
,"8":"Porro filii Bochor: Zamira et Ioas et Eliezer et Elioenai et Amri et Ierimoth et Abia et Anathoth et Almath; omnes hi filii Bochor."
,"9":"Numerati sunt autem in genealogiis suis principes familiarum suarum ad bella fortissimi viginti milia et ducenti."
,"10":"Porro filii Iedihel: Bilhan; filii autem Bilhan: Iehus et Beniamin et Aod et Chanaana et Zethan et Tharsis et Ahisahar;"
,"11":"omnes hi filii Iedihel principes familiarum suarum viri fortissimi decem et septem milia et ducenti ad proelium procedentes."
,"12":"Suphim quoque et Huphim filii Hir et Husim filii Aher."
,"13":"Filii autem Nephthali: Iasiel et Guni et Ieser et Sellum, filii Bilhae."
,"14":"Porro filius Manasse: Asriel, quem peperit concubina eius Syra; peperit quoque Machir patrem Galaad."
,"15":"Machir autem accepit uxorem de Huphim et Suphim et habuit sororem nomine Maacha; nomen autem secundi Salphaad, nataeque sunt Salphaad filiae."
,"16":"Et peperit Maacha uxor Machir filium vocavitque nomen eius Phares; porro nomen fratris eius Sares et filii eius Ulam et Recem."
,"17":"Filius autem Ulam: Badan; hi sunt filii Galaad filii Machir filii Manasse."
,"18":"Soror autem eius Ammalecheth peperit Isod et Abiezer et Maala."
,"19":"Erant autem filii Semida: Ahin et Sechem et Leci et Aniam."
,"20":"Filii autem Ephraim: Suthala, Bared filius eius, Thahath filius eius, Elada filius eius, Thahath filius eius,"
,"21":"et huius filius Zabad et huius filius Suthala et huius filius Ezer et Elad. Occiderunt autem eos viri Geth indigenae, quia descenderant, ut invaderent possessiones eorum."
,"22":"Luxit igitur Ephraim pater eorum multis diebus, et venerunt fratres eius, ut consolarentur eum;"
,"23":"ingressusque est ad uxorem suam, quae concepit et peperit filium, et vocavit nomen eius Beria, eo quod in malis domus eius ortus esset."
,"24":"Filia autem eius fuit Sara, quae aedificavit Bethoron inferiorem et superiorem et Ozensara."
,"25":"Porro filius eius Rapha et Reseph et Thale filius eius, de quo natus est Thaan,"
,"26":"qui genuit Laadan; huius quoque filius Ammiud genuit Elisama,"
,"27":"de quo ortus est Nun, qui habuit filium Iosue."
,"28":"Possessio autem eorum et habitationes: Bethel cum filiabus suis et contra orientem Noran, ad occidentalem plagam Gazer et filiae eius, Sichem quoque cum filiabus suis usque Hai et filias eius."
,"29":"Iuxta filios quoque Manasse: Bethsan et filias eius, Thanach et filias eius, Mageddo et filias eius, Dor et filias eius. In his habitaverunt filii Ioseph filii Israel."
,"30":"Filii Aser: Iemna et Iesua et Isui et Beria et Sara soror eorum."
,"31":"Filii autem Beria: Heber et Melchiel, ipse est pater Barzaith."
,"32":"Heber autem genuit Iephlat et Somer et Hotham et Suaa sororem eorum."
,"33":"Filii Iephlat: Phosech et Bamaal et Asoth; hi filii Iephlat."
,"34":"Porro filii Somer fratris sui: Roaga et Haba et Aram."
,"35":"Filii autem Hotham fratris eius: Supha et Iemna et Selles et Amal."
,"36":"Filii Supha: Sue, Hamapher et Sual et Beri et Iamra,"
,"37":"Bosor et Od et Samma et Salusa et Iethran et Beera."
,"38":"Filii Iether: Iephonne et Phaspha et Ara."
,"39":"Filii autem Olla: Area et Hanniel et Resia."
,"40":"Omnes hi filii Aser, principes familiarum electi atque fortissimi, capita principum; numerus autem eorum, qui inscripti erant in exercitu ad bellum, viginti sex milia."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Beniamin autem genuit Bela primogenitum suum, Asbel se cundum, Ahara tertium,"
,"2":"Nohaa quartum et Rapha quintum."
,"3":"Fueruntque filii Bela: Addar et Gera pater Aod,"
,"4":"Abisue quoque et Naaman et Ahoe,"
,"5":"sed et Gera et Sephuphan et Huram."
,"6":"Hi sunt filii Aod principes familiarum habitantium in Gabaa, qui translati sunt in Manahath;"
,"7":"Naaman autem et Ahia et Gera: ipse transtulit eos et genuit Oza et Ahiud."
,"8":"Porro Saharaim genuit in regione Moab, postquam dimisit Husim et Bara uxores suas;"
,"9":"genuit autem de Hodes uxore sua Iobab et Sebia et Mesa et Melcham,"
,"10":"Iehus quoque et Sechia et Marma; hi sunt filii eius principes in familiis suis."
,"11":"De Husim vero genuit Abitob et Elphaal;"
,"12":"porro filii Elphaal Heber et Misaam et Samad; hic aedificavit Ono et Lod et filias eius."
,"13":"Beria autem et Samma principes familiarum habitantium in Aialon; hi fugaverunt habitatores Geth."
,"14":"Et Ahi et Sesac et Ierimoth"
,"15":"et Zabadia et Arad et Eder,"
,"16":"Michael quoque et Iespha et Ioha filii Beria."
,"17":"Et Zabadia et Mosollam et Hezeci et Heber"
,"18":"et Iesamari et Iezlia et Iobab filii Elphaal"
,"19":"et Iacim et Zechri et Zabdi"
,"20":"et Elioenai et Selethai et Eliel"
,"21":"et Adaia et Baraia et Samarath filii Semei"
,"22":"et Iesphan et Heber et Eliel"
,"23":"et Abdon et Zechri et Hanan"
,"24":"et Hanania et Elam et Anathothia"
,"25":"et Iephdaia et Phanuel filii Sesac."
,"26":"Et Samsari et Sohoria et Otholia"
,"27":"et Iersia et Elia et Zechri filii Ieroham."
,"28":"Hi capita familiarum secundum genealogias, principes qui habitaverunt in Ierusalem."
,"29":"In Gabaon autem habitaverunt Iehiel pater Gabaon, et nomen uxoris eius Maacha,"
,"30":"filiusque eius primogenitus Abdon et Sur et Cis et Baal et Ner et Nadab,"
,"31":"Gedor quoque et Ahio et Zacher et Macelloth;"
,"32":"et Macelloth genuit Samaa. Habitaveruntque ex adverso fratrum suorum in Ierusalem cum fratribus suis."
,"33":"Ner autem genuit Cis, et Cis genuit Saul. Porro Saul genuit Ionathan et Melchisua et Abinadab et Isbaal."
,"34":"Filius autem Ionathan Meribbaal, et Meribbaal genuit Micha;"
,"35":"filii Micha Phithon et Melech et Tharaa et Ahaz."
,"36":"Et Ahaz genuit Ioada, et Ioada genuit Almath et Azmaveth et Zamri; porro Zamri genuit Mosa."
,"37":"Et Mosa genuit Banaa, cuius filius fuit Raphaia, de quo ortus est Elasa, qui genuit Asel."
,"38":"Porro Asel sex filii fuere his nominibus: Ezricam primogenitus eius, Ismael, Saria, Azarias, Obdia et Hanan; omnes hi filii Asel."
,"39":"Filii autem Esec fratris eius: Ulam primogenitus et Iehus secundus et Eliphalet tertius."
,"40":"Fueruntque filii Ulam viri robustissimi ad bellum et magno robore tendentes arcum et multos habentes filios ac nepotes usque ad centum quinquaginta. Omnes hi filii Beniamin."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Universus ergo Israel dinume ratus est, et summa eorum scrip ta est in libro regum Israel et Iudae. Translatique sunt in Babylonem propter delictum suum."
,"2":"Qui autem habitaverunt primi in possessionibus et in urbibus suis: Israel et sacerdotes et Levitae et Nathinaei."
,"3":"Commorati sunt in Ierusalem de filiis Iudae et de filiis Beniamin, de filiis quoque Ephraim et Manasse."
,"4":"Uthai filius Ammiud filii Amri filii Imri filii Bani: de filiis Phares filii Iudae;"
,"5":"et de Selanitis: Asaia primogenitus et filii eius;"
,"6":"de filiis autem Zara: Iehuel et fratres eorum sescenti nonaginta."
,"7":"Porro de filiis Beniamin: Sallu filius Mosollam filii Odovia filii Asana"
,"8":"et Iobania filius Ieroham et Ela filius Ozi filii Mochori et Mosollam filius Saphatiae filii Rahuel filii Iebaniae"
,"9":"et fratres eorum secundum genealogias suas nongenti quinquaginta sex; omnes hi principes familiarum secundum familias suas."
,"10":"De sacerdotibus autem: Iedaia, Ioiarib et Iachin,"
,"11":"Azarias quoque filius Helciae filii Mosollam filii Sadoc filii Meraioth filii Achitob principes domus Dei."
,"12":"Porro Adaias filius Ieroham filii Phassur filii Melchiae et Maasai filius Adiel filii Iezra filii Mosollam filii Mosollamoth filii Emmer,"
,"13":"fratres quoque eorum principes per familias suas mille septingenti sexaginta, fortissimi robore ad faciendum opus ministerii in domo Dei."
,"14":"De Levitis autem: Semeia filius Hassub filii Ezricam filii Hasabia de filiis Merari;"
,"15":"Bacbacar quoque, Hares et Galal et Matthania filius Micha filii Zechri filii Asaph"
,"16":"et Abdia filius Semeiae filii Galal filii Idithun et Barachia filius Asa filii Elcana, qui habitavit in atriis Netophathitarum."
,"17":"Ianitores autem: Sellum et Accub et Telmon et Ahiman; et frater eorum Sellum princeps"
,"18":"et usque ad hoc tempus est in porta regis ad orientem. Hi erant ianitores castris filiorum Levi."
,"19":"Sellum vero filius Core filii Abiasaph filii Core cum fratribus suis de domo patris sui: hi Coritae erant super opera ministerii custodes liminum tabernaculi; patres autem eorum super castra Domini custodiebant introitum,"
,"20":"et Phinees filius Eleazari princeps erat super eos olim - Dominus sit cum eo! -"
,"21":"Zacharias filius Mosollamia ianitor portae tabernaculi conventus."
,"22":"Omnes hi electi in ostiarios liminum ducenti duodecim, et descripti in villis propriis, quos constituerunt David et Samuel videns in munus perpetuum,"
,"23":"tam ipsos quam filios eorum in ostiis domus Domini, domus tabernaculi, in custodias."
,"24":"Per quattuor ventos erant ostiarii, id est ad orientem et ad occidentem, ad aquilonem et ad austrum."
,"25":"Fratres autem eorum in viculis suis morabantur et veniebant per septem dies de tempore usque ad tempus, ut essent cum illis."
,"26":"Nam munus habebant perpetuum hi quattuor principes ianitorum. Hi scilicet Levitae erant super exedras et thesauros domus Domini;"
,"27":"per gyrum quoque templi Domini pernoctabant in custodiis suis, ut et ipsi mane aperirent fores."
,"28":"De horum genere erant et super vasa ministerii, ad numerum enim et inferebantur vasa et efferebantur;"
,"29":"de ipsis et, qui credita habebant utensilia et omnia utensilia sancta, praeerant similae et vino et oleo et turi et aromatibus."
,"30":"Filii quidam autem sacerdotum unguenta ex aromatibus conficiebant;"
,"31":"et Matthathias Levites, primogenitus Sellum Coritae, munere perpetuo praefectus erat eorum, quae in sartagine frigebantur."
,"32":"Porro de filiis Caath fratribus eorum super panes erant propositionis, ut semper novos per singula sabbata praepararent."
,"33":"Hi sunt cantores, principes per familias Levitarum, qui in exedris vacantes morabantur, ita ut die et nocte iugiter suo ministerio deservirent."
,"34":"Hi sunt capita Levitarum per familias suas secundum genealogias suas principes; hi habitaverunt in Ierusalem."
,"35":"In Gabaon autem commorati sunt pater Gabaon Iehiel, et nomen uxoris eius Maacha."
,"36":"Filius primogenitus eius Abdon et Sur et Cis et Baal et Ner et Nadab,"
,"37":"Gedor quoque et Ahio et Zacharias et Macelloth."
,"38":"Porro Macelloth genuit Samaam; isti habitaverunt e regione fratrum suorum in Ierusalem cum fratribus suis."
,"39":"Ner autem genuit Cis, et Cis genuit Saul. Et Saul genuit Ionathan et Melchisua et Abinadab et Isbaal."
,"40":"Filius autem Ionathan Meribbaal, et Meribbaal genuit Micha;"
,"41":"porro filii Micha: Phithon et Melech et Tharaa et Ahaz."
,"42":"Ahaz autem genuit Iara, et Iara genuit Almath et Azmaveth et Zamri; Zamri autem genuit Mosa."
,"43":"Mosa vero genuit Banaa, cuius filius Raphaia genuit Elasa, de quo ortus est Asel."
,"44":"Porro Asel sex filios habuit his nominibus: Ezricam primogenitus eius, Ismael, Saria, Azarias, Obdia, Hanan; hi filii Asel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Philisthim autem pugnabant contra Israel, fugeruntque viri Israel a facie Philisthim et ceciderunt vulnerati in monte Gelboe;"
,"2":"cumque appropinquassent Philisthaei persequentes Saul et filios eius, percusserunt Ionathan et Abinadab et Melchisua filios Saul."
,"3":"Et aggravatum est proelium contra Saul, inveneruntque eum sagittarii et vulneraverunt iaculis;"
,"4":"et dixit Saul ad armigerum suum: ' Evagina gladium tuum et interfice me, ne forte veniant incircumcisi isti et illudant mihi '. Noluit autem armiger eius hoc facere timore perterritus. Arripuit igitur Saul ensem et irruit in eum;"
,"5":"quod cum vidisset armiger eius, videlicet mortuum esse Saul, irruit etiam ipse in gladium suum et mortuus est."
,"6":"Interiit ergo Saul et tres filii eius; omnis domus illius pariter concidit."
,"7":"Quod cum vidissent omnes viri Israel, qui habitabant in campestribus, quod fugissent, et mortui essent Saul et filii eius, dereliquerunt urbes suas et huc illucque dispersi sunt; veneruntque Philisthim et habitaverunt in eis."
,"8":"Die igitur altero venerunt Philisthim, ut spoliarent interfectos, et invenerunt Saul et filios eius iacentes in monte Gelboe;"
,"9":"cumque spoliassent eum et amputassent caput armisque nudassent, miserunt in terram suam per circuitum, ut annuntiaretur in idolorum templis et in populis."
,"10":"Arma autem eius consecraverunt in fano Astharoth et caput affixerunt in templo Dagon."
,"11":"Hoc cum audissent viri Iabes Galaad, omnia scilicet quae Philisthim fecerunt super Saul,"
,"12":"consurrexerunt omnes viri fortes et tulerunt cadavera Saul et filiorum eius attuleruntque ea in Iabes et sepelierunt ossa eorum subter quercum, quae erat in Iabes, et ieiunaverunt septem diebus."
,"13":"Mortuus est ergo Saul propter iniquitatem suam, eo quod praevaricatus sit mandatum Domini, quod praeceperat, et non custodierit illud, sed insuper etiam pythonissam consuluerit"
,"14":"nec quaesierit Dominum; propter quod et interfecit eum et transtulit regnum eius ad David filium Isai."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Congregatus est igitur omnis Israel ad David in Hebron dicens: ' Os tuum sumus et caro tua."
,"2":"Heri quoque et nudiustertius, cum adhuc regnaret Saul, tu eras qui educebas et introducebas Israel; tibi enim dixit Dominus Deus tuus: 'Tu pasces populum meum Israel et tu eris princeps super eum' '."
,"3":"Venerunt ergo omnes maiores natu Israel ad regem in Hebron, et iniit David cum eis foedus in Hebron coram Domino; unxeruntque eum regem super Israel iuxta sermonem Domini, quem locutus est in manu Samuel."
,"4":"Abiit quoque David et omnis Israel in Ierusalem, haec est Iebus, ubi erant Iebusaei habitatores terrae."
,"5":"Dixeruntque, qui habitabant in Iebus, ad David: ' Non ingredieris huc '. Porro David cepit arcem Sion, quae est civitas David;"
,"6":"dixitque: ' Omnis, qui percusserit Iebusaeum, in primis erit princeps et dux '. Ascendit igitur primus Ioab filius Sarviae et factus est princeps."
,"7":"Habitavit autem David in arce, et idcirco appellata est civitas David."
,"8":"Aedificavitque urbem in circuitu a Mello usque ad gyrum; Ioab autem reliqua urbis instauravit."
,"9":"Proficiebatque David vadens et crescens, et Dominus exercituum erat cum eo."
,"10":"Hi principes virorum fortium David, qui adiuverunt eum, ut rex fieret super omnem Israel iuxta verbum Domini, quod locutus est ad Israel;"
,"11":"et iste numerus robustorum David: Iesbaam filius Hachamon filius Hachamonitis princeps inter triginta; iste levavit hastam suam super trecentos, quos occidit impetu uno."
,"12":"Et post eum Eleazar filius Dodo Ahohites, qui erat inter tres potentes;"
,"13":"iste fuit cum David in Aphesdommim, quando Philisthim congregati sunt ad locum illum in proelium. Et erat ager regionis illius plenus hordeo, fugeratque populus a facie Philisthinorum."
,"14":"Hic stetit in medio agri et defendit eum; cumque percussisset Philisthaeos, dedit Dominus salutem magnam populo suo."
,"15":"Descenderunt autem tres de triginta principibus ad petram, in qua erat David, ad speluncam Odollam, quando Philisthim fuerant castrametati in valle Raphaim."
,"16":"Porro David erat in praesidio, et statio Philisthinorum in Bethlehem;"
,"17":"desideravit igitur David et dixit: ' O si quis daret mihi aquam de cisterna Bethlehem, quae est in porta! '."
,"18":"Tres ergo isti per media castra Philisthinorum perrexerunt et hauserunt aquam de cisterna Bethlehem, quae erat in porta, et attulerunt ad David, ut biberet. Qui noluit, sed magis libavit illam Domino"
,"19":"dicens: ' Avertat a me Deus meus, ut hoc faciam et sanguinem virorum istorum bibam, quia in periculo animarum suarum attulerunt mihi aquam '. Et ob hanc causam noluit bibere. Haec fecerunt tres robustissimi."
,"20":"Abisai quoque frater Ioab; ipse erat princeps inter triginta et ipse levavit hastam suam contra trecentos, quos interfecit, et ipse erat inter tres nominatus,"
,"21":"inter triginta duplici honore eminens et princeps eorum; verumtamen usque ad tres non pervenerat."
,"22":"Banaias filius Ioiadae vir robustissimus, qui multa opera perpetrarat, de Cabseel; ipse percussit duos Ariel de Moab et ipse descendit et interfecit leonem in media cisterna tempore nivis."
,"23":"Et ipse percussit virum Aegyptium, cuius statura erat quinque cubitorum, et habebat lanceam ut liciatorium texentium; descendit ergo ad eum cum virga et rapuit hastam, quam tenebat manu, et interfecit eum hasta sua."
,"24":"Haec fecit Banaias filius Ioiadae, qui erat inter tres robustos nominatus,"
,"25":"inter triginta primus; verumtamen ad tres usque non pervenerat, posuit autem eum David super satellites suos."
,"26":"Porro fortissimi in exercitu: Asael frater Ioab et Elchanan filius Dodo de Bethlehem,"
,"27":"Sammoth Harodites, Elica Harodites, Heles Phalonites,"
,"28":"Hira filius Acces Thecuites, Abiezer Anathothites,"
,"29":"Sobbochai Husathites, Ilai Ahohites,"
,"30":"Maharai Netophathites, Heled filius Baana Netophathites,"
,"31":"Ithai filius Ribai de Gabaa filiorum Beniamin, Banaia Pharathonites,"
,"32":"Hurai de tor rentibus Gaas, Abiel Arbathites,"
,"33":"Azmaveth Bahurimites, Eliaba Saalbonites,"
,"34":"Asem Gezonites, Ionathan filius Sage Ararites,"
,"35":"Ahiam filius Sachar Ararites, Eliphal filius Ur,"
,"36":"Hepher Mecherathites, Ahia Phelonites,"
,"37":"Hesro de Carmel, Naarai filius Azbai,"
,"38":"Ioel frater Nathan, Mibahar filius Agarai,"
,"39":"Selec Ammonites, Naharai Berothites armiger Ioab filii Sarviae,"
,"0":"Hira Iethraeus, Gareb Iethraeus,"
,"41":"Urias Hetthaeus, Zabad filius Oholai,"
,"42":"Adina filius Siza Rubenites princeps Rubenitarum, et cum eo triginta;"
,"43":"Hanan filius Maacha et Iosaphat Matthanites,"
,"44":"Ozia Astharothites, Sama et Iehiel filii Hotham Aroerites,"
,"45":"Iedihel filius Semri et Ioha frater eius Thosaites,"
,"46":"Eliel Mahumites et Ieribai et Iosaia filii Elnaem et Iethma Moabites,"
,"47":"Eliel et Obed et Iasiel de Soba."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Hi quoque venerunt ad Da vid in Siceleg, cum adhuc fu geret Saul filium Cis; qui erant fortissimi et egregii pugnatores"
,"2":"tendentes arcum et utraque manu fundis saxa iacientes et dirigentes sagittas. De fratribus Saul ex Beniamin:"
,"3":"princeps Ahiezer et Ioas filii Samaa Gabaathites et Iaziel et Phalet filii Azmaveth et Baracha et Iehu Anathothites;"
,"4":"Iesmaias quoque Gabaonites fortissimus inter triginta et super triginta,"
,"5":"Ieremias et Iahaziel et Iohanan et Iozabad Gederothites,"
,"6":"Eluzai et Ierimoth et Baalia et Samaria et Saphatia Haruphites,"
,"7":"Elcana et Iesia et Azareel et Ioezer et Iesbaam Coritae,"
,"8":"Ioela quoque et Zabadia filii Ieroham de Gedor."
,"9":"Sed et de Gad transfugerunt ad David, cum lateret in deserto, viri robustissimi et pugnatores optimi tenentes clipeum et hastam; facies eorum quasi facies leonis et veloces quasi capreae in montibus:"
,"10":"Ezer princeps, Abdias secundus, Eliab tertius,"
,"11":"Masmana quartus, Ieremias quintus,"
,"12":"Etthei sextus, Eliel septimus,"
,"13":"Iohanan octavus, Elzebad nonus,"
,"14":"Ieremias decimus, Machbanai undecimus."
,"15":"Hi de filiis Gad principes exercitus, minimus contra centum praevalebat et maximus contra mille."
,"16":"Isti sunt qui transierunt Iordanem mense primo, quando inundare consuevit super ripas suas, et omnes fugaverunt, qui morabantur in vallibus ad orientalem plagam et occidentalem."
,"17":"Venerunt autem et de Beniamin et de Iuda ad praesidium, in quo morabatur David."
,"18":"Egressusque est David obviam eis et ait: ' Si pacifice venistis ad me, ut auxiliemini mihi, cor meum iungatur vobis; si autem insidiamini mihi pro adversariis meis, cum ego iniquitatem in manibus non habeam, videat Deus patrum nostrorum et iudicet '."
,"19":"Spiritus vero induit Amasai principem inter triginta, et ait: ' Tui sumus, o David, et tecum, fili Isai!,Pax, pax tibi,et pax adiutoribus tuis; te enim adiuvat Deus tuus '. Suscepit ergo eos David et constituit principes turmae."
,"20":"Porro de Manasse transfugerunt ad David, quando veniebat cum Philisthim adversus Saul, ut pugnaret; et non dimicavit cum eis, quia inito consilio remiserunt eum principes Philisthinorum dicentes: ' Periculo capitis nostri revertetur ad dominum suum Saul '."
,"21":"Quando igitur reversus est in Siceleg, transfugerunt ad eum de Manasse Ednas et Iozabad et Iedihel et Michael et Iozabad et Eliu et Selathai principes milium in Manasse:"
,"22":"hi praebuerunt auxilium David adversus latrunculos; omnes enim erant viri fortissimi et facti sunt principes in exercitu."
,"23":"Sed et per singulos dies veniebant ad David ad auxiliandum ei, usque dum fieret grandis numerus quasi exercitus Dei."
,"24":"Iste quoque est numerus principum exercitus, qui venerunt ad David, cum esset in Hebron, ut transferrent regnum Saul ad eum iuxta verbum Domini."
,"25":"Filii Iudae portantes clipeum et hastam sex milia octingenti expediti ad proelium."
,"26":"De filiis Simeon virorum fortissimorum ad pugnandum septem milia centum."
,"27":"De filiis Levi quattuor milia sescenti;"
,"28":"Ioiada quoque princeps de stirpe Aaron et cum eo tria milia septingenti;"
,"29":"Sadoc etiam iuvenis fortissimus et familia eius principes viginti duo."
,"30":"De filiis autem Beniamin fratribus Saul tria milia; magna enim pars eorum adhuc sequebatur domum Saul."
,"31":"Porro de filiis Ephraim viginti milia octingenti, fortissimi robore viri nominati in familiis suis."
,"32":"Et ex dimidia parte tribus Manasse decem et octo milia; singuli per nomina sua destinati, ut venirent et constituerent regem David."
,"33":"De filiis quoque Issachar viri eruditi, qui norant singula tempora ad sciendum quid facere deberet Israel, principes ducenti et omnes fratres eorum ad iussa eorum."
,"34":"Porro de Zabulon, qui egrediebantur ad proelium et stabant in acie instructi omnibus armis bellicis, quinquaginta milia venerunt, ut congregarentur non in corde duplici."
,"35":"Et de Nephthali principes mille; et cum eis instructa clipeo et hasta triginta septem milia."
,"36":"De Dan etiam praeparata ad proelium viginti octo milia sescenti."
,"37":"Et de Aser egredientes ad pugnam et in acie procedentes quadraginta milia."
,"38":"Trans Iordanem autem de filiis Ruben et de Gad et dimidia parte tribus Manasse, instructi omnibus armis bellicis, centum viginti milia."
,"39":"Omnes isti viri bellatores expediti ad pugnandum corde perfecto venerunt in Hebron, ut constituerent regem David super universum Israel; sed et omnes reliqui ex Israel uno corde erant, ut rex fieret David."
,"40":"Fueruntque ibi apud David tribus diebus comedentes et bibentes; praeparaverunt enim eis fratres sui."
,"41":"Sed et qui iuxta eos erant, usque ad Issachar et Zabulon et Nephthali, afferebant panes in asinis et camelis et mulis et bobus, escam farinae, palathas, uvam passam, vinum, oleum, boves, oves ad omnem copiam; gaudium quippe erat in Israel."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Iniit autem consilium David cum tribunis et centurionibus et universis principibus"
,"2":"et ait ad omnem coetum Israel: ' Si placet vobis, et a Domino Deo nostro egreditur sermo, quem loquor, mittamus ad fratres nostros reliquos in universas regiones Israel et ad sacerdotes et Levitas, qui habitant in suburbanis urbium, ut congregentur ad nos,"
,"3":"et reducamus arcam Dei nostri ad nos; non enim requisivimus eam in diebus Saul '."
,"4":"Et respondit universa multitudo, ut ita fieret; placuerat enim sermo omni populo."
,"5":"Congregavit ergo David cunctum Israel a Sihor Aegypti usque ad introitum dum ingrediaris Emath, ut adduceret arcam Dei de Cariathiarim."
,"6":"Et ascendit David et omnis Israel in Baala, in Cariathiarim, quae est in Iuda, ut afferrent inde arcam Dei Domini sedentis super cherubim, ubi invocatum est nomen eius."
,"7":"Imposueruntque arcam Dei super plaustrum novum de domo Abinadab. Oza autem et Ahio minabant plaustrum."
,"8":"Porro David et universus Israel ludebant coram Deo omni virtute in canticis et in citharis et psalteriis et tympanis et cymbalis et tubis."
,"9":"Cum autem pervenissent ad aream Chidon, tetendit Oza manum suam, ut sustentaret arcam; boves quippe lascivientes proruperunt."
,"10":"Iratus est itaque Dominus contra Ozam et percussit eum, eo quod contigisset arcam; et mortuus est ibi coram Deo."
,"11":"Contristatusque est David, eo quod dirupisset Dominus Ozam; et vocatus est locus ille Pharesoza (id est Diruptio Ozae) usque in praesentem diem."
,"12":"Et timuit Deum tunc temporis dicens: ' Quomodo possum ad me introducere arcam Dei? '."
,"13":"Et ob hanc causam non eam adduxit ad se, hoc est in civitatem David, sed avertit in domum Obededom Getthaei."
,"14":"Mansit ergo arca Dei apud domum Obededom tribus mensibus; et benedixit Dominus domui eius et omnibus quae habebat."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Misit quoque Hiram rex Tyri nuntios ad David et ligna cedrina et artifices parietum lignorumque, ut aedificarent ei domum."
,"2":"Cognovitque David quod confirmasset eum Dominus in regem super Israel et sublevatum esset regnum suum propter populum eius Israel."
,"3":"Accepit quoque David alias uxores in Ierusalem genuitque filios et filias;"
,"4":"et haec nomina eorum, qui nati sunt ei in Ierusalem: Samua et Sobab, Nathan et Salomon,"
,"5":"Iebahar et Elisua et Eliphalet,"
,"6":"Noga quoque et Napheg et Iaphia,"
,"7":"Elisama et Beeliada et Eliphalet."
,"8":"Audientes autem Philisthim quod unctus esset David in regem super universum Israel, ascenderunt omnes, ut quaererent eum; quod cum audisset David, egressus est obviam eis."
,"9":"Porro Philisthim venientes diffusi sunt in valle Raphaim."
,"10":"Consuluitque David Deum dicens: ' Si ascendam contra Philisthaeos, et si trades eos in manu mea? '. Et dixit ei Dominus: ' Ascende, et tradam eos in manu tua '."
,"11":"Cumque illi ascendissent in Baalpharasim, percussit eos ibi David et dixit: ' Dirupit Deus inimicos meos per manum meam sicut dirumpuntur aquae '. Et idcirco vocatum est nomen loci illius Baalpharasim (id est Dominus diruptionum)."
,"12":"Dereliqueruntque ibi deos suos, quos David iussit exuri."
,"13":"Alia etiam vice Philisthim irruerunt et diffusi sunt in valle;"
,"14":"consuluitque rursum David Deum, et dixit ei Deus: ' Non ascendas post eos; circumdabis eos et venies contra illos ex adverso arborum celthium;"
,"15":"cumque audieris sonitum gradientis in cacumine arborum celthium, tunc egredieris ad bellum; egressus est enim Deus ante te, ut percutias castra Philisthim '."
,"16":"Fecit ergo David, sicut praeceperat ei Deus, et percussit castra Philisthinorum de Gabaon usque Gazer."
,"17":"Divulgatumque est nomen David in universis regionibus, et Dominus dedit pavorem eius super omnes gentes."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Fecit quoque sibi domos in civitate David et praeparavit locum arcae Dei tetenditque ei tabernaculum."
,"2":"Tunc dixit David: ' Illicitum est, ut a quocumque portetur arca Dei, nisi a Levitis, quos elegit Dominus ad portandum eam et ad ministrandum sibi usque in aeternum '."
,"3":"Congregavitque David universum Israel in Ierusalem, ut afferretur arca Domini in locum suum, quem praeparaverat ei;"
,"4":"necnon et filios Aaron et Levitas."
,"5":"De filiis Caath Uriel princeps fuit et fratres eius centum viginti;"
,"6":"de filiis Merari Asaia princeps et fratres eius ducenti viginti;"
,"7":"de filiis Gerson Ioel princeps et fratres eius centum triginta;"
,"8":"de filiis Elisaphan Semeias princeps et fratres eius ducenti;"
,"9":"de filiis Hebron Eliel princeps et fratres eius octoginta;"
,"10":"de filiis Oziel Aminadab princeps et fratres eius centum duodecim."
,"11":"Vocavitque David Sadoc et Abiathar sacerdotes et Levitas Uriel, Asaiam, Ioel, Semeiam, Eliel et Aminadab"
,"12":"et dixit ad eos: ' Vos, qui estis principes familiarum Leviticarum, sanctificamini cum fratribus vestris et afferte arcam Domini, Dei Israel, ad locum, quem praeparavi."
,"13":"Quia a principio non eratis praesentes, fecit Dominus, Deus Israel, diruptionem in nobis; non enim quaesivimus eum, sicut fas erat '."
,"14":"Sanctificati sunt ergo sacerdotes et Levitae, ut portarent arcam Domini, Dei Israel;"
,"15":"et tulerunt filii Levi arcam Dei, sicut praeceperat Moyses iuxta verbum Domini, umeris suis in vectibus."
,"16":"Dixitque David principibus Levitarum, ut constituerent de fratribus suis cantores in organis musicorum, nablis videlicet et lyris et cymbalis, ut resonaret fortiter sonitus laetitiae."
,"17":"Constitueruntque Levitae Heman filium Ioel et de fratribus eius Asaph filium Barachiae, de filiis vero Merari fratribus eorum Ethan filium Casaiae"
,"18":"et cum eis fratres eorum in secundo ordine Zachariam et Bani et Iaziel et Semiramoth et Iahiel et Ani, Eliab et Banaiam et Maasiam et Matthathiam et Eliphalu et Maceniam et Obededom et Iehiel ianitores."
,"19":"Porro cantores Heman, Asaph et Ethan in cymbalis aeneis bene sonantibus,"
,"20":"Zacharias autem et Oziel et Semiramoth et Iahiel et Ani et Eliab et Maasias et Banaias in nablis secundum ' Virgines '."
,"21":"Porro Matthathias et Eliphalu et Macenias et Obededom et Iehiel et Ozaziu in citharis super octavam, ut dirigerent;"
,"22":"Chonenias autem princeps Levitarum portantium arcam praeerat ad portandum, erat quippe valde sapiens."
,"23":"Et Barachias et Elcana ianitores pro arca."
,"24":"Porro Sebania et Iosaphat et Nathanael et Amasai et Zacharias et Banaias et Eliezer sacerdotes clangebant tubis coram arca Dei, et Obededom et Iehias erant ianitores pro arca."
,"25":"Igitur David et maiores natu Israel et tribuni ierunt ad deportandam arcam foederis Domini de domo Obededom cum laetitia."
,"26":"Cumque adiuvisset Deus Levitas, qui portabant arcam foederis Domini, immolati sunt septem tauri et septem arietes."
,"27":"Porro David indutus pallio byssino et universi Levitae, qui portabant arcam, cantoresque et Chonenias princeps pro portanda arca - David autem indutus erat etiam ephod lineo -"
,"28":"universusque Israel deducebant arcam foederis Domini in iubilo et sonitu bucinae et tubis et cymbalis bene sonantibus et nablis et citharis."
,"29":"Cumque pervenisset arca foederis Domini usque ad civitatem David, Michol filia Saul prospiciens per fenestram vidit regem David saltantem atque ludentem et despexit eum in corde suo."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Attulerunt igitur arcam Dei et constituerunt eam in me dio tabernaculi, quod tetenderat ei David, et obtulerunt holocausta et pacifica coram Deo."
,"2":"Cumque complesset David offerens holocausta et pacifica, benedixit populo in nomine Domini."
,"3":"Et divisit unicuique de Israel a viro usque ad mulierem tortam panis et laganum palmarum et palatham."
,"4":"Constituitque coram arca Domini de Levitis ministros, qui recordarentur operum eius et glorificarent atque laudarent Dominum, Deum Israel:"
,"5":"Asaph principem et secundum eius Zachariam, porro Iehiel et Semiramoth et Iahiel et Matthathiam et Eliab et Banaiam et Obededom et Iehiel in organis psalterii et citharis, Asaph autem, ut cymbalis personaret,"
,"6":"Banaiam vero et Iahaziel sacerdotes, ut canerent tubis iugiter coram arca foederis Dei."
,"7":"In illo die, tunc fecit David prima vice confiteri Domino per manum Asaph et fratrum eius:"
,"8":"' Confitemini Domino, invocate nomen eius, notas facite in populis opera eius."
,"9":"Canite ei et psallite,et narrate omnia mirabilia eius."
,"10":"Laudate nomen sanctum eius, laetetur cor quaerentium Dominum."
,"11":"Quaerite Dominum et virtutem eius, quaerite faciem eius semper."
,"12":"Recordamini mirabilium eius, quae fecit, signorum illius et iudiciorum oris eius,"
,"13":"semen Israel, servi eius, filii Iacob, electi illius."
,"14":"Ipse Dominus Deus noster; in universa terra iudicia eius."
,"15":"Recordamini in sempiternum pacti eius, sermonis, quem praecepit in mille generationes,"
,"16":"pacti, quod pepigit cum Abraham, et iuramenti illius cum Isaac."
,"17":"Et constituit illud Iacob in praeceptum,et Israel in pactum sempiternum"
,"18":"dicens: 'Tibi dabo terram Chanaan,funiculum hereditatis vestrae',"
,"19":"cum essent pauci numero, parvi et coloni in ea."
,"20":"Et transierunt de gente in gentem,et de regno ad populum alterum;"
,"21":"non dimisit quemquam calumniari eos, sed increpuit pro eis reges:"
,"22":"'Nolite tangere christos meos,et in prophetis meis nolite malignari'."
,"23":"Canite Domino, omnis terra, annuntiate ex die in diem salutare eius."
,"24":"Narrate in gentibus gloriam eius, in cunctis populis mirabilia illius."
,"25":"Quia magnus Dominus et laudabilis nimis,et horribilis super omnes deos;"
,"26":"omnes enim dii populorum inania, Dominus autem caelos fecit."
,"27":"Magnificentia et pulchritudo coram eo, fortitudo et gaudium in loco eius."
,"28":"Afferte Domino, familiae populorum,afferte Domino gloriam et imperium;"
,"29":"date Domino gloriam nominis eius, levate oblationem et venite in conspectu eius,et adorate Dominum in decore sancto."
,"30":"Commoveatur a facie illius omnis terra; ipse enim fundavit orbem immobilem."
,"31":"Laetentur caeli, et exsultet terra, et dicant in nationibus: 'Dominus regnat!'."
,"32":"Tonet mare et plenitudo eius, exsultent agri et omnia, quae in eis sunt."
,"33":"Tunc laudabunt ligna saltus coram Domino, quia venit iudicare terram."
,"34":"Confitemini Domino, quoniam bonus, quoniam in aeternum misericordia eius."
,"35":"Et dicite: 'Salva nos, Deus salvator noster, et congrega nos et erue de gentibus, ut confiteamur nomini sancto tuo,et exsultemus in carminibus tuis."
,"36":"Benedictus Dominus, Deus Israel, ab aeterno usque in aeternum' '. Et dixit omnis populus: ' Amen! ' et ' Laus Domino! '."
,"37":"Dereliquit itaque ibi coram arca foederis Domini Asaph et fratres eius, ut ministrarent in conspectu arcae iugiter secundum ritum singulorum dierum."
,"38":"Porro Obededom et fratres eius sexaginta octo et Obededom filium Idithun et Hosa constituit ianitores."
,"39":"Sadoc autem sacerdotem et fratres illius sacerdotes coram habitaculo Domini in excelso, quod erat in Gabaon,"
,"40":"ut offerrent holocausta Domino super altare holocautomatis iugiter, mane et vespere, iuxta omnia, quae scripta sunt in lege Domini, quam praecepit Israeli."
,"41":"Et cum eis Heman et Idithun et reliquos electos, qui nominatim memorati sunt ad confitendum Domino: ' Quoniam in aeternum misericordia eius '."
,"42":"Et cum eis Heman et Idithun canentes tuba et quatientes cymbala bene sonantia et omnia musicorum organa ad canendum Deo; filios autem Idithun fecit esse portarios."
,"43":"Reversusque est omnis populus unusquisque in domum suam et David, ut benediceret etiam domui suae."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Cum autem habitaret David in domo sua, dixit ad Nathan prophetam: ' Ecce ego habito in domo cedrina, arca autem foederis Domini sub pellibus est '."
,"2":"Et ait Nathan ad David: ' Omnia, quae in corde tuo sunt, fac; Deus enim tecum est '."
,"3":"Igitur nocte illa factus est sermo Dei ad Nathan dicens:"
,"4":"' Vade et loquere David servo meo: Haec dicit Dominus: Non aedificabis tu mihi domum ad habitandum;"
,"5":"neque enim mansi in domo ex eo tempore, quo eduxi Israel usque ad hanc diem, sed fui semper migrans de tabernaculo in tabernaculum et de habitatione in habitationem."
,"6":"Ubicumque ambulabam in omni Israel, numquid locutus sum uni iudicum Israel, quibus praeceperam, ut pascerent populum meum, et dixi: Quare non aedificastis mihi domum cedrinam?"
,"7":"Nunc itaque, sic loqueris ad servum meum David: Haec dicit Dominus exercituum: Ego tuli te, cum in pascuis sequereris gregem, ut esses dux populi mei Israel;"
,"8":"et fui tecum, quocumque perrexisti, et interfeci omnes inimicos tuos coram te fecique tibi nomen quasi unius magnorum, qui celebrantur in terra."
,"9":"Et dedi locum populo meo Israel et plantavi eum, ut habitaret in eo, et ultra non commovebitur, nec filii iniquitatis atterent eos sicut in principio"
,"10":"et ex diebus, quibus dedi iudices populo meo Israel et humiliavi universos inimicos tuos. Annuntio ergo tibi quod aedificaturus sit domum tibi Dominus."
,"11":"Cumque impleveris dies tuos, ut vadas ad patres tuos, suscitabo semen tuum post te, quod erit de filiis tuis, et stabiliam regnum eius."
,"12":"Ipse aedificabit mihi domum, et firmabo solium eius usque in aeternum."
,"13":"Ego ero ei in patrem, et ipse erit mihi in filium; et misericordiam meam non auferam ab eo, sicut abstuli ab eo, qui ante te fuit."
,"14":"Et statuam eum in domo mea et in regno meo usque in sempiternum, et thronus eius erit firmissimus in perpetuum '."
,"15":"Iuxta omnia verba haec et iuxta universam visionem istam, sic locutus est Nathan ad David."
,"16":"Cumque venisset rex David et sedisset coram Domino, dixit: ' Quis ego sum, Domine Deus, et quae domus mea, quia adduxisti me hucusque?"
,"17":"Sed hoc parum visum est in conspectu tuo, Deus; ideoque locutus es super domum servi tui etiam in futurum et aspexisti me excelsum super ordinem hominum, Domine Deus."
,"18":"Quid ultra addere potest David, cum ita glorificaveris servum tuum et cognoveris eum?"
,"19":"Domine, propter famulum tuum iuxta cor tuum fecisti omnem magnificentiam hanc; et nota esse voluisti universa magnalia."
,"20":"Domine, non est similis tui, et non est alius deus absque te secundum omnia, quae audivimus auribus nostris."
,"21":"Quis autem est alius ut populus tuus Israel, gens una in terra, ad quam perrexit Deus, ut liberaret sibi populum, ut faceres tibi nomen magnum et terribile eiciens nationes a facie populi tui, quem de Aegypto liberasti?"
,"22":"Et posuisti populum tuum Israel tibi in populum usque in aeternum; et tu, Domine, factus es Deus eius."
,"23":"Nunc igitur, Domine, sermo, quem locutus es super famulum tuum et super domum eius, confirmetur in perpetuum; et fac, sicut locutus es."
,"24":"Permaneatque et magnificetur nomen tuum usque in sempiternum, et dicatur: 'Dominus exercituum, Deus Israel, est Deus pro Israel, et domus David servi tui permanens coram te'."
,"25":"Tu enim, Deus meus, revelasti auriculam servi tui, ut aedificares ei domum; et idcirco invenit servus tuus fiduciam, ut oret coram te."
,"26":"Nunc ergo, Domine, tu es Deus; et locutus es super servum tuum tanta beneficia"
,"27":"et coepisti benedicere domui servi tui, ut sit semper coram te: te enim, Domine, benedicente, benedicta erit in perpetuum '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Factum est autem post haec, ut percuteret David Phili sthim et humiliaret eos et tolleret Geth et filias eius de manu Philisthim"
,"2":"percuteretque Moab, et fierent Moabitae servi David offerentes ei tributum."
,"3":"Et percussit David etiam Adadezer regem Soba in regione ad Emath, quando perrexit, ut dilataret imperium suum usque ad flumen Euphraten."
,"4":"Cepit ergo David mille quadrigas eius et septem milia equites ac viginti milia virorum peditum; subnervavitque omnes equos curruum, exceptis centum quadrigis, quas reservavit sibi."
,"5":"Supervenit autem et Syrus Damascenus, ut auxilium praeberet Adadezer regi Soba; sed et huius percussit David viginti duo milia virorum"
,"6":"et posuit praesidium in Syria Damasci, ut Syria quoque serviret sibi et offerret tributum. Adiuvitque eum Dominus in cunctis, ad quae perrexerat."
,"7":"Tulit quoque David arma aurea, quae habuerant servi Adadezer, et attulit ea in Ierusalem;"
,"8":"necnon de Tebah et Chun urbibus Adadezer aeris plurimum, de quo fecit Salomon mare aeneum et columnas et vasa aenea."
,"9":"Quod cum audisset Thou rex Emath, percussisse videlicet David omnem exercitum Adadezer regis Soba,"
,"10":"misit Adoram filium suum ad regem David, ut salutaret eum et congratularetur, eo quod pugnasset cum Adadezer et percussisset eum; adversarius quippe erat Thou Adadezer."
,"11":"Sed et omnia vasa aurea et argentea et aenea consecravit rex David Domino cum argento et auro, quod tulerat ex universis gentibus, tam de Idumaea et Moab et filiis Ammon, quam de Philisthim et Amalec."
,"12":"Abisai vero filius Sarviae percussit Edom in valle Salis decem et octo milia"
,"13":"et constituit in Edom praesidium, ut serviret Idumaea David. Salvavitque Dominus David in cunctis, ad quae perrexerat."
,"14":"Regnavit ergo David super universum Israel et faciebat iudicium atque iustitiam cuncto populo suo."
,"15":"Porro Ioab filius Sarviae erat super exercitum, et Iosaphat filius Ahilud a commentariis."
,"16":"Sadoc autem filius Achitob et Achimelech filius Abiathar sacerdotes et Susa scriba."
,"17":"Banaias vero filius Ioiadae super legiones Cherethi et Phelethi; porro filii David primi ad manum regis."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Accidit autem post haec, ut moreretur Naas rex filiorum Ammon, et regnaret filius eius pro eo."
,"2":"Dixitque David: ' Faciam misericordiam cum Hanon filio Naas; praestitit enim pater eius mihi gratiam '. Misitque David nuntios ad consolandum eum super morte patris sui. Qui cum pervenissent in terram filiorum Ammon, ut consolarentur Hanon,"
,"3":"dixerunt principes filiorum Ammon ad Hanon: ' Tu forsitan putas quod David honoris causa in patrem tuum miserit, qui consolentur te; nec animadvertis quod, ut explorent et investigent et evertant terram tuam, venerint ad te servi eius '."
,"4":"Igitur Hanon pueros David tulit et rasit et praecidit tunicas eorum a natibus usque ad pedes et dimisit eos."
,"5":"Qui cum abissent et hoc mandassent David, misit in occursum eorum - grandem enim contumeliam sustinuerant - et praecepit, ut manerent in Iericho, donec cresceret barba eorum, et tunc reverterentur."
,"6":"Videntes autem filii Ammon quod odiosos se fecissent David, tam Hanon quam reliquus populus miserunt mille talenta argenti, ut conducerent sibi de Mesopotamia et de Syria Maacha et de Soba currus et equites;"
,"7":"conduxeruntque sibi triginta duo milia curruum et regem Maacha cum populo eius. Qui cum venissent, castrametati sunt e regione Medaba; filii quoque Ammon congregati de urbibus suis venerunt ad bellum."
,"8":"Quod cum audisset David, misit Ioab et omnem exercitum virorum fortium."
,"9":"Egressique filii Ammon direxerunt aciem iuxta portam civitatis; reges autem, qui ad auxilium venerant, separatim in agro steterunt."
,"10":"Igitur Ioab intellegens bellum et ex adverso et post tergum contra se fieri elegit viros fortissimos de universo Israel et perrexit contra Syrum;"
,"11":"reliquam autem partem populi dedit sub manu Abisai fratris sui, et perrexerunt contra filios Ammon."
,"12":"Dixitque: ' Si vicerit me Syrus, auxilio eris mihi; si autem superaverint te filii Ammon, ero tibi in praesidium."
,"13":"Confortare et agamus viriliter pro populo nostro et pro urbibus Dei nostri; Dominus autem, quod in conspectu suo bonum est, faciet '."
,"14":"Appropinquavit ergo Ioab et populus, qui cum eo erat, contra Syrum ad proelium, et fugerunt a facie eorum."
,"15":"Porro filii Ammon videntes quod fugisset Syrus, ipsi quoque fugerunt Abisai fratrem eius et ingressi sunt civitatem. Reversusque est etiam Ioab in Ierusalem."
,"16":"Videns autem Syrus quod cecidisset coram Israel, misit nuntios et adduxit Syrum, qui erat trans fluvium; Sophach autem princeps militiae Adadezer erat dux eorum."
,"17":"Quod cum nuntiatum esset David, congregavit universum Israel et transivit Iordanem venitque ad eos et direxit ex adverso aciem et pugnavit cum eis."
,"18":"Fugit autem Syrus Israel, et interfecit David de Syris septem milia curruum et quadraginta milia peditum et Sophach exercitus principem."
,"19":"Videntes autem servi Adadezer se ab Israel esse superatos, fecerunt pacem cum David et servierunt ei; noluitque ultra Syria auxilium praebere filiis Ammon."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Factum est autem post anni circulum, eo tempore, quo solent reges ad bella procedere, eduxit Ioab robur exercitus et vastavit terram filiorum Ammon; perrexitque et obsedit Rabba. Porro David manebat in Ierusalem, quando Ioab percussit Rabba et destruxit eam."
,"2":"Tulit autem David coronam Melchom de capite eius et invenit in ea auri pondo talentum et pretiosissimam gemmam, venitque super caput David; manubias quoque urbis plurimas tulit."
,"3":"Populum autem, qui erat in ea, eduxit et condemnavit ad operam lapicidinarum et ad secures et dolabras ferreas. Sic fecit David cunctis urbibus filiorum Ammon et reversus est cum omni populo suo in Ierusalem."
,"4":"Post haec initum est bellum in Gazer adversum Philisthaeos, in quo percussit Sobbochai Husathites Saphai de genere Raphaim, et humiliavit eos."
,"5":"Aliud quoque bellum gestum est adversus Philisthaeos, in quo percussit Elchanan filius Iair Lahmi fratrem Goliath Getthaeum, cuius hastae lignum erat quasi liciatorium texentium."
,"6":"Sed et aliud bellum accidit in Geth, in quo fuit homo longissimus senos habens digitos, id est simul viginti quattuor, qui et ipse de Rapha fuerat stirpe generatus;"
,"7":"hic blasphemavit Israel, et percussit eum Ionathan filius Samma fratris David. Hi sunt filii Rapha in Geth, qui ceciderunt in manu David et servorum eius."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Consurrexit autem Satan contra Israel et incitavit Da vid, ut numeraret Israel."
,"2":"Dixitque David ad Ioab et ad principes populi: ' Ite et numerate Israel a Bersabee usque Dan et afferte mihi numerum, ut sciam '."
,"3":"Responditque Ioab: ' Augeat Dominus populum suum centuplum quam sunt. Nonne, domine mi rex, omnes servi tui sunt? Quare hoc quaerit dominus meus, quod in peccatum reputetur Israeli? '."
,"4":"Sed sermo regis magis praevaluit; egressusque est Ioab et circuivit universum Israel et reversus est Ierusalem."
,"5":"Deditque David numerum census, et inventus est omnis Israel numerus mille milia et centum milia virorum educentium gladium; de Iuda autem quadringenta septuaginta milia bellatorum;"
,"6":"nam Levi et Beniamin non numeravit in medio eorum, eo quod invitus exequeretur regis imperium."
,"7":"Displicuit autem Deo, quod iussum erat, et percussit Israel."
,"8":"Dixitque David ad Deum: ' Peccavi nimis, ut hoc facerem; obsecro, aufer iniquitatem servi tui, quia valde insipienter egi '."
,"9":"Et locutus est Dominus ad Gad videntem David dicens:"
,"10":"' Vade et loquere ad David et dic: Haec dicit Dominus: Trium tibi optionem do: unum, quod volueris, elige, et faciam tibi '."
,"11":"Cumque venisset Gad ad David, dixit ei: ' Haec dicit Dominus: Elige, quod volueris:"
,"12":"aut tribus annis famem aut tribus mensibus fugere te hostes tuos et gladium eorum non posse evadere aut tribus diebus gladium Domini et pestilentiam versari in terra et angelum Domini interficere in universis finibus Israel. Nunc igitur vide quid respondeam ei, qui misit me '."
,"13":"Et dixit David ad Gad: ' Ex omni parte me angustiae premunt, sed melius mihi est, ut incidam in manus Domini, quia multae sunt miserationes eius, quam in manus hominum '."
,"14":"Misit ergo Dominus pestilentiam in Israel, et ceciderunt de Israel septuaginta milia virorum."
,"15":"Misit quoque Deus angelum in Ierusalem, ut percuteret eam. Cumque percuteretur, vidit Dominus et misertus est super magnitudinem mali et imperavit angelo, qui percutiebat: ' Sufficit, iam cesset manus tua '. Porro angelus Domini stabat iuxta aream Ornan Iebusaei. "
,"16":"Levansque David oculos suos vidit angelum Domini stantem inter terram et caelum et evaginatum gladium in manu eius et versum contra Ierusalem; et ceciderunt tam ipse quam maiores natu vestiti ciliciis proni in terram."
,"17":"Dixitque David ad Deum: ' Nonne ego sum, qui iussi, ut numeraretur populus? Ego qui peccavi, ego qui malum feci; iste grex quid commeruit? Domine Deus meus, vertatur, obsecro, manus tua in me et in domum patris mei; populus autem tuus non percutiatur '."
,"18":"Angelus autem Domini praecepit Gad dicere David, ut ascenderet exstrueretque altare Domino in area Ornan Iebusaei."
,"19":"Ascendit ergo David iuxta sermonem Gad, quem locutus fuerat ex nomine Domini."
,"20":"Porro Ornan, cum conversus vidisset angelum, quattuorque filii eius cum eo absconderunt se; nam eo tempore terebat in area triticum."
,"21":"Igitur, cum veniret David ad Ornan, conspexit eum Ornan et processit ei obviam de area et adoravit illum pronus in terram."
,"22":"Dixitque ei David: ' Da mihi locum areae tuae, ut aedificem in ea altare Domino, ita ut quantum valet argenti accipias, et cesset plaga a populo '."
,"23":"Dixit autem Ornan ad David: ' Tolle, et faciat dominus meus rex, quodcumque ei placet; sed et boves do in holocaustum et tribulas in ligna et triticum in sacrificium; omnia libens praebebo '."
,"24":"Dixitque ei rex David: ' Nequaquam ita fiet, sed argentum dabo quantum valet; neque enim tibi auferre debeo et sic offerre Domino holocausta gratuita '."
,"25":"Dedit ergo David Ornan pro loco siclos auri iustissimi ponderis sescentos"
,"26":"et aedificavit ibi altare Domino obtulitque holocausta et pacifica et invocavit Dominum. Et exaudivit eum in igne de caelo super altare holocausti,"
,"27":"praecepitque Dominus angelo, et convertit gladium suum in vaginam."
,"28":"In illo ergo tempore David videns quod exaudisset eum Dominus in area Ornan Iebusaei immolavit ibi victimas."
,"29":"Tabernaculum autem Domini, quod fecerat Moyses in deserto, et altare holocaustorum ea tempestate erat in excelso Gabaon;"
,"30":"et non praevaluit David ire, ut ibi obsecraret Deum; nimio enim fuerat timore perterritus videns gladium angeli Domini."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Dixitque David: ' Haec est domus Domini Dei, et hoc est altare holocausti pro Israel '."
,"2":"Et praecepit, ut congregarentur omnes advenae de terra Israel, et constituit ex eis latomos ad caedendos lapides et poliendos, ut aedificaretur domus Dei."
,"3":"Ferrum quoque plurimum ad clavos ianuarum et ad commissuras atque iuncturas praeparavit David et aeris pondus innumerabile."
,"4":"Ligna quoque cedrina non poterant aestimari, quae Sidonii et Tyrii deportaverant ad David."
,"5":"Et dixit David: ' Salomon filius meus puer parvulus est et tener; domus autem, quae aedificanda est Domino, talis esse debet, ut in cunctis regionibus nominetur et glorificetur. Praeparabo ergo ei necessaria '. Et ob hanc causam ante mortem suam omnes paravit impensas."
,"6":"Vocavitque Salomonem filium suum et praecepit ei, ut aedificaret domum Domino, Deo Israel;"
,"7":"dixitque David ad Salomonem: ' Fili mi, voluntatis meae fuit, ut aedificarem domum nomini Domini Dei mei,"
,"8":"sed factus est ad me sermo Domini dicens: 'Multum sanguinem effudisti et magna bella bellasti. Non poteris aedificare domum nomini meo, tanto effuso sanguine coram me."
,"9":"Filius, qui nascetur tibi, erit vir quietissimus; faciam enim eum requiescere ab omnibus inimicis suis per circuitum et ob hanc causam Salomon vocabitur, et pacem et otium dabo in Israel cunctis diebus eius."
,"10":"Ipse aedificabit domum nomini meo, et ipse erit mihi in filium, et ego ero ei in patrem; firmaboque solium regni eius super Israel in aeternum'."
,"11":"Nunc ergo, fili mi, sit Dominus tecum; et prosperare et aedifica domum Domino Deo tuo, sicut locutus est de te."
,"12":"Tantum det tibi Dominus prudentiam et sensum, ut regere possis Israel et custodire legem Domini Dei tui;"
,"13":"tunc enim proficere poteris, si custodieris mandata et iudicia, quae praecepit Dominus Moysi super Israel. Confortare et viriliter age; ne timeas neque paveas."
,"14":"Ecce ego in labore meo praeparavi impensas domus Domini: auri talenta centum milia et argenti mille milia talentorum, aeris vero et ferri non est pondus, vincitur enim numerus magnitudine. Ligna et lapides praeparavi; tu autem ad ea adicies."
,"15":"Habes quoque plurimos artifices latomos et caementarios artificesque lignorum et omnium artium ad faciendum opus prudentissimos"
,"16":"in auro et argento et aere et ferro, cuius non est numerus. Surge igitur et fac, et erit Dominus tecum '."
,"17":"Praecepit quoque David cunctis principibus Israel, ut adiuvarent Salomonem filium suum: '"
,"18":"Cernitis, inquiens, quod Dominus Deus vester vobiscum sit et dederit vobis requiem per circuitum et tradiderit habitatores terrae in manu vestra, et subiecta sit terra coram Domino et coram populo eius."
,"19":"Praebete igitur corda vestra et animas vestras, ut quaeratis Dominum Deum vestrum; et consurgite et aedificate sanctuarium Domini Dei, ut introducatur arca foederis Domini et vasa Deo consecrata in domum, quae aedificatur nomini Domini '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Igitur David senex et plenus dierum regem constituit Sa lomonem filium suum super Israel"
,"2":"et congregavit omnes principes Israel et sacerdotes atque Levitas."
,"3":"Numeratique sunt Levitae a triginta annis et supra, et inventa sunt triginta octo milia virorum."
,"4":"' Ex his, inquit, praesint ministerio domus Domini viginti quattuor milia, praepositi autem et iudices sex milia;"
,"5":"porro quattuor milia ianitores et totidem psaltae canentes Domino in organis, quae feci ad canendum '."
,"6":"Et distribuit eos David per vices filiorum Levi Gerson videlicet et Caath et Merari."
,"7":"Filii Gerson: Ladan et Semei."
,"8":"Filii Ladan: princeps Iahiel et Zetham et Ioel, tres."
,"9":"Filii Semei: Salomith et Hoziel et Aran, tres; isti principes familiarum Ladan."
,"10":"Porro filii Semei: Iahath et Ziza et Iehus et Beria; isti filii Semei, quattuor."
,"11":"Erat autem Iahath prior, Ziza secundus; porro Iehus et Beria non habuerunt plurimos filios, et idcirco in una familia unaque domo computati sunt."
,"12":"Filii Caath: Amram et Isaar, Hebron et Oziel, quattuor."
,"13":"Filii Amram: Aaron et Moyses. Separatusque est Aaron, ut sanctificaret sanctissima, ipse et filii eius in sempiternum, et adoleret Domino et serviret ei ac benediceret in nomine eius in perpetuum."
,"14":"Moysi quoque hominis Dei filii annumerati sunt in tribu Levi."
,"15":"Filii Moysi: Gersam et Eliezer."
,"16":"Filii Gersam: Subael primus."
,"17":"Fuerunt autem filii Eliezer: Rohobia primus, et non erant Eliezer filii alii; porro filii Rohobia multiplicati sunt nimis."
,"18":"Filii Isaar: Salomoth primus."
,"19":"Filii Hebron: Ieriau primus, Amarias secundus, Iahaziel tertius, Iecmaam quartus."
,"20":"Filii Oziel: Micha primus, Iesia secundus."
,"21":"Filii Merari: Moholi et Musi. Filii Moholi: Eleazar et Cis;"
,"22":"mortuus est autem Eleazar et non habuit filios sed filias acceperuntque eas filii Cis fratres earum."
,"23":"Filii Musi: Moholi et Eder et Ierimoth, tres."
,"24":"Hi filii Levi in familiis suis, principes familiarum per vices et numerum capitum singulorum, qui faciebant opera ministerii domus Domini a viginti annis et supra."
,"25":"Dixit enim David: ' Requiem dedit Dominus, Deus Israel, populo suo et habitat in Ierusalem usque in aeternum;"
,"26":"nec erit officii Levitarum, ut ultra portent tabernaculum et omnia vasa eius ad ministrandum."
,"27":"Iuxta praecepta igitur David novissima, supputabitur numerus filiorum Levi a viginti annis et supra,"
,"28":"et erunt sub manu filiorum Aaron in cultum domus Domini pro atriis et exedris et in purificationem omnis rei sacrae et in ministerium templi Dei,"
,"29":"pro panibus propositionis et farina oblationis et laganis azymorum et pro sartagine et ad torrendum et super omne pondus atque mensuram."
,"30":"Et stent mane ad confitendum et canendum Domino similiterque ad vesperam,"
,"31":"tam in oblatione holocaustorum Domini quam in sabbatis et calendis et sollemnitatibus reliquis, iuxta numerum et caeremonias uniuscuiusque rei iugiter coram Domino."
,"32":"Et custodiant observationes tabernaculi conventus et ritum sanctuarii et observationem filiorum Aaron fratrum suorum, ut ministrent in domo Domini '."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Porro filiis Aaron hae partiones erant. Filii Aaron: Nadab et Abiu et Eleazar et Ithamar. "
,"2":"Mortui sunt autem Nadab et Abiu ante patrem suum absque liberis; sacerdotioque functus est Eleazar et Ithamar."
,"3":"Et divisit eos David cum Sadoc de filiis Eleazari et cum Achimelech de filiis Ithamar, secundum vices suas et ministerium."
,"4":"Inventique sunt multo plures filii Eleazar secundum capita virorum quam filii Ithamar; divisit igitur eis, hoc est filiis Eleazar principes per familias sedecim, et filiis Ithamar per familias et domos suas octo."
,"5":"Porro divisit utrasque inter se familias sortibus; erant enim principes sanctuarii et principes Dei tam de filiis Eleazar quam de filiis Ithamar."
,"6":"Descripsitque eos Semeias filius Nathanael scriba Levites coram rege et principibus et Sadoc sacerdote et Achimelech filio Abiathar, principibus quoque familiarum sacerdotalium et leviticarum: unam familiam pro Eleazar et unam pro Ithamar."
,"7":"Exivit autem sors prima Ioiarib, secunda Iedaiae,"
,"8":"tertia Harim, quarta Seorim,"
,"9":"quinta Melchia, sexta Miamin,"
,"10":"septima Accos, octava Abia,"
,"11":"nona Iesua, decima Sechenia,"
,"12":"undecima Eliasib, duodecima Iacim,"
,"13":"tertia decima Hoppha, quarta decima Isbaab,"
,"14":"quinta decima Belga, sexta decima Emmer,"
,"15":"septima decima Hezir, octava decima Aphses,"
,"16":"nona decima Phethahia, vicesima Hezechiel,"
,"17":"vicesima prima Iachin, vicesima secunda Gamul,"
,"18":"vicesima tertia Dalaiau, vicesima quarta Maaziau."
,"19":"Hae vices eorum secundum ministeria sua, ut ingrediantur domum Domini, et iuxta ritum suum sub manu Aaron patris eorum, sicut praecepit Dominus, Deus Israel."
,"20":"Porro filiorum Levi, qui reliqui fuerant: de filiis Amram Subael et de filiis Subael Iehedeia."
,"21":"De filiis quoque Rohobiae princeps Iesias."
,"22":"De Isaaritis vero Salomoth; de filiis Salomoth Iahath."
,"23":"De Hebronitis: Ieriau, Amarias secundus, Iahaziel tertius, Iecmaam quartus."
,"24":"Filius Oziel Micha; de filiis Micha Samir;"
,"25":"frater Micha Iesia; de filiis Iesiae Zacharias."
,"26":"Filii Merari: Moholi et Musi. Filii eius: Iaziau et Bani."
,"27":"Filius Merari: de Iaziau filio suo Soam et Zacchur et Hebri."
,"28":"Porro de Moholi filius Eleazar, qui non habebat liberos."
,"29":"Filius vero Cis Ierameel;"
,"30":"filii Musi: Moholi, Eder et Ierimoth. Isti filii Levi secundum familias suas. "
,"31":"Ipsi quoque miserunt sortes sicut fratres sui, filii Aaron coram David rege et Sadoc et Achimelech et principibus familiarum sacerdotalium et leviticarum tam maiores quam minores; omnes sors aequaliter dividebat."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Igitur David et magistratus exercitus segregaverunt in ministerium filios Asaph et Heman et Idithun, qui prophetarent in citharis et psalteriis et cymbalis, secundum numerum suum dedicato sibi officio servientes."
,"2":"De filiis Asaph: Zacchur et Ioseph et Nathania et Asarela filii Asaph erant sub manu Asaph prophetantis sub manu regis."
,"3":"De Idithun; filii Idithun: Godolias, Sori, Iesaias et Hasabias et Matthathias, sex, sub manu patris sui Idithun, qui in cithara prophetabat ad confitendum et laudandum Dominum."
,"4":"De Heman quoque; filii Heman: Bocciau, Matthaniau, Oziel, Subael et Ierimoth, Hananias, Hanani, Eliatha, Geddelthi et Romemthiezer et Iesbacasa, Mellothi, Othir, Mahazioth;"
,"5":"omnes isti filii Heman videntis regis iuxta sermones Dei, quod exaltaret cornu eius; deditque Deus Heman filios quattuordecim et filias tres."
,"6":"Universi sub manu patris sui ad cantandum in templo Domini distributi erant in cymbalis et psalteriis et citharis, in ministeria domus Dei sub manu regis: Asaph et Idithun et Heman."
,"7":"Fuit autem numerus eorum cum fratribus suis eruditis in cantando Domino, cuncti magistri, ducenti octoginta octo."
,"8":"Miseruntque sortes pro ministerio ex aequo, tam maior quam minor, magister pariter et discipulus."
,"9":"Egressaque est sors prima Ioseph, qui erat de Asaph. Secunda Godoliae, ipsi et fratribus eius et filiis eius, duodecim."
,"10":"Tertia Zacchur, filiis et fratribus eius, duodecim."
,"11":"Quarta Isari, filiis et fratribus eius, duodecim."
,"12":"Quinta Nathaniau, filiis et fratribus eius, duodecim."
,"13":"Sexta Bocciau, filiis et fratribus eius, duodecim."
,"14":"Septima Isreela, filiis et fratribus eius, duodecim."
,"15":"Octava Iesaiae, filiis et fratribus eius, duodecim."
,"16":"Nona Matthaniau, filiis et fratribus eius, duodecim."
,"17":"Decima Semei, filiis et fratribus eius, duodecim."
,"18":"Undecima Azareel, filiis et fratribus eius, duodecim."
,"19":"Duodecima Hasabiae, filiis et fratribus eius, duodecim."
,"20":"Tertia decima Subael, filiis et fratribus eius, duodecim."
,"21":"Quarta decima Matthathiae, filiis et fratribus eius, duodecim."
,"22":"Quinta decima Ierimoth, filiis et fratribus eius, duodecim."
,"23":"Sexta decima Hananiae, filiis et fratribus eius, duodecim."
,"24":"Septima decima Iesbacasae, filiis et fratribus eius, duodecim."
,"25":"Octava decima Hanani, filiis et fratribus eius, duodecim."
,"26":"Nona decima Mellothi, filiis et fratribus eius, duodecim."
,"27":"Vicesima Eliatha, filiis et fratribus eius, duodecim."
,"28":"Vicesima prima Othir, filiis et fratribus eius, duodecim."
,"29":"Vicesima secunda Geddelthi, filiis et fratribus eius, duodecim."
,"30":"Vicesima tertia Mahazioth, filiis et fratribus eius, duodecim."
,"31":"Vicesima quarta Romemthiezer, filiis et fratribus eius, duodecim."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Divisiones autem ianitorum. De Coritis: Meselemia filius Core de filiis Abiasaph. "
,"2":"Filii Meselemiae: Zacharias primogenitus, Iedihel secundus, Zabadias tertius, Iathanael quartus,"
,"3":"Elam quintus, Iohanan sextus, Elioenai septimus."
,"4":"Filii autem Obededom: Semeias primogenitus, Iozabad secundus, Ioah tertius, Sachar quartus, Nathanael quintus,"
,"5":"Ammiel sextus, Issachar septimus, Phollathi octavus, quia benedixit illi Deus."
,"6":"Semeiae autem filio eius nati sunt filii praefecti familiarum suarum, erant enim viri fortissimi;"
,"7":"filii ergo Semeiae: Othni et Raphael et Obed, Elzabad, fratres eius viri fortissimi, Eliu quoque et Samachias;"
,"8":"omnes hi de filiis Obededom, ipsi et filii et fratres eorum fortissimi ad ministrandum sexaginta duo de Obededom."
,"9":"Porro Meselemiae filii et fratres eorum robustissimi decem et octo."
,"10":"De Hosa autem, de filiis Merari, erant filii: Semri princeps - non enim fuerat primogenitus, et idcirco posuerat eum pater eius in principem -"
,"11":"Helcias secundus, Tabelias tertius, Zacharias quartus; omnes hi filii et fratres Hosa tredecim."
,"12":"Hae divisiones ianitorum: secundum capita virorum habebant ministeria sicut et fratres eorum ad ministrandum in domo Domini."
,"13":"Missae sunt ergo sortes ex aequo et parvis et magnis per familias suas in unamquamque portarum."
,"14":"Cecidit igitur sors orientalis Selemiae; porro Zachariae filio eius consiliario prudentissimo et erudito sortito obtigit plaga septentrionalis;"
,"15":"Obededom vero australis, et filiis eius horreum;"
,"16":"Sephim et Hosa occidentalis iuxta portam Sallecheth apud viam ascensionis. Custodia iuxta custodiam:"
,"17":"ad orientem per diem sex et ad aquilonem quattuor per diem, atque ad meridiem similiter in die quattuor et pro horreo bini et bini,"
,"18":"pro Parbar quoque ad occidentem quattuor in via, duo pro Parbar."
,"19":"Hae sunt divisiones ianitorum filiorum Core et Merari."
,"20":"Porro Levitae fratres eorum super thesauros domus Dei ac thesauros rerum consecratarum."
,"21":"De filiis Ladan Gersonitae principes familiarum Ladan Gersonitae erant Iahielitae."
,"22":"Filii Iahiel et Zetham et Ioel fratrum eius erant super thesauros domus Domini."
,"23":"De Amramitis et Isaaritis et Hebronitis et Ozielitis:"
,"24":"Subael filius Gersam filii Moysi praepositus thesauris."
,"25":"Fratres quoque eius Eliezer, cuius filius Rohobia et huius filius Iesaias; et huius filius Ioram, huius quoque filius Zechri et huius filius Selemith."
,"26":"Ipse Selemith et fratres eius super omnes thesauros rerum consecratarum, quas sanctificavit David rex et principes familiarum et tribuni et centuriones et duces exercitus"
,"27":"de bellis et manubiis proeliorum, quas consecraverant ad sustentandum templum Domini."
,"28":"Et universa, quae consecraverant Samuel videns et Saul filius Cis et Abner filius Ner et Ioab filius Sarviae, omnia donaria sacra erant sub manu Selemith et fratrum eius."
,"29":"De Isaaritis vero erant Chonenias et filii eius ad opera forinsecus super Israel praefecti et iudices."
,"30":"Porro de Hebronitis Hasabias et fratres eius viri strenui mille septingenti erant magistratus Israel trans Iordanem contra occidentem in cunctis operibus Domini et in ministerium regis;"
,"31":"Hebronitarum autem princeps fuit Ieria secundum cognationes et familias eorum. Quadragesimo anno regni David recensiti sunt et inventi viri fortes in Iazer Galaad"
,"32":"fratresque eius viri strenui duo milia septingenti principes familiarum; praeposuit autem eos David rex Rubenitis et Gadditis et dimidio tribus Manasse in omne ministerium Dei et regis."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Filii autem Israel secundum numerum suum, principes fa miliarum, tribuni et centuriones et praefecti, qui ministrabant regi iuxta turmas suas ingredientes et egredientes per singulos menses in anno, unaquaeque turma viginti quattuor milia."
,"2":"Primae turmae in primo mense Iesbaam praeerat filius Zabdiel, et sub eo viginti quattuor milia;"
,"3":"erat de filiis Phares princeps cunctorum principum in exercitu mense primo."
,"4":"Secundi mensis habebat turmam Dudi Ahohites, et sub eo viginti quattuor milia."
,"5":"Dux quoque turmae tertiae in mense tertio erat Banaias filius Ioiadae sacerdotis, et in divisione sua viginti quattuor milia;"
,"6":"ipse est Banaias fortissimus inter triginta et super triginta; praeerat autem turmae ipsius Amizabad filius eius."
,"7":"Quartus, mense quarto, Asael frater Ioab et Zabadias filius eius post eum, et in turma eius viginti quattuor milia."
,"8":"Quintus, mense quinto, princeps Samaoth Zaraita, et in turma eius viginti quattuor milia."
,"9":"Sextus, mense sexto, Hira filius Acces Thecuites, et in turma eius viginti quattuor milia."
,"10":"Septimus, mense septimo, Helles Phalonites de filiis Ephraim, et in turma eius viginti quattuor milia."
,"11":"Octavus, mense octavo, Sobbochai Husathites de stirpe Zara, et in turma eius viginti quattuor milia."
,"12":"Nonus, mense nono, Abiezer Anathothites de filiis Beniamin, et in turma eius viginti quattuor milia."
,"13":"Decimus, mense decimo, Maharai Netophathites de stirpe Zara, et in turma eius viginti quattuor milia."
,"14":"Undecimus, mense undecimo, Banaias Pharathonites de filiis Ephraim, et in turma eius viginti quattuor milia."
,"15":"Duodecimus, mense duodecimo, Holdai Netophathites de stirpe Othoniel, et in turma eius viginti quattuor milia."
,"16":"Porro tribubus praeerant Israel: Rubenitis dux Eliezer filius Zechri; Simeonitis Saphatia filius Maacha;"
,"17":"Levitis Hasabias filius Camuel; Aaronitis Sadoc; 18 Iudae Eliu de fratribus David; Issachar Amri filius Michael;"
,"19":"Zabulon Iesmaias filius Abdiae; Nephthali Ierimoth filius Azriel;"
,"20":"filiis Ephraim Osee filius Ozaziu; dimidio tribus Manasse Ioel filius Phadaiae;"
,"21":"et dimidio tribus Manasse in Galaad Iaddo filius Zachariae; Beniamin autem Iasiel filius Abner;"
,"22":"Dan vero Azareel filius Ieroham: hi principes tribuum Israel."
,"23":"Noluit autem David numerare eos a viginti annis inferius, quia dixerat Dominus ut multiplicaret Israel quasi stellas caeli."
,"24":"Ioab filius Sarviae coeperat numerare nec complevit, quia super hoc ira irruerat in Israel, et idcirco numerus non est relatus in librum annalium regis David."
,"25":"Super thesauros autem regis fuit Azmaveth filius Adiel; his autem thesauris, qui erant in regione, in urbibus et in vicis et in turribus praesidebat Ionathan filius Oziae."
,"26":"Operi autem rustico et agricolis, qui exercebant terram, praeerat Ezri filius Chelub."
,"27":"Vinearumque cultoribus Semei Ramathites; cellis autem vinariis in vineis Zabdi Sephamatites."
,"28":"Nam super oliveta et ficeta, quae erant in Sephela, Baalhanan Gederites; super apothecas autem olei Ioas."
,"29":"Porro armentis, quae pascebantur in Saron, praepositus fuit Setrai Saronites, et super boves in vallibus Saphat filius Adli."
,"30":"Super camelos vero Ubil Ismaelites, et super asinas Iehedeia Meronathites;"
,"31":"super oves quoque Iaziz Agarenus: omnes hi principes substantiae regis David."
,"32":"Ionathan autem patruus David consiliarius, vir prudens et litteratus, ipse et Iahiel filius Hachamonitis erant cum filiis regis."
,"33":"Achitophel etiam consiliarius regis, et Chusai Arachites amicus regis;"
,"34":"post Achitophel fuit Ioiada filius Banaiae et Abiathar. Princeps autem exercitus regis erat Ioab."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Convocavit igitur David om nes principes Israel, duces tri buum et praepositos turmarum, qui ministrabant regi, tribunos quoque et centuriones et, qui praeerant substantiae et gregibus regis filiorumque suorum, cum eunuchis et fortibus et robustissimis quibusque in exercitu Ierusalem."
,"2":"Cumque surrexisset rex et stetisset, ait: ' Audite me, fratres mei et populus meus. Cogitavi ut aedificarem domum, in qua requiesceret arca foederis Domini et scabellum pedum Dei nostri, et ad aedificandum omnia praeparavi;"
,"3":"Deus autem dixit mihi: 'Non aedificabis domum nomini meo, eo quod sis vir bellator et sanguinem fuderis'."
,"4":"Sed elegit Dominus, Deus Israel, me de universa domo patris mei, ut essem rex super Israel in sempiternum; Iudam enim elegit principem, porro in domo Iudae domum patris mei, et in filiis patris mei placuit ei, ut me eligeret regem super cunctum Israel."
,"5":"Sed et de filiis meis - filios enim multos dedit mihi Dominus - elegit Salomonem filium meum, ut sederet in throno regni Domini super Israel."
,"6":"Dixitque mihi: 'Salomon filius tuus aedificabit domum meam et atria mea; ipsum enim elegi mihi in filium, et ego ero ei in patrem."
,"7":"Et firmabo regnum eius usque in aeternum, si perseveraverit facere praecepta mea et iudicia, sicut et hodie'."
,"8":"Nunc igitur coram universo Israel coetu Domini, audiente Deo nostro, custodite et perquirite cuncta mandata Domini Dei vestri, ut possideatis terram bonam et relinquatis eam in hereditatem filiis vestris post vos usque in sempiternum."
,"9":"Tu autem, Salomon, fili mi, scito Deum patris tui et servi ei corde perfecto et animo voluntario; omnia enim corda scrutatur Dominus et universas mentium cogitationes intellegit. Si quaesieris eum, invenies; si autem dereliqueris illum, proiciet te in aeternum."
,"10":"Nunc ergo vide quia elegit te Dominus, ut aedificares domum sanctuarii; confortare et perfice '."
,"11":"Dedit autem David Salomoni filio suo descriptionem porticus et templi et cellariorum et cenaculorum et cubiculorum interiorum et domus propitiatorii"
,"12":"necnon et omnium, quae per Spiritum cum eo erant, de atriis domus Domini et de omnibus exedris per circuitum, de thesauris domus Dei et de thesauris rerum consecratarum"
,"13":"et de divisionibus sacerdotalibus et leviticis, de omni opere ministerii domus Domini et de universis vasis ministerii templi Domini,"
,"14":"de auro in pondere per singula vasa ministerii, de omnibus vasis argenteis in pondere per omnia vasa pro operum diversitate;"
,"15":"sed et ad candelabra aurea et ad lucernas eorum aurum pro mensura uniuscuiusque candelabri et lucernarum, similiter et in candelabris argenteis et in lucernis eorum pro diversitate mensurae, pondus argenti indicavit."
,"16":"Aurum quoque in mensas propositionis pro diversitate mensarum, similiter et argentum in alias mensas argenteas;"
,"17":"ad fuscinulas quoque et phialas et crateras ex auro purissimo et scyphos aureos pro qualitate mensurae pondus distribuit in scyphum et scyphum; similiter et in scyphos argenteos diversum argenti pondus constituit,"
,"18":"altari autem, in quo adoletur incensum, aurum purissimum, et aurum pro structura quadrigae cherubim extendentium alas et velantium arcam foederis Domini."
,"19":"' Omnia, inquit, venerunt scripta manu Domini ad me, ut intellegerem universa opera exemplaris '."
,"20":"Dixit quoque David Salomoni filio suo: ' Viriliter age et confortare et fac, ne timeas et ne paveas; Dominus enim Deus meus tecum erit et non dimittet te nec derelinquet, donec perficias omne opus ministerii domus Domini."
,"21":"Ecce divisiones sacerdotum et Levitarum: parati erunt in omne ministerium domus Dei; et assistet tibi in omni opere quisquis in sapientia ad omne ministerium promptus fuerit, principes quoque et universus populus in negotiis tuis '."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Locutusque est David rex ad omnem ecclesiam: ' Salomo nem filium meum unum elegit Deus adhuc puerum et tenellum; opus autem grande est: neque enim homini praeparatur habitatio sed Domino Deo."
,"2":"Ego autem totis viribus meis praeparavi impensas domus Dei mei: aurum ad vasa aurea et argentum in argentea, aes in aenea, ferrum in ferrea, ligna ad lignea, lapides onychinos et ad inserendum, durum caementum et lapides diversorum colorum omnemque pretiosum lapidem et marmor Parium abundantissime."
,"3":"Et super haec, cum delectarer super domo Dei mei, de peculio meo aurum et argentum do in templum Dei mei, exceptis his, quae paravi in aedem sanctam:"
,"4":"tria milia talenta auri de auro Ophir et septem milia talentorum argenti probatissimi ad operiendos parietes templi;"
,"5":"et ubicumque opus est aurum pro aureis, et ubicumque opus est argentum pro argenteis et pro quolibet opere per manus artificum; et si quis sponte offert, impleat manum suam hodie et offerat, quod voluerit, Domino '."
,"6":"Sponte obtulerunt itaque principes familiarum et proceres tribuum Israel, tribuni quoque et centuriones et principes operis regis;"
,"7":"dederuntque in opera domus Dei auri talenta quinque milia et solidos decem milia, argenti talenta decem milia et aeris talenta decem et octo milia, ferri quoque centum milia talentorum."
,"8":"Et apud quemcumque inventi sunt lapides, dederunt in thesaurum domus Domini in manum Iahiel Gersonitis."
,"9":"Laetatusque est populus super prompto animo eorum, quia corde toto offerebant ea Domino; sed et David rex laetatus est gaudio magno."
,"10":"Et benedixit Domino coram universa multitudine et ait: ' Benedictus es, Domine, Deus Israel patris nostri, ab aeterno in aeternum."
,"11":"Tua est, Domine, magnificentia et potentia, gloria, splendor atque maiestas. Cuncta enim, quae in caelo sunt et in terra, tua sunt. Tuum, Domine, regnum, et tu elevaris ut caput super omnia."
,"12":"De te sunt divitiae et gloria, tu dominaris omnium. In manu tua virtus et potentia, in manu tua est magnificare et firmare omnia."
,"13":"Nunc igitur, Deus noster, confitemur tibi,et laudamus nomen tuum inclitum. "
,"14":"Quis ego, et quis populus meus, ut possimus haec tibi universa offerre? Tua sunt haec omnia; et, quae de manu tua accepimus, dedimus tibi."
,"15":"Peregrini enim sumus coram te et advenae, sicut omnes patres nostri; dies nostri quasi umbra super terram, et nulla est spes."
,"16":"Domine Deus noster, omnis haec copia, quam paravimus, ut aedificaretur domus nomini sancto tuo, de manu tua est, et tua sunt omnia."
,"17":"Scio, Deus meus, quod probes corda et simplicitatem diligas; unde et ego in simplicitate cordis mei laetus obtuli universa haec et populum tuum, qui hic repertus est, vidi cum ingenti gaudio sponte tibi offerre donaria."
,"18":"Domine, Deus Abraham et Isaac et Israel patrum nostrorum, custodi in aeternum hanc voluntatem cordis eorum; et semper in venerationem tui mens ista permaneat."
,"19":"Salomoni quoque filio meo da cor perfectum, ut custodiat mandata tua, testimonia tua et legitima tua et faciat universa et aedificet aedem, cuius impensas paravi '."
,"20":"Praecepit autem David universae ecclesiae: ' Benedicite Domino Deo vestro! '. Et benedixit omnis ecclesia Domino, Deo patrum suorum; et inclinaverunt se et adoraverunt Deum et deinde regem."
,"21":"Immolaveruntque victimas Domino et obtulerunt holocausta die sequenti, tauros mille, arietes mille, agnos mille cum libaminibus suis et sacrificia abundantissime in omnem Israel."
,"22":"Et comederunt et biberunt coram Domino in die illo cum grandi laetitia; et fecerunt regem secundo Salomonem filium David atque unxerunt Domino in principem et Sadoc in pontificem."
,"23":"Seditque Salomon super solium Domini, ut esset rex pro David patre suo, et prosperatus est, et paruit illi omnis Israel."
,"24":"Sed et universi principes et fortes et cuncti filii regis David dederunt manum subicientes se Salomoni regi."
,"25":"Magnificavit ergo Dominus Salomonem in excelsum in conspectu omnis Israel et dedit illi gloriam regni, qualem nullus habuit ante eum rex Israel."
,"26":"Igitur David filius Isai regnavit super universum Israel;"
,"27":"et dies, quibus regnavit super Israel, fuerunt quadraginta anni: in Hebron regnavit septem annis et in Ierusalem annis triginta tribus."
,"28":"Et mortuus est in senectute bona plenus dierum et divitiis et gloria; et regnavit Salomon filius eius pro eo."
,"29":"Gesta autem David regis priora et novissima scripta sunt in libro Samuel videntis et in libro Nathan prophetae atque in volumine Gad videntis,"
,"30":"universique regni eius et fortitudinis et temporum, quae transierunt sub eo sive in Israel sive in cunctis regnis terrarum."
}`)

}
func LA_NVBSE_LoadVH1RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Et rex David senuerat habebat que aetatis plurimos dies; cum que operiretur vestibus, non calefiebat."
,"2":"Dixerunt ergo ei servi sui: ' Quaeratur domino nostro regi adulescentula virgo et stet coram rege et curam eius agat dormiatque in sinu tuo et calefaciat dominum nostrum regem '."
,"3":"Quaesierunt igitur adulescentulam speciosam in omnibus finibus Israel et invenerunt Abisag Sunamitin et adduxerunt eam ad regem."
,"4":"Erat autem puella pulchra nimis et curam agebat regis et ministrabat ei; rex vero non cognovit eam."
,"5":"Adonias autem filius Haggith elevabatur dicens: ' Ego regnabo! '. Fecitque sibi currum et equites et quinquaginta viros, qui ante eum currerent."
,"6":"Nec corripuit eum pater suus aliquando dicens: ' Quare hoc fecisti? '. Erat autem et ipse pulcher valde, secundus natu post Absalom."
,"7":"Et sermo ei cum Ioab filio Sarviae et cum Abiathar sacerdote, qui adiuvabant partes Adoniae."
,"8":"Sadoc vero sacerdos et Banaias filius Ioiadae et Nathan propheta et Semei et Rei et robur exercitus David non erat cum Adonia."
,"9":"Immolatis ergo Adonias ovibus et vitulis et pinguibus iuxta lapidem Zoheleth, qui erat vicinus fonti Rogel, vocavit universos fratres suos filios regis et omnes viros Iudae servos regis;"
,"10":"Nathan autem prophetam et Banaiam et robustos quosque et Salomonem fratrem suum non vocavit."
,"11":"Dixit itaque Nathan ad Bethsabee matrem Salomonis: ' Num audisti quod regnaverit Adonias filius Haggith, et dominus noster David hoc ignorat?"
,"12":"Nunc ergo veni, accipe a me consilium et salva animam tuam filiique tui Salomonis."
,"13":"Vade et ingredere ad regem David et dic ei: Nonne tu, domine mi rex, iurasti mihi ancillae tuae dicens: 'Salomon filius tuus regnabit post me et ipse sedebit in solio meo'? Quare ergo regnat Adonias?"
,"14":"Et, adhuc ibi te loquente cum rege, ego veniam post te et complebo sermones tuos '."
,"15":"Ingressa est itaque Bethsabee ad regem in cubiculo; rex autem senuerat nimis, et Abisag Sunamitis ministrabat ei."
,"16":"Inclinavit se Bethsabee et adoravit regem; ad quam rex: ' Quid tibi, inquit, vis? '."
,"17":"Quae respondens ait: ' Domine mi, tu iurasti per Dominum Deum tuum ancillae tuae: 'Salomon filius tuus regnabit post me, et ipse sedebit in solio meo';"
,"18":"et ecce nunc Adonias regnat, te, domine mi rex, ignorante."
,"19":"Mactavit boves et pinguia quaeque et oves plurimas et vocavit omnes filios regis, Abiathar quoque sacerdotem et Ioab principem militiae; Salomonem autem servum tuum non vocavit."
,"20":"Verumtamen, domine mi rex, in te oculi respiciunt totius Israel, ut indices eis quis sedere debeat in solio tuo, domine mi rex, post te."
,"21":"Eritque, cum dormierit dominus meus rex cum patribus suis, erimus ego et filius meus Salomon peccatores '."
,"22":"Adhuc illa loquente cum rege, Nathan propheta venit;"
,"23":"et nuntiaverunt regi dicentes: ' Adest Nathan propheta '. Cumque introisset ante conspectum regis et adorasset eum pronus in terram,"
,"24":"dixit Nathan: ' Domine mi rex, tu ergo dixisti: 'Adonias regnet post me, et ipse sedeat super thronum meum'?"
,"25":"Quia descendit hodie et immolavit boves et pinguia et arietes plurimos et vocavit universos filios regis et principes exercitus, Abiathar quoque sacerdotem; illique vescentes et bibentes coram eo dixerunt: 'Vivat rex Adonias!'."
,"26":"Me autem servum tuum et Sadoc sacerdotem et Banaiam filium Ioiadae et Salomonem famulum tuum non vocavit."
,"27":"Numquid a domino meo rege exivit hoc verbum, et mihi non indicasti servo tuo quis sessurus esset super thronum domini mei regis post eum? '."
,"28":"Et respondit rex David dicens: ' Vocate ad me Bethsabee '. Quae cum fuisset ingressa coram rege et stetisset ante eum,"
,"29":"iuravit rex et ait: ' Vivit Dominus, qui eruit animam meam de omni angustia,"
,"30":"quia, sicut iuravi tibi per Dominum, Deum Israel, dicens: Salomon filius tuus regnabit post me et ipse sedebit super solium meum pro me, sic faciam hodie '."
,"31":"Summissoque Bethsabee in terram vultu, adoravit regem dicens: ' Vivat dominus meus rex David in aeternum! '."
,"32":"Dixit quoque rex David: ' Vocate mihi Sadoc sacerdotem et Nathan prophetam et Banaiam filium Ioiadae '. Qui cum ingressi fuissent coram rege,"
,"33":"dixit ad eos: ' Tollite vobiscum servos domini vestri et imponite Salomonem filium meum, super mulam meam et ducite eum in Gihon,"
,"34":"et ungat eum ibi Sadoc sacerdos et Nathan propheta in regem super Israel, et canetis bucina atque dicetis: 'Vivat rex Salomon!'."
,"35":"Et ascendetis post eum, et veniet et sedebit super solium meum, et ipse regnabit pro me; illique praecipiam, ut sit dux super Israel et super Iudam '."
,"36":"Et respondit Banaias filius Ioiadae regi dicens: ' Amen, sic loquatur Dominus Deus domini mei regis."
,"37":"Quomodo fuit Dominus cum domino meo rege, sic sit cum Salomone et sublimius faciat solium eius a solio domini mei regis David '."
,"38":"Descendit ergo Sadoc sacerdos et Nathan propheta et Banaias filius Ioiadae et Cherethi et Phelethi, et imposuerunt Salomonem super mulam regis David et adduxerunt eum in Gihon."
,"39":"Sumpsitque Sadoc sacerdos cornu olei de tabernaculo et unxit Salomonem; et cecinerunt bucina, et dixit omnis populus: ' Vivat rex Salomon! '."
,"40":"Et ascendit universa multitudo post eum, et populus canebat tibiis et laetabatur gaudio magno, et insonuit terra ad clamorem eorum."
,"41":"Audivit autem Adonias et omnes, qui invitati fuerant ab eo; iamque convivium finitum erat. Sed et Ioab, audita voce tubae, ait: ' Quid sibi vult clamor civitatis tumultuantis? '."
,"42":"Adhuc illo loquente, Ionathan filius Abiathar sacerdotis venit; cui dixit Adonias: ' Ingredere, quia vir strenuus es et bona nuntians '."
,"43":"Responditque Ionathan Adoniae: ' Nequaquam! Dominus enim noster, rex David, regem constituit Salomonem"
,"44":"misitque cum eo Sadoc sacerdotem et Nathan prophetam et Banaiam filium Ioiadae et Cherethi et Phelethi, et imposuerunt eum super mulam regis;"
,"45":"unxeruntque eum Sadoc sacerdos et Nathan propheta regem in Gihon. Et ascenderunt inde laetantes, et insonuit civitas; haec est vox, quam audistis."
,"46":"Sed et Salomon sedit super solio regni,"
,"47":"et ingressi servi regis benedixerunt domino nostro regi David dicentes: 'Amplificet Deus nomen Salomonis super nomen tuum et magnificet thronum eius super thronum tuum'. Et adoravit rex in lectulo suo."
,"48":"Insuper et haec locutus est: 'Benedictus Dominus, Deus Israel, qui dedit hodie sedentem in solio meo, videntibus oculis meis' '."
,"49":"Territi sunt ergo et surrexerunt omnes, qui invitati fuerant ab Adonia, et ivit unusquisque in viam suam."
,"50":"Adonias autem timens Salomonem surrexit et abiit tenuitque cornua altaris."
,"51":"Et nuntiaverunt Salomoni dicentes: ' Ecce Adonias timens regem Salomonem tenuit cornua altaris dicens: 'Iuret mihi hodie rex Salomon quod non interficiat servum suum gladio'."
,"52":"Dixitque Salomon: ' Si fuerit vir bonus, non cadet ne unus quidem capillus eius in terram; sin autem malum inventum fuerit in eo, morietur '."
,"53":"Misit ergo rex Salomon et eduxit eum ab altari, et ingressus adoravit regem Salomonem; dixitque ei Salomon: ' Vade in domum tuam '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Appropinquaverant autem dies David ut moreretur, praecepit que Salomoni filio suo dicens:"
,"2":"' Ego ingredior viam universae terrae; confortare et esto vir"
,"3":"et observa decreta Domini Dei tui, ut ambules in viis eius et custodias statuta eius et praecepta eius et iudicia et testimonia, sicut scriptum est in lege Moysi, ut prospere agas in universis, quae facis et quocumque te verteris;"
,"4":"ut confirmet Dominus sermonem suum, quem locutus est de me dicens: 'Si custodierint filii tui viam suam et ambulaverint coram me in veritate, in omni corde suo et in omni anima sua, non auferetur tibi vir de solio Israel'."
,"5":"Tu quoque nosti, quae fecerit mihi Ioab filius Sarviae, quae fecerit duobus principibus exercitus Israel, Abner filio Ner et Amasae filio Iether, quos occidit; et effudit sanguinem belli in pace et posuit cruorem proelii in balteo suo, qui erat circa lumbos eius, et in calceamento suo, quod erat in pedibus eius."
,"6":"Facies ergo iuxta sapientiam tuam et non deduces canitiem eius pacifice ad inferos."
,"7":"Sed filiis Berzellai Galaaditis reddes gratiam, eruntque comedentes in mensa tua; occurrerunt enim mihi, quando fugiebam a facie Absalom fratris tui."
,"8":"Habes quoque apud te Semei filium Gera de Beniamin de Bahurim, qui maledixit mihi maledictione pessima, quando ibam ad Mahanaim; sed quia descendit mihi in occursum ad Iordanem, et iuravi ei per Dominum dicens: Non te interficiam gladio."
,"9":"Tu noli pati esse eum innoxium; vir autem sapiens es et scies, quae facias ei deducesque canos eius cum sanguine ad infernum '."
,"10":"Dormivit igitur David cum patribus suis et sepultus est in civitate David."
,"11":"Dies autem, quibus regnavit David super Israel, quadraginta anni sunt: in Hebron regnavit septem annis, in Ierusalem triginta tribus."
,"12":"Salomon autem sedit super thronum David patris sui, et firmatum est regnum eius nimis."
,"13":"Et ingressus est Adonias filius Haggith ad Bethsabee matrem Salomonis, quae dixit ei: ' Pacificusne ingressus tuus? '. Qui respondit: ' Pacificus '."
,"14":"Addiditque: ' Sermo mihi est ad te '. Cui ait: ' Loquere '. Et ille:"
,"15":"' Tu, inquit, nosti quia meum erat regnum, et me proposuerat omnis Israel sibi in regem, sed translatum est regnum et factum est fratris mei; a Domino enim constitutum est ei."
,"16":"Nunc ergo petitionem unam deprecor a te; ne confundas faciem meam '. Quae dixit ad eum: ' Loquere '."
,"17":"Et ille ait: ' Precor, ut dicas Salomoni regi - neque enim negare tibi quidquam potest - ut det mihi Abisag Sunamitin uxorem '."
,"18":"Et ait Bethsabee: ' Bene, ego loquar pro te regi '."
,"19":"Venit ergo Bethsabee ad regem Salomonem, ut loqueretur ei pro Adonia. Et surrexit rex in occursum eius adoravitque eam et sedit super thronum suum; positus quoque est thronus matri regis, quae sedit ad dexteram eius."
,"20":"Dixitque ei: ' Petitionem unam parvulam ego deprecor a te; ne confundas faciem meam'. Dixit ei rex: ' Pete, mater mi, neque enim fas est, ut avertam faciem tuam '."
,"21":"Quae ait: ' Detur Abisag Sunamitis Adoniae fratri tuo uxor '."
,"22":"Responditque rex Salomon et dixit matri suae: ' Quare postulas Abisag Sunamitin Adoniae? Postula ei et regnum! Ipse est enim frater meus maior me et habet Abiathar sacerdotem et Ioab filium Sarviae '."
,"23":"Iuravit itaque rex Salomon per Dominum dicens: ' Haec faciat mihi Deus et haec addat, certe contra animam suam locutus est Adonias verbum hoc."
,"24":"Et nunc, vivit Dominus, qui firmavit me et collocavit me super solium David patris mei et qui fecit mihi domum, sicut locutus est, certe hodie occidetur Adonias '."
,"25":"Misitque rex Salomon per manum Banaiae filii Ioiadae, qui interfecit eum, et mortuus est."
,"26":"Abiathar quoque sacerdoti dixit rex: ' Vade in Anathoth ad agrum tuum; es quidem vir mortis, sed hodie te non interficiam, quia portasti arcam Domini Dei coram David patre meo et sustinuisti laborem in omnibus, in quibus laboravit pater meus '."
,"27":"Eiecit ergo Salomon Abiathar, ut non esset sacerdos Domini, ut impleretur sermo Domini, quem locutus est super domum Heli in Silo."
,"28":"Venit autem nuntius ad Ioab. Ioab autem declinaverat post Adoniam, cum post Absalom non declinasset; fugit ergo Ioab in tabernaculum Domini et apprehendit cornua altaris."
,"29":"Nuntiatumque est regi Salomoni, quod fugisset Ioab in tabernaculum Domini et esset iuxta altare; misitque Salomon Banaiam filium Ioiadae dicens: ' Vade, interfice eum! '."
,"30":"Venit Banaias ad tabernaculum Domini et dixit ei: ' Haec dicit rex: Egredere!'. Qui ait: ' Non egrediar, sed hic moriar '. Renuntiavit Banaias regi sermonem dicens: ' Haec locutus est Ioab et haec respondit mihi '."
,"31":"Dixitque ei rex: ' Fac, sicut locutus est, et interfice eum et sepeli; et amovebis sanguinem innocentem, qui effusus est a Ioab, a me et a domo patris mei."
,"32":"Et reddet Dominus sanguinem eius super caput eius, quia interfecit duos viros iustos melioresque se et occidit eos gladio, patre meo David ignorante: Abner filium Ner principem militiae Israel et Amasam filium Iether principem exercitus Iudae."
,"33":"Et revertetur sanguis illorum in caput Ioab et in caput seminis eius in sempiternum; David autem et semini eius et domui et throno illius sit pax usque in aeternum a Domino '."
,"34":"Ascendit itaque Banaias filius Ioiadae et aggressus eum interfecit; sepultusque est in domo sua in deserto."
,"35":"Et constituit rex Banaiam filium Ioiadae pro eo super exercitum et Sadoc sacerdotem posuit pro Abiathar."
,"36":"Misit quoque rex et vocavit Semei dixitque ei: ' Aedifica tibi domum in Ierusalem et habita ibi et non egredieris inde huc atque illuc;"
,"37":"quacumque autem die egressus fueris et transieris torrentem Cedron, scito te interficiendum; sanguis tuus erit super caput tuum '."
,"38":"Dixitque Semei regi: ' Bonus sermo; sicut locutus est dominus meus rex, sic faciet servus tuus '. Habitavit itaque Semei in Ierusalem diebus multis."
,"39":"Factum est autem post annos tres, ut fugerent duo servi Semei ad Achis filium Maacha regem Geth; nuntiatumque est Semei quod servi eius essent in Geth."
,"40":"Et surrexit Semei et stravit asinum suum ivitque in Geth ad Achis ad requirendos servos suos et adduxit eos de Geth."
,"41":"Nuntiatum est autem Salomoni quod isset Semei in Geth de Ierusalem et redisset."
,"42":"Et mittens vocavit eum dixitque illi: ' Nonne testificatus sum tibi per Dominum et praedixi tibi: Quacumque die egressus ieris huc et illuc, scito te esse moriturum? Et respondisti mihi 'Bonus sermo; audivi'."
,"43":"Quare ergo non custodisti iusiurandum Domini et praeceptum, quod praeceperam tibi? '."
,"44":"Dixitque rex ad Semei: ' Tu nosti omne malum, cuius tibi conscium est cor tuum, quod fecisti David patri meo; reddit Dominus malitiam tuam in caput tuum."
,"45":"Et rex Salomon benedictus, et thronus David erit stabilis coram Domino usque in sempiternum '."
,"46":"Iussit itaque rex Banaiae filio Ioiadae, qui egressus percussit eum, et mortuus est. Confirmatum est igitur regnum in manu Salomonis."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et affinitate coniunctus est pharaoni regi Aegypti. Accepit namque filiam eius et adduxit in civitatem David, donec compleret aedificans domum suam et domum Domini et murum Ierusalem per circuitum."
,"2":"Attamen populus immolabat in excelsis; non enim aedificatum erat templum nomini Domini usque in diem illum."
,"3":"Dilexit autem Salomon Dominum ambulans in praeceptis David patris sui, excepto quod in excelsis immolabat et accendebat thymiama."
,"4":"Abiit itaque in Gabaon, ut immolaret ibi; illud quippe erat excelsum maximum. Mille hostias in holocaustum obtulit Salomon super altare illud."
,"5":"In Gabaon apparuit Dominus Salomoni per somnium nocte dicens: ' Postula quod vis, ut dem tibi '."
,"6":"Et ait Salomon: ' Tu fecisti cum servo tuo David patre meo misericordiam magnam, sicut ambulavit in conspectu tuo in veritate et iustitia et recto corde tecum; custodisti ei misericordiam tuam grandem et dedisti ei filium sedentem super thronum eius, sicut est hodie."
,"7":"Et nunc, Domine Deus meus, tu regnare fecisti servum tuum pro David patre meo. Ego autem sum puer parvus et ignorans egressum et introitum meum;"
,"8":"et servus tuus in medio est populi, quem elegisti, populi infiniti, qui numerari et supputari non potest prae multitudine."
,"9":"Da ergo servo tuo cor docile, ut iudicare possit populum tuum et discernere inter bonum et malum. Quis enim potest iudicare populum tuum hunc multum? '."
,"10":"Placuit ergo sermo coram Domino quod Salomon rem huiuscemodi postulasset,"
,"11":"et dixit Deus Salomoni: ' Quia postulasti verbum hoc et non petisti tibi dies multos nec divitias aut animam inimicorum tuorum, sed postulasti tibi sapientiam ad discernendum iudicium,"
,"12":"ecce feci tibi secundum sermones tuos et dedi tibi cor sapiens et intellegens, in tantum ut nullus ante te similis tui fuerit nec post te surrecturus sit;"
,"13":"sed et haec, quae non postulasti, dedi tibi, divitias scilicet et gloriam, ut nemo fuerit similis tui in regibus cunctis diebus tuis."
,"14":"Si autem ambulaveris in viis meis et custodieris praecepta mea et mandata mea, sicut ambulavit David pater tuus, longos faciam dies tuos '."
,"15":"Igitur evigilavit Salomon et intellexit quod esset somnium. Cumque venisset Ierusalem, stetit coram arca foederis Domini et obtulit holocausta et fecit victimas pacificas et convivium universis famulis suis."
,"16":"Tunc venerunt duae mulieres meretrices ad regem steteruntque coram eo."
,"17":"Quarum una ait: ' Obsecro, mi domine; ego et mulier haec habitabamus in domo una, et peperi apud eam in domo;"
,"18":"tertia vero die, postquam ego peperi, peperit et haec; et eramus simul, nullusque alius nobiscum in domo, exceptis nobis duabus."
,"19":"Mortuus est autem filius mulieris huius nocte; dormiens quippe oppressit eum."
,"20":"Et consurgens intempesta nocte, silentio tulit filium meum de latere meo ancillae tuae dormientis et collocavit in sinu suo; suum autem filium, qui erat mortuus, posuit in sinu meo."
,"21":"Cumque surrexissem mane, ut darem lac filio meo, apparuit mortuus; quem diligentius intuens clara luce, deprehendi non esse meum, quem genueram '."
,"22":"Responditque altera mulier: ' Non est ita, sed filius meus vivit, tuus autem mortuus est '. E contrario illa dicebat: ' Mentiris. Filius quippe tuus mortuus est, meus autem vivit '. Atque in hunc modum contendebant coram rege."
,"23":"Tunc rex ait: ' Haec dicit: 'Filius meus vivit, et filius tuus mortuus est'; et ista respondit: 'Non, sed filius tuus mortuus est, et filius meus vivit' '."
,"24":"Dixit ergo rex: ' Afferte mihi gladium! '. Cumque attulissent gladium coram rege:"
,"25":"' Dividite, inquit, infantem vivum in duas partes, et date dimidiam partem uni et dimidiam partem alteri '."
,"26":"Dixit autem mulier, cuius filius erat vivus, ad regem - commota sunt quippe viscera eius super filio suo -: ' Obsecro, domine, date illi infantem vivum et nolite interficere eum '. E contrario illa dicebat: ' Nec mihi nec tibi sit; dividatur '."
,"27":"Respondens rex ait: ' Date huic infantem vivum, et non occidatur; haec est mater eius '."
,"28":"Audivit itaque omnis Israel iudicium, quod iudicasset rex; et timuerunt regem videntes sapientiam Dei esse in eo ad faciendum iudicium."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Erat autem rex Salomon regnans super omnem Israel."
,"2":"Et hi principes quos habebat: Azarias filius Sadoc sacerdos;"
,"3":"Elihoreph et Ahia filii Sisa scribae; Iosaphat filius Ahilud cancellarius;"
,"4":"Banaias filius Ioiadae super exercitum; Sadoc autem et Abiathar sacerdotes;"
,"5":"Azarias filius Nathan super praefectos; Zabud filius Nathan sacerdos amicus regis;"
,"6":"et Ahisar praepositus domus et Adoniram filius Abda super tributa."
,"7":"Habebat autem Salomon duodecim praefectos super omnem Israel, qui praebebant annonam regi et domui eius; per singulos enim menses in anno singuli necessaria ministrabant."
,"8":"Et haec nomina eorum: Benhur in monte Ephraim;"
,"9":"Bendecar in Maces et in Salebim et in Bethsames et in Elon et in Bethanan;"
,"10":"Benhesed in Aruboth, ipsius erat Socho et omnis terra Epher;"
,"11":"Benabinadab, cuius omnis regio Dor, Tapheth filiam Salomonis habebat uxorem;"
,"12":"Baana filius Ahilud regebat Thanach et Mageddo et universam Bethsan, quae est iuxta Sarthan subter Iezrahel, a Bethsan usque Abelmehula et usque ultra Iecmaam;"
,"13":"Bengaber in Ramoth Galaad habebat villas Iair filii Manasse in Galaad: ipse praeerat in omni regione Argob, quae est in Basan, sexaginta civitatibus magnis atque muratis, quae habebant seras aereas;"
,"14":"Ahinadab filius Addo praeerat in Mahanaim;"
,"15":"Achimaas in Nephthali, sed et ipse habebat Basemath filiam Salomonis in coniugio;"
,"16":"Baana filius Chusai in Aser et in Baloth;"
,"17":"Iosaphat filius Pharue in Issachar;"
,"18":"Semei filius Ela in Beniamin;"
,"19":"Gaber filius Uri in terra Galaad, in terra Sehon regis Amorraei et Og regis Basan, ut praefectus unus, qui erat in terra."
,"20":"Iuda et Israel innumerabiles, sicut arena maris in multitudine, comedentes et bibentes atque laetantes."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Salomon autem erat in dicione sua habens omnia regna a Flu mine usque ad terram Philisthim et ad terminum Aegypti offerentium sibi munera et servientium ei cunctis diebus vitae eius."
,"2":"Erat autem cibus Salomonis per dies singulos triginta chori similae et sexaginta chori farinae,"
,"3":"decem boves pingues et viginti boves pascuales et centum oves, excepta venatione cervorum, caprearum atque bubalorum et avium altilium."
,"4":"Ipse enim obtinebat omnem regionem, quae erat trans Flumen, a Thaphsa usque Gazam, et cunctos reges illarum regionum; et habebat pacem ex omni parte in circuitu."
,"5":"Habitabatque Iuda et Israel absque timore ullo, unusquisque sub vite sua et sub ficu sua a Dan usque Bersabee cunctis diebus Salomonis."
,"6":"Et habebat Salomon quattuor milia praesepia equorum currulium et duodecim milia equestres."
,"7":"Et praebebant supradicti praefecti necessaria mensae regis Salomonis et convivarum eius cum ingenti cura, unusquisque in suo mense."
,"8":"Hordeum quoque et paleas equorum et iumentorum deferebant in locum, ubi erat unicuique constitutum."
,"9":"Dedit quoque Deus sapientiam Salomoni et prudentiam multam nimis et latitudinem cordis quasi arenam, quae est in litore maris."
,"10":"Et praecedebat sapientia Salomonis sapientiam omnium Orientalium et Aegyptiorum;"
,"11":"et erat sapientior cunctis hominibus, sapientior Ethan Ezrahita et Heman et Chalchol et Darda filiis Mahol et erat nominatus in universis gentibus per circuitum."
,"12":"Locutus est quoque Salomon tria milia parabolas, et fuerunt carmina eius quinque et mille."
,"13":"Et disputavit super lignis, a cedro, quae est in Libano, usque ad hyssopum, quae egreditur de pariete; et disseruit de iumentis et volucribus et reptilibus et piscibus."
,"14":"Et veniebant de cunctis populis ad audiendam sapientiam Salomonis, ab universis regibus terrae, qui audiebant sapientiam eius."
,"15":"Misit quoque Hiram rex Tyri servos suos ad Salomonem; audivit enim quod ipsum unxissent regem pro patre eius, quia amicus fuerat Hiram David omni tempore."
,"16":"Misit autem et Salomon ad Hiram dicens:"
,"17":"' Tu scis voluntatem David patris mei et quia non potuerit aedificare domum nomini Domini Dei sui propter bella imminentia per circuitum, donec daret Dominus eos sub vestigio pedum eius."
,"18":"Nunc autem requiem dedit Dominus Deus meus mihi per circuitum; non est adversarius neque occursus malus."
,"19":"Quam ob rem cogito aedificare templum nomini Domini Dei mei, sicut locutus est Dominus David patri meo dicens: 'Filius tuus, quem dabo pro te super solium tuum, ipse aedificabit domum nomini meo'."
,"20":"Praecipe igitur, ut praecidant mihi cedros de Libano, et servi mei sint cum servis tuis; mercedem autem servorum tuorum dabo tibi quamcumque praeceperis; scis enim quoniam non est in populo meo vir, qui noverit ligna caedere sicut Sidonii '."
,"21":"Cum ergo audisset Hiram verba Salomonis, laetatus est valde et ait: ' Benedictus Dominus hodie, qui dedit David filium sapientissimum super populum hunc plurimum '."
,"22":"Et misit Hiram ad Salomonem dicens: ' Audivi, quaecumque mandasti mihi; ego faciam omnem voluntatem tuam in lignis cedrinis et abiegnis."
,"23":"Servi mei deponent ea de Libano ad mare, et ego componam ea in ratibus in mari usque ad locum, quem significaveris mihi, et applicabo ea ibi, et tu tolles ea; praebebisque necessaria mihi, ut detur cibus domui meae '."
,"24":"Itaque Hiram dabat Salomoni ligna cedrina et ligna abiegna iuxta omnem voluntatem eius."
,"25":"Salomon autem praebebat Hiram viginti milia chororum tritici in cibum domui eius et viginti choros purissimi olei; haec tribuebat Salomon Hiram per annos singulos."
,"26":"Dedit quoque Dominus sapientiam Salomoni, sicut locutus est ei; et erat pax inter Hiram et Salomonem, et percusserunt foedus ambo."
,"27":"Elegitque rex Salomon operas de omni Israel, et erat indictio triginta milia virorum."
,"28":"Mittebatque eos in Libanum decem milia per menses singulos vicissim, ita ut duobus mensibus essent in domibus suis; et Adoniram erat super huiuscemodi indictione."
,"29":"Fueruntque Salomoni septuaginta milia eorum, qui onera portabant, et octoginta milia latomorum in monte,"
,"30":"absque praepositis, qui praeerant singulis operibus numero trium milium et trecentorum praecipientium populo, his, qui faciebant opus."
,"31":"Praecepitque rex, ut tollerent lapides grandes, lapides pretiosos in fundamentum templi, lapides quadratos;"
,"32":"dolaverunt ergo caementarii Salomonis, caementarii Hiram et Giblii ligna et lapides et praeparaverunt ad aedificandam domum."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Factum est igitur quadringente simo et octogesimo anno egres sionis filiorum Israel de terra Aegypti, in anno quarto, mense Ziv - ipse est mensis secundus - regni Salomonis super Israel, aedificare coepit domum Domino."
,"2":"Domus autem, quam aedificabat rex Salomon Domino, habebat sexaginta cubitos in longitudine et viginti cubitos in latitudine et triginta cubitos in altitudine."
,"3":"Et porticus erat ante templum viginti cubitorum longitudinis iuxta mensuram latitudinis templi et habebat decem cubitos latitudinis ante faciem templi."
,"4":"Fecitque in templo fenestras cum marginibus et cancellis."
,"5":"Et aedificavit contra parietem templi tabulata per gyrum in parietibus domus per circuitum templi et Dabir et fecit latera in circuitu."
,"6":"Tabulatum, quod subter erat, quinque cubitos habebat latitudinis et medium tabulatum sex cubitorum latitudinis et tertium tabulatum septem habens cubitos latitudinis; gradus enim posuit in domo per circuitum forinsecus, ut non ingrederentur trabes in muros templi."
,"7":"Domus autem cum aedificaretur, lapidibus dedolatis atque perfectis aedificata est; et malleus et securis et omne ferramentum non sunt audita in domo, cum aedificaretur."
,"8":"Ostium lateris inferioris in parte erat domus dextrae, et per cochleam ascendebant in medium latus et a medio in tertium."
,"9":"Et aedificavit domum et consummavit eam; texit quoque domum laquearibus cedrinis."
,"10":"Aedificavit ergo stratum contra omnem domum quinque cubitis altitudinis et iunxit domui lignis cedrinis."
,"11":"Et factus est sermo Domini ad Salomonem dicens:"
,"12":"' Domus haec, quam aedificas, si ambulaveris in praeceptis meis et iudicia mea feceris et custodieris omnia mandata mea gradiens per ea, firmabo sermonem meum tibi, quem locutus sum ad David patrem tuum;"
,"13":"et habitabo in medio filiorum Israel et non derelinquam populum meum Israel '."
,"14":"Igitur aedificavit Salomon domum et consummavit eam."
,"15":"Et aedificavit parietes domus intrinsecus tabulis cedrinis; a pavimento domus usque ad summitatem parietum et usque ad laquearia operuit lignis intrinsecus et texit pavimentum domus tabulis abiegnis."
,"16":"Aedificavitque viginti cubitorum a posteriore parte templi tabulis cedrinis a pavimento usque ad superiora; et fecit ei intrinsecus Dabir, id est sancta sanctorum."
,"17":"Porro quadraginta cubitorum erat ipsum templum ante illud."
,"18":"Et cedrus in domo intrinsecus sculptas habebat colocynthidas et calices apertos florum. Omnia cedrinis tabulis vestiebantur, nec omnino lapis apparere poterat in pariete."
,"19":"Dabir autem in medio domus in interiori parte fecerat, ut poneret ibi arcam foederis Domini."
,"20":"Habebat viginti cubitos longitudinis et viginti cubitos latitudinis et viginti cubitos altitudinis; et vestivit illud auro purissimo et fecit altare cedrinum ante Dabir."
,"21":"Domum quoque operuit Salomon intrinsecus auro purissimo et posuit catenas aureas ante Dabir."
,"22":"Nihilque erat in templo, quod non auro tegeretur; sed et totum altare Dabir texit auro."
,"23":"Et fecit in Dabir duos cherubim de lignis oleastri decem cubitorum altitudinis."
,"24":"Quinque cubitorum ala cherub una et quinque cubitorum ala cherub altera, id est decem cubitos habentes a summitate alae unius usque ad alae alterius summitatem."
,"25":"Decem quoque cubitorum erat cherub secundus, mensura par et effigies una erat duobus cherubim;"
,"26":"altitudinem habebat unus cherub decem cubitorum et similiter cherub secundus."
,"27":"Posuitque cherubim in medio templi interioris; extendebant autem alas suas cherubim, et tangebat ala una parietem et ala cherub secundi tangebat parietem alterum; alae autem alterae in media parte templi se invicem contingebant."
,"28":"Texit quoque cherubim auro."
,"29":"Et omnes parietes templi per circuitum scalpsit variis caelaturis; et fecit in eis cherubim et palmas et calices apertos florum intrinsecus et foras."
,"30":"Sed et pavimentum domus texit auro intrinsecus et extrinsecus."
,"31":"Et pro ingressu Dabir fecit valvas de lignis oleastri postesque cum marginibus quinque."
,"32":"Et in duabus valvis de lignis oleastri scalpsit cherubim et palmas et calices apertos florum et vestivit ea auro operiens tam cherubim quam palmas et cetera auro."
,"33":"Fecitque eodem modo pro introitu templi postes cum quattuor marginibus de lignis oleastri"
,"34":"et duas valvas de lignis abiegnis; et utraque valva duplex erat et versatilis."
,"35":"Et scalpsit cherubim et palmas et calices apertos florum operuitque omnia laminis aureis."
,"36":"Et aedificavit atrium interius tribus ordinibus lapidum politorum et uno ordine lignorum cedri."
,"37":"Anno quarto fundata est domus Domini in mense Ziv;"
,"38":"et in anno undecimo, mense Bul - ipse est mensis octavus - perfecta est domus in omni opere suo et in universis utensilibus; aedificavitque eam annis septem."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Domum autem suam aedificavit Salomon tredecim annis et ad perfectum usque perduxit."
,"2":"Aedificavit quoque domum Saltus Libani centum cubitorum longitudinis et quinquaginta cubitorum latitudinis et triginta cubitorum altitudinis super quattuor ordines columnarum cedrinarum, et ligna cedrina super columnas."
,"3":"Et erat tectum cedrinum in alto super tabulas quadraginta quinque, quae erant super columnas, quindecim in uno ordine,"
,"4":"et marginum tres ordines, fenestra iuxta fenestram tribus vicibus."
,"5":"Ostia, id est postes, habebant quadruplicem marginem."
,"6":"Et porticum columnarum fecit quinquaginta cubitorum longitudinis et triginta cubitorum latitudinis, et alteram porticum in facie maioris porticus et columnas et cancellos ante eas."
,"7":"Porticum quoque solii, in qua tribunal erat, fecit et texit lignis cedrinis a pavimento usque ad pavimentum."
,"8":"Et domus, in qua habitabat, erat in altero atrio intro a porticu et simili opere. Domum quoque fecit filiae pharaonis, quam uxorem duxerat Salomon, tali opere quali et hanc porticum."
,"9":"Omnia lapidibus pretiosis, qui ad normam quandam atque mensuram tam intrinsecus quam extrinsecus serrati erant, a fundamento usque ad summitatem parietum, et extrinsecus usque ad atrium maius."
,"10":"Fundamenta autem de lapidibus pretiosis, lapidibus magnis decem sive octo cubitorum."
,"11":"Et desuper lapides pretiosi secundum mensuram secti et ligna cedrina."
,"12":"Et atrium maius in circuitu habebat tres ordines de lapidibus sectis et unum ordinem de dolata cedro; necnon et atrium domus Domini interius et porticus domus."
,"13":"Misit quoque rex Salomon et tulit Hiram de Tyro,"
,"14":"filium mulieris viduae de tribu Nephthali, patre Tyrio, artificem aerarium et plenum sapientia et intellegentia et doctrina ad faciendum omne opus ex aere. Qui, cum venisset ad regem Salomonem, fecit omne opus eius."
,"15":"Et finxit duas columnas aereas, decem et octo cubitorum altitudinis columnam unam, et linea duodecim cubitorum ambiebat columnam, et grossitudo eius quattuor digitorum, et intrinsecus cava erat; sic et columna altera."
,"16":"Duo quoque capitella fecit, quae ponerentur super capita columnarum, fusili aere; quinque cubitorum altitudinis capitellum unum et quinque cubitorum altitudinis capitellum alterum,"
,"17":"et serta quasi in modum texturae, fimbriae in modum catenarum sibi invicem miro opere contextarum in capitellis, quae erant super caput columnarum, septem in capitello uno et septem in capitello altero."
,"18":"Et fecit malogranatorum duos ordines per circuitum super sertum unum, ut tegerent capitella, quae erant super summitatem columnarum; eodem modo fecit et capitello secundo."
,"19":"Capitella autem, quae erant super capita columnarum, quasi opere lilii fabricata erant in porticu, quattuor cubitorum."
,"20":"Et rursum alia capitella in summitate duarum columnarum etiam desuper, iuxta alvum, quae erat super sertum. Malogranatorum autem ducentorum duo ordines erant in circuitu capitelli primi et eodem modo in circuitu capitelli secundi."
,"21":"Et statuit duas columnas in porticum templi; cumque statuisset columnam dexteram, vocavit eam nomine Iachin, similiter erexit columnam sinistram et vocavit nomen eius Booz."
,"22":"Et super capita columnarum opus in modum lilii posuit; per fectumque est opus columnarum."
,"23":"Fecit quoque mare fusile decem cubitorum a labio usque ad labium, rotundum in circuitu, quinque cubitorum altitudo eius; et resticula triginta cubitorum cingebat illud per circuitum."
,"24":"Et scalptura colocynthidum subter labium circuibat illud, duo ordines scalpturarum fusilium in una fusione cum mari."
,"25":"Et stabat super duodecim boves, e quibus tres respiciebant ad aquilonem et tres ad occidentem et tres ad meridiem et tres ad orientem, et mare super eos desuper erat; quorum posteriora universa intrinsecus latitabant."
,"26":"Grossitudo autem luteris habebat mensuram palmi, labiumque eius erat quasi labium calicis et folium repandi lilii; duo milia batos capiebat."
,"27":"Et fecit bases decem aereas, quattuor cubitorum longitudinis bases singulas et quattuor cubitorum latitudinis et trium cubitorum altitudinis."
,"28":"Hoc autem erat opus basium: limbos habebant, insuper et limbos inter columellas."
,"29":"Super limbos inter columellas erant leones et boves et cherubim, et super columellas similiter; supra et infra leones et boves erant coronae, opus malleatum."
,"30":"Et quattuor rotae per bases singulas et axes aerei, et quattuor pedes et quasi umeruli subter luterem fusiles, contra singulos coronae."
,"31":"Et os eius erat rotundum, opus basis, unius cubiti et dimidii; etiam in ore eius variae caelaturae erant, limbi autem eius erant quadrati, non rotundi."
,"32":"Quattuor quoque rotae subter limbis erant, et fulcra rotarum cohaerebant basi; una rota habebat altitudinis cubitum et semis."
,"33":"Tales autem rotae erant, quales solent in curru fieri, et fulcra earum et canthi et radii et modioli, omnia fusilia."
,"34":"Nam et umeruli illi quattuor per singulos angulos basis unius ex ipsa basi fusiles et coniuncti erant."
,"35":"In summitate autem basis erat quaedam rotunditas dimidii cubiti, et in summitate basis fulcra eius et limbi eius ex semetipsa."
,"36":"Scalpsit quoque in tabulatis illis, fulcris eius et super limbos eius cherubim et leones et palmas secundum vacuum singulorum, et coronas per circuitum."
,"37":"In hunc modum fecit decem bases, fusura una, et mensura scalpturaque consimili."
,"38":"Fecit quoque decem luteres aereos; quadraginta batos capiebat luter unus, eratque quattuor cubitorum; singulosque luteres per singulas, id est decem bases posuit."
,"39":"Et constituit decem bases, quinque ad dexteram partem templi et quinque ad sinistram; mare autem posuit ad dexteram partem templi contra orientem ad meridiem."
,"40":"Fecit quoque Hiram lebetes et vatilla et phialas et perfecit omne opus regi Salomoni in templo Domini;"
,"41":"columnas duas et globos capitellorum super capita columnarum duos et serta duo, ut operirent duos globos, qui erant super capita columnarum;"
,"42":"et malogranata quadringenta in duobus sertis, duos versus malogranatorum in sertis singulis, ad operiendos globos capitellorum, qui erant super faciem columnarum;"
,"43":"et bases decem et luteres decem super bases"
,"44":"et mare unum et boves duodecim subter mare;"
,"45":"et lebetes et vatilla et phialas. Omnia vasa, quae fecit Hiram regi Salomoni in domo Domini, de aere polito erant."
,"46":"In campestri regione Iordanis fudit ea rex in argillosa terra inter Succoth et Sarthan."
,"47":"Et posuit Salomon omnia vasa; propter multitudinem autem nimiam ignorabatur pondus aeris."
,"48":"Fecitque Salomon omnia vasa in domo Domini: altare aureum et mensam, super quam ponerentur panes propositionis, auream;"
,"49":"et candelabra, quinque ad dexteram et quinque ad sinistram contra Dabir, ex auro puro, et florem et lucernas desuper aureas; et forcipes aureos"
,"50":"et pateras et cultros et phialas et sartagines et turibula de auro purissimo; et cardines ostiorum domus interioris Sancti sanctorum et ostiorum domus templi ex auro."
,"51":"Et perfecit omne opus, quod faciebat Salomon in domo Domini, et intulit Salomon, quae sanctificaverat David pater suus, argentum et aurum et vasa, reposuitque in thesauris domus Domini."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Tunc congregavit Salomon om nes maiores natu Israel - om nes principes tribuum, duces familiarum filiorum Israel ad regem Salomonem - in Ierusalem, ut deferrent arcam foederis Domini de civitate David, id est de Sion."
,"2":"Convenitque ad regem Salomonem universus Israel in mense Ethanim in sollemnitate, ipse est mensis septimus."
,"3":"Veneruntque cuncti senes Israel, et tulerunt sacerdotes arcam"
,"4":"et portaverunt arcam Domini et tabernaculum conventus et omnia vasa sanctuarii, quae erant in tabernaculo; et ferebant ea sacerdotes et Levitae."
,"5":"Rex autem Salomon et universus coetus Israel, qui convenerat ad eum, cum illo ante arcam immolabant oves et boves absque aestimatione et numero."
,"6":"Et intulerunt sacerdotes arcam foederis Domini in locum suum in Dabir templi, in sanctum sanctorum, subter alas cherubim;"
,"7":"siquidem cherubim expandebant alas super locum arcae et protegebant arcam et vectes eius desuper."
,"8":"Cumque eminerent vectes et apparerent summitates eorum foris in sanctuario ante Dabir, non apparebant ultra extrinsecus; qui et fuerunt ibi usque in praesentem diem."
,"9":"In arca autem non erat aliud nisi duae tabulae lapideae, quas posuerat in ea Moyses in Horeb, quando pepigit Dominus foedus cum filiis Israel, cum egrederentur de terra Aegypti."
,"10":"Factum est autem cum exissent sacerdotes de sanctuario, nebula implevit domum Domini,"
,"11":"et non poterant sacerdotes stare et ministrare propter nebulam; impleverat enim gloria Domini domum Domini."
,"12":"Tunc ait Salomon: ' Dominus dixit ut habitaret in nebula."
,"13":"Aedificans aedificavi domum in habitaculum tuum, firmissimum solium tuum in sempiternum '."
,"14":"Convertitque rex faciem suam et benedixit omni ecclesiae Israel; omnis enim ecclesia Israel stabat."
,"15":"Et ait: ' Benedictus Dominus, Deus Israel, qui locutus est ore suo ad David patrem meum et in manibus suis perfecit dicens:"
,"16":"'A die qua eduxi populum meum Israel de Aegypto, non elegi civitatem de universis tribubus Israel, ut aedificaretur domus, et esset nomen meum ibi; sed elegi David, ut esset super populum meum Israel'."
,"17":"Voluitque David pater meus aedificare domum nomini Domini, Dei Israel,"
,"18":"et ait Dominus ad David patrem meum: 'Quod cogitasti in corde tuo aedificare domum nomini meo, bene fecisti hoc ipsum mente tractans;"
,"19":"verumtamen tu non aedificabis domum sed filius tuus, qui egredietur de lumbis tuis, ipse aedificabit domum nomini meo'."
,"20":"Confirmavit Dominus sermonem suum, quem locutus est; stetique pro David patre meo et sedi super thronum Israel, sicut locutus est Dominus, et aedificavi domum nomini Domini, Dei Israel."
,"21":"Et constitui ibi locum arcae, in qua foedus est Domini, quod percussit cum patribus nostris, quando eduxit eos de terra Aegypti '."
,"22":"Stetit autem Salomon ante altare Domini in conspectu omnis ecclesiae Israel et expandit manus suas in caelum"
,"23":"et ait: ' Domine, Deus Israel, non est similis tui Deus in caelo desuper et super terra deorsum, qui custodis pactum et misericordiam servis tuis, qui ambulant coram te in toto corde suo;"
,"24":"qui custodisti servo tuo David patri meo, quae locutus es ei; ore locutus es et manibus perfecisti, ut et haec dies probat."
,"25":"Nunc igitur, Domine, Deus Israel, conserva famulo tuo David patri meo, quae locutus es ei dicens: 'Non auferetur de te vir coram me, qui sedeat super thronum Israel, ita tamen, si custodierint filii tui viam suam, ut ambulent coram me, sicut tu ambulasti in conspectu meo'."
,"26":"Et nunc, Domine, Deus Israel, firmentur verba tua, quae locutus es servo tuo David patri meo."
,"27":"Ergone putandum est quod vere Deus habitet super terram? Si enim caelum et caeli caelorum te capere non possunt, quanto magis domus haec, quam aedificavi!"
,"28":"Sed respice ad orationem servi tui et ad preces eius, Domine Deus meus; audi clamorem et orationem, quam servus tuus orat coram te hodie,"
,"29":"ut sint oculi tui aperti super domum hanc nocte ac die, super locum, de quo dixisti: 'Erit nomen meum ibi', ut exaudias orationem, qua orat te servus tuus in loco isto,"
,"30":"ut exaudias deprecationem servi tui et populi tui Israel, quodcumque oraverint in loco isto, et exaudies in loco habitaculi tui in caelo et, cum exaudieris, propitius eris."
,"31":"Si peccaverit homo in proximum suum et habuerit aliquod iuramentum, quo teneatur astrictus, et venerit propter iuramentum coram altari tuo in domum istam,"
,"32":"tu exaudies in caelo et facies et iudicabis servos tuos condemnans impium et reddens viam suam super caput eius iustificansque iustum et retribuens ei secundum iustitiam suam."
,"33":"Si superatus fuerit populus tuus Israel ab inimicis suis, quia peccaturus est tibi, et agentes paenitentiam et confitentes nomini tuo venerint et oraverint et deprecati te fuerint in domo hac,"
,"34":"exaudi in caelo et dimitte peccatum populi tui Israel et reduces eos in terram, quam dedisti patribus eorum."
,"35":"Si clausum fuerit caelum et non pluerit propter peccata eorum, et oraverint in loco isto confessi nomini tuo et a peccatis suis conversi propter afflictionem suam,"
,"36":"exaudi eos in caelo et dimitte peccata servorum tuorum et populi tui Israel et ostende eis viam bonam, per quam ambulent, et da pluviam super terram tuam, quam dedisti populo tuo in possessionem."
,"37":"Fames si oborta fuerit in terra aut pestilentia aut uredo aut aurugo aut locusta vel bruchus, et afflixerit eum inimicus eius portas obsidens, omnis plaga, universa infirmitas,"
,"38":"cuncta oratio et deprecatio, quae acciderit omni homini de populo tuo Israel; si quis cognoverit plagam cordis sui et expanderit manus suas in domo hac,"
,"39":"tu audies in caelo in loco habitationis tuae et repropitiaberis et facies, ut des unicuique secundum omnes vias suas, sicut videris cor eius, quia tu nosti solus cor omnium filiorum hominum,"
,"40":"ut timeant te cunctis diebus, quibus vivunt super faciem terrae, quam dedisti patribus nostris."
,"41":"Insuper et alienigena, qui non est de populo tuo Israel, cum venerit de terra longinqua propter nomen tuum"
,"42":"- audietur enim nomen tuum magnum et manus tua fortis et brachium tuum extentum ubique - cum venerit ergo et oraverit in hoc loco,"
,"43":"tu exaudies in caelo in loco habitationis tuae et facies omnia, pro quibus invocaverit te alienigena, ut sciant universi populi terrarum nomen tuum et timeant te, sicut populus tuus Israel, et probent quia nomen tuum invocatum est super domum hanc, quam aedificavi."
,"44":"Si egressus fuerit populus tuus ad bellum contra inimicos suos per viam, quocumque miseris eos, et oraverint te contra viam civitatis, quam elegisti, et contra domum, quam aedificavi nomini tuo,"
,"45":"exaudies in caelo orationes eorum et preces eorum et facies iudicium eorum."
,"46":"Quod si peccaverint tibi - non est enim homo qui non peccet - et iratus tradideris eos inimicis suis, et captivi ducti fuerint in terram inimicorum longe vel prope"
,"47":"et egerint paenitentiam in corde suo in loco captivitatis et conversi deprecati te fuerint in captivitate sua dicentes: 'Peccavimus, inique egimus, impie gessimus';"
,"48":"et reversi fuerint ad te in universo corde suo et tota anima sua in terra inimicorum suorum, ad quam captivi ducti sunt, et oraverint te contra viam terrae suae, quam dedisti patribus eorum, et civitatis, quam elegisti, et templi, quod aedificavi nomini tuo,"
,"49":"exaudies in caelo in firmamento solii tui orationes eorum et preces eorum et facies iudicium eorum;"
,"50":"et propitiaberis populo tuo, qui peccavit tibi, et omnibus iniquitatibus eorum, quibus praevaricati sunt in te, et dabis misericordiam coram eis, qui eos captivos habuerint, ut misereantur eis"
,"51":"- populus enim tuus est et hereditas tua, quos eduxisti de terra Aegypti de medio fornacis ferreae -"
,"52":"ut sint oculi tui aperti ad deprecationem servi tui et populi tui Israel, et exaudias eos in universis, pro quibus invocaverint te."
,"53":"Tu enim separasti eos tibi in hereditatem de universis populis terrae, sicut locutus es per Moysen servum tuum, quando eduxisti patres nostros de Aegypto, Domine Deus '."
,"54":"Factum est autem cum complesset Salomon orans Dominum omnem orationem et deprecationem hanc, surrexit de conspectu altaris Domini; utrumque enim genu in terram fixerat et manus expanderat in caelum."
,"55":"Stetit ergo et benedixit omni ecclesiae Israel voce magna dicens:"
,"56":"' Benedictus Dominus, qui dedit requiem populo suo Israel iuxta omnia, quae locutus est; non cecidit ne unus quidem sermo ex omnibus bonis, quae locutus est per Moysen servum suum."
,"57":"Sit Dominus Deus noster nobiscum, sicut fuit cum patribus nostris, non derelinquens nos neque proiciens,"
,"58":"sed inclinet corda nostra ad se, ut ambulemus in universis viis eius et custodiamus mandata eius et decreta et iudicia, quaecumque mandavit patribus nostris."
,"59":"Et sint sermones mei isti, quibus deprecatus sum coram Domino, appropinquantes Domino Deo nostro die ac nocte, ut faciat iudicium servo suo et populo suo Israel per singulos dies,"
,"60":"ut sciant omnes populi terrae quia Dominus ipse est Deus, et non est ultra absque eo."
,"61":"Sit quoque cor vestrum perfectum cum Domino Deo nostro, ut ambuletis in decretis eius et custodiatis mandata eius sicut et hodie '."
,"62":"Igitur rex et omnis Israel cum eo immolabant victimas coram Domino."
,"63":"Mactavitque Salomon hostias pacificas, quas immolavit Domino, boum viginti duo milia et ovium centum viginti milia. Et dedicaverunt templum Domini rex et omnes filii Israel."
,"64":"In die illa sanctificavit rex medium atrii, quod erat ante domum Domini; fecit quippe holocaustum ibi et oblationem et adipem pacificorum, quoniam altare aereum, quod erat coram Domino, minus erat et capere non poterat holocaustum et oblationem et adipem pacificorum."
,"65":"Fecit ergo Salomon in tempore illo festivitatem celebrem, et omnis Israel cum eo, ecclesia magna ab introitu Emath usque ad rivum Aegypti, coram Domino Deo nostro septem diebus."
,"66":"Et in die octava dimisit populos; qui benedicentes regi profecti sunt in tabernacula sua laetantes et alacri corde super omnibus bonis, quae fecerat Dominus David servo suo et Israel populo suo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Factum est autem cum perfecisset Salomon aedificium domus Domini et aedificium regis et omne, quod optaverat et voluerat facere,"
,"2":"apparuit ei Dominus secundo, sicut apparuerat ei in Gabaon."
,"3":"Dixitque Dominus ad eum: ' Exaudivi orationem tuam et deprecationem tuam, quam deprecatus es coram me; sanctificavi domum hanc, quam aedificasti, ut ponerem nomen meum ibi in sempiternum; et erunt oculi mei et cor meum ibi cunctis diebus."
,"4":"Tu quoque, si ambulaveris coram me, sicut ambulavit David pater tuus in simplicitate cordis et in aequitate, et feceris omnia, quae praecepi tibi, et legitima mea et iudicia mea servaveris,"
,"5":"ponam thronum regni tui super Israel in sempiternum, sicut locutus sum David patri tuo dicens: Non auferetur de genere tuo vir de solio Israel."
,"6":"Si autem aversione aversi fueritis vos et filii vestri non sequentes me nec custodientes mandata mea et decreta mea, quae proposui vobis, sed abieritis et colueritis deos alienos et adoraveritis eos,"
,"7":"auferam Israel de superficie terrae, quam dedi eis, et templum, quod sanctificavi nomini meo, proiciam a conspectu meo; eritque Israel in proverbium et in fabulam cunctis populis,"
,"8":"et domus haec erit in ruinas. Omnis, qui transierit per eam, stupebit et sibilabit et dicet: 'Quare fecit Dominus sic terrae huic et domui huic?'."
,"9":"Et respondebunt: 'Quia dereliquerunt Dominum Deum suum, qui eduxit patres eorum de terra Aegypti, et secuti sunt deos alienos et adoraverunt eos et coluerunt eos; idcirco induxit Dominus super eos omne malum hoc' '."
,"10":"Expletis autem annis viginti, postquam aedificaverat Salomon duas domos, id est domum Domini et domum regis"
,"11":"- Hiram rege Tyri praebente Salomoni ligna cedrina et abiegna et aurum iuxta omne quod opus habuerat - tunc dedit Salomon Hiram viginti oppida in terra Galilaeae."
,"12":"Et egressus est Hiram de Tyro, ut videret oppida, quae dederat ei Salomon, et non placuerunt ei;"
,"13":"et ait: ' Haeccine sunt civitates, quas dedisti mihi, frater? '. Et appellavit eas terram Chabul usque in diem hanc."
,"14":"Misit quoque Hiram ad regem centum viginti talenta auri."
,"15":"Haec est summa indictionis, quam constituit rex Salomon ad aedificandam domum Domini et domum suam et Mello et murum Ierusalem et Asor et Mageddo et Gazer."
,"16":"Pharao rex Aegypti ascendit et cepit Gazer succenditque eam igni et Chananaeum, qui habitabat in civitate, interfecit; et dedit eam in dotem filiae suae uxori Salomonis."
,"17":"Aedificavit ergo Salomon Gazer et Bethoron inferiorem"
,"18":"et Baalath et Thamar in terra solitudinis"
,"19":"et omnes civitates horreorum, quae ad se pertinebant, et civitates curruum et civitates equorum et quodcumque ei placuit, ut aedificaret in Ierusalem et in Libano et in omni terra potestatis suae."
,"20":"Universum populum, qui remanserat de Amorraeis et Hetthaeis et Pherezaeis et Hevaeis et Iebusaeis, qui non erant de filiis Israel,"
,"21":"horum filios, qui remanserant post eos in terra, quos scilicet non potuerant filii Israel exterminare, fecit Salomon tributarios usque in diem hanc."
,"22":"De filiis autem Israel non constituit Salomon servire quemquam, sed erant viri bellatores et ministri eius et principes et pugnatores eius et praefecti curruum et equitum."
,"23":"Erant autem principes eorum, qui super omnia opera Salomonis praepositi erant, quingenti quinquaginta; qui habebant subiectum populum et statutis operibus imperabant."
,"24":"Filia autem pharaonis ascendit de civitate David in domum suam, quam aedificaverat ei; tunc aedificavit Mello."
,"25":"Offerebat quoque Salomon tribus vicibus per annos singulos holocausta et pacificas victimas super altare, quod aedificaverat Domino, et adolebat coram Domino; perfectumque est templum."
,"26":"Classem quoque fecit rex Salomon in Asiongaber, quae est iuxta Ailath in litore maris Rubri in terra Idumaea."
,"27":"Misitque Hiram in classe illa servos suos viros nauticos gnaros maris cum servis Salomonis."
,"28":"Qui, cum venissent in Ophir, sumptum inde aurum quadringentorum viginti talentorum detulerunt ad regem Salomonem."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Sed et regina Saba, audita fama Salomonis - in hono rem nominis Domini - venit tentare eum in aenigmatibus."
,"2":"Et ingressa Ierusalem multo cum comitatu et divitiis, camelis portantibus aromata et aurum infinitum nimis et gemmas pretiosas, venit ad Salomonem et locuta est ei universa, quae habebat in corde suo."
,"3":"Et docuit eam Salomon omnia verba, quae proposuerat: non fuit sermo, qui regem posset latere, et non responderet ei."
,"4":"Videns autem regina Saba omnem sapientiam Salomonis et domum, quam aedificaverat,"
,"5":"et cibos mensae eius et sessionem servorum et ordinem ministrantium vestesque eorum et pincernas et holocausta, quae offerebat in domo Domini, non habebat ultra spiritum"
,"6":"dixitque ad regem: ' Verus est sermo, quem audivi in terra mea super rebus tuis et super sapientia tua!"
,"7":"Et non credebam narrantibus mihi, donec ipsa veni et vidi oculis meis et probavi quod media pars mihi nuntiata non fuerit; maior est sapientia et bona tua quam rumor, quem audivi."
,"8":"Beati viri tui et beati servi tui hi, qui stant coram te semper et audiunt sapientiam tuam!"
,"9":"Sit Dominus Deus tuus benedictus, cui placuisti, et posuit te super thronum Israel, eo quod dilexerit Dominus Israel in sempiternum et constituit te regem, ut faceres iudicium et iustitiam '."
,"10":"Dedit ergo regi centum viginti talenta auri et aromata multa nimis et gemmas pretiosas; non sunt allata ultra aromata tam multa quam ea, quae dedit regina Saba regi Salomoni."
,"11":"Sed et classis Hiram, quae portabat aurum de Ophir, attulit ex Ophir ligna thyina multa nimis et gemmas pretiosas."
,"12":"Fecitque rex de lignis thyinis fulcra domus Domini et domus regiae et citharas lyrasque cantoribus. Non sunt allata huiuscemodi ligna thyina neque visa usque in praesentem diem."
,"13":"Rex autem Salomon dedit reginae Saba omnia, quae voluit et petivit ab eo, praeter ea, quae ultro obtulerat ei munere regio. Quae reversa est et abiit in terram suam cum servis suis."
,"14":"Erat autem pondus auri, quod afferebatur Salomoni per annos singulos, sescentorum sexaginta sex talentorum auri,"
,"15":"praeter id, quod proveniebat ex tributis subiectorum et commercio negotiatorum et omnium regum Arabiae et ducum terrae."
,"16":"Fecit quoque rex Salomon ducenta scuta de auro puro, sescentos auri siclos dedit in laminas scuti unius;"
,"17":"et trecentas peltas ex auro probato, tres minae auri unam peltam vestiebant; posuitque ea rex in domo Saltus Libani."
,"18":"Fecit etiam rex Salomon thronum de ebore grandem et vestivit eum auro fulvo nimis."
,"19":"Qui habebat sex gradus, et summitas throni rotunda erat in parte posteriori, et duae manus hinc atque inde tenentes sedile, et duo leones stabant iuxta manus;"
,"20":"et duodecim leunculi stantes super sex gradus hinc atque inde. Non est factum tale opus in universis regnis."
,"21":"Sed et omnia vasa, quibus potabat rex Salomon, erant aurea, et universa supellex domus Saltus Libani de auro purissimo; non erat argentum nec alicuius pretii putabatur in diebus Salomonis,"
,"22":"quia classis Tharsis, quae regi erat, per mare cum classe Hiram semel per tres annos redibat deferens aurum et argentum et ebur et simias et pavos."
,"23":"Magnificatus est ergo rex Salomon super omnes reges terrae divitiis et sapientia."
,"24":"Et universa terra desiderabat vultum Salomonis, ut audiret sapientiam eius, quam dederat Deus in corde eius."
,"25":"Et singuli deferebant ei munera, vasa argentea et aurea, vestes et arma bellica, aromata quoque et equos et mulos per annos singulos."
,"26":"Congregavitque Salomon currus et equites, et facti sunt ei mille quadringenti currus et duodecim milia equitum; et disposuit eos per civitates quadrigarum et cum rege in Ierusalem."
,"27":"Fecitque ut tanta esset abundantia argenti in Ierusalem quanta et lapidum; et cedrorum praebuit multitudinem quasi sycomoros, quae nascuntur in Sephela."
,"28":"Et educebantur equi Salomoni de Aegypto et de Coa; negotiatores enim regis emebant de Coa statuto pretio."
,"29":"Constabat autem et egrediebatur quadriga ex Aegypto sescentis siclis argenti, et equus centum quinquaginta; atque in hunc modum cunctis regibus Hetthaeorum et Syriae per manus suas venundabant."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Rex autem Salomon amavit mulieres alienigenas multas, filiam quoque pharaonis et Moabitidas et Ammonitidas, Idumaeas et Sidonias et Hetthaeas,"
,"2":"de gentibus, super quibus dixit Dominus filiis Israel: ' Non ingrediemini ad eas, neque de illis ingredientur ad vestras; certissime enim avertent corda vestra, ut sequamini deos earum '. His itaque copulatus est Salomon amore;"
,"3":"fueruntque ei uxores quasi reginae septingentae et concubinae trecentae, et averterunt mulieres cor eius."
,"4":"Cumque iam esset senex, depravatum est cor eius per mulieres, ut sequeretur deos alienos; nec erat cor eius perfectum cum Domino Deo suo sicut cor David patris eius,"
,"5":"sed colebat Salomon Astharthen, deam Sidoniorum, et Melchom idolum Ammonitarum."
,"6":"Fecitque Salomon quod non placuerat coram Domino et non adimplevit ut sequeretur Dominum sicut David pater eius."
,"7":"Tunc aedificavit Salomon fanum Chamos idolo Moab in monte, qui est contra Ierusalem, et Melchom idolo filiorum Ammon;"
,"8":"atque in hunc modum fecit universis uxoribus suis alienigenis, quae adolebant et immolabant diis suis."
,"9":"Igitur iratus est Dominus Salomoni, quod aversa esset mens eius a Domino, Deo Israel, qui apparuerat ei bis"
,"10":"et praeceperat de verbo hoc, ne sequeretur deos alienos; et non custodivit, quae mandavit ei Dominus."
,"11":"Dixit itaque Dominus Salomoni: ' Quia habuisti hoc apud te et non custodisti pactum meum et praecepta mea, quae mandavi tibi, disrumpens scindam regnum tuum a te et dabo illud servo tuo."
,"12":"Verumtamen in diebus tuis non faciam propter David patrem tuum; de manu filii tui scindam illud."
,"13":"Nec totum regnum auferam, sed tribum unam dabo filio tuo propter David servum meum et Ierusalem, quam elegi '."
,"14":"Suscitavit autem Dominus adversarium Salomoni Adad Idumaeum, qui erat de semine regio, in Edom."
,"15":"Cum enim vicisset David Idumaeam, et ascendisset Ioab princeps militiae ad sepeliendum eos, qui fuerant interfecti, et occidisset omne masculinum in Idumaea"
,"16":"- sex enim mensibus ibi moratus est Ioab et omnis Israel, donec interimerent omne masculinum in Idumaea -"
,"17":"fugit Adad ipse et viri Idumaei de servis patris eius cum eo, ut ingrederetur Aegyptum; erat autem Adad puer parvulus."
,"18":"Cumque surrexissent de Madian, venerunt in Pharan tuleruntque secum viros de Pharan et introierunt Aegyptum ad pharaonem regem Aegypti, qui dedit ei domum et cibos constituit et terram delegavit."
,"19":"Et invenit Adad gratiam coram pharao valde, in tantum ut daret ei uxorem sororem uxoris suae germanam Taphnes reginae."
,"20":"Genuitque ei soror Taphnes Genubath filium et ablactavit eum Taphnes in domo pharaonis, eratque Genubath habitans apud pharaonem cum filiis eius."
,"21":"Cumque audisset Adad in Aegypto dormisse David cum patribus suis et mortuum esse Ioab principem militiae, dixit pharaoni: ' Dimitte me, ut vadam in terram meam '."
,"22":"Dixitque ei pharao: ' Qua enim re apud me indiges, ut quaeras ire ad terram tuam? '. At ille respondit: ' Nulla; sed obsecro, ut dimittas me '."
,"23":"Suscitavit quoque Deus Salomoni adversarium Razon filium Eliada, qui fugerat ab Adadezer rege Soba domino suo."
,"24":"Et congregavit ad se viros et factus est princeps turmae, cum interficeret eos David; abieruntque Damascum et habitaverunt ibi et regnaverunt in Damasco."
,"25":"Eratque adversarius Israeli cunctis diebus Salomonis; et hoc cum malo, quod erat Adad. Et detestatus est Israel regnavitque in Syria."
,"26":"Ieroboam quoque filius Nabat, Ephrathaeus de Sareda, servus Salomonis, cuius mater erat nomine Sarva mulier vidua, levavit manum contra regem."
,"27":"Et haec causa rebellionis adversus eum: Salomon aedificavit Mello et coaequavit voraginem civitatis David patris sui."
,"28":"Erat autem Ieroboam vir fortis et strenuus; vidensque Salomon adulescentem industrium constituerat eum praefectum super labores universae domus Ioseph."
,"29":"Factum est igitur in tempore illo, ut Ieroboam egrederetur de Ierusalem, et inveniret eum Ahias Silonites propheta in via opertus pallio novo; erant autem duo tantum in agro."
,"30":"Apprehendensque Ahias pallium suum novum, quo coopertus erat, scidit in duodecim partes"
,"31":"et ait ad Ieroboam: ' Tolle tibi decem scissuras; haec enim dicit Dominus, Deus Israel: Ecce ego scindam regnum de manu Salomonis et dabo tibi decem tribus."
,"32":"Porro una tribus remanebit ei propter servum meum David et Ierusalem civitatem, quam elegi ex omnibus tribubus Israel;"
,"33":"eo quod dereliquerint me et adoraverint Astharthen deam Sidoniorum et Chamos deum Moab et Melchom deum filiorum Ammon et non ambulaverint in viis meis, ut facerent iustitiam coram me et praecepta mea et iudicia sicut David pater eius."
,"34":"Nec auferam omne regnum de manu eius, sed ducem ponam eum cunctis diebus vitae suae propter David servum meum, quem elegi, qui custodivit mandata mea et praecepta mea."
,"35":"Auferam autem regnum de manu filii eius et dabo tibi decem tribus;"
,"36":"filio autem eius dabo tribum unam, ut remaneat lucerna David servo meo cunctis diebus coram me in Ierusalem civitate, quam elegi, ut esset nomen meum ibi."
,"37":"Te autem assumam, et regnabis super omnia, quae desiderat anima tua, erisque rex super Israel."
,"38":"Si igitur audieris omnia, quae praecepero tibi, et ambulaveris in viis meis et feceris, quod rectum est coram me custodiens mandata mea et praecepta mea, sicut fecit David servus meus, ero tecum et aedificabo tibi domum stabilem, quomodo aedificavi David, et tradam tibi Israel"
,"39":"et affligam semen David super hoc, verumtamen non cunctis diebus '."
,"40":"Voluit ergo Salomon interficere Ieroboam, qui surrexit et aufugit in Aegyptum ad Sesac regem Aegypti et fuit in Aegypto usque ad mortem Salomonis."
,"41":"Reliqua autem gestorum Salomonis, omnia, quae fecit, et sapientia eius, ecce universa scripta sunt in libro gestorum Salomonis;"
,"42":"dies autem, quos regnavit Salomon in Ierusalem super omnem Israel, quadraginta anni sunt."
,"43":"Dormivitque Salomon cum patribus suis et sepultus est in civitate David patris sui; regnavitque Roboam filius eius pro eo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Venit autem Roboam in Sichem; illuc enim congregatus erat omnis Israel ad constituendum eum regem."
,"2":"At Ieroboam filius Nabat, cum adhuc esset in Aegypto profugus a facie regis Salomonis, audito hoc nuntio, reversus est de Aegypto."
,"3":"Miseruntque et vocaverunt eum. Venit ergo Ieroboam et omnis multitudo Israel, et locuti sunt ad Roboam dicentes:"
,"4":"' Pater tuus durissimum iugum imposuit nobis; tu itaque nunc imminue paululum de imperio patris tui durissimo et de iugo gravissimo, quod imposuit nobis, et serviemus tibi '."
,"5":"Qui ait eis: ' Ite usque ad tertium diem et revertimini ad me '. Cumque abisset populus, "
,"6":"iniit consilium rex Roboam cum senioribus, qui assistebant coram Salomone patre eius, cum adhuc viveret, et ait: ' Quod mihi datis consilium, ut respondeam populo huic? '."
,"7":"Qui dixerunt ei: ' Si hodie oboedieris populo huic et servieris et petitioni eorum cesseris locutusque fueris ad eos verba lenia, erunt tibi servi cunctis diebus '."
,"8":"Qui dereliquit consilium senum, quod dederant ei, et adhibuit adulescentes, qui nutriti fuerant cum eo et assistebant illi,"
,"9":"dixitque ad eos: ' Quod mihi datis consilium, ut respondeam populo huic, qui dixerunt mihi: 'Levius fac iugum, quod imposuit pater tuus super nos'? '."
,"10":"Et dixerunt ei iuvenes, qui nutriti fuerant cum eo: ' Sic loquere populo huic, qui locuti sunt ad te dicentes: 'Pater tuus aggravavit iugum nostrum, tu releva nos'; sic loqueris ad eos: Minimus digitus meus grossior est lumbis patris mei."
,"11":"Et nunc, pater meus posuit super vos iugum grave, ego autem addam super iugum vestrum; pater meus cecidit vos flagellis, ego autem caedam scorpionibus '."
,"12":"Venit ergo Ieroboam et omnis populus ad Roboam die tertia, sicut locutus fuerat rex dicens: ' Revertimini ad me die tertia '."
,"13":"Responditque rex populo dura, derelicto consilio seniorum, quod ei dederant,"
,"14":"et locutus est eis secundum consilium iuvenum dicens: ' Pater meus aggravavit iugum vestrum, ego autem addam iugo vestro; pater meus cecidit vos flagellis, ego autem caedam vos scorpionibus '."
,"15":"Ergo non acquievit rex populo, quoniam dispositum erat a Domino, ut suscitaret verbum suum, quod locutus fuerat in manu Ahiae Silonitae ad Ieroboam filium Nabat."
,"16":"Videns itaque omnis Israel quod noluisset eos audire rex, respondit ei dicens: ' Quae nobis pars in David, vel quae hereditas in filio Isai?,Vade in tabernacula tua, Israel!,Nunc vide domum tuam, David! '. Et abiit Israel in tabernacula sua. "
,"17":"Super filios autem Israel, quicumque habitabant in civitatibus Iudae, regnavit Roboam."
,"18":"Misit rex Roboam Adoniram, qui erat super servitutem; et lapidavit eum omnis Israel, et mortuus est. Porro rex Roboam festinus ascendit currum et fugit in Ierusalem."
,"19":"Recessitque Israel a domo David usque in praesentem diem."
,"20":"Factum est autem cum audisset omnis Israel quod reversus esset Ieroboam, miserunt et vocaverunt eum, congregato coetu, et constituerunt eum regem super omnem Israel; nec secutus est quisquam domum David praeter tribum Iudae solam."
,"21":"Venit autem Roboam Ierusalem et congrcgavit universam domum Iudae et tribum Beniamin, centum octoginta milia electorum virorum bellatorum, ut pugnaret contra domum Israel et reduceret regnum Roboam filio Salomonis."
,"22":"Factus est vero sermo Domini ad Semeiam virum Dei dicens:"
,"23":"' Loquere ad Roboam filium Salomonis regem Iudae et ad omnem domum Iudae et Beniamin et reliquos de populo dicens:"
,"24":"Haec dicit Dominus: Non ascendetis neque bellabitis contra fratres vestros, filios Israel; revertatur vir in domum suam; a me enim factum est hoc '. Audierunt sermonem Domini et reversi sunt de itinere, sicut eis praeceperat Dominus."
,"25":"Aedificavit autem Ieroboam Sichem in monte Ephraim et habitavit ibi; et egressus inde aedificavit Phanuel."
,"26":"Dixitque Ieroboam in corde suo: ' Nunc revertetur regnum ad domum David,"
,"27":"si ascenderit populus iste, ut faciat sacrificia in domo Domini in Ierusalem, et convertetur cor populi huius ad dominum suum Roboam regem Iudae, interficientque me et revertentur ad Roboam regem Iudae '."
,"28":"Et excogitato consilio, fecit rex duos vitulos aureos et dixit ad populum: ' Nolite ultra ascendere in Ierusalem! Ecce dii tui, Israel, qui te eduxerunt de terra Aegypti '."
,"29":"Posuitque unum in Bethel et alterum donavit in Dan;"
,"30":"et factum est hoc in peccatum: ibat enim populus coram uno usque in Dan."
,"31":"Et fecit fana in excelsis et sacerdotes de extremis populi, qui non erant de filiis Levi."
,"32":"Constituitque diem sollemnem in mense octavo, quinta decima die mensis, in similitudinem sollemnitatis, quae celebratur in Iuda. Et ascendit altare; sic fecit in Bethel, ut immolaret vitulis, quos fabricatus erat; constituitque in Bethel sacerdotes excelsorum, quae fecerat."
,"33":"Et ascendit super altare, quod exstruxerat in Bethel, quinta decima die mensis octavi, quem finxerat de corde suo; et fecit sollemnitatem filiis Israel et ascendit super altare, ut adoleret."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Et ecce vir Dei venit de Iuda in sermone Domini in Bethel, Ieroboam stante super altare ad adolendum;"
,"2":"et exclamavit contra altare in sermone Domini et ait: ' Altare, altare, haec dicit Dominus: Ecce filius nascetur domui David, Iosias nomine, et immolabit super te sacerdotes excelsorum, qui nunc in te immolant, et ossa hominum super te incendent '."
,"3":"Deditque in illa die signum dicens: ' Hoc erit signum, quod locutus est Dominus: ecce altare scindetur, et effundetur cinis, qui in eo est '."
,"4":"Cumque audisset rex sermonem hominis Dei, quem inclamaverat contra altare in Bethel, extendit manum suam de altari dicens: ' Apprehendite eum! '. Et exaruit manus eius, quam extenderat contra eum, nec valuit retrahere eam ad se."
,"5":"Altare quoque scissum est, et effusus est cinis de altari iuxta signum, quod praedixerat vir Dei in sermone Domini."
,"6":"Et ait rex ad virum Dei: ' Deprecare faciem Domini Dei tui et ora pro me, ut restituatur manus mea mihi '. Oravit vir Dei faciem Domini, et reversa est manus regis ad eum et facta est sicut prius fuerat."
,"7":"Locutus est autem rex ad virum Dei: ' Veni mecum domum, ut prandeas, et dabo tibi munera '."
,"8":"Responditque vir Dei ad regem: ' Si dederis mihi mediam partem domus tuae, non veniam tecum nec comedam panem neque bibam aquam in loco isto;"
,"9":"sic enim mandatum est mihi in sermone Domini praecipientis: 'Non comedes panem neque bibes aquam nec reverteris per viam, qua venisti' '."
,"10":"Abiit ergo per aliam viam et non est reversus per iter, quo venerat in Bethel."
,"11":"Prophetes autem quidam senex habitabat in Bethel; ad quem venerunt filii sui et narraverunt ei omnia opera, quae fecerat vir Dei illa die in Bethel, et verba, quae locutus fuerat ad regem, narraverunt quoque patri suo."
,"12":"Et dixit eis pater eorum: ' Per quam viam abiit? '. Ostenderunt ei filii sui viam, per quam abierat vir Dei, qui venerat de Iuda."
,"13":"Et ait filiis suis: ' Sternite mihi asinum '. Qui cum stravissent, ascendit"
,"14":"et abiit post virum Dei et invenit eum sedentem subtus terebinthum et ait illi: ' Tune es vir Dei, qui venisti de Iuda?'. Respondit ille: ' Ego sum '."
,"15":"Dixit ad eum: ' Veni mecum domum, ut comedas panem '."
,"16":"Qui ait: ' Non possum reverti neque venire tecum nec comedam panem neque bibam aquam in loco isto;"
,"17":"sic enim dictum est mihi in sermone Domini: 'Non comedes panem et non bibes ibi aquam nec reverteris per viam, qua ieris' '."
,"18":"Qui ait illi: ' Et ego propheta sum similis tui; et angelus locutus est mihi in sermone Domini dicens: 'Reduc eum tecum in domum tuam, et comedat panem et bibat aquam' '. Fefellit eum"
,"19":"et reduxit secum; comedit ergo panem in domo eius et bibit aquam."
,"20":"Cumque sederent ad mensam, factus est sermo Domini ad prophetam, qui reduxerat eum,"
,"21":"et exclamavit ad virum Dei, qui venerat de Iuda, dicens: ' Haec dicit Dominus: Quia non oboediens fuisti ori Domini et non custodisti mandatum, quod praecepit tibi Dominus Deus tuus,"
,"22":"et reversus es et comedisti panem et bibisti aquam in loco, in quo praecepit tibi, ne comederes panem neque biberes aquam, non inferetur cadaver tuum in sepulcrum patrum tuorum '."
,"23":"Cumque comedisset panem et bibisset, stravit sibi asinum prophetae, qui reduxerat eum;"
,"24":"et, cum abisset, invenit eum leo in via et occidit, et erat cadaver eius proiectum in itinere; asinus autem stabat iuxta illum, et leo stabat iuxta cadaver."
,"25":"Et ecce viri transeuntes viderunt cadaver proiectum in via et leonem stantem iuxta cadaver; et venerunt et divulgaverunt in civitate, in qua prophetes ille senex habitabat."
,"26":"Quod cum audisset propheta ille, qui reduxerat eum de via, ait: ' Vir Dei est, qui inoboediens fuit ori Domini, et tradidit eum Dominus leoni; et confregit eum et occidit iuxta verbum Domini, quod locutus est ei '."
,"27":"Dixitque ad filios suos: ' Sternite mihi asinum! '. Qui cum stravissent,"
,"28":"et ille abisset, invenit cadaver eius proiectum in via et asinum et leonem stantes iuxta cadaver; non comedit leo de cadavere nec laesit asinum."
,"29":"Tulit ergo prophetes cadaver viri Dei et posuit illud super asinum et reversus intulit in civitatem prophetae senis, ut plangerent eum et sepelirent."
,"30":"Et posuit cadaver eius in sepulcro suo, et planxerunt eum: ' Heu, heu, mi frater! '."
,"31":"Cumque sepelissent eum, dixit ad filios suos: ' Cum mortuus fuero, sepelite me in sepulcro, in quo vir Dei sepultus est; iuxta ossa eius ponite ossa mea."
,"32":"Profecto enim veniet sermo, quem praedixit in sermone Domini contra altare, quod est in Bethel, et contra omnia fana excelsorum, quae sunt in urbibus Samariae '."
,"33":"Post haec non est reversus Ieroboam de via sua pessima, sed iterum faciebat de novissimis populi sacerdotes excelsorum; quicumque volebat, implebat eius manum, ut fieret sacerdos excelsorum."
,"34":"Et propter hanc causam peccavit domus Ieroboam, et eversa est et deleta de superficie terrae."
}`)
	CurrentBook.AddChapter(14, `{
"1":"In tempore illo aegrotavit Abia filius Ieroboam, 2 dixitque Ieroboam uxori suae: ' Surge et commuta habitum, ne cognoscaris quod sis uxor Ieroboam, et vade in Silo, ubi est Ahias propheta, qui locutus est mihi quod regnaturus essem super populum hunc."
,"3":"Tolle quoque in manu tua decem panes et crustula et vas mellis et vade ad illum: ipse indicabit tibi quid eventurum sit puero '."
,"4":"Fecit, ut dixerat, uxor Ieroboam et consurgens abiit in Silo et venit in domum Ahiae; at ille non poterat videre, quia caligaverant oculi eius prae senectute."
,"5":"Dixerat autem Dominus ad Ahiam: ' Ecce uxor Ieroboam ingredietur, ut consulat te super filio suo, qui aegrotat; haec et haec loqueris ei. Cum intret, simulabit se peregrinam esse '."
,"6":"Cum ergo audiret Ahias sonitum pedum eius introeuntis per ostium, ait: ' Ingredere, uxor Ieroboam. Quare aliam te esse simulas? Ego autem missus sum ad te durus nuntius."
,"7":"Vade et dic Ieroboam: 'Haec dicit Dominus, Deus Israel: Quia exaltavi te de medio populi et dedi te ducem super populum meum Israel"
,"8":"et scidi regnum a domo David et dedi illud tibi, et non fuisti sicut servus meus David, qui custodivit mandata mea et secutus est me in toto corde suo faciens quod placitum esset in conspectu meo,"
,"9":"sed operatus es mala super omnes, qui fuerunt ante te, et fecisti tibi deos alienos et conflatiles, ut me ad iracundiam provocares, me autem proiecisti post tergum tuum:"
,"10":"idcirco ecce ego inducam mala super domum Ieroboam et percutiam de Ieroboam quidquid masculini sexus, impuberem et puberem in Israel; et mundabo reliquias domus Ieroboam, sicut mundari solet fimus usque ad purum."
,"11":"Qui mortui fuerint de Ieroboam in civitate, comedent eos canes; qui autem mortui fuerint in agro, vorabunt eos aves caeli, quia Dominus locutus est."
,"12":"Tu igitur surge et vade in domum tuam, et in ipso introitu pedum tuorum in urbem morietur puer,"
,"13":"et planget eum omnis Israel et sepeliet; iste enim solus inferetur de Ieroboam in sepulcrum, quia inventum est in eo, quod bonum erat Domino, Deo Israel, in domo Ieroboam."
,"14":"Constituet autem sibi Dominus regem super Israel, qui percutiat domum Ieroboam."
,"15":"Et percutiet Dominus Israel, ut moveatur sicut arundo in aqua, et evellet Israel de terra bona hac, quam dedit patribus eorum; et ventilabit eos trans Flumen, quia fecerunt sibi palos, ut irritarent Dominum."
,"16":"Et tradet Dominus Israel propter peccata Ieroboam, qui peccavit et peccare fecit Israel' '."
,"17":"Surrexit itaque uxor Ieroboam et abiit et venit in Thersa; cumque illa ingrederetur limen domus, puer mortuus est."
,"18":"Et sepelierunt eum, et planxit illum omnis Israel iuxta sermonem Domini, quem locutus est in manu servi sui Ahiae prophetae."
,"19":"Reliqua autem gestorum Ieroboam, quomodo pugnaverit et quomodo regnaverit, ecce scripta sunt in libro annalium regum Israel."
,"20":"Dies autem, quibus regnavit Ieroboam, viginti duo anni sunt; et dormivit cum patribus suis. Regnavitque Nadab filius eius pro eo."
,"21":"Porro Roboam filius Salomonis regnavit in Iuda. Quadraginta et unius anni erat Roboam, cum regnare coepisset, et decem et septem annos regnavit in Ierusalem civitate, quam elegit Dominus, ut poneret nomen suum ibi ex omnibus tribubus Israel. Nomen autem matris eius Naama Ammanites."
,"22":"Et fecit Iuda malum coram Domino, et irritaverunt eum super omnibus, quae fecerant patres eorum in peccatis suis, quae peccaverant;"
,"23":"aedificaverunt enim et ipsi sibi excelsa et lapides et palos super omnem collem excelsum et subter omnem arborem frondosam."
,"24":"Sed et prostibula fuerunt in terra; feceruntque omnes abominationes gentium, quas attrivit Dominus ante faciem filiorum Israel."
,"25":"In quinto autem anno regni Roboam ascendit Sesac rex Aegypti in Ierusalem"
,"26":"et tulit thesauros domus Domini et thesauros regios et universa diripuit, scuta quoque aurea omnia, quae fecerat Salomon."
,"27":"Pro quibus fecit rex Roboam scuta aerea et tradidit ea in manu ducum cursorum, qui excubabant ante ostium domus regis."
,"28":"Cumque ingrederetur rex in domum Domini, portabant ea cursores et postea reportabant ad armamentarium cursorum."
,"29":"Reliqua autem gestorum Roboam et omnia, quae fecit, ecce scripta sunt in libro annalium regum Iudae."
,"30":"Fuitque bellum inter Roboam et Ieroboam cunctis diebus."
,"31":"Dormivit itaque Roboam cum patribus suis et sepultus est cum eis in civitate David; nomen autem matris eius Naama Ammanites. Et regnavit Abiam filius eius pro eo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Igitur in octavo decimo anno regni Ieroboam filii Nabat regnavit Abiam super Iudam."
,"2":"Tribus annis regnavit in Ierusalem; nomen matris eius Maacha filia Abessalom."
,"3":"Ambulavitque in omnibus peccatis patris sui, quae fecerat ante eum; nec erat cor eius perfectum cum Domino Deo suo sicut cor David patris eius."
,"4":"Sed propter David dedit ei Dominus Deus suus lucernam in Ierusalem, ut suscitaret filium eius post eum et statueret Ierusalem;"
,"5":"eo quod fecisset David rectum in oculis Domini et non declinasset ab omnibus, quae praeceperat ei, cunctis diebus vitae suae, excepta re Uriae Hetthaei. ( 6 )"
,"7":"Reliqua autem gestorum Abiam et omnia, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae? Fuitque bellum inter Abiam et inter Ieroboam."
,"8":"Et dormivit Abiam cum patribus suis, et sepelierunt eum in civitate David; regnavitque Asa filius eius pro eo."
,"9":"In anno ergo vicesimo Ieroboam regis Israel regnavit Asa rex Iudae"
,"10":"et quadraginta et uno anno regnavit in Ierusalem. Nomen matris eius Maacha filia Abessalom."
,"11":"Et fecit Asa rectum ante conspectum Domini sicut David pater eius."
,"12":"Et abstulit prostibula de terra purgavitque universas sordes idolorum, quae fecerant patres eius."
,"13":"Insuper et Maacham matrem suam amovit, ne esset domina, eo quod fecisset abominationem Aserae; confregitque Asa simulacrum turpissimum et combussit in torrente Cedron."
,"14":"Excelsa autem non abstulit; verumtamen cor Asa perfectum erat coram Domino cunctis diebus suis."
,"15":"Et intulit ea, quae sanctificaverat pater suus et quae ipse voverat, in domum Domini, argentum et aurum et vasa."
,"16":"Bellum autem erat inter Asa et Baasa regem lsrael cunctis diebus eorum."
,"17":"Ascendit quoque Baasa rex Israel in Iudam et aedificavit Rama, ut non posset quispiam egredi vel ingredi de parte Asa regis Iudae."
,"18":"Tollens itaque Asa omne argentum et aurum, quod remanserat in thesauris domus Domini et in thesauris domus regiae, dedit illud in manu servorum suorum et misit ad Benadad filium Tabremmon filii Hezion regem Syriae, qui habitabat in Damasco, dicens:"
,"19":"' Foedus est inter me et te et inter patrem meum et patrem tuum; ideo misi tibi munera, argentum et aurum, et peto, ut irritum facias foedus, quod habes cum Baasa rege Israel, et recedat a me '."
,"20":"Acquiescens Benadad regi Asa misit principes exercituum suorum in civitates Israel, et percusserunt Ahion et Dan et Abelbethmaacha et universam Chenereth cum omni terra Nephthali."
,"21":"Quod cum audisset Baasa, cessavit aedificare Rama et reversus est in Thersa."
,"22":"Rex autem Asa convocavit omnem Iudam, nullo excusato; et tulerunt lapides Rama et ligna eius, quibus aedificaverat Baasa, et exstruxit de eis rex Asa Gabaa Beniamin et Maspha."
,"23":"Reliqua autem omnium gestorum Asa et universa fortitudo eius et cuncta, quae fecit, et civitates, quas exstruxit, nonne haec scripta sunt in libro annalium regum Iudae? Verumtamen in tempore senectutis suae doluit pedes;"
,"24":"et dormivit cum patribus suis et sepultus est cum eis in civitate David patris sui. Regnavitque Iosaphat filius eius pro eo."
,"25":"Nadab vero filius Ieroboam regnavit super Israel anno secundo Asa regis Iudae; regnavitque super Israel duobus annis."
,"26":"Et fecit, quod malum est in conspectu Domini, et ambulavit in viis patris sui et in peccato eius, quo peccare fecit Israel."
,"27":"Insidiatus est autem ei Baasa filius Ahiae de domo Issachar et percussit eum in Gebbethon, quae est urbs Philisthinorum; siquidem Nadab et omnis Israel obsidebant Gebbethon."
,"28":"Interfecit igitur illum Baasa in anno tertio Asa regis Iudae et regnavit pro eo."
,"29":"Cumque regnasset, percussit omnem domum Ieroboam; non dimisit ne unam quidem animam de semine eius, donec deleret eam iuxta verbum Domini, quod locutus fuerat in manu servi sui Ahiae Silonitis"
,"30":"propter peccata Ieroboam, quae peccaverat et quibus peccare fecerat Israel, et propter delictum, quo irritaverat Dominum, Deum Israel."
,"31":"Reliqua autem gestorum Nadab et omnia, quae fortiter operatus est, nonne haec scripta sunt in libro annalium regum Israel?"
,"32":"Fuitque bellum inter Asa et Baasa regem Israel cunctis diebus eorum."
,"33":"Anno tertio Asa regis Iudae regnavit Baasa filius Ahiae super omnem Israel in Thersa viginti quattuor annis;"
,"34":"et fecit malum coram Domino ambulavitque in via Ieroboam et in peccato eius, quo peccare fecit Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Factus est autem sermo Domini ad Iehu filium Hanani contra Baasa dicens:"
,"2":"' Pro eo quod exaltavi te de pulvere et posui te ducem super populum meum Israel, tu autem ambulasti in via Ieroboam et peccare fecisti populum meum Israel, ut me irritares in peccatis eorum,"
,"3":"ecce ego demetam posteriora Baasa et posteriora domus eius et faciam domum tuam sicut domum Ieroboam filii Nabat."
,"4":"Qui mortuus fuerit de Baasa in civitate, comedent eum canes; et, qui mortuus fuerit ex eo in agro, comedent eum volucres caeli'."
,"5":"Reliqua autem gestorum Baasa et quaecumque fecit et fortitudo eius, nonne haec scripta sunt in libro annalium regum Israel?"
,"6":"Dormivit ergo Baasa cum patribus suis sepultusque est in Thersa; et regnavit Ela filius eius pro eo."
,"7":"Sed et in manu Iehu filii Hanani prophetae verbum Domini factum est ad Baasa et ad domum eius propter omne malum, quod fecerat coram Domino ad irritandum eum in operibus manuum suarum, ut fieret sicut domus Ieroboam, eo quod percussisset eam."
,"8":"Anno vicesimo sexto Asa regis Iudae regnavit Ela filius Baasa super Israel in Thersa duobus annis."
,"9":"Et rebellavit contra eum servus suus Zamri dux mediae partis curruum. Erat autem Ela in Thersa bibens et temulentus in domo Arsa praefecti domus in Thersa;"
,"10":"irruens ergo Zamri percussit et occidit eum anno vicesimo septimo Asa regis Iudae et regnavit pro eo."
,"11":"Cumque regnasset et sedisset super solium eius, percussit omnem domum Baasa et non dereliquit ex eo quidquid masculini sexus et propinquos et amicos eius."
,"12":"Delevitque Zamri omnem domum Baasa iuxta verbum Domini, quod locutus fuerat ad Baasa in manu Iehu prophetae,"
,"13":"propter universa peccata Baasa et peccata Ela filii eius, qui peccaverunt et peccare fecerunt Israel provocantes Dominum, Deum Israel, in vanitatibus suis."
,"14":"Reliqua autem gestorum Ela et omnia, quae fecit, nonne haec scripta sunt in libro annalium regum Israel?"
,"15":"Anno vicesimo septimo Asa regis Iudae regnavit Zamri septem diebus in Thersa. Porro exercitus obsidebat Gebbethon urbem Philisthinorum."
,"16":"Cumque audisset rebellasse Zamri et occidisse regem, fecit sibi regem omnis Israel Amri, qui erat princeps militiae super Israel in die illa in castris."
,"17":"Ascendit ergo Amri et omnis Israel cum eo de Gebbethon, et obsidebant Thersa;"
,"18":"videns autem Zamri quod expugnanda esset civitas, ingressus est palatium et succendit super se domum regiam et mortuus est igne"
,"19":"in peccatis suis, quae peccaverat faciens malum coram Domino et ambulans in via Ieroboam et in peccato eius, quo fecit peccare Israel."
,"20":"Reliqua autem gestorum Zamri et rebellio, quam fecit, nonne haec scripta sunt in libro annalium regum Israel?"
,"21":"Tunc divisus est populus Israel in duas partes: media pars populi sequebatur Thebni filium Gineth, ut constitueret eum regem, et media pars Amri."
,"22":"Praevaluit autem populus, qui erat cum Amri, populo, qui sequebatur Thebni filium Gineth; mortuusque est Thebni, et regnavit Amri."
,"23":"Anno tricesimo primo Asa regis Iudae regnavit Amri super Israel duodecim annis; in Thersa regnavit sex annis."
,"24":"Emitque montem Samariae a Somer duobus talentis argenti et aedificavit eum et vocavit nomen civitatis, quam exstruxerat, nomine Somer domini montis Samariae."
,"25":"Fecit autem Amri malum in conspectu Domini et operatus est nequiter super omnes, qui fuerunt ante eum;"
,"26":"ambulavitque in omni via Ieroboam filii Nabat et in peccato eius, quo peccare fecerat Israel, ut irritaret Dominum, Deum Israel, in vanitatibus suis."
,"27":"Reliqua autem gestorum Amri et proelia eius, quae fortiter gessit, nonne haec scripta sunt in libro annalium regum Israel?"
,"28":"Et dormivit Amri cum patribus suis et sepultus est in Samaria; regnavitque Achab filius eius pro eo."
,"29":"Achab vero filius Amri regnavit super Israel anno tricesimo octavo Asa regis Iudae; et regnavit Achab filius Amri super Israel in Samaria viginti et duobus annis."
,"30":"Et fecit Achab filius Amri malum in conspectu Domini super omnes, qui fuerunt ante eum."
,"31":"Nec suffecit ei, ut ambularet in peccatis Ieroboam filii Nabat; insuper duxit uxorem Iezabel filiam Ethbaal regis Sidoniorum et abiit et servivit Baal et adoravit eum."
,"32":"Et posuit aram Baal in templo Baal, quod aedificaverat in Samaria,"
,"33":"et fecit Achab palum. Et addidit Achab in opere suo irritans Dominum, Deum Israel, super omnes reges Israel, qui fuerant ante eum."
,"34":"In diebus eius aedificavit Hiel de Bethel Iericho; in Abiram primitivo suo fundavit eam et in Segub novissimo suo posuit portas eius, iuxta verbum Domini, quod locutus fuerat in manu Iosue filii Nun."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Et dixit Elias Thesbites de Thesbi in Galaad ad Achab: ' Vivit Dominus, Deus Israel, in cuius conspectu sto. Non erit annis his ros et pluvia, nisi iuxta oris mei verba! '."
,"2":"Et factum est verbum Domini ad eum dicens:"
,"3":"' Recede hinc et vade contra orientem et abscondere in torrente Charith, qui est contra Iordanem,"
,"4":"et ibi de torrente bibes; corvisque praecepi, ut pascant te ibi '."
,"5":"Abiit ergo et fecit iuxta verbum Domini; cumque abisset, sedit in torrente Charith, qui est contra Iordanem."
,"6":"Corvi quoque deferebant ei panem et carnes mane, similiter panem et carnes vesperi; et bibebat de torrente."
,"7":"Post dies autem siccatus est torrens; non enim pluerat super terram."
,"8":"Factus est igitur sermo Domini ad eum dicens:"
,"9":"' Surge et vade in Sarepta Sidoniorum et manebis ibi; praecepi enim ibi mulieri viduae, ut pascat te '."
,"10":"Surrexit et abiit Sareptam. Cumque venisset ad portam civitatis, apparuit ei mulier vidua colligens ligna; et vocavit eam dixitque: ' Da mihi paululum aquae in vase, ut bibam '."
,"11":"Cumque illa pergeret, ut afferret, clamavit post tergum eius dicens: ' Affer mihi, obsecro, et buccellam panis in manu tua '."
,"12":"Quae respondit: ' Vivit Dominus Deus tuus, non habeo panem, nisi quantum pugillus capere potest farinae in hydria et paululum olei in lecytho. En colligo duo ligna, ut ingrediar et faciam illud mihi et filio meo, ut comedamus et moriamur '."
,"13":"Ad quam Elias ait: ' Noli timere, sed vade et fac, sicut dixisti; verumtamen mihi primum fac de ipsa farinula subcinericium panem parvulum et affer ad me; tibi autem et filio tuo facies postea."
,"14":"Haec autem dicit Dominus, Deus Israel: 'Hydria farinae non deficiet, nec lecythus olei minuetur usque ad diem, in qua daturus est Dominus pluviam super faciem terrae' '."
,"15":"Quae abiit et fecit iuxta verbum Eliae et comedit illa et ipse et domus eius per dies."
,"16":"Hydria farinae non defecit, et lecythus olei non est imminutus iuxta verbum Domini, quod locutus fuerat in manu Eliae."
,"17":"Factum est autem post haec, aegrotavit filius mulieris matris familiae; et erat languor fortis nimis, ita ut non remaneret in eo halitus."
,"18":"Dixit ergo ad Eliam: ' Quid mihi et tibi, vir Dei? Ingressus es ad me, ut rememorarentur iniquitates meae, et interficeres filium meum? '."
,"19":"Et ait ad eam: ' Da mihi filium tuum '. Tulitque eum de sinu illius et portavit in cenaculum, ubi ipse manebat, et posuit super lectulum suum;"
,"20":"clamavitque ad Dominum et dixit: ' Domine Deus meus, etiamne viduam, apud quam ego ut hospes habito, afflixisti, ut interficeres filium eius? '."
,"21":"Et expandit se atque mensus est super puerum tribus vicibus et clamavit ad Dominum et ait: ' Domine Deus meus, revertatur, oro, anima pueri huius in viscera eius '."
,"22":"Et exaudivit Dominus vocem Eliae, et reversa est anima pueri intra eum, et revixit."
,"23":"Tulitque Elias puerum et deposuit eum de cenaculo in inferiorem domum et tradidit matri suae et ait illi: ' En vivit filius tuus '."
,"24":"Dixitque mulier ad Eliam: ' Nunc in isto cognovi quoniam vir Dei es tu, et verbum Domini in ore tuo verum est '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Post dies multos factum est verbum Domini ad Eliam in anno tertio dicens: ' Vade et ostende te Achab, ut dem pluviam super faciem terrae '."
,"2":"Ivit ergo Elias, ut ostenderet se Achab. Erat autem fames vehemens in Samaria. "
,"3":"Vocavitque Achab Abdiam dispensatorem domus suae. Abdias autem timebat Dominum valde;"
,"4":"nam, cum interficeret Iezabel prophetas Domini, tulit ille centum prophetas et abscondit eos quinquagenos et quinquagenos in speluncis et pavit eos pane et aqua."
,"5":"Dixit ergo Achab ad Abdiam: ' Vade in terra ad universos fontes aquarum et in cunctas valles, si forte invenire possimus herbam, ut salvemus equos et mulos et nullum de iumentis interficere debeamus '."
,"6":"Diviseruntque sibi regiones, ut circuirent eas: Achab ibat per viam unam, et Abdias per viam alteram seorsum."
,"7":"Cumque esset Abdias in via, Elias occurrit ei; qui cum cognovisset eum, cecidit super faciem suam et ait: ' Num tu es, domine mi, Elias? '."
,"8":"Cui ille respondit: ' Ego. Vade, dic domino tuo: 'Adest Elias' '."
,"9":"Et ille: ' Quid peccavi, inquit, quoniam trades me servum tuum in manu Achab, ut interficiat me?"
,"10":"Vivit Dominus Deus tuus, non est gens aut regnum, quo non miserit dominus meus te requirens et, respondentibus cunctis: 'Non est hic', adiuravit regna singula et gentes, eo quod minime reperireris."
,"11":"Et nunc dicis mihi: 'Vade et dic domino tuo: Adest Elias'."
,"12":"Cumque recessero a te, spiritus Domini asportabit te in locum, quem ego ignoro; et ingressus nuntiabo Achab, et non inveniet te et interficiet me. Servus autem tuus timet Dominum ab infantia sua."
,"13":"Numquid non indicatum est domino meo quid fecerim, cum interficeret Iezabel prophetas Domini: quod absconderim de prophetis Domini centum viros, quinquagenos et quinquagenos in speluncis et paverim eos pane et aqua?"
,"14":"Et nunc tu dicis: 'Vade et dic domino tuo: Adest Elias', ut interficiat me '."
,"15":"Dixit Elias: ' Vivit Dominus exercituum ante cuius vultum sto: hodie apparebo ei '."
,"16":"Abiit ergo Abdias in occursum Achab et indicavit ei. Venitque Achab in occursum Eliae "
,"17":"et, cum vidisset eum, ait: ' Tune es, qui conturbas Israel? '."
,"18":"Et ille ait: ' Non turbavi Israel, sed tu et domus patris tui, qui dereliquistis mandata Domini, et secutus es Baalim."
,"19":"Verumtamen nunc mitte et congrega ad me universum Israel in monte Carmeli et prophetas Baal quadringentos quinquaginta prophetasque Aserae quadringentos, qui comedunt de mensa Iezabel '."
,"20":"Misit Achab ad omnes filios Israel et congregavit prophetas in monte Carmeli."
,"21":"Accedens autem Elias ad omnem populum ait: ' Usquequo claudicatis in duas partes? Si Dominus est Deus, sequimini eum; si autem Baal, sequimini illum '. Et non respondit ei populus verbum."
,"22":"Et ait rursus Elias ad populum: ' Ego remansi propheta Domini solus; prophetae autem Baal quadringenti et quinquaginta viri sunt."
,"23":"Dentur nobis duo boves, et illi eligant sibi bovem unum et in frusta caedentes ponant super ligna; ignem autem non supponant. Et ego faciam bovem alterum et imponam super ligna; ignemque non supponam."
,"24":"Invocate nomen dei vestri, et ego invocabo nomen Domini; et Deus, qui exaudierit per ignem, ipse est Deus! '. Respondens omnis populus ait: ' Optima propositio '."
,"25":"Dixit ergo Elias prophetis Baal: ' Eligite vobis bovem unum et facite primi, quia vos plures estis; et invocate nomen dei vestri ignemque non supponatis '."
,"26":"Qui cum tulissent bovem, quem dederat eis, fecerunt et invocabant nomen Baal de mane usque ad meridiem dicentes: ' Baal, exaudi nos! '. Et non erat vox, nec qui responderet. Saliebantque in circuitu altaris, quod fecerant."
,"27":"Cumque esset iam meridies, illudebat eis Elias dicens: ' Clamate voce maiore; deus enim est et forsitan occupatus est aut secessit aut in itinere aut certe dormit, ut excitetur '."
,"28":"Clamabant ergo voce magna et incidebant se iuxta ritum suum cultris et lanceolis, donec perfunderentur sanguine."
,"29":"Postquam autem transiit meridies, et, illis prophetantibus, venerat tempus, quo sacrificium offerri solet, nec audiebatur vox, neque aliquis respondebat nec attendebat orantes,"
,"30":"dixit Elias omni populo: ' Venite ad me '. Et, accedente ad se populo, curavit altare Domini, quod destructum fuerat;"
,"31":"et tulit duodecim lapides iuxta numerum tribuum filiorum Iacob, ad quem factus est sermo Domini dicens: ' Israel erit nomen tuum '."
,"32":"Et aedificavit lapidibus altare in nomine Domini fecitque aquaeductum quasi pro duobus satis in circuitu altaris"
,"33":"et composuit ligna divisitque per membra bovem et posuit super ligna"
,"34":"et ait: ' Implete quattuor hydrias aqua et fundite super holocaustum et super ligna '. Rursumque dixit: ' Etiam secundo hoc facite '. Qui cum fecissent et secundo, ait: ' Etiam tertio idipsum facite '. Feceruntque et tertio,"
,"35":"et currebant aquae circum altare, et fossa aquaeductus repleta est."
,"36":"Cumque iam tempus esset, ut offerretur sacrificium, accedens Elias propheta ait: ' Domine, Deus Abraham, Isaac et Israel, hodie ostende quia tu es Deus in Israel, et ego servus tuus et iuxta praeceptum tuum feci omnia haec."
,"37":"Exaudi me, Domine, exaudi me, ut discat populus iste quia tu, Domine, es Deus et tu convertisti cor eorum iterum! '."
,"38":"Cecidit autem ignis Domini et voravit holocaustum et ligna et lapides, pulverem quoque et aquam, quae erat in aquaeductu lambens."
,"39":"Quod cum vidisset omnis populus, cecidit in faciem suam et ait: ' Dominus ipse est Deus, Dominus ipse est Deus! '."
,"40":"Dixitque Elias ad eos: ' Apprehendite prophetas Baal, et ne unus quidem effugiat ex eis! '. Quos cum comprehendissent, duxit eos Elias ad torrentem Cison et interfecit eos ibi."
,"41":"Et ait Elias ad Achab: ' Ascende, comede et bibe, quia sonus multae pluviae est '."
,"42":"Ascendit Achab, ut comederet et biberet. Elias autem ascendit in verticem Carmeli et pronus in terram posuit faciem inter genua sua"
,"43":"et dixit ad puerum suum: ' Ascende et prospice contra mare '. Qui, cum ascen disset et contemplatus esset, ait: ' Non est quidquam '. Et rursum ait illi: ' Revertere septem vicibus '."
,"44":"In septima autem vice dixit: ' Ecce nubecula parva quasi manus hominis ascendit de mari '. Et ait: ' Ascende et dic Achab: Iunge et descende, ne occupet te pluvia! '."
,"45":"Et factum est interea: ecce caeli contenebrati sunt, et nubes et ventus, et facta est pluvia grandis. Ascendens itaque Achab abiit in Iezrahel."
,"46":"Et manus Domini facta est super Eliam; accinctisque lumbis, currebat ante Achab, donec veniret in Iezrahel."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Nuntiavit autem Achab Iezabel omnia, quae fecerat Elias, et quomodo occidisset universos prophetas gladio."
,"2":"Misitque Iezabel nuntium ad Eliam dicens: ' Haec mihi faciant dii et haec addant, nisi hac hora cras posuero animam tuam sicut animam unius ex illis '."
,"3":"Timuit ergo Elias et surgens abiit, ut animam suam salvaret, venitque in Bersabee Iudae et dimisit ibi puerum suum."
,"4":"Et perrexit in desertum via unius diei; cumque venisset et sederet subter unam iuniperum, petivit animae suae, ut moreretur, et ait: ' Sufficit mihi, Domine! Tolle animam meam; neque enim melior sum quam patres mei '."
,"5":"Proiecitque se et obdormivit in umbra iuniperi; et ecce angelus tetigit eum et dixit illi: ' Surge, comede! '."
,"6":"Respexit, et ecce ad caput suum subcinericius panis et vas aquae; comedit ergo et bibit et rursum obdormivit."
,"7":"Reversusque est angelus Domini secundo et tetigit eum dixitque illi: ' Surge, comede! Grandis enim tibi restat via '."
,"8":"Qui, cum surrexisset, comedit et bibit et ambulavit in fortitudine cibi illius quadraginta diebus et quadraginta noctibus usque ad montem Dei Horeb."
,"9":"Cumque venisset illuc, mansit in spelunca. Et ecce sermo Domini ad eum dixitque illi: ' Quid hic agis, Elia? '."
,"10":"At ille respondit: ' Zelo zelatus sum pro Domino, Deo exercituum, quia dereliquerunt pactum tuum filii Israel, altaria tua destruxerunt et prophetas tuos occiderunt gladio; et derelictus sum ego solus, et quaerunt animam meam, ut auferant eam '."
,"11":"Et ait ei: ' Egredere et sta in monte coram Domino '. Et ecce Dominus transit, et ventus grandis et fortis subvertens montes et conterens petras ante Dominum; non in vento Dominus. Et post ventum, commotio; non in commotione Dominus."
,"12":"Et post commotionem, ignis; non in igne Dominus. Et post ignem, sibilus aurae tenuis."
,"13":"Quod cum audisset Elias, operuit vultum suum pallio et egressus stetit in ostio speluncae; et ecce vox ad eum dicens: ' Quid agis hic, Elia? '."
,"14":"Et ille respondit: ' Zelo zelatus sum pro Domino, Deo exercituum, quia dereliquerunt pactum tuum filii Israel, altaria tua destruxerunt et prophetas tuos occiderunt gladio; et derelictus sum ego solus, et quaerunt animam meam, ut auferant eam '."
,"15":"Et ait Dominus ad eum: ' Vade et revertere in viam tuam per desertum in Damascum. Cumque perveneris, unges Hazael regem super Syriam;"
,"16":"et Iehu filium Namsi unges regem super Israel; Eliseum autem filium Saphat, qui est de Abelmehula, unges prophetam pro te."
,"17":"Et erit: quicumque fugerit gladium Hazael, occidet eum Iehu; et, qui fugerit gladium Iehu, interficiet eum Eliseus."
,"18":"Et relinquam mihi in Israel septem milia: universorum genua, quae non sunt incurvata ante Baal, et omne os, quod non osculatum est eum '."
,"19":"Profectus ergo inde repperit Eliseum filium Saphat arantem duodecim iugis boum; et ipse cum duodecimo erat. Cumque venisset Elias ad eum, misit pallium suum super illum,"
,"20":"qui statim, relictis bobus, cucurrit post Eliam et ait: ' Osculer, oro, patrem meum et matrem meam, et sic sequar te '. Dixitque ei: ' Vade et revertere; quid enim feci tibi? '."
,"21":"Reversus autem ab eo tulit par boum et mactavit illud et in iugo boum coxit carnes et dedit populo, et comederunt. Consurgensque abiit et secutus est Eliam et ministrabat ei."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Porro Benadad rex Syriae congregavit omnem exerci tum suum et triginta duos reges secum et equos et currus et ascendens pugnabat contra Samariam et obsidebat eam."
,"2":"Mittensque nuntios ad Achab regem Israel in civitatem"
,"3":"ait: ' Haec dicit Benadad: Argentum tuum et aurum tuum meum est, et uxores tuae et filii tui optimi mei sunt '."
,"4":"Responditque rex Israel: ' Iuxta verbum tuum, domine mi rex; tuus sum ego et omnia mea '."
,"5":"Revertentesque nuntii dixerunt: ' Haec dicit Benadad: Quia misi ad te dicens: 'Argentum tuum et aurum tuum et uxores tuas et filios tuos dabis mihi',"
,"6":"profecto cras hac eadem hora mittam servos meos ad te, et scrutabuntur domum tuam et domum servorum tuorum; et omne, quod oculis tuis pretiosum est, ponent in manibus suis et auferent '."
,"7":"Vocavit autem rex Israel omnes seniores terrae et ait: ' Animadvertite et videte quoniam insidietur nobis; misit enim ad me pro uxoribus meis et filiis et pro argento et auro, et non abnui '."
,"8":"Dixeruntque omnes maiores natu et universus populus ad eum: ' Non audias neque acquiescas illi '."
,"9":"Respondit itaque nuntiis Benadad: ' Dicite domino meo regi: Omnia, propter quae misisti ad me servum tuum initio, faciam; hanc autem rem facere non possum '. Reversique nuntii rettulerunt ei."
,"10":"Qui remisit et ait: ' Haec faciant mihi dii et haec addant, si suffecerit pulvis Samariae pugillis omnis populi, qui sequitur me '."
,"11":"Et respondens rex Israel ait: ' Dicite ei: Ne glorietur accinctus aeque ut discinctus '."
,"12":"Factum est autem, cum audisset verbum istud, bibebat ipse et reges in umbraculis et ait servis suis: ' Circumdate civitatem! '. Et circumdederunt eam."
,"13":"Et ecce propheta unus accedens ad Achab regem Israel ait: ' Haec dicit Dominus: Certe vidisti omnem multitudinem hanc nimiam. Ecce ego tradam eam in manu tua hodie, ut scias quia ego sum Dominus '."
,"14":"Et ait Achab: ' Per quem? '. Dixitque ei: ' Haec dicit Dominus: Per pedisequos principum provinciarum '. Et ait: ' Quis incipiet proeliari? '. Et ille dixit: ' Tu '."
,"15":"Recensuit ergo pueros principum provinciarum et repperit numerum ducentorum triginta duorum; et post eos recensuit populum, omnes filios Israel, septem milia."
,"16":"Et egressi sunt meridie. Benadad autem bibebat temulentus in umbraculis ipse et reges triginta duo cum eo, qui ad auxilium eius venerant."
,"17":"Egressi sunt autem pueri principum provinciarum in prima fronte. Misit itaque Benadad, qui nuntiaverunt ei dicentes: ' Viri egressi sunt de Samaria '."
,"18":"At ille ait: ' Sive pro pace veniunt, apprehendite eos vivos; sive ut proelientur, vivos eos capite '."
,"19":"Egressi erant ergo ex urbe pueri principum provinciarum, ac reliquus exercitus sequebatur,"
,"20":"et percussit unusquisque virum, qui contra se venerat; fugeruntque Syri, et persecutus est eos Israel. Fugit quoque Benadad rex Syriae in equo cum equitibus."
,"21":"Necnon egressus rex Israel percussit equos et currus et percussit Syriam plaga magna."
,"22":"Accedens autem propheta ad regem Israel dixit ei: ' Vade et confortare et scito et vide quid facias; vertente enim anno rex Syriae ascendet contra te '."
,"23":"Servi vero regis Syriae dixerunt ei: ' Deus montium est Deus eorum, ideo superaverunt nos; sed pugnemus contra eos in campestribus et obtinebimus eos."
,"24":"Fac ergo hoc: Amove reges singulos a loco suo et pone principes pro eis;"
,"25":"et instaura numerum militum, qui ceciderunt de tuis, et equos secundum equos pristinos et currus secundum currus, quos ante habuisti, et pugnabimus contra eos in campestribus: et videbis quod obtinebimus eos '. Credidit consilio eorum et fecit ita."
,"26":"Igitur vertente anno recensuit Benadad Syros et ascendit in Aphec, ut pugnaret contra Israel."
,"27":"Porro filii Israel recensiti sunt et, acceptis cibariis, profecti ex adverso castraque metati sunt contra eos, quasi duo parvi greges caprarum; Syri autem repleverunt terram."
,"28":"Et accedens vir Dei dixit ad regem Israel: ' Haec dicit Dominus: Quia dixerunt Syri: 'Deus montium est Dominus et non est Deus vallium', dabo omnem multitudinem hanc grandem in manu tua, et scietis quia ego Dominus '."
,"29":"Dirigebant septem diebus ex adverso hi atque illi acies, septima autem die commissum est bellum; percusseruntque filii Israel de Syris centum milia peditum in die una."
,"30":"Fugerunt autem, qui remanserant in Aphec, in civitatem, et cecidit murus super viginti septem milia hominum, qui remanserant. Porro Benadad fugiens ingressus est civitatem in cubiculum, quod erat intra cubiculum. "
,"31":"Dixeruntque ei servi sui: ' Ecce audivimus quod reges domus Israel clementes sint; ponamus itaque saccos in lumbis nostris et funiculos in capitibus nostris et egrediamur ad regem Israel; forsitan salvabit animam tuam '."
,"32":"Accinxerunt saccis lumbos suos et posuerunt funes in capitibus suis veneruntque ad regem Israel et dixerunt: ' Servus tuus Benadad dicit: 'Vivat, oro te, anima mea' '. Et ille ait: ' Si adhuc vivit, frater meus est '."
,"33":"Quod acceperunt viri pro omine et festinantes rapuerunt verbum ex ore eius atque dixerunt: ' Frater tuus Benadad '. Et dixit eis: ' Ite et adducite eum '. Egressus est ergo ad eum Benadad, et levavit eum in currum suum."
,"34":"Qui dixit ei: ' Civitates, quas tulit pater meus a patre tuo, reddam; et plateas fac tibi in Damasco, sicut fecit pater meus in Samaria '. Achab: ' Ego autem, inquit, foederatum te dimittam '. Et pepigit ei foedus et dimisit eum."
,"35":"Tunc vir quidam de filiis prophetarum dixit ad socium suum in sermone Domini: ' Percute me! '. At ille noluit percutere."
,"36":"Cui ait: ' Quia noluisti audire vocem Domini, ecce recedes a me, et percutiet te leo '. Cumque paululum recessisset ab eo, invenit eum leo atque percussit."
,"37":"Sed et alterum inveniens virum dixit ad eum: ' Percute me! '. Qui percussit eum et vulneravit."
,"38":"Abiit ergo propheta et occurrit regi in via et mutavit aspectum ponens fasciam super oculos suos."
,"39":"Cumque rex transiret, clamavit ad regem et ait: ' Servus tuus egressus est ad proeliandum comminus; cumque fugisset vir unus, adduxit eum quidam ad me et ait: 'Custodi virum istum! Qui si lapsus fuerit, erit anima tua pro anima eius, aut talentum argenti appendes'."
,"40":"Dum autem ego turbatus huc illucque me verterem, subito non comparuit '. Et ait rex Israel ad eum: ' Hoc est iudicium tuum, quod ipse decrevisti '."
,"41":"At ille statim abstulit fasciam de oculis suis, et cognovit eum rex Israel quod esset de prophetis."
,"42":"Qui ait ad eum: ' Haec dicit Dominus: Quia dimisisti de manu tua virum, quem morti devoveram, erit anima tua pro anima eius, et populus tuus pro populo eius '."
,"43":"Reversus est igitur rex Israel in domum suam tristis et indignans venitque in Samariam."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Postea autem factum est hoc. Vinea erat Naboth Iez rahelitae, quae erat in Iezrahel iuxta palatium Achab regis Samariae."
,"2":"Locutus est ergo Achab ad Naboth dicens: ' Da mihi vineam tuam, ut faciam mihi hortum holerum, quia vicina est et prope domum meam. Daboque tibi pro ea vineam meliorem aut, si tibi commodius putas, argenti pretium quanto digna est '."
,"3":"Cui respondit Naboth: ' Propitius mihi sit Dominus, ne dem hereditatem patrum meorum tibi '."
,"4":"Venit ergo Achab in domum suam tristis et indignans super verbo, quod locutus fuerat ad eum Naboth Iezrahelites dicens: ' Non dabo tibi hereditatem patrum meorum '. Et proiciens se in lectulum suum avertit faciem ad parietem et non comedit panem."
,"5":"Ingressa est autem ad eum Iezabel uxor sua dixitque ei: ' Quid est hoc, unde anima tua contristata est? Et quare non comedis panem? '."
,"6":"Qui respondit ei: ' Quia locutus sum Naboth Iezrahelitae et dixi ei: Da mihi vineam tuam, accepta pecunia; aut, si tibi placet, dabo tibi vineam pro ea. Et ille ait: 'Non dabo tibi vineam meam' '."
,"7":"Dixit ergo ad eum Iezabel uxor eius: ' Grandis auctoritatis es et bene regis regnum Israel! Surge et comede panem et aequo esto animo; ego dabo tibi vineam Naboth Iezrahelitae '."
,"8":"Scripsit itaque litteras ex nomine Achab et signavit eas anulo eius et misit ad maiores natu et ad optimates, qui erant in civitate eius et habitabant cum Naboth."
,"9":"Litterarum autem haec erat sententia: ' Praedicate ieiunium et sedere facite Naboth in capite populi"
,"10":"et submittite duos viros filios Belial contra eum, et testimonium dicant: 'Maledixisti Deum et regem'; et educite eum et lapidate, sicque moriatur '."
,"11":"Fecerunt ergo cives eius maiores natu et optimates, qui habitabant cum eo in urbe, sicut praeceperat eis Iezabel et sicut scriptum erat in litteris, quas miserat ad eos."
,"12":"Praedicaverunt ieiunium et sedere fecerunt Naboth in capite populi;"
,"13":"et ingressi duo viri filii Belial sederunt contra eum et illi, ut viri diabolici, dixerunt contra eum testimonium coram multitudine: ' Maledixit Naboth Deum et regem '. Quam ob rem eduxerunt eum extra civitatem et lapidibus interfecerunt;"
,"14":"miseruntque ad Iezabel dicentes: ' Lapidatus est Naboth et mortuus est '."
,"15":"Factum est autem cum audisset Iezabel lapidatum Naboth et mortuum, locuta est ad Achab: ' Surge, posside vineam Naboth Iezrahelitae, qui noluit tibi acquiescere et dare eam, accepta pecunia; non enim vivit Naboth, sed mortuus est '."
,"16":"Quod cum audisset Achab, mortuum videlicet Naboth, surrexit et descendebat in vineam Naboth Iezrahelitae, ut possideret eam."
,"17":"Factus est igitur sermo Domini ad Eliam Thesbiten dicens:"
,"18":"' Surge et descende in occursum Achab regis Israel, qui est in Samaria; ecce est in vinea Naboth, ad quam descendit, ut possideat eam."
,"19":"Et loqueris ad eum dicens: Haec dicit Dominus: Occidisti, insuper et possedisti! Et post haec addes: Haec dicit Dominus: In loco, in quo linxerunt canes sanguinem Naboth, lambent tuum quoque sanguinem '."
,"20":"Et ait Achab ad Eliam: ' Num invenisti me, inimice mi? '. Qui dixit: ' Inveni, eo quod venumdatus sis, ut faceres malum in conspectu Domini."
,"21":"Ecce ego inducam super te malum et demetam posteriora tua et interficiam de Achab quidquid masculini sexus sive impuberem sive puberem in Israel."
,"22":"Et dabo domum tuam sicut domum Ieroboam filii Nabat et sicut domum Baasa filii Ahia, quia egisti, ut me ad iracundiam provocares, et peccare fecisti Israel."
,"23":"Sed et de Iezabel locutus est Dominus dicens: Canes comedent Iezabel in agro Iezrahel."
,"24":"Qui de Achab mortuus fuerit in civitate, comedent eum canes; qui autem mortuus fuerit in agro, comedent eum volucres caeli '."
,"25":"Igitur non fuit alter talis sicut Achab, qui venumdatus est, ut faceret malum in conspectu Domini; concitavit enim eum Iezabel uxor sua,"
,"26":"et abominabilis effectus est, in tantum ut sequeretur idola secundum omnia, quae fecerant Amorraei, quos consumpsit Dominus a facie filiorum Israel."
,"27":"Itaque cum audisset Achab sermones istos, scidit vestem suam et operuit cilicio carnem suam ieiunavitque et dormivit in sacco et ambulabat demisso capite."
,"28":"Factus est autem sermo Domini ad Eliam Thesbiten dicens:"
,"29":"Nonne vidisti humiliatum Achab coram me? Quia igitur humiliatus est mei causa, non inducam malum in diebus eius, sed in diebus filii sui inferam malum domui eius '."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Transierunt igitur tres anni absque bello inter Syriam et Israel."
,"2":"In anno autem tertio descendit Iosaphat rex ludae ad regem Israel,"
,"3":"dixitque rex Israel ad servos suos: ' Ignoratis quod nostra sit Ramoth Galaad et neglegimus tollere eam de manu regis Syriae? '."
,"4":"Et ait ad Iosaphat: ' Veniesne mecum ad proeliandum in Ramoth Galaad? '."
,"5":"Dixitque Iosaphat ad regem Israel: ' Sicut ego sum, ita et tu; populus meus et populus tuus unum sunt, et equites mei et equites tui '. Dixitque Iosaphat ad regem Israel: ' Quaere, oro te, hodie sermonem Domini '."
,"6":"Congregavit ergo rex Israel prophetas quadringentos circiter viros et ait ad eos: ' Ire debeo in Ramoth Galaad ad bellandum, an quiescere? '. Qui responderunt: ' Ascende, et dabit Dominus in manu regis '."
,"7":"Dixit autem Iosaphat: ' Non est hic et alius propheta Domini, ut interrogemus per eum? '."
,"8":"Et ait rex Israel ad Iosaphat: ' Remansit vir unus, per quem possimus interrogare Dominum; sed ego odi eum, quia non prophetat mihi bonum sed malum: Michaeas filius Iemla '. Cui Iosaphat ait: ' Ne loquaris ita, rex '."
,"9":"Vocavit ergo rex Israel eunuchum quendam et dixit ei: ' Festina adducere Michaeam filium Iemla '."
,"10":"Rex autem Israel et Iosaphat rex Iudae sedebat unusquisque in solio suo vestiti cultu regio in area iuxta ostium portae Samariae; et universi prophetae prophetabant in conspectu eorum."
,"11":"Fecit quoque sibi Sedecias filius Chanaana cornua ferrea et ait: ' Haec dicit Dominus: His ventilabis Syriam, donec deleas eam '."
,"12":"Omnesque prophetae similiter prophetabant dicentes: ' Ascende in Ramoth Galaad et vade prospere, et tradet Dominus in manu regis '."
,"13":"Nuntius vero, qui ierat ut vocaret Michaeam, locutus est ad eum dicens: ' Ecce sermones prophetarum ore uno regi bona praedicant; sit ergo sermo tuus similis eorum, et loquere bona '."
,"14":"Cui Michaeas ait: ' Vivit Dominus quia, quodcumque dixerit mihi Dominus, hoc loquar! '."
,"15":"Venit itaque ad regem, et ait illi rex: ' Michaea, ire debemus in Ramoth Galaad ad proeliandum, an cessare? '. Cui ille respondit: ' Ascende et vade prospere, et tradet Dominus in manu regis '."
,"16":"Dixit autem rex ad eum: ' Iterum atque iterum adiuro te, ut non loquaris mihi, nisi quod verum est in nomine Domini '."
,"17":"Et ille ait: ' Vidi cunctum Israel,dispersum in montibus,quasi oves non habentes pastorem. Et ait Dominus: 'Non habent isti dominum; revertatur unusquisque in domum suam in pace' '."
,"18":"Dixit ergo rex Israel ad Iosaphat: ' Numquid non dixi tibi quia non prophetat mihi bonum sed semper malum? '."
,"19":"Ille vero addens ait: ' Propterea audi sermonem Domini: Vidi Dominum sedentem super solium suum et omnem exercitum caeli assistentem ei a dextris et a sinistris."
,"20":"Et ait Dominus: 'Quis decipiet Achab, ut ascendat et cadat in Ramoth Galaad?'. Et dixit unus verba huiuscemodi et alius aliter."
,"21":"Egressus est autem spiritus et stetit coram Domino et ait: 'Ego decipiam illum'. Cui locutus est Dominus: 'In quo?'."
,"22":"Et ille ait: 'Egrediar et ero spiritus mendax in ore omnium prophetarum eius'. Et dixit Dominus: 'Decipies et praevalebis; egredere et fac ita'."
,"23":"Nunc igitur ecce dedit Dominus spiritum mendacii in ore omnium prophetarum tuorum, qui hic sunt, et Dominus locutus est contra te malum '."
,"24":"Accessit autem Sedecias filius Chanaana et percussit Michaeam in maxillam et dixit: ' Quomodo transivit spiritus Domini a me, ut loqueretur tibi? '."
,"25":"Et ait Michaeas: ' Visurus es in die illa, quando ingredieris cubiculum intra cubiculum, ut abscondaris '."
,"26":"Et ait rex Israel: ' Tolle Michaeam, et maneat apud Amon principem civitatis et apud Ioas filium regis,"
,"27":"et dic eis: 'Haec dicit rex: Mittite virum istum in carcerem et sustentate eum pane tribulationis et aqua angustiae, donec revertar in pace' '."
,"28":"Dixitque Michaeas: ' Si reversus fueris in pace, non est locutus Dominus in me '. Et ait: ' Audite, populi omnes! '."
,"29":"Ascendit itaque rex Israel et Iosaphat rex Iudae in Ramoth Galaad."
,"30":"Dixitque rex Israel ad Iosaphat: ' Mutato aspectu ineundum est proelium; tu autem induere vestibus tuis '. Porro rex Israel mutavit aspectum et ingressus est bellum."
,"31":"Rex autem Syriae praeceperat principibus curruum triginta duobus dicens: ' Non pugnabitis contra minorem et maiorem quempiam, nisi contra regem Israel solum '."
,"32":"Cum ergo vidissent principes curruum Iosaphat, suspicati sunt quod ipse esset rex Israel et impetu facto pugnabant contra eum. Et exclamavit Iosaphat;"
,"33":"intellexeruntque principes curruum quod non esset rex Israel et cessaverunt ab eo."
,"34":"Vir autem quidam tetendit arcum in incertum sagittam dirigens et percussit regem Israel inter iuncturas et loricam. At ille dixit aurigae suo: ' Verte manum tuam et eice me de exercitu, quia graviter vulneratus sum '."
,"35":"Aggravatum est ergo proelium in die illa; et rex Israel stabat in curru suo contra Syros et mortuus est vespere: fluebat autem sanguis plagae in sinum currus."
,"36":"Et clamor insonuit in universo exercitu ad solis occasum: ' Unusquisque revertatur in civitatem et in terram suam! '."
,"37":"Mortuus est igitur rex et perlatus est Samariam; sepelieruntque regem in Samaria."
,"38":"Et laverunt currum eius in piscina Samariae; et linxerunt canes sanguinem eius, et scorta laverunt se iuxta verbum Domini, quod locutus fuerat."
,"39":"Reliqua vero gestorum Achab et universa, quae fecit, et domus eburnea, quam aedificavit, cunctaeque urbes, quas exstruxit, nonne haec scripta sunt in libro annalium regum Israel?"
,"40":"Dormivit ergo Achab cum patribus suis; et regnavit Ochozias filius eius pro eo."
,"41":"Iosaphat vero filius Asa regnare coeperat super Iudam anno quarto Achab regis Israel;"
,"42":"triginta quinque annorum erat, cum regnare coepisset, et viginti quinque annos regnavit in Ierusalem. Nomen matris eius Azuba filia Selachi."
,"43":"Et ambulavit in omni via Asa patris sui et non declinavit ex ea; fecitque, quod rectum erat in conspectu Domini."
,"44":"Verumtamen excelsa non abstulit; adhuc enim populus sacrificabat et adolebat in excelsis."
,"45":"Pacemque fecit Iosaphat cum rege Israel."
,"46":"Reliqua autem gestorum Iosaphat et opera eius, quae fortiter gessit, et proelia, nonne haec scripta sunt in libro annalium regum Iudae?"
,"47":"Sed et reliquias prostibulorum, qui remanserant in diebus Asa patris eius, abstulit de terra."
,"48":"Nec erat tunc rex in Edom sed praefectus regius."
,"49":"Rex vero Iosaphat fecerat naves Tharsis, quae navigarent in Ophir propter aurum; et ire non potuerunt, quia confractae sunt in Asiongaber."
,"50":"Tunc ait Ochozias filius Achab ad Iosaphat: ' Vadant servi mei cum servis tuis in navibus '. Et noluit Iosaphat."
,"51":"Dormivitque Iosaphat cum patribus suis et sepultus est cum eis in civitate David patris sui; regnavitque Ioram filius eius pro eo."
,"52":"Ochozias autem filius Achab regnare coeperat super Israel in Samaria anno septimo decimo Iosaphat regis Iudae regnavitque super Israel duobus annis."
,"53":"Et fecit malum in conspectu Domini et ambulavit in via patris sui et matris suae et in via Ieroboam filii Nabat, qui peccare fecit Israel;"
,"54":"servivit quoque Baal et adoravit eum et irritavit Dominum, Deum Israel, iuxta omnia, quae fecerat pater eius."
}`)

}
func LA_NVBSE_LoadVH1SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Fuit vir unus de Ramathaim Suphita de monte Ephraim, et nomen eius Elcana filius Ieroham filii Eliu filii Thohu filii Suph, Ephrathaeus."
,"2":"Et habuit duas uxores: nomen uni Anna et nomen secundae Phenenna. Fueruntque Phenennae filii, Annae autem non erant liberi."
,"3":"Et ascendebat vir ille de civitate sua singulis annis, ut adoraret et sacrificaret Domino exercituum in Silo. Erant autem ibi duo filii Heli, Ophni et Phinees, sacerdotes Domini."
,"4":"Venit ergo dies, et immolavit Elcana dabatque Phenennae uxori suae et cunctis filiis eius et filiabus partes;"
,"5":"Annae autem dabat unam partem electam, quia Annam diligebat; Dominus autem concluserat vulvam eius."
,"6":"Affligebat quoque eam aemula eius et vehementer angebat, ut conturbaret eam, quod conclusisset Dominus vulvam eius."
,"7":"Sicque faciebat per singulos annos, cum, redeunte tempore, ascenderent templum Domini, et sic provocabat eam. Porro illa flebat et non capiebat cibum."
,"8":"Dixit ergo ei Elcana vir suus: ' Anna, cur fles et quare non comedis? Et quam ob rem affligitur cor tuum? Numquid non ego melior sum tibi quam decem filii? '."
,"9":"Surrexit autem Anna, postquam comederant et biberant in Silo, et Heli sacerdote sedente super sellam ante postes templi Domini."
,"10":"Cum esset Anna amaro animo, oravit Dominum flens largiter"
,"11":"et votum vovit dicens: ' Domine exercituum, si respiciens videris afflictionem famulae tuae et recordatus mei fueris nec oblitus ancillae tuae dederisque servae tuae sexum virilem, dabo eum Domino omnes dies vitae eius, et novacula non ascendet super caput eius '."
,"12":"Factum est ergo, cum illa multiplicaret preces coram Domino, ut Heli observaret os eius."
,"13":"Porro Anna loquebatur in corde suo; tantumque labia illius movebantur, et vox penitus non audiebatur. Aestimavit igitur eam Heli temulentam"
,"14":"dixitque ei: ' Usquequo ebria eris? Digere paulisper vinum, quo mades! '."
,"15":"Respondens Anna: ' Nequaquam, inquit, domine mi; nam mulier infelix nimis ego sum: vinumque et omne, quod inebriare potest, non bibi, sed effudi animam meam in conspectu Domini."
,"16":"Ne reputes ancillam tuam quasi unam de filiabus Belial, quia ex multitudine doloris et maeroris mei locuta sum usque in praesens '."
,"17":"Tunc Heli ait ei: ' Vade in pace, et Deus Israel det tibi petitionem, quam rogasti eum '."
,"18":"Et illa dixit: ' Utinam inveniat ancilla tua gratiam in oculis tuis '. Et abiit mulier in viam suam et comedit; vultusque illius non fuerunt amplius sicut prius."
,"19":"Et surrexerunt mane et adoraverunt coram Domino. Reversique sunt et venerunt in domum suam in Rama. Cognovit autem Elcana Annam uxorem suam, et recordatus est eius Dominus. "
,"20":"Et factum est post circulum dierum concepit Anna et peperit filium vocavitque nomen eius Samuel, eo quod a Domino postulasset eum."
,"21":"Ascendit autem vir Elcana et omnis domus eius, ut immolaret Domino hostiam annuam et votum suum."
,"22":"Et Anna non ascendit; dixit enim viro suo: ' Non vadam, donec ablactetur infans, et ducam eum, et appareat ante conspectum Domini et maneat ibi iugiter '."
,"23":"Et ait ei Elcana vir suus: ' Fac, quod bonum tibi videtur, et mane, donec ablactes eum; precorque, ut impleat Dominus verbum suum '. Mansit ergo mulier et lactavit filium suum, donec amoveret eum a lacte."
,"24":"Et adduxit eum secum, postquam ablactaverat, cum vitulo trium annorum et tribus modiis farinae et utre vini; et adduxit eum ad domum Domini in Silo. Puer autem erat adhuc infantulus."
,"25":"Et immolaverunt vitulum et obtulerunt puerum Heli,"
,"26":"et ait Anna: ' Obsecro, mi domine; vivit anima tua, domine, ego sum illa mulier, quae steti coram te hic orans Dominum."
,"27":"Pro puero isto oravi, et dedit mihi Dominus petitionem meam, quam postulavi eum."
,"28":"Idcirco et ego commodavi eum Domino; cunctis diebus, quibus vivet, postulatus erit pro Domino '. Et adoraverunt ibi Dominum."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et oravit Anna et ait: ' Exsultavit cor meum in Do mino, exaltatum est cornu meum in Deo meo; dilatatum est os meum super inimicos meos, quoniam laetata sum in salutari tuo."
,"2":"Non est sanctus ut est Dominus; neque enim est alius extra te, et non est fortis sicut Deus noster."
,"3":"Nolite multiplicare loqui sublimia gloriantes. Recedant superba de ore vestro, quia Deus scientiarum Dominus est, et ab eo ponderantur actiones."
,"4":"Arcus fortium confractus est, et infirmi accincti sunt robore."
,"5":"Saturati prius pro pane se locaverunt, et famelici non eguerunt amplius. Sterilis peperit plurimos, et, quae multos habebat filios, emarcuit."
,"6":"Dominus mortificat et vivificat, deducit ad infernum et reducit."
,"7":"Dominus pauperem facit et ditat, humiliat et sublevat;"
,"8":"suscitat de pulvere egenum,et de stercore elevat pauperem, ut sedeat cum principibus,et solium gloriae teneat. Domini enim sunt cardines terrae, et posuit super eos orbem."
,"9":"Pedes sanctorum suorum servabit, et impii in tenebris conticescent, quia non in fortitudine sua roborabitur vir."
,"10":"Dominus conteret adversarios suos; super ipsos in caelis tonabit. Dominus iudicabit fines terrae,et dabit imperium regi suo,et sublimabit cornu christi sui '."
,"11":"Et abiit Elcana in Rama in domum suam. Puer autem erat minister in conspectu Domini ante faciem Heli sacerdotis."
,"12":"Porro filii Heli filii Belial nescientes Dominum"
,"13":"neque officium sacerdotum ad populum, sed, quicumque immolasset victimam, veniebat puer sacerdotis, dum coquerentur carnes, et habebat fuscinulam tridentem in manu sua"
,"14":"et mittebat eam in lebetem vel in caldariam aut in ollam sive in cacabum et omne, quod levabat fuscinula, tollebat sacerdos sibi. Sic faciebant universo Israeli venienti in Silo."
,"15":"Etiam, antequam adolerent adipem, veniebat puer sacerdotis et dicebat immolanti: ' Da mihi carnem, ut coquam sacerdoti; non enim accipiet a te carnem coctam sed crudam '."
,"16":"Dicebatque illi immolans: ' Incendatur primum iuxta morem hodie adeps, et tolle tibi, quantumcumque desiderat anima tua '. Qui respondens aiebat ei: ' Nequaquam; nunc enim dabis, alioquin tollam vi '."
,"17":"Erat ergo peccatum puerorum grande nimis coram Domino, quia detrahebant sacrificio Domini."
,"18":"Samuel autem ministrabat ante faciem Domini, puer accinctus ephod lineo."
,"19":"Et tunicam parvam faciebat ei mater sua, quam afferebat ei singulis annis ascendens cum viro suo, ut immolaret hostiam annuam."
,"20":"Et benedicebat Heli Elcanae et uxori eius dicebatque: ' Reddat tibi Dominus semen de muliere hac pro petitione, quae postulata est pro Domino '. Et abierunt in locum suum."
,"21":"Visitavit ergo Dominus Annam, et concepit et peperit tres filios et duas filias. Et crevit puer Samuel apud Dominum."
,"22":"Heli autem erat senex valde et audivit omnia, quae faciebant filii sui universo Israeli et quomodo dormiebant cum mulieribus, quae ministrabant ad ostium tabernaculi,"
,"23":"et dixit eis: ' Quare facitis res huiuscemodi, quas ego audio, res pessimas, ab omni populo?"
,"24":"Nolite, filii mei; non enim est bona fama, quam ego audio, ut transgredi faciatis populum Domini."
,"25":"Si peccaverit vir in virum, arbiter ei potest esse Deus; si autem in Dominum peccaverit vir, quis intercedet pro eo? '. Et non audierunt vocem patris sui, quia voluit Dominus occidere eos."
,"26":"Puer autem Samuel proficiebat atque crescebat et placebat tam Domino quam hominibus."
,"27":"Venit autem vir Dei ad Heli et ait ad eum: ' Haec dicit Dominus: Numquid non aperte revelatus sum domui patris tui, cum esset in Aegypto in domo pharaonis?"
,"28":"Et elegi eum ex omnibus tribubus Israel mihi in sacerdotem, ut ascenderet ad altare meum et adoleret mihi incensum et portaret ephod coram me; et dedi domui patris tui omnia de sacrificiis filiorum Israel."
,"29":"Quare calce abicitis victimam meam et munera mea, quae praecepi, ut offerrentur in templo, et magis honorasti filios tuos quam me, ut impinguaremini primitiis omnis sacrificii Israel populi mei?"
,"30":"Propterea ait Dominus, Deus Israel: Loquens locutus sum, ut domus tua et domus patris tui ministraret in conspectu meo usque in sempiternum. Nunc autem, dicit Dominus, absit hoc a me. Sed quicumque glorificaverit me, glorificabo eum; qui autem contemnunt me, erunt ignobiles."
,"31":"Ecce dies veniunt, et praecidam brachium tuum et brachium domus patris tui, ut non sit senex in domo tua."
,"32":"Et videbis aemulum tuum in templo in universis prosperis Israel; et non erit senex in domo tua omnibus diebus."
,"33":"Verumtamen non auferam penitus virum ex te ab altari meo; sed ut deficiant oculi tui, et tabescat anima tua, et pars magna domus tuae morietur, cum ad virilem aetatem venerit."
,"34":"Hoc autem erit tibi signum, quod venturum est duobus filiis tuis Ophni et Phinees: in die uno morientur ambo."
,"35":"Et suscitabo mihi sacerdotem fidelem, qui iuxta cor meum et animam meam faciat; et aedificabo ei domum fidelem, et ambulabit coram christo meo cunctis diebus."
,"36":"Futurum est autem ut quicumque remanserit in domo tua, veniat, ut procidat ante illum pro nummo argenteo et torta panis dicatque: 'Dimitte me, obsecro, ad unam partem sacerdotalem, ut comedam buccellam panis' '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Puer autem Samuel ministrabat Domino coram Heli. Et sermo Domini erat pretiosus in diebus illis: non erat visio frequens."
,"2":"Factum est ergo in die quadam, Heli iacebat in loco suo, et oculi eius caligaverant, nec poterat videre."
,"3":"Lucerna Dei nondum exstincta erat, et Samuel dormiebat in templo Domini, ubi erat arca Dei."
,"4":"Et vocavit Dominus Samuel, qui respondens ait: ' Ecce ego '."
,"5":"Et cucurrit ad Heli et dixit: ' Ecce ego; vocasti enim me '. Qui dixit: ' Non vocavi. Revertere; dormi! '. Et abiit et dormivit."
,"6":"Et Dominus rursum vocavit Samuel. Consurgensque Samuel abiit ad Heli et dixit: ' Ecce ego, quia vocasti me '. Qui respondit: ' Non vocavi te, fili mi. Revertere et dormi! '."
,"7":"Porro Samuel necdum sciebat Dominum, neque revelatus fuerat ei sermo Domini."
,"8":"Et Dominus rursum vocavit Samuel tertio, qui consurgens abiit ad Heli"
,"9":"et ait: ' Ecce ego, quia vocasti me '. Intellexit igitur Heli quia Dominus vocaret puerum, et ait ad Samuel: ' Vade et dormi; et, si deinceps vocaverit te, dices: ' Loquere, Domine, quia audit servus tuus' '. Abiit ergo Samuel et dormivit in loco suo."
,"10":"Et venit Dominus et stetit et vocavit, sicut vocaverat prius: ' Samuel, Samuel '. Et ait Samuel: ' Loquere, quia audit servus tuus '."
,"11":"Et dixit Dominus ad Samuel: ' Ecce ego facio verbum in Israel, quod quicumque audierit, tinnient ambae aures eius."
,"12":"In die illo suscitabo adversum Heli omnia, quae locutus sum super domum eius: incipiam et complebo."
,"13":"Praedixi enim ei quod iudicaturus essem domum eius in aeternum propter iniquitatem, eo quod noverat filios suos contemnere Deum et non corripuit eos."
,"14":"Idcirco iuravi domui Heli quod non expietur iniquitas domus eius victimis et muneribus usque in aeternum '."
,"15":"Dormivit autem Samuel usque mane aperuitque ostia domus Domini. Et Samuel timebat indicare visionem Heli."
,"16":"Vocavit ergo Heli Samuelem et dixit: ' Samuel, fili mi '. Qui respondens ait: ' Praesto sum '."
,"17":"Et interrogavit eum: ' Quis est sermo, quem locutus est ad te? Oro te, ne celaveris me. Haec faciat tibi Deus et haec addat, si absconderis a me sermonem ex omnibus verbis, quae dicta sunt tibi '."
,"18":"Indicavit itaque ei Samuel universos sermones et non abscondit ab eo. Et ille respondit: ' Dominus est! Quod bonum est in oculis suis, faciat '."
,"19":"Crevit autem Samuel, et Dominus erat cum eo, et non cecidit ex omnibus verbis eius in terram."
,"20":"Et cognovit universus Israel a Dan usque Bersabee quod constitutus esset Samuel propheta Domini."
,"21":"Et addidit Dominus ut appareret in Silo, quoniam revelatus fuerat Dominus Samueli in Silo iuxta verbum Domini. Et evenit sermo Samuelis universo Israeli."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et factum est in diebus illis, convenerunt Philisthim in pu gnam; et egressus est Israel obviam Philisthim in proelium et castrametatus est iuxta Abenezer. Porro Philisthim venerunt in Aphec"
,"2":"et instruxerunt aciem contra Israel. Crescente autem certamine, terga vertit Israel Philisthaeis; et caesi sunt in illo certamine passim per agros quasi quattuor milia virorum."
,"3":"Et reversus est populus ad castra, dixeruntque maiores natu de Israel: ' Quare percussit nos Dominus hodie coram Philisthim? Afferamus ad nos de Silo arcam foederis Domini, et veniat in medium nostri, ut salvet nos de manu inimicorum nostrorum '."
,"4":"Misit ergo populus in Silo, et tulerunt inde arcam foederis Domini exercituum sedentis super cherubim; erantque duo filii Heli cum arca foederis Dei, Ophni et Phinees."
,"5":"Cumque venisset arca foederis Domini in castra, vociferatus est omnis Israel clamore grandi, et personuit terra."
,"6":"Et audierunt Philisthim vocem clamoris dixeruntque: ' Quaenam est haec vox clamoris magni in castris Hebraeorum? '. Et cognoverunt quod arca Domini venisset in castra."
,"7":"Timueruntque Philisthim dicentes: ' Venit Deus in castra! '. Et ingemuerunt dicentes:"
,"8":"' Vae nobis! Non enim fuit tanta exsultatio heri et nudiustertius. Vae nobis! Quis nos servabit de manu deorum sublimium istorum? Hi sunt dii, qui percusserunt Aegyptum omni plaga in deserto."
,"9":"Confortamini et estote viri, Philisthim, ne serviatis Hebraeis, sicut illi servierunt vobis. Estote viri et bellate! '."
,"10":"Pugnaverunt ergo Philisthim, et caesus est Israel, et fugit unusquisque in tabernaculum suum; et facta est plaga magna nimis, et ceciderunt de Israel triginta milia peditum."
,"11":"Et arca Dei capta est; duoque filii Heli mortui sunt, Ophni et Phinees."
,"12":"Currens autem vir de Beniamin ex acie venit in Silo in die illo scissa veste et conspersus pulvere caput."
,"13":"Cumque ille venisset, Heli sedebat super sellam iuxta portam aspectans viam; erat enim cor eius pavens pro arca Dei. Vir autem ille, postquam ingressus est, nuntiavit urbi; et ululavit omnis civitas."
,"14":"Et audivit Heli sonitum clamoris dixitque: ' Quis est hic sonitus tumultus huius? '. At ille festinavit et venit et nuntiavit Heli."
,"15":"Heli autem erat nonaginta et octo annorum, et oculi eius caligaverant, et videre non poterat."
,"16":"Et dixit ad Heli: ' Ego sum qui veni de proelio et ego qui de acie fugi hodie '. Cui ille ait: ' Quid actum est, fili mi? '."
,"17":"Respondens autem, qui nuntiabat: ' Fugit, inquit, Israel coram Philisthim, et ruina magna facta est in populo; insuper et duo filii tui mortui sunt, Ophni et Phinees, et arca Dei capta est '."
,"18":"Cumque ille nominasset arcam Dei, cecidit de sella retrorsum iuxta ostium et, fractis cervicibus, mortuus est; senex enim erat vir et gravis. Et ipse iudicavit Israel quadraginta annis."
,"19":"Nurus autem eius, uxor Phinees, praegnans erat vicinaque partui. Et, audito nuntio quod capta esset arca Dei et mortuus socer suus et vir suus, incurvavit se et peperit; irruerant enim in eam dolores subiti."
,"20":"In ipso autem momento mortis eius dixerunt ei, quae stabant circa eam: ' Ne timeas, quia filium peperisti '. Quae non respondit eis neque animadvertit."
,"21":"Et vocavit puerum Ichabod dicens: ' Translata est gloria de Israel! ', quia capta est arca Dei et pro socero suo et pro viro suo."
,"22":"Et ait: ' Translata est gloria ab Israel, eo quod capta est arca Dei! '."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Philisthim autem tulerunt arcam Dei et asportaverunt eam a Abenezer in Azotum."
,"2":"Tulerunt Philisthim arcam Dei et intulerunt eam in templum Dagon et statuerunt eam iuxta Dagon."
,"3":"Cumque surrexissent Azotii altera die, ecce Dagon iacebat pronus in terram ante arcam Domini; et tulerunt Dagon et restituerunt eum in loco suo."
,"4":"Rursumque mane die altera consurgentes invenerunt Dagon iacentem super faciem suam in terram coram arca Domini; caput autem Dagon et duae palmae manuum eius abscisae erant super limen:"
,"5":"porro Dagon truncus solus remanserat in loco suo. Propter hanc causam non calcant sacerdotes Dagon et omnes, qui ingrediuntur templum eius, super limen Dagon in Azoto usque in hodiernum diem."
,"6":"Aggravata est autem manus Domini super Azotios, et demolitus est eos et percussit eos tumoribus, Azotum et fines eius."
,"7":"Videntes autem viri Azotii huiuscemodi plagam dixerunt: ' Non maneat arca Dei Israel apud nos, quoniam dura est manus eius super nos et super Dagon deum nostrum '."
,"8":"Et mittentes congregaverunt omnes principes Philisthinorum ad se et dixerunt: ' Quid faciemus de arca Dei Israel? '. Responderuntque: ' In Geth circumducatur arca Dei Israel '. Et circumduxerunt arcam Dei Israel."
,"9":"Postquam autem circumduxerunt eam, facta est manus Domini super civitatem, pavor magnus nimis; et percussit viros urbis a parvo usque ad maiorem, et eruperunt eis tumores."
,"10":"Miserunt ergo arcam Dei in Accaron. Cumque venisset arca Dei in Accaron, exclamaverunt Accaronitae dicentes: ' Adduxerunt ad nos arcam Dei Israel, ut interficiat nos et populum nostrum! '. "
,"11":"Miserunt itaque et congregaverunt omnes principes Philisthinorum et dixerunt: ' Dimittite arcam Dei Israel, et revertatur in locum suum et non interficiat nos cum populo nostro '."
,"12":"Fiebat enim pavor mortis in tota civitate, et gravissima valde manus Dei. Viri quoque, qui mortui non fuerant, percutiebantur tumoribus, et ascendebat ululatus civitatis in caelum."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Fuit ergo arca Domini in regio ne Philisthinorum septem mensi bus;"
,"2":"et vocaverunt Philisthim sacerdotes et divinos dicentes: ' Quid faciemus de arca Domini? Indicate nobis quomodo remittemus eam in locum suum '. Qui dixerunt: "
,"3":"' Si remittitis arcam Dei Israel, nolite dimittere eam vacuam, sed, quod debetis, reddite ei pro peccato, et tunc curabimini; scietis quare non recedat manus eius a vobis '."
,"4":"Qui dixerunt: ' Quid est quod pro delicto reddere debeamus ei? '. Responderuntque illi:"
,"5":"' Iuxta numerum principum Philisthinorum quinque tumores aureos facietis et quinque mures aureos, quia plaga una fuit omnibus vobis et principibus vestris. Facietisque similitudines tumorum vestrorum et similitudines murium, qui demoliti sunt terram, et dabitis Deo Israel gloriam, si forte relevet manum suam a vobis et a diis vestris et a terra vestra."
,"6":"Quare gravatis corda vestra, sicut aggravavit Aegyptus et pharao cor suum? Nonne, postquam percussit eos, tunc dimiserunt eos, et abierunt?"
,"7":"Nunc ergo arripite et facite plaustrum novum unum et duas vaccas fetas, quibus non est impositum iugum, iungite in plaustro; et recludite vitulos earum domi."
,"8":"Tolletisque arcam Domini et ponetis in plaustro; et similitudines aureas, quas exsolvistis ei pro delicto, ponetis in capsella ad latus eius et dimittite eam, ut vadat,"
,"9":"et aspicietis. Et siquidem per viam finium suorum ascenderit contra Bethsames, ipse fecit nobis hoc malum grande; sin autem minime, sciemus quia nequaquam manus eius tetigit nos, sed casu accidit '."
,"10":"Fecerunt ergo illi hoc modo et tollentes duas vaccas, quae lactabant vitulos, iunxerunt ad plaustrum vitulosque earum concluserunt domi;"
,"11":"et posuerunt arcam Dei super plaustrum et capsellam, quae habebat mures aureos et similitudines tumorum."
,"12":"Ibant autem in directum vaccae per viam, quae ducit Bethsames, et itinere uno gradiebantur pergentes et mugientes et non declinabant neque ad dextram neque ad sinistram. Sed et principes Philisthim sequebantur usque ad terminos Bethsames."
,"13":"Porro Bethsamitae metebant triticum in valle; et elevantes oculos viderunt arcam et gavisi sunt, cum vidissent."
,"14":"Et plaustrum venit in agrum Iosue Bethsamitae et stetit ibi. Erat autem ibi lapis magnus; et conciderunt ligna plaustri vaccasque imposuerunt super ea holocaustum Domino."
,"15":"Levitae autem deposuerunt arcam Dei et capsellam, quae erat iuxta eam, in qua erant similitudines aureae; et posuerunt super lapidem grandem. Viri autem Bethsamitae obtulerunt holocausta et immolaverunt victimas in die illa Domino."
,"16":"Et quinque principes Philisthinorum viderunt et reversi sunt in Accaron in die illa."
,"17":"Hi sunt autem tumores aurei, quos reddiderunt Philisthim pro delicto Domino: Azotus unum, Gaza unum, Ascalon unum, Geth unum, Accaron unum;"
,"18":"et mures aureos secundum numerum urbium Philisthim quinque principum, ab urbe murata usque ad villam, quae erat absque muro; et lapis ille magnus, super quem posuerunt arcam Domini, testis est usque in hunc diem in agro Iosue Bethsamitis."
,"19":"Filii autem Iechoniae non sunt gavisi super viros Bethsamites quia viderant arcam Domini; et percussit Dominus de populo septuaginta viros. Luxitque populus eo quod Dominus percussisset plebem plaga magna;"
,"20":"et dixerunt viri Bethsamitae: ' Quis poterit stare in conspectu Domini, Dei sancti huius? Et ad quem ascendet a nobis? '."
,"21":"Miseruntque nuntios ad habitatores Cariathiarim dicentes: ' Reduxerunt Philisthim arcam Domini. Descendite et ducite eam sursum ad vos '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Venerunt ergo viri Cariathiarim et duxerunt arcam Domini sursum et intulerunt eam in domum Abinadab in colle; Eleazarum autem filium eius sanctificaverunt, ut custodiret arcam Domini."
,"2":"Et factum est, ex qua die mansit arca Domini in Cariathiarim, multiplicati sunt dies; erat quippe iam annus vicesimus, et ingemuit omnis domus Israel post Dominum."
,"3":"Ait autem Samuel ad universam domum Israel dicens: ' Si in toto corde vestro revertimini ad Dominum, auferte deos alienos de medio vestri et Astharoth et praeparate corda vestra Domino et servite ei soli, et eruet vos de manu Philisthim '."
,"4":"Abstulerunt ergo filii Israel Baalim et Astharoth et servierunt Domino soli."
,"5":"Dixit autem Samuel: ' Congregate universum Israel in Maspha, ut orem pro vobis Dominum '."
,"6":"Et convenerunt in Maspha hauseruntque aquam et effuderunt in conspectu Domini et ieiunaverunt in die illa et dixerunt ibi: ' Peccavimus Domino '. Iudicavitque Samuel filios Israel in Maspha."
,"7":"Et audierunt Philisthim quod congregati essent filii Israel in Maspha, et ascenderunt principes Philisthinorum ad Israel. Quod cum audissent filii Israel, timuerunt a facie Philisthinorum"
,"8":"dixeruntque ad Samuel: ' Ne cesses pro nobis clamare ad Dominum Deum nostrum, ut salvet nos de manu Philisthinorum '."
,"9":"Tulit ergo Samuel agnum lactantem unum et obtulit illum holocaustum integrum Domino; et clamavit Samuel ad Dominum pro Israel, et exaudivit eum Dominus."
,"10":"Factum est autem cum Samuel offerret holocaustum, Philisthim iniere proelium contra Israel. Intonuit autem Dominus fragore magno in die illa super Philisthim et exterruit eos, et caesi sunt a facie Israel."
,"11":"Egressique viri Israel de Maspha persecuti sunt Philisthaeos et percusserunt eos usque ad locum, qui erat subter Bethchar."
,"12":"Tulit autem Samuel lapidem unum et posuit eum inter Maspha et inter Sen et vocavit nomen loci illius Abenezer (id est Lapis adiutorii) dixitque: ' Hucusque auxiliatus est nobis Dominus '."
,"13":"Et humiliati sunt Philisthim nec apposuerunt ultra ut venirent in terminos Israel. Facta est itaque manus Domini super Philisthaeos cunctis diebus Samuel."
,"14":"Et redditae sunt urbes, quas tulerant Philisthim ab Israel, Israeli ab Accaron usque Geth; et terminos earum liberavit Israel de manu Philisthinorum. Eratque pax inter Israel et Amorraeum."
,"15":"Iudicabat quoque Samuel Israel cunctis diebus vitae suae"
,"16":"et ibat per singulos annos circumiens Bethel et Galgala et Maspha et iudicabat Israelem in supradictis locis. Revertebaturque in Rama; ibi enim erat domus eius, et ibi iudicabat Israelem. Aedificavit etiam ibi altare Domino."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Factum est autem cum senuis set, Samuel posuit filios suos iu dices Israel."
,"2":"Fuitque nomen filii eius primogeniti Ioel et nomen secundi Abia; iudicabant in Bersabee."
,"3":"Et non ambulaverunt filii illius in viis eius, sed declinaverunt post avaritiam acceperuntque munera et perverterunt iudicium."
,"4":"Congregati ergo universi maiores natu Israel venerunt ad Samuel in Rama"
,"5":"dixeruntque ei: ' Ecce tu senuisti, et filii tui non ambulant in viis tuis; nunc ergo constitue nobis regem, ut iudicet nos, sicut universae habent nationes '."
,"6":"Displicuitque sermo in oculis Samuelis, eo quod dixissent: ' Da nobis regem, ut iudicet nos '. Et oravit Samuel ad Dominum."
,"7":"Dixit autem Dominus ad Samuel: ' Audi vocem populi in omnibus, quae loquuntur tibi; non enim te abiecerunt, sed me abiecerunt, ne regnem super eos."
,"8":"Iuxta omnia opera sua, quae fecerunt a die, qua eduxi eos de Aegypto, usque ad diem hanc, sicut dereliquerunt me et servierunt diis alienis, sic faciunt etiam tibi."
,"9":"Nunc ergo audi vocem eorum; verumtamen contestare eos et praedic eis ius regis, qui regnaturus est super eos '."
,"10":"Dixit itaque Samuel omnia verba Domini ad populum, qui petierat a se regem,"
,"11":"et ait: ' Hoc erit ius regis, qui imperaturus est vobis: Filios vestros tollet et ponet in curribus suis facietque sibi equites, et current ante quadrigas eius;"
,"12":"et constituet sibi tribunos et centuriones et aratores agrorum suorum et messores segetum et fabros armorum et curruum suorum."
,"13":"Filias quoque vestras faciet sibi unguentarias et focarias et panificas."
,"14":"Agros quoque vestros et vineas et oliveta optima tollet et dabit servis suis."
,"15":"Sed et segetes vestras et vinearum reditus addecimabit, ut det eunuchis et famulis suis."
,"16":"Servos etiam vestros et ancillas et boves vestros optimos et asinos auferet et ponet in opere suo."
,"17":"Greges vestros addecimabit, vosque eritis ei servi."
,"18":"Et clamabitis in die illa a facie regis vestri, quem elegistis vobis, et non exaudiet vos Dominus in die illa '."
,"19":"Noluit autem populus audire vocem Samuel, sed dixerunt: ' Nequaquam: rex enim erit super nos,"
,"20":"et erimus nos quoque sicut omnes gentes; et iudicabit nos rex noster et egredietur ante nos et pugnabit bella nostra pro nobis '."
,"21":"Et audivit Samuel omnia verba populi et locutus est ea in auribus Domini."
,"22":"Dixit autem Dominus ad Samuel: ' Audi vocem eorum et constitue super eos regem '. Et ait Samuel ad viros Israel: ' Vadat unusquisque in civitatem suam '."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et erat vir de Beniamin nomine Cis filius Abiel filii Seror filii Be chorath filii Aphia, Beniaminita vir potens."
,"2":"Et erat ei filius vocabulo Saul electus et bonus, et non erat vir de filiis Israel melior illo; ab umero et sursum eminebat super omnem populum."
,"3":"Perierant autem asinae Cis patris Saul, et dixit Cis ad Saul filium suum: ' Tolle tecum unum de pueris et consurgens vade et quaere asinas '. Qui cum transissent per montem Ephraim"
,"4":"et per terram Salisa et non invenissent, transierunt etiam per terram Salim, et non erant, sed et per terram Iemini et minime reppererunt."
,"5":"Cum autem venissent in terram Suph, dixit Saul ad puerum suum, qui erat cum eo: ' Veni, et revertamur, ne forte dimiserit pater meus asinas et sollicitus sit pro nobis '."
,"6":"Qui ait ei: ' Ecce est vir Dei in civitate hac, vir nobilis. Omne quod loquitur, absque ambiguitate venit. Nunc ergo eamus illuc, si forte indicet nobis de via nostra, propter quam venimus '."
,"7":"Dixitque Saul ad puerum suum: ' Ecce ibimus; quid feremus ad virum? Panis defecit in sitarciis nostris, et sportulam non habemus, ut demus homini Dei. Quid habemus? '."
,"8":"Rursum puer respondit Sauli et ait: ' Ecce inventa est in manu mea quarta pars sicli argenti; demus homini Dei, ut indicet nobis viam nostram '. -"
,"9":"Olim in Israel sic loquebatur unusquisque vadens consulere Deum: ' Venite, et eamus ad videntem '; qui enim propheta dicitur hodie, vocabatur olim videns. -"
,"10":"Et dixit Saul ad puerum suum: ' Optimus sermo tuus; veni, eamus '. Et ierunt in civitatem, in qua erat vir Dei."
,"11":"Cumque ascenderent clivum civitatis, invenerunt puellas egredientes ad hauriendam aquam et dixerunt eis: ' Num hic est videns? '."
,"12":"Quae respondentes dixerunt illis: ' Hic est: ecce ante te, festina nunc; hodie enim venit in civitatem, quia sacrificium est hodie populo in excelso."
,"13":"Ingredientes urbem statim invenietis eum, antequam ascendat excelsum ad vescendum; neque enim comesurus est populus, donec ille veniat, quia ipse benedicit hostiae, et deinceps comedunt, qui vocati sunt. Nunc ergo conscendite, quia statim reperietis eum '."
,"14":"Et ascenderunt in civitatem. Cumque illi intrarent in urbem, apparuit Samuel egrediens obviam eis, ut ascenderet in excelsum."
,"15":"Dominus autem revelaverat Samuel, ante unam diem quam veniret Saul, dicens:"
,"16":"' Hac ipsa, quae nunc est hora, cras mittam ad te virum de terra Beniamin, et unges eum ducem super populum meum Israel, et salvabit populum meum de manu Philisthinorum, quia respexi populum meum; venit enim clamor eorum ad me '."
,"17":"Cumque aspexisset Samuel Saulem, Dominus ait ei: ' Ecce vir, quem dixeram tibi; iste dominabitur populo meo '."
,"18":"Accessit autem Saul ad Samuelem in medio portae et ait: ' Indica, oro, mihi: Ubi est domus videntis? '."
,"19":"Et respondit Samuel Sauli dicens: ' Ego sum videns. Ascende ante me in excelsum, ut comedatis mecum hodie. Et dimittam te mane et omnia, quae sunt in corde tuo, indicabo tibi;"
,"20":"et de asinis, quas perdidisti nudiustertius, ne sollicitus sis, quia inventae sunt. Et cuius erunt optima quaeque Israel? Nonne tibi et omni domui patris tui? '."
,"21":"Respondens autem Saul ait: 'Numquid non Beniaminita ego sum de minima tribu Israel, et cognatio mea novissima inter omnes familias de tribu Beniamin? Quare ergo locutus es mihi sermonem istum? '."
,"22":"Assumens itaque Samuel Saulem et puerum eius introduxit eos in triclinium et dedit eis locum in capite eorum, qui fuerant invitati: erant enim quasi triginta viri."
,"23":"Dixitque Samuel coco: ' Da partem, quam dedi tibi et praecepi, ut reponeres seorsum apud te '."
,"24":"Levavit autem cocus armum et caudam et posuit ante Saul. Dixitque Samuel: ' Ecce quod remansit; pone ante te et comede, quia de industria servatum est tibi, quando populum vocavi '. Et comedit Saul cum Samuel in die illa."
,"25":"Et descenderunt de excelso in oppidum. Et straverunt pro Saul in solario, et dormivit."
,"26":"Cumque mane surrexissent, et iam elucesceret, vocavit Samuel Saul in solario dicens: ' Surge, ut dimittam te '. Et surrexit Saul. Egressique sunt ambo, ipse videlicet et Samuel."
,"27":"Cumque descenderent in extrema parte civitatis, Samuel dixit ad Saul: ' Dic puero, ut antecedat nos - et ille antecessit C; tu autem subsiste paulisper, ut indicem tibi verbum Domini '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Tulit autem Samuel lenticulam olei et effudit super caput eius et deosculatus eum ait: ' Ecce unxit te Dominus in principem super populum suum, super Israel. Et tu dominaberis populo Domini et tu liberabis eum de manu inimicorum eius, qui in circuitu eius sunt. Et hoc tibi signum quia unxit te Deus in principem super hereditatem suam:"
,"2":"cum abieris hodie a me, invenies duos viros iuxta sepulcrum Rachel in finibus Beniamin, dicentque tibi: 'Inventae sunt asinae, ad quas ieras perquirendas; et intermissis pater tuus asinis sollicitus est pro vobis et dicit: Quid faciam de filio meo?'."
,"3":"Cumque abieris inde et ultra transieris et veneris ad quercum Thabor, invenient te ibi tres viri ascendentes ad Deum in Bethel: unus portans tres haedos et alius tres tortas panis et alius portans utrem vini."
,"4":"Cumque te salutaverint, dabunt tibi duos panes, et accipies de manu eorum."
,"5":"Post haec venies in Gabaa Dei, ubi est statio Philisthinorum; et, cum ingressus fueris ibi urbem, obviam habebis gregem prophetarum descendentium de excelso et ante eos psalterium et tympanum et tibiam et citharam ipsosque prophetantes."
,"6":"Et insiliet in te spiritus Domini, et prophetabis cum eis et mutaberis in virum alium."
,"7":"Quando ergo evenerint signa haec omnia tibi, fac, quaecumque invenerit manus tua, quia Dominus tecum est."
,"8":"Et descendes ante me in Galgala. Ego quippe descendam ad te, ut offeram oblationem et immolem victimas pacificas. Septem diebus exspectabis, donec veniam ad te et ostendam tibi, quae facias '."
,"9":"Itaque, cum avertisset umerum suum, ut abiret a Samuele, immutavit ei Deus cor aliud, et venerunt omnia signa haec in die illa."
,"10":"Veneruntque inde in Gabaa, et ecce grex prophetarum obvius ei; et insiluit super eum spiritus Dei, et prophetavit in medio eorum."
,"11":"Videntes autem omnes, qui noverant eum heri et nudiustertius, quod esset cum prophetis et prophetaret, dixerunt ad invicem: ' Quaenam res accidit filio Cis? Num et Saul inter prophetas? '."
,"12":"Responditque vir loci illius dicens: ' Et quis pater eorum? '. Propterea versum est in proverbium: ' Num et Saul inter prophetas? '."
,"13":"Cessavit autem prophetare et venit in Gabaa;"
,"14":"dixitque patruus Saul ad eum et ad puerum eius: ' Quo abistis? '. Qui respondit: ' Quaerere asinas; quas cum non repperissemus, venimus ad Samuelem'."
,"15":"Et dixit ei patruus suus: 'Indica mihi quid dixerit tibi Samuel'."
,"16":"Et ait Saul ad patruum suum: ' Indicavit nobis quia inventae essent asinae '. De sermone autem regni non indicavit ei, quem locutus illi fuerat Samuel."
,"17":"Et convocavit Samuel populum ad Dominum in Maspha"
,"18":"et ait ad filios Israel: ' Haec dicit Dominus, Deus Israel: Ego eduxi Israel de Aegypto et erui vos de manu Aegyptiorum et de manu omnium regnorum, quae affligebant vos."
,"19":"Vos autem hodie proiecistis Deum vestrum, qui solus salvavit vos de universis malis et tribulationibus vestris, et dixistis: 'Nequaquam, sed regem constitue super nos!'. Nunc ergo state coram Domino per tribus vestras et per familias '."
,"20":"Et applicuit Samuel omnes tribus Israel; et cecidit sors in tribum Beniamin."
,"21":"Et applicuit tribum Beniamin et cognationes eius; et cecidit in cognationem Metri et pervenit usque ad Saul filium Cis. Quaesierunt ergo eum, et non est inventus."
,"22":"Et consuluerunt post haec Dominum, utrumnam venisset illuc vir. Responditque Dominus: ' Ecce absconditus est inter sarcinas '."
,"23":"Cucurrerunt itaque et tulerunt eum inde; stetitque in medio populi et altior fuit universo populo ab umero et sursum."
,"24":"Et ait Samuel ad omnem populum: ' Certe videtis, quem elegit Dominus, quoniam non sit similis ei in omni populo '. Et clamavit cunctus populus et ait: ' Vivat rex! '."
,"25":"Locutus est autem Samuel ad populum legem regni et scripsit in libro et reposuit coram Domino; et dimisit Samuel omnem populum, singulos in domum suam."
,"26":"Sed et Saul abiit in domum suam in Gabaa; et abierunt cum eo viri fortes, quorum tetigerat Deus corda."
,"27":"Filii vero Belial dixerunt: ' Num salvare nos poterit iste? '. Et despexerunt eum et non attulerunt ei munera; ille vero dissimulabat se audire."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Ascendit autem Naas Am monites et pugnare coepit ad versum Iabes Galaad. Dixeruntque omnes viri Iabes ad Naas: ' Habeto nos foederatos, et serviemus tibi '."
,"2":"Et respondit ad eos Naas Ammonites: ' In hoc feriam vobiscum foedus, ut eruam omnium vestrum oculos dextros ponamque vos opprobrium in universo Israel '."
,"3":"Et dixerunt ad eum seniores Iabes: ' Concede nobis septem dies, ut mittamus nuntios in universos terminos Israel; et, si non fuerit qui defendat nos, egrediemur ad te '."
,"4":"Venerunt ergo nuntii in Gabaa Saulis et locuti sunt verba audiente populo; et levavit omnis populus vocem suam et flevit."
,"5":"Et ecce Saul veniebat sequens boves de agro et ait: ' Quid habet populus quod plorat? '. Et narraverunt ei verba virorum Iabes."
,"6":"Et insilivit spiritus Domini in Saul, cum audisset verba haec; et iratus est furor eius nimis."
,"7":"Et assumens par boum concidit in frusta misitque in omnes terminos Israel per manum nuntiorum dicens: ' Quicumque non exierit secutusque fuerit Saul et Samuel, sic fiet bobus eius '. Invasit ergo timor Domini populum, et egressi sunt quasi vir unus."
,"8":"Et recensuit eos in Bezec: fueruntque filiorum Israel trecenta milia; virorum autem Iudae triginta milia."
,"9":"Et dixit nuntiis, qui venerant: ' Sic dicetis viris, qui sunt in Iabes Galaad: Cras erit vobis salus, cum incaluerit sol '. Venerunt ergo nuntii et annuntiaverunt viris Iabes, qui laetati sunt"
,"10":"et dixerunt: 'Mane exibimus ad vos, et facietis nobis omne, quod placuerit vobis '."
,"11":"Et factum est, cum venisset dies crastinus, constituit Saul populum in tres partes; et ingressi sunt media castra in vigilia matutina et percusserunt Ammon, usque dum incalesceret dies. Reliqui autem dispersi sunt, ita ut non relinquerentur in eis duo pariter."
,"12":"Et ait populus ad Samuel: ' Quis est iste qui dixit: 'Saul num regnabit super nos?'. Date viros, et interficiemus eos '."
,"13":"Et ait Saul: ' Non occidetur quisquam in die hac, quia hodie fecit Dominus salutem in Israel'."
,"14":"Dixit autem Samuel ad populum: ' Venite, et eamus in Galgala et innovemus ibi regnum '."
,"15":"Et perrexit omnis populus in Galgala, et fecerunt ibi regem Saul coram Domino in Galgala; et immolaverunt ibi victimas pacificas coram Domino. Et laetatus est ibi Saul et cuncti viri Israel nimis."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Dixit autem Samuel ad universum Israel: ' Ecce audivi vocem vestram iuxta omnia, quae locuti estis ad me, et constitui super vos regem;"
,"2":"et nunc rex graditur ante vos. Ego autem senui et incanui; porro filii mei vobiscum sunt. Itaque conversatus coram vobis ab adulescentia mea usque ad hanc diem;"
,"3":"ecce praesto sum. Loquimini contra me coram Domino et coram christo eius, utrum bovem cuiusquam tulerim an asinum, si quempiam calumniatus sum, si oppressi aliquem, si de manu cuiusquam munus accepi, ut oculos meos clauderem in eius causa. Restituam vobis '."
,"4":"Et dixerunt: ' Non es calumniatus nos neque oppressisti neque tulisti de manu alicuius quippiam '."
,"5":"Dixitque ad eos: ' Testis Dominus adversum vos, et testis christus eius in die hac, quia non inveneritis in manu mea quippiam '. Et dixerunt: ' Testis '."
,"6":"Et ait Samuel ad populum: ' Testis est Dominus, qui fecit Moysen et Aaron et eduxit patres nostros de terra Aegypti."
,"7":"Nunc ergo state, ut iudicio contendam adversum vos coram Domino de omnibus misericordiis Domini, quas fecit vobiscum et cum patribus vestris:"
,"8":"quomodo ingressus est Iacob in Aegyptum, et oppresserunt eos Aegyptii; et clamaverunt patres vestri ad Dominum, et misit Dominus Moysen et Aaron et eduxit patres vestros ex Aegypto et collocavit eos in loco hoc;"
,"9":"qui obliti sunt Domini Dei sui, et tradidit eos in manu Sisarae magistri militiae Asor et in manu Philisthinorum et in manu regis Moab, et pugnaverunt adversum eos."
,"10":"Postea autem clamaverunt ad Dominum et dixerunt: 'Peccavimus, quia dereliquimus Dominum et servivimus Baalim et Astharoth; nunc ergo erue nos de manu inimicorum nostrorum, et serviemus tibi'."
,"11":"Et misit Dominus Ierobbaal et Barac et Iephte et Samuel et eruit vos de manu inimicorum vestrorum per circuitum; et habitastis confidenter."
,"12":"Videntes autem quod Naas rex filiorum Ammon venisset adversum vos, dixistis mihi: 'Nequaquam, sed rex imperabit nobis!', cum Dominus Deus vester regnaret in vobis."
,"13":"Nunc ergo praesto est rex vester, quem elegistis et petistis; ecce dedit vobis Dominus regem."
,"14":"Si timueritis Dominum et servieritis ei et audieritis vocem eius et non contempseritis sermonem Domini, eritis et vos et rex, qui imperat vobis, sequentes Dominum Deum vestrum."
,"15":"Si autem non audieritis vocem Domini, sed contempseritis sermonem Domini, erit manus Domini super vos et super regem vestrum, ut disperdat vos."
,"16":"Sed et nunc state et videte rem istam grandem, quam facturus est Dominus in conspectu vestro."
,"17":"Numquid non messis tritici est hodie? Invocabo Dominum, et dabit tonitrua et pluvias; et scietis et videbitis quia grande malum feceritis vobis in conspectu Domini petentes super vos regem '."
,"18":"Et clamavit Samuel ad Dominum, et dedit Dominus tonitrua et pluviam in die illa."
,"19":"Et timuit omnis populus nimis Dominum et Samuel; dixitque universus populus ad Samuel: ' Ora pro servis tuis ad Dominum Deum tuum, ut non moriamur: addidimus enim universis peccatis nostris malum, ut peteremus nobis regem '."
,"20":"Dixit autem Samuel ad populum: ' Nolite timere. Vos fecistis universum malum hoc; verumtamen nolite recedere a tergo Domini et servite Domino in omni corde vestro;"
,"21":"et nolite declinare post vana, quae non proderunt vobis neque eruent vos, quia vana sunt;"
,"22":"profecto non derelinquet Dominus populum suum propter nomen suum magnum, quia dignatus est Dominus facere vos sibi populum."
,"23":"Absit autem a me hoc peccatum in Dominum, ut cessem orare pro vobis et docere vos viam bonam et rectam."
,"24":"Igitur timete Dominum et servite ei in veritate et ex toto corde vestro; vidistis enim magnifica, quae in vobis gesserit."
,"25":"Quod si perseveraveritis in malitia, et vos et rex vester pariter peribitis '."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Filius annorum Saul, cum regnare coepisset; duobus au tem annis regnavit super Israel."
,"2":"Et elegit sibi Saul tria milia de Israel: et erant cum Saul duo milia in Machmas et in monte Bethel, mille autem cum Ionathan in Gabaa Beniamin. Porro ceterum populum remisit unumquemque in tabernacula sua."
,"3":"Et percussit Ionathan stationem Philisthinorum, quae erat in Gabaa. Quod audierunt Philisthim; Saul autem cecinit bucina in omni terra dicens: ' Audiant Hebraei! '."
,"4":"Et universus Israel audivit huiuscemodi famam: ' Percussit Saul stationem Philisthinorum; et factus est Israel odiosus Philisthim '. Ergo populus congregatus est post Saul in Galgala."
,"5":"Et Philisthim congregati sunt ad proeliandum contra Israel: tria milia curruum et sex milia equitum et reliquum vulgus plurimum sicut arena, quae est in litore maris. Et ascendentes castrametati sunt in Machmas ad orientem Bethaven."
,"6":"Quod cum vidissent viri Israel se in arto sitos - afflictus est enim populus - absconderunt se in speluncis et in abditis, in petris quoque et in antris et in cisternis."
,"7":"Hebraei autem transierunt Iordanem in terram Gad et Galaad. Cumque adhuc esset Saul in Galgalis, universus populus perterritus est, qui sequebatur eum. "
,"8":"Et exspectavit septem diebus iuxta placitum Samuel, et non venit Samuel in Galgala; dilapsusque est populus ab eo."
,"9":"Ait ergo Saul: ' Afferte mihi holocaustum et pacifica '. Et obtulit holocaustum."
,"10":"Cumque complesset offerens holocaustum, ecce Samuel veniebat; et egressus est Saul obviam ei, ut salutaret eum."
,"11":"Locutusque est ad eum Samuel: ' Quid fecisti? '. Respondit Saul: ' Quia vidi quod dilaberetur populus a me, et tu non veneras iuxta placitos dies, porro Philisthim congregati fuerant in Machmas,"
,"12":"dixi: Nunc descendent Philisthim ad me in Galgala, et faciem Domini non placavi. Necessitate compulsus obtuli holocaustum '."
,"13":"Dixitque Samuel ad Saul: ' Stulte egisti. Utinam custodisses mandata Domini Dei tui, quae praecepit tibi! Profecto nunc confirmasset Dominus regnum tuum super Israel in sempiternum;"
,"14":"sed nequaquam regnum tuum ultra consurget. Quaesivit sibi Dominus virum iuxta cor suum; et constituit eum Dominus ducem super populum suum, eo quod non servaveris, quae praecepit Dominus '."
,"15":"Surrexit autem Samuel et ascendit de Galgalis et abiit per viam suam. Et reliquus populus ascendit post Saul obviam exercitui bellatorum. Et venerunt de Galgalis in Gabaa Beniamin. Et recensuit Saul populum, qui inventi fuerant cum eo, quasi sescentos viros."
,"16":"Et Saul et Ionathan filius eius populusque, qui erat cum eis, erat in Gabaa Beniamin; porro Philisthim consederant in Machmas."
,"17":"Et egressi sunt ad praedandum de castris Philisthinorum tres cunei: unus cuneus pergebat contra viam Ophra ad terram Sual,"
,"18":"porro alius ingrediebatur per viam Bethoron, tertius autem verterat se ad iter termini imminentis valli Seboim contra desertum."
,"19":"Porro faber ferrarius non inveniebatur in omni terra Israel; caverant enim Philisthim, ne forte facerent Hebraei gladium aut lanceam."
,"20":"Descendebat ergo omnis Israel ad Philisthim, ut exacueret unusquisque vomerem suum et ligonem et securim et falcem."
,"21":"Pretium autem exacutionis erat: pro vomeribus et ligonibus duae partes sicli, et tertia pars sicli ad acuendas secures et ad stimulum corrigendum."
,"22":"Cumque venisset dies proelii Machmas, non est inventus ensis et lancea in manu totius populi, qui erat cum Saul et cum Ionathan, excepto Saul et Ionathan filio eius."
,"23":"Egressa est autem statio Philisthim ad fauces Machmas."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Et accidit quadam die, ut diceret Ionathan filius Saul ad adulescentem armigerum suum: ' Veni, et transeamus ad stationem Philisthim, quae est ibi ex adverso '. Patri autem suo hoc ipsum non indicavit."
,"2":"Porro Saul morabatur in extrema parte Gabaa sub malogranato, quae erat in Magron; et erat populus cum eo quasi sescentorum virorum."
,"3":"Et Ahias filius Achitob fratris Ichabod filii Phinees, qui ortus fuerat ex Heli sacerdote Domini in Silo, portabat ephod. Sed et populus ignorabat quod isset Ionathan."
,"4":"Erant autem inter ascensus, per quos nitebatur Ionathan transire ad stationem Philisthinorum, dens rupis hinc ex una parte et dens rupis illinc ex altera parte: nomen uni Boses et nomen alteri Sene;"
,"5":"unus scopulus prominens ad aquilonem ex adverso Machmas et alter a meridie contra Gabaa."
,"6":"Dixit autem Ionathan ad adulescentem armigerum suum: ' Veni, transeamus ad stationem incircumcisorum horum, si forte faciat Dominus pro nobis; quia non est Domino difficile salvare vel in multitudine vel in paucis '."
,"7":"Dixitque ei armiger suus: ' Fac omnia, quae placent animo tuo. Perge quo cupis; ego ero tecum ubicumque volueris '."
,"8":"Et ait Ionathan: ' Ecce nos transimus ad viros istos. Cumque apparuerimus eis,"
,"9":"si taliter locuti fuerint ad nos: 'Manete, donec veniamus ad vos', stemus in loco nostro nec ascendamus ad eos."
,"10":"Si autem dixerint: 'Ascendite ad nos', ascendamus, quia tradidit eos Dominus in manibus nostris; hoc erit nobis signum '."
,"11":"Apparuit igitur uterque stationi Philisthinorum. Dixeruntque Philisthim: ' En Hebraei egrediuntur de cavernis, in quibus absconditi fuerant '."
,"12":"Et locuti sunt viri de statione ad Ionathan et ad armigerum eius dixeruntque: ' Ascendite ad nos, et ostendimus vobis rem '. Et ait Ionathan ad armigerum suum: ' Ascendamus; sequere me, tradidit enim eos Dominus in manu Israel '."
,"13":"Ascendit autem Ionathan reptans manibus et pedibus et armiger eius post eum; Philisthim cadebant ante Ionathan, et eos armiger eius interficiebat sequens eum."
,"14":"Et facta est plaga prima, qua percussit Ionathan et armiger eius quasi viginti viros in media fere parte iugeri."
,"15":"Et factus est terror in castris per agros; sed et omnis populus stationis eorum et, qui ierant ad praedandum, obstupuerunt; et conturbata est terra, et factus est terror a Deo."
,"16":"Et respexerunt speculatores Saul, qui erant in Gabaa Beniamin; et ecce multitudo fluctuabat huc illucque diffugiens."
,"17":"Et ait Saul populo, qui erat cum eo: ' Requirite et videte quis abierit ex nobis '. Cumque requisissent, repertum est non adesse Ionathan et armigerum eius."
,"18":"Et ait Saul ad Ahiam: ' Applica ephod '. Ipse enim portabat ephod in die illa in conspectu filiorum Israel."
,"19":"Cumque loqueretur Saul ad sacerdotem, tumultus maior fiebat in castris Philisthinorum, crescebatque paulatim et clarius reboabat. Et ait Saul ad sacerdotem: ' Contrahe manum tuam '."
,"20":"Congregati ergo sunt Saul et omnis populus, qui erat cum eo, et venerunt usque ad locum certaminis. Et ecce versus fuerat gladius uniuscuiusque ad proximum suum: perturbatio magna nimis."
,"21":"Sed et Hebraei, qui fuerant cum Philisthim heri et nudiustertius ascenderantque cum eis in castris, reversi sunt et ipsi, ut essent cum Israel, qui erant cum Saul et Ionathan."
,"22":"Omnes quoque Israelitae, qui se absconderant in monte Ephraim, audientes quod fugissent Philisthim, sociaverunt se et ipsi cum suis in proelio."
,"23":"Et salvavit Dominus in die illa Israel; pugna autem pervenit ultra Bethaven."
,"24":"Et viri Israel comprimebant se in die illa. Adiuravit autem Saul populum dicens: ' Maledictus vir, qui comederit panem usque ad vesperam, donec ulciscar de inimicis meis! '. Et non manducavit universus populus panem."
,"25":"Omneque terrae vulgus venit in saltum, in quo erat mel super faciem agri."
,"26":"Ingressus est itaque populus saltum, et apparuit fluens mel. Nullusque applicuit manum ad os suum; timebat enim populus iuramentum."
,"27":"Porro Ionathan non audierat, cum adiuraret pater eius populum; extenditque summitatem virgae, quam habebat in manu, et intinxit in favo mellis et convertit manum suam ad os suum, et illuminati sunt oculi eius."
,"28":"Respondensque unus de populo ait: ' Iureiurando constrinxit pater tuus populum dicens: 'Maledictus, qui comederit panem hodie!'. Defecit autem populus '."
,"29":"Dixitque Ionathan: ' Turbavit pater meus terram! Videte quia illuminati sunt oculi mei, eo quod gustaverim paululum de melle isto;"
,"30":"quanto magis si comedisset hodie populus de praeda inimicorum suorum, quam repperit? Nonne nunc maior facta fuisset plaga in Philisthim? '."
,"31":"Percusserunt ergo in die illa Philisthaeos a Machmis usque in Aialon; defatigatus est autem populus nimis."
,"32":"Et versus ad praedam tulit oves et boves et vitulos; et mactaverunt in terra, comeditque populus cum sanguine."
,"33":"Nuntiaverunt autem Saul dicentes: ' Ecce populus peccat Domino comedens cum sanguine '. Qui ait: ' Praevaricati estis! Volvite ad me huc saxum grande '."
,"34":"Et dixit Saul: ' Dispergimini in vulgus et dicite eis, ut adducat ad me unusquisque bovem suum et arietem, et occidite super istud et vescimini; et non peccabitis Domino comedentes cum sanguine '. Adduxit itaque omnis populus, unusquisque quod erat in manu sua illa nocte, et occiderunt ibi."
,"35":"Aedificavit autem Saul altare Domino. Tuncque primum coepit aedificare altare Domino."
,"36":"Et dixit Saul: ' Irruamus super Philisthim nocte et vastemus eos, usquedum illucescat mane; nec relinquamus de eis virum '. Dixitque populus: ' Omne, quod bonum videtur in oculis tuis, fac '. Et ait sacerdos: ' Accedamus huc ad Deum '."
,"37":"Et consuluit Saul Deum: ' Num persequar Philisthim? Numquid trades eos in manu Israel? '. Et non respondit ei in die illa."
,"38":"Dixitque Saul: ' Accedite huc, universi duces populi, et scitote et videte per quem acciderit peccatum hoc hodie."
,"39":"Vivit Dominus, salvator Israel, quia si per Ionathan filium meum factum est, absque retractatione morietur '. Ad quod nullus contradixit ei de omni populo."
,"40":"Et ait ad universum Israel: ' Separamini vos in partem unam, et ego cum Ionathan filio meo ero in parte altera '. Respondit populus ad Saul: ' Quod bonum videtur in oculis tuis, fac '."
,"41":"Et dixit Saul ad Dominum, Deum Israel: ' Quid est quod non responderis servo tuo hodie? Si est in me aut in Ionathan filio meo iniquitas ista, Domine, Deus Israel, da Urim; sed, si est haec iniquitas in populo tuo Israel, da Tummim '. Et deprehensus est Ionathan et Saul; populus autem salvus evasit."
,"42":"Et ait Saul: ' Mittite sortem inter me et inter Ionathan filium meum '. Et captus est Ionathan."
,"43":"Dixit autem Saul ad Ionathan: ' Indica mihi quid feceris '. Et indicavit ei Ionathan et ait: ' Gustans gustavi in summitate virgae, quae erat in manu mea, paululum mellis et ecce ego morior '."
,"44":"Et ait Saul: ' Haec faciat mihi Deus et haec addat, nisi morte morieris, Ionathan '."
,"45":"Dixitque populus ad Saul: ' Ergone Ionathan morietur, qui fecit salutem hanc magnam in Israel? Hoc nefas est; vivit Dominus, quia non cadet capillus de capite eius in terram, quia cum Deo operatus est hodie '. Liberavit ergo populus Ionathan, ut non moreretur."
,"46":"Recessitque Saul nec persecutus est Philisthim; porro Philisthim abierunt in loca sua."
,"47":"At Saul, confirmato regno super Israel, pugnabat per circuitum adversum omnes inimicos eius: contra Moab et filios Ammon et Edom et reges Soba et Philisthaeos; et, quocumque se verterat, superabat."
,"48":"Fortiter egit et percussit Amalec et eruit Israel de manu vastatorum eius."
,"49":"Fuerunt autem filii Saul Ionathan et Isui et Melchisua. Nomina duarum filiarum eius: nomen primogenitae Merob et nomen minoris Michol."
,"50":"Et nomen uxoris Saul Achinoam filia Achimaas, et nomen principis militiae eius Abner filius Ner patrui Saul."
,"51":"Porro Cis pater Saul et Ner pater Abner fuerunt filii Abiel."
,"52":"Erat autem bellum potens adversum Philisthaeos omnibus diebus Saul; nam, quemcumque viderat Saul virum fortem et aptum ad proelium, sociabat eum sibi."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Et dixit Samuel ad Saul: ' Me misit Dominus, ut unge rem te in regem super populum eius Israel. Nunc ergo audi vocem Domini."
,"2":"Haec dicit Dominus exercituum: 'Recensui, quaecumque fecit Amalec Israeli, quomodo restitit ei in via, cum ascenderet de Aegypto."
,"3":"Nunc igitur vade et demolire Amalec et percute anathemate universa eius; non parcas ei, sed interfice a viro usque ad mulierem et parvulum atque lactantem, bovem et ovem, camelum et asinum' '."
,"4":"Convocavit itaque Saul populum et recensuit eos in Telem: ducenta milia peditum et decem milia virorum Iudae."
,"5":"Cumque venisset Saul usque ad civitatem Amalec, tetendit insidias in torrente"
,"6":"dixitque Saul Cinaeo: ' Abite, recedite atque descendite ab Amalec, ne forte perdam te cum eo; tu enim fecisti misericordiam cum omnibus filiis Israel, cum ascenderent de Aegypto '. Et recessit Cinaeus de medio Amalec."
,"7":"Percussitque Saul Amalec ab Hevila usque ad Sur, quae est e regione Aegypti."
,"8":"Et apprehendit Agag regem Amalec vivum; omne autem vulgus interfecit in ore gladii."
,"9":"Et pepercit Saul et populus Agag et optimis gregibus ovium et armentorum, pinguibus scilicet pecoribus et agnis et universis, quae pulchra erant, nec voluerunt disperdere ea; quidquid vero vile fuit et reprobum, hoc demoliti sunt."
,"10":"Factum est autem verbum Domini ad Samuel dicens:"
,"11":"' Paenitet me quod constituerim Saul regem, quia dereliquit me et verba mea opere non implevit '. Contristatusque est Samuel et clamavit ad Dominum tota nocte."
,"12":"Cumque de nocte surrexisset Samuel, ut iret ad Saul mane, nuntiatum est Samueli quod venisset Saul in Carmel et erexisset sibi trophaeum et reversus transisset descendissetque in Galgala."
,"13":"Et cum venisset Samuel ad Saul, dixit ei Saul: ' Benedictus tu Domino; implevi verbum Domini '."
,"14":"Dixitque Samuel: ' Et quae est haec vox gregum, quae resonat in auribus meis, et armentorum, quam ego audio? '."
,"15":"Et ait Saul: ' De Amalec adduxerunt ea; pepercit enim populus melioribus ovibus et armentis, ut immolarentur Domino Deo tuo; reliqua vero occidimus '."
,"16":"Dixit autem Samuel ad Saul: ' Sine me, et indicabo tibi, quae locutus sit Dominus ad me nocte '. Dixitque ei: ' Loquere '."
,"17":"Et ait Samuel: ' Nonne, cum parvulus esses in oculis tuis, caput in tribubus Israel factus es? Unxitque te Dominus regem super Israel"
,"18":"et misit te Dominus in viam et ait: ' Vade et interfice peccatores Amalec et pugnabis contra eos usque ad internecionem eorum '."
,"19":"Quare ergo non audisti vocem Domini, sed versus ad praedam es et fecisti malum in oculis Domini? '."
,"20":"Et ait Saul ad Samuelem: ' Immo audivi vocem Domini et ambulavi in via, per quam misit me Dominus; et adduxi Agag regem Amalec et Amalec interfeci."
,"21":"Tulit autem populus de praeda oves et boves, primitias eorum, quae caesa sunt, ut immolet Domino Deo tuo in Galgalis '."
,"22":"Et ait Samuel: ' Numquid vult Dominus holocausta aut victimas et non potius ut oboediatur voci Domini? Melior est enim oboedientia quam victimae, et auscultare magis quam offerre adipem arietum."
,"23":"Vere peccatum hariolandi est repugnare, et scelus idololatriae nolle acquiescere: pro eo ergo quod abiecisti sermonem Domini, abiecit te, ne sis rex '."
,"24":"Dixitque Saul ad Samuelem: ' Peccavi, quia praevaricatus sum sermonem Domini et verba tua timens populum et oboediens voci eorum;"
,"25":"sed nunc tolle, quaeso, peccatum meum et revertere mecum, ut adorem Dominum '."
,"26":"Et ait Samuel ad Saul: ' Non revertar tecum, quia proiecisti sermonem Domini; et proiecit te Dominus, ne sis rex super Israel '."
,"27":"Et conversus est Samuel, ut abiret; ille autem apprehendit summitatem pallii eius, quae et scissa est."
,"28":"Et ait ad eum Samuel: ' Scidit Dominus regnum Israel a te hodie et tradidit illud proximo tuo meliori te."
,"29":"Porro Gloria Israel non mentitur et paenitudine non flectitur; neque enim homo est, ut agat paenitentiam '."
,"30":"At ille ait: ' Peccavi, sed nunc honora me coram senibus populi mei et coram Israel; et revertere mecum, ut adorem Dominum Deum tuum '."
,"31":"Reversus ergo Samuel secutus est Saulem et adoravit Saul Dominum."
,"32":"Dixitque Samuel: ' Adducite ad me Agag regem Amalec '. Et oblatus est ei Agag tremens. Et dixit Agag: ' Certe secessit amaritudo mortis! '."
,"33":"Et ait Samuel: ' Sicut fecit absque liberis mulieres gladius tuus, sic absque liberis erit inter mulieres mater tua '. Et in frusta concidit Samuel Agag coram Domino in Galgalis."
,"34":"Abiit autem Samuel in Rama; Saul vero ascendit in domum suam in Gabaa Saulis."
,"35":"Et non vidit Samuel ultra Saul usque ad diem mortis suae; verumtamen lugebat Samuel Saul, quoniam Dominum paenitebat quod constituisset Saul regem super Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Dixitque Dominus ad Samuelem: ' Usquequo tu luges Saul, cum ego proiecerim eum, ne regnet super Israel? Imple cornu tuum oleo et veni, ut mittam te ad Isai Bethlehemitem; providi enim in filiis eius mihi regem '."
,"2":"Et ait Samuel: ' Quomodo vadam? Audiet enim Saul et interficiet me '. Et ait Dominus: ' Vitulam de armento tolles in manu tua et dices: 'Ad immolandum Domino veni'."
,"3":"Et vocabis Isai ad victimam; et ego ostendam tibi quid facias, et unges quemcumque monstravero tibi '."
,"4":"Fecit ergo Samuel, sicut locutus est ei Dominus, venitque in Bethlehem. Et expaverunt seniores civitatis occurrentes ei dixeruntque: ' Pacificusne ingressus tuus? '."
,"5":"Et ait: ' Pacificus; ad immolandum Domino veni. Sanctificamini et venite mecum, ut immolem '. Sanctificavit ergo Isai et filios eius et vocavit eos ad sacrificium."
,"6":"Cumque ingressi essent, vidit Eliab et ait: ' Absque dubio coram Domino est christus eius! '."
,"7":"Et dixit Dominus ad Samuelem: ' Ne respicias vultum eius neque altitudinem staturae eius, quoniam abieci eum; nec iuxta intuitum hominis iudico: homo enim videt ea, quae parent, Dominus autem intuetur cor '."
,"8":"Et vocavit Isai Abinadab et adduxit eum coram Samuele, qui dixit: ' Nec hunc elegit Dominus '."
,"9":"Adduxit autem Isai Samma, de quo ait: ' Etiam hunc non elegit Dominus '."
,"10":"Adduxit itaque Isai septem filios suos coram Samuele, et ait Samuel ad Isai: ' Non elegit Dominus ex istis '."
,"11":"Dixitque Samuel ad Isai: ' Numquid iam completi sunt filii? '. Qui respondit: ' Adhuc reliquus est minimus et pascit oves '. Et ait Samuel ad Isai: ' Mitte et adduc eum; nec enim discumbemus prius quam huc ille venerit '."
,"12":"Misit ergo et adduxit eum; erat autem rufus et pulcher aspectu decoraque facie. Et ait Dominus: ' Surge, unge eum; ipse est enim '."
,"13":"Tulit igitur Samuel cornu olei et unxit eum in medio fratrum eius; et directus est spiritus Domini in David a die illa et in reliquum. Surgensque Samuel abiit in Rama."
,"14":"Spiritus autem Domini recessit a Saul, et exagitabat eum spiritus nequam a Domino."
,"15":"Dixeruntque servi Saul ad eum: ' Ecce spiritus Dei malus exagitat te."
,"16":"Iubeat dominus noster, et servi tui, qui coram te sunt, quaerant hominem scientem psallere cithara, ut, quando arripuerit te spiritus Dei malus, psallat manu sua, et levius feras '."
,"17":"Et ait Saul ad servos suos: ' Providete mihi aliquem bene psallentem et adducite eum ad me '."
,"18":"Et respondens unus de pueris ait: ' Ecce vidi filium Isai Bethlehemitae scientem psallere et fortissimum robore et virum bellicosum et prudentem in verbis et virum pulchrum; et Dominus est cum eo '."
,"19":"Misit ergo Saul nuntios ad Isai dicens: ' Mitte ad me David filium tuum, qui est in pascuis '."
,"20":"Tulitque Isai asinum cum pane et utre vini et haedo de capris uno et misit per manum David filii sui Sauli."
,"21":"Et venit David ad Saul et stetit coram eo; at ille dilexit eum nimis, et factus est eius armiger."
,"22":"Misitque Saul ad Isai dicens: ' Stet David in conspectu meo; invenit enim gratiam in oculis meis '."
,"23":"Igitur, quandocumque spiritus Dei arripiebat Saul, David tollebat citharam et percutiebat manu sua; et refocillabatur Saul et levius habebat: recedebat enim ab eo spiritus malus."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Congregantes vero Phili sthim agmina sua in proe lium, convenerunt in Socho Iudae et castrametati sunt inter Socho et Azeca in Aphesdommim."
,"2":"Porro Saul et viri Israel congregati venerunt in vallem Terebinthi et instruxerunt aciem ad pugnandum contra Philisthim."
,"3":"Et Philisthim stabant super montem ex hac parte, et Israel stabat super montem ex altera parte; vallisque erat inter eos."
,"4":"Et egressus est vir propugnator de castris Philisthinorum nomine Goliath de Geth altitudinis sex cubitorum et palmi."
,"5":"Et cassis aerea super caput eius, et lorica squamata induebatur; porro pondus loricae eius quinque milia siclorum aeris."
,"6":"Et ocreas aereas habebat in cruribus, et acinaces aereus erat inter umeros eius."
,"7":"Hastile autem hastae eius erat quasi liciatorium texentium, ipsum autem ferrum hastae eius sescentos siclos habebat ferri; et armiger eius antecedebat eum."
,"8":"Stansque clamabat adversum agmina Israel et dicebat eis: ' Quare venitis parati ad proelium? Numquid ego non sum Philisthaeus, et vos servi Saul? Eligite ex vobis virum, et descendat ad singulare certamen!"
,"9":"Si quiverit pugnare mecum et percusserit me, erimus vobis servi; si autem ego praevaluero et percussero eum, vos servi eritis et servietis nobis '."
,"10":"Et aiebat Philisthaeus: ' Ego exprobravi agminibus Israel hodie: Date mihi virum, et ineat mecum singulare certamen! '."
,"11":"Audiens autem Saul et omnes Israelitae sermones Philisthaei huiuscemodi stupebant et metuebant nimis."
,"12":"David autem erat filius viri Ephrathaei, de quo supra dictum est, de Bethlehem Iudae, cui erat nomen Isai; qui habebat octo filios et erat vir in diebus Saul senex et grandaevus inter viros."
,"13":"Abierunt autem tres filii eius maiores post Saul in proelium; et nomina trium filiorum eius, qui perrexerant ad bellum: Eliab primogenitus et secundus Abinadab tertiusque Samma."
,"14":"David autem erat minimus; tribus ergo maioribus secutis Saulem,"
,"15":"ibat David et revertebatur a Saul, ut pasceret gregem patris sui in Bethlehem."
,"16":"Procedebat vero Philisthaeus mane et vespere et stabat quadraginta diebus."
,"17":"Dixit autem Isai ad David filium suum: ' Accipe fratribus tuis ephi frumenti tosti et decem panes istos et curre in castra ad fratres tuos."
,"18":"Et decem formellas casei has deferes ad tribunum, et fratres tuos visitabis, si recte agant; et pignus ab eis referes '."
,"19":"Saul autem et illi et omnes filii Israel in valle Terebinthi pugnabant adversum Philisthim."
,"20":"Surrexit itaque David mane et commendavit gregem custodi et onustus abiit, sicut praeceperat ei Isai. Et venit ad carraginem, dum exercitus egrediebatur ad pugnam et vociferabatur in certamine."
,"21":"Direxerunt ergo Israel et Philisthim aciem adversus aciem."
,"22":"Derelinquens autem David vasa, quae attulerat, sub manu custodis ad sarcinas, cucurrit ad locum certaminis et interrogabat, si omnia recte agerentur erga fratres suos."
,"23":"Cumque adhuc ille loqueretur eis, apparuit vir ille propugnator ascendens, Goliath nomine, Philisthaeus de Geth, ex castris Philisthinorum; et loquente eo haec eadem verba, audivit David."
,"24":"Omnes autem Israelitae, cum vidissent virum, fugerunt a facie eius timentes eum valde."
,"25":"Et dixit unus quispiam de Israel: ' Num vidistis virum hunc, qui ascendit? Ad exprobrandum enim Israeli ascendit. Virum ergo, qui percusserit eum, ditabit rex divitiis magnis et filiam suam dabit ei; et domum patris eius faciet absque tributo in Israel '."
,"26":"Et ait David ad viros, qui stabant secum, dicens: ' Quid dabitur viro, qui percusserit Philisthaeum hunc et tulerit opprobrium de Israel? Quis est enim hic Philisthaeus incircumcisus, qui exprobravit acies Dei viventis? '."
,"27":"Referebat autem ei populus eundem sermonem dicens: ' Haec dabuntur viro, qui percusserit eum '."
,"28":"Quod cum audisset Eliab frater eius maior, loquente eo cum aliis, iratus est contra David et ait: ' Quare venisti et cui dereliquisti pauculas oves illas in deserto? Ego novi superbiam tuam et nequitiam cordis tui, quia ut videres proelium descendisti '."
,"29":"Et dixit David: ' Quid feci? Numquid non verbum est? '."
,"30":"Et declinavit paululum ab eo ad alium dixitque eundem sermonem; et respondit ei populus verbum sicut prius."
,"31":"Audita sunt autem verba, quae locutus est David, et annuntiata in conspectu Saul."
,"32":"Ad quem cum fuisset adductus, locutus est ei: ' Non concidat cor cuiusquam in eo; ego servus tuus vadam et pugnabo adversus Philisthaeum istum '."
,"33":"Et ait Saul ad David: ' Non vales resistere Philisthaeo isti nec pugnare adversus eum, quia puer es; hic autem vir bellator ab adulescentia sua '."
,"34":"Dixitque David ad Saul: ' Pascebat servus tuus patris sui gregem, et veniebat leo vel ursus tollebatque arietem de medio gregis."
,"35":"Et sequebar eos et percutiebam eruebamque de ore eorum; et illi consurgebant adversum me, et apprehendebam mentum eorum et percutiebam interficiebamque eos."
,"36":"Nam et leonem et ursum interfecit servus tuus; erit igitur et Philisthaeus hic incircumcisus quasi unus ex eis, quia ausus est maledicere exercitum Dei viventis '."
,"37":"Et ait David: ' Dominus, qui eruit me de manu leonis et de manu ursi, ipse liberabit me de manu Philisthaei huius '. Dixit autem Saul ad David: ' Vade, et Dominus tecum sit '."
,"38":"Et induit Saul David vestimentis suis et imposuit galeam aeream super caput eius et vestivit eum lorica."
,"39":"Accinctus ergo David gladio eius super vestem suam coepit tentare, si armatus posset incedere; non enim habebat consuetudinem. Dixitque David ad Saul: ' Non possum sic incedere, quia nec usum habeo '. Et deposuit ea"
,"40":"et tulit baculum suum in manu sua; et elegit sibi quinque levissimos lapides de torrente et misit eos in peram pastoralem, qua ut sacculo lapidum utebatur, et fundam manu tulit et processit adversum Philisthaeum."
,"41":"Ibat autem Philisthaeus incedens et appropinquans adversum David, et armiger eius ante eum."
,"42":"Cumque inspexisset Philisthaeus et vidisset David, despexit eum; erat enim adulescens rufus et pulcher aspectu."
,"43":"Et dixit Philisthaeus ad David: ' Numquid ego canis sum, quod tu venis ad me cum baculo? '. Et maledixit Philisthaeus David in diis suis;"
,"44":"dixitque ad David: ' Veni ad me, et dabo carnes tuas volatilibus caeli et bestiis terrae '."
,"45":"Dixit autem David ad Philisthaeum: ' Tu venis ad me cum gladio et hasta et acinace; ego autem venio ad te in nomine Domini exercituum, Dei agminum Israel, quibus exprobrasti."
,"46":"Hodie dabit te Dominus in manu mea, et percutiam te et auferam caput tuum a te; et dabo cadaver tuum et cadavera castrorum Philisthim hodie volatilibus caeli et bestiis terrae, ut sciat omnis terra quia est Deus in Israel,"
,"47":"et noverit universa ecclesia haec quia non in gladio nec in hasta salvat Dominus: ipsius enim est bellum, et tradet vos in manus nostras '."
,"48":"Cum ergo surrexisset Philisthaeus et veniret et appropinquaret contra David, festinavit David et cucurrit ad pugnam adversum Philisthaeum."
,"49":"Et misit manum suam in peram tulitque unum lapidem et funda iecit; et percussit Philisthaeum in fronte, et infixus est lapis in fronte eius, et cecidit in faciem suam super terram."
,"50":"Praevaluitque David adversum Philisthaeum in funda et in lapide; percussumque Philisthaeum interfecit. Cumque gladium non haberet in manu, David"
,"51":"cucurrit et stetit super Philisthaeum; et tulit gladium eius et eduxit eum de vagina sua et interfecit eum praeciditque caput eius. Videntes autem Philisthim quod mortuus esset fortissimus eorum fugerunt. "
,"52":"Et consurgentes viri Israel et Iudae vociferati sunt et persecuti Philisthaeos usque dum venirent ad Geth et usque ad portas Accaron. Cecideruntque vulnerati de Philisthim in via a Saarim usque ad Geth et usque ad Accaron."
,"53":"Et revertentes filii Israel, postquam persecuti fuerant Philisthaeos, praedati sunt castra eorum."
,"54":"Assumens autem David caput Philisthaei attulit illud in Ierusalem; arma vero eius posuit in tabernaculo."
,"55":"Eo autem tempore, quo viderat Saul David egredientem contra Philisthaeum, ait ad Abner principem militiae: ' De qua stirpe descendit hic adulescens, Abner? '. Dixitque Abner: ' Vivit anima tua, rex, quia non novi '."
,"56":"Et ait rex: ' Interroga tu, cuius filius sit iste puer '."
,"57":"Cumque regressus esset David, percusso Philisthaeo, tulit eum Abner et introduxit coram Saul caput Philisthaei habentem in manu."
,"58":"Et ait ad eum Saul: ' De qua progenie es, o adulescens? '. Dixitque David: ' Filius servi tui Isai Bethlehemitae ego sum '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Et factum est cum complesset loqui ad Saul, anima Ionathan colligata est animae David, et dilexit eum Ionathan quasi animam suam."
,"2":"Tulitque eum Saul in die illa et non concessit ei, ut reverteretur in domum patris sui."
,"3":"Inierunt autem Ionathan et David foedus; diligebat enim eum quasi animam suam."
,"4":"Et exspoliavit se Ionathan tunicam, qua erat vestitus, et dedit eam David et reliqua vestimenta sua usque ad gladium et arcum suum et usque ad balteum."
,"5":"Egrediebatur quoque David ad omnia, quaecumque misisset eum Saul, et prospere agebat; posuitque eum Saul super viros belli, et acceptus erat in oculis universi populi, etiam in conspectu famulorum Saul."
,"6":"Porro cum reverterentur, cum rediret David, percusso Philisthaeo, egressae sunt mulieres de universis urbibus Israel cantantes chorosque ducentes in occursum Saul regis in tympanis et in canticis laetitiae et in sistris."
,"7":"Et praecinebant mulieres ludentes atque dicentes: ' Percussit Saul milia sua, et David decem milia sua '."
,"8":"Iratus est autem Saul nimis, et displicuit in oculis eius iste sermo, dixitque: ' Dederunt David decem milia et mihi dederunt milia; quid ei superest nisi solum regnum? '."
,"9":"Non rectis ergo oculis Saul aspiciebat David ex die illa et deinceps."
,"10":"Post diem autem alteram invasit spiritus Dei malus Saul, et vaticinabatur in medio domus suae; David autem psallebat manu sua sicut per singulos dies, tenebatque Saul lanceam."
,"11":"Et sustulit eam putans quod configere posset David cum pariete; et declinavit David a facie eius secundo."
,"12":"Et timuit Saul David, eo quod esset Dominus cum eo et a se recessisset."
,"13":"Amovit ergo eum Saul a se et fecit eum tribunum super mille viros; et egrediebatur et intrabat in conspectu populi."
,"14":"In omnibus quoque viis suis David prospere agebat, et Dominus erat cum eo."
,"15":"Vidit itaque Saul quod prospere ageret nimis et coepit pavere eum;"
,"16":"omnis autem Israel et Iuda diligebat David; ipse enim egrediebatur et ingrediebatur ante eos."
,"17":"Dixit autem Saul ad David: ' Ecce filia mea maior Merob, ipsam dabo tibi uxorem; tantummodo esto mihi vir fortis et proeliare bella Domini '. Saul autem reputabat dicens: ' Non sit manus mea in eo, sed sit super illum manus Philisthinorum '."
,"18":"Ait autem David ad Saul: ' Quis ego sum, aut quae est vita mea aut cognatio patris mei in Israel, ut fiam gener regis? '."
,"19":"Factum est autem tempus, cum deberet dari Merob filia Saul David, data est Hadriel Molathitae uxor."
,"20":"Dilexit autem Michol filia Saul altera David, et nuntiatum est Saul, et placuit ei;"
,"21":"dixitque Saul: ' Dabo eam illi, ut fiat ei in scandalum, et sit super eum manus Philisthinorum '. Dixit ergo Saul ad David altera vice: ' Gener meus eris hodie '."
,"22":"Et mandavit Saul servis suis: ' Loquimini ad David secreto dicentes: 'Ecce places regi, et omnes servi eius diligunt te; nunc ergo esto gener regis' '."
,"23":"Et locuti sunt servi Saul in auribus David omnia verba haec, et ait David: ' Num parum vobis videtur generum esse regis? Ego autem sum vir pauper et tenuis '."
,"24":"Et renuntiaverunt servi Saul dicentes: ' Huiuscemodi verba locutus est David '."
,"25":"Dixit autem Saul: ' Sic loquimini ad David: 'Non habet necesse rex sponsalia, nisi tantum centum praeputia Philisthinorum, ut fiat ultio de inimicis regis' '. Porro Saul cogitabat tradere David in manibus Philisthinorum."
,"26":"Cumque renuntiassent servi eius David verba, quae dixerat Saul, placuit sermo in oculis David, ut fieret gener regis."
,"27":"Et nondum erant dies impleti, cum David surgens abiit cum viris, qui sub eo erant, et percussit ex Philisthim ducentos viros; et attulit praeputia eorum, et annumeraverunt ea regi, ut esset gener eius. Dedit itaque ei Saul Michol filiam suam uxorem. "
,"28":"Et vidit Saul et intellexit quia Dominus esset cum David; Michol autem filia Saul diligebat eum."
,"29":"Et Saul magis coepit timere David; factusque est Saul inimicus David cunctis diebus."
,"30":"Et egressi sunt principes Philisthinorum; et, quotiescumque egrediebantur, prospere agebat David magis quam omnes servi Saul, et celebre factum est nomen eius nimis."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Locutus est autem Saul ad Ionathan filium suum et ad omnes servos suos de occisione David; porro Ionathan filius Saul diligebat David valde."
,"2":"Et indicavit Ionathan David dicens: ' Quaerit Saul pater meus occidere te; quapropter observa te, quaeso, mane; et manebis clam et absconderis."
,"3":"Ego autem egrediens stabo iuxta patrem meum in agro, ubicumque fueris; et ego loquar de te ad patrem meum et, quodcumque videro, nuntiabo tibi '."
,"4":"Locutus est ergo Ionathan de David bona ad Saul patrem suum dixitque ad eum: ' Ne peccet rex in servum suum David, quia non peccavit tibi, et opera eius bona sunt tibi valde."
,"5":"Et posuit animam suam in manu sua et percussit Philisthaeum, et fecit Dominus victoriam magnam universo Israeli; vidisti et laetatus es. Quare ergo peccas in sanguine innoxio interficiens David, qui est absque culpa? '."
,"6":"Quod cum audisset Saul, placatus voce Ionathan iuravit: ' Vivit Dominus quia non occidetur '."
,"7":"Vocavit itaque Ionathan David et indicavit ei omnia verba haec; et introduxit lonathan David ad Saul, et fuit ante eum, sicut fuerat heri et nudiustertius."
,"8":"Motum est autem rursum bellum, et egressus David pugnavit adversum Philisthim percussitque eos plaga magna; et fugerunt a facie eius."
,"9":"Et factus est spiritus Domini malus in Saul; sedebat autem in domo sua et tenebat lanceam, porro David psallebat in manu sua."
,"10":"Nisusque est Saul configere lancea David in pariete; et declinavit David a facie Saul, lancea autem, casso vulnere, perlata est in parietem. Et David fugit et salvatus est nocte illa."
,"11":"Misit ergo Saul satellites suos in domum David, ut custodirent eum, et interficeretur mane. Quod cum annuntiasset David Michol uxor sua dicens: ' Nisi salvaveris te nocte hac, cras morieris ', "
,"12":"deposuit eum per fenestram. Porro ille abiit et aufugit atque salvatus est."
,"13":"Tulit autem Michol theraphim et posuit eum super lectum; et pellem pilosam caprarum posuit ad caput eius et operuit eum vestimentis."
,"14":"Misit autem Saul nuntios, qui raperent David, et responsum est quod aegrotaret."
,"15":"Rursumque misit Saul nuntios, ut viderent David, dicens: ' Afferte eum ad me in lecto, ut occidatur '."
,"16":"Cumque venissent nuntii, inventus est theraphim super lectum, et pellis caprarum ad caput eius."
,"17":"Dixitque Saul ad Michol: ' Quare sic illusisti mihi et dimisisti inimicum meum, ut fugeret? '. Et respondit Michol ad Saul: ' Quia ipse locutus est mihi: 'Dimitte me, alioquin interficiam te' '."
,"18":"David autem fugiens salvatus est et venit ad Samuel in Rama et nuntiavit ei omnia, quae fecerat sibi Saul. Et abierunt ipse et Samuel et morati sunt in Naioth."
,"19":"Nuntiatum est autem Sauli a dicentibus: ' Ecce David in Naioth in Rama '."
,"20":"Misit ergo Saul nuntios, ut raperent David. Qui cum vidissent cuneum prophetarum vaticinantium et Samuel stantem super eos, factus est in illis spiritus Dei, et vaticinari coeperunt etiam ipsi."
,"21":"Quod cum nuntiatum esset Sauli, misit alios nuntios; vaticinati sunt autem et illi. Et rursum Saul misit tertios nuntios, qui et ipsi vaticinati sunt."
,"22":"Abiit autem etiam ipse in Rama et venit usque ad cisternam magnam, quae est in Socho; et interrogavit et dixit: ' In quo loco sunt Samuel et David? '. Dictumque est ei: ' Ecce in Naioth sunt in Rama '."
,"23":"Et abiit inde in Naioth in Rama; et factus est etiam super eum spiritus Dei, et ambulabat ingrediens et vaticinans, usquedum veniret in Naioth in Rama."
,"24":"Et exspoliavit se etiam ipse vestimentis suis et vaticinatus est cum ceteris coram Samuel; et cecidit nudus tota die illa et nocte, unde et exivit proverbium: ' Num et Saul inter prophetas? '."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Fugit autem David de Naioth, quae est in Rama, veniensque locutus est coram Ionathan: ' Quid feci? Quae est iniquitas mea et quod peccatum meum in patrem tuum, quia quaerit animam meam? '."
,"2":"Qui dixit ei: ' Absit, non morieris; neque enim faciet pater meus quidquam grande vel parvum, nisi prius indicaverit mihi; hoc ergo celavit me pater meus tantummodo? Nequaquam erit istud '."
,"3":"Et rursum respondit David et ait: ' Scit profecto pater tuus quia inveni gratiam in oculis tuis et dixit: 'Nesciat hoc Ionathan, ne forte tristetur'. Quinimmo vivit Dominus, et vivit anima tua, quia uno tantum gradu ego morsque dividimur '."
,"4":"Et ait Ionathan ad David: ' Quid desiderat anima tua, ut faciam tibi? '."
,"5":"Dixit autem David ad Ionathan: ' Ecce neomenia est crastino, et ego ex more sedere soleo iuxta regem ad vescendum; dimitte ergo me, ut abscondar in agro usque ad vesperam diei tertiae."
,"6":"Si requisierit me pater tuus, respondebis ei: 'Rogavit me David, ut iret celeriter in Bethlehem civitatem suam, quia victimae annuae ibi sunt universis contribulibus eius'."
,"7":"Si dixerit: 'Bene', pax erit servo tuo; si autem fuerit iratus, scito quia malum decretum est ab eo."
,"8":"Fac ergo misericordiam in servum tuum, quia foedus Domini me famulum tuum tecum inire fecisti; si autem est in me aliqua iniquitas, tu me interfice et ad patrem tuum ne introducas me '."
,"9":"Et ait Ionathan: ' Absit hoc a te; neque enim fieri potest ut, si certo cognovero malum decretum esse a patre meo contra te, non annuntiem tibi '."
,"10":"Responditque David ad Ionathan: ' Quis nuntiabit mihi, si quid forte responderit tibi pater tuus dure? '."
,"11":"Et ait Ionathan ad David: ' Veni, egrediamur foras in agrum '. Cumque exissent ambo in agrum,"
,"12":"ait Ionathan ad David: ' Vivit Dominus, Deus Israel, investigabo sententiam patris mei hoc fere tempore cras vel perendie; et si aliquid boni fuerit super David, et non statim miserim ad te et notum tibi fecerim,"
,"13":"haec faciat Dominus in Ionathan et haec augeat! Si autem perseveraverit patris mei malitia adversum te, hoc quoque notum faciam tibi et dimittam te, ut vadas in pace. Et sit Dominus tecum, sicut fuit cum patre meo."
,"14":"Et, si vixero, facies mihi misericordiam Domini; si vero mortuus fuero,"
,"15":"non auferas misericordiam tuam a domo mea usque in sempiternum, quando eradicaverit Dominus inimicos David unumquemque de terra '."
,"16":"Pepigit ergo foedus Ionathan cum domo David dicens: ' Requirat Dominus de manu inimicorum David! '."
,"17":"Et addidit Ionathan ut faceret David iurare per dilectionem suam erga illum; sicut animam enim suam, ita diligebat eum."
,"18":"Dixitque ad eum Ionathan: ' Cras neomenia est, et requireris;"
,"19":"vacua erit enim sessio tua. Perendie descendes festinus et venies in locum, ubi abscondisti te in die facti illius; et sedebis iuxta acervum illum."
,"20":"Et ego tres sagittas mittam iuxta eum et iaciam quasi exercens me ad signum."
,"21":"Mittam quoque et puerum dicens ei: 'Vade et affer mihi sagittas'."
,"22":"Si dixero puero: 'Ecce sagittae intra te sunt, tolle eas', tu veni ad me, quia pax tibi est, et nihil est mali, vivit Dominus. Si autem sic locutus fuero puero: 'Ecce sagittae ultra te sunt', vade, quia dimisit te Dominus."
,"23":"De verbo autem, quod locuti fuimus, ego et tu, sit Dominus inter me et te usque in sempiternum '."
,"24":"Absconditus est ergo David in agro; et venit neomenia, et sedit rex ad mensam ad comedendum."
,"25":"Cumque sedisset rex super cathedram suam secundum consuetudinem, quae erat iuxta parietem, sedit Ionathan ex adverso, et sedit Abner ex latere Saul; vacuusque apparuit locus David."
,"26":"Et non est locutus Saul quidquam in die illa; cogitabat enim quod forte evenisset ei, ut non esset mundus nec purificatus."
,"27":"Cumque illuxisset dies secunda post neomeniam, rursum vacuus apparuit locus David; dixitque Saul ad Ionathan filium suum: ' Cur non venit filius Isai nec heri nec hodie ad vescendum? '."
,"28":"Et respondit Ionathan Sauli: ' Rogavit me obnixe, ut iret in Bethlehem,"
,"29":"et ait: 'Dimitte me, quoniam sacrificium familiae est in civitate, et frater meus ipse accersivit me; nunc ergo, si inveni gratiam in oculis tuis, vadam cito et videbo fratres meos'. Ob hanc causam non venit ad mensam regis '."
,"30":"Iratus autem Saul adversum Ionathan dixit ei: ' Fili mulieris perversae, numquid ignoro quia diligis filium Isai in confusionem tuam et in confusionem nuditatis matris tuae?"
,"31":"Omnibus enim diebus, quibus filius Isai vixerit super terram, non stabilieris tu neque regnum tuum; itaque iam nunc mitte et adduc eum ad me, quia filius mortis est '."
,"32":"Respondens autem Ionathan Sauli patri suo ait: ' Quare morietur? Quid fecit? '."
,"33":"Et arripuit Saul lanceam, ut percuteret eum; et intellexit Ionathan quod definitum esset patri suo, ut interficeret David."
,"34":"Surrexit ergo Ionathan a mensa in ira furoris et non comedit in die neomeniae secunda panem; contristatus est enim super David, eo quod confudisset eum pater suus."
,"35":"Cumque illuxisset mane, venit Ionathan in agrum ad locum constitutum a David et puer parvulus cum eo;"
,"36":"et ait ad puerum suum: ' Vade et affer mihi sagittas, quas ego iacio '. Cumque puer cucurrisset, iecit sagittam trans puerum."
,"37":"Venit itaque puer ad locum sagittae, quam miserat Ionathan, et clamavit Ionathan post tergum pueri et ait: ' Ecce ibi est sagitta porro ultra te '."
,"38":"Clamavitque Ionathan post tergum pueri: ' Festina velociter, ne steteris '. Sustulit autem puer Ionathae sagittam et attulit ad dominum suum"
,"39":"et quid ageretur penitus ignorabat, tantummodo enim Ionathan et David rem noverant."
,"40":"Dedit igitur Ionathan arma sua puero et dixit ei: ' Vade, defer in civitatem '."
,"41":"Cumque abisset puer, surrexit David de latere acervi et cadens pronus in terram adoravit tertio; et osculantes alterutrum fleverunt pariter, David autem amplius."
,"42":"Dixit ergo Ionathan ad David: ' Vade in pace; iuravimus enim ambo in nomine Domini dicentes: Dominus erit inter me et te et inter semen meum et semen tuum usque in sempiternum '."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Et surrexit David et abiit; sed et Ionathan ingressus est civitatem."
,"2":"Venit autem David in Nob ad Achimelech sacerdotem, et obstupuit Achimelech eo quod venisset David, et dixit ei: ' Quare tu solus et nullus est tecum? '."
,"3":"Et ait David ad Achimelech sacerdotem: ' Rex praecepit mihi negotium et dixit: 'Nemo sciat rem, propter quam a me missus es, et cuiusmodi tibi praecepta dederim'; pueris vero condixi in illum et illum locum."
,"4":"Nunc igitur, si habes ad manum quinque panes, da mihi, aut quidquid inveneris '."
,"5":"Et respondens sacerdos David ait ei: ' Non habeo panes laicos ad manum, sed tantum panem sanctum; si mundi sunt pueri maxime a mulieribus? '."
,"6":"Et respondit David sacerdoti et dixit ei: ' Equidem, si de mulieribus agitur, continuimus nos ab heri et nudiustertius. Quando egrediebar, fuerunt corpora puerorum sancta, quamvis iter esset profanum. Quanto magis hodie sunt sancti quoad corpora '."
,"7":"Dedit ergo ei sacerdos sanctificatum panem; neque enim erat ibi panis, nisi tantum panes propositionis, qui sublati fuerant a facie Domini, ut ponerentur panes calidi."
,"8":"Erat autem ibi vir de servis Saul in die illa retentus ante Dominum; et nomen eius Doeg Idumaeus, potentissimus pastorum Saul."
,"9":"Dixit autem David ad Achimelech: ' Si habes hic ad manum hastam aut gladium? Quia gladium meum et arma mea non tuli mecum; negotium enim regis urgebat '."
,"10":"Et dixit sacerdos: ' Ecce hic gladius Goliath Philisthaei, quem percussisti in valle Terebinthi; est involutus pallio post ephod. Si istum vis tollere, tolle, neque enim est alius hic absque eo '. Et ait David: ' Non est huic alter similis; da mihi eum '."
,"11":"Surrexit itaque David et fugit in die illa a facie Saul et venit ad Achis regem Geth."
,"12":"Dixeruntque ei servi Achis: ' Numquid non iste est David rex terrae? Nonne huic cantabant per choros dicentes: 'Percussit Saul milia sua, et David decem milia sua'? '."
,"13":"Posuit autem David sermones istos in corde suo et extimuit valde a facie Achis regis Geth."
,"14":"Et immutavit os suum coram eis; et insaniebat inter manus eorum et impingebat in ostia portae, defluebantque salivae in barbam."
,"15":"Et ait Achis ad servos suos: ' Vidistis hominem insanum. Quare adduxistis eum ad me?"
,"16":"An desunt nobis furiosi, quod introduxistis istum, ut fureret, me praesente? Hicine ingredietur domum meam? '."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Abiit ergo inde David et fugit in speluncam Odollam; quod cum audissent fratres eius et omnis domus patris eius, descenderunt ad eum illuc."
,"2":"Et convenerunt ad eum omnes, qui erant in angustia constituti et oppressi aere alieno et amaro animo; et factus est eorum princeps, fueruntque cum eo quasi quadringenti viri."
,"3":"Et profectus est David inde in Maspha, quae est Moab, et dixit ad regem Moab: ' Maneat, oro, pater meus et mater mea vobiscum, donec sciam quid faciat mihi Deus '."
,"4":"Et reliquit eos ante faciem regis Moab; manseruntque apud eum cunctis diebus, quibus David fuit in praesidio."
,"5":"Dixitquc Gad propheta ad David: ' Noli manere in praesidio. Proficiscere et vade in terram Iudae '. Et profectus David venit in saltum Haret."
,"6":"Et audivit Saul quod detectus fuisset David et viri, qui erant cum eo. Saul autem, cum maneret in Gabaa et esset sub myrice, quae est in excelso, hastam manu tenens, cunctique servi eius circumstarent eum,"
,"7":"ait ad servos suos, qui assistebant ei: ' Audite, Beniaminitae. Etiam omnibus vobis dabit filius Isai agros et vineas et universos vos faciet tribunos et centuriones,"
,"8":"quoniam coniurastis omnes adversum me. Et non est qui mihi renuntiet quod filius meus foedus iunxerit cum filio Isai; non est qui vicem meam doleat ex vobis, nec qui annuntiet mihi quod suscitaverit filius meus servum meum adversum me insidiantem mihi sicut hodie '."
,"9":"Respondens autem Doeg Idumaeus, qui assistebat cum servis Saul: ' Vidi, inquit, filium Isai in Nob apud Achimelech filium Achitob;"
,"10":"qui consuluit pro eo Dominum et cibaria dedit ei, sed et gladium Goliath Philisthaei dedit illi '."
,"11":"Misit ergo rex ad accersendum Achimelech sacerdotem filium Achitob et omnem domum patris eius, sacerdotum, qui erant in Nob; qui venerunt universi ad regem."
,"12":"Et ait Saul: ' Audi, fili Achitob '. Qui respondit: ' Praesto sum, domine '."
,"13":"Dixitque ad eum Saul: ' Quare coniurastis adversum me, tu et filius Isai, et dedisti ei panes et gladium et consuluisti pro eo Deum, ut consurgeret adversum me insidiator, sicut est hodie? '."
,"14":"Respondensque Achimelech regi ait: ' Et quis in omnibus servis tuis sicut David fidelis et gener regis et dux satellitum tuorum et gloriosus in domo tua?"
,"15":"Num hodie coepi consulere pro eo Deum? Absit hoc a me, ne suspicetur rex adversus servum suum rem huiuscemodi, adversus universam domum patris mei; non enim scivit servus tuus quidquam super hoc negotio, vel modicum vel grande '."
,"16":"Dixitque rex: ' Morte morieris, Achimelech, tu et omnis domus patris tui '."
,"17":"Et ait rex emissariis, qui circumstabant eum: ' Convertimini et interficite sacerdotes Domini, nam manus eorum cum David est; scientes quod fugisset, non indicaverunt mihi '. Noluerunt autem servi regis extendere manum suam in sacerdotes Domini."
,"18":"Et ait rex ad Doeg: ' Convertere tu et irrue in sacerdotes '. Conversusque Doeg Idumaeus irruit in sacerdotes; et trucidavit in die illa octoginta quinque viros vestitos ephod lineo."
,"19":"Nob autem civitatem sacerdotum percussit in ore gladii, viros et mulieres, parvulos et lactantes, bovem et asinum et ovem in ore gladii."
,"20":"Evadens autem unus filius Achimelech filii Achitob, cuius nomen erat Abiathar, fugit ad David"
,"21":"et annuntiavit ei quod occidisset Saul sacerdotes Domini."
,"22":"Et ait David ad Abiathar: ' Sciebam in die illa quod, cum ibi esset Doeg Idumaeus, procul dubio annuntiaret Saul; ego sum reus omnium animarum domus patris tui."
,"23":"Mane mecum, ne timeas; qui enim quaerit animam meam, quaerit et animam tuam, mecumque servaberis '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Et nuntiaverunt David di centes: ' Ecce Philisthim op pugnant Ceila et diripiunt areas '."
,"2":"Consuluit igitur David Dominum dicens: ' Num vadam et percutiam Philisthaeos istos? '. Et ait Dominus ad David: ' Vade et percuties Philisthaeos et salvabis Ceila '."
,"3":"Et dixerunt viri, qui erant cum David, ad eum: ' Ecce nos hic in Iuda consistentes timemus; quanto magis si ierimus in Ceila adversum agmina Philisthinorum? '."
,"4":"Rursum ergo David consuluit Dominum, qui respondens ei ait: ' Surge et vade in Ceila; ego enim tradam Philisthaeos in manu tua '."
,"5":"Abiit ergo David et viri eius in Ceila et pugnavit adversum Philisthaeos et abegit iumenta eorum et percussit eos plaga magna: et salvavit David habitatores Ceilae."
,"6":"Porro cum fugisset Abiathar filius Achimelcch ad David, et ipse cum David in Ceila ephod secum habens descenderat."
,"7":"Nuntiatum est autem Saul quod venisset David in Ceila, et ait Saul: ' Tradidit eum Deus in manus meas; conclususque est introgressus urbem, in qua portae et serae sunt '."
,"8":"Et convocavit Saul omnem populum, ut ad pugnam descenderet in Ceila et obsideret David et viros eius."
,"9":"Quod cum rescisset David quia praepararet ei Saul clam malum, dixit ad Abiathar sacerdotem: ' Applica ephod '."
,"10":"Et ait David: ' Domine, Deus Israel, audivit famam servus tuus quod disponat Saul venire ad Ceila, ut evertat urbem propter me."
,"11":"Si tradent me viri Ceilae in manus eius? Et si descendet Saul, sicut audivit servus tuus? Domine, Deus Israel, indica servo tuo '. Et ait Dominus: ' Descendet '."
,"12":"Dixitque David: ' Si tradent viri Ceilae me et viros, qui sunt mecum, in manu Saul? '. Et dixit Dominus: ' Tradent '."
,"13":"Surrexit ergo David et viri eius quasi sescenti et egressi de Ceila huc atque illuc vagabantur incerti. Nuntiatumque est Saul quod fugisset David de Ceila, quam ob rem destitit exire."
,"14":"Morabatur autem David in deserto in locis firmissimis mansitque in monte, in deserto Ziph; et quaerebat eum Saul cunctis diebus, sed non tradidit eum Deus in manus eius."
,"15":"Et cognovit David quod egressus esset Saul, ut quaereret animam eius; porro David erat in deserto Ziph in Horesa."
,"16":"Et surrexit Ionathan filius Saul et abiit ad David in Horesa; et confortavit manus eius in Deo dixitque ei:"
,"17":"' Ne timeas, neque enim inveniet te manus Saul patris mei; et tu regnabis super Israel, et ego ero tibi secundus; sed et Saul pater meus scit hoc '."
,"18":"Percussit igitur uterque foedus coram Domino; mansitque David in Horesa, Ionathan autem reversus est in domum suam."
,"19":"Ascenderunt autem Ziphaei ad Saul in Gabaa dicentes: ' Nonne David latitat apud nos in locis tutissimis in Horesa, in colle Hachila, quae est ad meridiem deserti?"
,"20":"Nunc ergo, si desideravit anima tua, rex, ut descenderes, descende; nostrum autem erit ut tradamus eum in manus regis '."
,"21":"Dixitque Saul: ' Benedicti vos a Domino, quia doluistis vicem meam."
,"22":"Abite, oro, et diligentius praeparate et curiosius agite; et considerate locum, ubi sit pes eius, vel quis viderit eum ibi; dictum est enim ad me quod callidus sit valde."
,"23":"Considerate et videte omnia latibula eius, in quibus absconditur, et revertimini ad me ad certum locum, ut vadam vobiscum; quodsi fuerit in regione, perscrutabor eum in cunctis regionibus Iudae '."
,"24":"At illi surgentes abierunt in Ziph ante Saul. David autem et viri eius erant in deserto Maon, in Araba ad meridiem deserti. "
,"25":"Ivit ergo Saul et socii eius ad quaerendum eum, et nuntiatum est David; descenditque ad petram et versabatur in deserto Maon. Quod cum audisset Saul, persecutus est David in deserto Maon."
,"26":"Et ibat Saul ad latus montis ex parte una, David autem et viri eius erant in latere montis ex parte altera; porro David praeceps fugiebat a facie Saul. Itaque Saul et viri eius in modum coronae cingebant David et viros eius, ut caperent eos."
,"27":"Et nuntius venit ad Saul dicens: ' Festina et veni, quoniam infuderunt se Philisthim super terram '."
,"28":"Reversus est ergo Saul desistens persequi David; et perrexit in occursum Philisthinorum. Propter hoc vocaverunt locum illum: ' Petram dividentem '."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Ascendit ergo David inde et habitavit in locis tutissimis Engaddi."
,"2":"Cumque reversus esset Saul, postquam persecutus est Philisthaeos, nuntiaverunt ei dicentes: ' Ecce David in deserto est Engaddi '."
,"3":"Assumens ergo Saul tria milia electorum virorum ex omni Israel perrexit ad investigandum David et viros eius ad rupes ibicum."
,"4":"Et venit ad caulas ovium, quae se offerebant vianti. Eratque ibi spelunca, quam ingressus est Saul, ut purgaret ventrem; porro David et viri eius in interiore parte speluncae latebant. "
,"5":"Et dixerunt viri David ad eum: ' Ecce dies, de qua locutus est Dominus ad te: 'Ego trado tibi inimicum tuum, ut facias ei sicut placuerit in oculis tuis' '. Surrexit ergo David et praecidit oram chlamydis Saul silenter."
,"6":"Post haec cor David percussit eum, eo quod abscidisset oram chlamydis Saul,"
,"7":"dixitque ad viros suos: ' Propitius mihi sit Dominus, ne faciam hanc rem domino meo, christo Domini, ut mittam manum meam in eum, quoniam christus Domini est '."
,"8":"Et cohibuit David viros suos sermonibus et non permisit eos, ut consurgerent in Saul. Porro Saul exsurgens de spelunca pergebat coepto itinere. "
,"9":"Surrexit autem et David post eum et egressus de spelunca clamavit post tergum Saul dicens: ' Domine mi rex! '. Et respexit Saul post se, et inclinans se David pronus in terram adoravit"
,"10":"dixitque ad Saul: ' Quare audis verba hominum loquentium: 'David quaerit malum adversum te?'."
,"11":"Ecce hodie viderunt oculi tui quod tradiderit te Dominus hodie in manu mea in spelunca; et dictum est mihi, ut occiderem te, sed pepercit tibi oculus meus. Dixi enim: Non extendam manum meam in dominum meum, quia christus Domini est"
,"12":"et pater meus. Quin potius vide et cognosce oram chlamydis tuae in manu mea, quoniam, cum praeciderem summitatem chlamydis tuae, nolui occidere te. Animadverte et vide quoniam non est in manu mea malum neque iniquitas, neque peccavi in te; tu autem insidiaris animae meae, ut auferas eam."
,"13":"Iudicet Dominus inter me et te et ulciscatur me Dominus ex te; manus autem mea non sit in te."
,"14":"Sicut et in proverbio antiquo dicitur: 'Ab impiis egredietur impietas', manus ergo mea non sit in te."
,"15":"Quem sequitur rex Israel? Quem persequeris? Canem mortuum et pulicem unum."
,"16":"Sit Dominus iudex et iudicet inter me et te et videat et diiudicet causam meam et eruat me de manu tua '."
,"17":"Cum autem complesset David loquens sermones huiuscemodi ad Saul, dixit Saul: ' Numquid vox haec tua est, fili mi David? '. Et levavit Saul vocem suam et flevit."
,"18":"Dixitque ad David: ' Iustior tu es quam ego; tu enim tribuisti mihi bona, ego autem reddidi tibi mala."
,"19":"Et tu indicasti hodie, quae feceris mihi bona, quomodo tradiderit me Dominus in manu tua, et non occideris me."
,"20":"Quis enim, cum invenerit inimicum suum, dimittet eum in via bona? Sed Dominus reddat tibi vicissitudinem hanc, pro eo quod hodie operatus es in me."
,"21":"Et nunc, quia scio quod certissime regnaturus sis et habiturus in manu tua regnum Israel,"
,"22":"iura mihi in Domino, ne deleas semen meum post me neque auferas nomen meum de domo patris mei '."
,"23":"Et iuravit David Sauli. Abiit ergo Saul in domum suam, et David et viri eius ascenderunt ad praesidium."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Mortuus est autem Samuel; et congregatus est universus Israel, et planxerunt eum et sepelierunt eum in domo sua in Rama. Consurgensque David descendit in desertum Maon. "
,"2":"Erat autem vir quispiam in solitudine Maon, et possessio eius in Carmel; et homo ille magnus nimis; erantque ei oves tria milia et mille caprae. Et accidit ut tonderet gregem suum in Carmel."
,"3":"Nomen autem viri illius erat Nabal et nomen uxoris eius Abigail. Eratque mulier illa prudentissima et speciosa; porro vir eius durus et moribus malis; erat autem de genere Chaleb."
,"4":"Cum ergo audisset David in deserto quod tonderet Nabal gregem suum,"
,"5":"misit decem iuvenes et dixit eis: ' Ascendite in Carmel et venietis ad Nabal et salutabitis eum ex nomine meo pacifice"
,"6":"et dicetis fratri meo: 'Et tibi pax et domui tuae pax et omnibus, quaecumque habes, sit pax!"
,"7":"Et nunc audivi quod tonsores essent apud te. Pastores autem tui erant nobiscum in deserto; numquam eis molesti fuimus, nec aliquando defuit eis quidquam de grege omni tempore, quo fuerunt nobiscum in Carmel."
,"8":"Interroga pueros tuos, et indicabunt tibi. Nunc ergo inveniant pueri isti gratiam in oculis tuis, in die enim bona venimus; quodcumque invenerit manus tua, da servis tuis et filio tuo David' '."
,"9":"Cumque venissent pueri David, locuti sunt ad Nabal omnia verba haec ex nomine David et siluerunt."
,"10":"Respondens autem Nabal pueris David ait: ' Quis est David, et quis est filius Isai? Hodie increverunt servi, qui fugiunt dominos suos."
,"11":"Tollam ergo panes meos et aquas meas et carnes pecorum, quae occidi, tonsoribus meis et dabo viris, quos nescio unde sint? '."
,"12":"Regressi sunt itaque pueri David per viam suam et reversi venerunt et nuntiaverunt ei omnia verba haec."
,"13":"Tunc David ait viris suis: ' Accingatur unusquisque gladio suo! '. Et accincti sunt singuli gladio suo, accinctusque est et David ense suo, et secuti sunt David quasi quadringenti viri; porro ducenti remanserunt ad sarcinas."
,"14":"Abigail autem uxori Nabal nuntiavit unus de pueris suis dicens: ' Ecce misit David nuntios de deserto, ut benedicerent domino nostro, sed aversatus est eos."
,"15":"Homines isti boni satis fuerunt nobis et non molesti; nec quidquam aliquando periit omni tempore, quo sumus conversati cum eis in deserto."
,"16":"Pro muro erant nobis tam in nocte quam in die omnibus diebus, quibus pavimus apud eos greges."
,"17":"Quam ob rem considera et recogita quid facias, quoniam malum decretum est adversus dominum nostrum et adversus domum eius universam. Et ipse filius Belial est, ita ut nemo ei possit loqui '."
,"18":"Festinavit igitur Abigail et tulit ducentos panes et duos utres vini et quinque arietes coctos et quinque sata frumenti tosti et centum ligaturas uvae passae et ducentas massas caricarum et imposuit super asinos."
,"19":"Dixitque pueris suis: ' Praecedite me, ecce ego post tergum sequar vos '. Viro autem suo Nabal non indicavit."
,"20":"Cum ergo ascendisset asinum et descenderet in tegmine montis, David et viri eius descendebant in occursum eius; quibus et illa occurrit."
,"21":"Et aiebat David: ' Vere frustra servavi omnia, quae huius erant in deserto, et non periit quidquam de cunctis, quae ad eum pertinebant; et reddidit mihi malum pro bono."
,"22":"Haec faciat Deus inimicis David et haec addat, si reliquero de omnibus, quae ad eum pertinent, usque mane quidquid masculini sexus '."
,"23":"Cum autem vidisset Abigail David, festinavit et descendit de asino et procidit coram David super faciem suam et adoravit super terram."
,"24":"Et cecidit ad pedes eius et dixit: ' In me sit, domine mi, haec iniquitas; loquatur, obsecro, ancilla tua in auribus tuis, et audi verba famulae tuae."
,"25":"Ne ponat, oro, dominus meus cor suum super virum istum iniquum Nabal, quia secundum nomen suum stultus est, et est stultitia cum eo; ego autem ancilla tua non vidi pueros domini mei, quos misisti."
,"26":"Nunc ergo, domine mi, vivit Dominus, et vivit anima tua, quia Dominus prohibuit te, ne venires in sanguine et salvares te manu tua; et nunc fiant sicut Nabal inimici tui et qui quaerunt domino meo malum."
,"27":"Quapropter suscipe benedictionem hanc, quam attulit ancilla tua domino meo, et da pueris, qui sequuntur dominum meum."
,"28":"Aufer iniquitatem famulae tuae. Faciens enim faciet Dominus domino meo domum fidelem, quia proelia Domini dominus meus proeliatur; malitia ergo non inveniatur in te omnibus diebus vitae tuae."
,"29":"Si enim surrexerit aliquando homo persequens te et quaerens animam tuam, erit anima domini mei custodita in fasciculo vitae apud Dominum Deum tuum; sed inimicorum tuorum animam ipse iaciat in impetu et circulo fundae."
,"30":"Cum ergo fecerit Dominus domino meo omnia, quae locutus est, bona de te et constituerit te ducem super Israel,"
,"31":"non erit tibi hoc in singultum et in scrupulum cordis domino meo, quod effuderis sanguinem innoxium et ipse te ultus fueris; et cum benefecerit Dominus domino meo, recordaberis ancillae tuae '."
,"32":"Et ait David ad Abigail: ' Benedictus Dominus, Deus Israel, qui misit te hodie in occursum meum. Et benedicta prudentia tua,"
,"33":"et benedicta tu, quae prohibuisti me hodie, ne irem ad sanguinem et ulciscerer me manu mea."
,"34":"Alioquin, vivit Dominus, Deus Israel, qui prohibuit me malum facere tibi, nisi cito venisses in occursum mihi, non remansisset Nabal usque ad lucem matutinam quidquid masculini sexus '."
,"35":"Suscepit ergo David de manu eius omnia, quae attulerat ei, dixitque ei: ' Vade pacifice in domum tuam. Ecce audivi vocem tuam et honoravi faciem tuam '."
,"36":"Venit autem Abigail ad Nabal; et ecce erat ei convivium in domo eius quasi convivium regis, et cor Nabal iucundum; erat enim ebrius nimis. Et non indicavit ei verbum pusillum aut grande usque in mane."
,"37":"Diluculo autem, cum digessisset vinum Nabal, haec indicavit ei uxor sua; et emortuum est cor eius intrinsecus, et factus est quasi lapis."
,"38":"Cumque pertransissent decem dies, percussit Dominus Nabal, et mortuus est."
,"39":"Quod cum audisset David mortuum Nabal, ait: ' Benedictus Dominus, qui iudicavit causam opprobrii mei de manu Nabal et servum suum custodivit a malo et malitiam Nabal reddidit Dominus in caput eius '. Misit ergo David et locutus est ad Abigail, ut sumeret eam sibi in uxorem. "
,"40":"Et venerunt pueri David ad Abigail in Carmel et locuti sunt ad eam dicentes: ' David misit nos ad te, ut accipiat te sibi in uxorem '."
,"41":"Quae consurgens adoravit prona in terram et ait: ' Ecce famula tua sit in ancillam, ut lavet pedes servorum domini mei '."
,"42":"Et festinavit et surrexit Abigail et ascendit super asinum, et quinque puellae ierunt cum ea pedisequae eius; et secuta est nuntios David et facta est illi uxor."
,"43":"Sed et Achinoam accepit David de Iezrahel, et fuit utraque uxor eius."
,"44":"Saul autem dedit Michol filiam suam uxorem David Phalti filio Lais, qui erat de Gallim."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Et venerunt Ziphaei ad Saul in Gabaa dicentes: ' Ecce David absconditus est in colle Hachila, quae est ex adverso solitudinis '."
,"2":"Et surrexit Saul et descendit in desertum Ziph, et cum eo tria milia virorum de electis Israel, ut quaereret David in deserto Ziph."
,"3":"Et castrametatus est Saul in colle Hachila, quae erat ex adverso solitudinis in via. David autem habitabat in deserto; videns autem quod venisset Saul post se in desertum,"
,"4":"misit exploratores et didicit quod illuc venisset certissime."
,"5":"Et surrexit David et venit ad locum, ubi erat Saul. Cumque vidisset locum, in quo dormiebat Saul et Abner filius Ner princeps militiae eius, Saulem dormientem in carragine et reliquum vulgus per circuitum eius,"
,"6":"ait David ad Achimelech Hetthaeum et Abisai filium Sarviae fratrem Ioab dicens: ' Quis descendet mecum ad Saul in castra? '. Dixitque Abisai: ' Ego descendam tecum '."
,"7":"Venerunt ergo David et Abisai ad populum nocte et invenerunt Saul iacentem et dormientem in carragine et hastam fixam in terra ad caput eius, Abner autem et populum dormientes in circuitu eius."
,"8":"Dixitque Abisai ad David: ' Conclusit Deus hodie inimicum tuum in manus tuas; nunc ergo perfodiam eum lancea in terra semel, et secundo opus non erit '."
,"9":"Et dixit David ad Abisai: ' Ne interficias eum; quis enim extendit manum suam in christum Domini et innocens erit? '."
,"10":"Et dixit David: ' Vivit Dominus quia Dominus percutiet eum, aut dies eius veniet, ut moriatur, aut in proelium descendens peribit."
,"11":"Propitius mihi sit Dominus, ne extendam manum meam in christum Domini. Nunc igitur tolle hastam, quae est ad caput eius, et scyphum aquae, et abeamus '."
,"12":"Tulit ergo David hastam et scyphum aquae, qui erat ad caput Saul, et abierunt; et non erat quisquam, qui videret et intellegeret et vigilaret, sed omnes dormiebant, quia sopor Domini irruerat super eos."
,"13":"Cumque transisset David ex adverso et stetisset in vertice montis de longe, et esset grande intervallum inter eos,"
,"14":"clamavit David ad populum et ad Abner filium Ner dicens: ' Nonne respondebis, Abner? '. Et respondens Abner ait: ' Quis es tu? Clamasti ad regem! '."
,"15":"Et ait David ad Abner: ' Numquid non vir tu es? Et quis alius similis tui in Israel? Quare ergo non custodisti dominum tuum regem? Ingressus est enim unus de turba, ut interficeret regem dominum tuum."
,"16":"Non est bonum hoc, quod fecisti. Vivit Dominus quoniam filii mortis estis vos, qui non custodistis dominum vestrum, christum Domini. Nunc ergo vide, ubi sit hasta regis et ubi scyphus aquae, qui erat ad caput eius '."
,"17":"Cognovit autem Saul vocem David et dixit: ' Num vox tua haec est, fili mi David? '. Et ait David: ' Vox mea, domine mi rex '."
,"18":"Et ait: ' Quam ob causam dominus meus persequitur servum suum? Quid feci? Aut quod est in manu mea malum?"
,"19":"Nunc ergo audiat, oro, dominus meus rex verba servi sui: Si Dominus incitat te adversum me, odoretur sacrificium; si autem filii hominum, maledicti sint in conspectu Domini, quia eiecerunt me hodie, ut non habitem in hereditate Domini dicentes: 'Vade, servi diis alienis'."
,"20":"Et nunc non effundatur sanguis meus in terra longe a facie Domini; quia egressus est rex Israel, ut quaerat pulicem unum, sicut persequitur quis perdicem in montibus '."
,"21":"Et ait Saul: ' Peccavi. Revertere, fili mi David; nequaquam enim ultra malefaciam tibi, eo quod pretiosa fuerit anima mea in oculis tuis hodie; apparet quod stulte egerim et erraverim multum nimis '."
,"22":"Et respondens David ait: ' Ecce hasta regis; transeat unus de pueris et tollat eam."
,"23":"Dominus autem retribuet unicuique secundum iustitiam suam et fidem; tradidit enim te Dominus hodie in manu mea, et nolui extendere manum meam in christum Domini."
,"24":"Et sicut magnificata est anima tua hodie in oculis meis, sic magnificetur anima mea in oculis Domini, et liberet me de omni angustia '."
,"25":"Ait ergo Saul ad David: ' Benedictus tu, fili mi David; et quidem faciens facies et potens poteris '. Abiit autem David in viam suam, et Saul reversus est in locum suum."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Et ait David in corde suo: ' Aliquando incidam in uno die in manu Saul; nonne melius est ut fugiam et salver in terra Philisthinorum, ut desperet Saul cessetque me quaerere in cunctis finibus Israel? Fugiam ergo manus eius '."
,"2":"Et surrexit David et abiit ipse et sescenti viri cum eo ad Achis filium Maoch regem Geth."
,"3":"Et habitavit David cum Achis in Geth ipse et viri eius unusquisque cum domo sua; David et duae uxores eius, Achinoam Iezrahelites et Abigail uxor Nabal de Carmel."
,"4":"Et nuntiatum est Saul quod fugisset David in Geth, et non addidit ultra ut quaereret eum."
,"5":"Dixit autem David ad Achis: ' Si inveni gratiam in oculis tuis, detur mihi locus in una urbium regionis huius, ut habitem ibi. Cur enim manet servus tuus in civitate regis tecum? '."
,"6":"Dedit itaque ei Achis in die illa Siceleg; propter quam causam facta est Siceleg regum Iudae usque in diem hanc."
,"7":"Fuit autem numerus dierum, quibus habitavit David in regione Philisthinorum, annus et quattuor menses."
,"8":"Et ascendit David et viri eius et agebant praedas de Gesuri et de Gerzi et de Amalecitis; hae enim gentes habitabant terram, quae est a Telem in via Sur et usque ad terram Aegypti."
,"9":"Et percutiebat David omnem terram nec relinquebat viventem virum et mulierem; tollensque oves et boves et asinos et camelos et vestes revertebatur et veniebat ad Achis."
,"10":"Dicebat autem ei Achis: ' In quem irruistis hodie? '. Respondebatque David: ' Contra Nageb Iudae vel contra Nageb Ierameel vel contra Nageb Ceni '."
,"11":"Viro et mulieri non parcebat David nec adducebat in Geth dicens: ' Ne forte loquantur adversum nos: 'Haec fecit David' '. Et hoc erat decretum illi omnibus diebus, quibus habitavit in regione Philisthinorum."
,"12":"Credidit ergo Achis David dicens: ' Valde odiosum se fecit populo suo Israel; erit,igitur mihi servus sempiternus '. "
}`)
	CurrentBook.AddChapter(28, `{
"1":"Factum est autem in diebus illis, congregaverunt Phili sthim agmina sua, ut praepararentur ad bellum contra Israel. Dixitque Achis ad David: ' Sciens nunc scito quoniam mecum egredieris in castris tu et viri tui '."
,"2":"Dixitque David ad Achis: ' Ideo tu quoque scies, quae facturus est servus tuus '. Et ait Achis ad David: ' Ideo custodem capitis mei ponam te cunctis diebus '."
,"3":"Samuel autem mortuus erat; planxeratque eum omnis Israel, et sepelierant eum in Rama urbe sua. Et Saul abstulerat magos et hariolos de terra."
,"4":"Congregatique sunt Philisthim et venerunt et castrametati sunt in Sunam. Congregavit autem et Saul universum Israel, et castrametati sunt in Gelboe."
,"5":"Et vidit Saul castra Philisthim et timuit, et expavit cor eius nimis."
,"6":"Consuluitque Dominum, et non respondit ei neque per somnia neque per Urim neque per prophetas."
,"7":"Dixitque Saul servis suis: ' Quaerite mihi mulierem habentem pythonem, et vadam ad eam et sciscitabor per illam '. Et dixerunt servi eius ad eum: ' Est mulier habens pythonem in Endor '."
,"8":"Mutavit ergo habitum suum vestitusque est aliis vestimentis et abiit ipse et duo viri cum eo; veneruntque ad mulierem nocte, et ait: ' Divina mihi in pythone et suscita mihi, quem dixero tibi '."
,"9":"Et ait mulier ad eum: ' Ecce tu nosti, quanta fecerit Saul et quomodo eraserit magos et hariolos de terra; quare ergo insidiaris animae meae, ut occidar? '."
,"10":"Et iuravit ei Saul in Domino dicens: ' Vivit Dominus quia non veniet tibi quidquam mali propter hanc rem '."
,"11":"Dixitque ei mulier: ' Quem suscitabo tibi? '. Qui ait: ' Samuelem suscita mihi '."
,"12":"Cum autem vidisset mulier Samuelem, exclamavit voce magna et dixit ad Saul: ' Quare imposuisti mihi? Tu es enim Saul! '."
,"13":"Dixitque ei rex: ' Noli timere. Quid vidisti? '. Et ait mulier ad Saul: ' Hominem divinum vidi ascendentem de terra '."
,"14":"Dixitque ei: ' Qualis est forma eius? '. Quae ait: ' Vir senex ascendit et ipse amictus est pallio '. Intellexit Saul quod Samuel esset et inclinavit se super faciem suam in terra et adoravit."
,"15":"Dixit autem Samuel ad Saul: ' Quare inquietasti me, ut suscitarer? '. Et ait Saul: ' Coartor nimis. Siquidem Philisthim pugnant adversum me, et Deus recessit a me et exaudire me noluit neque in manu prophetarum neque per somnia; vocavi ergo te, ut ostenderes mihi quid faciam '."
,"16":"Et ait Samuel: ' Quid interrogas me, cum Dominus recesserit a te et factus est adversarius tuus?"
,"17":"Fecit enim Dominus, sicut locutus est in manu mea, et scidit regnum de manu tua et dedit illud proximo tuo David,"
,"18":"quia non oboedisti voci Domini neque fecisti iram furoris eius in Amalec. Idcirco quod pateris, fecit tibi Dominus hodie."
,"19":"Et dabit Dominus etiam Israel tecum in manu Philisthim; cras autem tu et filii tui mecum eritis, sed et castra Israel tradet Dominus in manu Philisthim '."
,"20":"Statimque Saul cecidit porrectus in terram; extimuerat enim verba Samuel, et robur non erat in eo, quia non comederat panem tota die illa et tota nocte illa."
,"21":"Accessit itaque mulier ad Saul et vidit quod conturbatus esset valde; dixitque ad eum: ' Ecce audivit ancilla tua vocem tuam, et posui animam meam in manu mea et oboedivi sermonibus tuis, quos locutus es ad me."
,"22":"Nunc igitur audi et tu vocem ancillae tuae, ut ponam coram te buccellam panis, et comedens convalescas, ut possis iter facere '."
,"23":"Qui renuit et ait: ' Non comedam '. Coegerunt autem eum servi sui et mulier; et tandem, audita voce eorum, surrexit de terra et sedit super lectum."
,"24":"Mulier autem illa habebat vitulum pascualem in domo; et festinavit et occidit eum, tollensque farinam miscuit eam et coxit azyma."
,"25":"Et posuit ante Saul et ante servos eius. Qui cum comedissent, surrexerunt et abierunt hac eadem nocte."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Congregata sunt ergo Philisthim universa agmina in Aphec; sed et Israel castrametatus est super fontem, qui erat in Iezrahel."
,"2":"Et principes quidem Philisthim incedebant in centuriis et milibus; David autem et viri eius incedebant in novissimo agmine cum Achis."
,"3":"Dixeruntque principes Philisthim: ' Quid sibi volunt Hebraei isti? '. Et ait Achis ad principes Philisthim: ' Nonne iste est David, qui fuit servus Saul regis Israel et est apud me multis diebus vel annis, et non inveni in eo quidquam ex die, qua transfugit ad me, usque ad diem hanc? '."
,"4":"Irati sunt autem adversus eum principes Philisthim et dixerunt ei: ' Revertatur vir iste et sedeat in loco suo, in quo constituisti eum, et non descendat nobiscum in proelium, ne fiat nobis adversarius, cum proeliari coeperimus. Quomodo enim aliter placare poterit dominum suum nisi in capitibus horum virorum?"
,"5":"Nonne iste est David, cui cantabant in choris dicentes: 'Percussit Saul milia sua, et David decem milia sua'? '."
,"6":"Vocavit ergo Achis David et ait ei: ' Vivit Dominus quia rectus es tu, et bonus est in conspectu meo exitus tuus et introitus tuus mecum in castris, et non inveni in te quidquam mali ex die, qua venisti ad me, usque ad diem hanc. Sed principibus non places."
,"7":"Revertere ergo et vade in pace et non offendes oculos principum Philisthim '."
,"8":"Dixitque David ad Achis: ' Quid enim feci, et quid invenisti in me servo tuo a die, qua fui in conspectu tuo, usque in diem hanc, ut non veniam et pugnem contra inimicos domini mei regis? '."
,"9":"Respondens autem Achis locutus est ad David: ' Scio quia bonus es tu in oculis meis sicut angelus Dei; sed principes Philisthim dixerunt: 'Non ascendet nobiscum in proelium'."
,"10":"Igitur consurge mane, tu et servi domini tui, qui venerunt tecum, et, cum de nocte surrexeritis et coeperit dilucescere, pergite '."
,"11":"Surrexit itaque de nocte David ipse et viri eius, ut proficiscerentur mane et reverterentur ad terram Philisthim. Philisthim autem ascenderunt in Iezrahel."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Cumque venissent David et viri eius in Siceleg die tertia, Amalecitae impetum fecerant contra Nageb et contra Siceleg et percusserant Siceleg et succenderant eam igni;"
,"2":"et captivas duxerant mulieres et omnes in ea a minimo usque ad magnum et non interfecerant quemquam, sed secum duxerant et pergebant in itinere suo."
,"3":"Cum ergo venisset David et viri eius ad civitatem et invenissent eam succensam igni et uxores suas et filios suos et filias ductas esse captivas,"
,"4":"levaverunt David et populus, qui erat cum eo, voces suas et planxerunt, donec deficerent in eis lacrimae."
,"5":"Siquidem et duae uxores David captivae ductae fuerant, Achinoam Iezrahelites et Abigail uxor Nabal de Carmel."
,"6":"Et angustiatus est David valde; volebat enim eum populus lapidare, quia amara erat anima uniuscuiusque viri super filiis suis et filiabus. Confortatus est autem David in Domino Deo suo"
,"7":"et ait ad Abiathar sacerdotem filium Achimelech: ' Applica ad me ephod '. Et applicuit Abiathar ephod ad David."
,"8":"Et consuluit David Dominum dicens: ' Persequar latrunculos hos et comprehendam eos an non? '. Dixitque ei: ' Persequere; absque dubio enim comprehendes eos et excuties praedam '."
,"9":"Abiit ergo David ipse et sescenti viri, qui erant cum eo, et venerunt usque ad torrentem Besor, et lassi quidam substiterunt."
,"10":"Persecutus est autem David ipse et quadringenti viri; et reliqui substiterunt: ducenti, qui lassi transire non poterant torrentem Besor."
,"11":"Et invenerunt virum Aegyptium in agro et adduxerunt eum ad David; dederuntque ei panem, et comedit, et dederunt ei aquam bibere,"
,"12":"sed et dederunt ei fragmen massae caricarum et duas ligaturas uvae passae. Quae cum comedisset, reversus est spiritus eius; non enim comederat panem neque biberat aquam tribus diebus et tribus noctibus."
,"13":"Dixit itaque ei David: ' Cuius es tu vel unde? '. Qui ait ei: ' Puer Aegyptius ego sum servus viri Amalecitae; dereliquit autem me dominus meus, quia aegrotare coepi nudiustertius."
,"14":"Siquidem nos erupimus contra Nageb Cherethi et contra Nageb Iudae et Nageb Chaleb et Siceleg succendimus igni '."
,"15":"Dixitque ei David: ' Potes me ducere ad istum cuneum? '. Qui ait: ' Iura mihi per Deum quod non occidas me et non tradas me in manu domini mei, et ducam te ad cuneum istum '. Et iuravit ei David."
,"16":"Qui cum duxisset eum, ecce illi discumbebant super faciem universae terrae comedentes et bibentes et festum celebrantes pro cuncta praeda et spoliis, quae ceperant de terra Philisthim et de terra Iudae."
,"17":"Et percussit eos David die altera a diluculo usque ad vesperam, et non evasit ex eis quisquam, nisi quadringenti viri adulescentes, qui ascenderant camelos et fugerant."
,"18":"Eruit ergo David omnia, quae ceperant Amalecitae, et duas uxores suas eruit."
,"19":"Nec defuit quidquam a parvo usque ad magnum tam de filiis quam de filiabus et de spoliis, et, quaecumque rapuerant, omnia reduxit David."
,"20":"Cepit ergo David universos greges et armenta, et minaverunt ante faciem eius possessionem hanc dixeruntque: ' Haec est praeda David '."
,"21":"Venit autem David ad ducentos viros, qui lassi substiterant nec sequi potuerant David, et residere eos iusserat in torrente Besor. Qui egressi sunt obviam David et populo, qui erat cum eo. Accedens autem David ad populum salutavit eos pacifice."
,"22":"Respondensque omnis vir pessimus et iniquus de viris, qui ierant cum David, dixit: ' Quia non venerunt nobiscum, non dabimus eis quidquam de praeda, quam eruimus; sed sufficiat unicuique uxor sua et filii; quos cum acceperint, recedant '."
,"23":"Dixit autem David: ' Non sic facietis, fratres mei, de his, quae tradidit Dominus nobis, et custodivit nos et dedit latrunculos, qui eruperant adversum nos, in manu nostra;"
,"24":"nec audiet vos quisquam super sermone hoc; aequa enim pars erit descendentis ad proelium et remanentis ad sarcinas, et similiter divident '."
,"25":"Et factum est hoc ex die illa et deinceps constitutum ut praeceptum et quasi lex in Israel usque ad diem hanc."
,"26":"Venit ergo David in Siceleg et misit dona de praeda senioribus Iudae proximis suis dicens: ' Accipite benedictionem de praeda hostium Domini ';"
,"27":"his, qui erant in Bethul et qui in Ramathnageb et qui in Iether"
,"28":"et qui in Aroer et qui in Sephamoth et qui in Esthemo"
,"29":"et qui in Carmel et qui in urbibus Ierameeli et qui in urbibus Ceni"
,"30":"et qui in Horma et qui in Borasan et qui in Athach"
,"31":"et qui in Hebron et reliquis locis, in quibus commoratus fuerat David ipse et viri eius."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Philisthim autem pugnabant adversum Israel; et fugerunt viri Israel ante faciem Philisthim et ceciderunt interfecti in monte Gelboe."
,"2":"Irrueruntque Philisthim in Saul et filios eius et percusserunt Ionathan et Abinadab et Melchisua filios Saul."
,"3":"Totumque pondus proelii versum est in Saul; et consecuti sunt eum viri arcu, et vulneratus est vehementer a sagittariis."
,"4":"Dixitque Saul ad armigerum suum: ' Evagina gladium tuum et percute me, ne forte veniant incircumcisi isti et confodiant me et illudant mihi '. Et noluit armiger eius; erat enim nimio timore perterritus. Arripuit itaque Saul gladium et irruit super eum."
,"5":"Quod cum vidisset armiger eius, videlicet quod mortuus esset Saul, irruit etiam ipse super gladium suum et mortuus est cum eo."
,"6":"Mortuus est ergo Saul et tres filii eius et armiger illius et universi viri eius in die illa pariter."
,"7":"Videntes autem viri Israel, qui erant trans vallem et trans Iordanem, quod fugissent viri Israelitae et quod mortuus esset Saul et filii eius, reliquerunt civitates suas et fugerunt. Veneruntque Philisthim et habitaverunt ibi."
,"8":"Facta autem die altera, venerunt Philisthim, ut spoliarent interfectos, et invenerunt Saul et tres filios eius iacentes in monte Gelboe."
,"9":"Et praeciderunt caput Saul et exspoliaverunt eum armis, quae miserunt in terram Philisthinorum per circuitum, ut annuntiaretur in templis idolorum suorum et populo."
,"10":"Et posuerunt arma eius in templo Astharoth, corpus vero eius suspenderunt in muro Bethsan."
,"11":"Quod cum audissent habitatores Iabes Galaad, quaecumque fecerant Philisthim Saul,"
,"12":"surrexerunt omnes viri fortissimi et ambulaverunt tota nocte et tulerunt cadaver Saul et cadavera filiorum eius de muro Bethsan; veneruntque Iabes et combusserunt ea ibi."
,"13":"Et tulerunt ossa eorum et sepelierunt sub myrice in Iabes et ieiunaverunt septem diebus."
}`)

}
func LA_NVBSE_LoadVH2MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Fratribus, qui sunt per Aegyp tum, Iudaeis salutem dicunt fratres, qui sunt in Hierosolymis Iudaei et qui in regione Iudaeae, pacem bonam."
,"2":"Et benefaciat vobis Deus et meminerit testamenti sui, quod locutus est ad Abraham et Isaac et Iacob servorum suorum fidelium;"
,"3":"et det vobis cor omnibus, ut colatis eum et faciatis eius voluntatem corde magno et animo volenti;"
,"4":"et adaperiat cor vestrum in lege sua et in praeceptis suis et faciat pacem;"
,"5":"et exaudiat orationes vestras et reconcilietur vobis nec vos deserat in tempore malo."
,"6":"Et nunc hic sumus orantes pro vobis."
,"7":"Regnante Demetrio, anno centesimo sexagesimo nono, nos Iudaei scripsimus vobis in tribulatione et impetu, qui supervenit nobis in istis annis, ex quo recessit Iason et, qui cum eo erant, a sancta terra et a regno"
,"8":"et portam succenderunt et effuderunt sanguinem innocentem; et oravimus ad Dominum et exauditi sumus et obtulimus sacrificia et similaginem et accendimus lucernas et proposuimus panes."
,"9":"Et nunc ut frequentetis dies Scenopegiae mensis Casleu,"
,"10":"anno centesimo octogesimo octavo. Qui sunt Hierosolymis et in Iudaea, senatusque et Iudas Aristobulo magistro Ptolemaei regis, qui est de genere christorum sacerdotum, et his, qui in Aegypto sunt, Iudaeis salutem et sanitatem. "
,"11":"De magnis periculis a Deo liberati magnifice gratias agimus ipsi, utpote qui adversus regem dimicavimus;"
,"12":"ipse enim effervere fecit eos, qui pugnaverunt contra sanctam civitatem."
,"13":"Nam cum in Perside esset dux ipse et qui cum ipso videbatur esse intolerabilis exercitus, concisi sunt in templo Naneae, fraude utentibus sacerdotibus Naneae."
,"14":"Etenim quasi cum ea habitaturus venit ad locum Antiochus et, qui cum ipso erant, amici, ut acciperet pecunias multas dotis nomine."
,"15":"Cumque proposuissent eas sacerdotes Naneae, et ipse cum paucis ingressus esset intra ambitum fani, clauserunt templum; cum intrasset Antiochus,"
,"16":"aperto occulto aditu laquearis, mittentes lapides percusserunt ducem et diviserunt membratim et, capitibus amputatis, foras proiecerunt."
,"17":"Per omnia benedictus Deus, qui tradidi"
,"18":"Facturi igitur quinta et vicesima die mensis Casleu purificationem templi, necessarium duximus significare vobis, ut et vos quoque agatis diem Scenopegiae et ignis, qui datus est, quando Nehemias, aedificato templo et altari, obtulit sacrificia."
,"19":"Nam cum in Persidem ducerentur patres nostri, sacerdotes, qui tunc cultores Dei erant, acceptum ignem de altari occulte absconderunt in cavo putei situm habentis siccum, in quo contutati sunt eum, ita ut omnibus ignotus esset locus."
,"20":"Cum autem praeterissent anni multi, et placuit Deo, ut mitteretur Nehemias a rege Persidis, nepotes sacerdotum illorum, qui absconderant, misit ad ignem."
,"21":"Sicut narraverunt nobis, non invenerunt ignem sed aquam crassam. Et iussit eos haurire et afferre. Utque imposita sunt sacrificia, iussit sacerdotes Nehemias aspergere aqua et ligna et, quae erant superposita."
,"22":"Utque hoc factum est, et tempus transiit, et sol refulsit, qui prius erat in nubilo, accensus est ignis magnus, ita ut omnes mirarentur."
,"23":"Orationem autem faciebant sacerdotes, dum consummaretur sacrificium: et sacerdotes et omnes, Ionatha inchoante, ceteris autem respondentibus ut Nehemias."
,"24":"Erat autem oratio hunc habens modum: ' Domine, Domine Deus, omnium creator, terribilis et fortis, iustus et misericors, qui solus es rex et bonus,"
,"25":"solus praestans, solus iustus et omnipotens et aeternus; qui liberas Israel de omni malo, qui fecisti patres electos et sanctificasti eos,"
,"26":"accipe sacrificium pro universo populo tuo Israel et custodi partem tuam et sanctifica."
,"27":"Congrega dispersionem nostram, libera eos, qui serviunt gentibus, et contemptos et abominatos respice, ut sciant gentes quia tu es Deus noster."
,"28":"Afflige opprimentes nos et contumeliam facientes in superbia."
,"29":"Constitue populum tuum in loco sancto tuo, sicut dixit Moyses '."
,"30":"Sacerdotes autem psallebant hymnos."
,"31":"Cum autem consumptum esset sacrificium, ex residua aqua Nehemias iussit lapides maiores perfundi"
,"32":"quod ut factum est, flamma accensa est, sed a lumine, quod refulsit ex altari, consumpta est."
,"33":"Ut vero manifestata est res, et renuntiatum est regi Persarum quod in loco, in quo ignem absconderant hi, qui translati fuerant, sacerdotes, aqua apparuit, de qua Nehemias et, qui cum eo erant, purificaverunt ea, quae essent sacrificii,"
,"34":"circumsaepiens autem rex et rem diligenter examinans, templum fecit."
,"35":"Et quibus gratificabatur rex, multa dona accipiebat et tribuebat."
,"36":"Appellaverunt autem, qui cum Nehemia erant, hunc locum Nephthar, quod interpretatur Purificatio; vocatur autem apud plures Nephthai."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Invenitur autem in descriptio nibus quod Ieremias propheta iussit eos ignem accipere, qui transmigrabant, ut significatum est,"
,"2":"et ut mandavit propheta transmigratis dans illis legem, ne obliviscerentur praecepta Domini et ut non exerrarent mentibus videntes simulacra aurea et argentea et ornamenta eorum."
,"3":"Et alia huiusmodi dicens hortabatur, ne legem amoverent a corde suo."
,"4":"Erat autem in ipsa scriptura quomodo tabernaculum et arcam iussit propheta, divino responso ad se facto, comitari secum, usquequo exiit in montem, in quo Moyses ascendit et vidit Dei hereditatem."
,"5":"Et veniens Ieremias invenit domum speluncae; et tabernaculum et arcam et altare incensi intulit illuc et ostium obstruxit."
,"6":"Et accesserunt quidam ex his, qui simul sequebantur, ut notarent viam, et non potuerunt invenire."
,"7":"Ut autem cognovit Ieremias, culpans illos dixit quod ignotus erit locus, donec congreget Deus congregationem populi et misericordia fiat;"
,"8":"et tunc Dominus ostendet haec, et apparebit maiestas Domini, et nubes erit, sicut et sub Moyse manifestabatur, sicut et Salomon petiit, ut locus sanctificaretur magnifice."
,"9":"Manifestabatur autem et ut sapientiam habens obtulit sacrificium dedicationis et consummationis templi."
,"10":"Sicut et Moyses orabat ad Dominum, et descendit ignis de caelo et consumpsit sacrificia, sic et Salomon oravit, et descendit ignis de caelo et consumpsit holocausta."
,"11":"Et dixit Moyses: ' Eo quod non sit comestum, quod erat pro peccato, consumptum est '."
,"12":"Similiter et Salomon octo dies celebravit."
,"13":"Inferebantur autem in descriptionibus et commentariis secundum Nehemiam haec eadem, et ut construens bibliothecam congregavit libros de regibus et prophetis et libros David et epistulas regum de donariis."
,"14":"Similiter autem et Iudas ea, quae deciderant per bellum, quod nobis acciderat, congregavit omnia, et sunt apud nos."
,"15":"Si ergo desideratis haec, mittite, qui perferant vobis."
,"16":"Acturi itaque purificationem, scripsimus vobis; bene ergo facietis, si egeritis hos dies."
,"17":"Deus autem, qui liberavit universum populum suum et reddidit hereditatem omnibus et regnum et sacerdotium et sanctificationem,"
,"18":"sicut promisit in lege. Speramus enim in Deo quod cito nostri miserebitur et congregabit de sub caelo in locum sanctum; eripuit enim nos de magnis periculis et locum purgavit."
,"19":"De Iuda vero Maccabaeo et fratribus eius et de templi magni purificatione et de arae dedicatione,"
,"20":"sed et de proeliis, quae pertinent ad Antiochum Epiphanem et filium eius Eupatorem,"
,"21":"et de illuminationibus, quae de caelo factae sunt ad eos, qui generose pro Iudaismo fortiter fecerunt, ita ut universam regionem, cum pauci essent, vindicarent et barbaram multitudinem fugarent"
,"22":"et famosissimum in toto orbe templum recuperarent et civitatem liberarent et leges, quae futurum erat ut abolerentur, restituerentur, Domino cum omni clementia propitio facto illis,"
,"23":"quae omnia ab Iasone Cyrenaeo quinque libris declarata sunt, tentavimus nos uno volumine breviare."
,"24":"Considerantes enim multitudinem numerorum et difficultatem, quae adest volentibus aggredi narrationes historiarum propter multitudinem rerum,"
,"25":"curavimus volentibus quidem legere, ut esset animi oblectatio, studiosis vero, ut facilius possint memoriae commendare, omnibus autem legentibus utilitas conferatur."
,"26":"Et nobis quidem ipsis, qui hoc opus breviandi causa suscepimus, non facilem laborem, immo vero negotium plenum vigiliarum et sudoris assumpsimus."
,"27":"Sicut praeparanti convivium et quaerenti aliorum utilitatem non facile est, tamen propter multorum gratiam libenter laborem sustinebimus,"
,"28":"accurate quidem de singulis elaborare auctori concedentes, ipsi autem persequi datam formam brevitati studentes."
,"29":"Sicut enim novae domus architecto de universa structura curandum est, ei vero, qui inurere et pingere curat, quae apta sunt ad ornatum exquirenda sunt, ita aestimo et in nobis."
,"30":"Inire quidem et deambulacrum facere verborum et curiosius partes singulas quasque disquirere historiae congruit auctori;"
,"31":"brevitatem vero dictionis sectari et exsecutionem rerum vitare brevianti concedendum est."
,"32":"Hinc ergo narrationem incipiemus, praedictis tantulo subiuncto; stultum etenim est ante historiam efffluere, ipsam autem historiam concidere."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Cum sancta civitas habitaretur cum omni pace, et leges quam optime custodirentur propter Oniae pontificis pietatem et odium malitiae,"
,"2":"fiebat ut et ipsi reges locum honorarent et templum maximis muneribus illustrarent,"
,"3":"ita ut Seleucus quoque Asiae rex de redditibus suis praestaret omnes sumptus ad ministeria sacrificiorum pertinentes."
,"4":"Simon autem de tribu Belgae praepositus templi constitutus dissentiebat a principe sacerdotum de dispensatione in civitate."
,"5":"Et cum vincere Oniam non posset, venit ad Apollonium Tharseae filium, qui eo tempore erat dux Coelesyriae et Phoenicis,"
,"6":"et nuntiavit pecuniis inenarrabilibus plenum esse aerarium Hierosolymis, ita ut multitudo vectigalium innumerabilis esset et ea non pertinere ad rationem sacrificiorum; esse autem possibile sub potestate regis haec cadere."
,"7":"Collocutus autem Apollonius cum rege, de indicatis sibi pecuniis aperuit; at ille vocans Heliodorum, qui erat super negotia, misit datis mandatis, ut praedictam pecuniam transportaret."
,"8":"Statimque Heliodorus iter est aggressus, specie quidem quasi per Coelesyriam et Phoenicen civitates esset peragraturus, re vera autem regis propositum perfecturus."
,"9":"Sed cum venisset Hierosolymam et benigne a summo sacerdote civitatis esset exceptus, narravit de dato indicio, et cuius rei gratia adesset aperuit; interrogabat autem, si vere haec ita essent."
,"10":"Tunc summus sacerdos ostendit deposita esse viduarum et pupillorum;"
,"11":"quaedam vero esse Hircani Thobiae, viri valde eminentis, non sicut detulerat obtrectans impius Simon; universa autem argenti talenta esse quadringenta et auri ducenta;"
,"12":"decipi vero eos, qui credidissent loci sanctitati et honorati per universum mundum templi venerationi inviolabili tutelae, omnino impossibile esse."
,"13":"At ille, pro his, quae habebat, mandatis a rege, omnino dicebat in regium fiscum ea esse deferenda."
,"14":"Constituta autem die, intrabat de his visitationem ordinaturus. Non modica vero per universam civitatem erat trepidatio."
,"15":"Sacerdotes autem ante altare cum stolis sacerdotalibus iactaverunt se et invocabant in caelum eum, qui de deposito legem posuit, ut his, qui deposuerant, ea salva custodiret."
,"16":"Erat autem, ut qui videret summi sacerdotis vultum, mente vulneraretur; facies enim et color immutatus declarabat internum animi dolorem."
,"17":"Circumfusus enim erat metus quidam viro, et horror corporis, unde manifestus aspicientibus dolor instans cordi efficiebatur."
,"18":"Alii autem de domibus gregatim prosiliebant ad publicam supplicationem, pro eo quod in contemptum locus esset venturus."
,"19":"Accinctaeque mulieres ciliciis sub mammis per vias confluebant; sed et virgines, quae conclusae erant, aliae quidem procurrebant ad ianuas, aliae autem ad muros, quaedam vero per fenestras aspiciebant;"
,"20":"universae autem protendentes manus in caelum deprecabantur."
,"21":"Erat enim misereri commixtae multitudinis prostrationem et summi sacerdotis in magna agonia constituti exspectationem."
,"22":"Et hi quidem invocabant omnipotentem Dominum, ut credita salva his, qui crediderant, conservaret cum omni tutela."
,"23":"Heliodorus autem, quod fuerat decretum, perficiebat."
,"24":"Eodem loco, ipso cum satellitibus circa aerarium praesente, spirituum et omnis potestatis Dominus magnam fecit ostensionem, ita ut omnes, qui ausi fuerant convenire, perterriti virtute Dei in dissolutionem et formidinem converterentur."
,"25":"Apparuit enim illis quidam equus terribilem habens sessorem et optimo operimento adornatus; isque cum impetu invectus Heliodoro priores calces impegit; qui autem supersedebat, videbatur arma habere aurea."
,"26":"Alii etiam apparuerunt duo iuvenes virtute decori, optimi gloria speciosique amictu, qui etiam circumsteterunt eum et ex utraque parte flagellabant sine intermissione multas inferentes ei plagas."
,"27":"Subito autem concidit in terram; eumque multa caligine circumfusum rapuerunt atque in sellam gestatoriam imposuerunt;"
,"28":"et eum, qui cum multis cursoribus et satellitibus praedictum ingressus erat aerarium, portabant carentem auxilio ex armis constitutum, manifeste Dei virtutem cognoscentem."
,"29":"Et ille quidem per divinam virtutem iacebat mutus atque omni spe et salute privatus;"
,"30":"hi autem Dominum benedicebant, qui magnificabat locum suum; et templum, quod paulo ante timore ac tumultu erat plenum, apparente omnipotente Domino, gaudio et laetitia impletum est."
,"31":"Confestim vero ex amicis Heliodori quidam rogabant Oniam, ut invocaret Altissimum, ut vitam donaret ei, qui prorsus in supremo spiritu erat constitutus."
,"32":"Suspectus autem factus summus sacerdos, ne forte rex opinaretur malitiam aliquam ex Iudaeis circa Heliodorum consummatam, obtulit hostiam pro salute viri."
,"33":"Cumque summus sacerdos litationem perficeret, iidem iuvenes rursus apparuerunt Heliodoro eisdem vestibus amicti et astantes dixerunt: ' Oniae summo sacerdoti multas gratias age, nam propter eum Dominus tibi vitam donavit;"
,"34":"tu autem a caelo flagellatus nuntia omnibus magnam Dei potestatem '. Et his dictis, non comparuerunt."
,"35":"Heliodorus autem, hostia Domino oblata et votis magnis promissis ei, qui vivere concessit, et Oniam acceptum habens cum exercitu repedavit ad regem;"
,"36":"testabatur autem omnibus ea, quae sub oculis suis viderat, opera maximi Dei."
,"37":"Cum autem rex interrogasset Heliodorum, quis esset aptus adhuc semel Hierosolymam mitti, ait:"
,"38":"' Si quem habes hostem aut rerum insidiatorem, mitte eum illuc et flagellatum eum recipies, si tamen evaserit, eo quod in loco sit vere Dei quaedam virtus;"
,"39":"nam ipse, qui habet in caelis habitationem, visitator et adiutor est loci illius et venientes ad malefaciendum percutit ac perdit '."
,"40":"Igitur de Heliodoro et aerarii custodia ita res processerunt."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Simon autem praedictus, qui pecuniarum et patriae delator exstitit, male loquebatur de Onia, tamquam ipse Heliodorum instigasset et malorum auctor fuisset;"
,"2":"benefactoremque civitatis et curatorem gentis suae et aemulatorem legum audebat insidiatorem rerum dicere."
,"3":"Sed cum inimicitia in tantum procederet, ut etiam per quendam eorum, qui a Simone probati essent, homicidia fierent,"
,"4":"considerans Onias periculum contentionis et Apollonium Menesthei, ducem Coelesyriae et Phoenicis, augentem malitiam Simonis,"
,"5":"ad regem se contulit, non ut civium accusator, sed quod utile esset in commune et singulariter universae multitudinis prospiciens."
,"6":"Videbat enim sine regali providentia impossibile esse pacem adhuc rebus obtingere, nec Simonem cessaturum a stultitia."
,"7":"Sed post Seleuci vitae excessum, cum suscepisset regnum Antiochus, qui Epiphanes appellabatur, ambiebat Iason frater Oniae summum sacerdotium,"
,"8":"promittens regi per interpellationem argenti talenta trecenta sexaginta et ex reditu quodam alio talenta octoginta;"
,"9":"super haec autem promittebat et alia centum quinquaginta se perscripturum, si concederetur per potestatem eius gymnasium et ephebiam sibi constituere et eos, qui in Hierosolymis erant, Antiochenos scribere."
,"10":"Quod cum rex annuisset, et obtinuisset principatum, statim ad Graecam consuetudinem contribules suos transferre coepit."
,"11":"Et, amotis his, quae humanitatis causa Iudaeis a regibus fuerant constituta per Ioannem patrem Eupolemi, qui apud Romanos de amicitia et societate functus est legatione, et legitima civium iura destituens, pravos mores innovabat."
,"12":"Prompte enim sub ipsa arce gymnasium constituit et optimos quosque epheborum subigens sub petasum ducebat."
,"13":"Erat autem sic culmen quoddam Graecae conversationis et profectus alienigenarum moris, propter impii et non summi sacerdotis Iasonis inauditam contaminationem,"
,"14":"ita ut sacerdotes iam non circa altaris officia dediti essent, sed contempto templo et sacrificiis neglectis, festinarent participes fieri iniquae in palaestra praebitionis post disci provocationem"
,"15":"et patrios quidem honores nihil habentes, Graecas autem glorias optimas aestimantes."
,"16":"Quarum gratia periculosa eos contentio habebat, et quorum instituta aemulabantur ac per omnia consimiles esse cupiebant, hos hostes et ultores habuerunt."
,"17":"In leges enim divinas impie agere non est facile, sed haec tempus sequens declarabit."
,"18":"Cum autem quinquennalis agon Tyri celebraretur, et rex praesens esset,"
,"19":"misit Iason facinorosus ab Hierosolymis spectatores Antiochenses portantes argenti drachmas trecentas in sacrificium Herculis; quas etiam postulaverunt hi, qui asportaverant, ne in sacrificium erogarentur, quia non oporteret, sed in alium sumptum eas deputari."
,"20":"Sed haec ceciderunt: propter illum quidem, qui miserat, in sacrificium Herculis; propter eos autem, qui afferebant, in fabricam triremium."
,"21":"Misso autem in Aegyptum Apollonio Menesthei filio propter ascensum ad solium Philometoris regis, cum cognovisset Antiochus alienum se ab illius negotiis effectum, propriae securitati consuluit; inde cum Ioppen venisset, se contulit Hierosolymam."
,"22":"Et magnifice ab Iasone et civitate susceptus, cum facularum luminibus et acclamationibus introductus est; deinde sic in Phoenicen exercitum convertit."
,"23":"Et post triennii tempus misit Iason Menelaum supradicti Simonis fratrem portantem pecunias regi et de negotiis necessariis commonitiones perlaturum."
,"24":"At ille commendatus regi, cum se magnificasset facie potestatis, in semetipsum contulit summum sacerdotium superponens Iasoni talenta argenti trecenta;"
,"25":"acceptisque regiis mandatis, venit nihil quidem gerens dignum sacerdotio, animos vero crudelis tyranni et ferae barbarae iram habens."
,"26":"Et Iason quidem, qui proprium fratrem circumvenerat, ipse circumventus ab alio profugus in Ammanitem expulsus est regionem."
,"27":"Menelaus autem principatum quidem obtinuit; de pecuniis vero regi promissis nihil debite agebat,"
,"28":"cum vero exactionem faceret Sostratus, qui arci erat praepositus, nam ad hunc exactio vectigalium pertinebat. Quam ob causam utrique a rege sunt advocati;"
,"29":"et Menelaus quidem reliquit summi sacerdotii successorem Lysimachum fratrem suum, Sostratus autem Cratetem, qui praeerat Cypriis."
,"30":"Talibus autem constitutis, contigit Tarsenses et Mallotas seditionem movere, eo quod Antiochidi, regis concubinae, dono essent dati."
,"31":"Festinanter itaque rex venit sedare illos, relicto suffecto uno ex iis in dignitate constitutis Andronico."
,"32":"Ratus autem Menelaus accepisse se tempus opportunum, aurea quaedam vasa e templo furatus donavit Andronico; et alia vendiderat Tyri et per vicinas civitates."
,"33":"Quod cum certissime cognovisset Onias, arguebat eum, ipse in loco tuto se continens in Daphne secus Antiochiam."
,"34":"Unde Menelaus seorsum apprehendens Andronicum rogabat, ut Oniam interficeret. At vero ille, cum venisset ad Oniam et cum fidem dolo dedisset ac dexteram accepisset dedissetque cum iureiurando, quamvis esset ei suspectus, suasit de asylo procedere, quem statim peremit, non veritus iustitiam."
,"35":"Ob quam causam non solum Iudaei, sed multi quoque ex aliis nationibus indignabantur et moleste ferebant de nece viri iniusta."
,"36":"Sed regressum regem de Ciliciae locis interpellabant, qui erant per civitatem Iudaei, simul et Graecis scelus conquerentibus, de eo quod sine ratione Onias interfectus esset."
,"37":"Contristatus itaque animo Antiochus et flexus ad misericordiam lacrimas fudit, propter defuncti sobrietatem et multam modestiam;"
,"38":"accensusque animis, confestim ablata Andronici purpura ac tunicis eius discissis, circumduxit per totam civitatem usque ad eundem locum, in quo in Oniam impietatem commiserat, atque illic sacrilegum interfectorem e mundo sustulit, Domino illi condignam retribuente poenam."
,"39":"Multis autem sacrilegiis per civitatem a Lysimacho commissis Menelai consilio, et divulgata foris fama, congregata est multitudo adversum Lysimachum, vasis aureis iam multis dissipatis."
,"40":"Turbis autem insurgentibus et ira repletis, Lysimachus, armatis fere tribus milibus, iniquis manibus coepit, duce quodam Aurano, aetate non minus ac dementia provecto."
,"41":"Sed ut intellexerunt conatum Lymachi, alii lapides, alii fustes validos arripuere, quidam vero ex adiacente cinere manu apprehenderunt et mixtim iecerunt in eos, qui circa Lysimachum erant."
,"42":"Quam ob causam multos quidem vulneraverunt, quosdam autem et prostraverunt, omnes vero in fugam compulerunt; ipsum vero sacrilegum secus aerarium interfecerunt."
,"43":"De his ergo coepit iudicium adversus Menelaum agitari."
,"44":"Et cum venisset rex Tyrum, apud ipsum causam egerunt missi tres viri a senatu."
,"45":"Et cum iam superaretur Menelaus, promisit Ptolemaeo Dorymenis multas pecunias ad suadendum regi."
,"46":"Unde Ptolemaeus, excipiens seorsum in quoddam atrium columnatum quasi refrigerandi gratia regem, deduxit a sententia."
,"47":"Et Menelaum quidem universae malitiae reum criminibus absolvit; miseros autem, qui etiam si apud Scythas causam dixissent, innocentes iudicarentur, hos morte damnavit."
,"48":"Cito ergo iniustam poenam dederunt, qui pro civitate et populo et sacris vasis causam prosecuti sunt."
,"49":"Quam ob rem Tyrii quoque in malefactum indignati, quaeque ad sepulturam eorum necessaria essent, magno sumptu praestiterunt."
,"50":"Menelaus autem propter eorum, qui in potentia erant, avaritiam permanebat in potestate, crescens in malitia magnus civium insidiator constitutus."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Circa hoc autem tempus Anti ochus secundam profectionem paravit in Aegyptum."
,"2":"Contigit autem per universam civitatem fere per dies quadraginta videri per aera equites discurrentes, auratas stolas habentes et hastas, ad modum cohortium armatos, et gladiorum evaginationes"
,"3":"et turmas equorum per ordinem digestas et congressiones fieri et decursus utrorumque et scutorum motus et contorum multitudinem et telorum iactus et aureorum ornamentorum fulgores omnisque generis loricationes."
,"4":"Quapropter omnes rogabant pro bono factam esse ostensionem."
,"5":"Sed cum falsus rumor exisset, tamquam vita excessisset Antiochus, assumptis Iason non minus mille viris repente aggressus est civitatem; illis autem, qui erant in muro, compulsis in fugam et ad ultimum iam apprehensa civitate, Menelaus fugit in arcem."
,"6":"Iason vero caedes civium suorum perpetrabat nulli parcens, non intellegens prosperitatem adversum cognatos calamitatem esse maximam, arbitrans autem hostium et non civium se trophaea constituere."
,"7":"Et principatum quidem non obtinuit, finem vero insidiarum suarum confusionem adeptus, profugus iterum abiit in Ammanitidem."
,"8":"Ad ultimum igitur malam reversionem sortitus est; conclusus apud Aretam Arabum tyrannum, fugiens de civitate in civitatem, expulsus ab omnibus, odiosus ut refuga legum et exsecrabilis ut patriae et civium carnifex in Aegyptum extrusus est."
,"9":"Et, qui multos de patria expulerat, peregre periit ad Lacedaemonios pervectus, quasi pro cognatione habiturus protectionem;"
,"10":"et, qui insepultos multos abiecerat, ipse illamentatus permansit nec exsequiis ullis neque patrio sepulcro participavit."
,"11":"Cum autem nuntia ad regem pervenissent de his, quae gesta erant, suspicatus est rex a societate defecturam Iudaeam; et ob hoc profectus ex Aegypto efferatus animo, civitatem quidem armis cepit"
,"12":"et iussit militibus interficere occursantes nemini parcendo et eos, qui in domos ascenderent, trucidare."
,"13":"Fiebant ergo iuvenum ac seniorum caedes, mulierum et natorum exterminium virginumque et parvulorum neces."
,"14":"Erant autem toto triduo octoginta milia perditi, quadraginta quidem milia in ipso manuum conflictu; non minus autem quam qui iugulati fuerant, venumdati sunt."
,"15":"Non contentus autem his, ausus est intrare templum universae terrae sanctissimum, ducem habens Menelaum, qui legum et patriae fuit proditor,"
,"16":"et scelestis manibus sumens sancta vasa et, quae ab aliis regibus et civitatibus erant posita ad augmentum et gloriam loci et honorem, profanis manibus contrectans."
,"17":"Ita extollebatur mente Antiochus non considerans quod propter peccata habitantium civitatem modicum Dominus fuerat iratus; propter quod accidit circa locum despectio."
,"18":"Alioquin nisi contigisset eos multis peccatis esse involutos, sicut Heliodorus, qui missus est a Seleuco rege ad inspectionem aerarii, et ipse, mox ut accessisset, confestim flagellatus repulsus fuisset ab audacia."
,"19":"Verum non propter locum gentem, sed propter gentem locum Dominus elegit."
,"20":"Ideoque et ipse locus particeps factus populi malorum, postea factus est socius beneficiorum; et, qui derelictus in ira Omnipotentis est, iterum in magni Domini reconciliatione cum omni gloria restitutus est."
,"21":"Igitur Antiochus mille et octingentis ablatis de templo talentis, velocius Antiochiam regressus est, existimans se prae superbia terram ad navigandum, pelagus vero ad ambulandum deducturum propter mentis elationem."
,"22":"Reliquit autem et praepositos ad affligendam gentem: Hierosolymis quidem Philippum, genere Phrygem, moribus barbariorem eo ipso, a quo constitutus est;"
,"23":"in Garizim autem Andronicum; praeter autem hos Menelaum, qui gravius quam ceteri imminebat civibus."
,"24":"Misit autem Apollonium Mysarcham cum exercitu - viginti vero et duo milia virorum - praecipiens omnes perfectae aetatis interficere, mulieres autem ac iuniores vendere."
,"25":"Qui cum venisset Hierosolymam et pacificum se simulasset, quievit usque ad diem sanctum sabbati et, cum comprehenderet feriatos Iudaeos, arma capere suis praecepit;"
,"26":"omnesque, qui ad spectaculum processerant, trucidavit et civitatem cum armatis discurrens ingentem multitudinem peremit."
,"27":"Iudas autem, qui et Maccabaeus, decimus factus secesserat in eremum et ferarum more in montibus vitam cum suis agebat; et feni cibo vescentes demorabantur, ne participes essent coinquinationis."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Sed non post multum temporis misit rex senem quendam Athe niensem, qui compelleret Iudaeos, ut se transferrent a patriis legibus et Dei legibus ne uterentur;"
,"2":"contaminare etiam, quod in Hierosolymis erat, templum et cognominare Iovis Olympii, et in Garizim, prout erant hi, qui locum inhabitabant, Iovis Hospitalis."
,"3":"Pessima autem et universis gravis erat malorum incursio."
,"4":"Nam templum luxuria et comissationibus gentium erat plenum, scortantium cum meretricibus et in sacratis porticibus mulieribus adhaerentium, insuper et intro inferentium ea, quae non licebat;"
,"5":"altare etiam plenum erat illicitis, quae legibus prohibebantur."
,"6":"Neque autem sabbata custodiebantur, neque dies sollemnes patrii servabantur, nec simpliciter Iudaeum se esse quisquam confitebatur."
,"7":"Ducebantur autem cum amara necessitate per singulos menses in die natalis regis ad sacrificium et, cum Liberi sacra celebrarentur, cogebantur hedera coronati pompam Libero celebrare."
,"8":"Decretum autem exiit in proximas Graecorum civitates, suggerente Ptolemaeo, ut pari modo et ipsi adversus Iudaeos agerent, ut sacrificarent;"
,"9":"eos autem, qui nollent transire ad instituta Graecorum, interficerent; erat ergo videre instantem miseriam."
,"10":"Duae enim mulieres delatae sunt natos suos circumcidisse; quas infantibus ad ubera suspensis, cum publice per civitatem circumduxissent, per muros praecipitaverunt."
,"11":"Alii vero ad proximas coeuntes speluncas, ut latenter septimam diem celebrarent, cum indicati essent Philippo, flammis succensi sunt, eo quod verebantur propter religionem sibimet auxilium ferre pro claritate sanctissimi diei."
,"12":"Obsecro autem eos, qui hunc librum lecturi sunt, ne abhorrescant propter adversos casus, sed reputent illas poenas non ad interitum, sed ad correptionem esse generis nostri."
,"13":"Etenim multo tempore non sinere eos, qui gerunt impie, sed statim ultiones adhibere, magni beneficii est indicium."
,"14":"Non enim, sicut et in aliis nationibus, Dominus patienter ferens exspectat, ut eas, cum pervenerint in plenitudinem peccatorum, puniat, ita et in nobis statuit esse,"
,"15":"ne, peccatis nostris in finem devolutis, demum in nos vindicet;"
,"16":"propter quod numquam quidem a nobis misericordiam suam amovet, corripiens vero per aerumnas populum suum non derelinquit."
,"17":"Sed haec nobis ad commonitionem dicta sint; paucis autem veniendum est ad narrationem."
,"18":"Eleazarus quidam, unus de primoribus scribarum, vir iam aetate provectus et aspectu faciei decorus, aperto ore compellebatur carnem porcinam manducare."
,"19":"At ille magis cum illustri fama mortem quam cum exsecratione vitam complectens, voluntarie praeibat ad supplicium,"
,"20":"exspuens autem, quemadmodum oportet accedere eos, qui sustinent non admittere illa, quae non est fas gustare, propter nimium vivendi amorem."
,"21":"Hi autem, qui iniquo sacrificio praepositi erant, propter antiquam cum viro amicitiam tollentes eum secreto rogabant, ut afferret carnes, quibus uti ei liceret quaeque ab ipso paratae essent, et fingeret se eas manducare, quas rex imperaverat de sacrificii carnibus,"
,"22":"ut hoc facto a morte liberaretur et propter veterem cum illis amicitiam consequeretur humanitatem."
,"23":"At ille, consilio decoro inito ac digno aetate et senectutis eminentia et acquisita nobilique canitie atque optima a puero vitae disciplina, magis autem sancta et a Deo condita legislatione, consequenter sententiam ostendit: cito, dicens, dimitterent ad inferos."
,"24":"' Non enim aetati nostrae dignum est fingere, ut multi adulescentium arbitrantes Eleazarum nonaginta annorum transisse ad morem alienigenarum"
,"25":"et ipsi propter meam simulationem et propter modicum et pusillum vitae tempus decipiantur propter me, et exsecrationem atque maculam meae senectuti conquiram."
,"26":"Nam etsi in praesenti tempore evasero eam, quae ex hominibus est, poenam, manus tamen Omnipotentis nec vivus nec defunctus effugiam."
,"27":"Quam ob rem viriliter nunc vita excedendo, senectute quidem dignus apparebo;"
,"28":"adulescentibus autem exemplum forte reliquero, ut prompto animo ac fortiter pro sacris ac sanctis legibus honesta morte perfungantur '. Et cum haec dixisset, confestim ad supplicium venit;"
,"29":"ipsis autem, qui eum ducebant, illam, quam paulo ante habuerant erga eum benevolentiam, in iram convertentibus, propterea quod sermones dicti, sicut ipsi arbitrabantur, essent amentia."
,"30":"Cumque coepisset plagis mori, ingemiscens dixit: ' Domino, qui habet sanctam scientiam, manifestum est quia cum a morte possem liberari, duros secundum corpus sustineo dolores flagellatus, secundum animam vero propter ipsius timorem libenter haec patior '."
,"31":"Et iste quidem hoc modo vita decessit, non solum iuvenibus, sed et plurimis ex gente mortem suam ad exemplum fortitudinis et memoriam virtutis relinquens."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Contigit autem et septem fra tres una cum matre apprehen sos compelli a rege attingere contra fas carnes porcinas, flagris et nervis cruciatos."
,"2":"Unus autem ex illis exstans prior locutor sic ait: ' Quid es quaesiturus, et quid vis discere a nobis? Parati sumus mori magis quam patrias leges praevaricari '."
,"3":"Iratus itaque rex iussit sartagines et ollas succendi."
,"4":"Quibus statim succensis, iussit ei, qui prior illorum fuerat locutus, amputari linguam et, cute capitis abstracta, summas quoque manus et pedes ei praescindi, ceteris eius fratribus et matre inspicientibus."
,"5":"Et cum iam per omnia inutilis factus esset, iussit eum igne admoveri adhuc spirantem et torreri in sartagine. Cum autem vapor sartaginis diu diffunderetur, ceteri una cum matre invicem se hortabantur mori fortiter ita dicentes:"
,"6":"' Dominus Deus aspicit et veritate in nobis consolatur, quemadmodum per personam contestantis cantici declaravit Moyses: 'Et in servis suis consolabitur' '."
,"7":"Mortuo itaque illo primo hoc modo, sequentem deducebant ad illudendum; et cute capitis eius cum capillis abstracta, interrogabant, si manducaret prius quam toto corpore per membra singula puniretur."
,"8":"At ille respondens patria voce dixit: ' Non faciam '. Propter quod et iste, sequenti loco, tormenta suscepit sicut primus."
,"9":"Et in ultimo spiritu constitutus, sic ait: ' Tu quidem, scelestissime, de praesenti vita nos perdis; sed rex mundi defunctos nos pro suis legibus in aeternam vitae resurrectionem suscitabit '."
,"10":"Post hunc tertius illudebatur; et linguam postulatus cito protulit et manus constanter extendit"
,"11":"et fortiter ait: ' E caelo ista possideo et propter illius leges haec ipsa despicio et ab ipso rursus me ea recepturum spero ',"
,"12":"ita ut rex et, qui cum ipso erant, mirarentur adulescentis animum, quomodo pro nihilo duceret cruciatus."
,"13":"Et hoc ita defuncto, quartum vexabant similiter torquentes;"
,"14":"et, cum iam esset ad mortem, sic ait: ' Potius est ab hominibus morti datos spem exspectare a Deo, iterum ab ipso resuscitandos; tibi enim resurrectio ad vitam non erit '."
,"15":"Et deinceps quintum, cum admovissent, vexabant;"
,"16":"at ille respiciens in eum dixit: ' Potestatem inter homines habens, cum sis corruptibilis, facis, quod vis; noli autem putare genus nostrum a Deo esse derelictum;"
,"17":"tu autem patienter sustine et videbis maiestatem virtutis ipsius, qualiter te et semen tuum torquebit '."
,"18":"Post hunc ducebant sextum, et is mori incipiens ait: ' Noli frustra errare; nos enim propter nosmetipsos haec patimur peccantes in Deum nostrum, et digna admiratione facta sunt in nobis:"
,"19":"tu autem ne existimes tibi impune futurum, quod contra Deum pugnare tentaveris '."
,"20":"Supra modum autem mater mirabilis et bona memoria digna, quae pereuntes septem filios sub unius diei tempore conspiciens bono animo ferebat propter spem, quam in Dominum habebat."
,"21":"Singulos illorum hortabatur voce patria, forti repleta sensu et femineam cogitationem masculino excitans animo, dicens ad eos:"
,"22":"' Nescio qualiter in utero meo apparuistis neque ego spiritum et vitam donavi vobis et singulorum vestrorum compagem non sum ego modulata;"
,"23":"sed enim mundi creator, qui formavit hominis nativitatem quique omnium invenit originem, et spiritum et vitam vobis iterum cum misericordia reddet, sicut nunc vosmetipsos despicitis propter leges eius '."
,"24":"Antiochus autem contemni se arbitratus, simul et exprobrantem dedignans vocem, cum adhuc adulescentior superesset, non solum verbis hortabatur, sed et cum iuramento affirmabat se divitem simul et beatum facturum, translatum a patriis legibus, et amicum habiturum et officia ei crediturum."
,"25":"Sed ad haec cum adulescens nequaquam intenderet, vocavit rex matrem et suadebat ei, ut adulescenti fieret suasor in salutem."
,"26":"Cum autem multis eam verbis esset hortatus, promisit suasuram se filio."
,"27":"Itaque inclinata ad illum, irridens crudelem tyrannum sic ait patria voce: ' Fili, miserere mei, quae te in utero novem mensibus portavi et lac triennio dedi et alui et in aetatem istam perduxi et nutricem me tibi exhibui."
,"28":"Peto, nate, ut aspicias ad caelum et terram et quae in ipsis sunt, universa videns intellegas quia non ex his, quae erant, fecit illa Deus; et hominum genus ita fit."
,"29":"Ne timeas carnificem istum, sed dignus fratribus tuis effectus suscipe mortem, ut in illa miseratione cum fratribus tuis te recipiam '."
,"30":"Cum haec illa adhuc diceret, ait adulescens: ' Quem sustinetis? Non oboedio praecepto regis, sed obtempero praecepto legis, quae data est patribus nostris per Moysen."
,"31":"Tu vero, qui inventor omnis malitiae factus es in Hebraeos, non effugies manus Dei."
,"32":"Nos enim pro peccatis nostris haec patimur;"
,"33":"et si nobis propter increpationem et correptionem ille vivens Dominus noster modicum iratus est, sed iterum reconciliabitur servis suis."
,"34":"Tu autem, o sceleste et omnium hominum flagitiosissime, noli frustra extolli elatus vanis spebus, in filios caeli levata manu;"
,"35":"nondum enim omnipotentis atque intuitoris Dei iudicium effugisti."
,"36":"Nam fratres nostri, modico nunc dolore sustentato, sub Dei testamentum aeternae vitae reciderunt; tu vero iudicio Dei iustas superbiae tuae poenas exsolves."
,"37":"Ego autem, sicut et fratres mei, et corpus et animam trado pro patriis legibus, invocans Deum maturius genti nostrae propitium fieri, teque cum tormentis et verberibus confiteri quod ipse est Deus solus;"
,"38":"in me vero et in fratribus meis restitit Omnipotentis ira, quae super omne genus nostrum iuste superducta est '."
,"39":"Tunc rex accensus ira in hunc super omnes crudelius desaevit, indigne ferens se derisum."
,"40":"Et hic itaque mundus obiit per omnia in Domino confidens."
,"41":"Novissima autem post filios et mater consumpta est."
,"42":"Igitur de sacrificiis et de nimiis crudelitatibus satis sit dictum."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Iudas vero Maccabaeus et, qui cum illo erant, introeuntes la tenter in castella convocabant cognatos; et eos, qui permanserunt in Iudaismo, assumentes, collegerunt circiter sex milia virorum."
,"2":"Et invocabant Dominum, ut respiceret in populum, qui ab omnibus calcabatur; et misereretur templo, quod contaminabatur ab impiis;"
,"3":"et misereretur etiam pereunti civitati et incipienti solo complanari et vocem sanguinis ad se clamantis exaudiret;"
,"4":"memoraretur quoque iniquas mortes parvulorum innocentum et blasphemias nomini suo illatas et indignaretur super his."
,"5":"At Maccabaeus, congregata multitudine, intolerabilis iam gentibus efficiebatur, ira Domini in misericordiam conversa."
,"6":"Et civitates et castella superveniens improvisus succendebat et opportuna loca occupans non paucos hostium in fugam convertens,"
,"7":"maxime noctes in huiusmodi excursus cooperantes captabat. Et fama virtutis eius ubique diffundebatur."
,"8":"Videns autem Philippus paulatim virum ad profectum venire ac frequentius in prosperitatibus procedere, ad Ptolemaeum ducem Coelesyriae et Phoenicis scripsit, ut auxilium ferret regis negotiis."
,"9":"At ille velociter sumpsit Nicanorem Patrocli de primoribus amicis et misit, datis ei de permixtis gentibus armatis non minus viginti milibus, ut universum Iudaeorum genus deleret; adiunxit autem ei et Gorgiam virum militarem et in bellicis rebus expertum."
,"10":"Constituit autem Nicanor, ut regi tributum, quod Romanis erat dandum, duo milia talentorum de captivitate Iudaeorum suppleret;"
,"11":"statimque ad maritimas civitates misit convocans ad coemptionem Iudaicorum mancipiorum, promittens se nonaginta mancipia talento distracturum, non exspectans vindictam, quae eum ab Omnipotente esset consecutura."
,"12":"Iudas autem, ubi comperit de Nicanoris adventu, indicavit his, qui secum erant, exercitus praesentiam."
,"13":"Ex quibus quidam formidantes et non credentes Dei iustitiae in fugam vertebantur et in alios locos seipsos transferebant;"
,"14":"alii vero omnia, quae eis supererant, vendebant simulque Dominum deprecabantur, ut eriperet eos, qui ab impio Nicanore, prius quam comminus venirent, venumdati essent:"
,"15":"et si non propter eos, sed tamen propter testamenta ad patres eorum et propter invocationem sancti et magnifici nominis eius super ipsos."
,"16":"Convocatis autem Maccabaeus sex milibus, qui cum ipso erant, rogabat ne ab hostibus perterrerentur neque metuerent inique venientium adversum se gentium multitudinem, sed fortiter contenderent,"
,"17":"ante oculos habentes contumeliam, quae in locum sanctum ab his iniuste esset consummata, itemque et ludibrio habitae civitatis iniuriam, adhuc etiam veterum instituta convulsa."
,"18":"' Nam illi quidem armis confidunt, ait, simul et audacia; nos autem in omnipotente Deo, qui potest et venientes adversum nos et universum mundum uno nutu delere, confidimus '."
,"19":"Cum autem admonuisset eos et de auxiliis, quae facta sunt erga parentes, et de illo sub Sennacherib, ut centum octoginta quinque milia perierunt,"
,"20":"et de illo in Babilonia, in proelio quod eis adversus Galatas fuit, ut omnes ad rem venerunt, octo milia cum quattuor milibus Macedonum - Macedonibus haesitantibus, ipsi octo milia peremerunt centum viginti milia propter auxilium illis datum de caelo et beneficia plurima consecuti sunt C;"
,"21":"quibus verbis cum eos constantes effecisset et paratos pro legibus et patria mori, in quattuor quasdam partes exercitum divisit."
,"22":"Constitutis itaque fratribus suis ducibus uniuscuiusque ordinis, Simone et Iosepho et Ionatha, subiectis unicuique millenis et quingentenis,"
,"23":"insuper et Eleazaro, lecto sancto libro et dato signo adiutorii Dei, primae cohortis ipse ductor commisit cum Nicanore."
,"24":"Et facto sibi adiutore Omnipotente, interfecerunt super novem milia hostium, saucios autem et membris debilitatos maiorem partem exercitus Nicanoris reddiderunt, omnes vero fugere compulerunt."
,"25":"Pecunias autem eorum, qui ad emptionem illorum advenerant, abstulerunt et, cum persecuti eos fuissent satis longe, reversi sunt hora conclusi;"
,"26":"nam erat ante sabbatum, quam ob causam non perseveraverunt insequentes eos."
,"27":"Cum autem ipsorum arma collegissent spoliisque hostes exuissent, circa sabbatum versabantur impensius benedicentes et confitentes Domino, qui liberavit eos in isto die misericordiae initium constituens in eos."
,"28":"Post sabbatum vero debilitatis et viduis et orphanis portione de spoliis data, residua ipsi cum pueris partiti sunt."
,"29":"His itaque gestis et communi facta obsecratione, misericordem Dominum postulabant, ut in finem servis suis reconciliaretur."
,"30":"Et contendentes cum his, qui cum Timotheo et Bacchide erant, super viginti milia eorum interfecerunt et munitiones excelsas facile obtinuerunt; et plures praedas diviserunt, aequaliter seipsos participes cum debilitatis et orphanis et viduis, sed et senioribus facientes."
,"31":"Et cum arma eorum diligenter collegissent, omnia composuerunt in locis opportunis; residua vero spolia Hierosolymam detulerunt."
,"32":"Et phylarchen eorum, qui cum Timotheo erant, interfecerunt, virum scelestissimum, qui in multis Iudaeos afflixerat;"
,"33":"et cum epinicia agerent in patria, eos, qui sacras ianuas incenderant, et Callisthenem succenderunt, qui in quoddam domicilium fugerat; et dignam pro impietate mercedem tulit."
,"34":"Facinorosissimus autem Nicanor, qui mille negotiantes ad Iudaeorum venditionem adduxerat,"
,"35":"humiliatus ab his, qui secundum ipsum exsistimabantur exigui esse, auxilio Domini, deposita veste gloriae, per mediterranea fugitivi more solitarius effectus venit Antiochiam, super omnia prosperatus in interitu exercitus."
,"36":"Et, qui Romanis promiserat se tributum de captivitate Hierosolymorum redigere, praedicabat propugnatorem habere Iudaeos, et hoc modo invulnerabiles esse, eo quod sequerentur leges ab ipso constitutas."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Eodem autem tempore Anti ochus inhoneste revertebatur de regionibus circa Persidem."
,"2":"Intraverat enim in eam, quae dicitur Persepolis, et tentavit exspoliare templum et civitatem opprimere; quapropter, multitudine ad armorum auxilium concurrente, in fugam versi sunt; et contigit ut Antiochus in fugam versus ab indigenis turpiter rediret."
,"3":"Et cum esset circa Ecbatana, nuntiata sunt ea, quae erga Nicanorem et Timotheum gesta sunt."
,"4":"Elatus autem ira arbitrabatur se etiam iniuriam illorum, qui se fugaverant, in Iudaeos retorquere; ideoque iussit, ut auriga sine intermissione iter perficeret, caelesti iam eum comitante iudicio. Ita enim superbe locutus erat: ' Congeriem sepulcri Iudaeorum Hierosolymam faciam, cum venero illo '."
,"5":"Sed qui universa conspicit, Dominus, Deus Israel, percussit eum insanabili et invisibili plaga; et continuo ut is finivit sermonem, apprehendit eum dolor dirus viscerum et amara internorum tormenta,"
,"6":"perquam iuste, quippe qui multis et novis cruciatibus aliorum torserat viscera."
,"7":"Ille vero nullo modo ab arrogantia cessabat; super hoc autem superbia repletus erat, ignem spirans animo in Iudaeos et praecipiens iter accelerari. Contigit autem, ut et ille caderet de curru, qui ferebatur impetu, et gravi lapsu corruens in omnibus corporis membris vexaretur."
,"8":"Isque, qui nuper videbatur fluctibus maris imperare propter super hominem iactantiam et in statera montium altitudines appendere, humiliatus ad terram in gestatorio portabatur manifestam Dei virtutem omnibus ostendens,"
,"9":"ita ut de oculis impii vermes scaturirent, ac viventis in doloribus et maeroribus carnes eius diffluerent, illiusque odore totus exercitus gravaretur propter putredinem."
,"10":"Et qui paulo ante sidera caeli contingere se arbitrabatur, eum nemo poterat propter intolerabilem foetoris gravitatem portare."
,"11":"Hinc igitur coepit multum superbiae deponere confractus et ad agnitionem venire divina plaga, per momenta doloribus extensus."
,"12":"Et, cum nec ipse foetorem suum ferre posset, ita ait: ' Iustum est subditum esse Deo et mortalem non superbe sentire '."
,"13":"Orabat autem hic scelestus Dominum, ei non amplius miserturum, ita dicens:"
,"14":"sanctam quidem civitatem, ad quam festinans veniebat, ut eam solo aequalem faceret ac sepulcrum congestorum strueret, liberam ostendere;"
,"15":"Iudaeos autem, quos decreverat nec sepultura quidem se dignos habiturum, sed avibus devorandos cum parvulis se feris proiecturum, omnes hos aequales Atheniensibus facturum;"
,"16":"templum vero sanctum, quod prius exspoliaverat, pulcherrimis donis ornaturum et sacra vasa multiplicia cuncta se redditurum, et pertinentes ad sacrificia sumptus de redditibus suis praestaturum;"
,"17":"super haec autem et Iudaeum se futurum et omnem locum habitabilem perambulaturum praedicantem Dei potestatem."
,"18":"Sed omnino non cessantibus doloribus - supervenerat enim in eum iustum Dei iudicium - semetipsum desperans scripsit ad Iudaeos hanc infra rescriptam epistulam modum deprecationis habentem, haec continentem:"
,"19":"' Optimis civibus Iudaeis plurimam salutem et bene valere et esse felices, rex et dux Antiochus."
,"20":"Si bene valetis et filii vestri, et res vestrae ex sententia sunt vobis, precans refero quidem Deo maximam gratiam, in caelum spem habens;"
,"21":"ego vero in infirmitate constitutus eram, vestri autem honoris et benevolentiae memineram cum affectione. Reversus de Persidis locis et in infirmitatem incidens molestiam habentem, necessarium duxi pro communi omnium securitate curam habere."
,"22":"Non desperans memetipsum, sed spem multam habens effugiendi infirmitatem,"
,"23":"respiciens autem quod et pater meus, quibus temporibus in superiora loca duxit exercitum, ostendit, qui susciperet principatum;"
,"24":"ut, si quid contrarium accideret aut etiam quid difficile nuntiaretur, scientes hi, qui circa regionem erant, cui esset rerum summa derelicta, non turbarentur."
,"25":"Ad haec autem considerans de proximo potentes et vicinos regno temporibus insidiantes et eventum exspectantes, designavi filium Antiochum regem, quem saepe recurrens in superiora regna plurimis vestrum committebam et commendabam; et scripsi ad eum, quae subiecta sunt."
,"26":"Oro itaque vos et peto memores beneficiorum publice et privatim, ut unusquisque conservet hanc, quam habetis benevolentiam in me et in filium."
,"27":"Confido enim eum modeste et humane, sequentem propositum meum, vobiscum acturum '."
,"28":"Igitur homicida et blasphemus pessima perpessus, ut ipse alios tractaverat, peregre in montibus miserabili obitu vita functus est."
,"29":"Transferebat autem corpus Philippus collactaneus eius, qui etiam metuens filium Antiochi ad Ptolemaeum Philometorem in Aegyptum se contulit."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Maccabaeus autem et, qui cum eo erant, Domino eos praeeunte, templum quidem et civitatem receperunt;"
,"2":"aras autem, quas alienigenae per plateam exstruxerant, itemque delubra demoliti sunt"
,"3":"et, purgato templo, aliud altare fecerunt et, succensis lapidibus igneque de his concepto, sacrificia obtulerunt post biennium et incensum et lucernas et panum propositionem fecerunt."
,"4":"Quibus autem gestis, rogaverunt Dominum prostrati in ventrem, ne amplius talibus malis inciderent, sed et, si quando peccassent, ut ab ipso cum clementia corriperentur et non blasphemis ac barbaris gentibus traderentur."
,"5":"Qua die autem templum ab alienigenis pollutum fuerat, contigit eadem die purificationem fieri templi vicesima quinta illius mensis, qui est Casleu."
,"6":"Et cum laetitia diebus octo egerunt in modum Tabernaculorum, recordantes quod ante modicum temporis diem sollemnem Tabernaculorum in montibus et in speluncis more bestiarum egerant."
,"7":"Propter quod thyrsos et ramos virides, adhuc et palmas habentes, hymnos tollebant ei, qui prosperavit mundari locum suum."
,"8":"Et decreverunt communi praecepto et decreto universae genti Iudaeorum omnibus annis agere dies istos."
,"9":"Res itaque de fine Antiochi, qui appellatus est Epiphanes, ita se habuerunt."
,"10":"Nunc autem res de Antiocho Eupatore, qui vero filius erat impii, narrabimus, illa breviantes, quae continent bellorum mala."
,"11":"Hic enim, suscepto regno, constituit super negotia regni Lysiam quendam Coelesyriae et Phoenicis ducem primarium."
,"12":"Nam Ptolemaeus, qui dicebatur Macron, quod esset iustum conservare praeferens erga Iudaeos propter in eos factam iniquitatem, conabatur, quae ad illos spectabant, pacifice peragere."
,"13":"Unde accusatus ab amicis apud Eupatorem et cum frequenter se proditorem esse audiret, eo quod Cyprum creditam sibi a Philometore deseruisset et ad Antiochum Epiphanem transiisset, cumque amplius nobilem potestatem digne ferre non posset, veneno hausto vitam finivit."
,"14":"Gorgias autem, cum esset dux locorum, externos milites alebat et frequenter adversus Iudaeos bellum instruebat."
,"15":"Atque una cum ipso etiam Idumaei, qui tenebant opportunas munitiones, exercebant Iudaeos et fugatos ab Hierosolymis suscipientes bellum alere tentabant."
,"16":"Hi vero, qui erant cum Maccabaeo, supplicatione facta et rogato Deo, ut esset sibi adiutor, impetum fecerunt in munitiones Idumaeorum;"
,"17":"quas fortiter aggressi, loca obtinuerunt et omnes, qui pugnabant in muris, propulerunt et occurrentes interemerunt et non minus viginti milibus trucidaverunt."
,"18":"Quidam autem, cum confugissent non minus quam novem milia in duas turres valde munitas et omnia ad repugnandum habentes,"
,"19":"Maccabaeus, ad eorum expugnationem relicto Simone et Iosepho itemque Zacchaeo eisque, qui cum ipso erant satis multis, ipse ad ea, quae amplius perurgebant, loca discessit."
,"20":"Hi vero, qui cum Simone erant, cupiditate ducti a quibusdam, qui in turribus erant, suasi sunt pecunia et, septuaginta milibus drachmis acceptis, dimiserunt quosdam effugere."
,"21":"Cum autem Maccabaeo nuntiatum esset quod factum est, principibus populi congregatis accusavit quod pecunia fratres vendidissent, adversariis eorum dimissis."
,"22":"Hos igitur proditores factos interfecit et confestim duas turres occupavit."
,"23":"Armis autem in manibus omnia prospere agendo in duabus munitionibus plus quam viginti milia peremit."
,"24":"At Timotheus, qui prius a Iudaeis fuerat superatus, convocatis peregrinis copiis valde multis et congregatis equis, qui erant ex Asia, non paucis, adfuit quasi armis victam Iudaeam capturus."
,"25":"Qui autem cum Maccabaeo erant, appropinquante illo, ad supplicationem Dei terra capita aspergentes lumbosque ciliciis praecincti"
,"26":"super crepidinem contra altare provoluti rogabant, ut sibi propitius factus inimicis eorum esset inimicus et adversariis adversaretur, sicut lex declarat."
,"27":"Digressi autem ab oratione, sumptis armis, longius de civitate processerunt et, proximi hostibus effecti, separatim steterunt."
,"28":"Cum autem lux oriens coepisset diffundi, utrique commiserunt, isti quidem prosperitatis et victoriae tamquam sponsorem habentes cum virtute refugium in Dominum, illi autem ut ducem certaminum sibi ipsis statuentes animum."
,"29":"Sed, cum vehemens pugna esset, apparuerunt adversariis de caelo viri quinque in equis, frenis aureis decori, et ducatum Iudaeis praestantes;"
,"30":"ex quibus duo Maccabaeum medium accipientes suisque armis protegentes incolumem conservabant, in adversarios autem tela et fulmina iaciebant, ex quo caecitate confusi evolaverunt repleti perturbatione."
,"31":"Interfecti sunt autem viginti milia quingenti et equites sescenti."
,"32":"Timotheus vero confugit in praesidium, quod Gazara dicitur, optimam munitionem, ducatum illic habente Chaerea."
,"33":"Qui autem cum Maccabaeo erant laetantes obsederunt munitionem diebus quattuor."
,"34":"At hi qui intus erant, loci munimento confisi, supra modum maledicebant et sermones nefandos iactabant;"
,"35":"sed, cum dies quinta illucesceret, viginti iuvenes ex his, qui cum Maccabaeo erant, accensi animis propter blasphemias, murum viriliter aggressi feroci animo, occursantem quemque caedebant;"
,"36":"sed et alii similiter ascendentes in circumflexione contra eos, qui intus erant, turres incendebant atque ignes inferentes ipsos maledicos vivos concremabant, alii autem portas concidebant et, recepto residuo exercitu, occupaverunt civitatem;"
,"37":"et Timotheum occultantem se in quodam lacu peremerunt et fratrem illius Chaeream et Apollophanem."
,"38":"Quibus gestis, in hymnis et confessionibus benedicebant Dominum, qui magnifice Israel benefaciebat et victoriam dabat illis."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Sed parvo prorsus post tem pore, Lysias procurator regis et propinquus ac negotiorum praepositus graviter ferens de his, quae acciderant,"
,"2":"congregatis octoginta milibus et equitatu universo, veniebat adversus Iudaeos existimans se civitatem quidem Graecis habitaculum facturum;"
,"3":"templum vero in pecuniae quaestum sicut cetera delubra gentium habiturum, et per singulos annos venale sacerdotium facturum,"
,"4":"nequaquam recogitans Dei potestatem, sed elatus multitudine peditum et milibus equitum et octoginta elephantis."
,"5":"Ingressus autem Iudaeam et appropians Bethsuris, munito quidem praesidio, distanti autem ab Hierosolymis intervallo quinque stadiorum, illud obsidione premebat."
,"6":"Ut autem, qui cum Maccabaeo erant, cognoverunt eum expugnare praesidia, cum fletibus et lacrimis rogabant Dominum, et omnis turba simul, ut bonum angelum mitteret ad salutem Israel."
,"7":"Et ipse primus Maccabaeus, sumptis armis, ceteros adhortatus est simul secum periculum subire et ferre auxilium fratribus suis; simul autem et prompto animo impetum fecerunt."
,"8":"Ilico vero, cum prope Hierosolymam essent, apparuit praecedens eos eques in veste candida armaturam auream vibrans."
,"9":"Tunc omnes simul benedixerunt misericordem Deum et convaluerunt animis non solum homines, sed et bestias ferocissimas et muros ferreos parati penetrare."
,"10":"Praeibant in apparatu de caelo habentes adiutorem, miserante super eos Domino."
,"11":"Leonum autem more impetu irruentes in hostes, prostraverunt ex eis undecim milia peditum et equitum mille sescentos, universos autem in fugam verterunt."
,"12":"Plures autem ex eis vulnerati, nudi evaserunt; sed et ipse Lysias turpiter fugiens evasit."
,"13":"Et, quia non insensatus erat, secum ipse reputans factam erga se deminutionem et intellegens invictos esse Hebraeos, potente Deo auxiliante, misit ad eos"
,"14":"suasitque eis se consensurum omnibus, quae iusta sunt, et regem quoque persuasurum, ut necessarium crederet se amicum eis esse."
,"15":"Annuit autem Maccabaeus in omnibus, quae Lysias rogabat, utilitati consulens; quaecumque enim Maccabaeus scriptis tradidit Lysiae de Iudaeis, rex concessit."
,"16":"Nam erant scriptae Iudaeis epistulae a Lysia quidem hunc modum continentes: ' Lysias populo Iudaeorum salutem."
,"17":"Ioannes et Abessalom, qui missi fuerant a vobis tradentes responsum rescriptum, postulabant circum ea, quae per illud significabantur."
,"18":"Quaecumque igitur oportebat etiam regi perferri, exposui; et, quae res permittebat, concessit."
,"19":"Si igitur in negotiis benevolentiam conservaveritis, et deinceps bonorum vobis causa esse tentabo."
,"20":"De ceteris autem per singula mandavi et istis et his, qui a me missi sunt, colloqui vobiscum."
,"21":"Bene valete. Anno centesimo quadragesimo octavo, mensis Iovis Corinthii die vicesima et quarta '."
,"22":"Regis autem epistula ista continebat: ' Rex Antiochus Lysiae fratri salutem."
,"23":"Patre nostro inter deos translato, nos volentes eos, qui sunt in regno nostro, sine tumultu attendere ad rerum suarum curam,"
,"24":"audientes Iudaeos non consensisse patri, ut transferrentur ad Graecas institutiones, sed suo ipsorum instituto adhaerentes postulare sibi concedi legitima sua;"
,"25":"cupientes igitur hanc quoque gentem extra tumultum esse, iudicamus templum illis restitui remque agi secundum suorum maiorum consuetudinem."
,"26":"Bene igitur feceris, si miseris ad eos et dexteram dederis ut, cognita nostra voluntate, bono animo sint et libenter propriarum rerum instaurationi deserviant '."
,"27":"Ad gentem vero regis epistula talis erat: ' Rex Antiochus senatui Iudaeorum et ceteris Iudaeis salutem."
,"28":"Si valetis, sic est, ut volumus; sed et ipsi bene valemus."
,"29":"Manifestavit nobis Menelaus velle vos redire et in negotiis propriis versari."
,"30":"His igitur, qui commeant usque ad diem tricesimum mensis Xanthici, erit dextera cum securitate,"
,"31":"ut Iudaei utantur cibis et legibus suis sicut et prius, et nemo eorum ullo modo molestiam patietur de his, quae per ignorantiam gesta sunt."
,"32":"Misimus autem et Menelaum, qui vos alloquatur."
,"33":"Valete. Anno centesimo quadragesimo octavo, Xanthici mensis quinta decima die '."
,"34":"Miserunt autem etiam Romani epistulam ita se habentem: ' Quintus Memmius, Titus Manius, legati Romanorum populo Iudaeorum salutem."
,"35":"De his, quae Lysias cognatus regis concessit vobis, et nos consentimus."
,"36":"De quibus autem ad regem iudicavit referendum, confestim aliquem mittite inter vos conferentes de his, ut proponamus, sicut congruit vobis; nos enim Antiochiam accedimus."
,"37":"Ideoque festinate et mittite aliquos, ut nos quoque sciamus cuius estis voluntatis."
,"38":"Bene valete. Anno centesimo quadragesimo octavo, quinta decima die mensis Xanthici '."
}`)
	CurrentBook.AddChapter(12, `{
"1":"His factis pactionibus, Lysias pergebat ad regem, Iudaei autem agriculturae operam dabant."
,"2":"Sed ex his, qui duces erant in singulis locis, Timotheus et Apollonius Gennaei filius, sed et Hieronymus et Demophon, super hos et Nicanor Cypriarches, non sinebant eos in silentio agere et quiete."
,"3":"Ioppitae vero tale quoddam flagitium perpetrarunt: cum rogavissent Iudaeos, cum quibus habitabant, ascendere scaphas, quas ipsi paraverant, cum uxoribus et filiis, quasi nullis inimicitiis in eos subiacentibus,"
,"4":"secundum autem commune civitatis decretum, et ipsis acquiescentibus, utpote qui pacem obtinere cuperent et nihil suspectum haberent, eos provectos in altum submerserunt non minus ducentos."
,"5":"Quam crudelitatem Iudas in suae gentis homines factam ut cognovit, praecepit viris, qui erant cum ipso, et, invocato iusto iudice Deo,"
,"6":"venit adversus interfectores fratrum et portum quidem noctu succendit, scaphas exussit, eos autem, qui illuc refugerant, gladio peremit."
,"7":"Et, cum conclusus esset locus, discessit quasi iterum reversurus et universam Ioppitarum civitatem eradicaturus."
,"8":"Sed, cum cognovisset et eos, qui erant Iamniae, velle pari modo facere habitantibus secum Iudaeis,"
,"9":"Iamnitis quoque nocte supervenit et portum cum navibus succendit, ita ut lumen ignis appareret Hierosolymis a stadiis ducentis quadraginta."
,"10":"Inde, cum iam abiissent novem stadiis et iter facerent ad Timotheum, commiserunt cum eo Arabes non minus quam quinque milia viri et equites quingenti."
,"11":"Cumque pugna valida fieret et hi, qui circa Iudam erant, per auxilium Dei prospere gessissent, nomades victi petebant a Iuda dextram sibi dari, promittentes se pascua daturos et in ceteris profuturos eis."
,"12":"Iudas autem arbitratus vere in multis eos utiles promisit se pacem acturum cum eis; dextrisque acceptis, discessere ad tabernacula sua."
,"13":"Aggressus est autem et civitatem quandam firmam pontibus murisque circumsaeptam, quae a promiscuis gentibus habitabatur, cui nomen Caspin."
,"14":"Hi vero, qui intus erant, confidentes in stabilitate murorum et apparatu alimoniarum contumeliosius agebant cum eis, qui circa Iudam erant, maledictis lacessentes et blasphemantes ac loquentes, quae fas non est."
,"15":"Qui autem cum Iuda erant, invocato magno mundi Principe, qui sine arietibus et machinis organicis temporibus Iosue praecipitavit Iericho, irruerunt ferociter muris"
,"16":"et, capta civitate per Dei voluntatem, inenarrabiles caedes fecerunt, ita ut adiacens stagnum latitudinem habens stadiorum duorum defluere repletum sanguine videretur."
,"17":"Inde autem discesserunt stadia septingenta quinquaginta et pervenerunt in Characa ad eos, qui dicuntur Tubiani, Iudaeos."
,"18":"Et Timotheum quidem in illis locis non comprehenderunt, qui, nullo negotio perfecto, tunc de locis regressus erat, relicto tamen in quodam loco firmissimo praesidio."
,"19":"Dositheus autem et Sosipater, ex ducibus, qui cum Maccabaeo erant, exeuntes peremerunt a Timotheo relictos in praesidio plures quam decem milia viros."
,"20":"At Maccabaeus, ordinato exercitu circum se per cohortes, constituit eos super cohortes et adversus Timotheum processit habentem secum centum viginti milia peditum equitumque duo milia quingentos."
,"21":"Cognito autem Iudae adventu, Timotheus praemisit mulieres et filios et reliquum apparatum in locum, qui Carnion dicitur; erat enim inexpugnabile et accessu difficile praesidium propter locorum angustias."
,"22":"Cumque cohors Iudae prima apparuisset, et pavor factus esset super hostes, ac timor ex praesentia illius, qui universa conspicit, super eos esset, in fugam exsiluerunt, alius alio se ferens, ita ut saepe a suis laederentur et gladiorum acuminibus configerentur."
,"23":"Iudas autem vehementer instabat confodiens impios et prostravit ad triginta milia virorum."
,"24":"Ipse vero Timotheus incidens in eos, qui erant cum Dositheo et Sosipatre, cum multa adulatione postulabat, ut vivus dimitteretur, eo quod multorum quidem parentes, aliorum autem fratres haberet, et contingeret horum curam non haberi."
,"25":"Et cum pluribus modis fidem dedisset secundum hoc constitutum, restituturum se eos illaesos, dimiserunt eum propter fratrum salutem."
,"26":"Egressus autem ad Carnion et Atergation interfecit viginti quinque milia corporum."
,"27":"Post autem horum fugam et necem, movit exercitum etiam adversus Ephron civitatem munitam, in qua multitudo diversarum gentium inhabitabat, et robusti iuvenes pro muris consistentes fortiter repugnabant; in hac autem machinarum et telorum multi erant apparatus."
,"28":"Sed, cum Potentem invocassent, qui potestate sua vires hostium confringit, ceperunt subiectam civitatem et ex eis, qui intus erant, ad viginti quinque milia prostraverunt."
,"29":"Inde profecti ad civitatem Scytharum perrexerunt, quae ab Hierosolymis sescentis stadiis aberat."
,"30":"Contestantibus autem his, qui erant illic Iudaei, benevolentiam, quam Scythopolitae erga eos habebant, et mitem occursum temporibus infelicitatis,"
,"31":"gratias agentes et exhortati etiam de cetero erga genus ipsum benignos esse, venerunt Hierosolymam die sollemni Septimanarum instante."
,"32":"Post eam vero, quae dicitur Pentecoste, abierunt contra Gorgiam praepositum Idumaeae."
,"33":"Exivit autem cum peditibus tribus milibus et equitibus quadringentis."
,"34":"Quibus autem congressis, contigit paucos ruere Iudaeorum."
,"35":"Dositheus vero quidam de iis, qui Bacenoris erant, eques vir et fortis, Gorgiam tenuit chlamydeque apprehensum ducebat eum fortiter; et, cum vellet illum capere vivum, eques quidam de Thracibus irruit in eum umerumque amputavit, et Gorgias effugit in Maresa."
,"36":"At illis, qui cum Esdrin erant, diutius pugnantibus et fatigatis, cum invocasset Iudas Dominum, ut adiutorem se ostenderet et ducem belli,"
,"37":"incipiens patria voce clamorem cum hymnis, irruens improviso in eos, qui circa Gorgiam erant, fugam eis incussit."
,"38":"Iudas autem, collecto exercitu, venit in civitatem Odollam et, cum septima dies superveniret, secundum consuetudinem purificati in eodem loco sabbatum egerunt."
,"39":"Et sequenti die venerunt, qui cum Iuda erant, eo tempore, quo necessarium factum erat, ut corpora prostratorum tollerent et cum parentibus reponerent in sepulcris paternis."
,"40":"Invenerunt autem sub tunicis uniuscuiusque interfectorum donaria idolorum, quae apud Iamniam fuerunt, a quibus lex prohibet Iudaeos. Omnibus ergo manifestum factum est ob hanc causam eos corruisse."
,"41":"Omnes itaque, cum benedixissent, quae sunt iusti iudicis, Domini, qui occulta manifesta facit,"
,"42":"ad obsecrationem conversi sunt, rogantes, ut id, quod factum erat, delictum oblivioni ex integro traderetur. At vero fortissimus Iudas hortatus est populum conservare se sine peccato, cum sub oculis vidissent, quae facta sunt propter peccatum eorum, qui prostrati sunt."
,"43":"Et, facta viritim collatione ad duo milia drachmas argenti, misit Hierosolymam offerri pro peccatis sacrificium, valde bene et honeste de resurrectione cogitans."
,"44":"Nisi enim eos, qui ceciderant, resurrecturos speraret, superfluum et vanum esset orare pro mortuis."
,"45":"Deinde considerans quod hi, qui cum pietate dormitionem acceperant, optimum haberent repositum gratiae donum:"
,"46":"sancta et pia cogitatio. Unde pro defunctis expiationem fecit, ut a peccato solverentur."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Anno centesimo quadrage simo nono his, qui erant cir ca Iudam, notum factum est Antiochum Eupatorem venire cum multitudine adversus Iudaeam"
,"2":"et cum eo Lysiam procuratorem et praepositum negotiorum, unumquemque habentem exercitum Graecum peditum centum decem milia et equitum quinque milia trecentos et elephantos viginti duos, currus autem cum falcibus trecentos."
,"3":"Commiscuit autem se illis et Menelaus et cum multa fallacia hortabatur Antiochum non pro patriae salute, sed sperans se constitui in principatum."
,"4":"Sed Rex regum suscitavit animos Antiochi in peccatorem; et, suggerente Lysia hunc esse causam omnium malorum, iussit, ut est consuetudo in loco, adductum in Beroeam necari."
,"5":"Erat autem in loco turris quinquaginta cubitorum, cineris plena, et machinam habebat volubilem undique praecipitem in cinerem."
,"6":"Illic reum sacrilegii vel quorundam etiam aliorum malorum summitatem factum, omnes propellunt ad interitum."
,"7":"Et tali lege praevaricatorem legis contigit mori, nec terram adeptum Menelaum."
,"8":"Valde iuste: nam, quia multa erga aram delicta commisit, cuius ignis et cinis erat sanctus, ipse in cinere mortem reportavit."
,"9":"Sed rex mente efferatus veniebat, peiora quam quae sub patre suo facta erant, ostensurus Iudaeis."
,"10":"Quibus Iudas cognitis, praecepit populo, ut die ac nocte Dominum invocarent, si quando et alias etiam nunc adiuvaret eos,"
,"11":"quippe qui lege et patria sanctoque templo in eo essent ut privarentur; ac populum, qui nuper paululum respirasset, ne sineret blasphemis nationibus subdi."
,"12":"Omnibus itaque simul idem facientibus et rogantibus misericordem Dominum cum fletu et ieiuniis et prostratione per triduum sine intermissione, hortatus eos Iudas praecepit adesse."
,"13":"Ipse vero seorsum cum senioribus cogitavit, prius quam regis exercitus invaderet Iudaeam et obtinerent civitatem, egressos res adiudicare auxilio Dei."
,"14":"Dans itaque procurationem Creatori mundi, exhortatus suos, ut fortiter dimicarent usque ad mortem pro legibus, templo, civitate, patria, institutionibus, circa Modin exercitum constituit."
,"15":"Cumque suis dedisset signum: ' Victoriam Dei ', cum iuvenibus fortissimis electis, nocte aggressus castra adversus aulam regiam, interfecit viros ad duo milia et primarium elephantorum una cum eo, qui intra habitaculum erat;"
,"16":"et postremo metu ac perturbatione castra repleverunt, rebusque prospere gestis, abierunt."
,"17":"Die autem iam illucescente hoc factum erat, adiuvante eum Domini protectione."
,"18":"Sed rex, accepto gustu audaciae Iudaeorum, artibus loca tentavit."
,"19":"Et Bethsuris, quae erat Iudaeorum praesidium munitum, castra admovebat; sed fugabatur, impingebat, minorabatur."
,"20":"His autem, qui intus erant, Iudas necessaria mittebat."
,"21":"Enuntiavit autem mysteria hostibus Rhodocus quidam de Iudaico exercitu; qui requisitus, comprehensus est et conclusus."
,"22":"Iterum rex sermonem habuit ad eos, qui erant in Bethsuris, dextram dedit, accepit, abiit;"
,"23":"commisit cum his, qui erant cum Iuda, superatus est; cognovit rebellasse Philippum Antiochiae, qui relictus erat super negotia, confusus est; Iudaeos deprecatus est, subditus est, iuravit de omnibus, quae iusta erant, reconciliatus est et obtulit sacrificium, honoravit templum et loco exhibuit humanitatem;"
,"24":"Maccabaeum excepit, reliquit ducem a Ptolemaide usque ad Gerrenos Hegemonidem,"
,"25":"venit Ptolemaidam: graviter ferebant Ptolemenses amicitiae conventiones - indignabantur enim supra modum - voluerunt irrita facere pacta."
,"26":"Accessit Lysias ad tribunal, exposuit rationem congruenter, persuasit, sedavit, tranquillos fecit, regressus est Antiochiam. Hoc modo res gestae a rege, adventus et profectionis eius, processerunt."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sed post triennii tempus co gnoverunt, qui cum Iuda erant, Demetrium Seleuci per portum apud Tripolim adnavigantem cum multitudine valida et navibus,"
,"2":"tenuisse regionem, sublato Antiocho et procuratore eius Lysia."
,"3":"Alcimus autem quidam, qui summus sacerdos fuerat, sed voluntarie coinquinatus temporibus seditionis, considerans nullo modo sibi esse salutem neque accessum ultra ad sanctum altare,"
,"4":"venit ad regem Demetrium, centesimo quinquagesimo primo anno, offerens ei coronam auream et palmam, super haec et thallos, qui templi esse videbantur; et ipsa quidem die siluit."
,"5":"Tempus autem opportunum dementiae suae nactus, convocatus a Demetrio ad consilium et interrogatus quo proposito et consilio Iudaei niterentur,"
,"6":"ad haec respondit: ' Ipsi, qui dicuntur Asidaei, Iudaeorum, quibus praeest Iudas Maccabaeus, bella nutriunt et seditiones movent nec patiuntur regnum esse quietum."
,"7":"Unde ego defraudatus parentum gloria, dico autem summo sacerdotio, huc nunc veni,"
,"8":"primo quidem de his, quae pertinent ad regem, mera fide sentiens, secundo autem etiam civibus meis consulens; nam illorum praedictorum inconsiderantia universum genus nostrum non modice laborat."
,"9":"Sed his singulis, tu rex, cognitis, et regioni et obsesso generi nostro, secundum quam habes omnibus obviam humanitatem, prospice;"
,"10":"nam, quamdiu superest Iudas, impossibile est pacem esse negotiis '."
,"11":"Talibus autem ab hoc dictis, velocius ceteri amici hostiliter se habentes adversus Iudam inflammaverunt Demetrium."
,"12":"Qui statim assumens Nicanorem, qui fuit praepositus elephantorum, et ducem ostendens Iudaeae misit,"
,"13":"datis mandatis, ut ipsum quidem Iudam occideret; eos vero, qui cum illo erant, dispergeret et constitueret Alcimum maximi templi summum sacerdotem."
,"14":"Tunc gentes, quae de Iudaea fugerant Iudam, gregatim se Nicanori miscebant, miserias et clades Iudaeorum prosperitates rerum suarum existimantes fore."
,"15":"Audito itaque Nicanoris adventu et conventu nationum, conspersi terra rogabant eum, qui populum suum constituit usque in aeternum quique suam portionem signis evidentibus protegit."
,"16":"Imperante autem duce, statim inde profectus congreditur eis ad castellum Dessau."
,"17":"Simon vero frater Iudae commiserat cum Nicanore, sed lente ob repentinum adversariorum silentium victus evaserat."
,"18":"Nicanor tamen audiens quam virtutem haberent, qui cum Iuda erant, et animi magnitudinem pro patriae certaminibus, sanguine iudicium facere metuebat."
,"19":"Quam ob rem misit Posidonium et Theodotum et Matthathiam, ut darent dextras atque acciperent."
,"20":"Et, cum diu de his consilium ageretur, et ipse dux ad multitudinem rettulisset, et paribus suffragiis pareret sententia, sponsionibus pacis annuerunt."
,"21":"Itaque diem constituerunt, qua secreto convenirent eodem, et processit utrimque currus, posuerunt sellas;"
,"22":"disposuit Iudas armatos paratos locis opportunis, ne forte ab hostibus repente mali aliquid fieret; congruum colloquium fecerunt."
,"23":"Morabatur Nicanor Hierosolymis nihilque inique agebat gregesque turbarum, quae congregatae fuerant, dimisit."
,"24":"Habebat autem Iudam semper in conspectu, ex animo erat viro inclinatus."
,"25":"Rogavit eum ducere uxorem filiosque procreare. Nuptias fecit, quiete egit, communiter vivebat."
,"26":"Alcimus autem, videns mutuam illorum benevolentiam et factas conventiones, accipiens venit ad Demetrium et dicebat Nicanorem aliena sentire a rebus; Iudam enim regni insidiatorem socium sibi designavit."
,"27":"Itaque rex exasperatus et pessimi huius criminationibus irritatus, scripsit Nicanori dicens graviter quidem se ferre de conventionibus, iubere tamen Maccabaeum citius vinctum mittere Antiochiam."
,"28":"Quibus cognitis, Nicanor confusus erat et aegre ferebat, si ea, quae convenerant, irrita faceret, nulla a viro facta iniuria;"
,"29":"sed, quia regi resisti non poterat, opportunitatem observabat, ut artificio illud perficeret."
,"30":"At Maccabaeus videns secum austerius agere Nicanorem et consuetum occursum ferocius exhibentem, intellegens non ex optimo esse austeritatem, non paucis suorum congregatis, occultavit se a Nicanore."
,"31":"Quod cum ille cognovit fortiter se a viro astutia praeventum, venit ad maximum et sanctum templum et sacerdotibus solitas hostias offerentibus iussit sibi tradi virum."
,"32":"Quibus cum iuramento dicentibus nescire se ubi esset, qui quaerebatur, extendens dexteram ad templum"
,"33":"iuravit haec: ' Nisi Iudam mihi vinctum tradideritis, istud Dei fanum in planitiem deducam et altare effodiam et templum hic Libero illustre erigam '."
,"34":"Et, his dictis, abiit. Sacerdotes autem protendentes manus in caelum invocabant eum, qui semper propugnator fuit gentis nostrae, haec dicentes:"
,"35":"' Tu, Domine universorum, qui nullius indiges, voluisti templum habitationis tuae fieri in nobis; 36 et nunc, Sancte, omnis sanctificationis Domine, conserva in aeternum impollutam domum istam, quae nuper mundata est '."
,"37":"Razis autem quidam de senioribus ab Hierosolymis delatus est Nicanori, vir amator civitatis et valde bene audiens, qui pro affectu pater Iudaeorum appellabatur."
,"38":"Hic enim pristinis temporibus seditionis iudicium pertulerat Iudaismi corpusque et animam pro Iudaismo tradiderat cum omni perseverantia."
,"39":"Volens autem Nicanor manifestare odium, quod habebat in Iudaeos, misit milites supra quingentos, ut eum comprehenderent;"
,"40":"putabat enim, si illum cepisset, se cladem istis illaturum."
,"41":"Turbis autem turrim iam occupaturis et atrii ianuae vim facientibus atque iubentibus ignem admovere et portas incendi, ipse undique comprehensus supposuit sibi gladium"
,"42":"volens nobiliter mori potius quam subditus fieri peccatoribus et nobilitate sua indignis iniuriis affici."
,"43":"Sed, cum per contentionis festinationem non certo ictu plagam dedisset, et turbae intra ostia irrumperent, recurrens audacter ad murum praecipitavit semetipsum viriliter in turbas;"
,"44":"quibus velociter locum dantibus intervallo facto, venit per medium spatium vacuum."
,"45":"Et, cum adhuc spiraret, accensus animis surrexit et, cum sanguis ad modum fontis deflueret, et gravissima essent vulnera, cursu turbas pertransiens et stans supra quandam petram praeruptam,"
,"46":"prorsus exsanguis iam effectus, proferens intestina et sumens utrisque manibus proiecit super turbas et invocans Dominatorem vitae ac spiritus, ut haec ipsi iterum redderet, ita vita defunctus est."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Nicanor autem, ut comperit eos, qui cum Iuda erant, in locis esse iuxta Samariam, cogitavit requietionis die cum omni securitate eos aggredi."
,"2":"Iudaeis vero, qui illum per necessitatem sequebantur, dicentibus: ' Ne ita ferociter et barbare disperdas, sed honorem tribue praehonoratae diei cum sanctificatione ab eo, qui universa conspicit ',"
,"3":"ille infelix interrogavit, si est potens in caelo, qui imperavit agi diem sabbatorum."
,"4":"Et respondentibus illis: ' Est Dominus vivus ipse in caelo potens, qui iussit colere septimam diem ';"
,"5":"at ille ait: ' Et ego potens sum super terram, qui impero sumi arma et negotia regis impleri '. Tamen non obtinuit, ut nefarium consilium perficeret."
,"6":"Et Nicanor quidem cum summa superbia cervicem erigens cogitaverat commune trophaeum statuere de iis, qui cum Iuda erant."
,"7":"Maccabaeus autem sine intermissione confidebat cum omni spe auxilium se consequi a Domino;"
,"8":"et hortabatur suos, ne formidarent adventum nationum, sed in mente habentes adiutoria sibi facta de caelo et nunc sperarent ab Omnipotente sibi affuturam victoriam."
,"9":"Et allocutus eos de Lege et Prophetis, admonens eos etiam de certaminibus, quae perfecerant, promptiores constituit eos."
,"10":"Et, animis eorum excitatis, denuntiavit simul ostendens gentium fallaciam et iuramentorum praevaricationem."
,"11":"Cum autem singulos illorum armavisset, non tam clipeorum et hastarum munitione quam per bonos sermones exhortatione, cumque somnium fide dignum exposuisset, supra modum universos laetificavit."
,"12":"Erat autem huiuscemodi visus eius: Oniam, qui fuerat summus sacerdos, virum honestum et bonum, verecundum occursu, modestum moribus et eloquium digne proferentem et qui a puero omnes virtutes domesticas exercuerat, manus protendentem orare pro omni populo Iudaeorum."
,"13":"Post hoc sic apparuisse virum canitie et gloria praestantem et mirabilem quandam et magni decoris esse eminentiam circa illum."
,"14":"Respondentem vero Oniam dixisse: ' Hic est fratrum amator, qui multum orat pro populo et sancta civitate, Ieremias propheta Dei '."
,"15":"Protendentem autem Ieremiam dextram dedisse Iudae gladium aureum et, cum daret, dixisse haec:"
,"16":"' Accipe sanctum gladium munus a Deo, in quo confringes adversarios '."
,"17":"Exhortati itaque Iudae sermonibus bonis valde, et qui poterant ad virtutem incitare et animos iuvenum confortare, statuerunt castra non tendere, sed fortiter inferri et cum omni virtute confligentes de negotiis iudicare, eo quod civitas et sancta et templum periclitarentur."
,"18":"Erat enim timor pro uxoribus et filiis itemque pro fratribus et cognatis in minore parte iacens, maximus vero et primus pro sanctificato templo."
,"19":"Sed et eos, qui in civitate erant comprehensi, non minima sollicitudo habebat propter illum sub aperto concursum."
,"20":"Et, cum iam omnes exspectarent iudicium futurum, hostesque iam committerent, atque exercitus esset ordinatus, et bestiae opportuno in loco constitutae, et equitatus dispositus,"
,"21":"considerans Maccabaeus adventum multitudinis et apparatum varium armorum et ferocitatem bestiarum, extendens manus in caelum prodigia facientem Dominum invocavit, sciens quoniam non est per arma, sed prout ab ipso iudicatum fuerit dignis tribuit victoriam."
,"22":"Dixit autem invocans hoc modo: ' Tu, Domine, qui misisti angelum tuum sub Ezechia rege Iudaeae, et interfecit de castris Sennacherib ad centum octoginta quinque milia,"
,"23":"et nunc, Dominator caelorum, mitte angelum bonum ante nos in timorem et tremorem;"
,"24":"magnitudine brachii tui exterreantur, qui cum blasphemia veniunt adversus sanctum populum tuum '. Et hic quidem in his finem fecit."
,"25":"Qui autem cum Nicanore erant, cum tubis et canticis admovebant;"
,"26":"hi vero qui erant cum Iuda, cum invocatione et orationibus congressi sunt cum hostibus."
,"27":"Et manibus quidem pugnantes, sed Dominum cordibus orantes, prostraverunt non minus triginta quinque milia, praesentia Dei magnifice delectati."
,"28":"Cumque cessassent ab opere et cum gaudio redirent, cognoverunt Nicanorem proruisse cum armis suis;"
,"29":"facto itaque clamore et tumultu, patria voce omnipotentem Dominum benedicebant."
,"30":"Et praecepit ille, qui per omnia corpore et animo primus fuerat in certamine pro civibus, qui iuventutis benevolentiam in suam gentem conservaverat, caput Nicanoris abscindi et manum cum umero, ac Hierosolymam perferri."
,"31":"Quo cum pervenisset, convocatis contribulibus et sacerdotibus, ante altare stans accersiit eos, qui in arce erant;"
,"32":"et, ostenso capite iniqui Nicanoris et manu nefarii, quam extendens contra domum sanctam omnipotentis Dei magnifice gloriatus est,"
,"33":"linguam etiam impii Nicanoris praecisam dixit particulatim avibus daturum, pretia autem dementiae contra templum suspendere."
,"34":"Omnes igitur in caelum benedixerunt manifestum Dominum dicentes: ' Benedictus, qui locum suum incontaminatum servavit! '."
,"35":"Alligavit autem Nicanoris caput de summa arce evidens omnibus et manifestum signum auxilii Domini."
,"36":"Itaque omnes communi consilio decreverunt nullo modo diem istum absque celebritate praeterire, habere autem celebrem tertiam decimam diem, mensis duodecimi - Adar dicitur voce Syriaca - pridie Mardochaei diei."
,"37":"Igitur his erga Nicanorem sic gestis, et ex illis temporibus ab Hebraeis civitate possessa, ego quoque hic faciam finem sermonis."
,"38":"Et, si quidem bene et apte compositioni, hoc et ipse volebam; sin autem exigue et modice, hoc est, quod assequi poteram."
,"39":"Sicut enim vinum solummodo bibere, similiter autem rursus et aquam, contrarium est, quemadmodum autem vinum aquae contemperatum iam et delectabilem gratiam perficit, huiusmodi etiam structura sermonis delectat aures eorum, quibus contingat compositionem legere. Hic autem erit finis."
}`)

}
func LA_NVBSE_LoadVH2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Confortatus est ergo Salomon filius David in regno suo, et Dominus Deus eius erat cum eo et magnificavit eum in excelsum."
,"2":"Praecepitque Salomon universo Israeli, tribunis et centurionibus et iudicibus et ducibus omnis Israel et principibus familiarum"
,"3":"et abiit cum universa multitudine in excelsum Gabaon, ubi erat tabernaculum conventus Dei, quod fecit Moyses famulus Dei in solitudine."
,"4":"Arcam autem Dei adduxerat David de Cariathiarim in locum, quem praeparaverat ei et ubi fixerat illi tabernaculum, hoc est in Ierusalem;"
,"5":"altare quoque aeneum, quod fabricatus fuerat Beseleel filius Uri filii Hur, ibi erat coram tabernaculo Domini; ibique requisivit eum Salomon et omnis ecclesia."
,"6":"Ascenditque ibi Salomon ad altare aeneum coram tabernaculo conventus Domini et obtulit in eo mille hostias."
,"7":"Ecce autem in ipsa nocte apparuit ei Deus dicens: ' Postula, quod vis, ut dem tibi '."
,"8":"Dixitque Salomon Deo: ' Tu fecisti cum David patre meo misericordiam magnam et constituisti me regem pro eo."
,"9":"Nunc ergo, Domine Deus, impleatur sermo tuus, quem pollicitus es David patri meo; tu enim me fecisti regem super populum tuum multum, qui tam innumerabilis est quam pulvis terrae."
,"10":"Da mihi sapientiam et intellegentiam, ut ingrediar et egrediar coram populo tuo; quis enim potest hunc populum tuum digne, qui tam grandis est, iudicare? '."
,"11":"Dixit autem Deus ad Salomonem: ' Quia hoc magis placuit cordi tuo et non postulasti divitias et substantiam et gloriam neque animas eorum, qui te oderant, sed nec dies vitae plurimos, petisti autem sapientiam et scientiam, ut iudicare possis populum meum, super quem constitui te regem,"
,"12":"sapientia et scientia data sunt tibi; divitias autem et substantiam et gloriam dabo tibi, ita ut nullus in regibus nec ante te nec post te fuerit similis tui '."
,"13":"Venit ergo Salomon ab excelso Gabaon in Ierusalem coram tabernaculo conventus et regnavit super Israel."
,"14":"Congregavitque sibi currus et equites, et facti sunt ei mille quadringenti currus et duodecim milia equitum, et fecit eos esse in urbibus quadrigarum et cum rege in Ierusalem."
,"15":"Praebuitque rex argentum et aurum in Ierusalem quasi lapides et cedros quasi sycomoros, quae nascuntur in Sephela multitudine magna."
,"16":"Adducebantur autem ei equi de Aegypto et de Coa; negotiatores regis de Coa emebant pretio"
,"17":"et faciebant ascendere et exire de Aegypto quadrigam sescentis argenteis et equum centum quinquaginta; similiter universis regibus Hetthaeorum et Syriae per manus suas educebant."
,"18":"Decrevit autem Salomon aedificare domum nomini Domini et palatium sibi."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et numeravit septuaginta milia virorum portantium umeris et octoginta milia, qui caederent lapides in montibus, praepositosque eorum tria milia sescentos."
,"2":"Misit quoque ad Hiram regem Tyri dicens: ' Sicut egisti cum David patre meo et misisti ei ligna cedrina, ut aedificaret sibi domum ad habitandum in ea,"
,"3":"sic fac mecum, ut aedificem domum nomini Domini Dei mei, ut consecrem eam ad adolendum coram illo fumiganda aromata et ad propositionem panum sempiternam et ad holocautomata mane et vespere, sabbatis quoque et neomeniis et sollemnitatibus Domini Dei nostri in sempiternum, quae mandata sunt Israeli."
,"4":"Domus enim, quam aedificare cupio, magna est; magnus est enim Deus noster super omnes deos."
,"5":"Quis ergo poterit praevalere, ut aedificet ei dignam domum? Si caelum et caeli caelorum capere eum nequeunt, quantus ego sum, ut possim aedificare ei domum? Sed ad hoc tantum, ut adoleatur incensum coram illo."
,"6":"Mitte ergo mihi virum eruditum, qui noverit operari in auro et argento, aere et ferro, purpura, coccino et hyacintho, et qui sciat sculpere caelaturas cum his artificibus, quos mecum habeo in Iudaea et Ierusalem, quos praeparavit David pater meus."
,"7":"Sed et ligna cedrina mitte mihi et arceuthina et pinea de Libano; scio enim quod servi tui noverint caedere ligna de Libano, et erunt servi mei cum servis tuis,"
,"8":"ut parentur mihi ligna plurima; domus enim, quam cupio aedificare, magna erit nimis et inclita."
,"9":"Praeterea operariis, qui caesuri sunt ligna, servis tuis dabo in cibaria tritici choros viginti milia et hordei choros totidem et vini viginti milia batos, olei quoque batos viginti milia '."
,"10":"Dixit autem Hiram rex Tyri per litteras, quas miserat Salomoni: ' Quia dilexit Dominus populum suum, idcirco te regnare fecit super eum '."
,"11":"Et addidit dicens: ' Benedictus Dominus, Deus Israel, qui fecit caelum et terram, qui dedit David regi filium sapientem et eruditum et sensatum atque prudentem, ut aedificaret domum Domino et palatium sibi."
,"12":"Misi ergo tibi virum prudentem et scientissimum Hiram magistrum meum,"
,"13":"filium mulieris de filiabus Dan, cuius pater fuit Tyrius, qui novit operari in auro et argento, aere et ferro et lapidibus et lignis, in purpura quoque et hyacintho et bysso et coccino, et qui scit caelare omnem sculpturam et adinvenire prudenter, quodcumque in opere necessarium est, cum artificibus tuis et cum artificibus domini mei David patris tui."
,"14":"Triticum ergo et hordeum et oleum et vinum, quae pollicitus es, domine mi, mitte servis tuis."
,"15":"Nos autem caedemus ligna de Libano, quot necessaria habueris, et applicabimus ea ratibus per mare in Ioppe; tuum autem erit transferre ea in Ierusalem '."
,"16":"Numeravit igitur Salomon omnes viros peregrinos, qui erant in terra Israel post dinumerationem, quam dinumeravit David pater eius; et inventi sunt centum quinquaginta milia et tria milia sescenti."
,"17":"Fecitque ex eis septuaginta milia, qui umeris onera portarent, et octoginta milia, qui lapides in montibus caederent; tria autem milia et sescentos praepositos operum populi."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et coepit Salomon aedificare domum Domini in Ierusalem in monte Moria, qui demonstratus fuerat a David patre eius, in loco, quem paraverat David in area Ornan Iebusaei."
,"2":"Coepit autem aedificare mense secundo anno quarto regni sui."
,"3":"Et hae sunt mensurae, quas statuit Salomon, ut aedificaret domum Dei: longitudinis cubiti in mensura prima sexaginta, latitudinis cubiti viginti."
,"4":"Porticum vero ante frontem, quae tendebatur in longum, iuxta mensuram latitudinis domus, cubitorum viginti; porro altitudo centum viginti cubitorum erat. Et deauravit eam intrinsecus auro mundissimo."
,"5":"Domum quoque maiorem texit tabulis ligneis abiegnis et laminas auri obryzi affixit per totum; scalpsitque in eis palmas et quasi catenulas se invicem complectentes."
,"6":"Stravit quoque pavimentum templi pretiosissimo marmore decore multo."
,"7":"Porro aurum erat de Parvaim, de cuius laminis texit domum, et trabes eius et postes et parietes et ostia; et caelavit cherubim in parietibus."
,"8":"Fecit quoque domum sancti sanctorum: longitudinem iuxta latitudinem domus cubitorum viginti et latitudinem similiter viginti cubitorum; et laminis auri optimi texit eam quasi talentis sescentis."
,"9":"Sed et pro clavis usus est auro ponderis quinquaginta siclorum. Cenacula quoque texit auro."
,"10":"Fecit etiam in domo sancti sanctorum cherubim duos opere statuario et texit eos auro."
,"11":"Alae cherubim viginti cubitis extendebantur, ita ut una ala haberet cubitos quinque et tangeret parietem domus, et altera quinque cubitos habens alam tangeret alterius cherub."
,"12":"Similiter cherub alterius ala quinque habebat cubitos et tangebat parietem, et ala eius altera quinque cubitorum alam cherub alterius contingebat."
,"13":"Igitur alae utriusque cherubim expansae erant et extendebantur per cubitos viginti; ipsi autem stabant erectis pedibus, et facies eorum erant versae ad exteriorem domum."
,"14":"Fecit quoque velum ex hyacintho, purpura, cocco et bysso et intexuit ei cherubim."
,"15":"Ante fores etiam templi duas columnas, quae triginta et quinque cubitos habebant altitudinis; porro capita earum quinque cubitorum."
,"16":"Necnon et quasi catenulas in torque, et superposuit eas capitibus columnarum; malogranata etiam centum, quae catenulis interposuit."
,"17":"Ipsas quoque columnas posuit ante faciem templi, unam a dextris et alteram a sinistris; eam, quae a dextris erat, vocavit Iachin et, quae ad laevam, Booz."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Fecit quoque altare aeneum viginti cubitorum longitudinis et viginti cubitorum latitudinis et decem cubitorum"
,"2":"altitudinis. Mare etiam fusile decem cubitis a labio usque ad labium rotundum per circuitum; quinque cubitos habebat altitudinis, et funiculus triginta cubitorum ambiebat gyrum eius."
,"3":"Similitudo quoque boum erat subter illud, in circuitu circumdabant illud - decem cubitis - duobus versibus alvum maris circuibant boves fusiles in una fusione cum mari."
,"4":"Et ipsum mare super duodecim boves impositum erat, quorum tres respiciebant aquilonem et alii tres occidentem, porro tres alii meridiem et tres, qui reliqui erant, orientem habentes mare superpositum; posteriora autem boum erant intrinsecus sub mari."
,"5":"Porro vastitas eius habebat mensuram palmi, et labium illius erat quasi labium calicis vel repandi lilii; capiebatque tria milia batos."
,"6":"Fecit quoque luteres decem et posuit quinque a dextris et quinque a sinistris, ut lavarent in eis omnia, quae in holocaustum oblaturi erant; porro in mari sacerdotes lavabantur."
,"7":"Fecit autem et candelabra aurea decem secundum speciem, qua iussa erant fieri, et posuit ea in templo quinque a dextris et quinque a sinistris."
,"8":"Necnon et mensas decem, et posuit eas in templo quinque a dextris et quinque a sinistris; phialas quoque aureas centum."
,"9":"Fecit etiam atrium sacerdotum et atrium grande et ostia in atrio, quae texit aere."
,"10":"Porro mare posuit in latere dextro contra orientem ad meridiem."
,"11":"Fecit autem Hiram lebetes et vatilla et phialas et complevit omne opus regis Salomonis in domo Dei;"
,"12":"hoc est columnas duas et globos et capitella super caput columnarum duarum et serta duo, quae tegerent globos capitellorum;"
,"13":"malogranata quoque quadringenta et serta duo, ita ut bini ordines malogranatorum singulis sertis iungerentur, quae protegerent globos capitellorum columnarum."
,"14":"Bases etiam fecit et luteres, quos superposuit basibus,"
,"15":"mare unum, boves quoque duodecim sub mari;"
,"16":"et lebetes et vatilla et fuscinulas: omnia vasa fecit regi Salomoni Hiram magister eius pro domo Domini ex aere mundissimo."
,"17":"In regione Iordanis fudit ea rex in argillosa terra inter Succoth et Saredatha."
,"18":"Fecitque Salomon multitudinem vasorum innumerabilem, ita ut ignoraretur pondus aeris."
,"19":"Fecitque Salomon omnia vasa domus Dei et altare aureum et mensas et super eas panes propositionis;"
,"20":"candelabra quoque cum lucernis suis, ut lucerent ante Dabir iuxta ritum, ex auro purissimo,"
,"21":"et florem et lucernas et forcipes aureos: omnia de auro perfectissimo facta sunt;"
,"22":"cultros quoque et phialas et sartagines et turibula ex auro purissimo. Et ostia templi interiora in sancta sanctorum et ostia templi forinsecus aurea."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Sicque completum est omne opus, quod fecit Salomon in do mo Domini. Intulit igitur Salomon omnia, quae voverat David pater suus, argentum et aurum, et universa vasa posuit in thesauris domus Dei."
,"2":"Post quae congregavit maiores natu Israel et cunctos principes tribuum et capita familiarum de filiis Israel in Ierusalem, ut adducerent arcam foederis Domini de civitate David, quae est Sion."
,"3":"Venerunt igitur ad regem omnes viri Israel in die sollemni mensis septimi."
,"4":"Cumque venissent cuncti seniorum Israel, portaverunt Levitae arcam"
,"5":"et intulerunt eam et tabernaculum conventus et omnem paraturam tabernaculi. Porro omnia vasa sanctuarii, quae erant in tabernaculo, portaverunt sacerdotes levitici generis."
,"6":"Rex autem Salomon et universus coetus Israel, omnes, qui fuerunt congregati ad eum ante arcam, immolabant oves et boves absque ullo numero: tanta enim erat multitudo victimarum."
,"7":"Et intulerunt sacerdotes arcam foederis Domini in locum suum ad Dabir templi, in sancta sanctorum subter alas cherubim,"
,"8":"ita ut cherubim expanderent alas suas super locum, in quo posita erat arca, et ipsam arcam tegerent cum vectibus suis ab alto."
,"9":"Vectium autem, quibus portabatur arca, quia paululum longiores erant, capita parebant ante Dabir; si vero quis erat extrinsecus eos videre non poterat. Fuit itaque arca ibi usque in praesentem diem."
,"10":"Nihilque erat aliud in arca, nisi duae tabulae, quas posuerat Moyses in Horeb, quando fecit Dominus foedus cum filiis Israel egredientibus ex Aegypto."
,"11":"Egressis autem sacerdotibus de sanctuario - omnes enim sacerdotes, qui ibi potuerant inveniri, sanctificati sunt, non observantes vices et ministeriorum ordinem,"
,"12":"et Levitae cantores, omnes, qui sub Asaph erant et qui sub Heman et qui sub Idithun, filii et fratres eorum, vestiti byssinis, cymbalis et psalteriis et citharis stabant ad orientalem plagam altaris, et cum eis sacerdotes centum viginti canentes tubis -"
,"13":"igitur cunctis pariter et tubis et voce et cymbalis et organis et diversi generis musicorum concinentibus et vocem in sublime tollentibus, cum una voce Dominum laudare coepissent et dicere: ' Confitemini Domino quoniam bonus, quoniam in aeternum misericordia eius ', impleta est domus Dei nube,"
,"14":"nec potuerunt sacerdotes stare et ministrare propter nubem; compleverat enim gloria Domini domum Dei."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Tunc Salomon ait: ' Dominus pollicitus est, ut habitaret in ca ligine;"
,"2":"ego autem aedificavi domum in habitaculum tuum, ut habitares ibi in perpetuum '."
,"3":"Et convertit rex faciem suam et benedixit universae multitudini Israel - nam omnis turba stabat intenta - et ait:"
,"4":"' Benedictus Dominus, Deus Israel, qui, quod locutus est ore suo David patri meo, opere complevit dicens:"
,"5":"'A die qua eduxi populum meum de terra Aegypti non elegi civitatem de cunctis tribubus Israel, ut aedificaretur in ea domus nomini meo, neque elegi quemquam alium virum, ut esset dux in populo meo Israel,"
,"6":"sed elegi Ierusalem, ut sit nomen meum in ea, et elegi David, ut constituerem eum super populum meum Israel'."
,"7":"Cumque fuisset voluntatis David patris mei, ut aedificaret domum nomini Domini, Dei Israel,"
,"8":"dixit Dominus ad eum: 'Quia haec fuit voluntas tua, ut aedificares domum nomini meo, bene quidem fecisti huiuscemodi habere voluntatem,"
,"9":"sed non tu aedificabis domum, verum filius tuus, qui egredietur de lumbis tuis, ipse aedificabit domum nomini meo'."
,"10":"Complevit ergo Dominus sermonem suum, quem locutus fuerat, et ego surrexi pro David patre meo et sedi super thronum Israel, sicut locutus est Dominus, et aedificavi domum nomini Domini, Dei Israel;"
,"11":"et posui in ea arcam, in qua est pactum Domini, quod pepigit cum filiis Israel '."
,"12":"Stetit ergo coram altari Domini ex adverso universae multitudinis Israel et extendit manus suas."
,"13":"Siquidem fecerat Salomon basim aeneam et posuerat eam in medio atrii habentem quinque cubitos longitudinis et quinque cubitos latitudinis et tres cubitos altitudinis, stetitque super eam; et deinceps, flexis genibus contra universam multitudinem Israel et palmis in caelum levatis,"
,"14":"ait: ' Domine, Deus Israel, non est similis tui Deus in caelo et in terra, qui custodis pactum et misericordiam cum servis tuis, qui ambulant coram te in toto corde suo,"
,"15":"qui praestitisti servo tuo David patri meo quaecumque locutus fueras ei, et, quae ore promiseras, opere complesti, sicut et praesens tempus probat."
,"16":"Nunc ergo, Domine, Deus Israel, imple servo tuo patri meo David, quaecumque locutus es dicens: 'Non deficiet ex te vir coram me, qui sedeat super thronum Israel, ita tamen si custodierint filii tui vias suas et ambulaverint in lege mea, sicut et tu ambulasti coram me'."
,"17":"Et nunc, Domine, Deus Israel, firmetur sermo tuus, quem locutus es servo tuo David!"
,"18":"Ergone credibile est, ut habitet Deus cum hominibus super terram? Si caelum et caeli caelorum non te capiunt, quanto magis domus ista, quam aedificavi!"
,"19":"Sed respice orationem servi tui et obsecrationem eius, Domine Deus meus, et audi clamorem et preces, quas fundit famulus tuus coram te,"
,"20":"ut aperias oculos tuos super domum istam diebus ac noctibus, super locum in quo pollicitus es, ut ponas nomen tuum et exaudires orationem, quam servus tuus orat in eo."
,"21":"Et exaudi preces famuli tui et populi tui Israel, qui oraverint ad locum istum; exaudi de habitaculo tuo, de caelis, exaudi et propitiare!"
,"22":"Si peccaverit quispiam in proximum suum, et ille exegerit ab eo iuramentum, ut se maledicto constringat coram altari in domo ista,"
,"23":"tu audies de caelo et facies iudicium servorum tuorum, ita ut reddas iniquo viam suam in caput proprium et ulciscaris iustum retribuens ei secundum iustitiam suam."
,"24":"Si superatus fuerit populus tuus Israel ab inimicis, quia peccaturi sunt tibi, et conversi egerint paenitentiam et confitentes nomini tuo oraverint et fuerint deprecati in domo ista,"
,"25":"tu exaudies de caelo, et propitiare peccato populi tui Israel et reduc eos in terram, quam dedisti eis et patribus eorum."
,"26":"Si clauso caelo pluvia non fluxerit propter peccata populi, et deprecati te fuerint in loco isto et confessi nomini tuo et conversi a peccatis suis, cum eos afflixeris,"
,"27":"exaudi de caelo, Domine, et dimitte peccata servorum tuorum et populi tui Israel, doce eos viam bonam, per quam ingrediantur, et da pluviam terrae, quam dedisti populo tuo ad possidendum."
,"28":"Fames si orta fuerit in terra et pestilentia, uredo et aurugo et locusta et bruchus et hostes, vastatis regionibus, portas eius obsederint, omnisque plaga et infirmitas presserit,"
,"29":"si quis de populo tuo Israel fuerit deprecatus cognoscens plagam et infirmitatem suam et expanderit manus suas ad domum hanc,"
,"30":"tu exaudi de caelo, de loco habitationis tuae, et propitiare et redde unicuique secundum vias suas, quia nosti cor eius; tu enim solus nosti corda filiorum hominum,"
,"31":"ut timeant te et ambulent in viis tuis cunctis diebus, quibus vivunt super faciem terrae, quam dedisti patribus nostris."
,"32":"Externum quoque, qui non est de populo tuo Israel, si venerit de terra longinqua propter nomen tuum magnum et propter manum tuam robustam et brachium tuum extentum, et oraverit in loco isto,"
,"33":"tu exaudies de caelo firmissimo habitaculo tuo et facies cuncta, pro quibus invocaverit te ille peregrinus, ut sciant omnes populi terrae nomen tuum et timeant te sicut populus tuus Israel et cognoscant quia nomen tuum invocatum est super domum hanc, quam aedificavi."
,"34":"Si egressus fuerit populus tuus ad bellum contra adversarios suos per viam, in qua miseris eos, et oraverint te contra viam, in qua civitas haec est, quam elegisti, et domus, quam aedificavi nomini tuo,"
,"35":"tu exaudies de caelo preces eorum et obsecrationem, et facies iudicium eorum."
,"36":"Si autem peccaverint tibi - neque enim est homo, qui non peccet - et iratus fueris eis et tradideris hostibus, et captivos duxerint eos in terram longinquam vel propinquam,"
,"37":"et conversi in corde suo in terra, ad quam captivi ducti fuerant, egerint paenitentiam et deprecati te fuerint in terra captivitatis suae dicentes: 'Peccavimus, inique fecimus, iniuste egimus';"
,"38":"et reversi fuerint ad te in toto corde suo et in tota anima sua in terra captivitatis suae, ad quam ducti sunt, et oraverint te contra viam terrae suae, quam dedisti patribus eorum, et urbis, quam elegisti, et domus, quam aedificavi nomini tuo,"
,"39":"ut exaudias de caelo, de loco habitationis tuae, preces eorum et supplicationes eorum et facias iudicium et dimittas populo tuo, qui peccavit tibi;"
,"40":"tu es enim Deus meus. Aperiantur, quaeso, oculi tui, et aures tuae intentae sint ad orationem, quae fit in loco isto."
,"41":"Nunc igitur consurge, Domine Deus, in requiem tuam, tu et arca fortitudinis tuae; sacerdotes tui, Domine Deus, induantur salutem, et sancti tui laetentur in bonis."
,"42":"Domine Deus, ne averteris faciem christi tui; memento misericordiarum David servi tui '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cumque complesset Salomon fundens preces, ignis descendit de caelo et devoravit holocaustum et victimas, et maiestas Domini implevit domum."
,"2":"Nec poterant sacerdotes ingredi templum Domini, eo quod implesset maiestas Domini templum Domini."
,"3":"Sed et omnes filii Israel videbant descendentem ignem et gloriam Domini super domum et corruentes proni in terram super pavimentum stratum lapide adoraverunt et laudaverunt Dominum: ' Quoniam bonus, quoniam in saeculum misericordia eius '."
,"4":"Rex autem et omnis populus immolabant victimas coram Domino."
,"5":"Mactavit igitur rex Salomon hostias boum viginti duo milia, ovium centum viginti milia, et dedicavit domum Dei rex et universus populus."
,"6":"Sacerdotes autem stabant in officiis suis et Levitae in organis carminum Domini, quae fecit David rex ad laudandum Dominum: ' Quoniam in aeternum misericordia eius ', hymnos David canentes per manus suas. Porro sacerdotes canebant tubis ante eos, cunctusque Israel stabat."
,"7":"Sanctificavit quoque Salomon medium atrii ante templum Domini; obtulerat enim ibi holocausta et adipes pacificorum, quia altare aeneum, quod fecerat, non poterat sustinere holocausta et oblationes et adipes."
,"8":"Fecit ergo Salomon sollemnitatem in tempore illo septem diebus, et omnis Israel cum eo, ecclesia magna valde ab introitu Emath usque ad torrentem Aegypti."
,"9":"Feceruntque die octavo collectam magnam, eo quod dedicassent altare septem diebus et sollemnitatem celebrassent diebus septem."
,"10":"Igitur in die vicesimo tertio mensis septimi dimisit populum ad tabernacula sua, laetantem atque gaudentem super bono, quod fecerat Dominus Davidi et Salomoni et Israeli populo suo."
,"11":"Complevitque Salomon domum Domini et domum regis; et in omnibus, quae disposuerat in corde suo, ut faceret in domo Domini et in domo sua, prosperatus est."
,"12":"Apparuit autem ei Dominus nocte et ait: ' Audivi orationem tuam et elegi locum istum mihi in domum sacrificii."
,"13":"Si clausero caelum, et pluvia non fluxerit, et mandavero et praecepero locustae, ut devoret terram, et misero pestilentiam in populum meum,"
,"14":"humiliatus autem populus meus, super quos invocatum est nomen meum, deprecatus me fuerit et exquisierit faciem meam et egerit paenitentiam a viis suis pessimis, ego exaudiam de caelo et propitius ero peccatis eorum et sanabo terram eorum."
,"15":"Nunc oculi mei erunt aperti, et aures meae attentae ad orationem eius, qui in loco isto oraverit;"
,"16":"elegi enim et sanctificavi locum istum, ut sit nomen meum ibi in sempiternum, et permaneant oculi mei et cor meum ibi cunctis diebus."
,"17":"Tu quoque, si ambulaveris coram me, sicut ambulavit David pater tuus, et feceris iuxta omnia, quae praecepi tibi, et decreta et iudicia mea servaveris,"
,"18":"stabiliam thronum regni tui, sicut pollicitus sum David patri tuo dicens: Non auferetur de stirpe tua vir, qui sit princeps in Israel."
,"19":"Si autem aversi fueritis et dereliqueritis decreta mea et praecepta mea, quae proposui vobis, et abeuntes servieritis diis alienis et adoraveritis eos,"
,"20":"evellam vos de terra mea, quam dedi vobis, et domum hanc, quam sanctificavi nomini meo, proiciam a facie mea et tradam eam in parabolam et in fabulam cunctis populis."
,"21":"Et super domo ista, quae erat excelsa, universi transeuntes stupebunt et dicent: 'Quare fecit Dominus sic terrae huic et domui huic?'."
,"22":"Respondebuntque: 'Quia dereliquerunt Dominum, Deum patrum suorum, qui eduxit eos de terra Aegypti, et apprehenderunt deos alienos et adoraverunt eos et coluerunt, idcirco venerunt super eos universa haec mala' '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Expletis autem viginti annis, postquam aedificavit Salomon domum Domini et domum suam,"
,"2":"civitates, quas dederat Hiram Salomoni, aedificavit et habitare ibi fecit filios Israel."
,"3":"Abiit quoque in Emath Soba et obtinuit eam."
,"4":"Et aedificavit Palmyram in deserto et omnes civitates horreorum, quas aedificavit in Emath."
,"5":"Exstruxitque Bethoron superiorem et Bethoron inferiorem, civitates munitas habentes muros et portas et vectes,"
,"6":"Baalath etiam et omnes urbes horreorum, quae fuerunt Salomonis, cunctasque urbes quadrigarum et urbes equorum. Omnia quaecumque voluit Salomon atque disposuit, aedificavit in Ierusalem et in Libano et in universa terra potestatis suae."
,"7":"Omnem populum, qui derelictus fuerat de Hetthaeis et Amorraeis et Pherezaeis et Hevaeis et Iebusaeis, qui non erant de stirpe Israel,"
,"8":"de filiis eorum, qui remanserant post eos in terra, quos non interfecerant filii Israel, subiugavit Salomon in tributarios usque in diem hanc."
,"9":"Porro de filiis Israel non posuit, ut servirent operibus regis; ipsi enim erant viri bellatores et principes pugnatorum eius et principes quadrigarum et equitum eius."
,"10":"Omnes autem principes praefectorum regis Salomonis fuerunt ducenti quinquaginta, qui praefuerant populo."
,"11":"Filiam vero pharaonis transtulit de civitate David in domum, quam aedificaverat ei; dixit enim rex: ' Non habitabit mulier mihi in domo David regis Israel, eo quod sanctificata sit, quia ingressa est in eam arca Domini '."
,"12":"Tunc obtulit Salomon holocausta Domino super altare Domini, quod exstruxerat ante porticum,"
,"13":"ut per singulos dies offerretur in eo iuxta praeceptum Moysi in sabbatis et in calendis et in festis diebus ter per annum, id est in sollemnitate Azymorum et in sollemnitate Hebdomadarum et in sollemnitate Tabernaculorum."
,"14":"Et constituit iuxta dispositionem David patris sui officia sacerdotum in ministeriis suis et Levitas in ordine suo, ut laudarent et ministrarent coram sacerdotibus iuxta ritum uniuscuiusque diei, et ianitores in divisionibus suis per portam et portam; sic enim praeceperat David homo Dei."
,"15":"Nec praetergressi sunt mandata regis de sacerdotibus et Levitis in omnibus et in custodiis thesaurorum."
,"16":"Et firmatum est totum opus Salomonis ex eo die, quo fundavit domum Domini, usque in diem, quo perfecit eam."
,"17":"Tunc abiit Salomon in Asiongaber et in Ailath ad oram maris Rubri, quae est in terra Edom."
,"18":"Misit autem ei Hiram per manus servorum suorum naves et nautas gnaros maris; et abierunt cum servis Salomonis in Ophir tuleruntque inde quadringenta quinquaginta talenta auri et attulerunt ad regem Salomonem."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Regina quoque Saba, cum audisset famam Salomonis, venit, ut tentaret eum in aenigmatibus in Ierusalem cum magno comitatu et camelis, qui portabant aromata et auri plurimum gemmasque pretiosas. Cumque venisset ad Salomonem, locuta est ei, quaecumque erant in corde suo."
,"2":"Et exposuit ei Salomon omnia, quae proposuerat, nec quidquam fuit quod ei non perspicuum fecerit."
,"3":"Quae postquam vidit, sapientiam scilicet Salomonis et domum, quam aedificaverat,"
,"4":"necnon et cibaria mensae eius et sessionem servorum et officia ministrorum eius et vestimenta eorum, pincernas quoque et vestes eorum et victimas, quas immolabat in domo Domini, non erat prae stupore ultra in ea spiritus."
,"5":"Dixitque ad regem: ' Verus est sermo, quem audieram in terra mea, de rebus tuis et sapientia tua;"
,"6":"non credebam narrantibus, donec ipsa venissem, et vidissent oculi mei, et probassem vix medietatem sapientiae tuae mihi fuisse narratam; vicisti famam, quam audivi."
,"7":"Beati viri tui et beati servi tui, qui assistunt coram te omni tempore et audiunt sapientiam tuam!"
,"8":"Sit Dominus Deus tuus benedictus, qui voluit te ordinare super thronum suum regem Domini Dei tui! Quia diligit Deus tuus Israel et vult servare eum in aeternum, idcirco posuit te super eum regem, ut facias iudicia atque iustitiam '."
,"9":"Dedit autem regi centum viginti talenta auri et aromata multa nimis et gemmas pretiosissimas; non fuerunt aromata talia ut haec, quae dedit regina Saba regi Salomoni."
,"10":"Sed et servi Hiram cum servis Salomonis attulerunt aurum de Ophir et ligna thyina et gemmas pretiosissimas;"
,"11":"et fecit rex de lignis thyinis gradus in domo Domini et in domo regia, citharas quoque et psalteria cantoribus. Numquam visa sunt in terra Iudae ligna talia."
,"12":"Rex autem Salomon dedit reginae Saba cuncta, quae voluit et quae postulavit, et multo plura quam attulerat ad eum. Quae reversa abiit in terram suam cum servis suis."
,"13":"Erat autem pondus auri, quod afferebatur Salomoni per singulos annos, sescenta sexaginta sex talenta auri,"
,"14":"excepta ea summa, quae proveniebat ex tributis mercatorum et negotiatorum afferentium et omnium regum Arabiae et ducum terrae, qui comportabant aurum et argentum Salomoni."
,"15":"Fecit igitur rex Salomon ducenta scuta aurea de summa sescentorum aureorum, qui in singulis scutis expendebantur,"
,"16":"trecentas quoque peltas aureas trecentorum aureorum, quibus tegebantur singulae peltae, posuitque ea rex in domo Saltus Libani."
,"17":"Fecit quoque rex solium eburneum grande et vestivit illud auro mundissimo;"
,"18":"sex quoque gradus, quibus ascendebatur ad solium, et scabellum aureum et brachiola duo altrinsecus et duos leones stantes iuxta brachiola,"
,"19":"sed et alios duodecim leunculos stantes super sex gradus ex utraque parte; non fuit tale solium in universis regnis."
,"20":"Omnia quoque vasa convivii regis erant aurea, et vasa domus Saltus Libani ex auro purissimo; argentum enim in diebus Salomonis pro nihilo reputabatur."
,"21":"Siquidem naves regis ibant in Tharsis cum servis Hiram; semel in annis tribus veniebant naves Tharsis portantes aurum et argentum et ebur et simias et pavos."
,"22":"Magnificatus est igitur rex Salomon super omnes reges terrae divitiis et sapientia."
,"23":"Omnesque reges terrarum desiderabant faciem videre Salomonis, ut audirent sapientiam, quam dederat Deus in corde eius,"
,"24":"et deferebant ei munera, vasa argentea et aurea et vestes et arma et aromata, equos et mulos per singulos annos."
,"25":"Habuit quoque Salomon quattuor milia stabula equorum et curruum equitumque duodecim milia; constituitque eos in urbibus quadrigarum et, ubi erat rex, in Ierusalem."
,"26":"Exercuit etiam potestatem super cunctos reges, a fluvio Euphrate usque ad terram Philisthinorum et usque ad terminos Aegypti;"
,"27":"tantamque copiam praebuit argenti in Ierusalem quasi lapidum, et cedrorum tantam multitudinem velut sycomororum, quae gignuntur in Sephela."
,"28":"Adducebantur autem ei equi de Aegypto cunctisque regionibus."
,"29":"Reliqua vero operum Salomonis priorum et novissimorum scripta sunt in verbis Nathan prophetae et in prophetia Ahiae Silonitis, in visione quoque Addo videntis super Ieroboam filium Nabat."
,"30":"Regnavit autem Salomon in Ierusalem super omnem Israel quadraginta annis;"
,"31":"dormivitque cum patribus suis, et sepelierunt eum in civitate David patris eius. Regnavitque Roboam filius eius pro eo."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Profectus est autem Roboam in Sichem; illuc enim cunctus Israel convenerat, ut constituerent eum regem."
,"2":"Quod cum audisset Ieroboam filius Nabat, qui erat in Aegypto - fugerat quippe illuc ante Salomonem - statim reversus est;"
,"3":"vocaveruntque eum, et venit cum universo Israel, et locuti sunt ad Roboam dicentes:"
,"4":"' Pater tuus durissimo iugo nos pressit; tu leviora impera patre tuo, qui nobis gravem imposuit servitutem, et paululum de onere subleva, et serviemus tibi '."
,"5":"Qui ait: ' Post tres dies revertimini ad me '. Cumque abisset populus, "
,"6":"iniit rex Roboam consilium cum senibus, qui steterant coram patre eius Salomone, dum adhuc viveret, dicens: ' Quid datis consilii, ut respondeam populo? '."
,"7":"Qui dixerunt ei: ' Si placueris populo huic et lenieris eos verbis clementibus, servient tibi omni tempore '."
,"8":"At ille reliquit consilium senum et cum iuvenibus tractare coepit, qui cum eo nutriti fuerant et erant in comitatu illius."
,"9":"Dixitque ad eos: ' Quid vobis videtur, vel respondere quid debemus populo huic, qui dixit mihi: 'Subleva iugum, quod imposuit nobis pater tuus'? '."
,"10":"Et responderunt iuvenes, qui nutriti fuerant cum eo, atque dixerunt: ' Sic loqueris populo, qui dixit tibi: 'Pater tuus aggravavit iugum nostrum, tu subleva', et sic respondebis eis: Minimus digitus meus grossior est lumbis patris mei;"
,"11":"pater meus imposuit vobis iugum grave, et ego maius pondus apponam; pater meus cecidit vos flagellis, ego vero caedam scorpionibus '."
,"12":"Venit ergo Ieroboam et universus populus ad Roboam die tertio, sicut praeceperat eis rex dicens: 'Revertimini ad me die tertio '."
,"13":"Responditque rex dura, derelicto consilio seniorum;"
,"14":"locutusque est iuxta iuvenum voluntatem: ' Pater meus grave vobis imposuit iugum, quod ego gravius faciam. Pater meus cecidit vos flagellis, ego vero caedam scorpionibus '."
,"15":"Et non acquievit populi precibus. Erat enim voluntatis Dei, ut compleretur sermo eius, quem locutus fuerat per manum Ahiae Silonitis ad Ieroboam filium Nabat."
,"16":"Israel autem universus videns quod noluisset eos audire rex, locutus est ad eum: ' Non est nobis pars in David, neque hereditas in filio Isai!,Revertere in tabernacula tua, Israel!,Tu autem vide domum tuam, David! '. Et abiit Israel in tabernacula sua. "
,"17":"Super filios autem Israel, qui habitabant in civitatibus Iudae, regnavit Roboam."
,"18":"Misitque rex Roboam Adoram, qui praeerat servituti, et lapidaverunt eum filii Israel, et mortuus est. Porro rex Roboam currum festinavit ascendere et fugit in Ierusalem."
,"19":"Recessitque Israel a domo David usque ad diem hanc."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Venit autem Roboam in Ie rusalem et convocavit univer sam domum Iudae et Beniamin, centum octoginta milia electorum bellantium, ut dimicaret contra Israel et converteret ad se regnum suum."
,"2":"Factusque est sermo Domini ad Semeiam hominem Dei dicens:"
,"3":"' Loquere ad Roboam filium Salomonis regem Iudae et ad universum Israel, qui est in Iuda et Beniamin:"
,"4":"Haec dicit Dominus: Non ascendetis neque pugnabitis contra fratres vestros. Revertatur unusquisque in domum suam, quia mea hoc gestum est voluntate '. Qui cum audissent sermonem Domini, reversi sunt nec perrexerunt contra Ieroboam."
,"5":"Habitavit autem Roboam in Ierusalem et aedificavit civitates muratas in Iuda."
,"6":"Exstruxitque Bethlehem et Etam et Thecue,"
,"7":"Bethsur quoque et Socho et Odollam"
,"8":"necnon Geth et Maresa et Ziph,"
,"9":"sed et Aduram et Lachis et Azeca,"
,"10":"Saraa quoque et Aialon et Hebron, quae erant in Iuda et Beniamin civitates munitissimas."
,"11":"Cumque clausisset eas muris, posuit in eis principes ciborumque horrea et olei et vini."
,"12":"Sed et in singulis urbibus fecit armamentarium scutorum et hastarum firmavitque eas summa diligentia et imperavit super Iudam et Beniamin."
,"13":"Sacerdotes autem et Levitae, qui erant in universo Israel, venerunt ad eum de cunctis sedibus suis."
,"14":"Levitae relinquentes suburbana et possessiones suas transierunt ad Iudam et Ierusalem, eo quod abiecisset eos Ieroboam et posteri eius, ne sacerdotio Domini fungerentur."
,"15":"Qui constituit sibi sacerdotes excelsorum et daemoniorum vitulorumque, quos fecerat."
,"16":"Sed sequentes eos et de cunctis tribubus Israel quicumque dederant cor suum, ut quaererent Dominum, Deum Israel, venerunt Ierusalem ad immolandum victimas Domino, Deo patrum suorum."
,"17":"Et roboraverunt regnum Iudae et confirmaverunt Roboam filium Salomonis per tres annos; ambulaverunt enim in viis David et Salomonis annis tantum tribus."
,"18":"Duxit autem Roboam uxorem Mahalath filiam Ierimoth filii David et Abihail filiae Eliab filii Isai,"
,"19":"quae peperit ei filios Iehus et Samariam et Zoom."
,"20":"Post hanc quoque accepit Maacha filiam Absalom, quae peperit ei Abia et Ethai et Ziza et Salomith."
,"21":"Amavit autem Roboam Maacha filiam Absalom super omnes uxores suas et concubinas; nam uxores decem et octo duxerat, concubinas autem sexaginta. Et genuit viginti octo filios et sexaginta filias."
,"22":"Constituit vero in capite Abiam filium Maacha ducem super fratres suos; ipsum enim regem facere cogitabat."
,"23":"Et sapienter filios suos dispersit in cunctis finibus Iudae et Beniamin in universis civitatibus muratis. Praebuitque eis escas plurimas et multas petivit uxores."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Cumque roboratum fuisset regnum Roboam et conforta tum, dereliquit legem Domini, et omnis Israel cum eo."
,"2":"Anno autem quinto regni Roboam ascendit Sesac rex Aegypti in Ierusalem - quia peccaverunt Domino -"
,"3":"cum mille ducentis curribus et sexaginta milibus equitum, nec erat numerus vulgi, quod venerat cum eo ex Aegypto, Libyes scilicet et Socciitae et Aethiopes."
,"4":"Cepitque civitates munitissimas in Iuda et venit usque Ierusalem."
,"5":"Semeias autem propheta ingressus est ad Roboam et principes Iudae, qui congregati fuerant in Ierusalem fugientes Sesac, dixitque ad eos: ' Haec dicit Dominus: Vos reliquistis me, et ego reliqui vos in manu Sesac '."
,"6":"Humiliatique principes Israel et rex dixerunt: ' Iustus est Dominus! '."
,"7":"Cumque vidisset Dominus quod humiliati essent, factus est sermo Domini ad Semeiam dicens: ' Quia humiliati sunt, non disperdam eos daboque eis mox effugium, et non effundetur furor meus super Ierusalem per manum Sesac."
,"8":"Verumtamen servient ei, ut sciant distantiam servitutis meae et servitutis regni terrarum '."
,"9":"Ascendit itaque Sesac rex Aegypti in Ierusalem, sublatis thesauris domus Domini et domus regis; omniaque secum tulit et clipeos aureos, quos fecerat Salomon."
,"10":"Pro quibus fecit rex Roboam aeneos et tradidit illos principibus cursorum, qui custodiebant vestibulum palatii."
,"11":"Cumque introiret rex domum Domini, veniebant cursores et tollebant eos; iterumque referebant eos ad armamentarium suum."
,"12":"Verumtamen, quia humiliatus est, aversa est ab eo ira Domini, nec deletus est penitus; siquidem et in Iuda inventa sunt opera bona."
,"13":"Confortatus est igitur rex Roboam in Ierusalem atque regnavit. Quadraginta autem et unius anni erat, cum regnare coepisset, et decem septemque annis regnavit in Ierusalem urbe, quam elegit Dominus, ut confirmaret nomen suum ibi de cunctis tribubus Israel. Nomenque matris eius Naama Ammanitis."
,"14":"Fecit autem malum et non praeparavit cor suum, ut quaereret Dominum."
,"15":"Opera vero Roboam prima et novissima scripta sunt in verbis Semeiae prophetae et Addo videntis, genealogia quoque et bella, quae erant inter Roboam et Ieroboam cunctis diebus."
,"16":"Et dormivit Roboam cum patribus suis sepultusque est in civitate David; et regnavit Abia filius eius pro eo."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Anno octavo decimo regis Ieroboam regnavit Abia su per Iudam."
,"2":"Tribus annis regnavit in Ierusalem. Nomenque matris eius Michaia filia Uriel de Gabaa. Et erat bellum inter Abiam et Ieroboam. "
,"3":"Cumque inisset Abia certamen et haberet bellicosissimos viros electorum quadringenta milia, Ieroboam instruxit e contra aciem octingenta milia virorum, qui et ipsi electi erant et ad bella fortissimi."
,"4":"Stetit igitur Abia super montem Semaraim, qui est in monte Ephraim, et ait: ' Audi, Ieroboam et omnis Israel:"
,"5":"Num ignoratis quod Dominus, Deus Israel, dederit regnum David super Israel in sempiternum, ipsi et filiis eius, pactum salis?"
,"6":"Et surrexit Ieroboam filius Nabat servus Salomonis filii David et rebellavit contra dominum suum;"
,"7":"congregatique sunt ad eum viri vanissimi, filii Belial, et praevaluerunt contra Roboam filium Salomonis. Porro Roboam erat iuvenis et corde pavido nec potuit resistere eis."
,"8":"Nunc ergo vos dicitis quod resistere possitis regno Domini, quod possidet per filios David, habetisque grandem populi multitudinem atque vitulos aureos, quos fecit vobis Ieroboam in deos."
,"9":"Et eiecistis sacerdotes Domini filios Aaron atque Levitas et fecistis vobis sacerdotes sicut populi terrarum. Quicumque venerit et initiaverit manum suam in tauro de bobus et in arietibus septem, fit sacerdos eorum, qui non sunt dii."
,"10":"Noster autem Deus Dominus est, quem non reliquimus; sacerdotesque ministrant Domino de filiis Aaron, et Levitae sunt in ordine suo."
,"11":"Holocausta quoque offerunt Domino per singulos dies, mane et vespere, et thymiama aromatum, et proponuntur panes in mensa mundissima. Estque apud nos candelabrum aureum et lucernae eius, ut accendantur semper ad vesperam; nos quippe custodimus praecepta Domini Dei nostri, quem vos reliquistis."
,"12":"Ergo in exercitu nostro dux Deus est et sacerdotes eius, qui clangunt tubis et resonant contra vos, filii Israel; nolite pugnare contra Dominum, Deum patrum vestrorum, quia non vobis expedit '."
,"13":"Ieroboam autem retro moliebatur insidias, ut venirent post eos, et erant ante Iudam, et insidiae post eos."
,"14":"Respiciensque Iuda vidit instare bellum ex adverso et post tergum et clamavit ad Dominum, ac sacerdotes tubis canere coeperunt,"
,"15":"omnesque viri Iudae vociferati sunt; et ecce, illis clamantibus, perterruit Deus Ieroboam et omnem Israel coram Abia et Iuda."
,"16":"Fugeruntque filii Israel Iudam, et tradidit eos Deus in manu eorum."
,"17":"Percussit ergo eos Abia et populus eius plaga magna; et corruerunt vulnerati ex Israel quingenta milia virorum fortium."
,"18":"Humiliatique sunt filii Israel in tempore illo, et confortati filii Iudae, eo quod sperassent in Domino, Deo patrum suorum."
,"19":"Persecutus est autem Abia fugientem Ieroboam et cepit civitates eius Bethel et filias eius et Iesana cum filiabus suis, Ephron quoque et filias eius."
,"20":"Nec invaluit ultra Ieroboam in diebus Abiae. Quem percussit Dominus, et mortuus est."
,"21":"Abia autem confortatus est et accepit sibi uxores quattuordecim procreavitque viginti duos filios et sedecim filias."
,"22":"Reliqua autem gestorum Abiae viarumque et sermonum eius scripta sunt in enarratione prophetae Addo."
,"23":"Dormivit autem Abia cum patribus suis, et sepelierunt eum in civitate David; regnavitque Asa filius eius pro eo. In cuius diebus quievit terra annis decem."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Fecit autem Asa, quod bo num et placitum erat in con spectu Domini Dei sui, et subvertit altaria peregrini cultus et excelsa"
,"2":"et confregit lapides palosque succidit"
,"3":"ac praecepit Iudae, ut quaereret Dominum, Deum patrum suorum, et faceret legem et universa mandata,"
,"4":"et abstulit e cunctis urbibus Iudae excelsa et thymiateria et regnavit in pace."
,"5":"Aedificavit quoque urbes munitas in Iuda, quia quievit terra, et nulla temporibus eius bella surrexerant, pacem Domino ei largiente."
,"6":"Dixit autem Iudae: ' Aedificemus civitates istas et vallemus muris et roboremus turribus et portis et seris, donec a bellis quieta sunt omnia; quia quaesivimus Dominum Deum nostrum, quaesivit nos et dedit nobis pacem per gyrum '. Aedificaverunt igitur et prosperati sunt."
,"7":"Habuit autem Asa exercitum portantium scuta et hastas de Iuda trecenta milia, de Beniamin vero scutariorum et sagittariorum ducenta octoginta milia; omnes isti viri fortissimi."
,"8":"Egressus est autem contra eos Zara Aethiops cum exercitu, decies centena milia et curribus trecentis, et venit usque Maresa."
,"9":"Porro Asa perrexit obviam ei, et instruxerunt aciem ad bellum in valle, quae est ad septentrionem Maresa,"
,"10":"et invocavit Asa Dominum Deum suum et ait: ' Domine, non est apud te ulla distantia, utrum paucis auxilieris an pluribus; adiuva nos, Domine Deus noster. In te enim et in tuo nomine habentes fiduciam venimus contra hanc multitudinem. Domine, Deus noster tu es, non praevaleat contra te homo '."
,"11":"Exterruit itaque Dominus Aethiopes coram Asa et Iuda; fugeruntque Aethiopes."
,"12":"Et persecutus est eos Asa et populus, qui cum eo erat, usque Gerar; et ruerunt Aethiopes usque ad internecionem, quia Domino caedente contriti sunt et exercitu illius proeliante. Tulerunt ergo spolia multa"
,"13":"et percusserunt omnes civitates per circuitum Gerarae; terror quippe Domini eos invaserat. Et diripuerunt omnes urbes et multam praedam asportaverunt."
,"14":"Sed et caulas ovium destruentes tulerunt pecorum infinitam multitudinem et camelorum reversique sunt Ierusalem."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Azarias autem filius Oded, facto in se spiritu Dei,"
,"2":"egressus est in occursum Asa et dixit ei: ' Audite me, Asa et omnis Iuda et Beniamin! Dominus vobiscum, quia fuistis cum eo. Si quaesieritis eum, invenietur a vobis; si autem dereliqueritis eum, derelinquet vos."
,"3":"Transierunt autem multi dies in Israel absque Deo veritatis et absque sacerdote doctore et absque lege."
,"4":"Cumque reversi essent in angustia sua ad Dominum, Deum Israel, et quaesivissent eum, inventus est ab eis."
,"5":"In temporibus illis non erat pax egredienti et ingredienti sed perturbatio magna multa in cunctis habitatoribus terrarum;"
,"6":"contundebatur enim gens contra gentem, et civitas contra civitatem, quia Dominus conturbabat eos in omni angustia."
,"7":"Vos autem confortamini, et non dissolvantur manus vestrae; erit enim merces operi vestro '."
,"8":"Cum audisset Asa verba haec et prophetiam, confortatus est et abstulit idola de omni terra Iudae et Beniamin et ex urbibus, quas ceperat montis Ephraim, et dedicavit altare Domini, quod erat ante porticum Domini."
,"9":"Congregavitque universum Iudam et Beniamin et advenas cum eis de Ephraim et de Manasse et de Simeon; plures enim ad eum confugerant ex Israel videntes quod Dominus Deus illius esset cum eo."
,"10":"Cumque convenissent in Ierusalem mense tertio anno quinto decimo regni Asa,"
,"11":"immolaverunt Domino in die illa de manubiis, quas adduxerant: boves septingentos et oves septem milia."
,"12":"Et inierunt foedus, ut quaererent Dominum, Deum patrum suorum, in toto corde et in tota anima sua:"
,"13":"si quis autem non quaesierit Dominum, Deum Israel, moriatur a minimo usque ad maximum, a viro usque ad mulierem."
,"14":"Iuraveruntque Domino voce magna in iubilo et in clangore tubarum et in sonitu bucinarum."
,"15":"Omnes, qui erant in Iuda, gavisi sunt de iuramento; in omni enim corde suo iuraverant et in tota voluntate quaesierant eum, et inventus fuerat ab eis. Praestititque eis Dominus requiem per circuitum."
,"16":"Sed et Maacham matrem Asa rex amovit, ne esset domina, eo quod fecisset simulacrum Aserae; quod contrivit Asa et in frusta comminuens combussit in torrente Cedron."
,"17":"Excelsa autem derelicta sunt in Israel; attamen cor Asa erat perfectum cunctis diebus eius."
,"18":"Ea quae voverat pater suus et ipse, intulit in domum Dei, argentum et aurum vasorumque diversam supellectilem."
,"19":"Bellum vero non fuit usque ad tricesimum quintum annum regni Asa."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Anno autem tricesimo sexto regni eius ascendit Baasa rex Israel in Iudam; et muro circumdabat Rama, ut nullus tute posset egredi et ingredi de regno Asa."
,"2":"Protulit ergo Asa argentum et aurum de thesauris domus Domini et domus regis misitque ad Benadad regem Syriae, qui habitabat in Damasco, dicens:"
,"3":"' Foedus inter me et te est et inter patrem meum et patrem tuum; quam ob rem misi tibi argentum et aurum, ut, rupto foedere, quod habes cum Baasa rege Israel, facias eum a me recedere '."
,"4":"Acquiescens Benadad regi Asa misit principes exercituum suorum ad urbes Israel, qui percusserunt Ahion et Dan et Abelmaim et universa horrea urbium Nephthali."
,"5":"Quod cum audisset Baasa, desivit aedificare Rama et intermisit opus suum."
,"6":"Porro Asa rex assumpsit universum Iudam, et tulerunt lapides Rama et ligna, quibus aedificaverat Baasa, aedificavitque ex eis Gabaa et Maspha."
,"7":"In tempore illo venit Hanani videns ad Asa regem Iudae et dixit ei: ' Quia habuisti fiduciam in rege Syriae et non in Domino Deo tuo, idcirco evasit Syriae regis exercitus de manu tua."
,"8":"Nonne Aethiopes et Libyes magnus exercitus erant quadrigis et equitibus et multitudine nimia, quos, cum Domino credidisses, tradidit in manu tua?"
,"9":"Oculi enim Domini contemplantur universam terram et praebent fortitudinem his, qui corde perfecto credunt in eum. Stulte igitur egisti in hoc, quia ex praesenti tempore contra te bella consurgent '."
,"10":"Iratusque Asa adversus videntem iussit eum mitti in nervum, valde quippe super hoc fuerat indignatus; et vexavit Asa quosdam de populo in tempore illo."
,"11":"Opera autem Asa prima et novissima scripta sunt in libro regum Iudae et Israel."
,"12":"Aegrotavit etiam Asa anno tricesimo nono regni sui dolore pedum vehementissimo et nec in infirmitate sua quaesivit Dominum, sed magis in medicorum arte confisus est."
,"13":"Dormivitque Asa cum patribus suis et mortuus est anno quadragesimo primo regni sui."
,"14":"Et sepelierunt eum in sepulcro suo, quod foderat sibi in civitate David; posueruntque eum super lectum plenum aromatibus et variis unguentis, quae erant pigmentariorum arte confecta, et fecerunt in exsequiis eius combustionem splendidam valde."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Regnavit autem Iosaphat filius eius pro eo et invaluit contra Israel."
,"2":"Constituitque militum numeros in cunctis urbibus Iudae, quae erant vallatae muris; praesidiaque disposuit in terra Iudae et in civitatibus Ephraim, quas ceperat Asa pater eius."
,"3":"Et fuit Dominus cum Iosaphat, quia ambulavit in viis patris sui primis et non speravit in Baalim"
,"4":"sed in Deo patris sui et perrexit in praeceptis illius et non iuxta peccata Israel."
,"5":"Confirmavitque Dominus regnum in manu eius, et dedit omnis Iuda munera Iosaphat; factaeque sunt ei infinitae divitiae et multa gloria."
,"6":"Cumque sumpsisset cor eius audaciam propter vias Domini, etiam excelsa et palos de Iuda abstulit."
,"7":"Tertio autem anno regni sui misit principes suos Benhail et Abdiam et Zachariam et Nathanael et Michaiam, ut docerent in civitatibus Iudae,"
,"8":"et cum eis Levitas Semeiam et Nathaniam et Zabadiam, Asael quoque et Semiramoth et Ionathan Adoniamque et Thobiam Levitas et cum eis Elisama et Ioram sacerdotes."
,"9":"Docebantque in Iuda habentes librum legis Domini et circuibant cunctas urbes Iudae atque erudiebant populum."
,"10":"Itaque factus est pavor Domini super omnia regna terrarum, quae erant per gyrum Iudae, nec audebant bellare contra Iosaphat."
,"11":"Sed et de Philisthim Iosaphat munera deferebant et vectigal argenti; Arabes quoque adducebant pecora arietum septem milia septingenta et hircos totidem."
,"12":"Crevit ergo Iosaphat et magnificatus est usque in sublime atque aedificavit in Iuda castella urbesque horreorum."
,"13":"Et multae copiae praesto erant ei in urbibus Iudae; viri quoque bellatores et robusti erant in Ierusalem,"
,"14":"quorum iste numerus per familias singulorum: in Iuda principes exercitus, Ednas dux, et cum eo robustissimorum trecenta milia;"
,"15":"et ad latus eius Iohanan princeps et cum eo ducenta octoginta milia;"
,"16":"ad latus quoque istius Amasias filius Zechri consecratus Domino et cum eo ducenta milia virorum fortium;"
,"17":"de Beniamin autem robustus ad proelia Eliada et cum eo tenentium arcum et clipeum ducenta milia;"
,"18":"et ad latus eius Iozabad et cum eo centum octoginta milia expeditorum militum."
,"19":"Hi omnes erant ad manum regis, exceptis aliis, quos posuerat in urbibus muratis in universo Iuda."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Fuit ergo Iosaphat dives et inclitus multum et affinitate coniunctus est Achab."
,"2":"Descenditque post annos ad eum in Samariam, ad cuius adventum mactavit Achab oves et boves plurimos ipsi et populo, qui venerat cum eo; persuasitque illi, ut ascenderet in Ramoth Galaad."
,"3":"Dixitque Achab rex Israel ad Iosaphat regem Iudae: ' Veni mecum in Ramoth Galaad '. Cui ille respondit: ' Ut ego, et tu; sicut populus tuus, sic et populus meus, tecumque erimus in bello '."
,"4":"Dixitque Iosaphat ad regem Israel: ' Consule, obsecro, impraesentiarum sermonem Domini '."
,"5":"Congregavitque rex Israel prophetarum quadringentos viros et dixit ad eos: ' In Ramoth Galaad ad bellandum ire debemus an quiescere? '. At illi: ' Ascende, inquiunt, et tradet Deus in manu regis '."
,"6":"Dixitque Iosaphat: ' Numquid non est hic et alius propheta Domini, ut ab illo etiam requiramus? '."
,"7":"Et ait rex Israel ad Iosaphat: ' Adhuc est vir unus, a quo possumus quaerere Domini voluntatem; sed ego odi eum, quia non prophetat mihi bonum sed malum omni tempore: est autem Michaeas filius Iemla '. Dixitque Iosaphat: ' Ne loquaris, rex, hoc modo '."
,"8":"Vocavit ergo rex Israel unum de eunuchis et dixit ei: ' Voca cito Michaeam filium Iemla '."
,"9":"Porro rex Israel et Iosaphat rex Iudae uterque sedebant in solio suo vestiti cultu regio; sedebant autem in area iuxta portam Samariae, omnesque prophetae vaticinabantur coram eis."
,"10":"Sedecias vero filius Chanaana fecit sibi cornua ferrea et ait: ' Haec dicit Dominus: His ventilabis Syriam, donec conteras eam '."
,"11":"Omnesque prophetae similiter prophetabant atque dicebant: ' Ascende in Ramoth Galaad et prosperaberis; et tradet Dominus in manu regis '."
,"12":"Nuntius autem, qui ierat ad vocandum Michaeam, ait illi: ' En verba omnium prophetarum uno ore bona regi annuntiant; quaeso ergo te, ut et sermo tuus ab eis non dissentiat, loquarisque prospera '."
,"13":"Cui respondit Michaeas: ' Vivit Dominus, quia, quodcumque dixerit Deus meus, hoc loquar! '."
,"14":"Venit ergo ad regem. Cui rex ait: ' Michaea, ire debemus in Ramoth Galaad ad bellandum an quiescere? '. Cui ille respondit: ' Ascendite et prosperamini, ut tradantur hostes in manus vestras '."
,"15":"Dixitque rex: ' Iterum atque iterum te adiuro, ut non mihi loquaris nisi, quod verum est, in nomine Domini '."
,"16":"At ille ait: ' Vidi universum Israel,dispersum in montibus,sicut oves absque pastore. Et dixit Dominus: 'Non habent isti dominum; revertatur unusquisque in domum suam in pace' '."
,"17":"Et ait rex Israel ad Iosaphat: ' Nonne dixi tibi quod non prophetaret iste mihi quidquam boni sed ea, quae mala sunt? '."
,"18":"At ille idcirco ait: ' Audite verbum Domini: Vidi Dominum sedentem in solio suo et omnem exercitum caeli assistentem ei a dextris et sinistris."
,"19":"Et dixit Dominus: 'Quis decipiet Achab regem Israel, ut ascendat et corruat in Ramoth Galaad?'. Cumque diceret unus hoc modo et alter alio,"
,"20":"processit spiritus et stetit coram Domino et ait: 'Ego decipiam eum'. Cui Dominus: 'In quo, inquit, decipies?'."
,"21":"At ille respondit: 'Egrediar et ero spiritus mendax in ore omnium prophetarum eius'. Dixitque Dominus: 'Decipies et praevalebis; egredere et fac ita'."
,"22":"Nunc igitur, ecce dedit Dominus spiritum mendacii in ore omnium prophetarum tuorum et Dominus locutus est de te mala '."
,"23":"Accessit autem Sedecias filius Chanaana et percussit Michaeae maxillam et ait: ' Per quam viam transivit spiritus Domini a me, ut loqueretur tibi? '."
,"24":"Dixitque Michaeas: ' Tu ipse videbis in die illo, quando ingressus fueris cubiculum intra cubiculum, ut abscondaris '."
,"25":"Praecepit autem rex Israel dicens: ' Tollite Michaeam et ducite eum ad Amon principem civitatis et ad Ioas filium regis"
,"26":"et dicetis: 'Haec dicit rex: Mittite hunc in carcerem et date ei panis modicum et aquae pauxillum, donec revertar in pace' '."
,"27":"Dixitque Michaeas: ' Si reversus fueris in pace, non est locutus Dominus in me '. Et ait: ' Audite, populi omnes! '."
,"28":"Igitur ascenderunt rex Israel et Iosaphat rex Iudae in Ramoth Galaad."
,"29":"Dixitque rex Israel ad Iosaphat: ' Mutabo habitum et sic ad pugnam vadam; tu autem induere vestibus tuis '. Mutatoque rex Israel habitu venit ad bellum."
,"30":"Rex autem Syriae praeceperat ducibus curruum suorum dicens: ' Ne pugnetis contra minimum aut contra maximum, nisi contra solum regem Israel '."
,"31":"Itaque, cum vidissent principes curruum Iosaphat, dixerunt: ' Rex Israel est iste! '. Et circumdederunt eum dimicantes. At ille clamavit ad Dominum, et auxiliatus est ei atque avertit eos Deus ab illo."
,"32":"Cum enim vidissent duces curruum quod non esset rex Israel, reliquerunt eum."
,"33":"Accidit autem, ut unus e populo sagittam in incertum iaceret et percuteret regem Israel inter iuncturas et loricam. At ille aurigae suo ait: ' Converte manum tuam et educ me de acie, quia vulneratus sum '."
,"34":"Et aggravata est pugna in die illo; porro rex Israel stabat in curru suo contra Syros usque ad vesperam et mortuus est occidente sole."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Reversus est autem Iosaphat rex Iudae in domum suam pacifice in Ierusalem."
,"2":"Cui occurrit Iehu filius Hanani videns et ait ad eum: ' Impio praebes auxilium et his, qui oderunt Dominum, amicitia iungeris, et idcirco iram quidem Domini merebaris;"
,"3":"sed bona opera inventa sunt in te, eo quod abstuleris palos de terra et praeparaveris cor tuum, ut requireres Deum '."
,"4":"Habitavit ergo Iosaphat in Ierusalem. Rursumque egressus est ad populum de Bersabee usque ad montem Ephraim et revocavit eos ad Dominum, Deum patrum suorum."
,"5":"Constituitque iudices terrae in cunctis civitatibus Iudae munitis per singula loca."
,"6":"Et praecipiens iudicibus: ' Videte, ait, quid faciatis. Non enim homini exercetis iudicium sed Domino, qui vobiscum est, quando iudicaveritis."
,"7":"Sit timor Domini, vobiscum et caute cuncta facite; non est enim apud Dominum Deum nostrum iniquitas nec personarum acceptio nec cupido munerum '."
,"8":"In Ierusalem quoque constituit Iosaphat ex Levitis et sacerdotibus et principibus familiarum Israel pro iudicio Domini et pro causis habitatorum Ierusalem."
,"9":"Praecepitque eis dicens: ' Sic agetis in timore Domini fideliter et corde perfecto."
,"10":"Omnem causam, quae venerit ad vos fratrum vestrorum, qui habitant in urbibus suis, ubicumque quaestio est de homicidio, de lege, de mandato, de praeceptis et de iustificationibus, commonete eos, ut non peccent in Dominum, et ne veniat ira super vos et super fratres vestros; sic ergo agetis et non peccabitis."
,"11":"Amarias autem sacerdos princeps super vos in omnibus, quae ad Deum pertinent, praesidebit; porro Zabadias filius Ismael, qui est dux in domo Iudae, super ea opera erit, quae ad regis officium pertinent; habetisque Levitas coram vobis ut scribas. Confortamini et agite diligenter, et sit Dominus cum bonis '."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Post haec congregati sunt filii Moab et filii Ammon et cum eis de Meunitis ad Iosaphat, ut pugnarent contra eum."
,"2":"Veneruntque nuntii et indicaverunt Iosaphat dicentes: ' Venit contra te multitudo magna de his locis, quae trans mare sunt, de Edom, et ecce consistunt in Asasonthamar, quae est Engaddi '."
,"3":"Iosaphat autem timore perterritus totum se contulit ad rogandum Dominum et praedicavit ieiunium universo Iudae."
,"4":"Congregatusque est Iuda ad precandum Dominum; sed et de omnibus urbibus suis venerunt ad obsecrandum eum."
,"5":"Cumque stetisset Iosaphat in medio coetu Iudae et Ierusalem in domo Domini ante atrium novum,"
,"6":"ait: ' Domine, Deus patrum nostrorum, tu es Deus in caelo et dominaris cunctis regnis gentium; in manu tua est fortitudo et potentia, nec quisquam tibi potest resistere."
,"7":"Nonne tu, Deus noster, expulisti habitatores terrae huius coram populo tuo Israel et dedisti eam semini Abraham amici tui in sempiternum?"
,"8":"Habitaveruntque in ea et exstruxerunt in illa sanctuarium nomini tuo dicentes:"
,"9":"'Si irruerint super nos mala, gladius iudicii, pestilentia et fames, stabimus coram domo hac in conspectu tuo, quia nomen tuum est in domo hac, et clamabimus ad te in tribulationibus nostris, et exaudies salvosque facies'."
,"10":"Nunc igitur ecce filii Ammon et Moab et mons Seir, per quos non concessisti Israeli ut transirent, quando egrediebantur de Aegypto, sed declinaverunt ab eis et non interfecerunt illos,"
,"11":"e contrario agunt et nituntur eicere nos de possessione tua, quam tradidisti nobis."
,"12":"Deus noster, ergo non iudicabis eos? In nobis quidem non tanta est fortitudo, ut possimus huic multitudini resistere, quae irruit super nos; sed, cum ignoremus quid agere debeamus, hoc solum habemus residui, ut oculos nostros dirigamus ad te '."
,"13":"Omnis vero Iuda stabat coram Domino cum parvulis et uxoribus et liberis suis."
,"14":"Erat autem Iahaziel filius Zachariae filii Banaiae filii Iehiel filii Matthaniae Levites de filiis Asaph, super quem factus est spiritus Domini in medio congregationis,"
,"15":"et ait: ' Attendite, omnis Iuda et qui habitatis Ierusalem et tu rex Iosaphat: Haec dicit Dominus vobis: Nolite timere nec paveatis hanc multitudinem magnam; non est enim vestra pugna sed Dei."
,"16":"Cras descendetis contra eos; ascensuri enim sunt per clivum nomine Sis, et invenietis illos in summitate torrentis, qui est contra solitudinem Ieruel."
,"17":"Non eritis vos, qui dimicabitis; sed tantummodo confidenter state et videbitis auxilium Domini super vos, o Iuda et Ierusalem. Nolite timere nec paveatis; cras egredimini contra eos, et Dominus erit vobiscum '."
,"18":"Iosaphat ergo inclinavit se super faciem suam in terra, et omnis Iuda et habitatores Ierusalem ceciderunt coram Domino et adoraverunt eum."
,"19":"Porro Levitae de filiis Caath, de filiis Core scilicet, surrexerunt et laudabant Dominum, Deum Israel, voce magna in excelsum."
,"20":"Cumque mane surrexissent, egressi sunt ad desertum Thecue; profectisque eis, stans Iosaphat in medio eorum dixit: ' Audite me, Iuda et habitatores Ierusalem! Credite in Domino Deo vestro et permanebitis; credite prophetis eius, et cuncta evenient vobis prospera '."
,"21":"Habuitque consilium cum populo et statuit cantores Domini, ut laudarent eum in ornatu sancto et antecederent exercitum ac voce consona dicerent: ' Confitemini Domino, quoniam in aeternum misericordia eius '."
,"22":"Cumque coepissent laudes canere, vertit Dominus insidias eorum contra filios Ammon et Moab et montem Seir, qui egressi fuerant, ut pugnarent contra Iudam, et percussi sunt."
,"23":"Et filii Ammon et Moab consurrexerunt adversum habitatores montis Seir, ut interficerent et delerent eos; cumque hoc opere perpetrassent, etiam in semetipsos versi mutuis concidere vulneribus."
,"24":"Porro Iuda, cum venisset ad speculam, quae respicit solitudinem, vidit procul omnem late regionem plenam cadaveribus, nec superesse quemquam, qui necem potuisset evadere."
,"25":"Venit ergo Iosaphat et omnis populus cum eo ad detrahenda spolia mortuorum inveneruntque iumenta multa et supellectilem, vestes quoque et vasa pretiosissima et diripuerunt, ita ut omnia portare non possent, et per tres dies spolia auferebant pro praedae magnitudine."
,"26":"Die autem quarto congregati sunt in valle Baracha; etenim, quoniam ibi benedixerant Domino, vocaverunt locum illum vallis Benedictionis usque in praesentem diem."
,"27":"Reversusque est omnis vir Iudae et Ierusalem et Iosaphat ante eos in Ierusalem cum laetitia magna, eo quod dedisset eis Dominus gaudium de inimicis suis;"
,"28":"ingressique sunt Ierusalem cum psalteriis et citharis et tubis in domum Domini."
,"29":"Irruit autem pavor Dei super universa regna terrarum, cum audissent quod pugnasset Dominus contra inimicos Israel."
,"30":"Quievitque regnum Iosaphat, et praebuit ei Deus eius pacem per circuitum."
,"31":"Regnavit igitur Iosaphat super Iudam. Et erat triginta quinque annorum, cum regnare coepisset; viginti autem et quinque annis regnavit in Ierusalem. Nomen matris eius Azuba filia Selachi."
,"32":"Et ambulavit in via patris sui Asa nec declinavit ab ea, faciens quod rectum erat coram Domino."
,"33":"Verumtamen excelsa non ablata sunt; et adhuc populus non direxerat cor suum ad Deum patrum suorum."
,"34":"Reliqua autem gestorum Iosaphat, priorum et novissimorum, scripta sunt in verbis Iehu filii Hanani, quae digesta sunt in libros regum Israel."
,"35":"Post haec iniit amicitias Iosaphat rex Iudae cum Ochozia rege Israel, cuius opera fuerunt impiissima,"
,"36":"et particeps fuit, ut facerent naves, quae irent in Tharsis, feceruntque classem in Asiongaber."
,"37":"Prophetavit autem Eliezer filius Dodiae de Maresa contra Iosaphat dicens: ' Quia habuisti foedus cum Ochozia, percussit Dominus opera tua '. Contritaeque sunt naves nec potuerunt ire in Tharsis."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Dormivit autem Iosaphat cum patribus suis et sepultus est cum eis in civitate David; regnavitque Ioram filius eius pro eo."
,"2":"Qui habuit fratres filios Iosaphat Azariam et Iahiel et Zachariam et Azariam et Michael et Saphatiam: omnes hi filii Iosaphat regis Israel."
,"3":"Deditque eis pater suus multa munera argenti et auri et res pretiosas cum civitatibus munitissimis in Iuda; regnum autem tradidit Ioram, eo quod esset primogenitus."
,"4":"Surrexit ergo Ioram super regnum patris sui; cumque se confirmasset, occidit omnes fratres suos gladio et quosdam de principibus Israel."
,"5":"Triginta duorum annorum erat Ioram, cum regnare coepisset, et octo annis regnavit in Ierusalem."
,"6":"Ambulavitque in viis regum Israel, sicut egerat domus Achab; filia quippe Achab erat uxor eius. Et fecit malum in conspectu Domini."
,"7":"Noluit autem Dominus disperdere domum David propter pactum, quod inierat cum eo, et quia promiserat, ut daret ei lucernam et filiis eius omni tempore."
,"8":"In diebus illis rebellavit Edom, ne esset subditus Iudae, et constituit sibi regem."
,"9":"Cumque transisset Ioram cum principibus suis et cunctis curribus, qui erant secum, surrexit nocte et percussit Edom, qui eum circumdederat, et omnes duces curruum eius."
,"10":"Attamen rebellavit Edom, ne esset sub dicione Iudae, usque ad hanc diem. Eo tempore et Lobna recessit, ne esset sub manu illius; dereliquerat enim Dominum, Deum patrum suorum."
,"11":"Insuper et excelsa fabricatus est in montibus Iudae et fornicari fecit habitatores Ierusalem et praevaricari Iudam."
,"12":"Allatae sunt autem ei litterae ab Elia propheta, in quibus scriptum erat: 'Haec dicit Dominus, Deus David patris tui: Quoniam non ambulasti in viis Iosaphat patris tui et in viis Asa regis Iudae,"
,"13":"sed incessisti per iter regum Israel et fornicari fecisti Iudam et habitatores Ierusalem imitatus fornicationem domus Achab, insuper et fratres tuos domum patris tui meliores te occidisti:"
,"14":"ecce Dominus percutiet plaga magna populum tuum, filios et uxores tuas universamque substantiam tuam;"
,"15":"tu autem aegrotabis pessimo languore uteri tui, donec egrediantur vitalia tua paulatim per singulos dies '."
,"16":"Suscitavit ergo Dominus contra Ioram spiritum Philisthinorum et Arabum, qui confines sunt Aethiopibus,"
,"17":"et ascenderunt in terram Iudae et irruperunt in eam diripueruntque cunctam substantiam, quae inventa est in domo regis, insuper et filios eius et uxores, nec remansit ei filius nisi Ioachaz, qui minimus natu erat."
,"18":"Et post haec omnia percussit eum Dominus alvi languore insanabili."
,"19":"Cumque diei succederet dies, et temporum spatia volverentur, duorum annorum expletus est circulus; et sic longa consumptus tabe, ita ut egereret etiam viscera sua, languore pariter et vita caruit. Mortuusque est in infirmitate pessima, et non fecit ei populus eius secundum morem combustionis exsequias, sicut fecerat maioribus eius."
,"20":"Triginta duorum annorum fuit, cum regnare coepisset, et octo annis regnavit in Ierusalem. Obiitque nullo relicto desiderio sui; et sepelierunt eum in civitate David, verumtamen non in sepulcro regum."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Constituerunt autem habita tores Ierusalem Ochoziam fi lium eius minimum regem pro eo; omnes enim maiores natu interfecerat turba, quae irruerat cum Arabibus in castra. Regnavitque Ochozias filius Ioram regis Iudae."
,"2":"Filius viginti duo annorum erat Ochozias, cum regnare coepisset, et uno anno regnavit in Ierusalem. Nomen matris eius Athalia filia Amri."
,"3":"Sed et ipse ingressus est per vias domus Achab; mater enim eius impulit eum, ut impie ageret."
,"4":"Fecit igitur malum in conspectu Domini sicut domus Achab; ipsi enim fuerunt ei consiliarii post mortem patris sui in interitum eius."
,"5":"Ambulavitque in consiliis eorum et perrexit cum Ioram filio Achab rege Israel in bellum contra Hazael regem Syriae in Ramoth Galaad; vulneraveruntque Syri Ioram."
,"6":"Qui reversus est, ut curaretur in Iezrahel a plagis, quas acceperat in supradicto certamine. Igitur Ochozias filius Ioram rex Iudae descendit, ut inviseret Ioram filium Achab in Iezrahel aegrotantem. "
,"7":"Voluntatis quippe fuit Dei adversum Ochoziam, ut veniret ad Ioram et, cum venisset, egrederetur cum eo adversum Iehu filium Namsi, quem unxit Dominus, ut deleret domum Achab."
,"8":"Cum ergo iudicium faceret Iehu in domum Achab, invenit principes Iudae et filios fratrum Ochoziae, qui ministrabant ei, et interfecit illos."
,"9":"Ipsumque perquisivit Ochoziam, et comprehenderunt eum latentem in Samaria; adductumque ad se Iehu occidit. Et sepelierunt eum, eo quod dicebant eum esse filium Iosaphat, qui quaesierat Dominum in toto corde suo. Nec erat aliquis de stirpe Ochoziae, qui posset regnare. "
,"10":"Athalia autem mater eius videns quod mortuus esset filius suus surrexit et interfecit omnem stirpem regiam domus Iudae."
,"11":"Porro Iosabeth filia regis tulit Ioas filium Ochoziae et furata est eum de medio filiorum regis, cum interficerentur, absconditque cum nutrice sua in cubiculo lectulorum. Iosabeth autem, quae absconderat eum, erat filia regis Ioram, uxor Ioiadae pontificis, soror Ochoziae; et idcirco Athalia non interfecit eum."
,"12":"Fuit ergo cum eis in domo Dei absconditus sex annis, quibus regnavit Athalia super terram."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Anno autem septimo confor tatus Ioiada assumpsit centu riones, Azariam videlicet filium Ieroham et Ismael filium Iohanan, Azariam quoque filium Obed et Maasiam filium Adaiae et Elisaphat filium Zechri, et iniit cum eis foedus."
,"2":"Qui circumeuntes Iudam congregaverunt Levitas de cunctis urbibus Iudae et principes familiarum Israel veneruntque in Ierusalem."
,"3":"Iniit igitur omnis congregatio pactum in domo Dei cum rege. Dixitque ad eos Ioiada: ' Ecce filius regis regnabit, sicut locutus est Dominus super filios David."
,"4":"Hoc est ergo, quod facietis."
,"5":"Tertia pars vestrum, qui veniunt ad sabbatum sacerdotum et Levitarum et ianitorum, erit in portis, tertia vero pars ad domum regis et tertia in porta, quae appellatur Fundamenti; omne vero reliquum vulgus sit in atriis domus Domini."
,"6":"Nec quisquam alius ingrediatur domum Domini, nisi sacerdotes et qui ministrant de Levitis; ipsi tantummodo ingrediantur, quia sanctificati sunt. Et omne reliquum vulgus observet observationem Domini."
,"7":"Levitae autem circumdent regem habentes singuli arma sua in manu. Et si quis alius ingressus fuerit templum, interficiatur. Sintque cum rege et intrante et egrediente '."
,"8":"Fecerunt igitur Levitae et universus Iuda iuxta omnia, quae praeceperat Ioiada pontifex; et assumpserunt singuli viros suos, qui veniebant sabbato cum his, qui sabbato egressuri erant: siquidem Ioiada pontifex non dimisit abire turmas, quae sibi per singulas hebdomadas succedere consueverant."
,"9":"Deditque Ioiada sacerdos centurionibus lanceas clipeosque et peltas regis David, quae erant in domo Dei."
,"10":"Constituitque omnem populum tenentium tela a parte templi dextra usque ad partem templi sinistram coram altari et templo per circuitum regis."
,"11":"Et eduxerunt filium regis et dederunt ei diadema et testimonium et constituerunt eum regem. Unxerunt quoque illum Ioiada pontifex et filii eius; imprecatique sunt ei atque dixerunt: ' Vivat rex! '."
,"12":"Quod cum audisset Athalia, vocem scilicet currentium atque laudantium regem, ingressa est ad populum in templum Domini."
,"13":"Cumque vidisset regem stantem super gradum suum in introitu et principes tubasque circa eum omnemque populum terrae gaudentem atque clangentem tubis cantoresque cum diversi generis organis signum dantes ad laudandum, scidit vestimenta sua et ait: ' Coniuratio, coniuratio! '."
,"14":"Praecepit autem Ioiada pontifex centurionibus, qui erant super exercitum, dicens: ' Educite illam extra saepta templi! Qui autem sequetur eam, interficiatur foris gladio! '. Dixerat enim sacerdos: ' Non occidetis eam in domo Domini! '."
,"15":"Et imposuerunt ei manus; cumque intrasset portam Equorum domus regis, interfecerunt eam ibi."
,"16":"Pepigit autem Ioiada foedus inter se universumque populum et regem, ut esset populus Domini."
,"17":"Itaque ingressus est omnis populus domum Baal et destruxerunt eam et altaria ac simulacra illius confregerunt; Matthan quoque sacerdotem Baal interfecerunt ante aras."
,"18":"Constituit autem Ioiada praepositos in domo Domini sub manibus sacerdotum et Levitarum, quos distribuit David in domo Domini, ut offerrent holocausta Domino, sicut scriptum est in lege Moysi, in gaudio et canticis iuxta dispositionem David."
,"19":"Constituit quoque ianitores in portis domus Domini, ut non ingrederetur eam immundus in omni re."
,"20":"Assumpsitque centuriones et fortissimos viros ac principes populi et omne vulgus terrae, et fecerunt descendere regem de domo Domini et introire per medium portae Superioris in domum regis et collocaverunt eum in solio regali."
,"21":"Laetatusque est omnis populus terrae, et urbs quievit; porro Athalia interfecta est gladio."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Septem annorum erat Ioas, cum regnare coepisset, et quadraginta annis regnavit in Ierusalem. Nomen matris eius Sebia de Bersabee."
,"2":"Fecitque, quod bonum est coram Domino, cunctis diebus Ioiadae sacerdotis."
,"3":"Accepit autem ei Ioiada uxores duas, e quibus genuit filios et filias."
,"4":"Post quae placuit Ioas, ut instauraret domum Domini."
,"5":"Congregavitque sacerdotes et Levitas et dixit eis: ' Egredimini ad civitates Iudae et colligite de universo Israel pecuniam ad sartatecta templi Dei vestri per singulos annos. Festinatoque hoc facite '. Porro Levitae non festinarunt."
,"6":"Vocavitque rex Ioiadam principem et dixit ei: ' Quare non tibi fuit curae, ut cogeres Levitas inferre de Iuda et de Ierusalem pecuniam, quae constituta est a Moyse servo Domini, ut inferret eam omnis congregatio Israel in tabernaculum testimonii?"
,"7":"Athalia enim impiissima et filii eius dissipaverunt domum Dei et de universis, quae sanctificata fuerant templo Domini, dedicaverunt Baalim '."
,"8":"Praecepit ergo rex, et fecerunt arcam posueruntque eam iuxta portam domus Domini forinsecus."
,"9":"Et praedicatum est in Iuda et Ierusalem, ut deferrent singuli pretium Domino, quod constituit Moyses servus Dei super Israel in deserto."
,"10":"Laetatique sunt cuncti principes et omnis populus et ingressi contulerunt in arcam atque miserunt ita, ut impleretur."
,"11":"Cumque tempus esset, ut deferrent arcam ad magistratus regis per manus Levitarum, et viderent multam esse pecuniam, ingrediebatur scriba regis et quem primus sacerdos constituerat, effundebantque pecuniam, quae erat in arca; porro arcam reportabant ad locum suum. Sicque faciebant per singula tempora, et congregata est infinita pecunia,"
,"12":"quam dederunt rex et Ioiada his, qui praeerant operibus domus Domini. At illi conducebant ex ea caesores lapidum et artifices operum singulorum, ut instaurarent domum Domini, fabros quoque ferri et aeris, ut domus Dei fulciretur."
,"13":"Egeruntque operarii, et obducebatur cicatrix operi per manus eorum, ac suscitaverunt domum Domini in statum pristinum et firme eam stare fecerunt."
,"14":"Cumque haec complessent, detulerunt coram rege et Ioiada reliquam partem pecuniae, de qua facta sunt vasa templi in ministerium et ad holocausta, phialae quoque et cetera vasa aurea et argentea. Et offerebantur holocausta in domo Domini iugiter cunctis diebus Ioiadae."
,"15":"Senuit autem Ioiada plenus dierum et mortuus est cum centum triginta esset annorum."
,"16":"Sepelieruntque eum in civitate David cum regibus, eo quod fecisset bonum in Israel cum Deo et cum domo eius."
,"17":"Postquam autem obiit Ioiada, ingressi sunt principes Iudae et adoraverunt regem, qui delinitus obsequiis eorum acquievit eis."
,"18":"Et dereliquerunt templum Domini, Dei patrum suorum, servieruntque palis et sculptilibus, et facta est ira contra Iudam et Ierusalem propter hoc peccatum."
,"19":"Mittebatque eis prophetas, ut reverterentur ad Dominum, quos protestantes illi audire nolebant."
,"20":"Spiritus itaque Dei induit Zachariam filium Ioiadae sacerdotis; et stetit in conspectu populi et dixit eis: ' Haec dicit Deus: Quare transgredimini praecepta Domini, quod vobis non proderit? Quia dereliquistis Dominum, ipse dereliquit vos '."
,"21":"Qui coniuraverunt adversus eum et lapidaverunt eum iuxta regis imperium in atrio domus Domini."
,"22":"Et non est recordatus Ioas rex misericordiae, quam fecerat Ioiada pater illius secum, sed interfecit filium eius. Qui cum moreretur, ait: ' Videat Dominus et requirat! '."
,"23":"Cumque evolutus esset annus, ascendit contra eum exercitus Syriae venitque in Iudam et Ierusalem et exterminaverunt cunctos principes populi atque universam praedam miserunt regi Damascum."
,"24":"Et certe, cum permodicus venisset numerus Syrorum, tradidit Dominus manibus eorum exercitum magnum valde, eo quod reliquissent Dominum, Deum patrum suorum; in Ioas quoque ignominiosa exercuere iudicia."
,"25":"Et abeuntes dimiserunt eum in languoribus magnis. Coniuraverunt autem contra eum servi sui in ultionem sanguinis filii Ioiadae sacerdotis et occiderunt eum in lectulo suo, et mortuus est. Sepelieruntque eum in civitate David, sed non in sepulcris regum."
,"26":"Insidiati vero sunt ei Zabad filius Semath Ammanitidis et Iozabad filius Semarith Moabitidis."
,"27":"Porro de filiis eius, de summa tributi, quod impositum fuerat sub eo, et de instauratione domus Dei scriptum est in commentariis libri regum. Regnavitque Amasias filius eius pro eo."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Viginti quinque annorum erat Amasias, cum regnare coepisset, et viginti novem annis regnavit in Ierusalem. Nomen matris eius Ioaden de Ierusalem."
,"2":"Fecitque bonum in conspectu Domini, verumtamen non in corde perfecto."
,"3":"Cumque roboratum sibi videret imperium, iugulavit servos suos, qui occiderant regem patrem suum,"
,"4":"sed filios eorum non interfecit, sicut scriptum est in libro legis Moysi, ubi praecepit Dominus dicens: ' Non occidentur patres pro filiis, neque filii pro patribus suis, sed unusquisque in suo peccato morietur '."
,"5":"Congregavit igitur Amasias Iudam et constituit eos per familias tribunosque et centuriones in universo Iuda et Beniamin. Et recensuit a viginti annis sursum invenitque trecenta milia iuvenum, qui egrederentur ad pugnam et tenerent hastam et clipeum."
,"6":"Mercede quoque conduxit de Israel centum milia robustorum centum talentis argenti."
,"7":"Venit autem homo Dei ad illum et ait: ' O rex, ne egrediatur tecum exercitus Israel; non est enim Dominus cum Israel, cunctis filiis Ephraim."
,"8":"Quod si putas in robore exercitus bella consistere, superari te faciet Deus ab hostibus: Dei quippe est et adiuvare et in fugam vertere '."
,"9":"Dixitque Amasias ad hominem Dei: ' Quid ergo fiet de centum talentis, quae dedi militibus Israel? '. Et respondit ei homo Dei: ' Habet Dominus, unde tibi dare possit multo his plura '."
,"10":"Separavit itaque Amasias exercitum, qui venerat ad eum ex Ephraim, ut reverteretur in locum suum; at illi contra Iudam vehementer irati reversi sunt in regionem suam."
,"11":"Porro Amasias confidenter eduxit populum suum et abiit in vallem Salinarum percussitque filios Seir decem milia."
,"12":"Et alia decem milia virorum ceperunt filii Iudae et adduxerunt ad praeruptum cuiusdam petrae praecipitaveruntque eos de summo in praeceps, qui universi crepuerunt."
,"13":"At ille exercitus, quem remiserat Amasias, ne secum iret ad proelium, diffusus est in civitatibus Iudae a Samaria usque Bethoron et, interfectis tribus milibus, diripuit praedam magnam."
,"14":"Amasias vero, post caedem Idumaeorum et allatos deos filiorum Seir, statuit illos in deos sibi et adorabat eos et illis adolebat."
,"15":"Quam ob rem iratus Dominus contra Amasiam misit ad illum prophetam, qui diceret ei: ' Cur adorasti deos, qui non liberaverunt populum suum de manu tua? '."
,"16":"Cumque haec ille loqueretur, respondit ei: ' Num consiliarium regis fecimus te? Quiesce! Cur interficiam te? '. Discedensque propheta: ' Sed scio, inquit, quod decrevit Deus occidere te, quia fecisti hoc et non acquievisti consilio meo '."
,"17":"Igitur Amasias rex Iudae, inito consilio, misit ad Ioas filium Ioachaz filii Iehu regem Israel dicens: ' Veni, videamus nos mutuo! '."
,"18":"At ille remisit nuntium dicens: ' Carduus, qui est in Libano, misit ad cedrum Libani dicens: 'Da filiam tuam filio meo uxorem'. Et ecce bestiae agri, quae erant in Libano, transierunt et conculcaverunt carduum."
,"19":"Dixisti: 'Percussi Edom!'. Et idcirco erigitur cor tuum in superbiam. Sede in domo tua! Cur malum adversum te provocas, ut cadas et tu et Iuda tecum? '."
,"20":"Noluit audire Amasias, eo quod Domini esset voluntas, ut traderetur in manibus hostium propter cultum deorum Edom."
,"21":"Ascendit igitur Ioas rex Israel, et mutuos sibi praebuere conspectus: ipse et Amasias rex Iudae in Bethsames Iudae."
,"22":"Corruitque Iuda coram Israel et fugit in tabernacula sua."
,"23":"Porro Amasiam regem Iudae filium Ioas filii Ioachaz cepit Ioas rex Israel in Bethsames et adduxit in Ierusalem destruxitque murum eius a porta Ephraim usque ad portam Anguli quadringentis cubitis."
,"24":"Omne quoque aurum et argentum et universa vasa, quae repererat in domo Dei et apud Obededom in thesauris etiam domus regiae, necnon et obsides reduxit Samariam."
,"25":"Vixit autem Amasias filius Ioas rex Iudae, postquam mortuus est Ioas filius Ioachaz rex Israel, quindecim annis."
,"26":"Reliqua vero gestorum Amasiae priorum et novissimorum scripta sunt in libro regum Iudae et Israel."
,"27":"Qui postquam recessit a Domino, tetenderunt ei insidias in Ierusalem; cumque fugisset Lachis, miserunt post eum in Lachis et interfecerunt eum ibi."
,"28":"Reportantesque super equos sepelierunt eum cum patribus suis in civitate David."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Omnis autem populus Iudae Oziam annorum sedecim constituit regem pro patre suo Amasia."
,"2":"Ipse reaedificavit Ailath et restituit eam dicioni Iudae, postquam dormivit rex cum patribus suis."
,"3":"Sedecim annorum erat Ozias, cum regnare coepisset, et quinquaginta duobus annis regnavit in Ierusalem. Nomen matris eius Iechelia de Ierusalem."
,"4":"Fecitque, quod erat rectum in oculis Domini iuxta omnia, quae fecerat Amasias pater eius."
,"5":"Et exquisivit Deum in diebus Zachariae, qui erudivit eum in timore Dei; et quamdiu requirebat Dominum, eum prosperari fecit Deus."
,"6":"Denique egressus est et pugnavit contra Philisthim et destruxit murum Geth et murum Iabniae murumque Azoti. Aedificavit quoque oppida in regione Azoti et Philisthim."
,"7":"Et adiuvit eum Deus contra Philisthim et contra Arabas, qui habitabant in Gurbaal, et contra Meunitas."
,"8":"Pendebantque Ammonitae munera Oziae; et divulgatum est nomen eius usque ad introitum Aegypti, quia confortatus est in excelsum."
,"9":"Aedificavitque Ozias turres in Ierusalem super portam Anguli et super portam Vallis et super Angulum firmavitque eas."
,"10":"Exstruxit etiam turres in solitudine et fodit cisternas plurimas, eo quod haberet multa pecora tam in Sephela quam in planitie; agricolas quoque habuit et vinitores in montibus et in campis fertilibus; erat quippe homo agriculturae deditus."
,"11":"Fuit autem exercitus bellatorum eius, qui procedebant ad proelia in turmis secundum numerum census per manum Iehiel scribae Maasiaeque praefecti sub manu Hananiae, qui erat de ducibus regis."
,"12":"Omnisque numerus principum per familias virorum fortium duorum milium sescentorum."
,"13":"Et sub eis universus exercitus trecentorum et septem milium quingentorum, qui erant apti ad bella, ut pro rege contra adversarios dimicarent."
,"14":"Praeparavit quoque eis Ozias, id est cuncto exercitui, clipeos et hastas et galeas et loricas arcusque et fundas ad iaciendos lapides."
,"15":"Et fecit in Ierusalem machinas excogitatas arte, quas in turribus collocavit et in angulis murorum, ut mitterent sagittas et saxa grandia; egressumque est nomen eius procul, eo quod mirabiliter auxiliaretur ei Dominus et corroborasset illum."
,"16":"Sed, cum roboratus esset, elevatum est cor eius in interitum suum, et deliquit contra Dominum Deum suum; ingressusque templum Domini adolere voluit incensum super altare thymiamatis."
,"17":"Statimque ingressus post eum Azarias sacerdos et cum eo sacerdotes Domini octoginta viri fortissimi;"
,"18":"restiterunt regi atque dixerunt: ' Non est tui officii, Ozia, ut adoleas incensum Domino, sed sacerdotum, hoc est filiorum Aaron, qui consecrati sunt ad huiuscemodi ministerium. Egredere de sanctuario, quia praevaricatus es; et non reputabitur tibi in gloriam hoc a Domino Deo '."
,"19":"Iratusque est Ozias et tenens in manu turibulum, ut adoleret incensum, minabatur sacerdotibus. Statimque orta est lepra in fronte eius coram sacerdotibus in domo Domini super altare thymiamatis."
,"20":"Cumque respexisset eum Azarias pontifex et omnes reliqui sacerdotes, viderunt lepram in fronte eius et festinato expulerunt eum; sed et ipse acceleravit egredi, eo quod malo afflixisset eum Dominus."
,"21":"Fuit igitur Ozias rex leprosus usque ad diem mortis suae et habitavit in domo separata plenus lepra, eo quod abscissus fuerat de domo Domini. Porro Ioatham filius eius rexit domum regis et iudicabat populum terrae."
,"22":"Reliqua autem gestorum Oziae priorum et novissimorum scripsit Isaias filius Amos propheta."
,"23":"Dormivitque Ozias cum patribus suis, et sepelierunt eum in agro regalium sepulcrorum, eo quod dicebant: ' Erat leprosus '. Regnavitque Ioatham filius eius pro eo."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Viginti quinque annorum erat Ioatham, cum regnare coepisset, et sedecim annis regnavit in Ierusalem. Nomen matris eius Ierusa filia Sadoc."
,"2":"Fecitque, quod rectum erat coram Domino iuxta omnia, quae fecerat Ozias pater suus, excepto quod non est ingressus templum Domini, et adhuc populus delinquebat."
,"3":"Ipse aedificavit portam domus Domini Superiorem et in muro Ophel multa construxit."
,"4":"Urbes quoque aedificavit in montibus Iudae et in saltibus castella et turres."
,"5":"Ipse pugnavit contra regem filiorum Ammon et vicit eos, dederuntque ei filii Ammon in anno illo centum talenta argenti et decem milia choros tritici ac totidem choros hordei; haec ei praebuerunt filii Ammon etiam in anno secundo et tertio."
,"6":"Corroboratusque est Ioatham, eo quod direxisset vias suas coram Domino Deo suo."
,"7":"Reliqua autem gestorum Ioatham et omnes pugnae eius et viae scriptae sunt in libro regum Israel et Iudae."
,"8":"Viginti quinque annorum erat, cum regnare coepisset, et sedecim annis regnavit in Ierusalem."
,"9":"Dormivitque Ioatham cum patribus suis, et sepelierunt eum in civitate David; et regnavit Achaz filius eius pro eo."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Viginti annorum erat Achaz, cum regnare coepis set, et sedecim annis regnavit in Ierusalem. Non fecit rectum in conspectu Domini sicut David pater eius,"
,"2":"sed ambulavit in viis regum Israel. Insuper et simulacra fudit Baalim."
,"3":"Ipse est, qui adolevit in valle filii Ennom et lustravit filios suos in igne iuxta abominationes gentium, quas expulit Dominus coram filiis Israel."
,"4":"Sacrificabat quoque et thymiama succendebat in excelsis et in collibus et sub omni ligno frondoso."
,"5":"Tradiditque eum Dominus Deus eius in manu regis Syriae, qui percussit eum multosque captivos de eo cepit et adduxit in Damascum. Manibus quoque regis Israel traditus est et percussus plaga grandi."
,"6":"Occidit enim Phacee filius Romeliae de Iuda centum viginti milia in die uno, omnes viros bellatores, eo quod reliquissent Dominum, Deum patrum suorum."
,"7":"Eodem tempore occidit Zechri vir potens ex Ephraim Maasiam filium regis et Ezricam praefectum domus, Elcanam quoque secundum a rege."
,"8":"Ceperuntque filii Israel de fratribus suis ducenta milia mulierum, puerorum et puellarum, et infinitam praedam pertuleruntque eam in Samariam."
,"9":"Erat autem ibi propheta Domini nomine Oded, qui egressus obviam exercitui venienti in Samariam dixit eis: ' Ecce, iratus Dominus, Deus patrum vestrorum, contra Iudam tradidit eos in manibus vestris, et occidistis eos atrociter, ita ut ad caelum pertingeret vestra crudelitas."
,"10":"Insuper filios Iudae et Ierusalem vultis vobis subicere in servos et ancillas. Attamen nonne vos ipsi estis in culpa coram Domino Deo vestro?"
,"11":"Audite ergo consilium meum et reducite captivos, quos adduxistis de fratribus vestris, quia magnus furor Domini imminet vobis '."
,"12":"Steterunt itaque viri de principibus filiorum Ephraim, Azarias filius Iohanan, Barachias filius Mosollamoth, Ezechias filius Sellum et Amasa filius Adali, contra eos, qui veniebant de proelio,"
,"13":"et dixerunt eis: ' Non introducetis huc captivos, quia ad culpam coram Domino, quae iam est super nos, vultis adicere super peccata nostra et culpam nostram. Grandis quippe culpa est nobis, et ira furoris Domini super Israel '."
,"14":"Dimiseruntque viri bellatores captivos et universa, quae ceperant, coram principibus et omni multitudine."
,"15":"Et surrexerunt viri nominatim designati et confortaverunt captivos omnesque, qui nudi erant, vestierunt de spoliis. Cumque vestissent eos et calceassent et refecissent cibo ac potu unxissentque, deduxerunt eos sollicite, et quidem omnes vacillantes in iumentis, et adduxerunt Iericho civitatem Palmarum ad fratres eorum. Ipsique reversi sunt Samariam."
,"16":"Tempore illo misit rex Achaz ad regem Assyriorum auxilium postulans."
,"17":"Venerunt enim et Idumaei et percusserunt Iudam et ceperunt captivos."
,"18":"Philisthim quoque diffusi sunt per urbes Sephelae et Nageb Iudae ceperuntque Bethsames et Aialon et Gederoth, Socho quoque cum viculis eius et Thamnan et Gamzo cum viculis earum et habitaverunt in eis."
,"19":"Humiliaverat enim Dominus Iudam propter Achaz regem Israel, eo quod relaxasset ei frenum et contemptui habuisset Dominum."
,"20":"Venitque contra eum Theglathphalasar rex Assyriorum, qui afflixit eum, non autem confortavit."
,"21":"Achaz enim, spoliata domo Domini et domo regis et principum, dedit regi Assyriorum munera, et tamen nihil ei profuit."
,"22":"Insuper et in tempore angustiae suae auxit contemptum in Dominum. Ipse rex Achaz"
,"23":"immolavit diis Damasci victimas percussoribus suis et dixit: ' Dii regum Syriae auxiliantur eis; quos ego placabo hostiis, et aderunt mihi ', cum e contrario ipsi fuerint ruina ei et universo Israel."
,"24":"Direptis itaque Achaz omnibus vasis domus Dei atque confractis, clausit ianuas templi Dei et fecit sibi altaria in universis angulis Ierusalem."
,"25":"In singulis quoque urbibus Iudae exstruxit excelsa ad adolendum diis alienis atque ad iracundiam provocavit Dominum, Deum patrum suorum."
,"26":"Reliqua autem gestorum eius et omnium operum suorum priorum et novissimorum scripta sunt in libro regum Iudae et Israel."
,"27":"Dormivitque Achaz cum patribus suis, et sepelierunt eum in civitate Ierusalem; non autem posuerunt eum in sepulcra regum Israel. Regnavitque Ezechias filius eius pro eo."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Igitur Ezechias regnare coepit, cum viginti quinque esset annorum, et viginti novem annis regnavit in Ierusalem. Nomen matris eius Abi filia Zachariae."
,"2":"Fecitque, quod erat placitum in conspectu Domini, iuxta omnia, quae fecerat David pater eius."
,"3":"Ipse anno et mense primo regni sui aperuit valvas domus Domini et instauravit eas."
,"4":"Adduxitque sacerdotes atque Levitas et congregavit eos in plateam orientalem"
,"5":"dixitque ad eos: ' Audite me, Levitae! Nunc sanctificamini; mundate domum Domini, Dei patrum vestrorum, et auferte omnem immunditiam de sanctuario."
,"6":"Peccaverunt patres nostri et fecerunt malum in conspectu Domini Dei nostri derelinquentes eum; averterunt facies suas a tabernaculo Domini et praebuerunt dorsum."
,"7":"Insuper clauserunt ostia, quae erant in porticu, et exstinxerunt lucernas incensumque non adoleverunt et holocausta non obtulerunt in sanctuario Deo Israel."
,"8":"Concitatus est itaque furor Domini super Iudam et Ierusalem; tradiditque eos in commotionem et in stuporem et in sibilum, sicut ipsi cernitis oculis vestris."
,"9":"En, corruerunt patres nostri gladiis, filii nostri et filiae nostrae et coniuges captivae ductae sunt propter hoc scelus."
,"10":"Nunc igitur placet mihi, ut ineam foedus cum Domino, Deo Israel, et avertat a nobis furorem irae suae."
,"11":"Filii mei, nolite neglegere; vos enim elegit Dominus, ut stetis coram eo et ministretis illi colatisque eum et adoleatis '."
,"12":"Surrexerunt ergo Levitae, Mahath filius Amasai et Ioel filius Azariae de filiis Caath; porro de filiis Merari Cis filius Abdi et Azarias filius Iallelel; de filiis autem Gerson Ioah filius Zimma et Eden filius Ioah;"
,"13":"at vero de filiis Elisaphan Semri et Iehiel; de filiis quoque Asaph Zacharias et Matthanias;"
,"14":"necnon de filiis Heman Iahiel et Semei; sed et de filiis Idithun Semeias et Oziel."
,"15":"Congregaveruntque fratres suos et sanctificati sunt et ingressi iuxta mandatum regis et imperium Domini, ut expiarent domum Dei."
,"16":"Sacerdotes quoque ingressi intra templum Domini, ut mundarent illud, extulerunt omnem immunditiam, quam intro reppererant in vestibulum domus Domini, quam tulerunt Levitae et asportaverunt ad torrentem Cedron foras."
,"17":"Coeperunt autem prima die mensis primi sanctificare et in die octava eiusdem mensis ingressi sunt porticum templi Domini et sanctificaverunt templum Domini diebus octo; et in die sexta decima mensis eiusdem, quod coeperant, impleverunt."
,"18":"Ingressi quoque sunt ad Ezechiam regem et dixerunt ei: ' Mundavimus omnem domum Domini et altare holocausti vasaque eius necnon et mensam propositionis cum omnibus vasis suis"
,"19":"cunctamque templi supellectilem, quam removerat rex Achaz in regno suo in praevaricatione sua, restituimus et sanctificavimus. Ecce exposita sunt omnia coram altari Domini '."
,"20":"Consurgensque diluculo Ezechias rex adunavit principes civitatis et ascendit domum Domini."
,"21":"Attuleruntque simul tauros septem, arietes septem, agnos septem et hircos septem pro peccato, pro regno, pro sanctuario, pro Iuda; dixit quoque sacerdotibus filiis Aaron, ut offerrent super altare Domini."
,"22":"Mactaverunt igitur tauros et susceperunt sacerdotes sanguinem et fuderunt illum super altare; mactaverunt etiam arietes et illorum sanguinem super altare fuderunt; immolaverunt agnos et fuderunt super altare sanguinem."
,"23":"Applicaverunt hircos pro peccato coram rege et universa multitudine imposueruntque manus suas super eos,"
,"24":"et immolaverunt illos sacerdotes et asperserunt sanguinem eorum super altare pro piaculo universi Israelis; pro omni quippe Israel praeceperat rex, ut holocaustum fieret et pro peccato."
,"25":"Constituit quoque Levitas in domo Domini cum cymbalis et psalteriis et citharis secundum dispositionem David et Gad videntis regis et Nathan prophetae; siquidem Domini praeceptum fuit per manum prophetarum eius."
,"26":"Steteruntque Levitae tenentes organa David, et sacerdotes tubas."
,"27":"Et iussit Ezechias, ut offerrent holocaustum super altare; cumque offerretur holocaustum, coeperunt laudes canere Domino et clangere tubis atque in diversis organis David regis Israel concrepare."
,"28":"Omni autem turba adorante, cantores et ii, qui tenebant tubas, erant in officio suo, donec compleretur holocaustum."
,"29":"Cumque finita esset oblatio, incurvatus est rex et omnes, qui erant cum eo, et adoraverunt."
,"30":"Praecepitque Ezechias et principes Levitis, ut laudarent Dominum verbis David et Asaph videntis; qui laudaverunt eum magna laetitia et curvato genu adoraverunt."
,"31":"Ezechias autem etiam haec addidit: ' Nunc, impletis manibus vestris Domino, accedite et afferte victimas et sacrificia pro gratiarum actione in domo Domini '. Attulit ergo universa multitudo hostias et sacrificia pro gratiarum actione, et omnis voluntarius et proni animi holocausta."
,"32":"Porro numerus holocaustorum, quae attulit multitudo, hic fuit: tauros septuaginta, arietes centum, agnos ducentos, in holocaustum Domino omnia haec."
,"33":"Sanctificaveruntque Domino boves sescentos et oves tria milia."
,"34":"Sacerdotes vero pauci erant nec poterant sufficere, ut pelles holocaustorum detraherent; unde et Levitae fratres eorum adiuverunt eos, donec impleretur opus, et sanctificarentur sacerdotes; Levitae quippe recti corde, ut sanctificarentur magis quam sacerdotes."
,"35":"Fuerunt igitur holocausta plurima, adipes pacificorum et libamina, quae pertinebant ad holocausta. Restitutus est ita cultus domus Domini. "
,"36":"Laetatusque est Ezechias et omnis populus de eo, quod paravit Dominus populo; repente quippe hoc factum est."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Misit quoque Ezechias ad omnem Israel et Iudam scri psitque et epistulas ad Ephraim et Manassen, ut venirent ad domum Domini in Ierusalem et facerent Pascha Domino, Deo Israel."
,"2":"Inito quoque consilio regis et principum et universi coetus in Ierusalem, decreverunt, ut facerent Pascha mense secundo."
,"3":"Non enim potuerant facere in tempore suo, quia sacerdotes, qui possent sufficere, sanctificati non fuerant, et populus necdum congregatus erat in Ierusalem."
,"4":"Placuit ergo sermo regi et omni multitudini,"
,"5":"et decreverunt, ut mitterent nuntios in universum Israel de Bersabee usque Dan, ut venirent et facerent Pascha Domino, Deo Israel, in Ierusalem; in plurima enim multitudine non fecerant, sicut lege praescriptum est."
,"6":"Perrexeruntque cursores cum epistulis ex regis manu et principum eius in universum Israel et Iudam, iuxta quod rex iusserat, praedicantes: ' Filii Israel, revertimini ad Dominum, Deum Abraham et Isaac et Israel, ut revertatur ad reliquias, quae effugerunt manum regum Assyriorum."
,"7":"Nolite fieri sicut patres vestri et fratres, qui recesserunt a Domino, Deo patrum suorum, et tradidit eos in interitum, ut ipsi cernitis."
,"8":"Nolite nunc indurare cervices vestras sicut patres vestri. Tradite manus Domino et venite ad sanctuarium eius, quod sanctificavit in aeternum; servite Domino Deo vestro, ut avertatur a vobis ira furoris eius."
,"9":"Si enim vos reversi fueritis ad Dominum, fratres vestri et filii habebunt misericordiam coram dominis suis, qui illos duxere captivos, et revertentur in terram hanc: misericors enim et clemens est Dominus Deus vester et non avertet faciem suam a vobis, si reversi fueritis ad eum '."
,"10":"Igitur cursores pergebant de civitate in civitatem per terram Ephraim et Manasse usque Zabulon, illis irridentibus et subsannantibus eos."
,"11":"Attamen quidam viri ex Aser et Manasse et Zabulon se humiliaverunt et venerunt Ierusalem."
,"12":"In Iuda quoque facta est manus Domini, ut daret eis cor unum, ut facerent praeceptum regis et principum iuxta verbum Domini."
,"13":"Congregatus est ergo in Ierusalem populus multus, ut faceret sollemnitatem Azymorum in mense secundo, ecclesia magna valde."
,"14":"Et surgentes destruxerunt altaria, quae erant in Ierusalem, atque universa thymiamateria subvertentes proiecerunt in torrentem Cedron."
,"15":"Et mactaverunt Pascha quarta decima die mensis secundi; sacerdotes autem atque Levitae confusi sanctificati sunt et attulerunt holocausta in domum Domini."
,"16":"Steteruntque in ordine suo iuxta dispositionem et legem Moysi hominis Dei, sacerdotes vero suscipiebant effundendum sanguinem de manibus Levitarum,"
,"17":"eo quod multi in coetu sanctificati non essent; idcirco Levitae mactaverunt victimas Paschae omnibus, qui non erant mundi, ut sanctificarent illas Domino."
,"18":"Valde magna enim pars populi, de Ephraim et Manasse et Issachar et Zabulon, non erant mundati; et comederunt Pascha non iuxta, quod scriptum est. Et oravit pro eis Eze chias dicens: ' Dominus bonus propitietur"
,"19":"cunctis, qui direxerunt cor suum, ut requirerent Dominum, Deum patrum suorum, quamvis non secundum munditiam sanctuarii '."
,"20":"Quem exaudivit Dominus, et placatus est populo."
,"21":"Feceruntque filii Israel, qui inventi sunt in Ierusalem, sollemnitatem Azymorum septem diebus in laetitia magna, laudaverunt Dominum et per singulos dies Levitae et sacerdotes per organa benesonantia."
,"22":"Et locutus est Ezechias ad cor omnium Levitarum, qui habebant intellegentiam bonam super Domino; et compleverunt sollemnitatem septem dierum immolantes victimas pacificorum et laudantes Dominum, Deum patrum suorum."
,"23":"Placuitque universae multitudini, ut celebrarent etiam alios dies septem, quod et fecerunt cum ingenti gaudio."
,"24":"Ezechias enim rex Iudae praebuerat multitudini mille tauros et septem milia ovium; principes vero dederant populo tauros mille et oves decem milia; sanctificata est ergo sacerdotum plurima multitudo."
,"25":"Et hilaritate perfusa est omnis turba Iudae, tam sacerdotum et Levitarum quam universae frequentiae, quae venerat ex Israel, advenae quoque, qui venerant de terra Israel vel habitabant in Iuda."
,"26":"Factaque est grandis laetitia in Ierusalem, qualis a diebus Salomonis filii David regis Israel in ea urbe non fuerat."
,"27":"Surrexerunt autem sacerdotes levitici generis benedicentes populo; et exaudita est vox eorum, pervenitque oratio eorum in habitaculum sanctum eius in caelum."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Cumque haec fuissent rite celebrata, egressus est omnis Israel, qui inventus fuerat in urbibus Iudae, et fregerunt simulacra succideruntque palos, demoliti sunt excelsa et altaria destruxerunt non solum de universo Iuda et Beniamin, sed et de Ephraim quoque et Manasse, donec penitus everterent. Reversique sunt omnes filii Israel in possessiones et civitates suas."
,"2":"Ezechias autem constituit turmas sacerdotales et leviticas per divisiones suas, unumquemque in officio proprio tam sacerdotum videlicet quam Levitarum, ad holocausta et pacifica, ut ministrarent et confiterentur canerentque laudes in portis castrorum Domini."
,"3":"Pars autem regis erat, ut de propria eius substantia offerretur holocaustum mane semper et vespere, sabbatis quoque et calendis et sollemnitatibus ceteris, sicut scriptum est in lege Moysi."
,"4":"Praecepit etiam populo habitanti Ierusalem, ut darent partes sacerdotibus et Levitis, ut possent vacare legi Domini."
,"5":"Quod cum percrebruisset in auribus multitudinis, plurimas obtulere primitias filii Israel frumenti, vini et olei, mellis quoque et omnium, quae gignit humus, et decimas obtulerunt de omnibus abundanter."
,"6":"Sed et filii Israel et Iudae, qui habitabant in urbibus Iudae, obtulerunt decimas boum et ovium decimasque sanctorum, quae sanctificabant Domino Deo suo; atque universa portantes fecerunt acervos plurimos."
,"7":"Mense tertio coeperunt acervorum iacere fundamenta et mense septimo compleverunt eos."
,"8":"Cumque ingressi fuissent Ezechias et principes, viderunt acervos et benedixerunt Domino ac populo Israel."
,"9":"Interrogavitque Ezechias sacerdotes et Levitas, cur ita iacerent acervi."
,"10":"Respondit illi Azarias sacerdos primus de stirpe Sadoc dicens: ' Ex quo coeperunt offerre donationem in domum Domini, comedimus et saturati sumus, et remanserunt plurima, eo quod benedixerit Dominus populo suo; reliquiarum autem copia est ista, quam cernis '."
,"11":"Praecepit igitur Ezechias, ut praepararent cellas in domo Domini. Quod cum fecissent,"
,"12":"intulerunt tam donationem quam decimas et quaecumque sanctificaverant fideliter. Fuit autem praefectus eorum Chonenias Levita et Semei frater eius secundus,"
,"13":"post quem Iahiel et Azazias et Nahath et Asael et Ierimoth, Iozabad quoque et Eliel et Iesmachias et Mahath et Banaias praepositi sub manibus Choneniae et Semei fratris eius ex imperio Ezechiae regis et Azariae pontificis domus Dei."
,"14":"Core vero filius Iemna Levites et ianitor orientalis portae praepositus erat iis, quae sponte offerebantur Domino, ad distribuendum donationem Domini et sanctissima."
,"15":"Et sub cura eius Eden et Beniamin, Iesua et Semeias, Amarias quoque et Sechenias in civitatibus sacerdotum, ut fideliter distribuerent fratribus suis tam maioribus quam minoribus in divisionibus suis,"
,"16":"dummodo recensiti essent mares ab annis tribus et supra, cuncti qui ingrediebantur templum Domini, ut singulorum dierum ministeria observarent iuxta divisiones suas."
,"17":"Sacerdotes recensiti erant per familias, et Levitae a vicesimo anno et supra per ministeria et turmas suas."
,"18":"Et recensita erat universa familia omnis turmae, tam pro uxoribus quam liberis eorum utriusque sexus, quia in fidelitate servitii ipsorum sanctificati erant omnes."
,"19":"Porro pro filiis Aaron, sacerdotibus in agris et suburbanis urbium singularum dispositi erant nominatim viri, qui partes distribuerent universo sexui masculino de sacerdotibus et omni, qui recensitus erat inter Levitas."
,"20":"Fecit ergo Ezechias secundum haec in omni Iuda operatusque est bonum et rectum et verum coram Domino Deo suo."
,"21":"Et in universo opere, quod coepit in servitio domus Dei, et iuxta legem et praeceptum volens requirere Deum suum, in toto corde suo operatus et prosperatus est."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Post quae et huiuscemodi fidem venit Sennacherib rex Assyriorum et ingressus Iudam obsedit civitates munitas volens eas capere."
,"2":"Quod cum vidisset Ezechias, venisse scilicet Sennacherib et totum belli impetum verti contra Ierusalem,"
,"3":"inito cum principibus consilio virisque fortissimis, ut obturarent capita fontium, qui erant extra urbem, et, hoc omnium decernente sententia,"
,"4":"congregata est plurima multitudo, et obturaverunt cunctos fontes et rivum, qui fluebat in medio terrae, dicentes: ' Ne veniant reges Assyriorum et inveniant aquarum abundantiam! '."
,"5":"Aedificavit quoque agens industrie omnem murum, qui fuerat dissipatus, et exstruxit turres desuper et forinsecus alterum murum instauravitque Mello in civitate David et fecit iacula plurima et clipeos."
,"6":"Constituitque principes belli super populum et convocavit illos ad se in platea portae civitatis ac locutus est ad cor eorum dicens:"
,"7":"' Viriliter agite et confortamini! Nolite timere nec paveatis regem Assyriorum et universam multitudinem, quae est cum eo. Multo enim plures nobiscum sunt quam cum illo:"
,"8":"cum illo est brachium carneum, nobiscum autem Dominus Deus noster, qui auxiliator est noster pugnatque pro nobis '. Confortatusque est populus huiuscemodi verbis Ezechiae regis Iudae."
,"9":"Quae postquam gesta sunt, misit Sennacherib rex Assyriorum servos suos Ierusalem - ipse enim cum universo exercitu obsidebat Lachis - ad Ezechiam regem Iudae et ad omnem populum, qui erat in urbe, dicens:"
,"10":"' Haec dicit Sennacherib rex Assyriorum: In quo habentes fiduciam sedetis obsessi in Ierusalem?"
,"11":"Nonne Ezechias decipit vos, ut tradat morti in fame et siti affirmans quod Dominus Deus vester liberet vos de manu regis Assyriorum?"
,"12":"Numquid non iste est Ezechias, qui destruxit excelsa illius et altaria et praecepit Iudae et Ierusalem dicens: 'Coram altari uno adorabitis et in ipso comburetis sacrificia'?"
,"13":"An ignoratis quae ego fecerim et patres mei cunctis terrarum populis? Numquid praevaluerunt dii gentium terrarum liberare regionem suam de manu mea?"
,"14":"Quis est de universis diis gentium, quas deleverunt patres mei, qui potuerit eruere populum suum de manu mea, ut possit etiam Deus vester eruere vos de hac manu?"
,"15":"Non vos ergo decipiat Ezechias nec vana persuasione deludat, neque credatis ei! Si enim nullus potuit deus cunctarum gentium atque regnorum liberare populum suum de manu mea et de manu patrum meorum, quanto minus Deus vester poterit eruere vos de manu mea! '."
,"16":"Sed et alia multa locuti sunt servi eius contra Dominum Deum et contra Ezechiam servum eius."
,"17":"Epistulas quoque scripsit plenas blasphemiae in Dominum, Deum Israel, et locutus est adversus eum: ' Sicut dii gentium terrarum non potuerunt liberare populos suos de manu mea, sic et Deus Ezechiae eruere non poterit populum suum de manu ista '."
,"18":"Insuper et clamore magno, lingua Iudaica, ad populum Ierusalem, qui sedebat in muro, personabant, ut terrerent et perturbarent eos et caperent civitatem."
,"19":"Locutusque est Sennacherib contra Deum Ierusalem sicut adversum deos populorum terrae opera manuum hominum."
,"20":"Oraverunt igitur Ezechias rex et Isaias filius Amos prophetes adversum hanc blasphemiam ac vociferati sunt in caelum."
,"21":"Et misit Dominus angelum, qui percussit omnem virum robustum et bellatorem et principem in castris regis Assyriorum; reversusque est cum ignominia in terram suam. Cumque ingressus esset domum dei sui, filii, qui egressi fuerant de visceribus eius, interfecerunt eum ibi gladio."
,"22":"Salvavit ergo Dominus Ezechiam et habitatores Ierusalem de manu Sennacherib regis Assyriorum et de manu omnium et praestitit eis quietem per circuitum."
,"23":"Multi etiam deferebant munera Domino in Ierusalem et res pretiosas Ezechiae regi Iudae, qui exaltatus est post haec coram cunctis gentibus."
,"24":"In diebus illis aegrotavit Ezechias usque ad mortem et oravit Dominum; exaudivitque eum et dedit ei signum."
,"25":"Sed non iuxta beneficia, quae acceperat, retribuit, quia elevatum est cor eius; et facta est contra eum ira et contra Iudam et Ierusalem."
,"26":"Humiliatusque est postea, eo quod exaltatum fuisset cor eius, tam ipse quam habitatores Ierusalem; et idcirco non venit super eos ira Domini in diebus Ezechiae."
,"27":"Fuit autem Ezechias dives et inclitus valde; et thesauros sibi plurimos congregavit argenti, auri et lapidis pretiosi, aromatum et clipeorum omnisque generis rerum pretiosarum."
,"28":"Apothecas quoque frumenti, vini et olei et praesepia omnium iumentorum caulasque pecoribus"
,"29":"et urbes exaedificavit sibi; habebat quippe greges ovium et armentorum innumerabiles, eo quod dedisset ei Deus substantiam multam nimis."
,"30":"Ipse est Ezechias, qui obturavit superiorem exitum aquarum Gihon et avertit eas subter ad occidentem urbis David. In omnibus operibus suis prosperatus est."
,"31":"Attamen sic in legatione principum Babylonis, qui missi fuerant ad eum, ut interrogarent de portento, quod acciderat super terram, dereliquit eum Deus, ut tentaretur, et nota fierent omnia, quae erant in corde eius."
,"32":"Reliqua autem gestorum Ezechiae et misericordiarum eius scripta sunt in visione Isaiae filii Amos prophetae et in libro regum Iudae et Israel."
,"33":"Dormivitque Ezechias cum patribus suis, et sepelierunt eum in ascensu ad sepulcra filiorum David; et celebravit eius exsequias universus Iuda et omnes habitatores Ierusalem. Regnavitque Manasses filius eius pro eo."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Duodecim annorum erat Manasses, cum regnare coe pisset, et quinquaginta quinque annis regnavit in Ierusalem."
,"2":"Fecit autem malum coram Domino iuxta abominationes gentium, quas expulit Dominus coram filiis Israel."
,"3":"Et conversus instauravit excelsa, quae demolitus fuerat Ezechias pater eius, construxitque aras Baalim et fecit palos et adoravit omnem militiam caeli et coluit eam."
,"4":"Aedificavit quoque altaria in domo Domini, de qua dixerat Dominus: ' In Ierusalem erit nomen meum in aeternum '."
,"5":"Aedificavit autem ea cuncto exercitui caeli in duobus atriis domus Domini."
,"6":"Transireque fecit filios suos per ignem in valle filii Ennom. Hariolatus est, sectabatur auguria, maleficis artibus inserviebat, habebat secum pythones et aruspices; multaque mala operatus est coram Domino, ut irritaret eum."
,"7":"Posuit quoque sculptile, idolum, quod fecerat, in domo Dei, de qua locutus est Deus ad David et ad Salomonem filium eius dicens: ' In domo hac et in Ierusalem, quam elegi de cunctis tribubus Israel, ponam nomen meum in sempiternum."
,"8":"Et moveri non faciam pedem Israel de terra, quam tradidi patribus eorum, ita dumtaxat si custodierint facere, quae praecepi eis, cunctamque legem et praecepta atque iudicia, per manum Moysi '."
,"9":"Igitur Manasses seduxit Iudam et habitatores Ierusalem, ut facerent malum super omnes gentes, quas subverterat Dominus a facie filiorum Israel."
,"10":"Locutusque est Dominus ad eum et ad populum illius, et attendere noluerunt."
,"11":"Idcirco superinduxit eis principes exercitus regis Assyriorum; ceperuntque Manassen compedibus et vinctum catenis duxerunt Babylonem."
,"12":"Qui, postquam coangustatus est, oravit Dominum Deum suum et egit paenitentiam valde coram Deo patrum suorum."
,"13":"Deprecatusque est eum, et placatus ei exaudivit orationem eius reduxitque eum Ierusalem in regnum suum; et cognovit Manasses quod Dominus ipse esset Deus."
,"14":"Post haec aedificavit murum extra civitatem David ad occidentem Gihon in convalle et ad introitum portae Piscium per circuitum Ophel et exaltavit illum vehementer; constituitque principes exercitus in cunctis civitatibus Iudae munitis."
,"15":"Et abstulit deos alienos et idolum de domo Domini, aras quoque, quas fecerat in monte domus Domini et in Ierusalem, et proiecit omnia extra urbem."
,"16":"Porro instauravit altare Domini et immolavit super illud victimas pacificorum et pro gratiarum actione praecepitque Iudae, ut serviret Domino, Deo Israel."
,"17":"Attamen adhuc populus immolabat in excelsis Domino Deo suo."
,"18":"Reliqua autem gestorum Manasse et obsecratio eius ad Deum suum, verba quoque videntium, qui loquebantur ad eum in nomine Domini, Dei Israel, continentur in sermonibus regum Israel."
,"19":"Oratio quoque eius et exauditio et cuncta peccata atque contemptus, loca etiam, in quibus aedificavit excelsa et fecit palos et statuas, antequam ageret paenitentiam, scripta sunt in sermonibus Hozai."
,"20":"Dormivit ergo Manasses cum patribus suis, et sepelierunt eum in domo sua. Regnavitque pro eo filius eius Amon."
,"21":"Viginti duorum annorum erat Amon, cum regnare coepisset, et duobus annis regnavit in Ierusalem."
,"22":"Fecitque malum in conspectu Domini, sicut fecerat Manasses pater eius, et cunctis idolis, quae Manasses fuerat fabricatus, immolavit atque servivit."
,"23":"Et non humiliavit se ante faciem Domini, sicut humiliaverat se Manasses pater eius, et multo maiora deliquit."
,"24":"Cumque coniurassent adversus eum servi sui, interfecerunt eum in domo sua."
,"25":"Porro populus terrae, caesis omnibus, qui conspiraverant contra regem Amon, consti tuit regem Iosiam filium eius pro eo."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Octo annorum erat Iosias, cum regnare coepisset, et tri ginta et uno annis regnavit in Ierusalem."
,"2":"Fecitque quod erat rectum in conspectu Domini, et ambulavit in viis David patris sui; non declinavit neque ad dextram neque ad sinistram."
,"3":"Octavo autem anno regni sui, cum adhuc esset puer, coepit quaerere Deum patris sui David; et duodecimo anno coepit mundare Iudam et Ierusalem ab excelsis et palis sculptilibusque et conflatilibus."
,"4":"Destruxeruntque coram eo aras Baalim; et thymiamateria, quae eis superposita fuerant, demolitus est; palos etiam et sculptilia et conflatilia succidit atque comminuit et super tumulos eorum, qui eis immolare consueverant, fragmenta dispersit."
,"5":"Ossa praeterea sacerdotum combussit in altaribus ipsorum; mundavitque Iudam et Ierusalem,"
,"6":"sed et in urbibus Manasse et Ephraim et Simeon usque Nephthali, in plateis eorum undique"
,"7":"dissipavit altaria et palos et sculptilia contrivit in frusta; cunctaque thymiamateria demolitus est de universa terra Israel et reversus est Ierusalem."
,"8":"Igitur anno octavo decimo regni sui, cum mundaret terram et domum, misit Saphan filium Eseliae et Maasiam principem civitatis et Ioah filium Ioachaz a commentariis, ut instaurarent domum Domini Dei sui."
,"9":"Qui venerunt ad Helciam sacerdotem magnum acceptamque ab eo pecuniam, quae illata fuerat in domum Domini, et quam congregaverant Levitae ianitores de Manasse et Ephraim et universis reliquiis Israel ab omni quoque Iuda et Beniamin et habitatoribus Ierusalem,"
,"10":"tradiderunt in manibus opificum, qui praeerant in domo Domini, et illi dederunt eam operariis, qui operabantur in domo Domini, ut instaurarent templum et infirma quaeque sarcirent;"
,"11":"dederunt scilicet eam lignariis et caementariis, ut emerent lapides dolatos et ligna ad commissuras aedificii et ad contignationem domorum, quas destruxerant reges Iudae."
,"12":"Qui fideliter cuncta faciebant. Erant autem praepositi operantium Iahath et Abdias Levitae de filiis Merari, Zacharias et Mosollam de filiis Caath, qui dirigebant opus. Omnes autem Levitae scientes organis canere"
,"13":"erant super eos, qui onera portabant et dirigebant omnes, qui varia opera faciebant. De Levitis quoque erant scribae et praefecti et ianitores."
,"14":"Cumque efferrent pecuniam, quae illata fuerat in templum Domini, repperit Helcias sacerdos librum legis Domini per manum Moysi"
,"15":"et ait ad Saphan scribam: ' Librum legis inveni in domo Domini '. Et tradidit ei."
,"16":"At ille intulit volumen ad regem et insuper nuntiavit ei dicens: ' Omnia, quae dedisti in manu servorum tuorum, ecce complentur."
,"17":"Argentum, quod repertum est in domo Domini, effuderunt, datum que est praefectis et operariis '."
,"18":"Et nuntiavit Saphan scriba regi dicens: ' Librum tradidit mihi Helcias sacerdos '. Et legebat illum Saphan coram rege."
,"19":"Et factum est, cum audisset rex verba legis, scidit vestimenta sua"
,"20":"et praecepit Helciae et Ahicam filio Saphan et Abdon filio Micha, Saphan quoque scribae et Asaiae servo regis dicens:"
,"21":"' Ite et consulite Dominum pro me et pro reliquiis Israel et Iudae super sermonibus libri, qui repertus est. Magnus enim furor Domini effusus est super nos, eo quod non custodierint patres nostri verba Domini, ut facerent iuxta omnia, quae scripta sunt in isto volumine '."
,"22":"Abiit igitur Helcias et hi, qui simul a rege missi fuerant, ad Holdam propheten uxorem Sellum filii Thecuae filii Haraas custodis vestium, quae habitabat in Ierusalem in secunda, et locuti sunt ei iuxta verba haec."
,"23":"Et illa respondit eis: ' Haec dicit Dominus, Deus Israel: Dicite viro, qui misit vos ad me:"
,"24":"Haec dicit Dominus: Ecce ego inducam mala super locum istum et super habitatores eius, cuncta maledicta, quae scripta sunt in libro hoc, quem legerunt coram rege Iudae,"
,"25":"quia dereliquerunt me et sacrificaverunt diis alienis, ut me ad iracundiam provocarent in cunctis operibus manuum suarum; idcirco effundetur furor meus super locum istum et non exstinguetur."
,"26":"Ad regem autem Iudae, qui misit vos pro Domino consulendo, sic loquimini: Haec dicit Dominus, Deus Israel: Quoniam audisti verba voluminis,"
,"27":"atque emollitum est cor tuum, et humiliatus es in conspectu Dei super his, quae dicta sunt contra locum hunc et habitatores Ierusalem, humiliatusque coram me scidisti vestimenta tua et flevisti coram me, ego quoque audivi, dicit Dominus."
,"28":"Ecce colligam te ad patres tuos, et infereris in sepulcrum tuum in pace; nec videbunt oculi tui omne malum, quod ego inducturus sum super locum istum et super habitatores eius '. Rettuleruntque itaque regi cuncta, quae dixerat."
,"29":"At ille, convocatis universis maioribus natu Iudae et Ierusalem,"
,"30":"ascendit domum Domini, unaque omnes viri Iudae et habitatores Ierusalem, sacerdotes et Levitae et cunctus populus a minimo usque ad maximum. Quibus audientibus, in domo Domini legit rex omnia verba voluminis foederis inventi in domo Domini."
,"31":"Et stans in gradu suo percussit foedus coram Domino, ut ambularet post eum et custodiret praecepta et testimonia et iustificationes eius in toto corde suo et in tota anima sua faceretque verba foederis scripta in hoc libro."
,"32":"Adiuravit quoque super hoc omnes, qui reperti fuerant in Ierusalem et Beniamin; et fecerunt habitatores Ierusalem iuxta pactum Domini, Dei patrum suorum."
,"33":"Abstulit ergo Iosias cunctas abominationes de universis regionibus filiorum Israel et fecit omnes, qui inventi erant in Israel, servire Domino Deo suo. Cunctis diebus eius non recesserunt a Domino, Deo patrum suorum."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Fecit autem Iosias in Ierusalem Pascha Domino, quod immolatum est quarta decima die mensis primi."
,"2":"Et constituit sacerdotes in officiis suis confortavitque eos, ut ministrarent in domo Domini."
,"3":"Levitis quoque, qui erudiebant omnem Israel et consecrati erant Domino, locutus est: ' Ponite arcam sanctam in templum, quod aedificavit Salomon filius David rex Israel; nequaquam eam ultra umeris portabitis. Nunc ministrate Domino Deo vestro et populo eius Israel."
,"4":"Et praeparate vos per familias vestras in divisionibus singulis, sicut scripsit David rex Israel, et descripsit Salomon filius eius;"
,"5":"et ministrate in sanctuario partibus familiarum fratrum vestrorum, filiorum populi, singulis pars familiae Levitarum."
,"6":"Mactate ergo Pascha et sanctificamini et praeparate vos pro fratribus vestris, ut faciatis iuxta verbum, quod locu tus est Dominus in manu Moysi '."
,"7":"Dedit praeterea Iosias omni populo, qui ibi inventus fuerat pro Pascha, agnos et haedos de gregibus triginta milia, boumque tria milia; haec de regis universa substantia."
,"8":"Duces quoque eius sponte obtulerunt, tam populo quam sacerdotibus et Levitis; porro Helcias et Zacharias et Iahiel principes domus Domini dederunt sacerdotibus ad faciendum Pascha pecora commixtim duo milia sescenta et boves trecentos."
,"9":"Chonenias autem, Semeias etiam et Nathanael fratres eius necnon Hasabias et Iehiel et Iozabad principes Levitarum dederunt ceteris Levitis ad celebrandum Pascha quinque milia pecorum et boves quingentos."
,"10":"Praeparatumque est ministerium, et steterunt sacerdotes in loco suo, Levitae quoque in turmis iuxta regis imperium."
,"11":"Et mactatum est Pascha; asperseruntque sacerdotes manu sua sanguinem, et Levitae detraxerunt pelles holocaustorum"
,"12":"et separaverunt holocaustum, ut darent partibus familiarum populi, et offerretur Domino, sicut scriptum est in libro Moysi. De bobus quoque fecere similiter."
,"13":"Et assaverunt Pascha super ignem, iuxta quod lege praeceptum est; pacificas vero hostias coxerunt in lebetis et caccabis et ollis et festinato distribuerunt universae plebi."
,"14":"Sibi autem et sacerdotibus postea paraverunt; nam in oblatione holocaustorum et adipum usque ad noctem sacerdotes fuerant occupati, unde Levitae et sibi et sacerdotibus filiis Aaron paraverunt novissimis."
,"15":"Porro cantores filii Asaph stabant in loco suo, iuxta praeceptum David et Asaph et Heman et Idithun prophetarum regis; ianitores vero per portas singulas observabant, ita ut ne puncto quidem discederent a ministerio, quia fratres eorum Levitae paraverunt eis cibos."
,"16":"Omnis igitur cultus Domini rite praeparatus est in die illa, ut facerent Pascha et offerrent holocausta super altare Domini, iuxta praeceptum regis Iosiae."
,"17":"Feceruntque filii Israel, qui reperti fuerant ibi, Pascha in tempore illo et sollemnitatem Azymorum septem diebus."
,"18":"Non fuit simile huic in Israel a diebus Samuelis prophetae, sed nec quisquam de cunctis regibus Israel fecit Pascha sicut Iosias cum sacerdotibus et Levitis et omni Iuda et Israel, qui repertus fuerat, et habitantibus in Ierusalem."
,"19":"Octavo decimo anno regni Iosiae hoc Pascha celebratum est."
,"20":"Postquam instauraverat Iosias templum, ascendit Nechao rex Aegypti ad pugnandum in Charchamis iuxta Euphraten. Et processit in occursum eius Iosias."
,"21":"At ille, missis ad eum nuntiis, ait: ' Quid mihi et tibi est, rex Iudae? Non adversum te hodie venio, sed contra aliam pugno domum, ad quam me Deus festinato ire praecepit. Desine adversum Deum facere, qui mecum est, ne interficiat te '."
,"22":"Noluit Iosias reverti, sed audacter praeparavit contra eum bellum nec acquievit sermonibus Nechao ex ore Dei; verum perrexit, ut dimicaret in campo Mageddo."
,"23":"Ibique vulneratus a sagittariis dixit pueris suis: ' Educite me de proelio, quia oppido vulneratus sum '."
,"24":"Qui transtulerunt eum de curru in alterum currum eius et asportaverunt in Ierusalem. Mortuusque est et sepultus in sepulcris patrum suorum; et universus Iuda et Ierusalem luxerunt eum."
,"25":"Ieremias fecit planctum super Iosiam; et omnes cantores atque cantrices usque in praesentem diem lamentationes super Iosia replicant, et quasi lex obtinuit in Israel; ecce scriptum fertur in Lamentationibus."
,"26":"Reliqua autem gestorum Iosiae et misericordiae eius, quae lege praecepta sunt Domini,"
,"27":"gesta quoque illius prima et novissima scripta sunt in libro regum Israel et Iudae."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Tulit ergo populus terrae Ioachaz filium Iosiae et con stituit regem pro patre suo in Ierusalem."
,"2":"Viginti trium annorum erat Ioachaz, cum regnare coepisset, et tribus mensibus regnavit in Ierusalem."
,"3":"Amovit autem eum rex Aegypti, cum venisset Ierusalem, et condemnavit terram centum talentis argenti et talento auri."
,"4":"Constituitque regem pro eo Eliachim fratrem eius super Iudam et Ierusalem et vertit nomen eius Ioachim. Ipsum vero Ioachaz tulit secum et adduxit in Aegyptum."
,"5":"Viginti quinque annorum erat Ioachim, cum regnare coepisset, et undecim annis regnavit in Ierusalem; fecitque malum coram Domino Deo suo."
,"6":"Contra hunc ascendit Nabuchodonosor rex Chaldaeorum et vinctum catenis duxit in Babylonem,"
,"7":"ad quam et ex vasis Domini transtulit et posuit ea in templo suo."
,"8":"Reliqua autem gestorum Ioachim et abominationum eius, quas operatus est, et quae inventa sunt contra eum, continentur in libro regum Israel et Iudae. Regnavitque autem Ioachin filius eius pro eo."
,"9":"Decem et octo annorum erat Ioachin, cum regnare coepisset, et tribus mensibus ac decem diebus regnavit in Ierusalem; fecitque malum in conspectu Domini."
,"10":"Cumque anni circulus volveretur, misit Nabuchodonosor rex, qui adduxerunt eum in Babylonem, asportatis simul pretiosissimis vasis domus Domini; regem vero constituit Sedeciam fratrem eius super Iudam et Ierusalem."
,"11":"Viginti et unius anni erat Sedecias, cum regnare coepisset, et undecim annis regnavit in Ierusalem."
,"12":"Fecitque malum in oculis Domini Dei sui nec humiliavit se coram Ieremia propheta loquente ad se ex ore Domini."
,"13":"Contra regem quoque Nabuchodonosor rebellavit, qui adiuraverat eum per Deum, et induravit cervicem suam et cor, ut non reverteretur ad Dominum, Deum Israel."
,"14":"Sed et universi principes sacerdotum et populus multiplicaverunt praevaricationes suas iuxta universas abominationes gentium et polluerunt domum Domini, quam sanctificaverat in Ierusalem."
,"15":"Mittebat autem Dominus, Deus patrum suorum, ad illos per manum nuntiorum suorum de nocte consurgens et cotidie commonens, eo quod parceret populo et habitaculo suo."
,"16":"At illi subsannabant nuntios Dei et parvipendebant sermones eius illudebantque prophetis, donec ascenderet furor Domini in populum eius, et esset nulla curatio."
,"17":"Adduxit enim super eos regem Chaldaeorum et interfecit iuvenes eorum gladio in domo sanctuarii sui; non est misertus adulescentis et virginis et senis nec decrepiti quidem, sed omnes tradidit in manibus eius."
,"18":"Universaque vasa domus Dei tam maiora quam minora et thesauros templi et regis et principum transtulit in Babylonem."
,"19":"Incenderunt hostes domum Dei destruxeruntque murum Ierusalem, universa palatia combusserunt et, quidquid pretiosum fuerat, demoliti sunt."
,"20":"Si quis evaserat gladium, ductus in Babylonem servivit regi et filiis eius, donec imperaret rex Persarum,"
,"21":"ut compleretur sermo Domini ex ore Ieremiae: donec terra acciperet sabbata sua, cunctis diebus devastationis egit sabbatum, usque dum complerentur septuaginta anni."
,"22":"Anno autem primo Cyri regis Persarum ad explendum sermonem Domini, quem locutus fuerat per os Ieremiae, suscitavit Dominus spiritum Cyri regis Persarum, qui iussit praedicari in universo regno suo etiam per scripturam dicens:"
,"23":"' Haec dicit Cyrus rex Persarum: Omnia regna terrae dedit mihi Dominus, Deus caeli, et ipse praecepit mihi, ut aedificarem ei domum in Ierusalem, quae est in Iudaea. Quis ex vobis est de omni populo eius? Sit Dominus Deus suus cum eo, et ascendat '."
}`)

}
func LA_NVBSE_LoadVH2RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Praevaricatus est autem Moab in Israel, postquam mortuus est Achab."
,"2":"Ceciditque Ochozias per cancellos cenaculi sui, quod habebat in Samaria, et aegrotavit; misitque nuntios dicens ad eos: ' Ite, consulite Beelzebub deum Accaron, utrum vivere queam de infirmitate mea hac '."
,"3":"Angelus autem Domini locutus est ad Eliam Thesbiten: ' Surge, ascende in occursum nuntiorum regis Samariae et dices ad eos: Numquid non est Deus in Israel, ut eatis ad consulendum Beelzebub deum Accaron?"
,"4":"Quam ob rem haec dicit Dominus: De lectulo, super quem ascendisti, non descendes, sed morte morieris '. Et abiit Elias."
,"5":"Reversique sunt nuntii ad Ochoziam, qui dixit eis: ' Quare reversi estis? '."
,"6":"At illi responderunt ei: ' Vir occurrit nobis et dixit ad nos: 'Ite, revertimini ad regem, qui misit vos, et dicetis ei: Haec dicit Dominus: Numquid, quia non est Deus in Israel, mittis, ut consulatur Beelzebub deus Accaron? Idcirco de lectulo, super quem ascendisti, non descendes, sed morte morieris' '."
,"7":"Qui dixit eis: ' Cuius figurae et habitus vir erat, qui occurrit vobis et locutus est verba haec? '."
,"8":"At illi dixerunt: ' Vir in veste pilosa et zona pellicea accinctis renibus '. Qui ait: ' Elias Thesbites est '."
,"9":"Misitque ad eum quinquagenarium principem et quinquaginta, qui erant sub eo; qui ascendit ad eum sedentique in vertice montis ait: ' Homo Dei, rex praecepit, ut descendas '."
,"10":"Respondensque Elias dixit quinquagenario: ' Si homo Dei sum, descendat ignis e caelo et devoret te et quinquaginta tuos '. Descendit itaque ignis e caelo et devoravit eum et quinquaginta, qui erant cum eo."
,"11":"Rursum misit ad eum principem quinquagenarium alterum et quinquaginta cum eo; qui locutus est illi: ' Homo Dei, haec dicit rex: 'Festina, descende!' '."
,"12":"Respondens Elias ait illis: ' Si homo Dei ego sum, descendat ignis e caelo et devoret te et quinquaginta tuos '. Descendit ergo ignis Dei e caelo et devoravit illum et quinquaginta eius."
,"13":"Iterum misit principem quinquagenarium tertium et quinquaginta, qui erant cum eo; qui cum venisset, curvavit genua contra Eliam et precatus est eum et ait: ' Homo Dei, noli despicere animam meam et animam servorum tuorum, qui mecum sunt."
,"14":"Ecce descendit ignis de caelo et devoravit duos principes quinquagenarios primos et quinquagenos, qui cum eis erant; sed nunc obsecro, ut miserearis animae meae '."
,"15":"Locutus est autem angelus Domini ad Eliam dicens: ' Descende cum eo, ne timeas '. Surrexit igitur et descendit cum eo ad regem"
,"16":"et locutus est ei: ' Haec dicit Dominus: Quia misisti nuntios ad consulendum Beelzebub deum Accaron, quasi non esset Deus in Israel, a quo posses interrogare sermonem, ideo de lectulo, super quem ascendisti, non descendes, sed morte morieris '."
,"17":"Mortuus est ergo iuxta sermonem Domini, quem locutus est Elias. Et regnavit Ioram frater eius pro eo anno secundo Ioram filii Iosaphat regis Iudae; non enim habebat filium."
,"18":"Reliqua autem gestorum Ochoziae, quae operatus est, nonne haec scripta sunt in libro annalium regum Israel?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Factum est autem cum levare vellet Dominus Eliam per turbi nem in caelum, ibant Elias et Eliseus de Galgalis;"
,"2":"dixitque Elias ad Eliseum: ' Sede hic, quia Dominus misit me usque Bethel '. Cui ait Eliseus: ' Vivit Dominus, et vivit anima tua, quia non derelinquam te '. Cumque descendissent Bethel,"
,"3":"egressi sunt filii prophetarum, qui erant in Bethel, ad Eliseum et dixerunt ei: 'Numquid nosti quia hodie Dominus tollat dominum tuum desuper capite tuo? '. Qui respondit: ' Et ego novi, silete '."
,"4":"Dixit autem ei Elias: ' Elisee, sede hic, quia Dominus misit me in Iericho '. Et ille ait: ' Vivit Dominus, et vivit anima tua, quia non derelinquam te '. Cumque venissent Ierichum,"
,"5":"accesserunt filii prophetarum, qui erant in Iericho, ad Eliseum et dixerunt ei: ' Numquid nosti quia hodie Dominus tollet dominum tuum desuper capite tuo? '. Et ait: ' Et ego novi, silete '."
,"6":"Dixit autem ei Elias: ' Sede hic, quia Dominus misit me ad Iordanem '. Qui ait: ' Vivit Dominus, et vivit anima tua, quia non derelinquam te '. Ierunt igitur ambo pariter,"
,"7":"et quinquaginta viri de filiis prophetarum secuti sunt, qui et steterunt e contra longe. Illi autem ambo stabant super Iordanem."
,"8":"Tulitque Elias pallium suum et involvit illud et percussit aquas, quae divisae sunt in utramque partem, et transierunt ambo per siccum."
,"9":"Cumque transissent, Elias dixit ad Eliseum: ' Postula, quod vis, ut faciam tibi, antequam tollar a te '. Dixitque Eliseus: ' Obsecro, ut fiant duae partes spiritus tui in me '."
,"10":"Qui respondit: ' Rem difficilem postulasti. Attamen si videris me, quando tollor a te, erit tibi, quod petisti; si autem non videris, non erit '."
,"11":"Cumque pergerent et incedentes sermocinarentur, ecce currus igneus et equi ignei diviserunt utrumque; et ascendit Elias per turbinem in caelum."
,"12":"Eliseus autem videbat et clamabat: ' Pater mi, pater mi, currus Israel et auriga eius! '. Et non vidit eum amplius; apprehenditque vestimenta sua et scidit illa in duas partes."
,"13":"Et levavit pallium Eliae, quod ceciderat ei, reversusque stetit super ripam Iordanis."
,"14":"Et pallio Eliae, quod ceciderat ei, percussit aquas et dixit: ' Ubi est Deus Eliae etiam nunc? '. Percussitque aquas, et divisae sunt huc atque illuc, et transiit Eliseus."
,"15":"Videntes autem filii prophetarum, qui erant in Iericho de contra, dixerunt: ' Requievit spiritus Eliae super Eliseum '. Et venientes in occursum eius adoraverunt eum proni in terram"
,"16":"dixeruntque illi: ' Ecce cum servis tuis sunt quinquaginta viri fortes, qui possunt ire et quaerere dominum tuum, ne forte tulerit eum spiritus Domini et proiecerit in uno montium aut in una vallium '. Qui ait: ' Nolite mittere! '."
,"17":"Coegeruntque eum, donec acquiesceret et diceret: ' Mittite '. Et miserunt quinquaginta viros. Qui cum quaesissent tribus diebus, non invenerunt"
,"18":"et reversi sunt ad eum. At ille habitabat in Iericho dixitque eis: ' Numquid non dixi vobis: Nolite ire?'."
,"19":"Dixerunt quoque viri civitatis ad Eliseum: ' Ecce habitatio civitatis huius optima est, sicut tu ipse, domine, perspicis; sed aquae pessimae sunt, et terra faciens abortium '."
,"20":"At ille ait: 'Afferte mihi vas novum et mittite in illud sal '. Qui cum attulissent,"
,"21":"egressus ad fontem aquarum misit in eum sal et ait: ' Haec dicit Dominus: Sanavi aquas has, et non erit ultra in eis mors neque abortium '."
,"22":"Sanatae sunt ergo aquae usque ad diem hanc iuxta verbum Elisei, quod locutus est."
,"23":"Ascendit autem inde Bethel. Cumque ascenderet per viam, pueri parvi egressi sunt de civitate et illudebant ei dicentes: 'Ascende, calve; ascende, calve! '."
,"24":"Qui cum respexisset, vidit eos et maledixit eis in nomine Domini; egressique sunt duo ursi de saltu et laceraverunt ex eis quadraginta duos pueros."
,"25":"Abiit autem inde in montem Carmeli et inde reversus est Samariam."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ioram vero filius Achab regnavit super Israel in Samaria anno decimo octavo Iosaphat regis Iudae regnavitque duodecim annis."
,"2":"Et fecit malum coram Domino, sed non sicut pater suus et mater; tulit enim lapidem Baal, quem fecerat pater eius."
,"3":"Verumtamen in peccatis Ieroboam filii Nabat, qui peccare fecit Israel, adhaesit nec recessit ab eis."
,"4":"Porro Mesa rex Moab nutriebat pecora multa et solvebat regi Israel centum milia agnorum et lanam centum milium arietum."
,"5":"Cumque mortuus fuisset Achab, praevaricatus est foedus, quod habebat cum rege Israel."
,"6":"Egressus est igitur rex Ioram in die illa de Samaria et recensuit universum Israel;"
,"7":"profectusque misit ad Iosaphat regem Iudae dicens: ' Rex Moab recessit a me. Vis venire mecum contra Moab ad proelium? '. Qui respondit: ' Ascendam. Qui meus est tuus est, populus meus populus tuus, equi mei equi tui '."
,"8":"Dixitque: ' Per quam viam ascendemus? '. At ille respondit: ' Per desertum Idumaeae '."
,"9":"Perrexerunt igitur rex Israel et rex Iudae et rex Edom et circuierunt per viam septem dierum; nec erat aqua exercitui et iumentis, quae sequebantur eos."
,"10":"Dixitque rex Israel: ' Heu! Congregavit nos Dominus tres reges, ut traderet in manu Moab '."
,"11":"Et ait Iosaphat: ' Estne hic propheta Domini, ut interrogemus Dominum per eum? '. Et respondit unus de servis regis Israel: ' Est hic Eliseus filius Saphat, qui fundebat aquam super manus Eliae '."
,"12":"Et ait Iosaphat: ' Est apud eum sermo Domini '. Descenditque ad eum rex Israel et Iosaphat et rex Edom."
,"13":"Dixit autem Eliseus ad regem Israel: ' Quid mihi et tibi est? Vade ad prophetas patris tui et ad prophetas matris tuae '. Et ait illi rex Israel: 'Non, congregavit enim Dominus tres reges hos, ut traderet eos in manu Moab? '."
,"14":"Dixit autem Eliseus: ' Vivit Dominus exercituum, in cuius conspectu sto, quod si non vultum Iosaphat regis Iudae revererer, ne attendissem quidem te nec respexissem;"
,"15":"nunc autem adducite mihi psaltem '. Cumque caneret psaltes, facta est super eum manus Domini,"
,"16":"et ait: ' Haec dicit Dominus: Facite in torrente hoc fossas et fossas."
,"17":"Haec enim dicit Dominus: Non videbitis ventum neque pluviam, et torrens replebitur aquis; et bibetis vos et pecora et iumenta vestra."
,"18":"Parumque hoc est in conspectu Domini; insuper tradet etiam Moab in manu vestra,"
,"19":"et percutietis omnem civitatem munitam et omnem urbem electam et universum lignum fructiferum succidetis cunctosque fontes aquarum obturabitis et omnem agrum egregium operietis lapidibus '."
,"20":"Factum est igitur mane, quando sacrificium offerri solet, et ecce aquae veniebant per viam Edom. Et repleta est terra aquis."
,"21":"Universi autem Moabitae audientes quod ascendissent reges, ut pugnarent adversum eos, convocaverunt omnes, qui accingi poterant balteo et desuper, et steterunt in terminis."
,"22":"Primoque mane surgentes et, orto iam sole super aquis, viderunt Moabitae e contra aquas rubras quasi sanguinem"
,"23":"dixeruntque: 'Sanguis est gladii! Pugnaverunt reges contra se et caesi sunt mutuo. Nunc perge ad praedam, Moab! '."
,"24":"Perrexeruntque in castra Israel. Porro consurgens Israel percussit Moab, at illi fugerunt coram eis. Venerunt igitur subsequentes et percutientes Moab."
,"25":"Et civitates destruxerunt et omnem agrum optimum mittentes singuli lapides repleverunt; et universos fontes aquarum obturaverunt et omnia ligna fructifera succiderunt, ita ut muri tantum Cirhareseth remanerent; et circumdederunt civitatem fundibularii et aggressi sunt."
,"26":"Quod cum vidisset rex Moab, praevaluisse scilicet hostes, tulit secum septingentos viros educentes gladium, ut irrumperet ad regem Edom; et non potuerunt."
,"27":"Arripiensque filium suum primogenitum, qui regnaturus erat pro eo, obtulit holocaustum super murum. Et facta est indignatio magna super Israel; statimque recesserunt ab eo et reversi sunt in terram suam."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Mulier autem quaedam de uxoribus filiorum prophetarum clamabat ad Eliseum dicens: ' Servus tuus vir meus mortuus est, et tu nosti quia servus tuus fuit timens Dominum; et ecce creditor venit, ut tollat duos filios meos ad serviendum sibi '."
,"2":"Cui dixit Eliseus: ' Quid vis, ut faciam tibi? Dic mihi: Quid habes in domo tua? '. At illa respondit: ' Non habeo ancilla tua quidquam in domo mea, nisi vasculum olei '."
,"3":"Cui ait: ' Vade, pete mutuo ab omnibus vicinis tuis vasa vacua non pauca;"
,"4":"et ingredere et claude ostium, cum intrinsecus fueris tu et filii tui, et mitte inde in omnia vasa haec et, cum plena fuerint, tolles '."
,"5":"Ivit itaque mulier et clausit ostium super se et super filios suos; illi offerebant vasa, et illa infundebat."
,"6":"Cumque plena fuissent vasa, dixit ad filium suum: ' Affer mihi adhuc vas '. Et ille respondit: ' Non habeo '. Stetitque oleum."
,"7":"Venit autem illa et indicavit homini Dei. Et ille: ' Vade, inquit, vende oleum et redde creditori tuo; tu autem et filii tui vivite de reliquo '."
,"8":"Facta est autem quaedam dies, et transibat Eliseus per Sunam. Erat autem ibi mulier magna, quae tenuit eum, ut comederet panem. Quotiescumque inde transibat, divertebat ad eam, ut comederet panem."
,"9":"Quae dixit ad virum suum: ' Animadverto quod vir Dei sanctus est iste, qui transit per nos frequenter."
,"10":"Faciamus ergo cenaculum muratum parvum et ponamus ei in eo lectulum et mensam et sellam et candelabrum, ut, cum venerit ad nos, maneat ibi '."
,"11":"Facta est ergo dies quaedam, et veniens divertit in cenaculum et requievit ibi."
,"12":"Dixitque ad Giezi puerum suum: ' Voca Sunamitin istam '. Qui cum vocasset eam, et illa stetisset coram eo,"
,"13":"dixit ad puerum: ' Loquere ad eam: Ecce sedule in omnibus ministrasti nobis; quid vis, ut faciam tibi? Numquid habes negotium et vis, ut loquar regi sive principi militiae? '. Quae respondit: ' In medio populi mei habito '."
,"14":"Et ait: ' Quid ergo vult, ut faciam ei? '. Dixitque Giezi: 'Ne quaeras; filium enim non habet, et vir eius senex est '."
,"15":"Praecepit itaque, ut vocaret eam; quae cum vocata fuisset et stetisset ad ostium,"
,"16":"dixit ad eam: ' In tempore isto, in anno altero, amplexaberis filium '. At illa respondit: ' Noli, quaeso, domine mi, vir Dei, noli mentiri ancillae tuae '."
,"17":"Et concepit mulier et peperit filium in tempore isto anni alterius, quo dixerat Eliseus."
,"18":"Crevit autem puer et, cum esset quaedam dies, et egressus isset ad patrem suum, ad messores,"
,"19":"ait patri suo: ' Caput meum, caput meum! '. At ille dixit servo: ' Tolle et duc eum ad matrem suam '."
,"20":"Qui cum tulisset et adduxisset eum ad matrem suam, posuit eum illa super genua sua usque ad meridiem, et mortuus est."
,"21":"Ascendit autem et collocavit eum super lectulum hominis Dei et clausit ostium; et egressa"
,"22":"vocavit virum suum et ait: 'Mitte mecum, obsecro, unum de pueris et asinam, ut excurram usque ad hominem Dei et revertar '."
,"23":"Qui ait illi: ' Quam ob causam vadis ad eum hodie? Non sunt calendae neque sabbatum '. Quae respondit: ' Vale '."
,"24":"Stravitque asinam et praecepit puero: ' Mina et propera, ne mihi moram facias in eundo, nisi praecepero tibi '."
,"25":"Profecta est igitur et venit ad virum Dei in montem Carmeli. Cumque vidisset eam vir Dei de contra, ait ad Giezi puerum suum: ' Ecce Sunamitis illa."
,"26":"Vade cito in occursum eius et dic ei: Rectene agitur circa te et circa virum tuum et circa filium tuum? '. Quae respondit: ' Recte '."
,"27":"Cumque venisset ad virum Dei in monte, apprehendit pedes eius; et accessit Giezi, ut amoveret eam, et ait homo Dei: ' Dimitte illam; anima enim eius in amaritudine est, et Dominus celavit me et non indicavit mihi '."
,"28":"Quae dixit illi: ' Numquid petivi filium a domino meo? Numquid non dixi tibi: Ne illudas me? '."
,"29":"Et ille ait ad Giezi: ' Accinge lumbos tuos et tolle baculum meum in manu tua et vade. Si occurrerit tibi homo, non salutes eum et, si salutaverit te quispiam, non respondeas illi. Et pones baculum meum super faciem pueri '."
,"30":"Porro mater pueri ait: ' Vivit Dominus, et vivit anima tua, non dimittam te '. Surrexit ergo et secutus est eam."
,"31":"Giezi autem praecesserat eos et posuerat baculum super faciem pueri, et non erat vox neque sensus reversusque est in occursum eius et nuntiavit ei dicens: ' Non evigilavit puer '."
,"32":"Ingressus est ergo Eliseus domum, et ecce puer mortuus iacebat in lectulo eius;"
,"33":"ingressusque clausit ostium super se et puerum et oravit ad Dominum."
,"34":"Et ascendit et incubuit super puerum posuitque os suum super os eius et oculos suos super oculos eius et manus suas super manus eius et incurvavit se super eum, et calefacta est caro pueri."
,"35":"At ille reversus deambulavit in domo semel huc et illuc et ascendit et incubuit super eum, et sternutavit puer septies aperuitque oculos."
,"36":"Et ille vocavit Giezi et dixit ei: ' Voca Sunamitin hanc '. Quae vocata ingressa est ad eum. Qui ait: ' Tolle filium tuum '."
,"37":"Venit illa et corruit ad pedes eius et adoravit super terram; tulitque filium suum et egressa est."
,"38":"Et Eliseus reversus est in Galgala. Erat autem fames in terra, et filii prophetarum habitabant coram eo. Dixitque puero suo: ' Pone ollam grandem et coque pulmentum filiis prophetarum '."
,"39":"Et egressus est unus in agrum, ut colligeret herbas agrestes; invenitque quasi vitem silvestrem et collegit ex ea colocynthidas agri. Et implevit pallium suum et reversus concidit in ollam pulmenti; nesciebat enim quid esset."
,"40":"Infuderunt ergo sociis, ut comederent. Cumque gustassent de coctione, exclamaverunt dicentes: ' Mors in olla, vir Dei! '. Et non potuerunt comedere."
,"41":"At ille: ' Afferte, inquit, farinam '. Cumque tulissent, misit in ollam et ait: ' Infunde turbae, et comedat '. Et non fuit amplius quidquam amaritudinis in olla."
,"42":"Vir autem quidam venit de Baalsalisa deferens viro Dei panes primitiarum, viginti panes hordeaceos et frumentum novum in pera sua. At ille dixit: ' Da populo, ut comedat '."
,"43":"Responditque ei minister eius: ' Quantum est hoc, ut apponam coram centum viris? '. Rursum ille dixit: ' Da populo, ut comedat. Haec enim dicit Dominus: 'Comedent, et supererit' '."
,"44":"Posuit itaque coram eis, qui comederunt, et superfuit iuxta verbum Domini."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Naaman princeps militiae regis Syriae erat vir magnus apud dominum suum et honoratus; per illum enim dedit Dominus salutem Syriae. Erat autem vir fortis leprosus."
,"2":"Porro de Syria egressa fuerat turma et captivam duxerat de terra Israel puellam parvulam, quae erat in obsequio uxoris Naaman."
,"3":"Quae ait ad dominam suam: ' Utinam esset dominus meus ad prophetam, qui est in Samaria! Profecto curaret eum a lepra, quam habet '."
,"4":"Ingressus est itaque Naaman ad dominum suum et nuntiavit ei dicens: ' Sic et sic locuta est puella de terra Israel '."
,"5":"Dixitque ei rex Syriae: ' Vade, et mittam litteras ad regem Israel '. Qui cum profectus esset et tulisset secum decem talenta argenti et sex milia siclorum auri et decem mutatoria vestimentorum,"
,"6":"detulit litteras ad regem Israel in haec verba: ' Cum acceperis epistulam hanc, scito quod miserim ad te Naaman servum meum, ut cures eum a lepra sua '."
,"7":"Cumque legisset rex Israel litteras, scidit vestimenta sua et ait: ' Numquid Deus sum, ut occidere possim et vivificare, quia iste mittit ad me, ut curem hominem a lepra sua? Animadvertite et videte quod occasiones quaerat adversum me '."
,"8":"Quod cum audisset Eliseus vir Dei, scidisse videlicet regem Israel vestimenta sua, misit ad eum dicens: ' Quare scidisti vestimenta tua? Veniat ad me et sciat esse prophetam in Israel '."
,"9":"Venit ergo Naaman cum equis et curribus et stetit ad ostium domus Elisei."
,"10":"Misitque ad eum Eliseus nuntium dicens: ' Vade et lavare septies in Iordane; et recipiet sanitatem caro tua, atque mundaberis '."
,"11":"Iratus Naaman recedebat dicens: ' Putabam quod egrederetur ad me et stans invocaret nomen Domini Dei sui et tangeret manu sua locum leprae et curaret me."
,"12":"Numquid non meliores sunt Abana et Pharphar, fluvii Damasci, omnibus aquis Israel, ut laver in eis et munder? '. Cum ergo vertisset se et abiret indignans,"
,"13":"accesserunt ad eum servi sui et locuti sunt ei: ' Si rem grandem dixisset tibi propheta, certe faceres; quanto magis quia nunc dixit tibi: 'Lavare et mundaberis!' '."
,"14":"Descendit et intinxit se in Iordane septies iuxta sermonem viri Dei, et restituta est caro eius sicut caro pueri parvuli, et mundatus est."
,"15":"Reversusque ad virum Dei cum universo comitatu suo venit et stetit coram eo et ait: ' Vere scio quod non sit Deus in universa terra, nisi tantum in Israel! Obsecro itaque, ut accipias benedictionem a servo tuo '."
,"16":"At ille respondit: ' Vivit Dominus, ante quem sto, non accipiam '. Cumque vim faceret, penitus non acquievit."
,"17":"Dixitque Naaman: ' Ut vis. Sed, obsecro, concedatur mihi servo tuo tantum terrae quantum onus duorum burdonum; non enim faciet ultra servus tuus holocaustum aut victimam diis alienis, nisi Domino."
,"18":"Hoc autem solum ignoscat Dominus servo tuo, quando ingreditur dominus meus templum Remmon, ut adoret ibi, et illo innitente super manum meam, si adoravero in templo Remmon, adorante eo in eodem loco, ut ignoscat mihi Dominus servo tuo pro hac re '."
,"19":"Qui dixit ei: ' Vade in pace '. Abiit ergo ab eo viam modicam."
,"20":"Dixitque Giezi puer viri Dei: ' Pepercit dominus meus Naaman Syro isti, ut non acciperet ab eo, quae attulit; vivit Dominus, curram post eum et accipiam ab eo aliquid '."
,"21":"Et secutus est Giezi post tergum Naaman. Quem cum vidisset ille currentem ad se, desiluit de curru in occursum eius et ait: ' Rectene sunt omnia? '."
,"22":"Et ille ait: ' Recte. Dominus meus misit me dicens: 'Modo venerunt ad me duo adulescentes de monte Ephraim ex filiis prophetarum. Da eis talentum argenti et vestes mutatorias duplices' '."
,"23":"Dixitque Naaman: ' Melius est, ut accipias duo talenta '. Et coegit eum ligavitque duo talenta argenti in duobus saccis et duplicia vestimenta et imposuit duobus pueris suis, qui et portaverunt coram eo."
,"24":"Cumque venisset ad collem, tulit de manu eorum et reposuit in domo; dimisitque viros et abierunt."
,"25":"Ipse autem ingressus stetit coram domino suo. Et dixit Eliseus: ' Unde venis, Giezi? '. Qui respondit: ' Non ivit servus tuus quoquam '."
,"26":"At ille: ' Nonne, ait, cor meum in praesenti erat, quando reversus est homo de curru suo in occursum tui? Estne tempus accipere argentum et accipere vestes et oliveta et vineta et oves et boves et servos et ancillas?"
,"27":"Sed et lepra Naaman adhaerebit tibi et semini tuo in sempiternum '. Et egressus est ab eo leprosus quasi nix."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Dixerunt autem filii prophetarum ad Eliseum: ' Ecce locus, in quo habitamus coram te, angustus est nobis."
,"2":"Eamus usque ad Iordanem, et tollant singuli de silva materias singulas, ut aedificemus nobis ibi locum ad habitandum '. Qui dixit: ' Ite '."
,"3":"Et ait unus ex illis: ' Veni ergo et tu cum servis tuis '. Respondit: ' Ego veniam '."
,"4":"Et abiit cum eis. Cumque venissent ad Iordanem, caedebant ligna."
,"5":"Accidit autem, ut, cum unus materiam succidisset, caderet ferrum securis in aquam; exclamavitque ille et ait: ' Heu, domine mi! Et hoc ipsum mutuo acceperam! '."
,"6":"Dixit autem homo Dei: ' Ubi cecidit? '. At ille monstravit ei locum. Praecidit ergo lignum et misit illuc, natavitque ferrum."
,"7":"Et ait: ' Tolle!'. Qui extendit manum et tulit illud."
,"8":"Rex autem Syriae pugnabat contra Israel; consiliumque iniit cum servis suis dicens: ' In loco illo et illo ponamus insidias '."
,"9":"Misit itaque vir Dei ad regem Israel dicens: ' Cave, ne transeas in loco illo, quia ibi Syri in insidiis sunt '."
,"10":"Misit rex Israel ad locum, quem dixerat ei vir Dei et de quo praemonuerat eum, et observavit se ibi non semel neque bis."
,"11":"Conturbatumque est cor regis Syriae pro hac re et, convocatis servis suis, ait: ' Quare non indicatis mihi quis proditor mei sit apud regem Israel? '."
,"12":"Dixitque unus servorum eius: ' Nequaquam, domine mi rex. Sed Eliseus propheta, qui est in Israel, indicat regi Israel omnia verba, quaecumque locutus fueris in conclavi tuo '."
,"13":"Dixit eis: ' Ite et videte ubi sit, ut mittam et capiam eum '. Annuntiaveruntque ei dicentes: ' Ecce in Dothain '."
,"14":"Misit ergo illuc equos et currus et robur exercitus; qui cum venissent nocte, circumdederunt civitatem."
,"15":"Consurgens autem diluculo minister viri Dei egressus est viditque exercitum in circuitu civitatis et equos et currus nuntiavitque ei dicens: ' Heu, domine mi, quid faciemus? '."
,"16":"At ille respondit: 'Noli timere; plures enim nobiscum sunt quam cum illis'."
,"17":"Oravitque Eliseus dicens: ' Domine, aperi oculos huius, ut videat '. Et aperuit Dominus oculos pueri, et vidit, et ecce mons plenus equorum et curruum igneorum in circuitu Elisei."
,"18":"Hostes vero descenderunt ad eum. Porro Eliseus oravit Dominum dicens: ' Percute, obsecro, gentem hanc caecitate! '. Percussitque eos Dominus, ne viderent iuxta verbum Elisei."
,"19":"Dixit autem ad eos Eliseus: ' Non est haec via, nec ista est civitas; sequimini me, et ostendam vobis virum, quem quaeritis '. Duxit ergo eos in Samariam."
,"20":"Cumque ingressi fuissent in Samaria, dixit Eliseus: ' Domine, aperi oculos istorum, ut videant '. Aperuitque Dominus oculos eorum, et viderunt esse se in medio Samariae."
,"21":"Dixitque rex Israel ad Eliseum, cum vidisset eos: ' Numquid percutiam eos, pater mi? '."
,"22":"At ille ait: ' Non percuties; neque enim, quos cepisti gladio et arcu tuo, percutis. Pone panem et aquam coram eis, ut comedant et bibant et vadant ad dominum suum '."
,"23":"Appositaque est eis ciborum magna praeparatio, et comederunt et biberunt, et dimisit eos; abieruntque ad dominum suum, et ultra non venerunt turmae Syriae in terram Israel."
,"24":"Factum est autem post haec, congregavit Benadad rex Syriae universum exercitum suum et ascendit et obsidebat Samariam."
,"25":"Factaque est fames magna in Samaria et tamdiu obsessa est, donec venumdaretur caput asini octoginta argenteis et quarta pars cabi stercoris columbarum quinque argenteis."
,"26":"Cumque rex Israel transiret per murum, mulier exclamavit ad eum dicens: ' Salva me, domine mi rex! '."
,"27":"Qui ait: ' Non, salvet te te Dominus. Unde salvare te possum? De area an de torculari? '. Dixitque ad eam rex: ' Quid tibi vis? '. Quae respondit:"
,"28":"' Mulier ista dixit mihi: 'Da filium tuum, ut comedamus eum hodie, et filium meum comedemus cras'."
,"29":"Coximus ergo filium meum et comedimus. Dixique ei die altera: Da filium tuum, ut comedamus eum; quae abscondit filium suum '."
,"30":"Quod cum audisset rex, scidit vestimenta sua. Et transibat super murum, viditque omnis populus cilicium, quo vestitus erat ad carnem intrinsecus."
,"31":"Et ait: ' Haec mihi faciat Deus et haec addat, si steterit caput Elisei filii Saphat super eum hodie '."
,"32":"Eliseus autem sedebat in domo sua, et senes sedebant cum eo. Praemisit itaque rex virum. Sed antequam veniret nuntius, Eliseus dixit ad senes: ' Numquid scitis quod miserit filius homicidae hic, ut praecidatur caput meum? Videte ergo, cum venerit nuntius, claudite ostium et non sinatis eum introire; ecce enim sonitus pedum domini eius post eum est '."
,"33":"Et adhuc illo loquente eis, apparuit rex, qui veniebat ad eum, et ait: ' Ecce, tantum malum a Domino est; quid amplius exspectabo a Domino? '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Dixit autem Eliseus: ' Audite verbum Domini. Haec dicit Dominus: In tempore hoc cras modius similae uno statere erit, et duo modii hordei statere uno in porta Samariae '."
,"2":"Respondens dux, super cuius manum rex incumbebat, homini Dei ait: ' Si Dominus fecerit etiam cataractas in caelo, numquid poterit esse, quod loqueris? '. Qui ait: ' Videbis oculis tuis et inde non comedes '."
,"3":"Quattuor ergo viri erant leprosi iuxta introitum portae; qui dixerunt ad invicem: ' Quid hic esse volumus, donec moriamur?"
,"4":"Sive ingredi voluerimus civitatem, fame moriemur; sive manserimus hic, moriendum nobis est. Venite igitur, et transfugiamus ad castra Syriae. Si pepercerint nobis, vivemus; si autem occidere voluerint, nihilominus moriemur '."
,"5":"Surrexerunt igitur vesperi, ut venirent ad castra Syriae. Cumque venissent ad principium castrorum Syriae, nullum ibidem reppererunt."
,"6":"Siquidem Dominus sonitum audiri fecerat in castris Syriae curruum et equorum et exercitus plurimi; dixeruntque ad invicem: ' Ecce mercede conduxit adversum nos rex Israel reges Hetthaeorum et Aegyptiorum, ut venirent contra nos '."
,"7":"Surrexerunt ergo et fugerunt in tenebris et dereliquerunt tentoria sua et equos et asinos, castra, sicut erant; fugeruntque animas tantum suas salvare cupientes."
,"8":"Igitur cum venissent leprosi illi ad principium castrorum, ingressi sunt unum tabernaculum et comederunt et biberunt; tuleruntque inde argentum et aurum et vestes et abierunt et absconderunt. Et rursum reversi sunt ad aliud tabernaculum, et inde similiter auferentes absconderunt."
,"9":"Dixeruntque ad invicem: ' Non recte facimus; haec enim dies boni nuntii est, et nos tacemus. Si noluerimus nuntiare usque mane, sceleris arguemur; venite, eamus et nuntiemus in aula regis '."
,"10":"Cumque venissent, vocaverunt portarios civitatis et narraverunt eis dicentes: ' Ivimus ad castra Syriae et nullum ibidem repperimus hominum nisi equos et asinos alligatos et tentoria, sicut erant '."
,"11":"Clamaverunt ergo portarii et nuntiaverunt in palatio regis intrinsecus."
,"12":"Qui surrexit nocte et ait ad servos suos: ' Dico vobis quid fecerint nobis Syri. Sciunt quia fame laboramus, et idcirco egressi sunt de castris et latitant in agris dicentes: 'Cum egressi fuerint de civitate, capiemus eos viventes, et tunc civitatem ingredi poterimus' '."
,"13":"Respondit autem unus servorum eius: ' Tollamus quinque equos, qui remanserunt in urbe; fiant sicut universa multitudo Israel, quae consumpta est; mittamus ergo et videamus '."
,"14":"Adduxerunt ergo duos currus cum equis, misitque rex post exercitum Syrorum dicens: ' Ite et videte '."
,"15":"Qui abierunt post eos usque ad Iordanem; ecce autem omnis via plena erat vestibus et vasis, quae proiecerant Syri, cum turbarentur. Reversique nuntii indicaverunt regi."
,"16":"Et egressus populus diripuit castra Syriae; factusque est modius similae statere uno, et duo modii hordei statere uno iuxta verbum Domini."
,"17":"Porro rex ducem illum, in cuius manu incumbebat, constituit ad portam; quem conculcavit turba in introitu, et mortuus est iuxta quod locutus fuerat vir Dei, quando descenderat rex ad eum."
,"18":"Factumque est secundum sermonem viri Dei, quem dixerat regi, quando ait: ' Duo modii hordei statere uno erunt, et modius similae statere uno hoc eodem tempore cras in porta Samariae ';"
,"19":"quando responderat dux ille viro Dei et dixerat: ' Etiamsi Dominus fecerit cataractas in caelo, numquid fieri poterit, quod loqueris? ', et dixerat ei: ' Videbis oculis tuis et inde non comedes '."
,"20":"Evenit ergo ei, sicut praedictum erat, et conculcavit eum populus in porta, et mortuus est."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Eliseus autem locutus est ad mulierem, cuius vivere fecerat fi lium, dicens: ' Surge, vade tu et domus tua et peregrinare ubicumque reppereris; vocavit enim Dominus famem, et veniet super terram septem annis '."
,"2":"Quae surrexit et fecit iuxta verbum hominis Dei et vadens cum domo sua peregrinata est in terra Philisthim septem annis."
,"3":"Cumque finiti essent anni septem, reversa est mulier de terra Philisthim; et egressa est, ut interpellaret regem pro domo sua et agris suis."
,"4":"Rex autem loquebatur cum Giezi puero viri Dei dicens: ' Narra mihi omnia magnalia, quae fecit Eliseus '."
,"5":"Cumque ille narraret regi quomodo mortuum suscitasset, apparuit mulier, cuius vivificaverat filium, clamans ad regem pro domo sua et pro agris suis. Dixitque Giezi: ' Domine mi rex, haec est mulier, et hic filius eius, quem suscitavit Eliseus '."
,"6":"Et interrogavit rex mulierem, quae narravit ei. Deditque ei rex eunuchum unum dicens: ' Restitue ei omnia, quae sua sunt, et universos reditus agrorum a die, qua reliquit terram usque ad praesens '."
,"7":"Venit quoque Eliseus Damascum, et Benadad rex Syriae aegrotabat. Nuntiaveruntque ei dicentes: ' Venit vir Dei huc '."
,"8":"Et ait rex ad Hazael: ' Tolle tecum munera et vade in occursum viri Dei et consule Dominum per eum dicens: Si evadere potero de infirmitate mea hac? '."
,"9":"Ivit igitur Hazael in occursum eius habens secum munera et omnia bona Damasci, onera quadraginta camelorum. Cumque stetisset coram eo, ait: ' Filius tuus Benadad rex Syriae misit me ad te dicens: 'Si sanari potero de infirmitate mea hac?' '."
,"10":"Dixitque ei Eliseus: ' Vade, dic ei: Sanaberis. Porro ostendit mihi Dominus quia morte morietur '."
,"11":"Stetitque facies eius, et conturbatus est usque ad suffusionem vultus flevitque vir Dei."
,"12":"Cui Hazael ait: ' Quare dominus meus flet? '. At ille respondit: ' Quia scio, quae facturus sis filiis Israel mala: civitates eorum munitas igne succendes et iuvenes eorum interficies gladio et parvulos eorum elides et praegnantes discindes '."
,"13":"Dixitque Hazael: ' Quid enim sum servus tuus canis, ut faciam rem istam magnam? '. Et ait Eliseus: ' Ostendit mihi Dominus te regem Syriae fore '."
,"14":"Qui cum recessisset ab Eliseo, venit ad dominum suum. Qui ait ei: ' Quid tibi dixit Eliseus? '. At ille respondit: ' Dixit mihi: Recipies sanitatem '."
,"15":"Cumque venisset dies altera, tulit stragulum et intinxit aqua et expandit super faciem eius, et mortuus est; regnavitque Hazael pro eo."
,"16":"Anno quinto Ioram filii Achab regis Israel - Iosaphat autem erat rex Iudae - regnavit Ioram filius Iosaphat regis Iudae."
,"17":"Triginta duorum erat annorum, cum regnare coepisset, et octo annis regnavit in Ierusalem."
,"18":"Ambulavitque in viis regum Israel, sicut ambulaverat domus Achab; filia enim Achab erat uxor eius. Et fecit, quod malum est coram Domino."
,"19":"Noluit autem Dominus disperdere Iudam propter David servum suum, sicut promiserat ei, ut daret illi lucernam et filiis eius cunctis diebus."
,"20":"In diebus eius recessit Edom, ne esset sub Iuda, et constituit sibi regem."
,"21":"Venitque Ioram Seira et omnis currus cum eo; et surrexit nocte percussitque Idumaeos, qui eum circumdederant, et principes curruum; et populus fugit in tabernacula sua."
,"22":"Recessit ergo Edom, ne esset sub Iuda, usque ad diem hanc. Tunc recessit et Lobna in tempore illo."
,"23":"Reliqua autem gestorum Ioram et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae?"
,"24":"Et dormivit Ioram cum patribus suis sepultusque est cum eis in civitate David; et regnavit Ochozias filius eius pro eo."
,"25":"Anno duodecimo Ioram filii Achab regis Israel regnavit Ochozias filius Ioram regis Iudae."
,"26":"Viginti duorum annorum erat Ochozias, cum regnare coepisset, et uno anno regnavit in Ierusalem. Nomen matris eius Athalia filia Amri regis Israel."
,"27":"Et ambulavit in viis domus Achab et fecit, quod malum est coram Domino, sicut domus Achab; gener enim domus Achab fuit."
,"28":"Abiit quoque cum Ioram filio Achab ad proeliandum contra Hazael regem Syriae in Ramoth Galaad; et vulneraverunt Syri Ioram."
,"29":"Qui reversus est, ut curaretur in Iezrahel de vulneribus, quibus vulneraverant eum Syri in Rama proeliantem contra Hazael regem Syriae. Porro Ochozias filius Ioram rex Iudae descendit invisere Ioram filium Achab in Iezrahel, quia aegrotabat."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Eliseus autem prophetes vocavit unum de filiis prophetarum et ait illi: ' Accinge lumbos tuos et tolle lenticulam olei hanc in manu tua et vade in Ramoth Galaad."
,"2":"Cumque veneris illuc, videbis Iehu filium Iosaphat filii Namsi et ingressus suscitabis eum de medio fratrum suorum et introduces interius cubiculum."
,"3":"Tenensque lenticulam olei fundes super caput eius et dices: ' Haec dicit Dominus: Unxi te regem super Israel '. Aperiesque ostium et fugies et non ibi subsistes '."
,"4":"Abiit ergo adulescens puer prophetae Ramoth Galaad"
,"5":"et ingressus est. Ecce autem principes exercitus sedebant, et ait: ' Verbum mihi ad te, princeps '. Dixitque Iehu: ' Ad quem ex omnibus nobis? '. At ille dixit: ' Ad te, o princeps '."
,"6":"Et surrexit et ingressus est cubiculum. At ille fudit oleum super caput eius et ait: ' Haec dicit Dominus, Deus Israel: Unxi te regem super populum Domini, super Israel."
,"7":"Percuties domum Achab domini tui, ut ulciscar sanguinem servorum meorum prophetarum et sanguinem omnium servorum Domini de manu Iezabel."
,"8":"Perdamque omnem domum Achab et interficiam de Achab quidquid masculini sexus et impuberem et puberem in Israel."
,"9":"Et dabo domum Achab sicut domum Ieroboam filii Nabat et sicut domum Baasa filii Ahiae."
,"10":"Iezabel quoque comedent canes in agro Iezrahel, nec erit qui sepeliat eam '. Aperuitque ostium et fugit."
,"11":"Iehu autem egressus est ad servos domini sui, qui dixerunt ei: ' Rectene sunt omnia? Quid venit insanus iste ad te? '. Qui ait eis: ' Nostis hominem et loquelam eius '."
,"12":"At illi responderunt: ' Mendacium! Narra nobis! '. Qui ait eis: ' Haec et haec locutus est mihi dicens: 'Haec dicit Dominus: Unxi te regem super Israel' '."
,"13":"Festinaverunt itaque et unusquisque tollens pallium suum posuerunt sub pedibus eius super structuram graduum et cecinerunt tuba atque dixerunt: ' Regnavit Iehu! '."
,"14":"Coniuravit ergo Iehu filius Iosaphat filii Namsi contra Ioram. Porro Ioram defenderat Ramoth Galaad ipse et omnis Israel contra Hazael regem Syriae"
,"15":"et reversus fuerat, ut curaretur in Iezrahel propter vulnera, quia percusserant eum Syri proeliantem contra Hazael regem Syriae. Dixitque Iehu: ' Si placet vobis, nemo egrediatur profugus de civitate, ne vadat et nuntiet in Iezrahel '."
,"16":"Et ascendit et profectus est in Iezrahel; Ioram enim aegrotabat ibi, et Ochozias rex Iudae descenderat ad visitandum Ioram."
,"17":"Igitur speculator, qui stabat super turrim Iezrahel, vidit globum Iehu venientis et ait: ' Video ego globum '. Dixitque Ioram: ' Tolle equitem et mitte in occursum eorum, et dicat vadens: 'Rectene sunt omnia?' '."
,"18":"Abiit igitur, qui ascenderat equum in occursum eius, et ait: ' Haec dicit rex: Pacatane sunt omnia? '. Dixitque ei Iehu: ' Quid tibi et paci? Transi et sequere me '. Nuntiavit quoque speculator dicens: ' Venit nuntius ad eos et non revertitur '."
,"19":"Misit etiam equitem secundum; venitque ad eos et ait: ' Haec dicit rex: Num pax est? '. Et ait Iehu: ' Quid tibi et paci? Transi et sequere me '."
,"20":"Nuntiavit autem speculator dicens: ' Venit usque ad eos et non revertitur. Est autem incessus quasi incessus Iehu filii Namsi; praeceps enim graditur '."
,"21":"Et ait Ioram: ' Iunge currum! '. Iunxeruntque currum eius, et egressus est Ioram rex Israel et Ochozias rex Iudae singuli in curribus suis. Egressique sunt in occursum Iehu et invenerunt eum in agro Naboth Iezrahelitis."
,"22":"Cumque vidisset Ioram Iehu, dixit: ' Estne pax, Iehu? '. At ille respondit: ' Quae pax? Adhuc fornicationes Iezabel matris tuae et veneficia eius multa vigent! '."
,"23":"Convertit autem Ioram manum suam et fugiens ait ad Ochoziam: ' Insidiae, Ochozia! '."
,"24":"Porro Iehu tetendit arcum manu et percussit Ioram inter scapulas. Et egressa est sagitta per cor eius; statimque corruit in curru suo."
,"25":"Dixitque Iehu ad Badacer ducem: ' Tolle, proice eum in agro Naboth Iezrahelitae! Memento enim: ego et tu eramus cum his, qui vectabantur gemini post Achab patrem huius, quando Dominus onus hoc levavit super eum dicens:"
,"26":"'Pro sanguine Naboth et pro sanguine filiorum eius, quem vidi heri, ait Dominus, reddam tibi in agro isto, dicit Dominus'. Nunc igitur tolle, proice eum in agro iuxta verbum Domini '."
,"27":"Ochozias autem rex Iudae videns hoc fugit per viam Bethgan; persecutusque est eum Iehu et ait: ' Etiam hunc percutite! '. Et percusserunt eum in curru suo in ascensu Gaver, qui est iuxta Ieblaam. Qui fugit in Mageddo et mortuus est ibi."
,"28":"Et imposuerunt eum servi eius super currum suum et tulerunt Ierusalem sepelieruntque in sepulcro cum patribus suis in civitate David."
,"29":"Anno undecimo Ioram filii Achab regnavit Ochozias super Iudam."
,"30":"Venit Iehu Iezrahel. Porro Iezabel, introitu eius audito, depinxit oculos suos stibio et ornavit caput suum et respexit per fenestram 31 ingredientem Iehu per portam et ait: ' Numquid pax esse potest Zamri, qui interfecit dominum suum? '."
,"32":"Levavitque Iehu faciem suam ad fenestram et ait: ' Quis est mecum, quisnam? '. Et inclinaverunt se ad eum duo vel tres eunuchi."
,"33":"At ille dixit eis: ' Praecipitate eam deorsum! '. Et praecipitaverunt eam; aspersusque est sanguine paries et equi, qui conculcaverunt eam."
,"34":"Cumque ingressus esset, ut comederet biberetque, ait: ' Ite, videte maledictam illam et sepelite eam, quia filia regis est '."
,"35":"Cumque issent, ut sepelirent eam, non invenerunt nisi calvariam et pedes et summas manus."
,"36":"Reversique nuntiaverunt ei. Et ait Iehu: ' Sermo Domini est, quem locutus est per servum suum Eliam Thesbiten dicens: In agro Iezrahel comedent canes carnes Iezabel;"
,"37":"et erit cadaver Iezabel sicut stercus super faciem terrae in agro Iezrahel, ita ut non dicatur: 'Haeccine est illa Iezabel' '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Erant autem Achab septuaginta filii in Samaria. Scripsit ergo Iehu litteras et misit in Samariam ad optimates civitatis et ad maiores natu et ad nutricios filiorum Achab dicens:"
,"2":"' Statim ut acceperitis litteras has, qui habetis filios domini vestri et currus et equos et civitatem firmam et arma,"
,"3":"eligite meliorem et iustiorem de filiis domini vestri et ponite eum super solium patris sui et pugnate pro domo domini vestri '."
,"4":"Timuerunt illi vehementer et dixerunt: ' Ecce duo reges non potuerunt stare coram eo, et quomodo nos valebimus resistere? '."
,"5":"Miserunt ergo praepositus domus et praefectus civitatis et maiores natu et nutricii ad Iehu dicentes: ' Servi tui sumus: quaecumque iusseris, faciemus nec constituemus regem; quodcumque tibi placet, fac '."
,"6":"Rescripsit autem eis litteras secundo dicens: ' Si mei estis et oboeditis mihi, tollite capita virorum filiorum domini vestri et venite ad me hac eadem hora cras in Iezrahel '. Porro filii regis, septuaginta viri, apud optimates civitatis nutriebantur."
,"7":"Cumque venissent litterae ad eos, tulerunt filios regis et occiderunt septuaginta viros et posuerunt capita eorum in cophinis et miserunt ad eum in Iezrahel."
,"8":"Venit autem nuntius et indicavit ei dicens: ' Attulerunt capita filiorum regis'. Qui respondit: ' Ponite ea duos acervos iuxta introitum portae usque mane '."
,"9":"Cumque diluxisset, egressus est et stans dixit ad omnem populum: ' Vos iusti estis; ecce ego coniuravi contra dominum meum et interfeci eum, sed quis percussit omnes hos?"
,"10":"Videte ergo nunc quoniam non cecidit de sermonibus Domini in terram, quos locutus est Dominus super domum Achab, et Dominus fecit, quod locutus est in manu servi sui Eliae '."
,"11":"Percussit igitur Iehu omnes, qui reliqui erant de domo Achab in Iezrahel, et universos optimates eius et notos et sacerdotes, donec non remanerent ex eo reliquiae."
,"12":"Et surrexit et intravit. Deinde profectus est in Samariam; cumque esset ad Betheced Pastorum in via,"
,"13":"invenit fratres Ochoziae regis Iudae dixitque ad eos: ' Quinam estis vos? '. At illi responderunt: ' Fratres Ochoziae sumus et descendimus ad salutandos filios regis et filios dominae reginae '."
,"14":"Qui ait: ' Comprehendite eos vivos '. Quos cum comprehendissent vivos, iugulaverunt eos iuxta cisternam Betheced, quadraginta duos viros, et non reliquit ex eis quemquam."
,"15":"Cumque abisset inde, invenit Ionadab filium Rechab in occursum sibi et benedixit ei. Et ait ad eum: ' Numquid est cor tuum rectum sicut cor meum cum corde tuo? '. Et ait Ionadab: ' Est '. ' Si est, inquit, da manum tuam '. Qui dedit manum suam. At ille levavit eum ad se in curru"
,"16":"dixitque ad eum: ' Veni mecum et vide zelum meum pro Domino '. Et impositum currui suo"
,"17":"duxit in Samariam. Et percussit omnes, qui reliqui fuerant de Achab in Samaria usque ad unum, iuxta verbum Domini, quod locutus est per Eliam."
,"18":"Congregavit ergo Iehu omnem populum et dixit ad eos: ' Achab coluit Baal parum, ego autem colam eum amplius."
,"19":"Nunc igitur omnes prophetas Baal et universos servos eius et cunctos sacerdotes ipsius vocate ad me; nullus sit qui non veniat. Sacrificium enim grande est mihi Baal; quicumque defuerit, non vivet '. Porro Iehu faciebat hoc insidiose, ut disperderet cultores Baal."
,"20":"Dixitque: ' Sanctificate diem sollemnem Baal '. Vocaveruntque."
,"21":"Et misit Iehu in universos terminos Israel, et venerunt cuncti servi Baal; non fuit residuus, ne unus quidem qui non veniret. Et ingressi sunt templum Baal, et repleta est domus Baal a summo usque ad summum."
,"22":"Dixitque ei, qui erat super vestes: ' Profer vestimenta universis servis Baal '. Et protulit eis vestes."
,"23":"Ingressusque Iehu et Ionadab filius Rechab templum Baal ait cultoribus Baal: ' Perquirite et videte, ne quis forte vobiscum sit de servis Domini, sed ut sint soli servi Baal '."
,"24":"Ingressi sunt igitur, ut facerent victimas et holocausta; Iehu autem praeparaverat sibi foris octoginta viros et dixerat eis: ' Quicumque permiserit fugere de hominibus his, quos ego adduxero in manus vestras, anima eius erit pro anima illius '."
,"25":"Factum est ergo cum completum esset holocaustum, praecepit Iehu cursoribus et ducibus suis: ' Ingredimini et percutite eos; nullus evadat! '. Percusseruntque eos cursores et duces ore gladii et proiecerunt. Tunc ierunt usque in dabir templi Baal."
,"26":"Et protulerunt lapidem Baal et combusserunt"
,"27":"et comminuerunt eum. Destruxerunt quoque aedem Baal et fecerunt pro ea latrinas usque diem hanc."
,"28":"Delevit itaque Iehu Baal de Israel."
,"29":"Verumtamen a peccatis Ieroboam filii Nabat, qui peccare fecerat Israel, non recessit; nec dereliquit vitulos aureos, qui erant in Bethel et in Dan."
,"30":"Dixit autem Dominus ad Iehu: ' Quia studiose fecisti, quod rectum erat in oculis meis et omnia quae erant in corde meo fecisti contra domum Achab, filii tui usque ad quartam generationem sedebunt super thronum Israel '."
,"31":"Porro Iehu non custodivit, ut ambularet in lege Domini, Dei Israel, in toto corde suo; non enim recessit a peccatis Ieroboam, qui peccare fecerat Israel."
,"32":"In diebus illis coepit Dominus discindere in Israel; percussitque eos Hazael in universis finibus Israel"
,"33":"a Iordane contra orientalem plagam omnem terram Galaad et Gad et Ruben et Manasse, ab Aroer, quae est super torrentem Arnon, et Galaad et Basan."
,"34":"Reliqua autem gestorum Iehu et universa, quae fecit, et fortitudo eius, nonne haec scripta sunt in libro annalium regum Israel?"
,"35":"Et dormivit Iehu cum patribus suis, sepelieruntque eum in Samaria; et regnavit Ioachaz filius eius pro eo."
,"36":"Dies autem, quos regnavit Iehu super Israel, viginti et octo anni sunt, in Samaria."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Athalia vero mater Ochoziae videns mortuum filium suum surrexit et interfecit omne semen regium."
,"2":"Tollens autem Iosaba filia regis Ioram soror Ochoziae Ioas filium Ochoziae furata est eum de medio filiorum regis, qui interficiebantur, et nutricem eius in cubiculo lectulorum, et absconderunt eum a facie Athaliae, ut non interficeretur."
,"3":"Eratque cum ea in domo Domini clam sex annis; porro Athalia regnavit super terram."
,"4":"Anno autem septimo misit Ioiada et assumens centuriones Carum et cursorum introduxit ad se in templum Domini pepigitque cum eis foedus; et adiurans eos in domo Domini ostendit eis filium regis"
,"5":"et praecepit illis dicens: ' Hoc est, quod facere debetis: tertia pars vestrum introeat sabbato et observet excubitum domus regis;"
,"6":"tertia autem pars ad portam Sur, et tertia pars sit ad portam, quae est post habitaculum cursorum, et custodietis excubitum domus per vices."
,"7":"Duae vero partes e vobis omnes egredientes sabbato custodiant excubias domus Domini circum regem."
,"8":"Et vallabitis eum habentes arma in manibus vestris; si quis autem ingressus fuerit saeptum templi, interficiatur; eritisque cum rege introeunte et egrediente."
,"9":"Et fecerunt centuriones iuxta omnia, quae praeceperat eis Ioiada sacerdos, et assumentes singuli viros suos, qui ingrediebantur sabbato, cum his, qui egrediebantur sabbato, venerunt ad Ioiada sacerdotem."
,"10":"Qui dedit centurionibus hastas et peltas regis David, quae erant in domo Domini."
,"11":"Et steterunt cursores singuli habentes arma in manu sua a parte templi dextera usque ad partem templi sinistram contra altare et aedem circum regem."
,"12":"Produxitque filium regis et dedit ei diadema et testimonium; feceruntque eum regem et unxerunt et plaudentes manu dixerunt: ' Vivat rex! '."
,"13":"Audivit autem Athalia vocem populi et ingressa ad turbas in templum Domini"
,"14":"vidit regem stantem super tribunal iuxta morem et principes et tubas prope eum omnemque populum terrae laetantem et canentem tubis; et scidit vestimenta sua clamavitque: ' Coniuratio, coniuratio! '."
,"15":"Praecepit autem Ioiada sacerdos centurionibus, qui erant super exercitum, et ait eis: ' Educite eam extra consaepta templi, et, quicumque secutus eam fuerit, feriatur gladio '. Dixerat enim sacerdos: ' Non occidatur in templo Domini '."
,"16":"Imposueruntque ei manus et impegerunt eam per viam introitus Equorum in palatium, et interfecta est ibi."
,"17":"Pepigit igitur Ioiada foedus inter Dominum et inter regem et inter populum, ut esset populus Domini, et inter regem et populum."
,"18":"Ingressusque est omnis populus terrae templum Baal, et destruxerunt illud et aras eius et imagines contriverunt valide; Matthan quoque sacerdotem Baal occiderunt coram altaribus. Et posuit sacerdos custodias in domo Domini "
,"19":"tulitque centuriones et Cares et cursores et omnem populum terrae; deduxeruntque regem de domo Domini. Et venerunt per viam portae Cursorum in palatium, et sedit super thronum regum."
,"20":"Laetatusque est omnis populus terrae, et civitas conquievit; Athalia autem occisa est gladio in domo regis."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Septemque annorum erat Ioas, cum regnare coepisset."
,"2":"Anno septimo Iehu regnavit Ioas; quadraginta annis regnavit in Ierusalem. Nomen matris eius Sebia de Bersabee."
,"3":"Fecitque Ioas rectum coram Domino cunctis diebus, quibus docuit eum Ioiada sacerdos."
,"4":"Verumtamen excelsa non abstulit; adhuc populus immolabat et adolebat in excelsis."
,"5":"Dixitque Ioas ad sacerdotes: ' Omnem pecuniam sanctorum, quae illata fuerit in templum Domini a praetereuntibus, quae offertur pro pretio animae, et quam sponte et arbitrio cordis sui inferunt in templum Domini,"
,"6":"accipiant illam singuli sacerdotes a notis suis et instaurent sartatecta domus, si quid necessarium viderint instauratione '."
,"7":"Igitur usque ad vicesimum tertium annum regis Ioas non instauraverunt sacerdotes sartatecta templi."
,"8":"Vocavitque rex Ioas Ioiada pontificem et sacerdotes dicens eis: ' Quare sartatecta non instauratis templi? Nolite ergo amplius accipere pecuniam a notis vestris, sed ad instaurationem templi reddite eam '."
,"9":"Acquieveruntque sacerdotes ultra non accipere pecuniam a populo nec instaurare sartatecta domus."
,"10":"Et tulit Ioiada pontifex gazophylacium unum aperuitque foramen desuper et posuit illud iuxta altare ad dexteram ingredientium domum Domini; mittebantque in eo sacerdotes, qui custodiebant ostia, omnem pecuniam, quae deferebatur ad templum Domini."
,"11":"Cumque viderent multam pecuniam esse in gazophylacio, ascendebat scriba regis et pontifex, colligebantque et numerabant pecuniam, quae inveniebatur in domo Domini,"
,"12":"et dabant eam iuxta numerum atque mensuram in manu opificum, qui operibus praepositi erant in domo Domini; ipsique impendebant eam in fabris lignorum et in structoribus, qui operabantur in domo Domini,"
,"13":"et in caementariis et in his, qui caedebant saxa, et ut emerent ligna et lapides de lapicidinis, ut instaurarentur sartatecta domus Domini, et pro universis, quae indigebant expensa ad muniendam domum."
,"14":"Verumtamen non fiebant pelves argenteae templi Domini et cultri et paterae et tubae, omne vas aureum et argenteum, de pecunia, quae inferebatur in templum Domini;"
,"15":"opificibus enim dabatur, ut instauraretur templum Domini."
,"16":"Et non fiebat ratio his hominibus, qui accipiebant pecuniam, ut distribuerent eam operariis; illi enim in fide agebant."
,"17":"Pecuniam vero pro delicto et pecuniam pro peccatis non inferebatur in templum Domini, quia sacerdotum erat."
,"18":"Tunc ascendit Hazael rex Syriae et pugnabat contra Geth; cepitque eam et direxit faciem suam, ut ascenderet in Ierusalem."
,"19":"Quam ob rem tulit Ioas rex Iudae omnia sanctificata, quae consecraverant Iosaphat et Ioram et Ochozias patres eius reges Iudae, et quae ipse obtulerat, et universum aurum, quod inveniri potuit in thesauris templi Domini et in palatio regis, misitque Hazaeli regi Syriae; et recessit ab Ierusalem."
,"20":"Reliqua autem gestorum Ioas et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae?"
,"21":"Surrexerunt autem servi eius et coniuraverunt inter se percusseruntque Ioas in domo Mello in descensu Sella."
,"22":"Iozachar namque filius Semath et Iozabad filius Somer servi eius percusserunt eum, et mortuus est; et sepelierunt eum cum patribus suis in civitate David. Regnavitque Amasias filius eius pro eo."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Anno vicesimo tertio Ioas fi lii Ochoziae regis Iudae re gnavit Ioachaz filius Iehu super Israel in Samaria decem et septem annis."
,"2":"Et fecit malum coram Domino secutusque est peccatum Ieroboam filii Nabat, qui peccare fecit Israel; non declinavit ab eo."
,"3":"Iratusque est furor Domini contra Israel et tradidit eos in manu Hazael regis Syriae et in manu Benadad filii Hazael cunctis diebus."
,"4":"Deprecatus est autem Ioachaz faciem Domini, et audivit eum Dominus; vidit enim angustiam Israel, qua attriverat eos rex Syriae."
,"5":"Et dedit Dominus Israeli salvatorem, et liberatus est de manu Syriae; habitaveruntque filii Israel in tabernaculis suis sicut heri et nudiustertius."
,"6":"Verumtamen non recesserunt a peccatis domus Ieroboam, qui peccare fecit Israel; in ipsis ambulaverunt. Siquidem et palus permansit in Samaria."
,"7":"Et non reliquit Dominus Ioachaz de populo nisi quinquaginta equites et decem currus et decem milia peditum; interfecerat enim eos rex Syriae et redegerat quasi pulverem in tritura areae."
,"8":"Reliqua autem gestorum Ioachaz et universa, quae fecit, sed et fortitudo eius, nonne haec scripta sunt in libro annalium regum Israel?"
,"9":"Dormivitque Ioachaz cum patribus suis, et sepelierunt eum in Samaria. Regnavitque Ioas filius eius pro eo."
,"10":"Anno tricesimo septimo Ioas regis Iudae regnavit Ioas filius Ioachaz super Israel in Samaria sedecim annis."
,"11":"Et fecit, quod malum est in conspectu Domini; non declinavit ab omnibus peccatis Ieroboam filii Nabat, qui peccare fecit Israel; in ipsis ambulavit."
,"12":"Reliqua autem gestorum Ioas et universa, quae fecit, sed et fortitudo eius, quomodo pugnaverit contra Amasiam regem Iudae, nonne haec scripta sunt in libro annalium regum Israel?"
,"13":"Et dormivit Ioas cum patribus suis; Ieroboam autem sedit super solium eius. Porro Ioas sepultus est in Samaria cum regibus Israel."
,"14":"Eliseus autem aegrotabat infirmitate, qua et mortuus est; descenditque ad eum Ioas rex Israel et flebat coram eo dicebatque: ' Pater mi, pater mi, currus Israel et auriga eius! '."
,"15":"Et ait illi Eliseus: 'Affer arcum et sagittas'. Cumque attulisset ad eum arcum et sagittas,"
,"16":"dixit ad regem Israel: ' Pone manum tuam super arcum '. Et, cum posuisset ille manum suam, superposuit Eliseus manus suas manibus regis"
,"17":"et ait: ' Aperi fenestram orientalem '. Cumque aperuisset, dixit Eliseus: 'Iace sagittam!'. Et iecit. Et ait Eliseus: ' Sagitta salutis Domini, et sagitta salutis contra Syriam. Percutiesque Syriam in Aphec, donec consumas eam '."
,"18":"Et ait: ' Tolle sagittas '. Qui cum tulisset, rursum dixit ei: ' Percute iaculo terram!'. Et, cum percussisset tribus vicibus et stetisset,"
,"19":"iratus est contra eum vir Dei et ait: ' Si percussisses quinquies aut sexies, percussisses Syriam usque ad consummationem; nunc autem tribus vicibus percuties eam '."
,"20":"Mortuus est ergo Eliseus, et sepelierunt eum. Latrunculi autem de Moab venerunt in terra in ipso anno."
,"21":"Quidam autem sepelientes hominem viderunt latrunculos et proiecerunt cadaver in sepulcro Elisei et abierunt. Quod cum tetigisset ossa Elisei, revixit homo et stetit super pedes suos."
,"22":"Igitur Hazael rex Syriae afflixit Israel cunctis diebus Ioachaz."
,"23":"Et misertus est Dominus eorum et reversus est ad eos propter pactum suum, quod habebat cum Abraham, Isaac et Iacob, et noluit disperdere eos neque proicere penitus usque in praesens tempus."
,"24":"Mortuus est autem Hazael rex Syriae; et regnavit Benadad filius eius pro eo."
,"25":"Porro Ioas filius Ioachaz tulit urbes de manu Benadad filii Hazael, quas tulerat de manu Ioachaz patris sui iure proelii; tribus vicibus percussit eum Ioas et reddidit civitates Israeli."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Anno secundo Ioas filii Ioachaz regis Israel regnavit Amasias filius Ioas regis Iudae."
,"2":"Viginti quinque annorum erat, cum regnare coepisset, viginti autem et novem annis regnavit in Ierusalem. Nomen matris eius Ioaden de Ierusalem."
,"3":"Et fecit rectum coram Domino, verumtamen non ut David pater eius. Iuxta omnia, quae fecit Ioas pater suus, fecit,"
,"4":"nisi hoc quod excelsa non abstulit; adhuc enim populus immolabat et adolebat in excelsis."
,"5":"Cumque obtinuisset regnum, percussit servos suos, qui interfecerant regem patrem suum;"
,"6":"filios autem eorum, qui occiderant, non occidit, iuxta quod scriptum est in libro legis Moysi, sicut praecepit Dominus dicens: ' Non morientur patres pro filiis, neque filii morientur pro patribus, sed unusquisque in peccato suo morietur '."
,"7":"Ipse percussit Edom in valle Salinarum decem milia et apprehendit Petram in proelio vocavitque nomen eius Iecethel usque in praesentem diem."
,"8":"Tunc misit Amasias nuntios ad Ioas filium Ioachaz filii Iehu regem Israel dicens: ' Veni, et videamus nos '."
,"9":"Remisitque Ioas rex Israel ad Amasiam regem Iudae dicens: ' Carduus Libani misit ad cedrum, quae est in Libano, dicens: 'Da filiam tuam filio meo uxorem'. Transieruntque bestiae agri, quae sunt in Libano, et conculcaverunt carduum."
,"10":"Percutiens invaluisti super Edom, et sublevavit te cor tuum; contentus esto gloria et sede in domo tua. Quare provocas malum, ut cadas tu et Iuda tecum? '."
,"11":"Et non acquievit Amasias. Ascenditque Ioas rex Israel, et viderunt se ipse et Amasias rex Iudae in Bethsames oppido Iudae. "
,"12":"Percussusque est Iuda coram Israel, et fugerunt unusquisque in tabernacula sua."
,"13":"Amasiam vero regem Iudae filium Ioas filii Ochoziae cepit Ioas rex Israel in Bethsames et adduxit eum in Ierusalem. Et interrupit murum Ierusalem a porta Ephraim usque ad portam Anguli quadringentis cubitis."
,"14":"Tulitque omne aurum et argentum et universa vasa, quae inventa sunt in domo Domini et in thesauris regis, et obsides; et reversus est Samariam."
,"15":"Reliqua autem gestorum Ioas, quae fecit, et fortitudo eius, qua pugnavit contra Amasiam regem Iudae, nonne haec scripta sunt in libro annalium regum Israel?"
,"16":"Dormivitque Ioas cum patribus suis et sepultus est in Samaria cum regibus Israel; et regnavit Ieroboam filius eius pro eo."
,"17":"Vixit autem Amasias filius Ioas rex Iudae, postquam mortuus est Ioas filius Ioachaz rex Israel, quindecim annis."
,"18":"Reliqua autem gestorum Amasiae, nonne haec scripta sunt in libro annalium regum Iudae?"
,"19":"Factaque est contra eum coniuratio in Ierusalem, at ille fugit in Lachis; miseruntque post eum in Lachis et interfecerunt eum ibi."
,"20":"Et asportaverunt eum in equis; sepultusque est in Ierusalem cum patribus suis in civitate David."
,"21":"Tulit autem universus populus Iudae Azariam annos natum sedecim, et constituerunt eum regem pro patre eius Amasia."
,"22":"Ipse aedificavit Ailath et restituit eam Iudae, postquam dormivit rex cum patribus suis."
,"23":"Anno quinto decimo Amasiae filii Ioas regis Iudae regnavit Ieroboam filius Ioas regis Israel in Samaria quadraginta et uno anno."
,"24":"Et fecit, quod malum est coram Domino; non recessit ab omnibus peccatis Ieroboam filii Nabat, qui peccare fecit Israel."
,"25":"Ipse restituit terminos Israel ab introitu Emath usque ad mare Arabae iuxta sermonem Domini, Dei Israel, quem locutus est per servum suum Ionam filium Amathi prophetam, qui erat de Gethhepher."
,"26":"Vidit enim Dominus afflictionem Israel amaram nimis, et quod consumpti essent impuber et puber, et non esset qui auxiliaretur Israel."
,"27":"Nec locutus est Dominus, ut deleret nomen Israel de sub caelo, sed salvavit eos in manu Ieroboam filii Ioas."
,"28":"Reliqua autem gestorum Ieroboam et universa, quae fecit, et fortitudo eius, qua proeliatus est, et quomodo restituit, quod de finibus Damasci et Emath fuerat Iudae, Israeli, nonne haec scripta sunt in libro annalium regum Israel?"
,"29":"Dormivitque Ieroboam cum patribus suis regibus Israel; et regnavit Zacharias filius eius pro eo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Anno vicesimo septimo Ieroboam regis Israel regnavit Azarias filius Amasiae regis Iudae."
,"2":"Sedecim annorum erat, cum regnare coepisset, et quinquaginta duobus annis regnavit in Ierusalem. Nomen matris eius Iechelia de Ierusalem."
,"3":"Fecitque, quod erat placitum coram Domino, iuxta omnia, quae fecit Amasias pater eius."
,"4":"Verumtamen excelsa non est demolitus; adhuc populus sacrificabat et adolebat in excelsis."
,"5":"Percussit autem Dominus regem, et fuit leprosus usque in diem mortis suae et habitabat in domo separata seorsum; Ioatham vero filius regis gubernabat palatium et iudicabat populum terrae."
,"6":"Reliqua autem gestorum Azariae et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae?"
,"7":"Et dormivit Azarias cum patribus suis, sepelieruntque eum cum maioribus suis in civitate David; et regnavit Ioatham filius eius pro eo."
,"8":"Anno tricesimo octavo Azariae regis Iudae regnavit Zacharias filius Ieroboam super Israel in Samaria sex mensibus."
,"9":"Et fecit, quod malum est coram Domino, sicut fecerant patres eius; non recessit a peccatis Ieroboam filii Nabat, qui peccare fecit Israel."
,"10":"Coniuravit autem contra eum Sellum filius Iabes percussitque eum in Ieblaam et interfecit; regnavitque pro eo."
,"11":"Reliqua autem gestorum Zachariae, nonne haec scripta sunt in libro annalium regum Israel?"
,"12":"Iste est sermo Domini, quem locutus est ad Iehu dicens: ' Filii usque ad quartam generationem sedebunt de te super thronum Israel '. Factumque est ita."
,"13":"Sellum filius Iabes regnavit tricesimo nono anno Azariae regis Iudae; regnavit autem uno mense in Samaria."
,"14":"Et ascendit Manahem filius Gadi de Thersa venitque Samariam et percussit Sellum filium Iabes in Samaria et interfecit eum; regnavitque pro eo."
,"15":"Reliqua autem gestorum Sellum et coniuratio eius, per quam tetendit insidias, nonne haec scripta sunt in libro annalium regum Israel?"
,"16":"Tunc percussit Manahem Thapsam et omnes, qui erant in ea, et terminos eius de Thersa; noluerant enim aperire ei. Et interfecit omnes praegnantes eius et scidit eas."
,"17":"Anno tricesimo nono Azariae regis Iudae regnavit Manahem filius Gadi super Israel decem annis in Samaria."
,"18":"Fecitque, quod erat malum coram Domino; non recessit a peccatis Ieroboam filii Nabat, qui peccare fecit Israel. In diebus eius"
,"19":"venit Phul rex Assyriorum in terram, et dedit Manahem Phul mille talenta argenti, ut esset ei in auxilio et firmaret regnum eius."
,"20":"Indixitque Manahem argentum super Israel cunctis potentibus, ut daret regi Assyriorum, quinquaginta siclos argenti per singulos. Reversusque est rex Assyriorum et non est moratus in terra."
,"21":"Reliqua autem gestorum Manahem et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Israel?"
,"22":"Et dormivit Manahem cum patribus suis; regnavitque Phaceia filius eius pro eo."
,"23":"Anno quinquagesimo Azariae regis Iudae regnavit Phaceia filius Manahem super Israel in Samaria biennio."
,"24":"Et fecit, quod erat malum coram Domino; non recessit a peccatis Ieroboam filii Nabat, qui peccare fecit Israel."
,"25":"Coniuravit autem adversus eum Phacee filius Romeliae dux eius et percussit eum in Samaria in turre domus regiae, et cum eo erant quinquaginta viri de filiis Galaaditarum. Et interfecit eum regnavitque pro eo."
,"26":"Reliqua autem gestorum Phaceia et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Israel?"
,"27":"Anno quinquagesimo secundo Azariae regis Iudae regnavit Phacee filius Romeliae super Israel in Samaria viginti annis."
,"28":"Et fecit, quod malum erat coram Domino; non recessit a peccatis Ieroboam filii Nabat, qui peccare fecit Israel."
,"29":"In diebus Phacee regis Israel venit Theglathphalasar rex Assur et cepit Ahion et Abelbethmaacha et Ianoe et Cedes et Asor et Galaad et Galilaeam, universam terram Nephthali, et transtulit eos in Assur."
,"30":"Coniuravit autem et tetendit insidias Osee filius Ela contra Phacee filium Romeliae; et percussit eum et interfecit regnavitque pro eo vicesimo anno Ioatham filii Oziae."
,"31":"Reliqua autem gestorum Phacee et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Israel?"
,"32":"Anno secundo Phacee filii Romeliae regis Israel regnavit Ioatham filius Oziae regis Iudae."
,"33":"Viginti quinque annorum erat, cum regnare coepisset, et sedecim annis regnavit in Ierusalem. Nomen matris eius Ierusa filia Sadoc."
,"34":"Fecitque, quod erat placitum coram Domino; iuxta omnia, quae fecerat Ozias pater suus, operatus est."
,"35":"Verumtamen excelsa non abstulit; adhuc populus immolabat et adolebat in excelsis. Ipse aedificavit portam domus Domini superiorem."
,"36":"Reliqua autem gestorum Ioatham et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae?"
,"37":"In diebus illis coepit Dominus mittere in Iudam Rasin regem Syriae et Phacee filium Romeliae."
,"38":"Et dormivit Ioatham cum patribus suis sepultusque est cum eis in civitate David patris sui; et regnavit Achaz filius eius pro eo."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Anno septimo decimo Phacee filii Romeliae regnavit Achaz filius Ioatham regis Iudae."
,"2":"Viginti annorum erat Achaz, cum regnare coepisset, et sedecim annis regnavit in Ierusalem; non fecit, quod erat placitum in conspectu Domini Dei sui, sicut David pater eius,"
,"3":"sed ambulavit in via regum Israel. Insuper et filium suum consecravit transferens per ignem secundum abominationes gentium, quas dissipavit Dominus coram filiis Israel;"
,"4":"immolabat quoque et adolebat in excelsis et in collibus et sub omni ligno frondoso."
,"5":"Tunc ascendit Rasin rex Syriae et Phacee filius Romeliae rex Israel in Ierusalem ad proeliandum; cumque obsiderent Achaz, non valuerunt superare eum."
,"6":"In tempore illo restituit Rasin rex Syriae Ailath ad Edom et eiecit Iudaeos de Ailath; et Idumaei venerunt in Ailath et habitaverunt ibi usque in diem hanc."
,"7":"Misit autem Achaz nuntios ad Theglathphalasar regem Assyriorum dicens: ' Servus tuus et filius tuus ego sum. Ascende et salvum me fac de manu regis Syriae et de manu regis Israel, qui consurrexerunt adversum me '."
,"8":"Et cum collegisset argentum et aurum, quod invenire potuit in domo Domini et in thesauris regis, misit regi Assyriorum munera."
,"9":"Qui et acquievit voluntati eius. Ascendit enim rex Assyriorum in Damascum et vastavit eam et transtulit habitatores eius in Cir; Rasin autem interfecit."
,"10":"Perrexitque rex Achaz in occursum Theglathphalasar regis Assyriorum in Damascum. Cumque vidisset altare Damasci, misit rex Achaz ad Uriam sacerdotem exemplar eius et descriptionem omnis operis eius."
,"11":"Exstruxitque Urias sacerdos altare; iuxta omnia, quae miserat rex Achaz de Damasco, ita fecit Urias sacerdos, donec veniret rex Achaz de Damasco."
,"12":"Cumque venisset rex de Damasco, vidit altare et accessit ad illud ascenditque"
,"13":"et adolevit holocausta sua et oblationes et libavit libamina et fudit sanguinem pacificorum suorum super altare."
,"14":"Porro altare aeneum, quod erat coram Domino, transtulit de facie templi et de loco inter altare et templum Domini posuitque illud ex latere altaris ad aquilonem."
,"15":"Praecepit quoque rex Achaz Uriae sacerdoti dicens: ' Super altare maius offer holocaustum matutinum et oblationem vespertinam et holocaustum regis et oblationem eius et holocaustum universi populi terrae et oblationem eorum et libamina eorum; et omnem sanguinem holocausti et universum sanguinem sacrificii super illud effundes. De altari vero aeneo erit mihi deliberandum '."
,"16":"Fecit igitur Urias sacerdos iuxta omnia, quae praeceperat rex Achaz."
,"17":"Excidit autem rex Achaz limbos basium et removit luterem, qui erat desuper, et mare deposuit de bobus aeneis, qui sustentabant illud, et posuit super pavimentum stratum lapide."
,"18":"Musach (id est Porticum) quoque sabbati, quod aedificatum erat in templo, et ingressum regis exterius convertit in templo Domini propter regem Assyriorum."
,"19":"Reliqua autem gestorum Achaz, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae?"
,"20":"Dormivitque Achaz cum patribus suis et sepultus est cum eis in civitate David; et regnavit Ezechias filius eius pro eo."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Anno duodecimo Achaz regis Iudae regnavit Osee filius Ela in Samaria super Israel novem annis."
,"2":"Fecitque malum coram Domino, sed non sicut reges Israel, qui ante eum fuerant."
,"3":"Contra hunc ascendit Salmanasar rex Assyriorum; et factus est ei Osee servus reddebatque illi tributa."
,"4":"Cumque deprehendisset rex Assyriorum Osee quod rebellare nitens misisset nuntios ad Sua regem Aegypti nec praestaret tributa regi Assyriorum, sicut singulis annis solitus erat, apprehendit eum et vinctum misit in carcerem."
,"5":"Pervagatusque est omnem terram et ascendens Samariam obsedit eam tribus annis."
,"6":"Anno autem nono Osee cepit rex Assyriorum Samariam et transtulit Israel in Assur posuitque eos in Hala et iuxta Habor fluvium Gozan et in civitatibus Medorum."
,"7":"Factum est enim hoc, cum peccassent filii Israel Domino Deo suo, qui eduxerat eos de terra Aegypti, de manu pharaonis regis Aegypti: coluerunt deos alienos."
,"8":"Et ambulaverunt iuxta ritus gentium, quas consumpserat Dominus in conspectu filiorum Israel et regum Israel, qui similiter fecerant."
,"9":"Et offenderunt filii Israel operibus non rectis Dominum Deum suum et aedificaverunt sibi excelsa in cunctis urbibus suis a turre custodum usque ad civitatem munitam."
,"10":"Feceruntque sibi lapides et palos in omni colle sublimi et subter omne lignum nemorosum"
,"11":"et adolebant ibi in omnibus excelsis sicut gentes, quas transtulerat Dominus a facie eorum; feceruntque pessima irritantes Dominum"
,"12":"et coluerunt idola immunda, de quibus praecepit Dominus eis, ne facerent hoc."
,"13":"Et testificatus est Dominus in Israel et in Iuda per manum omnium prophetarum et videntium dicens: ' Revertimini a viis vestris pessimis et custodite mandata mea et praecepta iuxta omnem legem, quam praecepi patribus vestris, et sicut misi ad vos in manu servorum meorum prophetarum '."
,"14":"Qui non audierunt, sed induraverunt cervicem suam iuxta cervicem patrum suorum, qui noluerunt credere in Dominum Deum suum."
,"15":"Et abiecerunt legitima eius et pactum, quod pepigit cum patribus eorum, et testificationes, quibus contestatus est eos; secutique sunt vanitates et vani facti sunt et secuti sunt gentes, quae erant per circuitum eorum, super quibus praeceperat Dominus eis ut non facerent, sicut et illae faciebant."
,"16":"Et dereliquerunt omnia praecepta Domini Dei sui feceruntque sibi conflatiles duos vitulos et palum et adoraverunt universam militiam caeli servieruntque Baal"
,"17":"et consecrabant filios suos et filias suas per ignem; et divinationibus inserviebant et auguriis et tradiderunt se, ut facerent malum coram Domino et irritarent eum."
,"18":"Iratusque est Dominus vehementer Israel et abstulit eos de conspectu suo, et non remansit nisi tribus Iudae tantummodo."
,"19":"Sed nec ipse Iuda custodivit mandata Domini Dei sui; verum ambulavit in erroribus Israel, quos operatus fuerat."
,"20":"Proiecitque Dominus omne semen Israel et afflixit eos et tradidit in manu diripientium, donec proiceret eos a facie sua,"
,"21":"ex eo iam tempore, quo scissus est Israel a domo David, et constituerunt sibi regem Ieroboam filium Nabat; separavit enim Ieroboam Israel a Domino et peccare eos fecit peccatum magnum."
,"22":"Et ambulaverunt filii Israel in universis peccatis Ieroboam, quae fecerat; non recesserunt ab eis,"
,"23":"usquequo auferret Dominus Israel a facie sua, sicut locutus fuerat in manu omnium servorum suorum prophetarum. Translatusque est Israel de terra sua in Assur usque in diem hanc."
,"24":"Adduxit autem rex Assyriorum de Babylone et de Chutha et de Ava et de Emath et de Sepharvaim et collocavit eos in civitatibus Samariae pro filiis Israel, qui possederunt Samariam et habitaverunt in urbibus eius."
,"25":"Cumque ibi habitare coepissent, non timebant Dominum. Et immisit eis Dominus leones, qui interficiebant inter eos."
,"26":"Nuntiatumque est regi Assyriorum et dictum: ' Gentes, quas transtulisti et habitare fecisti in civitatibus Samariae, ignorant legitima Dei terrae; et immisit eis leones, et ecce interficiunt eos, eo quod ignorent ritum Dei terrae '."
,"27":"Praecepit autem rex Assyriorum dicens: ' Ducite illuc unum de sacerdotibus, quos inde captivos adduxistis, et vadat et habitet cum eis et doceat eos legitima Dei terrae '."
,"28":"Igitur cum venisset unus de sacerdotibus his, qui captivi ducti fuerant de Samaria, habitavit in Bethel et docebat eos quomodo colerent Dominum."
,"29":"Et unaquaeque gens fabricata est deum suum; posueruntque eos in fanis excelsis, quae fecerant Samaritae, gens et gens in urbibus suis, in quibus habitabant."
,"30":"Viri enim Babylonii fecerunt Socchothbenoth, viri autem Chutheni fecerunt Nergel, et viri de Emath fecerunt Asima;"
,"31":"porro Hevaei fecerunt Nebahaz et Tharthac, hi autem, qui erant de Sepharvaim, comburebant filios suos igne Adramelech et Anamelech diis Sepharvaim."
,"32":"Et nihilominus colebant Dominum. Fecerunt autem sibi de medio ipsorum sacerdotes excelsorum et ponebant eos in fanis excelsorum;"
,"33":"et, cum Dominum colerent, diis quoque suis serviebant iuxta consuetudinem gentium, de quibus translati fuerant Samariam."
,"34":"Usque in praesentem diem morem sequuntur antiquum: non timent Dominum neque custodiunt instituta et iudicium ipsorum et legem et mandatum, quod praeceperat Dominus filiis Iacob, quem cognominavit Israel,"
,"35":"et percusserat cum eis pactum et mandaverat eis dicens: ' Nolite timere deos alienos et non adoretis eos neque colatis et non immoletis eis,"
,"36":"sed Dominum, qui eduxit vos de terra Aegypti in fortitudine magna et in brachio extento, ipsum timete, illum adorate et ipsi immolate."
,"37":"Instituta quoque et iudicia et legem et mandatum, quod scripsit vobis, custodite, ut faciatis cunctis diebus; et non timeatis deos alienos."
,"38":"Et pactum, quod percussi vobiscum, nolite oblivisci nec timeatis deos alienos,"
,"39":"sed Dominum Deum vestrum timete, et ipse eruet vos de manu omnium inimicorum vestrorum '."
,"40":"Illi vero non audierunt, sed iuxta consuetudinem suam pristinam perpetrabant."
,"41":"Fuerunt igitur gentes istae timentes quidem Dominum, sed nihilominus et idolis suis servientes; nam et filii eorum et nepotes, sicut fecerunt parentes sui, ita faciunt usque in praesentem diem."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Anno tertio Osee filii Ela regis Israel regnavit Ezechias filius Achaz regis Iudae."
,"2":"Viginti quinque annorum erat, cum regnare coepisset, et viginti et novem annis regnavit in Ierusalem. Nomen matris eius Abi filia Zachariae."
,"3":"Fecitque, quod erat bonum coram Domino, iuxta omnia, quae fecerat David pater suus."
,"4":"Ipse dissipavit excelsa et contrivit lapides et succidit palum confregitque serpentem aeneum, quem fecerat Moyses; siquidem usque ad illud tempus filii Israel adolebant ei; vocabatur Nohestan."
,"5":"In Domino, Deo Israel, speravit. Itaque post eum non fuit similis ei de cunctis regibus Iudae sed neque in his, qui ante eum fuerunt."
,"6":"Et adhaesit Domino et non recessit a vestigiis eius fecitque mandata eius, quae praeceperat Dominus Moysi,"
,"7":"unde et erat Dominus cum eo, et in cunctis, ad quae procedebat, prospere agebat. Rebellavit quoque contra regem Assyriorum et non servivit ei. "
,"8":"Ipse percussit Philisthaeos usque Gazam et terminos eius, a turre custodum usque ad civitatem munitam."
,"9":"Anno quarto regis Ezechiae, qui erat annus septimus Osee filii Ela regis Israel, ascendit Salmanasar rex Assvriorum Samariam et oppugnavit eam"
,"10":"et cepit. Post annos tres, anno sexto Ezechiae, id est nono anno Osee regis Israel, capta est Samaria."
,"11":"Et transtulit rex Assyriorum Israel in Assur collocavitque eos in Hala et Habor iuxta fluvium Gozan et in civitatibus Medorum,"
,"12":"quia non audierunt vocem Domini Dei sui, sed praetergressi sunt pactum eius; omnia, quae praeceperat Moyses servus Domini, non audierunt neque fecerunt."
,"13":"Anno quarto decimo regis Ezechiae ascendit Sennacherib rex Assyriorum ad universas civitates Iudae munitas et cepit eas."
,"14":"Tunc misit Ezechias rex Iudae nuntios ad regem Assyriorum Lachis dicens: ' Peccavi. Recede a me, et omne, quod imposueris mihi, feram '. Indixit itaque rex Assyriorum Ezechiae regi Iudae trecenta talenta argenti et triginta talenta auri;"
,"15":"deditque Ezechias omne argentum, quod repertum fuerat in domo Domini et in thesauris regis."
,"16":"In tempore illo confregit Ezechias valvas templi Domini et postes, quos ipse inauraverat, et dedit aurum regi Assyriorum."
,"17":"Misit autem rex Assyriorum Tharthan et Rabsaris et Rabsacen de Lachis ad regem Ezechiam cum manu valida Ierusalem. Qui cum ascendissent, venerunt in Ierusalem et steterunt iuxta aquae ductum piscinae superioris, quae est in via agri fullonis,"
,"18":"vocaveruntque regem. Egressus est autem ad eos Eliachim filius Helciae praepositus domus et Sobna scriba et Ioah filius Asaph a commentariis."
,"19":"Dixitque ad eos Rabsaces: ' Loquimini Ezechiae: Haec dicit rex magnus, rex Assyriorum: Quae est ista fiducia, qua niteris?"
,"20":"Forsitan putas verbum labiorum esse consilium et fortitudinem ad proelium? In quo confidis, ut audeas rebellare contra me?"
,"21":"An speras in baculo arundineo atque confracto, Aegypto, super quem, si incubuerit homo, comminutus ingreditur manum eius et perforabit eam? Sic est pharao rex Aegypti omnibus, qui confidunt in eo."
,"22":"Quod si dixeritis mihi: 'In Domino Deo nostro habemus fiduciam', nonne iste est, cuius abstulit Ezechias excelsa et altaria et praecepit Iudae et Ierusalem: 'Ante altare hoc adorabitis in Ierusalem?'."
,"23":"Nunc igitur spondete cum domino meo rege Assyriorum; dabo tibi duo milia equorum; et vide an habere valeas ascensores eorum."
,"24":"Et quomodo potes in fugam vertere unum satrapam de servis domini mei minimis? An fiduciam habes in Aegypto propter currus et equites?"
,"25":"Numquid sine Domini voluntate ascendi ad locum istum, ut demolirer eum? Dominus dixit mihi: 'Ascende ad terram hanc et demolire eam' '."
,"26":"Dixerunt autem Eliachim filius Helciae et Sobna et Ioah Rabsaci: ' Precamur, ut loquaris nobis servis tuis Aramaice, siquidem intellegimus hanc linguam, et non loquaris nobis Iudaice, audiente populo, qui est super murum '."
,"27":"Responditque eis Rabsaces: ' Numquid ad dominum tuum et ad te misit me dominus meus, ut loquerer sermones hos, et non ad viros, qui sedent super murum, ut comedant stercora sua et bibant urinam suam vobiscum? '."
,"28":"Stetit itaque Rabsaces et clamavit voce magna Iudaice et ait: ' Audite verba regis magni, regis Assyriorum:"
,"29":"Haec dicit rex: Non vos seducat Ezechias; non enim poterit eruere vos de manu mea!"
,"30":"Neque fiduciam vobis tribuat super Domino dicens: 'Eruens liberabit nos Dominus, et non tradetur civitas haec in manu regis Assyriorum'."
,"31":"Nolite audire Ezechiam! Haec enim dicit rex Assyriorum: Facite mecum benedictionem et egredimini ad me, et comedet unusquisque de vinea sua et de ficu sua, et bibetis aquas de cisternis vestris,"
,"32":"donec veniam et transferam vos in terram, quae similis terrae vestrae est, in terram fructiferam et fertilem vini, terram panis et vinearum, terram olivarum olei ac mellis; et vivetis et non moriemini. Nolite audire Ezechiam, qui vos decipit dicens: 'Dominus liberabit nos!'."
,"33":"Numquid liberaverunt dii gentium unusquisque terram suam de manu regis Assyriorum?"
,"34":"Ubi sunt dii Emath et Arphad? Ubi sunt dii Sepharvaim, Ana et Ava? Numquid liberaverunt Samariam de manu mea?"
,"35":"Quinam illi sunt in universis diis terrarum, qui eruerunt regionem suam de manu mea, ut possit eruere Dominus Ierusalem de manu mea? '."
,"36":"Tacuit itaque populus et non respondit ei quidquam; siquidem praeceptum regis acceperant, ut non responderent ei."
,"37":"Venitque Eliachim filius Helciae praepositus domus et Sobna scriba et Ioah filius Asaph a commentariis ad Ezechiam, scissis vestibus, et nuntiaverunt ei verba Rabsacis."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Quae cum audisset rex Ezechias, scidit vestimenta sua et opertus est sacco ingressusque est domum Domini."
,"2":"Et misit Eliachim praepositum domus et Sobnam scribam et senes de sacerdotibus opertos saccis ad Isaiam prophetam filium Amos."
,"3":"Qui dixerunt: ' Haec dicit Ezechias: Dies tribulationis et increpationis et blasphemiae dies iste; venerunt filii usque ad partum, et vires non habet parturiens."
,"4":"Forte audiet Dominus Deus tuus universa verba Rabsacis, quem misit rex Assyriorum dominus suus, ut exprobraret Deum viventem, et puniet verba, quae audivit Dominus Deus tuus; et fac orationem pro reliquiis, quae remanent '."
,"5":"Venerunt ergo servi regis Ezechiae ad Isaiam."
,"6":"Dixitque eis Isaias: ' Haec dicetis domino vestro: Haec dicit Dominus: Noli timere a facie sermonum, quos audisti, quibus blasphemaverunt pueri regis Assyriorum me;"
,"7":"ecce ego immittam ei spiritum, et audiet nuntium et revertetur in terram suam; et deiciam eum gladio in terra sua '."
,"8":"Reversus est igitur Rabsaces et invenit regem Assyriorum oppugnantem Lobnam; audierat enim quod recessisset de Lachis."
,"9":"Cumque audisset de Tharaca rege Aethiopiae dicentes: ' Ecce egressus est, ut pugnet adversum te ', iterum misit nuntios ad Ezechiam dicens:"
,"10":"' Haec dicite Ezechiae regi Iudae: Non te seducat Deus tuus, in quo habes fiduciam, neque dicas: 'Non tradetur Ierusalem in manu regis Assyriorum'."
,"11":"Tu enim ipse audisti, quae fecerint reges Assyriorum universis terris, quomodo vastaverint eas. Num ergo solus poteris liberari?"
,"12":"Numquid liberaverunt dii gentium singulos, quos vastaverunt patres mei, Gozan videlicet et Charran et Reseph et filios Eden, qui erant in Thelassar?"
,"13":"Ubi est rex Emath et rex Arphad et rex civitatis Sepharvaim, Ana et Ava? '."
,"14":"Itaque cum accepisset Ezechias litteras de manu nuntiorum et legisset eas, ascendit in domum Domini et expandit eas coram Domino"
,"15":"et oravit in conspectu eius dicens: ' Domine, Deus Israel, qui sedes super cherubim! Tu es Deus solus regnorum omnium terrae, tu fecisti caelum et terram."
,"16":"Inclina aurem tuam et audi; aperi, Domine, oculos tuos et vide et audi omnia verba Sennacherib, qui misit, ut exprobraret Deum viventem."
,"17":"Vere, Domine, dissipaverunt reges Assyriorum gentes et terras earum"
,"18":"et miserunt deos eorum in ignem; non enim erant dii, sed opera manuum hominum ex ligno et lapide, et perdiderunt eos."
,"19":"Nunc igitur, Domine Deus noster, salvos nos fac de manu eius, ut sciant omnia regna terrae quia tu, Domine, es Deus solus '."
,"20":"Misit autem Isaias filius Amos ad Ezechiam dicens: ' Haec dicit Dominus, Deus Israel: Quae deprecatus es me super Sennacherib rege Assyriorum, audivi."
,"21":"Iste est sermo, quem locutus est Dominus de eo: Sprevit te et subsannavit virgo filia Sion; post tergum tuum caput,movit filia Ierusalem."
,"22":"Cui exprobrasti et quem blasphemasti?,Contra quem exaltasti vocem,et elevasti in excelsum oculos tuos? Contra Sanctum Israel!"
,"23":"Per manum servorum tuorum,exprobrasti Domino,et dixisti: 'In multitudine curruum meorum,ascendi excelsa montium in summitate Libani,et succidi sublimes cedros eius, electas abietes eius, et ingressus sum usque ad terminos eius, silvam condensam."
,"24":"Ego fodi et bibi aquas alienas,et siccavi vestigiis pedum meorum omnes aquas Aegypti'."
,"25":"Numquid non audisti, ab initio quid fecerim?,Ex diebus antiquis plasmavi illud,et nunc adduxi; eruntque in eradicationem, in acervos ruinarum civitates munitae."
,"26":"Et, qui sedent in eis breviata manu, contremuerunt et confusi sunt; facti sunt quasi fenum agri,et gramen virens, herba tectorum, quae arefacta est, antequam veniret ad maturitatem."
,"27":"Sessionem tuam,et egressum tuum et introitum tuum ego praescivi,et furorem tuum contra me;"
,"28":"insanisti in me, et superbia tua ascendit in aures meas. Ponam itaque circulum in naribus tuis,et frenum in labris tuis,et reducam te in viam, per quam venisti."
,"29":"Tibi autem, Ezechia, hoc erit signum: Comede hoc anno, quod reppereris, in secundo autem anno, quae sponte nascuntur; porro in anno tertio seminate et metite, plantate vineas et comedite fructum earum."
,"30":"Et, quodcumque reliquum fuerit de domo Iudae, mittet radicem deorsum,et faciet fructum sursum;"
,"31":"de Ierusalem quippe egredientur reliquiae, et, quod relinquetur, de monte Sion. Zelus Domini exercituum faciet hoc."
,"32":"Quam ob rem haec dicit Dominus de rege Assyriorum: Non ingredietur urbem hanc,nec mittet in eam sagittam,nec occurret ei clipeo,nec fundet aggerem circa eam."
,"33":"Per viam, qua venit, revertetur,et civitatem hanc non ingredietur, dicit Dominus."
,"34":"Protegamque urbem hanc et salvabo eam,propter me et propter David servum meum '."
,"35":"Factum est igitur in nocte illa: egressus est angelus Domini et percussit in castris Assyriorum centum octoginta quinque milia. Cumque diluculo surrexissent, viderunt omnia corpora mortuorum."
,"36":"Et recedens abiit et reversus est Sennacherib rex Assyriorum et mansit in Nineve."
,"37":"Cumque adoraret in templo Nesroch dei sui, Adramelech et Sarasar filii eius percusserunt eum gladio fugeruntque in terram Armeniorum. Et regnavit Asarhaddon filius eius pro eo."
}`)
	CurrentBook.AddChapter(20, `{
"1":"In diebus illis aegrotavit Ezechias usque ad mortem. Et venit ad eum Isaias filius Amos prophetes dixitque ei: ' Haec dicit Dominus: Dispone domui tuae, morieris enim et non vives '."
,"2":"Qui convertit faciem suam ad parietem et oravit Dominum dicens:"
,"3":"' Obsecro, Domine, memento quomodo ambulaverim coram te in veritate et in corde perfecto et, quod placitum est coram te, fecerim '. Flevit itaque Ezechias fletu magno."
,"4":"Et antequam egrederetur Isaias mediam partem atrii, factus est sermo Domini ad eum dicens:"
,"5":"' Revertere et dic Ezechiae duci populi mei: Haec dicit Dominus, Deus David patris tui: Audivi orationem tuam, vidi lacrimam tuam, et ecce sano te; die tertio ascendes templum Domini."
,"6":"Et addam diebus tuis quindecim annos; sed et de manu regis Assyriorum liberabo te et civitatem hanc et protegam urbem istam propter me et propter David servum meum '."
,"7":"Dixitque Isaias: ' Afferte massam ficorum '. Quam cum attulissent et posuissent super ulcus eius, curatus est."
,"8":"Dixit autem Ezechias ad Isaiam: ' Quod erit signum quia Dominus me sanabit et quia ascensurus sum die tertio templum Domini? '."
,"9":"Cui ait Isaias: ' Hoc erit tibi signum a Domino quod facturus sit Dominus sermonem, quem locutus est: Vis ut accedat umbra decem gradibus, an ut revertatur totidem gradibus? '."
,"10":"Et ait Ezechias: ' Facile est umbram descendere decem gradibus, nec hoc volo ut fiat, sed ut revertatur retrorsum decem gradibus '."
,"11":"Invocavit itaque Isaias propheta Dominum; et reduxit umbram per gradus, quibus iam descenderat in gradibus Achaz, retrorsum decem gradibus."
,"12":"In tempore illo misit Merodachbaladan filius Baladan rex Babyloniorum litteras et munera ad Ezechiam; audierat enim quod aegrotasset Ezechias."
,"13":"Laetatus est autem in adventu eorum Ezechias et ostendit eis totam domum thesauri sui, argentum et aurum et aromata et oleum optimum et domum vasorum suorum et omnia, quae inventa sunt in thesauris suis: non fuit, quod non monstraret eis Ezechias in domo sua et in omni potestate sua."
,"14":"Venit autem Isaias propheta ad regem Ezechiam dixitque ei: ' Quid dixerunt viri isti et unde venerunt ad te? '. Cui ait Ezechias: ' De terra longinqua venerunt, de Babylone '."
,"15":"At ille respondit: ' Quid viderunt in domo tua? '. Ait Ezechias: ' Omnia, quae sunt in domo mea viderunt; nihil est, quod non monstraverim eis in thesauris meis '."
,"16":"Dixit itaque Isaias Ezechiae: ' Audi sermonem Domini:"
,"17":"Ecce dies venient, et auferentur omnia, quae sunt in domo tua, et quae condiderunt patres tui usque in diem hanc, in Babylone; non remanebit quidquam, ait Dominus."
,"18":"Sed et de filiis tuis, qui egredientur ex te, quos generabis, tollentur et erunt eunuchi in palatio regis Babylonis '."
,"19":"Dixit Ezechias ad Isaiam: ' Bonus sermo Domini, quem locutus es '. Et ait: ' Nonne erit pax et securitas in diebus meis? '."
,"20":"Reliqua autem gestorum Ezechiae et omnis fortitudo eius, et quomodo fecerit piscinam et aquae ductum et introduxerit aquas in civitatem, nonne haec scripta sunt in libro annalium regum Iudae?"
,"21":"Dormivitque Ezechias cum patribus suis; et regnavit Manasses filius eius pro eo."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Duodecim annorum erat Manasses, cum regnare coe pisset, et quinquaginta quinque annis regnavit in Ierusalem. Nomen matris eius Haphsiba."
,"2":"Fecitque malum in conspectu Domini iuxta abominationes gentium, quas delevit Dominus a facie filiorum Israel."
,"3":"Conversusque est et aedificavit excelsa, quae dissipaverat Ezechias pater eius, et erexit aras Baal et fecit palum, sicut fecerat Achab rex Israel, et adoravit omnem militiam caeli et coluit eam."
,"4":"Exstruxitque aras in domo Domini, de qua dixit Dominus: ' In Ierusalem ponam nomen meum '."
,"5":"Et exstruxit altaria universae militiae caeli in duobus atriis templi Domini"
,"6":"et traduxit filium suum per ignem et hariolatus est et observavit auguria et constituit pythones et haruspices multiplicavit, ut faceret malum coram Domino et irritaret eum."
,"7":"Posuit quoque palum Aserae, quem fecerat, in templo, super quo locutus est Dominus ad David et ad Salomonem filium eius: ' In templo hoc et in Ierusalem, quam elegi de cunctis tribubus Israel, ponam nomen meum in sempiternum;"
,"8":"et ultra non faciam commoveri pedem Israel de terra, quam dedi patribus eorum, sic tamen si custodierint opere omnia, quae praecepi eis, et universam legem, quam mandavit eis servus meus Moyses '."
,"9":"Illi vero non audierunt, sed seducti sunt a Manasse, ut facerent malum plus quam gentes, quas contrivit Dominus a facie filiorum Israel."
,"10":"Locutusque est Dominus in manu servorum suorum prophetarum dicens:"
,"11":"' Quia fecit Manasses rex Iudae abominationes istas pessimas super omnia, quae fecerunt Amorraei ante eum, et peccare fecit etiam Iudam in idolis suis,"
,"12":"propterea haec dicit Dominus, Deus Israel: Ecce ego inducam mala super Ierusalem et Iudam, ut quicumque audierit, tinniant ambae aures eius."
,"13":"Et extendam super Ierusalem funiculum Samariae et pondus domus Achab et extergam Ierusalem sicut qui extergit vas, extergit et convertit super faciem eius."
,"14":"Et proiciam reliquias hereditatis meae et tradam eas in manu inimicorum eius; eruntque in vastitate et rapina cunctis adversariis suis,"
,"15":"eo quod fecerint malum coram me et perseveraverint irritantes me ex die, qua egressi sunt patres eorum ex Aegypto, usque ad diem hanc '."
,"16":"Insuper et sanguinem innoxium fudit Manasses multum nimis, donec impleret Ierusalem usque ad summum, absque peccatis suis, quibus peccare fecit Iudam, ut faceret malum coram Domino."
,"17":"Reliqua autem gestorum Manasse et universa, quae fecit, et peccatum eius, quod peccavit, nonne haec scripta sunt in libro annalium regum Iudae?"
,"18":"Dormivitque Manasses cum patribus suis et sepultus est in horto domus suae, in horto Oza; et regnavit Amon filius eius pro eo."
,"19":"Viginti et duo annorum erat Amon, cum regnare coepisset, duobusque annis regnavit in Ierusalem. Nomen matris eius Mesallemeth filia Harus de Ieteba."
,"20":"Fecitque malum in conspectu Domini, sicut fecerat Manasses pater eius,"
,"21":"et ambulavit in omni via, per quam ambulaverat pater eius; servivitque idolis, quibus servierat pater suus, et adoravit ea."
,"22":"Et dereliquit Dominum, Deum patrum suorum et non ambulavit in via Domini."
,"23":"Tetenderuntque ei insidias servi sui et interfecerunt regem in domo sua;"
,"24":"percussit autem populus terrae omnes, qui coniuraverant contra regem Amon, et constituerunt sibi regem Iosiam filium eius pro eo."
,"25":"Reliqua autem gestorum Amon, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae?"
,"26":"Sepelieruntque eum in sepulcro suo in horto Oza; et regnavit Iosias filius eius pro eo."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Octo annorum erat Iosias, cum regnare coepisset, et tri ginta et uno anno regnavit in Ierusalem. Nomen matris eius Idida filia Adaia de Bascath."
,"2":"Fecitque, quod placitum erat coram Domino, et ambulavit per omnes vias David patris sui; non declinavit ad dexteram sive ad sinistram."
,"3":"Anno autem octavo decimo regis Iosiae misit rex Saphan filium Eseliae filii Mesullam scribam ad templum Domini dicens ei:"
,"4":"' Vade ad Helciam sacerdotem magnum, ut effundatur pecunia, quae illata est in templum Domini, quam collegerunt ianitores a populo,"
,"5":"deturque opificibus praepositis in domo Domini, qui et distribuent eam his, qui operantur in templo Domini ad instauranda sartatecta templi,"
,"6":"tignariis videlicet et caementariis et his, qui interrupta componunt, et ut emantur ligna et lapides de lapicidinis ad instaurandum templum."
,"7":"Verumtamen non supputetur eis argentum, quod accipiunt, quia in potestate habent et in fide '."
,"8":"Dixit autem Helcias pontifex ad Saphan scribam: ' Librum legis repperi in domo Domini! '. Deditque Helcias volumen Saphan, qui et legit illud."
,"9":"Venit quoque Saphan scriba ad regem et renuntiavit ei, quod praeceperat, et ait: ' Effuderunt servi tui pecuniam, quae reperta est in domo, et dederunt opificibus praefectis operum templi Domini '."
,"10":"Narravitque Saphan scriba regi dicens: ' Librum dedit mihi Helcias sacerdos '. Quem cum legisset Saphan coram rege, "
,"11":"et audisset rex verba libri legis, scidit vestimenta sua"
,"12":"et praecepit Helciae sacerdoti et Ahicam filio Saphan et Achobor filio Micha et Saphan scribae et Asaiae servo regis dicens:"
,"13":"' Ite et consulite Dominum super me et super populo et super omni Iuda de verbis voluminis istius, quod inventum est; magna enim ira Domini succensa est contra nos, quia non audierunt patres nostri verba libri huius, ut facerent omne, quod scriptum est nobis '."
,"14":"Ierunt itaque Helcias sacerdos et Ahicam et Achobor et Saphan et Asaia ad Holdam propheten uxorem Sellum filii Thecuae filii Haraas custodis vestium, quae habitabat in Ierusalem in secunda, locutique sunt ad eam,"
,"15":"et illa respondit eis: ' Haec dicit Dominus, Deus Israel: Dicite viro, qui misit vos ad me:"
,"16":"Haec dicit Dominus: Ecce ego adducam mala super locum hunc et super habitatores eius omnia verba libri, quae legit rex Iudae,"
,"17":"quia dereliquerunt me et sacrificaverunt diis alienis irritantes me in cunctis operibus manuum suarum; et succendetur indignatio mea in loco hoc et non exstinguetur."
,"18":"Regi autem Iudae, qui misit vos, ut consuleretis Dominum, sic dicetis: Haec dicit Dominus, Deus Israel: Pro eo quod audisti verba voluminis,"
,"19":"et perterritum est cor tuum, et humiliatus es coram Domino, auditis sermonibus contra locum istum et habitatores eius, quo videlicet fierent in stuporem et in maledictum, et scidisti vestimenta tua et flevisti coram me, et ego audivi, ait Dominus;"
,"20":"idcirco colligam te ad patres tuos, et colligeris ad sepulcrum tuum in pace, ut non videant oculi tui omnia mala, quae inducturus sum super locum istum '. Et renuntiaverunt regi, quod dixerat."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Qui misit, et congregati sunt ad eum omnes senes Iudae et Ierusalem;"
,"2":"ascenditque rex templum Domini et omnes viri Iudae universique, qui habitabant in Ierusalem cum eo, sacerdotes et prophetae et omnis populus a parvo usque ad magnum. Legitque, cunctis audientibus, omnia verba libri foederis, qui inventus est in domo Domini."
,"3":"Stetitque rex super gradum suum et percussit foedus coram Domino, ut ambularent post Dominum et custodirent praecepta eius et testimonia et legitima in omni corde et in tota anima et suscitarent verba foederis huius, quae scripta erant in libro illo. Acquievitque universus populus pacto."
,"4":"Et praecepit rex Helciae pontifici et sacerdotibus secundi ordinis et ianitoribus, ut proicerent de templo Domini omnia vasa, quae facta fuerant Baal et Aserae et universae militiae caeli; et combussit ea foris Ierusalem in convalle Cedron et tulit pulverem eorum in Bethel."
,"5":"Et delevit aedituos, quos posuerant reges Iudae ad sacrificandum in excelsis per civitates Iudae et in circuitu Ierusalem, et eos, qui adolebant Baal et soli et lunae et duodecim signis et omni militiae caeli."
,"6":"Et efferri fecit palum de domo Domini foras Ierusalem in convalle Cedron et combussit eum ibi et redegit in pulverem et proiecit super sepulcrum vulgi."
,"7":"Destruxit quoque aediculas prostibulorum, quae erant in domo Domini, in quibus mulieres texebant vestes pro Asera."
,"8":"Congregavitque omnes sacerdotes de civitatibus Iudae et contaminavit excelsa, ubi sacrificabant sacerdotes, de Gabaa usque Bersabee; et destruxit excelsa pilosorum in introitu portae Iosue principis civitatis, ad sinistram ingredientis portam civitatis."
,"9":"Verumtamen non ascendebant sacerdotes excelsorum ad altare Domini in Ierusalem, sed tantum comedebant azyma in medio fratrum suorum."
,"10":"Contaminavit quoque Topheth, quod est in convalle Benennom, ut nemo consecraret filium suum aut filiam per ignem Moloch."
,"11":"Abstulit quoque equos, quos dederant reges Iudae soli in introitu templi Domini iuxta cubiculum Nathanmelech eunuchi, quod erat in Pharurim; currus autem solis combussit igne."
,"12":"Altaria quoque, quae erant super tectum cenaculi Achaz, quae fecerant reges Iudae, et altaria, quae fecerat Manasses in duobus atriis templi Domini, destruxit rex et contrivit ea ibi et dispersit cinerem eorum in torrentem Cedron."
,"13":"Excelsa quoque, quae erant ex adverso Ierusalem ad dexteram partem montis Perditionis, quae aedificaverat Salomon rex Israel Astharoth idolo Sidoniorum et Chamos idolo Moab et Melchom idolo filiorum Ammon, polluit rex;"
,"14":"et contrivit lapides et succidit palos replevitque loca eorum ossibus mortuorum."
,"15":"Insuper et altare, quod erat in Bethel, excelsum, quod fecerat Ieroboam filius Nabat, qui peccare fecit Israel, etiam altare illud et excelsum destruxit atque combussit et comminuit in pulverem succenditque palum."
,"16":"Et conversus Iosias vidit ibi sepulcra, quae erant in monte, misitque et tulit ossa de sepulcris et combussit ea super altare et polluit illud iuxta verbum Domini, quod clamaverat vir Dei, cum staret Ieroboam in die festo ad altare. Et conversus elevavit oculos in sepulcrum viri Dei, qui clamaverat verba haec,"
,"17":"et ait: ' Quis est titulus ille, quem video? '. Responderuntque ei cives illius urbis: ' Sepulcrum est hominis Dei, qui venit de Iuda et clamavit verba haec, quae fecisti super altare Bethel '."
,"18":"Et ait: ' Dimittite eum; nemo commoveat ossa eius '. Et intacta manserunt ossa illius cum ossibus prophetae, qui venerat de Samaria."
,"19":"Insuper et omnia fana excelsorum, quae erant in civitatibus Samariae, quae fecerant reges Israel ad irritandum Dominum, abstulit Iosias et fecit eis secundum omnia opera, quae fecerat in Bethel."
,"20":"Et immolavit universos sacerdotes excelsorum, qui erant ibi super altaria, et combussit ossa humana super ea; reversusque est Ierusalem."
,"21":"Et praecepit omni populo dicens: ' Facite Pascha Domino Deo vestro secundum quod scriptum est in libro foederis huius '."
,"22":"Nec enim factum est Pascha tale a diebus iudicum, qui iudicaverunt Israel, et omnibus diebus regum Israel et regum Iudae,"
,"23":"sicut in octavo decimo anno regis Iosiae factum est Pascha istud Domino in Ierusalem."
,"24":"Sed et pythones et hariolos et theraphim et idola abominationesque omnes, quae erant in terra Iudae et in Ierusalem, abstulit Iosias, ut statueret verba legis, quae scripta sunt in libro, quem invenit Helcias sacerdos in templo Domini."
,"25":"Similis illi non fuit ante eum rex, qui reverteretur ad Dominum in omni corde suo et in tota anima sua et in universa virtute sua iuxta omnem legem Moysi, neque post eum surrexit similis illi."
,"26":"Verumtamen non est aversus Dominus ab ira furoris sui magni, quo iratus est furor eius contra Iudam propter omnes irritationes, quibus provocaverat eum Manasses."
,"27":"Dixit itaque Dominus: ' Etiam Iudam auferam a facie mea, sicut abstuli Israel, et proiciam civitatem hanc, quam elegi, Ierusalem et domum, de qua dixi: Erit nomen meum ibi '."
,"28":"Reliqua autem gestorum Iosiae et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae?"
,"29":"In diebus eius ascendit pharao Nechao rex Aegypti contra regem Assyriorum ad flumen Euphraten. Et abiit Iosias rex in occursum eius, qui occidit eum in Mageddo, cum vidisset eum."
,"30":"Et portaverunt eum in curru servi sui mortuum de Mageddo et pertulerunt in Ierusalem et sepelierunt eum in sepulcro suo. Tulitque populus terrae Ioachaz filium Iosiae et unxerunt eum et constituerunt eum regem pro patre suo."
,"31":"Viginti trium annorum erat Ioachaz, cum regnare coepisset, et tribus mensibus regnavit in Ierusalem. Nomen matris eius Amital filia Ieremiae de Lobna."
,"32":"Et fecit malum coram Domino iuxta omnia, quae fecerant patres eius."
,"33":"Vinxitque eum pharao Nechao in Rebla, quae est in terra Emath, ne regnaret in Ierusalem; et imposuit multam terrae centum talentis argenti et talento auri;"
,"34":"regemque constituit pharao Nechao Eliachim filium Iosiae pro Iosia patre eius vertitque nomen eius Ioachim. Porro Ioachaz tulit, et venit in Aegyptum et mortuus est ibi."
,"35":"Argentum autem et aurum dedit Ioachim pharaoni, cum indixisset terrae, ut conferretur argentum iuxta praeceptum pharaonis; et secundum uniuscuiusque aestimationem exegit tam argentum quam aurum de populo terrae, ut daret pharaoni Nechao."
,"36":"Viginti quinque annorum erat Ioachim, cum regnare coepisset, et undecim annis regnavit in Ierusalem. Nomen matris eius Zebida filia Phadaia de Ruma."
,"37":"Et fecit malum coram Domino iuxta omnia, quae fecerant patres eius."
}`)
	CurrentBook.AddChapter(24, `{
"1":"In diebus eius ascendit Nabuchodonosor rex Babylonis, et factus est ei Ioachim servus tribus annis et rursum rebellavit contra eum."
,"2":"Immisitque ei Dominus turmas Chaldaeorum et turmas Syriae, turmas Moab et turmas filiorum Ammon; et immisit eas in Iudam, ut disperderent eum iuxta verbum Domini, quod locutus erat per servos suos prophetas."
,"3":"Factum est autem hoc propter iram Domini contra Iudam, ut auferret eum de conspectu suo propter peccata Manasse universa, quae fecit,"
,"4":"et propter sanguinem innoxium, quem effudit et implevit Ierusalem cruore innocentium; et ob hanc rem noluit Dominus propitiari."
,"5":"Reliqua autem gestorum Ioachim et universa, quae fecit, nonne haec scripta sunt in libro annalium regum Iudae? Et dormivit Ioachim cum patribus suis;"
,"6":"regnavitque Ioachin filius eius pro eo."
,"7":"Et ultra non addidit rex Aegypti ut egrederetur de terra sua; tulerat enim rex Babylonis a rivo Aegypti usque ad fluvium Euphraten omnia, quae fuerant regis Aegypti."
,"8":"Decem et octo annorum erat Ioachin, cum regnare coepisset, et tribus mensibus regnavit in Ierusalem. Nomen matris eius Naestha filia Elnathan de Ierusalem."
,"9":"Et fecit malum coram Domino iuxta omnia, quae fecerat pater eius."
,"10":"In tempore illo ascenderunt servi Nabuchodonosor regis Babylonis in Ierusalem, et venit urbs in obsidione."
,"11":"Venitque Nabuchodonosor rex Babylonis ad civitatem, cum servi eius oppugnarent eam;"
,"12":"egressusque est Ioachin rex Iudae ad regem Babylonis ipse et mater eius et servi eius et principes eius et eunuchi eius; et cepit eum rex Babylonis anno octavo regni sui."
,"13":"Et protulit inde omnes thesauros domus Domini et thesauros domus regiae et concidit universa vasa aurea, quae fecerat Salomon rex Israel in templo Domini, iuxta verbum Domini."
,"14":"Et transtulit omnem Ierusalem et universos principes et omnes fortes exercitus decem milia in captivitatem et omnem artificem et clusorem; nihilque relictum est, exceptis pauperibus populi terrae."
,"15":"Transtulit quoque Ioachin in Babylonem; et matrem regis et uxores regis et eunuchos eius et cives validos terrae duxit in captivitatem de Ierusalem in Babylonem"
,"16":"et omnes viros robustos septem milia et artifices et clusores mille, omnes viros fortes bellatores; duxitque eos rex Babylonis captivos in Babylonem."
,"17":"Et constituit Matthaniam patruum eius pro eo; imposuitque nomen ei Sedeciam."
,"18":"Vicesimum et primum annum aetatis habebat Sedecias, cum regnare coepisset, et undecim annis regnavit in Ierusalem. Nomen matris eius erat Amital filia Ieremiae de Lobna."
,"19":"Et fecit malum coram Domino iuxta omnia, quae fecerat Ioachim;"
,"20":"irascebatur enim Dominus contra Ierusalem et contra Iudam, donec proiceret eos a facie sua. Recessitque Sedecias a rege Babylonis."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Factum est autem anno nono regni eius, mense decimo, decima die mensis venit Nabuchodonosor rex Babylonis ipse et omnis exercitus eius in Ierusalem; et circumdederunt eam et exstruxerunt in circuitu eius munitiones."
,"2":"Et clausa est civitas atque vallata usque ad undecimum annum regis Sedeciae."
,"3":"Nona die mensis quarti praevaluit fames in civitate, nec erat panis populo terrae."
,"4":"Et interrupta est civitas, et omnes viri bellatores fugerunt exieruntque de civitate nocte per viam portae, quae est inter duplicem murum ad hortum regis, obsidentibus Chaldaeis in circuitu civitatem. Abierunt itaque per viam, quae ducit ad Arabam."
,"5":"Et persecutus est exercitus Chaldaeorum regem comprehenditque eum in planitie Iericho, et omnis exercitus eius dispersus est et reliquit eum."
,"6":"Apprehensum ergo regem duxerunt ad regem Babylonis in Rebla, qui locutus est cum eo iudicium."
,"7":"Filios autem Sedeciae occidit coram eo et oculos eius effodit vinxitque eum catenis aereis et adduxit in Babylonem."
,"8":"Mense quinto septima die mensis, ipse est annus nonus decimus regis Babylonis, venit Nabuzardan princeps satellitum servus regis Babylonis Ierusalem"
,"9":"et succendit domum Domini et domum regis et omnes domos Ierusalem; omnemque domum combussit igne."
,"10":"Et muros Ierusalem in circuitu destruxit omnis exercitus Chaldaeorum, qui erat cum principe satellitum."
,"11":"Reliquam autem populi partem, qui remanserat in civitate, et perfugas, qui transfugerant ad regem Babylonis, et reliquum vulgus transtulit Nabuzardan princeps satellitum;"
,"12":"et de pauperibus terrae reliquit in vinitores et agricolas."
,"13":"Columnas autem aereas, quae erant in templo Domini, et bases et mare aereum, quod erat in domo Domini, confregerunt Chaldaei et transtulerunt aes omnium in Babylonem."
,"14":"Ollas quoque et trullas et cultros et phialas et omnia vasa aerea, in quibus ministrabant, tulerunt;"
,"15":"necnon thymiamateria et phialas, quae aurea aurea et quae argentea argentea, tulit princeps satellitum;"
,"16":"columnas duas, mare unum et bases, quas fecerat Salomon templo Domini; non erat pondus aeris omnium horum vasorum."
,"17":"Decem et octo cubitos altitudinis habebat columna una et capitellum aereum super se altitudinis quinque cubitorum; et reticulum et malogranata super capitellum in circuitu omnia aerea; similem et columna secunda habebat ornatum."
,"18":"Tulit quoque princeps satellitum Saraiam sacerdotem primum et Sophoniam sacerdotem secundum et tres ianitores"
,"19":"et de civitate eunuchum unum, qui erat praefectus super viros bellatores, et quinque viros de his, qui steterant coram rege, quos repperit in civitate, et scribam principis exercitus, qui probabat tirones de populo terrae, et sexaginta viros e populo terrae, qui inventi fuerant in civitate;"
,"20":"quos tollens Nabuzardan princeps satellitum duxit ad regem Babylonis in Rebla,"
,"21":"percussitque eos rex Babylonis et interfecit in Rebla in terra Emath. Et translatus est Iuda de terra sua."
,"22":"Populo autem, qui relictus erat in terra Iudae, quem dimiserat Nabuchodonosor rex Babylonis, praefecit Godoliam filium Ahicam filii Saphan."
,"23":"Quod cum audissent omnes duces militum, videlicet quod constituisset rex Babylonis Godoliam, ipsi et viri, qui erant cum eis, venerunt ad Godoliam in Maspha: Ismael filius Nathaniae et Iohanan filius Caree et Saraia filius Thanehumeth Netophathites et Iezonias filius Maachathitis, ipsi et socii eorum."
,"24":"Iuravitque eis Godolias et sociis eorum dicens: ' Nolite timere a servis Chaldaeorum; manete in terra et servite regi Babylonis, et bene erit vobis '."
,"25":"Factum est autem in mense septimo venit Ismael filius Nathaniae filii Elisama de semine regio et decem viri cum eo; percusseruntque Godoliam, qui mortuus est, sed et Iudaeos et Chaldaeos, qui erant cum eo in Maspha."
,"26":"Consurgens autem populus a parvo usque ad magnum et principes militum venerunt in Aegyptum timentes Chaldaeos."
,"27":"Factum est vero anno tricesimo septimo transmigrationis Ioachin regis Iudae, mense duodecimo vicesima septima die mensis sublevavit Evilmerodach rex Babylonis anno, quo regnare coeperat, caput Ioachin regis Iudae de carcere."
,"28":"Et locutus est ei benigna et posuit thronum eius super thronos regum, qui erant cum eo in Babylone,"
,"29":"et mutavit vestes eius, quas habuerat in carcere; et comedebat panem semper in conspectu eius cunctis diebus vitae suae."
,"30":"Annonam quoque constituit ei absque intermissione, quae et dabatur ei a rege per singulos dies omnibus diebus vitae suae."
}`)

}
func LA_NVBSE_LoadVH2SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Factum est autem, postquam mortuus est Saul, ut David re verteretur a caede Amalec et maneret in Siceleg dies duos."
,"2":"In die autem tertia apparuit homo veniens de castris Saul veste conscissa et pulvere aspersus caput; et, ut venit ad David, cecidit super faciem suam et adoravit."
,"3":"Dixitque ad eum David: ' Unde venis? '. Qui ait ad eum: ' De castris Israel fugi '."
,"4":"Et dixit ad eum David: ' Quid enim factum est? Indica mihi '. Qui ait: ' Fugit populus ex proelio, et multi corruentes e populo mortui sunt; sed et Saul et Ionathan filius eius interierunt '."
,"5":"Dixitque David ad adulescentem, qui nuntiabat ei: ' Unde scis quia mortuus est Saul et Ionathan filius eius? '."
,"6":"Et ait adulescens, qui narrabat ei: ' Casu veni in montem Gelboe, et Saul incumbebat super hastam suam. Porro currus et equites appropinquabant ei,"
,"7":"et conversus post tergum suum vidensque me vocavit. Cui cum respondissem: Adsum,"
,"8":"dixit mihi: 'Quisnam es tu?'. Et dixi ad eum: Amalecites ego sum."
,"9":"Et locutus est mihi: 'Sta super me et interfice me, quoniam tenent me angustiae, et adhuc tota anima mea in me est'."
,"10":"Stansque super eum occidi illum; sciebam enim quod vivere non poterat post ruinam. Et tuli diadema, quod erat in capite eius, et armillam de brachio illius et attuli ad te dominum meum huc '."
,"11":"Apprehendens autem David vestimenta sua scidit omnesque viri, qui erant cum eo;"
,"12":"et planxerunt et fleverunt et ieiunaverunt usque ad vesperam super Saul et super Ionathan filium eius et super populum Domini et super domum Israel, quod corruissent gladio."
,"13":"Dixitque David ad iuvenem, qui nuntiaverat ei: ' Unde es? '. Qui respondit: ' Filius hominis advenae Amalecitae ego sum '."
,"14":"Et ait ad eum David: ' Quare non timuisti mittere manum tuam, ut occideres christum Domini? '."
,"15":"Vocansque David unum de pueris ait: ' Accedens irrue in eum '. Qui percussit illum, et mortuus est."
,"16":"Et ait ad eum David: ' Sanguis tuus super caput tuum; os enim tuum locutum est adversum te dicens: 'Ego interfeci christum Domini' '."
,"17":"Planxit autem David planctum huiuscemodi super Saul et super Ionathan filium eius;"
,"18":"et praecepit, ut docerent filios Iudae canticum Arcus, sicut scriptum est in libro Iusti, et ait:"
,"19":"' Incliti, o Israel, super montes tuos interfecti, quomodo ceciderunt fortes!"
,"20":"Nolite annuntiare in Geth,neque annuntietis in compitis Ascalonis, ne forte laetentur filiae Philisthim, ne exsultent filiae incircumcisorum."
,"21":"Montes Gelboe, nec ros nec pluviae veniant super vos, neque sint agri oblationum!,Quia ibi abiectus est clipeus fortium, clipeus Saul, quasi non esset unctus oleo."
,"22":"A sanguine interfectorum, ab adipe fortium,arcus Ionathan numquam rediit retrorsum, et gladius Saul non est reversus inanis."
,"23":"Saul et Ionathan amabiles et decori in vita sua, in morte quoque non sunt divisi, aquilis velociores, leonibus fortiores. "
,"24":"Filiae Israel, super Saul flete, qui vestiebat vos coccino in deliciis, qui praebebat ornamenta aurea cultui vestro."
,"25":"Quomodo ceciderunt fortes in proelio!,Ionathan in excelsis tuis occisus est. "
,"26":"Doleo super te, frater mi Ionathan, suavis nimis mihi; mirabilis amor tuus mihi,super amorem mulierum."
,"27":"Quomodo ceciderunt fortes, et perierunt arma bellica! '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Igitur post haec consuluit David Dominum dicens: ' Num ascendam in unam de civitatibus Iudae? '. Et ait Dominus ad eum: ' Ascende '. Dixitque David: ' Quo ascendam? '. Et respondit ei: ' In Hebron '."
,"2":"Ascendit ergo David et duae uxores eius, Achinoam Iezrahelites et Abigail uxor Nabal de Carmel;"
,"3":"sed et viros, qui erant cum eo, duxit David singulos cum domo sua, et manserunt in oppidis Hebron."
,"4":"Veneruntque viri Iudae et unxerunt ibi David, ut regnaret super domum Iudae. Et nuntiatum est David quod viri Iabes Galaad sepelissent Saul. "
,"5":"Misit ergo David nuntios ad viros Iabes Galaad dixitque ad eos: ' Benedicti vos Domino, qui fecistis misericordiam hanc cum domino vestro Saul et sepelistis eum."
,"6":"Et nunc faciat quidem vobis Dominus misericordiam et veritatem; sed et ego reddam vobis similiter bonum, eo quod feceritis istud."
,"7":"Nunc autem confortentur manus vestrae, et estote fortes; licet enim mortuus sit dominus vester Saul, tamen me unxit domus Iudae in regem sibi '."
,"8":"Abner autem filius Ner princeps exercitus Saul tulit Isbaal filium Saul et duxit eum in Mahanaim"
,"9":"regemque constituit super Galaad et super Aser et super Iezrahel et super Ephraim et super Beniamin et super Israel universum."
,"10":"Quadraginta annorum erat Isbaal filius Saul, cum regnare coepisset super Israel, et duobus annis regnavit; sola autem domus Iudae sequebatur David."
,"11":"Et fuit numerus dierum, quos commoratus est David imperans in Hebron super domum Iudae, septem annorum et sex mensium."
,"12":"Egressusque est Abner filius Ner et pueri Isbaal filii Saul de Mahanaim in Gabaon."
,"13":"Porro Ioab filius Sarviae et pueri David egressi sunt et occurrerunt eis iuxta piscinam Gabaon; et, cum in unum convenissent e regione, constiterunt hi ex una parte piscinae et illi ex altera."
,"14":"Dixitque Abner ad Ioab: ' Surgant pueri et ludant coram nobis '. Et respondit Ioab: ' Surgant '."
,"15":"Surrexerunt ergo et transierunt numero duodecim de Beniamin ex parte Isbaal filii Saul, et duodecim de pueris David."
,"16":"Apprehensoque unusquisque capite comparis sui, defixit gladium in latus contrarii, et ceciderunt simul; vocatumque est nomen loci illius ager Laterum in Gabaon."
,"17":"Et ortum est bellum durum valde in die illa, fugatusque est Abner et viri Israel a pueris David."
,"18":"Erant autem ibi tres filii Sarviae: Ioab et Abisai et Asael. Porro Asael cursor velocissimus fuit quasi unus ex capreis, quae morantur in campis."
,"19":"Persequebatur autem Asael Abner et non declinavit ad dextram sive ad sinistram omittens persequi Abner."
,"20":"Respexit itaque Abner post tergum suum et ait: ' Tune es Asael? '. Qui respondit: ' Ego sum '."
,"21":"Dixitque ei Abner: ' Vade ad dextram sive ad sinistram et apprehende unum de adulescentibus et tolle tibi spolia eius '. Noluit autem Asael omittere quin urgeret eum."
,"22":"Rursumque locutus est Abner ad Asael: ' Recede, noli me sequi, ne compellar confodere te in terram et levare non potero faciem meam ad Ioab fratrem tuum '."
,"23":"Qui audire contempsit et noluit declinare. Percussit ergo eum Abner, aversa hasta in inguine, et exiit hasta retrorsum, et mortuus est ibi. Omnesque qui transibant per locum, in quo ceciderat Asael et mortuus erat, subsistebant."
,"24":"Persequentibus autem Ioab et Abisai fugientem Abner, sol occubuit; et venerunt usque ad collem Amma, qui est ex adverso Gaiah in via deserti in Gabaon."
,"25":"Congregatique sunt filii Beniamin ad Abner et conglobati in unum cuneum steterunt in summitate tumuli unius."
,"26":"Et exclamavit Abner ad Ioab et ait: ' Num usque ad internecionem tuus mucro desaeviet? An ignoras quod periculosa sit desperatio? Usquequo non dicis populo, ut omittat persequi fratres suos? '."
,"27":"Et ait Ioab: ' Vivit Deus, nisi locutus fuisses, usque mane non recessisset populus persequens unusquisque fratrem suum '."
,"28":"Insonuit ergo Ioab bucina, et stetit omnis exercitus; nec persecuti sunt ultra Israel neque certaverunt amplius."
,"29":"Abner autem et viri eius abierunt per Arabam tota nocte illa et transierunt Iordanem et, lustrato toto saltu Bethron, venerunt Mahanaim."
,"30":"Porro Ioab reversus, omisso Abner, congregavit omnem populum; et defuerunt de pueris David decem et novem viri, excepto Asaele;"
,"31":"servi autem David percusserunt de Beniamin et ex viris, qui erant cum Abner, trecentos sexaginta, qui et mortui sunt."
,"32":"Tuleruntque Asael et sepelierunt eum in sepulcro patris sui in Bethlehem. Et ambulaverunt tota nocte Ioab et viri, qui erant cum eo, et in ipso crepusculo pervenerunt in Hebron."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Facta est ergo longa concertatio inter domum Saul et inter do mum David: David semper invalescens, domus autem Saul decrescens cotidie."
,"2":"Nati quoque sunt filii David in Hebron. Fuitque primogenitus eius Amnon de Achinoam Iezrahelitide,"
,"3":"et post eum Cheleab de Abigail uxore Nabal de Carmel, porro tertius Absalom filius Maacha filiae Tholmai regis Gesur,"
,"4":"quartus autem Adonias filius Haggith et quintus Saphatia filius Abital,"
,"5":"sextus quoque Iethraam de Egla uxore David. Hi nati sunt David in Hebron."
,"6":"Cum ergo esset proelium inter domum Saul et domum David, Abner filius Ner regebat domum Saul."
,"7":"Fuerat autem Sauli concubina nomine Respha filia Aia. Dixitque Isbaal ad Abner:"
,"8":"' Quare ingressus es ad concubinam patris mei? '. Qui iratus nimis propter verba Isbaal ait: ' Numquid caput canis ego sum de Iuda? Hodie facio misericordiam super domum Saul patris tui et super fratres et proximos eius et non tradidi te in manu David. Et tu requisisti in me quod argueres pro muliere hodie."
,"9":"Haec faciat Deus Abner et haec addat ei, nisi, quomodo iuravit Dominus David, sic faciam cum eo,"
,"10":"ut transferatur regnum de domo Saul, et confirmetur thronus David super Israel et super Iudam a Dan usque Bersabee '."
,"11":"Et non potuit respondere ei quidquam, quia metuebat illum."
,"12":"Misit ergo Abner nuntios ad David pro se dicentes: ' Cuius est terra? ', et ut loquerentur: ' Fac mecum amicitias, et erit manus mea tecum, et reducam ad te universum Israel '."
,"13":"Qui ait: ' Optime, ego faciam tecum amicitias, sed unam rem peto a te dicens: Non videbis faciem meam, nisi prius adduxeris Michol filiam Saul; et sic venies et videbis me '."
,"14":"Misit autem David nuntios ad Isbaal filium Saul dicens: 'Redde uxorem meam Michol, quam despondi mihi centum praeputiis Philisthim '."
,"15":"Misit ergo Isbaal et tulit eam a viro suo Phaltiel filio Lais."
,"16":"Sequebaturque eam vir suus plorans usque Bahurim; et dixit ad eum Abner: ' Vade, revertere '. Qui reversus est."
,"17":"Sermonem quoque intulit Abner ad seniores Israel dicens: ' Tam heri quam nudiustertius quaerebatis David, ut regnaret super vos;"
,"18":"nunc ergo facite, quoniam Dominus locutus est ad David dicens: 'In manu servi mei David salvabo populum meum Israel de manu Philisthim et omnium inimicorum eius' '."
,"19":"Locutus est autem Abner etiam ad Beniamin; et abiit, ut loqueretur ad David in Hebron omnia, quae placuerant Israel et universo Beniamin."
,"20":"Venitque ad David in Hebron cum viginti viris, et fecit David Abner et viris eius, qui venerant cum eo, convivium."
,"21":"Et dixit Abner ad David: ' Surgam, ut congregem ad te dominum meum regem omnem Israel, et ineant tecum foedus, et imperes omnibus, sicut desiderat anima tua '. Cum ergo deduxisset David Abner, et ille isset in pace, "
,"22":"pueri David et Ioab venerunt ab expeditione cum praeda magna. Abner autem non erat cum David in Hebron, quia iam dimiserat eum, et profectus fuerat in pace,"
,"23":"et Ioab et omnis exercitus, qui erat cum eo, postea venerant. Nuntiatum est itaque Ioab a narrantibus: ' Venit Abner filius Ner ad regem, et dimisit eum, et abiit in pace '."
,"24":"Et ingressus est Ioab ad regem et ait: ' Quid fecisti? Ecce venit Abner ad te; quare dimisisti eum, et abiit et recessit?"
,"25":"Ignoras Abner filium Ner? Certe ad hoc venit, ut deciperet te et sciret exitum tuum et introitum tuum et nosset omnia quae agis '."
,"26":"Egressus itaque Ioab a David misit nuntios post Abner, et reduxerunt eum a cisterna Sira, ignorante David."
,"27":"Cumque redisset Abner in Hebron, seorsum abduxit eum Ioab ad medium portae, ut loqueretur ei quiete, et percussit illum ibi in inguine, et mortuus est in ultionem sanguinis Asael fratris eius."
,"28":"Quod cum audisset David rem iam gestam, ait: ' Mundus ego sum et regnum meum apud Dominum usque in sempiternum a sanguine Abner filii Ner;"
,"29":"et veniat super caput Ioab et super omnem domum patris eius, nec deficiat de domo Ioab fluxum morbidum sustinens, leprosus et tenens fusum et cadens gladio et indigens pane '."
,"30":"Igitur Ioab et Abisai frater eius interfecerunt Abner, eo quod occidisset Asael fratrem eorum in Gabaon in proelio."
,"31":"Dixit autem David ad Ioab et ad omnem populum, qui erat cum eo: ' Scindite vestimenta vestra et accingimini saccis et plangite ante exequias Abner '. Porro rex David sequebatur feretrum."
,"32":"Cumque sepelissent Abner in Hebron, levavit rex David vocem suam et flevit super tumulum Abner; flevit autem et omnis populus."
,"33":"Plangensque rex et lugens Abner ait: ' Numquid, ut mori solent insensati, mori debuit Abner?"
,"34":"Manus tuae ligatae non erant, et pedes tui non erant compedibus aggravati; sed, sicut solent cadere coram filiis iniquitatis, corruisti '. Congeminansque omnis populus flevit super eum. "
,"35":"Cumque venisset universa multitudo reficere David pane clara adhuc die, iuravit David dicens: ' Haec faciat mihi Deus et haec addat, si ante occasum solis gustavero panem vel aliud quidquam '."
,"36":"Omnisque populus audivit; et placuit eis, sicut cuncta, quae fecit rex, bona erant in conspectu totius populi."
,"37":"Et cognovit omne vulgus et universus Israel in die illa quoniam non actum fuisset a rege, ut occideretur Abner filius Ner."
,"38":"Dixit quoque rex ad servos suos: ' Num ignoratis quoniam princeps et maximus cecidit hodie in Israel?"
,"39":"Ego vero adhuc debilis sum, quamvis sim unctus rex; viri autem isti filii Sarviae duriores sunt quam ego. Retribuat Dominus facienti malum iuxta malitiam suam '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Audivit autem Isbaal filius Saul quod cecidisset Abner in He bron, et dissolutae sunt manus eius, omnisque Israel perturbatus est."
,"2":"Duo autem viri duces turmarum erant filio Saul, nomen uni Baana et nomen alteri Rechab filii Remmon Berothitae de filiis Beniamin; siquidem et Beroth reputata est in Beniamin."
,"3":"Fugerant enim Berothitae in Getthaim, factique sunt ibi advenae usque in tempus hoc."
,"4":"Erat autem Ionathan filio Saul filius debilis pedibus. Quinquennis enim fuit, quando venit nuntius de Saul et Ionathan ex Iezrahel. Tollens itaque eum nutrix sua fugit; cumque festinaret, ut fugeret, cecidit et claudus effectus est habuitque vocabulum Meribbaal."
,"5":"Venientes igitur filii Remmon Berothitae, Rechab et Baana, ingressi sunt, fervente die, domum Isbaal, qui dormiebat super stratum suum meridie; et ostiaria domus purgans triticum obdormivit."
,"6":"Ingressi sunt ergo usque interiora domus et percusserunt eum in inguine Rechab et Baana frater eius et fugerunt."
,"7":"Cum autem ingressi fuissent domum, ille dormiebat super lectum suum in conclavi, et percutientes interfecerunt eum; sublatoque capite eius, abierunt per viam Arabae tota nocte."
,"8":"Et attulerunt caput Isbaal ad David in Hebron dixeruntque ad regem: ' Ecce caput Isbaal filii Saul inimici tui, qui quaerebat animam tuam; et dedit Dominus domino meo regi ultiones hodie de Saul et de semine eius '."
,"9":"Respondens autem David Rechab et Baana fratri eius filiis Remmon Berothitae dixit ad eos: ' Vivit Dominus, qui eruit animam meam de omni angustia,"
,"10":"quoniam eum, qui annuntiaverat mihi et dixerat: 'Mortuus est Saul', qui putabat se prospera nuntiare, tenui et occidi in Siceleg, cui oportebat me dare mercedem pro nuntio;"
,"11":"quanto magis nunc, cum homines impii interfecerunt virum innoxium in domo sua super lectum suum, non quaeram sanguinem eius de manu vestra et auferam vos de terra? '."
,"12":"Praecepit itaque David pueris, et interfecerunt eos; praecidentesque manus et pedes eorum suspenderunt eos super piscinam in Hebron. Caput autem Isbaal tulerunt et sepelierunt in sepulcro Abner in Hebron."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et venerunt universae tribus Is rael ad David in Hebron dicen tes: ' Ecce nos os tuum et caro tua sumus."
,"2":"Sed et heri et nudiustertius, cum esset Saul rex super nos, tu eras educens et reducens Israel. Dixit autem Dominus ad te: 'Tu pasces populum meum Israel et tu eris dux super Israel' '."
,"3":"Venerunt quoque omnes senes Israel ad regem in Hebron, et percussit cum eis rex David foedus in Hebron coram Domino; unxeruntque David in regem super Israel."
,"4":"Triginta annorum erat David, cum regnare coepisset, et quadraginta annis regnavit:"
,"5":"in Hebron regnavit super Iudam septem annis et sex mensibus; in Ierusalem autem regnavit triginta tribus annis super omnem Israel et Iudam."
,"6":"Et abiit rex et omnes viri, qui erant cum eo, in Ierusalem ad Iebusaeum habitatorem terrae. Qui dixit ad David: 'Non ingredieris huc, sed depellent te caeci et claudi ', significantes: ' Non ingredietur David huc '."
,"7":"Cepit autem David arcem Sion: haec est civitas David."
,"8":"Dixerat enim David in die illa: ' Omnis, qui percutiet Iebusaeum, attingat per cuniculum fontis claudos et caecos exosos animae David '. Idcirco dicitur in proverbio: ' Caecus et claudus non intrabunt in domum '."
,"9":"Habitavit autem David in arce et vocavit eam Civitatem David; et aedificavit per gyrum a Mello et intrinsecus."
,"10":"Et ibat proficiens atque succrescens, et Dominus, Deus exercituum, erat cum eo."
,"11":"Misit quoque Hiram rex Tyri nuntios ad David et ligna cedrina et artifices lignorum artificesque lapidum pro parietibus; et aedificaverunt domum David."
,"12":"Et cognovit David quoniam confirmasset eum Dominus regem super Israel et quoniam exaltasset regnum eius super populum suum Israel."
,"13":"Accepitque David adhuc concubinas et uxores de Ierusalem, postquam venerat de Hebron; natique sunt David et alii filii et filiae."
,"14":"Et haec nomina eorum, qui nati sunt ei in Ierusalem: Samua et Sobab et Nathan et Salomon"
,"15":"et Iebahar et Elisua et Napheg"
,"16":"et Iaphia et Elisama et Eliada et Eliphalet."
,"17":"Audierunt vero Philisthim quod unxissent David regem super Israel et ascenderunt universi, ut quaererent David. Quod cum audisset David, descendit in praesidium;"
,"18":"Philisthim autem venientes diffusi sunt in valle Raphaim."
,"19":"Et consuluit David Dominum dicens: ' Si ascendam ad Philisthim? Et si dabis eos in manu mea? '. Et dixit Dominus ad David: 'Ascende, quia tradens dabo Philisthim in manu tua '."
,"20":"Venit ergo David in Baalpharasim (id est Dominus diruptionum); et percussit eos ibi et dixit: 'Divisit Dominus inimicos meos coram me, sicut dividuntur aquae '. Propterea vocatum est nomen loci illius Baalpharasim."
,"21":"Et reliquerunt ibi sculptilia sua, quae tulit David et viri eius."
,"22":"Et addiderunt adhuc Philisthim ut ascenderent et diffusi sunt in valle Raphaim."
,"23":"Consuluit autem David Dominum, qui respondit: ' Non ascendas, sed gyra post tergum eorum et venies ad eos ex adverso arborum celthium"
,"24":"et, cum audieris sonitum gradientis in cacumine arborum celthium, tunc inibis proelium, quia tunc egredietur Dominus ante faciem tuam, ut percutiat castra Philisthim '."
,"25":"Fecit itaque David, sicut praeceperat ei Dominus; et percussit Philisthim de Gabaon usque dum venias Gazer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Congregavit autem rursum Da vid omnes electos ex Israel tri ginta milia."
,"2":"Surrexitque David et abiit, et universus populus, qui erat cum eo, in Baala Iudae, ut adducerent inde arcam Dei, super quam invocatum est nomen Domini exercituum sedentis in cherubim super eam."
,"3":"Et imposuerunt arcam Dei super plaustrum novum tuleruntque eam de domo Abinadab, qui erat in colle. Oza autem et Ahio filii Abinadab minabant plaustrum:"
,"4":"Oza ambulabat iuxta arcam, et Ahio praecedebat eam."
,"5":"David autem et omnis Israel ludebant coram Domino omni virtute in canticis et citharis et lyris et tympanis et sistris et cymbalis."
,"6":"Postquam autem venerunt ad aream Nachon, extendit manum Oza ad arcam Dei et tenuit eam, quoniam boves lascivientes proruperunt."
,"7":"Iratusque est indignatione Dominus contra Ozam et percussit eum super temeritate; qui mortuus est ibi iuxta arcam Dei."
,"8":"Contristatus autem est David, eo quod diruptionem dirupisset Dominus in Ozam; et vocatum est nomen loci illius Pharesoza (id est Diruptio Ozae) usque in diem hanc."
,"9":"Et extimuit David Dominum in die illa dicens: ' Quomodo ingredietur ad me arca Domini? '."
,"10":"Et noluit divertere ad se arcam Domini in civitate David, sed divertit eam in domum Obededom Getthaei."
,"11":"Et habitavit arca Domini in domo Obededom Getthaei tribus mensibus, et benedixit Dominus Obededom et omnem domum eius."
,"12":"Nuntiatumque est regi David: ' Benedixit Dominus Obededom et omnia eius propter arcam Dei '. Abiit ergo David et adduxit arcam Dei de domo Obededom in civitatem David cum gaudio."
,"13":"Cumque progressi essent, qui portabant arcam Domini, sex passus, immolavit bovem et vitulum saginatum,"
,"14":"et David saltabat totis viribus ante Dominum. Porro David erat accinctus ephod lineo."
,"15":"Et David et omnis domus Israel ducebant arcam Domini in iubilo et in clangore bucinae."
,"16":"Cumque intrasset arca Domini in civitatem David, Michol filia Saul prospiciens per fenestram vidit regem David subsilientem atque saltantem coram Domino et despexit eum in corde suo."
,"17":"Et introduxerunt arcam Domini et posuerunt eam in loco suo in medio tabernaculi, quod tetenderat ei David; et obtulit David coram Domino holocausta et pacifica."
,"18":"Cumque complesset offerens holocaustum et pacifica, benedixit populo in nomine Domini exercituum."
,"19":"Et partitus est multitudini universae Israel tam viro quam mulieri singulis collyridam panis unam et laganum palmarum unum et palatham unam. Et abiit omnis populus unusquisque in domum suam."
,"20":"Reversusque est et David, ut benediceret domui suae, et egressa Michol filia Saul in occursum David ait: ' Quam gloriosus fuit hodie rex Israel discooperiens se ante ancillas servorum suorum, quasi si nudetur unus de scurris! '."
,"21":"Dixitque David ad Michol: ' Ante Dominum salto. Benedictus Dominus, qui elegit me potius quam patrem tuum et quam omnem domum eius, ut constitueret me ducem super populum Domini, super Israel!"
,"22":"Ludam in conspectu Domini et vilior fiam plus quam factus sum et ero deiectus in oculis meis, sed apud ancillas, de quibus locuta es, gloriosior apparebo '."
,"23":"Igitur Michol filiae Saul non est natus filius usque ad diem mortis suae."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Factum est autem cum sedisset rex in domo sua, et Dominus de disset ei requiem undique ab universis inimicis suis,"
,"2":"dixit ad Nathan prophetam: ' Videsne quod ego habitem in domo cedrina, et arca Dei posita sit in medio pellium? '."
,"3":"Dixitque Nathan ad regem: ' Omne, quod est in corde tuo, vade, fac, quia Dominus tecum est '."
,"4":"Factum est autem in nocte illa, et ecce sermo Domini ad Nathan dicens:"
,"5":"' Vade et loquere ad servum meum David: Haec dicit Dominus: Numquid tu aedificabis mihi domum ad habitandum?"
,"6":"Numquam enim habitavi in domo ex die, qua eduxi filios Israel de terra Aegypti, usque in diem hanc, sed ambulabam in tabernaculo et in tentorio."
,"7":"Per cuncta loca, quae transivi cum omnibus filiis Israel, numquid loquens locutus sum ad unum de iudicibus Israel, cui praecepi, ut pasceret populum meum Israel, dicens: Quare non aedificastis mihi domum cedrinam?"
,"8":"Et nunc haec dices servo meo David: Haec dicit Dominus exercituum: Ego tuli te de pascuis sequentem greges, ut esses dux super populum meum Israel,"
,"9":"et fui tecum in omnibus, ubicumque ambulasti, et interfeci universos inimicos tuos a facie tua; fecique tibi nomen grande iuxta nomen magnorum, qui sunt in terra."
,"10":"Et ponam locum populo meo Israel et plantabo eum, et habitabit in eo et non turbabitur amplius; nec addent filii iniquitatis ut affligant eum sicut prius"
,"11":"et ex die, qua constitui iudices super populum meum Israel, et requiem dabo tibi ab omnibus inimicis tuis. Praedicitque tibi Dominus quod domum faciat tibi Dominus."
,"12":"Cumque completi fuerint dies tui, et dormieris cum patribus tuis, suscitabo semen tuum post te, quod egredietur de visceribus tuis; et firmabo regnum eius."
,"13":"Ipse aedificabit domum nomini meo, et stabiliam thronum regni eius usque in sempiternum."
,"14":"Ego ero ei in patrem, et ipse erit mihi in filium; qui si inique aliquid gesserit, arguam eum in virga virorum et in plagis filiorum hominum."
,"15":"Misericordiam autem meam non auferam ab eo, sicut abstuli a Saul, quem amovi a facie tua;"
,"16":"et stabilis erit domus tua et regnum tuum usque in aeternum ante faciem meam, et thronus tuus erit firmus iugiter '."
,"17":"Secundum omnia verba haec et iuxta universam visionem istam sic locutus est Nathan ad David."
,"18":"Ingressus est autem rex David et sedit coram Domino et dixit: ' Quis ego sum, Domine Deus, et quae domus mea, quia adduxisti me hucusque?"
,"19":"Sed et hoc parum visum est in conspectu tuo, Domine Deus, et locutus es etiam de domo servi tui in longinquum, et ista est lex hominis, Domine Deus!"
,"20":"Quid ergo addere poterit adhuc David, ut loquatur ad te? Tu enim scis servum tuum, Domine Deus."
,"21":"Propter verbum tuum et secundum cor tuum fecisti omnia magnalia haec, ita ut nota faceres servo tuo."
,"22":"Idcirco magnus es, Domine Deus, quia non est similis tui; neque est Deus extra te, iuxta omnia, quae audivimus auribus nostris."
,"23":"Quae est autem ut populus tuus Israel una gens in terra, propter quam ivit Deus, ut redimeret eam sibi in populum et poneret sibi nomen faceretque eis magnalia et horribilia, ut eiceres a facie populi tui, quem redemisti tibi ex Aegypto, gentes et deos eorum?"
,"24":"Et firmasti tibi populum tuum Israel in populum sempiternum; et tu, Domine, factus es eis in Deum."
,"25":"Nunc ergo, Domine Deus, verbum, quod locutus es super servum tuum et super domum eius, confirma in sempiternum et fac, sicut locutus es!"
,"26":"Et magnificetur nomen tuum usque in sempiternum, atque dicatur: 'Dominus exercituum est Deus super Israel'. Et domus servi tui David erit stabilita coram te,"
,"27":"quia tu, Domine exercituum, Deus Israel, revelasti aurem servi tui dicens: 'Domum aedificabo tibi'. Propterea invenit servus tuus cor suum, ut oraret te oratione hac."
,"28":"Nunc ergo, Domine Deus, tu es Deus, et verba tua erunt vera; cum ergo locutus sis ad servum tuum bona haec,"
,"29":"dignare igitur benedicere domui servi tui, ut sit in sempiternum coram te, quia tu, Domine Deus, locutus es, et benedictione tua benedicetur domus servi tui in sempiternum '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Factum est autem post haec, percussit David Philisthim et humiliavit eos; et tulit David Geth et urbes eius de manu Philisthim."
,"2":"Et percussit Moab et mensus est eos funiculo sternens eos in terra; mensus est autem duos funiculos ad occidendum et unum funiculum plenum ad vivificandum; factusque est Moab David serviens sub tributo."
,"3":"Et percussit David Adadezer filium Rohob regem Soba, quando profectus est, ut dominaretur super flumen Euphraten."
,"4":"Et captis David ex parte eius mille septingentis equitibus et viginti milibus peditum, subnervavit omnes iugales curruum; dereliquit autem ex eis centum currus."
,"5":"Venit quoque Syria Damasci, ut praesidium ferret Adadezer regi Soba, et percussit David de Syria viginti duo milia virorum;"
,"6":"et posuit David praesidium in Syria Damasci; factaque est Syria David serviens sub tributo. Et auxiliatus est Dominus David in omnibus, ad quaecumque profectus est."
,"7":"Et tulit David arma aurea, quae habebant servi Adadezer, et detulit ea in Ierusalem;"
,"8":"et de Tebah et de Berothai civitatibus Adadezer tulit rex David aes multum nimis."
,"9":"Audivit autem Thou rex Emath quod percussisset David omne robur Adadezer"
,"10":"et misit Thou Adoram filium suum ad regem David, ut salutaret eum congratulans et gratias ageret eo quod pugnasset cum Adadezer et percussisset eum; hostis quippe erat Thou Adadezer. Attulit autem Adoram et vasa argentea et vasa aurea et vasa aerea,"
,"11":"quae et ipsa sanctificavit rex David Domino cum argento et auro, quae sanctificaverat de universis gentibus, quas subegerat:"
,"12":"de Syria et Moab et filiis Ammon et Philisthim et Amalec et de manibus Adadezer filii Rohob regis Soba."
,"13":"Fecit quoque sibi David nomen cum reverteretur, percussa Idumaea in valle Salis, caesis decem et octo milibus."
,"14":"Et posuit in Idumaea praesidia; et facta est universa Idumaea serviens David. Et auxiliatus est Dominus David in omnibus, ad quaecumque profectus est."
,"15":"Et regnavit David super omnem Israel; faciebat quoque David iudicium et iustitiam omni populo suo."
,"16":"Ioab autem filius Sarviae erat super exercitum; porro Iosaphat filius Ahilud erat a commentariis,"
,"17":"et Sadoc filius Achitob et Abiathar filius Achimelech sacerdotes, et Saraias scriba."
,"18":"Banaias autem filius Ioiadae super Cherethi et Phelethi; filii autem David sacerdotes erant."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et dixit David: ' Putasne est aliquis, qui remanserit adhuc de domo Saul, ut faciam cum eo misericordiam propter Ionathan? '."
,"2":"Erat autem de domo Saul servus nomine Siba; quem cum vocasset rex ad se, dixit ei: ' Tune es Siba? '. Et ille respondit: ' Ego sum, servus tuus '."
,"3":"Et ait rex: ' Num superest aliquis de domo Saul, ut faciam cum eo misericordiam Dei? '. Dixitque Siba regi: ' Superest filius Ionathan, debilis pedibus '."
,"4":"' Ubi, inquit, est? '. Et Siba ad regem: ' Ecce, ait, in domo est Machir filii Ammiel in Lodabar '."
,"5":"Misit ergo rex David et tulit eum de domo Machir filii Ammiel de Lodabar."
,"6":"Cum autem venisset Meribbaal filius Ionathan filii Saul ad David, corruit in faciem suam et adoravit. Dixitque David: ' Meribbaal '. Qui respondit: ' Adsum servus tuus '."
,"7":"Et ait ei David: 'Ne timeas, quia faciens faciam in te misericordiam propter Ionathan patrem tuum; et restituam tibi omnes agros Saul patris tui, et tu comedes panem in mensa mea semper '."
,"8":"Qui adorans eum dixit: ' Quis ego sum servus tuus, quoniam respexisti super canem mortuum similem mei? '."
,"9":"Vocavit itaque rex Sibam puerum Saul et dixit ei: ' Omnia, quaecumque fuerunt Saul et universae domui eius, do filio domini tui."
,"10":"Operare igitur ei terram, tu et filii tui et servi tui, et, quod inferes, sit cibus domui domini tui, quo alantur; Meribbaal autem filius domini tui comedet semper panem super mensam meam '. Erant autem Sibae quindecim filii et viginti servi."
,"11":"Dixitque Siba ad regem: ' Sicut iussisti, domine mi rex, servo tuo, sic faciet servus tuus '. Meribbaal autem comedebat super mensam eius quasi unus de filiis regis."
,"12":"Habebat autem Meribbaal filium parvulum nomine Micha; omnes vero, qui habitabant in domo Sibae, serviebant Meribbaal."
,"13":"Porro Meribbaal habitabat in Ierusalem, quia de mensa regis iugiter vescebatur; et erat claudus utroque pede."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Factum est autem post haec, ut moreretur rex filiorum Ammon, et regnaret Hanon filius eius pro eo."
,"2":"Dixitque David: ' Faciam misericordiam cum Hanon filio Naas, sicut fecit pater eius mecum misericordiam '. Misit ergo David consolans eum per servos suos super patris interitu. Cum autem venissent servi David in terram filiorum Ammon,"
,"3":"dixerunt principes filiorum Ammon ad Hanon dominum suum: ' Putas quod propter honorem patris tui David miserit ad te consolatores; et non ideo, ut investigaret et exploraret civitatem et everteret eam, misit David servos suos ad te? '."
,"4":"Tulit itaque Hanon servos David rasitque dimidiam partem barbae eorum et praecidit vestes eorum medias usque ad nates et dimisit eos."
,"5":"Quod cum nuntiatum esset David, misit in occursum eorum - erant enim viri confusi turpiter valde - et mandavit eis David: ' Manete Iericho, donec crescat barba vestra, et tunc revertimini '."
,"6":"Videntes autem filii Ammon quod exosos se fecissent David, miserunt et conduxerunt mercede a Syria Bethrohob et a Syria Soba viginti milia peditum et a rege Maacha mille viros et a viris Tob duodecim milia virorum."
,"7":"Quod cum audisset David, misit Ioab et omnem exercitum, viros fortissimos."
,"8":"Egressi sunt ergo filii Ammon et direxerunt aciem ante ipsum introitum portae; Syri autem Soba et Rohob et viri Tob et Maacha seorsum erant in campo."
,"9":"Videns igitur Ioab quod praeparatum esset adversum se proelium et ex adverso et post tergum, elegit ex omnibus electis Israel et instruxit aciem contra Syros;"
,"10":"reliquam autem partem populi tradidit Abisai fratri suo, qui direxit aciem adversus filios Ammon."
,"11":"Et ait Ioab: ' Si praevaluerint adversum me Syri, eris mihi in adiutorium; si autem filii Ammon praevaluerint adversum te, auxiliabor tibi."
,"12":"Esto vir fortis, et fortiter agamus pro populo nostro et civitatibus Dei nostri; Dominus autem faciet, quod bonum est in conspectu suo '."
,"13":"Iniit itaque Ioab et populus, qui erat cum eo, certamen contra Syros, qui fugerunt a facie eius."
,"14":"Filii autem Ammon videntes quod fugissent Syri, fugerunt et ipsi a facie Abisai et ingressi sunt civitatem. Reversusque est Ioab a filiis Ammon et venit Ierusalem."
,"15":"Videntes igitur Syri quoniam corruissent coram Israel, congregati sunt pariter."
,"16":"Misitque Adadezer et eduxit Syros, qui erant trans fluvium, et venerunt in Elam; Sobach autem magister militiae Adadezer erat princeps eorum."
,"17":"Quod cum nuntiatum esset David, contraxit omnem Israelem et transivit Iordanem venitque in Elam. Et direxerunt aciem Syri ex adverso David et pugnaverunt contra eum."
,"18":"Fugeruntque Syri a facie Israel; et occidit David de Syris septingentos currus et quadraginta milia peditum et Sobach principem militiae percussit, qui ibi mortuus est."
,"19":"Videntes autem universi reges, qui erant in praesidio Adadezer, se victos esse ab Israel, fecerunt pacem cum Israel et servierunt eis. Timueruntque Syri auxilium praebere ultra filiis Ammon."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Factum est autem vertente anno, eo tempore quo solent reges ad bella procedere, misit David Ioab et servos suos cum eo et universum Israel, et vastaverunt filios Ammon et obsederunt Rabba; David autem remansit in Ierusalem."
,"2":"Et factum est vespere, ut surgeret David de strato suo et deambularet in solario domus regiae. Viditque de solario mulierem se lavantem; erat autem mulier pulchra valde."
,"3":"Misit ergo rex et requisivit quae esset mulier; nuntiatumque ei est quod ipsa esset Bethsabee filia Eliam uxor Uriae Hetthaei."
,"4":"Missis itaque David nuntiis, tulit eam; quae cum ingressa esset ad illum, dormivit cum ea, quae se sanctificaverat ab immunditia sua."
,"5":"Et reversa est domum suam; cum autem concepisset, mittens nuntiavit David et ait: ' Concepi '."
,"6":"Misit autem David ad Ioab dicens: ' Mitte ad me Uriam Hetthaeum '. Misitque Ioab Uriam ad David,"
,"7":"et venit Urias ad David. Quaesivitque David quam recte ageret Ioab et populus, et quomodo administraretur bellum;"
,"8":"et dixit David ad Uriam: ' Descende in domum tuam et lava pedes tuos '. Et egressus est Urias de domo regis; secutusque est eum cibus regius."
,"9":"Dormivit autem Urias ante portam domus regiae cum aliis servis domini sui et non descendit ad domum suam."
,"10":"Nuntiatumque est David a dicentibus: ' Non ivit Urias ad domum suam '. Et ait David ad Uriam: ' Numquid non de via venisti? Quare non descendisti ad domum tuam? '."
,"11":"Et ait Urias ad David: ' Arca et Israel et Iuda habitant in papilionibus, et dominus meus Ioab et servi domini mei super faciem terrae manent; et ego ingrediar domum meam, ut comedam et bibam et dormiam cum uxore mea? Per salutem tuam et per salutem animae tuae, non faciam rem hanc! '."
,"12":"Ait ergo David ad Uriam: ' Mane hic etiam hodie, et cras dimittam te '. Mansit Urias in Ierusalem die illa et altera."
,"13":"Vocavit enim eum David, ut comederet coram se et biberet, et inebriavit eum. Qui egressus vespere dormivit in strato suo cum servis domini sui et in domum suam non descendit."
,"14":"Factum est ergo mane, et scripsit David epistulam ad Ioab misitque per manum Uriae"
,"15":"scribens in epistula: ' Ponite Uriam in prima acie, ubi fortissimum est proelium, et recedite ab eo, ut percussus intereat '."
,"16":"Igitur cum Ioab obsideret urbem, posuit Uriam in loco, quo sciebat viros esse fortissimos."
,"17":"Egressique viri de civitate bellabant adversum Ioab; et ceciderunt de populo, de servis David, et mortuus est etiam Urias Hetthaeus."
,"18":"Misit itaque Ioab et nuntiavit David omnia de proelio;"
,"19":"praecepitque nuntio dicens: ' Cum compleveris universos sermones proelii ad regem,"
,"20":"si eum videris indignari et dixerit: 'Quare accessistis ad urbem, ut proeliaremini? An ignorabatis quod desuper ex muro tela mittantur?"
,"21":"Quis percussit Abimelech filium Ierobbaal? Nonne mulier misit super eum molam versatilem de muro, et mortuus est in Thebes? Quare iuxta murum accessistis?', dices: Etiam servus tuus Urias Hetthaeus occubuit '."
,"22":"Abiit ergo nuntius et venit et narravit David omnia, quae ei praeceperat Ioab."
,"23":"Et dixit nuntius ad David: ' Quia praevaluerunt adversum nos viri et egressi sunt ad nos in agrum, nos, facto impetu, persecuti eos sumus usque ad portam civitatis."
,"24":"Et direxerunt iacula sagittarii ad servos tuos ex muro desuper; mortuique sunt de servis regis, quin etiam servus tuus Urias Hetthaeus mortuus est '."
,"25":"Et dixit David ad nuntium: ' Haec dices Ioab: Non te affligat ista res; varius enim eventus est belli, et nunc hunc, nunc illum consumit gladius; corrobora proelium tuum adversus urbem, ut destruas eam. Et tu conforta eum '."
,"26":"Audivit autem uxor Uriae quod mortuus esset Urias vir suus et planxit eum."
,"27":"Transactoque luctu, misit David et introduxit eam domum suam, et facta est ei uxor peperitque ei filium. Et displicuit, quod fecerat David, coram Domino."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Misit ergo Dominus Nathan ad David. Qui cum venisset ad eum, dixit ei: ' Duo viri erant in civitate una, unus dives et alter pauper."
,"2":"Dives habebat oves et boves plurimos valde."
,"3":"Pauper autem nihil habebat omnino praeter ovem unam parvulam, quam emerat et nutrierat, et quae creverat apud eum cum filiis eius simul de pane illius comedens et de calice eius bibens et in sinu illius dormiens; eratque illi sicut filia."
,"4":"Cum autem peregrinus quidam venisset ad divitem, parcens ille sumere de ovibus et de bobus suis, ut exhiberet convivium peregrino illi, qui venerat ad se, tulit ovem viri pauperis et praeparavit cibos homini, qui venerat ad se '."
,"5":"Iratus autem indignatione David adversus hominem illum nimis dixit ad Nathan: ' Vivit Dominus, quoniam filius mortis est vir, qui fecit hoc;"
,"6":"ovem reddet in quadruplum, eo quod fecerit istud et non pepercerit '."
,"7":"Dixit autem Nathan ad David: ' Tu es ille vir! Haec dicit Dominus, Deus Israel: Ego unxi te in regem super Israel et ego erui te de manu Saul;"
,"8":"et dedi tibi domum domini tui et uxores domini tui in sinu tuo dedique tibi domum Israel et Iudae et, si parva sunt ista, adiciam tibi multo maiora."
,"9":"Quare ergo contempsisti verbum Domini, ut faceres malum in conspectu eius? Uriam Hetthaeum percussisti gladio et uxorem illius accepisti uxorem tibi et interfecisti eum gladio filiorum Ammon."
,"10":"Quam ob rem non recedet gladius de domo tua usque in sempiternum, eo quod despexeris me et tuleris uxorem Uriae Hetthaei, ut esset uxor tua."
,"11":"Itaque haec dicit Dominus: Ecce ego suscitabo super te malum de domo tua et tollam uxores tuas in oculis tuis et dabo proximo tuo, et dormiet cum uxoribus tuis in oculis solis huius."
,"12":"Tu enim fecisti abscondite; ego vero faciam istud in conspectu omnis Israel et in conspectu solis '."
,"13":"Et dixit David ad Nathan: ' Peccavi Domino '. Dixitque Nathan ad David: ' Dominus quoque transtulit peccatum tuum; non morieris."
,"14":"Verumtamen quoniam blasphemare fecisti inimicos Domini propter hoc, filius, qui natus est tibi, morte morietur '."
,"15":"Et reversus est Nathan domum suam. Percussitque Dominus parvulum, quem peperat uxor Uriae David, et graviter aegrotavit; "
,"16":"deprecatusque est David Dominum pro parvulo et ieiunavit David ieiunio et ingressus domum pernoctabat iacens super terram."
,"17":"Steterunt autem seniores domus eius iuxta eum cogentes eum, ut surgeret de terra; qui noluit neque comedit cum eis cibum."
,"18":"Accidit autem die septima, ut moreretur infans. Timueruntque servi David nuntiare ei quod mortuus esset parvulus; dixerunt enim: ' Ecce, cum parvulus adhuc viveret, loquebamur ad eum, et non audiebat vocem nostram. Nunc quomodo dicemus: 'Mortuus est puer'? Peius patrabit! '."
,"19":"Cum ergo vidisset David servos suos mussitantes, intellexit quod mortuus esset infantulus dixitque ad servos suos: ' Num mortuus est puer? '. Qui responderunt ei: ' Mortuus est '."
,"20":"Surrexit igitur David de terra et lotus unctusque est; cumque mutasset vestem, ingressus est domum Domini et adoravit et venit in domum suam petivitque, ut ponerent ei panem, et comedit."
,"21":"Dixerunt autem ei servi sui: ' Quid est quod fecisti? Propter infantem, cum adhuc viveret, ieiunasti et flebas; mortuo autem puero, surrexisti et comedisti panem '."
,"22":"Qui ait: ' Propter infantem, dum adhuc viveret, ieiunavi et flevi. Dicebam enim: Quis scit, si forte miserebitur mei Dominus, et vivet infans?"
,"23":"Nunc autem, quia mortuus est, quare ieiuno? Numquid potero revocare eum amplius? Ego vadam magis ad eum, ille vero non revertetur ad me '."
,"24":"Et consolatus est David Bethsabee uxorem suam ingressusque ad eam dormivit cum ea, quae genuit filium; et vocavit nomen eius Salomon. Et Dominus dilexit eum"
,"25":"misitque in manu Nathan prophetae et vocavit nomen eius Iedidia (id est Amabilis Domino) propter Dominum."
,"26":"Igitur pugnavit Ioab contra Rabba filiorum Ammon et expugnavit urbem regiam."
,"27":"Misitque Ioab nuntios ad David dicens: ' Dimicavi adversum Rabba et cepi urbem aquarum;"
,"28":"nunc igitur congrega reliquam partem populi et obside civitatem et cape eam, ne, cum a me capta fuerit urbs, nomine meo vocetur '."
,"29":"Congregavit itaque David omnem populum et profectus est adversum Rabba; cumque dimicasset, cepit eam."
,"30":"Et tulit diadema Melchom de capite eius, pondo auri talentum, habens gemmam pretiosissimam, quod venit super caput David. Sed et praedam civitatis asportavit multam valde,"
,"31":"populum quoque eius educens condemnavit ad operam lapicidinarum et ad secures et dolabras ferreas et transtulit eos ad opus laterum; sic fecit universis civitatibus filiorum Ammon. Et reversus est David et omnis exercitus Ierusalem."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Factum est autem post haec, ut Absalom filii David soro rem speciosissimam, vocabulo Thamar, adamaret Amnon filius David."
,"2":"Et angustiatus est Amnon, ita ut aegrotaret propter amorem Thamar sororis suae, quia, cum esset virgo, difficile ei videbatur ut quippiam inhoneste ageret cum ea."
,"3":"Erat autem Amnonis amicus nomine Ionadab filius Samma fratris David, vir callidus valde."
,"4":"Qui dixit ad eum: ' Quare sic attenuaris macie, fili regis, per singulos dies? Cur non indicas mihi? '. Dixitque ei Amnon: ' Thamar sororem Absalom fratris mei amo '."
,"5":"Cui respondit Ionadab: ' Cuba super lectulum tuum et languorem simula. Cumque venerit pater tuus, ut visitet te, dic ei: 'Veniat, oro, Thamar soror mea, ut det mihi cibum et faciat in oculis meis pulmentum, ut videam et comedam de manu eius' '."
,"6":"Accubuit itaque Amnon et simulavit languorem. Cumque venisset rex ad visitandum eum, ait Amnon ad regem: ' Veniat, obsecro, Thamar soror mea, ut faciat in oculis meis duas sorbitiunculas, et cibum capiam de manu eius '."
,"7":"Misit ergo David ad Thamar domum dicens: ' Veni in domum Amnon fratris tui et fac ei pulmentum '."
,"8":"Venitque Thamar in domum Amnon fratris sui; ille autem iacebat. Quae tollens farinam commiscuit et conficiens in oculis eius coxit sorbitiunculas."
,"9":"Tollensque sartaginem effudit, quod coxerat, et posuit coram eo. Noluit comedere; dixitque Amnon: ' Eicite universos a me '. Cumque exissent omnes,"
,"10":"dixit Amnon ad Thamar: ' Infer cibum in conclave, ut vescar de manu tua '. Tulit ergo Thamar sorbitiunculas, quas fecerat, et intulit ad Amnon fratrem suum in conclave."
,"11":"Cumque obtulisset ei cibum, apprehendit eam et ait: ' Veni, cuba mecum, soror mea '."
,"12":"Quae respondit ei: ' Noli, frater mi, noli opprimere me! Neque enim hoc fas est in Israel; noli facere stultitiam hanc."
,"13":"Et ego quo ibo in opprobrio meo? Et tu eris quasi unus de insipientibus in Israel; quin potius loquere ad regem, et non negabit me tibi '."
,"14":"Noluit autem acquiescere precibus eius, sed praevalens viribus oppressit eam et cubavit cum illa."
,"15":"Et exosam eam habuit Amnon magno odio nimis, ita ut maius esset odium, quo oderat eam, amore, quo ante dilexerat. Dixitque ei Amnon: ' Surge, vade! '."
,"16":"Quae respondit ei: ' Ne fiat, frater mi, quia maius est hoc malum, quod nunc agis adversum me expellens me, quam quod ante fecisti '. Et noluit audire eam;"
,"17":"sed vocato puero, qui ministrabat ei, dixit: ' Eice hanc a me foras et claude ostium post eam '."
,"18":"Quae induta erat talari tunica; huiusmodi enim filiae regis virgines palliis vestibus utebantur. Eiecit itaque eam minister illius foras clausitque fores post eam."
,"19":"Quae aspergens pulverem capiti suo, scissa talari tunica impositisque manibus super caput suum, ibat ingrediens et clamans."
,"20":"Dixit autem ei Absalom frater suus: ' Num Amnon frater tuus fuit tecum? Sed nunc, soror, tace: frater tuus est; neque affligas cor tuum pro re hac '. Mansit itaque Thamar desolata in domo Absalom fratris sui."
,"21":"Cum autem audisset rex David omnia haec, iratus est valde; et noluit contristare spiritum Amnon filii sui, quoniam diligebat eum, quia primogenitus erat ei."
,"22":"Porro non est locutus Absalom ad Amnon nec malum nec bonum; oderat enim Absalom Amnon, eo quod violasset Thamar sororem suam."
,"23":"Factum est autem post tempus biennii, ut tonderentur oves Absalom in Baalhasor, quae est iuxta Ephraim; et vocavit Absalom omnes filios regis."
,"24":"Venitque ad regem et ait ad eum: ' Ecce tondentur oves servi tui; veniat, oro, rex cum servis suis ad servum tuum '."
,"25":"Dixitque rex ad Absalom: ' Noli, fili mi, noli rogare, ut veniamus omnes et gravemus te '. Cum autem cogeret eum, et noluisset ire, benedixit ei."
,"26":"Et ait Absalom: ' Si non vis venire, veniat, obsecro, nobiscum saltem Amnon frater meus '. Dixitque ad eum rex: ' Cur vadet tecum? '."
,"27":"Coegit itaque eum Absalom, et dimisit cum eo Amnon et universos filios regis. Fecitque Absalom convivium quasi convivium regis. "
,"28":"Praecepit autem Absalom pueris suis dicens: ' Observate. Cum hilarior fuerit Amnon vino, et dixero vobis: Percutite Amnon et interficite eum!, nolite timere; ego enim sum, qui praecepi vobis. Roboramini et estote viri fortes '."
,"29":"Fecerunt ergo pueri Absalom adversum Amnon, sicut praeceperat eis Absalom; surgentesque omnes filii regis ascenderunt singuli mulos suos et fugerunt."
,"30":"Cumque adhuc pergerent in itinere, fama praevenit ad David dicens: ' Percussit Absalom omnes filios regis, et non remansit ex eis saltem unus '."
,"31":"Surrexit itaque rex et scidit vestimenta sua et prostravit se super terram; et omnes servi ipsius, qui assistebant ei, sciderunt vestimenta sua."
,"32":"Respondens autem Ionadab filius Samma fratris David dixit: ' Ne aestimet dominus meus quod omnes pueri filii regis occisi sint; Amnon solus mortuus est, quoniam in ore Absalom hoc erat positum ex die, qua oppressit Thamar sororem eius."
,"33":"Nunc ergo ne ponat dominus meus rex super cor suum verbum istud dicens: 'Omnes filii regis occisi sunt', quoniam Amnon solus mortuus est '."
,"34":"Fugit autem Absalom. Et levavit puer speculator oculos suos et aspexit, et ecce populus multus veniebat per viam Oronaim ex latere montis in descensu; et venit speculator et nuntiavit regi dicens: ' Video homines per viam Oronaim '. "
,"35":"Dixit autem Ionadab ad regem: ' Ecce filii regis adsunt! Iuxta verbum servi tui sic factum est '."
,"36":"Cumque cessasset loqui, apparuerunt et filii regis et intrantes levaverunt vocem suam et fleverunt; sed et rex et omnes servi eius fleverunt ploratu magno nimis."
,"37":"Porro Absalom fugiens abiit ad Tholmai filium Ammiud regem Gesur. Luxit ergo David filium suum cunctis diebus."
,"38":"Absalom autem, cum fugisset et venisset in Gesur, fuit ibi tribus annis."
,"39":"Cessavitque spiritus regis adversari Absalom, eo quod consolatus esset super Amnon interitu."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Intellegens autem Ioab filius Sarviae quod cor regis ver sum esset ad Absalom,"
,"2":"misit Thecuam et tulit inde mulierem sapientem dixitque ad eam: ' Lugere te simula et induere veste lugubri et ne ungaris oleo, ut sis quasi mulier plurimo iam tempore lugens mortuum."
,"3":"Et ingredieris ad regem et loqueris ad eum sermones huiuscemodi '. Posuit autem Ioab verba in ore eius."
,"4":"Itaque, cum ingressa fuisset mulier Thecuites ad regem, cecidit coram eo super terram et adoravit et dixit: ' Serva me, rex '."
,"5":"Et ait ad eam rex: ' Quid causae habes? '. Quae respondit: ' Heu, mulier vidua ego sum: mortuus est vir meus."
,"6":"Et ancillae tuae erant duo filii, qui rixati sunt adversum se in agro, nullusque erat, qui eos interveniens prohibere posset; et percussit alter alterum et interfecit eum."
,"7":"Et ecce consurgens universa cognatio adversum ancillam tuam dicit: 'Trade eum, qui percussit fratrem suum, ut occidamus eum pro anima fratris sui, quem interfecit, et deleamus heredem'. Et quaerunt exstinguere scintillam meam, quae relicta est, ut non supersit viro meo nomen et reliquiae super terram '."
,"8":"Et ait rex ad mulierem: ' Vade in domum tuam, et ego iubebo de te '."
,"9":"Dixitque mulier Thecuites ad regem: ' In me, domine mi rex, iniquitas et in domum patris mei; rex autem et thronus eius sit innocens '."
,"10":"Et ait rex: ' Qui contradixerit tibi, adduc eum ad me, et ultra non addet ut tangat te '."
,"11":"Quae ait: ' Recordetur rex Domini Dei sui, ut non augeat ultor sanguinis perniciem, et nequaquam interficiant filium meum '. Qui ait: ' Vivit Dominus, quia non cadet de capillis filii tui super terram '."
,"12":"Dixit ergo mulier: ' Loquatur ancilla tua ad dominum meum regem verbum '. Et ait: ' Loquere '."
,"13":"Dixitque mulier: ' Quare cogitasti istiusmodi rem contra populum Dei? Eo enim quod rex locutus est verbum istud, hoc est quasi delictum, quia rex noluit reducere eiectum suum."
,"14":"Omnes morimur et quasi aquae sumus, quae delabuntur in terram, quae non colliguntur; nec tamen vult perire Deus animam, sed retractat cogitans, ne penitus pereat, qui abiectus est."
,"15":"Nunc igitur veni, ut loquar ad regem dominum meum verbum hoc, quia populus terruit me. Et dixit ancilla tua: Loquar ad regem, si quo modo faciat rex verbum ancillae suae."
,"16":"Nam audiet rex, ut liberet ancillam suam de manu illius, qui vult delere me et filium meum simul de hereditate Dei."
,"17":"Dixit ergo ancilla tua: Fiat verbum domini mei regis mihi in quietem. Sicut enim angelus Dei, sic est dominus meus rex, ut audiat et discernat bonum et malum. Et Dominus Deus tuus sit tecum! '."
,"18":"Et respondens rex dixit ad mulierem: ' Ne abscondas a me verbum, quod te interrogo '. Dixitque mulier: ' Loquatur dominus meus rex '."
,"19":"Et ait rex: ' Numquid manus Ioab tecum est in omnibus istis? '. Respondit mulier et ait: ' Per salutem animae tuae, domine mi rex, nec ad dextram nec ad sinistram potest deviari ab omnibus his, quae locutus est dominus meus rex; servus enim tuus Ioab ipse praecepit mihi et ipse posuit in os ancillae tuae omnia verba haec;"
,"20":"ut verterem figuram rei huius, servus tuus Ioab fecit istud. Tu autem, domine mi, sapiens es, sicut habet sapientiam angelus Dei, ut intellegas omnia, quae fiunt super terram '."
,"21":"Et ait rex ad Ioab: ' Ecce hoc facio; vade igitur et revoca puerum Absalom '."
,"22":"Cadensque Ioab super faciem suam in terram adoravit et benedixit regi. Et dixit Ioab: ' Hodie intellexit servus tuus quia inveni gratiam in oculis tuis, domine mi rex; fecisti enim sermonem servi tui '."
,"23":"Surrexit ergo Ioab et abiit in Gesur et adduxit Absalom in Ierusalem."
,"24":"Dixit autem rex: ' Revertatur in domum suam et faciem meam non videat '. Reversus est itaque Absalom in domum suam et faciem regis non vidit."
,"25":"Porro sicut Absalom vir non erat pulcher in omni Israel, qui valde laudaretur, a vestigio pedis usque ad verticem non erat in eo ulla macula."
,"26":"Et quando tondebatur capillus - semel autem in anno tondebatur, quia gravabat eum caesaries - ponderabat capillos capitis sui ducentis siclis pondere regio."
,"27":"Nati sunt autem Absalom filii tres et filia una, nomine Thamar, eleganti forma."
,"28":"Mansitque Absalom Ierusalem duobus annis et faciem regis non vidit."
,"29":"Misit itaque ad Ioab, ut mitteret eum ad regem; qui noluit venire ad eum. Cumque secundo misisset, et ille noluisset venire,"
,"30":"dixit servis suis: ' Videte agrum Ioab iuxta agrum meum habentem messem hordei; ite igitur et succendite eum igni '. Succenderunt ergo servi Absalom segetem igni. Et venientes servi Ioab, scissis vestibus suis, dixerunt: ' Succenderunt servi Absalom agrum igni! '."
,"31":"Surrexitque Ioab et venit ad Absalom in domum eius et dixit: ' Quare succenderunt servi tui segetem meam igni? '."
,"32":"Et respondit Absalom ad Ioab: ' Misi ad te obsecrans, ut venires ad me, et mitterem te ad regem, ut diceres ei: 'Quare veni de Gesur? Melius mihi erat adhuc ibi esse'. Obsecro ergo, ut videam faciem regis; quod si est in me iniquitas, interficiat me '."
,"33":"Ingressus Ioab ad regem nuntiavit ei. Vocatusque Absalom intravit ad regem et adoravit super faciem in terra coram eo; osculatusque est rex Absalom."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Post haec fecit sibi Absalom currus et equos et quinqua ginta viros, qui praecederent eum."
,"2":"Et mane consurgens Absalom stabat iuxta viam portae; et omnem virum, qui habebat negotium, ut veniret ad regis iudicium, vocabat Absalom ad se et dicebat: ' De qua civitate es tu? '. Qui respondens aiebat: ' Ex una tribu Israel ego sum servus tuus '."
,"3":"Respondebatque ei Absalom: ' Vide, sermones tui sunt boni et iusti, sed non est qui te audiat constitutus a rege '. Dicebatque Absalom:"
,"4":"' Quis me constituat iudicem in terra, ut ad me veniant omnes, qui habent negotium iudicandum, et iustificem eos? '."
,"5":"Sed et cum accederet ad eum homo, ut se prostraret coram illo, extendebat manum suam et apprehendens osculabatur eum."
,"6":"Faciebatque hoc omni Israel, qui veniebat ad iudicium, ut audiretur a rege, et sollicitabat corda virorum Israel."
,"7":"Post quattuor autem annos dixit Absalom ad regem: ' Vadam, quaeso, et reddam in Hebron vota mea, quae vovi Domino."
,"8":"Votum enim vovit servus tuus, cum esset in Gesur Syriae, dicens: Si reduxerit me Dominus in Ierusalem, sacrificabo Domino '."
,"9":"Dixitque ei rex. ' Vade in pace '. Et surrexit et abiit in Hebron."
,"10":"Misit autem Absalom exploratores in universas tribus Israel dicens: ' Statim ut audieritis clangorem bucinae, dicite: 'Factus est rex Absalom in Hebron' '."
,"11":"Porro cum Absalom ierunt ducenti viri de Ierusalem vocati, euntes simplici corde et causam penitus ignorantes."
,"12":"Accersivit quoque Absalom, cum immolaret victimas, Achitophel Gilonitem consiliarium David de civitate sua Gilo. Et facta est coniuratio valida; populusque concurrens augebatur cum Absalom."
,"13":"Venit igitur nuntius ad David dicens: ' Toto corde universus Israel sequitur Absalom '."
,"14":"Et ait David servis suis, qui erant cum eo in Ierusalem: ' Surgite, fugiamus; neque enim erit nobis effugium a facie Absalom. Festinate egredi, ne festinans occupet nos et impellat super nos ruinam et percutiat civitatem in ore gladii '."
,"15":"Dixeruntque servi regis ad eum: ' In omnibus, quaecumque elegerit dominus noster rex, ecce servi tui sumus '."
,"16":"Egressus est ergo rex et universa domus eius post eum et dereliquit rex decem mulieres concubinas ad custodiendam domum."
,"17":"Egressusque rex et omnis populus post eum steterunt ad ultimam domum."
,"18":"Et universi servi eius transierunt iuxta eum; et omnes Cherethi et Phelethi et omnes Getthaei, sescenti viri, qui secuti eum fuerant de Geth, transierunt coram rege."
,"19":"Dixit autem rex ad Ethai Getthaeum: ' Cur venis etiam tu nobiscum? Revertere et habita cum rege, quia alienigena es, immo et exsul de loco tuo."
,"20":"Heri venisti, et hodie compellam te vagari nobiscum, cum ego vadam, quo iturus sum? Revertere et reduc tecum fratres tuos, et Dominus faciat tecum misericordiam et veritatem '."
,"21":"Et respondit Ethai regi dicens: ' Vivit Dominus et vivit dominus meus rex, in quocumque loco fuerit dominus meus rex, sive ad mortem sive ad vitam, ibi erit servus tuus '."
,"22":"Et ait David Ethai: ' Veni et transi '. Et transivit Ethai Getthaeus et omnes viri eius et omnes parvuli, qui cum eo erant."
,"23":"Omnisque terra flebat voce magna, et universus populus transibat. Rex quoque transgrediebatur torrentem Cedron, et cunctus populus incedebat contra viam deserti."
,"24":"Venit autem et Sadoc et universi Levitae cum eo portantes arcam foederis Dei; et deposuerunt arcam Dei. Et sacrificavit Abiathar, donec omnis populus egressus fuerat de civitate."
,"25":"Et dixit rex ad Sadoc: ' Reporta arcam Dei in urbem. Si invenero gratiam in oculis Domini, reducet me et ostendet mihi eam et habitationem suam."
,"26":"Si autem dixerit: 'Non places mihi', praesto sum: faciat, quod bonum est coram se '."
,"27":"Et dixit rex ad Sadoc sacerdotem: ' Videsne? Revertere in civitatem in pace; et Achimaas filius tuus et Ionathan filius Abiathar, duo filii vestri sint vobiscum."
,"28":"Ecce ego morabor ad vada deserti, donec veniat sermo a vobis indicans mihi '."
,"29":"Reportaverunt igitur Sadoc et Abiathar arcam Dei Ierusalem et manserunt ibi."
,"30":"Porro David ascendebat clivum Olivarum scandens et flens, operto capite et nudis pedibus incedens; sed et omnis populus, qui erat cum eo, operto capite ascendebat plorans."
,"31":"Nuntiatum est autem David quod et Achitophel esset in coniuratione cum Absalom; dixitque David: ' Infatua, quaeso, Domine, consilium Achitophel '."
,"32":"Cumque ascendisset David summitatem montis, in quo adorabatur Deus, ecce occurrit ei Chusai Arachites, scissa veste et terra pleno capite."
,"33":"Et dixit ei David: ' Si veneris mecum, eris mihi oneri;"
,"34":"Si autem in civitatem revertaris et dixeris Absalom: 'Servus tuus ego, rex, ero; servus patris tui ego fui prius, nunc autem ego sum servus tuus', dissipabis mihi consilium Achitophel."
,"35":"Habes autem tecum Sadoc et Abiathar sacerdotes; et omne verbum, quodcumque audieris de domo regis, indicabis Sadoc et Abiathar sacerdotibus."
,"36":"Sunt autem cum eis duo filii eorum: Achimaas Sadoc et Ionathan Abiathar; et mittetis per eos ad me omne verbum, quod audieritis '."
,"37":"Veniente ergo Chusai amico David in civitatem, Absalom quoque ingressus est Ierusalem."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Cumque David transisset paululum montis verticem, apparuit Siba puer Meribbaal in occursum eius cum duobus asinis stratis, qui onerati erant ducentis panibus et centum alligaturis uvae passae et centum fasciculis fructuum aestivorum et utre vini."
,"2":"Et dixit rex Sibae: ' Quid sibi volunt haec? '. Responditque Siba: ' Asini domesticis regis ad sedendum; et panes et fructus aestivi ad vescendum pueris tuis; vinum autem, ut bibat, si quis defecerit in deserto '."
,"3":"Et ait rex: ' Ubi est filius domini tui? '. Responditque Siba regi: ' Remansit in Ierusalem dicens: 'Hodie restituet mihi domus Israel regnum patris mei' '."
,"4":"Et ait rex Sibae: ' Ecce, tua sint omnia, quae fuerunt Meribbaal '. Dixitque Siba: ' Adoro; inveniam gratiam coram te, domine mi rex '."
,"5":"Venit ergo rex David usque Bahurim, et ecce egrediebatur inde vir de cognatione domus Saul nomine Semei filius Gera; procedebat egrediens et maledicens"
,"6":"mittebatque lapides contra David et contra universos servos regis David. Omnis autem populus et universi viri fortissimi a dextro et sinistro latere regis incedebant."
,"7":"Ita autem loquebatur Semei, cum malediceret regi: ' Egredere, egredere, vir sanguinum et vir Belial!"
,"8":"Reddidit tibi Dominus universum sanguinem domus Saul, quoniam invasisti regnum eius; et dedit Dominus regnum in manu Absalom filii tui; et ecce premunt te mala tua, quoniam vir sanguinum es '."
,"9":"Dixit autem Abisai filius Sarviae regi: ' Quare maledicit canis hic mortuus domino meo regi? Vadam et amputabo caput eius '."
,"10":"Et ait rex: 'Quid mihi et vobis filii Sarviae? Si maledicit, et si Dominus praecepit ei, ut malediceret David, quis est qui audeat dicere: 'Quare sic fecisti?' '."
,"11":"Et ait rex Abisai et universis servis suis: ' Ecce filius meus, qui egressus est de visceribus meis, quaerit animam meam; quanto magis nunc iste filius Beniaminita. Dimittite eum, ut maledicat iuxta praeceptum Domini."
,"12":"Fortasse respiciet Dominus afflictionem meam et reddet mihi bonum pro maledictione hac hodierna '."
,"13":"Ambulabat itaque David et socii eius per viam; Semei autem per iugum montis ex latere gradiebatur maledicens et mittens lapides adversum eum terramque spargens."
,"14":"Venit itaque rex et universus populus cum eo lassus usque ad aquas, et refocillati sunt ibi."
,"15":"Absalom autem et omnis populus eius, viri Israel, ingressi sunt Ierusalem, sed et Achitophel cum eo."
,"16":"Cum autem venisset Chusai Arachites amicus David ad Absalom, locutus est ad eum: ' Vivat rex! Vivat rex! '."
,"17":"Ad quem Absalom: 'Haec est, inquit, gratia tua ad amicum tuum? Quare non isti cum amico tuo? '."
,"18":"Responditque Chusai ad Absalom: ' Nequaquam; quia, quem elegit Dominus, et hic populus et omnis Israel, illius ero et cum eo manebo."
,"19":"Sed, ut et hoc inferam, cui ego serviturus sum? Nonne filio regis? Sicut parui patri tuo, sic parebo et tibi '."
,"20":"Dixit autem Absalom ad Achitophel: ' Inite consilium quid agere debeamus '."
,"21":"Et ait Achitophel ad Absalom: ' Ingredere ad concubinas patris tui, quas dimisit ad custodiendam domum; ut, cum audierit omnis Israel quod foedaveris patrem tuum, roborentur manus omnium, qui tecum sunt '."
,"22":"Tetenderunt igitur Absalom tabernaculum in solario; ingressusque est ad concubinas patris sui coram universo Israel."
,"23":"Consilium autem Achitophel, quod dabat in diebus illis, quasi si quis consuleret Deum; sic erat omne consilium Achitophel, et cum esset cum David et cum esset cum Absalom."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Dixitque Achitophel ad Ab salom: ' Eligam mihi duode cim milia virorum et consurgens persequar David hac nocte"
,"2":"et irruens super eum, quippe qui lassus est et solutis manibus, terrebo eum. Cumque fugerit omnis populus, qui cum eo est, percutiam regem desolatum"
,"3":"et reducam universum populum ad te, sicut revertitur sponsa ad virum suum; unius solummodo viri animam quaeris, et omnis populus erit in pace '."
,"4":"Placuitque sermo eius Absalom et cunctis maioribus natu Israel."
,"5":"Ait autem Absalom: ' Vocate et Chusai Arachiten, et audiamus quid etiam ipse dicat '."
,"6":"Cumque venisset Chusai ad Absalom, ait Absalom ad eum: ' Huiuscemodi sermonem locutus est Achitophel; verbum eius facere debemus an non? Tu loquere '."
,"7":"Et dixit Chusai ad Absalom: ' Non bonum consilium, quod dedit Achitophel hac vice '."
,"8":"Et rursum intulit Chusai: ' Tu nosti patrem tuum et viros, qui cum eo sunt, esse fortissimos et amaro animo, veluti ursa in saltu catulis orbata; sed et pater tuus vir bellator est nec morabitur cum populo:"
,"9":"ecce nunc latitat in aliqua fovea aut in aliquo alio loco. Et, cum ceciderit unus quilibet in principio, certo audient et dicent: 'Facta est plaga in populo, qui sequitur Absalom'."
,"10":"Et fortissimus quoque, cuius cor est quasi leonis, pavore solvetur; scit enim omnis Israel fortem esse patrem tuum et robustos omnes, qui cum eo sunt."
,"11":"Sed hoc mihi videtur rectum esse consilium: congregetur ad te universus Israel a Dan usque Bersabee, quasi arena maris innumerabilis, et tu ipse gradieris in proelium;"
,"12":"et irruemus super eum, in quocumque loco fuerit inventus, et operiemus eum sicut cadere solet ros super terram; et non remanebit de eo et de omnibus viris, qui cum eo sunt, ne unus quidem."
,"13":"Quod si urbem aliquam fuerit ingressus, applicabit omnis Israel civitati illi funes, et trahemus eam in torrentem, ut non reperiatur nec calculus quidem ex ea '."
,"14":"Dixitque Absalom et omnis vir Israel: ' Melius consilium Chusai Arachitae consilio Achitophel '. Dominus enim statuerat dissipare consilium Achitophel utile, ut induceret Dominus super Absalom malum."
,"15":"Et ait Chusai Sadoc et Abiathar sacerdotibus: ' Hoc et hoc modo consilium dedit Achitophel Absalom et senibus Israel, et ego tale et tale dedi consilium;"
,"16":"nunc ergo mittite cito et nuntiate David dicentes: 'Ne moreris nocte hac ad vada deserti, sed absque dilatione transgredere, ne absorbeatur rex et omnis populus, qui cum eo est' '."
,"17":"Ionathan autem et Achimaas stabant iuxta fontem Rogel; abiit ancilla et nuntiavit eis, et illi profecti sunt, ut referrent ad regem David nuntium; non enim poterant introire civitatem, ne viderentur."
,"18":"Vidit autem eos quidam iuvenis et indicavit Absalom; illi vero concito gradu profecti ingressi sunt domum cuiusdam viri in Bahurim, qui habebat puteum in vestibulo suo, et descenderunt in eum."
,"19":"Tulit autem mulier et expandit velamen super os putei et sparsit super illud ptisanas, et sic res latuit."
,"20":"Cumque venissent servi Absalom ad mulierem in domum, dixerunt: ' Ubi est Achimaas et Ionathan? '. Et respondit eis mulier: ' Transierunt hinc ad aquas '. At hi, qui quaerebant, cum non repperissent, reversi sunt Ierusalem."
,"21":"Cumque abissent, ascenderunt illi de puteo et pergentes nuntiaverunt regi David atque dixerunt: ' Surgite et transite cito fluvium, quoniam huiuscemodi dedit consilium contra vos Achitophel '."
,"22":"Surrexit ergo David et omnis populus, qui erat cum eo, et transierunt Iordanem, donec dilucesceret; et ne unus quidem residuus fuit, qui non transisset fluvium."
,"23":"Porro Achitophel videns quod non fuisset factum consilium suum, stravit asinum suum et surrexit et abiit in domum suam in civitatem suam et, disposita domo sua, laqueo se suspendit et interiit; et sepultus est in sepulcro patris sui."
,"24":"David autem venit in Mahanaim, et Absalom transivit Iordanem, ipse et omnis vir Israel cum eo."
,"25":"Amasam vero constituerat Absalom pro Ioab super exercitum; Amasa autem erat filius viri, qui vocabatur Iether Ismaelites, qui ingressus est ad Abigail filiam Isai sororem Sarviae, quae fuit mater Ioab."
,"26":"Et castrametatus est Israel cum Absalom in terra Galaad."
,"27":"Cumque venisset David in Mahanaim, Sobi filius Naas de Rabba filiorum Ammon et Machir filius Ammiel de Lodabar et Berzellai Galaadites de Rogelim"
,"28":"obtulerunt ei stratoria et tapetia et pelves et vasa fictilia, frumentum et hordeum et farinam, frixum cicer et fabam et lentem"
,"29":"et mel et butyrum, oves et pingues vitulos; dederuntque David et populo, qui cum eo erat, ad vescendum; suspicati enim sunt populum fame et siti fuisse fatigatum in deserto."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Igitur, recensito David populo suo, constituit super eum tribunos et centuriones."
,"2":"Et divisit David populum in tres partes: tertiam partem sub manu Ioab et tertiam sub manu Abisai filii Sarviae fratris Ioab et tertiam in manu Ethai, qui erat de Geth. Dixitque rex ad populum: ' Egrediar et ego vobiscum '."
,"3":"Et respondit populus: ' Non exibis. Sive enim fugerimus, non magnopere ad eos de nobis pertinebit; et si media pars ceciderit e nobis, non satis curabunt, sed tu unus pro decem milibus computaris. Melius est igitur, ut sis nobis ex urbe praesidio '."
,"4":"Ad quos rex ait: ' Quod vobis rectum videtur, hoc faciam '. Stetit ergo rex iuxta portam; egrediebaturque populus per turmas suas centeni et milleni."
,"5":"Et praecepit rex Ioab et Abisai et Ethai dicens: ' Leniter mihi agite cum puero Absalom '. Et omnis populus audiebat praecipientem regem cunctis principibus pro Absalom."
,"6":"Itaque egressus est populus in campum contra Israel, et factum est proelium in saltu Ephraim."
,"7":"Et caesus est ibi populus Israel ab exercitu David; factaque est ibi plaga magna in die illa viginti milium hominum."
,"8":"Fuit autem ibi proelium dispersum super faciem omnis terrae; et multo plures erant, quos saltus consumpserat de populo, quam hi, quos voraverat gladius in die illa."
,"9":"Accidit autem, ut occurreret Absalom servis David sedens mulo; cumque ingressus fuisset mulus subter condensam quercum et magnam, adhaesit caput eius quercui, et mansit suspensus inter caelum et terram; mulus, cui insederat, pertransivit."
,"10":"Vidit autem hoc quispiam et nuntiavit Ioab dicens: ' Vidi Absalom pendere de quercu '."
,"11":"Et ait Ioab viro, qui nuntiaverat ei: ' Si vidisti, quare non confodisti eum in terra? Ego vero dedissem tibi decem argenti siclos et unum balteum '."
,"12":"Qui dixit ad Ioab: ' Et si appenderes in manibus meis mille argenteos, nequaquam mitterem manum meam in filium regis. Audientibus enim nobis, praecepit rex tibi et Abisai et Ethai dicens: 'Custodite, quisquis sit, puerum Absalom!'."
,"13":"Sed et si fecissem contra animam meam infideliter, nequaquam hoc regem latere potuisset, et tu stares ex adverso '."
,"14":"Et ait Ioab: ' Non ita praestolabor coram te '. Tulit ergo tres lanceas in manu sua et infixit eas in corde Absalom, cum adhuc palpitaret haerens in quercu;"
,"15":"et cucurrerunt decem iuvenes armigeri Ioab et percutientes interfecerunt eum."
,"16":"Cecinit autem Ioab bucina, et destitit populus persequi fugientem Israel, quia Ioab retinuit populum."
,"17":"Et tulerunt Absalom et proiecerunt eum in saltu in foveam grandem et erexerunt super eum acervum lapidum magnum nimis; omnis autem Israel fugit in tabernacula sua."
,"18":"Porro Absalom erexerat sibi, cum adhuc viveret, lapidem, qui est in valle Regis; dixerat enim: ' Non habeo filium, qui memoriam servabit nominis mei '. Vocavitque titulum nomine suo, et appellatur Manus Absalom usque ad hanc diem."
,"19":"Achimaas autem filius Sadoc ait: ' Curram et nuntiabo regi, quia iudicium fecerit ei Dominus de manu inimicorum eius '."
,"20":"Ad quem Ioab dixit: ' Non es vir boni nuntii in hac die, sed nuntiabis in alia; hodie enim non nuntiabis bona, eo quod filius regis est mortuus '."
,"21":"Et ait Ioab Aethiopi: ' Vade et nuntia regi, quae vidisti '. Adoravit Aethiops Ioab et cucurrit."
,"22":"Rursus autem Achimaas filius Sadoc dixit ad Ioab: ' Quidquid evenerit, etiam ego curram post Aethiopem! '. Dixitque Ioab: ' Quid vis currere, fili mi? Non erit tibi merces pro bono nuntio '."
,"23":"Qui respondit: ' Quidquid evenerit, curram '. Et ait ei: ' Curre! '. Currens ergo Achimaas per viam regionis transivit Aethiopem."
,"24":"David autem sedebat inter duas portas; speculator vero, qui ierat in solarium portae super murum, elevans oculos vidit hominem currentem solum"
,"25":"et exclamans indicavit regi. Dixitque rex: ' Si solus est, bonus est nuntius in ore eius '. Properante autem illo et accedente propius,"
,"26":"vidit speculator hominem alterum currentem, et clamavit speculator ad ianitorem: ' Apparet mihi homo currens solus '. Dixitque rex: ' Et iste bonus est nuntius '."
,"27":"Speculator autem: ' Contemplor, ait, cursum prioris quasi cursum Achimaas filii Sadoc '. Et ait rex: ' Vir bonus est et nuntium portans bonum venit '."
,"28":"Clamans autem Achimaas dixit ad regem: ' Pax! '. Et adorans regem pronus in terram ait: ' Benedictus Dominus Deus tuus, qui conclusit homines, qui levaverunt manus suas contra dominum meum regem! '."
,"29":"Et ait rex: ' Estne pax puero Absalom? '. Dixitque Achimaas: ' Vidi tumultum magnum, cum mitteret Ioab servum regis et me servum tuum, sed nescio quid fuerit '."
,"30":"Ad quem rex: ' Recede, ait, et sta illic '. Cumque ille recessisset et staret,"
,"31":"apparuit Aethiops et veniens ait: ' Bonum apporto nuntium, domine mi rex; iudicavit enim pro te Dominus hodie salvans te de manu omnium, qui surrexerunt contra te '."
,"32":"Dixit autem rex ad Aethiopem: ' Estne pax puero Absalom? '. Cui respondens Aethiops: ' Fiant, inquit, sicut puer inimici domini mei regis et universi, qui consurrexerunt adversus eum in malum! '."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Contremuit itaque rex et ascendit cenaculum portae et flevit. Et sic loquebatur vadens: ' Fili mi Absalom, fili mi, fili mi Absalom! Quis mihi tribuat, ut ego moriar pro te? Absalom fili mi, fili mi! '."
,"2":"Nuntiatum est autem Ioab quod rex fleret et lugeret filium suum."
,"3":"Et versa est victoria in die illa in luctum omni populo; audivit enim populus in die illa dici: ' Dolet rex super filio suo '."
,"4":"Et furtim ingressus est populus in die illa civitatem, quomodo reverti solet populus confusus, cum fugit de proelio."
,"5":"Porro rex operuit vultum suum et clamabat voce magna: ' Fili mi Absalom, Absalom fili mi, fili mi! '."
,"6":"Ingressus ergo Ioab ad regem in domo dixit: ' Confudisti hodie vultus omnium servorum tuorum, qui salvam fecerunt animam tuam hodie et animam filiorum tuorum et filiarum tuarum et animam uxorum tuarum et animam concubinarum tuarum."
,"7":"Diligis odientes te et odio habes diligentes te. Ostendisti hodie quia non curas de ducibus tuis et de servis tuis; et vere cognovi modo quia, si Absalom viveret, et nos omnes occubuissemus, tunc placeret tibi."
,"8":"Nunc igitur surge et procede et loquere ad cor servorum tuorum; iuro enim tibi per Dominum quod si non exieris, ne unus quidem remansurus sit tecum nocte hac, et peius erit hoc tibi quam omnia mala, quae venerunt super te ab adulescentia tua usque in praesens '."
,"9":"Surrexit ergo rex et sedit in porta, et omni populo nuntiatum est quod rex sederet in porta; venitque universa multitudo coram rege. Israel autem fugerat in tabernacula sua. "
,"10":"Omnis quoque populus certabat in cunctis tribubus Israel dicens: ' Rex liberavit nos de manu inimicorum nostrorum, ipse salvavit nos de manu Philisthinorum; et nunc fugit de terra ab Absalom."
,"11":"Absalom autem, quem unximus super nos, mortuus est in bello. Quare nunc siletis et non reducitis regem? '."
,"12":"Sermo autem omnis Israel pervenerat ad regem in domo eius. Tunc rex David misit ad Sadoc et Abiathar sacerdotes dicens: ' Loquimini ad maiores natu Iudae dicentes: Cur estis novissimi ad reducendum regem in domum suam?"
,"13":"Fratres mei vos, os meum et caro mea vos; quare novissimi reducitis regem?"
,"14":"Et Amasae dicite: Nonne os meum es et caro mea? Haec faciat mihi Deus et haec addat, si non magister militiae fueris coram me omni tempore pro Ioab! '."
,"15":"Et inclinavit cor omnium virorum Iudae quasi viri unius; miseruntque ad regem dicentes: ' Revertere tu et omnes servi tui '."
,"16":"Et reversus est rex et venit usque ad Iordanem; et Iuda venit in Galgala, ut occurreret regi et traduceret eum Iordanem."
,"17":"Festinavit autem Semei filius Gera Beniaminita de Bahurim et descendit cum viris Iudae in occursum regis David;"
,"18":"mille viri de Beniamin et Siba puer de domo Saul et quindecim filii eius ac viginti servi erant cum eo. Irruperant autem Iordanem iam ante regem"
,"19":"et transierant vada, ut traducerent domum regis et facerent iuxta placitum eius. Semei autem filius Gera prostratus coram rege, cum transiturus esset Iordanem,"
,"20":"dixit ad eum: ' Ne reputes mihi, domine mi, iniquitatem neque memineris iniuriam servi tui in die, qua egressus es, domine mi rex, de Ierusalem; neque ponas, rex, in corde tuo."
,"21":"Agnosco enim servus tuus peccatum meum et idcirco hodie primus veni de omni domo Ioseph descendique in occursum domini mei regis '."
,"22":"Respondens vero Abisai filius Sarviae dixit: ' Numquid non occidetur Semei, pro hoc quia maledixit christo Domini? '."
,"23":"Et ait David: ' Quid mihi et vobis, filii Sarviae, quia efficimini mihi hodie in satan? Ergone hodie interficietur vir in Israel? An ignoro hodie me factum regem super Israel? '."
,"24":"Et ait rex Semei: ' Non morieris! '. Iuravitque ei."
,"25":"Meribbaal quoque filius Saul descendit in occursum regis; non laverat pedes nec circumcidit ungues nec totonderat barbam vestesque suas non laverat a die, qua egressus fuerat rex, usque ad diem reversionis eius in pace."
,"26":"Cumque de Ierusalem occurrisset regi, dixit ei rex: ' Quare non venisti mecum, Meribbaal? '."
,"27":"Qui respondens ait: ' Domine mi rex, servus meus decepit me! Nam dixeram ei ego famulus tuus: Sternere faciam mihi asinum et ascendens abibo cum rege; claudus enim sum servus tuus."
,"28":"Insuper et fraudulenter accusavit me servum tuum ad te dominum meum regem. Tu autem, domine mi rex, sicut angelus Dei es; fac, quod placitum est tibi."
,"29":"Neque enim fuit domus patris mei nisi morti obnoxia domino meo regi; tu autem posuisti me servum tuum inter convivas mensae tuae. Quid ultra igitur habeo iustitiae, ut vociferer ad regem? '."
,"30":"Ait ergo ei rex: ' Quid ultra loqueris? Dixi: Tu et Siba dividite possessiones '."
,"31":"Responditque Meribbaal regi: ' Etiam cuncta accipiat, postquam reversus est dominus meus rex pacifice in domum suam! '."
,"32":"Berzellai quoque Galaadites descenderat de Rogelim et traduxit regem Iordanem, ut dimitteret eum ad Iordanem."
,"33":"Erat autem Berzellai Galaadites senex valde, id est octogenarius; et ipse praebuerat alimenta regi, cum moraretur in Mahanaim; erat quippe vir dives nimis."
,"34":"Dixit itaque rex ad Berzellai: ' Veni mecum et praebebo tibi alimenta apud me in Ierusalem '."
,"35":"Et ait Berzellai ad regem: ' Quot sunt dies annorum vitae meae, ut ascendam cum rege Ierusalem?"
,"36":"Octogenarius sum hodie; numquid vigent sensus mei ad discernendum suave aut amarum? Aut delectare potest servum tuum cibus et potus? Vel audire ultra possum vocem cantorum atque cantricum? Quare servus tuus esset ultra oneri domino meo regi?"
,"37":"Paululum procedam famulus tuus ab Iordane tecum. Et cur dabit rex mihi hanc vicissitudinem?"
,"38":"Sed obsecro, ut revertar servus tuus et moriar in civitate mea iuxta sepulcrum patris mei et matris meae. Sed ecce servus tuus Chamaam; ipse vadat tecum, domine mi rex, et fac ei, quod tibi bonum videtur '."
,"39":"Dixitque rex: ' Mecum transeat Chamaam, et ego faciam ei, quidquid tibi placuerit; et omne, quod petieris a me, impetrabis '."
,"40":"Cumque transisset universus populus et rex Iordanem, osculatus est rex Berzellai et benedixit ei; et ille reversus est in locum suum."
,"41":"Transivit ergo rex in Galgala, et Chamaam cum eo. Omnis autem populus Iudae traduxerat regem, et etiam media pars populi Israel."
,"42":"Et ecce omnes viri Israel concurrentes ad regem dixerunt ei: ' Quare te furati sunt fratres nostri viri Iudae et traduxerunt regem et domum eius Iordanem omnesque viros David cum eo? '."
,"43":"Et respondit omnis vir Iudae ad virum Israel: ' Quia propior mihi est rex. Cur irasceris super hac re? Numquid comedimus aliquid ex rege, aut munera nobis data sunt? '."
,"44":"Et respondit vir Israel ad virum Iudae et ait: ' Decem partes mihi sunt in rege et ideo etiam in David. Ego sum potior te; cur contempsisti me? Et non ego prior locutus sum, ut reducerem regem meum? '. Durius autem responderunt viri Iudae viris Israel."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Accidit quoque, ut ibi esset vir Belial nomine Seba filius Bochri Beniaminita; et cecinit bucina et ait: ' Non est nobis pars in David, neque hereditas in filio Isai!,Vir Israel, in tabernacula tua! '."
,"2":"Et separatus est omnis vir Israel a David secutusque est Seba filium Bochri; viri autem Iudae adhaeserunt regi suo a Iordane usque Ierusalem."
,"3":"Cumque venisset rex in domum suam Ierusalem, tulit decem mulieres concubinas, quas dereliquerat ad custodiendam domum, et tradidit eas in custodiam alimenta eis praebens. Et non est ingressus ad eas, sed erant clausae usque ad diem mortis suae in viduitate viventes."
,"4":"Dixit autem rex Amasae: ' Convoca mihi omnes viros Iudae in diem tertium et tu adesto praesens '."
,"5":"Abiit ergo Amasa, ut convocaret Iudam; et moratus est ultra tempus, quod ei constituerat."
,"6":"Ait autem David ad Abisai: ' Nunc magis afflicturus est nos Seba filius Bochri quam Absalom; tolle igitur servos domini tui et persequere eum, ne inveniat civitates munitas et effugiat nos '."
,"7":"Egressi sunt ergo cum eo viri Ioab, Cherethi quoque et Phelethi et omnes fortissimi; exierunt de Ierusalem ad persequendum Seba filium Bochri."
,"8":"Cumque illi essent iuxta lapidem grandem, qui est in Gabaon, Amasa venerat ante eos. Porro Ioab accinctus erat habitu suo, et in cingulo super lumbos gladius absconditus erat, qui levi motu ex vagina in manum suam cecidit."
,"9":"Dixitque Ioab ad Amasam: ' Estne pax tibi, mi frater? '. Et tenuit manu dextera mentum Amasae, ut oscularetur eum."
,"10":"Porro Amasa non observavit gladium in manu Ioab, qui percussit eum in inguine et effudit intestina eius in terram, nec secundum vulnus apposuit; et mortuus est. Ioab autem et Abisai frater eius persecuti sunt Seba filium Bochri."
,"11":"Interea quidam de pueris Ioab stetit iuxta cadaver Amasae et dixit: ' Qui esse vult cum Ioab et pro David, sequatur Ioab! '."
,"12":"Amasa autem conspersus sanguine iacebat in media via. Vidit hoc vir quod subsisteret omnis populus ad videndum eum; et amovit Amasam de via in agrum operuitque eum vestimento, cum videret quod omnes transeuntes propter eum subsisterent."
,"13":"Amoto igitur illo de via, transibat omnis vir sequens Ioab ad persequendum Seba filium Bochri."
,"14":"Porro ille transierat per omnes tribus Israel usque in Abelbethmaacha; omnesque Bochritae congregati sunt et ingressi sunt etiam post eum."
,"15":"Venerunt itaque et oppugnabant eum in Abelbethmaacha et fuderunt contra civitatem aggerem, qui stetit contra antemurale; et omnis populus, qui erat cum Ioab, moliebatur destruere muros."
,"16":"Et exclamavit mulier sapiens de civitate: ' Audite, audite! Dicite Ioab: 'Appropinqua huc, et loquar tecum' '."
,"17":"Qui cum accessisset ad eam, ait illi: ' Tu es Ioab? '. Et ille respondit: ' Ego '. Ad quem sic locuta est: ' Audi sermones ancillae tuae '. Qui respondit: ' Audio '."
,"18":"Rursumque illa: ' Sermo, inquit, dicebatur in vetere proverbio: 'Interrogent in Abel, et sic perficient rem'."
,"19":"Ego pacifica fidelium Israel, et tu quaeris subruere civitatem et evertere matrem in Israel. Quare praecipitas hereditatem Domini? '."
,"20":"Respondensque Ioab ait: ' Absit, absit hoc a me; non praecipito neque demolior."
,"21":"Non se sic habet res, sed homo de monte Ephraim, Seba filius Bochri cognomine, levavit manum suam contra regem David; tradite illum solum, et recedam a civitate'. Et ait mulier ad Ioab: ' Ecce, caput eius mittetur ad te per murum '."
,"22":"Ingressa est ergo ad omnem populum et locuta est eis sapienter. Qui abscissum caput Seba filii Bochri proiecerunt ad Ioab. Et ille cecinit tuba, et recesserunt ab urbe unusquisque in tabernacula sua. Ioab autem reversus est Ierusalem ad regem."
,"23":"Erat ergo Ioab super omnem exercitum Israel; Banaias autem filius Ioiadae super Cherethaeos et Phelethaeos;"
,"24":"Adoniram vero super onera; porro Iosaphat filius Ahilud a commentariis."
,"25":"Siva autem scriba, Sadoc vero et Abiathar sacerdotes;"
,"26":"Hira quoque Iairites erat sacerdos David."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Facta est fames in diebus David tribus annis iugiter. Et consuluit David oraculum Domini, dixitque Dominus: ' Super Saul et super domum eius est sanguis, quia occidit Gabaonitas '."
,"2":"Vocatis ergo Gabaonitis, rex dixit ad eos - porro Gabaonitae non sunt de filiis Israel, sed reliquiae Amorraeorum; filii quippe Israel iuraverant eis, sed voluit Saul percutere eos zelo suo pro filiis Israel et Iudae -;"
,"3":"dixit ergo David ad Gabaonitas: ' Quid faciam vobis? Et quod erit vestri piaculum, ut benedicatis hereditati Domini? '."
,"4":"Dixeruntque ei Gabaonitae: ' Non est nobis super argento et auro quaestio contra Saul et contra domum eius; neque nobis licet interficere hominem de Israel '. Ad quos ait: ' Quod ergo dixeritis, faciam vobis '."
,"5":"Qui dixerunt regi: ' De filiis viri, qui attrivit nos et cogitavit delere nos ita ut ne unus quidem nostrum residuus esset in cunctis finibus Israel,"
,"6":"dentur nobis septem viri, et suspendamus eos in patibulis Domino in Gabaon in monte Domini '. Et ait rex: ' Ego dabo '."
,"7":"Pepercitque rex Meribbaal filio Ionathan filii Saul propter iusiurandum Domini, quod fuerat inter David et inter Ionathan filium Saul."
,"8":"Tulit itaque rex duos filios Respha filiae Aia, quos peperit Saul, Armoni et Meribbaal, et quinque filios Merob filiae Saul, quos genuerat Hadrieli filio Berzellai, qui fuit de Molathi,"
,"9":"et dedit eos in manu Gabaonitarum, qui suspenderunt illos in monte coram Domino. Et ceciderunt hi septem simul, occisi in diebus messis primis, incipiente messione hordei."
,"10":"Tollens autem Respha filia Aia cilicium substravit sibi super petram ab initio messis, donec stillaret aqua super eos de caelo, et non dimisit aves caeli considere super eos per diem neque bestias campi per noctem."
,"11":"Et nuntiata sunt David, quae fecerat Respha filia Aia concubina Saul."
,"12":"Et abiit David et tulit ossa Saul et ossa Ionathan filii eius a civibus Iabes Galaad, qui furati fuerant ea de platea Bethsan, in qua suspenderant eos Philisthim, cum interfecissent Saul in Gelboe,"
,"13":"et asportavit inde ossa Saul et ossa Ionathan filii eius; et colligentes ossa eorum, qui suspensi fuerant,"
,"14":"sepelierunt ea cum ossibus Saul et Ionathan filii eius in terra Beniamin in Sela, in sepulcro Cis patris eius. Feceruntque omnia, quae praeceperat rex; et repropitiatus est Deus terrae post haec."
,"15":"Factum est autem rursum proelium Philisthinorum adversum Israel, et descendit David et servi eius cum eo, et pugnabant contra Philisthim, et fatigatus est David."
,"16":"Iesbibenob, qui fuit de genere Rapha - ferrum hastae trecentos siclos appendebat - et accinctus erat ense novo, nisus est percutere David;"
,"17":"praesidioque ei fuit Abisai filius Sarviae et percussum Philisthaeum interfecit. Tunc iuraverunt viri David dicentes: ' Iam non egredieris nobiscum in bellum, ne exstinguas lucernam Israel '."
,"18":"Fuitque rursum bellum in Gob contra Philisthaeos; tunc percussit Sobbochai de Husa Saph de stirpe Rapha."
,"19":"Et fuit iterum bellum in Gob contra Philisthaeos, in quo percussit Elchanan filius Iair Bethlehemites Goliath Getthaeum, cuius hastile hastae erat quasi liciatorium texentium."
,"20":"Et adhuc fuit bellum in Geth, in quo vir excelsus, qui senos in manibus pedibusque habebat digitos, id est viginti et quattuor, et is quoque erat de origine Rapha,"
,"21":"exprobravit Israel; percussit autem eum Ionathan filius Samma fratris David."
,"22":"Hi quattuor erant de genere Rapha ex Geth et ceciderunt per manum David et servorum eius."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Locutus est autem David Domino verba carminis huius in die, qua liberavit eum Dominus de manu omnium inimicorum suorum et de manu Saul,"
,"2":"et ait: ' Dominus petra mea et arx mea et salvator meus;"
,"3":"Deus meus, rupes mea, in quam confugiam, scutum meum et cornu salutis meae!,Munimentum meum et refugium meum. Salvator meus, de violentia liberabis me."
,"4":"Laudabilem invocabo Dominum,et ab inimicis meis salvus ero."
,"5":"Quia circumdederunt me fluctus mortis, torrentes Belial terruerunt me;"
,"6":"praeoccupaverunt me laquei mortis."
,"7":"In tribulatione mea invocavi Dominum,et ad Deum meum clamavi; et exaudivit de templo suo vocem meam, et clamor meus venit ad aures eius. "
,"8":"Commota est et contremuit terra; fundamenta caelorum concussa sunt,et conquassata, quoniam iratus est. "
,"9":"Ascendit fumus de naribus eius, et ignis de ore eius vorabat; carbones incensi sunt ab eo."
,"10":"Et inclinavit caelos et descendit, et caligo sub pedibus eius."
,"11":"Et ascendit super cherub et volavit,et devolavit super pennas venti."
,"12":"Posuit tenebras in circuitu suo tabernaculum suum, tenebrosas aquas, nubes densissimas."
,"13":"Prae fulgore in conspectu eius,incensi sunt carbones ignis."
,"14":"Intonuit de caelo Dominus, et Excelsus dedit vocem suam."
,"15":"Misit sagittas et dissipavit eos, fulguravit fulmina et conturbavit eos."
,"16":"Et apparuerunt effusiones maris, et revelata sunt fundamenta orbis,ab increpatione Domini, ab inspiratione spiritus furoris eius."
,"17":"Misit de excelso et assumpsit me, traxit me de aquis multis;"
,"18":"liberavit me ab inimico meo potentissimo, ab his, qui oderant me, qui robustiores me erant."
,"19":"Praevenerunt me in die afflictionis meae, et factus est Dominus firmamentum meum;"
,"20":"et eduxit me in latitudinem, liberavit me, quia complacui ei."
,"21":"Retribuit mihi Dominus secundum iustitiam meam,et secundum munditiam manuum mearum reddit mihi,"
,"22":"quia custodivi vias Domini,et non egi impie a Deo meo."
,"23":"Omnia enim iudicia eius in conspectu meo, et a praeceptis eius non recessi;"
,"24":"et fui immaculatus cum eo,et custodivi me ab iniquitate mea."
,"25":"Et retribuet mihi Dominus secundum iustitiam meam,et secundum munditiam meam in conspectu oculorum suorum."
,"26":"Cum sancto sanctus eris,et cum viro innocente innocens eris;"
,"27":"cum electo electus eris,et cum perverso callidus eris."
,"28":"Et populum pauperem salvum facies,et oculos superborum humiliabis,"
,"29":"quia tu lucerna mea, Domine, et Deus meus illuminat tenebras meas."
,"30":"In te enim aggrediar hostium turmas, in Deo meo transiliam murum."
,"31":"Deus, immaculata via eius, eloquium Domini igne examinatum; scutum est omnium sperantium in se."
,"32":"Quoniam quis est Deus praeter Dominum?,Et quae rupes praeter Deum nostrum?"
,"33":"Deus, qui accinxit me fortitudine,et complanavit perfectam viam meam,"
,"34":"coaequans pedes meos cervis,et super excelsa statuens me;"
,"35":"docens manus meas ad proelium, et tendunt arcum aereum brachia mea."
,"36":"Dedisti mihi clipeum salutis tuae, et exauditio tua magnificavit me."
,"37":"Dilatasti gressus meos subtus me, et non sunt infirmati tali mei."
,"38":"Persequebar inimicos meos et conterebam,et non convertebar, donec consumerem eos."
,"39":"Consumpsi eos et confregi, ut non consurgerent: ceciderunt sub pedibus meis."
,"40":"Accinxisti me fortitudine ad proelium, incurvasti insurgentes in me subtus me."
,"41":"Inimicos meos dedisti mihi dorsum, odientes me, et disperdidi eos."
,"42":"Clamaverunt, et non erat qui salvaret, ad Dominum, et non exaudivit eos. "
,"43":"Contrivi eos ut pulverem terrae, quasi lutum platearum comminui eos."
,"44":"Salvasti me a contradictionibus populi mei, constituisti me in caput gentium. Populus, quem ignorabam, servit mihi,"
,"45":"filii alieni blandiuntur mihi, auditu auris oboediunt mihi."
,"46":"Filii alieni defluunt,et contremiscunt ex arcibus suis."
,"47":"Vivit Dominus, et benedicta petra mea, et exaltetur Deus, petra salutis meae."
,"48":"Deus, qui das vindictas mihi,et deicis populos sub me."
,"49":"Qui educis me ab inimicis meis,et ab insurgentibus in me elevas me; a viro iniquo liberas me."
,"50":"Propterea confitebor tibi, Domine, in gentibus, et nomini tuo cantabo:"
,"51":"Magnificat salutes regis sui,et facit misericordiam christo suo David,et semini eius in sempiternum '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Haec autem sunt verba David novissima: ' Dixit David filius Isai, dixit vir constitutus in alto, christus Dei Iacob, suavis psalta Israel."
,"2":"Spiritus Domini locutus est per me, et sermo eius super linguam meam."
,"3":"Locutus est Deus Israel, mihi dixit Petra Israel: 'Dominator hominum iustus, dominator in timore Dei"
,"4":"est sicut lux aurorae, oriente sole, mane absque nubibus; de splendore post pluviam,herba oritur de terra'."
,"5":"Nonne sic est domus mea cum Deo?,Quia pactum aeternum statuit mihi, dispositum in omnibus atque munitum. Cunctam enim salutem meam et omne desiderabile,nonne faciet germinare?"
,"6":"Praevaricatores autem,quasi spinae abiectae universi, quae non tolluntur manibus;"
,"7":"et si quis tangere voluerit eas, armabitur ferro et ligno lanceato, igneque succensae comburentur '. "
,"8":"Haec nomina fortium David: Iesbaal Hachamonites, princeps inter tres, ipse levavit hastam suam super octingentos, quos interfecit impetu uno."
,"9":"Post hunc Eleazar filius Dodo Ahohites, inter tres fortes. Qui erat cum David in Aphesdommim, quando Philisthim congregati sunt illuc in proelium."
,"10":"Cumque ascendissent viri Israel, ipse stetit et percussit Philisthaeos, donec deficeret manus eius et obrigesceret cum gladio; fecitque Dominus salutem magnam in die illa, et populus reversus est tantum ad spolia detrahenda."
,"11":"Et post hunc Samma filius Age Ararites. Et congregati sunt Philisthim in Lehi; erat quippe ibi ager lente plenus. Cumque fugisset populus a facie Philisthim,"
,"12":"stetit ille in medio agri et tuitus est eum percussitque Philisthaeos, et fecit Dominus salutem magnam."
,"13":"Et descenderunt tres de triginta et venerunt tempore messis ad David in speluncam Odollam; castra autem Philisthinorum erant posita in valle Raphaim."
,"14":"Et David erat tunc in praesidio; porro statio Philisthinorum tunc erat in Bethlehem."
,"15":"Desideravit igitur David et ait: ' O si quis mihi daret potum aquae de cisterna, quae est in Bethlehem iuxta portam! '."
,"16":"Irruperunt ergo tres fortes castra Philisthinorum et hauserunt aquam de cisterna Bethlehem, quae erat iuxta portam, et attulerunt ad David. At ille noluit bibere, sed libavit illam Domino"
,"17":"dicens: ' Propitius mihi sit Dominus, ne faciam hoc. Num sanguinem hominum istorum, qui profecti sunt in animarum periculo, bibam? '. Noluit ergo bibere. Haec fecerunt tres robustissimi."
,"18":"Abisai autem frater Ioab filius Sarviae princeps erat de triginta. Ipse est qui elevavit hastam suam contra trecentos, quos interfecit. Nominatus in triginta"
,"19":"et inter triginta nobilior eratque eorum princeps; sed usque ad tres primos non pervenerat."
,"20":"Et Banaias filius Ioiadae vir fortissimus magnorum operum de Cabseel. Ipse percussit duos filios Ariel de Moab, et ipse descendit et percussit leonem in media cisterna in diebus nivis."
,"21":"Ipse quoque interfecit virum Aegyptium, virum procerae staturae habentem in manu hastam; itaque cum descendisset ad eum cum baculo, vi extorsit hastam de manu Aegyptii et interfecit eum hasta sua."
,"22":"Haec fecit Banaias filius Ioiadae, et ipse nominatus inter triginta fortissimos."
,"23":"Erat autem nobilior inter triginta; verumtamen usque ad tres non pervenerat. Fecitque eum David sibi caput satellitum suorum."
,"24":"Asael frater Ioab erat inter triginta. Elchanan filius Dodo de Bethlehem,"
,"25":"Samma de Harod, Elica de Harod,"
,"26":"Heles de Phalti, Hira filius Acces de Thecua,"
,"27":"Abiezer de Anathoth, Sobbochai de Husa,"
,"28":"Selmon Ahohites, Maharai Netophathites,"
,"29":"Heled filius Baana Netophathites, Ithai filius Ribai de Gabaa filiorum Beniamin,"
,"30":"Banaia Pharathonites, Heddai de torrentibus Gaas,"
,"31":"Abibaal Arbathites, Azmaveth de Bahurim,"
,"32":"Eliaba de Saalbon, Iasen de Gun,"
,"33":"Ionathan filius Samma de Arar, Ahiam filius Sarar Ararites."
,"34":"Eliphalet filius Aasbai Maachathitae, Eliam filius Achitophel Gilonites,"
,"35":"Hesro de Carmel, Pharai de Arab,"
,"36":"Igal filius Nathan de Soba, Bani de Gad,"
,"37":"Selec de Ammon, Naharai Berothites armiger Ioab filii Sarviae,"
,"38":"Hira Iethrites, Gareb et ipse Iethrites,"
,"39":"Urias Hetthaeus. Omnes triginta septem."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Et addidit furor Domini ira sci contra Israel; commovit que David contra eos dicens: ' Vade, numera Israel et Iudam '."
,"2":"Dixitque rex ad Ioab et ad principes exercitus sui, qui erant cum eo: ' Perambula omnes tribus Israel a Dan usque Bersabee, et numerate populum, ut sciam numerum eius '."
,"3":"Dixitque Ioab regi: ' Adaugeat Dominus Deus tuus ad populum, quantus nunc est, centuplum in conspectu domini mei regis! Sed quid sibi dominus meus rex vult in re huiuscemodi? '."
,"4":"Praevaluit autem sermo regis contra Ioab et principes exercitus; egressusque est Ioab et principes militum a facie regis, ut numerarent populum Israel."
,"5":"Cumque pertransissent Iordanem, inceperunt ab Aroer et ab urbe, quae est in media valle, transeuntes ad Gaditas et ad Iazer."
,"6":"Et pervenerunt in Galaad et in terram Hetthaeorum in Cades et venerunt in Dan. Et a Dan converterunt se ad Sidonem"
,"7":"et pervenerunt ad arcem Tyri et omnes urbes Hevaei et Chananaei exieruntque ad Nageb Iudae in Bersabee."
,"8":"Et, lustrata universa terra, affuerunt post novem menses et viginti dies in Ierusalem."
,"9":"Dedit ergo Ioab numerum descriptionis populi regi; et inventa sunt de Israel octingenta milia virorum fortium, qui educerent gladium, et de Iuda quingenta milia pugnatorum."
,"10":"Percussit autem cor David eum, postquam numeratus est populus, et dixit David ad Dominum: ' Peccavi valde in hoc facto; nunc vero precor, Domine, ut transferas iniquitatem servi tui, quia stulte egi nimis '."
,"11":"Surrexit itaque David mane, et sermo Domini factus est ad Gad propheten, videntem David, dicens:"
,"12":"' Vade et loquere ad David: Haec dicit Dominus: Trium tibi datur optio; elige unum, quod volueris ex his, ut faciam tibi '."
,"13":"Cumque venisset Gad ad David, nuntiavit ei dicens: ' Aut tribus annis veniet tibi fames in terra tua, aut tribus mensibus fugies adversarios tuos, et illi te persequentur, aut certe tribus diebus erit pestilentia in terra tua. Nunc ergo delibera et vide quem respondeam ei, qui me misit, sermonem '."
,"14":"Dixit autem David ad Gad: ' Artor nimis; sed melius est, ut incidamus in manu Domini - multae enim misericordiae eius sunt - quam in manu hominum! '."
,"15":"Et elegit sibi David pestilentiam; et erant dies messis tritici. Immisitque Dominus pestilentiam in Israel de mane usque ad tempus constitutum, et mortui sunt ex populo a Dan usque Bersabee septuaginta milia virorum."
,"16":"Cumque extendisset manum suam angelus super Ierusalem, ut disperderet eam, misertus est Dominus super afflictione et ait angelo percutienti populum: ' Sufficit; nunc contine manum tuam! '. Erat autem angelus Domini iuxta aream Areuna Iebusaei. "
,"17":"Dixitque David ad Dominum, cum vidisset angelum caedentem populum: ' Ego sum qui peccavi, ego inique egi; isti, qui oves sunt, quid fecerunt? Vertatur, obsecro, manus tua contra me et contra domum patris mei '."
,"18":"Venit autem Gad ad David in die illa et dixit ei: ' Ascende, constitue Domino altare in area Areuna Iebusaei '."
,"19":"Et ascendit David iuxta sermonem Gad, quem praeceperat ei Dominus."
,"20":"Conspiciensque Areuna animadvertit regem et servos eius transire ad se"
,"21":"et egressus adoravit regem prono vultu in terra et ait: ' Quid causae est, ut veniat dominus meus rex ad servum suum? '. Cui David ait: ' Ut emam a te aream et aedificem altare Domino, et cesset interfectio, quae grassatur in populo '."
,"22":"Et ait Areuna ad David: ' Accipiat et offerat dominus meus rex, sicut ei placet. Ecce boves in holocaustum et plaustrum et iuga boum in usum lignorum."
,"23":"Omnia dat Areuna, o rex, regi '. Dixitque Areuna ad regem: ' Dominus Deus tuus suscipiat votum tuum! '."
,"24":"Cui respondens rex ait: ' Nequaquam; sed emam pretio a te et non offeram Domino Deo meo holocausta gratuita '. Emit ergo David aream et boves argenti siclis quinquaginta."
,"25":"Et aedificavit ibi David altare Domino et obtulit holocausta et pacifica. Et repropitiatus est Dominus terrae, et cohibita est plaga ab Israel."
}`)

}
func LA_NVBSE_LoadVHEDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In anno primo Cyri regis Persarum, ut compleretur verbum Domini ex ore Ieremiae, suscitavit Dominus spiritum Cyri regis Persarum, qui emisit edictum in omni regno suo etiam per scripturam dicens:"
,"2":"' Haec dicit Cyrus rex Persarum: Omnia regna terrae dedit mihi Dominus, Deus caeli, et ipse praecepit mihi, ut aedificarem ei domum in Ierusalem, quae est in Iudaea."
,"3":"Quis ex vobis est de omni populo eius? Sit Dominus Deus suus cum eo, et ascendat in Ierusalem, quae est in Iudaea, et aedificet domum Domini, Dei Israel; ipse est Deus, qui est in Ierusalem."
,"4":"Et omnes reliqui in cunctis locis, ubicumque habitant, adiuventur a viris de loco suo, argento et auro et substantia et pecore sicut et oblationibus spontaneis pro templo Dei, quod est in Ierusalem '."
,"5":"Et surrexerunt principes familiarum de Iuda et Beniamin et sacerdotes et Levitae et omnis, cuius Deus suscitavit spiritum, ut ascenderent ad aedificandum templum Domini, quod erat in Ierusalem."
,"6":"Universique, qui erant in circuitu, confortaverunt manus eorum cum vasis argenteis et aureis, substantia, pecore et pensitationibus, praeter oblationes spontaneas."
,"7":"Rex quoque Cyrus protulit vasa templi Domini, quae tulerat Nabuchodonosor de Ierusalem et posuerat ea in templo dei sui;"
,"8":"protulit autem ea Cyrus rex Persarum per manum Mithridatis praepositi thesauri, qui enumeravit ea Sasabassar principi Iudae."
,"9":"Et hic est numerus eorum: phialae aureae triginta, phialae argenteae mille, cultri viginti novem, scyphi aurei triginta,"
,"10":"scyphi quoque argentei quadringenti decem, vasa alia plurima; 11 omnia vasa aurea et argentea quinque milia quadringenta. Universa tulit Sasabassar cum his, qui ascendebant de transmigratione Babylonis in Ierusalem."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Hi sunt autem provinciae filii, qui ascenderunt de captivitate migrantium, quos transtulerat Nabuchodonosor rex Babylonis in Babylonem, et reversi sunt in Ierusalem et Iudam, unusquisque in civitatem suam."
,"2":"Qui venerunt cum Zorobabel, Iesua, Nehemias, Saraia, Rahelaia, Mardochaeus, Belsan, Mesphar, Beguai, Rehum, Baana. Numerus virorum populi Israel: "
,"3":"filii Pharos duo milia centum septuaginta duo;"
,"4":"filii Saphatia trecenti septuaginta duo; 5 filii Area septingenti septuaginta quinque;"
,"6":"filii Phahathmoab, hi sunt filii Iesua et Ioab, duo milia octingenti duodecim;"
,"7":"filii Elam mille ducenti quinquaginta quattuor;"
,"8":"filii Zethua nongenti quadraginta quinque;"
,"9":"filii Zachai septingenti sexaginta;"
,"10":"filii Bani sescenti quadraginta duo;"
,"11":"filii Bebai sescenti viginti tres;"
,"12":"filii Azgad mille ducenti viginti duo;"
,"13":"filii Adonicam sescenti sexaginta sex;"
,"14":"filii Beguai duo milia quinquaginta sex;"
,"15":"filii Adin quadringenti quinquaginta quattuor;"
,"16":"filii Ater, qui erant ex Ezechia, nonaginta octo;"
,"17":"filii Besai trecenti viginti tres;"
,"18":"filii Iora centum duodecim;"
,"19":"filii Hasum ducenti viginti tres;"
,"20":"filii Gebbar nonaginta quinque;"
,"21":"filii Bethlehem centum viginti tres;"
,"22":"viri Netopha quinquaginta sex;"
,"23":"viri Anathoth centum viginti octo;"
,"24":"filii Azmaveth quadraginta duo;"
,"25":"filii Cariathiarim, Cephira et Beroth septingenti quadraginta tres;"
,"26":"filii Rama et Gabaa sescenti viginti unus;"
,"27":"viri Machmas centum viginti duo;"
,"28":"viri Bethel et Hai ducenti viginti tres;"
,"29":"filii Nabo quinquaginta duo;"
,"30":"filii Megbis centum quinquaginta sex;"
,"31":"filii Elam alterius mille ducenti quinquaginta quattuor;"
,"32":"filii Harim trecenti viginti;"
,"33":"filii Lod, Hadid et Ono septingenti viginti quinque;"
,"34":"filii Iericho trecenti quadraginta quinque;"
,"35":"filii Senaa tria milia sescenti triginta."
,"36":"Sacerdotes: filii Iedaia de domo Iesua nongenti septuaginta tres,"
,"37":"filii Emmer mille quinquaginta duo,"
,"38":"filii Phassur mille ducenti quadraginta septem,"
,"39":"filii Harim mille decem et septem."
,"40":"Levitae: filii Iesua, hi sunt filii Cadmihel, Bennui, Odoviae, septuaginta quattuor."
,"41":"Cantores: filii Asaph centum viginti octo."
,"42":"Ianitores: filii Sellum, filii Ater, filii Telmon, filii Accub, filii Hatita, filii Sobai: universi centum triginta novem."
,"43":"Oblati: filii Siha, filii Hasupha, filii Tabbaoth,"
,"44":"filii Ceros, filii Siaa, filii Phadon,"
,"45":"filii Lebana, filii Hagaba, filii Accub,"
,"46":"filii Hagab, filii Semlai, filii Hanan,"
,"47":"filii Giddel, filii Gaher, filii Raaia,"
,"48":"filii Rasin, filii Necoda, filii Gazam,"
,"49":"filii Oza, filii Phasea, filii Besai,"
,"50":"filii Asena, filii Meunitarum, filii Nephusorum,"
,"51":"filii Bacbuc, filii Hacupha, filii Harhur,"
,"52":"filii Basluth, filii Mahida, filii Harsa,"
,"53":"filii Bercos, filii Sisara, filii Thema,"
,"54":"filii Nasia, filii Hatipha."
,"55":"Filii servorum Salomonis: filii Sotai, filii Sophereth, filii Pheruda,"
,"56":"filii Iaala, filii Darcon, filii Giddel,"
,"57":"filii Saphatia, filii Hatil, filii Phochereth Hassebaim, filii Ami."
,"58":"Omnes oblati et filii servorum Salomonis trecenti nonaginta duo."
,"59":"Et hi, qui ascenderunt de Thelmela, Thelharsa, Cherub et Addon et Emmer et non potuerunt indicare domum patrum suorum et semen suum, utrum ex Israel essent:"
,"60":"filii Dalaia, filii Tobia, filii Necoda, sescenti quinquaginta duo."
,"61":"Et de filiis sacerdotum: filii Hobia, filii Accos, filii Berzellai, qui accepit de filiabus Berzellai Galaaditis uxorem et vocatus est nomine eorum."
,"62":"Hi quaesierunt tabulas genealogiae suae et non invenerunt; et eiecti sunt de sacerdotio."
,"63":"Et dixit praepositus eis, ut non comederent de sanctificatis sanctuarii, donec surgeret sacerdos pro Urim et Tummim."
,"64":"Omnis multitudo simul quadraginta duo milia trecenti sexaginta,"
,"65":"exceptis servis eorum et ancillis, qui erant septem milia trecenti triginta septem, insuper et cantores atque cantatrices ducenti."
,"66":"Equi eorum septingenti triginta sex, muli eorum ducenti quadraginta quinque,"
,"67":"cameli eorum quadringenti triginta quinque, asini eorum sex milia septingenti viginti."
,"68":"Nonnulli autem de principibus familiarum, cum ingrederentur templum domini, quod est in Ierusalem, sponte obtulerunt in domum Dei ad exstruendam eam in loco suo."
,"69":"Se cundum vires suas dederunt in aerarium operis auri solidos sexaginta milia et mille, argenti minas quinque milia et vestes sacerdotales centum."
,"70":"Habitaverunt ergo ibi sacerdotes et Levitae et quidam de populo; cantores autem et ianitores et oblati in urbibus suis, universusque Israel in civitatibus suis."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Iamque venerat mensis septi mus, et erant filii Israel in civita tibus suis. Congregatus est ergo populus quasi vir unus in Ierusalem."
,"2":"Et surrexit Iesua filius Iosedec et fratres eius sacerdotes et Zorobabel filius Salathiel et fratres eius et aedificaverunt altare Dei Israel, ut offerrent in eo holocautomata, sicut scriptum est in lege Moysi viri Dei."
,"3":"Collocaverunt autem altare super bases suas, deterrentibus eos per circuitum populis terrarum, et obtulerunt super illud holocaustum Domino mane et vespere."
,"4":"Feceruntque sollemnitatem Tabernaculorum, sicut scriptum est, et holocaustum diebus singulis per ordinem, secundum praeceptum pro singulis diebus;"
,"5":"et praeter holocaustum sempiternum illa etiam pro calendis et universis sollemnitatibus, quae erant consecratae Domino, et pro omnibus, quae ultro offerebantur Domino."
,"6":"A primo die mensis septimi coeperunt offerre holocaustum Domino; porro templum Dei nondum fundatum erat."
,"7":"Dederunt autem pecunias latomis et fabris, cibum quoque et potum et oleum Sidoniis Tyriisque, ut deferrent ligna cedrina de Libano ad mare Ioppe, iuxta quod concesserat Cyrus rex Persarum eis."
,"8":"Anno autem secundo adventus eorum ad templum Dei in Ierusalem mense secundo, coeperunt Zorobabel filius Salathiel et Iesua filius Iosedec et reliqui de fratribus eorum sacerdotes et Levitae et omnes, qui venerant de captivitate in Ierusalem, et constituerunt Levitas a viginti annis et supra, ut dirigerent opus templi Domini."
,"9":"Stetitque Iesua et filii eius et fratres eius, Cadmihel, Bennui et Odovia quasi vir unus, ut dirigerent eos, qui faciebant opus in templo Dei; itemque filii Henadad et filii eorum et fratres eorum Levitae."
,"10":"Fundato igitur ab aedificatoribus templo Domini, steterunt sacerdotes in ornatu suo cum tubis, et Levitae filii Asaph in cymbalis, ut laudarent Deum iuxta mandatum David regis Israel."
,"11":"Et concinebant in hymnis et gratiarum actione Domino: ' Quoniam bonus, quoniam in aeternum misericordia eius ' super Israel. Omnis quoque populus vociferabatur clamore magno in laudando Dominum, eo quod fundatum esset templum Domini."
,"12":"Plurimi etiam senes de sacerdotibus et Levitis et principibus familiarum, qui viderant oculis suis prius templum in loco suo, flebant voce magna; et multi vociferantes in laetitia elevabant vocem."
,"13":"Nec poterat quisquam agnoscere vocem clamoris laetantium et vocem fletus populi, quoniam populus vociferabatur clamore magno, et strepitus audiebatur procul."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Audierunt autem hostes Iudae et Beniamin, quia filii captivita tis aedificarent templum Domino, Deo Israel,"
,"2":"et accedentes ad Zorobabel et ad principes familiarum dixerunt eis: ' Aedificemus vobiscum, quia ita ut vos quaerimus Deum vestrum et immolavimus victimas a diebus Asarhaddon regis Assyriae, qui adduxit nos huc '."
,"3":"Et dixit eis Zorobabel et Iesua et reliqui principes familiarum Israel: ' Non est vobis et nobis, ut aedificemus domum Deo nostro, sed nos ipsi soli aedificabimus Domino, Deo Israel, sicut praecepit nobis Cyrus rex Persarum '."
,"4":"Factum est igitur, ut populus terrae impediret manus populi Iudae et turbaret eos in aedificando."
,"5":"Conduxerunt autem adversus eos consiliatores, ut destruerent consilium eorum omnibus diebus Cyri regis Persarum et usque ad regnum Darii regis Persarum."
,"6":"In regno autem Asueri, in principio regni eius, scripserunt accusationem adversus habitatores Iudae et Ierusalem."
,"7":"Et in diebus Artaxerxis scripsit Beselam, Mithridates et Tabel et reliqui, qui erant in consilio eorum, ad Artaxerxem regem Persarum; scriptura autem accusationis erat scripta litteris Syriacis et composita sermone Syro."
,"8":"Rehum praefectus et Samsai scriba scripserunt epistulam unam de Ierusalem Artaxerxi regi huiuscemodi:"
,"9":"' Rehum praefectus et Samsai scriba et reliqui socii eorum, iudices et duces, magistratus Persae, Erchuaei, Babylonii, Susanechaei, hoc est Elamitae,"
,"10":"et ceteri de gentibus, quas transtulit Asenaphar magnus et gloriosus et habitare fecit in civitatibus Samariae et in reliquis regionibus trans flumen in pace '."
,"11":"Hoc est exemplar epistulae, quam miserunt ad eum: ' Artaxerxi regi, servi tui, viri, qui sunt trans fluvium. Igitur "
,"12":"notum sit regi quia Iudaei, qui ascenderunt a te ad nos, venerunt in Ierusalem civitatem rebellem et pessimam, quam aedificant, exstruentes muros eius, fundamenta iam componentes."
,"13":"Nunc notum sit regi quia, si civitas illa aedificata fuerit, et muri eius instaurati, tributum et annonam et vectigal non dabunt, et ad ultimum regibus noxa erit."
,"14":"Nos autem, memores salis, quod in palatio comedimus, et quia laesiones regis videre nefas ducimus, idcirco misimus et nuntiavimus regi,"
,"15":"ut recenseas in libris historiarum patrum tuorum, et invenies in his historiis et scies quoniam urbs illa urbs rebellis est et nocens regibus et provinciis, et seditiones concitantur in ea ex diebus antiquis; quam ob rem et civitas ipsa destructa est."
,"16":"Nuntiamus nos regi quoniam, si civitas illa aedificata fuerit, et muri ipsius instaurati, possessionem trans fluvium non habebis '."
,"17":"Verbum misit rex ad Rehum praefectum et Samsai scribam et ad reliquos, qui erant in consilio eorum, qui habitabant in Samaria et in regione trans fluvium: ' Pax. Nunc igitur scriptura,"
,"18":"quam misistis ad nos, manifeste lecta est coram me."
,"19":"Et a me praeceptum est, et recensuerunt inveneruntque quoniam civitas illa a diebus antiquis adversum reges rebellabat, et rebelliones et seditiones concitabantur in ea;"
,"20":"nam et reges fortissimi fuerunt in Ierusalem, qui et dominati sunt omni regioni, quae trans fluvium est, tributum quoque et annonam et vectigal accipiebant."
,"21":"Nunc ergo praecipite, ut desistant isti homines, et urbs illa non aedificetur, donec forte a me iussum fuerit."
,"22":"Videte, ne negligenter hoc impleatis, et paulatim crescat malum contra reges '."
,"23":"Itaque exemplum edicti Artaxerxis regis lectum est coram Rehum praefectum et Samsai scriba et consiliariis eorum; et abierunt festini in Ierusalem ad Iudaeos et prohibuerunt eos in brachio et robore."
,"24":"Tunc intermissum est opus domus Domini in Ierusalem et non fiebat usque ad annum secundum regni Darii regis Persarum."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Prophetae autem Aggaeus et Zacharias filius Addo propheta verunt ad Iudaeos, qui erant in Iudaea et Ierusalem, in nomine Dei Israel, quod erat super eos."
,"2":"Tunc surrexerunt Zorobabel filius Salathiel et Iesua filius Iosedec et coeperunt aedificare templum Dei in Ierusalem; prophetae autem Dei adiuvabant eos."
,"3":"In ipso autem tempore venit ad eos Thathanai, qui erat dux trans flumen, et Stharbuzanai et consiliarii eorum, sicque dixerunt eis: ' Quis dedit vobis potestatem, ut domum hanc aedificaretis et materiam istam praepararetis?"
,"4":"Quae sunt nomina hominum auctorum aedificationis illius? '."
,"5":"Oculus autem Dei eorum factus est super senes Iudaeorum, et non obstiterunt eis, usque dum res ad Darium referretur, et tunc sententia de hac re redderetur."
,"6":"Exemplar epistulae, quam misit Thathanai dux regionis trans flumen et Stharbuzanai et consiliatores eius et duces, qui erant trans flumen, ad Darium regem."
,"7":"Sermo, quem miserant ei, sic scriptus erat: ' Dario regi pax omnis. "
,"8":"Notum sit regi isse nos ad Iudaeam provinciam, ad domum Dei magni, quae aedificatur lapide quadrato, et ligna ponuntur in parietibus; opusque illud diligenter exstruitur et crescit in manibus eorum."
,"9":"Interrogavimus ergo senes illos et ita diximus eis: 'Quis dedit vobis potestatem, ut domum hanc aedificaretis et materiam istam praepararetis?'."
,"10":"Sed et nomina eorum quaesivimus ab eis, ut nuntiaremus tibi, scripsimusque nomina eorum virorum, qui sunt principes in eis."
,"11":"Huiuscemodi autem sermonem responderunt nobis dicentes: 'Nos sumus servi Dei caeli et terrae et aedificamus templum, quod erat exstructum ante hos annos multos, quodque rex Israel magnus aedificaverat et exstruxerat."
,"12":"Postquam autem ad iracundiam provocaverunt patres nostri Deum caeli, tradidit eos in manus Nabuchodonosor regis Babylonis Chaldaei, qui domum hanc destruxit et populum eius transtulit in Babylonem."
,"13":"Anno autem primo Cyri regis Babylonis, Cyrus rex proposuit edictum, ut domus Dei haec aedificaretur."
,"14":"Nam et vasa templi Dei aurea et argentea, quae Nabuchodonosor tulerat de templo, quod erat in Ierusalem, et asportaverat ea in templum Babylonis, protulit Cyrus rex de templo Babylonis, et data sunt viro cuidam nomine Sasabassar, quem et principem constituit,"
,"15":"dixitque ei: 'Haec vasa tolle et vade et pone ea in templo, quod est in Ierusalem, et domus Dei aedificetur in loco suo'."
,"16":"Tunc itaque Sasabassar ille venit et posuit fundamenta templi Dei in Ierusalem, et ex eo tempore usque nunc aedificatur et necdum completum est'."
,"17":"Nunc ergo, si videtur regi bonum, recenseat in aerario regis, quod est in Babylone, utrumnam a Cyro rege potestas data fuerit, ut aedificaretur domus Dei in Ierusalem, et voluntatem regis super hac re mittat ad nos '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Tunc Darius rex praecepit, et recensuerunt in tabulis aerarii, quod est in Babylone,"
,"2":"et inventum est in Ecbatanis, quod est castrum in Medena provincia, volumen unum, et sic scriptus erat in eo commentarius:"
,"3":"' Anno primo Cyri regis, Cyrus rex decrevit de domo Dei, quae est in Ierusalem: Aedificetur domus, ubi immolent et sacrificent; altitudo eius cubitorum sexaginta et latitudo eius cubitorum sexaginta,"
,"4":"ordines de lapidibus quadratis tres et ordo de lignis unus; sumptus autem de domo regis dabuntur."
,"5":"Sed et vasa templi Dei aurea et argentea, quae Nabuchodonosor tulerat de templo Ierusalem et attulerat in Babylonem, reddantur et referantur in templum, quod est in Ierusalem, in locum suum, in templo Dei."
,"6":"Nunc ergo, Thathanai dux regionis, quae est trans flumen, Stharbuzanai et consiliarii eius et duces, qui estis trans flumen, procul recedite ab illo loco,"
,"7":"dimittite fieri templum Dei illud; dux Iudaeorum et seniores eorum aedificent domum Dei illam in loco suo."
,"8":"Sed et a me praeceptum est quomodo agere debeatis cum senioribus Iudaeorum illis, qui aedificant domum Dei illam: ut de arca regis, id est de tributis, quae dantur de regione trans flumen, studiose sumptus dentur viris illis sine intermissione."
,"9":"Et si quid necesse fuerit, sive vituli et arietes et agni in holocaustum Deo caeli, sive frumentum, sal, vinum et oleum, secundum ordinationem sacerdotum, qui sunt in Ierusalem, detur eis per singulos dies sine neglegentia."
,"10":"Et offerant oblationes suaves Deo caeli orentque pro vita regis et filiorum eius."
,"11":"A me ergo positum est decretum, ut omnis homo, qui hanc mutaverit iussionem, tollatur lignum de domo ipsius et erigatur et configatur in eo; domus autem eius ponatur in sterquilinium."
,"12":"Deus autem, qui habitare fecit nomen suum ibi, dissipet omnia regna et populum, qui extenderit manum suam, ut contemnat et dissipet domum Dei illam, quae est in Ierusalem. Ego Darius statui decretum, quod studiose impleri volo '."
,"13":"Igitur Thathanai dux regionis trans flumen et duces et consiliarii eius, secundum quod praeceperat Darius rex, sic diligenter exsecuti sunt."
,"14":"Seniores autem Iudaeorum prosperabantur in aedificatione iuxta prophetiam Aggaei prophetae et Zachariae filii Addo et perfecerunt aedificationem, iubente Deo Israel et iubente Cyro et Dario et Artaxerxe regibus Persarum,"
,"15":"et compleverunt domum Dei istam die tertia mensis Adar, qui est annus sextus regni Darii regis."
,"16":"Fecerunt autem filii Israel, sacerdotes et Levitae et reliqui filiorum transmigrationis dedicationem domus Dei illius in gaudio."
,"17":"Et obtulerunt in dedicationem domus Dei illius boves centum, arietes ducentos, agnos quadringentos, hircos caprarum pro peccato totius Israel duodecim, iuxta numerum tribuum Israel."
,"18":"Et statuerunt sacerdotes in ordinibus suis et Levitas in vicibus suis in ministerium Dei in Ierusalem, sicut scriptum est in libro Moysi."
,"19":"Fecerunt autem filii Israel transmigrationis Pascha quarta decima die mensis primi."
,"20":"Levitae universi se purificaverunt; purificati autem cuncti immolaverunt Pascha universis filiis transmigrationis et fratribus suis sacerdotibus et sibi."
,"21":"Et comederunt filii Israel, qui reversi fuerant de transmigratione, et omnes, qui a coinquinatione gentium terrae transierunt ad eos, ut quaererent Dominum, Deum Israel."
,"22":"Et fecerunt sollemnitatem Azymorum septem diebus in laetitia, quoniam laetificaverat eos Dominus et converterat cor regis Assyriae ad eos, ut adiuvaret manus eorum in opere domus Domini, Dei Israel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Post haec autem in regno Arta xerxis regis Persarum, Esdras fi lius Saraiae filii Azariae filii Helciae"
,"2":"filii Sellum filii Sadoc filii Achitob"
,"3":"filii Amariae filii Azariae filii Meraioth"
,"4":"filii Zaraiae filii Ozi filii Bocci"
,"5":"filii Abisue filii Phinees filii Eleazar filii Aaron summi sacerdotis,"
,"6":"ipse Esdras ascendit de Babylone et ipse scriba velox in lege Moysi, quam dedit Dominus, Deus Israel. Cumque manus Domini Dei eius esset super eum, dedit ei rex omnem petitionem eius."
,"7":"Et ascenderunt de filiis Israel et de filiis sacerdotum et de filiis Levitarum et de cantoribus et de ianitoribus et de oblatis in Ierusalem, anno septimo Artaxerxis regis."
,"8":"Venit in Ierusalem mense quinto, ipse est annus septimus regis."
,"9":"In primo die mensis primi coepit ascendere de Babylone et in primo die mensis quinti venit in Ierusalem, iuxta manum Dei sui bonam super se."
,"10":"Esdras enim applicavit cor suum, ut investigaret et impleret legem Domini et faceret et doceret in Israel praeceptum et iudicium."
,"11":"Hoc est autem exemplar epistulae, quam dedit rex Artaxerxes Esdrae sacerdoti, scribae erudito in mandatis Domini et praeceptis eius in Israel."
,"12":"' Artaxerxes rex regum Esdrae sacerdoti, scribae legis Dei caeli, salutem."
,"13":"A me decretum est, ut cuicumque placuerit in regno meo de populo Israel et de sacerdotibus eius et de Levitis ire in Ierusalem, tecum vadat."
,"14":"A facie enim regis et septem consiliatorum eius missus es, ut visites Iudaeam et Ierusalem secundum legem Dei tui, quae est in manu tua,"
,"15":"et ut feras argentum et aurum, quod rex et consiliatores eius sponte obtulerunt Deo Israel, cuius in Ierusalem tabernaculum est."
,"16":"Et omne argentum et aurum, quodcumque inveneris in universa provincia Babylonis simul cum oblationibus sponte oblatis a populo et a sacerdotibus pro domo Dei sui, quae est in Ierusalem,"
,"17":"igitur studiose eme de hac pecunia boves, arietes, agnos et oblationes et libamina eorum et offer ea super altare templi Dei vestri, quod est in Ierusalem."
,"18":"Sed et, si quid tibi et fratribus tuis placuerit de reliquo argento et auro ut faciatis iuxta voluntatem Dei vestri, facite."
,"19":"Vasa quoque, quae dantur tibi in ministerium domus Dei tui, trade in conspectu Dei in Ierusalem."
,"20":"Sed et cetera, quibus opus fuerit in domum Dei tui, quantumcumque necesse est ut expendas, dabitur ab aerario regis."
,"21":"Et ego Artaxerxes rex statui atque decrevi omnibus custodibus arcae publicae, qui sunt trans flumen, ut quodcumque petierit a vobis Esdras sacerdos, scriba legis Dei caeli, absque mora detis"
,"22":"usque ad argenti talenta centum et usque ad frumenti coros centum et usque ad vini batos centum et usque ad batos olei centum; sal vero absque mensura."
,"23":"Omne, quod requirit Deus caeli, tribuatur diligenter in domo Dei caeli, ne forte irascatur contra regnum regis et filiorum eius."
,"24":"Vobis quoque notum facimus de universis sacerdotibus et Levitis et cantoribus et ianitoribus, oblatis et ministris domus Dei huius, ut tributum et annonas et vectigal non habeatis potestatem imponendi super eos."
,"25":"Tu autem, Esdra, secundum sapientiam Dei tui, quae est in manu tua, constitue praesides et iudices, ut iudicent omni populo, qui est trans flumen, his videlicet, qui noverunt legem Dei tui; sed et imperitos docete."
,"26":"Et omnis, qui non fecerit legem Dei tui et legem regis diligenter, iudicium erit de eo, sive in mortem sive in exsilium sive in damnum substantiae eius vel certe in carcerem '."
,"27":"Benedictus Dominus, Deus patrum nostrorum, qui dedit hoc in corde regis, ut glorificaret domum Domini, quae est in Ierusalem,"
,"28":"et in me inclinavit misericordiam regis et consiliariorum eius et cunctorum principum eius potentium. Et ego confortatus manu Domini Dei mei, quae erat in me, congregavi de Israel principes, qui ascenderent mecum."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Hi sunt ergo principes familiarum et genealogia eorum, qui ascenderunt mecum in regno Artaxerxis regis de Babylone:"
,"2":"De filiis Phinees, Gersom. De filiis Ithamar, Daniel. De filiis David, Hattus filius Secheniae."
,"3":"De filiis Pharos, Zacharias; et cum eo numerati sunt viri centum quinquaginta."
,"4":"De filiis Phahathmoab, Elioenai filius Zaraiae, et cum eo ducenti viri."
,"5":"De filiis Zethua, Sechenia filius Iahaziel, et cum eo trecenti viri."
,"6":"De filiis Adin, Ebed filius Ionathan, et cum eo quinquaginta viri."
,"7":"De filiis Elam, Iesaias filius Athaliae, et cum eo septuaginta viri."
,"8":"De filiis Saphatiae, Zabadia filius Michael, et cum eo octoginta viri."
,"9":"De filiis Ioab, Abdia filius Iahiel, et cum eo ducenti decem et octo viri."
,"10":"De filiis Bani, Selomith filius Iosphiae, et cum eo centum sexaginta viri."
,"11":"De filiis Bebai, Zacharias filius Bebai, et cum eo viginti octo viri."
,"12":"De filiis Azgad, Iohanan filius Eccetan, et cum eo centum et decem viri."
,"13":"De filiis Adonicam ascenderunt iuniores, et haec nomina eorum: Eliphalet et Iehiel et Semeias, et cum eis sexaginta viri."
,"14":"De filiis Beguai, Uthai filius Zabud, et cum eis septuaginta viri."
,"15":"Congregavi autem eos ad fluvium, qui decurrit ad Ahava, et mansimus ibi tribus diebus. Recensui populum et sacerdotes; de filiis autem Levi non inveni ibi."
,"16":"Itaque misi Eliezer et Ariel et Semeiam et Ioiarib et Elnathan et Nathan et Zachariam et Mosollam principes sapientes."
,"17":"Et misi eos ad Eddo, qui est primus in Chasphiae loco, et posui in ore eorum verba, quae loquerentur ad Eddo et fratres eius, ut adducerent nobis ministros domus Dei nostri."
,"18":"Et adduxerunt nobis per manum Dei nostri bonam super nos virum doctissimum de filiis Moholi filii Levi filii Israel nomine Serebiam et filios eius et fratres eius decem et octo"
,"19":"et Hasabiam et cum eo Iesaiam de filiis Merari filiosque eius et fratres eius viginti"
,"20":"et de oblatis, quos dederant David et principes ad ministeria Levitarum, ducentos viginti viros; omnes hi suis nominibus recensiti sunt."
,"21":"Et praedicavi ibi ieiunium iuxta fluvium Ahava, ut affligeremur coram Deo nostro et peteremus ab eo iter prosperum nobis et filiis nostris universaeque substantiae nostrae."
,"22":"Erubui enim petere a rege praesidium et equites, qui defenderent nos ab inimico in via, quia dixeramus regi: ' Manus Dei nostri est super omnes, qui quaerunt eum in bonitate, et potentia eius et fortitudo eius super omnes, qui derelinquunt eum '."
,"23":"Ieiunavimus autem et rogavimus Deum nostrum per hoc, et evenit nobis prospere."
,"24":"Et separavi de principibus sacerdotum duodecim, Serebiam et Hasabiam et cum eis de fratribus eorum decem,"
,"25":"appendique eis argentum et aurum et vasa: tributum domus Dei nostri, quod obtulerat rex et consiliatores eius et principes eius universusque Israel eorum, qui ibi inveniebantur."
,"26":"Et appendi in manibus eorum argenti talenta sescenta quinquaginta et vasa argentea centum, quae habebant talenta duo, auri centum talenta,"
,"27":"et crateres aureos viginti, qui habebant solidos millenos, et vasa aeris fulgentis optimi duo pretiosa ut aurum."
,"28":"Et dixi eis: ' Vos sancti Domini, et vasa sancta et argentum et aurum consecrata Domino, Deo patrum nostrorum;"
,"29":"vigilate et custodite, donec appendatis coram principibus sacerdotum et Levitarum et ducibus familiarum Israel in Ierusalem, in habitaculis domus Domini '."
,"30":"Susceperunt autem sacerdotes et Levitae pondus argenti et auri et vasorum, ut deferrent Ierusalem in domum Dei nostri."
,"31":"Promovimus ergo a flumine Ahava duodecimo die mensis primi, ut pergeremus Ierusalem; et manus Dei nostri fuit super nos et liberavit nos de manu inimici et insidiatoris in via,"
,"32":"et venimus Ierusalem et mansimus ibi tribus diebus."
,"33":"Die autem quarta appensum est argentum et aurum et vasa in domo Dei nostri per manum Meremoth filii Uriae sacerdotis et cum eo Eleazar filius Phinees cumque eis Iozabad filius Iesua et Noadia filius Bennui Levitae,"
,"34":"iuxta numerum et pondus omnia; descriptumque est omne pondus. In tempore illo,"
,"35":"qui venerant de captivitate, filii transmigrationis, obtulerunt holocautomata Deo Israel, vitulos duodecim pro omni populo Israel, arietes nonaginta sex, agnos septuaginta septem, hircos pro peccato duodecim: omnia in holocaustum Domino."
,"36":"Dederunt autem edicta regis satrapis regis et ducibus trans flumen et sublevaverunt populum et domum Dei."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Postquam autem haec completa sunt, accesserunt ad me princi pes dicentes: ' Non est separatus populus Israel, sacerdotes et Levitae a populis terrarum et abominationibus eorum, Chananaei videlicet et Hetthaei et Pherezaei et Iebusaei et Ammonitarum et Moabitarum et Aegyptiorum et Amorraeorum."
,"2":"Tulerunt enim de filiabus eorum sibi et filiis suis et commiscuerunt semen sanctum cum populis terrarum; manus etiam principum et magistratuum fuit in transgressione hac prima '."
,"3":"Cumque audissem sermonem istum, scidi vestimentum meum et pallium et evelli capillos capitis mei et barbae et sedi maerens."
,"4":"Convenerunt autem ad me omnes, qui timebant verba Dei Israel pro transgressione eorum, qui de captivitate venerant; et ego sedebam tristis usque ad sacrificium vespertinum."
,"5":"Et in sacrificio vespertino surrexi de afflictione mea et, scisso vestimento et pallio, curvavi genua mea et expandi manus meas ad Dominum Deum meum."
,"6":"Et dixi: ' Deus meus, confundor et erubesco levare faciem meam ad te, quoniam iniquitates nostrae multiplicatae sunt super caput nostrum, et delicta nostra creverunt usque ad caelum"
,"7":"a diebus patrum nostrorum. Peccavimus graviter usque ad diem hanc, et propter iniquitates nostras traditi sumus, ipsi et reges nostri et sacerdotes nostri, in manum regum terrarum et in gladium et in captivitatem et in rapinam et in confusionem vultus sicut et die hac."
,"8":"Et nunc ad momentum invenimus gratiam apud Dominum Deum nostrum, ut servaret nobis reliquias et figeret nobis tentorium in loco sancto eius et illuminaret oculos nostros Deus noster et daret nobis solacium modicum in servitute nostra."
,"9":"Quia servi sumus, et in servitute nostra non dereliquit nos Deus noster, sed inclinavit super nos misericordiam regum Persarum, ut darent nobis solacium, et erigeretur domus Dei nostri, et instaurarentur ruinae eius, et dedit nobis refugium in Iuda et Ierusalem."
,"10":"Et nunc quid dicemus, Deus noster, post haec? Dereliquimus mandata tua,"
,"11":"quae praecepisti in manu servorum tuorum prophetarum dicens: 'Terra, ad quam vos ingredimini, ut possideatis eam, terra immunda est, iuxta immunditiam populorum terrarum et abominationem eorum, qui repleverunt eam a fine usque ad finem coinquinatione sua."
,"12":"Nunc ergo filias vestras ne detis filiis eorum et filias eorum ne accipiatis filiis vestris et non quaeratis pacem eorum et prosperitatem eorum usque in aeternum, ut confortemini et comedatis, quae bona sunt terrae, et heredes habeatis filios vestros usque in saeculum'."
,"13":"Et post omnia, quae venerunt super nos in operibus nostris pessimis et in delicto nostro magno, quia tu, Deus noster, non iudicasti secundum iniquitates nostras et dedisti nobis salutem, sicut est hodie,"
,"14":"numquid amplius irrita faciemus mandata tua et matrimonia iungemus cum populis abominationum istarum? Numquid iratus es nobis usque ad consummationem, ut non essent reliquiae et salus?"
,"15":"Domine, Deus Israel, tua clementia superstites sumus sicut die hac! Ecce coram te sumus in delicto nostro; non enim stari potest coram te propter hoc '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Dum ergo oraret Esdras et imploraret flens et prostratus ante templum Dei, collectus est ad eum de Israel coetus grandis nimis virorum et mulierum et puerorum; et flevit populus fletu multo."
,"2":"Et respondit Sechenias filius Iehiel de filiis Elam et dixit Esdrae: ' Nos praevaricati sumus in Deum nostrum et duximus uxores alienigenas de populis terrae. Nunc autem spes est in Israel super hoc:"
,"3":"percutiamus foedus cum Domino Deo nostro, ut proiciamus universas uxores et eos, qui de his nati sunt, iuxta voluntatem Domini et eorum, qui timent praeceptum Domini Dei nostri, et secundum legem fiat."
,"4":"Surge, tuum est decernere, nosque erimus tecum; confortare et fac '."
,"5":"Surrexit ergo Esdras et fecit principes sacerdotum et Levitarum et omnem Israel iurare, ut facerent secundum verbum hoc, et iuraverunt."
,"6":"Et surrexit Esdras ante domum Dei et abiit ad cubiculum Iohanan filii Eliasib et pernoctavit ibi; panem non comedit et aquam non bibit, lugebat enim transgressionem eorum, qui venerant de captivitate."
,"7":"Et missa est vox in Iuda et in Ierusalem omnibus filiis transmigrationis, ut congregarentur in Ierusalem;"
,"8":"et omnis, qui non venerit in tribus diebus iuxta consilium principum et seniorum, auferetur universa substantia eius, et ipse abicietur de coetu transmigrationis."
,"9":"Convenerunt igitur omnes viri Iudae et Beniamin in Ierusalem tribus diebus, ipse est mensis nonus vicesimo die mensis, et sedit omnis populus in platea domus Dei, trementes pro peccato et pluviis."
,"10":"Et surrexit Esdras sacerdos et dixit ad eos: ' Vos transgressi estis et duxistis uxores alienigenas, ut adderetis super delictum Israel."
,"11":"Et nunc date confessionem Domino, Deo patrum vestrorum, et facite placitum eius et separamini a populis terrae et ab uxoribus alienigenis '."
,"12":"Et respondit universa multitudo dixitque voce magna: ' Iuxta verbum tuum ad nos, sic fiat."
,"13":"Verumtamen quia populus multus est et tempus pluviae, et non sustinemus stare foris, et opus non est diei unius vel duorum - multi quippe peccavimus in sermone isto -"
,"14":"constituantur principes in universa multitudine; et omnes in civitatibus nostris, qui duxerunt uxores alienigenas, veniant in temporibus statutis, et cum his seniores per civitatem et civitatem et iudices eius, donec avertatur ira Dei nostri a nobis super peccato hoc '."
,"15":"Tantummodo Ionathan filius Asael et Iaasia filius Thecue steterunt contra hoc, et Mosollam et Sabethai Levites adiuverunt eos."
,"16":"Feceruntque sic filii transmigrationis. Et elegit Esdras sacerdos viros principes familiarum iuxta domus patrum eorum, omnes autem per nomina eorum, et sederunt in die primo mensis decimi, ut quaererent rem."
,"17":"Et absolverunt causam cunctorum, qui duxerant uxores alienigenas, intra diem primam mensis primi."
,"18":"Et inventi sunt de filiis sacerdotum, qui duxerant uxores alienigenas. De filiis Iesua filii Iosedec et de fratribus eius: Maasia et Eliezer et Iarib et Godolia;"
,"19":"et dederunt manus suas, ut eicerent uxores suas et pro delicto suo arietem offerrent."
,"20":"Et de filiis Emmer: Hanani et Zabadia."
,"21":"Et de filiis Harim: Maasia et Elia et Semeia et Iehiel et Ozias."
,"22":"Et de filiis Phassur: Elioenai, Maasia, Ismael, Nathanael, Iozabad et Elasa."
,"23":"Et de filiis Levitarum: Iozabad et Semei et Celaia, ipse est Celita, Phethahia, Iuda et Eliezer."
,"24":"Et de cantoribus: Eliasib. Et de ianitoribus: Sellum et Telem et Uri."
,"25":"Et ex Israel de filiis Pharos: Remia et Iezia et Melchia et Miamin et Eleazar et Melchia et Banaia."
,"26":"Et de filiis Elam: Matthania, Zacharias et Iehiel et Abdi et Ierimoth et Elia."
,"27":"Et de filiis Zethua: Elioenai, Eliasib, Matthania et Ierimoth et Zabad et Aziza."
,"28":"Et de filiis Bebai: Iohanan, Hanania, Zabbai, Athalai."
,"29":"Et de filiis Beguai: Mosollam et Melluch et Adaia, Iasub et Saal et Ramoth."
,"30":"Et de filiis Phahathmoab: Edna et Chalal, Banaias et Maasias, Matthanias, Beseleel, Bennui et Manasse."
,"31":"Et de filiis Harim: Eliezer, Iesia, Melchias, Semeias, Simeon,"
,"32":"Beniamin, Melluch, Samarias."
,"33":"Et de filiis Hasum: Matthanai, Matthatha, Zabad, Eliphalet, Iermai, Manasse, Semei."
,"34":"De filiis Bani: Maaddi, Amram et Ioel,"
,"35":"Banaia et Badaias, Cheliau,"
,"36":"Vania, Meremoth et Eliasib,"
,"37":"Matthanias, Matthanai et Iasi."
,"38":"Et de filiis Bennui: Semei"
,"39":"et Selemias et Nathan et Adaias"
,"40":"et Mechnedebai, Sisai, Sarai,"
,"41":"Azareel et Selemias, Samaria,"
,"42":"Sellum, Amaria, Ioseph."
,"43":"De filiis Nabo: Iehiel, Matthathias, Zabad, Zabina, Ieddu et Ioel et Banaia."
,"44":"Omnes hi acceperant uxores alienigenas et dimiserunt uxores et filios."
}`)

}
func LA_NVBSE_LoadVHETChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1a":"Anno secundo, regnante Artaxerxe rege magno, prima die mensis Nisan vidit somnium Mardochaeus filius Iair filii Semei filii Cis de tribu Beniamin,"
,"1b":"vir magnus, qui ministrabat in aula regia."
,"1c":"Et hoc eius somnium fuit. Apparuerunt voces et tumultus et tonitrua et terraemotus et conturbatio magna super terram."
,"1d":"Et ecce duo dracones magni parati prodierunt uterque luctari;"
,"1e":"et facta est illorum magna pugna, et dominabantur, et congregatae sunt nationes"
,"1f":"in die tenebroso et malo, et fuit perturbatio magna in habitantibus super terram."
,"1g":"Et timuerunt perditionem"
,"1h":"clamaveruntque ad Deum. Et a voce clamoris eorum factus est fons parvus, qui crevit in fluvium maximum et in aquas plurimas redundavit."
,"1i":"Lux et sol ortus est, et humiles exaltati sunt et devoraverunt inclitos."
,"1k":"Quod cum vidisset somnium Mardochaeus et surrexisset de strato, cogitabat quid Deus facere vellet; et fixum habebat in animo, quousque revelaretur."
,"1":"Et fuit in diebus Asueri, qui regnavit ab India usque Aethiopiam super centum viginti septem provincias,"
,"2":"quando sedit in solio regni sui in castris Susan,"
,"3":"tertio igitur anno imperii sui, fecit grande convivium cunctis principibus et pueris suis, fortissimis Persarum et Medorum, inclitis et praefectis provinciarum coram se,"
,"4":"ut ostenderet divitias gloriae regni sui ac splendorem atque iactantiam magnitudinis suae multo tempore, centum videlicet et octoginta diebus."
,"5":"Cumque implerentur dies convivii, invitavit omnem populum, qui inventus est in Susan, a maximo usque ad minimum; et septem diebus iussit convivium praeparari in vestibulo horti palatii regis."
,"6":"Et pendebant ex omni parte tentoria lintea et carbasina ac hyacinthina sustentata funibus byssinis atque purpureis, qui argenteis circulis inserti erant et columnis marmoreis fulciebantur; lectuli quoque aurei et argentei dispositi erant super pavimentum smaragdino et pario stratum lapide aliisque varii coloris."
,"7":"Bibebant autem, qui invitati erant, aureis poculis, aliis atque aliis; vinum quoque, ut magnificentia regia dignum erat, abundans et praecipuum ponebatur."
,"8":"Nec erat qui cogeret ad bibendum, quoniam sic rex statuerat omnibus praepositis domus suae, ut facerent secundum uniuscuiusque voluntatem."
,"9":"Vasthi quoque regina fecit convivium feminarum in palatio regio, ubi rex Asuerus manere consueverat."
,"10":"Itaque die septimo, cum rex esset hilarior potione meri, praecepit Mauman et Bazatha et Harbona et Bagatha et Abgatha et Zethar et Charchas, septem eunuchis, qui in conspectu eius ministrabant,"
,"11":"ut introducerent reginam Vasthi coram rege, posito super caput eius diademate regni, ut ostenderet cunctis populis et principibus pulchritudinem illius; erat enim pulchra valde."
,"12":"Quae renuit et ad regis imperium, quod per eunuchos mandaverat, venire contempsit; unde iratus rex et nimio furore succensus"
,"13":"interrogavit sapientes, qui tempora noverant, et illorum faciebat cuncta consilio scientium leges ac iura maiorum -"
,"14":"erant autem ei proximi Charsena et Sethar et Admatha et Tharsis et Mares et Marsana et Mamuchan, septem duces Persarum atque Medorum, qui videbant faciem regis et primi sedebant in regno C:"
,"15":"' Secundum legem quid oportet fieri Vasthi reginae, quae Asueri regis imperium, quod per eunuchos mandaverat, facere noluit? '."
,"16":"Responditque Mamuchan, audiente rege atque principibus: ' Non solum regem laesit regina Vasthi, sed et omnes principes et populos, qui sunt in cunctis provinciis regis Asueri."
,"17":"Egredietur enim sermo reginae ad omnes mulieres, ut contemnant viros suos et dicant: 'Rex Asuerus iussit, ut regina Vasthi intraret ad eum, et illa noluit'."
,"18":"Atque hac ipsa die dicent omnes principum coniuges Persarum atque Medorum quem audierint sermonem reginae principibus regis; unde despectio et indignatio."
,"19":"Si tibi, rex, placet, egrediatur edictum a facie tua et scribatur inter leges Persarum atque Medorum, quas immutari illicitum est, ut nequaquam ultra Vasthi ingrediatur ad regem, sed regnum illius altera, quae melior illa est, accipiat."
,"20":"Et hoc in omne, quod latissimum est, provinciarum tuarum divulgetur imperium, et cunctae uxores, tam maiorum quam minorum, deferent maritis suis honorem '."
,"21":"Placuit consilium eius regi et principibus, fecitque rex iuxta consilium Mamuchan."
,"22":"Et misit epistulas ad universas provincias regni sui, ut quaeque gens audire et legere poterat, diversis linguis et litteris, esse viros principes ac maiores in domibus suis et subditas habere omnes mulieres, quae essent cum eis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"His ita gestis, postquam regis Asueri deferbuerat indignatio, recordatus est Vasthi, et quae fecisset vel quae passa esset."
,"2":"Dixeruntque pueri regis ac ministri eius: ' Quaerantur regi puellae virgines ac speciosae,"
,"3":"et constituantur, qui considerent per universas provincias puellas speciosas et virgines et adducant eas ad civitatem Susan et tradant in domum feminarum sub manu Egei eunuchi, qui est praepositus et custos mulierum regiarum; et accipiant mundum muliebrem."
,"4":"Et, quaecumque inter omnes oculis regis placuerit, ipsa regnet pro Vasthi '. Placuit sermo regi; et ita, ut suggesserant, iussit fieri."
,"5":"Erat vir Iudaeus in Susan civitate vocabulo Mardochaeus filius Iair filii Semei filii Cis de tribu Beniamin,"
,"6":"qui translatus fuerat de Ierusalem cum captivis, qui ducti fuerant cum Iechonia rege Iudae, quem Nabuchodonosor rex Babylonis transtulerat."
,"7":"Qui fuit nutricius filiae patrui sui Edissae, quae altero nomine Esther vocabatur et utrumque parentem amiserat: pulchra aspectu et decora facie. Mortuisque patre eius ac matre, Mardochaeus sibi eam adoptavit in filiam."
,"8":"Et factum est, cum percrebruisset regis imperium, et iuxta mandatum illius multae virgines pulchrae adducerentur Susan et Egeo traderentur, Esther quoque in domum regis in manus Egei custodis feminarum tradita est."
,"9":"Quae placuit ei et invenit gratiam in conspectu illius; et acceleravit mundum muliebrem et tradidit ei partes suas et septem puellas speciosissimas de domo regis, et tam ipsam quam pedisequas eius transtulit in optimam partem domus feminarum."
,"10":"Quae non indicaverat ei populum et cognationem suam; Mardochaeus enim praeceperat, ut de hac re omnino reticeret."
,"11":"Qui deambulabat cotidie ante vestibulum domus, in qua electae virgines servabantur, curam agens salutis Esther et scire volens quid ei accideret."
,"12":"Cum autem venisset tempus singularum per ordinem puellarum, ut intrarent ad regem, expletis omnibus, quae ad cultum muliebrem pertinebant, per menses duodecim; ita dumtaxat, ut sex mensibus oleo ungerentur myrrhino et aliis sex feminarum pigmentis et aromatibus uterentur,"
,"13":"ingredientesque ad regem, quidquid postulassent, accipiebant, ut portarent secum de triclinio feminarum ad regis cubiculum."
,"14":"Et, quae intraverat vespere, mane iterum in domum feminarum deducebatur, sub manu Sasagazi eunuchi, qui concubinis praesidebat. Nec habebat potestatem ad regem ultra redeundi, nisi voluisset rex et eam venire iussisset ex nomine."
,"15":"Evoluto autem tempore per ordinem, instabat dies, quo Esther filia Abihail patrui Mardochaei, quam sibi adoptaverat in filiam, intrare deberet ad regem. Quae non quaesivit quidquam, nisi quae voluit Egeus eunuchus custos feminarum, et omnium oculis gratiosa et amabilis videbatur."
,"16":"Ducta est itaque ad cubiculum regis Asueri mense decimo, qui vocatur Tebeth, septimo anno regni eius."
,"17":"Et amavit eam rex plus quam omnes mulieres; habuitque gratiam et favorem coram eo super omnes virgines, et posuit diadema regni in capite eius fecitque eam regnare in loco Vasthi."
,"18":"Et iussit convivium praeparari magnificum cunctis principibus et servis suis, convivium Esther; et dedit remissionem tributi universis provinciis ac dona largitus est iuxta magnificentiam principalem."
,"19":"Mardochaeus autem manebat ad regis ianuam,"
,"20":"necdum prodiderat Esther cognationem et populum suum iuxta mandatum eius; quidquid enim ille praecipiebat, observabat Esther, ut eo tempore solita erat, quo eam parvulam nutriebat."
,"21":"Eo igitur tempore, quo Mardochaeus ad regis ianuam morabatur, irati sunt Bagathan et Thares, duo eunuchi regis, qui ianitores erant volueruntque in regem mittere manus."
,"22":"Quod Mardochaeum non latuit; statimque nuntiavit reginae Esther, et illa regi ex nomine Mardochaei."
,"23":"Quaesitum est et inventum, et appensus uterque eorum in patibulo; mandatumque est libro annalium coram rege."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Post haec rex Asuerus exaltavit Aman filium Amadathi, qui erat de stirpe Agag, et posuit solium eius super omnes principes, quos habebat."
,"2":"Cunctique servi regis, qui in foribus palatii versabantur, flectebant genua et adorabant Aman; sic enim praeceperat rex pro illo. Solus Mardochaeus non flectebat genu neque adorabat eum."
,"3":"Cui dixerunt pueri regis, qui ad fores palatii praesidebant: ' Cur non observas mandatum regis? '."
,"4":"Cumque hoc crebrius dicerent, et ille nollet audire, nuntiaverunt Aman scire cupientes utrum perseveraret in sententia; dixerat enim eis se esse Iudaeum."
,"5":"Cumque Aman experimento probasset quod Mardochaeus non sibi flecteret genu nec se adoraret, iratus est valde"
,"6":"et pro nihilo duxit in unum Mardochaeum mittere manus suas - audierat enim quod esset gentis Iudaeae - magisque voluit omnem Iudaeorum, qui erant in regno Asueri, perdere nationem."
,"7":"Mense primo, cuius vocabulum est Nisan, anno duodecimo regni Asueri, missa est in urnam sors, quae dicitur Phur, coram Aman, quo die et quo mense gens Iudaeorum deberet interfici; et exivit dies tertia decima mensis duodecimi, qui vocatur Adar."
,"8":"Dixitque Aman regi Asuero: ' Est populus per omnes provincias regni tui dispersus, segregatus inter populos alienisque utens legibus, quas ceteri non cognoscunt, insuper et regis scita contemnens; non expedit regi, ut det illis requiem."
,"9":"Si tibi placet, scriptis decerne, ut pereat, et decem milia talentorum argenti appendam arcariis gazae tuae '."
,"10":"Tulit ergo rex anulum, quo utebatur, de manu sua et dedit eum Aman filio Amadathi de progenie Agag, hosti Iudaeorum."
,"11":"Dixitque ad eum: ' Argentum, quod polliceris, tuum sit; de populo age, quod tibi placet '."
,"12":"Vocatique sunt scribae regis mense primo, tertia decima die eius, et scriptum est, ut iusserat Aman, ad omnes satrapas regis et duces provinciarum et principes diversarum gentium, ut quaeque gens legere poterat et audire pro varietate linguarum, ex nomine regis Asueri; et litterae ipsius signatae anulo."
,"13":"Missae sunt epistulae per cursores ad universas provincias regis, ut perderent, occiderent atque delerent omnes Iudaeos, a puero usque ad senem, parvulos et mulieres uno die, hoc est tertio decimo mensis duodecimi, qui vocatur Adar, et bona eorum diriperent."
,"13a":"Epistulae autem hoc exemplar fuit: ' Rex magnus Artaxerxes centum viginti septem ab India usque Aethiopiam provinciarum satrapis et ducibus, qui eius imperio subiecti sunt, haec scribit: "
,"13b":"Cum plurimis gentibus imperarem et universum orbem meae dicioni subiugassem, volui nequaquam abuti potentiae magnitudine, sed semper clementer et leniter agens gubernare subiectorum vitam absque ullo terrore, regnumque quietum et usque ad fines pervium praestans, optatam cunctis mortalibus pacem renovare."
,"13c":"Quaerente autem me a consiliariis meis, quomodo hoc posset impleri, unus qui prudentia, bona voluntate et fide stabili ceteros praecellit et est post regem secundus, Aman nomine,"
,"13d":"indicavit mihi in totius orbis terrarum tribubus populum hostilem esse dispersum, qui, legibus suis contra omnium gentium faciens consuetudinem, regum iussa in perpetuum contemnat, ne consistat concordia nationum a nobis consolidata."
,"13e":"Quod cum didicissemus, videntes unam hanc gentem rebellem adversus omne hominum genus perversis uti legibus nostrisque negotiis contraire, pessima conficere et regni impedire pacem,"
,"13f":"iussimus, ut quoscumque Aman, qui negotiis publicis praepositus est et quem patris loco colimus, per litteras monstraverit, cum coniugibus ac liberis radicitus deleantur inimicorum gladiis, nullusque eorum misereatur, quarta decima die duodecimi mensis Adar anni praesentis;"
,"13g":"ut, qui iam olim sunt nefarii homines, uno die violenter ad inferos descendentes stabiles in posterum et quietas reddant nobis plene res publicas."
,"13h":"Qui autem celaverit genus eorum, inhabitabilis erit non solum inter homines, sed nec inter aves, et igne sancto comburetur; et substantia eorum in regnum conferetur. Valete '."
,"14":"Exemplar autem epistularum ut lex in omnibus provinciis promulgandum erat, ut scirent omnes populi et pararent se ad praedictam diem."
,"15":"Festinabant cursores, qui missi erant, regis imperium explere; statimque in Susan pependit edictum, rege et Aman celebrante convivium, dum civitas ipsa esset conturbata."
,"15a":"Et convivium fecerunt omnes gentes; rex autem et Aman, cum introisset regiam, cum amicis luxuriabatur."
,"15b":"Ubicumque igitur proponebatur exemplum epistulae, ploratio et luctus ingens fiebat apud omnes Iudaeos."
,"15c":"Et invocabant Iudaei Deum patrum suorum et dicebant:"
,"15d":"' Domine Deus, tu solus Deus in caelo sursum, et non est alius Deus praeter te."
,"15e":"Si enim fecissemus legem tuam et praecepta, habitassemus cum securitate et pace per omne tempus vitae nostrae."
,"15f":"Nunc autem, quoniam non fecimus praecepta tua, venit super nos omnis tribulatio ista."
,"15g":"Iustus es et clemens et excelsus et magnus, Domine, et omnes viae tuae iudicia."
,"15h":"Et nunc, Domine, non des filios tuos in captivitatem,neque uxores nostras in violationem neque in perditionem, qui factus es nobis propitius ab Aegypto usque nunc."
,"15i":"Miserere principali tuae parti,et non tradas in infamiam hereditatem tuam, ut hostes dominentur nostri '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Cum comperisset Mardochaeus omnia, quae acciderant, scidit vestimenta sua et indutus est sacco spargens cinerem capiti. Et in platea mediae civitatis voce magna et amara clamabat"
,"2":"usque ad fores palatii gradiens; non enim erat licitum indutum sacco aulam regis intrare."
,"3":"In omnibus quoque provinciis, quocumque edictum et dogma regis pervenerat, planctus ingens erat apud Iudaeos, ieiunium, ululatus et fletus, sacco et cinere multis pro strato utentibus."
,"4":"Ingressae sunt autem puellae Esther et eunuchi nuntiaveruntque ei. Quod audiens consternata est valde et misit vestem, ut, ablato sacco, induerent eum; quam accipere noluit."
,"5":"Accitoque Athach eunucho, quem rex ministrum ei dederat, praecepit ei, ut iret ad Mardochaeum et disceret ab eo cur hoc faceret."
,"6":"Egressusque Athach ivit ad Mardochaeum stantem in platea civitatis ante ostium palatii."
,"7":"Qui indicavit ei omnia, quae ei acciderant, quantum Aman promisisset, ut in thesauros regis pro Iudaeorum nece inferret argentum."
,"8":"Exemplar quoque edicti, quod pendebat in Susan ad perdendum eos, dedit ei, ut reginae ostenderet et moneret eam, ut intraret ad regem et deprecaretur eum et rogaret pro populo suo."
,"8a":"' Memor, inquit, dierum humilitatis tuae, quando nutrita sis in manu mea, quia Aman secundus a rege locutus est contra nos in mortem. Et tu, invoca Dominum et loquere regi pro nobis et libera nos de morte '."
,"9":"Regressus Athach nuntiavit Esther omnia, quae Mardochaeus dixerat."
,"10":"Quae respondit ei et iussit, ut diceret Mardochaeo:"
,"11":"' Omnes servi regis et cunctae, quae sub dicione eius sunt, norunt provinciae, quod cuique sive viro sive mulieri, qui non vocatus interius atrium regis intraverit, una lex sit, ut statim interficiatur, nisi forte rex auream virgam ad eum tetenderit, ut possit vivere; ego autem triginta iam diebus non sum vocata ad regem '."
,"12":"Quod cum audisset Mardochaeus,"
,"13":"rursum mandavit Esther dicens: ' Ne putes quod animam tuam tantum liberes, quia in domo regis es, prae cunctis Iudaeis."
,"14":"Si enim nunc silueris, aliunde Iudaeis liberatio et salvatio exsurget, et tu et domus patris tui peribitis; et quis novit utrum idcirco ad regnum veneris, ut in tali tempore parareris? '."
,"15":"Rursumque Esther haec Mardochaeo verba mandavit:"
,"16":"' Vade et congrega omnes Iudaeos, qui in Susan reperiuntur; et ieiunate pro me. Non comedatis et non bibatis tribus diebus et tribus noctibus, et ego cum ancillis meis similiter ieiunabo; et tunc ingrediar ad regem contra legem faciens; si pereo, pereo '."
,"17":"Ivit itaque Mardochaeus et fecit omnia, quae ei Esther mandaverat."
,"17a":"Mardochaeus autem scidit vestimenta sua et substravit cilicium et cecidit super faciem suam in terram, et seniores populi, a mane usque ad vesperam"
,"17b":"et dixit: ' Deus Abraham et Deus Isaac et Deus Iacob, benedictus es."
,"17c":"Domine, Domine, rex omnipotens, in dicione enim tua cuncta sunt posita, et non est qui possit tuae resistere voluntati, si decreveris salvare Israel."
,"17d":"Tu enim fecisti caelum et terram,et quidquid mirabile caeli ambitu continetur;"
,"17e":"Dominus omnium es, nec est qui resistat maiestati tuae."
,"17f":"Tu scis, Domine, quia libenter adorarem,plantas pedum Aman pro salute Israel;"
,"17g":"hoc autem non feci, ne gloriam hominis ponerem super gloriam Dei mei, et alium non adorabo nisi te, Domine, Deus meus."
,"17h":"Et non facio ea in arrogantia,neque in gloriae cupiditate, Domine. Appare, Domine; manifestare, Domine!"
,"17i":"Et nunc, Domine rex, Deus Abraham et Deus Isaac et Deus Iacob, parce populo tuo, quia volunt nos inimici nostri perdere,et delere hereditatem tuam."
,"17k":"Ne despicias partem tuam, quam redemisti tibi de terra Aegypti."
,"17l":"Exaudi deprecationem meam,et propitius esto sorti tuae; et converte luctum nostrum in gaudium, ut viventes laudemus nomen tuum, Domine, et ne claudas ora te canentium '."
,"17m":"Omnis quoque Israel ex totis viribus clamavit ad Dominum, eo quod eis certa mors impenderet."
,"17n":"Esther quoque regina confugit ad Dominum pavens periculum mortis, quod imminebat."
,"17o":"Cumque deposuisset vestes gloriae, suscepit indumenta luctus et pro unguentis superbiae implevit caput suum cinere et corpus suum humiliavit ieiuniis valde."
,"17p":"Et cecidit super terram cum ancillis suis a mane usque ad vesperam et dixit:"
,"17q":"' Deus Abraham et Deus Isaac et Deus Iacob, benedictus es. Suffraga mihi soli,et non habenti defensorem praeter te, Domine,"
,"17r":"quoniam periculum in manu mea est."
,"17s":"Ego audivi ex libris maiorum meorum, Domine, quoniam tu Noe in aqua diluvii conservasti."
,"17t":"Ego audivi ex libris maiorum meorum, Domine, quoniam tu Abrahae in trecentis et decem octo viris,novem reges tradidisti."
,"17u":"Ego audivi ex libris maiorum meorum, Domine, quoniam tu Ionam de ventre ceti liberasti."
,"17v":"Ego audivi ex libris maiorum meorum, Domine, quoniam tu Ananiam, Azariam et Misael de camino ignis liberasti."
,"17x":"Ego audivi ex libris maiorum meorum, Domine, quoniam tu Daniel de lacu leonum eruisti."
,"17y":"Ego audivi ex libris maiorum meorum, Domine, quoniam tu Ezechiae, regi Iudaeorum, morte damnato et oranti pro vita misertus es,et donasti ei vitae annos quindecim. "
,"17z":"Ego audivi ex libris maiorum meorum, Domine, quoniam tu Annae petenti in desiderio animae,filii generationem donasti."
,"17aa":"Ego audivi ex libris maiorum meorum, Domine, quoniam tu omnes complacentes tibi liberas, Domine, usque in finem."
,"17bb":"Et nunc adiuva me solitariam,et neminem habentem nisi te, Domine, Deus meus."
,"17cc":"Tu nosti,quoniam abominata est ancilla tua concubitum incircumcisorum."
,"17dd":"Deus, tu nosti,quoniam non manducavi de mensa exsecrationum,et vinum libationum eorum non bibi."
,"17ee":"Tu nosti,quoniam a die translationis meae,non sum laetata, Domine, nisi in te solo."
,"17ff":"Tu scis, Deus, quoniam, ex quo vestimentum hoc super caput meum est, exsecror illud tamquam pannum menstruatae,et non indui illud in die bona."
,"17gg":"Et nunc subveni orphanae mihi,et verbum concinnum da in os meum in conspectu leonis,et gratam me fac coram eo,et converte cor eius in odium oppugnantis nos, in perditionem eius et eorum, qui consentiunt ei."
,"17hh":"Nos autem libera de manu inimicorum nostrorum; converte luctum nostrum in laetitiam,et dolores nostros in sanitatem."
,"17ii":"Surgentes autem supra partem tuam, Deus, fac in exemplum."
,"17kk":"Appare, Domine; manifestare, Domine! '."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et factum est die tertio, induta Esther regalibus vestimentis ste tit in atrio domus regiae, quod erat interius contra basilicam regis. At ille sedebat super solium suum in consistorio palatii contra ostium domus."
,"2":"Et factum est, cum vidisset Esther reginam stantem, placuit oculis eius, et extendit contra eam virgam auream, quam tenebat manu; quae accedens tetigit summitatem virgae eius."
,"2a":"Cumque regio fulgeret habitu et invocasset omnium rectorem et salvatorem Deum, assumpsit duas famulas"
,"2b":"et super unam quidem innitebatur, quasi in deliciis;"
,"2c":"altera autem sequebatur dominam defluentia in humum indumenta sustentans."
,"2d":"Ipsa autem roseo vultu colore perfusa et gratis ac nitentibus oculis tristem celabat animum et mortis timore contractum."
,"2e":"Ingressa igitur cuncta per ordinem ostia, stetit in aula interiore contra regem, ubi ille residebat super solium regni sui indutus vestibus regiis auroque fulgens et pretiosis lapidibus; eratque terribilis aspectu, et virga aurea in manu eius."
,"2f":"Cumque elevasset faciem, vidit eam sicut taurus in impetu irae suae et cogitans eam perdere clamavit ambiguus: ' Quis ausus est introire in aulam non vocatus? '. Et regina corruit et, in pallorem colore mutato, lassa se reclinavit super caput ancillulae, quae antecedebat."
,"2g":"Convertitque Iudaeorum Deus et universae creaturae Dominus spiritum regis in mansuetudinem, et festinus ac metuens exilivit de solio; et sustentans eam ulnis suis, donec rediret ad se, verbis pacificis ei blandiebatur:"
,"2h":"' Quid habes, Esther regina, soror mea et consors regni? Ego sum frater tuus, noli metuere."
,"2i":"Non morieris; non enim pro te, sed pro omnibus haec lex constituta est."
,"2k":"Accede! '."
,"2l":"Et elevans auream virgam posuit super collum eius et osculatus est eam et ait: ' Loquere mihi '."
,"2m":"Quae respondit: ' Vidi te, domine, quasi angelum Dei, et conturbatum est cor meum prae timore gloriae tuae;"
,"2n":"valde enim mirabilis es, domine, et facies tua plena est gratiarum '."
,"2o":"Cumque loqueretur, rursus corruit et paene exanimata est."
,"2p":"Rex autem turbabatur, et omnes ministri eius."
,"3":"Dixitque ad eam rex: ' Quid vis, Esther regina? Quae est petitio tua? Etiamsi dimidiam partem regni petieris, dabitur tibi '."
,"4":"At illa respondit: ' Si regi placet, obsecro, ut venias ad me hodie et Aman tecum ad convivium, quod paravi '."
,"5":"Statimque rex: ' Vocate, inquit, cito Aman, ut fiat verbum Esther '. Venerunt itaque rex et Aman ad convivium, quod eis regina paraverat. "
,"6":"Dixitque ei rex, postquam vinum biberat: ' Quid petis, ut detur tibi, et pro qua re postulas? Etiamsi dimidiam partem regni mei petieris, impetrabis '."
,"7":"Cui respondit Esther: ' Petitio mea et preces:"
,"8":"Si inveni in conspectu regis gratiam, et si regi placet, ut det mihi, quod postulo, et meam impleat petitionem, veniat rex et Aman ad convivium, quod parabo eis, et cras faciam secundum verbum regis '."
,"9":"Egressus est itaque illo die Aman laetus et alacer corde. Cumque vidisset Mardochaeum sedentem in foribus palatii, et non solum non assurrexisse sibi, sed nec motum quidem de loco sessionis suae, indignatus est valde."
,"10":"Et, dissimulata ira, reversus in domum suam convocavit ad se amicos suos et Zares uxorem suam"
,"11":"et exposuit illis magnitudinem divitiarum suarum filiorumque turbam, et quanta eum gloria super omnes principes et servos suos rex elevasset."
,"12":"Et post haec ait: ' Regina quoque Esther nullum alium vocavit ad convivium cum rege praeter me; apud quam etiam cras cum rege pransurus sum."
,"13":"Et, cum omnia haec habeam, nihil me habere puto, quamdiu videro Mardochaeum Iudaeum sedentem in foribus regis '."
,"14":"Responderuntque ei Zares uxor eius et ceteri amici: ' Iube parari excelsam trabem habentem altitudinis quinquaginta cubitos et dic mane regi, ut appendatur super eam Mardochaeus; et sic ibis cum rege laetus ad convivium '. Placuit ei consilium et iussit excelsam parari trabem."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Noctem illam duxit rex insomnem iussitque afferri sibi librum memorialium, annales priorum temporum. Quae cum illo praesente legerentur,"
,"2":"ventum est ad eum locum, ubi scriptum erat quomodo nuntiasset Mardochaeus insidias Bagathan et Thares duorum eunuchorum ianitorum, qui voluerant manus mittere in regem Asuerum."
,"3":"Quod cum audisset rex, ait: ' Quid pro hac fide honoris ac praemii Mardochaeus consecutus est? '. Dixeruntque ei servi illius ac ministri: ' Nihil omnino mercedis accepit '."
,"4":"Statimque rex: ' Quis est, inquit, in atrio? '. Aman quippe exterius atrium domus regiae intraverat, ut suggereret regi, ut iuberet Mardochaeum suspendi in patibulo, quod ei fuerat praeparatum."
,"5":"Responderunt pueri: ' Ecce Aman stat in atrio '. Dixitque rex: ' Ingrediatur '."
,"6":"Cumque esset ingressus, ait illi: ' Quid debet fieri viro, quem rex honorare desiderat? '. Cogitans autem in corde suo Aman et reputans quod nullum alium rex nisi se vellet honorare"
,"7":"respondit: ' Homo, quem rex honorare cupit,"
,"8":"debet indui vestibus regiis, quibus rex indutus erat, et imponi super equum, qui de sella regis est, et acceperit regium diadema super caput suum;"
,"9":"et primus de regiis principibus nobilissimis induat eum et teneat equum eius et per plateam civitatis incedens clamet et dicat: 'Sic honorabitur quemcumque voluerit rex honorare' '."
,"10":"Dixitque ei rex: ' Festina et, sumpta stola et equo, fac, ut locutus es, Mardochaeo Iudaeo, qui sedet in foribus palatii; cave, ne quidquam de his, quae locutus es, praetermittas '."
,"11":"Tulit itaque Aman stolam et equum; indutumque Mardochaeum et impositum equo praecedebat in platea civitatis atque clamabat: ' Hoc honore condignus est quemcumque rex voluerit honorare '."
,"12":"Reversusque est Mardochaeus ad ianuam palatii; et Aman festinavit ire in domum suam lugens et operto capite."
,"13":"Narravitque Zares uxori suae et amicis omnia, quae evenissent sibi; cui responderunt sapientes, quos habebat in consilio, et uxor eius: ' Si de semine Iudaeorum est Mardochaeus, ante quem cadere coepisti, non poteris praevalere contra eum, sed cades in conspectu eius '."
,"14":"Adhuc illis loquentibus, venerunt eunuchi regis et cito eum ad convivium, quod regina paraverat, pergere compulerunt."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Intravit itaque rex et Aman, ut biberent cum regina."
,"2":"Dixitque ei rex etiam in secundo die, postquam vino incaluerat: ' Quae est petitio tua, Esther, ut detur tibi, et quid vis fieri? Etiamsi dimidiam regni mei partem petieris, impetrabis '."
,"3":"Ad quem illa respondit: ' Si inveni gratiam in oculis tuis, o rex, et si tibi placet, dona mihi animam meam, pro qua rogo, et populum meum, pro quo obsecro."
,"4":"Traditi enim sumus, ego et populus meus, ut conteramur, iugulemur et pereamus. Atque utinam in servos et famulas venderemur: tacuissem, quia tribulatio haec non esset digna conturbare regem '."
,"5":"Respondensque rex Asuerus ait: ' Quis est iste et ubi est, ut haec audeat facere? '."
,"6":"Dixit Esther: ' Hostis et inimicus noster pessimus iste est Aman '. Quod ille audiens ilico obstupuit coram rege ac regina."
,"7":"Rex autem surrexit iratus et de loco convivii intravit in hortum palatii. Aman quoque surrexit, ut rogaret Esther reginam pro anima sua; intellexit enim a rege sibi decretum esse malum."
,"8":"Qui cum reversus esset de horto et intrasset convivii locum, repperit Aman super lectulum corruisse, in quo iacebat Esther, et ait: ' Etiam reginam vult opprimere, me praesente, in domo mea? '. Necdum verbum de ore regis exierat, et statim operuerunt faciem eius."
,"9":"Dixitque Harbona, unus de eunuchis, qui stabant in ministerio regis: ' En etiam lignum, quod paraverat Mardochaeo, qui locutus est bonum pro rege, stat in domo Aman habens altitudinis quinquaginta cubitos '. Cui dixit rex: ' Appendite eum in eo '."
,"10":"Suspensus est itaque Aman in patibulo, quod paraverat Mardochaeo; et regis ira quievit."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Die illo dedit rex Asuerus Esther reginae domum Aman adversarii Iudaeorum, et Mardochaeus ingressus est ante faciem regis; confessa est enim ei Esther quid esset sibi."
,"2":"Tulitque rex anulum suum, quem ab Aman recipi iusserat, et tradidit Mardochaeo; Esther autem constituit Mardochaeum super domum Aman."
,"3":"Et adiecit Esther loqui coram rege et procidit ad pedes eius flevitque et locuta ad eum oravit, ut malitiam Aman Agagitae et machinationes eius pessimas, quas excogitaverat contra Iudaeos, iuberet irritas fieri."
,"4":"At ille ex more sceptrum aureum protendit manu; illaque consurgens stetit ante eum"
,"5":"et ait: ' Si placet regi, et si inveni gratiam coram eo, et deprecatio mea non ei videtur esse contraria, et accepta sum in oculis eius, obsecro, ut novis epistulis veteres litterae Aman filii Amadathi, Agagitae, insidiatoris et hostis Iudaeorum, quibus eos in cunctis regis provinciis perire praeceperat, corrigantur."
,"6":"Quomodo enim potero sustinere malum, quod passurus est populus meus, et interitum cognationis meae? '."
,"7":"Responditque rex Asuerus Esther reginae et Mardochaeo Iudaeo: ' Domum Aman concessi Esther et ipsum iussi appendi in patibulo, quia ausus est manum in Iudaeos mittere."
,"8":"Scribite ergo Iudaeis sicut vobis placet, ex regis nomine, signantes litteras anulo meo, quia epistulae ex regis nomine scriptae et illius anulo signatae non possunt immutari '."
,"9":"Accitisque scribis regis - erat autem tempus tertii mensis, qui appellatur Sivan, vicesima et tertia illius die - scriptae sunt epistulae, ut Mardochaeus voluerat, ad Iudaeos et ad satrapas procuratoresque et principes, qui centum viginti septem provinciis ab India usque ad Aethiopiam praesidebant, provinciae atque provinciae, populo et populo, iuxta linguas et litteras suas, et Iudaeis iuxta linguam et litteras suas."
,"10":"Ipsaeque epistulae, quae ex regis nomine mittebantur, anulo ipsius obsignatae sunt et missae per veredarios electis equis regiis discurrentes."
,"11":"Quibus permisit rex Iudaeis in singulis civitatibus, ut in unum congregarentur et starent pro animabus suis et omnes inimicos suos cum coniugibus ac liberis interficerent atque delerent et spolia eorum diriperent;"
,"12":"et constituta est per omnes provincias una ultionis dies, id est tertia decima mensis duodecimi, qui vocatur Adar."
,"12a":"Quomodo praecepit eis uti suis legibus in omni civitate et auxiliari illis et uti inimicis et adversariis ipsorum, sicut vellent, in uno die,"
,"12b":"in omni regno Artaxerxis, quarta decima die duodecimi mensis, id est Adar."
,"12c":"Hoc est exemplar epistulae:"
,"12d":"' Rex magnus Artaxerxes ab India usque Aethiopiam centum viginti septem provinciarum satrapis ac omnibus, qui nostrae iussioni oboediunt, salutem dicit."
,"12e":"Multi nimia bonitate principum et honore, qui in eos collatus est, abusi sunt in superbiam;"
,"12f":"et non solum subiectos regibus nituntur opprimere, sed datam sibi gloriam non ferentes in ipsos, qui dederunt, moliuntur insidias."
,"12g":"Nec contenti sunt gratiarum actionem ex hominibus auferre, sed etiam vaniloquiis eorum, qui bono imperiti sunt inflati, Dei quoque cuncta cernentis et malum odientis arbitrantur se posse fugere sententiam."
,"12h":"Saepe autem et multi in potestate constituti, amicorum, quibus credita erant officia consilio, participes facti sunt effusionis sanguinis innocentis et implicati calamitatibus insanabilibus,"
,"12i":"cum isti perversis et mendacibus cuniculis deciperent sinceram principum benignitatem."
,"12k":"Quae res non tam ex veteribus probatur historiis quam ex his, quae in promptu sunt, intuentibus, quae pestilentia indigne dominantium perpetrata sunt."
,"12l":"Unde in posterum providendum est paci omnium provinciarum."
,"12m":"Si diversa iubeamus, quae sub oculis veniunt, discernimus semper cum clementissima attentione."
,"12n":"Aman enim filius Amadathi, Macedo, alienusque a Persarum sanguine et a pietate nostra multum distans, a nobis hospitio susceptus est."
,"12o":"Et tantam in se expertus humanitatem, quam erga omnem gentem habemus, ut pater noster publice vocaretur et adoraretur ab omnibus post regem semper secundus."
,"12p":"Qui in tantum arrogantiae tumorem sublatus est, ut regno nos privare niteretur et spiritu."
,"12q":"Nam nostrum servatorem et permanentem benefactorem Mardochaeum et irreprehensibilem consortem regni nostri Esther cum omni gente ipsorum tortuosis quibusdam atque fallacibus machinis expetivit in mortem;"
,"12r":"hoc cogitans, ut, illis interfectis, insidiaretur nostrae solitudini et regnum Persarum transferret in Macedonas."
,"12s":"Nos autem a pessimo mortalium Iudaeos neci destinatos in nulla penitus culpa repperimus; sed e contrario iustissimis utentes legibus"
,"12t":"et filios altissimi et maximi semperque viventis Dei, cuius beneficio et nobis et patribus nostris regnum est optima dispositione directum."
,"12u":"Bene igitur facietis non utentes litteris, quas Aman filius Amadathi direxerat."
,"12v":"Pro quo scelere ante portas huius urbis, id est Susan, ipse, qui machinatus est cum omni cognatione sua, pendet in patibulo, Deo, qui gubernat omnia, celeriter ei reddente quod meruit."
,"12x":"Exemplar autem huius edicti, quod nunc mittimus, in cunctis urbibus proponatur, ut liceat Iudaeis uti legibus suis."
,"12y":"Quibus debetis esse adminiculo, ut contra eos, qui in tempore tribulationis eos aggrediuntur, se possint defendere quarta decima die mensis duodecimi, qui vocatur Adar."
,"12z":"Hanc enim diem omnipotens Deus destinatam in interitum electi generis eis vertit in gaudium."
,"12aa":"Unde et vos inter sollemnes vestros dies hanc habetote diem insignem et celebrate eam cum omni laetitia,"
,"12bb":"ut nunc et in posterum illa nobis et benevolis Persis sit salus, illis autem, qui nobis insidiantur, memoria perditionis."
,"12cc":"Omnis autem civitas et provincia, quae noluerit sollemnitatis huius esse particeps, gladio et igne in ira pereat; et sic deleatur, ut non solum hominibus invia, sed etiam bestiis et volatilibus in sempiternum abominabilis relinquatur. Valete '."
,"13":"Exemplar epistulae in forma legis in omnibus provinciis promulgandum erat, ut omnibus populis notum fieret paratos esse Iudaeos in diem illam ad capiendam vindictam de hostibus suis."
,"14":"Egressique sunt veredarii celeres nuntios perferentes, et edictum regis pependit in Susan."
,"15":"Mardochaeus autem de palatio et de conspectu regis egrediens fulgebat vestibus regiis, hyacinthinis videlicet et albis, coronam magnam auream portans in capite et amictus pallio serico atque purpureo; omnisque civitas exsultavit atque laetata est."
,"16":"Iudaeis autem nova lux oriri visa est, gaudium, honor et tripudium."
,"17":"Apud omnes populos, urbes atque provincias, quocumque regis iussa veniebant, Iudaeis fuit exsultatio, epulae atque convivia et festus dies, in tantum ut plures alterius gentis et sectae eorum religioni et caeremoniis iungerentur; grandis enim cunctos Iudaici nominis terror invaserat."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Igitur duodecimi mensis - id est Adar - tertia decima die, quando verbum et edictum regis explendum erat, et hostes Iudaeorum sperabant quod dominarentur ipsis, versa vice Iudaei superaverunt adversarios suos."
,"2":"Congregatique sunt per singulas civitates, ut extenderent manum contra inimicos et persecutores suos; nullusque ausus est resistere, eo quod omnes populos invaserat formido eorum."
,"3":"Nam et omnes provinciarum principes et satrapae et procuratores omnisque dignitas, quae singulis locis ac operibus praeerat, sustinebant Iudaeos timore Mardochaei,"
,"4":"quem principem esse palatii et plurimum posse cognoverant; fama quoque nominis eius crescebat cotidie et per cunctorum ora volitabat."
,"5":"Itaque percusserunt Iudaei omnes inimicos suos plaga gladii et necis et interitus, reddentes eis, quod sibi paraverant facere."
,"6":"In Susan quingentos viros interfecerunt, extra decem filios Aman Agagitae hostis Iudaeorum, quorum ista sunt nomina:"
,"7":"Pharsandatha et Delphon et Esphatha"
,"8":"et Phoratha et Adalia et Aridatha"
,"9":"et Phermesta et Arisai et Aridai et Iezatha."
,"10":"Quos cum occidissent, praedas de substantiis eorum tangere noluerunt."
,"11":"Statimque numerus eorum, qui occisi erant in Susan, ad regem relatus est."
,"12":"Qui dixit reginae: ' In urbe Susan interfecerunt et deleverunt Iudaei quingentos viros et decem filios Aman. Quantam putas eos exercuisse caedem in universis provinciis? Quid ultra postulas et quid vis, ut fieri iubeam? '."
,"13":"Cui illa respondit: ' Si regi placet, detur potestas Iudaeis, qui in Susan sunt, ut sicut hodie fecerunt, sic et cras faciant, et decem filii Aman in patibulo suspendantur '."
,"14":"Praecepitque rex, ut ita fieret. Statimque in Susan pependit edictum, et decem filii Aman suspensi sunt."
,"15":"Congregatis igitur Iudaeis, qui in Susan erant, quarta decima die mensis Adar, interfecti sunt in Susan trecenti viri, nec eorum ab illis direpta substantia est."
,"16":"Reliqui autem Iudaei per omnes provincias, quae dicioni regis subiacebant, congregati pro animabus suis steterunt, ut requiescerent ab hostibus, ac interfecerunt de persecutoribus suis septuaginta quinque milia, sed nullus de substantiis eorum quidquam contigit."
,"17":"Dies autem tertius decimus mensis Adar, dies apud omnes interfectionis fuit, et quarta decima die requieverunt. Quem constituerunt esse diem epularum et laetitiae."
,"18":"At hi, qui in urbe Susan congregati sunt, tertio decimo et quarto decimo die eiusdem mensis in caede versati sunt, quinto decimo autem die requieverunt; et idcirco eundem diem constituerunt sollemnem epularum atque laetitiae."
,"19":"Hi vero Iudaei, qui in oppidis non muratis ac villis morabantur, quartum decimum diem mensis Adar conviviorum et gaudii decreverunt, ita ut exsultent in eo et mittant sibi mutuo partes epularum. Illi autem, qui in urbibus habitant, agunt etiam quintum decimum diem mensis Adar cum gaudio et convivio et ut diem festum, in quo mittunt sibi mutuo partes epularum."
,"19a":"Et satrapae provinciarum et principes et scribae regis honorificabant Deum, quia timor Mardochaei eos invaserat. Factum erat enim, ut praeceptum regis in toto regno nominaretur."
,"20":"Scripsit itaque Mardochaeus omnia haec et litteris comprehensa misit ad omnes Iudaeos, qui in omnibus regis provinciis morabantur, tam in vicino positis quam procul,"
,"21":"ut quartam decimam et quintam decimam diem mensis Adar pro festis susciperent et, revertente semper anno, sollemni honore celebrarent"
,"22":"secundum dies, in quibus requieverunt Iudaei ab inimicis suis, et mensem, qui de luctu atque tristitia in hilaritatem gaudiumque ipsis conversus est, essentque istae dies epularum atque laetitiae, et mitterent sibi invicem ciborum partes et pauperibus munuscula largirentur."
,"23":"Susceperuntque Iudaei in sollemnem ritum cuncta, quae eo tempore facere coeperant, et quae Mardochaeus litteris facienda mandaverat."
,"24":"Aman enim filius Amadathi stirpis Agag, adversarius omnium Iudaeorum, cogitavit contra eos malum, ut deleret illos, et misit Phur, id est sortem, ut eos conturbaret atque deleret."
,"25":"Sed postquam ingressa est Esther ad regem, mandavit ille simul cum litteris, ut malum, quod iste contra Iudaeos cogitaverat, reverteretur in caput eius, et suspenderentur ipse et filii eius in patibulo."
,"26":"Atque ex illo tempore dies isti appellati sunt Phurim propter nomen Phur. Propter cuncta illa, quae in hac epistula continentur,"
,"27":"et propter ea, quae de his viderant et quae eis acciderant, statuerunt et in sollemnem ritum numquam mutandum susceperunt Iudaei super se et semen suum et super cunctos, qui religioni eorum voluerint copulari, ut duos hos dies secundum praeceptum et tempus eorum singulis annis celebrarent."
,"28":"Isti dies memorarentur et celebrarentur per singulas generationes in singulis cognationibus, provinciis et civitatibus, nec esset ulla civitas, in qua dies Phurim non observarentur a Iudaeis et ab eorum progenie."
,"29":"Scripseruntque Esther regina filia Abihail et Mardochaeus Iudaeus omni studio ad confirmandam hanc secundam epistulam Phurim."
,"30":"Et miserunt ad omnes Iudaeos, qui in centum viginti septem provinciis regis Asueri versabantur, verba pacis et veritatis,"
,"31":"statuentes dies Phurim pro temporibus suis, sicut constituerant Mardochaeus et Esther, et sicut illi statuerant pro seipsis et pro semine suo, praecepta ieiuniorum et clamorum."
,"32":"Et mandatum Esther confirmavit praecepta Phurim et scriptum est in libro."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Rex vero Asuerus terrae et maris insulis imposuit tribu tum."
,"2":"Cuius fortitudo et imperium et dignitas atque sublimitas, qua exaltavit Mardochaeum, scripta sunt in libro annalium regum Medorum atque Persarum,"
,"3":"et quomodo Mardochaeus Iudaici generis secundus a rege Asuero fuerit et magnus apud Iudaeos et acceptabilis plebi fratrum suorum, quaerens bona populo suo et loquens ea, quae ad pacem seminis sui pertinerent."
,"3a":"Dixitque Mardochaeus ad omnes: ' A Deo facta sunt ista! '."
,"3b":"Recordatus est enim Mardochaeus somnii, quod viderat, haec eadem significantis; nec eorum quidquam irritum fuit."
,"3c":"' Quod parvus fons crevit in fluvium, et erat lux et sol et aqua plurima: fons et flumen est Esther, quam rex accepit uxorem et voluit esse reginam;"
,"3d":"duo autem dracones, ego sum et Aman;"
,"3e":"gentes, quae convenerant, hi sunt, qui conati sunt delere nomen Iudaeorum;"
,"3f":"gens autem mea, id est Israel, sunt illi, qui clamaverunt ad Dominum; et salvum fecit Dominus populum suum liberavitque nos de omnibus malis et fecit signa magna atque portenta, quae non sunt facta inter gentes."
,"3g":"Et duas sortes esse praecepit, unam populi Dei et alteram cunctarum gentium."
,"3h":"Venitque utraque sors in statutum tempus et in diem iudicii coram Deo universis gentibus."
,"3i":"Et recordatus est Deus populi sui ac iustificavit hereditatem suam."
,"3k":"Et observabuntur dies isti in mense Adar, quarta decima et quinta decima die eiusdem mensis, dies congregationis et hilaritatis et gaudii coram Deo per vestras deinceps generationes in populo Israel '."
}`)

}
func LA_NVBSE_LoadVHIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Post mortem Iosue consulue runt filii Israel Dominum dicen tes: ' Quis nostrum primus ascendet ad Chananaeum ad pugnandum contra eum? '."
,"2":"Dixitque Dominus: ' Iudas ascendet: ecce tradidi terram in manus eius '."
,"3":"Et ait Iudas Simeoni fratri suo: ' Ascende mecum in sorte mea, et pugnemus contra Chananaeum, et ego pergam tecum in sorte tua '. Et abiit cum eo Simeon."
,"4":"Ascenditque Iudas, et tradidit Dominus Chananaeum ac Pherezaeum in manus eorum, et percusserunt in Bezec decem milia virorum."
,"5":"Inveneruntque Adonibezec in Bezec et pugnaverunt contra eum ac percusserunt Chananaeum et Pherezaeum."
,"6":"Fugit autem Adonibezec, quem persecuti comprehenderunt, caesis pollicibus manuum eius ac pedum."
,"7":"Dixitque Adonibezec: ' Septuaginta reges, amputatis manuum ac pedum pollicibus, colligebant sub mensa mea ciborum reliquias. Sicut feci, ita reddidit mihi Deus '. Adduxeruntque eum in Ierusalem, et ibi mortuus est."
,"8":"Oppugnantes ergo filii Iudae Ierusalem ceperunt eam; et percusserunt in ore gladii tradentes incendio civitatem."
,"9":"Et postea descendentes pugnaverunt contra Chananaeum, qui habitabat in montanis et in Nageb et in Sephela."
,"10":"Pergensque Iuda contra Chananaeum, qui habitabat in Hebron, cui nomen fuit antiquitus Cariatharbe, percussit Sesai et Ahiman et Tholmai."
,"11":"Atque inde profectus abiit ad habitatores Dabir, cuius nomen vetus erat Cariathsepher (id est civitas Litterarum)."
,"12":"Dixitque Chaleb: ' Qui percusserit Cariathsepher et ceperit eam, dabo ei Axam filiam meam uxorem '."
,"13":"Cumque cepisset eam Othoniel filius Cenez frater Chaleb minor, dedit ei Axam filiam suam coniugem."
,"14":"Quae cum veniret, incitavit eum, ut peteret a patre suo agrum. Demisit ergo se de asino, et dixit ei Chaleb: ' Quid habes? '."
,"15":"At illa respondit: ' Da mihi benedictionem; quia terram arentem dedisti mihi, da et irriguam aquis '. Dedit ergo ei Chaleb irriguum superius et irriguum inferius."
,"16":"Filii autem Hobab Cinaei cognati Moysi ascenderunt de civitate Palmarum cum filiis Iudae in desertum Iudae, quod est ad meridiem Arad, et habitaverunt cum Amalecitis."
,"17":"Abiit autem Iudas cum Simeone fratre suo et percusserunt simul Chananaeum, qui habitabat in Sephath, et percusserunt urbem anathemate. Vocatumque est nomen eius Horma (id est Anathema)."
,"18":"Cepitque Iudas Gazam cum finibus suis et Ascalonem atque Accaron cum terminis suis."
,"19":"Fuitque Dominus cum Iuda, et montana possedit; nec potuit expellere habitatores vallis, quia falcatis curribus abundabant."
,"20":"Dederuntque Chaleb Hebron, sicut dixerat Moyses, qui expulit ex ea tres filios Enac."
,"21":"Iebusaeum autem habitatorem Ierusalem non expulerunt filii Beniamin, habitavitque Iebusaeus cum filiis Beniamin in Ierusalem usque in praesentem diem."
,"22":"Domus quoque Ioseph ascendit Bethel, fuitque Dominus cum eis."
,"23":"Nam, cum explorarent urbem, quae prius Luza vocabatur,"
,"24":"viderunt custodes hominem egredientem de civitate dixeruntque ad eum: ' Ostende nobis introitum civitatis, et faciemus tecum misericordiam '."
,"25":"Qui cum ostendisset eis, percusserunt urbem in ore gladii; hominem autem illum et omnem cognationem eius dimiserunt."
,"26":"Qui dimissus abiit in terram Hetthim et aedificavit ibi civitatem vocavitque eam Luzam, quae ita appellatur usque in praesentem diem."
,"27":"Manasses quoque non occupavit Bethsan et Thanach cum viculis suis nec expulit habitatores Dor et Ieblaam et Mageddo cum viculis suis; mansitque Chananaeus in terra hac."
,"28":"Postquam autem confortatus est Israel, fecit eos tributarios et expellere noluit."
,"29":"Ephraim etiam non expulit Chananaeum, qui habitabat in Gazer, sed habitavit Chananaeus in medio eius in Gazer."
,"30":"Zabulon non expulit habitatores Cetron et Naalol, sed habitavit Chananaeus in medio eius factusque est ei tributarius."
,"31":"Aser quoque non expulit habitatores Achcho et Sidonis, Ahalab et Achazib et Helba et Aphec et Rohob;"
,"32":"habitavitque Aser in medio Chananaei habitatoris illius terrae, quia non expulit eum."
,"33":"Nephthali non expulit habitatores Bethsames et Bethanath et habitavit inter Chananaeum habitatorem terrae, fueruntque ei Bethsamitae et Bethanitae tributarii."
,"34":"Artavitque Amorraeus filios Dan in montem nec dedit eis locum, ut ad planiora descenderent."
,"35":"Habitavitque Amorraeus in Hathares, in Aialon et Salebim; et aggravata est manus domus Ioseph, factusque est ei tributarius."
,"36":"Fuit autem terminus Amorraei ab ascensu Acrabbim ad Petram et superiora loca."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ascenditque angelus Domini de Galgalis in Bochim et ait: ' Eduxi vos de Aegypto et introduxi in terram, pro qua iuravi patribus vestris et pollicitus sum, ut non facerem irritum pactum meum vobiscum in sempiternum,"
,"2":"ita dumtaxat ut non feriretis foedus cum habitatoribus terrae huius, sed aras eorum subverteretis. Et noluistis audire vocem meam. Cur hoc fecistis?"
,"3":"Quam ob rem nolui expellere eos a facie vestra, ut sint vobis in laqueum, et dii eorum in ruinam '."
,"4":"Cumque loqueretur angelus Domini verba haec ad omnes filios Israel, elevaverunt vocem suam et fleverunt."
,"5":"Et vocatum est nomen loci illius Bochim (id est locus Flentium); immolaveruntque ibi hostias Domino."
,"6":"Dimisit ergo Iosue populum, et abierunt filii Israel unusquisque in possessionem suam, ut obtinerent terram."
,"7":"Servieruntque Domino cunctis diebus Iosue et seniorum, qui longo post eum vixerunt tempore et viderant universum opus magnum Domini, quod fecerat cum Israel."
,"8":"Mortuus est autem Iosue filius Nun famulus Domini centum et decem annorum;"
,"9":"et sepelierunt eum in finibus possessionis suae in Thamnathsare in monte Ephraim a septentrionali plaga montis Gaas."
,"10":"Omnisque illa generatio congregata est ad patres suos, et surrexerunt alii post illam, qui non noverant Dominum et opus, quod fecerat cum Israel."
,"11":"Feceruntque filii Israel malum in conspectu Domini et servierunt Baalim"
,"12":"ac dimiserunt Dominum, Deum patrum suorum, qui eduxerat eos de terra Aegypti, et secuti sunt deos alienos, de diis populorum, qui habitabant in circuitu eorum, et adoraverunt eos et ad iracundiam concitaverunt Dominum"
,"13":"dimittentes eum et servientes Baal et Astharoth."
,"14":"Iratusque Dominus contra Israel tradidit eos in manibus diripientium, qui diripuerunt eos, et vendidit eos hostibus, qui habitabant per gyrum, nec potuerunt resistere adversariis suis;"
,"15":"sed, quocumque pergere voluissent, manus Domini erat super eos ad malum, sicut locutus est et iuravit eis, et vehementer afflicti sunt."
,"16":"Suscitavitque Dominus iudices, qui liberarent eos de vastantium manibus;"
,"17":"sed nec illos audire voluerunt fornicantes cum diis alienis et adorantes eos. Cito deseruerunt viam, per quam ingressi fuerant patres eorum audientes mandata Domini, et omnia fecere contraria."
,"18":"Cumque Dominus iudices suscitaret eis, erat Dominus cum iudice et liberabat eos de manu hostium eorum toto tempore iudicis, quia flectebatur misericordia et audiebat gemitus afflictorum."
,"19":"Postquam autem mortuus esset iudex, revertebantur et multo faciebant peiora quam fecerant patres sui, sequentes deos alienos, servientes eis et adorantes illos: non dimiserunt opera sua et viam durissimam, per quam ambulare consueverant."
,"20":"Iratusque est furor Domini in Israel et ait: ' Quia irritum fecit gens ista pactum meum, quod pepigeram cum patribus eorum, et vocem meam audire contempsit,"
,"21":"et ego non expellam gentes, quas dimisit Iosue et mortuus est;"
,"22":"ut in ipsis experiar Israel, utrum custodiant viam Domini et ambulent in ea, sicut custodierunt patres eorum, an non '."
,"23":"Dimisit ergo Dominus has nationes et cito expellere noluit nec tradidit in manibus Iosue."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hae sunt gentes, quas Dominus dereliquit, ut erudiret in eis Is raelem, omnes, qui non noverant bella Chananaeorum,"
,"2":"ut discerent certare cum hostibus generationes filiorum Israel, quae non habebant consuetudinem proeliandi:"
,"3":"quinque satrapae Philisthinorum omnisque Chananaeus et Sidonius atque Hevaeus, qui habitabat in monte Libano de monte Baalhermon usque ad introitum Emath."
,"4":"Dimisitque eos, ut in ipsis experiretur Israelem, utrum audiret mandata Domini, quae praeceperat patribus eorum per manum Moysi, an non."
,"5":"Itaque filii Israel habitaverunt in medio Chananaei et Hetthaei et Amorraei et Pherezaei et Hevaei et Iebusaei"
,"6":"et duxerunt uxores filias eorum, ipsique filias suas eorum filiis tradiderunt, et servierunt diis eorum."
,"7":"Feceruntque filii Israel malum in conspectu Domini et obliti sunt Domini Dei sui servientes Baalim et Astharoth."
,"8":"Iratusque Dominus contra Israel tradidit eos in manus Chusanrasathaim regis Mesopotamiae, servieruntque ei octo annis."
,"9":"Et clamaverunt ad Dominum, qui suscitavit eis salvatorem et liberavit eos, Othoniel videlicet filium Cenez fratrem Chaleb minorem."
,"10":"Fuitque in eo spiritus Domini, et iudicavit Israelem egressusque est ad pugnam; et tradidit Dominus in manu eius Chusanrasathaim regem Mesopotamiae, et praevaluit adversus eum."
,"11":"Quievitque terra quadraginta annis, et mortuus est Othoniel filius Cenez."
,"12":"Addiderunt autem filii Israel facere malum in conspectu Domini, qui confortavit adversum eos Eglon regem Moab, quia fecerunt malum in conspectu Domini."
,"13":"Et copulavit sibi Eglon filios Ammon et Amalec abiitque et percussit Israel atque possedit urbem Palmarum."
,"14":"Servieruntque filii Israel Eglon regi Moab decem et octo annis."
,"15":"Et clamaverunt filii Israel ad Dominum, qui suscitavit eis salvatorem Aod filium Gera de Beniamin, qui sinistra manu utebatur pro dextera. Miseruntque filii Israel per illum munera Eglon regi Moab."
,"16":"Fecitque Aod sibi gladium ancipitem longitudinis palmae manus et accinctus est eo subter vestem in dextro femore"
,"17":"obtulitque munera Eglon regi Moab. Erat autem Eglon crassus nimis."
,"18":"Cumque obtulisset ei munera, dimisit socios, qui illa portaverant;"
,"19":"et reversus de Galgalis, ubi erant idola, dixit ad regem: ' Verbum secretum habeo ad te, o rex '. Et ille imperavit silentium; egressique sunt omnes, qui circa eum erant."
,"20":"Aod autem ingressus erat ad eum, cum sederet in aestivo cenaculo, quod ipsi soli erat, dixitque: ' Verbum Dei habeo ad te '. Qui statim surrexit de throno."
,"21":"Extenditque Aod manum sinistram et tulit sicam de dextro femore suo infixitque eam in ventre eius"
,"22":"tam valide, ut capulus ferrum sequeretur in vulnere ac pinguissimo adipe stringeretur. Nec eduxit gladium, sed ita, ut percusserat, reliquit in corpore; statimque per secreta naturae alvi stercora proruperunt."
,"23":"Aod autem egressus in atrium clausit ostium cenaculi post se et obfirmavit sera."
,"24":"Egresso illo, servi regis venerunt et, cum viderent clausas fores cenaculi, dixerunt: ' Certe purgat alvum in aestivo cubiculo '."
,"25":"Exspectantesque diu, donec erubescerent, et videntes quod nullus aperiret, tulerunt clavem et aperientes invenerunt dominum suum iacentem in terra mortuum."
,"26":"Aod autem, dum illi cunctarentur, effugerat et pertransiit locum idolorum, unde reversus fuerat, venitque in Seira."
,"27":"Et statim insonuit bucina in monte Ephraim; descenderuntque cum eo filii Israel, ipso in fronte gradiente."
,"28":"Qui dixit ad eos: ' Sequimini me; tradidit enim Dominus inimicos vestros Moabitas in manus vestras '. Descenderuntque post eum et occupaverunt vada Iordanis, quae transmittunt in Moab, et non dimiserunt transire quemquam,"
,"29":"sed percusserunt Moabitas in tempore illo circiter decem milia, omnes robustos et fortes viros. Nullus eorum evadere potuit."
,"30":"Humiliatusque est Moab die illo sub manu Israel; et quievit terra octoginta annis."
,"31":"Post hunc fuit Samgar filius Anath, qui percussit de Philisthim sescentos viros stimulo boum; et ipse quoque salvum fecit Israel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Addideruntque filii Israel facere malum in conspectu Domini post mortem Aod,"
,"2":"et tradidit illos Dominus in manu Iabin regis Chanaan, qui regnavit in Asor. Habuitque ducem exercitus sui nomine Sisaram: ipse autem habitabat in Haroseth gentium."
,"3":"Clamaveruntque filii Israel ad Dominum; nongentos enim habebat falcatos currus et per viginti annos vehementer oppresserat eos."
,"4":"Erat autem Debora prophetis, uxor Lapidoth, quae iudicabat Israel in illo tempore."
,"5":"Et sedebat sub palma Deborae inter Rama et Bethel in monte Ephraim; ascendebantque ad eam filii Israel in iudicium."
,"6":"Quae misit et vocavit Barac filium Abinoem de Cedes Nephthali dixitque ad eum: ' Praecepit tibi Dominus, Deus Israel: Vade et duc exercitum in montem Thabor tollesque tecum decem milia pugnatorum de filiis Nephthali et de filiis Zabulon."
,"7":"Ego autem ducam ad te in loco torrentis Cison Sisaram principem exercitus Iabin et currus eius atque omnem multitudinem et tradam eum in manu tua '."
,"8":"Dixitque ad eam Barac: ' Si venis mecum, vadam; si nolueris venire mecum, non pergam '."
,"9":"Quae dixit ad eum: ' Ibo quidem tecum; sed in hac via non erit tibi gloria, quia in manu mulieris tradet Dominus Sisaram '. Surrexit itaque Debora et perrexit cum Barac in Cedes. "
,"10":"Qui, accitis Zabulon et Nephthali in Cedes, ascendit cum decem milibus pugnatorum habens Deboram in comitatu suo."
,"11":"Haber autem Cinaeus recesserat a ceteris Cinaeis fratribus suis filiis Hobab cognati Moysi et tetendit tabernaculum usque ad quercum in Saananim iuxta Cedes."
,"12":"Nuntiatumque est Sisarae quod ascendisset Barac filius Abinoem in montem Thabor,"
,"13":"et congregavit omnes nongentos falcatos currus omnemque exercitum, qui cum eo erat, de Haroseth gentium ad torrentem Cison."
,"14":"Dixitque Debora ad Barac: ' Surge: haec est enim dies, in qua tradidit Dominus Sisaram in manus tuas. En ipse ductor est tuus '. Descendit itaque Barac de monte Thabor, et decem milia pugnatorum cum eo."
,"15":"Perterruitque Dominus Sisaram et omnes currus eius universamque multitudinem in ore gladii ad conspectum Barac, in tantum ut Sisara de curru desiliens pedibus fugeret,"
,"16":"et Barac persequeretur fugientes currus et exercitum usque ad Haroseth gentium, et omnis hostium multitudo usque ad internecionem caderet."
,"17":"Sisara autem fugiens pervenit ad tentorium Iahel uxoris Haber Cinaei; erat enim pax inter Iabin regem Asor et domum Haber Cinaei."
,"18":"Egressa igitur Iahel in occursum Sisarae dixit ad eum: ' Intra ad me, domine mi; intra, ne timeas '. Qui ingressus tabernaculum eius et opertus ab ea panno,"
,"19":"dixit ad eam: ' Da mihi, obsecro, paululum aquae, quia sitio '. Quae aperuit utrem lactis et dedit ei bibere et operuit illum."
,"20":"Dixitque Sisara ad eam: ' Sta ante ostium tabernaculi et, cum venerit aliquis interrogans te et dicens: 'Numquid hic est aliquis?', respondebis: 'Nullus est' '."
,"21":"Tulit porro Iahel uxor Haber clavum tabernaculi assumens pariter malleum; et ingressa abscondite et cum silentio, posuit supra tempus capitis eius clavum, percussumque malleo defixit in cerebrum usque ad terram; qui soporem morti socians defecit et mortuus est."
,"22":"Et ecce Barac sequens Sisaram veniebat; egressaque Iahel in occursum eius dixit ei: ' Veni, et ostendam tibi virum, quem quaeris '. Qui cum intrasset ad eam, vidit Sisaram iacentem mortuum et clavum infixum in tempore eius."
,"23":"Humiliavit ergo Deus in die illo Iabin regem Chanaan coram filiis Israel,"
,"24":"qui crescebant cotidie et forti manu opprimebant Iabin regem Chanaan, donec delerent eum."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cecineruntque Debora et Barac filius Abinoem in die illo dicen tes:"
,"2":"' Quia comae excussae sunt in Israel, cum sponte se obtulit populus, benedicite Domino!"
,"3":"Audite, reges, percipite auribus, principes; ego sum, ego sum, quae Domino canam, psallam Domino, Deo Israel!"
,"4":"Domine, cum exires de Seir, incederes de regione Edom, terra mota est, caelique stillaverunt, ac nubes stillaverunt aquis;"
,"5":"montes fluxerunt a facie Domini Sinai, a facie Domini, Dei Israel."
,"6":"In diebus Samgar filii Anath, in diebus Iahel quieverunt semitae; et, qui ingrediebantur per eas, ambulaverunt per calles devios."
,"7":"Cessaverunt fortes in Israel et quieverunt, donec surgeres, Debora, surgeres mater in Israel."
,"8":"Elegerunt deos novos; tunc erat pugna in portis. Clipeus et hasta non apparuerunt,in quadraginta milibus Israel."
,"9":"Cor meum diligit principes Israel. Qui sponte obtulistis vos in populo, benedicite Domino!"
,"10":"Qui ascenditis super nitentes asinas,et sedetis super tapetia,et ambulatis in via, loquimini."
,"11":"Ad vocem eorum, qui distribuunt aquas ad canales, ibi narrant iustitias Domini, iustitias fortitudinis eius in Israel: tunc descendit populus Domini ad portas."
,"12":"Surge, surge, Debora; surge, surge et loquere canticum!,Surge, Barac, et apprehende captivos tuos, fili Abinoem!"
,"13":"Tunc descenderunt reliquiae ad inclitos, populus Domini descendit pro eo in fortibus."
,"14":"Ex Ephraim venerunt principes in vallem,post te, Beniamin, in populis tuis. De Machir principes descenderunt, et de Zabulon, qui tenent sceptrum, praefecti."
,"15":"Duces Issachar fuere cum Debora; sic Barac in vallem missus cum peditibus suis. In pagis Ruben magna consilia cordis."
,"16":"Quare sedebas inter caulas, ut audires sibilos tibiae apud greges?,Pagis Ruben magnae investigationes cordis."
,"17":"Galaad trans Iordanem quiescebat; et Dan cur peregrinus vacabat navibus?,Aser habitabat in litore maris,et in portibus morabatur."
,"18":"Zabulon vero obtulit animam suam morti, et Nephthali super excelsa regionis. "
,"19":"Venerunt reges et pugnaverunt, pugnaverunt reges Chanaan,in Thanach iuxta aquas Mageddo, praedam argenti non tulere!"
,"20":"De caelo dimicaverunt stellae, cursu suo adversus Sisaram pugnaverunt."
,"21":"Torrens Cison traxit cadavera eorum, torrens proeliorum, torrens Cison; incede, anima mea, fortiter."
,"22":"Tunc calcaverunt ungulae equorum,in cursu praecipiti fortium suorum."
,"23":"Maledicite, Meroz, dixit angelus Domini, maledicite habitatoribus eius, quia non venerunt ad auxilium Domini, in adiutorium Domini in fortibus."
,"24":"Benedicta prae mulieribus Iahel uxor Haber Cinaei, prae mulieribus tabernaculi benedicatur!"
,"25":"Aquam petenti lac dedit,et in phiala principum obtulit butyrum."
,"26":"Sinistram manum misit ad clavum,et dextram ad fabrorum malleum: percussitque Sisaram quaerens in capite vulneri locum,et tempus valide perforans."
,"27":"Inter pedes eius ruit, cecidit, iacebat; inter pedes eius ruit, cecidit; ubi ruit, ibi iacebat exanimis."
,"28":"Per fenestram prospiciens eiulabat,mater Sisarae per cancellos: 'Cur moratur regredi currus eius? Quare tardant rotae quadrigarum illius?'."
,"29":"Una sapientior ceteris uxoribus respondit ei, et ipsa sibi repetit verba illius:"
,"30":"'Certo nunc dividunt inventa spolia, unam, duas feminas singulis viris; duas vestes diversorum colorum,Sisarae in praedam; unam, duas texturas discolores,collo meo in praedam'."
,"31":"Sic pereant omnes inimici tui, Domine!,Qui autem diligunt eum, rutilent, sicut sol in ortu suo splendet '."
,"32":"Quievitque terra per quadraginta annos."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Fecerunt autem filii Israel malum in conspectu Domini, qui tradidit eos in manu Madian septem annis."
,"2":"Et oppressi sunt valde ab eis. Feceruntque sibi antra et speluncas in montibus et tutissima loca."
,"3":"Cumque sevisset Israel, ascendebat Madian et Amalec ceterique orientalium nationum"
,"4":"et apud eos figentes tentoria, sicut erant in herbis, cuncta vastabant usque ad introitum Gazae nihilque omnino ad vitam pertinens relinquebant in Israel, non oves, non boves, non asinos."
,"5":"Ipsi enim et universi greges eorum veniebant cum tabernaculis suis et, instar locustarum, universa complebant, innumera multitudo hominum et camelorum, quidquid tetigerant devastantes."
,"6":"Humiliatusque est Israel valde in conspectu Madian."
,"7":"Et clamavit ad Dominum postulans auxilium contra Madianitas."
,"8":"Qui misit ad eos virum prophetam, et locutus est: ' Haec dicit Dominus, Deus Israel: Ego vos feci conscendere de Aegypto et eduxi vos de domo servitutis"
,"9":"et liberavi de manu Aegyptiorum et omnium inimicorum, qui affligebant vos, eiecique eos ad introitum vestrum et tradidi vobis terram eorum."
,"10":"Et dixi: Ego Dominus Deus vester, ne timeatis deos Amorraeorum, in quorum terra habitatis. Et noluistis audire vocem meam '."
,"11":"Venit autem angelus Domini et sedit sub quercu, quae erat in Ephra et pertinebat ad Ioas de familia Abiezer. Cumque Gedeon filius eius excuteret atque purgaret frumenta in torculari, ut absconderet a Madian,"
,"12":"apparuit ei angelus Domini et ait: ' Dominus tecum, vir fortis! '."
,"13":"Dixitque ei Gedeon: ' Obsecro, domine mi, si Dominus nobiscum est, cur apprehenderunt nos haec omnia? Ubi sunt omnia mirabilia eius, quae narraverunt patres nostri atque dixerunt: 'De Aegypto eduxit nos Dominus'? Nunc autem dereliquit nos Dominus et tradidit in manu Madian '."
,"14":"Respexitque ad eum Dominus et ait: ' Vade in hac fortitudine tua et liberabis Israel de manu Madian; scito quod miserim te '."
,"15":"Qui respondens ait: ' Obsecro, Domine, in quo liberabo Israel? Ecce familia mea infima est in Manasse, et ego minimus in domo patris mei '."
,"16":"Dixitque ei Dominus: ' Ego ero tecum, et percuties Madian quasi unum virum '."
,"17":"Et ille: ' Si inveni, inquit, gratiam coram te, da mihi signum quod tu sis, qui loquaris ad me;"
,"18":"ne recedas hinc, donec revertar ad te portans oblationem et offerens tibi '. Qui respondit: ' Ego praestolabor adventum tuum '."
,"19":"Ingressus est itaque Gedeon et coxit haedum et de farinae ephi azymos panes; carnesque ponens in canistro et ius carnium mittens in ollam tulit omnia sub quercum et obtulit ei."
,"20":"Cui dixit angelus Dei: ' Tolle carnes et panes azymos et pone super petram illam et ius desuper funde '. Cumque fecisset ita,"
,"21":"extendit angelus Domini summitatem virgae, quam tenebat in manu, et tetigit carnes et azymos panes, ascenditque ignis de petra et carnes azymosque panes consumpsit. Angelus autem Domini evanuit ex oculis eius."
,"22":"Vidensque Gedeon quod esset angelus Domini ait: 'Heu mihi, Domine Deus, quia vidi angelum Domini facie ad faciem! '."
,"23":"Dixitque ei Dominus: ' Pax tecum, ne timeas, non morieris! '."
,"24":"Aedificavit ergo ibi Gedeon altare Domino vocavitque illud: ' Dominus pax '; usque in praesentem diem adhuc est in Ephra filiorum Abiezer."
,"25":"Nocte illa dixit Dominus ad eum: ' Tolle taurum patris tui, alterum taurum scilicet annorum septem, destruesque aram Baal, quae est patris tui, et palum, qui iuxta aram est, succide;"
,"26":"et aedificabis altare Domino Deo tuo in summitate petrae huius secundum ordinem; tollesque taurum secundum et offeres holocaustum super struem lignorum pali, quem succideris '."
,"27":"Assumptis igitur Gedeon decem viris de servis suis, fecit, sicut praeceperat Dominus; timens autem domum patris sui et homines illius civitatis per diem facere noluit, sed omnia nocte complevit."
,"28":"Cumque surrexissent viri oppidi eius mane, viderunt destructam aram Baal palumque succisum et taurum alterum impositum super altare, quod tunc aedificatum erat."
,"29":"Dixeruntque ad invicem: ' Quis hoc fecit? '. Cumque perquirerent auctorem facti, dictum est: ' Gedeon filius Ioas fecit haec omnia '."
,"30":"Et dixerunt ad Ioas: ' Produc filium tuum, ut moriatur, quia destruxit aram Baal et succidit palum '."
,"31":"Respondit Ioas omnibus, qui circumdabant eum: ' Numquid certare vultis pro Baal et salvare eum? Qui certabit pro Baal, morietur usque mane. Si Deus est, certet pro seipso contra eum, qui destruxit aram eius '."
,"32":"Ex illo die vocatus est Gedeon Ierobbaal, eo quod dicebatur: ' Certet contra eum Baal, quia destruxit altare eius '."
,"33":"Igitur omnis Madian et Amalec et orientales populi congregati sunt simul et transeuntes Iordanem castrametati sunt in valle Iezrahel."
,"34":"Spiritus autem Domini induit Gedeon, qui clangens bucina convocavit domum Abiezer, ut sequeretur."
,"35":"Misitque nuntios in universum Manassen, qui et ipse secutus est eum; et alios nuntios in Aser et Zabulon et Nephthali, qui occurrerunt ei."
,"36":"Dixitque Gedeon ad Deum: ' Si salvum facis per manum meam Israel, sicut locutus es,"
,"37":"ponam vellus lanae in area: si ros in solo vellere fuerit, et in omni terra siccitas, sciam quod per manum meam, sicut locutus es, liberabis Israel '."
,"38":"Factumque est ita. Et de nocte consurgens, expresso vellere concham rore complevit."
,"39":"Dixitque rursus ad Deum: ' Ne irascatur furor tuus contra me, si adhuc semel tentavero signum quaerens in vellere. Oro, ut solum vellus siccum sit, et omnis terra rore madens '."
,"40":"Fecitque Deus nocte illa, ut postulaverat; et fuit siccitas in solo vellere, et ros in omni terra."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Igitur Ierobbaal, qui et Gedeon, de nocte consurgens et omnis populus cum eo castrame tati sunt ad fontem, qui vocatur Harad. Erant autem castra Madian in valle ad septentrionalem plagam collis Moreh."
,"2":"Dixitque Dominus ad Gedeon: ' Maior tecum est populus, quam ut tradatur Madian in manus eius, ne glorietur contra me Israel et dicat: 'Meis viribus liberatus sum'."
,"3":"Loquere ad populum et, cunctis audientibus, praedica: 'Qui formidolosus et timidus est, revertatur et recedat de monte Gelboe' '. Et reversa sunt ex populo viginti duo milia virorum; et tantum decem milia remanserunt."
,"4":"Dixitque Dominus ad Gedeon: ' Adhuc populus multus est; duc eos ad aquas, et ibi probabo illos, et, de quo dixero tibi ut tecum vadat, ipse pergat; quem ire prohibuero, revertatur '."
,"5":"Cumque deduxisset populum ad aquas, dixit Dominus ad Gedeon: ' Qui lingua lambuerint aquas, sicut solent canes lambere, separabis eos seorsum; qui autem curvatis genibus biberint, in altera parte erunt '."
,"6":"Fuit itaque numerus eorum, qui manu ad os proiciente aquas lambuerant, trecenti viri; omnis autem reliqua multitudo flexo poplite biberat."
,"7":"Et ait Dominus ad Gedeon: ' In trecentis viris, qui lambuerunt aquas, liberabo vos et tradam Madian in manu tua; omnis autem reliqua multitudo revertatur in locum suum '."
,"8":"Sumptis itaque pro numero cibariis et tubis, omnem reliquam multitudinem abire praecepit ad tabernacula sua et ipse trecentos viros tenuit. Castra autem Madian erant subter eum in valle."
,"9":"Eadem nocte dixit Dominus ad eum: ' Surge et descende in castra, quia tradidi ea in manu tua."
,"10":"Sin autem ire formidas, descendat tecum Phara puer tuus."
,"11":"Et, cum audieris quid loquantur, tunc confortabuntur manus tuae, et securior ad hostium castra descendes '. Descendit ergo ipse et Phara puer eius in partem castrorum, ubi erant armatorum vigiliae."
,"12":"Madian autem et Amalec et omnes orientales populi fusi iacebant in valle ut locustarum multitudo; cameli quoque innumerabiles erant sicut arena, quae iacet in litoribus maris."
,"13":"Cumque venisset Gedeon, narrabat aliquis somnium proximo suo et dicebat: ' Ecce vidi somnium, et videbatur mihi quasi subcinericius panis ex hordeo volvi et in Madian castra descendere; cumque pervenisset ad tabernaculum, percussit illud atque subvertit et terrae funditus coaequavit '."
,"14":"Respondit is, cui loquebatur: 'Non est hoc aliud nisi gladius Gedeonis filii Ioas viri Israelitae; tradidit Deus in manu eius Madian et omnia castra eius '."
,"15":"Cumque audisset Gedeon somnium et interpretationem eius, adoravit et reversus ad castra Israel ait: ' Surgite, tradidit enim Dominus in manus vestras castra Madian '."
,"16":"Divisitque trecentos viros in tres partes et dedit tubas in manibus eorum lagoenasque vacuas ac lampades in medio lagoenarum"
,"17":"et dixit ad eos: ' Quod me facere videritis, hoc facite; ingrediar extremam partem castrorum, et, quod fecero, sectamini."
,"18":"Quando personaverit tuba in manu mea et omnium eorum, qui mecum sunt, vos quoque per castrorum circuitum clangite et conclamate: 'Domino et Gedeoni!' '."
,"19":"Ingressusque est Gedeon et trecenti viri, qui erant cum eo, extremam partem castrorum, incipientibus vigiliis noctis mediae, cum eo ipso tempore custodes mutati essent, et coeperunt bucinis clangere et conterere lagoenas."
,"20":"Cumque in tribus personarent turmis et hydrias confregissent, tenuerunt sinistris manibus lampades et dextris sonantes tubas clamaveruntque: ' Gladius Domino et Gedeoni! ',"
,"21":"stantes singuli in loco suo per circuitum castrorum hostilium. Omnia itaque castra turbata sunt, et vociferantes ululantesque fugerunt."
,"22":"Et insistebant trecenti viri bucinis personantes. Immisitque Dominus gladium in omnibus castris, et mutua se caede truncabant fugientes usque Bethsetta, Sareda et crepidinem Abelmehula in Tebbath."
,"23":"Convocati autem viri Israel de Nephthali et Aser et omni Manasse persequebantur Madian."
,"24":"Misitque Gedeon nuntios in omnem montem Ephraim dicens: ' Descendite in occursum Madian et occupate aquas usque Bethbera atque Iordanem '. Omnis Ephraim praeoccupavit aquas usque Bethbera atque Iordanem."
,"25":"Apprehensosque duos principes Madian Oreb et Zeb interfecit Oreb in Petra Oreb, Zeb vero in Torculari Zeb; et persecuti sunt Madian capita Oreb et Zeb portantes ad Gedeon trans fluenta Iordanis."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Dixeruntque ad eum viri Ephraim: ' Quid est hoc quod nobis facere voluisti, ut non nos vocares, cum ad pugnam pergeres contra Madian? ', iurgantes fortiter et prope vim inferentes."
,"2":"Quibus ille respondit: ' Quid enim tale facere potui, quale vos fecistis? Nonne melior est racemus Ephraim vindemiis Abiezer?"
,"3":"In manus vestras Deus tradidit principes Madian Oreb et Zeb. Quid tale facere potui, quale vos fecistis? '. Quod cum locutus esset, requievit spiritus eorum, quo tumebant contra eum."
,"4":"Cumque venisset Gedeon ad Iordanem, transivit eum cum trecentis viris, qui secum erant et prae lassitudine fugientes persequi vix poterant."
,"5":"Dixitque ad viros Succoth: 'Date, obsecro, panes populo, qui mecum est, quia valde defecerunt, et ego persequor Zebee et Salmana reges Madian '."
,"6":"Responderunt principes Succoth: ' Forsitan palmae manuum Zebee et Salmana in manu tua sunt, ut demus exercitui tuo panes? '."
,"7":"Quibus ille ait: ' Cum ergo tradiderit Dominus Zebee et Salmana in manus meas, triturabo carnes vestras cum spinis deserti et tribulis '."
,"8":"Et inde conscendens venit in Phanuel locutusque est ad viros eius loci similia. Cui et illi responderunt, sicut responderant viri Succoth."
,"9":"Dixit itaque et eis: 'Cum reversus fuero in pace, destruam turrim hanc'."
,"10":"Zebee autem et Salmana requiescebant in Carcar cum omni exercitu suo, quasi quindecim milia viri, qui remanserant ex omnibus turmis orientalium populorum, caesis centum viginti milibus bellatorum educentium gladium."
,"11":"Ascendensque Gedeon per viam eorum, qui in tabernaculis morabantur ad orientalem partem Nobe et Iegbaa, percussit castra hostium, qui securi erant et nihil adversi suspicabantur."
,"12":"Fugeruntque Zebee et Salmana. Persequens Gedeon comprehendit duos reges Madian Zebee et Salmana, turbato omni exercitu eorum."
,"13":"Revertensque Gedeon filius Ioas de bello per ascensum Hares,"
,"14":"apprehendit puerum de viris Succoth interrogavitque eum nomina principum et seniorum Succoth, qui scripsit ei septuaginta septem viros."
,"15":"Venitque ad viros Succoth et dixit eis: 'En Zebee et Salmana, super quibus exprobrastis mihi dicentes: 'Forsitan manus Zebee et Salmana in manibus tuis sunt, ut demus viris tuis, qui lassi sunt, panes?' '."
,"16":"Tulit ergo seniores civitatis et spinas deserti ac tribulos; et trituravit cum eis viros Succoth."
,"17":"Turrim quoque Phanuel subvertit, occisis habitatoribus civitatis."
,"18":"Dixitque ad Zebee et Salmana: ' Quales fuerunt viri, quos occidistis in Thabor? '. Qui responderunt: ' Similes tui, et unusquisque ex eis quasi filius regis '."
,"19":"Quibus ille ait: ' Fratres mei fuerunt, filii matris meae. Vivit Dominus, si servassetis eos, non vos occiderem! '."
,"20":"Dixitque Iether primogenito suo: ' Surge et interfice eos! '. Qui non eduxit gladium; timebat enim, quia adhuc puer erat."
,"21":"Dixeruntque Zebee et Salmana: ' Tu surge et irrue in nos, quia iuxta aetatem robur est hominis '. Surrexit Gedeon et interfecit Zebee et Salmana et tulit lunulas, quibus colla camelorum eorum decorata erant."
,"22":"Dixeruntque viri Israel ad Gedeon: ' Dominare nostri, tu et filius tuus et filius filii tui, quia liberasti nos de manu Madian '."
,"23":"Quibus ille ait: ' Non dominabor vestri, nec dominabitur in vos filius meus, sed dominabitur Dominus '."
,"24":"Dixitque ad eos: ' Unam petitionem postulo a vobis: date mihi unusquisque anulum ex praeda sua '. Anulos enim aureos Ismaelitae habere consuerant."
,"25":"Qui responderunt: ' Libentissime dabimus '. Expandentesque super terram pallium proiecerunt in eo unusquisque anulum de praeda sua."
,"26":"Et fuit pondus postulatorum anulorum mille septingenti auri sicli absque lunulis et inauribus et vestibus purpureis, quibus Madian reges uti soliti erant, et praeter torques camelorum."
,"27":"Fecitque ex eo Gedeon ephod et posuit illud in civitate sua Ephra. Fornicatusque est omnis Israel in eo, et factum est Gedeoni et omni domui eius in ruinam."
,"28":"Humiliatus est autem Madian coram filiis Israel, nec potuerunt ultra elevare cervices, sed quievit terra per quadraginta annos, quibus Gedeon vivebat."
,"29":"Abiit itaque Ierobbaal filius Ioas et habitavit in domo sua;"
,"30":"habuitque Gedeon septuaginta filios, qui egressi sunt de femore eius, eo quod multas haberet uxores."
,"31":"Concubina quoque illius, quam habebat in Sichem, genuit ei filium, cui ipse nomen imposuit Abimelech."
,"32":"Mortuusque est Gedeon filius Ioas in senectute bona et sepultus est in sepulcro Ioas patris sui in Ephra filiorum Abiezer."
,"33":"Postquam autem mortuus est Gedeon, aversi sunt filii Israel et fornicati cum Baalim posuerunt sibi Baalberith in deum."
,"34":"Nec recordati sunt Domini Dei sui, qui eruit eos de manu omnium inimicorum suorum per circuitum,"
,"35":"nec fecerunt misericordiam cum domo Ierobbaal Gedeon iuxta omnia bona, quae fecerat Israeli."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Abiit autem Abimelech filius Ierobbaal in Sichem ad fratres matris suae et locutus est ad eos et ad omnem cognationem familiae matris suae dicens:"
,"2":"' Loquimini ad omnes viros Sichem: 'Quid vobis est melius, ut dominentur vestri septuaginta viri, omnes filii Ierobbaal, an ut dominetur vobis unus vir? Simulque considerate quod os vestrum et caro vestra sum' '."
,"3":"Locutique sunt fratres matris eius de eo ad omnes viros Sichem universos sermones istos et inclinaverunt cor eorum post Abimelech dicentes: ' Frater noster est '."
,"4":"Dederuntque illi septuaginta pondo argenti de fano Baalberith; qui conduxit sibi ex eo viros inopes et vagos, secutique sunt eum."
,"5":"Et venit in domum patris sui Ephra et occidit fratres suos filios Ierobbaal septuaginta viros super lapidem unum. Remansitque Ioatham filius Ierobbaal minimus, quia absconditus erat."
,"6":"Congregati sunt autem omnes viri Sichem et universae domus Mello abieruntque et constituerunt regem Abimelech iuxta quercum, quae stabat in Sichem."
,"7":"Quod cum nuntiatum esset Ioatham, ivit et stetit in vertice montis Garizim elevataque voce clamavit et dixit: ' Audite me, viri Sichem, ut audiat vos Deus."
,"8":"Ierunt ligna, ut ungerent super se regem, dixeruntque olivae: 'Impera nobis'."
,"9":"Quae respondit: 'Numquid possum deserere pinguedinem meam, qua et dii honorantur et homines, et venire, ut super ligna movear?'."
,"10":"Dixeruntque ligna ad arborem ficum: 'Veni et super nos regnum accipe'."
,"11":"Quae respondit eis: 'Numquid possum deserere dulcedinem meam fructusque suavissimos et ire, ut super cetera ligna movear?'."
,"12":"Locuta quoque sunt ligna ad vitem: 'Veni et impera nobis'."
,"13":"Quae respondit: 'Numquid possum deserere vinum meum, quod laetificat deos et homines, et super ligna cetera commoveri?'."
,"14":"Dixeruntque omnia ligna ad rhamnum: 'Veni et impera super nos'."
,"15":"Quae respondit eis: 'Si vere me regem vobis constituitis, venite et sub mea umbra requiescite; sin autem non vultis, egrediatur ignis de rhamno et devoret cedros Libani!'."
,"16":"Nunc igitur, si recte et absque peccato constituistis super vos regem Abimelech et bene egistis cum Ierobbaal et cum domo eius et reddidistis vicem beneficiis eius,"
,"17":"qui pugnavit pro vobis et animam suam dedit periculis, ut erueret vos de manu Madian,"
,"18":"qui nunc surrexistis contra domum patris mei et interfecistis filios eius septuaginta viros super unum lapidem et constituistis regem Abimelech filium ancillae eius super habitatores Sichem, eo quod frater vester sit;"
,"19":"si ergo recte et absque vitio egistis cum Ierobbaal et domo eius hodie, laetamini in Abimelech, et ille laetetur in vobis."
,"20":"Sin autem perverse, egrediatur ignis ex Abimelech et consumat habitatores Sichem et domum Mello, egrediaturque ignis de viris Sichem et de domo Mello et devoret Abimelech! '."
,"21":"Quae cum Ioatham dixisset, fugit et abiit in Bera habitavitque ibi metu Abimelech fratris sui."
,"22":"Regnavit itaque Abimelech super Israel tribus annis."
,"23":"Misitque Deus spiritum pessimum inter Abimelech et habitatores Sichem, qui rebellaverunt contra eum,"
,"24":"ut scelus interfectionis septuaginta filiorum Ierobbaal et effusio sanguinis eorum veniret super Abimelech fratrem suum et in viros Sichimorum, qui eum adiuverant."
,"25":"Posueruntque insidias adversus eum in montium summitate et exercebant latrocinia agentes praedas de omnibus praetereuntibus. Nuntiatumque est Abimelech."
,"26":"Venit autem Gaal filius Ebed cum fratribus suis et transivit in Sichimam, et confisi sunt habitatores Sichem in eo."
,"27":"Egressi in agros vindemiaverunt vineas uvasque calcaverunt et, factis cantantium choris, ingressi sunt fanum dei sui et inter epulas et pocula maledicebant Abimelech,"
,"28":"clamante Gaal filio Ebed: ' Quis est Abimelech, et quae est Sichem, ut serviamus ei? Numquid non est filius Ierobbaal et Zebul praefectus eius? Servite viris Hemmor patris Sichem! Cur serviemus ei?"
,"29":"Utinam daret aliquis populum istum sub manu mea, ut auferrem de medio Abimelech et dicerem ei: Congrega exercitus multitudinem et veni '."
,"30":"Zebul princeps civitatis, auditis sermonibus Gaal filii Ebed, iratus est valde"
,"31":"et misit clam ad Abimelech nuntios dicens: ' Ecce Gaal filius Ebed venit in Sichimam cum fratribus suis et excitant adversum te civitatem."
,"32":"Surge itaque nocte cum populo, qui tecum est, et latita in agro."
,"33":"Et primo mane, oriente sole, irrue super civitatem; illo autem egrediente adversum te cum populo suo, fac ei, quod potueris '."
,"34":"Surrexit itaque Abimelech cum omni exercitu suo nocte et tetendit insidias iuxta Sichimam in quattuor locis."
,"35":"Egressusque est Gaal filius Ebed et stetit in introitu portae civitatis; surrexit autem Abimelech et omnis exercitus cum eo de insidiarum loco."
,"36":"Cumque vidisset populum Gaal, dixit ad Zebul: ' Ecce de montibus multitudo descendit '. Cui ille respondit: ' Umbras montium vides quasi homines '."
,"37":"Rursumque Gaal ait: ' Ecce populus de Umbilico terrae descendit, et unus cuneus venit per viam Quercus Augurum '."
,"38":"Cui dixit Zebul: ' Ubi est nunc os tuum, quo loquebaris: 'Quis est Abimelech, ut serviamus ei?'. Nonne iste est populus, quem despiciebas? Egredere et pugna contra eum '."
,"39":"Abiit ergo Gaal, spectante Sichimorum populo, et pugnavit contra Abimelech."
,"40":"Qui persecutus est eum fugientem, cecideruntque ex parte eius plurimi usque ad portam civitatis."
,"41":"Et Abimelech sedit in Aruma; Zebul autem Gaal et fratres eius expulit de urbe nec in ea passus est commorari."
,"42":"Sequenti ergo die egressus est populus in campum. Quod cum nuntiatum esset Abimelech,"
,"43":"tulit exercitum suum et divisit in tres turmas tendens insidias in agris. Vidensque quod egrederetur populus de civitate, surrexit et percussit eos."
,"44":"Irruensque cum cuneo suo obsedit ingressum portae civitatis; duae autem turmae palantes per campum adversarios percusserunt."
,"45":"Porro Abimelech omni illo die oppugnabat urbem, quam cepit, interfectis habitatoribus eius ipsaque destructa, ita ut sal in ea dispergeret."
,"46":"Quod cum audissent, qui habitabant in turre Sichimorum, ingressi sunt cryptam fani Elberith (id est dei Foederis)."
,"47":"Abimelech quoque audiens omnes viros turris Sichimorum pariter conglobatos,"
,"48":"ascendit in montem Selmon cum omni populo suo et, arrepta securi, praecidit arboris ramum impositumque ferens umero dixit ad socios: ' Quod me viditis facere, cito facite '."
,"49":"Igitur certatim ramos de arboribus praecidentes sequebantur ducem, quos circumdantes cryptae succenderunt; atque ita factum est, ut fumo et igne omnes homines necarentur, circiter mille viri pariter ac mulieres, habitatores turris Sichem."
,"50":"Abimelech autem inde proficiscens venit ad oppidum Thebes, quod obsidebat et cepit."
,"51":"Erat autem turris fortis in media civitate, ad quam confugerant viri simul ac mulieres et omnes cives civitatis, clausa firmissime ianua, et super turris tectum stantes per propugnacula."
,"52":"Accedensque Abimelech iuxta turrim pugnabat fortiter et appropinquans ostio ignem supponere nitebatur."
,"53":"Et ecce una mulier superiorem molam desuper iaciens illisit capiti Abimelech et confregit cerebrum eius."
,"54":"Qui vocavit cito armigerum suum et ait ad eum: ' Evagina gladium tuum et percute me, ne forte dicatur quod a femina interfectus sim '. Qui transfodit eum."
,"55":"Illoque mortuo, omnes viri Israel hoc videntes reversi sunt in sedes suas."
,"56":"Et reddidit Deus malum, quod fecerat Abimelech contra patrem suum, interfectis septuaginta fratribus suis."
,"57":"Sichimitis quoque, quod operati erant, retributum est, et venit super eos maledictio Ioatham filii Ierobbaal."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Post Abimelech surrexit dux ad salvandum Israel Thola fi lius Phua filii Dodo, vir de Issachar, qui habitavit in Samir montis Ephraim."
,"2":"Et iudicavit Israel viginti et tribus annis mortuusque ac sepultus est in Samir."
,"3":"Huic successit Iair Galaadites, qui iudicavit Israel per viginti et duos annos"
,"4":"habens triginta filios sedentes super triginta pullos asinarum, et ipsis erant triginta civitates, quae appellatae sunt Havoth Iair (id est villae Iair) usque in praesentem diem, in terra Galaad."
,"5":"Mortuusque est Iair ac sepultus in Camon."
,"6":"Filii autem Israel peccatis veteribus iungentes nova fecerunt malum in conspectu Domini et servierunt Baalim et Astharoth et diis Syriae ac Sidonis et Moab et filiorum Ammon et Philisthim; dimiseruntque Dominum et non colebant eum."
,"7":"Contra quos iratus tradidit eos in manu Philisthim et filiorum Ammon."
,"8":"Afflictique sunt et vehementer oppressi per annos decem et octo omnes filii Israel, qui habitabant trans Iordanem in terra Amorraei in Galaad;"
,"9":"in tantum ut filii Ammon Iordanem transirent ad pugnandum etiam contra Iudam et Beniamin et domum Ephraim; afflictusque est Israel nimis."
,"10":"Et clamantes filii Israel ad Dominum dixerunt: ' Peccavimus tibi, quia dereliquimus Deum nostrum et servivimus Baalim '."
,"11":"Quibus locutus est Dominus: ' Numquid non Aegyptii et Amorraei filiique Ammon et Philisthim,"
,"12":"Sidonii quoque et Amalec et Madian oppresserunt vos, et clamastis ad me, et erui vos de manu eorum?"
,"13":"Et tamen reliquistis me et coluistis deos alienos; idcirco non addam ut ultra vos liberem."
,"14":"Ite et invocate deos, quos elegistis: ipsi vos liberent in tempore angustiae! '."
,"15":"Dixeruntque filii Israel ad Dominum: 'Peccavimus; redde tu nobis, quidquid tibi placet, tantum nunc libera nos '."
,"16":"Quae dicentes omnia de finibus suis alienorum deorum idola proiecerunt et servierunt Domino, qui doluit super miseriis Israel."
,"17":"Itaque filii Ammon convocati in Galaad fixere tentoria; contra quos congregati filii Israel in Maspha castrametati sunt."
,"18":"Dixeruntque populus, principes Galaad, singuli ad proximos suos: ' Qui primus contra filios Ammon coeperit dimicare, erit dux omnium habitatorum Galaad '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Fuit Iephte Galaadites vir fortissimus, filius meretricis mulieris, quem genuit Galaad."
,"2":"Habuit autem Galaad uxorem, de qua suscepit filios, qui, postquam creverant, eiecerunt Iephte dicentes: ' Heres in domo patris nostri esse non poteris, quia de altera matre generatus es '."
,"3":"Quos ille fugiens atque devitans habitavit in terra Tob; congregatique sunt ad eum viri inopes et exierunt cum eo."
,"4":"In illis diebus pugnabant filii Ammon contra Israel."
,"5":"Quibus acriter instantibus, perrexerunt maiores natu de Galaad, ut tollerent in auxilium sui Iephte de terra Tob."
,"6":"Dixeruntque ad eum: ' Veni et esto princeps noster, et pugnemus contra filios Ammon '."
,"7":"Quibus ille respondit: ' Nonne vos estis, qui odistis me et eiecistis de domo patris mei? Et nunc venistis ad me necessitate compulsi '."
,"8":"Dixeruntque principes Galaad ad Iephte: ' Ob hanc igitur causam nunc ad te venimus, ut proficiscaris nobiscum et pugnes contra filios Ammon sisque dux omnium, qui habitant in Galaad '."
,"9":"Iephte quoque dixit eis: ' Si revocatis me, ut pugnem pro vobis contra filios Ammon, tradideritque eos Dominus in manus meas, ego ero princeps vester '."
,"10":"Qui responderunt ei: ' Dominus, qui haec audit, ipse mediator ac testis est quod secundum verbum tuum faciemus '."
,"11":"Abiit itaque Iephte cum principibus Galaad, fecitque eum omnis populus principem sui. Locutusque est Iephte omnes sermones suos coram Domino in Maspha."
,"12":"Et misit Iephte nuntios ad regem filiorum Ammon, qui ex persona sua dicerent: ' Quid mihi et tibi est, quia venisti contra me, ut invaderes terram meam? '."
,"13":"Quibus ille respondit: ' Quia tulit Israel terram meam, quando ascendit de Aegypto, a finibus Arnon usque Iaboc atque Iordanem; nunc igitur cum pace redde mihi eam '."
,"14":"Rursumque Iephte nuntios misit et imperavit eis, ut dicerent regi Ammon:"
,"15":"' Haec dicit Iephte: Non tulit Israel terram Moab nec terram filiorum Ammon."
,"16":"Sed, quando de Aegypto conscenderunt, ambulavit Israel per solitudinem usque ad mare Rubrum et venit in Cades;"
,"17":"misitque nuntios ad regem Edom dicens: 'Dimitte, ut transeam per terram tuam'. Qui noluit acquiescere precibus eius. Misit quoque et ad regem Moab, qui et ipse transitum praebere contempsit. Mansit itaque Israel in Cades"
,"18":"et pertransiens desertum circuivit ex latere terram Edom et terram Moab venitque contra orientalem plagam terrae Moab et castrametatus est trans Arnon nec voluit intrare terminos Moab; Arnon quippe confinium est terrae Moab."
,"19":"Misit itaque Israel nuntios ad Sehon regem Amorraeorum, regem Hesebon, et dixit ei: 'Dimitte, ut transeam per terram tuam usque ad locum meum'."
,"20":"Qui et ipse Israel verbis diffidens non dimisit eum transire per terminos suos, sed, omni populo suo congregato, egressus est contra eum in Iasa et fortiter resistebat."
,"21":"Tradiditque eum Dominus in manu Israel cum omni exercitu suo, qui percussit eum et possedit omnem terram Amorraei habitatoris regionis illius,"
,"22":"universos fines eius de Arnon usque Iaboc et de solitudine usque ad Iordanem."
,"23":"Dominus ergo, Deus Israel, subvertit Amorraeum coram populo suo Israel; et tu nunc vis possidere terram eius?"
,"24":"Nonne ea, quae tibi Chamos deus tuus in possessionem dat, tibi iure debentur? Quae autem Dominus Deus noster victor obtinuit, in nostram cedunt possessionem."
,"25":"Num quid melior es Balac filio Sephor rege Moab? Numquid iurgatus est contra Israel et pugnavit contra eum?"
,"26":"Quando habitabat in Hesebon et viculis eius et in Aroer et villis illius et in cunctis civitatibus iuxta Arnon per trecentos annos, quare tanto tempore nihil super hac repetitione tentastis?"
,"27":"Igitur non ego pecco in te, sed tu contra me male agis indicens mihi bella non iusta. Iudicet Dominus arbiter huius diei inter filios Israel et inter filios Ammon '."
,"28":"Noluitque acquiescere rex filiorum Ammon verbis Iephte, quae per nuntios mandaverat."
,"29":"Factus est ergo super Iephte spiritus Domini, et pertransiens Galaad et Manasse venit in Maspha Galaad et inde ad filios Ammon."
,"30":"Votum autem vovit Domino dicens: ' Si tradideris filios Ammon in manus meas,"
,"31":"quicumque primus fuerit egressus de foribus domus meae mihique occurrerit revertenti cum pace a filiis Ammon, eum holocaustum offeram Domino '."
,"32":"Transivitque Iephte ad filios Ammon, ut pugnaret contra eos; quos tradidit Dominus in manus eius."
,"33":"Percussitque eos ab Aroer usque dum venias in Mennith viginti civitates et usque ad Abelcharmim plaga magna nimis; humiliatique sunt filii Ammon a filiis Israel."
,"34":"Revertenti autem Iephte in Maspha domum suam occurrit unigenita filia cum tympanis et choris: non enim habebat alios liberos."
,"35":"Qua visa, scidit vestimenta sua et ait: ' Heu, filia mi, incurvans incurvasti me! Et tu es in eis, qui me perturbant! Aperui enim os meum ad Dominum et aliud facere non potero '."
,"36":"Cui illa respondit: ' Pater mi, si aperuisti os tuum ad Dominum, fac mihi, quodcumque pollicitus es, concessa tibi a Domino ultione atque victoria de hostibus tuis filiis Ammon '."
,"37":"Dixitque ad patrem: ' Hoc solum mihi praesta, quod deprecor: Dimitte me, ut duobus mensibus circumeam montes et plangam virginitatem meam cum sodalibus meis '."
,"38":"Cui ille respondit: ' Vade! '. Et dimisit eam duobus mensibus. Cumque abisset cum sodalibus suis, flebat virginitatem suam in montibus."
,"39":"Expletisque duobus mensibus, reversa est ad patrem suum; et fecit ei, sicut voverat, quae non cognoverat virum. Exinde mos increbuit in Israel, et consuetudo servata est,"
,"40":"ut post anni circulum conveniant in unum filiae Israel et plangant filiam Iephte Galaaditae diebus quattuor."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Ecce autem convocatus vir Ephraim transiit contra aqui lonem, et dixerunt ad Iephte: ' Quare vadens ad pugnam contra filios Ammon vocare nos noluisti, ut pergeremus tecum? Igitur incendemus domum tuam super te '."
,"2":"Quibus ille respondit: ' Disceptatio erat mihi et populo meo contra filios Ammon vehemens, vocavique vos, ut mihi praeberetis auxilium, et facere noluistis."
,"3":"Quod cernens posui in manibus meis animam meam transivique ad filios Ammon, et tradidit eos Dominus in manus meas. Quid commerui, ut hodie adversum me consurgatis in proelium? '."
,"4":"Vocatis itaque ad se cunctis viris Galaad, pugnabat contra Ephraim. Percusseruntque viri Galaad Ephraim, quia dixerat: ' Fugitivi de Ephraim estis; Galaad habitat in medio Ephraim et Manasse '."
,"5":"Occupaveruntque Galaaditae vada Iordanis, per quae Ephraim reversurus erat. Cumque venisset ad ea de Ephraim numero fugiens atque dixisset: ' Obsecro, ut me transire permittatis ', dicebant ei Galaaditae: ' Numquid Ephrathaeus es? '. Quo dicente: ' Non sum ',"
,"6":"interrogabant eum: ' Dic ergo: Scibboleth ' (quod interpretatur Spica). Qui respondebat: ' Sibboleth ', illud recte exprimere non valens. Statimque apprehensum iugulabant in ipso Iordanis transitu. Et ceciderunt in illo tempore de Ephraim quadraginta duo milia."
,"7":"Iudicavitque Iephte Galaadites Israel sex annis et mortuus est ac sepultus in civitate sua in Galaad."
,"8":"Post hunc iudicavit Israel Abesan de Bethlehem."
,"9":"Qui habuit triginta filios et totidem filias emittens foras maritis dedit; et eiusdem numeri filiis suis accepit uxores forinsecus. Qui septem annis iudicavit Israel;"
,"10":"mortuusque est ac sepultus in Bethlehem."
,"11":"Cui successit Ahialon Zabulonites et iudicavit Israel decem annis;"
,"12":"mortuusque est ac sepultus in Ahialon terrae Zabulon."
,"13":"Post hunc iudicavit Israel Abdon filius Illel Pharathonites."
,"14":"Qui habuit quadraginta filios et triginta ex eis nepotes ascendentes super septuaginta pullos asinarum. Et iudicavit Israel octo annis;"
,"15":"mortuusque est ac sepultus in Pharathon terrae Ephraim in monte Amalecite."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Rursumque filii Israel fece runt malum in conspectu Do mini, qui tradidit eos in manus Philisthinorum quadraginta annis."
,"2":"Erat autem vir quidam de Saraa et de stirpe Dan nomine Manue habens uxorem sterilem."
,"3":"Cui apparuit angelus Domini et dixit ad eam: ' Ecce sterilis es et absque liberis, sed concipies et paries filium."
,"4":"Cave ergo, ne vinum bibas ac siceram nec immundum quidquam comedas,"
,"5":"quia ecce concipies et paries filium, cuius non tanget caput novacula: erit enim puer nazaraeus Dei ex matris utero et ipse incipiet liberare Israel de manu Philisthinorum '."
,"6":"Quae cum venisset ad maritum, dixit ei: ' Vir Dei venit ad me habens aspectum sicut angelus Domini, terribilis nimis. Non interrogavi eum, unde esset, nec ipse nomen suum mihi indicavit."
,"7":"Et dixit mihi: 'Ecce concipies et paries filium; cave, ne vinum bibas et siceram et ne aliquo vescaris immundo: erit enim puer nazaraeus Dei ex utero matris usque ad diem mortis suae' '."
,"8":"Oravit itaque Manue Dominum et ait: ' Obsecro, Domine, ut vir Dei, quem misisti, veniat iterum et doceat nos, quid debeamus facere de puero, qui nasciturus est '."
,"9":"Exaudivitque Deus precantem Manue, et venit rursum angelus Dei ad mulierem sedentem in agro. Manue autem maritus eius non erat cum ea."
,"10":"Festinavit ergo et cucurrit ad virum suum nuntiavitque ei dicens: ' Ecce apparuit mihi vir, qui illo die venerat ad me '."
,"11":"Qui surrexit et secutus est uxorem suam veniensque ad virum dixit ei: ' Tu es, qui locutus es mulieri? '. Et ille respondit: ' Ego sum '."
,"12":"Cui Manue: ' Quando, inquit, sermo tuus fuerit expletus, quid circa puerum observare et facere debemus? '."
,"13":"Dixitque angelus Domini ad Manue: ' Ab omnibus, quae locutus sum uxori tuae, abstineat se;"
,"14":"et, quidquid ex vinea nascitur, non comedat, vinum et siceram non bibat, nullo vescatur immundo et, quod ei praecepi, custodiat '."
,"15":"Dixitque Manue ad angelum Domini: ' Obsecro, ut retineamus te et faciamus tibi haedum de capris '."
,"16":"Cui respondit angelus Domini: ' Si me retines, non comedam panes tuos; sin autem vis holocaustum facere, offer illud Domino '. Et nesciebat Manue quod angelus Domini esset."
,"17":"Dixitque ad eum: ' Quod est tibi nomen, ut, si sermo tuus fuerit expletus, honoremus te? '."
,"18":"Cui ille respondit: ' Cur quaeris nomen meum, quod est mirabile? '."
,"19":"Tulit itaque Manue haedum de capris et oblationem similae et posuit super petram offerens Domino, qui facit mirabilia; ipse autem et uxor eius intuebantur."
,"20":"Cumque ascenderet flamma de altari in caelum, angelus Domini in flamma pariter ascendit. Quod cum vidisset Manue et uxor eius, proni ceciderunt in terram;"
,"21":"et ultra non eis apparuit angelus Domini. Statimque intellexit Manue angelum esse Domini"
,"22":"et dixit ad uxorem suam: ' Morte moriemur, quia vidimus Deum '."
,"23":"Cui respondit mulier: ' Si Dominus nos vellet occidere, de manibus nostris holocaustum et oblationem non suscepisset nec ostendisset nobis haec omnia neque talia dixisset '."
,"24":"Peperit itaque filium et vocavit nomen eius Samson. Crevitque puer, et benedixit ei Dominus."
,"25":"Coepitque spiritus Domini impellere eum in Castris Dan inter Saraa et Esthaol."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Descendit igitur Samson in Thamna vidensque ibi mulie rem de filiabus Philisthim"
,"2":"ascendit et nuntiavit patri suo et matri dicens: ' Vidi mulierem in Thamna de filiabus Philisthinorum, quam quaeso ut mihi accipiatis uxorem '."
,"3":"Cui dixerunt pater et mater sua: ' Numquid non est mulier in filiabus fratrum tuorum et in omni populo meo, quia vis accipere uxorem de Philisthim, qui incircumcisi sunt? '. Dixitque Samson ad patrem suum: ' Hanc mihi accipe, quia placuit oculis meis '."
,"4":"Parentes autem eius nesciebant quod res a Domino fieret, et quaereret occasionem contra Philisthim. Eo enim tempore Philisthim dominabantur Israeli."
,"5":"Descendit itaque Samson cum patre suo et matre in Thamna. Cumque venissent ad vineas oppidi, apparuit catulus leonis rugiens et occurrit ei."
,"6":"Irruit autem spiritus Domini in Samson, et dilaceravit leonem, quasi haedum in frusta concerperet, nihil omnino habens in manu; et hoc patri et matri noluit indicare."
,"7":"Descenditque et locutus est mulieri, quae placuerat oculis eius."
,"8":"Et post aliquot dies revertens, ut acciperet eam, declinavit, ut videret cadaver leonis; et ecce examen apum in corpore leonis erat ac favus mellis."
,"9":"Quem, cum sumpsisset in manibus, comedebat in via; veniensque ad patrem suum et matrem dedit eis partem, qui et ipsi comederunt. Nec tamen eis voluit indicare quod mel de corpore leonis assumpserat."
,"10":"Descendit itaque pater eius ad mulierem, et fecit ibi Samson convivium; sic enim iuvenes facere consuerant."
,"11":"Cum ergo cives loci illius vidissent eum, dederunt ei sodales triginta, qui essent cum eo."
,"12":"Quibus locutus est Samson: ' Proponam vobis problema, quod si solveritis mihi intra septem dies convivii, dabo vobis triginta tunicas et totidem vestes mutatorias;"
,"13":"sin autem non potueritis solvere, vos dabitis mihi triginta tunicas et eiusdem numeri vestes mutatorias '. Qui responderunt ei: ' Propone problema, ut audiamus '."
,"14":"Dixitque eis: ' De comedente exivit cibus, et de forti est egressa dulcedo '. Nec potuerunt per tres dies propositionem solvere. "
,"15":"Cumque adesset dies quartus, dixerunt ad uxorem Samson: ' Blandire viro tuo et suade ei, ut indicet tibi quid significet problema. Quod si facere nolueris, incendemus et te et domum patris tui. An idcirco nos vocastis ad nuptias, ut spoliaretis? '."
,"16":"Quae fundebat apud Samson lacrimas et querebatur dicens: ' Odisti me et non diligis; idcirco problema, quod proposuisti filiis populi mei, non vis mihi exponere '. At ille respondit: ' Patri meo et matri nolui dicere et tibi indicare potero? '."
,"17":"Septem igitur diebus convivii flebat apud eum; tandemque die septimo, cum ei molesta esset, exposuit. Quae statim indicavit civibus suis,"
,"18":"et illi dixerunt ei die septimo ante solis occubitum: ' Quid dulcius melle, et quid leone fortius? '. Qui ait ad eos: ' Si non arassetis in vitula mea, non invenissetis propositionem meam '."
,"19":"Irruit itaque in eo spiritus Domini, descenditque Ascalonem et percussit ibi triginta viros, quorum ablatas vestes dedit iis, qui problema solverant; iratusque nimis ascendit in domum patris sui."
,"20":"Uxor autem eius accepit maritum unum de amicis eius, qui erat pronubus."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Post aliquantum autem tem poris, cum dies triticeae mes sis instarent, venit Samson invisere volens uxorem suam et attulit ei haedum de capris. Cumque ad eam vellet intrare, prohibuit eum pater illius"
,"2":"dicens: ' Putavi quod odisses eam et ideo tradidi illam amico tuo; sed habet sororem iuniorem, quae pulchrior illa est; sit tibi pro ea uxor '."
,"3":"Dixitque eis Samson: ' Hac vice non erit culpa in me contra Philisthaeos, cum faciam eis mala '."
,"4":"Perrexitque et cepit trecentas vulpes caudasque earum iunxit ad caudas sumensque faces ligavit singulas in medio binarum caudarum;"
,"5":"facibusque igne succensis, dimisit vulpes in segetes Philisthinorum. Et comportatae iam fruges et adhuc stantes in stipula concrematae sunt in tantum, ut vineas quoque et oliveta flamma consumeret."
,"6":"Dixeruntque Philisthim: ' Quis fecit hanc rem? '. Quibus dictum est: ' Samson gener Thamnathaei, quia tulit uxorem eius et alteri tradidit, haec operatus est '. Ascenderuntque Philisthim et combusserunt tam mulierem quam patrem eius."
,"7":"Quibus ait Samson: ' Si talia facitis, utique ex vobis expetam ultionem et tunc quiescam '."
,"8":"Percussitque eos ingenti plaga, suram ad femur. Et descendens habitavit in spelunca petrae Etam."
,"9":"Igitur ascendentes Philisthim in terra Iudae castrametati sunt, et in Lehi (id est Maxilla) eorum est fusus exercitus."
,"10":"Dixeruntque ad eos viri de tribu Iudae: ' Cur ascendistis adversum nos? '. Qui responderunt: ' Ut ligemus Samson venimus et reddamus ei, quae in nos operatus est '."
,"11":"Descenderunt ergo tria milia virorum de Iuda ad specum petrae Etam dixeruntque ad Samson: ' Nescis quod Philisthim imperent nobis? Quare hoc nobis facere voluisti? '. Quibus ille ait: ' Sicut fecerunt mihi, feci eis '."
,"12":"' Ligare, inquiunt, te venimus et tradere in manus Philisthinorum '. ' Iurate, respondit, mihi quod non me occidatis '."
,"13":"Dixerunt: ' Non te occidemus, sed vinctum trademus '. Ligaveruntque eum duobus novis funibus et tulerunt de petra Etam."
,"14":"Qui cum venisset in Lehi, et Philisthim vociferantes occurrissent ei, irruit spiritus Domini in eum, et, sicut solent ad odorem ignis lina consumi, ita vincula, quibus brachia eius ligata erant, dissipata sunt et soluta."
,"15":"Inventamque maxillam asini recentem arripiens percussit in ea mille viros"
,"16":"et ait: ' In maxilla asini,acervum feci ex eis!,In mandibula asini,percussi mille viros! '."
,"17":"Cumque haec canens verba complesset, proiecit mandibulam de manu et vocavit nomen loci illius Ramathlehi (quod interpretatur Elevatio maxillae)."
,"18":"Sitiensque valde clamavit ad Dominum et ait: ' Tu dedisti in manu servi tui salutem hanc maximam atque victoriam; et en siti morior incidamque in manus incircumcisorum '."
,"19":"Aperuit itaque Deus fossam in Lehi, et egressae sunt inde aquae; quibus haustis, refocillavit spiritum et vires recepit. Idcirco appellatum est nomen fontis illius fons Invocantis, qui est in Lehi usque in praesentem diem."
,"20":"Iudicavitque Israel in diebus Philisthim viginti annis."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Abiit Samson in Gazam et vidit ibi meretricem mulie rem ingressusque est ad eam."
,"2":"Cum nuntiatum esset Gazaeis intrasse urbem Samson, circuierunt et insidiabantur ei in porta civitatis; tota autem nocte quieverunt praestolantes, ut, facto mane, exeuntem occiderent."
,"3":"Dormivit autem Samson usque ad noctis medium et inde consurgens apprehendit ambas portae fores cum postibus suis et evellit eas cum sera, impositasque umeris portavit ad verticem montis, qui respicit Hebron."
,"4":"Post haec amavit mulierem, quae habitabat in valle Sorec et vocabatur Dalila."
,"5":"Veneruntque ad eam principes Philisthinorum atque dixerunt: ' Decipe eum et disce ab illo in quo tantam habeat fortitudinem, et quomodo eum superare valeamus et vinctum humiliare; quod si feceris, dabimus tibi singuli mille centum argenteos '."
,"6":"Locuta est ergo Dalila ad Samson: ' Dic mihi, obsecro, in quo sit tua maxima fortitudo, et quid sit, quo ligatus humilieris '."
,"7":"Cui respondit Samson: ' Si septem nerviceis funibus necdum siccis et adhuc humentibus ligatus fuero, deficiam eroque ut ceteri homines '."
,"8":"Attuleruntque ad eam satrapae Philisthinorum septem funes, ut dixerat; quibus vinxit eum,"
,"9":"latentibus apud se insidiis in cubiculo. Clamavitque ad eum: ' Philisthim super te, Samson! '. Qui rupit vincula, quomodo si rumpat quis filum de stuppa tortum, cum odorem ignis acceperit; et non est cognitum in quo esset fortitudo eius."
,"10":"Dixitque ad eum Dalila: ' Ecce illusisti mihi et falsum locutus es; saltem nunc indica mihi quo ligari debeas '."
,"11":"Cui ille respondit: ' Si ligatus fuero novis funibus, qui numquam fuerunt in opere, infirmus ero et aliorum hominum similis '."
,"12":"Quibus rursum Dalila vinxit eum et clamavit: ' Philisthim super te, Samson! ', in cubiculo insidiis praeparatis. Qui ita rupit vincula brachiorum quasi fila telarum."
,"13":"Dixitque Dalila rursum ad eum: ' Usquequo decipis me et falsum loqueris? Ostende quo vinciri debeas '. Cui respondit Samson: ' Si septem crines nexos capitis mei cum licio plexueris et paxillo fixeris, deficiam eroque ut ceteri homines '."
,"14":"Quae cum dormire eum fecisset et septem crines nexos capitis eius cum licio plexisset et paxillo fixisset, dixit ad eum: ' Philisthim super te, Samson! '. Qui consurgens de somno extraxit paxillum cum navicula et licio."
,"15":"Dixitque ad eum Dalila: ' Quomodo dicis quod ames me, cum animus tuus non sit mecum? Per tres vices mentitus es mihi et noluisti dicere in quo sit tua maxima fortitudo '."
,"16":"Cumque molesta ei esset et per multos dies iugiter eum urgeret, defecit anima eius et ad mortem usque lassata est."
,"17":"Tunc aperiens ei totum cor suum dixit ad eam: ' Novacula numquam ascendit super caput meum, quia nazaraeus consecratus Deo sum de utero matris meae; si rasum fuerit caput meum, recedet a me fortitudo mea, et deficiam eroque ut ceteri homines '."
,"18":"Videns illa quod confessus ei esset omnem animum suum, misit ad principes Philisthinorum atque mandavit: ' Ascendite adhuc semel, quia nunc mihi aperuit totum cor suum '. Qui ascenderunt, assumpta pecunia, quam promiserant."
,"19":"At illa dormire eum fecit super genua sua vocavitque tonsorem et fecit radere septem crines eius et coepit humiliare eum; statim enim ab eo fortitudo discessit."
,"20":"Dixitque: ' Philisthim super te, Samson! '. Qui de somno consurgens dixit in animo suo: ' Egrediar, sicut ante feci, et me excutiam ', nesciens quod Dominus recessisset ab eo."
,"21":"Quem cum apprehendissent Philisthim, statim eruerunt oculos eius et duxerunt Gazam vinctum duabus catenis aeneis et clausum in carcere molere fecerunt."
,"22":"Iamque capilli eius renasci coeperant, postquam rasi sunt."
,"23":"Principes autem Philisthinorum convenerunt in unum, ut immolarent hostias magnificas Dagon deo suo et epularentur dicentes: ' Tradidit deus noster,in manus nostras,inimicum nostrum Samson '."
,"24":"Quem etiam populus videns laudabat deum suum eademque dicebat: ' Tradidit deus noster in manus nostras,adversarium nostrum, qui vastavit terram nostram,et occidit plurimos nostrum '."
,"25":"Cum enim iam hilariores essent, postulaverunt, ut vocaretur Samson et ante eos luderet. Qui adductus de carcere ludebat ante eos; feceruntque eum stare inter duas columnas."
,"26":"Qui dixit puero tenenti manum suam: ' Dimitte me, ut tangam columnas, quibus imminet domus, et recliner super eas et paululum requiescam '."
,"27":"Domus autem plena erat virorum ac mulierum; et erant ibi omnes principes Philisthinorum, ac de tecto circiter tria milia utriusque sexus spectabant ludentem Samson."
,"28":"At ille invocavit Dominum dicens: ' Domine Deus, memento mei! Et redde mihi tantum hac vice fortitudinem pristinam, Deus, ut ulciscar me de Philisthim saltem pro uno duorum luminum meorum! '."
,"29":"Et tangens ambas columnas medias, quibus innitebatur domus, obnixusque contra alteram earum dextera et contra alteram laeva"
,"30":"ait: ' Moriatur anima mea cum Philisthim! '. Concussisque fortiter columnis, cecidit domus super omnes principes et ceteram multitudinem, quae ibi erat; multoque plures interfecit moriens, quam ante vivus occiderat."
,"31":"Descendentes autem fratres eius et universa cognatio tulerunt corpus eius et sepelierunt inter Saraa et Esthaol in sepulcro patris sui Manue; iudicavitque Israel viginti annis."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Fuit vir quidam de monte Ephraim nomine Michas,"
,"2":"qui dixit matri suae: ' Mille centum argenteos, qui ablati sunt a te et super quibus, me audiente, maledicens iuraveras, ecce ego habeo; ego abstuli '. Cui illa respondit: ' Benedictus filius meus Domino! '."
,"3":"Reddidit ergo eos matri suae, quae dixit ei: ' Consecravi et vovi argentum hoc Domino: de manu mea suscipiat pro filio meo, ut faciat sculptile atque conflatile. Et nunc trado illud tibi '."
,"4":"Reddiditque eos matri suae, quae tulit ducentos argenteos et dedit eos argentario, ut faceret ex eis sculptile atque conflatile, quod fuit in domo Michae,"
,"5":"qui aediculam Dei habens fecit ephod ac theraphim implevitque unius filiorum suorum manum, et factus est ei sacerdos."
,"6":"In diebus illis non erat rex in Israel, sed unusquisque, quod sibi rectum videbatur, hoc faciebat."
,"7":"Fuit quoque adulescens de Bethlehem Iudae ex cognatione Iudae; eratque ipse Levites et habitabat ibi ut advena."
,"8":"Egressusque de civitate Bethlehem peregrinari voluit ubicumque sibi commodum repperisset. Cumque iter faciens venisset in monte Ephraim usque ad domum Michae,"
,"9":"interrogatus est ab eo unde venisset. Qui respondit: ' Levita sum de Bethlehem Iudae et vado, ut habitem, ubi potuero et utile mihi esse perspexero '."
,"10":"Dixitque Michas: ' Mane apud me et esto mihi parens ac sacerdos; daboque tibi per annos singulos decem argenteos ac vestium apparatum et quae ad victum sunt necessaria '."
,"11":"Acquievit et mansit apud hominem fuitque illi quasi unus de filiis."
,"12":"Implevitque Michas manum eius et habuit puerum sacerdotem apud se,"
,"13":"' nunc scio, dicens, quod benefaciet mihi Dominus habenti levitici generis sacerdotem '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"In diebus illis non erat rex in Israel, et tribus Dan quaere bat possessionem sibi, ut habitaret in ea; usque ad illum enim diem inter ceteras tribus sortem non acceperat."
,"2":"Miserunt igitur filii Dan stirpis et familiae suae quinque viros fortissimos de Saraa et Esthaol, ut explorarent terram et diligenter inspicerent, dixeruntque eis: ' Ite et considerate terram '. Qui cum venissent in montem Ephraim usque ad domum Michae, pernoctaverunt ibi."
,"3":"Cum essent prope domum Michae, agnoscentes vocem adulescentis Levitae declinaverant illuc dicentes ad eum: ' Quis te huc adduxit? Quid hic agis? Quam ob causam huc venire voluisti? '."
,"4":"Qui respondit eis: ' Haec et haec praestitit mihi Michas et me mercede conduxit, ut sim ei sacerdos '."
,"5":"Rogaveruntque eum, ut consuleret Deum, ut scire possent an prospero itinere pergerent, et res haberet effectum."
,"6":"Qui respondit eis: ' Ite cum pace; Dominus respicit viam vestram et iter, quo pergitis '."
,"7":"Euntes itaque quinque viri venerunt Lais videruntque populum habitantem in ea absque ullo timore iuxta Sidoniorum consuetudinem, securum et quietum, nullo eis penitus resistente, magnarumque opum et procul a Sidoniis neque in societate cum Syria."
,"8":"Reversique ad fratres suos in Saraa et Esthaol et quid egissent sciscitantibus, responderunt:"
,"9":"' Surgite, et ascendamus adversus eos. Vidimus enim terram valde opulentam et uberem, et vos neglegetis? Nolite cessare; eamus et possideamus eam."
,"10":"Intrabimus ad securos in regionem latissimam; tradetque nobis Deus locum, in quo nullius rei est penuria eorum, quae sunt in terra '."
,"11":"Profecti igitur sunt de cognatione Dan, de Saraa et Esthaol, sescenti viri accincti armis bellicis."
,"12":"Ascendentesque castrametati sunt in Cariathiarim Iudae, qui locus ex eo tempore Castrorum Dan nomen accepit et est post tergum Cariathiarim."
,"13":"Inde transierunt in montem Ephraim. Cumque venissent usque ad domum Michae, "
,"14":"dixerunt quinque viri, qui prius missi fuerant ad considerandam terram Lais, fratribus suis: ' Nostis quod in domibus istis sit ephod et theraphim et sculptile atque conflatile? Videte quid vobis placeat, ut faciatis '."
,"15":"Et, cum paululum declinassent, ingressi sunt domum adulescentis Levitae, domum Michae, salutaveruntque eum verbis pacificis."
,"16":"Sescenti autem viri, ita ut erant armati, stabant ante ostium."
,"17":"At illi, qui ingressi fuerant domum iuvenis, sculptile et ephod et theraphim atque conflatile tulerunt; et sacerdos stabat ante ostium et sescenti viri armati."
,"18":"Tulerunt igitur, qui intraverant domum, sculptile, ephod et theraphim atque conflatile. Quibus dixit sacerdos: ' Quid facitis? '."
,"19":"Cui responderunt: ' Tace et pone digitum super os tuum venique nobiscum, ut habeamus te patrem et sacerdotem. Quid tibi melius est, ut sis sacerdos in domo unius viri, an in una tribu et familia in Israel? '."
,"20":"Et gavisus est sacerdos tulitque ephod et theraphim ac sculptile et profectus est in medio populi."
,"21":"Qui cum pergerent et ante se ire fecissent parvulos et iumenta et omne, quod erat pretiosum,"
,"22":"iamque a domo Michae essent procul, viri, qui habitabant in aedibus prope domum Michae, convocati secuti sunt filios Dan"
,"23":"et post tergum clamare coeperunt. Qui cum respexissent, dixerunt ad Micham: ' Quid tibi vis? Cur concurritis? '."
,"24":"Qui respondit: ' Deos meos, quos mihi feci, tulistis, et sacerdotem et omnia, quae habeo, et dicitis: 'Quid tibi est?' '."
,"25":"Dixeruntque ei filii Dan: ' Cave, ne ultra loquaris ad nos, et irruant in te viri animo concitati, et ipse cum omni domo tua pereas '."
,"26":"Et sic, coepto itinere, perrexerunt. Videns autem Michas quod fortiores se essent, reversus est in domum suam."
,"27":"Sescenti autem viri tulerunt, quod Michas fecerat, et sacerdotem eius veneruntque in Lais ad populum quiescentem atque securum et percusserunt eos in ore gladii urbemque incendio tradiderunt,"
,"28":"nullo penitus ferente praesidium, eo quod procul habitarent a Sidone neque cum Syria haberent quidquam societatis ac negotii. Erat autem civitas sita in regione Rohob; quam rursum exstruentes habitaverunt in ea, "
,"29":"vocato nomine civitatis Dan iuxta vocabulum patris sui, quem genuerat Israel, quae prius Lais dicebatur."
,"30":"Posueruntque sibi sculptile; et Ionathan filius Gersam filii Moysi ac filii eius sacerdotes erant in tribu Dan usque ad diem captivitatis terrae;"
,"31":"mansitque apud eos idolum Michae omni tempore, quo fuit domus Dei in Silo."
}`)
	CurrentBook.AddChapter(19, `{
"1":"In diebus illis non erat rex in Israel. Fuit quidam vir Levi tes habitans ut advena in extrema parte montis Ephraim, qui accepit concubinam de Bethlehem Iudae."
,"2":"Quae irritata reversa est in domum patris sui in Bethlehem mansitque apud eum quattuor mensibus."
,"3":"Secutusque est eam vir suus volens loqui ad cor eius et secum reducere habens in comitatu puerum et duos asinos. Quae suscepit eum et introduxit in domum patris sui. Quem cum socer eius vidisset, occurrit ei laetus"
,"4":"et retinuit hominem. Mansitque gener in domo soceri tribus diebus comedens cum eo et bibens familiariter."
,"5":"Die autem quarto, cum de nocte consurrexissent, et ille proficisci vellet, socer ait ad eum: ' Gusta prius pauxillum panis et conforta cor tuum et sic proficisceris '."
,"6":"Sederuntque ambo simul et comederunt ac biberunt. Dixitque pater puellae ad generum suum: ' Quaeso te, ut hodie hic maneas, pariterque laetemur '."
,"7":"At ille consurgens coepit velle proficisci. Et nihilominus obnixe eum socer tenuit et apud se fecit manere."
,"8":"Mane autem facto, quinta die parabat Levites iter; cui socer rursum: ' Oro te, inquit, ut confortes cor tuum'. Et tardabant, donec declinaret dies; et ambo comederunt simul."
,"9":"Surrexitque adulescens, ut pergeret cum uxore sua et puero. Cui rursum locutus est socer eius pater puellae: ' Considera quod dies ad occasum declivior sit et propinquet ad vesperum; manete apud me etiam hodie, pernocta hic et esto laeto animo, et cras mane proficiscemini, ut vadas in domum tuam '."
,"10":"Noluit gener acquiescere sermonibus eius, sed statim perrexit et venit contra Iebus, id est Ierusalem, ducens secum duos asinos onustos et concubinam."
,"11":"Iamque aderant iuxta Iebus, et dies mutabatur in noctem; dixitque puer ad dominum suum: ' Veni, obsecro, declinemus ad urbem Iebusaeorum et maneamus in ea '."
,"12":"Cui respondit dominus: ' Non ingrediamur oppidum gentis alienae, quae non est de filiis Israel, sed transibimus usque Gabaa '."
,"13":"Dixitque puero suo: 'Veni, accedamus ad unum de locis et manebimus in Gabaa aut Rama '."
,"14":"Transierunt igitur Iebus et coeptum carpebant iter; occubuitque eis sol iuxta Gabaa, quae est in tribu Beniamin."
,"15":"Diverteruntque ad eam, ut manerent ibi; quo cum intrassent, sedebant in platea civitatis, et nullus eos recipere volebat hospitio."
,"16":"Et ecce apparuit homo senex revertens de agro et de opere suo vespere, qui et ipse erat de monte Ephraim et peregrinus habitabat in Gabaa; homines autem loci illius erant de tribu Beniamin."
,"17":"Elevatisque oculis, vidit senex sedentem hominem viatorem in platea civitatis et dixit ad eum: ' Unde venis et quo vadis? '."
,"18":"Qui respondit ei: ' Profecti sumus de Bethlehem Iudae et pergimus ad locum meum, qui est in extrema parte montis Ephraim, unde profectus sum in Bethlehem. Et nunc vado ad domum meam, nullusque sub tectum suum me vult recipere"
,"19":"habentem paleas et pabulum pro asinis nostris et panem ac vinum in meos et ancillae tuae usus et pueri, qui cum servo tuo sunt; nulla re indigemus nisi hospitio '."
,"20":"Cui respondit senex: ' Pax tecum sit! Ego praebebo omnia, quae necessaria sunt; tantum, quaeso, ne in platea maneas '."
,"21":"Introduxitque eum in domum suam et commixtum migma asinis praebuit; ac, postquam laverunt pedes suos, recepit eos in convivium."
,"22":"Illis laeto corde epulantibus, venerunt viri civitatis illius filii Belial et circumdantes domum senis fores pulsare coeperunt clamantes ad dominum domus atque dicentes: ' Educ virum, qui ingressus est domum tuam, ut abutamur eo '."
,"23":"Egressusque est ad eos senex et ait: ' Nolite, fratres, nolite facere malum hoc, quia ingressus est homo hospitium meum, et cessate ab hac stultitia."
,"24":"Habeo filiam virginem, et hic homo habet concubinam; educam eas ad vos, ut humilietis eas et faciatis eis, quod vobis placuerit; tantum, obsecro, ne scelus hoc operemini in virum '."
,"25":"Nolebant acquiescere sermonibus eius; quod cernens homo apprehendit et eduxit ad eos concubinam suam. Qua cum abusi essent et tota nocte ei illusissent, dimiserunt eam mane."
,"26":"At mulier, recedentibus tenebris, venit ad ostium domus, ubi manebat dominus suus, et ibi corruit."
,"27":"Mane facto surrexit homo et aperuit ostium, ut coeptam expleret viam; et ecce concubina eius iacebat ante ostium, sparsis in limine manibus."
,"28":"Cui ille loquebatur: ' Surge, ut ambulemus '. Qua nihil respondente, intellegens quod erat mortua, tulit eam et imposuit asino; reversusque est in domum suam."
,"29":"Quam cum esset ingressus, arripuit gladium et cadaver uxoris secundum ossa sua in duodecim partes ac frusta concidens misit in omnes terminos Israel."
,"30":"Quod cum vidissent singuli, conclamabant: ' Numquam res talis facta et visa est in Israel ex eo die, quo ascenderunt patres nostri de Aegypto, usque in praesens tempus! '. Praeceperat enim viris, quos miserat, dicens: ' Haec dicite omni viro Israel: Si factum est quidquam tale ex die, quo ascenderunt filii Israel de terra Aegypti, usque ad praesentem diem? Attendite ad hoc, consiliamini et decernite quid facto opus sit!'."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Egressi sunt itaque omnes fi lii Israel et pariter congrega ti, quasi vir unus, de Dan usque Bersabee et terra Galaad ad Dominum in Maspha."
,"2":"Omnisque populi anguli et cunctae tribus Israel in ecclesiam populi Dei convenerunt: quadringenta milia peditum pugnatorum."
,"3":"Nec latuit filios Beniamin, quod ascendissent filii Israel in Maspha. Interrogatusque Levita maritus mulieris interfectae quo modo tantum scelus perpetratum esset,"
,"4":"respondit: ' Veni in Gabaa Beniamin cum uxore mea illucque diverti."
,"5":"Et ecce homines civitatis illius circumdederunt nocte domum, in qua manebam, volentes me occidere et uxorem meam incredibili libidinis furore vexantes; denique mortua est."
,"6":"Quam arreptam in frusta concidi misique partes in omnes terminos possessionis Israel, quia fecerunt nefas et piaculum in Israel."
,"7":"Adestis omnes, filii Israel: decernite quid facere debeatis '."
,"8":"Stansque omnis populus quasi unius hominis sermone respondit: ' Non recedemus in tabernacula nostra, nec suam quisquam intrabit domum,"
,"9":"sed hoc contra Gabaa in commune faciemus secundum sortem:"
,"10":"decem viri eligantur e centum ex omnibus tribubus Israel et centum de mille et mille de decem milibus, ut comportent exercitui cibaria illis, qui venerunt, ut reddant Gabaa Beniamin pro scelere, quod meretur '."
,"11":"Convenitque universus Israel ad civitatem quasi unus homo, eadem mente unoque consilio,"
,"12":"et miserunt nuntios ad omnem tribum Beniamin, qui dicerent: ' Quale nefas in vobis repertum est!"
,"13":"Tradite homines filios Belial in Gabaa, qui hoc flagitium perpetrarunt, ut moriantur, et auferatur malum de Israel '. Qui noluerunt fratrum suorum filiorum Israel audire mandatum, "
,"14":"sed ex cunctis urbibus, quae suae sortis erant, convenerunt in Gabaa, ut illis ferrent auxilium et contra universum Israel populum dimicarent."
,"15":"Recensitique sunt in die illa viginti sex milia de civitatibus Beniamin educentium gladium, praeter habitatores Gabaa, qui septingenti erant viri fortissimi."
,"16":"In universo hoc populo erant septingenti viri electi, qui sinistra pro dextra utebantur et sic fundis lapides ad certum iaciebant, ut capillum quoque possent percutere, et nequaquam in alteram partem ictus lapidis deferretur."
,"17":"Virorum quoque Israel, absque filiis Beniamin, recensita sunt quadringenta milia educentium gladios et paratorum ad pugnam."
,"18":"Qui surgentes venerunt in Bethel consulueruntque Deum atque dixerunt: ' Quis erit in exercitu nostro princeps certaminis contra filios Beniamin? '. Quibus respondit Dominus: ' Iuda ascendet primus '."
,"19":"Statimque filii Israel surgentes mane castrametati sunt contra Gabaa;"
,"20":"et inde procedentes ad pugnam contra Beniamin, contra urbem aciem direxerunt."
,"21":"Egressique filii Beniamin de Gabaa occiderunt de filiis Israel die illo viginti duo milia viros."
,"22":"Rursum filii Israel confortati in eodem loco, in quo prius certaverant, aciem direxerunt,"
,"23":"ita tamen ut prius ascenderent et flerent coram Domino usque ad noctem consulerentque eum et dicerent: ' Debeo ultra procedere ad dimicandum contra filios Beniamin fratres meos, an non? '. Quibus ille respondit: ' Ascendite ad eos '."
,"24":"Cumque filii Israel altero die contra filios Beniamin ad proelium processissent,"
,"25":"eruperunt filii Beniamin de Gabaa et occurrentes eis iterum decem et octo milia virorum educentium gladium prostraverunt."
,"26":"Quam ob rem omnes filii Israel, universus populus, venerunt in Bethel et sedentes flebant coram Domino ieiunaveruntque die illo usque ad vesperam et obtulerunt ei holocausta et pacificas victimas"
,"27":"et super statu suo interrogaverunt. Eo tempore ibi erat arca foederis Dei,"
,"28":"et Phinees filius Eleazari filii Aaron stabat coram eo. Consuluerunt igitur Dominum atque dixerunt: ' Exire ultra debemus ad pugnam contra filios Beniamin fratres nostros, an quiescere? '. Quibus ait Dominus: ' Ascendite, cras enim tradam eos in manus vestras '."
,"29":"Posueruntque filii Israel insidias per circuitum urbis Gabaa"
,"30":"et tertia vice sicut semel et bis contra Beniamin et Gabaa exercitum produxerunt."
,"31":"Sed et filii Beniamin eruperunt in occursum populi et abstracti de civitate coeperunt caedere ex eis sicut primo et secundo die, per duas semitas terga vertentes, quarum una ferebat in Bethel, altera in Gabaa, atque prosternere in campo triginta circiter viros."
,"32":"Putaverunt enim solito eos more percussos cedere; qui fugam simulaverunt, ut abstraherent eos de civitate et quasi fugientes ad supradictas semitas perducerent."
,"33":"Omnes itaque viri Israel surgentes de sedibus suis tetenderunt aciem in loco, qui vocatur Baalthamar. Insidiae quoque eruperunt de loco suo, de regione in occidente Gabaa."
,"34":"Venerunt ergo adversus Gabaa decem milia virorum electorum de universo Israel. Ingravatumque est bellum contra filios Beniamin, et non intellexerunt quod ex omni parte illis instaret interitus."
,"35":"Percussitque eos Dominus in conspectu filiorum Israel, et interfecerunt ex eis in illo die viginti quinque milia et centum viros, omnes bellatores et educentes gladium."
,"36":"Filii autem Beniamin, cum se inferiores esse vidissent, coeperunt fugere. Quod cernentes filii Israel, dederunt eis ad fugiendum locum, quia confidebant in insidiis, quas iuxta urbem posuerant."
,"37":"Qui cum repente de latibulis surrexissent, irruerunt super Gabaa et ingressi celeriter percusserunt totam civitatem in ore gladii."
,"38":"Signum autem dederant filii Israel his, quos in insidiis collocaverant, ut ignem accenderent et, ascendente in altum fumo, captam urbem demonstrarent."
,"39":"Verterant ergo terga filii Israel in ipso certamine positi, et filii Beniamin putantes quod percussissent eos sicut in priore pugna, coeperant de exercitu eorum caedere triginta fere viros."
,"40":"Cum autem columna fumi de civitate conscendere coepisset, et Beniamin quoque retro aspiciens cerneret de civitate flammas in sublime ferri,"
,"41":"cumque vir Israel versa facie aggrederetur, vir Beniamin conturbatus est, quia vidit se apprehensum a malo."
,"42":"Et ad viam deserti ire coeperunt, illuc quoque eos adversariis persequentibus. Sed et hi, qui urbem succenderant, occurrerunt eis,"
,"43":"atque ita factum est ut ex utraque parte ab hostibus caederentur, nec erat eis ulla requies. Prostrati sunt usque ad orientalem plagam urbis Gabaa."
,"44":"Fuerunt autem, qui interfecti sunt de Beniamin, decem et octo milia virorum omnes robustissimi pugnatores."
,"45":"Qui remanserant, fugerunt in solitudinem et pergebant ad petram, cuius vocabulum est Remmon. Quasi racemos colligentes occiderunt in viis quinque milia viros. Et cum instantius eos persequerentur usque Gadaam, interfecerunt etiam alios duo milia."
,"46":"Et sic factum est ut omnes, qui ceciderant de Beniamin in die illa, essent viginti quinque milia pugnatores ad bella promptissimi."
,"47":"Remanserunt itaque, qui evadere potuerant et fugere in solitudinem, sescenti viri; sederuntque in petra Remmon mensibus quattuor."
,"48":"Regressi autem filii Israel ex civitatibus a viris usque ad iumenta, usque ad omne, quod inveniri poterat, gladio percusserunt, cunctasque urbes et viculos Beniamin vorax flamma consumpsit."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Iuraverunt autem filii Israel in Maspha et dixerunt: ' Nullus nostrum dabit filiis Beniamin de filiabus suis uxorem '."
,"2":"Venitque populus in Bethel, et in conspectu Dei sedentes usque ad vesperam levaverunt vocem et magno ululatu coeperunt flere dicentes:"
,"3":"' Quare, Domine, Deus Israel, factum est hoc in populo tuo, ut hodie una tribus auferretur de Israel? '."
,"4":"Altera autem die diluculo consurgentes exstruxerunt altare obtuleruntque ibi holocausta et pacificas victimas"
,"5":"et dixerunt: ' Quis non ascendit in congregationem ad Dominum de universis tribubus Israel? '. Grandi enim se iuramento constrinxerant interfici eos, qui non ascendissent ad Dominum in Maspha."
,"6":"Ductique paenitentia filii Israel super fratre suo Beniamin coeperunt dicere: ' Ablata est hodie una tribus de Israel."
,"7":"Quid faciemus, ut, qui remanserunt, uxores accipiant? Omnes enim in commune iuravimus per Dominum non daturos nos his filias nostras '."
,"8":"Idcirco dixerunt: ' Quis est de universis tribubus Israel, qui non ascendit ad Dominum in Maspha? '. Et ecce nemo de Iabes Galaad in castra venerat ad congregationem,"
,"9":"et, cum populus recenseretur, nullus ex eis repertus est."
,"10":"Misit itaque coetus decem milia viros robustissimos et praeceperunt eis: ' Ite et percutite habitatores Iabes Galaad in ore gladii tam uxores quam parvulos eorum."
,"11":"Et hoc erit, quod observare debetis: Omne generis masculini et mulieres, quae cognoverunt viros, interficite; virgines autem reservate '."
,"12":"Inventaeque sunt de Iabes Galaad quadringentae virgines, quae nescierunt viri torum, et adduxerunt eas in castra in Silo in terra Chanaan."
,"13":"Misitque coetus nuntios ad filios Beniamin, qui erant in petra Remmon, et dederunt eis pacem."
,"14":"Veneruntque filii Beniamin in illo tempore, et datae sunt eis uxores de filiabus Iabes Galaad; alias autem non reppererunt, quas simili modo traderent."
,"15":"Populusque valde doluit de Beniamin, quia fecerat Dominus confractionem in tribubus Israel."
,"16":"Dixeruntque seniores coetus: ' Quid faciemus reliquis, qui non acceperunt uxores? Omnes in Beniamin feminae conciderunt '."
,"17":"Et dixerunt: ' Possessio eorum, qui effugerunt, erit Beniamin, ne una tribus deleatur ex Israel."
,"18":"Filias autem nostras eis dare non possumus, constricti hoc iuramento: 'Maledictus, qui dederit de filiabus suis uxorem Beniamin!' '."
,"19":"Ceperuntque consilium atque dixerunt: ' Ecce sollemnitas Domini est in Silo anniversaria, quae sita est ad septentrionem urbis Bethel et ad orientalem plagam viae, quae de Bethel tendit ad Sichimam et ad meridiem oppidi Lebona '."
,"20":"Praeceperuntque filiis Beniamin atque dixerunt: 'Ite et latitate in vineis;"
,"21":"cumque videritis filias Silo ad ducendos choros ex more procedere, exite repente de vineis et rapite ex eis singuli uxores singulas et pergite in terram Beniamin '."
,"22":"Cumque venerint patres earum ac fratres et apud nos queri coeperint, dicemus eis: ' Miseremini nostri et eorum; non enim acceperunt unusquisque uxorem in bello, et vos, si dedissetis eis, deliquissetis '."
,"23":"Feceruntque filii Beniamin, ut sibi fuerat imperatum, et iuxta numerum suum rapuerunt sibi de his, quae ducebant choros, uxores singulas; abieruntque in possessionem suam aedificantes urbes et habitantes in eis."
,"24":"Filii quoque Israel reversi sunt inde illo tempore unusquisque ad tribum et familiam suam in possessionem suam."
,"25":"In diebus illis non erat rex in Israel, sed unusquisque, quod sibi rectum videbatur, hoc faciebat."
}`)

}
func LA_NVBSE_LoadVHIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Et factum est, ut post mortem Moysi servi Domini loqueretur Dominus ad Iosue filium Nun ministrum Moysi et diceret ei:"
,"2":"' Moyses servus meus mortuus est; nunc igitur surge et transi Iordanem istum, tu et omnis populus iste, in terram, quam ego dabo filiis Israel."
,"3":"Omnem locum, quem calcaverit vestigium pedis vestri, vobis tradidi, sicut locutus sum Moysi."
,"4":"A deserto et Libano isto usque ad fluvium magnum Euphraten, omnis terra Hetthaeorum usque ad mare Magnum contra solis occasum erit terminus vester."
,"5":"Nullus tibi poterit resistere cunctis diebus vitae tuae: sicut fui cum Moyse, ero et tecum; non dimittam nec derelinquam te."
,"6":"Confortare et esto robustus; tu enim sorte divides populo huic terram, pro qua iuravi patribus suis, ut traderem eam illis."
,"7":"Confortare tantum et esto robustus valde, ut custodias et facias iuxta omnem legem, quam praecepit tibi Moyses servus meus. Ne declines ab ea ad dexteram vel ad sinistram, ut prospereris in omnibus, ad quaecumque perrexeris."
,"8":"Non recedat hoc volumen legis de ore tuo, sed meditaberis in eo diebus ac noctibus, ut custodias et facias iuxta omnia, quae scripta sunt in eo: tunc optime diriges viam tuam et tunc prosperaberis."
,"9":"Nonne praecepi tibi: Confortare et esto robustus, noli metuere et noli timere, quoniam tecum est Dominus Deus tuus in omnibus, ad quaecumque perrexeris?'."
,"10":"Praecepitque Iosue praefectis populi dicens: ' Transite per medium castrorum et imperate populo ac dicite:"
,"11":"Praeparate vobis cibaria, quoniam post diem tertium transibitis Iordanem hunc et intrabitis ad possidendam terram, quam Dominus Deus vester daturus est vobis '."
,"12":"Rubenitis quoque et Gaditis et dimidiae tribui Manasse ait:"
,"13":"' Mementote sermonis, quem praecepit vobis Moyses famulus Domini dicens: 'Dominus Deus vester dedit vobis requiem et terram hanc'."
,"14":"Uxores vestrae et filii ac iumenta manebunt in terra, quam tradidit vobis Moyses trans Iordanem; vos autem transibitis armati ante fratres vestros, omnes viri fortes, et adiuvabitis eos,"
,"15":"donec det requiem Dominus fratribus vestris, sicut et vobis dedit, et possideant ipsi quoque terram, quam Dominus Deus vester daturus est eis. Et sic revertemini in terram possessionis vestrae et habitabitis in ea, quam vobis dedit Moyses famulus Domini trans Iordanem contra solis ortum '."
,"16":"Responderuntque ad Iosue atque dixerunt: ' Omnia, quae praecepisti nobis, faciemus et, quocumque miseris, ibimus."
,"17":"Sicut oboedivimus in cunctis Moysi, ita oboediemus et tibi; tantum sit Dominus Deus tuus tecum, sicut fuit cum Moyse."
,"18":"Quicumque contradixerit ori tuo et non oboedierit cunctis sermonibus, quos praeceperis ei, moriatur; tu tantum confortare et viriliter age '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Misit ergo Iosue filius Nun de Settim duos viros exploratores in abscondito et dixit eis; 'Ite et considerate terram urbemque Iericho '. Qui pergentes ingressi sunt domum mulieris meretricis nomine Rahab et quieverunt ibi."
,"2":"Nuntiatumque est regi Iericho et dictum: ' Ecce viri ingressi sunt huc per noctem de filiis Israel, ut explorarent terram '."
,"3":"Misitque rex Iericho ad Rahab dicens: ' Educ viros, qui venerunt ad te et ingressi sunt domum tuam; exploratores quippe sunt et omnem terram considerare venerunt '."
,"4":"Tollensque mulier viros abscondit et ait: ' Fateor, venerunt ad me, sed nesciebam unde essent;"
,"5":"cumque porta clauderetur in tenebris, et illi pariter exierunt, nescio quo abierunt. Persequimini cito et comprehendetis eos '."
,"6":"Ipsa autem fecit ascendere viros in solarium domus suae operuitque eos lini stipula, quae ibi erat."
,"7":"Hi autem, qui missi fuerant, secuti sunt eos per viam, quae ducit ad vadum Iordanis; illisque egressis, statim porta clausa est."
,"8":"Necdum obdormierant qui latebant, et ecce mulier ascendit ad eos et ait:"
,"9":"' Novi quod tradiderit Dominus vobis terram, et irruit in nos terror vester, et elanguerunt omnes habitatores terrae coram vobis."
,"10":"Audivimus enim quod siccaverit Dominus aquas maris Rubri ad vestrum introitum, quando egressi estis ex Aegypto, et quae feceritis duobus Amorraeorum regibus, qui erant trans Iordanem, Sehon et Og, quos interfecistis."
,"11":"Et haec audientes pertimuimus, et elanguit cor nostrum, nec remansit in nobis spiritus ad introitum vestrum; Dominus enim Deus vester ipse est Deus in caelo sursum et in terra deorsum."
,"12":"Nunc ergo iurate mihi per Dominum, ut, quomodo ego feci vobiscum misericordiam, ita et vos faciatis cum domo patris mei detisque mihi signum verum,"
,"13":"ut salvetis patrem meum et matrem, fratres ac sorores meas et omnia, quae eorum sunt, et eruatis animas nostras de morte '."
,"14":"Qui responderunt ei: ' Anima nostra sit pro vobis in mortem, si tamen non prodideris; cumque tradiderit nobis Dominus terram, faciemus in te misericordiam et veritatem '."
,"15":"Demisit ergo eos per funem de fenestra; domus enim eius haerebat muro, et in muro habitabat."
,"16":"Dixitque ad eos: ' Ad montana pergite, ne forte occurrant vobis persecutores, ibique latete diebus tribus, donec redeant; et postea ibitis per viam vestram."
,"17":"Qui dixerunt ad eam: ' Innoxii erimus a iuramento hoc, quo adiurasti nos,"
,"18":"si, ingredientibus nobis terram, signum fuerit funiculus iste coccineus, et ligaveris eum in fenestra, per quam nos demisisti, et patrem tuum ac matrem fratresque et omnem cognationem tuam congregaveris in domum tuam."
,"19":"Qui ostium domus tuae egressus fuerit, sanguis ipsius erit in caput eius, et nos erimus innoxii; cunctorum autem sanguis, qui tecum fuerint in domo, redundabit in caput nostrum, si eos aliquis tetigerit."
,"20":"Quod si prodideris hoc verbum, erimus mundi ab hoc iuramento, quo adiurasti nos '."
,"21":"Et illa respondit: ' Sicut locuti estis, ita fiat '. Dimittensque eos, ut pergerent, appendit funiculum coccineum in fenestra."
,"22":"Illi vero ambulantes pervenerunt ad montana et manserunt ibi tres dies, donec reverterentur, qui fuerant persecuti; quaerentes enim per omnem viam non reppererunt eos."
,"23":"Duo viri reversi sunt et descenderunt de monte et, transmisso Iordane, venerunt ad Iosue filium Nun narraveruntque ei omnia, quae acciderant sibi,"
,"24":"atque dixerunt: ' Tradidit Dominus in manus nostras omnem terram, et timore prostrati sunt cuncti habitatores eius in conspectu nostro '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Igitur Iosue de nocte consur gens movit castra. Egredientes que de Settim venerunt ad Iordanem, ipse et omnes filii Israel; et morati sunt ibi, antequam transirent."
,"2":"Tribus diebus evolutis, transierunt praefecti per castrorum medium"
,"3":"et praeceperunt populo: ' Quando videritis arcam foederis Domini Dei vestri et sacerdotes stirpis leviticae portantes eam, vos quoque consurgite et sequimini eam"
,"4":"- sitque inter vos et arcam spatium cubitorum duum fere milium, et cavete, ne appropinquetis ad eam - ut sciatis per quam viam ingrediamini, quia prius non ambulastis per eam '."
,"5":"Dixitque Iosue ad populum: ' Sanctificamini; cras enim faciet Dominus inter vos mirabilia '."
,"6":"Et ait ad sacerdotes: ' Tollite arcam foederis et praecedite populum '. Qui tulerunt et ambulaverunt ante eos."
,"7":"Dixitque Dominus ad Iosue: ' Hodie incipiam exaltare te coram omni Israel, ut sciant quod, sicut cum Moyse fui, ita et tecum sim."
,"8":"Tu autem praecipe sacerdotibus, qui portant arcam foederis, et dic eis: Cum veneritis ad oram aquae Iordanis, state in Iordane'."
,"9":"Dixitque Iosue ad filios Israel: ' Accedite huc et audite verba Domini Dei vestri '."
,"10":"Et rursum: ' In hoc, inquit, scietis quod Deus vivens in medio vestri est et disperdet in conspectu vestro Chananaeum et Hetthaeum, Hevaeum et Pherezaeum, Gergesaeum quoque et Amorraeum et Iebusaeum."
,"11":"Ecce arca foederis Domini omnis terrae antecedet vos per Iordanem."
,"12":"Parate duodecim viros de tribubus Israel, singulos per singulas tribus;"
,"13":"et cum posuerint vestigia pedum suorum sacerdotes, qui portant arcam Domini Dei universae terrae, in aquis Iordanis, aquae, quae inferiores sunt, decurrent, quae autem desuper veniunt, in una mole consistent '."
,"14":"Igitur egressus est populus de tabernaculis suis, ut transiret Iordanem; et sacerdotes, qui portabant arcam foederis, pergebant ante eum."
,"15":"Veneruntque usque ad Iordanem et, pedibus eorum in ora aquae tinctis - Iordanis autem omnes ripas alvei sui toto tempore messis impleverat -"
,"16":"steterunt aquae desuper descendentes in loco uno instar molis procul valde apud urbem, quae vocatur Adam, ex latere Sarthan; quae autem inferiores erant, in mare Arabae, quod est mare Salsissimum, descenderunt, usquequo omnino deficerent."
,"17":"Populus autem incedebat contra Iericho, et sacerdotes, qui portabant arcam foederis Domini, stabant super siccam humum in medio Iordanis firmiter, donec omnis Israel compleret per arentem alveum transitum Iordanis."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quibus transgressis, dixit Dominus ad Iosue:"
,"2":"' Sumite vobis de populo duodecim viros singulos per singulas tribus"
,"3":"et praecipite eis, ut tollant de medio Iordanis alveo, ubi firmiter steterunt sacerdotum pedes, duodecim lapides; quos portabitis vobiscum et ponetis in loco castrorum, ubi fixeritis hac nocte tentoria '."
,"4":"Vocavitque Iosue duodecim viros, quos elegerat de filiis Israel, singulos de tribubus singulis,"
,"5":"et ait ad eos: ' Ite ante arcam Domini Dei vestri ad Iordanis medium et portate singuli singulos lapides in umeris vestris, iuxta numerum tribuum filiorum Israel,"
,"6":"ut sit hoc signum inter vos. Quando interrogaverint vos filii vestri cras dicentes: 'Quid sibi volunt isti lapides?',"
,"7":"respondebitis eis: Defecerunt aquae Iordanis ante arcam foederis Domini, cum transiret eum; idcirco positi sunt lapides isti in monumentum filiis Israel usque in aeternum '."
,"8":"Fecerunt ergo filii Israel, sicut eis praecepit Iosue, portantes de medio Iordanis alveo duodecim lapides, ut ei Dominus imperarat, iuxta numerum tribuum filiorum Israel, usque ad locum, in quo castrametati sunt; ibique posuerunt eos."
,"9":"Alios quoque duodecim lapides posuit Iosue in medio Iordanis alveo, ubi steterunt sacerdotes, qui portabant arcam foederis; et sunt ibi usque in praesentem diem."
,"10":"Sacerdotes autem, qui portabant arcam, stabant in Iordanis medio, donec omnia complerentur, quae Iosue ut loqueretur ad populum praeceperat Dominus secundum omnia, quae dixerat ei Moyses. Festinavitque populus et transiit."
,"11":"Cumque transissent omnes, transivit et arca Domini; sacerdotesque pergebant ante populum."
,"12":"Filii quoque Ruben et Gad et dimidia tribus Manasse armati praecedebant filios Israel, sicut eis praeceperat Moyses;"
,"13":"quadraginta fere milia expeditorum ad pugnam incedebant coram Domino in campestria Iericho."
,"14":"In illo die magnificavit Dominus Iosue coram omni Israel, ut timerent eum, sicut timuerant Moysen, omnibus diebus vitae suae."
,"15":"Dixitque ad eum:"
,"16":"' Praecipe sacerdotibus, qui portant arcam testimonii, ut ascendant de Iordane '."
,"17":"Qui praecepit eis dicens: ' Ascendite de Iordane '."
,"18":"Cumque ascendissent portantes arcam foederis Domini et siccam humum calcare coepissent, reversae sunt aquae in alveum suum et fluebant sicut ante super omnes ripas suas."
,"19":"Populus autem ascendit de Iordane decimo die mensis primi, et castrametati sunt in Galgalis, in termino orientali Iericho."
,"20":"Duodecim quoque lapides, quos de Iordanis alveo sumpserant, posuit Iosue in Galgalis."
,"21":"Et dixit ad filios Israel: ' Quando interrogaverint filii vestri cras patres suos et dixerint eis: 'Quid sibi volunt isti lapides?',"
,"22":"docebitis eos atque dicetis: Per arentem alveum transivit Israel Iordanem istum,"
,"23":"siccante Domino Deo vestro aquas eius in conspectu vestro, donec transiretis,"
,"24":"sicut fecerat prius in mari Rubro, quod siccavit coram nobis, donec transiremus,"
,"25":"ut cognoscant omnes terrarum populi fortissimam Domini manum, et ut vos timeatis Dominum Deum vestrum omni tempore '."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Postquam ergo audierunt om nes reges Amorraeorum, qui ha bitabant trans Iordanem ad occidentalem plagam, et cuncti reges Chanaan, qui propinqua possidebant Magno mari loca, quod siccasset Dominus fluenta Iordanis coram filiis Israel, donec transirent, dissolutum est cor eorum, et non remansit in eis spiritus coram filiis Israel."
,"2":"Eo tempore ait Dominus ad Iosue: ' Fac tibi cultros lapideos et circumcide iterum secundo filios Israel '."
,"3":"Fecit, quod iusserat Dominus, et circumcidit filios Israel in colle Praeputiorum."
,"4":"Haec autem causa est secundae circumcisionis: omnis populus, qui egressus est ex Aegypto, generis masculini, universi bellatores viri mortui sunt in deserto in via;"
,"5":"qui omnes circumcisi erant. Populus autem, qui natus est in deserto, incircumcisus fuit."
,"6":"Per quadraginta enim annos ambulabant filii Israel, donec consumerentur omnes homines bellatores, qui non audierant vocem Domini, et quibus iuraverat, ut non ostenderet eis terram, super qua iuraverat patribus eorum, ut daret illis terram lacte et melle manantem."
,"7":"Horum filii in locum successerunt patrum et circumcisi sunt a Iosue, quia, sicut nati fuerant, in praeputio erant, nec eos in via aliquis circumciderat."
,"8":"Postquam autem omnes circumcisi sunt, manserunt in eodem castrorum loco, donec sanarentur."
,"9":"Dixitque Dominus ad Iosue: ' Hodie abstuli opprobrium Aegypti a vobis '. Vocatumque est nomen loci illius Galgala usque in praesentem diem."
,"10":"Manseruntque filii Israel in Galgalis et fecerunt Pascha quarta decima die mensis ad vesperum in campestribus Iericho;"
,"11":"et comederunt de frugibus terrae a die altero, azymos panes et polentam hoc ipso die."
,"12":"Defecitque manna a die sequenti, postquam comederunt de frugibus terrae, nec usi sunt ultra cibo illo filii Israel, sed comederunt de frugibus terrae Chanaan in anno illo."
,"13":"Cum autem esset Iosue in agro urbis Iericho, levavit oculos et vidit virum stantem contra se et evaginatum tenentem gladium; perrexitque ad eum et ait: ' Noster es an adversariorum? '."
,"14":"Qui respondit: ' Nequaquam, sed sum princeps exercitus Domini et nunc veni '."
,"15":"Cecidit Iosue pronus in terram et adorans ait: ' Quid Dominus meus loquitur ad servum suum? '."
,"16":"Et dixit princeps exercitus Domini ad Iosue: ' Solve calceamentum de pedibus tuis; locus enim, in quo stas, sanctus est '. Fecitque Iosue, ut sibi fuerat imperatum."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Iericho autem erat munita et clausa coram filiis Israel, et nul lus egredi audebat aut ingredi."
,"2":"Dixitque Dominus ad Iosue: ' Ecce dedi in manu tua Iericho et regem eius omnesque fortes viros."
,"3":"Circuite urbem cuncti bellatores semel per diem: sic facietis sex diebus."
,"4":"Septem sacerdotes portabunt septem bucinas, cornua arietum, ante arcam foederis. Die autem septimo septies circuibitis civitatem, et sacerdotes clangent bucinis."
,"5":"Cumque insonuerit vox tubae longior et in auribus vestris increpuerit, conclamabit omnis populus vociferatione maxima, et muri funditus corruent civitatis; ingredienturque singuli per locum, contra quem steterint '."
,"6":"Vocavit ergo Iosue filius Nun sacerdotes et dixit ad eos: ' Tollite arcam foederis, et septem alii sacerdotes tollant septem bucinas et incedant ante arcam Domini '."
,"7":"Ad populum quoque ait: ' Vadite et circuite civitatem, et viri armati praecedant arcam Domini '."
,"8":"Cumque Iosue verba finisset, septem sacerdotes septem bucinis clangebant ante arcam foederis Domini,"
,"9":"omnisque armatus exercitus praecedebat sacerdotes clangentes, reliquum vulgus arcam sequebatur, ac bucinis omnia concrepabant."
,"10":"Praeceperat autem Iosue populo dicens: ' Non clamabitis, nec audietur vox vestra, neque ullus sermo ex ore vestro egredietur, donec veniat dies, in quo dicam vobis: Clamate et vociferamini '."
,"11":"Circuivit ergo arca Domini civitatem per diem, et reversi in castra pernoctaverunt ibi."
,"12":"Igitur, Iosue de nocte consurgente, tulerunt sacerdotes arcam Domini,"
,"13":"et septem ex eis septem bucinas, cornua arietum, praecedebantque arcam Domini ambulantes atque clangentes, et armatus populus ibat ante eos; vulgus autem reliquum sequebatur arcam, bucinis personantibus."
,"14":"Circuieruntque civitatem secundo die semel et reversi sunt in castra; sic fecerunt sex diebus."
,"15":"Die autem septimo, diluculo consurgentes circuierunt urbem eodem modo septies; in illo die tantum circuierunt urbem septies."
,"16":"Cumque septimo circuitu clangerent bucinis sacerdotes, dixit Iosue ad populum: ' Vociferamini! Tradidit enim vobis Dominus civitatem."
,"17":"Sitque civitas anathema, ipsa et omnia, quae in ea sunt, Domino; sola Rahab meretrix vivat cum universis, qui cum ea in domo sunt: abscondit enim nuntios, quos direximus."
,"18":"Vos autem cavete, ne de anathemate quippiam auferatis et sitis praevaricationis rei, et omnia castra Israel anathema sint atque turbentur."
,"19":"Quidquid auri et argenti fuerit et vasorum aeneorum ac ferri, Domino consecretur repositum in thesauris eius '."
,"20":"Igitur, omni vociferante populo et clangentibus tubis, postquam in aures multitudinis vox sonitusque increpuit, muri ilico corruerunt; et ascendit unusquisque per locum, qui contra se erat, ceperuntque civitatem."
,"21":"Et interfecerunt omnia, quae erant in ea, a viro usque ad mulierem, ab infante usque ad senem; boves quoque et oves et asinos in ore gladii percusserunt."
,"22":"Duobus autem viris, qui exploratores missi fuerant, dixit Iosue: ' Ingredimini domum mulieris meretricis et producite eam et omnia, quae illius sunt, sicut illi iuramento firmastis '."
,"23":"Ingressique iuvenes eduxerunt Rahab et parentes eius, fratres quoque et cunctam supellectilem ac cognationem illius et extra castra Israel manere fecerunt."
,"24":"Urbem autem et omnia, quae erant in ea, succenderunt, absque argento et auro et vasis aeneis ac ferro, quae in aerarium domus Domini consecrarunt."
,"25":"Rahab vero meretricem et domum patris eius et omnia, quae habebat, fecit Iosue vivere; et habitavit in medio Israel usque in praesentem diem, eo quod absconderit nuntios, quos miserat Iosue, ut explorarent Iericho. In tempore illo imprecatus est Iosue dicens: "
,"26":"'Maledictus vir coram Domino, qui suscitaverit et aedificaverit civitatem Iericho; in primogenito suo fundamenta illius faciet et in novissimo liberorum ponet portas eius '."
,"27":"Fuit ergo Dominus cum Iosue, et nomen eius in omni terra vulgatum est."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Filii autem Israel praevaricati sunt mandatum et usurpaverunt de anathemate: nam Achan filius Charmi filii Zabdi filii Zarae de tribu Iudae tulit aliquid de anathemate. Iratusque est Dominus contra filios Israel."
,"2":"Cumque mitteret Iosue de Iericho viros contra Hai, quae est iuxta Bethaven ad orientalem plagam oppidi Bethel, dixit eis: ' Ascendite et explorate terram '. Qui praecepta complentes exploraverunt Hai"
,"3":"et reversi dixerunt ei: ' Non ascendat omnis populus, sed duo vel tria milia virorum pergant et deleant civitatem. Noli vexare omnem populum contra hostes paucissimos '."
,"4":"Ascenderunt ergo tria fere milia pugnatorum, qui statim terga verterunt coram viris urbis Hai,"
,"5":"qui percusserunt ex eis circiter triginta et sex homines persecutique sunt eos de porta usque ad Sabarim et percusserunt eos in descensu; pertimuitque cor populi et instar aquae liquefactum est."
,"6":"Iosue vero scidit vestimenta sua et cecidit pronus in terram coram arca Domini usque ad vesperum, tam ipse quam omnes senes Israel; miseruntque pulverem super capita sua."
,"7":"Et dixit Iosue: ' Heu, Domine Deus, quid voluisti traducere populum istum Iordanem fluvium, ut traderes nos in manus Amorraei et perderes? Utinam mansissemus trans Iordanem!"
,"8":"Quaeso, Domine, quid dicam videns Israelem hostibus suis terga vertentem?"
,"9":"Audient Chananaei et omnes habitatores terrae ac pariter conglobati circumdabunt nos atque delebunt nomen nostrum de terra. Et quid facies magno nomini tuo? '."
,"10":"Dixitque Dominus ad Iosue: ' Surge! Cur iaces pronus in terra?"
,"11":"Peccavit Israel et praevaricatus est pactum meum, quod mandaveram eis; tuleruntque de anathemate et furati sunt atque mentiti et absconderunt inter vasa sua."
,"12":"Nec poterunt filii Israel stare ante hostes suos eosque fugient, quia facti sunt anathema; non ero ultra vobiscum, donec conteratis anathema de medio vestri."
,"13":"Surge! Sanctifica populum et dic eis: Sanctificamini in crastinum. Haec enim dicit Dominus, Deus Israel: Anathema in medio tui est, Israel! Non poteris stare coram hostibus tuis, donec auferatis anathema de medio vestri."
,"14":"Accedetisque mane singuli per tribus vestras; et quamcumque tribum Dominus designaverit, accedet per cognationes suas et cognatio per domos domusque per viros:"
,"15":"et quicumque ille in hoc facinore fuerit deprehensus, comburetur igni cum omnibus, quae ipsius sunt, quoniam praevaricatus est pactum Domini et fecit nefas in Israel '."
,"16":"Surgens itaque Iosue mane applicuit Israel per tribus suas, et inventa est tribus Iudae."
,"17":"Quae cum iuxta familias suas esset oblata, inventa est familia Zarae; illam quoque per domos offerens repperit Zabdi."
,"18":"Cuius domum in singulos dividens viros invenit Achan filium Charmi filii Zabdi filii Zarae de tribu Iudae."
,"19":"Et ait Iosue ad Achan: ' Fili mi, da gloriam Domino, Deo Israel, et confitere atque indica mihi quid feceris; ne abscondas '."
,"20":"Responditque Achan Iosue et dixit ei: ' Vere ego peccavi Domino, Deo Israel, et sic et sic feci:"
,"21":"Vidi enim inter spolia pallium de Sennaar valde bonum et ducentos siclos argenti regulamque auream quinquaginta siclorum; et concupiscens abstuli et abscondi in terra contra medium tabernaculi mei argentumque subter '."
,"22":"Misit ergo Iosue ministros, qui currentes ad tabernaculum illius reppererunt cuncta abscondita in eodem loco et argentum simul;"
,"23":"auferentesque de tentorio tulerunt ea ad Iosue et ad omnes filios Israel proieceruntque ante Dominum."
,"24":"Tollens itaque Iosue Achan filium Zarae argentumque et pallium et auream regulam filiosque eius et filias, boves et asinos et oves ipsumque tabernaculum et cunctam supellectilem - et omnis Israel cum eo - duxerunt eos ad vallem Achor,"
,"25":"ubi dixit Iosue: ' Quia turbasti nos, exturbet te Dominus in die hac '. Lapidavitque eum omnis Israel; et cuncta, quae illius erant, igne consumpta sunt."
,"26":"Congregaverunt quoque super eum acervum magnum lapidum, qui permanet usque in praesentem diem. Et aversus est furor Domini ab eis; vocatumque est nomen loci illius vallis Achor usque hodie."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Dixit autem Dominus ad Iosue: ' Ne timeas neque formides; tol le tecum omnem multitudinem pugnatorum et consurgens ascende in oppidum Hai: ecce tradidi in manu tua regem eius et populum urbemque et terram eius."
,"2":"Faciesque urbi Hai et regi eius, sicut fecisti Iericho et regi illius; praedam vero et omnia animantia diripietis vobis. Pone insidias urbi post eam '."
,"3":"Surrexitque Iosue et omnis exercitus bellatorum cum eo, ut ascenderent in Hai; et electa triginta milia virorum fortium misit nocte"
,"4":"praecepitque eis dicens: 'Collocamini in insidiis post civitatem nec longius recedatis ab illa; et eritis omnes parati."
,"5":"Ego autem et reliqua multitudo, quae mecum est, accedemus ex adverso contra urbem; cumque exierint contra nos sicut ante, fugiemus et terga vertemus,"
,"6":"donec persequentes ab urbe longius protrahantur: putabunt enim nos fugere sicut prius."
,"7":"Nobis ergo fugientibus et illis sequentibus, consurgetis de insidiis et capietis civitatem; tradetque eam Dominus Deus vester in manus vestras."
,"8":"Cumque ceperitis, succendite eam; secundum verbum Domini facietis. Ecce mandavi vobis'."
,"9":"Dimisitque eos, et perrexerunt ad insidiarum locum sederuntque inter Bethel et Hai ad occidentalem plagam urbis Hai. Iosue autem nocte illa in medio mansit populi."
,"10":"Surgensque diluculo recensuit populum et ascendit cum senioribus in fronte exercitus."
,"11":"Cumque omnes pugnatores cum eo ascendissent et appropinquassent civitati, steterunt ad septentrionalem urbis plagam, inter quam et eos vallis media erat."
,"12":"Et elegit fere quinque milia viros et posuit in insidiis inter Bethel et Hai ex occidentali parte eiusdem civitatis."
,"13":"Et posuit populus tota castra, quae erant in aquilone urbis, et agmen extremum ad occidentalem plagam urbis. Abiit ergo Iosue nocte illa et stetit in vallis medio."
,"14":"Quod cum vidisset rex Hai, festinavit mane et egressus est cum omni exercitu civitatis direxitque aciem contra Arabam ignorans quod post tergum laterent insidiae."
,"15":"Iosue vero et omnis Israel cesserunt loco simulantes metum et fugientes per solitudinis viam."
,"16":"Et convocatus est totus populus, qui erat in civitate, ad persequendum eos, et persecuti sunt eos. Cumque recessissent a civitate,"
,"17":"et ne unus quidem in urbe Hai remansisset, qui non persequeretur Israel, et apertam urbem reliquissent,"
,"18":"dixit Dominus ad Iosue: 'Leva acinacem, quod in manu tua est, contra urbem Hai, quoniam tibi tradam eam '."
,"19":"Cumque elevasset acinacem ex adverso civitatis, insidiae, quae latebant, surrexerunt confestim et currentes ad civitatem ceperunt et cito succenderunt eam."
,"20":"Viri autem civitatis, qui persequebantur Iosue, respicientes et videntes fumum urbis ad caelum usque conscendere, non potuerunt ultra huc illucque diffugere, praesertim cum hi, qui simulaverant fugam et tendebant ad solitudinem, contra persequentes conversi essent."
,"21":"Vidensque Iosue et omnis Israel quod capta esset civitas, et fumus urbis ascenderet, reversi percusserunt viros Hai."
,"22":"Siquidem et illi, qui ceperant et succenderant civitatem, egressi sunt ex urbe in occursum eorum et hostes medios habuerunt. Cum ergo ex utraque parte adversarii caederentur, ita ut nullus de tanta multitudine salvaretur,"
,"23":"regem quoque urbis Hai apprehenderunt viventem et obtulerunt Iosue."
,"24":"Igitur, omnibus habitatoribus Hai interfectis, qui Israelem ad deserta tendentem fuerant persecuti, et in eodem loco gladio corruentibus, reversi filii Israel percusserunt civitatem ore gladii."
,"25":"Erant autem, qui in eo die conciderant, a viro usque ad mulierem duodecim milia hominum omnes urbis Hai."
,"26":"Iosue vero non contraxit manum, quam in sublime porrexerat tenens acinacem, donec interficerentur omnes habitatores Hai."
,"27":"Iumenta tantum et praedam civitatis diviserunt sibi filii Israel, sicut praeceperat Dominus Iosue."
,"28":"Qui succendit urbem et fecit eam tumulum sempiternum, desolationem usque in praesentem diem."
,"29":"Regem quoque eius suspendit in ligno usque ad vesperum; et ad solis occasum praecepit Iosue, et deposuerunt cadaver eius de ligno proieceruntque in ipso introitu portae civitatis, congesto super eum magno acervo lapidum, qui permanet usque in praesentem diem."
,"30":"Tunc aedificavit Iosue altare Domino, Deo Israel, in monte Hebal,"
,"31":"sicut praeceperat Moyses famulus Domini filiis Israel, et scriptum est in volumine legis Moysi, altare de lapidibus impolitis, quos ferrum non tetigit. Et obtulerunt super eo holocausta Domino immolaveruntque pacificas victimas."
,"32":"Et scripsit ibi super lapides exemplar legis Moysi, quod ille scripserat coram filiis Israel."
,"33":"Omnis autem populus et maiores natu praefectique ac iudices stabant ex utraque parte arcae in conspectu sacerdotum levitici generis, qui portabant arcam foederis Domini, ut advena ita et indigena. Media eorum pars iuxta montem Garizim et media iuxta montem Hebal, sicut praeceperat Moyses famulus Domini ad benedicendum populo Israel primum;"
,"34":"post haec legit omnia verba legis, benedictionem et maledictionem, secundum cuncta, quae scripta erant in legis volumine."
,"35":"Nihil ex his, quae Moyses iusserat, omisit legere, sed universa replicavit coram omni congregatione Israel, mulieribus ac parvulis et advenis, qui inter eos morabantur."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Quibus auditis, cuncti reges, qui trans Iordanem versabantur in montanis et in Sephela, in omni litore maris Magni, hi quoque, qui habitabant usque ad Libanum, Hetthaeus et Amorraeus, Chananaeus, Pherezaeus et Hevaeus et Iebusaeus"
,"2":"congregati sunt pariter, ut pugnarent contra Iosue et Israel uno animo eademque sententia."
,"3":"At hi, qui habitabant in Gabaon, audientes cuncta, quae fecerat Iosue Iericho et Hai,"
,"4":"et callide cogitantes tulerunt sibi cibaria, saccos veteres asinis imponentes et utres vinarios vetustos, scissos atque consutos,"
,"5":"calceamentaque perantiqua, quae ad indicium vetustatis pittaciis consuta erant, induti veteribus vestimentis; panes quoque, quos portabant ob viaticum, duri erant et in frusta comminuti."
,"6":"Perrexeruntque ad Iosue, qui tunc morabatur in castris Galgalae, et dixerunt ei atque omni simul Israeli: ' De terra longinqua venimus pactum vobiscum facere cupientes '. Responderuntque viri Israel ad Hevaeos atque dixerunt:"
,"7":"' Ne forte in medio nostri habitetis, et non possimus foedus inire vobiscum '."
,"8":"At illi ad Iosue: ' Servi, inquiunt, tui sumus '. Quibus Iosue ait: ' Quinam estis et unde venistis? '."
,"9":"Responderunt: ' De terra longinqua valde venerunt servi tui in nomine Domini Dei tui; audivimus enim famam potentiae eius, cuncta, quae fecit in Aegypto"
,"10":"et duobus Amorraeorum regibus trans Iordanem, Sehon regi Hesebon et Og regi Basan, qui erat in Astharoth."
,"11":"Dixeruntque nobis seniores et omnes habitatores terrae nostrae: 'Tollite in manibus cibaria in viam et occurrite eis ac dicite: Servi vestri sumus; foedus inite nobiscum'."
,"12":"En panes: quando egressi sumus de domibus nostris, ut veniremus ad vos, calidos sumpsimus; nunc sicci facti sunt et vetustate nimia comminuti."
,"13":"Utres vini novos implevimus, nunc rupti sunt et soluti; vestes et calceamenta, quibus induimur et quae habemus in pedibus, ob longitudinem largioris viae trita sunt et paene consumpta '."
,"14":"Susceperunt igitur viri de cibariis eorum et os Domini non interrogaverunt."
,"15":"Fecitque Iosue cum eis pacem et, inito foedere, pollicitus est quod viverent; principes quoque coetus iuraverunt eis."
,"16":"Post dies autem tres initi foederis, audierunt quod in vicino et inter eos habitarent."
,"17":"Moveruntque castra filii Israel et venerunt ad civitates eorum die tertio, quarum haec vocabula sunt: Gabaon et Cephira et Beroth et Cariathiarim;"
,"18":"et non percusserunt eos filii Israel, eo quod iurassent eis principes coetus in nomine Domini, Dei Israel. Murmuravit itaque omnis coetus contra principes,"
,"19":"qui responderunt eis: 'Iuravimus illis in nomine Domini, Dei Israel, et idcirco non possumus eos contingere."
,"20":"Sed hoc faciemus eis: reserventur quidem, ut vivant, ne contra nos ira Domini concitetur, si peieraverimus;"
,"21":"sed sic vivant, ut in usus universae multitudinis ligna caedant aquasque comportent '. Quibus haec loquentibus, "
,"22":"vocavit Gabaonitas Iosue et dixit eis: ' Cur nos decipere fraude voluistis, ut diceretis: 'Procul valde habitamus a vobis', cum in medio nostri sitis?"
,"23":"Itaque sub maledictione eritis, et non deficiet de stirpe vestra servus ligna caedens aquasque comportans in domum Dei mei'."
,"24":"Qui responderunt: ' Nuntiatum est nobis servis tuis, quod mandasset Dominus Deus tuus Moysi servo suo, ut traderet vobis omnem terram et disperderet cunctos habitatores eius; timuimus igitur valde pro animabus nostris, vestro terrore compulsi, et hoc consilium inivimus."
,"25":"Nunc autem in manu tua sumus: quod tibi bonum et rectum videtur, fac nobis '."
,"26":"Fecit ergo Iosue, ut dixerat, et liberavit eos de manu filiorum Israel, ut non occiderentur."
,"27":"Decrevitque in illo die esse eos in ministerium cuncti populi et altaris Domini caedentes ligna et aquas comportantes usque in praesens tempus pro loco, quem Dominus elegisset."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Quae cum audisset Adonise dec rex Ierusalem, quod scili cet cepisset Iosue Hai et subvertisset eam - sicut enim fecerat Iericho et regi eius, sic fecit Hai et regi illius - et quod pacem fecissent Gabaonitae cum Israel et essent in medio eorum,"
,"2":"timuerunt valde. Urbs enim magna erat Gabaon, sicut una regalium civitatum, et maior oppido Hai, omnesque viri eius bellatores fortissimi."
,"3":"Misit ergo Adonisedec rex Ierusalem ad Oham regem Hebron et ad Pharam regem Ierimoth, ad Iaphia quoque regem Lachis et ad Dabir regem Eglon dicens:"
,"4":"' Ascendite ad me et ferte praesidium, ut expugnemus Gabaon, quia fecit pacem cum Iosue et filiis Israel '."
,"5":"Congregati igitur ascenderunt quinque reges Amorraeorum: rex Ierusalem, rex Hebron, rex Ierimoth, rex Lachis, rex Eglon simul cum exercitibus suis; et castrametati sunt circa Gabaon oppugnantes eam."
,"6":"Habitatores autem Gabaon miserunt ad Iosue, qui tunc morabatur in castris apud Galgalam, et dixerunt ei: ' Ne retrahas manus tuas ab auxilio servorum tuorum! Ascende cito et libera nos ferque praesidium: convenerunt enim adversum nos omnes reges Amorraeorum, qui habitant in montanis '."
,"7":"Ascenditque Iosue de Galgalis, et omnis exercitus bellatorum cum eo, viri fortissimi."
,"8":"Dixitque Dominus ad Iosue: 'Ne timeas eos! In manus enim tuas tradidi illos; nullus tibi ex eis resistere poterit '."
,"9":"Irruit itaque Iosue super eos repente tota ascendens nocte de Galgalis,"
,"10":"et conturbavit eos Dominus a facie Israel; contrivitque plaga magna in Gabaon ac persecutus est per viam ascensus Bethoron et percussit usque Azeca et Maceda."
,"11":"Cumque fugerent filios Israel et essent in descensu Bethoron, Dominus misit super eos lapides magnos de caelo usque Azeca, et mortui sunt multo plures lapidibus grandinis, quam quos gladio percusserant filii Israel."
,"12":"Tunc locutus est Iosue Domino in die, qua tradidit Amorraeum in conspectu filiorum Israel, dixitque coram Israel: ' Sol, in Gabaon ne movearis, et luna, in valle Aialon '."
,"13":"Steteruntque sol et luna, donec ulcisceretur se gens de inimicis suis. Nonne scriptum est hoc in libro Iusti? Stetit itaque sol in medio caeli et non festinavit occumbere spatio unius fere diei. "
,"14":"Non fuit antea et postea sicut dies illa, oboediente Domino voci hominis, quia Dominus pugnavit pro Israel."
,"15":"Reversusque est Iosue cum omni Israel in castra Galgalae."
,"16":"Fugerant autem quinque reges et se absconderant in spelunca urbis Maceda."
,"17":"Nuntiatumque est Iosue quod inventi essent quinque reges latentes in spelunca urbis Maceda."
,"18":"Qui praecepit: ' Volvite saxa ingentia ad os speluncae et ponite viros, qui clausos custodiant."
,"19":"Vos autem nolite stare, sed persequimini hostes et extremos quoque fugientium caedite; ne dimittatis eos urbium suarum intrare praesidia, quia tradidit eos Dominus Deus vester in manus vestras '."
,"20":"Caesis igitur adversariis plaga maxima usque ad internecionem, ut reliquiae tantum ex eis effugere possent in civitates munitas,"
,"21":"reversus est omnis exercitus ad Iosue in Maceda ad castra, sani et integri; nullusque contra filios Israel mutire ausus est."
,"22":"Praecepitque Iosue dicens: ' Aperite os speluncae et producite ad me quinque reges, qui in ea latitant '."
,"23":"Feceruntque sic et eduxerunt ad eum quinque reges de spelunca: regem Ierusalem, regem Hebron, regem Ierimoth, regem Lachis, regem Eglon."
,"24":"Cumque educti essent ad eum, vocavit omnes viros Israel et ait ad principes exercitus, qui secum erant: 'Accedite et ponite pedes super colla regum istorum'. Qui cum accessissent et subiectorum colla pedibus calcarent,"
,"25":"rursum ait ad eos: ' Nolite timere nec paveatis; confortamini et estote robusti! Sic enim faciet Dominus cunctis hostibus vestris, adversum quos dimicatis '."
,"26":"Percussitque Iosue et interfecit eos atque suspendit super quinque ligna; fueruntque suspensi usque ad vesperum."
,"27":"Cumque occumberet sol, praecepit Iosue, ut deponerent eos de lignis; et depositos proiecerunt in speluncam, in qua latuerant, et posuerunt super os eius saxa ingentia, quae permanent usque in praesens."
,"28":"Eodem quoque die Macedam cepit Iosue et percussit eam in ore gladii regemque illius interfecit et omnes habitatores eius; non dimisit in ea ullas reliquias fecitque regi Maceda, sicut fecerat regi Iericho."
,"29":"Transivit cum omni Israel de Maceda in Lobna et pugnabat contra eam."
,"30":"Quam tradidit Dominus cum rege suo in manu Israel, percusseruntque urbem in ore gladii et omnes habitatores eius; non dimiserunt in ea ullas reliquias feceruntque regi Lobna, sicut fecerant regi Iericho."
,"31":"De Lobna transivit Iosue in Lachis cum omni Israel et, exercitu per gyrum disposito, oppugnabat eam."
,"32":"Tradiditque Dominus Lachis in manu Israel, qui cepit eam die altero; atque percussit in ore gladii omnemque animam, quae fuerat in ea, sicut fecerat Lobna."
,"33":"Eo tempore ascendit Horam rex Gazer, ut auxiliaretur Lachis; quem percussit Iosue cum omni populo eius usque ad internecionem."
,"34":"Transivitque de Lachis in Eglon cum omni Israel et circumdedit"
,"35":"atque expugnavit eam eadem die percussitque in ore gladii omnes animas, quae erant in ea, iuxta omnia, quae fecerat Lachis."
,"36":"Ascendit quoque cum omni Israel de Eglon in Hebron et pugnavit contra eam."
,"37":"Cepitque eam et percussit in ore gladii, regem quoque eius et omnia oppida eius universasque animas, quae ibi fuerant commoratae; non reliquit ullas reliquias: sicut fecerat Eglon, sic fecit et Hebron, cuncta, quae in ea repperit, consumens gladio."
,"38":"Inde reversus cum omni Israel in Dabir oppugnavit"
,"39":"et cepit eam; regem quoque eius et omnia oppida eius percussit in ore gladii; non dimisit in ea ullas reliquias: sicut fecerat Hebron et Lobna et regibus earum, sic fecit Dabir et regi illius."
,"40":"Percussit itaque Iosue omnem terram: montanam et Nageb atque Sephelam et declivia cum regibus suis; non dimisit in ea ullas reliquias, sed omne, quod spirare poterat, interfecit, sicut praeceperat Dominus, Deus Israel."
,"41":"Et percussit eos a Cadesbarne usque Gazam, omnem terram Gosen usque Gabaon,"
,"42":"universosque reges et regiones eorum uno cepit impetu; Dominus enim, Deus Israel, pugnabat pro Israel."
,"43":"Reversusque est Iosue cum omni Israel ad locum castrorum in Galgala."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Quae cum audisset Iabin rex Asor, misit ad Iobab regem Madon et ad regern Semeron atque ad regem Achsaph,"
,"2":"ad reges quoque aquilonis, qui habitabant in montanis et in Araba contra meridiem Chenereth, in Sephela quoque et in regionibus Dor iuxta mare,"
,"3":"Chananaeum in oriente et occidente, et Amorraeum atque Hetthaeum ac Pherezaeum et Iebusaeum in montanis, Hevaeum quoque, qui habitabat ad radices Hermon in terra Maspha."
,"4":"Egressique sunt omnes cum turmis suis, populus multus nimis sicut arena, quae est in litore maris, equi quoque et currus immensae multitudinis;"
,"5":"conveneruntque omnes reges isti et castrametati sunt in unum ad aquas Merom, ut pugnarent contra Israel."
,"6":"Dixitque Dominus ad Iosue: 'Ne timeas eos! Cras enim hac eadem hora ego tradam omnes istos occisos in conspectu Israel: equos eorum subnervabis et currus igne combures '."
,"7":"Venitque Iosue et omnis exercitus cum eo adversus illos ad aquas Merom subito, et irruerunt super eos."
,"8":"Tradiditque illos Dominus in manu Israel; qui percusserunt eos et persecuti sunt usque ad Sidonem magnam et Maserephoth in occidente campumque Maspha in oriente. Ita percussit omnes, ut nullas dimitteret ex eis reliquias;"
,"9":"fecit sicut praeceperat ei Dominus: equos eorum subnervavit currusque combussit."
,"10":"Reversusque tempore illo cepit Asor et regem eius percussit gladio. Asor enim antiquitus inter omnia regna haec principatum tenebat."
,"11":"Percussitque omnes animas, quae ibidem morabantur; non dimisit in ea ullas reliquias, sed usque ad internecionem universa vastavit ipsamque urbem peremit incendio."
,"12":"Et omnes per circuitum civitates regesque earum cepit, percussit atque delevit, sicut praeceperat Moyses famulus Domini."
,"13":"Urbes tantum, quae erant in tumulis earum sitae, non succendit Israel; unam Asor solam Iosue flamma consumpsit."
,"14":"Omnemque praedam istarum urbium ac iumenta diviserunt sibi filii Israel, cunctis hominibus interfectis; nullum vivum reliquerunt."
,"15":"Sicut praeceperat Dominus Moysi servo suo, ita praecepit Moyses Iosue, et ille universa complevit; non praeteriit de universis mandatis ne unum quidem verbum, quod iusserat Dominus Moysi."
,"16":"Cepit itaque Iosue omnem terram hanc, montanam et Nageb terramque Gosen et Sephelam et Arabam montemque Israel et campestria eius,"
,"17":"a monte Calvo, qui ascendit Seir, usque Baalgad in planitie Libani subter montem Hermon; omnes reges eorum cepit, percussit et occidit."
,"18":"Multo tempore pugnavit Iosue contra reges istos."
,"19":"Non fuit civitas, quae foedus iniret cum filiis Israel, praeter Hevaeum, qui habitabat in Gabaon: omnes bellando cepit."
,"20":"Domini enim sententia fuerat, ut indurarentur corda eorum, et pugnarent contra Israel et caderent et non mererentur ullam clementiam ac perirent, sicut praeceperat Dominus Moysi."
,"21":"In tempore illo venit Iosue et interfecit Enacim de montanis Hebron et Dabir et Anab et de omni monte Iudae et Israel urbesque eorum delevit."
,"22":"Non reliquit ullum de stirpe Enacim in terra filiorum Israel, absque civitatibus Gaza et Geth et Azoto, in quibus solis relicti sunt."
,"23":"Cepit ergo Iosue omnem terram, sicut locutus est Dominus ad Moysen, et tradidit eam in possessionem filiis Israel secundum partes et tribus suas; quievitque terra a proeliis."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Hi sunt reges, quos percusserunt filii Israel et possederunt terram eorum trans Iordanem ad solis ortum, a torrente Arnon usque ad montem Hermon et omnem orientalem plagam Arabae."
,"2":"Sehon rex Amorraeorum, qui habitavit in Hesebon, dominatus est ab Aroer, quae sita est super ripam torrentis Arnon, et a media parte vallis et in dimidia parte Galaad usque ad torrentem Iaboc, qui est terminus filiorum Ammon;"
,"3":"et in Araba usque ad mare Chenereth in oriente et usque ad mare Arabae, quod est mare Salsissimum, ad orientalem plagam in via, quae ducit Bethiesimoth, et in australi parte, quae iacet ad radices Phasga."
,"4":"Terminus Og regis Basan de reliquiis Raphaim, qui habitavit in Astharoth et in Edrai,"
,"5":"et dominatus est in monte Hermon et in Salcha atque in universa Basan usque ad terminos Gesuri et Maachathi et in dimidia parte Galaad usque ad terminos Sehon regis Hesebon."
,"6":"Moyses famulus Domini et filii Israel percusserunt eos; tradiditque terram eorum Moyses in possessionem Rubenitis et Gaditis et dimidiae tribui Manasse."
,"7":"Hi sunt reges terrae, quos percussit Iosue et filii Israel trans Iordanem ad occidentalem plagam, a Baalgad in campo Libani usque ad montem Calvum, qui ascendit in Seir; tradiditque eam Iosue in possessionem tribubus Israel, singulis partes suas,"
,"8":"tam in montanis quam in Sephela, in Araba et in declivibus et in solitudine ac in Nageb; Hetthaeus fuit et Amorraeus, Chananaeus et Pherezaeus, Hevaeus et Iebusaeus:"
,"9":"rex Iericho unus, rex Hai, quae est ex latere Bethel, unus,"
,"10":"rex Ierusalem unus, rex Hebron unus,"
,"11":"rex Ierimoth unus, rex Lachis unus,"
,"12":"rex Eglon unus, rex Gazer unus,"
,"13":"rex Dabir unus, rex Gader unus,"
,"14":"rex Horma unus, rex Arad unus,"
,"15":"rex Lobna unus, rex Odollam unus,"
,"16":"rex Maceda unus, rex Bethel unus,"
,"17":"rex Thapphua unus, rex Opher unus,"
,"18":"rex Aphec unus, rex Saron unus,"
,"19":"rex Madon unus, rex Asor unus,"
,"20":"rex Semeron unus, rex Achsaph unus,"
,"21":"rex Thanach unus, rex Mageddo unus,"
,"22":"rex Cedes unus, rex Iecnaam Carmeli unus,"
,"23":"rex Dor et provinciae Dor unus, rex gentium Galgal unus,"
,"24":"rex Thersa unus: omnes reges triginta unus."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Iosue senex provectaeque aetatis erat, et dixit Dominus ad eum: ' Senuisti et longaevus es; terraque latissima adhuc superest, quae necdum occupata est."
,"2":"Omnis videlicet Galilaea, regio Philisthim et universa Gesuri,"
,"3":"a fluvio Sihor, qui est ad orientem Aegypti, usque ad terminos Accaron contra aquilonem, terra Chananaea, quae in quinque principes Philisthim dividitur, Gazaeos et Azotios, Ascalonitas, Getthaeos et Accaronitas ac Hevaei"
,"4":"meridie; et omnis terra Chanaan de Ara Sidoniorum usque Apheca et terminos Amorraei;"
,"5":"et terra Gibliorum et omnis Libanus in oriente a Baalgad sub monte Hermon usque ad introitum Emath,"
,"6":"omnes, qui habitant in monte a Libano usque ad Maserephoth in occidente, universi Sidonii. Ego sum qui delebo eos a facie filiorum Israel. Sorte tantum distribue terram Israel in hereditatem, sicut praecepi tibi."
,"7":"Et nunc divide terram hanc in possessionem novem tribubus et dimidiae tribui Manasse '."
,"8":"Cum qua Ruben et Gad possederunt terram, quam tradidit eis Moyses famulus Domini trans fluenta Iordanis ad orientalem plagam:"
,"9":"ab Aroer, quae sita est in ripa torrentis Arnon, et civitate in vallis medio, universaque campestria Medaba usque Dibon;"
,"10":"et cunctas civitates Sehon regis Amorraei, qui regnavit in Hesebon, usque ad terminos filiorum Ammon;"
,"11":"et Galaad ac terminos Gesuri et Maachathi omnemque montem Hermon et universam Basan usque Salcha,"
,"12":"omne regnum Og in Basan, qui regnavit in Astharoth et Edrai - ipse fuit de reliquiis Raphaim C; percussitque eos Moyses atque delevit."
,"13":"Non autem disperdiderunt filii Israel Gesuri et Maachathi, et habitaverunt in medio Israel usque in praesentem diem."
,"14":"Tribui tantum Levi non dedit possessionem, sed sacrificia Domini, Dei Israel: ipsa est eius hereditas, sicut locutus est illi."
,"15":"Dedit ergo Moyses possessionem tribui filiorum Ruben iuxta cognationes suas."
,"16":"Fuitque terminus eorum ab Aroer, quae sita est in ripa torrentis Arnon, et a civitate in valle eiusdem torrentis media, et universa planities usque Medaba,"
,"17":"Hesebon cunctaque oppida eius, quae sunt in campestribus: Dibon et Bamothbaal et Bethbaalmeon"
,"18":"et Iasa et Cademoth et Mephaath,"
,"19":"Cariathaim et Sabama et Serethsahar in monte convallis,"
,"20":"Bethphegor et declivia Phasga et Bethiesimoth"
,"21":"et omnes urbes campestres universumque regnum Sehon regis Amorraei, qui regnavit in Hesebon, quem percussit Moyses, ipsum et principes Madian, Evi et Recem et Sur et Hur et Rebe, duces Sehon habitatores terrae."
,"22":"Et Balaam filium Beor hariolum occiderunt filii Israel gladio cum ceteris interfectis."
,"23":"Factusque est terminus filiorum Ruben Iordanis fluvius. Haec est possessio Rubenitarum per cognationes suas, urbes et viculi earum."
,"24":"Deditque Moyses tribui Gad, filiis Gad, per cognationes suas possessionem, cuius hic est"
,"25":"terminus: Iazer et omnes civitates Galaad dimidiaque pars terrae filiorum Ammon usque ad Aroer, quae est contra Rabba;"
,"26":"et ab Hesebon usque Ramothmaspha et Betonim et a Mahanaim usque ad terminos Lodabar,"
,"27":"in valle quoque Betharan et Bethnemra et Succoth et Saphon, reliqua pars regni Sehon regis Hesebon; Iordanis et terminus usque ad extremam partem maris Chenereth trans Iordanem ad orientalem plagam."
,"28":"Haec est possessio filiorum Gad per familias suas, civitates et villae earum."
,"29":"Dedit Moyses et dimidiae tribui filiorum Manasse, iuxta cognationes suas possessionem:"
,"30":"Manasse, a Mahanaim universam Basan, cunctum regnum Og regis Basan omnesque vicos Iair, qui sunt in Basan, sexaginta oppida;"
,"31":"et dimidiam partem Galaad et Astharoth et Edrai, urbes regni Og in Basan, filiis Machir filii Manasse, dimidiae parti filiorum Machir, iuxta cognationes suas."
,"32":"Hanc possessionem divisit Moyses in campestribus Moab trans Iordanem contra Iericho ad orientalem plagam."
,"33":"Tribui autem Levi non dedit possessionem, quoniam Dominus, Deus Israel, ipse est possessio eius, ut locutus est illi."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Hoc est, quod hereditave runt filii Israel in terra Cha naan, quod dederunt eis Eleazar sacerdos et Iosue filius Nun et principes familiarum tribuum Israel,"
,"2":"sorte omnia dividentes, sicut praeceperat Dominus in manu Moysi, novem tribubus et dimidiae tribui."
,"3":"Duabus enim tribubus et dimidiae dederat Moyses trans Iordanem possessionem, absque Levitis, quibus nihil dedit inter fratres suos;"
,"4":"sed sunt filii Ioseph in duas divisi tribus, Manasse et Ephraim, nec acceperunt Levitae aliam in terra partem, nisi urbes ad habitandum et suburbana earum ad alenda iumenta et pecora sua."
,"5":"Sicut praeceperat Dominus Moysi, ita fecerunt filii Israel et diviserunt terram."
,"6":"Accesserunt itaque filii Iudae ad Iosue in Galgala, locutusque est ad eum Chaleb filius Iephonne Cenezaeus: ' Nosti quid locutus sit Dominus ad Moysen hominem Dei de me et te in Cadesbarne."
,"7":"Quadraginta annorum eram, quando me misit Moyses famulus Domini de Cadesbarne, ut considerarem terram; nuntiavique ei quod mihi verum videbatur."
,"8":"Fratres autem mei, qui ascenderant mecum, dissolverunt cor populi, et nihilominus ego adimplevi, ut sequerer Dominum Deum meum."
,"9":"Iuravitque Moyses in die illo dicens: 'Terra, quam calcavit pes tuus, erit possessio tua et filiorum tuorum in aeternum, quia adimplevisti, ut sequereris Dominum Deum meum'."
,"10":"Concessit ergo Dominus vitam mihi, sicut pollicitus est, usque in praesentem diem. Quadraginta et quinque anni sunt ex quo locutus est Dominus verbum istud ad Moysen, quando ambulabat Israel per solitudinem; hodie octoginta quinque annorum sum,"
,"11":"sic valens ut eo valebam tempore, quando ad explorandum missus sum; illius in me temporis fortitudo usque hodie perseverat tam ad bellandum quam ad gradiendum."
,"12":"Da ergo mihi montem istum, quem pollicitus est Dominus die illo, te quoque audiente quod Enacim ibi sunt et urbes magnae atque munitae; si forte sit Dominus mecum, et potuero delere eos, sicut promisit mihi '."
,"13":"Benedixitque ei Iosue et tradidit Hebron in possessionem;"
,"14":"atque ex eo fuit Hebron Chaleb filio Iephonne Cenezaeo usque in praesentem diem, quia adimplevit, ut sequeretur Dominum, Deum Israel."
,"15":"Nomen Hebron antea vocabatur Cariatharbe (id est civitas Arbe), hominis maximi inter Enacim. Et terra cessavit a proeliis."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Sors tribus filiorum Iudae per cognationes suas ista fuit: usque ad terminum Edom, ad desertum Sin contra Nageb, usque ad extremam partem australis plagae."
,"2":"Terminus eius meridionalis a summitate maris Salsissimi et a lingua eius, quae respicit meridiem."
,"3":"Egrediturque contra ascensum Acrabbim et pertransit in Sin ascenditque in meridie Cadesbarne et pervenit in Esron ascendens ad Addar et vertitur in Carca;"
,"4":"atque inde pertransiens in Asemona pervenit ad torrentem Aegypti; eruntque exitus eius ad mare Magnum: hic erit vobis finis meridianae plagae."
,"5":"Ab oriente vero terminus erit mare Salsissimum usque ad extrema Iordanis. Terminus aquilonis a lingua maris et ab extremis Iordanis"
,"6":"ascendit in Bethagla et transit ab aquilone Betharaba ascendens ad lapidem Boen filii Ruben"
,"7":"et ascendens ad Dabir de valle Achor et contra aquilonem vergens ad Galiloth (hi sunt circuli), qui sunt ex adverso ascensionis Adommim, quae est ab australi parte torrentis, transit ad aquas, quae vocantur fons Solis, et erunt exitus eius ad fontem Rogel."
,"8":"Ascenditque per convallem Benennom ex latere Iebusaei ad meridiem - haec est Ierusalem - et inde se erigens ad verticem montis, qui est contra vallem Ennom ad occidentem in extrema parte vallis Raphaim contra aquilonem;"
,"9":"pertransitque a vertice montis usque ad fontem aquae Nephtoa et pervenit usque ad vicos montis Ephron inclinaturque in Baala, quae est Cariathiarim."
,"10":"Et vergit de Baala contra occidentem usque ad montem Seir transitque iuxta latus montis Iarim ad aquilonem - id est Cheslon - et descendit in Bethsames transitque in Thamna"
,"11":"et pervenit ad latus septentrionale Accaron inclinaturque in Sechron et transit montem Baala pervenitque in Iebneel et finitur mari. Terminus occidentalis est mare Magnum."
,"12":"Hi sunt termini filiorum Iudae per circuitum in cognationibus suis."
,"13":"Chaleb vero filio Iephonne dedit partem in medio filiorum Iudae, sicut praeceperat Dominus Iosue: Cariatharbe (id est civitas Arbe), patris Enac, ipsa est Hebron."
,"14":"Delevitque ex ea Chaleb tres filios Enac: Sesai et Ahiman et Tholmai de stirpe Enac."
,"15":"Atque inde conscendens venit ad habitatores Dabir, quae prius vocabatur Cariathsepher (id est civitas Litterarum)."
,"16":"Dixitque Chaleb: ' Qui percusserit Cariathsepher et ceperit eam, dabo illi Axam filiam meam uxorem '."
,"17":"Cepitque eam Othoniel filius Cenez frater Chaleb, deditque ei Axam filiam suam uxorem."
,"18":"Quae cum veniret, suasit viro suo, ut peteret a patre suo agrum; descenditque de asino. Cui Chaleb: ' Quid habes? ', inquit."
,"19":"At illa respondit: ' Da mihi benedictionem. Terram Nageb arentem dedisti mihi; iunge et irriguam '. Dedit itaque ei Chaleb irriguum superius et inferius."
,"20":"Haec est possessio tribus filiorum Iudae per cognationes suas."
,"21":"Erantque civitates ab extremis partibus filiorum Iudae iuxta terminos Edom in Nageb: Cabseel et Eder et Iagur"
,"22":"et Cina et Dimona et Adada"
,"23":"et Cades et Asor et Iethnan,"
,"24":"Ziph et Telem et Baloth"
,"25":"et Asorhadatta et Carioth, Esron - haec est Asor -"
,"26":"Amam et Sama et Molada"
,"27":"et Asargadda et Hasemon et Bethphelet"
,"28":"et Asarsual et Bersabee et Baziothia,"
,"29":"Baala et Iim et Esem"
,"30":"et Eltholad et Cesil et Horma"
,"31":"et Siceleg et Madmena et Sensenna"
,"32":"et Lebaoth et Selim et Enremmon: omnes civitates viginti novem et villae earum."
,"33":"In campestribus vero: Esthaol et Saraa et Asena"
,"34":"et Zanoa et Engannim, Thapphua et Enaim,"
,"35":"Ierimoth et Odollam, Socho et Azeca"
,"36":"et Saarim et Adithaim et Gedera et Gederothaim: urbes quattuordecim et villae earum."
,"37":"Sanan et Hadasa et Magdalgad"
,"38":"et Delean et Maspha et Iecethel,"
,"39":"Lachis et Bascath et Eglon"
,"40":"et Chebbon et Lehemas et Cethlis"
,"41":"et Gederoth, Bethdagon et Naama et Maceda: civitates sedecim et villae earum."
,"42":"Lobna et Ether et Asan"
,"43":"et Iephtha et Esna et Nesib"
,"44":"et Ceila et Achzib et Maresa: civitates novem et villae earum."
,"45":"Accaron cum filiabus et villulis suis;"
,"46":"ab Accaron usque ad mare: omnia, quae sunt ad latus Azoti, et viculos eorum,"
,"47":"Azotus cum filiabus et villulis suis, Gaza cum filiabus et villulis suis usque ad torrentem Aegypti, et mare Magnum terminus."
,"48":"Et in monte: Samir et Iether et Socho"
,"49":"et Danna et Cariathsenna - haec est Dabir -"
,"50":"et Anab et Esthemo et Anim"
,"51":"et Gosen et Helon et Gilo: civitates undecim et villae earum."
,"52":"Arab et Duma et Esaan"
,"53":"et Ianum et Beththapphua et Apheca"
,"54":"et Ammatha et Cariatharbe - haec est Hebron - et Sior: civitates novem et villae earum."
,"55":"Maon et Carmel et Ziph et Iutta"
,"56":"et Iezrahel et Iucadam et Zanoa,"
,"57":"Accain, Gabaa et Thamna: civitates decem et villae earum."
,"58":"Halhul, Bethsur et Gedor"
,"59":"et Mareth et Bethanoth et Eltecon: civitates sex et villae earum. Thecue et Ephratha - haec est Bethlehem - et Phegor et Etam et Culon et Tatam et Sores et Carem et Gallim et Bether et Manahath: civitates undecim et villae earum."
,"60":"Cariathbaal - haec est Cariathiarim (urbs Silvarum) - et Arebba: civitates duae et villae earum."
,"61":"In deserto: Betharaba, Meddin et Sachacha"
,"62":"et Nebsan et civitas Salis et Engaddi: civitates sex et villae earum."
,"63":"Iebusaeum autem habitatorem Ierusalem non potuerunt filii Iudae delere; habitavitque Iebusaeus cum filiis Iudae in Ierusalem usque in praesentem diem."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Cecidit quoque sors filiorum Ioseph ab Iordane contra Ie richo et aquas eius ab oriente, solitudo, quae ascendit de Iericho ad montem Bethel"
,"2":"et egreditur de Bethel Luz transitque per terminum Arachitarum in Ataroth"
,"3":"et descendit ad occidentem ad terminum Iephlethi usque ad terminos Bethoron inferioris et Gazer; finiunturque regiones eius mari Magno."
,"4":"Hereditaverunt illas filii Ioseph Manasses et Ephraim."
,"5":"Et factus est terminus filiorum Ephraim per cognationes suas et possessio eorum contra orientem Atarothaddar usque Bethoron superiorem;"
,"6":"egrediunturque confinia in mare, Machmethath vero aquilonem respicit et vertitur terminus contra orientem in Thanathselo et pertransit ab oriente Ianoe."
,"7":"Descenditque de Ianoe in Ataroth et Naaratha et pervenit in Iericho et egreditur ad Iordanem."
,"8":"De Thapphua pertransit terminus ad occidentem ad torrentem Cana, suntque egressus eius in mare: haec est possessio tribus filiorum Ephraim per familias suas,"
,"9":"urbesque separatae filiis Ephraim in medio possessionis filiorum Manasse, omnes urbes et villae earum."
,"10":"Et non interfecerunt filii Ephraim Chananaeum, qui habitabat in Gazer; habitavitque Chananaeus in medio Ephraim usque in diem hanc et factus est tributarius."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Cecidit autem sors tribui Manasse - ipse est enim pri mogenitus Ioseph C; Machir primogenito Manasse patri Galaad, quia fuit vir pugnator, accepit in possessionem Galaad et Basan."
,"2":"Et reliqui filiorum Manasse acceperunt iuxta familias suas: filii Abiezer et filii Helec et filii Asriel et filii Sechem et filii Hepher et filii Semida: isti sunt filii Manasse filii Ioseph, mares per cognationes suas."
,"3":"Salphaad vero filio Hepher filii Galaad filii Machir filii Manasse non erant filii, sed solae filiae, quarum ista sunt nomina: Maala et Noa, Hegla et Melcha et Thersa."
,"4":"Veneruntque in conspectu Eleazari sacerdotis et Iosue filii Nun et principum dicentes: ' Dominus praecepit per manum Moysi, ut daretur nobis possessio in medio fratrum nostrorum '. Deditque eis iuxta imperium Domini possessionem in medio fratrum patris earum."
,"5":"Et ceciderunt funiculi Manasse decem, absque terra Galaad et Basan trans Iordanem."
,"6":"Filiae enim Manasse acceperunt hereditatem in medio filiorum eius. Terra autem Galaad cecidit in sortem filiorum Manasse, qui reliqui erant."
,"7":"Fuitque terminus Manasse ab Aser: Machmethath, quae respicit Sichem et egreditur ad dextram in Iasib apud fontem Thapphuae."
,"8":"Etenim in sorte Manasse ceciderat terra Thapphuae; Thapphua autem ipsa, quae est iuxta terminos Manasse, fuit filiis Ephraim."
,"9":"Descenditque terminus ad torrentem Cana. In meridie torrentis civitates sunt Ephraim in medio urbium Manasse. Terminus Manasse est ab aquilone torrentis, et exitus eius pergit ad mare,"
,"10":"ita ut ab austro sit possessio Ephraim et ab aquilone Manasse, et utramque claudat mare, et attingunt tribum Aser ab aquilone et tribum Issachar ab oriente."
,"11":"Fuitque hereditas Manasse in Issachar et in Aser: Bethsan et filiae eius et Ieblaam cum filiabus suis et habitatores Dor cum filiabus suis, habitatores quoque Endor cum filiabus suis; similiterque habitatores Thanach cum filiabus suis et habitatores Mageddo cum filiabus suis et tertia pars regionis Nopheth."
,"12":"Nec potuerunt filii Manasse has occupare civitates, sed Chananaeus permansit in terra ista."
,"13":"Postquam autem convaluerunt filii Israel, subiecerunt Chananaeos et fecerunt sibi tributarios nec expulerunt eos."
,"14":"Locutique sunt filii Ioseph ad Iosue atque dixerunt: ' Quare dedisti mihi possessionem sortis et funiculi unius, cum sim tantae multitudinis et benedixerit mihi Dominus? '."
,"15":"Ad quos Iosue ait: ' Si populus multus es, ascende in silvam et succide tibi spatia in terra Pherezaei et Raphaim, quia angusta est tibi possessio montis Ephraim '."
,"16":"Cui responderunt filii Ioseph: ' Montana non sufficiunt nobis, et ferreis curribus utuntur omnes Chananaei, qui habitant in terra campestri, Bethsan cum filiabus suis et illi, qui sunt in planitie Iezrahel '."
,"17":"Dixitque Iosue ad domum Ioseph, Ephraim et Manasse: 'Populus multus es et magnae fortitudinis; non habebis sortem unam,"
,"18":"sed transibis ad montem et succides tibi atque purgabis ad habitandum spatia; et poteris ultra procedere cum subverteris Chananaeum, qui ferreos habet currus et est fortis '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Congregatique sunt omnes filii Israel in Silo ibique fixe runt tabernaculum conventus, et fuit eis terra subiecta."
,"2":"Remanserant autem filiorum Israel septem tribus, quae necdum acceperant possessiones suas."
,"3":"Ad quos Iosue ait: ' Usquequo marcetis ignavia et non intratis ad possidendam terram, quam Dominus, Deus patrum vestrorum,dedit vobis?"
,"4":"Eligite de singulis tribubus ternos viros, ut mittam eos, et surgant atque circumeant terram et describant eam iuxta numerum uniuscuiusque multitudinis referantque ad me, quod descripserint."
,"5":"Dividite vobis terram in septem partes: Iudas sit in terminis suis in australi plaga, et domus Ioseph in aquilone."
,"6":"Reliquam terram in septem partes describite; et huc afferetis ad me, ut coram Domino Deo nostro mittam vobis hic sortem,"
,"7":"quia non est inter vos pars Levitarum, sed sacerdotium Domini est eorum hereditas. Gad autem et Ruben et dimidia tribus Manasse iam acceperant possessiones suas trans Iordanem ad orientalem plagam, quas dedit eis Moyses famulus Domini '."
,"8":"Cumque surrexissent viri, ut pergerent ad describendam terram, praecepit eis Iosue dicens: 'Circuite terram et describite eam ac revertimini ad me, ut hic coram Domino in Silo mittam vobis sortem '."
,"9":"Itaque perrexerunt et lustrantes terram secundum urbes in septem partes diviserunt scribentes in volumine; reversique sunt ad Iosue in castra Silo."
,"10":"Qui misit eis sortes coram Domino in Silo divisitque ibi terram filiis Israel secundum partes eorum."
,"11":"Et ascendit sors prima filiorum Beniamin per familias suas, ut possiderent terram inter filios Iudae et filios Ioseph."
,"12":"Fuitque terminus eorum contra aquilonem a Iordane pergens iuxta latus Iericho septentrionalis plagae et inde contra occidentem ad montana conscendens et perveniens in solitudinem Bethaven;"
,"13":"atque pertransiens iuxta Luzam ad meridiem - ipsa est Bethel - descendit in Atarothaddar in montem, qui est ad meridiem Bethoron inferioris,"
,"14":"et inclinatur vergens contra mare ad meridiem a monte, qui respicit Bethoron contra meridiem; suntque exitus eius in Cariathbaal, quae vocatur et Cariathiarim, urbem filiorum Iudae. Haec est plaga ad occidentem."
,"15":"In plaga autem ad meridiem, ex parte Cariathiarim egreditur terminus in Gasim et pervenit usque ad fontem aquarum Nephtoa"
,"16":"descenditque in extremam partem montis, qui respicit vallem Benennom et est contra septentrionalem plagam in extrema parte vallis Raphaim; descenditque in vallem Ennom, iuxta latus Iebusaei ad austrum, et pervenit ad fontem Rogel"
,"17":"transiens ad aquilonem et egrediens ad Ensemes (id est fontem Solis). Et pertransit usque ad Galiloth (hi sunt circuli), qui sunt e regione ascensus Adommim, descenditque ad Abenboen (id est lapidem Boen) filii Ruben"
,"18":"et pertransit ex latere aquilonis Betharaba descenditque in Arabam."
,"19":"Et praetergreditur contra aquilonem Bethagla; suntque exitus eius contra linguam maris Salsissimi ab aquilone in fine Iordanis. Haec est australis plaga."
,"20":"Iordanis autem est terminus ab oriente. Haec est possessio filiorum Beniamin per terminos suos in circuitu secundum familias suas."
,"21":"Fueruntque civitates eius: Iericho et Bethagla et Ameccasis"
,"22":"et Betharaba et Semaraim et Bethel"
,"23":"et Avim et Phara et Ophra,"
,"24":"Capharemona et Ophni et Gabaa: civitates duodecim et villae earum."
,"25":"Gabaon et Rama et Beroth"
,"26":"et Maspha et Cephira et Mosa"
,"27":"et Recem, Iaraphel et Tharala"
,"28":"et Sela, Eleph et Iebus, quae est Ierusalem, Gabaath et Cariath: civitates quattuordecim et villae earum. Haec est possessio filiorum Beniamin iuxta familias suas."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Et egressa est sors secunda fi liorum Simeon per cognatio nes suas; fuitque hereditas"
,"2":"eorum in medio possessionis filiorum Iudae. Bersabee et Sama et Molada"
,"3":"et Asarsual et Bala et Esem"
,"4":"et Eltholad et Bethul et Horma"
,"5":"et Siceleg et Bethmarchaboth et Asarsusa"
,"6":"et Bethlebaoth et Sarohen: civitates tredecim et villae earum."
,"7":"Ain et Remmon et Ethar et Asan: civitates quattuor et villae earum."
,"8":"Omnes viculi per circuitum urbium istarum usque ad Baalathbeer, Ramathnageb: haec est hereditas filiorum Simeon iuxta cognationes suas."
,"9":"Sumpta est de funiculo filiorum Iudae, quia maior erat; et idcirco possederunt filii Simeon in medio hereditatis eorum."
,"10":"Ceciditque sors tertia filiorum Zabulon per cognationes suas. Et factus est terminus possessionis eorum usque Sarid"
,"11":"ascenditque contra occidentem et Merala et pervenit in Debbaseth usque ad torrentem, qui est contra Iecnaam,"
,"12":"et revertitur de Sarid contra orientem in fines Ceseleththabor et egreditur ad Dabereth ascenditque contra Iaphia."
,"13":"Et inde pertransit usque ad orientalem plagam Gethhepher, Etthacasin et egreditur in Remmon et inclinatur in Noa;"
,"14":"et vergit ad aquilonem ad Hanathon. Suntque egressus eius vallis Iephthael;"
,"15":"et Cateth et Naalol et Semeron et Iedala et Bethlehem: civitates duodecim et villae earum."
,"16":"Haec est hereditas tribus filiorum Zabulon per cognationes suas, urbes et viculi earum."
,"17":"Issachar egressa est sors quarta per cognationes suas."
,"18":"Fuitque eius hereditas Iezrahel et Chasaloth et Sunam"
,"19":"et Hapharaim et Seon et Anaharath"
,"20":"et Rabbith et Cesion et Abes"
,"21":"et Rameth et Engannim et Enhadda et Bethpheses."
,"22":"Et pervenit terminus eius usque Thabor et Sehesima et Bethsames; suntque exitus eius ad Iordanem; civitates sedecim et villae earum."
,"23":"Haec est possessio filiorum Issachar per cognationes suas, urbes et viculi earum."
,"24":"Ceciditque sors quinta tribui filiorum Aser per cognationes suas."
,"25":"Fuitque terminus eorum Helcath et Chali et Beten et Achsaph"
,"26":"et Elmelech et Amaad et Masal et pervenit usque ad Carmelum in occidente et ad Sihorlabanath;"
,"27":"ac revertitur contra orientem in Bethdagon et pertransit usque Zabulon et vallem Iephthael contra aquilonem in Bethemec et Neiel. Egrediturque ad laevam Chabul"
,"28":"et Abran et Rohob et Hamon et Cana usque ad Sidonem magnam"
,"29":"revertiturque in Rama usque ad civitatem munitissimam Tyrum et revertitur in Hosa; suntque exitus eius in mare; Mahaleb, Achazib"
,"30":"et Amma et Aphec et Rohob: civitates viginti duae et villae earum."
,"31":"Haec est possessio filiorum Aser per cognationes suas, urbes et viculi earum."
,"32":"Filiorum Nephthali sexta sors cecidit per familias suas."
,"33":"Et coepit terminus de Heleph et de quercu in Saananim et Adamineceb et Iebnael usque Lecum et egressus eius usque ad Iordanem;"
,"34":"revertiturque terminus contra occidentem in Aznotthabor atque inde egreditur in Hucoc et attingit Zabulon contra meridiem et Aser contra occidentem et Iordanem contra ortum solis;"
,"35":"civitates munitissimae Assedim, Ser et Ammath, Reccath et Chenereth"
,"36":"et Edema et Rama, Asor"
,"37":"et Cedes et Edrai et Enasor,"
,"38":"Ieron et Magdalel, Horem et Bethanath et Bethsames: civitates decem et novem et villae earum."
,"39":"Haec est possessio tribus filiorum Nephthali per cognationes suas, urbes et viculi earum."
,"40":"Tribui filiorum Dan per familias suas egressa est sors septima."
,"41":"Et fuit terminus possessionis eius Saraa et Esthaol et Hirsemes (id est civitas Solis)"
,"42":"et Selebin et Aialon et Iethela"
,"43":"et Elon et Thamna et Accaron"
,"44":"et Elthece et Gebbethon et Baalath"
,"45":"et Iud et Benebarach et Gethremmon"
,"46":"et Meiarcon et Areccon cum termino, qui respicit Ioppen."
,"47":"Et terminus filiorum Dan effugit ab eis. Ascenderuntque filii Dan et pugnaverunt contra Lesem ceperuntque eam; et percusserunt in ore gladii ac possederunt et habitaverunt in ea, vocantes Lesemdan ex nomine Dan patris sui."
,"48":"Haec est possessio tribus filiorum Dan per cognationes suas, urbes et viculi earum."
,"49":"Cumque complessent terram sorte dividere singulis per tribus suas, dederunt filii Israel possessionem Iosue filio Nun in medio sui,"
,"50":"iuxta praeceptum Domini, urbem quam postulavit: Thamnathsare in monte Ephraim. Et aedificavit civitatem habitavitque in ea."
,"51":"Hae sunt possessiones, quas sorte diviserunt Eleazar sacerdos et Iosue filius Nun et principes familiarum tribuum filiorum Israel in Silo coram Domino ad ostium tabernaculi conventus; compleveruntque partiri terram."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Et locutus est Dominus ad Iosue dicens: ' Loquere filiis Israel et dic eis:"
,"2":"Separate vobis urbes fugitivorum, de quibus locutus sum ad vos per manum Moysi,"
,"3":"ut confugiat ad eas, quicumque animam percusserit per errorem nescius, et possit evadere iram proximi, qui ultor est sanguinis."
,"4":"Cum ad unam harum confugerit civitatum, stabit ante portam civitatis et loquetur senioribus urbis illius ea, quae se comprobent innocentem; sicque suscipient eum et dabunt ei locum ad habitandum."
,"5":"Cumque ultor sanguinis eum fuerit persecutus, non tradent in manus eius, quia ignorans percussit proximum suum nec ante biduum triduumve eius probatur inimicus."
,"6":"Et habitabit in civitate illa, donec stet ante coetum ad iudicium, causam reddens facti sui, donec moriatur sacerdos magnus, qui fuerit in illo tempore. Tunc revertetur homicida et ingredietur civitatem suam et domum suam, de qua fugerat '."
,"7":"Decreveruntque Cedes in Galilaea montis Nephthali et Sichem in monte Ephraim et Cariatharbe - ipsa est Hebron - in monte Iudae;"
,"8":"et trans Iordanem contra orientalem plagam Iericho statuerunt Bosor, quae sita est in campestri solitudine de tribu Ruben, et Ramoth in Galaad de tribu Gad et Golan in Basan de tribu Manasse."
,"9":"Hae civitates constitutae sunt cunctis filiis Israel et advenis, qui habitant inter eos, ut fugeret ad eas, qui animam nescius percussisset et non moreretur in manu proximi effusum sanguinem vindicare cupientis, donec staret ante populum expositurus causam suam."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Accesseruntque principes familiarum Levi ad Eleazarum sacerdotem et Iosue filium Nun et ad duces cognationum per singulas tribus filiorum Israel"
,"2":"locutique sunt ad eos in Silo terrae Chanaan atque dixerunt: ' Dominus praecepit per manum Moysi, ut darentur nobis urbes ad habitandum et suburbana earum ad alenda iumenta '."
,"3":"Dederuntque filii Israel Levitis de possessionibus suis, iuxta imperium Domini, civitates illas et suburbana earum."
,"4":"Egressaque est sors in familias Caath: et acceperunt filii Aaron sacerdotis de tribubus Iudae et Simeon et Beniamin civitates tredecim."
,"5":"Et reliqui filiorum Caath, id est Levitae, acceperunt de tribubus Ephraim et Dan et dimidia tribu Manasse civitates decem."
,"6":"Porro filiis Gerson egressa est sors, ut acciperent de tribubus Issachar et Aser et Nephthali dimidiaque tribu Manasse in Basan civitates numero tredecim."
,"7":"Et filiis Merari per cognationes suas de tribubus Ruben et Gad et Zabulon urbes duodecim."
,"8":"Dederuntque filii Israel Levitis civitates illas et suburbana earum, sicut praecepit Dominus per manum Moysi, singulis sorte tribuentes."
,"9":"De tribubus filiorum Iudae et Simeon dederunt civitates, quarum ista sunt nomina,"
,"10":"filiis Aaron ex familiis Caath levitici generis - prima enim sors illis egressa est C:"
,"11":"Cariatharbe (id est civitas Arbe), patris Enac, quae vocatur Hebron, in monte Iudae et suburbana eius per circuitum."
,"12":"Agros vero et villas eius dederant Chaleb filio Iephonne ad possidendum."
,"13":"Dederunt ergo filiis Aaron sacerdotis Hebron confugii civitatem ac suburbana eius et Lobnam cum suburbanis suis"
,"14":"et Iether et Esthemo"
,"15":"et Helon et Dabir"
,"16":"et Ain et Iutta et Bethsames cum suburbanis suis: civitates novem de tribubus illis duabus."
,"17":"De tribu autem Beniamin Gabaon et Gabaa"
,"18":"et Anathoth et Almath cum suburbanis suis: civitates quattuor."
,"19":"Omnes simul civitates filiorum Aaron sacerdotis tredecim cum suburbanis suis."
,"20":"Reliquis vero ex familiis filiorum Caath Levitis haec est data possessio:"
,"21":"de tribu Ephraim urbs confugii Sichem cum suburbanis suis in monte Ephraim et Gazer"
,"22":"et Cibsaim et Bethoron cum suburbanis suis: civitates quattuor."
,"23":"De tribu quoque Dan Elthece et Gebbethon"
,"24":"et Aialon et Gethremmon cum suburbanis suis: civitates quattuor."
,"25":"Porro de dimidia tribu Manasse Thanach et Gethremmon cum suburbanis suis: civitates duae."
,"26":"Omnes civitates decem et suburbana earum datae sunt filiis Caath inferioris gradus."
,"27":"Filiis quoque Gerson levitici generis dederunt de dimidia tribu Manasse confugii civitatem Golan in Basan et Astharoth cum suburbanis suis: civitates duas."
,"28":"Porro de tribu Issachar Cesion et Dabereth"
,"29":"et Iaramoth et Engannim cum suburbanis suis: civitates quattuor."
,"30":"De tribu autem Aser Masal et Abdon"
,"31":"et Helcath et Rohob cum suburbanis suis: civitates quattuor."
,"32":"De tribu quoque Nephthali civitas confugii Cedes in Galilaea et Ammothdor et Carthan cum suburbanis suis: civitates tres."
,"33":"Omnes urbes familiarum Gerson tredecim cum suburbanis suis."
,"34":"Filiis autem Merari Levitis inferioris gradus per familias suas data est de tribu Zabulon Iecnaam et Cartha"
,"35":"et Remmon et Naalol: civitates quattuor cum suburbanis suis."
,"36":"De tribu Ruben ultra Iordanem contra Iericho civitas refugii Bosor in solitudine planitiei et Iasa"
,"37":"et Cademoth et Mephaath: civitates quattuor cum suburbanis suis."
,"38":"Et de tribu Gad civitas confugii Ramoth in Galaad et Mahanaim"
,"39":"et Hesebon et Iazer: civitates quattuor cum suburbanis suis."
,"40":"Omnes urbes filiorum Merari per familias reliquas de cognationibus Levitarum duodecim."
,"41":"Itaque universae civitates Levitarum in medio possessionis filiorum Israel fuerunt quadraginta octo"
,"42":"cum suburbanis suis, singulae cum suburbanis suis in circuitu."
,"43":"Deditque Dominus Israeli omnem terram, quam traditurum se patribus eorum iuraverat, et possederunt illam atque habitaverunt in ea."
,"44":"Deditque Dominus eis requiem secundum omnia, quae iuraverat patribus eorum, nullusque eis hostium resistere ausus est, sed cunctos in eorum dicionem redegit."
,"45":"Ne unum quidem verbum bonum, quod locutus est ad domum Israel, irritum fuit, sed rebus expleta sunt omnia."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Tunc vocavit Iosue Rubenitas et Gaditas et dimidiam tribum Manasse"
,"2":"dixitque ad eos: 'Fecistis omnia, quae vobis praecepit Moyses famulus Domini; mihi quoque in omnibus, quae praecepi vobis, oboedistis"
,"3":"nec reliquistis fratres vestros hoc longo tempore usque in praesentem diem custodientes imperium Domini Dei vestri."
,"4":"Quia igitur dedit Dominus Deus vester fratribus vestris quietem ac pacem, sicut eis pollicitus est, revertimini nunc et ite in tabernacula vestra et in terram possessionis, quam tradidit vobis Moyses famulus Domini trans Iordanem;"
,"5":"ita dumtaxat ut custodiatis attente et opere compleatis mandatum et legem, quam praecepit vobis Moyses servus Domini, ut diligatis Dominum Deum vestrum et ambuletis in omnibus viis eius et observetis mandata illius adhaereatisque ei ac serviatis in omni corde et in omni anima vestra '."
,"6":"Benedixitque eis Iosue et dimisit eos, qui reversi sunt in tabernacula sua."
,"7":"Dimidiae autem tribui Manasse possessionem Moyses dederat in Basan; et idcirco mediae, quae superfuit, dedit Iosue sortem inter ceteros fratres suos trans Iordanem ad occidentalem eius plagam. Cumque dimitteret eos in tabernacula sua et benedixisset illis,"
,"8":"dixit ad eos: 'Cum multis divitiis revertimini ad sedes vestras, cum argento et auro, aere ac ferro et veste multiplici; dividite praedam hostium cum fratribus vestris '."
,"9":"Reversique sunt et abierunt filii Ruben et filii Gad et dimidia tribus Manasse a filiis Israel de Silo, quae sita est in Chanaan, ut intrarent Galaad terram possessionis suae, quam obtinuerant iuxta imperium Domini in manu Moysi."
,"10":"Cumque venissent ad circulos Iordanis in terra Chanaan, aedificaverunt iuxta Iordanem altare ingens aspectu."
,"11":"Cum audissent filii Israel aedificasse filios Ruben et Gad et dimidiam tribum Manasse altare e regione terrae Chanaan ad Iordanis circulos ex adverso filiorum Israel,"
,"12":"convenerunt omnes in Silo, ut ascenderent et dimicarent contra eos."
,"13":"Et interim miserunt ad illos in terram Galaad Phinees filium Eleazari sacerdotem"
,"14":"et decem principes cum eo, singulos de tribubus, unusquisque erat caput familiae in cognationibus Israel."
,"15":"Qui venerunt ad filios Ruben et Gad et dimidiam tribum Manasse in terram Galaad dixeruntque ad eos:"
,"16":"' Haec mandat omnis coetus Domini: Quae est ista transgressio? Cur reliquistis Dominum, Deum Israel, aedificantes vobis altare sacrilegum et a cultu illius recedentes?"
,"17":"An parum vobis est peccatum Phegor, et usque in praesentem diem macula huius sceleris in nobis permanet, et facta est plaga in coetu Domini?"
,"18":"Et vos hodie reliquistis Dominum, et factum est ut rebellaretis contra Dominum; et cras in universum coetum Israel eius ira desaeviet."
,"19":"Quod si putatis immundam esse terram possessionis vestrae, transite ad terram possessionis Domini, in qua habitaculum Domini est, et habitate inter nos; tantum ut contra Dominum non rebelletis nec nos rebellare faciatis aedificantes altare praeter altare Domini Dei nostri."
,"20":"Nonne Achan filius Zarae praeteriit mandatum Domini de anathemate, et super omnem coetum Israel ira Domini incubuit? Et ille erat unus homo; atque utinam solus perisset in scelere suo! '."
,"21":"Responderuntque filii Ruben et Gad et dimidia tribus Manasse principibus legationis Israel:"
,"22":"' Fortissimus Deus Dominus, fortissimus Deus Dominus ipse novit, et Israel simul intelleget: si rebellionis, si praevaricationis animo contra Dominum hoc altare construximus, non salvet nos, sed puniat in praesenti;"
,"23":"et si ea mente fecimus, ut recedamus a Domino et holocausta et oblationes et pacificas victimas super eo imponeremus, Dominus ipse quaerat et iudicet;"
,"24":"et si non ea magis sollicitudine et cogitatione fecimus hoc dicentes: Cras dicent filii vestri filiis nostris: 'Quid vobis et Domino, Deo Israel?"
,"25":"Terminum posuit Dominus inter nos et vos, o filii Ruben et filii Gad, Iordanem fluvium, et idcirco partem non habetis in Domino'; et per hanc occasionem avertent filii vestri filios nostros a timore Domini. Putavimus itaque melius"
,"26":"et diximus: Exstruamus nobis altare non in holocausta neque ad victimas offerendas,"
,"27":"sed in testimonium inter nos et vos et sobolem nostram vestramque progeniem, ut serviamus Domino, et iuris nostri sit offerre holocausta et victimas et pacificas hostias, et nequaquam dicant cras filii vestri filiis nostris: 'Non est vobis pars in Domino'."
,"28":"Quod si voluerint dicere, respondebunt eis: 'Ecce similitudo altaris Domini, quam fecerunt patres nostri non in holocausta neque in sacrificia, sed in testimonium inter nos et vos'."
,"29":"Absit a nobis hoc scelus, ut recedamus a Domino et eius vestigia relinquamus, exstructo altari ad holocausta et oblationes et victimas offerendas, praeter altare Domini Dei nostri, quod est ante habitaculum eius '."
,"30":"Quibus auditis, Phinees sacerdos et principes legationis Israel, qui erant cum eo, placati sunt et verba filiorum Ruben et Gad et dimidiae tribus Manasse libentissime susceperunt;"
,"31":"dixitque Phinees filius Eleazar sacerdos ad eos: ' Nunc scimus quod nobiscum sit Dominus, quoniam alieni estis a praevaricatione hac et liberastis filios Israel de manu Domini '."
,"32":"Reversusque est cum principibus a filiis Ruben et Gad de terra Galaad in terram Chanaan ad filios Israel et rettulit eis."
,"33":"Placuitque sermo cunctis audientibus, et laudaverunt Deum filii Israel; et nequaquam ultra dixerunt, ut ascenderent contra eos in bellum et delerent terram, in qua habitabant filii Ruben et Gad."
,"34":"Vocaveruntque filii Ruben et filii Gad altare, quod exstruxerant, Testem; dixerunt enim: ' Testis est inter nos quod Dominus ipse sit Deus '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Evoluto autem multo tem pore, postquam pacem Do minus dederat Israeli ab omnibus in gyro nationibus et Iosue iam longaevo et persenilis aetatis,"
,"2":"vocavit Iosue omnem Israelem maioresque natu et principes ac iudices et praefectos dixitque ad eos: ' Ego senui et progressioris aetatis sum,"
,"3":"vosque vidistis omnia, quae fecerit Dominus Deus vester cunctis nationibus istis, quomodo pro vobis ipse pugnaverit."
,"4":"Videte, sorte divisi vobis gentes, quae supersunt, in possessionem tribuum vestrarum, sicut omnes, quas delevi, a Iordane usque ad mare Magnum in occidente."
,"5":"Dominus Deus vester disperdet eas et auferet a facie vestra, et possidebitis terram eorum, sicut vobis pollicitus est."
,"6":"Tantum confortamini, ut custodiatis cuncta, quae scripta sunt in volumine legis Moysi, et non declinetis ab eis nec ad dexteram nec ad sinistram;"
,"7":"ne conveniatis cum gentibus, quae inter vos residuae sunt, et iuretis in nomine deorum earum et serviatis eis et adoretis illos;"
,"8":"sed adhaereatis Domino Deo vestro, quod fecistis usque in diem hanc."
,"9":"Et expulit Dominus in conspectu vestro gentes magnas et robustissimas, et nullus vobis resistere potuit:"
,"10":"unus e vobis persequitur hostium mille viros, quia Dominus Deus vester pro vobis ipse pugnat, sicut pollicitus est;"
,"11":"hoc tantum diligentissime praecavete, ut diligatis Dominum Deum vestrum."
,"12":"Quod si volueritis gentium harum, quae inter vos residuae sunt, erroribus adhaerere et cum eis miscere conubia atque amicitias copulare,"
,"13":"iam nunc scitote quod Dominus Deus vester non eas deleat ante faciem vestram; sed sint vobis in rete, foveam ac laqueum et flagellum ex latere vestro, et spinae in oculis vestris, donec vos disperdat de terra hac optima, quam tradidit vobis."
,"14":"En ego hodie ingredior viam universae terrae; et toto animo cognoscetis quod de omnibus verbis bonis, quae Dominus Deus vester locutus est vobis, non praeterierit ne unum quidem incassum."
,"15":"Sicut ergo implevit opere, quod promisit, et prospera cuncta venerunt, sic adducet super vos quidquid malorum comminatus est, donec vos disperdat de terra hac optima, quam tradidit vobis."
,"16":"Si praeterieritis pactum Domini Dei vestri, quod mandavit vobis, et servieritis diis alienis et adoraveritis eos, consurget in vos furor Domini, et cito peribitis ab hac terra optima, quam tradidit vobis '."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Congregavitque Iosue omnes tribus Israel in Sichem et vocavit maiores natu ac principes et iudices et praefectos, steteruntque in conspectu Dei;"
,"2":"et ad totum populum sic locutus est: ' Haec dicit Dominus, Deus Israel: Trans fluvium habitaverunt patres vestri ab initio, Thare pater Abraham et Nachor, servieruntque diis alienis."
,"3":"Tuli ergo patrem vestrum Abraham de Mesopotamiae finibus et adduxi eum per totam terram Chanaan multiplicavique semen eius."
,"4":"Et dedi ei Isaac illique rursum dedi Iacob et Esau; e quibus Esau dedi montem Seir ad possidendum, Iacob vero et filii eius descenderunt in Aegyptum."
,"5":"Misique Moysen et Aaron et percussi Aegyptum signis, quae feci in medio eius, et postea eduxi vos."
,"6":"Eduxique patres vestros de Aegypto, et venistis ad mare. Persecutique sunt Aegyptii patres vestros cum curribus et equitatu usque ad mare Rubrum."
,"7":"Clamaverunt autem ad Dominum, qui posuit tenebras inter vos et Aegyptios et adduxit super eos mare et operuit illos. Viderunt oculi vestri, quae in Aegypto fecerim; et habitastis in solitudine multo tempore."
,"8":"Et introduxi vos ad terram Amorraei, qui habitabat trans Iordanem; cumque pugnarent contra vos, tradidi eos in manus vestras, et occupastis terram eorum atque interfecistis illos."
,"9":"Surrexit autem Balac filius Sephor rex Moab et pugnavit contra Israelem; misitque et vocavit Balaam filium Beor, ut malediceret vobis."
,"10":"Et ego nolui audire eum, sed e contrario benedixit vobis, et liberavi vos de manu eius."
,"11":"Transistisque Iordanem et venistis ad Iericho; pugnaveruntque contra vos viri civitatis illius, Amorraeus et Pherezaeus et Chananaeus et Hetthaeus et Gergesaeus et Hevaeus et Iebusaeus; et tradidi illos in manus vestras."
,"12":"Misique ante vos crabrones, et eiecerunt eos coram vobis - duos reges Amorraeorum - non in gladio nec in arcu tuo."
,"13":"Dedique vobis terram, de qua non laborastis, et urbes, quas non aedificastis, et habitatis in eis, vineas et oliveta, quae non plantastis, et manducatis ex eis."
,"14":"Nunc ergo timete Dominum et servite ei perfecto corde atque verissimo; et auferte deos, quibus servierunt patres vestri in Mesopotamia et in Aegypto, ac servite Domino."
,"15":"Sin autem malum vobis videtur, ut Domino serviatis, eligite vobis hodie, cui servire vultis, utrum diis, quibus servierunt patres vestri in Mesopotamia, an diis Amorraeorum, in quorum terra habitatis. Ego autem et domus mea serviemus Domino '."
,"16":"Responditque populus et ait: ' Absit a nobis, ut relinquamus Dominum et serviamus diis alienis."
,"17":"Dominus Deus noster ipse eduxit nos et patres nostros de terra Aegypti, de domo servitutis; fecitque videntibus nobis signa ingentia et custodivit nos in omni via, per quam ambulavimus, et in cunctis populis, per quos transivimus;"
,"18":"et eiecit universas gentes, Amorraeum habitatorem terrae, quam nos intravimus. Serviemus igitur etiam nos Domino, quia ipse est Deus noster '."
,"19":"Dixitque Iosue ad populum: ' Non poteritis servire Domino. Deus enim sanctus et Deus aemulator est nec ignoscet sceleribus vestris atque peccatis."
,"20":"Si dimiseritis Dominum et servieritis diis alienis, convertet se et affliget vos atque subvertet, postquam vobis praestiterit bona '."
,"21":"Dixitque populus ad Iosue: ' Nequaquam, sed Domino serviemus '."
,"22":"Et Iosue ad populum: ' Testes, inquit, vos estis contra vos quia ipsi elegeritis vobis Dominum, ut serviatis ei '. Responderuntque: ' Testes '."
,"23":"' Nunc ergo, ait, auferte deos alienos de medio vestri et inclinate corda vestra ad Dominum, Deum Israel'."
,"24":"Dixitque populus ad Iosue: 'Domino Deo nostro serviemus; oboedientes erimus praeceptis eius '."
,"25":"Percussit igitur Iosue in die illo foedus populo et proposuit ei praecepta atque iudicia in Sichem."
,"26":"Scripsitque verba haec in volumine legis Dei; et tulit lapidem pergrandem posuitque eum ibi subter quercum, quae erat in sanctuario Domini,"
,"27":"et dixit ad omnem populum: ' En lapis iste erit adversus vos in testimonium quia audivit omnia verba Domini, quae locutus est inter nos, ne forte postea negare velitis et mentiri Domino Deo vestro '."
,"28":"Dimisitque populum, singulos in possessionem suam."
,"29":"Et post haec mortuus est Iosue filius Nun, servus Domini, centum decem annorum."
,"30":"Sepelieruntque eum in finibus possessionis suae in Thamnathsare, quae sita est in monte Ephraim a septentrionali parte montis Gaas."
,"31":"Servivitque Israel Domino cunctis diebus Iosue et seniorum, qui longo vixerunt tempore post Iosue et qui noverunt omnia opera Domini, quae fecerat Israel."
,"32":"Ossa quoque Ioseph, quae tulerant filii Israel de Aegypto, sepelierunt in Sichem, in parte agri, quem emerat Iacob a filiis Hemmor patris Sichem centum argenteis, et fuit in possessionem filiorum Ioseph."
,"33":"Eleazar quoque filius Aaron mortuus est; et sepelierunt eum in Gabaa Phinees filii eius, quae data est ei in monte Ephraim."
}`)

}
func LA_NVBSE_LoadVHIHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Anno duodecimo regni Nabu chodonosor, qui regnavit in As syriis in Nineve civitate magna, in diebus Arphaxad, qui regnavit in Medis in Ecbatanis"
,"2":"et aedificavit in Ecbatanis et in circuitu muros ex lapidibus excisis in latitudinem cubitorum trium et in longitudinem cubitorum sex et fecit altitudinem muri cubitorum septuaginta et latitudinem eius cubitorum quinquaginta"
,"3":"et turres eius constituit super portas eius cubitorum centum et latitudinem earum fundavit in cubitos sexaginta."
,"4":"Et fecit portas eius portas exsurgentes in altitudinem cubitorum septuaginta et in latitudinem earum cubitis quadraginta in exitum virtutis potentium eius et in dispositiones peditum eius."
,"5":"Et fecit bellum in diebus illis rex Nabuchodonosor ad Arphaxad regem in campo magno, hic est campus in finibus Ragau."
,"6":"Et convenerunt in pugnam omnes inhabitantes montanam et omnes inhabitantes Euphraten et Tigrin et Hidaspen et campos Arioch regis Elymaeorum. Et convenerunt gentes multae valde ad bellum filiorum Chaldaeorum."
,"7":"Et misit Nabuchodonosor rex Assyriorum ad omnes inhabitantes Persidem et ad omnes inhabitantes ad occasum: inhabitantes Ciliciam et Damascum et Libanum et Antilibanum et ad omnes inhabitantes circa faciem maritimae;"
,"8":"et ad eos, qui sunt in nationibus Carmeli et Galaad, et ad superiorem Galilaeam et ad campum magnum Esdrelon;"
,"9":"et ad omnes, qui in Samaria et civitatibus eius et trans Iordanen usque in Ierusalem et Bathanam et Chelus et Cades et flumen Aegypti et Taphnas et Ramesses et omnem terram Gessen,"
,"10":"usquedum veniatur supra Tanim et Memphin, et ad omnes inhabitantes Aegyptum, usquedum veniatur ad fines Aethiopiae."
,"11":"Et contempserunt omnes inhabitantes universam terram verbum Nabuchodonosor regis Assyriorum et non convenerunt cum eo in pugnam, quoniam non timuerunt eum, sed erat adversus eos quasi vir unus. Et remiserunt legatos eius vacuos in despectu faciei eorum."
,"12":"Et indignatus est rex Nabuchodonosor ad omnem terram istam vehementer. Et iuravit per thronum et regnum suum se vindicaturum esse omnes fines Ciliciae et Damascenae et Syriae, sublaturum se gladio suo et omnes inhabitantes Moab et filios Ammon et omnem Iudaeam et omnes, qui in Aegypto, usquedum veniatur ad fines duorum marium."
,"13":"Et praeparavit se in virtute sua adversus regem Arphaxad in anno septimo decimo et invaluit in pugna sua et evertit omnem virtutem Arphaxad et omnem equitatum eius et omnes currus ipsius"
,"14":"et dominatus est civitatibus eius. Et abiit usque ad Ecbatana et obtinuit turres et praedavit plateas eius et ornatum eius posuit in improperium illius."
,"15":"Et cepit Arphaxad in montibus Ragau et iaculatus est eum iaculis suis et disperdidit eum usque in illum diem."
,"16":"Et reversus est postea in Nineven ipse et commixtura eius, multitudo hominum pugnatorum multa valde. Et erat ibi requiescens et epulans ipse et virtus eius per dies centum viginti."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et in anno octavo decimo, secundo et vicesimo die mensis primi factum est verbum Nabuchodonosor regis Assyriorum, ut vindicaret omnem terram, sicut locutus est."
,"2":"Et convocavit omnes famulos suos et omnes magnates suos et posuit cum eis secretum consilii sui et consummavit omne malum terrae ex ore suo;"
,"3":"et ipsi iudicaverunt exterminare omnem carnem eorum, qui non sunt obsecuti verbo oris eius."
,"4":"Et factum est, cum consummasset consilium suum, vocavit Nabuchodonosor rex Assyriorum Holofernen principem militiae virtutis suae, qui erat secundus post se,"
,"5":"et dixit ad eum: ' Haec dicit rex magnus, universae terrae dominus. Ecce tu exies a facie mea et accipies tecum viros fidentes in virtute sua: in centum viginti milia peditum et multitudinem equorum cum ascensoribus duodecim milia;"
,"6":"et exies in obviam universae terrae ad occasum, quia non crediderunt verbo oris mei."
,"7":"Et denuntiabis eis, ut praeparent mihi terram et aquam, quoniam ego exeam in ira mea ad eos et cooperiam omnem faciem terrae in pedibus virtutis meae et dabo eos in rapinam,"
,"8":"et vulnerati illorum replebunt valles eorum, et omnis torrens et flumen inundans mortuis eorum replebuntur."
,"9":"Et adducam captivitatem eorum ad extrema universae terrae."
,"10":"Tu autem exiens praeoccupabis mihi omnem finem eorum, et tradent se tibi, et reservabis mihi in diem redargutionis eorum."
,"11":"Super eos autem, qui non oboediunt, non parcet oculus tuus, ut des eos in occisionem et rapinam in tota terra tua,"
,"12":"quoniam vivo ego et potestas regni mei; locutus sum et faciam omnia haec in manu mea."
,"13":"Et tu non praeteries unum verbum domini tui, sed consummans consummabis, sicut praecepi tibi, et non prolongabis, ut facias ea '."
,"14":"Et exiit Holofernes a facie domini sui et vocavit omnes praefectos et duces et magistratus virtutis Assyriae"
,"15":"et numeravit electos viros in expeditionem, quemadmodum praeceperat ei dominus suus, in centum viginti milia et equitum sagittariorum duodecim milia."
,"16":"Et disposuit eos, quemadmodum belli multitudo constituitur."
,"17":"Et accepit camelos et asinos et mulos ad utensilia eorum, multitudinem magnam valde, et oves et boves et capras in praeparationem eorum, quorum non erat numerus,"
,"18":"et epimenia omni viro in multitudinem; et aurum et argentum de domo regis multum valde."
,"19":"Et exiit a Nineve ipse et omnis virtus eius in profectionem, ut praecederet regem Nabuchodonosor et cooperiret omnem faciem terrae, quae est ad occasum, in quadrigis et equitibus et peditibus electis suis."
,"20":"Et multa mixtura sicut locusta convenerunt cum eis et sicut arena terrae; non enim erat numerus prae multitudine eorum."
,"21":"Et exierunt ex Nineve viam dierum trium super faciem campi Bectileth et posuerunt tabernacula sua a Bectileth iuxta montem, qui est in sinistra superioris Ciliciae."
,"22":"Et accepit omnem virtutem suam, pedites et equites et quadrigas suas et abiit inde in montanam"
,"23":"et concidit Phut et Lud et praedaverunt omnes filios Rassis et filios Ismael, qui erant contra faciem deserti ad austrum Chelaeorum."
,"24":"Et transgressus est Euphraten et transiit Mesopotamiam et diruit omnes civitates excelsas, quae erant ad torrentem Abronam, usquequo veniatur ad mare."
,"25":"Et occupavit terminos Ciliciae et concidit omnes adversantes sibi et venit usque ad terminos Iapheth, qui sunt ad austrum contra faciem Arabiae."
,"26":"Et circuivit omnes filios Madian et succendit tabernacula eorum et praedavit stabula eorum."
,"27":"Et descendit in campum Damasci in diebus messis frumenti et succendit omnes agros eorum; greges et armenta dedit in exterminium et civitates eorum spoliavit et campos eorum ventilavit et percussit omnes iuvenes eorum in ore gladii."
,"28":"Et incidit timor et tremor eius super inhabitantes maritimam, qui erant in Sidone et Tyro, et inhabitantes Sur et Ochina et omnes, qui incolebant Iamniam; et habitantes in Azoto et Ascalone et Gaza timuerunt eum valde."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et miserunt ad eum legatos verbis pacificis dicentes:"
,"2":"' Ecce nos pueri Nabuchodonosor regis magni adstamus coram te; utere nobis, quemadmodum placet faciei tuae."
,"3":"Ecce villae nostrae et omnis locus noster et omnis campus frumenti et greges et armenta et omnia stabula iumentorum nostrorum adstant ante faciem tuam; utere, quemadmodum placet tibi."
,"4":"Ecce et civitates nostrae et, qui inhabitant in eis, servi tui sunt; veniens occurre eis, sicut est bonum in oculis tuis '."
,"5":"Et venerunt viri ad Holofernen et nuntiaverunt ei secundum verba haec."
,"6":"Et descendit ad maritimam ipse et virtus eius et custodivit civitates excelsas et accepit ex eis in auxilium viros electos."
,"7":"Et exceperunt eum ipsi et omnis circumregio eorum cum coronis et choris et tympanis."
,"8":"Et destruxit omnes fines eorum et lucos eorum excidit, et datum ei erat omnes deos terrae exterminare, ut ipsi soli Nabuchodonosor servirent omnes gentes, et omnes linguae et omnes tribus eorum invocarent eum deum."
,"9":"Et venit contra faciem Esdrelon prope Dothain, quae est contra descensum magnum Iudaeae,"
,"10":"et castra posuerunt inter Gabaa et Scytharum civitatem. Et erat ibi mensem dierum, ut colligeret omnia utensilia virtutis suae."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et audierunt filii Israel, qui habitabant in Iudaea, omnia, quaecumque fecerat gentibus Holofernes princeps militiae Nabuchodonosor regis Assyriorum, et quemadmodum spoliaverat omnia sancta eorum et dederat ea in exterminium."
,"2":"Et timuerunt multum valde a facie eius et pro Ierusalem et pro templo Domini Dei sui turbati sunt,"
,"3":"quoniam nuper ascenderant de captivitate, et nuper omnis populus Iudaeae collectus erat, et vasa et altare et domus ex commaculatione sanctificata erant."
,"4":"Et miserunt in omnem finem Samariae et in vicos et Bethoron et Abelmain et Iericho et Choba et Aisora et convallem Salem."
,"5":"Et praeoccupaverunt omnes vertices montium excelsorum et muris circumdederunt vicos, qui in eis sunt, et reposuerunt epimenia in praeparationem pugnae, quoniam nuper erant campi eorum demessi."
,"6":"Et scripsit Ioachim sacerdos magnus, qui erat in diebus illis in Ierusalem, inhabitantibus Betuliam et Betomesthaim, quae est supra descensum contra Esdrelon, contra faciem campi prope Dothain,"
,"7":"dicens ut obtinerent ascensus montanae, quoniam per eos erat introitus in Iudaeam et erat facile prohibere ascendentes, eo quod angustus esset accessus viris plus quam duobus."
,"8":"Et fecerunt filii Israel, sicut constituerat illis Ioachim sacerdos magnus et seniores totius plebis Israel, qui sedebant in Ierusalem."
,"9":"Et exclamavit omnis vir Israel ad Deum in instantia magna, et humiliaverunt animas suas in ieiunio magno;"
,"10":"ipsi et mulieres eorum et infantes eorum et iumenta eorum et omnis advena et mercennarius et argento emptus eorum posuerunt cilicia super lumbos suos."
,"11":"Et omnis vir Israel et mulier et pueri, qui habitabant in Ierusalem, prociderunt ante faciem templi et cineraverunt capita sua et extenderunt cilicia sua contra faciem templi Domini."
,"12":"Et altare cilicio cooperuerunt et clamaverunt ad Deum Israel unanimes instanter, ut non daret in rapinam infantes eorum et mulieres in praedam et civitates hereditatis eorum in exterminium et sancta in maculationem et in improperium, gaudium gentibus."
,"13":"Et audivit Dominus vocem eorum et vidit angustiam eorum; et erat populus ieiunans dies plures in tota Iudaea et Ierusalem, et prociderunt contra faciem sanctorum Domini omnipotentis."
,"14":"Et Ioachim sacerdos magnus et omnes adstantes ante conspectum Domini sacerdotes et deservientes Domino praecincti ciliciis lumbos suos offerebant holocaustum instantiae et vota et voluntaria munera populi."
,"15":"Et erat cinis super cidares eorum, et clamabant ad Dominum ex omni virtute, ut in bonum visitaret omnem domum Israel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et renuntiatum est Holoferni principi militiae virtutis Assyriae quoniam filii Israel praeparaverant se ad pugnam et transitus montanae concluserant et muris cinxerant omnem verticem montis excelsi et posuerant in campis offendicula."
,"2":"Et iratus est iracundia valde et convocavit omnes principes Moab et duces Ammon et omnes magistratus maritimae"
,"3":"et dixit eis: ' Renuntiate mihi, filii Chanaan: Quis est iste populus, qui sedet in montanis? Quae sunt autem, quas inhabitant, civitates, et quae est multitudo virtutis eorum? Et in quo est potestas et fortitudo eorum, et quis praeest super eos rex, dux militiae eorum?"
,"4":"Et quare terga verterunt, ne venirent in obviam mihi prae omnibus, qui inhabitant ad occasum? '."
,"5":"Et dixit ad eum Achior dux filiorum Ammon: ' Audiat dominus meus verbum ex ore servi tui, et referam tibi veritatem de populo isto, qui inhabitat montana ista iuxta te, et non exibit mendacium ex ore servi tui."
,"6":"Populus hic est ex progenie Chaldaeorum"
,"7":"et inhabitaverunt primum in Mesopotamia, quoniam noluerunt sequi deos patrum suorum, qui fuerunt in terra Chaldaeorum praeclari."
,"8":"Et declinaverunt de via parentum suorum et adoraverunt Deum caeli, Deum, quem cognoverunt; et eiecerunt eos a facie deorum suorum, et fugerunt in Mesopotamiam et inhabitaverunt ibi dies multos."
,"9":"Et dixit Deus eorum, ut exirent de peregrinatione ipsorum et irent in terram Chanaan. Et inhabitaverunt ibi et repleti sunt auro et argento et pecoribus multis valde."
,"10":"Et descenderunt in Aegyptum - cooperuerat enim fames faciem terrae Chanaan - et commorati sunt ibi, usquedum enutriti sunt et facti sunt ibi in multitudinem magnam, nec erat numerus generis eorum."
,"11":"Et insurrexerunt super eos Aegyptii et circumvenerunt eos in luto et latere, humiliaverunt eos et posuerunt eos in servos."
,"12":"Et clamaverunt ad Deum suum, et percussit totam terram Aegypti plagis, in quibus non erat medicina, et eiecerunt eos Aegyptii a facie sua."
,"13":"Et exsiccavit Deus Rubrum mare ante eos"
,"14":"et eduxit eos in viam Sinai et Cadesbarne. Et eiecerunt omnes inhabitantes in eremo"
,"15":"et habitaverunt in terra Amorraeorum et omnes Hesebonitas exstirpaverunt in virtute sua. Et transeuntes Iordanem possederunt totam montanam"
,"16":"et eiecerunt a facie sua Chananaeum et Pherezaeum et Iebusaeum et Sichem et omnes Gergesaeos et habitaverunt in ea diebus multis."
,"17":"Et, usquedum non peccarent in conspectu Dei sui, erant cum ipsis bona, quia Deus odiens iniquitatem cum ipsis est."
,"18":"Sed, cum recesserunt a via, quam disposuerat illis, exterminati sunt in bellis multis multum valde et captivi ducti sunt in terram non suam, et templum Dei eorum devenit ad solum, et civitates eorum comprehensae sunt ab adversariis."
,"19":"Et nunc revertentes ad Deum suum ascenderunt a dispersione, qua dispersi fuerant, et possederunt Ierusalem, ubi sanctuarium eorum est, et inhabitaverunt in montana, quia erat deserta."
,"20":"Et nunc, dominator domine, siquidem est ignorantia in populo isto, et peccant in Deum suum, inspiciemus quoniam est in illis offendiculum hoc et ascendemus et expugnabimus eos;"
,"21":"si autem non est iniquitas in ipsa gente, transeat dominus meus, ne forte protegat eos Dominus eorum et Deus eorum, et erimus in improperium coram omni terra '."
,"22":"Et factum est, ut desiit loqui Achior verba haec, murmuravit omnis populus, qui erat in circuitu tabernaculi. Et dixerunt magnates Holoferni et omnes, qui habitabant maritimam et Moab, ut configerent eum:"
,"23":"' Non enim timebimus a filiis Israel; ecce enim populus, in quo non est virtus neque potestas in pugnam validam."
,"24":"Propter hoc ascendemus, et erunt in escam militiae tuae, dominator Holofernes '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et, cum cessasset tumultus viro rum, qui erant in circuitu conci lii, dixit Holofernes princeps militiae virtutis Assyriae ad Achior coram omni populo alienigenarum et ad omnes filios Moab:"
,"2":"' Et quis es tu, Achior, et mercennarii Ephraim, quoniam prophetasti nobis sicut hodie et dixisti quoniam genus filiorum Israel non expugnatur, quoniam Deus eorum proteget eos? Et quis est Deus, nisi Nabuchodonosor rex omnis terrae? Hic mittet potestatem suam et disperdet eos a facie terrae, et non liberabit eos Deus eorum."
,"3":"Sed nos servi illius percutiemus eos sicut hominem unum, nec sustinebunt vim equorum nostrorum."
,"4":"Inundabimus enim eos in ipsis, et montes eorum inebriabuntur sanguine eorum, et campi eorum replebuntur mortuis eorum, et non resistet vestigium pedum eorum contra faciem nostram, sed perditione perient. Dicit rex Nabuchodonosor, dominus universae terrae; dixit enim, et non frustrabuntur verba oris eius."
,"5":"Tu autem, Achior, mercennari Ammon, qui locutus es verba haec in die iniquitatis tuae, non videbis faciem meam iam ex hac die, quoadusque ulciscar in genus illorum, qui ascenderunt ex Aegypto."
,"6":"Et tunc pertransiet ferrum militiae meae et populus famulorum meorum latera tua, et cades cum vulneratis eorum, cum venero."
,"7":"Et deducent te servi mei in montanam et ponent te in una civitatum ascensuum"
,"8":"et non peries, donec extermineris cum eis."
,"9":"Et, si speras corde tuo quoniam non capientur, non concidat facies tua. Locutus sum, et nihil decidet verborum meorum '."
,"10":"Et praecepit Holofernes servis suis, qui erant adstantes in tabernaculo eius, ut comprehenderent Achior et ducerent eum in Betuliam et traderent in manus filiorum Israel."
,"11":"Et comprehenderunt eum servi eius et duxerunt illum extra castra in campum et promoverunt ex medio campo in montanam et advenerunt ad fontes, qui erant sub Betulia."
,"12":"Et, ut viderunt eos viri civitatis super verticem montis, acceperunt arma sua et exierunt extra civitatem supra cacumen montis, et omnis vir fundibalarius occupavit ascensus eorum et mittebat lapides super eos."
,"13":"Et accedentes sub monte alligaverunt Achior et reliquerunt proiectum sub radice montis et reversi sunt ad dominum suum."
,"14":"Descendentes autem filii Israel de civitate sua adstiterunt ei et solventes eum perduxerunt in Betuliam et adduxerunt eum ad principes civitatis suae,"
,"15":"qui erant in diebus illis Ozias filius Michae de tribu Simeon et Chabris filius Gothoniel et Charmis filius Melchiel."
,"16":"Et convocaverunt omnes seniores civitatis, et concurrerunt omnes iuvenes eorum et mulieres et pueri eorum in ecclesiam; et statuerunt Achior in medio omnis populi ipsorum, et interrogavit eum Ozias, quid contigisset."
,"17":"Et respondens indicavit eis verba consilii Holofernis et omnia verba, quaecumque locutus est in medio principum filiorum Assyriae, et quaecumque magniverbatus est Holofernes adversus domum Israel."
,"18":"Et procidens omnis populus adoraverunt Deum et clamaverunt dicentes:"
,"19":"' Domine, Deus caeli, respice ad superbiam eorum et miserere humilitatis generis nostri et respice ad faciem eorum, qui sanctificati sunt tibi in hac die '."
,"20":"Et consolati sunt Achior et laudaverunt eum valde."
,"21":"Et suscepit eum Ozias de ecclesia in domum suam et fecit cenam senioribus, et invocaverunt,Deum Israel in adiutorium per totam noctem illam. "
}`)
	CurrentBook.AddChapter(7, `{
"1":"Crastina autem die praecepit Holofernes omni militiae suae et omni populo suo, qui affuerunt in auxilium illius, ut pararent se ad Betuliam et ascensus montanae praeoccuparent et facerent pugnam adversus filios Israel."
,"2":"Et paraverunt se in illa die omnis vir potens eorum; et virtus eorum virorum bellatorum erat centum septuaginta milia peditum et equitum duodecim milia, praeter impedimenta et viros, qui erant pedites in eis, multitudo magna valde."
,"3":"Et castra collocaverunt in convallem iuxta Betuliam ad fontem et praetenderunt in latitudinem contra Dothain usque ad Abelmain et in longitudinem a Betulia usque Chyamonem, quae est contra Esdrelon."
,"4":"Filii autem Israel, ut viderunt multitudinem eorum, turbati sunt valde et dixerunt unusquisque ad proximum suum: ' Nunc lingent isti faciem totius terrae, nec montes alti neque valles neque colles sustinebunt pondus eorum '."
,"5":"Et accipientes unusquisque vasa sua bellica et accendentes ignem in turribus murorum suorum manebant custodientes per totam noctem illam."
,"6":"Altera autem die eduxit Holofernes omnem equitatum suum contra faciem filiorum Israel, qui erant in Betulia,"
,"7":"et visitavit ascensus civitatis eorum et fontes aquarum perambulavit et praeoccupavit eos. Et praeposuit eis castra virorum bellatorum et ipse convertit in populum suum."
,"8":"Et accedentes ad eum omnes principes filiorum Esau et omnes duces populi Moab et magistratus maritimae dixerunt:"
,"9":"' Audiat verbum dominator noster, ne fiat confractio in virtute tua."
,"10":"Populus enim hic filiorum Israel non fidit in lanceis suis sed in altitudinibus montium, in quibus inhabitant; non enim est facile ascendere vertices montium ipsorum."
,"11":"Et nunc, dominator, noli pugnare ad eos sicut pugna fit belli, et non cadet ex populo tuo vir unus;"
,"12":"sed mane in castris tuis custodiens omnem virum virtutis tuae, et obtineant pueri tui fontem aquarum, qui emanat a radice montis,"
,"13":"quia inde hauriunt aquas omnes inhabitantes Betuliam. Et interficiet eos sitis, et tradent civitatem suam, et nos et populus tuus ascendemus super vertices montium proximos et obsidebimus in eis in custodiam, ut non exeat de civitate vir unus."
,"14":"Et destilliscent in fame et siti ipsi et mulieres eorum et filii eorum et, priusquam veniat gladius super eos, prosternentur in plateis habitationis suae,"
,"15":"et retribues eis retributionem malam, eo quod secesserunt et non obviaverunt faciei tuae in pace '."
,"16":"Et placuerunt verba eorum coram Holoferne et coram omnibus famulis eius, et constituit facere, ut locuti sunt."
,"17":"Et promoverunt castra filii Moab et cum eis quinque milia filiorum Assyriae et castra constituerunt in convalle et praeoccupaverunt aquas et fontes aquarum filiorum Israel."
,"18":"Et ascenderunt filii Ammon et filii Esau et castra constituerunt in montana contra Dothain. Et miserunt ex eis ad austrum et orientem contra Egrebel, quae est iuxta Chus, quae est ad rivum Mochmur. Et reliqua militia Assyriorum castra constituerunt in campo et operuerunt omnem faciem terrae; et tabernacula et impedimenta eorum constituerunt in turba multa, et erant in multitudinem magnam valde."
,"19":"Et filii Israel clamaverunt ad Dominum Deum suum, quoniam minorabatur spiritus eorum, quoniam circumdederant eos omnes inimici eorum, et non poterant effugere de medio eorum."
,"20":"Et manserunt in circuitu eorum omnia castra Assyriae, pedites et quadrigae et equites eorum per dies triginta quattuor. Et deficiebant omnibus inhabitantibus Betuliam omnia vasa aquarum eorum,"
,"21":"et cisternae eorum evacuabantur, et non habebant quod biberent in satietatem aquam unam diem, quoniam in mensura dabant eis bibere."
,"22":"Et anxiati sunt infantes eorum, et mulieres et iuvenes deficiebant a siti et cadebant in plateis civitatis et in transitu portarum, et non erat virtus adhuc in eis."
,"23":"Et collegit se omnis populus ad Oziam et ad principes civitatis, iuvenes et mulieres et infantes, et clamaverunt voce magna et dixerunt coram omnibus senioribus:"
,"24":"' Iudicet Deus inter vos et nos, quoniam fecistis in nobis iniquitatem magnam non loquentes pacifica cum filiis Assyriae."
,"25":"Et nunc non est qui nos adiuvet, sed vendidit nos Deus in manus eorum, ut prosterneremur ante eos in siti et perditione magna."
,"26":"Et nunc convocate eos et tradite civitatem totam in captivitatem populo Holofernis et omni virtuti eius."
,"27":"Melius est enim nos fieri illis in rapinam; erimus enim eis in servos et ancillas, et vivet anima nostra, et non videbimus mortem infantium nostrorum in oculis nostris et mulieres et filios nostros deficientes in animabus suis."
,"28":"Contestamur vobis caelum et terram et Deum eorum et Dominum patrum nostrorum, qui ulciscitur in nos secundum peccata nostra et secundum peccata patrum nostrorum, ut non faciat secundum verba haec in hac die '."
,"29":"Et factus est fletus magnus in medio ecclesiae omnium unanimiter, et clamaverunt ad Dominum Deum voce magna."
,"30":"Et dixit ad eos Ozias: ' Aequo animo estote, fratres, et sustineamus adhuc dies quinque, in quibus convertet Dominus Deus noster misericordiam suam super nos; non enim derelinquet nos in consummationem."
,"31":"Si autem transierint isti quinque dies, et non fuerit super nos adiutorium, faciam secundum verba vestra '."
,"32":"Et dispersit plebem unumquemque in castra sua, et super muros et turres civitatis abierunt, et mulieres et filios in domus suas dimiserunt; et erant in magna humilitate valde."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Et erat in civitate commorans in diebus illis Iudith filia Merari filii Ox filii Ioseph filii Oziel filii Elchiae filii Ananiae filii Gedeon filii Rafain filii Achitob filii Eliab filii Nathanael filii Salamiel filii Surisaddai filii Simeon filii Israel."
,"2":"Et vir eius Manasses erat ex tribu eius et patria eius; et mortuus est in diebus messis hordiariae."
,"3":"Steterat enim super alligantes manipulos in campo, et aestus introivit in caput eius, et incidit in lectum et mortuus est in Betulia civitate sua. Et sepelierunt eum cum patribus suis in agro, qui est inter Dothain et Balamon."
,"4":"Et erat Iudith in domo sua vidua per annos tres et menses quattuor."
,"5":"Et fecit sibi tabernaculum super tectum domus suae et imposuit super lumbos suos cilicium, et erant super eam vestimenta viduitatis suae,"
,"6":"et ieiunabat per omnes dies viduitatis suae praeter pridie sabbatorum et sabbata et pridie neomeniarum et neomenias et dies festos et gaudimonia domus Israel."
,"7":"Et erat bona in aspectu et formosa facie valde et prudens in corde et bona in sensu et erat honesta valde, quia reliquerat ei Manasses vir eius filius Ioseph filii Achitob filii Melchis filii Eliab filii Nathanael filii Surisaddai filii Simeon filii Israel aurum et argentum et pueros et puellas et pecora et praedia, et manebat in eis;"
,"8":"et non erat qui inferret ei verbum malum, quia timebat Deum valde."
,"9":"Et audivit verba populi maligna super principem quoniam defecerunt animo super penuriam aquarum. Et audivit omnia verba Iudith, quae locutus est ad eos Ozias, quemadmodum iuraverat eis, ut post quinque dies traderet civitatem Assyriis."
,"10":"Et mittens abram suam, quae erat super omnia bona eius, vocavit Oziam et Chabrin et Charmin seniores civitatis suae."
,"11":"Et venerunt ad eam. Et dixit ad eos: ' Audite me, principes inhabitantium in Betulia, quoniam non est rectum verbum vestrum, quod locuti estis coram plebe in hac die et statuistis iuramentum istud, quod locuti estis inter Deum et vos, et dixistis tradituros vos civitatem inimicis nostris, si non in illis diebus converterit Dominus Deus noster audiutorium nobis."
,"12":"Et nunc qui estis vos, qui tentastis Deum in hodierno die et astitistis pro Deo in medio filiorum hominum?"
,"13":"Et nunc Dominum omnipotentem tentatis et nihil intellegetis usque in sempiternum."
,"14":"Quoniam altitudinem cordis hominis non invenietis et cogitatus sensus eius non comprehendetis, quomodo Deum, qui fecit omnia ista, inquiretis et sensum eius cognoscetis et cogitationem eius inspicietis? Minime, fratres, nolite exacerbare Dominum Deum nostrum,"
,"15":"quoniam, si noluerit in his quinque diebus adiuvare nos, ipse habet potestatem, in quibus diebus velit, protegere aut disperdere nos ante faciem inimicorum nostrorum."
,"16":"Vos autem nolite praepignorare voluntates Domini Dei nostri, quoniam non sicut homo Deus est, ut minis terreatur, aut sicut filius hominis, ut iudicetur."
,"17":"Propter quod sustinentes salvationem ab eo, invocemus ipsum in adiutorium nostrum, et exaudiet vocem nostram, si fuerit ipsi placitum."
,"18":"Quoniam non exsurrexit in progenie nostra, nec est in hodierna die neque tribus neque patria neque populus neque civitas ex nobis, qui adorent deos manufactos, sicut factum est in primis diebus,"
,"19":"pro quibus traditi sunt in gladium et in rapinam patres nostri et ceciderunt casum magnum ante conspectum inimicorum nostrorum."
,"20":"Nos autem alium Deum nescimus praeter eum, a quo speramus quia non despiciet nos nec auferet salutare suum a genere nostro."
,"21":"Quoniam in eo quod capti sumus, sic et capietur omnis Iudaea, et praedabuntur sancta nostra, et exquiret Deus coinquinationem eorum ex sanguine nostro"
,"22":"et mortem fratrum nostrorum et captivitatem terrae et desertionem hereditatis nostrae reducet in caput nostrum in gentibus, ubicumque servierimus. Et erimus in offendiculum et in improperium ante omnes, qui possidebunt nos,"
,"23":"quoniam non dirigetur servitus nostra in gratiam, sed in inhonorationem ponet eam Dominus Deus noster."
,"24":"Et nunc, fratres, ostendamus fratribus nostris quoniam ex nobis pendet anima eorum, et sancta et domus et altare incumbit in nobis."
,"25":"Praeter haec omnia gratias agamus Domino Deo nostro, qui tentat nos sicut et patres nostros."
,"26":"Memores estote quanta fecerit cum Abraham et Isaac, et quanta facta sint Iacob in Mesopotamia Syriae pascenti oves Laban fratris matris suae."
,"27":"Quia non sicut illos combussit in inquisitionem cordis illorum et in nos non ultus est, sed in monitionem flagellat Dominus appropinquantes sibi '."
,"28":"Et dixit ad eam Ozias: ' Omnia, quaecumque dixisti, in bono corde locuta es, et non est qui resistat verbis tuis,"
,"29":"quoniam non ex hodierna die sapientia tua manifesta est, sed ab initio dierum tuorum scit omnis populus sensum tuum, quoniam bona sunt figmenta cordis tui."
,"30":"Sed populus sitiit valde, et coegerunt nos sic facere, ut locuti sumus eis, et inducere super nos iuramentum, quod non praeteriemus."
,"31":"Et nunc ora pro nobis, et forte exaudiet te Deus noster, quoniam tu mulier sancta es, et dimittet Dominus pluviam in repletionem lacuum nostrorum, et non deficiemus iam '."
,"32":"Et dixit ad eos Iudith: ' Audite me, et faciam opus prudentiae, quod perveniet in generationes generationum filiis generis nostri."
,"33":"Vos enim stabitis ad portam hac nocte, et exeam ego cum abra mea, et in diebus, post quos dixistis civitatem tradituros vos inimicis nostris, visitabit Dominus Israel in manu mea, sicut ego fido."
,"34":"Vos autem non scrutabitis actum meum; non enim renuntiabo vobis, quousque consummentur, quae ego facio '."
,"35":"Et dixit Ozias et principes ad eam: ' Vade in pacem, et Dominus Deus sit ante te in ultionem inimicorum nostrorum '."
,"36":"Et revertentes descenderunt de tabernaculo eius et abierunt ad dispositiones suas."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Iudith autem procidit in faciem suam et imposuit cinerem super caput suum et scidit tunicam suam et denudavit, quod induerat, cilicium; et, in ipso quod oblatum erat in Ierusalem in domum Dei incensum vespere illo, clamavit Iudith voce magna ad Dominum et dixit:"
,"2":"' Domine, Deus patris mei Simeon, cui dedisti in manu gladium in ultionem alienigenarum, qui solverunt cingulum virginis in coinquinationem et denudaverunt femur in confusionem et coinquinaverunt matricem in improperium. Dixisti enim: 'Non sic erit!'; et fecerunt."
,"3":"Pro quibus dedisti principes eorum in occisionem et torum eorum, qui erubuit seductione eorum, seductum in sanguinem; et percussisti servos super potentes et potentes super thronos eorum."
,"4":"Et dedisti mulieres eorum in praedam et filias in captivitatem et omnia spolia in divisionem filiorum a te delectorum, qui zelaverunt zelum tuum et abominaverunt coinquinationem sanguinis sui et invocaverunt te in adiutorium. Deus, Deus meus, exaudi me viduam."
,"5":"Tu enim fecisti priora illorum et illa et, quae postea et quae nunc et quae futura sunt, cogitasti; et facta sunt, quae cogitasti."
,"6":"Et astiterunt, quae voluisti, et dixerunt: 'Ecce adsumus'. Omnes enim viae tuae paratae, et creatura tua in praescientia."
,"7":"Ecce enim Assyrii repleti sunt in virtute sua et exaltati sunt in equo et ascensore, gloriati sunt in brachio peditum, speraverunt in clipeis et lancea et arcu et fundibula et nescierunt quoniam tu es Dominus, qui conteris bella;"
,"8":"Dominus nomen est tibi. Tu allide illorum vires, aeterne Deus, comminue illorum plenitudinem in virtute tua et deduc fortitudinem eorum in ira tua. Voluerunt enim polluere sancta tua, coinquinare tabernaculum requiei nominis maiestatis tuae et deicere ferro cornu altaris tui."
,"9":"Respice in superbiam eorum, dimitte iram tuam in capita eorum; da in manu mea viduae, quam cogitavi, virtutem,"
,"10":"et percute servum ex labiis seductionis meae super principem et principem super servum eius; quassa elationem in manu viduae."
,"11":"Non enim in multitudine virtus tua, nec potentia tua neque datum tuum in fortibus, sed humilium es Deus et minorum adiutorium, infirmorum susceptor, abiectorum protector, desperatorum salvator."
,"12":"Etiam, etiam, Deus patris mei et Deus hereditatis Israel, dominator caelorum et terrae, creator aquarum, rex totius creaturae tuae, exaudi deprecationem meam"
,"13":"et da verbum meum et suasionem in vulnus et livorem eorum, qui adversum testamentum tuum et domum tuam sanctam et verticem Sion et domum retentionis filiorum tuorum cogitaverunt dura."
,"14":"Et fac super omnem gentem tuam et omnem tribum scientiam, ut sciant quoniam tu Deus es universae potestatis et virtutis, et non est alius defensor generis Israel praeter te '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Et factum est, ut cessavit cla mans ad Deum Israel et con summavit omnia verba ista,"
,"2":"surrexit de prostratione sua et vocavit abram suam et descendit in domum suam, in qua commorabatur in diebus sabbatorum et in diebus festis suis."
,"3":"Et abstulit cilicium, quod induerat, et exuit se vestimenta viduitatis suae et lavit corpus suum aqua et unxit se unguento spisso et pectinavit capillos capitis sui et imposuit mitram super caput suum et induit se vestimenta iucunditatis suae, quibus vestiebatur in diebus vitae viri sui Manasses."
,"4":"Et accepit soleas in pedes suos et imposuit periscelides et dextralia et anulos et inaures et omnem ornatum suum et composuit se nimis in seductionem oculorum virorum, quicumque viderent eam."
,"5":"Et porrexit abrae suae ascopam vini et vas olei et peram implevit alphitis et massa fici et panibus et caseo et plicavit omnia vasa sua et imposuit ei."
,"6":"Et abierunt ad portam civitatis Betuliae et invenerunt adstantem ad eam Oziam et seniores civitatis Chabrin et Charmin."
,"7":"Qui cum vidissent eam, et erat mutata facies eius, et vestem mutatam, mirati sunt valde et dixerunt ei:"
,"8":"' Deus patrum nostrorum det te in gratiam et consummet cogitationes tuas in gloriam filiorum Israel et in exaltationem Ierusalem '."
,"9":"Et procidens in faciem adoravit Deum et dixit ad eos: ' Praecipite aperiri portam civitatis, et exeam in consummationen verborum, quae locuti estis mecum '. Et constituerunt iuvenibus aperiri ei, sicut locuti sunt;"
,"10":"et fecerunt sic. Et exiit Iudith, ipsa et ancilla eius cum ea; et speculabantur eam viri civitatis, quoadusque descendit montem, usquedum transiit convallem, et iam non videbant eam."
,"11":"Et ibant in convallem in directum, et obviavit ei prima custodia Assyriorum."
,"12":"Et comprehenderunt eam et interrogaverunt eam: ' Quorum es et unde venis et quo vadis? '. Dixitque eis: ' Filia sum ego Hebraeorum et recedo a facie ipsorum, quoniam incipiunt tradi vobis in devorationem."
,"13":"Et ego venio ad faciem Holofernis principis militiae virtutis vestrae, ut renuntiem ei verba veritatis et ostendam ante faciem ipsius viam, per quam vadat et dominetur universae montanae, et non discumveniat ex viris eius caro una, nec spiritus vitae '."
,"14":"Et, ut audierunt viri verba eius et inspexerunt faciem eius - et erat in conspectu eorum mirabilis specie valde - dixerunt ad eam:"
,"15":"' Salvasti animam tuam in bonum festinans descendere ad faciem domini nostri. Et nunc accede ad tabernaculum eius; et ex nostris praemittent te, quousque tradant te in manibus eius."
,"16":"Si autem steteris in conspectu eius, noli timere corde tuo, sed renuntia illi secundum verba tua, et bene tibi faciet '."
,"17":"Et elegerunt ex seipsis viros centum et adiunxerunt ei et abrae eius et perduxerunt eas ad tabernaculum Holofernis."
,"18":"Et factus est concursus in omnibus castris; innotuit enim in tabernaculis adventus eius. Et venerunt et circumdederunt eam stantem extra tabernaculum Holofernis, quoadusque nuntiaverunt ei de ea."
,"19":"Et mirabantur ad speciem eius et percipiebant verba eius, quia erant bona valde, et laudabant filios Israel propter eam. Et dixit unusquisque ad proximum suum: ' Quis contemnet populum hunc, qui habet in se mulieres tales? Quoniam non est bonum derelinquere virum unum ex eis, qui relicti possint decipere totam terram '."
,"20":"Et exierunt omnes cubicularii Holofernis et omnes famuli eius et induxerunt eam in tabernaculum eius."
,"21":"Et erat Holofernes requiescens in lectu suo in conopeo, quod erat ex purpura et auro et smaragdo et lapidibus pretiosissimis contextum."
,"22":"Et nuntiaverunt ei de ea. Qui cum audisset, exiit in proscaenium; et lampades argenteae praecedentes eum multae valde. Et induxerunt eam ad eum."
,"23":"Cum autem venit contra faciem eius Iudith et famulorum eius, laudaverunt omnes speciem faciei eius; procidensque in faciem adoravit eum, et suscitaverunt eam servi eius."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Dixitque ad eam Holofernes: ' Aequo animo esto, mulier, et noli pavere corde tuo, quoniam ego non nocui viro cuicumque placuit servire Nabuchodonosor regi totius terrae."
,"2":"Et nunc plebs tua, quae habitat montanam, nisi sprevissent me, non elevassem lanceam meam super ipsos, sed sibi ipsi fecerunt haec."
,"3":"Et nunc dic mihi: Qua ex causa recessisti ab eis et venisti ad nos? Venisti enim ad salutem. Aequo animo esto, in hac nocte vives et deinceps."
,"4":"Non enim est qui tibi noceat, sed bene tibi faciam, sicut fit servis domini mei '."
,"5":"Et dixit ad eum Iudith: ' Sume verba ancillae tuae, et loquatur ancilla tua ante faciem tuam et non nuntiabo mendacium domino meo in hac nocte."
,"6":"Et, si secutus fueris verba ancillae tuae, consummabis omnia in manibus tuis, quae faciet Deus tecum, et non excidet dominus meus de adinventionibus suis quoadusque vivit."
,"7":"Vivit enim Nabuchodonosor rex totius terrae, et vivit virtus eius, qui misit te in correctionem omnium animarum, quoniam non solum homines per te servient ei, sed et bestiae agri et iumenta et volatilia caeli et per virtutem tuam vivent in Nabuchodonosor et omni domo eius."
,"8":"Audivimus enim sapientiam tuam et adinventiones animi tui, et nuntiatum est universae terrae quoniam tu solus bonus in universo regno et potens in prudentia et admirabilis in militia belli."
,"9":"Et nunc, domine meus, verbum, quod locutus est Achior in consilio tuo, audivimus verba eius quoniam susceperunt viri in Betulia, et nuntiavit eis omnia, quae locutus est apud te."
,"10":"Propter quod, dominator domine, non transeas verbum eius, sed conde illud in corde tuo, quia est verum. Non enim ultio cadit in genus nostrum, neque dominatur gladius super eos, nisi peccent in Deum suum."
,"11":"Et nunc, ne fiat dominus meus frustratus et sine actu, cadet mors super faciem eorum, et comprehendet eos peccatum magnum, in quo exacerbaverint Dominum suum; mox ut fecerint illud, erunt tibi in consummationem."
,"12":"Postquam enim defecerunt eis escae, et vacuefactae sunt ab eis aquae, voluerunt inicere manus iumentis suis et omnia, quae praecepit eis Deus legibus suis, ne manducarent, cogitaverunt consummare."
,"13":"Et primitias frumenti et decimas vini et olei, quae conservaverunt sanctificantes sacerdotibus, qui praesunt in Ierusalem ante faciem Dei nostri, iudicaverunt consumere, quae nec manibus licet tangere neminem ex populo."
,"14":"Et miserunt in Ierusalem - quia et, qui ibi inhabitant, fecerunt omnia haec - eos, qui transtulerint eis illationem a senioribus."
,"15":"Et erit ut, cum nuntiatum fuerit, et fecerint, dentur tibi in perditionem in illa die."
,"16":"Unde ego ancilla tua, cum cognovissem haec omnia, refugi a facie eorum, et misit me Deus facere tecum rem, in qua mirabitur tota terra, quicumque audierint ea."
,"17":"Quoniam ancilla tua Deum colit et servit nocte ac die Deo caeli. Et nunc manebo penes te, domine meus, et exiet ancilla tua per noctem ad vallem et orabo ad Deum, et indicabit mihi quando fecerint peccata eorum."
,"18":"Et veniens indicabo illud tibi, et exies in omni virtute tua, et non erit, qui resistat tibi ex eis."
,"19":"Et adducam te per mediam Iudaeam, usque veniam contra Ierusalem et ponam sedem tuam in medio eius, et adduces eos sicut oves, quibus non est pastor. Et non muttiet canis lingua sua contra te, quoniam haec dicta sunt mihi secundum praescientiam meam et renuntiata sunt mihi, et missa sum nuntiare tibi '."
,"20":"Et placuerunt verba eius coram Holoferne et coram omnibus famulis eius, et mirati sunt in specie et in sapientia eius et dixerunt:"
,"21":"' Non est talis mulier a summo usque ad summum terrae in specie faciei et sensu verborum '."
,"22":"Et dixit Holofernes ad eam: ' Bene fecit Deus, qui misit te ante filios plebis tuae, ut fiat in manibus nostris virtus, in eis autem, qui spreverunt dominum meum perditio."
,"23":"Et nunc tu es speciosa in aspectu et bona in verbis tuis. Quoniam, si feceris secundum quod locuta es, Deus tuus erit Deus meus, et tu in domo Nabuchodonosor regis sedebis et eris nominata per omnem terram '."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Et iussit introduci eam, ubi reponebatur argentum ipsius. Et praecepit sterni ei et dare ei ex obsoniis suis et ex vino suo bibere."
,"2":"Et dixit Iudith: ' Non manducabo ex eis, ne fiat mihi offensio, sed ex eis, quae allata sunt, praebebitur mihi '."
,"3":"Et dixit ad eam Holofernes: ' Si autem defecerint, quae tecum sunt, unde afferemus et dabimus tibi similia eis? Non enim est homo nobiscum ex genere tuo, qui habeat similia '."
,"4":"Dixitque ad eum Iudith: ' Vivit anima tua, domine mi, quoniam non impendet ancilla tua, quae sunt mecum, quousque faciat Dominus in manu mea, quae voluit '."
,"5":"Et induxerunt eam servi Holofernis in tabernaculum, et dormivit usque in mediam noctem. Surrexitque ante vigiliam matutinam"
,"6":"et misit ad Holofernen dicens: ' Praecipiat nunc dominus meus permitti ancillam suam exire ad orationem '."
,"7":"Et praecepit Holofernes custodibus suis, ne prohiberent eam. Et permansit in castris triduum. Et exiebat per noctem in vallem Betuliae et baptizabat se in fontem aquae."
,"8":"Et, ut ascendebat, orabat Dominum, Deum Israel, ut dirigeret viam eius in exaltationem po puli sui."
,"9":"Et introiens munda manebat in tabernaculo, usque dum afferretur esca eius in vesperum."
,"10":"Et factum est, in quarta die fecit Holofernes cenam famulis suis solis et neminem eorum, qui erant super officia, vocavit ad convivium."
,"11":"Et dixit Bagoae spadoni, qui erat praepositus super omnia ipsius: ' Vadens suade mulieri Hebraeae, quae est apud te, ut veniat ad nos et manducet et bibat nobiscum."
,"12":"Ecce enim turpe est in conspectu nostro, ut mulierem talem dimittamus non fabulantes ei, quoniam, si non eam attraxerimus, deridebit nos '."
,"13":"Et exiit Bagoas a facie Holofernis et introivit ad eam et dixit ei: ' Non pigeat puellam bonam hanc introeuntem ad dominum meum glorificari ante faciem eius et bibere nobiscum vinum in iucunditatem et fieri in hodierno die honorificam sicut unam filiarum magnatorum Assyriae, quae assistunt in domo Nabuchodonosor '."
,"14":"Dixitque ad eum Iudith: ' Et quae sum ego, ut contradicam domino meo? Quoniam omne, quod erit optimum in oculis eius, festinans faciam, et erit hoc mihi gaudium usque ad diem mortis meae '."
,"15":"Et surgens exornavit se vestimento suo et omni muliebri ornatu, et praecessit ancilla eius et stravit ei contra Holofernen in terra stragula, quae acceperat a Bagoa in cotidianum usum, ut manducaret discumbens super ea."
,"16":"Et introiens Iudith discubuit. Et obstupuit cor Holofernis in eam, et commota est anima eius, et erat concupiscens valde, ut concumberet cum ea; quaerebatque tempus seducendi eam ex die, quo viderat illam."
,"17":"Et dixit ad eam Holofernes: ' Bibe et esto nobiscum in iucunditatem '."
,"18":"Et dixit Iudith: ' Bibam, domine, quia magnificata est vita mea in me hodie prae omnibus diebus nativitatis meae '."
,"19":"Et accipiens manducavit et bibit coram illo ea, quae praeparaverat ipsi ancilla sua."
,"20":"Et iucundatus est Holofernes de ea et bibit multum vinum, quantum numquam bibit in uno die, ex quo natus est."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Et, ut vesper factus est, festinaverunt servi eius abire, et Bagoas conclusit tabernaculum a foris et dimisit adstantes a facie domini sui. Et abierunt omnes in cubilia sua; erant enim omnes fatigati, quoniam plurimus factus erat potus."
,"2":"Derelicta est autem sola Iudith in tabernaculo, et Holofernes prociderat in lectum suum; circumfusum enim erat ei vinum."
,"3":"Et dixit Iudith ancillae suae, ut staret extra cubiculum et observaret exitum eius sicut cotidie; exire enim se dixit ad orationem suam, et Bagoae locuta est secundum verba haec."
,"4":"Discesseruntque omnes a facie, et nemo relictus est in cubiculo eius, a minimo usque ad magnum. Et stans Iudith ad caput eius dixit: ' Domine, Domine, Deus omnium virtutum, respice in hac hora ad opera manuum mearum, ut exaltetur Ierusalem."
,"5":"Quia nunc est tempus, ut suscipias hereditatem tuam et facias cogitationem meam in quassationem inimicorum, qui insurrexerunt super nos '."
,"6":"Et accedens ad columnam lectus, quae erat ad caput Holofernis, deposuit pugionem illius ab illa."
,"7":"Et accedens ad lectum comprehendit comam capitis eius et dixit: ' Deus Israel, confirma me, Domine, Deus Israel, in hoc die '."
,"8":"Et percussit in cervicem eius bis in virtute sua et abstulit caput eius ab eo."
,"9":"Et volutavit corpus eius a toro et abstulit conopeum eius a columnis; et post pusillum exiit et tradidit abrae suae caput Holofernis,"
,"10":"et misit illud in peram escarum suarum. Et exierunt ambae simul secundum consuetudinem suam quasi ad orationem. Transeuntesque castra gyraverunt totam vallem illam et subascenderunt montem Betuliae et venerunt ad portas eius."
,"11":"Et dixit Iudith a longe eis, qui custodiebant in portis: ' Aperite, aperite portam! Nobiscum est Deus, Deus noster, ut faciat adhuc virtutem in Israel et potentiam adversus inimicos nostros, sicut et hodie fecit '."
,"12":"Et factum est, ut audierunt viri civitatis vocem eius, festinaverunt descendere ad portam civitatis suae et convocaverunt seniores civitatis."
,"13":"Et concurrerunt omnes a minimo usque ad magnum, quoniam mirum erat eis illam reversam esse. Et aperuerunt portam et receperunt eas et accendentes ignem ad lumen congyraverunt eam."
,"14":"Quae dixit ad eos voce magna: ' Laudate Dominum nostrum, laudate, quia non abstulit misericordiam suam a domo Israel, sed conteruit inimicos nostros per manum meam in hac nocte '."
,"15":"Et proferens caput de pera sua ostendit et dixit eis: ' Ecce caput Holofernis principis militiae virtutis Assyriorum, et ecce conopeum, in quo recumbebat in ebrietate sua. Et percussit eum Dominus in manu feminae."
,"16":"Et vivit Dominus, qui custodivit me in via mea, qua profecta sum, quoniam seduxit eum facies mea in perditionem eius, et non fecit peccatum mecum in coinquinationem et confusionem '."
,"17":"Et obstupuit omnis populus valde et inclinantes se adoraverunt Deum et dixerunt unanimes: ' Benedictus es, Deus noster, qui ad nihilum redegisti inimicos populi tui in hodierna die '."
,"18":"Et dixit ad eam Ozias: ' Benedicta tu es, filia, a Deo excelso prae omnibus mulieribus, quae sunt super terram. Et benedictus Dominus Deus noster, qui creavit caelum et terram, qui direxit te in vulnus capitis principis inimicorum nostrorum."
,"19":"Quoniam non discedet laus tua a corde hominum memorantium virtutis Dei usque in sempiternum."
,"20":"Et faciat tibi ea Deus in exaltationem aeternam, ut visitet te in bonis, pro eo quod non pepercisti animae tuae propter humilitatem generis nostri, sed prosilisti in ruinam nostram in directum ambulans in conspectu Dei nostri '. Et dixit omnis populus: ' Fiat, fiat! '."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Et dixit Iudith ad illos: ' Audite me, fratres, et acci pientes caput hoc suspendite illud super propugnaculum muri nostri."
,"2":"Et, cum aurora illuxerit, et exierit sol super terram, accipite unusquisque vasa bellica vestra et exietis omnis vir potens extra civitatem et dabitis initium adversus eos tamquam descendentes in campum ad primam custodiam filiorum Assyriae; et non descendetis."
,"3":"Et accipientes illi arma sua ibunt in castra sua et suscitabunt duces virtutis Assyriae concurrentque ad tabernaculum Holofernis et non invenient illum, et incidet in illos timor, et fugient a facie vestra."
,"4":"Et subsecuti vos et omnes, qui incolunt omnem finem Israel, prosternite illos in viis illorum."
,"5":"Ante autem quam faciatis ista, vocate mihi Achior Ammoniten, ut videns recognoscat eum, qui vituperavit domum Israel et ipsum quasi in mortem misit ad nos '."
,"6":"Et vocaverunt Achior de domo Oziae, qui, ut venit et vidit caput Holofernis in manu viri unius in ecclesia populi, cecidit in faciem, et resolutus est spiritus ipsius."
,"7":"Ut autem resuscitaverunt eum, procidit ad pedes Iudith et adoravit faciem ipsius et dixit: ' Benedicta tu in omni tabernaculo Iudae et in omni gente, quicumque audientes nomen tuum turbabuntur."
,"8":"Et nunc annuntia mihi, quaecumque fecisti in diebus istis '. Et rettulit illi Iudith in medio populi omnia, quaecumque fecerat, ex qua die exivit usque in diem, qua loquebatur illis."
,"9":"Ut autem desiit loqui, exsultavit omnis populus voce magna et dedit vocem iucunditatis in civitate sua."
,"10":"Videns autem Achior omnia, quaecumque fecit Deus Israel, credidit Deo valde et circumcidit carnem praeputii sui, et appositus est ad do mum Israel usque in diem hanc."
,"11":"Postquam autem aurora orta est, suspenderunt caput Holofernis super murum; et accepit omnis vir arma sua, et exierunt secundum cohortes ad ascensiones montis."
,"12":"Filii autem Assyriae, ut viderunt illos, miserunt ad praepositos suos, et illi venerunt ad duces et ad tribunos et ad omnes principes suos."
,"13":"Et venerunt ad tabernaculum Holofernis et dixerunt Bagoae, qui erat super omnia eius: ' Suscita dominum nostrum, quoniam ausi sunt Iudaei descendere ad nos in bellum, ut pereant usque ad finem '."
,"14":"Introivitque Bagoas et pulsavit cortinam; suspicabatur enim illum cum Iudith dormire."
,"15":"Cum autem nemo responderet, aperiens cortinam intravit in cubiculum et invenit illum in scabello proiectum, mortuum, nudum, et caput illius sublatum ab eo."
,"16":"Et exclamavit voce magna cum fletu et gemitu et clamore magno et scidit vestimenta sua."
,"17":"Et intravit in tabernaculum, ubi Iudith fuerat hospitata, et non invenit eam. Et exsilivit ad populum et clamavit:"
,"18":"'Inique gesserunt servi! Fecit confusionem una mulier Hebraeorum in domum regis Nabuchodonosor, quoniam ecce Holofernes in terra, et caput ipsius non est in illo! '."
,"19":"Ut autem audierunt verba haec, principes virtutis Assyriae sciderunt tunicas suas, et conturbata est anima eorum valde, et factus est clamor et ululatus magnus in medio castrorum."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Ut autem audierunt hi, qui in tabernaculis erant, obstu puerunt super quod factum erat."
,"2":"Et incidit in illos timor et tremor, et non erat homo, qui maneret contra faciem proximi sui adhuc, sed effusi simul fugiebant in omnem viam campi et montanae."
,"3":"Et, qui castra collocaverant in montana circa Betuliam, in fugam conversi sunt. Et tunc filii Israel, omnis vir bellator eorum, diffusi sunt in illos."
,"4":"Et misit Ozias Betomesthaim et Bemen et Chobam et Cholam in omnem finem Israel, qui renuntiarent de his rebus, quae consummata erant, et ut omnes in hostes effunderentur in interfectionem eorum."
,"5":"Ut autem audierunt filii Israel, omnes simul irruerunt in illos et concidebant illos usque Chobam. Similiter autem et, qui in Ierusalem erant, advenerunt ex omni montana; renuntiata enim sunt illis, quae facta sunt in castris inimicorum illorum. Et qui in Galaad et qui in Galilaea erant, persecuti sunt illos et percusserunt eos plaga magna, donec transirent Damascum et terminos eorum."
,"6":"Reliqui autem, qui inhabitabant Betuliam, irruerunt in castra Assyriae et exspoliaverunt eos et locupletati sunt valde."
,"7":"Filii autem Israel regressi a caede dominati sunt reliquiis; et vici et villae in montana et in campestri multa spolia possederunt; multitudo enim magna erat."
,"8":"Et venit Ioachim sacerdos magnus et seniores filiorum Israel, qui inhabitabant Ierusalem, ut viderent bona, quae fecit Dominus Israel, et ut viderent Iudith et loquerentur cum illa in pace."
,"9":"Et, ut exiit ad illos Iudith, benedixerunt simul eam omnes et dixerunt ad illam: ' Tu exaltatio Ierusalem, tu gloria magna Israel, tu laus magna generis nostri."
,"10":"Fecisti omnia haec in manu tua, fecisti bona cum Israel, et complacuit in illis Deus. Benedicta esto tu, mulier, apud Deum omnipotentem in aeternum tempus '. Et dixit omnis populus: ' Fiat, fiat! '."
,"11":"Et exspoliavit populus castra per dies triginta, et dederunt Iudith tabernaculum Holofernis et omne argentum et lectus et vasa et omnem apparatum illius. Et accipiens illa imposuit in mulas et iunxit currus suos et congessit illa in ipsis."
,"12":"Et concurrit omnis mulier Israel, ut videret eam, et benedixerunt eam et fecerunt ei chorum de se. Et accepit thyrsos in manibus suis et dedit mulieribus, quae secum erant."
,"13":"Et coronatae sunt oliva, ipsa et quae cum illa erant. Et antecessit omni populo in chorea dux omnium mulierum, et sequebatur omnis vir Israel armatus, cum coronis et hymnis in ore ipsorum."
,"14":"Et exordiebatur Iudith confessionem hanc in omni Israel, et acclamabat omnis populus laudationem hanc Domini."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Dixitque Iudith: ' Incipite Deo meo in tym panis, cantate Domino meo in cymbalis, modulamini illi psalmum novum, exaltate et invocate nomen ipsius."
,"2":"Tu es Deus conterens bella, qui ponis castra in medio populi tui, ut eripias me de manu persequentium me."
,"3":"Venit Assur a montibus, a borra, venit in milibus virtutum suarum, quorum multitudo obturavit torrentes, et equitatus ipsorum texit colles."
,"4":"Et dixit incensurum se fines meos,et iuvenes meos occisurum gladio,et mammantes meos daturum ad solum,et infantes meos daturum in partitionem,et virgines spoliaturum."
,"5":"Dominus omnipotens sprevit illos et confudit illos in manu feminae!"
,"6":"Non enim cecidit potens eorum a iuvenibus, nec filii Titanum percusserunt illum, nec alti gigantes superposuerunt se illi, sed Iudith filia Merari,in specie faciei suae dissolvit illum. "
,"7":"Dispoliavit enim se stola viduitatis suae,in exaltationem dolentium in Israel. Unxit faciem suam unguento"
,"8":"et colligavit capillos suos in mitra,et accepit stolam lineam in seductionem eius."
,"9":"Sandalum eius rapuit oculum ipsius, et species eius captivam fecit animam illius, et transiit gladius cervicem eius."
,"10":"Horruerunt Persae audaciam eius, et Medi turbati sunt constantia ipsius."
,"11":"Tunc ululaverunt humiles mei, et exclamaverunt aegrotantes et territi sunt, in altum extulerunt vocem suam,et conversi sunt."
,"12":"Filii puellarum compunxerunt illos,et tamquam pueros ultroneos vulnerabant; perierunt a praelio Domini mei."
,"13":"Cantabo Deo meo hymnum novum: Domine, magnus es tu et clarus, mirabilis in virtute et insuperabilis. "
,"14":"Tibi serviat omnis creatura tua, quoniam dixisti, et facta sunt, misisti spiritum tuum, et aedificata sunt, et non est qui resistat voci tuae."
,"15":"Montes enim a fundamentis agitabuntur cum aquis, petrae autem a facie tua tamquam cera liquescent. Illis autem, qui timent te, propitius adhuc eris."
,"16":"Quoniam pusillum omne sacrum ad odorem suavitatis, et minimus omnis adeps in holocaustum tibi. Qui autem timet Dominum, magnus apud eum semper."
,"17":"Vae gentibus assurgentibus generi meo!,Dominus omnipotens vindicabit illos, in die iudicii visitabit eos, ut det ignem et vermes in carnes eorum, et comburentur, ut sentiant usque in aeternum '."
,"18":"Ut autem venerunt in Ierusalem, adoraverunt Deum; et, postquam mundatus est populus, rettulerunt holocaustum Domino et voluntaria sua et munera."
,"19":"Et attulit Iudith omnia vasa Holofernis, quaecumque dederat ei populus, et conopeum, quod sustulerat de cubiculo ipsius, in consecrationem Domino dedit."
,"20":"Et populus laetabatur in Ierusalem contra faciem sanctorum per menses tres, et Iudith cum illis mansit."
,"21":"Post illos autem dies rediit unusquisque in hereditatem suam, et Iudith abiit in Betuliam et demorata est in possessione sua. Et facta est secundum tempus suum clara in omni terra,"
,"22":"et multi concupierunt eam, et non cognovit vir illam omnibus diebus vitae eius, ex qua die mortuus est Manasses maritus illius et appositus est ad populum suum."
,"23":"Et procedens magna facta est valde et senuit in domo mariti sui Manasses annos centum quinque; et dimisit abram suam liberam. Et mortua est in Betulia, et sepelierunt eam in spelunca."
,"24":"Et planxit eam omnis Israel diebus septem. Divisitque bona sua, priusquam moreretur, omnibus proximis viri sui Manasses et proximis ex genere suo."
,"25":"Et non fuit adhuc, qui in timorem mitteret filios Israel in diebus Iudith et post mortem eius diebus multis."
}`)

}
func LA_NVBSE_LoadVHNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Verba Nehemiae filii Hacha liae. Et factum est in mense Ca sleu, anno vicesimo, et ego eram in castro Susan."
,"2":"Et venit Hanani unus de fratribus meis, ipse et viri ex Iuda; et interrogavi eos de Iudaeis, qui salvati erant et supererant de captivitate, et de Ierusalem."
,"3":"Et dixerunt mihi: ' Superstites, qui supererant de captivitate ibi in provincia, in afflictione magna sunt et in opprobrio; et murus Ierusalem dissipatus est, et portae eius combustae sunt igne '."
,"4":"Cumque audissem verba huiuscemodi, sedi et flevi et luxi diebus multis; ieiunabam et orabam ante faciem Dei caeli."
,"5":"Et dixi: ' Quaeso, Domine, Deus caeli, Deus fortis, magne atque terribilis, qui custodis pactum et misericordiam cum his, qui te diligunt et custodiunt mandata tua;"
,"6":"fiat auris tua auscultans, et oculi tui aperti, ut audias orationem servi tui, quam ego oro coram te hodie, die et nocte pro filiis Israel servis tuis, et confiteor pro peccatis filiorum Israel, quibus peccaverunt tibi. Ego quoque et domus patris mei peccavimus,"
,"7":"delinquentes deliquimus contra te et non custodivimus praecepta et mandata et iudicia, quae praecepisti Moysi famulo tuo."
,"8":"Memento verbi, quod mandasti Moysi servo tuo dicens: 'Cum transgressi fueritis, ego dispergam vos in populos;"
,"9":"si autem revertamini ad me et custodiatis praecepta mea et faciatis ea, etiamsi abducti fueritis in extrema caeli, inde congregabo vos et reducam in locum quem elegi, ut habitaret nomen meum ibi'."
,"10":"Ipsi enim sunt servi tui et populus tuus, quos redemisti in fortitudine tua magna et in manu tua valida."
,"11":"Obsecro, Domine, sit auris tua attendens ad orationem servi tui et ad orationem servorum tuorum, qui volunt timere nomen tuum; et fac servum tuum prosperari hodie et da ei gratiam ante virum hunc '. Ego enim eram pincerna regis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Factum est autem in mense Nisan, anno vicesimo Artaxerxis regis, dum biberet, levavi vinum et dedi regi; non enim eram ingratus coram eo."
,"2":"Dixitque mihi rex: ' Quare vultus tuus tristis est, cum te aegrotum non videam? Nihil est aliud nisi tristitia cordis '. Et timui valde"
,"3":"et dixi regi: ' Rex, in aeternum vive! Quare non maereat vultus meus, quia civitas sepulcrorum patrum meorum deserta est, et portae eius combustae sunt igne? '."
,"4":"Et ait mihi rex: ' Pro qua re postulas? '. Et oravi Deum caeli"
,"5":"et dixi ad regem: ' Si videtur regi bonum, et si placet servus tuus ante faciem tuam, ut mittas me in Iudaeam ad civitatem sepulcrorum patrum meorum, et aedificabo eam '."
,"6":"Dixitque mihi rex, et regina sedebat iuxta eum: ' Usque ad quod tempus erit iter tuum, et quando reverteris? '. Et placuit regi mittere me; et constitui ei tempus."
,"7":"Et dixi regi: ' Si regi videtur bonum, epistulae dentur mihi ad duces regionis trans flumen, ut me transire permittant, donec veniam in Iudaeam;"
,"8":"et epistulam ad Asaph custodem saltus regis, ut det mihi ligna, ut contignare possim portas turris domus et muri civitatis et domus, in qua habitabo '. Et dedit mihi rex, quia manus Dei mei bona super me."
,"9":"Et veni ad duces regionis trans flumen dedique eis epistulas regis. Miserat autem rex mecum principes militum et equites."
,"10":"Et audierunt Sanaballat Horonites et Thobias servus Ammanites et contristati sunt afflictione magna, quod venisset homo, qui quaereret prosperitatem filiorum Israel."
,"11":"Et veni Ierusalem et eram ibi tribus diebus."
,"12":"Et surrexi nocte ego, et viri pauci mecum, et non indicavi cuiquam quid Deus meus dedisset in corde meo, ut facerem in Ierusalem; et iumentum non erat mecum, nisi animal cui sedebam."
,"13":"Et egressus sum per portam Vallis nocte et ad fontem Draconis et portam Sterquilinii et considerabam murum Ierusalem dissipatum et portas eius consumptas igne."
,"14":"Et transivi ad portam Fontis et ad piscinam Regis, et non erat locus iumento cui sedebam, ut transiret."
,"15":"Et ascendi per torrentem nocte et considerabam murum; et iterum veni ad portam Vallis et reversus sum."
,"16":"Magistratus autem nesciebant quo abissem aut quid ego facerem, sed et Iudaeis et sacerdotibus et optimatibus et magistratibus et reliquis, qui faciebant opus, usque ad id loci nihil indicaveram."
,"17":"Et dixi eis: ' Vos nostis afflictionem, in qua sumus, quia Ierusalem deserta est, et portae eius consumptae sunt igne; venite et aedificemus murum Ierusalem et non simus ultra opprobrium '."
,"18":"Et indicavi eis quod manus Dei mei bona esset super me et verba regis, quae locutus esset mihi, et dixerunt: ' Surgamus et aedificemus! '. Et confortatae sunt manus eorum in bonum."
,"19":"Audierunt autem Sanaballat Horonites et Thobias servus Ammanites et Gosem Arabs et subsannaverunt nos et despexerunt dixeruntque: ' Quae est haec res, quam facitis? Numquid contra regem vos rebellatis? '."
,"20":"Et dedi eis responsum dicens: ' Deus caeli ipse nos facit prosperari, et nos servi eius sumus; surgamus et aedificemus. Vobis autem non est pars et ius et memoria in Ierusalem '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et surrexit Eliasib sacerdos magnus et fratres eius sacerdotes et aedificaverunt portam Gregis; contignaverunt eam et statuerunt valvas eius et usque ad turrim Meah et turrim Hananeel."
,"2":"Et iuxta eos aedificaverunt viri Iericho, et iuxta eos aedificavit Zacchur filius Imri."
,"3":"Portam autem Piscium aedificaverunt filii Asnaa; ipsi contignaverunt eam et statuerunt valvas eius et seras et vectes."
,"4":"Et iuxta eos restauravit Meremoth filius Uriae filii Accos, et iuxta eum restauravit Mosollam filius Barachiae filii Mesezabel, et iuxta eum restauravit Sadoc filius Baana,"
,"5":"et iuxta eum restauraverunt Thecueni; optimates autem eorum non supposuerunt colla sua in opere Domini sui."
,"6":"Et portam Veterem restauraverunt Ioiada filius Phasea et Mosollam filius Besodia; ipsi contignaverunt eam et statuerunt valvas eius et seras et vectes."
,"7":"Et iuxta eos restauraverunt Meltias Gabaonites et Iadon Meronathites, viri de Gabaon et Maspha, qui erant ad solium ducis, qui erat in regione trans flumen;"
,"8":"et iuxta eos restauravit Oziel filius Araia de aurificibus, et iuxta eum restauravit Hananias de pigmentariis et firmaverunt Ierusalem usque ad murum latiorem."
,"9":"Et iuxta eum restauravit Raphaia filius Hur, princeps dimidiae partis vici Ierusalem;"
,"10":"et iuxta eum restauravit Iedaia filius Haromaph contra domum suam, et iuxta eum restauravit Hattus filius Hasabneia."
,"11":"Alteram partem restauravit Melchias filius Harim et Hassub filius Phahathmoab usque ad turrim Furnorum."
,"12":"Et iuxta eos restauravit Sellum filius Alohes, princeps mediae partis vici Ierusalem, ipse et filiae eius."
,"13":"Portam Vallis restauravit Hanun et habitatores Zanoa; ipsi aedificaverunt eam et statuerunt valvas eius et seras et vectes et mille cubitos in muro usque ad portam Sterquilinii."
,"14":"Et portam Sterquilinii restauravit Melchias filius Rechab, princeps vici Bethcharem; ipse aedificavit eam et statuit valvas eius et seras et vectes."
,"15":"Et portam Fontis restauravit Sellum filius Cholhoza princeps pagi Maspha; ipse aedificavit eam et texit et statuit valvas eius et seras et vectes et murum piscinae Siloae iuxta hortum regis et usque ad gradus, qui descendunt de civitate David."
,"16":"Post eum restauravit Nehemias filius Azboc princeps dimidiae partis vici Bethsur usque contra sepulcra David et usque ad piscinam, quae repleta est, et usque ad domum Fortium."
,"17":"Post eum restauraverunt Levitae, Rehum filius Bani; iuxta eum restauravit Hasabias princeps dimidiae partis vici Ceilae pro vico suo;"
,"18":"post eum aedificaverunt fratres eorum Bavai filius Henadad princeps dimidiae partis vici Ceilae."
,"19":"Et restauravit iuxta eum Ezer filius Iesua princeps Maspha mensuram alteram contra ascensum armentarii in angulo."
,"20":"Post eum restauravit Baruch filius Zachai mensuram alteram ab angulo usque ad portam domus Eliasib sacerdotis magni."
,"21":"Post eum restauravit Meremoth filius Uriae filii Aecos mensuram secundam a porta domus Eliasib usque ad extremitatem domus Eliasib."
,"22":"Et post eum restauraverunt sacerdotes viri de campestribus."
,"23":"Post eos restauravit Beniamin et Hassub contra domum suam; post eos restauravit Azarias filius Maasiae filii Ananiae iuxta domum suam."
,"24":"Post eum restauravit Bennui filius Henadad mensuram alteram a domo Azariae usque ad angulum et flexuram."
,"25":"Phalel filius Ozi contra angulum turris, quae eminet de domo regis excelsa in atrio carceris; post eum Phadaia filius Pharos restauravit"
,"26":"usque contra portam Aquarum ad orientem et turrim, quae prominebat."
,"27":"Post eum restauraverunt Thecueni mensuram alteram a regione contra magnam turrim eminentem usque ad murum templi."
,"28":"Sursum autem a porta Equorum restauraverunt sacerdotes, unusquisque contra domum suam."
,"29":"Post eos restauravit Sadoc filius Emmer contra domum suam; et post eum restauravit Semeia filius Secheniae custos portae orientalis."
,"30":"Post eum restauravit Hanania filius Selemiae et Hanun filius Seleph sextus mensuram alteram. Post eum restauravit Mosollam filius Barachiae contra cellam suam."
,"31":"Post eum restauravit Melchias de aurificibus usque ad domum oblatorum et mercatorum, contra portam Iudicialem, et usque ad cenaculum anguli;"
,"32":"et inter cenaculum anguli et portam Gregis restauraverunt aurifices et negotiatores."
,"33":"Factum est autem, cum audisset Sanaballat quod aedificaremus murum, iratus est et indignatus est nimis et subsannavit Iudaeos"
,"34":"et dixit coram fratribus suis et optimatibus Samariae: ' Quid Iudaei faciunt imbecilles? Num hoc conceditur eis? Num, quia sacrificant, complebunt in una die? Numquid vivificare poterunt lapides de acervis pulveris, qui combusti sunt? '."
,"35":"Sed et Thobias Ammanites, qui erat ad latus eius, ait: ' Sine aedificare; si ascenderit vulpes, diruet murum eorum lapideum '."
,"36":"Audi, Deus noster, quia facti sumus irrisio! Converte contumeliam eorum super caput eorum et da eos in irrisionem in terra captivitatis!"
,"37":"Ne operias iniquitatem eorum, et peccatum eorum coram facie tua non deleatur, quia offenderunt te coram aedificantibus."
,"38":"Itaque aedificavimus murum, et compositus est totus murus usque ad partem dimidiam, et populus dabat cor suum, ut operaretur."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Factum est autem cum audisset Sanaballat et Thobias et Arabes et Ammanitae et Azotii quod prosperaretur restauratio muri Ierusalem et quod coepissent interrupta concludi, irati sunt nimis;"
,"2":"et conspiraverunt omnes pariter, ut venirent et pugnarent contra Ierusalem et facerent confusionem."
,"3":"Et oravimus Deum nostrum et posuimus custodiam die ac nocte contra eos."
,"4":"Dixit autem Iudas: ' Debilitata est fortitudo portantis, et humus nimia est; et nos non poterimus aedificare murum '."
,"5":"Et dixerunt hostes nostri: ' Nesciant et ignorent, donec veniamus in medium eorum et interficiamus eos et cessare faciamus opus '."
,"6":"Factum est autem venientibus Iudaeis, qui habitabant iuxta eos, et dicentibus nobis per decem vices ex omnibus locis, quibus venerant ad nos,"
,"7":"statuimus nos in inferioribus post murum in locis apertis, et ordinavi populum secundum familias cum gladiis suis et lanceis suis et arcubus suis."
,"8":"Et perspexi atque surrexi, et aio ad optimates et magistratus et ad reliquam partem vulgi: ' Nolite timere a facie eorum; Domini magni et terribilis mementote et pugnate pro fratribus vestris, filiis vestris et filiabus vestris et uxoribus vestris et domibus vestris '."
,"9":"Factum est autem cum audissent inimici nostri nuntiatum esse nobis, dissipavit Deus consilium eorum, et reversi sumus omnes ad murum, unusquisque ad opus suum."
,"10":"Et factum est a die illa, media pars iuvenum meorum faciebat opus, et media tenebat lanceas et scuta et arcus et loricas, et principes post omnem domum Iudae."
,"11":"Aedificantium in muro et portantium onera et imponentium, una manu sua faciebat opus et altera tenebat gladium;"
,"12":"aedificantium enim unusquisque gladio erat accinctus renes, et sic aedificabant; et, qui clangebat bucina, iuxta me."
,"13":"Et dixi ad optimates et ad magistratus et ad reliquam partem vulgi: ' Opus grande est et latum, et nos separati sumus in muro procul alter ab altero;"
,"14":"in loco quocumque audieritis clangorem tubae, illuc concurrite ad nos. Deus noster pugnabit pro nobis '."
,"15":"Et sic nos fecimus opus, et media pars nostrum tenebat lanceas ab ascensu aurorae, donec egrediantur astra."
,"16":"In tempore quoque illo dixi populo: ' Unusquisque cum puero suo pernoctet in medio Ierusalem; et erit nobis custodia per noctem, et opus per diem '."
,"17":"Ego autem et fratres mei et pueri mei et custodes, qui erant post me, non deponebamus vestimenta nostra; unusquisque tenebat gladium in dextera sua."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et factus est clamor populi et uxorum eius magnus adversus fratres suos Iudaeos."
,"2":"Et erant qui dicerent: ' Filios nostros et filias nostras pignoravimus, ut acciperemus frumentum et comederemus et viveremus! '."
,"3":"Et erant qui dicerent: ' Agros nostros et vineas et domos nostras opposuimus, ut acciperemus frumentum in fame! '."
,"4":"Et alii dicebant: ' Mutuo sumpsimus pecunias in tributa regis pro agris nostris et vineis nostris."
,"5":"Et nunc sicut caro fratrum nostrorum sic caro nostra est, et sicut filii eorum ita et filii nostri; ecce nos subiugamus filios nostros et filias nostras in servitutem, et de filiabus nostris quaedam iam in servitute subiugatae sunt, nec habemus unde possint redimi, quia agros nostros et vineas nostras alii possident '."
,"6":"Et iratus sum nimis, cum audissem clamorem eorum secundum verba haec."
,"7":"Cogitavique in corde meo et increpavi optimates et magistratus et dixi eis: ' Usuras singuli a fratribus vestris exigitis! '. Et congregavi adversum eos contionem magnam"
,"8":"et dixi eis: ' Nos, ut scitis, redemimus fratres nostros Iudaeos, qui venditi fuerant gentibus, secundum possibilitatem nostram; quin potius et vos vendetis fratres vestros, ut vendentur nobis? '. Et siluerunt nec invenerunt quid responderent."
,"9":"Dixique ad eos: ' Non est bona res, quam facitis. Quare non in timore Dei nostri ambulatis, ne exprobretur nobis a gentibus inimicis nostris?"
,"10":"Et ego et fratres mei et pueri mei commodavimus plurimis pecuniam et frumentum; non repetamus usuras istas."
,"11":"Reddite eis hodie agros suos et vineas suas et oliveta sua et domos suas et centesimam pecuniae frumenti vini et olei, quam exigere soletis ab eis '."
,"12":"Et dixerunt: ' Reddemus et ab eis nihil quaeremus; sicque faciemus, ut loqueris '. Et vocavi sacerdotes et feci eos iurare, ut facerent, sicut dictum erat."
,"13":"Insuper excussi sinum meum et dixi: ' Sic excutiat Deus omnem virum, qui non compleverit verbum istud, de domo sua et de laboribus suis; sic excutiatur et vacuus fiat! '. Et dixit universa multitudo: ' Amen! '. Et laudaverunt Deum. Fecit ergo populus, sicut erat dictum."
,"14":"A die autem illa, qua praeceperat rex mihi, ut essem dux in terra Iudae, ab anno vicesimo usque ad annum tricesimum secundum Artaxerxis regis, per annos duodecim ego et fratres mei annonas, quae ducibus debebantur, non comedimus."
,"15":"Duces autem priores, qui fuerant ante me, gravaverunt populum et acceperunt ab eis cotidie pro pane siclos argenti quadraginta; sed et ministri eorum depresserunt populum. Ego autem non feci ita propter timorem Dei,"
,"16":"quin potius in opere muri restauravi et agrum non emi; et omnes pueri mei congregati ad opus erant."
,"17":"Iudaei quoque et magistratus, centum quinquaginta viri, et qui veniebant ad nos de gentibus, quae in circuitu nostro sunt, in mensa mea erant."
,"18":"Parabatur autem mihi per dies singulos bos unus, arietes sex electi, exceptis volatilibus; et inter dies decem vina diversa multa. Insuper et annonas ducatus mei non quaesivi; gravis enim erat servitus populi huius."
,"19":"Memento mei, Deus meus, in bonum, secundum omnia, quae feci populo huic."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Factum est autem cum audisset Sanaballat et Thobias et Gosem Arabs et ceteri inimici nostri, quod aedificassem ego murum, et non esset in ipso residua interruptio - usque ad tempus autem illud valvas non posueram in portis -"
,"2":"miserunt Sanaballat et Gosem ad me dicentes: ' Veni, et conveniamus in Cephirim in campo Ono '. Ipsi autem cogitabant, ut facerent mihi malum."
,"3":"Misi ergo ad eos nuntios dicens: ' Opus grande ego facio et non possum descendere; cur cessare oportet opus, si desistero et descendero ad vos? '."
,"4":"Miserunt autem ad me secundum verbum hoc per quattuor vices, et respondi eis iuxta sermonem priorem."
,"5":"Et misit ad me Sanaballat iuxta verbum prius quinta vice puerum suum, et epistulam non obsignatam habebat in manu sua, in qua erat scriptum:"
,"6":"' In gentibus auditum est, et Gosem dixit quod tu et Iudaei cogitetis rebellare, et propterea aedifices murum et levare te velis super eos regem; iuxta hanc vocem"
,"7":"et prophetas posueris, qui praedicent de te in Ierusalem dicentes: 'Rex in Iudaea est!'. Nunc autem auditurus est rex verba haec; idcirco nunc veni, ut ineamus consilium pariter '."
,"8":"Et misi ad eum dicens: ' Non est factum secundum verba haec, quae tu loqueris; de corde enim tuo tu componis haec '."
,"9":"Omnes enim hi terrebant nos cogitantes: ' Fatigabuntur manus eorum ab opere, et non complebitur '. Quam ob causam magis confortavi manus meas."
,"10":"Et ingressus sum domum Semeiae filii Dalaiae filii Meetabel, ubi erat detentus. Qui ait: ' Tractemus nobiscum in domo Dei, in medio templi, et claudamus portas aedis, quia venturi sunt, ut interficiant te; utique nocte venturi sunt ad occidendum te'."
,"11":"Et dixi: ' Num quisquam similis mei fugit? Et quis ut ego ingredietur templum et vivet? Non ingrediar '."
,"12":"Et intellexi quod Deus non misisset eum, sed quasi vaticinans locutus esset ad me, quia Thobias et Sanaballat conduxerant eum."
,"13":"Acceperat enim pretium, ut territus sic agerem et peccarem, et haberent malum, quod exprobrarent mihi."
,"14":"Memento, Deus meus, Thobiae et Sanaballat iuxta opera eorum talia, sed et Noadiae prophetae et ceterorum prophetarum, qui terrebant me!"
,"15":"Completus est autem murus vicesimo quinto die mensis Elul, quinquaginta duobus diebus."
,"16":"Factum est ergo, cum audissent omnes inimici nostri, et vidissent universae gentes, quae erant in circuitu nostro, ut conciderent intra semetipsos et scirent quod a Deo factum esset opus hoc."
,"17":"Sed et in diebus illis, multae optimatum Iudaeorum epistulae mittebantur ad Thobiam, et a Thobia veniebant ad eos."
,"18":"Multi enim in Iudaea coniurationem fecerunt cum eo, quia gener erat Secheniae filii Area, et Iohanan filius eius acceperat filiam Mosollam filii Barachiae."
,"19":"Sed et laudabant eum coram me et verba mea nuntiabant ei; et Thobias mittebat epistulas, ut terreret me."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Postquam autem aedificatus est murus, et posui valvas et recen sui ianitores et cantores et Levitas,"
,"2":"praeposui Hanani fratrem meum et Hananiam principem arcis supra Ierusalem - ipse enim quasi vir verax et timens Deum plus ceteris videbatur -"
,"3":"et dixi eis: ' Non aperiantur portae Ierusalem usque ad calorem solis. Dum adhuc calor permanet, claudantur portae et oppilentur; et ponant custodes de habitatoribus Ierusalem, singulos per vices suas et unumquemque contra domum suam '."
,"4":"Civitas autem erat lata nimis et grandis, et populus parvus in medio eius, et non erant domus aedificatae."
,"5":"Deus autem meus dedit in corde meo, et congregavi optimates et magistratus et vulgus, ut recenserem eos; et inveni librum census eorum, qui ascenderant primum, et inventum est scriptum in eo:"
,"6":"Isti filii provinciae, qui ascenderunt de captivitate migrantium, quos transtulerat Nabuchodonosor rex Babylonis, et reversi sunt in Ierusalem et in Iudaeam unusquisque in civitatem suam."
,"7":"Qui venerunt cum Zorobabel, Iesua, Nehemias, Azarias, Raamias, Nahamani, Mardochaeus, Belsan, Mespharath, Beguai, Nahum, Baana. Numerus virorum populi Israel: "
,"8":"filii Pharos duo milia centum septuaginta duo;"
,"9":"filii Saphatia trecenti septuaginta duo;"
,"10":"filii Area sescenti quinquaginta duo;"
,"11":"filii Phahathmoab, hi sunt filii Iesua et Ioab, duo milia octingenti decem et octo;"
,"12":"filii Elam mille ducenti quinquaginta quattuor;"
,"13":"filii Zethua octingenti quadraginta quinque;"
,"14":"filii Zachai septingenti sexaginta;"
,"15":"filii Bennui sescenti quadraginta octo;"
,"16":"filii Bebai sescenti viginti octo;"
,"17":"filii Azgad duo milia trecenti viginti duo;"
,"18":"filii Adonicam sescenti sexaginta septem;"
,"19":"filii Beguai duo milia sexaginta septem;"
,"20":"filii Adin sescenti quinquaginta quinque;"
,"21":"filii Ater, qui erant ex Ezechia, nonaginta octo;"
,"22":"filii Hasum trecenti viginti octo;"
,"23":"filii Besai trecenti viginti quattuor;"
,"24":"filii Hareph centum duodecim;"
,"25":"filii Gabaon nonaginta quinque;"
,"26":"filii Bethlehem et Netopha centum octoginta octo;"
,"27":"viri Anathoth centum viginti octo;"
,"28":"viri Bethazmaveth quadraginta duo;"
,"29":"viri Cariathiarim, Cephira et Beroth septingenti quadraginta tres;"
,"30":"viri Rama et Gabaa sescenti viginti unus;"
,"31":"viri Machmas centum viginti duo;"
,"32":"viri Bethel et Hai centum viginti tres;"
,"33":"viri Nabo alterius quinquaginta duo;"
,"34":"viri Elam alterius mille ducenti quinquaginta quattuor;"
,"35":"filii Harim trecenti viginti;"
,"36":"filii Iericho trecenti quadraginta quinque;"
,"37":"filii Lod, Hadid et Ono septingenti viginti unus;"
,"38":"filii Senaa tria milia nongenti triginta."
,"39":"Sacerdotes: filii Iedaia de domo Iesua nongenti septuaginta tres;"
,"40":"filii Emmer mille quinquaginta duo;"
,"41":"filii Phassur mille ducenti quadraginta septem;"
,"42":"filii Harim mille decem et septem."
,"43":"Levitae: filii Iesua, hi sunt filii Cadmihel, Bennui et Odoviae, septuaginta quattuor."
,"44":"Cantores: filii Asaph centum quadraginta octo."
,"45":"Ianitores: filii Sellum, filii Ater, filii Telmon, filii Accub, filii Hatita, filii Sobai, centum triginta octo."
,"46":"Oblati: filii Siha, filii Hasupha, filii Tabbaoth,"
,"47":"filii Ceros, filii Siaa, filii Phadon,"
,"48":"filii Lebana, filii Hagaba, filii Selmai,"
,"49":"filii Hanan, filii Giddel, filii Gaher,"
,"50":"filii Raaia, filii Rasin, filii Necoda,"
,"51":"filii Gazam, filii Oza, filii Phasea,"
,"52":"filii Besai, filii Meunitarum, filii Nephusorum,"
,"53":"filii Bacbuc, filii Hacupha, filii Harhur,"
,"54":"filii Basluth, filii Mahida, filii Harsa,"
,"55":"filii Bercos, filii Sisara, filii Thema,"
,"56":"filii Nasia, filii Hatipha."
,"57":"Filii servorum Salomonis: filii Sotai, filii Sophereth, filii Pheruda,"
,"58":"filii Iaala, filii Darcon, filii Giddel,"
,"59":"filii Saphatia, filii Hatil, filii Phochereth Hassebaim, filii Amon."
,"60":"Omnes oblati et filii servorum Salomonis trecenti nonaginta duo."
,"61":"Hi sunt autem, qui ascenderunt de Thelmela, Thelharsa, Cherub, Addon et Emmer et non potuerunt indicare domum patrum suorum et semen suum, utrum ex Israel essent:"
,"62":"filii Dalaia, filii Thobia, filii Necoda sescenti quadraginta duo."
,"63":"Et de sacerdotibus: filii Hobia, filii Accos, filii Berzellai, qui accepit de filiabus Berzellai Galaaditis uxorem et vocatus est nomine eorum."
,"64":"Hi quaesierunt tabulas genealogiae suae et non invenerunt; et eiecti sunt de sacerdotio;"
,"65":"dixitque praepositus eis, ut non manducarent de sanctificatis sanctuarii, donec staret sacerdos pro Urim et Tummim."
,"66":"Omnis multitudo simul quadraginta duo milia trecenti sexaginta,"
,"67":"absque servis et ancillis eorum, qui erant septem milia trecenti triginta septem; insuper et cantores et cantatrices ducenti quadraginta quinque."
,"68":"Equi eorum septingenti triginta sex, muli eorum ducenti quadraginta quinque,"
,"69":"cameli eorum quadringenti triginta quinque, asini sex milia septingenti viginti."
,"70":"Nonnulli autem de principibus familiarum dederunt in opus: praepositus dedit in thesaurum auri drachmas mille, phialas quinquaginta, tunicas sacerdotales quingentas triginta;"
,"71":"et de principibus familiarum dederunt in thesaurum operis auri drachmas viginti milia et argenti minas duo milia ducentas."
,"72":"Et quod dedit reliquus populus, auri drachmas viginti milia et argenti minas duo milia et tunicas sacerdotales sexaginta septem. Habitaverunt autem ibi sacerdotes et Levitae; ianitores autem et cantores et quidam de populo et oblati et omnis Israel habitaverunt in civitatibus suis. Et venerat mensis septimus; filii autem Israel erant in civitatibus suis."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Congregatusque est omnis populus quasi vir unus ad plateam, quae est ante portam Aquarum, et dixerunt Esdrae scribae, ut afferret librum legis Moysi, quam praece perat Dominus Israeli."
,"2":"Attulit ergo Esdras sacerdos legem coram multitudine virorum et mulierum cunctisque, qui poterant intellegere, in die prima mensis septimi."
,"3":"Et legit in eo in platea, quae erat ante portam Aquarum, de mane usque ad mediam diem in conspectu virorum et mulierum et eorum, qui intellegere poterant; et aures omnis populi erant erectae ad librum legis."
,"4":"Stetit autem Esdras scriba super gradum ligneum, quem ad hoc fecerant; et steterunt iuxta eum Matthathias et Sema et Anaia et Uria et Helcia et Maasia ad dexteram eius, et ad sinistram Phadaia, Misael et Melchia et Hasum et Hasbadana, Zacharia et Mosollam."
,"5":"Et aperuit Esdras librum coram omni populo - super universum quippe populum eminebat - et, cum aperuisset eum, stetit omnis populus."
,"6":"Et benedixit Esdras Domino, Deo magno; et respondit omnis populus: ' Amen, amen ', elevans manus suas. Et incurvati sunt et adoraverunt Deum proni in terram."
,"7":"Porro Iesua et Bani et Serebia, Iamin, Accub, Sabethai, Hodia, Maasia, Celita, Azarias, Iozabad, Hanan, Phalaia et Levitae erudiebant populum in lege; populus autem stabat in gradu suo."
,"8":"Et legerunt in libro legis Dei distincte et aperierunt sensum et explicaverunt lectionem."
,"9":"Dixit autem Nehemias, ipse est praepositus, et Esdras sacerdos et scriba et Levitae instruentes populum universo populo: ' Dies iste sanctificatus est Domino Deo nostro! Nolite lugere et nolite flere '. Flebat enim omnis populus, cum audiret verba legis."
,"10":"Et dixit eis: ' Ite, comedite pinguia et bibite mulsum et mittite partes his, qui non praeparaverunt sibi, quia sanctus dies Domini nostri est; et nolite contristari, gaudium etenim Domini est fortitudo vestra '."
,"11":"Levitae autem silentium faciebant in omni populo dicentes: ' Tacete, quia dies sanctus est, et nolite dolere '."
,"12":"Abiit itaque omnis populus, ut comederet et biberet et mitteret partes et faceret laetitiam magnam, quia intellexerant verba, quae docuerat eos."
,"13":"Et in die secundo congregati sunt principes familiarum universi populi, sacerdotes et Levitae ad Esdram scribam, ut intellegerent verba legis."
,"14":"Et invenerunt scriptum in lege, quam praecepit Dominus per Moysen, ut habitent filii Israel in tabernaculis in die sollemni mense septimo"
,"15":"et ut praedicent et divulgent vocem in universis urbibus suis et in Ierusalem dicentes: ' Egredimini in montem et afferte frondes olivae et frondes oleastri, frondes myrti et ramos palmarum et frondes ligni nemorosi, ut fiant tabernacula, sicut scriptum est '."
,"16":"Et egressus est populus, et attulerunt feceruntque sibi tabernacula, unusquisque in domate suo et in atriis suis et in atriis domus Dei et in platea portae Aquarum et in platea portae Ephraim."
,"17":"Fecit ergo universa ecclesia eorum, qui redierant de captivitate, tabernacula et habitaverunt in tabernaculis. Non enim fecerant a diebus Iosue filii Nun taliter filii Israel usque ad diem illum; et fuit laetitia magna nimis."
,"18":"Legit autem in libro legis Dei per dies singulos, a die primo usque ad diem novissimum; et fecerunt sollemnitatem septem diebus et in die octavo conventum iuxta ordinationem."
}`)
	CurrentBook.AddChapter(9, `{
"1":"In die autem vicesimo quarto mensis huius convenerunt filii Is rael in ieiunio et in saccis, et humus super eos."
,"2":"Et separatum est semen filiorum Israel ab omni alienigena; et steterunt et confitebantur peccata sua et iniquitates patrum suorum."
,"3":"Et consurrexerunt ad standum et legerunt in volumine legis Domini Dei sui per quartam partem diei; et per quartam partem confitebantur et adorabant Dominum Deum suum."
,"4":"Surrexerunt autem super gradum Levitarum Iesua et Bani et Cadmihel, Sebania, Bunni, Serebia, Bani et Chanani et clamaverunt voce magna ad Dominum Deum suum."
,"5":"Et dixerunt Levitae Iesua et Cadmihel, Bani, Hasabneia, Serebia, Hodia, Sebania, Phethahia: ' Surgite, benedicite Domino Deo vestro,ab aetemo usque in aeternum, et benedicant nomini gloriae tuae excelso,super omnem benedictionem et laudem."
,"6":"Tu ipse, Domine, solus; tu fecisti caelum et caelum caelorum,et omnem exercitum eorum, terram et universa, quae in ea sunt, maria et omnia, quae in eis sunt; et tu vivificas omnia haec, et exercitus caeli te adorat."
,"7":"Tu ipse, Domine Deus, qui elegisti Abram,et eduxisti eum de Ur Chaldaeorum,et posuisti nomen eius Abraham."
,"8":"Et invenisti cor eius fidele coram te,et percussisti cum eo foedus, ut dares terram Chananaei, Hetthaei et Amorraei,et Pherezaei et Iebusaei et Gergesaei, nempe ut dares semini eius; et implesti verba tua, quoniam iustus es."
,"9":"Et vidisti afflictionem patrum nostrorum in Aegypto,clamoremque eorum audisti iuxta mare Rubrum."
,"10":"Et dedisti signa atque portenta in pharaone,et in universis servis eius et in omni populo terrae illius; cognovisti enim quia superbe egerant contra eos, et fecisti tibi nomen, sicut et in hac die."
,"11":"Et mare divisisti ante eos, et transierunt per medium maris in sicco; persecutores autem eorum proiecisti in profundum, quasi lapidem in aquas validas."
,"12":"Et in columna nubis ductor eorum fuisti per diem,et in columna ignis per noctem, ut illuminaret eis viam, per quam ingrediebantur."
,"13":"Ad montem quoque Sinai descendisti,et locutus es cum eis de caelo; et dedisti eis iudicia recta,et legem rectam, mandata et praecepta bona."
,"14":"Et sabbatum sanctificatum tuum ostendisti eis,et praecepta et mandata et legem praecepisti eis,in manu Moysi servi tui."
,"15":"Panem quoque de caelo dedisti eis in fame eorum,et aquam de petra eduxisti eis in siti eorum; et dixisti eis, ut ingrederentur et possiderent terram, super quam levasti manum tuam, ut traderes eis."
,"16":"Ipsi vero patres nostri superbe egerunt,et induraverunt cervices suas et non audierunt mandata tua."
,"17":"Et noluerunt audire,et non sunt recordati mirabilium tuorum, quae feceras eis, et induraverunt cervices suas,et posuerunt caput suum, ut reverterentur ad servitutem suam in Aegyptum. Tu autem Deus propitius, clemens et misericors, longanimis et multae miserationis, non dereliquisti eos."
,"18":"Et quidem, cum fecissent sibi vitulum conflatilem,et dixissent: 'Iste est Deus tuus, qui eduxit te de Aegypto',feceruntque blasphemias magnas;"
,"19":"tu autem in misericordiis tuis multis,non dimisisti eos in deserto: columna nubis non recessit ab eis per diem, ut duceret eos in viam; et columna ignis per noctem, ut illuminaret eis iter, per quod ingrederentur."
,"20":"Et spiritum tuum bonum dedisti, qui doceret eos, et manna tuum non prohibuisti ab ore eorum,et aquam dedisti eis in siti eorum."
,"21":"Quadraginta annis pavisti eos in deserto, nihilque eis defuit; vestimenta eorum non inveteraverunt, et pedes eorum non intumuerunt."
,"22":"Et dedisti eis regna et populos,et partitus es eis sortes; et possederunt terram Sehon et terram regis Hesebon,et terram Og regis Basan."
,"23":"Et multiplicasti filios eorum sicut stellas caeli; et adduxisti eos ad terram, de qua dixeras patribus eorum, ut ingrederentur et possiderent."
,"24":"Et venerunt filii et possederunt terram, et humiliasti coram eis habitatores terrae Chananaeos; et dedisti eos in manu eorum,et reges eorum et populos terrae, ut facerent eis, sicut placebat illis."
,"25":"Ceperunt itaque urbes munitas et humum pinguem; et possederunt domos plenas cunctis bonis, cisternas ab aliis fabricatas, vineas et oliveta,et ligna pomifera multa. Et comederunt et saturati sunt et impinguati sunt,et delectati sunt in bonitate tua magna."
,"26":"Vexaverunt autem te et rebellaverunt contra te,et proiecerunt legem tuam post terga sua; et prophetas tuos occiderunt, qui contestabantur eos, ut reverterentur ad te; feceruntque blasphemias grandes."
,"27":"Et dedisti eos in manu hostium suorum, et afflixerunt eos; et in tempore tribulationis suae clamaverunt ad te, et tu de caelo audisti,et secundum miserationes tuas multas dedisti eis salvatores, qui salvarent eos da manu hostium suorum."
,"28":"Cumque requievissent, reversi sunt, ut facerent malum in conspectu tuo; et dereliquisti eos in manu inimicorum suorum, et dominati sunt eis. Conversique sunt et clamaverunt ad te; tu autem de caelo exaudisti,et liberasti eos in misericordiis tuis multis vicibus."
,"29":"Et contestatus es eos, ut reduceres eos ad legem tuam; ipsi vero superbe egerunt et non audierunt mandata tua,et in iudicia tua peccaverunt, quae si fecerit homo, vivet in eis, et dederunt umerum rebellem,et cervicem suam induraverunt nec audierunt."
,"30":"Et pepercisti eis annos multos,et contestatus es eos in spiritu tuo,per manum prophetarum tuorum, et non audierunt; et tradidisti eos in manu populorum terrarum."
,"31":"In misericordiis autem tuis plurimis,non fecisti eos in consumptionem,nec dereliquisti eos; quoniam Deus misericors et clemens es tu."
,"32":"Nunc itaque, Deus noster magne, fortis et terribilis, custodiens pactum et misericordiam, ne parvipendas omnem laborem, qui invenit nos, reges nostros et principes nostros,et sacerdotes nostros et prophetas nostros,et patres nostros et omnem populum tuum,a diebus regum Assyriae usque in diem hanc."
,"33":"Et tu iustus es in omnibus, quae venerunt super nos, quia recte fecisti, nos autem impie egimus."
,"34":"Reges nostri, principes nostri, sacerdotes nostri et patres nostri,non fecerunt legem tuam,et non attenderunt mandata tua et testimonia tua, quae testificatus es in eis."
,"35":"Et ipsi in regnis suis et in bonitate tua multa, quam dederas eis, et in terra latissima et pingui, quam tradideras in conspectu eorum, non servierunt tibi nec reversi sunt a studiis suis pessimis."
,"36":"Ecce nos ipsi hodie servi sumus; et in terra, quam dedisti patribus nostris, ut comederent fructum eius et bona eius, nos ipsi servi sumus."
,"37":"Et fruges eius multiplicantur regibus, quos posuisti super nos propter peccata nostra, et corporibus nostris dominantur et iumentis nostris,secundum voluntatem suam, et in tribulatione magna sumus '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"' Super omnibus ergo his nos ipsi percutimus foedus et scribimus, et signant principes nostri, Levitae nostri et sacerdotes nostri '."
,"2":"Signatores autem fuerunt: Nehemias praepositus, filius Hachaliae, et Sedecias,"
,"3":"Saraias, Azarias, Ieremias,"
,"4":"Phassur, Amarias, Melchias,"
,"5":"Hattus, Sebania, Melluch,"
,"6":"Harim, Meremoth, Abdias,"
,"7":"Daniel, Genthon, Baruch,"
,"8":"Mosollam, Abia, Miamin,"
,"9":"Maazia, Belgai, Semeia; hi sacerdotes."
,"10":"Porro Levitae: Iesua filius Azaniae, Bennui de filiis Henadad, Cadmihel"
,"11":"et fratres eorum Sebania, Hodia, Celita, Phalaia, Hanan,"
,"12":"Micha, Rohob, Hasabia,"
,"13":"Zacchur, Serebia, Sebania,"
,"14":"Hodia, Bani, Baninu."
,"15":"Capita populi: Pharos, Phahathmoab, Elam, Zethua, Bani,"
,"16":"Bunni, Azgad, Bebai,"
,"17":"Adonia, Beguai, Adin,"
,"18":"Ater, Ezechia, Azur,"
,"19":"Hodia, Hasum, Besai,"
,"20":"Hareph, Anathoth, Nebai,"
,"21":"Megphias, Mosollam, Hezir,"
,"22":"Mesezabel, Sadoc, Ieddua,"
,"23":"Pheltia, Hanan, Anaia,"
,"24":"Osee, Hanania, Hassub,"
,"25":"Alohes, Phalea, Sobec,"
,"26":"Rehum, Hasabna, Maasia,"
,"27":"Ahia, Hanan, Anan,"
,"28":"Melluch, Harim, Baana."
,"29":"Et reliqui de populo, sacerdotes, Levitae, ianitores et cantores, oblati et omnes, qui se separaverunt de populis terrarum ad legem Dei, uxores eorum, filii eorum et filiae eorum, omnes, qui poterant sapere,"
,"30":"adhaeserunt fratribus suis optimatibus pollicentes et iurantes, ut ambularent in lege Dei, quam dederat in manu Moysi servi Dei, et ut facerent et custodirent universa mandata Domini Dei nostri et iudicia eius et praecepta eius,"
,"31":"et ut non daremus filias nostras populo terrae et filias eorum non acciperemus filiis nostris."
,"32":"Et si populi terrae importaverint venalia et omnia cibaria per diem sabbati, ut vendant, non accipiemus ab eis in sabbato et in die sanctificato; et dimittemus annum septimum et omnem exactionem."
,"33":"Et statuimus super nos praecepta, ut demus tertiam partem sicli per annum ad opus domus Dei nostri,"
,"34":"ad panes propositionis et ad oblationem sempiternam et in holocaustum sempiternum in sabbatis, in calendis, in sollemnitatibus et in sanctificata et in sacrificium pro peccato, ut expietur pro Israel, et in omnem usum domus Dei nostri."
,"35":"Sortes ergo misimus super oblationem lignorum inter sacerdotes et Levitas et populum, ut inferrentur in domum Dei nostri per domos patrum nostrorum, in temporibus constitutis ab anno in annum, ut arderent super altare domini Dei nostri, sicut scriptum est in lege;"
,"36":"et ut afferremus primogenita terrae nostrae et primitiva universi fructus omnis ligni ab anno in annum in domo Domini,"
,"37":"et primitiva filiorum nostrorum et pecorum nostrorum, sicut scriptum est in lege, et primitiva boum nostrorum et ovium nostrarum, ut afferrentur in domum Dei nostri sacerdotibus, qui ministrant in domo Dei nostri;"
,"38":"et primitias ciborum nostrorum et libaminum nostrorum et poma omnis ligni, vindemiae quoque et olei, afferemus sacerdotibus ad gazophylacium Dei nostri, et decimam partem terrae nostrae Levitis. Ipsi Levitae decimas accipient ex omnibus civitatibus agriculturae nostrae."
,"39":"Erit autem sacerdos filius Aaron cum Levitis in decimis Levitarum colligendis, et Levitae offerent decimam partem decimae in domo Dei nostri ad gazophylacium thesauri."
,"40":"Ad gazophylacium enim deportabunt filii Israel et filii Levi primitias frumenti, vini et olei; et ibi erunt vasa sanctificata et sacerdotes, qui ministrabant, et ianitores et cantores. Et non dimittemus domum Dei nostri."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Habitaverunt autem princi pes populi in Ierusalem; reli qua vero plebs misit sortem, ut adducerent unum virum de decem ad habitandum in Ierusalem civitate sancta, novem vero partes in civitatibus."
,"2":"Benedixit autem populus omnibus viris, qui se sponte obtulerant, ut habitarent in Ierusalem."
,"3":"Hi sunt itaque principes provinciae, qui habitaverunt in Ierusalem et in civitatibus Iudae. Habitavit autem unusquisque in possessione sua, in urbibus suis, Israel, sacerdotes, Levitae, oblati et filii servorum Salomonis."
,"4":"Et in Ierusalem habitaverunt de filiis Iudae et de filiis Beniamin. De filiis Iudae: Athaias filius Oziam filii Zachariae filii Amariae filii Saphatiae filii Malaleel, de filiis Phares;"
,"5":"et Maasia filius Baruch filius Cholhoza filius Hazia filius Adaia filius Ioiarib filius Zachariae filius Silonitis."
,"6":"Omnes filii Phares, qui habitaverunt in Ierusalem, quadringenti sexaginta octo viri fortes."
,"7":"Hi sunt autem filii Beniamin: Sallu filius Mosollam filius Ioed filius Phadaia filius Colaia filius Maasia filius Etheel filius Iesaia;"
,"8":"et fratres eius viri fortes, nongenti viginti octo."
,"9":"Et Ioel filius Zechri praepositus eorum, et Iudas filius Asana super civitatem secundus."
,"10":"Et de sacerdotibus: Iedaia filius Ioiarib filius"
,"11":"Saraia filius Helciae filius Mosollam filius Sadoc filius Meraioth filius Achitob princeps domus Dei;"
,"12":"et fratres eorum facientes opera templi, octingenti viginti duo. Et Adaia filius Ieroham filius Phelelia filius Amsi filius Zachariae filius Phassur filius Melchiae;"
,"13":"et fratres eius principes familiarum ducenti quadraginta duo. Et Amassai filius Azareel filius Ahazi filius Mosollamoth filius Emmer;"
,"14":"et fratres eorum potentes nimis, centum viginti octo; et praepositus eorum Zabdiel vir nobilis."
,"15":"Et de Levitis: Semeia filius Hassub filius Ezricam filius Hasabia filius Bunni;"
,"16":"et Sabethai et Iozabad super omnia opera, quae erant forinsecus in domo Dei, de principibus Levitarum;"
,"17":"et Matthania filius Micha filius Zebedaei filius Asaph magister chori incohabat orationem; et Becbecia secundus de fratribus eius, et Abda filius Sammua filius Galal filius Idithun."
,"18":"Omnes Levitae in civitate sancta ducenti octoginta quattuor."
,"19":"Et ianitores: Accub, Telmon et fratres eorum, qui custodiebant ostia, centum septuaginta duo."
,"20":"Et reliqui ex Israel sacerdotes et Levitae in universis civitatibus Iudae, unusquisque in possessione sua."
,"21":"Et oblati habitabant in Ophel; et Siha et Gaspha super oblatos."
,"22":"Et praefectus Levitarum in Ierusalem Ozi filius Bani filius Hasabiae filius Matthaniae filius Michae de filiis Asaph, cantores in ministerio domus Dei."
,"23":"Praeceptum quippe regis super eos erat, et ordo in cantoribus per dies singulos."
,"24":"Et Phethahia filius Mesezabel de filiis Zara filii Iudae, legatus regis in omni negotio populi."
,"25":"Et in viculis per omnes regiones eorum, de filiis Iudae habitaverunt in Cariatharbe et in pagis eius et in Dibon et in pagis eius et in Cabseel et in viculis eius"
,"26":"et in Iesua et in Molada et in Bethpheleth"
,"27":"et in Asarsual et in Bersabee et in pagis eius"
,"28":"et in Siceleg et in Mochona et in pagis eius"
,"29":"et in Remmon et in Saraa et in Ierimoth,"
,"30":"Zanoa, Odollam et in villis earum, Lachis et regionibus eius et Azeca et pagis eius. Et habitaverunt a Bersabee usque ad vallem Ennom."
,"31":"Filii autem Beniamin in Gabaa, Machmas et Hai et Bethel et pagis eius,"
,"32":"Anathoth, Nob, Anania,"
,"33":"Asor, Rama, Getthaim,"
,"34":"Hadid, Seboim et Neballat,"
,"35":"Lod et Ono et valle Artificum."
,"36":"Et de Levitis portiones in Iuda et Beniamin."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Hi sunt autem sacerdotes et Levitae, qui ascenderunt cum Zorobabel filio Salathiel et Iesua: Saraia, Ieremias, Esdras,"
,"2":"Amaria, Melluch, Hattus,"
,"3":"Sechenias, Rehum, Meremoth,"
,"4":"Addo, Genthon, Abia,"
,"5":"Miamin, Maadia, Belga,"
,"6":"Semeia et Ioiarib, Iedaia,"
,"7":"Sallu, Amoc, Helcias, Iedaia. Isti principes sacerdotum et fratrum eorum in diebus Iesua."
,"8":"Porro Levitae: Iesua, Bennui, Cadmihel, Serebia, Iuda, Matthanias, super hymnos ipse et fratres eius;"
,"9":"et Becbecia atque Hanni fratres eorum coram eis per vices suas."
,"10":"Iesua autem genuit Ioachim, et Ioachim genuit Eliasib, et Eliasib genuit Ioiada,"
,"11":"et Ioiada genuit Ionathan, et Ionathan genuit Ieddua."
,"12":"In diebus autem Ioachim erant sacerdotes principes familiarum: Saraiae Maraia, Ieremiae Hanania,"
,"13":"Esdrae Mosollam, Amariae Iohanan,"
,"14":"Milicho Ionathan, Sebaniae Ioseph,"
,"15":"Harim Edna, Meraioth Helci,"
,"16":"Adaiae Zacharia, Genthon Mosollam,"
,"17":"Abiae Zechri, Miamin Maadiae Phelti,"
,"18":"Belgae Sammua, Semeiae Ionathan,"
,"19":"Ioiarib Matthanai, Iedaiae Ozi,"
,"20":"Sellai Celai, Amoc Heber,"
,"21":"Helciae Hasabia, Iedaiae Nathanael."
,"22":"Levitae in diebus Eliasib et Ioiada et Iohanan et Ieddua scripti principes familiarum et sacerdotes usque ad regnurn Darii Persae."
,"23":"Filii Levi principes familiarum scripti in libro Chronicorum usque ad dies Ionathan filii Eliasib."
,"24":"Et principes Levitarum Hasabia, Serebia, Iesua, Bennui et Cadmihel et fratres eorum coram eis, ut laudarent et confiterentur iuxta praeceptum David viri Dei per vices suas;"
,"25":"Matthania et Becbecia, Abdia, Mosollam, Telmon, Accub ianitores ad custodiam horreorum iuxta portas."
,"26":"Hi in diebus Ioachim filii Iesua filii Iosedec et in diebus Nehemiae ducis et Esdrae sacerdotis scribaeque."
,"27":"In dedicatione autem muri Ierusalem requisierunt Levitas de omnibus locis suis, ut adducerent eos in Ierusalem et facerent dedicationem in laetitia, in actione gratiarum et cantico et cymbalis, psalteriis et citharis."
,"28":"Congregati sunt autem cantores de campestribus circa Ierusalem et de villis Netophathitarum 29 et de Bethgalgala et de regionibus Gabaa et Azmaveth, quoniam villas aedificaverunt sibi cantores in circuitu Ierusalem."
,"30":"Et mundati sunt sacerdotes et Levitae et mundaverunt populum et portas et murum."
,"31":"Ascendere autem feci principes Iudae super murum et statui duos magnos choros laudantium, quorum unus ivit ad dexteram super murum ad portam Sterquilinii."
,"32":"Et ivit post eos Osaias et media pars principum Iudae"
,"33":"et Azarias, Esdras et Mosollam,"
,"34":"Iudas et Beniamin et Semeia et Ieremias."
,"35":"Et de sacerdotibus cum tubis et Zacharias filius Ionathan filius Semeiae filius Matthaniae filius Michaiae filius Zacchur filius Asaph;"
,"36":"et fratres eius Semeia et Azareel, Malalai, Galalai, Maai, Nathanael et Iudas et Hanani cum musicis David viri Dei; et Esdras scriba ante eos et in porta Fontis."
,"37":"Processerunt per gradus civitatis David in ascensu muri super domum David et usque ad portam Aquarum ad orientem."
,"38":"Et chorus secundus gratias referentium ibat ex adverso, et ego post eum, et media pars populi super murum et super turrim Furnorum et usque ad murum latissimum"
,"39":"et super portam Ephraim et super portam Antiquam et super portam Piscium et turrim Hananeel et turrim Meah et usque ad portam Gregis; et steterunt in porta Custodiae."
,"40":"Steteruntque duo chori laudantium in domo Dei, et ego et dimidia pars magistratuum mecum."
,"41":"Et sacerdotes Eliachim, Maasia, Miamin, Michaia, Elioenai, Zacharia, Hanania in tubis;"
,"42":"et Maasia et Semeia et Eleazar et Ozi et Iohanan et Melchia et Elam et Ezer. Et clare cecinerunt cantores et Izrahia praepositus."
,"43":"Et obtulerunt in die illa sacrificia magna et laetati sunt; Deus enim laetificaverat eos laetitia magna; sed et uxores eorum et liberi gavisi sunt, et audita est laetitia Ierusalem procul."
,"44":"Praeposuerunt quoque in die illa viros super gazophylacia ad thesaurum, ad libamina et ad primitias et ad decimas, ut colligerent in ea de agris civitatum partes legitimas pro sacerdotibus et Levitis; quia laetificatus est Iuda in sacerdotibus et Levitis, qui adstiterunt"
,"45":"et servierunt in ministerio Dei sui et in ministerio purificationis simul cum cantoribus et ianitoribus iuxta praeceptum David et Salomonis filii eius;"
,"46":"quia in diebus David et Asaph ab exordio erant catervae cantorum et carmina laudis et actionis gratiarum Deo."
,"47":"Et omnis Israel in diebus Zorobabel et in diebus Nehemiae dabant partes cantoribus et ianitoribus per dies singulos partem suam et partes consecrabant Levitis, et Levitae consecrabant filiis Aaron."
}`)
	CurrentBook.AddChapter(13, `{
"1":"In die autem illo lectum est in volumine Moysi, audiente populo, et inventum est scriptum in eo quod non debeant introire Ammonites et Moabites in ecclesiam Dei usque in aeternum,"
,"2":"eo quod non occurrerint filiis Israel cum pane et aqua et conduxerint adversum eos Balaam ad maledicendum eis, et convertit Deus noster maledictionem in benedictionem."
,"3":"Factum est autem, cum audissent legem, separaverunt omnem promiscuum ab Israel."
,"4":"Ante hoc autem erat Eliasib sacerdos, qui fuerat praepositus in gazophylacio domus Dei nostri et proximus Thobiae;"
,"5":"fecerat ei gazophylacium grande, ubi antea reponebant munera et tus et vasa et decimam frumenti, vini et olei, partes Levitarum et cantorum et ianitorum et tributa sacerdotum."
,"6":"In omnibus autem his non fui in Ierusalem, quia anno tricesimo secundo Artaxerxis regis Babylonis veni ad regem et in fine dierum rogavi, ut abirem a rege,"
,"7":"et veni in Ierusalem. Et intellexi malum, quod fecerat Eliasib Thobiae: fecerat enim ei thesaurum in vestibulis domus Dei."
,"8":"Et malum mihi visum est valde, et proieci vasa domus Thobiae foras de gazophylacio;"
,"9":"praecepique, et emundaverunt gazophylacia, et rettuli ibi vasa domus Dei, oblationem et tus."
,"10":"Et cognovi quod partes Levitarum non fuissent datae, et fugisset unusquisque in campum suum de Levitis et cantoribus, qui ministrabant."
,"11":"Et egi causam adversus magistratus et dixi: ' Quare dereliquimus domum Dei? '. Et congregavi eos et feci stare in stationibus suis."
,"12":"Et omnis Iuda apportabat decimam frumenti, vini et olei in horrea."
,"13":"Et constitui super horrea Selemiam sacerdotem et Sadoc scribam et Phadaiam de Levitis et iuxta eos Hanan filium Zacchur, filium Matthaniae, quoniam fideles comprobati sunt; et ipsi curam habebant distribuendi partes fratribus suis."
,"14":"Memento mei, Deus meus, pro hoc; et ne deleas opera mea bona, quae feci in domo Dei mei et in ministeriis eius!"
,"15":"In diebus illis vidi in Iuda calcantes torcularia in sabbato, portantes acervos et onerantes super asinos vinum et uvas et ficus et omne onus et inferentes in Ierusalem die sabbati; et contestatus sum, quando vendebant cibaria."
,"16":"Et ibi Tyrii habitaverunt in ea inferentes pisces et omnia venalia et vendebant in sabbatis filiis Iudae in Ierusalem."
,"17":"Et obiurgavi optimates Iudae et dixi eis: ' Quae est haec res mala, quam vos facitis, et profanatis diem sabbati?"
,"18":"Numquid non haec fecerunt patres nostri, et adduxit Deus noster super nos omne malum hoc et super civitatem hanc? Et vos additis iracundiam super Israel profanando sabbatum! '."
,"19":"Factum est autem, cum obscuratae essent portae Ierusalem ante diem sabbati, dixi, et clauserunt ianuas; et praecepi, ut non aperirent eas usque post sabbatum. Et de pueris meis constitui super portas, ut nullus inferret onus in die sabbati."
,"20":"Et manserunt negotiatores et vendentes universa venalia foris Ierusalem semel et bis."
,"21":"Et contestatus sum eos et dixi eis: ' Quare manetis ex adverso muri? Si iterum hoc feceritis, manum mittam in vos '. Itaque ex tempore illo non venerunt in sabbato."
,"22":"Dixi quoque Levitis, ut mundarentur et venirent ad custodiendas portas et sanctificandam diem sabbati. Et pro hoc ergo memento mei, Deus meus, et parce mihi secundum multitudinem miserationum tuarum!"
,"23":"Sed et in diebus illis vidi Iudaeos, qui duxerant uxores Azotidas, Ammonitidas et Moabitidas."
,"24":"Et filii eorum ex media parte loquebantur Azotice et nesciebant loqui Iudaice vel loquebantur iuxta linguam unius vel alterius populi."
,"25":"Et obiurgavi eos et maledixi et cecidi quosdam ex eis et decalvavi eos; et adiuravi in Deo, ut non darent filias suas filiis eorum et non acciperent de filiabus eorum filiis suis et sibimetipsis dicens:"
,"26":"' Numquid non in huiuscemodi re peccavit Salomon rex Israel? Et certe in gentibus multis non erat rex similis ei, et dilectus Deo suo erat, et posuit eum Deus regem super omnem Israel; et ipsum ergo duxerunt ad peccatum mulieres alienigenae."
,"27":"Numquid et vobis obsequentes faciemus omne malum grande hoc, ut praevaricemur in Deo nostro et ducamus uxores peregrinas? '."
,"28":"Unus autem de filiis Ioiada filii Eliasib sacerdotis magni gener erat Sanaballat Horonites, quem fugavi a me."
,"29":"Recordare, Domine Deus meus, adversum eos, qui polluunt sacerdotium et pactum sacerdotale et leviticum!"
,"30":"Igitur mundavi eos ab omnibus alienigenis et constitui ordines pro sacerdotibus et Levitis, unumquemque in ministerio suo,"
,"31":"et pro oblatione lignorum in temporibus constitutis et pro primitiis. Memento mei, Deus meus, in bonum."
}`)

}
func LA_NVBSE_LoadVHRTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In diebus, quando iudices praeerant, facta est fames in ter ra. Abiitque homo de Bethlehem Iudae, ut peregrinaretur in regione Moabitide cum uxore sua ac duobus liberis."
,"2":"Ipse vocabatur Elimelech et uxor eius Noemi et duo filii alter Mahalon et alter Chelion Ephrathaei de Bethlehem Iudae. Ingressique regionem Moabitidem morabantur ibi."
,"3":"Et mortuus est Elimelech maritus Noemi, remansitque ipsa cum filiis,"
,"4":"qui acceperunt uxores Moabitidas, quarum una vocabatur Orpha, altera Ruth; manseruntque ibi decem fere annis."
,"5":"Et ambo mortui sunt, Mahalon videlicet et Chelion; remansitque mulier orbata duobus liberis ac marito."
,"6":"Et surrexit, ut in patriam pergeret cum utraque nuru sua de regione Moabitide; audierat enim quod respexisset Dominus populum suum et dedisset eis escas."
,"7":"Egressa est itaque de loco peregrinationis suae cum utraque nuru et, iam in via posita revertendi in terram Iudae,"
,"8":"dixit ad eas: ' Ite in domum matris vestrae; faciat Dominus vobiscum misericordiam, sicut fecistis cum mortuis et mecum:"
,"9":"det vobis invenire requiem in domibus virorum, quos sortiturae estis '. Et osculata est eas. Quae elevata voce flere coeperunt"
,"10":"et dicere: ' Tecum pergemus ad populum tuum '."
,"11":"Quibus illa respondit: ' Revertimini, filiae meae; cur venitis mecum? Num ultra habeo filios in utero meo, ut viros ex me sperare possitis?"
,"12":"Revertimini, filiae meae, abite; iam enim senectute confecta sum nec apta vinculo coniugali; etiamsi possem hac nocte concipere et parere filios,"
,"13":"numquid exspectare velitis et abstinere vos a matrimonio, donec crescant et annos impleant pubertatis? Nolite, quaeso, filiae meae; quia amaritudo est mihi magis quam vobis, et egressa est manus Domini contra me '."
,"14":"Elevata igitur voce, rursum flere coeperunt. Orpha osculata socrum est ac reversa; Ruth autem adhaesit socrui suae."
,"15":"Cui dixit Noemi: ' En reversa est cognata tua ad populum suum et ad deos suos; vade cum ea'."
,"16":"Quae respondit: 'Noli instare mihi, ut relinquam te et abeam; quocumque perrexeris, pergam; ubi morata fueris, et ego pariter morabor: populus tuus populus meus et Deus tuus Deus meus."
,"17":"Quae te morientem terra susceperit, in ea moriar ibique locum accipiam sepulturae. Haec mihi faciat Dominus et haec addat, si non sola mors me et te separaverit '."
,"18":"Videns ergo Noemi quod obstinato Ruth animo decrevisset secum pergere, adversari noluit nec ultra ad suos reditum persuadere."
,"19":"Profectaeque sunt simul et venerunt in Bethlehem. Quibus urbem ingressis, tota urbs commota est super eas; dicebantque mulieres: 'Haec est illa Noemi!'."
,"20":"Quibus ait: 'Ne vocetis me Noemi (id est Pulchram), sed vocate me Mara (hoc est Amaram), quia valde me amaritudine replevit Omnipotens."
,"21":"Egressa sum plena, et vacuam reduxit me Dominus; cur igitur vocatis me Noemi, quam humiliavit Dominus, et afflixit Omnipotens? '."
,"22":"Venit ergo Noemi cum Ruth Moabitide nuru sua de terra peregrinationis suae ac reversa est in Bethlehem, quando hordea metere incipiebant."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Erat autem Noemi consangui neus viri sui homo potens et for tis nomine Booz."
,"2":"Dixitque Ruth Moabitis ad socrum suam: ' Si permittis, vadam in agrum et colligam spicas, quae fugerint manus metentium, ubicumque clementis in me patris familias repperero gratiam'. Cui illa respondit: ' Vade, filia mea '."
,"3":"Abiit itaque et colligebat spicas post terga metentium. Accidit autem ut ager ille haberet dominum nomine Booz, qui erat de cognatione Elimelech."
,"4":"Et ecce ipse veniebat de Bethlehem dixitque messoribus: 'Dominus vobiscum'. Qui responderunt ei: ' Benedicat tibi Dominus '."
,"5":"Dixitque Booz iuveni, qui messoribus praeerat: ' Cuius est haec puella? '."
,"6":"Qui respondit: ' Haec est Moabitis, quae venit cum Noemi de regione Moabitide"
,"7":"et rogavit, ut spicas colligeret remanentes sequens messorum vestigia; et de mane usque nunc stat in agro et nunc tantum ad momentum requievit '."
,"8":"Et ait Booz ad Ruth: ' Audi, filia: ne vadas ad colligendum in alterum agrum nec recedas ab hoc loco, sed iungere puellis meis."
,"9":"Vide et, ubi messuerint, sequere eas; mandavi enim pueris, ut nemo tibi molestus sit; sed, si sitieris, vade ad sarcinulas et bibe de aqua, quam pueri hauserint '."
,"10":"Quae cadens in faciem suam et adorans super terram dixit ad eum: ' Unde mihi hoc, ut invenirem gratiam ante oculos tuos, et nosse me dignareris peregrinam mulierem? '."
,"11":"Cui ille respondit: ' Nuntiata sunt mihi omnia, quae feceris socrui tuae post mortem viri tui et quod dereliqueris parentes tuos et terram, in qua nata es, et veneris ad populum, quem ante nesciebas."
,"12":"Reddat tibi Dominus pro opere tuo, et plenam mercedem recipias a Domino, Deo Israel, ad quem venisti et sub cuius confugisti alas '."
,"13":"Quae ait: ' Inveniam gratiam ante oculos tuos, domine mi, qui consolatus es me et locutus es ad cor ancillae tuae, quae non sum similis unius puellarum tuarum '."
,"14":"Dixitque ad eam Booz hora vescendi: 'Veni huc et comede panem et intinge buccellam tuam in aceto '. Sedit itaque ad messorum latus, et porrexit ei polentam, comeditque et saturata est et tulit reliquias."
,"15":"Atque inde surrexit, ut spicas ex more colligeret. Praecepit autem Booz pueris suis dicens: 'Etiam inter manipulos colligat, ne prohibeatis eam;"
,"16":"quin et de fasciculis spicas proicite et remanere permittite, ut colligat, et colligentem nemo corripiat '."
,"17":"Collegit ergo in agro usque ad vesperam; et, quae collegerat virga excutiens, invenit hordei quasi ephi mensuram (id est tres modios)."
,"18":"Quos portans reversa est in civitatem et ostendit socrui suae, quae collegerat; insuper protulit et dedit ei de reliquiis cibi sui, quo saturata fuerat."
,"19":"Dixitque ei socrus: ' Ubi hodie collegisti et ubi fecisti opus? Sit benedictus, qui misertus est tui! '. Indicavitque ei apud quem esset operata et dixit: ' Nomen viri est Booz '."
,"20":"Cui respondit Noemi: ' Benedictus sit a Domino, quia non subtraxit gratiam suam nec vivis nec mortuis! '. Rursumque ait: ' Propinquus noster est homo ex eis, qui pro nobis ius redemptionis habent '."
,"21":"Et Ruth: ' Hoc quoque, inquit, praecepit mihi, ut tamdiu messoribus eius iungerer, donec omnes segetes meterentur '."
,"22":"Cui dixit socrus: ' Melius est, filia mea, ut cum puellis eius exeas ad metendum, ne in alieno agro quispiam tibi molestus sit '."
,"23":"Iuncta est itaque puellis Booz usque ad finem messis hordei et tritici; et mansit cum socru sua."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et dixit ad eam Noemi socrus sua: ' Filia mea, quaeram tibi requiem et providebo, ut bene sit tibi."
,"2":"Booz propinquus noster, cuius puellis in agro iuncta eras, ecce ipse hac nocte aream hordei ventilat."
,"3":"Lavare igitur, ungere et induere pallio tuo ac descende in aream; non te videat homo, donec esum potumque finierit."
,"4":"Quando autem ierit ad dormiendum, nota locum, in quo dormiat; veniesque et discooperies pallium, quo operitur a parte pedum, et ibi iacebis. Ipse autem dicet tibi quid agere debeas '."
,"5":"Quae respondit: ' Quidquid praeceperis, faciam '."
,"6":"Descenditque in aream et fecit omnia, quae sibi imperaverat socrus."
,"7":"Cumque comedisset Booz et bibisset et factus esset hilarior issetque ad dormiendum in extrema parte acervi manipulorum, venit abscondite et, discooperto a pedibus eius pallio, se proiecit."
,"8":"Et ecce, nocte iam media, expavit homo et erexit se viditque mulierem iacentem ad pedes suos."
,"9":"Et ait illi: ' Quae es? '. Illaque respondit: ' Ego sum Ruth ancilla tua. Expande pallium tuum super famulam tuam, quia tibi est ius redemptionis '."
,"10":"Et ille: ' Benedicta, inquit, es a Domino, filia; et priorem pietatem posteriore superasti, quia non es secuta iuvenes pauperes sive divites."
,"11":"Noli ergo metuere, sed, quidquid dixeris mihi, faciam tibi; scit enim omnis populus, qui habitat intra portas urbis meae, mulierem te esse fortem."
,"12":"Nec abnuo me propinquum, sed est alius me propinquior."
,"13":"Quiesce hac nocte et, facto mane, si te voluerit propinquitatis iure suscipere, bene, suscipiat; sin autem ille noluerit, vivit Dominus, ego te absque ulla dubitatione suscipiam! Dormi usque mane '."
,"14":"Dormivit itaque ad pedes eius usque ad noctis abscessum. Surrexitque, antequam homines se cognoscerent mutuo, et dixit Booz: ' Cave, ne quis noverit quod huc veneris '."
,"15":"Et rursum: ' Expande, inquit, palliolum tuum, quo operiris, et tene utraque manu '. Qua extendente et tenente, mensus est sex modios hordei et posuit super eam; quae portans ingressa est civitatem"
,"16":"et venit ad socrum suam. Quae dixit ei: ' Quid egisti, filia? '. Narravitque ei omnia, quae sibi fecisset homo,"
,"17":"et ait: ' Ecce sex modios hordei dedit mihi et ait: ' Nolo vacuam te reverti ad socrum tuam '."
,"18":"Dixitque Noemi: ' Exspecta, filia, donec videamus quem res exitum habeat; neque enim cessabit homo, nisi compleverit hodie, quod locutus est '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ascendit ergo Booz ad portam et sedit ibi. Cumque vidisset propinquum praeterire, de quo locutus erat, dixit ad eum: ' Declina paulisper et sede hic ', vocans eum nomine suo. Qui divertit et sedit."
,"2":"Tollens autem Booz decem viros de senioribus civitatis dixit ad eos: ' Sedete hic '."
,"3":"Quibus sedentibus, locutus est ad propinquum: ' Partem agri fratris nostri Elimelech vendit Noemi, quae reversa est de regione Moabitide."
,"4":"Quod audire te volui et tibi dicere: Coram cunctis sedentibus et maioribus natu de populo meo, si vis possidere iure propinquitatis, eme et posside; sin autem tibi displicet, hoc ipsum indica mihi, ut sciam quid facere debeam. Nullus est enim propinquus, excepto te, qui prior es, et me, qui secundus sum '. At ille respondit: ' Ego agrum emam '."
,"5":"Cui dixit Booz: ' Quando emeris agrum de manu Noemi, Ruth quoque Moabitidem, quae uxor defuncti fuit, debes accipere, ut suscites nomen defuncti propinqui tui in hereditate sua '."
,"6":"Qui respondit: ' Cedo iure propinquitatis; neque enim possessionem familiae meae delere debeo. Tu meo utere privilegio, quo me libenter carere profiteor '."
,"7":"Hic autem erat mos antiquitus in Israel pro redemptione et commutatione: ut esset firma concessio, solvebat homo calceamentum suum et dabat proximo suo. Hoc erat testimonium cessionis in Israel."
,"8":"Dixit ergo propinquus ad Booz: ' Eme tibi '. Et solvit calceamentum suum de pede suo."
,"9":"Et Booz maioribus natu et universo populo: ' Testes, inquit, vos estis hodie quod acquisierim omnia, quae fuerunt Elimelech et Chelion et Mahalon, tradente Noemi,"
,"10":"et etiam Ruth Moabitidem uxorem Mahalon in coniugium sumpserim, ut suscitem nomen defuncti in hereditate sua, ne vocabulum eius de fratribus suis et de porta loci sui deleatur. Vos, inquam, huius rei hodie testes estis '."
,"11":"Respondit omnis populus, qui erat in porta, et maiores natu: ' Nos testes sumus; faciat Dominus hanc mulierem, quae ingreditur domum tuam, sicut Rachel et Liam, quae aedificaverunt ambae domum Israel. Fortiter age in Ephratha,et fac tibi celebre nomen in Bethlehem!"
,"12":"Fiatque domus tua sicut domus Phares, quem Thamar peperit Iudae, de semine, quod dederit Dominus tibi ex hac puella! '."
,"13":"Tulit itaque Booz Ruth et accepit uxorem; ingressusque est ad eam, et dedit illi Dominus, ut conciperet et pareret filium."
,"14":"Dixeruntque mulieres ad Noemi: ' Benedictus Dominus, qui non est passus, ut deficeret tibi hodie, qui redimit familiam tuam, et vocetur nomen eius in Israel"
,"15":"et consoletur animam tuam et enutriat senectutem; de nuru enim tua natus est, quae te diligit et multo tibi est melior quam septem filii '."
,"16":"Susceptumque Noemi puerum posuit in sinu suo et gerulae officio fungebatur."
,"17":"Vicinae autem mulieres congratulantes ei et dicentes: ' Natus est filius Noemi! ', vocaverunt nomen eius Obed. Hic est pater Isai patris David."
,"18":"Hae sunt generationes Phares: Phares genuit Esrom,"
,"19":"Esrom genuit Aram, Aram genuit Aminadab,"
,"20":"Aminadab genuit Naasson, Naasson genuit Salmon,"
,"21":"Salmon genuit Booz, Booz genuit Obed,"
,"22":"Obed genuit Iesse, Iesse genuit David."
}`)

}
func LA_NVBSE_LoadVHTBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Liber sermonum Thobis filii Thobiel filii Ananiel filii Aduel filii Gabael filii Raphael filii Raguel ex semine Asiel, ex tribu Nephthali,"
,"2":"qui captivus ductus est in diebus Salmanasar regis Assyriorum ex Thisbe, quae est a dextera parte Cades Nephthali in superiori Galilaea supra Asor post occidentem solem a sinistra parte Phogor."
,"3":"Ego Thobi in viis veritatis ambulabam et in iustitiis omnibus diebus vitae meae et eleemosynas multas feci fratribus meis et nationi meae, qui abierant mecum in captivitatem in regionem Assyriorum in Nineven."
,"4":"Et cum essem in regione mea in terra Israel et cum essem iunior, omnis tribus Nephthali patris mei recessit de domo David patris mei et ab Ierusalem civitate, quae est electa ex omnibus tribubus Israel; et sanctificatum est templum habitationis Dei et aedificatum est in ipsa, ut sacrificarent omnes tribus Israel in omnes generationes saeculi."
,"5":"Omnes fratres mei omnisque domus Nephthali patris mei sacrificabant vitulo, quem fecit Ieroboam rex Israel in Dan, in omnibus montibus Galilaeae."
,"6":"Ego autem solus ibam aliquotiens in Ierusalem diebus festis, sicut scriptum est in toto Israel in praecepto sempiterno; primitias et primogenita et decimas armentorum et pecorum et initia tonsurae ovium mecum portabam in Ierusalem"
,"7":"et dabam ea sacerdotibus, filiis Aaron, ad aram; et decimam tritici et vini et olei et malorum granatorum et ceterorum pomorum filiis Levi servientibus in Ierusalem; et secundam decimationem computabam in pecunia sex annorum et ibam et consummabam illa in Ierusalem unoquoque anno."
,"8":"Et dabam ea orphanis et viduis et proselytis appositis ad filios Israel; inferebam et dabam illis in tertio anno, et manducabamus illa secundum praeceptum, quod praeceptum est de eis in lege Moysis, et secundum mandata, quae mandaverat Debora mater patris mei Ananiel patris nostri, quia orphanum me reliquit pater et mortuus est."
,"9":"Et, postquam vir factus sum, accepi uxorem Annam ex semine patriae nostrae et genui ex illa filium et vocavi nomen eius Thobiam."
,"10":"Et, postquam in captivitatem deveni ad Assyrios, cum captivus morarer, ibam in Nineven; et omnes fratres mei et, qui de genere meo erant, manducabant de panibus gentium,"
,"11":"ego autem custodivi animam meam, ne manducarem de panibus gentium."
,"12":"Et quoniam memor eram Dei mei in tota anima mea,"
,"13":"dedit mihi Excelsus gratiam et speciem penes Salmanasar, et comparabam illi omnia, quaecumque erant in usum;"
,"14":"et ibam in Mediam, usque dum moreretur, et commendavi Gabael fratri Gabriae in Rages, in regione Mediae, saccellos decem talenta argenti."
,"15":"Et postquam mortuus est Salmanasar, et regnavit Sennacherib filius eius pro eo, et viae Mediae secesserunt, et non potui iam ire in Mediam."
,"16":"Et in diebus Salmanasar multas eleemosynas feci fratribus meis, qui erant ex genere meo."
,"17":"Panes meos dabam esurientibus et vestimenta nudis et, si quem videbam mortuum et proiectum post murum Nineves ex natione mea, sepeliebam illum."
,"18":"Et, si quem occidebat Sennacherib rex, ubi venit de Iudaea fugiens in diebus iudicii, quod fecit Rex caeli ex illo de blasphemiis, quibus blasphemaverat - multos enim filiorum Israel occidit in ira sua - ego autem corpora illorum involabam et sepeliebam; et quaesivit illa Sennacherib et non invenit illa."
,"19":"Et abiit quidam ex Ninevitis et indicavit regi de me quoniam ego sepelio illos, et abscondi me et, ubi cognovi quod rex sciebat de me et quod inquiror, ut occidar, timui et refugi."
,"20":"Et direpta est omnis substantia mea, et nihil mihi derelictum est, quod non assumptum esset in fiscum regis, nisi uxor mea Anna et Thobias filius meus."
,"21":"Et non transierunt dies quadraginta, quousque occiderent illum duo filii ipsius et fugerunt in montes Ararat; et regnavit Asarhaddon filius eius pro illo et constituit Achicarum filium fratris mei Anael super omnem exactionem regni eius, et ipse habebat potestatem super omnem regionem."
,"22":"Tunc petiit Achicarus pro me, et descendi in Nineven. Achicarus enim erat praepositus pincernarum et super anulum et procurator et exactor sub Sennacherib rege Assyriorum; et constituit illum Asarhaddon. Erat enim ex fratribus meis et ex cognatione mea."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et sub Asarhaddon rege de scendi in domum meam, et red dita est mihi uxor mea Anna et filius meus Thobias. In Pentecoste, die festo nostro, qui est sanctus a Septimanis, factum est mihi prandium bonum, et discubui, ut pranderem."
,"2":"Et apposita est mihi mensa, et vidi pulmentaria complura. Et dixi Thobiae filio meo: ' Vade et, quemcumque pauperem inveneris ex fratribus nostris, qui sunt captivi in Nineve, qui in mente habet Dominum in toto corde suo, hunc adduc, et manducabit pariter mecum; ecce sustineo te, fili, donec venias '."
,"3":"Et abiit Thobias quaerere aliquem pauperem ex fratribus nostris et reversus dixit mihi: ' Pater! '. Et ego dixi illi: ' Ecce ego, fili '. Et respondens ait: ' Ecce unus ex natione nostra occisus est et proiectus est in foro et nunc ibidem laqueo suffocatus est '."
,"4":"Et exsiliens reliqui prandium, antequam ex illo gustarem, et sustuli eum de platea in unam domum, donec sol caderet, et illum sepelirem."
,"5":"Et reversus lavi et manducavi panem meum cum luctu"
,"6":"et rememoratus sum sermonis prophetae Amos, quem locutus est in Bethel dicens: ' Convertentur omnes dies festi vestri in luctum, et omnia cantica vestra in lamentationem '."
,"7":"Et lacrimatus sum. Et, postquam sol occidit, abii et fodiens sepelivi illum."
,"8":"Et proximi mei deridebant me dicentes: ' Non timet adhuc hic homo; iam enim inquisitus est huius rei causa, ut occideretur, et fugit et ecce iterum sepelit mortuos '."
,"9":"Et lavi ea nocte, postquam illum sepelivi, et introivi in atrium meum et obdormivi circa parietem atrii, et facies mea nuda erat propter aestum."
,"10":"Et ignorabam quoniam passeres in pariete super me erant, quorum stercora insederunt in oculos meos calida et induxerunt albugines. Et ibam ad medicos, ut curarer, et, quanto inunxerunt me medicamentis, tanto magis oculi mei excaecabantur maculis, donec perexcaecatus sum. Et eram inutilis meis oculis annis quattuor, et omnes fratres mei dolebant pro me. Achicarus autem pascebat me annis duobus, priusquam iret in Elymaida."
,"11":"In illo tempore Anna uxor mea mercede deserviebat operibus mulierum lanam faciens."
,"12":"Et remittebat dominis eorum, et dabant ei mercedem. Septima autem die mensis Dystri detexuit texturam et reddidit illam dominis, et dederunt ei mercedem totam et dederunt ei pro textura haedum de capris."
,"13":"Et cum introisset ad me haedus, coepit clamare. Et vocavi eam et dixi: ' Unde est hic haedus? Ne forte furtivus sit, redde illum dominis suis; nobis enim non licet manducare quidquam furtivum '."
,"14":"Et illa mihi dixit: ' Munere mihi datus est supra mercedem '. Et ego non credebam ei, sed dicebam, ut restitueret illum dominis, et erubescebam coram illa huius rei causa. Et respondens dixit mihi: ' Et ubi sunt eleemosynae tuae? Ubi sunt iustitiae tuae? Ecce, omnia tibi nota sunt '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et contristatus animo et suspirans ploravi et coepi orare cum gemitibus:"
,"2":"' Iustus es, Domine, et omnia opera tua iusta sunt, et omnes viae tuae misericordia et veritas, et tu iudicas saeculum."
,"3":"Et nunc, Domine, memor esto mei et respice in me; ne vindictam sumas de me pro peccatis meis et pro neglegentiis meis et parentum meorum, quibus peccaverunt ante te,"
,"4":"quoniam non oboedivimus praeceptis tuis, et tradidisti nos in direptionem et captivitatem et mortem et in parabolam et fabulam et improperium in omnibus nationibus, in quas nos dispersisti."
,"5":"Et nunc multa sunt iudicia tua vera, quae de me exigas pro peccatis meis et parentum meorum, quia non egimus secundum praecepta tua et non ambulavimus sinceriter coram te."
,"6":"Et nunc secundum quod tibi placet fac mecum et praecipe recipi spiritum meum, ut dimittar a facie terrae et fiam terra, quia expedit mihi mori magis quam vivere, quoniam improperia falsa audivi, et tristitia multa est in me. Praecipe, Domine, ut dimittar ab hac necessitate, et dimitte me in locum aeternum et noli avertere a me faciem tuam, Domine, quia expedit mihi mori magis quam videre tantam necessitatem in vita mea, et ne improperia audiam '."
,"7":"Eadem die contigit Sarae filiae Raguel, qui erat Ecbatanis Mediae, ut et ipsa audiret improperia ab una ex ancillis patris sui,"
,"8":"quoniam tradita erat viris septem, et Asmodeus daemonium nequissimum occidebat eos, antequam cum illa fierent, sicut est solitum mulieribus. Et dixit illi ancilla: ' Tu es, quae suffocas viros tuos! Ecce, iam tradita es viris septem, et nemine eorum fruita es."
,"9":"Quid nos flagellas causa virorum tuorum, quia mortui sunt? Vade cum illis, nec ex te videamus filium aut filiam in perpetuum '."
,"10":"In illa die contristata est animo puella et lacrimata est et ascendens in superiorem locum patris sui voluit laqueo se suspendere. Et cogitavit iterum et dixit: ' Ne forte improperent patri meo et dicant: 'Unicam habuisti filiam carissimam, et haec laqueo se suspendit ex malis'; et deducam senectam patris mei cum tristitia ad inferos. Utilius mihi est non me laqueo suspendere, sed deprecari Dominum, ut moriar et iam improperia non audiam in vita mea '."
,"11":"Eodem tempore, porrectis manibus ad fenestram, deprecata est et dixit: ' Benedictus es, Domine, Deus misericors, et benedictum est nomen tuum sanctum et honorabile in saecula. Benedicant tibi omnia opera tua in aeternum."
,"12":"Et nunc, Domine, ad te faciem meam et oculos meos direxi."
,"13":"Iube me dimitti desuper terram, et ne audiam iam improperia."
,"14":"Tu scis, Domine, quoniam munda sum ab omni immunditia viri"
,"15":"et non coinquinavi nomen meum neque nomen patris mei in terra captivitatis meae. Unica sum patri meo, et non habet alium filium, qui possideat hereditatem illius, neque frater est illi proximus neque propinquus illi, ut custodiam me illi uxorem. Iam perierunt mihi septem, et ut quid mihi adhuc vivere? Et si non tibi videtur, Domine, occidere me, impera, ut respiciatur in me et misereatur mei, et ne iam improperium audiam '."
,"16":"In ipso tempore exaudita est oratio amborum in conspectu claritatis Dei,"
,"17":"et missus est Raphael angelus sanare duos, Thobin desquamare ab albuginibus oculorum eius, ut videret oculis lumen Dei, et Saram filiam Raguel dare Thobiae filio Thobis uxorem, et colligare Asmodeum daemonium nequissimum, quoniam Thobiae contigit possidere eam prae omnibus, qui volebant accipere eam. In illo tempore reversus est Thobi de atrio in domum suam; et Sara filia Raguel descendit et ipsa de loco superiori."
}`)
	CurrentBook.AddChapter(4, `{
"1":"In illa die rememoratus est Thobi pecuniae, quam com mendaverat Gabael in Rages Mediae."
,"2":"Et dixit in corde suo: ' Ecce ego postulavi mortem. Quid non voco Thobiam filium meum et indicabo illi de hac pecunia, quam commendavi, antequam moriar? '."
,"3":"Et vocavit Thobiam filium suum, et venit ad illum; et dixit illi: ' Fili, cum mortuus fuero, sepeli me diligenter et honorem habe matri tuae et noli derelinquere illam omnibus diebus vitae suae et fac, quod bonum est in conspectu eius, et noli contristare spiritum eius in ullo."
,"4":"Memor esto eius, fili, quoniam multa pericula vidit propter te in utero. Cum mortua fuerit, sepeli illam iuxta me in uno sepulcro."
,"5":"Et omnibus diebus tuis, fili, Dominum in mente habe et noli velle peccare et praeterire praecepta illius. Iustitiam fac omnibus diebus vitae tuae et noli ire in vias iniquitatis,"
,"6":"quoniam, agente te veritatem, prospera erunt itinera in operibus tuis et in omnibus, qui faciunt iustitiam."
,"7":"Ex substantia tua, fili, fac eleemosynam et noli avertere faciem tuam ab ullo paupere, ne a te avertatur facies Dei."
,"8":"Quomodo habueris, fili, secundum multitudinem fac ex ipsis eleemosynam. Si tibi fuerit largior substantia, plus ex illa fac eleemosynam. Si exiguum habueris, secundum exiguum ne timueris facere eleemosynam:"
,"9":"praemium enim bonum reponis tibi in diem necessitatis,"
,"10":"quoniam eleemosyna a morte liberat et non sinit ire in tenebras."
,"11":"Munus enim bonum est eleemosyna omnibus, qui faciunt illam coram Excelso."
,"12":"Attende tibi, fili, ab omni fornicatione. Uxorem primum accipe ex semine parentum tuorum et noli sumere uxorem alienam, quae non est ex tribu patris tui, quoniam filii prophetarum sumus: Noe et Abraham et Isaac et Iacob patres nostri a saeculo. Rememorare, fili, quoniam hi omnes acceperunt uxores ex semine patrum suorum et benedicti sunt in filiis suis, et semen illorum possidebit hereditatem terrae."
,"13":"Et tu, fili, dilige fratres tuos et noli fastidire in corde tuo a fratribus tuis et a filiis et filiabus populi tui, ut accipias uxorem ex illis, quoniam in fastidio perditio et inconstantia magna est, et in nugacitate diminutio et exiguitas magna est. Nugacitas enim mater est famis."
,"14":"Merces omnis hominis, quicumque penes te operatus fuerit, non maneat penes te, sed redde ei statim, et merces tua non minorabitur; si servieris Deo in veritate, reddetur tibi. Attende tibi, fili, in omnibus operibus tuis et esto sapiens in omnibus sermonibus tuis"
,"15":"et, quod oderis, nemini feceris. Noli bibere vinum in ebrietatem, et non comitetur te ebrietas in via tua."
,"16":"De pane tuo communica esurienti et de vestimentis tuis nudis; ex omnibus, quaecumque tibi abundaverint, fac eleemosynam, et non invideat oculus tuus, cum facis eleemosynam."
,"17":"Frange panem tuum et effunde vinum tuum super sepulcra iustorum et noli dare peccatoribus."
,"18":"Consilium ab omni sapiente inquire et noli contemnere omne consilium utile."
,"19":"Omni tempore benedic Dominum et postula ab illo, ut dirigantur viae tuae, et omnes semitae tuae et consilia bene disponantur, quoniam omnes gentes non habent consilium bonum, sed ipse Dominus dabit ipsis bonum consilium. Quem enim voluerit, allevat et, quem voluerit, Dominus demergit usque ad inferos deorsum. Et nunc, fili, memor esto praeceptorum meorum, et non deleantur de corde tuo."
,"20":"Et nunc, fili, indico tibi commendasse me decem talenta argenti Gabael filio Gabriae in Rages Mediae."
,"21":"Noli vereri, fili, quia pauperem vitam gessimus. Habes multa bona, si timueris Deum et recesseris ab omni peccato et bene egeris in conspectu Domini Dei tui '."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tunc Thobias respondens Thobi patri suo dixit: ' Omnia, quaecumque mihi praecepisti, pater, faciam."
,"2":"Quomodo autem potero hanc pecuniam recipere ab illo? Neque ille me novit, neque ego novi illum. Quod signum dabo illi, ut me cognoscat et credat et det mihi hanc pecuniam? Sed neque vias, quae ad Mediam, novi, ut eam illuc '."
,"3":"Tunc respondens Thobi Thobiae filio suo dixit: ' Chirographum dedit mihi, et chirographum meum dedi illi et divisi in duas partes, et unusquisque unam accepimus, et posui cum ipsa pecunia. Et ecce nunc anni sunt viginti, ex quibus penes illum commendavi hanc pecuniam. Et nunc, fili, inquire tibi hominem fidelem, qui eat tecum, et dabimus illi mercedem, donec venias. Et, dum vivo, recipe pecuniam ab illo '."
,"4":"Et exiit Thobias quaerere hominem, qui iret cum ipso in Mediam et qui haberet notitiam viae. Et invenit Raphael angelum stantem ante ipsum et nesciebat illum angelum Dei esse."
,"5":"Et dixit illi: ' Unde es, iuvenis? '. Et dixit illi: ' Ex filiis Israel fratribus tuis et veni huc, ut operer '. Et dixit illi Thobias: ' Nosti viam, quae ducit in Mediam? '."
,"6":"Et ille dixit: ' Utique, aliquotiens fui ibi et habeo notitiam et scio omnes vias et aliquotiens ibam in Mediam et manebam penes Gabael fratrem nostrum, qui commoratur in Rages Mediae, et abest iter bidui statuti ex Ecbatanis usque Rages. Nam posita est in monte et Ecbatana in medio campo '."
,"7":"Et dixit illi Thobias: ' Sustine me, iuvenis, donec intrans patri meo nuntiem. Necessarium est enim mihi, ut eas mecum, et dabo tibi mercedem tuam '."
,"8":"Et dixit illi: ' Ecce sustineo; tantum noli tardare '."
,"9":"Et introiens Thobias renuntiavit Thobi patri suo et dixit ei: ' Ecce inveni hominem ex fratribus nostris, de filiis Israel, qui eat mecum '. Et dixit illi: ' Roga mihi hominem, ut sciam quid sit genus eius, et ex qua tribu sit et an fidelis sit, ut eat tecum, fili '."
,"10":"Et exivit Thobias et vocavit illum et dixit ei: ' Iuvenis, pater te rogat '. Et introivit ad eum, et prior Thobis salutavit eum. Et ille dixit ei: ' Gaudium tibi magnum sit! '. Et respondens Thobi dixit illi: 'Quid mihi adhuc gaudium est? Homo sum inutilis oculis et non video lumen caelorum, sed in tenebris positus sum sicut mortui, qui non amplius vident lumen. Vivus ego sum inter mortuos. Vocem hominum audio et ipsos non video '. Et dixit ei: ' Forti esto animo; in proximo est, ut a Deo cureris. Forti animo esto! '. Et respondit illi Thobi: ' Thobias filius meus vult ire in Mediam. Nonne poteris ire cum illo et ducere illum? Et dabo tibi mercedem tuam, frater '. Et dixit illi: ' Potero ire cum illo, quoniam novi omnes vias et aliquotiens ivi in Mediam et perambulavi omnes campos eius et montes et omnes commeatus scio '."
,"11":"Et dixit ei: ' Frater, ex qua patria es et ex qua tribu? Narra mihi, frater '."
,"12":"Et ille dixit: ' Quid tibi necesse est tribus? '. Et dixit ei: ' Volo scire ex veritate cuius sis et nomen tuum '."
,"13":"Et dixit: ' Ego sum Azarias Ananiae magni filius, ex fratribus tuis '."
,"14":"Et dixit illi Thobi: ' Salvus et sanus venias, frater, sed ne irascaris, frater, quod voluerim verum scire et patriam tuam. Tu frater meus es et de genere bono et optimo! Noveram Ananiam et Nathan duos filios Semeliae magni; et ipsi mecum ibant in Ierusalem et adorabant ibi mecum et non exerraverunt. Fratres tui viri optimi sunt; ex bona radice es. Et gaudens venias! '."
,"15":"Et dixit ei: ' Ego tibi dabo mercedis nomine drachmam diurnam et, quaecumque necessaria sunt tibi et filio meo, similiter; et vade cum illo,"
,"16":"et adiciam tibi ad mercedem '."
,"17":"Et dixit illi: ' Ibo cum illo, ne timueris; salvi ibimus et salvi revertemur ad te, quoniam via tuta est '. Et dixit ei: ' Benedictio sit tibi, frater! '. Et vocavit filium suum et dixit illi: ' Fili, praepara, quae ad viam, et exi cum fratre tuo. Deus autem, qui in caelo est, protegat vos ibi et reducat vos ad me salvos; et angelus illius comitetur vos cum sanitate, fili! '. Et exiit, ut iret viam suam, et osculatus est patrem suum et matrem. Et dixit illi Thobi: ' Vade sanus! '. "
,"18":"Et lacrimata est mater illius et dixit Thobi: ' Quid dimisisti filium meum? Nonne ipse est virga manus nostrae et ipse intrat et exit coram nobis?"
,"19":"Pecunia ne adveniat pecuniae, sed purgamentum sit filii nostri."
,"20":"Quomodo datum est nos a Domino vivere, hoc sufficiebat nobis '."
,"21":"Et dixit illi: ' Noli computare; salvus ibit filius noster et salvus revertetur ad nos, et oculi tui videbunt eum illa die, qua venerit ad te sanus. Ne computaveris, ne timueris de illis, soror."
,"22":"Angelus enim bonus ibit cum illo, et bene disponetur via illius, et revertetur sanus '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et cessavit plorare."
,"2":"Et profectus est puer et angelus cum illo; et canis exiit cum illo et secutus est eos. Et abierunt ambo, et comprehendit illos prima nox; et manserunt super flumen Tigrin."
,"3":"Et descendit puer lavare pedes in flumen, et exsiliens piscis de aqua magnus volebat gluttire pedem pueri, et exclamavit."
,"4":"Et ait illi angelus: ' Comprehende et tene! '. Et comprehendit puer piscem et eduxit illum in terram."
,"5":"Et dixit angelus illi: ' Exintera hunc piscem et tolle fel et cor et iecur illius et repone ea tecum et interanea proice. Sunt enim fel et cor et iecur eius ad medicamentum utilia '."
,"6":"Et exinterans puer piscem illum collegit fel, cor et iecur; et piscem assavit et manducavit et reliquit ex illo salitum. Et abierunt ambo pariter, donec appropinquarent ad Mediam."
,"7":"Et tunc interrogavit puer angelum et dixit ei: ' Azaria frater, quod remedium est in corde et iecore piscis et in felle? '."
,"8":"Et dixit illi: ' Cor et iecur piscis fumiga coram viro aut muliere, qui occursum daemonii aut spiritus nequissimi habet, et fugiet ab illo omnis occursus, et ne maneant cum illo in aeternum."
,"9":"Et fel ad inungendos oculos hominis, in quos ascenderunt albugines, ad flandum in ipsis super albugines, et ad sanitatem perveniunt '."
,"10":"Et postquam intravit in Mediam et iam appropinquabat ad Ecbatana,"
,"11":"dixit Raphael puero: ' Thobia frater! '. Et dixit ei: ' Ecce ego '. Et dixit illi: ' In eis, quae sunt Raguel, hac nocte manere nos oportet. Et homo est propinquus tuus et habet filiam nomine Saram,"
,"12":"sed neque masculum neque filiam aliam praeter Saram solam habet, et tu proximus es illius prae omnibus hominibus, ut possideas eam; et iustum est, ut possideas, quae sunt patri eius. Et haec puella sapiens et fortis et bona valde, et pater ipsius diligit illam '."
,"13":"Et dixit: ' Iustum est, ut accipias illam. Et audi me, frater, et loquar de puella hac nocte, ut accipiamus illam tibi uxorem et, cum reversi fuerimus ex Rages, faciemus nuptias eius. Scio autem quoniam Raguel non potest denegare illam tibi. Novit enim quia, si dederit illam viro alteri, morte periet, secundum iudicium libri Moysis, quia tibi aptum est accipere hereditatem et filiam illius magis quam omni homini. Et nunc, frater, audi me, et loquemur de hac puella hac nocte et desponsabimus illam tibi et, cum reversi fuerimus ex Rages, accipiemus illam et ducemus eam nobiscum in domum tuam '."
,"14":"Tunc respondens Thobias dixit Raphael: ' Azaria frater, audivi quoniam iam tradita est viris septem, et mortui sunt in cubiculis suis noctu; cum intrabant ad illam, moriebantur. Audivi etiam quosdam dicentes quoniam daemonium illos occidit;"
,"15":"et timeo nunc, quoniam diligit illam et ipsam quidem non vexat, sed eum, qui illi voluerit propinquare, ipsum occidit. Unicus sum patri meo; ne forte moriar et deducam patris mei vitam et matris meae cum dolore super me in sepulcrum eorum. Sed neque alium filium habent, qui sepeliat illos '."
,"16":"Et dixit illi angelus: ' Non es memor mandatorum patris tui, quoniam praecepit tibi accipere uxorem ex domo patris tui? Et nunc audi me, frater: noli computare daemonium illud, sed accipe illam, et scio quoniam dabitur tibi hac nocte uxor."
,"17":"Et, cum intraveris in cubiculum, tolle de iecore piscis et cor et impone super cinerem incensi. Et odor manabit, et odorabitur illud daemonium et fugiet et non apparebit circa illam omnino in perpetuo."
,"18":"Et, cum coeperis esse cum illa, surgite primum ambo et orate et deprecamini Dominum caeli, ut detur vobis misericordia et sanitas. Noli timere; tibi enim destinata est ante saeculum, et tu illam sanabis, et ibit tecum, et credo quoniam habebis ex illa filios, et erunt tibi sicut fratres. Noli computare '. Et cum audisset Thobias sermones Raphael quoniam soror est illius et de semine patris illius, dilexit eam valde, et cor eius haesit illi."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Et cum venisset in Ecbatana, dixit illi: ' Azaria frater, duc me ad Raguel, fratrem nostrum, viam rectam '. Et duxit eum ad domum Raguel, et invenerunt illum sedentem circa ostium atrii sui et salutaverunt illum priores. Et ille dixit eis: ' Bene valeatis, fratres, intrate salvi et sani '. Et induxit eos in domum suam."
,"2":"Et dixit Ednae uxori suae: ' Quam similis est hic iuvenis Thobi fratri meo! '."
,"3":"Et interrogavit illos Edna et dixit eis: 'Unde estis, fratres? '. Et dixerunt illi: ' Ex filiis Nephthali nos sumus captivis in Nineve '."
,"4":"Et dixit eis: ' Nostis Thobin fratrem nostrum? '. Et dixerunt ei: ' Novimus illum '. Et dixit eis: ' Fortis est? '."
,"5":"Et dixerunt illi: ' Fortis est et vivit '. Et Thobias dixit: ' Pater meus est '."
,"6":"Et exsilivit Raguel et osculatus est illum lacrimans"
,"7":"et dixit: ' Benedictio tibi sit, fili, boni et optimi patris fili. O infelicitas malorum, quia excaecatus est vir iustus et faciens eleemosynas! '. Et incubuit lacrimans super collum Thobiae filii fratris sui."
,"8":"Et Edna uxor eius lacrimata est super eum, et Sara filia eorum lacrimata est et ipsa."
,"9":"Et occidit arietem ex ovibus et suscepit illos libenter. Et, postquam laverunt et se purificaverunt et discubuerunt ad cenandum, dixit Thobias ad Raphael: ' Azaria frater, dic Raguel, ut det mihi Saram sororem meam '."
,"10":"Et audivit Raguel hunc sermonem et dixit puero: ' Manduca et bibe et suaviter tibi sit hac nocte. Non est enim homo, quem oporteat accipere Saram filiam meam nisi tu, frater. Similiter et mihi non licet eam dare alii viro nisi tibi, quia tu proximus mihi es. Verum autem tibi dicam, fili."
,"11":"Tradidi illam viris septem fratribus nostris, et omnes mortui sunt nocte, cum intrabant ad eam. Et nunc, fili, manduca et bibe, et Dominus faciet in vobis '. Et dixit Thobias: ' Hinc non edam neque bibam, donec, quae sunt ad me, confirmes '. Et Raguel dixit ei: ' Facio; et ipsa datur tibi secundum iudicium libri Moysis, et de caelo iudicatum est tibi illam dari. Duc sororem tuam; amodo tu illius frater es, et haec tua soror est. Datur tibi ex hodierno et in aeternum. Et Dominus caeli bene disponat vobis, fili, hac nocte et faciat misericordiam et pacem '."
,"12":"Et accersivit Raguel Saram filiam suam, et accessit ad illum. Et, apprehensa manu illius, tradidit eam illi et dixit: ' Duc secundum legem et iudicium, quod scriptum est in libro Moysis dari tibi uxorem. Habe et duc ad patrem tuum sanus. Et Deus caeli det vobis bonum iter et pacem '."
,"13":"Et vocavit matrem eius et praecepit afferri chartam, ut faceret conscriptionem coniugii et quemadmodum tradidit illam uxorem ei secundum iudicium legis Moysis. Et attulit mater illius chartam, et ille scripsit et signavit."
,"14":"Et ex illa hora coeperunt manducare et bibere."
,"15":"Et vocavit Raguel Ednam uxorem suam et dixit illi: ' Soror, praepara cubiculum aliud et introduc eam illuc '."
,"16":"Et abiens stravit, sicut illi dixit, et introduxit eam illuc et lacrimata est causa illius et extersit lacrimas et dixit illi:"
,"17":"' Forti animo esto, filia. Dominus caeli det tibi gaudium pro taedio tuo. Forti animo esto! '. Et exiit."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Et, cum consummaverunt man ducare et bibere, voluerunt dor mire et deduxerunt iuvenem et induxerunt eum in cubiculum."
,"2":"Et rememoratus est Thobias sermonum Raphael et sustulit de saccello, quem habebat, cor et iecur piscis et imposuit super cinerem incensi."
,"3":"Et odor piscis prohibuit et refugit daemonium in superiores partes Aegypti. Et abiens Raphael colligavit eum ibi et reversus est continuo."
,"4":"Et exierunt et clauserunt ostium cubiculi. Et exsurrexit Thobias de lecto et dixit ei: ' Surge, soror! Oremus et deprecemur Dominum nostrum, ut faciat super nos misericordiam et sanitatem '."
,"5":"Et surrexit, et coeperunt orare et deprecari Dominum, ut daretur illis sanitas. Et coeperunt dicere: ' Benedictus es, Deus patrum nostrorum, et benedictum nomen tuum in omnia saecula saeculorum! Benedicant tibi caeli et omnis creatura tua in omnia saecula!"
,"6":"Tu fecisti Adam et dedisti illi adiutorium firmum Evam, et ex ambobus factum est semen hominum. Et dixisti non esse bonum hominem solum: 'Faciamus ei adiutorium simile sibi'."
,"7":"Et nunc non luxuriae causa accipio hanc sororem meam sed in veritate. Praecipe, ut miserearis mei et illius, et consenescamus pariter sani '."
,"8":"Et dixerunt: ' Amen, amen! '."
,"9":"Et dormierunt per noctem. Et surgens Raguel accersivit servos secum, et abierunt et foderunt foveam. "
,"10":"Dixit enim: ' Ne forte moriatur, et omnibus simus derisio et opprobrium '."
,"11":"Et, ut consummaverunt fossuram, reversus est Raguel domum et vocavit uxorem suam"
,"12":"et dixit: ' Mitte unam ex ancillis, et intrans videat an vivat; et, si mortuus est, ut sepeliamus illum, nemine sciente '."
,"13":"Et miserunt ancillam et accenderunt lucernam et aperuerunt ostium, et intravit et invenit illos iacentes et pariter dormientes."
,"14":"Et reversa puella nuntiavit eis illum vivere et nihil mali esse."
,"15":"Et benedixerunt Deum caeli et dixerunt: ' Benedictus es, Deus, in omni benedictione sancta et munda, et benedicant tibi omnes sancti tui et omnis creatura tua; et omnes angeli tui et electi tui benedicant tibi in omnia saecula!"
,"16":"Benedictus es, quoniam laetificasti me, et non contigit mihi, sicut putabam, sed secundum magnam misericordiam tuam egisti nobiscum."
,"17":"Et benedictus es, quoniam misertus es duorum unicorum. Fac illis, Domine, misericordiam et sanitatem et consumma vitam illorum cum misericordia et laetitia '."
,"18":"Tunc praecepit servis suis, ut replerent fossam priusquam lucesceret."
,"19":"Et praecepit uxori suae, ut faceret panes multos; et abiens ipse ad gregem adduxit vaccas duas et quattuor arietes et iussit consummari eos, et coeperunt praeparare."
,"20":"Et vocavit Thobiam et iuravit illi et dixit ei: ' Diebus quattuordecim hinc non recedes, sed hic manebis, manducans et bibens mecum, et laetificabis animam filiae meae multis afflictam doloribus."
,"21":"Et ex eo, quod possideo, accipe partem dimidiam et vade sanus ad patrem tuum. Et alia dimidia pars, cum mortui fuerimus ego et uxor mea, vestra erit. Forti animo esto, fili! Ego pater tuus sum et Edna mater tua; et tui sumus nos et sororis tuae amodo et in perpetuum. Forti animo esto, fili! '."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Tunc accersivit Thobias Ra phael et dixit illi:"
,"2":"' Azaria fra ter, adsume tecum hinc servos quattuor et camelos duos et perveni in Rages et vade ad Gabael et da illi chirographum et recipe pecuniam et adduc illum tecum ad nuptias."
,"3":"Scis enim quoniam numerat dies pater et, si tardavero diem unum, contristabo eum valde."
,"4":"Sed vides quomodo Raguel iuraverit, cuius iuramentum spernere non possum '."
,"5":"Et abiit Raphael et quattuor pueri et duo cameli in Rages Mediae, et manserunt penes Gabael, et dedit illi Raphael chirographum eius et indicavit illi de Thobia filio Thobis quoniam accepit uxorem filiam Raguel et quia rogat illum ad nuptias. Et surrexit Gabael et protulit folles cum sigillis suis et numeravit pecuniam et composuit supra camelos."
,"6":"Et vigilaverunt simul et venerunt ad nuptias et intraverunt in ea, quae Raguel, et invenerunt Thobiam discumbentem. Et exsiliit et salutavit illum et lacrimatus est et benedixit eum et dixit illi Gabael: ' Benedictus Dominus, qui dedit tibi pacem, quoniam boni et optimi et iusti viri et eleemosynas facientis filius es! Det tibi benedictionem Dominus caeli et uxori tuae et patri tuo et matri tuae et patri et matri uxoris tuae. Et benedictus Deus, quoniam video Thobiam consobrinum meum similem illi! '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Et cotidie ex illo die computabat Thobi dies, in quibus iret et in quibus reverteretur filius eius. Et, postquam consummati sunt dies, et filius eius non veniebat,"
,"2":"dixit: ' Numquid detentus est ibi? Aut numquid Gabael mortuus est, et nemo illi reddit pecuniam? '."
,"3":"Et contristari coepit."
,"4":"Et Anna uxor illius dixit: ' Periit filius meus et iam non est inter vivos. Quare tardat? '. Et coepit plorare et lugere filium suum et dixit:"
,"5":"' Vae mihi, fili, quia te dimisi ire, lumen oculorum meorum! '."
,"6":"Cui Thobi dicebat: ' Tace, noli computare, soror; salvus est filius noster, sed certe mora fuit illis ibi, et homo, qui cum illo ivit, fidelis est et est ex fratribus nostris. Noli taediare pro illo, soror, iam veniet '."
,"7":"Et illa dixit: ' Tace a me; noli me seducere! Periit filius meus '. Et exsiliens circumspiciebat cotidie viam, qua filius eius profectus erat, et nihil gustabat; et, cum occidisset sol, introibat et lugebat lacrimans tota nocte et non dormiebat. Et, ut consummati sunt quattuordecim dies nuptiarum, quos iuraverat Raguel facere filiae suae, exiit ad illum Thobias et dixit: ' Dimitte me. Scio enim quia pater meus et mater mea non credunt se adhuc visuros me. Nunc itaque peto, pater, ut dimittas me, et eam ad patrem meum; iam tibi indicavi quomodo illum reliquerim '. "
,"8":"Et dixit Raguel Thobiae: ' Remane, fili, remane penes me, et ego nuntios mitto ad Thobin patrem tuum, et indicabunt illi de te '."
,"9":"Et dixit illi: ' Minime; peto, ut dimittas me hinc ad patrem meum '."
,"10":"Et surgens Raguel tradidit Thobiae Saram uxorem eius et dimidiam partem substantiae suae, pueros et puellas, oves et boves, asinos et camelos, vestem et pecuniam et vasa."
,"11":"Et dimisit illos et vale illi fecit et dixit illi: ' Sanus sis, fili, et vade sanus! Dominus caeli bene dirigat vias vestras; et videam ex vobis filios, antequam moriar '."
,"12":"Et osculatus est Saram filiam suam et dixit illi: ' Filia, honorem habe socero tuo et socrui tuae, quia ipsi amodo sunt parentes tui tamquam hi qui te genuerunt. Vade in pacem, filia! Audiam de te auditionem bonam in vita mea '. Et osculatus est eam et dimisit illos. Et Edna dixit Thobiae: ' Fili et frater dilecte, te restituat Dominus caeli, et videam filios tuos et Sarae filiae meae, antequam moriar, ut delecter coram Domino. Ego trado tibi filiam meam tamquam depositum, ut non vexes eam omnibus diebus vitae tuae. Vade, fili, in pacem. Ego mater tua amodo, et Sara soror tua. Bene dirigamur omnes in ipso omnibus diebus vitae nostrae '. Et osculata est ambos et dimisit illos sanos."
,"13":"Et discessit Thobias a Raguel gaudens et benedicens Dominum caeli et terrae, regem omnium, quia direxerat viam eius. Et benedixit Raguel et Ednae uxori eius et dixit eis: ' Fiat mihi honorare vos tamquam parentes meos omnibus diebus vitae vestrae '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et abierunt viam suam et pervenerunt Charran, quae est contra Nineven."
,"2":"Tunc dixit Raphael: ' Scis quomodo dereliquerimus patrem tuum."
,"3":"Praecedamus uxorem tuam et praeparemus domum, dum veniunt '."
,"4":"Et processerunt ambo pariter. Et dixit illi: ' Tolle tecum fel '. Et abiit cum illis canis ex eis, qui sequebantur eum et Thobiam."
,"5":"Et Anna sedebat circumspiciens viam filii sui."
,"6":"Et cognovit illum venientem et dixit patri eius: ' Ecce filius tuus venit et homo, qui cum illo ierat '."
,"7":"Et Raphael dixit Thobiae, antequam appropinquaret patri: ' Scio quia oculi eius aperientur."
,"8":"Asperge fel piscis in oculis eius; et detrahet medicamentum et decoriabit albugines de oculis eius. Et respiciet pater tuus et videbit lumen '."
,"9":"Et occurrit ei Anna et irruit collo filii sui et dixit illi: ' Fili, video te; amodo moriar! '. Et lacrimata est."
,"10":"Et surrexit Thobi et offendebat pedibus et egressus est ad ostium atrii. Et occurrit illi Thobias,"
,"11":"et fel piscis in manu sua, et insufflavit in oculis illius et apprehendit illum et dixit: ' Forti animo esto, pater! '. Et iniecit medicamentum super eum et imposuit."
,"12":"Et decoriavit duabus manibus suis albugines ab angulis oculorum illius."
,"13":"Et videns filium suum irruit collo eius"
,"14":"et lacrimatus est et dixit ei: ' Video te, fili, lumen oculorum meorum! '. Et dixit: ' Benedictus Deus, et benedictum nomen illius magnum, et benedicti omnes sancti angeli eius in omnia saecula,"
,"15":"quoniam ipse flagellavit me, et ecce ego video Thobiam filium meum! '. Et introivit Thobi et Anna uxor eius in domum gaudentes et benedicentes Deum toto ore suo pro omnibus, quae sibi evenerant. Et indicavit patri suo Thobias, quoniam perfecta erat via illius bene a Domino Deo, et quia attulerat pecuniam et quemadmodum acceperat Saram filiam Raguel uxorem, et quia ecce venit et ipsa in proximo est portae Nineves. Et gavisi sunt Thobi et Anna"
,"16":"et exierunt in obviam nurui suae ad portam Nineves. Et videntes Thobin, qui erant in Nineve, venientem et ambulantem cum omni virtute sua et a nemine manu deductum mirabantur,"
,"17":"et confitebatur Thobi et benedicebat magna voce Deum coram illis, quoniam misertus est illius Deus et aperuit oculos eius. Et appropinquavit Thobi ad Saram uxorem Thobiae filii sui et benedixit illi et dixit ei: ' Intres sana, filia! Et benedictus Deus tuus, qui adduxit te ad nos, filia! Et benedictus pater tuus et benedictus Thobias filius meus et benedicta tu, filia! Intra in domum tuam sana in benedictione et gaudio; intra, filia! '. In illo die factum est gaudium omnibus Iudaeis, qui erant in Nineve."
,"18":"Et venerunt Achicarus et Nadab ex fratribus illius gaudentes ad Thobiam. Et consummatae sunt nuptiae cum gaudio septem diebus, et data sunt illi munera multa."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Et, postquam consummatae sunt nuptiae, vocavit Thobi filium suum Thobiam et dixit illi: ' Homini illi, qui tecum ivit, reddamus honorem et adiciamus ad mercedem suam '."
,"2":"Et dixit illi: ' Pater, quantam illi dabo mercedem? Non laedor, si dedero illi ex his, quae mecum contulit, dimidiam partem."
,"3":"Duxit me sanum et uxorem meam curavit et pecuniam mecum attulit et te curavit! Quantam illi dabo mercedem adhuc? '."
,"4":"Et dixit illi Thobi: ' Iustum est illum, fili, dimidium omnium horum, quae tecum attulit, accipere '."
,"5":"Et vocavit illum et dixit: ' Accipe dimidium omnium horum, quae tecum attulisti, in mercedem tuam et vade sanus '."
,"6":"Tunc Raphael vocavit ambos abscondite et dixit illis: ' Deum benedicite et illi confitemini coram omnibus viventibus, quae fecit nobiscum bona, ut benedicatis et decantetis nomini eius; sermones Dei honorifice ostendite et ne cunctemini confiteri illi."
,"7":"Sacramentum regis bonum est abscondere, opera autem Dei revelare et confiteri honorificum est. Bonum facite, et malum non inveniet vos."
,"8":"Bona est oratio cum ieiunio, et eleemosyna cum iustitia. Melius est modicum cum iustitia quam plurimum cum iniquitate. Bonum est facere eleemosynam magis quam thesauros auri condere."
,"9":"Eleemosyna a morte liberat et ipsa purgat omne peccatum. Qui faciunt eleemosynam, saturabuntur vita;"
,"10":"qui faciunt peccatum et iniquitatem, hostes sunt animae suae."
,"11":"Omnem veritatem vobis manifestabo et non abscondam a vobis ullum sermonem. Iam demonstravi vobis et dixi: Sacramentum regis bonum est abscondere, opera autem Dei revelare honorificum est."
,"12":"Et nunc, quando orabas tu et Sara, ego obtuli memoriam orationis vestrae in conspectu claritatis Domini; et, cum sepeliebas mortuos, similiter."
,"13":"Et quia non es cunctatus exsurgere et relinquere prandium tuum et abisti et sepelisti mortuum, tunc missus sum ad te tentare te."
,"14":"Et iterum me misit Deus curare te et Saram nurum tuam."
,"15":"Ego sum Raphael, unus ex septem angelis sanctis, qui assistimus et ingredimur ante claritatem Domini '."
,"16":"Et conturbati sunt ambo et ceciderunt in faciem suam et timuerunt."
,"17":"Et dixit illis: ' Nolite timere; pax vobis. Deum benedicite in omne aevum."
,"18":"Cum essem vobiscum, non mea gratia eram vobiscum sed voluntate Dei. Ipsi benedicite omnibus diebus, decantate ei."
,"19":"Et videbatis me quia nihil manducabam, sed visus vobis videbatur."
,"20":"Et nunc benedicite Dominum super terra et confitemini Deo. Ecce ego ascendo ad eum, qui me misit. Scribite omnia haec, quae contigerunt vobis '. Et ascendit."
,"21":"Et surrexerunt et iam non poterant illum videre."
,"22":"Et benedicebant et decantabant Deo et confitebantur illi in omnibus his magnis operibus illius, quia apparuerat illis angelus Dei."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Et scripsit orationem Thobi in laetitiam et dixit:"
,"2":"' Benedictus Deus vivens in aevum, et regnum illius, quia ipse flagellat et miseretur, deducit usque ad inferos deorsum,et reducit a perditione maiestate sua, et non est qui effugiat manum eius. "
,"3":"Confitemini illi, filii Israel, coram nationibus, quia ipse dispersit vos in illis"
,"4":"et ibi ostendit maiestatem suam. Et exaltate illum coram omni vivente, quoniam Dominus noster, et ipse est pater noster, et ipse est Deus noster in omnia saecula."
,"5":"Flagellabit vos ob iniquitates vestras,et omnium miserebitur vestrum,et colliget vos ab omnibus nationibus, ubicumque dispersi fueritis."
,"6":"Cum conversi fueritis ad illum,in toto corde vestro et in tota anima vestra, ut faciatis coram illo veritatem, tunc revertetur ad vos,et non abscondet a vobis faciem suam amplius. Et nunc aspicite, quae fecit vobiscum, et confitemini illi in toto ore vestro. Benedicite Dominum iustitiae,et exaltate regem saeculorum. Ego in terra captivitatis meae confiteor illi,et ostendo virtutem et maiestatem eius genti peccatorum. Convertimini, peccatores, et facite iustitiam coram illo. Quis scit, si velit vos et faciat vobis misericordiam?"
,"7":"Ego et anima mea regi caeli laetationes dicimus, et anima mea laetabitur omnibus diebus vitae suae."
,"8":"Benedicite Dominum, omnes electi; et omnes, laudate maiestatem illius. Agite dies laetitiae et confitemini illi."
,"9":"Ierusalem, civitas sancta, flagellabit te in operibus manuum tuarum."
,"10":"Confitere Domino in bono opere et benedic regem saeculorum, ut iterum tabernaculum tuum aedificetur in te cum gaudio, et laetos faciat in te omnes captivos et diligat in te omnes miseros in omnia saecula saeculorum."
,"11":"Lux splendida fulgebit in omnibus finibus terrae; nationes multae venient tibi ex longinquo,et a novissimis partibus terrae ad nomen sanctum tuum,et munera sua in manibus suis habentes regi caeli. Generationes generationum dabunt in te laetitiam, et nomen electae erit in saecula saeculorum."
,"12":"Maledicti omnes, qui dixerint verbum durum. Maledicti erunt omnes, qui deponunt te,et destruunt muros tuos, et omnes, qui subvertunt turres tuas et qui incendunt habitationes tuas. Et benedicti erunt omnes, qui timent te in aevum."
,"13":"Tunc gaude et laetare in filiis iustorum, quoniam omnes colligentur,et benedicent Domino aeterno."
,"14":"Felices, qui diligunt te, et felices, qui gaudebunt in pace tua. Et beati omnes homines, qui contristabuntur in omnibus flagellis tuis, quoniam in te gaudebunt,et videbunt omne gaudium tuum in aeternum."
,"15":"Anima mea, benedic Domino, regi magno,"
,"16":"quia in Ierusalem civitate aedificabitur,domus illius in omnia saecula. Felix ero, si fuerint reliquiae seminis mei,ad videndam claritatem tuam,et confitendum regi caeli. Ostia Ierusalem sapphiro et smaragdo aedificabuntur, et lapide pretioso omnes muri tui; et turres Ierusalem auro aedificabuntur, et propugnacula eius auro mundo. "
,"17":"Plateae Ierusalem carbunculo sternentur,et lapide Ophir;"
,"18":"et ostia Ierusalem cantica laetitiae dicent, et omnes vici eius loquentur: 'Alleluia. Benedictus Deus Israel, et benedicti, qui benedicent nomen sanctum, in aeternum et adhuc!' '."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Et consummati sunt sermones confessionis Thobis. Et mortuus est in pace annorum centum duodecim et sepultus est praeclare in Nineve. "
,"2":"Sexaginta autem et duorum annorum erat, cum invalidus oculis factus est; et, postquam lucem recepit, vixit in bonis et fecit eleemosynas et proposuit benedicere Deum et confiteri magnitudini Dei."
,"3":"Et, cum moreretur, vocavit Thobiam filium suum et praecepit illi dicens: ' Fili, duc filios tuos"
,"4":"et recurre in Mediam, quoniam credo ego verbo Dei, quod locutus est Nahum in Nineven, quia omnia erunt et venient super Assyriam et Nineven, quae locuti sunt prophetae Israel, quos misit Deus; omnia evenient, nihilque minuetur ex omnibus verbis, sed omnia contingent temporibus suis. Et in Media erit salus magis quam in Assyriis et quam in Babylone, quia scio ego et credo quoniam omnia, quae dixit Deus, erunt. Et perficientur, et non excidet verbum de sermonibus. Et fratres nostri, qui habitant in terra Israel, omnes dispergentur et captivi ducentur a terra optima. Et erit omnis terra Israel deserta, et Samaria et Ierusalem erit deserta, et domus Dei in tristitia erit et incendetur et erit deserta usque in tempus."
,"5":"Et iterum misericordiam faciet illorum Deus et convertetur ad illos Deus in terram Israel, et iterum aedificabunt domum, sed non sicut prius, quoadusque repleatur tempus maledictionum. Et postea revertentur a captivitate sua omnes et aedificabunt Ierusalem honorifice, et domus Dei aedificabitur in ea, sicut locuti sunt de illa omnes prophetae Israel."
,"6":"Et omnes nationes in tota terra convertentur et timebunt Deum vere et relinquent omnes idola sua, quae seducunt false seductione eorum."
,"7":"Et benedicent Deo aeterno in iustitia. Omnes filii Israel, qui liberabuntur in diebus illis, memores Dei in veritate, colligentur et venient in Ierusalem et habitabunt in aeternum in terra Abraham cum tutela, et tradetur eis. Et gaudebunt, qui diligunt Deum in veritate; qui autem faciunt iniquitatem et peccatum, deficient de terris omnibus."
,"8":"Et nunc, filii, mando vobis: Servite Deo in veritate et facite coram illo, quod ipsi placet. Et filiis vestris mandabitur, ut faciant iustitias et eleemosynam et ut sint memores Dei et benedicant nomini ipsius in omni tempore in veritate et in tota virtute sua."
,"9":"Nunc vero, fili, exi a Nineve et noli manere hic,"
,"10":"sed, quocumque die sepelieris matrem tuam circa me, eodem die noli manere in finibus eius. Video enim quia multa iniquitas est in illa, et fictio multa perficitur in illa, et non confunduntur. Vide, fili, quae fecit Nadab Achicaro, qui eum nutrivit. Nonne vivus deductus est in terram? Sed tradidit Deus infamiam ante faciem ipsius, et Achicarus exiit ad lucem, Nadab autem intravit in tenebras aeternas, quia quaesivit occidere Achicarum. Cum faciebat eleemosynam, exiit de laqueo mortis, quem fixerat ei Nadab, et Nadab cecidit in laqueum mortis, et perdidit illum."
,"11":"Et nunc, filii, videte quid faciat eleemosyna, et quid faciat iniquitas, quoniam occidit. Et ecce anima mea deficit! '. Et posuerunt eum super lectum, et mortuus est et sepultus est praeclare."
,"12":"Et, cum mortua est mater eius, Thobias sepelivit eam iuxta patrem suum et abiit ipse et uxor eius in Mediam et habitavit in Ecbatanis cum Raguel socero suo."
,"13":"Et curam habuit senectutis eorum honorifice et sepelivit illos in Ecbatanis Mediae et hereditatem percepit domus Raguel et Thobis patris sui."
,"14":"Et mortuus est annorum centum decem et septem cum claritate."
,"15":"Et, antequam moreretur, vidit et audivit perditionem Nineves et vidit captivitatem illius in Mediam adductam, quam adduxit Asuerus rex Mediae, et benedixit Deum in omnibus, quae fecit filiis Nineves et Assyriae. Et gavisus est, antequam moreretur, in Nineve, et benedixit Dominum Deum in omnia saecula saeculorum."
}`)

}
func LA_NVBSE_LoadVMBRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Et haec verba, quae scripsit Baruch filius Neriae filii Maasiae filii Sedeciae filii Asadei filii Helciae in Babylone,"
,"2":"in anno quinto, in septima die mensis, in tempore quo ceperunt Chaldaei Ierusalem et incenderunt eam igni."
,"3":"Et legit Baruch verba libri huius in aures Iechoniae filii Ioachim regis Iudae et in aures omnis populi venientis ad librum"
,"4":"et in aures potentium et filiorum regum et in aures seniorum et in aures omnis populi a minimo usque ad maximum universorum habitantium in Babylonia, ad flumen Sud."
,"5":"Et flebant et ieiunabant et orabant in conspectu Domini."
,"6":"Et collegerunt argentum, prout poterant manus singulorum,"
,"7":"et miserunt in Ierusalem ad Ioachim filium Helciae filii Salom sacerdotem et ad sacerdotes et ad omnem populum, qui inventi sunt cum illo in Ierusalem,"
,"8":"cum acciperet vasa domus Domini, quae ablata fuerant de templo, ut referret ea in terram Iudae, decima die mensis Sivan: vasa argentea, quae fecit Sedecias filius Iosiae rex Iudae,"
,"9":"postquam adduxit Nabuchodonosor rex Babylonis Iechoniam et principes et inclusores et potentes et populum terrae ex Ierusalem et induxit eos in Babylonem."
,"10":"Et dixerunt: 'Ecce misimus ad vos pecuniam; emite ex ea pecunia holocausta et pro peccato et tus et facite oblationem et afferte super altare Domini Dei nostri;"
,"11":"et orate pro vita Nabuchodonosor regis Babylonis et pro vita Balthasar filii eius, ut sint dies eorum, sicuti sunt dies caeli super terram;"
,"12":"et dabit Dominus virtutem nobis et illuminabit oculos nostros, et vivemus sub umbra Nabuchodonosor regis Babylonis et sub umbra Balthasar filii eius et serviemus eis multis diebus et inveniemus gratiam in conspectu eorum."
,"13":"Et orate pro nobis ad Dominum Deum nostrum, quia peccavimus Domino Deo nostro, et non avertit se indignatio Domini et ira eius a nobis usque in hunc diem."
,"14":"Et legetis librum hunc, quem misimus ad vos recitari in domo Domini, in die sollemni et in diebus constitutis,"
,"15":"et dicetis: Domino Deo nostro iustitia, nobis autem confusio faciei, sicut hodiernus dies homini Iudae et habitatoribus Ierusalem "
,"16":"et regibus nostris et principibus nostris et sacerdotibus nostris et prophetis nostris et patribus nostris:"
,"17":"peccavimus enim ante Dominum et non credidimus ei"
,"18":"et non audivimus vocem Domini Dei nostri, ut ambularemus in mandatis Domini, quae dedit ante faciem nostram."
,"19":"A die qua Dominus eduxit patres nostros de terra Aegypti et usque ad hanc diem eramus contumaces in Dominum Deum nostrum et temere egimus, ne audiremus vocem eius,"
,"20":"et adhaeserunt nobis mala et maledictio, quam constituit Dominus Moysi servo suo in die, qua eduxit patres nostros de terra Aegypti dare nobis terram fluentem lac et mel, sicut hic dies."
,"21":"Et non audivimus vocem Domini Dei nostri secundum omnia verba prophetarum, quos misit ad nos,"
,"22":"et abivimus unusquisque in sensu cordis nostri mali ad serviendum diis alienis, facientes mala sub oculis Dei nostri."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et statuit Dominus verbum suum, quod locutus est super nos et super iudices nostros, qui iudicabant Israel, et super reges nostros et super principes nostros et super omnem hominem Israel et Iudae,"
,"2":"ut induceret super nos mala magna, quae non sunt facta sub omni caelo, secundum quae fecit in Ierusalem, secundum ea quae scripta sunt in lege Moysi,"
,"3":"comedere nos unumquemque carnes filii sui et unumquemque carnes filiae suae."
,"4":"Et dedit illos subditos omnibus regnis, quae in circuitu nostro sunt, in opprobrium et in desolationem in omnibus populis, qui in circuitu nostro sunt, quo dispersit illos Dominus,"
,"5":"et facti sunt subtus et non supra, quia peccavimus Deo nostro non oboediendo voci eius."
,"6":"Domino Deo nostro iustitia, nobis autem et patribus nostris confusio faciei, sicut hic dies;"
,"7":"quae locutus est Dominus super nos, omnia mala haec venerunt super nos,"
,"8":"et non sumus deprecati faciem Domini, ut averteremur unusquisque a cogitationibus cordis nostri pessimi."
,"9":"Et vigilavit Dominus super mala et induxit ea super nos, quia iustus est Dominus in omnibus operibus suis, quae mandavit nobis."
,"10":"Et non oboedivimus voci eius, ut ambularemus in praeceptis Domini, quae dedit ante faciem nostram."
,"11":"Et nunc, Domine, Deus Israel, qui eduxisti populum tuum de terra Aegypti in manu valida, in signis et portentis et in virtute magna et in brachio excelso et fecisti tibi nomen, sicut hic dies,"
,"12":"peccavimus, impie fecimus, inique egimus, Domine Deus noster, in omnibus iustificationibus tuis."
,"13":"Avertatur ira tua a nobis, quia derelicti sumus pauci in gentibus, quo dispersisti nos."
,"14":"Exaudi, Domine, orationem nostram et deprecationem nostram et eripe nos propter te et da nobis gratiam ante faciem eorum, qui nos abduxerunt,"
,"15":"ut sciat omnis terra quia tu es Dominus Deus noster, et quia nomen tuum invocatum est super Israel et super genus eius."
,"16":"Domine, prospice de domo sancta tua et attende in nos; inclina, Domine, aurem tuam et audi."
,"17":"Aperi, Domine, oculos tuos et vide, quia non mortui, qui in inferno sunt, quorum spiritus ablatus est a visceribus eorum, dabunt gloriam et iustificationem Domino,"
,"18":"sed anima, quae tristis est super magnitudinem, quae incedit curva et infirma, et oculi deficientes et anima esuriens dabunt tibi gloriam et iustitiam, Domine."
,"19":"Quia non in iustificationibus patrum nostrorum et regum nostrorum nos prosternimus preces nostras ante faciem tuam, Domine Deus noster;"
,"20":"quia immisisti indignationem tuam et iram tuam super nos, sicut locutus es in manibus puerorum tuorum prophetarum dicens:"
,"21":"'Sic dicit Dominus: Inclinate umerum vestrum et servite regi Babylonis et sedebitis super terram, quam dedi patribus vestris."
,"22":"Et si non audieritis vocem Domini, ut serviatis regi Babylonis, deficere faciam a civitatibus Iudae et a plateis Ierusalem"
,"23":"vocem laetitiae et vocem iucunditatis et vocem sponsi et vocem sponsae, et erit omnis terra sine vestigio ab inhabitantibus'."
,"24":"Et non audivimus vocem tuam, ut serviremus regi Babylonis; et statuisti verba tua, quae locutus es in manibus puerorum tuorum prophetarum, ut eicerentur ossa regum nostrorum et ossa patrum nostrorum de loco suo;"
,"25":"et ecce sunt proiecta in calore diei et in gelu noctis, et mortui sunt in doloribus malis, in fame et in gladio et in peste."
,"26":"Et posuisti domum, super quam invocatum est nomen tuum, sicut hic dies propter malitiam domus Israel et domus Iudae."
,"27":"Et fecisti in nos, Domine Deus noster, secundum omnem moderationem tuam et secundum omnem miserationem tuam magnam,"
,"28":"sicut locutus es in manu pueri tui Moysi in die, quo mandasti ei scribere legem tuam coram filiis Israel"
,"29":"dicens: 'Si non audieritis vocem meam, profecto turba haec magna et multa convertetur in parvam inter gentes, quo eos dispergam;"
,"30":"quia scivi quod me non audient, quia populus est dura cervice. Et convertentur ad cor suum in terra captivitatis suae"
,"31":"et scient quia ego Dominus Deus illorum, et dabo illis cor intellegens et aures audientes,"
,"32":"et laudabunt me in terra captivitatis suae et memores erunt nominis mei;"
,"33":"et avertent se a dorso suo duro et a nequissimis adinventionibus suis, quia memores erunt viae patrum suorum, qui peccaverunt coram Domino."
,"34":"Et convertam eos in terram, quam iuravi patribus eorum, Abraham, Isaac et Iacob; et possidebunt eam et multiplicabo eos, et non minorabuntur;"
,"35":"et statuam illis testamentum aeternum, ut sim illis in Deum, et ipsi erunt mihi in populum, et ultra iam non movebo populum meum Israel a terra, quam dedi illis'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Domine omnipotens, Deus Is rael, anima in angustiis et spiri tus anxius clamat ad te."
,"2":"Audi, Domine, et miserere, quia peccavimus in conspectu tuo;"
,"3":"quia tu sedens es in aeternum, et nos pereuntes in aeternum."
,"4":"Domine omnipotens, Deus Israel, audi nunc orationem defunctorum Israel et filiorum eorum, qui peccaverunt in conspectu tuo, qui non audierunt vocem Domini Dei sui, et adhaeserunt nobis mala."
,"5":"Noli memor esse iniquitatum patrum nostrorum, sed memor esto manus tuae et nominis tui in hoc tempore,"
,"6":"quia tu es Dominus Deus noster, et laudabimus te, Domine,"
,"7":"quia propter hoc dedisti timorem tuum in cor nostrum, ut invocaremus nomen tuum; et laudabimus te in captivitate nostra, quia avertimus a corde nostro omnem iniquitatem patrum nostrorum, qui peccaverunt in conspectu tuo."
,"8":"Ecce nos hodie in captivitate nostra, quo nos dispersisti in opprobrium et in maledictum et in expiationem, secundum omnes iniquitates patrum nostrorum, qui discesserunt a Domino Deo nostro '."
,"9":"Audi, Israel, mandata vitae; auribus percipite, ut sciatis prudentiam."
,"10":"Quid est, Israel?,Quid est quod in terra es inimicorum?"
,"11":"Inveterasti in terra aliena, coinquinatus es mortuis, reputatus es cum eis, qui apud inferos sunt."
,"12":"Dereliquisti fontem sapientiae!"
,"13":"Si in via Dei ambulasses, habitasses in pace in aeternum."
,"14":"Disce, ubi sit prudentia, ubi fortitudo, ubi sit intellectus, ut scias simul, ubi sit longiturnitas dierum et vita, ubi sit lumen oculorum et pax."
,"15":"Quis invenit locum eius?,Et quis intravit in thesauros eius?"
,"16":"Ubi sunt principes gentium,et qui dominantur bestiis, quae sunt super terram,"
,"17":"qui in avibus caeli ludunt,"
,"18":"qui argentum thesaurizant et aurum, in quo confidunt homines, neque est finis acquisitionis eorum; qui argentum fabricant et solliciti sunt, nec est inquisitio operum illorum?"
,"19":"Exterminati sunt et ad inferos descenderunt, et alii loco eorum surrexerunt."
,"20":"Iuvenes viderunt lumen et habitaverunt super terram; viam autem disciplinae non cognoverunt"
,"21":"nec intellexerunt semitas eius; neque susceperunt eam filii eorum, a via eorum longe facti sunt."
,"22":"Neque audita est in Chanaan,neque visa est in Theman."
,"23":"Filii quoque Agar, qui exquirunt sapientiam super terram, negotiatores Merran et Theman,et fabulatores et inquisitores prudentiae: viam autem sapientiae non cognoverunt,neque commemorati sunt semitas eius."
,"24":"O Israel, quam magna est domus Dei, et ingens locus possessionis eius!"
,"25":"Magnus est et non habet finem, excelsus est et immensus."
,"26":"Ibi fuerunt gigantes nominati illi, qui ab initio fuerunt, statura magna, scientes bellum."
,"27":"Non illos elegit Deus,neque viam disciplinae dedit illis;"
,"28":"et perierunt, quia non habuerunt prudentiam, perierunt propter insipientiam suam."
,"29":"Quis ascendit in caelum et accepit eam,et deduxit eam de nubibus?"
,"30":"Quis transfretavit mare et invenit eam,et apportabit eam auro electo?"
,"31":"Non est qui noverit viam eius, neque qui cogitet semitam eius."
,"32":"Sed qui scit omnia, novit eam, adinvenit eam prudentia sua; qui composuit terram in aeternum tempus, implevit eam iumentis quadrupedibus;"
,"33":"qui mittit lumen et vadit, vocavit illud, et oboedivit ei in tremore."
,"34":"Stellae autem splenduerunt in custodiis suis,et laetatae sunt."
,"35":"Vocavit eas, et dixerunt: 'Adsumus'; luxerunt cum laetitia ei, qui fecit eas."
,"36":"Hic est Deus noster, non aestimabitur alter adversus eum."
,"37":"Invenit omnem viam disciplinae,et dedit eam Iacob puero suo,et Israel dilecto suo."
,"38":"Post haec super terram visa est,et inter homines conversata est."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ipsa est liber praeceptorum Dei,et lex, quae permanet in aeter num. Omnes, qui tenent eam, ad vitam; qui autem relinquunt eam, morientur."
,"2":"Convertere, Iacob, et apprehende eam; perambula ad splendorem in lumine eius."
,"3":"Noli dare alteri gloriam tuam,et dignitates tuas genti alienae."
,"4":"Beati sumus, Israel, quia, quae placent Deo, nobis nota sunt."
,"5":"Confide, popule meus, memoria Israel:"
,"6":"venumdati estis gentibus,non in perditionem, sed, quia irritastis Deum, traditi estis adversariis."
,"7":"Exacerbastis enim eum, qui fecit vos, sacrificantes daemonibus et non Deo."
,"8":"Obliti autem estis Deum, qui vos pavit, Deum aeternum, et contristastis eam, quae vos enutrivit, Ierusalem."
,"9":"Vidit enim supervenientem vobis iram a Deo,et dixit: ' Audite, vicinae Sion: Superinduxit mihi Deus luctum magnum."
,"10":"Vidi enim captivitatem filiorum meorum et filiarum, quam superinduxit illis Aeternus."
,"11":"Nutrivi enim illos cum iucunditate, dimisi autem illos cum fletu et luctu."
,"12":"Nemo gaudeat super me, viduam et derelictam a multis; desolata sum propter peccata filiorum meorum, quia declinaverunt a lege Dei."
,"13":"Iustificationes autem eius non cognoverunt,neque ambulaverunt in viis mandatorum Dei,neque semitas disciplinae in iustitia eius ingressi sunt."
,"14":"Veniant vicinae Sion; et memores estote captivitatis filiorum meorum et filiarum, quam superinduxit illis Aeternus."
,"15":"Superinduxit enim illis gentem de longinquo, gentem improbam et alterius linguae, qui non sunt reveriti senem,neque parvulorum miserti sunt"
,"16":"et abduxerunt dilectos viduae,et a filiabus unicam desolaverunt '."
,"17":"Ego autem, quid possum adiuvare vos?"
,"18":"Qui enim superinduxit in vos mala, eripiet vos de manu inimicorum vestrorum."
,"19":"Abite, filii, abite; ego enim derelicta sum sola."
,"20":"Exui me stola pacis, indui autem me cilicio obsecrationis meae, clamabo ad Aeternum in diebus meis."
,"21":"Confidite, filii, clamate ad Deum, et eripiet vos de dominatione, de manu inimicorum."
,"22":"Ego enim speravi ab Aeterno salutem vestram; et venit mihi gaudium a Sancto,super misericordia, quae veniet vobis cito,ab Aeterno, salutari vestro."
,"23":"Emisi enim vos cum luctu et fletu; reddet autem mihi vos Deus,cum gaudio et laetitia in aeternum."
,"24":"Nam, sicut nunc viderunt vicinae Sion vestram captivitatem, sic videbunt cito a Deo vestram salutem, quae superveniet vobis cum magna gloria et splendore Aeterni."
,"25":"Filii, patienter sustinete iram, quae vobis a Deo supervenit; persecutus est te inimicus tuus, sed cito videbis perditionem,in cervicem eorum ascendentem."
,"26":"Delicati mei ambulaverunt vias asperas, ducti sunt ut grex direptus ab inimicis."
,"27":"Confidite, filii, et clamate ad Deum; erit enim vestra ab inductore memoria."
,"28":"Nam sicut fuit mens vestra, ut erraretis a Deo, conversi decuplate studium quaerendi eum;"
,"29":"qui enim induxit in vos mala, inducet in vos aeternam iucunditatem cum salute vestra."
,"30":"Confide, Ierusalem; consolabitur enim te, qui te nominavit."
,"31":"Miseri, qui te nocuerunt,et qui exsultati sunt in casu tuo!"
,"32":"Miserae civitates, quibus servierunt filii tui; misera, quae accepit filios tuos!"
,"33":"Sicut enim gavisa est in tua ruina,et laetata est in tuo casu, ita contristabitur in sua solitudine."
,"34":"Et amputabo exsultationem multitudinis, et laetitia eius erit in luctum."
,"35":"Ignis enim superveniet illi ab Aeterno,in dies longinquos, et inhabitabitur a daemoniis plurimum temporis."
,"36":"Circumspice ad orientem, Ierusalem, et vide iucunditatem, quae a Deo tibi superventura est."
,"37":"Ecce veniunt filii tui, quos emisisti, veniunt congregati ab ortu usque ad occasum,verbo Sancti, gaudentes in Dei gloria."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Exue te, Ierusalem, stola luctus et vexationis tuae,et indue te decore eius, quae a Deo tibi data est gloriae in aeternum."
,"2":"Circumda te diploide iustitiae, quae a Deo est, et impone mitram capiti tuo gloriae Aeterni."
,"3":"Deus enim ostendet omni, quod sub caelo est, splendorem tuum."
,"4":"Vocabitur enim nomen tuum a Deo in aeternum: Pax iustitiae et Gloria culturae Dei."
,"5":"Surge, Ierusalem, et sta in excelso,et circumspice ad orientem et vide congregatos filios tuos,a solis ortu usque ad occasum,verbo Sancti, gaudentes in memoria Dei."
,"6":"Exierunt enim abs te pedites abducti ab inimicis; inducet autem illos ad te,portatos cum gloria sicut thronum regni;"
,"7":"constituit enim Deus humiliare,omnem montem excelsum et rupes perennes,et convalles implere ad aequalitatem terrae, ut ingrediatur Israel in securitate gloriae Dei."
,"8":"Obumbrabunt autem et silvae et omne lignum suavitatis,Israel ex praecepto Dei."
,"9":"Praeibit enim Deus Israel cum laetitia,in lumine maiestatis suae, cum misericordia et iustitia, quae est ab ipso."
}`)
	CurrentBook.AddChapter(6, `{
"0":"Exemplum epistulae, quam mi sit Ieremias ad abducendos cap tivos in Babyloniam a rege Babyloniorum, ut nuntiaret illis secundum quod praeceptum est ei a Deo."
,"1":"Propter peccata, quae peccastis ante Deum, abducemini in Babyloniam captivi a Nabuchodonosor rege Babyloniorum."
,"2":"Ingressi itaque in Babylonem, eritis illic annis pluribus et tempus longum usque ad generationes septem; post hoc autem educam vos inde cum pace."
,"3":"Nunc autem videbitis in Babylone deos argenteos et aureos et ligneos in umeris portari, ostentantes metum gentibus."
,"4":"Cavete ergo, ne et vos assimilati assimilemini alienigenis, et metus vos capiat in ipsis."
,"5":"Videntes turbam ante et retro adorantem eos, dicite autem in corde vestro: ' Te oportet adorare, Domine '."
,"6":"Angelus enim meus vobiscum est; ipse autem exquiret animas vestras."
,"7":"Nam lingua eorum polita a fabro; ipsa etiam inaurata et inargentata falsa sunt et non possunt loqui."
,"8":"Et sicut virgini ornatum amanti, accepto auro fabricantur"
,"9":"coronas super capita deorum suorum. Interdum autem accidit etiam, ut sacerdotes, subtrahentes a diis aurum et argentum, erogent illud in semetipsos"
,"10":"et dent ex ipso et prostitutis in lupanari. Et ornant illos ut homines vestimentis, deos argenteos et aureos et ligneos."
,"11":"Hi autem non liberantur ab aerugine et tinea."
,"12":"Opertis illis veste purpurea, extergunt faciem eorum propter pulverem domus, qui est plurimus super eos."
,"13":"Et sceptrum habet ut homo, iudex regionis, qui in se peccantem non interficiet."
,"14":"Habet etiam gladium in manu dextera et securim, se autem de bello et a latronibus non liberabit. Unde notum est quia non sunt dii;"
,"15":"non ergo timueritis eos. Sicut enim vas hominis confractum inutile fit, tales sunt dii eorum. "
,"16":"Collocatis illis in domo, oculi eorum pleni sunt pulvere ex pedibus introeuntium."
,"17":"Et sicut alicui, qui regem offendit, circumsaeptae sunt aulae, tamquam ad mortem ducto, domus eorum muniunt sacerdotes ostiis et clausuris et seris, ne a latronibus exspolientur."
,"18":"Lucernas accendunt et quidem plures quam sibi ipsis, quarum nullam videre possunt."
,"19":"Sunt autem sicut trabes in domo; corda vero eorum dicunt elingere serpentes, qui de terra sunt; dum comedunt eos et vestimentum eorum, non sentiunt."
,"20":"Nigrae fiunt facies eorum a fumo, qui in domo fit."
,"21":"Super corpus eorum et super caput volitant noctuae et hirundines et aves, similiter et cattae."
,"22":"Unde scietis quia non sunt dii; non ergo timueritis eos."
,"23":"Aurum enim, quod circa se habent ad speciem, nisi aliquis exterserit aeruginem, non fulgebit; neque enim, cum conflabantur, sentiebant."
,"24":"Ex omni pretio empta sunt, in quibus spiritus non est."
,"25":"Sine pedibus, in umeris portantur, ostentantes ignobilitatem suam hominibus; confunduntur et, qui excolunt ea,"
,"26":"propter quod, ne forte cadat in terram, per ipsos erigetur. Neque, si quis illud erectum statuerit, per semetipsum movebitur neque, si inclinatum fuerit, erigetur; sed sicut mortuis munera illis apponuntur."
,"27":"Hostias vero eorum sacerdotes eorum vendunt et abutuntur; similiter et uxores eorum, ex ipsis partes sale condientes, neque mendico neque infirmo aliquid impertiunt. De sacrificiis eorum menstruatae et fetae contingunt."
,"28":"Scientes itaque ex his quia non sunt dii, ne timueritis eos."
,"29":"Unde enim vocabuntur dii? Quia mulieres apponunt diis argenteis et aureis et ligneis,"
,"30":"et in domibus illorum sacerdotes sedent habentes tunicas scissas et capita et barbam rasam, quorum capita nuda sunt."
,"31":"Rugiunt autem clamantes coram diis suis sicut in cena mortui."
,"32":"A vestimento eorum auferunt sacerdotes et vestiunt uxores suas et filios suos."
,"33":"Neque si quid mali patiantur ab aliquo neque si bonum, poterint retribuere; neque constituere regem possunt neque auferre."
,"34":"Similiter neque divitias neque aes poterunt dare. Si quis illis votum voverit nec reddiderit, non requirent."
,"35":"De morte hominem non liberabunt neque infirmiorem a potentiore eripient."
,"36":"Hominem caecum ad visum non restituent, de necessitate hominem non liberabunt."
,"37":"Viduae non miserebuntur neque orphano benefacient."
,"38":"Lapidibus de monte similes sunt, lignea et inaurata et inargentata; qui autem excolunt illa, confundentur."
,"39":"Quomodo ergo aestimandum aut dicendum est esse illos deos?"
,"40":"Adhuc etiam ipsi Chaldaei non honorant ea; qui cum viderint mutum non posse loqui, afferunt Bel postulantes illum loqui,"
,"41":"quasi ipse possit sentire. Et non possunt ipsi, cum intellexerint, relinquere ea; sensum enim non habent."
,"42":"Mulieres autem circumdatae funibus in viis sedent succendentes furfurem;"
,"43":"cum autem aliqua ex ipsis, attracta ab aliquo transeunte, dormierit cum eo, proximae suae exprobrat quod ea non sit digna habita, sicut ipsa, neque funis eius diruptus."
,"44":"Omnia autem, quae illis fiunt, falsa sunt; quomodo ergo aestimandum est aut dicendum illos esse deos?"
,"45":"A fabris et ab aurificibus facti sunt; nihil aliud erunt, nisi id quod volunt artifices."
,"46":"Ipsi etiam, qui ea faciunt, non erunt multi temporis; itaque numquid possunt, quae ab ipsis fabricata sunt, esse dii?"
,"47":"Reliquerunt enim falsa et opprobrium postea futuris."
,"48":"Nam cum supervenerit illis proelium et mala, cogitant apud se sacerdotes, ubi se abscondant cum illis."
,"49":"Quomodo ergo non est sentiendum quia non sunt dii, qui nec liberant se de bello nec de malis?"
,"50":"Nam cum sint lignea et inaurata et inargentata, scietur postea quia falsa sunt; gentibus universis et regibus manifestum erit quia non sunt dii sed opera manuum hominum, et nullum Dei opus in illis est."
,"51":"Cui ergo non notum est quod non sunt dii?"
,"52":"Regem enim regioni non suscitabunt neque pluviam hominibus dabunt."
,"53":"Iudicium quoque eorum non discernent nec regiones liberabunt iniuriam patientes, quia nihil possunt sicut corniculae inter medium caeli et terrae."
,"54":"Etenim cum inciderit in domum deorum ligneorum vel inauratorum vel inargentatorum ignis, sacerdotes quidem ipsorum fugient et liberabuntur; ipsi vero sicut trabes in medio comburentur."
,"55":"Regi autem et hostibus non resistent. Quomodo ergo aestimandum est aut recipiendum quia dii sunt?"
,"56":"Neque a furibus neque a latronibus se liberabunt dii lignei et inaurati et inargentati;"
,"57":"quibus hi fortiores sunt, quia aurum et argentum et vestimentum, quo operti sunt, auferent illis et abibunt; nec illi sibi auxilium ferent."
,"58":"Itaque melius est esse regem ostentantem virtutem suam aut vas in domo utile, quo uti potest is, qui possidet illud, quam falsi dii, aut etiam ostium in domo, quod custodit, quae in ea sunt, quam falsi dii, et columna lignea in regiis quam falsi dii."
,"59":"Sol quidem et luna et sidera, cum sint splendida et emissa ad utilitates, oboediunt;"
,"60":"similiter et fulgur cum apparuerit, perspicuum est; eodem modo et spiritus in omni regione spirat;"
,"61":"et nubes, quibus cum imperatum fuerit a Deo perambulare universum orbem, perficiunt, quod imperatum est;"
,"62":"ignis etiam missus desuper, ut consumat montes et silvas, facit, quod praeceptum est: haec autem neque speciebus neque virtutibus uni eorum similia sunt."
,"63":"Unde neque aestimandum est neque dicendum illos esse deos, quando non possunt neque iudicium iudicare neque benefacere hominibus."
,"64":"Scientes itaque quia non sunt dii, ne timueritis eos."
,"65":"Neque enim regibus maledicent neque benedicent."
,"66":"Signa in caelo gentibus non ostendent neque ut sol lucebunt neque illuminabunt sicut luna."
,"67":"Bestiae meliores sunt illis, quae possunt, fugientes sub tegumentum, prodesse sibi."
,"68":"Nullo itaque modo nobis est manifestum quia sunt dii; propter quod ne timueritis eos."
,"69":"Nam sicut in cucumerario formido nihil custodit, ita sunt dii illorum lignei et inaurati et inargentati."
,"70":"Eodem modo et in horto spinae albae, super quam omnis avis sedet; similiter et mortuo proiecto in tenebris similes sunt dii eorum lignei et inaurati et inargentati."
,"71":"A purpura et bysso, quae super illos tineant, scietis quia non sunt dii; ipsa etiam postremo comeduntur, et erit opprobrium in regione."
,"72":"Melior est ergo homo iustus, qui non habet simulacra, nam erit longe ab opprobriis."
}`)

}
func LA_NVBSE_LoadVMDNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Anno tertio regni Ioachim regis Iudae venit Nabuchodonosor rex Babylonis Ierusalem et obsedit eam;"
,"2":"et tradidit Dominus in manu eius Ioachim regem Iudae et partem vasorum domus Dei, et asportavit ea in terram Sennaar in domum deorum suorum et vasa intulit in domum thesauri deorum suorum."
,"3":"Et ait rex Asfanaz praeposito eunuchorum suorum, ut introduceret de filiis Israel et de semine regio et tyrannorum"
,"4":"pueros, in quibus nulla esset macula, decoros forma et eruditos omni sapientia, cautos scientia et doctos disciplina, et qui possent stare in palatio regis, et ut docerent eos litteras et linguam Chaldaeorum."
,"5":"Et constituit eis rex annonam per singulos dies de cibis suis et de vino, unde bibebat ipse, ut enutriti tribus annis postea starent in conspectu regis."
,"6":"Fuerunt ergo inter eos de filiis Iudae Daniel, Ananias, Misael et Azarias."
,"7":"Et imposuit eis praepositus eunuchorum nomina: Danieli Baltassar et Ananiae Sedrac, Misaeli Misac et Azariae Abdenago."
,"8":"Proposuit autem Daniel in corde suo, ne pollueretur de mensa regis neque de vino potus eius, et rogavit eunuchorum praepositum, ne contaminaretur."
,"9":"Dedit autem Deus Danieli gratiam et misericordiam in conspectu principis eunuchorum;"
,"10":"et ait princeps eunuchorum ad Daniel: ' Timeo ego dominum meum regem, qui constituit vobis cibum et potum; qui si viderit vultus vestros macilentiores prae ceteris adulescentibus coaevis vestris, condemnabitis caput meum regi '."
,"11":"Et dixit Daniel ad custodem, quem constituerat princeps eunuchorum super Daniel, Ananiam, Misael et Azariam:"
,"12":"' Tenta nos, obsecro, servos tuos diebus decem, et dentur nobis legumina ad vescendum et aqua ad bibendum;"
,"13":"et videantur in conspectu tuo vultus nostri et vultus puerorum, qui vescuntur cibo regio, et, sicut videris, facies cum servis tuis '."
,"14":"Qui, audito sermone huiuscemodi, tentavit eos diebus decem."
,"15":"Post dies autem decem apparuerunt vultus eorum meliores et corpulentiores prae omnibus pueris, qui vescebantur cibo regio."
,"16":"Porro custos tollebat cibaria et vinum potus eorum dabatque eis legumina."
,"17":"Quattuor autem pueris his dedit Deus scientiam et disciplinam in omni scriptura et sapientia, Danieli autem intellegentiam omnium visionum et somniorum."
,"18":"Completis itaque diebus, post quos dixerat rex, ut introducerentur, introduxit eos praepositus eunuchorum in conspectu Nabuchodonosor."
,"19":"Cumque locutus eis fuisset rex, non sunt inventi de universis tales ut Daniel, Ananias, Misael et Azarias; et steterunt in conspectu regis."
,"20":"Et omne verbum sapientiae et intellectus, quod sciscitatus est ab eis, rex invenit in eis decuplum super cunctos hariolos et magos, qui erant in universo regno eius."
,"21":"Fuit autem Daniel usque ad annum primum Cyri regis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"In anno secundo regni Nabu chodonosor vidit Nabuchodo nosor somnium, et conterritus est spiritus eius, et somnus eius fugit ab eo."
,"2":"Praecepit autem rex, ut convocarentur harioli et magi et malefici et Chaldaei et indicarent regi somnia sua; qui cum venissent, steterunt coram rege."
,"3":"Et dixit ad eos rex: ' Vidi somnium, et spiritus meus conterritus est, ut intellegat somnium '."
,"4":"Responderuntque Chaldaei regi Aramaice: ' Rex, in sempiternum vive! Dic somnium servis tuis, et interpretationem eius indicabimus '."
,"5":"Et respondens rex ait Chaldaeis: ' Sermo recessit a me. Nisi indicaveritis mihi somnium et coniecturam eius, in frusta concidemini, et domus vestrae in sterquilinium ponentur;"
,"6":"si autem somnium et coniecturam eius narraveritis, praemia et dona et honorem multum accipietis a me. Somnium igitur et interpretationem eius indicate mihi '."
,"7":"Responderunt secundo atque dixerunt: ' Rex somnium dicat servis suis, et interpretationem illius indicabimus '."
,"8":"Respondit rex et ait: ' Certe novi quia tempus redimitis, scientes quod recesserit a me sermo."
,"9":"Si ergo somnium non indicaveritis mihi, una est de vobis sententia. Et verbum fallax et deceptione plenum composuistis, ut loquamini mihi, donec tempus pertranseat; somnium itaque dicite mihi, ut sciam quod interpretationem eius loquamini mihi '."
,"10":"Respondentes ergo Chaldaei coram rege dixerunt: ' Non est homo super terram qui sermonem regis possit indicare; quapropter neque regum quisquam magnus et potens verbum huiuscemodi sciscitatur ab omni hariolo et mago et Chaldaeo."
,"11":"Sermo enim, quem tu quaeris, rex, gravis est, nec reperietur quisquam qui indicet illum in conspectu regis, exceptis diis, quorum non est cum hominibus conversatio '."
,"12":"Quo audito, rex in furore et in ira magna praecepit, ut perirent omnes sapientes Babylonis."
,"13":"Et egressa sententia, ut sapientes interficerentur, quaerebantur Daniel et socii eius, ut perirent."
,"14":"Tunc Daniel interrogavit cum consilio et prudentia Arioch, principem militiae regis, qui egressus fuerat ad interficiendos sapientes Babylonis;"
,"15":"respondens dixit ad Arioch, qui a rege potestatem acceperat, quam ob causam tam crudelis sententia a facie esset regis egressa. Cum ergo rem indicasset Arioch Danieli,"
,"16":"Daniel ingressus rogavit regem, ut tempus daret sibi ad solutionem indicandam regi;"
,"17":"et ingressus est domum suam Ananiaeque, Misaeli et Azariae sociis suis indicavit negotium,"
,"18":"ut quaererent misericordiam a facie Dei caeli super sacramento isto et non perirent Daniel et socii eius cum ceteris sapientibus Babylonis."
,"19":"Tunc Danieli per visionem nocte mysterium revelatum est, et benedixit Daniel Deo caeli"
,"20":"et locutus Daniel ait: ' Sit nomen Dei benedictum,a saeculo et usque in saeculum, quia sapientia et fortitudo eius sunt;"
,"21":"et ipse mutat tempora et aetates, transfert atque constituit reges, dat sapientiam sapientibus,et scientiam intellegentibus disciplinam:"
,"22":"ipse revelat profunda et abscondita,et novit in tenebris constituta, et lux cum eo inhabitat,"
,"23":"Tibi, Deus patrum meorum, confiteor teque laudo, quia sapientiam et fortitudinem dedisti mihi,et nunc ostendisti mihi, quae rogavimus te, quia sermonem regis aperuisti nobis '."
,"24":"Propterea Daniel, ingressus ad Arioch, quem constituerat rex, ut perderet sapientes Babylonis, sic ei locutus est: ' Sapientes Babylonis ne perdas; introduc me in conspectu regis et solutionem regi enarrabo '."
,"25":"Tunc Arioch festinus introduxit Danielem ad regem et dixit ei: ' Inveni hominem de filiis transmigrationis Iudae, qui solutionem regi annuntiet '."
,"26":"Respondit rex et dixit Danieli, cuius nomen erat Baltassar: ' Putasne vere potes mihi indicare somnium, quod vidi, et interpretationem eius?'."
,"27":"Et respondens Daniel coram rege ait: ' Mysterium, quod rex interrogat, sapientes, magi et harioli et haruspices non queunt indicare regi;"
,"28":"sed est Deus in caelo revelans mysteria, qui indicavit tibi, rex Nabuchodonosor, quae ventura sunt in novissimis temporibus. Somnium tuum et visiones capitis tui in cubili tuo huiuscemodi sunt:"
,"29":"Tu, rex, cogitare coepisti in strato tuo quid esset futurum post haec; et, qui revelat mysteria, ostendit tibi, quae ventura sunt."
,"30":"Mihi quoque non in sapientia, quae est in me plus quam in cunctis viventibus, sacramentum hoc revelatum est, sed ut interpretatio regi manifesta fieret, et cogitationes mentis tuae scires."
,"31":"Tu, rex, videbas, et ecce statua una grandis: statua illa magna et statura sublimis stabat contra te, et intuitus eius erat terribilis."
,"32":"Huius statuae caput ex auro optimo erat, pectus autem et brachia de argento, porro venter et femora ex aere,"
,"33":"tibiae autem ferreae, pedum quaedam pars erat ferrea, quaedam autem fictilis."
,"34":"Videbas ita, donec abscissus est lapis sine manibus et percussit statuam in pedibus eius ferreis et fictilibus et comminuit eos;"
,"35":"tunc contrita sunt pariter ferrum, testa, aes, argentum et aurum, et fuerunt quasi folliculus ex areis aestivis, et rapuit ea ventus, nullusque locus inventus est eis; lapis autem, qui percusserat statuam, factus est mons magnus et implevit universam terram."
,"36":"Hoc est somnium; interpretationem quoque eius dicemus coram te, rex."
,"37":"Tu rex regum es, et Deus caeli regnum et fortitudinem et imperium et gloriam dedit tibi;"
,"38":"et omnia, in quibus habitant filii hominum et bestiae agri volucresque caeli, dedit in manu tua et te dominum universorum constituit: tu es caput aureum."
,"39":"Et post te consurget regnum aliud minus te et regnum tertium aliud aereum, quod imperabit universae terrae."
,"40":"Et regnum quartum erit robustum velut ferrum; quomodo ferrum comminuit et domat omnia, et sicut ferrum comminuens conteret et comminuet omnia haec."
,"41":"Porro quia vidisti pedum et digitorum partem testae figuli et partem ferream, regnum divisum erit; et robur ferri erit ei, secundum quod vidisti ferrum mixtum testae ex luto."
,"42":"Et digitos pedum ex parte ferreos et ex parte fictiles, ex parte regnum erit solidum et ex parte contritum."
,"43":"Quod autem vidisti ferrum mixtum testae ex luto, commiscebuntur quidem humano semine, sed non adhaerebunt sibi, sicuti ferrum misceri non potest testae."
,"44":"In diebus autem regnorum illorum suscitabit Deus caeli regnum, quod in aeternum non dissipabitur, et regnum populo alteri non tradetur: comminuet et consumet universa regna haec, et ipsum stabit in aeternum."
,"45":"Secundum quod vidisti quod de monte abscisus est lapis sine manibus et comminuit testam et ferrum et aes et argentum et aurum, Deus magnus ostendit regi, quae ventura sunt postea; et verum est somnium et fidelis interpretatio eius '."
,"46":"Tunc rex Nabuchodonosor cecidit in faciem suam et Danielem adoravit et hostias et incensum praecepit, ut sacrificarent ei."
,"47":"Loquens ergo rex ait Danieli: ' Vere Deus vester Deus deorum est et Dominus regum et revelans mysteria, quoniam potuisti aperire sacramentum hoc '."
,"48":"Tunc rex Danielem in sublime extulit et munera multa et magna dedit ei et constituit eum principem super omnes provincias Babylonis et principem praefectorum super cunctos sapientes Babylonis."
,"49":"Daniel autem postulavit a rege et constituit super opera provinciae Babylonis Sedrac, Misac et Abdenago; ipse autem Daniel erat in foribus regis."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Nabuchodonosor rex fecit sta tuam auream altitudine cubito rum sexaginta, latitudine cubitorum sex; et statuit eam in campo Dura in provincia Babylonis."
,"2":"Itaque Nabuchodonosor rex misit ad congregandos satrapas, magistratus et iudices, duces et tyrannos et praefectos omnesque principes provinciarum, ut convenirent ad dedicationem statuae, quam erexerat Nabuchodonosor rex."
,"3":"Tunc congregati sunt satrapae, magistratus et iudices, duces et tyranni et optimates, qui erant in potestatibus constituti, et universi principes provinciarum ad dedicationem statuae, quam erexerat Nabuchodonosor rex. Stabant autem in conspectu statuae, quam posuerat Nabuchodonosor,"
,"4":"et praeco clamabat valenter: ' Vobis dicitur, populi, tribus et linguae:"
,"5":"in hora, qua audieritis sonitum tubae et fistulae et citharae, sambucae et psalterii et symphoniae et universi generis musicorum, cadentes adorate statuam auream, quam constituit Nabuchodonosor rex."
,"6":"Si quis autem non prostratus adoraverit, eadem hora mittetur in fornacem ignis ardentis '."
,"7":"Post haec igitur, statim ut audierunt omnes populi sonitum tubae, fistulae et citharae, sambucae et psalterii et symphoniae et omnis generis musicorum, cadentes omnes populi tribus et linguae adoraverunt statuam auream, quam constituerat Nabuchodonosor rex."
,"8":"Statimque et in ipso tempore accedentes viri Chaldaei accusaverunt Iudaeos"
,"9":"dixeruntque Nabuchodonosor regi: ' Rex, in aeternum vive!"
,"10":"Tu, rex, posuisti decretum, ut omnis homo, qui audierit sonitum tubae, fistulae et citharae, sambucae et psalterii et symphoniae et universi generis musicorum, prosternat se et adoret statuam auream;"
,"11":"si quis autem non procidens adoraverit, mittetur in fornacem ignis ardentis."
,"12":"Sunt ergo viri Iudaei, quos constituisti super opera provinciae Babylonis, Sedrac, Misac et Abdenago; viri isti te, rex, non honorant: deos tuos non colunt et statuam auream, quam erexisti, non adorant '."
,"13":"Tunc Nabuchodonosor in furore et in ira praecepit, ut adducerentur Sedrac, Misac et Abdenago; tunc viri illi adducti sunt in conspectu regis."
,"14":"Pronuntiansque Nabuchodonosor rex ait eis: ' Verene, Sedrac, Misac et Abdenago, deos meos non colitis et statuam auream, quam constitui, non adoratis?"
,"15":"Numquid estis nunc parati, quacumque hora audieritis sonitum tubae, fistulae, citharae, sambucae, psalterii et symphoniae omnisque generis musicorum, prosternere vos et adorare statuam, quam feci? Quod si non adoraveritis, eadem hora mittemini in fornacem ignis ardentis; et quis est deus, qui eripiat vos de manu mea? '."
,"16":"Respondentes Sedrac, Misac et Abdenago dixerunt regi Nabuchodonosor: ' Non oportet nos de hac re respondere tibi:"
,"17":"Si enim Deus noster, quem colimus, potest eripere nos de camino ignis ardentis, et de manu tua, rex, liberabit."
,"18":"Quod si noluerit, notum sit tibi, rex, quia deos tuos non colimus et statuam auream, quam erexisti, non adoramus '."
,"19":"Tunc Nabuchodonosor repletus est furore, et aspectus faciei illius immutatus est super Sedrac, Misac et Abdenago; et respondens praecepit, ut succenderetur fornax septuplum quam succendi consueverat;"
,"20":"et viris fortissimis de exercitu suo iussit, ut ligarent Sedrac, Misac et Abdenago et mitterent eos in fornacem ignis ardentis;"
,"21":"et confestim viri illi vincti, cum bracis suis et tiaris et calceamentis et vestibus missi sunt in medium fornacis ignis ardentis;"
,"22":"itaque, quia iussio regis urgebat, et fornax succensa erat nimis, viros illos, qui miserant Sedrac, Misac et Abdenago, interfecit flamma ignis."
,"23":"Viri autem tres, Sedrac, Misac et Abdenago, ceciderunt in medio camino ignis ardentis colligati. (Quae sequuntur in Hebraeis voluminibus non repperi)."
,"24":"Et ambulabant in medio flammae laudantes Deum et benedicentes Domino."
,"25":"Stans autem Azarias oravit sic aperiensque os suum in medio ignis ait:"
,"26":"' Benedictus es, Domine, Deus patrum nostrorum, et laudabilis et gloriosum nomen tuum in saecula,"
,"27":"quia iustus es in omnibus, quae fecisti nobis, et universa opera tua vera, et viae tuae rectae, et omnia iudicia tua veritas."
,"28":"Iudicia enim vera fecisti,iuxta omnia, quae induxisti super nos,et super civitatem sanctam patrum nostrorum Ierusalem, quia in veritate et in iudicio induxisti omnia haec,propter peccata nostra."
,"29":"Peccavimus enim et inique egimus recedentes a te,et deliquimus in omnibus;"
,"30":"et praecepta tua non audivimus,nec observavimus,nec fecimus, sicut praeceperas nobis, ut bene nobis esset."
,"31":"Omnia ergo, quae induxisti super nos, et universa, quae fecisti nobis, vero iudicio fecisti;"
,"32":"et tradidisti nos in manibus inimicorum nostrorum,iniquorum et pessimorum praevaricatorumque,et regi iniusto et pessimo ultra omnem terram."
,"33":"Et nunc non possumus aperire os; confusio et opprobrium facta sunt,servis tuis et his, qui colunt te."
,"34":"Ne, quaesumus, tradas nos in perpetuum,propter nomen tuum,et ne dissipes testamentum tuum"
,"35":"neque auferas misericordiam tuam a nobis,propter Abraham dilectum tuum,et Isaac servum tuum,et Israel sanctum tuum,"
,"36":"quibus dixisti,quod multiplicares semen eorum sicut stellas caeli,et sicut arenam, quae est in litore maris;"
,"37":"quia, Domine, imminuti sumus plus quam omnes gentes,sumusque humiles in universa terra,hodie propter peccata nostra;"
,"38":"et non est in tempore hoc,princeps et propheta et dux,neque holocaustum neque sacrificium,neque oblatio neque incensum,neque locus primitiarum coram te, ut possimus invenire misericordiam;"
,"39":"sed in anima contrita et spiritu humilitatis suscipiamur,sicut in holocausto arietum et taurorum"
,"40":"et sicut in milibus agnorum pinguium; sic fiat sacrificium nostrum in conspectu tuo hodie, et perfice subsequentes te, quoniam non est confusio confidentibus in te."
,"41":"Et nunc sequimur te in toto corde,et timemus te et quaerimus faciem tuam;"
,"42":"ne confundas nos, sed fac nobiscum iuxta mansuetudinem tuam,et secundum multitudinem misericordiae tuae"
,"43":"et erue nos in mirabilibus tuis,et da gloriam nomini tuo, Domine. "
,"44":"Et confundantur omnes, qui ostendunt servis tuis mala; confundantur absque ulla potentia, et robur eorum conteratur."
,"45":"Sciant quia tu es Dominus, Deus solus et gloriosus super orbem terrarum '."
,"46":"Et non cessabant, qui immiserant eos, ministri regis succendere fornacem naphta et stuppa et pice et malleolis,"
,"47":"et effundebatur flamma super fornacem cubitis quadraginta novem"
,"48":"et erupit et incendit, quos repperit iuxta fornacem de Chaldaeis."
,"49":"Angelus autem Domini descendit cum Azaria et sociis eius in fornacem et excussit flammam ignis de fornace"
,"50":"et fecit medium fornacis quasi ventum roris flantem; et non tetigit eos omnino ignis neque contristavit nec quidquam molestiae intulit."
,"51":"Tunc hi tres, quasi ex uno ore, laudabant et glorificabant et benedicebant Deo in fornace dicentes:"
,"52":"' Benedictus es, Domine, Deus patrum nostrorum, et laudabilis et superexaltatus in saecula; et benedictum nomen gloriae tuae sanctum,et superlaudabile et superexaltatum in saecula."
,"53":"Benedictus es in templo sanctae gloriae tuae,et superlaudabilis et supergloriosus in saecula."
,"54":"Benedictus es in throno regni tui,et superlaudabilis et superexaltatus in saecula."
,"55":"Benedictus es, qui intueris abyssos sedens super cherubim, et laudabilis et superexaltatus in saecula."
,"56":"Benedictus es in firmamento caeli,et laudabilis et gloriosus in saecula."
,"57":"Benedicite, omnia opera Domini, Domino, laudate et superexaltate eum in saecula."
,"58":"Benedicite, caeli, Domino, laudate et superexaltate eum in saecula."
,"59":"Benedicite, angeli Domini, Domino, laudate et superexaltate eum in saecula."
,"60":"Benedicite, aquae omnes, quae super caelos sunt, Domino, laudate et superexaltate eum in saecula."
,"61":"Benedicat omnis virtus Domino, laudate et superexaltate eum in saecula."
,"62":"Benedicite, sol et luna, Domino, laudate et superexaltate eum in saecula."
,"63":"Benedicite, stellae caeli, Domino, laudate et superexaltate eum in saecula."
,"64":"Benedicite, omnis imber et ros, Domino, laudate et superexaltate eum in saecula."
,"65":"Benedicite, omnes venti, Domino, laudate et superexaltate eum in saecula."
,"66":"Benedicite, ignis et aestus, Domino, laudate et superexaltate eum in saecula."
,"67":"Benedicite, frigus et aestus, Domino, laudate et superexaltate eum in saecula."
,"68":"Benedicite, rores et pruina, Domino, laudate et superexaltate eum in saecula."
,"69":"Benedicite, gelu et frigus, Domino, laudate et superexaltate eum in saecula."
,"70":"Benedicite, glacies et nives, Domino, laudate et superexaltate eum in saecula."
,"71":"Benedicite, noctes et dies, Domino, laudate et superexaltate eum in saecula."
,"72":"Benedicite, lux et tenebrae, Domino, laudate et superexaltate eum in saecula."
,"73":"Benedicite, fulgura et nubes, Domino, laudate et superexaltate eum in saecula."
,"74":"Benedicat terra Dominum, laudet et superexaltet eum in saecula."
,"75":"Benedicite, montes et colles, Domino, laudate et superexaltate eum in saecula."
,"76":"Benedicite, universa germinantia in terra, Domino, laudate et superexaltate eum in saecula."
,"77":"Benedicite, maria et flumina, Domino, laudate et superexaltate eum in saecula."
,"78":"Benedicite, fontes, Domino, laudate et superexaltate eum in saecula."
,"79":"Benedicite, cete et omnia quae moventur in aquis, Domino, laudate et superexaltate eum in saecula."
,"80":"Benedicite, omnes volucres caeli, Domino, laudate et superexaltate eum in saecula."
,"81":"Benedicite, omnes bestiae et pecora, Domino, laudate et superexaltate eum in saecula."
,"82":"Benedicite, filii hominum, Domino, laudate et superexaltate eum in saecula."
,"83":"Benedic, Israel, Domino, laudate et superexaltate eum in saecula."
,"84":"Benedicite, sacerdotes Domini, Domino, laudate et superexaltate eum in saecula."
,"85":"Benedicite, servi Domini, Domino, laudate et superexaltate eum in saecula."
,"86":"Benedicite, spiritus et animae iustorum, Domino, laudate et superexaltate eum in saecula."
,"87":"Benedicite, sancti et humiles corde, Domino, laudate et superexaltate eum in saecula."
,"88":"Benedicite, Anania, Azaria, Misael, Domino, laudate et superexaltate eum in saecula; quia eruit nos de inferno et salvos fecit de manu mortis,et liberavit nos de medio fornacis ardentis flammae,et de medio ignis eruit nos."
,"89":"Confitemini Domino, quoniam bonus, quoniam in saeculum misericordia eius."
,"90":"Benedicite, omnes, qui timetis Dominum, Deo deorum; laudate et confitemini ei, quia in saecula misericordia eius '. (Hucusque non habetur in Hebraeo et, quae posuimus, de Theodotionis editione translata sunt)."
,"91":"24 Tunc Nabuchodonosor rex obstupuit et surrexit propere; respondens ait optimatibus suis: ' Nonne tres viros misimus in medium ignis compeditos?'. Qui respondentes dixerunt regi: ' Vere, rex '."
,"92":"25 Respondit et ait: ' Ecce ego video viros quattuor solutos et ambulantes in medio ignis, et nihil corruptionis in eis est, et species quarti similis filio deorum '."
,"93":"26 Tunc accessit Nabuchodonosor ad ostium fornacis ignis ardentis et ait: ' Sedrac, Misac et Abdenago, servi Dei excelsi, egredimini et venite '. Statimque egressi sunt Sedrac, Misac et Abdenago de medio ignis."
,"94":"27 Et congregati satrapae, magistratus et iudices et potentes regis contemplabantur viros illos, quoniam nihil potestatis habuisset ignis in corporibus eorum, et capillus capitis eorum non esset adustus, et sarabara eorum non fuissent immutata, et odor ignis non transisset per eos."
,"95":"28 Et erumpens Nabuchodonosor ait: ' Benedictus Deus eorum, Sedrac, Misac et Abdenago, qui misit angelum suum et eruit servos suos, qui crediderunt in eo, et verbum regis immutaverunt et tradiderunt corpora sua, ne servirent et ne adorarent omnem deum, excepto Deo suo."
,"96":"29 A me ergo positum est decretum, ut omnis populus, tribus et lingua quaecumque locuta fuerit blasphemiam contra Deum Sedrac, Misac et Abdenago, in frusta concidatur, et domus eius in sterquilinium fiat, eo quod non est Deus alius, qui possit ita salvare '."
,"97":"30 Tunc rex promovit Sedrac, Misac et Abdenago in provincia Babylonis."
,"98":"31 Nabuchodonosor rex omnibus populis, gentibus et linguis, quae habitant in universa terra: ' Pax vobis multiplicetur."
,"99":"32 Signa et mirabilia, quae fecit apud me Deus excelsus, placuit mihi praedicare:"
,"100":"33 Signa eius quam magna sunt, et mirabilia eius quam fortia!,Et regnum eius regnum sempiternum, et potestas eius in generationem et generationem '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ego Nabuchodonosor quietus eram in domo mea et florens in palatio meo;"
,"2":"somnium vidi, quod perterruit me, et cogitationes in stratu meo et visiones capitis mei conturbaverunt me."
,"3":"Et per me propositum est decretum, ut introducerentur in conspectu meo cuncti sapientes Babylonis, ut solutionem somnii indicarent mihi."
,"4":"Tunc ingrediebantur harioli, magi, Chaldaei et haruspices; et somnium narravi in conspectu eorum, et solutionem eius non indicaverunt mihi;"
,"5":"donec denique ingressus est in conspectu meo Daniel, cui nomen Baltassar secundum nomen dei mei et qui habet spiritum deorum sanctorum in semetipso. Et somnium coram ipso locutus sum:"
,"6":"Baltassar, princeps hariolorum, quem ego scio quod spiritum deorum sanctorum habeas in te, et omne sacramentum non est impossibile tibi, visiones somnii mei, quas vidi, et solutionem eius narra."
,"7":"Visio capitis mei in cubili meo: Videbam, et ecce arbor in medio terrae, et altitudo eius nimia."
,"8":"Magna arbor et fortis, et proceritas eius contingens caelum; aspectus illius erat usque ad terminos universae terrae."
,"9":"Folia eius pulcherrima, et fructus eius nimius, et esca universorum in ea. Subter eam habitabant bestiae agri, et in ramis eius conversabantur volucres caeli, et ex ea vescebatur omnis caro."
,"10":"Videbam in visione capitis mei super stratum meum, et ecce vigil et sanctus de caelo descendit."
,"11":"Clamavit fortiter et sic ait: 'Succidite arborem et praecidite ramos eius, excutite folia eius et dispergite fructus eius. Fugiant bestiae de sub ea, et volucres de ramis eius."
,"12":"Verumtamen germen radicum eius in terra sinite,et in vinculo ferreo et aereo in herbis agri, et rore caeli tingatur, et cum feris pars eius in herba terrae."
,"13":"Cor eius ab humano commutetur, et cor ferae detur ei, et septem tempora mutentur super eum."
,"14":"In sententia vigilum decretum est, et sermo sanctorum petitio, ut cognoscant viventes,quoniam dominatur Excelsus in regno hominum,et, cuicumque voluerit, dabit illud,et humillimum hominem constituet super eo'."
,"15":"Hoc somnium vidi ego rex Nabuchodonosor. Tu ergo, Baltassar, interpretationem narra, quia omnes sapientes regni mei non queunt solutionem edicere mihi; tu autem potes, quia spiritus deorum sanctorum in te est '."
,"16":"Tunc Daniel, cuius nomen Baltassar, obstupuit quasi una hora, et cogitationes eius conturbabant eum. Respondens autem rex ait: ' Baltassar, somnium et interpretatio eius non conturbent te '. Respondit Baltassar et dixit: ' Domine mi, somnium his, qui te oderunt, et interpretatio eius hostibus tuis sit."
,"17":"Arborem, quam vidisti sublimem atque robustam, cuius altitudo pertingit ad caelum, et aspectus illius in omnem terram,"
,"18":"et rami eius pulcherrimi, et fructus eius nimius, et esca omnium in ea, subter eam habitantes bestiae agri, et in ramis eius commorantes aves caeli,"
,"19":"tu es, rex, qui magnificatus es et invaluisti, et magnitudo tua crevit et pervenit usque ad caelum, et potestas tua in terminos terrae."
,"20":"Quod autem vidit rex vigilem et sanctum descendere de caelo et dicere: 'Succidite arborem et dissipate illam; attamen germen radicum eius in terra dimittite, et vinculo ferreo et aereo in herbis agri, et rore caeli conspergatur, et cum feris sit pars eius, donec septem tempora mutentur super eum',"
,"21":"haec est interpretatio, rex, et sententia Altissimi, quae pervenit super dominum meum regem:"
,"22":"et eicient te ab hominibus, et cum bestiis feris erit habitatio tua, et fenum ut boves comedes et rore caeli infunderis; septem quoque tempora mutabuntur super te, donec scias quod dominetur Excelsus super regnum hominum et, cuicumque voluerit, det illud."
,"23":"Quod autem praeceperunt, ut relinqueretur germen radicum eius, id est arboris, regnum tuum tibi manebit, postquam cognoveris potestatem caeli."
,"24":"Quam ob rem, rex, consilium meum placeat tibi, et peccata tua eleemosynis redime et iniquitates tuas misericordiis pauperum; sic longitudo erit prosperitati tuae '."
,"25":"Omnia haec venerunt super Nabuchodonosor regem."
,"26":"Post finem mensium duodecim in palatio regni Babylonis deambulabat;"
,"27":"responditque rex et ait: ' Nonne haec est Babylon magna, quam ego aedificavi in domum regni, in robore fortitudinis meae et in gloria decoris mei? '."
,"28":"Cum adhuc sermo esset in ore regis, vox de caelo ruit: ' Tibi dicitur, Nabuchodonosor rex: Regnum tuum transiit a te,"
,"29":"et ab hominibus te eicient, et cum bestiis feris erit habitatio tua: fenum quasi boves comedes; et septem tempora mutabuntur super te, donec scias quod dominetur Excelsus in regno hominum et, cuicumque voluerit, det illud '."
,"30":"Eadem hora sermo completus est super Nabuchodonosor, et ex hominibus abiectus est et fenum ut boves comedit, et rore caeli corpus eius infectum est, donec capilli eius in similitudinem aquilarum crescerent, et ungues eius quasi avium."
,"31":"' Igitur post finem dierum ego Nabuchodonosor oculos meos ad caelum levavi, et sensus meus redditus est mihi, et Altissimo benedixi et Viventem in sempiternum laudavi et glorificavi, quia potestas eius potestas sempiterna, et regnum eius in generationem et generationem;"
,"32":"et omnes habitatores terrae apud eum in nihilum reputati sunt: iuxta voluntatem enim suam facit,tam in virtutibus caeli quam in habitatoribus terrae, et non est qui resistat manui eius,et dicat ei: 'Quid facis?'."
,"33":"In ipso tempore sensus meus reversus est ad me, et ad honorem regni mei maiestas mea et splendor meus reversa sunt ad me; et optimates mei et magistratus mei requisierunt me, et in regno meo constitutus sum, et magnificentia amplior addita est mihi."
,"34":"Nunc igitur ego Nabuchodonosor laudo et magnifico et glorifico Regem caeli, quia omnia opera eius veritas, et viae eius iudicium, et gradientes in superbia potest humiliare '."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Balthasar rex fecit grande con vivium optimatibus suis mille et coram his milibus vinum bibebat."
,"2":"Balthasar ergo praecepit iam temulentus, ut afferrentur vasa aurea et argentea, quae asportaverat Nabuchodonosor pater eius de templo, quod fuit in Ierusalem, ut biberent in eis rex et optimates eius uxoresque eius et concubinae."
,"3":"Tunc allata sunt vasa aurea, quae asportaverat de templo, quod fuerat in Ierusalem; et biberunt in eis rex et optimates eius, uxores et concubinae illius:"
,"4":"bibebant vinum et laudabant deos suos aureos et argenteos, aereos, ferreos ligneosque et lapideos."
,"5":"In eadem hora apparuerunt digiti manus hominis et scripserunt contra candelabrum in superficie parietis palatii regis; et rex aspiciebat articulos manus scribentis."
,"6":"Tunc regis facies commutata est, et cogitationes eius conturbabant eum, et compages renum eius solvebantur, et genua eius ad se invicem collidebantur."
,"7":"Exclamavit itaque rex fortiter, ut introducerent magos, Chaldaeos et haruspices; et proloquens rex ait sapientibus Babylonis: ' Quicumque legerit scripturam hanc et interpretationem eius manifestam mihi fecerit, purpura vestietur et torquem auream habebit in collo et tertius in regno meo dominabitur '."
,"8":"Tunc ingressi sunt omnes sapientes regis et non potuerunt nec scripturam legere nec interpretationem indicare regi;"
,"9":"unde rex Balthasar satis conturbatus est, et vultus illius immutatus est super eum, sed et optimates eius turbabantur."
,"10":"Regina autem, sermonum regis optimatiumque eius causa, domum convivii ingressa est; et regina proloquens ait: ' Rex, in aeternum vive! Non te conturbent cogitationes tuae, neque facies tua immutetur."
,"11":"Est vir in regno tuo, qui spiritum deorum sanctorum habet in se, et in diebus patris tui scientia et intellegentia et sapientia quasi sapientia deorum inventae sunt in eo; nam et rex Nabuchodonosor pater tuus principem magorum, incantatorum, Chaldaeorum et haruspicum constituit eum; pater tuus, o rex,"
,"12":"quia spiritus amplior et prudentia intellegentiaque et interpretatio somniorum et ostensio secretorum ac solutio ligatorum inventae sunt in eo, in Daniele, cui rex posuit nomen Baltassar. Nunc itaque Daniel vocetur et interpretationem narrabit '."
,"13":"Igitur introductus est Daniel coram rege; ad quem praefatus rex ait: ' Tu es Daniel de filiis captivitatis Iudae, quem adduxit rex pater meus de Iuda?"
,"14":"Audivi de te quoniam spiritum deorum habeas, et scientia intellegentiaque ac sapientia ampliores inventae sint in te."
,"15":"Et nunc introgressi sunt in conspectu meo sapientes, magi, ut scripturam hanc legerent et interpretationem eius indicarent mihi et nequiverunt sensum huius sermonis edicere."
,"16":"Porro ego audivi de te quod possis obscura interpretari et ligata dissolvere; si ergo vales scripturam legere et interpretationem eius indicare mihi, purpura vestieris et torquem auream circa collum tuum habebis et tertius in regno meo princeps eris '."
,"17":"Tunc respondens Daniel ait coram rege: ' Munera tua sint tibi, et dona tua alteri da; scripturam autem legam tibi, rex, et interpretationem eius ostendam tibi."
,"18":"O rex, Deus altissimus regnum et magnificentiam et gloriam et honorem dedit Nabuchodonosor patri tuo."
,"19":"Et propter magnificentiam, quam dederat ei, universi populi, tribus et linguae tremebant et metuebant eum; quos volebat, interficiebat et, quos volebat, percutiebat et, quos volebat, exaltabat et, quos volebat, humiliabat."
,"20":"Quando autem elevatum est cor eius, et spiritus illius obfirmatus est ad superbiam, depositus est de solio regni sui, et gloria eius ablata est ab eo;"
,"21":"et a filiis hominum eiectus est, sed et cor eius cum bestiis positum est, et cum onagris erat habitatio eius, fenum quoque ut boves comedebat, et rore caeli corpus eius infectum est, donec cognosceret quod potestatem haberet Deus altissimus in regno hominum et, quemcumque voluerit, suscitabit super illud."
,"22":"Tu quoque filius eius, Balthasar, non humiliasti cor tuum, cum scires haec omnia,"
,"23":"sed adversum Dominum caeli elevatus es, et vasa domus eius allata sunt coram te, et tu et optimates tui et uxores tuae et concubinae tuae vinum bibistis in eis; deos quoque argenteos et aureos et aereos, ferreos ligneosque et lapideos, qui non vident neque audiunt neque sentiunt, laudasti, porro Deum, qui habet flatum tuum in manu sua et omnes vias tuas, non glorificasti."
,"24":"Idcirco ab eo missi sunt articuli manus, et scriptura haec exarata est."
,"25":"Haec est autem scriptura, quae digesta est: mane, thecel, upharsin."
,"26":"Et haec est interpretatio sermonis: mane, numeravit Deus regnum tuum et complevit illud;"
,"27":"thecel, appensus es in statera et inventus es minus habens;"
,"28":"phares, divisum est regnum tuum et datum est Medis et Persis '."
,"29":"Tunc, iubente Balthasar, indutus est Daniel purpura, et circumdata est torques aurea collo eius, et praedicatum est de eo quod haberet potestatem tertius in regno suo."
,"30":"Eadem nocte interfectus est Balthasar rex Chaldaeorum."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et Darius Medus successit in regnum annos natus sexaginta duos."
,"2":"Placuit Dario et constituit super regnum satrapas centum viginti, ut essent in toto regno suo,"
,"3":"et super eos principes tres, ex quibus Daniel unus erat, ut satrapae illis redderent rationem, et rex non sustineret molestiam."
,"4":"Igitur ille Daniel superabat omnes principes et satrapas, quia spiritus Dei amplior erat in eo. Porro rex cogitabat constituere eum super omne regnum;"
,"5":"unde principes et satrapae quaerebant, ut invenirent occasionem Danieli ex latere regni, nullamque causam et suspicionem reperire potuerunt, eo quod fidelis esset, et omnis culpa et suspicio non inveniretur in eo."
,"6":"Dixerunt ergo viri illi: ' Non inveniemus Danieli huic aliquam occasionem, nisi forte inveniamus adversus eum in lege Dei sui '."
,"7":"Tunc principes et satrapae illi concurrerunt ad regem et sic locuti sunt ei: ' Darie rex, in aeternum vive!"
,"8":"Consilium inierunt cuncti principes regni, magistratus et satrapae, optimates et iudices, ut decretum regis promulget et edictum confirmet, ut omnis, qui petierit aliquam petitionem a quocumque deo et homine usque ad dies triginta, nisi a te, rex, mittatur in lacum leonum."
,"9":"Nunc itaque, rex, confirma sententiam et signa decretum, ut non immutetur iuxta legem Medorum et Persarum, quam praevaricari non licet '."
,"10":"Porro rex Darius signavit edictum et decretum."
,"11":"Daniel autem, cum comperisset decretum signatum esse, ingressus est domum suam et, fenestris apertis in cenaculo suo contra Ierusalem, tribus temporibus in die flectebat genua sua et adorabat confitebaturque coram Deo suo, sicut et ante facere consueverat."
,"12":"Viri ergo illi accesserunt et invenerunt Danielem orantem et obsecrantem Deum suum."
,"13":"Tunc accesserunt et locuti sunt coram rege super edicto: ' Rex, numquid non signasti decretum, ut omnis homo, qui rogaret quemquam de diis et hominibus usque ad dies triginta, nisi a te, rex, mitteretur in lacum leonum? '. Respondens rex ait: ' Verus est sermo iuxta decretum Medorum atque Persarum, quod praevaricari non licet '."
,"14":"Tunc respondentes dixerunt coram rege: ' Daniel de filiis captivitatis Iudae non curavit de te, rex, et de edicto, quod constituisti, sed tribus temporibus per diem orat obsecratione sua'."
,"15":"Quod verbum cum audisset, rex satis contristatus est; et pro Daniele posuit cor, ut liberaret eum, et usque ad occasum solis laborabat, ut erueret illum."
,"16":"Viri autem illi accesserunt ad regem et dixerunt ei: ' Scito, rex, quia lex Medorum est atque Persarum, ut omne decretum et edictum, quod constituit rex, non liceat immutari '."
,"17":"Tunc rex praecepit, et adduxerunt Danielem et miserunt eum in lacum leonum. Dixitque rex Danieli: ' Deus tuus, quem colis semper, ipse liberet te '."
,"18":"Allatusque est lapis unus et positus est super os laci; quem obsignavit rex anulo suo et anulo optimatum suorum, ne quid fieret contra Danielem."
,"19":"Et abiit rex in domum suam et dormivit incenatus, cibique non sunt illati coram eo; insuper et somnus recessit ab eo."
,"20":"Tunc rex primo diluculo consurgens festinus ad lacum leonum perrexit;"
,"21":"appropinquansque lacui Danielem voce lacrimabili inclamavit et affatus est Danielem: ' Daniel, serve Dei viventis, Deus tuus, cui tu servis semper, putasne valuit liberare te a leonibus?'."
,"22":"Et Daniel regi respondens ait: ' Rex, in aeternum vive!"
,"23":"Deus meus misit angelum suum et conclusit ora leonum, et non nocuerunt mihi, quia coram eo iustitia inventa est in me; sed et coram te, rex, delictum non feci '."
,"24":"Tunc rex vehementer gavisus est super eo et Danielem praecepit educi de lacu; eductusque est Daniel de lacu, et nulla laesio inventa est in eo, quia credidit Deo suo."
,"25":"Dixit autem rex, et adducti sunt viri illi, qui accusaverant Danielem, et in lacum leonum missi sunt, ipsi et filii eorum et uxores eorum, et non pervenerunt usque ad pavimentum laci, donec potirentur eis leones, et omnia ossa eorum comminuerunt."
,"26":"Tunc Darius rex scripsit universis populis, tribubus et linguis, habitantibus in universa terra: 'Pax vobis multiplicetur!"
,"27":"A me constitutum est decretum, ut in universo imperio regni mei tremescant et paveant Deum Danielis: ipse est enim Deus vivens,et permanens in saecula, et regnum eius non dissipabitur, et potestas eius usque in aeternum;"
,"28":"ipse liberator atque salvator,et faciens signa et mirabilia,in caelo et in terra. Liberavit autem Danielem,de manu leonum '."
,"29":"Porro Daniel prosperatus est in regno Darii et in regno Cyri Persae."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Anno primo Balthasar regis Babylonis Daniel somnium vidit et visionem capitis eius in cubili suo; tunc et somnium scripsit. Caput verborum, quae locutus est."
,"2":"Respondit Daniel et dixit: ' Videbam in visione mea nocte: et ecce quattuor venti caeli conturbabant mare Magnum,"
,"3":"et quattuor bestiae grandes ascendebant de mari diversae inter se."
,"4":"Prima quasi leaena et alas habebat aquilae; aspiciebam, donec evulsae sunt alae eius; et sublata est de terra et super pedes quasi homo stetit, et cor hominis datum est ei."
,"5":"Et ecce bestia alia, secunda, similis urso in parte stetit, et tres costae erant in ore eius et in dentibus eius; et sic dicebant ei: 'Surge, comede carnes plurimas'."
,"6":"Post hoc aspiciebam, et ecce alia quasi pardus et alas habebat avis quattuor super se, et quattuor capita erant in bestia; et potestas data est ei."
,"7":"Post hoc aspiciebam in visione noctis, et ecce bestia quarta terribilis atque mirabilis et fortis nimis; dentes ferreos habebat magnos, comedens atque comminuens et reliqua pedibus suis conculcans; dissimilis autem erat ceteris bestiis, quas videram ante eam, et habebat cornua decem."
,"8":"Considerabam cornua, et ecce cornu aliud parvulum ortum est de medio eorum, et tria de cornibus primis evulsa sunt a facie eius; et ecce oculi quasi oculi hominis erant in cornu isto, et os loquens ingentia."
,"9":"Aspiciebam, donec throni positi sunt, et Antiquus dierum sedit. Vestimentum eius quasi nix candidum, et capilli capitis eius quasi lana munda; thronus eius flammae ignis, rotae eius ignis accensus."
,"10":"Fluvius igneus effluebat,et egrediebatur a facie eius; milia milium ministrabant ei, et decies milies centena milia assistebant ei: iudicium sedit, et libri aperti sunt."
,"11":"Aspiciebam tunc propter vocem sermonum grandium, quos cornu illud loquebatur; et vidi quoniam interfecta esset bestia, et perisset corpus eius, et tradita esset ad comburendum igni;"
,"12":"aliarum quoque bestiarum ablata esset potestas, et tempora vitae constituta essent eis usque ad tempus et tempus."
,"13":"Aspiciebam ergo in visione noctis: et ecce cum nubibus caeli,quasi Filius hominis veniebat,et usque ad Antiquum dierum pervenit, et in conspectu eius obtulerunt eum;"
,"14":"et data sunt ei potestas et honor et regnum; et omnes populi, tribus et linguae,ipsi servierunt: potestas eius potestas aeterna, quae non auferetur, et regnum eius, quod non corrumpetur."
,"15":"Horruit spiritus meus: ego Daniel territus sum in his, et visiones capitis mei conturbaverunt me."
,"16":"Accessi ad unum de assistentibus et veritatem quaerebam ab eo de omnibus his; qui dixit mihi et interpretationem sermonum edocuit me:"
,"17":"'Hae bestiae magnae quattuor, quattuor regna consurgent de terra;"
,"18":"suscipient autem regnum sancti Dei altissimi et obtinebunt regnum usque in saeculum et saeculum saeculorum'."
,"19":"Post hoc volui diligenter discere de bestia quarta, quae erat dissimilis valde ab omnibus his et terribilis nimis, dentes ferrei et ungues eius aerei, comedens et comminuens et reliquias pedibus suis conculcans,"
,"20":"et de cornibus decem, quae habebat in capite, et de alio, quod ortum fuerat ante, et ceciderant tria cornua, de cornu illo, quod habebat oculos et os loquens grandia et maius erat ceteris."
,"21":"Aspiciebam, et ecce cornu illud faciebat bellum adversus sanctos et praevalebat eis,"
,"22":"donec venit Antiquus dierum et iudicium dedit sanctis Excelsi, et tempus advenit, et regnum obtinuerunt sancti."
,"23":"Et sic ait: 'Bestia quarta regnum quartum erit in terra, quod maius erit omnibus regnis et devorabit universam terram et conculcabit et comminuet eam."
,"24":"Porro cornua decem regni decem reges erunt; et alius consurget post eos et ipse potentior erit prioribus et tres reges humiliabit"
,"25":"et sermones contra Excelsum loquetur et sanctos Altissimi conteret et putabit quod possit mutare tempora et legem, et tradentur in manu eius usque ad tempus et tempora et dimidium temporis;"
,"26":"et iudicium sedebit, et potentiam eius auferent, ut conteratur et dispereat usque in finem;"
,"27":"regnum autem et potestas et magnitudo regnorum, quae sunt subter omne caelum, detur populo sanctorum Altissimi, cuius regnum regnum sempiternum est, et omnes reges servient ei et oboedient' '."
,"28":"Hucusque finis verbi. Ego Daniel multum cogitationibus meis conturbabar, et facies mea mutata est in me; verbum autem in corde meo conservavi."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Anno tertio regni Balthasar regis visio apparuit mihi, ego Daniel, post id quod mihi apparuerat in principio."
,"2":"Vidi in visione, et factum est, dum viderem, eram in Susis castro, quod est in Elam provincia; vidi autem in visione esse me super rivum Ulai."
,"3":"Et levavi oculos meos et vidi: et ecce aries unus stabat ante rivum habens cornua et cornua excelsa et unum excelsius altero, et excelsius crescebat in postero."
,"4":"Vidi arietem cornibus ventilantem contra occidentem et contra aquilonem et contra meridiem, et omnes bestiae non poterant resistere ei neque liberari de manu eius; fecitque secundum voluntatem suam et magnificatus est."
,"5":"Et ego intellegebam: ecce autem hircus caprarum veniebat ab occidente super faciem totius terrae et non tangebat terram; porro hircus habebat cornu insigne inter oculos suos."
,"6":"Et venit usque ad arietem illum cornutum, quem videram stantem ante rivum, et cucurrit ad eum in impetu fortitudinis suae."
,"7":"Vidi eum appropinquantem prope arietem, et efferatus est in eum et percussit arietem et comminuit duo cornua eius, et non poterat aries resistere ei; cumque eum misisset in terram, conculcavit, et nemo quibat liberare arietem de manu eius."
,"8":"Hircus autem caprarum magnus factus est nimis; cumque crevisset, fractum est cornu magnum, et orta sunt quattuor cornua loco illius per quattuor ventos caeli."
,"9":"De uno autem ex eis egressum est cornu unum modicum et factum est grande contra meridiem et contra orientem et contra fortitudinem"
,"10":"et magnificatum est usque ad fortitudinem caeli et deiecit de fortitudine et de stellis et conculcavit eas;"
,"11":"et usque ad principem fortitudinis magnificatum est et ab eo tulit iuge sacrificium et deiecit locum sanctificationis eius."
,"12":"Militia autem data est contra iuge sacrificium propter peccata, et prostrata est veritas in terra; cornu autem fecit et prosperatum est."
,"13":"Et audivi unum de sanctis loquentem, et dixit unus sanctus alteri, nescio cui, loquenti: ' Usquequo visio et iuge sacrificium et peccatum desolationis, quae facta est, et sanctuarium et fortitudo conculcabitur? '."
,"14":"Et dixit ei: ' Usque ad vesperam et mane, dies duo milia trecenti; et mundabitur sanctuarium '."
,"15":"Factum est autem cum viderem ego Daniel visionem et quaererem intellegentiam, ecce stetit in conspectu meo quasi species viri;"
,"16":"et audivi vocem viri inter Ulai, et clamavit et ait: ' Gabriel, fac intellegere istum visionem '."
,"17":"Et venit et stetit iuxta, ubi ego stabam; cumque venisset, pavens corrui in faciem meam, et ait ad me: 'Intellege, fili hominis, quoniam in tempore finis complebitur visio '."
,"18":"Cumque loqueretur ad me, collapsus sum pronus in terram, et tetigit me et statuit me in gradu meo"
,"19":"dixitque: ' Ecce ego ostendam tibi, quae futura sint in novissimo maledictionis, quoniam in tempore erit finis."
,"20":"Aries, quem vidisti habere cornua, reges Medorum est atque Persarum;"
,"21":"porro hircus caprarum rex Graecorum est, et cornu grande, quod erat inter oculos eius, ipse est rex primus."
,"22":"Quod autem, fracto illo, surrexerunt quattuor pro eo, quattuor regna de gente eius consurgent sed non in fortitudine eius."
,"23":"Et post regnum eorum, cum creverint iniquitate, consurget rex impudens facie et intellegens propositiones;"
,"24":"et roborabitur fortitudo eius sed non in viribus suis, et supra quam credi potest universa vastabit et prosperabitur et faciet et interficiet robustos et populum sanctorum,"
,"25":"et secundum sapientiam suam prosperabitur dolus in manu eius, et in corde suo magnificabitur et in tranquillitate occidet plurimos et contra principem principum consurget et sine manu conteretur."
,"26":"Et visio vespere et mane, quae dicta est, vera est; tu ergo signa visionem, quia post dies multos erit '."
,"27":"Et ego Daniel langui et aegrotavi per dies; cumque surrexissem, faciebam opera regis et stupebam ad visionem, et non erat qui intellegeret."
}`)
	CurrentBook.AddChapter(9, `{
"1":"In anno primo Darii filii Asueri de semine Medorum, qui impe ravit super regnum Chaldaeorum,"
,"2":"anno uno regni eius, ego Daniel intellexi in libris numerum annorum, de quo factus est sermo Domini ad Ieremiam prophetam, ut complerentur desolationes Ierusalem, septuaginta anni;"
,"3":"et posui faciem meam ad Dominum Deum meum, ut quaererem rogationem et deprecationem in ieiuniis, sacco et cinere."
,"4":"Et oravi Dominum Deum et confessus sum et dixi: ' Obsecro, Domine, Deus magne et terribilis, custodiens pactum et misericordiam diligentibus eum et custodientibus mandata eius; "
,"5":"peccavimus, inique fecimus, impie egimus et recessimus et declinavimus a mandatis tuis ac iudiciis tuis;"
,"6":"non oboedivimus servis tuis prophetis, qui locuti sunt in nomine tuo regibus nostris, principibus nostris, patribus nostris omnique populo terrae."
,"7":"Tibi, Domine, iustitia; nobis autem confusio faciei, sicut est hodie viro Iudae et habitatoribus Ierusalem et omni Israel, his qui prope sunt et his qui procul in universis terris, ad quas eiecisti eos propter iniquitates eorum, in quibus peccaverunt in te."
,"8":"Domine, nobis confusio faciei, regibus nostris, principibus nostris et patribus nostris, quia peccavimus tibi;"
,"9":"Domino autem, Deo nostro, misericordia et propitiatio, quia recessimus a te."
,"10":"Et non audivimus vocem Domini Dei nostri, ut ambularemus in lege eius, quam posuit nobis per servos suos prophetas;"
,"11":"et omnis Israel praevaricati sunt legem tuam et declinaverunt, ne audirent vocem tuam, et stillavit super nos maledictio et detestatio, quae scripta est in libro Moysis servi Dei, quia peccavimus ei."
,"12":"Et statuit sermones suos, quos locutus est super nos et super iudices nostros, qui iudicaverunt nos, ut superducerent in nos magnum malum, quale numquam fuit sub omni caelo, secundum quod factum est in Ierusalem."
,"13":"Sicut scriptum est in lege Moysis, omne malum hoc venit super nos, et non rogavimus faciem Domini Dei nostri, ut reverteremur ab iniquitatibus nostris et cogitaremus veritatem tuam."
,"14":"Et vigilavit Dominus super malitiam et adduxit eam super nos, quia iustus Dominus Deus noster in omnibus operibus suis, quae fecit; non enim audivimus vocem eius."
,"15":"Et nunc, Domine Deus noster, qui eduxisti populum tuum de terra Aegypti in manu forti et fecisti tibi nomen secundum diem hanc, peccavimus, iniquitatem fecimus,"
,"16":"Domine, in omnem iustitiam tuam; avertatur, obsecro, ira tua et furor tuus a civitate tua Ierusalem et monte sancto tuo; propter peccata enim nostra et iniquitates patrum nostrorum Ierusalem et populus tuus in opprobrium sunt omnibus per circuitum nostrum."
,"17":"Nunc ergo exaudi, Deus noster, orationem servi tui et preces eius et ostende faciem tuam super sanctuarium tuum, quod desertum est, propter temetipsum."
,"18":"Inclina, Deus meus, aurem tuam et audi; aperi oculos tuos et vide desolationem nostram et civitatem, super quam invocatum est nomen tuum; neque enim in iustificationibus nostris prosternimus preces ante faciem tuam sed in miserationibus tuis multis."
,"19":"Exaudi, Domine! Placare, Domine! Attende et fac! Ne moreris propter temetipsum, Deus meus, quia nomen tuum invocatum est super civitatem et super populum tuum '."
,"20":"Cumque adhuc loquerer et orarem et confiterer peccata mea et peccata populi mei Israel et prosternerem preces meas in conspectu Dei mei pro monte sancto Dei mei,"
,"21":"adhuc me loquente in oratione, ecce vir Gabriel, quem videram in visione principio, cito volans tetigit me in tempore sacrificii vespertini;"
,"22":"et docuit me et locutus est mihi dixitque: 'Daniel, nunc egressus sum, ut docerem te, et intellegeres."
,"23":"Ab exordio precum tuarum egressus est sermo; ego autem veni, ut indicarem, quia vir desideriorum es tu; ergo animadverte sermonem et intellege visionem."
,"24":"Septuaginta hebdomades decretae sunt,super populum tuum et super urbem sanctam tuam, ut consummetur praevaricatio, et finem accipiat peccatum, et deleatur iniquitas, et adducatur iustitia sempiterna, et impleatur visio et prophetes, et ungatur Sanctus sanctorum."
,"25":"Scito ergo et animadverte: ab exitu sermonis,ut iterum aedificetur Ierusalem,usque ad christum ducem, hebdomades septem. Et hebdomades sexaginta duae erunt; et rursum aedificabitur platea et muri,in angustia temporum."
,"26":"Et post hebdomades sexaginta duas,occidetur christus; et nihil erit ei. Et civitatem et sanctuarium dissipabit,populus ducis venturi, et finis eius vastitas, et usque ad finem belli,statuta desolatio."
,"27":"Confirmabit autem pactum multis,hebdomade una; et in dimidio hebdomadi,deficiet hostia et sacrificium, et erit super alam abominationis vastator, et usquedum consummatio et decretum,effundantur super vastatorem '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Anno tertio Cyri regis Per sarum verbum revelatum est Danieli cognomento Baltassar, et verum verbum et acies magna; intellexitque sermonem, intellegentia enim fuit ei in visione."
,"2":"In diebus illis ego Daniel lugebam tribus hebdomadis dierum,"
,"3":"panem desiderabilem non comedi, et caro et vinum non introierunt in os meum, sed neque unguento unctus sum, donec complerentur tres hebdomades dierum."
,"4":"Die autem vicesima et quarta mensis primi eram iuxta fluvium magnum, qui est Tigris,"
,"5":"et levavi oculos meos et vidi: et ecce vir unus vestitus lineis, et renes eius accincti auro obryzo;"
,"6":"et corpus eius quasi chrysolithus, et facies eius velut species fulgoris, et oculi eius ut lampas ardens, et brachia eius et, quae deorsum sunt usque ad pedes, quasi species aeris candentis, et vox sermonum eius ut vox multitudinis."
,"7":"Vidi autem ego Daniel solus visionem; porro viri, qui erant mecum, visionem non viderunt, sed terror nimius irruit super eos, et fugerunt in absconditum."
,"8":"Ego autem relictus solus vidi visionem grandem hanc, et non remansit in me fortitudo, sed et species mea immutata est in me usque ad dissipationem, nec habui quidquam virium."
,"9":"Et audivi vocem sermonum eius; et audiens vocem sermonum eius iacebam consternatus super faciem meam, et vultus meus haerebat terrae."
,"10":"Et ecce manus tetigit me et erexit me super genua mea et super palmas manuum mearum,"
,"11":"et dixit ad me: ' Daniel, vir desideriorum, intellege verba, quae ego loquor ad te, et sta in gradu tuo; nunc enim sum missus ad te '. Cumque dixisset mihi sermonem istum, steti tremens."
,"12":"Et ait ad me: ' Noli metuere, Daniel, quia ex die primo, quo posuisti cor tuum ad intellegendum et ad humiliandum te in conspectu Dei tui, exaudita sunt verba tua; et ego veni propter sermones tuos."
,"13":"Princeps autem regni Persarum restitit mihi viginti et uno diebus; et ecce Michael, unus de principibus primis, venit in adiutorium meum; et ego remansi ibi iuxta regem Persarum."
,"14":"Veni autem, ut docerem te, quae ventura sunt populo tuo in novissimis diebus, quoniam adhuc visio in dies '."
,"15":"Cumque loqueretur mihi huiuscemodi verbis, deieci vultum meum ad terram et tacui."
,"16":"Et ecce quasi similitudo filiorum hominis tetigit labia mea; et aperiens os meum locutus sum et dixi ad eum, qui stabat contra me: ' Domine mi, in visione angustiae venerunt super me, et nihil in me remansit virium."
,"17":"Et quomodo poterit servus domini mei loqui cum hoc domino meo? Nihil enim in me remansit virium, et halitus meus non remansit in me '."
,"18":"Rursum ergo tetigit me quasi visio hominis et confortavit me"
,"19":"et dixit: 'Noli timere, vir desideriorum; pax tibi, confortare et esto robustus '. Cumque loqueretur mecum, convalui et dixi: ' Loquere, domine mi, quia confortasti me '."
,"20":"Et ait: ' Numquid scis, quare venerim ad te? Et nunc revertar, ut proelier adversum principem Persarum. Et ego egrediar, et ecce princeps Graecorum veniens."
,"21":"Verumtamen annuntiabo tibi, quod expressum est in scriptura veritatis; et nemo est adiutor meus adversus hos, nisi Michael princeps vester."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Ego autem ab anno primo Darii Medi astabam ei, ut confortaretur et roboraretur."
,"2":"Et nunc veritatem annuntiabo tibi: Ecce adhuc tres reges stabunt pro Perside, et quartus ditabitur opibus nimis super omnes et, cum invaluerit divitiis suis, concitabit omnia adversum regnum Graeciae."
,"3":"Surget vero rex fortis et dominabitur dominatione multa et faciet, quod placuerit ei;"
,"4":"et cum steterit, conteretur regnum eius et dividetur in quattuor ventos caeli, sed non in posteros eius neque secundum potentiam illius, qua dominatus est; lacerabitur enim regnum eius etiam ad alios, exceptis his."
,"5":"Et confortabitur rex austri, et unus de principibus eius praevalebit super eum et dominabitur dominatione super dominationem eius."
,"6":"Et post finem annorum foederabuntur; filiaque regis austri veniet ad regem aquilonis facere amicitiam. Et non obtinebit fortitudinem brachii, nec stabit brachium eius; et tradetur ipsa, et qui adduxerunt eam, et adulescens eius, et qui confortabat eam in temporibus."
,"7":"Et stabit de germine radicum eius plantatio loco eius et veniet ad exercitum et ingredietur oppidum regis aquilonis; et faciet adversus eos et confortabitur."
,"8":"Insuper et deos eorum cum sculptilibus eorum et vasis pretiosis argenti et auri captivos ducet in Aegyptum: ipse per aliquot annos praevalebit adversus regem aquilonis."
,"9":"Et intrabit in regnum regis austri et revertetur ad terram suam."
,"10":"Filii autem eius provocabuntur et congregabunt multitudinem exercituum plurimorum; et veniet properans et inundans et revertetur et concitabitur et congredietur usque ad oppidum eius."
,"11":"Et provocabitur rex austri et egredietur et pugnabit adversus eum, adversus regem aquilonis; et praeparabit multitudinem nimiam, et dabitur multitudo in manu eius."
,"12":"Et tolletur multitudo, et exaltabitur cor eius, et deiciet multa milia, sed non praevalebit."
,"13":"Revertetur enim rex aquilonis et praeparabit multitudinem maiorem quam prius; et in fine temporum annorumque veniet properans cum exercitu magno et opibus nimis."
,"14":"Et in temporibus illis multi consurgent adversus regem austri, filii quoque praevaricatorum populi tui extollentur, ut impleant visionem, et corruent."
,"15":"Et veniet rex aquilonis et comportabit aggerem et capiet urbem munitissimam; et brachia austri non sustinebunt, et populo electorum eius non erit fortitudo ad resistendum."
,"16":"Et faciet veniens super eum iuxta placitum suum, et non erit qui stet contra faciem eius; et stabit in terra inclita, et consumptio in manu eius."
,"17":"Et ponet faciem suam, ut veniat ad tenendum universum regnum eius, et recta faciet cum eo et filiam feminarum dabit ei, ut evertat illud; et non stabit nec illius erit."
,"18":"Et convertet faciem suam ad insulas et capiet multas, et cessare faciet princeps opprobrium eius, et opprobrium eius convertetur in eum."
,"19":"Et convertet faciem suam ad oppida terrae suae et impinget et corruet, et non invenietur."
,"20":"Et stabit in loco eius, qui mittat exactorem in decus regni; et in paucis diebus conteretur, non in furore nec in proelio."
,"21":"Et stabit in loco eius despectus, et non tribuetur ei honor regius; et veniet clam et obtinebit regnum in fraudulentia."
,"22":"Et brachia pugnantis expugnabuntur a facie eius et conterentur; insuper et dux foederis."
,"23":"Et post amicitias, cum eo faciet dolum et ascendet et superabit in modico populo."
,"24":"In prosperitate uberes urbes ingredietur et faciet, quae non fecerunt patres eius et patres patrum eius: rapinas et praedam et divitias eorum dissipabit et contra oppida cogitationes inibit, et hoc usque ad tempus."
,"25":"Et concitabitur fortitudo eius et cor eius adversum regem austri in exercitu magno; et rex austri provocabitur ad bellum multis auxiliis et fortibus nimis, et non stabit, quia inibunt adversus eum consilia."
,"26":"Et comedentes panem cum eo conterent illum; exercitusque eius opprimetur, et cadent interfecti plurimi."
,"27":"Duorum quoque regum cor erit, ut malefaciant et ad mensam unam mendacium loquentur et non proficient, quia adhuc finis in aliud tempus."
,"28":"Et revertetur in terram suam cum opibus multis, et cor eius adversum testamentum sanctum; et faciet et revertetur in terram suam."
,"29":"Statuto tempore revertetur et veniet ad austrum, et non erit priori simile novissimum."
,"30":"Et venient super eum trieres, Romani; et percutietur et revertetur et indignabitur contra testamentum sanctum et faciet reverteturque et cogitabit adversum eos, qui dereliquerunt testamentum sanctum."
,"31":"Et brachia ex eo stabunt et polluent sanctuarium fortitudinis et auferent iuge sacrificium et dabunt abominationem vastatoris."
,"32":"Et impios in testamentum errare faciet fraudulenter; populus autem scientium Deum suum obtinebit et faciet."
,"33":"Et docti in populo docebunt plurimos; et ruent in gladio et in flamma et in captivitate et in rapina per dies."
,"34":"Cumque corruerint, sublevabuntur auxilio parvulo, et applicabuntur eis plurimi fraudulenter."
,"35":"Et de eruditis ruent, ut aliqui eorum conflentur et purgentur et dealbentur usque ad tempus praefinitum, quia adhuc aliud tempus erit."
,"36":"Et faciet iuxta voluntatem suam rex et elevabitur et magnificabitur adversus omnem deum et adversus Deum deorum loquetur magnifica et prosperabitur, donec compleatur iracundia; perpetrata quippe est definitio."
,"37":"Et deos patrum suorum non reputabit neque concupiscentiam feminarum nec quemquam deorum curabit, quia super universa magnificabit se;"
,"38":"deum autem oppidorum in loco suo venerabitur et deum, quem ignoraverunt patres eius, colet auro et argento et lapide pretioso rebusque pretiosis"
,"39":"et faciet adversus oppida munita cum deo alieno; qui cognoverit eum, multiplicabit gloriam eius et dabit eis potestatem in multis et terram dividet pretio."
,"40":"Et in tempore praefinito proeliabitur adversus eum rex austri, et quasi tempestas veniet contra illum rex aquilonis in curribus et in equitibus et in classe magna, et ingredietur terras et conteret et pertransiet."
,"41":"Et introibit in terram gloriosam, et multae corruent; hae autem solae salvabuntur de manu eius: Edom et Moab et principium filiorum Ammon."
,"42":"Et mittet manum suam in terras, et terra Aegypti non effugiet;"
,"43":"et dominabitur thesaurorum auri et argenti et in omnibus pretiosis Aegypti, et Libyes et Aethiopes in vestigia eius transibunt."
,"44":"Et fama turbabit eum ab oriente et ab aquilone; et veniet in ira magna, ut conterat et interficiat plurimos,"
,"45":"et figet tabernacula palatii sui inter maria super montem sanctum decoris; et veniet usque ad summitatem eius, et nemo auxiliabitur ei."
}`)
	CurrentBook.AddChapter(12, `{
"1":"In tempore autem illo con surget Michael, princeps magnus, qui stat pro filiis populi tui, et erit tempus angustiae, quale non fuit ab eo, quo gentes esse coeperunt, usque ad tempus illud. Et in tempore illo salvabitur populus tuus, omnis, qui inventus fuerit scriptus in libro."
,"2":"Et multi de his, qui dormiunt in terra pulveris, evigilabunt: alii in vitam aeternam, et alii in opprobrium sempiternum."
,"3":"Qui autem docti fuerint, fulgebunt quasi splendor firmamenti; et, qui ad iustitiam erudierint multos, quasi stellae in perpetuas aeternitates."
,"4":"Tu autem, Daniel, claude sermones et signa librum usque ad tempus finis; pertransibunt plurimi, et multiplex erit scientia '."
,"5":"Et vidi ego Daniel: et ecce duo alii stabant, unus hinc super ripam fluminis, et alius inde ex altera ripa fluminis."
,"6":"Et dixit viro, qui indutus erat lineis, qui stabat super aquas fluminis: ' Usquequo finis horum mirabilium? '."
,"7":"Et audivi virum, qui indutus erat lineis, qui stabat super aquas fluminis, cum levasset dexteram et sinistram suam in caelum et iurasset per Viventem in aeternum: ' Quia in tempus, tempora et dimidium temporis; et cum completa fuerit dispersio manus populi sancti, complebuntur universa haec '."
,"8":"Et ego audivi et non intellexi et dixi: ' Domine mi, quid erit finis horum? '."
,"9":"Et ait: ' Vade, Daniel, quia clausi sunt signatique sermones usque ad tempus praefinitum."
,"10":"Purificabuntur et dealbabuntur et probabuntur multi, et impie agent impii, neque intellegent omnes impii; porro docti intellegent."
,"11":"Et a tempore, cum ablatum fuerit iuge sacrificium, et posita fuerit abominatio vastatoris, dies mille ducenti nonaginta."
,"12":"Beatus, qui exspectat et pervenit usque ad dies mille trecentos triginta quinque."
,"13":"Tu autem vade ad finem et requiesce; et stabis in sorte tua in fine dierum '. (Hucusque Daniel in Hebraeo volumine legimus. Cetera, quae sequuntur usque ad finem libri, de Theodotionis editione translata sunt)."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Et erat vir habitans in Ba bylone, et nomen eius Ioa chim;"
,"2":"et accepit uxorem nomine Susannam, filiam Helciae, pulchram nimis et timentem Dominum;"
,"3":"parentes enim illius, cum essent iusti, erudierunt filiam suam secundum legem Moysis."
,"4":"Erat autem Ioachim dives valde, et erat ei pomerium vicinum domui suae; et ad ipsum confluebant Iudaei, eo quod esset honorabilior omnium."
,"5":"Et constituti sunt de populo duo senes iudices in anno illo, de quibus locutus est Dominus quia egressa est iniquitas de Babylone a senibus iudicibus, qui videbantur regere populum."
,"6":"Isti frequentabant domum Ioachim, et veniebant ad eos omnes, qui habebant iudicia."
,"7":"Cum autem populus revertisset per meridiem, ingrediebatur Susanna et deambulabat in pomerio viri sui."
,"8":"Et videbant eam duo senes cotidie ingredientem et deambulantem et facti sunt in concupiscentia eius"
,"9":"et everterunt sensum suum et declinaverunt oculos suos, ut non viderent caelum neque recordarentur iudiciorum iustorum."
,"10":"Erant ergo ambo vulnerati amore eius nec indicaverunt sibi vicissim dolorem suum;"
,"11":"erubescebant enim indicare concupiscentiam suam, volentes concumbere cum ea."
,"12":"Et observabant cotidie sollicitius videre eam. Dixitque alter ad alterum:"
,"13":"' Eamus domum, quia prandi hora est '. Et egressi recesserunt a se."
,"14":"Cumque revertissent, venerunt in unum et, sciscitantes ab invicem causam, confessi sunt concupiscentiam suam; et tunc in commune statuerunt tempus, quando eam possent invenire solam."
,"15":"Factum est autem, cum observarent diem aptum, ingressa est aliquando sicut heri et nudiustertius cum duabus solis puellis voluitque lavari in pomerio, aestus quippe erat."
,"16":"Et non erat ibi quisquam, praeter duos senes absconditos et contemplantes eam."
,"17":"Dixit ergo puellis: ' Afferte mihi oleum et smegmata et ostia pomerii claudite, ut laver '."
,"18":"Et fecerunt, sicut praeceperat; clauseruntque ostia pomerii et egressae sunt per posticium, ut afferrent, quae iusserat; nesciebantque senes intus esse absconditos."
,"19":"Cum autem egressae essent puellae, surrexerunt duo senes et accurrerunt ad eam et dixerunt:"
,"20":"' Ecce ostia pomerii clausa sunt, et nemo nos videt, et in concupiscentia tui sumus; quam ob rem assentire nobis et commiscere nobiscum."
,"21":"Quod si nolueris, dicemus testimonium contra te, quod fuerit tecum iuvenis et ob hanc causam emiseris puellas a te '."
,"22":"Ingemuit Susanna et ait: ' Angustiae sunt mihi undique: si enim hoc egero, mors mihi est; si autem non egero, non effugiam manus vestras;"
,"23":"sed melius mihi est absque opere incidere in manus vestras quam peccare in conspectu Domini '."
,"24":"Et exclamavit voce magna Susanna; exclamaverunt autem et senes adversus eam,"
,"25":"et, cum cucurrisset unus, aperuit ostia pomerii."
,"26":"Cum ergo audissent clamorem in pomerio famuli domus, irruerunt per posticam, ut viderent quidnam esset ei."
,"27":"Postquam autem senes locuti sunt sermones suos, erubuerunt servi vehementer, quia numquam dictus fuerat sermo huiuscemodi de Susanna. Et factum est die crastina,"
,"28":"cum venisset populus ad virum eius Ioachim, venerunt et duo presbyteri pleni iniqua cogitatione adversum Susannam, ut interficerent eam;"
,"29":"et dixerunt coram populo: ' Mittite ad Susannam, filiam Helciae, quae est uxor Ioachim '; et miserunt."
,"30":"Et venit cum parentibus et filiis et universis cognatis suis."
,"31":"Porro Susanna erat delicata nimis et pulchra specie."
,"32":"At iniqui illi iusserunt, ut discooperiretur - erat enim cooperta - ut satiarentur decore eius."
,"33":"Flebant igitur sui et omnes, qui videbant eam."
,"34":"Consurgentes autem duo presbyteri in medio populi, posuerunt manus super caput eius;"
,"35":"quae flens suspexit ad caelum: erat enim cor eius fiduciam habens in Domino."
,"36":"Et dixerunt presbyteri: ' Cum deambularemus in pomerio soli, ingressa est haec cum duabus puellis et clausit ostia pomerii et dimisit puellas;"
,"37":"venitque ad eam adulescens, qui erat absconditus, et concubuit cum ea."
,"38":"Porro nos cum essemus in angulo pomerii, videntes iniquitatem cucurrimus ad eos et vidimus eos commisceri."
,"39":"Et illum quidem non quivimus comprehendere, quia fortior nobis erat et, apertis ostiis, exilivit."
,"40":"Hanc autem cum apprehendissemus, interrogavimus, quisnam esset adulescens, et noluit indicare nobis. Huius rei testes sumus '."
,"41":"Credidit eis multitudo quasi senibus populi et iudicibus, et condemnaverunt eam ad mortem."
,"42":"Exclamavit autem voce magna Susanna et dixit: ' Deus aeterne, qui absconditorum es cognitor, qui nosti omnia antequam fiant,"
,"43":"tu scis quoniam falsum contra me tulerunt testimonium; et ecce morior, cum nihil horum fecerim, quae isti malitiose composuerunt adversum me '."
,"44":"Exaudivit autem Dominus vocem eius."
,"45":"Cumque duceretur ad mortem, suscitavit Deus spiritum sanctum pueri iunioris, cuius nomen Daniel;"
,"46":"et exclamavit voce magna: ' Innocens ego sum a sanguine huius '."
,"47":"Et conversus omnis populus ad eum dixit: ' Quis est iste sermo, quem tu locutus es? '."
,"48":"Qui cum staret in medio eorum, ait: ' Sic fatui, filii Israel? Non iudicantes neque, quod verum est, cognoscentes, condemnastis filiam Israel!"
,"49":"Revertimini ad iudicium, quia falsum testimonium locuti sunt adversum eam '."
,"50":"Reversus est ergo omnis populus cum festinatione, et dixerunt ei senes: ' Veni et sede in medio nostrum et indica nobis, quia tibi dedit Deus honorem senectutis '."
,"51":"Et dixit ad eos Daniel: ' Separate illos ab invicem procul, et diiudicabo eos '."
,"52":"Cum ergo divisi essent alter ab altero, vocavit unum de eis et dixit ad eum: ' Inveterate dierum malorum, nunc venerunt peccata tua, quae operabaris prius,"
,"53":"iudicans iudicia iniusta, innocentes opprimens et dimittens noxios, dicente Domino: 'Innocentem et iustum non interficies'."
,"54":"Nunc ergo, si vidisti eam, dic sub qua arbore videris eos loquentes sibi '. Qui ait: ' Sub schino '."
,"55":"Dixit autem Daniel: ' Recte mentitus es in caput tuum; ecce enim angelus Dei, accepta sententia a Deo, scindet te medium '."
,"56":"Et amoto eo, iussit adduci alium et dixit ei: ' Semen Chanaan et non Iudae, species decepit te, et concupiscentia subvertit cor tuum."
,"57":"Sic faciebatis filiabus Israel, et illae timentes loquebantur vobis, sed non filia Iudae sustinuit iniquitatem vestram."
,"58":"Nunc ergo dic mihi sub qua arbore comprehenderis eos colloquentes sibi '. Qui ait: ' Sub prino '. "
,"59":"Dixit autem ei Daniel: ' Recte mentitus es et tu in caput tuum; manet enim angelus Dei, gladium habens, ut secet te medium et interficiat vos '."
,"60":"Exclamavit itaque omnis coetus voce magna et benedixerunt Deo, qui salvat sperantes in se."
,"61":"Et consurrexerunt adversum duos presbyteros - convicerat enim eos Daniel ex ore suo falsum dixisse testimonium - feceruntque eis, sicut male egerant adversum proximum,"
,"62":"ut facerent secundum legem Moysis; et interfecerunt eos, et salvatus est sanguis innoxius in die illa."
,"63":"Helcias autem et uxor eius laudaverunt Deum pro filia sua Susanna, cum Ioachim marito eius et cognatis omnibus, quia non esset inventa in ea res turpis."
,"64":"Daniel autem factus est magnus in conspectu populi a die illa et deinceps."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Et rex Astyages appositus est ad patres suos, et suscepit Cyrus Perses regnum eius."
,"2":"Erat autem Daniel conviva regis et honoratus super omnes amicos eius."
,"3":"Erat quoque idolum nomine Bel apud Babylonios, ct impendebantur in eo per dies singulos similae artabae duodecim et oves quadraginta vinique metretae sex."
,"4":"Rex quoque colebat eum et ibat per singulos dies adorare eum; porro Daniel adorabat Deum suum. Dixitque ei rex: ' Quare non adoras Bel? '."
,"5":"Qui respondens ait ei: ' Quia non colo idola manufacta sed viventem Deum, qui creavit caelum et terram et habet potestatem omnis carnis '."
,"6":"Et dixit ad eum rex: 'Non tibi videtur esse Bel vivens deus? An non vides, quanta comedat et bibat cotidie? '."
,"7":"Et ait Daniel arridens: ' Ne erres, rex; iste enim intrinsecus luteus est et forinsecus aereus, neque comedit neque bibit aliquando '."
,"8":"Et iratus rex vocavit sacerdotes eius et ait eis: ' Nisi dixeritis mihi, quis est qui comedat impensas has, moriemini;"
,"9":"si autem ostenderitis quoniam Bel comedat haec, morietur Daniel, quia blasphemavit in Bel '. Et dixit Daniel regi: ' Fiat iuxta verbum tuum '."
,"10":"Erant autem sacerdotes Bel septuaginta, exceptis uxoribus et parvulis et filiis. Et venit rex cum Daniele in templum Belis."
,"11":"Et dixerunt sacerdotes Belis: ' Ecce nos egredimur foras; et tu, rex, affer escas et vinum miscens pone et claude ostium et signa anulo tuo;"
,"12":"et, cum ingressus fueris mane, nisi inveneris omnia comesta a Bel, morte moriemur, vel Daniel, qui mentitus est adversum nos '."
,"13":"Contemnebant autem, quia fecerant sub mensa absconditum introitum et per illum ingrediebantur semper et devorabant ea."
,"14":"Factum est igitur, postquam egressi sunt illi, et rex posuit cibos ante Bel; et praecepit Daniel pueris suis, et attulerunt cinerem et cribraverunt per totum templum coram rege solo et egressi clauserunt ostium et signantes anulo regis abierunt."
,"15":"Sacerdotes autem ingressi sunt nocte iuxta consuetudinem suam et uxores et filii eorum et comederunt omnia et biberunt."
,"16":"Surrexit autem rex primo diluculo, et Daniel cum eo;"
,"17":"et ait rex: ' Salvane sunt signa, Daniel? '. Qui respondit: ' Salva, rex '."
,"18":"Statimque cum aperuisset ostium, intuitus rex mensam, exclamavit voce magna: ' Magnus es, Bel, et non est apud te dolus quisquam '."
,"19":"Et risit Daniel et tenuit regem, ne ingrederetur intro, et dixit: ' Ecce pavimentum; animadverte, cuius vestigia sunt haec '."
,"20":"Et dixit rex: ' Video vestigia virorum et mulierum et infantium '. Et iratus est rex."
,"21":"Tunc apprehendit sacerdotes et uxores et filios eorum, et ostenderunt ei abscondita ostiola, per quae ingrediebantur et consumebant, quae erant super mensam."
,"22":"Occidit ergo illos rex et tradidit Bel in potestate Danieli, qui subvertit eum et templum eius."
,"23":"Et erat draco magnus, et colebant eum Babylonii."
,"24":"Et dixit rex Danieli: ' Non potes dicere quia iste non sit deus vivens; adora ergo eum '."
,"25":"Dixitque Daniel: ' Dominum Deum meum adoro, quia ipse est Deus vivens."
,"26":"Tu autem, rex, da mihi potestatem, et interficiam draconem absque gladio et fuste '. Et ait rex: ' Do tibi '."
,"27":"Tulit ergo Daniel picem et adipem et pilos et coxit pariter; fecitque massas et dedit in os draconis et, cum comedisset, diruptus est draco. Et dixit: ' Ecce quae colebatis '."
,"28":"Cum audissent Babylonii, indignati sunt vehementer et congregati adversum regem dixerunt: 'Iudaeus factus est rex; Bel destruxit, draconem interfecit et sacerdotes occidit '."
,"29":"Et dixerunt, cum venissent ad regem: ' Trade nobis Danielem; alioquin interficiemus te et domum tuam '."
,"30":"Vidit ergo rex quod irruerent in eum vehementer et, necessitate compulsus, tradidit eis Danielem."
,"31":"Qui miserunt eum in lacum leonum, et erat ibi diebus sex."
,"32":"Porro in lacu erant septem leones, et dabantur eis cotidie duo corpora et duae oves; et tunc non data sunt eis, ut devorarent Danielem."
,"33":"Erat autem Abacuc propheta in Iudaea et ipse coxerat pulmentum et intriverat panes in alveolo et ibat in campum, ut ferret messoribus."
,"34":"Dixitque angelus Domini ad Abacuc: ' Fer prandium, quod habes, in Babylonem Danieli, qui est in lacu leonum '."
,"35":"Et dixit Abacuc: ' Domine, Babylonem non vidi et lacum nescio '."
,"36":"Et apprehendit eum angelus Domini in vertice eius et portavit eum capillo capitis sui posuitque eum in Babylone supra lacum in impetu spiritus sui."
,"37":"Et clamavit Abacuc dicens: ' Daniel, Daniel, tolle prandium, quod misit tibi Deus '."
,"38":"Et ait Daniel: 'Recordatus es enim mei, Deus, et non dereliquisti diligentes te '."
,"39":"Surgensque Daniel comedit. Porro angelus Dei restituit Abacuc confestim in loco suo."
,"40":"Venit ergo rex die septima, ut lugeret Danielem; et venit ad lacum et introspexit, et ecce Daniel sedens."
,"41":"Et exclamavit rex voce magna dicens: 'Magnus es, Domine, Deus Danielis, et non est alius praeter te '."
,"42":"Porro illos, qui perditionis eius causa fuerant, intromisit in lacum; et devorati sunt in momento coram eo."
}`)

}
func LA_NVBSE_LoadVMEZChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Et factum est in tricesimo anno, in quarto mense, in quinta men sis, cum essem in medio captivorum iuxta fluvium Chobar, aperti sunt caeli, et vidi visiones Dei."
,"2":"In quinta mensis, ipse est annus quintus transmigrationis regis Ioachin,"
,"3":"factum est verbum Domini ad Ezechielem filium Buzi, sacerdotem, in terra Chaldaeorum secus flumen Chobar, et facta est super eum ibi manus Domini."
,"4":"Et vidi: et ecce ventus turbinis veniebat ab aquilone et nubes magna et ignis conglobatus, et splendor in circuitu eius, et de medio eius quasi species electri, id est de medio ignis;"
,"5":"et ex medio eius similitudo quattuor animalium, et hic aspectus eorum: similitudo hominis erat eis."
,"6":"Quattuor facies uni et quattuor pennae uni;"
,"7":"pedes eorum pedes recti, et planta pedis eorum quasi planta pedis vituli, et scintillabant quasi aspectus aeris candentis."
,"8":"Et manus hominis erant sub pennis eorum in quattuor partibus. Facies autem et pennae illorum quattuor:"
,"9":"iunctae erant pennae eorum altera ad alteram; non revertebantur, cum incederent, sed unumquodque ante faciem suam gradiebatur."
,"10":"Similitudo autem vultus eorum: facies hominis et facies leonis a dextris ipsorum quattuor, facies autem bovis a sinistris ipsorum quattuor et facies aquilae ipsorum quattuor."
,"11":"Et pennae eorum extentae desuper; duae pennae singulorum iungebantur, et duae tegebant corpora eorum."
,"12":"Et unumquodque coram facie sua ambulabat: ubi erat impetus spiritus, illuc gradiebantur nec revertebantur, cum ambularent."
,"13":"Et in medio animalium, aspectus quasi carbonum ignis ardentium, quasi aspectus lampadarum discurrentium in medio animalium; et splendor erat ignis, et de igne fulgur egrediens."
,"14":"Et animalia ibant et revertebantur in similitudinem fulguris coruscantis."
,"15":"Cumque aspicerem animalia, apparuit rota una super terram iuxta singula animalia."
,"16":"Et aspectus rotarum et opus earum quasi species chrysolithi, et una similitudo ipsarum quattuor; et aspectus earum et opera, quasi sit rota in medio rotae."
,"17":"Per quattuor partes earum euntes ibant et non revertebantur, cum ambularent."
,"18":"Canthis autem earum erat altitudo et horribilis aspectus; et canthi earum erant oculis pleni in circuitu ipsarum quattuor."
,"19":"Cumque ambularent animalia, ambulabant pariter et rotae iuxta ea; et cum elevarentur animalia de terra, elevabantur simul et rotae."
,"20":"Quocumque impellebat spiritus ut irent, ibant, et rotae pariter levabantur sequentes eum; spiritus enim animalium erat in rotis."
,"21":"Cum euntibus ibant et cum stantibus stabant; et cum elevatis a terra pariter elevabantur, et rotae sequentes ea, quia spiritus animalium erat in rotis."
,"22":"Et similitudo super capita animalium firmamenti quasi aspectus crystalli horribilis et extenti super capita eorum desuper."
,"23":"Sub firmamento autem pennae eorum rectae altera ad alteram; unumquodque duabus alis velabat corpus suum."
,"24":"Et audiebam sonum alarum quasi sonum aquarum multarum, quasi sonum Omnipotentis: cum ambularent, erat strepitus vehemens ut sonus castrorum; cumque starent, demittebantur pennae eorum."
,"25":"Nam cum fieret vox supra firmamentum, quod erat super caput eorum, stabant et submittebant alas suas."
,"26":"Et super firmamentum, quod erat imminens capiti eorum, quasi aspectus lapidis sapphiri similitudo throni; et super similitudinem throni similitudo quasi aspectus hominis desuper."
,"27":"Et vidi quasi speciem electri, velut aspectum ignis per circuitum ab aspectu lumborum eius et desuper; et ab aspectu lumborum eius usque deorsum vidi quasi speciem ignis splendentis in circuitu."
,"28":"Velut aspectus arcus, cum fuerit in nube in die pluviae: sic erat aspectus splendoris per gyrum. Haec visio similitudinis gloriae Domini. Et vidi et cecidi in faciem meam et audivi vocem loquentis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et dixit ad me: ' Fili hominis, sta super pedes tuos, et loquar tecum '."
,"2":"Et ingressus est in me spiritus, postquam locutus est mihi et statuit me supra pedes meos, et audivi loquentem ad me"
,"3":"et dicentem: ' Fili hominis, mitto ego te ad filios Israel, ad gentes apostatrices, quae recesserunt a me; ipsi et patres eorum praevaricati sunt in me usque ad diem hanc."
,"4":"Et filii dura facie et obstinato corde sunt, ad quos ego mitto te; et dices ad eos: Haec dicit Dominus Deus."
,"5":"Ipsi sive audiant, sive contemnant - quoniam domus exasperans est - sciant tamen quia propheta fuerit in medio eorum."
,"6":"Tu ergo, fili hominis, ne timeas eos neque sermones eorum metuas, etsi cardui et spinae te circumdant, et cum scorpionibus habitas. Verba eorum ne timeas et vultus eorum ne formides, quia domus exasperans est."
,"7":"Loqueris ergo verba mea ad eos, sive audiant, sive contemnant, quoniam exasperantes sunt."
,"8":"Tu autem, fili hominis, audi, quaecumque loquor ad te, et noli esse exasperans, sicut domus exasperatrix est; aperi os tuum et comede, quaecumque ego do tibi '."
,"9":"Et vidi: et ecce manus missa ad me, in qua erat involutus liber; et expandit illum coram me, qui erat scriptus intus et foris, et scriptae erant in eo lamentationes et gemitus et vae."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et dixit ad me: ' Fili hominis, quodcumque inveneris, comede; comede volumen istud et vadens loquere ad filios Israel '."
,"2":"Et aperui os meum, et cibavit me volumine illo"
,"3":"et dixit ad me: ' Fili hominis, venter tuus comedet, et viscera tua complebuntur volumine isto, quod ego do tibi '. Et comedi illud, et factum est in ore meo sicut mel dulce."
,"4":"Et dixit ad me: ' Fili hominis, vade ad domum Israel et loqueris verba mea ad eos."
,"5":"Non enim ad populum profundi sermonis et ignotae linguae tu mitteris, ad domum Israel;"
,"6":"neque ad populos multos profundi sermonis et ignotae linguae, quorum non possis audire sermones; et si ad illos mittereris, ipsi audirent te."
,"7":"Domus autem Israel nolunt audire te, quia nolunt audire me; omnis quippe domus Israel dura fronte est et obstinato corde."
,"8":"Ecce dedi faciem tuam valentiorem faciebus eorum et frontem tuam duriorem frontibus eorum;"
,"9":"ut adamantem et duriorem silice dedi faciem tuam: ne timeas eos neque metuas a facie eorum, quia domus exasperans est '."
,"10":"Et dixit ad me: ' Fili hominis, omnes sermones meos, quos loquor ad te, assume in corde tuo et auribus tuis audi."
,"11":"Et vade, ingredere ad transmigrationem, ad filios populi tui, et loqueris ad eos et dices eis: Haec dicit Dominus Deus; sive audiant, sive contemnant '."
,"12":"Et assumpsit me spiritus, et audivi post me vocem commotionis magnae, cum elevaretur gloria Domini de loco suo;"
,"13":"et vocem alarum animalium percutientium alteram ad alteram et vocem rotarum sequentium animalia et vocem commotionis magnae."
,"14":"Spiritus quoque levavit me et assumpsit me; et abii amarus in indignatione spiritus mei: manus enim Domini erat super me gravis."
,"15":"Et veni ad transmigrationem, ad Telabib, ad eos, qui habitabant iuxta flumen Chobar; et sedi, ubi illi sedebant, et mansi ibi septem diebus obstupefactus in medio eorum."
,"16":"Cum autem pertransissent septem dies, factum est verbum Domini ad me dicens:"
,"17":"' Fili hominis, speculatorem dedi te domui Israel; et audies de ore meo verbum et commonebis eos ex me."
,"18":"Si, dicente me ad impium: Morte morieris, non commonueris eum neque locutus fueris ei, ut avertatur a via sua impia et vivat, ipse impius in iniquitate sua morietur, sanguinem autem eius de manu tua requiram."
,"19":"Si autem tu commonueris impium, et ille non fuerit conversus ab impietate sua et a via sua impia, ipse quidem in iniquitate sua morietur, tu autem animam tuam liberasti."
,"20":"Sed et si conversus iustus a iustitia sua, fecerit iniquitatem, ponam offendiculum coram eo; ipse morietur, quia non commonuisti eum: in peccato suo morietur, et non erunt in memoria iustitiae eius, quas fecit; sanguinem vero eius de manu tua requiram."
,"21":"Si autem tu commonueris iustum, ut non peccet iustus, et ille non peccaverit, vivens vivet, quia commonuisti eum et tu animam tuam liberasti '."
,"22":"Et facta est super me manus Domini, et dixit ad me: ' Surgens egredere in campum, et ibi loquar tecum '."
,"23":"Et surgens egressus sum in campum, et ecce ibi gloria Domini stabat quasi gloria, quam vidi iuxta fluvium Chobar, et cecidi in faciem meam."
,"24":"Et ingressus est in me spiritus et statuit me super pedes meos et locutus est mihi et dixit ad me: ' Ingredere et includere in medio domus tuae."
,"25":"Et tu, fili hominis, ecce data sunt super te vincula, et ligabunt te in eis, et non egredieris in medio eorum;"
,"26":"et linguam tuam adhaerere faciam palato tuo, et eris mutus nec quasi vir obiurgans, quia domus exasperans est."
,"27":"Cum autem locutus fuero tibi, aperiam os tuum, et dices ad eos: Haec dicit Dominus Deus. Qui audit, audiat; et, qui contemnit, contemnat, quia domus exasperans est '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"' Et tu, fili hominis, sume tibi laterem et pones eum coram te et describes in eo civitatem Ierusalem."
,"2":"Et ordinabis adversus eam obsidionem et aedificabis munitiones et comportabis aggerem et dabis contra eam castra et pones arietes in gyro."
,"3":"Et tu sume tibi sartaginem ferream et pones eam in murum ferreum inter te et inter civitatem; et obfirmabis faciem tuam ad eam, et erit in obsidionem, et circumdabis eam: signum est domui Israel."
,"4":"Et tu recumbes super latus tuum sinistrum et pones iniquitates domus Israel super eo; numero dierum, quibus recumbes super illud, assumes iniquitatem eorum."
,"5":"Ego autem dedi tibi annos iniquitatis eorum numero dierum trecentos et nonaginta dies, et portabis iniquitatem domus Israel."
,"6":"Et cum compleveris haec, recumbes super latus tuum dextrum secundo et assumes iniquitatem domus Iudae quadraginta diebus; diem pro anno, diem, inquam, pro anno dedi tibi."
,"7":"Et ad obsidionem Ierusalem convertes faciem tuam, et brachium tuum erit exsertum, et prophetabis adversus eam."
,"8":"Ecce circumdedi te vinculis, et non te convertes a latere tuo in latus aliud, donec compleas dies obsidionis tuae."
,"9":"Et tu sume tibi frumentum et hordeum et fabam et lentem et milium et far et mittes ea in vas unum et facies tibi panes numero dierum, quibus recumbes super latus tuum: trecentis et nonaginta diebus comedes illud."
,"10":"Cibus autem tuus, quo vesceris, erit in pondere viginti stateres in die; a tempore usque ad tempus comedes illud."
,"11":"Et aquam in mensura bibes, sextam partem hin; a tempore usque ad tempus bibes illud."
,"12":"Et quasi subcinericium hordeaceum comedes illud; et stercore, quod egreditur de homine, coques illud in oculis eorum'."
,"13":"Et dixit Dominus: ' Sic comedent filii Israel panem suum pollutum inter gentes, ad quas eiciam eos '."
,"14":"Et dixi: ' Heu, Domine Deus, ecce anima mea non est polluta, et morticinum et laceratum a bestiis non comedi ab infantia mea usque nunc, et non est ingressa in os meum caro immunda '."
,"15":"Et dixit ad me: ' Ecce dedi tibi fimum boum pro stercoribus humanis, et facies panem tuum in eo '."
,"16":"Et dixit ad me: ' Fili hominis, ecce ego conteram baculum panis in Ierusalem, et comedent panem in pondere et in sollicitudine et aquam in mensura et in desolatione bibent,"
,"17":"ut, deficientibus pane et aqua, desoletur unusquisque cum fratre suo, et contabescant in iniquitatibus suis."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et tu, fili hominis, sume tibi gladium acutum radentem pilos et assumes eum et duces per caput tuum et per barbam tuam et assumes tibi stateram ponderis et divides eos."
,"2":"Tertiam partem igne combures in medio civitatis, post completionem dierum obsidionis; et assumens tertiam partem, concides gladio in circuitu eius; tertiam vero aliam disperges in ventum, et gladium nudabo post eos."
,"3":"Et sumes inde parvum numerum et ligabis eos in summitate pallii tui;"
,"4":"et ex eis rursum tolles et proicies eos in medio ignis et combures eos igne; ex eo egredietur ignis. Et dices ad omnem domum Israel:"
,"5":"Haec dicit Dominus Deus: Ista est Ierusalem! In medio gentium posui eam et in circuitu eius terras."
,"6":"Et contempsit iudicia mea, ut plus esset impia quam gentes, et praecepta mea ultra quam terrae, quae in circuitu eius sunt: iudicia enim mea proiecerunt et in praeceptis meis non ambulaverunt."
,"7":"Idcirco haec dicit Dominus Deus: Quia tumultuati estis magis quam gentes, quae in circuitu vestro sunt, et in praeceptis meis non ambulastis et iudicia mea non fecistis et iuxta iudicia gentium, quae in circuitu vestro sunt, non estis operati,"
,"8":"ideo haec dicit Dominus Deus: Ecce ego ad te et ipse ego faciam in medio tui iudicia in oculis gentium"
,"9":"et faciam in te, quae non feci et quibus similia ultra non faciam, propter omnes abominationes tuas."
,"10":"Ideo patres comedent filios in medio tui, et filii comedent patres suos, et faciam in te iudicia et ventilabo universas reliquias tuas in omnem ventum."
,"11":"Idcirco vivo ego, dicit Dominus Deus, vere pro eo quod sanctum meum violasti in omnibus offensionibus tuis et in omnibus abominationibus tuis, ego quoque radam, et non parcet oculus meus, et non miserebor."
,"12":"Tertia tui pars peste morietur et fame consumetur in medio tui, et tertia tui pars in gladio cadet in circuitu tuo, tertiam vero partem tuam in omnem ventum dispergam et gladium evaginabo post eos."
,"13":"Et complebo furorem meum et requiescere faciam indignationem meam in eis et consolabor; et scient quia ego Dominus locutus sum in zelo meo, cum implevero indignationem meam in eis."
,"14":"Et dabo te in desertum et in opprobrium in gentibus, quae in circuitu tuo sunt, in conspectu omnis praetereuntis;"
,"15":"et eris opprobrium et blasphemia, exemplum et stupor in gentibus, quae in circuitu tuo sunt, cum fecero in te iudicia in furore et in indignatione et in castigationibus irae."
,"16":"Ego Dominus locutus sum. Quando misero sagittas famis pessimas in vos, quae erunt mortiferae, et quas mittam, ut destruam vos, et famem congregabo super vos et conteram vobis baculum panis;"
,"17":"et immittam in vos famem et bestias pessimas, et absque liberis facient te, et pestilentia et sanguis transibunt per te, et gladium inducam super te. Ego Dominus locutus sum '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, pone faciem tuam ad montes Israel et prophetabis ad eos"
,"3":"et dices: Montes Israel, audite verbum Domini Dei. Haec dicit Dominus Deus montibus et collibus, voraginibus et vallibus: Ecce ego inducam super vos gladium et destruam excelsa vestra;"
,"4":"et demoliar aras vestras, et confringentur delubra vestra, et deiciam interfectos vestros ante idola vestra."
,"5":"Et dabo cadavera filiorum Israel ante faciem simulacrorum vestrorum et dispergam ossa vestra circum aras vestras;"
,"6":"in omnibus habitationibus vestris urbes desertae erunt, et excelsa demolientur, ut dissipentur et intereant arae vestrae, et confringantur et cessent idola vestra, et conterantur delubra vestra, et deleantur opera vestra."
,"7":"Et cadet interfectus in medio vestri, et scietis quia ego Dominus."
,"8":"Et relinquam in vobis eos, qui fugerint gladium in gentibus, cum dispersero vos in terris;"
,"9":"et recordabuntur mei liberati vestri in gentibus, ad quas captivi ducti sunt, quia contrivi cor eorum fornicans et recedens a me, et oculos eorum fornicantes post idola sua; et displicebunt sibimet super malis, quae fecerunt in universis abominationibus suis,"
,"10":"et scient quia ego Dominus non frustra locutus sum, ut facerem eis malum hoc."
,"11":"Haec dicit Dominus Deus: Plaude manu tua et percute pede tuo et dic: Heu ad omnes abominationes malas domus Israel, quia gladio, fame et peste ruituri sunt!"
,"12":"Qui longe est, peste morietur; qui autem prope, gladio corruet; et, qui relictus fuerit et obsessus, fame morietur, et complebo indignationem meam in eis."
,"13":"Et scietis quia ego Dominus, cum fuerint interfecti eorum in medio idolorum suorum, in circuitu ararum suarum, in omni colle excelso, in cunctis summitatibus montium et subtus omne lignum nemorosum et subtus universam quercum frondosam, locum ubi obtulerunt tura redolentia universis idolis suis."
,"14":"Et extendam manum meam super eos et faciam terram desolatam et destitutam a deserto usque Rebla in omnibus habitationibus eorum, et scient quia ego Dominus '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Et tu, fili hominis, loquere. Haec dicit Dominus Deus terrae Israel: Finis venit, finis super quattuor plagas terrae;"
,"3":"nunc finis super te, et immittam furorem meum in te et iudicabo te iuxta vias tuas et ponam super te omnes abominationes tuas."
,"4":"Et non parcet oculus meus super te, et non miserebor, sed vias tuas ponam super te, et abominationes tuae in medio tui erunt, et scietis quia ego Dominus."
,"5":"Haec dicit Dominus Deus: Afflictio super afflictionem ecce venit."
,"6":"Finis venit, venit finis; evigilavit adversum te, ecce venit."
,"7":"Venit contractio super te, qui habitas in terra; venit tempus, prope est dies turbationis et non iubilationis in montibus."
,"8":"Nunc de propinquo effundam iram meam super te et complebo furorem meum in te et iudicabo te iuxta vias tuas et imponam tibi omnia scelera tua;"
,"9":"et non parcet oculus meus, nec miserebor, sed vias tuas imponam tibi, et abominationes tuae in medio tui erunt, et scietis quia ego sum Dominus percutiens."
,"10":"Ecce dies, ecce venit; egressa est contractio, floruit iniustitia, germinavit superbia;"
,"11":"violentia surrexit, ut esset virga impietatis: non ex eis et non ex pompa eorum neque ex sonitu eorum; et non erit requies in eis."
,"12":"Venit tempus, appropinquavit dies: qui emit, non laetetur; et, qui vendit, non lugeat, quia ira super omnem pompam eius."
,"13":"Quia, qui vendit, ad id quod vendidit non revertetur, cum adhuc sit in viventibus vita eorum. Visio enim ad omnem pompam eius non regredietur, et unusquisque in iniquitate sua vitam suam non confortabit."
,"14":"Canite tuba, praeparentur omnia, sed non est qui vadat ad proelium; ira enim mea super universam pompam eius."
,"15":"Gladius foris, pestis et fames intrinsecus. Qui in agro est, gladio morietur; et, qui in civitate, fame et pestilentia devorabuntur."
,"16":"Et salvabuntur, qui fugerint ex eis, et erunt in montibus quasi columbae convallium omnes gementes, unusquisque in iniquitate sua."
,"17":"Omnes manus dissolventur, et omnia genua fluent aquis."
,"18":"Et accingent se ciliciis, et operiet eos formido; et in omni facie confusio, et in universis capitibus eorum calvitium."
,"19":"Argentum suum foras proicient, et aurum eorum in immunditiam erit; argentum eorum et aurum eorum non valebit liberare eos in die furoris Domini; animam suam non saturabunt, et ventres eorum non implebuntur, quia scandalum iniquitatis eorum factum est,"
,"20":"et ornamentum monilium suorum in superbiam posuerunt et imagines abominationum suarum et simulacrorum fecerunt ex eo; propter hoc dedi eis illud in immunditiam."
,"21":"Et dabo illud in manus alienorum ad diripiendum et impiis terrae in praedam, et contaminabunt illud."
,"22":"Et avertam faciem meam ab eis, et violabunt thesaurum meum absconditum; et introibunt in illud praedones et contaminabunt illud"
,"23":"et facient ex illo catenas; quoniam terra plena est iudicio sanguinum, et civitas plena iniquitate."
,"24":"Et adducam pessimos de gentibus, et possidebunt domos eorum; et quiescere faciam superbiam potentium, et possidebunt sanctuaria eorum."
,"25":"Angustia superveniente, requirent pacem, et non erit."
,"26":"Calamitas super calamitatem veniet, et auditus super auditum; et quaerent visionem de propheta, et lex peribit a sacerdote, et consilium a senioribus."
,"27":"Rex lugebit, et princeps induetur horrore, et manus populi terrae conturbabuntur. Secundum viam eorum faciam eis et secundum iudicia eorum iudicabo eos, et scient quia ego Dominus '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Et factum est in anno sexto, in sexto mense, in quinta mensis, ego sedebam in domo mea, et senes Iudae sedebant coram me, et cecidit super me ibi manus Domini Dei,"
,"2":"et vidi: et ecce similitudo quasi aspectus viri, ab aspectu lumborum eius et deorsum ignis, et a lumbis eius et sursum quasi aspectus splendoris ut visio electri."
,"3":"Emisit similitudinem manus et apprehendit me in cincinno capitis mei; et elevavit me spiritus inter terram et caelum et adduxit in Ierusalem, in visionibus Dei, iuxta ostium interius, quod respiciebat aquilonem, ubi erat statutum idolum zeli ad provocandam aemulationem."
,"4":"Et ecce ibi gloria Dei Israel secundum visionem, quam videram in campo;"
,"5":"et dixit ad me: ' Fili hominis, leva oculos tuos ad viam aquilonis '. Et levavi oculos meos ad viam aquilonis, et ecce ab aquilone portae altaris hoc idolum zeli in introitu."
,"6":"Et dixit ad me: ' Fili hominis, putasne vides tu, quid isti faciunt, abominationes magnas, quas domus Israel facit hic, ut procul recedam a sanctuario meo? Et adhuc conversus videbis abominationes maiores '."
,"7":"Et duxit me ad ostium atrii, et vidi: et ecce foramen unum in pariete."
,"8":"Et dixit ad me: 'Fili hominis, fode parietem'; et cum perfodissem parietem, apparuit ostium unum."
,"9":"Et dixit ad me: ' Ingredere et vide abominationes pessimas, quas isti faciunt hic '."
,"10":"Et ingressus vidi: et ecce omnis similitudo reptilium et animalium abominatio et universa idola domus Israel depicta erant in pariete in circuitu per totum;"
,"11":"et septuaginta viri de senioribus domus Israel, et Iezonias filius Saphan stabat in medio eorum stantium ante picturas, et unusquisque habebat turibulum in manu sua, et vapor nebulae de ture consurgebat."
,"12":"Et dixit ad me: ' Certe vides, fili hominis, quae seniores domus Israel faciunt in tenebris, unusquisque in cubiculo simulacri sui; dicunt enim: 'Non videt Dominus nos, dereliquit Dominus terram'."
,"13":"Et dixit ad me: ' Adhuc videbis abominationes maiores, quas isti faciunt '."
,"14":"Et duxit me ad ostium portae domus Domini, quod respiciebat ad aquilonem, et ecce ibi mulieres sedebant plangentes Thammuz."
,"15":"Et dixit ad me: 'Certe vidisti, fili hominis; adhuc videbis abominationes maiores his '."
,"16":"Et introduxit me in atrium domus Domini interius, et ecce in ostio templi Domini, inter vestibulum et altare, quasi viginti quinque viri dorsa habentes contra templum Domini et facies ad orientem, et adorabant ad ortum solis."
,"17":"Et dixit ad me: ' Certe vidisti, fili hominis; numquid parum est hoc domui Iudae, ut facerent abominationes istas, quas fecerunt hic, quia replentes terram iniquitate iterum irritaverunt me et ecce applicant ramum ad nares suas."
,"18":"Ergo et ego faciam in furore: non parcet oculus meus, nec miserebor et, cum clamaverint ad aures meas voce magna, non exaudiam eos '."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et clamavit in auribus meis voce magna dicens: ' Appro pinquaverunt visitationes urbis, et unusquisque vas interfectionis habet in manu sua '."
,"2":"Et ecce sex viri veniebant de via portae superioris, quae respicit ad aquilonem, et uniuscuiusque vas interitus in manu eius; vir quoque unus in medio eorum vestitus lineis, et atramentarium scriptoris ad renes eius; et ingressi sunt et steterunt iuxta altare aereum."
,"3":"Et gloria Dei Israel elevata est de cherub, super quem erat, ad limen domus; et vocavit virum, qui indutus erat lineis et atramentarium scriptoris habebat in lumbis suis."
,"4":"Et dixit Dominus ad eum: ' Transi per mediam civitatem in medio Ierusalem et signa thau super frontes virorum gementium et dolentium super cunctis abominationibus, quae fiunt in medio eius '."
,"5":"Et illis dixit, audiente me: ' Transite per civitatem sequentes eum et percutite; non parcat oculus vester, neque misereamini:"
,"6":"senem, adulescentulum et virginem et parvulum et mulieres interficite usque ad internecionem; omnem autem, super quem videritis thau, ne occidatis, et a sanctuario meo incipite '. Coeperunt ergo a viris senioribus, qui erant ante faciem domus."
,"7":"Et dixit ad eos: 'Contaminate domum et implete atria interfectis. Egredimini '. Et egressi sunt et percutiebant eos, qui erant in civitate."
,"8":"Et caede completa, remansi ego ruique super faciem meam et clamans aio: 'Heu, Domine Deus! Ergone disperdes omnes reliquias Israel, effundens furorem tuum super Ierusalem? '."
,"9":"Et dixit ad me: ' Iniquitas domus Israel et Iudae magna est nimis valde; et repleta est terra sanguinibus, et civitas repleta est iniustitia. Dixerunt enim: 'Dereliquit Dominus terram, et Dominus non videt';"
,"10":"igitur et meus non parcet oculus, neque miserebor: viam eorum super caput eorum reddam '."
,"11":"Et ecce vir, qui indutus erat lineis, qui habebat atramentarium in lumbis suis, respondit verbum dicens: ' Feci, sicut praecepisti mihi '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Et vidi: et ecce super fir mamentum, quod erat super caput cherubim, quasi lapis sapphirus, quasi species similitudinis solii apparuit super ea."
,"2":"Et dixit ad virum, qui indutus erat lineis, et ait: ' Ingredere in medio rotarum, quae sunt subtus cherub, et imple manus tuas prunis ignis, quae sunt inter cherubim, et effunde super civitatem '. Ingressusque est in conspectu meo."
,"3":"Cherubim autem stabant a dextris domus, cum ingrederetur vir, et nubes implevit atrium interius."
,"4":"Et elevata est gloria Domini desuper cherub ad limen domus, et repleta est domus nube, et atrium repletum est splendore gloriae Domini."
,"5":"Et sonitus alarum cherubim audiebatur usque ad atrium exterius, quasi vox Dei omnipotentis loquentis."
,"6":"Cumque praecepisset viro, qui indutus erat lineis, dicens: ' Sume ignem de medio rotarum, de medio cherubim ', ingressus ille stetit iuxta rotam;"
,"7":"et extendit cherub manum de medio cherubim ad ignem, qui erat inter cherubim, et sumpsit et dedit in manus eius, qui indutus erat lineis; qui accipiens egressus est."
,"8":"Et apparuit in cherubim similitudo manus hominis subtus pennas eorum,"
,"9":"et vidi: et ecce quattuor rotae iuxta cherubim; rota una iuxta cherub unum, et rota alia iuxta cherub unum, species autem rotarum erat quasi species lapidis chrysolithi,"
,"10":"et aspectus earum similitudo una illis quattuor, quasi sit rota in medio rotae."
,"11":"Cumque ambularent in quattuor partes, gradiebantur et non convertebantur ambulantes, sed ad locum, ad quem ire declinabat quae prima erat, sequebantur et ceterae nec convertebantur, cum ambularent."
,"12":"Et omne corpus eorum et terga et manus et pennae et rotae plena erant oculis in circuitu illis quattuor;"
,"13":"et rotae istae vocatae sunt Volubiles, audiente me."
,"14":"Quattuor autem facies habebat unumquodque: facies prima facies cherub, et facies secunda facies hominis, et tertia facies leonis, et quarta facies aquilae."
,"15":"Et elevati sunt cherubim: ipsum est animal, quod videram iuxta fluvium Chobar."
,"16":"Cumque ambularent, cherubim ibant pariter, et rotae iuxta ea; et cum elevarent cherubim alas suas, ut exaltarentur de terra, non convertebantur rotae, sed et ipsae iuxta erant."
,"17":"Stantibus illis, stabant et cum elevatis elevabantur; spiritus enim animalium erat in eis."
,"18":"Et egressa est gloria Domini a limine templi et stetit super cherubim;"
,"19":"et elevantes cherubim alas suas exaltata sunt a terra coram me, et, illis egredientibus, rotae quoque subsecutae sunt; et stetit in introitu portae domus Domini orientalis, et gloria Dei Israel erat super eos."
,"20":"Ipsum est animal, quod vidi subter Deum Israel iuxta fluvium Chobar, et intellexi quia cherubim essent."
,"21":"Quattuor per quattuor vultus unicuique, et quattuor alae unicuique, et similitudo manus hominis sub alis eorum;"
,"22":"et similitudo vultuum eorum, ipsi vultus quorum aspectum videram iuxta fluvium Chobar. Et singuli ante faciem suam gradiebantur."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et elevavit me spiritus et duxit me ad portam domus Domini orientalem, quae respicit solis ortum; et ecce in introitu portae viginti quinque viri, et vidi in medio eorum Iezoniam filium Azur et Pheltiam filium Banaiae, principes populi."
,"2":"Dixitque ad me: ' Fili hominis, hi sunt viri, qui cogitant iniquitatem et tractant consilium pessimum in urbe ista"
,"3":"dicentes: 'Nonne dudum aedificatae sunt domus? Haec est lebes, nos autem carnes'."
,"4":"Idcirco vaticinare de eis; vaticinare, fili hominis '."
,"5":"Et irruit in me spiritus Domini et dixit ad me: ' Loquere. Haec dicit Dominus: Sic locuti estis, domus Israel, et cogitationes cordis vestri ego novi."
,"6":"Plurimos occidistis in urbe hac et implestis vias eius interfectis."
,"7":"Propterea haec dicit Dominus Deus: Interfecti vestri, quos posuistis in medio eius, hi sunt carnes, et haec est lebes, et educam vos de medio eius."
,"8":"Gladium metuitis, et gladium inducam super vos, ait Dominus Deus."
,"9":"Et eiciam vos de medio eius daboque vos in manu hostium et faciam in vobis iudicia."
,"10":"Gladio cadetis, in finibus Israel iudicabo vos, et scietis quia ego Dominus."
,"11":"Haec non erit vobis in lebetem, et vos non eritis in medio eius in carnes: in finibus Israel iudicabo vos;"
,"12":"et scietis quia ego Dominus, qui in praeceptis meis non ambulastis et iudicia mea non fecistis, sed iuxta iudicia gentium, quae in circuitu vestro sunt, estis operati '."
,"13":"Et factum est cum prophetarem, Pheltias filius Banaiae mortuus est; et cecidi in faciem meam, clamans voce magna, et dixi: ' Heu, Domine Deus, consummationem tu facis reliquiarum Israel! '."
,"14":"Et factum est verbum Domini ad me dicens:"
,"15":"' Fili hominis, fratres tui, fratres tui, viri propinqui tui et omnis domus Israel, universi, quibus dixerunt habitatores Ierusalem: 'Longe sunt a Domino; nobis data est terra in possessionem'."
,"16":"Propterea haec dicit Dominus Deus: Quia longe feci eos in gentibus et quia dispersi eos in terris, ero eis in sanctificationem modicam in terris, ad quas venerunt."
,"17":"Propterea loquere: Haec dicit Dominus Deus: Congregabo vos de populis et adunabo de terris, in quibus dispersi estis, daboque vobis humum Israel."
,"18":"Et ingredientur illuc et auferent omnes offensiones cunctasque abominationes eius de illa."
,"19":"Et dabo eis cor aliud et spiritum novum tribuam in visceribus eorum; et auferam cor lapideum de carne eorum et dabo eis cor carneum,"
,"20":"ut in praeceptis meis ambulent et iudicia mea custodiant faciantque ea et sint mihi in populum, et ego sim eis in Deum."
,"21":"Quorum cor post offendicula et abominationes suas ambulat, horum viam in capite suo ponam ', dicit Dominus Deus."
,"22":"Et elevaverunt cherubim alas suas, et rotae cum eis, et gloria Dei Israel erat super eos;"
,"23":"et ascendit gloria Domini de medio civitatis stetitque super montem, qui est ad orientem urbis."
,"24":"Et spiritus levavit me adduxitque in Chaldaeam ad transmigrationem in visione in spiritu Dei; et sublata est a me visio, quam videram."
,"25":"Et locutus sum ad transmigrationem omnia verba Domini, quae ostenderat mihi."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, in medio domus exasperantis tu habitas, qui oculos habent ad videndum et non vident, et aures ad audiendum et non audiunt, quia domus exasperans est."
,"3":"Tu ergo, fili hominis, fac tibi vasa transmigrationis et transmigrabis per diem coram eis; transmigrabis autem de loco tuo ad locum alterum in conspectu eorum, si forte aspiciant, quia domus exasperans est."
,"4":"Et efferes foras vasa tua quasi vasa transmigrantis per diem in conspectu eorum; tu autem egredieris vespere coram eis, sicut egreditur migrans."
,"5":"Ante oculos eorum perfode tibi parietem et efferes per eum;"
,"6":"in conspectu eorum in umeris portabis, in caligine efferes: faciem tuam velabis et non videbis terram, quia portentum dedi te domui Israel '."
,"7":"Feci ergo, sicut praeceperat mihi Dominus: vasa mea protuli quasi vasa transmigrantis per diem et vespere perfodi mihi parietem manu; et in caligine extuli in umeris portans in conspectu eorum."
,"8":"Et factus est sermo Domini ad me mane dicens:"
,"9":"' Fili hominis, numquid non dixerunt ad te domus Israel, domus exasperans: 'Quid tu facis?'."
,"10":"Dic ad eos: Haec dicit Dominus Deus: Super ducem onus istud, qui est in Ierusalem, et super omnem domum Israel, quae est in medio eius."
,"11":"Dic: Ego portentum vestrum. Quomodo feci, sic fiet illis: in transmigrationem et in captivitatem ibunt."
,"12":"Et dux, qui est in medio eorum, in umeris portabit, in caligine, et egredietur; parietem perfodient, ut transitus fiat per eum; faciem suam operiet, ut non videat oculo terram."
,"13":"Et extendam rete meum super illum, et capietur in tendicula mea; et adducam eum in Babylonem in terram Chaldaeorum, et ipsam non videbit ibique morietur."
,"14":"Et omnes, qui circa eum sunt, praesidium eius et agmina eius, dispergam in omnem ventum; et gladium evaginabo post eos."
,"15":"Et scient quia ego Dominus, quando dispersero illos in gentibus et disseminavero eos in terris."
,"16":"Et relinquam ex eis viros paucos a gladio et fame et pestilentia, ut narrent omnia scelera eorum in gentibus, ad quas ingredientur, et scient quia ego Dominus '."
,"17":"Et factus est sermo Domini ad me dicens:"
,"18":"' Fili hominis, panem tuum in conturbatione comede; sed et aquam tuam in trepidatione et sollicitudine bibe."
,"19":"Et dices ad populum terrae: Haec dicit Dominus Deus ad eos, qui habitant in Ierusalem in terra Israel: Panem suum in sollicitudine comedent et aquam suam in desolatione bibent, quia desolabitur terra a plenitudine sua propter violentiam omnium, qui habitant in ea;"
,"20":"et civitates, quae nunc habitantur, desolatae erunt, terraque deserta, et scietis quia ego Dominus '."
,"21":"Et factus est sermo Domini ad me dicens:"
,"22":"' Fili hominis, quod est proverbium istud vobis in terra Israel dicentibus: 'In longum differentur dies, et peribit omnis visio'?"
,"23":"Ideo dic ad eos: Haec dicit Dominus Deus: Quiescere faciam proverbium istud, neque vulgo dicetur ultra in Israel; et loquere ad eos quod appropinquaverint dies et sermo omnis visionis."
,"24":"Non enim erit ultra omnis visio vana neque divinatio ambigua in medio filiorum Israel,"
,"25":"quia ego Dominus loquar; quodcumque locutus fuero verbum, et fiet: non prolongabitur amplius, sed in diebus vestris, domus exasperans, loquar verbum et faciam illud ', dicit Dominus Deus."
,"26":"Et factus est sermo Domini ad me dicens:"
,"27":"' Fili hominis, ecce domus Israel dicentium: 'Visio, quam hic videt, in dies multos et in tempora longa iste prophetat';"
,"28":"propterea dic ad eos: Haec dicit Dominus Deus: Non differetur ultra omnis sermo meus; verbum, quod locutus fuero, complebitur ', dicit Dominus Deus."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, vaticinare ad prophetas Israel, qui prophetant; et dices prophetantibus de corde suo: Audite verbum Domini."
,"3":"Haec dicit Dominus Deus: Vae prophetis insipientibus, qui sequuntur spiritum suum et nihil vident!"
,"4":"Quasi vulpes in ruinis prophetae tui, Israel, facti sunt."
,"5":"Non ascendistis confractiones neque opposuistis murum pro domo Israel, ut staretis in proelio in die Domini."
,"6":"Vident vana et divinant mendacium dicentes: 'Ait Dominus', cum Dominus non miserit eos; et exspectant, ut confirmet sermonem."
,"7":"Numquid non visionem cassam vidistis et divinationem mendacem locuti estis, et dicitis: 'Ait Dominus', cum ego non sim locutus?"
,"8":"Propterea haec dicit Dominus Deus: Quia locuti estis vana et vidistis mendacium, ideo ecce ego ad vos, ait Dominus Deus;"
,"9":"et erit manus mea super prophetas, qui vident vana et divinant mendacium: in consilio populi mei non erunt et in scriptura domus Israel non scribentur nec in terram Israel ingredientur, et scietis quia ego Dominus Deus."
,"10":"Eo quod deceperint populum meum dicentes: 'Pax', et non est pax; et ipse aedificabat parietem, illi autem liniebant eum calce."
,"11":"Dic ad eos, qui liniunt calce, quod casurus sit; erit enim imber inundans, et dabo lapides grandinis desuper irruentes et ventum procellae dissipantem."
,"12":"Siquidem ecce cecidit paries; numquid non dicetur vobis: 'Ubi est litura, quam levistis?'."
,"13":"Propterea haec dicit Dominus Deus: Et erumpere faciam spiritum tempestatum in indignatione mea, et imber inundans in furore meo erit, et lapides grandinis in ira in consumptionem;"
,"14":"et destruam parietem, quem levistis calce, et adaequabo eum terrae, et revelabitur fundamentum eius, et cadet, et consumemini in medio eius et scietis quia ego sum Dominus."
,"15":"Et complebo indignationem meam in pariete et in his, qui leverunt eum calce, dicamque vobis: Non est paries, et non sunt qui leverunt eum; 16 prophetae Israel, qui prophetant ad Ierusalem et vident ei visionem pacis, et non est pax, ait Dominus Deus."
,"17":"Et tu, fili hominis, pone faciem tuam contra filias populi tui, quae prophetant de corde suo, et vaticinare super eas"
,"18":"et dic: Haec dicit Dominus Deus: Vae, quae consuunt fascias pro omni articulo manus et faciunt velamina pro capite omnis staturae ad capiendas animas! Numquid capietis animas de populo meo et vivificabitis animas vobis?"
,"19":"Et violastis me ad populum meum pro pugillo hordei et fragmento panis, ut interficeretis animas, quae mori non deberent, et vivificastis animas, quae non deberent vivere, mentientes populo meo credenti mendaciis."
,"20":"Propter hoc haec dicit Dominus Deus: Ecce ego ad fascias vestras, quibus vos capitis animas quasi volatilia, et disrumpam eas de brachiis vestris; et dimittam animas, quas vos cepistis, animas quasi volatilia,"
,"21":"et disrumpam velamina vestra et liberabo populum meum de manu vestra, neque erunt ultra in manibus vestris ad praedandum, et scietis quia ego Dominus."
,"22":"Pro eo quod maerere fecistis cor iusti mendaciter, quem ego non contristavi, et confortastis manus impii, ut non reverteretur a via sua mala et viveret,"
,"23":"propterea vana non videbitis et divinationes non divinabitis amplius, et eruam populum meum de manu vestra, et scietis quia ego Dominus '."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Et venerunt ad me viri seniorum Israel et sederunt coram me."
,"2":"Et factus est sermo Domini ad me dicens:"
,"3":"' Fili hominis, viri isti posuerunt idola sua in cordibus suis et scandalum iniquitatis suae statuerunt contra faciem suam; numquid interrogatus respondebo eis?"
,"4":"Propter hoc loquere eis et dices ad eos: Haec dicit Dominus Deus: Omnis homo de domo Israel, qui posuerit idola sua in corde suo et scandalum iniquitatis suae statuerit contra faciem suam et venerit ad prophetam interrogans per eum me, ego Dominus respondebo ei per me pro multitudine idolorum suorum,"
,"5":"ut capiam domum Israel in corde suo, quo recesserunt a me in cunctis idolis suis."
,"6":"Propterea dic ad domum Israel: Haec dicit Dominus Deus: Convertimini et recedite ab idolis vestris et ab universis contaminationibus vestris avertite facies vestras."
,"7":"Quia omnis homo de domo Israel et de advenis, quicumque advena fuerit in Israel, si alienatus fuerit a me et posuerit idola sua in corde suo et scandalum iniquitatis suae statuerit contra faciem suam et venerit ad prophetam, ut interroget per eum me, ego Dominus respondebo ei per me;"
,"8":"et ponam faciem meam contra hominem illum et faciam eum in exemplum et in proberbium et disperdam eum de medio populi mei, et scietis quia ego Dominus."
,"9":"Et propheta cum erraverit et locutus fuerit verbum, ego Dominus decepi prophetam illum et extendam manum meam contra eum et delebo eum de medio populi mei Israel."
,"10":"Et portabunt iniquitatem suam: sicut iniquitas interrogantis, sic et iniquitas prophetae erit,"
,"11":"ut non erret ultra domus Israel a me neque polluatur in universis praevaricationibus suis, sed sit mihi in populum, et ego sim eis in Deum ', ait Dominus Deus."
,"12":"Et factus est sermo Domini ad me dicens:"
,"13":"' Fili hominis, terra cum peccaverit mihi, ut praevaricetur praevaricans, extendam manum meam super eam et conteram virgam panis eius et immittam in eam famem et interficiam de ea hominem et iumentum;"
,"14":"et si fuerint tres viri isti in medio eius, Noe, Danel et Iob, ipsi iustitia sua liberabunt animas suas, ait Dominus Deus."
,"15":"Quod si et bestias pessimas induxero super terram, ut absque liberis faciant eam, et fuerit deserta, in qua nullus pertranseat propter bestias,"
,"16":"tres viri isti si fuerint in ea, vivo ego, dicit Dominus Deus, quia nec filios nec filias liberabunt, sed ipsi soli liberabuntur, terra autem desolabitur."
,"17":"Vel si gladium induxero super terram illam et dixero gladio: Transi per terram, et interfecero de ea hominem et iumentum,"
,"18":"et tres viri isti fuerint in medio eius, vivo ego, dicit Dominus Deus, non liberabunt filios neque filias, sed ipsi soli liberabuntur."
,"19":"Vel si pestilentiam immisero super terram illam et effudero indignationem meam super eam in sanguine, ut auferam ex ea hominem et iumentum,"
,"20":"et Noe et Danel et Iob fuerint in medio eius, vivo ego, dicit Dominus Deus, quia filium et filiam non liberabunt, sed ipsi iustitia sua liberabunt animas suas."
,"21":"Quoniam haec dicit Dominus Deus: Quod si et quattuor iudicia mea pessima, gladium et famem et bestias malas et pestilentiam misero in Ierusalem, ut interficiam de ea hominem et pecus,"
,"22":"tamen relinquetur in ea salvatio educentium filios et filias: ecce ipsi egredientur ad vos, et videbitis viam eorum et opera eorum et consolabimini super malo, quod induxi in Ierusalem in omnibus, quae importavi super eam."
,"23":"Et consolabuntur vos, cum videritis viam eorum et opera eorum, et cognoscetis quod non frustra fecerim omnia, quae feci in ea ', ait Dominus Deus."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, quid habet lignum vitis,prae omnibus lignis sarmentorum, quae sunt inter ligna silvarum?"
,"3":"Numquid tolletur de ea lignum, ut fiat opus, aut fabricabitur de ea paxillus, ut dependeat in eo quodcumque vas?"
,"4":"Ecce igni datum est in escam, utramque partem eius consumpsit ignis, et medietas eius adusta est; numquid utile erit ad opus?"
,"5":"Etiam cum esset integrum, non erat aptum ad opus; quanto magis cum ignis illud devoraverit et combusserit, nihil ex eo fiet operis."
,"6":"Propterea haec dicit Dominus Deus: Quomodo lignum vitis inter ligna silvarum, quod dedi igni ad devorandum, sic tradam habitatores Ierusalem."
,"7":"Et ponam faciem meam in eos: de igne egressi sunt, et ignis consumet eos. Et scietis quia ego Dominus, cum posuero faciem meam in eos"
,"8":"et dedero terram inviam et desolatam, eo quod praevaricatores exstiterint ', dicit Dominus Deus."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, notas fac Ierusalem abominationes suas"
,"3":"et dices: Haec dicit Dominus Deus ad Ierusalem: Radix tua et generatio tua de terra Chanaan, pater tuus Amorraeus et mater tua Hetthaea."
,"4":"Et quando nata es, in die ortus tui non est praecisus umbilicus tuus, et in aqua non es lota in emundationem nec sale salita nec involuta pannis."
,"5":"Non pepercit super te oculus, ut faceret tibi unum de his, miseratus tui, sed proiecta es super faciem terrae in abiectione animae tuae in die, qua nata es."
,"6":"Praeteriens autem te, vidi te palpitare in sanguine tuo et dixi tibi, cum esses in sanguine tuo: Vive. Dixi, inquam, tibi: In sanguine tuo vive."
,"7":"Crescentem quasi germen agri dedi te, et crevisti et grandis effecta es et pervenisti ad mundum muliebrem: ubera tua intumuerunt, et pilus tuus germinavit; sed eras nuda et confusione plena."
,"8":"Et transivi per te et vidi te; et ecce tempus tuum, tempus amantium. Et expandi amictum meum super te et operui ignominiam tuam; et iuravi tibi et ingressus sum pactum tecum, ait Dominus Deus, et facta es mea."
,"9":"Et lavi te aqua et emundavi sanguinem tuum ex te et unxi te oleo;"
,"10":"et vestivi te discoloribus et calceavi te calceis corii delphini et cinxi te bysso et indui te serico."
,"11":"Et ornavi te ornamento et dedi armillas in manibus tuis et torquem circa collum tuum;"
,"12":"et dedi inaurem super os tuum et circulos auribus tuis et coronam decoris in capite tuo."
,"13":"Et ornata es auro et argento et vestita es bysso et serico et multicoloribus. Similam et mel et oleum comedisti et decora facta es vehementer nimis et apta ad regnum."
,"14":"Et egressum est nomen tuum in gentes propter speciem tuam, quia perfecta eras in decore meo, quem posueram super te, dicit Dominus Deus."
,"15":"Et habens fiduciam in pulchritudine tua fornicata es in nomine tuo et exposuisti fornicationem tuam omni transeunti, quisquis fuerit."
,"16":"Et sumens de vestimentis tuis fecisti tibi excelsa variegata et fornicata es super eis, sicut non est factum neque futurum est."
,"17":"Et tulisti vasa decoris tui de auro meo atque argento meo, quae dedi tibi, et fecisti tibi imagines masculinas et fornicata es in eis."
,"18":"Et sumpsisti vestimenta tua multicoloria et operuisti illas et oleum meum et thymiama meum posuisti coram eis."
,"19":"Et panem meum, quem dedi tibi, similam et oleum et mel, quibus enutrivi te, posuisti in conspectu eorum in odorem suavitatis, et factum est, ait Dominus Deus."
,"20":"Et tulisti filios tuos et filias tuas, quas generasti mihi, et immolasti eis ad devorandum. Numquid parva est fornicatio tua?"
,"21":"Immolasti filios meos et dedisti illos consecrans eis."
,"22":"Et post omnes abominationes tuas et fornicationes non es recordata dierum adulescentiae tuae, quando eras nuda et confusione plena, palpitans in sanguine tuo."
,"23":"Et accidit post omnem malitiam tuam - vae, vae tibi!, ait Dominus Deus -"
,"24":"et aedificasti tibi fornicem et fecisti tibi excelsum in cunctis plateis;"
,"25":"ad omne caput viae aedificasti locum elevatum tuum et abominabilem fecisti decorem tuum et divisisti pedes tuos omni transeunti et multiplicasti fornicationes tuas."
,"26":"Et fornicata es cum filiis Aegypti vicinis tuis magnorum membrorum et multiplicasti fornicationem tuam ad irritandum me."
,"27":"Ecce ego extendi manum meam super te et imminui portionem tuam et dedi te in animam odientium te, filiarum Palaestinarum, quae erubescunt in via tua scelerata."
,"28":"Et fornicata es in filiis Assyriorum, eo quod necdum fueris expleta; et, postquam fornicata es, nec sic es satiata."
,"29":"Et multiplicasti fornicationem tuam usque ad terram mercatorum Chaldaeam, et nec sic satiata es."
,"30":"In quo mundabo cor tuum, ait Dominus Deus, cum faceres omnia haec opera mulieris meretricis et procacis?"
,"31":"Quia fabricasti fornicem tuum in capite omnis viae et excelsum tuum fecisti in omni platea; nec facta es quasi meretrix, quia sprevisti pretium."
,"32":"Mulier adultera loco viri sui accipit alienos."
,"33":"Omnibus meretricibus dantur mercedes, tu autem dedisti mercedes cunctis amatoribus tuis et donabas eis, ut intrarent ad te undique ad fornicandum tecum."
,"34":"Factumque in te est contra consuetudinem mulierum in fornicationibus tuis, et post te non sunt fornicati; in eo enim quod dedisti mercedes et mercedes non accepisti, factum est in te contrarium."
,"35":"Propterea, meretrix, audi verbum Domini."
,"36":"Haec dicit Dominus Deus: Quia effusum est aes tuum, et revelata est ignominia tua in fornicationibus tuis ad amatores tuos et ad omnia idola abominabilia tua, in sanguine filiorum tuorum, quos dedisti eis,"
,"37":"ideo ecce ego congregabo omnes amatores tuos, quibus iucunda fuisti, et omnes, quos dilexisti, cum universis, quos oderas; et congregabo eos super te undique et nudabo ignominiam tuam coram eis, et videbunt omnem turpitudinem tuam."
,"38":"Et iudicabo te iudiciis adulterarum et effundentium sanguinem et dabo te in sanguinem furoris et zeli."
,"39":"Et dabo te in manus eorum, et destruent fornicem tuum et demolientur excelsa tua et denudabunt te vestimentis tuis et auferent vasa decoris tui et derelinquent te nudam plenamque ignominia."
,"40":"Et convocabunt contra te congregationem et lapidabunt te lapidibus et trucidabunt te gladiis suis."
,"41":"Et comburent domos tuas igni et facient in te iudicia in oculis mulierum plurimarum; et faciam ut desinas fornicari, et mercedes ultra non dabis."
,"42":"Et satiabo indignationem meam in te, et auferetur zelus meus a te; et quiescam nec irascar amplius."
,"43":"Eo quod non fueris recordata dierum adulescentiae tuae et provocasti me in omnibus his, propterea et ego vias tuas in capite tuo dabo, ait Dominus Deus, et non feci iuxta scelera tua in omnibus abominationibus tuis."
,"44":"Ecce omnis, qui dicit vulgo proverbium in te, assumet illud dicens: 'Sicut mater, ita et filia eius'."
,"45":"Filia matris tuae es tu, quae sprevit virum suum et filios suos; et soror sororum tuarum es tu, quae spreverunt viros suos et filios suos. Mater vestra Hetthaea, et pater vester Amorraeus."
,"46":"Et soror tua maior Samaria, ipsa et filiae eius, quae habitat ad sinistram tuam; soror autem tua minor te, quae habitat a dextris tuis, Sodoma et filiae eius."
,"47":"Sed nec in viis earum ambulasti neque secundum scelera earum fecisti; quasi parum fuisset, sceleratiora fecisti illis in omnibus viis tuis."
,"48":"Vivo ego, dicit Dominus Deus, non fecit Sodoma soror tua, ipsa et filiae eius, sicut fecisti tu et filiae tuae."
,"49":"Ecce haec fuit iniquitas Sodomae, sororis tuae: superbia, saturitas panis et securum otium erat ei et filiabus eius, et manum egeni et pauperis non sustentabant;"
,"50":"et elevatae sunt et fecerunt abominationes coram me, et abstuli eas, sicut vidisti."
,"51":"Et Samaria dimidium peccatorum tuorum non peccavit, sed vicisti eas sceleribus tuis et iustificasti sorores tuas in omnibus abominationibus tuis, quas operata es."
,"52":"Ergo et tu porta confusionem tuam, quae absolvisti sorores tuas peccatis tuis, sceleratius agens quam illae; iustificatae sunt enim a te. Ergo et tu confundere et porta ignominiam tuam, quae iustificasti sorores tuas."
,"53":"Et convertam sortem earum, sortem Sodomorum cum filiabus suis et sortem Samariae et filiarum eius; et convertam sortem tuam in medio earum,"
,"54":"ut portes ignominiam tuam et confundaris in omnibus, quae fecisti consolans eas."
,"55":"Et soror tua Sodoma et filiae eius revertentur ad pristinum statum suum, et Samaria et filiae eius revertentur ad pristinum statum suum, et tu et filiae tuae revertimini ad pristinum statum vestrum."
,"56":"Nonne fuit Sodoma, soror tua, in fabulam in ore tuo in die superbiae tuae,"
,"57":"antequam revelaretur malitia tua, sicut hoc tempore tu es in opprobrium filiarum Syriae et cunctarum in circuitu tuo filiarum Palaestinarum, quae ambiunt te per gyrum?"
,"58":"Scelus tuum et ignominiam tuam tu portabis, ait Dominus."
,"59":"Quia haec dicit Dominus Deus: Et faciam tibi, sicut fecisti, qui despexisti iuramentum, ut irritum faceres pactum."
,"60":"Et recordabor ego pacti mei tecum in diebus adulescentiae tuae et suscitabo tibi pactum sempiternum."
,"61":"Et recordaberis viarum tuarum et confunderis, cum receperis sorores tuas te maiores cum minoribus tuis, et dabo eas tibi in filias sed non ex pacto tuo."
,"62":"Et suscitabo ego pactum meum tecum, et scies quia ego Dominus,"
,"63":"ut recorderis et confundaris, et non sit tibi ultra aperire os prae confusione tua, cum placatus fuero tibi in omnibus, quae fecisti ', ait Dominus Deus."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Et factum est verbum Do mini ad me dicens:"
,"2":"'Fili ho minis, propone aenigma et narra parabolam ad domum Israel"
,"3":"et dices: Haec dicit Dominus Deus: Aquila grandis,magnarum alarum, longo pennarum ductu, plena plumis et varietate, venit ad Libanum,et tulit cacumen cedri;"
,"4":"summitatem frondium eius avellit,et transportavit eam in terram Chanaan, in urbem negotiatorum posuit illam."
,"5":"Et tulit de semine terrae,et posuit illud in terra pro semine, super aquas multas, quasi salicem posuit illud,"
,"6":"ut germinaret et cresceret in vineam latiorem,humili statura, respicientibus ramis eius ad illam, et radices eius sub illa essent. Facta est ergo vinea,et fructificavit in palmites,et emisit propagines."
,"7":"Et fuit aquila altera grandis, magnis alis,multisque plumis; et ecce vinea ista, quasi mittens radices suas ad eam, palmites suos extendit ad illam, ut irrigaret eam abundantius,quam areolae, in quibus erat plantata."
,"8":"In terra bona,super aquas multas,plantata est, ut faciat frondes,et portet fructum,et sit in vineam grandem."
,"9":"Dic: Haec dicit Dominus Deus: Ergone prosperabitur?,Nonne radices eius evellet,et fructum eius distringet, et marcescent omnia recentia germina eius, et arescet?,Et non opus erit brachio grandi neque populo multo, ut evellat eam radicitus."
,"10":"Ecce plantata est; ergone prosperabitur?,Nonne, cum tetigerit eam ventus urens, siccabitur,et in areis, in quibus germinaverat, arescet? '."
,"11":"Et factum est verbum Domini ad me dicens:"
,"12":"' Dic ad domum exasperantem: Nescitis quid ista significent? Dic: Ecce venit rex Babylonis Ierusalem et assumpsit regem et principes eius et adduxit eos ad semetipsum in Babylonem;"
,"13":"et tulit de semine regni pepigitque cum eo foedus et accepit ab eo iusiurandum, sed et fortes terrae sustulit,"
,"14":"ut esset regnum humile et non elevaretur, sed custodiret pactum eius et servaret illud."
,"15":"Qui recedens ab eo, misit nuntios ad Aegyptum, ut daret sibi equos et populum multum. Numquid prosperabitur vel consequetur salutem, qui fecit haec? Et, qui dissolvit pactum, numquid effugiet?"
,"16":"Vivo ego, dicit Dominus Deus, quoniam in loco regis, qui constituit eum regem, cuius fecit irritum iuramentum et solvit pactum, quod habebat cum eo, in medio Babylonis morietur."
,"17":"Et non in exercitu grandi neque in populo multo adiuvabit eum pharao in proelio, in iactu aggeris et in exstructione munitionum, ut interficiat animas multas."
,"18":"Spreverat enim iuramentum, ut solveret foedus, et ecce dedit manum suam et, cum omnia haec fecerit, non effugiet."
,"19":"Propterea haec dicit Dominus Deus: Vivo ego, quoniam iuramentum meum, quod sprevit, et foedus meum, quod praevaricatus est, ponam in caput eius"
,"20":"et expandam super eum rete meum, et comprehendetur tendicula mea, et adducam eum in Babylonem et iudicabo illum ibi in praevaricatione, qua praevaricatus est in me."
,"21":"Et omnes electi eius in universo agmine suo gladio cadent; residui autem in omnem ventum dispergentur, et scietis quia ego Dominus locutus sum."
,"22":"Haec dicit Dominus Deus: Et sumam ego de cacumine cedri sublimis et ponam; de vertice ramorum eius tenerum distringam,et plantabo super montem excelsum et eminentem."
,"23":"In monte sublimi Israel plantabo illud; et erumpet in germen et faciet fructum,et erit in cedrum magnam; et habitabunt sub ea omnes volucres, et universum volatile sub umbra frondium eius nidificabit."
,"24":"Et scient omnia ligna regionis,quia ego Dominus,humiliavi lignum sublime,et exaltavi lignum humile,et siccavi lignum viride,et frondere feci lignum aridum. Ego Dominus locutus sum et feci '. "
}`)
	CurrentBook.AddChapter(18, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"'Quid est vo bis quod vulgo dicitis proverbium istud in terra Israel dicentes: 'Patres comederunt uvam acerbam, et dentes filiorum obstupescunt'?"
,"3":"Vivo ego, dicit Dominus Deus, non dicetis ultra hoc proverbium in Israel."
,"4":"Ecce omnes animae meae sunt: ut anima patris, ita et anima filii mea est; anima, quae peccaverit, ipsa morietur."
,"5":"Et vir, si fuerit iustus et fecerit iudicium et iustitiam,"
,"6":"in montibus non comederit et oculos suos non levaverit ad idola domus Israel et uxorem proximi sui non violaverit et ad mulierem menstruatam non accesserit"
,"7":"et hominem non afflixerit, pignus debitori reddiderit, per vim nihil rapuerit, panem suum esurienti dederit et nudum operuerit vestimento,"
,"8":"ad usuram non commodaverit et fenus non acceperit, ab iniquitate averterit manum suam, iudicium verum fecerit inter virum et virum,"
,"9":"in praeceptis meis ambulaverit et iudicia mea custodierit, ut faciat veritatem, hic iustus est, vita vivet, ait Dominus Deus."
,"10":"Quod si genuerit filium latronem, effundentem sanguinem et facientem unum de istis,"
,"11":"cum ipse haec omnia non fecerit, et etiam in montibus comedentem et uxorem proximi sui polluentem,"
,"12":"egenum et pauperem affligentem, rapientem rapinas, pignus non reddentem et ad idola levantem oculos suos, abominationem facientem,"
,"13":"ad usuram dantem et fenus accipientem, numquid vivet? Non vivet. Cum universa detestanda haec fecerit, morte morietur; sanguis eius in ipso erit."
,"14":"Quod si genuerit filium, qui videns omnia peccata patris sui, quae fecit, timuerit et non fecerit simile eis:"
,"15":"super montes non comederit et oculos suos non levaverit ad idola domus Israel et uxorem proximi sui non violaverit"
,"16":"et virum non afflixerit, pignus non retinuerit et rapinam non rapuerit, panem suum esurienti dederit et nudum operuerit vestimento,"
,"17":"ab iniuria averterit manum suam, usuram et fenus non acceperit, iudicia mea fecerit, in praeceptis meis ambulaverit, hic non morietur in iniquitate patris sui, sed vita vivet."
,"18":"Pater eius, quia calumniatus est et fecit rapinas nec bonum operatus est in medio populi sui, ecce mortuus est in iniquitate sua."
,"19":"Et dicitis: 'Quare non portavit filius iniquitatem patris?'. Videlicet, quia filius iudicium et iustitiam operatus est, omnia praecepta mea custodivit et fecit illa, vivet vita."
,"20":"Anima, quae peccaverit, ipsa morietur; filius non portabit iniquitatem patris, et pater non portabit iniquitatem filii. Iustitia iusti super eum erit, et impietas impii erit super eum."
,"21":"Si autem impius egerit paenitentiam ab omnibus peccatis suis, quae operatus est, et custodierit universa praecepta mea et fecerit iudicium et iustitiam, vita vivet, non morietur."
,"22":"Omnes iniquitates eius, quas operatus est, non memorabuntur ei; in iustitia sua, quam operatus est, vivet."
,"23":"Numquid voluntatis meae est mors impii, dicit Dominus Deus, et non ut convertatur a viis suis et vivat?"
,"24":"Si autem averterit se iustus a iustitia sua et fecerit iniquitatem secundum omnes abominationes, quas operari solet impius, numquid vivet? Omnes iustitiae eius, quas fecerat, non recordabuntur; in praevaricatione, qua praevaricatus est, et in peccato suo, quod peccavit, in ipsis morietur."
,"25":"Et dixistis: 'Non est aequa via Domini'. Audite ergo, domus Israel: Numquid via mea non est aequa, et non magis viae vestrae pravae sunt?"
,"26":"Cum enim averterit se iustus a iustitia sua et fecerit iniquitatem, morietur; in iniustitia, quam operatus est, morietur."
,"27":"Et cum averterit se impius ab impietate sua, quam operatus est, et fecerit iudicium et iustitiam, ipse animam suam vivificabit;"
,"28":"considerans enim et avertens se ab omnibus iniquitatibus suis, quas operatus est, vita vivet, non morietur."
,"29":"Et dicunt domus Israel: 'Non est aequa via Domini'. Numquid viae meae non sunt aequae, domus Israel, et non magis viae vestrae pravae?"
,"30":"Idcirco unumquemque iuxta vias suas iudicabo, domus Israel, ait Dominus Deus. Convertimini et agite paenitentiam ab omnibus iniquitatibus vestris, et non erit vobis in scandalum iniquitatis."
,"31":"Proicite a vobis omnes praevaricationes vestras, in quibus praevaricati estis, et facite vobis cor novum et spiritum novum. Et quare moriemini, domus Israel?"
,"32":"Quia nolo mortem morientis, dicit Dominus Deus. Revertimini et vivite."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Et tu, assume planctum super principes Israel"
,"2":"et dices: Qualis erat mater tua leaena,inter leones!,Cubavit in medio leunculorum, enutrivit catulos suos."
,"3":"Et educavit unum de leunculis suis; leo factus est,et didicit capere praedam, homines devoravit."
,"4":"Et convocaverunt contra eum gentes, in fovea earum captus est; et adduxerunt eum in circulis,in terram Aegypti."
,"5":"Quae cum vidisset quoniam exspectaverat, et perierat spes eius, tulit alium de leunculis suis, leonem constituit eum."
,"6":"Qui incedebat inter leones, factus est leo,et didicit praedam capere, homines devoravit;"
,"7":"et fregit arces eorum,et civitates eorum vastavit. Et obstupuit terra et plenitudo eius,a voce rugitus illius."
,"8":"Et convenerunt adversum eum gentes,undique de provinciis,et expanderunt super eum rete suum, in fovea earum captus est."
,"9":"Et miserunt eum in caveam in circulis,et adduxerunt eum ad regem Babylonis; qui misit eum in carcerem, ne audiretur vox eius ultra,super montes Israel."
,"10":"Mater tua vineae assimilabatur,super aquam plantata. Fructus eius et frondes eius creverunt,ex aquis multis;"
,"11":"et factae sunt ei virgae solidae,in sceptra dominantium, et exaltata est statura eius,usque in nubes, et apparuit in altitudine sua, in multitudine palmitum suorum."
,"12":"Et evulsa est in ira,in terramque proiecta, et ventus urens siccavit fructum eius; abrepta et arefacta est virga roboris eius, ignis comedit eam."
,"13":"Et nunc transplantata est in desertum, in terra invia et sitienti."
,"14":"Et egressus est ignis de virga ramorum eius, qui fructum eius comedit; et non fuit in ea virga fortis, sceptrum regni '. Planctus est, et erit in planctum."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Et factum est in anno sep timo, in quinto mense, in de cima mensis, venerunt viri de senioribus Israel, ut interrogarent Dominum, et sederunt coram me."
,"2":"Et factus est sermo Domini ad me dicens:"
,"3":"' Fili hominis, loquere senioribus Israel et dices ad eos: Haec dicit Dominus Deus: Num ad interrogandum me vos venistis? Vivo ego, quia non respondebo vobis, ait Dominus Deus."
,"4":"Numquid iudicabis eos, numquid iudicabis, fili hominis? Abominationes patrum eorum ostende eis."
,"5":"Et dices ad eos: Haec dicit Dominus Deus: In die qua elegi Israel et levavi manum meam pro stirpe domus Iacob et apparui eis in terra Aegypti et levavi manum meam pro eis dicens: Ego Dominus Deus vester;"
,"6":"in die illa levavi manum meam pro eis, ut educerem eos de terra Aegypti in terram, quam provideram eis fluentem lacte et melle, quae est egregia inter omnes terras."
,"7":"Et dixi ad eos: Unusquisque abominationes oculorum suorum abiciat, et in idolis Aegypti nolite pollui: ego Dominus Deus vester."
,"8":"Et irritaverunt me nolueruntque me audire; unusquisque abominationes oculorum suorum non proiecit, nec idola Aegypti reliquerunt. Et dixi, ut effunderem indignationem meam super eos et consummarem iram meam in eis in medio terrae Aegypti."
,"9":"Et feci propter nomen meum, ut non violaretur coram gentibus, in quarum medio erant, et inter quas apparui eis, ut educerem eos de terra Aegypti."
,"10":"Eduxi ergo eos de terra Aegypti et duxi in desertum."
,"11":"Et dedi eis praecepta mea et iudicia mea ostendi eis, quae faciat homo et vivat in eis."
,"12":"Insuper et sabbata mea dedi eis, ut essent signum inter me et eos, et scirent quia ego Dominus sanctificans eos."
,"13":"Et irritaverunt me domus Israel in deserto: in praeceptis meis non ambulaverunt et iudicia mea proiecerunt, quae faciens homo vivet in eis, et sabbata mea violaverunt vehementer. Dixi ergo, ut effunderem furorem meum super eos in deserto et consumerem eos."
,"14":"Et feci propter nomen meum, ne violaretur coram gentibus, de quibus eduxi eos in conspectu earum."
,"15":"Attamen ego levavi quoque manum meam super eos in deserto, ne inducerem eos in terram, quam dedi eis fluentem lacte et melle, praecipuam terrarum omnium;"
,"16":"quia iudicia mea proiecerunt et in praeceptis meis non ambulaverunt et sabbata mea violaverunt, post idola enim sua cor eorum gradiebatur."
,"17":"Et pepercit oculus meus super eos, ut non interficerem eos; nec consumpsi eos in deserto."
,"18":"Dixi autem ad filios eorum in solitudine: In praeceptis patrum vestrorum nolite incedere nec iudicia eorum custodiatis nec in idolis eorum polluamini."
,"19":"Ego Dominus Deus vester. In praeceptis meis ambulate et iudicia mea custodite et facite ea"
,"20":"et sabbata mea sanctificate, ut sint signum inter me et vos, et sciatur quia ego Dominus Deus vester."
,"21":"Et exacerbaverunt me filii; in praeceptis meis non ambulaverunt et iudicia mea non custodierunt, ut facerent ea, quae cum fecerit homo, vivet in eis, et sabbata mea violaverunt. Et comminatus sum, ut effunderem furorem meum super eos et consummarem iram meam in eis in deserto."
,"22":"Averti autem manum meam et feci propter nomen meum, ut non violaretur coram gentibus, de quibus eduxi eos in oculis earum."
,"23":"Iterum levavi manum meam in eos in solitudine, ut dispergerem illos in nationes et ventilarem in terras,"
,"24":"eo quod iudicia mea non fecissent et praecepta mea reprobassent et sabbata mea violassent et post idola patrum suorum fuissent oculi eorum."
,"25":"Ergo et ego dedi eis praecepta non bona et iudicia, in quibus non vivent;"
,"26":"et pollui eos in muneribus suis, cum offerrent omne, quod aperit vulvam, ut horrorem eis incuterem, et sciant quia ego Dominus."
,"27":"Quam ob rem loquere ad domum Israel, fili hominis, et dices ad eos: Haec dicit Dominus Deus: Adhuc et in hoc blasphemaverunt me patres vestri, cum sprevissent me contemnentes,"
,"28":"et induxissem eos in terram, super quam levavi manum meam, ut darem eis. Viderunt omnem collem excelsum et omne lignum nemorosum et immolaverunt ibi victimas suas et dederunt ibi irritationem oblationis suae et posuerunt ibi odorem suavitatis suae et libaverunt libationes suas."
,"29":"Et dixi ad eos: Quid est excelsum, ad quod vos ingredimini? Et vocatum est nomen eius Excelsum usque ad hanc diem."
,"30":"Propterea dic ad domum Israel: Haec dicit Dominus Deus: Certe in via patrum vestrorum vos polluimini et post offendicula eorum vos fornicamini"
,"31":"et in oblatione donorum vestrorum, cum traducitis filios vestros per ignem; vos polluimini in omnibus idolis vestris usque hodie, et ego respondebo vobis, domus Israel? Vivo ego, dicit Dominus Deus, quia non respondebo vobis."
,"32":"Neque cogitatio mentis vestrae fiet dicentium: 'Erimus sicut gentes et sicut cognationes terrarum, ut colamus ligna et lapides'."
,"33":"Vivo ego, dicit Dominus Deus, quoniam in manu forti et brachio extento et in furore effuso regnabo super vos."
,"34":"Et educam vos de populis et congregabo vos de terris, in quibus dispersi estis; in manu valida et brachio extento et in furore effuso."
,"35":"Et adducam vos in desertum populorum et iudicio contendam vobiscum ibi facie ad faciem."
,"36":"Sicut iudicio contendi adversum patres vestros in deserto terrae Aegypti, sic iudicio contendam vobiscum, dicit Dominus Deus,"
,"37":"et transire vos faciam sub baculo meo et inducam vos in vinculis foederis."
,"38":"Et segregabo de vobis transgressores et impios et de terra incolatus eorum educam eos, et terram Israel non ingredientur, et scietis quia ego Dominus."
,"39":"Et vos, domus Israel, haec dicit Dominus Deus: Singuli post idola vestra ambulate et servite eis. Sed postea nonne audietis me et nomen meum sanctum non polluetis ultra in muneribus vestris et in idolis vestris?"
,"40":"In monte enim sancto meo, in monte excelso Israel, ait Dominus Deus, ibi serviet mihi omnis domus Israel: omnes, inquam, in terra, in qua placebunt mihi; et ibi quaeram donaria vestra et primitias oblationum vestrarum in omnibus sanctificationibus vestris."
,"41":"In odorem suavitatis suscipiam vos, cum eduxero vos de populis et congregavero vos de terris, in quas dispersi estis, et sanctificabor in vobis in oculis nationum."
,"42":"Et scietis quia ego Dominus, cum induxero vos ad terram Israel, in terram, pro qua levavi manum meam, ut darem eam patribus vestris."
,"43":"Et recordabimini ibi viarum vestrarum et omnium scelerum vestrorum, quibus polluti estis, et displicebitis vobis in conspectu vestro in omnibus malitiis vestris, quas fecistis."
,"44":"Et scietis quia ego Dominus, cum benefecero vobis propter nomen meum, non secundum vias vestras malas neque secundum scelera vestra pessima, domus Israel ', ait Dominus Deus."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, pone faciem tuam contra meridiem et stilla ad austrum et propheta ad saltum agri Nageb."
,"3":"Et dices saltui Nageb: Audi verbum Domini. Haec dicit Dominus Deus: Ecce ego succendam in te ignem, et comburet in te omne lignum viride et omne lignum aridum; non exstinguetur flamma succensionis, et comburetur in ea omnis facies ab austro usque ad aquilonem."
,"4":"Et videbit universa caro quia ego Domínus succendi eam, nec exstinguetur '."
,"5":"Et dixi: ' Heu, Domine Deus! Ipsi dicunt de me: 'Numquid non per parabolas loquitur iste?' '."
,"6":"Et factus est sermo Domini ad me dicens:"
,"7":"' Fili hominis, pone faciem tuam ad Ierusalem et stilla ad sanctuaria et propheta contra humum Israel."
,"8":"Et dices terrae Israel: Haec dicit Dominus Deus: Ecce ego ad te, et eiciam gladium meum de vagina sua et occidam in te iustum et impium."
,"9":"Pro eo autem quod occidi in te iustum et impium, idcirco egredietur gladius meus de vagina sua ad omnem carnem, ab austro ad aquilonem,"
,"10":"ut sciat omnis caro quia ego Dominus eduxi gladium meum de vagina sua irrevocabilem."
,"11":"Et tu, fili hominis, ingemisce in contritione lumborum et in amaritudinibus ingemisce coram eis."
,"12":"Cumque dixerint ad te: 'Quare tu gemis?', dices: Pro auditu quia venit et tabescet omne cor, et dissolventur universae manus, et infirmabitur omnis spiritus, et per cuncta genua fluent aquae; ecce venit et fiet ', ait Dominus Deus."
,"13":"Et factus est sermo Domini ad me dicens:"
,"14":"' Fili hominis, propheta et dices: Haec dicit Dominus Deus: Loquere: Gladius, gladius exacutus est,et etiam limatus;"
,"15":"ut caedat victimas exacutus est, ut splendeat limatus est."
,"16":"Et datus est ad levigandum, ut teneatur manu. Iste exacutus est gladius et iste limatus, ut sit in manu interficientis."
,"17":"Clama et ulula, fili hominis, quia hic directus est in populum meum, hic in cunctos duces Israel, qui gladio traditi sunt cum populo meo."
,"18":"Idcirco plaude super femur, quia probatio est, dicit Dominus Deus."
,"19":"Tu ergo, fili hominis, propheta et percute manu ad manum. Et duplicetur gladius, ac triplicetur gladius interfectorum: hic est gladius occisionis magnae, qui eos circumdat,"
,"20":"ut cor tabescat, et multiplicentur corruentes. In omnibus portis eorum,dedi occisionem gladii: eheu, facti acuti et limati ad fulgendum, politi ad caedem!"
,"21":"'Exacuere, vade ad dexteram sive ad sinistram, quocumque acies tuae sunt destinatae'."
,"22":"Quin et ego plaudam manu ad manum,et saturabo indignationem meam, ego Dominus locutus sum '."
,"23":"Et factus est sermo Domini ad me dicens:"
,"24":"'Et tu, fili hominis, pone tibi duas vias, ut veniat gladius regis Babylonis: de terra una egrediantur ambae; et indicem statue, in capite viae civitatis statue."
,"25":"Viam pones, quo veniat gladius, ad Rabba filiorum Ammon et ad Iudam in Ierusalem munitissimam."
,"26":"Stat enim rex Babylonis in bivio in capite duarum viarum, divinationem quaerens, commiscens sagittas; interrogat teraphim, iecur consulit."
,"27":"Ad dexteram eius facta est divinatio super Ierusalem, ut ponat arietes, ut aperiat os ad caedem, ut elevet vocem in ululatu, ut ponat arietes contra portas, ut comportet aggerem, ut aedificet munitiones."
,"28":"Eritque quasi consulens frustra oraculum in oculis eorum, et iuramenta sanctissima sunt eis; ipse autem in memoriam revocabit iniquitatem ad capiendum."
,"29":"Idcirco haec dicit Dominus Deus: Pro eo quod in memoriam revocastis iniquitatem vestram, et revelatae sunt praevaricationes vestrae, et apparuerunt peccata vestra in omnibus operibus vestris; pro eo, inquam, quod in memoriam revocati estis, manu capiemini."
,"30":"Tu autem, profane, impie dux Israel, cuius venit dies in tempore iniquitatis finitae -"
,"31":"haec dicit Dominus Deus - auferatur cidaris, tollatur corona; hoc non erit amplius. Humile sublevetur, et sublime humilietur."
,"32":"Ruinam, ruinam, ruinam ponam illud; et hoc non fiet, donec veniat, cuius est iudicium, et tradam ei."
,"33":"Et tu, fili hominis, propheta et dic: Haec dicit Dominus Deus ad filios Ammon et ad opprobrium eorum; et dices: Gladius, gladius est evaginatus ad occidendum, limatus ad consumendum, ut fulgeat,"
,"34":"cum tibi videntur vana, et divinantur mendacia, ut ponatur gladius ad colla profanorum impiorum, quorum venit dies in tempore iniquitatis finitae."
,"35":"Revertatur ad vaginam suam. In loco, in quo creatus es, in terra nativitatis tuae iudicabo te."
,"36":"Et effundam super te indignationem meam, in igne furoris mei sufflabo in te; daboque te in manus hominum insipientium et fabricantium interitum."
,"37":"Igni eris cibus, sanguis tuus erit in medio terrae; oblivioni traderis, quia ego Dominus locutus sum '."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Et factum est verbum Do mini ad me dicens:"
,"2":"' Et tu, fili hominis, num iudicas, num iudicas civitatem sanguinum?"
,"3":"Et ostendes ei omnes abominationes suas et dices: Haec dicit Dominus Deus: Civitas effundens sanguinem in medio sui, ut veniat tempus eius et, quae fecit idola contra semetipsam, ut pollueretur."
,"4":"In sanguine tuo, qui a te effusus est, deliquisti; et in idolis tuis, quae fecisti, polluta es; et appropinquare fecisti dies tuos et adduxisti tempus annorum tuorum. Propterea dedi te opprobrium gentibus et irrisionem universis terris."
,"5":"Quae iuxta sunt et quae procul a te, triumphabunt de te, sordibus famosa, grandis tumultu."
,"6":"Ecce principes Israel singuli pro brachio suo fuerunt in te ad effundendum sanguinem."
,"7":"Pater et mater contempti sunt in te, advena oppressus est in medio tui, pupillum et viduam afflixerunt apud te."
,"8":"Sanctuaria mea sprevisti et sabbata mea profanasti."
,"9":"Viri detractores fuerunt in te ad effundendum sanguinem et super montes comederunt in te; scelus operati sunt in medio tui."
,"10":"Verecundiora patris discooperuerunt in te, immunditiam menstruatae humiliaverunt in te;"
,"11":"et unus in uxorem proximi sui operatus est abominationem, et alter nurum suam polluit nefarie; frater sororem suam, filiam patris sui, oppressit in te."
,"12":"Munera acceperunt apud te ad effundendum sanguinem, usuram et fenus accepisti et avare proximos tuos calumniabaris meique oblita es, ait Dominus Deus."
,"13":"Ecce complosi manus meas super lucrum tuum, quod fecisti, et super sanguinem, qui effusus est in medio tui."
,"14":"Numquid sustinebit cor tuum, aut praevalebunt manus tuae in diebus, quos ego faciam tibi? Ego Dominus locutus sum et faciam;"
,"15":"et dispergam te in nationes et ventilabo te in terras et deficere faciam immunditiam tuam a te:"
,"16":"et profanabo me in te in conspectu gentium, et scies quia ego Dominus '."
,"17":"Et factum est verbum Domini ad me dicens:"
,"18":"' Fili hominis, versa est mihi domus Israel in scoriam; omnes isti argentum et aes et stannum et ferrum et plumbum in medio fornacis, scoria facti sunt."
,"19":"Propterea haec dicit Dominus Deus: Eo quod versi estis omnes in scoriam, propterea ecce ego congregabo vos in medio Ierusalem"
,"20":"congregatione argenti et aeris et ferri et plumbi et stanni in medio fornacis, ut succendatur in ea ignis ad conflandum: sic congregabo in furore meo et in ira mea et ponam et conflabo vos"
,"21":"et congregabo vos et succendam vos in igne furoris mei, et conflabimini in medio eius."
,"22":"Ut conflatur argentum in medio fornacis, sic conflabimini in medio eius; et scietis quia ego Dominus effuderim indignationem meam super vos '."
,"23":"Et factum est verbum Domini ad me dicens:"
,"24":"' Fili hominis, dic ei: Tu es terra, super quam non cecidit pluvia neque imber in die furoris,"
,"25":"cuius duces in medio eius sicut leo rugiens capiensque praedam: animas devoraverunt, opes et pretium acceperunt, viduas eius multiplicaverunt in medio illius."
,"26":"Sacerdotes eius contempserunt legem meam et polluerunt sanctuaria mea, inter sanctum et profanum non habuerunt distantiam et inter pollutum et mundum non docuerunt distinguere et a sabbatis meis averterunt oculos suos, et coinquinabar in medio eorum."
,"27":"Principes eius in medio illius quasi lupi rapientes praedam ad effundendum sanguinem et perdendas animas et avare sectanda lucra."
,"28":"Prophetae autem eius liniebant eis omnia calce, videntes vana et divinantes eis mendacium, dicentes: 'Haec dicit Dominus Deus', cum Dominus non sit locutus."
,"29":"Populus terrae calumniabatur calumniam et rapiebat violenter; egenum et pauperem affligebant et advenam opprimebant absque iudicio."
,"30":"Et quaesivi de eis virum, qui interponeret saepem et staret in confractione contra me pro terra, ne dissiparem eam, et non inveni."
,"31":"Et effudi super eos indignationem meam, in igne irae meae consumpsi eos, viam eorum in caput eorum reddidi ', ait Dominus Deus."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, duae mulieres filiae matris unius fuerunt"
,"3":"et fornicatae sunt in Aegypto, in adulescentia sua fornicatae sunt; ibi subacta sunt ubera earum, et tactae sunt mammae virginitatis earum."
,"4":"Nomina autem earum Oolla maior et Ooliba soror eius; et habui eas, et pepererunt filios et filias: porro earum nomina Samaria Oolla et Ierusalem Ooliba."
,"5":"Fornicata est igitur Oolla discedens a me; et insanivit in amatores suos, in Assyrios: bellatores"
,"6":"vestitos hyacintho, principes et magistratus, iuvenes desiderabiles universi, equites ascensores equorum."
,"7":"Et dedit fornicationes suas ad eos electos filiorum Assyriae universos; et apud omnes, in quos insanivit, in omnibus idolis eorum polluta est."
,"8":"Insuper et fornicationes suas, quas habuerat in Aegypto, non reliquit; nam et illi dormierunt cum ea in adulescentia eius, et illi tetigerant ubera virginitatis eius et effuderant fornicationem suam super eam."
,"9":"Propterea tradidi eam in manus amatorum suorum, in manus filiorum Assyriae, in quos insanivit;"
,"10":"ipsi discooperuerunt ignominiam eius, filios et filias illius tulerunt et ipsam occiderunt gladio; et facta est famosa mulieribus, et iudicia perpetrarunt in ea."
,"11":"Quod cum vidisset soror eius Ooliba, plus quam illa insanivit libidine et fornicatione sua super fornicationem sororis suae."
,"12":"In filios Assyriorum amore exarsit: duces et magistratus, bellatores indutos veste pretiosa, equites, qui vectabantur equis, adulescentes cuncti desiderabiles."
,"13":"Et vidi quod polluta esset: via una ambarum;"
,"14":"et auxit fornicationes suas. Cumque vidisset viros depictos in pariete, imagines Chaldaeorum expressas sinopide,"
,"15":"et accinctos balteis renes, et tiaras defluentes in capitibus eorum; aspectus essedariorum omnibus, similitudo filiorum Babylonis, quorum patria Chaldaea."
,"16":"Et insanivit super eos concupiscentia oculorum suorum et misit nuntios ad eos in Chaldaeam."
,"17":"Cumque venissent ad eam filii Babylonis ad cubile amoris, polluerunt eam stupris suis; et, cum polluta esset ab eis, recessit anima eius ab illis."
,"18":"Cum manifestasset fornicationes suas et discooperuisset ignominiam suam, recessit anima mea ab ea, sicut recesserat anima mea a sorore eius."
,"19":"Multiplicavit autem fornicationes suas, recordans dies adulescentiae suae, quibus fornicata est in terra Aegypti;"
,"20":"et insanivit libidine in amatores suos, quorum membra sunt ut membra asinorum, et sicut fluxus equorum fluxus eorum."
,"21":"Et desiderasti scelus adulescentiae tuae, quando subacta sunt in Aegypto ubera tua, et tactae mammae pubertatis tuae."
,"22":"Propterea, Ooliba, haec dicit Dominus Deus: Ecce ego suscitabo amatores tuos contra te, de quibus recessit anima tua; et congregabo eos adversum te in circuitu,"
,"23":"filios Babylonis et universos Chaldaeos, Phacud et Sue et Cue, omnes filios Assyriorum cum eis, iuvenes desiderabiles, duces et magistratus universos, essedarios et nominatos, ascensores equorum omnes."
,"24":"Et venient super te instructi curru et rota, cum multitudine populorum; scuto et clipeo et galea armabuntur contra te undique, et dabo coram eis iudicium, et iudicabunt te iudiciis suis."
,"25":"Et ponam zelum meum in te, quem exercent tecum in furore: nasum tuum et aures tuas praecident et, quae remanserint de te, gladio concident; ipsi filios tuos et filias tuas capient, et novissimum tuum devorabitur igni."
,"26":"Et denudabunt te vestimentis tuis et tollent vasa gloriae tuae;"
,"27":"et cessare faciam scelus tuum de te et fornicationem tuam de terra Aegypti, nec levabis oculos tuos ad eos et Aegypti non recordaberis amplius."
,"28":"Quia haec dicit Dominus Deus: Ecce ego tradam te in manu eorum, quos odisti, in manu, de quibus recessit anima tua;"
,"29":"et agent tecum in odio et tollent omnes labores tuos et dimittent te nudam et ignominia plenam, et revelabitur ignominia fornicationum tuarum, scelus tuum et fornicationes tuae."
,"30":"Fecerunt haec tibi, quia fornicata es post gentes, inter quas polluta es in idolis earum."
,"31":"In via sororis tuae ambulasti, et dabo calicem eius in manu tua."
,"32":"Haec dicit Dominus Deus: Calicem sororis tuae bibes,profundum et latum,C eris in derisum et in subsannationem C: est capacissimus."
,"33":"Ebrietate et dolore repleberis, calice stuporis et horroris, calice sororis tuae Samariae,"
,"34":"et bibes illum et epotabis usque ad faeces; et fragmenta eius rodes,et ubera tua lacerabis, quia ego locutus sum ', ait Dominus Deus."
,"35":"Propterea haec dicit Dominus Deus: ' Quia oblita es mei et proiecisti me post tergum tuum, tu quoque porta scelus tuum et fornicationes tuas '."
,"36":"Et ait Dominus ad me: ' Fili hominis, numquid iudicas Oollam et Oolibam? Annuntia ergo eis scelera earum."
,"37":"Quia adulteratae sunt, et sanguis in manibus earum, et cum idolis suis fornicatae sunt; insuper et filios suos, quos genuerunt mihi, obtulerunt eis ad devorandum."
,"38":"Sed et hoc fecerunt mihi: polluerunt sanctuarium meum in die illa et sabbata mea profanaverunt."
,"39":"Cumque immolarent filios suos idolis suis et ingrederentur sanctuarium meum in die illa, ut polluerent illud, ecce haec fecerunt in medio domus meae."
,"40":"Quin et miserunt ad viros venientes de longe, ad quos nuntius missus erat; itaque ecce venerunt. Quibus te lavisti et circumlevisti stibio oculos tuos et ornata es mundo muliebri;"
,"41":"sedisti in lecto pulcherrimo, et mensa ornata est ante te, thymiama meum et unguentum meum posuisti super eam."
,"42":"Et vox multitudinis exsultantis erat apud eam et apud viros multitudo hominum, qui adducebantur de deserto; et posuerunt armillas in manibus earum et coronas speciosas in capitibus earum."
,"43":"Et dixi de ea, quae attrita est in adulteriis: Nunc fornicabitur in fornicatione sua etiam haec."
,"44":"Et ingressi sunt ad eam quasi ad mulierem meretricem; sic ingrediebantur ad Oollam et ad Oolibam, mulieres nefarias."
,"45":"Viri ergo iusti sunt; hi iudicabunt eas iudicio adulterarum et iudicio effundentium sanguinem, quia adulterae sunt, et sanguis in manibus earum '."
,"46":"Haec enim dicit Dominus Deus: ' Adduc ad eas congregationem et trade eas in terrorem et in rapinam;"
,"47":"et lapidentur lapidibus congregationis et confodiantur gladiis eorum; filios et filias earum interficiant et domos earum igne succendant."
,"48":"Et auferam scelus de terra, et discent omnes mulieres, ne faciant secundum scelus vestrum;"
,"49":"et dabunt scelus vestrum super vos, et peccata idolorum vestrorum portabitis et scietis quia ego Dominus Deus '."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Et factum est verbum Do mini ad me in anno nono, in mense decimo, decima mensis, dicens:"
,"2":"'Fili hominis, scribe tibi nomen diei huius, in qua aggressus est rex Babylonis adversum Ierusalem hodie."
,"3":"Et dices per proverbium ad domum irritatricem parabolam et loqueris ad eos: Haec dicit Dominus Deus: Pone ollam; pone, inquam, et mitte in ea aquam."
,"4":"Congere frusta eius in ea, omnem partem bonam, femur et armum, electis ossibus imple eam,"
,"5":"pinguissimum pecus assume. Compone quoque struem lignorum sub ea; effervescant frusta eius, et coque ossa illius in medio eius."
,"6":"Propterea haec dicit Dominus Deus: Vae civitati sanguinum, ollae, cuius rubigo in ea est, et rubigo eius non exivit de ea!,Per partes et per partes suas eice ex ea, neque cadat super eam sors."
,"7":"Sanguis enim eius in medio eius est, super limpidissimam petram effudit illum; non effudit illum super terram, ut possit operiri pulvere;"
,"8":"ut superducerem indignationem meam,et vindicta ulciscerer, dedi sanguinem eius,super petram limpidissimam, ne operiretur."
,"9":"Propterea haec dicit Dominus Deus: Vae civitati sanguinum, cuius ego grandem faciam pyram!"
,"10":"Congere ligna, succende ignem, coque carnes usque ad consumptionem,et effunde ius, et ossa comburentur."
,"11":"Relinque quoque eam super prunas vacuam, ut incalescat, et ardescat aes eius, et confletur in medio eius inquinamentum eius, et consumatur rubigo eius."
,"12":"Multo labore sudatum est, et non exibit de ea nimia rubigo eius, neque per ignem."
,"13":"Immunditia tua execrabilis, quia mundare te volui, et non es mundata a sordibus tuis; sed nec mundaberis prius, donec quiescere faciam indignationem meam in te."
,"14":"Ego Dominus locutus sum; veniet et faciam: non indulgebo nec parcam nec placabor. Iuxta vias tuas et iuxta opera tua iudicabo te ', dicit Dominus."
,"15":"Et factum est verbum Domini ad me dicens:"
,"16":"' Fili hominis, ecce ego tollo a te delicias oculorum tuorum in plaga, et non planges neque plorabis, neque fluent lacrimae tuae."
,"17":"Ingemisce tacens, mortuorum luctum non facies, corona tua circumligata sit tibi, et calceamenta tua pones in pedibus tuis nec amictu ora velabis nec cibos lugentium comedes '."
,"18":"Locutus sum ergo ad populum mane, et mortua est uxor mea vespere; fecique mane, sicut praeceperat mihi."
,"19":"Et dixit ad me populus: ' Quare non indicas nobis, quid ista significent, quae tu facis? '."
,"20":"Et dixi ad eos: ' Sermo Domini factus est ad me dicens:"
,"21":"Loquere domui Israel: Haec dicit Dominus Deus: Ecce ego polluam sanctuarium meum, superbiam roboris vestri et delicias oculorum vestrorum et sollicitudinem animae vestrae. Filii vestri et filiae, quas reliquistis, gladio cadent."
,"22":"Et facietis, sicut feci: ora amictu non velabitis et cibos lugentium non comedetis,"
,"23":"coronas habebitis in capitibus vestris et calceamenta in pedibus, non plangetis neque flebitis, sed tabescetis in iniquitatibus vestris, et unusquisque gemet ad fratrem suum."
,"24":"Eritque Ezechiel vobis in portentum: iuxta omnia, quae fecit, facietis, cum venerit istud, et scietis quia ego Dominus Deus."
,"25":"Et tu, fili hominis, ecce in die, quo tollam ab eis fortitudinem eorum et gaudium magnificentiae et delicias oculorum eorum et desiderium animae eorum, filios et filias eorum;"
,"26":"in die illa, cum venerit fugiens ad te, ut annuntiet tibi,"
,"27":"in die, inquam, illa aperietur os tuum cum eo, qui fugit; et loqueris et non silebis ultra erisque eis in portentum, et scient quia ego Dominus '."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, pone faciem tuam contra filios Ammon et propheta de eis"
,"3":"et dices filiis Ammon: Audite verbum Domini Dei. Haec dicit Dominus Deus: Pro eo quod dixisti: 'Euge!' super sanctuarium meum, quia pollutum est, et super terram Israel, quoniam desolata est, et super domum Iudae, quoniam ducti sunt in captivitatem, "
,"4":"idcirco ego tradam te filiis orientalibus in hereditatem, et collocabunt castra sua in te et ponent in te tentoria sua; ipsi comedent fruges tuas, et ipsi bibent lac tuum."
,"5":"Daboque Rabba in pascua camelorum et filios Ammon in cubile pecorum, et scietis quia ego Dominus."
,"6":"Quia haec dicit Dominus Deus: Pro eo quod plausisti manu et percussisti pede et gavisa es ex toto affectu super terram Israel,"
,"7":"idcirco ecce ego extendam manum meam super te et tradam te in direptionem gentium et interficiam te de populis et perdam de terris et conteram, et scies quia ego Dominus."
,"8":"Haec dicit Dominus Deus: Pro eo quod dixerunt Moab et Seir: 'Ecce sicut omnes gentes domus Iudae!',"
,"9":"idcirco ecce ego aperiam latus Moab privans eam civitatibus, civitatibus, inquam, eius, a finibus eius, decore terrae: Bethiesimoth et Baalmeon et Cariathaim;"
,"10":"filiis orientis cum filiis Ammon dabo eam in hereditatem, ut non sit memoria ultra filiorum Ammon in gentibus."
,"11":"Et in Moab faciam iudicia, et scient quia ego Dominus."
,"12":"Haec dicit Dominus Deus: Pro eo quod fecit Idumaea ultionem, ut se vindicaret de domo Iudae, peccavitque delinquens et vindictam expetivit de eis,"
,"13":"idcirco haec dicit Dominus Deus: Extendam manum meam super Idumaeam et auferam de ea hominem et iumentum et faciam eam desertum; de Theman et usque Dedan gladio cadent."
,"14":"Et dabo ultionem meam super Idumaeam per manum populi mei Israel, et facient in Edom iuxta iram meam et furorem meum, et scient vindictam meam, dicit Dominus Deus."
,"15":"Haec dicit Dominus Deus: Pro eo quod fecerunt Palaestini in vindicta et ulti se sunt toto animo interficientes et implentes inimicitias sempiternas,"
,"16":"propterea haec dicit Dominus Deus: Ecce ego extendam manum meam super Palaestinos et interficiam Cherethaeos et perdam reliquias maritimae regionis;"
,"17":"faciamque in eis ultiones magnas, arguens in furore, et scient quia ego Dominus, cum dedero vindictam meam super eos '."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Et factum est in undecimo anno, prima mensis, factus est sermo Domini ad me dicens:"
,"2":"'Fili hominis, pro eo quod dixit Tyrus de Ierusalem: 'Euge, confracta est,porta populorum!,Conversa est ad me; quae erat plena, deserta est',"
,"3":"propterea haec dicit Dominus Deus: Ecce ego super te, Tyre, et ascendere faciam ad te gentes multas, sicut ascendit mare fluctuans;"
,"4":"et dissipabunt muros Tyri,et destruent turres eius, et radam pulverem eius de ea, et dabo eam in limpidissimam petram."
,"5":"Siccatio sagenarum,erit in medio maris, quia ego locutus sum, ait Dominus Deus; et erit in direptionem gentibus."
,"6":"Filiae quoque eius, quae sunt in agro, gladio interficientur, et scient quia ego Dominus."
,"7":"Quia haec dicit Dominus Deus: Ecce ego adducam ad Tyrum,Nabuchodonosor, regem Babylonis, ab aquilone, regem regum, cum equis et curribus et equitibus,et coetu populoque magno."
,"8":"Filias tuas, quae sunt in agro, gladio interficiet, et circumdabit te munitionibus,et comportabit aggerem in gyro,et levabit contra te clipeum"
,"9":"et vineas et arietes temperabit in muros tuos,et turres tuas destruet in armatura sua."
,"10":"Inundatione equorum eius,operiet te pulvis eorum, a sonitu equitum,et rotarum et curruum,movebuntur muri tui, dum ingressus fuerit portas tuas,quasi per introitus urbis dissipatae."
,"11":"Ungulis equorum suorum,conculcabit omnes plateas tuas, populum tuum gladio caedet, et columnae tuae fortissimae,in terram corruent."
,"12":"Vastabunt opes tuas, diripient negotiationes tuas,et destruent muros tuos,et domos tuas praeclaras subvertent,et lapides tuos et ligna tua et pulverem tuum,in medio aquarum ponent."
,"13":"Et quiescere faciam tumultum canticorum tuorum, et sonitus cithararum tuarum non audietur amplius,"
,"14":"et dabo te in limpidissimam petram; siccatio sagenarum eris, nec aedificaberis ultra, quia ego locutus sum, dicit Dominus Deus."
,"15":"Haec dicit Dominus Deus Tyro: Numquid non a sonitu ruinae tuae et gemitu interfectorum tuorum, cum occisi fuerint in medio tui, commovebuntur insulae?"
,"16":"Et descendent de sedibus suis omnes principes maris et auferent pallia sua et vestimenta sua varia abicient; et induentur stupore, in terra sedebunt et attoniti et tremefacti stupebunt super te."
,"17":"Et assumentes super te lamentum dicent tibi: 'Quomodo peristi, quae habitas in mari, urbs inclita, quae fuisti fortis in mari,cum habitatoribus tuis, quos formidabant universi!"
,"18":"Nunc stupebunt naves,in die ruinae tuae, et turbabuntur insulae in mari,ob exitum tuum'."
,"19":"Quia haec dicit Dominus Deus: Cum dedero te urbem desolatam sicut civitates, quae non habitantur, et adduxero super te abyssum, et operuerint te aquae multae,"
,"20":"detraham te cum his, qui descendunt in lacum, ad populum pristinum et collocabo te in profundis terrae sicut ruinas a saeculo cum his, qui descendunt in lacum, ut non habiteris et consistas in terra viventium;"
,"21":"in nihilum redigam te, et non eris et requisita non invenieris ultra in sempiternum ', dicit Dominus Deus."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Et factum est verbum Do mini ad me dicens:"
,"2":"'Tu er go, fili hominis, assume super Tyrum lamentum"
,"3":"et dices Tyro, quae habitat in introitu maris, negotiatrici populorum ad insulas multas: Haec dicit Dominus Deus: O Tyre, tu dixisti: 'Perfecti decoris ego sum!'."
,"4":"In corde maris fines tui; qui te aedificaverunt, impleverunt decorem tuum."
,"5":"Abietibus de Sanir exstruxerunt,tibi omnia tabulata; cedrum de libano tulerunt, ut facerent tibi malum;"
,"6":"quercus de Basan,dolaverunt in remos tuos,et transtra tua fecerunt ex ebore,et cupressis de insulis Cetthim."
,"7":"Byssus varia texta de Aegypto,erat tibi in velum, ut poneretur in malo, hyacinthus et purpura de insulis Elisa,facta sunt operimentum tuum."
,"8":"Habitatores Sidonis et Aradii,fuerunt remiges tui; sapientes tui, Tyre, facti sunt nautae tui."
,"9":"Senes Gibli et prudentes eius fuerunt in te, ut sarcirent rimas tuas. Omnes naves maris et nautae earum,fuerunt in te, ut mercarentur merces tuas."
,"10":"Persae et Lud et Phut,erant in exercitu tuo, viri bellatores tui. Clipeum et galeam suspenderunt in te; ipsi dederunt tibi splendorem."
,"11":"Filii Aradii cum exercitu tuo erant super muros tuos in circuitu, et Gammadii erant in turribus tuis. Clipeos suos suspenderunt in muris tuis per gyrum; ipsi compleverunt pulchritudinem tuam."
,"12":"Tharsis negotiatrix tua propter multitudinem cunctarum divitiarum; argentum, ferrum, stannum plumbumque dederunt pro mercibus tuis."
,"13":"Iavan, Thubal et Mosoch ipsi institores tui; mancipia et vasa aerea adduxerunt tibi in commutationem populo tuo."
,"14":"De domo Thogorma equos et equites et mulos adduxerunt pro mercibus tuis ad forum tuum;"
,"15":"filii Rhodi negotiatores tui; insulae multae negotiatio manus tuae: dentes eburneos et ebenina reddiderunt tibi ut tributum."
,"16":"Edom negotiator tuus propter multitudinem operum tuorum; carbunculum, purpuram et scutulata et byssum et corallia et rubinum attulerunt pro mercibus tuis."
,"17":"Iuda et terra Israel ipsi institores tui; frumentum primum, balsamum et mel et oleum et resinam attulerunt tibi in commutationem."
,"18":"Damascenus negotiator tuus propter multitudinem operum tuorum, propter multitudinem diversarum opum; vinum de Helbon et lanam de Sahar"
,"19":"et vinum de Uzal pro mercibus tuis dederunt; ferrum fabrefactum, cassia et calamus in commutatione tua erat."
,"20":"Dedan institores tui in tapetibus ad equitandum."
,"21":"Arabia et universi principes Cedar ipsi negotiatores manus tuae; cum agnis et arietibus et haedis, cum quibus erant negotiatores tui."
,"22":"Venditores Saba et Regma, ipsi negotiatores tui, universa prima aromata et omnem lapidem pretiosum et aurum dederunt pro mercibus tuis."
,"23":"Charran et Chenne et Eden negotiatores tui; Saba, Assyria et Chelmad venditores tui."
,"24":"Ipsi negotiatores tui cum vestibus splendidis, involucris hyacinthinis et polymitis texturisque discoloribus, funibus obvolutis et cedris in negotiationibus tuis."
,"25":"Naves Tharsis, principes tui,in negotiatione tua; et repleta es et glorificata nimis,in corde maris."
,"26":"In aquis multis adduxerunt te,remiges tui; ventus auster contrivit te,in corde maris."
,"27":"Divitiae tuae et thesauri tui et multiplices merces tuae, nautae tui et gubernatores tui, resarcientes rimas tuas et commutantes merces tuas, omnes quoque viri bellatores tui, qui sunt in te, cum universa multitudine tua, quae est in medio tui, cadent in corde maris,in die ruinae tuae."
,"28":"A sonitu clamoris gubernatorum tuorum,conturbabuntur litora."
,"29":"Et descendent de navibus suis,omnes, qui tenebant remum; nautae et universi gubernatores maris,in terra stabunt."
,"30":"Et eiulabunt super te voce magna,et clamabunt amare; et superiacient pulverem capitibus suis, in cinere volutabuntur."
,"31":"Et radent super te calvitium,et accingentur ciliciis,et plorabunt te in amaritudine animae,ploratu amarissimo;"
,"32":"et assument super te congementes carmen lugubre,et plangent te: 'Quae est ut Tyrus, quae obmutuit,in medio maris?"
,"33":"Cum venissent merces tuae de mari, satiasti populos multos; in multitudine divitiarum tuarum et mercium tuarum,ditasti reges terrae."
,"34":"Nunc contrita es a mari,in profundis aquarum. Opes tuae et omnis multitudo tua, quae erat in medio tui, ceciderunt."
,"35":"Universi habitatores insularum,obstupuerunt super te, et reges earum horrore formidarunt vultu conturbato;"
,"36":"negotiatores in populis sibilaverunt super te. In horrorem facta es,et non eris usque in perpetuum' '. "
}`)
	CurrentBook.AddChapter(28, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, dic principi Tyri: Haec dicit Dominus Deus: Eo quod elevatum est cor tuum, et dixisti: 'Deus ego sum,et in cathedra deorum sedeo,in corde maris!', cum sis homo et non Deus, et dedisti cor tuum quasi cor Dei."
,"3":"Ecce sapientior es tu Danel, omne secretum non est absconditum a te,"
,"4":"in sapientia et prudentia tua,fecisti tibi opes,et acquisisti aurum et argentum,in thesauris tuis;"
,"5":"in multitudine sapientiae tuae et in negotiatione tua,multiplicasti tibi opes, et elevatum est cor tuum in opibus tuis."
,"6":"Propterea haec dicit Dominus Deus: Eo quod fecisti cor tuum quasi cor Dei,"
,"7":"idcirco ecce ego adducam super te,alienos violentissimos gentium; et nudabunt gladios suos super pulchritudinem sapientiae tuae,et polluent splendorem tuum."
,"8":"In fossam detrahent te, et morieris,interitu occisorum in corde maris."
,"9":"Numquid dicens loqueris: 'Deus ego sum!',coram interficientibus te, cum sis homo et non Deus,in manu occidentium te?"
,"10":"Morte incircumcisorum morieris,in manu alienorum, quia ego locutus sum ', ait Dominus Deus."
,"11":"Et factus est sermo Domini ad me dicens: ' Fili hominis, leva planctum super regem Tyri"
,"12":"et dices ei: Haec dicit Dominus Deus: Tu signaculum perfectum, plenus sapientia et perfectus decore;"
,"13":"in deliciis paradisi Dei fuisti, omnis lapis pretiosus operimentum tuum: sardius, topazius et iaspis, chrysolithus et onyx et beryllus, sapphirus et carbunculus et smaragdus, aurum opus caelaturae in te; in die, qua conditus es, praeparata sunt."
,"14":"Cum cherub extento et protegente te posui te, in monte sancto Dei fuisti, in medio lapidum ignitorum ambulasti,"
,"15":"perfectus in viis tuis,a die conditionis tuae, donec inventa est iniquitas in te."
,"16":"In multitudine negotiationis tuae repleta sunt interiora tua,iniquitate, et peccasti. Et eieci te de monte Dei, et perdidit te cherub protegens,de medio lapidum ignitorum."
,"17":"Elevatum est cor tuum in decore tuo; perdidisti sapientiam tuam propter splendorem tuum: in terram proieci te, ante faciem regum dedi te, ut cernerent te."
,"18":"In multitudine iniquitatum tuarum,et iniquitate negotiationis tuae,polluisti sanctuaria tua; producam ergo ignem de medio tui, qui comedat te, et dabo te in cinerem super terram,in conspectu omnium videntium te."
,"19":"Omnes, qui viderint te, in gentibus,obstupescent super te; in horrorem factus es,et non eris in perpetuum '."
,"20":"Et factus est sermo Domini ad me dicens:"
,"21":"' Fili hominis, pone faciem tuam contra Sidonem et propheta de ea"
,"22":"et dices: Haec dicit Dominus Deus: Ecce ego ad te, Sidon, et glorificabor in medio tui, et scient quia ego Dominus, cum fecero in ea iudicia,et sanctificatus fuero in ea."
,"23":"Et immittam ei pestilentiam,et sanguinem in plateis eius, et corruent interfecti in medio eius gladio per circuitum, et scient quia ego Dominus."
,"24":"Et non erit ultra domui Israel stimulus amaritudinis et spina dolorem inferens undique per circuitum eorum, qui adversantur eis, et scient quia ego Dominus Deus."
,"25":"Haec dicit Dominus Deus: Quando congregavero domum Israel de populis, in quibus dispersi sunt, sanctificabor in eis coram gentibus, et habitabunt in terra sua, quam dedi servo meo Iacob;"
,"26":"et habitabunt in ea securi et aedificabunt domos plantabuntque vineas et habitabunt confidenter, cum fecero iudicia in omnibus, qui adversantur eis per circuitum, et scient quia ego Dominus Deus eorum '."
}`)
	CurrentBook.AddChapter(29, `{
"1":"In anno decimo, in decimo mense, duodecima mensis, factum est verbum Domini ad me dicens:"
,"2":"' Fili hominis, pone faciem tuam contra pharaonem, regem Aegypti, et prophetabis de eo et de Aegypto universa."
,"3":"Loquere et dices: Haec dicit Dominus Deus: Ecce ego ad te, pharao, rex Aegypti, draco magne, qui cubas,in medio fluminum tuorum,et dicis: 'Meus est fluvius, et ego feci memetipsum!'."
,"4":"Et ponam uncos in maxillis tuis,et agglutinabo pisces fluminum tuorum squamis tuis,et extraham te de medio fluminum tuorum, et universi pisces tui squamis tuis adhaerebunt."
,"5":"Et proiciam te in desertum,et omnes pisces fluminum tuorum. Super faciem terrae cades; non colligeris neque congregaberis. Bestiis terrae et volatilibus caeli,dedi te ad devorandum."
,"6":"Et scient omnes habitatores Aegypti,quia ego Dominus, pro eo quod fuisti baculus arundineus,domui Israel:"
,"7":"quando apprehenderunt te manu, confractus es et lacerasti omnem umerum eorum,et, innitentibus eis super te, comminutus es,et dissolvisti omnes lumbos eorum."
,"8":"Propterea haec dicit Dominus Deus: Ecce ego adducam super te gladium et interficiam de te hominem et iumentum;"
,"9":"et erit terra Aegypti in desertum et solitudinem, et scient quia ego Dominus. Pro eo quod dixeris: 'Fluvius meus est, et ego feci!',"
,"10":"idcirco ecce ego ad te et ad flumina tua, daboque terram Aegypti in solitudines, gladio dissipatam a Magdolo ad Syenen et usque ad terminos Chus."
,"11":"Non pertransibit eam pes hominis, neque pes iumenti gradietur in ea, et non habitabitur quadraginta annis;"
,"12":"daboque terram Aegypti desertam in medio terrarum desertarum, et civitates eius in medio urbium subversarum erunt desolatae quadraginta annis, et dispergam Aegyptios in nationes et ventilabo eos in terras."
,"13":"Quia haec dicit Dominus Deus: Post finem quadraginta annorum congregabo Aegyptios de populis, in quibus dispersi fuerunt,"
,"14":"et convertam sortem Aegypti et collocabo eos in terra Phatures, in terra nativitatis suae; et erunt ibi in regnum humile."
,"15":"Inter regna cetera erit humillima et non elevabitur ultra super nationes, et imminuam eos, ne imperent gentibus."
,"16":"Neque erunt ultra domui Israel in confidentiam, in memoriam revocans iniquitatem, cum sequerentur eos, et scient quia ego Dominus Deus '."
,"17":"Et factum est in vicesimo et septimo anno, in primo, in una mensis, factum est verbum Domini ad me dicens:"
,"18":"' Fili hominis, Nabuchodonosor, rex Babylonis, servire fecit exercitum suum servitute magna adversus Tyrum; omne caput decalvatum et omnis umerus attritus est, et merces non est reddita ei neque exercitui eius de Tyro pro servitute, qua servivit adversum eam."
,"19":"Propterea haec dicit Dominus Deus: Ecce ego dabo Nabuchodonosor, regi Babylonis, terram Aegypti, et accipiet opes eius et depraedabitur manubias eius et diripiet spolia eius, et erit merces exercitui illius,"
,"20":"ut stipendium eius, pro quo servivit adversum eam. Dedi ei terram Aegypti pro eo quod laboraverunt mihi, ait Dominus Deus."
,"21":"In die illo germinare faciam cornu domui Israel, et tibi dabo apertum os in medio eorum, et scient quoniam ego Dominus '."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Et factum est verbum Do mini ad me dicens:"
,"2":"' Fili ho minis, propheta et dic: Haec dicit Dominus Deus: Ululate, vae diei,"
,"3":"quia iuxta est dies, et appropinquat dies Domini, dies nubis; tempus gentium erit."
,"4":"Et veniet gladius in Aegyptum, et erit pavor in Chus, cum ceciderint vulnerati in Aegypto, et ablatae fuerint opes illius, et destructa fundamenta eius."
,"5":"Chus et Phut et Lud et omne vulgus promiscuum,et Chub et filii terrae foederis,cum eis gladio cadent."
,"6":"Haec dicit Dominus Deus: Et corruent fulcientes Aegyptum, et destruetur superbia potentiae eius; a Magdolo usque ad Syenen gladio cadent in ea, ait Dominus Deus."
,"7":"Et dissipabuntur in medio terrarum desolatarum, et urbes eius in medio civitatum desertarum erunt;"
,"8":"et scient quia ego Dominus, cum dedero ignem in Aegyptum, et attriti fuerint omnes auxiliatores eius."
,"9":"In die illa egredientur nuntii a facie mea in navibus ad conterendam confidentiam Chus, et erit pavor in eis in die Aegypti, quia veniet."
,"10":"Haec dicit Dominus Deus: Cessare faciam pompam Aegypti in manu Nabuchodonosor, regis Babylonis."
,"11":"Ipse et populus eius cum eo violentissimi gentium adducentur ad disperdendam terram; et evaginabunt gladios suos super Aegyptum et implebunt terram interfectis."
,"12":"Et faciam alveos fluminum aridos et tradam terram in manu pessimorum et dissipabo terram et plenitudinem eius in manu alienorum. Ego Dominus locutus sum."
,"13":"Haec dicit Dominus Deus: Et disperdam simulacra,et cessare faciam idola de Memphi, et dux de terra Aegypti,non erit amplius, et dabo terrorem in terra Aegypti."
,"14":"Et disperdam terram Phatures,et dabo ignem in Tani,et faciam iudicia in No."
,"15":"Et effundam indignationem meam super Sin, robur Aegypti, et interficiam multitudinem No."
,"16":"Et dabo ignem in Aegypto; quasi parturiens dolebit Sin, et in No scissura erit, et contra Memphin hostes plena die."
,"17":"Iuvenes Heliopoleos et Bubasti gladio cadent, et ipsae captivae ducentur."
,"18":"Et in Taphnis nigrescet dies, cum contrivero ibi sceptra Aegypti, et defecerit in ea superbia potentiae eius; ipsam nubes operiet, filiae autem eius in captivitatem ducentur."
,"19":"Et faciam iudicia in Aegypto, et scient quia ego Dominus '."
,"20":"Et factum est in undecimo anno, in primo, in septima mensis, factum est verbum Domini ad me dicens:"
,"21":"' Fili hominis, brachium pharaonis, regis Aegypti, confregi, et ecce non est obvolutum, ut restitueretur ei sanitas, ut ligaretur pannis et farciretur linteolis, ut recepto robore posset tenere gladium."
,"22":"Propterea haec dicit Dominus Deus: Ecce ego ad pharaonem, regem Aegypti, et comminuam brachium eius forte sed confractum et deiciam gladium de manu eius"
,"23":"et dispergam Aegyptum in gentibus et ventilabo eos in terris."
,"24":"Et confortabo brachia regis Babylonis daboque gladium meum in manu eius; et confringam brachia pharaonis, et gemet gemitibus sicut transfixus coram facie eius."
,"25":"Et confortabo brachia regis Babylonis, et brachia pharaonis concident; et scient quia ego Dominus, cum dedero gladium meum in manu regis Babylonis, et extenderit eum super terram Aegypti."
,"26":"Et dispergam Aegyptum in nationes et ventilabo eos in terras, et scient quia ego Dominus '."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Et factum est in anno unde cimo, in tertio, una mensis, factum est verbum Domini ad me dicens:"
,"2":"Fili hominis, dic pharaoni, regi Aegypti, et pompae eius: Cui similis factus es in magnitudine tua?"
,"3":"Ecce abies, quasi cedrus in Libano, pulcher ramis et frondibus nemorosus,excelsusque altitudine, et inter nubes elevatum est cacumen eius;"
,"4":"aquae nutrierunt illum, abyssus exaltavit eum, flumina eius manabant,in circuitu radicum eius, et rivos suos emisit,ad universa ligna campi."
,"5":"Propterea elevata est altitudo eius,super omnia ligna campi, et multiplicata sunt arbusta eius, et elevati sunt rami eius,propter aquas multas."
,"6":"Cumque extendisset umbram suam, in ramis eius fecerunt nidos,omnia volatilia caeli, et sub frondibus eius genuerunt,omnes bestiae campi, et sub umbra illius habitabat,universa multitudo gentium;"
,"7":"eratque pulcherrimus in magnitudine sua,et in dilatatione arbustorum suorum, erat enim radix illius,iuxta aquas multas."
,"8":"Cedri non fuerunt pares illi,in paradiso Dei; abietes non adaequaverunt,ramos eius, et platani non fuerunt,aequae frondibus illius; omne lignum paradisi Dei,non est assimilatum illi et pulchritudini eius,"
,"9":"quoniam speciosum feci eum,et multis condensisque frondibus: et aemulata sunt eum omnia ligna Eden, quae erant in paradiso Dei."
,"10":"Propterea haec dicit Dominus Deus: Pro eo quod sublimatus est in altitudine et dedit summitatem suam usque in nubes, et elevatum est cor eius in altitudine sua,"
,"11":"tradam eum in manu potentis principis gentium; faciens faciet ei: iuxta impietatem eius eieci eum."
,"12":"Et succident illum alieni, violentissimi nationum; et proicient eum super montes, et in cunctis convallibus corruent rami eius, et confringentur arbusta eius in universis voraginibus terrae, et recedent de umbra eius omnes populi terrae et relinquent eum."
,"13":"Super ruinam eius habitabunt,omnia volatilia caeli, et in ramis eius erunt,universae bestiae campi,"
,"14":"ne eleventur in altitudine sua,omnia ligna aquarum neque ponant,sublimitatem suam inter nubes nec,stent apud eas in sublimitate sua,omnia, quae irrigantur aquis, quia,omnes traditi sunt in mortem,ad inferiora terrae, in medio filiorum hominum, ad eos, qui descendunt in lacum."
,"15":"Haec dicit Dominus Deus: In die, quando descendit ad inferos, induxi luctum, operui propter eum abyssum et prohibui flumina eius et coercui aquas multas; obscuravi super eum Libanum, et omnia ligna agri concussa sunt."
,"16":"A sonitu ruinae eius commovi gentes, cum deducerem eum ad infernum cum his, qui descendebant in lacum; et consolata sunt in inferioribus terrae omnia ligna Eden, egregia atque praeclara in Libano, universa, quae irrigabantur aquis."
,"17":"Nam et ipsi cum eo descenderunt ad infernum ad interfectos gladio et auxiliatores eius, qui sederant sub umbra eius in medio nationum."
,"18":"Cui assimilatus es, o inclite atque sublimis inter ligna Eden? Et ecce deductus es cum lignis Eden ad inferiora terrae; in medio incircumcisorum dormies cum his, qui interfecti sunt gladio. Ipse est pharao et omnis pompa eius ', dicit Dominus Deus."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Et factum est duodecimo anno, in mense duodecimo, in una mensis, factum est verbum Domini ad me dicens:"
,"2":"' Fili hominis, assume lamentum super pharaonem, regem Aegypti, et dices ad eum: Leo gentium peristi, et eras sicut draco in mari; et bulliebas in fluminibus tuis,et conturbabas aquas pedibus tuis,et turbida faciebas flumina earum."
,"3":"Haec dicit Dominus Deus: Expandam super te rete meum,in coetu populorum multorum, et extrahent te in sagena mea;"
,"4":"et proiciam te in terram, super faciem agri abiciam te,et habitare faciam super te omnia volatilia caeli,et saturabo de te bestias universae terrae;"
,"5":"et dabo carnes tuas super montes,et implebo valles sanie tua."
,"6":"Et irrigabo terram paedore,sanguinis tui super montes, et voragines implebuntur ex te;"
,"7":"et operiam, cum exstinctus fueris, caelum,et nigrescere faciam stellas eius: solem nube tegam, et luna non dabit lumen suum;"
,"8":"omnia luminaria caeli,maerere faciam super te,et dabo tenebras super terram tuam, dicit Dominus Deus."
,"9":"Et commovebo cor populorum multorum, cum induxero contritionem tuam in gentibus super terras, quas nescis."
,"10":"Et stupescere faciam super te populos multos, et reges eorum horrore nimio formidabunt super te, cum volare coeperit gladius meus coram facie eorum, et obstupescet tremefactus unusquisque pro anima sua in die ruinae tuae."
,"11":"Quia haec dicit Dominus Deus: Gladius regis Babylonis veniet tibi,"
,"12":"in gladiis fortium deiciam multitudinem tuam; violentissimae gentium omnium hae,et vastabunt superbiam Aegypti, et dissipabitur omnis pompa eius."
,"13":"Et perdam omnia iumenta eius, quae erant super aquas plurimas, et non conturbabit eas pes hominis ultra, neque ungula iumentorum turbabit eas;"
,"14":"tunc purissimas reddam aquas eorum,et flumina eorum quasi oleum adducam, ait Dominus Deus."
,"15":"Cum dedero terram Aegypti desolatam, deseretur autem terra a plenitudine sua, quando percussero omnes habitatores eius, scient quia ego Dominus."
,"16":"Planctus est, et plangent eum; filiae gentium plangent eum, super Aegyptum et super omnem pompam eius plangent eum ', ait Dominus Deus."
,"17":"Et factum est in duodecimo anno, in quinta decima mensis, factum est verbum Domini ad me dicens:"
,"18":"' Fili hominis, cane lugubre super pompam Aegypti et detrahe eam, ipsam et filias gentium robustarum ad inferiora terrae cum his, qui descendunt in lacum."
,"19":"Quo pulchrior es?,Descende et dormi cum incircumcisis."
,"20":"In medio interfectorum gladio cadent; gladius datus est, attraxerunt eam et omnes populos eius."
,"21":"Loquentur ei potentissimi robustorum de medio inferni, cum auxiliatoribus eius descenderunt: 'Tacent incircumcisi interfecti gladio!'."
,"22":"Ibi Assyria et omnis multitudo eius, in circuitu illius sepulcra eius, omnes interfecti, qui ceciderunt gladio;"
,"23":"quorum data sunt sepulcra in profundissimis laci, et facta est multitudo eius per gyrum sepulcri eius; universi interfecti, cadentes gladio, qui dederant quondam formidinem in terra viventium."
,"24":"Ibi Elam et omnis pompa eius per gyrum sepulcri sui; omnes hi interfecti ruentesque gladio, qui descenderunt incircumcisi ad inferiora terrae, qui dederant quondam formidinem suam in terra viventium et sustulerunt ignominiam suam cum his, qui descendunt in lacum."
,"25":"In medio interfectorum posuerunt cubile eius, in omni pompa eius, in circuitu eius sepulcra illius, omnes hi incircumcisi interfectique gladio; dederant enim terrorem suum in terra viventium et sustulerunt ignominiam suam cum his, qui descendunt in lacum, in medio interfectorum positi sunt."
,"26":"Ibi Mosoch, Thubal et omnis pompa eius, in circuitu illius sepulcra eius, omnes hi incircumcisi interfectique gladio, quia dederunt formidinem suam in terra viventium;"
,"27":"et non dormient cum fortibus, qui ceciderunt a saeculo et descenderunt ad infernum cum armis suis et posuerunt gladios suos sub capitibus suis, et fuerunt scuta eorum super ossa eorum, quia terror fortium erat in terra viventium."
,"28":"Et tu ergo in medio incircumcisorum contereris et dormies cum interfectis gladio."
,"29":"Ibi Idumaea, reges eius et omnes duces eius, qui dati sunt in robore suo cum interfectis gladio et qui cum incircumcisis dormiunt et cum his, qui descenderunt in lacum."
,"30":"Ibi principes aquilonis omnes et universi Sidonii, qui deducti sunt cum interfectis in terrore suo, in sua fortitudine confusi; qui dormiunt incircumcisi cum interfectis gladio et sustulerunt confusionem suam cum his, qui descendunt in lacum."
,"31":"Videbit eos pharao et consolabitur super universa pompa sua. Interfecti sunt gladio pharaonis et omnis exercitus eius, ait Dominus Deus,"
,"32":"quia dedi terrorem meum in terra viventium; et prostratus est in medio incircumcisorum cum interfectis gladio pharaonis et omnis pompa eius ', ait Dominus Deus."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Et factum est verbum Do mini ad me dicens:"
,"2":"' Fili ho minis, loquere ad filios populi tui et dices ad eos: Terra, cum induxero super eam gladium, et tulerit populus terrae virum unum de finibus suis et constituerit eum sibi speculatorem,"
,"3":"et ille viderit gladium venientem super terram et cecinerit bucina et annuntiaverit populo;"
,"4":"audiens autem quisquis ille est sonum bucinae, non se observaverit, veneritque gladius et tulerit eum: sanguis ipsius super caput eius erit;"
,"5":"sonum bucinae audivit et non se observavit, sanguis eius in ipso erit. Si autem se custodierit, animam suam salvavit."
,"6":"Quod si speculator viderit gladium venientem et non insonuerit bucina, et populus non se custodierit; veneritque gladius et tulerit de eis animam: ille quidem in iniquitate sua captus est, sanguinem autem eius de manu speculatoris requiram."
,"7":"Te autem, fili hominis, speculatorem dedi domui Israel. Audiens ergo ex ore meo sermonem, commonebis eos ex me."
,"8":"Si, me dicente ad impium: Impie, morte morieris, non fueris locutus, ut se custodiat impius a via sua, ipse impius in iniquitate sua morietur, sanguinem autem eius de manu tua requiram."
,"9":"Si autem commonueris impium, ut a viis suis convertatur, et ille non fuerit conversus a via sua, ipse in iniquitate sua morietur, porro tu animam tuam liberasti."
,"10":"Tu ergo, fili hominis, dic ad domum Israel: Sic locuti estis, dicentes: 'Iniquitates nostrae et peccata nostra super nos sunt, et in ipsis nos tabescimus; quomodo ergo vivere poterimus?'."
,"11":"Dic ad eos: Vivo ego, dicit Dominus Deus; nolo mortem impii, sed ut revertatur impius a via sua et vivat. Convertimini, convertimini a viis vestris pessimis; et quare moriemini, domus Israel?"
,"12":"Tu itaque, fili hominis, dic ad filios populi tui: Iustitia iusti non liberabit eum in quacumque die praevaricatus fuerit; et impietas impii non nocebit ei in quacumque die conversus fuerit ab impietate sua; et iustus non poterit vivere in iustitia sua in quacumque die peccaverit."
,"13":"Etiamsi dixero iusto quod vita vivat, et, confisus in iustitia sua, fecerit iniquitatem, omnes iustitiae eius oblivioni tradentur, et in iniquitate sua, quam operatus est, in ipsa morietur."
,"14":"Sin autem dixero impio: Morte morieris, et egerit paenitentiam a peccato suo feceritque iudicium et iustitiam,"
,"15":"pignus restituerit ille impius rapinamque reddiderit, in mandatis vitae ambulaverit nec fecerit quidquam iniustum, vita vivet et non morietur;"
,"16":"omnia peccata eius, quae peccavit, non imputabuntur ei: iudicium et iustitiam fecit, vita vivet."
,"17":"Et dicunt filii populi tui: 'Non est aequa via Domini'; et ipsorum via iniqua est."
,"18":"Cum enim recesserit iustus a iustitia sua feceritque iniquitates, morietur in eis;"
,"19":"et cum recesserit impius ab impietate sua feceritque iudicium et iustitiam, vivet in eis."
,"20":"Et dicitis: 'Non est recta via Domini'. Unumquemque iuxta vias suas iudicabo de vobis, domus Israel '."
,"21":"Et factum est in duodecimo anno, in decimo, in quinta mensis transmigrationis nostrae, venit ad me, qui fugerat de Ierusalem, dicens: ' Vastata est civitas '."
,"22":"Manus autem Domini facta fuerat ad me vespere, antequam veniret qui fugerat; aperuitque os meum, donec veniret ad me mane, et, aperto ore meo, non silui amplius."
,"23":"Et factum est verbum Domini ad me dicens:"
,"24":"' Fili hominis, qui habitant in ruinosis his super humum Israel, loquentes aiunt: 'Unus erat Abraham et hereditate possedit terram; nos autem multi, nobis data est terra in possessionem'."
,"25":"Idcirco dices ad eos: Haec dicit Dominus Deus: Qui in sanguine comeditis et oculos vestros levatis ad idola vestra et sanguinem funditis, numquid terram hereditate possidebitis?"
,"26":"Stetistis in gladiis vestris, fecistis abominationes, et unusquisque uxorem proximi sui polluit, et terram hereditate possidebitis?"
,"27":"Haec dices ad eos: Sic dicit Dominus Deus: Vivo ego, qui in ruinosis habitant, gladio cadent; et, qui in agro est, bestiis tradetur ad devorandum; qui autem in praesidiis et in speluncis sunt, peste morientur."
,"28":"Et dabo terram in solitudinem et desertum, et deficiet superba fortitudo eius, et desolabuntur montes Israel, ita ut nullus sit qui per eos transeat;"
,"29":"et scient quia ego Dominus, cum dedero terram desolatam et desertam propter universas abominationes suas, quas operati sunt."
,"30":"Et tu, fili hominis, filii populi tui, qui loquuntur de te iuxta parietes et in ostiis domorum et dicunt unus ad alterum, vir ad fratrem suum, loquentes: 'Venite et audite, qui sit sermo egrediens a Domino'."
,"31":"Et veniunt ad te quasi si conveniat populus, et sedent coram te populus meus; et audiunt sermones tuos et non faciunt eos, quia quasi amatores loquuntur, et avaritiam suam sequitur cor eorum."
,"32":"Et es eis quasi carmen amatorum, quod suavi voce et cum dulci chordarum sono canitur, et audiunt verba tua et non faciunt ea."
,"33":"Et cum venerit, quod praedictum est - ecce enim venit - tunc scient quod prophetes fuerit inter eos '."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Et factum est verbum Do mini ad me dicens:"
,"2":"' Fili ho minis, propheta de pastoribus Israel, propheta et dices pastoribus: Haec dicit Dominus Deus: Vae pastoribus Israel, qui pascebant semetipsos! Nonne greges pascuntur a pastoribus?"
,"3":"Lac comedebatis et lana operiebamini et, quod crassum erat, occidebatis, gregem autem non pascebatis;"
,"4":"quod infirmum fuit, non consolidastis et, quod aegrotum, non sanastis; quod fractum est, non alligastis et, quod eiectum est, non reduxistis et, quod perierat, non quaesistis et super forte imperabatis cum violentia."
,"5":"Et dispersae sunt oves meae, eo quod non esset pastor; et factae sunt in devorationem omnium bestiarum agri et dispersae sunt."
,"6":"Erraverunt greges mei in cunctis montibus et in universo colle excelso, et super omnem faciem terrae dispersi sunt greges mei; et non erat qui requireret, non erat qui requireret."
,"7":"Propterea, pastores, audite verbum Domini:"
,"8":"Vivo ego, dicit Dominus Deus, pro eo quod factus est grex meus in rapinam et oves meae in devorationem omnium bestiarum agri, eo quod non esset pastor, neque enim quaesierunt pastores mei gregem meum, sed pascebant pastores semetipsos et gregem meum non pascebant,"
,"9":"propterea, pastores, audite verbum Domini."
,"10":"Haec dicit Dominus Deus: Ecce ego ipse super pastores requiram gregem meum de manu eorum et cessare eos faciam, ut ultra non pascant gregem nec pascant amplius pastores semetipsos; et liberabo gregem meum de ore eorum, et non erit ultra eis in escam."
,"11":"Quia haec dicit Dominus Deus: Ecce ego ipse requiram oves meas et visitabo eas."
,"12":"Sicut visitat pastor gregem suum in die, quando fuerit in medio ovium suarum dissipatarum, sic visitabo oves meas et liberabo eas de omnibus locis, in quibus dispersae fuerant in die nubis et caliginis."
,"13":"Et educam eas de populis et congregabo eas de terris et inducam eas in terram suam et pascam eas in montibus Israel, in rivis et in cunctis sedibus terrae."
,"14":"In pascuis uberrimis pascam eas, et in montibus excelsis Israel erunt pascua earum; ibi requiescent in herbis virentibus et in pascuis pinguibus pascentur super montes Israel."
,"15":"Ego pascam oves meas et ego eas accubare faciam, dicit Dominus Deus."
,"16":"Quod perierat, requiram et, quod eiectum erat, reducam et, quod confractum fuerat, alligabo et, quod infirmum erat, consolidabo et, quod pingue et forte, custodiam et pascam illas in iudicio."
,"17":"Vos autem, grex meus, haec dicit Dominus Deus: Ecce ego iudico inter pecus et pecus, inter arietes et hircos."
,"18":"Nonne satis vobis erat pascuam bonam depasci? Insuper et reliquias pascuarum vestrarum conculcastis pedibus vestris et, cum purissimam aquam biberetis, reliquam pedibus vestris turbabatis;"
,"19":"et oves meae his, quae conculcata pedibus vestris fuerant, pascebantur et, quae pedes vestri turbaverant, haec bibebant."
,"20":"Propterea haec dicit Dominus Deus ad eos: Ecce ego ipse iudico inter pecus pingue et macilentum;"
,"21":"pro eo quod lateribus et umeris impingebatis et cornibus vestris ventilabatis omnia infirma pecora, donec dispergerentur foras,"
,"22":"salvabo gregem meum, et non erit ultra in rapinam, et iudicabo inter pecus et pecus."
,"23":"Et suscitabo super eas pastorem unum, qui pascat eas, servum meum David; ipse pascet eas et ipse erit eis in pastorem."
,"24":"Ego autem Dominus ero eis in Deum, et servus meus David princeps in medio eorum. Ego Dominus locutus sum."
,"25":"Et faciam cum eis pactum pacis et cessare faciam bestias pessimas de terra, et habitabunt in deserto securi et dormient in saltibus;"
,"26":"et ponam eos et, quae sunt in circuitu collis mei, benedictionem et deducam imbrem in tempore suo: pluviae benedictionis erunt."
,"27":"Et dabit lignum agri fructum suum, et terra dabit germen suum, et erunt in terra sua absque timore et scient quia ego Dominus, cum contrivero vectes iugi eorum et eruero eos de manu imperantium sibi."
,"28":"Et non erunt ultra in rapinam gentibus, neque bestiae terrae devorabunt eos, sed habitabunt confidenter absque ullo terrore."
,"29":"Et suscitabo eis germen nominatum, et non erunt ultra imminuti fame in terra neque portabunt ultra opprobrium gentium;"
,"30":"et scient quia ego Dominus Deus eorum cum eis, et ipsi populus meus domus Israel, ait Dominus Deus."
,"31":"Vos autem grex meus, grex pascuae meae vos, et ego Dominus Deus vester ', dicit Dominus Deus."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, pone faciem tuam adversum montem Seir et propheta de eo et dices illi:"
,"3":"Haec dicit Dominus Deus: Ecce ego ad te, mons Seir; et extendam manum meam super te,et dabo te desolatum atque desertum."
,"4":"Urbes tuas demoliar, et tu desertus eris,et scies quia ego Dominus."
,"5":"Eo quod fueris inimicus sempiternus et concluseris filios Israel in manus gladii in tempore afflictionis eorum, in tempore poenae extremae;"
,"6":"propterea, vivo ego, dicit Dominus Deus, sanguini tradam te, et sanguis te persequetur et, cum sanguinem non oderis, sanguis persequetur te."
,"7":"Et dabo montem Seir desolatum atque desertum et auferam de eo euntem et redeuntem"
,"8":"et implebo montes eius occisorum suorum, in collibus tuis et in vallibus tuis, atque in omnibus torrentibus tuis interfecti gladio cadent."
,"9":"In solitudines sempiternas tradam te, et civitates tuae non habitabuntur, et scietis quoniam ego Dominus."
,"10":"Eo quod dixeris: 'Duae gentes et duae terrae meae erunt, et hereditate possidebo eas!', cum Dominus esset ibi;"
,"11":"propterea, vivo ego, dicit Dominus Deus, faciam iuxta iram tuam et secundum zelum tuum, quem fecisti odio habens eos, et notus efficiar in eis, cum te iudicavero."
,"12":"Et scies quia ego Dominus audivi universa opprobria tua, quae locutus es de montibus Israel dicens: 'Deserti nobis ad devorandum dati sunt!'."
,"13":"Et insurrexistis super me ore vestro et vociferati estis vobis adversum me verba vestra; ego audivi."
,"14":"Haec dicit Dominus Deus: Laetante universa terra, in solitudinem te redigam;"
,"15":"sicuti gavisus es super hereditatem domus Israel, eo quod fuerit dissipata, sic faciam tibi: dissipatus eris, mons Seir, et Idumaea omnis, et scient quia ego Dominus."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Tu autem, fili hominis, pro pheta super montes Israel et dices: Montes Israel, audite verbum Domini."
,"2":"Haec dicit Dominus Deus: Eo quod dixerit inimicus de vobis: 'Euge, altitudines sempiternae in hereditatem datae sunt nobis'; 3 propterea vaticinare et dic: Haec dicit Dominus Deus: Pro eo quod desolati estis, et inhiaverunt vobis per circuitum, ut fieretis in hereditatem reliquis gentibus, et ascendistis super labium linguae et opprobrium populi;"
,"4":"propterea, montes Israel, audite verbum Domini Dei: Haec dicit Dominus Deus montibus et collibus, torrentibus vallibusque et desertis dissipatis et urbibus derelictis, quae depopulatae sunt et subsannatae a reliquis gentibus per circuitum;"
,"5":"propterea haec dicit Dominus Deus: In igne zeli mei locutus sum de reliquis gentibus et de Idumaea universa, quae dederunt terram meam sibi in hereditatem cum gaudio et toto corde et ex animo maligno, ut pascua eius depraedarentur."
,"6":"Idcirco vaticinare super humum Israel et dices montibus et collibus, torrentibus et vallibus: Haec dicit Dominus Deus: Ecce ego in zelo meo et in furore meo locutus sum, eo quod confusionem gentium sustinueritis;"
,"7":"idcirco haec dicit Dominus Deus: Ego levavi manum meam: gentes, quae in circuitu vestro sunt, ipsae confusionem suam portabunt;"
,"8":"vos autem, montes Israel, ramos vestros germinabitis et fructum vestrum afferetis populo meo Israel, prope est enim ut veniat."
,"9":"Quia ecce ego ad vos et convertar ad vos, et arabimini et accipietis sementem;"
,"10":"et multiplicabo in vobis homines, omnem domum Israel, et habitabuntur civitates, et ruinosa instaurabuntur."
,"11":"Et replebo vos hominibus et iumentis, et multiplicabuntur et crescent; et habitari vos faciam, sicut a principio bonisque donabo maioribus quam habuistis ab initio, et scietis quia ego Dominus."
,"12":"Et adducam super vos homines, populum meum Israel, et hereditate possidebunt te, et eris eis in hereditatem et non addes ultra ut eos facias absque liberis."
,"13":"Haec dicit Dominus Deus: Pro eo quod dicunt de vobis: 'Devoratrix hominum es et faciens gentem tuam absque liberis';"
,"14":"propterea homines non comedes amplius et gentem tuam non facies ultra absque liberis, ait Dominus Deus."
,"15":"Nec auditam faciam in te amplius ignominiam gentium, et opprobrium populorum nequaquam portabis ultra et gentem tuam non facies amplius absque liberis ', ait Dominus Deus."
,"16":"Et factum est verbum Domini ad me dicens:"
,"17":"' Fili hominis, domus Israel habitaverunt in humo sua et polluerunt eam in viis suis et in operibus suis; iuxta immunditiam menstruatae facta est via eorum coram me."
,"18":"Et effudi indignationem meam super eos pro sanguine, quem fuderunt super terram, et in idolis suis polluerunt eam."
,"19":"Et dispersi eos in gentes, et ventilati sunt in terras; iuxta vias eorum et iuxta opera eorum iudicavi eos."
,"20":"Et ingressi sunt ad gentes, ad quas introierunt, et polluerunt nomen sanctum meum, cum diceretur de eis: 'Populus Domini iste est, et de terra eius egressi sunt'."
,"21":"Et peperci nomini meo sancto, quod polluerat domus Israel in gentibus, ad quas ingressi sunt."
,"22":"Idcirco dices domui Israel: Haec dicit Domihus Deus: Non propter vos ego faciam, domus Israel, sed propter nomen sanctum meum, quod polluistis in gentibus, ad quas intrastis;"
,"23":"et sanctificabo nomen meum magnum, quod pollutum est inter gentes, quod polluistis in medio earum, ut sciant gentes quia ego Dominus, ait Dominus Deus, cum sanctificatus fuero in vobis coram eis."
,"24":"Tollam quippe vos de gentibus et congregabo vos de universis terris et adducam vos in terram vestram;"
,"25":"et effundam super vos aquam mundam, et mundabimini ab omnibus inquinamentis vestris, et ab universis idolis vestris mundabo vos."
,"26":"Et dabo vobis cor novum et spiritum novum ponam in medio vestri et auferam cor lapideum de carne vestra et dabo vobis cor carneum;"
,"27":"et spiritum meum ponam in medio vestri et faciam, ut in praeceptis meis ambuletis et iudicia mea custodiatis et operemini."
,"28":"Et habitabitis in terra, quam dedi patribus vestris, et eritis mihi in populum, et ego ero vobis in Deum."
,"29":"Et salvabo vos ex universis inquinamentis vestris et vocabo frumentum et multiplicabo illud et non imponam vobis famem."
,"30":"Et multiplicabo fructum ligni et genimina agri, ut non portetis ultra opprobrium famis in gentibus."
,"31":"Et recordabimini viarum vestrarum pessimarum operumque non bonorum, et displicebunt vobis iniquitates vestrae et scelera vestra."
,"32":"Non propter vos ego faciam, ait Dominus Deus, notum sit vobis; confundimini et erubescite super viis vestris, domus Israel."
,"33":"Haec dicit Dominus Deus: In die, qua mundavero vos ex omnibus iniquitatibus vestris et inhabitari fecero urbes et instauravero ruinosa,"
,"34":"et terra deserta fuerit exculta, quae quondam erat desolata in oculis omnis viatoris,"
,"35":"dicent: 'Terra illa inculta facta est ut hortus Eden, et civitates desertae et destitutae atque destructae munitae inhabitantur'."
,"36":"Et scient gentes, quaecumque derelictae fuerint in circuitu vestro, quia ego Dominus aedificavi dissipata plantavique inculta; ego Dominus locutus sum et facio."
,"37":"Haec dicit Dominus Deus: Adhuc in hoc exorabor a domo Israel, ut faciam eis: multiplicabo eos sicut gregem hominum,"
,"38":"ut gregem sanctum, ut gregem Ierusalem in sollemnitatibus eius; sic erunt civitates desertae plenae gregibus hominum, et scient quia ego Dominus '."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Facta est super me manus Domini et eduxit me in spiri tu Domini et posuit me in medio campi, qui erat plenus ossibus,"
,"2":"et circumduxit me per ea in gyro: erant autem multa valde super faciem campi siccaque vehementer."
,"3":"Et dixit ad me: ' Fili hominis, putasne vivent ossa ista? '. Et dixi: ' Domine, tu nosti '."
,"4":"Et dixit ad me: ' Vaticinare super ossa ista et dices eis: Ossa arida, audite verbum Domini."
,"5":"Haec dicit Dominus Deus ossibus his: Ecce ego intromittam in vos spiritum, et vivetis,"
,"6":"et dabo super vos nervos et succrescere faciam super vos carnes et superextendam in vobis cutem et dabo vobis spiritum, et vivetis et scietis quia ego Dominus '."
,"7":"Et prophetavi, sicut praeceperat mihi. Factus est autem sonitus, prophetante me, et ecce commotio; et accesserunt ossa ad ossa, unumquodque ad iuncturam suam."
,"8":"Et vidi: et ecce super ea nervi et carnes ascenderunt, et extenta est in eis cutis desuper, sed spiritum non habebant."
,"9":"Et dixit ad me: ' Vaticinare ad spiritum; vaticinare, fili hominis, et dices ad spiritum: Haec dicit Dominus Deus: A quattuor ventis veni, spiritus, et insuffla super interfectos istos, ut reviviscant '."
,"10":"Et prophetavi, sicut praeceperat mihi, et ingressus est in ea spiritus; et vixerunt steteruntque super pedes suos, exercitus grandis nimis valde."
,"11":"Et dixit ad me: ' Fili hominis, ossa haec universa domus Israel est. Ipsi dicunt: 'Aruerunt ossa nostra, et periit spes nostra, et abscissi sumus'."
,"12":"Propterea vaticinare et dices ad eos: Haec dicit Dominus Deus: Ecce ego aperiam tumulos vestros et educam vos de sepulcris vestris, populus meus, et inducam vos in terram Israel;"
,"13":"et scietis quia ego Dominus, cum aperuero sepulcra vestra et eduxero vos de tumulis vestris, populus meus."
,"14":"Et dabo spiritum meum in vobis, et vivetis, et collocabo vos super humum vestram, et scietis quia ego Dominus. Locutus sum et facio ', ait Dominus Deus."
,"15":"Et factus est sermo Domini ad me dicens:"
,"16":"' Et tu, fili hominis, sume tibi lignum unum et scribe super illud: Iudae et filiis Israel sociis eius. Et tolle lignum alterum et scribe super illud: Ioseph, lignum Ephraim, et cunctae domui Israel sociis eius."
,"17":"Et adiunge illa unum ad alterum tibi in lignum unum; et erunt in unionem in manu tua."
,"18":"Cum autem dixerint ad te filii populi tui loquentes: 'Nonne indicas nobis, quid in his tibi velis?',"
,"19":"loqueris ad eos: Haec dicit Dominus Deus: Ecce ego assumam lignum Ioseph, quod est in manu Ephraim, et tribus Israel, quae iunctae sunt ei, et dabo eas pariter cum ligno Iudae et faciam eas in lignum unum, et erunt unum in manu mea."
,"20":"Erunt autem ligna, super quae scripseris, in manu tua in oculis eorum,"
,"21":"et dices ad eos: Haec dicit Dominus Deus: Ecce ego assumam filios Israel de medio nationum, ad quas abierunt, et congregabo eos undique et adducam eos ad humum suam"
,"22":"et faciam eos in gentem unam in terra, in montibus Israel; et rex unus erit omnibus imperans, et non erunt ultra duae gentes nec dividentur amplius in duo regna."
,"23":"Neque polluentur ultra in idolis suis et abominationibus suis et in cunctis iniquitatibus suis, et salvos eos faciam de universis aversionibus suis, quibus peccaverunt, et mundabo eos, et erunt mihi populus, et ego ero eis Deus."
,"24":"Et servus meus David rex super eos, et pastor unus erit omnium eorum; in iudiciis meis ambulabunt et mandata mea custodient et facient ea."
,"25":"Et habitabunt super terram, quam dedi servo meo Iacob, in qua habitaverunt patres vestri; et habitabunt super eam, ipsi et filii eorum et filii filiorum eorum usque in sempiternum, et David servus meus princeps eorum in perpetuum."
,"26":"Et percutiam illis foedus pacis, pactum sempiternum erit eis, et fundabo eos et multiplicabo; et dabo sanctuarium meum in medio eorum in perpetuum,"
,"27":"et erit habitaculum meum in eis, et ero eis Deus, et ipsi erunt mihi populus;"
,"28":"et scient gentes quia ego Dominus sanctificator Israel, cum fuerit sanctuarium meum in medio eorum in perpetuum '."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Et factus est sermo Domini ad me dicens:"
,"2":"' Fili hominis, pone faciem tuam contra Gog, in terra Magog, principem summum Mosoch et Thubal, et vaticinare de eo"
,"3":"et dices: Haec dicit Dominus Deus: Ecce ego ad te, Gog, principem summum Mosoch et Thubal,"
,"4":"et circumagam te et ponam uncos in maxillis tuis et educam te et omnem exercitum tuum, equos et equites vestitos perfecte universos, multitudinem magnam cum scuto et clipeo arripientes gladium."
,"5":"Persae, Chus et Phut cum eis, omnes scutati et galeati;"
,"6":"Gomer et universa agmina eius, domus Thogorma de extremo aquilone et totum robur eius, populi multi tecum."
,"7":"Praepara et instrue te et omnem multitudinem tuam, quae coacervata est ad te, et esto mihi in custodiam."
,"8":"Post dies multos evocaberis; in novissimo annorum venies ad terram, quae reversa est a gladio, congregata est de populis multis ad montes Israel, qui fuerunt deserti iugiter: haec de populis educta est, et habitant in ea confidenter universi."
,"9":"Ascendens autem quasi tempestas venies, quasi nubes, ut operias terram, tu et omnia agmina tua et populi multi tecum."
,"10":"Haec dicit Dominus Deus: In die illa ascendent sermones super cor tuum, et cogitabis cogitationem pessimam"
,"11":"et dices: 'Ascendam ad terram absque muro, veniam ad quiescentes habitantesque secure; hi omnes habitant sine muro, vectes et portae non sunt eis';"
,"12":"ut diripias spolia et capias praedam, ut inferas manum tuam super deserta iterum inhabitata et super populum, qui est congregatus ex gentibus, qui acquisivit pecora et substantiam et habitat in umbilico terrae."
,"13":"Saba et Dedan et negotiatores Tharsis et omnes principes eius dicent tibi: 'Numquid ad sumenda spolia tu venis? Numquid ad diripiendam praedam congregasti multitudinem tuam, ut tollas argentum et aurum, auferas pecora atque substantiam et diripias manubias infinitas?'."
,"14":"Propterea vaticinare, fili hominis, et dices ad Gog: Haec dicit Dominus Deus: Numquid non in die illo, cum habitaverit populus meus Israel confidenter, consurges?"
,"15":"Et venies de loco tuo ab extremo aquilone, tu et populi multi tecum, ascensores equorum universi, coetus magnus et exercitus vehemens."
,"16":"Et ascendes super populum meum Israel quasi nubes, ut operias terram. In novissimis diebus erit, et adducam te super terram meam, ut sciant gentes me, cum sanctificatus fuero in te in oculis eorum, o Gog."
,"17":"Haec dicit Dominus Deus: Tu ergo ille es, de quo locutus sum in diebus antiquis in manu servorum meorum prophetarum Israel, qui prophetaverunt in diebus illis per annos, ut adducerem te super eos."
,"18":"Et erit in die illa, in die adventus Gog super terram Israel, ait Dominus Deus, ascendet indignatio mea in furore meo."
,"19":"Et in zelo meo, in igne irae meae locutus sum: In die illa erit commotio magna super terram Israel,"
,"20":"et commovebuntur a facie mea pisces maris et volucres caeli et bestiae agri et omne reptile, quod movetur super humum, cunctique homines, qui sunt super faciem terrae; et subvertentur montes, et cadent rupes, et omnis murus in terram corruet."
,"21":"Et convocabo adversus eum in cunctis montibus meis gladium, ait Dominus Deus; gladius uniuscuiusque in fratrem suum dirigetur."
,"22":"Et iudicabo eum peste et sanguine et imbre vehementi et lapidibus grandinis; ignem et sulphur pluam super eum et super exercitum eius et super populos multos, qui sunt cum eo,"
,"23":"et magnificabor et sanctificabor et notus ero in oculis multarum gentium, et scient quia ego Dominus."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Tu autem, fili hominis, va ticinare adversum Gog et dices: Haec dicit Dominus Deus: Ecce ego super te, Gog, principem summum Mosoch e Thubal;"
,"2":"et circumagam te et seducam te et ascendere faciam de extremo aquilone et adducam te super montes Israel."
,"3":"Et percutiam arcum tuum in manu sinistra tua et sagittas tuas de manu dextera tua deiciam."
,"4":"Super montes Israel cades, tu et omnia agmina tua et populi, qui sunt tecum; feris avibus, omni volatili et bestiis terrae dedi te devorandum:"
,"5":"super faciem agri cades, quia ego locutus sum, ait Dominus Deus."
,"6":"Et emittam ignem in Magog et in his, qui habitant in insulis confidenter, et scient quia ego Dominus."
,"7":"Et nomen sanctum meum notum faciam in medio populi mei Israel et non polluam nomen sanctum meum amplius, et scient gentes quia ego Dominus, sanctus in Israel."
,"8":"Ecce venit et fit, ait Dominus Deus; haec est dies, de qua locutus sum."
,"9":"Et egredientur habitatores de civitatibus Israel et succendent et comburent arma, clipeum et scutum, arcum et sagittas et baculos, manus et contos, et succendent ea igne septem annis."
,"10":"Et non portabunt ligna de campis neque succident de saltibus, quoniam arma succendent igne et depraedabuntur eos, quibus praedae fuerant, et diripient vastatores suos, ait Dominus Deus."
,"11":"Et erit, in die illa dabo Gog locum nominatum sepulcrum in Israel, vallem viatorum ad orientem maris, quae oppilat viam praetereuntibus; et sepelient ibi Gog et omnem multitudinem eius, et vocabitur vallis Multitudinis Gog."
,"12":"Et sepelient eos domus Israel, ut mundent terram septem mensibus;"
,"13":"sepeliet autem eum omnis populus terrae, et erit eis nominata dies, in qua glorificatus sum, ait Dominus Deus."
,"14":"Et viros iugiter constituent lustrantes terram, qui sepeliant eos, qui remanserant super faciem terrae, ut emundent eam; post menses autem septem quaerere incipient"
,"15":"et circuibunt peragrantes terram; cumque viderint os hominis, statuent iuxta illud titulum, donec sepeliant illud pollinctores in valle Multitudinis Gog."
,"16":"Nomen quoque civitatis Amona, et mundabunt terram."
,"17":"Tu ergo, fili hominis, haec dicit Dominus Deus, dic volucri, universis avibus cunctisque bestiis agri: Convenite, properate, concurrite undique ad victimam meam, quam ego immolo vobis, victimam grandem super montes Israel, ut comedatis carnes et bibatis sanguinem."
,"18":"Carnes fortium comedetis et sanguinem principum terrae bibetis: arietes, agni et hirci taurique saginati de Basan sunt omnes;"
,"19":"et comedetis adipem in saturitatem et bibetis sanguinem in ebrietatem de victima, quam ego immolabo vobis."
,"20":"Et saturabimini super mensam meam de equo et de iugali currus, de forti et de universis viris bellatoribus, ait Dominus Deus."
,"21":"Et ponam gloriam meam in gentibus, et videbunt omnes gentes iudicium meum, quod fecerim, et manum meam, quam posuerim super eos;"
,"22":"et scient domus Israel quia ego Dominus Deus eorum a die illa et deinceps,"
,"23":"et scient gentes quoniam in iniquitate sua capta sit domus Israel, eo quod reliquerint me, et absconderim faciem meam ab eis et tradiderim eos in manus hostium suorum, et ceciderint in gladio universi."
,"24":"Iuxta immunditiam eorum et scelera eorum feci eis et abscondi faciem meam ab illis."
,"25":"Propterea haec dicit Dominus Deus: Nunc restituam Iacob et miserebor omnis domus Israel et assumam zelum pro nomine sancto meo."
,"26":"Et portabunt confusionem suam et omnem praevaricationem, quam praevaricati sunt in me, cum habitaverint in terra sua confidenter; et nemo erit qui exterreat."
,"27":"Et reduxero eos de populis et congregavero de terris inimicorum suorum et sanctificatus fuero in eis in oculis gentium plurimarum,"
,"28":"et scient quia ego Dominus Deus eorum, eo quod transtulerim eos in nationes et congregaverim eos super terram suam et non dereliquerim quemquam ex eis ibi."
,"29":"Et non abscondam ultra faciem meam ab eis, eo quod effuderim spiritum meum super domum Israel ', ait Dominus Deus."
}`)
	CurrentBook.AddChapter(40, `{
"1":"In vicesimo et quinto anno transmigrationis nostrae, in exordio anni, decima mensis, quarto decimo anno, postquam percussa est civitas, in ipsa hac die facta est super me manus Domini et adduxit me illuc."
,"2":"In visionibus Dei adduxit me in terram Israel et posuit me super montem excelsum nimis, super quem erat quasi aedificium civitatis ad austrum."
,"3":"Et introduxit me illuc; et ecce vir, cuius erat species quasi species aeris, et funiculus lineus in manu eius, et calamus mensurae in manu eius, stabat autem in porta."
,"4":"Et locutus est ad me idem vir: ' Fili hominis, vide oculis tuis et auribus tuis audi et pone cor tuum in omnia, quae ego ostendam tibi, quia ut ostendantur tibi, adductus es huc; annuntia omnia, quae tu vides, domui Israel '."
,"5":"Et ecce murus forinsecus in circuitu domus undique, et in manu viri calamus mensurae sex cubitorum, qui habebant cubitum et palmum; et mensus est latitudinem aedificii calamo uno, altitudinem quoque calamo uno."
,"6":"Et venit ad portam, quae respiciebat viam orientalem, et ascendit per gradus eius et mensus est limen portae calamo uno latitudinem"
,"7":"et cubiculum uno calamo in longum et uno calamo in latum et inter cubicula quinque cubitos et limen portae iuxta vestibulum portae intrinsecus calamo uno."
,"8":"Et mensus est vestibulum portae"
,"9":"octo cubitorum et postem eius duobus cubitis; vestibulum autem portae erat intrinsecus."
,"10":"Porro cubicula portae ad viam orientalem, tria hinc et tria inde, mensura una trium et mensura una postium ex utraque parte."
,"11":"Et mensus est latitudinem ostii portae decem cubitorum et longitudinem portae tredecim cubitorum,"
,"12":"et saeptum ante cubicula cubiti unius utrimque; cubicula autem sex cubitorum erant hinc et inde."
,"13":"Et mensus est portam a tecto cubiculi usque ad tectum eius a contra, latitudinem viginti et quinque cubitorum, ostium contra ostium, (14) 15 et a facie ingressus portae usque ad faciem vestibuli portae intrinsecus, quinquaginta cubitos. "
,"16":"Et erant fenestrae marginatae in cubiculis et in postibus intra portam undique per circuitum; similiter autem erant et in vestibulo fenestrae per gyrum intrinsecus, et ante postes pictura palmarum."
,"17":"Et eduxit me ad atrium exterius, et ecce exedrae et pavimentum stratum lapide in atrio per circuitum, triginta exedrae in circuitu pavimenti;"
,"18":"et pavimentum ad latus portarum secundum longitudinem portarum; hoc erat pavimentum inferius."
,"19":"Et mensus est latitudinem a facie portae inferioris usque ad frontem portae interioris extrinsecus, centum cubitos. Sic oriens. Et sic aquilo."
,"20":"Portam quoque, quae respiciebat viam aquilonis atrii exterioris, mensus est, tam in longitudine quam in latitudine;"
,"21":"et cubicula eius, tria hinc et tria inde, et postes eius et vestibulum eius secundum mensuram portae prioris; quinquaginta cubitorum longitudo eius et latitudo viginti quinque cubitorum."
,"22":"Et fenestrae vestibuli eius et sculpturae palmarum secundum mensuram portae, quae respiciebat ad orientem; et septem graduum erat ascensus eius, et vestibulum intrinsecus."
,"23":"Et porta atrii interioris contra portam aquilonis sicut in porta orientali; et mensus est a porta usque ad portam centum cubitos."
,"24":"Et duxit me ad viam australem, et ecce porta, quae respiciebat ad austrum; et mensus est postes eius et vestibulum eius iuxta mensuras superiores."
,"25":"Et fenestrae eius et vestibuli in circuitu sicut fenestrae ceterae; quinquaginta cubitorum longitudo erat et latitudo viginti quinque cubitorum."
,"26":"Et in gradibus septem ascendebatur ad eam, et vestibulum erat intrinsecus, et caelatae palmae erant, una hinc et altera inde, in postibus eius."
,"27":"Et porta erat atrio interiori in via australi, et mensus est a porta usque ad portam in via australi centum cubitos."
,"28":"Et introduxit me in atrium interius per portam australem et mensus est portam iuxta mensuras superiores;"
,"29":"cubicula eius et postes eius, et vestibulum eius eisdem mensuris; et fenestrae erant ei et vestibulo eius in circuitu. Quinquaginta cubitorum longitudo erat et latitudo viginti quinque cubitorum. (30) 31 Et vestibulum eius respiciebat ad atrium exterius, et palmae in postibus eius, et octo gradus erant, quibus ascendebatur ad eam."
,"32":"Et introduxit me in atrium interius per viam orientalem et mensus est portam secundum mensuras superiores;"
,"33":"cubicula eius et postes eius et vestibulum eius sicut supra; et fenestrae erant ei et vestibulo eius in circuitu. Longitudo erat quinquaginta cubitorum et latitudo viginti quinque cubitorum."
,"34":"Et vestibulum eius respiciebat ad atrium exterius, et palmae caelatae in postibus eius hinc et inde et in octo gradibus ascensus eius."
,"35":"Et introduxit me ad portam, quae respiciebat ad aquilonem, et mensus est secundum mensuras superiores"
,"36":"cubicula eius et postes eius et vestibulum eius; et fenestrae ei erant per circuitum. Longitudo quinquaginta cubitorum erat et latitudo viginti quinque cubitorum."
,"37":"Et vestibulum eius respiciebat ad atrium exterius, et caelatura palmarum in postibus illius hinc et inde et in octo gradibus ascensus eius."
,"38":"Et erat exedra, cuius ostium in vestibulo portae; ibi lavabunt holocaustum."
,"39":"Et in vestibulo portae duae mensae hinc et duae mensae inde, ut mactetur super eas holocaustum et pro peccato et pro delicto."
,"40":"Et ad latus extra vestibulum ad ostium portae, quae respicit ad aquilonem, duae mensae; et ad la tus alterum vestibuli portae duae mensae."
,"41":"Quattuor mensae hinc et quattuor mensae inde ad latus portae: octo mensae erant, super quas mactabunt."
,"42a":"Quattuor autem mensae ad holocaustum de lapidibus quadris exstructae longitudine cubiti unius et dimidii et latitudine cubiti unius et dimidii et altitudine cubiti unius,"
,"43a":"et labia palmi unius reflexa intrinsecus per circuitum;"
,"42b":"super ista ponant vasa, quibus mactetur holocaustum et victima, 43b super mensas autem carnes oblationis."
,"44":"Et extra portam interiorem exedrae duae, in atrio interiori; una erat in latere portae respicientis ad aquilonem, et facies eius contra viam australem, et una ex latere portae australis, quae respiciebat ad viam aquilonis."
,"45":"Et dixit ad me: ' Haec est exedra, quae respicit viam meridianam; sacerdotum erit, qui excubant in custodiis templi."
,"46":"Porro exedra, quae respicit ad viam aquilonis, sacerdotum erit, qui excubant ad ministerium altaris: isti sunt filii Sadoc, qui accedunt de filiis Levi ad Dominum, ut ministrent ei '."
,"47":"Et mensus est atrium longitudine centum cubitorum et latitudine centum cubitorum per quadrum. Altare autem erat ante faciem templi."
,"48":"Et introduxit me in vestibulum templi; et mensus est postes vestibuli quinque cubitis hinc et quinque cubitis inde et latitudinem portae quattuordecim cubitorum et latera portae trium cubitorum hinc et trium cubitorum inde;"
,"49":"longitudinem autem vestibuli viginti cubitorum et latitudinem duodecim cubitorum, et decem gradibus ascendebatur ad illud, et columnae erant in postibus, una hinc et altera inde."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Et introduxit me in templum et mensus est postes: sex cu bitos latitudinis hinc et sex cubitos latitudinis inde."
,"2":"Et latitudo portae decem cubitorum erat, et latera portae quinque cubitis hinc et quinque cubitis inde; et mensus est longitudinem eius quadraginta cubitorum et latitudinem viginti cubitorum."
,"3":"Et introgressus intrinsecus, mensus est in poste portae duos cubitos et portam sex cubitorum et latitudinem laterum portae septem cubitorum hinc et septem cubitorum inde."
,"4":"Et mensus est longitudinem eius viginti cubitorum et latitudinem viginti cubitorum versus faciem templi. Et dixit ad me: ' Hoc est Sanctum sanctorum '."
,"5":"Et mensus est parietem domus sex cubitorum et latitudinem aedificii adiacentis quattuor cubitorum undique per circuitum domus;"
,"6":"cubicula autem adiacentia, cubiculum super cubiculum, in tribus tabulatis. Et erant margines eminentes in pariete domus pro cubiculis adiacentibus per circuitum, ut essent fulcra, neque essent fulcra intra parietem domus,"
,"7":"et latitudo ambitus sursum ascendens iuxta cubicula adiacentia, quia circumdata erat domus usque sursum circa domum; idcirco amplificata erat domus usque sursum, et de inferiore tabulato ascendebatur ad superius per medium."
,"8":"Et vidi in domo altitudinem per circuitum, fundamenta aedificii adiacentis mensura calami pleni, id est sex cubitorum, in altitudine."
,"9":"Et latitudo parietis aedificii adiacentis forinsecus erat quinque cubitorum. Et area vacua inter cubicula domui adiacentia,"
,"10":"et inter exedras habebat latitudinem viginti cubitorum in circuitu domus undique."
,"11":"Et ostia aedificii adiacentis ad aream vacuam, ostium unum ad viam aquilonis et ostium unum ad viam australem; et latitudo muri areae vacuae quinque cubitorum in circuitu."
,"12":"Et aedificium, quod erat ex adverso areae separatae versumque ad viam respicientem ad mare, latitudinis septuaginta cubitorum; paries autem aedificii quinque cubitorum latitudinis per circuitum et longitudo eius nonaginta cubitorum."
,"13":"Et mensus est domus longitudinem centum cubitorum et areae separatae et aedificii et parietum eius longitudinem centum cubitorum;"
,"14":"latitudinem autem faciei domus et areae separatae contra orientem centum cubitorum."
,"15":"Et mensus est longitudinem aedificii ex adverso areae separatae ad dorsum et parietum eius ex utraque parte centum cubitorum. Et templum interius et vestibulum exterius"
,"16":"strata erant ligno, et fenestrae marginatae et margines in circuitu triplices contra limen erant strato ligno per gyrum in circuitu, et a terra usque ad fenestras - et fenestrae poterant claudi - usque ad superiora ostii;"
,"17":"et usque ad domum interiorem et forinsecus et per omnem parietem in circuitu, intrinsecus et forinsecus, ad mensuram"
,"18":"fabrefacti cherubim et palmae, et palma inter cherub et cherub; duasque facies habebat cherub,"
,"19":"faciem hominis versam ad palmam ex hac parte et faciem leonis versam ad palmam ex alia parte: expressi per omnem domum in circuitu."
,"20":"De terra usque ad superiora portae cherubim et palmae caelatae erant. In pariete templi"
,"21":"postes portae quadruplices, et coram sanctuario aspectus quasi aspectus"
,"22":"altaris lignei trium cubitorum altitudo, et longitudo eius duorum cubitorum, et anguli eius et bases eius et parietes eius lignei. Et locutus est ad me: ' Haec est mensa coram Domino '."
,"23":"Et duo ostia erant templo et sanctuario"
,"24":"duo ostia. Ostiis erant duae valvae versatiles usque ad parietem, valvae duae ostio uni et valvae duae ostio alteri."
,"25":"Et caelati erant in ipsis ostiis templi cherubim et sculpturae palmarum, sicut in parietibus quoque expressi erant; et tectum ligneum erat in vestibuli fronte forinsecus."
,"26":"Et fenestrae marginatae et similitudo palmarum hinc atque inde in lateribus vestibuli et in cubiculis adiacentibus domus."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Et eduxit me in atrium ex terius per viam ducentem ad aquilonem; et duxit me ad exedram, quae erat contra aream separatam, et contra aedem ad aquilonem."
,"2":"Longitudo erat centum cubitorum in latere aquilonis et latitudo quinquaginta cubitorum."
,"3":"Contra viginti cubitos atrii interioris et contra pavimentum stratum lapide atrii exterioris elevabatur pars iuxta partem in tribus gradibus."
,"4":"Et ante exedras deambulatio decem cubitorum latitudinis, ad interiora respiciens, longitudinis centum cubitorum; et ostia eorum ad aquilonem."
,"5":"Exedrae superiores angustiores erant, quia gradus auferebant eis spatium, prae inferioribus et mediis aedificii."
,"6":"Tristega enim erant et non habebant columnas, sicut erant columnae exteriorum; sic ergo in gradibus de inferioribus, et de mediis a terra surgebat aedificium."
,"7":"Et murus exterior secundum exedras erat in via atrii exterioris ante exedras, longitudo eius quinquaginta cubitorum,"
,"8":"quia longitudo erat exedrarum atrii exterioris quinquaginta cubitorum, quae erant ante faciem illarum, totum erat centum cubitorum."
,"9":"Et erat subter exedras has introitus ab oriente ingredientibus in ea de atrio exteriori"
,"10":"in capite muri atrii. Contra viam meridianam in facie areae separatae, et erant exedrae ante aedificium,"
,"11":"et via ante faciem earum iuxta similitudinem exedrarum, quae erant in via aquilonis; secundum longitudinem earum et latitudinem earum, sic et omnes exitus earum et dispositiones et ostia earum."
,"12":"Et ad ostia exedrarum, quae erant in via respiciente ad notum, ostium in capite viae, quae via erat ante murum protegentem per viam orientalem ingredientibus."
,"13":"Et dixit ad me: 'Exedrae aquilonis et exedrae austri, quae sunt ante aream separatam, hae sunt exedrae sanctae, in quibus vescuntur sacerdotes, qui appropinquant ad Dominum sancta sanctorum: ibi ponent sancta sanctorum et oblationem et pro peccato et pro delicto, locus enim sanctus est."
,"14":"Cum autem ingressi fuerint sacerdotes, non egredientur de sanctis in atrium exterius, sed ibi reponent vestimenta sua, in quibus ministrant, quia sancta sunt; vestienturque vestimentis aliis et sic procedent ad locum populi '."
,"15":"Cumque complesset mensuras interioris areae domus, eduxit me per viam portae, quae respiciebat ad viam orientalem, et mensus est ibi undique per circuitum."
,"16":"Mensus est autem contra ventum orientalem calamo mensurae quingentos calamos in calamo mensurae per circuitum."
,"17":"Et mensus est contra ventum aquilonis quingentos calamos in calamo mensurae per gyrum."
,"18":"Et ad ventum australem mensus est quingentos calamos in calamo mensurae per circuitum."
,"19":"Et conversus ad ventum occidentalem mensus est quingentos calamos in calamo mensurae."
,"20":"Per quattuor ventos mensus est illud; murus ei erat undique per circuitum longitudine quingentorum cubitorum et latitudine quingentorum cubitorum, dividens inter sanctuarium et locum profanum."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Et duxit me ad portam, quae respiciebat ad viam orientalem,"
,"2":"et ecce gloria Dei Israel ingrediebatur per viam orientalem, et vox erat ei quasi vox aquarum multarum, et terra splendebat a maiestate eius."
,"3":"Et vidi visionem secundum speciem, quam videram, quando venit, ut disperderet civitatem, et species secundum aspectum, quem videram iuxta fluvium Chobar; et cecidi super faciem meam."
,"4":"Et maiestas Domini ingressa est templum per viam portae, quae respiciebat ad orientem."
,"5":"Et levavit me spiritus et introduxit me in atrium interius; et ecce repleta erat gloria Domini domus."
,"6":"Et audivi loquentem ad me de domo, cum vir staret iuxta me,"
,"7":"et dixit ad me: ' Fili hominis, locus solii mei et locus vestigiorum pedum meorum, ubi habitabo in medio filiorum Israel in aeternum; et non polluent ultra domus Israel nomen sanctum meum, ipsi et reges eorum, in fornicationibus suis et in cadaveribus regum suorum in morte eorum,"
,"8":"qui fabricati sunt limen suum iuxta limen meum et postes suos iuxta postes meos, et paries erat inter me et eos, et polluerunt nomen sanctum meum in abominationibus, quas fecerunt; propter quod consumpsi eos in ira mea."
,"9":"Nunc ergo repellant procul fornicationem suam et cadavera regum suorum a me, et habitabo in medio eorum semper."
,"10":"Tu autem, fili hominis, ostende domui Israel templum, et confundantur ab iniquitatibus suis et metiantur fabricam."
,"11":"Et si erubuerint ex omnibus, quae fecerunt, describe domum et supellectilem eius, exitus et introitus, et omnem figuram eius et universa praecepta eius et omnes leges eius ostende eis et scribes oculis eorum, ut custodiant omnem figuram eius et omnia praecepta illius et faciant ea."
,"12":"Ista est lex domus in summitate montis: omnes fines eius in circuitu sanctum sanctorum sunt; haec est ergo lex domus '."
,"13":"Istae autem mensurae altaris in cubitis, cubitus habebat cubitum et palmum; fossae in circuitu eius erat cubitus in altitudine et cubitus in latitudine; et saepto eius ad marginem eius in circuitu palmus unus. Haec autem erat altitudo altaris:"
,"14":"de fossa terrae usque ad crepidinem inferiorem duo cubiti, et latitudo cubiti unius; et a crepidine minore usque ad crepidinem maiorem quattuor cubiti, et latitudo unius cubiti."
,"15":"Ipse autem focus quattuor cubitorum, et a foco usque sursum cornua quattuor."
,"16":"Et focus duodecim cubitorum in longitudine per duodecim cubitos latitudinis, quadrangulatum aequis lateribus."
,"17":"Et crepido quattuordecim cubitorum longitudinis per quattuordecim cubitos latitudinis in quattuor angulis eius; et saeptum in circuitu eius dimidii cubiti, et fossa eius unius cubiti per circuitum; gradus autem eius versi ad orientem."
,"18":"Et dixit ad me: ' Fili hominis, haec dicit Dominus Deus: Hi sunt ritus altaris: in qua die fuerit fabricatum, ut offeratur super illud holocaustum, et effundatur sanguis,"
,"19":"dabis sacerdotibus levitis, qui sunt de semine Sadoc, qui accedunt ad me, ait Dominus Deus, ut ministrent mihi, vitulum de armento pro peccato."
,"20":"Et assumens de sanguine eius, pones super quattuor cornua eius et super quattuor angulos crepidinis et super saeptum in circuitu et mundabis illud et expiabis."
,"21":"Et tolles vitulum, qui oblatus fuerit pro peccato, et combures illum in destinato loco domus extra sanctuarium."
,"22":"Et in die secunda offeres hircum caprarum immaculatum pro peccato, et expiabunt altare, sicut expiaverunt in vitulo."
,"23":"Cumque compleveris expians illud, offeres vitulum de armento immaculatum et arietem de grege immaculatum;"
,"24":"et offeres eos in conspectu Domini, et mittent sacerdotes super eos sal et offerent eos holocaustum Domino."
,"25":"Septem diebus facies hircum pro peccato cotidie, et vitulum de armento et arietem de pecoribus immaculatos offerent."
,"26":"Septem diebus expiabunt altare et mundabunt illud et consecrabunt illud."
,"27":"Expletis autem diebus, in die octava et ultra facient sacerdotes super altare holocausta vestra et pacifica, et placatus ero vobis ', ait Dominus Deus."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Et convertit me ad viam portae sanctuarii exterioris, quae respiciebat ad orientem, et erat clausa;"
,"2":"et dixit Dominus ad me: ' Porta haec clausa erit; non aperietur, et vir non transibit per eam, quoniam Dominus, Deus Israel, ingressus est per eam, eritque clausa."
,"3":"Princeps, ut princeps ipse sedebit in ea, ut comedat panem coram Domino; per viam vestibuli portae ingredietur et per eandem viam egredietur '."
,"4":"Et adduxit me per viam portae aquilonis in conspectum domus; et vidi: et ecce implevit gloria Domini domum Domini, et cecidi in faciem meam."
,"5":"Et dixit ad me Dominus: ' Fili hominis, pone cor tuum et vide oculis tuis et auribus tuis audi omnia, quae ego loquor ad te de universis caeremoniis domus Domini et de cunctis legibus eius; et pones cor tuum in introitu templi et in omni exitu sanctuarii"
,"6":"et dices ad exasperantem me domum Israel: Haec dicit Dominus Deus: Sufficiant vobis omnes abominationes vestrae, domus Israel,"
,"7":"eo quod induxistis alienigenas incircumcisos corde et incircumcisos carne, ut essent in sanctuario meo et polluerent domum meam, cum offertis panem meum, adipem et sanguinem; et dissolvistis pactum meum in omnibus abominationibus vestris"
,"8":"et non explevistis ministerium sanctorum meorum et posuistis illos ministrantes mihi in sanctuario meo. Propterea"
,"9":"haec dicit Dominus Deus: Omnis alienigena incircumcisus corde et incircumcisus carne non ingredietur sanctuarium meum, omnis alienigena, qui est in medio filiorum Israel."
,"10":"Sed Levitae, qui longe recesserint a me in errore filiorum Israel, qui erraverunt a me post idola sua, portabunt iniquitatem suam"
,"11":"et erunt in sanctuario meo aeditui et ianitores portarum domus et ministri domus: ipsi mactabunt holocausta et victimas populo et ipsi stabunt in conspectu eorum, ut ministrent eis."
,"12":"Pro eo quod ministraverunt illis in conspectu idolorum suorum et facti sunt domui Israel in offendiculum iniquitatis, idcirco levavi manum meam super eos, dicit Dominus Deus; portabunt iniquitatem suam."
,"13":"Et non appropinquabunt ad me, ut sacerdotio fungantur mihi, neque accedent ad omnia sancta mea, ad sanctissima, sed portabunt confusionem suam et abominationes suas, quas fecerunt."
,"14":"Et faciam eos ministros in omni ministerio domus et in universis, quae facienda sunt in ea."
,"15":"Sacerdotes autem levitae filii Sadoc, qui custodierunt caeremonias sanctuarii mei, cum errarent filii Israel a me, ipsi accedent ad me, ut ministrent mihi, et stabunt in conspectu meo, ut offerant mihi adipem et sanguinem, ait Dominus Deus."
,"16":"Ipsi ingredientur sanctuarium meum et ipsi accedent ad mensam meam, ut serviant mihi et custodiant ministerium meum."
,"17":"Cumque ingredientur portas atrii interioris, vestibus lineis induentur, nec ascendet super eos quidquam laneum, quando ministrant in portis atrii interioris et in domo."
,"18":"Vittae lineae erunt in capitibus eorum, et feminalia linea erunt in lumbis eorum, et non accingentur in sudore."
,"19":"Cumque egredientur atrium exterius ad populum, exuent se vestimenta sua, in quibus ministraverunt, et reponent ea in exedris sanctis et vestient se vestimentis aliis et non sanctificabunt populum in vestibus suis."
,"20":"Caput autem suum non radent neque comam nutrient, sed tondentes attondent capita sua."
,"21":"Et vinum non bibet omnis sacerdos, quando ingressurus est atrium interius."
,"22":"Et viduam et repudiatam non accipient sibi uxores sed virgines de semine domus Israel; sed et viduam, quae fuerit vidua a sacerdote, accipient."
,"23":"Et populum meum docebunt quid sit inter sanctum et profanum et inter mundum et immundum ostendent eis."
,"24":"Et cum fuerit controversia, stabunt ad iudicandum et in iudiciis meis iudicabunt; leges meas et praecepta mea in omnibus sollemnitatibus meis custodient et sabbata mea sanctificabunt."
,"25":"Et ad mortuum hominem non ingredientur, ne polluantur, nisi ad patrem et matrem et filium et filiam et fratrem et sororem, quae virum non habuit: in quibus contaminabuntur."
,"26":"Et postquam fuerit emundatus, septem dies numerabuntur ei,"
,"27":"et in die introitus sui in sanctuarium ad atrium interius, ut ministret mihi in sanctuario, offeret pro peccato suo, ait Dominus Deus."
,"28":"Et erit eis in hereditatem: ego hereditas eorum; et possessionem non dabitis eis in Israel: ego enim possessio eorum."
,"29":"Oblationem et pro peccato et pro delicto ipsi comedent, et omne anathema in Israel ipsorum erit;"
,"30":"et primitiva omnium primogenitorum et omnia libamenta ex omnibus, quae offertis, sacerdotum erunt; et primitiva farinae vestrae dabitis sacerdoti, ut reponat benedictionem domui tuae."
,"31":"Omne morticinum et captum a bestia de avibus et de pecoribus non comedent sacerdotes."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Cumque coeperitis terram dividere sortito, separate oblationem Domino sanctificatum de terra, longitudine viginti quinque milia et latitudine viginti milia: sanctificatum erit in omni termino suo per circuitum;"
,"2":"ex quo sanctuarium obtinebit quingentos per quingentos, quadrifariam per circuitum, et quinquaginta cubitos pascua eius per gyrum."
,"3":"Et a mensura ista mensurabis longitudinem viginti quinque milium et latitudinem decem milium, et in ipso erit templum, Sanctum sanctorum."
,"4":"Sanctificatum de terra erit sacerdotibus ministris sanctuarii, qui accedunt ad ministerium Domini; et erit eis locus in domos et in pascua pecoribus."
,"5":"Viginti quinque autem milia longitudinis et decem milia latitudinis erunt Levitis, qui ministrant domui; ipsis in possessionem, civitates ad habitandum."
,"6":"Et possessionem civitatis dabitis quinque milia latitudinis et longitudinis viginti quinque milia, iuxta oblationem sacram; omni domui Israel erit."
,"7":"Principi quoque ex utraque parte oblationis sacrae et possessionis civitatis, secundum oblationem sacram et possessionem urbis, a latere maris usque ad mare et a latere orientis versus orientem, longitudinem autem iuxta unamquamque partium, a termino occidentali usque ad terminum orientalem."
,"8":"Haec terra erit ei possessio in Israel, et non depopulabuntur ultra principes mei populum meum; sed terram dabunt domui Israel secundum tribus eorum."
,"9":"Haec dicit Dominus Deus: Sufficiat vobis, principes Israel; violentiam et rapinas omittite et iudicium et iustitiam facite; auferte exactiones vestras a populo meo, ait Dominus Deus."
,"10":"Statera iusta et ephi iustum et batus iustus sit vobis;"
,"11":"ephi et batus aequalia et unius mensurae sint, ut capiat decimam partem homer batus, et decimam partem homer ephi: iuxta mensuram homer sit aequa libratio eorum."
,"12":"Siclus autem viginti gera habeat; quinque sicli sint quinque, et decem sicli sint decem, et quinquaginta sint vobis mina."
,"13":"Haec est oblatio, quam offeratis: sextam partem ephi de gomor frumenti et sextam partem ephi de gomor hordei."
,"14":"Praeceptum quoque de oleo - batus est mensura olei C: decimam partem bati offeratis de choro - decem bati homer faciunt, quia decem bati implent chorum C."
,"15":"Et pecus unum de grege ducentorum, de pascuis irriguis Israel, in oblationem et in holocaustum et in pacifica ad expiandum pro eis, ait Dominus Deus."
,"16":"Omnis populus terrae tenebitur ad hanc oblationem principi in Israel;"
,"17":"et super principem erunt holocausta et oblationes et libamina in diebus festis et in calendis et in sabbatis et in universis sollemnitatibus domus Israel; ipse faciet pro peccato et oblationem et holocaustum et pacifica ad expiandum pro domo Israel."
,"18":"Haec dicit Dominus Deus: In primo mense, una mensis, sumes vitulum de armento immaculatum et expiabis sanctuarium."
,"19":"Et tollet sacerdos de sanguine hostiae pro peccato et ponet in postibus domus et in quattuor angulis crepidinis altaris et in postibus portae atrii interioris."
,"20":"Et sic facies in septima mensis pro unoquoque, qui ignoravit et errore deceptus est, et expiabitis pro domo."
,"21":"In primo mense, quarta decima die mensis, erit vobis Paschae sollemnitas; septem diebus azyma comedentur."
,"22":"Et faciet princeps in die illa pro se et pro universo populo terrae vitulum pro peccato;"
,"23":"et in septem dierum sollemnitate faciet holocaustum Domino septem vitulos et septem arietes immaculatos cotidie septem diebus et pro peccato hircum caprarum cotidie;"
,"24":"et oblationem ephi per vitulum et ephi per arietem faciet et olei hin per singula ephi."
,"25":"Septimo mense, quinta decima die mensis, in sollemnitate faciet, sicut supra dicta sunt, per septem dies, tam pro peccato quam pro holocausto et in oblatione et in oleo."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Haec dixit Dominus Deus: Porta atrii interioris, quae respicit ad orientem, erit clausa sex diebus, in quibus opus fit; die autem sabbati aperietur, sed et in die calendarum aperietur,"
,"2":"et intrabit princeps per viam vestibuli portae deforis et stabit in poste portae, et facient sacerdotes holocaustum eius et pacifica eius, et adorabit super limen portae et egredietur; porta autem non claudetur usque ad vesperam."
,"3":"Et adorabit populus terrae ad ostium portae illius in sabbatis et in calendis coram Domino."
,"4":"Holocaustum autem hoc offeret princeps Domino: in die sabbati sex agnos immaculatos et arietem immaculatum"
,"5":"et oblationem ephi per arietem, per agnos autem oblationem, quantum dederit manus eius, et olei hin per singula ephi;"
,"6":"in die autem calendarum vitulum de armento immaculatum et sex agni et aries immaculati erunt"
,"7":"et ephi per vitulum, ephi quoque per arietem faciet oblationem, per agnos autem sicut invenerit manus eius, et olei hin per singula ephi."
,"8":"Cumque ingressurus est princeps, per viam vestibuli portae ingrediatur et per eandem viam exeat."
,"9":"Et cum intrabit populus terrae in conspectu Domini in sollemnitatibus, qui ingreditur per portam aquilonis, ut adoret, egrediatur per viam portae meridianae; porro qui ingreditur per viam portae meridianae, egrediatur per viam portae aquilonis: non revertetur per viam portae, per quam ingressus est, sed e regione illius egredietur."
,"10":"Princeps autem in medio eorum cum ingredientibus ingredietur et cum egredientibus egredietur."
,"11":"Et in diebus festis et in sollemnitatibus erit oblatio ephi per vitulum et ephi per arietem, per agnos autem erit oblatio, quantum invenerit manus eius, et olei hin per singula ephi."
,"12":"Cum autem fecerit princeps spontaneum holocaustum aut pacifica voluntaria Domino, aperietur ei porta, quae respicit ad orientem, et faciet holocaustum suum et pacifica sua, sicut facere solet in die sabbati, et egredietur, claudeturque porta, postquam exierit."
,"13":"Et agnum anniculum immaculatum facies holocaustum cotidie Domino; semper mane facies illud."
,"14":"Et oblationem facies super eo mane mane sextam partem ephi, et de oleo tertiam partem hin, ut conspergatur simila; oblatio Domino, legitimum iuge atque perpetuum."
,"15":"Facient agnum et oblationem et oleum mane mane, holocaustum sempiternum."
,"16":"Haec dixit Dominus Deus: Si dederit princeps donum alicui de filiis suis de hereditate sua, filiorum suorum erit; possidebunt illud hereditarie."
,"17":"Si autem dederit legatum de hereditate sua uni servorum suorum, erit illius usque ad annum remissionis et revertetur ad principem; sola hereditas filiorum eius illorum erit."
,"18":"Et non accipiet princeps de hereditate populi, ut expellat eos de possessione eorum, sed de possessione sua hereditatem dabit filiis suis, ut non dispergatur populus meus unusquisque a possessione sua '."
,"19":"Et introduxit me per ingressum, qui erat ex latere portae, in exedras sacras sacerdotum, quae respiciebant ad aquilonem, et erat ibi locus in extrema parte vergens ad occidentem;"
,"20":"et dixit ad me: ' Iste est locus, ubi coquent sacerdotes pro delicto et pro peccato, ubi coquent oblationem, ut non efferant in atrium exterius, et sanctificetur populus '."
,"21":"Et eduxit me in atrium exterius et circumduxit me per quattuor angulos atrii, et ecce atriola singula per angulos atrii."
,"22":"In quattuor angulis atrii atriola inclusa quadraginta cubitorum per longum et triginta per latum: mensurae unius quattuor erant."
,"23":"Et paries per circuitum ambiens quattuor atriola, et culinae fabricatae erant subter parietes per gyrum."
,"24":"Et dixit ad me: 'Hae sunt domus culinarum, in quibus coquent ministri domus Domini victimas populi '."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Et convertit me ad portam domus, et ecce aquae egre diebantur subter limen domus ad orientem; facies enim domus respiciebat ad orientem, aquae autem descendebant a latere templi dextro a meridie altaris."
,"2":"Et eduxit me per viam portae aquilonis et convertit me ad viam foras ad portam exteriorem, quae respiciebat ad orientem; et ecce aquae exeuntes a latere dextro."
,"3":"Cum egrederetur vir ad orientem, qui habebat funiculum in manu sua, mensus est mille cubitos et traduxit me per aquam usque ad talos."
,"4":"Rursumque mensus est mille et traduxit me per aquam usque ad genua."
,"5":"Et mensus est mille et traduxit me per aquam usque ad renes. Et mensus est mille; torrens, quem non potui pertransire, quoniam intumuerant aquae, aquae ad natandum; torrens, qui non poterat transvadari."
,"6":"Et dixit ad me: ' Certe vidisti, fili hominis '; et duxit me et convertit ad ripam torrentis."
,"7":"Cumque me convertissem, ecce in ripa torrentis ligna multa nimis ex utraque parte;"
,"8":"et ait ad me: ' Aquae istae, quae egrediuntur ad regionem orientalem et descendunt ad Arabam, intrabunt mare, aquas salsas, et sanabuntur aquae:"
,"9":"et omnis anima vivens, quae movetur, quocumque venerit torrens, vivet, et erunt pisces multi satis, postquam venerint illuc aquae istae, et sanabuntur et vivent omnia, ad quae venerit torrens."
,"10":"Et stabunt super mare piscatores; ab Engaddi usque ad Engallim siccatio sagenarum erit; plurimae species erunt piscium eius, sicut pisces maris Magni, multitudinis nimiae."
,"11":"Palustria autem eius et stagna non sanabuntur, quia in salinas dabuntur."
,"12":"Et super torrentem orietur in ripis eius ex utraque parte omne lignum pomiferum; non defluet folium ex eo, et non deficiet fructus eius: per singulos menses afferet primitiva, quia aquae eius de sanctuario egredientur, et erunt fructus eius in cibum, et folia eius ad medicinam."
,"13":"Haec dicit Dominus Deus: Hic est terminus, in quo possidebitis terram in duodecim tribubus Israel, quia Ioseph duplicem funiculum habet;"
,"14":"possidebitis autem eam, singuli aeque ut frater suus, super quam levavi manum meam, ut darem patribus vestris; et cadet terra haec vobis in possessionem."
,"15":"Hic est autem terminus terrae: ad plagam septentrionalem a mari Magno via Hethalon ad introitum Emath,"
,"16":"Sedada, Berotha, Sabarim, quae est inter terminum Damasci et confinium Emath, usque ad Asarenon, quae est iuxta terminum Auran;"
,"17":"erit ergo terminus a mari usque ad Asarenon, cum fines Damasci et fines Emath sint in aquilone; haec est plaga septentrionalis."
,"18":"Porro plaga orientalis de loco inter Auran et inter Damascum et in medio inter Galaad et terram Israel, Iordanis disterminans usque ad mare orientale, usque Thamar; haec est plaga orientalis."
,"19":"Plaga autem australis meridiana a Thamar usque ad aquas Meribathcades et torrentem usque ad mare Magnum; haec est plaga ad meridiem australis."
,"20":"Et plaga maris, mare Magnum a confinio per directum, donec venias Emath; haec est plaga maris."
,"21":"Et dividetis terram istam vobis per tribus Israel"
,"22":"et mittetis eam in hereditatem, vobis et advenis, qui accesserint ad vos, qui genuerint filios in medio vestrum, et erunt vobis sicut indigenae inter filios Israel: vobiscum divident possessionem in medio tribuum Israel;"
,"23":"in tribu autem quacumque fuerit advena, ibi dabitis possessionem illi, ait Dominus Deus."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Et haec nomina tribuum: in finibus aquilonis iuxta viam Hethalon ad introitum Emath, Asarenon - fines Damasci ad aquilonem iuxta Emath - erit a plaga orientali usque ad mare, Dan pars una."
,"2":"Et iuxta terminum Dan a plaga orientali usque ad plagam maris, Aser una."
,"3":"Et iuxta terminum Aser a plaga orientali usque ad plagam maris, Nephthali una."
,"4":"Et iuxta terminum Nephthali a plaga orientali usque ad plagam maris, Manasse una."
,"5":"Et iuxta terminum Manasse a plaga orientali usque ad plagam maris, Ephraim una."
,"6":"Et iuxta terminum Ephraim a plaga orientali usque ad plagam maris, Ruben una."
,"7":"Et iuxta terminum Ruben a plaga orientali usque ad plagam maris, Iudae una."
,"8":"Et iuxta terminum Iudae a plaga orientali usque ad plagam maris oblatio, quam separabitis viginti quinque milibus latitudinis et longitudinis, sicuti singulae partes a plaga orientali usque ad plagam maris; et erit sanctuarium in medio eius."
,"9":"Oblatio, quam separabitis Domino, longitudo viginti quinque milibus et latitudo viginti milibus."
,"10":"His autem est oblatio sacra: sacerdotibus, ad aquilonem viginti quinque milia et ad mare latitudinis decem milia et ad orientem latitudinis decem milia et ad meridiem longitudinis viginti quinque milia; et erit sanctuarium Domini in medio eius."
,"11":"Sacerdotibus consecratis erit, filiis Sadoc, qui custodierunt caeremonias meas et non erraverunt, cum errarent filii Israel, sicut erraverunt Levitae."
,"12":"Et erit eis oblatio de oblatione terrae sanctum sanctorum iuxta terminum Levitarum;"
,"13":"sed et Levitis similiter secundum fines sacerdotum, viginti quinque milia longitudinis et latitudinis decem milia, totum in longitudine viginti et quinque milia et in latitudine viginti milia;"
,"14":"et non venumdabunt ex eo neque mutabunt, neque transferetur oblatio terrae, quia sanctificata est Domino."
,"15":"Quinque milia autem, quae supersunt in latitudine per viginti quinque milia, profana erunt urbi in habitaculum et in pascua, et erit civitas in medio eius."
,"16":"Et hae mensurae eius: ad plagam septentrionalem quingenti et quattuor milia et ad plagam meridianam quingenti et quattuor milia et ad plagam orientalem quingenti et quattuor milia et ad plagam occidentalem quingenti et quattuor milia."
,"17":"Erunt autem pascua civitatis ad aquilonem ducenti quinquaginta et ad meridiem ducenti quinquaginta et ad orientem ducenti quinquaginta et ad mare ducenti quinquaginta."
,"18":"Quod autem reliquum fuerit in longitudine iuxta oblationem sacram, decem milia ad orientem et decem milia ad occidentem, erunt iuxta oblationem sacram, et erunt fruges eius in panem his, qui serviunt civitati."
,"19":"Servientes autem civitati operabuntur ex omnibus tribubus Israel."
,"20":"Tota oblatio viginti quinque milium, per viginti quinque milia: in quadrum; separabitis oblationem sacram una cum possessione civitatis."
,"21":"Quod autem reliquum fuerit, principis erit, ex utraque parte oblationis sacrae et possessionis civitatis, e regione viginti quinque milium oblationis usque ad terminum orientalem, sed et ad mare e regione viginti quinque milium usque ad terminum maris secundum partes tribuum, principis erit. Et erit oblatio sacra et sanctuarium templi in medio eius,"
,"22":"segregata a possessione Levitarum et a possessione civitatis in medio partium principis: inter terminum Iudae et inter terminum Beniamin erit possessio principis."
,"23":"Et reliquis tribubus: a plaga orientali usque ad plagam occidentalem, Beniamin una."
,"24":"Et iuxta terminum Beniamin a plaga orientali usque ad plagam occidentalem, Simeon una."
,"25":"Et iuxta terminum Simeonis a plaga orientali usque ad plagam occidentalem, Issachar una."
,"26":"Et iuxta terminum Issachar a plaga orientali usque ad plagam occidentalem, Zabulon una."
,"27":"Et iuxta terminum Zabulon a plaga orientali usque ad plagam maris, Gad una."
,"28":"Et iuxta terminum Gad ad plagam austri in meridiem, erit finis de Thamar usque ad aquas Meribathcades, ad torrentem usque ad mare Magnum."
,"29":"Haec est terra, quam mittetis in sortem tribubus Israel, et hae partitiones earum, ait Dominus Deus."
,"30":"Et hi egressus civitatis: a plaga septentrionali, cuius mensura quingenti et quattuor milia,"
,"31":"portae civitatis in nominibus tribuum Israel: portae tres a septentrione, porta Ruben una, porta Iudae una, porta Levi una."
,"32":"Et ad plagam orientalem quingentorum et quattuor milium, portae tres: porta Ioseph una, porta Beniamin una, porta Dan una."
,"33":"Et ad plagam meridianam, cuius mensura quingenti et quattuor milia, portae tres: porta Simeonis una, porta Issachar una, porta Zabulon una."
,"34":"Et ad plagam occidentalem quingentorum et quattuor milium, portae tres: porta Gad una, porta Aser una, porta Nephthali una."
,"35":"Per circuitum decem et octo milia, et nomen civitatis ex illa die: Dominus ibidem '."
}`)

}
func LA_NVBSE_LoadVMIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Verba Ieremiae filii Helciae de sacerdotibus, qui fuerunt in Anathoth in terra Beniamin."
,"2":"Quod factum est verbum Domini ad eum in diebus Iosiae filii Amon regis Iudae, in tertio decimo anno regni eius."
,"3":"Et factum est in diebus Ioachim filii Iosiae regis Iudae, usque ad consummationem undecimi anni Sedeciae filii Iosiae regis Iudae, usque ad transmigrationem Ierusalem in mense quinto."
,"4":"Et factum est verbum Domini ad me dicens:"
,"5":"' Priusquam te formarem in utero, novi te,et, antequam exires de vulva, sanctificavi te,et prophetam gentibus dedi te '."
,"6":"Et dixi: ' Heu, Domine Deus! Ecce nescio loqui, quia puer ego sum '."
,"7":"Et dixit Dominus ad me: ' Noli dicere: 'Puer sum', quoniam, ad quoscumque mittam te, ibis,et universa, quaecumque mandavero tibi, loqueris."
,"8":"Ne timeas a facie eorum, quia tecum ego sum, ut eruam te ', dicit Dominus."
,"9":"Et misit Dominus manum suam et tetigit os meum; et dixit Dominus ad me: ' Ecce dedi verba mea in ore tuo;"
,"10":"ecce constitui te hodie super gentes et super regna, ut evellas et destruas,et disperdas et dissipes,et aedifices et plantes '."
,"11":"Et factum est verbum Domini ad me dicens: ' Quid tu vides, Ieremia? '. Et dixi: ' Virgam amygdali vigilantis ego video '."
,"12":"Et dixit Dominus ad me: 'Bene vidisti, quia vigilo ego super verbo meo, ut faciam illud '."
,"13":"Et factum est verbum Domini secundo ad me dicens: ' Quid tu vides? '. Et dixi: ' Ollam succensam ego video; et facies eius a facie aquilonis '."
,"14":"Et dixit Dominus ad me: ' Ab aquilone pandetur malum,super omnes habitatores terrae;"
,"15":"quia ecce ego convocabo,omnia regna aquilonis, ait Dominus, et venient et ponent unusquisque solium suum,in introitu portarum Ierusalem,et contra omnes muros eius in circuitu,et contra universas urbes Iudae;"
,"16":"et loquar iudicia mea cum eis,super omnem malitiam eorum, qui dereliquerunt me,et incensum obtulerunt diis alienis,et adoraverunt opus manuum suarum."
,"17":"Tu ergo accinge lumbos tuos,et surge et loquere ad eos omnia, quae ego praecipio tibi; ne timeas a facie eorum, alioquin timere te faciam vultum eorum."
,"18":"Ego quippe dedi te hodie,in civitatem munitam,et in columnam ferream,et in murum aereum,contra omnem terram,regibus Iudae, principibus eius,et sacerdotibus et populo terrae;"
,"19":"et bellabunt adversum te et non praevalebunt, quia tecum ego sum, ait Dominus, ut eripiam te '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et factum est verbum Domini ad me dicens:"
,"2":"' Vade et clama in auribus Ierusalem dicens: Haec dicit Dominus: Recordatus sum tui, caritatis adulescentiae tuae,et amoris desponsationis tuae, quando secuta es me in deserto, in terra, quae non seminatur."
,"3":"Sanctus Domino Israel, primitiae frugum eius; omnes, qui devorabant eum, delinquebant; mala veniebant super eos, dicit Dominus."
,"4":"Audite verbum Domini, domus Iacob,et omnes cognationes domus Israel."
,"5":"Haec dicit Dominus: Quid invenerunt patres vestri in me iniquitatis, quia elongaverunt a me,et ambulaverunt post vanitatem,et vani facti sunt?"
,"6":"Et non dixerunt: 'Ubi est Dominus, qui ascendere nos fecit de terra Aegypti, qui traduxit nos per desertum, per terram inhabitabilem et inviam, per terram sitis et caliginis, per terram, in qua non ambulavit vir, neque habitavit homo?'."
,"7":"Et induxi vos in terram hortorum, ut comederetis fructum eius et optima illius; et ingressi contaminastis terram meam,et hereditatem meam posuistis in abominationem."
,"8":"Sacerdotes non dixerunt: 'Ubi est Dominus?'. Et tractantes legem nescierunt me, et pastores praevaricati sunt in me, et prophetae prophetaverunt in Baal,et, quae nihil prosunt, secuti sunt."
,"9":"Propterea adhuc iudicio contendam vobiscum, ait Dominus, et cum filiis filiorum vestrorum disceptabo."
,"10":"En transite ad insulas Cetthim et videte,et in Cedar mittite et considerate vehementer,et videte, si factum est huiuscemodi:"
,"11":"si mutavit gens deos, et certe ipsi non sunt dii; populus vero meus mutavit gloriam suam,in id, quod nihil prodest."
,"12":"Obstupescite, caeli, super hoc,et inhorrescite supra modum, dicit Dominus."
,"13":"Duo enim mala fecit populus meus: me dereliquerunt fontem aquae vivae, ut foderent sibi cisternas, cisternas dissipatas, quae continere non valent aquas."
,"14":"Numquid servus est Israel,aut vernaculus?,Quare ergo factus est in praedam?,Super eum rugierunt leones"
,"15":"et dederunt vocem suam; posuerunt terram eius in solitudinem: civitates eius exustae sunt, et non est qui habitet in eis."
,"16":"Filii quoque Mempheos et Taphnes,decalvabunt tibi verticem."
,"17":"Numquid non istud factum est tibi, quia dereliquisti Dominum Deum tuum,eo tempore, quo ducebat te per viam?"
,"18":"Et nunc quid tibi vis in via Aegypti, ut bibas aquam Nili?,Et quid tibi cum via Assyriorum, ut bibas aquam Fluminis?"
,"19":"Arguet te malitia tua, et aversio tua increpabit te; scito et vide quia malum et amarum est,reliquisse te Dominum Deum tuum et non esse timorem mei apud te, dicit Dominus, Deus exercituum."
,"20":"A saeculo confregisti iugum tuum, rupisti vincula tua,et dixisti: 'Non serviam'. In omni enim colle sublimi,et sub omni ligno frondoso,tu prosternebaris meretrix."
,"21":"Ego autem plantavi te vineam electam, omne semen verum; quomodo ergo conversa es,in palmites vineae alienae?"
,"22":"Si laveris te nitro,et multiplicaveris tibi herbam fullonum, maculata es in iniquitate tua coram me, dicit Dominus Deus."
,"23":"Quomodo dicis: 'Non sum polluta, post Baalim non ambulavi'?,Vide viam tuam in convalle, scito quid feceris: camelus levis contorquens vias suas."
,"24":"Onager assuetus in solitudine,in desiderio animae suae attrahit aerem; libidinem eius quis avertet?,Omnes, qui quaerunt eam, non deficient, in menstruis eius invenient eam."
,"25":"Prohibe pedem tuum a nuditate,et guttur tuum a siti. Et dixisti: 'Vanum est, nequaquam; adamavi quippe alienos,et post eos ambulabo'."
,"26":"Quomodo confunditur fur, quando deprehenditur, sic confusi sunt domus Israel, ipsi et reges eorum, principes,et sacerdotes et prophetae eorum"
,"27":"dicentes ligno: 'Pater meus es tu' et lapidi: 'Tu me genuisti'. Verterunt ad me tergum et non faciem, sed in tempore afflictionis suae dicent: 'Surge et libera nos!'."
,"28":"Ubi sunt dii tui, quos fecisti tibi?,Surgant et liberent te in tempore afflictionis tuae; secundum numerum quippe civitatum tuarum,facti sunt dii tui, Iuda."
,"29":"Quid vultis mecum iudicio contendere?,Omnes praevaricati estis in me, dicit Dominus."
,"30":"Frustra percussi filios vestros: disciplinam non receperunt. Devoravit gladius vester prophetas vestros: quasi leo vastator."
,"31":"O generatio, vos videte verbum Domini: numquid solitudo factus sum Israeli,aut terra tenebrarum?,Quare ergo dixit populus meus: 'Recessimus, non veniemus ultra ad te'?"
,"32":"Numquid obliviscitur virgo ornamenti sui, sponsa fasciae pectoralis suae?,Populus vero meus oblitus est mei,diebus innumeris."
,"33":"Quam bene paras viam tuam,ad quaerendum amorem!,Et insuper in malum,docuisti vias tuas,"
,"34":"et in fimbriis tuis inventus est,sanguis animarum pauperum innocentium: non effringentes invenisti eos; sed in omnibus his"
,"35":"dixisti: 'Innocens ego sum, propterea aversus est furor eius a me'. Ecce ego iudicio contendam tecum, eo quod dixeris: 'Non peccavi'."
,"36":"Quam leviter mutas vias tuas!,Et ab Aegypto confunderis, sicut confusa es ab Assyria."
,"37":"Nam et ab ista egredieris, et manus tuae erunt super caput tuum, quoniam obtrivit Dominus illos, quibus confisus es, et nihil habebis prosperum in eis."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Si dimiserit vir uxorem suam, et recedens ab eo,duxerit virum alterum, numquid revertetur ad eam ultra?,Numquid non polluta,et contaminata est terra illa?,Tu autem fornicata es cum amatoribus multis,et reverteris ad me?, dicit Dominus."
,"2":"Leva oculos tuos ad colles et vide, ubi non prostrata sis. In viis sedebas exspectans eos,quasi Arabs in solitudine; et polluisti terram,in fornicationibus tuis et in malitia tua."
,"3":"Quam ob rem prohibitae sunt stillae pluviarum, et serotinus imber non fuit. Frons mulieris meretricis facta est tibi; noluisti erubescere."
,"4":"Nonne amodo vocas me: 'Pater meus, dux adulescentiae meae tu es!"
,"5":"Numquid irascetur in perpetuum,aut perseverabit in finem?'. Ecce locuta es,et fecisti mala et praevaluisti '."
,"6":"Et dixit Dominus ad me in diebus Iosiae regis: ' Numquid vidisti, quae fecerit aversatrix Israel? Abiit sibimet super omnem montem excelsum et sub omni ligno frondoso et fornicata est ibi."
,"7":"Et dixi: 'Cum fecerit haec omnia, ad me revertetur'; et non est reversa. Et vidit praevaricatrix soror eius, Iuda;"
,"8":"et vidit quia pro eo quod moechata esset aversatrix Israel, dimisissem eam et dedissem ei libellum repudii, et non timuit praevaricatrix Iuda, soror eius, sed abiit et fornicata est etiam ipsa;"
,"9":"et facilitate fornicationis suae contaminavit terram et moechata est cum lapide et ligno."
,"10":"Sed in omnibus his non est reversa ad me praevaricatrix soror eius Iuda in toto corde suo sed in mendacio ', ait Dominus."
,"11":"Et dixit Dominus ad me: ' Iustificavit animam suam aversatrix Israel comparatione praevaricatricis Iudae."
,"12":"Vade et clama sermones istos contra aquilonem et dices: Revertere, aversatrix Israel, ait Dominus, et non avertam faciem meam a vobis, quia pius ego sum, dicit Dominus, et non irascar in perpetuum."
,"13":"Verumtamen scito iniquitatem tuam, quia in Dominum Deum tuum praevaricata es,et dispersisti vias tuas alienis,sub omni ligno frondoso; et vocem meam non audistis, ait Dominus."
,"14":"Convertimini, filii, qui aversi estis a me, dicit Dominus, quia ego Dominus vester sum; et assumam vos unum de civitate et duos de cognatione et introducam vos in Sion;"
,"15":"et dabo vobis pastores iuxta cor meum, et pascent vos scientia et doctrina."
,"16":"Cumque multiplicati fueritis et creveritis in terra in diebus illis, ait Dominus, non dicent ultra: 'Arca testamenti Domini', neque ascendet super cor, neque recordabuntur illius, nec requiretur, nec fiet ultra."
,"17":"In tempore illo vocabunt Ierusalem Solium Domini, et congregabuntur ad eam omnes gentes in nomine Domini in Ierusalem; et non ambulabunt ultra post pravitatem cordis sui pessimi."
,"18":"In diebus illis ibit domus Iudae ad domum Israel, et venient simul de terra aquilonis ad terram, quam dedi in hereditatem patribus vestris."
,"19":"Ego autem dixi: Quomodo ponam te in filiis,et tribuam tibi terram desiderabilem, hereditatem praeclarissimam inter gentes?,Et dixi: Patrem vocabitis me,et post me ingredi non cessabitis."
,"20":"Sed, quomodo contemnit mulier amatorem suum, sic contempsistis me, domus Israel ', dicit Dominus."
,"21":"Vox in collibus audita est, ploratus et supplicatio filiorum Israel, quoniam iniquam fecerunt viam suam, obliti sunt Domini Dei sui."
,"22":"' Convertimini, filii, qui aversi estis a me, et sanabo aversiones vestras '. ' Ecce nos venimus ad te; tu enim es Dominus Deus noster."
,"23":"Vere mendaces erant colles,et tumultus montium; vere in Domino Deo nostro,salus Israel."
,"24":"Confusio comedit laborem patrum nostrorum,ab adulescentia nostra, greges eorum et armenta eorum, filios eorum et filias eorum."
,"25":"Dormiemus in confusione nostra, et operiet nos ignominia nostra, quoniam Domino Deo nostro peccavimus,nos et patres nostri,ab adulescentia nostra usque ad hanc diem,et non audivimus vocem Domini Dei nostri '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"' Si converteris, Israel, ait Dominus, ad me convertere; si abstuleris abominationes tuas a facie mea, non effugies."
,"2":"Et iurabis: 'Vivit Dominus!',in veritate et in iudicio et in iustitia, et benedicentur in ipso gentes,et in ipso gloriabuntur."
,"3":"Haec enim dicit Dominus,viro Iudae et Ierusalem: Novate vobis novale,et nolite serere super spinas."
,"4":"Circumcidimini Domino,et auferte praeputia cordium vestrorum, viri Iudae et habitatores Ierusalem, ne forte egrediatur ut ignis indignatio mea,et succendatur, et non sit qui exstinguat, propter malitiam operum vestrorum."
,"5":"Annuntiate in Iuda,et in Ierusalem auditum facite; et loquimini et canite tuba in terra, clamate fortiter et dicite: 'Congregamini, et ingrediamur civitates munitas'."
,"6":"Levate signum in Sion, fugite, nolite stare, quia malum ego adduco ab aquilone,et contritionem magnam."
,"7":"Ascendit leo de cubili suo, et praedo gentium se levavit; egressus est de loco suo, ut ponat terram tuam in solitudinem: civitates tuae vastabuntur, remanentes absque habitatore."
,"8":"Super hoc accingite vos ciliciis, plangite et ululate, quia non est aversa ira furoris Domini a nobis."
,"9":"Et erit in die illa, dicit Dominus, peribit cor regis,et cor principum, et obstupescent sacerdotes, et prophetae consternabuntur '."
,"10":"Et dixi: ' Heu, Domine Deus!,Ergo decepisti populum istum et Ierusalem,dicens: 'Pax erit vobis'; et ecce pervenit gladius usque ad animam '."
,"11":"In tempore illo dicetur populo huic et Ierusalem: ' Ventus urens collium, qui sunt in deserto, invadit filiam populi mei,non ad ventilandum et ad purgandum."
,"12":"Ventus plenior his veniet mihi, nunc et ego loquar iudicia mea cum eis '."
,"13":"Ecce quasi nubes ascendet, et quasi tempestas currus eius; velociores aquilis equi illius. Vae nobis, quoniam vastati sumus!"
,"14":"Lava a malitia cor tuum, Ierusalem, ut salva fias; usquequo morabuntur in te,cogitationes iniquae?"
,"15":"Vox enim annuntiantis a Dan,et notam facientis calamitatem de monte Ephraim."
,"16":"Nuntiate gentibus. Ecce adsunt!,Auditum facite hoc super Ierusalem: ' Custodes venerunt de terra longinqua,et dederunt super civitates Iudae vocem suam;"
,"17":"quasi custodes agrorum facti sunt super eam in gyro, quia adversus me contumax erat ', dicit Dominus."
,"18":"Via tua et opera tua,fecerunt haec tibi; ista malitia tua, quia amara, quia tetigit cor tuum."
,"19":"Viscera mea, viscera mea! Doleo. Parietes cordis mei!,Turbatur in me cor meum: non tacebo, quoniam vocem bucinae audivit anima mea, clamorem proelii."
,"20":"Contritio super contritionem vocata est, quoniam vastata est omnis terra, repente vastata sunt tabernacula mea, subito tentoria mea."
,"21":"Usquequo videbo vexillum, audiam vocem bucinae?"
,"22":"' Quia stultus populus meus: me non cognoverunt; filii insipientes sunt et vecordes: sapientes sunt, ut faciant mala, bene autem facere nesciunt '."
,"23":"Aspexi terram, et ecce vacua erat et deserta; et caelos, et non erat lux in eis."
,"24":"Aspexi montes, et ecce movebantur, et omnes colles conturbati sunt."
,"25":"Aspexi, et ecce non erat homo, et omne volatile caeli recesserat."
,"26":"Aspexi, et ecce hortus desertus, et omnes urbes eius destructae sunt,a facie Domini et a facie irae furoris eius."
,"27":"Haec enim dicit Dominus: ' Deserta erit omnis terra, sed tamen consummationem non faciam."
,"28":"Super hoc lugebit terra, et maerebunt caeli desuper, eo quod locutus sum, statui et non paenitet me,nec avertar ab eo '."
,"29":"A voce equitis et mittentis sagittam,fugit omnis civitas; ingressi sunt silvas condensas,et ascenderunt rupes; universae urbes derelictae sunt, et non habitat in eis homo."
,"30":"Tu autem, vastata, quid facies?,Cum vestieris te coccino, cum ornata fueris monili aureo, et pinxeris stibio oculos tuos, frustra componeris; contempserunt te amatores tui, animam tuam quaerent."
,"31":"Vocem enim quasi parturientis audivi, angustias ut puerperae; vox filiae Sion,intermorientis expandentisque manus suas: ' Vae mihi, quia defecit anima mea,propter interfectores! '."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Circuite vias Ierusalem,et aspicite et considerate,et quaerite in plateis eius, an inveniatis virum, an sit qui faciat iudicium et quaerentem fidem, et propitius ero ei."
,"2":"Quod si etiam ' Vivit Dominus! ' dixerint, certe falso iurabunt."
,"3":"Domine, nonne oculi tui respiciunt fidem?,Percussisti eos, et non doluerunt, attrivisti eos, et renuerunt accipere disciplinam: induraverunt facies suas supra petram, noluerunt reverti."
,"4":"Ego autem dixi: ' Ecce pauperes illi stulte agunt, quia ignorant viam Domini, iudicium Dei sui."
,"5":"Ibo igitur ad optimates,et loquar eis; ipsi enim noverunt viam Domini, iudicium Dei sui '. Ecce hi simul confregerunt iugum, ruperunt vincula."
,"6":"Idcirco percussit eos leo de silva, lupus deserti vastabit eos, pardus vigilans super civitates eorum: omnis, qui egressus fuerit ex eis, lacerabitur, quia multiplicatae sunt praevaricationes eorum, confortatae sunt aversiones eorum. "
,"7":"' Super quo propitius tibi esse potero?,Filii tui dereliquerunt me,et iuraverunt in his, qui non sunt dii; saturavi eos, et moechati sunt,et in domum meretricis gregatim confluebant."
,"8":"Equi impinguati et admissarii facti sunt: unusquisque ad uxorem proximi sui hinniebat."
,"9":"Numquid super his non visitabo, dicit Dominus, et in gente tali non ulciscetur anima mea?"
,"10":"Ascendite muros eius et dissipate, consummationem autem nolite facere; auferte propagines eius, quia non sunt Domini."
,"11":"Praevaricatione enim praevaricata est in me,domus Israel et domus Iudae ', ait Dominus."
,"12":"Negaverunt Dominum,et dixerunt: 'Non est ipse; neque veniet super nos malum, et gladium et famem non videbimus."
,"13":"Prophetae erunt in ventum, et responsum non est in eis. Haec ergo evenient illis '."
,"14":"Propterea haec dicit Dominus, Deus exercituum: ' Quia locuti estis verbum istud, ecce ego do verba mea in ore tuo in ignem,et populum istum in ligna, et vorabit eos."
,"15":"Ecce ego adducam super vos gentem de longinquo, domus Israel, ait Dominus, gentem robustam, gentem antiquam, gentem, cuius ignorabis linguam,nec intelleges quid loquatur."
,"16":"Pharetra eius quasi sepulcrum patens,universi fortes."
,"17":"Et comedet segetes tuas et panem tuum, devorabit filios tuos et filias tuas, comedet gregem tuum et armenta tua, comedet vineam tuam et ficum tuam; et conteret urbes munitas tuas, in quibus tu habes fiduciam, gladio."
,"18":"Verumtamen et in diebus illis, ait Dominus, non faciam in vobis consummationem '."
,"19":"Quod si dixeritis: ' Quare fecit nobis Dominus Deus noster haec omnia? ', dices ad eos: ' Sicut dereliquistis me et servistis diis alienis in terra vestra, sic servietis alienis in terra non vestra '."
,"20":"Annuntiate hoc domui Iacob,et auditum facite in Iuda dicentes:"
,"21":"' Audi, popule stulte, qui non habes cor, qui habentes oculos non vident, et aures et non audiunt."
,"22":"Numquid me non timebitis, ait Dominus, et a facie mea non trepidabitis?,Qui posui arenam terminum mari, praeceptum sempiternum, quod non praeteribit; et commovebuntur et non poterunt, et intumescent fluctus eius, et non transibunt illud '."
,"23":"Populo autem huic factum est cor contumax et rebelle; recesserunt et abierunt"
,"24":"et non dixerunt in corde suo: ' Metuamus Dominum Deum nostrum, qui dat nobis pluviam,temporaneam et serotinam in tempore suo, hebdomadas statutas messis,custodientem nobis '."
,"25":"Iniquitates vestrae declinaverunt haec, et peccata vestra prohibuerunt bonum a vobis,"
,"26":"quia inventi sunt in populo meo impii, insidiantes quasi incurvati aucupes, laqueos ponentes ad capiendos viros."
,"27":"Sicut decipula plena avibus, sic domus eorum plenae dolo; ideo magnificati sunt et ditati,"
,"28":"incrassati sunt et impinguati: et transgressi sunt terminos mali. Causam non iudicaverunt, causam pupilli, ut ipsi prospere agant, et iudicium pauperum non iudicaverunt."
,"29":"Numquid super his non visitabo, dicit Dominus, aut super gentem huiuscemodi,non ulciscetur anima mea?"
,"30":"Stupor et mirabilia,facta sunt in terra:"
,"31":"prophetae prophetabant mendacium, et sacerdotes applaudebant manibus suis, et populus meus dilexit talia. Quid igitur facietis in novissimo eius?"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Fugite, filii Beniamin, de medio Ierusalem; et in Thecua clangite bucina,et super Bethcharem levate vexillum, quia malum visum est ab aquilone,et contritio magna."
,"2":"Speciosam et delicatam silere feci,filiam Sion."
,"3":"Ad eam venient pastores et greges eorum, figent in ea tentoria in circuitu; pascet unusquisque partem suam."
,"4":"' Sanctificate super eam bellum, consurgite, et ascendamus in meridie; vae nobis, quia declinavit dies, quia longiores factae sunt umbrae vesperi!"
,"5":"Surgite, et ascendamus in nocte,et dissipemus domos eius '."
,"6":"Quia haec dicit Dominus exercituum: ' Caedite lignum eius,et fundite circa Ierusalem aggerem; haec est civitas visitationis, omnis calumnia in medio eius."
,"7":"Sicut effluere facit cisterna aquam suam, sic illa effluere facit malitiam suam; violentia et vastitas auditur in ea, coram me semper afflictio et plaga."
,"8":"Erudire, Ierusalem, ne forte recedat anima mea a te, ne forte ponam te desertam, terram inhabitabilem '."
,"9":"Haec dicit Dominus exercituum: ' Usque ad racemum colligent quasi in vinea,reliquias Israel. Converte manum tuam,quasi vindemiator ad palmites '."
,"10":"Cui loquar et quem contestabor, ut audiat?,Ecce incircumcisae aures eorum, et audire non possunt; ecce verbum Domini factum est eis in opprobrium, et non suscipient illud."
,"11":"Idcirco furore Domini plenus sum, laboravi sustinens. ' Effunde super parvulum foris,et super concilium iuvenum simul; etiam vir cum muliere capietur, senex cum pleno dierum."
,"12":"Et transibunt domus eorum ad alteros, agri et uxores pariter, quia extendam manum meam,super habitantes terram ', dicit Dominus."
,"13":"A minore quippe usque ad maiorem,omnes avaritiae student, et a propheta usque ad sacerdotem,cuncti faciunt dolum."
,"14":"Et curant contritionem populi mei in levitate,dicentes: ' Pax, pax '; et non est pax."
,"15":"Confusi sunt, quia abominationem fecerunt; quin potius confusione non sunt confusi,et erubescere nescierunt. ' Quam ob rem cadent inter ruentes; tempore, quo visitavero eos, corruent ', dicit Dominus."
,"16":"Haec dicit Dominus: ' State super vias et videte,et interrogate de semitis antiquis, quae sit via bona, et ambulate in ea,et invenietis refrigerium animabus vestris '. Et dixerunt: ' Non ambulabimus! '."
,"17":"Et constitui super vos speculatores: ' Audite vocem tubae '. Et dixerunt: ' Non audiemus! '."
,"18":"Ideo audite, gentes, et cognosce, congregatio, quanta ego faciam eis."
,"19":"Audi terra: ' Ecce ego adducam mala super populum istum, fructum cogitationum eorum, quia verba mea non audierunt,et legem meam proiecerunt."
,"20":"Ut quid mihi tus, quod de Saba venit, et calamus suave olens de terra longinqua?,Holocautomata vestra non sunt accepta, et victimae vestrae non placent mihi '."
,"21":"Propterea haec dicit Dominus: ' Ecce ego dabo in populum istum offendicula, et offendent in eis patres et filii simul, vicinus et proximus peribunt '."
,"22":"Haec dicit Dominus: ' Ecce populus venit de terra aquilonis, et gens magna consurget a finibus terrae;"
,"23":"arcum et acinacem arripiet, crudelis est et non miserebitur; vox eorum quasi mare sonabit, et super equos ascendent, praeparati quasi vir ad proelium,adversum te, filia Sion '."
,"24":"' Audivimus famam eius; dissolutae sunt manus nostrae, tribulatio apprehendit nos, dolores ut parturientem '."
,"25":"Nolite exire ad agros,et in via ne ambuletis, quoniam gladius inimici, pavor in circuitu."
,"26":"Filia populi mei, accingere cilicio,et volutare in cinere, luctum unigeniti fac tibi, planctum amarum, quia repente veniet vastator super nos."
,"27":"Probatorem dedi te in populo meo; et scies et probabis viam eorum."
,"28":"Omnes isti principes rebelles, ambulantes fraudulenter. Aes et ferrum, omnia isti corrumpunt."
,"29":"Sufflavit sufflatorium in igne, consumptum est plumbum; frustra conflavit conflator, scoriae enim non sunt separatae."
,"30":"Argentum reprobum vocate eos, quia Dominus proiecit illos."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Verbum, quod factum est ad Ieremiam a Domino dicens:"
,"2":"' Sta in porta domus Domini et praedica ibi verbum istud et dic: Audite verbum Domini, omnis Iuda, qui ingredimini per portas has, ut adoretis Dominum."
,"3":"Haec dicit Dominus exercituum, Deus Israel: Bonas facite vias vestras et opera vestra, et habitare vos faciam in loco isto."
,"4":"Nolite confidere in verbis mendacii dicentes: 'Templum Domini, templum Domini, templum Domini est'."
,"5":"Quoniam, si bene direxeritis vias vestras et opera vestra, si feceritis iudicium inter virum et proximum eius,"
,"6":"advenae et pupillo et viduae non feceritis calumniam nec sanguinem innocentem effuderitis in loco hoc et post deos alienos non ambulaveritis in malum vobismetipsis,"
,"7":"habitare vos faciam in loco isto, in terra, quam dedi patribus vestris a saeculo usque in saeculum."
,"8":"Ecce vos confiditis vobis in sermonibus mendacii, qui non proderunt."
,"9":"Quid? Furari, occidere, adulterari, iurare mendaciter, incensum offerre Baal et ire post deos alienos, quos ignoratis;"
,"10":"et venitis et statis coram me in domo hac, super quam invocatum est nomen meum, et dicitis: 'Liberati sumus', eo quod faciatis omnes abominationes istas."
,"11":"Numquid spelunca latronum facta est domus ista, super quam invocatum est nomen meum in oculis vestris?,Ecce, etiam ego vidi, dicit Dominus. "
,"12":"Ite ad locum meum in Silo, ubi habitavit nomen meum a principio, et videte, quae fecerim ei propter malitiam populi mei Israel."
,"13":"Et nunc, quia fecistis omnia opera haec, dicit Dominus, et locutus sum ad vos mane consurgens et loquens, et non audistis, et vocavi vos, et non respondistis,"
,"14":"faciam domui huic, super quam invocatum est nomen meum, et in qua vos habetis fiduciam, et loco, quem dedi vobis et patribus vestris, sicut feci Silo;"
,"15":"et proiciam vos a facie mea, sicut proieci omnes fratres vestros, universum semen Ephraim."
,"16":"Tu ergo, noli orare pro populo hoc nec assumas pro eis deprecationem et orationem et non obsistas mihi, quia non exaudiam te."
,"17":"Nonne vides, quid isti faciant in civitatibus Iudae et in plateis Ierusalem?"
,"18":"Filii colligunt ligna, et patres succendunt ignem, et mulieres commiscent farinam, ut faciant placentas reginae caeli et libent diis alienis, ut me ad iracundiam provocent."
,"19":"Numquid me ad iracundiam provocant, dicit Dominus, nonne semetipsos in confusionem vultus sui?"
,"20":"Ideo haec dicit Dominus Deus: Ecce furor meus et indignatio mea effunditur super locum istum, super homines et super iumenta et super lignum regionis et super fruges terrae et succendetur et non exstinguetur."
,"21":"Haec dicit Dominus exercituum, Deus Israel: Holocautomata vestra addite victimis vestris et comedite carnes,"
,"22":"quia non sum locutus cum patribus vestris et non praecepi eis in die, qua eduxi eos de terra Aegypti, de verbo holocautomatum et victimarum."
,"23":"Sed hoc verbum praecepi eis dicens: Audite vocem meam, et ero vobis Deus, et vos eritis mihi populus; et ambulate in omni via, quam mandaverim vobis, ut bene sit vobis."
,"24":"Et non audierunt nec inclinaverunt aurem suam, sed abierunt in voluntatibus et in pravitate cordis sui mali factique sunt retrorsum et non in ante"
,"25":"a die, qua egressi sunt patres eorum de terra Aegypti, usque ad diem hanc. Et misi ad vos omnes servos meos prophetas, per diem consurgens diluculo et mittens;"
,"26":"et non audierunt me nec inclinaverunt aurem suam, sed induraverunt cervicem suam et peius operati sunt quam patres eorum."
,"27":"Et loqueris ad eos omnia verba haec, et non audient te; et vocabis eos, et non respondebunt tibi;"
,"28":"et dices ad eos: Haec est gens, quae non audivit vocem Domini Dei sui nec recepit disciplinam. Periit fides et ablata est de ore eorum."
,"29":"Tonde capillum tuum et proice,et sume in collibus planctum, quia sprevit Dominus,et proiecit generationem furoris sui."
,"30":"Quia fecerunt filii Iudae malum in oculis meis, dicit Dominus; posuerunt abominationes suas in domo, super quam invocatum est nomen meum, ut polluerent eam;"
,"31":"et aedificaverunt excelsa Topheth, quae est in valle Benennom, ut incenderent filios suos et filias suas igni: quae non praecepi nec cogitavi in corde meo."
,"32":"Ideo ecce dies venient, dicit Dominus, et non dicetur amplius Topheth et vallis Benennom sed vallis Interfectionis; et sepelient in Topheth, eo quod non sit locus."
,"33":"Et erit morticinum populi huius in cibum volucribus caeli et bestiis terrae, et non erit qui abigat."
,"34":"Et quiescere faciam de urbibus Iudae et de plateis Ierusalem vocem gaudii et vocem laetitiae, vocem sponsi et vocem sponsae: in desolationem enim erit terra '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"' In illo tempore, ait Dominus, eicient ossa regum Iudae et ossa principum eius et ossa sacerdotum et ossa prophetarum et ossa eorum, qui habitaverunt Ierusalem de sepulcris suis;"
,"2":"et expandent ea ad solem et lunam et omnem militiam caeli, quae dilexerunt et quibus servierunt et post quae ambulaverunt et quae quaesierunt et adoraverunt; non colligentur et non sepelientur: in sterquilinium super faciem terrae erunt."
,"3":"Et eligent magis mortem quam vitam omnes, qui residui fuerint de cognatione hac pessima in universis locis, ad quae eiecero eos, dicit Dominus exercituum."
,"4":"Et dices ad eos: Haec dicit Dominus: Numquid, qui cadit, non resurget, et, qui aversus est, non revertetur?"
,"5":"Quare ergo aversus est populus iste, Ierusalem aversione perpetua?,Apprehenderunt mendacium,et noluerunt reverti."
,"6":"Attendi et auscultavi: nemo, quod bonum est, loquitur, nullus est, qui agat paenitentiam,super malitia sua dicens: 'Quid feci?'. Omnes conversi sunt ad cursum suum, quasi equus impetu vadens in proelio."
,"7":"Etiam ciconia in caelo,novit tempus suum; turtur et hirundo et turdus,custodierunt tempus adventus sui; populus autem meus non novit,iudicium Domini."
,"8":"Quomodo dicitis: 'Sapientes nos sumus, et lex Domini nobiscum est'?,Vere mendacium operatus est,stilus mendax scribarum."
,"9":"Confusi sunt sapientes, perterriti et capti sunt; verbum enim Domini proiecerunt, et sapientia nulla est in eis."
,"10":"Propterea dabo mulieres eorum exteris, agros eorum expugnatoribus, quia a minimo usque ad maximum,omnes avaritiam sequuntur, a propheta usque ad sacerdotem,cuncti faciunt mendacium."
,"11":"Et sanant contritionem,filiae populi mei in levitate,dicentes 'Pax, pax', cum non sit pax."
,"12":"Confusi sunt, quia abominationem fecerunt; quin immo confusione non sunt confusi,et erubescere nescierunt, idcirco cadent inter corruentes, in tempore visitationis suae corruent, dicit Dominus."
,"13":"Congregans congregabo eos, ait Dominus; non est uva in vitibus, et non sunt ficus in ficulnea, folium defluxit, et dabo eis gradientes super eos."
,"14":"'Quare sedemus?,Convenite, et ingrediamur civitates munitas,et pereamus ibi, quia Dominus Deus noster tradidit nos in interitum,et potum dedit nobis aquam fellis; peccavimus enim Domino."
,"15":"Exspectavimus pacem, et non est bonum, tempus medelae, et ecce formido'."
,"16":"A Dan auditus est fremitus equorum eius, a voce hinnituum fortium equorum eius,commota est omnis terra; et venient et devorabunt terram et plenitudinem eius, urbem et habitatores eius."
,"17":"Quia ecce ego mittam vobis,serpentes regulos, quibus non est incantatio, et mordebunt vos ', ait Dominus."
,"18":"Hilaritas mea facta est dolor in me, cor meum maerens."
,"19":"Ecce vox clamoris filiae populi mei,de terra longinqua: ' Numquid Dominus non est in Sion?,Aut rex eius non est in ea? '. ' Quare ergo me ad iracundiam concitaverunt in sculptilibus suis,et in vanitatibus alienis? '."
,"20":"' Transiit messis, finita est aestas, et nos salvati non sumus '."
,"21":"Super contritione filiae populi mei,contritus sum et contristatus; stupor obtinuit me."
,"22":"Numquid resina non est in Galaad?,Aut medicus non est ibi?,Quare enim non est obducta,cicatrix filiae populi mei?"
,"23":"Quis dabit capiti meo aquam,et oculis meis fontem lacrimarum, et plorabo die ac nocte,interfectos filiae populi mei?"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Quis dabit mihi in solitudine deversorium viatorum, et de relinquam populum meum et recedam ab eis?,Quia omnes adulteri sunt, coetus praevaricatorum."
,"2":"' Et tenderunt linguam suam quasi arcum; mendacium, et non veritas, invaluit in terra, quia de malo ad malum egressi sunt,et me non cognoverunt, dicit Dominus."
,"3":"Unusquisque se a proximo suo custodiat,et in omni fratre suo non habeat fiduciam, quia omnis frater supplantat, et omnis amicus fraudulenter incedit,"
,"4":"et vir fratrem suum decipit, et veritatem non loquuntur; docuerunt enim linguam suam loqui mendacium, inique egerunt, noluerunt converti."
,"5":"Iniuria super iniuriam, dolus super dolum. Renuerunt scire me ', dicit Dominus."
,"6":"Propterea haec dicit Dominus exercituum: ' Ecce ego conflabo et probabo eos; quid enim aliud faciam filiae populi mei?"
,"7":"Sagitta vulnerans lingua eorum; dolum locuta est in ore suo: pacem cum amico suo loquitur,et occulte ponit ei insidias."
,"8":"Numquid super his non visitabo eos, dicit Dominus, aut in gente huiusmodi,non ulciscetur anima mea? '."
,"9":"Super montes assumam fletum ac lamentum,et super pascua deserti planctum, quoniam incensa sunt, eo quod non sit vir pertransiens, et non audiunt vocem gregis; a volucre caeli usque ad pecora,transmigraverunt, recesserunt."
,"10":"' Et dabo Ierusalem in acervos arenae,et cubilia thoum, et civitates Iudae dabo in desolationem, eo quod non sit habitator '."
,"11":"Quis est vir sapiens, qui intellegat hoc, et ad quem verbum oris Domini fiat, ut annuntiet istud: Quare perierit terra, exusta sit quasi desertum, eo quod non sit qui pertranseat?"
,"12":"Et dixit Dominus: ' Quia dereliquerunt legem meam, quam dedi eis, et non audierunt vocem meam et non ambulaverunt in ea;"
,"13":"et abierunt post pravitatem cordis sui et post Baalim, quos didicerunt a patribus suis '."
,"14":"Idcirco haec dicit Dominus exercituum, Deus Israel: ' Ecce ego cibabo populum istum absinthio et potum dabo eis aquam fellis;"
,"15":"et dispergam eos in gentibus, quas non noverunt ipsi et patres eorum, et mittam post eos gladium, donec consumantur."
,"16":"Haec dicit Dominus exercituum: Attendite et vocate lamentatrices, et veniant; et ad eas, quae sapientes sunt, mittite, et properent! '."
,"17":"Festinent,et assumant super nos lamentum: deducant oculi nostri lacrimas, et palpebrae nostrae defluant aquis."
,"18":"Quia vox lamentationis audita est de Sion: ' Quomodo vastati sumus et confusi vehementer, quia dereliquimus terram, quoniam deiecta sunt tabernacula nostra '."
,"19":"Audite ergo, mulieres, verbum Domini; et assumant aures vestrae sermonem oris eius, et docete filias vestras lamentum, et unaquaeque proximam suam planctum."
,"20":"Quia ascendit mors per fenestras nostras, ingressa est domos nostras, disperdere parvulos deforis, iuvenes de plateis."
,"21":"Loquere. Haec dicit Dominus: ' Et cadet morticinum hominis,quasi stercus super faciem regionis,et quasi manipulus post tergum metentis, et non est qui colligat '."
,"22":"Haec dicit Dominus: ' Non glorietur sapiens in sapientia sua, et non glorietur fortis in fortitudine sua, et non glorietur dives in divitiis suis;"
,"23":"sed in hoc glorietur, qui gloriatur: scire et nosse me, quia ego sum Dominus, qui facio misericordiam,et iudicium et iustitiam in terra; haec enim placent mihi, ait Dominus."
,"24":"Ecce dies veniunt, dicit Dominus, et visitabo super omnem, qui circumcisum habet praeputium,"
,"25":"super Aegyptum et super Iudam et super Edom et super filios Ammon et super Moab et super omnes, qui attonsi sunt in comam, habitantes in deserto, quia omnes gentes habent praeputium, omnis autem domus Israel incircumcisi sunt corde '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Audite verbum, quod locutus est Dominus super vos, domus Israel."
,"2":"Haec dicit Dominus: ' Iuxta vias gentium nolite discere,et a signis caeli nolite metuere, quae timent gentes,"
,"3":"quia leges populorum vanae sunt. Quia lignum de saltu praecidit,opus manuum artificis in ascia,"
,"4":"argento et auro decoravit illud, clavis et malleis firmavit, ut non moveatur;"
,"5":"sicut formido in cucumerario sunt,et non loquentur, portantur, quia incedere non valent: nolite ergo timere ea, quia nec male possunt facere nec bene '."
,"6":"Non est similis tui, Domine; magnus es tu, et magnum nomen tuum in fortitudine."
,"7":"Quis non timebit te, o rex gentium?,Te enim decet, quoniam inter cunctos sapientes gentium,et in universis regnis earum nullus est similis tui."
,"8":"Pariter insipientes et fatui sunt; doctrina vanitatis eorum lignum est."
,"9":"Argentum involutum, quod de Tharsis affertur, et aurum de Ophaz, opus artificis et manuum aurificis, hyacinthus et purpura indumentum eorum; opus artificum universa haec."
,"10":"Dominus autem Deus verus est, ipse Deus vivens et rex sempiternus; ab indignatione eius commovebitur terra, et non sustinebunt gentes comminationem eius."
,"11":"Sic ergo dicetis eis: ' Dii, qui caelos et terram non fecerunt, pereant de terra et de his, quae sub caelis sunt '."
,"12":"Qui fecit terram in fortitudine sua, firmavit orbem in sapientia sua,et prudentia sua extendit caelos."
,"13":"Ad vocem suam dat multitudinem aquarum in caelo,et elevat nebulas ab extremitatibus terrae; fulgura in pluviam facit,et educit ventum de thesauris suis."
,"14":"Stultus factus est omnis homo absque scientia; confusus est omnis artifex in sculptili, quoniam falsum est, quod conflavit, et non est spiritus in eis."
,"15":"Vana sunt et opus risu dignum; in tempore visitationis suae peribunt."
,"16":"Non est his similis pars Iacob: qui enim formavit omnia, ipse est, et Israel tribus hereditatis eius, Dominus exercituum nomen illi."
,"17":"Congrega de terra sarcinam tuam, quae habitas in obsidione,"
,"18":"quia haec dicit Dominus: ' Ecce ego longe proiciam habitatores terrae in hac vice,et tribulabo eos, ita ut inveniant me '."
,"19":"Vae mihi super contritione mea, pessima plaga mea!,Ego autem dixi: ' Plane haec infirmitas mea est, et portabo illam '."
,"20":"Tabernaculum meum vastatum est, omnes funiculi mei dirupti sunt; filii mei exierunt a me et non subsistunt, non est qui extendat ultra tentorium meum,et erigat pelles meas."
,"21":"Quia stulte egerunt pastores,et Dominum non quaesierunt; propterea non prosperati sunt, et omnis grex eorum dispersus est."
,"22":"Vox auditionis ecce venit,et commotio magna de terra aquilonis, ut ponat civitates Iudae solitudinem,et habitaculum thoum."
,"23":"' Scio, Domine, quia non est hominis via eius, nec viri est, ut ambulet et dirigat gressus suos."
,"24":"Corripe me, Domine, verumtamen in iudicio et non in furore tuo, ne forte ad nihilum redigas me '."
,"25":"Effunde indignationem tuam super gentes, quae non cognoverunt te, et super cognationes, quae nomen tuum non invocaverunt; quia comederunt Iacob,et devoraverunt eum,et consumpserunt illum,et pascua eius dissipaverunt."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Verbum, quod factum est ad Ieremiam a Domino dicens:"
,"2":"' Audite verba pacti huius et loquimini ad viros Iudae et habitatores Ierusalem."
,"3":"Et dices ad eos: Haec dicit Dominus, Deus Israel: Maledictus vir, qui non audierit verba pacti huius,"
,"4":"quod praecepi patribus vestris in die, qua eduxi eos de terra Aegypti, de fornace ferrea, dicens: Audite vocem meam et facite omnia, quae praecipio vobis, et eritis mihi in populum, et ego ero vobis in Deum;"
,"5":"ut suscitem iuramentum, quod iuravi patribus vestris, daturum me eis terram fluentem lacte et melle, sicut est dies haec '. Et respondi et dixi: ' Amen, Domine '."
,"6":"Et dixit Dominus ad me: ' Vociferare omnia verba haec in civitatibus Iudae et in foris Ierusalem dicens: Audite verba pacti huius et facite illa."
,"7":"Quia contestans contestatus sum patres vestros in die, qua eduxi eos de terra Aegypti, usque ad diem hanc; mane consurgens contestatus sum et dixi: Audite vocem meam."
,"8":"Et non audierunt nec inclinaverunt aurem suam, sed abierunt unusquisque in pravitate cordis sui mali; et induxi super eos omnia verba pacti huius, quod praecepi, ut facerent, et non fecerunt '."
,"9":"Et dixit Dominus ad me: ' Inventa est coniuratio in viris Iudae et in habitatoribus Ierusalem."
,"10":"Reversi sunt ad iniquitates patrum suorum priorum, qui noluerunt audire verba mea; et hi ergo abierunt post deos alienos, ut servirent eis: irritum fecerunt domus Israel et domus Iudae pactum meum, quod pepigi cum patribus eorum."
,"11":"Quam ob rem haec dicit Dominus: Ecce ego inducam super eos mala, de quibus exire non poterunt; et clamabunt ad me, et non exaudiam eos."
,"12":"Et ibunt civitates Iudae et habitatores Ierusalem et clamabunt ad deos, quibus sacrificant, et non salvabunt eos in tempore afflictionis eorum."
,"13":"Secundum numerum enim civitatum tuarum erant dii tui, Iuda, et secundum numerum viarum Ierusalem posuistis aras confusioni, aras ad sacrificandum Baal."
,"14":"Tu ergo noli orare pro populo hoc et ne assumas pro eis deprecationem et orationem, quia non exaudiam in tempore clamoris eorum ad me, in tempore afflictionis eorum."
,"15":"Quid est dilectae meae, ut in domo mea perficiat consilia mala?,Numquid vota et carnes sanctae,auferent a te malitias tuas, in quibus glorieris? '."
,"16":"Olivam uberem, pulchram, fructibus speciosam, vocabit Dominus nomen tuum; ad vocem strepitus grandis,succendit ignem in ea, et combusti sunt rami eius."
,"17":"Et Dominus exercituum, qui plantavit te, locutus est super te malum, pro malis domus Israel et domus Iudae, quae fecerunt sibi ad irritandum me, sacrificantes Baal."
,"18":"Tu autem, Domine, demonstrasti mihi, et cognovi; tunc ostendisti mihi opera eorum."
,"19":"Et ego quasi agnus mansuetus, qui portatur ad victimam; et non cognovi quia super me cogitaverunt consilia: ' Caedamus lignum in vigore eius et eradamus eum de terra viventium, et nomen eius non memoretur amplius '."
,"20":"Tu autem, Domine exercituum, qui iudicas iuste et probas renes et corda: videam ultionem tuam ex eis; tibi enim revelavi causam meam."
,"21":"Propterea haec dicit Dominus super viros Anathoth, qui quaerunt animam tuam et dicunt: ' Non prophetabis in nomine Domini et non morieris in manibus nostris '."
,"22":"Propterea haec dicit Dominus exercituum: ' Ecce ego visitabo super eos: iuvenes morientur in gladio, filii eorum et filiae eorum morientur in fame,"
,"23":"et reliquiae non erunt eis; inducam enim malum super viros Anathoth, annum visitationis eorum '."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Iustus quidem tu es, Domine, si disputem tecum; verumtamen de iudiciis loquar ad te. Quare via impiorum prosperatur?,Bene est omnibus, qui praevaricantur et inique agunt."
,"2":"Plantasti eos, et radicem miserunt, proficiunt et faciunt fructum; prope es tu ori eorum,et longe a renibus eorum."
,"3":"Et tu, Domine, nosti me, vidisti me,et probasti cor meum tecum; segrega eos quasi gregem ad victimam,et sanctifica eos in diem occisionis."
,"4":"Usquequo lugebit terra, et herba omnis regionis siccabitur,propter malitiam habitantium in ea?,Consumptum est animal et volucre, quoniam dixerunt: 'Non videbit novissima nostra'."
,"5":"' Si cum peditibus currens laborasti, quomodo contendere poteris cum equis?,Cum autem in terra pacis securus fueris, quid facies in silva condensa Iordanis?"
,"6":"Nam et fratres tui et domus patris tui, etiam ipsi fraudulenter egerunt adversum te,et clamaverunt post te plena voce; ne credas eis, cum locuti fuerint tibi bona '."
,"7":"' Reliqui domum meam, dimisi hereditatem meam; dedi dilectam animae meae,in manu inimicorum eius."
,"8":"Facta est mihi hereditas mea,quasi leo in silva; dedit contra me vocem, ideo odivi eam."
,"9":"Numquid avis discolor hereditas mea mihi?,Numquid aves in circuitu contra eam?,Venite, congregamini, omnes bestiae campi, properate ad devorandum."
,"10":"Pastores multi demoliti sunt vineam meam, conculcaverunt partem meam; dederunt portionem meam desiderabilem,in desertum solitudinis."
,"11":"Posuerunt eam in dissipationem; lugetque coram me desolata, vastata est omnis terra, quia nullus est qui recogitet corde '."
,"12":"Super omnes colles in deserto venerunt vastatores, quia gladius Domini devorat,ab extremo terrae usque ad extremum eius; non est pax universae carni."
,"13":"Seminaverunt triticum et spinas messuerunt, laboraverunt, et non eis proderit; confundemini a fructibus vestris,propter iram furoris Domini."
,"14":"Haec dicit Dominus adversum omnes vicinos meos pessimos, qui tangunt hereditatem, quam distribui populo meo Israel: 'Ecce ego evellam eos de terra sua et domum Iudae evellam de medio eorum."
,"15":"Et erit: cum evulsero eos, convertar et miserebor eorum et reducam eos, virum ad hereditatem suam et virum in terram suam."
,"16":"Et erit: si eruditi didicerint vias populi mei, ut iurent in nomine meo: 'Vivit Dominus!', sicut docuerunt populum meum iurare in Baal, aedificabuntur in medio populi mei."
,"17":"Quod si non audierint, evellam gentem illam evulsione et perditione ', ait Dominus."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Haec dixit Dominus ad me: ' Vade et posside tibi lumba re lineum et pones illud super lumbos tuos et in aquam non inferes illud '."
,"2":"Et possedi lumbare iuxta verbum Domini et posui circa lumbos meos."
,"3":"Et factus est sermo Domini ad me secundo dicens:"
,"4":"' Tolle lumbare, quod possedisti, quod est circa lumbos tuos, et surgens vade ad Euphraten et absconde ibi illud in foramine petrae '."
,"5":"Et abii et abscondi illud ad Euphraten, sicut praeceperat mihi Dominus."
,"6":"Et factum est, post dies plurimos dixit Dominus ad me: ' Surge, vade ad Euphraten et tolle inde lumbare, quod praecepi tibi, ut absconderes ibi '."
,"7":"Et abii ad Euphraten et fodi et tuli lumbare de loco, ubi absconderam illud; et ecce, computruerat lumbare, ita ut nulli usui aptum esset."
,"8":"Et factum est verbum Domini ad me dicens:"
,"9":"' Haec dicit Dominus: Sic putrescere faciam superbiam Iudae et superbiam Ierusalem multam;"
,"10":"populus iste pessimus - qui nolunt audire verba mea et ambulant in pravitate cordis sui abieruntque post deos alienos, ut servirent eis et adorarent eos - erit sicut lumbare istud, quod nulli usui aptum est."
,"11":"Sicut enim adhaeret lumbare ad lumbos viri, sic agglutinavi mihi omnem domum Israel et omnem domum Iudae, dicit Dominus, ut esset mihi in populum et in nomen et in laudem et in gloriam, et non audierunt."
,"12":"Dices ergo ad eos sermonem istum: Haec dicit Dominus, Deus Israel: Omnis laguncula implebitur vino. Et dicent ad te: 'Numquid ignoramus quia omnis laguncula implebitur vino?'."
,"13":"Et dices ad eos: Haec dicit Dominus: Ecce ego implebo omnes habitatores terrae huius et reges, qui sedent de stirpe David super thronum eius, et sacerdotes et prophetas et omnes habitatores Ierusalem ebrietate;"
,"14":"et collidam eos, virum in fratrem suum et patres et filios pariter, ait Dominus; non parcam et non concedam neque miserebor, ut non disperdam eos '."
,"15":"Audite et auribus percipite; nolite elevari, quia Dominus locutus est."
,"16":"Date Domino Deo vestro gloriam, antequam contenebrescat, et antequam offendant pedes vestri,ad montes caliginosos; exspectabitis lucem, et ponet eam in umbram mortis,et in caliginem."
,"17":"Quod si hoc non audieritis, in abscondito plorabit anima mea,a facie superbiae; plorans plorabit,et deducet oculus meus lacrimam, quia captus est grex Domini."
,"18":"' Dic regi et dominatrici: In humo sedete, quoniam descendit de capite vestro,corona gloriae vestrae."
,"19":"Civitates austri clausae sunt, et non est qui aperiat; translata est omnis Iuda,transmigratione perfecta."
,"20":"Leva oculos tuos et vide,venientes ab aquilone: Ubi est grex, qui datus est tibi, pecus inclitum tuum?"
,"21":"Quid dices, cum visitaverit te?,Tu enim ipsa docuisti eos adversum te, amicos in caput tuum; numquid non dolores apprehendent te,quasi mulierem parturientem?"
,"22":"Quod si dixeris in corde tuo: 'Quare venerunt mihi haec?'. Propter multitudinem iniquitatis tuae,revelatae sunt laciniae tuae, pollutae sunt plantae tuae."
,"23":"Numquid mutare potest Aethiops pellem suam,aut pardus varietates suas?,Tunc et vos poteritis benefacere, cum didiceritis malum."
,"24":"Et disseminabo eos quasi stipulam, quae raptatur in vento deserti."
,"25":"Haec sors tua parsque mensurae tuae a me, dicit Dominus, quia oblita es mei,et confisa es in mendacio."
,"26":"Unde et ego sublevabo lacinias tuas super faciem tuam, et apparebit ignominia tua,"
,"27":"adulteria tua et hinnitus tuus, scelus fornicationis tuae. Super colles in agro vidi abominationes tuas. Vae tibi, Ierusalem! Non mundaberis; usquequo adhuc? '."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Quod factum est verbum Domini ad Ieremiam de sic citate."
,"2":"Luget Iuda, et portae eius languescunt,et contristatae iacent in terra, et clamor Ierusalem ascendit."
,"3":"Maiores eorum miserunt minores suos ad aquam: venerunt ad cisternas, non invenerunt aquam; reportaverunt vasa sua vacua, confusi sunt et afflicti,et operuerunt capita sua."
,"4":"Propter terrae vastitatem, quia non venit pluvia in terram, confusi sunt agricolae, operuerunt capita sua."
,"5":"Nam et cerva in agro peperit et reliquit, quia non erat herba."
,"6":"Et onagri steterunt in collibus, traxerunt aerem quasi thoes; defecerunt oculi eorum, quia non erat herba."
,"7":"' Si iniquitates nostrae testificantur adversus nos, Domine, fac propter nomen tuum, quoniam multae sunt aversiones nostrae, tibi peccavimus."
,"8":"Exspectatio Israel, salvator eius in tempore tribulationis, quare quasi peregrinus es in terra,et quasi viator declinans ad pernoctandum?"
,"9":"Quare es velut vir attonitus, ut fortis, qui non potest salvare?,Tu autem in medio nostri es, Domine, et nomen tuum invocatum est super nos; ne derelinquas nos '."
,"10":"Haec dicit Dominus populo huic: ' Ita diligunt vagari, pedes suos non prohibent et Domino non placent '. Nunc recordatus est iniquitatum eorum et visitat peccata eorum."
,"11":"Et dixit Dominus ad me: ' Noli orare pro populo isto in bonum."
,"12":"Cum ieiunaverint, non exaudiam preces eorum; et, si obtulerint holocautomata et oblationes, non suscipiam ea; quoniam gladio et fame et peste consumam eos '."
,"13":"Et dixi: ' Heu, Domine Deus! Ecce prophetae dicunt eis: 'Non videbitis gladium, et fames non erit in vobis, sed pacem veram dabit vobis in loco isto' '."
,"14":"Et dixit Dominus ad me: ' Falso prophetae vaticinantur in nomine meo: non misi eos et non praecepi eis neque locutus sum ad eos; visionem mendacem et divinationem et fraudulentiam et seductionem cordis sui prophetant vobis."
,"15":"Idcirco haec dicit Dominus contra prophetas, qui prophetant in nomine meo, quos ego non misi, dicentes: 'Gladius et fames non erit in terra hac': In gladio et fame consumentur prophetae illi;"
,"16":"et homines, quibus prophetant, erunt proiecti in viis Ierusalem prae fame et gladio, et non erit qui sepeliat eos: ipsi et uxores eorum, filii et filiae eorum, et effundam super eos malum suum."
,"17":"Et dices ad eos verbum istud: Deducant oculi mei lacrimam,per noctem et diem, et non taceant, quoniam contritione magna contrita est,virgo filia populi mei, plaga pessima vehementer."
,"18":"Si egressus fuero ad agros, ecce occisi gladio; et, si introiero in civitatem, ecce attenuati fame; propheta quoque et sacerdos,abierunt per terram nescientes '."
,"19":"Numquid proiciens abiecisti Iudam, aut Sion abominata est anima tua?,Quare ergo percussisti nos, ita ut nulla sit sanitas?,Exspectavimus pacem, et non est bonum, et tempus curationis, et ecce turbatio."
,"20":"Cognovimus, Domine, impietates nostras, iniquitates patrum nostrorum, quia peccavimus tibi."
,"21":"Ne des nos in opprobrium propter nomen tuum, ne facias contumeliam solio gloriae tuae; recordare, ne irritum facias foedus tuum nobiscum."
,"22":"Numquid sunt in sculptilibus gentium, qui pluant, aut caeli possunt dare imbres?,Nonne tu es Dominus Deus noster, quem exspectamus?,Tu enim fecisti omnia haec."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Et dixit Dominus ad me: ' Si steterit Moyses et Samuel co ram me, non est anima mea ad populum istum; eice illos a facie mea, et egrediantur."
,"2":"Quod si dixerint ad te: 'Quo egrediemur?', dices ad eos: Haec dicit Dominus: Qui ad mortem, ad mortem; et qui ad gladium, ad gladium; et qui ad famem, ad famem; et qui ad captivitatem, ad captivitatem."
,"3":"Et mandabo super eos quattuor species, dicit Dominus: gladium ad occisionem et canes ad lacerandum et volatilia caeli et bestias terrae ad devorandum et dissipandum."
,"4":"Et dabo eos in commotionem universis regnis terrae, propter Manassem filium Ezechiae regem Iudae, super omnibus, quae fecit in Ierusalem."
,"5":"Quis enim miserebitur tui, Ierusalem, aut quis contristabitur pro te, aut quis ibit ad rogandum de pace tua?"
,"6":"Tu reppulisti me, dicit Dominus, retrorsum abiisti; et extendi manum meam super te et interfeci te: laboravi miserans."
,"7":"Et ventilavi eos ventilabro,in portis terrae; orbavi et disperdidi populum meum: a viis suis non sunt reversi."
,"8":"Multiplicatae sunt mihi viduae eius,super arenam maris, induxi eis super matrem,militem vastatorem meridie, misi super eam repente,perturbationem et terrorem."
,"9":"Infirmata est, quae peperit septem, exhalavit animam suam; occidit ei sol, cum adhuc esset dies, confusa est et erubuit, et residuos eorum in gladium dabo,in conspectu inimicorum eorum ', ait Dominus."
,"10":"Vae mihi, mater mea, quoniam genuisti me virum rixae,et virum discordiae in universa terra!,Non feneravi, nec feneravit mihi quisquam; omnes maledicunt mihi."
,"11":"Amen, Domine, ministravi tibi in bonum, intercessi apud te in tempore afflictionis,et in tempore tribulationis pro inimico."
,"12":"Numquid frangitur ferro,ferrum aquilonis et aes?"
,"13":"' Divitias tuas et thesauros tuos,in direptionem dabo gratis, propter omnia peccata tua, in omnibus terminis tuis."
,"14":"Et servire te faciam inimicis tuis,in terra, quam nescis, quia ignis succensus est in furore meo: super vos ardebit '."
,"15":"Tu scis, Domine; recordare mei et visita me,et vindica me de his, qui persequuntur me; noli in patientia tua abripere me, scito quoniam sustinui pro te opprobrium."
,"16":"Inventi sunt sermones tui, et comedi eos, et factum est mihi verbum tuum,in gaudium et in laetitiam cordis mei, quoniam invocatum est nomen tuum super me, Domine, Deus exercituum."
,"17":"Non sedi in concilio ludentium,et gloriatus sum; a facie manus tuae solus sedebam, quoniam indignatione replesti me."
,"18":"Quare factus est dolor meus perpetuus, et plaga mea desperabilis renuit curari?,Factus es mihi quasi rivus mendax, aquae infideles."
,"19":"Propter hoc haec dixit Dominus: ' Si converteris, convertam te, et ante faciem meam stabis; et si separaveris pretiosum a vili, quasi os meum eris; convertentur ipsi ad te, et tu non converteris ad eos."
,"20":"Et dabo te populo huic,in murum aereum fortem; et bellabunt adversum te,et non praevalebunt, quia ego tecum sum, ut salvem te et eruam te, dicit Dominus."
,"21":"Et liberabo te de manu pessimorum,et redimam te de manu fortium '."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Et factum est verbum Domi ni ad me dicens:"
,"2":"' Non acci pies uxorem, et non erunt tibi filii et filiae in loco isto."
,"3":"Quia haec dicit Dominus super filios et filias, qui generantur in loco isto, et super matres eorum, quae genuerunt eos, et super patres eorum, de quorum stirpe sunt nati in terra hac:"
,"4":"Mortibus aegrotationum morientur, non plangentur et non sepelientur; in sterquilinium super faciem terrae erunt et gladio et fame consumentur, et erit cadaver eorum in escam volatilibus caeli et bestiis terrae '."
,"5":"Haec enim dixit Dominus: 'Ne ingrediaris domum convivii neque vadas ad plangendum neque lugebis eos, quia abstuli pacem meam a populo isto, dicit Dominus, misericordiam et miserationes."
,"6":"Et morientur grandes et parvi in terra ista, non sepelientur neque plangentur, et non se incident, neque calvitium fiet pro eis."
,"7":"Et non frangent lugenti panem ad consolandum super mortuo et non dabunt ei calicem ad consolandum super patre suo et matre."
,"8":"Et domum convivii non ingredieris, ut sedeas cum eis et comedas et bibas."
,"9":"Quia haec dicit Dominus exercituum, Deus Israel: Ecce ego auferam de loco isto in oculis vestris et in diebus vestris vocem gaudii et vocem laetitiae, vocem sponsi et vocem sponsae."
,"10":"Et cum annuntiaveris populo huic omnia verba haec, et dixerint tibi: 'Quare locutus est Dominus super nos omne malum grande istud? Quae iniquitas nostra et quod peccatum nostrum, quod peccavimus Domino Deo nostro?',"
,"11":"dices ad eos: Quia dereliquerunt me patres vestri, ait Dominus, et abierunt post deos alienos et servierunt eis et adoraverunt eos et me dereliquerunt et legem meam non custodierunt."
,"12":"Sed et vos peius operati estis quam patres vestri: ecce enim ambulat unusquisque post pravitatem cordis sui mali, ut me non audiat."
,"13":"Et eiciam vos de terra hac in terram, quam ignoratis, vos et patres vestri; et servietis ibi diis alienis, die ac nocte, quia non dabo vobis gratiam."
,"14":"Propterea ecce dies veniunt, dicit Dominus, et non dicetur ultra: 'Vivit Dominus, qui eduxit filios Israel de terra Aegypti!',"
,"15":"sed: 'Vivit Dominus, qui eduxit filios Israel de terra aquilonis et de universis terris, ad quas eieci eos!'. Et reducam eos in terram suam, quam dedi patribus eorum."
,"16":"Ecce ego mittam piscatores multos, dicit Dominus, et piscabuntur eos; et post haec mittam eis multos venatores, et venabuntur eos de omni monte et de omni colle et de cavernis petrarum."
,"17":"Quia oculi mei super omnes vias eorum: non sunt absconditae a facie mea, et non est occulta iniquitas eorum ab oculis meis."
,"18":"Et reddam primum dupliciter iniquitates et peccata eorum, quia contaminaverunt terram meam in morticinis idolorum suorum et abominationibus suis impleverunt hereditatem meam '."
,"19":"Domine, fortitudo mea et praesidium meum,et refugium meum in die tribulationis; ad te gentes venient ab extremis terrae et dicent: ' Vere mendacium possederunt patres nostri, vanitatem, quae nihil prodest '."
,"20":"Numquid faciet sibi homo deos, et ipsi non sunt dii?"
,"21":"' Idcirco ecce ego ostendam eis per vicem hanc, ostendam eis manum meam et virtutem meam, et scient quia nomen mihi Dominus '."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Peccatum Iudae scriptum est stilo ferreo, in ungue adamantino exaratum,super tabulam cordis eorum,et in cornibus ararum eorum,"
,"2":"ut recordarentur filii eorum ararum suarum,et palorum suorum iuxta ligna frondentia,in collibus excelsis,"
,"3":"montibus in campo. ' Divitias tuas, omnes thesauros tuos,in direptionem dabo, excelsa tua propter peccata,in universis finibus tuis."
,"4":"Et relinques hereditatem tuam, quam dedi tibi; et servire te faciam inimicis tuis,in terra, quam ignoras, quoniam ignem succendistis in naribus meis; usque in aeternum ardebit '."
,"5":"Haec dicit Dominus: ' Maledictus homo, qui confidit in homine,et ponit carnem brachium suum, et a Domino recedit cor eius;"
,"6":"erit enim quasi myricae in deserto,et non videbit, cum venerit bonum, sed habitabit in siccitate in deserto, in terra salsuginis et inhabitabili."
,"7":"Benedictus vir, qui confidit in Domino, et erit Dominus fiducia eius;"
,"8":"et erit quasi lignum, quod transplantatur super aquas, quod ad humorem mittit radices suas,et non timebit, cum venerit aestus; et erit folium eius viride, et in anno siccitatis non erit sollicitum,nec aliquando desinet facere fructum"
,"9":"Dolosum est cor super omnia et insanabile; quis cognoscet illud?"
,"10":"Ego Dominus scrutans cor et probans renes, qui do unicuique iuxta viam suam,et iuxta fructum operum suorum."
,"11":"Perdix fovit, quae non peperit, ita faciens divitias sed non in iudicio. In dimidio dierum suorum derelinquet eas,et in novissimo suo erit insipiens '."
,"12":"Solium gloriae, altitudo a principio, locus sanctificationis nostrae!"
,"13":"Exspectatio Israel, Domine, omnes, qui te derelinquunt, confundentur; recedentes a te in terra scribentur, quoniam dereliquerunt venam,aquarum viventium, Dominum."
,"14":"Sana me, Domine, et sanabor; salvum me fac, et salvus ero, quoniam laus mea tu es."
,"15":"Ecce ipsi dicunt ad me: ' Ubi est verbum Domini? Veniat '."
,"16":"Et ego non institi pro malo apud te,et diem calamitatis non desideravi, tu scis: quod egressum est de labiis meis, rectum in conspectu tuo fuit."
,"17":"Non sis mihi tu formidini; refugium meum tu in die afflictionis."
,"18":"Confundantur, qui me persequuntur, et non confundar ego; paveant illi, et non paveam ego; induc super eos diem afflictionis,et duplici contritione contere eos."
,"19":"Haec dixit Dominus ad me: ' Vade et sta in porta Filiorum populi, per quam ingrediuntur reges Iudae et egrediuntur, et in cunctis portis Ierusalem;"
,"20":"et dices ad eos: Audite verbum Domini, reges Iudae et omnis Iuda cunctique habitatores Ierusalem, qui ingredimini per portas istas."
,"21":"Haec dicit Dominus: Custodite animas vestras et nolite portare pondera in die sabbati nec inferatis per portas Ierusalem;"
,"22":"et nolite efferre onera de domibus vestris in die sabbati et omne opus non facietis: sanctificate diem sabbati, sicut praecepi patribus vestris."
,"23":"Et non audierunt nec inclinaverunt aurem suam; sed induraverunt cervicem suam, ne audirent me et ne acciperent disciplinam."
,"24":"Et erit: si audieritis me, dicit Dominus, ut non inferatis onera per portas civitatis huius in die sabbati, et si sanctificaveritis diem sabbati, ne faciatis in eo omne opus,"
,"25":"ingredientur per portas civitatis huius reges et principes sedentes super solium David et ascendentes in curribus et equis, ipsi et principes eorum, viri Iudae et habitatores Ierusalem; et habitabitur civitas haec in sempiternum."
,"26":"Et venient de civitatibus Iudae et de circuitu Ierusalem et de terra Beniamin et de Sephela et de montuosis et a Nageb, portantes holocaustum et victimam et sacrificium et tus, et inferent oblationem laudis in domum Domini."
,"27":"Si autem non audieritis me, ut sanctificetis diem sabbati et ne portetis onus intrantes per portas Ierusalem in die sabbati, succendam ignem in portis eius, et devorabit domos Ierusalem et non exstinguetur '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Verbum, quod factum est ad Ieremiam a Domino dicens:"
,"2":"' Surge et descende in domum figuli et ibi audies verba mea '."
,"3":"Et descendi in domum figuli, et ecce ipse faciebat opus super rotam;"
,"4":"et dissipatum est vas, quod ipse faciebat e luto manibus suis, et rursus fecit illud vas alterum, sicut placuerat in oculis eius, ut faceret."
,"5":"Et factum est verbum Domini ad me dicens:"
,"6":"' Numquid sicut figulus iste non potero vobis facere, domus Israel?, ait Dominus. Ecce, sicut lutum in manu figuli, sic vos in manu mea, domus Israel."
,"7":"Repente loquar adversum gentem et adversum regnum, ut eradicem et destruam et disperdam illud;"
,"8":"si paenitentiam egerit gens illa a malo suo, propter quod locutus sum adversus eam, agam et ego paenitentiam super malo, quod cogitavi ut facerem ei."
,"9":"Et subito loquar de gente et de regno, ut aedificem et plantem illud;"
,"10":"si fecerit malum in oculis meis, ut non audiat vocem meam, paenitentiam agam super bono, quod locutus sum ut facerem ei."
,"11":"Nunc ergo, dic viro Iudae et habitatoribus Ierusalem dicens: Haec dicit Dominus: Ecce ego fingo contra vos malum et cogito contra vos cogitationem; revertatur unusquisque a via sua mala, et dirigite vias vestras et opera vestra '."
,"12":"Qui dixerunt: ' Vanum est; post cogitationes enim nostras ibimus et unusquisque pravitatem cordis sui mali faciemus '."
,"13":"Ideo haec dicit Dominus: ' Interrogate gentes: quis audivit talia horribilia, quae fecit nimis virgo Israel?"
,"14":"Numquid deficiet de petra agri,nix Libani, aut arescent aquae erumpentes,frigidae et defluentes?"
,"15":"Quia oblitus est mei populus meus, vanitati sacrificantes,et impingentes in viis suis, in semitis antiquis, ut ambularent per calles,in itinere non trito,"
,"16":"ut poneret terram eorum in desolationem,et in sibilum sempiternum: omnis, qui praeterierit per eam, obstupescet,et movebit caput suum."
,"17":"Sicut ventus urens dispergam eos,coram inimico; dorsum et non faciem ostendam eis in die perditionis eorum '."
,"18":"Et dixerunt: ' Venite, et cogitemus contra Ieremiam cogitationes; non enim peribit lex a sacerdote, neque consilium a sapiente, nec sermo a propheta. Venite, et percutiamus eum lingua et non attendamus ad universos sermones eius '."
,"19":"Attende, Domine, ad me,et audi vocem adversariorum meorum."
,"20":"Numquid redditur pro bono malum, quia foderunt foveam animae meae?,Recordare quod steterim in conspectu tuo, ut loquerer pro eis bonum,et averterem indignationem tuam ab eis."
,"21":"Propterea da filios eorum in famem,et deduc eos in manus gladii; fiant uxores eorum absque liberis et viduae, et viri eorum interficiantur morte, iuvenes eorum confodiantur gladio in proelio."
,"22":"Audiatur clamor de domibus eorum; adduces enim super eos latronem repente, quia foderunt foveam, ut caperent me, et laqueos absconderunt pedibus meis."
,"23":"Tu autem, Domine, scis omne consilium eorum,adversum me in mortem; ne propitieris iniquitati eorum, et peccatum eorum a facie tua non deleatur. Fiant corruentes in conspectu tuo; in tempore furoris tui abutere eis."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Haec dicit Dominus: ' Vade et eme lagunculam figuli testeam et accipe de senioribus populi et de senioribus sacerdotum"
,"2":"et egredere ad vallem Benennom, quae est iuxta introitum portae Fictilium, et praedicabis ibi verba, quae ego loquar ad te,"
,"3":"et dices: Audite verbum Domini, reges Iudae et habitatores Ierusalem: Haec dicit Dominus exercituum, Deus Israel: Ecce ego inducam afflictionem super locum istum, ita ut omnis, qui audierit illam, tinniant aures eius,"
,"4":"eo quod dereliquerint me et alienum fecerint locum istum et sacrificaverint in eo diis alienis, quos nescierunt ipsi et patres eorum et reges Iudae; et repleverunt locum istum sanguine innocentium;"
,"5":"et aedificaverunt excelsa Baal ad comburendos filios suos igne in holocaustum Baal: quae non praecepi nec locutus sum, nec ascenderunt in cor meum."
,"6":"Propterea ecce dies veniunt, dicit Dominus, et non vocabitur amplius locus iste Topheth et vallis Benennom sed vallis Occisionis."
,"7":"Et dissipabo consilium Iudae et Ierusalem in loco isto; et subvertam eos gladio in conspectu inimicorum suorum et in manu quaerentium animas eorum et dabo cadavera eorum escam volatilibus caeli et bestiis terrae."
,"8":"Et ponam civitatem hanc in stuporem et in sibilum; omnis, qui praeterierit per eam, obstupescet et sibilabit super universa plaga eius."
,"9":"Et cibabo eos carnibus filiorum suorum et carnibus filiarum suarum; et unusquisque carnem amici sui comedet in obsidione et in angustia, in qua concludent eos inimici eorum et qui quaerunt animas eorum."
,"10":"Et conteres lagunculam in oculis virorum, qui ibunt tecum,"
,"11":"et dices ad eos: Haec dicit Dominus exercituum: Sic conteram populum istum et civitatem istam, sicut conteritur vas figuli, quod non potest ultra instaurari; et in Topheth sepelientur, eo quod non sit alius locus ad sepeliendum."
,"12":"Sic faciam loco huic, ait Dominus, et habitatoribus eius, ut ponam civitatem istam sicut Topheth;"
,"13":"et erunt domus Ierusalem et domus regum Iudae sicut locus Topheth, immundae: omnes domus, in quarum domatibus sacrificaverunt omni militiae caeli et libaverunt libamina diis alienis '."
,"14":"Venit autem Ieremias de Topheth, quo miserat eum Dominus ad prophetandum, et stetit in atrio domus Domini et dixit ad omnem populum:"
,"15":"' Haec dicit Dominus exercituum, Deus Israel: Ecce ego inducam super civitatem hanc et super omnes urbes eius universa mala, quae locutus sum adversum eam, quoniam induraverunt cervicem suam, ut non audirent sermones meos '."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Et audivit Phassur filius Em mer sacerdos, qui constitutus erat princeps in domo Domini, Ieremiam prophetantem sermones istos;"
,"2":"et percussit Phassur Ieremiam prophetam et misit eum in nervum, quod erat in porta Beniamin superiore in domo Domini."
,"3":"Cumque illuxisset in crastinum, eduxit Phassur Ieremiam de nervo; et dixit ad eum Ieremias: ' Non Phassur vocavit Dominus nomen tuum sed Pavorem undique."
,"4":"Quia haec dicit Dominus: Ecce ego dabo te in pavorem, te et omnes amicos tuos, et corruent gladio inimicorum suorum, et oculi tui videbunt; et omnem Iudam dabo in manu regis Babylonis, et traducet eos in Babylonem et percutiet eos gladio."
,"5":"Et dabo universam substantiam civitatis huius et omnem laborem eius omneque pretium et cunctos thesauros regum Iudae dabo in manu inimicorum eorum; et diripient eos et tollent et ducent in Babylonem."
,"6":"Tu autem, Phassur et omnes habitatores domus tuae, ibitis in captivitatem; et in Babylonem venies et ibi morieris ibique sepelieris, tu et omnes amici tui, quibus prophetasti mendacium '."
,"7":"Seduxisti me, Domine, et seductus sum; fortior me fuisti et invaluisti. Factus sum in derisum tota die, omnes subsannant me."
,"8":"Quia quotiescumque loquor, vociferor, iniquitatem et vastitatem clamito; et factus est mihi sermo Domini,in opprobrium et in derisum tota die."
,"9":"Et dixi: ' Non recordabor eius,neque loquar ultra in nomine illius '. Et factus est in corde meo quasi ignis exaestuans,claususque in ossibus meis: et defeci, ferre non sustinens."
,"10":"Audivi enim contumelias multorum,et terrorem in circuitu: ' Denuntiate, et denuntiemus eum '. Omnes pacifici mei observabant lapsum meum: ' Forte decipietur, et praevalebimus adversus eum,et consequemur ultionem ex eo '."
,"11":"Dominus autem mecum est quasi bellator fortis; idcirco, qui persequuntur me, cadent et infirmi erunt. Confundentur vehementer, quia non prosperati sunt; opprobrium sempiternum, quod numquam delebitur."
,"12":"Et tu, Domine exercituum, probator iusti, qui vides renes et cor, videam, quaeso, ultionem tuam ex eis; tibi enim revelavi causam meam."
,"13":"Cantate Domino, laudate Dominum, quia liberavit animam pauperis,de manu malorum."
,"14":"Maledicta dies, in qua natus sum; dies, in qua peperit me mater mea, non sit benedicta."
,"15":"Maledictus vir, qui annuntiavit patri meo,dicens: ' Natus est tibi puer masculus ',et gaudio laetificavit eum;"
,"16":"sit homo ille, ut sunt civitates, quas subvertit Dominus,et non paenituit eum: audiat clamorem mane,et ululatum in tempore meridiano, "
,"17":"qui non me interfecit a vulva, ut fieret mihi mater mea sepulcrum, et vulva eius conceptus aeternus."
,"18":"Quare de vulva egressus sum, ut viderem laborem et dolorem, et consumerentur in confusione dies mei?"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Verbum, quod factum est ad Ieremiam a Domino, quando misit ad eum rex Sedecias Phassur filium Melchiae et Sophoniam filium Maasiae sacerdotem dicens:"
,"2":"' Interroga pro nobis Dominum, quia Nabuchodonosor rex Babylonis proeliatur adversum nos; si forte faciat Dominus nobiscum secundum omnia mirabilia sua, et recedat a nobis '."
,"3":"Et dixit Ieremias ad eos: ' Sic dicetis Sedeciae:"
,"4":"Haec dicit Dominus, Deus Israel: Ecce ego convertam vasa belli, quae in manibus vestris sunt et quibus vos pugnatis adversum regem Babylonis et Chaldaeos, qui obsident vos in circuitu murorum; et congregabo eos in medio civitatis huius."
,"5":"Et debellabo ego vos in manu extenta et in brachio forti et in furore et in indignatione et in ira grandi"
,"6":"et percutiam habitatores civitatis huius, homines et bestias: pestilentia magna morientur."
,"7":"Et post haec, ait Dominus, dabo Sedeciam regem Iudae et servos eius et populum eius, qui derelicti sunt in civitate hac a peste et gladio et fame, in manu Nabuchodonosor regis Babylonis et in manu inimicorum eorum et in manu quaerentium animam eorum; et percutiet eos in ore gladii et non flectetur neque parcet nec miserebitur."
,"8":"Et ad populum hunc dices: Haec dicit Dominus: Ecce ego do coram vobis viam vitae et viam mortis:"
,"9":"qui habitaverit in urbe hac, morietur gladio et fame et peste; qui autem egressus fuerit et transfugerit ad Chaldaeos, qui obsident vos, vivet, et erit ei anima sua quasi spolium."
,"10":"Posui enim faciem meam super civitatem hanc in malum et non in bonum, ait Dominus: in manu regis Babylonis dabitur, et exuret eam igni."
,"11":"Et domui regis Iudae: Audite verbum Domini,"
,"12":"domus David. Haec dicit Dominus: Iudicate mane iudicium,et eruite vi oppressum de manu expoliantis, ne forte egrediatur ut ignis indignatio mea,et succendatur, et non sit qui exstinguat, propter malitiam operum vestrorum."
,"13":"Ecce ego ad te, habitatricem vallis, petram in planitie, ait Dominus; qui dicitis: 'Quis invadet nos?,Et quis ingredietur domos nostras?'."
,"14":"Et visitabo super vos iuxta fructum operum vestrorum, dicit Dominus; et succendam ignem in saltu eius, et devorabit omnia in circuitu eius '."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Haec dicit Dominus: ' Descende in domum regis Iudae et loqueris ibi verbum hoc"
,"2":"et dices: Audi verbum Domini, rex Iudae, qui sedes super solium David, tu et servi tui et populus tuus, qui ingredimini per portas istas."
,"3":"Haec dicit Dominus: Facite iudicium et iustitiam et liberate vi oppressum de manu expoliantis et advenam et pupillum et viduam nolite affligere neque opprimatis inique et sanguinem innocentem ne effundatis in loco isto."
,"4":"Si enim facientes feceritis verbum istud, ingredientur per portas domus huius reges, sedentes de genere David super thronum eius et ascendentes currus et equos, ipsi et servi et populus eorum."
,"5":"Quod si non audieritis verba haec, in memetipso iuravi, dicit Dominus, quia in solitudinem erit domus haec."
,"6":"Quia haec dicit Dominus super domum regis Iudae: Galaad tu mihi, caput Libani, verumtamen ponam te solitudinem, urbes inhabitabiles,"
,"7":"et sanctificabo super te,interficientem virum et arma eius, et succident electas cedros tuas,et praecipitabunt in ignem."
,"8":"Et pertransibunt gentes multae per civitatem hanc, et dicet unusquisque proximo suo: 'Quare fecit Dominus sic civitati huic grandi?'."
,"9":"Et respondebunt: 'Eo quod dereliquerint pactum Domini Dei sui et adoraverint deos alienos et servierint eis' '."
,"10":"Nolite flere mortuum,neque lugeatis super eum fletu; plangite eum, qui egreditur, quia non revertetur ultra,nec videbit terram nativitatis suae."
,"11":"Quia haec dicit Dominus ad Sellum filium Iosiae regem Iudae, qui regnavit pro Iosia patre suo: ' Qui egressus est de loco isto, non revertetur huc amplius,"
,"12":"sed in loco, ad quem transtulerunt eum, ibi morietur et terram istam non videbit amplius '."
,"13":"Vae, qui aedificat domum suam in iniustitia,et cenacula sua non in iudicio, proximum suum servire facit gratis,et mercedem eius non reddet ei;"
,"14":"qui dicit: ' Aedificabo mihi domum latam,et cenacula spatiosa '; qui aperit sibi fenestras,et facit laquearia cedrina,pingitque sinopide!"
,"15":"Numquid regnabis, quoniam gloriaris in cedris?,Pater tuus numquid non comedit et bibit?,Sed fecit iudicium et iustitiam, tunc bene erat ei."
,"16":"Iudicavit causam pauperis et egeni, tunc bene. ' Numquid non hoc est nosse me? ', dicit Dominus."
,"17":"Tui vero oculi et cor tuum nonnisi ad avaritiam,et ad sanguinem innocentem fundendum,et ad calumniam et ad oppressionem faciendam."
,"18":"Propterea haec dicit Dominus ad Ioachim filium Iosiae regem Iudae: ' Non plangent eum: 'Vae, frater meus!' et 'Vae, soror!'. Non concrepabunt ei: 'Vae, domine!' et 'Vae, inclite!'."
,"19":"Sepultura asini sepelietur, tractus et proiectus longe,extra portas Ierusalem '."
,"20":"Ascende Libanum et clama,et in Basan da vocem tuam,et clama de Abarim, quia contriti sunt omnes amatores tui."
,"21":"Locutus sum ad te in securitate tua, et dixisti: ' Non audiam! '. Haec est via tua ab adulescentia tua, quia non audisti vocem meam."
,"22":"Omnes pastores tuos pascet ventus, et amatores tui in captivitatem ibunt, quia tunc confunderis et erubesces,ab omni malitia tua."
,"23":"Quae sedes in Libano,et nidificas in cedris, quomodo congemisces, cum venerint tibi dolores,quasi dolores parturientis!"
,"24":"' Vivo ego, dicit Dominus, quia si fuerit Iechonias, filius Ioachim rex Iudae, anulus in manu dextera mea, inde evellam eum"
,"25":"et dabo te in manu quaerentium animam tuam et in manu, quorum tu formidas faciem, in manu Nabuchodonosor, regis Babylonis, et in manu Chaldaeorum;"
,"26":"et mittam te et matrem tuam, quae genuit te, in terram alienam, in qua nati non estis, ibique moriemini;"
,"27":"et in terram, ad quam ipsi levant animam suam, ut revertantur, illuc non revertentur '."
,"28":"Numquid vas despectum et contritum, vir iste Iechonias? Numquid vas absque omni voluptate? Quare abiecti sunt, ipse et semen eius, et proiecti in terram, quam ignoraverunt?"
,"29":"Terra, terra, terra, audi sermonem Domini!"
,"30":"Haec dicit Dominus: ' Scribite virum istum sterilem, virum, qui in diebus suis non prosperabitur; nec enim erit de semine eius vir, qui sedeat super solium David et potestatem habeat ultra in Iuda '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"'Vae pastoribus, qui disper dunt et dissipant gregem pascuae meae!, dicit Dominus."
,"2":"Ideo haec dicit Dominus, Deus Israel, ad pastores, qui pascunt populum meum: Vos dissipastis gregem meum et eiecistis eos et non visitastis eos; ecce ego visitabo super vos malitiam operum vestrorum, ait Dominus."
,"3":"Et ego congregabo reliquias gregis mei de omnibus terris, ad quas eiecero eos, et convertam eos ad rura sua, et crescent et multiplicabuntur."
,"4":"Et suscitabo super eos pastores, et pascent eos; non formidabunt ultra et non pavebunt, et nullus quaeretur ex numero, dicit Dominus."
,"5":"Ecce dies veniunt, dicit Dominus, et suscitabo David germen iustum; et regnabit rex et sapiens erit,et faciet iudicium et iustitiam in terra."
,"6":"In diebus illis salvabitur Iuda, et Israel habitabit confidenter; et hoc est nomen, quod vocabunt eum: Dominus iustitia nostra."
,"7":"Propter hoc ecce dies veniunt, dicit Dominus, et non dicent ultra: 'Vivit Dominus, qui eduxit filios Israel de terra Aegypti!',"
,"8":"sed: 'Vivit Dominus, qui eduxit et adduxit semen domus Israel de terra aquilonis et de cunctis terris!', ad quas eieceram eos; et habitabunt in terra sua '."
,"9":"Ad prophetas. Contritum est cor meum in medio mei, contremuerunt omnia ossa mea; factus sum quasi vir ebrius,et quasi homo madidus a vino, a facie Domini,et a facie verborum sanctorum eius;"
,"10":"quia adulteris repleta est terra, quia a facie maledictionis luxit terra, arefacta sunt arva deserti, factus est cursus eorum malus, et fortitudo eorum iniustitia."
,"11":"' Propheta namque et sacerdos polluti sunt, et in domo mea inveni malum eorum, ait Dominus."
,"12":"Idcirco via eorum erit quasi lubricum; in tenebras proicientur et cadent in eis; afferam enim super eos mala, annum visitationis eorum, ait Dominus."
,"13":"Et in prophetis Samariae vidi fatuitatem: prophetabant in Baal,et decipiebant populum meum Israel."
,"14":"Et in prophetis Ierusalem vidi horribilia: adulterium faciunt et in mendacio ambulant; et confortaverunt manus pessimorum, ut non converteretur unusquisque a malitia sua: facti sunt mihi omnes ut Sodoma, et habitatores eius quasi Gomorra '."
,"15":"Propterea haec dicit Dominus exercituum ad prophetas: ' Ecce ego cibabo eos absinthio,et potabo eos felle; a prophetis enim Ierusalem,egressa est pollutio super omnem terram."
,"16":"Haec dicit Dominus exercituum: Nolite audire verba prophetarum, qui prophetant vobis et decipiunt vos; visionem cordis sui loquuntur, non de ore Domini."
,"17":"Dicunt his, qui despiciunt me: 'Locutus est Dominus: Pax erit vobis'; et omni, qui ambulat in pravitate cordis sui, dixerunt: 'Non veniet super vos malum'."
,"18":"Quis enim affuit in consilio Domini et vidit et audivit sermonem eius? Quis consideravit verbum illius et audivit?"
,"19":"Ecce turbo Domini, indignatio egressa est, et tempestas erumpens super caput impiorum irruet."
,"20":"Non cessabit furor Domini, usque dum faciat,et usque dum compleat cogitationes cordis sui; in novissimis diebus intellegetis consilium eius."
,"21":"Non mittebam prophetas, et ipsi currebant; non loquebar ad eos, et ipsi prophetabant."
,"22":"Si stetissent in consilio meo, nota fecissent verba mea populo meo,et avertissent utique eos a via sua mala,et ab operibus suis pessimis."
,"23":"Putasne Deus e vicino ego sum, dicit Dominus, et non Deus de longe?"
,"24":"Si occultabitur vir in absconditis, ego non videbo eum?, dicit Dominus. Numquid non caelum et terram ego impleo?, dicit Dominus."
,"25":"Audivi, quae dixerunt prophetae prophetantes in nomine meo mendacium atque dicentes: 'Somniavi, somniavi'."
,"26":"Usquequo istud est in corde prophetarum vaticinantium mendacium et prophetantium seductionem cordis sui?"
,"27":"Qui volunt facere, ut obliviscatur populus meus nominis mei, propter somnia eorum, quae narrat unusquisque ad proximum suum, sicut obliti sunt patres eorum nominis mei propter Baal."
,"28":"Propheta, qui habet somnium, narret somnium et, qui habet sermonem meum, loquatur sermonem meum vere. Quid paleis ad triticum?, dicit Dominus."
,"29":"Numquid non verba mea sunt quasi ignis, dicit Dominus, et quasi malleus conterens petram? "
,"30":"Propterea ecce ego ad prophetas, ait Dominus, qui furantur verba mea unusquisque a proximo suo."
,"31":"Ecce ego ad prophetas, ait Dominus, qui assumunt linguas suas et aiunt: 'Dicit Dominus'."
,"32":"Ecce ego ad prophetantes somnia mendacii, ait Dominus, qui narraverunt ea et seduxerunt populum meum in mendaciis suis et in iactantia sua, cum ego non misissem eos nec mandassem eis; qui nihil profuerunt populo huic, dicit Dominus."
,"33":"Si interrogaverit te populus iste vel propheta aut sacerdos dicens: 'Quod est onus Domini', dices ad eos: Vos estis onus; proiciam quippe vos, dicit Dominus."
,"34":"Et propheta et sacerdos et populus, qui dicit: 'Onus Domini', visitabo super virum illum et super domum eius."
,"35":"Haec dicetis unusquisque ad proximum et ad fratrem suum: 'Quid respondit Dominus?' et 'Quid locutus est Dominus?'."
,"36":"Sed 'Onus Domini' ultra non memorabitis, quia onus erit unicuique sermo suus, et pervertitis verba Dei viventis, Domini exercituum, Dei nostri."
,"37":"Haec dices ad prophetam: 'Quid respondit tibi Dominus?' et 'Quid locutus est Dominus?'."
,"38":"Si autem 'Onus Domini' dixeritis, propter hoc haec dicit Dominus: Quia dixistis sermonem istum: 'Onus Domini', et misi ad vos dicens: Nolite dicere: 'Onus Domini';"
,"39":"propterea, ecce ego tollam vos portans et proiciam vos et civitatem, quam dedi vobis et patribus vestris, a facie mea;"
,"40":"et dabo vos in opprobrium sempiternum et in ignominiam aeternam, quae numquam oblivione delebitur '."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Ostendit mihi Dominus, et ecce duo calathi pleni ficis positi ante templum Domini, postquam transtulit Nabuchodonosor rex Babylonis Iechoniam filium Ioachim regem Iudae et principes eius et fabrum et inclusorem de Ierusalem et adduxit eos in Babylonem."
,"2":"Calathus unus ficus bonas habebat nimis, ut solent ficus esse primi temporis; et calathus unus ficus habebat malas nimis, quae comedi non poterant, eo quod essent malae."
,"3":"Et dixit Dominus ad me: ' Quid tu vides, Ieremia? '. Et dixi: ' Ficus, ficus bonas, bonas valde, et malas, malas valde, quae comedi non possunt, eo quod sint malae '."
,"4":"Et factum est verbum Domini ad me dicens:"
,"5":"' Haec dicit Dominus, Deus Israel: Sicut ficus hae bonae, sic cognoscam transmigrationem Iudae, quam emisi de loco isto in terram Chaldaeorum, in bonum."
,"6":"Et ponam oculos meos super eos ad placandum et reducam eos in terram hanc et aedificabo eos et non destruam et plantabo eos et non evellam."
,"7":"Et dabo eis cor, ut sciant me quia ego sum Dominus; et erunt mihi in populum, et ego ero eis in Deum, quia revertentur ad me in toto corde suo."
,"8":"Et sicut ficus pessimae, quae comedi non possunt, eo quod sint malae, haec dicit Dominus, sic dabo Sedeciam regem Iudae et principes eius et reliquos de Ierusalem, qui remanserunt in terra hac et qui habitant in terra Aegypti."
,"9":"Et dabo eos in vexationem afflictionemque omnibus regnis terrae, in opprobrium et in proverbium et in derisum et in maledictionem in universis locis, ad quae eieci eos."
,"10":"Et mittam in eis gladium et famem et pestem, donec consumantur de terra, quam dedi eis et patribus eorum '."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Verbum, quod factum est ad Ieremiam de omni populo Iudae in anno quarto Ioachim filii Iosiae regis Iudae - ipse est annus primus Nabuchodonosor regis Babylonis -"
,"2":"quod locutus est Ieremias propheta ad omnem populum Iudae et ad universos habitatores Ierusalem dicens:"
,"3":"' A tertio decimo anno Iosiae filii Amon regis Iudae usque ad diem hanc, iste tertius et vicesimus est annus, factum est verbum Domini ad me, et locutus sum ad vos de nocte consurgens et loquens, et non audistis."
,"4":"Et misit Dominus ad vos omnes servos suos prophetas, consurgens diluculo mittensque; et non audistis neque inclinastis aures vestras, ut audiretis,"
,"5":"cum diceret: 'Revertimini unusquisque a via sua mala et a pessimis cogitationibus vestris, et habitabitis in terra, quam dedit Dominus vobis et patribus vestris, a saeculo et usque in saeculum;"
,"6":"et nolite ire post deos alienos, ut serviatis eis adoretisque eos, neque me ad iracundiam provocetis in operibus manuum vestrarum, et non affligam vos."
,"7":"Et non audistis me, dicit Dominus, ut me ad iracundiam provocaretis in operibus manuum vestrarum, in malum vestrum'."
,"8":"Propterea haec dicit Dominus exercituum: Pro eo quod non audistis verba mea,"
,"9":"ecce ego mittam et assumam universas cognationes aquilonis, ait Dominus, et Nabuchodonosor regem Babylonis, servum meum, et adducam eos super terram istam et super habitatores eius et super omnes nationes, quae in circuitu illius sunt; et interficiam eos et ponam eos in stuporem et in sibilum et in ruinas sempiternas."
,"10":"Perdamque ex eis vocem gaudii et vocem laetitiae, vocem sponsi et vocem sponsae, vocem molae et lumen lucernae,"
,"11":"et erit universa terra haec in solitudinem et in stuporem, et servient omnes gentes istae regi Babylonis septuaginta annis."
,"12":"Cumque impleti fuerint septuaginta anni, visitabo super regem Babylonis et super gentem illam, dicit Dominus, iniquitatem eorum et super terram Chaldaeorum; et ponam illam in solitudines sempiternas."
,"13":"Et adducam super terram illam omnia verba mea, quae locutus sum contra eam, omne, quod scriptum est in libro isto, quaecumque prophetavit Ieremias adversum omnes gentes."
,"14":"Quia servient eis etiam illi, gentes multae et reges magni, et reddam eis secundum opera eorum et secundum facta manuum suarum '."
,"15":"Quia sic dicit Dominus, Deus Israel, ad me: ' Sume calicem vini furoris huius de manu mea et propinabis de illo cunctis gentibus, ad quas ego mittam te; 16 et bibent et turbabuntur et insanient a facie gladii, quem ego mittam inter eos '."
,"17":"Et accepi calicem de manu Domini et propinavi cunctis gentibus, ad quas misit me Dominus,"
,"18":"Ierusalem et civitatibus Iudae et regibus eius et principibus eius, ut darem eos in solitudinem et in stuporem, in sibilum et in maledictionem, sicut est dies ista;"
,"19":"pharaoni regi Aegypti et servis eius et principibus eius et omni populo eius;"
,"20":"et omni vulgo promiscuo et cunctis regibus terrae Us et cunctis regibus terrae Philisthim et Ascaloni et Gazae et Accaroni et reliquiis Azoti,"
,"21":"Edom et Moab et filiis Ammon;"
,"22":"et cunctis regibus Tyri et universis regibus Sidonis et regibus terrae insularum, qui sunt trans mare;"
,"23":"et Dedan et Thema et Buz et universis, qui attonsi sunt in comam;"
,"24":"et cunctis regibus Arabiae et cunctis regibus vulgi promiscui, qui habitant in deserto,"
,"25":"et cunctis regibus Zimri et cunctis regibus Elam et cunctis regibus Medorum,"
,"26":"cunctis quoque regibus aquilonis de prope et de longe, unicuique post fratrem suum et omnibus regnis terrae, quae super faciem eius sunt; et rex Sesach bibet post eos."
,"27":"' Et dices ad eos: Haec dicit Dominus exercituum, Deus Israel: Bibite et inebriamini et vomite; et cadite neque surgatis a facie gladii, quem ego mittam inter vos."
,"28":"Cumque noluerint accipere calicem de manu tua, ut bibant, dices ad eos: Haec dicit Dominus exercituum: Bibentes bibetis;"
,"29":"quia ecce in civitate, super quam invocatum est nomen meum, ego incipio affligere, et vos immunes eritis? Non eritis immunes; gladium enim ego voco super omnes habitatores terrae, dicit Dominus exercituum."
,"30":"Et tu prophetabis ad eos omnia verba haec et dices ad illos: Dominus de excelso rugiet,et de habitaculo sancto suo dabit vocem suam; rugiens rugiet super pascua sua, celeuma quasi calcantium concinetur,adversus omnes habitatores terrae."
,"31":"Pervenit sonitus usque ad extrema terrae, quia iudicium Domino cum gentibus; in iudicium venit ipse cum omni carne; impios tradidit gladio, dicit Dominus."
,"32":"Haec dicit Dominus exercituum: Ecce afflictio egreditur de gente in gentem, et turbo magnus surgit a summitatibus terrae '."
,"33":"Et erunt interfecti Domini in die illa a summo terrae usque ad summum eius; non plangentur et non colligentur neque sepelientur: in sterquilinium super faciem terrae erunt."
,"34":"Ululate, pastores, et clamate; et volutamini vos in pulvere, optimates gregis, quia completi sunt dies vestri ad occisionem,et ad dispersionem vestram, et cadetis quasi vasa pretiosa."
,"35":"Et peribit fuga a pastoribus, et salvatio ab optimatibus gregis."
,"36":"Vox clamoris pastorum,et ululatus optimatium gregis, quia vastavit Dominus pascua eorum."
,"37":"Et conticuerunt arva pacis,a facie irae furoris Domini."
,"38":"Dereliquit quasi leo umbraculum suum, quia facta est terra eorum in desolationem, a facie irae violentae,et a facie irae furoris Domini."
}`)
	CurrentBook.AddChapter(26, `{
"1":"In principio regni Ioachim filii Iosiae regis Iudae factum est verbum istud a Domino dicens:"
,"2":"' Haec dicit Dominus: Sta in atrio domus Domini et loqueris ad omnes civitates Iudae, de quibus veniunt, ut adorent in domo Domini, universos sermones, quos ego mandavi tibi, ut loquaris ad eos: noli subtrahere verbum,"
,"3":"si forte audiant et convertantur unusquisque a via sua mala, et paeniteat me mali, quod cogito facere eis propter malitiam operum eorum."
,"4":"Et dices ad eos: Haec dicit Dominus: Si non audieritis me, ut ambuletis in lege mea, quam dedi vobis,"
,"5":"ut audiatis sermones servorum meorum prophetarum, quos ego misi ad vos de nocte consurgens et dirigens, et non audistis,"
,"6":"dabo domum istam sicut Silo et urbem hanc dabo in maledictionem cunctis gentibus terrae '."
,"7":"Et audierunt sacerdotes et prophetae et omnis populus Ieremiam loquentem verba haec in domo Domini."
,"8":"Cumque complesset Ieremias loquens omnia, quae praeceperat ei Dominus, ut loqueretur ad universum populum, apprehenderunt eum sacerdotes et prophetae et omnis populus dicens: ' Morte moriaris!"
,"9":"Quare prophetasti in nomine Domini dicens: 'Sicut Silo erit domus haec, et urbs ista desolabitur, eo quod non sit habitator'? '. Et congregatus est omnis populus adversus Ieremiam in domo Domini. "
,"10":"Et audierunt principes Iudae verba haec et ascenderunt de domo regis in domum Domini et sederunt in introitu portae domus Domini Novae."
,"11":"Et locuti sunt sacerdotes et prophetae ad principes et ad omnem populum dicentes: ' Iudicium mortis est viro huic, quia prophetavit adversus civitatem istam, sicut audistis auribus vestris '."
,"12":"Et ait Ieremias ad omnes principes et ad universum populum dicens: ' Dominus misit me, ut prophetarem ad domum istam et ad civitatem hanc omnia verba, quae audistis."
,"13":"Nunc ergo bonas facite vias vestras et opera vestra et audite vocem Domini Dei vestri, et paenitebit Dominum mali, quod locutus est adversum vos."
,"14":"Ego autem ecce in manibus vestris sum; facite mihi, quod bonum et rectum est in oculis vestris."
,"15":"Verumtamen scitote et cognoscite quod si occideritis me, sanguinem innocentem tradetis contra vosmetipsos et contra civitatem istam et habitatores eius; in veritate enim misit me Dominus ad vos, ut loquerer in auribus vestris omnia verba haec '."
,"16":"Et dixerunt principes et omnis populus ad sacerdotes et prophetas: ' Non est viro huic iudicium mortis, quia in nomine Domini Dei nostri locutus est ad nos '."
,"17":"Surrexerunt ergo viri de senioribus terrae et dixerunt ad omnem coetum populi loquentes:"
,"18":"' Michaeas Morasthites fuit propheta in diebus Ezechiae regis Iudae et ait ad omnem populum Iudae dicens: 'Haec dicit Dominus exercituum: Sion quasi ager arabitur, et Ierusalem in acervum lapidum erit, et mons domus in excelsa silvarum'."
,"19":"Numquid morte condemnavit eum Ezechias rex Iudae et omnis Iuda? Numquid non timuerunt Dominum et deprecati sunt faciem Domini, et paenituit Dominum mali, quod locutus fuerat adversum eos? Et nos facimus malum grande contra animas nostras! '."
,"20":"Fuit quoque vir prophetans in nomine Domini Urias filius Semei de Cariathiarim et prophetavit adversus civitatem istam et adversus terram hanc iuxta omnia verba Ieremiae."
,"21":"Et audivit rex Ioachim et omnes potentes et principes eius verba haec, et quaesivit rex interficere eum; et audivit Urias et timuit fugitque et ingressus est Aegyptum."
,"22":"Et misit rex Ioachim viros in Aegyptum, Elnathan filium Achobor et viros cum eo in Aegyptum;"
,"23":"et eduxerunt Uriam de Aegypto et adduxerunt eum ad regem Ioachim, et percussit eum gladio et proiecit cadaver eius in sepulcris filiorum vulgi."
,"24":"Igitur manus Ahicam filii Saphan fuit cum Ieremia, ut non traderetur in manus populi, et interficerent eum."
}`)
	CurrentBook.AddChapter(27, `{
"1":"In principio regni Sedeciae filii Iosiae regis Iudae factum est verbum istud ad Ieremiam a Domino dicens:"
,"2":"' Haec dicit Dominus ad me: Fac tibi vincula et iuga et pones ea in collo tuo"
,"3":"et mittes ea ad regem Edom et ad regem Moab et ad regem filiorum Ammon et ad regem Tyri et ad regem Sidonis in manu nuntiorum, qui venerunt Ierusalem ad Sedeciam regem Iudae;"
,"4":"et praecipies eis, ut ad dominos suos loquantur: Haec dicit Dominus exercituum, Deus Israel: Haec dicetis ad dominos vestros:"
,"5":"Ego feci terram et hominem et iumenta, quae sunt super faciem terrae, in fortitudine mea magna et in brachio meo extento et dedi eam ei, qui placuit in oculis meis."
,"6":"Et nunc itaque ego dedi omnes terras istas in manu Nabuchodonosor regis Babylonis servi mei, insuper et bestias agri dedi ei, ut serviant illi;"
,"7":"et servient ei omnes gentes et filio eius et filio filii eius, donec veniat tempus terrae eius etiam ipsius; et servient ei gentes multae et reges magni."
,"8":"Gens autem et regnum, quod non servierit Nabuchodonosor regi Babylonis, et quicumque non curvaverit collum suum sub iugo regis Babylonis, in gladio et in fame et in peste visitabo super gentem illam, ait Dominus, donec consumam eos in manu eius."
,"9":"Vos ergo nolite audire prophetas vestros et divinos et somniatores et augures et maleficos, qui dicunt vobis: 'Non servietis regi Babylonis',"
,"10":"quia mendacium prophetant vobis, ut longe vos faciant de terra vestra, et eiciam vos, et pereatis."
,"11":"Porro gens, quae subiecerit cervicem suam sub iugo regis Babylonis et servierit ei, dimittam eam in terra sua, dicit Dominus, et colet eam et habitabit in ea '."
,"12":"Et ad Sedeciam regem Iudae locutus sum secundum omnia verba haec dicens: ' Subicite colla vestra sub iugo regis Babylonis et servite ei et populo eius, et vivetis."
,"13":"Quare moriemini tu et populus tuus gladio, fame et peste, sicut locutus est Dominus ad gentem, quae servire noluerit regi Babylonis?"
,"14":"Nolite audire verba prophetarum dicentium vobis: 'Non servietis regi Babylonis', quia mendacium ipsi loquuntur vobis."
,"15":"Quia non misi eos, ait Dominus, et ipsi prophetant in nomine meo mendaciter, ut eiciam vos et pereatis, tam vos quam prophetae, qui vaticinantur vobis '."
,"16":"Et ad sacerdotes et ad populum istum locutus sum dicens: ' Haec dicit Dominus: Nolite audire verba prophetarum vestrorum, qui prophetant vobis dicentes: 'Ecce vasa domus Domini revertentur de Babylone nunc cito'. Mendacium enim prophetant vobis."
,"17":"Nolite ergo audire eos, sed servite regi Babylonis, ut vivatis. Quare datur haec civitas in solitudinem?"
,"18":"Et si prophetae sunt, et est verbum Domini in eis, occurrant Domino exercituum, ut non veniant vasa, quae derelicta fuerant in domo Domini et in domo regis Iudae et in Ierusalem, in Babylonem '."
,"19":"Quia haec dicit Dominus exercituum ad columnas et ad mare et ad bases et ad reliqua vasorum, quae remanserunt in civitate hac,"
,"20":"quae non tulit Nabuchodonosor rex Babylonis, cum transferret Iechoniam filium Ioachim regem Iudae de Ierusalem in Babylonem et omnes optimates Iudae et Ierusalem;"
,"21":"quia haec dicit Dominus exercituum, Deus Israel, ad vasa, quae derelicta sunt in domo Domini et in domo regis Iudae et Ierusalem:"
,"22":"'In Babylonem transferentur et ibi erunt usque ad diem visitationis eorum, dicit Dominus; et afferri faciam ea et restitui in loco isto '."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Et factum est in anno illo, in principio regni Sedeciae regis Iudae, in anno quarto in mense quinto, dixit ad me Hananias filius Azur propheta de Gabaon in domo Domini coram sacerdotibus et omni populo dicens:"
,"2":"' Haec dicit Domi nus exercituum, Deus Israel: Contrivi iugum regis Babylonis."
,"3":"Adhuc duo anni dierum, et ego referri faciam ad locum istum omnia vasa domus Domini, quae tulit Nabuchodonosor rex Babylonis de loco isto et transtulit ea in Babylonem."
,"4":"Et Iechoniam filium Ioachim regem Iudae et omnem transmigrationem Iudae, qui ingressi sunt in Babylonem, ego convertam ad locum istum, ait Dominus; conteram enim iugum regis Babylonis '."
,"5":"Et dixit Ieremias propheta ad Hananiam prophetam in oculis sacerdotum et in oculis omnis populi, qui stabat in domo Domini,"
,"6":"et ait Ieremias propheta: ' Amen, sic faciat Dominus! Suscitet Dominus verba tua, quae prophetasti, ut referantur vasa in domum Domini et omnis transmigratio de Babylone ad locum istum."
,"7":"Verumtamen audi verbum hoc, quod ego loquor in auribus tuis et in auribus universi populi:"
,"8":"Prophetae, qui fuerunt ante me et ante te ab initio et prophetaverunt super terras multas et super regna magna de proelio et de afflictione et de peste;"
,"9":"propheta, qui vaticinatur pacem, cum venerit verbum eius, scietur propheta, quem misit Dominus in veritate '."
,"10":"Et tulit Hananias propheta iugum de collo Ieremiae prophetae et confregit illud;"
,"11":"et ait Hananias in conspectu omnis populi dicens: ' Haec dicit Dominus: Sic confringam iugum Nabuchodonosor regis Babylonis post duos annos dierum de collo omnium gentium '. Et abiit Ieremias propheta in viam suam."
,"12":"Et factum est verbum Domini ad Ieremiam, postquam confregit Hananias propheta iugum de collo Ieremiae prophetae, dicens:"
,"13":"'Vade et dices Hananiae: Haec dicit Dominus: Iuga lignea contrivisti et facies pro eis iuga ferrea."
,"14":"Quia haec dicit Dominus exercituum, Deus Israel: Iugum ferreum posui super collum cunctarum gentium istarum, ut serviant Nabuchodonosor regi Babylonis, et servient ei; insuper et bestias terrae dedi ei '."
,"15":"Et dixit Ieremias propheta ad Hananiam prophetam: 'Audi, Hanania! Non misit te Dominus, et tu confidere fecisti populum istum in mendacio."
,"16":"Idcirco haec dicit Dominus: Ecce emittam te a facie terrae; hoc anno morieris, adversum enim Dominum praevaricationem locutus es '."
,"17":"Et mortuus est Hananias propheta in anno illo, mense septimo."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Et haec sunt verba epistulae, quam misit Ieremias propheta de Ierusalem ad reliquias seniorum transmigrationis et ad sacerdotes et ad prophetas et ad omnem populum, quem traduxerat Nabuchodonosor de Ierusalem in Babylonem,"
,"2":"postquam egressus est Iechonias rex et domina et eunuchi et principes Iudae et Ierusalem et faber et inclusor de Ierusalem,"
,"3":"in manu Elasa filii Saphan et Gamariae filii Helciae, quos misit Sedecias rex Iudae ad Nabuchodonosor regem Babylonis in Babylonem dicens:"
,"4":"' Haec dicit Dominus exercituum, Deus Israel, omni transmigrationi, quam transtuli de Ierusalem in Babylonem:"
,"5":"Aedificate domos et habitate et plantate hortos et comedite fructum eorum,"
,"6":"accipite uxores et generate filios et filias et date filiis vestris uxores et filias vestras date viris, et pariant filios et filias, et multiplicamini ibi et nolite esse pauci numero."
,"7":"Et quaerite pacem civitatis, ad quam transmigrare vos feci, et orate pro ea ad Dominum, quia in pace illius erit pax vobis."
,"8":"Haec enim dicit Dominus exercituum, Deus Israel: Non vos seducant prophetae vestri, qui sunt in medio vestrum, et divini vestri, et ne attendatis ad somnia vestra, quae vos somniatis,"
,"9":"quia falso ipsi prophetant vobis in nomine meo, et non misi eos, dicit Dominus."
,"10":"Quia haec dicit Dominus: Cum impleti fuerint in Babylone septuaginta anni, visitabo vos et suscitabo super vos verbum meum bonum, ut reducam vos ad locum istum."
,"11":"Ego enim scio cogitationes, quas ego cogito super vos, ait Dominus, cogitationes pacis et non afflictionis, ut dem vobis posteritatem et spem."
,"12":"Et invocabitis me et ibitis; et orabitis me, et ego exaudiam vos."
,"13":"Quaeretis me et invenietis, cum quaesieritis me in toto corde vestro."
,"14":"Et inveniar a vobis, ait Dominus, et reducam captivitatem vestram et congregabo vos de universis gentibus et de cunctis locis, ad quae expuli vos, dicit Dominus; et reverti vos faciam ad locum, de quo transmigrare vos feci."
,"15":"Quia dixistis: 'Suscitavit nobis Dominus prophetas in Babylone'."
,"16":"Quia haec dicit Dominus ad regem, qui sedet super solium David, et ad omnem populum habitatorem urbis huius, ad fratres vestros, qui non sunt egressi vobiscum in transmigrationem,"
,"17":"haec dicit Dominus exercituum: Ecce mittam in eis gladium et famem et pestem et ponam eos quasi ficus malas, quae comedi non possunt, eo quod pessimae sint;"
,"18":"et persequar eos in gladio et in fame et in pestilentia et dabo eos in vexationem universis regnis terrae, in maledictionem et in stuporem et in sibilum et in opprobrium cunctis gentibus, ad quas ego eieci eos,"
,"19":"eo quod non audierint verba mea, dicit Dominus, quae misi ad eos per servos meos prophetas, de nocte consurgens et mittens, et non audistis, dicit Dominus."
,"20":"Vos ergo audite verbum Domini, omnis transmigratio, quam emisi de Ierusalem in Babylonem."
,"21":"Haec dicit Dominus exercituum, Deus Israel, ad Achab filium Colaiae et ad Sedeciam filium Maasiae, qui prophetant vobis in nomine meo mendaciter: Ecce ego tradam eos in manu Nabuchodonosor regis Babylonis, et percutiet eos in oculis vestris;"
,"22":"et assumetur ex eis maledictio omni transmigrationi Iudae, quae est in Babylone, dicentium: 'Ponat te Dominus sicut Sedeciam et sicut Achab, quos frixit rex Babylonis in igne!';"
,"23":"pro eo quod fecerint stultitiam in Israel et moechati sunt in uxores amicorum suorum et locuti sunt verbum in nomine meo mendaciter, quod non mandavi eis. Ego enim scio et sum testis, dicit Dominus."
,"24":"Et ad Semeiam Nehelamiten dices:"
,"25":"Haec dicit Dominus exercituum, Deus Israel, pro eo quod misisti in nomine tuo epistulas ad omnem populum, qui est in Ierusalem, et ad Sophoniam filium Maasiae sacerdotem et ad universos sacerdotes dicens:"
,"26":"'Dominus dedit te sacerdotem pro Ioiada sacerdote, ut sis praefectus in domo Domini super omnem virum arrepticium et prophetantem, ut mittas eum in nervum et in vincula."
,"27":"Et nunc quare non increpasti Ieremiam Anathothiten, qui prophetat vobis?"
,"28":"Quia super hoc misit ad nos in Babylonem dicens: Longum est; aedificate domos et habitate et plantate hortos et comedite fructum eorum' '."
,"29":"Legit ergo Sophonias sacerdos epistulam istam in auribus Ieremiae prophetae."
,"30":"Et factum est verbum Domini ad Ieremiam dicens:"
,"31":"' Mitte ad omnem transmigrationem dicens: Haec dicit Dominus ad Semeiam Nehelamiten: Pro eo quod prophetavit vobis Semeias, et ego non misi eum, et fecit vos confidere in mendacio,"
,"32":"idcirco haec dicit Dominus: Ecce ego visitabo super Semeiam Nehelamiten et super semen eius; non erit ei vir sedens in medio populi huius, et non videbit bonum, quod ego faciam populo meo, ait Dominus, quia praevaricationem locutus est adversus Dominum '."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Verbum, quod factum est ad Ieremiam a Domino dicens:"
,"2":"' Haec dicit Dominus, Deus Israel, dicens: Scribe tibi omnia verba, quae locutus sum ad te, in libro;"
,"3":"ecce enim dies veniunt, dicit Dominus, et convertam sortem populi mei Israel et Iudae, ait Dominus, et convertam eos ad terram, quam dedi patribus eorum, et possidebunt eam '."
,"4":"Et haec verba, quae locutus est Dominus ad Israel et ad Iudam:"
,"5":"' Quoniam haec dicit Dominus: Vocem terroris audivimus, formido et non est pax."
,"6":"Interrogate et videte, si generat masculus; quare ergo vidi omnis viri manum,super lumbum suum quasi parturientis, et conversae sunt universae facies in auruginem?"
,"7":"Vae, quia magna dies illa, nec est similis eius, tempusque tribulationis est Iacob, et ex ipso salvabitur."
,"8":"Et erit: in die illa, ait Dominus exercituum, conteram iugum eius de collo tuo et vincula tua dirumpam; et non dominabuntur ei amplius alieni,"
,"9":"sed servient Domino Deo suo et David regi suo, quem suscitabo eis."
,"10":"Tu ergo ne timeas, serve meus Iacob, ait Dominus, neque paveas, Israel, quia ecce ego salvabo te de terra longinqua,et semen tuum de terra captivitatis eorum; et revertetur Iacob et quiescet,et securus erit, et non erit quem formidet;"
,"11":"quoniam tecum ego sum, ait Dominus, ut salvem te. Faciam enim consummationem in cunctis gentibus, in quibus dispersi te; te autem non faciam in consummationem, sed castigabo te in iudicio,nec quasi innocenti parcam tibi."
,"12":"Quia haec dicit Dominus: Insanabilis fractura tua, pessima plaga tua;"
,"13":"non est qui iudicet iudicium tuum; sunt ulceri medicamina, tibi vero cicatrix non obducitur."
,"14":"Omnes amatores tui obliti sunt tui, te non quaerunt; plaga enim inimici percussi te,castigatione crudeli: propter multitudinem iniquitatis tuae,dura facta sunt peccata tua."
,"15":"Quid clamas super contritione tua?,Insanabilis est dolor tuus. Propter multitudinem iniquitatis tuae,et propter dura peccata tua feci haec tibi."
,"16":"Propterea omnes, qui comedunt te, devorabuntur, et universi hostes tui in captivitatem ducentur, et, qui te vastant, vastabuntur, cunctosque praedatores tuos dabo in praedam."
,"17":"Obducam enim cicatricem tibi,et a vulneribus tuis sanabo te, dicit Dominus, quia Eiectam vocaverunt te, Sion haec, quae non habebat requirentem."
,"18":"Haec dicit Dominus: Ecce ego convertam sortem tabernaculorum Iacob,et tectis eius miserebor, et aedificabitur civitas in ruinis suis, et arx in loco suo fundabitur;"
,"19":"et egredietur de eis laus voxque ludentium. Et multiplicabo eos, et non imminuentur, et glorificabo eos, et non attenuabuntur."
,"20":"Et erunt filii eius sicut a principio, et coetus eius coram me permanebit, et visitabo adversum omnes, qui tribulant eum."
,"21":"Et erit dux eius ex eo, et princeps de medio eius procedet; et applicabo eum, et accedet ad me. Quis enim iste est, qui pignori dabit cor suum, ut appropinquet mihi?, ait Dominus."
,"22":"Et eritis mihi in populum, et ego ero vobis in Deum."
,"23":"Ecce turbo Domini, furor egrediens, procella ruens; in capite impiorum conquiescet."
,"24":"Non cessabit ab ira indignationis Dominus, donec faciat et compleat,cogitationes cordis sui; in novissimo dierum intellegetis ea."
}`)
	CurrentBook.AddChapter(31, `{
"1":"In tempore illo, dicit Dominus, ero Deus universis cognationibus Israel, et ipsi erunt mihi in populum."
,"2":"Haec dicit Dominus: Invenit gratiam in deserto,populus, qui remanserat a gladio; vadet ad requiem suam Israel '."
,"3":"De longe Dominus apparuit mihi: ' In caritate perpetua dilexi te; ideo attraxi te in misericordia."
,"4":"Rursumque aedificabo te, et aedificaberis, virgo Israel; adhuc ornaberis tympanis tuis,et egredieris in choro ludentium."
,"5":"Adhuc plantabis vineas in montibus Samariae; plantabunt plantantes,et vindemiabunt."
,"6":"Quia erit dies, in qua clamabunt custodes,in monte Ephraim: 'Surgite, et ascendamus in Sion,ad Dominum Deum nostrum'."
,"7":"Quia haec dicit Dominus: Exsultate in laetitia propter Iacob,et hinnite capiti gentium; personate, canite et dicite: 'Salva, Domine, populum tuum, reliquias Israel'."
,"8":"Ecce ego adducam eos de terra aquilonis,et congregabo eos ab extremis terrae; inter quos erunt caecus et claudus, praegnans et pariens simul: coetus magnus revertentium huc."
,"9":"In fletu venient, et in deprecatione reducam eos,et adducam eos per torrentes aquarum,in via recta, et non impingent in ea, quia factus sum Israeli pater, et Ephraim primogenitus meus est '."
,"10":"Audite verbum Domini, gentes, et annuntiate in insulis, quae procul sunt, et dicite: ' Qui dispersit Israel, congregabit eum,et custodiet eum sicut pastor gregem suum '."
,"11":"Redemit enim Dominus Iacob,et liberavit eum de manu potentioris."
,"12":"Et venient et laudabunt in monte Sion,et confluent ad bona Domini,super frumento et vino et oleo,et fetu pecorum et armentorum; eritque anima eorum quasi hortus irriguus, et ultra non esurient."
,"13":"Tunc laetabitur virgo in choro, iuvenes et senes simul. ' Et convertam luctum eorum in gaudium,et consolabor eos et laetificabo a dolore suo."
,"14":"Et inebriabo animam sacerdotum pinguedine, et populus meus bonis meis adimplebitur ', ait Dominus."
,"15":"Haec dicit Dominus: ' Vox in Rama audita est,lamentationis, luctus et fletus,Rachel plorantis filios suos,et nolentis consolari super eis, quia non sunt '."
,"16":"Haec dicit Dominus: ' Quiescat vox tua a ploratu, et oculi tui a lacrimis, quia est merces operi tuo, ait Dominus, et revertentur de terra inimici."
,"17":"Et est spes novissimis tuis, ait Dominus, et revertentur filii ad terminos suos."
,"18":"Audiens audivi Ephraim transmigrantem: 'Castigasti me, et eruditus sum,quasi iuvenculus indomitus; converte me, et convertar, quia tu Dominus Deus meus."
,"19":"Postquam enim convertisti me, egi paenitentiam; et postquam ostendisti mihi, percussi femur meum; confusus sum et erubui, quoniam sustinui opprobrium adulescentiae meae'."
,"20":"Estne filius honorabilis mihi Ephraim,aut puer delectabilis, quia ex quo locutus sum de eo, adhuc recordabor eius?,Idcirco conturbata sunt viscera mea super eum: miserans miserebor eius ', ait Dominus."
,"21":"Statue tibi lapides, pone tibi signa, dirige cor tuum in iter, viam, in qua ambulasti; revertere, virgo Israel, revertere ad civitates tuas istas."
,"22":"Usquequo vagaberis, filia rebellis?,Quia creavit Dominus novum super terram: femina circumdabit virum."
,"23":"Haec dicit Dominus exercituum, Deus Israel: ' Adhuc dicent verbum istud in terra Iudae et in urbibus eius, cum convertero sortem eorum: 'Benedicat tibi Dominus, habitaculum iustitiae, mons sanctus'."
,"24":"Et habitabunt in eo Iudas et omnes civitates eius simul, agricolae et minantes greges."
,"25":"Quia inebriavi animam lassam et omnem animam esurientem saturavi '."
,"26":"Ideo quasi de somno suscitatus sum et vidi, et somnus meus dulcis mihi."
,"27":"' Ecce dies veniunt, dicit Dominus, et seminabo domum Israel et domum Iudae semine hominum et semine iumentorum."
,"28":"Et sicut vigilavi super eos, ut evellerem et demolirer et dissiparem et disperderem et affligerem, sic vigilabo super eos, ut aedificem et plantem, ait Dominus."
,"29":"In diebus illis non dicent ultra: 'Patres comederunt uvam acerbam, et dentes filiorum obstupuerunt',"
,"30":"sed unusquisque in iniquitate sua morietur; omnis homo, qui comederit uvam acerbam, obstupescent dentes eius."
,"31":"Ecce dies veniunt, dicit Dominus, et feriam domui Israel et domui Iudae pactum novum;"
,"32":"non secundum pactum, quod pepigi cum patribus eorum in die qua apprehendi manum eorum, ut educerem eos de terra Aegypti, pactum, quod irritum fecerunt, et ego dominatus sum eorum, dicit Dominus."
,"33":"Sed hoc erit pactum, quod feriam cum domo Israel post dies illos, dicit Dominus: Dabo legem meam in visceribus eorum et in corde eorum scribam eam; et ero eis in Deum, et ipsi erunt mihi in populum."
,"34":"Et non docebit ultra vir proximum suum, et vir fratrem suum dicens: 'Cognosce Dominum'; omnes enim cognoscent me, a minimo eorum usque ad maximum, ait Dominus, quia propitiabor iniquitati eorum et peccati eorum non memorabor amplius '."
,"35":"Haec dicit Dominus, qui dat solem in lumine diei, ordinem lunae et stellarum in lumine noctis, qui turbat mare, et fremunt fluctus eius, Dominus exercituum nomen illi:"
,"36":"' Si defecerint leges istae coram me, dicit Dominus, tunc et semen Israel deficiet, ut non sit gens coram me cunctis diebus '."
,"37":"Haec dicit Dominus: ' Si mensurari potuerint caeli sursum, et investigari fundamenta terrae deorsum, et ego abiciam universum semen Israel,propter omnia, quae fecerunt, dicit Dominus."
,"38":"Ecce dies veniunt, dicit Dominus, et aedificabitur civitas Domino a turre Hananeel usque ad portam Anguli,"
,"39":"et exibit ultra norma mensurae in conspectu eius super collem Gareb et vertetur in Goa,"
,"40":"et omnis vallis cadaverum et cineris et universa regio usque ad torrentem Cedron et usque ad angulum portae Equorum orientalis sanctum Domini; non evelletur et non destruetur ultra in perpetuum '."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Verbum, quod factum est ad Ieremiam a Domino in anno decimo Sedeciae regis Iudae; ipse est annus decimus octavus Nabuchodonosor."
,"2":"Tunc exercitus regis Babylonis obsidebat Ierusalem, et Ieremias propheta erat clausus in atrio custodiae, qui erat in domo regis Iudae."
,"3":"Clauserat enim eum Sedecias rex Iudae dicens: ' Quare vaticinaris dicens: 'Haec dicit Dominus: Ecce ego dabo civitatem istam in manu regis Babylonis, et capiet eam;"
,"4":"et Sedecias rex Iudae non effugiet de manu Chaldaeorum, sed tradetur in manus regis Babylonis, et loquetur os eius cum ore illius, et oculi eius oculos illius videbunt;"
,"5":"et in Babylonem ducet Sedeciam, et ibi erit, donec visitem eum, ait Dominus; si autem dimicaveritis adversum Chaldaeos, nihil prosperum habebitis'? '."
,"6":"Et dixit Ieremias: ' Factum est verbum Domini ad me dicens:"
,"7":"Ecce Hanameel filius Sellum patruelis tuus veniet ad te dicens: 'Eme tibi agrum meum, qui est in Anathoth; tibi enim competit ex propinquitate, ut emas'."
,"8":"Et venit ad me Hanameel filius patrui mei secundum verbum Domini ad vestibulum custodiae et ait ad me: 'Posside agrum meum, qui est in Anathoth in terra Beniamin, quia tibi competit hereditas, et tu propinquus es, ut possideas'. Intellexi autem quod verbum Domini esset"
,"9":"et emi agrum ab Hanameel filio patrui mei, qui est in Anathoth, et appendi ei argentum: septem et decem siclos argenteos."
,"10":"Et scripsi in libro et signavi et adhibui testes et appendi argentum in statera."
,"11":"Et accepi librum possessionis signatum, continentem stipulationes et rata, et apertum;"
,"12":"et dedi librum possessionis Baruch filio Neriae filii Maasiae in oculis Hanameel patruelis mei et in oculis testium, qui obsignaverant in libro emptionis, et in oculis omnium Iudaeorum, qui sedebant in atrio custodiae."
,"13":"Et praecepi Baruch coram eis dicens:"
,"14":"Haec dicit Dominus exercituum, Deus Israel: Sume libros istos, librum emptionis hunc signatum et librum hunc, qui apertus est; et pones illos in vase fictili, ut permanere possint diebus multis."
,"15":"Haec enim dicit Dominus exercituum, Deus Israel: Adhuc possidebuntur domus et agri et vineae in terra ista."
,"16":"Et oravi ad Dominum, postquam tradidi librum possessionis Baruch filio Neriae, dicens:"
,"17":"Heu, Domine Deus, ecce tu fecisti caelum et terram in fortitudine tua magna et in brachio tuo extento; non erit tibi difficile omne verbum,"
,"18":"qui facis misericordiam in milibus et reddis iniquitatem patrum in sinum filiorum eorum post eos; Deus magne, potens, Dominus exercituum nomen eius:"
,"19":"magnus consilio et potens in operibus, cuius oculi aperti sunt super omnes vias filiorum Adam, ut reddas unicuique secundum vias suas et secundum fructum operum eius."
,"20":"Qui posuisti signa et portenta in terra Aegypti usque ad diem hanc et in Israel et in hominibus; et fecisti tibi nomen, sicut est dies haec."
,"21":"Et eduxisti populum tuum Israel de terra Aegypti in signis et in portentis et in manu robusta et in brachio extento et in terrore magno."
,"22":"Et dedisti eis terram hanc, quam iurasti patribus eorum, ut dares eis, terram fluentem lacte et melle."
,"23":"Et ingressi sunt et possederunt eam; et non oboedierunt voci tuae et in lege tua non ambulaverunt: omnia, quae mandasti eis, ut facerent, non fecerunt; et occurrere fecisti eis omnia mala haec."
,"24":"Ecce munitiones exstructae sunt adversum civitatem, ut capiatur, et urbs data est in manu Chaldaeorum, qui proeliantur adversus eam, in gladio et fame et pestilentia; et quaecumque locutus es, acciderunt, ut tu ipse cernis."
,"25":"Et tu dicis mihi, Domine Deus: Eme agrum argento et adhibe testes, cum urbs data sit in manu Chaldaeorum '."
,"26":"Et factum est verbum Domini ad Ieremiam dicens:"
,"27":"' Ecce ego Dominus, Deus universae carnis; numquid mihi difficile erit omne verbum?"
,"28":"Propterea haec dicit Dominus: Ecce ego tradam civitatem istam in manus Chaldaeorum et in manus regis Babylonis, et capiet eam."
,"29":"Et venient Chaldaei proeliantes adversum urbem hanc et succendent eam igni et comburent eam et domos, in quarum domatibus sacrificabant Baal et libabant diis alienis libamina ad irritandum me."
,"30":"Erant enim filii Israel et filii Iudae iugiter facientes malum in oculis meis ab adulescentia sua, filii Israel, qui usque nunc exacerbant me in opere manuum suarum, dicit Dominus."
,"31":"Quia in furorem et in indignationem meam facta est mihi civitas haec a die, qua aedificaverunt eam, usque ad diem istam, qua auferetur de conspectu meo"
,"32":"propter omnem malitiam filiorum Israel et filiorum Iudae, quam fecerunt, ad iracundiam me provocantes, ipsi et reges eorum, principes eorum et sacerdotes eorum et prophetae eorum, viri Iudae et habitatores Ierusalem."
,"33":"Et verterunt ad me terga et non facies, cum docerem eos diluculo consurgens et erudiens, et nollent audire, ut acciperent disciplinam."
,"34":"Et posuerunt idola sua in domo, super quam invocatum est nomen meum, ut polluerent eam;"
,"35":"et aedificaverunt excelsa Baal, quae sunt in valle Benennom, ut initiarent filios suos et filias suas Moloch; quod non mandavi eis, nec ascendit in cor meum, ut facerent abominationem hanc et in peccatum deducerent Iudam '."
,"36":"Et nunc propter ista, haec dicit Dominus, Deus Israel, ad civitatem hanc, de qua vos dicitis quod tradatur in manus regis Babylonis in gladio et in fame et in peste:"
,"37":"' Ecce ego congregabo eos de universis terris, ad quas eieci eos in furore meo et in ira mea et in indignatione grandi; et reducam eos ad locum istum et habitare eos faciam confidenter."
,"38":"Et erunt mihi in populum, et ego ero eis in Deum."
,"39":"Et dabo eis cor unum et viam unam, ut timeant me universis diebus, et bene sit eis et filiis eorum post eos."
,"40":"Et feriam eis pactum sempiternum et non desinam eis benefacere et timorem meum dabo in corde eorum, ut non recedant a me."
,"41":"Et laetabor super eis, cum bene eis fecero, et plantabo eos in terra ista in veritate, in toto corde meo et in tota anima mea."
,"42":"Quia haec dicit Dominus: Sicut adduxi super populum istum omne malum hoc grande, sic adducam super eos omne bonum, quod ego loquor ad eos,"
,"43":"et possidebuntur agri in terra ista, de qua vos dicitis quod deserta sit, eo quod non remanserit homo et iumentum, et data sit in manu Chaldaeorum."
,"44":"Agri ementur pecunia et scribentur in libro, et imprimetur signum, et testes adhibebuntur in terra Beniamin et in circuitu Ierusalem, in civitatibus Iudae et in civitatibus montanis et in civitatibus Sephelae et in civitatibus, quae ad austrum sunt, quia convertam sortem eorum ', ait Dominus."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Et factum est verbum Domi ni ad Ieremiam secundo, cum adhuc clausus esset in atrio custodiae, dicens:"
,"2":"' Haec dicit Dominus, qui facturus est id, Dominus, qui formaturus est illud et paraturus, Dominus nomen eius:"
,"3":"Clama ad me, et exaudiam te et annuntiabo tibi grandia et inaccessibilia, quae nescis."
,"4":"Quia haec dicit Dominus, Deus Israel, super domos urbis huius et ad domos regis Iudae, quae destructae sunt, pro munitionibus et pro gladio"
,"5":"venientium, ut dimicent cum Chaldaeis et impleant eas cadaveribus hominum, quos percussi in furore meo et in indignatione mea, abscondens faciem meam a civitate hac propter omnem malitiam eorum."
,"6":"Ecce ego obducam ei cicatricem et sanitatem et curabo eos et revelabo illis abundantiam pacis et veritatis"
,"7":"et convertam sortem Iudae et sortem Israel et aedificabo eos sicut a principio."
,"8":"Et emundabo illos ab omni iniquitate sua, in qua peccaverunt mihi, et propitius ero cunctis iniquitatibus eorum, in quibus deliquerunt mihi et spreverunt me;"
,"9":"et erit mihi in nomen et in gaudium et in laudem et in exsultationem cunctis gentibus terrae, quae audierint omnia bona, quae ego facturus sum eis; et pavebunt et turbabuntur in universis bonis et in omni pace, quam ego faciam eis."
,"10":"Haec dicit Dominus: Adhuc audietur in loco isto, quem vos dicitis esse desertum, eo quod non sit homo et iumentum in civitatibus Iudae et foris Ierusalem, quae desolatae sunt absque homine et absque habitatore et absque pecore,"
,"11":"vox gaudii et vox laetitiae, vox sponsi et vox sponsae, vox dicentium: 'Confitemini Domino exercituum, quoniam bonus Dominus, quoniam in aeternum misericordia eius'; et portantium vota in domum Domini; reducam enim sortem terrae sicut a principio, dicit Dominus."
,"12":"Haec dicit Dominus exercituum: Adhuc erit in loco isto deserto, absque homine et absque iumento, et in cunctis civitatibus eius habitaculum pastorum accubantium gregum."
,"13":"In civitatibus montuosis et in civitatibus Sephelae et in civitatibus, quae ad austrum sunt, et in terra Beniamin et in circuitu Ierusalem et in civitatibus Iudae adhuc transibunt greges ad manum numerantis, ait Dominus."
,"14":"Ecce dies veniunt, dicit Dominus, et suscitabo verbum bonum, quod locutus sum ad domum Israel et ad domum Iudae."
,"15":"In diebus illis et in tempore illo germinare faciam David germen iustitiae, et faciet iudicium et iustitiam in terra."
,"16":"In diebus illis salvabitur Iuda, et Ierusalem habitabit confidenter; et hoc est nomen, quod vocabit eam: Dominus iustitia nostra."
,"17":"Quia haec dicit Dominus: Non interibit de David vir, qui sedeat super thronum domus Israel;"
,"18":"et de sacerdotibus Levitis non interibit vir a facie mea, qui offerat holocautomata et incendat sacrificium et caedat victimas omnibus diebus '."
,"19":"Et factum est verbum Domini ad Ieremiam dicens:"
,"20":"' Haec dicit Dominus: Si irritum potest fieri pactum meum cum die et pactum meum cum nocte, ut non sit dies et nox in tempore suo,"
,"21":"et pactum meum irritum esse poterit cum David servo meo, ut non sit ex eo filius, qui regnet in throno eius, et cum Levitis sacerdotibus ministris meis."
,"22":"Sicuti enumerari non possunt stellae caeli et metiri arena maris, sic multiplicabo semen David servi mei et Levitas ministros meos '."
,"23":"Et factum est verbum Domini ad Ieremiam dicens:"
,"24":"' Numquid non vidisti quid populus hic locutus sit dicens: 'Duae cognationes, quas elegerat Dominus, abiectae sunt', et populum meum despexerunt, eo quod non sit ultra gens coram eis?"
,"25":"Haec dicit Dominus: Si pactum meum inter diem et noctem et leges caelo et terrae non posui,"
,"26":"equidem et semen Iacob et David servi mei proiciam, ut non assumam de semine eius principes seminis Abraham et Isaac et Iacob; reducam enim sortem eorum et miserebor eis '."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Verbum, quod factum est ad Ieremiam a Domino, quando Nabuchodonosor rex Babylonis et omnis exercitus eius universaque regna terrae, quae erant sub potestate manus eius, et omnes populi bellabant contra Ierusalem et contra omnes urbes eius, dicens:"
,"2":"' Haec dicit Dominus, Deus Israel: Vade et loquere ad Sedeciam regem Iudae et dices ad eum: Haec dicit Dominus: Ecce ego tradam civitatem hanc in manus regis Babylonis, et succendet eam igni;"
,"3":"et tu non effugies de manu eius, sed comprehensione capieris et in manu eius traderis, et oculi tui oculos regis Babylonis videbunt, et os eius cum ore tuo loquetur, et Babylonem introibis."
,"4":"Attamen audi verbum Domini, Sedecia rex Iudae. Haec dicit Dominus ad te: Non morieris in gladio,"
,"5":"sed in pace morieris et secundum combustiones patrum tuorum regum priorum, qui fuerunt ante te, sic comburent tibi et 'Vae, domine!' plangent te, quia verbum ego locutus sum ', dicit Dominus."
,"6":"Et locutus est Ieremias propheta ad Sedeciam regem Iudae universa verba haec in Ierusalem;"
,"7":"et exercitus regis Babylonis pugnabat contra Ierusalem et contra omnes civitates Iudae, quae reliquae erant, contra Lachis et contra Azeca: hae enim supererant de civitatibus Iudae urbes munitae."
,"8":"Verbum, quod factum est ad Ieremiam a Domino, postquam percussit rex Sedecias foedus cum omni populo in Ierusalem praedicans eis libertatem,"
,"9":"ut dimitteret unusquisque servum suum et unusquisque ancillam suam, Hebraeum et Hebraeam, liberos et nequaquam dominarentur eis, id est in Iudaeo et fratre suo."
,"10":"Audierunt ergo omnes principes et universus populus, qui inierant pactum, ut dimitteret unusquisque servum suum et unusquisque ancillam suam liberos et ultra non dominarentur eis; audierunt igitur et dimiserunt."
,"11":"Et conversi sunt deinceps et retraxerunt servos et ancillas suas, quos dimiserant liberos, et subiugaverunt in famulos et in famulas."
,"12":"Et factum est verbum Domini ad Ieremiam a Domino dicens:"
,"13":"' Haec dicit Dominus, Deus Israel: Ego percussi foedus cum patribus vestris in die, qua eduxi eos de terra Aegypti de domo servitutis, dicens:"
,"14":"Cum completi fuerint septem anni, dimittat unusquisque fratrem suum Hebraeum, qui venditus est ei, et serviet tibi sex annis, et dimittes eum a te liberum, et non audierunt patres vestri me nec inclinaverunt aurem suam."
,"15":"Et conversi estis vos hodie et fecistis, quod rectum est in oculis meis, ut praedicaretis libertatem unusquisque ad proximum suum; et inistis pactum in conspectu meo in domo, super quam invocatum est nomen meum."
,"16":"Et reversi estis et commaculastis nomen meum et reduxistis unusquisque servum suum et unusquisque ancillam suam, quos dimiseratis, ut essent liberi et suae potestatis, et subiugastis eos, ut sint vobis servi et ancillae."
,"17":"Propterea haec dicit Dominus: Vos non audistis me, ut praedicaretis libertatem unusquisque fratri suo et unusquisque amico suo; ecce ego praedico vobis libertatem, ait Dominus, ad gladium et pestem et famem et dabo vos in commotionem cunctis regnis terrae."
,"18":"Et dabo viros, qui praevaricantur foedus meum et non observaverunt verba foederis, quibus assensi sunt in conspectu meo, sicut vitulum, quem conciderunt in duas partes et transierunt inter divisiones eius,"
,"19":"principes Iudae et principes Ierusalem, eunuchi et sacerdotes et omnis populus terrae, qui transierunt inter divisiones vituli;"
,"20":"et dabo eos in manu inimicorum suorum et in manu quaerentium animam eorum, et erit morticinum eorum in escam volatilibus caeli et bestiis terrae."
,"21":"Et Sedeciam regem Iudae et principes eius dabo in manus inimicorum suorum et in manus quaerentium animas eorum et in manus exercituum regis Babylonis, qui recesserunt a vobis."
,"22":"Ecce ego praecipio, dicit Dominus, et reducam eos in civitatem hanc; et proeliabuntur adversus eam et capient eam et incendent igni; et civitates Iudae dabo in solitudinem, eo quod non sit habitator '."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Verbum, quod factum est ad Ieremiam a Domino in die bus Ioachim filii Iosiae regis Iudae dicens:"
,"2":"' Vade ad domum Rechabitarum et loquere eis; et introduces eos in domum Domini in unam exedram et dabis eis bibere vinum '."
,"3":"Et assumpsi Iezoniam filium Ieremiae filii Habsaniae et fratres eius et omnes filios eius et universam domum Rechabitarum;"
,"4":"et introduxi eos in domum Domini ad exedram filiorum Hanan filii Iegdaliae hominis Dei, quod erat iuxta exedram principum super exedram Maasiae filii Sellum, qui erat custos vestibuli."
,"5":"Et posui coram filiis domus Rechabitarum scyphos plenos vino et calices et dixi ad eos: ' Bibite vinum '."
,"6":"Qui responderunt: ' Non bibemus vinum, quia Ionadab filius Rechab pater noster praecepit nobis dicens: 'Non bibetis vinum, vos et filii vestri, usque in sempiternum"
,"7":"et domum non aedificabitis et sementem non seretis et vineas non plantabitis, nec habebitis, sed in tabernaculis habitabitis cunctis diebus vestris, ut vivatis diebus multis super faciem terrae, in qua vos peregrinamini'."
,"8":"Oboedivimus ergo voci Ionadab filii Rechab patris nostri in omnibus, quae praecepit nobis, ita ut non biberemus vinum cunctis diebus nostris, nos et mulieres nostrae, filii et filiae nostrae,"
,"9":"et non aedificaremus domos ad habitandum et vineam et agrum et sementem non habuimus,"
,"10":"sed habitavimus in tabernaculis; et oboedientes fecimus iuxta omnia, quae praecepit nobis Ionadab pater noster."
,"11":"Cum autem ascendisset Nabuchodonosor rex Babylonis ad terram, diximus: Venite, et ingrediamur Ierusalem a facie exercitus Chaldaeorum et a facie exercitus Syriae. Et mansimus in Ierusalem '."
,"12":"Et factum est verbum Domini ad Ieremiam dicens:"
,"13":"' Haec dicit Dominus exercituum, Deus Israel: Vade et dic viris Iudae et habitatoribus Ierusalem: Numquid non recipietis disciplinam, ut oboediatis verbis meis?, dicit Dominus."
,"14":"Praevaluerunt sermones Ionadab filii Rechab, quos praecepit filiis suis, ut non biberent vinum, et non biberunt usque ad diem hanc, quia oboedierunt praecepto patris sui; ego autem locutus sum ad vos de mane consurgens et loquens, et non oboedistis mihi."
,"15":"Misique ad vos omnes servos meos prophetas, consurgens diluculo mittensque et dicens: Convertimini unusquisque a via sua pessima et bona facite opera vestra et nolite sequi deos alienos neque colatis eos, et habitabitis in terra, quam dedi vobis et patribus vestris, et non inclinastis aurem vestram neque audistis me."
,"16":"Firmaverunt igitur filii Ionadab filii Rechab praeceptum patris sui, quod praeceperat eis; populus autem iste non oboedivit mihi."
,"17":"Idcirco haec dicit Dominus exercituum, Deus Israel: Ecce ego adducam super Iudam et super omnes habitatores Ierusalem universam afflictionem, quam locutus sum adversum illos, eo quod locutus sum ad illos, et non audierunt, vocavi illos, et non responderunt mihi '."
,"18":"Domui autem Rechabitarum dixit Ieremias: ' Haec dicit Dominus exercituum, Deus Israel: Pro eo quod oboedistis praecepto Ionadab patris vestri et custodistis omnia mandata eius et fecistis universa, quae praecepit vobis,"
,"19":"propterea haec dicit Dominus exercituum, Deus Israel: Non deficiet vir de stirpe Ionadab filii Rechab stans in conspectu meo cunctis diebus '."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Et factum est in anno quarto Ioachim filii Iosiae regis Iudae, factum est verbum hoc ad Ieremiam a Domino dicens:"
,"2":"' Tolle volumen libri et scribes in eo omnia verba, quae locutus sum tibi adversum Israel et Iudam et adversum omnes gentes a die qua locutus sum ad te ex diebus Iosiae usque ad diem hanc,"
,"3":"si forte, audiente domo Iudae universa mala, quae ego cogito facere eis, revertatur unusquisque a via sua pessima, et propitius ero iniquitati et peccato eorum '."
,"4":"Vocavit ergo Ieremias Baruch filium Neriae; et scripsit Baruch ex ore Ieremiae omnes sermones Domini, quos locutus est ad eum, in volumine libri."
,"5":"Et praecepit Ieremias Baruch dicens: ' Ego impeditus sum nec valeo ingredi domum Domini."
,"6":"Ingredere ergo tu et lege de volumine, in quo scripsisti ex ore meo verba Domini, audiente populo in domo Domini, in die ieiunii; insuper et audiente universo Iuda, qui veniunt de civitatibus suis, leges eis,"
,"7":"si forte cadat oratio eorum in conspectu Domini, et revertatur unusquisque a via sua pessima, quoniam magnus furor et indignatio est, quam locutus est Dominus adversus populum hunc '."
,"8":"Et fecit Baruch filius Neriae iuxta omnia, quae praeceperat ei Ieremias propheta, legens ex volumine sermones Domini in domo Domini."
,"9":"Factum est autem in anno quinto Ioachim filii Iosiae regis Iudae, in mense nono, praedicaverunt ieiunium in conspectu Domini omni populo in Ierusalem et universae multitudini, quae confluxerat de civitatibus Iudae in Ierusalem."
,"10":"Legitque Baruch ex volumine sermones Ieremiae in domo Domini, in exedra Gamariae filii Saphan scribae in vestibulo superiore, in introitu portae Novae domus Domini, audiente omni populo."
,"11":"Cumque audisset Michaeas filius Gamariae filii Saphan omnes sermones Domini ex libro,"
,"12":"descendit in domum regis ad exedram scribae; et ecce ibi omnes principes sedebant: Elisama scriba et Dalaias filius Semiae et Elnathan filius Achobor et Gamarias filius Saphan et Sedecias filius Hananiae et universi principes."
,"13":"Et nuntiavit eis Michaeas omnia verba, quae audivit, legente Baruch ex volumine in auribus populi."
,"14":"Miserunt itaque omnes principes ad Baruch Iudi filium Nathaniae filii Selemiae filii Chusi dicentes: ' Volumen, ex quo legisti audiente populo, sume in manu tua et veni '. Tulit ergo Baruch filius Neriae volumen in manu sua et venit ad eos."
,"15":"Et dixerunt ad eum: ' Sede et lege haec in auribus nostris '; et legit Baruch in auribus eorum."
,"16":"Igitur cum audissent omnia verba, obstupuerunt unusquisque ad proximum suum; et dixerunt ad Baruch: 'Nuntiare debemus regi omnes sermones istos'."
,"17":"Et interrogaverunt Baruch dicentes: ' Indica nobis, quomodo scripsisti omnes sermones istos ex ore eius '."
,"18":"Dixit autem eis Baruch: ' Ex ore suo loquebatur ad me omnes sermones istos, et ego scribebam in volumine atramento '."
,"19":"Et dixerunt principes ad Baruch: ' Vade et abscondere, tu et Ieremias, et nemo sciat, ubi sitis '."
,"20":"Et ingressi sunt ad regem in atrium, porro volumen deposuerunt in exedra Elisamae scribae; et nuntiaverunt audiente rege omnes sermones."
,"21":"Misitque rex Iudi, ut sumeret volumen; qui, tollens illud de exedra Elisamae scribae, legit audiente rege et universis principibus, qui stabant circa regem."
,"22":"Rex autem sedebat in domo hiemali in mense nono, et posita erat arula coram eo plena prunis;"
,"23":"cumque legisset Iudi tres pagellas vel quattuor, scidit eas scalpello scribae et proiecit in ignem, qui erat super arulam, donec consumeretur omne volumen igni, qui erat in arula."
,"24":"Et non timuerunt neque sciderunt vestimenta sua rex et omnes servi eius, qui audierunt universos sermones istos."
,"25":"Verumtamen Elnathan et Dalaias et Gamarias instanter rogaverunt regem, ne combureret librum, et non audivit eos."
,"26":"Et praecepit rex Ierameel filio regis et Saraiae filio Azriel et Selemiae filio Abdeel, ut comprehenderent Baruch scribam et Ieremiam prophetam; abscondit autem eos Dominus."
,"27":"Et factum est verbum Domini ad Ieremiam, postquam combusserat rex volumen et sermones, quos scripserat Baruch ex ore Ieremiae, dicens:"
,"28":"'Rursum tolle volumen aliud et scribe in eo omnes sermones priores, qui erant in primo volumine, quod combussit Ioachim rex Iudae."
,"29":"Et super Ioachim regem Iudae dices: Haec dicit Dominus: Tu combussisti volumen illud dicens: 'Quare scripsisti in eo annuntians: Certe veniet rex Babylonis et vastabit terram hanc et cessare faciet ex illa hominem et iumentum?'."
,"30":"Propterea haec dicit Dominus contra Ioachim regem Iudae: Non erit ex eo, qui sedeat super solium David, et cadaver eius proicietur ad aestum per diem et ad gelu per noctem;"
,"31":"et visitabo contra eum et contra semen eius et contra servos eius iniquitates suas; et adducam super eos et super habitatores Ierusalem et super viros Iudae omne malum, quod locutus sum ad eos, et non audierunt '."
,"32":"Ieremias autem tulit volumen aliud et dedit illud Baruch filio Neriae scribae; qui scripsit in eo ex ore Ieremiae omnes sermones libri, quem combusserat Ioachim rex Iudae igni; et insuper additi sunt multi sermones similes illis."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Et regnavit rex Sedecias filius Iosiae pro Iechonia filio Ioachim; quem constituit regem Nabuchodonosor rex Babylonis in terra Iudae."
,"2":"Et non oboedivit, ipse et servi eius et populus terrae, verbis Domini, quae locutus est in manu Ieremiae prophetae."
,"3":"Et misit rex Sedecias Iuchal filium Selemiae et Sophoniam filium Maasiae sacerdotem ad Ieremiam prophetam dicens: ' Ora pro nobis Dominum Deum nostrum '."
,"4":"Ieremias autem libere ambulabat in medio populi; non enim miserant eum in custodiam carceris."
,"5":"Igitur exercitus pharaonis egressus est de Aegypto, et audientes Chaldaei, qui obsidebant Ierusalem, huiuscemodi nuntium recesserunt ab Ierusalem."
,"6":"Et factum est verbum Domini ad Ieremiam prophetam dicens:"
,"7":"' Haec dicit Dominus, Deus Israel: Sic dicetis regi Iudae, qui misit vos ad me interrogandum: Ecce exercitus pharaonis, qui egressus est vobis in auxilium, revertetur in terram suam in Aegyptum;"
,"8":"et redient Chaldaei et bellabunt contra civitatem hanc et capient eam et succendent eam igni."
,"9":"Haec dicit Dominus: Nolite decipere animas vestras dicentes: 'Euntes abibunt et recedent a nobis Chaldaei', quia non abibunt."
,"10":"Sed et si percusseritis omnem exercitum Chaldaeorum, qui proeliantur adversum vos, et derelicti fuerint ex eis aliqui vulnerati, singuli de tentorio suo consurgent et incendent civitatem hanc igni '."
,"11":"Ergo cum recessisset exercitus Chaldaeorum ab Ierusalem propter exercitum pharaonis,"
,"12":"egressus est Ieremias de Ierusalem, ut iret in terram Beniamin et divideret ibi possessionem in conspectu populi."
,"13":"Cumque pervenisset ad portam Beniamin, erat ibi custos portae nomine Ierias filius Selemiae filii Hananiae; et apprehendit Ieremiam prophetam dicens: ' Ad Chaldaeos profugis '."
,"14":"Et respondit Ieremias: ' Falsum est! Non fugio ad Chaldaeos '. Et non audivit eum; sed comprehendit Ierias Ieremiam et adduxit eum ad principes."
,"15":"Et irati sunt principes contra Ieremiam, quem caesum miserunt in carcerem, qui erat in domo Ionathan scribae; eam enim in carcerem fecerant."
,"16":"Itaque ingressus est Ieremias in domum laci fornice tectam; et sedit ibi Ieremias diebus multis."
,"17":"Mittens autem Sedecias rex tulit eum et interrogavit eum in domo sua abscondite et dixit: ' Putasne est sermo a Domino? '. Et dixit Ieremias: ' Est '; et ait: 'In manus regis Babylonis traderis '."
,"18":"Et dixit Ieremias ad regem Sedeciam: ' Quid peccavi tibi et servis tuis et populo isti, quia misistis me in domum carceris?"
,"19":"Ubi sunt prophetae vestri, qui prophetabant vobis et dicebant: 'Non veniet rex Babylonis super vos et super terram hanc'?"
,"20":"Nunc ergo audi, obsecro, domine mi rex; valeat deprecatio mea in conspectu tuo, et ne me remittas in domum Ionathan scribae, ne moriar ibi '."
,"21":"Praecepit ergo rex Sedecias, ut traderetur Ieremias in vestibulo custodiae, et daretur ei torta panis cotidie ex vico Pistorum, donec consumerentur omnes panes de civitate. Et mansit Ieremias in vestibulo custodiae."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Audivit autem Saphatias fi lius Matthan et Godolias fi lius Phassur et Iuchal filius Selemiae et Phassur filius Melchiae sermones, quos Ieremias loquebatur ad omnem populum dicens:"
,"2":"' Haec dicit Dominus: Quicumque manserit in civitate hac, morietur gladio et fame et peste; qui autem profugerit ad Chaldaeos, vivet, et erit anima eius quasi spolium et vivet."
,"3":"Haec dicit Dominus: Certe tradetur civitas haec in manu exercitus regis Babylonis, et capiet eam '."
,"4":"Et dixerunt principes regi: ' Rogamus, ut occidatur homo iste; de industria enim dissolvit manus virorum bellantium, qui remanserunt in civitate hac, et manus universi populi loquens ad eos iuxta verba haec; siquidem homo iste non quaerit pacem populo huic sed malum '."
,"5":"Et dixit rex Sedecias: ' Ecce ipse in manibus vestris est; nequit enim rex vobis quidquam negare '."
,"6":"Tulerunt ergo Ieremiam et proiecerunt eum in lacum Melchiae filii regis, qui erat in vestibulo custodiae. Et submiserunt Ieremiam funibus. Et in lacu non erat aqua sed lutum; descendit itaque Ieremias in caenum."
,"7":"Audivit autem Abdemelech Aethiops, vir eunuchus, qui erat in domo regis, quod misissent Ieremiam in lacum; porro rex sedebat in porta Beniamin."
,"8":"Et egressus est Abdemelech de domo regis et locutus est ad regem dicens:"
,"9":"' Domine mi rex, malefecerunt viri isti omnia, quaecumque perpetrarunt contra Ieremiam prophetam, mittentes eum in lacum, ut moriatur ibi fame; non sunt enim panes ultra in civitate '."
,"10":"Praecepit itaque rex Abdemelech Aethiopi dicens: ' Tolle tecum hinc triginta viros et leva Ieremiam prophetam de lacu, antequam moriatur '."
,"11":"Assumptis ergo Abdemelech secum viris, ingressus est domum regis, in conclave, quod erat sub thesauro, et tulit inde pannos ex vestibus veteribus et scissis et submisit eos ad Ieremiam in lacum per funiculos."
,"12":"Dixitque Abdemelech Aethiops ad Ieremiam: ' Pone veteres pannos et haec scissa sub scapuli et postea funes '. Fecit ergo Ieremias sic;"
,"13":"et extraxerunt Ieremiam funibus et eduxerunt eum de lacu. Mansit autem Ieremias in vestibulo custodiae."
,"14":"Et misit rex Sedecias et tulit ad se Ieremiam prophetam ad ostium tertium, quod erat in domo Domini; et dixit rex ad Ieremiam: 'Interrogo ego te sermonem, ne abscondas a me aliquid '."
,"15":"Dixit autem Ieremias ad Sedeciam: ' Si annuntiavero tibi, numquid non interficies me? Et si consilium dedero tibi, non me audies '."
,"16":"Iuravit ergo rex Sedecias Ieremiae clam dicens: ' Vivit Dominus, qui fecit nobis animam hanc, non occidam te et non tradam te in manu virorum istorum, qui quaerunt animam tuam '."
,"17":"Et dixit Ieremias ad Sedeciam: ' Haec dicit Dominus exercituum, Deus Israel: Si profectus exieris ad principes regis Babylonis, vivet anima tua, et civitas haec non succendetur igni, et salvus eris tu et domus tua;"
,"18":"si autem non exieris ad principes regis Babylonis, tradetur civitas haec in manu Chaldaeorum, et succendent eam igni, et tu non effugies de manu eorum '."
,"19":"Et dixit rex Sedecias ad Ieremiam: ' Sollicitus sum propter Iudaeos, qui transfugerunt ad Chaldaeos, ne forte tradar in manus eorum, et illudant mihi '."
,"20":"Respondit autem Ieremias: ' Non te tradent; audi, quaeso, vocem Domini, quam ego loquor ad te, et bene tibi erit, et vivet anima tua."
,"21":"Quod si nolueris egredi, iste est sermo, quem ostendit mihi Dominus:"
,"22":"Ecce omnes mulieres, quae remanserunt in domo regis Iudae, educentur ad principes regis Babylonis et ipsae dicent: 'Seduxerunt te et praevaluerunt adversum te,viri pacifici tui; demersi sunt in caeno pedes tui, illi autem recesserunt a te'."
,"23":"Et omnes uxores tuae et filii tui educentur ad Chaldaeos, et non effugies manus eorum, sed in manu regis Babylonis capieris; et civitatem hanc comburet igni '."
,"24":"Dixit ergo Sedecias ad Ieremiam: ' Nullus sciat verba haec, et non morieris."
,"25":"Si autem audierint principes quia locutus sum tecum, et venerint ad te et dixerint tibi: 'Indica nobis, quid locutus sis cum rege, ne celes nos, et non te interficiemus, et quid locutus est tecum rex',"
,"26":"dices ad eos: 'Prostravi ego preces meas coram rege, ne me reduci iuberet in domum Ionathan, et ibi morerer' '."
,"27":"Venerunt ergo omnes principes ad Ieremiam et interrogaverunt eum, et locutus est eis iuxta omnia verba, quae praeceperat ei rex; et cessaverunt ab eo: nihil enim fuerat auditum."
,"28":"Mansit vero Ieremias in vestibulo custodiae usque ad diem, quo capta est Ierusalem. Et factum est ut caperetur Ierusalem."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Anno nono Sedeciae regis Iudae, mense decimo, venit Nabuchodonosor rex Babylonis et omnis exercitus eius ad Ierusalem et obsidebant eam."
,"2":"Undecimo autem anno Sedeciae, mense quarto, nona mensis, aperta est civitas;"
,"3":"et ingressi sunt omnes principes regis Babylonis et sederunt in porta Media: Nergelsereser Samegarnabu, Sarsachim princeps eunuchorum, Nergelsereser princeps magorum et omnes reliqui principes regis Babylonis."
,"4":"Cumque vidisset eos Sedecias rex Iudae et omnes viri bellatores, fugerunt et egressi sunt nocte de civitate per viam horti regis et per portam, quae erat inter duos muros, et egressi sunt ad viam Arabae."
,"5":"Persecutus est autem eos exercitus Chaldaeorum; et comprehenderunt Sedeciam in campestribus Iericho et captum adduxerunt ad Nabuchodonosor regem Babylonis in Rebla, quae est in terra Emath; et locutus est ad eum iudicia."
,"6":"Et occidit rex Babylonis filios Sedeciae in Rebla in oculis eius, et omnes nobiles Iudae occidit rex Babylonis;"
,"7":"oculos quoque Sedeciae eruit et vinxit eum compedibus, ut duceretur in Babylonem."
,"8":"Domum quoque regis et domum vulgi succenderunt Chaldaei igni; et murum Ierusalem subverterunt."
,"9":"Et reliquias populi, quae remanserant in civitate, et perfugas, qui transfugerant ad eum, et superfluos artificum, qui remanserant, transtulit Nabuzardan magister satellitum in Babylonem."
,"10":"Et de plebe pauperum, qui nihil penitus habebant, dimisit Nabuzardan magister satellitum in terra Iudae; et dedit eis vineas et agros in die illa."
,"11":"Praeceperat autem Nabuchodonosor rex Babylonis de Ieremia Nabuzardan magistro satellitum dicens:"
,"12":"' Tolle illum et pone super eum oculos tuos nihilque ei mali facias, sed, ut voluerit, sic facies ei '."
,"13":"Misit ergo Nabuzardan princeps satellitum et Nabusezban princeps eunuchorum et Nergelsereser princeps magorum et omnes optimates regis Babylonis"
,"14":"miserunt et tulerunt Ieremiam de vestibulo custodiae et tradiderunt eum Godoliae filio Ahicam filii Saphan, ut duceret domum. Et habitavit in populo."
,"15":"Ad Ieremiam autem factus fuerat sermo Domini, cum clausus esset in vestibulo custodiae, dicens:"
,"16":"' Vade et dic Abdemelech Aethiopi dicens: Haec dicit Dominus exercituum, Deus Israel: Ecce ego inducam sermones meos super civitatem hanc in malum et non in bonum; et erunt in conspectu tuo in die illa."
,"17":"Et liberabo te in die illa, ait Dominus, et non traderis in manus virorum, quos tu formidas;"
,"18":"sed eruens liberabo te, et gladio non cades, sed erit tibi anima tua quasi spolium, quia in me habuisti fiduciam ', ait Dominus."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Sermo, qui factus est ad Ieremiam a Domino, postquam dimissus est a Nabuzardan magistro satellitum de Rama, quando tulit eum vinctum catenis in medio omnium, qui migrabant de Ierusalem et Iuda et ducebantur in Babylonem."
,"2":"Tollens ergo princeps satellitum Ieremiam, dixit ad eum: ' Dominus Deus tuus locutus est malum hoc super locum istum"
,"3":"et adduxit; et fecit Dominus, sicut locutus est, quia peccastis Domino et non audistis vocem eius, et factus est vobis sermo hic."
,"4":"Nunc ergo ecce solvi te hodie de catenis, quae sunt in manibus tuis. Si placet tibi, ut venias mecum in Babylonem, veni, et ponam oculos meos super te; si autem displicet tibi venire mecum in Babylonem, reside; ecce omnis terra in conspectu tuo est: quod elegeris et quo placuerit tibi ut vadas, illuc perge '."
,"5":"Cum nondum reverteretur, dixit: ' Revertere ad Godoliam filium Ahicam filii Saphan, quem praeposuit rex Babylonis civitatibus Iudae; habita ergo cum eo in medio populi vel quocumque placuerit tibi ut vadas, vade '. Dedit quoque ei magister satellitum cibaria et munuscula et dimisit eum."
,"6":"Venit autem Ieremias ad Godoliam filium Ahicam in Maspha et habitavit cum eo in medio populi, qui relictus fuerat in terra."
,"7":"Cumque audissent omnes principes exercitus, qui dispersi fuerant per regiones, ipsi et viri eorum, quod praefecisset rex Babylonis Godoliam filium Ahicam terrae et quod commendasset ei viros et mulieres et parvulos et de pauperibus terrae, qui non fuerant translati in Babylonem,"
,"8":"venerunt ad Godoliam in Maspha; Ismael, inquam, filius Nathaniae et Iohanan et Ionathan filii Caree et Saraia filius Thanehumeth et filii Ophi, qui erant de Netopha, et Iezonias filius Maachathi, ipsi et viri eorum."
,"9":"Et iuravit eis Godolias filius Ahicam filii Saphan et comitibus eorum dicens: 'Nolite timere servire Chaldaeis; habitate in terra et servite regi Babylonis, et bene erit vobis."
,"10":"Ecce ego habito in Maspha, ut stem coram Chaldaeis, qui veniunt ad nos; vos autem colligite vindemiam et messem et oleum et condite in vasis vestris et manete in urbibus vestris, quas tenetis '."
,"11":"Sed et omnes Iudaei, qui erant in Moab et in filiis Ammon et in Edom et in universis regionibus, audito quod dedisset rex Babylonis reliquias in Iudaea et quod praeposuisset super eos Godoliam filium Ahicam filii Saphan,"
,"12":"reversi sunt, inquam, omnes Iudaei de universis locis, ad quae profugerant, et venerunt in terram Iudae ad Godoliam in Maspha et collegerunt vinum et messem multam nimis."
,"13":"Iohanan autem filius Caree et omnes principes exercitus, qui dispersi fuerant in regionibus, venerunt ad Godoliam in Maspha"
,"14":"et dixerunt ei: ' Scito quod Baalis rex filiorum Ammon misit Ismael filium Nathaniae percutere animam tuam '; et non credidit eis Godolias filius Ahicam."
,"15":"Iohanan vero filius Caree dixit ad Godoliam seorsum in Maspha loquens: ' Ibo et percutiam Ismael filium Nathaniae, nullo sciente, ne interficiat animam tuam, et dissipentur omnes Iudaei, qui congregati sunt ad te, et peribunt reliquiae Iudae '."
,"16":"Et ait Godolias filius Ahicam ad Iohanan filium Caree: ' Noli facere verbum hoc; falsum enim tu loqueris de Ismael '."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Et factum est in mense septi mo, venit Ismael filius Nathaniae filii Elisama de semine regali et optimates regis et decem viri cum eo ad Godoliam filium Ahicam in Maspha; et comederunt ibi panes simul in Maspha."
,"2":"Surrexit autem Ismael filius Nathaniae et decem viri, qui cum eo erant, et percusserunt Godoliam filium Ahicam filii Saphan gladio; et interfecerunt eum, quem praefecerat rex Babylonis terrae."
,"3":"Omnes quoque Iudaeos, qui erant cum Godolia in Maspha, et Chaldaeos, qui reperti sunt ibi, et viros bellatores percussit Ismael."
,"4":"Secundo autem die postquam occiderat Godoliam, nullo adhuc sciente,"
,"5":"venerunt viri de Sichem et de Silo et de Samaria, octoginta viri, rasi barba et scissis vestibus et incisi in cute, et munera et tus habebant in manu, ut offerrent in domo Domini."
,"6":"Egressus ergo Ismael filius Nathaniae in occursum eorum de Maspha, incedens et plorans ibat. Cum autem occurrisset eis, dixit ad eos: ' Venite ad Godoliam filium Ahicam '."
,"7":"Qui cum venissent ad medium civitatis, interfecit eos Ismael filius Nathaniae et proiecit in medium laci, ipse et viri, qui erant cum eo."
,"8":"Decem autem viri reperti sunt inter eos, qui dixerunt ad Ismael: ' Noli occidere nos, quia habemus thesauros in agro, frumenti et hordei et olei et mellis '; et cessavit et non interfecit eos cum fratribus suis."
,"9":"Lacus autem, in quem proiecerat Ismael omnia cadavera virorum, quos percussit, est lacus magnus, quem fecit rex Asa propter Baasa regem Israel; ipsum replevit Ismael filius Nathaniae occisis."
,"10":"Et captivas duxit Ismael omnes reliquias populi, qui erant in Maspha, filias regis et universum populum, qui remanserat in Maspha, quos commendaverat Nabuzardan princeps satellitum Godoliae filio Ahicam; et cepit eos Ismael filius Nathaniae et abiit, ut transiret ad filios Ammon."
,"11":"Audivit autem Iohanan filius Caree et omnes principes bellatorum, qui erant cum eo, omne malum, quod fecerat Ismael filius Nathaniae,"
,"12":"et, assumptis universis viris, profecti sunt, ut bellarent adversum Ismael filium Nathaniae; et invenerunt eum ad aquas multas, quae sunt in Gabaon."
,"13":"Cumque vidisset omnis populus, qui erat cum Ismael, Iohanan filium Caree et universos principes bellatorum, qui erant cum eo, laetati sunt."
,"14":"Et omnis populus, quem ceperat Ismael in Maspha, reversus est et abiit ad Iohanan filium Caree;"
,"15":"Ismael autem filius Nathaniae fugit cum octo viris a facie Iohanan et abiit ad filios Ammon."
,"16":"Tulit ergo Iohanan filius Caree et omnes principes bellatorum, qui erant cum eo, universas reliquias vulgi, quas reduxerat ab Ismael filio Nathaniae venientes de Maspha, postquam percussit Godoliam filium Ahicam, viros fortes ad proelium et mulieres et pueros et eunuchos, quos reduxerat de Gabaon."
,"17":"Et abierunt et sederunt in Gherutchamaam, quae est iuxta Bethlehem, ut pergerent et introirent Aegyptum"
,"18":"a facie Chaldaeorum; timebant enim eos, quia percusserat Ismael filius Nathaniae Godoliam filium Ahicam, quem praeposuerat rex Babylonis in regione."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Et accesserunt omnes princi pes bellatorum, scilicet Iohanan filius Caree et Iezonias filius Osaiae et universum vulgus, a parvo usque ad magnum,"
,"2":"dixeruntque ad Ieremiam prophetam: ' Cadat oratio nostra in conspectu tuo, et ora pro nobis ad Dominum Deum tuum pro universis reliquiis istis, quia derelicti sumus pauci de pluribus, sicut oculi tui nos intuentur;"
,"3":"et annuntiet nobis Dominus Deus tuus viam, per quam pergamus, et verbum, quod faciamus '."
,"4":"Dixit autem ad eos Ieremias propheta: ' Audivi. Ecce ego oro ad Dominum Deum vestrum secundum verba vestra; omne verbum, quodcumque responderit pro vobis, indicabo vobis nec celabo vos quidquam '."
,"5":"Et illi dixerunt ad Ieremiam: ' Sit Dominus inter nos testis verax et fidelis, si non iuxta omne verbum, in quo miserit te Dominus Deus tuus ad nos, sic faciemus."
,"6":"Sive bonum est sive malum, voci Domini Dei nostri, ad quem mittimus te, oboediemus, ut bene sit nobis, cum audierimus vocem Domini Dei nostri '."
,"7":"Cum autem completi essent decem dies, factum est verbum Domini ad Ieremiam;"
,"8":"vocavitque Iohanan filium Caree et omnes principes bellatorum, qui erant cum eo, et universum populum a minimo usque ad magnum"
,"9":"et dixit ad eos: ' Haec dicit Dominus, Deus Israel, ad quem misistis me, ut prosternerem preces vestras in conspectu eius:"
,"10":"Si quiescentes manseritis in terra hac, aedificabo vos et non destruam, plantabo et non evellam; iam enim placatus sum super malo, quod feci vobis."
,"11":"Nolite timere a facie regis Babylonis, quem vos pavidi formidatis; nolite metuere eum, dicit Dominus, quia vobiscum sum ego, ut salvos vos faciam et eruam de manu eius;"
,"12":"et dabo vobis, ut misericordiam inveniatis, et ipse miserebitur vestri et habitare vos faciet in terra vestra."
,"13":"Si autem dixeritis vos: 'Non habitabimus in terra ista', nec audieritis vocem Domini Dei vestri"
,"14":"dicentes: 'Nequaquam, sed ad terram Aegypti pergemus, ubi non videbimus bellum et clangorem tubae non audiemus et famem non sustinebimus et ibi habitabimus',"
,"15":"propter hoc nunc audite verbum Domini, reliquiae Iudae: Haec dicit Dominus exercituum, Deus Israel: Si posueritis faciem vestram, ut ingrediamini Aegyptum, et intraveritis, ut ibi peregrinemini,"
,"16":"gladius, quem vos formidatis, ibi comprehendet vos in terra Aegypti, et fames, pro qua estis solliciti, adhaerebit vobis in Aegypto, et ibi moriemini."
,"17":"Omnesque viri, qui posuerunt faciem suam, ut ingrediantur Aegyptum et peregrinentur ibi, morientur gladio et fame et peste: nullus de eis remanebit nec effugiet a facie mali, quod ego afferam super eos."
,"18":"Quia haec dicit Dominus exercituum, Deus Israel: Sicut effusus est furor meus et indignatio mea super habitatores Ierusalem, sic effundetur indignatio mea super vos, cum ingressi fueritis Aegyptum, et eritis in exsecrationem et in stuporem et in maledictum et in opprobrium et nequaquam ultra videbitis locum istum '."
,"19":"Verbum Domini super vos, reliquiae Iudae: ' Nolite intrare Aegyptum; scientes scietis quia obtestatus sum vos hodie,"
,"20":"quia decepistis animas vestras. Vos enim misistis me ad Dominum Deum nostrum dicentes: 'Ora pro nobis ad Dominum Deum nostrum et iuxta omnia, quaecumque dixerit tibi Dominus Deus noster, sic annuntia nobis, et faciemus'."
,"21":"Et annuntiavi vobis hodie, et non audistis vocem Domini Dei vestri super universis, pro quibus misit me ad vos."
,"22":"Nunc ergo scientes scietis quia gladio et fame et peste moriemini in loco, ad quem voluistis intrare et ibi peregrinari '."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Factum est autem, cum complesset Ieremias loquens ad populum universos sermones Domini Dei eorum, pro quibus miserat eum Dominus Deus eorum ad illos omnia verba haec,"
,"2":"dixit Azarias filius Osaiae et Iohanan filius Caree et omnes viri superbi dicentes ad Ieremiam: ' Mendacium tu loqueris; non misit te Dominus Deus noster dicens: 'Ne ingrediamini Aegyptum, ut illic peregrinemini',"
,"3":"sed Baruch filius Neriae incitat te adversum nos, ut tradat nos in manu Chaldaeorum, ut interficiant nos et traducant in Babylonem '."
,"4":"Et non audivit Iohanan filius Caree et omnes principes bellatorum et universus populus vocem Domini, ut manerent in terra Iudae."
,"5":"Sed tollens Iohanan filius Caree et universi principes bellatorum universos reliquiarum Iudae, qui reversi fuerant de cunctis gentibus, ad quas fuerant ante dispersi, ut peregrinarentur in terra Iudae,"
,"6":"viros et mulieres et parvulos et filias regis et omnem animam, quam reliquerat Nabuzardan princeps satellitum cum Godolia filio Ahicam filii Saphan, et Ieremiam prophetam et Baruch filium Neriae,"
,"7":"et ingressi sunt terram Aegypti, quia non oboedierunt voci Domini; et venerunt usque ad Taphnas."
,"8":"Et factus est sermo Domini ad Ieremiam in Taphnis dicens:"
,"9":"' Sume lapides grandes in manu tua et absconde eos in caemento, sub pavimento, quod est ad portam domus pharaonis in Taphnis, cernentibus viris Iudaeis;"
,"10":"et dices ad eos: Haec dicit Dominus exercituum, Deus Israel: Ecce ego mittam et assumam Nabuchodonosor regem Babylonis servum meum et ponam thronum eius super lapides istos, quos abscondi, et statuet solium suum super eos;"
,"11":"veniensque percutiet terram Aegypti, quos in mortem, in mortem et, quos in captivitatem, in captivitatem et, quos in gladium, in gladium;"
,"12":"et succendet ignem in delubris deorum Aegypti et comburet ea et captivos ducet illos et excutiet terram Aegypti, sicut pastor pediculis excutit pallium suum, et egredietur inde in pace;"
,"13":"et conteret statuas domus Solis, quae sunt in terra Aegypti, et delubra deorum Aegypti comburet igni '."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Verbum, quod factum est per Ieremiam ad omnes Iudaeos, qui habitabant in terra Aegypti, habitantes in Magdolo et in Taphnis et in Memphi et in terra Phatures, dicens:"
,"2":"' Haec dicit Dominus exercituum, Deus Israel: Vos vidistis omne malum istud, quod adduxi super Ierusalem et super omnes urbes Iudae; et ecce desertae sunt hodie, et non est in eis habitator"
,"3":"propter malitiam, quam fecerunt, ut me ad iracundiam provocarent et irent, ut sacrificarent et colerent deos alienos, quos nesciebant et illi et vos et patres vestri."
,"4":"Et misi ad vos omnes servos meos prophetas, de nocte consurgens mittensque et dicens: Nolite facere verbum abominationis huiuscemodi, quam odivi."
,"5":"Et non audierunt nec inclinaverunt aurem suam, ut converterentur a malis suis et non sacrificarent diis alienis;"
,"6":"et effusa est indignatio mea et furor meus et succensa est in civitatibus Iudae et in plateis Ierusalem, et versae sunt in solitudinem et vastitatem secundum diem hanc."
,"7":"Et nunc haec dicit Dominus exercituum, Deus Israel: Quare vos facitis malum grande contra animas vestras, ut intereat ex vobis vir et mulier, parvulus et lactans de medio Iudae, nec relinquatur vobis quidquam residuum,"
,"8":"provocantes me in operibus manuum vestrarum, sacrificando diis alienis in terra Aegypti, in quam ingressi estis, ut ibi peregrinemini, et dissipet vos, et sitis in maledictionem et in opprobrium cunctis gentibus terrae?"
,"9":"Numquid obliti estis mala patrum vestrorum et mala regum Iudae et mala uxorum eius et mala vestra et mala uxorum vestrarum, quae fecerunt in terra Iudae et in plateis Ierusalem?"
,"10":"Non sunt contriti usque ad diem hanc et non timuerunt et non ambulaverunt in lege mea et in praeceptis meis, quae dedi coram vobis et coram patribus vestris."
,"11":"Ideo haec dicit Dominus exercituum, Deus Israel: Ecce ego ponam faciem meam in vobis in malum et disperdam omnem Iudam."
,"12":"Et assumam reliquias Iudae, qui posuerunt facies suas, ut ingrederentur terram Aegypti et peregrinarentur ibi, et consumentur omnes in terra Aegypti: cadent in gladio et in fame et consumentur a minimo usque ad maximum, in gladio et in fame morientur; et erunt in exsecrationem et in stuporem et in maledictionem et in opprobrium."
,"13":"Et visitabo super habitatores terrae Aegypti, sicut visitavi super Ierusalem, in gladio et in fame et in peste:"
,"14":"et non erit qui effugiat et sit residuus de reliquiis Iudaeorum, qui venerunt, ut peregrinarentur in terra Aegypti et reverterentur in terram Iudae, ad quam ipsi elevant animas suas, ut revertantur et habitent ibi; non revertentur, nisi qui fugerint '."
,"15":"Responderunt autem Ieremiae omnes viri, scientes quod sacrificarent uxores eorum diis alienis, et universae mulieres, quarum stabat multitudo grandis, et omnis populus habitantium in terra Aegypti in Phatures, dicentes:"
,"16":"' Sermonem, quem locutus es ad nos in nomine Domini, non audiemus ex te,"
,"17":"sed facientes faciemus omne verbum, quod egressum est de ore nostro, ut sacrificemus reginae caeli et libemus ei libamina, sicut fecimus nos et patres nostri, reges nostri et principes nostri in urbibus Iudae et in plateis Ierusalem, et saturati sumus panibus et bene nobis erat malumque non vidimus."
,"18":"Ex eo autem tempore, quo cessavimus sacrificare reginae caeli et libare ei libamina, indigemus omnibus et gladio et fame consumpti sumus."
,"19":"Quod si nos sacrificamus reginae caeli et libamus ei libamina, numquid sine viris nostris fecimus ei placentas ad effingendum eam et libandum ei libamina? '."
,"20":"Et dixit Ieremias ad omnem populum, adversum viros et adversum mulieres et adversum universam plebem, qui responderant ei verbum, dicens:"
,"21":"' Numquid non sacrificium, quod sacrificastis in civitatibus Iudae et in plateis Ierusalem, vos et patres vestri, reges vestri et principes vestri et populus terrae, horum recordatus est Dominus, et ascendit super cor eius?"
,"22":"Et non poterat Dominus ultra portare propter malitiam operum vestrorum et propter abominationes, quas fecistis; et facta est terra vestra in desolationem et in stuporem et in maledictum, eo quod non sit habitator, sicut est dies haec."
,"23":"Propterea quod sacrificaveritis et peccaveritis Domino et non audieritis vocem Domini et in lege et in praeceptis et in testimoniis eius non ambulaveritis, idcirco evenerunt vobis mala haec, sicut est dies haec '."
,"24":"Dixit autem Ieremias ad omnem populum et ad universas mulieres: ' Audite verbum Domini, omnis Iuda, qui estis in terra Aegypti."
,"25":"Haec dicit Dominus exercituum, Deus Israel, dicens: Vos et uxores vestrae locuti estis ore vestro et manibus vestris implestis dicentes: 'Faciamus vota nostra, quae vovimus, ut sacrificemus reginae caeli et libemus ei libamina'. Implete vota vestra et opere perpetrate ea."
,"26":"Ideo audite verbum Domini, omnis Iuda, qui habitatis in terra Aegypti: Ecce ego iuravi in nomine meo magno, ait Dominus, quia nequaquam ultra vocabitur nomen meum ex ore omnis viri Iudae dicentis: 'Vivit Dominus Deus', in omni terra Aegypti."
,"27":"Ecce ego vigilabo super eos in malum et non in bonum, et consumentur omnes viri Iudae, qui sunt in terra Aegypti, gladio et fame, donec penitus consumantur."
,"28":"Et, qui fugerint gladium, revertentur de terra Aegypti in terram Iudae, viri pauci, et scient omnes reliquiae Iudae, quae ingressae sunt terram Aegypti, ut peregrinarentur ibi, cuius sermo compleatur, meus an illorum."
,"29":"Et hoc vobis signum, ait Dominus, quod visitem ego super vos in loco isto, ut sciatis quia vere complebuntur sermones mei contra vos in malum."
,"30":"Haec dicit Dominus: Ecce ego tradam pharaonem Ophree, regem Aegypti, in manu inimicorum eius et in manu quaerentium animam illius, sicut tradidi Sedeciam regem Iudae in manu Nabuchodonosor regis Babylonis inimici sui et quaerentis animam eius '."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Verbum, quod locutus est Ieremias propheta ad Baruch filium Neriae, cum scriberet verba haec in libro ex ore Ieremiae, anno quarto Ioachim filii Iosiae regis Iudae, dicens:"
,"2":"' Haec dicit Dominus, Deus Israel, super te, Baruch."
,"3":"Dixisti: 'Vae misero mihi, quoniam addidit Dominus dolorem maerori meo; laboravi in gemitu meo et requiem non inveni'."
,"4":"Haec dices ad eum: Sic dicit Dominus: Ecce, quod aedificavi, ego destruo et, quod plantavi, ego evello, universam terram hanc;"
,"5":"et tu quaeris tibi grandia? Noli quaerere, quia ecce ego adducam malum super omnem carnem, ait Dominus, et dabo tibi animam tuam quasi spolium in omnibus locis, ad quaecumque perrexeris '."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Quod factum est verbum Domini ad Ieremiam prophetam contra gentes."
,"2":"Ad Aegyptum. Adversum exercitum pharaonis Nechao regis Aegypti, qui erat iuxta fluvium Euphraten in Charchamis, quem percussit Nabuchodonosor rex Babylonis in quarto anno Ioachim filii Iosiae regis Iudae."
,"3":"' Praeparate scutum et clipeum,et procedite ad bellum."
,"4":"Iungite equos et ascendite, equites; state in galeis, polite lanceas, induite vos loricis."
,"5":"Quid igitur? Vidi ipsos pavidos et terga vertentes, fortes eorum caesos; fugerunt conciti nec respexerunt: terror undique, ait Dominus."
,"6":"Non fugiat velox, nec salvari se putet fortis; ad aquilonem iuxta flumen Euphraten,victi sunt et ruerunt."
,"7":"Quis est iste, qui quasi Nilus ascendit, et veluti fluviorum intumescunt gurgites eius?"
,"8":"Aegyptus Nili instar ascendit, et velut flumina moventur fluctus eius, et dixit: 'Ascendens operiam terram, perdam civitatem et habitatores eius'."
,"9":"Ascendite, equi, et irruite, currus; et procedant fortes, Aethiopia et Phut tenentes scutum et Ludii arripientes et iacientes sagittas."
,"10":"Dies autem ille Domini, Dei exercituum, dies ultionis, ut sumat vindictam de inimicis suis: devorat gladius, et saturatur, et inebriatur sanguine eorum; victima enim Domini, Dei exercituum, in terra aquilonis iuxta flumen Euphraten."
,"11":"Ascende in Galaad et tolle resinam, virgo filia Aegypti; frustra multiplicas medicamina, tibi vero cicatrix non obducitur."
,"12":"Audierunt gentes ignominiam tuam, et ululatus tuus replevit terram, quia fortis impegit in fortem, et ambo pariter conciderunt '."
,"13":"Verbum, quod locutus est Dominus ad Ieremiam prophetam super eo quod veniret Nabuchodonosor rex Babylonis percussurus terram Aegypti."
,"14":"' Annuntiate Aegypto,et auditum facite in Magdolo, et resonet in Memphi et in Taphnis, dicite: 'Sta et praepara te, quia devoravit gladius ea, quae per circuitum tuum sunt'."
,"15":"Quare deiectus est fortis tuus?,Non stetit, quoniam Dominus subvertit eum."
,"16":"Multiplicavit ruentes, ceciditque vir ad proximum suum, et dixerunt: 'Surge, et revertamur ad populum nostrum,et ad terram nativitatis nostrae, a facie gladii saevientis'."
,"17":"Vocate nomen pharaonis regis Aegypti: Tumultum, qui praetermisit tempus opportunum."
,"18":"Vivo ego, inquit rex, Dominus exercituum nomen eius, quoniam sicut Thabor in montibus,et sicut Carmelus ad mare veniet."
,"19":"Vasa transmigrationis fac tibi, habitatrix filia Aegypti, quia Memphis in solitudinem erit,et destruetur et inhabitabilis erit."
,"20":"Vitula elegans atque formosa Aegyptus, stimulus ab aquilone venit ei."
,"21":"Mercennarii quoque eius, qui versabantur in medio eius quasi vituli saginati, versi sunt et fugerunt simul,nec stare potuerunt, quia dies interfectionis eorum venit super eos, tempus visitationis eorum."
,"22":"Vox eius quasi serpentis sibilantis, quoniam cum exercitu properabunt et cum securibus venient ei, quasi caedentes ligna."
,"23":"Succiderunt saltum eius, ait Dominus, qui supputari non potest; multiplicati sunt enim super locustas, et non est eis numerus."
,"24":"Confusa est filia Aegypti,et tradita in manu populi aquilonis '."
,"25":"Dixit Dominus exercituum, Deus Israel: ' Ecce ego visitabo super Amon de No et super pharaonem et super Aegyptum et super deos eius et super reges eius et super pharaonem et super eos, qui confidunt in eo;"
,"26":"et dabo eos in manu quaerentium animam eorum et in manu Nabuchodonosor regis Babylonis et in manu servorum eius; et post haec habitabitur sicut diebus pristinis, ait Dominus."
,"27":"Et tu ne timeas, serve meus Iacob, et ne paveas, Israel, quia ecce ego salvum te faciam de longinquo,et semen tuum de terra captivitatis eorum; et revertetur Iacob et requiescet, securus erit, et non erit qui exterreat eum."
,"28":"Et tu noli timere, serve meus Iacob, ait Dominus, quia tecum ego sum, quia ego consumam cunctas gentes, ad quas eieci te; te vero non consumam, sed castigabo te in iudicio,nec quasi innocenti parcam tibi '."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Quod factum est verbum Domini ad Ieremiam prophe tam contra Philisthim, antequam percuteret pharao Gazam."
,"2":"Haec dicit Dominus: ' Ecce, aquae ascendunt ab aquilone,et erunt quasi torrens inundans,et operient terram et plenitudinem eius, urbem et habitatores eius. Clamabunt homines, et ululabunt omnes habitatores terrae"
,"3":"a strepitu ungularum fortium equorum eius, a commotione quadrigarum eius,et tumultu rotarum illius; non respexerunt patres filios, manibus dissolutis,"
,"4":"pro adventu diei, in quo vastabuntur omnes Philisthim, et dissipabitur Tyro et Sidoni omnis superstes auxiliator: depopulatus est enim Dominus Philisthim, reliquias insulae Caphtor."
,"5":"Venit calvitium super Gazam, conticuit Ascalon; reliquiae Enacim, usquequo incidetis vos?"
,"6":"O mucro Domini, usquequo non quiesces?,Ingredere in vaginam tuam, refrigerare et sile."
,"7":"Quomodo quiescet, cum Dominus praeceperit ei adversus Ascalonem,et adversus maritimas regiones,ibique condixerit illi? '."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Ad Moab. Haec dicit Dominus exercituum, Deus Israel: ' Vae super Nabo, quoniam vastata est et confusa!,Capta est Cariathaim, confusa est arx et tremuit."
,"2":"Non est ultra exsultatio in Moab; in Hesebon cogitaverunt malum contra eam: 'Venite et disperdamus eam de gente'. Tu quoque, Madmen, conticesces, sequeturque te gladius."
,"3":"Vox clamoris de Oronaim: 'Vastitas et contritio magna'."
,"4":"Contrita est Moab, auditum fecerunt clamorem usque ad Segor."
,"5":"Per ascensum enim Luith,plorans ascendit in fletu, quoniam in descensu Oronaim,hostes ululatum contritionis audierunt:"
,"6":"'Fugite, salvate animas vestras,et eritis quasi myricae in deserto'."
,"7":"Pro eo enim quod habuisti fiduciam,in operibus tuis et in thesauris tuis, tu quoque capieris; et ibit Chamos in transmigrationem, sacerdotes eius et principes eius simul."
,"8":"Et veniet praedo ad omnem urbem, et urbs nulla salvabitur; et peribit vallis, et dissipabuntur campestria, quoniam dixit Dominus."
,"9":"Date pennas ad volandum; et civitates eius desertae erunt et inhabitabiles."
,"10":"Maledictus, qui facit opus Domini neglegenter, et maledictus, qui prohibet gladium suum a sanguine."
,"11":"Securus fuit Moab ab adulescentia sua,et requievit in faecibus suis,nec transfusus est de vase in vas,et in transmigrationem non abiit; idcirco permansit gustus eius in eo, et odor eius non est immutatus."
,"12":"Propterea, ecce, dies veniunt, dicit Dominus, et mittam ei stratores laguncularum; et sternent eum,et vasa eius exhaurient,et lagunculas eorum collident."
,"13":"Et confundetur Moab a Chamos, sicut confusa est domus Israel a Bethel, in qua habebat fiduciam."
,"14":"Quomodo dicitis: 'Fortes sumus,et viri robusti ad proeliandum'?"
,"15":"Vastata est Moab, et ascenderunt civitates illius, et electi iuvenes eius descenderunt in occisionem, ait rex, Dominus exercituum nomen eius."
,"16":"Prope est interitus Moab ut veniat, et malum eius velociter accurret nimis."
,"17":"Lugete super eum, omnes, qui estis in circuitu eius; et universi, qui scitis nomen eius, dicite: 'Quomodo confracta est virga fortis, baculus gloriosus?'."
,"18":"Descende de gloria et sede in siti, habitatrix filia Dibon, quoniam vastator Moab ascendit ad te, dissipavit munitiones tuas."
,"19":"Ad viam sta et prospice, habitatrix Aroer; interroga fugientem,et eam, quae evasit. Dic: 'Quid accidit?'."
,"20":"Confusus est Moab, quoniam victus est. Ululate et clamate; annuntiate in Arnon, quoniam vastatus est Moab."
,"21":"Et iudicium venit ad terram campestrem super Helon et super Iasa et super Mephaath"
,"22":"et super Dibon et super Nabo et super Bethdeblathaim,"
,"23":"et super Cariathaim et super Bethgamul et super Bethmaon"
,"24":"et super Carioth et super Bosra et super omnes civitates terrae Moab, quae longe et quae prope sunt."
,"25":"Abscissum est cornu Moab, et brachium eius contritum est, ait Dominus."
,"26":"Inebriate eum, quoniam contra Dominum erectus est; et allidet manum Moab in vomitu suo, et erit in derisum etiam ipse."
,"27":"Nonne in derisum tibi fuit Israel? Num inter fures repertus est? Quotiescumque enim adversum illum loquebaris, caput movebas."
,"28":"Relinquite civitates et habitate in petra, habitatores Moab, et estote quasi columba nidificans,in parietibus apertae voraginis."
,"29":"Audivimus superbiam Moab, superbus est valde; sublimitatem eius et arrogantiam,et superbiam et altitudinem cordis eius."
,"30":"Ego scio, ait Dominus, iactantiam eius, et quod non sint rectae fabulationes, nec recta fecerint."
,"31":"Ideo super Moab eiulabo et super Moab universam clamabo, super viros Cirhareseth plorabitur."
,"32":"Plus quam in planctu Iazer plorabo tibi, vinea Sabama; propagines tuae transierunt mare, usque ad Iazer pervenerunt. Super messem tuam et vindemiam tuam,praedo irruit."
,"33":"Ablata est laetitia et exsultatio,de horto et de terra Moab, et vinum de torcularibus sustuli; nequaquam calcator uvae,solitum celeuma cantabit."
,"34":"De clamore Hesebon usque Eleale et Iasa dederunt vocem suam, a Segor usque ad Oronaim, ad Eglatselisiam; aquae quoque Nemrim pessimae erunt."
,"35":"Et auferam de Moab, ait Dominus, offerentem in excelsis et sacrificantem diis eius."
,"36":"Propterea cor meum ad Moab quasi tibia resonabit, et cor meum ad viros Cirhareseth dabit sonitum tibiarum; quia depositum, quod acquisierunt, periit."
,"37":"Omne enim caput calvitium et omnis barba rasa erit, in cunctis manibus incisiones et super lumbos cilicium."
,"38":"Super omnia tecta Moab et in plateis eius omnis planctus, quoniam contrivi Moab sicut vas, quod nemini placet, ait Dominus."
,"39":"Quomodo victa est, et ululaverunt? Quomodo vertit dorsum Moab et confusus est? Eritque Moab in derisum et in terrorem omnibus in circuitu suo."
,"40":"Haec dicit Dominus: Ecce quasi aquila volabit,et extendet alas suas ad Moab."
,"41":"Capta sunt oppida, et munitiones comprehensae sunt, et erit cor fortium Moab in die illa,sicut cor mulieris parturientis."
,"42":"Et cessabit Moab esse populus, quoniam contra Dominum gloriatus est."
,"43":"Pavor et fovea et laqueus super te, o habitator Moab, dicit Dominus."
,"44":"Qui fugerit a facie pavoris, cadet in foveam, et, qui conscenderit de fovea, capietur laqueo; adducam enim super Moab,annum visitationis eorum, ait Dominus."
,"45":"In umbra Hesebon steterunt sine viribus fugientes, sed ignis egressus est de Hesebon, et flamma de medio Sehon, et devoravit tempora Moab,et verticem filiorum tumultus."
,"46":"Vae tibi, Moab!,Periit populus Chamos, quia comprehensi sunt filii tui,et filiae tuae in captivitatem."
,"47":"Et convertam sortem Moab in novissimis diebus ', ait Dominus. Hucusque iudicia Moab."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Ad filios Ammon. Haec dicit Dominus: ' Numquid filii non sunt Israel, aut heres non est ei?,Cur igitur hereditate possedit Melchom Gad, et populus eius in urbibus eius habitavit?"
,"2":"Ideo ecce dies veniunt, dicit Dominus, et auditum faciam super Rabba filiorum Ammon,fremitum proelii; et erit in tumulum dissipata, filiaeque eius igni succendentur, et possidebit Israel possessores suos, ait Dominus."
,"3":"Ulula, Hesebon, quoniam vastata es, ut sis in acervum lapidum; clamate, filiae Rabba, accingite vos ciliciis, plangite,et circuite per muros, quoniam Melchom in transmigrationem ducetur, sacerdotes eius et principes eius simul."
,"4":"Quid gloriaris in vallibus?,Copiose fluxit vallis tua, filia rebellis, quae confidebas in thesauris tuis,et dicebas: 'Quis veniet ad me?'."
,"5":"Ecce ego inducam super te terrorem, ait Dominus, Deus exercituum, ab omnibus, qui sunt in circuitu tuo; et dispergemini singuli in viam suam, nec erit qui congreget fugientes."
,"6":"Et post haec convertam,sortem filiorum Ammon ', ait Dominus."
,"7":"Ad Edom. Haec dicit Dominus exercituum: ' Numquid non ultra est sapientia in Theman?,Periit consilium a prudentibus, inutilis facta est sapientia eorum."
,"8":"Fugite, terga vertite, descendite in voraginem, habitatores Dedan, quoniam perditionem Esau adduxi super eum, tempore quo visitavi eum."
,"9":"Si vindemiatores veniunt super te, non relinquent racemum; si fures in nocte, diripiunt, quod placet sibi."
,"10":"Ego vero discooperui Esau, revelavi abscondita eius, et celari non poterit; vastatum est semen eius,et fratres eius et vicini eius, et non erit."
,"11":"Relinque pupillos tuos, ego faciam eos vivere; et viduae tuae in me sperabunt."
,"12":"Quia haec dicit Dominus: Ecce quibus non erat iudicium, ut biberent calicem, bibentes bibent; et tu quasi innocens relinqueris? Non eris innocens, sed bibens bibes."
,"13":"Quia per memetipsum iuravi, dicit Dominus, quod in solitudinem et in opprobrium et in desertum et in maledictionem erit Bosra; et omnes civitates eius erunt in solitudines sempiternas '."
,"14":"Auditum audivi a Domino, et legatus ad gentes missus est: ' Congregamini et venite contra eam,et consurgite in proelium '."
,"15":"' Ecce enim parvulum dedi te in gentibus, contemptibilem inter homines."
,"16":"Arrogantia tua decepit te, et superbia cordis tui, qui habitas in cavernis petrae,et tenes altitudinem collis; cum exaltaveris quasi aquila nidum tuum, inde detraham te, dicit Dominus."
,"17":"Et erit Edom in desolationem: omnis, qui transibit per eam, stupebit et sibilabit super omnes plagas eius."
,"18":"Sicut subversa est Sodoma et Gomorra et vicinae eius, ait Dominus, non habitabit ibi vir, et non peregrinabitur in ea filius hominis."
,"19":"Ecce quasi leo ascendet de silva condensa Iordanis ad prata semper virentia, quia subito currere faciam eos ex illa; et, qui erit electus, illum praeponam ei. Quis enim similis mei? Et quis vocabit me in iudicium? Et quis est iste pastor, qui resistat vultui meo?"
,"20":"Propterea audite consilium Domini, quod iniit de Edom, et cogitationes eius, quas cogitavit de habitatoribus Theman: Certe abstrahent parvulos gregis, certe desolabuntur super eos pascua eorum."
,"21":"A voce ruinae eorum commota est terra, clamor in mari Rubro auditus est ocis eius."
,"22":"Ecce quasi aquila ascendet et volabit,et expandet alas suas super Bosram; et erit cor fortium Edom in die illa,quasi cor mulieris parturientis '."
,"23":"Ad Damascum. ' Confusa est Emath et Arphad, quia auditum pessimum audierunt; turbati sunt in mari sollicitudinis, quod quiescere non potuit."
,"24":"Dissoluta est Damascus, versa in fugam; tremor apprehendit eam, angustia et dolores tenuerunt eam,quasi parturientem."
,"25":"Quomodo non erit derelicta civitas laudabilis, urbs laetitiae?"
,"26":"Ideo cadent iuvenes eius in plateis eius, et omnes viri proelii conticescent in die illa, ait Dominus exercituum."
,"27":"Et succendam ignem in muro Damasci, et devorabit moenia Benadad '."
,"28":"Ad Cedar et ad regna Asor, quae percussit Nabuchodonosor rex Babylonis. Haec dicit Dominus: ' Surgite, ascendite ad Cedar,et vastate filios orientis."
,"29":"Tabernacula eorum et greges eorum capient; tentoria eorum et omnia vasa eorum,et camelos eorum tollent sibi; et vocabunt super eos formidinem in circuitu."
,"30":"Fugite, abite vehementer, in voraginibus sedete, qui habitatis Asor, ait Dominus; iniit enim contra vos,Nabuchodonosor rex Babylonis consilium,et cogitavit adversum vos cogitationes."
,"31":"Consurgite, et ascendite,ad gentem quietam et habitantem confidenter, ait Dominus; non ostia nec vectes eis: soli habitant."
,"32":"Et erunt cameli eorum in direptionem, et multitudo iumentorum in praedam; et dispergam eos in omnem ventum, qui sunt attonsi in comam, et ex omni confinio eorum,adducam interitum super eos, ait Dominus."
,"33":"Et erit Asor in habitaculum thoum, deserta usque in aeternum; non manebit ibi vir, nec peregrinabitur in ea filius hominis '."
,"34":"Quod factum est verbum Domini ad Ieremiam prophetam super Elam, in principio regni Sedeciae regis Iudae, dicens:"
,"35":"' Haec dicit Dominus exercituum: Ecce ego confringam arcum Elam, summam fortitudinem eorum;"
,"36":"et inducam super Elam,quattuor ventos a quattuor plagis caeli, et ventilabo eos in omnes ventos istos, et non erit gens, ad quam non perveniant profugi Elam."
,"37":"Et pavere faciam Elam coram inimicis suis,et in conspectu quaerentium animam eorum; et adducam super eos malum,iram furoris mei, dicit Dominus, et mittam post eos gladium, donec consumam eos."
,"38":"Et ponam solium meum in Elam,et perdam inde regem et principes, ait Dominus."
,"39":"In novissimis autem diebus,convertam sortem Elam ', dicit Dominus."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Verbum, quod locutus est Dominus de Babylone et de terra Chaldaeorum in manu Ieremiae prophetae:"
,"2":"' Annuntiate in gentibus et auditum facite, levate signum; praedicate et nolite celare, dicite: 'Capta est Babylon, confusus est Bel, victus est Merodach. Confusa sunt sculptilia eius, superata sunt idola eorum'."
,"3":"Quoniam ascendit contra eam gens ab aquilone, quae ponet terram eius in solitudinem, et non erit qui habitet in ea ab homine usque ad pecus: et moti sunt et abierunt."
,"4":"In diebus illis et in tempore illo, ait Dominus, venient filii Israel ipsi et filii Iudae simul; ambulantes et flentes properabunt et Dominum Deum suum quaerent."
,"5":"De Sion interrogabunt, ad cuius viam facies eorum: 'Venite, et apponamur ad Dominum foedere sempiterno, quod nulla oblivione delebitur'."
,"6":"Grex perditus factus est populus meus, pastores eorum seduxerunt eos feceruntque vagari in montibus; de monte in collem transierunt, obliti sunt cubilis sui."
,"7":"Omnes, qui invenerunt, comederunt eos, et hostes eorum dixerunt: 'Non delinquimus, pro eo quod peccaverunt Domino, habitaculo iustitiae et exspectationi patrum eorum Domino'."
,"8":"Recedite de medio Babylonis,et de terra Chaldaeorum egredimini; et estote quasi haedi ante gregem."
,"9":"Quoniam ecce ego suscito et adducam in Babylonem,congregationem gentium magnarum,de terra aquilonis; et praeparabuntur adversus eam, et inde capietur: sagitta eorum quasi bellatoris electi,non revertetur vacua."
,"10":"Et erit Chaldaea in praedam; omnes vastantes eam replebuntur ', ait Dominus."
,"11":"Dum exsultatis et magna loquimini,diripientes hereditatem meam,dum effusi estis sicut vituli super herbam,et hinnitis sicut equi fortes,"
,"12":"confusa est mater vestra nimis, et in opprobrium facta est, quae genuit vos; ecce novissima erit in gentibus, deserta, invia et arens."
,"13":"Ab ira Domini non habitabitur, sed redigetur tota in solitudinem; omnis, qui transibit per Babylonem, stupebit,et sibilabit super universis plagis eius."
,"14":"Praeparamini contra Babylonem per circuitum,omnes, qui tenditis arcum; debellate eam, non parcatis iaculis, quia Domino peccavit."
,"15":"Clamate adversus eam; ubique dedit manum, ceciderunt fundamenta eius, destructi sunt muri eius, quoniam ultio Domini est; ultionem accipite de ea: sicut fecit, facite ei."
,"16":"Disperdite satorem de Babylone,et tenentem falcem in tempore messis; a facie gladii saevientis,unusquisque ad populum suum convertetur, et singuli ad terram suam fugient."
,"17":"Ovis dispersa Israel; leones eiecerunt eum. Primus comedit eum rex Assyriae; iste novissimus exossavit eum,Nabuchodonosor rex Babylonis."
,"18":"Propterea haec dicit Dominus exercituum, Deus Israel: ' Ecce ego visitabo regem Babylonis et terram eius, sicut visitavi regem Assyriae;"
,"19":"et reducam Israel ad pascua sua, et pascetur Carmelum et Basan, et in monte Ephraim et Galaad saturabitur anima eius."
,"20":"In diebus illis et in tempore illo, ait Dominus, quaeretur iniquitas Israel et non erit, et peccatum Iudae et non invenietur, quoniam propitius ero eis, quos reliquero."
,"21":"Super terram Merataim ascende,et super habitatores Phacud. Dissipa et interfice persequens eos, ait Dominus, et fac iuxta omnia, quae praecepi tibi '."
,"22":"Vox belli in terra,et contritio magna."
,"23":"Quomodo confractus est et contritus,malleus universae terrae?,Quomodo versa est in desolationem Babylon in gentibus?"
,"24":"Illaqueavi te, et capta es, Babylon, et nesciebas; inventa es et apprehensa, quoniam Dominum provocasti."
,"25":"Aperuit Dominus thesaurum suum,et protulit vasa irae suae, quoniam opus est Domino Deo exercituum,in terra Chaldaeorum."
,"26":"Venite ad eam ab extremis finibus, aperite horrea eius; redigite eam in acervos lapidum quasi manipulos,et interficite eam, nec sit quidquam reliquum."
,"27":"Dissipate universos tauros eius, descendant in occisionem. Vae eis, quia venit dies eorum, tempus visitationis eorum!"
,"28":"Vox fugientium,et eorum, qui evaserunt de terra Babylonis, ut annuntient in Sion,ultionem Domini Dei nostri, ultionem templi eius."
,"29":"Convocate in Babylonem sagittarios, omnes, qui tendunt arcum; consistite adversus eam per gyrum, et nullus evadat: reddite ei secundum opus suum, iuxta omnia, quae fecit, facite illi, quia contra Dominum erecta est, adversum Sanctum Israel."
,"30":"' Idcirco cadent iuvenes eius in plateis eius, et omnes viri bellatores eius conticescent in die illa, ait Dominus."
,"31":"Ecce ego ad te, Superbia, dicit Dominus, Deus exercituum, quia venit dies tuus, tempus visitationis tuae."
,"32":"Et cadet Superbia et corruet, et non erit qui suscitet eam; et succendam ignem in urbibus eius, et devorabit omnia in circuitu eius '."
,"33":"Haec dicit Dominus exercituum: ' Calumniam sustinent filii Israel et filii Iudae simul; omnes, qui ceperunt eos, tenent, nolunt dimittere eos."
,"34":"Redemptor eorum fortis, Dominus exercituum nomen eius, iudicio defendet causam eorum, ut quietem det terrae et conturbet habitatores Babylonis."
,"35":"Gladius ad Chaldaeos, ait Dominus, et ad habitatores Babylonis,et ad principes et ad sapientes eius! "
,"36":"Gladius ad divinos eius, qui stulti erunt!,Gladius ad fortes illius, qui timebunt!"
,"37":"Gladius ad equos eius et ad currus eius,et ad omne vulgus, quod est in medio eius; et erunt quasi mulieres!,Gladius ad thesauros eius, qui diripientur!"
,"38":"Siccitas super aquas eius erit, et arescent, quia terra sculptilium est, et in portentis insaniunt."
,"39":"Propterea habitabunt dracones cum thoibus, et habitabunt in ea struthiones; et non inhabitabitur ultra usque in sempiternum nec exstruetur usque ad generationem et generationem."
,"40":"Sicut subvertit Deus Sodomam et Gomorram et vicinas eius, ait Dominus, non habitabit ibi vir, et non peregrinabitur in ea filius hominis."
,"41":"Ecce populus venit ab aquilone, et gens magna et reges multi consurgent a finibus terrae."
,"42":"Arcum et acinacem apprehendent, crudeles sunt et immisericordes; vox eorum quasi mare sonabit, et super equos ascendent sicut vir paratus ad proelium contra te, filia Babylon."
,"43":"Audivit rex Babylonis famam eorum, et dissolutae sunt manus eius; angustia apprehendit eum, dolor quasi parturientem."
,"44":"Ecce quasi leo ascendet de silva condensa Iordanis ad prata semper virentia, quia subito currere faciam eos ex illa et, qui erit electus, illum praeponam ei. Quis enim similis mei? Et quis vocabit me in iudicium? Et quis est iste pastor, qui resistat vultui meo? '."
,"45":"Propterea audite consilium Domini, quod mente concepit adversum Babylonem, et cogitationes eius, quas cogitavit super terram Chaldaeorum: certe abstrahent parvulos gregis, certe desolabuntur super eos pascua eorum."
,"46":"A voce captivitatis Babylonis commota est terra, et clamor inter gentes auditus est."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Haec dicit Dominus: ' Ecce ego suscitabo super Babylonem,et super habitatores Chaldaeae,quasi ventum pestilentem;"
,"2":"et mittam in Babylonem ventilatores, et ventilabunt eam,et demolientur terram eius, quoniam venerunt super eam undique,in die afflictionis."
,"3":"Non tendat, qui tendit arcum suum, et non ascendat loricatus; nolite parcere iuvenibus eius, interficite omnem militiam eius '."
,"4":"Et cadent interfecti in terra Chaldaeorum,et vulnerati in plateis eius,"
,"5":"quoniam non est viduatus Israel et Iuda,a Deo suo, Domino exercituum; terra autem eorum repleta est delicto,in conspectu Sancti Israel."
,"6":"Fugite de medio Babylonis, et salvet unusquisque animam suam; nolite perire in poena eius, quoniam tempus ultionis est Domino: vicissitudinem ipse retribuet ei."
,"7":"Calix aureus Babylon in manu Domini,inebrians omnem terram; de vino eius biberunt gentes,et ideo insaniunt."
,"8":"Subito cecidit Babylon et contrita est. Ululate super eam; tollite resinam ad dolorem eius, si forte sanetur."
,"9":"' Curavimus Babylonem, et non est sanata. Derelinquite eam, et eamus unusquisque in terram suam, quoniam pervenit usque ad caelos iudicium eius,et elevatum est usque ad nubes."
,"10":"Protulit Dominus iustitias nostras; venite, et narremus in Sion,opus Domini Dei nostri '."
,"11":"Acuite sagittas, implete pharetras; suscitavit Dominus spiritum regum Medorum, et contra Babylonem mens eius est, ut perdat eam, quoniam ultio Domini,est ultio templi sui."
,"12":"Super muros Babylonis levate signum, augete custodiam, ponite custodes, praeparate insidias, quia cogitavit Dominus, et facit quaecumque locutus est,contra habitatores Babylonis."
,"13":"Quae habitas super aquas multas, locuples in thesauris, venit finis tuus, pedalis praecisionis tuae."
,"14":"Iuravit Dominus exercituum per animam suam: ' Quoniam, etsi replevero te hominibus quasi brucho, super te celeuma cantabitur '."
,"15":"Qui fecit terram in fortitudine sua, praeparavit orbem in sapientia sua et prudentia sua extendit caelos;"
,"16":"dante eo vocem, multiplicantur aquae in caelo; qui levat nubes ab extremo terrae, fulgura in pluviam facit,et producit ventum de thesauris suis."
,"17":"Stultus factus est omnis homo, absque scientia; confusus est omnis conflator in sculptili, quia mendax conflatio eius, nec est spiritus in eis."
,"18":"Vana sunt opera et risu digna, in tempore visitationis suae peribunt."
,"19":"Non sicut haec pars Iacob, quia, qui fecit omnia, ipse est, et Israel tribus hereditatis eius: Dominus exercituum nomen eius."
,"20":"' Malleus tu mihi, vas belli: et ego collisi in te gentes,et dispersi in te regna"
,"21":"et collisi in te equum et equitem eius,et collisi in te currum et ascensorem eius"
,"22":"et collisi in te virum et mulierem,et collisi in te senem et puerum,et collisi in te iuvenem et virginem"
,"23":"et collisi in te pastorem et gregem eius,et collisi in te agricolam et iugales eius,et collisi in te duces et magistratus. "
,"24":"Et reddam Babyloni et cunctis habitatoribus Chaldaeae omne malum suum, quod fecerunt in Sion in oculis vestris, ait Dominus."
,"25":"Ecce ego ad te, mons pestifer, ait Dominus, qui corrumpis universam terram; et extendam manum meam super te,et evolvam te de petris,et dabo te in montem combustionis. "
,"26":"Et non tollent de te lapidem in angulum,et lapidem in fundamenta, sed perditus in aeternum eris ', ait Dominus."
,"27":"Levate signum in terra, clangite bucina in gentibus, sanctificate super eam gentes, vocate contra illam regna,Ararat, Menni et Aschenez. Constituite super eam scribas, adducite equos quasi bruchum aculeatum."
,"28":"Sanctificate contra eam gentes, reges Mediae, duces eius et universos magistratus eius cunctamque terram potestatis eius."
,"29":"Et commovebitur terra et conturbabitur, quia impletur contra Babylonem cogitatio Domini, ut ponat terram Babylonis,desertam et inhabitabilem."
,"30":"Cessaverunt fortes Babylonis a proelio, habitaverunt in praesidiis; devoratum est robur eorum, et facti sunt quasi mulieres; incensa sunt tabernacula eius, contriti sunt vectes eius."
,"31":"Currens obviam currenti veniet, et nuntius obvius nuntianti, ut annuntiet regi Babylonis,quia capta est civitas eius,a summo usque ad summum."
,"32":"Et vada praeoccupata sunt, et paludes incensae sunt igni; et viri bellatores conturbati sunt."
,"33":"Quia haec dicit Dominus exercituum, Deus Israel: ' Filia Babylonis quasi area tempore triturae eius; adhuc modicum, et veniet tempus messionis eius '."
,"34":"' Comedit me, devoravit me Nabuchodonosor; rex Babylonis reddidit me quasi vas inane, absorbuit me quasi draco, replevit ventrem suum deliciis meis et eiecit me '."
,"35":"' Iniquitas adversum me et caro mea super Babylonem! ', dicit habitatio Sion. ' Et sanguis meus super habitatores Chaldaeae! ', dicit Ierusalem."
,"36":"Propterea haec dicit Dominus: ' Ecce ego iudicabo causam tuam,et ulciscar ultionem tuam,et desertum faciam mare eius,et siccabo venam eius;"
,"37":"et erit Babylon in tumulos, habitatio thoum, stupor et sibilus, eo quod non sit habitator."
,"38":"Simul ut leones rugient, frement veluti catuli leonum."
,"39":"In calore eorum ponam potus eorum,et inebriabo eos, ut sopiantur,et dormiant somnum sempiternum et non consurgant, dicit Dominus."
,"40":"Deducam eos quasi agnos ad victimam, quasi arietes cum haedis '."
,"41":"Quomodo capta est Babel, et comprehensa est gloria universae terrae?,Quomodo facta est in stuporem,Babylon inter gentes?"
,"42":"Ascendit super Babylonem mare, multitudine fluctuum eius operta est."
,"43":"Factae sunt civitates eius in stuporem, terra inhabitabilis et deserta, terra, in qua nullus habitet, nec transeat per eam filius hominis. "
,"44":"' Et visitabo super Bel in Babylone,et eiciam, quod absorbuerat, de ore eius; et non confluent ad eum ultra gentes, siquidem et murus Babylonis corruet."
,"45":"Egredimini de medio eius, populus meus, ut salvet unusquisque animam suam,ab ira furoris Domini."
,"46":"Et ne forte mollescat cor vestrum, et timeatis auditum, qui audietur in terra; et veniet in anno auditio, et post hunc annum auditio, et iniquitas in terra, et dominator super dominatorem."
,"47":"Propterea ecce dies veniunt, et visitabo super sculptilia Babylonis, et omnis terra eius confundetur, et universi interfecti eius cadent in medio eius."
,"48":"Et laudabunt super Babylonem caeli et terra et omnia, quae in eis sunt, quia ab aquilone venient ei praedones, ait Dominus."
,"49":"Et Babylon cadet, occisi in Israel, sicut pro Babylone ceciderunt occisi universae terrae."
,"50":"Qui fugistis gladium, ite, nolite stare; recordamini procul Domini, et Ierusalem ascendat super cor vestrum."
,"51":"'Confusi sumus, quoniam audivimus opprobrium; operuit ignominia facies nostras, quia venerunt alieni super sanctificationem domus Domini'."
,"52":"Propterea ecce dies veniunt, ait Dominus, et visitabo super sculptilia eius, et in omni terra eius gemet vulneratus."
,"53":"Si ascenderit Babylon in caelum et firmaverit in excelso robur suum, a me venient vastatores eius ', ait Dominus."
,"54":"Vox clamoris de Babylone et contritio magna de terra Chaldaeorum, 55 quoniam vastavit Dominus Babylonem et perdidit ex ea vocem magnam; et sonabunt fluctus eorum quasi aquae multae, dedit sonitum vox eorum."
,"56":"Quia venit super eam, id est super Babylonem, praedo; et apprehensi sunt fortes eius, et fractus est arcus eorum, quia Deus ultor Dominus reddens retribuet."
,"57":"' Et inebriabo principes eius et sapientes eius et duces eius et magistratus eius et fortes eius; et dormient somnum sempiternum et non expergiscentur ', ait rex, Dominus exercituum nomen eius."
,"58":"Haec dicit Dominus exercituum: ' Murus Babylonis ille latissimus funditus suffodietur, et portae eius excelsae igni comburentur; et laboraverunt populi pro nihilo, et gentes pro igni lassatae sunt '."
,"59":"Verbum, quod praecepit Ieremias propheta Saraiae filio Neriae filii Maasiae, cum pergeret cum Sedecia rege Iudae in Babylonem in anno quarto regni eius; Saraias autem erat princeps, qui mansionibus praeerat."
,"60":"Et scripsit Ieremias omne malum, quod venturum erat super Babylonem, in libro uno, omnia verba haec, quae scripta sunt contra Babylonem."
,"61":"Et dixit Ieremias ad Saraiam: ' Cum veneris in Babylonem et videris et legeris omnia verba haec,"
,"62":"dices: 'Domine, tu locutus es contra locum istum, ut disperderes eum, ne sit qui in eo habitet ab homine usque ad pecus, et ut sit perpetua solitudo'."
,"63":"Cumque compleveris legere librum istum, ligabis ad eum lapidem et proicies illum in medium Euphraten"
,"64":"et dices: 'Sic submergetur Babylon et non consurget a facie afflictionis, quam ego adduco super eam, et dissolvetur' '. Hucusque verba Ieremiae."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Filius viginti et unius anni erat Sedecias, cum regnare coepisset, et undecim annis regnavit in Ierusalem; et nomen matris eius Amital filia Ieremiae de Lobna."
,"2":"Et fecit malum in oculis Domini iuxta omnia, quae fecerat Ioachim,"
,"3":"quoniam furor Domini erat in Ierusalem et in Iuda, usquequo proiceret eos a facie sua. Et recessit Sedecias a rege Babylonis. "
,"4":"Factum est autem in anno nono regni eius, in mense decimo decima mensis, venit Nabuchodonosor rex Babylonis, ipse et omnis exercitus eius, adversus Ierusalem; et obsederunt eam et aedificaverunt contra eam munitiones in circuitu."
,"5":"Et fuit civitas obsessa usque ad undecimum annum regis Sedeciae."
,"6":"Mense autem quarto, nona mensis, obtinuit fames in civitate, et non erant alimenta populo terrae."
,"7":"Et dirupta est civitas, et omnes viri bellatores fugerunt exieruntque de civitate nocte per viam portae, quae est inter duos muros et ducit ad hortum regis, Chaldaeis obsidentibus urbem in gyro, et abierunt per viam, quae ducit in Arabam."
,"8":"Persecutus est autem Chaldaeorum exercitus regem, et apprehenderunt Sedeciam in campestribus Iericho, et omnis comitatus eius diffugit ab eo."
,"9":"Cumque comprehendissent regem, adduxerunt eum ad regem Babylonis in Rebla, quae est in terra Emath; et locutus est ad eum iudicia."
,"10":"Et iugulavit rex Babylonis filios Sedeciae in oculis eius, sed et omnes principes Iudae occidit in Rebla;"
,"11":"et oculos Sedeciae eruit et vinxit eum compedibus et adduxit eum rex Babylonis in Babylonem et posuit eum in domo carceris usque ad diem mortis eius."
,"12":"In mense autem quinto, decima mensis, ipse est annus nonus decimus Nabuchodonosor regis Babylonis, venit Nabuzardan princeps satellitum, qui stabat coram rege Babylonis, in Ierusalem."
,"13":"Et incendit domum Domini et domum regis; et omnes domos Ierusalem et omnem domum magnam igni combussit;"
,"14":"et totum murum Ierusalem per circuitum destruxit cunctus exercitus Chaldaeorum, qui erat cum magistro satellitum."
,"15":"De pauperibus autem populi et de reliquo vulgo, quod remanserat in civitate, et de perfugis, qui transfugerant ad regem Babylonis, et superfluos artificum transtulit Nabuzardan princeps satellitum."
,"16":"De pauperibus vero terrae reliquit Nabuzardan princeps satellitum in vinitores et in agricolas."
,"17":"Columnas quoque aereas, quae erant in domo Domini, et bases et mare aereum, quod erat in domo Domini, confregerunt Chaldaei et tulerunt omne aes eorum in Babylonem."
,"18":"Et lebetes et vatilla et cultros et phialas et mortariola et omnia vasa aerea, quae in ministerio fuerant, tulerunt;"
,"19":"et pelves et thymiamateria et phialas et lebetes et candelabra et mortaria et cyathos, quotquot aurea aurea, et quotquot argentea argentea, tulit magister satellitum;"
,"20":"columnas duas et mare unum et vitulos duodecim aereos, qui erant subtus basi, quam fecerat rex Salomon domui Domini. Non erat pondus aeris omnium horum vasorum."
,"21":"De columnis autem, decem et octo cubiti altitudinis erant in columna una, et funiculus duodecim cubitorum circuibat eam; porro grossitudo eius quattuor digitorum, et intrinsecus cava erat."
,"22":"Et capitella super utramque aerea: altitudo capitelli unius quinque cubitorum, et retiacula et malogranata super capitellum in circuitu omnia aerea; similiter columnae secundae."
,"23":"Et malogranata nonaginta sex dependentia; omnia malogranata centum super retiacula in circuitu."
,"24":"Et tulit magister satellitum Saraiam sacerdotem primum et Sophoniam sacerdotem secundum et tres custodes vestibuli."
,"25":"Et de civitate tulit eunuchum unum, qui erat praepositus super viros bellatores, et septem viros de his, qui videbant faciem regis, qui inventi sunt in civitate, et scribam principis militum, qui ex populo terrae probabat tirones, et sexaginta viros de populo terrae, qui inventi sunt in medio civitatis."
,"26":"Tulit autem eos Nabuzardan magister satellitum et duxit eos ad regem Babylonis in Rebla;"
,"27":"et percussit eos rex Babylonis et interfecit eos in Rebla in terra Emath. Et translatus est Iuda de terra sua."
,"28":"Iste est populus, quem transtulit Nabuchodonosor: in anno septimo, Iudaeos tria millia et viginti tres;"
,"29":"in anno octavo decimo Nabuchodonosor de Ierusalem animas octingentas triginta duas;"
,"30":"in anno vicesimo tertio Nabuchodonosor transtulit Nabuzardan magister satellitum animas Iudaeorum septingentas quadraginta quinque; omnes ergo animae quattuor milia sescentae."
,"31":"Et factum est in tricesimo septimo anno transmigrationis Ioachin regis Iudae, duodecimo mense vicesima quinta mensis, elevavit Evilmerodach rex Babylonis, ipso anno regni sui, caput Ioachin regis Iudae; et eduxit eum de domo carceris."
,"32":"Et locutus est cum eo bona et posuit thronum eius super thronos regum, qui erant secum in Babylone."
,"33":"Et mutavit vestimenta carceris eius, et comedebat panem coram eo semper cunctis diebus vitae suae."
,"34":"Et cibaria eius, cibaria perpetua dabantur ei a rege Babylonis statuta per singulos dies, usque ad diem mortis suae, cunctis diebus vitae eius."
}`)

}
func LA_NVBSE_LoadVMISChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Visio Isaiae filii Amos, quam vidit super Iudam et Ierusalem in diebus Oziae, Ioatham, Achaz, Ezechiae regum Iudae."
,"2":"Audite, caeli, et auribus percipe, terra, quoniam Dominus locutus est: ' Filios enutrivi et exaltavi, ipsi autem spreverunt me."
,"3":"Cognovit bos possessorem suum, et asinus praesepe domini sui; Israel non cognovit, populus meus non intellexit '."
,"4":"Vae genti peccatrici, populo gravi iniquitate, semini nequam, filiis sceleratis!,Dereliquerunt Dominum, blasphemaverunt Sanctum Israel, abalienati sunt retrorsum."
,"5":"Super quo percutiemini vos ultra, addentes praevaricationem?,Omne caput languidum, et omne cor maerens."
,"6":"A planta pedis usque ad verticem,non est in eo sanitas; vulnus et livor et plaga tumens,non est circumligata,nec curata medicamine neque fota oleo."
,"7":"Terra vestra deserta, civitates vestrae succensae igni; regionem vestram coram vobis alieni devorant, et desolabitur sicut in vastitate hostili."
,"8":"Et derelinquetur filia Sion,ut umbraculum in vinea, sicut tugurium in cucumerario, sicut civitas, quae obsessa est."
,"9":"Nisi Dominus exercituum reliquisset nobis semen, quasi Sodoma fuissemus,et quasi Gomorra similes essemus."
,"10":"Audite verbum Domini, principes Sodomorum; percipite auribus legem Dei nostri, populus Gomorrae."
,"11":"' Quo mihi multitudinem victimarum vestrarum?, dicit Dominus. Plenus sum holocaustis arietum,et adipe pinguium; et sanguinem vitulorum,et agnorum et hircorum nolui."
,"12":"Cum veneritis ante conspectum meum, quis quaesivit haec de manibus vestris, ut ambularetis in atriis meis?"
,"13":"Ne afferatis ultra sacrificium vanum; abominatio mihi incensum, neomenia et sabbatum et conventus; non feram scelus cum coetu sollemni;"
,"14":"calendas vestras et sollemnitates vestras odivit anima mea, facta sunt mihi molesta, laboravi sustinens."
,"15":"Et cum extenderitis manus vestras, avertam oculos meos a vobis; et cum multiplicaveritis orationem, non exaudiam: manus enim vestrae sanguine plenae sunt."
,"16":"Lavamini, mundi estote, auferte malum cogitationum vestrarum ab oculis meis; quiescite agere perverse,"
,"17":"discite benefacere: quaerite iudicium, subvenite oppresso, iudicate pupillo, defendite viduam."
,"18":"Et venite, et iudicio contendamus, dicit Dominus. Si fuerint peccata vestra ut coccinum, quasi nix dealbabuntur; et, si fuerint rubra quasi vermiculus, velut lana erunt."
,"19":"Si volueritis et audieritis, bona terrae comedetis;"
,"20":"quod si nolueritis et me ad iracundiam provocaveritis, gladius devorabit vos, quia os Domini locutum est '."
,"21":"Quomodo facta est meretrix,civitas fidelis, plena iudicii?,Iustitia habitavit in ea, nunc autem homicidae."
,"22":"Argentum tuum versum est in scoriam, vinum tuum mixtum est aqua;"
,"23":"principes tui infideles, socii furum: omnes diligunt munera, sequuntur retributiones, pupillo non iudicant, et causa viduae non ingreditur ad illos."
,"24":"Propter hoc ait Dominus, Deus exercituum, Fortis Israel: ' Heu, consolabor super hostibus meis,et vindicabor de inimicis meis."
,"25":"Et convertam manum meam ad te,et excoquam ad purum scoriam tuam,et auferam omne stannum tuum."
,"26":"Et restituam iudices tuos, ut fuerunt prius, et consiliarios tuos sicut antiquitus; post haec vocaberis Civitas iustitiae, Urbs fidelis '."
,"27":"Sion in iudicio redimetur,et, qui in ea reversi sunt, in iustitia."
,"28":"Erit autem ruina scelestis et peccatoribus simul; et, qui dereliquerunt Dominum, consumentur."
,"29":"Confundemini enim terebinthis, in quibus delectati estis, et erubescetis super hortis, quos elegistis."
,"30":"Nam eritis velut quercus, defluentibus foliis, et velut hortus absque aqua;"
,"31":"et erit fortitudo vestra ut favilla stuppae, et opus eius quasi scintilla, et succendetur utrumque simul, et non erit qui exstinguat."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Verbum, quod vidit Isaias filius Amos super Iudam et Ieru salem."
,"2":"Et erit in novissimis diebus,praeparatus mons domus Domini in vertice montium, et elevabitur super colles; et fluent ad eum omnes gentes."
,"3":"Et ibunt populi multi et dicent: ' Venite, et ascendamus ad montem Domini, ad domum Dei Iacob, ut doceat nos vias suas, et ambulemus in semitis eius '; quia de Sion exibit lex, et verbum Domini de Ierusalem."
,"4":"Et iudicabit gentes,et arguet populos multos; et conflabunt gladios suos in vomeres,et lanceas suas in falces; non levabit gens contra gentem gladium, nec exercebuntur ultra ad proelium."
,"5":"Domus Iacob, venite, et ambulemus in lumine Domini."
,"6":"Proiecisti enim populum tuum, domum Iacob, quia repleti sunt hariolis orientalibus,et augures habuerunt ut Philisthim,et manus alienis porrigunt."
,"7":"Repleta est terra eius argento et auro, et non est finis thesaurorum eius;"
,"8":"et repleta est terra eius equis, et innumerabiles quadrigae eius; et repleta est terra eius idolis: opus manuum suarum adoraverunt, quod fecerunt digiti eorum."
,"9":"Et incurvavit se homo, et humiliatus est vir: ne dimittas eis."
,"10":"Ingredere in petram, abscondere in pulvere,a facie timoris Domini et a gloria maiestatis eius."
,"11":"Oculi sublimes hominis humiliabuntur, et incurvabitur altitudo virorum; exaltabitur autem Dominus solus in die illa."
,"12":"Quia dies Domini exercituum,super omnem superbum et excelsum,et super omnem arrogantem, et humiliabitur;"
,"13":"et super omnes cedros Libani sublimes et erectas,et super omnes quercus Basan"
,"14":"et super omnes montes excelsos,et super omnes colles elevatos"
,"15":"et super omnem turrim excelsam,et super omnem murum munitum"
,"16":"et super omnes naves Tharsis,et super omnia navigia pulchra."
,"17":"Et incurvabitur sublimitas hominum, et humiliabitur altitudo virorum; et elevabitur Dominus solus in die illa,"
,"18":"et idola penitus conterentur."
,"19":"Et introibunt in speluncas petrarum,et in voragines terrae,a facie formidinis Domini et a gloria maiestatis eius, cum surrexerit percutere terram."
,"20":"In die illa proiciet homo idola sua argentea et simulacra sua aurea, quae fecerat sibi, ut adoraret, ad talpas et vespertiliones."
,"21":"Et ingredietur scissuras petrarum et cavernas saxorum a facie formidinis Domini et a gloria maiestatis eius, cum surrexerit percutere terram."
,"22":"Quiescite ergo ab homine, cuius spiritus in naribus eius. Quanti enim aestimabitur ipse?"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ecce enim Dominator, Dominus exercituum, aufert a Ierusalem et a Iuda robur et praesidium, omne robur panis et omne robur aquae,"
,"2":"fortem et virum bellatorem, iudicem et prophetam et hariolum et senem,"
,"3":"principem super quinquaginta et honorabilem vultu,et consiliarium et sapientem magum,et prudentem incantatorem."
,"4":"Et dabo pueros principes eorum; et infantes dominabuntur eis."
,"5":"Et irruet populus, vir ad virum, unusquisque ad proximum suum: tumultuabitur puer contra senem, et ignobilis contra nobilem."
,"6":"Apprehendet enim vir fratrem suum,in domo patris sui: ' Vestimentum tibi est, princeps esto noster, ruina autem haec sub manu tua '."
,"7":"Clamabit in die illa dicens: ' Non sum medicus, et in domo mea non est panis neque vestimentum; nolite constituere me principem populi '."
,"8":"Ruit enim Ierusalem, et Iudas concidit, quia lingua eorum et adinventiones eorum contra Dominum, ut provocarent oculos maiestatis eius."
,"9":"Procacitas vultus eorum accusat eos, et peccatum suum quasi Sodoma,praedicaverunt nec absconderunt; vae animae eorum, quoniam reddita sunt eis mala!"
,"10":"Dicite iusto: ' Bene! ', quoniam fructum adinventionum suarum comedet."
,"11":"Vae impio in malum: retributio enim manuum eius fiet ei!"
,"12":"Populum meum opprimit infans, et mulieres dominantur ei. Popule meus, qui te beatum dicunt, ipsi te decipiunt,et viam gressuum tuorum dissipant."
,"13":"Surgit ad arguendum Dominus,et stat ad iudicandos populos."
,"14":"Dominus ad iudicium veniet,cum senibus populi sui et principibus eius: ' Vos enim depasti estis vineam, et rapina pauperis in domibus vestris."
,"15":"Quare atteritis populum meum,et facies pauperum commolitis? ', dicit Dominus, Deus exercituum."
,"16":"Et dixit Dominus: ' Pro eo quod elevatae sunt filiae Sion,et ambulaverunt extento collo et nutibus oculorum, parvis passibus incedebant,et catenulis pedum tinniebant,"
,"17":"decalvabit Dominus verticem filiarum Sion,et Dominus crinem earum nudabit '."
,"18":"In die illa auferet Dominus,ornamentum calceamentorum et torques"
,"19":"et lunulas et inaures,et armillas et mitras,"
,"20":"discriminalia et periscelidas,et fascias et olfactoriola"
,"21":"et anulos et ornamenta narium,"
,"22":"mutatoria et palliola,et linteamina et marsupia,"
,"23":"specula et sindones,et vittas et pallia."
,"24":"Et erit pro suavi odore foetor, et pro zona funiculus, et pro crispante crine calvitium, et pro fascia pectorali cilicium, stigma pro pulchritudine."
,"25":"Viri tui gladio cadent, et fortes tui in proelio,"
,"26":"et maerebunt atque lugebunt portae eius, et desolata in terra sedebit."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et apprehendent septem mulieres,virum unum in die illa dicentes: ' Panem nostrum comedemus,et vestimentis nostris operiemur, tantummodo vocetur nomen tuum super nos: aufer opprobrium nostrum '."
,"2":"In die illa erit germen Domini in splendorem et gloriam, et fructus terrae sublimis et exsultatio,his, qui salvati fuerint de Israel."
,"3":"Et erit: omnis, qui relictus fuerit in Sion, et residuus in Ierusalem, sanctus vocabitur, omnis, qui scriptus est ad vitam in Ierusalem."
,"4":"Cum abluerit Dominus sordem filiarum Sion,et sanguinem Ierusalem laverit de medio eius,spiritu iudicii et spiritu ardoris,"
,"5":"et creabit Dominus super omnem locum montis Sion,et super coetum eius,nubem per diem,et fumum et splendorem ignis flammantis in nocte: super omnem enim gloriam protectio,"
,"6":"et tabernaculum erit in umbraculum diei ab aestu,et in securitatem et absconsionem a turbine et a pluvia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cantabo dilecto meo,canticum amici mei de vinea sua: Vinea facta est dilecto meo,in colle pingui;"
,"2":"et saepivit eam,et lapides elegit ex illa,et plantavit in ea vites electas,et aedificavit turrim in medio eius,et torcular exstruxit in ea; et exspectavit, ut faceret uvas, et fecit labruscas."
,"3":"Nunc ergo, habitator Ierusalem,et vir Iudae, iudicate inter me et vineam meam."
,"4":"Quid est quod debui ultra facere vineae meae,et non feci ei?,Cur exspectavi, ut faceret uvas, et fecit labruscas?"
,"5":"Et nunc ostendam vobis,quid ego faciam vineae meae: auferam saepem eius, et erit in direptionem; diruam maceriam eius, et erit in conculcationem."
,"6":"Et ponam eam desertam: non putabitur et non fodietur, et ascendent vepres et spinae; et nubibus mandabo, ne pluant super eam imbrem."
,"7":"Vinea enim Domini exercituum domus Israel est, et vir Iudae germen eius delectabile; et exspectavi, ut faceret iudicium, et ecce iniquitas, et iustitiam, et ecce nequitia."
,"8":"Vae, qui coniungunt domum ad domum,et agrum agro copulant usque ad terminum loci!,Numquid habitabitis vos soli in medio terrae?"
,"9":"In auribus meis iuravit Dominus exercituum: ' Certe domus multae desertae erunt, grandes et pulchrae absque habitatore '."
,"10":"Decem enim iugera vinearum facient lagunculam unam, et triginta modii sementis facient modios tres."
,"11":"Vae, qui consurgunt mane ad ebrietatem sectandam,et ad potandum usque ad vesperam, ut vinum inflammet eos!"
,"12":"Cithara et lyra,et tympanum et tibia,et vinum in conviviis eorum, et opus Domini non respiciunt, nec opera manuum eius considerant."
,"13":"Propterea captivus ductus est populus meus, quia non habuit scientiam, et nobiles eius interierunt fame, et multitudo eius siti exaruit."
,"14":"Propterea dilatavit infernus fauces suas,et aperuit os suum absque ullo termino; et descendunt fortes Ierusalem, et populus eius, et sublimes et tripudiantes in ea."
,"15":"Et incurvabitur homo, et humiliabitur vir, et oculi sublimium deprimentur;"
,"16":"et exaltabitur Dominus exercituum in iudicio, et Deus sanctus sanctificabitur in iustitia,"
,"17":"et pascentur agni iuxta ordinem suum velut in prato suo, et alieni comedent in ruinis pinguium."
,"18":"Vae, qui trahunt iniquitatem in funiculis vanitatis,et quasi vinculum plaustri peccatum!"
,"19":"Qui dicunt: ' Festinet,et cito veniat opus eius, ut videamus; et appropiet et veniat consilium Sancti Israel, et sciemus illud! '."
,"20":"Vae, qui dicunt malum bonum et bonum malum, ponentes tenebras in lucem et lucem in tenebras, ponentes amarum in dulce et dulce in amarum!"
,"21":"Vae, qui sapientes sunt in oculis suis,et coram ipsis prudentes!"
,"22":"Vae, qui potentes sunt ad bibendum vinum, et viri fortes ad miscendam ebrietatem!"
,"23":"Qui absolvunt impium pro muneribus,et iustitiam iusti auferunt ab eo!"
,"24":"Propter hoc, sicut devorat stipulam lingua ignis, et palea flamma consumitur, sic radix eorum quasi tabes erit, et flos eorum sicut putredo ascendet; abiecerunt enim legem Domini exercituum,et eloquium Sancti Israel blasphemaverunt."
,"25":"Ideo exarsit furor Domini in populum suum, et extendit manum suam super eum et percussit eum, et conturbati sunt montes; et facta sunt morticina eorum quasi stercus in medio platearum. In his omnibus non est aversus furor eius, sed adhuc manus eius extenta."
,"26":"Et levabit signum nationibus procul; et sibilabit ad eum de finibus terrae; et ecce festinus velociter veniet."
,"27":"Non est deficiens neque laborans in eo, non dormitabit neque dormiet; neque solvetur cingulum renum eius, nec rumpetur corrigia calceamenti eius."
,"28":"Sagittae eius acutae, et omnes arcus eius extenti; ungulae equorum eius ut silex reputantur, et rotae eius quasi impetus tempestatis."
,"29":"Rugitus eius ut leonis: rugiet ut catuli leonum et frendet; et arripiet praedam et in tuto collocabit, et non erit qui eruat."
,"30":"Et sonabit super eum in die illa sicut sonitus maris. Aspiciet in terram: et ecce tenebrae tribulationis, et lux obtenebrata est in caligine eius."
}`)
	CurrentBook.AddChapter(6, `{
"1":"In anno, quo mortuus est rex Ozias, vidi Dominum edentem super solium excelsum et elevatum; et fimbriae eius replebant templum."
,"2":"Seraphim stabant iuxta eum; sex alae uni et sex alae alteri: duabus velabat faciem suam et duabus velabat pedes suos et duabus volabat."
,"3":"Et clamabat alter ad alterum et dicebat: ' Sanctus, Sanctus, Sanctus Dominus exercituum; plena est omnis terra gloria eius '."
,"4":"Et commota sunt superliminaria cardinum a voce clamantis, et domus repleta est fumo."
,"5":"Et dixi: ' Vae mihi, quia perii!,Quia vir pollutus labiis ego sum,et in medio populi polluta labia habentis ego habito,et regem, Dominum exercituum, vidi oculis meis '."
,"6":"Et volavit ad me unus de seraphim, et in manu eius calculus, quem forcipe tulerat de altari,"
,"7":"et tetigit os meum et dixit: ' Ecce tetigit hoc labia tua, et auferetur iniquitas tua, et peccatum tuum mundabitur '."
,"8":"Et audivi vocem Domini dicentis: ' Quem mittam? Et quis ibit nobis? '. Et dixi: ' Ecce ego, mitte me '."
,"9":"Et dixit: ' Vade, et dices populo huic: 'Audientes audite et nolite intellegere, et videntes videte et nolite cognoscere'."
,"10":"Pingue redde cor populi huius,et aures eius aggrava,et oculos eius excaeca, ne forte videat oculis suis,et auribus suis audiat,et corde suo intellegat et convertatur,et sanetur '."
,"11":"Et dixi: ' Usquequo, Domine? '. Et dixit: ' Donec desolentur,civitates absque habitatore, et domus sine homine, et terra relinquatur deserta '."
,"12":"Et longe adducet Dominus homines, et magna erit desolatio in medio terrae;"
,"13":"et adhuc in ea decimatio, et rursus excisioni tradetur,sicut terebinthus et sicut quercus, in quibus deiectis manebit aliquid stabile. Semen sanctum erit id quod steterit in ea."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Et factum est in diebus Achaz filii Ioatham filii Oziae regis Iu dae, ascendit Rasin rex Syriae et Phacee filius Romeliae rex Israel in Ierusalem ad proeliandum contra eam; et non potuerunt debellare eam."
,"2":"Et nuntiaverunt domui David dicentes: ' Requievit Syria super Ephraim '. Et commotum est cor eius et cor populi eius, sicut moventur ligna silvarum a facie venti."
,"3":"Et dixit Dominus ad Isaiam: ' Egredere in occursum Achaz, tu et Seariasub (id est Reliquiae revertentur) filius tuus, ad extremum aquaeductus piscinae superioris in viam agri fullonis;"
,"4":"et dices ad eum: Vide, ut sileas; noli timere, et cor tuum ne formidet a duabus caudis titionum fumigantium istorum, ob ardorem irae Rasin et Syriae et filii Romeliae,"
,"5":"eo quod consilium malum inierit contra te Syria, Ephraim et filius Romeliae dicentes:"
,"6":"'Ascendamus ad Iudam et terrorem iniciamus ei et avellamus eum ad nos et ponamus regem in medio eius filium Tabeel' '."
,"7":"Haec dicit Dominus Deus: ' Non stabit et non erit!"
,"8":"Caput enim Syriae Damascus, et caput Damasci Rasin; et adhuc sexaginta et quinque anni,et desinet Ephraim esse populus;"
,"9":"et caput Ephraim Samaria, et caput Samariae filius Romeliae. Si non credideritis, non permanebitis '."
,"10":"Et adiecit Dominus loqui ad Achaz dicens:"
,"11":"' Pete tibi signum a Domino Deo tuo in profundum inferni sive in excelsum supra '."
,"12":"Et dixit Achaz: ' Non petam et non tentabo Dominum '."
,"13":"Et dixit: ' Audite ergo, domus David; numquid parum vobis est molestos esse hominibus, quia molesti estis et Deo meo?"
,"14":"Propter hoc dabit Dominus ipse vobis signum. Ecce, virgo concipiet et pariet filium et vocabit nomen eius Emmanuel;"
,"15":"butyrum et mel comedet, ut ipse sciat reprobare malum et eligere bonum."
,"16":"Quia antequam sciat puer reprobare malum et eligere bonum, desolabitur terra, cuius tu formidas duos reges;"
,"17":"adducet Dominus super te et super populum tuum et super domum patris tui dies, qui non venerunt a diebus separationis Ephraim a Iuda, regem Assyriorum '."
,"18":"Et erit in die illa: sibilabit Dominus muscae, quae est in extremo fluminum Aegypti, et api, quae est in terra Assur;"
,"19":"et venient et requiescent omnes,in vallibus praeruptis,et in cavernis petrarum,et in omnibus frutetis,et in omnibus pascuis."
,"20":"In die illa radet Dominus,in novacula conducta e regione trans flumen,C in rege Assyriorum C,caput et pilos pedum,et barbam quoque abradet."
,"21":"Et erit in die illa: nutriet homo vitulam et duas oves"
,"22":"et prae ubertate lactis,comedet butyrum; butyrum enim et mel manducabit omnis, qui relictus fuerit in medio terrae."
,"23":"Et erit in die illa: omnis locus, ubi fuerint mille vites mille argenteis, spinae et vepres erunt."
,"24":"Cum sagittis et arcu ingredientur illuc, vepres enim et spinae erit universa terra."
,"25":"Et in omnes montes, qui in sarculo sarriebantur, nemo veniet prae terrore spinarum et veprium, et erit in pascua bovis et in conculcationem pecoris."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Et dixit Dominus ad me: ' Sume tibi tabulam grandem et scribe in ea stilo hominis: Maher Salal Has Baz (id est Velociter spolia detrahe, cito praedare)."
,"2":"Et adhibui mihi testes fideles, Uriam sacerdotem et Zachariam filium Barachiae;"
,"3":"et accessi ad prophetissam, et concepit et peperit filium. Et dixit Dominus ad me: ' Voca nomen eius Maher Salal Has Baz,"
,"4":"quia antequam sciat puer clamare: 'Pater mi' et 'Mater mea', afferentur opes Damasci et spolia Samariae coram rege Assyriorum '."
,"5":"Et adiecit Dominus loqui ad me adhuc dicens:"
,"6":"' Pro eo quod abiecit populus iste aquas Siloae, quae vadunt cum silentio, et defecit coram Rasin et filio Romeliae,"
,"7":"propter hoc ecce Dominus adducet super eos,aquas Fluminis fortes et multas, regem Assyriorum et omnem gloriam eius, et ascendet super omnes rivos eius,et fluet super universas ripas eius;"
,"8":"et ibit per Iudam inundans et diffluens, usque ad collum veniet. Et erit extensio alarum eius,implens latitudinem terrae tuae, o Emmanuel '."
,"9":"Clamorem tollite, populi, et consternemini; et audite, universae procul terrae: accingimini et perterremini, accingimini et perterremini."
,"10":"Inite consilium, et dissipabitur; loquimini verbum, et non fiet, quia nobiscum Deus."
,"11":"Haec enim ait Dominus ad me, cum apprehendit me manu et monuit, ne irem in via populi huius, dicens:"
,"12":"' Ne vocetis coniurationem, quodcumque populus iste vocat coniurationem, et timorem eius ne timeatis neque paveatis '."
,"13":"Dominum exercituum ipsum sanctificate: ipse pavor vester, et ipse terror vester;"
,"14":"et erit in sanctuarium, in lapidem offensionis et in petram scandali,duabus domibus Israel, in laqueum et in insidias habitantibus Ierusalem."
,"15":"Et offendent ex eis plurimi,et cadent et conterentur,et irretientur et capientur."
,"16":"Liga testimonium, signa legem in discipulis meis."
,"17":"Et exspectabo Dominum, qui abscondit faciem suam a domo Iacob, et praestolabor eum."
,"18":"Ecce ego et pueri, quos dedit mihi Dominus in signum et in portentum Israel a Domino exercituum, qui habitat in monte Sion."
,"19":"Et cum dixerint ad vos: ' Quaerite a pythonibus et a divinis, qui susurrant et murmurant; numquid non populus a deo suo requiret, pro vivis a mortuis? '."
,"20":"Ad legem et ad testimonium! Quod si non dixerint iuxta verbum hoc, non erit eis matutina lux."
,"21":"Et transibit per eam afflictus et esuriens; et, cum esurierit, irascetur,et maledicet regi suo et deo suo,et suspiciet sursum"
,"22":"et ad terram intuebitur: et ecce tribulatio et tenebrae, caligo opprimens et obscuritas diffusa."
,"23":"Non erit enim amplius caligo, ubi erat oppressio. Primo tempore contemptibilem reddidit terram Zabulon et terram Nephthali; et novissimo glorificavit viam maris, trans Iordanem, Galilaeam gentium."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Populus, qui ambulabat in tenebris, vidit lucem magnam; habitantibus in regione umbrae mortis,lux orta est eis."
,"2":"Multiplicasti exsultationem,et magnificasti laetitiam; laetantur coram te,sicut laetantes in messe, sicut exsultant, quando dividunt spolia."
,"3":"Iugum enim oneris eius,et virgam umeri eius,et sceptrum exactoris eius,fregisti, sicut in die Madian."
,"4":"Quia omnis caliga incedentis cum tumultu,et vestimentum mixtum sanguine,erit in combustionem, cibus ignis."
,"5":"Parvulus enim natus est nobis, filius datus est nobis; et factus est principatus super umerum eius; et vocabitur nomen eius,admirabilis Consiliarius, Deus fortis, Pater aeternitatis, Princeps pacis."
,"6":"Magnum erit eius imperium, et pacis non erit finis,super solium David et super regnum eius, ut confirmet illud et corroboret in iudicio et iustitia,amodo et usque in sempiternum: zelus Domini exercituum faciet hoc."
,"7":"Verbum misit Dominus in Iacob, et cecidit in Israel."
,"8":"Et sciet omnis populus Ephraim et habitantes Samariam,in superbia et magnitudine cordis dicentes:"
,"9":"' Lateres ceciderunt, sed quadris lapidibus aedificabimus; sycomori succisae sunt, sed cedris commutabimus '."
,"10":"Et elevavit Dominus hostes super eum,et inimicos eius excitavit,"
,"11":"Syriam ab oriente et Philisthim ab occidente, qui devoraverunt Israel toto ore. In omnibus his non est aversus furor eius, sed adhuc manus eius extenta."
,"12":"Et populus non est reversus ad percutientem se, et Dominum exercituum non inquisierunt."
,"13":"Et succidit Dominus ab Israel caput et caudam, palmam et arundinem die una:"
,"14":"longaevus et honorabilis vultu ipse est caput, et propheta docens mendacium ipse est cauda;"
,"15":"rectores populi istius seducentes,et, qui regebantur, perierunt."
,"16":"Propter hoc super adulescentulis eius non laetabitur Dominus,et pupillorum eius et viduarum non miserebitur, quia omnis impius est et nequam, et universum os loquitur stultitiam. In omnibus his non est aversus furor eius, sed adhuc manus eius extenta."
,"17":"Succensa est enim quasi ignis impietas, veprem et spinam vorat, et succenditur in densitate saltus, et convolvuntur columnae fumi."
,"18":"In ira Domini exercituum incenditur terra; et est populus quasi esca ignis: vir fratri suo non parcit."
,"19":"Et devorat ad dexteram et esurit,et comedit ad sinistram et non saturatur; unusquisque carnem proximi sui vorat:"
,"20":"Manasses Ephraim, et Ephraim Manassen, simul ipsi contra Iudam. In omnibus his non est aversus furor eius, sed adhuc manus eius extenta."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Vae, qui condunt leges iniquas,et scribentes iniustitiam scribunt,"
,"2":"ut opprimant in iudicio pauperes,et vim faciant causae humilium populi mei, ut fiant viduae praeda eorum, et pupillos diripiant!"
,"3":"Quid facietis in die visitationis,et calamitatis de longe venientis?,Ad cuius confugietis auxilium,et ubi derelinquetis gloriam vestram?"
,"4":"Nam incurvabimini subter captivos,et infra occisos cadetis. In omnibus his non est aversus furor eius, sed adhuc manus eius extenta."
,"5":"Vae Assur, virga furoris mei,et baculus in manu mea, indignatio mea!"
,"6":"Ad gentem impiam mitto eum,et contra populum furoris mei mando illi, ut auferat spolia et diripiat praedam,et ponat illum in conculcationem,quasi lutum platearum."
,"7":"Ipse autem non sic arbitratur, et cor eius non ita existimat; sed in corde suo ad conterendum,et ad internecionem gentium non paucarum."
,"8":"Dicet enim: ' Numquid non principes mei omnes reges sunt?"
,"9":"Numquid non ut Charcamis sic Chalano?,Numquid non ut Arphad sic Emath?,Numquid non ut Damascus sic Samaria?"
,"10":"Quomodo apprehendit manus mea regna idololatra, quorum simulacra plura sunt quam in Ierusalem et in Samaria,"
,"11":"numquid non sicut feci Samariae et idolis eius, sic faciam Ierusalem et simulacris eius? '."
,"12":"Et erit: cum impleverit Dominus cuncta opera sua in monte Sion et in Ierusalem, visitabo super fructum superbiae cordis regis Assyriae et super arrogantiam altitudinis oculorum eius."
,"13":"Dixit enim: ' In fortitudine manus meae feci,et in sapientia mea, prudens sum enim; et abstuli terminos populorum,et scrinia eorum depraedatus sum,et detraxi quasi potens in sublimi sedentes;"
,"14":"et apprehendit quasi nidum manus mea fortitudinem populorum; et sicut colliguntur ova derelicta, sic universam terram ego congregavi, et non fuit qui moveret pennam aut aperiret os et ganniret '."
,"15":"Numquid gloriabitur securis,contra eum, qui secat in ea?,Aut exaltabitur serra,contra eum, qui trahit eam?,Quomodo si agitet virga elevantem eam, et exaltet baculus eum, qui non est lignum."
,"16":"Propter hoc mittet Dominator, Dominus exercituum, in pingues eius tenuitatem; et subtus gloriam eius,ardor ardebit quasi combustio ignis."
,"17":"Et erit Lumen Israel ignis, et Sanctus eius flamma; et succendetur et devorabit spinas eius,et vepres in die una."
,"18":"Et gloriam saltus eius et horti eius,ab anima usque ad carnem consumet, et erit sicut aeger tabescens;"
,"19":"et reliquiae ligni saltus eius,tam paucae erunt, ut puer scribat ea."
,"20":"Et erit in die illa: non adiciet residuum Israel,et, qui effugerint de domo Iacob, inniti super eo, qui percutit eos, sed innitentur super Dominum, Sanctum Israel, in veritate."
,"21":"Reliquiae revertentur, reliquiae, inquam, Iacob, ad Deum fortem."
,"22":"Si enim fuerit populus tuus, Israel, quasi arena maris, reliquiae revertentur ex eo; consummatio decreta redundat in iustitia:"
,"23":"interitum enim, qui decretus est, Dominus, Deus exercituum, faciet in medio omnis terrae."
,"24":"Propter hoc haec dicit Dominus, Deus exercituum: ' Noli timere, populus meus habitator Sion, ab Assur; in virga percutiet te et baculum suum levabit super te sicut Aegyptus."
,"25":"Adhuc enim paululum modicumque, et consummabitur indignatio et furor meus ad destructionem eorum '."
,"26":"Et suscitabit super eum Dominus exercituum flagellum iuxta plagam Madian in Petra Oreb et virgam suam super mare et levabit eam sicut in Aegypto."
,"27":"Et erit in die illa: auferetur onus eius de umero tuo, et iugum eius de collo tuo. Et vastator ascendit a Remmon."
,"28":"Veniet in Aiath, transibit per Magron, apud Machmas deponit sarcinas suas;"
,"29":"transeunt vadum cursim; in Geba pernoctabimus; trepidat Rama, Gabaa Saulis fugit."
,"30":"Hinni voce tua, Bathgallim; attende, Laisa; responde, Anathoth."
,"31":"Migrat Medemena, habitatores Gabim fugiunt;"
,"32":"hodie in Nob stabit: agitabit manum suam ad montem filiae Sion, collem Ierusalem."
,"33":"Ecce Dominator, Dominus exercituum, amputat ramos in terrore, et extrema acumina succiduntur, et sublimes humiliantur;"
,"34":"et caeduntur condensa saltus ferro, et Libanus cum excelsis suis cadet."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et egredietur virga de stirpe Iesse, et flos de radice eius ascendet;"
,"2":"et requiescet super eum spiritus Domini: spiritus sapientiae et intellectus, spiritus consilii et fortitudinis, spiritus scientiae et timoris Domini;"
,"3":"et deliciae eius in timore Domini. Non secundum visionem oculorum iudicabit,neque secundum auditum aurium decernet;"
,"4":"sed iudicabit in iustitia pauperes,et decernet in aequitate pro mansuetis terrae; et percutiet terram virga oris sui,et spiritu labiorum suorum interficiet impium."
,"5":"Et erit iustitia cingulum lumborum eius, et fides cinctorium renum eius."
,"6":"Habitabit lupus cum agno, et pardus cum haedo accubabit; vitulus et leo simul saginabuntur, et puer parvulus minabit eos."
,"7":"Vitula et ursus pascentur, simul accubabunt catuli eorum; et leo sicut bos comedet paleas."
,"8":"Et ludet infans ab ubere,super foramine aspidis; et in cavernam reguli, qui ablactatus fuerit, manum suam mittet."
,"9":"Non nocebunt et non occident,in universo monte sancto meo, quia plena erit terra scientia Domini, sicut aquae mare operiunt."
,"10":"In die illa radix Iesse,stat in signum populorum; ipsam gentes requirent, et erit sedes eius gloriosa."
,"11":"Et erit in die illa: rursus extendet Dominus manum suam,ad possidendum residuum populi sui, quod relictum erit ab Assyria et ab Aegypto,et a Phatros et ab Aethiopia,et ab Elam et a Sennaar,et ab Emath et ab insulis maris;"
,"12":"et levabit signum in nationes,et congregabit profugos Israel,et dispersos Iudae colliget a quattuor plagis terrae."
,"13":"Et auferetur zelus Ephraim, et hostes Iudae abscindentur; Ephraim non aemulabitur Iudam, et Iudas non pugnabit contra Ephraim."
,"14":"Et volabunt in umeros Philisthim ad mare, simul praedabuntur filios orientis: in Edom et Moab extendent manus suas, et filii Ammon oboedient eis."
,"15":"Et exsiccabit Dominus linguam maris Aegypti,et levabit manum suam super flumen in fortitudine spiritus sui,et percutiet illud in septem rivos, ita ut transire faciat eos calceatos."
,"16":"Et erit via residuo populo meo, qui relinquetur ab Assyria, sicut fuit Israeli in die illa, qua ascendit de terra Aegypti."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Et dices in die illa: ' Confitebor tibi, Domine, quoniam cum iratus eras mihi, conversus est furor tuus, et consolatus es me."
,"2":"Ecce Deus salutis meae; fiducialiter agam et non timebo, quia fortitudo mea et laus mea Dominus, et factus est mihi in salutem '."
,"3":"Et haurietis aquas in gaudio de fontibus salutis."
,"4":"Et dicetis in die illa: ' Confitemini Domino et invocate nomen eius, notas facite in populis adinventiones eius; mementote quoniam excelsum est nomen eius."
,"5":"Cantate Domino, quoniam magnifice fecit; notum sit hoc in universa terra."
,"6":"Exsulta et lauda, quae habitas in Sion, quia magnus in medio tui Sanctus Israel '."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Oraculum Babylonis, quod vidit Isaias filius Amos."
,"2":"Super montem decalvatum levate signum, exaltate vocem, levate manum, et ingrediantur portas ducum."
,"3":"Ego mandavi sanctificatis meis,et vocavi fortes meos ad iram meam, exsultantes in gloria mea."
,"4":"Vox multitudinis in montibus quasi populi ingentis, vox sonitus regnorum gentium congregatarum. Dominus exercituum recenset militiam belli;"
,"5":"veniunt de terra procul a termino caeli, Dominus et vasa furoris eius, ut disperdat omnem terram."
,"6":"Ululate, quia prope est dies Domini; quasi vastitas a Domino veniet."
,"7":"Propter hoc omnes manus dissolventur, et omne cor hominis tabescet."
,"8":"Perterrebuntur. Torsiones et dolores tenebunt eos, quasi parturiens dolebunt; unusquisque ad proximum suum stupebit: facies combustae vultus eorum."
,"9":"Ecce dies Domini venit, crudelis et indignationis plenus,et irae furorisque, ad ponendam terram in solitudinem, et peccatores eius conteret de ea."
,"10":"Quoniam stellae caeli et sidera eius,non expandent lumen suum; obtenebratus est sol in ortu suo, et luna non splendebit in lumine suo."
,"11":"Et visitabo super orbem propter mala,et super impios propter iniquitatem eorum; et quiescere faciam superbiam protervorum,et arrogantiam fortium humiliabo. "
,"12":"Pretiosior erit vir auro, et homo mundo obryzo."
,"13":"Super hoc caelum turbabo, et movebitur terra de loco suo,in indignatione Domini exercituum,et in die irae furoris eius."
,"14":"Et erit quasi damula fugiens et quasi ovis, et non erit qui congreget; unusquisque ad populum suum convertetur, et singuli ad terram suam fugient."
,"15":"Omnis, qui inventus fuerit, occidetur, et omnis, qui captus fuerit, cadet in gladio;"
,"16":"infantes eorum allidentur in oculis eorum, diripientur domus eorum, et uxores eorum violabuntur."
,"17":"Ecce ego suscitabo super eos Medos, qui argentum non quaerant nec aurum velint;"
,"18":"sed arcus pueros prosternent,et fructui uteri non miserebuntur."
,"19":"Et erit Babylon, splendor regnorum, inclita superbia Chaldaeorum, sicut cum subvertit Dominus Sodomam et Gomorram."
,"20":"Non habitabitur usque in finem,et non fundabitur usque ad generationem et generationem, nec ponet ibi tentoria Arabs, nec pastores accubare facient ibi,"
,"21":"sed accubabunt ibi bestiae, et replebunt domus eorum ululae, et habitabunt ibi struthiones, et pilosi saltabunt ibi;"
,"22":"et respondebunt ibi hyaenae in aedibus eius, et thoes in delubris voluptatis. Prope est ut veniat tempus eius, et dies eius non elongabuntur."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Miserebitur enim Dominus Iacob,et eliget adhuc de Israel,et requiescere eos faciet super humum suam; adiungetur advena ad eos,et adhaerebit domui Iacob."
,"2":"Et tenebunt eos populi,et adducent eos in locum suum; et possidebit eos domus Israel,super terram Domini in servos et ancillas; et erunt capientes eos, qui se ceperant, et subicient exactores suos."
,"3":"Et erit in die illa: cum requiem dederit tibi Dominus,a labore tuo et a concussione tua,et a servitute dura, qua ante servisti,"
,"4":"proferes parabolam istam contra regem Babylonis et dices: ' Quomodo cessavit exactor, quievit oppressio?"
,"5":"Contrivit Dominus baculum impiorum, virgam dominantium,"
,"6":"caedentem populos in indignatione plaga sine remissione, subicientem in furore gentes persecutione sine fine."
,"7":"Conquievit et siluit omnis terra, gavisa est, et exsultaverunt."
,"8":"Abietes quoque laetatae sunt super te, et cedri Libani: 'Ex quo dormisti, non ascendit, qui succidat nos'."
,"9":"Infernus subter conturbatus est,in occursum adventus tui; suscitat tibi umbras, omnes principes terrae,surgere fecit de soliis suis, omnes reges nationum."
,"10":"Universi respondebunt et dicent tibi: 'Et tu vulneratus es sicut nos, nostri similis effectus es'."
,"11":"Detracta est ad inferos superbia tua, sonitus nablorum tuorum; subter te sternitur tinea, et operimentum tuum sunt vermes."
,"12":"Quomodo cecidisti de caelo, lucifer, fili aurorae?,Deiectus es in terram, qui deiciebas gentes,"
,"13":"qui dicebas in corde tuo: 'In caelum conscendam, super astra Dei exaltabo solium meum, sedebo in monte conventus,in lateribus aquilonis;"
,"14":"ascendam super altitudinem nubium, similis ero Altissimo'."
,"15":"Verumtamen ad infernum detractus es, in profundum laci."
,"16":"Qui te viderint, te intuentur,teque prospicient: 'Numquid iste est vir, qui conturbavit terram, qui concussit regna,"
,"17":"qui posuit orbem desertum,et urbes eius destruxit, vinctis eius non aperuit carcerem?"
,"18":"Omnes reges gentium universi dormiunt in gloria, vir in domo sua;"
,"19":"tu autem proiectus es de sepulcro tuo,quasi stirps abominabilis, obvolutus cum his, qui interfecti sunt gladio,et descenderunt ad lapides sepulcri, quasi cadaver conculcatum."
,"20":"Non habebis consortium cum eis in sepultura; tu enim terram tuam disperdidisti, tu populum tuum occidisti: non vocabitur in aeternum semen malefactorum."
,"21":"Praeparate filios eius occisioni,ob iniquitatem patrum suorum; ne consurgant, ut hereditent terram, neque impleant faciem orbis civitatum' '."
,"22":"' Et consurgam contra eos, dicit Dominus exercituum; et perdam Babylonis nomen et reliquias,et germen et progeniem, dicit Dominus;"
,"23":"et ponam eam in possessionem ericii,et in paludes aquarum, et scopabo eam in scopa destructionis ', dicit Dominus exercituum."
,"24":"Iuravit Dominus exercituum dicens: ' Profecto, ut putavi, ita erit; et quomodo mente tractavi, sic eveniet."
,"25":"Conteram Assyrium in terra mea,et in montibus meis conculcabo eum; et auferetur ab eis iugum eius, et onus illius ab umero eorum tolletur '."
,"26":"Hoc consilium, quod initum est,super omnem terram, et haec est manus extenta,super universas gentes."
,"27":"Dominus enim exercituum decrevit, et quis poterit infirmare?,Et manus eius extenta, et quis avertet eam?"
,"28":"In anno, quo mortuus est rex Achaz, factum est oraculum istud:"
,"29":"' Ne laeteris, Philisthaea omnis tu, quoniam comminuta est virga percussoris tui; de radice enim colubri egredietur regulus, et semen eius draco volans."
,"30":"Et pascentur primogeniti egenorum, et pauperes fiducialiter requiescent; et interire faciam in fame radicem tuam,et reliquias tuas interficiam."
,"31":"Ulula, porta! Clama, civitas!,Contremisce, Philisthaea omnis; ab aquilone enim fumus venit, et non est fugitivus in agminibus eius '."
,"32":"Et quid respondebitur nuntiis gentis?,' Quia Dominus fundavit Sion, et in ipsam confugiunt pauperes populi eius '."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Oraculum Moab. Quia nocte vastata est Ar moab, conticuit; quia nocte vastata est Cirmoab, conticuit."
,"2":"Ascendit filia Dibon ad excelsa in planctum; super Nabo et super Medaba Moab ululavit; in cunctis capitibus eius calvitium, omnis barba rasa."
,"3":"In triviis eius accincti sunt sacco; super tecta eius et in plateis eius,omnes ululant, prorumpunt in fletum."
,"4":"Clamat Hesebon et Eleale, usque Iasa auditur vox eorum; super hoc expediti Moab fremunt, anima eius fremit sibi."
,"5":"Cor meum super Moab clamat, vectes eius usque ad Segor, Eglatselisiam; per ascensum enim Luith flentes ascendunt,et in via Oronaim clamorem contritionis levant."
,"6":"Aquae enim Nemrim desertae erunt, quia aruit herba, defecit germen, viror omnis interiit."
,"7":"Ideo supellectiles colligunt, copias divitiarum suas,trans torrentem Salicum ducunt."
,"8":"Quoniam circuivit clamor terminum Moab; usque ad Eglaim ululatus eius, et usque ad Beerelim clamor eius."
,"9":"Quia aquae Dimon repletae sunt sanguine; ponam enim super Dimon additamenta,his, qui fugerint de Moab leonem, et reliquiis terrae."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Emittite agnum dominatori terrae,de Petra deserti ad montem filiae Sion."
,"2":"Et erit: sicut avis fugiens, et pulli de nido avolantes, sic erunt filiae Moab,ad vada Arnon."
,"3":"Affer consilium, fac iudicium; pone quasi noctem umbram tuam in meridie, absconde fugientes et vagos ne prodas."
,"4":"Habitent apud te profugi Moab; esto latibulum eorum a facie vastatoris; finitus est enim exactor, consummata est devastatio, defecit calcator a terra."
,"5":"Et firmabitur in misericordia solium; et sedebit super illud in veritate, in tabernaculo David, iudicans et quaerens iudicium,et velociter reddens, quod iustum est."
,"6":"Audivimus superbiam Moab,C superbus est valde C,superbiam eius et arrogantiam eius et indignationem eius,et iactantiam eius non rectam."
,"7":"Idcirco ululabit Moab super Moab, omnes ululabunt; super placentas Cirhareseth,lamentantur percussi."
,"8":"Quoniam suburbana Hesebon deserta sunt et vinea Sabama; dominos gentium perdiderunt uvae eius; usque ad Iazer pervenerunt, erraverunt in deserto: propagines eius diffusae sunt, transierunt mare."
,"9":"Super hoc plorabo in fletu Iazer vineam Sabama; inebriabo te lacrima mea, Hesebon et Eleale, quoniam super vindemiam tuam et super messem tuam,clamor cecidit."
,"10":"Et ablata est laetitia et exsultatio de hortis, et in vineis non exsultant neque iubilant. Vinum in torculari non calcabit, qui calcare consueverat; clamor cessavit."
,"11":"Ideo venter meus super Moab quasi cithara fremit, et viscera mea super Cirhareseth."
,"12":"Et erit: cum apparuerit,et laboraverit Moab super excelsis, ingredietur ad sancta sua, ut obsecret, et non valebit."
,"13":"Et hoc verbum, quod locutus est Dominus ad Moab ex tunc;"
,"14":"nunc autem loquitur Dominus dicens: ' In tribus annis, quasi anni mercennarii, auferetur gloria Moab cum omni populo multo, et residuum parvum et modicum nequaquam ingens erit '."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Oraculum Damasci. ' Ecce Damascus desinet esse civitas,et erit sicut acervus ruinarum."
,"2":"Derelictae civitates Aroer gregibus erunt; et requiescent ibi, et non erit qui exterreat."
,"3":"Et auferetur munimentum ab Ephraim,et regnum a Damasco, et reliquiae Syriae sicut gloria filiorum Israel erunt, dicit Dominus exercituum."
,"4":"Et erit in die illa: attenuabitur gloria Iacob, et pinguedo carnis eius marcescet;"
,"5":"et erit, sicut cum messor arripit culmos, et brachium eius spicas legit; et erit, sicut cum quis quaerit spicas in valle Raphaim."
,"6":"Et relinquetur in eo racemus, et sicut cum excutitur olea: duae vel tres olivae in summitate rami,sive quattuor aut quinque in cacuminibus arboris fructiferae ', dicit Dominus Deus Israel."
,"7":"In die illa attendet homo ad factorem suum, et oculi eius ad Sanctum Israel respicient;"
,"8":"et non attendet ad altaria, quae fecerunt manus eius, et quae operati sunt digiti eius; non respiciet lucos et thymiateria."
,"9":"In die illa erunt civitates fortitudinis eius derelictae, sicut civitates, quas dereliquerunt Hevaei et Amorraei,a facie filiorum Israel; et erit desolatio,"
,"10":"quia oblita es Dei salutis tuae,et petrae fortitudinis tuae non es recordata: propterea plantabis plantationes iucundas,et germen alienum seminabis."
,"11":"In ipso die plantationis tuae saepies eas,et mane semen tuum florere facies; evanescet messis in die penuriae, et dolor insanabilis erit."
,"12":"Heu!, strepitus populorum multorum; strepunt quasi strepitu maris, et tumultus turbarum,quasi sonitu aquarum sonabunt."
,"13":"Sonabunt populi sicut sonitus aquarum inundantium, et increpabit eum, et fugiet procul; et rapietur sicut pulvis montium a facie venti,et sicut turbo coram tempestate."
,"14":"In tempore vespere, et ecce turbatio, ante matutinum non subsistet: haec est pars eorum, qui vastaverunt nos, et sors diripientium nos."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Vae terrae alarum strepitantium, quae est trans flumina Aethiopiae!"
,"2":"Quae mittit in mari legatos,et in vasis papyri super aquas: ' Ite, nuntii veloces, ad gentem proceram et lucidam, ad populum terribilem, prope et procul, gentem robustam et conculcantem, cuius flumina scindunt terram '."
,"3":"Omnes habitatores orbis,et in terra commorantes, cum elevatum fuerit signum in montibus, videbitis,et, cum clanguerit tuba, audietis."
,"4":"Quia haec dixit Dominus ad me: ' Quiescam et considerabo in loco meo, sicut calor torrens orta iam luce,et sicut nubes roris in aestu messis '."
,"5":"Etenim ante vindemiam, cum consummatus fuerit flos, et uva germinans maturescens erit, praecidet ramusculos falcibus,et propagines abscindet et proiciet;"
,"6":"et relinquentur simul avibus montium,et bestiis terrae; et aestate erunt super ea volucres, et omnes bestiae terrae super illa hiemabunt."
,"7":"In tempore illo deferetur munus Domino exercituum a populo procero et lucido, a populo terribili, prope et procul, a gente robusta et conculcante, cuius terram flumina scindunt, ad locum nominis Domini exercituum, montem Sion."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Oraculum Aegypti. Ecce Dominus vehitur super nubem levem,et ingreditur Aegyptum; et commovebuntur simulacra Aegypti a facie eius, et cor Aegypti tabescet in medio eius."
,"2":"' Et concurrere faciam Aegyptios adversus Aegyptios; et pugnabit vir contra fratrem suum, et vir contra amicum suum, civitas adversus civitatem, regnum adversus regnum."
,"3":"Et dirumpetur spiritus Aegypti in visceribus eius, et consilium eius confundam; et interrogabunt simulacra et divinos,et pythones et hariolos."
,"4":"Et tradam Aegyptios in manu domini crudelis, et rex fortis dominabitur eorum ', ait Dominus, Deus exercituum."
,"5":"Et arescet aqua de mari, et fluvius desolabitur atque siccabitur,"
,"6":"et putrida fient flumina; attenuabuntur et siccabuntur rivi Aegypti, calamus et iuncus marcescent;"
,"7":"nudabuntur ripae Nili, et omnis planta Nili siccabitur; arescet et non erit."
,"8":"Et maerebunt piscatores, et lugebunt omnes mittentes in flumen hamum; et expandentes rete super faciem aquarum languebunt."
,"9":"Confundentur, qui operantur linum, pectentes et texentes byssum."
,"10":"Et opifices eius deprimentur, omnes mercennarii omnino deficient."
,"11":"Quam stulti principes Taneos!,Sapientes consiliarii pharaonis dederunt consilium insipiens; quomodo dicetis pharaoni: ' Filius sapientium ego, filius regum antiquorum '?"
,"12":"Ubi nunc sunt sapientes tui?,Annuntient tibi et indicent,quid cogitaverit Dominus exercituum super Aegyptum."
,"13":"Stulti facti sunt principes Taneos, decepti sunt principes Mempheos, deceperunt Aegyptum anguli tribuum eius."
,"14":"Dominus miscuit in medio eius spiritum vertiginis, et errare fecerunt Aegyptum in omni opere suo, sicut errat ebrius in vomitu suo;"
,"15":"et non erit Aegypto opus, quod faciat, caput vel cauda, palma vel arundo."
,"16":"In die illa erunt Aegyptii quasi mulieres et stupebunt et timebunt a facie commotionis manus Domini exercituum, quam ipse movebit super eam."
,"17":"Et erit terra Iudae Aegypto in pavorem: omnis, qui illius fuerit recordatus, pavebit a facie consilii Domini exercituum, quod ipse cogitavit super eam."
,"18":"In die illa erunt quinque civitates in terra Aegypti loquentes lingua Chanaan et iurantes per Dominum exercituum. Civitas Solis vocabitur una."
,"19":"In die illa erit altare Domino in medio terrae Aegypti, et titulus iuxta terminum eius Domino."
,"20":"Et erit in signum et in testimonium Domino exercituum in terra Aegypti. Clamabunt enim ad Dominum a facie tribulantium, et mittet eis salvatorem et propugnatorem, qui liberet eos."
,"21":"Et cognoscetur Dominus ab Aegypto, et cognoscent Aegyptii Dominum in die illa; et colent eum in hostiis et in muneribus et vota vovebunt Domino et solvent."
,"22":"Et percutiet Dominus Aegyptum plaga et sanabit; et revertentur ad Dominum, et placabitur eis et sanabit eos."
,"23":"In die illa erit via de Aegypto in Assyriam; et intrabit Assyrius Aegyptum, et Aegyptius in Assyriam, et servient Aegyptii cum Assyriis."
,"24":"In die illa erit Israel tertius cum Aegypto et Assyria; benedictio in medio terrae,"
,"25":"cui benedicet Dominus exercituum dicens: ' Benedictus populus meus Aegyptius, et opus manuum mearum Assyrius, et hereditas mea Israel '."
}`)
	CurrentBook.AddChapter(20, `{
"1":"In anno quo ingressus est Tharthan in Azotum, cum misisset eum Sargon rex Assyriorum, et pugnasset contra Azotum et cepisset eam,"
,"2":"in tempore illo locutus est Dominus in manu Isaiae filii Amos dicens: ' Vade et solve saccum de lumbis tuis et calceamenta tua tolle de pedibus tuis '. Et fecit sic, vadens nudus et discalceatus."
,"3":"Et dixit Dominus: ' Sicut ambulavit servus meus Isaias nudus et discalceatus tribus annis signum et portentum super Aegyptum et super Aethiopiam,"
,"4":"sic minabit rex Assyriorum captivos Aegypti et exsules Aethiopiae, iuvenes et senes, nudos et discalceatos, discoopertis natibus ad ignominiam Aegypti."
,"5":"Et timebunt et confundentur ab Aethiopia spe sua et ab Aegypto gloria sua."
,"6":"Et dicet habitator maritimae regionis huius in die illa: 'Ecce, haec erat spes nostra, quo confugimus in auxilium, ut liberaremur a facie regis Assyriorum; et quomodo effugere poterimus nos?' '."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Oraculum deserti maris. Sicut turbines per austrum transeuntes, de deserto venit, de terra horribili."
,"2":"Visio dura nuntiata est mihi: praedo praedatur, et vastator vastat. Ascende, Elam; obside, Media; omnem gemitum eius cessare feci."
,"3":"Propterea repleti sunt lumbi mei tremore, angustia possedit me sicut angustia parientis; corrui, cum audirem; conturbatus sum, cum viderem."
,"4":"Vacillat cor meum, pavor invadit me: crepusculum optatum,posuit mihi in terrorem."
,"5":"Ponunt mensam, stragulum pandunt, comedunt, bibunt. Surgite, principes, ungite clipeum."
,"6":"Haec enim dixit mihi Dominus: ' Vade et pone speculatorem; quodcumque viderit, annuntiet."
,"7":"Si viderit currum, bigam equitum, ascensorem asini et ascensorem cameli, intueatur diligenter multo intuitu '."
,"8":"Et clamavit speculator: ' Super specula, Domine, ego sum stans iugiter per diem, et super custodiam meam,ego sum stans totis noctibus."
,"9":"Ecce, huc venit agmen virorum, biga equitum '. Et respondit et dixit: ' Cecidit, cecidit Babylon, et omnia sculptilia deorum eius,contrita sunt in terram '."
,"10":"Tritura mea et fili areae meae, quae audivi a Domino exercituum, Deo Israel, annuntiavi vobis."
,"11":"Oraculum Duma. Ad me clamat ex Seir: ' Custos, quid de nocte?,Custos, quid de nocte? '."
,"12":"Dixit custos: ' Venit mane, sed etiam nox; si quaeritis, quaerite, revertimini, venite '."
,"13":"Oraculum in solitudine. In saltu, in solitudine dormietis, turmae Dedanim."
,"14":"Occurrentes sitienti ferte aquam, qui habitatis terram Thema; cum panibus occurrite fugienti:"
,"15":"a facie enim gladiorum fugerunt, a facie gladii nudati, a facie arcus extenti, a facie gravis proelii."
,"16":"Quoniam haec dicit Dominus ad me: ' Adhuc anno sicut anni mercennarii, et auferetur omnis gloria Cedar;"
,"17":"et reliquiae numeri arcuum fortium filiorum Cedar imminuentur; Dominus enim, Deus Israel, locutus est '."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Oraculum vallis Visionis. Quidnam tibi est, quia ascendisti omnis in tecta,"
,"2":"clamoris plena, urbs tumultuans, civitas exsultans?,Interfecti tui non interfecti gladio,nec mortui in bello;"
,"3":"cuncti principes tui fugerunt,simul sine arcu capti; omnes, qui inventi sunt, capti sunt simul, procul fugerunt."
,"4":"Propterea dixi: ' Recedite a me, amare flebo; nolite incumbere, ut consolemini me,super vastitate filiae populi mei '."
,"5":"Dies enim confusionis,et conculcationis et fletus,Domino, Deo exercituum, in valle Visionis, eversio murorum et vociferatio ad montem."
,"6":"Et Elam sumpsit pharetram, in agmine hominum equitum, et Cir nudavit clipeum."
,"7":"Et electae valles tuae,plenae sunt quadrigarum, et equites ponunt sedes suas in porta."
,"8":"Et revelatum est operimentum Iudae, et respexisti in die illa armamentarium domus Saltus;"
,"9":"et scissuras civitatis David vidistis, quia multiplicatae sunt; et congregastis aquas piscinae inferioris."
,"10":"Et domos Ierusalem numerastis,et destruxistis domos,ad muniendum murum;"
,"11":"et lacum fecistis inter duos muros,pro aqua piscinae veteris; sed non suspexistis ad eum, qui fecit haec, et eum, qui haec de longe formavit, non vidistis."
,"12":"Et vocavit Dominus, Deus exercituum, in die illa,ad fletum et ad planctum, ad calvitium et ad cingendum saccum;"
,"13":"et ecce gaudium et laetitia, occidere boves et iugulare pecus, comedere carnes et bibere vinum: ' Comedamus et bibamus, cras enim moriemur '."
,"14":"Et revelatum est in auribus meis,a Domino exercituum: ' Certe non dimittetur iniquitas haec vobis, donec moriamini! ', dicit Dominus, Deus exercituum."
,"15":"Haec dicit Dominus, Deus exercituum: ' Vade, ingredere ad procuratorem istum, ad Sobnam praepositum palatii:"
,"16":"'Quid tibi hic? Aut quis tibi hic, quia excidisti tibi hic sepulcrum?'. Effodiens in excelso sepulcrum suum, excavabat in petra tabernaculum sibi."
,"17":"Ecce Dominus vehementer proiciet te, homo, violenter te apprehendens."
,"18":"In globum te convolvet glomerans; quasi pilam mittet te,in terram latam et spatiosam: ibi morieris, et ibi erunt currus gloriae tuae, ignominia domus domini tui."
,"19":"Et expellam te de statione tua,et de ministerio tuo deponam te."
,"20":"Et erit in die illa: vocabo servum meum Eliachim filium Helciae"
,"21":"et induam illum tunicam tuam,et cingulo tuo cingam eum,et potestatem tuam dabo in manu eius; et erit in patrem habitantibus Ierusalem,et domui Iudae."
,"22":"Et dabo clavem domus David,super umerum eius; et aperiet, et non erit qui claudat; et claudet, et non erit qui aperiat."
,"23":"Et figam illum paxillum in loco securo, et erit in solium gloriae domui patris sui."
,"24":"Et suspendent super eum omnem gloriam domus patris sui, propagines et stirpes, omne vas parvulum, a pelvibus ad amphoras."
,"25":"In die illa, dicit Dominus exercituum, auferetur paxillus, qui fixus fuerat in loco securo, et frangetur et cadet; et peribit, quod pependerat in eo, quia Dominus locutus est '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Oraculum Tyri. Ululate, naves Tharsis, quia vastatum est refugium vestrum; cum redirent de terra Cetthim, revelatum est eis."
,"2":"Obstupescite, qui habitatis in insula; negotiatores Sidonis,transfretantes mare repleverunt te. "
,"3":"In aquis multis semen Nili, messis fluminis fruges eius; et facta est negotiatio gentium."
,"4":"Erubesce, Sidon, ait enim mare, fortitudo maris, dicens: ' Non parturivi et non peperi; et non enutrivi iuvenes,nec virgines educavi '."
,"5":"Cum auditum fuerit in Aegypto, dolebunt cum audierint de Tyro."
,"6":"Transite ad Tharsis, ululate, qui habitatis in insula."
,"7":"Estne vestra haec, quae gloriabatur?,A diebus pristinis antiquitas eius. Ducebant eam pedes sui longe,ad peregrinandum."
,"8":"Quis cogitavit hoc,super Tyrum quondam coronatam, cuius negotiatores principes, institores eius incliti terrae?"
,"9":"Dominus exercituum cogitavit hoc, ut detraheret superbiam omnis gloriae,et viles faceret universos inclitos terrae."
,"10":"Excole terram tuam sicut litus Nili, filia Tharsis, iam non est portus."
,"11":"Manum suam extendit super mare, conturbavit regna. Dominus mandavit adversus Chanaan, ut contereret munimenta eius,"
,"12":"et dixit: ' Non adicies ultra ut glorieris, violata virgo filia Sidonis; in Cetthim consurgens transfreta: ibi quoque non erit requies tibi '."
,"13":"Ecce terra Chaldaeorum: talis populus non fuit; Assyria fundavit eam pro feris. Erexerunt turres suas; suffoderunt domos eius, posuerunt eam in ruinam."
,"14":"Ululate, naves Tharsis, quia devastatum est praesidium vestrum."
,"15":"Et erit in die illa: in oblivione erit Tyrus septuaginta annis, sicut dies regis unius. Post septuaginta autem annos erit Tyro iuxta canticum meretricis:"
,"16":"' Sume citharam, circui civitatem, meretrix oblivioni tradita; bene cane, frequenta canticum, ut memoria tui sit '."
,"17":"Et erit: post septuaginta annos visitabit Dominus Tyrum, et redibit ad mercedes suas et rursum fornicabitur cum universis regnis terrae super faciem terrae."
,"18":"Et erunt negotiatio eius et merces eius sanctificatae Domino; non condentur neque reponentur, quia his, qui habitaverint coram Domino, erit negotiatio eius, ut manducent in saturitate et vestiantur splendide."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Ecce Dominus dissipat terram et frangit eam,et conturbat faciem eius,et dispergit habitatores eius."
,"2":"Et erit sicut populus sic sacerdos, et sicut servus sic dominus eius, sicut ancilla sic domina eius, sicut emens sic ille qui vendit, sicut fenerator sic is qui mutuum accipit, sicut qui repetit sic qui debet."
,"3":"Dissipatione dissipabitur terra,et direptione praedabitur: Dominus enim locutus est verbum hoc."
,"4":"Luget, languet terra, marcescit, languet orbis, marcescit altitudo simul cum terra. "
,"5":"Et terra infecta est sub habitatoribus suis, quia transgressi sunt leges, violaverunt mandatum, dissipaverunt foedus sempiternum."
,"6":"Propter hoc maledictio voravit terram, et poenas exsolverunt habitatores eius; ideoque imminuti sunt cultores eius, et relicti sunt homines pauci."
,"7":"Luget mustum, emarcuit vitis, ingemiscunt omnes, qui laetabantur corde."
,"8":"Cessavit gaudium tympanorum, quievit sonitus laetantium, cessavit gaudium citharae;"
,"9":"cum cantico non bibent vinum, amara erit potio bibentibus illam."
,"10":"Attrita est civitas inanitatis, clausa est omnis domus, ut nemo introeat;"
,"11":"clamor est super vino in plateis, occidit omnis laetitia, translatum est gaudium terrae."
,"12":"Relicta est in urbe solitudo, et in ruinam confracta est porta;"
,"13":"quia haec erunt in medio terrae, in medio populorum, quomodo si olivae excutiantur, et finita vindemia colligantur racemi."
,"14":"Hi levabunt vocem suam, laudabunt maiestatem Domini, hinnient de mari."
,"15":"Propter hoc in regionibus lucis glorificate Dominum, in insulis maris nomen Domini, Dei Israel."
,"16":"A finibus terrae laudes audivimus: ' Gloria iusto '. Et dixi: ' Secretum meum mihi, secretum meum mihi. Vae mihi! '. Praevaricantes praevaricati sunt,et praevaricatione praevaricantium praevaricati sunt."
,"17":"Formido et fovea et laqueus super te, habitator terrae."
,"18":"Et erit: qui fugerit a voce formidinis, cadet in foveam; et, qui ascenderit de fovea, tenebitur laqueo, quia cataractae de excelsis apertae sunt, et concussa sunt fundamenta terrae. "
,"19":"Confractione confracta est terra, contritione contrita est terra, commotione commota est terra,"
,"20":"agitatione agitabitur terra sicut ebrius,et fluctuabit quasi tabernaculum; et gravis erit super eam iniquitas eius, et corruet et non adiciet ut resurgat."
,"21":"Et erit in die illa: visitabit Dominus super militiam caeli in excelso,et super reges terrae super terram;"
,"22":"et congregabuntur et vincientur in lacu,et claudentur in carcere; et post multos dies visitabuntur."
,"23":"Et erubescet luna, et confundetur sol, quia regnavit Dominus exercituum in monte Sion et in Ierusalem,et in conspectu senum suorum glorificabitur."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Domine, Deus meus es tu; exaltabo te, confitebor no mini tuo, quoniam fecisti mirabilia, cogitationes antiquas, fideles, veraces."
,"2":"Quia posuisti civitatem in tumulum, urbem munitam in ruinam: arx superborum non amplius est civitas, in sempiternum non reaedificabitur."
,"3":"Super hoc glorificabit te populus fortis, civitas gentium robustarum timebit te;"
,"4":"quia factus es fortitudo pauperi, fortitudo egeno in tribulatione sua, protectio a turbine, umbraculum ab aestu: spiritus enim robustorum,quasi imber hiemalis."
,"5":"Sicut aestus in arida,tumultum superborum humiliabis; sicut aestus in umbra nubis,canticum fortium reprimes."
,"6":"Et faciet Dominus exercituum,omnibus populis in monte hoc,convivium pinguium, convivium vini meri, pinguium medullatorum, vini deliquati."
,"7":"Et praecipitabit in monte isto,faciem vinculi colligati super omnes populos,et telam, quam orditus est super omnes nationes."
,"8":"Praecipitabit mortem in sempiternum,et absterget Dominus Deus lacrimam ab omni facie,et opprobrium populi sui auferet de universa terra, quia Dominus locutus est."
,"9":"Et dicetur in die illa: ' Ecce Deus noster iste, exspectavimus eum, ut salvaret nos; iste Dominus, sustinuimus eum: exsultabimus et laetabimur in salutari eius."
,"10":"Quia requiescet manus Domini in monte isto '. Et triturabitur Moab in loco suo, sicuti teruntur paleae in sterquilinio;"
,"11":"et extendet manus suas in medio eius, sicut extendit natans ad natandum; et humiliabitur superbia eius,cum allisione manuum eius."
,"12":"Et firmum munimentum murorum tuorum evertit, deiecit, prostravit in terram usque ad pulverem."
}`)
	CurrentBook.AddChapter(26, `{
"1":"In die illa cantabitur canticum istud in terra Iudae: ' Urbs fortis nobis in salutem; posuit muros et antemurale."
,"2":"Aperite portas, et ingrediatur gens iusta, quae servat fidem."
,"3":"Propositum eius est firmum; servabis pacem, quia in te speravit."
,"4":"Sperate in Dominum in saeculis aeternis, Dominus est petra aeterna."
,"5":"Quia evertit habitantes in excelso, civitatem sublimem humiliabit; humiliabit eam usque ad terram, detrahet eam usque ad pulverem."
,"6":"Conculcabit eam pes, pedes pauperis, gressus egenorum."
,"7":"Semita iusti recta est; rectum callem iusti complanas."
,"8":"Et in semita iudiciorum tuorum, Domine, speravimus in te; ad nomen tuum et ad memoriale tuum desiderium animae."
,"9":"Anima mea desiderat te in nocte, sed et spiritu meo in praecordiis meis te quaero. Cum resplenduerint iudicia tua in terra, iustitiam discent habitatores orbis. "
,"10":"Fit misericordia impio, non discet iustitiam; in terra probitatis inique gerit,et non videt maiestatem Domini."
,"11":"Domine, exaltata est manus tua, et non vident; videant confusi zelum tuum in populum, et ignis hostium tuorum devorabit eos."
,"12":"Domine, dabis pacem nobis; omnia enim opera nostra operatus es nobis."
,"13":"Domine Deus noster, possederunt nos domini absque te; tantum in te recordemur nominis tui."
,"14":"Mortui non reviviscent, defuncti non resurgent; propterea visitasti et contrivisti eos et perdidisti omnem memoriam eorum. "
,"15":"Auxisti gentem, Domine, auxisti gentem, glorificatus es; elongasti omnes terminos terrae."
,"16":"Domine, in angustia quaesierunt te, fuderunt incantationem, castigatio tua in eis."
,"17":"Sicut quae concipit, cum appropinquaverit ad partum,dolens clamat in doloribus suis, sic facti sumus a facie tua, Domine."
,"18":"Concepimus et parturivimus, quasi peperimus ventum. Salutes non fecimus in terra, ideo non nati sunt habitatores terrae."
,"19":"Reviviscent mortui tui, interfecti mei resurgent. Expergiscimini et laudate, qui habitatis in pulvere, quia ros lucis ros tuus, et terra defunctos suos edet in lucem."
,"20":"Vade, populus meus, intra in cubicula tua, claude ostia tua super te, abscondere modicum ad momentum, donec pertranseat indignatio."
,"21":"Ecce enim Dominus egredietur de loco suo, ut visitet iniquitatem habitatoris terrae contra eum; et revelabit terra sanguinem suum,et non operiet ultra interfectos suos '."
}`)
	CurrentBook.AddChapter(27, `{
"1":"In die illa visitabit Dominus,in gladio suo duro et forti et grandi,super Leviathan serpentem fugacem,et super Leviathan serpentem tortuosum,et occidet draconem, qui in mari est."
,"2":"In die illa vinea erit iucunda; cantate ei."
,"3":"Ego Dominus, qui servo eam; per singula momenta irrigabo eam. Ne forte visitetur contra eam, nocte et die servo eam."
,"4":"Indignatio non est mihi. Quis dabit mihi spinam et veprem?,In proelio gradiar super eam, succendam eam pariter,"
,"5":"nisi forte protectionem meam apprehendat, faciat pacem mecum, pacem faciat mecum."
,"6":"Diebus futuris radices mittet Iacob, florebit et germinabit Israel, et implebunt faciem orbis fructibus."
,"7":"Numquid iuxta plagam percutientis eum percussit eum?,Aut, sicut occiduntur occisi eius, occisus est?"
,"8":"In mensura punit eum deiciens eum, impellit in spiritu suo duro, tempore quo spirat eurus."
,"9":"Idcirco super hoc dimittetur iniquitas Iacob, et hic erit omnis fructus ablationis peccati eius: ut scilicet ponat omnes lapides altaris,sicut lapides calcis comminutos, ne exstent luci et thymiateria."
,"10":"Civitas enim munita desolata est, habitaculum derelictum et dimissum quasi desertum; ibi pascetur vitulus et ibi accubabit,et consumet arbusta eius."
,"11":"In siccitate frondes illius conterentur; mulieres venient et comburent eas. Ipse enim non est populus sapiens, propterea non miserebitur eius, qui fecit eum, et, qui formavit eum, non parcet ei."
,"12":"Et erit: in die illa percutiet spicas Dominus,a Flumine usque ad torrentem Aegypti; et vos congregabimini,unus et unus, filii Israel."
,"13":"Et erit: in die illa clangetur in tuba magna; et venient, qui perditi fuerant de terra Assyriorum, et qui eiecti erant in terra Aegypti, et adorabunt Dominum,in monte sancto in Ierusalem."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Vae coronae superbiae ebriorum Ephraim,et flori decidenti gloriae maiestatis eius, qui erant in vertice vallis pinguissimae, errantes a vino!"
,"2":"Ecce validus et fortis Domino,sicut impetus grandinis, turbo confringens, sicut impetus aquarum multarum inundantium, et deiciet in terram violenter."
,"3":"Pedibus conculcabitur,corona superbiae ebriorum Ephraim;"
,"4":"et erit flos decidens gloriae maiestatis eius, qui est super verticem vallis pinguium, quasi ficus praecox ante messem, quam quis, ut viderit, manu statim arreptam devorabit."
,"5":"In die illa erit Dominus exercituum,corona gloriae,et sertum maiestatis,residuo populi sui"
,"6":"et spiritus iudicii,sedenti ad iudicandum,et fortitudo,vertentibus proelium usque ad portam."
,"7":"Verum hi quoque prae vino vacillant,et prae ebrietate nutant; sacerdos et propheta vacillant prae ebrietate, absorpti sunt a vino, nutant in ebrietate, vacillant in visione, fluctuant in iudicio."
,"8":"Omnes enim mensae repletae sunt vomitu sordiumque, ita ut non esset ultra locus."
,"9":"Quem docebit scientiam?,Et quem intellegere faciet auditum?,Ablactatos a lacte, avulsos ab uberibus."
,"10":"Etenim praeceptum ad praeceptum, praeceptum ad praeceptum, regula ad regulam, regula ad regulam, modicum ibi, modicum ibi."
,"11":"Balbis enim labiis et lingua altera,loquetur ad populum istum,"
,"12":"cui dixerat: ' Haec requies, reficite lassum; et hoc est refrigerium '. Et noluerunt audire."
,"13":"Et erit eis verbum Domini: ' Praeceptum ad praeceptum, praeceptum ad praeceptum, regula ad regulam, regula ad regulam, modicum ibi, modicum ibi ', ut vadant et cadant retrorsum et conterantur,et illaqueentur et capiantur."
,"14":"Propter hoc audite verbum Domini, viri illusores, qui dominamini super populum meum, qui est in Ierusalem."
,"15":"Dixistis enim: ' Percussimus foedus cum morte,et cum inferno fecimus pactum; flagellum inundans cum transierit, non veniet super nos, quia posuimus mendacium spem nostram,et in fallacia absconditi sumus '."
,"16":"Idcirco haec dicit Dominus Deus: ' Ecce ego fundamentum ponam in Sion, lapidem, lapidem probatum, angularem, pretiosum, fundatum; qui crediderit, non turbabitur."
,"17":"Et ponam iudicium tamquam normam,et iustitiam tamquam perpendiculum; et subvertet grando spem mendacii, et latibulum aquae inundabunt."
,"18":"Et delebitur foedus vestrum cum morte, et pactum vestrum cum inferno non stabit; flagellum inundans cum transierit, eritis ei in conculcationem."
,"19":"Quandocumque pertransierit, tollet vos; quoniam mane diluculo pertransibit, in die et in nocte, et erit tantummodo horrendum intellegere auditum '."
,"20":"Coangustatum est enim stratum, ut quis se extendat, et pallium brevius, ut quis se operire possit."
,"21":"Sicut enim in monte Pharasim stabit Dominus, sicut in valle, quae est in Gabaon, irascetur, ut faciat opus suum, novum opus suum, ut operetur operationem suam, peregrinam operationem suam."
,"22":"Et nunc nolite illudere, ne forte constringantur vincula vestra; decretum enim destructionis audivi,a Domino, Deo exercituum, super universam terram."
,"23":"Auribus percipite et audite vocem meam, attendite et audite eloquium meum."
,"24":"Numquid tota die arat arans, ut serat, proscindit et sarrit humum suam?"
,"25":"Nonne, cum adaequaverit faciem eius, spargit nigellam et serit cuminum, ponit triticum et hordeum,et far in finibus suis?"
,"26":"Erudit enim illum recte, Deus suus docet illum."
,"27":"Non enim in serris trituratur nigella, nec rota plaustri super cuminum circuit; sed in virga excutitur nigella, et cuminum in baculo."
,"28":"Numquid comminuitur triticum?,Verum non in perpetuum triturans triturabit illum, neque vexabit eum rota plaustri, nec ungulis suis comminuet eum."
,"29":"Et hoc a Domino, Deo exercituum, exivit; mirabile fecit consilium, magnificavit sapientiam."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Vae Ariel, Ariel, civitas, quam circumdedit David!,Addite annum ad annum, sollemnitates evolvantur;"
,"2":"et circumvallabo Ariel, et erit maeror et maestitia, et erit mihi quasi Ariel."
,"3":"Et circumdabo te quasi sphaeram,et iaciam contra te aggerem,et munimenta ponam in obsidionem tuam."
,"4":"Humiliaberis, de terra loqueris, et de pulvere vix audietur eloquium tuum, et erit quasi pythonis de terra vox tua, et de humo eloquium tuum mussitabit."
,"5":"Et erit sicut pulvis tenuis multitudo superborum tuorum, et sicut palea volans multitudo fortium. Eritque repente confestim,"
,"6":"a Domino exercituum visitaberis,in tonitruo et commotione terrae, magno fragore, turbine et tempestate,et flamma ignis devorantis."
,"7":"Et erit sicut somnium visionis nocturnae,multitudo omnium gentium, quae dimicant contra Ariel, et omnes, qui pugnant contra eam et contra munimenta eius et oppressores eius;"
,"8":"Et sicut somniat esuriens, et ecce comedit, cum autem fuerit expergefactus, vacua est anima eius; et sicut somniat sitiens, et ecce bibit,et, postquam fuerit expergefactus, lassus adhuc sitit, et anima eius vacua est, sic erit multitudo omnium gentium,dimicantium contra montem Sion. "
,"9":"Obstupescite et admiramini, excaecamini et caeci estote, inebriamini et non a vino, vacillate et non ab ebrietate."
,"10":"Quoniam miscuit vobis Dominus spiritum soporis, clausit oculos vestros,et capita vestra operuit."
,"11":"Et erit vobis visio omnis sicut verba libri signati; quem cum dederint scienti litteras dicentes: ' Lege istum ', respondebit: ' Non possum, signatus est enim '."
,"12":"Et dabitur liber nescienti litteras diceturque ei: ' Lege ', et respondebit: ' Nescio litteras '."
,"13":"Et dixit Dominus: ' Eo quod appropinquat populus iste ore suo,et labiis suis glorificat me, cor autem eius longe est a me, et est timor eorum erga me,velut mandatum hominum perceptum,"
,"14":"ideo ecce ego addam ut admirationem faciam,populo huic miraculo grandi et stupendo: peribit sapientia sapientium eius, et prudentia prudentium eius abscondetur '."
,"15":"Vae, qui profunde a Domino,consilium abscondunt, quorum sunt in tenebris opera, et dicunt: ' Quis videt nos, et quis novit nos? '."
,"16":"Perversa cogitatio vestra!,Numquid quasi lutum reputabitur figulus, ut dicat opus factori suo: ' Non fecisti me '; et figmentum dicat fictori suo: ' Non intellegis '?"
,"17":"Nonne adhuc in modico et in brevi convertetur Libanus in hortum, et hortus in saltum reputabitur?"
,"18":"Et audient in die illa surdi verba libri, et de tenebris et caligine oculi caecorum videbunt."
,"19":"Et addent mites in Domino laetitiam, et pauperrimi hominum in Sancto Israel exsultabunt;"
,"20":"quoniam defecit, qui praevalebat, consummatus est illusor, et succisi sunt omnes, qui vigilabant super iniquitatem,"
,"21":"qui peccare faciebant homines in verbo,et arguentem in porta supplantabant,et deiecerunt inanibus verbis iustum."
,"22":"Propter hoc haec dicit Dominus,ad domum Iacob, qui redemit Abraham: ' Non modo confundetur Iacob, nec modo vultus eius erubescet;"
,"23":"sed, cum viderit opera manuum mearum, in medio sui sanctificabunt nomen meum,et sanctificabunt Sanctum Iacob,et Deum Israel pavebunt,"
,"24":"et scient errantes spiritu sapientiam, et mussitatores discent doctrinam '."
}`)
	CurrentBook.AddChapter(30, `{
"1":"' Vae, filii desertores, dicit Dominus, eo quod facitis consilium et non ex me, et pactum statuitis et non per spiritum meum, ut addatis peccatum super peccatum!"
,"2":"Qui ambulatis, ut descendatis in Aegyptum, et os meum non interrogastis, sperantes auxilium in fortitudine pharaonis,et habentes fiduciam in umbra Aegypti."
,"3":"Et erit vobis fortitudo pharaonis in confusionem, et fiducia sub umbra Aegypti in ignominiam."
,"4":"Cum fuerint enim in Tani principes tui, et nuntii tui usque ad Hanes pervenerint,"
,"5":"omnes confundentur,super populo, qui eis prodesse non potest; non erit in auxilium et in utilitatem sed in confusionem et opprobrium '. "
,"6":"Oraculum iumentorum Nageb. In terra tribulationis et angustiae, leaenae et leonis rugientis, viperae et draconis volantis,portant super umeros iumentorum divitias suas,et super gibbum camelorum thesauros suos,ad populum, qui eis prodesse non poterit."
,"7":"Aegyptus enim frustra et vane auxiliabitur; ideo vocavi Rahab otiosam."
,"8":"Nunc ingredere, scribe coram eis super buxum,et in libro diligenter exara illud, et erit in posterum,in testimonium usque in aeternum."
,"9":"Populus enim rebellis est, et filii mendaces, filii nolentes audire legem Domini;"
,"10":"qui dicunt videntibus: ' Nolite videre ',et aspicientibus: ' Nolite aspicere nobis ea, quae recta sunt; loquimini nobis placentia, aspicite nobis illusiones."
,"11":"Recedite a via, declinate a semita, tollite a facie nostra Sanctum Israel '."
,"12":"Propterea haec dicit Sanctus Israel: ' Pro eo quod reprobastis verbum hoc,et sperastis in perversitatem et in perfidiam,et innixi estis super eis,"
,"13":"propterea erit vobis iniquitas haec,sicut interruptio cadens, locus tumens in muro excelso, cuius confractio subito, dum non speratur, venit improviso;"
,"14":"et comminuetur, sicut conteritur lagoena figuli, contritione absque misericordia, et non invenietur de fragmentis eius testa, in qua capiatur igniculus de incendio, aut hauriatur aqua de fovea '."
,"15":"Quia haec dixit Dominus Deus, Sanctus Israel: ' In conversione et quiete salvi eritis; in silentio et in spe erit fortitudo vestra '. Et noluistis 16 et dixistis: ' Nequaquam, sed super equis fugiemus ', ideo fugietis; et: ' Super veloces ascendemus ', ideo veloces erunt, qui persequentur vos."
,"17":"Mille pavebunt a facie terroris unius, et a facie terroris quinque fugietis, donec relinquamini,quasi malus in vertice montis,et quasi signum super collem."
,"18":"Propterea exspectat Dominus, ut misereatur vestri, et ideo exaltabitur parcens vobis, quia Deus iudicii Dominus; beati omnes, qui exspectant eum."
,"19":"Nam, popule Sion, qui habitas in Ierusalem, plorans nequaquam plorabis: miserans miserebitur tui ad vocem clamoris tui; statim ut audierit, respondebit tibi. "
,"20":"Et dabit vobis Dominus,panem angustiae et aquam afflictionis, sed non amplius avolabit a te doctor tuus; et erunt oculi tui videntes praeceptorem tuum,"
,"21":"et aures tuae audient verbum post tergum monentis: ' Haec via, ambulate in ea ', si declinaveritis ad dexteram vel ad sinistram."
,"22":"Et contaminabis laminas sculptilium argentorum tuorum,et vestimentum conflatilis aurei tui; disperges ea sicut immunditiam menstruatae. ' Egredere ' dices ei."
,"23":"Et dabit pluviam semini tuo, quod seminaveris in terra, et panis frugum terrae erit uberrimus et pinguis; pascetur pecus tuum in die illo, agnus in pascuis spatiosis,"
,"24":"et boves tui et asini, qui operantur terram, commixtum migma comedent,ventilatum in pala et ventilabro."
,"25":"Et erunt super omnem montem excelsum,et super omnem collem elevatum,rivi currentium aquarum,in die interfectionis multorum, cum ceciderint turres."
,"26":"Et erit lux lunae sicut lux solis, et lux solis erit septempliciter sicut lux septem dierum,in die, qua alligaverit Dominus vulnus populi sui,et percussuram plagae eius sanaverit."
,"27":"Ecce nomen Domini venit de longinquo, ardens furor eius, et gravis eius fragor; labia eius repleta sunt indignatione, et lingua eius quasi ignis devorans."
,"28":"Spiritus eius velut torrens inundans, usque ad collum pertingens, ad cribrandas gentes in cribro funesto, et frenum dolosum in maxillis populorum."
,"29":"Canticum erit vobis,sicut nox sanctificatae sollemnitatis, et laetitia cordis,sicut eius, qui ad sonum tibiae pergit,in montem Domini, ad petram Israel."
,"30":"Et auditam faciet Dominus,gloriam vocis suae,et terrorem brachii sui,ostendet in comminatione furoris,et flamma ignis devorantis, in turbine et in imbre et in lapide grandinis."
,"31":"A voce enim Domini pavebit,Assyrius virga percussus."
,"32":"Et erit omnis ictus baculi percutientis, quem requiescere faciet Dominus,super eum in tympanis et citharis, et in bellis agitatis expugnabit eos."
,"33":"Praeparata est enim ab heri Topheth, praeparata, profunda et dilatata, in pyra eius ignis et ligna multa; flatus Domini sicut torrens sulphuris,succendit eam."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Vae, qui descendunt in Aegyptum ad auxilium, in equis sperantes,et habentes fiduciam super quadrigis, quia multae sunt, et super equitibus, quia praevalidi nimis, et non intendunt in Sanctum Israel,et Dominum non requirunt!"
,"2":"Tamen et ipse sapiens adducit malum,et verba sua non retractat; et consurget contra domum pessimorum,et contra auxilium operantium iniquitatem."
,"3":"Aegyptius homo et non Deus, et equi eorum caro et non spiritus; et Dominus inclinabit manum suam, et corruet auxiliator, et cadet, cui praestatur auxilium, simulque omnes consumentur."
,"4":"Quia haec dicit Dominus ad me: ' Quomodo si rugit leo et catulus leonis super praedam suam, cum occurrerit ei multitudo pastorum, a voce eorum non formidabit et a multitudine eorum non pavebit, sic descendet Dominus exercituum, ut proelietur super montem Sion et super collem eius."
,"5":"Sicut aves volantes, sic proteget Dominus exercituum Ierusalem, protegens et liberans, parcens et salvans '."
,"6":"Convertimini ad eum, a quo penitus recesseratis, filii Israel."
,"7":"In die enim illa abiciet vir,idola argentea sua et idola aurea sua, quae fecerunt vobis manus vestrae in peccatum;"
,"8":"et cadet Assyria in gladio non viri, et gladius non hominis vorabit eum, et fugiet a facie gladii, et iuvenes eius vectigales erunt."
,"9":"Et fortitudo eius prae terrore transibit, et pavebunt signum principes eius, dixit Dominus, cuius ignis est in Sion, et caminus eius in Ierusalem."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Ecce in iustitia regnabit rex, et principes in iudicio praee runt."
,"2":"Et erit vir sicut latibulum a vento,et refugium a tempestate, sicut rivi aquarum in sitiente terra,et umbra petrae magnae in terra arida."
,"3":"Non caligabunt oculi videntium, et aures audientium diligenter auscultabunt,"
,"4":"et cor stultorum intelleget scientiam, et lingua balborum velociter loquetur et plane."
,"5":"Non vocabitur ultra is, qui insipiens est, nobilis, neque fraudulentus appellabitur maior;"
,"6":"stultus enim fatua loquitur, et cor eius cogitat iniquitatem, ut perficiat impietatem,et loquatur contra Dominum errores,et vacuam faciat animam esurientem,et potum sitienti auferat."
,"7":"Fraudulenti fraudes pessimae sunt; ipse enim cogitationes concinnat,ad perdendos mites in sermone mendaci, etiam quando pauper iudicium vindicat."
,"8":"Nobilis vero consilia nobilia dat,et ipse ad nobilia assurget."
,"9":"Mulieres vanae, surgite, audite vocem meam; filiae confidentes, percipite auribus eloquium meum."
,"10":"Post dies enim et annum,vos pavebitis confidentes; consummata est enim vindemia, collectio ultra non veniet."
,"11":"Obstupescite, vanae; pavete, confidentes, exuite vos et nudate vos, accingite lumbos vestros."
,"12":"Super ubera plangite, super regione desiderabili, super vinea fertili."
,"13":"Super humum populi mei,spinae et vepres ascendent, super omnes domos gaudii, super civitatem exsultantem."
,"14":"Domus enim dimissa est; multitudo urbis relicta est, Ophel et Bahan erunt speluncae,usque in aeternum, gaudium onagrorum, pascua gregum,"
,"15":"donec effundatur super nos,spiritus de excelso. Et erit desertum in hortum, et hortus in saltum reputabitur,"
,"16":"et habitabit in solitudine iudicium, et iustitia in horto sedebit;"
,"17":"et erit opus iustitiae pax, et cultus iustitiae silentium, et securitas usque in sempiternum."
,"18":"Et sedebit populus meus in habitatione pacis,et in tabernaculis fiduciae,et in locis securis."
,"19":"Et penitus cadet saltus, et profunde deprimetur civitas."
,"20":"Beati, qui seminatis super omnes aquas, immittentes pedem bovis et asini."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Vae, qui praedaris, cum nemo te praedatus sit; qui devastas, cum nemo te devastaverit!,Cum consummaveris depraedationem, depraedaberis; cum perfeceris devastationem, te devastabunt."
,"2":"Domine, miserere nostri, te enim exspectavimus; esto brachium nostrum in mane,et salus nostra in tempore tribulationis."
,"3":"A voce fragoris fugerunt populi, ab exaltatione tua dispersae sunt gentes."
,"4":"Et congregabuntur spolia, sicut colligitur bruchus; sicut discurrunt locustae, ad ea discurritur."
,"5":"Sublimis est Dominus, quoniam habitat in excelso; implet Sion iudicio et iustitia."
,"6":"Et erit firmitas in temporibus tuis; divitiae salutis sapientia et scientia: timor Domini ipse est thesaurus eius."
,"7":"Ecce praecones clamabunt foris, angeli pacis amare flebunt."
,"8":"Dissipatae sunt viae, cessavit transiens per semitam; irritum fecit pactum, reiecit testes, non reputavit homines."
,"9":"Luget et elanguescit terra, confusus est Libanus et obsorduit, et factus est Saron sicut desertum, et exaruerunt Basan et Carmelus."
,"10":"' Nunc consurgam, dicit Dominus, nunc exaltabor, nunc sublevabor."
,"11":"Concipietis fenum, parietis stipulam; spiritus meus ut ignis vorabit vos."
,"12":"Et erunt populi fornaces calcis: spinae congregatae igne comburentur."
,"13":"Audite, qui longe estis, quae fecerim, et cognoscite, vicini, fortitudinem meam '."
,"14":"Conterriti sunt in Sion peccatores, possedit tremor impios. Quis poterit habitare de vobis cum igne devorante?,Quis habitabit ex vobis cum ardoribus sempiternis?"
,"15":"Qui ambulat in iustitiis et loquitur aequitates, qui reicit lucra ex rapinis,et excutit manus suas, ne munera accipiat, qui obturat aures suas, ne audiat sanguinem, et claudit oculos suos, ne videat malum:"
,"16":"iste in excelsis habitabit, munimenta saxorum refugium eius; panis ei datus est, aquae eius fideles sunt."
,"17":"Regem in decore suo videbunt oculi tui, cernent terram longinquam."
,"18":"Cor tuum cum timore inquiret: ' Ubi est scriba? Ubi ponderator?,Ubi computator turrium? '."
,"19":"Populum impudentem non videbis, populum profundi sermonis, ininterpretabilis, linguae barbarae absque intellegentia."
,"20":"Respice Sion civitatem sollemnitatum nostrarum!,Oculi tui videbunt Ierusalem, habitationem securam, tabernaculum quod nequaquam transferri poterit; nec auferentur clavi eius in sempiternum, et omnes funiculi eius non rumpentur."
,"21":"Quia ibi potens Dominus pro nobis,loco fluviorum, rivorum late patentium; non transibit ibi navis remigum, neque navis magna transgredietur eum."
,"22":"Dominus enim iudex noster, Dominus legifer noster, Dominus rex noster: ipse salvabit nos."
,"23":"Laxati sunt funiculi tui,nec sustinent malum suum, ut dilatare velum non queant. Tunc divident caeci praedam multam; claudi diripient rapinam."
,"24":"Nec dicet incola: ' Elangui '. Populus, qui habitat in ea, auferetur ab eo iniquitas."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Accedite, gentes, ad audien dum; et populi, attendite. Audiat terra et plenitudo eius, orbis et omne germen eius."
,"2":"Quia indignatio Domini super omnes gentes, et furor super universam militiam eorum: ad interitum devovit eos et dedit eos in occisionem."
,"3":"Interfecti eorum proicientur, et de cadaveribus eorum ascendet foetor; dissolventur montes sanguine eorum."
,"4":"Et tabescet omnis militia caelorum, et complicabuntur sicut liber caeli, et omnis militia eorum defluet, sicut defluit folium de vinea et arida frons de ficu."
,"5":"Quoniam inebriatus est in caelo gladius meus: ecce super Edom descendet,et super populum interfectionis meae ad iudicium."
,"6":"Gladius Domini repletus est sanguine, incrassatus est adipe, de sanguine agnorum et hircorum, de adipe viscerum arietum; victima enim Domini in Bosra, et interfectio magna in terra Edom."
,"7":"Cadunt bubali cum eis, iuvenci cum tauris; inebriabitur terra eorum sanguine, et humus eorum adipe pinguium,"
,"8":"quia dies ultionis Domini, annus retributionum ad vindicandam Sion."
,"9":"Et convertentur torrentes eius in picem, et humus eius in sulphur, et erit terra eius in picem ardentem."
,"10":"Nocte et die non exstinguetur, in sempiternum ascendet fumus eius, a generatione in generationem desolabitur, in saecula saeculorum non erit transiens per eam."
,"11":"Et possidebunt illam onocrotalus et ericius, noctua et corvus habitabunt in ea; et extendet super eam mensuram solitudinis,et perpendiculum desolationis."
,"12":"Nobiles eius non erunt, nec regnum proclamabunt; et omnes principes eius erunt in nihilum."
,"13":"Et orientur in domibus eius spinae, urticae et paliurus in munitionibus eius; et erit cubile draconum,et pascua struthionum."
,"14":"Et occurrent hyaenae thoibus, et pilosus clamat ad amicum suum; ibi cubat lamia,et invenit sibi requiem."
,"15":"Ibi nidificat serpens ovaque deponit,et circumfodit et fovet in umbra eius; illuc congregantur milvi alter ad alterum."
,"16":"Requirite in libro Domini et legite: unum ex eis non deest, alter alterum exspectare non debet; quia os Domini praecepit, et spiritus eius ipse congregavit ea. "
,"17":"Et ipse misit eis sortem, et manus eius divisit terram illis in mensura; usque in aeternum possidebunt eam, in generatione et generatione habitabunt in ea."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Laetentur deserta et invia, et exsultet solitudo et floreat quasi lilium."
,"2":"Germinet et exsultet,laetabunda et laudans. Gloria Libani data est ei, decor Carmeli et Saron; ipsi videbunt gloriam Domini, maiestatem Dei nostri."
,"3":"Confortate manus dissolutas,et genua debilia roborate."
,"4":"Dicite pusillanimis: ' Confortamini, nolite timere!,Ecce Deus vester, ultio veniet, retributio Dei; ipse veniet et salvabit vos '."
,"5":"Tunc aperientur oculi caecorum, et aures surdorum patebunt."
,"6":"Tunc saliet sicut cervus claudus, et exsultabit lingua mutorum, quia erumpent in deserto aquae, et torrentes in solitudine."
,"7":"Et terra arida erit in stagnum, et sitiens in fontes aquarum; in cubilibus, in quibus dracones habitabant, erit locus calami et iunci."
,"8":"Et erit ibi semita et via; et via sancta vocabitur: non transibit per eam pollutus; et erit eis directa via, ita ut stulti non errent per eam."
,"9":"Non erit ibi leo, et rapax bestia non ascendet per eam,nec invenietur ibi; et ambulabunt, qui liberati fuerint,"
,"10":"et redempti a Domino revertentur. Et venient in Sion cum laude, et laetitia sempiterna super caput eorum: gaudium et laetitiam obtinebunt, et fugiet maeror et gemitus."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Et factum est in quarto deci mo anno regis Ezechiae, ascendit Sennacherib rex Assyriorum super omnes civitates Iudae munitas et cepit eas."
,"2":"Et misit rex Assyriorum Rabsacen de Lachis in Ierusalem ad regem Ezechiam in manu gravi, et stetit in aquaeductu piscinae superioris in via agri fullonis."
,"3":"Et egressus est ad eum Eliachim filius Helciae, qui erat super domum, et Sobna scriba et Ioah filius Asaph a commentariis."
,"4":"Et dixit ad eos Rabsaces: ' Dicite Ezechiae: Haec dicit rex magnus, rex Assyriorum: Quae est ista fiducia, qua confidis?"
,"5":"Dixisti: ' Verbum labiorum est consilium et fortitudo ad bellum'. Nunc super quem habes fiduciam, quia recessisti a me?"
,"6":"Ecce confidis super baculum arundineum confractum istum, super Aegyptum; cui si innixus fuerit homo, intrabit in manum eius et perforabit eam: sic pharao rex Aegypti omnibus, qui confidunt in eo."
,"7":"Quod si responderis mihi: 'In Domino Deo nostro confidimus'; nonne ipse est, cuius abstulit Ezechias excelsa et altaria et dixit Iudae et Ierusalem: 'Coram altari isto adorabitis'?"
,"8":"Et nunc sponde domino meo regi Assyriorum, et dabo tibi duo milia equorum, si poteris ex te praebere ascensores eorum."
,"9":"Et quomodo averteris faciem unius ex servis domini mei minoribus? Et tamen confidis in Aegypto, in quadriga et in equitibus;"
,"10":"et nunc, numquid sine Domino ascendi ad terram istam, ut disperderem eam? Dominus dixit ad me: 'Ascende super terram istam et disperde eam' '."
,"11":"Et dixit Eliachim et Sobna et Ioah ad Rabsacen: 'Loquere ad servos tuos Aramaice; intellegimus enim. Ne loquaris ad nos Iudaice in auribus populi, qui est super murum '."
,"12":"Et dixit Rabsaces: ' Numquid ad dominum tuum et ad te misit me dominus meus, ut loquerer omnia verba ista? Et non potius ad viros, qui sedent in muro, ut comedant stercora sua et bibant urinam suam vobiscum? '."
,"13":"Et stetit Rabsaces et clamavit voce magna Iudaice et dixit: ' Audite verba regis magni, regis Assyriorum:"
,"14":"Haec dicit rex: Non seducat vos Ezechias, quia non poterit eruere vos."
,"15":"Et non vobis tribuat fiduciam Ezechias super Domino dicens: 'Eruens liberabit nos Dominus; non dabitur civitas ista in manu regis Assyriorum'."
,"16":"Nolite audire Ezechiam. Haec enim dicit rex Assyriorum: Facite mecum benedictionem et egredimini ad me; et comedite unusquisque vineam suam et unusquisque ficum suam, et bibite unusquisque aquam de cisterna sua,"
,"17":"donec veniam et tollam vos ad terram, quae est ut terra vestra, terram frumenti et vini, terram panis et vinearum."
,"18":"Ne illudat vos Ezechias dicens: 'Dominus liberabit nos'. Numquid liberaverunt dii gentium unusquisque terram suam de manu regis Assyriorum?"
,"19":"Ubi sunt dii Emath et Arphad? Ubi sunt dii Sepharvaim? Numquid liberaverunt Samariam de manu mea?"
,"20":"Quinam ex omnibus diis terrarum istarum eruerunt terram suam de manu mea? Numquid eruet Dominus Ierusalem de manu mea? '."
,"21":"Et siluerunt et non responderunt ei verbum; mandaverat enim rex dicens: ' Ne respondeatis ei '."
,"22":"Et ingressus est Eliachim filius Helciae, qui erat super domum, et Sobna scriba et Ioah filius Asaph a commentariis ad Ezechiam scissis vestibus; et nuntiaverunt ei verba Rabsacis."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Et factum est cum audisset rex Ezechias, scidit vestimen ta sua et obvolutus est sacco et intravit in domum Domini;"
,"2":"et misit Eliachim, qui erat super domum, et Sobnam scribam et seniores de sacerdotibus opertos saccis ad Isaiam filium Amos prophetam,"
,"3":"et dixerunt ad eum: ' Haec dicit Ezechias: Dies tribulationis et correptionis et contumeliae dies haec, quia venerunt filii usque ad partum, et virtus non est pariendi."
,"4":"Forsitan audiet Dominus Deus tuus verba Rabsacis, quem misit rex Assyriorum, dominus suus, ad blasphemandum Deum viventem, et puniet sermones, quos audivit Dominus Deus tuus; leva ergo orationem pro reliquiis, quae repertae sunt '."
,"5":"Et venerunt servi regis Ezechiae ad Isaiam;"
,"6":"et dixit ad eos Isaias: 'Haec dicetis domino vestro: Haec dicit Dominus: Ne timeas a facie verborum, quae audisti, quibus blasphemaverunt pueri regis Assyriorum me."
,"7":"Ecce ego dabo ei spiritum, et audiet nuntium et revertetur ad terram suam, et corruere eum faciam gladio in terra sua '."
,"8":"Reversus est autem Rabsaces et invenit regem Assyriorum proeliantem adversus Lobnam; audierat enim quia profectus esset de Lachis."
,"9":"Et audivit de Tharaca rege Aethiopiae dicentes: ' Egressus est, ut pugnet contra te '. Quod cum audisset, misit nuntios ad Ezechiam dicens: "
,"10":"' Haec dicetis Ezechiae regi Iudae loquentes: Non te decipiat Deus tuus, in quo tu confidis, dicens: 'Non dabitur Ierusalem in manu regis Assyriorum'."
,"11":"Ecce tu audisti omnia, quae fecerunt reges Assyriorum omnibus terris, quas ad interitum devoverunt, et tu poteris liberari?"
,"12":"Numquid eruerunt eos dii gentium, quos subverterunt patres mei, Gozan et Charran et Reseph et filios Eden, qui erant in Thelassar?"
,"13":"Ubi est rex Emath et rex Arphad et rex urbis Sepharvaim, Ana et Ava? '."
,"14":"Et tulit Ezechias epistulam de manu nuntiorum et legit eam. Et ascendit in domum Domini et expandit eam Ezechias coram Domino."
,"15":"Et oravit Ezechias ad Dominum dicens:"
,"16":"' Domine exercituum, Deus Israel, qui sedes super cherubim, tu es Deus solus omnium regnorum terrae, tu fecisti caelum et terram."
,"17":"Inclina, Domine, aurem tuam et audi; aperi, Domine, oculos tuos et vide et audi omnia verba Sennacherib, quae misit ad blasphemandum Deum viventem."
,"18":"Vere enim, Domine, dissipaverunt reges Assyriorum gentes et regiones earum"
,"19":"et dederunt deos earum igni: non enim erant dii, sed opera manuum hominum, lignum et lapis; et comminuerunt eos."
,"20":"Et nunc, Domine Deus noster, salva nos de manu eius; et cognoscant omnia regna terrae quia tu, Domine, es solus Deus '."
,"21":"Et misit Isaias filius Amos ad Ezechiam dicens: ' Haec dicit Dominus, Deus Israel: Pro quibus rogasti me de Sennacherib rege Assyriorum,"
,"22":"hoc est verbum, quod locutus est Dominus super eum: Despexit te, subsannavit te virgo filia Sion; post te caput movit filia Ierusalem."
,"23":"Cui exprobrasti et quem blasphemasti?,Et super quem exaltasti vocem,et levasti altitudinem oculorum tuorum?,Contra Sanctum Israel!"
,"24":"In manu servorum tuorum exprobrasti Domino,et dixisti: 'In multitudine quadrigarum mearum,ego ascendi altitudinem montium, iuga Libani; et succidi excelsa cedrorum eius,et electas abietes illius,et introivi altitudinem summitatis eius, silvam condensam."
,"25":"Ego fodi et bibi aquam alienam,et exsiccavi vestigio pedis mei,omnes rivos Aegypti'."
,"26":"Numquid non audisti?,A saeculo feci illud; a diebus antiquis,ego plasmavi illud et nunc adduxi, ut fiat in eradicationem, in lapides eversos civitates munitae."
,"27":"Habitatores earum breviata manu,contremuerunt et confusi sunt; facti sunt sicut fenum agri,et gramen viride et herba tectorum, quae exaruit a facie austri."
,"28":"Sessionem tuam,et egressum tuum et introitum tuum cognovi,et insaniam tuam contra me."
,"29":"Cum fureris adversum me, et superbia tua ascenderit in aures meas, ponam circulum in naribus tuis,et frenum in labiis tuis,et reducam te in viam, per quam venisti."
,"30":"Tibi autem hoc erit signum: Comedantur hoc anno, quae colligi poterunt, et in anno secundo, quae sponte nascuntur; in anno autem tertio seminate et metite,et plantate vineas et comedite fructum earum."
,"31":"Et mittet id, quod salvatum fuerit de domo Iudae, quod reliquum est, radicem deorsum,et faciet fructum sursum."
,"32":"Quia de Ierusalem exibit residuum, et, quod salvum fuerit, de monte Sion. Zelus Domini exercituum faciet istud."
,"33":"Propterea haec dicit Dominus de rege Assyriorum: Non introibit civitatem hanc,et non iaciet ibi sagittam,et non opponet ei clipeum,et non mittet contra eam aggerem."
,"34":"In via, qua venit, per eam revertetur, et civitatem hanc non ingredietur, dicit Dominus."
,"35":"Et protegam civitatem istam, ut salvem eam,propter me et propter David servum meum '."
,"36":"Egressus est autem angelus Domini et percussit in castris Assyriorum centum octoginta quinque milia; et surrexerunt mane, et ecce omnes illi cadavera mortuorum."
,"37":"Et egressus est et abiit; et reversus est Sennacherib rex Assyriorum et habitavit in Nineve."
,"38":"Et factum est, cum adoraret in templo Nesroch dei sui, Adramelech et Sarasar filii eius percusserunt eum gladio fugeruntque in terram Ararat. Et regnavit Asarhaddon filius eius pro eo."
}`)
	CurrentBook.AddChapter(38, `{
"1":"In diebus illis aegrotavit Ezechias usque ad mortem. Et introivit ad eum Isaias filius Amos propheta et dixit ei: ' Haec dicit Dominus: Dispone domui tuae, quia morieris tu et non vives'."
,"2":"Et convertit Ezechias faciem suam ad parietem et oravit ad Dominum"
,"3":"et dixit: ' Obsecro, Domine; memento, quaeso, quomodo ambulaverim coram te in veritate et in corde perfecto et, quod bonum est in oculis tuis, fecerim '. Et flevit Ezechias fletu magno."
,"4":"Et factum est verbum Domini ad Isaiam dicens:"
,"5":"' Vade et dic Ezechiae: 'Haec dicit Dominus, Deus David patris tui: Audivi orationem tuam, vidi lacrimas tuas; ecce ego adiciam super dies tuos quindecim annos"
,"6":"et de manu regis Assyriorum eruam te et civitatem istam et protegam hanc civitatem'."
,"7":"Hoc autem tibi erit signum a Domino quia faciet Dominus verbum hoc, quod locutus est:"
,"8":"Ecce ego reverti faciam umbram graduum, per quos descenderat in horologio Achaz in sole retrorsum decem gradibus '. Et reversus est sol decem gradibus per gradus, quos descenderat."
,"9":"Scriptura Ezechiae regis Iudae, cum aegrotasset et convaluisset de infirmitate sua:"
,"10":"' Ego dixi: In dimidio dierum meorum,vadam ad portas inferi; quaesivi residuum annorum meorum."
,"11":"Dixi: Non videbo Dominum Deum in terra viventium, non aspiciam hominem ultra,inter habitatores orbis."
,"12":"Habitaculum meum ablatum est et abductum longe a me,quasi tabernaculum pastorum; convolvit sicut textor vitam meam; de stamine succidit me. De mane usque ad vesperam confecisti me."
,"13":"Prostratus sum usque ad mane, quasi leo sic conterit omnia ossa mea; de mane usque ad vesperam confecisti me."
,"14":"Sicut pullus hirundinis, sic mussitabo, meditabor ut columba; attenuati sunt oculi mei,suspicientes in excelsum. Domine, vim patior, sponde pro me."
,"15":"Quid dicam, aut quid respondebit mihi?,Ipse fecit!,Incedam per omnes annos meos,in amaritudine animae meae."
,"16":"Domine, in te sperat cor meum; vivat spiritus meus, sana me et vivifica me;"
,"17":"ecce in pacem versa est amaritudo mea. Tu autem eruisti animam meam,a fovea consumptionis, proiecisti enim post tergum tuum,omnia peccata mea."
,"18":"Quia non infernus confitebitur tibi, neque mors laudabit te; non exspectabunt, qui descendunt in lacum, veritatem tuam."
,"19":"Vivens, vivens ipse confitebitur tibi, sicut et ego hodie; pater filiis notam faciet veritatem tuam."
,"20":"Domine, salvum me fac, et ad sonum citharae cantabimus,cunctis diebus vitae nostrae,in domo Domini '."
,"21":"Et iussit Isaias, ut tollerent massam de ficis et cataplasmarent super vulnus, et sanaretur."
,"22":"Et dixit Ezechias: ' Quod erit signum quia ascendam in domum Domini?'."
}`)
	CurrentBook.AddChapter(39, `{
"1":"In tempore illo misit Merodachbaladan filius Baladan rex Babylonis litteras et munera ad Ezechiam; audierat enim quod aegrotasset et convaluisset."
,"2":"Laetatus est autem super eis Ezechias et ostendit eis cellam thesauri sui et argentum et aurum et aromata et oleum optimum et omnes apothecas supellectilis suae et universa, quae inventa sunt in thesauris eius. Nihil fuit, quod non ostenderet eis Ezechias in domo sua et in omni potestate sua."
,"3":"Introivit autem Isaias propheta ad Ezechiam regem et dixit ei: ' Quid dixerunt viri isti et unde venerunt ad te? '. Et dixit Ezechias: ' De terra longinqua venerunt ad me, de Babylone '."
,"4":"Et dixit: 'Quid viderunt in domo tua?'. Et dixit Ezechias: ' Omnia, quae in domo mea sunt, viderunt; non fuit res, quam non ostenderim eis in thesauris meis '."
,"5":"Et dixit Isaias ad Ezechiam: ' Audi verbum Domini exercituum:"
,"6":"Ecce dies venient, et auferentur omnia, quae in domo tua sunt, et quae thesaurizaverunt patres tui usque ad diem hanc, in Babylonem; non relinquetur quidquam, dicit Dominus."
,"7":"Et de filiis tuis, qui exibunt de te, quos genueris, tollent, et erunt eunuchi in palatio regis Babylonis '."
,"8":"Et dixit Ezechias ad Isaiam: ' Bonum verbum Domini, quod locutus est '. Et dixit: ' Dummodo fiat pax et securitas in diebus meis '."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Consolamini, consolamini populum meum, dicit Deus vester."
,"2":"Loquimini ad cor Ierusalem,et clamate ad eam, quoniam completa est militia eius, expiata est iniquitas illius; suscepit de manu Domini,duplicia pro omnibus peccatis suis."
,"3":"Vox clamantis: ' In deserto parate viam Domini, rectas facite in solitudine,semitas Dei nostri."
,"4":"Omnis vallis exaltetur, et omnis mons et collis humilietur; et fiant prava in directa, et aspera in plana:"
,"5":"et revelabitur gloria Domini, et videbit omnis caro pariter,quod os Domini locutum est '."
,"6":"Vox dicentis: ' Clama! '. Et dixi: ' Quid clamabo? '. Omnis caro fenum, et omnis gloria eius quasi flos agri;"
,"7":"exsiccatum est fenum, et cecidit flos, quia spiritus Domini sufflavit in eo. Vere fenum est populus."
,"8":"Exsiccatum est fenum, et cecidit flos; verbum autem Dei nostri manet in aeternum."
,"9":"Super montem excelsum ascende, tu, quae evangelizas Sion; exalta in fortitudine vocem tuam, quae evangelizas Ierusalem; exalta, noli timere; dic civitatibus Iudae: ' Ecce Deus vester,"
,"10":"ecce Dominus Deus in virtute venit, et brachium eius dominatur: ecce merces eius cum eo, et praemium illius coram illo."
,"11":"Sicut pastor gregem suum pascit, in brachio suo congregat agnos,et in sinu suo levat; fetas ipse portat '."
,"12":"Quis mensus est pugillo aquas,et caelos palmo disposuit, modio continuit pulverem terrae,et libravit in pondere montes,et colles in statera?"
,"13":"Quis direxit spiritum Domini?,Aut quis consilium suum,ostendit illi?"
,"14":"Cum quo iniit consilium, et instruxit eum,et docuit eum semitam iustitiae,et erudivit eum scientiam,et viam prudentiae ostendit illi?"
,"15":"Ecce gentes quasi stilla situlae,et quasi momentum pulveris in statera reputantur; ecce insulae quasi pulvis exiguus."
,"16":"Et Libanus non sufficiet ad succendendum, et animalia eius non sufficient ad holocaustum."
,"17":"Omnes gentes, quasi non sint, coram eo; quasi nihilum et inane reputantur ab eo."
,"18":"Cui ergo similem facitis Deum?,Aut quam imaginem ponitis ei?"
,"19":"Sculptile conflat faber, et aurifex auro figurat illud, et laminis argenteis argentarius."
,"20":"Nimis pauper, ut offerat lignum imputribile: exquirit sibi sapientem artificem, ut statuat simulacrum, quod non moveatur."
,"21":"Numquid non scitis? Numquid non audistis?,Numquid non annuntiatum est vobis ab initio?,Numquid non intellexistis fundamenta terrae?"
,"22":"Qui sedet super gyrum terrae, et habitatores eius sunt quasi locustae; qui extendit sicut velum caelos,et expandit eos sicut tabernaculum ad inhabitandum;"
,"23":"qui redigit in nihilum principes, iudices terrae velut inane facit."
,"24":"Et quidem neque plantatus neque satus,neque radicatus in terra truncus eorum; repente flavit in eos, et aruerunt, et turbo quasi stipulam aufert eos."
,"25":"' Et cui assimilabitis me, quasi aequalis ei sim ego? ', dicit Sanctus."
,"26":"Levate in excelsum oculos vestros,et videte: Quis creavit haec?,Qui educit in numero militiam eorum,et omnes ex nomine vocat; prae multitudine fortitudinis et roboris virtutisque eius,neque unum deest."
,"27":"Quare dicis, Iacob, et loqueris, Israel: ' Abscondita est via mea a Domino, et a Deo meo iudicium meum transit? '."
,"28":"Numquid nescis? Aut non audisti?,Deus sempiternus Dominus, qui creavit terminos terrae; non deficiet neque laborabit, nec est investigatio sapientiae eius. "
,"29":"Qui dat lasso virtutem,et invalido robur multiplicat."
,"30":"Deficient pueri et laborabunt, et iuvenes lapsu labentur;"
,"31":"qui autem sperant in Domino, mutabunt fortitudinem, assument pennas sicut aquilae, current et non laborabunt, ambulabunt et non deficient."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Taceant ante me insulae, et gentes renovent fortitudinem; accedant et tunc loquantur, simul ad iudicium propinquemus."
,"2":"Quis suscitavit ab oriente eum, cuius gressum sequitur iustitia?,Dabit in conspectu eius gentes,et subiciet ei reges, quos reddet quasi pulverem gladius eius, sicut stipulam vento raptam arcus eius."
,"3":"Persequetur eos, transibit in pace; semita sub pedibus eius non apparebit."
,"4":"Quis operatus est et fecit, vocans generationes ab exordio?,Ego Dominus, primus,et cum novissimis ego sum."
,"5":"Viderunt insulae et timuerunt, extrema terrae obstupuerunt, appropinquaverunt et accesserunt."
,"6":"Unusquisque proximo suo auxiliabitur,et fratri suo dicet: ' Confortare '."
,"7":"Confortabit faber aurificem, percutiens malleo eum, qui cudit, dicens de glutino: ' Bonum est '; et roborat eum clavis, ut non moveatur."
,"8":"Tu autem, Israel, serve meus, Iacob, quem elegi, semen Abraham amici mei,"
,"9":"quem apprehendi ab extremis terrae, et a longinquis eius vocavi te,et dixi tibi: ' Servus meus es tu; elegi te et non abieci te '."
,"10":"Ne timeas, quia ego tecum sum; ne declines, quia ego Deus tuus: confortabo te et auxiliabor tibi,et sustentabo te dextera iustitiae meae."
,"11":"Ecce confundentur et erubescent,omnes, qui irascuntur adversum te; erunt quasi non sint,et peribunt viri, qui contradicunt tibi."
,"12":"Quaeres eos et non invenies,viros, qui rixantur tecum; erunt quasi non sint et veluti nihilum, viri bellantes adversum te."
,"13":"Quia ego Dominus Deus tuus,apprehendens manum tuam,dicensque tibi: ' Ne timeas; ego auxiliabor tibi."
,"14":"Noli timere, vermis Iacob, homines ex Israel. Ego auxiliabor tibi ', dicit Dominus,et redemptor tuus, Sanctus Israel."
,"15":"Ecce posui te quasi plaustrum triturans novum, habens rostra serrantia. Triturabis montes et comminues,et colles quasi pulverem pones."
,"16":"Ventilabis eos, et ventus tollet eos, et turbo disperget eos; et tu exsultabis in Domino, in Sancto Israel laetaberis."
,"17":"Egeni et pauperes quaerunt aquas, et non sunt, lingua eorum siti aruit. Ego, Dominus, exaudiam eos, Deus Israel non derelinquam eos."
,"18":"Aperiam in decalvatis collibus flumina,et in medio vallium fontes; ponam desertum in stagna aquarum,et terram aridam in rivos aquarum."
,"19":"Plantabo in deserto cedrum, acaciam et myrtum et lignum olivae; ponam in solitudine abietem, ulmum et cupressum simul,"
,"20":"ut videant et sciant,et recogitent et intellegant pariter,quia manus Domini fecit hoc, et Sanctus Israel creavit illud."
,"21":"Proferte causam vestram, dicit Dominus; afferte, si quid firmum habetis, dixit Rex Iacob."
,"22":"Accedant et nuntient nobis, quaecumque ventura sunt. Priora, quae fuerunt, nuntiate, ut ponamus cor nostrum et sciamus novissima eorum; et, quae ventura sunt, indicate nobis."
,"23":"Annuntiate, quae ventura sunt in futurum, ut sciamus quia dii estis vos; bene quoque aut male facite, ut inspiciamus et videamus simul."
,"24":"Ecce vos estis nihilum, et opus vestrum nihil valet; abominatio est, qui eligit vos."
,"25":"Suscitavi ab aquilone, et venit ab ortu solis; vocavi eum nomine; et conculcabit potentes quasi lutum,et velut plastes calcans humum."
,"26":"Quis annuntiavit ab exordio, ut sciamus, et a principio, ut dicamus: ' Iustum est '?,Non est neque annuntians neque praedicens,neque audiens sermones vestros."
,"27":"Primus ad Sion: Ecce adsunt; et Ierusalem laeta nuntiantem do."
,"28":"Et vidi, et nemo erat, ex istis nullus consiliator, ut, si eos interrogarem, responderent verbum."
,"29":"Ecce omnes iniquitas, vana opera eorum; ventus et inane,simulacra eorum."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Ecce servus meus, suscipiam eum; electus meus, complacet sibi in illo anima mea; dedi spiritum meum super eum, iudicium gentibus proferet."
,"2":"Non clamabit neque vociferabitur, nec audietur vox eius foris."
,"3":"Calamum quassatum non conteret,et linum fumigans non exstinguet; in veritatem proferet iudicium."
,"4":"Non languebit nec frangetur, donec ponat in terra iudicium; et legem eius insulae exspectant."
,"5":"Haec dicit Dominus Deus, creans caelos et extendens eos, firmans terram et quae germinant ex ea, dans flatum populo, qui est super eam, et spiritum calcantibus eam:"
,"6":"' Ego, Dominus, vocavi te in iustitia,et apprehendi manum tuam; et formavi te et dedi te,in foedus populi, in lucem gentium,"
,"7":"ut aperires oculos caecorum,et educeres de conclusione vinctum, de domo carceris sedentes in tenebris."
,"8":"Ego Dominus: hoc est nomen meum; et gloriam meam alteri non dabo,et laudem meam sculptilibus."
,"9":"Quae prima fuerunt, ecce venerunt; nova quoque ego annuntio: antequam oriantur, audita vobis faciam '."
,"10":"Cantate Domino canticum novum, laus eius ab extremis terrae; qui descenditis in mare, et plenitudo eius, insulae et habitatores earum."
,"11":"Exsultent desertum et civitates eius, vici, quos habitat Cedar. Iubilent habitatores Petrae, de vertice montium clament."
,"12":"Ponant Domino gloriam,et laudem eius in insulis nuntient."
,"13":"Dominus sicut fortis egredietur, sicut vir proeliator suscitabit zelum; vociferabitur et conclamabit, super inimicos suos praevalebit."
,"14":"' Tacui semper, silui, patiens fui; sicut parturiens ululabo, gemam et fremam simul."
,"15":"Desertos faciam montes et colles,et omne gramen eorum exsiccabo; et ponam flumina in insulas,et stagna arefaciam."
,"16":"Et ducam caecos in viam, quam nesciunt, et in semitis, quas ignoraverunt, ambulare eos faciam; ponam tenebras coram eis in lucem,et prava in recta. Haec verba faciam eis,et non dereliquam eos '."
,"17":"Conversi sunt retrorsum; confundantur confusione, qui confidunt in sculptili, qui dicunt conflatili: ' Vos dii nostri '."
,"18":"Surdi, audite; et caeci, intuemini ad videndum."
,"19":"Quis caecus sicut servus meus, et surdus sicut nuntius, quem ego mittam?,Quis caecus sicut qui restitutus est?,Et quis caecus sicut servus Domini?"
,"20":"Multa vidisti, sed non servas; aures aperuisti, sed non audis."
,"21":"Dominus voluit propter iustitiam suam,magnificare legem et extollere."
,"22":"Ipse autem populus direptus et vastatus; in foveis conclusi omnes, et in domibus carcerum absconditi sunt. Facti sunt in rapinam, nec est qui eruat; in direptionem, nec est qui dicat: ' Redde! '."
,"23":"Quis est in vobis, qui audiat hoc, attendat et auscultet futura?"
,"24":"Quis dedit in direptionem Iacob,et Israel vastantibus?,Nonne Dominus ipse, cui peccavimus?,Et noluerunt in viis eius ambulare,et non audierunt legem eius."
,"25":"Et effudit super eum indignationem furoris sui,et forte bellum. Et combussit eum in circuitu, et non cognovit; et succendit eum, et non intellexit."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Et nunc haec dicit Dominus, qui creavit te, Iacob, et formavit te, Israel: ' Noli timere, quia redemi te,et vocavi te nomine tuo; meus es tu."
,"2":"Cum transieris per aquas, tecum ero, et flumina non operient te; cum ambulaveris in igne, non combureris, et flamma non ardebit in te,"
,"3":"quia ego Dominus Deus tuus, Sanctus Israel, salvator tuus: dedi propitiationem tuam Aegyptum, Aethiopiam et Saba pro te."
,"4":"Quoniam pretiosus factus es in oculis meis,et gloriosus, ego diligo te,et dabo homines pro te,et populos pro anima tua."
,"5":"Noli timere, quoniam ego tecum sum: ab oriente adducam semen tuum,et ab occidente congregabo te."
,"6":"Dicam aquiloni: 'Da',et austro: 'Noli prohibere; affer filios meos de longinquo,et filias meas ab extremis terrae."
,"7":"Omnem, qui vocatur nomine meo, in gloriam meam creavi eum, formavi eum et feci eum'."
,"8":"Educ foras populum caecum, et oculos habentem, surdos, et aures eis sunt."
,"9":"Omnes gentes congregentur simul, et colligantur nationes: quis in eis annuntiabit istud,et priora audire nos faciet?,Dent testes suos et iustificentur,et audiant et dicant: 'Vere'."
,"10":"Vos testes mei, dicit Dominus, et servus meus, quem elegi, ut sciatis et credatis mihi,et intellegatis quia ego ipse sum; ante me non est formatus Deus,et post me non erit."
,"11":"Ego, ego sum Dominus, et non est absque me salvator."
,"12":"Ego, annuntiavi et salvavi; auditum feci, et non fuit in vobis alienus; et vos testes mei, dicit Dominus, et ego Deus,"
,"13":"iam ab initio ego ipse. Et non est qui de manu mea eruat; operabor, et quis avertet illud? '. "
,"14":"Haec dicit Dominus, redemptor vester, Sanctus Israel: ' Propter vos misi in Babylonem,et detraxi fugitivos universos,et Chaldaeos in navibus suis gloriantes."
,"15":"Ego Dominus, Sanctus vester, creans Israel, rex vester '."
,"16":"Haec dicit Dominus, qui dedit in mari viam,et in aquis torrentibus semitam;"
,"17":"qui eduxit quadrigam et equum, agmen et robustum; simul iacuerunt nec resurgent, contriti sunt quasi linum et exstincti sunt."
,"18":"' Ne memineritis priorum,et antiqua ne intueamini:"
,"19":"ecce ego facio nova, et nunc orientur: nonne cognoscitis ea?,Utique ponam in deserto viam,et in invio flumina."
,"20":"Glorificabit me bestia agri, dracones et struthiones, quia dedi in deserto aquas, flumina in invio, ut darem potum populo meo, electo meo."
,"21":"Populum istum formavi mihi; laudem meam narrabunt."
,"22":"Non me invocasti, Iacob; immo taedio mei affectus es, Israel."
,"23":"Non obtulisti mihi agnos holocausti tui,et victimis tuis non glorificasti me; non te gravavi in oblatione,nec laborem tibi praebui in ture."
,"24":"Non emisti mihi argento calamum,et adipe victimarum tuarum non inebriasti me; verumtamen servire me fecisti in peccatis tuis, praebuisti mihi laborem in iniquitatibus tuis."
,"25":"Ego, ego sum ipse, qui deleo iniquitates tuas propter me,et peccatorum tuorum non recordabor."
,"26":"Memorem me redde, iudicium agamus simul: narra, ut iustificeris."
,"27":"Pater tuus primus peccavit, et interpretes tui praevaricati sunt in me;"
,"28":"et contaminavi principes sanctuarii, dedi ad internecionem Iacob,et Israel in opprobrium '."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Et nunc audi, Iacob serve meus, et Israel, quem elegi."
,"2":"Haec dicit Dominus, qui fecit te,et formavit te ab utero, auxiliator tuus: ' Noli timere, serve meus Iacob, et dilecte, quem elegi."
,"3":"Effundam enim aquas super terram sitientem,et fluenta super aridam; effundam spiritum meum super semen tuum,et benedictionem meam super stirpem tuam:"
,"4":"et germinabunt inter herbas,quasi salices iuxta praeterfluentes aquas."
,"5":"Iste dicet: 'Domini ego sum', et ille vocabit se nomine Iacob; et hic scribet manu sua: 'Domino', et inscribetur nomine Israel '."
,"6":"Haec dicit Dominus, rex Israel,et redemptor eius, Dominus exercituum: ' Ego primus et ego novissimus, et absque me non est Deus."
,"7":"Quis similis mei? Conclamet et annuntiet,et exponat mihi, ex quo constitui populum antiquum; ventura et, quae futura sunt, annuntiet nobis."
,"8":"Nolite timere neque conturbemini; nonne ex tunc audire te feci et annuntiavi?,Vos estis testes mei. Numquid est Deus absque me,aut Petra, quam ego non noverim? '."
,"9":"Plastae idoli omnes nihil sunt, et pretiosa eorum non proderunt eis; testes eorum non vident neque intellegunt, ut confundantur."
,"10":"Quis formavit deum et sculptile conflavit lucrum non quaerens?"
,"11":"Ecce omnes participes eius confundentur; fabri enim sunt ex hominibus: conveniant omnes, stent; pavebunt, confundentur simul."
,"12":"Faber ferrarius securim operatur in prunis et in malleis format illam et polit eam in brachio fortitudinis suae; esurit et deficit, non bibit aquam et lassescit."
,"13":"Artifex lignarius extendit normam, describit illud stilo, operatur illud scalpellis et circino describit illud quasi imaginem viri, quasi speciosum hominem, qui resideat in domo."
,"14":"Succidit sibi cedros et arripit ilicem et quercum, quae steterat inter ligna saltus; plantavit pinum, quam pluvia nutrivit."
,"15":"Homini facta sunt ad comburendum; sumit ex eis, ut calefaciat, et succendit et coquit panes. De reliquo autem operatur deum et adorat; facit sculptile et curvatur ante illud."
,"16":"Medium eius comburit igne et medio eius carnes assat, manducat assaturam et saturatur et calefit et dicit: ' Vah, calefactus sum, vidi focum '."
,"17":"Reliquum autem eius deum fecit, sculptile sibi; curvatur ante illud et adorat illud et obsecrat dicens: ' Libera me, quia deus meus es tu '."
,"18":"Nescierunt neque intellexerunt; nam clausit oculos eorum, ne videant et ne intellegant corde suo."
,"19":"Non recogitant in corde suo, scientia et intellegentia carent, ut dicant: ' Medietatem eius combussi igne et coxi super carbones eius panes, coxi carnes et comedi et de reliquo eius abominationem faciam; ante truncum ligni procidam? '."
,"20":"Cinere vescitur; cor insipiens decepit eum, et non liberabit animam suam neque dicet: ' Nonne mendacium est in dextera mea? '."
,"21":"Memento horum, Iacob, et Israel, quoniam servus meus es tu; formavi te, servus meus es tu, Israel, non decipies me."
,"22":"Delevi ut nubem iniquitates tuas,et quasi nebulam peccata tua; revertere ad me, quoniam redemi te."
,"23":"Exsultate, caeli, quoniam hoc fecit Dominus; iubilate, fundamenta terrae, resonate, montes, laudationem, saltus et omne lignum eius, quoniam redemit Dominus Iacob,et in Israel glorificabitur."
,"24":"Haec dicit Dominus, redemptor tuus et formator tuus ex utero: ' Ego sum Dominus, qui feci omnia, extendi caelos solus, expandi terram; et quis mecum?"
,"25":"Qui irrita facio signa divinorum,et hariolos stultos reddo; compello sapientes retrorsum,et scientiam eorum vanam facio;"
,"26":"qui suscito verbum servi mei,et consilium nuntiorum meorum compleo. Qui dico Ierusalem: 'Habitaberis' et civitatibus Iudae: 'Aedificabimini',et deserta eius suscitabo;"
,"27":"qui dico profundo: 'Desolare, et flumina tua arefaciam';"
,"28":"qui dico de Cyro: 'Pastor meus est,et omnem voluntatem meam complebit'; qui dico Ierusalem: 'Aedificaberis', et templo: 'Fundaberis' '."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Haec dicit Dominus de uncto suo Cyro: ' Apprehendi dexteram eius, ut subiciam ante faciem eius gentes,et dorsa regum vertam,et aperiam coram eo ianuas; et portae non claudentur."
,"2":"Ego ante te ibo,et montes humiliabo; portas aereas conteram,et vectes ferreos confringam."
,"3":"Et dabo tibi thesauros absconditos,et divitias occultas, ut scias quia ego Dominus, qui vocavi te nomine tuo, Deus Israel."
,"4":"Propter servum meum Iacob,et Israel electum meum, et vocavi te nomine tuo; designavi te, et non cognovisti me."
,"5":"Ego Dominus, et non est amplius: extra me non est Deus. Accinxi te, et non cognovisti me,"
,"6":"ut sciant ab ortu solis et ab occidente,quoniam absque me nullus est. Ego Dominus, et non est alter,"
,"7":"formans lucem et creans tenebras, faciens pacem et creans malum: ego Dominus faciens omnia haec."
,"8":"Rorate, caeli, desuper, et nubes pluant iustitiam; aperiatur terra,et germinet salvationem; et iustitia oriatur simul: ego Dominus creavi eam '."
,"9":"Vae, qui contradicit fictori suo, testa de vasis fictilibus terrae!,Numquid dicet lutum figulo suo: ' Quid facis? ',et ' Opus tuum absque manibus est '?"
,"10":"Vae, qui dicit patri: ' Quid generas? ',et mulieri: ' Quid parturis? '."
,"11":"Haec dicit Dominus, Sanctus Israel, plastes eius: ' Numquid ventura interrogatis me super filios meos,et super opus manuum mearum mandatis mihi?"
,"12":"Ego feci terram,et hominem super eam creavi ego; manus meae tetenderunt caelos, et omni militiae eorum mandavi."
,"13":"Ego suscitavi eum in iustitia,et omnes vias eius dirigam; ipse aedificabit civitatem meam,et captivitatem meam dimittet,non in pretio neque in muneribus ', dicit Dominus exercituum."
,"14":"Haec dicit Dominus: ' Labor Aegypti et negotiatio Aethiopiae,et Sabaim viri sublimes,ad te transibunt et tui erunt; post te ambulabunt, vincti manicis pergent et te adorabunt,teque deprecabuntur: 'Tantum in te est Deus, et non est absque te Deus!'."
,"15":"Vere tu es Deus absconditus, Deus Israel, salvator."
,"16":"Confusi sunt et erubuerunt omnes, simul abierunt in confusionem fabricatores idolorum."
,"17":"Israel salvatus est in Domino salute aeterna; non confundemini et non erubescetis,usque in saeculum saeculi."
,"18":"Quia haec dicit Dominus, qui creavit caelos, ipse Deus, qui formavit terram et fecit eam, ipse fundavit eam; non ut vacua esset, creavit eam, ut habitaretur, formavit eam: ' Ego Dominus, et non est alius."
,"19":"Non in abscondito locutus sum, in loco terrae tenebroso; non dixi semini Iacob: 'Frustra quaerite me'. Ego Dominus loquens iustitiam, annuntians recta."
,"20":"Congregamini et venite et accedite simul, qui salvati estis ex gentibus. Nescierunt, qui levant lignum sculpturae suae,et rogant deum non salvantem."
,"21":"Annuntiate et venite et consiliamini simul. Quis auditum fecit hoc ab initio, ex tunc praedixit illud?,Numquid non ego Dominus, et non est ultra Deus absque me?,Deus iustus et salvans non est praeter me."
,"22":"Convertimini ad me et salvi eritis, omnes fines terrae, quia ego Deus, et non est alius."
,"23":"In memetipso iuravi: Egressa est de ore meo iustitia, verbum, quod non revertetur; quia mihi curvabitur omne genu, et iurabit omnis lingua '."
,"24":"' Tantum in Domino ' dicent,' sunt iustitiae et robur! '. Ad eum venient et confundentur,omnes, qui repugnant ei;"
,"25":"in Domino iustificabitur et laudabitur,omne semen Israel."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Concidit Bel, incurvavit se Nabo; fuerunt simulacra eorum bestiis et iumentis. Statuae vestrae portantur, onera lassis."
,"2":"Se incurvaverunt et conciderunt simul; non potuerunt salvare onus,et ipsi in captivitatem ibunt."
,"3":"Audite me, domus Iacob,et omne residuum domus Israel, qui portamini ab utero, qui gestamini a vulva."
,"4":"Usque ad senectam ego ipse,et usque ad canos ego portabo; et ego feci et ego feram, ego portabo et salvabo."
,"5":"Cui assimilatis me et adaequatis,et comparatis me, et erimus similes?"
,"6":"Qui effundunt aurum de sacculo,et argentum statera ponderant, conducunt aurificem, ut faciat deum, et procidunt et adorant."
,"7":"Portant illum in umeris gestantes,et ponentes in loco suo; et stabit ac de loco suo non movebitur; sed et si quis clamat ad eum, non respondet; de tribulatione eius non salvabit eum."
,"8":"Mementote istud et confundamini; redite, praevaricatores, ad cor."
,"9":"Recordamini prioris saeculi, quoniam ego sum Deus, et non est ultra Deus, nec est similis mei."
,"10":"Annuntians ab exordio novissimum,et ab initio, quae necdum facta sunt, dicens: ' Consilium meum stabit, et omnem voluntatem meam faciam '."
,"11":"Vocans ab oriente avem rapacem,et de terra longinqua virum consilii mei; et locutus sum et adducam illud, decrevi et faciam illud."
,"12":"Audite me, duri corde, qui longe estis a iustitia."
,"13":"Prope feci iustitiam meam, non elongabitur; et salus mea non morabitur: et dabo in Sion salutem,et Israeli gloriam meam."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Descende, sede in pulvere, virgo filia Babylon; sede in terra sine solio, filia Chaldaeorum, quia ultra non vocaberis,mollis et tenera."
,"2":"Tolle molam et mole farinam; depone velum tuum, subleva stolam, revela crura, transi flumina."
,"3":"Revelabitur ignominia tua, et videbitur opprobrium tuum. ' Ultionem capiam, nemini parcam ',"
,"4":"dicit Redemptor noster, Dominus exercituum nomen illius, Sanctus Israel."
,"5":"Sede tacens et intra in tenebras, filia Chaldaeorum, quia non vocaberis ultra,Domina regnorum."
,"6":"Iratus sum super populum meum, contaminavi hereditatem meam,et dedi eos in manu tua; non posuisti eis misericordias, super senem aggravasti iugum tuum valde"
,"7":"et dixisti: ' In sempiternum ero domina '. Non posuisti haec super cor tuum,neque recordata es novissimi tui."
,"8":"Et nunc audi haec, delicata, quae habitas confidenter,et dicis in corde tuo: ' Ego, et praeter me non est altera, non sedebo vidua et orbitatem ignorabo '."
,"9":"Venient tibi duo haec,subito in die una, orbitas et viduitas; repente venerunt super te,propter multitudinem maleficiorum tuorum, propter abundantiam incantationum tuarum."
,"10":"Et fiduciam habuisti in malitia tua,et dixisti: ' Non est qui videat me '. Sapientia tua et scientia tua, haec decepit te. Et dixisti in corde tuo: ' Ego, et praeter me non est altera '."
,"11":"Veniet super te malum, et nescies avertere; et irruet super te calamitas, quam non poteris expiare; veniet super te repente,miseria, quam nescies."
,"12":"Sta cum incantationibus tuis,et cum multitudine maleficiorum tuorum, in quibus laborasti ab adulescentia tua: forte poteris iuvari, forte terrebis."
,"13":"Defecisti in multitudine consiliorum tuorum; stent et salvent te, qui metiuntur caelum, qui contemplantur sidera,et annuntiant singulis noviluniis,ventura tibi."
,"14":"Ecce facti sunt quasi stipula, ignis combussit eos. Non liberabunt seipsos,de manu flammae; non sunt prunae, quibus calefiant, nec focus, ut sedeant ad eum."
,"15":"Sic fiunt tibi incantatores tui, in quibuscumque laborasti ab adulescentia tua; unusquisque in via sua errat, non est qui salvet te."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Audite hoc, domus Iacob, qui vocamini nomine Israel,et de aquis Iudae existis, qui iuratis in nomine Domini,et Deum Israel invocatis,non in veritate neque in iustitia."
,"2":"De civitate enim sancta vocati sunt,et super Deum Israel constabiliti sunt; Dominus exercituum nomen eius."
,"3":"Priora ex tunc annuntiavi, et ex ore meo exierunt, et audita feci ea; repente operatus sum, et venerunt."
,"4":"Scivi enim quia durus es tu, et nervus ferreus cervix tua, et frons tua aerea."
,"5":"Praedixi tibi ex tunc; antequam venirent, indicavi tibi, ne forte diceres: 'Idolum meum operatum est haec, et sculptile meum et conflatile mandaverunt ista '."
,"6":"Quae audisti, vide omnia; vos autem num annuntiabitis?,Audita facio tibi nova ex nunc,et occulta, quae nescis."
,"7":"Nunc creata sunt et non ex tunc, et ante eorum diem, et non audisti ea, ne forte diceres: 'Ecce ego cognovi ea '."
,"8":"Neque audisti neque cognovisti, neque ex tunc aperta est auris tua; scio enim quia praevaricans praevaricaris,et transgressor ex utero vocaris."
,"9":"Propter nomen meum longe faciam furorem meum,et propter laudem meam infrenabo me super te, ne perdam te."
,"10":"Ecce excoxi te, sed non quasi argentum; probavi te in camino paupertatis."
,"11":"Propter me, propter me faciam, ut non blasphemer; et gloriam meam alteri non dabo."
,"12":"Audi me, Iacob, et Israel, quem ego vocavi; ego, ego primus,et ego novissimus."
,"13":"Manus mea fundavit terram, et dextera mea expandit caelos; ego voco eos, et stant simul."
,"14":"Congregamini, omnes vos, et audite: Quis de eis annuntiavit haec?,Dominus dilexit eum; faciet voluntatem suam in Babylone,et brachium suum in Chaldaeis."
,"15":"Ego, ego locutus sum et vocavi eum; adduxi eum, et prospera fuit via eius."
,"16":"Accedite ad me et audite hoc: Non a principio in abscondito locutus sum; ex tempore, antequam fieret, ibi eram; et nunc Dominus Deus misit me cum spiritu suo."
,"17":"Haec dicit Dominus, redemptor tuus, Sanctus Israel: Ego Dominus Deus tuus docens te utilia, gubernans te in via, qua ambulas."
,"18":"Utinam attendisses mandata mea!,Facta fuisset sicut flumen pax tua, et iustitia tua sicut gurgites maris;"
,"19":"et fuisset quasi arena semen tuum, et stirps uteri tui ut lapilli eius; non interisset et non fuisset attritum,nomen eius a facie mea."
,"20":"Egredimini de Babylone, fugite a Chaldaeis, in voce exsultationis annuntiate; auditum facite hoc, efferte illud usque ad extrema terrae, dicite: ' Redemit Dominus servum suum Iacob '."
,"21":"Non sitierunt, cum per desertum duceret eos; aquam de petra produxit eis,et scidit petram, et fluxerunt aquae."
,"22":"Non est pax impiis, dicit Dominus."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Audite me, insulae, et attendite, populi de longe; Dominus ab utero vocavit me, de ventre matris meae recordatus est nominis mei;"
,"2":"et posuit os meum quasi gladium acutum, in umbra manus suae protexit me,et posuit me sicut sagittam electam, in pharetra sua abscondit me"
,"3":"et dixit mihi: ' Servus meus es tu, Israel, in quo gloriabor '."
,"4":"Et ego dixi: ' In vacuum laboravi, sine causa et vane fortitudinem meam consumpsi; verumtamen iudicium meum cum Domino, et merces mea cum Deo meo '."
,"5":"Et nunc dicit Dominus, qui formavit me ex utero servum sibi, ut reducerem Iacob ad eum, et Israel ei congregaretur; et glorificatus sum in oculis Domini, et Deus meus factus est fortitudo mea."
,"6":"Et dixit: ' Parum est ut sis mihi servus,ad suscitandas tribus Iacob,et reliquias Israel reducendas: dabo te in lucem gentium, ut sit salus mea usque ad extremum terrae '."
,"7":"Haec dicit Dominus, redemptor Israel, Sanctus eius, ad contemptum in anima, ad abominatum in gente, ad servum dominorum: ' Reges videbunt et consurgent, principes quoque et adorabunt, propter Dominum, quia fidelis est, Sanctum Israel, qui elegit te '."
,"8":"Haec dicit Dominus: ' In tempore beneplaciti exaudivi te,et in die salutis auxiliatus sum tui; et servavi te et dedi te in foedus populi, ut suscitares terram,et distribueres hereditates dissipatas;"
,"9":"ut diceres his, qui vincti sunt: 'Exite', et his, qui in tenebris: 'Revelamini'. Super vias pascentur, et in omnibus collibus decalvatis pascua eorum;"
,"10":"non esurient neque sitient, et non percutiet eos aestus vel sol, quia miserator eorum reget eos,et ad fontes aquarum adducet eos."
,"11":"Et ponam omnes montes meos in viam, et semitae meae exaltabuntur."
,"12":"Ecce isti de longe venient, et ecce illi ab aquilone et mari, et isti de terra Sinim '."
,"13":"Laudate, caeli, et exsulta, terra; iubilate, montes, laudem, quia consolatur Dominus populum suum,et pauperum suorum miseretur."
,"14":"Et dixit Sion: ' Dereliquit me Dominus, et Dominus oblitus est mei '."
,"15":"Numquid oblivisci potest mulier infantem suum, ut non misereatur filio uteri sui?,Et si illa oblita fuerit, ego tamen non obliviscar tui."
,"16":"Ecce in manibus meis descripsi te; muri tui coram me semper."
,"17":"Festinant structores tui; destruentes te et dissipantes a te exibunt."
,"18":"Leva in circuitu oculos tuos et vide: omnes isti congregati sunt, venerunt tibi. ' Vivo ego, dicit Dominus, quia omnibus his velut ornamento vestieris,et circumdabis tibi eos quasi sponsa '."
,"19":"Quia ruinae tuae et solitudines tuae,et terra eversa: nunc angusta eris prae habitatoribus; et longe erunt, qui devorabant te."
,"20":"Adhuc dicent in auribus tuis,filii orbitatis tuae: ' Angustus est mihi locus; fac spatium mihi, ut habitem '."
,"21":"Et dices in corde tuo: ' Quis genuit mihi istos?,Ego orbata et non pariens, transmigrata et captiva; et istos quis enutrivit?,Ecce ego relicta eram sola; et isti ubi erant? '."
,"22":"Haec dicit Dominus Deus: ' Ecce levabo ad gentes manum meam,et ad populos exaltabo signum meum; et afferent filios tuos in ulnis, et filiae tuae super umeros portabuntur."
,"23":"Et erunt reges nutricii tui, et reginae nutrices tuae; vultu in terram demisso adorabunt te,et pulverem pedum tuorum lingent. Et scies quia ego Dominus: non confundentur, qui sperant in me '."
,"24":"Numquid tolletur a forti praeda, aut, quod captum fuerit, a robusto salvari poterit?"
,"25":"Quia haec dicit Dominus: ' Equidem et captivus a forti tolletur, et, quod ablatum fuerit a robusto, salvabitur; cum his, qui contendebant tecum, ego contendam,et filios tuos ego salvabo."
,"26":"Et cibabo hostes tuos carnibus suis, et quasi musto sanguine suo inebriabuntur; et sciet omnis caro quia ego Dominus salvator tuus, et redemptor tuus Fortis Iacob '."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Haec dicit Dominus: ' Ubinam est liber repudii matris vestrae, quo dimisi eam?,Aut quis est creditor meus, cui vendidi vos?,Ecce in iniquitatibus vestris venditi estis, et in sceleribus vestris dimissa est mater vestra."
,"2":"Cur veni, et non erat vir, vocavi, et non erat qui responderet?,Numquid abbreviata est manus mea, ut non possim redimere?,Aut non est in me virtus ad liberandum?,Ecce in increpatione mea exsiccabo mare, ponam flumina in siccum; computrescent pisces sine aqua,et morientur in siti."
,"3":"Induam caelos luctu,et saccum ponam operimentum eorum '."
,"4":"Dominus Deus dedit mihi linguam eruditam, ut sciam sustentare eum, qui lassus est, verbo; excitat mane, mane excitat mihi aurem, ut audiam quasi discipulus."
,"5":"Dominus Deus aperuit mihi aurem; ego autem non rebellavi, retrorsum non abii."
,"6":"Dorsum meum dedi percutientibus,et genas meas vellentibus: faciem meam non averti,ab increpationibus et sputis."
,"7":"Dominus Deus auxiliator meus; ideo non sum confusus, ideo posui faciem meam ut petram durissimam,et scio quoniam non confundar."
,"8":"Iuxta est qui iustificat me; quis contradicet mihi? Stemus simul. Quis est adversarius meus? Accedat ad me."
,"9":"Ecce Dominus Deus auxiliator meus; quis est qui condemnet me?,Ecce omnes quasi vestimentum conterentur, tinea comedet eos."
,"10":"Quis ex vobis timet Dominum, audiens vocem servi sui?,Qui ambulavit in tenebris, et non est lumen ei, speret in nomine Domini,et innitatur super Deum suum."
,"11":"Ecce vos omnes, qui accenditis ignem, accincti sagittis, ambulate in lumine ignis vestri,et in sagittis, quas succendistis. De manu mea factum est hoc vobis; in doloribus recumbetis."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Audite me, qui sequimini iustitiam, qui quaeritis Dominum; attendite ad petram, unde excisi estis, et ad cavernam laci, de qua praecisi estis."
,"2":"Attendite ad Abraham patrem vestrum,et ad Saram, quae peperit vos; quia unum vocavi eum,et benedixi ei et multiplicavi eum."
,"3":"Consolatur enim Dominus Sion, consolatur omnes ruinas eius; et ponit desertum eius quasi Eden,et solitudinem eius quasi hortum Domini. Gaudium et laetitia invenietur in ea, gratiarum actio et vox laudis."
,"4":"Attendite ad me, popule meus; et nationes, me audite, quia lex a me exiet, et iudicium meum in lucem populorum statuam."
,"5":"Prope est iustitia mea, egressa est salus mea, et brachia mea populos iudicabunt; in me insulae sperabunt,et ad brachium meum attendent."
,"6":"Levate in caelum oculos vestros,et inspicite in terram deorsum, quia caeli sicut fumus liquescent, et terra sicut vestimentum atteretur, et habitatores eius sicut haec interibunt. Salus autem mea in sempiternum erit, et iustitia mea non deficiet."
,"7":"Audite me, qui scitis iustitiam, popule, in cuius corde est lex mea: nolite timere opprobrium hominum,et blasphemias eorum ne metuatis."
,"8":"Sicut enim vestimentum sic comedet eos vermis, et sicut lanam sic devorabit eos tinea; iustitia autem mea in sempiternum erit, et salus mea in generationes generationum."
,"9":"Consurge, consurge, induere fortitudinem, brachium Domini; consurge sicut in diebus antiquis, in generationibus saeculorum. Numquid non tu percussisti Rahab, vulnerasti draconem?"
,"10":"Numquid non tu siccasti mare, aquam abyssi vehementis, qui posuisti profundum maris viam, ut transirent liberati?"
,"11":"Et redempti a Domino revertentur,et venient in Sion laudantes; et laetitia sempiterna super capita eorum, gaudium et laetitiam obtinebunt; fugiet dolor et gemitus."
,"12":"Ego, ego ipse consolator vester. Quis tu, ut timeas ab homine mortali,et a filio hominis, qui quasi fenum ita arescet?"
,"13":"Et oblitus es Domini factoris tui, qui tetendit caelos et fundavit terram; et formidasti iugiter tota die,a facie furoris eius, qui te tribulabat, cum parabat ad perdendum. Ubi nunc est furor tribulantis?"
,"14":"Cito captivus liberabitur,et non morietur in fovea, nec deficiet panis eius."
,"15":"Ego enim sum Dominus Deus tuus, qui conturbo mare, et intumescunt fluctus eius; Dominus exercituum nomen eius."
,"16":"Posui verba mea in ore tuo,et in umbra manus meae protexi te, cum extendebam caelos et fundabam terram,et dicebam ad Sion: 'Populus meus es tu '."
,"17":"Elevare, elevare, consurge, Ierusalem, quae bibisti de manu Domini calicem irae eius; poculum soporis bibisti, epotasti."
,"18":"Non est qui sustentet eam,ex omnibus filiis, quos genuit; et non est qui apprehendat manum eius,ex omnibus filiis, quos enutrivit."
,"19":"Duo sunt quae occurrerunt tibi; quis contristabitur super te?,Vastitas et contritio et fames et gladius; quis consolabitur te?"
,"20":"Filii tui defecerunt, iacent in capite omnium viarum,sicut oryx illaqueatus, pleni indignatione Domini, increpatione Dei tui."
,"21":"Idcirco audi hoc, paupercula,et ebria, sed non a vino."
,"22":"Haec dicit dominator tuus, Dominus et Deus tuus, qui contendit pro populo suo: ' Ecce tuli de manu tua calicem soporis, poculum indignationis meae; non adicies, ut bibas illum ultra."
,"23":"Et ponam illum in manu eorum, qui te humiliaverunt,et dixerunt tibi: 'Incurvare, ut transeamus'; et ponebas ut terram dorsum tuum,et quasi viam transeuntibus '."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Consurge, consurge, induere fortitudine tua, Sion; induere vestimentis gloriae tuae, Ierusalem, civitas sanctitatis, quia non adiciet ultra, ut pertranseat per te,incircumcisus et immundus."
,"2":"Excutere de pulvere, consurge, captiva Ierusalem; solve vincula colli tui, captiva filia Sion."
,"3":"Quia haec dicit Dominus: ' Gratis venumdati estis et sine argento redimemini '."
,"4":"Quia haec dicit Dominus Deus: ' In Aegyptum descendit populus meus in principio, ut colonus esset ibi; et Assur sine causa oppressit eum."
,"5":"Et nunc quid mihi est hic, dicit Dominus, quoniam ablatus est populus meus gratis? Dominatores eius ululant, dicit Dominus, et iugiter tota die nomen meum blasphematur."
,"6":"Propter hoc sciet populus meus nomen meum in die illa, quia ego ipse, qui loquebar: 'Ecce adsum' '."
,"7":"Quam pulchri super montes,pedes annuntiantis, praedicantis pacem, annuntiantis bonum, praedicantis salutem, dicentis Sion: 'Regnavit Deus tuus!'."
,"8":"Vox speculatorum tuorum: levaverunt vocem, simul exsultabunt, quia oculo ad oculum videbunt, cum redierit Dominus ad Sion."
,"9":"Gaudete et exsultate simul, deserta Ierusalem, quia consolatus est Dominus populum suum, redemit Ierusalem."
,"10":"Nudavit Dominus brachium sanctum suum,in oculis omnium gentium; et videbunt omnes fines terrae,salutare Dei nostri."
,"11":"Recedite, recedite, exite inde, pollutum nolite tangere; exite de medio eius, mundamini, qui fertis vasa Domini."
,"12":"Quoniam non in festinatione exibitis,nec in fuga properabitis; praecedet enim vos Dominus, et colliget vos Deus Israel."
,"13":"Ecce prospere aget servus meus; exaltabitur et elevabitur et sublimis erit valde."
,"14":"Sicut obstupuerunt super eum multi, sic deformis erat, quasi non esset hominis species eius, filiorum hominis aspectus eius,"
,"15":"sic disperget gentes multas. Super ipsum continebunt reges os suum, quia, quae non sunt narrata eis, viderunt,et, quae non audierunt, contemplati sunt."
}`)
	CurrentBook.AddChapter(53, `{
"1":"' Quis credidit auditui nostro, et brachium Domini cui revelatum est?"
,"2":"Et ascendit sicut virgultum coram eo,et sicut radix de terra sitienti. Non erat species ei neque decor, ut aspiceremus eum, et non erat aspectus, ut desideraremus eum."
,"3":"Despectus erat et novissimus virorum, vir dolorum et sciens infirmitatem, et quasi abscondebamus vultum coram eo; despectus, unde nec reputabamus eum."
,"4":"Vere languores nostros ipse tulit,et dolores nostros ipse portavit; et nos putavimus eum quasi plagatum, percussum a Deo et humiliatum."
,"5":"Ipse autem vulneratus est propter iniquitates nostras, attritus est propter scelera nostra; disciplina pacis nostrae super eum, et livore eius sanati sumus."
,"6":"Omnes nos quasi oves erravimus, unusquisque in viam suam declinavit; et posuit Dominus in eo,iniquitatem omnium nostrum '."
,"7":"Afflictus est et ipse subiecit se,et non aperuit os suum; sicut agnus, qui ad occisionem ducitur, et quasi ovis, quae coram tondentibus se obmutuit,et non aperuit os suum."
,"8":"Angustia et iudicio sublatus est. De generatione eius quis curabit?,Quia abscissus est de terra viventium; propter scelus populi mei percussus est ad mortem."
,"9":"Et posuerunt sepulcrum eius cum impiis, cum divitibus tumulum eius, eo quod iniquitatem non fecerit, neque dolus fuerit in ore eius."
,"10":"Et Dominus voluit conterere eum infirmitate. Si posuerit in piaculum animam suam, videbit semen longaevum, et voluntas Domini in manu eius prosperabitur."
,"11":"Propter laborem animae eius,videbit lucem, saturabitur in scientia sua. Iustificabit iustus servus meus multos,et iniquitates eorum ipse portabit."
,"12":"Ideo dispertiam ei multos, et cum fortibus dividet spolia, pro eo quod tradidit in mortem animam suam,et cum sceleratis reputatus est; et ipse peccatum multorum tulit,et pro transgressoribus rogat."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Exsulta, sterilis, quae non peperisti, laetare, gaude, quae non parturisti, quoniam multi sunt filii desertae,magis quam filii nuptae, dicit Dominus."
,"2":"Dilata locum tentorii tui,et pelles tabernaculorum tuorum extende, ne parcas; longos fac funiculos tuos,et clavos tuos consolida."
,"3":"Ad dexteram enim et ad laevam penetrabis, et semen tuum hereditabit gentes, quae civitates desertas inhabitabunt."
,"4":"Noli timere, quia non confunderis, neque erubescas, quia non te pudebit; nam confusionis adulescentiae tuae oblivisceris,et opprobrii viduitatis tuae non recordaberis amplius."
,"5":"Qui enim fecit te, erit sponsus tuus, Dominus exercituum nomen eius; et redemptor tuus Sanctus Israel, Deus omnis terrae vocabitur."
,"6":"Quia ut mulierem derelictam et maerentem spiritu,vocavit te Dominus, et uxorem ab adulescentia abiectam,dixit Deus tuus."
,"7":"Ad punctum in modico dereliqui te,et in miserationibus magnis congregabo te."
,"8":"In momento indignationis,abscondi faciem meam parumper a te,et in misericordia sempiterna misertus sum tui, dixit redemptor tuus Dominus."
,"9":"Sicut in diebus Noe istud mihi est, cui iuravi, ne inducerem aquas Noe ultra supra terram; sic iuravi, ut non irascar tibi,et non increpem te."
,"10":"Montes enim recedent, et colles movebuntur, misericordia autem mea non recedet a te, et foedus pacis meae non movebitur, dixit miserator tuus Dominus."
,"11":"Paupercula, tempestate convulsa absque ulla consolatione, ecce ego sternam super carbunculos lapides tuos,et fundabo te in sapphiris;"
,"12":"et ponam iaspidem propugnacula tua,et portas tuas in lapides pretiosos,et omnes terminos tuos in lapides desiderabiles."
,"13":"Universi filii tui erunt discipuli Domini, et magna erit pax filiis tuis;"
,"14":"in iustitia fundaberis. Procul eris ab oppressione, quia non timebis, et a pavore, quia non appropinquabit tibi."
,"15":"Ecce, si impetus fiet, non erit ex me; qui impetum fecerit in te, cadet contra te."
,"16":"Ecce, ego creavi fabrum,sufflantem in igne prunas,et proferentem vas in opus suum; et ego creavi etiam vastatorem ad disperdendum."
,"17":"Omne vas, quod fictum est contra te, frustra erit. Et omnem linguam insurgentem tibi in iudicio confutabis: haec est hereditas servorum Domini,et iustitia eorum ex me, dicit Dominus."
}`)
	CurrentBook.AddChapter(55, `{
"1":"Heu! Omnes sitientes, venite ad aquas; et, qui non habetis argentum, properate, emite et comedite, venite, emite absque argento,et absque ulla commutatione vinum et lac."
,"2":"Quare appenditis argentum non in panibus,et laborem vestrum non in saturitate?,Audite, audientes me, et comedite bonum, ut delectetur in crassitudine anima vestra."
,"3":"Inclinate aurem vestram et venite ad me; audite, ut vivat anima vestra, et feriam vobiscum pactum sempiternum, misericordias David fideles."
,"4":"Ecce testem populis dedi eum, ducem ac praeceptorem gentibus."
,"5":"Ecce gentem, quam nesciebas, vocabis, et gentes, quae te non cognoverunt, ad te current, propter Dominum Deum tuum,et Sanctum Israel, quia glorificavit te."
,"6":"Quaerite Dominum, dum inveniri potest; invocate eum, dum prope est."
,"7":"Derelinquat impius viam suam, et vir iniquus cogitationes suas; et revertatur ad Dominum, et miserebitur eius, et ad Deum nostrum, quoniam multus est ad ignoscendum."
,"8":"Non enim cogitationes meae cogitationes vestrae, neque viae vestrae viae meae, dicit Dominus."
,"9":"Quia sicut exaltantur caeli a terra, sic exaltatae sunt viae meae a viis vestris, et cogitationes meae a cogitationibus vestris."
,"10":"Et quomodo descendit imber et nix de caelo,et illuc ultra non revertitur, sed inebriat terram et infundit eam,et germinare eam facit,et dat semen serenti et panem comedenti,"
,"11":"sic erit verbum meum, quod egredietur de ore meo: non revertetur ad me vacuum, sed faciet, quaecumque volui, et prosperabitur in his, ad quae misi illud."
,"12":"Quia in laetitia egrediemini,et in pace deducemini; montes et colles cantabunt coram vobis laudem, et omnia ligna regionis plaudent manu."
,"13":"Pro vepribus ascendet cupressus, et pro urtica crescet myrtus; et erit Domino in gloriam, in signum aeternum, quod non auferetur."
}`)
	CurrentBook.AddChapter(56, `{
"1":"Haec dicit Dominus: ' Custodite iudicium et facite,iustitiam, quia iuxta est salus mea, ut veniat, et iustitia mea, ut reveletur '."
,"2":"Beatus vir, qui facit hoc, et filius hominis, qui apprehendit istud, custodiens sabbatum, ne polluat illud, custodiens manum suam, ne faciat omne malum."
,"3":"Et non dicat filius advenae, qui adhaeret Domino, dicens: ' Separatione dividet me Dominus a populo suo '. Et non dicat eunuchus: ' Ecce, ego lignum aridum '."
,"4":"Quia haec dicit Dominus eunuchis: ' Qui custodierint sabbata mea,et elegerint, quae ego volui, et tenuerint foedus meum,"
,"5":"dabo eis in domo mea et in muris meis,locum et nomen melius a filiis et filiabus: nomen sempiternum dabo eis, quod non peribit."
,"6":"Et filios advenae, qui adhaerent Domino, ut colant eum, ut diligant nomen Domini, ut sint ei in servos, omnes custodientes sabbatum, ne polluant illud, et tenentes foedus meum,"
,"7":"adducam eos in montem sanctum meum,et laetificabo eos in domo orationis meae: holocausta eorum et victimae eorum,placebunt mihi super altari meo, quia domus mea domus orationis,vocabitur cunctis populis '."
,"8":"Ait Dominus Deus, qui congregat dispersos Israel: ' Adhuc congregabo ad eum praeter congregatos eius '."
,"9":"Omnes bestiae agri, venite ad devorandum, universae bestiae saltus."
,"10":"Speculatores eius caeci, omnes nescierunt; universi sunt canes muti non valentes latrare, insanientes, cubantes, amantes soporem;"
,"11":"et canes voraces nescierunt saturitatem, ipsi pastores ignoraverunt intellegentiam: omnes in viam suam declinaverunt, unusquisque ad avaritiam suam, a summo usque ad novissimum."
,"12":"' Venite, sumam vinum, et impleamur ebrietate; et cras erit sicut hodie,et multo amplius '."
}`)
	CurrentBook.AddChapter(57, `{
"1":"Iustus perit, et non est qui recogitet in corde suo; et viri misericordiae colliguntur, tamen non est qui intellegat: a facie enim malitiae collectus est iustus."
,"2":"In pacem ingreditur, requiescit in cubili suo, qui ambulat in directione sua."
,"3":"Vos autem accedite huc, filii auguratricis, semen adulteri et fornicariae."
,"4":"Super quem luditis?,Super quem dilatatis os et eicitis linguam?,Numquid non vos filii scelesti, semen mendax,"
,"5":"qui exardescitis in terebinthis,subter omne lignum frondosum, immolantes parvulos in vallibus,subter scissuras petrarum?"
,"6":"In partibus vallis pars tua, hae sunt sors tua; et ipsis effundisti libamen, obtulisti sacrificium. Numquid super his consolabor?"
,"7":"Super montem excelsum et sublimem posuisti cubile tuum, et illuc ascendisti, ut immolares hostias."
,"8":"Et post ostium et postem posuisti memoriale tuum; nam longe a me discooperuisti et ascendisti, dilatasti cubile tuum, et pepigisti cum eis foedus; dilexisti stratum eorum, manum respexisti."
,"9":"Et ingressa es ad regem cum unguento,et multiplicasti pigmenta tua; misisti legatos tuos procul,et humiliata es usque ad inferos."
,"10":"In multitudine viae tuae laborasti; non dixisti: ' Vanum est! '. Vitam manus tuae invenisti, propterea non aegrotasti."
,"11":"Pro quo sollicita timuisti, quia mentita es et mei non es recordata,neque cogitasti in corde tuo?,Nonne, quia ego tacui et longo tempore, me non times?"
,"12":"Ego annuntiabo iustitiam tuam,et opera tua, quae non proderunt tibi."
,"13":"Cum clamaveris, liberent te lucra tua; et omnia illa auferet ventus, tollet aura. Qui autem fiduciam habet in me, hereditabit terram,et possidebit montem sanctum meum."
,"14":"Et dicent: ' Sternite, sternite, parate viam, auferte offendicula de via populi mei '."
,"15":"Quia haec dicit Excelsus et Sublimis, habitans aeternitatem, et sanctum nomen eius: ' Excelsus et sanctus habito,et cum contrito et humili spiritu, ut vivificem spiritum humilium,et vivificem cor contritorum."
,"16":"Non enim in sempiternum litigabo,neque usque ad finem irascar, quia spiritus a facie mea deficeret, halitus, quem ego feci."
,"17":"Propter iniquitatem avaritiae eius iratus sum et percussi eum, abscondi faciem meam et indignatus sum; et abiit vagus in via cordis sui."
,"18":"Vias eius vidi et sanabo eum et reducam eum,et reddam consolationes ipsi et lugentibus eius."
,"19":"Creo fructum labiorum pacem; pacem ei, qui longe est et qui prope, dixit Dominus, et sanabo eum '."
,"20":"Impii autem quasi mare fervens, quod quiescere non potest, et redundant fluctus eius in limum et lutum."
,"21":"Non est pax impiis, dicit Deus meus."
}`)
	CurrentBook.AddChapter(58, `{
"1":"Clama fortiter, ne cesses; quasi tuba exalta vocem tuam,et annuntia populo meo scelera eorum,et domui Iacob peccata eorum."
,"2":"Me etenim de die in diem quaerunt et scire vias meas volunt, quasi gens, quae iustitiam fecerit,et iudicium Dei sui non dereliquerit. Rogant me iudicia iustitiae, appropinquare Deum volunt."
,"3":"' Quare ieiunavimus, et non aspexisti, humiliavimus animam nostram, et nescisti? '. Ecce, in die ieiunii vestri agitis negotia,et omnes operarios vestros opprimitis."
,"4":"Ecce, ad lites et contentiones ieiunatis,et percutitis pugno impie. Nolite ieiunare sicut hodie, ut audiatur in excelso clamor vester."
,"5":"Numquid tale est ieiunium, quod elegi, dies, quo homo affligit animam suam?,Numquid contorquere quasi iuncum caput suum,et saccum et cinerem sternere?,Numquid istud vocabis ieiunium,et diem acceptabilem Domino?"
,"6":"Nonne hoc est ieiunium, quod elegi: dissolvere vincula iniqua, solvere funes iugi, dimittere eos, qui confracti sunt, liberos, et omne iugum dirumpere?"
,"7":"Nonne frangere esurienti panem tuum, et egenos, vagos inducere in domum?,Cum videris nudum, operi eum,et carnem tuam ne despexeris."
,"8":"Tunc erumpet quasi aurora lumen tuum, et sanatio tua citius orietur; et anteibit faciem tuam iustitia tua, et gloria Domini colliget te."
,"9":"Tunc invocabis, et Dominus exaudiet; clamabis, et dicet: ' Ecce adsum '. Si abstuleris de medio tui iugum,et desieris extendere digitum,et loqui iniquitatem;"
,"10":"si effuderis esurienti animam tuam,et animam afflictam satiaveris, orietur in tenebris lux tua, et caligo tua erit sicut meridies."
,"11":"Et te ducet Dominus semper, et satiabit in locis aridis animam tuam,et ossa tua firmabit; et eris quasi hortus irriguus,et sicut fons aquarum, cuius non deficient aquae."
,"12":"Et reaedificabit gens tua ruinas antiquas; fundamenta generationis et generationis suscitabis: et vocaberis restitutor ruinarum, instaurator viarum, ut habitentur."
,"13":"Si averteris a sabbato pedem tuum, facere negotia tua in die sancto meo, et vocaveris sabbatum delicias,et diem Domino sacrum gloriosum; et glorificaveris eum relinquens vias tuas,et negotia tua et sermones tuos,"
,"14":"tunc delectaberis super Domino; et vehi te faciam super altitudines terrae,et cibabo te hereditate Iacob patris tui. Os enim Domini locutum est."
}`)
	CurrentBook.AddChapter(59, `{
"1":"Ecce non est abbreviata manus Domini, ut salvare nequeat, neque aggravata est auris eius, ut non exaudiat;"
,"2":"sed iniquitates vestrae diviserunt,inter vos et Deum vestrum, et peccata vestra absconderunt faciem eius,a vobis, ne exaudiret."
,"3":"Manus enim vestrae pollutae sunt sanguine, et digiti vestri iniquitate; labia vestra locuta sunt mendacium, et lingua vestra iniquitatem fatur."
,"4":"Non est qui invocet iustitiam, neque est qui iudicet vere; confidunt in nihilo et loquuntur vanitates: conceperunt laborem et pepererunt iniquitatem."
,"5":"Ova aspidum rumpunt,et telas araneae texunt; qui comederit de ovis eorum, morietur, et, quod fractum est, erumpet in regulum."
,"6":"Telae eorum non erunt in vestimentum, neque operientur operibus suis; opera eorum opera iniquitatis, et facinora violentiae in manibus eorum."
,"7":"Pedes eorum ad malum currunt,et festinant, ut effundant sanguinem innocentem; cogitationes eorum cogitationes iniquitatis, vastitas et contritio in viis eorum."
,"8":"Viam pacis nescierunt, et non est iudicium in gressibus eorum; semitae eorum incurvatae sunt eis: omnis, qui calcat in eis, ignorat pacem."
,"9":"Propter hoc elongatum est iudicium a nobis, et non apprehendit nos iustitia; exspectamus lucem, et ecce tenebrae, splendorem, et in caligine ambulamus."
,"10":"Palpamus sicut caeci parietem,et quasi absque oculis attrectamus; impegimus meridie quasi in crepusculo, inter sanos quasi mortui."
,"11":"Rugimus quasi ursi omnes,et quasi columbae gementes gemimus; exspectamus iudicium, et non est, salutem, et elongata est a nobis."
,"12":"Multiplicatae sunt enim iniquitates nostrae coram te, et peccata nostra respondent nobis; quia scelera nostra nobiscum, et iniquitates nostras cognovimus:"
,"13":"peccare et mentiri contra Dominum,et recedere a Deo nostro, loqui violentiam et transgressionem, concipere et murmurare de corde verba mendacii."
,"14":"Et conversum est retrorsum iudicium, et iustitia longe stat, quia corruit in platea veritas, et aequitas non potuit ingredi."
,"15":"Et facta est veritas in oblivionem, et, qui recedit a malo, spoliatur. Et vidit Dominus, et malum apparuit in oculis eius, quia non est iudicium."
,"16":"Et vidit quia non est vir, et aporiatus est, quia non est qui occurrat; et salvavit sibi brachium suum, et iustitia eius ipsa confirmavit eum."
,"17":"Indutus est iustitia ut lorica, et galea salutis in capite eius; indutus est vestimentis ultionis,et operuit se zelo quasi pallio."
,"18":"Secundum opera sic retribuet: iram hostibus suis, retributionem inimicis suis, insulis vicem reddet."
,"19":"Et timebunt, qui ab occidente, nomen Domini, et, qui ab ortu solis, gloriam eius, cum venerit quasi fluvius violentus, quem spiritus Domini cogit."
,"20":"Et veniet pro Sion redemptor,et eis, qui redeunt ab iniquitate in Iacob, dixit Dominus."
,"21":"Hoc foedus meum cum eis, dixit Dominus: ' Spiritus meus, qui est super te, et verba mea, quae posui in ore tuo, non recedent de ore tuo,et de ore seminis tui,et de ore seminis seminis tui, dixit Dominus, amodo et usque in sempiternum '."
}`)
	CurrentBook.AddChapter(60, `{
"1":"Surge, illuminare, quia venit lumen tuum, et gloria Domini super te orta est."
,"2":"Quia ecce tenebrae operient terram,et caligo populos; super te autem orietur Dominus, et gloria eius in te videbitur."
,"3":"Et ambulabunt gentes in lumine tuo, et reges in splendore ortus tui."
,"4":"Leva in circuitu oculos tuos et vide: omnes isti congregati sunt, venerunt tibi; filii tui de longe veniunt, et filiae tuae in ulnis gestantur."
,"5":"Tunc videbis et illuminaberis, et palpitabit et dilatabitur cor tuum, quia confluet ad te multitudo maris, fortitudo gentium veniet tibi;"
,"6":"inundatio camelorum operiet te, dromedarii Madian et Epha; omnes de Saba venient, aurum et tus deferentes,et laudem Domini annuntiantes."
,"7":"Omne pecus Cedar congregabitur tibi, arietes Nabaioth ministrabunt tibi; offerentur super placabili altari meo, et domum gloriae meae glorificabo."
,"8":"Quae sunt istae, quae ut nubes volant, et quasi columbae ad fenestras suas?"
,"9":"Me enim insulae exspectabunt, et in principio naves Tharsis, ut adducant filios tuos de longe, argentum eorum et aurum eorum cum eis, nomini Domini Dei tui et Sancto Israel, quia glorificavit te."
,"10":"Et aedificabunt filii peregrinorum muros tuos, et reges eorum ministrabunt tibi; in indignatione enim mea percussi te, sed in beneplacito meo misertus sum tui."
,"11":"Et aperientur portae tuae iugiter, die ac nocte non claudentur, ut afferatur ad te fortitudo gentium, et reges earum adducantur."
,"12":"Gens enim et regnum, quae non servierint tibi, peribunt, et gentes vastitate vastabuntur."
,"13":"Gloria Libani ad te veniet, cupressus, ulmus et abies simul, ad ornandum locum sanctuarii mei; et locum pedum meorum glorificabo."
,"14":"Et venient ad te curvi filii eorum, qui humiliaverunt te, et adorabunt vestigia pedum tuorum omnes, qui detrahebant tibi, et vocabunt te Civitatem Domini, Sion Sancti Israel."
,"15":"Pro eo quod fuisti derelicta et odio habita, et non erat qui per te transiret, ponam te in superbiam saeculorum, gaudium in generationem et generationem;"
,"16":"et suges lac gentium,et mamilla regum lactaberis,et scies quia ego Dominus salvator tuus, et redemptor tuus Fortis Iacob."
,"17":"Pro aere afferam aurum,et pro ferro afferam argentum,et pro lignis aes,et pro lapidibus ferrum; et ponam custodes tuos pacem,et praepositos tuos iustitiam."
,"18":"Non audietur ultra violentia in terra tua, vastitas et contritio in terminis tuis; et vocabis Salutem muros tuos,et portas tuas Laudem."
,"19":"Non erit tibi amplius sol ad lucendum per diem, nec splendor lunae illuminabit te, sed erit tibi Dominus in lucem sempiternam, et Deus tuus in gloriam tuam."
,"20":"Non occidet ultra sol tuus, et luna tua non minuetur, quia erit tibi Dominus in lucem sempiternam, et complebuntur dies luctus tui."
,"21":"Populus autem tuus omnes iusti; in perpetuum hereditabunt terram, germen plantationis meae, opus manus meae ad glorificandum."
,"22":"Minimus erit in mille, et parvulus in gentem fortem. Ego Dominus in tempore eius subito faciam istud."
}`)
	CurrentBook.AddChapter(61, `{
"1":"Spiritus Domini Dei super me, eo quod unxerit Dominus me; ad annuntiandum laeta mansuetis misit me, ut mederer contritis corde,et praedicarem captivis liberationem,et clausis apertionem;"
,"2":"ut praedicarem annum placabilem Domino,et diem ultionis Deo nostro; ut consolarer omnes lugentes,"
,"3":"ut ponerem lugentibus Sion,et darem eis coronam pro cinere, oleum gaudii pro luctu, pallium laudis pro spiritu maeroris. Et vocabuntur Terebinthi iustitiae, plantatio Domini ad glorificandum."
,"4":"Et aedificabunt deserta a saeculo,et ruinas antiquas erigent,et instaurabunt civitates desertas, dissipatas in generatione et generatione."
,"5":"Et stabunt alieni et pascent pecora vestra, et filii peregrinorum agricolae et vinitores vestri erunt;"
,"6":"vos autem Sacerdotes Domini vocabimini, Ministri Dei nostri dicetur vobis; fortitudinem gentium comedetis,et in gloria earum superbietis."
,"7":"Pro confusione eorum duplici,et ignominia laudabunt partem suam; propterea in terra sua duplicia possidebunt, laetitia sempiterna erit eis."
,"8":"Quia ego Dominus diligens iudicium, odio habens rapinam et iniquitatem; et dabo opus eorum in veritate,et foedus perpetuum feriam eis."
,"9":"Et scietur in gentibus semen eorum, et germen eorum in medio populorum; omnes, qui viderint eos, cognoscent illos, quia isti sunt semen, cui benedixit Dominus."
,"10":"Gaudens gaudebo in Domino, et exsultabit anima mea in Deo meo, quia induit me vestimentis salutis,et indumento iustitiae circumdedit me, quasi sponsum decoratum corona,et quasi sponsam ornatam monilibus suis."
,"11":"Sicut enim terra profert germen suum, et sicut hortus semen suum germinat, sic Dominus Deus germinabit iustitiam,et laudem coram universis gentibus."
}`)
	CurrentBook.AddChapter(62, `{
"1":"Propter Sion non tacebo,et propter Ierusalem non,quiescam, donec egrediatur ut splendor iustitia eius, et salus eius ut lampas accendatur."
,"2":"Et videbunt gentes iustitiam tuam, et cuncti reges gloriam tuam; et vocaberis nomine novo, quod os Domini nominabit."
,"3":"Et eris corona gloriae in manu Domini, et diadema regni in manu Dei tui."
,"4":"Non vocaberis ultra Derelicta, et terra tua non vocabitur amplius Desolata; sed vocaberis Beneplacitum meum in ea, et terra tua Nupta, quia complacuit Domino in te, et terra tua erit nupta."
,"5":"Nam ut iuvenis uxorem ducit virginem, ita ducent te filii tui; ut gaudet sponsus super sponsam, ita gaudebit super te Deus tuus."
,"6":"Super muros tuos, Ierusalem, constitui custodes; tota die et tota nocte, in perpetuo non tacebunt. Qui commonetis Dominum, ne taceatis"
,"7":"et ne detis silentium ei, donec stabiliat et donec ponat Ierusalem,laudem in terra."
,"8":"Iuravit Dominus in dextera sua,et in brachio fortitudinis suae: ' Non dabo triticum tuum ultra,cibum inimicis tuis, neque bibent filii alieni,vinum tuum, in quo laborasti."
,"9":"Quia, qui collegerint illud, comedent,et laudabunt Dominum; et, qui vindemiam fecerint, illud bibent in atriis sanctuarii mei."
,"10":"Transite, transite per portas, parate viam populo. Sternite, sternite semitam, eligite lapides, elevate signum ad populos '."
,"11":"Ecce Dominus auditum fecit in extremis terrae: ' Dicite filiae Sion: Ecce salus tua venit, ecce merces eius cum eo, et praemium eius coram illo."
,"12":"Et vocabunt eos Populus sanctus, Redempti a Domino; tu autem vocaberis Quaesita, Civitas non derelicta '."
}`)
	CurrentBook.AddChapter(63, `{
"1":"' Quis est iste, qui venit de Edom, tinctis vestibus de Bosra?,Iste formosus in stola sua, gradiens in multitudine fortitudinis suae '. ' Sum ego, qui loquor iustitiam, potens ad salvandum '."
,"2":"' Quare ergo rubrum est indumentum tuum, et vestimenta tua sicut calcantis in torculari? '."
,"3":"' Torcular calcavi solus, et de gentibus non erat vir mecum; calcavi eos in furore meo,et conculcavi eos in ira mea. Et aspersus est sanguis eorum super vestimenta mea, et omnia indumenta mea inquinavi."
,"4":"Dies enim ultionis in corde meo, annus redemptionis meae venit."
,"5":"Circumspexi, et non erat auxiliator, miratus sum, et non fuit qui adiuvaret; et salvavit mihi brachium meum, et indignatio mea ipsa auxiliata est mihi."
,"6":"Et conculcavi populos in furore meo,et contrivi eos in indignatione mea,et effudi in terram sanguinem eorum '."
,"7":"Miserationum Domini recordabor, laudum Domini,super omnibus, quae reddidit nobis Dominus, et super multitudinem bonorum domui Israel, quae largitus est eis secundum misericordias suas,et secundum multitudinem miserationum suarum."
,"8":"Et dixit: ' Verumtamen populus meus est, filii, qui non deludent '; et factus est eis salvator."
,"9":"In omni tribulatione eorum non legatus neque angelus, sed ipse salvavit eos. In dilectione sua et in indulgentia sua,ipse redemit eos,et sustulit eos et portavit eos,cunctis diebus saeculi."
,"10":"Ipsi autem ad iracundiam provocaverunt,et afflixerunt spiritum sanctitatis eius; et conversus est eis in inimicum,et ipse debellavit eos."
,"11":"Et recordatus est dierum antiquorum, Moysi et populi sui. Ubi est qui eduxit eos de mari,cum pastore gregis sui?,Ubi est qui posuit in medio eius,spiritum sanctitatis suae?"
,"12":"Qui adduxit ad dexteram Moysi,brachium maiestatis suae, qui scidit aquas ante eos, ut faceret sibi nomen sempiternum,"
,"13":"qui deduxit eos per abyssos,quasi equum per desertum, et non impingebant?"
,"14":"Sicut armentum, quod descendit per vallem, spiritus Domini fecit eos quiescere; sic conduxisti populum tuum, ut faceres tibi nomen gloriae."
,"15":"Attende de caelo et vide,de habitaculo sancto tuo et gloriae tuae; ubi est zelus tuus et fortitudo tua?,Commotio viscerum tuorum et misericordiae tuae,super me continuerunt se."
,"16":"Tu enim pater noster. Abraham enim nescit nos, et Israel ignorat nos; tu, Domine, pater noster, redemptor noster: a saeculo nomen tuum."
,"17":"Quare errare nos fecisti, Domine, de viis tuis, indurasti cor nostrum, ne timeremus te?,Convertere propter servos tuos, tribus hereditatis tuae."
,"18":"Brevi tempore hereditaverunt populum sanctum tuum, hostes nostri conculcaverunt sanctuarium tuum."
,"19":"Facti sumus a saeculo, cum non dominareris nostri, neque invocaretur nomen tuum super nos. Utinam dirumperes caelos et descenderes!,A facie tua montes defluerent."
}`)
	CurrentBook.AddChapter(64, `{
"1":"Sicut ignis succendit sarmenta, aquam ebullire facit ignis, ut notum facias nomen tuum inimicis tuis, a facie tua gentes turbentur,"
,"2":"cum feceris mirabilia, quae non sperabamus. Descendisti, et a facie tua montes defluxerunt."
,"3":"A saeculo non audierunt, neque aures perceperunt; oculus non vidit Deum, absque te, qui operaretur pro sperantibus in eum."
,"4":"Occurris laetanti, facienti iustitiam,et his, qui in viis tuis recordantur tui. Ecce tu iratus es, et peccavimus; in ipsis a saeculo nos salvabimur."
,"5":"Et facti sumus ut immundus omnes nos, et quasi pannus inquinatus universae iustitiae nostrae; et marcuimus quasi folium universi, et iniquitates nostrae quasi ventus abstulerunt nos."
,"6":"Non est qui invocet nomen tuum, qui consurgat et adhaereat tibi, quia abscondisti faciem tuam a nobis,et dissolvisti nos in manu iniquitatis nostrae."
,"7":"Et nunc, Domine, pater noster es tu, nos vero lutum; et fictor noster tu, et opera manuum tuarum omnes nos."
,"8":"Ne irascaris, Domine, nimis,et ne ultra memineris iniquitatis; ecce, respice: populus tuus omnes nos."
,"9":"Urbes sanctitatis tuae factae sunt in desertum, Sion deserta facta est, Ierusalem desolata est."
,"10":"Domus sanctitatis nostrae et gloriae nostrae, ubi laudaverunt te patres nostri, facta est in exustionem ignis, et omnia desiderabilia nostra versa sunt in ruinas."
,"11":"Numquid super his continebis te, Domine, tacebis et affliges nos vehementer?"
}`)
	CurrentBook.AddChapter(65, `{
"1":"' Quaesitus sum ab his, qui non consulebant me, inventus sum ab his, qui non quaerebant me. Dixi: 'Ecce ego, ecce ego!',ad gentem, quae non invocabat nomen meum."
,"2":"Expandi manus meas tota die,ad populum rebellem, qui graditur in via non bona,post cogitationes suas;"
,"3":"populus, qui ad iracundiam provocat me,ante faciem meam semper, qui immolant in hortis,et sacrificant super lateres,"
,"4":"qui morantur in sepulcris,et in locis occultis pernoctant, qui comedunt carnem suillam,et ius abominabile in vasis eorum,"
,"5":"qui dicunt: 'Recede!,Non appropinques mihi, quia sanctificarem te'. Isti fumus sunt in naribus meis, ignis ardens tota die."
,"6":"Ecce scriptum est coram me; non tacebo, sed retribuam, et retribuam in sinum eorum"
,"7":"iniquitates vestras et iniquitates patrum vestrorum,simul, dicit Dominus, qui sacrificaverunt super montes,et super colles exprobraverunt mihi; et remetiar opus eorum primo,in sinu eorum '."
,"8":"Haec dicit Dominus: ' Quomodo si inveniatur mustum in botro,et dicatur: 'Ne dissipes illud, quoniam benedictio est in eo', sic faciam propter servos meos, ut non disperdam totum."
,"9":"Et educam de Iacob semen,et de Iuda possidentem montes meos; et hereditabunt terram electi mei, et servi mei habitabunt ibi."
,"10":"Et erit Saron in pascua gregum, et vallis Achor in cubile armentorum,populo meo, qui quaesierunt me."
,"11":"Vos autem, qui derelinquitis Dominum, qui obliviscimini montem sanctum meum, qui ponitis Gad mensam,et amphoram impletis Meni,"
,"12":"numerabo vos in gladio, et omnes in caede corruetis; pro eo quod vocavi, et non respondistis, locutus sum, et non audistis, sed fecistis malum in oculis meis,et, quod displicet mihi, elegistis '."
,"13":"Propter hoc haec dicit Dominus Deus: ' Ecce servi mei comedent, et vos esurietis; ecce servi mei bibent, et vos sitietis; ecce servi mei laetabuntur, et vos confundemini;"
,"14":"ecce servi mei laudabunt in exsultatione cordis, et vos clamabitis prae dolore cordis,et prae contritione spiritus ululabitis."
,"15":"Et relinquetis nomen vestrum,in iuramentum electis meis: 'Interficiat te Dominus Deus'; et servos suos vocabit nomine alio."
,"16":"Quicumque benedicit sibi in terra, benedicet sibi in Deo Amen; et, quicumque iurat in terra, iurabit in Deo Amen; quia oblivioni tradentur angustiae priores, et quia abscondentur ab oculis meis."
,"17":"Ecce enim ego creo,caelos novos et terram novam, et non erunt in memoria priora,et non ascendent super cor."
,"18":"Sed gaudebunt et exsultabunt usque in sempiternum,in his, quae ego creo, quia ecce ego creo Ierusalem exsultationem,et populum eius gaudium."
,"19":"Et exsultabo in Ierusalem,et gaudebo in populo meo, et non audietur in ea ultra,vox fletus et vox clamoris."
,"20":"Non erit ibi amplius infans dierum,et senex, qui non impleat dies suos. Quoniam puer erit, qui centenarius moriatur; et, qui non attingat centum annos, maledictus erit."
,"21":"Et aedificabunt domos et habitabunt,et plantabunt vineas et comedent fructus earum."
,"22":"Non aedificabunt, ut alius habitet, non plantabunt, ut alius comedat: secundum enim dies ligni erunt dies populi mei, et operibus manuum suarum diu fruentur electi mei."
,"23":"Non laborabunt frustra,neque generabunt in interitum repentinum, quia semen benedictorum erunt Domini, et nepotes eorum cum eis."
,"24":"Eritque: antequam clament, ego respondebo; adhuc illis loquentibus, ego exaudiam."
,"25":"Lupus et agnus pascentur simul, et leo sicut bos comedet paleas, et serpenti pulvis panis eius. Non nocebunt neque occident,in omni monte sancto meo ', dicit Dominus."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Haec dicit Dominus: ' Caelum thronus meus, terra autem scabellum pedum meorum. Quae ista domus, quam aedificabitis mihi, et quis iste locus quietis meae?"
,"2":"Omnia haec manus mea fecit, et mea sunt universa ista, dicit Dominus. Ad hunc autem respiciam, ad pauperculum et contritum spiritu,et trementem sermones meos."
,"3":"Qui immolat bovem, interficit virum; qui sacrificat ovem, excerebrat canem; qui offert oblationem, idemque sanguinem suillum; qui adolet incensum, benedicit idolo. Sicut isti elegerunt vias suas, et in abominationibus suis anima eorum delectatur,"
,"4":"sic ego eligam malam sortem eorum,et, quae timebant, adducam eis; quia vocavi, et non erat qui responderet, locutus sum, et non audierunt,feceruntque malum in oculis meis,et, quod displicet mihi, elegerunt '."
,"5":"Audite verbum Domini, qui tremitis ad verbum eius. Dixerunt fratres vestri odientes vos,et abicientes vos propter nomen meum: ' Gloriam suam manifestet Dominus, ut videamus laetitiam vestram'; ipsi autem confundentur."
,"6":"Vox clamoris de civitate, vox de templo, vox Domini,reddentis retributionem inimicis suis."
,"7":"Antequam parturiret, peperit; antequam veniret partus eius, peperit masculum."
,"8":"Quis audivit umquam tale?,Et quis vidit huic simile?,Numquid oritur terra in die una, aut parietur gens in momento?,Quia parturivit, iam peperit Sion filios suos."
,"9":"' Numquid aperiam uterum et parere non faciam? ', dicit Dominus. ' Aut ego, qui parere facio, uterum claudam? ', ait Deus tuus."
,"10":"Laetamini cum Ierusalem et exsultate in ea, omnes, qui diligitis eam; gaudete cum ea gaudio, universi, qui lugebatis super eam,"
,"11":"ut sugatis et repleamini,ab ubere consolationis eius, ut mulgeatis et deliciis affluatis,ex uberibus gloriae eius."
,"12":"Quia haec dicit Dominus: ' Ecce ego dirigam ad eam quasi fluvium pacem,et quasi torrentem inundantem gloriam gentium. Sugetis, in ulnis portabimini, et super genua blandientur vobis."
,"13":"Quomodo si quem mater consolatur, ita ego consolabor vos; et in Ierusalem consolabimini."
,"14":"Videbitis, et gaudebit cor vestrum, et ossa vestra quasi herba germinabunt, et manifestabitur manus Domini in servis eius, et indignabitur inimicis suis."
,"15":"Quia ecce Dominus in igne veniet, et quasi turbo quadrigae eius, reddere in indignatione furorem suum,et increpationem suam in flamma ignis;"
,"16":"quia in igne Dominus diiudicabit,et in gladio suo omnem carnem, et multiplicabuntur interfecti a Domino."
,"17":"Qui sanctificantur et purificantur, ut ingrediantur,in hortos post aliquem stantem in medio, qui comedunt carnem suillam,et abominationem et murem, simul consumentur, dicit Dominus."
,"18":"Ego autem cognoscens opera eorum et cogitationes eorum veniam, ut congregem omnes gentes et linguas; et venient et videbunt gloriam meam."
,"19":"Et ponam in eis signum et mittam ex eis, qui salvati fuerint, ad gentes in Tharsis, Phut, Lud, Mosoch, Ros, Thubal et Iavan, ad insulas longinquas, ad eos, qui non audierunt de me et non viderunt gloriam meam, et annuntiabunt gloriam meam gentibus;"
,"20":"et adducent omnes fratres vestros de cunctis gentibus oblationem Domino, in equis et in quadrigis et in lecticis et in mulis et in dromedariis, ad montem sanctum meum Ierusalem, dicit Dominus: quomodo si inferant filii Israel oblationem in vase mundo in domum Domini."
,"21":"Et assumam ex eis in sacerdotes et Levitas, dicit Dominus."
,"22":"Quia sicut caeli novi,et terra nova, quae ego faciam, stabunt coram me, dicit Dominus, sic stabit semen vestrum et nomen vestrum."
,"23":"Et erit: unoquoque novilunio,et quovis sabbato,veniet omnis caro, ut adoret coram facie mea, dicit Dominus."
,"24":"Et egredientur et videbunt cadavera virorum, qui praevaricati sunt in me; nam vermis eorum non morietur, et ignis eorum non exstinguetur, et erunt abominationi omni carni '."
}`)

}
func LA_NVBSE_LoadVMLMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"ALEPH. Quomodo sedet sola,civitas plena populo!,Facta est quasi vidua,domina gentium; princeps provinciarum,facta est sub tributo."
,"2":"BETH. Plorans plorat in nocte, et lacrimae eius in maxillis eius; non est qui consoletur eam,ex omnibus caris eius: omnes amici eius spreverunt eam,et facti sunt ei inimici."
,"3":"GHIMEL. Migravit Iudas prae afflictione,et multitudine servitutis; habitat inter gentes,nec invenit requiem: omnes persecutores eius apprehenderunt eam,inter angustias."
,"4":"DALETH. Viae Sion lugent, eo quod non sint qui veniant ad sollemnitatem; omnes portae eius destructae, sacerdotes eius gementes, virgines eius afflictae, et ipsa oppressa amaritudine."
,"5":"HE. Facti sunt hostes eius in caput, inimici eius in securitate, quia Dominus afflixit eam,propter multitudinem iniquitatum eius; parvuli eius ducti sunt captivi,ante faciem tribulantis."
,"6":"VAU. Et egressus est a filia Sion,omnis decor eius; facti sunt principes eius velut cervi,non invenientes pascua,et abierunt absque fortitudine,ante faciem persequentis."
,"7":"ZAIN. Recordata est Ierusalem,dierum afflictionis suae et peregrinationis, omnium desiderabilium suorum, quae habuerat a diebus antiquis, cum caderet populus eius in manu hostili, et non esset auxiliator; viderunt eam hostes,et deriserunt interitum eius."
,"8":"HETH. Peccatum peccavit Ierusalem, propterea abominabilis facta est; omnes, qui glorificabant eam, spreverunt illam, quia viderunt ignominiam eius: ipsa autem gemens,conversa est retrorsum."
,"9":"TETH. Sordes eius in fimbriis eius, nec recordata est finis sui; deposita est vehementer, non habens consolatorem. ' Vide, Domine, afflictionem meam, quoniam erectus est inimicus! '."
,"10":"IOD. Manum suam misit hostis,ad omnia desiderabilia eius, quia vidit gentes,ingressas sanctuarium suum, de quibus praeceperas, ne intrarent in ecclesiam tuam."
,"11":"CAPH. Omnis populus eius gemens,et quaerens panem; dederunt pretiosa quaeque pro cibo,ad refocillandam animam. ' Vide, Domine, et considera, quoniam facta sum vilis!"
,"12":"LAMED. O vos omnes, qui transitis per viam, attendite et videte, si est dolor sicut dolor meus, quem paravit mihi, quo afflixit me Dominus,in die irae furoris sui."
,"13":"MEM. De excelso misit ignem, in ossa mea immisit eum; expandit rete pedibus meis, convertit me retrorsum: posuit me desolatam, tota die maerore confectam."
,"14":"NUN. Vigilavit super iniquitates meas, in manu eius convolutae sunt,et impositae collo meo; debilitavit virtutem meam: dedit me Dominus in manu, de qua non potero surgere."
,"15":"SAMECH. Sprevit omnes fortes meos,Dominus in medio mei; vocavit adversum me conventum, ut contereret iuvenes meos: torcular calcavit Dominus,virgini filiae Iudae."
,"16":"AIN. Idcirco ego plorans, et oculus meus deducens aquas, quia longe factus est a me consolator,reficiens animam meam; facti sunt filii mei desolati, quoniam invaluit inimicus '."
,"17":"PHE. Expandit Sion manus suas, non est qui consoletur eam; mandavit Dominus adversum Iacob,in circuitu eius hostes eius: facta est Ierusalem,quasi polluta menstruis inter eos."
,"18":"SADE. ' Iustus est Dominus, quia contra os eius rebellis fui. Audite, obsecro, universi populi, et videte dolorem meum: virgines meae et iuvenes mei,abierunt in captivitatem."
,"19":"COPH. Vocavi amicos meos, et ipsi deceperunt me; sacerdotes mei et senes mei,in urbe consumpti sunt, quia quaesierunt cibum sibi, ut refocillarent animam suam."
,"20":"RES. Vide, Domine, quoniam tribulor; efferbuerunt viscera mea, subversum est cor meum in memetipsa, quoniam valde rebellis fui; foris orbavit me gladius,et domi mors."
,"21":"SIN. Audi, quia ingemisco ego, et non est qui consoletur me; omnes inimici mei audierunt malum meum, laetati sunt quoniam tu fecisti. Adduc diem, quem proclamasti, et fient similes mei."
,"22":"THAU. Ingrediatur omne malum eorum coram te, et fac eis, sicut fecisti mihi,propter omnes iniquitates meas; multi enim gemitus mei, et cor meum maerens '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"ALEPH. Quomodo obtexit caligine in furore suo,Dominus filiam Sion!,Proiecit de caelo in terram,gloriam Israel,et non est recordatus scabelli pedum suorum,in die furoris sui."
,"2":"BETH. Praecipitavit Dominus,nec pepercit omnia pascua Iacob; destruxit in furore suo,munitiones filiae Iudae; deiecit in terram, polluit,regnum et principes eius."
,"3":"GHIMEL. Confregit in ira furoris sui,omne cornu Israel; avertit retrorsum dexteram suam,a facie inimici,et succendit in Iacob quasi ignem flammae,devorantis in gyro."
,"4":"DALETH. Tetendit arcum suum quasi inimicus, firmavit dexteram suam quasi hostis,et occidit omne, quod pulchrum erat visu, in tabernaculo filiae Sion; effudit quasi ignem indignationem suam."
,"5":"HE. Factus est Dominus velut inimicus, deglutivit Israel, deglutivit omnia moenia eius, dissipavit munitiones eius,et multiplicavit in filia Iudae,maerorem et maestitiam."
,"6":"VAU. Et dissipavit quasi hortum saepem suam, demolitus est tabernaculum suum; oblivioni tradidit Dominus in Sion festivitatem et sabbatum,et despexit in indignatione furoris sui,regem et sacerdotem."
,"7":"ZAIN. Reppulit Dominus altare suum, maledixit sanctuario suo; tradidit in manu inimici,muros domorum eius: vocem dederunt in domo Domini,sicut in die sollemni."
,"8":"HETH. Cogitavit Dominus dissipare,murum filiae Sion; tetendit funiculum, non avertit manum suam a perditione; et in luctum redegit antemurale et murum: pariter elanguerunt."
,"9":"TETH. Defixae sunt in terra portae eius; perdidit et contrivit vectes eius. Rex eius et principes eius in gentibus; non est lex, et prophetae eius non invenerunt,visionem a Domino."
,"10":"IOD. Sederunt in terra, conticuerunt senes filiae Sion, consperserunt cinere capita sua, accincti sunt ciliciis; abiecerunt in terram capita sua,virgines Ierusalem."
,"11":"CAPH. Defecerunt prae lacrimis oculi mei, efferbuerunt viscera mea; effusum est in terra iecur meum,super contritione filiae populi mei, cum deficeret parvulus et lactans,in plateis oppidi."
,"12":"LAMED. Matribus suis dixerunt: ' Ubi est triticum et vinum? ', cum deficerent quasi vulnerati,in plateis civitatis, cum exhalarent animas suas,in sinu matrum suarum."
,"13":"MEM. Cui comparabo te vel cui assimilabo te, filia Ierusalem?,Cui exaequabo te et consolabor te, virgo filia Sion?,Magna est enim velut mare contritio tua; quis medebitur tui?"
,"14":"NUN. Prophetae tui viderunt tibi falsa et stulta,nec aperiebant iniquitatem tuam, ut converterent sortem tuam; viderunt autem tibi oracula,mendacii et seductionis."
,"15":"SAMECH. Plauserunt super te manibus,omnes transeuntes per viam; sibilaverunt et moverunt caput suum,super filiam Ierusalem: ' Haeccine est urbs, quam vocabant perfectum decorem, gaudium universae terrae? '."
,"16":"PHE. Aperuerunt super te os suum,omnes inimici tui; sibilaverunt et fremuerunt dentibus,et dixerunt: ' Devoravimus; en ista est dies, quam exspectabamus: invenimus, vidimus '."
,"17":"AIN. Fecit Dominus, quae cogitavit; complevit sermonem suum, quem praeceperat a diebus antiquis: destruxit et non pepercit. Et laetificavit super te inimicum,et exaltavit cornu hostium tuorum."
,"18":"SADE. Clamet cor tuum ad Dominum,super muros filiae Sion; deduc quasi torrentem lacrimas,per diem et noctem. Non des requiem tibi, neque taceat pupilla oculi tui."
,"19":"COPH. Consurge, lamentare in nocte,in principio vigiliarum, effunde sicut aquam cor tuum,ante conspectum Domini; leva ad eum manus tuas,pro anima parvulorum tuorum, qui defecerunt in fame,in capite omnium compitorum."
,"20":"RES. ' Vide, Domine, et considera, cui feceris ita; ergone comedent mulieres fructum suum, parvulos diligenter fovendos?,Num occidetur in sanctuario Domini,sacerdos et propheta?"
,"21":"SIN. Iacuerunt in terra foris,puer et senex; virgines meae et iuvenes mei,ceciderunt in gladio: interfecisti in die furoris tui, percussisti nec misertus es."
,"22":"THAU. Vocasti quasi ad diem sollemnem, qui terrerent me de circuitu, et non fuit in die furoris Domini, qui effugeret et relinqueretur: quos fovi et enutrivi, inimicus meus consumpsit eos '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"ALEPH. Ego vir videns paupertatem meam,in virga indignationis eius."
,"2":"ALEPH. Me minavit et adduxit,in tenebras et non in lucem."
,"3":"ALEPH. Tantum in me vertit et convertit,manum suam tota die."
,"4":"BETH. Consumpsit pellem meam et carnem meam, contrivit ossa mea."
,"5":"BETH. Aedificavit in gyro meo,et circumdedit me felle et labore."
,"6":"BETH. In tenebrosis collocavit me,quasi mortuos sempiternos."
,"7":"GHIMEL. Circumaedificavit adversum me, ut non egrediar, aggravavit compedem meum."
,"8":"GHIMEL. Sed et cum clamavero et rogavero, exclusit orationem meam."
,"9":"GHIMEL. Conclusit vias meas lapidibus quadris, semitas meas subvertit."
,"10":"DALETH. Ursus insidians factus est mihi, leo in absconditis."
,"11":"DALETH. Semitas meas subvertit et confregit me, posuit me desolatam."
,"12":"DALETH. Tetendit arcum suum et posuit me,quasi signum ad sagittam."
,"13":"HE. Misit in renibus meis,filias pharetrae suae."
,"14":"HE. Factus sum in derisum omni populo meo, canticum eorum tota die."
,"15":"HE. Replevit me amaritudinibus, inebriavit me absinthio."
,"16":"VAU. Et fregit in glarea dentes meos, depressit me cinere."
,"17":"VAU. Et repulsa est a pace anima mea, oblitus sum bonorum."
,"18":"VAU. Et dixi: ' Periit splendor meus et spes mea a Domino '."
,"19":"ZAIN. Recordare paupertatis et peregrinationis meae, absinthii et fellis."
,"20":"ZAIN. Memoria memor est,et tabescit in me anima mea."
,"21":"ZAIN. Haec recolam in corde meo, ideo sperabo."
,"22":"HETH. Misericordiae Domini, quia non sumus consumpti, quia non defecerunt miserationes eius."
,"23":"HETH. Novae sunt omni mane, magna est fides tua."
,"24":"HETH. ' Pars mea Dominus, dixit anima mea; propterea exspectabo eum '."
,"25":"TETH. Bonus est Dominus sperantibus in eum, animae quaerenti illum."
,"26":"TETH. Bonum est praestolari cum silentio,salutare Domini."
,"27":"TETH. Bonum est viro, cum portaverit,iugum ab adulescentia sua."
,"28":"IOD. Sedebit solitarius et tacebit, cum istud imponitur ei."
,"29":"IOD. Ponet in pulvere os suum, si forte sit spes."
,"30":"IOD. Dabit percutienti se maxillam, saturabitur opprobriis."
,"31":"CAPH. Quia non repellet in sempiternum,Dominus."
,"32":"CAPH. Quia si afflixit, et miserebitur,secundum multitudinem misericordiarum suarum."
,"33":"CAPH. Non enim humiliat ex corde suo,et affligit filios hominum."
,"34":"LAMED. Conterere sub pedibus suis,omnes vinctos terrae."
,"35":"LAMED. Declinare iudicium viri,in conspectu vultus Altissimi."
,"36":"LAMED. Pervertere hominem in iudicio suo, num Dominus haec ignorat?"
,"37":"MEM. Quis est iste, qui dixit, et factum est?,Dominus non iussit?"
,"38":"MEM. Ex ore Altissimi nonne egrediuntur,et mala et bona?"
,"39":"MEM. Quid murmurabit homo vivens, vir pro peccatis suis?"
,"40":"NUN. ' Scrutemur vias nostras et quaeramus,et revertamur ad Dominum."
,"41":"NUN. Levemus corda nostra cum manibus,ad Dominum in caelos."
,"42":"NUN. Nos inique egimus et rebelles fuimus; idcirco tu inexorabilis fuisti."
,"43":"SAMECH. Operuisti in furore et percussisti nos; occidisti nec pepercisti."
,"44":"SAMECH. Opposuisti nubem tibi, ne transeat oratio."
,"45":"SAMECH. In eradicationem et abiectionem posuisti nos,in medio populorum."
,"46":"PHE. Aperuerunt super nos os suum,omnes inimici nostri."
,"47":"PHE. Formido et fovea facta est nobis, vastatio et contritio '."
,"48":"PHE. Rivos aquarum deducit oculus meus,in contritione filiae populi mei."
,"49":"AIN. Oculus meus lacrimas effundit nec tacet, eo quod non sit requies."
,"50":"AIN. Donec respiciat et videat,Dominus de caelis."
,"51":"AIN. Oculus meus affligit animam meam,prae cunctis filiabus urbis meae."
,"52":"SADE. Venatione venati sunt me quasi avem,inimici mei gratis."
,"53":"SADE. Perdiderunt in lacu vitam meam,et iecerunt lapides super me."
,"54":"SADE. Inundaverunt aquae super caput meum, dixi: ' Perii '."
,"55":"COPH. Invocavi nomen tuum, Domine, de profunditate lacus."
,"56":"COPH. Vocem meam audisti: ' Ne avertas,aurem tuam a singultu meo et clamoribus '."
,"57":"COPH. Appropinquasti in die, quando invocavi te, dixisti: ' Ne timeas '."
,"58":"RES. Iudicasti, Domine, causam animae meae, redemisti vitam meam."
,"59":"RES. Vidisti, Domine, afflictionem meam; iudica iudicium meum."
,"60":"RES. Vidisti omnem furorem eorum, universas cogitationes eorum adversum me."
,"61":"SIN. Audisti opprobrium eorum, Domine, omnes cogitationes eorum adversum me."
,"62":"SIN. Labia insurgentium mihi et meditationes eorum,adversum me tota die."
,"63":"SIN. Sessionem eorum et resurrectionem eorum vide; ego sum psalmus eorum."
,"64":"THAU. Reddes eis vicem, Domine, iuxta opera manuum suarum."
,"65":"THAU. Dabis eis duritiam cordis, exsecrationem tuam."
,"66":"THAU. Persequeris in furore et conteres eos,sub caelis tuis, Domine."
}`)
	CurrentBook.AddChapter(4, `{
"1":"ALEPH. Quomodo obscuratum est aurum, mutatum est obryzum optimum!,Dispersi sunt lapides sancti,in capite omnium platearum."
,"2":"BETH. Filii Sion incliti,et ponderati auro primo, quomodo reputati sunt in vasa testea, opus manuum figuli!"
,"3":"GHIMEL. Sed et thoes nudaverunt mammam, lactaverunt catulos suos; filia populi mei crudelis,quasi struthio in deserto."
,"4":"DALETH. Adhaesit lingua lactantis,ad palatum eius in siti; parvuli petierunt panem, et non erat qui frangeret eis."
,"5":"HE. Qui vescebantur voluptuose, interierunt in viis; qui nutriebantur in coccinis, amplexati sunt stercora."
,"6":"VAU. Et maior effecta est iniquitas filiae populi mei,peccato Sodomae, quae subversa est in momento, et non laborabant in ea manus."
,"7":"ZAIN. Candidiores nazaraei eius nive, nitidiores lacte, rubicundiores in corpore coralliis, sapphirus aspectus eorum."
,"8":"HETH. Denigrata est super carbones facies eorum, et non sunt cogniti in plateis: adhaesit cutis eorum ossibus, aruit et facta est quasi lignum."
,"9":"TETH. Melius fuit occisis gladio,quam interfectis fame, quoniam isti extabuerunt consumpti,a sterilitate terrae."
,"10":"IOD. Manus mulierum misericordium,coxerunt filios suos: facti sunt cibus earum,in contritione filiae populi mei."
,"11":"CAPH. Complevit Dominus furorem suum, effudit iram indignationis suae; et succendit ignem in Sion, qui devoravit fundamenta eius."
,"12":"LAMED. Non crediderunt reges terrae,et universi habitatores orbis, quoniam ingrederetur hostis et inimicus,per portas Ierusalem."
,"13":"MEM. Propter peccata prophetarum eius,et iniquitates sacerdotum eius, qui effuderunt in medio eius,sanguinem iustorum."
,"14":"NUN. Erraverunt caeci in plateis, polluti sunt in sanguine, ita ut nemo posset attingere,lacinias eorum."
,"15":"SAMECH. ' Recedite! Pollutus est ', clamaverunt eis; ' Recedite, abite, nolite tangere! '. Cum fugerent et errarent, dixerunt inter gentes: ' Non addent ultra ut incolant '."
,"16":"PHE. Facies Domini dispersit eos, non addet ut respiciat eos; facies sacerdotum non respexerunt,neque senum miserti sunt."
,"17":"AIN. Adhuc deficiunt oculi nostri,ad auxilium nostrum vanum?,In specula nostra respeximus,ad gentem, quae salvare non potest."
,"18":"SADE. Insidiati sunt vestigiis nostris, ne iremus per plateas nostras. ' Appropinquavit finis noster, completi sunt dies nostri, quia venit finis noster '."
,"19":"COPH. Velociores fuerunt persecutores nostri,aquilis caeli; super montes persecuti sunt nos, in deserto insidiati sunt nobis."
,"20":"RES. Spiritus oris nostri, unctus Domini, captus est in foveis eorum, de quo dicebamus: ' Sub umbra sua,vivemus in gentibus '."
,"21":"SIN. Gaude et laetare, filia Edom, quae habitas in terra Us; ad te quoque perveniet calix, inebriaberis atque nudaberis."
,"22":"THAU. Completa est iniquitas tua, filia Sion, non addet ultra ut transmigret te; visitavit iniquitatem tuam, filia Edom, discooperuit peccata tua."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Recordare, Domine, quid acci derit nobis; intuere et respice opprobrium nostrum."
,"2":"Hereditas nostra versa est ad alienos, domus nostrae ad extraneos."
,"3":"Pupilli facti sumus absque patre, matres nostrae quasi viduae."
,"4":"Aquam nostram pecunia bibimus, ligna nostra pretio comparamus."
,"5":"Iugum in cervicibus nostris minamur; lassis non datur requies."
,"6":"Aegyptiis dedimus manum et Assyriis, ut saturaremur pane."
,"7":"Patres nostri peccaverunt et non sunt, et nos iniquitates eorum portamus."
,"8":"Servi dominantur nostri; non est qui redimat de manu eorum."
,"9":"Vitae nostrae periculo afferimus panem nobis,a facie gladii in deserto."
,"10":"Pellis nostra quasi clibanus exusta est,propter aestum famis."
,"11":"Mulieres in Sion humiliaverunt,et virgines in civitatibus Iudae."
,"12":"Principes manu eorum suspensi sunt; facies senum honorem non habuerunt."
,"13":"Adulescentes molam portaverunt, et pueri sub lignis corruerunt."
,"14":"Senes deficiunt de portis, iuvenes de choro psallentium."
,"15":"Defecit gaudium cordis nostri; versus est in luctum chorus noster."
,"16":"Cecidit corona capitis nostri; vae nobis, quia peccavimus!"
,"17":"Propterea maestum factum est cor nostrum, ideo contenebrati sunt oculi nostri,"
,"18":"propter montem Sion, quia desolatus est: vulpes ambulant in eo."
,"19":"Tu autem, Domine, in aeternum permanebis, solium tuum in generationem et generationem."
,"20":"Quare in perpetuum oblivisceris nostri, derelinques nos in longitudinem dierum?"
,"21":"Converte nos, Domine, ad te, et convertemur; innova dies nostros sicut a principio."
,"22":"Ergone proiciens reppulisti nos, iratus es contra nos vehementer?"
}`)

}
func LA_NVBSE_LoadVNABChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Visio Abdiae. Haec dicit Dominus Deus ad Edom. Auditum audivimus a Domino, et legatus ad gentes missus est: ' Surgite, et consurgamus,adversus eum in proelium! '."
,"2":"' Ecce parvulum te dabo in gentibus, contemptibilis tu es valde."
,"3":"Superbia cordis tui decepit te,habitantem in scissuris petrae, exaltantem solium suum; qui dicit in corde suo: 'Quis detrahet me in terram?'."
,"4":"Si exaltatus fueris ut aquila,et si inter sidera posueris nidum tuum, inde detraham te ', dicit Dominus."
,"5":"Si fures introissent ad te, si latrones per noctem, quomodo periisses!,Nonne furati essent sufficientia sibi?,Si vindemiatores introissent ad te, nonne racemos tantum reliquissent?"
,"6":"Quomodo scrutati sunt Esau?,Investigaverunt abscondita eius."
,"7":"Usque ad terminum eiecerunt te, omnes viri foederis tui deceperunt te, invaluerunt adversum te viri pacis tuae; qui comedunt tecum, ponent insidias subter te. Non est prudentia in eo."
,"8":"' Numquid non in die illa, dicit Dominus, perdam sapientes de Edom,et prudentiam de monte Esau?"
,"9":"Et timebunt fortes tui Theman, ut intereat omnis vir de monte Esau."
,"10":"Propter interfectionem,et propter iniquitatem,in fratrem tuum Iacob,operiet te confusio, et peribis in aeternum."
,"11":"In die cum stares ex adverso, quando capiebant alieni exercitum eius, et extranei ingrediebantur portas eius,et super Ierusalem mittebant sortem, tu quoque eras quasi unus ex eis '. "
,"12":"Et non respicies diem fratris tui, diem calamitatis eius; et non laetaberis super filios Iudae,in die perditionis eorum; et non magnificabis os tuum,in die angustiae."
,"13":"Neque ingredieris portam populi mei,in die ruinae eorum; neque respicies et tu malum eius,in die vastitatis illius,et non mittes manum in opes eius,in die vastitatis illius;"
,"14":"neque stabis in exitibus, ut interficias eos, qui fugerint, et non trades reliquos eius,in die tribulationis."
,"15":"Quoniam iuxta est dies Domini,super omnes gentes: sicut fecisti, fiet tibi, retributio tua convertetur in caput tuum."
,"16":"Quomodo enim bibistis super montem sanctum meum, bibent omnes gentes iugiter; et bibent et absorbebunt,et erunt quasi non fuerint."
,"17":"Et in monte Sion erit salvatio, et erit sanctum; et possidebit domus Iacob,eos, qui se possederant."
,"18":"Et erit domus Iacob ignis, et domus Ioseph flamma, et domus Esau stipula; et succendentur in eis, et devorabunt eos, et non erunt reliquiae domus Esau, quia Dominus locutus est."
,"19":"Et hereditabunt austrum, montem Esau, et Sephelam Philisthim; et possidebunt regionem Ephraim,et regionem Samariae, et Beniamin possidebit Galaad;"
,"20":"et transmigratio prima filiorum Israel,possidebit terram Chananaeorum usque ad Sareptam; et transmigratio Ierusalem, quae in Sapharad est, possidebit civitates austri."
,"21":"Et ascendent salvatores in montem Sion,iudicare montem Esau, et erit Domino regnum."
}`)

}
func LA_NVBSE_LoadVNAGChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In anno secundo Darii regis, in mense sexto, in die prima men sis, factum est verbum Domini in manu Aggaei prophetae ad Zorobabel filium Salathiel ducem Iudae et ad Iesua filium Iosedec sacerdotem magnum dicens:"
,"2":"' Haec ait Dominus exercituum dicens: Populus iste dicit: 'Nondum venit tempus domus Domini aedificandae' '."
,"3":"Et factum est verbum Domini in manu Aggaei prophetae dicens:"
,"4":"' Numquid tempus vobis est, ut habitetis in domibus laqueatis, et domus ista deserta?"
,"5":"Et nunc haec dicit Dominus exercituum: Ponite corda vestra super vias vestras:"
,"6":"seminastis multum et intulistis parum, comedistis et non estis satiati, bibistis et non estis inebriati, operuistis vos et non estis calefacti, et, qui pro mercede operatus est, misit eam in sacculum pertusum."
,"7":"Haec dicit Dominus exercituum: Ponite corda vestra super vias vestras."
,"8":"Ascendite in montem, portate lignum et aedificate domum, et acceptabilis mihi erit et glorificabor, dicit Dominus."
,"9":"Respexistis ad amplius, et ecce factum est minus; et intulistis in domum, et exsufflavi illud. Quam ob causam?, dicit Dominus exercituum. Quia domus mea deserta est, et vos festinatis unusquisque in domum suam."
,"10":"Propter hoc super vos prohibiti sunt caeli, ne darent rorem, et terra prohibita est, ne daret fructum suum."
,"11":"Et vocavi siccitatem super terram et super montes et super triticum et super vinum et super oleum et, quaecumque profert humus, et super homines et super iumenta et super omnem laborem manuum '."
,"12":"Et audivit Zorobabel filius Salathiel et Iesua filius Iosedec sacerdos magnus et omnes reliquiae populi vocem Domini Dei sui et verba Aggaei prophetae, sicut misit eum Dominus Deus eorum ad ipsos; et timuit populus a facie Domini."
,"13":"Et dixit Aggaeus nuntius Domini secundum mandatum Domini populo dicens: ' Ego vobiscum, dicit Dominus '."
,"14":"Et suscitavit Dominus spiritum Zorobabel filii Salathiel ducis Iudae et spiritum Iesua filii Iosedec sacerdotis magni et spiritum reliquorum omnium de populo; et ingressi sunt et faciebant opus in domo Domini exercituum Dei sui."
,"15":"In die vicesima et quarta mensis, in sexto mense, in anno secundo Darii regis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"In septimo mense, vicesima et prima mensis, factum est ver bum Domini in manu Aggaei prophetae dicens:"
,"2":"' Loquere ad Zorobabel filium Salathiel ducem Iudae et ad Iesua filium Iosedec sacerdotem magnum et ad reliquos populi dicens:"
,"3":"Quis in vobis est derelictus, qui vidit domum istam in gloria sua prima? Et quid vos videtis eam nunc? Numquid non ita est quasi non sit in oculis vestris?"
,"4":"Sed et nunc confortare, Zorobabel, dicit Dominus, et confortare, Iesua fili Iosedec sacerdos magne, et confortare, omnis popule terrae, dicit Dominus exercituum; et facite, quoniam ego vobiscum sum, dicit Dominus exercituum."
,"5":"Verbum quod pepigi vobiscum, cum egrederemini de terra Aegypti, et spiritus meus stat in medio vestrum; nolite timere."
,"6":"Quia haec dicit Dominus exercituum: Adhuc unum modicum est, et ego commovebo caelum et terram et mare et aridam."
,"7":"Et movebo omnes gentes, et venient thesauri cunctarum gentium, et implebo domum istam gloria, dicit Dominus exercituum."
,"8":"Meum est argentum et meum est aurum, dicit Dominus exercituum."
,"9":"Maior erit gloria domus istius novissima plus quam prima, dicit Dominus exercituum; et in loco isto dabo pacem, dicit Dominus exercituum '."
,"10":"In vicesima et quarta noni mensis, in anno secundo Darii, factum est verbum Domini ad Aggaeum prophetam dicens:"
,"11":"' Haec dicit Dominus exercituum: Interroga sacerdotes legem dicens:"
,"12":"Si tulerit homo carnem sanctificatam in ora vestimenti sui et tetigerit de summitate eius panem aut pulmentum aut vinum aut oleum aut omnem cibum, numquid sanctificabitur? '. Respondentes autem sacerdotes dixerunt: ' Non '."
,"13":"Et dixit Aggaeus: ' Si tetigerit pollutus cadavere omnia haec, numquid contaminabuntur? '. Et responderunt sacerdotes et dixerunt: ' Contaminabuntur '."
,"14":"Et respondit Aggaeus et dixit: ' Sic populus iste et sic gens ista ante faciem meam, dicit Dominus, et sic omne opus manuum eorum et omnia, quae offerunt ibi, contaminata sunt."
,"15":"Et nunc ponite corda vestra a die hac et supra: Antequam poneretur lapis super lapidem in templo Domini,"
,"16":"quid fuistis? Cum accederetis ad acervum viginti modiorum, erant decem; cum intraretis ad torcular, ut hauriretis quinquaginta lagenas, erant viginti."
,"17":"Percussi vos ariditate et rubigine et grandine omnia opera manuum vestrarum, et non fuit in vobis qui reverteretur ad me, dicit Dominus."
,"18":"Ponite corda vestra ex die ista et in futurum, a die vicesima et quarta noni mensis, a die, qua fundamenta iacta sunt templi Domini, ponite super cor vestrum."
,"19":"Numquid adhuc semen in horreo est, et adhuc vinea et ficus et malogranatum et lignum olivae non portavit fructum? Ex die hac benedicam '."
,"20":"Et factum est verbum Domini secundo ad Aggaeum in vicesima et quarta mensis dicens:"
,"21":"' Loquere ad Zorobabel ducem Iudae dicens: Ego movebo caelum pariter et terram"
,"22":"et subvertam solium regnorum et conteram fortitudinem regnorum gentium et subvertam quadrigam et ascensores eius; et descendent equi et ascensores eorum, unusquisque percussus gladio fratris sui."
,"23":"In die illo, dicit Dominus exercituum, assumam te, Zorobabel fili Salathiel, serve meus, dicit Dominus, et ponam te quasi signaculum, quia te elegi ', dicit Dominus exercituum."
}`)

}
func LA_NVBSE_LoadVNAMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Verba Amos, qui fuit in pastori bus de Thecua; quae vidit super Israel in diebus Oziae regis Iudae et in diebus Ieroboam filii Ioas regis Israel, duobus annis ante terraemotum."
,"2":"Et dixit: ' Dominus de Sion rugit,et de Ierusalem dat vocem suam; et lugent pascua pastorum, et exsiccatur vertex Carmeli '."
,"3":"Haec dicit Dominus: ' Super tribus sceleribus Damasci,et super quattuor verbum non revocabo: eo quod trituraverint in plaustris ferreis Galaad,"
,"4":"mittam ignem in domum Hazael, et devorabit aedes Benadad;"
,"5":"conteram vectem Damasci,et disperdam habitatorem de Biceataven,et tenentem sceptrum de Betheden; et transferetur populus Syriae Cir ', dicit Dominus."
,"6":"Haec dicit Dominus: ' Super tribus sceleribus Gazae,et super quattuor verbum non revocabo: eo quod transtulerint captivitatem perfectam, ut traderent eam in Edom,"
,"7":"mittam ignem in murum Gazae, et devorabit aedes eius;"
,"8":"disperdam habitatorem de Azoto,et tenentem sceptrum de Ascalone; convertam manum meam super Accaron, et peribunt reliqui Philisthinorum ', dicit Dominus Deus."
,"9":"Haec dicit Dominus: ' Super tribus sceleribus Tyri,et super quattuor verbum non revocabo: eo quod tradiderint captivitatem perfectam in Edom,et non sint recordati foederis fratrum,"
,"10":"mittam ignem in murum Tyri, et devorabit aedes eius '."
,"11":"Haec dicit Dominus: ' Super tribus sceleribus Edom,et super quattuor verbum non revocabo: eo quod persecutus sit in gladio fratrem suum,et violaverit misericordiam eius,et tenuerit ultra furorem suum,et indignationem suam servaverit usque in finem,"
,"12":"mittam ignem in Theman, et devorabit aedes Bosrae '."
,"13":"Haec dicit Dominus: ' Super tribus sceleribus filiorum Ammon,et super quattuor verbum non revocabo: eo quod dissecuerint praegnantes Galaad,ad dilatandum terminum suum,"
,"14":"succendam ignem in muro Rabba, et devorabit aedes eius in ululatu in die belli,et in turbine in die procellae;"
,"15":"et ibit rex eorum in captivitatem, ipse et principes eius simul ', dicit Dominus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Haec dicit Dominus: ' Super tribus sceleribus Moab,et super quattuor verbum non revocabo: eo quod incenderit ossa regis Edom,usque ad cinerem,"
,"2":"mittam ignem in Moab, et devorabit aedes Carioth, et morietur in tumultu Moab, in clamore et voce tubae;"
,"3":"disperdam iudicem de medio eius,et omnes principes eius interficiam cum eo ', dicit Dominus."
,"4":"Haec dicit Dominus: ' Super tribus sceleribus Iudae,et super quattuor verbum non revocabo: eo quod abiecerint legem Domini,et mandata eius non custodierint,C deceperunt enim eos idola sua, post quae abierant patres eorum C"
,"5":"mittam ignem in Iudam, et devorabit aedes Ierusalem '."
,"6":"Haec dicit Dominus: ' Super tribus sceleribus Israel,et super quattuor verbum non revocabo: eo quod vendiderint pro argento iustum,et pauperem pro calceamentis;"
,"7":"qui contriverint super pulverem terrae capita pauperum,et viam humilium declinaverint, et filius ac pater eius iverint ad puellam, ut violarent nomen sanctum meum;"
,"8":"et super vestimentis pignoratis accubuerint,iuxta omne altare,et vinum damnatorum biberint,in domo Dei sui."
,"9":"Ego autem exterminaveram,Amorraeum a facie eorum, cuius altitudo sicut altitudo cedrorum, et fortitudo quasi quercuum; exterminaveram fructum eius desuper,et radices eius subter."
,"10":"Ego ascendere vos feci,de terra Aegypti,et duxi vos in deserto,quadraginta annis, ut possideretis terram Amorraei;"
,"11":"et suscitavi de filiis vestris prophetas et de iuvenibus vestris nazaraeos. Numquid non ita est, filii Israel?, dicit Dominus."
,"12":"Et propinastis nazaraeis vinum,et prophetis mandastis dicentes: 'Ne prophetetis'."
,"13":"Ecce ego comprimam vos ad solum, sicut comprimit plaustrum,onustum feno;"
,"14":"deerit fuga a veloce, et fortis non firmabit virtutem suam, et robustus non salvabit animam suam;"
,"15":"tenens arcum non stabit, et velox pedibus suis non salvabitur; ascensor equi non salvabit animam suam,"
,"16":"et fortissimus corde inter robustos,nudus fugiet in illa die ', dicit Dominus."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Audite verbum hoc, quod locutus est Dominus super vos, filii Israel, super omnem cognationem, quam eduxi de terra Aegypti, dicens:"
,"2":"' Tantummodo vos cognovi,ex omnibus cognationibus terrae; idcirco visitabo super vos,omnes iniquitates vestras."
,"3":"Numquid ambulabunt duo pariter, nisi convenerint?"
,"4":"Numquid rugiet leo in saltu, nisi habuerit praedam?,Numquid dabit catulus leonis vocem de cubili suo, nisi aliquid apprehenderit?"
,"5":"Numquid cadet avis super terram,absque laqueo?,Numquid laxatur laqueus de terra, antequam quid ceperit?"
,"6":"Si clanget tuba in civitate, populus non expavescet?,Si erit malum in civitate, nonne Dominus fecit?"
,"7":"Nihil enim faciet Dominus Deus, nisi revelaverit secretum suum,ad servos suos prophetas."
,"8":"Leo rugit, quis non timebit?,Dominus Deus locutus est, quis non prophetabit?"
,"9":"Auditum facite in aedibus Assyriae,et in aedibus terrae Aegypti,et dicite: 'Congregamini super montes Samariae'; et videte insanias multas in medio eius,et oppressos in sinu eius."
,"10":"Et nescierunt facere rectum, dicit Dominus, thesaurizantes violentiam et rapinas,in aedibus suis '."
,"11":"Propterea haec dicit Dominus Deus: ' Inimicus circumdabit terram, et detrahetur ex te fortitudo tua, et diripientur aedes tuae '."
,"12":"Haec dicit Dominus: ' Quomodo si eruat pastor de ore leonis,duo crura aut extremum auriculae, sic eruentur filii Israel, qui habitant in Samaria, in margine lectuli,et in Damasci grabato."
,"13":"Audite et contestamini in domo Iacob, dicit Dominus, Deus exercituum:"
,"14":"In die cum visitavero praevaricationes Israel, super eum visitabo et super altaria Bethel, et amputabuntur cornua altaris,et cadent in terram;"
,"15":"et percutiam domum hiemalem,cum domo aestiva, et peribunt domus eburneae, et dissipabuntur aedes magnae ', dicit Dominus."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Audite verbum hoc, vaccae Basan, quae estis in monte Samariae, quae opprimitis egenos,et vexatis pauperes, quae dicitis dominis vestris: ' Affer, ut bibamus '."
,"2":"Iuravit Dominus Deus,in sanctitate sua: ' Ecce dies venient super vos, et levabunt vos in contis,et posteros vestros in hamis piscatoriis;"
,"3":"et per aperturas exibitis altera contra alteram,et proiciemini in Armon ', dicit Dominus."
,"4":"' Venite in Bethel et impie agite, ad Galgalam et multiplicate praevaricationem; et offerte mane victimas vestras, tribus diebus decimas vestras,"
,"5":"et sacrificate de fermentato laudem,et vocate voluntarias oblationes et annuntiate; sic enim diligitis, filii Israel ', dicit Dominus Deus."
,"6":"' Unde et ego dedi vobis,vacuitatem dentium in cunctis urbibus vestris,et indigentiam panis in omnibus locis vestris; et non estis reversi ad me ', dicit Dominus."
,"7":"' Ego quoque prohibui a vobis imbrem, cum adhuc tres menses superessent usque ad messem; et plui super unam civitatem,et super alteram civitatem non plui: pars una compluta est, et pars, super quam non plui, aruit. "
,"8":"Tunc fugiebant duae, tres civitates,ad unam civitatem, ut biberent aquam, et non satiabantur; sed non redistis ad me ', dicit Dominus."
,"9":"' Percussi vos in vento urente et in aurugine; multitudinem hortorum vestrorum et vinearum vestrarum, ficeta vestra et oliveta vestra,comedit eruca; sed non redistis ad me ', dicit Dominus."
,"10":"' Misi in vos pestem,sicut pestem Aegypti, percussi in gladio iuvenes vestros, captis equis vestris; et ascendere feci putredinem,castrorum vestrorum in nares vestras; sed non redistis ad me ', dicit Dominus."
,"11":"' Subverti vos, sicut subvertit Deus Sodomam et Gomorram, et facti estis quasi torris,raptus ab incendio; sed non redistis ad me ', dicit Dominus."
,"12":"Quapropter haec faciam tibi, Israel, et quia haec faciam tibi, praeparare in occursum Dei tui, Israel;"
,"13":"quia ecce formans montes et creans ventum,et annuntians homini cogitationem eius, faciens auroram et tenebras,et gradiens super excelsa terrae; Dominus, Deus exercituum, nomen eius."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Audite verbum istud, quod ego levo super vos, planctum, domus Israel:"
,"2":"Cecidit, non adiciet ut resurgat,virgo Israel; proiecta est in terram suam, non est qui suscitet eam."
,"3":"Quia haec dicit Dominus Deus: ' Urbs, de qua egrediebantur mille, relinquentur in ea centum; et de qua egrediebantur centum, relinquentur in ea decem,pro domo Israel '."
,"4":"Quia haec dicit Dominus domui Israel: ' Quaerite me et vivetis;"
,"5":"et nolite quaerere Bethel,et in Galgalam nolite intrare,et in Bersabee nolite transire, quia Galgala captiva ducetur, et Bethel erit iniquitas '."
,"6":"Quaerite Dominum et vivite; ne forte invadat sicut ignis,domum Ioseph, et devoret, et non sit,qui exstinguat Bethel."
,"7":"Qui convertunt in absinthium iudicium,et iustitiam in terram deiciunt."
,"8":"Qui facit stellas Pliadis et Orionem,et convertit in mane tenebras,et diem in noctem obscurat; qui vocat aquas maris,et effundit eas super faciem terrae; Dominus nomen eius."
,"9":"Qui micare facit vastitatem super robustum,et vastitatem super arcem affert."
,"10":"Odio habuerunt corripientem in porta,et loquentem perfecte abominati sunt."
,"11":"Idcirco, pro eo quod conculcastis pauperem,et portionem frumenti abstulistis ab eo, domos quadro lapide aedificastis,et non habitabitis in eis, vineas plantastis amantissimas,et non bibetis vinum earum."
,"12":"Quia cognovi multa scelera vestra,et fortia peccata vestra, opprimentes iustum, accipientes munus,et pauperes deprimentes in porta."
,"13":"Ideo prudens in tempore illo tacet, quia tempus malum est."
,"14":"Quaerite bonum et non malum, ut vivatis, ita ut sit Dominus, Deus exercituum, vobiscum, sicut dixistis."
,"15":"Odite malum et diligite bonum,et constituite in porta iudicium, si forte misereatur Dominus, Deus exercituum, reliquiis Ioseph."
,"16":"Propterea haec dicit Dominus, Deus exercituum, dominator: ' In omnibus plateis planctus, et in cunctis viis dicetur: 'Vae, vae!'; et vocabunt agricolam ad luctum,et ad planctum eos, qui sciunt lamentationem."
,"17":"Et in omnibus vineis erit luctus, quia pertransibo in medio tui ', dicit Dominus."
,"18":"Vae desiderantibus diem Domini!,Ad quid vobis dies Domini?,Tenebrae et non lux."
,"19":"Quomodo si fugiat vir a facie leonis, et occurrat ei ursus; et ingrediatur domum,et innitatur manu sua super parietem, et mordeat eum coluber."
,"20":"Numquid non tenebrae dies Domini et non lux?,Et caligo sine splendore in ea?"
,"21":"' Odi, proieci festivitates vestras,et non delector coetibus vestris."
,"22":"Quod si obtuleritis mihi holocautomata, oblationes vestras non suscipiam,et sacrificia pinguium vestrorum non respiciam."
,"23":"Aufer a me tumultum carminum tuorum, et canticum lyrarum tuarum non audiam."
,"24":"Et affluat quasi aqua iudicium, et iustitia quasi torrens perennis."
,"25":"Numquid hostias et oblationes obtulistis mihi in deserto,quadraginta annis, domus Israel?"
,"26":"Et portastis Saccut regem vestrum, et Caivan, imagines vestras, sidus deorum vestrorum, quae fecistis vobis."
,"27":"Et migrare vos faciam trans Damascum ', dicit Dominus; Deus exercituum nomen eius."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Vae, qui tranquilli sunt in Sion,et confidunt in monte Samariae; designati primitiae populorum, ad quos venit domus Israel!"
,"2":"Transite in Chalanne et videte; et ite inde in Emath magnam,et descendite in Geth Palaestinorum. Numquid meliores regnis istis vos, aut latior terminus eorum termino vestro est?"
,"3":"Qui removetis diem malum,et appropinquare facitis solium violentiae."
,"4":"Qui dormiunt in lectis eburneis, recumbentes in stratis suis, comedentes agnos de grege,et vitulos de medio armenti;"
,"5":"canentes ad vocem psalterii, sicut David excogitant sibi vasa cantici;"
,"6":"bibentes vinum in phialis, optimis unguentis delibuti, et non sunt contristati super ruina Ioseph."
,"7":"Quapropter nunc migrabunt in capite transmigrantium, et auferetur factio lascivientium."
,"8":"Iuravit Dominus Deus in anima sua, dicit Dominus, Deus exercituum: ' Detestor ego superbiam Iacob,et domos eius odi,et tradam civitatem et plenitudinem eius '."
,"9":"Quod si reliqui fuerint,decem viri in domo una, et ipsi morientur;"
,"10":"et tollet eum propinquus suus,et comburet eum, ut efferat ossa de domo, et dicet ei, qui in penetralibus domus est: ' Numquid adhuc est penes te? '. Et respondebit: 'Non est'; et dicet ei: 'Tace!'; non est qui recordetur nominis Domini."
,"11":"Quia ecce Dominus mandat,et percutiet domum maiorem ruinis,et domum minorem scissionibus."
,"12":"Numquid currunt in petris equi, aut aratur mare in bobus, quoniam convertistis in venenum iudicium,et fructum iustitiae in absinthium?"
,"13":"Qui laetantur pro Lodabar, qui dicunt: ' Numquid non in fortitudine nostra,cepimus nobis Carnaim? '."
,"14":"' Ecce enim suscitabo super vos, domus Israel, dicit Dominus, Deus exercituum, gentem; et oppriment vos ab introitu Emath,usque ad torrentem Arabae '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Haec ostendit mihi Dominus Deus: et ecce, ipse formabat lo custas in principio, cum germinarent serotinae fruges; et ecce fruges serotinae post fruges demessas regis."
,"2":"Et factum est, cum consummasset comedere herbam terrae, dixi: 'Domine Deus, propitius esto, obsecro; quomodo stabit Iacob, quia parvulus est? '."
,"3":"Misertus est Dominus super hoc. ' Non erit ', dixit Dominus Deus."
,"4":"Haec ostendit mihi Dominus Deus: et ecce, vocabat ad iudicium per ignem Dominus Deus, et devoravit abyssum magnam et comedit simul partem."
,"5":"Et dixi: ' Domine Deus, quiesce, obsecro; quomodo stabit Iacob, quia parvulus est? '."
,"6":"Misertus est Dominus super hoc. ' Sed et istud non erit ', dicit Dominus Deus."
,"7":"Haec ostendit mihi Dominus Deus: ecce vir stans super murum litum, et in manu eius trulla caementarii."
,"8":"Et dixit Dominus ad me: ' Quid tu vides, Amos? '. Et dixi: ' Trullam caementarii '. Et dixit Dominus: 'Ecce ego ponam trullam in medio populi mei Israel; non adiciam ultra ignoscere ei."
,"9":"Et demolientur excelsa Isaac, et sanctuaria Israel desolabuntur, et consurgam super domum Ieroboam in gladio '."
,"10":"Et misit Amasias sacerdos Bethel ad Ieroboam regem Israel dicens: ' Conspiravit contra te Amos in medio domus Israel; non poterit terra sustinere universos sermones eius."
,"11":"Haec enim dicit Amos: 'In gladio morietur Ieroboam, et Israel captivus migrabit de terra sua' '."
,"12":"Et dixit Amasias ad Amos: ' Qui vides, gradere. Fuge in terram Iudae et comede ibi panem et prophetabis ibi;"
,"13":"et in Bethel non adicies ultra ut prophetes, quia sanctuarium regis est, et domus regni est '."
,"14":"Responditque Amos et dixit ad Amasiam: ' Non sum propheta,et non sum filius prophetae; sed armentarius ego sum, vellicans sycomoros."
,"15":"Et tulit me Dominus, cum sequerer gregem, et dixit Dominus ad me: 'Vade, propheta ad populum meum Israel'."
,"16":"Et nunc audi verbum Domini. Tu dicis: 'Non prophetabis super Israel et non stillabis verba super domum Isaac'."
,"17":"Propter hoc haec dicit Dominus: 'Uxor tua in civitate fornicabitur, et filii tui et filiae tuae in gladio cadent, et humus tua funiculo metietur; et tu in terra polluta morieris, et Israel captivus migrabit de terra sua' '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Haec ostendit mihi Dominus Deus: et ecce canistrum pomorum."
,"2":"Et dixit: ' Quid tu vides, Amos? '. Et dixi: ' Canistrum pomorum '. Et dixit Dominus ad me: ' Venit finis super populum meum Israel; non adiciam ultra ignoscere ei."
,"3":"Et lugent cantatrices palatii in die illa, dicit Dominus Deus; multa erunt cadavera, in omni loco proicientur: silentium."
,"4":"Audite hoc, qui conteritis pauperem,et deficere facitis egenos terrae,"
,"5":"dicentes: 'Quando transibit neomenia, et venumdabimus merces?,Et sabbatum, et aperiemus frumentum, ut imminuamus mensuram et augeamus siclum,et supponamus stateras dolosas,"
,"6":"ut possideamus in argento egenos,et pauperem pro calceamentis,et quisquilias frumenti vendamus?'."
,"7":"Iuravit Dominus in superbia Iacob: ' Non obliviscar in perpetuum omnia opera eorum."
,"8":"Numquid super isto non commovebitur terra, et lugebit omnis habitator eius, et ascendet quasi fluvius universa, fervebit et decrescet quasi flumen Aegypti?"
,"9":"Et erit: in die illa, dicit Dominus Deus, occidere faciam solem in meridie,et tenebrescere faciam terram in die luminis"
,"10":"et convertam festivitates vestras in luctum,et omnia cantica vestra in planctum; et inducam super omnes lumbos saccum,et super omne caput calvitium; et ponam eam quasi luctum unigeniti,et novissima eius quasi diem amarum."
,"11":"Ecce dies veniunt, dicit Dominus, et mittam famem in terram; non famem panis neque sitim aquae, sed audiendi verbum Domini '."
,"12":"Et fugient a mari usque ad mare; et ab aquilone usque ad orientem circuibunt, quaerentes verbum Domini, et non invenient."
,"13":"In die illa deficient virgines pulchrae,et adulescentes in siti."
,"14":"Qui iurant in delicto Samariae,et dicunt: ' Vivit Deus tuus, Dan! ',et ' Vivit via, Bersabee! ', et cadent et non resurgent ultra."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Vidi Dominum,stantem super altare, et dixit: 'Percute capitellum, et commoveantur superliminaria; frange eos in capite omnes, et novissimum eorum in gladio interficiam; non fugiet ex eis fugitivus, et non salvabitur superstes eis."
,"2":"Si descenderint usque ad infernum, inde manus mea educet eos; et si ascenderint usque in caelum, inde detraham eos."
,"3":"Et si absconditi fuerint in vertice Carmeli, inde quaeram et auferam eos; et si celaverint se ab oculis meis,in profundo maris, ibi mandabo serpenti, et mordebit eos;"
,"4":"et si abierint in captivitatem,coram inimicis suis, ibi mandabo gladio, et occidet eos, et ponam oculos meos super eos,in malum et non in bonum '."
,"5":"Et Dominus, Deus exercituum, qui tangit terram, et tabescet. Et lugebunt omnes habitantes in ea; et ascendet sicut fluvius ea omnis,et decrescet sicut flumen Aegypti."
,"6":"Qui aedificat in caelo ascensus suos,et cameram suam super terram fundat, qui vocat aquas maris,et effundit eas super faciem terrae; Dominus nomen eius."
,"7":"' Numquid non ut filii Aethiopum,vos estis mihi, filii Israel?, ait Dominus. Numquid non Israel ascendere feci,de terra Aegypti,et Philisthim de Caphtor,et Syros de Cir?"
,"8":"Ecce oculi Domini Dei,super regnum peccans, et conteram illud,a facie terrae; verumtamen conterens non conteram,domum Iacob, dicit Dominus."
,"9":"Ecce enim mandabo ego,et concutiam in omnibus gentibus domum Israel, sicut concutitur triticum in cribro, et non cadet lapillus super terram."
,"10":"In gladio morientur omnes peccatores populi mei, qui dicunt: 'Non appropinquabit et non veniet,super nos malum'."
,"11":"In die illa suscitabo,tabernaculum David, quod cecidit, et reaedificabo rupturas eius; et ea, quae corruerant, instaurabo,et reaedificabo illud sicut diebus antiquis,"
,"12":"ut possideant,reliquias Edom,et omnes nationes, super quas invocatum est nomen meum, dicit Dominus, qui faciet haec."
,"13":"Ecce dies veniunt, dicit Dominus, et comprehendet arator messorem, et calcator uvae mittentem semen; et stillabunt montes mustum, et omnes colles liquefient."
,"14":"Et convertam captivitatem populi mei Israel; et aedificabunt civitates vastatas et inhabitabunt,et plantabunt vineas et bibent vinum earum,et facient hortos et comedent fructus eorum."
,"15":"Et plantabo eos super humum suam, et non evellentur ultra,de terra sua, quam dedi eis ', dicit Dominus Deus tuus."
}`)

}
func LA_NVBSE_LoadVNHAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oraculum, quod vidit Habacuc propheta."
,"2":"Usquequo, Domine, clamabo, et non exaudis?,Vociferabor ad te: ' Violentia! ', et non salvas?"
,"3":"Quare ostendisti mihi iniquitatem,et malitiam vides?,Et vastitas et violentia est coram me, et facta est contentio, et iurgium exoritur."
,"4":"Propter hoc languet lex, et non pervenit usque ad finem iudicium. Quia impius praevalet adversus iustum, propterea egreditur iudicium perversum."
,"5":"' Aspicite in gentibus et videte, admiramini et obstupescite, quia opus facio in diebus vestris, quod nemo credet, cum narrabitur."
,"6":"Quia ecce ego suscitabo Chaldaeos, gentem amaram et velocem, ambulantem super latitudinem terrae, ut possideat tabernacula non sua."
,"7":"Horribilis et terribilis est, ex semetipsa iudicium eius,et maiestas eius egredietur."
,"8":"Leviores pardis equi eius,et saeviores lupis deserti; et accurrunt equites eius: equites namque eius de longe venient, volabunt quasi aquila,festinans ad comedendum."
,"9":"Omnes, ut violentiam faciant, venient, omnes facies eorum ventus urens; et congregabunt quasi arenam captivos."
,"10":"Et ipsa reges subsannabit, tyrannis illudet; ipsa super omnem munitionem ridebit,et comportabit aggerem et capiet eam."
,"11":"Tunc ultra progrediens quasi ventus pertransibit,et constituet fortitudinem suam deum suum '."
,"12":"Numquid non tu a principio, Domine, Deus meus, sanctus meus, qui non morieris?,Domine, ad iudicium posuisti eam; petra mea, ad corripiendum fundasti eam."
,"13":"Mundi sunt oculi tui, ne videas malum; et respicere ad iniquitatem non poteris. Quare respicis super inique agentes et taces, devorante impio iustiorem se?"
,"14":"Fecisti homines quasi pisces maris, quasi reptile non habens principem super se."
,"15":"Omnes in hamo sublevat, trahit eos in sagena sua,et congregat in rete suo; super hoc laetatur et exsultat."
,"16":"Propterea immolat sagenae suae,et sacrificat reti suo, quia in ipsis incrassata est portio eius, et cibus eius pinguis."
,"17":"Propter hoc ergo evaginabit gladium suum semper, ut interficiat gentes sine misericordia?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Super custodiam meam stabo,et consistam super speculam,et contemplabor, ut videam quid dicat mihi,et quid respondeat ad querelam meam."
,"2":"Et respondit mihi Dominus et dixit: ' Scribe visum,et explana eum super tabulas, ut percurrat, qui legerit eum."
,"3":"Quia adhuc visus ad tempus constitutum, sed anhelat in finem et non mentietur; si moram fecerit, exspecta illum, quia veniens veniet et non tardabit."
,"4":"Ecce languidus, in quo non est anima recta; iustus autem in fide sua vivet '."
,"5":"Et profecto divitiae decipiunt virum superbum, et non perveniet ad finem; qui dilatat quasi infernus fauces suas,et ipse quasi mors et non adimpletur: et congregat ad se omnes gentes,et coacervat ad se omnes populos."
,"6":"Numquid non omnes isti super eum parabolam sument,et loquelam aenigmatum dicentes: ' Vae ei, qui multiplicat non sua - usquequo? C,et aggravat pignora super se! '."
,"7":"Numquid non repente consurgent, qui mordeant te, et evigilabunt agitantes te, et eris in rapinam eis?"
,"8":"Quia tu spoliasti gentes multas, spoliabunt te omnes, qui reliqui fuerint de populis; propter sanguinem hominum et oppressionem terrae, civitatum et omnium habitantium in eis."
,"9":"Vae, qui congregat lucrum iniustum in malum domui suae, ut ponat in excelso nidum suum,et salvet se de manu mali!"
,"10":"Consilium cepisti in confusionem domui tuae,concidendi populos multos,et peccasti in animam tuam."
,"11":"Quia lapis de pariete clamabit, et trabes de contignatione respondebit ei."
,"12":"Vae, qui aedificat civitatem in sanguinibus,et condit urbem in iniquitate!"
,"13":"Numquid non haec a Domino sunt exercituum, ut laborent populi pro igne, et gentes in vacuum fatigentur?"
,"14":"Quia replebitur terra cognitione gloriae Domini, sicut aquae operiunt mare."
,"15":"Vae, qui potum dat amico suo,mittens venenum suum et inebrians eum, ut aspiciat nuditatem eius!"
,"16":"Repleris ignominia pro gloria; bibe tu quoque et denudare!,Transibit ad te calix dexterae Domini, et veniet ignominia super gloriam tuam."
,"17":"Quia vastitas Libani operiet te, et miseria animalium deterrebit te,propter sanguinem hominum et oppressionem terrae, civitatum et omnium habitantium in eis."
,"18":"Quid prodest sculptile, quia sculpsit illud fictor suus; conflatile et oraculum mendax, quia speravit in figmento fictor eius, ut faceret simulacra muta?"
,"19":"Vae, qui dicit ligno: ' Expergiscere! ', ' Surge! ' lapidi tacenti!,Numquid ipse docere poterit?,Ecce iste coopertus est auro et argento, et omnis spiritus non est in visceribus eius."
,"20":"Dominus autem in templo sancto suo; sileat a facie eius omnis terra."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Oratio Habacuc prophetae. Secundum melodiam lamentationum."
,"2":"Domine, audivi auditionem tuam,et timui, Domine, opus tuum. In medio annorum vivifica illud, in medio annorum notum facies. Cum iratus fueris, misericordiae recordaberis."
,"3":"Deus a Theman veniet, et Sanctus de monte Pharan. - Selah. Operit caelos gloria eius, et laudis eius plena est terra."
,"4":"Splendor eius ut lux erit, radii ex manibus eius: ibi abscondita est fortitudo eius."
,"5":"Ante faciem eius ibit mors, et egredietur pestis post pedes eius. "
,"6":"Stetit et concussit terram, aspexit et dissolvit gentes. Et contriti sunt montes saeculi, incurvati sunt colles antiqui,ab itineribus aeternitatis eius."
,"7":"In afflictione vidi tentoria Chusan; turbantur pelles terrae Madian."
,"8":"Numquid in fluminibus iratus es, Domine, aut in fluminibus furor tuus,vel in mari indignatio tua?,Quia ascendes super equos tuos, quadrigas tuas victrices."
,"9":"Suscitans suscitabis arcum tuum, sagittis replevisti pharetram tuam. - Selah. In fluvios scindes terram,"
,"10":"viderunt te et doluerunt montes. Effuderunt aquas nubes, dedit abyssus vocem suam, in altum levavit manus suas."
,"11":"Sol et luna steterunt in habitaculo suo, prae luce sagittarum tuarum discedunt, prae splendore fulgurantis hastae tuae."
,"12":"In fremitu calcabis terram, in furore conteres gentes."
,"13":"Egressus es in salutem populi tui, in salutem cum christo tuo. Percussisti caput de domo impii, denudasti fundamentum usque ad petram. - Selah."
,"14":"Confodisti iaculis tuis caput bellatorum eius, venientium ut turbo ad dispergendum me; exsultatio eorum, sicut eius, qui devorat pauperem in abscondito. "
,"15":"Viam fecisti in mari equis tuis, in luto aquarum multarum."
,"16":"Audivi, et conturbatus est venter meus, ad vocem contremuerunt labia mea. Ingreditur putredo in ossibus meis, et subter me vacillant gressus mei. Conquiescam in die tribulationis, ut ascendat super populum, qui invadit nos."
,"17":"Ficus enim non florebit, et non erit fructus in vineis; mentietur opus olivae, et arva non afferent cibum; abscissum est de ovili pecus, et non est armentum in praesepibus."
,"18":"Ego autem in Domino gaudebo,et exsultabo in Deo salvatore meo. "
,"19":"Dominus Deus fortitudo mea,et ponet pedes meos quasi cervorum et super excelsa mea deducet me. Magistro chori. Ad sonitum chordarum."
}`)

}
func LA_NVBSE_LoadVNILChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Verbum Domini, quod factum est ad loel filium Phatuel."
,"2":"Audite hoc, senes, et auribus percipite, omnes habitatores terrae, si factum est istud in diebus vestris,aut in diebus patrum vestrorum."
,"3":"Super hoc filiis vestris narrate, et filii vestri filiis suis, et filii eorum generationi alterae."
,"4":"Residuum erucae comedit locusta, et residuum locustae comedit bruchus, et residuum bruchi comedit gryllus."
,"5":"Expergiscimini, ebrii, et flete, et ululate, omnes, qui bibitis vinum, propter mustum, quoniam periit ab ore vestro."
,"6":"Gens enim ascendit super terram meam,fortis et innumerabilis; dentes eius ut dentes leonis, et molares leaenae sunt ei."
,"7":"Posuit vineam meam in desertum,et ficum meam in lignum confractum; nudans spoliavit eam et proiecit, albi facti sunt rami eius."
,"8":"Plange, quasi virgo accincta sacco,super virum pubertatis suae."
,"9":"Periit oblatio et libatio,de domo Domini; luxerunt sacerdotes,ministri Domini."
,"10":"Depopulata est regio; luxit humus, quoniam devastatum est triticum, defecit mustum, elanguit oleum."
,"11":"Confundemini, agricolae, ululate, vinitores, super frumento et hordeo, quia periit messis agri."
,"12":"Vinea exaruit, et ficus elanguit, malogranatum et palma et malum,et omnia ligna agri aruerunt, quia evanuit gaudium,a filiis hominum."
,"13":"Accingite vos et plangite, sacerdotes; ululate, ministri altaris. Ingredimini, cubate in sacco, ministri Dei mei, quoniam interiit de domo Dei vestri,oblatio et libatio."
,"14":"Sanctificate ieiunium, vocate coetum, congregate senes, omnes habitatores terrae,in domum Dei vestri, et clamate ad Dominum:"
,"15":"' Heu diei!,Quia prope est dies Domini, et quasi vastitas a potente veniet."
,"16":"Numquid non coram oculis vestris,alimenta perierunt, de domo Dei nostri,laetitia et exsultatio?'."
,"17":"Computruerunt semina,subtus glebas suas, demolita sunt horrea, dissipatae sunt apothecae, eo quod exaruit triticum."
,"18":"Quid ingemuit animal, perterrita sunt armenta boum, quia non est pascua eis?,Sed et greges pecorum disperierunt."
,"19":"Ad te, Domine, clamo, quia ignis comedit,pascua deserti, et flamma succendit,omnia ligna agri."
,"20":"Sed et bestiae agri,suspirant ad te, quoniam exsiccati sunt fontes aquarum, et ignis devoravit,pascua deserti."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Canite tuba in Sion, ululate in monte sancto meo; conturbentur omnes habitatores terrae, quia venit dies Domini, quia prope est."
,"2":"Dies tenebrarum et caliginis, dies nubis et turbinis; quasi aurora expansa super montes,populus multus et fortis: similis ei non fuit a principio, et post eum non erit,usque in annos generationis et generationis."
,"3":"Ante faciem eius ignis vorat, et post eum exurit flamma. Quasi hortus Eden terra coram eo, et post eum solitudo deserti; neque est quod effugiat eum."
,"4":"Quasi aspectus equorum aspectus eorum, et quasi equites sic current."
,"5":"Sicut sonitus quadrigarum,super capita montium exsiliunt, sicut sonitus flammae ignis,devorantis stipulam, velut populus fortis,praeparatus ad proelium."
,"6":"A facie eius cruciabuntur populi, omnes vultus candentes."
,"7":"Sicut fortes currunt, quasi viri bellatores ascendunt murum; unusquisque in viis suis graditur, et non declinant a semitis suis."
,"8":"Unusquisque fratrem suum non coarctat, singuli in calle suo ambulant, per media tela prorumpunt,sine intermissione."
,"9":"Urbem ingrediuntur, in murum discurrunt, domos conscendunt, per fenestras intrant quasi fur."
,"10":"A facie eius contremuit terra, moti sunt caeli, sol et luna obtenebrati sunt, et stellae retraxerunt splendorem suum."
,"11":"Et Dominus dedit vocem suam ante faciem exercitus sui, quia multa sunt nimis castra eius, quia fortia et facientia verbum eius; magnus enim dies Domini,et terribilis valde, et quis sustinebit eum?"
,"12":"' Nunc ergo, dicit Dominus, convertimini ad me in toto corde vestro, in ieiunio et in fletu et in planctu;"
,"13":"et scindite corda vestra et non vestimenta vestra, et convertimini ad Dominum Deum vestrum, quia benignus et misericors est, patiens et multae misericordiae,et placabilis super malitia '."
,"14":"Quis scit, si convertatur et ignoscat,et relinquat post se benedictionem, oblationem et libationem,Domino Deo vestro?"
,"15":"Canite tuba in Sion, sanctificate ieiunium, vocate coetum; congregate populum, sanctificate conventum, coadunate senes,"
,"16":"congregate parvulos et sugentes ubera, egrediatur sponsus de cubili suo, et sponsa de thalamo suo."
,"17":"Inter vestibulum et altare plorent,sacerdotes ministri Domini,et dicant: 'Parce, Domine, populo tuo,et ne des hereditatem tuam in opprobrium, ut dominentur eis nationes '. Quare dicent in populis: ' Ubi est Deus eorum '?"
,"18":"Zelatus est Dominus terram suam,et pepercit populo suo."
,"19":"Et respondit Dominus et dixit populo suo: ' Ecce ego mittam vobis,frumentum et vinum et oleum, et replebimini eis; et non dabo vos ultra,opprobrium in gentibus."
,"20":"Et eum, qui ab aquilone est, procul faciam a vobis,et expellam eum in terram,inviam et desertam: facies eius contra mare orientale, et extremum eius ad mare occidentale; et ascendet foetor eius, et ascendet putredo eius, quia magna operatus est."
,"21":"Noli timere, terra; exsulta et laetare, quoniam magna Dominus operatus est."
,"22":"Nolite timere, animalia regionis, quia germinaverunt pascua deserti, quia lignum attulit fructum suum, ficus et vinea dederunt divitias suas."
,"23":"Et, filii Sion, exsultate,et laetamini in Domino Deo vestro, quia dedit vobis,pluviam iustitiae,et descendere fecit ad vos,imbrem matutinum et serotinum sicut prius."
,"24":"Et implebuntur areae frumento, et redundabunt torcularia,vino et oleo;"
,"25":"et reddam vobis annos, quos comedit locusta, bruchus,et gryllus et eruca, exercitus meus magnus, quem misi in vos."
,"26":"Et comedetis vescentes et saturabimini,et laudabitis nomen Domini Dei vestri, qui mirabilia fecit vobiscum; et non confundetur populus meus in sempiternum."
,"27":"Et scietis quia in medio Israel ego sum, et ego Dominus Deus vester, et non est amplius; et non confundetur populus meus in aeternum '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et erit post haec: effundam spiritum meum super omnem carnem, et prophetabunt filii vestri et filiae vestrae, senes vestri somnia somniabunt, et iuvenes vestri visiones videbunt;"
,"2":"sed et super servos meos et ancillas,in diebus illis effundam spiritum meum."
,"3":"Et dabo prodigia in caelo et in terra, sanguinem et ignem et columnas fumi;"
,"4":"sol convertetur in tenebras, et luna in sanguinem, antequam veniat dies Domini,magnus et horribilis."
,"5":"Et erit: omnis, qui invocaverit nomen Domini, salvus erit, quia in monte Sion et in Ierusalem,erit salvatio, sicut dixit Dominus, et in residuis, quos Dominus vocaverit."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quia ecce in diebus illis,et in tempore illo, cum convertero sortem,Iudae et Ierusalem,"
,"2":"congregabo omnes gentes,et deducam eas in vallem Iosaphat,et disceptabo cum eis ibi,super populo meo et hereditate mea Israel, quos disperserunt in nationibus, et terram meam diviserunt."
,"3":"Et super populum meum miserunt sortem; et dederunt puerum pro meretrice,et puellam vendiderunt pro vino, ut biberent."
,"4":"Verum quid vobis et mihi, Tyrus et Sidon et omnes termini Philisthaeae? Numquid ultionem vos reddetis mihi? Et si ulciscimini vos contra me, cito velociter reddam ultionem vestram super caput vestrum."
,"5":"Argentum enim meum et aurum tulistis et pretiosa bona mea intulistis in delubra vestra."
,"6":"Et filios Iudae et filios Ierusalem vendidistis filiis Graecorum, ut longe faceretis eos de finibus suis."
,"7":"Ecce ego suscitabo eos de loco, in quo vendidistis eos, et reddam ultionem vestram in caput vestrum."
,"8":"Et vendam filios vestros et filias vestras in manibus filiorum Iudae; et venumdabunt eos Sabaeis, genti longinquae, quia Dominus locutus est."
,"9":"Clamate hoc in gentibus, sanctificate bellum, suscitate robustos; accedant, ascendant,omnes viri bellatores."
,"10":"Concidite vomeres vestros in gladios,et falces vestras in lanceas; infirmus dicat: ' Fortis ego sum '."
,"11":"Erumpite et venite, omnes gentes de circuitu, et congregamini ibi!,Deduc, Domine, robustos tuos!"
,"12":"Consurgant et ascendant gentes,in vallem Iosaphat, quia ibi sedebo, ut iudicem,omnes gentes in circuitu."
,"13":"Mittite falces, quoniam maturavit messis; venite et premite, quia plenum est torcular: exuberant torcularia, quia magna est malitia eorum."
,"14":"Populi, populi,in valle Decisionis, quia iuxta est dies Domini,in valle Decisionis."
,"15":"Sol et luna obtenebrati sunt, et stellae retraxerunt splendorem suum."
,"16":"Et Dominus de Sion rugiet,et de Ierusalem dabit vocem suam; et movebuntur caeli et terra, et Dominus refugium populo suo,et fortitudo filiis Israel."
,"17":"Et scietis quia ego Dominus Deus vester,habitans in Sion monte sancto meo; et erit Ierusalem locus sanctus, et alieni non transibunt per eam amplius."
,"18":"Et erit in die illa: stillabunt montes mustum, et colles fluent lacte; et per omnes rivos Iudae ibunt aquae, et fons de domo Domini egredietur,et irrigabit torrentem Settim."
,"19":"Aegyptus in desolationem erit, et Idumaea in desertum desolationis, pro eo quod inique egerint in filios Iudae,et effuderint sanguinem innocentem in terra eorum."
,"20":"Et Iuda in aeternum habitabitur, et Ierusalem in generationem et generationem;"
,"21":"et vindicabo sanguinem eorum, quem non relinquam impunitum; et Dominus commoratur in Sion."
}`)

}
func LA_NVBSE_LoadVNINChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Et factum est verbum Domini ad Ionam filium Amathi dicens:"
,"2":"' Surge et vade in Nineven civitatem grandem et praedica in ea, quia ascendit malitia eius coram me '."
,"3":"Et surrexit Ionas, ut fugeret in Tharsis a facie Domini; et descendit Ioppen et invenit navem euntem in Tharsis et dedit naulum eius et descendit in eam, ut iret cum eis in Tharsis a facie Domini."
,"4":"Dominus autem misit ventum magnum in mare, et facta est tempestas magna in mari, et navis periclitabatur conteri."
,"5":"Et timuerunt nautae et clamaverunt unusquisque ad deum suum et miserunt vasa, quae erant in navi, in mare, ut alleviaretur ab eis. Ionas autem descenderat ad interiora navis et, cum recubuisset, dormiebat sopore gravi."
,"6":"Et accessit ad eum gubernator et dixit ei: ' Quid? Tu sopore deprimeris? Surge, invoca Deum tuum, si forte recogitet Deus de nobis, et non pereamus '."
,"7":"Et dixit unusquisque ad collegam suum: ' Venite, et mittamus sortes, ut sciamus quare hoc malum sit nobis '. Et miserunt sortes, et cecidit sors super Ionam."
,"8":"Et dixerunt ad eum: ' Indica nobis cuius causa malum istud sit nobis. Quod est opus tuum, et unde venis? Quae terra tua, et ex quo populo es tu? '."
,"9":"Et dixit ad eos: ' Hebraeus ego sum et Dominum, Deum caeli, ego timeo, qui fecit mare et aridam '."
,"10":"Et timuerunt viri timore magno et dixerunt ad eum: ' Quid hoc fecisti? '. Cognoverant enim viri quod a facie Domini fugeret, quia indicaverat eis."
,"11":"Et dixerunt ad eum: ' Quid faciemus tibi, ut conticescat mare a nobis? '. Mare enim magis ac magis intumescebat."
,"12":"Et dixit ad eos: ' Tollite me et mittite in mare, et cessabit mare a vobis; scio enim ego quoniam propter me tempestas haec grandis super vos '."
,"13":"Et remigabant viri, ut reverterentur ad aridam; et non valebant, quia mare magis intumescebat super eos."
,"14":"Et clamaverunt ad Dominum et dixerunt: ' Quaesumus, Domine, ne pereamus in anima viri istius, et ne des super nos sanguinem innocentem; quia tu, Domine, sicut voluisti, fecisti '."
,"15":"Et tulerunt Ionam et miserunt in mare; et stetit mare a fervore suo."
,"16":"Et timuerunt viri timore magno Dominum et immolaverunt hostias Domino et voverunt vota."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et praeparavit Dominus piscem grandem, ut deglutiret Ionam; et erat Ionas in ventre piscis tribus diebus et tribus noctibus."
,"2":"Et oravit Ionas ad Dominum Deum suum de ventre piscis"
,"3":"et dixit: ' Clamavi de tribulatione mea ad Dominum, et respondit mihi; de ventre inferi clamavi, et exaudisti vocem meam."
,"4":"Et proiecisti me in profundum in corde maris, et flumen circumdedit me; omnes gurgites tui et fluctus tui,super me transierunt."
,"5":"Et ego dixi: 'Abiectus sum,a conspectu oculorum tuorum; verumtamen rursus videbo,templum sanctum tuum'."
,"6":"Circumdederunt me aquae usque ad guttur, abyssus vallavit me, iuncus alligatus est capiti meo."
,"7":"Ad extrema montium descendi, terrae vectes concluserunt me in aeternum, sed eduxisti de fovea vitam meam, Domine Deus meus."
,"8":"Cum angustiaretur in me anima mea, Domini recordatus sum, et venit ad te oratio mea, ad templum sanctum tuum."
,"9":"Qui colunt idola vana, pietatem suam derelinquunt;"
,"10":"ego autem in voce laudis,immolabo tibi, quaecumque vovi, reddam; salus Domini est '."
,"11":"Et dixit Dominus pisci, et evomuit Ionam in aridam."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et factum est verbum Domini ad Ionam secundo dicens:"
,"2":"' Surge, vade in Nineven civitatem magnam et praedica in ea praedicationem, quam ego loquor ad te '."
,"3":"Et surrexit Ionas et abiit in Nineven iuxta verbum Domini. Et Nineve erat civitas magna coram Deo, itinere trium dierum. "
,"4":"Et coepit Ionas introire in civitatem itinere diei unius; et clamavit et dixit: ' Adhuc quadraginta dies, et Nineve subvertetur '."
,"5":"Et crediderunt viri Ninevitae in Deo; et praedicaverunt ieiunium et vestiti sunt saccis a maiore usque ad minorem."
,"6":"Et pervenit verbum ad regem Nineve; et surrexit de solio suo et abiecit pallium suum a se et indutus est sacco et sedit in cinere."
,"7":"Et clamavit et dixit in Nineve decreto regis et principum eius dicens: ' Homines et iumenta et boves et pecora non gustent quidquam nec pascantur et aquam non bibant;"
,"8":"et operiantur saccis homines et iumenta et clament ad Deum in fortitudine, et convertatur vir a via sua mala et a violentia, quae est in manibus eorum."
,"9":"Quis scit si convertatur et ignoscat Deus et revertatur a furore irae suae, et non peribimus? '."
,"10":"Et vidit Deus opera eorum, quia conversi sunt de via sua mala; et misertus est Deus super malum, quod lo cutus fuerat ut faceret eis, et,non fecit. "
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et afflictus est Ionas afflictione magna et iratus est;"
,"2":"et oravit ad Dominum et dixit: ' Obsecro, Domine, numquid non hoc est verbum meum, cum adhuc essem in terra mea? Propter hoc praeoccupavi ut fugerem in Tharsis. Sciebam enim quia tu Deus clemens et misericors es, longanimis et multae miserationis et ignoscens super malitia."
,"3":"Et nunc, Domine, tolle, quaeso, animam meam a me, quia melior est mihi mors quam vita'."
,"4":"Et dixit Dominus: ' Putasne bene irasceris tu? '."
,"5":"Et egressus est Ionas de civitate et sedit contra orientem civitatis et fecit sibimet umbraculum ibi et sedebat subter illud in umbra, donec videret quid accideret in civitate."
,"6":"Et praeparavit Dominus Deus hederam, et ascendit super Ionam, ut esset umbra super caput eius et protegeret eum ab afflictione sua. Et laetatus est Ionas super hedera laetitia magna."
,"7":"Et paravit Deus vermem, cum surgeret aurora in crastinum, et percussit hederam, quae exaruit."
,"8":"Et, cum ortus fuisset sol, praecepit Deus vento orientali calido; et percussit sol super caput Ionae, et elanguit; et petivit animae suae, ut moreretur, et dixit: ' Melius est mihi mori quam vivere '"
,"9":"Et dixit Deus ad Ionam: ' Putasne bene irasceris tu super hedera? '. Et dixit: ' Bene irascor ego usque ad mortem '."
,"10":"Et dixit Dominus: ' Tu doles super hederam, in qua non laborasti neque fecisti, ut cresceret, quae sub una nocte nata est et sub una nocte periit."
,"11":"Et ego non parcam Nineve civitati magnae, in qua sunt plus quam centum viginti milia hominum, qui nesciunt quid sit inter dexteram et sinistram suam, et iumenta multa? '."
}`)

}
func LA_NVBSE_LoadVNMIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Verbum Domini, quod factum est ad Michaeam Morasthiten in diebus Ioatham, Achaz, Ezechiae regum Iudae, quod vidit super Samariam et Ierusalem."
,"2":"Audite, populi omnes, et attendat terra et plenitudo eius; et sit Dominus Deus vobis in testem, Dominus de templo sancto suo."
,"3":"Quia ecce Dominus egreditur de loco suo,et descendet et calcabit,super excelsa terrae;"
,"4":"et liquescent montes subtus eum, et valles scindentur,sicut cera a facie ignis, sicut aquae, quae decurrunt in praeceps."
,"5":"In scelere Iacob omne istud,et in peccatis domus Israel. Quod scelus Iacob?,Nonne Samaria?,Et quae excelsa Iudae?,Nonne Ierusalem?"
,"6":"Et ponam Samariam in acervum lapidum, in agrum, ubi plantatur vinea; et detraham in vallem lapides eius,et fundamenta eius revelabo."
,"7":"Et omnia sculptilia eius concidentur, et omnes mercedes eius comburentur igne, et omnia idola eius ponam in perditionem, quia de mercedibus meretricis congregata sunt,et usque ad mercedem meretricis revertentur."
,"8":"Super hoc plangam et ululabo; vadam spoliatus et nudus, faciam planctum velut thoum,et luctum quasi struthionum,"
,"9":"quia desperata est plaga eius, quia venit usque ad Iudam, tetigit portam populi mei,usque ad Ierusalem."
,"10":"In Geth nolite annuntiare, lacrimis ne ploretis, in Bethleaphra in pulvere volutamini."
,"11":"Et transite vobis, habitatores Saphir, confusi ignominia; non sunt egressi habitatores Saanan. Planctus Bethesel,auferet a vobis mansionem suam."
,"12":"Profecto trement de bono,habitatores Maroth, quia descendit malum a Domino,in portam Ierusalem."
,"13":"Iungite quadrigae equos, habitatores Lachis; principium peccati est filiae Sion, quia in te inventa sunt scelera Israel."
,"14":"Propterea dabis dimissionem,super Moresethgeth. Domus Achzib in deceptionem,regibus Israel."
,"15":"Adhuc expugnatorem adducam tibi, quae habitas in Maresa; usque Odollam veniet,gloria Israel."
,"16":"Decalvare et tondere,super filios deliciarum tuarum; dilata calvitium tuum sicut aquila, quoniam captivi ducti sunt ex te."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Vae, qui cogitant iniquitatem,et operantur malum in cubilibus suis!,In luce matutina faciunt illud, quoniam est in potestate manus eorum."
,"2":"Concupiscunt agros, et violenter tollunt, domos, et rapiunt. Et opprimunt virum et domum eius, hominem et hereditatem eius."
,"3":"Idcirco haec dicit Dominus: ' Ecce ego cogito,super familiam istam malum, unde non auferetis,colla vestra; et non ambulabitis erecti, quoniam tempus pessimum est."
,"4":"In die illa,sumetur super vos parabola, et assumetur lamentum dicentium: 'Depopulatione vastati sumus; pars populi mei commutatur, quam nemo ei restituet; infideli regiones nostrae dividuntur'."
,"5":"Propter hoc non erit tibi,mittens funiculum sortis,in coetu Domini '."
,"6":"' Ne vaticinemini! '. ' Vaticinentur, non vaticinentur de his, non cedet confusio! '."
,"7":"Numquid maledicta est domus Iacob?,Numquid abbreviatus est spiritus Domini, aut tales sunt actiones eius?,Nonne verba eius bona sunt,cum eo, qui recte graditur?"
,"8":"Vos autem contra populum meum,ut adversarium consurgitis. Desuper tunica pallium tollitis ei; qui transibant fiducialiter, fiunt quasi bello capti."
,"9":"Mulieres populi mei eicitis,de domo deliciarum suarum; a parvulis earum aufertis,decorem meum in perpetuum."
,"10":"' Surgite et ite, quia non habetis hic requiem! '. Propter immunditiam peribitis,perditione pessima."
,"11":"Si esset vir vento excitatus,et mendacium loqueretur: ' Vaticinabor tibi de vino et sicera ', hic esset vates populi istius."
,"12":"Congregatione congregabo, Iacob, totum te; in unum conducam reliquias Israel, pariter ponam illum quasi gregem in ovili, quasi pecus in medio pascuae; et tumultuabuntur a multitudine hominum."
,"13":"Ascendet enim pandens iter ante eos; erumpent et transibunt portam, egredientur per eam. Et transibit rex eorum coram eis, et Dominus in capite eorum."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et dixi: ' Audite, principes Iacob,et duces domus Israel: Numquid non vestrum est scire iudicium? '."
,"2":"Sed odio habetis bonum et diligitis malum. Violenter tollitis pelles eorum desuper eos,et carnem eorum desuper ossibus eorum."
,"3":"Qui comedunt carnem populi mei,et pellem eorum desuper excoriant; et ossa eorum confringunt,et secant sicut carnem assam in lebete,et quasi carnem in medio ollae."
,"4":"Tunc clamabunt ad Dominum, et non exaudiet eos,et abscondet faciem suam ab eis,in tempore illo, sicut pessima fecerunt opera sua."
,"5":"Haec dicit Dominus super prophetas, qui seducunt populum meum, qui cum habent, quid mordeant dentibus suis, praedicant pacem; et, si quis non dederit in ore eorum quippiam, sanctificant super eum proelium."
,"6":"Propterea nox vobis sine visione erit, et tenebrae vobis sine divinatione; et occumbet sol super prophetas, et obtenebrabitur super eos dies."
,"7":"Et confundentur videntes, et confundentur divini, et operient labia sua omnes, quia non est responsum Dei."
,"8":"Verumtamen ego repletus sum,fortitudine spiritus Domini, iudicio et virtute, ut annuntiem Iacob scelus suum,et Israel peccatum suum."
,"9":"Audite hoc, principes domus Iacob,et iudices domus Israel, qui abominamini iudicium,et omnia recta pervertitis,"
,"10":"qui aedificatis Sion in sanguinibus,et Ierusalem in iniquitate."
,"11":"Principes eius in muneribus iudicant, et sacerdotes eius in mercede docent, et prophetae eius in pecunia divinant; et super Dominum requiescunt dicentes: ' Numquid non Dominus in medio nostrum?,Non venient super nos mala '."
,"12":"Propter hoc causa vestri,Sion quasi ager arabitur, et Ierusalem quasi acervus lapidum erit, et mons templi in excelsa silvarum."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et erit in novissimis diebus: Erit mons domus Domini,praeparatus in vertice montium,et sublimis super colles; et fluent ad eum populi."
,"2":"Et properabunt gentes multae et dicent: ' Venite, ascendamus ad montem Domini,et ad domum Dei Iacob, et docebit nos de viis suis, et ibimus in semitis eius '; quia de Sion egredietur lex, et verbum Domini de Ierusalem."
,"3":"Et iudicabit inter populos multos,et decernet gentibus fortibus usque in longinquum; et concident gladios suos in vomeres,et hastas suas in falces; non sumet gens adversus gentem gladium, et non discent ultra belligerare."
,"4":"Et sedebit unusquisque subtus vitem suam,et subtus ficum suam, et non erit qui deterreat; quia os Domini exercituum locutum est."
,"5":"Quia omnes populi ambulabunt,unusquisque in nomine dei sui; nos autem ambulabimus in nomine Domini,Dei nostri in aeternum et ultra."
,"6":"' In die illa, dicit Dominus, congregabo claudicantem, et eam, quam eieceram, colligam,et quam afflixeram;"
,"7":"et ponam claudicantem in reliquias,et eam, quae laboraverat, in gentem robustam '. Et regnabit Dominus super eos in monte Sion,ex hoc nunc et usque in aeternum."
,"8":"Et tu, turris gregis, collis filiae Sion, usque ad te veniet et perveniet,potestas prima, regnum filiae Ierusalem."
,"9":"Nunc quare clamas clamore magno?,Numquid rex non est in te, aut consiliarius tuus periit, quia comprehendit te dolor sicut parturientem?"
,"10":"Dole et satage, filia Sion, quasi parturiens; quia nunc egredieris de civitate,et habitabis in campo,et venies usque ad Babylonem; ibi liberaberis, ibi redimet te Dominus,de manu inimicorum tuorum."
,"11":"Nunc autem congregatae sunt super te,gentes multae, quae dicunt: 'Profanetur, et aspiciat in Sion oculus noster '."
,"12":"Ipsi autem non cognoverunt,cogitationes Domini,et non intellexerunt consilium eius, quia congregavit eos quasi manipulos in area."
,"13":"Surge et tritura, filia Sion, quia cornu tuum ponam ferreum,et ungulas tuas ponam aereas, et comminues populos multos,et vovebis Domino rapinas eorum,et divitias eorum Domino universae terrae."
,"14":"Nunc incide te, filia incisionis!,Obsidionem posuerunt super nos; in virga percutiunt,maxillam iudicis Israel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Sed tu, Bethlehem Ephratha, parvulus in milibus Iudae, ex te mihi egredietur, qui sit dominator in Israel; et egressus eius a temporibus antiquis, a diebus aeternitatis."
,"2":"Propter hoc dabit eos,usque ad tempus, in quo parturiens pariet; et reliquiae fratrum eius,convertentur ad filios Israel."
,"3":"Et stabit et pascet in fortitudine Domini, in sublimitate nominis Domini Dei sui; et habitabunt secure, quia nunc magnus erit,usque ad terminos terrae,"
,"4":"et erit iste pax. Assyrius cum venerit in terram nostram,et quando calcaverit in domibus nostris, suscitabimus super eum septem pastores,et octo primates hominum."
,"5":"Et pascent terram Assyriae in gladio et terram Nemrod in lanceis; et liberabit ab Assyrio, cum venerit in terram nostram,et cum calcaverit in finibus nostris."
,"6":"Et erunt reliquiae Iacob,in medio populorum multorum,quasi ros a Domino,et quasi imbres super herbam, quae non exspectat virum,et non praestolatur filios homi num. "
,"7":"Et erunt reliquiae Iacob in gentibus, in medio populorum multorum, quasi leo in iumentis silvarum,et quasi catulus leonis in gregibus pecorum; qui cum transierit et conculcaverit et ceperit, non est qui eruat."
,"8":"Exaltabitur manus tua super hostes tuos, et omnes inimici tui interibunt."
,"9":"'Et erit in die illa, dicit Dominus, auferam equos tuos de medio tui,et disperdam quadrigas tuas"
,"10":"et perdam civitates terrae tuae,et destruam omnes munitiones tuas."
,"11":"Et auferam veneficia de manu tua, et divini non erunt in te."
,"12":"Et perire faciam sculptilia tua,et lapides tuos de medio tui, et non adorabis ultra,opera manuum tuarum;"
,"13":"et evellam palos tuos de medio tui,et conteram idola tua."
,"14":"Et faciam in furore,et in indignatione ultionem,in omnibus gentibus, quae non audierunt '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Audite, quae Dominus loqui tur: ' Surge, contende iudicio coram montibus, et audiant colles vocem tuam '."
,"2":"Audite, montes, iudicium Domini, et auscultate, fundamenta terrae; quia iudicium Domini cum populo suo, et cum Israel iudicio contendit."
,"3":"' Popule meus, quid feci tibi,et quid molestus fui tibi?,Responde mihi."
,"4":"Ego eduxi te de terra Aegypti,et de domo servientium liberavi te,et misi ante faciem tuam Moysen,et Aaron et Mariam."
,"5":"Popule meus, memento, quaeso, quid cogitaverit Balac rex Moab, et quid responderit ei Balaam filius Beor, de Settim usque ad Galgalam, ut cognoscas iustitias Domini '."
,"6":"' Quid dignum offeram Domino, dum curvo genu Deo excelso?,Numquid offeram ei holocautomata,et vitulos anniculos?"
,"7":"Numquid placebunt Domino milia arietum, multa milia torrentium olei?,Numquid dabo primogenitum meum pro scelere meo, fructum ventris mei pro peccato animae meae?'."
,"8":"Indicatum est tibi, o homo, quid sit bonum, et quid Dominus quaerat a te: utique facere iudicium et diligere caritatem,et sollicitum ambulare cum Deo tuo."
,"9":"Vox Domini ad civitatem clamat,- et sapientia est timere nomen tuum -: ' Audite, tribus et coetus civitatis!"
,"10":"Numquid tolerabo batum iniquum,et ephi minus maledictum?"
,"11":"Numquid iustificabo stateram impiam,et saccelli pondera dolosa?"
,"12":"Quia divites eius repleti sunt iniquitate, et habitantes in ea loquebantur mendacium, et lingua eorum fraudulenta in ore eorum."
,"13":"Ego ergo coepi percutere te,perditione super peccatis tuis."
,"14":"Tu comedes et non saturaberis, et sordes tuae in medio tui. Tu removebis et non salvabis; et, quos salvaveris, in gladium dabo. "
,"15":"Tu seminabis et non metes, tu calcabis olivam et non ungeris oleo, mustum et non bibes vinum."
,"16":"Custodisti praecepta Amri,et omne opus domus Achab; et ambulasti in voluntatibus eorum, ut darem te in perditionem,et habitantes tuos in sibilum: et opprobrium populorum portabitis '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Vae mihi, quia factum est mihi,sicut congregata messe, sicut collecta vindemia!,Non est botrus ad comedendum, nec praecoqua ficus, quam desideravit anima mea."
,"2":"Periit pius de terra, et rectus in hominibus non est; omnes in sanguine insidiantur, vir fratrem suum rete venatur."
,"3":"Ad malum manus eorum paratae sunt; princeps postulat, et iudex est pro mercede, et magnus manifestat desiderium animae suae; vae eis, qui pervertunt illud!"
,"4":"Qui optimus in eis, est quasi paliurus, et, qui rectus, quasi spina de saepe; dies speculatorum tuorum, visitatio tua venit: nunc erit confusio eorum."
,"5":"Nolite credere amico, nolite confidere in proximo; ab ea, quae dormit in sinu tuo, custodi claustra oris tui;"
,"6":"quia filius contumeliam facit patri, filia consurgit adversus matrem suam, nurus adversus socrum suam: inimici hominis domestici eius."
,"7":"Ego autem ad Dominum aspiciam, exspectabo Deum salvatorem meum; audiet me Deus meus."
,"8":"Ne laeteris, inimica mea, super me,quia cecidi: consurgam; cum sedeo in tenebris, Dominus lux mea est."
,"9":"Iram Domini porto, quoniam peccavi ei, donec iudicet causam meam,et faciat iudicium meum; educet me in lucem, videbo iustitiam eius."
,"10":"Et aspiciet inimica mea,et operietur confusione, quae dicit ad me: ' Ubi est Dominus Deus tuus? '. Oculi mei videbunt in eam; nunc erit in conculcationem,ut lutum platearum."
,"11":"Dies veniet ut aedificentur maceriae tuae; in die illa dilatabuntur fines tui."
,"12":"In die illa usque ad te venient,habitantes ab Assyria usque ad Aegyptum,et ab Aegypto usque ad flumen,et a mari usque ad mare,et a monte usque ad montem."
,"13":"Terra autem erit in desolationem,propter habitatores suos,et propter fructum operum eorum."
,"14":"Pasce populum tuum in virga tua, gregem hereditatis tuae, habitantes solos in saltu, in medio hortorum; pascantur Basan et Galaad,iuxta dies antiquos."
,"15":"Secundum dies egressionis tuae de terra Aegypti,ostende nobis mirabilia."
,"16":"Videbunt gentes et confundentur,super omni fortitudine sua, ponent manum super os, aures eorum surdae erunt;"
,"17":"lingent pulverem sicut serpens, velut reptilia terrae. Trementes exibunt de aedibus suis ' ad Dominum Deum nostrum ',formidabunt et timebunt te."
,"18":"Quis Deus similis tui, qui aufers iniquitatem,et transis peccatum,reliquiarum hereditatis tuae?,Non servat in aeternum furorem suum, quoniam volens misericordiam est."
,"19":"Revertetur et miserebitur nostri, calcabit iniquitates nostras,et proiciet in profundum maris,omnia peccata nostra."
,"20":"Dabis veritatem Iacob, misericordiam Abraham, quae iurasti patribus nostris,a diebus antiquis."
}`)

}
func LA_NVBSE_LoadVNMLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oraculum. Verbum Domini ad Israel in manu Malachiae."
,"2":"' Dilexi vos, dicit Dominus, et dixistis: 'In quo dilexisti nos?'. Nonne frater erat Esau Iacob?, dicit Dominus; et dilexi Iacob,"
,"3":"Esau autem odio habui et posui montes eius in solitudinem et hereditatem eius thoibus deserti."
,"4":"Quod si dixerit Edom: 'Destructi sumus, sed revertentes aedificabimus, quae destructa sunt', haec dicit Dominus exercituum: Isti aedificabunt, et ego destruam; et vocabuntur 'Termini impietatis' et 'Populus, cui iratus est Dominus usque in aeternum'."
,"5":"Et oculi vestri videbunt, et vos dicetis: 'Magnificatus est Dominus ultra terminos Israel'."
,"6":"Filius honorat patrem, et servus dominum suum. Si ergo pater ego sum, ubi est honor meus? Et si Dominus ego sum, ubi est timor meus?, dicit Dominus exercituum ad vos, o sacerdotes, qui despicitis nomen meum et dicitis: 'In quo despeximus nomen tuum?'."
,"7":"Offertis super altare meum panem pollutum et dicitis: 'In quo polluimus te?'. In eo quod dicitis: 'Mensa Domini contemptibilis est'."
,"8":"Si offeratis caecum ad immolandum, nonne malum est? Et si offeratis claudum et languidum, nonne malum est? Offer illud duci tuo, si placuerit ei, aut si susceperit faciem tuam!, dicit Dominus exercituum."
,"9":"Sed nunc deprecamini vultum Dei, ut misereatur vestri! De manu enim vestra factum est hoc. Num suscipiet facies vestras?, dicit Dominus exercituum."
,"10":"Quis est in vobis, qui claudat ostia, ne incendatis altare meum gratuito? Non est mihi voluntas in vobis, dicit Dominus exercituum; et munus non suscipiam de manu vestra."
,"11":"Ab ortu enim solis usque ad occasum magnum est nomen meum in gentibus, et in omni loco sacrificatur et offertur nomini meo oblatio munda, quia magnum nomen meum in gentibus, dicit Dominus exercituum."
,"12":"Vos autem polluistis illud in eo quod dicitis: 'Mensa Domini contaminata est, et contemptibilis esca eius'."
,"13":"Et dicitis: 'Quantus labor!', et despicitis illam, dicit Dominus exercituum. Et infertis de rapinis claudum et languidum et infertis sicut munus. Numquid suscipiam illud de manu vestra?, dicit Dominus."
,"14":"Maledictus dolosus, qui habet in grege suo masculum et votum faciens immolat debile Domino. Quia Rex magnus ego, dicit Dominus exercituum, et nomen meum horribile in gentibus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et nunc ad vos mandatum hoc, o sacerdotes."
,"2":"Si nolueritis audi re et si nolueritis ponere super cor, ut detis gloriam nomini meo, ait Dominus exercituum, mittam in vos maledictionem et maledicam benedictionibus vestris; et maledicam illis, quoniam non posuistis super cor."
,"3":"Ecce ego abscindam vobis brachium,et dispergam stercus super vultum vestrum, stercus sollemnitatum vestrarum, et assumet vos secum;"
,"4":"et scietis quia misi ad vos mandatum istud, ut esset pactum meum cum Levi, dicit Dominus exercituum."
,"5":"Pactum meum fuit cum eo vitae et pacis, et dedi haec ei simul cum timore, et timuit me,et a facie nominis mei pavebat."
,"6":"Lex veritatis fuit in ore eius, et iniquitas non est inventa in labiis eius; in pace et in aequitate ambulavit mecum,et multos avertit ab iniquitate."
,"7":"Labia enim sacerdotis custodiunt scientiam, et legem requirunt ex ore eius, quia angelus Domini exercituum est."
,"8":"Vos autem recessistis de via,et scandalizastis plurimos in lege; irritum fecistis pactum Levi, dicit Dominus exercituum;"
,"9":"propter quod et ego dedi vos,contemptibiles et humiles omnibus populis, sicut non servastis vias meas,et accepistis personam in lege."
,"10":"Numquid non pater unus omnium nostrum? Numquid non Deus unus creavit nos? Quare ergo dolum facit unusquisque nostrum cum fratre suo, violans pactum patrum nostrorum?"
,"11":"Dolum fecit Iuda, et abominatio facta est in Israel et in Ierusalem, quia contaminavit Iuda sanctuarium Domini, quod diligit, et accepit uxorem filiam dei alieni."
,"12":"Disperdet Dominus virum, qui fecerit hoc, filium et nepotem, de tabernaculis Iacob et de offerentibus munus Domino exercituum."
,"13":"Et hoc rursum facitis: operitis lacrimis altare Domini, fletu et mugitu, ita ut non respiciam ultra ad sacrificium nec accipiam placabile quid de manu vestra;"
,"14":"et dicitis: 'Quam ob causam?'. Quia Dominus testificatus est inter te et uxorem adulescentiae tuae, cui tu factus es infidelis; et haec particeps tua et uxor foederis tui."
,"15":"Nonne unitatem fecit carnis et spiritus? Et quid unitas quaerit nisi semen a Deo? Custodite ergo spiritum vestrum; et uxori adulescentiae tuae noli esse infidelis."
,"16":"Si quis odio dimittit, dicit Dominus, Deus Israel, operit iniquitas vestimentum eius, dicit Dominus exercituum. Custodite spiritum vestrum et nolite esse infideles."
,"17":"Laborare facitis Dominum in sermonibus vestris et dicitis: 'In quo eum facimus laborare?'. In eo quod dicitis: 'Omnis, qui facit malum, bonus est in conspectu Domini, et tales ei placent' aut: 'Ubi est Deus iudicii?'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ecce ego mittam angelum meum, et praeparabit viam an te faciem meam; et statim veniet ad templum suum Dominator, quem vos quaeritis, et angelus testamenti, quem vos vultis. Ecce venit, dicit Dominus exercituum;"
,"2":"et quis poterit sustinere diem adventus eius, et quis stabit, cum apparebit? Ipse enim quasi ignis conflans et quasi herba fullonum;"
,"3":"et sedebit conflans et emundans argentum et purgabit filios Levi et colabit eos quasi aurum et quasi argentum, et erunt Domino offerentes sacrificia in iustitia."
,"4":"Et placebit Domino sacrificium Iudae et Ierusalem sicut diebus pristinis et sicut annis antiquis."
,"5":"Et accedam ad vos in iudicio; et ero testis velox maleficis et adulteris et periuris et, qui opprimunt mercennarios, viduas et pupillos et flectunt ius peregrinorum nec timuerunt me, dicit Dominus exercituum."
,"6":"Ego enim Dominus et non mutatus sum; sed vos, filii lacob, nondum ad finem pervenistis."
,"7":"A diebus enim patrum vestrorum,recessistis a praeceptis legitimis meis et non custodistis ea. Revertimini ad me, et revertar ad vos, dicit Dominus exercituum. Et dicitis: 'In quo revertemur?'."
,"8":"Numquid homo potest defraudare Deum?,Sed vos defraudatis me. Et dicitis: 'In quo defraudavimus te?'. In decimis et in primitiis."
,"9":"Maledictione vos maledicti estis, quia me vos defraudatis, gens tota."
,"10":"Inferte omnem decimam in horreum, et sit cibus in domo mea; et probate me super hoc, dicit Dominus exercituum: si non aperuero vobis cataractas caeli,et effudero vobis benedictionem usque ad abundantiam"
,"11":"et increpabo pro vobis devorantem, et non corrumpet fructum terrae, nec erit sterilis vobis vinea in agro, dicit Dominus exercituum."
,"12":"Et beatos vos dicent omnes gentes; eritis enim vos terra desiderabilis, dicit Dominus exercituum."
,"13":"Invaluerunt super me verba vestra, dicit Dominus;"
,"14":"et dicitis: 'Quid locuti sumus contra te?'. Dicitis: 'Vanum est servire Deo; et, quod emolumentum, quia custodivimus praecepta eius et quia ambulavimus tristes coram Domino exercituum?"
,"15":"Ergo nunc beatos dicimus arrogantes; siquidem aedificati sunt facientes impietatem et tentaverunt Deum et salvi facti sunt'."
,"16":"Tunc locuti sunt timentes Dominum, unusquisque cum proximo suo. Et attendit Dominus et audivit; et scriptus est liber memorabilium coram eo timentibus Dominum et cogitantibus nomen eius."
,"17":"Erunt mihi, ait Dominus exercituum, in die, qua ego facio in peculium; et parcam eis, sicut parcit vir filio suo servienti sibi."
,"18":"Rursum videbitis quid sit inter iustum et impium, inter servientem Deo et non servientem ei."
,"19":"Ecce enim dies veniet succensa quasi caminus; et erunt omnes superbi et omnes facientes impietatem stipula; et inflammabit eos dies veniens, dicit Dominus exercituum, quae non derelinquet eis radicem et ramum."
,"20":"Et orietur vobis timentibus nomen meum sol iustitiae et sanitas in pennis eius; et egrediemini et salietis sicut vituli saginati"
,"21":"et calcabitis impios, cum fuerint cinis sub planta pedum vestrorum in die, quam ego facio, dicit Dominus exercituum."
,"22":"Mementote legis Moysi servi mei, cui mandavi,in Horeb ad omnem Israel,praecepta et iudicia."
,"23":"Ecce ego mittam vobis,Eliam prophetam, antequam veniat dies Domini,magnus et horribilis;"
,"24":"et convertet cor patrum ad filios,et cor filiorum ad patres eorum, ne veniam et percutiam,terram anathemate '."
}`)

}
func LA_NVBSE_LoadVNNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oraculum Nineve. Liber visio nis Nahum Elcesaei."
,"2":"Deus aemulator et ulciscens Dominus, ulciscens Dominus et habens furorem, ulciscens Dominus in hostes suos,et servans iram inimicis suis."
,"3":"Dominus patiens et magnus fortitudine, nullumque impunitum derelinquet Dominus. In tempestate et turbine via eius, et nubes pulvis pedum eius."
,"4":"Increpans mare et exsiccans illud,et omnia flumina ad desertum deducens. Elanguit Basan et Carmelus, et flos Libani elanguit."
,"5":"Montes commoti sunt ab eo, et colles conturbati; et contremuit terra a facie eius,et orbis et omnes habitantes in eo."
,"6":"Ante faciem indignationis eius quis stabit, et quis resistet in aestu furoris eius? Indignatio eius effusa est ut ignis, et petrae dissolutae sunt ab eo."
,"7":"Bonus Dominus, refugium in die tribulationis,et sciens sperantes in se"
,"8":"et in diluvio transeunte; consummationem faciet adversariorum suorum, et inimicos eius persequentur tenebrae."
,"9":"Quid cogitatis contra Dominum?,Consummationem ipse faciet; non consurget duplex tribulatio."
,"10":"Sicut spinae condensae se invicem complectentes,et sicut potatores inebriati,consumentur quasi stipula omnino arida."
,"11":"Ex te exivit cogitans contra Dominum malitiam, mente pertractans praevaricationem."
,"12":"Haec dicit Dominus: ' Et si incolumes fuerint et numerosi, sic quoque attondentur et pertransibunt; afflixi te et non affligam te ultra."
,"13":"Et nunc conteram virgam eius de dorso tuo,et vincula tua disrumpam '."
,"14":"Et praecipiet super te Dominus: ' Non seminabitur ex nomine tuo amplius. De domo dei tui disperdam sculptile et conflatile; ponam sepulcrum tuum, quia inhonoratus es '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ecce super montes pedes evan gelizantis,et annuntiantis pacem. Celebra, Iuda, festivitates tuas,et redde vota tua, quia non adiciet ultra ut pertranseat in te Belial: totus interiit."
,"2":"Ascendit, qui dispergat, contra te. ' Custodi munitionem, contemplare viam, conforta lumbos, robora virtutem valde '."
,"3":"Quia restituet Dominus magnificentiam Iacob,sicut magnificentiam Israel, quia praedones praedati sunt eos,et propagines eorum corruperunt."
,"4":"Clipeus fortium eius ruber, viri exercitus in coccineis; ignitae laminae ferreae curruum, quando praeparat bellum, et equites agitantur."
,"5":"In viis furibundae currunt quadrigae, invicem colliduntur in plateis; aspectus eorum quasi lampades, quasi fulgura discurrentia."
,"6":"Recordatur fortium suorum, ruunt in itineribus suis; currunt ad murum, et praeparatur umbraculum."
,"7":"Portae fluviorum apertae sunt, palatium tremit."
,"8":"Et speciosa denudatur, tollitur, et ancillae eius gemunt ut columbae et percutiunt corda sua."
,"9":"Et Nineve quasi piscina aquarum, cuius aquae fugiunt. ' State, state! '; sed non est qui revertatur."
,"10":"' Diripite argentum, diripite aurum! '. Et non est finis divitiarum; thesaurus ex omnibus vasis desiderabilibus."
,"11":"Dissipata et vastata et dilacerata, et cor tabescens, et dissolutio geniculorum; et tremor in cunctis renibus, et facies omnium eorum candentes. "
,"12":"Ubi est habitaculum leonum, et spelunca catulorum leonum, ad quam ivit leo, ut duceret illuc catulum leonis, et non erat qui exterreret?"
,"13":"Leo cepit sufficienter catulis suis,et necavit leaenis suis; et implevit praeda speluncas suas,et cubile suum rapina."
,"14":"' Ecce ego ad te, dicit Dominus exercituum, et succendam usque ad fumum quadrigas tuas; et leunculos tuos comedet gladius, et exterminabo de terra praedam tuam, et non audietur ultra vox nuntiorum tuorum '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Vae, civitas sanguinum, universa mendacii,praeda plena!,Non recedet a te rapina."
,"2":"Vox flagellorum et vox strepitus rotarum, equi frementes et quadrigae ferventes, equites irruentes"
,"3":"et gladii micantes et hastae fulgurantes,et multitudo interfectorum et acervi mortuorum; nec est finis cadaverum, et corruunt super corpora."
,"4":"Hoc propter multitudinem fornicationum meretricis,speciosae et gratae et habentis maleficia, quae vendidit gentes fornicationibus suis,et nationes maleficiis suis."
,"5":"' Ecce ego ad te, dicit Dominus exercituum; et levabo vestimentum tuum in faciem tuam,et ostendam gentibus nuditatem tuam,et regnis ignominiam tuam."
,"6":"Et proiciam super te abominationes,et contumeliis te afficiam; et ponam te in exemplum."
,"7":"Et erit: omnis, qui viderit te, resiliet a te et dicet: 'Vastata est Nineve!,Quis dolebit super eam?,Unde quaeram consolatorem tibi?'."
,"8":"Numquid melior es quam Noamon, quae habitabat in fluminibus?,Aquae in circuitu eius: cuius vallum mare, aquae muri eius."
,"9":"Chus fuit fortitudo eius,et Aegyptus, cuius non est finis; Phut et Libyes fuerunt in auxilio eius."
,"10":"Sed et ipsa in transmigrationem ducta est, ivit in captivitatem. Parvuli eius elisi sunt,in capite omnium viarum; et super inclitos eius miserunt sortem, et omnes optimates eius constricti sunt in compedibus."
,"11":"Et tu ergo inebriaberis, eris despecta; et tu quaeres,refugium ab inimico."
,"12":"Omnes munitiones tuae sicut ficus,cum ficis praecocibus: si concussae fuerint, cadent in os comedentis."
,"13":"Ecce populus tuus, mulieres in medio tui; inimicis tuis late patebunt,portae terrae tuae; devorabit ignis vectes tuos."
,"14":"Aquam propter obsidionem hauri tibi, firma munitiones tuas; intra in lutum et calca argillam, tene typum laterum."
,"15":"Ibi comedet te ignis, peribis gladio, devorabit te ut bruchus. Augere ut bruchus, multiplicare ut locusta."
,"16":"Plures fecisti negotiatores tuos,quam stellae sint caeli; bruchus exuit pellem,et avolavit."
,"17":"Custodes tui quasi locustae, et scribae tui quasi agmen locustarum, quae considunt in saepibus,in die frigoris; sol ortus est, et avolaverunt, non est cognitus locus earum, ubi fuerint."
,"18":"Dormiunt pastores tui, rex Assyriae, requiescunt principes tui; dispersus est populus tuus in montibus, et non est qui congreget."
,"19":"Non est remedium fracturae tuae, insanabilis est plaga tua; omnes, qui audierint auditionem tuam, plaudent manibus super te, quia super quem non transiit,malitia tua semper? '."
}`)

}
func LA_NVBSE_LoadVNOSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Verbum Domini, quod factum est ad Osee filium Beeri in die bus Oziae, Ioatham, Achaz, Ezechiae regum Iudae, et in diebus Ieroboam filii Ioas regis Israel."
,"2":"Principium verbi Domini per Osee. Dixit Dominus ad Osee: ' Vade, sume tibi mulierem fornicationum,et filios fornicationum, quia fornicans fornicatur terra a Domino '."
,"3":"Et abiit et accepit Gomer filiam Debelaim, quae concepit et peperit ei filium."
,"4":"Et dixit Dominus ad eum: ' Voca nomen eius 'Iezrahel', quoniam adhuc modicum et visitabo sanguinem Iezrahel super domum Iehu et cessare faciam regnum domus Israel;"
,"5":"et in illa die conteram arcum Israel in valle Iezrahel '."
,"6":"Et concepit adhuc et peperit filiam; et dixit ei: ' Voca nomen eius 'Absque misericordia', quia non addam ultra misereri domui Israel, ut ignoscam eis."
,"7":"Et domui Iudae miserebor et salvabo eos in Domino Deo suo et non salvabo eos in arcu et gladio et in bello et in equis et in equitibus '."
,"8":"Et ablactavit eam, quae erat 'Absque misericordia', et concepit et peperit filium."
,"9":"Et dixit: ' Voca nomen eius 'Non populus meus', quia vos non populus meus, et ego 'Non sum' vobis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et erit numerus filiorum Israel,quasi arena maris, quae sine mensura est et non numerabitur. Et erit: in loco, ubi dicebatur eis: 'Non populus meus vos', dicetur eis: 'Filii Dei viventis'."
,"2":"Et congregabuntur filii Iudae,et filii Israel pariter,et ponent sibimet caput unum,et ascendent de terra, quia magnus dies Iezrahel."
,"3":"Dicite fratribus vestris: 'Populus meus',et sororibus vestris: 'Misericordiam consecuta'."
,"4":"Contendite adversum matrem vestram; contendite, quoniam ipsa non uxor mea, et ego non vir eius; auferat fornicationes suas a facie sua,et adulteria sua de medio uberum suorum,"
,"5":"ne forte exspoliem eam nudam,et statuam eam secundum diem nativitatis suae,et ponam eam quasi solitudinem,et statuam eam velut terram aridam,et interficiam eam siti."
,"6":"Et filiorum illius non miserebor, quoniam filii fornicationum sunt,"
,"7":"quia fornicata est mater eorum, turpiter egit, quae concepit eos; quia dixit: 'Vadam post amatores meos, qui dant panes mihi et aquas meas, lanam meam et linum meum, oleum meum et potum meum'."
,"8":"Propter hoc ecce ego saepiam,viam tuam spinis,et saepiam eam maceria, et semitas suas non inveniet;"
,"9":"et sequetur amatores suos,et non apprehendet eos; et quaeret eos et non inveniet,et dicet: 'Vadam et revertar,ad virum meum priorem, quia bene mihi erat tunc magis quam nunc'."
,"10":"Et haec nescivit quia ego,dedi ei frumentum et vinum et oleum,et argentum multiplicavi ei,et aurum, quae fecerunt Baal."
,"11":"Idcirco convertar et sumam,frumentum meum in tempore suo,et vinum meum in tempore suo; et auferam lanam meam et linum meum, quae operiebant pudenda eius,"
,"12":"et nunc revelabo ignominiam eius,in oculis amatorum eius, et nullus est qui eruat eam de manu mea."
,"13":"Et cessare faciam omne gaudium eius, sollemnitatem eius, neomeniam eius, sabbatum eius et omnia festa tempora eius;"
,"14":"et corrumpam vineam eius et ficum eius, de quibus dixit: 'Mercedes hae meae sunt, quas dederunt mihi amatores mei'. Et ponam eas in saltum, et comedet illas bestia agri."
,"15":"Et visitabo super eam dies Baalim, quibus accendebat incensum,et ornabatur inaure sua et monili suo,et ibat post amatores suos, sed mei obliviscebatur, dicit Dominus."
,"16":"Propter hoc ecce ego lactabo eam,et ducam eam in solitudinem,et loquar ad cor eius;"
,"17":"et dabo ei vineas eius ex eodem loco,et vallem Achor, portam spei, et respondebit ibi,iuxta dies iuventutis suae,et iuxta dies ascensionis suae de terra Aegypti."
,"18":"Et erit: in die illa, ait Dominus, vocabis me: 'Vir meus',et non vocabis me ultra: 'Baal meus'."
,"19":"Et auferam nomina Baalim de ore eius, et non recordabitur ultra nominis eorum."
,"20":"Et percutiam eis foedus in die illa,cum bestia agri et cum volucre caeli et cum reptili terrae; et arcum et gladium et bellum,conteram de terra,et cubare eos faciam confidenter."
,"21":"Et sponsabo te mihi in sempiternum; et sponsabo te mihi in iustitia et iudicio,et in misericordia et miserationibus."
,"22":"Et sponsabo te mihi in fide, et cognosces Dominum."
,"23":"Et erit: in illa die exaudiam, dicit Dominus, exaudiam caelos, et illi exaudient terram;"
,"24":"et terra exaudiet,triticum et vinum et oleum, et haec exaudient Iezrahel."
,"25":"Et seminabo eam mihi in terram,et miserebor eius, quae fuit 'Absque misericordia';"
,"26":"et dicam 'Non populo meo': 'Populus meus tu'; et ipse dicet: 'Deus meus es tu' '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et dixit Dominus ad me: ' Adhuc vade, dilige mulierem dilectam amico et adulteram, sicut diligit Dominus filios Israel, et ipsi respectant ad deos alienos et diligunt placentas uvarum '."
,"2":"Et emi eam mihi quindecim argenteis et choro hordei et dimidio choro hordei."
,"3":"Et dixi ad eam: ' Dies multos exspectabis me; non fornicaberis et non eris viro, neque ibo ego ad te '."
,"4":"Quia dies multos sedebunt filii Israel sine rege et sine principe et sine sacrificio et sine lapide et sine ephod et sine theraphim."
,"5":"Et post haec revertentur filii Israel et quaerent Dominum Deum suum et David regem suum et pavebunt ad Dominum et ad bonum eius in fine dierum."
}`)
	CurrentBook.AddChapter(4, `{
"1":"' Audite verbum Domini, filii Israel, quia iudicium Domino,cum habitatoribus terrae: non est enim veritas, et non est benignitas, et non est scientia Dei in terra;"
,"2":"maledictum et mendacium,et homicidium et furtum et adulterium inundaverunt, et sanguis sanguinem tetigit."
,"3":"Propter hoc lugebit terra, et infirmabitur omnis, qui habitat in ea, cum bestia agri et volucre caeli, sed et pisces maris auferentur."
,"4":"Verumtamen non sit qui contendat,nec qui arguat, sed tecum iudicium meum, sacerdos."
,"5":"Et corrues plena die, et corruet etiam propheta tecum nocte; et perdam matrem tuam."
,"6":"Perit populus meus, eo quod non habuerit scientiam. Quia tu scientiam reppulisti, repellam te, ne sacerdotio fungaris mihi; et quia oblitus es legis Dei tui, obliviscar filiorum tuorum et ego."
,"7":"Secundum multitudinem eorum, sic peccaverunt mihi; gloriam eorum in ignominiam commutabo."
,"8":"Peccatum populi mei comedunt,et ad iniquitatem eorum sublevabunt animas eorum."
,"9":"Et erit sicut populus sic sacerdos; et visitabo super eum vias eius,et opera eius reddam ei."
,"10":"Et comedent et non saturabuntur; fornicabuntur et non multiplicabuntur, quoniam Dominum reliquerunt,in non custodiendo."
,"11":"Fornicatio et vinum et ebrietas auferunt cor."
,"12":"Populus meus in ligno suo interrogat, et baculus eius annuntiat ei; spiritus enim fornicationum decepit eos, et fornicantur a Deo suo."
,"13":"Super capita montium sacrificant,et super colles accendunt thymiama, subtus quercum et populum et terebinthum, quia bona est umbra eius; ideo fornicantur filiae vestrae, et sponsae vestrae adulterae sunt."
,"14":"Non visitabo super filias vestras, cum fuerint fornicatae, et super sponsas vestras, cum adulteraverint, quoniam hi ipsi cum meretricibus secedunt,et cum prostibulis delubrorum sacrificant, et populus non intellegens corruet."
,"15":"Si fornicaris tu, Israel, non delinquat saltem Iuda; et nolite ingredi in Galgala,et ne ascenderitis in Bethaven,neque iuraveritis: 'Vivit Dominus'."
,"16":"Quoniam sicut vacca lasciviens,Israel contumax est; nunc pascet eos Dominus,quasi agnum in latitudine?"
,"17":"Particeps idolorum Ephraim, dimitte eum."
,"18":"Transiit convivium eorum, fornicatione fornicati sunt, diligunt vehementer,ignominiam impudicitiae."
,"19":"Ligabit spiritus eos in alis suis, et confundentur a sacrificiis suis."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Audite hoc, sacerdotes, et attendite, domus Israel; et domus regis, auscultate, quia vobis iudicium est; quoniam laqueus facti estis pro Maspha,et rete expansum super Thabor."
,"2":"Et foveam Settim profundam fecerunt; ego autem castigabo vos omnes."
,"3":"Ego scio Ephraim, et Israel non est absconditus a me; quia nunc fornicatus es, Ephraim, contaminatus est Israel."
,"4":"Non dabunt opera sua, ut revertantur ad Deum suum, quia spiritus fornicationis in medio eorum, et Dominum non cognoverunt."
,"5":"Et testatur arrogantia Israel in faciem suam, et Israel et Ephraim ruent in iniquitate sua: ruet etiam Iudas cum eis."
,"6":"In gregibus suis et in armentis suis,vadent ad quaerendum Dominum,et non invenient; subtraxit se ab eis."
,"7":"In Dominum praevaricati sunt, quia filios alienos genuerunt; nunc devorabit eos uno mense cum partibus suis."
,"8":"Clangite bucina in Gabaa, tuba in Rama, conclamate in Bethaven, exterrete Beniamin."
,"9":"Ephraim vastabitur in die correptionis; in tribubus Israel annuntio rem certam."
,"10":"Facti sunt principes Iudae,quasi transferentes terminos; super eos effundam,quasi aquam iram meam."
,"11":"Oppressus est Ephraim, fractum est ius, quoniam voluit abire post sordem."
,"12":"Et ego quasi sanies Ephraim, et quasi putredo domui Iudae."
,"13":"Et vidit Ephraim languorem suum, et Iuda ulcus suum; et abiit Ephraim ad Assyriam,et misit ad regem magnum; sed et ipse non poterit sanare vos,nec solvere poterit vos ab ulcere."
,"14":"Quoniam ego quasi leaena Ephraim,et quasi catulus leonis domui Iudae; ego, ego capiam et vadam, tollam, et non est qui eruat."
,"15":"Vadens revertar ad locum meum, donec poenas solvant,et quaerant faciem meam, in tribulatione sua me desiderent."
}`)
	CurrentBook.AddChapter(6, `{
"1":"'Venite, et revertamur ad Do minum, quia ipse laceravit et sanabit nos, percussit et curabit nos."
,"2":"Vivificabit nos post duos dies, in die tertia suscitabit nos, et vivemus in conspectu eius."
,"3":"Sciamus sequamurque, ut cognoscamus Dominum. Quasi diluculum praeparatus est egressus eius, et veniet quasi imber nobis temporaneus, quasi imber serotinus irrigans terram'."
,"4":"Quid faciam tibi, Ephraim?,Quid faciam tibi, Iuda?,Caritas vestra quasi nubes matutina,et quasi ros mane pertransiens."
,"5":"Propter hoc dolavi per prophetas, occidi eos in verbis oris mei, sed ius meum quasi lux egredietur;"
,"6":"quia caritatem volo et non sacrificium, et scientiam Dei plus quam holocausta."
,"7":"Ipsi autem in Adam transgressi sunt pactum; ibi praevaricati sunt in me."
,"8":"Galaad civitas operantium iniquitatem,maculata sanguine."
,"9":"Et quasi insidiantes virum latrones,caterva sacerdotum; in via interficiunt pergentes Sichem, vere scelus operantur."
,"10":"In domo Israel vidi horrendum: ibi fornicationes Ephraim, contaminatus est Israel."
,"11":"Sed et tibi, Iuda, parata est messis, cum convertero sortem populi mei."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cum sanare vellem Israel, revelata est iniquitas Ephraim,et malitia Samariae, quia operati sunt mendacium; et fur ingressus est, foris autem spoliat turma latronum."
,"2":"Et non dicunt in cordibus suis,omnem malitiam eorum me recordari. Nunc circumdederunt eos opera sua, coram facie mea facta sunt."
,"3":"In malitia sua laetificaverunt regem et in mendaciis suis principes."
,"4":"Omnes adulterantes; quasi clibanus succensus illi, pistor cessat excitare ignem,a commixtione fermenti, donec fermentetur totum."
,"5":"Die regis nostri,infirmi facti sunt principes ardore vini, quod apprehendit protervos."
,"6":"Quia applicuerunt quasi clibanum cor suum,in insidiando; tota nocte dormivit ira eorum, mane ipsa ardet quasi ignis flammae."
,"7":"Omnes calefacti sunt quasi clibanus,et devorant iudices suos. Omnes reges eorum ceciderunt; non est qui clamet in eis ad me."
,"8":"Ephraim in populis ipse commiscebatur; Ephraim factus est subcinericius panis, qui non reversatur."
,"9":"Comederunt alieni robur eius, et ipse nescit; sed et cani effusi sunt in eo, et ipse ignorat."
,"10":"Et testatur superbia Israel in faciem suam, nec reversi sunt ad Dominum Deum suum,et non quaesierunt eum in omnibus his."
,"11":"Et factus est Ephraim quasi columba,insipiens non habens sensum: Aegyptum invocabant, ad Assyrios abierunt."
,"12":"Et cum profecti fuerint, expandam super eos rete meum; quasi volucrem caeli detraham eos, corripiam eos secundum auditionem coetus eorum."
,"13":"Vae eis, quoniam recesserunt a me!,Vastabuntur, quia praevaricati sunt in me. Et ego redimam eos, cum ipsi locuti sint contra me mendacia?"
,"14":"Et non clamaverunt ad me in corde suo, sed ululabant in cubilibus suis; super triticum et vinum se incidebant, contumaces sunt adversum me."
,"15":"Et ego erudivi eos et confortavi brachia eorum, et in me cogitaverunt malitiam."
,"16":"Convertuntur ad eum, qui non prodest, facti sunt quasi arcus dolosus; cadent in gladio principes eorum,propter execrationem linguae suae: ista subsannatio eorum in terra Aegypti."
}`)
	CurrentBook.AddChapter(8, `{
"1":"In gutture tuo sit tuba!,Quasi aquila super domum Do mini,pro eo quod transgressi sunt foedus meum,et legem meam praevaricati sunt."
,"2":"Me invocant: 'Deus meus'; cognovimus te, Israel."
,"3":"Proiecit Israel bonum; inimicus persequetur eum."
,"4":"Ipsi constituerunt reges, et non ex me; principes constituerunt, et non cognovi: argentum suum et aurum suum,fecerunt sibi idola, ut interirent."
,"5":"Proiectus est vitulus tuus, Samaria; iratus est furor meus in eos. Usquequo non poterunt emundari?"
,"6":"Quia ex Israel et ipse est: artifex fecit illum, et non est Deus; quoniam in scintillas erit,vitulus Samariae."
,"7":"Quia ventum seminabunt,et turbinem metent; cum culmus non sit in eo, germen non faciet farinam: quod et si fecerit, alieni comedent eam."
,"8":"Devoratus est Israel, nunc factus est in nationibus,quasi vas immundum."
,"9":"Quia ipsi ascenderunt ad Assyriam, onager est solitarius sibi; Ephraim autem munera dederunt amatoribus."
,"10":"Sed et cum mercede conduxerint nationes, nunc compellam eos, et trement paulisper sub onere regis principum."
,"11":"Cum multiplicaret Ephraim altaria pro peccato, factae sunt ei arae in peccatum."
,"12":"Scribebam ei multiplices leges meas; velut alienae computatae sunt."
,"13":"Hostias amant, immolant carnes et comedunt; sed Dominus non suscipiet eas. Nunc recordabitur iniquitatis eorum,et visitabit peccata eorum: ipsi in Aegyptum convertentur."
,"14":"Et oblitus est Israel factoris sui,et aedificavit delubra; et Iudas multiplicavit urbes munitas. Et mittam ignem in civitates eius, et devorabit aedes illius."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Noli laetari, Israel; noli exsultare sicut populi, quia fornicatus es a Deo tuo, dilexisti mercedem super omnes areas tritici."
,"2":"Area et torcular non pascet eos, et vinum mentietur eis."
,"3":"Non manebunt in terra Domini: revertetur Ephraim in Aegyptum, et in Assyria pollutum comedent."
,"4":"Non libabunt Domino vinum, et non placebunt ei sacrificia eorum; quasi panis lugentium erunt eis: omnes, qui comedent eum, contaminabuntur, quia panis eorum erit tantummodo pro vita ipsorum; non intrabit in domum Domini."
,"5":"Quid facietis in die sollemni, in die festivitatis Domini?"
,"6":"Ecce enim profecti sunt a vastitate; Aegyptus congregabit eos, Memphis sepeliet eos: desiderabile argentum eorum,urtica hereditabit, spina in tabernaculis eorum."
,"7":"Venerunt dies visitationis, venerunt dies retributionis: sciat Israel!,'Stultus - clamet - est propheta; insanus vir spiritalis'. Secundum multitudinem iniquitatis tuae,multae sunt inimicitiae tuae."
,"8":"Speculatur Ephraim, populus Dei mei, prophetam; laqueus aucupis super omnes vias eius, inimicitiae in ipsa domo Dei eius."
,"9":"Profunde peccaverunt,sicut in diebus Gabaa; recordabitur iniquitatis eorum,et visitabit peccata eorum."
,"10":"Quasi uvas in deserto,inveni Israel, quasi prima poma ficulneae in initio eius,vidi patres vestros; ipsi autem intraverunt ad Baalphegor,et se consecraverunt Confusioni,et facti sunt abominabiles,sicut id, quod dilexerunt."
,"11":"Ephraim quasi avis avolabit gloria eorum, a partu et ab utero et a conceptu."
,"12":"Quod si et enutrierint filios suos, absque liberis eos faciam, absque hominibus; sed et vae eis, cum recessero ab eis!"
,"13":"Ephraim, ut vidi, in venationem posuit sibi filios suos, et Ephraim educit ad interfectorem filios suos."
,"14":"'Da eis, Domine! Quid dabis eis?,Da eis vulvam sine liberis et ubera arentia!'."
,"15":"Omnes nequitiae eorum in Galgala, profecto ibi exosos habui eos. Propter malitiam operum eorum,de domo mea eiciam eos. Non addam ut diligam eos; omnes principes eorum rebelles."
,"16":"Percussus est Ephraim, radix eorum exsiccata est, fructum nequaquam facient; quod si et genuerint, interficiam amantissima uteri eorum '."
,"17":"Abiciet eos Deus meus, quia non audierunt eum; et erunt vagi in nationibus."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Vitis frondosa Israel, fructum producens sibi; secundum multitudinem fructus sui multiplicavit altaria, iuxta ubertatem terrae suae,decoravit simulacra."
,"2":"Divisum est cor eorum, nunc poenas solvent; ipse confringet aras eorum, depopulabitur simulacra eorum."
,"3":"Profecto nunc dicent: ' Non est rex nobis; non enim timemus Dominum, et rex quid faciet nobis? '."
,"4":"Loqui verba, iurare in vanum, ferire foedus; et germinabit quasi venenum ius,super sulcos agri."
,"5":"De vitulo Bethaven,trement habitatores Samariae; quia luget super eum populus eius; dum sacerdotes eius super eum,exsultant in gloria eius; vere migrabit ab eo."
,"6":"Siquidem et ipse in Assyriam delatus est, munus regi magno; confusio Ephraim capiet, et confundetur Israel in consilio suo."
,"7":"Perit Samaria, rex eius quasi festuca super faciem aquae."
,"8":"Et disperdentur excelsa impietatis, peccatum Israel; spina et tribulus ascendet,super aras eorum, et dicent montibus: ' Operite nos! ',et collibus: ' Cadite super nos! '."
,"9":"Ex diebus Gabaa peccavit Israel; ibi perstiterunt. Non comprehendet eos in Gabaa,proelium super filios iniquitatis?"
,"10":"' Iuxta desiderium meum corripiam eos; congregabuntur super eos populi, cum corripientur propter duas iniquitates suas."
,"11":"Ephraim vitula docta, diligens trituram. Et ego transivi super pulchritudinem colli eius; iunxi Ephraim aratro, arabit Iudas, sarriet sibi Iacob."
,"12":"Seminate vobis in iustitia, metite secundum caritatem; innovate vobis novale. Tempus est requirendi Dominum, donec veniat, ut pluat vobis iustitiam."
,"13":"Arastis impietatem, iniquitatem messuistis, comedistis frugem mendacii, quia confisus es in curribus tuis, in multitudine fortium tuorum."
,"14":"Consurget tumultus in populo tuo, et omnes munitiones tuae vastabuntur, sicut vastavit Salman Betharbeel,in die proelii, matre super filios allisa."
,"15":"Sic faciet vobis Bethel,propter maximam nequitiam vestram. Mane interibit rex Israel."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Cum puer esset Israel, dilexi eum,et ex Aegypto vocavi filium meum."
,"2":"Quanto magis vocabam eos, tanto recesserunt a facie mea; ipsi Baalim immolabant,et simulacris sacrificabant."
,"3":"Et ego dirigebam gressus Ephraim, portabam eos in brachiis meis, et nescierunt quod curarem eos."
,"4":"In funiculis humanitatis trahebam eos, in vinculis caritatis; et fui eis, quasi qui elevant infantem ad maxillas suas, et declinavi ad eum, ut vesceretur."
,"5":"Revertetur in terram Aegypti, et Assur ipse rex eius, quoniam noluerunt converti."
,"6":"Saeviet gladius in civitatibus eius,et consumet garrulos eius,et comedet eos propter consilia eorum."
,"7":"Populus meus pendet ad praevaricandum contra me; vocant eum ad altum, sed simul non erigunt eum."
,"8":"Quomodo dabo te, Ephraim, tradam te, Israel?,Quomodo dabo te sicut Adama, ponam te ut Seboim?,Convertitur in me cor meum, simul exardescit miseratio mea."
,"9":"Non faciam furorem irae meae, non convertar, ut disperdam Ephraim, quoniam Deus ego,et non homo, in medio tui Sanctus,et non veniam in terrore."
,"10":"Post Dominum ambulabunt; quasi leo rugiet, quia ipse rugiet, et in tremore accurrent filii ab occidente."
,"11":"Et avolabunt quasi avis ex Aegypto,et quasi columba de terra Assyriae; et collocabo eos in domibus suis, dicit Dominus."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Circumdedit me in fraude Ephraim, et in dolo domus Israel; C Iudas autem, dum adhuc vagatur, est cum Deo,et cum Sancto fidelis ' C."
,"2":"Ephraim pascit ventum,et sequitur aestum; tota die mendacium et violentiam multiplicat,et foedus cum Assyriis init,et oleum in Aegyptum fert."
,"3":"Iudicium ergo Domini cum Iuda, et visitatio super Iacob; iuxta vias eius et iuxta opera eius reddet ei."
,"4":"In utero supplantavit fratrem suum,et in robore suo luctatus est cum Deo."
,"5":"Et luctatus est cum angelo et praevaluit; flevit et deprecatus est eum. In Bethel invenit eum,et ibi locutus est nobiscum"
,"6":"Dominus, Deus exercituum: Dominus memoriale eius."
,"7":"' Et tu ad Deum tuum converteris; caritatem et iudicium custodi,et spera in Deo tuo semper '."
,"8":"Chanaan, in manu eius statera dolosa, fraudem diligit."
,"9":"Et dixit Ephraim: ' Verumtamen dives effectus sum, inveni opes mihi, omnes labores mei non invenient mihi,iniquitatem, quam peccavi '."
,"10":"' Ego autem Dominus, Deus tuus,ex terra Aegypti; adhuc sedere te faciam in tabernaculis, sicut in diebus conventus."
,"11":"Et loquar ad prophetas,et ego visionem multiplicabo,et in manu prophetarum proponam similitudines '."
,"12":"Si Galaad iniquitas fuerat, prorsus inanes facti sunt; in Galgala bobus immolantes, etiam altaria eorum erunt quasi acervi,super sulcos agri."
,"13":"Fugit Iacob in regionem Aram; et servivit Israel pro uxore,et pro uxore custos fuit."
,"14":"Per prophetam autem eduxit Dominus,Israel de Aegypto, et per prophetam custoditus est."
,"15":"Ad iracundiam provocavit Ephraim amarissime, sed sanguinem eius super eum relinquet,et opprobrium eius retribuet ei Dominus suus."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Loquente Ephraim, horror factus est; dux erat in Israel. Et deliquit in Baal,et mortuus est."
,"2":"Et nunc addunt ad peccandum,faciuntque sibi conflatile de argento suo, secundum intellegentiam suam simulacra; factura artificum totum est. ' His - ipsi dicunt - immolate! '. Homines vitulos osculantur."
,"3":"Idcirco erunt quasi nubes matutina,et sicut ros matutinus praeteriens, sicut palea turbine rapta ex area,et sicut fumus de fumario."
,"4":"' Ego autem Dominus, Deus tuus,ex terra Aegypti; et Deum absque me nescies, et salvator non est praeter me."
,"5":"Ego pavi te in deserto, in terra ardenti solitudinis."
,"6":"Iuxta pascua sua saturati sunt,et saturati elevaverunt cor suum, propterea obliti sunt mei."
,"7":"Et ego ero eis quasi leaena, sicut pardus iuxta viam insidiabor."
,"8":"Occurram eis quasi ursa, raptis catulis, et dirumpam claustrum cordis eorum: et consumam eos ibi quasi leo; bestia agri scindet eos."
,"9":"Perdo te, Israel; quis est auxiliator tuus?"
,"10":"Ubinam est rex tuus, ut salvet te in omnibus urbibus tuis, et iudices tui, de quibus dixisti: 'Da mihi regem et principes'?"
,"11":"Do tibi regem in furore meo,et aufero in indignatione mea."
,"12":"Colligata est iniquitas Ephraim, absconditum peccatum eius."
,"13":"Dolores parturientis venient ei; erit filius non sapiens: suo enim tempore non stabit,in ore vulvae."
,"14":"De manu inferni liberabo eos, de morte redimam eos?,Ubi pestilentiae tuae, o mors?,Ubi pestis tua, inferne?,Consolatio abscondita est ab oculis meis '."
,"15":"Dum ipse inter fratres fructificat, veniet ventus urens, ventus Domini,de deserto ascendens, et siccabit venas eius,et desolabit fontem eius. Ipse diripiet thesaurum, omne vas desiderabile."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Poenas solvet Samaria, quoniam rebellavit contra Deum suum: in gladio peribunt, parvuli eorum elidentur, et praegnantes discindentur."
,"2":"Convertere, Israel, ad Dominum Deum tuum, quoniam corruisti in iniquitate tua."
,"3":"Tollite vobiscum verba,et convertimini ad Dominum; dicite ei: ' Omnem aufer iniquitatem,et accipe bonum, et reddemus fructum labiorum nostrorum."
,"4":"Assyria non salvabit nos; super equum non ascendemus,nec vocabimus ultra: 'Deos nostros!',opera manuum nostrarum, quia in te misericordiam consequetur pupillus '."
,"5":"' Sanabo praevaricationem eorum, diligam eos spontanee, quia aversus est furor meus ab eis."
,"6":"Ero quasi ros pro Israel; germinabit quasi lilium,et mittet radices suas ut Libanus."
,"7":"Expandentur rami eius; et erit quasi oliva gloria eius, et odor eius ut Libani."
,"8":"Convertentur sedentes in umbra mea, colent triticum,et germinabunt quasi vinea; memoriale eius sicut vinum Libani."
,"9":"Ephraim, quid ei ultra idola?,Ego exaudio et respicio in eum. Ego ut abies virens: ex me fructus tuus invenitur '."
,"10":"Qui sapiens est, intellegat ista; intellegens sciat haec!,Quia rectae viae Domini, et iusti ambulabunt in eis; praevaricatores vero corruent in eis."
}`)

}
func LA_NVBSE_LoadVNSOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Verbum Domini, quod factum est ad Sophoniam filium Chusi filii Godoliae filii Amariae filii Ezechiae, in diebus Iosiae filii Amon regis Iudae."
,"2":"' Auferens auferam omnia,a facie terrae, dicit Dominus,"
,"3":"auferam hominem et pecus, auferam volatile caeli,et pisces maris. Et ruinae impiorum erunt; et disperdam homines a facie terrae, dicit Dominus."
,"4":"Et extendam manum meam super Iudam,et super omnes habitantes Ierusalem; et disperdam de loco hoc reliquias Baal,et nomina aedituorum cum sacerdotibus"
,"5":"et eos, qui adorant super tecta,militiam caeli,et adorant et iurant in Domino,et iurant in Melchom,"
,"6":"et qui avertuntur de post tergum Domini, et qui non quaerunt Dominum nec investigant eum '."
,"7":"Silete a facie Domini Dei, quia iuxta est dies Domini; quia praeparavit Dominus hostiam, sanctificavit vocatos suos."
,"8":"' Et erit in die hostiae Domini: visitabo super principes,et super filios regis,et super omnes, qui induti sunt,veste peregrina;"
,"9":"et visitabo super omnem, qui arroganter ingreditur super limen in die illa, qui complent domum domini sui,iniquitate et dolo."
,"10":"Et erit in die illa, dicit Dominus, vox clamoris a porta Piscium, et ululatus ab urbe Nova, et contritio magna a collibus."
,"11":"Ululate, habitatores Pilae, quia interiit omnis populus Chanaan, disperierunt omnes involuti argento."
,"12":"Et erit in tempore illo: scrutabor Ierusalem in lucernis,et visitabo super viros,defixos in faecibus suis, qui dicunt in cordibus suis: 'Non faciet bene Dominus,et non faciet male'."
,"13":"Et erunt opes eorum in direptionem, et domus eorum in desertum; et aedificabunt domos,et non habitabunt, et plantabunt vineas,et non bibent vinum earum '."
,"14":"Iuxta est dies Domini magnus, iuxta et velox nimis; vox diei Domini amara, tribulabitur ibi fortis."
,"15":"Dies irae dies illa, dies tribulationis et angustiae, dies vastitatis et desolationis, dies tenebrarum et caliginis, dies nebulae et turbinis,"
,"16":"dies tubae et clangoris,super civitates munitas,et super angulos excelsos."
,"17":"Et tribulabo homines, et ambulabunt ut caeci, quia Domino peccaverunt; et effundetur sanguis eorum sicut humus, et viscera eorum sicut stercora."
,"18":"Sed et argentum eorum et aurum eorum,non poterit liberare eos,in die irae Domini; in igne zeli eius,devorabitur omnis terra, quia consummationem cum festinatione faciet,cunctis habitantibus terram."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Convenite, congregamini, gens non amabilis,"
,"2":"priusquam dispergamini,quasi pulvis transeuntes, antequam veniat super vos,ira furoris Domini, antequam veniat super vos,dies furoris Domini."
,"3":"Quaerite Dominum, omnes mansueti terrae, qui iudicium eius estis operati; quaerite iustitiam, quaerite mansuetudinem, si quomodo abscondamini,in die furoris Domini."
,"4":"Quia Gaza deserta erit, et Ascalon desolata, Azotum in meridie eicient, et Accaron eradicabitur."
,"5":"Vae, qui habitatis funiculum maris, gens Cretensium!,Verbum Domini super vos, Chanaan, terra Philisthinorum: ' Disperdam te, ita ut non sit inhabitator '."
,"6":"Et erit funiculus maris,requies pastorum et caulae pecorum."
,"7":"Et erit funiculus maris,reliquiis domus Iudae: ibi pascentur, in domibus Ascalonis ad vesperam requiescent, quia visitabit eos Dominus Deus eorum,et convertet sortem eorum."
,"8":"' Audivi opprobrium Moab,et blasphemias filiorum Ammon, qui exprobraverunt populo meo,et magnificati sunt super terminos eorum."
,"9":"Propterea vivo ego, dicit Dominus exercituum, Deus Israel, quia Moab ut Sodoma erit, et filii Ammon quasi Gomorra, possessio spinarum et acervi salis,et desertum usque in aeternum; reliquiae populi mei diripient eos, et residui gentis meae possidebunt illos '."
,"10":"Hoc eis eveniet pro superbia sua, quia blasphemaverunt et magnificati sunt,super populum Domini exercituum."
,"11":"Horribilis Dominus super eos, quia attenuabit omnes deos terrae; et adorabunt eum, singuli de loco suo, omnes insulae gentium."
,"12":"' Sed et vos, Aethiopes, interfecti gladio meo eritis '."
,"13":"Et extendet manum suam super aquilonem,et perdet Assyriam; et ponet Nineven in solitudinem,et in aridam, quasi desertum."
,"14":"Et accubabunt in medio eius greges, omne genus animalium. Et onocrotalus et ulula,in capitellis eius morabuntur; vox cantat in fenestra, corvus in limine, quoniam tabulatum cedrinum sublatum est."
,"15":"Haec est civitas exsultans, habitans in confidentia, quae dicebat in corde suo: ' Ego sum, et extra me non est alia amplius! '. Quomodo facta est in desertum, cubile bestiae?,Omnis, qui transit per eam, sibilabit et movebit manum suam."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Vae, provocatrix et inquinata, civitas violenta!"
,"2":"Non audivit vocem, non suscepit disciplinam; in Domino non est confisa, ad Deum suum non appropiavit."
,"3":"Principes eius in medio eius,leones rugientes; iudices eius lupi deserti, ossa non relinquunt in mane."
,"4":"Prophetae eius vaniloqui, viri fallaces; sacerdotes eius polluerunt sanctum, iniuste egerunt contra legem."
,"5":"Dominus iustus in medio eius,non faciet iniquitatem; mane, mane iudicium suum dabit, sicut lucem, quae non deficit; nescivit autem iniquus confusionem."
,"6":"' Disperdidi gentes, dissipati sunt anguli earum; desertas feci vias eorum, dum non est qui transeat; desolatae sunt civitates eorum, non remanente viro nec ullo habitatore."
,"7":"Dixi: Nunc timebis me, suscipies disciplinam!,Et non evanescent ab oculis eius omnia, in quibus visitavi eam. Verumtamen acceleraverunt corrumpere,omnes actiones suas."
,"8":"Quapropter exspecta me, dicit Dominus, in die qua surgam ut testis; quia iudicium meum, ut congregem gentes,et colligam regna, ut effundam super eas indignationem meam, omnem iram furoris mei; in igne enim zeli mei,devorabitur omnis terra."
,"9":"Quia tunc reddam populis,labium purum, ut invocent omnes in nomine Domini,et serviant ei umero uno."
,"10":"Ultra flumina Aethiopiae, inde supplices mei, filii dispersorum meorum,deferent munus mihi."
,"11":"In die illa non confunderis,super cunctis actionibus tuis, quibus praevaricata es in me; quia tunc auferam de medio tui,magniloquos superbos tuos, et non adicies exaltari amplius,in monte sancto meo."
,"12":"Et derelinquam in medio tui,populum pauperem et egenum '. Et sperabunt in nomine Domini,reliquiae Israel."
,"13":"Non facient iniquitatem,nec loquentur mendacium; et non invenietur in ore eorum,lingua dolosa, quoniam ipsi pascentur et accubabunt, et non erit qui exterreat."
,"14":"Lauda, filia Sion; iubilate, Israel!,Laetare et exsulta in omni corde, filia Ierusalem!"
,"15":"Abstulit Dominus iudicium tuum, avertit inimicos tuos; rex Israel, Dominus, in medio tui, non timebis malum ultra."
,"16":"In die illa dicetur Ierusalem: ' Noli timere, Sion; ne dissolvantur manus tuae!"
,"17":"Dominus Deus tuus in medio tui, fortis ipse salvabit; gaudebit super te in laetitia, commotus in dilectione sua; exsultabit super te in laude"
,"18":"sicut in die conventus '. ' Auferam a te calamitatem, ut non ultra habeas super ea opprobrium."
,"19":"Ecce ego interficiam,omnes, qui afflixerunt te,in tempore illo; et salvabo claudicantem,et eam, quae eiecta fuerat, congregabo; et ponam eos in laudem et in nomen in omni terra confusionis eorum,"
,"20":"in tempore illo, quo adducam vos, et in tempore, quo congregabo vos. Dabo enim vos in nomen et in laudem,omnibus populis terrae, cum convertero sortem vestram,coram oculis vestris ', dicit Dominus."
}`)

}
func LA_NVBSE_LoadVNZAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In mense octavo, in anno se cundo Darii, factum est verbum Domini ad Zachariam filium Barachiae filii Addo prophetam dicens:"
,"2":"' Iratus est Dominus super patres vestros iracundia."
,"3":"Et dices ad eos: Haec dicit Dominus exercituum: Convertimini ad me, ait Dominus exercituum; et convertar ad vos, dicit Dominus exercituum."
,"4":"Ne sitis sicut patres vestri, ad quos clamabant prophetae priores dicentes: Haec dicit Dominus exercituum: Convertimini de viis vestris malis et de cogitationibus vestris malis; et non audierunt neque attenderunt ad me, dicit Dominus."
,"5":"Patres vestri ubi sunt? Et prophetae numquid in sempiternum vivent?"
,"6":"Verumtamen verba mea et praecepta mea, quae mandavi servis meis prophetis, numquid non attigerunt patres vestros? Et conversi sunt et dixerunt: 'Sicut cogitavit Dominus exercituum facere nobis, secundum vias nostras et secundum adinventiones nostras fecit nobis' '."
,"7":"In die vicesima et quarta undecimi mensis, qui est mensis Sabath, in anno secundo Darii, factum est verbum Domini ad Zachariam filium Barachiae filii Addo prophetam dicens:"
,"8":"' Vidi per noctem, et ecce vir sedens super equum rufum et ipse stabat inter myrteta, quae erant in profundo; et post eum equi rufi, fulvi et albi."
,"9":"Et dixi: 'Quid sunt isti, domine mi?'. Et dixit ad me angelus, qui loquebatur in me: 'Ego ostendam tibi quid sint isti'."
,"10":"Et respondit vir, qui stabat inter myrteta, et dixit: 'Isti sunt quos misit Dominus, ut perambularent terram'."
,"11":"Et responderunt angelo Domini, qui stabat inter myrteta, et dixerunt: 'Perambulavimus terram, et ecce omnis terra habitatur et quiescit'."
,"12":"Et respondit angelus Domini et dixit: 'Domine exercituum, usquequo tu non misereberis Ierusalem et urbium Iudae, quibus iratus es? Iste septuagesimus annus est!'."
,"13":"Et respondit Dominus angelo, qui loquebatur in me verba bona, verba consolatoria."
,"14":"Et dixit ad me angelus, qui loquebatur in me: 'Clama dicens: Haec dixit Dominus exercituum: Zelatus sum Ierusalem et Sion zelo magno,"
,"15":"sed ira magna ego irascor super gentes opulentas, quia ego iratus sum parum, ipsi vero adiuverunt in malum."
,"16":"Propterea haec dicit Dominus: Revertar ad Ierusalem in misericordiis. Domus mea aedificabitur in ea, ait Dominus exercituum, et perpendiculum extendetur super Ierusalem."
,"17":"Adhuc clama dicens: Haec dicit Dominus exercituum: Adhuc affluent civitates meae bonis, et consolabitur adhuc Dominus Sion et eliget adhuc Ierusalem'."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Et levavi oculos meos et vidi, et ecce quattuor cornua;"
,"2":"et dixi ad angelum, qui loquebatur in me: 'Quid sunt haec?'. Et dixit ad me: 'Haec sunt cornua, quae ventilaverunt Iudam et Israel et Ierusalem'."
,"3":"Et ostendit mihi Dominus quattuor fabros;"
,"4":"et dixi: 'Quid isti veniunt facere?'. Qui respondit dicens: 'Haec sunt cornua, quae ventilaverunt Iudam per singulos viros, ut nemo eorum levaret caput suum; et venerunt isti deterrere ea, ut deiciant cornua gentium, quae levaverunt cornu super terram Iudae, ut dispergerent eam'."
,"5":"Et levavi oculos meos et vidi; et ecce vir, et in manu eius funiculus mensorum."
,"6":"Et dixi: 'Quo tu vadis?'. Et dixit ad me: 'Ut metiar Ierusalem et videam, quanta sit latitudo eius et quanta longitudo eius'."
,"7":"Et ecce angelus, qui loquebatur in me, egrediebatur, et angelus alius egrediebatur in occursum eius;"
,"8":"et dixit ad eum: 'Curre, loquere ad puerum istum dicens: Absque muris habitabitur Ierusalem prae multitudine hominum et iumentorum in medio eius."
,"9":"Et ego ero ei, ait Dominus, murus ignis in circuitu et in gloria ero in medio eius."
,"10":"Heu, heu! Fugite de terra aquilonis, dicit Dominus, quoniam in quattuor ventos caeli dispersi vos, dicit Dominus."
,"11":"Heu, Sion, fuge, quae habitas apud filiam Babylonis!"
,"12":"Quia haec dicit Dominus exercituum, cuius gloria misit me ad gentes, quae spoliaverunt vos: Qui tetigerit vos, tangit pupillam oculi mei."
,"13":"Quia ecce ego levo manum meam super eos, et erunt praeda servorum suorum; et cognoscetis quia Dominus exercituum misit me."
,"14":"Iubila et laetare, filia Sion, quia ecce ego venio,et habitabo in medio tui, ait Dominus."
,"15":"Et applicabuntur gentes multae,ad Dominum in die illa,et erunt ei in populum. Et habitabo in medio tui, et scies quia Dominus exercituum,misit me ad te."
,"16":"Et possidebit Dominus Iudam,partem suam super terram sanctam,et eliget adhuc Ierusalem."
,"17":"Sileat omnis caro a facie Domini, quia consurrexit de habitaculo sancto suo'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et ostendit mihi Iesua sacer dotem magnum stantem coram angelo Domini; et Satan stabat a dextris eius, ut adversaretur ei."
,"2":"Et dixit angelus Domini ad Satan: 'Increpet Dominus in te, Satan! Et increpet Dominus in te, qui elegit Ierusalem! Numquid non iste torris est erutus de igne?'."
,"3":"Et Iesua erat indutus vestibus sordidis et stabat ante faciem angeli."
,"4":"Qui respondit et ait ad eos, qui stabant coram se, dicens: 'Auferte vestimenta sordida ab eo'. Et dixit ad eum: 'Ecce, abstuli a te iniquitatem tuam; induam te mutatoriis'."
,"5":"Et dixit: 'Ponite cidarim mundam super caput eius'. Et posuerunt cidarim mundam super caput eius et induerunt eum vestibus; et angelus Domini stabat."
,"6":"Et contestabatur angelus Domini Iesua dicens:"
,"7":"'Haec dicit Dominus exercituum: Si in viis meis ambulaveris et ministerium meum custodieris, tu quoque iudicabis domum meam et custodies atria mea; et dabo tibi accessum inter eos, qui nunc hic assistunt."
,"8":"Audi, Iesua sacerdos magne, tu et amici tui, qui sedent coram te, quia viri portendentes sunt: Ecce enim ego adduco servum meum Germen."
,"9":"Quia ecce lapis, quem dedi coram Iesua: super lapidem unum septem oculi sunt; ecce ego caelabo sculpturam eius, ait Dominus exercituum, et auferam iniquitatem terrae illius in die una."
,"10":"In die illa, oraculum Domini exercituum, vocabit vir amicum suum subter vitem et subter ficum'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et reversus est angelus, qui loquebatur in me, et excitavit me quasi virum, qui excitatur de somno suo."
,"2":"Et dixit ad me: 'Quid tu vides?'. Et dixi: 'Vidi: et ecce candelabrum aureum totum, et ampulla super caput ipsius, et septem lucernae eius super illud, et septena infusoria lucernis, quae erant super caput eius."
,"3":"Et duae olivae super illud, una a dextris ampullae et una a sinistris eius'."
,"4":"Et respondi et aio ad angelum, qui loquebatur in me, dicens: 'Quid sunt haec, domine mi?'."
,"5":"Et respondit angelus, qui loquebatur in me, et dixit ad me: 'Numquid nescis quid sunt haec?'. Et dixi: 'Non, domine mi'."
,"6":"Et respondit et ait ad me dicens: 'Hoc est verbum Domini ad Zorobabel dicens: Non in exercitu nec in robore sed in spiritu meo, dicit Dominus exercituum."
,"7":"Quis tu, mons magne, coram Zorobabel? Eris in planum. Et educet lapidem primarium inter clamores: Quam venustus!"
,"8":"Et factum est verbum Domini ad me dicens:"
,"9":"Manus Zorobabel fundaverunt domum istam et manus eius perficient eam, et scietis quia Dominus exercituum misit me ad vos."
,"10":"Quis enim despexit diem initiorum parvorum? Et laetabuntur et videbunt lapidem stanneum in manu Zorobabel. Septem illae oculi sunt Domini, qui discurrunt in universa terra'."
,"11":"Et respondi et dixi ad eum: 'Quid sunt duae olivae istae ad dexteram candelabri et ad sinistram eius?'."
,"12":"Et respondi secundo et dixi ad eum: 'Quid sunt duo rami olivarum, qui duabus fistulis aureis effundunt ex se aurum?'."
,"13":"Et ait ad me dicens: 'Numquid nescis quid sunt haec?'. Et dixi: 'Non, domine mi'."
,"14":"Et dixit: 'Isti sunt duo filii olei, qui assistunt Dominatori universae terrae'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Et conversus sum et levavi ocu los meos et vidi: et ecce volu men volans."
,"2":"Et dixit ad me: 'Quid tu vides?'. Et dixi: 'Ego video volumen volans; longitudo eius viginti cubitorum et latitudo eius decem cubitorum'."
,"3":"Et dixit ad me: 'Haec est maledictio, quae egreditur super faciem omnis terrae; quia omnis fur hinc iuxta illud expurgatur, et omnis periurus illinc iuxta illud expurgatur."
,"4":"Educo illud, dicit Dominus exercituum, et veniet ad domum furis et ad domum iurantis in nomine meo mendaciter; et commorabitur in medio domus eius, et consumet eam et ligna eius et lapides eius'."
,"5":"Et egressus est angelus, qui loquebatur in me, et dixit ad me: 'Leva, quaeso, oculos tuos et vide. Quid est hoc, quod egreditur?'."
,"6":"Et dixi: 'Quidnam est?'. Et ait: 'Haec est epha egrediens'. Et dixit: 'Hoc est peccatum eorum in universa terra'."
,"7":"Et ecce operculum plumbi elevatum est, et ecce mulier una sedens in medio ephae."
,"8":"Et dixit: 'Haec est impietas'. Et proiecit eam in epham et misit massam plumbeam in os eius."
,"9":"Et levavi oculos meos et vidi: et ecce duae mulieres egredientes, et ventus in alis earum, et habebant alas quasi alas milvi; et levaverunt epham inter terram et caelum."
,"10":"Et dixi ad angelum, qui loquebatur in me: 'Quo istae deferunt epham?'."
,"11":"Et dixit ad me: 'Ut aedificetur ei domus in terra Sennaar; et, postquam constructa fuerit, ponetur ibi super basem suam'."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Et rursus levavi oculos meos et vidi: et ecce quattuor quadrigae egredientes de medio duorum montium; et montes, montes aerei."
,"2":"In quadriga prima equi rufi, et in quadriga secunda equi nigri,"
,"3":"et in quadriga tertia equi albi, et in quadriga quarta equi varii."
,"4":"Et respondi et dixi ad angelum, qui loquebatur in me: 'Quid sunt haec, domine mi?'."
,"5":"Et respondit angelus et ait ad me: 'Isti sunt quattuor venti caeli, qui egrediuntur, postquam steterunt coram Dominatore omnis terrae'."
,"6":"In qua erant equi nigri, egrediebantur in terram aquilonis, et albi egressi sunt post eos, et varii egressi sunt ad terram austri."
,"7":"Et equi fortes exierunt et quaerebant ire et discurrere per terram. Et dixit: 'Ite, perambulate terram'. Et perambulaverunt terram."
,"8":"Et vocavit me et locutus est ad me dicens: 'Ecce, qui egrediuntur in terram aquilonis requiescere fecerunt spiritum meum in terra aquilonis'."
,"9":"Et factum est verbum Domini ad me dicens:"
,"10":"'Sume ab his, qui de captivitate sunt, ab Holdai et a Thobia et ab Iedaia, et venies tu in die illa et intrabis domum Iosiae filii Sophoniae, qui venerunt de Babylone."
,"11":"Et sumes argentum et aurum et facies coronam et pones in capite Iesua filii Iosedec, sacerdotis magni,"
,"12":"et loqueris ad eum dicens: Haec ait Dominus exercituum dicens: Ecce vir, Germen nomen eius; et in loco suo aliquid germinabit et aedificabit templum Domini."
,"13":"Et ipse exstruet templum Domini; et ipse portabit gloriam et sedebit et dominabitur super solio suo; et erit sacerdos ad dexteram eius, et consilium pacis erit inter illos duos."
,"14":"Et corona erit Helem et Thobiae et Iedaiae et Hen filio Sophoniae memoriale in templo Domini."
,"15":"Et qui procul sunt, venient et aedificabunt in templo Domini; et scietis quia Dominus exercituum misit me ad vos. Erit autem hoc, si oboedieritis voci Domini Dei vestri' '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Et factum est in anno quarto Darii regis, factum est verbum Domini ad Zachariam in quarta mensis noni, qui est Casleu."
,"2":"Et Bethel miserat Sarasar et Regemmelech et viros, qui erant cum eo, ad deprecandam faciem Domini,"
,"3":"ut dicerent sacerdotibus domus Domini exercituum et prophetis loquentes: ' Numquid flendum est mihi in quinto mense vel ieiunandum, sicut iam feci multis annis? '."
,"4":"Et factum est verbum Domini exercituum ad me dicens:"
,"5":"' Loquere ad omnem populum terrae et ad sacerdotes dicens: Cum ieiunaretis et plangeretis in quinto et septimo mense per hos septuaginta annos, numquid revera ieiunastis mihi?"
,"6":"Et cum comedistis et bibistis, numquid non vobis comedistis et vobismetipsis bibistis?"
,"7":"Numquid non sunt verba, quae locutus est Dominus in manu prophetarum priorum, cum adhuc Ierusalem habitaretur et esset opulenta, ipsa et urbes in circuitu eius, et Nageb habitaretur simul cum Sephela? '."
,"8":"Et factum est verbum Domini ad Zachariam dicens:"
,"9":"' Haec ait Dominus exercituum dicens: Iudicium verum iudicate et misericordiam et miserationes facite unusquisque cum fratre suo;"
,"10":"et viduam et pupillum et advenam et pauperem nolite calumniari, et malum unusquisque contra fratrem suum nolite cogitare in corde vestro."
,"11":"Et noluerunt attendere; et opposuerunt dorsum rebelle et aures suas aggravaverunt, ne audirent."
,"12":"Et cor suum posuerunt adamantem, ne audirent legem et verba, quae misit Dominus exercituum in spiritu suo per manum prophetarum priorum, et facta est indignatio magna a Domino exercituum."
,"13":"Et factum est, sicut cum clamaret, et ipsi non audierunt, sic clamabunt, et non exaudiam, dicit Dominus exercituum."
,"14":"Et disperdam eos per omnes gentes, quas nesciunt; et terra desolata est post eos, ita ut non esset transiens et revertens. Et posuerunt terram desiderabilem in desertum '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Et factum est verbum Domini exercituum dicens:"
,"2":"' Haec dicit Dominus exercituum: Zelatus sum Sion zelo magno,et ardore magno zelatus sum eam."
,"3":"Haec dicit Dominus: Reversus sum ad Sion et habitabo in medio Ierusalem; et vocabitur Ierusalem civitas Veritatis, et mons Domini exercituum mons Sanctitatis."
,"4":"Haec dicit Dominus exercituum: Adhuc sedebunt senes et anus in plateis Ierusalem et unusquisque cum baculo suo in manu sua prae multitudine dierum;"
,"5":"et plateae civitatis complebuntur pueris et puellis ludentibus in plateis eius."
,"6":"Haec dicit Dominus exercituum: Si videbitur difficile in oculis reliquiarum populi huius in diebus illis, numquid etiam in oculis meis difficile erit?, dicit Dominus exercituum."
,"7":"Haec dicit Dominus exercituum: Ecce ego salvabo populum meum de terra orientis,et de terra occasus solis:"
,"8":"et adducam eos, et habitabunt in medio Ierusalem; et erunt mihi in populum, et ego ero eis in Deum,in veritate et iustitia."
,"9":"Haec dicit Dominus exercituum: Confortentur manus vestrae, qui auditis in his diebus sermones istos per os prophetarum in die, qua fundata est domus Domini exercituum, ut templum aedificaretur."
,"10":"Siquidem ante dies istos,merces hominis non erat, nec merces iumenti erat, neque introeunti neque exeunti,erat pax prae tribulatione; et dimisi omnes homines, unumquemque contra proximum suum."
,"11":"Nunc autem non iuxta dies priores ego sum,reliquiis populi huius, dicit Dominus exercituum;"
,"12":"sed semen pacis erit: vinea dabit fructum suum, et terra dabit proventum suum, et possidere faciam,reliquias populi huius,universa haec."
,"13":"Et erit: sicut eratis maledictio in gentibus, domus Iudae et domus Israel, sic salvabo vos, et eritis benedictio. Nolite timere; confortentur manus vestrae."
,"14":"Quia haec dicit Dominus exercituum: Sicut cogitavi, ut affligerem vos, cum ad iracundiam provocassent patres vestri me, dicit Dominus exercituum,"
,"15":"et non sum misertus, sic conversus cogitavi in diebus istis, ut benefaciam Ierusalem et domui Iudae; nolite timere."
,"16":"Haec sunt ergo, quae facietis: Loquimini veritatem unusquisque cum proximo suo et iudicium pacis iudicate in portis vestris,"
,"17":"et unusquisque malum contra amicum suum ne cogitetis in cordibus vestris et iuramentum mendax ne diligatis: omnia enim haec sunt quae odi ', dicit Dominus."
,"18":"Et factum est verbum Domini exercituum ad me dicens:"
,"19":"' Haec dicit Dominus exercituum: Ieiunium quarti et ieiunium quinti et ieiunium septimi et ieiunium decimi erit domui Iudae in gaudium et laetitiam et in sollemnitates praeclaras; veritatem tantum et pacem diligite."
,"20":"Haec dicit Dominus exercituum: Adhuc venient populi et habitatores civitatum magnarum,"
,"21":"et ibunt habitatores unius ad alteram dicentes: 'Eamus, ut deprecemur faciem Domini et quaeramus Dominum exercituum; vadam etiam ego'."
,"22":"Et venient populi multi et gentes robustae ad quaerendum Dominum exercituum in Ierusalem et deprecandam faciem Domini."
,"23":"Haec dicit Dominus exercituum: In diebus illis apprehendent decem homines ex omnibus linguis gentium, apprehendent fimbriam viri Iudaei dicentes: 'Ibimus vobiscum; audivimus enim quoniam Deus vobiscum est' '."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Oraculum. ' Verbum Domini in terra Ha drach,et Damasci requiei eius, quia Domini est oculus Aram,sicut omnes tribus Israel."
,"2":"Emath quoque in terminis eius,et Tyrus et Sidon, quae sapiens est valde."
,"3":"Et aedificavit Tyrus munitionem suam,et coacervavit argentum quasi pulverem,et aurum ut lutum platearum."
,"4":"Ecce Dominus possidebit eam,et percutiet in mari fortitudinem eius; et haec igni devorabitur."
,"5":"Videbit Ascalon et timebit, et Gaza dolore torquetur nimis, et Accaron, quoniam confusa est spes eius; et peribit rex de Gaza, et Ascalon non habitabitur."
,"6":"Et habitabit spurius in Azoto, et disperdam superbiam Philisthim."
,"7":"Et auferam sanguinem eius de ore eius,et abominationes eius de medio dentium eius, et relinquetur etiam ipse Deo nostro, et erit quasi dux in Iuda, et Accaron quasi Iebusaeus."
,"8":"Et circumdabo domum meam ut praesidium,contra euntes et revertentes; et non transibit super eos ultra exactor, quia nunc vidi in oculis meis."
,"9":"Exsulta satis, filia Sion; iubila, filia Ierusalem. Ecce rex tuus venit tibi,iustus et salvator ipse, pauper et sedens super asinum,et super pullum filium asinae."
,"10":"Et disperdam currum ex Ephraim,et equum de Ierusalem; et confringetur arcus belli, et loquetur pacem gentibus. Et imperium eius a mari usque ad mare,et a flumine usque ad fines terrae."
,"11":"Tu quoque: in sanguine testamenti tui,extraho vinctos tuos de lacu, in quo non est aqua."
,"12":"Convertimini ad munitionem, vincti spei; hodie quoque annuntians: Duplicia reddam tibi."
,"13":"Nam extendi mihi Iudam quasi arcum, implevi Ephraim; et suscitabo filios tuos, Sion, super filios tuos, Graecia, et ponam te quasi gladium fortium."
,"14":"Et Dominus super eos videbitur, et exibit ut fulgur iaculum eius; et Dominus Deus in tuba canet,et vadet in procellis austri."
,"15":"Dominus exercituum proteget eos; et devorabunt et conculcabunt lapides fundae,et bibent, agitabuntur quasi vino,et replebuntur ut phialae et quasi cornua altaris."
,"16":"Et salvabit eos Dominus Deus eorum,in die illa,ut gregem populi sui, quia lapides coronae,fulgebunt super terram eius."
,"17":"Quid enim bonum eius est, et quid pulchrum eius!,Frumentum succrescere facit iuvenes, et mustum virgines."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Petite a Domino pluviam,in tempore pluviae serotinae. Dominus facit fulgura,et pluviam imbris dabit eis, singulis herbam in agro."
,"2":"Quia theraphim loquuntur inania, et divini vident mendacium, et somnia loquuntur vana, vane consolantur; idcirco migrant quasi grex, affliguntur, quia non est eis pastor. "
,"3":"Super pastores iratus est furor meus, et super hircos visitabo: certe visitat Dominus exercituum,gregem suum, domum Iudae, et faciet eos quasi equum gloriae suae,in bello."
,"4":"Ex ipso angulus, ex ipso paxillus, ex ipso arcus proelii, ex ipso egredietur omnis exactor simul."
,"5":"Et erunt quasi fortes,conculcantes lutum viarum in proelio,et bellabunt, quia Dominus cum eis; et confundentur ascensores equorum."
,"6":"Et confortabo domum Iudae,et domum Ioseph salvabo,et reducam eos, quia miserebor eorum; et erunt, sicut non proiecissem eos: ego enim Dominus Deus eorum et exaudiam eos."
,"7":"Et erunt quasi fortes Ephraim, et laetabitur cor eorum quasi a vino, et filii eorum videbunt et laetabuntur, et exsultabit cor eorum in Domino."
,"8":"Sibilabo eis et congregabo illos, quia redemi eos, et multi erunt, sicut multi ante fuerant."
,"9":"Et seminabo eos in populis, et de longe recordabuntur mei; et alent filios suos et revertentur."
,"10":"Et reducam eos de terra Aegypti,et de Assyria congregabo eos,et ad terram Galaad et Libani adducam eos, et non invenietur eis locus."
,"11":"Et transibunt per mare angustiae, et percutiet in mari fluctus, et exiccabuntur omnia profunda fluminis; et humiliabitur superbia Assyriae, et sceptrum Aegypti recedet."
,"12":"Confortabo eos in Domino, et in nomine eius ambulabunt ', dicit Dominus."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Aperi, Libane, portas tuas, et comedat ignis cedros tuas."
,"2":"Ulula, abies, quia cecidit cedrus, quoniam magnifici vastati sunt; ululate, quercus Basan, quoniam corruit saltus impervius."
,"3":"Vox ululatus pastorum, quia vastata est magnificentia eorum; vox rugitus leonum, quoniam vastata est superbia Iordanis."
,"4":"Haec dicit Dominus Deus meus: ' Pasce pecora occisionis."
,"5":"Quae, qui emunt, occidunt et non dolent; et, qui vendunt ea, dicunt: 'Benedictus Dominus! Dives factus sum'. Et pastores eorum non miserentur eorum."
,"6":"Et ego non miserebor ultra super habitantes terram, dicit Dominus; ecce ego tradam homines, unumquemque in manu proximi sui et in manu regis sui; et concident terram, et non eruam de manu eorum '."
,"7":"Et ego pavi pecus occisionis pro mercatoribus gregis. Et assumpsi mihi duas virgas: unam vocavi Gratiam et alteram vocavi Funiculum; et pavi gregem."
,"8":"Et succidi tres pastores in mense uno, et taeduit eorum animam meam; siquidem et animam eorum taeduit mei."
,"9":"Et dixi: ' Non pascam vos. Quae moritura est, moriatur; et, quae succidenda est, succidatur; et reliquae devorent unaquaeque carnem proximae suae '."
,"10":"Et tuli virgam meam, quae vocabatur Gratia, et abscidi eam, ut irritum facerem foedus meum, quod percussi cum omnibus populis."
,"11":"Et irritum factum est in die illa; et cognoverunt mercatores gregis, qui observabant me, quia verbum Domini est."
,"12":"Et dixi ad eos: ' Si bonum est in oculis vestris, afferte mercedem meam et, si non, quiescite '. Et appenderunt mercedem meam triginta siclos argenteos."
,"13":"Et dixit Dominus ad me: ' Proice illud in thesaurum, decorum pretium, quo appretiatus sum ab eis '. Et tuli triginta siclos argenteos et proieci illos in domum Domini in thesaurum."
,"14":"Et praecidi virgam meam secundam, quae appellabatur Funiculus, ut dissolverem germanitatem inter Iudam et Israel."
,"15":"Et dixit Dominus ad me: ' Adhuc sume tibi vasa pastoris stulti;"
,"16":"quia ecce ego suscitabo pastorem in terra, qui perituram ovem non visitabit, dispersam non quaeret,et contritam non sanabit,et stantem non sustinebit,et carnes pinguium comedet,et ungulas earum confringet."
,"17":"Vae stulto meo pastori,derelinquenti gregem!,Gladius super brachium eius,et super oculum dextrum eius; brachium eius ariditate siccetur, et oculus dexter eius tenebrescens obscuretur '."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Oraculum. Verbum Domini super Israel et super Iudam. Oraculum Domini, qui extendit caelum et fundat terram et fingit spiritum hominis in eo:"
,"2":"' Ecce ego pono Ierusalem pateram crapulae omnibus populis in circuitu. Hoc erit in obsidione contra Ierusalem."
,"3":"Et erit: in die illa ponam Ierusalem lapidem portandum cunctis populis; omnes portantes eam concisione lacerabuntur, et colligentur adversus eam omnes gentes terrae."
,"4":"In die illa, dicit Dominus, percutiam omnem equum in stuporem et ascensorem eius in amentiam; et super domum Iudae aperiam oculos meos et omnem equum populorum percutiam caecitate."
,"5":"Et dicent duces Iudae in corde suo: 'Robur habitantium Ierusalem est in Domino exercituum, Deo eorum'."
,"6":"In die illa ponam duces Iudae sicut ollam ignis super ligna et sicut facem ignis super fenum; et devorabunt ad dexteram et ad sinistram omnes populos in circuitu, et habitabitur Ierusalem rursus in loco suo."
,"7":"Et salvabit Dominus prius tabernacula Iudae, ut non elevetur gloria domus David et gloria habitantium Ierusalem contra Iudam."
,"8":"In die illa proteget Dominus habitatores Ierusalem; et erit, qui offenderit ex eis in die illa quasi David, et domus David quasi Deus, sicut angelus Domini in conspectu eorum."
,"9":"Et erit: in die illa quaeram conterere omnes gentes, quae veniunt contra Ierusalem,"
,"10":"et effundam super domum David et super habitatores Ierusalem spiritum gratiae et precum; et aspicient ad me. Quem confixerunt, plangent quasi planctu super unigenitum et dolebunt super eum, ut doleri solet super primogenitum."
,"11":"In die illa magnus erit planctus in Ierusalem sicut planctus Adadremmon in campo Mageddo;"
,"12":"et planget terra, singulae familiae seorsum: familia domus David seorsum,et mulieres eorum seorsum; familia domus Nathan seorsum,et mulieres eorum seorsum;"
,"13":"familia domus Levi seorsum,et mulieres eorum seorsum; familia Semei seorsum,et mulieres eorum seorsum;"
,"14":"omnes reliquae familiae, singulae familiae seorsum,et mulieres eorum seorsum."
}`)
	CurrentBook.AddChapter(13, `{
"1":"In die illa erit fons patens domui David et habitantibus Ierusalem pro peccatis et immunditia."
,"2":"Et erit in die illa, dicit Dominus exercituum, disperdam nomina idolorum de terra, et non memorabuntur ultra; et pseudoprophetas et spiritum immundum auferam de terra."
,"3":"Et erit: cum prophetaverit quispiam ultra, dicent ei pater eius et mater eius, qui genuerunt eum: 'Non vives, quia mendacium locutus es in nomine Domini'; et configent eum pater eius et mater eius, qui genuerunt eum, cum prophetaverit."
,"4":"Et erit: in die illa confundentur prophetae, unusquisque ex visione sua, cum prophetaverit; nec operientur pallio saccino, ut mentiantur,"
,"5":"sed dicet: 'Non sum propheta; homo operans terram ego sum, quoniam terra est possessio mea ab adulescentia mea'."
,"6":"Et dicetur ei: 'Quid sunt plagae istae in medio manuum tuarum?'. Et dicet: 'His plagatus sum in domo eorum, qui diligebant me'."
,"7":"Framea, suscitare super pastorem meum,et super virum cohaerentem mihi, dicit Dominus exercituum. Percute pastorem, et dispergentur oves, et convertam manum meam contra parvulos."
,"8":"Et erit in omni terra, dicit Dominus: partes duae in ea dispergentur et deficient, et tertia pars relinquetur in ea;"
,"9":"et ducam tertiam partem per ignem,et purgabo eos, sicut purgatur argentum, et probabo eos, sicut probatur aurum: ipse vocabit nomen meum, et ego exaudiam eum. Dicam: Populus meus est ille; et ipse dicet: 'Dominus est Deus meus'."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Ecce venit dies Domino, et dividentur spolia tua in me dio tui,"
,"2":"et congregabo omnes gentes ad Ierusalem in proelium, et capietur civitas, et vastabuntur domus, et mulieres violabuntur; et egredietur media pars civitatis in captivitatem, et reliquum populi non auferetur ex urbe."
,"3":"Et egredietur Dominus et proeliabitur contra gentes illas, sicut proeliatus est in die certaminis."
,"4":"Et stabunt pedes eius in die illa super montem Olivarum, qui est contra Ierusalem ad orientem; et scindetur mons Olivarum ex media parte sui ad orientem et ad occidentem, praerupto grandi valde, et separabitur medium montis ad aquilonem et medium eius ad meridiem."
,"5":"Et fugietis ad vallem montium eorum, quoniam vallis montium pertinget usque ad Iasol; et fugietis, sicut fugistis a facie terraemotus in diebus Oziae regis Iudae, et veniet Dominus Deus meus, omnesque sancti cum eo."
,"6":"Erit: in die illa non erit lux sed frigus et gelu;"
,"7":"et erit dies una, quae nota est Domino, non dies neque nox; et in tempore vesperi erit lux."
,"8":"Et erit: in die illa exibunt aquae vivae de Ierusalem, medium earum ad mare orientale, et medium earum ad mare occidentale: in aestate et in hieme erunt."
,"9":"Et erit Dominus rex super omnem terram: in die illa erit Dominus unus, et erit nomen eius unum."
,"10":"Et revertetur omnis terra in desertum, a Gabaa usque ad Remmon ad austrum Ierusalem, quae exaltabitur et habitabitur in loco suo, a porta Beniamin usque ad locum portae Prioris, et usque ad portam Angulorum, et a turre Hananeel usque ad Torcularia regis."
,"11":"Et habitabunt in ea, et anathema non erit amplius; sed habitabitur Ierusalem secura."
,"12":"Et haec erit plaga, qua percutiet Dominus omnes gentes, quae pugnaverunt adversus Ierusalem: tabescet caro uniuscuiusque stantis super pedes suos, et oculi eius contabescent in foraminibus suis, et lingua eius contabescet in ore suo."
,"13":"In die illa erit tumultus Domini magnus in eis, et apprehendet vir manum proximi sui, et elevabitur manus eius super manum proximi sui."
,"14":"Sed et Iudas pugnabit in Ierusalem, et congregabuntur divitiae omnium gentium in circuitu, aurum et argentum et vestes multae nimis."
,"15":"Et sic erit ruina equi, muli, cameli et asini et omnium iumentorum, quae fuerint in castris illis, sicut ruina haec."
,"16":"Et omnes, qui reliqui fuerint de universis gentibus, quae venerunt contra Ierusalem, ascendent ab anno in annum, ut adorent Regem, Dominum exercituum, et celebrent festivitatem Tabernaculorum."
,"17":"Et erit: qui non ascenderit de familiis terrae ad Ierusalem, ut adoret Regem, Dominum exercituum, non erit super eos imber."
,"18":"Quod et si familia Aegypti non ascenderit et non venerit, super eos erit plaga, qua percutit Dominus gentes, quae non ascenderint ad celebrandam festivitatem Tabernaculorum."
,"19":"Haec erit poena Aegypti, et haec poena omnium gentium, quae non ascenderint ad celebrandam festivitatem Tabernaculorum."
,"20":"In die illa erit super tintinnabula equorum; 'Sanctum Domino'; et erunt lebetes in domo Domini quasi phialae coram altari."
,"21":"Et erit omnis lebes in Ierusalem et in Iuda sanctificatus Domino exercituum; et venient omnes immolantes et sument ex eis et coquent in eis, et non erit mercator ultra in domo Domini exercituum in die illo '."
}`)

}
func LA_NVBSE_LoadVPDTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Haec sunt verba, quae locutus est Moyses ad omnem Israel trans Iordanem in solitudine, in Araba contra Suph, inter Pharan et Thophel et Laban et Aseroth et Dizahab."
,"2":"Undecim dies de Horeb per viam montis Seir usque Cadesbarne."
,"3":"Quadragesimo anno, undecimo mense, prima die mensis locutus est Moyses ad filios Israel omnia, quae praeceperat illi Dominus ut diceret eis."
,"4":"Postquam percussit Sehon regem Amorraeorum, qui habitavit in Hesebon, et Og regem Basan, qui mansit in Astharoth et in Edrai,"
,"5":"trans Iordanem in terra Moab coepitque Moyses explanare legem hanc et dicere:"
,"6":"' Dominus Deus noster locutus est ad nos in Horeb dicens: 'Sufficit vobis quod in hoc monte mansistis;"
,"7":"convertimini et proficiscimini et venite ad montem Amorraeorum et ad omnes vicinos eius: in Araba atque montanis et in Sephela et in Nageb et iuxta litus maris, in terram Chananaeorum et in Libanum usque ad flumen magnum Euphraten."
,"8":"En, inquit, tradidi vobis terram: ingredimini et possidete eam, super qua iuravit Dominus patribus vestris, Abraham, Isaac et Iacob, ut daret illam eis et semini eorum post eos'."
,"9":"Dixique vobis illo in tempore: Non possum solus sustinere vos;"
,"10":"Dominus Deus vester multiplicavit vos, et estis hodie sicut stellae caeli plurimi."
,"11":"Dominus, Deus patrum vestrorum, addat ad hunc numerum multa milia et benedicat vobis, sicut locutus est vobis."
,"12":"Non valeo solus vestra negotia sustinere et pondus ac iurgia;"
,"13":"date vobis viros sapientes et gnaros, et quorum conversatio sit probata in tribubus vestris, ut ponam eos vobis principes."
,"14":"Tunc respondistis mihi: 'Bona res est, quam vis facere'."
,"15":"Tulique principes de tribubus vestris viros sapientes et probatos et constitui eos principes super vos: tribunos et centuriones et quinquagenarios ac decanos et praefectos operum pro tribubus vestris."
,"16":"Praecepique iudicibus vestris in tempore illo: Audite causam fratrum vestrorum et, quod iustum est, iudicate, sive civis sit ille sive peregrinus."
,"17":"Non accipietis personam in iudicio; ita parvum audietis ut magnum nec timebitis cuiusquam personam, quia Dei iudicium est. Quod si difficile vobis aliquid visum fuerit, referte ad me, et ego audiam."
,"18":"Praecepique vobis in tempore illo omnia, quae facere deberetis."
,"19":"Profecti autem de Horeb transivimus per totam illam eremum maximam et terribilem, quam vidistis, per viam montis Amorraei, sicut praeceperat Dominus Deus noster nobis. Cumque venissemus in Cadesbarne,"
,"20":"dixi vobis: Venistis ad montem Amorraei, quem Dominus Deus noster daturus est nobis."
,"21":"Vide terram, quam Dominus Deus tuus dat tibi: ascende et posside eam, sicut locutus est tibi Dominus, Deus patrum tuorum; noli metuere nec quidquam paveas."
,"22":"Et accessistis ad me vos omnes atque dixistis: 'Mittamus viros ante nos, qui considerent terram et renuntient de itinere, per quod debeamus ascendere, et de civitatibus, ad quas pergere'."
,"23":"Cumque mihi sermo placuisset, misi ex vobis duodecim viros singulos de tribubus suis."
,"24":"Qui cum perrexissent et ascendissent in montana, venerunt usque ad Nehelescol et, considerata terra,"
,"25":"sumentes de fructibus eius attulerunt ad nos atque dixerunt: 'Bona est terra, quam Dominus Deus noster daturus est nobis'."
,"26":"Et noluistis ascendere, sed increduli ad sermonem Domini Dei vestri"
,"27":"murmurastis in tabernaculis vestris atque dixistis: 'Odit nos Dominus et idcirco eduxit nos de terra Aegypti, ut traderet nos in manu Amorraei atque deleret."
,"28":"Quo ascendemus? Fratres nostri terruerunt cor nostrum dicentes: Maxima multitudo est et nobis in statura procerior; urbes magnae et ad caelum usque munitae; etiam filios Enacim vidimus ibi'."
,"29":"Et dixi vobis: Nolite metuere nec timeatis eos."
,"30":"Dominus Deus, qui ductor est vester, ipse pro vobis pugnabit, sicut fecit in Aegypto, vobis videntibus."
,"31":"Et in solitudine - ipse vidisti - portavit te Dominus Deus tuus, ut solet homo gestare parvulum filium suum, in omni via, per quam ambulastis, donec veniretis ad locum istum."
,"32":"Et nec sic quidem credidistis Domino Deo vestro,"
,"33":"qui praecessit vos in via, et metatus est locum, in quo tentoria figere deberetis, nocte ostendens vobis iter per ignem et die per columnam nubis."
,"34":"Cumque audisset Dominus vocem sermonum vestrorum, iratus iuravit et ait:"
,"35":"'Non videbit quispiam de viris generationis huius pessimae terram bonam, quam sub iuramento pollicitus sum patribus vestris,"
,"36":"praeter Chaleb filium Iephonne: ipse enim videbit eam, et ipsi dabo terram, quam calcavit, et filiis eius, quia adimplevit ut sequeretur Dominum'."
,"37":"Mihi quoque iratus Dominus propter vos dixit: 'Nec tu ingredieris illuc;"
,"38":"sed Iosue filius Nun minister tuus ipse intrabit illuc. Hunc robora, et ipse terram sorte dividat Israeli."
,"39":"Parvuli vestri, de quibus dixistis quod captivi ducerentur, et filii, qui hodie boni ac mali ignorant distantiam, ipsi ingredientur; et ipsis dabo terram, et possidebunt eam."
,"40":"Vos autem revertimini et abite in solitudinem per viam maris Rubri'."
,"41":"Et respondistis mihi: 'Peccavimus Domino; nos ascendemus atque pugnabimus, sicut praecepit nobis Dominus Deus noster'. Cumque instructi armis pergeretis in montem,"
,"42":"ait mihi Dominus: 'Dic ad eos: Nolite ascendere neque pugnetis, non enim sum vobiscum, ne cadatis coram inimicis vestris'."
,"43":"Locutus sum, et non audistis, sed adversantes imperio Domini et tumentes superbia ascendistis in montem."
,"44":"Itaque egressus Amorraeus, qui habitat in monte illo, obviam vobis, persecutus est vos, sicut solent apes persequi, et cecidit vos de Seir usque Horma."
,"45":"Cumque reversi ploraretis coram Domino, non audivit vos nec voci vestrae voluit acquiescere."
,"46":"Sedistis ergo in Cades multo illo tempore, dum ibi mansistis."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Profectique inde venimus in solitudinem per viam maris Ru bri, sicut mihi dixerat Dominus; et circuivimus montem Seir longo tempore."
,"2":"Dixitque Dominus ad me:"
,"3":"'Sufficit vobis circuire montem istum; ite contra aquilonem."
,"4":"Et populo praecipe dicens: Transibitis per terminos fratrum vestrorum filiorum Esau, qui habitant in Seir, et timebunt vos."
,"5":"Cavete ergo diligenter, ne moveamini contra eos; neque enim dabo vobis de terra eorum, quantum potest unius pedis calcare vestigium, quia in possessionem Esau dedi montem Seir."
,"6":"Cibos emetis ab eis pecunia et comedetis; etiam aquam emptam haurietis et bibetis."
,"7":"Dominus Deus tuus benedixit tibi in omni opere manuum tuarum; novit iter tuum, quomodo transieris solitudinem hanc magnam per quadraginta annos habitans tecum Dominus Deus tuus, et nihil tibi defuit'."
,"8":"Cumque transissemus fratres nostros filios Esau, qui habitabant in Seir, per viam Arabae de Ailath et de Asiongaber, vertimus nos et venimus per iter, quod ducit in desertum Moab."
,"9":"Dixitque Dominus ad me: 'Non pugnes contra Moabitas nec ineas adversus eos proelium; non enim dabo tibi quidquam de terra eorum, quia filiis Lot tradidi Ar in possessionem."
,"10":"- Emim primi fuerunt habitatores eius, populus magnus et multus et tam excelsus ut Enacim;"
,"11":"ipsi quoque Raphaim reputabantur sicut Enacim; denique Moabitae appellant eos Emim."
,"12":"In Seir autem prius habitaverunt Horim; quibus expulsis atque deletis, habitaverunt filii Esau pro eis, sicut fecit Israel in terra possessionis suae, quam dedit eis Dominus C."
,"13":"Surgite ergo et transite torrentem Zared'. Et transivimus torrentem Zared."
,"14":"Tempus autem, quo ambulavimus de Cadesbarne usque ad transitum torrentis Zared, triginta octo annorum fuit, donec consumeretur omnis generatio hominum bellatorum de castris, sicut iuraverat eis Dominus,"
,"15":"cuius manus fuit adversum eos, ut interirent de castrorum medio."
,"16":"Postquam autem universi ceciderunt pugnatores de medio populi,"
,"17":"locutus est Dominus ad me dicens:"
,"18":"'Tu transibis hodie terminos Moab, urbem nomine Ar;"
,"19":"et accedens in vicina filiorum Ammon, cave, ne pugnes contra eos nec movearis ad proelium; non enim dabo tibi de terra filiorum Ammon, quia filiis Lot dedi eam in possessionem."
,"20":"- Terra Raphaim reputata est et ipsa olim habitaverunt Raphaim in ea, quos Ammonitae vocant Zomzommim,"
,"21":"populus magnus et multus et procerae longitudinis sicut Enacim, quos delevit Dominus a facie eorum et fecit illos habitare pro eis,"
,"22":"sicut fecerat filiis Esau, qui habitant in Seir, delens Horim et terram eorum illis tradens, quam possident usque in praesens."
,"23":"Hevaeos quoque, qui habitabant in villis usque Gazam, Caphtorim, qui egressi de Caphtor deleverunt eos et habitaverunt pro illis C."
,"24":"Surgite! Proficiscimini et transite torrentem Arnon: ecce tradidi in manu tua Sehon regem Hesebon Amorraeum; et terram eius incipe possidere et committe adversus eum proelium."
,"25":"Hodie incipiam mittere terrorem atque formidinem tuam in populos, qui habitant sub omni caelo, ut, audito nomine tuo, paveant et contremiscant coram te'."
,"26":"Misi ergo nuntios de solitudine Cademoth ad Sehon regem Hesebon verbis pacificis dicens:"
,"27":"Transibo per terram tuam, publica gradiar via, non declinabo neque ad dexteram neque ad sinistram;"
,"28":"alimenta pretio vende mihi, ut vescar, aquam pecunia tribue mihi, et sic bibam; tantum est ut mihi concedas transitum,"
,"29":"sicut fecerunt mihi filii Esau, qui habitant in Seir, et Moabitae, qui morantur in Ar, donec veniam ad Iordanem et transeam in terram, quam Dominus Deus noster daturus est nobis."
,"30":"Noluitque Sehon rex Hesebon dare nobis transitum, quia induraverat Dominus Deus tuus spiritum eius et obfirmaverat cor illius, ut traderetur in manus tuas, sicut est in praesenti die."
,"31":"Dixitque Dominus ad me: 'Ecce coepi tradere tibi Sehon et terram eius. Incipe possidere eam!'."
,"32":"Egressusque est Sehon obviam nobis cum omni populo suo ad proelium in Iasa,"
,"33":"et tradidit eum Dominus Deus noster nobis; percussimusque eum cum filiis suis et omni populo suo."
,"34":"Cunctasque urbes eius in tempore illo cepimus et percussimus anathemate singulas civitates cum viris ac mulieribus et parvulis; neminem reliquimus in eis superstitem,"
,"35":"absque iumentis, quae in partem venere praedantium, et spoliis urbium, quas cepimus."
,"36":"Ab Aroer, quae est super ripam torrentis Arnon, et oppido, quod in valle situm est, usque Galaad non fuit civitas, quae nostras effugeret manus: omnia tradidit Dominus Deus noster nobis,"
,"37":"absque terra filiorum Ammon, ad quam non accessisti, cunctis, quae adiacent torrenti Iaboc, et urbibus montanis universisque locis, a quibus nos prohibuit Dominus Deus noster."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Itaque conversi ascendimus per iter Basan; egressusque est Og rex Basan in occursum nobis cum omni populo suo ad bellandum in Edrai."
,"2":"Dixitque Dominus ad me: 'Ne timeas eum, quia in manu tua tradidi eum cum omni populo ac terra sua; faciesque ei, sicut fecisti Sehon regi Amorraeorum, qui habitavit in Hesebon'."
,"3":"Tradidit ergo Dominus Deus noster in manibus nostris etiam Og regem Basan et universum populum eius; percussimusque eos usque ad internecionem."
,"4":"Et cepimus cunctas civitates eius in illo tempore. Non fuit oppidum, quod nos effugeret: sexaginta urbes, omnem regionem Argob, regnum Og in Basan."
,"5":"Cunctae urbes erant munitae muris altissimis portisque et vectibus, absque oppidis innumeris, quae non habebant muros."
,"6":"Et percussimus eos anathemate, sicut feceramus Sehon regi Hesebon, disperdentes omnem civitatem virosque ac mulieres et parvulos;"
,"7":"iumenta autem et spolia urbium diripuimus."
,"8":"Tulimusque illo in tempore terram de manu duorum regum Amorraeorum, qui erant trans Iordanem, a torrente Arnon usque ad montem Hermon"
,"9":"- Sidonii vocant Hermon Sarion et Amorraei Sanir -"
,"10":"omnes civitates, quae sitae sunt in planitie, et universam terram Galaad et Basan usque Salcha et Edrai, civitates regni Og in Basan."
,"11":"- Solus quippe Og rex Basan remanserat de residuis Raphaim. Monstratur lectus eius ferreus. Nonne est in Rabba filiorum Ammon? Novem cubitos habet longitudinis et quattuor latitudinis ad mensuram cubiti virilis manus C."
,"12":"Terramque hanc possedimus in tempore illo ab Aroer, quae est super ripam torrentis Arnon, usque ad mediam partem montis Galaad; et civitates illius dedi Ruben et Gad."
,"13":"Reliquam autem partem Galaad et omnem Basan, regnum Og, tradidi mediae tribui Manasse, omnem regionem Argob. Cuncta Basan vocatur terra Raphaim."
,"14":"Iair filius Manasse possedit omnem regionem Argob usque ad terminos Gesuri et Maachathi; vocavitque ea ex nomine suo Basan Havoth Iair (id est villas Iair) usque in praesentem diem."
,"15":"Machir quoque dedi Galaad."
,"16":"Et tribubus Ruben et Gad dedi de terra Galaad usque ad torrentem Arnon, medium torrentis et confinium usque ad torrentem Iaboc, qui est terminus filiorum Ammon;"
,"17":"et Arabam atque Iordanem et terminos a Chenereth usque ad mare Arabae, quod est mare Salis, ad radices montis Phasga contra orientem."
,"18":"Praecepique vobis in tempore illo dicens: Dominus Deus vester dedit vobis terram hanc in hereditatem; expediti praecedite fratres vestros filios Israel, omnes viri robusti,"
,"19":"absque uxoribus et parvulis ac iumentis. Novi enim quod plura habeatis pecora, et in urbibus remanere debebunt, quas tradidi vobis,"
,"20":"donec requiem tribuat Dominus fratribus vestris, sicut vobis tribuit, et possideant etiam ipsi terram, quam Dominus Deus vester daturus est eis trans Iordanem; tunc revertetur unusquisque in possessionem suam, quam dedi vobis."
,"21":"Iosue quoque in tempore illo praecepi dicens: Oculi tui viderunt, quae fecit Dominus Deus vester duobus his regibus; sic faciet omnibus regnis, ad quae transiturus es."
,"22":"Ne timeas eos: Dominus enim Deus vester pugnabit pro vobis."
,"23":"Precatusque sum Dominum in tempore illo dicens:"
,"24":"Domine Deus, tu coepisti ostendere servo tuo magnitudinem tuam manumque fortissimam; neque enim est alius Deus vel in caelo vel in terra, qui possit facere opera tua et comparari fortitudini tuae."
,"25":"Transeam igitur et videam terram hanc optimam trans Iordanem et montem istum egregium et Libanum."
,"26":"Iratusque est Dominus mihi propter vos nec exaudivit me, sed dixit mihi: 'Sufficit tibi; nequaquam ultra loquaris de hac re ad me."
,"27":"Ascende cacumen Phasgae et oculos tuos circumfer ad occidentem et aquilonem austrumque et orientem et aspice; nec enim transibis Iordanem istum."
,"28":"Praecipe Iosue et corrobora eum atque conforta, quia ipse praecedet populum istum et dividet eis terram, quam visurus es'."
,"29":"Mansimusque in valle contra Bethphegor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Et nunc, Israel, audi praecepta et iudicia, quae ego doceo vos, ut facientes ea vivatis et ingredientes possideatis terram, quam Dominus, Deus patrum vestrorum, daturus est vobis."
,"2":"Non addetis ad verbum, quod vobis loquor, neque auferetis ex eo; custodite mandata Domini Dei vestri, quae ego praecipio vobis."
,"3":"Oculi vestri viderunt omnia, quae fecit Dominus contra Baalphegor, quomodo contriverit omnes cultores eius de medio vestri;"
,"4":"vos autem, qui adhaeretis Domino Deo vestro, vivitis universi usque in praesentem diem."
,"5":"En docui vos praecepta atque iudicia, sicut mandavit mihi Dominus Deus meus, ut faceretis ea in terra, quam possessuri estis,"
,"6":"et observaretis et impleretis opere. Haec est enim vestra sapientia et intellectus coram populis, ut audientes universa praecepta haec dicant: 'En populus sapiens et intellegens, gens magna haec!'."
,"7":"Quae est enim alia natio tam grandis, quae habeat deos appropinquantes sibi, sicut Dominus Deus noster adest cunctis obsecrationibus nostris?"
,"8":"Et quae est alia gens sic inclita, ut habeat praecepta iustaque iudicia, sicut est universa lex haec, quam ego proponam hodie ante oculos vestros?"
,"9":"Custodi igitur temetipsum et animam tuam sollicite, ne obliviscaris verborum, quae viderunt oculi tui, et ne excidant de corde tuo cunctis diebus vitae tuae. Docebis ea filios ac nepotes tuos"
,"10":"die, in quo stetisti coram Domino Deo tuo in Horeb, quando Dominus locutus est mihi: 'Congrega ad me populum, ut audiant sermones meos et discant timere me omni tempore, quo vivunt in terra, doceantque filios suos'."
,"11":"Et accessistis et stetistis ad radices montis, qui ardebat usque ad caelum, erantque in eo tenebrae, nubes et caligo."
,"12":"Locutusque est Dominus ad vos de medio ignis; vocem verborum audistis et formam penitus non vidistis."
,"13":"Et ostendit vobis pactum suum, quod praecepit, ut faceretis, et decem verba, quae scripsit in duabus tabulis lapideis."
,"14":"Mihique mandavit in illo tempore, ut docerem vos praecepta et iudicia, quae facere deberetis in terra, quam possessuri estis."
,"15":"Custodite igitur sollicite animas vestras. Non vidistis aliquam similitudinem in die, qua locutus est vobis Dominus in Horeb de medio ignis;"
,"16":"ne forte corrupti faciatis vobis sculptam similitudinem, imaginem masculi vel feminae,"
,"17":"similitudinem omnium iumentorum, quae sunt super terram, vel avium sub caelo volantium"
,"18":"atque reptilium, quae moventur in terra, sive piscium, qui sub terra morantur in aquis;"
,"19":"et ne forte oculis elevatis ad caelum videas solem et lunam et astra, omnem exercitum caeli, et errore deceptus adores ea et colas, quae attribuit Dominus Deus tuus cunctis gentibus, quae sub caelo sunt."
,"20":"Vos autem tulit Dominus et eduxit de fornace ferrea Aegypti, ut haberet populum hereditarium, sicut est in praesenti die."
,"21":"Iratusque est Dominus contra me propter sermones vestros et iuravit, ut non transirem Iordanem nec ingrederer terram optimam, quam Dominus Deus tuus daturus est tibi in haereditatem."
,"22":"Ecce morior in hac humo, non transibo Iordanem; vos transibitis et possidebitis terram egregiam hanc."
,"23":"Cavete, ne quando obliviscamini pacti Domini Dei vestri, quod pepigit vobiscum, et faciatis vobis sculptam similitudinem omnium, quae fieri Dominus Deus tuus prohibuit;"
,"24":"quia Dominus Deus tuus ignis consumens est, Deus aemulator."
,"25":"Si genueris filios ac nepotes, et morati fueritis in terra corruptique feceritis aliquam similitudinem sculptam patrantes malum coram Domino Deo tuo, ut eum ad iracundiam provocetis,"
,"26":"testes invoco contra vos hodie caelum et terram, cito perituros vos esse de terra, quam, transito Iordane, possessuri estis: non habitabitis in ea longo tempore, sed delebit vos Dominus"
,"27":"atque disperget in gentes, et remanebitis pauci in nationibus, ad quas vos ducturus est Dominus."
,"28":"Ibique servietis diis, qui hominum manu fabricati sunt, ligno et lapidi, qui non vident nec audiunt nec comedunt nec odorantur."
,"29":"Cumque quaesieris ibi Dominum Deum tuum, invenies eum, si tamen toto corde quaesieris eum et tota anima tua."
,"30":"Postquam in tribulatione tua te invenerint omnia, quae praedicta sunt, novissimo tempore reverteris ad Dominum Deum tuum et audies vocem eius;"
,"31":"quia Deus misericors Dominus Deus tuus est, non dimittet te nec omnino delebit neque obliviscetur pacti, in quo iuravit patribus tuis."
,"32":"Interroga de diebus antiquis, qui fuerunt ante te ex die, quo creavit Deus hominem super terram, et a summo caeli usque ad summum eius, si facta est aliquando huiuscemodi res magna, aut umquam cognitum est,"
,"33":"num audivit populus vocem Dei loquentis de medio ignis, sicut tu audisti et vixisti?"
,"34":"Aut tentavit Deus, ut ingrederetur et tolleret sibi gentem de medio nationis per tentationes, signa atque portenta, per pugnam et robustam manum extentumque brachium et terrores magnos, iuxta omnia, quae fecit pro vobis Dominus Deus vester in Aegypto, videntibus oculis tuis?"
,"35":"Tibi monstratum est, ut scires quoniam Dominus ipse est Deus, et non est alius praeter eum."
,"36":"De caelo te fecit audire vocem suam, ut doceret te, et in terra ostendit tibi ignem suum maximum; et audisti verba illius de medio ignis,"
,"37":"quia dilexit patres tuos et elegit semen eorum post eos. Eduxitque te vultu suo in virtute sua magna ex Aegypto,"
,"38":"ut expelleret nationes maiores et fortiores te in introitu tuo et introduceret te daretque tibi terram earum in possessionem, sicut cernis in praesenti die."
,"39":"Scito ergo hodie et cogitato in corde tuo quod Dominus ipse sit Deus in caelo sursum et in terra deorsum, et non sit alius."
,"40":"Custodi praecepta eius atque mandata, quae ego praecipio tibi hodie, ut bene sit tibi et filiis tuis post te, et permaneas multo tempore super terram, quam Dominus Deus tuus daturus est tibi '."
,"41":"Tunc separavit Moyses tres civitates trans Iordanem ad orientalem plagam,"
,"42":"ut confugiat ad eas, qui occiderit nolens proximum suum, nec fuerit inimicus ante unum et alterum diem, et ad harum aliquam urbium possit evadere et vivat:"
,"43":"Bosor in solitudine, quae sita est in terra campestri, pro tribu Ruben, et Ramoth in Galaad pro tribu Gad et Golan in Basan pro tribu Manasse."
,"44":"Ista est lex, quam proposuit Moyses coram filiis Israel;"
,"45":"haec testimonia et praecepta atque iudicia, quae locutus est ad filios Israel, quando egressi sunt de Aegypto,"
,"46":"trans Iordanem in valle contra Bethphegor, in terra Sehon regis Amorraei, qui habitavit in Hesebon, quem percussit Moyses et filii Israel egressi ex Aegypto."
,"47":"Et possederunt terram eius et terram Og regis Basan, duorum regum Amorraeorum, qui erant trans Iordanem ad solis ortum,"
,"48":"ab Aroer, quae sita est super ripam torrentis Arnon, usque ad montem Sion, qui est Hermon,"
,"49":"omnem Arabam trans Iordanem ad orientalem plagam usque ad mare Arabae et usque ad radices montis Phasga."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Vocavitque Moyses omnem Israelem et dixit ad eos: ' Audi, Israel, praecepta atque iudicia, quae ego loquor in auribus vestris hodie; discite ea et opere complete."
,"2":"Dominus Deus noster pepigit nobiscum foedus in Horeb."
,"3":"Non cum patribus nostris iniit pactum hoc sed nobiscum, qui in praesentiarum hic sumus, omnibus nobis, qui vivimus."
,"4":"Facie ad faciem locutus est vobis in monte de medio ignis;"
,"5":"ego sequester et medius fui inter Dominum et vos in tempore illo, ut annuntiarem vobis verba eius; timuistis enim ignem et non ascendistis in montem. Et ait:"
,"6":"'Ego Dominus Deus tuus, qui eduxi te de terra Aegypti, de domo servitutis."
,"7":"Non habebis deos alienos in conspectu meo."
,"8":"Non facies tibi sculptile nec similitudinem omnium, quae in caelo sunt desuper et quae in terra deorsum et quae versantur in aquis sub terra."
,"9":"Non adorabis ea et non coles: Ego enim sum Dominus Deus tuus, Deus aemulator, reddens iniquitatem patrum super filios in tertiam et quartam generationem his, qui oderunt me,"
,"10":"et faciens misericordiam in multa milia diligentibus me et custodientibus praecepta mea."
,"11":"Non usurpabis nomen Domini Dei tui frustra, quia non erit impunitus, qui super re vana nomen eius assumpserit."
,"12":"Observa diem sabbati, ut sanctifices eum, sicut praecepit tibi Dominus Deus tuus."
,"13":"Sex diebus operaberis et facies omnia opera tua."
,"14":"Septimus dies sabbatum est Domino Deo tuo. Non facies in eo quidquam operis tu et filius tuus et filia, servus et ancilla et bos et asinus et omne iumentum tuum et peregrinus tuus, qui est intra portas tuas, ut requiescat servus tuus et ancilla tua sicut et tu."
,"15":"Memento quod et ipse servieris in Aegypto, et eduxerit te inde Dominus Deus tuus in manu forti et brachio extento: idcirco praecepit tibi, ut observares diem sabbati."
,"16":"Honora patrem tuum et matrem, sicut praecepit tibi Dominus Deus tuus, ut longo vivas tempore et bene sit tibi in terra, quam Dominus Deus tuus daturus est tibi."
,"17":"Non occides."
,"18":"Neque moechaberis."
,"19":"Furtumque non facies."
,"20":"Nec loqueris contra proximum tuum falsum testimonium."
,"21":"Nec concupisces uxorem proximi tui. Nec desiderabis domum proximi tui, non agrum, non servum, non ancillam, non bovem, non asinum et universa, quae illius sunt'."
,"22":"Haec verba locutus est Dominus ad omnem multitudinem vestram in monte, de medio ignis et nubis et caliginis voce magna nihil addens amplius; et scripsit ea in duabus tabulis lapideis, quas tradidit mihi."
,"23":"Vos autem, postquam audistis vocem de medio tenebrarum et montem ardere vidistis, accessistis ad me omnes principes tribuum et maiores natu"
,"24":"atque dixistis: 'Ecce ostendit nobis Dominus Deus noster maiestatem et magnitudinem suam; vocem eius audivimus de medio ignis et probavimus hodie quod, loquente Deo cum homine, vixerit homo."
,"25":"Nunc autem cur moriemur, et devorabit nos ignis hic maximus? Si enim audierimus ultra vocem Domini Dei nostri, moriemur."
,"26":"Quid est omnis caro, ut audiat vocem Dei viventis, qui de medio ignis loquitur, sicut nos audivimus, et possit vivere?"
,"27":"Tu magis accede et audi cuncta, quae dixerit Dominus Deus noster, et tu loqueris ad nos cuncta, quae dixerit Dominus Deus noster tibi, et nos audientes faciemus ea'."
,"28":"Quod cum audisset Dominus, ait ad me: 'Audivi vocem verborum populi huius, quae locuti sunt tibi: bene omnia sunt locuti."
,"29":"Quis det talem eos habere mentem, ut timeant me et custodiant universa mandata mea in omni tempore, ut bene sit eis et filiis eorum in sempiternum?"
,"30":"Vade et dic eis: Revertimini in tentoria vestra."
,"31":"Tu vero, hic sta mecum, et loquar tibi omnia mandata et praecepta atque iudicia, quae docebis eos, ut faciant ea in terra, quam dabo illis in possessionem'."
,"32":"Custodite igitur et facite, quae praecepit Dominus Deus vester vobis; non declinabitis neque ad dexteram neque ad sinistram,"
,"33":"sed per totam viam, quam praecepit Dominus Deus vester, ambulabitis, ut vivatis, et bene sit vobis, et protelentur dies in terra possessionis vestrae."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Haec sunt mandata et praecep ta atque iudicia, quae mandavit Dominus Deus vester, ut docerem vos, et faciatis ea in terra, ad quam transgredimini possidendam;"
,"2":"ut timeas Dominum Deum tuum et custodias omnia praecepta et mandata eius, quae ego praecipio tibi et filiis ac nepotibus tuis, cunctis diebus vitae tuae, ut prolongentur dies tui."
,"3":"Audi, Israel, et observa, ut facias, et bene sit tibi, et multipliceris amplius, sicut pollicitus est Dominus, Deus patrum tuorum, tibi terram lacte et melle manantem."
,"4":"Audi, Israel: Dominus Deus noster Dominus unus est."
,"5":"Diliges Dominum Deum tuum ex toto corde tuo et ex tota anima tua et ex tota fortitudine tua."
,"6":"Eruntque verba haec, quae ego praecipio tibi hodie, in corde tuo,"
,"7":"et inculcabis ea filiis tuis et loqueris ea sedens in domo tua et ambulans in itinere, decumbens atque consurgens;"
,"8":"et ligabis ea quasi signum in manu tua, eruntque quasi appensum quid inter oculos tuos,"
,"9":"scribesque ea in postibus domus tuae et in portis tuis."
,"10":"Cumque introduxerit te Dominus Deus tuus in terram, pro qua iuravit patribus tuis Abraham, Isaac et Iacob, ut daret tibi, civitates magnas et optimas, quas non aedificasti,"
,"11":"domos plenas cunctarum opum, quas non implevisti, cisternas, quas non fodisti, vineta et oliveta, quae non plantasti, et comederis et saturatus fueris,"
,"12":"cave diligenter, ne obliviscaris Domini, qui eduxit te de terra Aegypti, de domo servitutis:"
,"13":"Dominum Deum tuum timebis et ipsi servies ac per nomen illius iurabis."
,"14":"Non ibitis post deos alienos, de diis gentium, quae in circuitu vestro sunt,"
,"15":"quoniam Deus aemulator Dominus Deus tuus in medio tui; ne quando irascatur furor Domini Dei tui contra te et auferat te de superficie terrae."
,"16":"Non tentabitis Dominum Deum vestrum, sicut tentastis in Massa."
,"17":"Custodite mandata Domini Dei vestri ac testimonia et praecepta, quae praecepit tibi;"
,"18":"et fac, quod rectum est et bonum in conspectu Domini, ut bene sit tibi, et ingressus possideas terram optimam, de qua iuravit Dominus patribus tuis,"
,"19":"ut deleret omnes inimicos tuos coram te, sicut locutus est Dominus."
,"20":"Cumque interrogaverit te filius tuus cras dicens: 'Quid sibi volunt testimonia haec et praecepta atque iudicia, quae praecepit Dominus Deus noster vobis?',"
,"21":"dices ei: 'Servi eramus pharaonis in Aegypto, et eduxit nos Dominus de Aegypto in manu forti"
,"22":"fecitque signa atque prodigia magna et pessima in Aegypto contra pharaonem et omnem domum illius in conspectu nostro;"
,"23":"et eduxit nos inde, ut introductis daret terram, super qua iuravit patribus nostris."
,"24":"Praecepitque nobis Dominus, ut faciamus omnia praecepta haec et timeamus Dominum Deum nostrum, et bene sit nobis cunctis diebus vitae nostrae, sicut est hodie."
,"25":"Eritque iustitia nobis, si custodierimus et fecerimus omnia mandata haec coram Domino Deo nostro, sicut mandavit nobis'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Cum introduxerit te Dominus Deus tuus in terram, quam pos sessurus ingredieris, et deleverit gentes multas coram te, Hetthaeum et Gergesaeum et Amorraeum, Chananaeum et Pherezaeum et Hevaeum et Iebusaeum, septem gentes multo maioris numeri quam tu es et robustiores te,"
,"2":"tradideritque eas Dominus Deus tuus tibi, percuties eas usque ad internecionem. Non inibis cum eis foedus nec misereberis earum"
,"3":"neque sociabis cum eis coniugia; filiam tuam non dabis filio eius nec filiam illius accipies filio tuo,"
,"4":"quia seducet filium tuum, ne sequatur me et ut serviat diis alienis, irasceturque furor Domini contra vos et delebit te cito."
,"5":"Quin potius haec facietis eis: aras eorum subvertite et confringite lapides et palos lucosque succidite et sculptilia comburite;"
,"6":"quia populus sanctus es Domino Deo tuo. Te elegit Dominus Deus tuus, ut sis ei populus peculiaris de cunctis populis, qui sunt super terram."
,"7":"Non quia cunctas gentes numero vincebatis, vobis iunctus est Dominus et elegit vos, cum omnibus sitis populis pauciores,"
,"8":"sed quia dilexit vos Dominus et custodivit iuramentum, quod iuravit patribus vestris, eduxit vos in manu forti et redemit te de domo servitutis, de manu pharaonis regis Aegypti."
,"9":"Et scies quia Dominus Deus tuus ipse est Deus, Deus fidelis, custodiens pactum et misericordiam diligentibus se et his, qui custodiunt mandata eius, in mille generationes"
,"10":"et reddens odientibus se protinus, ita ut disperdat eos et ultra non differat, protinus eis restituens, quod merentur."
,"11":"Custodi ergo mandata et praecepta atque iudicia, quae ego mando tibi hodie, ut facias."
,"12":"Si audieritis haec iudicia et custodieritis ea et feceritis, custodiet et Dominus Deus tuus tibi pactum et misericordiam, quam iuravit patribus tuis,"
,"13":"et diliget te et benedicet tibi ac multiplicabit te benedicetque fructui ventris tui et fructui terrae tuae, frumento tuo atque vindemiae, oleo et partui armentorum et incremento ovium tuarum super terram, pro qua iuravit patribus tuis, ut daret eam tibi."
,"14":"Benedictus eris prae omnibus populis. Non erit apud te sterilis utriusque sexus, tam in hominibus quam in gregibus tuis."
,"15":"Auferet Dominus a te omnem languorem; et infirmitates Aegypti pessimas, quas novisti, non inferet tibi, sed cunctis hostibus tuis."
,"16":"Devorabis omnes populos, quos Dominus Deus tuus daturus est tibi; non parcet eis oculus tuus, nec servies diis eorum, ne sint in ruinam tui."
,"17":"Si dixeris in corde tuo: 'Plures sunt gentes istae quam ego; quomodo potero delere eas?',"
,"18":"noli metuere eas, sed recordare, quae fecerit Dominus Deus tuus pharaoni et cunctis Aegyptiis,"
,"19":"plagas maximas, quas viderunt oculi tui, et signa atque portenta manumque robustam et extentum brachium, ut educeret te Dominus Deus tuus; sic faciet cunctis populis, quos metuis."
,"20":"Insuper et crabrones mittet Dominus Deus tuus in eos, donec deleat omnes atque disperdat, qui te fugerint et latere potuerint."
,"21":"Non timebis eos, quia Dominus Deus tuus in medio tui est, Deus magnus et terribilis."
,"22":"Ipse consumet nationes has in conspectu tuo paulatim atque per partes. Non poteris delere eas cito, ne multiplicentur contra te bestiae terrae."
,"23":"Dabitque eos Dominus Deus tuus in conspectu tuo et conturbabit illos conturbatione magna, donec penitus deleantur."
,"24":"Tradetque reges eorum in manus tuas, et disperdes nomina eorum sub caelo; nullus poterit resistere tibi, donec conteras eos."
,"25":"Sculptilia eorum igne combures; non concupisces argentum et aurum, quibus vestita sunt, neque assumes ex eis tibi quidquam, ne offendas propterea, quia abominatio est Domini Dei tui."
,"26":"Nec inferes abominationem in domum tuam, ne fias anathema sicut et illa est; quasi spurcitiam detestaberis et velut inquinamentum ac sordes abominationi habebis, quia anathema est."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Omne mandatum, quod ego praecipio tibi hodie, cave dili genter ut facias, ut possitis vivere et multiplicemini ingressique possideatis terram, pro qua iuravit Dominus patribus vestris."
,"2":"Et recordaberis cuncti itineris, per quod adduxit te Dominus Deus tuus his quadraginta annis per desertum, ut affligeret te atque tentaret, et nota fierent, quae in tuo animo versabantur, utrum custodires mandata illius an non."
,"3":"Afflixit te penuria et dedit tibi cibum manna, quem ignorabas tu et patres tui, ut ostenderet tibi quod non in solo pane vivat homo, sed in omni verbo, quod egreditur de ore Domini."
,"4":"Vestimentum tuum, quo operiebaris, nequaquam defecit, et pes tuus non intumuit his quadraginta annis."
,"5":"Recogites ergo in corde tuo quia, sicut erudit homo filium suum, sic Dominus Deus tuus erudivit te,"
,"6":"ut custodias mandata Domini Dei tui et ambules in viis eius et timeas eum."
,"7":"Dominus enim Deus tuus introducet te in terram bonam, terram rivorum aquarum et fontium, in cuius campis et montibus erumpunt fluviorum abyssi,"
,"8":"terram frumenti, hordei ac vinearum, in qua ficus et malogranata et oliveta nascuntur, terram olei ac mellis,"
,"9":"ubi absque ulla penuria comedes panem tuum et rerum omnium abundantia perfrueris; cuius lapides ferrum sunt, et de montibus eius aeris metalla fodiuntur;"
,"10":"ut, cum comederis et satiatus fueris, benedicas Domino Deo tuo pro terra optima, quam dedit tibi."
,"11":"Observa et cave, ne quando obliviscaris Domini Dei tui et neglegas mandata eius atque iudicia et praecepta, quae ego praecipio tibi hodie;"
,"12":"ne, postquam comederis et satiatus fueris, domos pulchras aedificaveris et habitaveris in eis"
,"13":"habuerisque armenta et ovium greges multos, argenti et auri cunctarumque rerum copiam,"
,"14":"elevetur cor tuum, et obliviscaris Domini Dei tui, qui eduxit te de terra Aegypti, de domo servitutis,"
,"15":"et ductor tuus fuit in solitudine magna atque terribili, in qua erat serpens adurens et scorpio ac terra arida et nullae omnino aquae; qui eduxit tibi rivos de petra durissima"
,"16":"et cibavit te manna in solitudine, quod nescierunt patres tui, et, postquam afflixit ac probavit te, ad extremum misertus est tui,"
,"17":"ne diceres in corde tuo: 'Fortitudo mea et robur manus meae haec mihi omnia praestiterunt';"
,"18":"sed recorderis Domini Dei tui, quod ipse vires tibi praebuerit, ut consequereris prosperitatem, ut impleret pactum suum, super quo iuravit patribus tuis, sicut praesens indicat dies."
,"19":"Sin autem oblitus Domini Dei tui secutus fueris deos alienos coluerisque illos et adoraveris, ecce nunc testificor vobis quod omnino dispereatis:"
,"20":"sicut gentes, quas delevit Dominus in introitu vestro, ita et vos peribitis, si inoboedientes fueritis voci Domini Dei vestri."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Audi, Israel: Tu transgredieris hodie Iordanem, ut possideas nationes maximas et fortiores te, civitates ingentes et ad caelum usque muratas,"
,"2":"populum magnum atque sublimem, filios Enacim, quos ipse nosti et audisti, quibus nullus potest ex adverso resistere."
,"3":"Scies ergo hodie quod Dominus Deus tuus ipse transibit ante te ignis devorans, qui conteret eos atque subiciet ante faciem tuam, ut velociter expellas et deleas eos, sicut locutus est tibi."
,"4":"Ne dicas in corde tuo, cum deleverit eos Dominus Deus tuus in conspectu tuo: 'Propter iustitiam meam introduxit me Dominus, ut terram hanc possiderem', cum propter impietates nationum istarum expellat eas Dominus ante te."
,"5":"Neque enim propter iustitiam tuam et aequitatem cordis tui ingredieris, ut possideas terras earum, sed quia illae egerunt impie, introeunte te, Dominus Deus tuus expellet eos ante te, et ut compleat verbum suum Dominus, quod sub iuramento pollicitus est patribus tuis, Abraham, Isaac et Iacob."
,"6":"Scito igitur quod non propter iustitiam tuam Dominus Deus tuus dederit tibi terram hanc optimam in possessionem, cum durissimae cervicis sis populus."
,"7":"Memento et ne obliviscaris quomodo ad iracundiam provocaveris Dominum Deum tuum in solitudine; ex eo die, quo egressus es ex Aegypto, usque ad locum istum adversum Dominum contendistis."
,"8":"Nam et in Horeb provocastis eum, et iratus delere vos voluit,"
,"9":"quando ascendi in montem, ut acciperem tabulas lapideas, tabulas pacti, quod pepigit vobiscum Dominus, et perseveravi in monte quadraginta diebus ac noctibus panem non comedens et aquam non bibens."
,"10":"Deditque mihi Dominus duas tabulas lapideas scriptas digito Dei et continentes omnia verba, quae vobis locutus est in monte de medio ignis, quando contio populi congregata est."
,"11":"Cumque transissent quadraginta dies et totidem noctes, dedit mihi Dominus duas tabulas lapideas, tabulas foederis,"
,"12":"dixitque mihi: 'Surge et descende hinc cito, quia peccavit populus tuus, quem eduxisti de Aegypto: deseruerunt velociter viam, quam praecepi eis, feceruntque sibi conflatile'."
,"13":"Rursumque ait Dominus ad me: 'Cerno quod populus iste durae cervicis sit;"
,"14":"dimitte me, ut conteram eos et deleam nomen eorum sub caelo et faciam te in gentem, quae hac fortior et maior sit'."
,"15":"Cumque reversus de monte ardente descenderem et duas tabulas foederis utraque tenerem manu"
,"16":"vidissemque vos peccasse Domino Deo vestro et fecisse vobis vitulum conflatilem ac deseruisse velociter viam eius, quam Dominus vobis praeceperat,"
,"17":"arripui duas tabulas et proieci eas de manibus meis confregique eas in conspectu vestro;"
,"18":"et procidi ante Dominum, sicut prius quadraginta diebus et noctibus panem non comedens et aquam non bibens propter omnia peccata vestra, quae gessistis contra Dominum et eum ad iracundiam provocastis;"
,"19":"timui enim indignationem et iram illius, qua adversum vos concitatus delere vos voluit. Et exaudivit me Dominus etiam hac vice."
,"20":"Adversum Aaron quoque vehementer iratus voluit eum conterere; et pro illo similiter tunc deprecatus sum."
,"21":"Peccatum autem vestrum, quod feceratis, id est vitulum, arripiens igne combussi et in frusta comminuens omninoque in pulverem redigens proieci in torrentem, qui de monte descendit."
,"22":"In Tabera quoque et in Massa et in Cibrottaava provocastis Dominum;"
,"23":"et quando misit Dominus vos de Cadesbarne dicens: 'Ascendite et possidete terram, quam dedi vobis', contempsistis imperium Domini Dei vestri et non credidistis ei neque vocem eius audire voluistis;"
,"24":"semper fuistis rebelles contra Dominum a die, qua nosse vos coepi."
,"25":"Et iacui coram Domino quadraginta diebus ac noctibus, quibus eum suppliciter deprecabar, ne deleret vos, ut fuerat comminatus."
,"26":"Et orans dixi: Domine Deus, ne disperdas populum tuum et hereditatem tuam, quam redemisti in magnitudine tua, quos eduxisti de Aegypto in manu forti."
,"27":"Recordare servorum tuorum Abraham, Isaac et Iacob; ne aspicias duritiam populi huius et impietatem atque peccatum,"
,"28":"ne forte dicant habitatores terrae, de qua eduxisti nos: 'Non poterat Dominus introducere eos in terram, quam pollicitus est eis, et oderat illos; idcirco eduxit, ut interficeret eos in solitudine'."
,"29":"Attamen ipsi sunt populus tuus et hereditas tua, quos eduxisti in fortitudine tua magna et in brachio tuo extento."
}`)
	CurrentBook.AddChapter(10, `{
"1":"In tempore illo dixit Dominus ad me: 'Dola tibi duas tabulas lapideas, sicut priores fuerunt, et ascende ad me in montem faciesque tibi arcam ligneam."
,"2":"Et scribam in tabulis verba, quae fuerunt in his, quas ante confregisti, ponesque eas in arca'."
,"3":"Feci igitur arcam de lignis acaciae; cumque dolassem duas tabulas lapideas instar priorum, ascendi in montem habens eas in manibus."
,"4":"Scripsitque in tabulis iuxta id quod prius scripserat, verba decem, quae locutus est Dominus ad vos in monte de medio ignis, quando populus congregatus est, et dedit eas mihi."
,"5":"Reversusque de monte descendi et posui tabulas in arcam, quam feceram; quae hucusque ibi sunt, sicut mihi praecepit Dominus."
,"6":"Filii autem Israel castra moverunt ex Berothbeneiacan in Mosera, ubi Aaron mortuus ac sepultus est; pro quo sacerdotio functus est Eleazar filius eius."
,"7":"Inde venerunt in Gadgad; de quo loco profecti castrametati sunt in Ietebatha, in terra torrentium aquarum."
,"8":"Eo tempore separavit Dominus tribum Levi, ut portaret arcam foederis Domini et staret coram eo in ministerio ac benediceret in nomine illius usque in praesentem diem."
,"9":"Quam ob rem non habuit Levi partem neque hereditatem cum fratribus suis, quia ipse Dominus hereditas eius est, sicut promisit ei Dominus Deus tuus."
,"10":"Ego autem steti in monte sicut prius quadraginta diebus ac noctibus, exaudivitque me Dominus etiam hac vice et te perdere noluit."
,"11":"Dixitque mihi: 'Surge, vade et praecede populum, ut ingrediatur et possideat terram, quam iuravi patribus eorum, ut traderem eis'."
,"12":"Et nunc, Israel, quid Dominus Deus tuus petit a te, nisi ut timeas Dominum Deum tuum et ambules in viis eius et diligas eum ac servias Domino Deo tuo in toto corde tuo et in tota anima tua"
,"13":"custodiasque mandata Domini et praecepta eius, quae ego hodie praecipio, ut bene sit tibi?"
,"14":"En Domini Dei tui caelum est et caelum caeli, terra et omnia, quae in ea sunt;"
,"15":"et tamen patribus tuis conglutinatus est Dominus et amavit eos elegitque semen eorum post eos, id est vos, de cunctis gentibus, sicut hodie comprobatur."
,"16":"Circumcidite igitur praeputium cordis vestri et cervicem vestram, ne induretis amplius,"
,"17":"quia Dominus Deus vester ipse est Deus deorum et Dominus dominantium, Deus magnus, potens et terribilis, qui personam non accipit nec munera,"
,"18":"facit iudicium pupillo et viduae, amat peregrinum et dat ei victum atque vestitum."
,"19":"Et vos ergo, amate peregrinos, quia et ipsi fuistis advenae in terra Aegypti."
,"20":"Dominum Deum tuum timebis et ei servies, ipsi adhaerebis iurabisque in nomine illius."
,"21":"Ipse est laus tua et Deus tuus, qui fecit tibi haec magnalia et terribilia, quae viderunt oculi tui."
,"22":"In septuaginta animabus descenderunt patres tui in Aegyptum; et ecce nunc multiplicavit te Dominus Deus tuus sicut astra caeli."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Ama itaque Dominum Deum tuum et custodi obser vationem eius et praecepta, iudicia atque mandata omni tempore."
,"2":"Cognoscite hodie, quae ignorant filii vestri, qui non viderunt disciplinam Domini Dei vestri, magnalia eius et robustam manum extentumque brachium,"
,"3":"signa et opera, quae fecit in medio Aegypti pharaoni regi et universae terrae eius"
,"4":"omnique exercitui Aegyptiorum et equis ac curribus; quomodo operuerint eos aquae maris Rubri, cum vos persequerentur, et deleverit eos Dominus usque in praesentem diem;"
,"5":"vobisque, quae fecerit in solitudine, donec veniretis ad hunc locum;"
,"6":"et Dathan atque Abiram filiis Eliab, qui fuit filius Ruben, quos aperto ore suo terra absorbuit cum domibus et tabernaculis et universa substantia eorum, quam habebant in medio Israel."
,"7":"Oculi vestri viderunt omnia opera Domini magna, quae fecit,"
,"8":"ut custodiatis universa mandata, quae ego hodie praecipio vobis, ut roboremini et possitis introire et possidere terram, ad quam ingredimini,"
,"9":"multoque in ea vivatis tempore, quam sub iuramento pollicitus est Dominus patribus vestris et semini eorum, lacte et melle manantem."
,"10":"Terra enim, ad quam ingredieris possidendam, non est sicut terra Aegypti, de qua existis, ubi, iacto semine, in hortorum morem aquae pede ducuntur irriguae;"
,"11":"sed montuosa est et campestris, de caelo exspectans pluvias,"
,"12":"quam Dominus Deus tuus semper invisit, et oculi illius in ea sunt a principio anni usque ad finem eius."
,"13":"Si ergo oboedieritis mandatis meis, quae hodie praecipio vobis, ut diligatis Dominum Deum vestrum et serviatis ei in toto corde vestro et in tota anima vestra,"
,"14":"dabo pluviam terrae vestrae temporaneam et serotinam in tempore suo, ut colligas frumentum et vinum et oleum,"
,"15":"et dabit fenum ex agris ad pascenda iumenta, et ut ipse comedas ac satureris."
,"16":"Cavete, ne decipiatur cor vestrum, et recedatis a Domino serviatisque diis alienis et adoretis eos,"
,"17":"iratusque Dominus contra vos claudat caelum, et pluviae non descendant, nec terra det fructum suum, pereatisque velociter de terra optima, quam Dominus daturus est vobis."
,"18":"Ponite haec verba mea in cordibus et in animis vestris et ligate ea pro signo in manibus et inter oculos vestros collocate quasi appensum quid."
,"19":"Docete ea filios vestros, de illis loquendo, quando sederis in domo tua et ambulaveris in via et accubueris atque surrexeris."
,"20":"Scribes ea super postes domus tuae et portas tuas,"
,"21":"ut multiplicentur dies tui et filiorum tuorum in terra, quam iuravit Dominus patribus tuis, ut daret eis, quamdiu caelum imminet terrae."
,"22":"Si enim custodieritis omnia mandata haec, quae ego praecipio vobis, et feceritis ea, ut diligatis Dominum Deum vestrum et ambuletis in omnibus viis eius adhaerentes ei,"
,"23":"disperdet Dominus omnes gentes istas ante faciem vestram, et possidebitis eas, quae maiores et fortiores vobis sunt;"
,"24":"omnis locus, quem calcaverit pes vester, vester erit. A deserto et a Libano, a flumine magno Euphrate usque ad mare occidentale erunt termini vestri."
,"25":"Nullus stabit contra vos; terrorem vestrum et formidinem dabit Dominus Deus vester super omnem terram, quam calcaturi estis, sicut locutus est vobis."
,"26":"En propono in conspectu vestro hodie benedictionem et maledictionem:"
,"27":"benedictionem, si oboedieritis mandatis Domini Dei vestri, quae ego hodie praecipio vobis;"
,"28":"maledictionem, si non oboedieritis mandatis Domini Dei vestri, sed recesseritis de via, quam ego nunc ostendo vobis, et ambulaveritis post deos alienos, quos ignoratis."
,"29":"Cum introduxerit te Dominus Deus tuus in terram, ad quam pergis habitandam, pones benedictionem super montem Garizim, maledictionem super montem Hebal,"
,"30":"qui sunt trans Iordanem, post viam quae vergit ad solis occubitum in terra Chananaei, qui habitat in Araba contra Galgalam, quae est iuxta Quercus Moreh."
,"31":"Vos enim transibitis Iordanem, ut possideatis terram, quam Dominus Deus vester daturus est vobis, et habitetis in illa."
,"32":"Videte ergo ut impleatis omnia praecepta atque iudicia, quae ego hodie ponam in conspectu vestro."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Haec sunt praecepta atque iudicia, quae facere debetis in terra, quam Dominus, Deus patrum tuorum, daturus est tibi, ut possideas eam cunctis diebus, quibus super humum gradieris."
,"2":"Subvertite omnia loca, in quibus coluerunt gentes, quas possessuri estis, deos suos super montes excelsos et colles et subter omne lignum frondosum."
,"3":"Dissipate aras eorum et confringite lapides, palos igne comburite et idola comminuite, disperdite nomina eorum de locis illis."
,"4":"Non facietis ita Domino Deo vestro."
,"5":"Sed ad locum, quem elegerit Dominus Deus vester de cunctis tribubus vestris, ut ponat nomen suum ibi et habitet in eo, venietis"
,"6":"et offeretis in illo loco holocausta et victimas vestras, decimas et donaria manuum vestrarum et vota atque dona, primogenita boum et ovium."
,"7":"Et comedetis ibi in conspectu Domini Dei vestri ac laetabimini in cunctis, ad quae miseritis manum vos et domus vestrae, in quibus benedixerit vobis Dominus Deus vester."
,"8":"Non facietis secundum omnia, quae nos hic facimus hodie, singuli, quod sibi rectum videtur;"
,"9":"neque enim usque in praesens tempus venistis ad requiem et possessionem, quam Dominus Deus vester daturus est vobis."
,"10":"Transibitis Iordanem et habitabitis in terra, quam Dominus Deus vester daturus est vobis, ut requiescatis a cunctis hostibus per circuitum et absque ullo timore habitetis"
,"11":"in loco, quem elegerit Dominus Deus vester, ut habitet nomen eius in eo. Illuc omnia, quae praecipio, conferetis: holocausta et hostias ac decimas et donaria manuum vestrarum et, quidquid praecipuum est in muneribus, quae vovebitis Domino."
,"12":"Ibi laetabimini coram Domino Deo vestro vos, filii ac filiae vestrae, famuli et famulae atque Levites, qui in urbibus vestris commoratur; neque enim habet partem et possessionem inter vos."
,"13":"Cave, ne offeras holocausta tua in omni loco, quem videris,"
,"14":"sed in eo, quem elegerit Dominus in una tribuum tuarum, offeres holocausta et ibi facies quaecumque praecipio tibi."
,"15":"Sin autem comedere volueris, et te esus carnium delectaverit, occide et comede carnem iuxta benedictionem Domini Dei tui, quam dedit tibi in omnibus urbibus tuis; sive immundus sive mundus comedet illam, sicut capream et cervum,"
,"16":"absque esu dumtaxat sanguinis, quem super terram quasi aquam effundes."
,"17":"Non poteris comedere in oppidis tuis decimam frumenti et vini et olei tui, primogenita armentorum et pecorum et omnia, quae voveris et sponte offerre volueris, et primitiva manuum tuarum."
,"18":"Sed coram Domino Deo tuo comedes ea in loco, quem elegerit Dominus Deus tuus, tu et filius tuus ac filia tua, servus et famula atque Levites, qui manet in urbibus tuis; et laetaberis coram Domino Deo tuo in cunctis, ad quae extenderis manum tuam."
,"19":"Cave, ne derelinquas Levitem omni tempore, quo versaris in terra tua."
,"20":"Quando dilataverit Dominus Deus tuus terminos tuos, sicut locutus est tibi, et volueris vesci carnibus, quas desiderat anima tua, comedes carnem secundum omne desiderium animae tuae;"
,"21":"locus autem, quem elegerit Dominus Deus tuus, ut sit nomen eius ibi, si procul fuerit, occides de armentis et pecoribus, quae dederit tibi Dominus, sicut praecepi tibi, et comedes in oppidis tuis, ut tibi placet."
,"22":"Sicut comeditur caprea et cervus, ita vesceris eis; et mundus et immundus in commune vescentur."
,"23":"Hoc solum cave, ne sanguinem comedas; sanguis enim eorum anima est, et idcirco non debes animam comedere cum carnibus."
,"24":"Non comedes eum, sed super terram fundes quasi aquam;"
,"25":"non comedes eum, ut bene sit tibi et filiis tuis post te, cum feceris, quod placet in conspectu Domini."
,"26":"Quae autem sanctificaveris et voveris Domino, tolles et venies ad locum, quem elegerit Dominus,"
,"27":"et offeres holocausta tua, carnem et sanguinem super altare Domini Dei tui; sanguis hostiarum tuarum fundetur in altari, carnibus autem ipse vesceris."
,"28":"Observa et audi omnia, quae ego praecipio tibi, ut bene sit tibi et filiis tuis post te in sempiternum, cum feceris, quod bonum est et placitum in conspectu Domini Dei tui."
,"29":"Quando disperdiderit Dominus Deus tuus ante faciem tuam gentes, ad quas ingredieris possidendas, et possederis eas atque habitaveris in terra earum,"
,"30":"cave, ne irretiaris per eas, postquam te fuerint introeunte subversae, et requiras caeremonias earum dicens: 'Sicut coluerunt gentes istae deos suos, ita et ego colam'."
,"31":"Non facies similiter Domino Deo tuo; omnes enim abominationes, quas aversatur Dominus, fecerunt diis suis offerentes etiam filios et filias et comburentes igne."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Quod praecipio vobis, hoc custodite et facite, nec addas quidquam nec minuas."
,"2":"Si surrexerit in medio tui prophetes aut, qui somnium vidisse se dicat, et dederit tibi signum vel portentum,"
,"3":"et evenerit, quod locutus est, et dixerit tibi: 'Eamus et sequamur deos alienos, quos ignoras, et serviamus eis',"
,"4":"non audies verba prophetae illius aut somniatoris, quia tentat vos Dominus Deus vester, ut sciat utrum diligatis eum an non in toto corde et in tota anima vestra."
,"5":"Dominum Deum vestrum sequimini et ipsum timete et mandata illius custodite et audite vocem eius; ipsi servietis et ipsi adhaerebitis."
,"6":"Propheta autem ille aut fictor somniorum interficietur, quia locutus est, ut vos averteret a Domino Deo vestro, qui eduxit vos de terra Aegypti et redemit te de domo servitutis; ut errare te faceret de via, quam tibi praecepit Dominus Deus tuus; et auferes malum de medio tui."
,"7":"Si tibi voluerit persuadere frater tuus filius matris tuae aut filius tuus vel filia sive uxor, quae est in sinu tuo, aut amicus, quem diligis ut animam tuam, clam dicens: 'Eamus et serviamus diis alienis', quos ignorasti tu et patres tui,"
,"8":"de diis cunctarum in circuitu gentium, quae iuxta vel procul sunt ab initio usque ad finem terrae,"
,"9":"non acquiescas ei nec audias, neque parcat ei oculus tuus, ut miserearis et occultes eum,"
,"10":"sed interficies. Sit primum manus tua super eum, et postea omnis populus mittat manum:"
,"11":"lapidibus obrutus necabitur, quia voluit te abstrahere a Domino Deo tuo, qui eduxit te de terra Aegypti, de domo servitutis,"
,"12":"ut omnis Israel audiens timeat, et nequaquam ultra faciat quippiam huius rei simile in medio tui."
,"13":"Si audieris in una urbium tuarum, quas Dominus Deus tuus dabit tibi ad habitandum, dicentes aliquos:"
,"14":"'Egressi sunt filii Belial de medio tui et averterunt habitatores urbis suae atque dixerunt: Eamus et serviamus diis alienis', quos ignorastis,"
,"15":"quaere sollicite et, diligenter rei veritate perspecta, si inveneris certum esse, quod dicitur, et abominationem hanc opere perpetratam in medio tui,"
,"16":"percuties habitatores urbis illius in ore gladii et delebis eam ac omnia, quae in illa sunt."
,"17":"Quidquid etiam supellectilis fuerit, congregabis in medio platearum eius et cum ipsa civitate succendes, ita ut universa consumas Domino Deo tuo, et sit tumulus sempiternus: non aedificabitur amplius."
,"18":"Et non adhaerebit de illo anathemate quidquam in manu tua, ut avertatur Dominus ab ira furoris sui et misereatur tui multiplicetque te, sicut iuravit patribus tuis,"
,"19":"quando audieris vocem Domini Dei tui custodiens omnia mandata eius, quae ego praecipio tibi hodie, ut facias quod placitum est in conspectu Domini Dei tui."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Filii estote Domini Dei ve stri; non vos incidetis nec fa cietis calvitium inter oculos vestros super mortuo,"
,"2":"quoniam populus sanctus es Domino Deo tuo, et te elegit, ut sis ei in populum peculiarem de cunctis gentibus, quae sunt super terram."
,"3":"Ne comedatis quidquid abominabile est."
,"4":"Hoc est animal, quod comedere potestis: bovem et ovem et capram,"
,"5":"cervum et capream, bubalum, tragelaphum, pygargum, orygem, rupicapram."
,"6":"Omne animal inter pecora, quod findit ungulam plene in duas partes et ruminat, comedetis;"
,"7":"de his autem, quae ruminant et ungulam non findunt, haec comedere non debetis: camelum, leporem, hyracem, quia ruminant et non dividunt ungulam, immunda erunt vobis."
,"8":"Sus quoque, quoniam dividit ungulam et non ruminat, immunda erit vobis: carnibus eorum non vescemini et cadavera non tangetis."
,"9":"Haec comedetis ex omnibus, quae morantur in aquis: quae habent pinnulas et squamas comedite;"
,"10":"quae absque pinnulis et squamis sunt, ne comedatis, quia immunda sunt vobis."
,"11":"Omnes aves mundas comedite;"
,"12":"has autem ne comedatis: aquilam scilicet et grypem et alietum,"
,"13":"ixon et vulturem ac milvum iuxta genus suum"
,"14":"et omne corvini generis,"
,"15":"struthionem ac noctuam et larum atque accipitrem iuxta genus suum,"
,"16":"bubonem ac cycnum et ibin"
,"17":"ac mergulum, porphyrionem et nycticoracem,"
,"18":"erodium et charadrium, singula in genere suo, upupam quoque et vespertilionem."
,"19":"Et omne, quod reptat et pinnulas habet, immundum erit vobis, nec comedetur."
,"20":"Omne volatile, quod mundum est, comedite."
,"21":"Quidquid morticinum est, ne vescamini ex eo; advenae, qui intra portas tuas est, da, ut comedat, aut vende peregrino: quia tu populus sanctus es Domino Deo tuo. Non coques haedum in lacte matris suae."
,"22":"Decimam partem separabis de cunctis frugibus seminis tui, quae nascuntur in terra per annos singulos;"
,"23":"et comedes in conspectu Domini Dei tui in loco, quem elegerit, ut in eo nomen illius habitet, decimam frumenti tui et vini et olei et primogenita de armentis et ovibus tuis, ut discas timere Dominum Deum tuum omni tempore."
,"24":"Cum autem longior fuerit tibi via et locus, quem elegerit Dominus Deus tuus, ut ponat nomen suum ibi tibique benedixerit, nec potueris ad eum haec cuncta portare,"
,"25":"vendes omnia et in pretium rediges; portabisque manu tua et proficisceris ad locum, quem elegerit Dominus Deus tuus,"
,"26":"et emes ex eadem pecunia, quidquid tibi placuerit, sive ex armentis sive ex ovibus, vinum quoque et siceram et omne, quod desiderat anima tua; et comedes ibi coram Domino Deo tuo et epulaberis tu et domus tua"
,"27":"et Levites, qui intra portas tuas est: cave, ne derelinquas eum, quia non habet partem nec possessionem tecum."
,"28":"Anno tertio separabis aliam decimam ex omnibus, quae nascuntur tibi eo tempore, et repones intra portas tuas;"
,"29":"venietque Levites, qui non habet partem nec possessionem tecum, et peregrinus ac pupillus ac vidua, qui intra portas tuas sunt, et comedent et saturabuntur, ut benedicat tibi Dominus Deus tuus in cunctis operibus manuum tuarum, quae feceris."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Septimo anno facies remis sionem,"
,"2":"quae hoc ordine ce lebrabitur: cui debetur aliquid a proximo ac fratre suo, repetere non poterit, quia annus remissionis est Domino."
,"3":"A peregrino exiges; civem et propinquum repetendi, quod tuum est, non habebis potestatem."
,"4":"Sed omnino indigens non erit apud te, quia benedicet tibi Dominus Deus tuus in terra, quam traditurus est tibi in possessionem,"
,"5":"si tamen audieris vocem Domini Dei tui et custodieris universum mandatum hoc, quod ego hodie praecipio tibi,"
,"6":"quia Dominus Deus tuus benedicet tibi, ut pollicitus est. Fenerabis gentibus multis et ipse a nullo accipies mutuum; dominaberis nationibus plurimis, et tui nemo dominabitur."
,"7":"Si unus de fratribus tuis, qui morantur in una civitatum tuarum in terra, quam Dominus Deus tuus daturus est tibi, ad paupertatem venerit, non obdurabis cor tuum nec contrahes manum;"
,"8":"sed aperies eam pauperi fratri tuo et dabis mutuum, quod eum indigere perspexeris."
,"9":"Cave, ne forte subrepat tibi impia cogitatio, et dicas in corde tuo: 'Appropinquat septimus annus remissionis', et avertas oculos tuos a paupere fratre tuo nolens ei, quod postulat, mutuum commodare, ne clamet contra te ad Dominum, et fiat tibi in peccatum."
,"10":"Sed dabis ei, nec contristabitur cor tuum in eius necessitatibus sublevandis, nam propter hoc benedicet tibi Dominus Deus tuus in omni opere tuo et in cunctis, ad quae manum miseris."
,"11":"Non deerunt pauperes in terra habitationis tuae; idcirco ego praecipio tibi, ut aperias manum fratri tuo egeno et pauperi, qui tecum versatur in terra tua."
,"12":"Cum tibi venditus fuerit frater tuus Hebraeus aut Hebraea et sex annis servierit tibi, in septimo anno dimittes eum liberum;"
,"13":"et quem libertate donaveris, nequaquam vacuum abire patieris."
,"14":"Sed dabis ei viaticum de gregibus et de area et torculari tuo, quibus Dominus Deus tuus benedixerit tibi."
,"15":"Memento quod et ipse servieris in terra Aegypti, et liberaverit te Dominus Deus tuus; idcirco ego nunc hoc praecipio tibi."
,"16":"Sin autem dixerit: 'Nolo egredi', eo quod diligat te et domum tuam et bene sibi apud te esse sentiat,"
,"17":"assumes subulam et perforabis aurem eius in ianua domus tuae, et serviet tibi usque in aeternum. Ancillae quoque similiter facies."
,"18":"Non sit durum in oculis tuis dimittere eum liberum, quoniam iuxta mercedem mercennarii per sex annos servivit tibi, et benedicet tibi Dominus Deus tuus in cunctis operibus, quae egeris."
,"19":"De primogenitis, quae nascuntur in armentis et ovibus tuis, quidquid sexus est masculini, sanctificabis Domino Deo tuo; non operaberis in primogenito bovis et non tondebis primogenita ovium."
,"20":"In conspectu Domini Dei tui comedes ea per annos singulos in loco, quem elegerit Dominus, tu et domus tua."
,"21":"Sin autem habuerit maculam et vel claudum fuerit vel caecum aut in aliqua parte deforme vel debile, non immolabis illud Domino Deo tuo,"
,"22":"sed intra portas tuas comedes illud; tam mundus quam immundus similiter vescentur eis, quasi caprea et cervo."
,"23":"Solum sanguinem eorum non comedes, sed effundes in terram quasi aquam."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Observa mensem Abib, ut facias Pascha Domino Deo tuo; quoniam in isto mense Abib eduxit te Dominus Deus tuus de Aegypto nocte."
,"2":"Immolabisque Pascha Domino Deo tuo de ovibus et de bobus in loco, quem elegerit Dominus Deus tuus, ut habitet nomen eius ibi."
,"3":"Non comedes cum eo panem fermentatum; septem diebus comedes absque fermento afflictionis panem, quoniam festinanter egressus es de Aegypto, ut memineris diei egressionis tuae de Aegypto omnibus diebus vitae tuae."
,"4":"Non apparebit fermentum in omnibus terminis tuis septem diebus; et non manebit de carnibus eius, quod immolatum est vespere in die primo, usque mane."
,"5":"Non poteris immolare Pascha in qualibet urbium tuarum, quas Dominus Deus tuus daturus est tibi,"
,"6":"sed in loco, quem elegerit Dominus Deus tuus, ut habitet nomen eius ibi, immolabis Pascha vespere ad solis occasum, quando egressus es de Aegypto."
,"7":"Et coques et comedes in loco, quem elegerit Dominus Deus tuus, maneque consurgens vades in tabernacula tua."
,"8":"Sex diebus comedes azyma et in die septimo, quia collecta est Domino Deo tuo, non facies opus."
,"9":"Septem hebdomadas numerabis tibi ab ea die, qua falcem in segetem miseris,"
,"10":"et celebrabis diem festum Hebdomadarum Domino Deo tuo, oblationem spontaneam manus tuae, quam offeres iuxta benedictionem Domini Dei tui."
,"11":"Et epulaberis coram Domino Deo tuo tu, filius tuus et filia tua, servus tuus et ancilla tua et Levites, qui est intra portas tuas, advena ac pupillus et vidua, qui morantur tecum in loco, quem elegerit Dominus Deus tuus, ut habitet nomen eius ibi;"
,"12":"et recordaberis quoniam servus fueris in Aegypto custodiesque ac facies, quae praecepta sunt."
,"13":"Sollemnitatem quoque Tabernaculorum celebrabis per septem dies, quando collegeris de area et torculari fruges tuas;"
,"14":"et epulaberis in festivitate tua tu, filius tuus et filia, servus tuus et ancilla, Levites quoque et advena, pupillus ac vidua, qui intra portas tuas sunt."
,"15":"Septem diebus Domino Deo tuo festa celebrabis in loco, quem elegerit Dominus, quia benedicet tibi Dominus Deus tuus in cunctis frugibus tuis et in omni opere manuum tuarum, erisque totus in laetitia."
,"16":"Tribus vicibus per annum apparebit omne masculinum tuum in conspectu Domini Dei tui in loco, quem elegerit: in sollemnitate Azymorum et in sollemnitate Hebdomadarum et in sollemnitate Tabernaculorum. Non apparebit ante Dominum vacuus,"
,"17":"sed offeret unusquisque secundum quod habuerit, iuxta benedictionem Domini Dei tui, quam dederit tibi."
,"18":"Iudices et praefectos operum constitues in omnibus portis tuis, quas Dominus Deus tuus dederit tibi per singulas tribus tuas, ut iudicent populum iusto iudicio."
,"19":"Non declinabis iudicium. Non accipies personam nec munera, quia munera excaecant oculos sapientum et mutant causas iustorum."
,"20":"Iustitiam, iustitiam persequeris, ut vivas et possideas terram, quam Dominus Deus tuus dederit tibi."
,"21":"Non plantabis tibi palum, omnem arborem iuxta altare Domini Dei tui, quod feceris tibi."
,"22":"Neque constitues lapidem, quem odit Dominus Deus tuus."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Non immolabis Domino Deo tuo ovem et bovem, in quo est macula aut quippiam vitii, quia abominatio est Domino Deo tuo."
,"2":"Cum reperti fuerint apud te intra unam portarum tuarum, quas Dominus Deus tuus dabit tibi, vir aut mulier, qui faciant, quod malum est in conspectu Domini Dei tui, et transgrediantur pactum illius,"
,"3":"ut vadant et serviant diis alienis et adorent eos, solem vel lunam vel omnem militiam caeli, quae non praecepi,"
,"4":"et hoc tibi fuerit nuntiatum, audiensque inquisieris diligenter et verum esse reppereris, et abominatio haec facta est in Israel,"
,"5":"educes virum vel mulierem, qui hanc rem sceleratissimam perpetrarunt, ad portas civitatis tuae, et lapidibus obruentur."
,"6":"In ore duorum aut trium testium peribit, qui interficietur; nemo occidatur uno contra se dicente testimonium."
,"7":"Manus testium prima erit ad interficiendum eum, et manus reliqui populi extrema mittetur, ut auferas malum de medio tui."
,"8":"Si intra portas tuas in litibus difficile et ambiguum apud te iudicium esse perspexeris inter sanguinem et sanguinem, causam et causam, plagam et plagam, surge et ascende ad locum, quem elegerit Dominus Deus tuus,"
,"9":"veniesque ad sacerdotes levitici generis et ad iudicem, qui fuerit illo tempore; quaeresque ab eis, qui indicabunt tibi iudicii sententiam."
,"10":"Et facies quodcumque dixerint tibi de loco, quem elegerit Dominus, et observabis, ut facias omnia quae docuerint te"
,"11":"iuxta mandatum, quod mandaverunt, et iuxta sententiam, quam dixerint tibi. Nec declinabis ad dexteram vel ad sinistram."
,"12":"Qui autem superbierit nolens oboedire sacerdotis imperio, qui eo tempore ministrat Domino Deo tuo, aut decreto iudicis, morietur homo ille, et auferes malum de Israel;"
,"13":"cunctusque populus audiens timebit, ut nullus deinceps intumescat superbia."
,"14":"Cum ingressus fueris terram, quam Dominus Deus tuus dabit tibi, et possederis eam habitaverisque in illa et dixeris: 'Constituam super me regem, sicut habent omnes per circuitum nationes',"
,"15":"eum constitues super te regem, quem Dominus Deus tuus elegerit de numero fratrum tuorum. Non poteris alterius gentis hominem regem facere, qui non sit frater tuus."
,"16":"Tantummodo non multiplicabit sibi equos nec reducet populum in Aegyptum, ut equitatus numerum augeat, praesertim cum Dominus praeceperit vobis, ut nequaquam amplius per hanc viam revertamini."
,"17":"Neque habebit uxores plurimas, ne declinet cor eius, neque argenti et auri immensa pondera."
,"18":"Postquam autem sederit in solio regni sui, describet sibi exemplar legis huius in volumine accipiens illam a sacerdotibus leviticae tribus;"
,"19":"et habebit secum legetque illud omnibus diebus vitae suae, ut discat timere Dominum Deum suum. et custodire verba legis huius et praecepta ista et quae in lege praecepta sunt."
,"20":"Nec elevetur cor eius in superbiam super fratres suos neque declinet a mandatis in partem dexteram vel sinistram, ut longo tempore regnet ipse et filii eius in medio Israel."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Non habebunt sacerdotes le vitae, omnis tribus Levi, par tem et hereditatem cum reliquo Israel; de sacrificiis Domini et hereditate eius comedent"
,"2":"et nihil accipient de possessione fratrum suorum: Dominus enim ipse est hereditas eorum, sicut locutus est illis."
,"3":"Hoc erit ius sacerdotum a populo, ab his qui offerunt victimas: sive bovem sive ovem immolaverint, dabunt sacerdoti armum et duas maxillas ac ventriculum,"
,"4":"primitias frumenti, vini et olei et lanarum ex ovium tonsione."
,"5":"Ipsum enim elegit Dominus Deus tuus de cunctis tribubus tuis, ut stet et ministret in nomine Domini ipse et filii eius in sempiternum."
,"6":"Si exierit Levites de una urbium tuarum ex omni Israel, in qua ut advena habitat, et voluerit venire desiderans locum, quem elegerit Dominus,"
,"7":"ministrabit in nomine Domini Dei sui, sicut omnes fratres eius levitae, qui stabunt ibi coram Domino."
,"8":"Partem ciborum eandem accipiet quam et ceteri, excepto eo, quod ex paterna ei successione debetur."
,"9":"Quando ingressus fueris terram, quam Dominus Deus tuus dabit tibi, cave, ne imitari velis abominationes illarum gentium."
,"10":"Nec inveniatur in te, qui filium suum aut filiam traducat per ignem, aut qui sortes sciscitetur et observet nubes atque auguria, nec sit maleficus"
,"11":"nec incantator, nec qui pythones consulat nec divinos, aut quaerat a mortuis veritatem;"
,"12":"omnia enim haec abominatur Dominus et propter istiusmodi scelera expellet eos in introitu tuo."
,"13":"Perfectus eris et absque macula cum Domino Deo tuo."
,"14":"Gentes istae, quarum possidebis terram, augures et divinos audiunt; tu autem a Domino Deo tuo aliter institutus es."
,"15":"Prophetam de gente tua et de fratribus tuis sicut me suscitabit tibi Dominus Deus tuus; ipsum audietis,"
,"16":"ut petiisti a Domino Deo tuo in Horeb, quando contio congregata est, atque dixisti: 'Ultra non audiam vocem Domini Dei mei et ignem hunc maximum amplius non videbo, ne moriar'."
,"17":"Et ait Dominus mihi: 'Bene omnia sunt locuti;"
,"18":"prophetam suscitabo eis de medio fratrum suorum similem tui et ponam verba mea in ore eius, loqueturque ad eos omnia, quae praecepero illi."
,"19":"Qui autem verba mea, quae loquetur in nomine meo, audire noluerit, ego ultor exsistam."
,"20":"Propheta autem qui, arrogantia depravatus, voluerit loqui in nomine meo, quae ego non praecepi illi ut diceret, aut ex nomine alienorum deorum, interficietur'."
,"21":"Quod si tacita cogitatione responderis: 'Quomodo possum intellegere verbum, quod Dominus non est locutus?',"
,"22":"hoc habebis signum: quod in nomine Domini propheta ille praedixerit, et non evenerit, hoc Dominus non est locutus, sed per tumorem animi sui propheta confinxit; et idcirco non timebis eum."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Cum disperderit Dominus Deus tuus gentes, quarum ti bi traditurus est terram, et possederis eam habitaverisque in urbibus eius et in aedibus,"
,"2":"tres civitates separabis tibi in medio terrae, quam Dominus Deus tuus dabit tibi in possessionem"
,"3":"sternens diligenter viam; et in tres aequaliter partes totam terrae tuae provinciam divides, ut habeat e vicino, qui propter homicidium profugus est, quo possit evadere."
,"4":"Haec erit lex homicidae fugientis, cuius vita servanda est: qui percusserit proximum suum nesciens et qui heri et nudiustertius nullum contra eum habuisse odium comprobatur,"
,"5":"sed abiisse cum eo simpliciter in silvam ad ligna caedenda, et in succisione lignorum securis fugerit manu, ferrumque lapsum de manubrio amicum eius percusserit et occiderit, hic ad unam supradictarum urbium confugiet et vivet;"
,"6":"ne forsitan ultor sanguinis cordis calore stimulatus persequatur et apprehendat eum, si longior via fuerit, et percutiat eum, et moriatur, qui non est reus mortis, quia nullum contra eum, qui occisus est, odium prius habuisse monstratur."
,"7":"Idcirco praecipio tibi, ut tres civitates aequalis inter se spatii dividas."
,"8":"Cum autem dilataverit Dominus Deus tuus terminos tuos, sicut iuravit patribus tuis, et dederit tibi cunctam terram, quam eis pollicitus est"
,"9":"- si tamen custodieris omne mandatum hoc et feceris, quae hodie praecipio tibi, ut diligas Dominum Deum tuum et ambules in viis eius omni tempore - addes tibi tres alias civitates et supradictarum trium urbium numerum duplicabis,"
,"10":"ut non effundatur sanguis innoxius in medio terrae, quam Dominus Deus tuus dabit tibi possidendam, nec sis sanguinis reus."
,"11":"Si quis autem odio habens proximum suum insidiatus fuerit vitae eius surgensque percusserit illum, et mortuus fuerit, fugeritque ad unam de supradictis urbibus,"
,"12":"mittent seniores civitatis eius et arripient eum de loco effugii tradentque in manu ultoris sanguinis, et morietur:"
,"13":"non misereberis eius et auferes innoxium sanguinem de Israel, ut bene sit tibi."
,"14":"Non transferes terminos proximi tui, quos fixerunt priores in possessione tua, quam acceperis in terra, quam Dominus Deus tuus dabit tibi possidendam."
,"15":"Non stabit testis unus contra aliquem, quidquid illius peccatum vel facinus fuerit; sed in ore duorum aut trium testium stabit omne verbum."
,"16":"Si steterit testis mendax contra hominem accusans eum praevaricationis,"
,"17":"stabunt ambo, quorum causa est, ante Dominum in conspectu sacerdotum et iudicum, qui fuerint in diebus illis."
,"18":"Cumque diligentissime perscrutantes iudices invenerint falsum testem dixisse contra fratrem suum mendacium,"
,"19":"reddent ei, sicut fratri suo facere cogitavit, et auferes malum de medio tui,"
,"20":"ut audientes ceteri timorem habeant et nequaquam ultra talia audeant facere in medio tui."
,"21":"Non misereberis eius, sed animam pro anima, oculum pro oculo, dentem pro dente, manum pro manu, pedem pro pede exiges."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Si exieris ad bellum contra hostes tuos et videris equita tus et currus et maiorem, quam tu habes, adversarii exercitus multitudinem, non timebis eos, quia Dominus Deus tuus tecum est, qui eduxit te de terra Aegypti."
,"2":"Appropinquante autem iam proelio, stabit sacerdos ante aciem et sic loquetur ad populum:"
,"3":"'Audi, Israel: Vos hodie contra inimicos vestros pugnam committitis; non pertimescat cor vestrum, nolite metuere, nolite cedere nec formidetis eos,"
,"4":"quia Dominus Deus vester incedit vobiscum et pro vobis contra adversarios vestros dimicabit, ut eruat vos de periculo'."
,"5":"Praefecti quoque per singulas turmas, audiente exercitu, proclamabunt: 'Quis est homo, qui aedificavit domum novam et non dedicavit eam? Vadat et revertatur in domum suam, ne forte moriatur in bello, et alius dedicet illam."
,"6":"Quis est homo, qui plantavit vineam et necdum vindemiavit eam? Vadat et revertatur in domum suam, ne forte moriatur in bello, et alius homo vindemiet illam."
,"7":"Quis est homo, qui despondit uxorem et non accepit eam? Vadat et revertatur in domum suam, ne forte moriatur in bello, et alius homo accipiat eam'."
,"8":"His dictis, addent reliqua et loquentur ad populum: 'Quis est homo formidulosus et corde pavido? Vadat et revertatur in domum suam, ne pavere faciat corda fratrum suorum, sicut ipse timore perterritus est'."
,"9":"Cumque praefecti finem loquendi ad populum fecerint, constituantur duces exercitus in capite populi."
,"10":"Si quando accesseris ad expugnandam civitatem, offeres ei primum pacem;"
,"11":"si receperit et aperuerit tibi portas, cunctus populus, qui in ea est, serviet tibi sub tributo."
,"12":"Sin autem foedus inire noluerit et coeperit contra te bellum, oppugnabis eam."
,"13":"Cumque tradiderit Dominus Deus tuus illam in manu tua, percuties omne, quod in ea generis masculini est, in ore gladii"
,"14":"absque mulieribus et infantibus, iumentis et ceteris, quae in civitate sunt. Omnem praedam hanc diripies tibi et comedes de spoliis hostium tuorum, quae Dominus Deus tuus dederit tibi."
,"15":"Sic facies cunctis civitatibus, quae a te procul valde sunt et non sunt de gentium istarum urbibus, quas in possessionem accepturus es."
,"16":"De his autem civitatibus, quae dabuntur tibi, nullum omnino permittes vivere,"
,"17":"sed interficies in ore gladii, Hetthaeum videlicet et Amorraeum et Chananaeum, Pherezaeum et Hevaeum et Iebusaeum, sicut praecepit tibi Dominus Deus tuus,"
,"18":"ne forte doceant vos facere cunctas abominationes, quas ipsi operati sunt diis suis, et peccetis in Dominum Deum vestrum."
,"19":"Quando obsederis civitatem multo tempore et munitionibus circumdederis, ut expugnes eam, non immittes securim in arbores eius, de quibus vesci potes, nec succidas eas. Numquid homo est arbor campi, ut eam obsideas?"
,"20":"Si qua autem ligna non sunt pomifera, succide illa et exstrue machinas, donec capias civitatem, quae contra te dimicat."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Quando inventum fuerit in terra, quam Dominus Deus tuus daturus est tibi, hominis cadaver occisi, et ignoratur caedis reus,"
,"2":"egredientur maiores natu et iudices tui et metientur a loco cadaveris singularum per circuitum spatia civitatum"
,"3":"et, quam viciniorem ceteris esse perspexerint, seniores civitatis illius tollent vitulam de armento, quae non traxit iugum nec terram scidit vomere,"
,"4":"et ducent eam ad torrentem perennem, ubi numquam aratum est nec seminatum, et caedent apud eum cervices vitulae;"
,"5":"accedentque sacerdotes filii Levi, quos elegerit Dominus Deus tuus, ut ministrent ei et benedicant in nomine eius, et ad verbum eorum omnis causa et omnis percussio iudicetur."
,"6":"Et omnes maiores natu civitatis illius, qui prope interfectum sunt, lavabunt manus suas super vitulam, quae apud torrentem percussa est,"
,"7":"et dicent: 'Manus nostrae non effuderunt hunc sanguinem, nec oculi nostri viderunt;"
,"8":"propitius esto populo tuo Israel, quem redemisti, Domine, et non reputes sanguinem innocentem in medio populi tui Israel'. Et auferetur ab eis reatus sanguinis."
,"9":"Tu autem removebis innocentem cruorem, cum feceris, quod rectum est in oculis Domini."
,"10":"Si egressus fueris ad pugnam contra inimicos tuos, et tradiderit eos Dominus Deus tuus in manu tua, captivosque duxeris"
,"11":"et videris in numero captivorum mulierem pulchram et adamaveris eam voluerisque habere uxorem,"
,"12":"introduces eam in domum tuam. Quae radet caesariem et circumcidet ungues"
,"13":"et deponet vestem captivitatis sedensque in domo tua flebit patrem et matrem suam uno mense; et postea intrabis ad eam sociaberisque illi, et erit uxor tua."
,"14":"Sin autem postea non sederit animo tuo, dimittes eam liberam; nec vendere poteris pecunia nec opprimere per potentiam, quia humiliasti eam."
,"15":"Si habuerit homo uxores duas, unam dilectam et alteram odiosam, genuerintque ei liberos, et fuerit filius odiosae primogenitus,"
,"16":"volueritque substantiam inter filios suos dividere, non poterit filium dilectae facere primogenitum et praeferre filio odiosae,"
,"17":"sed filium odiosae agnoscet primogenitum dabitque ei de cunctis, quae habuerit, duplicia; iste est enim principium roboris eius, et huic debentur primogenita."
,"18":"Si genuerit homo filium contumacem et protervum, qui non audiat patris aut matris imperium et coercitus oboedire contempserit,"
,"19":"apprehendent eum et ducent ad seniores civitatis suae et ad portam iudicii"
,"20":"dicentque ad eos: 'Filius noster iste protervus et contumax est: monita nostra audire contemnit, comissationibus vacat et luxuriae atque conviviis potatorum'."
,"21":"Lapidibus eum obruent viri civitatis, et morietur, ut auferatis malum de medio vestri, et universus Israel audiens pertimescat."
,"22":"Quando peccaverit homo, quod morte plectendum est, et occisum appenderis in patibulo,"
,"23":"non permanebit cadaver eius in ligno; sed in eadem die sepelietur, quia maledictus a Deo est, qui pendet in ligno; et nequaquam contaminabis terram tuam, quam Dominus Deus tuus dederit tibi in possessionem."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Non videbis bovem fratris tui aut ovem errantem et praeteribis, sed reduces fratri tuo;"
,"2":"si autem non est prope frater tuus nec nosti eum, duces in domum tuam, et erunt apud te quamdiu quaerat ea frater tuus et recipiat."
,"3":"Similiter facies de asino et de vestimento et de omni re fratris tui, quae perierit: si inveneris eam, ne subtrahas te."
,"4":"Si videris asinum fratris tui aut bovem cecidisse in via, non subtrahes te, sed sublevabis cum eo."
,"5":"Non induetur mulier veste virili, nec vir utetur veste feminea: abominabilis enim apud Dominum Deum tuum est omnis, qui facit haec."
,"6":"Si ambulans per viam, in arbore vel in terra nidum avis inveneris et matrem pullis vel ovis desuper incubantem, non sumes eam de filiis,"
,"7":"sed abire patieris matrem tenens filios, ut bene sit tibi, et longo vivas tempore."
,"8":"Cum aedificaveris domum novam, facies murum tecto tuo per circuitum, ne adducas sanguinem super domum tuam et sis reus, labente aliquo in praeceps ruente."
,"9":"Non seres vineam tuam altero semine, ne et sementis, quam sevisti, et quae nascuntur ex vinea, pariter sanctificentur."
,"10":"Non arabis in bove simul et asino."
,"11":"Non indueris vestimento, quod ex lana linoque contextum est."
,"12":"Funiculos facies per quattuor angulos pallii tui, quo operieris."
,"13":"Si duxerit vir uxorem et intraverit ad eam et postea odio habuerit eam"
,"14":"imputaveritque ei obiciens ei nomen pessimum et dixerit: 'Uxorem hanc accepi et ingressus ad eam non inveni virginem',"
,"15":"tollent pater et mater eius et ferent secum signa virginitatis eius ad seniores urbis, qui in porta sunt,"
,"16":"et dicet pater: 'Filiam meam dedi huic uxorem, quam, quia odit,"
,"17":"imponit ei nomen pessimum, ut dicat: Non inveni filiam tuam virginem; et ecce haec sunt signa virginitatis filiae meae'. Expandent vestimentum coram se nioribus civitatis."
,"18":"Apprehendentque senes urbis illius virum et verberabunt illum"
,"19":"condemnantes insuper centum siclis argenti, quos dabunt patri puellae, quoniam diffamavit nomen pessimum super virginem Israel; habebitque eam uxorem et non poterit dimittere eam omnibus diebus vitae suae."
,"20":"Quod si verum est, quod obicit, et non est in puella inventa virginitas,"
,"21":"educent eam ad fores domus patris sui, et lapidibus obruent viri civitatis eius, et morietur, quoniam fecit nefas in Israel, ut fornicaretur in domo patris sui; et auferes malum de medio tui."
,"22":"Si inventus fuerit vir dormiens cum uxore alterius, uterque morietur, id est adulter et adultera; et auferes malum de Israel."
,"23":"Si puellam virginem desponsatam viro invenerit aliquis in civitate et concubuerit cum illa,"
,"24":"educetis utrumque ad portam civitatis illius et lapidibus obruetis, et morientur: puella quia non clamavit, cum esset in civitate, vir quia humiliavit uxorem proximi sui; et auferes malum de medio tui."
,"25":"Sin autem in agro reppererit vir puellam, quae desponsata est, et apprehendens concubuerit cum illa, ipse morietur solus;"
,"26":"puella nihil patietur nec est rea mortis, quoniam sicut vir consurgit contra fratrem suum et occidit eum, ita et puella perpessa est:"
,"27":"sola erat in agro, clamavit puella desponsata, et nullus affuit, qui liberaret eam."
,"28":"Si invenerit vir puellam virginem, quae non habet sponsum, et apprehendens concubuerit cum ea, et res ad iudicium venerit,"
,"29":"dabit, qui dormivit cum ea, patri puellae quinquaginta siclos argenti et habebit eam uxorem, quia humiliavit illam: non poterit dimittere eam cunctis diebus vitae suae."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Non accipiet homo uxorem patris sui nec revelabit operi mentum eius."
,"2":"Non intrabit eunuchus, attritis vel amputatis testiculis et absciso veretro, ecclesiam Domini."
,"3":"Non ingredietur mamzer in ecclesiam Domini neque decima generatione."
,"4":"Ammonites et Moabites etiam in decima generatione non intrabunt ecclesiam Domini in aeternum,"
,"5":"quia noluerunt vobis occurrere cum pane et aqua in via, quando egressi estis de Aegypto, et quia conduxerunt contra te Balaam filium Beor de Phethor in Aramnaharaim, ut malediceret tibi;"
,"6":"et noluit Dominus Deus tuus audire Balaam vertitque tibi maledictionem eius in benedictionem, eo quod diligeret te."
,"7":"Non facies cum eis pacem nec quaeres eis bona cunctis diebus vitae tuae in sempiternum."
,"8":"Non abominaberis Idumaeum, quia frater tuus est, nec Aegyptium, quia advena fuisti in terra eius:"
,"9":"qui nati fuerint ex eis tertia generatione, intrabunt ecclesiam Domini."
,"10":"Quando egressus fueris adversus hostes tuos in pugnam, custodies te ab omni re mala."
,"11":"Si fuerit apud te homo, qui nocturno pollutus sit somnio, egredietur extra castra et non revertetur,"
,"12":"priusquam ad vesperam lavetur aqua; et ad solis occasum regredietur in castra."
,"13":"Habebis locum extra castra, ad quem egrediaris ad requisita naturae"
,"14":"gerens paxillum in balteo; cumque sederis foris, fodies foveam et egesta humo operies."
,"15":"Dominus enim Deus tuus ambulat in medio castrorum tuorum, ut eruat te et tradat tibi inimicos tuos; sint castra tua sancta, et nihil in eis videat foeditatis nec derelinquat te."
,"16":"Non trades servum domino suo, qui ad te confugerit:"
,"17":"habitabit tecum in medio tui in loco, quem elegerit in una urbium tuarum, quae placuerit ei, nec contristes eum."
,"18":"Non erit prostibulum sacrum de filiabus Israel, nec scortator sacer de filiis Israel."
,"19":"Non offeres mercedem prostibuli nec pretium canis in domo Domini Dei tui, quidquid illud est, quod voveris, quia abominatio est utrumque apud Dominum Deum tuum."
,"20":"Non fenerabis fratri tuo ad usuram pecuniam nec alimenta nec quamlibet aliam rem,"
,"21":"sed alieno fenerabis. Fratri autem tuo absque usura id, quo indiget, commodabis, ut benedicat tibi Dominus Deus tuus in omni opere tuo in terra, ad quam ingredieris possidendam."
,"22":"Cum voveris votum Domino Deo tuo, non tardabis reddere; quia requiret illud Dominus Deus tuus a te, et reputabitur tibi in peccatum."
,"23":"Si nolueris polliceri, absque peccato eris;"
,"24":"quod autem egressum est de labiis tuis, observabis et facies, sicut promisisti Domino Deo tuo: propria voluntate et ore tuo locutus es."
,"25":"Ingressus vineam proximi tui comede uvas, quantum tibi placuerit; in sporta autem ne efferas tecum."
,"26":"Si intraveris in segetem amici tui, franges spicas manu; falce autem non metes."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Si acceperit homo uxorem et habuerit eam, et non invene rit gratiam ante oculos eius propter aliquam foeditatem, et scripserit libellum repudii dederitque in manu illius et dimiserit eam de domo sua,"
,"2":"cumque egressa alterius uxor facta fuerit,"
,"3":"et ille quoque oderit eam dederitque ei libellum repudii et dimiserit de domo sua, vel mortuus fuerit,"
,"4":"non poterit prior maritus recipere eam in uxorem, quia polluta est; hoc esset abominatio coram Domino. Ne peccare facias terram tuam, quam Dominus Deus tuus tradiderit tibi possidendam."
,"5":"Cum acceperit homo nuper uxorem, non procedet ad bellum, nec ei quippiam necessitatis iniungetur publicae, sed vacabit liber domui suae, ut uno anno laetetur cum uxore sua."
,"6":"Non accipies loco pignoris molam vel superiorem lapidem molarem, quia animam suam apposuit tibi."
,"7":"Si deprehensus fuerit homo rapiens unum de fratribus suis de filiis Israel et, vendito eo, accipiens pretium, interficietur; et auferes malum de medio tui."
,"8":"Observa diligenter, si incurras plagam leprae, quaecumque docuerint vos sacerdotes levitici generis; quod praecepi eis, implete sollicite."
,"9":"Memento, quae fecerit Dominus Deus tuus Mariae in via, cum egrederemini de Aegypto."
,"10":"Cum mutuam dabis proximo tuo rem aliquam, non ingredieris domum eius, ut pignus auferas,"
,"11":"sed stabis foris, et ille tibi pignus proferet, quod habuerit."
,"12":"Sin autem pauper est, non pernoctabit apud te pignus,"
,"13":"sed statim reddes ei ad solis occasum, ut dormiens in vestimento suo benedicat tibi, et habeas iustitiam coram Domino Deo tuo."
,"14":"Non negabis mercedem indigentis et pauperis ex fratribus tuis sive advenis, qui tecum morantur in terra intra portas tuas,"
,"15":"sed eadem die reddes ei pretium laboris sui ante solis occasum, quia pauper est, et illud desiderat anima sua; ne clamet contra te ad Dominum, et reputetur tibi in peccatum."
,"16":"Non occidentur patres pro filiis, nec filii pro patribus, sed unusquisque pro peccato suo morietur."
,"17":"Non pervertes iudicium advenae et pupilli nec auferes pignoris loco viduae vestimentum."
,"18":"Memento quod servieris in Aegypto, et eruerit te Dominus Deus tuus inde; idcirco praecipio tibi, ut facias hanc rem."
,"19":"Quando messueris segetem in agro tuo et oblitus manipulum reliqueris, non reverteris, ut tollas eum, sed advenam et pupillum et viduam auferre patieris, ut benedicat tibi Dominus Deus tuus in omni opere manuum tuarum."
,"20":"Si fruges collegeris olivarum, quidquid remanserit in arboribus, non reverteris, ut colligas, sed relinques advenae, pupillo ac viduae."
,"21":"Si vindemiaveris vineam tuam, non colliges remanentes racemos, sed cedent in usus advenae, pupilli ac viduae."
,"22":"Memento quod et tu servieris in Aegypto; et idcirco praecipio tibi, ut facias hanc rem."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Si fuerit causa inter aliquos, et interpellaverint iudices, quem iustum esse perspexerint, illi iustitiae palmam dabunt; quem impium, condemnabunt impietatis."
,"2":"Sin autem iudex eum, qui peccavit, dignum viderit plagis, prosternet et coram se faciet verberari; pro mensura peccati erit et plagarum modus,"
,"3":"ita dumtaxat, ut quadragenarium numerum non excedant, ne ultra percussus plagis multis et foede laceratus ante oculos tuos abeat frater tuus."
,"4":"Non ligabis os bovis terentis in area fruges tuas."
,"5":"Quando habitaverint fratres simul, et unus ex eis absque filio mortuus fuerit, uxor defuncti non nubet foras alteri, sed accipiet eam frater eius uxorem et suscitabit semen fratris sui;"
,"6":"et primogenitum ex ea filium nomine illius appellabit, ut non deleatur nomen eius ex Israel."
,"7":"Sin autem noluerit accipere uxorem fratris sui, quae ei lege debetur, perget mulier ad portam civitatis et interpellabit maiores natu dicetque: 'Non vult frater viri mei suscitare nomen fratris sui in Israel nec me in coniugium sumere';"
,"8":"statimque accersiri eum facient et interrogabunt. Si responderit: 'Nolo eam uxorem accipere',"
,"9":"accedet mulier ad eum coram senioribus et tollet calceamentum de pede eius spuetque in faciem illius et dicet: 'Sic fit homini, qui non aedificat domum fratris sui'."
,"10":"Et vocabitur nomen illius in Israel: 'Domus discalceati'."
,"11":"Si habuerint inter se iurgium viri, et unus contra alterum rixari coeperit, volensque uxor alterius eruere virum suum de manu fortioris, miserit manum et apprehenderit verenda eius,"
,"12":"abscides manum illius nec flecteris super eam ulla misericordia."
,"13":"Non habebis in sacculo tuo diversa pondera maius et minus;"
,"14":"nec erit in domo tua ephi maius et minus."
,"15":"Pondus habebis iustum et verum, et ephi iustum et verum erit tibi, ut multo vivas tempore super terram, quam Dominus Deus tuus dederit tibi."
,"16":"Abominatur enim Dominus tuus eum, qui facit haec, et aversatur omnem iniustitiam."
,"17":"Memento quae fecerit tibi Amalec in via, quando egrediebaris ex Aegypto;"
,"18":"quomodo occurrerit tibi et omnes extremos agminis tui, qui lassi residebant, ceciderit, quando tu eras fame et labore confectus, et non timuerit Deum."
,"19":"Cum ergo Dominus Deus tuus dederit tibi requiem a cunctis per circuitum inimicis tuis in terra, quam tibi daturus est, delebis nomen Amalec sub caelo: cave, ne obliviscaris!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Cumque intraveris terram, quam Dominus Deus tuus ti bi daturus est possidendam, et obtinueris eam atque habitaveris in illa,"
,"2":"tolles primitias de cunctis frugibus agri, quas collegeris de terra tua, quam Dominus Deus tuus dabit tibi, et pones in cartallo pergesque ad locum, quem Dominus Deus tuus elegerit, ut ibi habitet nomen eius,"
,"3":"accedesque ad sacerdotem, qui fuerit in diebus illis, et dices ad eum: 'Profiteor hodie coram Domino Deo tuo quod ingressus sim terram, pro qua iuravit patribus nostris, ut daret eam nobis'."
,"4":"Suscipiensque sacerdos cartallum de manu tua ponet ante altare Domini Dei tui,"
,"5":"et loqueris in conspectu Domini Dei tui: 'Syrus vagus erat pater meus et descendit in Aegyptum et ibi peregrinatus est in paucissimo numero; crevitque in gentem magnam ac robustam et infinitae multitudinis."
,"6":"Afflixeruntque nos Aegyptii et persecuti sunt imponentes onera gravissima."
,"7":"Et clamavimus ad Dominum, Deum patrum nostrorum, qui exaudivit nos et respexit humilitatem nostram et laborem atque angustias,"
,"8":"et eduxit nos Dominus de Aegypto in manu forti et brachio extento, in ingenti pavore, in signis atque portentis,"
,"9":"et introduxit ad locum istum et tradidit nobis terram hanc lacte et melle manantem."
,"10":"Et ecce nunc attuli primitias frugum terrae, quam dedisti mihi, Domine'. Et dimittes eas in conspectu Domini Dei tui et adorato Domino Deo tuo."
,"11":"Et epulaberis in omnibus bonis, quae Dominus Deus tuus dederit tibi et domui tuae, tu et Levites et advena, qui tecum est."
,"12":"Quando compleveris decimam cunctarum frugum tuarum, anno tertio, anno decimarum, et dederis Levitae et advenae et pupillo et viduae, ut comedant intra portas tuas et saturentur,"
,"13":"loqueris in conspectu Domini Dei tui: 'Abstuli, quod sanctificatum est, de domo mea et dedi illud Levitae et advenae, pupillo ac viduae, sicut iussisti mihi; non praeterivi mandata tua nec sum oblitus imperii tui,"
,"14":"non comedi ex eis in luctu meo nec separavi ex eis in qualibet immunditia nec expendi ex his quidquam mortuo: oboedivi voci Domini Dei mei et feci omnia, sicut praecepisti mihi."
,"15":"Respice de habitaculo sancto tuo, de caelo, et benedic populo tuo Israel et terrae, quam dedisti nobis, sicut iurasti patribus nostris, terrae lacte et melle mananti'."
,"16":"Hodie Dominus Deus tuus mandavit tibi, ut facias praecepta haec atque iudicia et custodias et impleas illa ex toto corde tuo et ex tota anima tua."
,"17":"Dominum elegisti hodie, ut sit tibi Deus, et ambules in viis eius et custodias praecepta illius et mandata atque iudicia et oboedias eius imperio;"
,"18":"et Dominus elegit te hodie, ut sis ei populus peculiaris, sicut locutus est tibi, et custodias omnia mandata illius,"
,"19":"et faciat te excelsiorem cunctis gentibus, quas creavit in laudem et nomen et gloriam suam, ut sis populus sanctus Domini Dei tui, sicut locutus est '."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Praecepit autem Moyses et seniores Israel populo dicen tes: ' Custodite omne mandatum, quod praecipio vobis hodie."
,"2":"Cumque transieritis Iordanem in terram, quam Dominus Deus tuus dabit tibi, eriges ingentes lapides et calce obduces eos,"
,"3":"ut possis in eis scribere omnia verba legis huius, Iordane transmisso, ut introeas terram, quam Dominus Deus tuus dabit tibi, terram lacte et melle manantem, sicut locutus est Dominus, Deus patrum tuorum, tibi."
,"4":"Quando ergo transieritis Iordanem, erigite istos lapides, sicut ego hodie praecipio vobis, in monte Hebal, et obduces eos calce;"
,"5":"et aedificabis ibi altare Domino Deo tuo de lapidibus, quos ferrum non tetigit,"
,"6":"de saxis impolitis, et offeres super eo holocausta Domino Deo tuo."
,"7":"Et immolabis hostias pacificas comedesque ibi et epulaberis coram Domino Deo tuo;"
,"8":"et scribes super lapides omnia verba legis huius plane et lucide '."
,"9":"Dixeruntque Moyses et sacerdotes levitici generis ad omnem Israelem: ' Attende et audi, Israel: hodie factus es populus Domino Deo tuo;"
,"10":"audies vocem eius et facies mandata atque praecepta, quae ego praecipio tibi '."
,"11":"Praecepitque Moyses populo in die illo dicens:"
,"12":"' Hi stabunt ad benedicendum populo super montem Garizim, Iordane transmisso: Simeon, Levi, Iudas, Issachar, Ioseph et Beniamin."
,"13":"Et e regione isti stabunt ad maledicendum in monte Hebal: Ruben, Gad et Aser et Zabulon, Dan et Nephthali."
,"14":"Et pronunciabunt Levitae dicentque ad omnes viros Israel excelsa voce:"
,"15":"'Maledictus homo, qui facit sculptile et conflatile, abominationem Domini, opus manuum artificum, ponetque illud in abscondito'. Et respondebit omnis populus et dicet: 'Amen'."
,"16":"'Maledictus, qui contemnit patrem suum et matrem'. Et dicet omnis populus: 'Amen'."
,"17":"'Maledictus, qui transfert terminos proximi sui'. Et dicet omnis populus: 'Amen'."
,"18":"'Maledictus, qui errare facit caecum in itinere'. Et dicet omnis populus: 'Amen'."
,"19":"'Maledictus, qui pervertit iudicium advenae, pupilli et viduae'. Et dicet omnis populus: 'Amen'."
,"20":"'Maledictus, qui dormit cum uxore patris sui, quia revelat operimentum lectuli eius'. Et dicet omnis populus: 'Amen'."
,"21":"'Maledictus, qui dormit cum omni iumento'. Et dicet omnis populus: 'Amen'."
,"22":"'Maledictus, qui dormit cum sorore sua, filia patris sui sive matris suae'. Et dicet omnis populus: 'Amen'."
,"23":"'Maledictus, qui dormit cum socru sua'. Et dicet omnis populus: 'Amen'."
,"24":"'Maledictus, qui clam percusserit proximum suum'. Et dicet omnis populus: 'Amen'."
,"25":"'Maledictus, qui accipit munera, ut percutiat sanguinem innocentem'. Et dicet omnis populus: 'Amen'."
,"26":"'Maledictus, qui non permanet in sermonibus legis huius nec eos opere perficit'. Et dicet omnis populus: 'Amen'."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Sin audieris vocem Domini Dei tui, ut facias atque custo dias omnia mandata eius, quae ego praecipio tibi hodie, faciet te Dominus Deus tuus excelsiorem cunctis gentibus, quae versantur in terra,"
,"2":"venientque super te universae benedictiones istae et apprehendent te, si tamen vocem Domini Dei tui audieris."
,"3":"Benedictus tu in civitate et benedictus in agro."
,"4":"Benedictus fructus ventris tui et fructus terrae tuae fructusque iumentorum tuorum, partus armentorum tuorum et incrementum ovium tuarum."
,"5":"Benedictum canistrum et pistrinum tuum."
,"6":"Benedictus eris et ingrediens et egrediens."
,"7":"Dabit Dominus inimicos tuos, qui consurgunt adversum te, corruentes in conspectu tuo; per unam viam venient contra te et per septem fugient a facie tua."
,"8":"Emittet Dominus benedictionem super cellaria tua et super omnia opera manuum tuarum; benedicetque tibi in terra, quam Dominus Deus tuus dabit tibi."
,"9":"Suscitabit te Dominus sibi in populum sanctum, sicut iuravit tibi, si custodieris mandata Domini Dei tui et ambulaveris in viis eius."
,"10":"Videbuntque omnes terrarum populi quod nomen Domini invocatum sit super te, et timebunt te."
,"11":"Abundare te faciet Dominus omnibus bonis, fructu uteri tui et fructu iumentorum tuorum, fructu terrae tuae, quam iuravit Dominus patribus tuis, ut daret tibi."
,"12":"Aperiet Dominus tibi thesaurum suum optimum, caelum, ut tribuat pluviam terrae tuae in tempore suo; benedicatque cunctis operibus manuum tuarum; et fenerabis gentibus multis et ipse a nullo fenus accipies."
,"13":"Constituet te Dominus in caput et non in caudam, et eris semper supra et non subter, si audieris mandata Domini Dei tui, quae ego praecipio tibi hodie, et custodieris et feceris"
,"14":"ac non declinaveris a verbis, quae ego praecipio vobis hodie, nec ad dexteram nec ad sinistram, nec secutus fueris deos alienos neque colueris eos."
,"15":"Quod si audire nolueris vocem Domini Dei tui, ut custodias et facias omnia mandata eius et praecepta, quae ego praecipio tibi hodie, venient super te omnes maledictiones istae et apprehendent te:"
,"16":"Maledictus eris in civitate, maledictus in agro."
,"17":"Maledictum canistrum et pistrinum tuum."
,"18":"Maledictus fructus ventris tui et fructus terrae tuae, partus armentorum tuorum et incrementum ovium tuarum."
,"19":"Maledictus eris ingrediens et maledictus egrediens."
,"20":"Mittet Dominus super te maledictionem et conturbationem et increpationem in omnia opera tua, quae facies, donec conterat te et perdat velociter propter adinventiones tuas pessimas, in quibus reliquisti me."
,"21":"Adiunget Dominus tibi pestilentiam, donec consumat te de terra, ad quam ingredieris possidendam."
,"22":"Percutiet te Dominus consumptione, febri et inflammatione, ardore et aestu, uredine ac aurugine, et persequentur te, donec pereas."
,"23":"Et erit caelum, quod est supra caput tuum, aeneum, et terra, quam calcas, ferrea."
,"24":"Convertet Dominus imbrem terrae tuae in pulverem, et de caelo descendet super te cinis, donec conteraris."
,"25":"Tradet te Dominus corruentem ante hostes tuos: per unam viam egredieris contra eos et per septem fugies et eris in terrorem omnibus regnis terrae."
,"26":"Eritque cadaver tuum in escam cunctis volatilibus caeli et bestiis terrae, et non erit qui abigat."
,"27":"Percutiet te Dominus ulcere Aegypti et tumore, scabie quoque et prurigine, ita ut curari nequeas."
,"28":"Percutiet te Dominus amentia et caecitate ac stupore mentis;"
,"29":"et palpabis in meridie, sicut palpare solet caecus in tenebris, et non diriges vias tuas. Omnique tempore eris oppressus et exspoliatus nec habebis, qui liberet te."
,"30":"Uxorem accipies, et alius dormiet cum ea. Domum aedificabis et non habitabis in ea. Plantabis vineam et non vindemiabis eam."
,"31":"Bos tuus mactabitur coram te, et non comedes ex eo. Asinus tuus rapietur in conspectu tuo et non reddetur tibi. Oves tuae dabuntur inimicis tuis, et non erit qui te adiuvet."
,"32":"Filii tui et filiae tuae tradentur alteri populo, videntibus oculis tuis et deficientibus ad conspectum eorum tota die, et non erit fortitudo in manu tua."
,"33":"Fructus terrae tuae et omnes labores tuos comedet populus, quem ignoras, et eris semper oppressus et confractus cunctis diebus"
,"34":"et insanies in aspectu eorum, quae videbunt oculi tui."
,"35":"Percutiet te Dominus ulcere pessimo in genibus et in suris, sanarique non poteris a planta pedis usque ad verticem tuum."
,"36":"Ducet te Dominus et regem tuum, quem constitueris super te, in gentem, quam ignorasti tu et patres tui, et servies ibi diis alienis, ligno et lapidi;"
,"37":"et eris in stuporem et in proverbium ac fabulam omnibus populis, ad quos te introduxerit Dominus."
,"38":"Sementem multam iacies in terram et modicum congregabis, quia locustae devorabunt omnia."
,"39":"Vineas plantabis et coles et vinum non bibes nec colliges ex ea quippiam, quoniam vastabitur vermibus."
,"40":"Olivas habebis in omnibus terminis tuis et non ungeris oleo, quia defluent et peribunt."
,"41":"Filios generabis et filias et non frueris eis, quoniam ducentur in captivitatem."
,"42":"Omnes arbores tuas et fruges terrae tuae locusta consumet."
,"43":"Advena, qui tecum versatur in terra, ascendet super te eritque sublimior; tu autem descendes et eris inferior."
,"44":"Ipse fenerabit tibi, et tu non fenerabis ei; ipse erit in caput, et tu eris in caudam."
,"45":"Et venient super te omnes maledictiones istae et persequentes apprehendent te, donec intereas, quia non audisti vocem Domini Dei tui nec servasti mandata eius et praecepta, quae praecepit tibi."
,"46":"Et erunt in te signa atque prodigia et in semine tuo usque in sempiternum."
,"47":"Eo quod non servieris Domino Deo tuo in gaudio cordisque laetitia propter rerum omnium abundantiam,"
,"48":"servies inimico tuo, quem immittet Dominus tibi, in fame et siti et nuditate et omnium penuria, et ponet iugum ferreum super cervicem tuam, donec te conterat."
,"49":"Adducet Dominus super te gentem de longinquo et de extremis finibus terrae in similitudinem aquilae volantis cum impetu, cuius linguam intellegere non possis:"
,"50":"gentem procacissimam, quae non deferat seni nec misereatur parvulo;"
,"51":"et devoret fructum iumentorum tuorum ac fruges terrae tuae, donec intereas, et non relinquat tibi triticum, vinum et oleum, partum armentorum et incrementum ovium, donec te disperdat"
,"52":"et obsideat te in cunctis urbibus tuis, donec destruantur muri tui firmi atque sublimes, in quibus habebas fiduciam in omni terra tua. Obsideberis intra portas tuas in omni terra tua, quam dabit tibi Dominus Deus tuus,"
,"53":"et comedes fructum uteri tui, carnes filiorum tuorum et filiarum tuarum, quas dederit tibi Dominus Deus tuus, in obsidione et angustia, qua opprimet te hostis tuus."
,"54":"Homo tener in te et delicatus valde invidebit fratri suo et uxori, quae cubat in sinu suo, et residuis filiis suis, quos reservaverit,"
,"55":"ne det uni ex eis de carnibus filiorum suorum, quas comedet, eo quod nihil aliud habeat in obsidione et angustia, qua oppresserit te inimicus tuus intra omnes portas tuas."
,"56":"Tenera mulier in te et delicata, quae non tentabat pedis vestigium figere in terram propter mollitiem et teneritudinem nimiam, invidebit viro suo, qui cubat in sinu eius, filio et filiae"
,"57":"et illuviei secundarum, quae egrediuntur de medio feminum eius, et liberis, qui eadem hora nati sunt; comedet enim eos clam propter rerum omnium penuriam in obsidione et angustia, qua opprimet te inimicus tuus intra portas tuas."
,"58":"Nisi custodieris et feceris omnia verba legis huius, quae scripta sunt in hoc volumine, et timueris nomen gloriosum et terribile hoc, Dominum Deum tuum,"
,"59":"augebit ultra modum Dominus plagas tuas et plagas seminis tui, plagas magnas et perseverantes, infirmitates pessimas et perpetuas,"
,"60":"et convertet in te omnes afflictiones Aegypti, quas timuisti, et adhaerebunt tibi."
,"61":"Insuper universos languores et plagas, quae non sunt scriptae in volumine legis huius, inducet Dominus super te, donec te conterat;"
,"62":"et remanebitis pauci numero, qui prius eratis sicut astra caeli prae multitudine, quoniam non audisti vocem Domini Dei tui."
,"63":"Et sicut ante laetatus est Dominus super vos bene vobis faciens vosque multiplicans, sic laetabitur super vos disperdens vos atque subvertens, ut auferamini de terra, ad quam ingredieris possidendam."
,"64":"Disperget te Dominus in omnes populos a summitate terrae usque ad terminos eius, et servies ibi diis alienis, quos et tu ignorasti et patres tui, lignis et lapidibus."
,"65":"In gentibus quoque illis non quiesces, neque erit requies vestigio pedis tui; dabit enim tibi Dominus ibi cor pavidum et deficientes oculos et animam consumptam maerore."
,"66":"Et erit vita tua quasi pendens ante te; timebis nocte et die et non credes vitae tuae."
,"67":"Mane dices: 'Quis mihi det vesperum?'; et vespere: 'Quis mihi det mane?', propter cordis tui formidinem, qua terreberis, et propter ea, quae tuis videbis oculis."
,"68":"Reducet te Dominus classibus in Aegyptum per viam, de qua dixi tibi, ut eam amplius non videres; ibi vendetis vos inimicis vestris in servos et ancillas, et non erit qui emat '."
,"69":"Haec sunt verba foederis, quod praecepit Dominus Moysi, ut feriret cum filiis Israel in terra Moab, praeter illud foedus, quod cum eis pepigit in Horeb."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Vocavitque Moyses omnem Israel et dixit ad eos: ' Vos vidistis universa, quae fecit Dominus coram vobis in terra Aegypti pharaoni et omnibus servis eius universaeque terrae illius,"
,"2":"tentationes magnas, quas viderunt oculi tui, signa illa portentaque ingentia;"
,"3":"et non dedit Dominus vobis cor intellegens et oculos videntes et aures, quae possint audire, usque in praesentem diem."
,"4":"Adduxi vos quadraginta annis per desertum; non sunt attrita vestimenta vestra, nec calceamenta pedum tuorum vetustate consumpta sunt,"
,"5":"panem non comedistis, vinum et siceram non bibistis, ut sciretis quia ego sum Dominus Deus vester."
,"6":"Et venistis ad hunc locum, egressusque est Sehon rex Hesebon et Og rex Basan occurrentes nobis ad pugnam, et percussimus eos."
,"7":"Et tulimus terram eorum ac tradidimus possidendam Ruben et Gad et dimidiae tribui Manasse."
,"8":"Custodite ergo verba pacti huius et implete ea, ut prosperemini in universis, quae facitis."
,"9":"Vos statis hodie cuncti coram Domino Deo vestro, principes vestri ac tribus et maiores natu atque praefecti, omnis vir Israel,"
,"10":"liberi et uxores vestrae et advena tuus, qui tecum moratur in castris, a lignorum caesoribus usque ad hos, qui hauriunt aquas tuas,"
,"11":"ut transeas in foedere Domini Dei tui et in iure iurando, quod hodie Dominus Deus tuus percutit tecum,"
,"12":"ut suscitet te sibi hodie in populum, et ipse sit Deus tuus, sicut locutus est tibi et sicut iuravit patribus tuis, Abraham, Isaac et Iacob."
,"13":"Nec vobis solis ego hoc foedus ferio et haec iuramenta confirmo,"
,"14":"sed cunctis hic nobiscum hodie praesentibus coram Domino Deo nostro et illis, qui hodie hic nobiscum non adsunt."
,"15":"Vos enim nostis quomodo habitaverimus in terra Aegypti et quomodo transierimus per medium nationum, quas transeuntes"
,"16":"vidistis abominationes et idola eorum, lignum et lapidem, argentum et aurum, quae colebant."
,"17":"Ne forte sit inter vos vir aut mulier, familia aut tribus, cuius cor aversum est hodie a Domino Deo nostro, ut vadat et serviat diis illarum gentium, et sit inter vos radix germinans fel et absinthium;"
,"18":"cumque audierit verba iuramenti huius, benedicat sibi in corde suo dicens: 'Pax erit mihi, etsi ambulabo in pravitate cordis mei', et absumat terram irriguam et sitientem."
,"19":"Dominus non ignoscet ei, sed tunc quam maxime furor eius fumabit et zelus contra hominem illum, et sedebunt super eum omnia maledicta, quae scripta sunt in hoc volumine, et delebit Dominus nomen eius sub caelo"
,"20":"et consumet eum in perditionem ex omnibus tribubus Israel, iuxta maledictiones foederis, quae in hoc libro legis scriptae sunt."
,"21":"Dicetque sequens generatio, filii vestri, qui nascentur deinceps, et peregrini, qui de longe venerint, videntes plagas terrae illius et infirmitates, quibus eam afflixerit Dominus,"
,"22":"sulphur et salem: combusta est omnis humus eius, ita ut ultra non seratur, nec virens quippiam germinet in exemplum subversionis Sodomae et Gomorrae, Adamae et Seboim, quas subvertit Dominus in ira et furore suo."
,"23":"Et dicent omnes gentes: 'Quare sic fecit Dominus terrae huic? Quae est haec ira furoris immensa?'."
,"24":"Et respondebunt: 'Quia dereliquerunt pactum Domini, Dei patrum suorum, quod pepigit cum eis, quando eduxit eos de terra Aegypti,"
,"25":"et servierunt diis alienis et adoraverunt eos, quos nesciebant et quibus non fuerant attributi;"
,"26":"idcirco iratus est furor Domini contra terram istam, ut induceret super eam omnia maledicta, quae in hoc volumine scripta sunt,"
,"27":"et eiecit eos de terra eorum in ira et furore et indignatione maxima proiecitque in terram alienam, sicut hodie comprobatur'."
,"28":"Abscondita Domino Deo nostro, manifesta autem nobis et filiis nostris usque in sempiternum, ut faciamus universa verba legis huius."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Cum ergo venerint super te omnes sermones isti, benedic tio et maledictio, quas proposui in conspectu tuo, et ductus paenitudine cordis tui in universis gentibus, in quas disperserit te Dominus Deus tuus,"
,"2":"et reversus fueris ad eum et oboedieris eius imperiis secundum omnia, quae ego hodie praecipio tibi, cum filiis tuis in toto corde tuo et in tota anima tua,"
,"3":"reducet Dominus Deus tuus captivitatem tuam ac miserebitur tui et rursum congregabit te de cunctis populis, in quos te ante dispersit."
,"4":"Si ad cardines caeli fueris dissipatus, inde te retrahet Dominus Deus tuus et assumet"
,"5":"atque introducet in terram, quam possederunt patres tui, et obtinebis eam; et feliciorem et maioris numeri esse te faciet quam fuerunt patres tui."
,"6":"Circumcidet Dominus Deus tuus cor tuum et cor seminis tui, ut diligas Dominum Deum tuum in toto corde tuo et in tota anima tua, ut possis vivere."
,"7":"Omnes autem maledictiones has convertet super inimicos tuos et eos, qui oderunt te et persequuntur."
,"8":"Tu autem reverteris et audies vocem Domini faciesque universa mandata, quae ego praecipio tibi hodie;"
,"9":"et abundare te faciet Dominus Deus tuus in cunctis operibus manuum tuarum, in subole uteri tui et in fructu iumentorum tuorum et in ubertate terrae tuae, in rerum omnium largitate; revertetur enim Dominus, ut gaudeat super te in omnibus bonis, sicut gavisus est in patribus tuis."
,"10":"Si tamen audieris vocem Domini Dei tui et custodieris mandata eius et praecepta, quae in hac lege conscripta sunt, et revertaris ad Dominum Deum tuum in toto corde tuo et in tota anima tua."
,"11":"Mandatum hoc, quod ego praecipio tibi hodie, non supra te est neque procul positum"
,"12":"nec in caelo situm, ut possis dicere: 'Quis nobis ad caelum valet ascendere, ut deferat illud ad nos, et audiamus atque opere compleamus?'."
,"13":"Neque trans mare positum, ut causeris et dicas: 'Quis nobis transfretare poterit mare et illud ad nos usque deferre, ut possimus audire et facere quod praeceptum est?'."
,"14":"Sed iuxta te est sermo valde in ore tuo et in corde tuo, ut facias illum."
,"15":"Considera quod hodie proposuerim in conspectu tuo vitam et bonum, et e contrario mortem et malum."
,"16":"Si oboedieris mandatis Domini Dei tui, quae ego praecipio tibi hodie, ut diligas Dominum Deum tuum et ambules in viis eius et custodias mandata illius et praecepta atque iudicia, vives; ac multiplicabit te benedicetque tibi in terra, ad quam ingredieris possidendam."
,"17":"Sin autem aversum fuerit cor tuum, et audire nolueris atque errore deceptus adoraveris deos alienos et servieris eis,"
,"18":"praedico vobis hodie quod pereatis et parvo tempore moremini in terra, ad quam, Iordane transmisso, ingredieris possidendam."
,"19":"Testes invoco hodie contra vos caelum et terram quod proposuerim vobis vitam et mortem, benedictionem et maledictionem. Elige ergo vitam, ut et tu vivas et semen tuum"
,"20":"et diligas Dominum Deum tuum atque oboedias voci eius et illi adhaereas - ipse est enim vita tua et longitudo dierum tuorum - ut habites in terra, pro qua iuravit Dominus patribus tuis, Abraham, Isaac et Iacob, ut daret eam illis '."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Abiit itaque Moyses et locu tus est omnia verba haec ad universum Israel"
,"2":"et dixit ad eos: ' Centum viginti annorum sum hodie, non possum ultra egredi et ingredi, praesertim cum et Dominus dixerit mihi: 'Non transibis Iordanem istum'."
,"3":"Dominus Deus tuus ipse transibit ante te; ipse delebit gentes has in conspectu tuo, et possidebis eas, et Iosue transibit ante te, sicut locutus est Dominus."
,"4":"Facietque Dominus eis, sicut fecit Sehon et Og regibus Amorraeorum et terrae eorum delevitque eos."
,"5":"Cum ergo et hos tradiderit vobis, similiter facietis eis, sicut praecepi vobis."
,"6":"Viriliter agite et confortamini; nolite timere nec paveatis a conspectu eorum, quia Dominus Deus tuus ipse est ductor tuus et non dimittet nec derelinquet te '."
,"7":"Vocavitque Moyses Iosue et dixit ei coram omni Israel: ' Confortare et esto robustus; tu enim introduces populum istum in terram, quam daturum se patribus eorum iuravit Dominus, et tu eam sorte divides eis."
,"8":"Et Dominus, qui ductor tuus est, ipse erit tecum, non dimittet nec derelinquet te; noli timere nec paveas '."
,"9":"Et scripsit Moyses legem hanc et tradidit eam sacerdotibus filiis Levi, qui portabant arcam foederis Domini, et cunctis senioribus Israel;"
,"10":"praecepitque eis dicens: ' Post septem annos, anno remissionis, in sollemnitate Tabernaculorum,"
,"11":"convenientibus cunctis ex Israel, ut appareant in conspectu Domini Dei tui in loco, quem elegerit, leges verba legis huius coram omni Israel, audientibus eis;"
,"12":"congrega populum tam viros quam mulieres, parvulos et advenas, qui sunt intra portas tuas, ut audientes discant et timeant Dominum Deum vestrum et custodiant impleantque omnes sermones legis huius;"
,"13":"filii quoque eorum, qui nunc ignorant, audiant et discant timere Dominum Deum vestrum cunctis diebus, quibus versamini in terra, ad quam vos, Iordane transmisso, pergitis obtinendam '."
,"14":"Et ait Dominus ad Moysen: ' Ecce prope sunt dies mortis tuae; voca Iosue, et state in tabernaculo conventus, ut praecipiam ei '. Abierunt ergo Moyses et Iosue et steterunt in tabernaculo conventus;"
,"15":"apparuitque Dominus ibi in columna nubis, quae stetit in introitu tabernaculi."
,"16":"Dixitque Dominus ad Moysen: ' Ecce tu dormies cum patribus tuis, et populus iste consurgens fornicabitur post deos alienos terrae, ad quam ingredietur; ibi derelinquet me et irritum faciet foedus, quod pepigi cum eo."
,"17":"Et irascetur furor meus contra eum in die illo, et derelinquam eos et abscondam faciem meam ab eis, et erit in devorationem; invenient eum mala multa et afflictiones, ita ut dicat in illo die: 'Vere, quia non est Deus mecum, invenerunt me haec mala'."
,"18":"Ego autem abscondam et celabo faciem meam in die illo, propter omnia mala, quae fecit, quia secutus est deos alienos."
,"19":"Nunc itaque scribite vobis canticum istud, et doce filios Israel, ut memoriter teneant et ore decantent, ut sit mihi carmen istud pro testimonio inter filios Israel."
,"20":"Introducam enim eum in terram, pro qua iuravi patribus eius, lacte et melle manantem. Cumque comederit et saturatus crassusque fuerit, avertetur ad deos alienos, et servient eis detrahentque mihi et irritum facient pactum meum."
,"21":"Postquam invenerint eum mala multa et afflictiones, respondebit ei canticum istud pro testimonio, quod nulla delebit oblivio ex ore seminis sui; scio enim cogitationes eius, quae facit hodie, antequam introducam eum in terram, quam ei pollicitus sum '."
,"22":"Scripsit ergo Moyses canticum istud in die illo et docuit filios Israel."
,"23":"Praecepitque Dominus Iosue filio Nun et ait: ' Confortare et esto robustus; tu enim introduces filios Israel in terram, quam eis pollicitus sum, et ego ero tecum '."
,"24":"Postquam ergo scripsit Moyses verba legis huius in volumine atque complevit,"
,"25":"praecepit Levitis, qui portabant arcam foederis Domini, dicens:"
,"26":"' Tollite librum legis istum et ponite eum in latere arcae foederis Domini Dei vestri, ut sit ibi contra te in testimonium."
,"27":"Ego enim scio contentionem tuam et cervicem tuam durissimam. Adhuc vivente me vobiscum, semper contentiose egistis contra Dominum; quanto magis cum mortuus fuero?"
,"28":"Congregate ad me omnes maiores natu per tribus vestras atque praefectos vestros, et loquar audientibus eis sermones istos et invocabo contra eos caelum et terram."
,"29":"Novi enim quod post mortem meam inique agetis et declinabitis de via, quam praecepi vobis, et occurrent vobis mala in extremo tempore, quando feceritis malum in conspectu Domini, ut irritetis eum per opera manuum vestrarum '."
,"30":"Locutus est ergo Moyses, audiente universo coetu Israel, verba carminis huius et ad finem usque complevit:"
}`)
	CurrentBook.AddChapter(32, `{
"1":"' Audite, caeli, quae loquor; audiat terra verba oris mei!"
,"2":"Stillet ut pluvia doctrina mea, fluat ut ros eloquium meum,quasi imber super herbam,et quasi stillae super gramina."
,"3":"Quia nomen Domini invocabo: date magnificentiam Deo nostro!"
,"4":"Petra, perfecta sunt opera eius, quia omnes viae eius iustitia. Deus fidelis et absque ulla iniquitate, iustus et rectus."
,"5":"Peccaverunt ei non filii eius in sordibus suis, generatio prava atque perversa."
,"6":"Haeccine redditis Domino, popule stulte et insipiens?,Numquid non ipse est pater tuus, qui possedit te, ipse fecit et stabilivit te?"
,"7":"Memento dierum antiquorum, cogita generationes singulas; interroga patrem tuum, et annuntiabit tibi, maiores tuos, et dicent tibi."
,"8":"Quando dividebat Altissimus gentes, quando separabat filios Adam, constituit terminos populorum,iuxta numerum filiorum Israel;"
,"9":"pars autem Domini populus eius, Iacob funiculus hereditatis eius."
,"10":"Invenit eum in terra deserta, in loco horroris et ululatu solitudinis; circumdedit eum et attendit,et custodivit quasi pupillam oculi sui."
,"11":"Sicut aquila provocans ad volandum pullos suos,et super eos volitans expandit alas suas,et assumpsit eum,atque portavit super pennas suas."
,"12":"Dominus solus dux eius fuit, et non erat cum eo deus alienus."
,"13":"Constituit eum super excelsam terram, ut comederet fructus agrorum, ut sugeret mel de petra,oleumque de saxo durissimo,"
,"14":"butyrum de armento et lac de ovibus, cum adipe agnorum et arietum,filiorum Basan et hircorum, cum medulla tritici, et sanguinem uvae biberet meracissimum."
,"15":"Incrassatus est dilectus et recalcitravit; incrassatus, impinguatus, dilatatus dereliquit Deum factorem suum,et recessit a Petra salutari suo."
,"16":"Provocaverunt eum in diis alienis,et in abominationibus ad iracundiam concitaverunt."
,"17":"Immolaverunt daemonibus et non Deo, diis, quos ignorabant; novi recentesque venerunt, quos non coluerunt patres vestri."
,"18":"Petram, quae te genuit, dereliquisti, et oblitus es Domini creatoris tui."
,"19":"Vidit Dominus et sprevit, quia provocaverunt eum filii sui et filiae."
,"20":"Et ait: 'Abscondam faciem meam ab eis,et considerabo novissima eorum; generatio enim perversa est, et infideles filii."
,"21":"Ipsi me provocaverunt in eo, qui non erat Deus, et irritaverunt in vanitatibus suis; et ego provocabo eos in eo, qui non est populus, et in gente stulta irritabo illos."
,"22":"Ignis succensus est in furore meo,et ardebit usque ad inferni profundissima; devorabitque terram cum germine suo,et montium fundamenta comburet. "
,"23":"Congregabo super eos mala,et sagittas meas complebo in eis."
,"24":"Consumentur fame et devorabuntur febri,et peste amarissima; dentes bestiarum immittam in eos, cum veneno serpentium in pulvere. "
,"25":"Foris vastabit eos gladius, et intus pavor: iuvenem simul ac virginem, lactantem cum homine sene."
,"26":"Dixi: Disperdam eos, cessare faciam ex hominibus memoriam eorum!,"
,"27":"sed arrogantiam inimicorum timui, ne superbirent hostes eorum,et dicerent: >Manus nostra excelsa, et non Dominus fecit haec omnia!'. "
,"28":"Gens enim absque consilio est,et sine prudentia."
,"29":"Utinam saperent et intellegerent haec,ac novissima sua providerent!"
,"30":"Quomodo persequatur unus mille, et duo fugent decem milia?,Nonne ideo, quia Petra eorum vendidit eos, et Dominus tradidit illos?'."
,"31":"Non enim est petra eorum ut Petra nostra, et inimici nostri sunt iudices."
,"32":"Vere de vinea Sodomorum vinea eorum,et de suburbanis Gomorrae; uva eorum uva fellis,et botri amarissimi;"
,"33":"fel draconum vinum eorum,et venenum aspidum insanabile."
,"34":"Nonne haec condita sunt apud me,et signata in thesauris meis?"
,"35":"Mea est ultio, et ego retribuam in tempore, in quo labetur pes eorum!,Iuxta est dies perditionis, et adesse festinat sors eorum."
,"36":"Iudicabit Dominus populum suum,et in servis suis miserebitur; videbit quod infirmata sit manus, et defecerint clausi ac liberati."
,"37":"Et dicet: 'Ubi sunt dii eorum, petra, in qua habebant fiduciam,"
,"38":"de quorum victimis comedebant adipes,et bibebant vinum libaminum?,Surgant et opitulentur vobis,et in necessitate vos protegant!"
,"39":"Videte nunc quod ego sim solus, et non sit Deus praeter me. Ego occidam et ego vivere faciam; percutiam et ego sanabo; et non est qui de manu mea possit eruere."
,"40":"Levabo ad caelum manum meam,et dicam: Vivo ego in aeternum!"
,"41":"Si acuero ut fulgur gladium meum, et arripuerit iudicium manus mea, reddam ultionem hostibus meis,et his, qui oderunt me, retribuam."
,"42":"Inebriabo sagittas meas sanguine, et gladius meus devorabit carnes: de cruore occisorum et captivorum, de capite ducum inimici!'."
,"43":"Laudate, gentes, populum eius, quia sanguinem servorum suorum ulciscetur,et vindictam retribuet in hostes suos,et propitius erit terrae populi sui '."
,"44":"Venit ergo Moyses et locutus est omnia verba cantici huius in auribus populi, ipse et Iosue filius Nun;"
,"45":"complevitque omnes sermones istos loquens ad universum Israel."
,"46":"Et dixit ad eos: ' Ponite corda vestra in omnia verba, quae ego testificor vobis hodie, ut mandetis ea filiis vestris custodire et facere et implere universa verba legis huius;"
,"47":"quia verbum non incassum vobis, sed est vita vestra: et in verbo hoc longo perseverabitis tempore in terra, ad quam, Iordane transmisso, ingredimini possidendam '."
,"48":"Locutusque est Dominus ad Moysen in eadem die dicens:"
,"49":"' Ascende in montem istum Abarim, in montem Nabo, qui est in terra Moab contra Iericho, et vide terram Chanaan, quam ego tradam filiis Israel obtinendam."
,"50":"Et morere in monte, quem conscendens iungeris populo tuo, sicut mortuus est Aaron frater tuus in monte Hor et appositus populo suo."
,"51":"Quia praevaricati estis contra me in medio filiorum Israel ad aquas Meribathcades deserti Sin, quia non sanctificastis me inter filios Israel."
,"52":"E contra videbis terram et non ingredieris in eam, quam ego dabo filiis Israel '."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Haec est benedictio, qua be nedixit Moyses homo Dei fi liis Israel ante mortem suam."
,"2":"Et ait: ' Dominus de Sinai venit,et de Seir ortus est eis; apparuit de monte Pharan,et venit in Meribathcades,de meridie eius in Asedoth."
,"3":"Vere diligit populos; omnes sancti eius in manu illius sunt; et, qui appropinquant pedibus tuis, accipient de doctrina tua."
,"4":"Legem praecepit nobis Moyses, hereditatem multitudinis Iacob."
,"5":"Et factus est apud dilectum rex, congregatis principibus populi,cum tribubus Israel '."
,"6":"' Vivat Ruben et non moriatur,et sit parvus in numero '."
,"7":"Haec est Iudae benedictio: ' Audi, Domine, vocem Iudae,et ad populum suum introduc eum. Manus eius pugnabunt pro eo, et adiutor illius contra adversarios eius eris '."
,"8":"De Levi quoque ait: ' Tummim et Urim tui,viro sancto tuo, quem probasti in Massa,et cum quo litigasti ad aquas Meriba."
,"9":"Qui dixit de patre suo et matre sua: 'Nescio vos'; et fratres suos ignoravit,et filios suos nescivit. Quia custodierunt eloquium tuum,et pactum tuum servaverunt."
,"10":"Docebunt iudicia tua Iacob,et legem tuam Israel; ponent thymiama in naribus tuis,et holocaustum super altare tuum."
,"11":"Benedic, Domine, fortitudini eius,et opera manuum illius suscipe. Percute lumbos inimicorum eius; et, qui oderunt eum, non consurgant '."
,"12":"De Beniamin ait: ' Amantissimus Domini,habitabit confidenter in eo; Altissimus proteget eum tota die,et inter umeros illius requiescet '."
,"13":"De Ioseph quoque ait: ' Benedicta a Domino terra eius: donis caeli, rore,atque abysso subiacente,"
,"14":"fructibus solis,et donis mensium,"
,"15":"primitiis antiquorum montium,et donis collium aeternorum,"
,"16":"frugibus terrae et plenitudine eius. Benedictio illius, qui apparuit in rubo, veniat super caput Ioseph,et super verticem nazaraei inter fratres suos;"
,"17":"quasi primogeniti tauri pulchritudo eius, cornua unicornis cornua illius, in ipsis ventilabit gentes,usque ad terminos terrae. Hae sunt multitudines Ephraim, et hae milia Manasse '."
,"18":"De Zabulon ait: ' Laetare, Zabulon, in exitu tuo, et Issachar, in tabernaculis tuis!"
,"19":"Populos ad montem vocabunt, ibi immolabunt victimas iustitiae. Qui inundationem maris, quasi lac, sugent,et thesauros absconditos arenarum '."
,"20":"De Gad ait: ' Benedictus, qui dilatat Gad!,Quasi leo requiescit,dilaceratque brachium et verticem."
,"21":"Et vidit primitias sibi, quia ibi pars ducis erat reposita; qui fuit cum principibus populi,et fecit iustitiam Domini,et iudicia sua cum Israel '."
,"22":"De Dan quoque ait: ' Dan catulus leonis,prosiliet largiter de Basan '."
,"23":"De Nephthali dixit: ' Nephthali satiabatur beneplacito,et plenus erit benedictione Domini: mare et meridiem possidebit '."
,"24":"De Aser quoque ait: ' Benedictus prae filiis Aser!,Sit placens fratribus suis,et tingat in oleo pedem suum."
,"25":"Ferrum et aes serae tuae, sicut dies tui robur tuum '."
,"26":"' Non est ut Deus Iesurun, qui ascendit super caelos ad auxilium tuum,et in magnificentia sua super nubes."
,"27":"Habitaculum Deus antiquus, et subter brachia sempiterna. Eiciet a facie tua inimicum,dicetque: 'Conterere!'."
,"28":"Habitabit Israel confidenter, et fons Iacob solus; stillabunt in terra frumenti et vini, caelique rorem."
,"29":"Beatus tu, Israel! Quis similis tui, popule, qui salvaris in Domino?,Ipse est scutum auxilii tui,et gladius gloriae tuae. Blandientur tibi inimici tui, et tu eorum altitudines calcabis '."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Ascendit ergo Moyses de campestribus Moab super montem Nabo in verticem Phasga contra Iericho; ostenditque ei Dominus omnem terram Galaad usque Dan"
,"2":"et universum Nephthali terramque Ephraim et Manasse et omnem terram Iudae usque ad mare occidentale"
,"3":"et Nageb et latitudinem campi Iericho civitatis palmarum usque Segor."
,"4":"Dixitque Dominus ad eum: ' Haec est terra, pro qua iuravi Abraham, Isaac et Iacob, dicens: Semini tuo dabo eam. Vidisti eam oculis tuis et non transibis ad illam '."
,"5":"Mortuusque est ibi Moyses servus Domini in terra Moab, iubente Domino."
,"6":"Et sepelivit eum in valle in terra Moab contra Bethphegor; et non cognovit homo sepulcrum eius usque in praesentem diem."
,"7":"Moyses centum et viginti annorum erat, quando mortuus est; non caligavit oculus eius, nec robur illius defecit."
,"8":"Fleveruntque eum filii Israel in campestribus Moab triginta diebus; et completi sunt dies planctus lugentium Moysen."
,"9":"Iosue vero filius Nun repletus est spiritu sapientiae, quia Moyses posuit super eum manus suas; et oboedierunt ei filii Israel feceruntque, sicut praecepit Dominus Moysi."
,"10":"Et non surrexit ultra propheta in Israel sicut Moyses, quem nosset Dominus facie ad faciem,"
,"11":"in omnibus signis atque portentis, quae misit per eum, ut faceret in terra Aegypti pharaoni et omnibus servis eius universaeque terrae illius,"
,"12":"et in cuncta manu robusta magnisque mirabilibus, quae fecit Moyses coram universo Israel."
}`)

}
func LA_NVBSE_LoadVPEXChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Haec sunt nomina filiorum Is rael, qui ingressi sunt Aegyp tum cum Iacob; singuli cum domibus suis introierunt:"
,"2":"Ruben, Simeon, Levi, Iuda,"
,"3":"Issachar, Zabulon et Beniamin,"
,"4":"Dan et Nephthali, Gad et Aser."
,"5":"Erant igitur omnes animae eorum, qui egressi sunt de femore Iacob, septuaginta; Ioseph autem in Aegypto erat."
,"6":"Quo mortuo et universis fratribus eius omnique cognatione illa,"
,"7":"filii Israel creverunt et pullulantes multiplicati sunt ac roborati nimis impleverunt terram."
,"8":"Surrexit interea rex novus super Aegyptum, qui ignorabat Ioseph;"
,"9":"et ait ad populum suum: ' Ecce, populus filiorum Israel multus et fortior nobis est;"
,"10":"venite, prudenter agamus cum eo, ne forte multiplicetur et, si ingruerit contra nos bellum, addatur inimicis nostris, expugnatisque nobis, egrediatur de terra '."
,"11":"Praeposuit itaque eis magistros operum, ut affligerent eos oneribus; aedificaveruntque urbes promptuarias pharaoni, Phithom et Ramesses."
,"12":"Quantoque opprimebant eos, tanto magis multiplicabantur et crescebant."
,"13":"Formidaveruntque filios Israel Aegyptii et in servitutem redegerunt eos"
,"14":"atque ad amaritudinem perducebant vitam eorum operibus duris luti et lateris omnique famulatu, quo in terrae operibus premebantur."
,"15":"Dixit autem rex Aegypti obstetricibus Hebraeorum, quarum una vocabatur Sephra, altera Phua,"
,"16":"praecipiens eis: ' Quando obstetricabitis Hebraeas, et partus tempus advenerit, si masculus fuerit, interficite eum; si femina, reservate '."
,"17":"Timuerunt autem obstetrices Deum et non fecerunt iuxta praeceptum regis Aegypti, sed conservabant mares."
,"18":"Quibus ad se accersitis rex ait: ' Quidnam est hoc, quod facere voluistis, ut pueros servaretis? '."
,"19":"Quae responderunt: ' Non sunt Hebraeae sicut Aegyptiae mulieres; ipsae enim robustae sunt et, priusquam veniamus ad eas, pariunt '."
,"20":"Bene ergo fecit Deus obstetricibus, et crevit populus confortatusque est nimis;"
,"21":"et, quia timuerunt obstetrices Deum, aedificavit illis domos."
,"22":"Praecepit ergo pharao omni populo suo dicens: ' Quidquid masculini sexus natum fuerit, in flumen proicite; quidquid feminei, reservate '."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Egressus est vir de domo Levi et accepit uxorem stirpis suae;"
,"2":"quae concepit et peperit filium et videns eum elegantem abscondit tribus mensibus."
,"3":"Cumque iam celare non posset, sumpsit fiscellam scirpeam et linivit eam bitumine ac pice; posuitque intus infantulum et exposuit eum in carecto ripae fluminis,"
,"4":"stante procul sorore eius et considerante eventum rei."
,"5":"Ecce autem descendebat filia pharaonis, ut lavaretur in flumine, et puellae eius gradiebantur per crepidinem alvei. Quae cum vidisset fiscellam in papyrione, misit unam e famulabus suis; et allatam"
,"6":"aperiens cernensque in ea parvulum vagientem, miserta eius ait: ' De infantibus Hebraeorum est hic '."
,"7":"Cui soror pueri: ' Vis, inquit, ut vadam et vocem tibi mulierem Hebraeam, quae nutrire possit tibi infantulum? '."
,"8":"Respondit: ' Vade '. Perrexit puella et vocavit matrem infantis."
,"9":"Ad quam locuta filia pharaonis: ' Accipe, ait, puerum istum et nutri mihi; ego dabo tibi mercedem tuam '. Suscepit mulier et nutrivit puerum adultumque tradidit filiae pharaonis."
,"10":"Quem illa adoptavit in locum filii vocavitque nomen eius Moysen dicens: ' Quia de aqua tuli eum '."
,"11":"In diebus illis, postquam creverat, Moyses egressus est ad fratres suos; viditque afflictionem eorum et virum Aegyptium percutientem quendam de Hebraeis fratribus suis."
,"12":"Cumque circumspexisset huc atque illuc et nullum adesse vidisset, percussum Aegyptium abscondit sabulo."
,"13":"Et egressus die altero conspexit duos Hebraeos rixantes dixitque ei, qui faciebat iniuriam: ' Quare percutis proximum tuum? '."
,"14":"Qui respondit: ' Quis te constituit principem et iudicem super nos? Num occidere me tu vis, sicut occidisti Aegyptium? '. Timuit Moyses et ait: ' Quomodo palam factum est verbum istud? '."
,"15":"Audivitque pharao sermonem hunc et quaerebat occidere Moysen. Qui fugiens de conspectu eius moratus est in terra Madian; venit ergo in terram Madian et sedit iuxta puteum."
,"16":"Erant autem sacerdoti Madian septem filiae, quae venerunt ad hauriendam aquam; et impletis canalibus adaquare cupiebant greges patris sui."
,"17":"Supervenere pastores et eiecerunt eas: surrexitque Moyses et, defensis puellis, adaquavit oves earum."
,"18":"Quae cum revertissent ad Raguel patrem suum, dixit ad eas: ' Cur velocius venistis solito? '."
,"19":"Responderunt: ' Vir Aegyptius liberavit nos de manu pastorum; insuper et hausit aquam nobis potumque dedit ovibus '."
,"20":"At ille: ' Ubi est? ', inquit. ' Quare dimisistis hominem? Vocate eum, ut comedat panem '."
,"21":"Consensit ergo Moyses habitare cum eo accepitque Sephoram filiam eius uxorem."
,"22":"Quae peperit ei filium, quem vocavit Gersam dicens: ' Advena sum in terra aliena '."
,"23":"Post multum vero temporis mortuus est rex Aegypti; et ingemiscentes filii Israel propter opera vociferati sunt, ascenditque clamor eorum ad Deum ab operibus."
,"24":"Et audivit gemitum eorum ac recordatus est foederis, quod pepigit cum Abraham, Isaac et Iacob;"
,"25":"et respexit Dominus filios Israel et apparuit eis."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Moyses autem pascebat oves Iethro soceri sui sacerdotis Ma dian; cumque minasset gregem ultra desertum, venit ad montem Dei Horeb."
,"2":"Apparuitque ei angelus Domini in flamma ignis de medio rubi; et videbat quod rubus arderet et non combureretur."
,"3":"Dixit ergo Moyses: ' Vadam et videbo visionem hanc magnam, quare non comburatur rubus '."
,"4":"Cernens autem Dominus quod pergeret ad videndum, vocavit eum Deus de medio rubi et ait: ' Moyses, Moyses '. Qui respondit: ' Adsum '."
,"5":"At ille: ' Ne appropies, inquit, huc; solve calceamentum de pedibus tuis; locus enim, in quo stas, terra sancta est '."
,"6":"Et ait: ' Ego sum Deus patris tui, Deus Abraham, Deus Isaac et Deus Iacob '. Abscondit Moyses faciem suam; non enim audebat aspicere contra Deum."
,"7":"Cui ait Dominus: ' Vidi afflictionem populi mei in Aegypto et clamorem eius audivi propter duritiam exactorum eorum."
,"8":"Et sciens dolorem eius descendi, ut liberem eum de manibus Aegyptiorum et educam de terra illa in terram bonam et spatiosam, in terram, quae fluit lacte et melle, ad loca Chananaei et Hetthaei et Amorraei et Pherezaei et Hevaei et Iebusaei."
,"9":"Clamor ergo filiorum Israel venit ad me, vidique afflictionem eorum, qua ab Aegyptiis opprimuntur;"
,"10":"sed veni, mittam te ad pharaonem, ut educas populum meum, filios Israel, de Aegypto '."
,"11":"Dixitque Moyses ad Deum: ' Quis sum ego, ut vadam ad pharaonem et educam filios Israel de Aegypto? '."
,"12":"Qui dixit ei: ' Ego ero tecum; et hoc habebis signum quod miserim te: cum eduxeris populum de Aegypto, servietis Deo super montem istum '."
,"13":"Ait Moyses ad Deum: ' Ecce, ego vadam ad filios Israel et dicam eis: Deus patrum vestrorum misit me ad vos. Si dixerint mihi: 'Quod est nomen eius?' quid dicam eis? '."
,"14":"Dixit Deus ad Moysen: ' Ego sum qui sum '. Ait: ' Sic dices filiis Israel: Qui sum misit me ad vos '."
,"15":"Dixitque iterum Deus ad Moysen: ' Haec dices filiis Israel: Dominus, Deus patrum vestrorum, Deus Abraham, Deus Isaac et Deus lacob, misit me ad vos; hoc nomen mihi est in aeternum, et hoc memoriale meum in generationem et generationem."
,"16":"Vade et congrega seniores Israel et dices ad eos: Dominus, Deus patrum vestrorum, apparuit mihi, Deus Abraham, Deus Isaac et Deus Iacob, dicens: Visitans visitavi vos et vidi omnia, quae acciderunt vobis in Aegypto;"
,"17":"et dixi: Educam vos de afflictione Aegypti in terram Chananaei et Hetthaei et Amorraei et Pherezaei et Hevaei et Iebusaei, ad terram fluentem lacte et melle."
,"18":"Et audient vocem tuam; ingredierisque tu et seniores Israel ad regem Aegypti, et dicetis ad eum: Dominus, Deus Hebraeorum, occurrit nobis; et nunc eamus viam trium dierum in solitudinem, ut immolemus Domino Deo nostro."
,"19":"Sed ego scio quod non dimittet vos rex Aegypti, ut eatis, nisi per manum validam."
,"20":"Extendam enim manum meam et percutiam Aegyptum in cunctis mirabilibus meis, quae facturus sum in medio eius; post haec dimittet vos."
,"21":"Daboque gratiam populo huic coram Aegyptiis, et, cum egrediemini, non exibitis vacui."
,"22":"Sed postulabit mulier a vicina sua et ab hospita sua vasa argentea et aurea ac vestes; ponetisque eas super filios et filias vestras et spoliabitis Aegyptum '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Respondens Moyses ait: ' Quid autem, si non credent mihi ne que audient vocem meam, sed dicent: 'Non apparuit tibi Dominus?' '."
,"2":"Dixit ergo ad eum: ' Quid est quod tenes in manu tua? '. Respondit: ' Virga '."
,"3":"Dixitque Dominus: ' Proice eam in terram! '. Proiecit, et versa est in serpentem, ita ut fugeret Moyses."
,"4":"Dixitque Dominus: ' Extende manum tuam et apprehende caudam eius! '. Extendit et tenuit, versaque est in virgam."
,"5":"' Ut credant, inquit, quod apparuerit tibi Dominus, Deus patrum suorum, Deus Abraham, Deus Isaac et Deus Iacob '."
,"6":"Dixitque Dominus rursum: ' Mitte manum tuam in sinum tuum! '. Quam cum misisset in sinum, protulit leprosam instar nivis."
,"7":"' Retrahe, ait, manum tuam in sinum tuum! '. Retraxit et protulit iterum, et erat similis carni reliquae."
,"8":"' Si non crediderint, inquit, tibi, neque audierint sermonem signi prioris, credent verbo signi sequentis."
,"9":"Quod si nec duobus quidem his signis crediderint neque audierint vocem tuam, sume aquam fluminis et effunde eam super aridam, et, quidquid hauseris de fluvio, vertetur in sanguinem '."
,"10":"Ait Moyses: ' Obsecro, Domine, non sum eloquens ab heri et nudiustertius et ex quo locutus es ad servum tuum, nam impeditioris et tardioris linguae sum '."
,"11":"Dixit Dominus ad eum: ' Quis fecit os hominis? Aut quis fabricatus est mutum vel surdum vel videntem vel caecum? Nonne ego?"
,"12":"Perge igitur, et ego ero in ore tuo; doceboque te quid loquaris '."
,"13":"At ille: ' Obsecro, inquit, Domine, mitte quem missurus es '."
,"14":"Iratus Dominus in Moysen ait: ' Aaron, frater tuus Levites, scio quod eloquens sit; ecce ipse egreditur in occursum tuum vidensque te laetabitur corde."
,"15":"Loquere ad eum et pone verba mea in ore eius; et ego ero in ore tuo et in ore illius et ostendam vobis quid agere debeatis."
,"16":"Ipse loquetur pro te ad populum et erit os tuum; tu autem eris ei ut Deus."
,"17":"Virgam quoque hanc sume in manu tua, in qua facturus es signa '."
,"18":"Abiit Moyses et reversus est ad Iethro socerum suum dixitque ei: ' Vadam, quaeso, et revertar ad fratres meos in Aegyptum, ut videam, si adhuc vivant '. Cui ait Iethro: ' Vade in pace '."
,"19":"Dixit ergo Dominus ad Moysen in Madian: ' Vade, revertere in Aegyptum; mortui sunt enim omnes, qui quaerebant animam tuam '."
,"20":"Tulit Moyses uxorem suam et filios suos et imposuit eos super asinum; reversusque est in Aegyptum portans virgam Dei in manu sua."
,"21":"Dixitque ei Dominus revertenti in Aegyptum: ' Vide, ut omnia ostenta, quae posui in manu tua, facias coram pharaone; ego indurabo cor eius, et non dimittet populum."
,"22":"Dicesque ad eum: Haec dicit Dominus: Filius meus primogenitus Israel."
,"23":"Dico tibi: Dimitte filium meum, ut serviat mihi; si autem non vis dimittere eum, ecce ego interficiam filium tuum primogenitum '."
,"24":"Cumque esset in itinere, in deversorio, occurrit ei Dominus et volebat occidere eum."
,"25":"Tulit ilico Sephora acutissimam petram et circumcidit praeputium filii sui; tetigitque pedes eius et ait: ' Sponsus sanguinum tu mihi es '."
,"26":"Et dimisit eum, postquam dixerat: ' Sponsus sanguinum ', ob circumcisionem."
,"27":"Dixit autem Dominus ad Aaron: ' Vade in occursum Moysi in desertum '. Qui perrexit obviam ei in montem Dei et osculatus est eum."
,"28":"Narravitque Moyses Aaron omnia verba Domini, quibus miserat eum, et signa, quae mandaverat."
,"29":"Veneruntque simul et congregaverunt cunctos seniores filiorum Israel."
,"30":"Locutusque est Aaron omnia verba, quae dixerat Dominus ad Moysen, et fecit signa coram populo."
,"31":"Et credidit populus, audieruntque quod visitasset Dominus filios Israel et quod respexisset afflictionem eorum; et proni adoraverunt."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Post haec ingressi sunt Moyses et Aaron et dixerunt pharaoni: ' Haec dicit Dominus, Deus Israel: Dimitte populum meum, ut sacrificet mihi in deserto '."
,"2":"At ille responclit: ' Quis est Dominus, ut audiam vocem eius et dimittam Israel? Nescio Dominum et Israel non dimittam '."
,"3":"Dixeruntque: ' Deus Hebraeorum occurrit nobis; eamus, quaeso, viam trium dierum in solitudinem et sacrificemus Domino Deo nostro, ne forte accidat nobis pestis aut gladius '."
,"4":"Ait ad eos rex Aegypti: ' Quare, Moyses et Aaron, sollicitatis populum ab operibus suis? Ite ad onera vestra '."
,"5":"Dixitque pharao: ' Multus nimis iam est populus terrae; videtis quod turba succreverit; quanto magis si dederitis eis requiem ab operibus? '."
,"6":"Praecepit ergo in die illo exactoribus populi et praefectis eius dicens:"
,"7":"' Nequaquam ultra dabitis paleas populo ad conficiendos lateres sicut prius, sed ipsi vadant et colligant stipulas."
,"8":"Et mensuram laterum, quam prius faciebant, imponetis super eos; nec minuetis quidquam. Vacant enim et idcirco vociferantur dicentes: 'Eamus et sacrificemus Deo nostro'."
,"9":"Opprimantur operibus et expleant ea, ut non acquiescant verbis mendacibus '."
,"10":"Igitur egressi exactores populi et praefecti eius dixerunt ad populum: ' Sic dicit pharao: 'Non do vobis paleas."
,"11":"Ite et colligite, sicubi invenire poteritis, nec minuetur quid quam de opere vestro' '."
,"12":"Dispersusque est populus per omnem terram Aegypti ad colligendas paleas."
,"13":"Exactores quoque instabant dicentes: ' Complete opus vestrum cotidie, ut prius facere solebatis, quando dabantur vobis paleae '."
,"14":"Flagellatique sunt praefecti filiorum Israel, quos constituerant super eos exactores pharaonis dicentes: ' Quare non implestis mensuram laterum sicut prius, nec heri nec hodie? '."
,"15":"Veneruntque praefecti filiorum Israel et vociferati sunt ad pharaonem dicentes: ' Cur ita agis contra servos tuos?"
,"16":"Paleae non dantur nobis, et lateres similiter imperantur; en famuli tui flagellis caedimur, et populus tuus est in culpa '."
,"17":"Qui ait: ' Vacatis otio et idcirco dicitis: 'Eamus et sacrificemus Domino'."
,"18":"Ite ergo et operamini; paleae non dabuntur vobis, et reddetis consuetum numerum laterum '."
,"19":"Videbantque se praefecti filiorum Israel in malo, eo quod diceretur eis: ' Non minuetur quidquam de lateribus per singulos dies ';"
,"20":"occurreruntque Moysi et Aaron, qui stabant ex adverso egredientibus a pharaone,"
,"21":"et dixerunt ad eos: ' Videat Dominus et iudicet, quoniam foetere fecistis odorem nostrum coram pharaone et servis eius; et praebuistis ei gladium, ut occideret nos '."
,"22":"Reversusque est Moyses ad Dominum et ait: ' Domine, cur afflixisti populum istum? Quare misisti me?"
,"23":"Ex eo enim quo ingressus sum ad pharaonem, ut loquerer in nomine tuo, afflixit populum tuum; et non liberasti eos '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Dixitque Dominus ad Moysen: ' Nunc videbis quae facturus sim pharaoni; per manum enim fortem dimittet eos et in manu robusta eiciet illos de terra sua '."
,"2":"Locutusque est Dominus ad Moysen dicens: ' Ego Dominus,"
,"3":"qui apparui Abraham, Isaac et Iacob ut Deus omnipotens; et nomen meum Dominum non indicavi eis."
,"4":"Pepigique cum eis foedus, ut darem illis terram Chanaan, terram peregrinationis eorum, in qua fuerunt advenae."
,"5":"Ego audivi gemitum filiorum Israel, quia Aegyptii oppresserunt eos, et recordatus sum pacti mei."
,"6":"Ideo dic filiis Israel: Ego Dominus, qui educam vos de ergastulo Aegyptiorum; et eruam de servitute ac redimam in brachio excelso et iudiciis magnis."
,"7":"Et assumam vos mihi in populum et ero vester Deus; et scietis quod ego sum Dominus Deus vester, qui eduxerim vos de ergastulo Aegyptiorum"
,"8":"et induxerim in terram, super quam levavi manum meam, ut darem eam Abraham, Isaac et Iacob; daboque illam vobis possidendam, ego Dominus '."
,"9":"Narravit ergo Moyses omnia filiis Israel; qui non acquieverunt ei propter angustiam spiritus et opus durissimum."
,"10":"Locutusque est Dominus ad Moysen dicens:"
,"11":"' Ingredere et loquere ad pharaonem regem Aegypti, ut dimittat filios Israel de terra sua '."
,"12":"Respondit Moyses coram Domino: ' Ecce, filii Israel non audiunt me, et quomodo audiet me pharao, praesertim cum incircumcisus sim labiis? '."
,"13":"Locutusque est Dominus ad Moysen et Aaron et dedit mandatum ad filios Israel et ad pharaonem regem Aegypti, ut educerent filios Israel de terra Aegypti."
,"14":"Isti sunt principes domorum per familias suas. Filii Ruben primogeniti Israelis: Henoch et Phallu, Hesron et Charmi; hae cognationes Ruben."
,"15":"Filii Simeon: Iamuel et Iamin et Ahod et Iachin et Sohar er Saul filius Chananitidis; hae progenies Simeon."
,"16":"Et haec nomina filiorum Levi per cognationes suas: Gerson et Caath et Merari; anni autem vitae Levi fuerunt centum triginta septem."
,"17":"Filii Gerson: Lobni et Semei per cognationes suas."
,"18":"Filii Caath: Amram et Isaar et Hebron et Oziel; anni quoque vitae Caath centum triginta tres."
,"19":"Filii Merari: Moholi et Musi; hae cognationes Levi per familias suas."
,"20":"Accepit autem Amram uxorem Iochabed amitam suam, quae peperit ei Aaron et Moysen; fueruntque anni vitae Amram centum triginta septem."
,"21":"Filii quoque Isaar: Core et Napheg et Zechri."
,"22":"Filii quoque Oziel: Misael et Elisaphan et Sethri."
,"23":"Accepit autem Aaron uxorem Elisabeth filiam Aminadab sororem Naasson, quae peperit ei Nadab et Abiu et Eleazar et Ithamar."
,"24":"Filii quoque Core: Asir et Elcana et Abiasaph; hae sunt cognationes Coritarum."
,"25":"At vero Eleazar filius Aaron accepit uxorem de filiabus Phutiel, quae peperit ei Phinees; hi sunt principes familiarum Leviticarum per cognationes suas."
,"26":"Iste est Aaron et Moyses, quibus praecepit Dominus, ut educerent filios Israel de terra Aegypti per turmas suas."
,"27":"Hi sunt qui loquuntur ad pharaonem regem Aegypti, ut educant filios Israel de Aegypto; iste est Moyses et Aaron"
,"28":"in die, qua locutus est Dominus ad Moysen in terra Aegypti."
,"29":"Et locutus est Dominus ad Moysen dicens: ' Ego Dominus; loquere ad pharaonem regem Aegypti omnia, quae ego loquor tibi '."
,"30":"Et ait Moyses coram Domino: ' En incircumcisus labiis sum. Quomodo audiet me pharao? '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Dixitque Dominus ad Moysen: ' Ecce constitui te deum pha raonis, et Aaron frater tuus erit propheta tuus."
,"2":"Tu loqueris omnia, quae mando tibi; et ille loquetur ad pharaonem, ut dimittat filios Israel de terra sua."
,"3":"Sed ego indurabo cor eius et multiplicabo signa et ostenta mea in terra Aegypti."
,"4":"Et non audiet vos; immittamque manum meam super Aegyptum et educam exercitum et populum meum, filios Israel, de terra Aegypti per iudicia maxima."
,"5":"Et scient Aegyptii quia ego sum Dominus, qui extenderim manum meam super Aegyptum et eduxerim filios Israel de medio eorum '."
,"6":"Fecit itaque Moyses et Aaron, sicut praeceperat Dominus; ita egerunt."
,"7":"Erat autem Moyses octoginta annorum, et Aaron octoginta trium, quando locuti sunt ad pharaonem."
,"8":"Dixitque Dominus ad Moysen et Aaron:"
,"9":"' Cum dixerit vobis pharao: 'Ostendite signum', dices ad Aaron: Tolle virgam tuam et proice eam coram pharaone, ac vertetur in colubrum '."
,"10":"Ingressi itaque Moyses et Aaron ad pharaonem fecerunt, sicut praeceperat Dominus; proiecitque Aaron virgam coram pharaone et servis eius, quae versa est in colubrum."
,"11":"Vocavit autem pharao sapientes et maleficos, et fecerunt etiam ipsi magi Aegypti per incantationes suas similiter."
,"12":"Proieceruntque singuli virgas suas, quae versae sunt in colubros; sed devoravit virga Aaron virgas eorum."
,"13":"Induratumque est cor pharaonis, et non audivit eos, sicut dixerat Dominus."
,"14":"Dixit autem Dominus ad Moysen: ' Ingravatum est cor pharaonis: non vult dimittere populum."
,"15":"Vade ad eum mane. Ecce egredietur ad aquas; et stabis in occursum eius super ripam fluminis. Et virgam, quae conversa est in serpentem, tolles in manu tua"
,"16":"dicesque ad eum: Dominus, Deus Hebraeorum, misit me ad te dicens: Dimitte populum meum, ut sacrificet mihi in deserto; et usque ad praesens audire noluisti."
,"17":"Haec igitur dicit Dominus: In hoc scies quod sim Dominus: ecce percutiam virga, quae in manu mea est, aquam fluminis; et vertetur in sanguinem."
,"18":"Pisces quoque, qui sunt in fluvio, morientur, et computrescent aquae, et taedebit Aegyptios bibere aquam fluminis '."
,"19":"Dixit quoque Dominus ad Moysen: ' Dic ad Aaron: Tolle virgam tuam et extende manum tuam super aquas Aegypti, super fluvios eorum et rivos ac paludes et omnes lacus aquarum, ut vertantur in sanguinem; et sit cruor in omni terra Aegypti, tam in ligneis vasis quam in saxeis '."
,"20":"Feceruntque ita Moyses et Aaron, sicut praeceperat Dominus. Et elevans virgam percussit aquam fluminis coram pharaone et servis eius; quae versa est in sanguinem."
,"21":"Et pisces, qui erant in flumine, mortui sunt, computruitque fluvius, et non poterant Aegyptii bibere aquam fluminis; et fuit sanguis in tota terra Aegypti."
,"22":"Feceruntque similiter malefici Aegyptiorum incantationibus suis; et induratum est cor pharaonis, nec audivit eos, sicut dixerat Dominus."
,"23":"Avertitque se et ingressus est domum suam nec ad hoc apposuit cor suum."
,"24":"Foderunt autem omnes Aegyptii per circuitum fluminis aquam, ut biberent; non enim poterant bibere de aqua fluminis."
,"25":"Impletique sunt septem dies, postquam percussit Dominus fluvium."
,"26":"Dixit quoque Dominus ad Moysen: ' Ingredere ad pharaonem et dices ad eum: Haec dicit Dominus: Dimitte populum meum, ut sacrificet mihi."
,"27":"Sin autem nolueris dimittere, ecce ego percutiam omnes terminos tuos ranis."
,"28":"Et ebulliet fluvius ranas, quae ascendent et ingredientur domum tuam et cubiculum lectuli tui et super stratum tuum et in domos servorum tuorum et in populum tuum et in furnos tuos et in pistrina tua;"
,"29":"et ad te et ad populum tuum et ad omnes servos tuos intrabunt ranae '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Dixitque Dominus ad Moysen: ' Dic ad Aaron: Extende ma num tuam cum baculo tuo super fluvios, super rivos ac paludes et educ ranas super terram Aegypti '."
,"2":"Et extendit Aaron manum super aquas Aegypti, et ascenderunt ranae operueruntque terram Aegypti."
,"3":"Fecerunt autem et malefici per incantationes suas similiter eduxeruntque ranas super terram Aegypti."
,"4":"Vocavit autem pharao Moysen et Aaron et dixit: ' Orate Dominum, ut auferat ranas a me et a populo meo, et dimittam populum, ut sacrificet Domino '."
,"5":"Dixitque Moyses ad pharaonem: ' Constitue mihi, quando deprecer pro te et pro servis et pro populo tuo, ut abigantur ranae a te et a domo tua et tantum in flumine remaneant '."
,"6":"Qui respondit: ' Cras '. At ille: ' Iuxta verbum, inquit, tuum faciam, ut scias quoniam non est sicut Dominus Deus noster."
,"7":"Et recedent ranae a te et a domo tua et a servis tuis et a populo tuo; tantum in flumine remanebunt '."
,"8":"Egressique sunt Moyses et Aaron a pharaone; et clamavit Moyses ad Dominum pro sponsione ranarum, quam condixerat pharaoni."
,"9":"Fecitque Dominus iuxta verbum Moysi, et mortuae sunt ranae de domibus et de villis et de agris;"
,"10":"congregaveruntque eas in immensos aggeres, et computruit terra."
,"11":"Videns autem pharao quod data esset requies, ingravavit cor suum et non audivit eos, sicut dixerat Dominus."
,"12":"Dixitque Dominus ad Moysen: ' Loquere ad Aaron: Extende virgam tuam et percute pulverem terrae, et sint scinifes in universa terra Aegypti '."
,"13":"Feceruntque ita; et extendit Aaron manum virgam tenens percussitque pulverem terrae. Et facti sunt scinifes in hominibus et in iumentis; omnis pulvis terrae versus est in scinifes per totam terram Aegypti."
,"14":"Feceruntque similiter malefici incantationibus suis, ut educerent scinifes; et non potuerunt. Erantque scinifes tam in hominibus quam in iumentis;"
,"15":"et dixerunt malefici ad pharaonem: ' Digitus Dei est hic '. Induratumque est cor pharaonis et non audivit eos, sicut praeceperat Dominus."
,"16":"Dixit quoque Dominus ad Moysen: ' Consurge diluculo et sta coram pharaone. Egredietur enim ad aquas, et dices ad eum: Haec dicit Dominus: Dimitte populum meum, ut sacrificet mihi."
,"17":"Quod si non dimiseris eum, ecce ego immittam in te et in servos tuos et in populum tuum et in domos tuas omne genus muscarum; et implebuntur domus Aegyptiorum muscis et etiam humus, in qua fuerint."
,"18":"Et segregabo in die illa terram Gessen, in qua populus meus est, ut non sint ibi muscae, et scias quoniam ego Dominus in medio terrae;"
,"19":"ponamque divi sionem inter populum meum et populum tuum; cras erit signum istud '."
,"20":"Fecitque Dominus ita; et venit musca gravissima in domos pharaonis et servorum eius et in omnem terram Aegypti, corruptaque est terra ab huiuscemodi muscis."
,"21":"Vocavitque pharao Moysen et Aaron et ait eis: ' Ite, sacrificate Deo vestro in terra '."
,"22":"Et ait Moyses: ' Non potest ita fieri: abominationes enim Aegyptiorum immolabimus Domino Deo nostro; quod si mactaverimus ea, quae colunt Aegyptii, coram eis, lapidibus nos obruent."
,"23":"Viam trium dierum pergemus in solitudinem et sacrificabimus Domino Deo nostro, sicut praecepit nobis '."
,"24":"Dixitque pharao: ' Ego dimittam vos, ut sacrificetis Domino Deo vestro in deserto, verumtamen longius ne abeatis; rogate pro me '."
,"25":"Et ait Moyses: ' Egressus a te, orabo Dominum, et recedet musca a pharaone et a servis suis et a populo eius cras; verumtamen noli ultra fallere, ut non dimittas populum sacrificare Domino '."
,"26":"Egressusque Moyses a pharaone oravit Dominum;"
,"27":"qui fecit iuxta verbum illius et abstulit muscas a pharaone et a servis suis et a populo eius; non superfuit ne una quidem."
,"28":"Et ingravatum est cor pharaonis, ita ut ne hac quidem vice dimitteret populum."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Dixit autem Dominus ad Moysen: ' Ingredere ad pharaonem et loquere ad eum: Haec dicit Dominus, Deus Hebraeorum: Dimitte populum meum, ut sacrificet mihi."
,"2":"Quod si adhuc renuis et retines eos,"
,"3":"ecce manus Domini erit super possessionem tuam in agris, super equos et asinos et camelos et boves et oves, pestis valde gravis;"
,"4":"et distinguet Dominus inter possessiones Israel et possessiones Aegyptiorum, ut nihil omnino pereat ex his, quae pertinent ad filios Israel."
,"5":"Constituitque Dominus tempus dicens: Cras faciet Dominus verbum istud in terra '."
,"6":"Fecit ergo Dominus verbum hoc altera die, mortuaque sunt omnia animantia Aegyptiorum; de animalibus vero filiorum Israel nihil omnino periit."
,"7":"Et misit pharao ad videndum; nec erat quidquam mortuum de his, quae possidebat Israel. Ingravatumque est cor pharaonis, et non dimisit populum."
,"8":"Et dixit Dominus ad Moysen et Aaron: ' Tollite plenas manus cineris de camino, et spargat illum Moyses in caelum coram pharaone;"
,"9":"sitque pulvis super omnem terram Aegypti; erunt enim in hominibus et iumentis ulcera et vesicae turgentes in universa terra Aegypti '."
,"10":"Tuleruntque cinerem de camino et steterunt coram pharaone, et sparsit illum Moyses in caelum; factaque sunt ulcera vesicarum turgentium in hominibus et iumentis."
,"11":"Nec poterant malefici stare coram Moyse propter ulcera, quae in illis erant et in omni terra Aegypti."
,"12":"Induravitque Dominus cor pharaonis, et non audivit eos, sicut locutus est Dominus ad Moysen."
,"13":"Dixitque Dominus ad Moysen: ' Mane consurge et sta coram pharaone et dices ad eum: Haec dicit Dominus, Deus Hebraeorum: Dimitte populum meum, ut sacrificet mihi;"
,"14":"quia in hac vice mittam omnes plagas meas super cor tuum et super servos tuos et super populum tuum, ut scias quod non sit similis mei in omni terra."
,"15":"Nunc enim extendens manum si percussissem te et populum tuum peste, perisses de terra."
,"16":"Idcirco autem servavi te, ut ostendam in te fortitudinem meam, et narretur nomen meum in omni terra."
,"17":"Adhuc retines populum meum et non vis dimittere eum?"
,"18":"En pluam cras, hac ipsa hora, grandinem multam nimis, qualis non fuit in Aegypto a die, qua fundata est, usque in praesens tempus."
,"19":"Mitte ergo iam nunc et congrega iumenta tua et omnia, quae habes in agro; homines enim et iumenta universa, quae inventa fuerint foris nec congregata de agris, cadet super ea grando, et morientur '."
,"20":"Qui timuit verbum Domini de servis pharaonis, fecit confugere servos suos et iumenta in domos;"
,"21":"qui autem neglexit sermonem Domini, dimisit servos suos et iumenta in agris."
,"22":"Et dixit Dominus ad Moysen: ' Extende manum tuam in caelum, ut fiat grando in universa terra Aegypti super homines et super iumenta et super omnem herbam agri in terra Aegypti '."
,"23":"Extenditque Moyses virgam in caelum, et Dominus dedit tonitrua et grandinem ac discurrentia fulgura super terram; pluitque Dominus grandinem super terram Aegypti."
,"24":"Et grando et ignis immixta pariter ferebantur; tantaeque fuit magnitudinis, quanta ante numquam apparuit in universa terra Aegypti, ex quo gens illa condita est."
,"25":"Et percussit grando in omni terra Aegypti cuncta, quae fuerunt in agris, ab homine usque ad iumentum; cunctamque herbam agri percussit grando et omne lignum regionis confregit."
,"26":"Tantum in terra Gessen, ubi erant filii Israel, grando non cecidit."
,"27":"Misitque pharao et vocavit Moysen et Aaron dicens ad eos: ' Nunc peccavi; Dominus iustus, ego et populus meus rei."
,"28":"Orate Dominum, ut desinant tonitrua Dei et grando, et dimittam vos, et nequaquam hic ultra manebitis '."
,"29":"Ait Moyses: ' Cum egressus fuero de urbe, extendam palmas meas ad Dominum; et cessabunt tonitrua, et grando non erit, ut scias quia Domini est terra."
,"30":"Novi autem quod et tu et servi tui necdum timeatis Dominum Deum '."
,"31":"Linum ergo et hordeum laesum est, eo quod hordeum iam spicas et linum iam folliculos germinaret;"
,"32":"triticum autem et far non sunt laesa, quia serotina erant."
,"33":"Egressusque Moyses a pharaone ex urbe tetendit manus ad Dominum; et cessaverunt tonitrua et grando, nec ultra effundebatur pluvia super terram."
,"34":"Videns autem pharao quod cessasset pluvia et grando et tonitrua, auxit peccatum;"
,"35":"et ingravatum est cor eius et servorum illius et induratum nimis; nec dimisit filios Israel, sicut dixerat Dominus per manum Moysi."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Et dixit Dominus ad Moy sen: ' Ingredere ad pharao nem: ego enim induravi cor eius et servorum illius, ut faciam signa mea haec in medio eorum,"
,"2":"et narres in auribus filii tui et nepotum tuorum, quotiens contriverim Aegyptios et signa mea fecerim in eis; et sciatis quia ego Dominus '."
,"3":"Introierunt ergo Moyses et Aaron ad pharaonem et dixerunt ei: ' Haec dicit Dominus, Deus Hebraeorum: Usquequo non vis subici mihi? Dimitte populum meum, ut sacrificet mihi."
,"4":"Sin autem resistis et non vis dimittere eum, ecce ego inducam cras locustam in fines tuos,"
,"5":"quae operiat superficiem terrae, ne quidquam eius appareat, sed comedatur, quod residuum fuerit grandini; corrodet enim omnia ligna, quae germinant in agris."
,"6":"Et implebunt domos tuas et servorum tuorum et omnium Aegyptiorum, quantam non viderunt patres tui et avi, ex quo orti sunt super terram usque in praesentem diem '. Avertitque se et egressus est a pharaone."
,"7":"Dixerunt autem servi pharaonis ad eum: ' Usquequo patiemur hoc scandalum? Dimitte homines, ut sacrificent Domino Deo suo; nonne vides quod perierit Aegyptus? '."
,"8":"Revocaveruntque Moysen et Aaron ad pharaonem, qui dixit eis: ' Ite, sacrificate Domino Deo vestro. Quinam sunt qui ituri sunt? '."
,"9":"Ait Moyses: ' Cum parvulis nostris et senioribus pergemus, cum filiis et filiabus, cum ovibus et armentis; est enim sollemnitas Domini nobis '."
,"10":"Et respondit eis: ' Sic Dominus sit vobiscum, quomodo ego dimittam vos et parvulos vestros. Cui dubium est quod pessime cogitetis?"
,"11":"Non fiet ita, sed ite tantum viri et sacrificate Domino; hoc enim et ipsi petistis '. Statimque eiecti sunt de conspectu pharaonis."
,"12":"Dixit autem Dominus ad Moysen: ' Extende manum tuam super terram Aegypti, ut veniat locusta et ascendat super eam et devoret omnem herbam, quidquid residuum fuerit grandini '."
,"13":"Et extendit Moyses virgam super terram Aegypti, et Dominus induxit ventum urentem tota die illa et nocte. Et mane facto, ventus urens levavit locustas;"
,"14":"quae ascenderunt super universam terram Aegypti et sederunt in cunctis finibus Aegyptiorum innumerabiles, quales ante illud tempus non fuerant nec postea futurae sunt."
,"15":"Operueruntque universam superficiem terrae, et obscurata est terra. Devoraverunt igitur omnem herbam terrae et, quidquid pomorum in arboribus fuit, quae grando dimiserat; nihilque omnino virens relictum est in lignis et in herbis terrae in cuncta Aegypto."
,"16":"Quam ob rem festinus pharao vocavit Moysen et Aaron et dixit eis: ' Peccavi in Dominum Deum vestrum et in vos."
,"17":"Sed nunc dimittite peccatum mihi tantum hac vice et rogate Dominum Deum vestrum, ut auferat a me saltem mortem istam '."
,"18":"Egressusque Moyses de conspectu pharaonis oravit Dominum,"
,"19":"qui flare fecit ventum ab occidente vehementissimum et arreptam locustam proiecit in mare Rubrum; non remansit ne una quidem in cunctis finibus Aegypti."
,"20":"Et induravit Dominus cor pharaonis, nec dimisit filios Israel."
,"21":"Dixit autem Dominus ad Moysen: ' Extende manum tuam in caelum, et sint tenebrae super terram Aegypti tam densae ut palpari queant '."
,"22":"Extenditque Moyses manum in caelum, et factae sunt tenebrae horribiles in universa terra Aegypti tribus diebus."
,"23":"Nemo vidit fratrem suum nec movit se de loco, in quo erat. Ubicumque autem habitabant filii Israel, lux erat."
,"24":"Vocavitque pharao Moysen et Aaron et dixit eis: ' Ite, sacrificate Domino; oves tantum vestrae et armenta remaneant, parvuli vestri eant vobiscum '."
,"25":"Ait Moyses: ' Etiamsi tu hostias et holocausta dares nobis, quae offeramus Domino Deo nostro,"
,"26":"tamen et greges nostri pergent nobiscum; non remanebit ex eis ungula, quoniam ex ipsis sumemus, quae necessaria sunt in cultum Domini Dei nostri; praesertim cum ignoremus quid debeat immolari, donec ad ipsum locum perveniamus '."
,"27":"Induravit autem Dominus cor pharaonis, et noluit dimittere eos."
,"28":"Dixitque pharao ad eum: ' Recede a me. Cave, ne ultra videas faciem meam; quocumque die apparueris mihi, morieris '."
,"29":"Respondit Moyses: ' Ita fiet, ut locutus es; non videbo ultra faciem tuam '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Et dixit Dominus ad Moy sen: ' Adhuc una plaga tan gam pharaonem et Aegyptum, et post haec dimittet vos utique, immo et exire compellet."
,"2":"Dices ergo omni plebi, ut postulet vir ab amico suo et mulier a vicina sua vasa argentea et aurea;"
,"3":"dabit autem Dominus gratiam populo coram Aegyptiis '. Fuitque Moyses vir magnus valde in terra Aegypti coram servis pharaonis et omni populo."
,"4":"Et ait Moyses: ' Haec dicit Dominus: Media nocte egrediar in Aegyptum;"
,"5":"et morietur omne primogenitum in terra Aegyptiorum, a primogenito pharaonis, qui sedet in solio eius, usque ad primogenitum ancillae, quae est ad molam, et omnia primogenita iumentorum."
,"6":"Eritque clamor magnus in universa terra Aegypti, qualis nec ante fuit nec postea futurus est."
,"7":"Apud omnes autem filios Israel non mutiet canis contra hominem et pecus, ut sciatis quanto miraculo dividat Dominus Aegyptios et Israel."
,"8":"Descendentque omnes servi tui isti ad me et adorabunt me dicentes: 'Egredere tu et omnis populus, qui sequitur te'. Post haec egrediar '. Et exivit a pharaone iratus nimis."
,"9":"Dixit autem Dominus ad Moysen: ' Non audiet vos pharao, ut multa signa fiant in terra Aegypti '."
,"10":"Moyses autem et Aaron fecerunt omnia ostenta haec coram pharaone; et induravit Dominus cor pharaonis, nec dimisit filios Israel de terra sua."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Dixit Dominus ad Moysen et Aaron in terra Aegypti:"
,"2":"' Mensis iste vobis principium mensium, primus erit in mensibus anni."
,"3":"Loquimini ad universum coetum filiorum Israel et dicite eis: Decima die mensis huius tollat unusquisque agnum per familias et domos suas."
,"4":"Sin autem minor est numerus, ut sufficere possit ad vescendum agnum, assumet vicinum suum, qui iunctus est domui suae, iuxta numerum animarum, quae sufficere possunt ad esum agni."
,"5":"Erit autem vobis agnus absque macula, masculus, anniculus; quem de agnis vel haedis tolletis"
,"6":"et servabitis eum usque ad quartam decimam diem mensis huius; immolabitque eum universa congregatio filiorum Israel ad vesperam."
,"7":"Et sument de sanguine eius ac ponent super utrumque postem et in superliminaribus domorum, in quibus comedent illum;"
,"8":"et edent carnes nocte illa assas igni et azymos panes cum lactucis amaris."
,"9":"Non comedetis ex eo crudum quid nec coctum aqua, sed tantum assum igni; caput cum pedibus eius et intestinis vorabitis."
,"10":"Nec remanebit quidquam ex eo usque mane; si quid residuum fuerit, igne comburetis."
,"11":"Sic autem comedetis illum: renes vestros accingetis, calceamenta habebitis in pedibus, tenentes baculos in manibus, et comedetis festinanter; est enim Pascha (id est Transitus) Domini!"
,"12":"Et transibo per terram Aegypti nocte illa percutiamque omne primogenitum in terra Aegypti ab homine usque ad pecus; et in cunctis diis Aegypti faciam iudicia, ego Dominus."
,"13":"Erit autem sanguis vobis in signum in aedibus, in quibus eritis; et videbo sanguinem et transibo vos, nec erit in vobis plaga disperdens, quando percussero terram Aegypti."
,"14":"Habebitis autem hanc diem in monumentum et celebrabitis eam sollemnem Domino in generationibus vestris cultu sempiterno."
,"15":"Septem diebus azyma comedetis. Iam in die primo non erit fermentum in domibus vestris; quicumque comederit fermentatum, a primo die usque ad diem septimum, peribit anima illa de Israel."
,"16":"Dies prima erit sancta atque sollemnis, et dies septima eadem festivitate venerabilis. Nihil operis facietis in eis, exceptis his, quae ad vescendum pertinent."
,"17":"Et observabitis azyma, in eadem enim ipsa die eduxi exercitum vestrum de terra Aegypti; et custodietis diem istum in generationes vestras ritu perpetuo."
,"18":"Primo mense, quarta decima die mensis ad vesperam comedetis azyma; usque ad diem vicesimam primam eiusdem mensis ad vesperam."
,"19":"Septem diebus fermentum non invenietur in domibus vestris. Qui comederit fermentatum, peribit anima eius de coetu Israel, tam de advenis quam de indigenis terrae."
,"20":"Omne fermentatum non comedetis; in cunctis habitaculis vestris edetis azyma '."
,"21":"Vocavit autem Moyses omnes seniores filiorum Israel et dixit ad eos: ' Ite tollentes animal per familias vestras et immolate Pascha."
,"22":"Fasciculumque hyssopi tingite in sanguine, qui est in pelvi, et aspergite ex eo superliminare et utrumque postem. Nullus vestrum egrediatur ostium domus suae usque mane."
,"23":"Transibit enim Dominus percutiens Aegyptios; cumque viderit sanguinem in superliminari et in utroque poste, transcendet ostium et non sinet percussorem ingredi domos vestras et laedere."
,"24":"Custodite verbum istud legitimum tibi et filiis tuis usque in aeternum."
,"25":"Cumque introieritis terram, quam Dominus daturus est vobis, ut pollicitus est, observabitis caeremonias istas;"
,"26":"et, cum dixerint vobis filii vestri: 'Quae est ista religio?',"
,"27":"dicetis eis: 'Victima Paschae Domino est, quando transivit super domos filiorum Israel in Aegypto percutiens Aegyptios et domos nostras liberans' '. Incurvatusque populus adoravit;"
,"28":"et egressi filii Israel fecerunt, sicut praeceperat Dominus Moysi et Aaron."
,"29":"Factum est autem in noctis medio, percussit Dominus omne primogenitum in terra Aegypti, a primogenito pharaonis, qui in solio eius sedebat, usque ad primogenitum captivi, qui erat in carcere, et omne primogenitum iumentorum."
,"30":"Surrexitque pharao nocte et omnes servi eius cunctaque Aegyptus, et ortus est clamor magnus in Aegypto, neque enim erat domus, in qua non iaceret mortuus."
,"31":"Vocatisque pharao Moyse et Aaron nocte, ait: ' Surgite, egredimini a populo meo, vos et filii Israel; ite, immolate Domino, sicut dicitis."
,"32":"Oves vestras et armenta assumite, ut petieratis, et abeuntes benedicite mihi '."
,"33":"Urgebantque Aegyptii populum de terra exire velociter dicentes: ' Omnes moriemur '."
,"34":"Tulit igitur populus conspersam farinam, antequam fermentaretur; et ligans pistrina in palliis suis posuit super umeros suos."
,"35":"Feceruntque filii Israel, sicut praeceperat Moyses, et petierunt ab Aegyptiis vasa argentea et aurea vestemque plurimam."
,"36":"Dominus autem dedit gratiam populo coram Aegyptiis, ut commodarent eis; et spoliaverunt Aegyptios."
,"37":"Profectique sunt filii Israel de Ramesse in Succoth, sescenta fere milia peditum virorum absque parvulis."
,"38":"Sed et vulgus promiscuum innumerabile ascendit cum eis, oves et armenta, animantia multa nimis."
,"39":"Coxeruntque farinam, quam dudum de Aegypto conspersam tulerant, et fecerunt subcinericios panes azymos; neque enim poterant fermentari, cogentibus exire Aegyptiis et nullam facere sinentibus moram; nec pulmenti quidquam occurrerant praeparare."
,"40":"Habitatio autem filiorum Israel, qua manserant in Aegypto, fuit quadringentorum triginta annorum."
,"41":"Quibus expletis, eadem die egressus est omnis exercitus Domini de terra Aegypti."
,"42":"Nox ista vigiliarum Domino, quando eduxit eos de terra Aegypti: hanc observare debent Domino omnes filii Israel in generationibus suis."
,"43":"Dixitque Dominus ad Moysen et Aaron: ' Haec est religio Paschae: Omnis alienigena non comedet ex eo;"
,"44":"omnis autem servus empticius circumcidetur et sic comedet;"
,"45":"advena et mercennarius non edent ex eo."
,"46":"In una domo comedetur, nec efferetis de carnibus eius foras nec os illius confringetis."
,"47":"Omnis coetus filiorum Israel faciet illud."
,"48":"Quod si quis peregrinorum in vestram voluerit transire coloniam et facere Pascha Domini, circumcidetur prius omne masculinum eius, et tunc rite celebrabit eritque sicut indigena terrae; si quis autem circumcisus non fuerit, non vescetur ex eo."
,"49":"Eadem lex erit indigenae et colono, qui peregrinatur apud vos '."
,"50":"Feceruntque omnes filii Israel, sicut praeceperat Dominus Moysi et Aaron;"
,"51":"et in eadem die eduxit Dominus filios Israel de terra Aegypti per turmas suas."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Sanctifica mihi omne primogenitum, quod aperit vulvam in filiis Israel, tam de hominibus quam de iumentis: mea sunt enim omnia '."
,"3":"Et ait Moyses ad populum: ' Mementote diei huius, in qua egressi estis de Aegypto et de domo servitutis, quoniam in manu forti eduxit vos Dominus de loco isto, ut non comedatis fermentatum panem."
,"4":"Hodie egredimini, mense Abib (id est novarum Frugum)."
,"5":"Cumque introduxerit te Dominus in terram Chananaei et Hetthaei et Amorraei et Hevaei et Iebusaei, quam iuravit patribus tuis, ut daret tibi, terram fluentem lacte et melle; celebrabis hunc morem sacrorum mense isto."
,"6":"Septem diebus vesceris azymis, et in die septimo erit sollemnitas Domini."
,"7":"Azyma comedetis septem diebus: non apparebit apud te aliquid fermentatum nec in cunctis finibus tuis."
,"8":"Narrabisque filio tuo in die illo dicens: 'Propter hoc, quod fecit mihi Dominus, quando egressus sum de Aegypto'."
,"9":"Et erit quasi signum in manu tua et quasi monumentum inter oculos tuos, ut lex Domini semper sit in ore tuo; in manu enim forti eduxit te Dominus de Aegypto."
,"10":"Custodies huiuscemodi cultum statuto tempore a diebus in dies."
,"11":"Cumque introduxerit te Dominus in terram Chananaei, sicut iuravit tibi et patribus tuis, et dederit tibi eam,"
,"12":"separabis omne, quod aperit vulvam, Domino et quod primitivum est in pecoribus tuis; quidquid habueris masculini sexus, consecrabis Domino."
,"13":"Primogenitum asini mutabis ove; quod, si non redemeris, interficies. Omne autem primogenitum hominis de filiis tuis pretio redimes."
,"14":"Cumque interrogaverit te filius tuus cras dicens: 'Quid est hoc?', respondebis ei: 'In manu forti eduxit nos Dominus de Aegypto, de domo servitutis."
,"15":"Nam, cum induratus esset pharao et nollet nos dimittere, occidit Dominus omne primogenitum in terra Aegypti, a primogenito hominis usque ad primogenitum iumentorum; idcirco immolo Domino omne, quod aperit vulvam, masculini sexus, et omnia primogenita filiorum meorum redimo'."
,"16":"Erit igitur quasi signum in manu tua et quasi appensum quid ob recordationem inter oculos tuos, eo quod in manu forti eduxit nos Dominus de Aegypto '."
,"17":"Igitur cum emisisset pharao populum, non eos duxit Deus per viam terrae Philisthim, quae vicina est, reputans ne forte paeniteret populum, si vidisset adversum se bella consurgere, et reverteretur in Aegyptum,"
,"18":"sed circumduxit per viam deserti, quae est iuxta mare Rubrum. Et armati ascenderunt filii Israel de terra Aegypti."
,"19":"Tulit quoque Moyses ossa Ioseph secum, eo quod adiurasset filios Israel dicens: ' Visitabit vos Deus; efferte ossa mea hinc vobiscum '."
,"20":"Profectique de Succoth castrametati sunt in Etham, in extremis finibus solitudinis."
,"21":"Dominus autem praecedebat eos ad ostendendam viam per diem in columna nubis et per noctem in columna ignis, ut dux esset itineris utroque tempore."
,"22":"Nunquam defuit columna nubis per diem, nec columna ignis per noctem, coram populo."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Locutus est autem Dominus ad Moysen dicens:"
,"2":"' Lo quere filiis Israel: Reversi castrametentur e regione Phihahiroth, quae est inter Magdolum et mare contra Beelsephon; in conspectu eius castra ponetis super mare."
,"3":"Dicturusque est pharao super filiis Israel: 'Errant in terra, conclusit eos desertum'."
,"4":"Et indurabo cor eius, ac persequetur eos, et glorificabor in pharaone et in omni exercitu eius; scientque Aegyptii quia ego sum Dominus '. Feceruntque ita."
,"5":"Et nuntiatum est regi Aegyptiorum quod fugisset populus; immutatumque est cor pharaonis et servorum eius super populo, et dixerunt: ' Quid hoc fecimus, ut dimitteremus Israel, ne servirent nobis? '."
,"6":"Iunxit ergo currum et omnem populum suum assumpsit secum;"
,"7":"tulitque sescentos currus electos et quidquid in Aegypto curruum fuit et bellatores in singulis curribus."
,"8":"Induravitque Dominus cor pharaonis regis Aegypti, et persecutus est filios Israel; at illi egressi erant in manu excelsa."
,"9":"Cumque persequerentur Aegyptii vestigia praecedentium, reppererunt eos in castris super mare; omnes equi et currus pharaonis, equites et exercitus eius erant in Phihahiroth contra Beelsephon."
,"10":"Cumque appropinquasset pharao, levantes filii Israel oculos viderunt Aegyptios post se et timuerunt valde clamaveruntque ad Dominum"
,"11":"et dixerunt ad Moysen: ' Forsitan non erant sepulcra in Aegypto? Ideo tulisti nos, ut moreremur in solitudine. Quid hoc fecisti, ut educeres nos ex Aegypto?"
,"12":"Nonne iste est sermo, quem loquebamur ad te in Aegypto dicentes: Recede a nobis, ut serviamus Aegyptiis? Multo enim melius erat servire eis quam mori in solitudine '."
,"13":"Et ait Moyses ad populum: ' Nolite timere; state et videte salutem Domini, quam facturus est vobis hodie; Aegyptios enim, quos nunc videtis, nequaquam ultra videbitis usque in sempiternum."
,"14":"Dominus pugnabit pro vobis, et vos silebitis '."
,"15":"Dixitque Dominus ad Moysen: ' Quid clamas ad me? Loquere filiis Israel, ut proficiscantur."
,"16":"Tu autem eleva virgam tuam et extende manum tuam super mare et divide illud, ut gradiantur filii Israel in medio mari per siccum."
,"17":"Ego autem indurabo cor Aegyptiorum, ut persequantur eos; et glorificabor in pharaone et in omni exercitu eius, in curribus et in equitibus illius."
,"18":"Et scient Aegyptii quia ego sum Dominus, cum glorificatus fuero in pharaone, in curribus atque in equitibus eius '."
,"19":"Tollensque se angelus Dei, qui praecedebat castra Israel, abiit post eos; et cum eo pariter columna nubis, priora dimittens, post tergum."
,"20":"Stetit inter castra Aegyptiorum et castra Israel; et erat nubes tenebrosa et illuminans noctem, ita ut ad se invicem toto noctis tempore accedere non valerent."
,"21":"Cumque extendisset Moyses manum super mare, reppulit illud Dominus, flante vento vehementi et urente tota nocte, et vertit in siccum; divisaque est aqua."
,"22":"Et ingressi sunt filii Israel per medium maris sicci; erat enim aqua quasi murus a dextra eorum et laeva."
,"23":"Persequentesque Aegyptii ingressi sunt post eos, omnis equitatus pharaonis, currus eius et equites per medium maris."
,"24":"Iamque advenerat vigilia matutina, et ecce respiciens Dominus super castra Aegyptiorum per columnam ignis et nubis perturbavit exercitum eorum;"
,"25":"et impedivit rotas curruum, ita ut difficile moverentur. Dixerunt ergo Aegyptii: ' Fugiamus Israelem! Dominus enim pugnat pro eis contra nos '."
,"26":"Et ait Dominus ad Moysen: ' Extende manum tuam super mare, ut revertantur aquae ad Aegyptios super currus et equites eorum '."
,"27":"Cumque extendisset Moyses manum contra mare, reversum est primo diluculo ad priorem locum; fugientibusque Aegyptiis occurrerunt aquae, et involvit eos Dominus in mediis fluctibus."
,"28":"Reversaeque sunt aquae et operuerunt currus et equites cuncti exercitus pharaonis, qui sequentes ingressi fuerant mare; ne unus quidem superfuit ex eis."
,"29":"Filii autem Israel perrexerunt per medium sicci maris, et aquae eis erant quasi pro muro a dextris et a sinistris."
,"30":"Liberavitque Dominus in die illo Israel de manu Aegyptiorum. Et viderunt Aegyptios mortuos super litus maris"
,"31":"et manum magnam, quam exercuerat Dominus contra eos; timuitque populus Dominum et crediderunt Domino et Moysi servo eius."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Tunc cecinit Moyses et filii Israel carmen hoc Domino, et dixerunt: ' Cantemus Domino, gloriose enim magnificatus est: equum et ascensorem eius,deiecit in mare!"
,"2":"Fortitudo mea et robur meum Dominus, et factus est mihi in salutem. Iste Deus meus, et glorificabo eum; Deus patris mei, et exaltabo eum!"
,"3":"Dominus quasi vir pugnator; Dominus nomen eius!"
,"4":"Currus pharaonis et exercitum eius,proiecit in mare; electi bellatores eius,submersi sunt in mari Rubro."
,"5":"Abyssi operuerunt eos, descenderunt in profundum quasi lapis."
,"6":"Dextera tua, Domine, magnifice in fortitudine, dextera tua, Domine, percussit inimicum."
,"7":"Et in multitudine gloriae tuae,deposuisti adversarios tuos; misisti iram tuam, quae devoravit eos sicut stipulam."
,"8":"Et in spiritu furoris tui,congregatae sunt aquae; stetit ut agger,unda fluens, coagulatae sunt abyssi,in medio mari."
,"9":"Dixit inimicus: 'Persequar, comprehendam, dividam spolia, implebitur anima mea; evaginabo gladium meum, interficiet eos manus mea!'."
,"10":"Flavit spiritus tuus, et operuit eos mare; submersi sunt quasi plumbum,in aquis vehementibus."
,"11":"Quis similis tui,in diis, Domine?,Quis similis tui, magnificus in sanctitate, terribilis atque laudabilis, faciens mirabilia?"
,"12":"Extendisti manum tuam, devoravit eos terra."
,"13":"Dux fuisti in misericordia tua,populo, quem redemisti, et portasti eum in fortitudine tua,ad habitaculum sanctum tuum."
,"14":"Attenderunt populi et commoti sunt, dolores obtinuerunt habitatores Philisthaeae."
,"15":"Tunc conturbati sunt principes Edom, potentes Moab obtinuit tremor, obriguerunt omnes habitatores Chanaan."
,"16":"Irruit super eos,formido et pavor; in magnitudine brachii tui,fiunt immobiles quasi lapis, donec pertranseat populus tuus, Domine, donec pertranseat populus tuus iste, quem possedisti."
,"17":"Introduces eos et plantabis,in monte hereditatis tuae, firmissimo habitaculo tuo, quod operatus es, Domine, sanctuario, Domine, quod firmaverunt manus tuae."
,"18":"Dominus regnabit,in aeternum et ultra! '."
,"19":"Ingressi sunt enim equi pharaonis cum curribus et equitibus eius in mare, et reduxit super eos Dominus aquas maris; filii autem Israel ambu laverunt per siccum in medio eius."
,"20":"Sumpsit ergo Maria prophetissa soror Aaron tympanum in manu sua; egressaeque sunt omnes mulieres post eam cum tympanis et choris,"
,"21":"quibus praecinebat dicens: ' Cantemus Domino, gloriose enim magnificatus est: equum et ascensorem eius,deiecit in mare! '."
,"22":"Tulit autem Moyses Israel de mari Rubro, et egressi sunt in desertum Sur; ambulaveruntque tribus diebus per solitudinem et non inveniebant aquam."
,"23":"Et venerunt in Mara nec poterant bibere aquas de Mara, eo quod essent amarae; unde vocatum est nomen eius Mara (id est Amaritudo)."
,"24":"Et murmuravit populus contra Moysen dicens: ' Quid bibemus? '."
,"25":"At ille clamavit ad Dominum, qui ostendit ei lignum; quod cum misisset in aquas, in dulcedinem versae sunt. Ibi constituit ei praecepta atque iudicia et ibi tentavit eum"
,"26":"dicens: ' Si audieris vocem Domini Dei tui et, quod rectum est coram eo, feceris et oboedieris mandatis eius custodierisque omnia praecepta illius, cunctum languorem, quem posui in Aegypto, non inducam super te: Ego enim Dominus sanator tuus '."
,"27":"Venerunt autem in Elim, ubi erant duodecim fontes aquarum et septuaginta palmae; et castrametati sunt iuxta aquas."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Profectique sunt de Elim, et venit omnis congregatio filio rum Israel in desertum Sin, quod est inter Elim et Sinai, quinto decimo die mensis secundi postquam egressi sunt de terra Aegypti."
,"2":"Et murmuravit omnis congregatio filiorum Israel contra Moysen et Aaron in solitudine,"
,"3":"dixeruntque filii Israel ad eos: ' Utinam mortui essemus per manum Domini in terra Aegypti, quando sedebamus super ollas carnium et comedebamus panem in saturitate. Cur eduxistis nos in desertum istud, ut occideretis omnem coetum fame? '."
,"4":"Dixit autem Dominus ad Moysen: ' Ecce ego pluam vobis panes de caelo; egrediatur populus et colligat, quae sufficiunt per singulos dies, ut tentem eum, utrum ambulet in lege mea an non."
,"5":"Die autem sexta parabunt quod intulerint, et duplum erit quam colligere solebant per singulos dies '."
,"6":"Dixeruntque Moyses et Aaron ad omnes filios Israel: ' Vespere scietis,quod Dominus eduxerit vos,de terra Aegypti;"
,"7":"et mane videbitis,gloriam Domini. Audivit enim murmur vestrum contra Dominum. Nos vero quid sumus, quia mussitatis contra nos? '."
,"8":"Et ait Moyses: ' Dabit Dominus vobis,vespere carnes edere,et mane panes in saturitate, eo quod audierit murmurationes vestras, quibus murmurati estis contra eum. Nos enim quid sumus? Nec contra nos est murmur vestrum, sed contra Dominum '."
,"9":"Dixitque Moyses ad Aaron: ' Dic universae congregationi filiorum Israel: Accedite coram Domino; audivit enim murmur ve strum '."
,"10":"Cumque loqueretur Aaron ad omnem coetum filiorum Israel, respexerunt ad solitudinem, et ecce gloria Domini apparuit in nube."
,"11":"Locutus est autem Dominus ad Moysen dicens:"
,"12":"' Audivi murmurationes filiorum Israel. Loquere ad eos: Vespere comedetis carnes et mane saturabimini panibus scietisque quod ego sum Dominus Deus vester '."
,"13":"Factum est ergo vespere, et ascendens coturnix operuit castra; mane quoque ros iacuit per circuitum castrorum."
,"14":"Cumque operuisset superficiem deserti, apparuit minutum et squamatum in similitudinem pruinae super terram."
,"15":"Quod cum vidissent filii Israel, dixerunt ad invicem: ' Manhu? ' (quod significat: ' Quid est hoc? '). Ignorabant enim quid esset. Quibus ait Moyses: ' Iste est panis, quem dedit Dominus vobis ad vescendum."
,"16":"Hic est sermo, quem praecepit Dominus: 'Colligat ex eo unusquisque quantum sufficiat ad vescendum; gomor per singula capita iuxta numerum animarum vestrarum, quae habitant in tabernaculo, sic tolletis' '."
,"17":"Feceruntque ita filii Israel; et collegerunt alius plus, alius minus."
,"18":"Et mensi sunt ad mensuram gomor; nec qui plus collegerat, habuit amplius, nec qui minus paraverat, repperit minus, sed singuli, iuxta id quod edere poterant, congregaverunt."
,"19":"Dixitque Moyses ad eos: ' Nullus relinquat ex eo in mane '."
,"20":"Qui non audierunt eum, sed dimiserunt quidam ex eis usque mane, et scatere coepit vermibus atque computruit; et iratus est contra eos Moyses."
,"21":"Colligebant autem mane singuli, quantum sufficere poterat ad vescendum; cumque incaluisset sol, liquefiebat."
,"22":"In die autem sexta collegerunt cibos duplices, id est duo gomor per singulos homines. Venerunt autem omnes principes congregationis et narraverunt Moysi."
,"23":"Qui ait eis: ' Hoc est quod locutus est Dominus: Requies, sabbatum sanctum Domino cras; quodcumque torrendum est, torrete et, quae coquenda sunt, coquite; quidquid autem reliquum fuerit, reponite usque in mane '."
,"24":"Feceruntque ita, ut praeceperat Moyses, et non computruit, neque vermis inventus est in eo."
,"25":"Dixitque Moyses: ' Comedite illud hodie, quia sabbatum est Domino; non invenietur hodie in agro."
,"26":"Sex diebus colligite; in die autem septimo sabbatum est Domino, idcirco non invenietur in eo '."
,"27":"Venitque septima dies; et egressi de populo, ut colligerent, non invenerunt."
,"28":"Dixit autem Dominus ad Moysen: ' Usquequo non vultis custodire mandata mea et legem meam?"
,"29":"Videte quod Dominus dederit vobis sabbatum et propter hoc die sexta tribuit vobis cibos duplices; maneat unusquisque apud semetipsum, nullus egrediatur de loco suo die septimo '."
,"30":"Et sabbatizavit populus die septimo."
,"31":"Appellavitque domus Israel nomen eius Man: quod erat quasi semen coriandri album, gustusque eius quasi similae cum melle."
,"32":"Dixit autem Moyses: ' Iste est sermo, quem praecepit Dominus: 'Imple gomor ex eo, et custodiatur in generationes vestras, ut noverint panem, quo alui vos in solitudine, quando educti estis de terra Aegypti' '."
,"33":"Dixitque Moyses ad Aaron: ' Sume vas unum et mitte ibi man, quantum potest capere gomor; et repone coram Domino ad servandum in generationes vestras '."
,"34":"Sicut praecepit Dominus Moysi, posuit illud Aaron coram testimonio reservandum."
,"35":"Filii autem Israel comederunt man quadraginta annis, donec venirent in terram habitabilem; hoc cibo aliti sunt, usquequo tangerent fines terrae Chanaan."
,"36":"Gomor autem decima pars est ephi."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Igitur profecta omnis congregatio filiorum Israel de deserto Sin per mansiones suas iuxta sermonem Domini, castrametati sunt in Raphidim, ubi non erat aqua ad bibendum populo."
,"2":"Qui iurgatus contra Moysen ait: ' Da nobis aquam, ut bibamus '. Quibus respondit Moyses: ' Quid iurgamini contra me? Cur tentatis Dominum? '."
,"3":"Sitivit ergo ibi populus prae aquae penuria et murmuravit contra Moysen dicens: ' Cur fecisti nos exire de Aegypto, ut occideres nos et liberos nostros ac iumenta siti? '."
,"4":"Clamavit autem Moyses ad Dominum dicens: ' Quid faciam populo huic? Adhuc paululum et lapidabunt me '."
,"5":"Et ait Dominus ad Moysen: ' Antecede populum et sume tecum de senioribus Israel, et virgam, qua percussisti fluvium, tolle in manu tua et vade."
,"6":"En ego stabo coram te ibi super petram Horeb; percutiesque petram, et exibit ex ea aqua, ut bibat populus '. Fecit Moyses ita coram senioribus Israel."
,"7":"Et vocavit nomen loci illius Massa et Meriba, propter iurgium filiorum Israel et quia tentaverunt Dominum dicentes: ' Estne Dominus in nobis an non? '."
,"8":"Venit autem Amalec et pugnabat contra Israel in Raphidim."
,"9":"Dixitque Moyses ad Iosue: ' Elige nobis viros et egressus pugna contra Amalec; cras ego stabo in vertice collis habens virgam Dei in manu mea '."
,"10":"Fecit Iosue, ut locutus erat ei Moyses, et pugnavit contra Amalec; Moyses autem et Aaron et Hur ascenderunt super verticem collis."
,"11":"Cumque levaret Moyses manus, vincebat Israel; sin autem remisisset, superabat Amalec."
,"12":"Manus autem Moysi erant graves; sumentes igitur lapidem posuerunt subter eum, in quo sedit; Aaron autem et Hur sustentabant manus eius ex utraque parte. Et factum est ut manus eius non lassarentur usque ad occasum solis."
,"13":"Vicitque Iosue Amalec et populum eius in ore gladii."
,"14":"Dixit autem Dominus ad Moysen: ' Scribe hoc ob monumentum in libro et trade auribus Iosue; delebo enim memoriam Amalec sub caelo '."
,"15":"Aedificavitque Moyses altare et vocavit nomen eius Dominus Nissi (Dominus vexillum meum)"
,"16":"dicens: ' Quia manus contra solium Domini: bellum Domino erit contra Amalec a generatione in generationem '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Cumque audisset Iethro sacerdos Madian socer Moysi omnia, quae fecerat Deus Moysi et Israel populo suo, eo quod eduxisset Dominus Israel de Aegypto,"
,"2":"tulit Sephoram uxorem Moysi, quam remiserat,"
,"3":"et duos filios eius, quorum unus vocabatur Gersam, dicente patre: ' Advena fui in terra aliena ',"
,"4":"alter vero Eliezer: ' Deus enim, ait, patris mei adiutor meus, et eruit me de gladio pharaonis '."
,"5":"Venit ergo Iethro socer Moysi et filii eius et uxor eius ad Moysen in desertum, ubi erat castrametatus iuxta montem Dei;"
,"6":"et mandavit Moysi dicens: ' Ego socer tuus Iethro venio ad te et uxor tua et duo filii tui cum ea '."
,"7":"Qui egressus in occursum soceri sui adoravit et osculatus est eum, salutaveruntque se mutuo verbis pacificis. Cumque intrasset tabernaculum,"
,"8":"narravit Moyses socero suo cuncta, quae fecerat Dominus pharaoni et Aegyptiis propter Israel, universumque laborem, qui accidisset eis in itinere, et quod liberaverat eos Dominus."
,"9":"Laetatusque est Iethro super omnibus bonis, quae fecerat Dominus Israel, eo quod eruisset eum de manu Aegyptiorum,"
,"10":"et ait: ' Benedictus Dominus, qui liberavit vos de manu Aegyptiorum et de manu pharaonis."
,"11":"Nunc cognovi quia magnus Dominus super omnes deos, eo quod eruerit populum de manu Aegyptiorum, qui superbe egerunt contra illos '."
,"12":"Obtulit ergo Iethro socer Moysi holocausta et hostias Deo; veneruntque Aaron et omnes seniores Israel, ut comederent panem cum eo coram Deo."
,"13":"Altero autem die sedit Moyses, ut iudicaret populum, qui assistebat Moysi de mane usque ad vesperam."
,"14":"Quod cum vidisset socer eius, omnia scilicet, quae agebat in populo, ait: ' Quid est hoc, quod facis in plebe? Cur solus sedes, et omnis populus praestolatur de mane usque ad vesperam? '."
,"15":"Cui respondit Moyses: ' Venit ad me populus quaerens sententiam Dei."
,"16":"Cumque acciderit eis aliqua disceptatio, veniunt ad me, ut iudicem inter eos et ostendam praecepta Dei et leges eius '."
,"17":"At ille: ' Non bonam, inquit, rem facis."
,"18":"Consumeris et tu et populus iste, qui tecum est. Ultra vires tuas est negotium; solus illud non poteris sustinere."
,"19":"Sed audi verba mea atque consilia, et erit Deus tecum: Esto tu populo in his, quae ad Deum pertinent, ut referas causas ad Deum"
,"20":"ostendasque populo praecepta et leges viamque, per quam ingredi debeant, et opus, quod facere debeant."
,"21":"Provide autem de omni plebe viros strenuos et timentes Deum, in quibus sit veritas, et qui oderint avaritiam, et constitue ex eis tribunos et centuriones et quinquagenarios et decanos,"
,"22":"qui iudicent populum omni tempore. Quidquid autem maius fuerit, referant ad te, et ipsi minora tantummodo iudicent; leviusque sit tibi, partito cum aliis onere."
,"23":"Si hoc feceris, implebis imperium Dei et praecepta eius poteris sustentare, et omnis hic populus revertetur ad loca sua cum pace '."
,"24":"Quibus auditis, Moyses fecit omnia, quae ille suggesserat;"
,"25":"et, electis viris strenuis de cuncto Israel, constituit eos principes populi, tribunos et centuriones et quinquagenarios et decanos,"
,"26":"qui iudicabant plebem omni tempore. Quidquid autem gravius erat, referebant ad eum, faciliora tantummodo iudicantes."
,"27":"Dimisitque socerum suum, qui reversus abiit in terram suam."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Mense tertio egressionis Israel de terra Aegypti, in die hac venerunt in solitudinem Sinai."
,"2":"Nam profecti de Raphidim et pervenientes usque in desertum Sinai, castrametati sunt in eodem loco, ibique Israel fixit tentoria e regione montis."
,"3":"Moyses autem ascendit ad Deum, vocavitque eum Dominus de monte et ait: ' Haec dices domui Iacob,et annuntiabis filiis Israel:"
,"4":"Vos ipsi vidistis, quae fecerim Aegyptiis, quomodo portaverim vos super alas aquilarum,et adduxerim ad me."
,"5":"Si ergo audieritis vocem meam,et custodieritis pactum meum, eritis mihi in peculium de cunctis populis; mea est enim omnis terra."
,"6":"Et vos eritis mihi regnum sacerdotum,et gens sancta. Haec sunt verba, quae loqueris ad filios Israel '."
,"7":"Venit Moyses et, convocatis maioribus natu populi, exposuit omnes sermones, quos mandaverat Dominus."
,"8":"Responditque universus populus simul: ' Cuncta, quae locutus est Dominus, faciemus '. Cumque rettulisset Moyses verba populi ad Dominum,"
,"9":"ait ei Dominus: ' Ecce ego veniam ad te in caligine nubis, ut audiat me populus loquentem ad te et tibi quoque credat in perpetuum '. Nuntiavit ergo Moyses verba populi ad Dominum, "
,"10":"qui dixit ei: ' Vade ad populum et sanctifica illos hodie et cras; laventque vestimenta sua"
,"11":"et sint parati in diem tertium. In die enim tertio descendet Dominus coram omni plebe super montem Sinai."
,"12":"Constituesque terminos populo per circuitum et dices: Cavete, ne ascendatis in montem nec tangatis fines illius; omnis, qui tetigerit montem, morte morietur."
,"13":"Manus non tanget eum, sed lapidibus opprimetur aut confodietur iaculis; sive iumentum fuerit, sive homo, non vivet. Cum coeperit clangere bucina, tunc ascendant in montem '."
,"14":"Descenditque Moyses de monte ad populum et sanctificavit eum; cumque lavissent vestimenta sua,"
,"15":"ait ad eos: ' Estote parati in diem tertium; ne appropinquetis uxoribus vestris '."
,"16":"Iamque advenerat tertius dies, et mane inclaruerat; et ecce coeperunt audiri tonitrua ac micare fulgura et nubes densissima operire montem, clangorque bucinae vehementius perstrepebat; et timuit populus, qui erat in castris."
,"17":"Cumque eduxisset eos Moyses in occursum Dei de loco castrorum, steterunt ad radices montis."
,"18":"Totus autem mons Sinai fumabat, eo quod descendisset Dominus super eum in igne, et ascenderet fumus ex eo quasi de fornace. Et tremuit omnis mons vehementer."
,"19":"Et sonitus bucinae paulatim crescebat in maius; Moyses loquebatur, et Deus respondebat ei cum voce."
,"20":"Descenditque Dominus super montem Sinai in ipso montis vertice et vocavit Moysen in cacumen eius. Quo cum ascendisset,"
,"21":"dixit ad eum: ' Descende et contestare populum, ne velit transcendere terminos ad videndum Dominum, et pereat ex eis plurima multitudo."
,"22":"Sacerdotes quoque, qui accedunt ad Dominum, sanctificentur, ne percutiat eos '."
,"23":"Dixitque Moyses ad Dominum: ' Non poterit vulgus ascendere in montem Sinai, tu enim testificatus es et iussisti dicens: 'Pone terminos circa montem et sanctifica illum' '."
,"24":"Cui ait Dominus: ' Vade, descende; ascendesque tu et Aaron tecum, sacerdotes autem et populus ne transeant terminos nec ascendant ad Dominum, ne interficiat illos '."
,"25":"Descenditque Moyses ad populum et omnia narravit eis."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Locutusque est Deus cunctos sermones hos:"
,"2":"' Ego sum Dominus Deus tuus, qui eduxi te de terra Aegypti, de domo servitutis."
,"3":"Non habebis deos alienos coram me."
,"4":"Non facies tibi sculptile neque omnem similitudinem eorum, quae sunt in caelo desuper et quae in terra deorsum et quae in aquis sub terra."
,"5":"Non adorabis ea neque coles, quia ego sum Dominus Deus tuus, Deus zelotes, visitans iniquitatem patrum in filiis in tertiam et quartam generationem eorum, qui oderunt me,"
,"6":"et faciens misericordiam in milia his, qui diligunt me et custodiunt praecepta mea."
,"7":"Non assumes nomen Domini Dei tui in vanum, nec enim habebit insontem Dominus eum, qui assumpserit nomen Domini Dei sui frustra."
,"8":"Memento, ut diem sabbati sanctifices."
,"9":"Sex diebus operaberis et facies omnia opera tua;"
,"10":"septimus autem dies sabbatum Domino Deo tuo est; non facies omne opus tu et filius tuus et filia tua, servus tuus et ancilla tua, iumentum tuum et advena, qui est intra portas tuas."
,"11":"Sex enim diebus fecit Dominus caelum et terram et mare et omnia, quae in eis sunt, et requievit in die septimo; idcirco benedixit Dominus diei sabbati et sanctificavit eum."
,"12":"Honora patrem tuum et matrem tuam, ut sis longaevus super terram, quam Dominus Deus tuus dabit tibi."
,"13":"Non occides."
,"14":"Non moechaberis."
,"15":"Non furtum facies."
,"16":"Non loqueris contra proximum tuum falsum testimonium."
,"17":"Non concupisces domum proximi tui: non desiderabis uxorem eius, non servum, non ancillam, non bovem, non asinum nec omnia, quae illius sunt '."
,"18":"Cunctus autem populus videbat voces et lampades et sonitum bucinae montemque fumantem; et perterriti ac pavore concussi steterunt procul"
,"19":"dicentes Moysi: ' Loquere tu nobis, et audiemus; non loquatur nobis Deus, ne moriamur '."
,"20":"Et ait Moyses ad populum: ' Nolite timere; ut enim probaret vos, venit Deus, et ut timor illius esset in vobis, ne peccaretis '."
,"21":"Stetitque populus de longe; Moyses autem accessit ad caliginem, in qua erat Deus."
,"22":"Dixit praeterea Dominus ad Moysen: ' Haec dices filiis Israel: Vos vidistis quod de caelo locutus sim vobis."
,"23":"Non facietis praeter me deos argenteos nec deos aureos facietis vobis."
,"24":"Altare de terra facietis mihi et offeretis super eo holocausta et pacifica vestra, oves vestras et boves; in omni loco, in quo memoriam fecero nominis mei, veniam ad te et benedicam tibi."
,"25":"Quod si altare lapideum feceris mihi, non aedificabis illud de sectis lapidibus; si enim levaveris cultrum super eo, polluetur."
,"26":"Non ascendes per gradus ad altare meum, ne reveletur turpitudo tua."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Haec sunt iudicia, quae propones eis:"
,"2":"Si emeris servum Hebraeum, sex annis serviet tibi; in septimo egredietur liber gratis."
,"3":"Si solus intraverit, solus exeat; si habens uxorem, et uxor egredietur simul."
,"4":"Sin autem dominus dederit illi uxorem, et pepererit filios et filias, mulier et liberi eius erunt domini sui; ipse vero exibit solus."
,"5":"Quod si dixerit servus: 'Diligo dominum meum et uxorem ac liberos, non egrediar liber',"
,"6":"afferet eum dominus ad Deum et applicabit eum ad ostium vel postes perforabitque aurem eius subula; et erit ei servus in saeculum."
,"7":"Si quis vendiderit filiam suam in famulam, non egredietur sicut servi exire consueverunt."
,"8":"Si displicuerit oculis domini sui, cui tradita fuerat, faciat eam redimi; populo autem alieno vendendi non habebit potestatem, quia fraudavit eam."
,"9":"Sin autem filio suo desponderit eam, iuxta morem filiarum faciet illi."
,"10":"Quod si alteram sibi acceperit, cibum et vestimentum et concubitum non negabit."
,"11":"Si tria ista non fecerit ei, egredietur gratis absque pretio."
,"12":"Qui percusserit hominem, et ille mortuus fuerit, morte moriatur."
,"13":"Qui autem non est insidiatus, sed Deus illum tradidit in manus eius, constituam tibi locum, in quem fugere debeat."
,"14":"Si quis de industria occiderit proximum suum et per insidias, ab altari meo evelles eum, ut moriatur."
,"15":"Qui percusserit patrem suum aut matrem, morte moriatur."
,"16":"Qui furatus fuerit hominem sive vendiderit eum sive inventus fuerit in manu eius, morte moriatur."
,"17":"Qui maledixerit patri suo vel matri, morte moriatur."
,"18":"Si rixati fuerint viri, et percusserit alter proximum suum lapide vel pugno, et ille mortuus non fuerit, sed iacuerit in lectulo,"
,"19":"si surrexerit et ambulaverit foris super baculum suum, impunitus erit, qui percusserit, ita tamen, ut operas eius deperditas et impensas pro medela restituat."
,"20":"Qui percusserit servum suum vel ancillam virga, et mortui fuerint in manibus eius, ultioni subiacetur."
,"21":"Sin autem uno die vel duobus supervixerit, non subiacebit poenae, quia pecunia illius est."
,"22":"Si rixati fuerint viri, et percusserit quis mulierem praegnantem et abortivum quidem fecerit, sed aliud quid adversi non acciderit, subiacebit damno, quantum maritus mulieris expetierit, et arbitri iudicaverint."
,"23":"Sin autem quid adversi acciderit, reddet animam pro anima,"
,"24":"oculum pro oculo, dentem pro dente, manum pro manu, pedem pro pede,"
,"25":"adustionem pro adustione, vulnus pro vulnere, livorem pro livore."
,"26":"Si percusserit quispiam oculum servi sui aut ancillae et luscos eos fecerit, dimittet eos liberos pro oculo."
,"27":"Dentem quoque si excusserit servo vel ancillae suae, dimittet eos liberos pro dente."
,"28":"Si bos cornu percusserit virum aut mulierem, et mortui fuerint, lapidibus obruetur, et non comedentur carnes eius; dominus autem bovis innocens erit."
,"29":"Quod si bos cornupeta fuerit ab heri et nudiustertius, et contestati sunt dominum eius, nec recluserit eum, occideritque virum aut mulierem: et bos lapidibus obruetur, et dominum illius occident."
,"30":"Quod si pretium ei fuerit impositum, dabit pro anima sua, quidquid fuerit postulatus."
,"31":"Filium quoque vel filiam si cornu percusserit, simili sententiae subiacebit."
,"32":"Si servum vel ancillam invaserit, triginta siclos argenti dabit domino; bos vero lapidibus opprimetur."
,"33":"Si quis aperuerit cisternam vel foderit et non operuerit eam, cedideritque bos vel asinus in eam,"
,"34":"dominus cisternae reddet pretium iumentorum; quod autem mortuum est, ipsius erit."
,"35":"Si bos alienus bovem alterius vulneraverit, et ille mortuus fuerit, vendent bovem vivum et divident pretium; cadaver autem mortui inter se dispertient."
,"36":"Sin autem notum erat quod bos cornupeta esset ab heri et nudiustertius, et non custodivit eum dominus suus, reddet bovem pro bove et cadaver integrum accipiet."
,"37":"Si quis furatus fuerit bovem aut ovem et occiderit vel vendiderit, quinque boves pro uno bove restituet et quattuor oves pro una ove."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Si effringens fur domum sive suffodiens fuerit inventus et, accepto vulnere, mortuus fuerit, percussor non erit reus sanguinis."
,"2":"Quod si orto sole hoc fecerit, erit reus sanguinis. Fur plene restituet. Si non habuerit, quod reddat, venumdabitur pro furto."
,"3":"Si inventum fuerit apud eum, quod furatus est, vivens sive bos sive asinus sive ovis, duplum restituet."
,"4":"Si quispiam depasci permiserit agrum vel vineam et dimiserit iumentum suum, ut depascatur agrum alienum, restituet plene ex agro suo secundum fruges eius; si autem totum agrum depastum fuerit, quidquid optimum habuerit in agro suo vel in vinea, restituet."
,"5":"Si egressus ignis invenerit spinas et comprehenderit acervos frugum sive stantes segetes sive agrum, reddet damnum, qui ignem succenderit."
,"6":"Si quis commendaverit amico pecuniam aut vasa in custodiam, et ab eo, qui susceperat, furto ablata fuerint, si invenitur fur, duplum reddet."
,"7":"Si latet fur, dominus domus applicabitur ad Deum et iurabit quod non extenderit manum in rem proximi sui."
,"8":"In omni causa fraudis tam de bove quam de asino et ove ac vestimento et, quidquid damnum inferre potest, si quis dixerit: ' Hoc est! ', ad Deum utriusque causa perveniet, et, quem Deus condemnaverit, duplum restituet proximo suo."
,"9":"Si quis commendaverit proximo suo asinum, bovem, ovem vel omne iumentum ad custodiam, et mortuum fuerit aut fractum vel captum ab hostibus, nullusque hoc viderit,"
,"10":"iusiurandum per Dominum erit in medio quod non extenderit manum ad rem proximi sui; suscipietque dominus iuramentum, et ille reddere non cogetur."
,"11":"Quod si furto ablatum fuerit, restituet damnum domino;"
,"12":"si dilaceratum a bestia, deferat, quod occisum est, in testimonium et non restituet."
,"13":"Qui a proximo suo quidquam horum mutuo postulaverit, et fractum aut mortuum fuerit, domino non praesente, reddere compelletur."
,"14":"Quod si impraesentiarum dominus fuerit, non restituet. Si mercennarius est, venit in mercedem operis sui."
,"15":"Si seduxerit quis virginem necdum desponsatam dormieritque cum ea, pretio acquiret eam sibi uxorem."
,"16":"Si pater virginis eam dare noluerit, appendet ei pecuniam iuxta pretium pro virginibus dandum."
,"17":"Maleficam non patieris vivere."
,"18":"Qui coierit cum iumento, morte moriatur."
,"19":"Qui immolat diis, occidetur, praeter Domino soli."
,"20":"Advenam non opprimes neque affliges eum; advenae enim et ipsi fuistis in terra Aegypti."
,"21":"Viduae et pupillo non nocebitis."
,"22":"Si laeseritis eos, vociferabuntur ad me, et ego audiam clamorem eorum;"
,"23":"et indignabitur furor meus, percutiamque vos gladio, et erunt uxores vestrae viduae et filii vestri pupilli."
,"24":"Si pecuniam mutuam dederis in populo meo pauperi, qui habitat tecum, non eris ei quasi creditor; non imponetis ei usuram."
,"25":"Si pignus a proximo tuo acceperis pallium, ante solis occasum reddes ei;"
,"26":"ipsum enim est solum, quo operitur, indumentum carnis eius, nec habet aliud, in quo dormiat; si clamaverit ad me, exaudiam eum, quia misericors sum."
,"27":"Deo non detrahes et principi populi tui non maledices."
,"28":"Abundantiam areae tuae et torcularis tui non tardabis reddere. Primogenitum filiorum tuorum dabis mihi."
,"29":"De bobus quoque et ovibus similiter facies: septem diebus sit cum matre sua, die octavo reddes illum mihi."
,"30":"Viri sancti eritis mihi; carnem animalis in agro dilacerati non comedetis, sed proicietis canibus."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Non suscipies famam falsam nec iunges manum tuam cum impio, ut dicas falsum testimonium."
,"2":"Non sequeris turbam ad faciendum malum; nec in iudicio plurimorum acquiesces sententiae, ut a vero devies."
,"3":"Pauperis quoque non misereberis in iudicio."
,"4":"Si occurreris bovi inimici tui aut asino erranti, reduc ad eum."
,"5":"Si videris asinum odientis te iacere sub onere suo, non pertransibis, sed sublevabis cum eo."
,"6":"Non pervertes iudicium pauperis in lite eius."
,"7":"Mendacium fugies. Insontem et iustum non occides, quia aversor impium."
,"8":"Nec accipies munera, quae excaecant etiam prudentes et subvertunt verba iustorum."
,"9":"Peregrinum non opprimes; scitis enim advenarum animas, quia et ipsi peregrini fuistis in terra Aegypti."
,"10":"Sex annis seminabis terram tuam et congregabis fruges eius."
,"11":"Anno autem septimo dimittes eam et requiescere facies, ut comedant pauperes populi tui; et quidquid reliquum fuerit, edant bestiae agri. Ita facies in vinea et in oliveto tuo."
,"12":"Sex diebus operaberis; septima die cessabis, ut requiescat bos et asinus tuus, et refrigeretur filius ancillae tuae et advena."
,"13":"Omnia, quae dixi vobis, custodite, et nomen externorum deorum non invocabitis, neque audietur ex ore tuo."
,"14":"Tribus vicibus per singulos annos mihi festa celebrabitis."
,"15":"Sollemnitatem Azymorum custodies: septem diebus comedes azyma, sicut praecepi tibi, tempore statuto mensis Abib, quando egressus es de Aegypto. Non apparebis in conspectu meo vacuus."
,"16":"Et sollemnitatem Messis primitivorum operis tui, quaecumque seminaveris in agro; sollemnitatem quoque Collectae in exitu anni, quando congregaveris omnes fruges tuas de agro."
,"17":"Ter in anno apparebit omne masculinum tuum coram Domino Deo."
,"18":"Non immolabis super fermento sanguinem victimae meae, nec remanebit adeps sollemnitatis meae usque mane."
,"19":"Primitias primarum frugum terrae tuae deferes in domum Domini Dei tui. Non coques haedum in lacte matris suae."
,"20":"Ecce ego mittam angelum, qui praecedat te et custodiat in via et introducat ad locum, quem paravi."
,"21":"Observa eum et audi vocem eius nec contemnendum putes; quia non dimittet, cum peccaveritis, quia est nomen meum in illo."
,"22":"Quod si audieris vocem eius et feceris omnia, quae loquor, inimicus ero inimicis tuis et affligam affligentes te."
,"23":"Praecedet enim te angelus meus et introducet te ad Amorraeum et Hetthaeum et Pherezaeum Chananaeumque et Hevaeum et Iebusaeum, quos ego conteram."
,"24":"Non adorabis deos eorum nec coles eos; non facies secundum opera eorum, sed destrues eos et confringes lapides eorum."
,"25":"Servietisque Domino Deo vestro, ut benedicam panibus tuis et aquis et auferam infirmitatem de medio tui."
,"26":"Non erit abortiens nec sterilis in terra tua; numerum dierum tuorum implebo."
,"27":"Terrorem meum mittam in praecursum tuum et perturbabo omnem populum, ad quem ingre dieris; cunctorumque inimicorum tuorum coram te terga vertam"
,"28":"emittens crabrones prius, qui fugabunt Hevaeum et Chananaeum et Hetthaeum, antequam introeas."
,"29":"Non eiciam eos a facie tua anno uno, ne terra in solitudinem redigatur, et multiplicentur contra te bestiae agri."
,"30":"Paulatim expellam eos de conspectu tuo, donec augearis et possideas terram."
,"31":"Ponam autem terminos tuos a mari Rubro usque ad mare Palaestinorum et a deserto usque ad Fluvium. Tradam manibus vestris habitatores terrae et eiciam eos de conspectu vestro."
,"32":"Non inibis cum eis foedus nec cum diis eorum."
,"33":"Non habitent in terra tua, ne peccare te faciant in me, si servieris diis eorum; quod tibi certo erit in scandalum '."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Moysi quoque dixit: ' Ascende ad Dominum, tu et Aa ron, Nadab et Abiu et septuaginta senes ex Israel, et adorabitis procul."
,"2":"Solusque Moyses ascendet ad Dominum, et illi non appropinquabunt, nec populus ascendet cum eo '."
,"3":"Venit ergo Moyses et narravit plebi omnia verba Domini atque iudicia; responditque omnis populus una voce: ' Omnia verba Domini, quae locutus est, faciemus '."
,"4":"Scripsit autem Moyses universos sermones Domini; et mane consurgens aedificavit altare ad radices montis et duodecim lapides per duodecim tribus Israel."
,"5":"Misitque iuvenes de filiis Israel, et obtulerunt holocausta; immolaveruntque victimas pacificas Domino vitulos."
,"6":"Tulit itaque Moyses dimidiam partem sanguinis et misit in crateras; partem autem residuam respersit super altare."
,"7":"Assumensque volumen foederis legit, audiente populo, qui dixerunt: ' Omnia, quae locutus est Dominus, faciemus et erimus oboedientes '."
,"8":"Ille vero sumptum sanguinem respersit in populum et ait: ' Hic est sanguis foederis, quod pepigit Dominus vobiscum super cunctis sermonibus his '."
,"9":"Ascenderuntque Moyses et Aaron, Nadab et Abiu et septuaginta de senioribus Israel."
,"10":"Et viderunt Deum Israel, et sub pedibus eius quasi opus lapidis sapphirini et quasi ipsum caelum, cum serenum est."
,"11":"Nec in electos filiorum Israel misit manum suam; videruntque Deum et comederunt ac biberunt."
,"12":"Dixit autem Dominus ad Moysen: ' Ascende ad me in montem et esto ibi; daboque tibi tabulas lapideas et legem ac mandata, quae scripsi, ut doceas eos '."
,"13":"Surrexerunt Moyses et Iosue minister eius; ascendensque Moyses in montem Dei"
,"14":"senioribus ait: ' Exspectate hic, donec revertamur ad vos. Habetis Aaron et Hur vobiscum; si quid natum fuerit quaestionis, referetis ad eos '."
,"15":"Cumque ascendisset Moyses in montem, operuit nubes montem;"
,"16":"et habitavit gloria Domini super Sinai tegens illum nube sex diebus; septimo autem die vocavit eum de medio caliginis."
,"17":"Erat autem species gloriae Domini quasi ignis ardens super verticem montis in conspectu filiorum Israel."
,"18":"Ingressusque Moyses medium nebulae ascendit in montem; et fuit ibi quadraginta diebus et quadraginta noctibus."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Loquere filiis Israel, ut tollant mihi donaria; ab omni homine, qui offert ultroneus, accipietis ea."
,"3":"Haec sunt autem, quae accipere debetis: aurum et argentum et aes,"
,"4":"hyacinthum et purpuram coccumque et byssum, pilos caprarum"
,"5":"et pelles arietum rubricatas pellesque delphini et ligna acaciae,"
,"6":"oleum ad luminaria concinnanda, aromata in unguentum et in thymiama boni odoris,"
,"7":"lapides onychinos et gemmas ad ornandum ephod ac pectorale."
,"8":"Facientque mihi sanctuarium, et habitabo in medio eorum."
,"9":"Iuxta omnem similitudinem habitaculi, quam ostendam tibi, et omnium vasorum in cultum eius: sicque facietis illud."
,"10":"Arcam de lignis acaciae compingent; cuius longitudo habeat duos semis cubitos, latitudo cubitum et dimidium, altitudo cubitum similiter ac semissem."
,"11":"Et deaurabis eam auro mundissimo intus et foris; faciesque supra coronam auream per circuitum"
,"12":"et conflabis ei quattuor circulos aureos, quos pones in quattuor arcae pedibus: duo circuli sint in latere uno et duo in altero."
,"13":"Facies quoque vectes de lignis acaciae et operies eos auro;"
,"14":"inducesque per circulos, qui sunt in arcae lateribus, ut portetur in eis;"
,"15":"qui semper erunt in circulis nec umquam extrahentur ab eis."
,"16":"Ponesque in arcam testimonium, quod dabo tibi."
,"17":"Facies et propitiatorium de auro mundissimo; duos cubitos et dimidium tenebit longitudo eius, et cubitum ac semissem latitudo."
,"18":"Duos quoque cherubim aureos et productiles facies ex utraque parte propitiatorii,"
,"19":"cherub unus sit in latere uno et alter in altero; ex propitiatorio facies cherubim in utraque parte eius."
,"20":"Expandent alas sursum et operient alis suis propitiatorium; respicientque se mutuo, versis vultibus in propitiatorium,"
,"21":"quo operienda est arca, in qua pones testimonium, quod dabo tibi."
,"22":"Et conveniam te ibi et loquar ad te supra propitiatorium de medio duorum cherubim, qui erunt super arcam testimonii, cuncta, quae mandabo per te filiis Israel."
,"23":"Facies et mensam de lignis acaciae habentem duos cubitos longitudinis et in latitudine cubitum et in altitudine cubitum ac semissem."
,"24":"Et inaurabis eam auro purissimo; faciesque illi coronam auream per circuitum."
,"25":"Facies quoque ei limbum altum quattuor digitis per circuitum et super illum coronam auream."
,"26":"Quattuor quoque circulos aureos praeparabis et pones eos in quattuor angulis eiusdem mensae per singulos pedes."
,"27":"Iuxta limbum erunt circuli aurei, ut mittantur vectes per eos, et possit mensa portari."
,"28":"Ipsosque vectes facies de lignis acaciae et circumdabis auro, et per ipsos subvehitur mensa."
,"29":"Parabis et acetabula ac phialas, vasa et cyathos, in quibus offerenda sunt libamina, ex auro purissimo."
,"30":"Et pones super mensam panes propositionis in conspectu meo semper."
,"31":"Facies et candelabrum ductile de auro mundissimo: basis et hastile eius, scyphi et sphaerulae ac flores in unum efformentur."
,"32":"Sex calami egredientur de lateribus, tres ex uno latere et tres ex altero."
,"33":"Tres scyphi quasi in nucis modum in calamo uno sphaerulaeque simul et flores; et tres similiter scyphi instar nucis in calamo altero sphaerulaeque simul et flores: hoc erit opus sex calamorum, qui producendi sunt de hastili."
,"34":"In ipso autem hastili candelabri erunt quattuor scyphi in nucis modum sphaerulaeque et flores."
,"35":"Singulae sphaerulae sub binis calamis per tria loca, qui simul sex fiunt, procedentes de hastili uno."
,"36":"Sphaerulae igitur et calami unum cum ipso erunt, totum ductile de auro purissimo."
,"37":"Facies et lucernas septem et pones eas super candelabrum, ut luceant in locum ex adverso."
,"38":"Emunctoria quoque et vasa, in quibus emuncta condantur, fient de auro purissimo."
,"39":"Omne pondus candelabri cum universis vasis suis habebit talentum auri purissimi."
,"40":"Inspice et fac secundum exemplar, quod tibi in monte monstratum est."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Habitaculum vero ita facies: decem cortinas de bysso re torta et hyacintho ac purpura coccoque cum cherubim opere polymito facies."
,"2":"Longitudo cortinae unius habebit viginti octo cubitos, latitudo quattuor cubitorum erit. Unius mensurae fient universae cortinae."
,"3":"Quinque cortinae sibi iungentur mutuo, et aliae quinque nexu simili cohaerebunt."
,"4":"Ansulas hyacinthinas in latere facies cortinae unius in extremitate iuncturae et similiter facies in latere cortinae extremae in iunctura altera."
,"5":"Quinquaginta ansulas facies in cortina una et quinquaginta ansulas facies in summitate cortinae, quae est in iunctura altera, ita insertas, ut ansa contra ansam veniat."
,"6":"Facies et quinquaginta fibulas aureas, quibus cortinarum vela iungenda sunt, ut unum habitaculum fiat."
,"7":"Facies et saga cilicina undecim pro tabernaculo super habitaculum."
,"8":"Longitudo sagi unius habebit triginta cubitos et latitudo quattuor; aequa erit mensura sagorum omnium."
,"9":"E quibus quinque iunges seorsum et sex sibi mutuo copulabis, ita ut sextum sagum in fronte tecti duplices."
,"10":"Facies et quinquaginta ansas in ora sagi ultimi iuncturae unius et quinquaginta ansas in ora sagi iuncturae alterius."
,"11":"Facies et quinquaginta fibulas aeneas, quibus iungantur ansae, ut unum ex omnibus tabernaculum fiat."
,"12":"Quod autem superfuerit in sagis, quae parantur tecto, id est unum sagum, quod amplius est, ex medietate eius operies posteriora habitaculi;"
,"13":"et cubitus ex una parte pendebit, et alter ex altera, qui plus est in longitudine sagorum tabernaculi utrumque latus habitaculi protegens."
,"14":"Facies et operimentum aliud pro tabernaculo de pellibus arietum rubricatis et super hoc rursum aliud operimentum de pellibus delphini."
,"15":"Facies et tabulas stantes habitaculi de lignis acaciae,"
,"16":"quae singulae denos cubitos in longitudine habeant et in latitudine singulos ac semissem."
,"17":"In tabula una duo pedes fient, quibus tabula alteri tabulae conectatur; atque in hunc modum cunctae tabulae habitaculi parabuntur."
,"18":"Quarum viginti erunt in latere meridiano, quod vergit ad austrum;"
,"19":"quibus quadraginta bases argenteas fundes, ut binae bases singulis pedibus singularum tabularum subiciantur."
,"20":"In latere quoque secundo habitaculi, quod vergit ad aquilonem, viginti tabulae erunt,"
,"21":"quadraginta habentes bases argenteas; binae bases singulis tabulis supponentur."
,"22":"Ad occidentalem vero plagam in tergo habitaculi facies sex tabulas;"
,"23":"et rursum alias duas, quae in angulis erigantur, post tergum habitaculi."
,"24":"Eruntque geminae a deorsum usque sursum in compaginem unam; ita erit duabus istis, pro duabus angulis erunt."
,"25":"Et erunt simul tabulae octo, bases earum argenteae sedecim, duabus basibus per unam tabulam supputatis."
,"26":"Facies et vectes de lignis acaciae, quinque ad continendas tabulas in uno latere habitaculi"
,"27":"et quinque alios in altero et eiusdem numeri in tergo ad occidentalem plagam;"
,"28":"vectis autem medius transibit per medias tabulas a summo usque ad summum."
,"29":"Ipsasque tabulas deaurabis et fundes eis anulos aureos, per quos vectes tabulata contineant, quos operies laminis aureis."
,"30":"Et eriges habitaculum iuxta exemplar, quod tibi in monte monstratum est."
,"31":"Facies et velum de hyacintho et purpura coccoque et bysso retorta, opere polymito, cum cherubim intextis."
,"32":"Quod appendes in quattuor columnis de lignis acaciae, quae ipsae quidem deauratae erunt et habebunt uncos aureos, sed bases argenteas."
,"33":"Inseres autem velum subter fibulas, intra quod pones arcam testimonii et quo sanctum et sanctum sanctorum dividentur."
,"34":"Pones et propitiatorium super arcam testimonii in sancto sanctorum"
,"35":"mensamque extra velum et contra mensam candelabrum in latere habitaculi meridiano; mensa enim stabit in parte aquilonis."
,"36":"Facies et velum in introitu tabernaculi de hyacintho et purpura coccoque et bysso retorta opere plumarii."
,"37":"Et quinque columnas deaurabis lignorum acaciae, ante quas ducetur velum, quarum erunt unci aurei et bases aeneae."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Facies et altare de lignis acaciae, quod habebit quinque cubitos in longitudine et totidem in latitudine, id est quadrum, et tres cubitos in altitudine."
,"2":"Cornua autem per quattuor angulos ex ipso erunt, et operies illud aere."
,"3":"Faciesque in usus eius lebetes ad suscipiendos cineres et vatilla et pateras atque fuscinulas et ignium receptacula; omnia vasa ex aere fabricabis."
,"4":"Craticulamque facies ei in modum retis aeneam, per cuius quattuor angulos erunt quattuor anuli aenei,"
,"5":"et pones eam subter marginem altaris; eritque craticula usque ad altaris medium."
,"6":"Facies et vectes altaris de lignis acaciae duos, quos operies laminis aeneis,"
,"7":"et induces per anulos; eruntque ex utroque latere altaris ad portandum."
,"8":"Cavum ex tabulis facies illud; sicut tibi in monte monstratum est, sic facient."
,"9":"Facies et atrium habitaculi, in cuius plaga australi contra meridiem erunt tentoria de bysso retorta: centum cubitos unum latus tenebit in longitudine"
,"10":"et columnas viginti et bases totidem aeneas et uncos columnarum anulosque earum argenteos."
,"11":"Similiter in latere aquilonis: per longum erunt tentoria centum cubitorum, columnae viginti et bases aeneae eiusdem numeri et unci columnarum anulique earum argentei."
,"12":"In latitudine vero atrii, quae respicit ad occidentem, erunt tentoria per quinquaginta cubitos et columnae decem basesque totidem."
,"13":"In ea quoque atrii latitudine, quae respicit ad orientem, quinquaginta cubiti erunt,"
,"14":"in quibus quindecim cubitorum tentoria lateri uno deputabuntur columnaeque tres et bases totidem;"
,"15":"et in latere altero erunt tentoria, cubitos obtinentia quindecim, columnae tres et bases totidem."
,"16":"In introitu vero atrii fiet velum cubitorum viginti, ex hyacintho et purpura coccoque et bysso retorta opere plumarii; columnas habebit quattuor cum basibus totidem."
,"17":"Omnes columnae atrii per circuitum cinctae erunt anulis argenteis, et unci earum erunt argentei et bases aeneae."
,"18":"In longitudine occupabit atrium cubitos centum, in latitudine quinquaginta, altitudo quinque cubitorum erit; fietque de bysso retorta, et habebit bases aeneas."
,"19":"Cuncta vasa habitaculi in omnes usus eius et omnes paxillos eius et omnes paxillos atrii ex aere facies."
,"20":"Praecipe filiis Israel, ut afferant tibi oleum de arboribus olivarum purissimum piloque contusum, ut ardeat lucerna semper"
,"21":"in tabernaculo conventus, extra velum, quod oppansum est testimonio. Et parabunt eam Aaron et filii eius, ut a vespere usque mane luceat coram Domino. Perpetuus erit cultus per successiones eorum a filiis Israel."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Applica quoque ad te Aaron fratrem tuum cum filiis suis de medio filiorum Israel, ut sacerdotio fungantur mihi: Aaron, Nadab et Abiu, Eleazar et Ithamar."
,"2":"Faciesque vestes sanctas Aaron fratri tuo in gloriam et decorem;"
,"3":"et loqueris cunctis sapientibus corde, quos replevi spiritu prudentiae, ut faciant vestes Aaron, in quibus sanctificatus ministret mihi."
,"4":"Haec autem erunt vestimenta, quae facient: pectorale et ephod, tunicam et subuculam textam, tiaram et balteum. Facient vestimenta sancta Aaron fratri tuo et filiis eius, ut sacerdotio fungantur mihi;"
,"5":"accipientque aurum et hyacinthum et purpuram coccumque et byssum."
,"6":"Facient autem ephod de auro et hyacintho ac purpura coccoque bysso retorta opere polymito."
,"7":"Duas fascias umerales habebit et in utroque latere summitatum suarum copulabitur cum eis."
,"8":"Et balteus super ephod ad constringendum, eiusdem operis et unum cum eo, erit ex auro et hyacintho et purpura coccoque et bysso retorta."
,"9":"Sumesque duos lapides onychinos et sculpes in eis nomina filiorum Israel:"
,"10":"sex nomina in lapide uno et sex reliqua in altero, iuxta ordinem nativitatis eorum."
,"11":"Opere sculptoris et caelatura gemmarii sculpes eos nominibus filiorum Israel, inclusos textura aurea;"
,"12":"et pones duos lapides super fascias umerales ephod, lapides memorialis filiorum Israel. Portabitque Aaron nomina eorum coram Domino super utrumque umerum ob recordationem."
,"13":"Facies ergo margines textas ex auro"
,"14":"et duas catenulas ex auro purissimo quasi funiculos opus tortile et inseres catenulas tortas marginibus."
,"15":"Pectorale quoque iudicii facies opere polymito, iuxta texturam ephod, ex auro, hyacintho et purpura coccoque et bysso retorta."
,"16":"Quadrangulum erit et duplex; mensuram palmi habebit tam in longitudine quam in latitudine."
,"17":"Ponesque in eo quattuor ordines lapidum: in primo versu erit lapis sardius et topazius et smaragdus;"
,"18":"in secundo carbunculus, sapphirus et iaspis;"
,"19":"in tertio hyacinthus, achates et amethystus;"
,"20":"in quarto chrysolithus, onychinus et beryllus. Inclusi auro erunt per ordines suos."
,"21":"Habebuntque nomina filiorum Israel: duodecim nominibus caelabuntur, singuli lapides nominibus singulorum per duodecim tribus."
,"22":"Facies in pectorali catenas quasi funiculos, opus tortile, ex auro purissimo;"
,"23":"et duos anulos aureos, quos pones in utraque pectoralis summitate;"
,"24":"catenasque aureas iunges anulis, qui sunt in marginalibus eius;"
,"25":"et ipsarum catenarum extrema duobus copulabis marginibus in fasciis umeralibus ephod in parte eius anteriore."
,"26":"Facies et duos anulos aureos, quos pones in summitatibus pectoralis in ora interiore, quae respicit ephod."
,"27":"Necnon et alios duos anulos aureos, qui ponendi sunt in utraque fascia umerali ephod deorsum, versus partem anteriorem eius iuxta iuncturam eius supra balteum ephod,"
,"28":"et stringatur pectorale anulis suis cum anulis ephod vitta hyacinthina, ut maneat supra balteum ephod, et a se invicem pectorale et ephod nequeant separari."
,"29":"Portabitque Aaron nomina filiorum Israel in pectorali iudicii super cor suum, quando ingredietur sanctuarium: memoriale coram Domino in aeternum."
,"30":"Pones autem in pectorali iudicii Urim et Tummim, quae erunt super cor Aaron, quando ingredietur coram Domino; et gestabit iudicium filiorum Israel super cor suum in conspectu Domini semper."
,"31":"Facies et pallium ephod totum hyacinthinum,"
,"32":"in cuius medio supra erit capitium et ora per gyrum eius textilis, sicut in capitio loricae, ne rumpatur."
,"33":"Deorsum vero, ad pedes eiusdem pallii per circuitum, quasi mala punica facies ex hyacintho et purpura et cocco, mixtis in medio tintinnabulis aureis;"
,"34":"ita ut sit tintinnabulum aureum inter singula mala punica."
,"35":"Et vestietur eo Aaron in officio ministerii, ut audiatur sonitus, quando ingreditur et egreditur sanctuarium in conspectu Domini, et non moriatur."
,"36":"Facies et laminam de auro purissimo, in qua sculpes opere caelatoris: 'Sanctum Domino'."
,"37":"Ligabisque eam vitta hyacinthina, et erit super tiaram"
,"38":"super frontem Aaron. Portabitque Aaron iniquitatem contra sancta, quae sanctificabunt filii Israel in cunctis muneribus et donariis suis. Eritque lamina semper in fronte eius, ut placatus eis sit Dominus."
,"39":"Texesque tunicam bysso et tiaram byssinam facies et balteum opere plumarii."
,"40":"Porro filiis Aaron tunicas lineas parabis et balteos ac mitras in gloriam et decorem;"
,"41":"vestiesque his omnibus Aaron fratrem tuum et filios eius cum eo. Et unges eos et implebis manus eorum sanctificabisque illos, ut sacerdotio fungantur mihi."
,"42":"Facies eis et feminalia linea, ut operiant carnem turpitudinis suae a renibus usque ad femora;"
,"43":"et utentur eis Aaron et filii eius, quando ingredientur tabernaculum conventus, vel quando appropinquant ad altare, ut ministrent in sanctuario, ne iniquitatis rei moriantur: legitimum sempiternum erit Aaron et semini eius post eum."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Sed et hoc facies eis, ut mihi in sacerdotio consecrentur: tolle vitulum unum de armento et arietes duos immaculatos"
,"2":"panesque azymos et crustulas absque fermento, quae conspersa sint oleo, lagana quoque azyma oleo lita; de simila triticea cuncta facies"
,"3":"et posita in canistro offeres, vitulum quoque et duos arietes."
,"4":"Aaron ac filios eius applicabis ad ostium tabernaculi conventus. Cumque laveris patrem cum filiis suis aqua,"
,"5":"indues Aaron vestimentis suis, id est subucula et tunica ephod et ephod et pectorali, quod constringes ei cingulo ephod;"
,"6":"et pones tiaram in capite eius et diadema sanctum super tiaram"
,"7":"et oleum unctionis fundes super caput eius; atque hoc ritu consecrabitur."
,"8":"Filios quoque illius applicabis et indues tunicis lineis cingesque balteo"
,"9":"et impones eis mitras; eruntque sacerdotes mihi iure perpetuo. Postquam impleveris manus Aaron et filiorum eius, "
,"10":"applicabis et vitulum coram tabernaculo conventus; imponentque Aaron et filii eius manus super caput illius,"
,"11":"et mactabis eum in conspectu Domini, iuxta ostium tabernaculi conventus."
,"12":"Sumptumque de sanguine vituli, pones super cornua altaris digito tuo, reliquum autem sanguinem fundes iuxta basim eius."
,"13":"Sumes et adipem totum, qui operit intestina, et reticulum iecoris ac duos renes et adipem, qui super eos est, et offeres comburens super altare;"
,"14":"carnes vero vituli et corium et fimum combures foris extra castra, eo quod pro peccato sit."
,"15":"Unum quoque arietem sumes, super cuius caput ponent Aaron et filii eius manus;"
,"16":"quem cum mactaveris, tolles sanguinem eius et fundes super altare per circuitum."
,"17":"Ipsum autem arietem secabis in frusta lotaque intestina eius ac pedes pones super concisas carnes et super caput illius."
,"18":"Et adolebis totum arietem super altare: holocaustum est Domino, odor suavissimus, incensum est Domino."
,"19":"Tolles quoque arietem alterum, super cuius caput Aaron et filii eius ponent manus;"
,"20":"quem cum immolaveris, sumes de sanguine ipsius et pones super extremum auriculae dextrae Aaron et filiorum eius et super pollices manus eorum ac pedis dextri; fundesque sanguinem super altare per circuitum."
,"21":"Cumque tuleris de sanguine, qui est super altare, et de oleo unctionis, asperges Aaron et vestes eius, filios et vestimenta eorum cum ipso. Et sanctus erit ipse et vestimenta eius et filii eius et vestimenta eorum cum ipso."
,"22":"Tollesque adipem de ariete et caudam et arvinam, quae operit intestina, ac reticulum iecoris et duos renes atque adipem, qui super eos est, armumque dextrum, eo quod sit aries consecrationis,"
,"23":"tortamque panis unam, crustulam unam conspersam oleo, laganum unum de canistro azymorum, quod positum est in conspectu Domini;"
,"24":"ponesque omnia super manus Aaron et filiorum eius, ut agitent ea coram Domino."
,"25":"Suscipiesque universa de manibus eorum et incendes in altari super holocausto in odorem suavissimum in conspectu Domini; quia incensum est Domino."
,"26":"Sumes quoque pectusculum de ariete, quo initiatus est Aaron, elevabisque illud coram Domino; et cedet in partem tuam."
,"27":"Sanctificabisque pectusculum elevatum et armum oblatum, quem de ariete separasti,"
,"28":"quo initiatus est Aaron et filii eius; cedentque in partem Aaron et filiorum eius iure perpetuo a filiis Israel; quia oblatio est et oblatio erit a filiis Israel de victimis eorum pacificis, oblatio eorum Domino."
,"29":"Vestem autem sanctam, qua utetur Aaron, habebunt filii eius post eum, ut ungantur in ea, et impleantur in ea manus eorum."
,"30":"Septem diebus utetur illa, qui pontifex pro eo fuerit constitutus de filiis eius, qui ingredietur tabernaculum conventus, ut ministret in sanctuario."
,"31":"Arietem autem consecrationis tolles et coques carnes eius in loco sancto."
,"32":"Et vescetur Aaron et filii eius carnibus arietis et panibus, qui sunt in canistro, in vestibulo tabernaculi conventus."
,"33":"Et comedent ea, quibus expiatio facta fuerit ad implendum manus eorum, ad sanctificandum eos. Alienigena non vescetur ex eis, quia sancta sunt."
,"34":"Quod si remanserit de carnibus consecrationis sive de panibus usque mane, combures reliquias igni; non comedentur, quia sancta sunt."
,"35":"Omnia, quae praecepi tibi, facies super Aaron et filiis eius. Septem diebus consecrabis manus eorum"
,"36":"et vitulum pro peccato offeres per singulos dies ad expiandum. Mundabisque altare expians illud et unges illud in sanctificationem."
,"37":"Septem diebus expiabis altare et sanctificabis; et erit sanctum sanctorum: omnis, qui tetigerit illud, sanctificabitur."
,"38":"Hoc est quod facies in altari: agnos anniculos duos per singulos dies iugiter,"
,"39":"unum agnum mane et alterum vespere;"
,"40":"decimam partem similae conspersae oleo tunso, quod habeat mensuram quartam partem hin, et vinum ad libandum eiusdem mensurae in agno uno."
,"41":"Alterum vero agnum offeres ad vesperam iuxta ritum matutinae oblationis et libationis in odorem suavitatis, incensum Domino,"
,"42":"holocaustum perpetuum in generationes vestras, ad ostium tabernaculi conventus coram Domino, ubi conveniam vos, ut loquar ad te."
,"43":"Ibi conveniam filios Israel, et sanctificabitur locus in gloria mea."
,"44":"Sanctificabo et tabernaculum conventus cum altari et Aaron cum filiis eius, ut sacerdotio fungantur mihi."
,"45":"Et habitabo in medio filiorum Israel eroque eis Deus;"
,"46":"et scient quia ego Dominus Deus eorum, qui eduxi eos de terra Aegypti, ut manerem inter illos: ego Dominus Deus ipsorum."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Facies quoque altare ad adolendum thymiama de lignis acaciae"
,"2":"habens cubitum longitudinis et alterum latitudinis, id est quadrangulum, et duos cubitos in altitudine; cornua ex ipso procedent."
,"3":"Vestiesque illud auro purissimo, tam craticulam eius quam parietes per circuitum et cornua. Faciesque ei coronam aureolam per gyrum"
,"4":"et duos anulos aureos sub corona in duobus lateribus, ut mittantur in eos vectes, et altare portetur."
,"5":"Ipsos quoque vectes facies de lignis acaciae et inaurabis."
,"6":"Ponesque altare contra velum, quod ante arcam pendet testimonii, coram propitiatorio, quo tegitur testimonium, ubi conveniam ad te."
,"7":"Et adolebit incensum super eo Aaron suave fragrans mane. Quando componet lucernas, incendet illud;"
,"8":"et quando collocabit eas ad vesperum, uret thymiama sempiternum coram Domino in generationes vestras."
,"9":"Non offeretis super eo thymiama compositionis alterius nec holocaustum nec oblationem, nec libabitis libamina."
,"10":"Et expiabit Aaron super cornua eius semel per annum in sanguine sacrificii pro peccato; et placabit super eo in generationibus vestris: sanctum sanctorum erit Domino '."
,"11":"Locutusque est Dominus ad Moysen dicens:"
,"12":"' Quando tuleris summam filiorum Israel iuxta numerum, dabunt singuli pretium expiationis pro animabus suis Domino; et non erit plaga in eis, cum fuerint recensiti."
,"13":"Hoc autem dabit omnis, qui transit ad censum, dimidium sicli iuxta mensuram sanctuarii siclus viginti obolos habet ; media pars sicli offeretur Domino."
,"14":"Qui habetur in numero a viginti annis et supra, dabit pretium;"
,"15":"dives non addet ad medium sicli, et pauper nihil minuet, quando dabitis oblationem Domino in expiationem animarum vestrarum."
,"16":"Susceptamque expiationis pecuniam, quae collata est a filiis Israel, trades in usus tabernaculi conventus, ut sit monumentum eorum coram Domino et propitietur animabus illorum '."
,"17":"Locutusque est Dominus ad Moysen dicens:"
,"18":"' Facies et labrum aeneum cum basi aenea ad lavandum; ponesque illud inter tabernaculum conventus et altare. Et, missa aqua,"
,"19":"lavabunt in eo Aaron et filii eius manus suas ac pedes."
,"20":"Quando ingressuri sunt tabernaculum conventus, lavabunt se aqua, ne moriantur; vel quando accessuri sunt ad altare, ut ministrent, ut adoleant victimam Domino."
,"21":"Et lavabunt manus et pedes, ne moriantur: legitimum sempiternum erit, ipsi et semini eius per successiones '."
,"22":"Locutusque est Dominus ad Moysen"
,"23":"dicens: ' Sume tibi aromata prima myrrhae electae quingentos siclos et cinnamomi boni odoris medium, id est ducentos quinquaginta siclos, calami suave olentis similiter ducentos quinquaginta,"
,"24":"casiae autem quingentos siclos, in pondere sanctuarii, olei de olivetis mensuram hin."
,"25":"Faciesque unctionis oleum sanctum, unguentum compositum opere unguentarii; unctionis oleum sanctum erit."
,"26":"Et unges ex eo tabernaculum conventus et arcam testamenti"
,"27":"mensamque cum vasis suis, candelabrum et utensilia eius, altaria thymiamatis"
,"28":"et holocausti et universam supellectilem, quae ad cultum eorum pertinet, et labrum cum basi sua."
,"29":"Sanctificabisque omnia, et erunt sancta sanctorum: qui tetigerit ea, sanctificabitur."
,"30":"Aaron et filios eius unges sanctificabisque eos, ut sacerdotio fungantur mihi."
,"31":"Filiis quoque Israel dices: Hoc oleum unctionis sanctum erit mihi in generationes vestras."
,"32":"Caro hominis non ungetur ex eo, et iuxta compositionem eius non facietis aliud, quia sanctum est et sanctum erit vobis."
,"33":"Homo quicumque tale composuerit et dederit ex eo super alienum, exterminabitur de populo suo '."
,"34":"Dixitque Dominus ad Moysen: ' Sume tibi aromata, stacten et onycha, galbanum boni odoris et tus lucidissimum; aequalis ponderis erunt omnia."
,"35":"Faciesque thymiama compositum opere unguentarii, sale conditum et purum et sanctum."
,"36":"Cumque in tenuissimum pulverem ex parte contuderis, pones ex eo coram testimonio in tabernaculo conventus, in quo conveniam ad te: sanctum sanctorum erit vobis thymiama."
,"37":"Talem compositionem non facietis in usus vestros, quia tibi sanctum erit pro Domino;"
,"38":"homo quicumque fecerit simile, ut odore illius perfruatur, peribit de populis suis '."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Ecce voca vi ex nomine Beseleel filium Uri filii Hur de tribu Iudae"
,"3":"et implevi eum spiritu Dei, sapientia et intellegentia et scientia in omni opere"
,"4":"ad excogitandum, quidquid fabrefieri potest ex auro et argento et aere,"
,"5":"ad scindendum et includendum gemmas et ad sculpendum ligna, ad faciendum omne opus;"
,"6":"dedique ei socium Ooliab filium Achisamech de tribu Dan et in corde omnis eruditi posui sapientiam, ut faciant cuncta, quae praecepi tibi:"
,"7":"tabernaculum conventus et arcam testimonii et propitiatorium, quod super eam est, et cuncta vasa tabernaculi"
,"8":"mensamque et vasa eius, candelabrum purissimum cum vasis suis et altaria thymiamatis"
,"9":"et holocausti et omnia vasa eorum, labrum cum basi sua"
,"10":"et vestes textas et vestes sanctas Aaron sacerdoti et vestes filiorum eius, ut fungantur officio suo in sacris,"
,"11":"oleum unctionis et thymiama aromatum in sanctuario: omnia, quae praecepi tibi, facient '."
,"12":"Et locutus est Dominus ad Moysen dicens:"
,"13":"' Loquere filiis Israel et dices ad eos: Videte ut sabbatum meum custodiatis, quia signum est inter me et vos in generationibus vestris, ut sciatis quia ego Dominus, qui sanctifico vos."
,"14":"Custodite sabbatum, sanctum est enim vobis. Qui polluerit illud, morte morietur; qui fecerit in eo opus, peribit anima illius de medio populi sui."
,"15":"Sex diebus facietis opus; in die septimo sabbatum est, requies sancta Domino: omnis, qui fecerit opus in hac die, morietur."
,"16":"Custodiant filii Israel sabbatum et celebrent illud in generationibus suis: pactum est sempiternum"
,"17":"inter me et filios Israel signumque perpetuum; sex enim diebus fecit Dominus caelum et terram et in septimo ab opere cessavit et respiravit '."
,"18":"Deditque Dominus Moysi, completis huiuscemodi sermonibus in monte Sinai, duas tabulas testimonii lapideas scriptas digito Dei."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Videns autem populus quod moram faceret descendendi de monte Moyses, congregatus ad Aaron dixit: ' Surge, fac nobis deos, qui nos praecedant; Moysi enim, huic viro, qui nos eduxit de terra Aegypti, ignoramus quid acciderit '."
,"2":"Dixitque ad eos Aaron: ' Tollite inaures aureas de uxorum filiorumque et filiarum vestrarum auribus et afferte ad me '."
,"3":"Fecitque omnis populus, quae iusserat, deferens inaures ad Aaron."
,"4":"Quas cum ille accepisset, formavit stilo imaginem et fecit ex eis vitulum conflatilem. Dixeruntque: ' Hi sunt dii tui, Israel, qui te eduxerunt de terra Aegypti! '."
,"5":"Quod cum vidisset Aaron, aedificavit altare coram eo et praeconis voce clamavit dicens: ' Cras sollemnitas Domini est '."
,"6":"Surgen tesque mane altero die obtulerunt holocausta et hostias pacificas; et sedit populus manducare et bibere et surrexerunt ludere."
,"7":"Locutus est autem Dominus ad Moysen: ' Vade, descende; peccavit populus tuus, quem eduxisti de terra Aegypti."
,"8":"Recesserunt cito de via, quam praecepi eis, feceruntque sibi vitulum conflatilem et adoraverunt atque immolantes ei hostias dixerunt: 'Isti sunt dii tui, Israel, qui te eduxerunt de terra Aegypti!' '."
,"9":"Rursumque ait Dominus ad Moysen: ' Cerno quod populus iste durae cervicis sit;"
,"10":"dimitte me, ut irascatur furor meus contra eos et deleam eos faciamque te in gentem magnam '."
,"11":"Moyses autem orabat Dominum Deum suum dicens: ' Cur, Domine, irascitur furor tuus contra populum tuum, quem eduxisti de terra Aegypti in fortitudine magna et in manu robusta?"
,"12":"Ne, quaeso, dicant Aegyptii: 'Callide eduxit eos, ut interficeret in montibus et deleret e terra'. Quiescat ira tua, et esto placabilis super nequitia populi tui."
,"13":"Recordare Abraham, Isaac et Israel servorum tuorum, quibus iurasti per temetipsum dicens: 'Multiplicabo semen vestrum sicut stellas caeli; et universam terram hanc, de qua locutus sum, dabo semini vestro, et possidebitis eam semper' '."
,"14":"Placatusque est Dominus, ne faceret malum, quod locutus fuerat adversus populum suum."
,"15":"Et reversus est Moyses de monte portans duas tabulas testimonii in manu sua scriptas ex utraque parte"
,"16":"et factas opere Dei; scriptura quoque Dei erat sculpta in tabulis."
,"17":"Audiens autem Iosue tumultum populi vociferantis dixit ad Moysen: ' Ululatus pugnae auditur in castris '."
,"18":"Qui respondit: ' Non est clamor vincentium,neque clamor fugientium, sed clamorem cantantium,ego audio '."
,"19":"Cumque appropinquasset ad castra, vidit vitulum et choros; iratusque valde proiecit de manu tabulas et confregit eas ad radices montis."
,"20":"Arripiensque vitulum, quem fecerant, combussit et contrivit usque ad pulverem, quem sparsit in aquam et dedit ex eo potum filiis Israel."
,"21":"Dixitque ad Aaron: ' Quid tibi fecit hic populus, ut induceres super eum peccatum maximum? '."
,"22":"Cui ille respondit: ' Ne indignetur dominus meus; tu enim nosti populum istum, quod pronus sit ad malum."
,"23":"Dixerunt mihi: 'Fac nobis deos, qui nos praecedant; huic enim Moysi, qui nos eduxit de terra Aegypti, nescimus quid acciderit'."
,"24":"Quibus ego dixi: Quis vestrum habet aurum? Abstulerunt et dederunt mihi, et proieci illud in ignem; egressusque est hic vitulus '."
,"25":"Vidit ergo Moyses populum quod esset effrenatus; relaxaverat enim ei Aaron frenum in ludibrium hostium eorum."
,"26":"Et stans in porta castrorum ait: ' Si quis est Domini, iungatur mihi! '. Congregatique sunt ad eum omnes filii Levi."
,"27":"Quibus ait: ' Haec dicit Dominus, Deus Israel: Ponat unusquisque gladium super femur suum. Ite et redite de porta usque ad portam per medium castrorum, et occidat unusquisque fratrem et amicum et proximum suum '."
,"28":"Fecerunt filii Levi iuxta sermonem Moysi; cecideruntque de populo in die illa quasi tria milia hominum."
,"29":"Et ait Moyses: ' Implestis manus vestras hodie Domino unusquisque in filio et in fratre suo, ut detur vobis benedictio '."
,"30":"Facto autem altero die, locutus est Moyses ad populum: ' Peccastis peccatum maximum; ascendam ad Dominum, si quo modo quivero eum deprecari pro scelere vestro '."
,"31":"Reversusque ad Dominum ait: ' Obsecro, peccavit populus iste peccatum maximum, feceruntque sibi deos aureos; aut dimitte eis hanc noxam"
,"32":"aut, si non facis, dele me de libro tuo, quem scripsisti '."
,"33":"Cui respondit Dominus: ' Qui peccaverit mihi, delebo eum de libro meo."
,"34":"Tu autem vade et duc populum istum, quo locutus sum tibi: angelus meus praecedet te; ego autem in die ultionis visitabo et hoc peccatum eorum '."
,"35":"Percussit ergo Dominus populum pro reatu vituli, quem fecerat Aaron."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Locutusque est Dominus ad Moysen: ' Vade, ascende de loco isto, tu et populus tuus, quem eduxisti de terra Aegypti, in terram, quam iuravi Abraham, Isaac et Iacob dicens: Semini tuo dabo eam."
,"2":"Et mittam praecursorem tui angelum et eiciam Chananaeum et Amorraeum et Hetthaeum et Pherezaeum et Hevaeum et Iebusaeum,"
,"3":"et intres in terram fluentem lacte et melle. Non enim ascendam tecum, quia populus durae cervicis es, ne forte disperdam te in via '."
,"4":"Audiens populus sermonem hunc pessimum luxit, et nullus ex more indutus est cultu suo."
,"5":"Dixitque Dominus ad Moysen: ' Loquere filiis Israel: Populus durae cervicis es; uno momento, si ascendam in medio tui, delebo te. Nunc autem depone ornatum tuum, ut sciam quid faciam tibi '."
,"6":"Deposuerunt ergo filii Israel ornatum suum a monte Horeb."
,"7":"Moyses autem tollens tabernaculum tetendit ei extra castra procul; vocavitque nomen eius Tabernaculum conventus. Et omnis, qui quaerebat Dominum, egrediebatur ad tabernaculum conventus extra castra."
,"8":"Cumque egrederetur Moyses ad tabernaculum, surgebat universa plebs, et stabat unusquisque in ostio papilionis sui; aspiciebantque tergum Moysi, donec ingrederetur tabernaculum."
,"9":"Ingresso autem illo tabernaculum, descendebat columna nubis et stabat ad ostium; loquebaturque cum Moyse,"
,"10":"cernentibus universis quod columna nubis staret ad ostium tabernaculi. Stabantque ipsi et adorabant per fores tabernaculorum suorum."
,"11":"Loquebatur autem Dominus ad Moysen facie ad faciem, sicut solet loqui homo ad amicum suum. Cumque ille reverteretur in castra, minister eius Iosue filius Nun puer non recedebat de medio tabernaculi."
,"12":"Dixit autem Moyses ad Dominum: ' Praecipis, ut educam populum istum, et non indicas mihi, quem missurus es mecum; cum dixeris: 'Novi te ex nomine, et invenisti gratiam coram me'."
,"13":"Si ergo inveni gratiam in conspectu tuo, ostende mihi viam tuam, ut sciam te et inveniam gratiam ante oculos tuos; respice quia populus tuus est natio haec '."
,"14":"Dixitque Dominus: ' Facies mea ibit, et requiem dabo tibi '."
,"15":"Et ait Moyses: ' Si non tu ipse eas, ne educas nos de loco isto;"
,"16":"in quo enim scietur me et populum tuum invenisse gratiam in conspectu tuo, nisi ambulaveris nobiscum, ut glorificemur ego et populus tuus prae omnibus populis, qui habitant super terram? '."
,"17":"Dixitque Dominus ad Moysen: ' Et verbum istud, quod locutus es, faciam; invenisti enim gratiam coram me, et teipsum novi ex nomine '."
,"18":"Qui ait: ' Ostende mihi gloriam tuam '."
,"19":"Respondit: ' Ego ostendam omne bonum tibi et vocabo in nomine Domini coram te; et miserebor, cui voluero, et clemens ero, in quem mihi placuerit '."
,"20":"Rursumque ait: ' Non poteris videre faciem meam; non enim videbit me homo et vivet '."
,"21":"Et iterum: ' Ecce, inquit, est locus apud me, stabis super petram;"
,"22":"cumque transibit gloria mea, ponam te in foramine petrae et protegam dextera mea, donec transeam;"
,"23":"tollamque manum meam, et videbis posteriora mea; faciem autem meam videre non poteris '."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Dixitque Dominus ad Moy sen: ' Praecide tibi duas ta bulas lapideas instar priorum, et scribam super eas verba, quae habuerunt tabulae, quas fregisti."
,"2":"Esto paratus mane, ut ascendas statim in montem Sinai; stabisque mihi super verticem montis."
,"3":"Nullus ascendat tecum, nec videatur quispiam per totum montem; oves quoque et boves non pascantur e contra '."
,"4":"Excidit ergo duas tabulas lapideas, quales antea fuerant; et de nocte consurgens ascendit in montem Sinai, sicut praeceperat ei Dominus, portans secum tabulas."
,"5":"Cumque descendisset Dominus per nubem, stetit cum eo vocans in nomine Domini."
,"6":"Et transiens coram eo clamavit: ' Dominus, Dominus Deus, misericors et clemens, patiens et multae miserationis ac verax,"
,"7":"qui custodit misericordiam in milia, qui aufert iniquitatem et scelera atque peccata, nihil autem impunitum sinit, qui reddit iniquitatem patrum in filiis ac nepotibus in tertiam et quartam progeniem '."
,"8":"Festinusque Moyses curvatus est pronus in terram et adorans"
,"9":"ait: ' Si inveni gratiam in conspectu tuo, Domine, obsecro, ut gradiaris nobiscum; populus quidem durae cervicis est, sed tu auferes iniquitates nostras atque peccata nosque possidebis '."
,"10":"Respondit Dominus: ' Ego inibo pactum coram universo populo tuo; mirabilia faciam, quae numquam visa sunt super totam terram nec in ullis gentibus, ut cernat cunctus populus, in cuius es medio, opus Domini terribile, quod facturus sum tecum."
,"11":"Observa cuncta, quae hodie mando tibi: ego ipse eiciam ante faciem tuam Amorraeum et Chananaeum et Hetthaeum, Pherezaeum quoque et Hevaeum et Iebusaeum."
,"12":"Cave, ne umquam cum habitatoribus terrae, quam intraveris, iungas amicitias, quae tibi sint in ruinam;"
,"13":"sed aras eorum destrue, confringe lapides palosque succide."
,"14":"Noli adorare deum alienum: Dominus Zelotes nomen eius, Deus est aemulator."
,"15":"Ne ineas pactum cum hominibus illarum regionum, ne, cum fornicati fuerint cum diis suis et sacrificaverint eis, vocet te quispiam, et comedas de immolatis."
,"16":"Nec uxorem de filiabus eorum accipies filiis tuis, ne, postquam ipsae fuerint fornicatae cum diis suis, fornicari faciant et filios tuos in deos suos."
,"17":"Deos conflatiles non facies tibi."
,"18":"Sollemnitatem Azymorum custodies: septem diebus vesceris azymis, sicut praecepi tibi, in tempore constituto mensis Abib; mense enim verni temporis egressus es de Aegypto."
,"19":"Omne, quod aperit vulvam generis masculini, meum erit; de cuncto grege tuo tam de bobus quam de ovibus meum erit."
,"20":"Primogenitum asini redimes ove, sin autem nec pretium pro eo dederis, franges cervicem eius. Primogenitum filiorum tuorum redimes; nec apparebis in conspectu meo vacuus."
,"21":"Sex diebus operaberis, die septimo cessabis etiam arare et metere."
,"22":"Sollemnitatem Hebdomadarum facies tibi in primitiis frugum messis tuae triticeae et sollemnitatem Collectae, quando, redeunte anni tempore, cuncta conduntur."
,"23":"Tribus temporibus anni apparebit omne masculinum tuum in conspectu omnipotentis Domini, Dei Israel."
,"24":"Cum enim tulero gentes a facie tua et dilatavero terminos tuos, nullus insidiabitur terrae tuae, ascendente te et apparente in conspectu Domini Dei tui ter in anno."
,"25":"Non immolabis super fermento sanguinem hostiae meae; neque residebit mane de victima sollemnitatis Paschae."
,"26":"Primitias frugum terrae tuae afferes in domum Domini Dei tui. Non coques haedum in lacte matris suae '."
,"27":"Dixitque Dominus ad Moysen: ' Scribe tibi verba haec, quibus et tecum et cum Israel pepigi foedus '."
,"28":"Fuit ergo ibi cum Domino quadraginta dies et quadraginta noctes; panem non comedit et aquam non bibit et scripsit in tabulis verba foederis, decem verba."
,"29":"Cumque descenderet Moyses de monte Sinai, tenebat duas tabulas testimonii et ignorabat quod resplenderet cutis faciei suae ex consortio sermonis Domini."
,"30":"Videntes autem Aaron et filii Israel resplendere cutem faciei Moysi, timuerunt prope accedere;"
,"31":"vocatique ab eo reversi sunt tam Aaron quam principes synagogae. Et postquam locutus est ad eos,"
,"32":"venerunt ad eum etiam omnes filii Israel; quibus praecepit cuncta, quae audierat a Domino in monte Sinai."
,"33":"Impletisque sermonibus, posuit velamen super faciem suam,"
,"34":"quod ingressus ad Dominum et loquens cum eo auferebat, donec exiret; et tunc loquebatur ad filios Israel omnia, quae sibi fuerant imperata."
,"35":"Qui videbant cutem faciei Moysi resplendere, sed operiebat ille rursus faciem suam, donec ingressus loqueretur cum eo."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Igitur, congregato omni coetu filiorum Israel, dixit ad eos: ' Haec sunt, quae iussit Dominus fieri:"
,"2":"sex diebus facietis opus, septimus dies erit vobis sanctus, sabbatum et requies Domino; qui fecerit opus in eo, occidetur."
,"3":"Non succendetis ignem in omnibus habitaculis vestris per diem sabbati '."
,"4":"Et ait Moyses ad omnem coetum filiorum Israel: ' Iste est sermo, quem praecepit Dominus dicens:"
,"5":"'Separate apud vos donaria Domino'. Omnis voluntarius et proni animi offerat ea Domino: aurum et argentum et aes,"
,"6":"hyacinthum et purpuram coccumque et byssum, pilos caprarum"
,"7":"et pelles arietum rubricatas et pelles delphini, ligna acaciae"
,"8":"et oleum ad luminaria concinnanda et aromata, ut conficiatur unguentum et thymiama suavissimum,"
,"9":"lapides onychinos et gemmas ad ornatum ephod et pectoralis."
,"10":"Quisquis vestrum sapiens est, veniat et faciat, quod Dominus imperavit,"
,"11":"habitaculum scilicet et tentorium eius atque operimentum, fibulas et tabulata cum vectibus, columnas et bases;"
,"12":"arcam et vectes, propitiatorium et velum, quod ante illud oppanditur;"
,"13":"mensam cum vectibus et vasis et propositionis panibus;"
,"14":"candelabrum ad luminaria sustentanda, vasa illius et lucernas et oleum ad nutrimenta luminarium;"
,"15":"altare thymiamatis et vectes et oleum unctionis et thymiama ex aromatibus; velum ad ostium habitaculi;"
,"16":"altare holocausti et craticulam eius aeneam cum vectibus et vasis suis, labrum et basim eius;"
,"17":"cortinas atrii cum columnis et basibus, velum in foribus atrii;"
,"18":"paxillos habitaculi et atrii cum funiculis suis;"
,"19":"vestimenta texta, quorum usus est in ministerio sanctuarii, vestes sanctas Aaron pontificis ac vestes filiorum eius, ut sacerdotio fungantur mihi '."
,"20":"Egressus est omnis coetus filiorum Israel de conspectu Moysi,"
,"21":"et venit, quisquis erat mentis promptissimae, et attulit sponte sua donaria Domino ad faciendum opus tabernaculi conventus et quidquid ad cultum et ad vestes sanctas necessarium erat."
,"22":"Viri cum mulieribus, omnes voluntarii praebuerunt fibulas et inaures, anulos et dextralia; omne vas aureum in donaria Domini separatum est."
,"23":"Si quis habebat hyacinthum et purpuram coccumque, byssum et pilos caprarum, pelles arietum rubricatas et pelles delphini,"
,"24":"argenti aerisque metalla, obtulerunt Domino lignaque acaciae in varios usus."
,"25":"Sed et mulieres eruditae dederunt, quae neverant, hyacinthum, purpuram et coccum ac byssum"
,"26":"et pilos caprarum, sponte propria cuncta tribuentes."
,"27":"Principes vero obtulerunt lapides onychinos et gemmas ad ephod et pectorale"
,"28":"aromataque et oleum ad luminaria concinnanda et ad praeparandum unguentum ac thymiama odoris suavissimi componendum."
,"29":"Omnes viri et mulieres mente prompta obtulerunt donaria, ut fierent opera, quae iusserat Dominus per manum Moysi. Cuncti filii Israel voluntaria Domino dedicaverunt."
,"30":"Dixitque Moyses ad filios Israel: ' Ecce vocavit Dominus ex nomine Beseleel filium Uri filii Hur de tribu Iudae;"
,"31":"implevitque eum spiritu Dei, sapientia et intellegentia et scientia ad omne opus,"
,"32":"ad excogitandum et faciendum opus in auro et argento et aere,"
,"33":"ad scindendum et includendum gemmas et ad sculpendum ligna, quidquid fabre adinveniri potest."
,"34":"Dedit quoque in corde eius, ut alios doceret, ipsi et Ooliab filio Achisamech de tribu Dan."
,"35":"Ambos implevit sapientia, ut faciant opera fabri polymitarii ac plumarii de hyacintho ac purpura coccoque et bysso et textoris, facientes omne opus ac nova quaeque reperientes '."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Fecit ergo Beseleel et Ooliab et omnis vir sapiens, quibus dedit Dominus sapientiam et intellectum, ut scirent fabre operari, quae in usus sanctuarii necessaria sunt et quae praecepit Dominus."
,"2":"Cumque vocasset Moyses Beseleel et Ooliab et omnem eruditum virum, cui dederat Dominus sapientiam, omnes, qui sponte sua obtulerant se ad faciendum opus,"
,"3":"acceperunt ab ipso universa donaria, quae attulerant filii Israel ad faciendum opus in cultum sanctuarii. Ipsi autem cotidie mane donaria ei offerebant."
,"4":"Unde omnes sapientes artifices venerunt singuli de opere suo pro sanctuario"
,"5":"et dixerunt Moysi: ' Plus offert populus quam necessarium est operi, quod Dominus iussit facere '."
,"6":"Iussit ergo Moyses praeconis voce per castra clamari: ' Nec vir nec mulier quidquam offerat ultra pro omni opere sanctuario '. Sicque cessatum est a muneribus offerendis,"
,"7":"eo quod oblata sufficerent et superabundarent."
,"8":"Feceruntque omnes corde sapientes inter artifices habitaculi cortinas decem de bysso retorta et hyacintho et purpura coccoque, cum cherubim intextis arte polymita;"
,"9":"quarum una habebat in longitudine viginti octo cubitos et in latitudine quattuor: una mensura erat omnium cortinarum."
,"10":"Coniunxitque cortinas quinque alteram alteri et alias quinque sibi invicem copulavit."
,"11":"Fecit et ansas hyacinthinas in ora cortinae unius in extremitate iuncturae et in ora cortinae extremae in iunctura altera similiter."
,"12":"Quinquagenas ansas fecit pro utraque cortina, ut contra se invicem venirent ansae et mutuo iungerentur."
,"13":"Unde et quinquaginta fudit fibulas aureas, quae morderent cortinarum ansas, et fieret unum habitaculum."
,"14":"Fecit et saga undecim de pilis caprarum pro tentorio super habitaculum;"
,"15":"unum sagum in longitudine habebat cubitos triginta et in latitudine cubitos quattuor: unius mensurae erant omnia saga."
,"16":"Quorum quinque iunxit seorsum et sex alia separatim."
,"17":"Fecitque ansas quinquaginta in ora sagi ultimi iuncturae unius et quinquaginta in ora sagi iuncturae alterius, ut sibi invicem iungerentur;"
,"18":"et fecit fibulas aeneas quinquaginta, quibus necteretur tentorium, ut esset unum."
,"19":"Fecit et opertorium tentorio de pellibus arietum rubricatis aliudque desuper velamentum de pellibus delphini."
,"20":"Fecit et tabulas habitaculi de lignis acaciae stantes."
,"21":"Decem cubitorum erat longitudo tabulae unius, et unum ac semis cubitum latitudo retinebat."
,"22":"Bini pedes erant per singulas tabulas, ut altera alteri iungeretur: sic fecit in omnibus tabulis habitaculi."
,"23":"E quibus viginti ad plagam meridianam erant contra austrum"
,"24":"cum quadraginta basibus argenteis. Duae bases sub singulis tabulis ponebantur pro duabus pedibus."
,"25":"Ad plagam quoque habitaculi, quae respicit ad aquilonem, fecit viginti tabulas"
,"26":"cum quadraginta basibus argenteis: duas bases per singulas tabulas."
,"27":"Contra occidentem vero, id est ad eam partem habitaculi quae mare respicit, fecit sex tabulas"
,"28":"et duas alias per singulos angulos habitaculi retro;"
,"29":"quae gemellae erant a deorsum usque sursum in unam compaginem. Ita fecit duas tabulas in duobus angulis,"
,"30":"ut octo essent simul tabulae et haberent bases argenteas sedecim: binas scilicet bases sub singulis tabulis."
,"31":"Fecit et vectes de lignis acaciae quinque ad continendas tabulas unius lateris habitaculi"
,"32":"et quinque alios ad alterius lateris coaptandas tabulas; et extra hos quinque alios vectes ad occidentalem plagam habitaculi contra mare."
,"33":"Fecit autem vectem medium, qui per medias tabulas ab una extremitate usque ad alteram perveniret."
,"34":"Ipsa autem tabulata deauravit. Et anulos eorum fecit aureos, per quos vectes induci possent; quos et ipsos laminis aureis operuit."
,"35":"Fecit et velum de hyacintho et purpura coccoque ac bysso retorta, opere polymitario, cum cherubim intextis;"
,"36":"et quattuor columnas de lignis acaciae, quas cum uncis suis deauravit, fusis basibus earum argenteis."
,"37":"Fecit et velum in introitu tabernaculi ex hyacintho, purpura, cocco byssoque retorta opere plumarii;"
,"38":"et columnas quinque cum uncis suis. Et operuit auro capita et anulos earum basesque earum fudit aeneas."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Fecit autem Beseleel et ar cam de lignis acaciae haben tem duos semis cubitos in longitudine et cubitum ac semissem in latitudine, altitudo quoque unius cubiti fuit et dimidii; vestivitque eam auro purissimo intus ac foris."
,"2":"Et fecit illi coronam auream per gyrum,"
,"3":"conflans quattuor anulos aureos in quattuor pedibus eius; duos anulos in latere uno et duos in altero."
,"4":"Vectes quoque fecit de lignis acaciae, quos vestivit auro"
,"5":"et quos misit in anulos, qui erant in lateribus arcae, ad portandum eam."
,"6":"Fecit et propitiatorium de auro mundissimo: duorum cubitorum et dimidii in longitudine et cubiti ac semis in latitudine."
,"7":"Duos etiam cherubim ex auro ductili fecit ex utraque parte propitiatorii:"
,"8":"cherub unum ex summitate unius partis et cherub alterum ex summitate partis alterius; duos cherubim ex singulis summitatibus propitiatorii"
,"9":"extendentes alas sursum et tegentes alis suis propitiatorium seque mutuo et illud respicientes."
,"10":"Fecit et mensam de lignis acaciae in longitudine duorum cubitorum et in latitudine unius cubiti, quae habebat in altitudine cubitum ac semissem;"
,"11":"circumdeditque eam auro mundissimo et fecit illi coronam auream per gyrum."
,"12":"Fecit ei quoque limbum aureum quattuor digitorum per circuitum et super illum coronam auream."
,"13":"Fudit et quattuor circulos aureos, quos posuit in quattuor angulis per singulos pedes mensae"
,"14":"iuxta limbum; misitque in eos vectes, ut possit mensa portari."
,"15":"Ipsos quoque vectes fecit de lignis acaciae et circumdedit eos auro;"
,"16":"et vasa ad diversos usus mensae, acetabula, phialas et cyathos et crateras ex auro puro, in quibus offerenda sunt libamina."
,"17":"Fecit et candelabrum ductile de auro mundissimo, basim et hastile eius; scyphi sphaerulaeque ac flores unum cum ipso erant:"
,"18":"sex in utroque latere, tres calami ex parte una et tres ex altera;"
,"19":"tres scyphi in nucis modum in calamo uno sphaerulaeque simul et flores et tres scyphi instar nucis in calamo altero sphaerulaeque simul et flores. Aequum erat opus sex calamorum, qui procedebant de hastili candelabri."
,"20":"In ipso autem hastili erant quattuor scyphi in nucis modum sphaerulaeque et flores;"
,"21":"singulae sphaerulae sub binis calamis per loca tria, qui simul sex fiunt calami procedentes de hastili uno."
,"22":"Sphaerulae igitur et calami unum cum ipso erant, totum ductile ex auro purissimo."
,"23":"Fecit et lucernas septem cum emunctoriis suis et vasa, ubi emuncta condantur, de auro mundissimo."
,"24":"Talentum auri purissimi appendebat candelabrum cum omnibus vasis suis."
,"25":"Fecit et altare thymiamatis de lignis acaciae habens per quadrum singulos cubitos et in altitudine duos; e cuius angulis procedebant cornua."
,"26":"Vestivitque illud auro purissimo cum craticula ac parietibus et cornibus."
,"27":"Fecitque ei coronam aureolam per gyrum et binos anulos aureos sub corona in duobus lateribus, ut mittantur in eos vectes, et possit altare portari."
,"28":"Ipsos autem vectes fecit de lignis acaciae et operuit laminis aureis."
,"29":"Composuit et oleum ad sanctificationis unguentum et thymiama de aromatibus mundissimis opere pigmentarii."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Fecit et altare holocausti de lignis acaciae quinque cubi torum per quadrum et trium in altitudine,"
,"2":"cuius cornua de angulis procedebant; operuitque illud laminis aeneis."
,"3":"Et in usus eius paravit ex aere vasa diversa: lebetes, vatilla et pateras, fuscinulas et ignium receptacula."
,"4":"Craticulamque eius in modum retis fecit aeneam subter marginem altaris ab imo usque ad medium eius,"
,"5":"fusis quattuor anulis per totidem craticulae summitates, ad immittendos vectes ad portandum."
,"6":"Quos et ipsos fecit de lignis acaciae et operuit laminis aeneis;"
,"7":"induxitque in circulos, qui in lateribus altaris eminebant. Ipsum autem altare non erat solidum, sed cavum ex tabulis et intus vacuum."
,"8":"Fecit et labrum aeneum cum basi sua de speculis mulierum, quae excubabant in ostio tabernaculi conventus."
,"9":"Fecit et atrium, in cuius australi plaga erant tentoria de bysso retorta cubitorum centum;"
,"10":"columnae aeneae viginti cum basibus suis; unci columnarum et anuli earum argentei."
,"11":"Aeque ad septentrionalem plagam tentoria, columnae basesque et unci anulique columnarum eiusdem mensurae et operis ac metalli erant."
,"12":"In ea vero plaga, quae ad occidentem respicit, fuerunt tentoria cubitorum quinquaginta, columnae decem cum basibus suis; et unci columnarum anulique earum argentei."
,"13":"Porro contra orientem quinquaginta cubitorum paravit tentoria,"
,"14":"e quibus quindecim cubitos columnarum trium cum basibus suis unum tenebat latus;"
,"15":"et in parte altera quia inter utraque introitum tabernaculi fecit quindecim aeque cubitorum erant tentoria columnaeque tres et bases totidem."
,"16":"Cuncta atrii tentoria in circuitu ex bysso retorta texuerat."
,"17":"Bases columnarum fuere aeneae, unci autem earum et anuli earum argentei et capita earum vestivit argento et omnes columnas atrii cinxit anulis argenteis."
,"18":"Et in introitu eius opere plumario fecit velum ex hyacintho, purpura, cocco ac bysso retorta; quod habebat viginti cubitos in longitudine, altitudo vero quinque cubitorum erat iuxta mensuram, quam cuncta atrii tentoria habebant."
,"19":"Columnae autem in ingressu fuere quattuor cum basibus aeneis, uncis argenteis; capitaque et anulos earum vestivit argento."
,"20":"Paxillos quoque habitaculi et atrii per gyrum fecit aeneos."
,"21":"Hic est census habitaculi, habitaculi testimonii, qui recensitus est iuxta praeceptum Moysi ministerio Levitarum per manum Ithamar filii Aaron sacerdotis."
,"22":"Beseleel filius Uri filii Hur de tribu Iudae fecit cuncta, quae praeceperat Dominus Moysi,"
,"23":"iuncto sibi socio Ooliab filio Achisamech de tribu Dan fabro et polymitario atque plumario ex hyacintho, purpura, cocco et bysso."
,"24":"Omne aurum, quod expensum est in opere sanctuarii et quod oblatum est in donariis, viginti novem talentorum fuit et septingentorum triginta siclorum ad mensuram sicli sanctuarii."
,"25":"Argentum autem eorum, qui in congregatione recensiti sunt, centum talentorum fuit et mille septingentorum et septuaginta quinque siclorum ad mensuram sicli sanctuarii."
,"26":"Beca, id est dimidium sicli iuxta mensuram sicli sanctuarii, dedit quisquis transit ad censum a viginti annis et supra, de sescentis tribus milibus et quingentis quinquaginta armatorum."
,"27":"De talentis centum argenti conflatae sunt bases sanctuarii et veli, singulis talentis per bases singulas supputatis."
,"28":"De mille autem septingentis et septuaginta quinque siclis fecit uncos columnarum et vestivit capita earum et cinxit eas argento."
,"29":"Aeris quoque oblata sunt septuaginta talenta et duo milia et quadringenti sicli,"
,"30":"ex quibus fecit bases in introitu tabernaculi conventus et altare aeneum cum craticula sua omniaque vasa, quae ad usum eius pertinent,"
,"31":"et bases atrii tam in circuitu quam in ingressu eius et omnes paxillos habitaculi atque atrii per gyrum."
}`)
	CurrentBook.AddChapter(39, `{
"1":"De hyacintho vero et purpura, cocco ac bysso fecerunt vestes textas pro ministerio sanctuarii. Et fecerunt vestes sacras Aaron, sicut praecepit Dominus Moysi."
,"2":"Fecerunt igitur ephod de auro, hyacintho et purpura coccoque et bysso retorta"
,"3":"opere polymitario tundentes bratteas aureas et extenuantes in fila, ut possent torqueri cum priorum colorum subtegmine."
,"4":"Fasciasque umerales fecerunt ei, cum quibus in utroque latere summitatum suarum copulabatur,"
,"5":"et balteum, quo constringebatur ephod, eiusdem operis et unum cum eo ex auro, et hyacintho et purpura coccoque et bysso retorta, sicut praeceperat Dominus Moysi."
,"6":"Paraverunt et duos lapides onychinos, inclusos texturis aureis et sculptos arte gemmaria nominibus filiorum Israel;"
,"7":"posueruntque eos in fasciis umeralibus ephod, lapides memorialis filiorum Israel, sicut praeceperat Dominus Moysi."
,"8":"Fecerunt et pectorale opere polymito iuxta opus ephod ex auro, hyacintho, purpura coccoque et bysso retorta,"
,"9":"quadrangulum duplex mensurae palmi."
,"10":"Et posuerunt in eo gemmarum ordines quattuor: in primo versu erat sardius, topazius, smaragdus;"
,"11":"in secundo carbunculus, sapphirus et iaspis;"
,"12":"in tertio hyacinthus, achates et amethystus;"
,"13":"in quarto chrysolithus, onychinus et beryllus: inclusi textura aurea per ordines suos."
,"14":"Ipsique lapides duodecim sculpti erant nominibus duodecim tribuum Israel, singuli per nomina singulorum."
,"15":"Fecerunt in pectorali catenulas quasi funiculos opus tortile de auro purissimo"
,"16":"et duos margines aureos totidemque anulos aureos. Porro duos anulos posuerunt in utraque summitate pectoralis;"
,"17":"duos funiculos aureos inseruerunt anulis, qui in pectoralis angulis eminebant."
,"18":"Duas summitates amborum funiculorum colligaverunt duobus marginibus in fasciis umeralibus ephod in parte eius anteriore."
,"19":"Et fecerunt duos anulos aureos et posuerunt super duas summitates pectoralis in eius margine interiore contra ephod, sicut praecepit Dominus Moysi."
,"20":"Feceruntque duos anulos aureos, quos posuerunt in duabus fasciis umeralibus ephod deorsum in latere eius anteriore secus iuncturam eius super balteum ephod."
,"21":"Et strinxerunt pectorale anulis eius ad anulos ephod vitta hyacinthina, ut esset super balteum ephod, ne amoveretur ab ephod, sicut praecepit Dominus Moysi."
,"22":"Fecerunt quoque pallium ephod opere textili totum hyacinthinum"
,"23":"et capitium in medio eius supra oramque per gyrum sicut in capitio loricae;"
,"24":"deorsum autem ad pedes mala punica ex hyacintho, purpura, cocco ac bysso retorta"
,"25":"et tintinnabula de auro purissimo, quae posuerunt inter malogranata in inferiore parte pallii per gyrum,"
,"26":"ut sit tintinnabulum inter singula mala punica, quibus ornatus incedebat pontifex, quando ministerio fungebatur, sicut praeceperat Dominus Moysi."
,"27":"Fecerunt et tunicas byssinas opere textili Aaron et filiis eius"
,"28":"et tiaram et ornatum mitrarum ex bysso, feminalia quoque linea ex bysso retorta,"
,"29":"cingulum vero de bysso retorta, hyacintho, purpura ac cocco, arte plumaria, sicut praeceperat Dominus Moysi."
,"30":"Fecerunt et laminam diadema sanctitatis de auro purissimo; scripseruntque in ea opere caelatoris: ' Sanctum Domino ';"
,"31":"et strinxerunt eam desuper cum tiara vitta hyacinthina, sicut praeceperat Dominus Moysi."
,"32":"Perfectum est igitur omne opus habitaculi et tabernaculi conventus; feceruntque filii Israel cuncta, quae praeceperat Dominus Moysi: sic fecerunt."
,"33":"Et obtulerunt habitaculum et tabernaculum et universam supellectilem, fibulas, tabulas, vectes, columnas ac bases,"
,"34":"opertorium de pellibus arietum rubricatis et operimentum de pellibus delphini, velum,"
,"35":"arcam testimonii, vectes, propitiatorium,"
,"36":"mensam cum vasis suis et propositionis panibus,"
,"37":"candelabrum ex auro puro, lucernas in ordine earum et utensilia earum cum oleo candelabri,"
,"38":"altare aureum et unguentum et thymiama ex aromatibus et velum in introitu tabernaculi,"
,"39":"altare aeneum, craticulam aeneam, vectes et vasa eius omnia, labrum cum basi sua,"
,"40":"tentoria atrii et columnas cum basibus suis, velum in introitu atrii funiculosque illius et paxillos. Nihil ex vasis defuit, quae in ministerium habitaculi in tabernaculo conventus iussa sunt fieri."
,"41":"Vestes quoque textas, quibus sacerdotes utuntur in sanctuario, et vestes sacras Aaron sacerdotis et vestes filiorum eius"
,"42":"obtulerunt filii Israel, sicut praeceperat Dominus Moysi."
,"43":"Quae postquam Moyses cuncta vidit completa, benedixit eis."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Mense pri mo, die prima mensis eriges habitaculum, tabernaculum conventus,"
,"3":"et pones in eo arcam testimonii, abscondes illam velo;"
,"4":"et, illata mensa, pones super eam, quae rite praecepta sunt. Candelabrum stabit cum lucernis suis"
,"5":"et altare aureum, in quo adoletur incensum, coram arca testimonii. Velum in introitu habitaculi pones,"
,"6":"et ante tabernaculum conventus altare holocausti,"
,"7":"et labrum inter altare et tabernaculum conventus et implebis illud aqua."
,"8":"Circumdabisque atrium tentoriis et pones velum in porta eius."
,"9":"Et, assumpto unctionis oleo, unges habitaculum et omnia, quae in eo sunt, et consecrabis illud cum vasis suis, et erit sanctum."
,"10":"Unges quoque altare holocausti et omnia vasa eius et consecrabis altare, et erit sanctum sanctorum."
,"11":"Et unges labrum cum basi sua et consecrabis illud."
,"12":"Applicabisque Aaron et filios eius ad fores tabernaculi conventus; et lotos aqua"
,"13":"indues Aaron sanctis vestibus, unges et consecrabis eum, ut mihi sacerdotio fungatur;"
,"14":"filios eius applicabis et vesties eos tunicis"
,"15":"et unges eos, sicut unxisti patrem eorum, ut mihi sacerdotio fungantur, et unctio eorum erit eis in sacerdotium sempiternum in generationibus eorum '."
,"16":"Fecitque Moyses omnia, quae praeceperat ei Dominus: sic fecit."
,"17":"Igitur mense primo anni secundi, prima die mensis collocatum est habitaculum."
,"18":"Erexitque Moyses illud et posuit bases ac tabulas et vectes statuitque columnas"
,"19":"et expandit tentorium super habitaculum, imposito desuper operimento, sicut Dominus imperaverat Moysi."
,"20":"Sumpsit et posuit testimonium in arca et, subditis infra vectibus, posuit propitiatorium desuper."
,"21":"Cumque intulisset arcam in habitaculum, appendit ante eam velum, sicut iusserat Dominus Moysi."
,"22":"Posuit et mensam in tabernaculo conventus ad plagam septentrionalem extra velum,"
,"23":"ordinatis coram propositionis panibus, sicut praeceperat Dominus Moysi."
,"24":"Posuit et candelabrum in tabernaculo conventus e regione mensae in parte australi,"
,"25":"locatis per ordinem lucernis, sicut praeceperat Dominus Moysi."
,"26":"Posuit et altare aureum in tabernaculo conventus coram propitiatorio"
,"27":"et adolevit super eo incensum aromatum, sicut iusserat Dominus Moysi."
,"28":"Posuit et velum in introitu habitaculi"
,"29":"et altare holocausti in vestibulo habitaculi, tabernaculi conventus, offerens in eo holocaustum et sacrificium, sicut Dominus imperaverat Moysi."
,"30":"Labrum quoque statuit inter tabernaculum conventus et altare implens illud aqua;"
,"31":"laveruntque Moyses et Aaron ac filii eius manus suas et pedes,"
,"32":"cum ingrederentur tabernaculum conventus et accederent ad altare, sicut praeceperat Dominus Moysi."
,"33":"Erexit et atrium per gyrum habitaculi et altaris, ducto in introitu eius velo. Sic complevit opus."
,"34":"Et operuit nubes tabernaculum conventus, et gloria Domini implevit habitaculum."
,"35":"Nec poterat Moyses ingredi tabernaculum conventus, quia habitavit nubes super illud, et gloria Domini replevit habitaculum."
,"36":"Si quando nubes de tabernaculo ascendebat, proficiscebantur filii Israel in omnibus stationibus suis;"
,"37":"si autem non ascendebat nubes, non proficiscebantur usque in diem, quo levabatur."
,"38":"Nubes quippe Domini incubabat per diem habitaculo, et ignis in nocte, ante oculos universae domus Israel per cunctas mansiones suas."
}`)

}
func LA_NVBSE_LoadVPGNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"In principio creavit Deus caelum et terram."
,"2":"Terra autem erat inanis et vacua, et tenebrae super faciem abyssi, et spiritus Dei ferebatur super aquas."
,"3":"Dixitque Deus: 'Fiat lux'. Et facta est lux."
,"4":"Et vidit Deus lucem quod esset bona et divisit Deus lucem ac tenebras."
,"5":"Appellavitque Deus lucem Diem et tenebras Noctem. Factumque est vespere et mane, dies unus."
,"6":"Dixit quoque Deus: 'Fiat firmamentum in medio aquarum et dividat aquas ab aquis'."
,"7":"Et fecit Deus firmamentum divisitque aquas, quae erant sub firmamento, ab his, quae erant super firmamentum. Et factum est ita."
,"8":"Vocavitque Deus firmamentum Caelum. Et factum est vespere et mane, dies secundus."
,"9":"Dixit vero Deus: 'Congregentur aquae, quae sub caelo sunt, in locum unum, et appareat arida'. Factumque est ita."
,"10":"Et vocavit Deus aridam Terram congregationesque aquarum appellavit Maria. Et vidit Deus quod esset bonum."
,"11":"Et ait Deus: 'Germinet terra herbam virentem et herbam facientem semen et lignum pomiferum faciens fructum iuxta genus suum, cuius semen in semetipso sit super terram'. Et factum est ita."
,"12":"Et protulit terra herbam virentem et herbam afferentem semen iuxta genus suum lignumque faciens fructum, qui habet in semetipso sementem secundum speciem suam. Et vidit Deus quod esset bonum."
,"13":"Et factum est vespere et mane, dies tertius."
,"14":"Dixit autem Deus: 'Fiant luminaria in firmamento caeli, ut dividant diem ac noctem et sint in signa et tempora et dies et annos,"
,"15":"ut luceant in firmamento caeli et illuminent terram. Et factum est ita."
,"16":"Fecitque Deus duo magna luminaria: luminare maius, ut praeesset diei, et luminare minus, ut praeesset nocti, et stellas."
,"17":"Et posuit eas Deus in firmamento caeli, ut lucerent super terram"
,"18":"et praeessent diei ac nocti et dividerent lucem ac tenebras. Et vidit Deus quod esset bonum."
,"19":"Et factum est vespere et mane, dies quartus."
,"20":"Dixit etiam Deus: 'Pullulent aquae reptile animae viventis, et volatile volet super terram sub firmamento caeli'."
,"21":"Creavitque Deus cete grandia et omnem animam viventem atque motabilem, quam pullulant aquae secundum species suas, et omne volatile secundum genus suum. Et vidit Deus quod esset bonum;"
,"22":"benedixitque eis Deus dicens: 'Crescite et multiplicamini et replete aquas maris, avesque multiplicentur super terram '."
,"23":"Et factum est vespere et mane, dies quintus."
,"24":"Dixit quoque Deus: 'Producat terra animam viventem in genere suo, iumenta et reptilia et bestias terrae secundum species suas'. Factumque est ita."
,"25":"Et fecit Deus bestias terrae iuxta species suas et iumenta secundum species suas et omne reptile terrae in genere suo. Et vidit Deus quod esset bonum."
,"26":"Et ait Deus: 'Faciamus hominem ad imaginem et similitudinem nostram; et praesint piscibus maris et volatilibus caeli et bestiis universaeque terrae omnique reptili, quod movetur in terra'."
,"27":"Et creavit Deus hominem ad imaginem suam; ad imaginem Dei creavit illum; masculum et feminam creavit eos. "
,"28":"Benedixitque illis Deus et ait illis Deus: 'Crescite et multiplicamini et replete terram et subicite eam et dominamini piscibus maris et volatilibus caeli et universis animantibus, quae moventur super terram'."
,"29":"Dixitque Deus: 'Ecce dedi vobis omnem herbam afferentem semen super terram et universa ligna, quae habent in semetipsis fructum ligni portantem sementem, ut sint vobis in escam"
,"30":"et cunctis animantibus terrae omnique volucri caeli et universis, quae moventur in terra et in quibus est anima vivens, omnem herbam virentem ad vescendum'. Et factum est ita."
,"31":"Viditque Deus cuncta, quae fecit, et ecce erant valde bona. Et factum est vespere et mane, dies sextus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Igitur perfecti sunt caeli et terra et omnis exercitus eorum."
,"2":"Complevitque Deus die septimo opus suum, quod fecerat, et requievit die septimo ab universo opere, quod patrarat."
,"3":"Et benedixit Deus diei septimo et sanctificavit illum, quia in ipso requieverat ab omni opere suo, quod creavit Deus, ut faceret."
,"4":"Istae sunt generationes caeli et terrae, quando creata sunt. In die quo fecit Dominus Deus terram et caelum "
,"5":"omne virgultum agri, antequam oriretur in terra, omnisque herba regionis, priusquam germinaret; non enim pluerat Dominus Deus super terram, et homo non erat, qui operaretur humum,"
,"6":"sed fons ascendebat e terra irrigans universam superficiem terrae"
,"7":"tunc formavit Dominus Deus hominem pulverem de humo et inspiravit in nares eius spiraculum vitae, et factus est homo in animam viventem."
,"8":"Et plantavit Dominus Deus paradisum in Eden ad orientem, in quo posuit hominem, quem formaverat."
,"9":"Produxitque Dominus Deus de humo omne lignum pulchrum visu et ad vescendum suave, lignum etiam vitae in medio paradisi lignumque scientiae boni et mali."
,"10":"Et fluvius egrediebatur ex Eden ad irrigandum paradisum, qui inde dividitur in quattuor capita."
,"11":"Nomen uni Phison: ipse est, qui circuit omnem terram Hevila, ubi est aurum;"
,"12":"et aurum terrae illius optimum est; ibi invenitur bdellium et lapis onychinus."
,"13":"Et nomen fluvio secundo Geon: ipse est, qui circuit omnem terram Aethiopiae."
,"14":"Nomen vero fluminis tertii Tigris: ipse vadit ad orientem Assyriae. Fluvius autem quartus ipse est Euphrates."
,"15":"Tulit ergo Dominus Deus hominem et posuit eum in paradiso Eden, ut operaretur et custodiret illum;"
,"16":"praecepitque Dominus Deus homini dicens: 'Ex omni ligno paradisi comede;"
,"17":"de ligno autem scientiae boni et mali ne comedas; in quocumque enim die comederis ex eo, morte morieris'."
,"18":"Dixit quoque Dominus Deus: 'Non est bonum esse hominem solum; faciam ei adiutorium simile sui'."
,"19":"Formatis igitur Dominus Deus de humo cunctis animantibus agri et universis volatilibus caeli, adduxit ea ad Adam, ut videret quid vocaret ea; omne enim, quod vocavit Adam animae viventis, ipsum est nomen eius."
,"20":"Appellavitque Adam nominibus suis cuncta pecora et universa volatilia caeli et omnes bestias agri; Adae vero non inveniebatur adiutor similis eius."
,"21":"Immisit ergo Dominus Deus soporem in Adam. Cumque obdormisset, tulit unam de costis eius et replevit carnem pro ea;"
,"22":"et aedificavit Dominus Deus costam, quam tulerat de Adam, in mulierem et adduxit eam ad Adam."
,"23":"Dixitque Adam: 'Haec nunc os ex ossibus meis,et caro de carne mea!,Haec vocabitur Virago, quoniam de viro sumpta est haec'."
,"24":"Quam ob rem relinquet vir patrem suum et matrem et adhaerebit uxori suae; et erunt in carnem unam."
,"25":"Erant autem uterque nudi, Adam scilicet et uxor eius, et non erubescebant."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Et serpens erat callidior cunctis animantibus agri, quae fecerat Dominus Deus. Qui dixit ad mulierem: 'Verene praecepit vobis Deus, ut non comederetis de omni ligno paradisi?'."
,"2":"Cui respondit mulier: 'De fructu lignorum, quae sunt in paradiso, vescimur;"
,"3":"de fructu vero ligni, quod est in medio paradisi, praecepit nobis Deus, ne comederemus et ne tangeremus illud, ne moriamur'."
,"4":"Dixit autem serpens ad mulierem: 'Nequaquam morte moriemini!"
,"5":"Scit enim Deus quod in quocumque die comederitis ex eo, aperientur oculi vestri, et eritis sicut Deus scientes bonum et malum'."
,"6":"Vidit igitur mulier quod bonum esset lignum ad vescendum et pulchrum oculis et desiderabile esset lignum ad intellegendum; et tulit de fructu illius et comedit deditque etiam viro suo secum, qui comedit."
,"7":"Et aperti sunt oculi amborum. Cumque cognovissent esse se nudos, consuerunt folia ficus et fecerunt sibi perizomata."
,"8":"Et cum audissent vocem Domini Dei deambulantis in paradiso ad auram post meridiem, abscondit se Adam et uxor eius a facie Domini Dei in medio ligni paradisi."
,"9":"Vocavitque Dominus Deus Adam et dixit ei: 'Ubi es?'."
,"10":"Qui ait: 'Vocem tuam audivi in paradiso et timui eo quod nudus essem et abscondi me'."
,"11":"Cui dixit: 'Quis enim indicavit tibi quod nudus esses, nisi quod ex ligno, de quo tibi praeceperam, ne comederes, comedisti?'."
,"12":"Dixitque Adam: 'Mulier, quam dedisti sociam mihi, ipsa dedit mihi de ligno, et comedi'."
,"13":"Et dixit Dominus Deus ad mulierem: 'Quid hoc fecisti?'. Quae respondit: 'Serpens decepit me, et comedi'."
,"14":"Et ait Dominus Deus ad serpentem: 'Quia fecisti hoc, maledictus es,inter omnia pecora,et omnes bestias agri!,Super pectus tuum gradieris,et pulverem comedes cunctis,diebus vitae tuae."
,"15":"Inimicitias ponam inter te et mulierem,et semen tuum et semen illius; ipsum conteret caput tuum, et tu conteres calcaneum eius'."
,"16":"Mulieri dixit: 'Multiplicabo aerumnas tuas,et conceptus tuos: in dolore paries filios, et ad virum tuum erit appetitus tuus, ipse autem dominabitur tui'."
,"17":"Adae vero dixit: 'Quia audisti vocem uxoris tuae et comedisti de ligno, ex quo praeceperam tibi, ne comederes, maledicta humus propter te!,In laboribus comedes ex ea,cunctis diebus vitae tuae."
,"18":"Spinas et tribulos germinabit tibi, et comedes herbas terrae;"
,"19":"in sudore vultus tui vesceris pane, donec revertaris ad humum, de qua sumptus es, quia pulvis es et in pulverem reverteris'."
,"20":"Et vocavit Adam nomen uxoris suae Eva, eo quod mater esset cunctorum viventium."
,"21":"Fecit quoque Dominus Deus Adae et uxori eius tunicas pelliceas et induit eos."
,"22":"Et ait Dominus Deus: 'Ecce homo factus est quasi unus ex nobis, ut sciat bonum et malum; nunc ergo, ne mittat manum suam et sumat etiam de ligno vitae et comedat et vivat in aeternum!'."
,"23":"Emisit eum Dominus Deus de paradiso Eden, ut operaretur humum, de qua sumptus est."
,"24":"Eiecitque hominem et collocavit ad orientem paradisi Eden cherubim et flammeum gladium atque versatilem ad custodiendam viam ligni vitae."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Adam vero cognovit Evam uxo rem suam, quae concepit et peperit Cain dicens: 'Acquisivi virum per Dominum'."
,"2":"Rursusque peperit fratrem eius Abel. Et fuit Abel pastor ovium et Cain agricola."
,"3":"Factum est autem post aliquot dies ut offerret Cain de fructibus agri munus Domino."
,"4":"Abel quoque obtulit de primogenitis gregis sui et de adipibus eorum. Et respexit Dominus ad Abel et ad munus eius,"
,"5":"ad Cain vero et ad munus illius non respexit. Iratusque est Cain vehementer, et concidit vultus eius."
,"6":"Dixitque Dominus ad eum: 'Quare iratus es, et cur concidit facies tua?"
,"7":"Nonne si bene egeris, vultum attolles? Sin autem male, in foribus peccatum insidiabitur, et ad te erit appetitus eius, tu autem dominaberis illius'."
,"8":"Dixitque Cain ad Abel fratrem suum: 'Egrediamur foras'. Cumque essent in agro, consurrexit Cain adversus Abel fratrem suum et interfecit eum."
,"9":"Et ait Dominus ad Cain: 'Ubi est Abel frater tuus?'. Qui respondit: 'Nescio. Num custos fratris mei sum ego?'."
,"10":"Dixitque ad eum: 'Quid fecisti? Vox sanguinis fratris tui clamat ad me de agro."
,"11":"Nunc igitur maledictus eris procul ab agro, qui aperuit os suum et suscepit sanguinem fratris tui de manu tua!"
,"12":"Cum operatus fueris eum, amplius non dabit tibi fructus suos; vagus et profugus eris super terram'."
,"13":"Dixitque Cain ad Dominum: 'Maior est poena mea quam ut portem eam."
,"14":"Ecce eicis me hodie a facie agri, et a facie tua abscondar et ero vagus et profugus in terra; omnis igitur, qui invenerit me, occidet me'."
,"15":"Dixitque ei Dominus: 'Nequaquam ita fiet, sed omnis qui occiderit Cain, septuplum punietur!'. Posuitque Dominus Cain signum, ut non eum interficeret omnis qui invenisset eum."
,"16":"Egressusque Cain a facie Domini habitavit in terra Nod ad orientalem plagam Eden."
,"17":"Cognovit autem Cain uxorem suam, quae concepit et peperit Henoch. Et aedificavit civitatem vocavitque nomen eius ex nomine filii sui Henoch."
,"18":"Porro Henoch genuit Irad, et Irad genuit Maviael, et Maviael genuit Mathusael, et Mathusael genuit Lamech."
,"19":"Qui accepit uxores duas: nomen uni Ada et nomen alteri Sella."
,"20":"Genuitque Ada Iabel, qui fuit pater habitantium in tentoriis atque pastorum."
,"21":"Et nomen fratris eius Iubal; ipse fuit pater omnium canentium cithara et organo."
,"22":"Sella quoque genuit Tubalcain, qui fuit malleator et faber in cuncta opera aeris et ferri. Soror vero Tubalcain Noema."
,"23":"Dixitque Lamech uxoribus suis: 'Ada et Sella, audite vocem meam; uxores Lamech, auscultate sermonem meum: occidi virum pro vulnere meo,et adulescentulum pro livore meo; "
,"24":"septuplum ultio dabitur de Cain, de Lamech vero septuagies septies'."
,"25":"Cognovit quoque Adam uxorem suam, et peperit filium vocavitque nomen eius Seth dicens: 'Posuit mihi Deus semen aliud pro Abel, quem occidit Cain'."
,"26":"Sed et Seth natus est filius, quem vocavit Enos. Tunc coeperunt invocare nomen Domini."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Hic est liber generationis Adam. In die qua creavit Deus homi nem, ad similitudinem Dei fecit illum."
,"2":"Masculum et feminam creavit eos et benedixit illis; et vocavit nomen eorum Adam in die, quo creati sunt."
,"3":"Vixit autem Adam centum triginta annis et genuit ad similitudinem et imaginem suam vocavitque nomen eius Seth."
,"4":"Et facti sunt dies Adam, postquam genuit Seth, octingenti anni, genuitque filios et filias."
,"5":"Et factum est omne tempus, quod vixit Adam, anni nongenti triginta, et mortuus est."
,"6":"Vixit quoque Seth centum quinque annos et genuit Enos."
,"7":"Vixitque Seth, postquam genuit Enos, octingentis septem annis genuitque filios et filias."
,"8":"Et facti sunt omnes dies Seth nongentorum duodecim annorum, et mortuus est."
,"9":"Vixit vero Enos nonaginta annis et genuit Cainan."
,"10":"Et vixit Enos, postquam genuit Cainan, octingentis quindecim annis et genuit filios et filias."
,"11":"Factique sunt omnes dies Enos nongentorum quinque annorum, et mortuus est."
,"12":"Vixit quoque Cainan septuaginta annis et genuit Malaleel."
,"13":"Et vixit Cainan, postquam genuit Malaleel, octingentos quadraginta annos genuitque filios et filias."
,"14":"Et facti sunt omnes dies Cainan nongenti decem anni, et mortuus est."
,"15":"Vixit autem Malaleel sexaginta quinque annos et genuit Iared."
,"16":"Et vixit Malaleel, postquam genuit Iared, octingentis triginta annis et genuit filios et filias."
,"17":"Et facti sunt omnes dies Malaleel octingenti nonaginta quinque anni, et mortuus est."
,"18":"Vixitque Iared centum sexaginta duobus annis et genuit Henoch."
,"19":"Et vixit Iared, postquam genuit Henoch, octingentos annos et genuit filios et filias."
,"20":"Et facti sunt omnes dies Iared nongenti sexaginta duo anni, et mortuus est."
,"21":"Porro Henoch vixit sexaginta quinque annis et genuit Mathusalam."
,"22":"Et ambulavit Henoch cum Deo, postquam genuit Mathusalam, trecentis annis et genuit filios et filias."
,"23":"Et facti sunt omnes dies Henoch trecenti sexaginta quinque anni,"
,"24":"ambulavitque cum Deo et non apparuit, quia tulit eum Deus."
,"25":"Vixit quoque Mathusala centum octoginta septem annos et genuit Lamech."
,"26":"Et vixit Mathusala, postquam genuit Lamech, septingentos octoginta duos annos et genuit filios et filias."
,"27":"Et facti sunt omnes dies Mathusalae nongenti sexaginta novem anni, et mortuus est."
,"28":"Vixit autem Lamech centum octoginta duobus annis et genuit filium"
,"29":"vocavitque nomen eius Noe dicens: 'Iste consolabitur nos ab operibus nostris et labore manuum nostrarum in agro, cui maledixit Dominus'."
,"30":"Vixitque Lamech, postquam genuit Noe, quingentos nonaginta quinque annos et genuit filios et filias."
,"31":"Et facti sunt omnes dies Lamech septingenti septuaginta septem anni, et mortuus est."
,"32":"Noe vero, cum quingentorum esset annorum, genuit Sem, Cham et Iapheth."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Cumque coepissent homines multiplicari super terram et fi lias procreassent,"
,"2":"videntes filii Dei filias hominum quod essent pulchrae, acceperunt sibi uxores ex omnibus, quas elegerant."
,"3":"Dixitque Deus: 'Non permanebit spiritus meus in homine in aeternum, quia caro est; eruntque dies illius centum viginti annorum'."
,"4":"Gigantes erant super terram in diebus illis et etiam postquam ingressi sunt filii Dei ad filias hominum, illaeque eis genuerunt: isti sunt potentes a saeculo viri famosi."
,"5":"Videns autem Dominus quod multa malitia hominum esset in terra, et cuncta cogitatio cordis eorum non intenta esset nisi ad malum omni tempore,"
,"6":"paenituit Dominum quod hominem fecisset in terra. Et tactus dolore cordis intrinsecus:"
,"7":"'Delebo, inquit, hominem, quem creavi, a facie terrae, ab homine usque ad pecus, usque ad reptile et usque ad volucres caeli; paenitet enim me fecisse eos'."
,"8":"Noe vero invenit gratiam coram Domino."
,"9":"Hae sunt generationes Noe: Noe vir iustus atque perfectus fuit in generatione sua; cum Deo ambulavit."
,"10":"Et genuit tres filios: Sem, Cham et Iapheth."
,"11":"Corrupta est autem terra coram Deo et repleta est iniquitate."
,"12":"Cumque vidisset Deus terram esse corruptam omnis quippe caro corruperat viam suam super terram"
,"13":"dixit ad Noe: 'Finis universae carnis venit coram me; repleta est enim terra iniquitate a facie eorum, et ecce ego disperdam eos de terra."
,"14":"Fac tibi arcam de lignis cupressinis; mansiunculas in arca facies et bitumine linies eam intrinsecus et extrinsecus."
,"15":"Et sic facies eam: trecentorum cubitorum erit longitudo arcae, quinquaginta cubitorum latitudo et triginta cubitorum altitudo illius."
,"16":"Fenestram in arca facies et cubito consummabis summitatem eius. Ostium autem arcae pones ex latere; tabulatum inferius, medium et superius facies in ea."
,"17":"Ecce ego adducam diluvii aquas super terram, ut interficiam omnem carnem, in qua spiritus vitae est subter caelum: universa, quae in terra sunt, consumentur."
,"18":"Ponamque foedus meum tecum; et ingredieris arcam tu et filii tui, uxor tua et uxores filiorum tuorum tecum."
,"19":"Et ex cunctis animantibus universae carnis bina induces in arcam, ut vivant tecum, masculini sexus et feminini."
,"20":"De volucribus iuxta genus suum et de iumentis in genere suo et ex omni reptili terrae secundum genus suum: bina de omnibus ingredientur ad te, ut possint vivere."
,"21":"Tu autem tolle tecum ex omnibus escis, quae mandi possunt, et comportabis apud te; et erunt tam tibi quam illis in cibum'."
,"22":"Fecit ergo Noe omnia, quae praeceperat illi Deus; sic fecit."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Dixitque Dominus ad Noe: 'Ingredere tu et omnis domus tua arcam; te enim vidi iustum coram me in generatione hac."
,"2":"Ex omnibus pecoribus mundis tolle septena septena, masculum et feminam; de pecoribus vero non mundis duo duo, masculum et feminam."
,"3":"Sed et de volatilibus caeli septena septena, masculum et feminam, ut salvetur semen super faciem universae terrae."
,"4":"Adhuc enim et post dies septem ego pluam super terram quadraginta diebus et quadraginta noctibus et delebo omnem substantiam, quam feci, de superficie terrae'."
,"5":"Fecit ergo Noe omnia, quae mandaverat ei Dominus."
,"6":"Eratque Noe sescentorum annorum, quando diluvii aquae inundaverunt super terram."
,"7":"Et ingressus est Noe et filii eius, uxor eius et uxores filiorum eius cum eo in arcam propter aquas diluvii."
,"8":"De pecoribus mundis et immundis et de volucribus et ex omni, quod movetur super terram,"
,"9":"duo et duo ingressa sunt ad Noe in arcam, masculus et femina, sicut praeceperat Deus Noe."
,"10":"Cumque transissent septem dies, aquae diluvii inundaverunt super terram."
,"11":"Anno sescentesimo vitae Noe, mense secundo, septimo decimo die mensis rupti sunt omnes fontes abyssi magnae, et cataractae caeli apertae sunt;"
,"12":"et facta est pluvia super terram quadraginta diebus et quadraginta noctibus."
,"13":"In articulo diei illius ingressus est Noe et Sem et Cham et Iapheth filii eius, uxor illius et tres uxores filiorum eius cum eis in arcam."
,"14":"Ipsi et omne animal secundum genus suum, universaque iumenta in genere suo, et omne reptile, quod movetur super terram in genere suo, cunctumque volatile secundum genus suum, universae aves omnesque volucres"
,"15":"ingressae sunt ad Noe in arcam, bina et bina ex omni carne, in qua erat spiritus vitae."
,"16":"Et quae ingressa sunt, masculus et femina ex omni carne introierunt, sicut praeceperat ei Deus; et inclusit eum Dominus de foris."
,"17":"Factumque est diluvium quadraginta diebus super terram, et multiplicatae sunt aquae et elevaverunt arcam in sublime a terra."
,"18":"Vehementer enim inundaverunt et omnia repleverunt in superficie terrae; porro arca ferebatur super aquas."
,"19":"Et aquae praevaluerunt nimis super terram, opertique sunt omnes montes excelsi sub universo caelo."
,"20":"Quindecim cubitis altior fuit aqua super montes, quos operuerat."
,"21":"Consumptaque est omnis caro, quae movebatur super terram, volucrum, pecorum, bestiarum omniumque reptilium, quae reptant super terram, et universi homines:"
,"22":"cuncta, in quibus spiraculum vitae in terra, mortua sunt."
,"23":"Et delevit omnem substantiam, quae erat super terram, ab homine usque ad pecus, usque ad reptile et usque ad volucres caeli; et deleta sunt de terra. Remansit autem solus Noe et qui cum eo erant in arca."
,"24":"Obtinueruntque aquae terram centum quinquaginta diebus."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Recordatus autem Deus Noe cunctorumque animantium et omnium iumentorum, quae erant cum eo in arca, adduxit spiritum super terram, et imminutae sunt aquae."
,"2":"Et clausi sunt fontes abyssi et cataractae caeli, et prohibitae sunt pluviae de caelo."
,"3":"Reversaeque sunt aquae de terra euntes et redeuntes et coeperunt minui post centum quinquaginta dies."
,"4":"Requievitque arca mense septimo, decima septima die mensis super montes Ararat."
,"5":"At vero aquae ibant et decrescebant usque ad decimum mensem; decimo enim mense, prima die mensis, apparuerunt cacumina montium."
,"6":"Cumque transissent quadraginta dies, aperiens Noe fenestram arcae, quam fecerat, dimisit corvum;"
,"7":"qui egrediebatur exiens et rediens, donec siccarentur aquae super terram."
,"8":"Emisit quoque columbam a se, ut videret si iam cessassent aquae super faciem terrae."
,"9":"Quae, cum non invenisset, ubi requiesceret pes eius, reversa est ad eum in arcam; aquae enim erant super universam terram. Extenditque manum et apprehensam intulit in arcam."
,"10":"Exspectatis autem ultra septem diebus aliis, rursum dimisit columbam ex arca."
,"11":"At illa venit ad eum ad vesperam portans ramum olivae virentibus foliis in ore suo. Intellexit ergo Noe quod cessassent aquae super terram."
,"12":"Exspectavitque nihilominus septem alios dies; et emisit columbam, quae non est reversa ultra ad eum."
,"13":"Igitur sescentesimo primo anno, primo mense, prima die mensis, siccatae sunt aquae super terram; et aperiens Noe tectum arcae, et ecce aspexit viditque quod exsiccata erat superficies terrae."
,"14":"Mense secundo, septima et vicesima die mensis, arefacta est terra."
,"15":"Locutus est autem Deus ad Noe dicens:"
,"16":"'Egredere de arca tu et uxor tua, filii tui et uxores filiorum tuorum tecum."
,"17":"Cuncta animantia, quae sunt apud te ex omni carne, tam in volatilibus quam in pecoribus et in universis reptilibus, quae reptant super terram, educ tecum, ut pullulent super terram et crescant et multiplicentur super eam'."
,"18":"Egressus est ergo Noe et filii eius, uxor illius et uxores filiorum eius cum eo."
,"19":"Sed et omnia animantia, iumenta, volatilia et reptilia, quae reptant super terram, secundum genus suum egressa sunt de arca."
,"20":"Aedificavit autem Noe altare Domino; et tollens de cunctis pecoribus mundis et volucribus mundis obtulit holocausta super altare."
,"21":"Odoratusque est Dominus odorem suavitatis et locutus est Dominus ad cor suum: 'Nequaquam ultra maledicam terrae propter homines, quia cogitatio humani cordis in malum prona est ab adulescentia sua. Non igitur ultra percutiam omnem animam viventem, sicut feci."
,"22":"Cunctis diebus terrae, sementis et messis, frigus et aestus, aestas et hiems, dies et nox non requiescent'."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Benedixitque Deus Noe et filiis eius et dixit ad eos: 'Crescite et multiplicamini et implete terram."
,"2":"Et terror vester ac tremor sit super cuncta animalia terrae et super omnes volucres caeli cum universis, quae moventur super terram; omnes pisces maris manui vestrae traditi sunt."
,"3":"Omne, quod movetur et vivit, erit vobis in cibum; quasi holera virentia tradidi vobis omnia,"
,"4":"excepto quod carnem cum anima, quae est in sanguine, non comedetis."
,"5":"Sanguinem enim animarum vestrarum requiram de manu cunctarum bestiarum; et de manu hominis, de manu viri fratris eius requiram animam hominis."
,"6":"Quicumque effuderit humanum sanguinem, per hominem fundetur sanguis illius; ad imaginem quippe Dei,factus est homo."
,"7":"Vos autem crescite et multiplicamini et pullulate super terram et dominamini ei'."
,"8":"Haec quoque dixit Deus ad Noe et ad filios eius cum eo:"
,"9":"'Ecce ego statuam pactum meum vobiscum et cum semine vestro post vos"
,"10":"et ad omnem animam viventem, quae est vobiscum tam in volucribus quam in iumentis et in omnibus bestiis terrae, quae sunt vobiscum, cunctis, quae egressa sunt de arca, universis bestiis terrae."
,"11":"Statuam pactum meum vobiscum; et nequaquam ultra interficietur omnis caro aquis diluvii, neque erit deinceps diluvium dissipans terram'."
,"12":"Dixitque Deus: 'Hoc signum foederis, quod do inter me et vos et ad omnem animam viventem, quae est vobiscum, in generationes sempiternas:"
,"13":"arcum meum ponam in nubibus, et erit signum foederis inter me et inter terram."
,"14":"Cumque obduxero nubibus caelum, apparebit arcus meus in nubibus,"
,"15":"et recordabor foederis mei vobiscum et cum omni anima vivente, quae carnem vegetat; et non erunt ultra aquae diluvii ad delendum universam carnem."
,"16":"Eritque arcus in nubibus, et videbo illum et recordabor foederis sempiterni, quod pactum est inter Deum et omnem animam viventem universae carnis, quae est super terram'."
,"17":"Dixitque Deus ad Noe: 'Hoc erit signum foederis, quod constitui inter me et omnem carnem super terram'."
,"18":"Erant ergo filii Noe, qui egressi sunt de arca, Sem, Cham et Iapheth. Porro Cham ipse est pater Chanaan."
,"19":"Tres isti filii sunt Noe, et ab his disseminatum est omne hominum genus super universam terram."
,"20":"Coepitque Noe agricola plantare vineam;"
,"21":"bibensque vinum inebriatus est et nudatus in tabernaculo suo."
,"22":"Quod cum vidisset Cham pater Chanaan, verenda scilicet patris sui esse nudata, nuntiavit duobus fratribus suis foras."
,"23":"At vero Sem et Iapheth pallium imposuerunt umeris suis et incedentes retrorsum operuerunt verecunda patris sui, faciesque eorum aversae erant, et patris virilia non viderunt."
,"24":"Evigilans autem Noe ex vino, cum didicisset, quae fecerat ei filius suus minor,"
,"25":"ait: Maledictus Chanaan!,Servus servorum erit fratribus suis'."
,"26":"Dixitque: Benedictus Dominus Deus Sem!,Sitque Chanaan servus eius."
,"27":"Dilatet Deus Iapheth, et habitet in tabernaculis Sem, sitque Chanaan servus eius'."
,"28":"Vixit autem Noe post diluvium trecentis quinquaginta annis."
,"29":"Et impleti sunt omnes dies eius nongentorum quinquaginta annorum, et mortuus est."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Hae sunt generationes filio rum Noe, Sem, Cham et Ia pheth; natique sunt eis filii post diluvium."
,"2":"Filii Iapheth: Gomer et Magog et Madai et Iavan et Thubal et Mosoch et Thiras."
,"3":"Porro filii Gomer: Aschenez et Riphath et Thogorma."
,"4":"Filii autem Iavan: Elisa et Tharsis, Cetthim et Rodanim."
,"5":"Ab his divisae sunt insulae gentium in regionibus suis, unusquisque secundum linguam suam et familias suas in nationibus suis."
,"6":"Filii autem Cham: Chus et Mesraim et Phut et Chanaan."
,"7":"Filii Chus: Saba et Hevila et Sabatha et Regma et Sabathacha. Filii Regma: Saba et Dedan."
,"8":"Porro Chus genuit Nemrod: ipse coepit esse potens in terra"
,"9":"et erat robustus venator coram Domino. Ob hoc exivit proverbium: 'Quasi Nemrod robustus venator coram Domino'."
,"10":"Fuit autem principium regni eius Babylon et Arach et Achad et Chalanne in terra Sennaar."
,"11":"De terra illa egressus est in Assyriam et aedificavit Nineven et Rohobothir et Chale,"
,"12":"Resen quoque inter Nineven et Chale; haec est civitas magna."
,"13":"At vero Mesraim genuit Ludim et Anamim et Laabim, Nephthuim"
,"14":"et Phetrusim et Chasluim et Caphtorim, de quibus egressi sunt Philisthim."
,"15":"Chanaan autem genuit Sidonem primogenitum suum, Hetthaeum"
,"16":"et Iebusaeum et Amorraeum, Gergesaeum,"
,"17":"Hevaeum et Aracaeum, Sinaeum"
,"18":"et Aradium, Samaraeum et Emathaeum; et post haec disseminati sunt populi Chananaeorum."
,"19":"Factique sunt termini Chanaan venientibus a Sidone Geraram usque Gazam, donec ingrediaris Sodomam et Gomorram et Adamam et Seboim usque Lesa."
,"20":"Hi sunt filii Cham in cognationibus et linguis terrisque et gentibus suis."
,"21":"De Sem quoque nati sunt, patre omnium filiorum Heber, fratre Iapheth maiore."
,"22":"Filii Sem: Elam et Assur et Arphaxad et Lud et Aram."
,"23":"Filii Aram: Us et Hul et Gether et Mes."
,"24":"At vero Arphaxad genuit Sala, de quo ortus est Heber."
,"25":"Natique sunt Heber filii duo: nomen uni Phaleg, eo quod in diebus eius divisa sit terra, et nomen fratris eius Iectan."
,"26":"Qui Iectan genuit Elmodad et Saleph et Asarmoth, Iare"
,"27":"et Adoram et Uzal et Decla"
,"28":"et Ebal et Abimael, Saba"
,"29":"et Ophir et Hevila et Iobab. Omnes isti filii Iectan;"
,"30":"et facta est habitatio eorum de Messa pergentibus usque Sephar montem orientalem."
,"31":"Isti filii Sem secundum cognationes et linguas et regiones in gentibus suis."
,"32":"Hae familiae filiorum Noe iuxta generationes et nationes suas. Ab his divisae sunt gentes in terra post diluvium."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Erat autem universa terra labii unius et sermonum eo rundem."
,"2":"Cumque proficiscerentur de oriente, invenerunt campum in terra Sennaar et habitaverunt in eo."
,"3":"Dixitque alter ad proximum suum: 'Venite, faciamus lateres et coquamus eos igni'. Habueruntque lateres pro saxis et bitumen pro caemento."
,"4":"Et dixerunt: 'Venite, faciamus nobis civitatem et turrim, cuius culmen pertingat ad caelum, et faciamus nobis nomen, ne dividamur super faciem universae terrae'."
,"5":"Descendit autem Dominus, ut videret civitatem et turrim, quam aedificaverunt filii hominum,"
,"6":"et dixit Dominus: 'Ecce unus est populus et unum labium omnibus; et hoc est initium operationis eorum, nec eis erit deinceps difficile, quidquid cogitaverint facere."
,"7":"Venite igitur, descendamus et confundamus ibi linguam eorum, ut non intellegat unusquisque vocem proximi sui'."
,"8":"Atque ita divisit eos Dominus ex illo loco super faciem universae terrae, et cessaverunt aedificare civitatem."
,"9":"Et idcirco vocatum est nomen eius Babel, quia ibi confusum est labium universae terrae, et inde dispersit eos Dominus super faciem universae terrae."
,"10":"Hae sunt generationes Sem. Sem centum erat annorum, quando genuit Arphaxad biennio post diluvium;"
,"11":"vixitque Sem, postquam genuit Arphaxad, quingentos annos et genuit filios et filias."
,"12":"Porro Arphaxad vixit triginta quinque annos et genuit Sala."
,"13":"Vixitque Arphaxad, postquam genuit Sala, quadringentis tribus annis et genuit filios et filias."
,"14":"Sala quoque vixit triginta annis et genuit Heber."
,"15":"Vixitque Sala, postquam genuit Heber, quadringentis tribus annis et genuit filios et filias."
,"16":"Vixit autem Heber triginta quattuor annis et genuit Phaleg."
,"17":"Et vixit Heber, postquam genuit Phaleg, quadringentis triginta annis et genuit filios et filias."
,"18":"Vixit quoque Phaleg triginta annis et genuit Reu."
,"19":"Vixitque Phaleg, postquam genuit Reu, ducentis novem annis et genuit filios et filias."
,"20":"Vixit autem Reu triginta duobus annis et genuit Seruch."
,"21":"Vixitque Reu, postquam genuit Seruch, ducentis septem annis et genuit filios et filias."
,"22":"Vixit vero Seruch triginta annis et genuit Nachor."
,"23":"Vixitque Seruch, postquam genuit Nachor, ducentos annos et genuit filios et filias."
,"24":"Vixit autem Nachor viginti novem annis et genuit Thare."
,"25":"Vixitque Nachor, postquam genuit Thare, centum decem et novem annos et genuit filios et filias."
,"26":"Vixitque Thare septuaginta annis et genuit Abram, Nachor et Aran."
,"27":"Hae sunt autem generationes Thare. Thare genuit Abram, Nachor et Aran. Porro Aran genuit Lot;"
,"28":"mortuusque est Aran ante Thare patrem suum in terra nativitatis suae in Ur Chaldaeorum."
,"29":"Duxerunt autem Abram et Nachor uxores: nomen uxoris Abram Sarai, et nomen uxoris Nachor Melcha, filia Aran patris Melchae et patris Ieschae."
,"30":"Erat autem Sarai sterilis nec habebat liberos."
,"31":"Tulitque Thare Abram filium suum et Lot filium Aran filium filii sui et Sarai nurum suam, uxorem Abram filii sui, et eduxit eos de Ur Chaldaeorum, ut irent in terram Chanaan. Veneruntque usque Charran et habitaverunt ibi."
,"32":"Et facti sunt dies Thare ducentorum quinque annorum, et mortuus est in Charran."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Dixit autem Dominus ad Abram: 'Egredere de terra tua et de cognatione tua,et de domo patris tui,in terram, quam monstrabo tibi."
,"2":"Faciamque te in gentem magnam,et benedicam tibi,et magnificabo nomen tuum, erisque in benedictionem."
,"3":"Benedicam benedicentibus tibi,et maledicentibus tibi maledicam, atque in te benedicentur,universae cognationes terrae!'."
,"4":"Egressus est itaque Abram, sicut praeceperat ei Dominus, et ivit cum eo Lot. Septuaginta quinque annorum erat Abram, cum egrederetur de Charran."
,"5":"Tulitque Sarai uxorem suam et Lot filium fratris sui universamque substantiam, quam acquisiverant, et animas, quas fecerant in Charran, et egressi sunt, ut irent in terram Chanaan; et venerunt in terram Chanaan."
,"6":"Pertransivit Abram terram usque ad locum Sichem, usque ad Quercum Moreh. Chananaeus autem tunc erat in terra."
,"7":"Apparuit autem Dominus Abram et dixit ei: 'Semini tuo dabo terram hanc'. Qui aedificavit ibi altare Domino, qui apparuerat ei."
,"8":"Et inde transgrediens ad montem, qui erat contra orientem Bethel, tetendit ibi tabernaculum suum ab occidente habens Bethel et ab oriente Hai; aedificavit quoque ibi altare Domino et invocavit nomen Domini."
,"9":"Perrexitque Abram de mansione in mansionem usque ad Nageb."
,"10":"Facta est autem fames in terra; descenditque Abram in Aegyptum, ut peregrinaretur ibi; praevaluerat enim fames in terra."
,"11":"Cumque prope esset, ut ingrederetur Aegyptum, dixit Sarai uxori suae: 'Novi quod pulchra sis mulier"
,"12":"et quod, cum viderint te Aegyptii, dicturi sunt: 'Uxor ipsius est'; et interficient me et te reservabunt."
,"13":"Dic ergo, obsecro te, quod soror mea sis, ut bene sit mihi propter te, et vivat anima mea ob gratiam tui'."
,"14":"Cum itaque ingressus esset Abram Aegyptum, viderunt Aegyptii mulierem quod esset pulchra nimis,"
,"15":"et viderunt eam principes pharaonis et laudaverunt eam apud illum; et sublata est mulier in domum pharaonis."
,"16":"Abram vero bene usus est propter illam; fueruntque ei oves et boves et asini et servi et famulae et asinae et cameli."
,"17":"Flagellavit autem Dominus pharaonem plagis maximis et domum eius propter Sarai uxorem Abram."
,"18":"Vocavitque pharao Abram et dixit ei: 'Quidnam est hoc quod fecisti mihi? Quare non indicasti mihi quod uxor tua esset?"
,"19":"Quam ob causam dixisti esse sororem tuam, ut tollerem eam mihi in uxorem? Nunc igitur, ecce coniux tua: accipe eam et vade!'."
,"20":"Praecepitque pharao super Abram viris; et deduxerunt eum et uxorem illius et omnia, quae habebat."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Ascendit ergo Abram de Ae gypto ipse et uxor eius et om nia, quae habebat, et Lot cum eo ad Nageb."
,"2":"Abram autem erat dives valde in pecoribus, argento et auro."
,"3":"Et profectus est de mansione in mansionem a Nageb in Bethel usque ad locum, ubi prius fixerat tabernaculum inter Bethel et Hai,"
,"4":"in loco altaris, quod fecerat prius, et invocavit ibi nomen Domini."
,"5":"Sed et Lot, qui ibat cum Abram, fuerunt greges ovium et armenta et tabernacula;"
,"6":"nec poterat eos capere terra, ut habitarent simul: erat quippe substantia eorum multa, et nequibant habitare communiter."
,"7":"Unde et facta est rixa inter pastores gregum Abram et pastores gregum Lot. Eo autem tempore Chananaeus et Pherezaeus habitabant in illa terra."
,"8":"Dixit ergo Abram ad Lot: 'Ne, quaeso, sit iurgium inter me et te et inter pastores meos et pastores tuos: fratres enim sumus."
,"9":"Nonne universa terra coram te est? Recede a me, obsecro: si ad sinistram ieris, ego dexteram tenebo; si tu dexteram elegeris, ego ad sinistram pergam'."
,"10":"Elevatis itaque Lot oculis, vidit omnem circa regionem Iordanis, quae universa irrigabatur, antequam subverteret Dominus Sodomam et Gomorram, sicut paradisus Domini et sicut Aegyptus usque in Segor."
,"11":"Elegitque sibi Lot omnem regionem circa Iordanem et recessit ad orientem; divisique sunt alterutrum a fratre suo."
,"12":"Abram habitavit in terra Chanaan; Lot vero moratus est in oppidis, quae erant circa Iordanem, et tabernacula movit usque ad Sodomam."
,"13":"Homines autem Sodomitae pessimi erant et peccatores coram Domino nimis."
,"14":"Dixitque Dominus ad Abram, postquam divisus est Lot ab eo: 'Leva oculos tuos et vide a loco, in quo nunc es, ad aquilonem et ad meridiem, ad orientem et ad occidentem:"
,"15":"omnem terram, quam conspicis, tibi dabo et semini tuo usque in sempiternum;"
,"16":"faciamque semen tuum sicut pulverem terrae: si quis potest hominum numerare pulverem terrae, semen quoque tuum numerare poterit."
,"17":"Surge et perambula terram in longitudine et in latitudine sua, quia tibi daturus sum eam'."
,"18":"Movens igitur tabernaculum suum, Abram venit et habitavit iuxta Quercus Mambre, quae sunt in Hebron, aedificavitque ibi altare Domino."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Factum est autem in illo tempore, ut Amraphel rex Sennaar et Arioch rex Ellasar et Chodorlahomor rex Elam et Thadal rex gentium"
,"2":"inirent bellum contra Bara regem Sodomae et contra Bersa regem Gomorrae et contra Sennaab regem Adamae et contra Semeber regem Seboim contraque regem Belae; ipsa est Segor."
,"3":"Omnes hi convenerunt in vallem Siddim, quae nunc est mare Salis."
,"4":"Duodecim annis servierant Chodorlahomor et tertio decimo anno recesserunt ab eo."
,"5":"Igitur anno quarto decimo venit Chodorlahomor et reges, qui erant cum eo, percusseruntque Raphaim in Astharothcarnaim et Zuzim in Ham et Emim in Savecariathaim"
,"6":"et Chorraeos in montibus Seir usque ad Elpharan, quae est in deserto."
,"7":"Reversique sunt et venerunt ad fontem Mesphat; ipsa est Cades. Et percusserunt omnem regionem Amalecitarum et etiam Amorraeum, qui habitabat in Asasonthamar."
,"8":"Et egressi sunt rex Sodomae et rex Gomorrae rexque Adamae et rex Seboim necnon et rex Belae, quae est Segor; et direxerunt contra eos aciem in valle Siddim,"
,"9":"scilicet adversus Chodorlahomor regem Elam et Thadal regem gentium et Amraphel regem Sennaar et Arioch regem Ellasar: quattuor reges adversus quinque."
,"10":"Vallis autem Siddim habebat puteos multos bituminis. Itaque rex Sodomae et Gomorrae terga verterunt cecideruntque illuc; et, qui remanserant, fugerunt ad montem."
,"11":"Tulerunt autem omnem substantiam Sodomae et Gomorrae et universa, quae ad cibum pertinent, et abierunt;"
,"12":"ceperunt et Lot et substantiam eius, filium fratris Abram, qui habitabat in Sodoma."
,"13":"Et ecce unus, qui evaserat, nuntiavit Abram Hebraeo, qui habitabat iuxta Quercus Mambre Amorraei fratris Eschol et fratris Aner; hi enim pepigerant foedus cum Abram."
,"14":"Quod cum audisset Abram, captum videlicet Lot fratrem suum, numeravit expeditos vernaculos suos trecentos decem et octo et persecutus est usque Dan;"
,"15":"et, divisis sociis, irruit super eos nocte percussitque eos et persecutus est eos usque Hoba, quae est ad laevam Damasci;"
,"16":"reduxitque omnem substantiam, necnon et Lot fratrem suum cum substantia illius, mulieres quoque et populum."
,"17":"Egressus est autem rex Sodomae in occursum eius, postquam reversus est a caede Chodorlahomor et regum, qui cum eo erant, in vallem Save, quae est vallis Regis."
,"18":"At vero Melchisedech rex Salem proferens panem et vinum erat enim sacerdos Dei altissimi"
,"19":"benedixit ei et ait: 'Benedictus Abram a Deo excelso, qui creavit caelum et terram "
,"20":"et benedictus Deus excelsus, qui tradidit hostes tuos in manus tuas'. Et dedit ei decimas ex omnibus. "
,"21":"Dixit autem rex Sodomae ad Abram: 'Da mihi animas; substantiam tolle tibi'."
,"22":"Qui respondit ei: 'Levo manum meam ad Dominum, Deum excelsum, creatorem caeli et terrae,"
,"23":"a filo subteminis usque ad corrigiam caligae non accipiam ex omnibus, quae tua sunt, ne dicas: 'Ego ditavi Abram';"
,"24":"exceptis his, quae comederunt iuvenes, et partibus virorum, qui venerunt mecum, Aner, Eschol et Mambre: isti accipient partes suas'."
}`)
	CurrentBook.AddChapter(15, `{
"1":"His itaque transactis, factus est sermo Domini ad Abram per visionem dicens: 'Noli timere, Abram! Ego protector tuus sum, et merces tua magna erit nimis'."
,"2":"Dixitque Abram: 'Domine Deus, quid dabis mihi? Ego vadam absque liberis, et heres domus meae erit Damascenus Eliezer '."
,"3":"Addiditque Abram: 'En mihi non dedisti semen, et ecce vernaculus meus heres meus erit'."
,"4":"Sed ecce sermo Domini factus est ad eum: 'Non erit hic heres tuus, sed qui egredietur de visceribus tuis, ipsum habebis heredem '."
,"5":"Eduxitque eum foras et ait illi: 'Suspice caelum et numera stellas, si potes'. Et dixit ei: 'Sic erit semen tuum'."
,"6":"Credidit Domino, et reputatum est ei ad iustitiam."
,"7":"Dixitque ad eum: 'Ego Dominus, qui eduxi te de Ur Chaldaeorum, ut darem tibi terram istam, et possideres eam'."
,"8":"Et ille ait: 'Domine Deus, unde scire possum quod possessurus sim eam?'."
,"9":"Respondens Dominus: 'Sume, inquit, mihi vitulam triennem et capram trimam et arietem annorum trium, turturem quoque et columbam'."
,"10":"Qui tollens universa haec divisit ea per medium et utrasque partes contra se altrinsecus posuit; aves autem non divisit."
,"11":"Descenderuntque volucres super cadavera, et abigebat eas Abram."
,"12":"Cumque sol occumberet, sopor irruit super Abram, et ecce horror magnus et tenebrosus invasit eum."
,"13":"Dictumque est ad eum: 'Scito praenoscens quod peregrinum futurum sit semen tuum in terra non sua, et subicient eos servituti et affligent quadringentis annis."
,"14":"Verumtamen et gentem, cui servituri sunt, ego iudicabo, et post haec egredientur cum magna substantia."
,"15":"Tu autem ibis ad patres tuos in pace, sepultus in senectute bona."
,"16":"Generatione autem quarta revertentur huc; necdum enim completae sunt iniquitates Amorraeorum usque ad praesens tempus'."
,"17":"Cum ergo occubuisset sol, facta est caligo tenebrosa, et apparuit clibanus fumans et lampas ignis transiens inter divisiones illas."
,"18":"In illo die pepigit Dominus cum Abram foedus dicens: 'Semini tuo dabo terram hanc a fluvio Aegypti usque ad magnum fluvium Euphraten,"
,"19":"Cinaeos et Cenezaeos, Cedmonaeos"
,"20":"et Hetthaeos et Pherezaeos, Raphaim quoque"
,"21":"et Amorraeos et Chananaeos et Gergesaeos et Iebusaeos'."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Sarai autem uxor Abram non genuerat ei liberos; sed habens ancillam Aegyptiam nomine Agar,"
,"2":"dixit marito suo: 'Ecce conclusit me Dominus, ne parerem; ingredere ad ancillam meam, si forte saltem ex illa suscipiam filios'. Cumque ille acquiesceret deprecanti,"
,"3":"tulit Agar Aegyptiam ancillam suam post annos decem quam habitare coeperant in terra Chanaan, et dedit eam viro suo uxorem."
,"4":"Qui ingressus est ad eam. At illa concepisse se videns despexit dominam suam."
,"5":"Dixitque Sarai ad Abram: 'Inique agis contra me; ego dedi ancillam meam in sinum tuum, quae videns quod conceperit, despectui me habet. Iudicet Dominus inter me et te'."
,"6":"Cui respondens Abram: 'Ecce, ait, ancilla tua in manu tua est; utere ea, ut libet'. Affligente igitur eam Sarai, aufugit ab ea."
,"7":"Cumque invenisset illam angelus Domini iuxta fontem aquae in deserto, ad fontem in via Sur,"
,"8":"dixit: ' Agar, ancilla Sarai, unde venis et quo vadis? '. Quae respondit: ' A facie Sarai dominae meae ego fugio '."
,"9":"Dixitque ei angelus Domini: ' Revertere ad dominam tuam et humiliare sub manibus ipsius '."
,"10":"Et dixit ei angelus Domini: ' Multiplicans multiplicabo semen tuum, et non numerabitur prae multitudine '."
,"11":"Et dixit ei angelus Domini: ' Ecce, concepisti et paries filium,vocabisque nomen eius Ismael, eo quod audierit Dominus afflictionem tuam."
,"12":"Hic erit homo onagro similis; manus eius contra omnes, et manus omnium contra eum; et e regione universorum fratrum suorum figet tabernacula '."
,"13":"Vocavit autem nomen Domini, qui loquebatur ad eam: ' Tu Deus, qui vidisti me '. Dixit enim: ' Profecto hic vidi posteriora videntis me '."
,"14":"Propterea appellatur puteus ille Lahairoi (id est Viventis et Videntis me); ipse est inter Cades et Barad."
,"15":"Peperitque Agar Abrae filium; qui vocavit nomen filii sui, quem pepererat Agar, Ismael."
,"16":"Octoginta et sex annorum erat Abram, quando peperit ei Agar Ismaelem."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Postquam Abram nonaginta et novem annorum factus est, apparuit ei Dominus dixitque ad eum: 'Ego Deus omnipotens, ambula coram me et esto perfectus."
,"2":"Ponamque foedus meum inter me et te et multiplicabo te vehementer nimis'."
,"3":"Cecidit Abram pronus in faciem."
,"4":"Dixitque ei Deus: 'Ecce pactum meum tecum. Erisque pater multarum gentium,"
,"5":"nec ultra vocabitur nomen tuum Abram, sed Abraham erit nomen tuum, quia patrem multarum gentium constitui te."
,"6":"Faciamque te crescere vehementissime et ponam te in gentes; regesque ex te egredientur."
,"7":"Et statuam pactum meum inter me et te et inter semen tuum post te in generationibus suis foedere sempiterno, ut sim Deus tuus et seminis tui post te."
,"8":"Daboque tibi et semini tuo post te terram peregrinationis tuae, omnem terram Chanaan in possessionem aeternam; eroque Deus eorum'."
,"9":"Dixit iterum Deus ad Abraham: 'Tu autem pactum meum custodies, et semen tuum post te in generationibus suis."
,"10":"Hoc est pactum meum, quod observabitis, inter me et vos et semen tuum post te. Circumcidetur ex vobis omne masculinum,"
,"11":"et circumcidetis carnem praeputii vestri, ut sit in signum foederis inter me et vos."
,"12":"Infans octo dierum circumcidetur in vobis: omne masculinum in generationibus vestris, tam vernaculus quam empticius ex omnibus alienigenis, quicumque non fuerit de stirpe vestra."
,"13":"Circumcidetur vernaculus et empticius, eritque pactum meum in carne vestra in foedus aeternum."
,"14":"Masculus, cuius praeputii caro circumcisa non fuerit, delebitur anima illa de populo suo; pactum meum irritum fecit'."
,"15":"Dixit quoque Deus ad Abraham: 'Sarai uxorem tuam non vocabis nomen eius Sarai, sed Sara erit nomen eius."
,"16":"Et benedicam ei; et ex illa quoque dabo tibi filium. Benedicturus sum eam, eritque in nationes; reges populorum orientur ex ea'."
,"17":"Cecidit Abraham in faciem suam et risit dicens in corde suo: 'Putasne centenario nascetur filius? Et Sara nonagenaria pariet?'."
,"18":"Dixitque ad Deum: 'Utinam Ismael vivat coram te'."
,"19":"Et ait Deus: 'Sara uxor tua pariet tibi filium, vocabisque nomen eius Isaac; et constituam pactum meum illi in foedus sempiternum et semini eius post eum."
,"20":"Super Ismael quoque exaudivi te: ecce benedicam ei et crescere faciam et multiplicabo eum vehementissime; duodecim duces generabit, et faciam illum in gentem magnam."
,"21":"Pactum vero meum statuam ad Isaac, quem pariet tibi Sara tempore isto in anno altero'."
,"22":"Cumque cessasset loqui cum eo, ascendit Deus ab Abraham."
,"23":"Tulit ergo Abraham Ismael filium suum et omnes vernaculos domus suae universosque, quos emerat: cunctos mares ex omnibus viris domus suae; et circumcidit carnem praeputii eorum statim in ipsa die, sicut praeceperat ei Deus."
,"24":"Abraham nonaginta novem erat annorum, quando circumcisus est in carne praeputii sui;"
,"25":"et Ismael filius eius tredecim annos impleverat tempore circumcisionis suae."
,"26":"Eadem die circumcisus est Abraham et Ismael filius eius;"
,"27":"et omnes viri domus illius, tam vernaculi quam empticii ex alienigenis, circumcisi sunt cum eo."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Apparuit autem ei Dominus iuxta Quercus Mambre se denti in ostio tabernaculi sui in ipso fervore diei."
,"2":"Cumque elevasset oculos, apparuerunt ei tres viri stantes prope eum. Quos cum vidisset, cucurrit in occursum eorum de ostio tabernaculi et adoravit in terram"
,"3":"et dixit: 'Domine mi, si inveni gratiam in oculis tuis, ne transeas servum tuum;"
,"4":"afferatur pauxillum aquae, et lavate pedes vestros et requiescite sub arbore."
,"5":"Ponamque buccellam panis, et confortate cor vestrum, postea transibitis; idcirco enim declinastis ad servum vestrum'. Qui dixerunt: 'Fac ut locutus es'."
,"6":"Festinavit Abraham in tabernaculum ad Saram dixitque: 'Accelera, tria sata similae commisce et fac subcinericios panes'."
,"7":"Ipse vero ad armentum cucurrit et tulit inde vitulum tenerrimum et optimum deditque puero; qui festinavit et coxit illum."
,"8":"Tulit quoque butyrum et lac et vitulum, quem coxerat, et posuit coram eis. Ipse vero stabat iuxta eos sub arbore; et comederunt."
,"9":"Dixeruntque ad eum: 'Ubi est Sara uxor tua?'. Ille respondit: 'Ecce in tabernaculo est'."
,"10":"Cui dixit: 'Revertens veniam ad te tempore isto, et habebit filium Sara uxor tua'. Quo audito, Sara risit ad ostium tabernaculi, quod erat post eum."
,"11":"Erant autem ambo senes provectaeque aetatis, et desierant Sarae fieri muliebria."
,"12":"Quae risit occulte dicens: 'Postquam consenui, et dominus meus vetulus est, voluptas mihi erit?'."
,"13":"Dixit autem Dominus ad Abraham: 'Quare risit Sara dicens: 'Num vere paritura sum anus?'."
,"14":"Numquid Domino est quidquam difficile? Revertar ad te hoc eodem tempore, et habebit Sara filium '."
,"15":"Negavit Sara dicens: 'Non risi', timore perterrita. Ille autem dixit: 'Non; sed risisti'."
,"16":"Cum ergo surrexissent inde viri, direxerunt oculos contra Sodomam; et Abraham simul gradiebatur deducens eos."
,"17":"Dixitque Dominus: 'Num celare potero Abraham, quae gesturus sum,"
,"18":"cum futurus sit in gentem magnam ac robustissimam, et benedicendae sint in illo omnes nationes terrae?"
,"19":"Nam elegi eum, ut praecipiat filiis suis et domui suae post se, ut custodiant viam Domini et faciant iustitiam et iudicium, ut adducat Dominus super Abraham omnia, quae locutus est ad eum'."
,"20":"Dixit itaque Dominus: 'Clamor contra Sodomam et Gomorram multiplicatus est, et peccatum eorum aggravatum est nimis."
,"21":"Descendam et videbo utrum clamorem, qui venit ad me, opere compleverint an non; sciam'."
,"22":"Converteruntque se inde viri et abierunt Sodomam; Abraham vero adhuc stabat coram Domino."
,"23":"Et appropinquans ait: 'Numquid vere perdes iustum cum impio?"
,"24":"Si forte fuerint quinquaginta iusti in civitate, vere perdes et non parces loco illi propter quinquaginta iustos, si fuerint in eo?"
,"25":"Absit a te, ut rem hanc facias et occidas iustum cum impio, fiatque iustus sicut impius; absit a te. Nonne iudex universae terrae faciet iudicium?'."
,"26":"Dixitque Dominus: 'Si invenero Sodomae quinquaginta iustos in medio civitatis, dimittam omni loco propter eos'."
,"27":"Respondensque Abraham ait: 'Ecce coepi loqui ad Dominum meum, cum sim pulvis et cinis."
,"28":"Quid, si forte minus quinquaginta iustis quinque fuerint? Delebis propter quinque universam urbem?'. Et ait: 'Non delebo, si invenero ibi quadraginta quinque'."
,"29":"Rursumque locutus est ad eum: 'Si forte inventi fuerint ibi quadraginta?'. Ait: 'Non percutiam propter quadraginta'."
,"30":"'Ne, quaeso, inquit, indignetur Dominus meus, si loquar. Si forte ibi inventi fuerint triginta?'. Respondit: 'Non faciam, si invenero ibi triginta'."
,"31":"'Ecce, ait, coepi loqui ad Dominum meum. Si forte inventi fuerint ibi viginti? '. Dixit: 'Non interficiam propter viginti'."
,"32":"'Obsecro, inquit, ne irascatur Dominus meus, si loquar adhuc semel. Si forte inventi fuerint ibi decem?'. Dixit: 'Non delebo propter decem'."
,"33":"Abiit Dominus, postquam cessavit loqui ad Abraham; et ille reversus est in locum suum."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Veneruntque duo angeli Sodomam vespere, sedente Lot in foribus civitatis. Qui cum vidisset eos, surrexit et ivit obviam eis adoravitque pronus in terram"
,"2":"et dixit: 'Obsecro, domini mei, declinate in domum pueri vestri et pernoctate; lavate pedes vestros et mane proficiscemini in viam vestram'. Qui dixerunt: 'Minime, sed in platea pernoctabimus'."
,"3":"Compulit illos oppido, et diverterunt ad eum. Ingressisque domum illius fecit convivium et coxit azyma, et comederunt."
,"4":"Prius autem quam irent cubitum, viri civitatis, viri Sodomae, vallaverunt domum a iuvene usque ad senem, omnis populus simul."
,"5":"Vocaveruntque Lot et dixerunt ei: 'Ubi sunt viri, qui introierunt ad te nocte? Educ illos ad nos, ut cognoscamus eos'."
,"6":"Egressus ad eos Lot post tergum occludens ostium ait:"
,"7":"'Nolite, quaeso, fratres mei, nolite malum hoc facere."
,"8":"Ecce, habeo duas filias, quae necdum cognoverunt virum; educam eas ad vos, et facite eis sicut placuerit vobis, dummodo viris istis nihil faciatis; ideo enim ingressi sunt sub umbra tecti mei'."
,"9":"At illi dixerunt: 'Recede illuc'. Et rursus: 'Unus ingressus est, inquiunt, ut advena et vult iudicare? Te ergo ipsum magis quam hos affligemus'. Vimque faciebant Lot vehementissime, iamque prope erat, ut effringerent fores."
,"10":"Et ecce miserunt manum viri et introduxerunt ad se Lot clauseruntque ostium;"
,"11":"et eos, qui foris erant, percusserunt caecitate a minimo usque ad maximum, ita ut ostium invenire non possent."
,"12":"Dixerunt autem viri ad Lot: 'Habes hic quempiam tuorum? Generum et filios et filias et omnes, qui tui sunt in urbe, educ de loco hoc:"
,"13":"delebimus enim locum istum, eo quod increverit clamor contra eos coram Domino, qui misit nos, ut perdamus eam'."
,"14":"Egressus itaque Lot locutus est ad generos suos, qui accepturi erant filias eius, et dixit: 'Surgite, egredimini de loco isto, quia delebit Dominus civitatem'. Et visus est eis quasi ludens loqui."
,"15":"Cumque esset mane, cogebant eum angeli dicentes: 'Surge, tolle uxorem tuam et duas filias, quas habes hic, ne pereas in scelere civitatis'."
,"16":"Tardante illo, apprehenderunt viri manum eius et manum uxoris ac duarum filiarum eius, eo quod parceret Dominus illi."
,"17":"Et eduxerunt eum posueruntque extra civitatem. Ibi locutus est: 'Salvare, agitur de vita tua; noli respicere post tergum, nec stes in omni circa regione; sed in monte salvum te fac, ne pereas'."
,"18":"Dixitque Lot ad eos: 'Non, quaeso, Domine."
,"19":"Ecce invenit servus tuus gratiam coram te, et magnificasti misericordiam tuam, quam fecisti mecum, ut salvares animam meam; nec possum in monte salvari, ne forte apprehendat me malum et moriar."
,"20":"Ecce, civitas haec iuxta, ad quam possum fugere, parva, et salvabor in ea numquid non modica est? et vivet anima mea'."
,"21":"Dixitque ad eum: 'Ecce, etiam in hoc suscepi preces tuas, ut non subvertam urbem, pro qua locutus es."
,"22":"Festina et salvare ibi, quia non potero facere quidquam, donec ingrediaris illuc'. Idcirco vocatum est nomen urbis illius Segor."
,"23":"Sol egressus est super terram, et Lot ingressus est Segor."
,"24":"Igitur Dominus pluit super Sodomam et Gomorram sulphur et ignem a Domino de caelo"
,"25":"et subvertit civitates has et omnem circa regionem, universos habitatores urbium et cuncta terrae virentia."
,"26":"Respiciensque uxor eius post se versa est in statuam salis."
,"27":"Abraham autem consurgens mane venit ad locum, ubi steterat prius cum Domino,"
,"28":"intuitus est Sodomam et Gomorram et universam terram regionis illius; viditque ascendentem favillam de terra quasi fornacis fumum."
,"29":"Cum enim subverteret Deus civitates regionis illius, recordatus Abrahae liberavit Lot de subversione urbium, in quibus habitaverat."
,"30":"Ascenditque Lot de Segor et mansit in monte, duae quoque filiae eius cum eo; timuerat enim manere in Segor. Et mansit in spelunca ipse et duae filiae eius."
,"31":"Dixitque maior ad minorem: 'Pater noster senex est, et nullus virorum remansit in terra, qui possit ingredi ad nos iuxta morem universae terrae."
,"32":"Veni, inebriemus patrem nostrum vino dormiamusque cum eo, ut servare possimus ex patre nostro semen'."
,"33":"Dederunt itaque patri suo bibere vinum nocte illa, et ingressa est maior dormivitque cum patre; at ille non sensit, nec quando accubuit filia nec quando surrexit."
,"34":"Altera quoque die dixit maior ad minorem: 'Ecce, dormivi heri cum patre meo; demus ei bibere vinum etiam hac nocte, et ingressa dormies cum eo, ut salvemus semen de patre nostro'."
,"35":"Dederunt et illa nocte patri suo bibere vinum, ingressaque minor filia dormivit cum eo; et ne tunc quidem sensit, quando illa concubuerit vel quando surrexerit."
,"36":"Conceperunt ergo duae filiae Lot de patre suo."
,"37":"Peperitque maior filium et vocavit nomen eius Moab; ipse est pater Moabitarum usque in praesentem diem."
,"38":"Minor quoque peperit filium et vocavit nomen eius Benammi (id est Filius populi mei); ipse est pater Ammonitarum usque hodie."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Profectus inde Abraham in terram Nageb, habitavit in ter Cades et Sur et peregrinatus est in Geraris."
,"2":"Dixitque de Sara uxore sua: 'Soror mea est'. Misit ergo Abimelech rex Gerarae et tulit eam."
,"3":"Venit autem Deus ad Abimelech per somnium nocte et ait illi: 'En morieris propter mulierem, quam tulisti; habet enim virum'."
,"4":"Abimelech vero non tetigerat eam. Et ait: 'Domine, num gentem etiam iustam interficies?"
,"5":"Nonne ipse dixit mihi: 'Soror mea est', et ipsa quoque ait: 'Frater meus est'? In simplicitate cordis mei et munditia manuum mearum feci hoc'."
,"6":"Dixitque ad eum Deus per somnium: 'Et ego scio quod simplici corde feceris; et ideo custodivi te, ne peccares in me, et non dimisi, ut tangeres eam."
,"7":"Nunc igitur redde viro suo uxorem, quia propheta est; et orabit pro te, et vives. Si autem nolueris reddere, scito quod morte morieris tu et omnia, quae tua sunt'."
,"8":"Statimque de nocte consurgens Abimelech vocavit omnes servos suos et locutus est universa verba haec in auribus eorum; timueruntque viri valde."
,"9":"Vocavit autem Abimelech etiam Abraham et dixit ei: 'Quid fecisti nobis? Quid peccavi in te, quia induxisti super me et super regnum meum peccatum grande? Quae non debuisti facere, fecisti mihi'."
,"10":"Rursusque ait: 'Quid vidisti, ut hoc faceres?'."
,"11":"Respondit Abraham: ' Cogitavi mecum: Certe non est timor Dei in loco isto, et interficient me propter uxorem meam."
,"12":"Alias autem et vere soror mea est, filia patris mei et non filia matris meae, et duxi eam in uxorem."
,"13":"Cum autem vagari me faceret Deus de domo patris mei, dixi ad eam: Hanc misericordiam facies mecum: in omni loco, ad quem ingrediemur, dices quod frater tuus sim '."
,"14":"Tulit igitur Abimelech oves et boves et servos et ancillas et dedit Abraham; reddiditque illi Saram uxorem suam"
,"15":"et ait: 'Ecce terra mea coram te; ubicumque tibi placuerit, habita'."
,"16":"Sarae autem dixit: 'Ecce mille argenteos dedi fratri tuo; ecce hoc erit tibi in velamen oculorum ad omnes, qui tecum sunt, et apud omnes iustificaberis'."
,"17":"Orante autem Abraham, sanavit Deus Abimelech et uxorem ancillasque eius et pepererunt;"
,"18":"concluserat enim Dominus omnem vulvam domus Abimelech propter Saram uxorem Abraham."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Visitavit autem Dominus Saram, sicut promiserat, et implevit Sarae, quae locutus est;"
,"2":"concepitque et peperit Abrahae filium in senectute eius tempore, quo praedixerat ei Deus."
,"3":"Vocavitque Abraham nomen filii sui, quem genuit ei Sara, Isaac"
,"4":"et circumcidit eum octavo die, sicut praeceperat ei Deus."
,"5":"Cum Abraham centum esset annorum, natus est ei Isaac filius eius."
,"6":"Dixitque Sara: 'Risum fecit mihi Deus; quicumque audierit, corridebit mihi ?."
,"7":"Rursumque ait: ? Quis auditurum crederet Abraham,quod Sara lactaret filios, quia peperit ei filium,iam seni?'."
,"8":"Crevit igitur puer et ablactatus est. Fecitque Abraham grande convivium in die ablactationis eius."
,"9":"Cumque vidisset Sara filium Agar Aegyptiae iocantem cum Isaac filio suo, dixit ad Abraham:"
,"10":"'Eice ancillam hanc et filium eius; non enim erit heres filius ancillae cum filio meo Isaac'."
,"11":"Dure accepit hoc Abraham propter filium suum."
,"12":"Cui dixit Deus: 'Non tibi videatur asperum super puero et super ancilla tua; omnia, quae dixerit tibi Sara, audi vocem eius, quia in Isaac vocabitur tibi semen."
,"13":"Sed et filium ancillae faciam in gentem magnam, quia semen tuum est'."
,"14":"Surrexit itaque Abraham mane et tollens panem et utrem aquae imposuit scapulae eius tradiditque puerum et dimisit eam. Quae cum abisset, errabat in deserto Bersabee."
,"15":"Cumque consumpta esset aqua in utre, abiecit puerum subter unum arbustum"
,"16":"et abiit; seditque e regione procul, quantum potest arcus iacere. Dixit enim: 'Non videbo morientem puerum'. Et sedens contra levavit vocem suam et flevit."
,"17":"Exaudivit autem Deus vocem pueri; vocavitque angelus Dei Agar de caelo dicens: 'Quid tibi, Agar? Noli timere; exaudivit enim Deus vocem pueri de loco, in quo est."
,"18":"Surge, tolle puerum et tene illum manu tua, quia in gentem magnam faciam eum'."
,"19":"Aperuitque Deus oculos eius; quae videns puteum aquae abiit et implevit utrem deditque puero bibere."
,"20":"Et fuit Deus cum eo; qui crevit et moratus est in solitudine factusque est iuvenis sagittarius."
,"21":"Habitavitque in deserto Pharan; et accepit illi mater sua uxorem de terra Aegypti."
,"22":"Eodem tempore dixit Abimelech et Phicol princeps exercitus eius ad Abraham: 'Deus tecum est in universis, quae agis."
,"23":"Iura ergo per Deum, ne noceas mihi et posteris meis stirpique meae; sed iuxta fidem, quam feci tibi, facies mihi et terrae, in qua versatus es advena'."
,"24":"Dixitque Abraham: 'Ego iurabo'."
,"25":"Et increpavit Abraham Abimelech propter puteum aquae, quem vi abstulerant servi eius."
,"26":"Responditque Abimelech: 'Nescivi quis fecerit hanc rem; sed et tu non indicasti mihi, et ego non audivi praeter hodie'."
,"27":"Tulit itaque Abraham oves et boves et dedit Abimelech; percusseruntque ambo foedus."
,"28":"Et statuit Abraham septem agnas gregis seorsum."
,"29":"Cui dixit Abimelech: 'Quid sibi volunt septem agnae istae, quas stare fecisti seorsum?'."
,"30":"At ille: 'Septem, inquit, agnas accipies de manu mea, ut sint in testimonium mihi, quoniam ego fodi puteum istum'."
,"31":"Idcirco vocatus est locus ille Bersabee, quia ibi uterque iuraverunt."
,"32":"Et inierunt foedus in Bersabee."
,"33":"Surrexit autem Abimelech et Phicol princeps militiae eius reversique sunt in terram Philisthim. Abraham vero plantavit nemus in Bersabee et invocavit ibi nomen Domini, Dei aeterni."
,"34":"Et fuit colonus in terra Philisthim diebus multis."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Quae postquam gesta sunt, tentavit Deus Abraham et di xit ad eum: 'Abraham'. Ille respondit: 'Adsum'."
,"2":"Ait: 'Tolle filium tuum unigenitum, quem diligis, Isaac et vade in terram Moria; atque offer eum ibi in holocaustum super unum montium, quem monstravero tibi'."
,"3":"Igitur Abraham de nocte consurgens stravit asinum suum ducens secum duos iuvenes suos et Isaac filium suum. Cumque concidisset ligna in holocaustum, surrexit et abiit ad locum, quem praeceperat ei Deus."
,"4":"Die autem tertio, elevatis oculis, vidit locum procul"
,"5":"dixitque ad pueros suos: 'Exspectate hic cum asino. Ego et puer illuc usque properantes, postquam adoraverimus, revertemur ad vos'."
,"6":"Tulit quoque ligna holocausti et imposuit super Isaac filium suum; ipse vero portabat in manibus ignem et cultrum. Cumque duo pergerent simul,"
,"7":"dixit Isaac Abrahae patri suo: 'Pater mi'. Ille respondit: 'Quid vis, fili?'. 'Ecce, inquit, ignis et ligna; ubi est victima holocausti?'."
,"8":"Dixit Abraham: 'Deus providebit sibi victimam holocausti, fili mi'. Pergebant ambo pariter; "
,"9":"et venerunt ad locum, quem ostenderat ei Deus, in quo aedificavit Abraham altare et desuper ligna composuit. Cumque colligasset Isaac filium suum, posuit eum in altari super struem lignorum"
,"10":"extenditque Abraham manum et arripuit cultrum, ut immolaret filium suum."
,"11":"Et ecce angelus Domini de caelo clamavit: 'Abraham, Abraham'. Qui respondit: 'Adsum'."
,"12":"Dixitque: 'Non extendas manum tuam super puerum neque facias illi quidquam. Nunc cognovi quod times Deum et non pepercisti filio tuo unigenito propter me'."
,"13":"Levavit Abraham oculos suos viditque arietem unum inter vepres haerentem cornibus; quem assumens obtulit holocaustum pro filio."
,"14":"Appellavitque nomen loci illius: 'Dominus videt'. Unde usque hodie dicitur: 'In monte Dominus videtur'."
,"15":"Vocavit autem angelus Domini Abraham secundo de caelo et dixit:"
,"16":"'Per memetipsum iuravi, dicit Dominus: quia fecisti hanc rem et non pepercisti filio tuo unigenito,"
,"17":"benedicam tibi et multiplicabo semen tuum sicut stellas caeli et velut arenam, quae est in litore maris. Possidebit semen tuum portas inimicorum suorum,"
,"18":"et benedicentur in semine tuo omnes gentes terrae, quia oboedisti voci meae'."
,"19":"Reversus est Abraham ad pueros suos, et surrexerunt abieruntque Bersabee simul, et habitavit Abraham in Bersabee."
,"20":"His ita gestis, nuntiatum est Abrahae quod Melcha quoque genuisset filios Nachor fratri suo:"
,"21":"Us primogenitum et Buz fratrem eius et Camuel patrem Aram"
,"22":"et Cased et Azau, Pheldas quoque et Iedlaph"
,"23":"ac Bathuel, de quo nata est Rebecca. Octo istos genuit Melcha Nachor fratri Abrahae."
,"24":"Concubina vero illius, nomine Reuma, peperit Tabee et Gaham et Tahas et Maacha."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Vixit autem Sara centum viginti septem annis"
,"2":"et mortua est in Cariatharbe, quae est Hebron, in terra Chanaan; venitque Abraham, ut plangeret et fleret eam."
,"3":"Cumque surrexisset ab officio funeris, locutus est ad filios Heth dicens:"
,"4":"'Advena sum et inquilinus apud vos; date mihi possessionem sepulcri vobiscum, ut sepeliam mortuum meum'."
,"5":"Responderunt filii Heth dicentes:"
,"6":"'Audi nos, domine, princeps Dei es apud nos: in nobilissimo sepulcrorum nostrorum sepeli mortuum tuum; nullusque te prohibebit, quin in sepulcro eius sepelias mortuum tuum'."
,"7":"Surrexit Abraham et adoravit populum terrae, filios videlicet Heth,"
,"8":"dixitque ad eos: 'Si placet animae vestrae, ut sepeliam mortuum meum, audite me et intercedite pro me apud Ephron filium Seor,"
,"9":"ut det mihi speluncam Machpela, quam habet in extrema parte agri sui. Pecunia digna tradat eam mihi coram vobis in possessionem sepulcri'."
,"10":"Sedebat autem Ephron in medio filiorum Heth. Responditque Ephron Hetthaeus ad Abraham, filiis Heth audientibus cunctis, qui ingrediebantur portam civitatis illius, dicens:"
,"11":"'Nequaquam ita fiat, domine mi, ausculta me. Agrum do tibi et speluncam, quae in eo est, praesentibus filiis populi mei; sepeli mortuum tuum'."
,"12":"Adoravit Abraham coram populo terrae"
,"13":"et locutus est ad Ephron, audiente populo terrae: 'Quaeso, ut audias me. Dabo pecuniam pro agro; suscipe eam, et sic sepeliam mortuum meum in eo'."
,"14":"Respondit Ephron ad Abraham dicens ei:"
,"15":"'Domine mi, audi me. Terra quadringentorum siclorum argenti inter me et te quid est hoc? Sepeli mortuum tuum'."
,"16":"Auscultavit Abraham Ephron et appendit pecuniam, quam Ephron postulaverat, audientibus filiis Heth, quadringentos siclos argenti, sicut mos erat apud negotiatores."
,"17":"Confirmatusque est ager Ephronis, qui erat in Machpela respiciens Mambre, tam ipse quam spelunca in eo et omnes arbores eius in cunctis terminis eius per circuitum,"
,"18":"Abrahae in possessionem, videntibus filiis Heth cunctis, qui intrabant portam civitatis illius."
,"19":"Deinde sepelivit Abraham Saram uxorem suam in spelunca agri Machpela, qui respiciebat Mambre haec est Hebron in terra Chanaan."
,"20":"Et confirmatus est ager et antrum, quod erat in eo, Abrahae in possessionem sepulcri a filiis Heth."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Erat autem Abraham senex dierumque multorum; et Do minus in cunctis benedixerat ei."
,"2":"Dixitque Abraham ad servum seniorem domus suae, qui praeerat omnibus, quae habebat: 'Pone manum tuam subter femur meum,"
,"3":"ut adiurem te per Dominum, Deum caeli et Deum terrae, ut non accipias uxorem filio meo de filiabus Chananaeorum, inter quos habito;"
,"4":"sed ad terram et cognationem meam proficiscaris et inde accipias uxorem filio meo Isaac'."
,"5":"Respondit servus: 'Si noluerit mulier venire mecum in terram hanc, num reducere debeo filium tuum ad terram, a quo tu egressus es?'."
,"6":"Dixit Abraham: 'Cave, ne quando reducas illuc filium meum."
,"7":"Dominus, Deus caeli, qui tulit me de domo patris mei et de terra nativitatis meae, qui locutus est mihi et iuravit mihi dicens: 'Semini tuo dabo terram hanc', ipse mittet angelum suum coram te, et accipies inde uxorem filio meo."
,"8":"Sin autem noluerit mulier sequi te, non teneberis iuramento; filium tantum meum ne reducas illuc'."
,"9":"Posuit ergo servus manum sub femore Abraham domini sui et iuravit illi super hac re."
,"10":"Tulitque servus decem camelos de grege domini sui et abiit ex omnibus bonis eius portans secum; profectusque perrexit in Aram Naharaim ad urbem Nachor."
,"11":"Cumque camelos fecisset accumbere extra oppidum iuxta puteum aquae vespere, tempore quo solent mulieres egredi ad hauriendam aquam, dixit:"
,"12":"'Domine,Deus domini mei Abraham, occurre obsecro mihi hodie et fac misericordiam cum domino meo Abraham."
,"13":"Ecce ego sto prope fontem aquae, et filiae habitatorum huius civitatis egredientur ad hauriendam aquam."
,"14":"Igitur puella, cui ego dixero: 'Inclina hydriam tuam, ut bibam', et illa responderit: 'Bibe, quin et camelis tuis dabo potum', ipsa est, quam praeparasti servo tuo Isaac, et per hoc intellegam quod feceris misericordiam cum domino meo'."
,"15":"Necdum intra se verba compleverat, et ecce Rebecca egrediebatur filia Bathuel filii Melchae uxoris Nachor fratris Abraham habens hydriam in scapula:"
,"16":"puella decora nimis, virgo et incognita viro. Descendit ad fontem et implevit hydriam ac revertebatur."
,"17":"Occurritque ei servus et ait: 'Pauxillum mihi ad sorbendum praebe aquae de hydria tua'."
,"18":"Quae respondit: 'Bibe, domine mi'. Celeriterque deposuit hydriam super ulnam suam et dedit ei potum."
,"19":"Cumque ille bibisset, adiecit: 'Quin et camelis tuis hauriam aquam, donec cuncti bibant'."
,"20":"Effundensque hydriam in canalibus recurrit ad puteum, ut hauriret aquam; et haustam omnibus camelis dedit."
,"21":"Ille autem contemplabatur eam tacitus, scire volens utrum prosperum fecisset iter suum Dominus an non."
,"22":"Postquam ergo biberunt cameli, protulit vir anulum aureum pondo dimidii sicli pro naribus et duas armillas pro manibus eius pondo siclorum decem;"
,"23":"dixitque: 'Cuius es filia? lndica mihi. Est in domo patris tui locus nobis ad pernoctandum?'."
,"24":"Quae respondit: 'Filia Bathuelis sum filii Melchae, quem peperit Nachor'."
,"25":"Et addidit dicens: 'Palearum quoque et pabuli plurimum est apud nos et locus ad pernoctandum'."
,"26":"Inclinavit se homo et adoravit Dominum"
,"27":"dicens: 'Benedictus Dominus, Deus domini mei Abraham, qui non abstulit misericordiam et veritatem suam a domino meo et recto itinere me perduxit in domum fratris domini mei'."
,"28":"Cucurrit itaque puella et nuntiavit in domum matris suae omnia, quae evenerant."
,"29":"Habebat autem Rebecca fratrem nomine Laban, qui festinus egressus est ad hominem, ubi erat fons."
,"30":"Cumque vidisset anulum in naribus et armillas in manibus sororis suae et audisset cuncta verba referentis: 'Haec locutus est mihi homo', venit ad virum, qui stabat iuxta camelos et prope fontem aquae;"
,"31":"dixitque ad eum: 'Ingredere, benedicte Domini, cur foris stas? Praeparavi domum et locum camelis'."
,"32":"Et introduxit eum in hospitium ac destravit camelos; deditque paleas et pabulum camelis et aquam ad lavandos pedes eius et virorum, qui venerant cum eo."
,"33":"Et apposuit in conspectu eius panem. Qui ait: 'Non comedam, donec loquar sermones meos'. Respondit: 'Loquere'."
,"34":"At ille: 'Servus, inquit, Abraham sum;"
,"35":"et Dominus benedixit domino meo valde, magnificatusque est; et dedit ei oves et boves, argentum et aurum, servos et ancillas, camelos et asinos."
,"36":"Et peperit Sara uxor domini mei filium domino meo in senectute sua; deditque illi omnia, quae habuerat."
,"37":"Et adiuravit me dominus meus dicens: 'Non accipies uxorem filio meo de filiabus Chananaeorum, in quorum terra habito;"
,"38":"sed ad domum patris mei perges et de cognatione mea accipies uxorem filio meo'."
,"39":"Ego vero respondi domino meo: Quid, si noluerit venire mecum mulier?"
,"40":"'Dominus, ait, in cuius conspectu ambulo, mittet angelum suum tecum et diriget viam tuam; accipiesque uxorem filio meo de cognatione mea et de domo patris mei."
,"41":"Innocens eris a maledictione mea, cum veneris ad propinquos meos, et non dederint tibi; tunc innocens eris a maledictione mea'."
,"42":"Veni ergo hodie ad fontem et dixi: Domine, Deus domini mei Abraham, si direxisti viam meam, in qua nunc ambulo,"
,"43":"ecce sto iuxta fontem aquae; et virgo, quae egredietur ad hauriendam aquam, audierit a me: 'Da mihi pauxillum aquae ad bibendum ex hydria tua';"
,"44":"et dixerit mihi: 'Et tu bibe, et camelis tuis hauriam', ipsa est mulier, quam praeparavit Dominus filio domini mei."
,"45":"Dum haec tacitus mecum volverem, apparuit Rebecca veniens cum hydria, quam portabat in scapula; descenditque ad fontem et hausit aquam. Et aio ad eam: Da mihi paululum bibere."
,"46":"Quae festina deposuit hydriam de umero et dixit mihi: 'Et tu bibe, et camelis tuis potum tribuam'. Bibi, et adaquavit camelos."
,"47":"Interrogavique eam et dixi: Cuius es filia? Quae respondit: 'Filia Bathuelis sum filii Nachor, quem peperit illi Melcha'. Suspendi itaque anulum in naribus eius et armillas posui in manibus eius. "
,"48":"Pronusque adoravi Dominum benedicens Domino, Deo domini mei Abraham, qui perduxit me recto itinere, ut sumerem filiam fratris domini mei filio eius."
,"49":"Quam ob rem, si facitis misericordiam et veritatem cum domino meo, indicate mihi; sin autem aliud placet, et hoc dicite mihi, ut vadam ad dexteram sive ad sinistram'."
,"50":"Responderunt Laban et Bathuel: 'A Domino egressus est sermo; non possumus extra placitum eius quidquam aliud loqui tecum."
,"51":"En Rebecca coram te est; tolle eam et proficiscere, et sit uxor filii domini tui, sicut locutus est Dominus'."
,"52":"Quod cum audisset puer Abraham, procidens adoravit in terram Dominum."
,"53":"Prolatisque vasis argenteis et aureis ac vestibus, dedit ea Rebeccae; res pretiosas dedit fratri eius et matri."
,"54":"Tunc comederunt et biberunt ipse et viri, qui erant cum eo, et pernoctaverunt ibi. Surgens autem mane locutus est puer: 'Dimittite me, ut vadam ad dominum meum'. "
,"55":"Responderuntque frater eius et mater: 'Maneat puella saltem decem dies apud nos et postea proficiscetur'."
,"56":"'Nolite, ait, me retinere, quia Dominus direxit viam meam; dimittite me, ut pergam ad dominum meum'."
,"57":"Dixerunt: 'Vocemus puellam et quaeramus ipsius voluntatem'."
,"58":"Cumque vocata venisset, sciscitati sunt: 'Vis ire cum homine isto?'. Quae ait: 'Vadam'."
,"59":"Dimiserunt ergo Rebeccam sororem eorum et nutricem illius servumque Abraham et comites eius,"
,"60":"imprecantes prospera sorori suae atque dicentes: 'Soror nostra es, crescas in mille milia, et possideat semen tuum,portas inimicorum suorum!'."
,"61":"Igitur surrexit Rebecca et puellae illius et, ascensis camelis, secutae sunt virum; sumpsitque servus Rebeccam et abiit."
,"62":"Isaac autem venerat a regione putei Lahairoi et habitabat in terra Nageb."
,"63":"Et egressus est Isaac ad lamentandum in agro, inclinata iam die. Cumque levasset oculos, vidit camelos venientes."
,"64":"Rebecca quoque levavit oculos et vidit Isaac; descenditque de camelo"
,"65":"et ait ad puerum: 'Quis est ille homo, qui venit per agrum in occursum nobis?'. Dixitque ei: 'Ipse est dominus meus'. At illa tollens cito velum operuit se."
,"66":"Servus autem cuncta, quae gesserat, narravit Isaac;"
,"67":"qui introduxit eam in tabernaculum Sarae matris suae et accepit Rebeccam uxorem; et dilexit eam et consolatus est a morte matris suae."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Abraham vero aliam duxit uxorem nomine Ceturam,"
,"2":"quae peperit ei Zamran et Iecsan et Madan et Madian et Iesboc et Sue."
,"3":"Iecsan quoque genuit Saba et Dedan. Filii Dedan fuerunt Assurim et Latusim et Loommim."
,"4":"At vero ex Madian ortus est Epha et Opher et Henoch et Abida et Eldaa. Omnes hi filii Ceturae."
,"5":"Deditque Abraham cuncta, quae possederat, Isaac;"
,"6":"filiis autem concubinarum suarum largitus est munera et separavit eos ab Isaac filio suo, dum adhuc ipse viveret, ad plagam orientalem."
,"7":"Fuerunt autem dies vitae Abrahae centum septuaginta quinque anni."
,"8":"Et deficiens mortuus est Abraham in senectute bona provectaeque aetatis et plenus dierum congregatusque est ad populum suum."
,"9":"Et sepelierunt eum Isaac et Ismael filii sui in spelunca Machpela, quae sita est in agro Ephron filii Seor Hetthaei e regione Mambre,"
,"10":"quem emerat a filiis Heth. Ibi sepultus est ipse et Sara uxor eius."
,"11":"Et post obitum illius benedixit Deus Isaac filio eius, qui habitabat iuxta puteum Lahairoi."
,"12":"Hae sunt generationes Ismael filii Abrahae, quem peperit ei Agar Aegyptia famula Sarae."
,"13":"Et haec nomina filiorum Ismael in vocabulis et generationibus suis: primogenitus Ismaelis Nabaioth, dein Cedar et Adbeel et Mabsam,"
,"14":"Masma quoque et Duma et Massa,"
,"15":"Hadad et Thema, Iethur et Naphis et Cedma."
,"16":"Isti sunt filii Ismaelis, et haec nomina eorum per vicos et mansiones eorum: duodecim principes tribuum suarum."
,"17":"Et facti sunt anni vitae Ismaelis centum triginta septem; deficiens mortuus est et appositus ad populum suum."
,"18":"Habitaverunt autem ab Hevila usque Sur, quae respicit Aegyptum introeuntibus Assyriam. In faciem cunctorum fratrum suorum obiit."
,"19":"Hae sunt generationes Isaac filii Abraham: Abraham genuit Isaac;"
,"20":"qui, cum quadraginta esset annorum, duxit uxorem Rebeccam filiam Bathuelis Aramaei de Paddanaram, sororem Laban Aramaei."
,"21":"Deprecatusque est Isaac Dominum pro uxore sua, eo quod esset sterilis. Qui exaudivit eum et dedit conceptum Rebeccae."
,"22":"Sed collidebantur in utero eius parvuli. Quae ait: 'Si sic est, cur mihi?'. Perrexitque, ut consuleret Dominum."
,"23":"Qui respondens ait: 'Duae gentes sunt in utero tuo, et duo populi ex ventre tuo dividentur; populusque populum superabit, et maior serviet minori'."
,"24":"Iam tempus pariendi venerat, et ecce gemini in utero eius."
,"25":"Qui primus egressus est rufus erat et totus quasi pallium pilosum; vocatumque est nomen eius Esau. Postea frater eius egrediens plantam Esau tenebat manu, et idcirco appellatum est nomen eius Iacob."
,"26":"Sexagenarius erat Isaac, quando nati sunt parvuli."
,"27":"Quibus adultis, factus est Esau vir gnarus venandi et homo agrestis; Iacob autem vir compositus et habitans in tabernaculis."
,"28":"Isaac amabat Esau, eo quod de venationibus illius libenter vesceretur; et Rebecca diligebat Iacob."
,"29":"Coxit autem Iacob pulmentum; ad quem, cum venisset Esau de agro lassus,"
,"30":"ait: 'Da mihi de coctione hac rufa, quia oppido lassus sum'. Quam ob causam vocatum est nomen eius Edom (id est Rufus)."
,"31":"Cui dixit Iacob: 'Vende mihi prius primogenita tua'."
,"32":"Ille respondit: 'En morior; quid mihi proderunt primogenita?'."
,"33":"Ait Iacob: 'Iura ergo mihi'. Iuravit et vendidit primogenita."
,"34":"Et sic, accepto pane et lentis edulio, comedit et bibit; surrexit et abiit parvipendens quod primogenita vendidisset."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Orta autem fame super terram post eam sterilitatem, quae acciderat in diebus Abraham, abiit Isaac ad Abimelech regem Philisthim in Gerara."
,"2":"Apparuitque ei Dominus et ait: 'Ne descendas in Aegyptum, sed habita in terra, quam dixero tibi,"
,"3":"et peregrinare in ea; eroque tecum et benedicam tibi. Tibi enim et semini tuo dabo universas regiones has complens iuramentum, quod spopondi Abraham patri tuo,"
,"4":"et multiplicabo semen tuum sicut stellas caeli daboque posteris tuis universas regiones has; et benedicentur in semine tuo omnes gentes terrae,"
,"5":"eo quod oboedierit Abraham voci meae et custodierit praecepta et mandata mea et iustificationes legesque servaverit'."
,"6":"Mansit itaque Isaac in Geraris."
,"7":"Qui, cum interrogaretur a viris loci illius super uxore sua, respondit: 'Soror mea est'. Timuerat enim confiteri quod sibi esset sociata coniugio, reputans ne forte interficerent eum propter illius pulchritudinem."
,"8":"Cumque pertransissent dies plurimi et ibidem moraretur, prospiciens Abimelech rex Philisthim per fenestram vidit eum iocantem cum Rebecca uxore sua."
,"9":"Et, accersito eo, ait: 'Perspicuum est quod uxor tua sit; cur mentitus es eam sororem tuam esse?'. Respondit: 'Timui, ne morerer propter eam'."
,"10":"Dixitque Abimelech: 'Quare hoc fecisti nobis? Potuit coire quispiam de populo cum uxore tua, et induxeras super nos grande peccatum'. Praecepitque omni populo dicens:"
,"11":"'Qui tetigerit hominem hunc et uxorem eius, morte morietur'."
,"12":"Sevit autem Isaac in terra illa et invenit in ipso anno centuplum; benedixitque ei Dominus."
,"13":"Et locupletatus est homo et ibat proficiens atque succrescens, donec magnus vehementer effectus est;"
,"14":"habuitque possessionem ovium et armentorum et familiae plurimum. Ob haec invidentes ei Philisthim "
,"15":"omnes puteos, quos foderant servi patris illius in diebus Abraham, obstruxerunt implentes humo,"
,"16":"in tantum ut ipse Abimelech diceret ad Isaac: ' Recede a nobis, quoniam potentior nostri factus es valde '."
,"17":"Et ille discedens tentoria fixit ad torrentem Gerarae habitavitque ibi."
,"18":"Rursum fodit puteos, quos foderant in diebus patris sui Abraham et quos, illo mortuo, obstruxerant Philisthim. Appellavitque eos eisdem nominibus, quibus ante pater vocaverat."
,"19":"Foderunt servi Isaac in torrente et reppererunt ibi puteum aquae vivae."
,"20":"Sed et ibi iurgium fuit pastorum Gerarae adversus pastores Isaac dicentium: ' Nostra est aqua! '. Quam ob rem nomen putei vocavit Esec (id est Iurgium), quia iurgati sunt cum eo."
,"21":"Foderunt autem et alium puteum, et pro illo quoque rixati sunt; appellavitque eum Sitna (id est Inimicitias)."
,"22":"Profectus inde fodit alium puteum, pro quo non contenderunt; itaque vocavit nomen eius Rehoboth (id est Latitudinem) dicens: ' Nunc dilatavit nos Dominus, et crescemus in terra '."
,"23":"Ascendit autem ex illo loco in Bersabee,"
,"24":"ubi apparuit ei Dominus in ipsa nocte dicens: ' Ego sum Deus Abraham patris tui. Noli timere, quia tecum sum; benedicam tibi,et multiplicabo semen tuum,propter servum meum Abraham '."
,"25":"Itaque aedificavit ibi altare et, invocato nomine Domini, extendit tabernaculum, et servi Isaac foderunt ibi puteum."
,"26":"Abimelech autem venit ad eum de Geraris et Ochozath amicus illius et Phicol dux militum,"
,"27":"et locutus est eis Isaac: ' Quid venistis ad me hominem, quem odistis et expulistis a vobis? '."
,"28":"Qui responderunt: ' Vidimus tecum esse Dominum et idcirco diximus: Sit iuramentum inter nos et te, et ineamus tecum foedus,"
,"29":"ut non facias nobis quidquam mali, sicut et nos non attigimus te et nihil fecimus tibi nisi bonum et cum pace dimisimus te. Tu es enim benedictus Domini '."
,"30":"Fecit ergo eis convivium, et comederunt et biberunt."
,"31":"Surgentesque mane iuraverunt sibi mutuo. Dimisitque eos Isaac, et profecti sunt ab eo cum pace."
,"32":"Ecce autem venerunt in ipso die servi Isaac annuntiantes ei de puteo, quem foderant, atque dicentes: ' Invenimus aquam '."
,"33":"Unde appellavit eum Sabee (quod significat Abundantiam); et nomen urbi impositum est Bersabee usque in praesentem diem."
,"34":"Esau vero quadragenarius duxit uxores Iudith filiam Beeri Hetthaei et Basemath filiam Elon Hetthaei."
,"35":"Quae ambae offenderant animum Isaac et Rebeccae."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Senuit autem Isaac, et caligaverunt oculi eius, et videre non poterat. Vocavitque Esau filium suum maiorem et dixit ei: ' Fili mi '. Qui respondit: ' Adsum '."
,"2":"Cui pater: ' Vides, inquit, quod senuerim et ignorem diem mortis meae;"
,"3":"sume arma tua, pharetram et arcum, et egredere in agrum. Cumque venatu aliquid apprehenderis,"
,"4":"fac mihi inde pulmentum, sicut velle me nosti, et affer, ut comedam; et benedicat tibi anima mea, antequam moriar '."
,"5":"Rebecca autem audierat Isaac loquentem cum Esau filio suo. Esau ergo abiit in agrum, ut venationem caperet et offerret eam."
,"6":"Rebecca autem dixit filio suo Iacob: ' Ecce, audivi patrem tuum loquentem cum Esau fratre tuo et dicentem ei:"
,"7":"'Affer mihi venationem tuam et fac cibos, ut comedam et benedicam tibi coram Domino, antequam moriar'."
,"8":"Nunc ergo, fili mi, audi vocem meam in eo, quod praecipio tibi."
,"9":"Pergens ad gregem affer mihi duos haedos optimos, ut faciam ex eis escas patri tuo, quibus libenter vescitur."
,"10":"Quas cum intuleris patri tuo, et comederit, benedicat tibi, priusquam moriatur '."
,"11":"Cui ille respondit: ' Nosti quod Esau frater meus homo pilosus sit, et ego lenis."
,"12":"Si attrectaverit me pater meus et senserit, timeo, ne putet me sibi voluisse illudere; et inducam super me maledictionem pro benedictione'."
,"13":"Ad quem mater: ' In me sit, ait, ista maledictio, fili mi; tantum audi vocem meam et perge afferque, quae dixi '."
,"14":"Abiit et attulit deditque matri. Paravit illa cibos, sicut noverat velle patrem illius."
,"15":"Et vestibus Esau valde bonis, quas apud se habebat domi, induit eum"
,"16":"pelliculasque haedorum circumdedit manibus et colli nuda protexit;"
,"17":"dedit pulmentum optimum et panes, quos coxerat, in manus filii sui Iacob."
,"18":"Qui ingressus ad patrem suum dixit: ' Pater mi '. At ille respondit: ' Audio. Quis es tu, fili mi? '."
,"19":"Dixitque Iacob ad patrem suum: ' Ego sum Esau primogenitus tuus. Feci sicut praecepisti mihi; surge, sede et comede de venatione mea, ut benedicat mihi anima tua '."
,"20":"Rursum Isaac ad filium suum: ' Quomodo, inquit, tam cito invenire potuisti, fili mi? '. Qui respondit: ' Voluntas Domini Dei tui fuit, ut occurreret mihi '."
,"21":"Dixitque Isaac ad Iacob: ' Accede huc, ut tangam te, fili mi, et probem, utrum tu sis filius meus Esau an non '."
,"22":"Accessit ille ad patrem, et, palpato eo, dixit Isaac: ' Vox quidem, vox Iacob est, sed manus, manus sunt Esau '."
,"23":"Et non cognovit eum, quia pilosae manus similitudinem maioris expresserant. Benedixit ergo illi."
,"24":"Ait: ' Tu es filius meus Esau? '. Respondit: ' Ego sum '."
,"25":"At ille: ' Affer, inquit, mihi, et comedam de venatione tua, fili mi, ut benedicat tibi anima mea '. Quos cum oblatos comedisset, obtulit ei etiam vinum. Quo hausto,"
,"26":"dixit ad eum Isaac pater eius: ' Accede ad me et da mihi osculum, fili mi '."
,"27":"Accessit et osculatus est eum. Statimque, ut sensit vestimentorum illius fragrantiam, benedicens illi ait: ' Ecce odor filii mei,sicut odor agri pleni, cui benedixit Dominus."
,"28":"Det tibi Deus de rore caeli,et de pinguedine terrae,et abundantiam frumenti et vini."
,"29":"Et serviant tibi populi, et adorent te nationes; esto dominus fratrum tuorum, et incurventur ante te filii matris tuae. Qui maledixerit tibi, sit maledictus; et, qui benedixerit tibi, sit benedictus! '."
,"30":"Vix Isaac benedictionem Iacob finierat, et Iacob egressus erat a patre suo Isaac, venit Esau frater eius"
,"31":"coctosque de venatione cibos intulit patri dicens: ' Surge, pater mi, et comede de venatione filii tui, ut benedicat mihi anima tua '."
,"32":"Dixitque illi Isaac pater eius: ' Quis enim es tu? '. Qui respondit: ' Ego sum filius tuus primogenitus Esau '."
,"33":"Expavit Isaac stupore vehementi ultra modum et ait: ' Quis igitur ille est, qui dudum captam venationem attulit mihi, et comedi ex omnibus, priusquam tu venires? Benedixique ei, et erit benedictus! '."
,"34":"Auditis Esau sermonibus patris, irrugiit clamore magno et amaro ultra modum et ait patri suo: ' Benedic etiam mihi, pater mi! '."
,"35":"Qui ait: ' Venit germanus tuus fraudulenter et accepit benedictionem tuam '."
,"36":"At ille subiunxit: ' Iuste vocatum est nomen eius Iacob; supplantavit enim me en altera vice: primogenita mea ante tulit et nunc secundo surripuit benedictionem meam '. Rursumque ait: ' Numquid non reservasti mihi benedictionem? '. "
,"37":"Respondit Isaac: ' Ecce, dominum tuum illum constitui et omnes fratres eius servituti illius subiugavi; frumento et vino stabilivi eum. Et tibi post haec, fili mi, ultra quid faciam? '."
,"38":"Dixitque Esau ad patrem suum: ' Num unam tantum benedictionem habes, pater mi? Mihi quoque obsecro, ut benedicas! '. Cumque eiulatu magno fleret,"
,"39":"motus Isaac dixit ad eum: ' Ecce, procul a pinguedine terrae erit habitatio tua,et procul a rore caeli desuper."
,"40":"De gladio tuo vives,et fratri tuo servies. Tempusque veniet, cum excutias,et solvas iugum eius de cervicibus tuis '."
,"41":"Oderat ergo Esau Iacob pro benedictione, qua benedixerat ei pater, dixitque in corde suo: ' Appropinquabunt dies luctus patris mei, et occidam Iacob fratrem meum '."
,"42":"Nuntiata sunt Rebeccae verba Esau filii eius maioris, quae mittens et vocans Iacob filium suum minorem dixit ad eum: ' Ecce, Esau frater tuus minatur, ut occidat te."
,"43":"Nunc ergo, fili mi, audi vocem meam et consurgens fuge ad Laban fratrem meum in Charran;"
,"44":"habitabisque cum eo dies paucos, donec requiescat furor fratris tui,"
,"45":"et cesset indignatio eius, obliviscaturque eorum, quae fecisti in eum. Postea mittam et adducam te inde huc. Cur utroque orbabor filio in uno die? '."
,"46":"Dixit quoque Rebecca ad Isaac: ' Taedet me vitae meae propter filias Heth; si acceperit Iacob uxorem de filiabus Heth sicut istis de filiabus terrae, nolo vivere '."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Vocavit itaque Isaac Iacob et benedixit eum praecepit que ei dicens: ' Noli accipere coniugem de filiabus Chanaan;"
,"2":"surge, vade in Paddanaram ad domum Bathuel patris matris tuae et accipe tibi inde uxorem de filiabus Laban avunculi tui."
,"3":"Deus autem omnipotens benedicat tibi et crescere te faciat atque multiplicet, ut sis in multitudinem populorum;"
,"4":"et det tibi benedictiones Abraham tibi et semini tuo tecum, ut possideas terram peregrinationis tuae, quam pollicitus est Deus avo tuo '."
,"5":"Cumque dimisisset eum Isaac, profectus est in Paddanaram ad Laban filium Bathuel Aramaei fratrem Rebeccae matris Iacob et Esau."
,"6":"Videns autem Esau quod benedixisset pater suus Iacob et misisset eum in Paddanaram, ut inde uxorem duceret, et quod post benedictionem praecepisset ei dicens: ' Non accipies uxorem de filiabus Chanaan ',"
,"7":"quodque oboediens Iacob parentibus suis isset in Paddanaram;"
,"8":"probans quoque quod non libenter aspiceret filias Chanaan pater suus,"
,"9":"ivit ad Ismaelem et duxit uxorem, absque iis, quas habebat, Mahalath filiam Ismael filii Abraham sororem Nabaioth."
,"10":"Igitur egressus Iacob de Bersabee pergebat Charran."
,"11":"Cumque venisset ad quendam locum et vellet in eo requiescere post solis occubitum, tulit de lapidibus, qui iacebant, et supponens capiti suo dormivit in eodem loco."
,"12":"Viditque in somnio scalam stantem super terram et cacumen illius tangens caelum, angelos quoque Dei ascendentes et descendentes per eam"
,"13":"et Dominum innixum scalae dicentem sibi: ' Ego sum Dominus, Deus Abraham patris tui et Deus Isaac. Terram, in qua dormis, tibi dabo et semini tuo."
,"14":"Eritque semen tuum quasi pulvis terrae; dilataberis ad occidentem et orientem et septentrionem et meridiem; et benedicentur in te et in semine tuo cunctae tribus terrae."
,"15":"Et ecce, ego tecum sum et custodiam te, quocumque perrexeris, et reducam te in terram hanc; nec dimittam te, nisi complevero quae dixi tibi '."
,"16":"Cumque evigilasset Iacob de somno, ait: ' Vere Dominus est in loco isto, et ego nesciebam '."
,"17":"Pavensque: ' Quam terribilis est, inquit, locus iste! Non est hic aliud nisi domus Dei et porta caeli '."
,"18":"Surgens ergo Iacob mane tulit lapidem, quem supposuerat capiti suo, et erexit in titulum fundens oleum desuper."
,"19":"Appellavitque nomen loci illius Bethel; prius autem urbs vocabatur Luza."
,"20":"Vovit Iacob etiam votum dicens: ' Si fuerit Deus mecum et custodierit me in via hac, per quam ambulo, et dederit mihi panem ad vescendum et vestimentum ad induendum,"
,"21":"reversusque fuero prospere ad domum patris mei, erit mihi Dominus in Deum,"
,"22":"et lapis iste, quem erexi in titulum, erit domus Dei; cunctorumque, quae dederis mihi, decimas offeram tibi '."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Profectus ergo Iacob venit in terram orientalium."
,"2":"Et vidit puteum in agro, tres quoque greges ovium accubantes iuxta eum; nam ex illo adaquabantur pecora, et os eius grandi lapide claudebatur."
,"3":"Morisque erat, ut, cunctis ovibus congregatis, devolverent lapidem et, refectis gregibus, rursum super os putei ponerent."
,"4":"Dixitque ad pastores: ' Fratres, unde estis? '. Qui responderunt: ' De Charran '."
,"5":"Quos interrogans: ' Numquid, ait, nostis Laban filium Nachor? '. Dixerunt: ' Novimus '."
,"6":"' Sanusne est? ', inquit. ' Valet, inquiunt, et ecce Rachel filia eius venit cum grege '."
,"7":"Dixitque: ' Adhuc multum diei superest, nec est tempus, ut congregentur greges; date potum ovibus et sic ad pastum eas reducite '."
,"8":"Qui responderunt: ' Non possumus, donec omnia pecora congregentur et amoveamus lapidem de ore putei, ut adaquemus greges '."
,"9":"Adhuc loquebatur cum eis, et ecce Rachel veniebat cum ovibus patris sui; nam gregem ipsa pascebat."
,"10":"Cum vidisset Iacob Rachel filiam Laban avunculi sui ovesque Laban avunculi sui, accedens amovit lapidem de ore putei"
,"11":"et adaquavit gregem Laban avunculi sui. Tunc Iacob osculatus est Rachel et elevata voce flevit;"
,"12":"et indicavit ei quod frater esset patris eius et filius Rebeccae. At illa festinans nuntiavit patri suo."
,"13":"Qui cum audisset venisse Iacob filium sororis suae, cucurrit obviam ei; complexusque eum et in oscula ruens duxit in domum suam. Auditis autem omnibus, quae evenerant,"
,"14":"respondit: ' Vere os meum es et caro mea! '. Et, postquam Iacob habitavit apud eum per dies mensis unius, "
,"15":"dixit ei Laban: ' Num, quia frater meus es, gratis servies mihi? Dic quid mercedis accipias '."
,"16":"Habebat vero filias duas: nomen maioris Lia, minor vero appellabatur Rachel;"
,"17":"sed Lia lippis erat oculis, Rachel decora et venusto aspectu."
,"18":"Quam diligens Iacob ait: ' Serviam tibi pro Rachel filia tua minore septem annis '."
,"19":"Respondit Laban: ' Melius est, ut tibi eam dem quam alteri viro; mane apud me '."
,"20":"Servivit igitur Iacob pro Rachel septem annis, et videbantur illi pauci dies prae amoris magnitudine."
,"21":"Dixitque ad Laban: ' Da mihi uxorem meam, quia iam tempus expletum est, ut ingrediar ad eam '."
,"22":"Qui, vocatis omnibus viris loci ad convivium, fecit nuptias."
,"23":"Et vespere sumpsit Liam filiam suam et introduxit ad eum, et venit ad eam."
,"24":"Et dedit Laban ancillam filiae Zelpham nomine. Facto mane, vidit, et ecce erat Lia. "
,"25":"Et dixit ad socerum suum: ' Quid hoc fecisti mihi? Nonne pro Rachel servivi tibi? Quare imposuisti mihi? '."
,"26":"Respondit Laban: ' Non est in loco nostro consuetudinis, ut minorem ante maiorem tradamus ad nuptias."
,"27":"Imple hebdomadam hanc, et alteram quoque dabo tibi pro opere, quo serviturus es mihi septem annis aliis '."
,"28":"Acquievit placito et, hebdomada transacta, dedit ei Laban filiam suam Rachel uxorem,"
,"29":"cui servam Bilham tradidit."
,"30":"Et ingressus etiam ad Rachel amavit eam plus quam Liam serviens apud eum septem annis aliis."
,"31":"Videns autem Dominus quod despiceret Liam, aperuit vulvam eius, Rachel sterili permanente."
,"32":"Et concepit Lia et genuit filium vocavitque nomen eius Ruben dicens: ' Vidit Dominus humilitatem meam; nunc amabit me vir meus '."
,"33":"Rursumque concepit et peperit filium et ait: ' Quoniam audivit me Dominus haberi contemptui, dedit etiam istum mihi '; vocavitque nomen illius Simeon."
,"34":"Concepit tertio et genuit alium filium dixitque: ' Nunc quoque copulabitur mihi maritus meus, eo quod pepererim ei tres filios '; et idcirco appellavit nomen eius Levi."
,"35":"Quarto concepit et peperit filium et ait: ' Modo confitebor Domino '; et ob hoc vocavit eum Iudam. Cessavitque parere."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Cernens autem Rachel quod infecunda esset, invidit sorori et ait marito suo: ' Da mihi liberos, alioquin moriar '."
,"2":"Cui iratus respondit Iacob: ' Num pro Deo ego sum, qui privavit te fructu ventris? '."
,"3":"At illa: ' Ecce, inquit, famula mea Bilha; ingredere ad illam, ut pariat super genua mea, et habeam ex illa et ego filios '."
,"4":"Deditque illi Bilham famulam suam in coniugium. Quae,"
,"5":"ingresso ad se Iacob, concepit et peperit filium."
,"6":"Dixitque Rachel: ' Iudicavit mihi Deus et exaudivit vocem quoque meam dans mihi filium '; et idcirco appellavit nomen illius Dan."
,"7":"Rursumque Bilha famula Rachel concepit et peperit Iacob alterum filium, et"
,"8":"ait Rachel: ' Certamina Dei certavi cum sorore mea et invalui '; vocavitque eum Nephthali."
,"9":"Sentiens Lia quod parere desisset, sumpsit Zelpham ancillam suam et tradidit eam Iacob in uxorem."
,"10":"Quae peperit Iacob filium."
,"11":"Dixitque Lia: ' Feliciter! '; et idcirco vocavit nomen eius Gad."
,"12":"Peperit quoque Zelpha ancilla Liae Iacob alterum filium."
,"13":"Dixitque Lia: ' Pro beatitudine mea! Beatam quippe me dicent mulieres '; propterea appellavit eum Aser."
,"14":"Egressus autem Ruben tempore messis triticeae, repperit in agro mandragoras, quas Liae matri suae detulit. Dixitque Rachel: ' Da mihi partem de mandragoris filii tui '."
,"15":"Illa respondit: ' Parumne tibi videtur, quod praeripueris maritum mihi, ut etiam mandragoras filii mei auferas? '. Ait Rachel: ' Dormiat ergo tecum hac nocte pro mandragoris filii tui '."
,"16":"Redeuntique ad vesperam Iacob de agro egressa est in occursum eius Lia et: ' Ad me, inquit, intrabis, quia mercede conduxi te pro mandragoris filii mei '. Dormivitque cum ea nocte illa."
,"17":"Et exaudivit Deus Liam, concepitque et peperit Iacob filium quintum"
,"18":"et ait: ' Dedit Deus mercedem mihi, quia dedi ancillam meam viro meo '; appellavitque nomen illius Issachar."
,"19":"Rursum Lia concepit et peperit Iacob sextum filium"
,"20":"et ait: ' Donavit me Deus dono bono; hac vice honorabit me maritus meus, eo quod genuerim ei sex filios '; et idcirco appellavit nomen eius Zabulon."
,"21":"Post quem peperit filiam nomine Dinam."
,"22":"Recordatus quoque Deus Rachelis exaudivit eam Deus et aperuit vulvam illius."
,"23":"Quae concepit et peperit filium dicens: ' Abstulit Deus opprobrium meum ';"
,"24":"et vocavit nomen illius Ioseph dicens: ' Addat mihi Dominus filium alterum! '."
,"25":"Nato autem Ioseph, dixit Iacob ad Laban: ' Dimitte me, ut revertar in patriam et ad terram meam."
,"26":"Da mihi uxores et liberos meos, pro quibus servivi tibi, ut abeam; tu nosti servitutem, qua servivi tibi '."
,"27":"Ait illi Laban: ' Inveniam gratiam in conspectu tuo; augurio didici, quia benedixerit mihi Deus propter te."
,"28":"Constitue mercedem tuam, quam dem tibi '."
,"29":"At ille respondit: ' Tu nosti quomodo servierim tibi et quanti in manibus meis facti sint greges tui."
,"30":"Modicum habuisti, antequam venirem ad te, et nunc multiplicatum est vehementer, benedixitque tibi Dominus ad introitum meum. Nunc autem quando providebo etiam domui meae? '."
,"31":"Dixitque Laban: ' Quid tibi dabo? '. At ille ait: ' Nihil mihi dabis; si feceris, quod postulo, iterum pascam et custodiam pecora tua."
,"32":"Gyrabo omnes greges tuos hodie; separa cuncta pecora varia et maculosa et, quodcumque furvum in ovibus et maculosum variumque in capris fuerit, erit merces mea."
,"33":"Respondebitque mihi cras iustitia mea; quando veneris, ut inspicias mercedem meam, omnia, quae non fuerint varia et maculosa in capris et furva in ovibus, furti me arguent '."
,"34":"Dixit Laban: ' Gratum habeo, quod petis! '."
,"35":"Et separavit in die illo hircos striatos atque maculosos et omnes capras varias et maculosas, omne, in quo album erat, et omne furvum in ovibus, et tradidit in manu filiorum suorum."
,"36":"Et posuit spatium itineris trium dierum inter se et Iacob, qui pascebat reliquos greges Laban."
,"37":"Tollens ergo Iacob virgas virides populeas et amygdalinas et ex platanis, ex parte ita decorticavit eas, ut in his, quae spoliata fuerant, candor appareret."
,"38":"Posuitque virgas, quas ex parte decorticaverat, in canalibus, ubi effundebatur aqua, ut, cum venissent greges ad bibendum, ante oculos haberent virgas et in aspectu earum conciperent."
,"39":"Factumque est ut in ipso calore coitus greges intuerentur virgas et parerent striata et varia et maculosa."
,"40":"Agnos autem segregavit Iacob et posuit gregem ex adverso striatorum et omnium furvorum in grege Laban et constituit sibi greges seorsum neque statuit eos cum grege Laban."
,"41":"Quotiescumque igitur calefiebant pecora robusta, ponebat Iacob virgas in canalibus aquarum ante oculos pecorum, ut in earum contemplatione conciperent."
,"42":"Quando vero pecora debilia erant, non ponebat eas. Factaque sunt debilia Laban et robusta Iacob;"
,"43":"ditatusque est homo ultra modum et habuit greges multos, ancillas et servos, camelos et asinos."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Postquam autem audivit verba filiorum Laban dicen tium: ' Tulit Iacob omnia, quae fuerunt patris nostri, et de patris nostri facultate acquisivit has divitias ',"
,"2":"animadvertit quoque faciem Laban quod non esset erga se sicut heri et nudiustertius."
,"3":"Et dixit Dominus ad Iacob: ' Revertere in terram patrum tuorum et ad cognationem tuam, eroque tecum '."
,"4":"Misit Iacob et vocavit Rachel et Liam in agrum, ubi pascebat greges,"
,"5":"dixitque eis: ' Video faciem patris vestri quod non sit erga me sicut heri et nudiustertius; Deus autem patris mei fuit mecum,"
,"6":"et ipsae nostis quod totis viribus meis servierim patri vestro."
,"7":"Sed pater vester circumvenit me et mutavit mercedem meam decem vicibus; et tamen non dimisit eum Deus, ut noceret mihi."
,"8":"Si quando dixit: 'Variae erunt mercedes tuae', pariebant omnes oves varios fetus. Quando vero e contrario ait: 'Striata quaeque accipies pro mercede', omnes greges striata pepererunt."
,"9":"Tulitque Deus substantiam patris vestri et dedit mihi."
,"10":"Postquam enim conceptus gregis tempus advenerat, levavi oculos meos et vidi in somnis ascendentes mares super feminas, striatos et varios et respersos."
,"11":"Dixitque angelus Dei ad me in somnis: 'Iacob'. Et ego respondi: Adsum."
,"12":"Qui ait: 'Leva oculos tuos et vide universos masculos ascendentes super feminas, striatos et varios atque respersos. Vidi enim omnia, quae fecit tibi Laban."
,"13":"Ego sum Deus Bethel, ubi unxisti lapidem et votum vovisti mihi. Nunc ergo surge et egredere de terra hac revertens in terram nativitatis tuae' '."
,"14":"Responderunt ei Rachel et Lia: ' Numquid habemus adhuc partem et hereditatem in domo patris nostri?"
,"15":"Nonne quasi alienas reputavit nos et vendidit nos comeditque pretium nostrum?"
,"16":"Sed omnes opes, quas tulit Deus patri nostro, nobis abstulit ac filiis nostris; unde omnia, quae praecepit tibi Deus, fac '."
,"17":"Surrexit itaque Iacob et imposuit liberos suos ac coniuges suas super camelos."
,"18":"Tulitque omnes greges suos et omnem substantiam suam, quidquid in Paddanaram acquisierat, ut iret ad Isaac patrem suum in terram Chanaan."
,"19":"Eo tempore Laban ierat ad tondendas oves, et Rachel furata est theraphim patris sui."
,"20":"Iacob autem decepit cor Laban, non indicans ei quod fugeret."
,"21":"Cumque fugisset cum omnibus, quae possidebat, et, amne transmisso, pergeret contra montem Galaad,"
,"22":"nuntiatum est Laban die tertio quod fugisset Iacob."
,"23":"Qui, assumptis fratribus suis, persecutus est eum diebus septem et comprehendit eum in monte Galaad."
,"24":"Venit autem Deus ad Laban Aramaeum per somnium noctis dixitque ei: 'Cave, ne quidquam loquaris contra Iacob!'."
,"25":"Iamque Iacob extenderat in monte tabernaculum, cum Laban, consecutus eum cum fratribus suis, in eodem monte Galaad fixit tentorium."
,"26":"Et dixit ad Iacob: ' Quare ita egisti et decepisti cor meum, abigens filias meas quasi captivas gladio?"
,"27":"Cur clam fugisti et decepisti me, non indicans mihi, ut prosequerer te cum gaudio et canticis et tympanis et citharis?"
,"28":"Non es passus, ut oscularer filios meos ac filias; stulte operatus es. Et nunc"
,"29":"valet quidem manus mea reddere tibi malum, sed Deus patris vestri heri dixit mihi: 'Cave, ne loquaris contra Iacob quidquam!'."
,"30":"Esto, profectus es, quia desiderio tibi erat domus patris tui; cur furatus es deos meos? '."
,"31":"Respondit Iacob: ' Quia timui. Dixi enim, ne forte violenter auferres filias tuas a me."
,"32":"Apud quemcumque inveneris deos tuos, non vivat! Coram fratribus nostris scrutare, quidquid tuorum apud me inveneris, et aufer '. Ignorabat enim Iacob quod Rachel furata esset theraphim."
,"33":"Ingressus itaque Laban tabernacula Iacob et Liae et utriusque famulae, non invenit. Egressus de tentorio Liae, intravit tentorium Rachelis."
,"34":"Illa autem absconderat theraphim in stramento cameli et sedit desuper. Scrutantique omne tentorium et nihil invenienti"
,"35":"ait: ' Ne irascatur dominus meus, quod coram te assurgere nequeo, quia iuxta consuetudinem feminarum nunc accidit mihi '. Quaesivit ergo et non invenit theraphim."
,"36":"Tumensque Iacob cum iurgio ait: ' Quam ob culpam meam et ob quod peccatum meum sic persecutus es me,"
,"37":"quia scrutatus es omnem supellectilem meam? Quid invenisti de cuncta substantia domus tuae? Pone hic coram fratribus meis et fratribus tuis, et iudicent inter me et te."
,"38":"Ecce, viginti annis fui tecum. Oves tuae et caprae non abortiverunt, arietes gregis tui non comedi;"
,"39":"nec dilaceratum a bestia ostendi tibi: ego damnum omne reddebam; quidquid die noctuque furto perierat, a me exigebas."
,"40":"Die aestu consumebar et nocte gelu, fugiebatque somnus ab oculis meis."
,"41":"Sic per viginti annos in domo tua servivi tibi: quattuordecim pro filiabus et sex pro gregibus tuis; immutasti quoque mercedem meam decem vicibus."
,"42":"Nisi Deus patris mei, Deus Abraham et Timor Isaac, affuisset mihi, certemodo nudum me dimisisses; afflictionem meam et laborem manuum mearum respexit Deus et iudicavit heri '."
,"43":"Respondit ei Laban: ' Filiae filiae meae et filii filii mei et greges greges mei et omnia, quae cernis, mea sunt; et filiabus meis quid possum facere illis hodie et filiis earum, quos genuerunt?"
,"44":"Veni ergo, et ineamus foedus ego et tu, ut sit in testimonium inter me et te '."
,"45":"Tulit itaque Iacob lapidem et erexit illum in titulum;"
,"46":"dixitque fratribus suis: ' Afferte lapides '. Qui congregantes fecerunt tumulum comederuntque ibi super eum."
,"47":"Quem vocavit Laban Iegarsahadutha (id est Tumulus testimonii), et Iacob Galed (uterque iuxta proprietatem linguae suae)."
,"48":"Dixitque Laban: ' Tumulus iste testis erit inter me et te hodie '; et idcirco appellatum est nomen eius Galed (id est Tumulus testis)"
,"49":"et etiam Maspha (id est Specula), quia dixit: ' Speculetur Dominus inter me et te, quando absconditi erimus ab invicem."
,"50":"Si afflixeris filias meas et si introduxeris uxores alias super eas, cum nemo nobiscum sit, vide, Deus est testis inter me et te '."
,"51":"Dixitque Laban ad Iacob: ' En tumulus hic et lapis, quem erexi inter me et te."
,"52":"Testis erit tumulus iste et lapis quod ego non transibo tumulum hunc pergens ad te, neque tu transibis tumulum hunc et lapidem hunc ad malum."
,"53":"Deus Abraham et Deus Nachor iudicent inter nos '. Iuravit Iacob per Timorem patris sui Isaac; "
,"54":"immolatisque victimis in monte, vocavit fratres suos, ut ederent panem. Qui cum comedissent, pernoctaverunt in monte."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Laban vero de nocte consur gens osculatus est filios et fi lias suas et benedixit illis reversusque est in locum suum."
,"2":"Iacob quoque abiit itinere, quo coeperat, fueruntque ei obviam angeli Dei."
,"3":"Quos cum vidisset, ait: ' Castra Dei sunt haec '; et appellavit nomen loci illius Mahanaim (id est Castra)."
,"4":"Misit autem nuntios ante se ad Esau fratrem suum in terram Seir, in regionem Edom."
,"5":"Praecepitque eis dicens: ' Sic loquimini domino meo Esau: Haec dicit servus tuus Iacob: Apud Laban peregrinatus sum et fui usque in praesentem diem."
,"6":"Habeo boves et asinos, oves et servos atque ancillas; mittoque nunc legationem ad dominum meum, ut inveniam gratiam in conspectu tuo '."
,"7":"Reversique sunt nuntii ad Iacob dicentes: ' Venimus ad Esau fratrem tuum, et ecce properat in occursum tibi cum quadringentis viris '."
,"8":"Timuit Iacob valde et perterritus divisit populum, qui secum erat, greges quoque et oves et boves et camelos in duas turmas"
,"9":"dicens: ' Si venerit Esau ad unam turmam et percusserit eam, alia turma, quae reliqua est, salvabitur '."
,"10":"Dixitque Iacob: ' Deus patris mei Abraham et Deus patris mei Isaac, Domine, qui dixisti mihi: 'Revertere in terram tuam et in locum nativitatis tuae, et benefaciam tibi',"
,"11":"minor sum cunctis miserationibus et cuncta veritate, quam explesti servo tuo. In baculo meo transivi Iordanem istum et nunc cum duabus turmis regredior."
,"12":"Erue me de manu fratris mei, de manu Esau, quia valde eum timeo; ne forte veniens percutiat matrem cum filiis."
,"13":"Tu locutus es quod bene mihi faceres et dilatares semen meum sicut arenam maris, quae prae multitudine numerari non potest '."
,"14":"Mansit ibi nocte illa et sumpsit de his, quae habebat, munera Esau fratri suo:"
,"15":"capras ducentas, hircos viginti, oves ducentas et arietes viginti,"
,"16":"camelos fetas cum pullis suis triginta, vaccas quadraginta et tauros decem, asinas viginti et pullos earum decem."
,"17":"Et misit per manus servorum suorum singulos seorsum greges dixitque pueris suis: ' Antecedite me, et sit spatium inter gregem et gregem '."
,"18":"Et praecepit priori dicens: ' Si obvium habueris Esau fratrem meum, et interrogaverit te: 'Cuius es?' et 'Quo vadis?' et 'Cuius sunt ista, quae sequeris?',"
,"19":"respondebis: Servi tui Iacob; munera misit domino meo Esau. Ipse quoque post nos venit '."
,"20":"Similiter mandata dedit secundo ac tertio et cunctis, qui sequebantur greges, dicens: ' Iisdem verbis loquimini ad Esau, cum inveneritis eum,"
,"21":"et addetis: Ipse quoque servus tuus Iacob iter nostrum insequitur. Dixit enim: Placabo illum muneribus, quae praecedunt, et postea videbo faciem eius: forsitan propitiabitur mihi '."
,"22":"Praecesserunt itaque munera ante eum, ipse vero mansit nocte illa in castris."
,"23":"Cumque nocte surrexisset, tulit duas uxores suas et totidem famulas cum undecim filiis et transivit vadum Iaboc;"
,"24":"sumptis ergo traductisque illis et omnibus, quae ad se pertinebant, per torrentem,"
,"25":"mansit solus. Et ecce vir luctabatur cum eo usque mane. "
,"26":"Qui cum videret quod eum superare non posset, tetigit acetabulum femoris eius, et statim luxatum est acetabulum femoris Iacob, cum luctaretur cum illo."
,"27":"Dixitque: ' Dimitte me, iam enim ascendit aurora '. Respondit: ' Non dimittam te, nisi benedixeris mihi '."
,"28":"Ait ad eum: ' Quod nomen est tibi? '. Respondit: ' Iacob '."
,"29":"At ille: ' Nequaquam, inquit, Iacob amplius appellabitur nomen tuum, sed Israel: quoniam certasti cum Deo et cum hominibus et praevaluisti! '."
,"30":"Interrogavit eum Iacob: ' Dic mihi, quo appellaris nomine? '. Respondit: ' Cur quaeris nomen meum? '. Et benedixit ei in eodem loco."
,"31":"Vocavitque Iacob nomen loci illius Phanuel dicens: ' Vidi Deum facie ad faciem, et salva facta est anima mea '."
,"32":"Ortusque est ei sol, cum transgrederetur Phanuel; ipse vero claudicabat propter femur."
,"33":"Quam ob causam non comedunt filii Israel nervum, qui est in femore, usque in praesentem diem, eo quod tetigerit nervum femoris Iacob."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Elevans autem Iacob oculos suos vidit venientem Esau et cum eo quadringentos viros; divisitque filios Liae et Rachel ambarumque famularum."
,"2":"Et posuit utramque ancillam et liberos earum in principio, Liam vero et filios eius in secundo loco, Rachel autem et Ioseph novissimos."
,"3":"Et ipse praegrediens adoravit pronus in terram septies, donec appropinquaret ad fratrem suum."
,"4":"Currens itaque Esau obviam fratri suo amplexatus est eum; stringensque collum eius osculatus est eum, et fleverunt."
,"5":"Levatisque oculis, vidit mulieres et liberos earum et ait: ' Qui sunt isti tibi? '. Respondit: ' Liberi sunt, quos donavit mihi Deus servo tuo '."
,"6":"Et appropinquantes ancillae et filii earum incurvati sunt."
,"7":"Accessit quoque Lia cum liberis suis et, cum similiter adorassent, extremi Ioseph et Rachel adoraverunt."
,"8":"' Quaenam sunt, inquit, istae turmae, quas obvias habui? '. Respondit: ' Ut invenirem gratiam coram domino meo '."
,"9":"At ille: ' Habeo, ait, plurima, frater mi; sint tua tibi '."
,"10":"Dixit Iacob: ' Noli ita, obsecro; sed, si inveni gratiam in oculis tuis, accipe munusculum de manibus meis; sic enim vidi faciem tuam quasi viderim vultum Dei, et mihi propitius fuisti."
,"11":"Suscipe, quaeso, benedictionem, quae allata est tibi; quia Deus misertus est mihi, et habeo omnia '. Et, cum compelleret illum, suscepit "
,"12":"et ait: ' Gradiamur simul, eroque socius itineris tui '."
,"13":"Dixit Iacob: ' Nosti, domine mi, quod parvulos habeam teneros et oves et boves fetas mecum; quas si plus in ambulando fecero laborare vel una die, morientur cuncti greges."
,"14":"Praecedat dominus meus ante servum suum; et ego sequar paulatim secundum gressum pecorum ante me et secundum gressum parvulorum, donec veniam ad dominum meum in Seir '."
,"15":"Respondit Esau: ' Oro te, ut de populo, qui mecum est, saltem socii remaneant viae tuae'. ' Non est, inquit, necesse; hoc uno indigeo, ut inveniam gratiam in conspectu domini mei '."
,"16":"Reversus est itaque illo die Esau itinere suo in Seir."
,"17":"Et Iacob venit in Succoth, ubi, aedificata sibi domo et fixis tentoriis pro gregibus suis, appellavit nomen loci illius Succoth (id est Tabernacula)."
,"18":"Transivitque Iacob incolumis ad urbem Sichem, quae est in terra Chanaan, cum veniret de Paddanaram; et habitavit iuxta oppidum."
,"19":"Emitque partem agri, in qua fixerat tabernaculum suum, a filiis Hemmor patris Sichem centum argenteis."
,"20":"Et erexit ibi altare et vocavit illud: ' Deus est Deus Israel '."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Egressa est autem Dina filia, quam Lia pepererat Iacob, ut videret filias regionis illius."
,"2":"Quam cum vidisset Sichem filius Hemmor Hevaei principis terrae illius, adamavit eam et rapuit; et dormivit cum illa, vi opprimens illam."
,"3":"Et conglutinata est anima eius cum ea, et amavit puellam et locutus est ad cor eius."
,"4":"Dixitque ad Hemmor patrem suum: ' Accipe mihi puellam hanc coniugem '."
,"5":"Cum audisset Iacob quod violasset Dinam filiam suam, absentibus filiis et in pastu pecorum occupatis, siluit, donec redirent."
,"6":"Egresso autem Hemmor patre Sichem, ut loqueretur ad Iacob,"
,"7":"ecce filii Iacob veniebant de agro, auditoque, quod acciderat, contristati et irati sunt valde, eo quod foedam rem esset operatus in Israel et, violata filia Iacob, rem illicitam perpetrasset."
,"8":"Locutus est itaque Hemmor ad eos: ' Sichem filii mei adhaesit anima filiae vestrae; date eam illi uxorem,"
,"9":"et iungamus vicissim conubia: filias vestras tradite nobis et filias nostras accipite vobis."
,"10":"Et habitate nobiscum; terra in potestate vestra est: manete, perambulate et possidete eam '."
,"11":"Sed et Sichem ad patrem et ad fratres eius ait: ' Inveniam gratiam coram vobis et, quaecumque statueritis, dabo."
,"12":"Augete mihi valde dotem et munera; libens tribuam, quod petieritis. Tantum date mihi puellam hanc uxorem '."
,"13":"Responderunt filii Iacob Sichem et Hemmor patri eius in dolo ob stuprum sororis:"
,"14":"' Non possumus facere, quod petitis, dare sororem nostram homini incircumciso, opprobrium enim esset nobis."
,"15":"In hoc tantum valebimus acquiescere vobis: si esse volueritis similes nostri, circumcidatur in vobis omne masculini sexus;"
,"16":"tunc dabimus et accipiemus mutuo filias nostras ac vestras et habitabimus vobiscum erimusque unus populus."
,"17":"Si autem circumcidi nolueritis, tollemus filiam nostram et recedemus '."
,"18":"Placuit oblatio eorum Hemmor et Sichem filio eius,"
,"19":"nec distulit adulescens quin statim, quod petebatur, expleret; amabat enim filiam Iacob valde, et ipse erat inclitus in omni domo patris sui."
,"20":"Ingressique portam urbis, Hemmor et Sichem filius eius locuti sunt ad viros civitatis suae:"
,"21":"' Viri isti pacifici sunt erga nos; maneant in terra et perambulent eam, quae spatiosa et lata est eis; filias eorum accipiemus uxores et nostras illis dabimus."
,"22":"Tantum in hoc valebunt viri acquiescere nobis, ut maneant nobiscum et efficiamur unus populus, si circumcidamus masculos nostros ritum gentis imitantes;"
,"23":"et pecora et substantia et armenta eorum nostra erunt. Tantum in hoc acquiescamus, et habitabunt nobiscum '."
,"24":"Assensique sunt omnes, circumcisis cunctis maribus, qui egrediebantur e porta civitatis suae."
,"25":"Et ecce, die tertio, quando gravissimus vulnerum dolor est, arreptis duo filii Iacob Simeon et Levi fratres Dinae gladiis, ingressi sunt urbem securi; interfectisque omnibus masculis,"
,"26":"Hemmor et Sichem pariter necaverunt, tollentes Dinam de domo Sichem sororem suam."
,"27":"Filii Iacob irruerunt super occisos, et depopulati sunt urbem in ultionem stupri."
,"28":"Oves eorum et armenta et asinos cunctaque, quae in civitate et in agris erant, tulerunt."
,"29":"Omnes opes eorum, parvulos quoque et uxores duxerunt captivas et diripuerunt omnia, quae in domibus erant."
,"30":"Iacob autem dixit ad Simeon et Levi: ' Turbastis me et odiosum fecistis me Chananaeis et Pherezaeis habitatoribus terrae huius. Nos pauci sumus; illi congregati percutient me, et delebor ego et domus mea '."
,"31":"Responderunt: ' Numquid ut scorto abuti debuere sorore nostra? '."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Locutus est Deus ad Iacob: ' Surge et ascende Bethel et habita ibi; facque altare Deo, qui apparuit tibi, quando fugiebas Esau fratrem tuum '."
,"2":"Iacob vero, convocata omni domo sua, ait: ' Abigite deos alienos, qui in medio vestri sunt, et mundamini ac mutate vestimenta vestra."
,"3":"Surgamus et ascendamus in Bethel, ut faciamus ibi altare Deo, qui exaudivit me in die tribulationis meae et socius fuit itineris mei '."
,"4":"Dederunt ergo ei omnes deos alienos, quos habebant, et inaures, quae erant in auribus eorum; at ille infodit ea subter Quercum, quae est prope urbem Sichem."
,"5":"Cumque profecti essent, terror Dei invasit omnes per circuitum civitates, et non sunt ausi persequi filios Iacob."
,"6":"Venit igitur Iacob Luzam, quae est in terra Chanaan, id est Bethel, ipse et omnis populus cum eo."
,"7":"Aedificavitque ibi altare et appellavit nomen loci illius Deus Bethel; ibi enim apparuit ei Deus, cum fugeret fratrem suum."
,"8":"Eodem tempore mortua est Debora nutrix Rebeccae et sepulta est ad radices Bethel subter quercum; vocatumque est nomen loci illius Quercus fletus."
,"9":"Apparuit iterum Deus Iacob, postquam reversus est de Paddanaram, benedixitque ei"
,"10":"dicens: ' Non vocaberis ultra Iacob, sed Israel erit nomen tuum ', et appellavit eum Israel."
,"11":"Dixitque ei: ' Ego Deus omnipotens. Cresce et multiplicare; gens et congregatio nationum erunt ex te, reges de lumbis tuis egredientur."
,"12":"Terramque, quam dedi Abraham et Isaac, dabo tibi; et semini tuo post te dabo terram hanc '."
,"13":"Et ascendit ab eo Deus."
,"14":"Ille vero erexit titulum lapideum in loco, quo locutus ei fuerat Deus, libans super eum libamina et effundens oleum"
,"15":"vocansque nomen loci illius Bethel."
,"16":"Egressi sunt de Bethel. Et adhuc spatium quoddam erat usque ad Ephratham, cum parturiret Rachel;"
,"17":"ob difficultatem partus periclitari coepit, dixitque ei obstetrix: ' Noli timere, quia et hac vice habes filium '."
,"18":"Egrediente autem anima et imminente iam morte, vocavit nomen filii sui Benoni (id est Filius doloris mei); pater vero appellavit eum Beniamin (id est Filius dextrae)."
,"19":"Mortua est ergo Rachel et sepulta est in via, quae ducit Ephratham; haec est Bethlehem."
,"20":"Erexitque Iacob titulum super sepulcrum eius; hic est titulus monumenti Rachel usque in praesentem diem."
,"21":"Egressus inde Israel, fixit tabernaculum trans Magdaleder (id est Turris gregis)."
,"22":"Cumque habitaret in illa regione, abiit Ruben et dormivit cum Bilha concubina patris sui; quod illum minime latuit. Erant autem filii Iacob duodecim. "
,"23":"Filii Liae: primogenitus Ruben et Simeon et Levi et Iudas et Issachar et Zabulon."
,"24":"Filii Rachel: Ioseph et Beniamin."
,"25":"Filii Bilhae ancillae Rachelis: Dan et Nephthali."
,"26":"Filii Zelphae ancillae Liae: Gad et Aser. Hi sunt filii Iacob, qui nati sunt ei in Paddanaram."
,"27":"Venit Iacob ad Isaac patrem suum in Mambre Cariatharbe, id est Hebron, ubi peregrinatus est Abraham et Isaac."
,"28":"Et completi sunt dies Isaac centum octoginta annorum;"
,"29":"consumptusque aetate mortuus est et appositus est populo suo senex et plenus dierum. Et sepelierunt eum Esau et Iacob filii sui."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Hae sunt autem generationes Esau. Ipse est Edom."
,"2":"Esau accepit uxores de filiabus Chanaan: Ada filiam Elon Hetthaei et Oolibama filiam Ana filii Sebeon Horraei;"
,"3":"Basemath quoque filiam Ismael sororem Nabaioth."
,"4":"Peperit autem Ada Eliphaz, Basemath genuit Rahuel,"
,"5":"Oolibama genuit Iehus et Ialam et Core. Hi filii Esau, qui nati sunt ei in terra Chanaan."
,"6":"Tulit autem Esau uxores suas et filios et filias et omnes animas domus suae et pecora armenta et cuncta, quae acquisierat in terra Chanaan, et abiit in terram Seir; recessitque a fratre suo Iacob."
,"7":"Divites enim erant valde et simul habitare non poterant; nec sustinebat eos terra peregrinationis eorum prae multitudine gregum."
,"8":"Habitavitque Esau in monte Seir. Ipse est Edom."
,"9":"Hae autem sunt generationes Esau patris Edom in monte Seir,"
,"10":"et haec nomina filiorum eius: Eliphaz filius Ada uxoris Esau, Rahuel quoque filius Basemath uxoris eius."
,"11":"Fueruntque Eliphaz filii: Theman, Omar, Sepho et Gatham et Cenez."
,"12":"Erat autem Thamna concubina Eliphaz filii Esau, quae peperit ei Amalec. Hi sunt filii Ada uxoris Esau."
,"13":"Filii autem Rahuel: Nahath et Zara, Samma et Meza; hi filii Basemath uxoris Esau."
,"14":"Isti erant filii Oolibama filiae Ana filii Sebeon uxoris Esau, quos genuit ei: Iehus et Ialam et Core."
,"15":"Hi duces filiorum Esau. Filii Eliphaz primogeniti Esau: dux Theman, dux Omar, dux Sepho, dux Cenez,"
,"16":"dux Core, dux Gatham, dux Amalec. Hi duces Eliphaz in terra Edom; hi filii Ada."
,"17":"Hi filii Rahuel filii Esau: dux Nahath, dux Zara, dux Samma, dux Meza. Hi duces Rahuel in terra Edom; isti filii Basemath uxoris Esau."
,"18":"Hi filii Oolibama uxoris Esau: dux Iehus, dux Ialam, dux Core. Hi duces Oolibama filiae Ana uxoris Esau."
,"19":"Isti sunt filii Esau et hi duces eorum. Ipse est Edom."
,"20":"Isti sunt filii Seir Horraei habitatores terrae: Lotan et Sobal et Sebeon et Ana"
,"21":"et Dison et Eser et Disan; hi duces Horraei filii Seir in terra Edom."
,"22":"Facti sunt autem filii Lotan: Hori et Hemam; erat autem soror Lotan Thamna."
,"23":"Et isti filii Sobal: Alvan et Manahath et Ebal, Sepho et Onam."
,"24":"Et hi filii Sebeon: Aia et Ana. Iste est Ana, qui invenit aquas calidas in solitudine, cum pasceret asinos Sebeon patris sui."
,"25":"Habuitque filium Dison et filiam Oolibama."
,"26":"Et isti filii Dison: Hemdan et Eseban et Iethran et Charran."
,"27":"Hi filii Eser: Bilhan et Zavan et Iacan."
,"28":"Habuit autem filios Disan: Us et Aran."
,"29":"Isti duces Horraeorum: dux Lotan, dux Sobal, dux Sebeon, dux Ana,"
,"30":"dux Dison, dux Eser, dux Disan; isti duces Horraeorum secundum tribus eorum in terra Seir."
,"31":"Reges autem, qui regnaverunt in terra Edom, antequam haberent regem filii Israel, fuerunt hi."
,"32":"Regnavit in Edom Bela filius Beor, nomenque urbis eius Denaba."
,"33":"Mortuus est autem Bela, et regnavit pro eo Iobab filius Zarae de Bosra."
,"34":"Cumque mortuus esset Iobab, regnavit pro eo Husam de terra Themanorum."
,"35":"Hoc quoque mortuo, regnavit pro eo Adad filius Badad, qui percussit Madian in regione Moab; et nomen urbis eius Avith."
,"36":"Cumque mortuus esset Adad, regnavit pro eo Semla de Masreca."
,"37":"Hoc quoque mortuo, regnavit pro eo Saul de Rohoboth iuxta fluvium."
,"38":"Cumque et hic obiisset, successit in regnum Baalhanan filius Achobor."
,"39":"Isto quoque mortuo, regnavit pro eo Adad, nomenque urbis eius Phau; et appellabatur uxor eius Meetabel filia Matred filiae Mezaab."
,"40":"Haec ergo nomina ducum Esau in cognationibus et locis et vocabulis suis: dux Thamna, dux Alva, dux Ietheth,"
,"41":"dux Oolibama, dux Ela, dux Phinon,"
,"42":"dux Cenez, dux Theman, dux Mabsar,"
,"43":"dux Magdiel, dux Iram. Hi duces Edom habitantes in terra imperii sui. Ipse est Esau pater Idumaeorum."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Habitavit autem Iacob in terra Chanaan, in qua pere grinatus est pater suus."
,"2":"Hae sunt generationes Iacob. Ioseph, cum decem et scptem esset annorum, pascebat gregem cum fratribus suis adhuc puer; et erat cum filiis Bilhae et Zelphae uxorum patris sui; detulitque patri malam eorum famam. "
,"3":"Israel autem diligebat Ioseph super omnes filios suos, eo quod in senectute genuisset eum; fecitque ei tunicam talarem."
,"4":"Videntes autem fratres eius quod a patre plus cunctis filiis amaretur, oderant eum nec poterant ei quidquam pacifice loqui."
,"5":"Accidit quoque ut visum somnium referret fratribus suis; quae causa maioris odii seminarium fuit."
,"6":"Dixitque ad eos: ' Audite somnium meum, quod vidi."
,"7":"Putabam ligare nos manipulos in agro, et quasi consurgere manipulum meum et stare, vestrosque manipulos circumstantes adorare manipulum meum '."
,"8":"Responderunt fratres eius: ' Numquid rex noster eris? Aut subiciemur dicioni tuae? '. Haec ergo causa somniorum atque sermonum, invidiae et odii fomitem ministravit."
,"9":"Aliud quoque vidit somnium, quod narrans fratribus ait: ' Vidi per somnium quasi solem et lunam et stellas undecim adorare me '."
,"10":"Quod cum patri suo et fratribus retulisset, increpavit eum pater suus et dixit: ' Quid sibi vult hoc somnium, quod vidisti? Num ego et mater tua et fratres tui adorabimus te proni in terram? '."
,"11":"Invidebant igitur ei fratres sui; pater vero rem tacitus considerabat."
,"12":"Cumque fratres illius in pascendis gregibus patris morarentur in Sichem,"
,"13":"dixit Israel ad Ioseph: ' Fratres tui pascunt oves in Sichimis; veni, mittam te ad eos '. Quo respondente:"
,"14":"' Praesto sum ', ait ei: ' Vade et vide, si cuncta prospera sint erga fratres tuos et pecora, et renuntia mihi quid agatur '. Missus de valle Hebron venit in Sichem;"
,"15":"invenitque eum vir errantem in agro et interrogavit quid quaereret."
,"16":"At ille respondit: ' Fratres meos quaero; indica mihi, ubi pascant greges '."
,"17":"Dixitque ei vir: ' Recesserunt de loco isto; audivi autem eos dicentes: 'Eamus in Dothain' '. Perrexit ergo Ioseph post fratres suos et invenit eos in Dothain."
,"18":"Qui cum vidissent eum procul, antequam accederet ad eos, cogitaverunt illum occidere."
,"19":"Et mutuo loquebantur: ' Ecce somniator venit;"
,"20":"venite, occidamus eum et mittamus in unam cisternarum dicemusque: Fera pessima devoravit eum. Et tunc apparebit quid illi prosint somnia sua '."
,"21":"Audiens autem hoc Ruben nitebatur liberare eum de manibus eorum et dixit:"
,"22":"' Non interficiamus animam eius '. Et dixit ad eos: ' Non effundatis sanguinem; sed proicite eum in cisternam hanc, quae est in solitudine, manusque vestras servate innoxias '. Hoc autem dicebat volens eripere eum de manibus eorum et reddere patri suo."
,"23":"Confestim igitur, ut pervenit ad fratres suos, nudaverunt eum tunica talari"
,"24":"miseruntque eum in cisternam, quae non habebat aquam."
,"25":"Et sederunt, ut comederent panem. Attollentes autem oculos viderunt Ismaelitas viatorcs venire de Galaad et camelos eorum portantes tragacanthum et masticem et ladanum in Aegyptum."
,"26":"Dixit ergo Iudas fratribus suis: ' Quid nobis prodest, si occiderimus fratrem nostrum et celaverimus sanguinem ipsius?"
,"27":"Melius est ut vendatur Ismaelitis, et manus nostrae non polluantur; frater enim et caro nostra est '. Acquieverunt fratres sermonibus illius."
,"28":"Et praetereuntibus Madianitis negotiatoribus, extrahentes Ioseph de cisterna, vendiderunt eum Ismaelitis viginti argenteis. Qui duxerunt eum in Aegyptum."
,"29":"Reversusque Ruben ad cisternam non invenit puerum"
,"30":"et, scissis vestibus, pergens ad fratres suos ait: ' Puer non comparet, et ego quo ibo? '."
,"31":"Tulerunt autem tunicam eius et in sanguinem haedi, quem occiderant, tinxerunt"
,"32":"mittentes, qui ferrent ad patrem et dicerent: 'Hanc invenimus; vide, utrum tunica talaris filii tui sit an non? '."
,"33":"Quam cum agnovisset pater, ait: ' Tunica filii mei est; fera pessima comedit eum, bestia devoravit Ioseph '."
,"34":"Scissisque vestibus, indutus est cilicio lugens filium suum multo tempore."
,"35":"Congregatis autem cunctis liberis eius, ut lenirent dolorem patris, noluit consolationem accipere et ait: ' Descendam ad filium meum lugens in infernum '. Et flevit super eo pater eius."
,"36":"Madianitae autem vendiderunt Ioseph in Aegypto Putiphari eunucho pharaonis, magistro satellitum."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Eo tempore descendens Iudas a fratribus suis divertit ad virum Odollamitem nomine Hiram."
,"2":"Viditque ibi filiam hominis Chananaei vocabulo Sue et, accepta uxore, ingressus est ad eam."
,"3":"Quae concepit et peperit filium vocavitque nomen eius Her."
,"4":"Rursumque concepto fetu, natum filium nominavit Onan."
,"5":"Tertium quoque peperit, quem appellavit Sela. Ipsa autem erat in Chasib, quando peperit illum."
,"6":"Dedit autem Iudas uxorem primogenito suo Her nomine Thamar."
,"7":"Fuit quoque Her primogenitus Iudae nequam in conspectu Domini, et ab eo occisus est."
,"8":"Dixit ergo Iudas ad Onan: ' Ingredere ad uxorem fratris tui et sociare illi, ut suscites semen fratri tuo '."
,"9":"Ille, sciens non sibi nasci hunc filium, introiens ad uxorem fratris sui semen fundebat in terram, ne proles fratris nomine nasceretur."
,"10":"Et idcirco occidit et eum Dominus, quod rem detestabilem fecerat."
,"11":"Quam ob rem dixit Iudas Thamar nurui suae: ' Esto vidua in domo patris tui, donec crescat Sela filius meus '. Timebat, enim, ne et ipse moreretur sicut fratres eius. Quae abiit et habitavit in domo patris sui."
,"12":"Evolutis autem multis diebus, mortua est filia Sue uxor Iudae. Qui, post luctum consolatione suscepta, ascendebat ad tonsores ovium suarum ipse et Hiras amicus suus Odollamites in Thamnam."
,"13":"Nuntiatumque est Thamar quod socer illius ascenderet in Thamnam ad tondendas oves."
,"14":"Quae, depositis viduitatis vestibus, cooperuit se velo et, mutato habitu, sedit in porta Enaim in via, quae ducit Thamnam; eo quod crevisset Sela, et non eum accepisset maritum."
,"15":"Quam cum vidisset Iudas, suspicatus est esse meretricem; operuerat enim vultum suum."
,"16":"Declinansque ad eam in via ait: ' Veni, coeam tecum '; nesciebat enim quod nurus sua esset. Qua respondente: ' Quid mihi dabis, ut fruaris concubitu meo? ',"
,"17":"dixit: ' Mittam tibi haedum de gregibus '. Rursum illa dicente: ' Si dederis mihi arrabonem, donec mittas illum ',"
,"18":"ait Iudas: ' Quid vis tibi pro arrabone dari? '. Respondit: ' Sigillum tuum et funiculum et baculum, quem manu tenes '. Et dedit ei. In coitu cum eo mulier concepit"
,"19":"et surgens abiit; depositoque velo, induta est viduitatis vestibus."
,"20":"Misit autem Iudas haedum per amicum suum Odollamitem, ut reciperet pignus, quod dederat mulieri. Qui cum non invenisset eam,"
,"21":"interrogavit homines loci illius: ' Ubi est meretrix, quae sedebat in Enaim in via? '. Respondentibus cunctis: ' Non fuit in loco isto meretrix ',"
,"22":"reversus est ad Iudam et dixit ei: ' Non inveni eam; sed et homines loci illius dixerunt mihi numquam ibi sedisse scortum '."
,"23":"Ait Iudas: ' Habeat sibi; ne simus in ludibrium. Ego misi haedum, quem promiseram, et tu non invenisti eam '."
,"24":"Ecce autem post tres menses nuntiaverunt Iudae dicentes: ' Fornicata est Thamar nurus tua et gravida est ex fornicatione '. Dixitque Iudas: ' Producite eam, ut comburatur '."
,"25":"Quae cum educeretur ad poenam, misit ad socerum suum dicens: ' De viro, cuius haec sunt, concepi; cognosce cuius sit sigillum et funiculus et baculus '."
,"26":"Qui, agnitis pignoribus, ait: ' Iustior me est, quia non tradidi eam Sela filio meo '. Attamen ultra non cognovit illam."
,"27":"Instante autem partu, apparuerunt gemini in utero; atque in ipsa effusione infantium unus protulit manum, in qua obstetrix ligavit coccinum dicens:"
,"28":"' Iste egressus est prior '."
,"29":"Illo vero retrahente manum, egressus est frater eius; dixitque mulier: ' Qualem rupisti tibi rupturam? '. Et ob hanc causam vocatum est nomen eius Phares (id est Ruptura)."
,"30":"Postea egressus est frater eius, in cuius manu erat coccinum; qui appellatus est Zara (id est Ortus solis)."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Igitur Ioseph ductus est in Aegyptum; emitque eum Pu tiphar eunuchus pharaonis, princeps satellitum, vir Aegyptius, de manu Ismaelitarum, a quibus perductus erat."
,"2":"Fuitque Dominus cum eo, et erat vir in cunctis prospere agens habitabatque in domo domini sui."
,"3":"Qui optime noverat esse Dominum cum eo et omnia, quae gereret, ab eo dirigi in manu illius."
,"4":"Invenitque loseph gratiam coram domino suo et ministrabat ei. Et factum est, postquam praeposuit eum domui suae et omnia, quae possidebat, tradidit in manum eius,"
,"5":"benedixit Dominus domui Aegyptii propter Ioseph, et benedictio Domini erat in omni possessione eius tam in aedibus quam in agris."
,"6":"Et reliquit omnia, quae possidebat, in manu Ioseph nec cum eo quidquam aliud noverat nisi panem, quo vescebatur. Erat autem Ioseph pulchra facie et decorus aspectu."
,"7":"Post haec ergo iniecit uxor domini eius oculos suos in Ioseph et ait: ' Dormi mecum '."
,"8":"Qui nequaquam acquiescens dixit ad eam: ' Ecce dominus meus, omnibus mihi traditis, non curat de ulla re in domo sua,"
,"9":"nec quisquam maior est in domo hac quam ego, et nihil mihi subtraxit praeter te, quae uxor eius es. Quomodo ergo possum malum hoc magnum facere et peccare in Deum? '."
,"10":"Huiuscemodi verbis per singulos dies et mulier molesta erat adulescenti, et ille recusabat stuprum."
,"11":"Accidit autem quadam die, ut intraret Ioseph domum et opus suum absque arbitris faceret;"
,"12":"illa, apprehensa lacinia vestimenti eius, dixit: ' Dormi mecum '. Qui, relicto in manu illius pallio, fugit et egressus est foras."
,"13":"Cumque vidisset illum mulier vestem reliquisse in manibus suis et fugisse foras,"
,"14":"vocavit homines domus suae et ait ad eos: ' En introduxit virum Hebraeum, ut illuderet nobis; ingressus est ad me, ut coiret mecum. Cumque ego succlamassem,"
,"15":"et audisset vocem meam, reliquit pallium, quod tenebam, et fugit foras '."
,"16":"Retentum pallium ostendit marito revertenti domum"
,"17":"et secundum verba haec locuta est: ' Ingressus est ad me servus Hebraeus, quem adduxisti, ut illuderet mihi;"
,"18":"cumque audisset me clamare, reliquit pallium, quod tenebam, et fugit foras '."
,"19":"Dominus, auditis his verbis coniugis, iratus est valde;"
,"20":"tradiditque Ioseph in carcerem, ubi vincti regis custodiebantur. Et erat ibi clausus."
,"21":"Fuit autem Dominus cum Ioseph et misertus illius dedit ei gratiam in conspectu principis carceris."
,"22":"Qui tradidit in manu Ioseph universos vinctos, qui in custodia tenebantur, et, quidquid ibi faciendum erat, ipse faciebat,"
,"23":"nec princeps carceris spectabat quidquid in manu eius erat: Dominus enim erat cum illo et omnia opera eius dirigebat."
}`)
	CurrentBook.AddChapter(40, `{
"1":"His ita gestis, accidit ut peccarent pincerna regis Aegypti et pistor domino suo."
,"2":"Iratusque pharao contra duos eunuchos, praepositum pincernarum et praepositum pistorum,"
,"3":"misit eos in carcerem principis satellitum, in quo erat vinctus et Ioseph."
,"4":"Et princeps satellitum tradidit eos Ioseph, qui ministrabat eis. Aliquantulum temporis illi in custodia tenebantur."
,"5":"Videruntque ambo somnium nocte una iuxta interpretationem congruam sibi."
,"6":"Ad quos cum introisset Ioseph mane et vidisset eos tristes,"
,"7":"sciscitatus est eos dicens: ' Cur tristior est hodie solito facies vestra? '."
,"8":"Qui responderunt: ' Somnium vidimus, et non est qui interpretetur nobis '. Dixitque ad eos Ioseph: ' Numquid non Dei est interpretatio? Referte mihi quid videritis '."
,"9":"Narravit praepositus pincernarum somnium suum: ' Videbam coram me vitem,"
,"10":"in qua erant tres propagines, crescere paulatim in gemmas et post flores uvas maturescere;"
,"11":"calicemque pharaonis in manu mea. Tuli ergo uvas et expressi in calicem, quem tenebam, et tradidi poculum pharaoni '."
,"12":"Respondit Ioseph: ' Haec est interpretatio somnii: tres propagines, tres adhuc dies sunt,"
,"13":"post quos elevabit pharao caput tuum et restituet te in gradum pristinum; dabisque ei calicem iuxta officium tuum, sicut facere ante consueveras."
,"14":"Tantum memento mei, cum tibi bene fuerit, et facias mecum misericordiam, ut suggeras pharaoni, ut educat me de isto carcere;"
,"15":"quia furto sublatus sum de terra Hebraeorum et hic innocens in lacum missus sum '."
,"16":"Videns pistorum magister quod somnium in bonum dissolvisset, ait: ' Et ego vidi somnium, quod tria canistra farinae haberem super caput meum;"
,"17":"et in uno canistro, quod erat excelsius, portare me ex omnibus cibis pharaonis, qui fiunt arte pistoria, avesque comedere eos '."
,"18":"Respondit Ioseph: ' Haec est interpretatio somnii: tria canistra, tres adhuc dies sunt,"
,"19":"post quos auferet pharao caput tuum ac suspendet te in patibulo, et comedent volucres carnes tuas '."
,"20":"Exinde dies tertius natalicius pharaonis erat; qui faciens grande convivium pueris suis elevavit caput magistri pincernarum et caput pistorum principis in medio puerorum suorum;"
,"21":"restituitque alterum in locum suum, ut porrigeret ei poculum,"
,"22":"alterum suspendit in patibulo, sicut interpretatus erat eis Ioseph."
,"23":"Attamen praepositus pincernarum non est recordatus Ioseph, sed oblitus est interpretis sui."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Post duos annos vidit pharao somnium. Putabat se stare super fluvium,"
,"2":"de quo ascendebant septem boves pulchrae et crassae et pascebantur in locis palustribus."
,"3":"Aliae quoque septem emergebant post illas de flumine foedae confectaeque macie et stabant in ipsa amnis ripa;"
,"4":"devoraveruntque septem boves pulchras et crassas. Expergefactus pharao"
,"5":"rursum dormivit et vidit alterum somnium. Septem spicae pullulabant in culmo uno plenae atque formosae."
,"6":"Aliae quoque totidem spicae tenues et percussae vento urente oriebantur"
,"7":"devorantes omnem priorum pulchritudinem. Evigilavit pharao, et ecce erat somnium!"
,"8":"Et, facto mane, pavore perterritus misit ad omnes coniectores Aegypti cunctosque sapientes suos; et accersitis narravit somnium, nec erat qui interpretaretur."
,"9":"Tunc demum reminiscens pincernarum magister ait: ' Confiteor peccatum meum."
,"10":"Iratus rex servis suis me et magistrum pistorum retrudi iussit in carcerem principis satellitum,"
,"11":"ubi una nocte uterque vidimus somnium praesagum futurorum."
,"12":"Erat ibi puer Hebraeus eiusdem ducis satellitum famulus, cui narrantes somnia"
,"13":"audivimus quidquid postea rei probavit eventus. Ego enim redditus sum officio meo, et ille suspensus est in patibulo '."
,"14":"Protinus ad regis imperium eductum de carcere Ioseph totonderunt ac, veste mutata, obtulerunt ei."
,"15":"Cui ille ait: ' Vidi somnia, nec est qui edisserat; quae audivi te sapientissime conicere '."
,"16":"Respondit Ioseph: ' Absque me Deus respondebit prospera pharaoni! '."
,"17":"Narravit ergo pharao, quod viderat: ' Putabam me stare super ripam fluminis"
,"18":"et septem boves de amne conscendere pulchras nimis et obesis carnibus, quae in pastu paludis virecta carpebant."
,"19":"Et ecce has sequebantur aliae septem boves in tantum deformes et macilentae, ut numquam tales in terra Aegypti viderim;"
,"20":"quae, devoratis et consumptis prioribus,"
,"21":"nullum saturitatis dedere vestigium; sed simili macie et squalore torpebant. Evigilans, rursus sopore depressus,"
,"22":"vidi somnium: Septem spicae pullulabant in culmo uno plenae atque pulcherrimae."
,"23":"Aliae quoque septem tenues et percussae vento urente oriebantur e stipula;"
,"24":"quae priorum pulchritudinem devoraverunt. Narravi coniectoribus somnium, et nemo est qui edisserat '."
,"25":"Respondit Ioseph: ' Somnium regis unum est: quae facturus est, Deus ostendit pharaoni."
,"26":"Septem boves pulchrae et septem spicae plenae septem ubertatis anni sunt; eandemque vim somnii comprehendunt."
,"27":"Septem quoque boves tenues atque macilentae, quae ascenderunt post eas, et septem spicae tenues et vento urente percussae septem anni sunt venturae famis,"
,"28":"qui hoc ordine complebuntur:"
,"29":"ecce septem anni venient fertilitatis magnae in universa terra Aegypti;"
,"30":"quos sequentur septem anni alii tantae sterilitatis, ut oblivioni tradatur cuncta retro abundantia. Consumptura est enim fames omnem terram,"
,"31":"et ubertatis magnitudinem perditura est inopiae magnitudo."
,"32":"Quod autem vidisti secundo ad eandem rem pertinens somnium, firmitatis indicium est, eo quod fiat sermo Dei et velocius a Deo impleatur."
,"33":"Nunc ergo provideat rex virum intellegentem et sapientem et praeficiat eum terrae Aegypti"
,"34":"constituatque praepositos per cunctas regiones et quintam partem fructuum per septem annos fertilitatis,"
,"35":"qui iam nunc futuri sunt, congreget in horrea; et omne frumentum sub pharaonis potestate condatur serveturque in urbibus;"
,"36":"et paretur futurae septem annorum fami, quae pressura est Aegyptum, et non consumetur terra inopia '."
,"37":"Placuit pharaoni consilium et cunctis ministris eius."
,"38":"Locutusque est ad eos: ' Num invenire poterimus talem virum, qui spiritu Dei plenus sit? '."
,"39":"Dixit ergo ad Ioseph: ' Quia ostendit tibi Deus omnia, quae locutus es, numquid sapientiorem et consimilem tui invenire potero?"
,"40":"Tu eris super domum meam, et ad tui oris imperium cunctus populus meus oboediet; uno tantum regni solio te praecedam '."
,"41":"Dixitque rursus pharao ad Ioseph: ' Ecce, constitui te super universam terram Aegypti '."
,"42":"Tulitque anulum de manu sua et dedit eum in manu eius; vestivitque eum stola byssina et collo torquem auream circumposuit."
,"43":"Fecitque eum ascendere super currum suum secundum, clamante praecone: ' Abrech! ', ut omnes coram eo genuflecterent et praepositum esse scirent universae terrae Aegypti."
,"44":"Dixit quoque rex ad Ioseph: ' Ego sum pharao; absque tuo imperio non movebit quisquam manum aut pedem in omni terra Aegypti '."
,"45":"Vertitque nomen eius et vocavit eum lingua Aegyptiaca Saphaneth Phanec (quod interpretatur Salvator mundi) deditque illi uxorem Aseneth filiam Putiphare sacerdotis Heliopoleos. Egressus est itaque Ioseph ad terram Aegypti "
,"46":"triginta autem annorum erat quando stetit in conspectu regis pharaonis et circuivit omnes regiones Aegypti."
,"47":"Venitque fertilitas septem annorum, et segetes congregavit in horrea Aegypti"
,"48":"condens in singulis urbibus frumentum camporum in circuitu."
,"49":"Tantaque fuit abundantia tritici, ut arenae maris coaequaretur, et copia mensuram excederet."
,"50":"Nati sunt autem Ioseph filii duo, antequam veniret fames, quos ei peperit Aseneth filia Putiphare sacerdotis Heliopoleos."
,"51":"Vocavitque nomen primogeniti Manasses dicens: ' Oblivisci me fecit Deus omnium laborum meorum et domus patris mei '."
,"52":"Nomen quoque secundi appellavit Ephraim dicens: ' Crescere me fecit Deus in terra paupertatis meae '."
,"53":"Igitur, transactis septem annis ubertatis, qui fuerant in Aegypto,"
,"54":"coeperunt venire septem anni inopiae, quos praedixerat Ioseph, et in universo orbe fames praevaluit; in cuncta autem terra Aegypti erat panis."
,"55":"Qua esuriente, clamavit populus ad pharaonem alimenta petens. Quibus ille respondit: ' Ite ad Ioseph et, quidquid vobis dixerit, facite '."
,"56":"Et invaluit fames in omni terra Aegypti; aperuitque Ioseph universa horrea et vendebat Aegyptiis; nam et illos oppresserat fames."
,"57":"Omnesque provinciae veniebant in Aegyptum, ut emerent escas apud Ioseph, quia inopia invaluerat in universa terra."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Audiens autem Iacob quod alimenta venderentur in Ae gypto, dixit filiis suis: ' Quare aspicitis vos invicem?"
,"2":"Audivi quod triticum venumdetur in Aegypto; descendite et emite nobis necessaria, ut possimus vivere et non consumamur inopia '."
,"3":"Descenderunt igitur fratres Ioseph decem, ut emerent frumenta in Aegypto,"
,"4":"Beniamin fratre Ioseph domi retento a Iacob, qui dixerat fratribus eius: ' Ne forte in itinere quidquam patiatur mali '."
,"5":"Et ingressi sunt filii Israel terram Aegypti cum aliis, qui pergebant ad emendum. Erat autem fames in terra Chanaan."
,"6":"Et Ioseph erat princeps in terra Aegypti, atque ad eius nutum frumenta populis vendebantur. Cumque venissent et adorassent eum fratres sui proni in terram,"
,"7":"et agnovisset eos, quasi ad alienos durius loquebatur interrogans eos: ' Unde venistis? '. Qui responderunt: ' De terra Chanaan, ut emamus victui necessaria '."
,"8":"Et tamen fratres ipse cognoscens non est cognitus ab eis."
,"9":"Recordatusque somniorum, quae aliquando viderat, ait ad eos: ' Exploratores estis; ut videatis infirmiora terrae, venistis! '."
,"10":"Qui dixerunt: ' Non est ita, domine; sed servi tui venerunt, ut emerent cibos."
,"11":"Omnes filii unius viri sumus; sinceri sumus, nec quidquam famuli tui machinantur mali '."
,"12":"Quibus ille respondit: ' Aliter est; immunita terrae huius considerare venistis! '."
,"13":"At illi: ' Duodecim, inquiunt, servi tui fratres sumus filii viri unius in terra Chanaan; minimus cum patre nostro est, alius non est super '."
,"14":"' Hoc est, ait, quod locutus sum: exploratores estis!"
,"15":"Iam nunc experimentum vestri capiam: per salutem pharaonis, non egrediemini hinc, donec veniat frater vester minimus!"
,"16":"Mittite ex vobis unum, et adducat eum; vos autem eritis in vinculis, donec probentur, quae dixistis, utrum vera an falsa sint. Alioquin, per salutem pharaonis, exploratores estis! '."
,"17":"Tradidit ergo illos custodiae tribus diebus."
,"18":"Die autem tertio eductis de carcere, ait: ' Facite, quae dixi, et vivetis; Deum enim timeo."
,"19":"Si sinceri estis, frater vester unus ligetur in carcere; vos autem abite et ferte frumenta, quae emistis, in domos vestras,"
,"20":"et fratrem vestrum minimum ad me adducite, ut possim vestros probare sermones, et non moriamini '. Fecerunt, ut dixerat, "
,"21":"et locuti sunt ad invicem: ' Merito haec patimur, quia peccavimus in fratrem nostrum videntes angustiam animae illius, cum deprecaretur nos, et non audivimus. Idcirco venit super nos ista tribulatio '."
,"22":"Et Ruben ait: ' Numquid non dixi vobis: Nolite peccare in puerum? Et non audistis me. En sanguis eius exquiritur '."
,"23":"Nesciebant autem quod intellegeret Ioseph, eo quod per interpretem loquebatur ad eos."
,"24":"Avertitque se parumper et flevit; et reversus locutus est ad eos."
,"25":"Tollensque Simeon et ligans, illis praesentibus, iussit ministris, ut implerent eorum saccos tritico et reponerent pecunias singulorum in sacculis suis, datis supra cibariis in viam. Qui fecerunt ita."
,"26":"At illi portantes frumenta in asinis suis profecti sunt."
,"27":"Apertoque unus sacco, ut daret iumento pabulum in deversorio, contemplatus pecuniam in ore sacculi"
,"28":"dixit fratribus suis: ' Reddita est mihi pecunia: en habetur in sacco! '. Et obstupefacti turbatique mutuo dixerunt: ' Quidnam est hoc, quod fecit nobis Deus? '."
,"29":"Veneruntque ad Iacob patrem suum in terram Chanaan; et narraverunt ei omnia, quae accidissent sibi, dicentes:"
,"30":"' Locutus est nobis dominus terrae dure et putavit nos exploratores esse provinciae '."
,"31":"Cui respondimus: ' Sinceri sumus, nec ullas molimur insidias;"
,"32":"duodecim fratres uno patre geniti sumus, unus non est super, minimus cum patre nostro est in terra Chanaan."
,"33":"Et dixit nobis vir, dominus terrae: 'Sic probabo quod sinceri sitis: fratrem vestrum unum dimittite apud me et cibaria domibus vestris necessaria sumite et abite;"
,"34":"fratremque vestrum minimum adducite ad me, ut sciam quod non sitis exploratores et istum, qui tenetur in vinculis, recipere possitis ac deinceps peragrandi terram habeatis licentiam' '."
,"35":"His dictis, cum frumenta effunderent, singuli reppererunt in ore saccorum ligatas pecunias; exterritisque simul omnibus,"
,"36":"dixit pater Iacob: ' Absque liberis me esse fecistis: Ioseph non est super, Simeon tenetur in vinculis, et Beniamin auferetis. In me haec omnia mala reciderunt '."
,"37":"Cui respondit Ruben: ' Duos filios meos interfice, si non reduxero illum tibi; trade illum in manu mea, et ego eum tibi restituam '."
,"38":"At ille: ' Non descendet, inquit, filius meus vobiscum. Frater mortuus est, et ipse solus remansit; si quid ei adversi acciderit in via, deducetis canos meos cum dolore ad inferos '."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Interim fames omnem terram vehementer premebat;"
,"2":"consumptisque cibis, quos ex Aegypto detulerant, dixit Iacob ad filios suos: ' Revertimini et emite nobis pauxillum escarum '."
,"3":"Respondit Iudas: ' Denuntiavit nobis vir ille sub attestatione iurisiurandi dicens: 'Non videbitis faciem meam, nisi fratrem vestrum minimum adduxeritis vobiscum'."
,"4":"Si ergo vis eum mittere nobiscum, pergemus pariter et ememus tibi necessaria;"
,"5":"sin autem non vis, non ibimus. Vir enim, ut saepe diximus, denuntiavit nobis dicens: 'Non videbitis faciem meam absque fratre vestro minimo' '."
,"6":"Dixit eis Israel: ' Cur in meam hoc fecistis miseriam, ut indicaretis ei et alium habere vos fratrem? '."
,"7":"At illi responderunt: ' Interrogavit nos homo per ordinem nostram progeniem: si pater viveret, si haberemus fratrem; et nos respondimus ei consequenter iuxta id, quod fuerat sciscitatus. Numquid scire poteramus quod dicturus esset: 'Adducite fratrem vestrum vobiscum?' '."
,"8":"Iudas quoque dixit patri suo Israel: ' Mitte puerum mecum, ut proficiscamur et possimus vivere, ne moriamur nos et tu et parvuli nostri."
,"9":"Ego spondeo pro puero; de manu mea require illum. Nisi reduxero et reddidero eum tibi, ero peccati reus in te omni tempore."
,"10":"Si non intercessisset dilatio, iam vice altera venissemus '."
,"11":"Igitur Israel pater eorum dixit ad eos: ' Si sic necesse est, facite, quod vultis; sumite de optimis terrae fructibus in vasis vestris et deferte viro munera: modicum resinae et mellis et tragacanthum et ladanum, pistacias terebinthi et amygdalas."
,"12":"Pecuniam quoque duplicem ferte vobiscum et illam, quam invenistis in sacculis, reportate, ne forte errore factum sit;"
,"13":"sed et fratrem vestrum tollite et ite ad virum."
,"14":"Deus autem meus omnipotens faciat vobis eum placabilem, et remittat vobiscum fratrem vestrum, quem tenet, et hunc Beniamin. Ego autem quasi orbatus absque liberis ero '."
,"15":"Tulerunt ergo viri munera et pecuniam duplicem et Beniamin descenderuntque in Aegyptum; et steterunt coram Ioseph."
,"16":"Quos cum ille vidisset et Beniamin simul, praecepit dispensatori domus suae dicens: ' Introduc viros domum et occide victimas et instrue convivium, quoniam mecum sunt comesturi meridie '."
,"17":"Fecit ille, quod sibi fuerat imperatum, et introduxit viros in domum Ioseph."
,"18":"Ibique exterriti dixerunt mutuo: ' Propter pecuniam, quam rettulimus prius in saccis nostris, introducti sumus, ut irruant in nos et violenter subiciant servituti et nos et asinos nostros '."
,"19":"Quam ob rem in ipsis foribus accedentes ad dispensatorem domus"
,"20":"locuti sunt: ' Oramus, domine, ut audias nos. Iam ante descendimus, ut emeremus escas;"
,"21":"quibus emptis, cum venissemus ad deversorium, aperuimus saccos nostros et invenimus pecuniam in ore saccorum; quam nunc eodem pondere reportavimus."
,"22":"Sed et aliud attulimus argentum, ut emamus, quae nobis necessaria sunt. Non est in nostra conscientia, quis posuerit argentum in marsupiis nostris '."
,"23":"At ille respondit: ' Pax vobiscum, nolite timere. Deus vester et Deus patris vestri dedit vobis thesauros in saccis vestris; nam pecuniam, quam dedistis mihi, probatam ego habeo '. Eduxitque ad eos Simeon."
,"24":"Et introductis domum attulit aquam, et laverunt pedes suos; deditque pabulum asinis eorum."
,"25":"Illi vero parabant munera, donec ingrederetur Ioseph meridie; audierant enim quod ibi comesturi essent panem."
,"26":"Igitur ingressus est Ioseph domum suam, obtuleruntque ei munera tenentes in manibus suis; et adoraverunt proni in terram."
,"27":"At ille, clementer resalutatis eis, interrogavit eos dicens: ' Salvusne est pater vester senex, de quo dixeratis mihi? Adhuc vivit? '."
,"28":"Qui responderunt: ' Sospes est servus tuus pater noster, adhuc vivit '. Et incurvati adoraverunt eum."
,"29":"Attollens autem Ioseph oculos vidit Beniamin fratrem suum uterinum et ait: ' Iste est frater vester parvulus, de quo dixeratis mihi? '. Et rursum: ' Deus, inquit, misereatur tui, fili mi '."
,"30":"Festinavitque, quia commota fuerant viscera eius super fratre suo, et erumpebant lacrimae; et introiens cubiculum flevit."
,"31":"Rursumque, lota facie, egressus continuit se et ait: ' Ponite panes '."
,"32":"Quibus appositis, seorsum Ioseph et seorsum fratribus, Aegyptiis quoque, qui vescebantur simul, seorsum illicitum est enim Aegyptiis comedere cum Hebraeis, et profanum putant huiuscemodi convivium"
,"33":"sederunt coram eo, primogenitus iuxta primogenita sua et minimus iuxta aetatem suam. Et mirabantur nimis,"
,"34":"sumptis partibus, quas ab eo acceperant; maiorque pars venit Beniamin, ita ut quinque partibus excederet. Biberuntque et inebriati sunt cum eo."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Praecepit autem Ioseph dispensatori domus suae dicens: ' Imple saccos eorum frumento, quantum possunt capere, et pone pecuniam singulorum in summitate sacci."
,"2":"Scyphum autem meum argenteum et pretium, quod dedit tritici, pone in ore sacci iunioris '. Factumque est ita."
,"3":"Et, orto mane, dimissi sunt cum asinis suis."
,"4":"Iamque urbem exierant et processerant paululum, tunc Ioseph, arcessito dispensatore domus: ' Surge, inquit, et persequere viros; et apprehensis dicito: 'Quare reddidistis malum pro bono? Cur furati estis mihi scyphum argenteum?"
,"5":"Nonne ipse est, in quo bibit dominus meus et in quo augurari solet? Pessimam rem fecistis!' '."
,"6":"Fecit ille, ut iusserat, et apprehensis per ordinem locutus est."
,"7":"Qui responderunt: ' Quare sic loquitur dominus noster? Absit a servis tuis, ut tantum flagitii commiserimus."
,"8":"Pecuniam, quam invenimus in summitate saccorum, reportavimus ad te de terra Chanaan; et quomodo consequens est, ut furati simus de domo domini tui aurum vel argentum?"
,"9":"Apud quemcumque fuerit inventum servorum tuorum, quod quaeris, moriatur; et nos erimus servi domini nostri '."
,"10":"Qui dixit eis: ' Fiat iuxta vestram sententiam: apud quemcumque fuerit inventum, ipse sit servus meus; vos autem eritis innoxii '."
,"11":"Itaque festinato deponentes in terram saccos aperuerunt singuli."
,"12":"Quos scrutatus incipiens a maiore usque ad minimum invenit scyphum in sacco Beniamin."
,"13":"At illi, scissis vestibus, oneratisque rursum asinis, reversi sunt in oppidum."
,"14":"Et Iudas cum fratribus ingressus est ad Ioseph necdum enim de loco abierat omnesque ante eum pariter in terram corruerunt."
,"15":"Quibus ille ait: ' Cur sic agere voluistis? An ignoratis quod non sit similis mei in augurandi scientia? '."
,"16":"Cui Iudas: ' Quid respondebimus, inquit, domino meo? Vel quid loquemur aut iuste poterimus obtendere? Deus invenit iniquitatem servorum tuorum; en omnes servi sumus domini mei, et nos et apud quem inventus est scyphus '."
,"17":"Respondit Ioseph: ' Absit a me, ut sic agam! Qui furatus est scyphum, ipse sit servus meus; vos autem abite liberi ad patrem vestrum '."
,"18":"Accedens autem propius Iudas confidenter ait: ' Oro, domine mi, loquatur servus tuus verbum in auribus tuis, et ne irascaris famulo tuo; tu es enim sicut pharao!"
,"19":"Dominus meus interrogavit prius servos suos: 'Habetis patrem aut fratrem?'."
,"20":"Et nos respondimus domino meo: 'Est nobis pater senex et puer parvulus, qui in senectute illius natus est, cuius uterinus frater mortuus est; et ipse solus superest a matre sua, pater vero tenere diligit eum' '."
,"21":"Dixistique servis tuis: 'Adducite eum ad me, et ponam oculos meos super illum'."
,"22":"Suggessimus domino meo: 'Non potest puer relinquere patrem suum; si enim illum dimiserit, morietur'."
,"23":"Et dixisti servis tuis: 'Nisi venerit frater vester minimus vobiscum, non videbitis amplius faciem meam'."
,"24":"Cum ergo ascendissemus ad famulum tuum patrem nostrum, narravimus ei omnia, quae locutus est dominus meus,"
,"25":"et dixit pater noster: 'Revertimini et emite nobis parum tritici'."
,"26":"Cui diximus: 'Ire non possumus. Si frater noster minimus descenderit nobiscum, proficiscemur simul; alioquin, illo absente, non poterimus videre faciem viri'."
,"27":"Ad quae servus tuus pater meus respondit: 'Vos scitis quod duos genuerit mihi uxor mea."
,"28":"Egressus est unus a me, et dixi: Bestia devoravit eum! Et hucusque non comparet."
,"29":"Si tuleritis et istum a facie mea, et aliquid ei in via contigerit, deducetis canos meos cum maerore ad inferos'."
,"30":"Igitur, si intravero ad servum tuum patrem meum, et puer defuerit cum anima illius ex huius anima pendeat"
,"31":"videritque eum non esse nobiscum, morietur; et deducent famuli tui canos eius cum dolore ad inferos."
,"32":"Servus tuus pro puero patri meo spopondit: Nisi reduxero eum, peccati reus ero in patrem meum omni tempore."
,"33":"Manebo itaque servus tuus pro puero in ministerio domini mei, et puer ascendat cum fratribus suis."
,"34":"Non enim possum redire ad patrem meum, absente puero, ne calamitatis, quae oppressura est patrem meum, testis assistam '."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Non se poterat ultra cohibere Ioseph omnibus coram astantibus, unde clamavit: ' Egredimini, cuncti, foras! '. Et nemo aderat cum eo, quando manifestavit se fratribus suis."
,"2":"Elevavitque vocem cum fletu, quam audierunt Aegyptii omnisque domus pharaonis."
,"3":"Et dixit Ioseph fratribus suis: ' Ego sum Ioseph! Adhuc pater meus vivit? '. Nec poterant respondere fratres nimio terrore perterriti."
,"4":"Ad quos ille clementer: ' Accedite, inquit, ad me '. Et cum accessissent prope: ' Ego sum, ait, Ioseph frater vester, quem vendidistis in Aegyptum."
,"5":"Nolite contristari, neque vobis durum esse videatur quod vendidistis me in his regionibus. Pro salute enim vestra misit me Deus ante vos in Aegyptum."
,"6":"Biennium est enim quod coepit fames esse in terra, et adhuc quinque anni restant, quibus nec arari poterit nec meti."
,"7":"Praemisitque me Deus, ut reservemini super terram, et servetur vita vestra in salvationem magnam."
,"8":"Non vestro consilio, sed Dei voluntate huc missus sum, qui fecit me quasi patrem pharaonis et dominum universae domus eius ac principem in omni terra Aegypti."
,"9":"Festinate et ascendite ad patrem meum et dicetis ei: 'Haec mandat filius tuus Ioseph: Deus fecit me dominum universae terrae Aegypti; descende ad me, ne moreris."
,"10":"Et habitabis in terra Gessen; erisque iuxta me tu et filii tui et filii filiorum tuorum, oves tuae et armenta tua et universa, quae possides."
,"11":"Ibique te pascam adhuc enim quinque anni residui sunt famis ne et tu pereas et domus tua et omnia, quae possides'."
,"12":"En oculi vestri et oculi fratris mei Beniamin vident quia os meum est, quod loquitur ad vos."
,"13":"Nuntiate patri meo universam gloriam meam in Aegypto et cuncta, quae vidistis. Festinate et adducite eum ad me '."
,"14":"Cumque amplexatus recidisset in collum Beniamin fratris sui, flevit, illo quoque similiter flente, super collum eius."
,"15":"Osculatusque est Ioseph omnes fratres suos et ploravit super singulos. Post quae ausi sunt loqui ad eum."
,"16":"Auditumque est et celebri sermone vulgatum in aula regis: ' Venerunt fratres Ioseph! '. Et gavisus est pharao atque omnis familia eius."
,"17":"Dixitque ad Ioseph, ut imperaret fratribus suis dicens: ' Onerantes iumenta ite in terram Chanaan"
,"18":"et tollite inde patrem vestrum et cognationem et venite ad me; et ego dabo vobis omnia bona Aegypti, ut comedatis medullam terrae."
,"19":"Praecipe etiam: tollite plaustra de terra Aegypti ad subvectionem parvulorum vestrorum ac coniugum et tollite patrem vestrum et properate quantocius venientes."
,"20":"Nec doleatis super supellectilem vestram, quia omnes opes Aegypti vestrae erunt '."
,"21":"Feceruntque filii Israel, ut eis mandatum fuerat. Quibus dedit Ioseph plaustra secundum pharaonis imperium et cibaria in itinere."
,"22":"Singulis quoque proferri iussit vestimentum mutatorium; Beniamin vero dedit trecentos argenteos cum quinque"
,"23":"vestimentis mutatoriis. Patri suo misit similiter asinos decem, qui subveherent ex omnibus divitiis Aegypti, et totidem asinas triticum et panem et cibum pro itinere portantes."
,"24":"Dimisit ergo fratres suos et proficiscentibus ait: ' Ne irascamini in via! '."
,"25":"Qui ascendentes ex Aegypto venerunt in terram Chanaan ad patrem suum Iacob"
,"26":"et nuntiaverunt ei dicentes: ' Ioseph vivit et ipse dominatur in omni terra Aegypti! '. At cor eius frigidum mansit; non enim credebat eis."
,"27":"Tunc referebant omnia verba Ioseph, quae dixerat eis. Cumque vidisset plaustra et universa, quae miserat ad adducendum eum, revixit spiritus eius,"
,"28":"et ait: ' Sufficit mihi, si adhuc Ioseph filius meus vivit. Vadam et videbo illum, antequam moriar '."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Profectusque Israel cum omnibus, quae habebat, venit Bersabee et, mactatis ibi victimis Deo patris sui Isaac,"
,"2":"audivit eum per visionem noctis vocantem se: ' Iacob, Iacob! '. Cui respondit: ' Ecce adsum! '."
,"3":"Ait illi: ' Ego sum Deus, Deus patris tui. Noli timere descendere in Aegyptum, quia in gentem magnam faciam te ibi."
,"4":"Ego descendam tecum illuc et ego inde adducam te revertentem; Ioseph quoque ponet manus suas super oculos tuos '."
,"5":"Surrexit igitur Iacob a Bersabee, tuleruntque eum filii cum parvulis et uxoribus suis in plaustris, quae miserat pharao ad portandum senem,"
,"6":"sumpserunt quoque omnia, quae possederant in terra Chanaan; veneruntque in Aegyptum Iacob et omne semen eius,"
,"7":"filii eius et nepotes, filiae et cuncta simul progenies."
,"8":"Haec sunt autem nomina filiorum Israel, qui ingressi sunt in Aegyptum, ipse cum liberis suis. Primogenitus Ruben. "
,"9":"Filii Ruben: Henoch et Phallu et Hesron et Charmi."
,"10":"Filii Simeon: Iamuel et Iamin et Ahod et Iachin et Sohar et Saul filius Chananitidis."
,"11":"Filii Levi: Gerson et Caath et Merari."
,"12":"Filii Iudae: Her et Onan et Sela et Phares et Zara. Mortui sunt autem Her et Onan in terra Chanaan. Natique sunt filii Phares: Esrom et Hamul."
,"13":"Filii Issachar: Thola et Phua et Iasub et Semron."
,"14":"Filii Zabulon: Sared et Elon et Iahelel."
,"15":"Hi filii Liae, quos genuit in Paddanaram, cum Dina filia sua. Omnes animae filiorum eius et filiarum triginta tres."
,"16":"Filii Gad: Sephon et Haggi, Suni et Esebon, Heri et Arodi et Areli."
,"17":"Filii Aser: Iemna et lesua et Isui et Beria, Sara quoque soror eorum. Filii Beria: Heber et Melchiel."
,"18":"Hi filii Zelphae, quam dedit Laban Liae filiae suae; et hos genuit Iacob: sedecim animas."
,"19":"Filii Rachel uxoris Iacob: Ioseph et Beniamin."
,"20":"Natique sunt Ioseph filii in terra Aegypti, quos genuit ei Aseneth filia Putiphare sacerdotis Heliopoleos: Manasses et Ephraim."
,"21":"Filii Beniamin: Bela et Bochor et Asbel, Gera et Naaman et Echi et Ros, Mophim et Huphim et Ared."
,"22":"Hi filii Rachel, quos genuit Iacob: omnes animae quattuordecim."
,"23":"Filii Dan: Husim."
,"24":"Filii Nephthali: Iasiel et Guni et Ieser et Sellem."
,"25":"Hi filii Bilhae, quam dedit Laban Racheli filiae suae; et hos genuit Iacob: omnes animae septem."
,"26":"Cunctae animae, quae ingressae sunt cum Iacob in Aegyptum et egressae de femore illius, absque uxoribus filiorum eius, sexaginta sex."
,"27":"Filii autem Ioseph, qui nati sunt ei in terra Aegypti, animae duae. Omnes animae domus Iacob, quae ingressae sunt in Aegyptum, fuere septuaginta."
,"28":"Misit autem Iudam ante se ad Ioseph, ut nuntiaret et occurreret in Gessen."
,"29":"Et venerunt in terram Gessen. Iunctoque Ioseph curru suo, ascendit obviam patri suo in Gessen; vidensque eum irruit super collum eius et inter amplexus diu flevit."
,"30":"Dixitque Israel ad Ioseph: ' Iam laetus moriar, quia vidi faciem tuam et superstitem te relinquo '."
,"31":"Et ille locutus est ad fratres suos et ad omnem domum patris sui: ' Ascendam et nuntiabo pharaoni dicamque ei: Fratres mei et domus patris mei, qui erant in terra Chanaan, venerunt ad me."
,"32":"Et sunt viri pastores ovium curamque habent alendorum gregum; pecora sua et armenta et omnia, quae habere potuerunt, adduxerunt secum."
,"33":"Cumque vocaverit vos et dixerit: 'Quod est opus vestrum?'."
,"34":"Respondebitis: 'Viri pastores sumus servi tui ab infantia nostra usque in praesens et nos et patres nostri'. Haec autem dicetis, ut habitare possitis in terra Gessen, quia detestantur Aegyptii omnes pastores ovium '."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Ingressus ergo Ioseph nun tiavit pharaoni dicens: ' Pater meus et fratres, oves eorum et armenta et cuncta, quae possident, venerunt de terra Chanaan; et ecce consistunt in terra Gessen '."
,"2":"Ex omnibus fratribus suis quinque viros statuit coram rege,"
,"3":"quos ille interrogavit: ' Quid habetis operis? '. Responderunt: ' Pastores ovium sumus servi tui et nos et patres nostri '."
,"4":"Dixeruntque ad pharaonem: ' Ad peregrinandum in terra venimus, quoniam non est herba gregibus servorum tuorum, ingravescente fame, in terra Chanaan petimusque, ut esse nos iubeas servos tuos in terra Gessen '."
,"5":"Dixit itaque rex ad Ioseph: ' Pater tuus et fratres tui venerunt ad te."
,"6":"Terra Aegypti in conspectu tuo est; in optimo loco fac eos habitare et trade eis terram Gessen. Quod si nosti in eis esse viros industrios, constitue illos magistros pecorum meorum '."
,"7":"Post haec introduxit Ioseph patrem suum ad regem et statuit eum coram eo, qui benedicens illi"
,"8":"et interrogatus ab eo: ' Quot sunt dies annorum vitae tuae? ',"
,"9":"respondit: ' Dies peregrinationis meae centum triginta annorum sunt, parvi et mali; et non pervenerunt usque ad dies patrum meorum, quibus peregrinati sunt '."
,"10":"Et benedicto rege, egressus est foras."
,"11":"Ioseph vero patri et fratribus suis dedit possessionem in Aegypto in optimo terrae loco, in terra Ramesses, ut praeceperat pharao;"
,"12":"et alebat eos omnemque domum patris sui praebens cibaria singulis."
,"13":"In tota terra panis deerat, et oppresserat fames terram valde, defecitque terra Aegypti et terra Chanaan prae fame."
,"14":"E quibus omnem pecuniam congregavit pro venditione frumenti et intulit eam in aerarium regis."
,"15":"Cumque defecisset emptoribus pretium, venit cuncta Aegyptus ad Ioseph dicens: ' Da nobis panes! Quare morimur coram te, deficiente pecunia? '."
,"16":"Quibus ille respondit: ' Adducite pecora vestra, et dabo vobis pro eis cibos, si pretium non habetis '."
,"17":"Quae cum adduxissent, dedit eis alimenta pro equis et ovibus et bobus et asinis; sustentavitque eos illo anno pro commutatione pecorum."
,"18":"Venerunt quoque anno secundo et dixerunt ei: ' Non celamus dominum nostrum quod, deficiente pecunia, pecora transierunt ad dominum nostrum; nec clam te est quod absque corporibus et terra nihil habeamus."
,"19":"Cur ergo moriemur, te vidente, et nos et terra nostra? Eme nos et terram nostram in servitutem regiam et praebe semina, ne, pereunte cultore, redigatur terra in solitudinem '."
,"20":"Emit igitur Ioseph omnem terram Aegypti, vendentibus singulis possessiones suas prae magnitudine famis. Subiecitque eam pharaoni"
,"21":"et cunctos populos eius redegit ei in servitutem, a novissimis terminis Aegypti usque ad extremos fines eius."
,"22":"Terram autem sacerdotum non emit, qui cibariis a rege statutis fruebantur, et idcirco non sunt compulsi vendere possessiones suas."
,"23":"Dixit ergo Ioseph ad populos: ' En, ut cernitis, et vos et terram vestram pharao possidet; accipite semina et serite agros,"
,"24":"ut fruges habere possitis. Quintam partem regi dabitis; quattuor reliquas permitto vobis in sementem et in cibum familiis et liberis vestris '."
,"25":"Qui responderunt: ' Tu salvasti nos! Respiciat nos tantum dominus noster, et laeti serviemus regi '."
,"26":"Ex eo tempore usque in praesentem diem in universa terra Aegypti regibus quinta pars solvitur; et factum est a Ioseph in legem absque terra sacerdotali, quae libera ab hac condicione est."
,"27":"Habitavit ergo Israel in Aegypto, id est in terra Gessen, et possedit eam; auctusque est et multiplicatus nimis."
,"28":"Et vixit Iacob in terra Aegypti decem et septem annis; factique sunt omnes dies vitae illius centum quadraginta septem annorum."
,"29":"Cumque appropinquare cerneret diem mortis suae, vocavit filium suum Ioseph et dixit ad eum: ' Si inveni gratiam in conspectu tuo, pone manum tuam sub femore meo et facies mihi misericordiam et veritatem, ut non sepelias me in Aegypto,"
,"30":"sed dormiam cum patribus meis, et auferas me de terra hac condasque in sepulcro maiorum meorum '. Cui respondit Ioseph: ' Ego faciam, quod iussisti '."
,"31":"Et ille: ' Iura ergo, inquit, mihi! '. Quo iurante, adoravit Israel conversus ad lectuli caput."
}`)
	CurrentBook.AddChapter(48, `{
"1":"His ita transactis, nuntiatum est Ioseph quod aegrotaret pater suus. Et assumpsit secum duos filios Manasse et Ephraim."
,"2":"Dictumque est seni: ' Ecce filius tuus Ioseph venit ad te '. Qui confortatus sedit in lectulo"
,"3":"et ingresso ad se ait: ' Deus omnipotens apparuit mihi in Luza, quae est in terra Chanaan, benedixitque mihi"
,"4":"et ait: 'Ego te augebo et multiplicabo et faciam te in multitudinem populorum; daboque tibi terram hanc et semini tuo post te in possessionem sempiternam'."
,"5":"Duo ergo filii tui, qui nati sunt tibi in terra Aegypti, antequam huc venirem ad te, mei erunt: Ephraim et Manasses sicut Ruben et Simeon reputabuntur mihi."
,"6":"Reliquos autem, quos genueris post eos, tui erunt et nomine fratrum suorum vocabuntur in possessionibus suis."
,"7":"Mihi enim, quando veniebam de Paddanaram, mortua est Rachel mater tua in terra Chanaan in ipso itinere, cum adhuc esset spatium aliquod usque ad Ephratham, et sepelivi eam iuxta viam Ephrathae, quae alio nomine appellatur Bethlehem '."
,"8":"Videns autem filios eius dixit ad eum: ' Qui sunt isti? '."
,"9":"Respondit: ' Filii mei sunt, quos donavit mihi Deus in hoc loco '. ' Adduc, inquit, eos ad me, ut benedicam illis! '."
,"10":"Oculi enim Israel caligabant prae nimia senectute, et clare videre non poterat. Applicitosque ad se deosculatus et circumplexus eos"
,"11":"dixit ad filium suum: ' Non sum fraudatus aspectu tuo; insuper ostendit mihi Deus semen tuum '."
,"12":"Cumque tulisset eos Ioseph de gremio patris, adoravit pronus in terram."
,"13":"Et posuit Ephraim ad dexteram suam, id est ad sinistram Israel, Manassen vero in sinistra sua, ad dexteram scilicet patris; applicuitque ambos ad eum."
,"14":"Qui extendens manum dexteram, posuit super caput Ephraim minoris fratris, sinistram autem super caput Manasse, qui maior natu erat, commutans manus."
,"15":"Benedixitque Iacob Ioseph et ait: ' Deus, in cuius conspectu ambulaverunt,patres mei Abraham et Isaac, Deus, qui pascit me ab adulescentia mea,usque in praesentem diem,"
,"16":"Angelus, qui eruit me de cunctis malis, benedicat pueris istis!,Et invocetur super eos nomen meum, nomina quoque patrum meorum Abraham et Isaac, et crescant in multitudinem,super terram! '."
,"17":"Videns autem Ioseph quod posuisset pater suus dexteram manum super caput Ephraim, graviter accepit et apprehensam manum patris levare conatus est de capite Ephraim et transferre super caput Manasse."
,"18":"Dixitque ad patrem: ' Non ita convenit, pater, quia hic est primogenitus; pone dexteram tuam super caput eius! '."
,"19":"Qui renuens ait: ' Scio, fili mi, scio; et iste quidem erit in populos et multiplicabitur, sed frater eius minor maior erit illo, et semen illius crescet in plenitudinem gentium '."
,"20":"Benedixitque eis in die illo dicens: ' In te benedicet Israel atque dicet: 'Faciat te Deus sicut Ephraim et sicut Manasse!' '. Constituitque Ephraim ante Manassen. "
,"21":"Et ait ad Ioseph filium suum: ' En ego morior, et erit Deus vobiscum reducetque vos ad terram patrum vestrorum."
,"22":"Do tibi partem unam extra fratres tuos, quam tuli de manu Amorraei in gladio et arcu meo '."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Vocavit autem Iacob filios suos et ait eis: ' Congrega mini, ut annuntiem, quae ventura sunt vobis in diebus novissimis."
,"2":"Congregamini et audite, filii Iacob, audite Israel patrem vestrum!"
,"3":"Ruben primogenitus meus, tu fortitudo mea et principium roboris mei; prior in dignitate, maior in robore!"
,"4":"Ebulliens sicut aqua non excellas, quia ascendisti cubile patris tui,et maculasti stratum meum."
,"5":"Simeon et Levi fratres, vasa violentiae arma eorum."
,"6":"In consilium eorum ne veniat anima mea, et in coetu illorum non sit gloria mea; quia in furore suo occiderunt virum,et in voluntate sua subnervaverunt tauros."
,"7":"Maledictus furor eorum, quia pertinax, et indignatio eorum, quia dura!,Dividam eos in Iacob,et dispergam eos in Israel."
,"8":"Iuda, te laudabunt fratres tui; manus tua in cervicibus inimicorum tuorum; adorabunt te filii patris tui."
,"9":"Catulus leonis Iuda: a praeda, fili mi, ascendisti; requiescens accubuit ut leo,et quasi leaena; quis suscitabit eum?"
,"10":"Non auferetur sceptrum de Iuda,et baculus ducis de pedibus eius, donec veniat ille, cuius est, et cui erit oboedientia gentium;"
,"11":"ligans ad vineam pullum suum,et ad vitem filium asinae suae, lavabit in vino stolam suam,et in sanguine uvae pallium suum; "
,"12":"nigriores sunt oculi eius vino,et dentes eius lacte candidiores."
,"13":"Zabulon in litore maris habitabit,et in statione navium, pertingens usque ad Sidonem."
,"14":"Issachar asinus fortis, accubans inter caulas"
,"15":"vidit requiem quod esset bona, et terram quod optima; et supposuit umerum suum ad portandum,factusque est tributis serviens."
,"16":"Dan iudicabit populum suum,sicut una tribuum Israel."
,"17":"Fiat Dan coluber in via, cerastes in semita, mordens calcanea equi, ut cadat ascensor eius retro."
,"18":"Salutare tuum exspectabo, Domine!"
,"19":"Gad, latrones aggredientur eum, ipse autem aggredietur calcaneum eorum."
,"20":"Aser, pinguis panis eius, et praebebit delicias regales."
,"21":"Nephthali cerva emissa, dans cornua pulchra."
,"22":"Arbor fructifera Ioseph, arbor fructifera super fontem: rami transcendunt murum."
,"23":"Sed exasperaverunt eum et iurgati sunt, et adversati sunt illi habentes iacula."
,"24":"Et confractus est arcus eorum, et dissoluti sunt nervi brachiorum eorum,per manus Potentis Iacob, per nomen Pastoris, Lapidis Israel."
,"25":"Deus patris tui erit adiutor tuus, et Omnipotens benedicet tibi,benedictionibus caeli desuper, benedictionibus abyssi iacentis,deorsum, benedictionibus uberum et vulvae."
,"26":"Benedictiones patris tui confortatae sunt,super benedictiones montium aeternorum, desiderium collium antiquorum; fiant in capite Ioseph,et in vertice nazaraei inter fratres suos."
,"27":"Beniamin lupus rapax; mane comedet praedam,et vespere dividet spolia '."
,"28":"Omnes hi in tribubus Israel duodecim. Haec locutus est eis pater suus benedixitque singulis benedictionibus propriis."
,"29":"Et praecepit eis dicens: ' Ego congregor ad populum meum; sepelite me cum patribus meis in spelunca Machpela, quae est in agro Ephron Hetthaei"
,"30":"contra Mambre in terra Chanaan, quam emit Abraham cum agro ab Ephron Hetthaeo in possessionem sepulcri;"
,"31":"ibi sepelierunt eum et Saram uxorem eius, ibi sepultus est Isaac cum Rebecca coniuge sua, ibi et Lia condita iacet '."
,"32":"Finitisque mandatis, quibus filios instruebat, collegit pedes suos super lectulum et obiit; appositusque est ad populum suum."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Ioseph ruit super faciem patris flens et deosculans eum."
,"2":"Praecepitque servis suis medicis, ut aromatibus condirent patrem."
,"3":"Quibus iussa explentibus, transierunt quadraginta dies; iste quippe mos erat cadaverum conditorum. Flevitque eum Aegyptus septuaginta diebus."
,"4":"Et, expleto planctus tempore, locutus est Ioseph ad familiam pharaonis: ' Si inveni gratiam in conspectu vestro, loquimini in auribus pharaonis,"
,"5":"eo quod pater meus adiuraverit me dicens: 'En morior; in sepulcro meo, quod fodi mihi in terra Chanaan, sepelies me'; ascendam nunc et sepeliam patrem meum ac revertar '."
,"6":"Dixitque ei pharao: ' Ascende et sepeli patrem tuum, sicut adiuratus es '."
,"7":"Quo ascendente, ierunt cum eo omnes servi pharaonis, senes domus eius cunctique maiores natu terrae Aegypti,"
,"8":"domus Ioseph cum fratribus suis, absque parvulis et gregibus atque armentis, quae dereliquerant in terra Gessen."
,"9":"Habuit quoque in comitatu currus et equites; et facta est turba non modica."
,"10":"Veneruntque ad Gorenatad (id est Aream rhamni), quae sita est trans Iordanem; ubi celebrantes exsequias planctu magno atque vehementi impleverunt septem dies."
,"11":"Quod cum vidissent habitatores terrae Chanaan, dixerunt: ' Planctus magnus est iste Aegyptiis '; et idcirco vocatum est nomen loci illius Abelmesraim (id est Planctus Aegypti)."
,"12":"Fecerunt ergo filii Iacob, sicut praeceperat eis;"
,"13":"et portantes eum in terram Chanaan sepelierunt eum in spelunca Machpela, quam emerat Abraham cum agro in possessionem sepulcri ab Ephron Hetthaeo contra faciem Mambre."
,"14":"Reversusque est Ioseph in Aegyptum cum fratribus suis et omni comitatu, sepulto patre."
,"15":"Quo mortuo, timentes fratres eius et mutuo colloquentes: ' Ne forte memor sit iniuriae, quam passus est, et reddat nobis omne malum, quod fecimus ',"
,"16":"mandaverunt ei dicentes: ' Pater tuus praecepit nobis, antequam moreretur,"
,"17":"ut haec tibi verbis illius diceremus: 'Obsecro, ut obliviscaris sceleris fratrum tuorum et peccati atque malitiae, quam exercuerunt in te'. Nos quoque oramus, ut servis Dei patris tui dimittas iniquitatem hanc '. Quibus auditis, flevit Ioseph."
,"18":"Veneruntque ad eum fratres sui et proni coram eo dixerunt: ' Servi tui sumus '."
,"19":"Quibus ille respondit: ' Nolite timere. Num Dei possumus resistere voluntati?"
,"20":"Vos cogitastis de me malum; sed Deus vertit illud in bonum, ut exaltaret me, sicut in praesentiarum cernitis, et salvos faceret multos populos."
,"21":"Nolite timere: ego pascam vos et parvulos vestros '. Consolatusque est eos et blande ac leniter est locutus."
,"22":"Et habitavit in Aegypto cum omni domo patris sui; vixitque centum decem annis"
,"23":"et vidit Ephraim filios usque ad tertiam generationem; filii quoque Machir filii Manasse nati sunt in genibus Ioseph."
,"24":"Quibus transactis, locutus est fratribus suis: ' Post mortem meam Deus visitabit vos et ascendere vos faciet de terra ista ad terram, quam iuravit Abraham, Isaac et Iacob '."
,"25":"Cumque adiurasset eos atque dixisset: ' Deus visitabit vos; asportate ossa mea vobiscum de loco isto ',"
,"26":"mortuus est, expletis centum decem vitae suae annis. Et conditus aromatibus repositus est in loculo in Aegypto."
}`)

}
func LA_NVBSE_LoadVPLVChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Vocavit autem Moysen et locu tus est ei Dominus de tabernacu lo conventus dicens:"
,"2":"' Loquere filiis Israel et dices ad eos: Homo, qui obtulerit ex vobis hostiam Domino de animalibus domesticis, de bobus et pecoribus offerens victimas,"
,"3":"si holocaustum fuerit eius oblatio de armento, masculum immaculatum offeret ad ostium tabernaculi conventus ad placandum sibi Dominum;"
,"4":"ponetque manum super caput hostiae, et acceptabilis erit atque in expiationem eius proficiens."
,"5":"Immolabitque vitulum coram Domino, et offerent filii Aaron sacerdotes sanguinem eius aspergentes per altaris circuitum, quod est ante ostium tabernaculi conventus."
,"6":"Detracta pelle, hostiam offerens in frusta concidet;"
,"7":"et filii Aaron sacerdotis ponent in altari ignem, strueque lignorum super ignem composita,"
,"8":"membra, quae caesa sunt, desuper ordinabunt, caput videlicet et adipem."
,"9":"Intestina autem et crura offerens lavabit aqua adolebitque ea sacerdos super altare in holocaustum, incensum suavissimi odoris Domino."
,"10":"Quod si de pecoribus eius oblatio est, de ovibus sive de capris holocaustum, masculum absque macula offeret;"
,"11":"immolabitque ad latus altaris, quod respicit ad aquilonem, coram Domino. Sanguinem vero illius aspergent contra altare filii Aaron sacerdotes per circuitum;"
,"12":"dividetque offerens membra, caput et adipem, et sacerdos imponet ea super ligna, quibus subest ignis in altari."
,"13":"Intestina vero et crura lavabit offerens aqua, et oblata omnia adolebit sacerdos super altare: holocaustum est et incensum odoris suavissimi Domino."
,"14":"Sin autem de avibus holocausti oblatio fuerit Domino, offeret de turturibus aut pullis columbae oblationem suam."
,"15":"Et sacerdos afferet eam ad altare; retortum ad collum caput adolebit in altari, sanguisque eius exprimetur contra parietem altaris."
,"16":"Vesiculam vero gutturis et plumas proiciet offerens prope altare ad orientalem plagam in loco, in quo cineres effundi solent;"
,"17":"confringetque eam inter alas, quas non secabit, et adolebit eam sacerdos super altare, lignis super ignem positis: holocaustum est et incensum suavissimi odoris Domino."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Anima cum obtulerit oblationem sacrificii farinae Domino, simila erit eius oblatio, fundetque super eam oleum et ponet tus"
,"2":"ac deferet ad filios Aaron sacerdotes, tolletque ex eo pugillum plenum similae et olei ac totum tus, et sacerdos adolebit memoriale super altare, incensum odoris suavissimi Domino."
,"3":"Quod autem reliquum fuerit de sacrificio, erit Aaron et filiorum eius: sanctum sanctorum de incensis Domini."
,"4":"Cum autem obtuleris sacrificium similae coctum in clibano: de simila erunt panes, scilicet absque fermento conspersi oleo et lagana azyma oleo lita;"
,"5":"si oblatio tua fuerit de sartagine, simila erit, conspersa oleo et absque fermento;"
,"6":"divides eam minutatim et fundes super eam oleum: oblatio similae est."
,"7":"Sin autem de frixorio fuerit sacrificium, aeque simila oleo conspergetur."
,"8":"Et deferes oblationem ex his Domino factam tradens manibus sacerdotis,"
,"9":"qui afferet eam ad altare, tollet memoriale de sacrificio et adolebit super altare: incensum odoris suavissimi Domino."
,"10":"Quidquid autem reliquum est, erit Aaron et filiorum eius: sanctum sanctorum de incensis Domini."
,"11":"Omnis oblatio similae, quam offeretis Domino, absque fermento fiet, quia nihil fermenti ac mellis adolebitis incensum Domino."
,"12":"Primitias tantum eorum offeretis tamquam munera Domino; super altare vero non ponentur in odorem suavitatis."
,"13":"Quidquid obtuleris sacrificii, similae sale condies nec auferes sal foederis Dei tui de sacrificio tuo: in omni oblatione tua offeres sal."
,"14":"Sin autem obtuleris munus primarum frugum tuarum Domino, spicas tostas igni et grana fracta farris recentis offeres in sacrificium primarum frugum tuarum"
,"15":"fundens supra oleum et tus imponens: similae oblatio est."
,"16":"De qua adolebit sacerdos tamquam memoriale partem farris fracti et olei ac totum tus."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Quod si hostia pacificorum fue rit eius oblatio et de bobus vo luerit offerre marem sive feminam, immaculata offeret coram Domino."
,"2":"Ponetque manum super caput victimae suae, quam immolabit ad ostium tabernaculi conventus, fundentque filii Aaron sacerdotes sanguinem per circuitum altaris"
,"3":"et offerent de hostia pacificorum tamquam incensum Domino adipem, qui operit vitalia, et quidquid pinguedinis eis adhaeret,"
,"4":"duos renes cum adipe, quo teguntur iuxta ilia, et reticulum iecoris, quem iuxta renes, auferet."
,"5":"Adolebuntque ea filii Aaron in altari super holocausto, quod est super lignis et igne: incensum suavissimi odoris Domino."
,"6":"Si vero de pecoribus fuerit Domino eius oblatio, pacificorum scilicet hostia, sive masculum sive feminam obtulerit, immaculata erunt."
,"7":"Si agnum obtulerit coram Domino,"
,"8":"ponet manum super caput victimae suae, quam immolabit coram tabernaculo conventus; fundentque filii Aaron sanguinem eius per altaris circuitum;"
,"9":"et offeret de pacificorum hostia incensum Domino adipem et caudam totam, quam iuxta tergum, auferet, et pinguedinem, quae operit ventrem, atque universum adipem, qui vitalibus adhaeret,"
,"10":"et utrumque renunculum cum adipe, qui est iuxta ilia, reticulumque iecoris, quem iuxta renunculos, auferet."
,"11":"Et adolebit ea sacerdos super altare: panis et incensum Domino."
,"12":"Si capra fuerit eius oblatio, offeret eam coram Domino,"
,"13":"ponet manum suam super caput eius immolabitque eam coram tabernaculo conventus. Et fundent filii Aaron sanguinem eius per altaris circuitum,"
,"14":"tolletque ex ea oblationem suam, incensum Domino, adipem scilicet, qui operit ventrem, et universum, qui vitalibus adhaeret,"
,"15":"duos renunculos cum adipe, qui est super eos iuxta ilia, et reticulum iecoris, quem iuxta renunculos, auferet;"
,"16":"adolebitque ea sacerdos super altare: panis et incensum suavissimi odoris omnis adeps Domino."
,"17":"Iure perpetuo in generationibus et cunctis habitaculis vestris, nec adipem nec sanguinem omnino comedetis '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Loquere filiis Israel: Anima cum peccaverit per ignorantiam et de universis mandatis Domini, quae praecepit ut non fierent, quippiam fecerit,"
,"3":"si sacerdos, qui est unctus, peccaverit, delinquere faciens populum, offeret pro peccato suo vitulum immaculatum Domino sacrificium pro peccato;"
,"4":"et adducet illum ad ostium tabernaculi conventus coram Domino ponetque manum super caput eius et immolabit eum coram Domino."
,"5":"Hauriet quoque sacerdos unctus de sanguine vituli inferens illum in tabernaculum conventus;"
,"6":"cumque intinxerit digitum in sanguinem, asperget eo septies coram Domino contra velum sanctuarii;"
,"7":"ponetque de eodem sanguine super cornua altaris thymiamatis gratissimi coram Domino, quod est in tabernaculo conventus; omnem autem reliquum sanguinem fundet in basim altaris holocausti in introitu tabernaculi."
,"8":"Et omnem adipem vituli pro peccato auferet tam eum, qui operit vitalia, quam omnem, qui vitalibus adhaeret,"
,"9":"duos renunculos et adipem, qui est super eos iuxta ilia, et reticulum iecoris, quem iuxta renunculos, auferet,"
,"10":"sicut aufertur de vitulo hostiae pacificorum; et adolebit ea sacerdos super altare holocausti."
,"11":"Pellem vero et omnes carnes cum capite et pedibus et intestinis et fimo,"
,"12":"totum vitulum efferet extra castra in locum mundum, ubi cineres effundi solent; incendetque eum super lignorum struem igne: in loco effusorum cinerum cremabitur."
,"13":"Quod si omnis coetus Israel ignoraverit, et res abscondita fuerit ab oculis congregationis, feceritque quod contra mandatum Domini est et deliquerit,"
,"14":"et postea intellexerit peccatum suum, offeret congregatio vitulum pro peccato adducetque eum ad ostium tabernaculi conventus."
,"15":"Et ponent seniores coetus populi manus super caput eius coram Domino, immolatoque vitulo in conspectu Domini,"
,"16":"inferet sacerdos, qui unctus est, de sanguine eius in tabernaculum conventus,"
,"17":"tincto digito aspergens septies contra velum;"
,"18":"ponetque de eodem sanguine in cornibus altaris, quod est coram Domino in tabernaculo conventus. Reliquum autem sanguinem fundet iuxta basim altaris holocaustorum, quod est in ostio tabernaculi conventus;"
,"19":"omnemque eius adipem tollet et adolebit super altare."
,"20":"Sic faciens et de hoc vitulo quomodo fecit de vitulo pro peccato; sic faciet ei. Expiante eos sacerdote, propitius erit Dominus."
,"21":"Ipsum autem vitulum efferet extra castra atque comburet sicut et priorem vitulum: sacrificium pro peccato est congregationis."
,"22":"Si peccaverit princeps et fecerit unum ex omnibus per ignorantiam, quod Domini Dei sui lege prohibetur, deliqueritque,"
,"23":"aut indicatum ei fuerit peccatum suum, offeret hostiam Domino hircum de capris immaculatum"
,"24":"ponetque manum suam super caput eius et immolabit eum in loco, ubi solet mactari holocaustum coram Domino: sacrificium pro peccato est."
,"25":"Et tinguat sacerdos digitum in sanguine hostiae pro peccato ponetque super cornua altaris holocausti et reliquum fundet ad basim eius."
,"26":"Adipem vero adolebit supra, sicut in victimis pacificorum fieri solet; expiabitque eum a peccato eius, ac dimittetur ei."
,"27":"Quod si peccaverit anima per ignorantiam de populo terrae, ut faciat quidquam ex his, quae Domini lege prohibentur, atque delinquat,"
,"28":"aut indicatum ei fuerit peccatum suum, offeret capram immaculatam;"
,"29":"ponetque manum super caput hostiae pro peccato et immolabit eam in loco holocausti."
,"30":"Tolletque sacerdos de sanguine in digito suo et ponet super cornua altaris holocausti et reliquum fundet ad basim eius."
,"31":"Omnem autem auferens adipem, sicut auferri solet de victimis pacificorum, adolebit super altare in odorem suavitatis Domino, expiabitque eum, et propitius erit Dominus."
,"32":"Sin autem de ovibus obtulerit victimam pro peccato, adducet agnam immaculatam;"
,"33":"ponet manum super caput eius et immolabit eam in loco, ubi solent holocaustorum caedi hostiae."
,"34":"Sumetque sacerdos de sanguine eius digito suo et ponens super cornua altaris holocausti reliquum fundet ad basim eius."
,"35":"Omnem quoque auferens adipem, sicut auferri solet adeps agni, qui immolatur pro pacificis, cremabit in altari super incensis Domini; expiabitque eum et peccatum eius, et dimittetur illi."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Si peccaverit anima et audiverit vocem iurantis testisque fuerit, quod aut ipse vidit aut comperit, si non indicaverit, iniquitatem portabit;"
,"2":"vel si anima tetigerit aliquid immundum, sive cadaver bestiae sit aut iumenti vel reptilis, et absconditum fuerit ab eo, ipse immundus et reus erit;"
,"3":"aut si tetigerit quidquam de immunditia hominis iuxta omnem impuritatem, qua pollui solet, absconditumque fuerit ab eo, sed ipse cognoverit postea, subiacebit delicto;"
,"4":"aut si anima temere iuraverit et protulerit labiis suis, ut vel male quid faceret vel bene iuxta omnia, quae homines temere iurant, absconditumque fuerit ab eo, sed ipse postea intellexerit, delicto subiacebit;"
,"5":"si ergo reus factus fuerit uno ex istis, confiteatur peccatum suum"
,"6":"et offerat Domino sacrificium delicti pro peccato suo agnam de gregibus sive capram ut sacrificium pro peccato; expiabitque eum sacerdos a peccato eius."
,"7":"Sin autem non potuerit offerre pecus, offerat ut sacrificium pro delicto duos turtures vel duos pullos columbarum Domino: unum in sacrificium pro peccato et alterum in holocaustum;"
,"8":"dabitque eos sacerdoti, qui primum offerens ut sacrificium pro peccato retorquebit caput eius ad pennulas, ita ut collo haereat et non penitus abrumpatur;"
,"9":"et asperget de sanguine eius parietem altaris; quidquid autem reliquum fuerit, faciet destillare ad fundamentum eius: sacrificium pro peccato est."
,"10":"Alterum vero adolebit holocaustum, ut fieri solet; expiabitque eum sacerdos a peccato eius, et dimittetur ei."
,"11":"Quod si non quiverit manus eius offerre duos turtures aut duos pullos columbarum, offeret pro peccato suo similae partem ephi decimam in sacrificium pro peccato; non mittet in eam oleum, nec turis aliquid imponet, quia sacrificium pro peccato est."
,"12":"Tradetque eam sacerdoti, qui, plenum ex toto pugillum in memoriale hauriens, cremabit in altari super incensis Domini: sacrificium pro peccato est."
,"13":"Et expiabit eum sacerdos et peccatum eius in uno ex his casibus, et propitius erit Dominus. Reliquam vero partem sacerdos habebit sicut in oblatione similae '."
,"14":"Locutus est Dominus ad Moysen dicens:"
,"15":"' Anima, si praevaricans per errorem in his, quae Domino sunt sanctificata, peccaverit, offeret sacrificium pro delicto arietem immaculatum de gregibus iuxta aestimationem argenti siclorum pondere sanctuarii in paenitentiam;"
,"16":"ipsumque, quod intulit damni, restituet et quintam partem ponet supra tradens sacerdoti, qui expiabit eum offerens arietem, et dimittetur ei."
,"17":"Anima, si peccaverit per ignorantiam feceritque unum ex his, quae Domini lege prohibentur, et peccati rea portaverit iniquitatem suam,"
,"18":"offeret arietem immaculatum de gregibus iuxta aestimationem sacerdoti, qui expiabit eum ab eo, quod nesciens fecerit, et dimittetur ei:"
,"19":"sacrificium pro delicto est, delinquens deliquit in Dominum '."
,"20":"Locutus est Dominus ad Moysen dicens:"
,"21":"' Anima, quae peccaverit et, contempto Domino, negaverit proximo suo depositum, quod fidei eius creditum fuerat, vel vi aliquid extorserit aut calumniam fecerit,"
,"22":"sive rem perditam invenerit et infitians insuper peierarit in uno ex omnibus, in quibus peccare solent homines,"
,"23":"si quis sic peccaverit et deliquerit, reddet omnia, quae per rapinam vel calumniam abstulerit vel deposita retinuerit vel perdita invenerit"
,"24":"vel de quibus peierarit, et restituet integra et quintam insuper addet partem domino, cui damnum intulerat, in die sacrificii pro delicto."
,"25":"Sacrificium pro delicto offeret Domino: arietem immaculatum de grege iuxta aestimationem;"
,"26":"qui expiabit eum coram Domino, et dimittetur illi pro singulis, quae faciendo peccaverit '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Locutus est Dominus ad Moysen dicens:"
,"2":"' Praecipe Aaron et filiis eius: Haec est lex holocausti: cremabitur in foco altaris tota nocte usque mane; ignis altaris in eo ardebit."
,"3":"Vestietur sacerdos tunica et feminalibus lineis super verecunda sua; tolletque cineres, quos vorans ignis exussit, et ponet iuxta altare."
,"4":"Porro spoliabitur prioribus vestimentis; indutusque aliis efferet cineres extra castra in locum mundum."
,"5":"Ignis autem in altari semper ardebit, non exstinguetur, quem nutriet sacerdos subiciens ligna mane per singulos dies et, imposito holocausto, desuper adolebit adipes pacificorum."
,"6":"Ignis est iste perpetuus, qui numquam deficiet in altari."
,"7":"Haec est lex sacrificii similae, quod offerent filii Aaron coram Domino et coram altare:"
,"8":"tollet sacerdos ex eo pugillum similae, quae conspersa est oleo, et totum tus, quod super similam positum est; adolebitque illud in altari in odorem suavissimum, memoriale Domino."
,"9":"Reliquam autem partem similae comedet Aaron cum filiis suis, et panis absque fermento comedetur in loco sancto; in atrio tabernaculi conventus comedent illam."
,"10":"Ideo autem non coquetur fermentata, quia ut partem eorum dedi illam ex incensis meis: sanctum sanctorum est, sicut sacrificium pro peccato atque pro delicto;"
,"11":"mares tantum stirpis Aaron comedent illud. Legitimum sempiternum est in generationibus vestris de incensis Domini; omnis, qui tetigerit illa, sanctificabitur '."
,"12":"Et locutus est Dominus ad Moysen dicens:"
,"13":"' Haec est oblatio Aaron et filiorum eius, quam offerre debent Domino in die unctionis ipsius: decimam partem ephi offerent similae in sacrificio sempiterno medium eius mane et medium vespere;"
,"14":"quae in sartagine oleo conspersa frigetur. Afferes eam calidam et offeres divisam minutatim, sacrificium in odorem suavissimum Domino."
,"15":"Sacerdos unctus, qui patri iure successerit, faciet illud. Legitimum sempiternum: Domino tota cremabitur;"
,"16":"omne enim sacrificium similae sacerdotum igne consumetur, nec quisquam comedet ex eo '."
,"17":"Locutus est Dominus ad Moysen dicens:"
,"18":"' Loquere Aaron et filiis eius: Ista est lex sacrificii pro peccato: in loco, ubi mactatur holocaustum, mactabitur coram Domino: sanctum sanctorum est."
,"19":"Sacerdos, qui offert, comedet illud in loco sancto, in atrio tabernaculi conventus."
,"20":"Quidquid tetigerit carnes eius, sanctificabitur: si de sanguine illius vestis fuerit aspersa, lavabitur in loco sancto;"
,"21":"vas autem fictile, in quo coctum est, confringetur; quod si vas aeneum fuerit, defricabitur et lavabitur aqua."
,"22":"Omnis masculus de genere sacerdotali vescetur carnibus eius, quia sanctum sanctorum est."
,"23":"Omne autem sacrificium pro peccato, de cuius sanguine infertur in tabernaculum conventus ad expiandum in sanctuario, non comedetur, sed comburetur igni."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Haec quoque est lex sacrificii pro delicto: sanctum sanctorum est,"
,"2":"idcirco, ubi immolatur holocaustum, mactabitur et victima pro delicto; sanguis eius per gyrum fundetur altaris."
,"3":"Omnemque adipem offeret ex ea, caudam scilicet et adipem, qui operit vitalia,"
,"4":"duos renunculos et pinguedinem, quae super eos iuxta ilia est, reticulumque iecoris, quem iuxta renunculos, auferet;"
,"5":"et adolebit ea sacerdos super altare ut incensum Domino: sacrificium pro delicto est."
,"6":"Omnis masculus de sacerdotali genere in loco sancto vescetur his carnibus, quia sanctum sanctorum est."
,"7":"Sicut sacrificium pro peccato, ita et sacrificium pro delicto, utriusque hostiae lex una est; ad sacerdotem, qui eam obtulerit, pertinebit."
,"8":"Sacerdos, qui offert holocaustum cuiusdam viri, habebit pellem victimae,"
,"9":"et omne sacrificium similae, quod coquitur in clibano, et, quidquid in frixorio vel in sartagine praeparatur, eius erit sacerdotis, a quo offertur;"
,"10":"et omne sacrificium similae sive oleo conspersum sive aridum fuerit, cunctis filiis Aaron aequa mensura per singulos dividetur."
,"11":"Haec est lex hostiae pacificorum quae offertur Domino;"
,"12":"si pro gratiarum actione fuerit oblatio, offerent panes absque fermento conspersos oleo et lagana azyma uncta oleo coctamque similam ut collyridas olei admixtione conspersas,"
,"13":"panes quoque fermentatos cum hostia pacificorum pro gratiarum actione,"
,"14":"ex quibus unus offeretur munus Domino et erit sacerdotis, qui fundet hostiae sanguinem."
,"15":"Cuius carnes eadem comedentur die, nec remanebit ex eis quidquam usque mane."
,"16":"Si voto vel sponte quisquam obtulerit hostiam, eadem similiter edetur die; sed et si quid in crastinum remanserit, vesci licitum est;"
,"17":"quidquid autem tertius invenerit dies, ignis absumet."
,"18":"Si quis de carnibus victimae pacificorum die tertio comederit, irrita fiet oblatio nec proderit offerenti; quin potius, quaecumque anima tali se edulio contaminarit, praevaricationis rea erit."
,"19":"Caro, quae aliquid tetigerit immundum, non comedetur, sed comburetur igni; ceterum carne, qui fuerit mundus, vescetur."
,"20":"Anima polluta, quae ederit de carnibus hostiae pacificorum, quae oblata est Domino, peribit de populis suis;"
,"21":"et, quae tetigerit immunditiam hominis vel iumenti, sive omnis rei abominabilis, quae polluere potest, et comederit de huiuscemodi carnibus, interibit de populis suis '."
,"22":"Locutusque est Dominus ad Moysen dicens:"
,"23":"' Loquere filiis Israel: Adipem bovis et ovis et caprae non comedetis."
,"24":"Adipem cadaveris morticini et eius animalis, quod a bestia laceratum est, habebitis in usus varios, sed non comedetis."
,"25":"Si quis adipem, qui offertur in incensum Domini, comederit, peribit de populo suo."
,"26":"Sanguinem quoque omnis animalis non sumetis in cibo, tam de avibus quam de pecoribus;"
,"27":"omnis anima, quae ederit sanguinem, peribit de populis suis '."
,"28":"Locutus est Dominus ad Moysen dicens:"
,"29":"' Loquere filiis Israel: Qui offert victimam pacificorum Domino, afferat oblationem suam Domino de victima pacificorum."
,"30":"Tenebit manibus incensa Domini, adipem scilicet et pectusculum afferet; pectusculum, ut elevetur coram Domino."
,"31":"Et sacerdos adolebit adipem super altare; pectusculum autem erit Aaron et filiorum eius."
,"32":"Armus quoque dexter de pacificorum hostiis cedet in munus sacerdotis."
,"33":"Qui de filiis Aaron obtulerit sanguinem et adipem victimae pacificorum, ipse habebit armum dextrum in portione sua;"
,"34":"pectusculum enim elationis et armum donationis tuli a filiis Israel de hostiis eorum pacificis et dedi Aaron sacerdoti ac filiis eius, lege perpetua, ab omni populo Israel '."
,"35":"Haec est portio Aaron et filiorum eius de incensis Domini die, qua applicavit eos, ut sacerdotio fungerentur;"
,"36":"et quae praecepit dari eis Dominus a filiis Israel die, qua unxit eos, religione perpetua in generationibus eorum."
,"37":"Ista est lex holocausti et oblationis similae et sacrificii pro peccato atque delicto et pro consecratione et pacificorum victimis,"
,"38":"quam constituit Dominus Moysi in monte Sinai, quando mandavit filiis Israel, ut offerrent oblationes suas Domino in deserto Sinai."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Tolle Aaron cum filiis suis, vestes eorum et unctionis oleum, vitulum pro peccato, duos arietes, canistrum cum azymis;"
,"3":"et congregabis omnem coetum ad ostium tabernaculi conventus '."
,"4":"Fecit Moyses, ut Dominus imperarat; congregatoque omni coetu ante fores tabernaculi conventus,"
,"5":"ait: ' Iste est sermo, quem iussit Dominus fieri '."
,"6":"Statimque applicavit Aaron et filios eius. Cumque lavisset eos aqua,"
,"7":"vestivit pontificem subucula linea accingens eum balteo et induens tunica hyacinthina et desuper ephod imposuit,"
,"8":"quod astrinxit cingulo ephod firmiter; et imposuit ei pectorale, in quo dedit Urim et Tummim."
,"9":"Cidari quoque texit caput et super eam contra frontem posuit laminam auream, diadema sanctum, sicut praeceperat Dominus Moysi."
,"10":"Tulit et unctionis oleum, quo levit habitaculum cum omni supellectili sua et sanctificavit ea."
,"11":"Cumque de eo aspersisset altare septem vicibus, unxit illud et omnia vasa eius labrumque cum basi sua sanctificavit oleo."
,"12":"Quod fundens super caput Aaron, unxit eum et consecravit;"
,"13":"filios quoque eius applicatos vestivit subuculis lineis et cinxit balteo imposuitque mitras, ut iusserat Dominus Moysi."
,"14":"Adduxit et vitulum pro peccato; cumque super caput eius posuissent Aaron et filii eius manus suas,"
,"15":"immolavit eum; et hauriens Moyses sanguinem tincto digito tetigit cornua altaris per gyrum et mundavit illud; fuditque reliquum sanguinem ad fundamenta eius et sanctificavit illud expiando."
,"16":"Adipem autem, qui erat super vitalia, et reticulum iecoris duosque renunculos cum arvinulis suis adolevit super altare;"
,"17":"vitulum cum pelle, carnibus et fimo cremans extra castra, sicut praeceperat Dominus Moysi."
,"18":"Attulit et arietem in holocaustum, super cuius caput cum imposuissent Aaron et filii eius manus suas,"
,"19":"immolavit eum et fudit sanguinem eius per altaris circuitum."
,"20":"Ipsumque arietem in frusta concidens, caput eius et artus et adipem adolevit igni;"
,"21":"lotis prius intestinis et pedibus, totumque simul arietem adolevit super altare, eo quod esset holocaustum suavissimi odoris, incensum Domino, sicut praeceperat Dominus Moysi."
,"22":"Attulit et arietem secundum in consecrationem sacerdotum; posueruntque super caput illius Aaron et filii eius manus suas."
,"23":"Quem cum immolasset Moyses, sumens de sanguine tetigit extremum auriculae dextrae Aaron et pollicem manus eius dextrae, similiter et pedis."
,"24":"Applicavit et filios Aaron; cumque de sanguine arietis immolati tetigisset extremum auriculae singulorum dextrae et pollices manus ac pedis dextri, reliquum fudit super altare per circuitum."
,"25":"Tulitque adipem et caudam omnemque pinguedinem, quae operit intestina reticulumque iecoris, et duos renes cum adipibus suis et armo dextro."
,"26":"Tollens autem de canistro azymorum, quod erat coram Domino, panem absque fermento et collyridam conspersam oleo laganumque posuit super adipes et armum dextrum,"
,"27":"tradens simul omnia super manus Aaron et filiorum eius. Qui, postquam levaverunt ea coram Domino,"
,"28":"rursum suscepta de manibus eorum adolevit in altari super holocausto, eo quod illa essent consecrationis oblatio, in odorem suavitatis: incensum erat Domino."
,"29":"Tulit et pectusculum elevans illud coram Domino de ariete consecrationis in partem suam, sicut praeceperat Dominus Moysi."
,"30":"Assumensque de unguento et sanguine, qui erat in altari, aspersit super Aaron et vestimenta eius et super filios illius ac vestes eorum."
,"31":"Cumque sanctificasset eos in vestitu suo, praecepit eis dicens: ' Coquite carnes ante fores tabernaculi et ibi comedite eas; panes quoque consecrationis edite, qui positi sunt in canistro, sicut mihi praeceptum est: 'Aaron et filii eius comedent eos;"
,"32":"quidquid autem reliquum fuerit de carne et panibus, ignis absumet'."
,"33":"De ostio quoque tabernaculi conventus non exibitis septem diebus usque ad diem, quo complebitur tempus consecrationis vestrae; septem enim diebus finitur consecratio."
,"34":"Sicut et impraesentiarum factum est, praecepit Dominus, ut fieret in expiationem eorum."
,"35":"Die ac nocte manebitis in ostio tabernaculi conventus observantes observationem Domini, ne moriamini: sic enim mihi praeceptum est '."
,"36":"Feceruntque Aaron et filii eius cuncta, quae locutus est Dominus per manum Moysi."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Facto autem octavo die, vocavit Moyses Aaron et filios eius ac maiores natu Israel dixitque ad Aaron:"
,"2":"' Tolle de armento vitulum pro peccato et arietem in holocaustum, utrumque immaculatum, et affer illos coram Domino."
,"3":"Et ad filios Israel loqueris: 'Tollite hircum pro peccato et vitulum atque agnum anniculos et sine macula in holocaustum,"
,"4":"bovem et arietem pro pacificis, et immolate eos coram Domino, et sacrificium similae oleo conspersae: hodie enim Dominus apparebit vobis' '."
,"5":"Tulerunt ergo cuncta, quae iusserat Moyses, ad ostium tabernaculi conventus; ubi, cum omnis coetus accessisset et staret coram Domino,"
,"6":"ait Moyses: ' Iste est sermo, quem praecepit Dominus: facite, et apparebit vobis gloria eius '."
,"7":"Dixit et ad Aaron: ' Accede ad altare et immola pro peccato tuo; offer holocaustum et expia te et populum. Et fac hostiam populi et expia eum, sicut praecepit Dominus '."
,"8":"Statimque Aaron accedens ad altare immolavit vitulum pro peccato suo,"
,"9":"cuius sanguinem obtulerunt ei filii sui; in quo tinguens digitum tetigit cornua altaris et fudit residuum ad basim eius."
,"10":"Adipemque et renunculos ac reticulum iecoris, quae sunt de sacrificio pro peccato, adolevit super altare, sicut praeceperat Dominus Moysi."
,"11":"Carnes vero et pellem eius extra castra combussit igni."
,"12":"Immolavit et holocausti victimam; obtuleruntque ei filii sui sanguinem eius, quem fudit per altaris circuitum."
,"13":"Ipsam etiam hostiam in frusta concisam cum capite ei obtulerunt, quae omnia super altare cremavit igni;"
,"14":"lavit quoque aqua intestina cruraque et adolevit super holocausto in altari."
,"15":"Et applicavit oblationem populi sumensque hircum pro peccato populi mactavit et obtulit in expiationem sicut priorem;"
,"16":"fecit quoque holocaustum secundum ritum"
,"17":"et addens sacrificium similae implevit manum ex illa et adolevit super altare praeter holocaustum matutinum."
,"18":"Immolavit et bovem atque arietem, hostias pacificas populi; obtuleruntque ei filii sui sanguinem, quem fudit super altare in circuitu."
,"19":"Adipes autem bovis et caudam arietis renunculosque cum adipibus suis et reticulum iecoris"
,"20":"posuerunt super pectora; cumque cremati essent adipes in altari,"
,"21":"pectora eorum et armos dextros Aaron elevavit coram Domino, sicut praeceperat Moyses."
,"22":"Et elevans Aaron manus ad populum benedixit eis. Sicque, completis hostiis pro peccato et holocaustis et pacificis, descendit."
,"23":"Ingressi autem Moyses et Aaron tabernaculum conventus et deinceps egressi benedixerunt populo. Apparuitque gloria Domini omni populo;"
,"24":"et ecce egressus ignis a Domino devoravit holocaustum et adipes, qui erant super altare. Quod cum vidissent turbae, exultaverunt ruentes in facies suas."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Arreptisque Nadab et Abiu filii Aaron turibulis, posue runt ignem et incensum desuper offerentes coram Domino ignem alienum, qui eis praeceptus non erat."
,"2":"Egressusque ignis a Domino devoravit eos, et mortui sunt coram Domino."
,"3":"Dixitque Moyses ad Aaron: ' Hoc est, quod locutus est Dominus: 'Sanctificabor in his, qui appropinquant mihi, et in conspectu omnis populi glorificabor' '. Quod audiens tacuit Aaron."
,"4":"Vocatis autem Moyses Misael et Elisaphan filiis Oziel patrui Aaron, ait ad eos: ' Ite et tollite fratres vestros de conspectu sanctuarii et asportate extra castra '."
,"5":"Confestimque pergentes tulerunt eos, sicut iacebant vestitos subuculis suis, foras, ut sibi fuerat imperatum."
,"6":"Locutus est Moyses ad Aaron et ad Eleazar atque Ithamar filios eius: ' Comas vestras nolite excutere et vestimenta nolite scindere, ne moriamini, et super omnem coetum oriatur indignatio. Fratres vestri, omnis domus Israel, plangant incendium, quod Dominus suscitavit."
,"7":"Vos autem non egredimini fores tabernaculi conventus, alioquin peribitis; oleum quippe unctionis Domini est super vos '. Qui fecerunt omnia iuxta praeceptum Moysi."
,"8":"Dixit quoque Dominus ad Aaron:"
,"9":"' Vinum et omne, quod inebriare potest, non bibetis tu et filii tui, quando intratis tabernaculum conventus, ne moriamini praeceptum est sempiternum in generationes vestras"
,"10":"et ut habeatis scientiam discernendi inter sanctum et profanum, inter pollutum et mundum,"
,"11":"doceatisque filios Israel omnia legitima mea, quae locutus est Dominus ad eos per manum Moysi '."
,"12":"Locutusque est Moyses ad Aaron et ad Eleazar atque Ithamar filios eius, qui residui erant: ' Tollite oblationem similae, quae remansit de incensis Domini, et comedite illam absque fermento iuxta altare, quia sanctum sanctorum est."
,"13":"Comedetis autem in loco sancto, quia data est tibi et filiis tuis de incensis Domini, sicut praeceptum est mihi."
,"14":"Pectusculum quoque elationis et armum donationis edetis in loco mundissimo, tu et filii tui ac filiae tuae tecum; tibi enim ac liberis tuis reposita sunt de hostiis pacificis filiorum Israel."
,"15":"Armum et pectus cum incensis adipum afferent ad elationem coram Domino, et pertineant ad te et ad filios tuos lege perpetua, sicut praecepit Dominus '."
,"16":"De hirco autem pro peccato cum quaereret Moyses, exustum repperit; iratusque contra Eleazar et Ithamar filios Aaron, qui remanserant, ait:"
,"17":"' Cur non comedistis sacrificium pro peccato in loco sancto? Quod sanctum sanctorum est, et datum vobis, ut portetis iniquitatem coetus in expiationem eorum in conspectu Domini;"
,"18":"praesertim cum de sanguine illius non sit illatum intra sancta, comedere eam debuistis in sanctuario, sicut praeceptum est mihi '."
,"19":"Respondit Aaron: ' Oblata est hodie victima pro peccato et holocaustum eorum coram Domino; mihi autem accidit, quod vides. Quomodo potui comedere eam et placere Domino? '."
,"20":"Quod cum audisset Moyses, recepit satisfactionem."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Locutus est Dominus ad Moysen et Aaron dicens:"
,"2":"' Dicite filiis Israel: Haec sunt animalia, quae comedere debetis de cunctis animantibus terrae."
,"3":"Omne, quod habet plene divisam ungulam et ruminat in pecoribus, comedetis."
,"4":"Haec autem non comedetis ex ruminantibus vel dividentibus ungulam: camelum, quia ruminat quidem, sed non dividit ungulam, inter immunda reputabis;"
,"5":"hyracem, qui ruminat ungulamque non dividit, immundus est;"
,"6":"leporem quoque, nam et ipse ruminat, sed ungulam non dividit;"
,"7":"et suem, qui, cum ungulam plene dividat, non ruminat."
,"8":"Horum carnibus non vescemini nec cadavera contingetis, quia immunda sunt vobis."
,"9":"Haec sunt, quae gignuntur in aquis et vesci licitum est: omne, quod habet pinnulas et squamas, tam in mari quam in fluminibus et torrentibus, comedetis."
,"10":"Quidquid autem pinnulas et squamas non habet, reptilium vel quorumlibet aliorum animalium, quae in aquis moventur, abominabile vobis"
,"11":"et execrandum erit; carnes eorum non comedetis et morticina vitabitis."
,"12":"Cuncta, quae non habent pinnulas et squamas in aquis, polluta erunt vobis."
,"13":"Haec sunt, quae de avibus comedere non debetis, et vitanda sunt vobis: aquilam et grypem et haliaeetum,"
,"14":"milvum ac vulturem iuxta genus suum"
,"15":"et omne corvini generis,"
,"16":"struthionem et noctuam et larum et accipitrem iuxta genus suum,"
,"17":"bubonem et mergulum et ibin,"
,"18":"cycnum et nyctocoracem et porphyrionem,"
,"19":"erodionem et charadrion iuxta genus suum, upupam quoque et vespertilionem."
,"20":"Omne de volucribus, quod reptat super quattuor pedes, abominabile erit vobis."
,"21":"Quidquid autem ambulat quidem super quattuor pedes, sed habet longiora retro crura, per quae salit super terram,"
,"22":"comedere debetis; ut est bruchus in genere suo et attacus atque ophiomachus ac locusta, singula iuxta genus suum."
,"23":"Quidquid autem ex volucribus reptantibus quattuor tantum habet pedes, execrabile erit vobis."
,"24":"Et quicumque morticina eorum tetigerit, polluetur et erit immundus usque ad vesperum."
,"25":"Et si necesse fuerit, ut portet quippiam horum mortuum, lavabit vestimenta sua et immundus erit usque ad solis occasum."
,"26":"Omne animal, quod habet quidem ungulam, sed non dividit eam nec ruminat, immundum erit vobis; et, qui tetigerit illud, contaminabitur."
,"27":"Quod ambulat super plantas pedum ex cunctis animantibus, quae incedunt quadrupedia, immundum erit; qui tetigerit morticina eorum, polluetur usque ad vesperum."
,"28":"Et, qui portaverit huiuscemodi cadavera, lavabit vestimenta sua et immundus erit usque ad vesperum; quia omnia haec immunda sunt vobis."
,"29":"Haec quoque inter polluta reputabuntur de his, quae reptant in terra: mustela et mus et lacerta iuxta genus suum,"
,"30":"mygale et testudo et stellio et talpa et chamaeleon:"
,"31":"omnia haec immunda sunt. Qui tetigerit morticina eorum, immundus erit usque ad vesperum; "
,"32":"et super quod ceciderit quidquam de morticinis eorum, polluetur tam vas ligneum et vestimentum quam pelles et cilicia, et in quocumque fit opus; tinguentur aqua et polluta erunt usque ad vesperum et postea munda."
,"33":"Vas autem fictile, in quo horum quidquam intro ceciderit, polluetur et frangendum est."
,"34":"Omnis cibus, quem comedetis, si fusa fuerit exinde super eum aqua, immundus erit; et omne liquens, quod bibitur de tali vase, immundum erit."
,"35":"Et quidquid de morticinis istiusmodi ceciderit super illud, immundum erit; sive clibani sive chytropodes destruentur: immundi sunt et immundi erunt vobis."
,"36":"Fontes tamen et cisternae et omnis aquarum congregatio munda erit. Qui vero morticinum eorum tetigerit, polluetur."
,"37":"Si ceciderint super sementem, non polluent eam;"
,"38":"sin autem quispiam aqua sementem perfuderit, et postea morticinis tacta fuerit, immunda erit vobis."
,"39":"Si mortuum fuerit animal, quod licet vobis comedere, qui cadaver eius tetigerit, immundus erit usque ad vesperum;"
,"40":"et, qui comederit ex eo quippiam sive portaverit cadaver eius, lavabit vestimenta sua et immundus erit usque ad vesperum."
,"41":"Omne, quod reptat super terram, abominabile erit nec assumetur in cibum."
,"42":"Quidquid super pectus et quidquid quadrupes graditur, vel multos habet pedes sive per humum trahitur, non comedetis, quia abominabile est."
,"43":"Nolite contaminare animas vestras nec tangatis quidquam eorum, ne immundi sitis."
,"44":"Ego enim sum Dominus Deus vester; sanctificamini et sancti estote, quoniam et ego sanctus sum. Ne polluatis animas vestras in omni reptili, quod movetur super terram."
,"45":"Ego enim sum Dominus, qui eduxi vos de terra Aegypti, ut essem vobis in Deum: sancti eritis, quia et ego sanctus sum."
,"46":"Ista est lex animantium et volucrum et omnis animae viventis, quae movetur in aqua et reptat in terra,"
,"47":"ut differentias noveritis mundi et immundi, et sciatis quid comedere et quid respuere debeatis '."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Locutus est Dominus ad Moysen dicens:"
,"2":"' Loquere fi liis Israel et dices ad eos: Mulier, si, suscepto semine, pepererit masculum, immunda erit septem diebus iuxta dies separationis menstruae,"
,"3":"et die octavo circumcidetur infantulus;"
,"4":"ipsa vero triginta tribus diebus manebit in sanguine purificationis suae; omne sanctum non tanget nec ingredietur sanctuarium, donec impleantur dies purificationis eius."
,"5":"Sin autem feminam pepererit, immunda erit duabus hebdomadibus iuxta ritum fluxus menstrui, et sexaginta ac sex diebus manebit in sanguine purificationis suae."
,"6":"Cumque expleti fuerint dies purificationis suae pro filio sive pro filia, deferet agnum anniculum in holocaustum et pullum columbae sive turturem pro peccato ad ostium tabernaculi conventus et tradet sacerdoti."
,"7":"Qui offeret illa coram Domino et expiabit eam; et sic mundabitur a profluvio sanguinis sui: ista est lex parientis masculum aut feminam."
,"8":"Quod si non invenerit manus eius, nec potuerit offerre agnum, sumet duos turtures vel duos pullos columbae, unum in holocaustum et alterum pro peccato; expiabitque eam sacerdos, et sic mundabitur '."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Locutus est Dominus ad Moysen et Aaron dicens:"
,"2":"' Homo, in cuius carne et cute ortus fuerit tumor sive pustula aut quasi lucens quippiam, id est plaga leprae, adducetur ad Aaron sacerdotem vel ad unum quemlibet filiorum eius sacerdotum."
,"3":"Qui cum viderit plagam in cute et pilos in album mutatos colorem ipsamque speciem plagae humiliorem cute et carne reliqua: plaga leprae est; quod cum viderit sacerdos, eum immundum esse decernet."
,"4":"Sin autem lucens candor fuerit in cute nec humilior carne reliqua, et pili coloris pristini, recludet eum sacerdos septem diebus."
,"5":"Et considerabit eum die septimo: et, siquidem plaga ultra non creverit nec transierit in cute priores terminos, rursum recludet eum septem diebus aliis."
,"6":"Et die septimo contemplabitur eum iterum: si obscurior fuerit plaga et non creverit in cute, eum mundum esse decernet, quia scabies est. Lavabitque homo vestimenta sua et mundus erit."
,"7":"Quod si, postquam a sacerdote visus est et redditus munditiae, iterum scabies creverit, adducetur ad eum;"
,"8":"et, si viderit ita esse, immunditiae condemnabitur: est lepra."
,"9":"Plaga leprae si fuerit in homine, adducetur ad sacerdotem,"
,"10":"et videbit eum. Cumque tumor albus in cute fuerit et capillorum mutaverit aspectum in album, caro quoque viva creverit in tumore,"
,"11":"lepra vetustissima iudicabitur atque inolita cuti. Contaminabit itaque eum sacerdos et non recludet, quia perspicue immunditia est."
,"12":"Sin autem effloruerit discurrens lepra in cute et operuerit omnem cutem a capite usque ad pedes, quidquid sub aspectu oculorum cadit,"
,"13":"considerabit eum sacerdos et teneri lepra mundissima iudicabit, eo quod omnis in candorem versa sit, et idcirco homo mundus erit."
,"14":"Quando vero caro vivens in eo apparuerit, immundus erit."
,"15":"Quod cum sacerdos viderit, inter immundos reputabit; caro enim viva immunda est: lepra est."
,"16":"Quod si rursum versa fuerit in alborem, veniet ad sacerdotem,"
,"17":"qui cum hoc consideraverit, eum mundum esse decernet."
,"18":"Caro et cutis, in qua ulcus natum est et sanatum,"
,"19":"et in loco ulceris tumor apparuerit albus sive macula subrufa, ostendet se homo sacerdoti."
,"20":"Qui cum viderit locum maculae humiliorem carne reliqua et pilos versos in candorem, contaminabit eum: plaga enim leprae orta est in ulcere."
,"21":"Quod si pilus coloris est pristini et cicatrix subobscura et vicina carne non est humilior, recludet eum septem diebus."
,"22":"Et, siquidem creverit, adiudicabit eum leprae;"
,"23":"sin autem steterit in loco suo macula nec creverit, ulceris est cicatrix, et sacerdos eum mundum esse decernet."
,"24":"Vel si alicuius cutem ignis exusserit, et locus exustionis subrufam sive albam habuerit maculam,"
,"25":"considerabit eam sacerdos; et ecce pilus versus est in alborem, et locus eius reliqua cute humilior, contaminabit eum, quia plaga leprae in cicatrice orta est."
,"26":"Quod si pilorum color non fuerit immutatus, nec humilior macula carne reliqua, et ipsa leprae species fuerit subobscura, recludet eum septem diebus."
,"27":"Et die septimo contemplabitur eum; si creverit in cute macula, contaminabit eum: plaga est leprae;"
,"28":"sin autem in loco suo macula steterit non satis clara, tumor combustionis est, et idcirco mundabit eum, quia cicatrix est combusturae."
,"29":"Vir sive mulier, in cuius capite vel barba germinarit plaga, videbit eam sacerdos."
,"30":"Et, siquidem humilior fuerit locus carne reliqua, et capillus flavus solitoque subtilior, contaminabit eos, quia scabies est, lepra capitis vel barbae."
,"31":"Sin autem viderit plagam scabiei aequalem vicinae carni nec capillum nigrum in ea, recludet eos septem diebus."
,"32":"Et die septimo intuebitur plagam: si non creverit scabies, nec capillus flavus fuerit in ea, et locus plagae carni reliquae aequalis,"
,"33":"radetur homo absque loco maculae, et includet eum sacerdos septem diebus aliis."
,"34":"Si die septimo visa fuerit stetisse plaga in loco suo nec humilior carne reliqua, mundabit eum sacerdos; lotisque vestibus mundus erit."
,"35":"Sin autem post emundationem rursus creverit scabies in cute,"
,"36":"non quaeret amplius utrum capillus in flavum colorem sit commutatus, quia aperte immundus est."
,"37":"Porro si steterit macula, et capilli nigri fuerint, noverit hominem esse sanatum et confidenter eum pronuntiet mundum."
,"38":"Vir et mulier, in cuius cute maculae, maculae albae apparuerint,"
,"39":"intuebitur eos sacerdos. Si deprehenderit subobscurum alborem lucere in cute, sciat impetiginem ortam esse in cute; mundus est."
,"40":"Vir, de cuius capite capilli fluunt, calvus ac mundus est;"
,"41":"et, si a fronte ceciderint pili, recalvaster et mundus est."
,"42":"Sin autem in calvitio sive in recalvatione plaga alba vel subrufa fuerit exorta, lepra est capitis."
,"43":"Sacerdos eum videbit, et ecce tumor plagae subrufus secundum aspectum leprae cutis carnis."
,"44":"Vir maculatus est lepra, et sacerdos omnino decernet eum esse immundum; plaga est in capite eius."
,"45":"Leprosus hac plaga percussus habebit vestimenta dissuta, comam capitis excussam, barbam contectam; clamabit: 'Immundus! Immundus!'."
,"46":"Omni tempore, quo leprosus est immundus, immundus est et solus habitabit extra castra."
,"47":"Si in veste lanea sive linea lepra fuerit,"
,"48":"in stamine sive subtemine lineo vel laneo aut in pelle vel quolibet ex pelle confecto,"
,"49":"si macula pallida aut rufa fuerit, lepra reputabitur ostendeturque sacerdoti."
,"50":"Qui considerabit macula infectum et recludet septem diebus;"
,"51":"et die septimo rursus aspiciens, si crevisse deprehenderit, lepra maligna est; pollutum iudicabit vestimentum et omne, in quo fuerit inventa,"
,"52":"et idcirco comburetur flammis."
,"53":"Quod si eam viderit non crevisse,"
,"54":"praecipiet, et lavabunt id, in quo plaga est; recludetque illud septem diebus aliis."
,"55":"Et cum viderit post lavationem faciem quidem pristinam non mutatam, nec tamen crevisse plagam, immunda est res, et igne combures eam, eo quod infusa sit plaga in superficie rei vel in parte aversa."
,"56":"Sin autem obscurior fuerit locus plagae, postquam res est lota, sacerdos abrumpet eum et a solido dividet."
,"57":"Quod si macula ultra apparuerit in his rebus, quae prius immaculata erant, lepra volatilis et vaga, igne combures illas."
,"58":"Quas vero laveris et a quibus cessaverit plaga, illas lavabis secundo, et mundae erunt."
,"59":"Ista est lex leprae vestimenti lanei et linei, staminis atque subteminis, omnisque supellectilis pelliceae, quomodo mundari debeat vel contaminari '."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Hic est ri tus leprosi, quando mundandus est: adducetur ad sacerdotem,"
,"3":"qui egressus e castris, cum invenerit lepram esse sanatam,"
,"4":"praecipiet, ut sumant pro eo, qui purificatur, duas aves vivas, mundas et lignum cedrinum vermiculumque et hyssopum."
,"5":"Et unam ex avibus immolari iubebit in vase fictili super aquas viventes."
,"6":"Aliam autem vivam cum ligno cedrino et cocco et hyssopo tinguet in sanguine avis super aquas viventes immolatae,"
,"7":"quo asperget illum, qui a lepra mundandus est, septies, ut iure purgetur; et dimittet avem vivam, ut in agrum avolet."
,"8":"Cumque laverit homo vestimenta sua, radet omnes pilos corporis, et lavabitur aqua; purificatusque ingredietur castra, ita dumtaxat ut maneat extra tabernaculum suum septem diebus."
,"9":"Et die septimo radet capillos capitis barbamque et supercilia ac totius corporis pilos et lavabit vestimenta carnemque suam aqua, et mundus erit."
,"10":"Die octavo assumet duos agnos immaculatos et ovem anniculam absque macula et tres decimas ephi similae in sacrificium, quae conspersa sit oleo, et log olei."
,"11":"Cumque sacerdos purificans hominem statuerit eum et haec omnia coram Domino in ostio tabernaculi conventus,"
,"12":"tollet agnum unum et offeret eum in sacrificium pro delicto, oleique log et, elevatis ante Dominum omnibus,"
,"13":"immolabit agnum, ubi immolari solet hostia pro peccato et holocaustum, id est in loco sancto. Sicut enim pro peccato ita et pro delicto ad sacerdotem pertinet sacrificium: sanctum sanctorum est."
,"14":"Assumensque sacerdos de sanguine hostiae pro delicto ponet super extremum auriculae dextrae eius, qui mundatur, et super pollices manus dextrae et pedis;"
,"15":"et de olei log mittet in manum suam sinistram"
,"16":"tinguetque digitum dextrum in eo et asperget septies coram Domino."
,"17":"Quod autem reliquum est olei in laeva manu, fundet super extremum auriculae dextrae eius, qui mundatur, et super pollices manus ac pedis dextri et super sanguinem sacrificii pro delicto"
,"18":"et super caput eius, qui mundatur; expiabitque eum coram Domino"
,"19":"et faciet sacrificium pro peccato. Tunc immolabit holocaustum"
,"20":"et ponet illud in altari cum sacrificio similae, et homo rite mundabitur."
,"21":"Quod si pauper est, et non potest manus eius invenire, quae dicta sunt, assumet agnum pro delicto ad elationem, ut expiet eum sacerdos, decimamque partem similae conspersae oleo in sacrificium et olei log"
,"22":"duosque turtures sive duos pullos columbae, quos manus eius invenire poterit, unum pro peccato et alterum in holocaustum."
,"23":"Offeretque ea die octavo purificationis suae sacerdoti ad ostium tabernaculi conventus coram Domino."
,"24":"Qui suscipiens agnum pro delicto et log olei levabit simul coram Domino;"
,"25":"immolatoque agno pro delicto, de sanguine eius ponet super extremum auriculae dextrae illius, qui mundatur, et super pollices manus eius ac pedis dextri;"
,"26":"olei vero partem mittet in manum suam sinistram."
,"27":"In quo tinguens digitum dextrae manus asperget septies coram Domino;"
,"28":"tangetque extremum auriculae dextrae illius, qui mundatur, et pollices manus ac pedis dextri super locum sanguinis, qui effusus est pro delicto."
,"29":"Reliquam autem partem olei, quae est in sinistra manu, mittet super caput hominis, qui purificatur, in expiationem eius coram Domino;"
,"30":"et turtures sive pullos columbae, quos manus illius invenerit, offeret,"
,"31":"unum pro delicto et alterum in holocaustum cum sacrificio similae, et sic expiabit eum sacerdos coram Domino."
,"32":"Hoc est sacrificium leprosi, qui habere non potest omnia in emundationem sui '."
,"33":"Locutus est Dominus ad Moysen et Aaron dicens:"
,"34":"' Cum ingressi fueritis terram Chanaan, quam ego dabo vobis in possessionem, si fuerit plaga leprae in aedibus terrae possessionis vestrae,"
,"35":"ibit, cuius est domus, nuntians sacerdoti et dicet: 'Quasi plaga videtur mihi esse in domo mea'."
,"36":"At ille praecipiet, ut efferant universa de domo, priusquam ingrediatur eam, et videat plagam, ne immunda fiant omnia, quae in domo sunt. Intrabitque postea, ut consideret domum;"
,"37":"et, cum viderit in parietibus illius quasi valliculas pallore sive rubore deformes et humiliores superficie reliqua,"
,"38":"egredietur ostium domus et statim claudet eam septem diebus."
,"39":"Reversusque die septimo considerabit eam; si invenerit crevisse plagam,"
,"40":"iubebit erui lapides, in quibus plaga est, et proici eos extra civitatem in loco immundo;"
,"41":"domum autem ipsam radi intrinsecus per circuitum et spargi pulverem rasurae extra urbem in locum immundum"
,"42":"lapidesque alios reponi pro his, qui ablati fuerint, et luto alio liniri domum."
,"43":"Sin autem plaga rursum effloruerit in domo, postquam eruti sunt lapides et pulvis erasus et alia terra lita,"
,"44":"et ingressus sacerdos viderit crevisse plagam in domo: lepra est maligna et domus immunda."
,"45":"Quam statim destruent et lapides eius ac ligna atque universum pulverem domus proicient extra oppidum in loco immundo."
,"46":"Qui intraverit domum, quando clausa est, immundus erit usque ad vesperum;"
,"47":"et, qui dormierit in ea vel comederit quippiam, lavabit vestimenta sua."
,"48":"Quod si introiens sacerdos viderit plagam non crevisse in domo, postquam denuo lita est, mundam eam esse decernet, reddita sanitate."
,"49":"Et in purificationem eius sumet duas aves lignumque cedrinum et vermiculum atque hyssopum"
,"50":"et, immolata una avi in vase fictili super aquas vivas,"
,"51":"tollet lignum cedrinum et hyssopum et coccum et avem vivam et intinguet omnia in sanguine avis immolatae atque in aquis viventibus et asperget domum septies;"
,"52":"purificabitque eam tam in sanguine avis quam in aquis viventibus et in avi viva lignoque cedrino et hyssopo atque vermiculo;"
,"53":"cumque dimiserit avem avolare extra urbem in agrum libere, expiabit domum, et erit munda."
,"54":"Ista est lex omnis leprae et scabiei,"
,"55":"leprae vestium et domorum,"
,"56":"tumoris et pustulae et lucentis maculae,"
,"57":"ut possit sciri quo tempore immundum quid vel mundum sit '."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Locutus est Dominus ad Moysen et Aaron dicens:"
,"2":"' Loquimini filiis Israel et dicite eis: Vir, si patitur fluxum seminis, immundus erit."
,"3":"Et tunc iudicabitur huic vitio subiacere: sive emiserit caro eius fluxum suum vel occluserit se a fluxu."
,"4":"Omne stratum, in quo iacuerit, immundum erit, et ubicumque sederit."
,"5":"Si quis hominum tetigerit lectum eius, lavabit vestimenta sua, et ipse lotus aqua immundus erit usque ad vesperum."
,"6":"Si sederit, ubi ille sederat, et ipse lavabit vestimenta sua et lotus aqua immundus erit usque ad vesperum."
,"7":"Qui tetigerit carnem eius, lavabit vestimenta sua et ipse lotus aqua immundus erit usque ad vesperum."
,"8":"Si salivam huiuscemodi homo iecerit super eum, qui mundus est, hic lavabit vestem suam et lotus aqua immundus erit usque ad vesperum."
,"9":"Sagma, super quo sederit, immundum erit;"
,"10":"et quicumque tetigerit omne, quod sub eo fuerit, qui fluxum seminis patitur, pollutus erit usque ad vesperum. Qui portaverit horum aliquid, lavabit vestem suam et ipse lotus aqua immundus erit usque ad vesperum."
,"11":"Omnis, quem tetigerit, qui fluxum patitur, non lotis ante manibus, lavabit vestimenta sua et lotus aqua immundus erit usque ad vesperum."
,"12":"Vas fictile, quod tetigerit, confringetur; vas autem ligneum lavabitur aqua."
,"13":"Si sanatus fuerit, qui huiuscemodi sustinet passionem, numerabit septem dies ad emundationem sui et, lotis vestibus ac toto corpore in aquis viventibus, erit mundus."
,"14":"Die autem octavo sumet duos turtures aut duos pullos columbae et veniet in conspectu Domini ad ostium tabernaculi conventus dabitque eos sacerdoti."
,"15":"Qui faciet unum in sacrificium pro peccato et alterum in holocaustum; expiabitque eum coram Domino et emundabitur a fluxu seminis sui."
,"16":"Vir, de quo egreditur semen, lavabit aqua omne corpus suum et immundus erit usque ad vesperum."
,"17":"Vestem et pellem, super quam fuerit semen effusum, lavabitur aqua et immunda erit usque ad vesperum."
,"18":"Si cum muliere coierit vir, lavabunt se aqua et immundi erunt usque ad vesperum."
,"19":"Mulier, quae redeunte mense patitur fluxum sanguinis, septem diebus separabitur. Omnis, qui tetigerit eam, immundus erit usque ad vesperum;"
,"20":"et in quo iacuerit vel sederit diebus separationis suae, polluetur."
,"21":"Qui tetigerit lectum eius, lavabit vestimenta sua et ipse lotus aqua immundus erit usque ad vesperum."
,"22":"Omne vas, super quo illa sederit, quisquis attigerit, lavabit vestimenta sua et ipse lotus aqua pollutus erit usque ad vesperum."
,"23":"Et quicumque tetigerit omne, quod fuerit super lectum vel supellectilem, in qua illa sederit, immundus erit usque ad vesperum."
,"24":"Si coierit cum ea vir tempore sanguinis menstrualis, immundus erit septem diebus, et omne stratum, in quo dormierit, polluetur."
,"25":"Mulier, quae patitur multis diebus fluxum sanguinis non in tempore menstruali vel quae post menstruum sanguinem fluere non cessat, quamdiu huic subiacet passioni, immunda erit quasi sit in tempore menstruo."
,"26":"Omne stratum, in quo dormierit, et vas, in quo sederit, pollutum erit."
,"27":"Quicumque tetigerit ea, polluetur; lavabit vestimenta sua et ipse lotus aqua immundus erit usque ad vesperum."
,"28":"Si steterit sanguis et fluere cessarit, numerabit septem dies et deinde munda erit."
,"29":"Et octavo die assumet pro se duos turtures vel duos pullos columbae afferetque sacerdoti ad ostium tabernaculi conventus."
,"30":"Qui unum faciet in sacrificium pro peccato et alterum in holocaustum; expiabitque eam coram Domino a fluxu immunditiae eius."
,"31":"Docebitis ergo filios Israel, ut caveant immunditiam, ne moriantur in sordibus suis, cum polluerint habitaculum meum, quod est inter eos."
,"32":"Ista est lex eius, qui patitur fluxum seminis et de quo egreditur semen et polluitur,"
,"33":"et quae menstruis temporibus separatur vel quae iugi fluit sanguine, et hominis, qui dormierit cum immunda '."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Locutusque est Dominus ad Moysen post mortem duum filiorum Aaron, quando appropinquantes in conspectum Domini interfecti sunt,"
,"2":"et praecepit ei dicens: ' Loquere ad Aaron fratrem tuum, ne omni tempore ingrediatur sanctuarium, quod est intra velum coram propitiatorio, quo tegitur arca, ut non moriatur, quia in nube apparebo super propitiatorium;"
,"3":"sed hoc modo ingrediatur: vitulum offeret pro peccato et arietem in holocaustum;"
,"4":"subucula linea sancta vestietur, feminalibus lineis verecunda celabit, accingetur zona linea, cidarim lineam imponet capiti. Haec enim vestimenta sunt sancta, quibus cunctis, cum lotus fuerit, induetur."
,"5":"Suscipietque a coetu filiorum Israel duos hircos in sacrificium pro peccato et unum arietem in holocaustum."
,"6":"Cumque obtulerit vitulum in sacrificium suum pro peccato et expiaverit se et domum suam,"
,"7":"duos hircos stare faciet coram Domino in ostio tabernaculi conventus,"
,"8":"mittens super utrumque sortem, unam Domino et alteram Azazel."
,"9":"Cuius sors exierit Domino, offeret illum pro peccato;"
,"10":"cuius autem in Azazel, statuet eum vivum coram Domino in expiationem, ut emittat illum ad Azazel in solitudinem."
,"11":"Afferet ergo Aaron vitulum pro peccato et expians se et domum suam immolabit eum;"
,"12":"assumptoque turibulo, quod de prunis altaris coram Domino impleverit, et hauriens manu compositum thymiama in incensum ultra velum intrabit in sancta,"
,"13":"ut, positis super ignem aromatibus coram Domino, nebula eorum et vapor operiat propitiatorium, quod est super testimonium, et non moriatur."
,"14":"Tollet quoque de sanguine vituli et asperget digito septies contra frontem propitiatorii."
,"15":"Cumque mactaverit hircum pro peccato populi, inferet sanguinem eius intra velum, sicut praeceptum est de sanguine vituli, ut aspergat e regione propitiatorii"
,"16":"et expiet sanctuarium ab immunditiis filiorum Israel et a praevaricationibus eorum cunctisque peccatis. Iuxta hunc ritum faciet tabernaculo conventus, quod fixum est inter eos in medio sordium habitationis eorum."
,"17":"Nullus hominum sit in tabernaculo conventus, quando pontifex ingreditur sanctuarium, ut expiet se et domum suam et universam congregationem Israel, donec egrediatur."
,"18":"Cum autem exierit ad altare, quod coram Domino est, expiabit illud et sumptum sanguinem vituli atque hirci fundet super cornua eius per gyrum;"
,"19":"aspergensque de sanguine digito septies mundabit sanctificabitque illud ab immunditiis filiorum Israel."
,"20":"Et postquam compleverit expiationem sanctuarii et tabernaculi conventus et altaris, tunc afferat hircum viventem;"
,"21":"et, posita utraque manu super caput eius, confiteatur Aaron super eum omnes iniquitates filiorum Israel et universa delicta atque peccata eorum; quae ponens super caput eius emittet illum per hominem paratum in desertum."
,"22":"Cumque portaverit hircus super se omnes iniquitates eorum in terram solitariam et dimissus fuerit in desertum,"
,"23":"ingredietur Aaron in tabernaculum conventus; et, depositis vestibus lineis, quibus prius indutus erat, cum intraret sanctuarium, relictisque ibi,"
,"24":"lavabit carnem suam aqua in loco sancto indueturque vestimentis suis. Et postquam egressus obtulerit holocaustum suum ac plebis, expiabit se et populum;"
,"25":"et adipem sacrificii pro peccato adolebit super altare."
,"26":"Ille vero, qui dimiserit caprum emissarium ad Azazel, lavabit vestimenta sua et corpus aqua et postea ingredietur in castra."
,"27":"Vitulum autem et hircum, qui pro peccato fuerant immolati, et quorum sanguis illatus est, ut in sanctuario expiatio compleretur, asportabunt foras castra et comburent igni tam pelles quam carnes eorum et fimum;"
,"28":"et quicumque combusserit ea, lavabit vestimenta sua et carnem aqua et postea ingredietur in castra."
,"29":"Eritque hoc vobis legitimum sempiternum: mense septimo, decima die mensis affligetis animas vestras nullumque facietis opus sive indigena sive advena, qui peregrinatur inter vos."
,"30":"In hac die expiatio erit vestri atque mundatio; ab omnibus peccatis vestris coram Domino mundabimini."
,"31":"Sabbatum requietionis est vobis, et affligetis animas vestras religione perpetua."
,"32":"Expiabit autem sacerdos, qui unctus fuerit, et cuius initiatae manus, ut sacerdotio fungatur pro patre suo; indueturque vestimentis lineis, vestibus sanctis,"
,"33":"et expiabit sanctuarium sanctissimum et tabernaculum conventus atque altare, sacerdotes quoque et universum populum congregationis."
,"34":"Eritque hoc vobis legitimum sempiternum, ut expietis filios Israel a cunctis peccatis eorum semel in anno '. Fecit igitur, sicut praeceperat Dominus Moysi."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Et locutus est Dominus ad Moysen dicens:"
,"2":"' Loquere Aaron et filiis eius et cunctis filiis Israel et dices ad eos: Iste est sermo, quem mandavit Dominus dicens:"
,"3":"Homo quilibet de domo Israel, si occiderit bovem aut ovem sive capram in castris vel extra castra"
,"4":"et non attulerit ad ostium tabernaculi conventus in oblationem Domino coram habitaculo Domini, sanguinis reus erit; sanguinem fudit et peribit de medio populi sui."
,"5":"Ideo offerre debent sacerdoti filii Israel hostias suas, quas occidunt in agro, ut afferant Domino ante ostium tabernaculi conventus et immolent eas hostias pacificas Domino."
,"6":"Fundetque sacerdos sanguinem super altare Domini ad ostium tabernaculi conventus et adolebit adipem in odorem suavitatis Domino;"
,"7":"et nequaquam ultra immolabunt hostias suas daemonibus, cum quibus fornicati sunt: legitimum sempiternum erit hoc illis et posteris eorum '."
,"8":"Et ad ipsos dices: ' Homo de domo Israel et de advenis, qui peregrinantur apud vos, qui obtulerit holocaustum sive sacrificium"
,"9":"et ad ostium tabernaculi conventus non adduxerit victimam, ut offeratur Domino, interibit de populo suo."
,"10":"Homo quilibet de domo Israel et de advenis, qui peregrinantur inter eos, si comederit sanguinem, confirmabo faciem meam contra talem animam et disperdam eam de populo suo."
,"11":"Quia anima carnis in sanguine est, et ego dedi illum vobis, ut super altare in eo expietis pro animabus vestris, quia sanguis ipse per animam expiat."
,"12":"Idcirco dixi filiis Israel: Omnis anima ex vobis non comedet sanguinem, nec ex advenis, qui peregrinantur inter vos."
,"13":"Homo quicumque de filiis Israel et de advenis, qui peregrinantur apud vos, si venatione ceperit feram vel avem, quibus vesci licitum est, fundat sanguinem eius et operiat illum terra."
,"14":"Anima enim omnis carnis, sanguis est anima eius, unde dixi filiis Israel: Sanguinem universae carnis non comedetis, quia anima omnis carnis sanguis eius est; et, quicumque comederit illum, interibit."
,"15":"Anima, quae comederit morticinum vel captum a bestia, tam de indigenis quam de advenis, lavabit vestes suas et semetipsum aqua, et contaminatus erit usque ad vesperum; et hoc ordine mundus fiet."
,"16":"Quod si non laverit vestimenta sua nec corpus, portabit iniquitatem suam '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Locutus est Dominus ad Moysen dicens:"
,"2":"' Loquere fi liis Israel et dices ad eos: Ego Dominus Deus vester."
,"3":"Iuxta consuetudinem terrae Aegypti, in qua habitastis, non facietis; et iuxta morem regionis Chanaan, ad quam ego introducturus sum vos, non agetis nec in legitimis eorum ambulabitis."
,"4":"Facietis iudicia mea et praecepta mea servabitis et ambulabitis in eis. Ego Dominus Deus vester."
,"5":"Custodite leges meas atque iudicia; quae faciens homo vivet in eis. Ego Dominus."
,"6":"Omnis homo ad consanguineum suum non accedet, ut revelet turpitudinem eius. Ego Dominus."
,"7":"Turpitudinem patris et turpitudinem matris tuae non discooperies: mater tua est, non revelabis turpitudinem eius."
,"8":"Turpitudinem uxoris patris tui non discooperies, turpitudo enim patris tui est."
,"9":"Turpitudinem sororis tuae ex patre sive ex matre, quae domi vel foris genita est, non revelabis."
,"10":"Turpitudinem filiae filii tui vel neptis ex filia non revelabis, quia turpitudo tua est."
,"11":"Turpitudinem filiae uxoris patris tui, quam peperit patri tuo et est soror tua, non revelabis."
,"12":"Turpitudinem sororis patris tui non discooperies, quia caro est patris tui."
,"13":"Turpitudinem sororis matris tuae non revelabis, eo quod caro sit matris tuae."
,"14":"Turpitudinem patrui tui non revelabis nec accedes ad uxorem eius, quae tibi affinitate coniungitur."
,"15":"Turpitudinem nurus tuae non revelabis, quia uxor filii tui est, nec discooperies ignominiam eius."
,"16":"Turpitudinem uxoris fratris tui non revelabis, quia turpitudo fratris tui est."
,"17":"Turpitudinem mulieris et filiae eius non revelabis. Filiam filii eius et filiam filiae illius non sumes, ut reveles ignominiam eius, quia caro illius sunt: nefas est."
,"18":"Sororem uxoris tuae aemulam illius non accipies nec revelabis turpitudinem eius, adhuc illa vivente."
,"19":"Ad mulierem, quae patitur menstrua, non accedes nec revelabis foeditatem eius."
,"20":"Cum uxore proximi tui non coibis nec seminis commixtione maculaberis."
,"21":"De semine tuo non dabis, ut consecretur idolo Moloch, nec pollues nomen Dei tui. Ego Dominus."
,"22":"Cum masculo non commisceberis coitu femineo: abominatio est."
,"23":"Cum omni pecore non coibis nec maculaberis cum eo. Mulier non succumbet iumento nec miscebitur ei, quia scelus est."
,"24":"Ne polluamini in omnibus his, quibus contaminatae sunt universae gentes, quas ego eiciam ante conspectum vestrum"
,"25":"et quibus polluta est terra, cuius ego scelera visitavi, et evomuit habitatores suos."
,"26":"Vos autem custodite legitima mea atque iudicia et non faciatis ex omnibus abominationibus istis tam indigena quam colonus, qui peregrinatur apud vos."
,"27":"Omnes enim execrationes istas fecerunt accolae terrae, qui fuerunt ante vos, et polluerunt eam."
,"28":"Cavete ergo, ne et vos similiter evomat, cum pollueritis eam, sicut evomuit gentem, quae fuit ante vos."
,"29":"Omnis enim anima, quae fecerit de abominationibus his quippiam, peribit de medio populi sui."
,"30":"Custodite mandata mea. Nolite facere legitima abominabilia, quae fecerunt hi, qui fuerunt ante vos, et ne polluamini in eis. Ego Dominus Deus vester '."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Locutus est Dominus ad Moysen dicens:"
,"2":"' Loquere ad omnem coetum filiorum Israel et dices ad eos: Sancti estote, quia sanctus sum ego, Dominus Deus vester."
,"3":"Unusquisque matrem et patrem suum timeat. Sabbata mea custodite. Ego Dominus Deus vester."
,"4":"Nolite converti ad idola nec deos conflatiles faciatis vobis. Ego Dominus Deus vester."
,"5":"Si immolaveritis hostiam pacificorum Domino, immolabitis eam ita ut sit vobis placabilis."
,"6":"Eo die, quo fuerit immolata, comedetur et die altero; quidquid autem residuum fuerit in diem tertium, igne comburetur."
,"7":"Si quid post biduum comestum fuerit, profanum erit neque acceptabile."
,"8":"Qui manducaverit illud, portabit iniquitatem suam, quia sanctum Domini polluit, et peribit anima illa de populo suo."
,"9":"Cum messueris segetes terrae tuae, non tondebis usque ad marginem agri tui nec remanentes spicas colliges."
,"10":"Neque in vinea tua racemos et grana decidentia congregabis, sed pauperibus et peregrinis carpenda dimittes. Ego Dominus Deus vester."
,"11":"Non facietis furtum. Non mentiemini, nec decipiet unusquisque proximum suum."
,"12":"Non periurabis in nomine meo nec pollues nomen Dei tui. Ego Dominus."
,"13":"Non facies calumniam proximo tuo nec spoliabis eum. Non morabitur merces mercennarii apud te usque mane."
,"14":"Non maledices surdo nec coram caeco pones offendiculum; sed timebis Deum tuum. Ego Dominus."
,"15":"Non facietis, quod iniquum est in iudicio. Non consideres personam pauperis nec honores vultum potentis. Iuste iudica proximo tuo."
,"16":"Non eris criminator et susurro in populo tuo. Non stabis contra sanguinem proximi tui. Ego Dominus."
,"17":"Ne oderis fratrem tuum in corde tuo; argue eum, ne habeas super illo peccatum."
,"18":"Non quaeres ultionem nec irasceris civibus tuis. Diliges proximum tuum sicut teipsum. Ego Dominus."
,"19":"Leges meas custodite. Iumenta tua non facies coire cum alterius generis animantibus. Agrum tuum non seres diverso semine. Veste, quae ex duobus texta est, non indueris."
,"20":"Homo, si dormierit cum muliere coitu seminis, quae sit ancilla destinata viro et tamen pretio non redempta nec libertate donata, vapulabunt ambo et non morientur, quia non fuit libera."
,"21":"Et in sacrificium suum pro delicto offeret Domino ad ostium tabernaculi conventus arietem;"
,"22":"expiabitque eum sacerdos ariete a peccato eius coram Domino, et dimittetur ei peccatum, quod peccavit."
,"23":"Quando ingressi fueritis terram et plantaveritis omnimoda ligna pomifera, non auferetis praeputia eorum, id est poma, quae germinant; tribus annis erunt vobis immunda ut praeputia, nec edetis ex eis."
,"24":"Quarto anno omnis fructus eorum sanctificabitur laudabilis Domino."
,"25":"Quinto autem anno comedetis fructus eorum, ut augeatur vobis proventus eorum. Ego Dominus Deus vester."
,"26":"Non comedetis cum sanguine. Non augurabimini nec observabitis omina."
,"27":"Neque in rotundum attondebitis marginem comae nec truncabis barbam."
,"28":"Et super mortuo non incidetis carnem vestram neque figuras aliquas in cute incidetis vobis. Ego Dominus."
,"29":"Ne polluas et prostituas filiam tuam, ne contaminetur terra et impleatur piaculo."
,"30":"Sabbata mea custodite et sanctuarium meum metuite. Ego Dominus."
,"31":"Non declinetis ad pythones nec ab hariolis aliquid sciscitemini, ut polluamini per eos. Ego Dominus Deus vester."
,"32":"Coram cano capite consurge et honora personam senis; et time Deum tuum. Ego Dominus."
,"33":"Si habitaverit tecum advena in terra vestra, non opprimetis eum;"
,"34":"sed sit inter vos quasi indigena, et diliges eum sicut teipsum: fuistis enim et vos advenae in terra Aegypti. Ego Dominus Deus vester."
,"35":"Nolite facere iniquum aliquid in iudicio, in regula, in pondere, in mensura."
,"36":"Statera iusta, aequa pondera, iustum ephi aequumque hin sint vobis. Ego Dominus Deus vester, qui eduxi vos de terra Aegypti."
,"37":"Custodite omnia praecepta mea et universa iudicia et facite ea. Ego Dominus '."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Haec lo queris filiis Israel: Homo de filiis Israel et de advenis, qui habitant in Israel, si dederit de semine suo idolo Moloch, morte moriatur: populus terrae lapidabit eum."
,"3":"Et ego ponam faciem meam contra illum; succidamque eum de medio populi sui, eo quod dederit de semine suo Moloch et contaminaverit sanctuarium meum ac polluerit nomen sanctum meum."
,"4":"Quod si clauserit populus terrae oculos suos, ne videat hominem illum, qui dederit de semine suo Moloch, nec voluerit eum occidere,"
,"5":"ponam ego faciem meam super hominem illum et cognationem eius succidamque et ipsum et omnes, qui consenserunt ei, ut fornicarentur cum Moloch, de medio populi sui."
,"6":"Anima, quae declinaverit ad pythones et hariolos et fornicata fuerit cum eis, ponam faciem meam contra eam et interficiam illam de medio populi sui."
,"7":"Sanctificamini et estote sancti, quia ego Dominus Deus vester."
,"8":"Custodite praecepta mea et facite ea. Ego Dominus, qui sanctifico vos."
,"9":"Qui maledixerit patri suo et matri, morte moriatur; qui patri matrique maledixit, sanguis eius sit super eum."
,"10":"Si moechatus quis fuerit cum uxore alterius et adulterium perpetrarit cum coniuge proximi sui, morte moriantur et moechus et adultera."
,"11":"Qui dormierit cum noverca sua et revelaverit ignominiam patris sui, morte moriantur ambo: sanguis eorum sit super eos."
,"12":"Si quis dormierit cum nuru sua, uterque moriatur, quia scelus operati sunt: sanguis eorum sit super eos."
,"13":"Qui dormierit cum masculo coitu femineo, uterque operatus est nefas, morte moriantur: sit sanguis eorum super eos."
,"14":"Qui supra uxorem filiam duxerit matrem eius, scelus operatus est: vivus ardebit cum eis, nec permanebit tantum nefas in medio vestri."
,"15":"Qui cum iumento et pecore coierit, morte moriatur; pecus quoque occidite."
,"16":"Mulier, quae succubuerit cuilibet iumento, simul interficies illam cum eo, morte moriantur: sanguis eorum sit super eos."
,"17":"Qui acceperit sororem suam filiam patris sui vel filiam matris suae et viderit turpitudinem eius, illaque conspexerit fratris ignominiam, nefaria res est; occidentur in conspectu populi sui, eo quod turpitudinem sororis suae revelaverit, portabit iniquitatem suam."
,"18":"Qui coierit cum muliere in fluxu menstruo et revelaverit turpitudinem eius fontem eius nudavit, ipsaque aperuit fontem sanguinis sui interficientur ambo de medio populi sui."
,"19":"Turpitudinem materterae et amitae tuae non discooperies; qui hoc fecerit, ignominiam carnis suae nudavit; portabunt ambo iniquitatem suam."
,"20":"Qui coierit cum uxore patrui vel avunculi sui et revelaverit ignominiam cognationis suae, portabunt ambo peccatum suum: absque liberis morientur."
,"21":"Qui duxerit uxorem fratris sui, immunditia est, turpitudinem fratris sui revelavit: absque liberis erunt."
,"22":"Custodite omnes leges meas atque omnia iudicia et facite ea, ne et vos evomat terra, quam intraturi estis et habitaturi."
,"23":"Nolite ambulare in legitimis nationum, quas ego expulsurus sum ante vos. Omnia enim haec fecerunt, et abominatus sum eas"
,"24":"locutusque sum vobis: Vos possidebitis terram eorum, et ego dabo eam vobis in hereditatem, terram fluentem lacte et melle. Ego Dominus Deus vester, qui separavi vos a ceteris populis."
,"25":"Separate ergo et vos iumentum mundum ab immundo et avem immundam a munda, ne polluatis animas vestras in pecore et in avibus et cunctis, quae moventur in terra, et quae vobis separavi tamquam immunda."
,"26":"Eritis mihi sancti, quia sanctus sum ego Dominus et separavi vos a ceteris populis, ut essetis mei."
,"27":"Vir sive mulier, in quibus pythonicus vel divinationis fuerit spiritus, morte moriantur; lapidibus obruent eos: sanguis eorum sit super illos '."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Dixit quoque Dominus ad Moysen: ' Loquere ad sacer dotes filios Aaron et dices eis: Ne contaminetur sacerdos in mortibus civium suorum,"
,"2":"nisi tantum in consanguineis propinquis, id est super matre et patre et filio ac filia, fratre quoque"
,"3":"et sorore virgine propinqua, quae non est nupta viro; in ipsa contaminabitur."
,"4":"Non contaminabitur ut maritus in cognatis suis, ne profanetur."
,"5":"Non radent caput nec barbam neque in carne sua facient incisuras."
,"6":"Sancti erunt Deo suo et non polluent nomen eius: incensa enim Domini et panem Dei sui offerunt et ideo sancti erunt."
,"7":"Scortum et oppressam non ducent uxorem nec eam, quae repudiata est a marito, quia consecratus est Deo suo."
,"8":"Et sanctificabis eum, quia panem Dei sui offert. Sit ergo sanctus tibi, quia ego sanctus sum, Dominus, qui sanctifico vos."
,"9":"Sacerdotis filia, si profanaverit se stupro, profanat nomen patris sui; flammis exuretur."
,"10":"Sacerdos maximus inter fratres suos, super cuius caput fusum est unctionis oleum, et cuius manus in sacerdotio consecratae sunt, vestitusque est sanctis vestibus, comam suam non excutiet, vestimenta non scindet"
,"11":"et ad omnem mortuum non ingredietur omnino; super patre quoque suo et matre non contaminabitur."
,"12":"Nec egredietur de sanctuario, ne polluat sanctuarium Domini, quia consecratus est oleo unctionis Dei sui. Ego Dominus."
,"13":"Virginem ducet uxorem;"
,"14":"viduam et repudiatam et oppressam atque meretricem non accipiet, sed virginem de cognatis suis ducet uxorem."
,"15":"Ne profanet stirpem suam inter cognatos suos, quia ego Dominus, qui sanctifico eum '."
,"16":"Locutusque est Dominus ad Moysen dicens:"
,"17":"' Loquere ad Aaron: Homo de semine tuo in generationibus suis, qui habuerit maculam, non accedet, ut offerat panem Dei sui;"
,"18":"quia quicumque habuerit maculam, non accedet: si caecus fuerit vel claudus, si mutilo naso vel deformis,"
,"19":"si fracto pede vel manu,"
,"20":"si gibbus, si pusillus, si albuginem habens in oculo, si iugem scabiem, si impetiginem in corpore vel contritos testiculos."
,"21":"Omnis, qui habuerit maculam de semine Aaron sacerdotis, non accedet offerre incensa Domini nec panem Dei sui."
,"22":"Vescetur tamen pane Dei sui de sanctissimis et de sanctis."
,"23":"Sed ad velum non ingrediatur nec accedat ad altare, quia maculam habet et contaminare non debet sanctuaria mea, quia ego Dominus, qui sanctifico ea '."
,"24":"Locutus est ergo Moyses ad Aaron et filios eius et ad omnem Israel."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Locutus quoque est Dominus ad Moysen dicens:"
,"2":"' Loquere ad Aaron et ad filios eius, ut caveant ab his, quae consecrata sunt filiorum Israel, et non contaminent nomen sanctum meum, quae ipsi offerunt mihi. Ego Dominus."
,"3":"Dic ad eos pro posteris vestris: Omnis homo, qui accesserit de omni stirpe vestra ad sancta, quae consecraverunt filii Israel Domino, in immunditia sua, peribit coram me. Ego Dominus."
,"4":"Homo de semine Aaron, qui fuerit leprosus aut patiens fluxum, non vescetur de his, quae sanctificata sunt, donec sanetur. Qui tetigerit omne, quod immundum est ex mor tuo, vel vir, ex quo egreditur semen,"
,"5":"et qui tangit reptile, quo polluitur, vel hominem, quo polluitur qualibet immunditia illius,"
,"6":"immundus erit usque ad vesperum et non vescetur his, quae sanctificata sunt; sed cum laverit carnem suam aqua,"
,"7":"et occubuerit sol, tunc mundatus vescetur de sanctificatis, quia cibus illius est."
,"8":"Morticinum et dilaceratum a bestia non comedent, nec polluentur in eis. Ego Dominus."
,"9":"Custodient praeceptum meum, ut non habeant super illo peccatum et propterea moriantur, cum polluerint illud; ego Dominus, qui sanctifico eos."
,"10":"Omnis alienigena non comedet de sanctificatis, inquilinus sacerdotis et mercennarius non vescentur ex eis."
,"11":"Quem autem sacerdos emerit, et qui vernaculus domus eius fuerit, hi comedent ex eis."
,"12":"Si filia sacerdotis cuilibet ex populo nupta fuerit, de muneribus, quae sanctificata sunt, non vescetur;"
,"13":"sin autem vidua vel repudiata et absque liberis reversa fuerit ad domum patris sui, sicut puella consueverat, aletur cibo patris sui. Omnis alienigena comedendi ex eo non habet potestatem."
,"14":"Qui comederit de sanctificatis per ignorantiam, addet quintam partem cum eo, quod comedit, et dabit sacerdoti sanctificatum."
,"15":"Nec contaminabunt sanctificata filiorum Israel, quae tamquam munus offerunt Domino,"
,"16":"ne inducant super eos iniquitatem delicti, cum illi sanctificata sua comederint. Ego Dominus, qui sanctifico '."
,"17":"Locutus est Dominus ad Moysen dicens:"
,"18":"' Loquere ad Aaron et filios eius et ad omnes filios Israel dicesque ad eos: Homo de domo Israel et de advenis, qui habitant apud vos, qui obtulerit oblationem suam vel vota solvens vel sponte offerens, quidquid illud obtulerit in holocaustum Domino,"
,"19":"in beneplacitum pro vobis offeratur masculus immaculatus ex bobus et ex ovibus et ex capris;"
,"20":"si maculam habuerit, non offeretis, quia non erit vobis acceptabile."
,"21":"Homo, qui obtulerit victimam pacificorum Domino, vel vota solvens vel sponte offerens tam de bobus quam de ovibus immaculatum offeret, ut acceptabile sit; omnis macula non erit in eo."
,"22":"Si caecum fuerit, si fractum, si mutilum, si verrucam habens aut scabiem vel impetiginem, non offeretis ea Domino nec in incensum dabitis ex eis super altare Domino."
,"23":"Bovem et ovem deformem et debilem voluntarie offerre potes; votum autem ex his solvi non potest."
,"24":"Omne animal, quod vel contritis vel tusis vel sectis ablatisque testiculis est, non offeretis Domino, et in terra vestra hoc omnino ne faciatis."
,"25":"De manu alienigenae non offeretis cibum Dei vestri ex omnibus his animalibus, quia corrupta et maculata sunt omnia; non erunt in beneplacitum pro vobis '."
,"26":"Locutusque est Dominus ad Moysen dicens:"
,"27":"' Bos, ovis et capra, cum genita fuerint, septem diebus erunt sub ubere matris suae; die autem octavo et deinceps erunt acceptabile munus incensi Domino."
,"28":"Sive illa bos sive ovis non immolabuntur una die cum fetibus suis."
,"29":"Si sacrificaveritis hostiam pro gratiarum actione Domino, sacrificabitis, ut possit esse placabilis."
,"30":"Eodem die comedetis eam; non remanebit quidquam in mane alterius diei. Ego Dominus."
,"31":"Custodite mandata mea et facite ea. Ego Dominus."
,"32":"Ne polluatis nomen meum sanctum, ut sanctificer in medio filiorum Israel. Ego Dominus, qui sanctifico vos"
,"33":"et eduxi de terra Aegypti, ut essem vobis in Deum. Ego Dominus '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Locutus est Dominus ad Moysen dicens:"
,"2":"' Loquere filiis Israel et dices ad eos: Hae sunt feriae Domini, quas vocabitis conventus sanctos; hae sunt feriae meae."
,"3":"Sex diebus facietis opus; dies septimus sabbatum requiei est, conventus sanctus; omne opus non facietis; sabbatum est Domino in cunctis habitationibus vestris."
,"4":"Hae sunt ergo feriae Domini, conventus sancti, quas celebrare debetis temporibus suis."
,"5":"Mense primo, quarta decima die mensis, ad vesperum Pascha Domini est."
,"6":"Et quinta decima die mensis huius sollemnitas Azymorum Domini est. Septem diebus azyma comedetis."
,"7":"Die primo erit vobis conventus sanctus; omne opus servile non facietis in eo,"
,"8":"sed offeretis incensum Domino septem diebus. Die autem septimo erit conventus sanctus, nullumque servile opus facietis in eo '."
,"9":"Locutusque est Dominus ad Moysen dicens:"
,"10":"' Loquere filiis Israel et dices ad eos: Cum ingressi fueritis terram, quam ego dabo vobis, et messueritis segetem, feretis manipulum spicarum primitias messis vestrae ad sacerdotem,"
,"11":"qui elevabit fasciculum coram Domino, ut acceptabile sit pro vobis; altero die sabbati sanctificabit illum."
,"12":"Atque in eodem die, quo manipulum consecrabitis, facietis agnum immaculatum anniculum in holocaustum Domino,"
,"13":"et oblationem cum eo duas decimas similae conspersae oleo in incensum Domino odoremque suavissimum et libamentum eius vini quartam partem hin."
,"14":"Panem et grana tosta farrem recentem non comedetis ex segete usque ad diem, qua offeretis ex ea munus Deo vestro. Praeceptum est sempiternum generationibus vestris in cunctis habitaculis vestris."
,"15":"Numerabitis vobis ab altero die sabbati, in quo obtulistis manipulum elationis, septem hebdomadas plenas"
,"16":"usque ad alteram diem expletionis hebdomadae septimae, id est quinquaginta dies; et sic offeretis oblationem novam Domino"
,"17":"ex habitaculis vestris panes elationis duos de duabus decimis similae fermentatae, quos coquetis in primitias Domino;"
,"18":"offeretisque cum panibus septem agnos immaculatos anniculos et vitulum de armento unum et arietes duos, et erunt holocaustum Domino cum oblatione similae et libamentis suis in odorem suavissimum Domino."
,"19":"Facietis et hircum in sacrificium pro peccato duosque agnos anniculos, hostias pacificorum."
,"20":"Cumque elevaverit eos sacerdos cum panibus primitiarum coram Domino, cum duobus agnis sanctum erunt Domino in usum sacerdotis."
,"21":"Et vocabitis hoc ipso die conventum, conventus sanctus erit vobis; omne opus servile non facietis in eo. Legitimum sempiternum erit in cunctis habitaculis generationibus vestris."
,"22":"Cum autem metatis segetem terrae vestrae, non secabis eam usque ad oram agri nec remanentes spicas colliges, sed pauperibus et peregrinis dimittes eas. Ego Dominus Deus vester '."
,"23":"Locutusque est Dominus ad Moysen dicens:"
,"24":"' Loquere filiis Israel: Mense septimo, prima die mensis, erit vobis requies, memoriale, clangentibus tubis, conventus sanctus."
,"25":"Omne opus servile non facietis in eo et offeretis incensum Domino '."
,"26":"Locutusque est Dominus ad Moysen dicens:"
,"27":"' Attamen decimo die mensis huius septimi dies Expiationum est, conventus sanctus erit vobis; affligetisque animas vestras in eo et offeretis incensum Domino."
,"28":"Omne opus non facietis in tempore diei huius, quia dies expiationum est in expiationem vestram coram Domino Deo vestro."
,"29":"Omnis anima, quae afflicta non fuerit die hoc, peribit de populis suis;"
,"30":"et,quae operis quippiam fecerit die hac, delebo eam de populo suo."
,"31":"Nihil ergo operis facietis in eo: legitimum sempiternum erit vestris generationibus in cunctis habitationibus vestris."
,"32":"Sabbatum requietionis est vobis, et affligetis animas vestras; die nono mensis a vespero usque ad vesperum servabitis sabbatum vestrum '."
,"33":"Et locutus est Dominus ad Moysen dicens:"
,"34":"' Loquere filiis Israel: Quinto decimo die mensis huius septimi erit festum Tabernaculorum septem diebus Domino."
,"35":"Die primo conventus sanctus, omne opus servile non facietis in eo;"
,"36":"septem diebus offeretis incensum Domino. Die octavo conventus sanctus erit vobis et offeretis incensum Domino; est enim coetus: omne opus servile non facietis."
,"37":"Hae sunt feriae Domini, quas vocabitis conventus sanctos, offeretisque in eis incensum Domino, holocausta et oblationes similae, sacrificia et libamenta iuxta ritum uniuscuiusque diei;"
,"38":"praeter sabbata Domini donaque vestra et omnia, quae offeretis ex voto vel quae sponte tribuetis Domino."
,"39":"Sed quinto decimo die mensis septimi, quando congregaveritis omnes fructus terrae, celebrabitis festum Domini septem diebus; die primo et die octavo erit requies."
,"40":"Sumetisque vobis die primo fructus arboris pulcherrimos spatulasque palmarum et ramos ligni densarum frondium et salices de torrente et laetabimini coram Domino Deo vestro."
,"41":"Celebrabitisque sollemnitatem eius septem diebus per annum: legitimum sempiternum erit generationibus vestris. Mense septimo festum celebrabitis"
,"42":"et habitabitis in umbraculis septem diebus; omnis, qui de genere est Israel, manebit in tabernaculis,"
,"43":"ut discant posteri vestri quod in tabernaculis habitare fecerim filios Israel, cum educerem eos de terra Aegypti. Ego Dominus Deus vester '."
,"44":"Locutusque est Moyses super sollemnitatibus Domini ad filios Israel."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Et locutus est Dominus ad Moysen dicens:"
,"2":"' Praecipe fi liis Israel, ut afferant tibi oleum de olivis purissimum ac lucidum ad concinnandas lucernas candelabri iugiter."
,"3":"Extra velum testimonii in tabernaculo conventus parabit illud Aaron a vespere usque ad mane coram Domino iugiter, ritu perpetuo in generationibus vestris."
,"4":"Super candelabro mundissimo parabit lucernas semper in conspectu Domini."
,"5":"Accipies quoque similam et coques ex ea duodecim panes, qui singuli habebunt duas decimas,"
,"6":"quorum senos altrinsecus super mensam purissimam coram Domino statues."
,"7":"Et pones super ambas strues tus lucidissimum, ut sit panis in memoriale, incensum Domino."
,"8":"Per singula sabbata mutabuntur coram Domino suscepti a filiis Israel; foedus sempiternum."
,"9":"Eruntque Aaron et filiorum eius, ut comedant eos in loco sancto, quia sanctum sanctorum est ei de incensis Domini; iure perpetuo '."
,"10":"Ecce autem egressus filius mulieris Israelitis, quem pepererat de viro Aegyptio inter filios Israel, iurgatus est in castris cum viro Israelita."
,"11":"Cumque blasphemasset nomen et maledixisset ei, adductus est ad Moysen; vocabatur autem mater eius Salomith filia Dabri de tribu Dan."
,"12":"Miseruntque eum in custodiam, donec nossent quid iuberet Dominus."
,"13":"Qui locutus est ad Moysen dicens:"
,"14":"' Educ blasphemum extra castra, et ponant omnes, qui audierunt, manus suas super caput eius, et lapidet eum coetus universus."
,"15":"Et ad filios Israel loqueris: Homo, qui maledixerit Deo suo, portabit peccatum suum; "
,"16":"et, qui blasphemaverit nomen Domini, morte moriatur: lapidibus opprimet eum omnis coetus, sive ille peregrinus sive civis fuerit. Qui blasphemaverit nomen Domini, morte moriatur."
,"17":"Qui percusserit et occiderit hominem, morte moriatur."
,"18":"Qui percusserit animal, reddet vicarium, id est animam pro anima."
,"19":"Qui irrogaverit maculam cuilibet civium suorum, sicut fecit, sic fiet ei:"
,"20":"fracturam pro fractura, oculum pro oculo, dentem pro dente restituet; qualem inflixerit maculam, talem sustinere cogetur."
,"21":"Qui percusserit iumentum, reddet aliud. Qui percusserit hominem, morietur."
,"22":"Aequum iudicium sit inter vos, sive peregrinus sive civis peccaverit; quia ego sum Dominus Deus vester '."
,"23":"Locutusque est Moyses ad filios Israel, et eduxerunt eum, qui blasphemaverat, extra castra, ac lapidibus oppresserunt. Feceruntque filii Israel, sicut praeceperat Dominus Moysi."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Locutusque est Dominus ad Moysen in monte Sinai di cens:"
,"2":"' Loquere filiis Israel et dices ad eos: Quando ingressi fueritis terram, quam ego dabo vobis, sabbatizet terra sabbatum Domino."
,"3":"Sex annis seres agrum tuum et sex annis putabis vineam tuam colligesque fructus eius;"
,"4":"septimo autem anno, sabbatum requietionis erit terrae, sabbatum Domino: agrum tuum non seres et vineam tuam non putabis."
,"5":"Quae sponte gignit humus, non metes et uvas vineae tuae non putatae non colliges quasi vindemiam; annus enim requietionis erit terrae."
,"6":"Et erit sabbatum terrae vobis in cibum: tibi et servo tuo, ancillae et mercennario tuo et advenis, qui peregrinantur apud te,"
,"7":"iumentis tuis et animalibus, quae in terra tua sunt, omnia, quae nascuntur, praebebunt cibum."
,"8":"Numerabis quoque tibi septem hebdomadas annorum, id est septem septies, quae simul faciunt annos quadraginta novem;"
,"9":"et clanges bucina mense septimo, decima die mensis expiationis die clangetis tuba in universa terra vestra."
,"10":"Sanctificabitisque annum quinquagesimum et vocabitis remissionem in terra cunctis habitatoribus eius: ipse est enim iobeleus. Revertemini unusquisque ad possessionem suam, et unusquisque rediet ad familiam pristinam."
,"11":"Iobeleus erit vobis quinquagesimus annus. Non seretis neque metetis sponte in agro nascentia neque vineas non putatas vindemiabitis"
,"12":"ob sanctificationem iobelei; sed de agro statim ablatas comedetis fruges."
,"13":"Hoc anno iobelei rediet unusquisque vestrum ad possessionem suam."
,"14":"Quando vendes quippiam civi tuo vel emes ab eo, ne contristet unusquisque fratrem suum; sed iuxta numerum annorum post iobeleum emes ab eo,"
,"15":"et iuxta supputationem annorum frugum vendet tibi."
,"16":"Quanto plures anni remanserint post iobeleum, tanto crescet et pretium; et quanto minus temporis numeraveris, tanto minoris et emptio constabit: tempus enim frugum vendet tibi."
,"17":"Nolite affligere contribules vestros, sed timeas Deum tuum, quia ego Dominus Deus vester."
,"18":"Facite praecepta mea et iudicia, custodite et implete ea, ut habitare possitis in terra absque ullo pavore,"
,"19":"et gignat vobis humus fructus suos, quibus vescamini usque ad saturitatem, et habitabitis super terram, nullius impetum formidantes."
,"20":"Quod si dixeritis: 'Quid comedemus anno septimo, si non seruerimus neque collegerimus fruges nostras?'."
,"21":"Dabo benedictionem meam vobis anno sexto, et faciet fructus trium annorum,"
,"22":"seretisque anno octavo et comedetis veteres fruges usque ad nonum annum; donec nova nascantur, edetis vetera."
,"23":"Terra quoque non veniet in perpetuum, quia mea est, et vos advenae et coloni mei estis."
,"24":"Unde cuncta regio possessionis vestrae sub redemptionis condicione a vobis vendetur."
,"25":"Si attenuatus frater tuus vendiderit partem possessionis suae, veniet ut redemptor propinquus eius, et redimet, quod ille vendiderat."
,"26":"Sin autem non habuerit redemptorem et ipse pretium ad redimendum potuerit invenire,"
,"27":"computabuntur fructus ex eo tempore, quo vendidit; et, quod reliquum est, reddet emptori sicque recipiet possessionem suam."
,"28":"Quod si non invenerit manus eius, ut reddat pretium, habebit emptor, quod emerat, usque ad annum iobeleum. In ipso enim omnis venditio rediet ad dominum et ad possessorem pristinum."
,"29":"Qui vendiderit domum intra urbis muros, habebit licentiam redimendi, donec unus impleatur annus."
,"30":"Si non redemerit, et anni circulus fuerit evolutus, emptor possidebit eam et posteri eius in perpetuum; et redimi non poterit, etiam in iobeleo."
,"31":"Sin autem in villa fuerit domus, quae muros non habet, agrorum iure vendetur: potest redimi et in iobeleo revertetur ad dominum."
,"32":"Aedes Levitarum, quae in urbibus possessionis eorum sunt, semper possunt ab eis redimi."
,"33":"Si autem quis redemerit a Levitis, domus et urbs in iobeleo revertentur ad dominos; quia domus urbium leviticarum pro possessionibus eorum sunt inter filios Israel."
,"34":"Suburbana autem pascua eorum non venient, quia possessio sempiterna est eis."
,"35":"Si attenuatus fuerit frater tuus, et infirma manus eius apud te, suscipies eum quasi advenam et peregrinum, et vivet tecum."
,"36":"Ne accipias usuras ab eo nec amplius quam dedisti: time Deum tuum, ut vivere possit frater tuus apud te."
,"37":"Pecuniam tuam non dabis ei ad usuram nec plus aequo exiges pro cibo tuo."
,"38":"Ego Dominus Deus vester, qui eduxi vos de terra Aegypti, ut darem vobis terram Chanaan et essem vester Deus."
,"39":"Si paupertate compulsus vendiderit se tibi frater tuus, non eum opprimes servitute servorum,"
,"40":"sed quasi mercennarius et colonus erit tecum. Usque ad annum iobeleum operabitur apud te"
,"41":"et postea egredietur cum liberis suis et revertetur ad cognationem suam et ad possessionem patrum suorum."
,"42":"Mei enim servi sunt, et ego eduxi eos de terra Aegypti: non venient condicione servorum;"
,"43":"ne affligas eum per po tentiam, sed metuito Deum tuum."
,"44":"Servus et ancilla sint tibi de nationibus, quae in circuitu vestro sunt; de illis emetis servum et ancillam."
,"45":"De filiis quoque advenarum, qui peregrinantur apud vos, emetis et de cognatione eorum, quae est apud vos et quam genuerint in terra vestra, hos habebitis in possessionem"
,"46":"et hereditario iure transmittetis ad posteros ac possidebitis in aeternum ut servos; fratres autem vestros filios Israel ne opprimatis cum potentia."
,"47":"Si invaluerit apud vos manus advenae atque peregrini, et attenuatus frater tuus vendiderit se ei aut cuiquam de stirpe eius,"
,"48":"post venditionem potest redimi. Unus ex fratribus suis redimet eum"
,"49":"et patruus et patruelis et consanguineus et affinis. Sin autem et ipse potuerit, redimat se,"
,"50":"supputatis dumtaxat cum emptore annis a tempore venditionis suae usque ad annum iobeleum, et pecunia, qua venditus fuerat, iuxta annorum numerum et rationem mercennarii supputata."
,"51":"Si plures fuerint anni, qui remanent usque ad iobeleum, secundum hos reddet et pretium redemptionis de pecunia emptionis;"
,"52":"si pauci, ponet rationem cum eo; iuxta annorum numerum reddet emptori, quod reliquum est annorum,"
,"53":"quibus ante servivit, mercedibus mercennarii imputatis. Non affliget eum violenter in conspectu tuo."
,"54":"Quod si per haec redimi non potuerit, anno iobeleo egredietur cum liberis suis:"
,"55":"mei sunt enim servi filii Israel, quos eduxi de terra Aegypti. Ego Dominus Deus vester '."
}`)
	CurrentBook.AddChapter(26, `{
"1":"' Non facietis vobis idolum et sculptile nec lapidem eri getis nec imaginem sculptam in petra ponetis in terra vestra, ut adoretis eam. Ego enim sum Dominus Deus vester."
,"2":"Custodite sabbata mea et pavete sanctuarium meum. Ego Dominus."
,"3":"Si in praeceptis meis ambulaveritis et mandata mea custodieritis et feceritis ea,"
,"4":"dabo vobis pluvias temporibus suis, et terra gignet germen suum, et pomis arbores replebuntur."
,"5":"Apprehendet messium tritura vindemiam, et vindemia occupabit sementem; et comedetis panem vestrum in saturitatem et absque pavore habitabitis in terra vestra."
,"6":"Dabo pacem in finibus vestris, dormietis, et non erit qui exterreat. Auferam malas bestias, et gladius non transibit per terminos vestros."
,"7":"Persequemini inimicos vestros, et corruent coram vobis gladio."
,"8":"Persequentur quinque de vestris centum alienos, et centum ex vobis decem milia; cadent inimici vestri in conspectu vestro gladio."
,"9":"Respiciam vos et crescere faciam; multiplicabimini, et firmabo pactum meum vobiscum."
,"10":"Comedetis vetusta congregata priorum messium; et vetera, novis supervenientibus, proicietis."
,"11":"Ponam habitaculum meum in medio vestri, et non abominabitur vos anima mea."
,"12":"Ambulabo inter vos et ero vester Deus, vosque eritis populus meus."
,"13":"Ego Dominus Deus vester, qui eduxi vos de terra Aegyptiorum, ne serviretis eis, et qui confregi vectes iugi vestri, ut incederetis erecti."
,"14":"Quod si non audieritis me nec feceritis omnia mandata haec,"
,"15":"si spreveritis leges meas, et iudicia mea contempserit anima vestra, ut non faciatis omnia, quae a me constituta sunt, et ad irritum perducatis pactum meum,"
,"16":"ego quoque haec faciam vobis: visitabo vos in terrore repentino, in tabe et ardore, qui conficiant oculos et consumant animam, frustra seretis sementem, quae ab hostibus devorabitur."
,"17":"Ponam faciem meam contra vos, et corruetis coram hostibus vestris et subiciemini his, qui oderunt vos, et fugietis, nemine persequente."
,"18":"Sin autem nec sic oboedieritis mihi, addam correptiones vestras septuplum propter peccata vestra"
,"19":"et conteram superbiam duritiae vestrae. Daboque caelum vobis desuper sicut ferrum et terram aeneam."
,"20":"Consumetur incassum robur vestrum: non proferet terra germen, nec arbores poma praebebunt."
,"21":"Si ambulaveritis ex adverso mihi nec volueritis audire me, addam plagas vestras usque in septuplum propter peccata vestra;"
,"22":"emittamque in vos bestias agri, quae absque liberis vos faciant et deleant pecora vestra et ad paucitatem vos redigant, desertaeque fiant viae vestrae."
,"23":"Quod si nec sic volueritis recipere disciplinam, sed ambulaveritis ex adverso mihi,"
,"24":"ego quoque contra vos adversus incedam et percutiam vos septies propter peccata vestra."
,"25":"inducamque super vos gladium ultorem foederis mei; cumque confugeritis in urbes vestras, mittam pestilentiam in medio vestri, et trademini hostium manibus."
,"26":"Postquam confregero vobis baculum panis, coquent decem mulieres in uno clibano panem vestrum et reddent eum ad pondus, et comedetis et non saturabimini."
,"27":"Sin autem nec per haec audieritis me, sed ambulaveritis contra me,"
,"28":"et ego incedam adversus vos in furore contrario; et corripiam vos septem plagis propter peccata vestra,"
,"29":"ita ut comedatis carnes filiorum et filiarum vestrarum."
,"30":"Destruam excelsa vestra et thymiamateria confringam et ponam cadavera vestra super cadavera idolorum vestrorum, et abominabitur vos anima mea,"
,"31":"in tantum ut urbes vestras redigam in solitudinem et deserta faciam sanctuaria vestra nec recipiam ultra odorem suavissimum."
,"32":"Disperdamque terram vestram; et stupebunt super ea inimici vestri, cum habitatores illius fuerint."
,"33":"Vos autem dispergam in gentes et evaginabo post vos gladium; eritque terra vestra deserta et civitates dirutae."
,"34":"Tunc placebunt terrae sabbata sua cunctis diebus solitudinis suae; quando fueritis in terra hostili, sabbatizabit et sabbata sua supplebit."
,"35":"Cunctis diebus solitudinis sabbatizabit, eo quod non requieverit in sabbatis vestris, quando habitabatis in ea."
,"36":"Et, qui de vobis remanserint, dabo pavorem in cordibus eorum in regionibus hostium; terrebit eos sonitus folii volantis, et ita fugient quasi gladium; cadent, nullo persequente."
,"37":"Et corruent singuli super fratres suos quasi bella fugientes, nemine persequente. Nemo vestrum inimicis audebit resistere."
,"38":"Peribitis inter gentes, et hostilis vos terra consumet."
,"39":"Quod si et de vobis aliqui remanserint, tabescent in iniquitatibus suis in terris inimicorum vestrorum et propter peccata patrum suorum cum ipsis tabescent."
,"40":"Et confitebuntur iniquitates suas et maiorum suorum, quibus praevaricati sunt in me et ambulaverunt ex adverso mihi,"
,"41":"ut et ego ambularem contra eos et inducerem illos in terram hostilem; vel tunc humiliabitur incircumcisum cor eorum, et tunc expiabunt pro impietatibus suis."
,"42":"Et recordabor foederis mei, quod pepigi cum Iacob et Isaac et Abraham. Terrae quoque memor ero,"
,"43":"quae, cum relicta fuerit ab eis, complacebit sibi in sabbatis suis patiens solitudinem propter illos. Ipsi vero expiabunt pro peccatis suis, eo quod abiecerint iudicia mea et leges meas despexerint."
,"44":"Et tamen, etiam cum essent in terra hostili, non penitus abieci eos neque sic despexi, ut consumerentur, et irritum facerem pactum meum cum eis. Ego enim sum Dominus, Deus eorum."
,"45":"Et recordabor eis foederis cum maioribus, quos eduxi de terra Aegypti in conspectu gentium, ut essem Deus eorum. Ego Dominus '."
,"46":"Haec sunt iudicia atque praecepta et leges, quas dedit Dominus inter se et inter filios Israel in monte Sinai per manum Moysi."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Loquere fi liis Israel et dices ad eos: Homo, qui votum fecerit et spoponderit Deo animas, sub aestimatione dabit pretium:"
,"3":"si fuerit masculus a vicesimo usque ad sexagesimum annum, dabit quinquaginta siclos argenti ad mensuram sanctuarii;"
,"4":"si mulier, triginta."
,"5":"A quinto autem anno usque ad vicesimum masculus dabit viginti siclos, femina decem;"
,"6":"ab uno mense usque ad annum quintum pro masculo dabuntur quinque sicli, pro femina tres;"
,"7":"sexagenarius et ultra masculus dabit quindecim siclos, femina decem."
,"8":"Si pauper fuerit et aestimationem reddere non valebit, sistet eum coram sacerdote, et quantum ille aestimaverit et viderit posse reddere, tantum dabit."
,"9":"Animal autem, quod immolari potest Domino, si quis voverit, sanctum erit"
,"10":"et mutari non poterit, id est nec melius malo nec peius bono. Quod si mutaverit, et ipsum quod mutatum est et illud pro quo mutatum est, consecratum erit Domino."
,"11":"Animal immundum, quod immolari Domino non potest, si quis voverit, adducetur ante sacerdotem,"
,"12":"qui diiudicans utrum bonum an malum sit, sicut statuet pretium, sic erit."
,"13":"Quod si redimere illud voluerit is qui offert, addet supra aestimationem quintam partem."
,"14":"Homo si voverit domum suam et sanctificaverit Domino, considerabit eam sacerdos utrum bona an mala sit, et iuxta pretium, quod ab eo fuerit constitutum, stabit."
,"15":"Sin autem ille, qui voverat, voluerit redimere eam, dabit quintam partem aestimationis supra et habebit domum."
,"16":"Quod si agrum possessionis suae voverit et consecraverit Domino, iuxta mensuram sementis aestimabitur pretium: si triginta homer hordei seritur terra, quinquaginta siclis aestimabitur argenti."
,"17":"Si statim ab anno iobelei voverit agrum, quanto valere potest, tanto aestimabitur."
,"18":"Sin autem post aliquantum temporis, supputabit ei sacerdos pecuniam iuxta annorum, qui reliqui sunt, numerum usque ad iobeleum, et detrahetur ex pretio."
,"19":"Quod si voluerit redimere agrum ille, qui voverat, addet quintam partem aestimatae pecuniae et possidebit eum."
,"20":"Sin autem noluerit redimere, sed alteri cuilibet vendiderit, ultra redimi non poterit;"
,"21":"sed, cum iobelei venerit dies, sanctum erit Domino sicut ager anathematis; sacerdotis erit possessio eius."
,"22":"Quod si agrum emptum, qui non est de possessione maiorum, sanctificare voluerit Domino,"
,"23":"supputabit ei sacerdos iuxta annorum numerum usque ad iobeleum pretium, quod dabit ille, qui voverat, in ipso die ut sanctum Domino."
,"24":"In anno autem iobelei revertetur ager ad priorem dominum, qui vendiderat eum et habuerat in sortem possessionis suae."
,"25":"Omnis aestimatio siclo sanctuarii ponderabitur; siclus viginti gera habet."
,"26":"Primogenita, quae de animalibus ad Dominum pertinent, nemo sanctificare poterit et vovere: sive bos sive ovis fuerit, Domini sunt."
,"27":"Quod si immundum est animal, redimet, qui obtulit, iuxta aestimationem et addet quintam partem pretii; si redimere noluerit, vendetur quanto fuerit."
,"28":"Omne anathema, quod aliquis vir consecrat Domino de omni possessione sua, sive homo fuerit sive animal sive ager, non veniet nec redimi poterit; quidquid semel fuerit consecratum, sanctum sanctorum erit Domino."
,"29":"Et omnis homo, qui ut anathema offertur, non redimetur, sed morte morietur."
,"30":"Omnes decimae terrae sive de frugibus sive de pomis arborum Domini sunt, sanctum Domino."
,"31":"Si quis autem voluerit redimere aliquid de decimis suis, addet quintam partem."
,"32":"Omnes decimae boves et oves et caprae, quae sub pastoris virga transeunt, quidquid decimum venerit, erit sanctum Domino."
,"33":"Non discernetur inter bonum et malum nec altero commutabitur; si quis mutaverit, et quod mutatum est et pro quo mutatum est, sanctum erit et non redimetur '."
,"34":"Haec sunt praecepta, quae mandavit Dominus Moysi ad filios Israel in monte Sinai."
}`)

}
func LA_NVBSE_LoadVPNMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Locutusque est Dominus ad Moysen in deserto Sinai in ta bernaculo conventus, prima die mensis secundi, anno altero egressionis eorum ex Aegypto, dicens: "
,"2":"' Tollite summam universae congregationis filiorum Israel per cognationes et domos suas et nomina singulorum, quidquid sexus est masculini"
,"3":"a vicesimo anno et supra omnium ex Israel, qui possunt ad bella procedere, et numerabitis eos per turmas suas, tu et Aaron."
,"4":"Eritque vobiscum vir per tribum, princeps domus patrum suorum,"
,"5":"quorum ista sunt nomina: de Ruben Elisur filius Sedeur;"
,"6":"de Simeon Salamiel filius Surisaddai;"
,"7":"de Iuda Naasson filius Aminadab;"
,"8":"de Issachar Nathanael filius Suar;"
,"9":"de Zabulon Eliab filius Helon."
,"10":"Filiorum autem Ioseph: de Ephraim Elisama filius Ammiud; de Manasse Gamaliel filius Phadassur."
,"11":"De Beniamin Abidan filius Gedeonis;"
,"12":"de Dan Ahiezer filius Ammisaddai;"
,"13":"de Aser Phegiel filius Ochran;"
,"14":"de Gad Eliasaph filius Deuel;"
,"15":"de Nephthali Ahira filius Enan '."
,"16":"Hi viri nobilissimi congregationis principes tribuum patrum suorum et capita milium Israel."
,"17":"Quos tulerunt Moyses et Aaron nominatim designatos"
,"18":"et omnem congregationem congregaverunt primo die mensis secundi recensentes eos per cognationes et domos patrum eorum, per nomina singulorum a vicesimo anno et supra per capita,"
,"19":"sicut praeceperat Dominus Moysi. Numeratique sunt in deserto Sinai."
,"20":"De Ruben primogenito Israelis generationes per familias ac domos patrum suorum, per nomina capitum singulorum omne quod sexus est masculini a vicesimo anno et supra procedentium ad bellum."
,"21":"Recensiti tribus Ruben quadraginta sex milia quingenti."
,"22":"De filiis Simeon generationes per familias ac domos cognationum suarum recensiti sunt per nomina et capita singulorum omne quod sexus est masculini a vicesimo anno et supra procedentium ad bellum."
,"23":"Recensiti tribus Simeon quinquaginta novem milia trecenti."
,"24":"De filiis Gad generationes per familias ac domos cognationum suarum recensiti sunt per nomina singulorum a viginti annis et supra omnes, qui ad bella procederent,"
,"25":"quadraginta quinque milia sescenti quinquaginta."
,"26":"De filiis Iudae generationes per familias ac domos cognationum suarum per nomina singulorum a vicesimo anno et supra omnes, qui poterant ad bella procedere,"
,"27":"recensiti sunt septuaginta quattuor milia sescenti."
,"28":"De filiis Issachar generationes per familias ac domos cognationum suarum per nomina singulorum a vicesimo anno et supra omnes, qui ad bella procederent,"
,"29":"recensiti sunt quinquaginta quattuor milia quadringenti."
,"30":"De filiis Zabulon generationes per familias ac domos cognationum suarum recensiti sunt per nomina singulorum a vicesimo anno et supra omnes, qui poterant ad bella procedere,"
,"31":"quinquaginta septem milia quadringenti."
,"32":"De filiis Ioseph filiorum Ephraim generationes per familias ac domos cognationum suarum recensiti sunt per nomina singulorum a vicesimo anno et supra omnes, qui poterant ad bella procedere,"
,"33":"quadraginta milia quingenti."
,"34":"Porro filiorum Manasse generationes per familias ac domos cognationum suarum recensiti sunt per nomina singulorum a viginti annis et supra omnes, qui poterant ad bella procedere,"
,"35":"triginta duo milia ducenti."
,"36":"De filiis Beniamin generationes per familias ac domos cognationum suarum recensiti sunt nominibus singulorum a vicesimo anno et supra omnes, qui poterant ad bella procedere,"
,"37":"triginta quinque milia quadringenti."
,"38":"De filiis Dan generationes per familias ac domos cognationum suarum recensiti sunt nominibus singulorum a vicesimo anno et supra omnes, qui poterant ad bella procedere,"
,"39":"sexaginta duo milia septingenti."
,"40":"De filiis Aser generationes per familias ac domos cognationum suarum recensiti sunt per nomina singulorum a vicesimo anno et supra omnes, qui poterant ad bella procedere,"
,"41":"quadraginta milia et mille quingenti."
,"42":"De filiis Nephthali generationes per familias ac domos cognationum suarum recensiti sunt nominibus singulorum a vicesimo anno et supra omnes, qui poterant ad bella procedere,"
,"43":"quinquaginta tria milia quadringenti."
,"44":"Hi sunt quos numeraverunt Moyses et Aaron et duodecim principes Israel, singuli per domos patrum suorum."
,"45":"Fueruntque omnis numerus filiorum Israel per domos patrum suorum a vicesimo anno et supra, qui poterant ad bella procedere, 46 sescenta tria milia virorum quingenti quinquaginta."
,"47":"Levitae autem in tribu patrum suorum non sunt numerati cum eis."
,"48":"Locutusque est Dominus ad Moysen dicens:"
,"49":"' Tribum Levi noli numerare neque pones summam eorum cum filiis Israel,"
,"50":"sed constitue eos super habitaculum testimonii et cuncta vasa eius et quidquid ad caeremonias pertinet. Ipsi portabunt habitaculum et omnia utensilia eius et erunt in ministerio ac per gyrum habitaculi metabuntur."
,"51":"Cum proficiscendum fuerit, deponent Levitae habitaculum; cum castrametandum, erigent; quisquis externorum accesserit, occidetur."
,"52":"Metabuntur autem castra filii Israel, unusquisque per turmas et cuneos atque exercitum suum."
,"53":"Porro Levitae per gyrum habitaculi testimonii figent tentoria, ne fiat indignatio super congregationem filiorum Israel, et excubabunt in custodiis habitaculi testimonii '."
,"54":"Fecerunt ergo filii Israel iuxta omnia, quae praeceperat Dominus Moysi."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Locutusque est Dominus ad Moysen et Aaron dicens:"
,"2":"' Singuli per turmas, signa atque vexilla et domos patrum suorum castrametabuntur filii Israel per gyrum tabernaculi conventus."
,"3":"Ad orientem Iudas figet tentoria per turmas exercitus sui, fuitque princeps filiorum eius Naasson filius Aminadab;"
,"4":"et eius summa pugnantium septuaginta quattuor milia sescenti."
,"5":"Iuxta eum castrametabuntur de tribu Issachar, quorum princeps fuit Nathanael filius Suar;"
,"6":"et omnis numerus pugnatorum eius quinquaginta quattuor milia quadringenti."
,"7":"In tribu Zabulon princeps fuit Eliab filius Helon;"
,"8":"et numerus exercitus pugnatorum eius quinquaginta septem milia quadringenti."
,"9":"Universi, qui in castris Iudae annumerati sunt, fuerunt centum octoginta sex milia quadringenti, et per turmas suas primi egredientur."
,"10":"Vexillum castrorum Ruben ad meridianam plagam erit, secundum exercitus eorum; princeps Elisur filius Sedeur;"
,"11":"et cunctus exercitus pugnatorum eius, qui numerati sunt, quadraginta sex milia quingenti."
,"12":"Iuxta eum castrametabuntur de tribu Simeon, quorum princeps fuit Salamiel filius Surisaddai;"
,"13":"et cunctus exercitus pugnatorum eius, qui numerati sunt, quinquaginta novem milia trecenti."
,"14":"In tribu Gad princeps fuit Eliasaph filius Deuel;"
,"15":"et cunctus exercitus pugnatorum eius, qui numerati sunt, quadraginta quinque milia sescenti quinquaginta."
,"16":"Omnes, qui recensiti sunt in castris Ruben, centum quinquaginta milia et mille quadringenti quinquaginta, per turmas suas in secundo loco proficiscentur."
,"17":"Levabitur deinde tabernaculum conventus, castra Levitarum in medio castrorum, quomodo erigetur ita et deponetur; singuli per loca et vexilla sua proficiscentur."
,"18":"Ad occidentalem plagam erit vexillum castrorum filiorum Ephraim per turmas suas, quorum princeps fuit Elisama filius Ammiud;"
,"19":"cunctus exercitus pugnatorum eius, qui numerati sunt, quadraginta milia quingenti."
,"20":"Et cum eis tribus filiorum Manasse, quorum princeps fuit Gamaliel filius Phadassur;"
,"21":"cunctusque exercitus pugnatorum eius, qui numerati sunt, triginta duo milia ducenti."
,"22":"In tribu filiorum Beniamin princeps fuit Abidan filius Gedeonis;"
,"23":"et cunctus exercitus pugnatorum eius, qui recensiti sunt, triginta quinque milia quadringenti."
,"24":"Omnes, qui numerati sunt in castris Ephraim, centum octo milia centum, per turmas suas tertii proficiscentur."
,"25":"Ad aquilonis partem stabit vexillum castrorum filiorum Dan secundum exercitus suos, quorum princeps fuit Ahiezer filius Ammisaddai;"
,"26":"cunctus exercitus pugnatorum eius, qui numerati sunt, sexaginta duo milia septingenti."
,"27":"Iuxta eum figet tentoria tribus Aser, quorum princeps fuit Phegiel filius Ochran;"
,"28":"cunctus exercitus pugnatorum eius, qui numerati sunt, quadraginta milia et mille quingenti."
,"29":"De tribu filiorum Nephthali princeps fuit Ahira filius Enan;"
,"30":"cunctus exercitus pugnatorum eius quinquaginta tria milia quadringenti."
,"31":"Omnes, qui numerati sunt in castris Dan, fuerunt centum quinquaginta septem milia sescenti, et novissimi proficiscentur secundum vexilla sua '."
,"32":"Hic numerus filiorum Israel, per domos patrum suorum omnes recensiti secundum exercitus suos, sescenta tria milia quingenti quinquaginta."
,"33":"Levitae autem non sunt numerati inter filios Israel; sic enim praeceperat Dominus Moysi."
,"34":"Feceruntque filii Israel iuxta omnia, quae mandaverat Dominus: castrametati sunt per vexilla sua et profecti per tribus ad domos patrum suorum."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Hae sunt generationes Aaron et Moysi in die, qua locutus est Dominus ad Moysen in monte Sinai."
,"2":"Et haec nomina filiorum Aaron: primogenitus eius Nadab, deinde Abiu et Eleazar et Ithamar."
,"3":"Haec nomina filiorum Aaron sacerdotum, qui uncti sunt et quorum repletae manus, ut sacerdotio fungerentur."
,"4":"Mortui sunt enim Nadab et Abiu, cum offerrent ignem alienum in conspectu Domini in deserto Sinai, absque liberis; functique sunt sacerdotio Eleazar et Ithamar coram Aaron patre suo."
,"5":"Locutusque est Dominus ad Moysen dicens:"
,"6":"' Applica tribum Levi et fac stare in conspectu Aaron sacerdotis, ut ministrent ei"
,"7":"et observent, quidquid ad eum pertinet et ad totam congregationem coram tabernaculo conventus, servientes in ministerio habitaculi,"
,"8":"et custodiant vasa tabernaculi conventus explentes officia filiorum Israel, servientes in ministerio habitaculi."
,"9":"Dabisque dono Levitas Aaron et filiis eius, quibus traditi sunt a filiis Israel; 10 Aaron autem et filios eius constitues super cultum sacerdotii. Externus, qui ad ministrandum accesserit, morietur '."
,"11":"Locutusque est Dominus ad Moysen dicens:"
,"12":"' Ecce ego tuli Levitas a filiis Israel pro omni primogenito, qui aperit vulvam in filiis Israel; eruntque Levitae mei."
,"13":"Meum est enim omne primogenitum: ex quo percussi omnes primogenitos in terra Aegypti, sanctificavi mihi, quidquid primum nascitur in Israel ab homine usque ad pecus; mei sunt. Ego Dominus '."
,"14":"Locutusque est Dominus ad Moysen in deserto Sinai dicens:"
,"15":"' Numera filios Levi per domos patrum suorum et familias omnem masculum ab uno mense et supra '."
,"16":"Numeravit eos Moyses, ut praeceperat Dominus,"
,"17":"et inventi sunt filii Levi per nomina sua Gerson et Caath et Merari."
,"18":"Haec sunt nomina filiorum Gerson secundum familias suas: Lobni et Semei;"
,"19":"filii Caath secundum familias suas: Amram et Isaar, Hebron et Oziel;"
,"20":"filii Merari secundum familias suas: Moholi et Musi. Hae sunt familiae Levi per domos patrum suorum."
,"21":"De Gerson fuere familiae duae Lobnitica et Semeitica,"
,"22":"quarum numeratus est omnis populus sexus masculini ab uno mense et supra septem milia quingenti."
,"23":"Hi post habitaculum metabantur ad occidentem"
,"24":"sub principe Eliasaph filio Lael;"
,"25":"et habebant excubias in tabernaculo conventus, ipsum habitaculum et tabernaculum, operimentum eius, velum, quod trahitur ante fores tabernaculi conventus,"
,"26":"et cortinas atrii, velum quoque, quod appenditur in introitu atrii, quod est circa habitaculum et circa altare, et funes ad omne opus eius."
,"27":"Caath habet familias: Amramitas et Isaaritas et Hebronitas et Ozielitas; hae sunt familiae Caathitarum."
,"28":"Omnes generis masculini ab uno mense et supra octo milia sescenti habebant excubias sanctuarii."
,"29":"Familiae filiorum Caath castrametabantur ad latus habitaculi ad meridianam plagam,"
,"30":"princepsque eorum erat Elisaphan filius Oziel."
,"31":"Et custodiebant arcam mensamque et candelabrum, altaria et vasa sanctuarii, in quibus ministratur, et velum cunctamque huiuscemodi supellectilem."
,"32":"Princeps autem principum Levitarum Eleazar filius Aaron sacerdotis erat super excubitores custodiae sanctuarii."
,"33":"At vero de Merari erant familiae Moholitae et Musitae."
,"34":"Omnes generis masculini ab uno mense et supra sex milia ducenti;"
,"35":"princeps familiarum Merari Suriel filius Abihail. In plaga septentrionali ad latus habitaculi castrametabantur;"
,"36":"erant sub custodia eorum tabulae habitaculi et vectes et columnae ac bases earum et cuncta vasa eius et omnia, quae ad cultum huiuscemodi pertinent,"
,"37":"columnaeque atrii per circuitum cum basibus suis et paxilli cum funibus."
,"38":"Castrametabantur ante habitaculum, ad orientalem plagam ante tabernaculum conventus ad orientem, Moyses et Aaron cum filiis suis habentes custodiam sanctuarii in medio filiorum Israel. Quisquis alienus accesserit, morietur."
,"39":"Omnes Levitae, quos numeravit Moyses iuxta praeceptum Domini per familias suas in genere masculino a mense uno et supra, fuerunt viginti duo milia."
,"40":"Et ait Dominus ad Moysen: ' Numera omnes primogenitos sexus masculini de filiis Israel ab uno mense et supra et habebis summam eorum;"
,"41":"tollesque Levitas mihi pro omni primogenito filiorum Israel ego sum Dominus et pecora eorum pro universis primogenitis pecorum filiorum Israel '."
,"42":"Recensuit Moyses, sicut praeceperat Dominus, omnes primogenitos filiorum Israel,"
,"43":"et fuerunt omnes masculi per nomina sua a mense uno et supra viginti duo milia ducenti septuaginta tres."
,"44":"Locutusque est Dominus ad Moysen dicens:"
,"45":"' Tolle Levitas pro omnibus primogenitis filiorum Israel et pecora Levitarum pro pecoribus corum; eruntque Levitae mei. Ego sum Dominus."
,"46":"In pretio autem ducentorum septuaginta trium, qui excedunt numerum Levitarum de primogenitis filiorum Israel,"
,"47":"accipies quinque siclos per singula capita, ad mensuram sanctuarii. Siclus habet viginti obolos."
,"48":"Dabisque pecuniam Aaron et filiis eius pretium eorum, qui supra sunt '."
,"49":"Tulit igitur Moyses pecuniam eorum, qui excesserant numerum eorum, qui redempti erant a Levitis;"
,"50":"a primogenitis filiorum Israel tulit pecuniam mille trecentorum sexaginta quinque siclorum iuxta pondus sanctuarii."
,"51":"Et dedit eam Aaron et filiis eius iuxta verbum, quod praeceperat sibi Dominus."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Locutusque est Dominus ad Moysen et Aaron dicens:"
,"2":"' Tolle summam filiorum Caath de medio Levitarum per familias et domos suas"
,"3":"a tricesimo anno et supra usque ad quinquagesimum annum omnium, qui ingrediuntur, ut stent et ministrent in tabernaculo conventus."
,"4":"Hic est cultus filiorum Caath in tabernaculo conventus: sanctum sanctorum."
,"5":"Ingredientur Aaron et filii eius, quando movenda sunt castra, et deponent velum, quod pendet ante fores, involventque eo arcam testimonii;"
,"6":"et operient rursum velamine pellium delphini extendentque desuper pallium totum hyacinthinum et inducent vectes."
,"7":"Mensam quoque propositionis involvent hyacinthino pallio et ponent cum ea acetabula et phialas, cyathos et crateras ad liba fundenda; panes semper in ea erunt."
,"8":"Extendentque desuper pallium coccineum, quod rursum operient velamento pellium delphini et inducent vectes."
,"9":"Sument et pallium hyacinthinum, quo operient candelabrum cum lucernis et forcipibus suis et emunctoriis et cunctis vasis olei, quae ad concinnandas lucernas necessaria sunt;"
,"10":"et super omnia ponent operimentum pellium delphini et ponent super feretrum."
,"11":"Nec non et altare aureum involvent hyacinthino vestimento et extendent desuper operimentum pellium delphini et inducent vectes."
,"12":"Omnia vasa, quibus ministratur in sanctuario, involvent hyacinthino pallio; et extendent desuper operimentum pellium delphini ponentque super feretrum."
,"13":"Sed et altare mundabunt cinere et involvent illud purpureo vestimento;"
,"14":"ponentque super illud omnia vasa, quibus in ministerio eius utuntur, id est ignium receptacula, fuscinulas ac vatilla et pateras. Cuncta vasa altaris operient simul velamine pellium delphini et inducent vectes."
,"15":"Cumque involverint Aaron et filii eius sanctuarium et omnia vasa eius in commotione castrorum, tunc intrabunt filii Caath, ut portent involuta, et non tangent sanctuarium, ne moriantur. Ista sunt onera filiorum Caath in tabernaculo conventus."
,"16":"Ad curam Eleazari filii Aaron sacerdotis pertinet oleum ad concinnandas lucernas et gratissimum incensum et oblatio, quae semper offertur, et oleum unctionis et quidquid ad cultum habitaculi pertinet omniumque vasorum, quae in sanctuario sunt '."
,"17":"Locutusque est Dominus ad Moysen et Aaron dicens:"
,"18":"' Nolite perdere populum Caath de medio Levitarum,"
,"19":"sed hoc facite eis, ut vivant et non moriantur, quando appropinquant ad sancta sanctorum: Aaron et filii eius intrabunt ipsique disponent opera singulorum et divident quid portare quis debeat."
,"20":"Non intrabunt ad videndum, nec puncto quidem, sanctuarium; alioquin morientur '."
,"21":"Locutusque est Dominus ad Moysen dicens:"
,"22":"' Tolle summam etiam filiorum Gerson per domos ac familias et cognationes suas;"
,"23":"a triginta annis et supra usque ad annos quinquaginta numera omnes, qui ingrediuntur et ministrant in tabernaculo conventus."
,"24":"Hoc est officium familiarum Gersonitarum,"
,"25":"ut portent cortinas habitaculi, tabernaculum conventus, operimentum eius et super illud velamen delphini velumque, quod pendet in introitu tabernaculi conventus,"
,"26":"cortinas atrii et velum in introitu atrii, quod est circa habitaculum et altare, funiculos et vasa ministerii, omnia, quae facta sunt, ut eis laborent."
,"27":"Iubente Aaron et filiis eius, portabunt filii Gerson, et scient singuli cui debeant oneri mancipari."
,"28":"Hic est cultus familiarum Gersonitarum in tabernaculo conventus; eruntque sub manu Ithamar filii Aaron sacerdotis."
,"29":"Filios quoque Merari per familias et domos patrum suorum recensebis"
,"30":"a triginta annis et supra usque ad annos quinquaginta, omnes, qui ingrediuntur ad officium ministerii sui et cultum tabernaculi conventus."
,"31":"Haec sunt onera eorum: portabunt tabulas habitaculi et vectes eius, columnas ac bases earum,"
,"32":"columnas quoque atrii per circuitum cum basibus et paxillis et funibus suis; omnia vasa et supellectilem ad numerum accipient sicque portabunt."
,"33":"Hoc est officium familiarum Meraritarum et ministerium in tabernaculo conventus; eruntque sub manu Ithamar filii Aaron sacerdotis '."
,"34":"Recensuerunt igitur Moyses et Aaron et principes synagogae filios Caath per cognationes et domos patrum suorum"
,"35":"a triginta annis et supra usque ad annum quinquagesimum, omnes, qui ingrediuntur ad ministerium tabernaculi conventus;"
,"36":"et inventi sunt duo milia septingenti quinquaginta."
,"37":"Hic est numerus familiarum Caath, qui ministrant in tabernaculo conventus: hos numeravit Moyses et Aaron iuxta sermonem Domini per manum Moysi."
,"38":"Numerati sunt et filii Gerson per cognationes et domos patrum suorum"
,"39":"a triginta annis et supra usque ad quinquagesimum annum, omnes, qui ingrediuntur, ut ministrent in tabernaculo conventus;"
,"40":"et inventi sunt secundum familias et domus patrum suorum duo milia sescenti triginta."
,"41":"Hic est numerus Gersonitarum, omnes, qui ministrant in tabernaculo conventus, quos numeraverunt Moy ses et Aaron iuxta verbum Domini."
,"42":"Numeratae sunt et familiae filiorum Merari per cognationes et domos patrum suorum"
,"43":"a triginta annis et supra usque ad annum quinquagesimum, omnes, qui ingrediuntur ad explendos ritus tabernaculi conventus;"
,"44":"et inventi sunt tria milia ducenti."
,"45":"Hic est numerus familiarum filiorum Merari, quos recensuerunt Moyses et Aaron iuxta imperium Domini per manum Moysi."
,"46":"Omnes, qui recensiti sunt de Levitis et quos recenseri fecit ad nomen Moyses et Aaron et principes Israel per cognationes et domos patrum suorum"
,"47":"a triginta annis et supra usque ad annum quinquagesimum ingredientes ad ministerium tabernaculi et onera portanda in tabernaculo conventus,"
,"48":"fuerunt simul octo milia quingenti octoginta."
,"49":"Iuxta verbum Domini per manum Moysi recensuit eos unumquemque iuxta officium et onera sua, sicut praeceperat ei Dominus."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Praecipe filiis Israel, ut eiciant de castris omnem leprosum et qui semine fluit pollutusque est super mortuo."
,"3":"Tam masculum quam feminam eicite de castris, ne contaminent ea, cum habitaverim cum eis '."
,"4":"Feceruntque ita filii Israel et eiecerunt eos extra castra, sicut locutus erat Dominus Moysi."
,"5":"Locutusque est Dominus ad Moysen dicens:"
,"6":"' Loquere ad filios Israel: Vir sive mulier, cum fecerint ex omnibus peccatis, quae solent hominibus accidere, et fraude transgressi fuerint mandatum Domini, ille homo reus erit;"
,"7":"et confitebuntur peccatum suum et reddent ipsum caput quintamque partem desuper ei, in quem peccaverint."
,"8":"Sin autem non fuerit qui recipiat, dabunt Domino, et erit sacerdotis, praeter arietem, qui offertur pro expiatione, ut sit placabilis hostia."
,"9":"Omnis quoque praelibatio rerum sacrarum, quas offerunt filii Israel, ad sacerdotem pertinet;"
,"10":"et, quidquid in sanctuarium offertur a singulis et traditur manibus sacerdotis, ipsius erit '."
,"11":"Locutusque est Dominus ad Moysen dicens:"
,"12":"' Loquere ad filios Israel et dices ad eos: Vir, cuius uxor erraverit maritumque decipiens"
,"13":"dormierit cum altero viro, et hoc maritus deprehendere non quiverit, sed latet quod impuram se reddiderit et testibus argui non potest, quia non est inventa in stupro,"
,"14":"si spiritus zelotypiae concitaverit virum contra uxorem suam, quae vel polluta est vel falsa suspicione appetitur,"
,"15":"adducet eam ad sacerdotem et offeret oblationem pro illa decimam partem ephi farinae hordeaceae. Non fundet super eam oleum nec imponet tus, quia sacrificium zelotypiae est et oblatio investigans adulterium."
,"16":"Afferet igitur eam sacerdos et statuet coram Domino;"
,"17":"assumetque aquam sanctam in vase fictili et pauxillum terrae de pavimento habitaculi mittet in eam."
,"18":"Cumque posuerit sacerdos mulierem in conspectu Domini, discooperiet caput eius et ponet super manus illius sacrificium recordationis, oblationem zelotypiae; ipse autem tenebit aquas amarissimas, in quibus cum exsecratione maledicta congessit."
,"19":"Adiurabitque eam et dicet: 'Si non dormivit vir alienus tecum, et si non declinasti a viro tuo et non polluta es, deserto mariti toro, non te nocebunt aquae istae amarissimae, in quas maledicta congessi."
,"20":"Sin autem declinasti a viro tuo atque polluta es et concubuisti cum altero viro',"
,"21":"adiurabit eam sacerdos iuramento maledictionis: 'Det te Dominus in maledictionem, iuramentum in medio populi tui; putrescere faciat femur tuum, et tumens uterus tuus disrumpatur;"
,"22":"ingrediantur aquae maledictae in ventrem tuum, et utero tumescente putrescat femur!'. Et respondebit mulier: 'Amen, amen'."
,"23":"Scribetque sacerdos in libello ista maledicta et delebit ea aquis amarissimis"
,"24":"et dabit ei bibere aquas amaras, in quas maledicta congessit, et ingredientur in eam aquae maledictionis, quae amarae fient;"
,"25":"tollet sacerdos de manu eius sacrificium zelotypiae et agitabit illud coram Domino imponetque illud super altare;"
,"26":"pugillum sacrificii tollat de eo, quod offertur in memoriale, et incendat super altare; et deinde potum det mulieri aquas amarissimas."
,"27":"Quas cum biberit, si polluta est et, contempto viro, adulterii rea, pertransibunt eam aquae maledictionis et, inflato ventre, computrescet femur; eritque mulier in maledictionem omni populo eius."
,"28":"Quod si polluta non fuerit sed munda, erit innoxia et faciet liberos '."
,"29":"Ista est lex zelotypiae, si declinaverit mulier a viro suo et si polluta fuerit,"
,"30":"maritusque zelotypiae spiritu concitatus adduxerit eam in conspectu Domini, et fecerit ei sacerdos iuxta omnia, quae scripta sunt;"
,"31":"maritus absque culpa erit, et illa recipiet iniquitatem suam."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Loquere ad filios Israel et dices ad eos: Vir sive mulier cum fecerint votum, ut sanctificentur et se voluerint Domino consecrare,"
,"3":"a vino et omni quod inebriare potest abstinebunt; acetum ex vino et ex qualibet alia potione et, quidquid de uva exprimitur, non bibent; uvas recentes siccasque non comedent"
,"4":"cunctis diebus, quibus ex voto Domino consecrantur: quidquid ex vinea esse potest ab uva acerba usque ad pellicula non comedent."
,"5":"Omni tempore separationis suae novacula non transibit per caput eius usque ad completum tempus, quo Domino consecratur; sanctus erit crescente caesarie capitis eius."
,"6":"Omni tempore consecrationis suae ad mortuum non ingredietur;"
,"7":"nec super patris quidem et matris et fratris sororisque funere contaminabitur, quia consecratio Dei sui super caput eius est."
,"8":"Omnibus diebus separationis suae sanctus erit Domino."
,"9":"Sin autem mortuus fuerit subito quispiam coram eo, polluetur caput consecrationis eius; quod radet ilico in eadem die purgationis suae, id est die septima."
,"10":"In octava autem die offeret duos turtures vel duos pullos columbae sacerdoti in introitu tabernaculi conventus,"
,"11":"facietque sacerdos unum pro peccato et alterum in holocaustum et expiabit pro eo, quia peccavit super mortuo, sanctificabitque caput eius in die illo"
,"12":"et consecrabit Domino dies separationis suae offerens agnum anniculum pro delicto; ita tamen, ut dies priores irriti fiant, quoniam polluta est consecratio eius."
,"13":"Ista est lex consecrationis, cum dies, quos ex voto decreverat, complebuntur: adducent eum ad ostium tabernaculi conventus,"
,"14":"et offeret oblationem suam Domino agnum anniculum immaculatum in holocaustum et ovem anniculam immaculatam pro peccato et arietem immaculatum hostiam pacificam,"
,"15":"canistrum quoque panum azymorum, qui permixti sint oleo, et lagana absque fermento uncta oleo ac oblationem et libamina singulorum."
,"16":"Quae offeret sacerdos coram Domino et faciet tam pro peccato quam in holocaustum;"
,"17":"arietem vero immolabit hostiam pacificam Domino offerens simul canistrum azymorum; facietque oblationem eius et libamenta."
,"18":"Tunc radet nazaraeus ante ostium tabernaculi conventus caesariem consecrationis suae tolletque capillos suos et ponet super ignem, qui est suppositus sacrificio pacificorum,"
,"19":"et sumet sacerdos armum coctum arietis tortamque absque fermento unam de canistro et laganum azymum unum et tradet in manus nazaraei, postquam rasum fuerit caput eius;"
,"20":"et agitabit in conspectu Domini, et sanctificata sacerdotis erunt sicut pectusculum, quod agitari, et femur, quod praelevari iussum est. Post haec potest bibere nazaraeus vinum '."
,"21":"Ista est lex nazaraei, cum voverit oblationem suam Domino tempore consecrationis suae, exceptis his, quae invenerit manus eius. Iuxta quod devoverat, ita faciet secundum legem consecrationis suae."
,"22":"Locutusque est Dominus ad Moysen dicens:"
,"23":"' Loquere Aaron et filiis eius: Sic benedicetis filiis Israel et dicetis eis:"
,"24":"'Benedicat tibi Dominus et custodiat te!"
,"25":"Illuminet Dominus faciem suam super te et misereatur tui!"
,"26":"Convertat Dominus vultum suum ad te et det tibi pacem!'."
,"27":"Invocabuntque nomen meum super filios Israel, et ego benedicam eis '."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Factum est autem in die, qua complevit Moyses habitaculum et erexit illud unxitque et sanctificavit cum omnibus vasis suis, altare similiter et omnia vasa eius,"
,"2":"obtulerunt principes Israel et capita familiarum, qui erant per singulas tribus praefecti eorum, qui numerati fuerant,"
,"3":"munera coram Domino sex plaustra tecta cum duodecim bobus. Unum plaustrum obtulere duo duces et unum bovem singuli; obtuleruntque ea in conspectu habitaculi."
,"4":"Ait autem Dominus ad Moysen:"
,"5":"' Suscipe ab eis, ut serviant in ministerio tabernaculi conventus, et trades ea Levitis iuxta ordinem ministerii sui '."
,"6":"Itaque cum suscepisset Moyses plaustra et boves, tradidit eos Levitis."
,"7":"Duo plaustra et quattuor boves dedit filiis Gerson, iuxta id quod habebant necessarium."
,"8":"Quattuor alia plaustra et octo boves dedit filiis Merari, secundum offficia sua sub manu Ithamar filii Aaron sacerdotis."
,"9":"Filiis autem Caath non dedit plaustra et boves, quia in sanctuario serviunt et onera propriis portant umeris."
,"10":"Igitur obtulerunt duces in dedicationem altaris die, qua unctum est, oblationem suam ante altare."
,"11":"Dixitque Dominus ad Moysen: ' Singuli duces per singulos dies offerant munera in dedicationem altaris '."
,"12":"Primo die obtulit oblationem suam Naasson filius Aminadab de tribu Iudae."
,"13":"Fueruntque in ea scutula argentea pondo centum triginta siclorum, phiala argentea habens septuaginta siclos iuxta pondus sanctuarii, utraque plena simila conspersa oleo in sacrificium,"
,"14":"acetabulum ex decem siclis aureis plenum incenso,"
,"15":"bos de armento et aries et agnus anniculus in holocaustum"
,"16":"hircusque pro peccato;"
,"17":"et in sacrificio pacificorum boves duo, arietes quinque, hirci quinque, agni anniculi quinque: haec est oblatio Naasson filii Aminadab."
,"18":"Secundo die obtulit Nathanael filius Suar dux de tribu Issachar"
,"19":"scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos iuxta pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"20":"acetabulum aureum habens decem siclos plenum incenso,"
,"21":"bovem de armento et arietem et agnum anniculum in holocaustum"
,"22":"hircumque pro peccato;"
,"23":"et in sacrificio pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Nathanael filii Suar."
,"24":"Tertio die princeps filiorum Zabulon Eliab filius Helon"
,"25":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"26":"acetabulum aureum appendens decem siclos plenum incenso,"
,"27":"bovem de armento et arietem et agnum anniculum in holocaustum"
,"28":"hircumque pro peccato;"
,"29":"et in sacrificio pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec est oblatio Eliab filii Helon."
,"30":"Die quarto princeps filiorum Ruben Elisur filius Sedeur"
,"31":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"32":"acetabulum aureum appendens decem siclos plenum incenso,"
,"33":"bovem de armento et arietem et agnum anniculum in holocaustum"
,"34":"hircumque pro peccato;"
,"35":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Elisur filii Sedeur."
,"36":"Die quinto princeps filiorum Simeon Salamiel filius Surisaddai"
,"37":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"38":"acetabulum aureum appendens decem siclos plenum incenso,"
,"39":"bovem de armento et arietem et agnum anniculum in holocaustum,"
,"40":"hircumque pro peccato;"
,"41":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Salamiel filii Surisaddai."
,"42":"Die sexto princeps filiorum Gad Eliasaph filius Deuel"
,"43":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"44":"acetabulum aureum appendens decem siclos plenum incenso,"
,"45":"bovem de armento et arietem et agnum anniculum in holocaustum,"
,"46":"hircumque pro peccato;"
,"47":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Eliasaph filii Deuel."
,"48":"Die septimo princeps filiorum Ephraim Elisama filius Ammiud"
,"49":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"50":"acetabulum aureum appendens decem siclos plenum incenso,"
,"51":"bovem de armento et arietem et agnum anniculum in holocaustum,"
,"52":"hircumque pro peccato;"
,"53":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Elisama filii Ammiud."
,"54":"Die octavo princeps filiorum Manasse Gamaliel filius Phadassur"
,"55":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"56":"acetabulum aureum appendens decem siclos plenum incenso,"
,"57":"bovem de armento et arietem et agnum anniculum in holocaustum"
,"58":"hircumque pro peccato;"
,"59":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Gamaliel filii Phadassur."
,"60":"Die nono princeps filiorum Beniamin Abidan filius Gedeonis"
,"61":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"62":"et acetabulum aureum appendens decem siclos plenum incenso,"
,"63":"bovem de armento et arietem et agnum anniculum in holocaustum"
,"64":"hircumque pro peccato;"
,"65":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Abidan filii Gedeonis."
,"66":"Die decimo princeps filiorum Dan Ahiezer filius Ammisaddai"
,"67":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"68":"acetabulum aureum appendens decem siclos plenum incenso,"
,"69":"bovem de armento et arietem et agnum anniculum in holocaustum"
,"70":"hircumque pro peccato;"
,"71":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Ahiezer filii Ammisaddai."
,"72":"Die undecimo princeps filiorum Aser Phegiel filius Ochran"
,"73":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila conspersa oleo in sacrificium,"
,"74":"acetabulum aureum appendens decem siclos plenum incenso,"
,"75":"bovem de armento et arietem et agnum anniculum in holocaustum"
,"76":"hircumque pro peccato;"
,"77":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Phegiel filii Ochran."
,"78":"Die duodecimo princeps filiorum Nephthali Ahira filius Enan"
,"79":"obtulit scutulam argenteam appendentem centum triginta siclos, phialam argenteam habentem septuaginta siclos ad pondus sanctuarii, utramque plenam simila oleo conspersa in sacrificium,"
,"80":"acetabulum aureum appendens decem siclos plenum incenso,"
,"81":"bovem de armento et arietem et agnum anniculum in holocaustum"
,"82":"hircumque pro peccato;"
,"83":"et in hostias pacificorum boves duos, arietes quinque, hircos quinque, agnos anniculos quinque: haec fuit oblatio Ahira filii Enan."
,"84":"Haec in dedicatione altaris oblata sunt a principibus Israel in die, qua consecratum est: scutulae argenteae duodecim, phialae argenteae duodecim, acetabula duodecim,"
,"85":"ita ut centum triginta siclos argenti haberet una scutella, et septuaginta siclos haberet una phiala, id est in commune vasorum omnium ex argento sicli duo milia quadringenti pondere sanctuarii;"
,"86":"acetabula aurea duodecim plena incenso denos siclos appendentia pondere sanctuarii, id est simul auri sicli centum viginti;"
,"87":"omnes boves de armento in holocaustum duodecim, arietes duodecim, agni anniculi duodecim et libamenta eorum; hirci duodecim pro peccato."
,"88":"In hostias pacificorum omnes boves viginti quattuor, arietes sexaginta, hirci sexaginta, agni anniculi sexaginta: haec oblata sunt in dedicatione altaris, quando unctum est."
,"89":"Cumque ingrederetur Moyses tabernaculum testimonii, ut consuleret oraculum, audiebat vocem loquentis ad se de propitiatorio, quod erat super arcam testimonii inter duos cherubim, unde et loquebatur ei."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Loquere Aa ron et dices ad eum: Cum posueris lucernas, contra eam partem, quam candelabrum respicit, lucere debebunt septem lucernae '."
,"3":"Fecitque sic Aaron et posuit lucernas super candelabrum, ut praeceperat Dominus Moysi."
,"4":"Haec autem erat factura candelabri: ex auro ductili, tam medius stipes quam flores eius. Iuxta exemplum, quod ostendit Dominus Moysi, ita operatus est candelabrum."
,"5":"Et locutus est Dominus ad Moysen dicens:"
,"6":"' Tolle Levitas de medio filiorum Israel et purificabis eos"
,"7":"iuxta hunc ritum. Aspergantur aqua lustrationis et radant omnes pilos carnis suae, lavabunt vestimenta sua et mundabunt se."
,"8":"Tollent bovem de armentis et oblationem eius similam oleo conspersam; bovem autem alterum de armento tu accipies pro peccato"
,"9":"et applicabis Levitas coram tabernaculo conventus, convocata omni multitudine filiorum Israel."
,"10":"Cumque Levitae fuerint coram Domino, ponent filii Israel manus suas super eos,"
,"11":"et agitabit Aaron Levitas munus in conspectu Domini a filiis Israel, ut serviant in ministerio eius."
,"12":"Levitae quoque ponent manus suas super capita boum, e quibus unum facies pro peccato et alterum in holocaustum Domini, ut expies eos."
,"13":"Statuesque Levitas in conspectu Aaron et filiorum eius et agitabis eos Domino"
,"14":"ac separabis de medio filiorum Israel, ut sint mei;"
,"15":"et postea ingredientur, ut serviant tabernaculo conventus. Sicque purificabis et agitabis eos, "
,"16":"quoniam dono donati sunt mihi e medio filiorum Israel; pro primogenitis, quae aperiunt omnem vulvam in Israel, accepi eos."
,"17":"Mea sunt enim omnia primogenita filiorum Israel, tam ex hominibus quam ex iumentis. Ex die, quo percussi omne primogenitum in terra Aegypti, sanctificavi eos mihi."
,"18":"Et tuli Levitas pro cunctis primogenitis filiorum Israel"
,"19":"tradidique eos dono Aaron et filiis eius de medio filiorum Israel, ut serviant mihi pro Israel in tabernaculo conventus et expient pro eis, ne sit in populo plaga, si ausi fuerint accedere ad sanctuarium '."
,"20":"Feceruntque Moyses et Aaron et omnis congregatio filiorum Israel super Levitis, quae praeceperat Dominus Moysi."
,"21":"Purificatique sunt et laverunt vestimenta sua, agitavitque eos Aaron in conspectu Domini et expiavit eos, ut purificati"
,"22":"ingrederentur ad officia sua in tabernaculo conventus coram Aaron et filiis eius; sicut praeceperat Dominus Moysi de Levitis, ita factum est."
,"23":"Locutusque est Dominus ad Moysen dicens:"
,"24":"' Haec est lex Levitarum: a viginti quinque annis et supra ingredientur, ut ministrent in tabernaculo conventus;"
,"25":"cumque quinquagesimum annum aetatis impleverint, servire cessabunt"
,"26":"eruntque ministri fratrum suorum in tabernaculo conventus, ut custodiant, quae sibi fuerint commendata; opera autem ipsa non faciant. Sic dispones Levitis in custodiis suis '."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Locutus est Dominus ad Moy sen in deserto Sinai anno secun do, postquam egressi sunt de terra Aegypti, mense primo dicens:"
,"2":"' Faciant filii Israel Pascha in tempore suo"
,"3":"quarta decima die mensis huius ad vesperam iuxta omnia praecepta et iustificationes eius '."
,"4":"Praecepitque Moyses filiis Israel, ut facerent Pascha."
,"5":"Qui fecerunt tempore suo quarta decima die mensis ad vesperam in deserto Sinai; iuxta omnia, quae mandaverat Dominus Moysi, fecerunt filii Israel."
,"6":"Ecce autem quidam immundi super animam hominis, qui non poterant facere Pascha in die illo, accedentes ad Moysen et Aaron"
,"7":"dixerunt ei: ' Immundi sumus super animam hominis; quare fraudamur, ut non valeamus oblationem offerre Domino in tempore suo inter filios Israel? '."
,"8":"Quibus respondit Moyses: ' State, ut consulam quid praecipiat Dominus de vobis '."
,"9":"Locutusque est Dominus ad Moysen dicens:"
,"10":"' Loquere filiis Israel: Homo, qui fuerit immundus super anima, sive in via procul in gente vestra, faciat Pascha Domino"
,"11":"in mense secundo quarta decima die mensis ad vesperam; cum azymis et lactucis agrestibus comedent illud,"
,"12":"non relinquent ex eo quippiam usque mane et os eius non confringent: omnem ritum Pascha observabunt."
,"13":"Si quis autem et mundus est et in itinere non fuit et tamen non fecit Pascha, exterminabitur anima illa de populis suis, quia sacrificium Domino non obtulit tempore suo: peccatum suum ipse portabit."
,"14":"Peregrinus quoque et advena, si fuerint apud vos, facient Pascha Domino iuxta praecepta et iustificationes eius; praeceptum idem erit apud vos tam advenae quam indigenae '."
,"15":"Igitur die, qua erectum est habitaculum, operuit nubes habitaculum, tabernaculum testimonii; a vespere autem super habitaculum erat quasi species ignis usque mane."
,"16":"Sic fiebat iugiter: per diem operiebat illud nubes, et per noctem quasi species ignis."
,"17":"Cumque ablata fuisset nubes, quae tabernaculum protegebat, tunc proficiscebantur filii Israel; et in loco, ubi stetisset nubes, ibi castrametabantur."
,"18":"Ad imperium Domini proficiscebantur et ad imperium illius castrametabantur. Cunctis diebus, quibus stabat nubes super habitaculum, manebant in eodem loco."
,"19":"Et si evenisset ut multo tempore maneret super illud, erant filii Israel in excubiis Domini et non proficiscebantur;"
,"20":"si diebus paucis fuisset nubes super habitaculum, ad imperium Domini erigebant tentoria et ad imperium illius deponebant."
,"21":"Si fuisset nubes a vespere usque mane et statim diluculo habitaculum reliquisset, proficiscebantur; et si post diem et noctem recessisset, dissipabant tentoria."
,"22":"Si vero biduo aut uno mense vel longiore tempore fuisset super habitaculum, manebant filii Israel in eodem loco et non proficiscebantur. Statim autem ut recessisset, movebant castra."
,"23":"Per verbum Domini figebant tentoria et per verbum illius proficiscebantur; erantque in excubiis Domini iuxta imperium eius per manum Moysi."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Fac tibi duas tubas argenteas ductiles, quibus convocare possis congregationem, quando movenda sunt castra."
,"3":"Cumque increpueris tubis, congregabitur ad te omnis turba ad ostium tabernaculi conventus."
,"4":"Si semel clangueris, venient ad te principes et capita congregationis Israel;"
,"5":"si autem prolixior clangor increpuerit, movebunt castra primi, qui sunt ad orientalem plagam;"
,"6":"in secundo autem sonitu et pari ululatu tubae levabunt tentoria, qui habitant ad meridiem, et iuxta hunc modum reliqui facient, ululantibus tubis in profectionem."
,"7":"Quando autem congregandus est populus, simplex tubarum clangor erit, et non ululabunt."
,"8":"Filii autem Aaron sacerdotes clangent tubis. Eritque hoc vobis legitimum sempiternum in generationibus vestris."
,"9":"Si exieritis ad bellum in terra vestra contra hostes, qui dimicant adversum vos, clangetis ululantibus tubis; et erit recordatio vestri coram Domino Deo vestro, ut eruamini de manibus inimicorum vestrorum."
,"10":"Si quando habebitis epulum et dies festos et calendas, canetis tubis super holocaustis vestris et pacificis victimis, ut sint vobis in recordationem Dei vestri. Ego Dominus Deus vester '."
,"11":"Anno secundo, mense secundo, vicesima die mensis elevata est nubes de habitaculo testimonii;"
,"12":"profectique sunt filii Israel per migrationes suas de deserto Sinai, et recubuit nubes in solitudine Pharan."
,"13":"Moveruntque castra prima vice, iuxta imperium Domini in manu Moysi."
,"14":"Elevatum est primum vexillum castrorum filiorum Iudae per turmas suas, quorum princeps erat Naasson filius Aminadab;"
,"15":"et super turmam tribus filiorum Issachar fuit princeps Nathanael filius Suar;"
,"16":"et super turmam tribus Zabulon erat princeps Eliab filius Helon."
,"17":"Depositumque est habitaculum, quod portantes egressi sunt filii Gerson et Merari."
,"18":"Profectum est vexillum castrorum filiorum Ruben per turmas suas, et super turbam suam princeps erat Elisur filius Sedeur."
,"19":"Super turmam autem tribus filiorum Simeon princeps fuit Salamiel filius Surisaddai."
,"20":"Porro super turmam tribus filiorum Gad erat princeps Eliasaph filius Deuel."
,"21":"Profectique sunt et Caathitae portantes sanctuarium. Et erectum est habitaculum, antequam venirent."
,"22":"Elevatum est vexillum castrorum filiorum Ephraim per turmas suas, in quorum exercitu princeps erat Elisama filius Ammiud."
,"23":"Et super turmam tribus filiorum Manasse princeps fuit Gamaliel filius Phadassur;"
,"24":"et super turmam tribus filiorum Beniamin erat dux Abidan filius Gedeonis."
,"25":"Novissime elevatum est vexillum castrorum filiorum Dan per turmas suas, in quorum exercitu princeps fuit Ahiezer filius Ammisaddai."
,"26":"Et super turmam tribus filiorum Aser erat princeps Phegiel filius Ochran;"
,"27":"et super turmam tribus filiorum Nephthali princeps fuit Ahira filius Enan."
,"28":"Hae sunt profectiones filiorum Israel per turmas suas, quando egrediebantur."
,"29":"Dixitque Moyses Hobab filio Raguel Madianitae cognato suo: ' Proficiscimur ad locum, quem Dominus daturus est nobis; veni nobiscum, ut benefaciamus tibi, quia Dominus bona promisit Israeli '."
,"30":"Cui ille respondit: ' Non vadam tecum, sed revertar in terram meam, in qua natus sum '."
,"31":"Et ille: ' Noli, inquit, nos relinquere; tu enim nosti in quibus locis per desertum castra ponere debeamus, et eris ductor noster."
,"32":"Cumque nobiscum veneris, quidquid optimum fuerit ex opibus, quas nobis traditurus est Dominus, dabimus tibi '."
,"33":"Profecti sunt ergo de monte Domini viam trium dierum; arcaque foederis Domini praecedebat eos per dies tres providens castrorum locum."
,"34":"Nubes quoque Domini super eos erat per diem, cum incederent."
,"35":"Cumque elevaretur arca, dicebat Moyses: ' Surge, Domine, et dissipentur inimici tui; et fugiant, qui oderunt te, a facie tua '."
,"36":"Cum autem deponeretur, aiebat: ' Revertere, Domine, ad multitudinem exercitus Israel '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Ortum est murmur populi, quasi dolentium pro labore, contra Dominum. Quod cum audisset Dominus, iratus est, et accensus in eos ignis Domini devoravit extremam castrorum partem."
,"2":"Cumque clamasset populus ad Moysen, oravit Moyses ad Dominum, et absorptus est ignis."
,"3":"Vocaverunt nomen loci illius Tabera, eo quod incensus fuisset contra eos ignis Domini."
,"4":"Vulgus autem promiscuum, quod erat in medio eius, flagravit desiderio, et sedentes fleverunt pariter filii Israel et dixerunt: ' Quis dabit nobis ad vescendum carnes?"
,"5":"Recordamur piscium, quos comedebamus in Aegypto gratis; in mentem nobis veniunt cucumeres et pepones porrique et cepae et alia."
,"6":"Guttur nostrum aridum est; nihil aliud respiciunt oculi nostri nisi man '."
,"7":"Erat autem man quasi semen coriandri aspectus bdellii."
,"8":"Circuibatque populus et colligens illud frangebat mola sive terebat in mortario coquens in olla et faciens ex eo tortulas saporis quasi panis oleati."
,"9":"Cumque descenderet nocte super castra ros, descendebat pariter et man."
,"10":"Audivit ergo Moyses flentem populum per familias, singulos per ostia tentorii sui. Iratusque est furor Domini valde; quod Moysi intoleranda res visa est,"
,"11":"et ait ad Dominum: ' Cur afflixisti servum tuum? Quare non invenio gratiam coram te? Et cur imposuisti pondus universi populi huius super me?"
,"12":"Numquid ego concepi omnem hunc populum vel genui eum, ut dicas mihi: 'Porta eum in sinu tuo, sicut portare solet nutrix infantulum, et defer in terram, pro qua iurasti patribus eorum?'."
,"13":"Unde mihi carnes, ut dem universo populo isti? Flent contra me dicentes: 'Da nobis carnes, ut comedamus!'."
,"14":"Non possum ego solus sustinere omnem hunc populum, quia nimis gravis est mihi."
,"15":"Si hoc modo agis mecum, obsecro ut interficias me, si inveni gratiam in oculis tuis, ne videam amplius mala mea! '."
,"16":"Et dixit Dominus ad Moysen: ' Congrega mihi septuaginta viros de senibus Israel, quos tu nosti quod senes populi sint ac magistri, et duces eos ad ostium tabernaculi conventus, stabuntque ibi tecum."
,"17":"Et descendam et loquar tibi et auferam de spiritu tuo tradamque eis, ut sustentent tecum onus populi, et non tu solus graveris."
,"18":"Populo quoque dices: Sanctificamini, cras comedetis carnes; ego enim audivi vos flere: 'Quis dabit nobis escas carnium? Bene nobis erat in Aegypto'. Et dabit vobis Dominus carnes, et comedetis"
,"19":"non uno die nec duobus vel quinque aut decem nec viginti quidem,"
,"20":"sed usque ad mensem dierum, donec exeat per nares vestras et vertatur in nauseam, eo quod reppuleritis Dominum, qui in medio vestri est, et fleveritis coram eo dicentes: 'Quare egressi sumus ex Aegypto?' '."
,"21":"Et ait Moyses: ' Populus, in cuius medio sum, sescenta milia peditum sunt, et tu dicis: 'Dabo eis esum carnium mense integro!'."
,"22":"Numquid ovium et boum multitudo caedetur, ut possit sufficere ad cibum? Vel omnes pisces maris in unum congregabuntur, ut eos satient? '."
,"23":"Cui respondit Dominus: ' Numquid manus Domini abbreviata est? Iam nunc videbis utrum meus sermo opere compleatur an non '."
,"24":"Venit igitur Moyses et narravit populo verba Domini congregans septuaginta viros de senibus Israel, quos stare fecit circa tabernaculum."
,"25":"Descenditque Dominus per nubem et locutus est ad eum auferens de spiritu, qui erat in Moyse, et dans septuaginta viris senibus. Cumque requievisset in eis spiritus, prophetaverunt nec ultra fecerunt."
,"26":"Remanserant autem in castris duo viri, quorum unus vocabatur Eldad et alter Medad, super quos requievit spiritus; nam et ipsi descripti fuerant et non exierant ad tabernaculum. Cumque prophetarent in castris,"
,"27":"cucurrit puer et nuntiavit Moysi dicens: ' Eldad et Medad prophetant in castris '."
,"28":"Statim Iosue filius Nun minister Moysi et electus eius a iuventute sua ait: ' Domine mi Moyses, prohibe eos! '."
,"29":"At ille: ' Quid, inquit, aemularis pro me? Quis tribuat, ut omnis populus prophetet, et det eis Dominus spiritum suum? '."
,"30":"Reversusque est Moyses et maiores natu Israel in castra."
,"31":"Ventus autem egrediens a Domino arreptas trans mare coturnices detulit et demisit in castra itinere, quantum uno die confici potest, ex omni parte castrorum per circuitum; volabantque in aere duobus cubitis altitudine super terram."
,"32":"Surgens ergo populus toto die illo et nocte ac die altero congregavit coturnicum, qui parum, decem choros; et extenderunt eas per gyrum castrorum."
,"33":"Adhuc carnes erant in dentibus eorum, nec defecerat huiuscemodi cibus, et ecce furor Domini concitatus in populum percussit eum plaga magna nimis."
,"34":"Vocatusque est ille locus Cibrottaava; ibi enim sepelierunt populum, qui desideraverat."
,"35":"Egressi autem de Cibrottaava, venerunt in Aseroth et manserunt ibi."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Locutaque est Maria et Aaron contra Moysen propter uxorem eius Aethiopissam"
,"2":"et dixerunt: ' Num per solum Moysen locutus est Dominus? Nonne et per nos similiter est locutus? '. Quod cum audisset Dominus"
,"3":"erat enim Moyses vir humillimus super omnes homines, qui morabantur in terra"
,"4":"statim locutus est ad eum et ad Aaron et Mariam: ' Egredimini vos tantum tres ad tabernaculum conventus '. Cumque fuissent egressi,"
,"5":"descendit Dominus in columna nubis et stetit in introitu tabernaculi vocans Aaron et Mariam. Qui cum issent,"
,"6":"dixit ad eos: ' Audite sermones meos!,Si quis fuerit inter vos propheta Domini, in visione apparebo ei,vel per somnium loquar ad illum."
,"7":"At non talis servus meus Moyses, qui in omni domo mea fidelissimus est!"
,"8":"Ore enim ad os loquor ei, et palam et non per aenigmata et figuras,Dominum videt!,Quare ergo non timuistis detrahere,servo meo Moysi? '."
,"9":"Iratusque contra eos abiit,"
,"10":"nubes quoque recessit, quae erat super tabernaculum; et ecce Maria apparuit candens lepra quasi nix. Cumque respexisset eam Aaron et vidisset perfusam lepra, "
,"11":"ait ad Moysen: ' Obsecro, domine mi, ne imponas nobis hoc peccatum, quod stulte commisimus,"
,"12":"ne fiat haec quasi mortua et ut abortivum, quod proicitur de vulva matris suae; ecce iam medium carnis eius devoratum est a lepra '."
,"13":"Clamavitque Moyses ad Dominum dicens: ' Deus, obsecro, sana eam! '."
,"14":"Cui respondit Dominus: ' Si pater eius spuisset in faciem illius, nonne debuerat saltem septem diebus rubore suffundi? Separetur septem diebus extra castra et postea revocabitur '."
,"15":"Exclusa est itaque Maria extra castra septem diebus, et populus non est motus de loco illo, donec revocata est Maria."
,"16":"Profectusque est populus de Aseroth, fixis tentoriis in deserto Pharan."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Ibi locutus est Dominus ad Moysen dicens:"
,"2":"' Mitte vi ros, qui considerent terram Chanaan, quam daturus sum filiis Israel, singulos de singulis tribubus ex principibus '."
,"3":"Fecit Moyses quod Dominus imperaverat, de deserto Pharan mittens principes viros, quorum ista sunt nomina:"
,"4":"de tribu Ruben Sammua filium Zacchur,"
,"5":"de tribu Simeon Saphat filium Hori,"
,"6":"de tribu Iudae Chaleb filium Iephonne,"
,"7":"de tribu Issachar Igal filium Ioseph,"
,"8":"de tribu Ephraim Osee filium Nun,"
,"9":"de tribu Beniamin Phalti filium Raphu,"
,"10":"de tribu Zabulon Geddiel filium Sodi,"
,"11":"de tribu Ioseph, tribu Manasse, Gaddi filium Susi,"
,"12":"de tribu Dan Ammiel filium Gemalli,"
,"13":"de tribu Aser Sthur filium Michael,"
,"14":"de tribu Nephthali Nahabi filium Vaphsi,"
,"15":"de tribu Gad Guel filium Machi."
,"16":"Haec sunt nomina virorum, quos misit Moyses ad considerandam terram. Vocavitque Osee filium Nun Iosue."
,"17":"Misit ergo eos Moyses ad considerandam terram Chanaan et dixit ad eos: ' Ascendite per Nageb. Cumque veneritis ad montes,"
,"18":"considerate terram, qualis sit, et populum, qui habitator est eius, utrum fortis sit an infirmus, si pauci numero an plures;"
,"19":"ipsa terra bona an mala, urbes quales, absque muris an muratae;"
,"20":"humus pinguis an sterilis, nemorosa an absque arboribus. Confortamini et afferte nobis de fructibus terrae '. Erat autem tempus, quando iam praecoquae uvae vesci possunt."
,"21":"Cumque ascendissent, exploraverunt terram a deserto Sin usque Rohob in introitu Emath."
,"22":"Ascenderuntque ad Nageb et venerunt in Hebron, ubi erant Ahiman et Sesai et Tholmai filii Enac. Nam Hebron septem annis ante Tanim urbem Aegypti condita est."
,"23":"Pergentesque usque ad Nehelescol absciderunt palmitem cum uva sua, quem portaverunt in vecte duo viri. De malis quoque granatis et de ficis loci illius tulerunt,"
,"24":"qui appellatus est Nehelescol, eo quod botrum portassent inde filii Israel."
,"25":"Reversique exploratores terrae post quadraginta dies, omni regione circuita,"
,"26":"venerunt ad Moysen et Aaron et ad omnem coetum filiorum Israel in desertum Pharan, quod est in Cades. Locutique eis et omni congregationi ostenderunt fructus terrae"
,"27":"et narraverunt dicentes: ' Venimus in terram, ad quam misisti nos, quae re vera fluit lacte et melle, ut ex his fructibus cognosci potest."
,"28":"Sed cultores fortissimos habet et urbes grandes atque muratas. Stirpem Enac vidimus ibi;"
,"29":"Amalec habitat in Nageb, Hetthaeus et Iebusaeus et Amorraeus in montanis, Chananaeus vero moratur iuxta mare et circa fluenta Iordanis '."
,"30":"Inter haec Chaleb compescens murmur populi, qui oriebatur contra Moysen, ait: ' Ascendamus et possideamus terram, quoniam poterimus obtinere eam '."
,"31":"Alii vero, qui fuerant cum eo, dicebant: ' Nequaquam ad hunc populum valemus ascendere, quia fortior nobis est '."
,"32":"Detraxeruntque terrae, quam inspexerant, apud filios Israel dicentes: ' Terra, quam lustravimus, devorat habitatores suos; populus, quem aspeximus, procerae staturae est;"
,"33":"ibi vidimus gigantes, filios Enac de genere giganteo, quibus comparati quasi locustae videbamur '."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Igitur vociferans omnis tur ba flevit nocte illa,"
,"2":"et mur murati sunt contra Moysen et Aaron cuncti filii Israel dicentes: ' Utinam mortui essemus in Aegypto vel in hac vasta solitudine!"
,"3":"Cur inducit nos Dominus in terram istam, ut cadamus gladio, et uxores ac liberi nostri ducantur captivi? Nonne melius est reverti in Aegyptum? '."
,"4":"Dixeruntque alter ad alterum: ' Constituamus nobis ducem et revertamur in Aegyptum! '."
,"5":"Quo audito, Moyses et Aaron ceciderunt proni in terram coram omni congregatione filiorum Israel."
,"6":"At vero Iosue filius Nun et Chaleb filius Iephonne, qui et ipsi lustraverant terram, sciderunt vestimenta sua"
,"7":"et ad omnem congregationem filiorum Israel locuti sunt: ' Terra, quam circuivimus, valde bona est."
,"8":"Si propitius fuerit Dominus, inducet nos in eam et tradet humum lacte et melle manantem."
,"9":"Nolite rebelles esse contra Dominum neque timeatis populum terrae huius, quia sicut panem ita eos possumus devorare. Recessit ab eis omne praesidium; Dominus nobiscum est, nolite metuere '."
,"10":"Cumque clamaret omnis congregatio et lapidibus eos vellet opprimere, apparuit gloria Domini super tabernaculum conventus cunctis filiis Israel,"
,"11":"et dixit Dominus ad Moysen: ' Usquequo detrahet mihi populus iste? Quousque non credent mihi in omnibus signis, quae feci coram eis?"
,"12":"Feriam igitur eos pestilentia atque consumam; te autem faciam in gentem magnam et fortiorem quam haec est '."
,"13":"Et ait Moyses ad Dominum: ? Audient Aegyptii, de quorum medio eduxisti populum istum in virtute tua,"
,"14":"et dicent ad habitatores terrae huius, quia audierunt quod tu, Domine, in populo isto sis et facie videaris ad faciem, et nubes tua protegat illos, et in columna nubis praecedas eos per diem et in columna ignis per noctem."
,"15":"Et occidisti hunc populum quasi unum hominem, et dicent gentes, quae audierunt auditum tuum:"
,"16":"'Non poterat Dominus introducere populum in terram, pro qua iuraverat, idcirco occidit eos in solitudine!'."
,"17":"Magnificetur ergo fortitudo Domini, sicut iurasti dicens:"
,"18":"'Dominus patiens et multae misericordiae, auferens iniquitatem et scelera nullumque innoxium derelinquens, qui visitas peccata patrum in filios in tertiam et quartam generationem'."
,"19":"Dimitte obsecro peccatum populi huius secundum magnitudinem misericordiae tuae, sicut propitius fuisti populo huic de Aegypto usque ad locum istum '."
,"20":"Dixitque Dominus: ' Dimisi iuxta verbum tuum."
,"21":"Vivo ego, et implebit gloria Domini universam terram!"
,"22":"Attamen omnes homines, qui viderunt maiestatem meam et signa, quae feci in Aegypto et in solitudine, et tentaverunt me iam per decem vices nec oboedierunt voci meae,"
,"23":"non videbunt terram, pro qua iuravi patribus eorum; nec quisquam ex illis, qui detraxit mihi, intuebitur eam."
,"24":"Servum meum Chaleb, qui plenus alio spiritu secutus est me, inducam in terram hanc, quam circuivit, et semen eius possidebit eam."
,"25":"Quoniam Amalecites et Chananaeus habitant in vallibus, cras movete castra et revertimini in solitudinem per viam maris Rubri '."
,"26":"Locutusque est Dominus ad Moysen et Aaron dicens:"
,"27":"' Usquequo congregatio haec pessima murmurat contra me? Querelas filiorum Israel audivi."
,"28":"Dic ergo eis: Vivo ego, ait Dominus, sicut locuti estis, audiente me, sic faciam vobis!"
,"29":"In solitudine hac iacebunt cadavera vestra. Omnes, qui numerati estis a viginti annis et supra et murmurastis contra me,"
,"30":"non intrabitis terram, super quam levavi manum meam, ut habitare vos facerem, praeter Chaleb filium Iephonne et Iosue filium Nun."
,"31":"Parvulos autem vestros, de quibus dixistis quod praedae hostibus forent, introducam, ut videant terram, quae vobis displicuit."
,"32":"Vestra cadavera iacebunt in solitudine hac;"
,"33":"filii vestri erunt pastores in deserto annis quadraginta et portabunt fornicationem vestram, donec consumantur cadavera vestra in deserto."
,"34":"Iuxta numerum quadraginta dierum, quibus considerastis terram annus pro die imputabitur quadraginta annis portabitis iniquitates vestras et scietis ultionem meam."
,"35":"Ego Dominus locutus sum, ita faciam omni congregationi huic pessimae, quae consurrexit adversum me: in solitudine hac deficiet et morietur '."
,"36":"Igitur omnes viri, quos miserat Moyses ad contemplandam terram et qui reversi murmurare fecerant contra eum omnem congregationem detrahentes terrae quod esset mala,"
,"37":"mortui sunt atque percussi in conspectu Domini."
,"38":"Iosue autem filius Nun et Chaleb filius Iephonne vixerunt ex omnibus, qui perrexerant ad considerandam terram."
,"39":"Locutusque est Moyses universa verba haec ad omnes filios Israel, et luxit populus nimis."
,"40":"Et ecce mane primo surgentes ascenderunt verticem montis atque dixerunt: ' Parati sumus ascendere ad locum, de quo Dominus locutus est, quia peccavimus '."
,"41":"Quibus Moyses: ' Cur, inquit, transgredimini verbum Domini, quod vobis non cedet in prosperum?"
,"42":"Nolite ascendere, non enim est Dominus vobiscum, ne corruatis coram inimicis vestris!"
,"43":"Amalecites et Chananaeus ante vos sunt, quorum gladio corruetis, eo quod nolueritis acquiescere Domino, nec erit Dominus vobiscum '."
,"44":"At illi contenebrati ascenderunt in verticem montis; arca autem foederis Domini et Moyses non recesserunt de castris."
,"45":"Descenditque Amalecites et Chananaeus, qui habitabat in monte, et percutiens eos atque concidens persecutus est eos usque Horma."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Locutus est Dominus ad Moysen dicens:"
,"2":"' Loquere ad filios Israel et dices ad eos: Cum ingressi fueritis terram habitationis vestrae, quam ego dabo vobis,"
,"3":"et feceritis oblationem Domino in holocaustum aut victimam vota solventes vel sponte offerentes munera aut in sollemnitatibus vestris adolentes odorem suavitatis Domino de bobus sive de ovibus,"
,"4":"offeret, quicumque immolaverit victimam, sacrificium similae decimam partem ephi conspersae oleo, quod mensuram habebit quartam partem hin,"
,"5":"et vinum ad liba fundenda eiusdem mensurae dabit in holocaustum sive in victimam per agnos singulos."
,"6":"Per arietes erit sacrificium similae duarum decimarum, quae conspersa sit oleo tertiae partis hin;"
,"7":"et vinum ad libamentum tertiae partis eiusdem mensurae offeret in odorem suavitatis Domino."
,"8":"Quando vero de bobus feceris holocaustum aut hostiam, ut impleas votum vel pacificas victimas,"
,"9":"dabis per singulos boves similae tres decimas conspersae oleo, quod habeat medium mensurae hin,"
,"10":"et vinum ad liba fundenda eiusdem mensurae in oblationem suavissimi odoris Domino."
,"11":"Sic facies per singulos boves et arietes et agnos et capras."
,"12":"Secundum numerum victimarum quas offeretis, ita facietis singulis secundum numerum earum."
,"13":"Omnis indigena eodem ritu offeret sacrificium ignis in odorem suavitatis Domino."
,"14":"Et omnis peregrinus, qui habitat vobiscum vel qui commoratur in medio vestri in omnibus generationibus vestris, offeret sacrificium ignis in odorem suavitatis Domino eodem modo sicut et vos."
,"15":"Unum praeceptum erit tam vobis quam advenis pro omnibus generationibus vestris coram Domino."
,"16":"Una lex erit atque unum iudicium tam vobis quam advenis, qui vobiscum commorantur '."
,"17":"Locutus est Dominus ad Moysen dicens:"
,"18":"' Loquere filiis Israel et dices ad eos: Cum veneritis in terram, quam dabo vobis,"
,"19":"et comederitis de panibus regionis illius, separabitis donaria Domino"
,"20":"de pulmento placentam. Sicut de areis donaria separatis,"
,"21":"ita et de pulmentis dabitis ea Domino."
,"22":"Quod si per ignorantiam praeterieritis quidquam horum, quae locutus est Dominus ad Moysen"
,"23":"et mandavit per eum ad vos a die, qua coepit iubere et ultra ad generationes vestras,"
,"24":"si longe ab oculis congregationis, offeret congregatio vitulum de armento, holocaustum in odorem placabilem Domino et oblationem ac liba eius, ut caeremoniae postulant, hircumque pro peccato."
,"25":"Et expiabit sacerdos pro omni congregatione filiorum Israel, et dimittetur eis, quoniam non sponte peccaverunt, nihilominus offerentes sacrificium ignis Domino pro se et pro peccato atque errore suo."
,"26":"Et dimittetur universae plebi filiorum Israel et advenis, qui peregrinantur inter eos, quoniam culpa est omnis populi per ignorantiam."
,"27":"Quod si anima una nesciens peccaverit, offeret capram anniculam pro peccato suo."
,"28":"Et expiabit pro ea sacerdos, quod inscia peccaverit coram Domino; expiabit pro ea, et dimittetur illi."
,"29":"Tam indigenis quam advenis una lex erit omnium, qui peccaverint ignorantes."
,"30":"Anima vero, quae per superbiam aliquid commiserit, sive civis sit ille sive peregrinus, quoniam adversus Dominum rebellis fuit, peribit de populo suo."
,"31":"Verbum enim Domini contempsit et praeceptum illius fecit irritum; idcirco delebitur et portabit iniquitatem suam '."
,"32":"Factum est autem, cum essent filii Israel in solitudine et invenissent hominem colligentem ligna in die sabbati,"
,"33":"obtulerunt eum Moysi et Aaron et universae congregationi,"
,"34":"qui recluserunt eum in carcerem nescientes quid super eo facere deberent."
,"35":"Dixitque Dominus ad Moysen: ' Morte moriatur homo iste; obruat eum lapidibus omnis turba extra castra '."
,"36":"Cumque eduxissent eum foras, obruerunt lapidibus; et mortuus est, sicut praeceperat Dominus."
,"37":"Dixit quoque Dominus ad Moysen:"
,"38":"' Loquere filiis Israel et dices ad eos, ut faciant sibi fimbrias per angulos palliorum ponentes in eis vittas hyacinthinas."
,"39":"Quas cum videbitis, recordabimini omnium mandatorum Domini eaque facietis nec sequamini cogitationes vestras et oculos per res varias fornicantes,"
,"40":"sed magis memores omnium praeceptorum meorum faciatis ea sitisque sancti Deo vestro."
,"41":"Ego Dominus Deus vester, qui eduxi vos de terra Aegypti, ut essem Deus vester. Ego Dominus Deus vester '."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Ecce autem Core filius Isaar filii Caath filii Levi et Dathan atque Abiram filii Eliab, Hon quoque filius Pheleth de filiis Ruben"
,"2":"surrexerunt contra Moysen aliique filiorum Israel ducenti quinquaginta viri proceres synagogae vocati ad concilium, viri famosi."
,"3":"Cumque stetissent adversum Moysen et Aaron, dixerunt: ' Sufficiat vobis quia omnis congregatio sanctorum est, et in ipsis est Dominus! Cur elevamini super congregationem Domini? '."
,"4":"Quod cum audisset Moyses, cecidit pronus in faciem"
,"5":"locutusque ad Core et ad omne concilium: ' Mane, inquit, notum faciet Dominus qui ad se pertineant et qui sint sancti, et sanctos applicabit sibi; et, quos elegerit, appropinquare sibi faciet."
,"6":"Hoc igitur facite: tollat unusquisque turibulum suum, tu, Core, et omne concilium tuum;"
,"7":"et hausto cras igne, ponite desuper thymiama coram Domino; et, quemcumque elegerit, ipse erit sanctus. Sufficiat vobis, filii Levi! '."
,"8":"Dixitque rursum ad Core: ' Audite, filii Levi."
,"9":"Num parum vobis est quod separavit vos Deus Israel ab omni congregatione et iunxit sibi, ut serviretis ei in cultu habitaculi Domini et staretis coram frequentia populi et ministraretis pro ea?"
,"10":"Idcirco ad se fecit accedere te et omnes fratres tuos filios Levi, ut vobis etiam sacerdotium vindicetis,"
,"11":"et omne concilium tuum stet contra Dominum? Quid est enim Aaron, ut murmuretis contra eum? '."
,"12":"Misit ergo Moyses, ut vocaret Dathan et Abiram filios Eliab, qui responderunt: ' Non venimus!"
,"13":"Numquid parum est tibi quod eduxisti nos de terra, quae lacte et melle manabat, ut occideres in deserto, nisi et dominatus fueris nostri?"
,"14":"Revera non induxisti nos in terram, quae fluit rivis lactis et mellis, nec dedisti nobis possessiones agrorum et vinearum! An et oculos illorum hominum vis eruere? Non venimus! '."
,"15":"Iratusque Moyses valde ait ad Dominum: ' Ne respicias sacrificia eorum; tu scis quod ne asellum quidem umquam acceperim ab eis nec afflixerim quempiam eorum '."
,"16":"Dixitque ad Core: ' Tu et omne concilium tuum state seorsum coram Domino, et Aaron die crastino separatim."
,"17":"Tollite singuli turibula vestra et ponite super ea incensum offerentes Domino ducenta quinquaginta turibula; tu et Aaron teneatis unusquisque turibulum suum '."
,"18":"Quod cum fecissent, stantibus Moyse et Aaron,"
,"19":"et coacervasset Core adversum eos omne concilium ad ostium tabernaculi conventus, apparuit cunctis gloria Dornini."
,"20":"Locutusque Dominus ad Moysen et Aaron ait:"
,"21":"' Separamini de medio congregationis huius, ut eos repente disperdam '."
,"22":"Qui ceciderunt proni in faciem atque dixerunt: ' Deus, Deus spirituum universae carnis; num, uno peccante, contra omnes ira tua desaeviet? '."
,"23":"Et ait Dominus ad Moysen:"
,"24":"' Praecipe universo populo, ut separetur ab habitaculis Core et Dathan et Abiram '."
,"25":"Surrexitque Moyses et abiit ad Dathan et Abiram et, sequentibus eum senioribus Israel,"
,"26":"dixit ad turbam: ' Recedite ab habitaculis hominum impiorum et nolite tangere, quae ad eos pertinent, ne involvamini in peccatis eorum '."
,"27":"Cumque recessissent a tentoriis eorum per circuitum, Dathan et Abiram egressi stabant in introitu papilionum suorum cum uxoribus et filiis et parvulis."
,"28":"Et ait Moyses: ' In hoc scietis quod Dominus miserit me, ut facerem universa, quae cernitis, et non ex proprio ea corde protulerim:"
,"29":"si consueta hominum morte interierint, et visitaverit eos plaga, qua et ceteri visitari solent, non misit me Dominus."
,"30":"Sin autem novam rem fecerit Dominus, ut aperiens terra os suum deglutiat eos et omnia, quae ad illos pertinent, descenderintque viventes in infernum, scietis quod blasphemaverint Dominum '."
,"31":"Confestim igitur, ut cessavit loqui, dirupta est terra sub pedibus eorum"
,"32":"et aperiens os suum devoravit illos cum domibus suis et omnibus hominibus Core et universa substantia eorum;"
,"33":"descenderuntque vivi in infernum operti humo et perierunt de medio congregationis."
,"34":"At vero omnis Israel, qui stabat per gyrum, fugit ad clamorem pereuntium dicens: ' Ne forte et nos terra deglutiat '."
,"35":"Sed et ignis egressus a Domino interfecit ducentos quinquaginta viros, qui offerebant incensum."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Praecipe Eleazaro filio Aaron sacerdoti, ut tollat turibula, quae iacent in incendio, et ignem huc illucque dispergat, quoniam sanctificata sunt"
,"3":"in mortibus peccatorum; producatque ea in laminas et affigat altari, eo quod attulerunt ea Domino, et sanctificata sunt, ut sint pro signo filiis Israel '."
,"4":"Tulit ergo Eleazar sacerdos turibula aenea, in quibus obtulerant hi, quos incendium devoravit, et produxit ea in laminas affigens altari,"
,"5":"ut haberent postea filii Israel, quibus commonerentur, ne quis accedat alienigena et, qui non est de semine Aaron, ad offerendum incensum Domino, ne patiatur sicut passus est Core et omnis congregatio eius, loquente Domino ad Moysen."
,"6":"Murmuravit autem omnis congregatio filiorum Israel sequenti die contra Moysen et Aaron dicens: ' Vos interfecistis populum Domini '."
,"7":"Cumque oriretur seditio contra Moysen et Aaron, converterunt se ad tabernaculum conventus; quod operuit nubes, et apparuit gloria Domini."
,"8":"Moyses et Aaron venerunt ante tabernaculum conventus."
,"9":"Dixitque Dominus ad Moysen:"
,"10":"' Recedite de medio congregationis huius, nam extemplo delebo eos '. Et ceciderunt in faciem suam."
,"11":"Dixit Moyses ad Aaron: ' Tolle turibulum et, hausto igne de altari, mitte incensum desuper pergens cito ad populum, ut expies pro eis; iam enim egressa est ira a Domino, et plaga desaevit '."
,"12":"Quod cum fecisset Aaron et cucurrisset ad mediam congregationem, quam iam vastabat plaga, obtulit thymiama et expiavit pro populo;"
,"13":"et stetit inter mortuos ac viventes, et plaga cessavit."
,"14":"Fuerunt autem, qui percussi sunt, quattuordecim milia hominum et septingenti, absque his, qui perierant in seditione Core."
,"15":"Reversusque est Aaron ad Moysen ad ostium tabernaculi conventus, postquam quievit interitus."
,"16":"Et locutus est Dominus ad Moysen dicens:"
,"17":"' Loquere ad filios Israel et accipe ab eis virgas singulas per cognationes suas, a cunctis principibus tribuum virgas duodecim, et uniuscuiusque nomen superscribes virgae suae."
,"18":"Nomen autem Aaron scribes in virga Levi, et una virga cunctas seorsum familias continebit."
,"19":"Ponesque eas in tabernaculo conventus coram testimonio, ubi conveniam cum vobis."
,"20":"Quem ex his elegero, germinabit virga eius; et cohibebo a me querimonias filiorum Israel, quibus contra vos murmurant '."
,"21":"Locutusque est Moyses ad filios Israel, et dederunt ei omnes principes virgas per singulas tribus; fueruntque virgae duodecim, et virga Aaron in medio earum."
,"22":"Quas cum posuisset Moyses coram Domino in tabernaculo testimonii,"
,"23":"sequenti die regressus invenit germinasse virgam Aaron in domo Levi; et turgentibus gemmis eruperant flores, qui, foliis dilatatis, in amygdalas deformati sunt."
,"24":"Protulit ergo Moyses omnes virgas de conspectu Domini ad cunctos filios Israel; videruntque et receperunt singuli virgas suas."
,"25":"Dixitque Dominus ad Moysen: ' Refer virgam Aaron coram testimonio, ut servetur ibi in signum rebellium filiorum Israel, et quiescant querelae eorum a me, ne moriantur '."
,"26":"Fecitque Moyses, sicut praeceperat Dominus."
,"27":"Dixerunt autem filii Israel ad Moysen: ' Ecce consumpti sumus, perimus, omnes perimus!"
,"28":"Quicumque accedit ad habitaculum Domini, moritur. Num usque ad internecionem cuncti delendi sumus? '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Dixitque Dominus ad Aaron: ' Tu et filii tui et domus patris tui tecum portabitis iniquitatem sanctuarii; et tu et filii tui simul sustinebitis peccata sacerdotii vestri."
,"2":"Sed et fratres tuos de tribu Levi, tribum patris tui sume tecum, praestoque sint et ministrent tibi; tu autem et filii tui ministrabitis in tabernaculo testimonii."
,"3":"Excubabuntque Levitae ad praecepta tua et ad cuncta opera tabernaculi, ita dumtaxat ut ad vasa sanctuarii et ad altare non accedant, ne et illi moriantur, et vos pereatis simul."
,"4":"Sint autem tecum et excubent in custodiis tabernaculi conventus et in omni ministerio eius; alienigena non miscebitur vobis."
,"5":"Excubate in ministerio sanctuarii et in ministerio altaris, ne oriatur amplius indignatio super filios Israel."
,"6":"Ego sumpsi fratres vestros Levitas de medio filiorum Israel et tradidi donum Domino, ut serviant in ministeriis tabernaculi conventus."
,"7":"Tu autem et filii tui custodite sacerdotium vestrum et omnia, quae ad cultum altaris pertinent et intra velum sunt, administrabitis. Ministerium do vobis sacerdotium in donum; si quis externus accesserit, occidetur '."
,"8":"Locutusque est Dominus ad Aaron: ' Ecce dedi tibi custodiam praelibationum mearum. Omnia, quae sanctificantur a filiis Israel, tradidi tibi et filiis tuis pro officio sacerdotali, legitima sempiterna."
,"9":"Haec ergo accipies de sanctis sanctorum, exceptis his, quae comburuntur: omnis oblatio et sacrificium pro peccato atque delicto, quod redditur mihi, sanctum sanctorum tuum erit et filiorum tuorum."
,"10":"In sanctuario comedes illud; mares tantum edent ex eo, quia consecratum est tibi."
,"11":"Praelibationem donorum, quae elevando obtulerint filii Israel, tibi dedi et filiis tuis ac filiabus tuis iure perpetuo: qui mundus est in domo tua, vescetur eis."
,"12":"Omnem medullam olei et vini ac frumenti quidquid offerunt primitiarum Domino, tibi dedi."
,"13":"Universa frugum initia, quas gignit humus et Domino deportantur, cedent in usus tuos: qui mundus est in domo tua, vescetur eis."
,"14":"Omne, quod ex voto reddiderint filii Israel, tuum erit."
,"15":"Quidquid primum erumpit e vulva cunctae carnis, quod offerunt Domino, sive ex hominibus sive de pecoribus fuerit, tui iuris erit; ita dumtaxat, ut hominis primogenitum et omne animal, quod immundum est, redimi facias."
,"16":"Cuius redemptio erit post unum mensem siclis argenti quinque pondere sanctuarii. Siclus viginti obolos habet."
,"17":"Primogenitum autem bovis vel ovis vel caprae non facies redimi, quia sanctificata sunt Domino; sanguinem tantum eorum fundes super altare et adipes adolebis in suavissimum odorem Domino."
,"18":"Carnes vero eorum in usum tuum cedent, sicut pectusculum elevatum et armus dexter tua erunt."
,"19":"Omnes praelibationes sanctas, quas offerunt filii Israel Domino, tibi dedi et filiis ac filiabus tuis iure perpetuo: pactum salis est sempiternum coram Domino tibi ac filiis tuis '."
,"20":"Dixitque Dominus ad Aaron: ' In terra eorum nihil possidebitis nec habebitis partem inter eos: Ego pars et hereditas tua in medio filiorum Israel."
,"21":"Filiis autem Levi dedi omnes decimas Israelis in possessionem pro ministerio, quo serviunt mihi in tabernaculo conventus,"
,"22":"ut non accedant ultra filii Israel ad tabernaculum conventus nec committant peccatum mortiferum."
,"23":"Solis filiis Levi mihi in tabernaculo conventus servientibus et portantibus peccata populi; legitimum sempiternum erit in generationibus vestris, et in medio filiorum Israel nihil aliud possidebunt."
,"24":"Decimas, quas filii Israel in praelibationem elevant Domino, dedi Levitis in possessionem. Propterea dixi eis: In medio filiorum Israel non habebitis possessionem '."
,"25":"Locutusque est Dominus ad Moysen dicens:"
,"26":"' Praecipe Levitis atque denuntia: Cum acceperitis a filiis Israel decimas, quas dedi vobis, praelibationem earum elevabitis Domino, id est decimam partem decimae,"
,"27":"ut reputetur vobis in praelibationem tam de areis quam de torcularibus."
,"28":"Sic de universis, quorum accipitis primitias a filiis Israel, elevate Domino: date Aaron sacerdoti."
,"29":"Omnia, quae offeretis ex decimis, in donaria Domini separabitis: optima et electa erunt."
,"30":"Dicesque ad eos: Si praeclara et meliora quaeque obtuleritis ex decimis, reputabitur vobis quasi de area et torculari dederitis fructus;"
,"31":"et comedetis eas in omnibus locis vestris, tam vos quam familiae vestrae, quia pretium est pro ministerio, quo servitis in tabernaculo conventus."
,"32":"Et non peccabitis super hoc egregia vobis et pinguia reservantes, ne polluatis oblationes filiorum Israel et moriamini '."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Locutusque est Dominus ad Moysen et Aaron dicens:"
,"2":"' Ista est religio legis, quam constituit Dominus. Praecipe filiis Israel, ut adducant ad te vaccam rufam aetatis integrae, in qua nulla sit macula, nec portaverit iugum."
,"3":"Tradetisque eam Eleazaro sacerdoti, quae educta extra castra mactabitur in conspectu eius;"
,"4":"et tinguens digitum in sanguine eius asperget contra fores tabernaculi conventus septem vicibus,"
,"5":"combureturque in conspectu eius, tam pelle et carnibus eius quam sanguine et fimo flammae traditis."
,"6":"Lignum quoque cedrinum et hyssopum coccumque sacerdos mittet in flammam, quae vaccam vorat."
,"7":"Et tunc demum, lotis vestibus et corpore suo, ingredietur in castra commaculatusque erit usque ad vesperum."
,"8":"Sed et ille, qui combusserit eam, lavabit vestimenta sua et corpus, et immundus erit usque ad vesperum."
,"9":"Colliget autem vir mundus cineres vaccae et effundet eos extra castra in loco purissimo, ut sint congregationi filiorum Israel in custodiam pro aqua aspersionis."
,"10":"Cumque laverit, qui vaccae portaverat cineres, vestimenta sua, immundus erit usque ad vesperum. Habebunt hoc filii Israel et advenae, qui habitant inter eos, sanctum iure perpetuo."
,"11":"Qui tetigerit cadaver hominis et propter hoc septem diebus fuerit immundus,"
,"12":"aspergetur ex hac aqua die tertio et septimo et sic mundabitur. Si die tertio aspersus non fuerit, septimo non erit mundus."
,"13":"Omnis, qui tetigerit humanae animae morticinum et aspersus hac commixtione non fuerit, polluet habitaculum Domini et peribit ex Israel, quia aqua expiationis non est aspersus: immundus erit, et manebit spurcitia eius super eum."
,"14":"Ista est lex hominis, qui moritur in tabernaculo: omnes, qui ingrediuntur tentorium illius, et universa vasa, quae ibi sunt, polluta erunt septem diebus."
,"15":"Vas, quod non habuerit operculum nec ligaturam desuper, immundum erit."
,"16":"Si quis in agro tetigerit cadaver hominis gladio occisi aut per se mortui sive os illius vel sepulcrum, immundus erit septem diebus."
,"17":"Tollentque de cineribus combustionis peccati et mittent aquas vivas super eos in vas;"
,"18":"in quibus cum homo mundus tinxerit hyssopum, asperget ex eo omne tentorium et cunctam supellectilem et homines, qui ibi fuerint, et super eum, qui tetigerit ossa vel occisum hominem aut per se mortuum aut sepultum."
,"19":"Atque hoc modo mundus lustrabit immundum tertio et septimo die; expiatusque die septimo lavabit et se et vestimenta sua et mundus erit ad vesperum."
,"20":"Si quis hoc ritu non fuerit expiatus, peribit anima illius de medio ecclesiae, quia sanctuarium Domini polluit et non est aqua lustrationis aspersus; immundus est."
,"21":"Erit vobis praeceptum legitimum sempiternum. Ipse quoque, qui aspergit aqua lustrali, lavabit vestimenta sua; omnis, qui tetigerit aquas expiationis, immundus erit usque ad vesperum."
,"22":"Quidquid tetigerit immundus, immundum erit, et anima, quae horum quippiam tetigerit, immunda erit usque ad vesperum '."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Veneruntque filii Israel et omnis congregatio in de sertum Sin mense primo, et mansit populus in Cades. Mortuaque est ibi Maria et sepulta in eodem loco."
,"2":"Cumque indigeret aqua populus, convenerunt adversum Moysen et Aaron"
,"3":"et versi in seditionem dixerunt: ' Utinam perissemus inter fratres nostros coram Domino!"
,"4":"Cur eduxistis ecclesiam Domini in solitudinem, ut et nos et nostra iumenta moriamur?"
,"5":"Quare nos fecistis ascendere de Aegypto et adduxistis in locum istum pessimum, qui seri non potest, qui nec ficum gignit nec vineas nec malogranata, insuper et aquam non habet ad bibendum? '."
,"6":"Venitque Moyses et Aaron, relicta congregatione, ad introitum tabernaculi conventus corrueruntque proni in terram, et apparuit gloria Domini super eos."
,"7":"Locutusque est Dominus ad Moysen dicens:"
,"8":"' Tolle virgam et congrega populum, tu et Aaron frater tuus; et loquimini ad petram coram eis, et illa dabit aquas. Cumque eduxeris aquam de petra, potabis congregationem et iumenta eius '."
,"9":"Tulit igitur Moyses virgam, quae erat in conspectu Domini, sicut praeceperat ei."
,"10":"Et congregaverunt Moyses et Aaron populum ante petram, dixitque eis: ' Audite, rebelles; num de petra hac vobis aquam poterimus eicere? '."
,"11":"Cumque elevasset Moyses manum percutiens virga bis silicem, egressae sunt aquae largissimae, ita ut populus biberet et iumenta."
,"12":"Dixitque Dominus ad Moysen et Aaron: ' Quia non credidistis mihi, ut sanctificaretis me coram filiis Israel, non introducetis hos populos in terram, quam dabo eis '."
,"13":"Hae sunt aquae Meriba, ubi iurgati sunt filii Israel contra Dominum, et sanctificatus est in eis."
,"14":"Misit nuntios Moyses de Cades ad regem Edom, qui dicerent: ' Haec mandat frater tuus Israel: Nosti omnem laborem, qui apprehendit nos,"
,"15":"quomodo descenderint patres nostri in Aegyptum, et habitaverimus ibi multo tempore, afflixerintque nos Aegyptii et patres nostros,"
,"16":"et quomodo clamaverimus ad Dominum, et exaudierit nos miseritque angelum, qui eduxerit nos de Aegypto. Ecce nos in urbe Cades, quae est in extremis finibus tuis, positi"
,"17":"obsecramus, ut nobis transire liceat per terram tuam: non ibimus per agros nec per vineas, non bibemus aquas de puteis tuis; sed gradiemur via regia, nec ad dexteram nec ad sinistram declinantes, donec transeamus terminos tuos '."
,"18":"Cui respondit Edom: ' Non transibis per me, alioquin armatus occurram tibi '."
,"19":"Dixeruntque filii Israel: ' Per tritam gradiemur viam et, si biberimus aquas tuas ego et pecora mea, dabo, quod iustum est: nulla erit in pretio difficultas; tantum velociter transeamus '."
,"20":"At ille respondit: ' Non transibis! '. Statimque egressus est obvius cum infinita multitudine et manu forti"
,"21":"nec voluit acquiescere Israeli, ut concederet transitum per fines suos; quam ob rem divertit ab eo Israel."
,"22":"Cumque castra movissent de Cades, venerunt in montem Hor,"
,"23":"ubi locutus est Dominus ad Moysen et Aaron in monte Hor, qui est in finibus terrae Edom:"
,"24":"' Congregabitur, inquit, Aaron ad populum suum. Non enim intrabit terram, quam dedi filiis Israel, eo quod rebelles fuistis ori meo ad aquas Meriba."
,"25":"Tolle Aaron et Eleazarum filium eius cum eo et duces eos in montem Hor."
,"26":"Cumque nudaveris patrem veste sua, indues ea Eleazarum filium eius: Aaron colligetur et morietur ibi '."
,"27":"Fecit Moyses, ut praeceperat Dominus, et ascenderunt in montem Hor coram omni congregatione."
,"28":"Cumque Aaron spoliasset vestibus suis, induit eis Eleazarum filium eius. Illo mortuo in montis supercilio, descendit cum Eleazaro."
,"29":"Omnis autem congregatio videns occubuisse Aaron flevit super eo triginta diebus tota domus Israel."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Quod cum audisset Chana naeus rex Arad, qui habita bat in Nageb, venisse scilicet Israel per viam Atarim, pugnavit contra illum et duxit ex eo captivos."
,"2":"At Israel voto se Domino obligans ait: ' Si tradideris populum istum in manu mea, delebo urbes eius '."
,"3":"Exaudivitque Dominus preces Israel et tradidit Chananaeum, quem ille interfecit, subversis urbibus eius, et vocavit nomen loci illius Horma."
,"4":"Profecti sunt autem et de monte Hor per viam, quae ducit ad mare Rubrum, ut circumirent terram Edom. Et taedere coepit populum itineris."
,"5":"Locutusque contra Deum et Moysen ait: ' Cur eduxisti nos de Aegypto, ut moreremur in solitudine? Deest panis, non sunt aquae; anima nostra iam nauseat super cibo isto levissimo '."
,"6":"Quam ob rem misit Dominus in populum ignitos serpentes, qui mordebant populum, et mortuus est populus multus ex Israel."
,"7":"Et venerunt ad Moysen atque dixerunt: ' Peccavimus, quia locuti sumus contra Dominum et te; ora, ut tollat a nobis serpentes '. Oravitque Moyses pro populo."
,"8":"Et locutus est Dominus ad eum: ' Fac serpentem ignitum et pone eum pro signo: qui percussus aspexerit eum, vivet '."
,"9":"Fecit ergo Moyses serpentem aeneum et posuit eum pro signo; quem cum percussi aspicerent, sanabantur."
,"10":"Profectique filii Israel castrametati sunt in Oboth,"
,"11":"unde egressi fixere tentoria in Ieabarim, in solitudine, quae respicit Moab contra orientalem plagam."
,"12":"Et inde moventes venerunt ad torrentem Zared;"
,"13":"quem relinquentes castrametati sunt ultra Arnon, qui est in deserto, quod prominet de finibus Amorraei. Siquidem Arnon terminus est Moab dividens Moabitas et Amorraeos."
,"14":"Unde dicitur in libro bellorum Domini: ' Vaheb in Supha,et torrentes Arnon."
,"15":"Scopuli torrentium inclinati sunt,in habitationem Ar,et recumbunt in finibus Moabitarum '."
,"16":"Ex eo loco in Beer. Hic est puteus, super quo locutus est Dominus ad Moysen: ' Congrega populum, et dabo ei aquam '."
,"17":"Tunc cecinit Israel carmen istud: ' Ascendat puteus. Concinite ei."
,"18":"Puteus, quem foderunt principes,et paraverunt duces populi,in sceptris et in baculis suis '. De solitudine in Matthana; "
,"19":"de Matthana in Nahaliel; de Nahaliel in Bamoth;"
,"20":"de Bamoth in vallem, quae est in regione Moab in vertice Phasga, qui respicit contra desertum."
,"21":"Misit autem Israel nuntios ad Sehon regem Amorraeorum dicens:"
,"22":"' Obsecro, ut transire mihi liceat per terram tuam: non declinabimus in agros et vineas, non bibemus aquas ex puteis. Via regia gradiemur, donec transeamus terminos tuos '."
,"23":"Qui concedere noluit, ut transiret Israel per fines suos; quin potius, populo congregato, egressus est obviam in desertum et venit in Iasa pugnavitque contra Israel."
,"24":"A quo percussus est in ore gladii, et possessa est terra eius ab Arnon usque Iaboc et filios Ammon; quia forti praesidio tenebantur termini Ammonitarum."
,"25":"Tulit ergo Israel omnes civitates eius et habitavit in urbibus Amorraei, in Hesebon scilicet et viculis eius."
,"26":"Hesebon enim erat urbs Sehon regis Amorraei, qui pugnavit contra primum regem Moab et tulit omnem terram, quae dicionis illius fuerat usque Arnon."
,"27":"Idcirco dicitur in proverbio: ' Venite in Hesebon!,Aedificetur et construatur civitas Sehon!"
,"28":"Ignis egressus est de Hesebon, flamma de oppido Sehon,et devoravit Ar Moabitarum,et deglutivit excelsa Arnon."
,"29":"Vae tibi, Moab; peristi, popule Chamos!,Dedit filios eius in fugam,et filias in captivitatem,regi Amorraeorum Sehon."
,"30":"Iecimus sagittas in eos, disperiit Hesebon usque Dibon. Vastavimus usque Nophe,et usque Medaba '."
,"31":"Habitavit itaque Israel in terra Amorraei."
,"32":"Misitque Moyses, qui explorarent Iazer, cuius ceperunt viculos et expulerunt Amorraeos, qui erant ibi."
,"33":"Verteruntque se et ascenderunt per viam Basan, et occurrit eis Og rex Basan cum omni populo suo pugnaturus in Edrai."
,"34":"Dixitque Dominus ad Moysen: ' Ne timeas eum, quia in manu tua tradidi illum et omnem populum ac terram eius, faciesque illi, sicut fecisti Sehon regi Amorraeorum habitatori Hesebon '."
,"35":"Percusserunt igitur et hunc cum filiis suis universumque populum eius usque ad internecionem; et possederunt terram illius."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Profectique castrametati sunt filii Israel in campestri bus Moab, ubi trans Iordanem Iericho sita est."
,"2":"Videns autem Balac filius Sephor omnia, quae fecerat Israel Amorraeo,"
,"3":"valde metuit Moab populum, quia multus erat. Et cum pertimeret Moab filios Israel,"
,"4":"dixit ad maiores natu Madian: ' Nunc carpet haec congregatio omnem regionem per circuitum, quomodo solet bos herbas campi carpere '. Balac filius Sephor erat eo tempore rex in Moab. "
,"5":"Misit ergo nuntios ad Balaam filium Beor in Phethor, quae est super flumen in terra filiorum Ammau, ut vocarent eum et dicerent: ' Ecce egressus est populus ex Aegypto, qui operuit superficiem terrae sedens contra me."
,"6":"Veni igitur et maledic populo huic, quia fortior me est; si quo modo possim percutere et eicere eum de terra mea. Novi enim quod benedictus sit, cui benedixeris, et maledictus, in quem maledicta congesseris '."
,"7":"Perrexeruntque seniores Moab et maiores natu Madian habentes divinationis pretium in manibus. Cumque venissent ad Balaam et narrassent ei omnia verba Balac,"
,"8":"ille respondit: ' Manete hic nocte, et respondebo quidquid mihi dixerit Dominus '. Manentibus illis apud Balaam,"
,"9":"venit Deus et ait ad eum: ' Quid sibi volunt homines isti apud te? '."
,"10":"Respondit: ' Balac filius Sephor rex Moabitarum misit ad me"
,"11":"dicens: 'Ecce populus, qui egressus est de Aegypto, operuit superficiem terrae; veni et maledic ei pro me, si quo modo possim pugnans abigere eum'."
,"12":"Dixitque Deus ad Balaam: 'Noli ire cum eis neque maledicas populo, quia benedictus est '."
,"13":"Qui mane consurgens dixit ad principes: ' Ite in terram vestram, quia prohibuit me Dominus venire vobiscum '."
,"14":"Reversi principes dixerunt ad Balac: ' Noluit Balaam venire nobiscum '."
,"15":"Rursum ille multo plures et nobiliores, quam ante miserat, misit."
,"16":"Qui cum venissent ad Balaam, dixerunt: ' Sic dicit Balac filius Sephor: 'Ne cuncteris venire ad me;"
,"17":"paratus sum honorare te et, quidquid volueris, dabo tibi. Veni et maledic pro me populo isti' '."
,"18":"Respondit Balaam: ' Si dederit mihi Balac plenam domum suam argenti et auri, non potero transgredi verbum Domini Dei mei, ut vel plus vel minus loquar."
,"19":"Obsecro, ut hic maneatis etiam hac nocte, et scire queam quid mihi rursum respondeat Dominus '."
,"20":"Venit ergo Deus ad Balaam nocte et ait ei: ' Si vocare te venerunt homines isti, surge et vade cum eis, ita dumtaxat, ut, quod tibi praecepero, facias '."
,"21":"Surrexit Balaam mane et, strata asina sua, profectus est cum eis."
,"22":"Et iratus est Deus, cum profectus esset; stetitque angelus Domini in via contra Balaam, ut adversaretur ei, qui insidebat asinae et duos pueros habebat secum."
,"23":"Cernens asina angelum Domini stantem in via, evaginato gladio in manu sua, avertit se de itinere et ibat per agrum. Quam cum verberaret Balaam et vellet ad semitam reducere,"
,"24":"stetit angelus Domini in angustiis duarum maceriarum, quibus vineae cingebantur."
,"25":"Quem videns asina iunxit se parieti et attrivit sedentis pedem. At ille iterum verberabat eam;"
,"26":"et angelus Domini iterum transiens ad locum angustum, ubi nec ad dexteram nec ad sinistram poterat deviare, obvius stetit."
,"27":"Cumque vidisset asina stantem angelum Domini, concidit sub pedibus sedentis; qui iratus vehementius caedebat fuste latera eius."
,"28":"Aperuitque Dominus os asinae, et locuta est: ' Quid feci tibi? Cur percutis me ecce iam tertio? '."
,"29":"Respondit Balaam: ' Quia illusisti mihi. Utinam haberem gladium, ut te interficerem! '."
,"30":"Dixit asina: ' Nonne animal tuum sum, cui semper sedere consuevisti usque in praesentem diem? Dic quid simile umquam fecerim tibi '. At ille ait: ' Numquam '."
,"31":"Protinus aperuit Dominus oculos Balaam, et vidit angelum Domini stantem in via, evaginato gladio in manu eius; adoravitque eum pronus in terram."
,"32":"Cui angelus Domini: ' Cur, inquit, tertio verberas asinam tuam? Ego veni, ut adversarer tibi, quia perversa est via tua mihique contraria."
,"33":"Et videns me asina declinavit ter a me; nisi declinasset, te occidissem et illam vivam reliquissem '."
,"34":"Dixit Balaam: ' Peccavi nesciens quod tu stares contra me in via; et nunc, si displicet tibi, revertar '."
,"35":"Ait angelus Domini: ' Vade cum istis et cave, ne aliud, quam praecepero tibi, loquaris '. Ivit igitur cum principibus Balac."
,"36":"Quod cum audisset Balac, venisse scilicet Balaam, egressus est in occursum eius in Irmoab, quod situm est in extremis finibus Arnon;"
,"37":"dixitque ad Balaam: ' Nonne misi nuntios, ut vocarem te? Cur non statim venisti ad me? An quia honorare te nequeo? '."
,"38":"Cui ille respondit: ' Ecce adsum; numquid loqui potero aliud, nisi quod Deus posuerit in ore meo? '."
,"39":"Perrexerunt ergo simul et venerunt in Cariathusoth."
,"40":"Cumque occidisset Balac boves et oves, misit ad Balaam et principes, qui cum eo erant."
,"41":"Mane autem facto, duxit eum ad excelsa Baal et intuitus est extremam partem populi."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Dixitque Balaam ad Balac: ' Aedifica mihi hic septem aras et para totidem vitulos eiusdemque numeri arietes '."
,"2":"Cumque fecisset iuxta sermonem Balaam, imposuerunt vitulum et arietem super aram."
,"3":"Dixitque Balaam ad Balac: ' Sta paulisper iuxta holocaustum tuum, donec vadam, si forte occurrat mihi Dominus; et, quodcumque imperaverit, loquar tibi '. Cumque abiisset in collem nudum,"
,"4":"occurrit illi Deus. Locutusque ad eum Balaam: ' Septem, inquit, aras erexi et imposui vitulum et arietem desuper '."
,"5":"Dominus autem posuit verbum in ore eius et ait: ' Revertere ad Balac et haec loqueris '."
,"6":"Reversus invenit stantem Balac iuxta holocaustum suum et omnes principes Moabitarum;"
,"7":"assumptaque parabola sua, dixit: ' De Aram adduxit me Balac, rex Moabitarum de montibus orientis: 'Veni, inquit, et maledic pro me Iacob; propera et detestare Israel!'."
,"8":"Quomodo maledicam, cui non maledixit Deus?,Qua ratione detester, quem Dominus non detestatur?"
,"9":"De summis silicibus video eum,et de collibus considero illum: populus solus habitabit,et inter gentes non reputabitur."
,"10":"Et quis dinumerare possit pulverem Iacob,et quis numeravit arenam Israel?,Moriatur anima mea morte iustorum, et fiant novissima mea horum similia '."
,"11":"Dixitque Balac ad Balaam: ' Quid est hoc, quod agis? Ut malediceres inimicis meis, vocavi te, et tu e contrario benedicis eis! '."
,"12":"Cui ille respondit: ' Num aliud possum loqui, nisi quod iusserit Dominus? '."
,"13":"Dixit ergo Balac: ' Veni mecum in alterum locum, unde partem Israel videas et totum videre non possis; inde maledicito ei '."
,"14":"Cumque duxisset eum in campum speculatorum super verticem montis Phasga, aedificavit septem aras imposuitque supra vitulum atque arietem."
,"15":"Et dixit Balaam ad Balac: ' Sta hic iuxta holocaustum tuum, donec ego obvius pergam '."
,"16":"Cui cum Dominus occurrisset posuissetque verbum in ore eius, ait: ' Revertere ad Balac et haec loqueris ei '."
,"17":"Reversus invenit eum stantem iuxta holocaustum suum et principes Moabitarum cum eo. Ad quem Balac: ' Quid, inquit, locutus est Dominus? '."
,"18":"At ille, assumpta parabola sua, ait: ' Surge, Balac, et ausculta; audi, fili Sephor."
,"19":"Non est Deus quasi homo, ut mentiatur, nec ut filius hominis, ut mutetur. Numquid dixit et non faciet?,Locutus est et non implebit?"
,"20":"Ad benedicendum adductus sum, benedictionem prohibere non valeo. "
,"21":"Non conspicitur malum in Iacob, nec videtur calamitas in Israel. Dominus Deus eius cum eo est, et clangor regis in illo."
,"22":"Deus eduxit illum de Aegypto, sicut cornua bubali est ei."
,"23":"Non est augurium in Iacob, nec divinatio in Israel. Temporibus suis dicetur Iacob et Israeli,quid operatus sit Deus."
,"24":"Ecce populus ut leaena consurget, et quasi leo erigetur; non accubabit, donec devoret praedam,et occisorum sanguinem bibat '."
,"25":"Dixitque Balac ad Balaam: ' Nec maledicas ei, nec benedicas! '."
,"26":"Et ille ait: ' Nonne dixi tibi quod, quidquid mihi Dominus imperaret, hoc facerem? '."
,"27":"Et ait Balac ad eum: ' Veni, et ducam te ad alîum locum, si forte placeat Deo, ut inde maledicas ei '."
,"28":"Cumque duxisset eum super verticem montis Phegor, qui respicit solitudinem,"
,"29":"dixit ei Balaam: ' Aedifica mihi hic septem aras et para totidem vitulos eiusdemque numeri arietes '."
,"30":"Fecit Balac, ut Balaam dixerat, imposuitque vitulos et arietes per singulas aras."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Cumque vidisset Balaam quod placeret Domino, ut be nediceret Israeli, nequaquam abiit, ut ante perrexerat, ut augurium quaereret; sed dirigens contra desertum vultum suum"
,"2":"et elevans oculos vidit Israel commorantem per tribus suas et, irruente in se spiritu Dei,"
,"3":"assumpta parabola sua, ait: ' Dixit Balaam filius Beor, dixit homo, cuius apertus est oculus,"
,"4":"dixit auditor sermonum Dei, qui visionem Omnipotentis intuitus est, qui cadit, et sic aperiuntur oculi eius."
,"5":"Quam pulchra tabernacula tua, Iacob, et tentoria tua, Israel!"
,"6":"Ut valles dilatantur, ut horti iuxta fluvios irrigui, ut aloe, quam plantavit Dominus, quasi cedri prope aquas."
,"7":"Fluet aqua de situlis eius, et semen illius erit in aquis multis. Extolletur super Agag rex eius, et elevabitur regnum illius."
,"8":"Deus eduxit illum de Aegypto, sicut cornua bubali est ei. Devorabit gentes, hostes suos, ossaque eorum confringet,et perforabit sagittis."
,"9":"Accubans dormit ut leo, et quasi leaena, quis suscitare illum audebit?,Qui benedixerit tibi, erit et ipse benedictus; qui maledixerit tibi, maledictus erit! '."
,"10":"Iratusque Balac contra Balaam, complosis manibus, ait: ' Ad maledicendum inimicis meis vocavi te, quibus iam tertio benedixisti!"
,"11":"Revertere nunc ad locum tuum! Decreveram quidem magnifice honorare te, sed Dominus privavit te honore disposito '."
,"12":"Respondit Balaam ad Balac: ' Nonne iam nuntiis tuis, quos misisti ad me, dixi:"
,"13":"Si dederit mihi Balac plenam domum suam argenti et auri, non potero praeterire sermonem Domini, ut vel boni quid vel mali proferam ex corde meo, sed, quidquid Dominus dixerit, hoc loquar?"
,"14":"Et nunc, pergens ad populum meum dabo consilium, quid populus hic populo tuo faciat extremo tempore '."
,"15":"Sumpta igitur parabola sua, rursum ait: ' Dixit Balaam filius Beor, dixit homo, cuius apertus est oculus, "
,"16":"dixit auditor sermonum Dei, qui novit doctrinam Altissimi,et visiones Omnipotentis videt, qui cadens apertos habet oculos."
,"17":"Video eum, sed non modo; intueor illum, sed non prope. Oritur stella ex Iacob, et consurgit virga de Israel; et percutit tempora Moab,et verticem omnium filiorum Seth. "
,"18":"Et erit Idumaea possessio eius, et hereditas eius Seir, inimicus eius; Israel vero fortiter aget."
,"19":"De Iacob erit, qui dominetur,et perdat reliquias civitatis '."
,"20":"Cumque vidisset Amalec, assumens parabolam suam ait: ' Principium gentium Amalec, cuius extrema perdentur '."
,"21":"Vidit quoque Cinaeum et, assumpta parabola sua, ait: ' Robustum quidem est habitaculum tuum, et in petra positus nidus tuus."
,"22":"Erit in combustionem Cain, donec Assur capiat te '."
,"23":"Assumptaque parabola sua, iterum locutus est: ' Heu! Quis vivet, quando ista faciet Deus?"
,"24":"Venient naves de Cetthim, superabunt Assyrios vastabuntque Heber; et ad extremum etiam ipsi peribunt '. Surrexitque Balaam et reversus est in locum suum; Balac quoque via, qua venerat, rediit."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Morabatur autem Israel in Settim, et incepit populus fornicari cum filiabus Moab,"
,"2":"quae vocaverunt populum ad sacrificia deorum suorum. Et illi comederunt et adoraverunt deos earum;"
,"3":"et adhaesit Israel Baalphegor. Et iratus Dominus"
,"4":"ait ad Moysen: ' Tolle cunctos principes populi et suspende eos coram Domino contra solem in patibulis, ut avertatur furor meus ab Israel '."
,"5":"Dixitque Moyses ad iudices Israel: ' Occidat unusquisque proximos suos, qui adhaeserunt Baalphegor '."
,"6":"Et ecce unus de filiis Israel intravit coram fratribus suis ad Madianitin, vidente Moyse et omni turba filiorum Israel, qui flebant ante fores tabernaculi conventus."
,"7":"Quod cum vidisset Phinees filius Eleazari filii Aaron sacerdotis, surrexit de medio congregationis et, arrepta lancea,"
,"8":"ingressus est post virum Israelitem in cubiculum et perfodit ambos simul, virum scilicet et mulierem, in locis genitalibus; cessavitque plaga a filiis Israel."
,"9":"Et occisi sunt viginti quattuor milia hominum."
,"10":"Dixitque Dominus ad Moysen:"
,"11":"' Phinees filius Eleazari filii Aaron sacerdotis avertit iram meam a filiis Israel, quia zelo meo commotus est in medio eorum, ut non ipse delerem filios Israel in zelo meo."
,"12":"Idcirco loquere ad eum: Ecce do ei pacem foederis mei,"
,"13":"et erit tam ipsi quam semini eius pactum sacerdotii sempiternum, quia zelatus est pro Deo suo et expiavit scelus filiorum Israel '."
,"14":"Erat autem nomen viri Israelitae, qui occisus est cum Madianitide, Zamri filius Salu dux de cognatione et tribu Simeonis;"
,"15":"porro mulier Madianitis, quae pariter interfecta est, vocabatur Cozbi filia Sur principis tribus in Madian."
,"16":"Locutusque est Dominus ad Moysen dicens:"
,"17":"' Pugnate contra Madianitas et percutite eos,"
,"18":"quia ipsi hostiliter egerunt contra vos et decepere insidiis per idolum Phegor et in negotio Cozbi filiae ducis Madian sororis eorum, quae percussa est in die plagae pro sacrilegio Phegor '."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Post hanc plagam dixit Do minus ad Moysen et Eleaza rum filium Aaron sacerdotem:"
,"2":"' Numerate summam totius congregationis filiorum Israel a viginti annis et supra per domos et cognationes suas, cunctos, qui possunt ad bella procedere '."
,"3":"Locuti sunt itaque Moyses et Eleazar sacerdos in campestribus Moab super Iordanem contra Iericho ad eos, qui erant"
,"4":"a viginti annis et supra, sicut Dominus imperaverat Moysi. Filiorum Israel, qui egressi sunt de terra Aegypti, iste est numerus."
,"5":"Ruben primogenitus Israel. Huius filius Henoch, a quo familia Henochitarum, et Phallu, a quo familia Phalluitarum,"
,"6":"et Hesron, a quo familia Hesronitarum, et Charmi, a quo familia Charmitarum."
,"7":"Hae sunt familiae de stirpe Ruben, quarum numerus inventus est quadraginta tria milia et septingenti triginta."
,"8":"Filius Phallu: Eliab."
,"9":"Huius filii: Namuel et Dathan et Abiram. Isti sunt Dathan et Abiram principes populi, qui surrexerunt contra Moysen et Aaron in seditione Core, quando adversus Dominum rebellaverunt,"
,"10":"et aperiens terra os suum devoravit eos et Core, morientibus plurimis, quando combussit ignis ducentos quinquaginta viros; et facti sunt in signum."
,"11":"Core pereunte, filii illius non perierunt."
,"12":"Filii Simeon per cognationes suas: Namuel, ab hoc familia Namuelitarum; Iamin, ab hoc familia Iaminitarum; Iachin, ab hoc familia Iachinitarum;"
,"13":"Zara, ab hoc familia Zaraitarum; Saul, ab hoc familia Saulitarum."
,"14":"Hae sunt familiae de stirpe Simeon, quarum omnis numerus fuit viginti duo milia ducenti."
,"15":"Filii Gad per cognationes suas: Sephon, ab hoc familia Sephonitarum; Haggi, ab hoc familia Haggitarum; Suni, ab hoc familia Sunitarum;"
,"16":"Ozni, ab hoc familia Oznitarum; Heri, ab hoc familia Heritarum;"
,"17":"Arodi, ab hoc familia Aroditarum; Areli, ab hoc familia Arelitarum."
,"18":"Istae sunt familiae Gad, quarum omnis numerus fuit quadraginta milia quingenti."
,"19":"Filii Iudae Her et Onan, qui ambo mortui sunt in terra Chanaan."
,"20":"Fueruntque filii Iudae per cognationes suas: Sela, a quo familia Selanitarum; Phares, a quo familia Pharesitarum; Zara, a quo familia Zaraitarum."
,"21":"Porro filii Phares: Esrom, a quo familia Esromitarum; et Hamul, a quo familia Hamulitarum."
,"22":"Istae sunt familiae Iudae, quarum omnis numerus fuit septuaginta sex milia quingenti."
,"23":"Filii Issachar per cognationes suas: Thola, a quo familia Tholaitarum; Phua, a quo familia Phuaitarum;"
,"24":"Iasub, a quo familia Iasubitarum; Semron, a quo familia Semronitarum."
,"25":"Hae sunt cognationes Issachar, quarum numerus fuit sexaginta quattuor milia trecenti."
,"26":"Filii Zabulon per cognationes suas: Sared, a quo familia Sareditarum; Elon, a quo familia Elonitarum; Iahelel, a quo familia Iahelelitarum."
,"27":"Hae sunt cognationes Zabulon, quarum numerus fuit sexaginta milia quingenti."
,"28":"Filii Ioseph per cognationes suas: Manasse et Ephraim."
,"29":"De Manasse ortus est Machir, a quo familia Machiritarum; Machir genuit Galaad, a quo familia Galaaditarum."
,"30":"Galaad habuit filios: Iezer, a quo familia Iezeritarum; et Helec, a quo familia Helecitarum;"
,"31":"et Asriel, a quo familia Asrielitarum; et Sechem, a quo familia Sechemitarum;"
,"32":"et Semida, a quo familia Semidaitarum; et Hepher, a quo familia Hepheritarum."
,"33":"Fuit autem Hepher pater Salphaad, qui filios non habebat sed tantum filias, quarum ista sunt nomina: Maala et Noa et Hegla et Melcha et Thersa."
,"34":"Hae sunt familiae Manasse, et numerus earum quinquaginta duo milia septingenti."
,"35":"Filii autem Ephraim per cognationes suas fuerunt hi: Suthala, a quo familia Suthalaitarum; Becher, a quo familia Becheritarum; Thehen, a quo familia Thehenitarum."
,"36":"Porro filius Suthala fuit Heran, a quo familia Heranitarum."
,"37":"Hae sunt cognationes filiorum Ephraim, quarum numerus fuit triginta duo milia quingenti. Isti sunt filii Ioseph per familias suas."
,"38":"Filii Beniamin in cognationibus suis: Bela, a quo familia Belaitarum; Asbel, a quo familia Asbelitarum; Ahiram, a quo familia Ahiramitarum;"
,"39":"Supham, a quo familia Suphamitarum; Hupham, a quo familia Huphamitarum."
,"40":"Filii Bela: Ared et Naaman; de Ared familia Areditarum, de Naaman familia Naamanitarum."
,"41":"Hi sunt filii Beniamin per cognationes suas, quorum numerus fuit quadraginta quinque milia sescenti."
,"42":"Filii Dan per cognationes suas: Suham, a quo familia Suhamitarum. Hae sunt cognationes Dan per familias suas:"
,"43":"omnes fuere Suhamitae, quorum numerus erat sexaginta quattuor milia quadringenti."
,"44":"Filii Aser per cognationes suas: Iemna, a quo familia Iemnaitarum; Isui, a quo familia Isuitarum; Beria, a quo familia Beriaitarum."
,"45":"Filii Beria: Heber, a quo familia Heberitarum, et Melchiel a quo familia Melchielitarum."
,"46":"Nomen autem filiae Aser fuit Sara."
,"47":"Hae cognationes filiorum Aser, et numerus eorum quinquaginta tria milia quadringenti."
,"48":"Filii Nephthali per cognationes suas: Iasiel, a quo familia Iasielitarum; Guni, a quo familia Gunitarum;"
,"49":"Ieser, a quo familia Ieseritarum; Sellem, a quo familia Sellemitarum."
,"50":"Hae sunt cognationes filiorum Nephthali per familias suas, quorum numerus quadraginta quinque milia quadringenti."
,"51":"Ista est summa filiorum Israel qui recensiti sunt: sescenta milia et mille septingenti triginta."
,"52":"Locutusque est Dominus ad Moysen dicens:"
,"53":"' Istis dividetur terra iuxta numerum vocabulorum in possessiones suas."
,"54":"Pluribus maiorem partem dabis et paucioribus minorem: singulis, sicut nunc recensiti sunt, tradetur possessio;"
,"55":"ita dumtaxat, ut sors terram dividat. Secundum numerum tribuum patrum suorum hereditabunt."
,"56":"Quidquid sorte contigerit, hoc vel plures accipiant vel pauciores."
,"57":"Hic quoque est numerus filiorum Levi per familias suas: Gerson, a quo familia Gersonitarum; Caath, a quo familia Caathitarum; Merari, a quo familia Meraritarum."
,"58":"Hae sunt familiae Levi: familia Lobni, familia Hebroni, familia Moholi, familia Musi, familia Core. At vero Caath genuit Amram,"
,"59":"qui habuit uxorem Iochabed filiam Levi, quae nata est ei in Aegypto. Haec genuit Amram viro suo filios, Aaron et Moysen et Mariam sororem eorum."
,"60":"De Aaron orti sunt Nadab et Abiu et Eleazar et Ithamar,"
,"61":"quorum Nadab et Abiu mortui sunt, cum obtulissent ignem alienum coram Domino."
,"62":"Fueruntque omnes, qui numerati sunt, viginti tria milia generis masculini ab uno mense et supra; quia non sunt recensiti inter filios Israel, nec eis cum ceteris data possessio est."
,"63":"Hic est numerus filiorum Israel, qui descripti sunt a Moyse et Eleazaro sacerdote in campestribus Moab supra Iordanem contra Iericho;"
,"64":"inter quos nullus fuit eorum, qui ante numerati sunt a Moyse et Aaron in deserto Sinai:"
,"65":"praedixerat enim Dominus quod omnes morerentur in solitudine; nullusque remansit ex eis, nisi Chaleb filius Iephonne et Iosue filius Nun."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Accesserunt autem filiae Sal phaad filii Hepher filii Ga laad filii Machir filii Manasse, e cognationibus Manasse, qui fuit filius Ioseph, quarum sunt nomina: Maala et Noa et Hegla et Melcha et Thersa."
,"2":"Steteruntque coram Moyse et Eleazaro sacerdote et principibus et cuncta congregatione ad ostium tabernaculi conventus atque dixerunt:"
,"3":"' Pater noster mortuus est in deserto, nec fuit in seditione, quae concitata est contra Dominum sub Core, sed in peccato suo mortuus est; hic non habuit mares filios."
,"4":"Cur tollitur nomen illius de familia sua, quia non habuit filium? Date nobis possessionem inter fratres patris nostri '."
,"5":"Rettulitque Moyses causam earum ad iudicium Domini,"
,"6":"qui dixit ad eum:"
,"7":"' Iustam rem postulant filiae Salphaad. Da eis possessionem inter fratres patris sui, et ei in hereditatem succedant."
,"8":"Ad filios autem Israel loqueris haec: Homo cum mortuus fuerit absque filio, ad filiam eius transibit hereditas;"
,"9":"si filiam non habuerit, habebit successores fratres suos."
,"10":"Quod si et fratres non fuerint, dabitis hereditatem fratribus patris eius."
,"11":"Sin autem nec patruos habuerit, dabitur hereditas illi, qui ei proximus est e cognatione sua; possidebitque eam. Eritque hoc filiis Israel sanctum lege perpetua, sicut praecepit Dominus Moysi '."
,"12":"Dixit quoque Dominus ad Moysen: ' Ascende in montem istum Abarim et contemplare inde terram, quam daturus sum filiis Israel."
,"13":"Cumque videris eam, ibis et tu ad populum tuum, sicut ivit frater tuus Aaron,"
,"14":"quia offendistis me in deserto Sin in contradictione congregationis, nec sanctificare me voluistis coram ea super aquas '. Hae sunt aquae Meribathcades deserti Sin."
,"15":"Cui respondit Moyses:"
,"16":"' Provideat Dominus, Deus spirituum omnis carnis, hominem, qui sit super congregationem hanc"
,"17":"et possit exire et intrare ante eos et educere eos vel introducere, ne sit populus Domini sicut oves absque pastore '."
,"18":"Dixitque Dominus ad eum: ' Tolle Iosue filium Nun, virum in quo est spiritus; et pone manum tuam super eum,"
,"19":"quem statues coram Eleazaro sacerdote et omni congregatione et dabis ei praecepta, cunctis videntibus,"
,"20":"et partem gloriae tuae, ut audiat eum omnis synagoga filiorum Israel."
,"21":"Stabit coram Eleazaro sacerdote, qui pro eo iudicium Urim consulet Dominum. Ad verbum eius egredietur et ingredietur ipse et omnes filii Israel cum eo, cuncta congregatio '."
,"22":"Fecit Moyses, ut praeceperat Dominus. Cumque tulisset Iosue, statuit eum coram Eleazaro sacerdote et omni frequentia populi;"
,"23":"et, impositis capiti eius manibus, constituit eum, sicut mandaverat Dominus per manum Moysi."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Dixit quoque Dominus ad Moysen:"
,"2":"' Praecipe filiis Is rael et dices ad eos: Oblationem meam et panem meum, sacrificium ignis in odorem suavissimum offerte per tempora sua."
,"3":"Hoc est sacrificium ignis, quod offerre debetis: agnos anniculos immaculatos duos cotidie in holocaustum sempiternum;"
,"4":"unum offeretis mane et alterum ad vesperam;"
,"5":"decimam partem ephi similae in oblationem, quae conspersa sit oleo purissimo et habeat quartam partem hin."
,"6":"Holocaustum iuge est, quod obtulistis in monte Sinai in odorem suavissimum, sacrificium ignis Domino;"
,"7":"et libabitis vini quartam partem hin per agnos singulos; in sanctuario effundetis libamen potus inebriantis Domino."
,"8":"Alterumque agnum similiter offeretis ad vesperam, iuxta ritum sacrificii matutini: sacrificium ignis in odorem suavissimum Domino."
,"9":"Die autem sabbati offeretis duos agnos anniculos immaculatos et duas decimas similae oleo conspersae et libamentum eius."
,"10":"Est holocaustum sabbati per singula sabbata, praeter holocaustum sempiternum et libamentum eius."
,"11":"In calendis autem offeretis holocaustum Domino vitulos de armento duos, arietem unum, agnos anniculos septem immaculatos"
,"12":"et tres decimas similae oleo conspersae in oblatione per singulos vitulos et duas decimas similae oleo conspersae per singulos arietes,"
,"13":"et decimam unam similae oleo conspersae in oblatione per agnos singulos: holocaustum in odorem suavissimum, sacrificium ignis Domino."
,"14":"Libamenta autem eorum ista erunt: media pars hin vini per singulos vitulos, tertia per arietem, quarta per agnum. Hoc erit holocaustum per omnes menses, qui sibi anno vertente succedunt."
,"15":"Hircus quoque offeretur Domino pro peccato, praeter holocaustum sempiternum cum libamentis suis."
,"16":"Mense autem primo, quarta decima die mensis Pascha Domini erit,"
,"17":"et quinta decima die sollemnitas. Septem diebus vescemini azymis,"
,"18":"quarum die prima conventus sanctus erit; omne opus servile non facietis in ea."
,"19":"Offeretisque sacrificium ignis, holocaustum Domino: vitulos de armento duos, arietem unum, agnos anniculos immaculatos septem;"
,"20":"et oblationem singulorum ex simila, quae conspersa sit oleo, tres decimas per singulos vitulos et duas decimas per arietem"
,"21":"et decimam unam per agnos singulos, id est per septem agnos;"
,"22":"et hircum pro peccato unum, ut expietur pro vobis,"
,"23":"praeter holocaustum matutinum, quod semper offeretis."
,"24":"Ita facietis per singulos dies septem dierum: panem, sacrificium ignis in odorem suavissimum Domino praeter holocaustum iuge et libationem eius."
,"25":"Die quoque septimo conventus sanctus erit vobis; omne opus servile non facietis in eo."
,"26":"Die etiam primitivorum, quando offeretis oblationem novam Domino, in sollemnitate Hebdomadarum, conventus sanctus erit vobis; omne opus servile non facietis in ea."
,"27":"Offeretisque holocaustum in odorem suavissimum Domino: vitulos de armento duos, arietem unum et agnos anniculos immaculatos septem,"
,"28":"atque in oblatione eorum similae oleo conspersae, tres decimas per singulos vitulos, per arietem duas,"
,"29":"per agnos decimam unam, qui simul sunt agni septem;"
,"30":"hircum quoque, qui mactatur pro expiatione,"
,"31":"praeter holocaustum sempiternum et oblationem eius. Immaculata offeretis omnia cum libationibus suis."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Mensis etiam septimi prima die conventus sanctus erit vo bis; omne opus servile non facietis in ea, quia dies clangoris est et tubarum."
,"2":"Offeretisque holocaustum in odorem suavissimum Domino: vitulum de armento unum, arietem unum et agnos anniculos immaculatos septem;"
,"3":"et in oblationibus eorum similae oleo conspersae tres decimas per vitulum, duas decimas per arietem,"
,"4":"unam decimam per agnum, qui simul sunt agni septem;"
,"5":"et hircum pro peccato, qui offertur in expiationem vestram,"
,"6":"praeter holocaustum calendarum cum oblatione et holocaustum sempiternum cum oblatione et libationibus solitis in odorem suavissimum, sacrificium ignis Domino."
,"7":"Decima quoque die mensis huius septimi erit vobis conventus sanctus, et affligetis animas vestras; omne opus servile non facietis."
,"8":"Offeretisque holocaustum Domino in odorem suavissimum: vitulum de armento unum, arietem unum, agnos anniculos immaculatos septem;"
,"9":"et in oblatione eorum similae oleo conspersae tres decimas per vitulum, duas decimas per arietem,"
,"10":"decimam unam per agnos singulos, qui sunt simul septem agni;"
,"11":"et hircum pro peccato, absque his, quae offerri pro delicto solent in expiationem et holocaustum sempiternum cum oblatione et libaminibus eorum."
,"12":"Quinta decima vero die mensis septimi conventus sanctus erit; omne opus servile non facietis in ea, sed celebrabitis sollemnitatem Domino septem diebus"
,"13":"offeretisque holocaustum in odorem suavissimum Domino: vitulos de armento tredecim, arietes duos, agnos anniculos immaculatos quattuordecim;"
,"14":"et in oblatione eorum similae oleo conspersae tres decimas per vitulos singulos, qui sunt simul vituli tredecim, et duas decimas arieti uno, id est simul arietibus duobus,"
,"15":"et decimam unam agnis singulis, qui sunt simul agni quattuordecim;"
,"16":"et hircum pro peccato absque holocausto sempiterno et oblatione et libamine eius."
,"17":"In die altero offeretis vitulos de armento duodecim, arietes duos, agnos anniculos immaculatos quattuordecim;"
,"18":"oblationemque et libamina singulorum per vitulos et arietes et agnos iuxta numerum eorum rite celebrabitis,"
,"19":"et hircum pro peccato absque holocausto sempiterno oblationeque et libamine eorum."
,"20":"Die tertio offeretis vitulos undecim, arietes duos, agnos anniculos imma culatos quattuordecim,"
,"21":"oblationem et libamina singulorum per vitulos et arietes et agnos iuxta numerum eorum rite celebrabitis,"
,"22":"et hircum pro peccato absque holocausto sempiterno oblationeque et libamine eius."
,"23":"Die quarto offeretis vitulos decem, arietes duos, agnos anniculos immaculatos quattuordecim,"
,"24":"oblationem et libamina singulorum per vitulos et arietes et agnos iuxta numerum eorum rite celebrabitis,"
,"25":"et hircum pro peccato absque holocausto sempiterno, oblatione eius et libamine."
,"26":"Die quinto offeretis vitulos novem, arietes duos, agnos anniculos immaculatos quattuordecim,"
,"27":"oblationem et libamina singulorum per vitulos et arietes et agnos iuxta numerum eorum rite celebrabitis,"
,"28":"et hircum pro peccato absque holocausto sempiterno, oblatione eius et libamine."
,"29":"Die sexto offeretis vitulos octo, arietes duos, agnos anniculos immaculatos quattuordecim,"
,"30":"oblationem et libamina singulorum per vitulos et arietes et agnos iuxta numerum eorum rite celebrabitis,"
,"31":"et hircum pro peccato absque holocausto sempiterno, oblatione eius et libamine."
,"32":"Die septimo offeretis vitulos septem et arietes duos, agnos anniculos immaculatos quattuordecim,"
,"33":"oblationem et libamina singulorum per vitulos et arietes et agnos iuxta numerum eorum rite celebrabitis,"
,"34":"et hircum pro peccato absque holocausto sempiterno, oblatione eius et libamine."
,"35":"Die octavo erit conventus sollemnis, omne opus servile non facietis"
,"36":"offerentes holocaustum in odorem suavissimum Domino: vitulum unum, arietem unum, agnos anniculos immaculatos septem,"
,"37":"oblationem et libamina singulorum per vitulum et arietem et agnos iuxta numerum eorum rite celebrabitis,"
,"38":"et hircum pro peccato absque holocausto sempiterno, oblatione eius et libamine."
,"39":"Haec offeretis Domino in sollemnitatibus vestris, praeter vota et oblationes spontaneas in holocaustis, in oblationibus, in libaminibus et in hostiis pacificis '."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Narravitque Moyses filiis Israel omnia, quae ei Dominus imperarat,"
,"2":"et locutus est ad principes tribuum filiorum Israel: ' Iste est sermo, quem praecepit Dominus:"
,"3":"Si quis virorum votum Domino voverit aut se constrinxerit iuramento, non faciet irritum verbum suum, sed omne, quod promisit, implebit."
,"4":"Mulier, si quippiam voverit Domino aut se constrinxerit iuramento, quae est in domo patris sui et in aetate adhuc puellari,"
,"5":"si cognoverit pater votum, quod pollicita est, aut iuramentum, quo ligavit animam suam, et tacuerit, voti rea erit; quidquid pollicita est aut iuravit, opere complebit."
,"6":"Sin autem, quo die audierit contradixerit pater, et vota et iuramenta eius irrita erunt; et propitius erit ei Dominus, eo quod contradixerit pater."
,"7":"Si maritum habuerit et voverit aliquid, aut semel de ore eius verbum egrediens animam eius ligaverit iuramento,"
,"8":"quo die audierit vir eius et non contradixerit, voti rea erit reddetque, quodcumque promiserat."
,"9":"Sin autem, quo die audierit contradixerit, irritas facit pollicitationes eius verbaque, quibus obstrinxerat animam suam; et propitius erit ei Dominus."
,"10":"Vidua et repudiata, quidquid voverint, reddent."
,"11":"Uxor in domo viri cum se voto constrinxerit aut iuramento,"
,"12":"si audierit vir et tacuerit nec contradixerit sponsioni, reddet, quodcumque promiserat."
,"13":"Sin autem extemplo contradixerit, non tenebitur promissionis rea, quia maritus contradixit, et Dominus ei propitius erit."
,"14":"Si voverit aut iuramento se constrinxerit, ut per ieiunium affligat animam suam, in arbitrio viri erit, ut faciat sive non faciat."
,"15":"Quod si audiens vir tacuerit et de die in diem distulerit sententiam, quidquid voverat atque promiserat, reddet, quia, quo die audierat, tacuit."
,"16":"Sin autem contradixerit, postquam rescivit, portabit ipse iniquitatem eius '."
,"17":"Istae sunt leges, quas constituit Dominus Moysi inter virum et uxorem, inter patrem et filiam, quae in puellari adhuc aetate manet in parentis domo."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Ulciscere filios Israel de Madianitis et sic colligeris ad populum tuum '."
,"3":"Statimque Moyses: ' Armate, inquit, ex vobis viros ad pugnam, qui possint ultionem Domini expetere de Madianitis."
,"4":"Mille viri de singulis tribubus eligantur ex Israel, qui mittantur ad bellum '."
,"5":"Dederuntque millenos de singulis tribubus, id est duodecim milia expeditorum ad pugnam,"
,"6":"quos misit Moyses cum Phinees filio Eleazari sacerdotis. Vasa quoque sancta et tubas ad clangendum tradidit ei."
,"7":"Cumque pugnassent contra Madianitas, sicut praeceperat Dominus Moysi, omnes mares occiderunt"
,"8":"et reges eorum Evi et Recem et Sur et Hur et Rebe, quinque principes gentis, Balaam quoque filium Beor interfecerunt gladio;"
,"9":"ceperuntque mulieres eorum et parvulos. Omniaque pecora et cunctam supellectilem, quidquid habere potuerant, depopulati sunt:"
,"10":"tam urbes quam viculos et castra flamma consumpsit;"
,"11":"et tulerunt praedam et universa, quae ceperant, tam ex hominibus quam ex iumentis,"
,"12":"et adduxerunt captivos, spolia et praedam ad Moysen et Eleazarum sacerdotem et ad omnem congregationem filiorum Israel ad castra in campestribus Moab iuxta Iordanem contra Iericho."
,"13":"Egressi sunt autem Moyses et Eleazar sacerdos et omnes principes synagogae in occursum eorum extra castra."
,"14":"Iratusque Moyses principibus exercitus, tribunis et centurionibus, qui venerant de bello,"
,"15":"ait: ' Cur omnes feminas reservastis?"
,"16":"Nonne istae sunt, quae deceperunt filios Israel ad suggestionem Balaam et praevaricari vos fecerunt in Dominum super peccato Phegor, unde et percussus est populus Domini?"
,"17":"Ergo cunctos interficite parvulos generis masculini et omnes mulieres, quae noverunt viros in coitu, iugulate;"
,"18":"puellas autem et omnes feminas virgines reservate vobis."
,"19":"Et vos manete extra castra septem diebus; qui occiderit hominem vel occisum tetigerit, lustrabitur die tertio et septimo, vos et captivi vestri."
,"20":"Et de omni praeda, sive vestimentum fuerit sive aliquid in utensilia praeparatum de caprarum pellibus et pilis et ligno, lustrabitis '."
,"21":"Eleazar quoque sacerdos ad viros exercitus, qui pugnaverant, sic locutus est: ' Hoc est praeceptum legis, quod mandavit Dominus Moysi:"
,"22":"Aurum et argentum et aes et ferrum et stannum et plumbum,"
,"23":"omne, quod potest transire per flammas, igne purgabitur; quidquid autem ignem non potest sustinere, aqua expiationis sanctificabitur."
,"24":"Et lavabitis vestimenta vestra die septimo, et purificati postea castra intrabitis '."
,"25":"Dixit quoque Dominus ad Moysen:"
,"26":"' Tollite summam eorum, quae capta sunt, ab homine usque ad pecus, tu et Eleazar sacerdos et principes familiarum;"
,"27":"dividesque ex aequo praedam inter eos, qui pugnaverunt egressique sunt ad bellum, et inter omnem congregationem."
,"28":"Et separabis partem Domino ab his, qui pugnaverunt et fuerunt in bello, unam animam de quingentis tam ex hominibus quam ex bobus et asinis et ovibus"
,"29":"et dabis eam Eleazaro sacerdoti, quia praelibatio Domini sunt."
,"30":"Ex media quoque parte filiorum Israel accipies quinquagesimum caput hominum et boum et asinorum et ovium cunctorum animantium et dabis ea Levitis, qui excubant in custodiis habitaculi Domini '."
,"31":"Feceruntque Moyses et Eleazar sacerdos, sicut praeceperat Dominus."
,"32":"Fuit autem praeda, quae supererat, quam exercitus ceperat, ovium sescenta septuaginta quinque milia,"
,"33":"boum septuaginta duo milia,"
,"34":"asinorum sexaginta milia et mille,"
,"35":"animae hominum sexus feminei, quae non cognoverant viros, triginta duo milia."
,"36":"Dataque est media pars his, qui in proelio fuerant, ovium trecenta triginta septem milia quingentae,"
,"37":"e quibus in partem Domini supputatae sunt oves sescentae septuaginta quinque,"
,"38":"et de bobus triginta sex milibus, boves septuaginta et duo,"
,"39":"de asinis triginta milibus quingentis, asini sexaginta unus,"
,"40":"de animabus hominum sedecim milibus, cesserunt in partem Domini triginta duae animae."
,"41":"Tradiditque Moyses tributum praelibationis Domini Eleazaro sacerdoti, sicut fuerat ei imperatum."
,"42":"Ex media vero parte filiorum Israel, quam separaverat a parte eorum, qui in proelio fuerant,"
,"43":"de hac media parte, quae contigerat congregationi, id est de ovibus trecentis triginta septem milibus quingentis"
,"44":"et de bobus triginta sex milibus"
,"45":"et de asinis triginta milibus quingentis"
,"46":"et de hominibus sedecim milibus,"
,"47":"tulit Moyses quinquagesimum caput et dedit Levitis, qui excubabant in habitaculo Domini, sicut praeceperat Dominus."
,"48":"Cumque accessissent principes exercitus ad Moysen, tribuni centurionesque, dixerunt:"
,"49":"' Nos servi tui recensuimus numerum pugnatorum, quos habuimus sub manu nostra, et ne unus quidem defuit."
,"50":"Ob hanc causam offerimus in donariis Domini singuli, quod auri potuimus invenire, periscelidas et armillas, anulos et inaures ac muraenulas, ad placandum pro nobis Dominum '."
,"51":"Susceperuntque Moyses et Eleazar sacerdos aurum in diversis speciebus;"
,"52":"omne aurum, quod elevaverunt Domino, pondo sedecim milia septingentos quinquaginta siclos, a tribunis et centurionibus."
,"53":"Unusquisque enim, quod in praeda rapuerat, suum erat."
,"54":"Et susceptum intulerunt in tabernaculum conventus in monumentum filiorum Israel coram Domino."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Filii autem Ruben et Gad habebant pecora multa, et erat illis in iumentis infinita substantia. Cumque vidissent Iazer et Galaad aptas animalibus alendis terras,"
,"2":"venerunt ad Moysen et ad Eleazarum sacerdotem et principes congregationis atque dixerunt:"
,"3":"' Ataroth et Dibon et Iazer et Nemra, Hesebon et Eleale et Sabam et Nabo et Beon,"
,"4":"terra, quam percussit Dominus in conspectu congregationis Israel, regio uberrima est ad pastum animalium, et nos servi tui habemus iumenta plurima '."
,"5":"Dixeruntque: ' Si invenimus gratiam coram te, detur haec terra famulis tuis in possessionem, nec facias nos transire Iordanem '."
,"6":"Quibus respondit Moyses: ' Numquid fratres vestri ibunt ad pugnam, et vos hic sedebitis?"
,"7":"Cur subvertitis mentes filiorum Israel, ne transire audeant in terram, quam eis daturus est Dominus?"
,"8":"Nonne ita egerunt patres vestri, quando misi de Cadesbarne ad explorandam terram?"
,"9":"Cumque venissent usque ad Nehelescol, lustrata omni regione, subverterunt cor filiorum Israel, ut non intrarent terram, quam eis Dominus dedit."
,"10":"Qui iratus iuravit dicens:"
,"11":"'Non videbunt homines isti, qui ascenderunt ex Aegypto, a viginti annis et supra, terram, quam sub iuramento pollicitus sum Abraham, Isaac et Iacob; nam noluerunt sequi me,"
,"12":"praeter Chaleb filium Iephonne Cenezaeum et Iosue filium Nun: isti secuti sunt Dominum!'."
,"13":"Iratusque Dominus adversum Israel circumduxit eum per desertum quadraginta annis, donec consumeretur universa generatio, quae fecerat malum in conspectu eius."
,"14":"Et ecce, inquit, vos surrexistis pro patribus vestris progenies hominum peccatorum, ut augeretis furorem irae Domini contra Israel."
,"15":"Quod si nolueritis sequi eum, in solitudine iterum populum hunc circumducet, et vos causa eritis necis omnium '."
,"16":"At illi prope accedentes dixerunt: ' Caulas ovium fabricabimus pro iumentis nostris, parvulis quoque nostris urbes;"
,"17":"nos autem ipsi armati et accincti pergemus ad proelium ante filios Israel, donec introducamus eos ad loca sua. Parvuli nostri erunt in urbibus muratis propter habitatorum insidias."
,"18":"Non revertemur in domos nostras usque dum possideant filii Israel hereditatem suam;"
,"19":"nec quidquam quaeremus trans Iordanem et ultra, quia iam habemus nostram hereditatem in orientali eius plaga '."
,"20":"Quibus Moyses ait: ' Si feceritis quod promittitis, si expediti perrexeritis coram Domino ad pugnam,"
,"21":"et omnis vir bellator armatus Iordanem transierit, donec expulerit Dominus inimicos suos ante se,"
,"22":"et subiecta ei omni terra redieritis in terram hanc, tunc eritis inculpabiles apud Dominum et apud Israel et obtinebitis terram hanc in hereditatem coram Domino."
,"23":"Sin autem, quod dicitis, non feceritis, nulli dubium est quin peccetis in Dominum; et scitote quoniam peccatum vestrum apprehendet vos."
,"24":"Aedificate ergo urbes parvulis vestris et caulas ovibus et, quod polliciti estis, implete '."
,"25":"Dixeruntque filii Gad et Ruben ad Moysen: ' Servi tui sumus, faciemus, quod iubet dominus noster:"
,"26":"parvulos nostros, mulieres, pecora ac iumenta remanebunt ibi in urbibus Galaad;"
,"27":"famuli autem tui, omnes expediti pergent coram Domino ad bellum, sicut tu, domine, loqueris '."
,"28":"Praecepit ergo Moyses Eleazaro sacerdoti et Iosue filio Nun et principibus familiarum per tribus filiorum Israel et dixit ad eos:"
,"29":"' Si transierint filii Gad et filii Ruben vobiscum Iordanem omnes armati ad bellum coram Domino, et vobis fuerit terra subiecta, date eis Galaad in possessionem."
,"30":"Sin autem noluerint transire armati vobiscum in terram Chanaan, inter vos habitandi accipiant loca '."
,"31":"Responderuntque filii Gad et filii Ruben: ' Sicut locutus est Dominus servis suis, ita faciemus."
,"32":"Ipsi armati pergemus coram Domino in terram Chanaan; et possidebimus hereditatem nostram trans Iordanem '."
,"33":"Dedit itaque Moyses filiis Gad et Ruben et dimidiae tribui Manasse filii Ioseph regnum Sehon regis Amorraei et regnum Og regis Basan, terram cum urbibus suis et terminis, urbes terrae per circuitum."
,"34":"Igitur exstruxerunt filii Gad Dibon et Ataroth et Aroer"
,"35":"et Atrothsophan et Iazer et Iegbaa"
,"36":"et Bethnemra et Betharan, urbes munitas, et caulas pecoribus suis."
,"37":"Filii vero Ruben aedificaverunt Hesebon et Eleale et Cariathaim"
,"38":"et Nabo et Baalmeon, versis nominibus, Sabama quoque, imponentes vocabula urbibus, quas exstruxerant."
,"39":"Porro filii Machir filii Manasse perrexerunt in Galaad et ceperunt eam, expulso Amorraeo habitatore eius."
,"40":"Dedit ergo Moyses terram Galaad Machir filio Manasse, qui habitavit in ea."
,"41":"Iair autem filius Manasse abiit et occupavit vicos eius, quos appellavit Havoth Iair (id est villas Iair)."
,"42":"Nobe quoque perrexit et apprehendit Canath cum viculis suis vocavitque eam ex nomine suo Nobe."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Hae sunt mansiones filiorum Israel, qui egressi sunt de Ae gypto per turmas suas in manu Moysi et Aaron,"
,"2":"quas descripsit Moyses iuxta castrorum loca, quae Domini iussione mutabant."
,"3":"Profecti igitur de Ramesse mense primo, quinta decima die mensis primi, altera die Paschae, filii Israel in manu excelsa, videntibus cunctis Aegyptiis"
,"4":"et sepelientibus primogenitos, quos percusserat Dominus, nam et in diis eorum exercuerat ultionem,"
,"5":"castrametati sunt in Succoth."
,"6":"Et de Succoth venerunt in Etham, quae est in extremis finibus solitudinis."
,"7":"Inde egressi venerunt contra Phihahiroth, quae respicit Beelsephon, et castrametati sunt ante Magdolum."
,"8":"Profectique de Phihahiroth transierunt per medium mare in solitudinem, et ambulantes tribus diebus per desertum Etham castrametati sunt in Mara."
,"9":"Profectique de Mara venerunt in Elim, ubi erant duodecim fontes aquarum et palmae septuaginta; ibique castrametati sunt."
,"10":"Sed et inde egressi fixerunt tentoria super mare Rubrum. Profectique de mari Rubro"
,"11":"castrametati sunt in deserto Sin;"
,"12":"unde egressi venerunt in Daphca."
,"13":"Profectique de Daphca castrametati sunt in Alus."
,"14":"Egressique de Alus in Raphidim fixere tentoria, ubi populo defuit aqua ad bibendum;"
,"15":"profectique de Raphidim castrametati sunt in deserto Sinai."
,"16":"Sed et de solitudine Sinai egressi venerunt ad Cibrottaava;"
,"17":"profectique de Cibrottaava castrametati sunt in Aseroth."
,"18":"Et de Aseroth venerunt in Rethma;"
,"19":"profectique de Rethma castrametati sunt in Remmonphares."
,"20":"Unde egressi venerunt in Lebna;"
,"21":"de Lebna castrametati sunt in Ressa;"
,"22":"egressique de Ressa venerunt in Ceelatha,"
,"23":"unde profecti castrametati sunt in monte Sepher."
,"24":"Egressi de monte Sepher venerunt in Arada;"
,"25":"inde proficiscentes castrametati sunt in Maceloth;"
,"26":"profectique de Maceloth venerunt in Thahath;"
,"27":"de Thahath castrametati sunt in Thare."
,"28":"Unde egressi fixere tentoria in Methca"
,"29":"et de Methca castrametati sunt in Hesmona;"
,"30":"profectique de Hesmona venerunt in Moseroth."
,"31":"Et de Moseroth castrametati sunt in Beneiacan;"
,"32":"profectique de Beneiacan venerunt in montem Gadgad;"
,"33":"unde profecti castrametati sunt in Ietebatha."
,"34":"Et de Ietebatha venerunt in Ebrona;"
,"35":"egressique de Ebrona castrametati sunt in Asiongaber."
,"36":"Inde profecti venerunt in desertum Sin, hoc est Cades."
,"37":"Egressique de Cades castrametati sunt in monte Hor in extremis finibus terrae Edom."
,"38":"Ascenditque Aaron sacerdos in montem Hor, iubente Domino, et ibi mortuus est anno quadragesimo egressionis filiorum Israel ex Aegypto, mense quinto, prima die mensis,"
,"39":"cum esset annorum centum viginti trium."
,"40":"Audivitque Chananaeus rex Arad, qui habitabat in Nageb, in terra Chanaan, venisse filios Israel."
,"41":"Et profecti de monte Hor castrametati sunt in Salmona;"
,"42":"unde egressi venerunt in Phinon."
,"43":"Profectique de Phinon castrametati sunt in Oboth;"
,"44":"et de Oboth venerunt in Ieabarim, quae est in finibus Moabitarum."
,"45":"Profectique de Ieabarim fixere tentoria in Dibongad;"
,"46":"unde egressi castrametati sunt in Elmondeblathaim."
,"47":"Egressique de Elmondeblathaim venerunt ad montes Abarim contra Nabo."
,"48":"Profectique de montibus Abarim transierunt ad campestria Moab supra Iordanem contra Iericho;"
,"49":"ibique castrametati sunt de Bethiesimoth usque ad Abelsettim in campestribus Moab."
,"50":"Ubi locutus est Dominus ad Moysen:"
,"51":"' Praecipe filiis Israel et dic ad eos: Quando transieritis Iordanem intrantes terram Chanaan,"
,"52":"disperdite cunctos habitatores terrae ante vos, confringite omnes imagines eorum et omnes statuas comminuite atque omnia excelsa vastate."
,"53":"Possidebitis terram et habitabitis in ea. Ego enim dedi vobis illam in possessionem,"
,"54":"quam dividetis inter tribus vestras. Maiori dabitis latiorem et minori angustiorem; singulis, ut sors ceciderit, ita tribuetur hereditas; per tribus et familias possessio dividetur."
,"55":"Sin autem nolueritis expellere habitatores terrae, qui remanserint, erunt vobis quasi spinae in oculis vestris et sudes in lateribus, et adversabuntur vobis in terra habitationis vestrae;"
,"56":"et, quidquid illis cogitaveram facere, vobis faciam '."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Locutusque est Dominus ad Moysen dicens:"
,"2":"' Praecipe fi liis Israel et dices ad eos: Cum ingressi fueritis terram hanc Chanaan, et in possessionem vobis sorte ceciderit, his finibus terminabitur."
,"3":"Pars meridiana incipiet a solitudine Sin, quae est iuxta Edom, et habebit terminos contra orientem mare Salsissimum."
,"4":"Qui circuibunt australem plagam per ascensum Acrabbim (id est Scorpionum), ita ut transeant in Sin et perveniant ad meridiem Cadesbarne, unde egredientur ad Asaraddar et tendent usque ad Asemona."
,"5":"Ibitque per gyrum terminus ab Asemona usque ad torrentem Aegypti, et maris Magni litore finietur."
,"6":"Plaga autem occidentalis a mari Magno incipiet et ipso fine claudetur."
,"7":"Porro ad septentrionalem plagam a mari Magno termini incipient pervenientes usque ad montem Hor,"
,"8":"a quo venient in introitum Emath usque ad terminos Sedada."
,"9":"Ibuntque confinia usque ad Zephrona et Asarenon. Hi erunt termini in parte aquilonis."
,"10":"Inde metabuntur fines contra orientalem plagam de Asarenon usque Sephama;"
,"11":"et de Sephama descendent termini in Rebla ad orientem Ain; inde descendent et pervenient ad latus maris Chenereth in oriente"
,"12":"et tendent usque ad Iordanem, et ad ultimum Salsissimo claudentur mari. Hanc habebitis terram per fines suos in circuitu '."
,"13":"Praecepitque Moyses filiis Israel dicens: ' Haec erit terra, quam possidebitis sorte et quam iussit Dominus dari novem tribubus et dimidiae tribui."
,"14":"Tribus enim filiorum Ruben per familias suas et tribus filiorum Gad iuxta cognationum numerum media quoque tribus Manasse,"
,"15":"id est duae semis tribus, acceperunt partem suam trans Iordanem contra Iericho ad orientalem plagam '."
,"16":"Et ait Dominus ad Moysen:"
,"17":"' Haec sunt nomina virorum, qui terram vobis divident: Eleazar sacerdos et Iosue filius Nun"
,"18":"et singuli principes de tribubus singulis,"
,"19":"quorum ista sunt vocabula: de tribu Iudae Chaleb filius Iephonne;"
,"20":"de tribu Simeon Samuel filius Ammiud;"
,"21":"de tribu Beniamin Elidad filius Chaselon;"
,"22":"de tribu filiorum Dan Bocci filius Iogli."
,"23":"Filiorum Ioseph: de tribu Manasse Hanniel filius Ephod,"
,"24":"de tribu Ephraim Camuel filius Sephtan."
,"25":"De tribu Zabulon Elisaphan filius Pharnach;"
,"26":"de tribu Issachar dux Phaltiel filius Ozan;"
,"27":"de tribu Aser Ahiud filius Salomi;"
,"28":"de tribu Nephthali Phedael filius Ammiud '."
,"29":"Hi sunt, quibus praecepit Dominus, ut dividerent filiis Israel terram Chanaan."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Haec quoque locutus est Do minus ad Moysen in campe stribus Moab supra Iordanem contra Iericho:"
,"2":"' Praecipe filiis Israel, ut dent Levitis de possessionibus suis urbes ad habitandum et suburbana earum per circuitum,"
,"3":"ut ipsi in oppidis maneant, et suburbana sint pecoribus ac substantiae et omnibus animalibus eorum;"
,"4":"quae a muris civitatum forinsecus per circuitum mille cubitos spatio tendentur."
,"5":"Et mensurabitis extra civitatem contra orientem duo milia cubitorum, et contra meridiem similiter duo milia, ad mare quoque, quod respicit ad occidentem, eadem mensura erit, et septentrionalis plaga aequali termino finietur; eruntque urbes in medio et foris suburbana."
,"6":"De ipsis autem oppidis, quae Levitis dabitis, sex erunt in fugitivorum auxilia separata, ut fugiat ad ea, qui nesciens fuderit sanguinem; et, exceptis his, alia quadraginta duo oppida dabitis,"
,"7":"id est simul quadraginta octo cum suburbanis suis."
,"8":"Ipsaeque urbes, quas dabitis de possessionibus filiorum Israel, ab his, qui plus habent, plures auferetis, et, qui minus, pauciores; singuli iuxta mensuram hereditatis suae dabunt oppida Levitis '."
,"9":"Ait Dominus ad Moysen:"
,"10":"' Loquere filiis Israel et dices ad eos: Quando transgressi fueritis Iordanem in terram Chanaan,"
,"11":"eligetis urbes, quae esse debeant in praesidia fugitivorum, qui nolentes sanguinem fuderint;"
,"12":"erunt vobis urbes refugii contra ultorem, et occisor non morietur, donec stet in conspectu congregationis, et causa illius iudicetur."
,"13":"De ipsis autem sex urbibus, quae ad fugitivorum subsidia separantur,"
,"14":"tres erunt trans Iordanem et tres in terra Chanaan,"
,"15":"tam filiis Israel quam advenis atque peregrinis, ut confugiat ad eas sex, qui nolens sanguinem fuderit."
,"16":"Si quis ferro percusserit, et mortuus fuerit, qui percussus est, reus erit homicidii et ipse morietur."
,"17":"Si lapidem mortiferum iecerit, et ictus occiderit, similiter punietur."
,"18":"Si ligno mortifero percusserit eum et interfecerit, homicida est; ipse morte punietur."
,"19":"Ultor sanguinis homicidam interficiet: statim ut apprehenderit eum, interficiet."
,"20":"Si per odium quis hominem impulerit vel iecerit quippiam in eum per insidias"
,"21":"aut, cum esset inimicus, manu percusserit, et ille mortuus fuerit, percussor homicidii reus erit: ultor sanguinis statim ut invenerit eum, iugulabit."
,"22":"Quod si fortuitu et absque odio eum percusserit vel quidpiam in eum iecerit absque insidiis,"
,"23":"vel quemlibet lapidem mortiferum in eum devolverit, cum eum non vidisset, et ille mortuus est, quamvis eum non oderit nec quaesierit ei malum,"
,"24":"iudicabit congregatio inter percussorem et ultorem sanguinis secundum has regulas"
,"25":"et liberabit occisorem de manu ultoris sanguinis et reducet in civitatem refugii, ad quam confugerat, manebitque ibi, donec sacerdos magnus, qui oleo sancto unctus est, moriatur."
,"26":"Si interfector extra fines civitatis refugii, in quam confugerat, exierit,"
,"27":"et invenerit eum ultor sanguinis ibi et interfecerit, absque noxa erit, qui eum occiderit;"
,"28":"debuerat enim profugus usque ad mortem pontificis in civitate refugii residere. Postquam autem ille obierit, homicida revertetur in terram suam."
,"29":"Haec erunt vobis in legitima iudicii pro generationibus vestris, in cunctis habitationibus vestris."
,"30":"Homicida sub testibus occidetur; ad unius testimonium nullus ad mortem condemnabitur."
,"31":"Non accipietis pretium pro eo, qui reus est sanguinis, sed morietur."
,"32":"Neque accipietis pretium, ut fugiat in civitatem refugii sui, ut revertatur et habitet in terra ante mortem sacerdotis."
,"33":"Non polluetis terram habitationis vestrae, quia sanguis polluit terram, nec aliter expiari potest nisi per eius sanguinem, qui alterius sanguinem fuderit."
,"34":"Non maculabitis terram habitationis vestrae, me commorante vobiscum. Ego enim sum Dominus, qui habito inter filios Israel '."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Accesserunt autem et princi pes familiarum tribus filio rum Galaad filii Machir filii Manasse de stirpe filiorum Ioseph; locutique sunt Moysi coram principibus familiarum Israel"
,"2":"atque dixerunt: ' Tibi domino nostro praecepit Dominus, ut terram sorte divideres filiis Israel et ut filiabus Salphaad fratris nostri dares hereditatem debitam patri;"
,"3":"quas si alterius tribus homines uxores acceperint, sequetur possessio sua, et translata ad aliam tribum de nostra hereditate minuetur."
,"4":"Atque ita fiet, ut cum iobeleus advenerit, addetur possessio earum possessioni tribus, ad quam pertinent, et a possessione tribus patrum nostrorum auferetur '."
,"5":"Respondit Moyses filiis Israel et, Domino praecipiente, ait: ' Recte tribus filiorum Ioseph locuta est,"
,"6":"et haec lex super filiabus Salphaad a Domino promulgata est: Nubant, quibus volunt, tantum ut suae tribus hominibus,"
,"7":"ne commisceatur possessio filiorum Israel de tribu in tribum; filii Israel adhaerebunt possessioni tribus patrum suorum,"
,"8":"et cunctae filiae heredes e filiis Israel maritos e cognatione tribus patrum suorum accipient, ut hereditas permaneat in familiis,"
,"9":"nec commisceatur possessio de tribu in tribum alteram, sed filii Israel adhaerebunt possessioni tribuum suarum '."
,"10":"Sicut mandavit Dominus Moysi, sic fecerunt filiae Salphaad"
,"11":"et nupserunt Maala et Thersa et Hegla et Melcha et Noa filiis patruorum suorum"
,"12":"de familiis Manasse, qui fuit filius Ioseph; et possessio, quae illis fuerat attributa, mansit in tribu et familia patris earum."
,"13":"Haec sunt mandata atque iudicia, quae mandavit Dominus per manum Moysi ad filios Israel in campestribus Moab supra Iordanem contra Iericho."
}`)

}
func LA_NVBSE_LoadVSCCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Canticum Canticorum Salomonis."
,"2":"Osculetur me osculo oris sui!,Nam meliores sunt amores tui vino:"
,"3":"in fragrantiam unguentorum tuorum optimorum. Oleum effusum nomen tuum; ideo adulescentulae dilexerunt te."
,"4":"Trahe me post te. Curramus!,Introducat me rex in cellaria sua; exsultemus et laetemur in te,memores amorum tuorum super vinum; recte diligunt te."
,"5":"Nigra sum sed formosa, filiae Ierusalem, sicut tabernacula Cedar, sicut pelles Salma."
,"6":"Nolite me considerare quod fusca sim, quia decoloravit me sol. Filii matris meae irati sunt mihi; posuerunt me custodem in vineis, vineam meam non custodivi."
,"7":"Indica mihi, tu, quem diligit anima mea, ubi pascas, ubi cubes in meridie, ne vagari incipiam,post greges sodalium tuorum."
,"8":"Si ignoras, o pulcherrima inter mulieres, egredere et abi post vestigia gregum,et pasce haedos tuos,iuxta tabernacula pastorum."
,"9":"Equae in curribus pharaonis,assimilavi te, amica mea."
,"10":"Pulchrae sunt genae tuae inter inaures, collum tuum inter monilia."
,"11":"Inaures aureas faciemus tibi,vermiculatas argento."
,"12":"Dum esset rex in accubitu suo, nardus mea dedit odorem suum."
,"13":"Fasciculus myrrhae dilectus meus mihi, qui inter ubera mea commoratur."
,"14":"Botrus cypri dilectus meus mihi,in vineis Engaddi."
,"15":"Ecce tu pulchra es, amica mea, ecce tu pulchra es: oculi tui columbarum."
,"16":"Ecce tu pulcher es, dilecte mi, et decorus. Lectulus noster floridus,"
,"17":"tigna domorum nostrarum cedrina, laquearia nostra cupressina."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ego flos campi,et lilium convallium."
,"2":"Sicut lilium inter spinas, sic amica mea inter filias."
,"3":"Sicut malus inter ligna silvarum, sic dilectus meus inter filios. Sub umbra illius, quem desideraveram, sedi, et fructus eius dulcis gutturi meo."
,"4":"Introduxit me in cellam vinariam, et vexillum eius super me est caritas."
,"5":"Fulcite me uvarum placentis, stipate me malis, quia amore langueo."
,"6":"Laeva eius sub capite meo, et dextera illius amplexatur me."
,"7":"Adiuro vos, filiae Ierusalem, per capreas cervasque camporum, ne suscitetis neque evigilare faciatis dilectam, quoadusque ipsa velit."
,"8":"Vox dilecti mei!,Ecce iste venit,saliens in montibus, transiliens colles."
,"9":"Similis est dilectus meus capreae,hinnuloque cervorum. En ipse stat,post parietem nostrum,respiciens per fenestras, prospiciens per cancellos."
,"10":"En dilectus meus loquitur mihi: ' Surge, amica mea, columba mea, formosa mea, et veni."
,"11":"Iam enim hiems transiit, imber abiit et recessit."
,"12":"Flores apparuerunt in terra, tempus putationis advenit; vox turturis audita est,in terra nostra,"
,"13":"ficus protulit grossos suos, vineae florentes dederunt odorem suum; surge, amica mea, speciosa mea, et veni,"
,"14":"columba mea, in foraminibus petrae, in caverna abrupta. Ostende mihi faciem tuam, sonet vox tua in auribus meis; vox enim tua dulcis, et facies tua decora '."
,"15":"Capite nobis vulpes, vulpes parvulas, quae demoliuntur vineas, nam vineae nostrae florescunt."
,"16":"Dilectus meus mihi, et ego illi, qui pascitur inter lilia,"
,"17":"antequam aspiret dies, et festinent umbrae. Revertere; similis esto, dilecte mi, capreae,hinnuloque cervorum super montes Bether."
}`)
	CurrentBook.AddChapter(3, `{
"1":"In lectulo meo per noctes,quaesivi, quem diligit anima mea; quaesivi illum et non inveni."
,"2":"' Surgam et circuibo civitatem; per vicos et plateas,quaeram, quem diligit anima mea'. Quaesivi illum et non inveni."
,"3":"Invenerunt me vigiles, qui circumeunt civitatem: ' Num, quem diligit anima mea, vidistis? '."
,"4":"Paululum cum pertransissem eos, inveni, quem diligit anima mea; tenui eum nec dimittam, donec introducam illum in domum matris meae,et in cubiculum genetricis meae."
,"5":"Adiuro vos, filiae Ierusalem, per capreas cervasque camporum, ne suscitetis neque evigilare faciatis dilectam, donec ipsa velit."
,"6":"Quid hoc, quod ascendit per desertum,sicut virgula fumi, aromatizans tus et myrrham,et universum pulverem pigmentarii?"
,"7":"En lectulum Salomonis. Sexaginta fortes ambiunt illum,ex fortissimis Israel,"
,"8":"omnes tenentes gladios,et ad bella doctissimi, uniuscuiusque ensis super femur suum,propter timores nocturnos."
,"9":"Ferculum fecit sibi rex Salomon,de lignis Libani;"
,"10":"columnas eius fecit argenteas, reclinatorium aureum, sedile purpureum: medium eius stratum ebeneum. Filiae Ierusalem,"
,"11":"egredimini et videte, filiae Sion, regem Salomonem,in diademate, quo coronavit illum mater sua,in die desponsationis illius,et in die laetitiae cordis eius."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quam pulchra es, amica mea, quam pulchra es: oculi tui columbarum,per velamen tuum. Capilli tui sicut grex caprarum, quae descenderunt de monte Galaad;"
,"2":"dentes tui sicut grex tonsarum, quae ascenderunt de lavacro: omnes gemellis fetibus, et sterilis non est inter eas."
,"3":"Sicut vitta coccinea labia tua, et eloquium tuum dulce; sicut fragmen mali punici, ita genae tuae,per velamen tuum."
,"4":"Sicut turris David collum tuum, quae aedificata est cum propugnaculis: mille clipei pendent ex ea, omnis armatura fortium."
,"5":"Duo ubera tua sicut duo hinnuli, capreae gemelli, qui pascuntur in liliis."
,"6":"Antequam aspiret dies, et festinent umbrae, vadam ad montem myrrhae,et ad collem turis."
,"7":"Tota pulchra es, amica mea, et macula non est in te."
,"8":"Veni de Libano, sponsa, veni de Libano, ingredere; respice de capite Amana, de vertice Sanir et Hermon, de cubilibus leonum, de montibus pardorum."
,"9":"Vulnerasti cor meum, soror mea, sponsa, vulnerasti cor meum in uno oculorum tuorum,et in uno monili torquis tui."
,"10":"Quam pulchri sunt amores tui, soror, mea sponsa; meliores sunt amores tui vino, et odor unguentorum tuorum super omnia aromata."
,"11":"Favus distillans labia tua, sponsa; mel et lac sub lingua tua, et odor vestimentorum tuorum,sicut odor Libani."
,"12":"Hortus conclusus, soror mea, sponsa, hortus conclusus, fons signatus;"
,"13":"propagines tuae paradisus malorum punicorum,cum optimis fructibus, cypri cum nardo."
,"14":"Nardus et crocus, fistula et cinnamomum,cum universis lignis turiferis, myrrha et aloe,cum omnibus primis unguentis."
,"15":"Fons hortorum, puteus aquarum viventium, quae fluunt impetu de Libano."
,"16":"Surge, aquilo, et veni, auster; perfla hortum meum, et fluant aromata illius."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Veniat dilectus meus in hortum suum,et comedat fructus eius optimos. Veni in hortum meum, soror mea, sponsa; messui myrrham meam cum aromatibus meis, comedi favum cum melle, bibi vinum cum lacte meo. Comedite, amici, et bibite,et inebriamini, carissimi."
,"2":"Ego dormio, et cor meum vigilat. Vox dilecti mei pulsantis: ' Aperi mihi, soror mea, amica mea, columba mea, immaculata mea, quia caput meum plenum est rore, et cincinni mei guttis noctium '. "
,"3":"' Exspoliavi me tunica mea, quomodo induar illa?,Lavi pedes meos, quomodo inquinabo illos?'."
,"4":"Dilectus meus misit manum suam per foramen, et venter meus ilico intremuit."
,"5":"Surrexi, ut aperirem dilecto meo; manus meae stillaverunt myrrham, et digiti mei pleni myrrha probatissima,super ansam pessuli."
,"6":"Aperui dilecto meo; at ille declinaverat atque transierat. Anima mea liquefacta est, quia discesserat. Quaesivi et non inveni illum; vocavi, et non respondit mihi."
,"7":"Invenerunt me custodes, qui circumeunt civitatem; percusserunt me et vulneraverunt me, tulerunt pallium meum mihi,custodes murorum."
,"8":"Adiuro vos, filiae Ierusalem: si inveneritis dilectum meum, quid nuntietis ei?,' Quia amore langueo '."
,"9":"Quid est dilecto tuo prae ceteris, o pulcherrima mulierum?,Quid est dilecto tuo prae ceteris, quia sic adiurasti nos?"
,"10":"Dilectus meus candidus et rubicundus,dignoscitur ex milibus."
,"11":"Caput eius aurum optimum, cincinni eius sicut racemi palmarum, nigri quasi corvus."
,"12":"Oculi eius sicut columbae,super rivulos aquarum, quae lacte sunt lotae,et resident iuxta fluenta plenissima."
,"13":"Genae illius sicut areolae aromatum, turriculae unguentorum; labia eius lilia,distillantia myrrham primam."
,"14":"Manus illius tornatiles aureae, plenae hyacinthis; venter eius opus eburneum,distinctum sapphiris."
,"15":"Crura illius columnae marmoreae, quae fundatae sunt super bases aureas; species eius ut Libani, electus ut cedri."
,"16":"Guttur illius suavissimum, et totus desiderabilis. Talis est dilectus meus, et ipse est amicus meus, filiae Ierusalem."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Quo abiit dilectus tuus, o pulcherrima mulierum?,Quo declinavit dilectus tuus, et quaeremus eum tecum?"
,"2":"Dilectus meus descendit in hortum suum,ad areolam aromatum, ut pascatur in hortis,et lilia colligat."
,"3":"Ego dilecto meo, et dilectus meus mihi, qui pascitur inter lilia."
,"4":"Pulchra es, amica mea, sicut Thersa, decora sicut Ierusalem, terribilis ut castrorum acies ordinata."
,"5":"Averte oculos tuos a me, quia ipsi me conturbant. Capilli tui sicut grex caprarum, quae descenderunt de Galaad."
,"6":"Dentes tui sicut grex ovium, quae ascenderunt de lavacro: omnes gemellis fetibus, et sterilis non est in eis."
,"7":"Sicut fragmen mali punici, sic genae tuae,per velamen tuum."
,"8":"Sexaginta sunt reginae, et octoginta concubinae, et adulescentularum non est numerus;"
,"9":"una est columba mea, perfecta mea, una est matri suae, electa genetrici suae. Viderunt eam filiae et beatissimam praedicaverunt; reginae et concubinae, et laudaverunt eam:"
,"10":"' Quae est ista, quae progreditur quasi aurora consurgens, pulchra ut luna, electa ut sol, terribilis ut castrorum acies ordinata? '."
,"11":"Descendi in hortum nucum, ut viderem poma convallium,et inspicerem, si floruisset vinea, et germinassent mala punica."
,"12":"Non advertit animus meus, cum posuit me in quadrigas principis populi mei."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Convertere, convertere, Sula mitis; convertere, convertere, ut intueamur te. Quid aspicitis in Sulamitem, cum saltat inter binos choros?"
,"2":"Quam pulchri sunt pedes tui in calceamentis, filia principis!,Flexurae femorum tuorum sicut monilia, quae fabricata sunt manu artificis."
,"3":"Gremium tuum crater tornatilis: numquam indigeat vino mixto; venter tuus sicut acervus tritici,vallatus liliis."
,"4":"Duo ubera tua sicut duo hinnuli, gemelli capreae,"
,"5":"collum tuum sicut turris eburnea. Oculi tui sicut piscinae in Hesebon, quae sunt ad portam Bathrabbim; nasus tuus sicut turris Libani, quae respicit contra Damascum."
,"6":"Caput tuum ut Carmelus, et comae capitis tui sicut purpura; rex vincitur cincinnis."
,"7":"Quam pulchra es et quam decora, carissima, in deliciis!"
,"8":"Statura tua assimilata est palmae, et ubera tua botris."
,"9":"Dixi: ' Ascendam in palmam,et apprehendam fructus eius '. Et erunt ubera tua sicut botri vineae, et odor oris tui sicut malorum."
,"10":"Guttur tuum sicut vinum optimum, dignum dilecto meo ad potandum, labiisque et dentibus illius ad ruminandum."
,"11":"Ego dilecto meo, et ad me appetitus eius."
,"12":"Veni, dilecte mi, egrediamur in agrum, commoremur in villis;"
,"13":"mane properabimus ad vineas, videbimus; si floruit vinea, si flores aperiuntur, si floruerunt mala punica; ibi dabo tibi amores meos."
,"14":"Mandragorae dederunt odorem; in portis nostris omnia poma optima, nova et vetera, dilecte mi, servavi tibi."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quis mihi det te fratrem meum, sugentem ubera matris meae, ut inveniam te foris et deosculer te, et iam me nemo despiciat?"
,"2":"Apprehenderem te et ducerem in domum matris meae; ibi me doceres, et darem tibi poculum ex vino condito,et mustum malorum granatorum meorum."
,"3":"Laeva eius sub capite meo, et dextera illius amplexatur me."
,"4":"Adiuro vos, filiae Ierusalem, ne suscitetis neque evigilare faciatis dilectam, donec ipsa velit."
,"5":"Quae est ista, quae ascendit de deserto,innixa super dilectum suum?,Sub arbore malo suscitavi te; ibi parturivit te mater tua, ibi parturivit te genetrix tua."
,"6":"Pone me ut signaculum super cor tuum, ut signaculum super brachium tuum, quia fortis est ut mors dilectio, dura sicut infernus aemulatio; lampades eius lampades ignis,atque flammae divinae."
,"7":"Aquae multae non potuerunt exstinguere caritatem, nec flumina obruent illam; si dederit homo omnem substantiam domus suae pro dilectione, quasi nihil despicient eum."
,"8":"Soror nostra parva,et ubera non habet; quid faciemus sorori nostrae,in die, quando alloquenda est?"
,"9":"Si murus est, aedificemus super eum propugnacula argentea; si ostium est, compingamus illud tabulis cedrinis."
,"10":"Ego murus, et ubera mea sicut turris; ex quo facta sum coram eo,quasi pacem reperiens."
,"11":"Vinea fuit Salomoni,in Baalhamon. Tradidit eam custodibus; vir affert pro fructu eius,mille argenteos."
,"12":"Vinea mea coram me est; mille tibi, Salomon, et ducenti his, qui custodiunt fructus eius."
,"13":"Quae habitas in hortis, amici auscultant, fac me audire vocem tuam."
,"14":"Fuge, dilecte mi, et assimilare capreae,hinnuloque cervorum,super montes aromatum."
}`)

}
func LA_NVBSE_LoadVSEEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Verba Ecclesiastes filii David regis Ierusalem.'"
,"2":"' Vanitas vanitatum, dixit Ecclesiastes, vanitas vanitatum et omnia vanitas '."
,"3":"Quid lucri est homini,de universo labore suo, quo laborat sub sole?"
,"4":"Generatio praeterit, et generatio advenit, terra autem in aeternum stat."
,"5":"Oritur sol, et occidit sol,et ad locum suum anhelat ibique renascitur."
,"6":"Gyrat per meridiem et flectitur ad aquilonem, lustrans universa in circuitu pergit spiritus,et in circulos suos revertitur."
,"7":"Omnia flumina pergunt ad mare, et mare non redundat; ad locum, unde exeunt, flumina illuc revertuntur in cursu suo."
,"8":"Cunctae res difficiles; non potest eas homo explicare sermone. Non saturatur oculus visu, nec auris auditu impletur."
,"9":"Quod fuit, ipsum est, quod futurum est. Quod factum est, ipsum est, quod faciendum est:"
,"10":"nihil sub sole novum. Si de quadam re dicitur: ' Ecce hoc novum est ', iam enim praecessit in saeculis, quae fuerunt ante nos."
,"11":"Non est priorum memoria, sed nec eorum quidem, qui postea futuri sunt, erit recordatio apud eos, qui futuri sunt in novissimo."
,"12":"Ego Ecclesiastes fui rex Israel in Ierusalem"
,"13":"et proposui in animo meo quaerere et investigare sapienter de omnibus, quae fiunt sub sole. Hanc occupationem pessimam dedit Deus filiis hominum, ut occuparentur in ea."
,"14":"Vidi cuncta, quae fiunt sub sole; et ecce universa vanitas et afflictio spiritus."
,"15":"Quod est curvum, rectum fieri non potest; et, quod deficiens est, numerari non potest."
,"16":"Locutus sum ego in corde meo dicens: ' Ecce ego magnificavi et apposui sapientiam super omnes, qui fuerunt ante me in Ierusalem; et mens mea contemplata est multam sapientiam et scientiam '."
,"17":"Dedique cor meum, ut scirem sapientiam et scientiam, insipientiam et stultitiam. Et agnovi quod in his quoque esset afflictio spiritus, eo quod"
,"18":"in multa sapientia multus sit maeror; et, qui addit scientiam, addit et laborem."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Dixi ego in corde meo: ' Veni, tentabo te gaudio: fruere bo nis '; et ecce hoc quoque vanitas."
,"2":"De risu dixi: ' Insania ',et de gaudio: ' Quid prodest? '."
,"3":"Tractavi in corde meo detinere in vino carnem meam, cum cor meum duceretur in sapientia, et amplecti stultitiam, donec viderem quid esset utile filiis hominum, ut faciant sub sole paucis diebus vitae suae."
,"4":"Magnificavi opera mea: aedificavi mihi domos et plantavi vineas,"
,"5":"feci hortos et pomaria et consevi ea arboribus cuncti generis fructuum"
,"6":"et exstruxi mihi piscinas aquarum, ut irrigarem silvam lignorum germinantium."
,"7":"Possedi servos et ancillas et habui multam familiam, habui armenta quoque et magnos ovium greges ultra omnes, qui fuerunt ante me in Ierusalem."
,"8":"Coacervavi mihi etiam argentum et aurum et substantias regum ac provinciarum, feci mihi cantores et cantatrices et delicias filiorum hominum, scyphos et urceos in ministerio ad vina fundenda"
,"9":"et crevi, supergressus sum omnes, qui ante me fuerunt in Ierusalem; sapientia quoque mea perseveravit mecum."
,"10":"Et omnia, quae desideraverunt oculi mei, non negavi eis nec prohibui cor meum ab omni voluptate, et oblectatum est ex omnibus laboribus, et hanc ratus sum partem meam ab omnibus aerumnis meis."
,"11":"Cumque me convertissem ad universa opera, quae fecerant manus meae, et ad labores, in quibus sudaveram, et ecce in omnibus vanitas et afflictio spiritus, et nihil lucri esse sub sole."
,"12":"Verti me ad contemplandam sapientiam et insipientiam et stultitiam: ' Quid faciet, inquam, homo, qui veniet post regem? Id quod antea fecerunt '."
,"13":"Et vidi quod tantum praecederet sapientia stultitiam, quantum lux praecedit tenebras."
,"14":"' Sapientis oculi in capite eius, stultus in tenebris ambulat '; et didici quod unus utriusque,esset interitus."
,"15":"Et dixi in corde meo: ' Si unus et stulti et meus occasus erit, quid mihi prodest quod maiorem sapientiae dedi operam? '. Locutusque cum mente mea, animadverti quod hoc quoque esset vanitas."
,"16":"Non enim erit memoria sapientis similiter ut stulti in perpetuum; siquidem futura tempora oblivione cuncta pariter operient: moritur doctus similiter ut indoctus."
,"17":"Et idcirco taeduit me vitae meae, quia malum mihi est, quod sub sole fit; cuncta enim vanitas et afflictio spiritus."
,"18":"Rursus detestatus sum omnem laborem meum, quo sub sole laboravi, quem relicturus sum homini, qui erit post me;"
,"19":"et quis scit utrum sapiens an stultus futurus sit? Et dominabitur in laboribus meis, quibus desudavi et sollicitus fui sub sole. Hoc quoque vanitas."
,"20":"Verti me exasperans cor meum de omni labore, quo laboravi sub sole."
,"21":"Nam est qui laborat in sapientia et doctrina et sollicitudine, et homini, qui non laboraverit, dabit portionem suam; et hoc ergo vanitas et magnum malum."
,"22":"Quid enim proderit homini de universo labore suo et afflictione cordis, qua sub sole laboravit?"
,"23":"Cuncti dies eius dolores sunt, et aerumnae occupatio eius, nec per noctem cor eius requiescit; et hoc quoque vanitas est."
,"24":"Nihil melius est homini quam comedere et bibere et ostendere animae suae bona de laboribus suis. Et hoc vidi de manu Dei esse."
,"25":"Quis enim comedet et deliciis affluet sine eo?"
,"26":"Quia homini bono in conspectu suo dedit sapientiam et scientiam et laetitiam; peccatori autem dedit afflictionem colligendi et congregandi, ut tradat ei, qui placuit Deo; sed et hoc vanitas est et afflictio spiritus."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Omnia tempus habent, et momentum suum cuique negotio sub caelo:"
,"2":"tempus nascendi et tempus moriendi, tempus plantandi et tempus evellendi quod plantatum est,"
,"3":"tempus occidendi et tempus sanandi, tempus destruendi et tempus aedificandi,"
,"4":"tempus flendi et tempus ridendi, tempus plangendi et tempus saltandi,"
,"5":"tempus spargendi lapides et tempus eos colligendi, tempus amplexandi et tempus longe fieri ab amplexibus,"
,"6":"tempus quaerendi et tempus perdendi, tempus custodiendi et tempus abiciendi,"
,"7":"tempus scindendi et tempus consuendi, tempus tacendi et tempus loquendi,"
,"8":"tempus dilectionis et tempus odii, tempus belli et tempus pacis."
,"9":"Quid lucri habet, qui operatur, de labore suo?"
,"10":"Vidi occupationem, quam dedit Deus filiis hominum, ut occuparentur in ea."
,"11":"Cuncta fecit bona in tempore suo; et mundum tradidit cordi eorum, et non inveniet homo opus, quod operatus est Deus ab initio usque ad finem."
,"12":"Cognovi quod nihil boni esset in eis nisi laetari et facere bene in vita sua."
,"13":"Omnis enim homo, qui comedit et bibit et videt bonum de labore suo, hoc donum Dei est."
,"14":"Didici quod omnia opera, quae fecit Deus, perseverent in perpetuum; non possumus eis quidquam addere nec auferre, quae fecit Deus, ut timeatur."
,"15":"Quod iam fuit, ipsum est; et, quod futurum est, iam fuit; et Deus requirit, quod abiit."
,"16":"Et adhuc vidi sub sole: in loco iudicii ibi impietas, et in loco iustitiae ibi iniquitas;"
,"17":"et dixi in corde meo: ' Iustum et impium iudicabit Deus, quia tempus omni rei et omnibus occasio '."
,"18":"Dixi in corde meo de filiis hominum, ut probaret eos Deus et ostenderet eos in semetipsis similes esse bestiis."
,"19":"Quoniam sors filiorum hominis et iumentorum una est atque eadem: sicut moritur homo, sic et illa moriuntur; et idem spiritus omnibus: nihil habet homo iumento amplius, quia omnia vanitas."
,"20":"Et omnia pergunt ad unum locum: de terra facta sunt omnia, et in terram omnia pariter revertuntur."
,"21":"Quis novit, si spiritus filiorum hominis ascendat sursum, et si spiritus iumentorum descendat deorsum in terram?"
,"22":"Et deprehendi nihil esse melius quam laetari hominem in opere suo; nam haec est pars illius. Quis enim eum adducet, ut post se futura cognoscat?"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Verti me ad alia et vidi calumnias, quae sub sole geruntur, et ecce lacrimae oppressorum, et nemo consolator; et ex parte opprimentium violentia, et nemo consolator."
,"2":"Et laudavi magis mortuos, qui iam defuncti sunt, quam viventes, qui adhuc vitam agunt,"
,"3":"et feliciorem utroque iudicavi, qui necdum natus est nec vidit opera mala, quae sub sole fiunt."
,"4":"Rursum contemplatus sum omnes labores et omnem successum operis, et hoc esse zelum in proximum suum. Et in hoc ergo vanitas et afflictio spiritus."
,"5":"Stultus complicat manus suas,et comedit carnes suas."
,"6":"Melior est pugillus cum requie,quam plena utraque manus cum labore et afflictione spiritus."
,"7":"Iterum repperi et aliam vanitatem sub sole:"
,"8":"unus est et secundum non habet, non filium, non fratrem, et tamen laborare non cessat, nec satiantur oculi eius divitiis, nec recogitat dicens: ' Cui laboro et fraudo animam meam bonis?'. In hoc quoque vanitas est et occupatio pessima."
,"9":"Melius est duos esse simul quam unum: habent enim emolumentum in labore suo,"
,"10":"quia si unus ceciderit, ab altero fulcietur. Vae soli! Cum ceciderit, non habet sublevantem se."
,"11":"Insuper, si dormierint duo, fovebuntur mutuo; unus quomodo calefiet?"
,"12":"Et, si quispiam praevaluerit contra unum, duo resistent ei. Et fu niculus triplex non cito rumpitur."
,"13":"Melior est puer pauper et sapiens,rege sene et stulto, qui iam nescit erudiri."
,"14":"Ille enim de domo carceris exivit, ut regnaret, etiamsi in regno istius natus sit pauper."
,"15":"Vidi cunctos viventes, qui ambulant sub sole, cum adulescente illo secundo, qui consurgebat pro eo."
,"16":"Infinitus numerus erat populi, omnium, quos ipse praecedebat; sed qui postea futuri sunt, non laetabuntur in eo. Et hoc vanitas et afflictio spiritus."
,"17":"Custodi pedem tuum ingrediens domum Dei, nam accedere, ut audias, melius est quam cum stulti offerunt victimas: multo enim melior est oboedientia quam stultorum victimae, qui nesciunt se malum facere."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ne temere quid loquaris, neque cor tuum sit velox ad proferen dum sermonem coram Deo; Deus enim in caelo, et tu super terram: idcirco sint pauci sermones tui."
,"2":"Multas curas sequuntur somnia, et in multis sermonibus invenietur stultitia."
,"3":"Si quid vovisti Deo, ne moreris reddere: displicet enim ei stulta promissio; sed, quodcumque voveris, redde."
,"4":"Multoque melius est non vovere, quam post votum promissa non reddere."
,"5":"Ne dederis os tuum, ut peccare faciat carnem tuam, neque dicas coram angelo: ' Error fuit '; ne forte iratus Deus contra sermones tuos dissipet opera manuum tuarum."
,"6":"Ubi multa sunt somnia, plurimae sunt vanitates et sermones innumeri; tu vero Deum time."
,"7":"Si videris calumnias egenorum et subreptionem iudicii et iustitiae in provincia, non mireris super hoc negotio, quia excelso excelsior vigilat, et super hos quoque eminentiores sunt alii;"
,"8":"et terrae lucrum in omnibus est rex, cuius agri culti sunt."
,"9":"Qui diligit pecuniam, pecunia non implebitur; et, qui amat divitias, fructum non capiet ex eis; et hoc ergo vanitas."
,"10":"Ubi multae sunt opes, multi et qui comedunt eas; et quid prodest possessori, nisi quod cernit divitias oculis suis?"
,"11":"Dulcis est somnus operanti, sive parum sive multum comedat; saturitas autem divitis,non sinit eum dormire."
,"12":"Est et infirmitas pessima, quam vidi sub sole: divitiae conservatae in malum domini sui."
,"13":"Perierunt enim in negotio pessimo; si generavit filium, in summa egestate erit."
,"14":"Sicut egressus est de utero matris suae, nudus iterum abibit, sicut venit, et nihil auferet secum de labore suo, quod tollat in manu sua."
,"15":"Miserabilis prorsus infirmitas: quomodo venit, sic revertetur. Quid ergo prodest ei quod laboravit in ventum?"
,"16":"Cunctis enim diebus vitae suae comedit in tenebris et in curis multis et in aerumna atque tristitia."
,"17":"Ecce quod ego vidi bonum, quod pulchrum, ut comedat quis et bibat et fruatur laetitia ex labore suo, quo laboravit ipse sub sole, numero dierum vitae suae, quos dedit ei Deus; haec enim est pars illius."
,"18":"Et quidem omni homini, cui dedit Deus divitias atque substantiam, potestatemque ei tribuit, ut comedat ex eis et tollat partem suam et laetetur de labore suo: hoc est donum Dei."
,"19":"Non enim satis recordabitur dierum vitae suae, eo quod Deus occupet deliciis cor eius."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Est et aliud malum, quod vidi sub sole, et quidem grave apud homines:"
,"2":"vir, cui dedit Deus divitias et substantiam et honorem, et nihil deest animae suae ex omnibus, quae desiderat; nec tribuit ei potestatem Deus, ut comedat ex eo, sed homo extraneus vorabit illud: hoc vanitas et miseria mala est."
,"3":"Si genuerit quispiam centum liberos et vixerit multos annos et plures dies aetatis habuerit, et anima illius non sit satiata bonis substantiae suae, immo et sepultura careat, de hoc ego pronuntio quod melior illo sit abortivus."
,"4":"Frustra enim venit et pergit ad tenebras, et in tenebris abscondetur nomen eius."
,"5":"Etsi non vidit solem neque cognovit, maior est requies isti quam illi."
,"6":"Etiamsi duobus milibus annis vixerit et non fuerit perfruitus bonis, nonne ad unum locum properant omnes?"
,"7":"' Omnis labor hominis est ad os eius, sed anima eius non implebitur '."
,"8":"Quid habet amplius sapiens prae stulto? Et quid pauper, qui sciat ambulare coram vivis?"
,"9":"' Melior est oculorum visio quam vana persequi desideria '; sed et hoc vanitas est et afflictio spiritus."
,"10":"Quidquid est, iam vocatum est nomen eius; et scitur quod homo sit et non possit contra fortiorem se in iudicio contendere."
,"11":"Ubi verba sunt plurima, multiplicant vanitatem; quid lucri habet homo?"
,"12":"Quoniam quis scit quid homini bonum sit in vita, in paucis diebus vanitatis suae, quos peragit velut umbra? Aut quis ei poterit indicare quid post eum futurum sub sole sit?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Melius est nomen bonum quam unguenta pretiosa, et dies mortis die nativitatis."
,"2":"Melius est ire ad domum luctus,quam ad domum convivii; in illa enim finis cunctorum hominum, et vivens hoc conferet in corde."
,"3":"Melior est tristitia risu, quia per tristitiam vultus corrigitur animus."
,"4":"Cor sapientium in domo luctus, et cor stultorum in domo laetitiae."
,"5":"Melius est a sapiente corripi,quam laetari stultorum canticis,"
,"6":"quia sicut sonitus spinarum ardentium sub olla, sic risus stulti. Sed et hoc vanitas."
,"7":"Quia calumnia stultum facit sapientem, et munus cor insanire facit."
,"8":"' Melior est finis negotii quam principium, melior est patiens arrogante '."
,"9":"Ne sis velox in animo ad irascendum, quia ira in sinu stulti requiescit."
,"10":"Ne dicas: 'Quid, putas, causae est quod priora tempora meliora fuere quam nunc sunt? '. Non enim ex sapientia interrogas de hoc."
,"11":"Bona est sapientia cum divitiis et prodest videntibus solem."
,"12":"Sicut enim protegit sapientia, sic protegit pecunia; hoc autem plus habet eruditio, quod sapientia vitam tribuit possessori suo."
,"13":"Considera opera Dei: quod nemo possit corrigere, quod ille curvum fecerit."
,"14":"In die bona fruere bonis et in die mala considera: sicut hanc, sic et illam fecit Deus, ita ut non inveniat homo quidquam de futuro."
,"15":"Cuncta vidi in diebus vanitatis meae: est iustus, qui perit in iustitia sua, et impius, qui multo vivit tempore in malitia sua."
,"16":"Noli esse nimis iustus,neque sapiens supra modum!,Cur te perdere vis?"
,"17":"Ne agas nimis impie,et noli esse stultus!,Cur mori debeas in tempore non tuo?"
,"18":"Bonum est ut, quod habes, teneas, sed et ab illo ne subtrahas manum tuam, quia qui timet Deum, utrumque devitat."
,"19":"Sapientia confortabit sapientem super decem principes civitatis."
,"20":"Nullus enim homo iustus in terra, qui faciat bonum et non peccet."
,"21":"Sed et cunctis sermonibus, qui dicuntur, ne accommodes cor tuum, ne forte audias servum tuum maledicentem tibi;"
,"22":"scit enim conscientia tua, quia et tu crebro maledixisti aliis."
,"23":"Cuncta tentavi in sapientia, dixi: ' Sapiens efficiar '."
,"24":"Et ipsa longius recessit a me. Longe est, quod fuit; et alta est profunditas. Quis inveniet eam?"
,"25":"Lustravi universa animo meo, ut scirem et considerarem et quaererem sapientiam et rationem et ut cognoscerem impietatem esse stultitiam et errorem imprudentiam."
,"26":"Et invenio amariorem morte mulierem, quae laqueus venatorum est, et sagena cor eius, vincula sunt manus illius. Qui placet Deo, effugiet eam; qui autem peccator est, capietur ab illa."
,"27":"Ecce hoc inveni, dixit Ecclesiastes, unum et alterum, ut invenirem rationem,"
,"28":"quam adhuc quaerit anima mea, et non inveni: Hominem de mille unum repperi, mulierem ex omnibus non inveni."
,"29":"Ecce solummodo hoc inveni: Quod fecerit Deus hominem rectum, et ipsi quaesierint infinitas quaestiones."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quis talis, ut sapiens est?,Et quis cognovit solutionem re rum?,Sapientia hominis illuminat vultum eius, et durities faciei illius commutatur."
,"2":"Os regis observa et propter iuramenta Dei"
,"3":"ne festines recedere a facie eius neque permaneas in re mala, quia omne, quod voluerit, faciet."
,"4":"Quia sermo illius potestate plenus est, nec dicere ei quisquam potest: ' Quare ita facis? '."
,"5":"Qui custodit praeceptum, non experietur quidquam mali; tempus et iudicium cor sapientis intellegit."
,"6":"Omni enim negotio tempus est et iudicium, et multa hominis afflictio;"
,"7":"ignorat enim quid futurum sit, nam quomodo sit futurum, quis nuntiabit ei?"
,"8":"Non est in hominis potestate dominari super spiritum nec cohibere spiritum, nec habet potestatem supra diem mortis, nec ulla remissio est ingruente bello, neque salvabit impietas impium."
,"9":"Omnia haec consideravi et dedi cor meum cunctis operibus, quae fiunt sub sole, quo tempore dominatur homo homini in malum suum."
,"10":"Et ita vidi impios sepultos, discedentes de loco sancto; in oblivionem cadere in civitate, quod ita egerunt: sed et hoc vanitas est."
,"11":"Etenim, quia non profertur cito sententia contra opera mala, ideo cor filiorum hominum repletur, ut perpetrent mala."
,"12":"Nam peccator centies facit malum et prolongat sibi dies; verumtamen novi quod erit bonum timentibus Deum, qui verentur faciem eius."
,"13":"Non sit bonum impio, nec prolongabit dies suos quasi umbram, qui non timet faciem Domini."
,"14":"Est vanitas, quae fit super terram: sunt iusti, quibus mala proveniunt, quasi opera egerint impiorum, et sunt impii, quibus bona proveniunt, quasi iustorum facta habeant; sed et hoc vanissimum iudico."
,"15":"Laudavi igitur laetitiam quod non esset homini bonum sub sole, nisi quod comederet et biberet atque gauderet et hoc solum secum auferret de labore suo in diebus vitae suae, quos dedit ei Deus sub sole."
,"16":"Cum apposui cor meum, ut scirem sapientiam et intellegerem occupationem, quae versatur in terra, quod diebus et noctibus somnum non capit oculis,"
,"17":"ecce intellexi quod omnium operum Dei nullam possit homo invenire rationem eorum, quae fiunt sub sole; et quanto plus laboraverit homo ad quaerendum, tanto minus inveniet; etiamsi dixerit sapiens se nosse, non poterit reperire."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Omnia haec contuli in corde meo, ut curiose intellegerem quod iusti atque sapientes et opera eorum sunt in manu Dei. Utrum amor sit an odium, omnino nescit homo: coram illis omnia."
,"2":"Sicut omnibus sors una: iusto et impio, bono et malo, mundo et immundo, immolanti victimas et non immolanti. Sicut bonus sic et peccator; ut qui iurat, ita et ille qui iuramentum timet."
,"3":"Hoc est pessimum inter omnia, quae sub sole fiunt, quia sors eadem cunctis; unde et corda filiorum hominum implentur malitia et stultitia in vita sua, et novissima eorum apud mortuos."
,"4":"Qui enim sociatur omnibus viventibus, habet fiduciam: melior est canis vivus leone mortuo."
,"5":"Viventes enim sciunt se esse morituros; mortui vero nihil noverunt amplius nec habent ultra mercedem, quia oblivioni tradita est memoria eorum."
,"6":"Amor quoque eorum et odium et invidiae simul perierunt, nec iam habent partem in hoc saeculo et in opere, quod sub sole geritur."
,"7":"Vade ergo et comede in laetitia panem tuum,et bibe cum gaudio vinum tuum, etenim iam diu placuerunt Deo opera tua."
,"8":"Omni tempore sint vestimenta tua candida, et oleum de capite tuo non deficiat."
,"9":"Perfruere vita cum uxore, quam diligis, cunctis diebus vitae instabilitatis tuae, qui dati sunt tibi sub sole omni tempore vanitatis tuae: haec est enim pars in vita et in labore tuo, quo laboras sub sole."
,"10":"Quodcumque facere potest manus tua, instanter operare, quia nec opus nec ratio nec sapientia nec scientia erunt apud inferos, quo tu properas."
,"11":"Verti me ad aliud et vidi sub sole nec velocium esse cursum nec fortium bellum nec sapientium panem nec doctorum divitias nec prudentium gratiam, sed tempus casumque in omnibus."
,"12":"Insuper nescit homo finem suum, sed sicut pisces capiuntur sagena mala, et sicut aves laqueo comprehenduntur, sic capiuntur homines in tempore malo, cum eis extemplo supervenerit."
,"13":"Hanc quoque sub sole vidi sapientiam et probavi maximam:"
,"14":"civitas parva, et pauci in ea viri; venit contra eam rex magnus et vallavit eam exstruxitque munitiones magnas per gyrum."
,"15":"Inventusque est in ea vir pauper et sapiens et liberavit urbem per sapientiam suam; et nullus deinceps recordatus est hominis illius pauperis."
,"16":"Et dicebam ego meliorem esse sapientiam fortitudine, sed sapientia pauperis contemnitur, et verba eius non sunt audita."
,"17":"Verba sapientium cum lenitate audiuntur,plus quam clamor principis inter stultos."
,"18":"Melior est sapientia quam arma bellica; sed unus, qui peccaverit, multa bona perdet."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Muscae morientes perdunt et corrumpunt oleum unguentarii. Gravior quam sapientia et gloria est parva stultitia."
,"2":"Cor sapientis in dextera eius, et cor stulti in sinistra illius."
,"3":"Sed et in via stultus ambulans, cum ipse insipiens sit, omnes stultos aestimat."
,"4":"Si spiritus potestatem habentis ascenderit contra te, locum tuum ne dimiseris, quia lenitas faciet cessare peccata maxima."
,"5":"Est malum, quod vidi sub sole quasi errorem egredientem a facie principis:"
,"6":"positum stultum in dignitate sublimi et divites sedere deorsum."
,"7":"Vidi servos in equis et principes ambulantes super terram quasi servos."
,"8":"Qui fodit foveam, incidet in eam; et, qui dissipat murum, mordebit eum coluber."
,"9":"Qui excidit lapides, affligetur in eis; et, qui scindit ligna, periclitabitur ex eis."
,"10":"Si retusum fuerit ferrum, et aciem eius non exacueris, labor multiplicabitur, sed lucrum industriae erit sapientia."
,"11":"Si mordeat serpens incantatione neglecta, nihil lucri habet incantator."
,"12":"Verba oris sapientis gratia, et labia insipientis praecipitabunt eum."
,"13":"Initium verborum eius stultitia, et novissimum oris illius insipientia mala."
,"14":"Stultus verba multiplicat: ' Ignorat homo quid futurum sit; et, quid post se futurum sit, quis ei poterit indicare?'."
,"15":"Labor stultorum affliget eos, qui nesciunt in urbem pergere."
,"16":"Vae tibi, terra, cuius rex puer est, et cuius principes mane comedunt."
,"17":"Beata terra, cuius rex nobilis est, et cuius principes vescuntur in tempore suo,ad reficiendum et non ad luxuriam."
,"18":"In pigris manibus humiliabitur contignatio, et in remissis perstillabit domus."
,"19":"In risum faciunt epulas; vinum laetificat vitam, et pecunia praestat omnia."
,"20":"In cogitatione tua regi ne detrahas,et in secreto cubiculi tui ne maledixeris diviti, quia et aves caeli portabunt vocem tuam, et, qui habet pennas, annuntiabit sententiam."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Mitte panem tuum super transeuntes aquas, quia post tempora multa invenies illum."
,"2":"Da partem septem necnon et octo, quia ignoras, quid futurum sit mali super terram."
,"3":"Si repletae fuerint nubes, imbrem super terram effundent; si ceciderit lignum ad austrum aut ad aquilonem, in quocumque loco ceciderit, ibi erit. "
,"4":"Qui observat ventum, non seminat, et, qui considerat nubes, numquam metet."
,"5":"Quomodo ignoras, quae sit via spiritus, et qua ratione compingantur ossa in ventre praegnantis, sic nescis opera Dei, qui fabricator est omnium."
,"6":"Mane semina semen tuum, et vespere ne cesset manus tua, quia nescis quid magis prosit, hoc aut illud, et si utrumque simul melius erit."
,"7":"Dulce lumen, et delectabile est oculis videre solem."
,"8":"Si annis multis vixerit homo,et in his omnibus laetatus fuerit, meminisse debet tenebrosi temporis, quod multum erit: omne, quod venerit, vanitas."
,"9":"Laetare ergo, iuvenis, in adulescentia tua, et in bono sit cor tuum in diebus iuventutis tuae, et ambula in viis cordis tui,et in intuitu oculorum tuorum,et scito quod pro omnibus his,adducet te Deus in iudicium."
,"10":"Aufer curam a corde tuo,et amove malum a carne tua; adulescentia enim et iuventus vanae sunt."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Memento Creatoris tui,in diebus iuventutis tuae, antequam veniat tempus afflictionis, et appropinquent anni, de quibus dicas: ' Non mihi placent ';"
,"2":"antequam tenebrescat,sol et lumen et luna et stellae, et revertantur nubes post pluviam;"
,"3":"quando commovebuntur custodes domus, et nutabunt viri fortissimi, et otiosae erunt molentes imminuto numero, et tenebrescent videntes per foramina,"
,"4":"et claudentur ostia in platea,submissa voce molentis, et consurgent ad vocem volucris, et subsident omnes filiae carminis;"
,"5":"excelsa quoque timebunt,et formidabunt in via. Florebit amygdalus, reptabit locusta, et dissipabitur capparis, quoniam ibit homo in domum aeternitatis suae, et circuibunt in platea plangentes,"
,"6":"antequam rumpatur funiculus argenteus, et frangatur lecythus aureus, et conteratur hydria super fontem, et confringatur rota super cisternam,"
,"7":"et revertatur pulvis in terram suam, unde erat, et spiritus redeat ad Deum, qui dedit illum."
,"8":"Vanitas vanitatum, dixit Ecclesiastes, et omnia vanitas."
,"9":"Cumque esset sapientissimus, Ecclesiastes docuit insuper populum scientiam; ponderavit et investigans composuit parabolas multas."
,"10":"Quaesivit Ecclesiastes verba delectabilia et conscripsit sermones rectissimos ac veritate plenos."
,"11":"Verba sapientium sicut stimuli, et quasi clavi defixi sunt magistri collationum; data sunt a pastore uno."
,"12":"His amplius, fili mi, ne requiras: faciendi plures libros nullus est finis, frequensque meditatio carnis afflictio est."
,"13":"Finis loquendi, omnibus auditis: Deum time et mandata eius observa; hoc est enim omnis homo."
,"14":"Et cuncta, quae fiunt, adducet Deus in iudicium circa omne occultum, sive bonum sive malum."
}`)

}
func LA_NVBSE_LoadVSEIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"0":"PROLOGUS,Cum multa nobis et magna per Legem et Prophetas aliosque, qui secuti sunt illos, data sint, in quibus oportet laudare Israel doctrinae et sapientiae causa, cumque non solum ipsos legentes necesse sit fieri peritos, sed etiam extraneis posse sapientiae studiosos et dicentes et scribentes utiles fieri, avus meus Iesus, postquam se amplius dedit ad diligentiam lectionis Legis et Prophetarum et aliorum librorum, qui nobis a parentibus nostris traditi sunt, atque in his sufficientem usum acquisivit, voluit et ipse scribere aliquid horum, quae ad doctrinam et sapientiam pertinent, ut desiderantes discere et illorum periti facti magis magisque attendant animo et confirmentur per legitimam vitam. Hortor itaque venire vos cum benevolentia et attentiore studio lectionem facere et veniam habere in illis, in quibus interpretationi adlaborantes videamur quibusdam verbis deficere. Nam deficiunt verba Hebraica, quando fuerint translata ad alteram linguam; non autem solum haec, sed et ipsa Lex et Prophetae ceteraque aliorum librorum non parvam habent differentiam, quando ipsa per se leguntur. Nam in octavo et trigesimo anno temporibus Ptolemaei Evergetis regis, postquam perveni in Aegyptum et, cum multum temporis ibi fecissem, inveni ibi exemplar non parvae neque contemnendae doctrinae. Itaque bonum et necessarium putavi et ipse aliquam addere diligentiam et laborem interpretandi librum istum; et multam vigiliam attuli et doctrinam in spatio temporis, ut perducens ad finem, librum istum ederem etiam pro illis, qui in terra aliena, cum iam moribus instituti sint, sibi proposuerint secundum legem vitam agere."
,"1":"Omnis sapientia a Domino Deo est,et cum illo fuit semper et est ante aevum."
,"2":"Arenam maris et pluviae guttas,et dies saeculi quis dinumeravit?,Altitudinem caeli et latitudinem terrae,et profundum abyssi quis mensus est?"
,"3":"Sapientiam Dei praecedentem omnia quis investigavit?"
,"4":"Prior omnium creata est sapientia, et intellectus prudentiae ab aevo."
,"5":"Fons sapientiae verbum Dei in excelsis, et ingressus illius mandata aeterna."
,"6":"Radix sapientiae cui revelata est?,Et astutias illius quis agnovit?"
,"7":"Disciplina sapientiae cui revelata est et manifestata?,Et multiplicem peritiam illius quis intellexit?"
,"8":"Unus est Altissimus, creator omnipotens,et rex potens et metuendus nimis, sedens super thronum suum et dominans, Deus."
,"9":"Ipse creavit illam in spiritu sancto,et vidit et dinumeravit et mensus est;"
,"10":"et effudit illam super omnia opera sua,et super omnem carnem secundum largitatem suam,et praebuit illam diligentibus se."
,"11":"Timor Domini gloria et gloriatio,et laetitia et corona exsultationis."
,"12":"Timor Domini delectabit cor,et dabit laetitiam et gaudium et longitudinem dierum."
,"13":"Timenti Dominum bene erit in extremis, et in die defunctionis suae benedicetur."
,"14":"Dilectio Dei honorabilis sapientia;"
,"15":"quibus autem apparuerit, dispertit eam in visionem sui ipsius,et in agnitione magnalium suorum."
,"16":"Initium sapientiae timor Domini, et cum fidelibus in vulva concreata est; cum hominibus veritatis ab aevo fundata est,et semini eorum se credet."
,"17":"Timor Domini scientiae religiositas;"
,"18":"religiositas custodiet et iustificabit cor, iucunditatem atque gaudium dabit.(19),(20 Plenitudo sapientiae est timere Deum; et inebriat eos fructibus suis."
,"21":"Omnem domum illius implebit rebus pretiosis,et receptacula thesauris illius."
,"22":"Corona sapientiae timor Domini, repollens pacem et salutis fructum:"
,"23":"utraque autem sunt dona Dei."
,"24":"Scientiam et intellectum prudentiae sapientia effundit quasi pluviam; et gloriam tenentium se exaltat."
,"25":"Radix sapientiae est timere Dominum, et rami illius longaevi."
,"26":"In thesauris sapientiae intellectus et scientiae religiositas; exsecratio autem peccatoribus sapientia."
,"27":"Timor Domini expellit peccatum; cum autem adsit, omnem avertit iram."
,"28":"Nam, qui sine timore est, non poterit iustificari; iracundia enim animositatis illius subversio illi erit."
,"29":"Usque in tempus sustinebit patiens, et postea erit redditio iucunditatis."
,"30":"Bonus sensus usque in tempus abscondet verba illius, et labia multorum enarrabunt sensum illius."
,"31":"In thesauris sapientiae parabola disciplinae;"
,"32":"exsecratio autem peccatori cultura Dei."
,"33":"Fili, concupiscens sapientiam conserva iustitiam, et Deus praebebit illam tibi."
,"34":"Sapientia enim et disciplina timor Domini, et quod beneplacitum est illi,"
,"35":"fides et mansuetudo."
,"36":"Ne sis incredibilis timori Domini,et ne accesseris ad illum duplici corde."
,"37":"Ne fueris hypocrita in conspectu hominum,et cave a labiis tuis."
,"38":"Ne extollas teipsum, ne forte cadas,et adducas animae tuae inhonorationem,"
,"39":"et revelet Deus absconsa tua,et in medio synagogae elidat te;"
,"40":"quoniam accessisti maligne ad timorem Domini, et cor tuum plenum est dolo et fallacia."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Fili, accedens ad servitutem Dei,sta in iustitia et timore,et praepara animam tuam ad tentationem."
,"2":"Dirige cor tuum et sustine, inclina aurem tuam et suscipe verba intellectus,et ne sollicitus sis in tempore calamitatis."
,"3":"Sustine sustentationes Dei, coniungere Deo et ne laxes, ut sapiens fias in viis tuis."
,"4":"Omne, quod tibi applicitum fuerit, accipe et in dolore sustine,et in humilitate tua patientiam habe,"
,"5":"quoniam in igne probatur aurum et argentum, homines vero receptibiles in camino humiliationis."
,"6":"Crede Deo, et recuperabit te, et spera in illum, et diriget viam tuam; serva timorem illius et in illo veterasce."
,"7":"Metuentes Dominum, sustinete misericordiam eius,et non deflectatis ab illo, ne cadatis."
,"8":"Qui timetis Dominum, credite illi, et non evacuabitur merces vestra."
,"9":"Qui timetis Dominum, sperate in bona,et in oblectationem aevi et in misericordiam."
,"10":"Qui timetis Dominum, diligite illum, et illuminabuntur corda vestra."
,"11":"Respicite, filii, generationes antiquas et videte: quis speravit in Domino et confusus est?"
,"12":"Aut quis permansit in mandatis eius et derelictus est?,Aut quis invocavit eum, et despexit illum?"
,"13":"Quoniam pius et misericors est Dominus,et remittet in die tribulationis peccata,et protector est omnibus exquirentibus se in veritate."
,"14":"Vae duplici corde et labiis scelestis et manibus dissolutis,et peccatori terram ingredienti duabus viis!"
,"15":"Vae dissolutis corde, qui non credunt, et ideo non protegentur!"
,"16":"Vae vobis, qui perdidistis sustinentiam,et qui dereliquistis vias rectas et divertistis in vias pravas!"
,"17":"Et quid facietis, cum inspicere coeperit Dominus?"
,"18":"Qui timent Dominum, non erunt incredibiles verbo illius; et, qui diligunt illum, conservabunt viam illius."
,"19":"Qui timent Dominum, inquirent quae beneplacita sunt ei; et, qui diligunt eum, replebuntur lege ipsius."
,"20":"Qui timent Dominum, praeparabunt corda sua,et in conspectu illius sanctificabunt animas suas."
,"21":"Qui timent Dominum, custodiunt mandata illius,et patientiam habebunt usque ad inspectionem illius"
,"22":"dicentes: ' Si paenitentiam non egerimus, incidemus in manus Domini et non in manus hominum;"
,"23":"secundum enim magnitudinem ipsius, sic et misericordia illius '."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Filii sapientiae ecclesia iustorum, et natio illorum oboedientia et dilectio."
,"2":"Indicium patris audite, filii, et sic facite, ut salvi sitis."
,"3":"Deus enim honoravit patrem in filiis,et iudicium matris firmavit in filios."
,"4":"Qui honorat patrem, exorabit pro peccatis,et continebit se ab illis,et in oratione dierum exaudietur."
,"5":"Et, sicut qui thesaurizat, ita et qui honorificat matrem suam."
,"6":"Qui honorat patrem suum, iucundabitur in filiis,et in die orationis suae exaudietur;"
,"7":"qui honorat patrem suum, vita vivet longiore, et, qui oboedit patri, refrigerabit matrem."
,"8":"Qui timet Dominum, honorat parentes,et quasi dominis serviet his, qui se genuerunt."
,"9":"In opere et sermone honora patrem tuum,"
,"10":"ut superveniat tibi benedictio ab eo."
,"11":"Benedictio patris firmat domos filiorum; maledictio autem matris eradicat fundamenta."
,"12":"Ne glorieris in contumelia patris tui, non est enim tibi gloria eius confusio;"
,"13":"gloria enim hominis ex honore patris sui, et dedecus filii mater sine honore."
,"14":"Fili, suscipe senectam patris tui,et non contristes eum in vita illius;"
,"15":"et, si defecerit sensu, veniam da,et ne spernas eum omnibus diebus vitae eius. Eleemosyna enim patris non erit in oblivione,"
,"16":"nam pro peccatis ipsa plantabitur"
,"17":"et in iustitia aedificabitur tibi; et in die tribulationis commemorabitur tui, et sicut in sereno glacies solventur tua peccata."
,"18":"Quam malae famae est, qui derelinquit patrem; et maledictus a Deo, qui exasperat matrem."
,"19":"Fili, in mansuetudine opera tua perfice,et super hominem datorem diligeris."
,"20":"Quanto magnus es, humilia te in omnibus,et coram Deo invenies gratiam. Multi sunt excelsi et gloriosi, sed mansuetis revelat mysteria sua."
,"21":"Quoniam magna potentia Dei solius, et ab humilibus honoratur."
,"22":"Altiora te ne quaesieris,et fortiora te ne scrutatus fueris; sed, quae praecepit tibi Deus, illa cogita semper,et in pluribus operibus eius ne fueris curiosus."
,"23":"Non est enim tibi necessarium,ea, quae abscondita sunt, videre oculis tuis."
,"24":"In supervacuis rebus noli scrutari multipliciter;"
,"25":"plurima enim super sensum hominum ostensa sunt tibi."
,"26":"Multos quoque supplantavit suspicio illorum, et species vana decepit sensus illorum. Sine pupilla deerit lux, sine scientia deerit sapientia."
,"27":"Cor durum male habebit in novissimo; et, qui amat periculum, in illo peribit."
,"28":"Cor ingrediens duas vias non habebit successus, et pravus corde in illis scandalizabitur."
,"29":"Cor nequam gravabitur doloribus, et peccator adiciet peccatum ad peccatum."
,"30":"Plagis superborum non erit sanitas, frutex enim peccati radicabitur in illis et non intellegetur."
,"31":"Cor sapientis intelleget verba sapientium, et auris audiens concupiscet sapientiam."
,"32":"Sapiens cor et intellegibile abstinebit se a peccatis,et in operibus iustitiae successus habebit."
,"33":"Ignem ardentem exstinguit aqua, sic eleemosyna expiat peccata."
,"34":"Deus prospector est eius, qui reddit gratiam; meminit eius in posterum, et in tempore casus sui inveniet firmamentum."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Fili, eleemosynam pauperis ne defraudes,et oculos tuos ne transvertas a paupere."
,"2":"Animam esurientem ne contristaveris,et non exasperes pauperem in inopia sua."
,"3":"Cor inopis ne afflixeris,et non protrahas datum angustianti."
,"4":"Rogationem contribulati ne abicias,et non avertas faciem tuam ab egeno."
,"5":"Ab inope ne avertas oculos tuos propter iram,et non des ei locum tibi retro maledicendi;"
,"6":"maledicentis enim tibi in amaritudine animae, exaudietur precatio illius: exaudiet autem eum, qui fecit illum."
,"7":"Congregationi affabilem te facito,et presbytero humilia animam tuam,et magnato humilia caput tuum."
,"8":"Declina pauperi sine tristitia aurem tuam,et redde debitum tuum,et responde illi pacifica in mansuetudine."
,"9":"Libera eum, qui iniuriam patitur, de manu opprimentis eum,et non acide feras in anima tua in iudicando."
,"10":"Esto pupillis misericors ut pater,et pro viro matri illorum;"
,"11":"et eris velut filius Altissimi oboediens, et miserebitur tui magis quam mater."
,"12":"Sapientia filiis suis vitam inspiravit,et suscipit inquirentes se."
,"13":"Qui illam diligit, diligit vitam; et, qui vigilaverint ad illam, complectentur placorem a Domino."
,"14":"Qui tenuerint illam, gloriam hereditabunt, et, quo introibit, benedicet Deus."
,"15":"Qui serviunt ei, obsequentes erunt Sancto, et eos, qui diligunt illam, diligit Deus."
,"16":"Qui audit illam, iudicabit gentes; et, qui intuetur illam, permanebit confidens."
,"17":"Si crediderit ei, hereditabit illam, et erunt in possessione generationes illius."
,"18":"Quoniam in simulatione ambulat cum eo,et in primis explorat eum,"
,"19":"timorem et tremorem inducet super illum,et probabit illum in tentatione doctrinae suae, donec ipse teneat eam in cogitationibus suis,et credat animae illius."
,"20":"Et redibit recta ad illum et firmabit illum,et laetificabit illum "
,"21":"et denudabit illi absconsa sua,et thesaurizabit super illum scientiam et intellectum iustitiae."
,"22":"Si autem oberraverit, derelinquet eum,et tradet eum in manus inimici sui."
,"23":"Fili, observa tempus et devita a malo"
,"24":"et pro anima tua ne confundaris;"
,"25":"est enim confusio adducens peccatum, et est confusio adducens gloriam et gratiam."
,"26":"Ne accipias faciem adversus animam tuam,nec adversus animam tuam mendacium."
,"27":"Ne reverearis proximum tuum in casu suo"
,"28":"nec retineas verbum in tempore suo; non abscondas sapientiam tuam in decorem."
,"29":"In verbo enim agnoscitur sapientia, et sensus in responsione linguae."
,"30":"Non contradicas verbo veritatis ullo modo,et de ineruditione tua confundere."
,"31":"Non confundaris confiteri peccata tua,et ne subicias te omni homini pro peccato."
,"32":"Noli resistere contra faciem potentis,nec coneris contra ictum fluvii."
,"33":"Usque ad mortem agonizare pro iustitia, et Deus expugnabit pro te inimicos tuos."
,"34":"Noli citatus esse in lingua tua,et pavidus et remissus in operibus tuis."
,"35":"Noli esse sicut leo in domo tua,evertens domesticos tuos et opprimens subiectos tibi."
,"36":"Non sit porrecta manus tua ad accipiendum,et ad dandum collecta."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ne innitaris possessionibus tuis,et ne dixeris: ' Est mihi sufficiens vita '."
,"2":"Ne sequaris fortitudinem tuam, ut ambules in concupiscentiis cordis tui,"
,"3":"et ne dixeris: ' Quis praevalebit in me? ',aut ' Quis me subiciet propter facta mea? '. Deus enim vindicans vindicabit."
,"4":"Ne dixeris: ' Peccavi, et quid mihi accidit triste? '. Altissimus enim est patiens redditor."
,"5":"De propitiato peccato noli esse sine metu,neque adicias peccatum super peccatum"
,"6":"et ne dicas: ' Miseratio Domini magna est, multitudinis peccatorum meorum miserebitur ';"
,"7":"misericordia enim et ira ab illo cito proximant, et super peccatores requiescit ira illius."
,"8":"Non tardes converti ad Dominum,et ne differas de die in diem."
,"9":"Subito enim veniet ira illius, et in tempore vindictae abripieris."
,"10":"Ne innitaris divitiis iniustis, nihil enim proderunt in die calamitatis."
,"11":"Non ventiles in omnem ventum,et non eas in omnem viam; sic enim omnis peccator probatur in duplici lingua."
,"12":"Esto firmus in sensu tuo,et in veritate sensus tui et scientia; et prosequatur te verbum pacis et iustitiae."
,"13":"Esto velox ad audiendum verbum, ut intellegas,et cum tarditate proferas responsum."
,"14":"Si est tibi intellectus, responde proximo; sin autem, sit manus tua super os tuum, ne capiaris in verbo indisciplinato et confundaris."
,"15":"Honor et ignominia in sermone; lingua vero homini subversio est ipsius."
,"16":"Non appelleris susurro, et lingua tua ne calumnieris."
,"17":"Super furem enim est confusio, et denotatio pessima super bilinguem, susurratori autem odium et inimicitia et contumelia."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Nec pusillum nec multum noceas,et noli fieri pro amico inimicus. Nomen enim malum et improperium et contumeliam hereditabis; sic omnis peccator invidus et bilinguis."
,"2":"Non te extollas in cogitatione animae tuae velut taurus, ne forte elidatur virtus tua per stultitiam,"
,"3":"et folia tua comedat et fructus tuos perdat, et relinquaris velut lignum aridum in eremo."
,"4":"Anima enim nequam disperdet eum, qui se habet, et in gaudium inimicis dat illum,et deducet in sortem impiorum."
,"5":"Os dulce multiplicat amicos et mitigat inimicos; et lingua eucharis salutem dicit."
,"6":"Multi pacifici sint tibi, et consiliarius sit tibi unus de mille."
,"7":"Si possides amicum, in tentatione posside eum,et ne facile credas ei."
,"8":"Est enim amicus secundum opportunitatem suam,et non permanebit in die tribulationis."
,"9":"Et est amicus, qui convertitur ad inimicitiam,et rixam convicii tui denudabit."
,"10":"Est autem amicus socius mensae,et non permanebit in die necessitatis;"
,"11":"in prosperis erit tibi quasi coaequalis,et in domesticis tuis fiducialiter aget."
,"12":"Si humiliatus fueris, convertetur contra te,et a facie tua abscondet se."
,"13":"Ab inimicis tuis separare,et de amicis tuis attende."
,"14":"Amicus fidelis protectio fortis; qui autem invenit illum, invenit thesaurum."
,"15":"Amico fideli nulla est comparatio, et non est ponderatio contra bonitatem illius."
,"16":"Amicus fidelis medicamentum vitae, et, qui metuunt Dominum, invenient illum."
,"17":"Qui timet Deum, aeque habebit amicitiam eius, quoniam secundum illum erit amicus illius."
,"18":"Fili, a iuventute tua excipe doctrinam,et usque ad canos invenies sapientiam."
,"19":"Quasi is qui arat et seminat, accede ad eam,et sustine bonos fructus illius."
,"20":"In opere enim ipsius exiguum laborabis,et cito edes de generationibus illius."
,"21":"Quam aspera est nimium sapientia indoctis hominibus, et non permanebit in illa excors."
,"22":"Quasi lapis probationis gravis erit super illum, et non demorabitur proicere illam."
,"23":"Doctrina est enim secundum nomen eius,et non est multis manifesta; quibus autem cognita est, permanet usque ad conspectum Dei."
,"24":"Audi, fili, et accipe sententiam meam,et ne abicias consilium meum."
,"25":"Inice pedem tuum in compedes illius,et in torques illius collum tuum;"
,"26":"subice umerum tuum et porta illam,et ne acedieris vinculis eius."
,"27":"In omni animo tuo accede ad illam,et in omni virtute tua conserva vias eius."
,"28":"Investiga et scrutare, exquire et invenies, et continens factus ne derelinquas eam."
,"29":"In novissimis enim invenies requiem in ea, et convertetur tibi in oblectationem."
,"30":"Et erunt tibi compedes eius in protectionem fortitudinis, et torques illius in stolam gloriae;"
,"31":"decor enim aureus est in illa, et vincula illius alligatura hyacinthina."
,"32":"Stolam gloriae indues eam,et coronam gratulationis superpones tibi."
,"33":"Fili, si attenderis, disces; et, si accommodaveris animum tuum, prudens eris."
,"34":"Si dilexeris audire, excipies doctrinam; et, si inclinaveris aurem tuam, sapiens eris."
,"35":"In multitudine presbyterorum sta,et sapientiae illorum ex corde coniungere, ut omnem narrationem Dei velis audire, et proverbia intellectus non effugiant a te."
,"36":"Et, si videris sensatum, evigila ad eum, et gradus ostiorum illius exterat pes tuus."
,"37":"Cogitatum tuum habe in praeceptis Dei,et in mandatis illius maxime assiduus esto; et ipse firmabit tibi cor, et concupiscentia sapientiae dabitur tibi."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Noli facere mala, et mala non te apprehendent;"
,"2":"discede ab iniquitate, et deficiet abs te."
,"3":"Fili, non semines in sulcis iniustitiae,et non metes ea in septuplum."
,"4":"Noli quaerere a Domino ducatum,neque a rege cathedram honoris."
,"5":"Non te iustifices ante Deum, quoniam agnitor cordis ipse est; et penes regem noli velle videri sapiens."
,"6":"Noli quaerere fieri iudex, nisi valeas virtute irrumpere iniquitates; ne forte extimescas faciem potentis,et ponas scandalum in aequitate tua."
,"7":"Non pecces in multitudinem civitatis,nec te immittas in populum."
,"8":"Neque alliges duplicia peccata; nec enim in uno eris immunis."
,"9":"Noli esse pusillanimis in oratione tua;"
,"10":"exorare et facere eleemosynam ne despicias."
,"11":"Ne dicas: ' In multitudine munerum meorum respiciet Deus,et, offerente me Deo altissimo, munera mea suscipiet '."
,"12":"Non irrideas hominem in amaritudine animae; est enim, qui humiliat et exaltat, circumspector Deus."
,"13":"Noli arare mendacium adversus fratrem tuum,neque in amicum similiter facias."
,"14":"Noli velle mentiri omne mendacium, assiduitas enim illius non est bona."
,"15":"Noli verbosus esse in multitudine presbyterorum,et non iteres verbum in oratione tua."
,"16":"Non oderis laboriosa opera,et rusticationem creatam ab Altissimo."
,"17":"Non te reputes in multitudine indisciplinatorum;"
,"18":"memento irae, quoniam non tardabit."
,"19":"Humilia valde spiritum tuum, quoniam vindicta carnis impii ignis et vermis."
,"20":"Noli commutare amicum cum pecunia,neque fratrem carissimum cum auro Ophir."
,"21":"Noli discedere a muliere sensata et bona, quam sortitus es in timore Domini; gratia enim verecundiae illius super aurum."
,"22":"Non laedas servum operantem in veritate,neque mercennarium dantem animam suam."
,"23":"Servus sensatus sit tibi dilectus quasi anima tua; non defraudes illum libertate,neque inopem derelinquas illum."
,"24":"Pecora tibi sunt? Attende illis, et, si sunt utilia, perseverent apud te."
,"25":"Filii tibi sunt? Erudi illos,et curva a pueritia cervicem illorum."
,"26":"Filiae tibi sunt? Serva corpus illarum,et non ostendas hilarem faciem tuam ad illas."
,"27":"Trade filiam, et grande opus feceris, et homini sensato da illam."
,"28":"Mulier si est tibi secundum animam tuam, non proicias illam, sed odibili non credas teipsum. In toto corde tuo "
,"29":"honora patrem tuum,et gemitus matris tuae ne obliviscaris."
,"30":"Memento quoniam, nisi per illos, natus non fuisses; et quid retribues illis, quomodo et illi tibi?"
,"31":"In tota anima tua time Dominum,et sacerdotes illius sanctifica."
,"32":"In omni virtute tua dilige eum, qui te fecit, et ministros eius ne derelinquas."
,"33":"Honora Deum ex tota anima tua,et honorifica sacerdotes."
,"34":"Da illis partem, sicut mandatum est tibi, primitiarum et purgationis et de neglegentia"
,"35":"et armum in oblationem,et sacrificium sanctificationis et primitias sanctorum."
,"36":"Et pauperi porrige manum tuam, ut perficiatur propitiatio et benedictio tua."
,"37":"Gratia dati in conspectu omnis viventis, sed et mortuo non prohibeas gratiam."
,"38":"Non desis plorantibus in consolatione,et cum lugentibus luge."
,"39":"Non te pigeat visitare infirmum, ex his enim in dilectione firmaberis."
,"40":"In omnibus operibus tuis memorare novissima tua,et in aeternum non peccabis."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Non litiges cum homine potente, ne forte incidas in manus illius."
,"2":"Non contendas cum viro locuplete, ne forte contra te constituat pondus tuum:"
,"3":"multos enim perdidit aurum, et argentum etiam cor regum subvertit."
,"4":"Non litiges cum homine linguato,et non struas in ignem illius ligna."
,"5":"Non communices homini indocto, ne contemnaris a principibus."
,"6":"Ne despicias hominem avertentem se a peccato,neque improperes ei; memento quoniam omnes in correptione sumus."
,"7":"Ne spernas hominem in sua senectute, etenim ex nobis senescunt."
,"8":"Noli de mortuo inimico tuo gaudere; memento quoniam omnes morimur et in gaudium nolumus venire."
,"9":"Ne despicias narrationem presbyterorum sapientium,et in proverbiis eorum conversare;"
,"10":"ab ipsis enim disces sapientiam et doctrinam intellectus,et servire magnatis sine querela."
,"11":"Non te praetereat narratio seniorum: ipsi enim didicerunt a patribus suis;"
,"12":"quoniam ab ipsis disces intellectum,et in tempore necessitatis dare responsum."
,"13":"Non incendas carbones peccatorum arguens eos,et ne incendaris flamma ignis peccatorum illorum."
,"14":"Ne contra faciem stes contumeliosi, ne sedeat quasi insidiator ori tuo."
,"15":"Noli fenerari homini fortiori te; quod si feneraveris, quasi perditum habe."
,"16":"Non spondeas super virtutem tuam; quod si spoponderis, quasi restituens cogita."
,"17":"Non litiges contra iudicem, quoniam secundum placitum suum iudicat."
,"18":"Cum audace non eas in via, ne forte aggraves mala tua: ipse enim secundum voluntatem suam vadit, et simul cum stultitia illius peries."
,"19":"Cum iracundo non facias rixam,et cum ipso non eas in desertum, quoniam quasi nihil est ante illum sanguis, et, ubi non est adiutorium, elidet te."
,"20":"Cum fatuis consilium non habeas; non enim poterunt occultare secretum tuum."
,"21":"Coram extraneo nihil facias cautum; nescis enim quid pariet."
,"22":"Non omni homini cor tuum manifestes, ne forte repellas a te bonum."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Non zeles mulierem sinus tui, ne doceas contra te notitiam ne quam."
,"2":"Non des mulieri potestatem animae tuae, ne ingrediatur in virtutem tuam, et confundaris."
,"3":"Ne adeas ad mulierem multivolam, ne forte incidas in laqueos illius."
,"4":"Cum psaltria ne assiduus sis nec audias illam, ne forte pereas in efficacitate illius."
,"5":"Virginem ne conspicias, ne forte scandalizeris in decore illius."
,"6":"Ne des fornicariis animam tuam in ullo, ne perdas te et hereditatem tuam."
,"7":"Noli circumspicere in vicis civitatis, nec oberraveris in plateis illius."
,"8":"Averte faciem tuam a muliere compta,et ne circumspicias speciem alienam."
,"9":"Propter speciem mulieris multi perierunt, et ex hoc concupiscentia quasi ignis exardescit."
,"12":"Cum alterius muliere ne sedeas omnino,nec accumbas cum ea super cubitum in vino,"
,"13":"ne forte declinet cor tuum in illam, et sanguine tuo labaris in perditionem."
,"14":"Ne derelinquas amicum antiquum: novus enim non erit similis illi."
,"15":"Vinum novum amicus novus: veterascet, et cum suavitate bibes illud."
,"16":"Non zeles gloriam et opes peccatoris; non enim scis quae futura sit illius subversio."
,"17":"Non placeat tibi prosperitas iniustorum,sciens quoniam usque ad inferos non iustificabuntur."
,"18":"Longe abesto ab homine potestatem habente occidendi,et non suspicaberis timorem mortis;"
,"19":"et, si accesseris ad illum, noli aliquid committere, ne forte auferat vitam tuam."
,"20":"Communionem mortis scito, quoniam in medio laqueorum ingredieris,et super retia ambulabis."
,"21":"Secundum virtutem tuam conversare cum proximo tuo,et cum sapientibus et prudentibus tracta."
,"22":"Et cum sensato sit cogitatus tuus, et omnis enarratio tua in praeceptis Altissimi."
,"23":"Viri iusti sint tibi convivae, et in timore Dei sit tibi gloriatio."
,"24":"In manu artificum opera laudabuntur, et princeps populi in sapientia sermonis sui, in sensu vero seniorum verbum."
,"25":"Terribilis est in civitate sua homo linguosus, et temerarius in verbo suo odibilis erit."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Iudex sapiens instituet populum suum, et principatus sensati stabilis erit."
,"2":"Secundum iudicem populi sic et ministri eius, et qualis rector est civitatis, tales et inhabitantes in ea."
,"3":"Rex insipiens perdet populum suum, et civitates inhabitabuntur per sensum potentium."
,"4":"In manu Dei potestas terrae, et utilem rectorem suscitabit in tempus super illam."
,"5":"In manu Dei prosperitas hominis, et super faciem scribae imponet honorem suum."
,"6":"Pro omni iniuria proximi ne rependas,et nihil agas in operibus superbiae."
,"7":"Odibilis coram Deo est et hominibus superbia, et utrisque execrabilis omnis vexatio."
,"8":"Regnum a gente in gentem transfertur,propter iniustitias et contumelias et divitias dolosas."
,"9":"Avaro autem nihil est scelestius, hic enim et animam suam venalem habet."
,"10":"Quid superbit terra et cinis?,Quoniam in vita sua proiecit intima sua."
,"11":"Languor prolixior gravat medicum, brevis languor serenat medicum."
,"12":"Omnis potentatus brevis vita, sic et rex hodie est et cras morietur."
,"13":"Cum enim morietur homo, hereditabit serpentes et bestias et vermes."
,"14":"Initium superbiae hominis apostatare a Deo;"
,"15":"et ab eo, qui fecit illum, recessit cor eius. Quoniam initium omnis peccati est superbia, qui tenuerit illam, ebulliet maledictum, et subvertet eum in finem."
,"16":"Propterea mirabiles fecit Dominus plagas malorum,et destruxit eos usque in finem."
,"17":"Sedes ducum superborum destruxit Deus,et sedere fecit mites pro eis."
,"18":"Radices gentium superbarum eradicavit Deus,et plantavit humiles pro ipsis."
,"19":"Terras gentium evertit Dominus,et perdidit eas usque ad fundamentum."
,"20":"Arefecit ex ipsis et disperdidit eos,et cessare fecit memoriam eorum a terra."
,"21":"Memoriam superborum perdidit Deus,et reliquit memoriam humilium sensu."
,"22":"Non est creata hominibus superbia, neque iracundia nato mulierum."
,"23":"Semen hominum honoratum hoc, quod timet Deum; semen autem hoc exhonorabitur, quod praeterit mandata Domini."
,"24":"In medio fratrum rector illorum in honore; et, qui timent Dominum, erunt in oculis illius."
,"25":"Peregrinus, advena et pauper: timor Dei est gloria eorum."
,"26":"Noli despicere hominem iustum pauperem,et noli magnificare virum peccatorem divitem."
,"27":"Magnus et iudex et potens est in honore, sed non est maior illo, qui timet Deum."
,"28":"Servo sensato liberi servient; et vir prudens et disciplinatus non murmurabit correptus."
,"29":"Noli extollere te in faciendo opere tuo,et noli gloriari in tempore angustiae tuae."
,"30":"Melior est, qui operatur et abundat in omnibus, quam qui gloriatur et eget pane."
,"31":"Fili, in mansuetudine honora animam tuam,et da illi victum cultumque secundum meritum suum."
,"32":"Peccantem in animam suam quis iustificabit?,Et quis honorificabit exhonorantem animam suam?"
,"33":"Est pauper, qui honoratur propter disciplinam et timorem suum, et est homo, qui honorificatur propter substantiam suam."
,"34":"Qui autem honoratur in paupertate, quanto magis in substantia!,Et, qui exhonoratur in substantia, quanto magis in paupertate!"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Sapientia humiliati exaltabit caput illius,et in medio magnatorum consedere illum faciet."
,"2":"Non laudes virum in specie sua,neque spernas hominem deformem in visu suo."
,"3":"Brevis in volatilibus est apis, et initium dulcoris habet fructus illius."
,"4":"In vestitu ne glorieris umquam,nec in die honoris tui extollaris, quoniam mirabilia opera Altissimi solius, et absconsa et invisa hominibus opera illius."
,"5":"Multi tyranni sederunt in terra, et insuspicabilis portavit diadema."
,"6":"Multi potentes exhonorati sunt valide, et gloriosi traditi sunt in manus alterorum."
,"7":"Priusquam interroges, ne vituperes quemquam, sed, postquam interrogaveris, corripe iuste."
,"8":"Priusquam audias, ne respondeas verbum,et in medio sermonum ne adicias loqui."
,"9":"De ea re, quae te non molestat, ne certeris,et in iudicio peccantium ne consistas."
,"10":"Fili, ne in multis sint actus tui; etsi festinaveris, non eris immunis a delicto: si enim persecutus fueris, non apprehendes, et non effugies, si discurreris."
,"11":"Est homo laborans et festinans et dolens,et tanto magis non abundabit."
,"12":"Est homo marcidus egens susceptione, plus deficiens virtute et abundans paupertate;"
,"13":"et oculus Dei respexit illum in bono,et erexit eum ab humilitate ipsius,et exaltavit caput eius: et mirati sunt in illo multi."
,"14":"Bona et mala, vita et mors, paupertas et honestas a Deo sunt."
,"15":"Sapientia et disciplina et scientia legis apud Dominum; dilectio et viae bonorum apud ipsum."
,"16":"Error et tenebrae peccatoribus concreata sunt; qui autem exsultant in malis, consenescunt in malo."
,"17":"Datio Dei permanet iustis, et beneplacitum illius successus habebit in aeternum."
,"18":"Est qui locupletatur parce agendo, et haec est pars mercedis illius"
,"19":"in eo quod dicit: ' Inveni requiem mihi, et nunc manducabo de bonis meis solus';"
,"20":"et nescit quod tempus praeteriet, et mors appropinquet, et relinquet omnia aliis et morietur."
,"21":"Sta in mandato tuo et in illo conversare,et in opere mandatorum tuorum veterasce."
,"22":"Ne mireris in operibus peccatorum; confide autem in Deo et mane in labore tuo."
,"23":"Facile est enim in oculis Dei subito honestare pauperem."
,"24":"Benedictio Dei in mercede iusti continuo, et in hora veloci successus illius fructificat."
,"25":"Ne dicas: ' Quid est mihi opus?,Et, quae erunt mihi ex hoc bona? '."
,"26":"Ne dicas: ' Sufficiens mihi sum; et, quid ex hoc nunc pessimabor? '"
,"27":"In die bonorum ne immemor sis malorum,et in die malorum ne immemor sis bonorum,"
,"28":"quoniam facile est coram Deo in die obitus,retribuere unicuique secundum vias suas."
,"29":"Malitia horae oblivionem facit luxuriae magnae, et in fine hominis denudatio operum illius."
,"30":"Ante mortem ne laudes hominem quemquam, quoniam in extremis suis agnoscitur vir."
,"31":"Non omnem hominem inducas in domum tuam, multae enim sunt insidiae dolosi."
,"32":"Sicut enim eructant praecordia foetentium, et sicut perdix inducitur in caveam, et ut caprea in laqueum, sic et cor superborum, et sicut prospector videns casum proximi sui."
,"33":"Bona enim in mala convertens insidiator,et in electis imponet maculam."
,"34":"A scintilla una augentur carbones, et ab uno doloso augetur sanguis; homo vero peccator sanguini insidiatur."
,"35":"Attende tibi a pestifero, fabricat enim mala; ne forte inducat super te maculam in perpetuum."
,"36":"Admitte ad te alienigenam, et subvertet te in turbore,et abalienabit te a tuis propriis."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Si benefeceris, scito cui feceris, et erit gratia in bonis tuis multa."
,"2":"Benefac iusto et invenies retributionem magnam,et, si non ab ipso, certe a Domino."
,"3":"Non est enim ei bene, qui assiduus est in malis,et eleemosynas non dat, quoniam et Altissimus odio habet peccatores,et misertus est paenitentibus."
,"4":"Da misericordi et ne suscipias peccatorem; et impiis et peccatoribus reddet vindictam,custodiens eos in diem vindictae."
,"5":"Da bono et non receperis peccatorem."
,"6":"Benefac humili et non dederis impio; vasa belli ne dederis illi, ne in ipsis potentior te sit."
,"7":"Nam duplicia mala invenies,in omnibus bonis quaecumque feceris illi, quoniam et Altissimus odio habet peccatores,et impiis reddet vindictam."
,"8":"Non agnoscetur in bonis amicus, et non abscondetur in malis inimicus."
,"9":"In bonis viri etiam inimici illius sunt amici, et in malis etiam amicus discedit."
,"10":"Non credas inimico tuo in aeternum, sicut enim aeramentum aeruginat nequitia illius"
,"11":"et, si humiliatus vadat curvus, adice animum tuum et custodi te ab illo,et fias ei sicut qui extergit speculum, et cognosces quoniam in finem aeruginavit."
,"12":"Non statuas illum penes te, nec sedeat ad dexteram tuam, ne forte conversus in locum tuum,inquirat cathedram tuam; et in novissimo agnoscas verba mea et in sermonibus meis stimuleris."
,"13":"Quis miserebitur incantatori a serpente percusso,et omnibus, qui appropiant bestiis?,Et sic qui comitatur cum viro iniquo,et obvolutus est in peccatis eius: non evadet, donec incendat eum ignis."
,"14":"Una hora tecum permanebit; si autem declinaveris, non supportabit."
,"15":"In labiis suis indulcat inimicus,et in corde suo insidiatur, ut subvertat te in foveam."
,"16":"In oculis suis lacrimatur inimicus,et, si invenerit opportunitatem, non satiabitur sanguine."
,"17":"Si incurrerint tibi mala, invenies eum illic priorem,"
,"18":"et quasi adiuvans suffodiet plantas tuas."
,"19":"Caput suum movebit et plaudet manu,et multa susurrans commutabit vultum suum."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Qui tetigerit picem, inquinabitur ab ea; et, qui communicaverit superbo, induet superbiam."
,"2":"Pondus super te ne tollas,et honestiori et ditiori te ne socius fueris."
,"3":"Quid communicabit caccabus ad ollam?,Quando enim se colliserint, confringetur."
,"4":"Dives iniuste egit et fremet, pauper autem laesus, ipse supplicabit."
,"5":"Si utilis fueris, assumet te,et, si non habueris, derelinquet te."
,"6":"Si habes, convivet tecum et evacuabit te,et ipse non dolebit super te."
,"7":"Si necessarius illi fueris, ludet te,et subridens spem dabit narrans tibi bona,et dicet: ' Quid opus est tibi? '."
,"8":"Et confundet te in cibis suis, donec te exinaniat bis et ter,et in novissimo deridebit te; et postea videns derelinquet te,et caput suum movebit ad te."
,"9":"Humiliare Deo et exspecta manus eius."
,"10":"Attende, ne seductus in stultitiam humilieris."
,"11":"Noli esse humilis in sapientia tua, ne humiliatus in stultitiam seducaris."
,"12":"Advocatus a potentiore discede, et eo magis te advocabit."
,"13":"Ne accedas, ne impingaris; et ne longe sis ab eo, ne eas in oblivionem."
,"14":"Ne retineas ex aequo loqui cum illo,nec credas multis verbis illius; ex multa enim loquela tentabit te,et subridens inquiret de absconditis tuis."
,"15":"Immitis animus illius conservabit verba tua,et non parcet de malitia et de vinculis."
,"16":"Cave tibi et attende diligenter auditui tuo, quoniam cum subversione tua ambulas."
,"17":"Audiens vero illa,ex somno evigila."
,"18":"Omni vita tua dilige Deum,et invoca illum in salutem tuam."
,"19":"Omne animal diligit simile sibi: sic et omnis homo proximum sibi."
,"20":"Omnis caro ad similem sibi coniungetur, et omnis homo simili sui sociabitur."
,"21":"Quid communicabit lupus agno?,Sic peccator iusto."
,"22":"Quae pax hyaenae ad canem?,Aut quae pars diviti ad pauperem?"
,"23":"Venatio leonis onager in eremo, sic et pascua divitum sunt pauperes."
,"24":"Et sicut abominatio est superbo humilitas, sic et exsecratio divitis pauper."
,"25":"Dives commotus confirmatur ab amicis suis, humilis autem, cum ceciderit, expelletur et a notis."
,"26":"Diviti decepto multi recuperatores: locutus est nefaria, et iustificaverunt illum;"
,"27":"humilis deceptus est, insuper et arguitur: locutus est sensate, et non est datus ei locus."
,"28":"Dives locutus est, et omnes tacuerunt, et verbum illius usque ad nubes perducent;"
,"29":"pauper locutus est, et dicunt: ' Quis est hic? ',et, si offenderit, insuper subvertent illum."
,"30":"Bona est substantia, cui non est peccatum in conscientia, et nequissima paupertas in ore impii."
,"31":"Cor hominis immutat faciem illius,sive in bona sive in mala."
,"32":"Vestigium cordis boni facies hilaris: difficile invenies et cum labore."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Beatus vir, qui non est lapsus verbo ex ore suo,et non est stimulatus in tristitia delicti."
,"2":"Felix, quem non condemnat anima sua, et non excidit a spe sua."
,"3":"Viro tenaci sine ratione est substantia; et homini livido ad quid aurum?"
,"4":"Qui denegat animo suo iniuste, aliis congregat, et in bonis illius alius luxuriabitur."
,"5":"Qui sibi nequam est, cui alii bonus erit?,Et non iucundabitur in bonis suis."
,"6":"Qui sibi invidet, nihil est illo nequius; et haec redditio est malitiae illius."
,"7":"Et, si bene fecerit, ignoranter et non volens facit,et in novissimo manifestat malitiam suam."
,"8":"Nequam est oculus lividi,et avertens faciem suam et despiciens animas."
,"9":"Insatiabilis oculus cupidi in parte non satiabitur, donec consumat arefaciens animam suam."
,"10":"Oculus malus lividus irruit in panem,et neglegens est mensae suae."
,"11":"Fili, si habes, benefac tecum,et Deo dignas oblationes offer."
,"12":"Memor esto quoniam mors non tardat, et decretum inferorum quia non demonstratum est tibi; decretum enim huius mundi: morte morietur."
,"13":"Ante mortem benefac amico tuo,et secundum vires tuas exporrigens da ei."
,"14":"Non defrauderis a bono diei, et particula desiderii boni non te praetereat."
,"15":"Nonne aliis relinques res dolore partas,et labores tuos in divisione sortis?"
,"16":"Da et accipe et oblecta animam tuam;"
,"17":"ante obitum tuum operare iustitiam, quoniam non est apud inferos quaerere voluptates."
,"18":"Omnis caro sicut vestimentum veterascet,et sicut folium fructificans in arbore viridi: alia generantur, et alia deiciuntur;"
,"19":"sic generatio carnis et sanguinis: alia finitur, et alia nascitur."
,"20":"Omne opus corruptibile in fine deficiet, et, qui illud operatur, ibit cum illo;"
,"21":"et omne opus electum iustificabitur, et, qui operatur illud, honorabitur in illo."
,"22":"Beatus vir, qui in sapientia morabitur,et qui in iustitia sua meditabitur,et in sensu cogitabit circumspectionem Dei;"
,"23":"qui excogitat vias illius in corde suo,et in absconditis suis intellegens, vadens post illam quasi investigator,et in viis illius consistens;"
,"24":"qui respicit per fenestras illius,et in ianuis illius audiens;"
,"25":"qui requiescit iuxta domum illius,et in parietibus illius figens palum, statuet casulam suam ad manus illius,et requiescet in deversorio bonorum per aevum."
,"26":"Statuet filios suos sub tegmine illius,et sub ramis eius morabitur;"
,"27":"protegetur sub tegmine illius a fervore,et in gloria eius requiescet."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Qui timet Deum, faciet haec, et, qui continens est legis, apprehendet illam;"
,"2":"et obviabit illi quasi mater honorificata,et quasi mulier a virginitate suscipiet illum."
,"3":"Cibabit illum pane vitae et intellectus,et aqua sapientiae salutaris potabit illum, et firmabitur in illa et non flectetur"
,"4":"et confidet in illam et non confundetur; et exaltabit illum prae proximis suis"
,"5":"et in medio ecclesiae aperiet os eius,et adimplebit illum spiritu sapientiae et intellectus,et stola gloriae vestiet illum;"
,"6":"iucunditatem et exsultationem thesaurizabit super illum,et nomine aeterno hereditabit illum."
,"7":"Homines stulti non apprehendent illam, et homines sensati obviabunt illi; homines peccatores non videbunt eam, longe enim abest a superbia et dolo."
,"8":"Viri mendaces non erunt illius memores; et viri veraces invenientur in illa,et successum habebunt usque ad inspectionem Dei."
,"9":"Non est speciosa laus in ore peccatoris,"
,"10":"quoniam non a Deo tributa est ei; sapientiae enim Dei astabit laus, et in ore sapientis dicetur laus, et dominator illius docebit eam."
,"11":"Ne dixeris: ' A Deo peccatum meum ',quae enim odit, ipse non facit."
,"12":"Non dicas: ' Ille in me impegit '; non enim necessarii sunt ei homines impii."
,"13":"Omne exsecramentum erroris odit Dominus, et non erit amabile timentibus eum."
,"14":"Deus ab initio constituit hominem,et reliquit illum in manu consilii sui,et dedit eum in manum concupiscentiae suae."
,"15":"Adiecit mandata et praecepta sua,et intellegentiam ad faciendum placitum eius."
,"16":"Si volueris mandata servare, conservabunt te; si confidis in illo, etiam tu vives."
,"17":"Apposuit tibi aquam et ignem; ad quod volueris, porrige manum tuam."
,"18":"Ante hominem vita et mors, bonum et malum: quod placuerit ei, dabitur illi."
,"19":"Quoniam multa sapientia Dei, et fortis in potentia videns omnes sine intermissione."
,"20":"Oculi Domini ad timentes eum, et ipse agnoscit omnem operam hominis."
,"21":"Nemini mandavit impie agere,et nemini dedit spatium peccandi."
,"22":"Non concupiscas multitudinem filiorum infidelium et iniquorum."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Ne iucunderis in filiis impiis; si multiplicentur, non oblecteris super ipsos, si non est timor Dei cum illis."
,"2":"Non credas vitae illorum,et ne respexeris in labores eorum."
,"3":"Melior est enim unus timens Deum,quam mille filii impii;"
,"4":"et potius est mori sine filiis,quam relinquere filios impios."
,"5":"Ab uno sensato inhabitabitur patria, tribus autem impiorum deseretur."
,"6":"Multa talia vidit oculus meus, et fortiora horum audivit auris mea."
,"7":"In synagoga peccantium exardebit ignis, et in gente incredibili exardescet ira."
,"8":"Non exoraverunt eum antiqui gigantes, qui rebelles fuerunt confidentes suae virtuti."
,"9":"Et non pepercit accolis Lot,et exsecratus est eos prae superbia verbi illorum;"
,"10":"non misertus est gentis anathematis, qui depulsi sunt in peccatis suis."
,"11":"Et sicut sescenta milia peditum, qui congregati sunt in duritia cordis sui; et, si unus fuisset cervicatus, mirum si fuisset immunis:"
,"12":"misericordia enim et ira est cum illo, sustinens, exorabilis et effundens iram."
,"13":"ecundum multam misericordiam suam, sic et correptio illius: hominem secundum opera sua iudicat."
,"14":"Non effugiet in rapina peccator, et non irrita erit sustinentia iusti."
,"15":"Omni misericordiae erit merces: unusquisque secundum meritum operum suorum inveniet coram se,et secundum intellectum peregrinationis ipsius. Dominus induravit cor pharaonis, ne agnosceret illum, ut opera sua innotescerent sub caelo. Misericordia eius apparuit omnibus creaturis eius, lucem suam et tenebras dispertiit filiis hominum."
,"16":"Non dicas: ' A Deo abscondar!,Et, ex summo quis mei memorabitur?"
,"17":"In populo magno non agnoscar; quae est enim anima mea in tam immensa creatura? '."
,"18":"Ecce caelum et caeli caelorum, abyssus et universa terra et quae in eis sunt, in visitatione illius commovebuntur;"
,"19":"montes simul et colles et fundamenta terrae, cum conspexerit illa Deus, tremore concutientur."
,"20":"Et in omnibus his non apponet cor, etenim omne cor intellegitur ab illo."
,"21":"Et vias illius quis intellegit,et procellam, quam nec oculus videbit hominis?"
,"22":"Nam plurima illius opera sunt in absconsis, et opera iustitiae eius quis enuntiabit, aut quis sustinebit?,Longe enim est decretum, et interrogatio omnium in consummatione est."
,"23":"Qui minoratur corde, cogitat ista, et vir imprudens et errans cogitat stulta."
,"24":"Audi me, fili, et disce prudentiam sensus,"
,"25":"et dicam in aequitate disciplinam,et scrutabor enarrare sapientiam; et in verbis meis attende in corde tuo. Edico in aequitate spiritus virtutes, quas posuit Deus in opera sua ab initio, et in veritate enuntio scientiam eius."
,"26":"Quando creavit Deus opera sua ab initio,et ab institutione ipsorum distinxit partes illorum,"
,"27":"ornavit in aeternum opera illorum,et dominatum eorum in generationibus suis. Nec esurierunt nec laboraverunt,et non destiterunt ab operibus suis."
,"28":"Unusquisque proximum sibi non angustiavit,"
,"29":"et usque in aeternum non erunt incredibiles verbo illius."
,"30":"Post haec Deus in terram respexit,et complevit illam bonis suis;"
,"31":"anima omnis vitalis cooperuit faciem ipsius, et in ipsam iterum reversio illorum."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Deus creavit de terra hominem,et secundum imaginem suam fecit illum;"
,"2":"et iterum convertit illum in ipsam,et secundum se vestivit illum virtute."
,"3":"Numerum dierum et tempus dedit illi,et dedit illi potestatem eorum, quae sunt super terram."
,"4":"Posuit timorem illius super omnem carnem, ut dominaretur bestiarum et volatilium."
,"5":"Creavit illis consilium et linguam et oculos et aures,et cor dedit illis excogitandi,et disciplina intellectus replevit illos."
,"6":"Creavit illis scientiam spiritus, sensu implevit cor illorum,et mala et bona ostendit illis."
,"7":"Posuit timorem suum super corda illorum,ostendens illis magnalia operum suorum"
,"8":"et dedit illis gloriari in mirabilibus illius, ut nomen sanctificationis collaudent,et magnalia enarrent operum eius."
,"9":"Addidit illis disciplinam,et legem vitae hereditavit illos."
,"10":"Testamentum aeternum constituit cum illis,et iustitiam et iudicia sua ostendit illis."
,"11":"Et magnalia honoris eius vidit oculus illorum, et honorem vocis eius audierunt aures illorum, et dixit illis: ' Attendite ab omni iniquo '."
,"12":"Et mandavit illis unicuique de proximo suo."
,"13":"Viae illorum coram ipso sunt semper: non sunt absconsae ab oculis ipsius."
,"14":"In unamquamque gentem praeposuit rectorem,"
,"15":"et pars Dei Israel factus est."
,"16":"Et omnia opera illorum velut sol in conspectu eius; et oculi eius sine intermissione inspicientes in viis eorum."
,"17":"Non sunt absconsae iniquitates illorum,et omnia peccata eorum in conspectu Dei."
,"18":"Eleemosyna viri quasi signaculum cum ipso, et gratiam hominis quasi pupillam conservabit."
,"19":"Et postea resurget et retribuet illis,et retributionem unicuique in caput ipsorum convertet."
,"20":"Paenitentibus autem dedit viam reditus,et confirmavit deficientes sustinere,et destinavit illis sortem veritatis."
,"21":"Convertere ad Dominum et relinque peccata tua;"
,"22":"precare ante faciem Domini et minue offendicula."
,"23":"Revertere ad Altissimum et avertere ab iniustitia tua,et nimis odito exsecrationem."
,"24":"Et cognosce iustitias et iudicia Dei,et sta in sorte propositionis et orationis altissimi Dei."
,"25":"Altissimum quis laudabit in inferis,pro vivis et dantibus confessionem Deo?"
,"26":"Non demoreris in errore impiorum; ante mortem confitere: a mortuo, quasi nihil sit, perit confessio."
,"27":"Confiteberis vivens, vivus et sanus confiteberis,et laudabis Deum et gloriaberis in miserationibus illius."
,"28":"Quam magna misericordia Domini, et propitiatio illius convertentibus ad se!"
,"29":"Nec enim omnia possunt esse in hominibus, quoniam non est immortalis filius hominis."
,"30":"Quid lucidius sole? Et hic deficiet. Aut quid nequius quam quod excogitavit caro et sanguis?,Et hoc arguetur."
,"31":"Virtutem altitudinis caeli ipse conspicit, et omnes homines terra et cinis."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Qui vivit in aeternum, creavit omnia simul. Deus solus iustificabitur et manet invictus rex in aeternum."
,"2":"Quis sufficit enarrare opera illius?"
,"3":"Et quis investigabit magnalia eius?"
,"4":"Virtutem autem magnitudinis eius quis enuntiabit?,Aut quis adiciet enarrare misericordiam eius?"
,"5":"Non est minuere neque adicere,nec est invenire magnalia Dei;"
,"6":"cum consummaverit homo, tunc incipiet,et, cum quieverit, aporiabitur."
,"7":"Quid est homo, quis defectus, et quae est utilitas illius?,Et quid est bonum, aut quid nequam illius?"
,"8":"Numerus dierum hominum ut multum centum anni, quasi gutta aquae maris deputati sunt, et sicut calculus arenae, sic exigui anni in die aevi."
,"9":"Propter hoc patiens est Deus in illis,et effundit super eos misericordiam suam."
,"10":"Vidit praesumptionem cordis eorum, quoniam mala est; et cognovit subversionem illorum, quoniam nequam est."
,"11":"Ideo adimplevit propitiationem suam in illis,et ostendit eis viam aequitatis."
,"12":"Miseratio hominis circa proximum suum, misericordia autem Dei super omnem carnem."
,"13":"Qui reprehendit, docet et erudit,quasi pastor dirigens gregem suum."
,"14":"Miseretur excipientibus doctrinam miserationis,et festinantibus in iudiciis eius."
,"15":"Fili, in bonis non des querelam,et in omni dato non des tristitiam verbi mali."
,"16":"Nonne ardorem refrigerabit ros?,Sic et verbum melius quam datum."
,"17":"Nonne ecce verbum super datum bonum?,Sed utraque cum homine gratioso."
,"18":"Stultus acriter improperabit, et datus indisciplinati tabescere facit oculos."
,"19":"Ante iudicium para advocatum tibi,et, antequam loquaris, disce."
,"20":"Ante languorem adhibe medicinam,et ante iudicium interroga teipsum,et in hora visitationis invenies propitiationem."
,"21":"Ante languorem humilia te,et in tempore peccati ostende conversionem tuam."
,"22":"Non sinas te impediri reddere votum tempore opportuno,et ne tardes usque ad mortem iustificari, quoniam merces Dei manet in aeternum."
,"23":"Ante votum praepara animam tuam,et noli esse quasi homo, qui tentat Dominum."
,"24":"Memento irae in die consummationis,et, suo tempore, retributionis in conversione faciei."
,"25":"Memento famis in tempore abundantiae,et necessitatum paupertatis in die divitiarum."
,"26":"A mane usque ad vesperam mutatur tempus, et haec omnia citata in oculis Dei."
,"27":"Homo sapiens in omnibus metuet,et in diebus delictorum cavebit a malitia."
,"28":"Omnis astutus agnoscit sapientiam,et invenienti eam dabit confessionem."
,"29":"Sensati in verbis et ipsi sapienter egerunt,et intellexerunt veritatem et iustitiam,et effuderunt tamquam pluviam proverbia et iudicia."
,"30":"De continentia animae. Post concupiscentias tuas non eas,et a voluptatibus tuis te contine;"
,"31":"si praestes animae tuae beneplacitum concupiscentiae, faciet te in gaudium inimicis tuis."
,"32":"Ne oblecteris in multa epulatione; duplex enim portio est paupertas illius."
,"33":"Ne fueris ganeo et potator, cum nihil tibi est in sacculo: eris enim invidus vitae tuae."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Operarius ebriosus non locupletabitur; et, qui spernit modica, paulatim decidet."
,"2":"Vinum et mulieres apostatare faciunt sensatos; et, qui se iungit fornicariis, peribit: putredo et vermes hereditabunt illum."
,"3":"Anima audax perdet dominum suum; et tolletur de numero anima eius, et extolletur in exemplum maius."
,"4":"Qui credit cito, levis corde est et minorabitur; et, qui delinquit in animam suam, quis innoxium faciet?"
,"5":"Qui gaudet iniquitate, denotabitur, et, qui odit correptionem, minuetur vita, et, qui odit loquacitatem, exstinguit malitiam. (6)"
,"7":"Ne umquam iteres verbum nequam et durum,et prorsus non minoraberis."
,"8":"De amico et inimico noli narrare,et, si notum est tibi delictum, noli denudare:"
,"9":"audiet enim te et cavebit te,et quasi defendens peccatum odiet te."
,"10":"Audisti verbum adversus proximum tuum?,Commoriatur in te fidens quoniam non te dirumpet."
,"11":"A facie verbi parturiet fatuus,tamquam parturiens a facie infantis;"
,"12":"sagitta infixa femori carnis, sic verbum in corde stulti."
,"13":"Corripe amicum, ne forte fecerit malum et ipse dicat: ' Non feci '; aut, si fecerit, ne iterum addat facere."
,"14":"Corripe proximum, ne forte dixerit,et, si dixerit, ne forte iteret."
,"15":"Corripe amicum, saepe enim fit criminatio,"
,"16":"et non omni verbo credas. Est qui labitur lingua sed non ex animo;"
,"17":"quis est enim qui non deliquerit in lingua sua?,Corripe proximum, antequam commineris,"
,"18":"et da locum legi Altissimi. Quia omnis sapientia timor Dei et in illa timere Deum, et in omni sapientia dispositio legis."
,"19":"Et non est sapientia nequitiae scientia, et non est consilium peccatorum prudentia."
,"20":"Est astutia et ipsa exsecratio, et est insipiens, qui minuitur sapientia."
,"21":"Melior est homo, qui minuitur sapientia et deficiens sensu in timore, quam qui abundat sensu et transgreditur legem Altissimi."
,"22":"Est solertia certa et ipsa iniqua."
,"23":"Et est qui pervertit gratiam, ut proferat iudicium; est qui videtur oppressus et fractus animo, et interiora eius plena sunt dolo."
,"24":"Et est qui se nimium submittit a multa humilitate; et est qui inclinat faciem suam,et fingit se non audire: ubi ignoratus est, praeveniet te."
,"25":"Et, si ab imbecillitate virium vetetur peccare, si invenerit tempus malefaciendi, malefaciet."
,"26":"Ex visu cognoscitur vir, et ab occursu faciei cognoscitur sensatus:"
,"27":"amictus corporis et risus dentium,et gressus hominis enuntiant de illo."
,"28":"Est correptio inopportuna, et est indicium, quod non probatur esse bonum; et est tacens, et ipse est prudens."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Quam bonum est arguere quam irasci, et confitentem in oratione non prohibere!"
,"2":"Concupiscentia spadonis devirginans iuvenculam:"
,"3":"sic qui facit per vim iudicium iniquum."
,"4":"Quam bonum est correptum manifestare paenitentiam!,Sic enim effugies voluntarium peccatum."
,"5":"Est tacens, qui invenitur sapiens, et est odibilis, quia procax est ad loquendum."
,"6":"Est tacens non habens responsum, et est tacens sciens tempus aptum."
,"7":"Homo sapiens tacebit usque ad tempus, lascivus autem et imprudens non servabunt tempus."
,"8":"Qui multis utitur verbis, exsecrabitur; et, qui potestatem sibi assumit iniuste, odietur."
,"9":"Est processus in malis viro indisciplinato, et est inventio in detrimentum."
,"10":"Est datum, quod non est utile, et est datum, cuius retributio duplex."
,"11":"Est propter gloriam minoratio, et est qui ab humilitate levat caput."
,"12":"Est qui multa redimat modico pretio,et restituens ea in septuplum."
,"13":"Sapiens in verbis seipsum amabilem facit, gratiae autem fatuorum effundentur."
,"14":"Datum insipientis non erit utile tibi, oculi enim illius septemplices sunt:"
,"15":"exigua dabit et multa improperabit, et apertio oris illius quasi clamantis."
,"16":"Hodie feneratur quis et cras expetit: odibilis est homo huiusmodi."
,"17":"Fatuus dicit: ' Non est mihi amicus, et non est gratia bonis meis '."
,"18":"Qui enim edunt panem illius, falsae linguae sunt. Quoties et quanti irridebunt eum!"
,"19":"Neque enim, quod habendum erat, directo sensu distribuit, similiter et, quod non erat habendum, est indifferens ei."
,"20":"Melius lapsus in pavimento quam lapsus linguae: sic casus malorum festinanter veniet."
,"21":"Homo acharis quasi fabula importuna; in ore indisciplinatorum assidua erit."
,"22":"Ex ore fatui reprobabitur parabola, non enim dicit illam in tempore suo."
,"23":"Est qui vetatur peccare prae inopia, et in requie sua non stimulabitur."
,"24":"Est qui perdit animam suam prae confusione, et ab imprudenti persona perdet eam; personae autem acceptione perdet se."
,"25":"Est qui prae confusione promittit amico, et lucratus est eum inimicum gratis."
,"26":"Opprobrium nequam in homine mendacium, et in ore indisciplinatorum assidue erit."
,"27":"Potior fur quam assiduitas viri mendacis; perditionem autem ambo hereditabunt."
,"28":"Mos hominis mendacis est sine honore, et confusio illius cum ipso sine intermissione."
,"29":"Verbum parabolarum. Sapiens in verbis producet seipsum, et homo prudens placebit magnatis."
,"30":"Qui operatur terram suam, inaltabit acervum frugum, et, qui operatur iustitiam, ipse exaltabitur; qui vero placet magnatis, effugiet iniquitatem."
,"31":"Xenia et dona excaecant oculos iudicum,et quasi camus in ore avertunt correptiones eorum."
,"32":"Sapientia absconsa et thesaurus invisus, quae utilitas in utrisque?"
,"33":"Melior est, qui celat insipientiam suam, quam homo, qui abscondit sapientiam suam."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Fili, peccasti? Non adicias iterum, sed et de pristinis deprecare, ut tibi dimittantur."
,"2":"Quasi a facie colubri fuge peccata: et, si accesseris ad illa, mordebunt te."
,"3":"Dentes leonis dentes eorum,interficientes animas hominum."
,"4":"Quasi romphaea bis acuta omnis iniquitas: plagae illius non est sanitas."
,"5":"Terror et iniuriae annullabunt substantiam, et domus, quae nimis locuples est, annullabitur superbia; sic substantia superbi eradicabitur."
,"6":"Deprecatio pauperis ex ore usque ad aures Dei perveniet, et iudicium festinato adveniet illi."
,"7":"Qui odit correptionem, in vestigio est peccatoris; et, qui timet Deum, convertet illam ad cor suum."
,"8":"Notus a longe potens lingua audaci, et sensatus novit illum labi."
,"9":"Qui aedificat domum suam impendiis alienis, quasi qui colligit lapides suos in hiemem."
,"10":"Stuppa collecta synagoga peccantium, et consummatio illorum flamma ignis."
,"11":"Via peccantium complanata lapidibus, et in fine illius fovea inferi."
,"12":"Qui custodit legem, continebit sensum suum;"
,"13":"consummatio timoris Dei sapientia et sensus."
,"14":"Non erudietur, qui non est prudens;"
,"15":"est autem astutia, quae abundat in malo, et non est sensus, ubi est amaritudo."
,"16":"Scientia sapientis tamquam inundatio abundabit, et consilium illius sicut fons vitae permanet."
,"17":"Cor fatui quasi vas confractum,et omnem sapientiam non tenebit."
,"18":"Verbum sapiens, quodcumque audierit scius, laudabit et ad illud adiciet; audivit luxuriosus, et displicebit illi,et proiciet illud post dorsum suum."
,"19":"Narratio fatui quasi sarcina in via, sed in labiis sensati invenietur gratia."
,"20":"Os prudentis quaeretur in ecclesia, et verba illius cogitabunt in cordibus suis."
,"21":"Tamquam domus exterminata sic fatuo sapientia; et scientia insensati inenarrabilia verba."
,"22":"Compedes in pedibus stulto doctrina,et quasi vincula manuum super manum dexteram."
,"23":"Fatuus in risu exaltat vocem suam; vir autem sapiens vix tacite ridebit."
,"24":"Tamquam ornamentum aureum prudenti doctrina,et quasi brachiale in brachio dextro."
,"25":"Pes fatui facilis in domum proximi, sed homo peritus verebitur personam."
,"26":"Stultus a fenestra respiciet in domum, vir autem eruditus foris stabit."
,"27":"Ineruditio hominis auscultare per ostium, et prudenti gravis contumelia."
,"28":"Labia imprudentium stulta narrabunt, verba autem prudentium statera ponderabuntur."
,"29":"In ore fatuorum cor illorum, et in corde sapientium os illorum."
,"30":"Dum maledicit impius adversarium, maledicit ipse animam suam."
,"31":"Susurro coinquinabit animam suam et in omnibus odietur; et, qui cum eo manserit, odiosus erit: tacitus et sensatus honorabitur."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Lapidi luteo comparatus est piger, et omnes sibilabunt super aspernationem illius;"
,"2":"fimo boum comparatus est piger: et omnis, qui tetigerit eum, excutiet manus."
,"3":"Confusio patris est de filio indisciplinato, filia autem in deminorationem generatur."
,"4":"Filia prudens hereditas viro suo, nam, quae confundit, in contumeliam fit genitoris."
,"5":"Patrem et virum confundit filia audax, ab utrisque autem inhonorabitur."
,"6":"Musica in luctu importuna narratio; disciplina et doctrina in omni tempore sapientia."
,"7":"Qui docet fatuum, quasi qui conglutinat testam;"
,"8":"qui narrat verbum non audienti, quasi qui excitat dormientem de gravi somno."
,"9":"Cum dormiente loquitur, qui enarrat stulto sapientiam, et in fine narrationis dicit: ' Quis est hic? '."
,"10":"Supra mortuum plora, defecit enim lux, et supra fatuum plora, defecit enim sensus."
,"11":"Modicum plora supra mortuum, quoniam requievit;"
,"12":"nequissima enim vita fatui super mortem."
,"13":"Luctus mortui septem dies, fatui autem et impii omnes dies vitae illorum."
,"14":"Cum stulto ne multum loquaris,et cum insensato ne abieris."
,"15":"Serva te ab illo, ut non molestiam habeas, et non coinquinaberis impactione illius."
,"16":"Deflecte ab illo et invenies requiem,et non acediaberis in stultitia illius."
,"17":"Super plumbum quid gravius?,Et quod illi aliud nomen quam fatuus?"
,"18":"Arenam et salem et massam ferri facilius est ferre,quam hominem imprudentem et fatuum et impium."
,"19":"Loramentum ligneum colligatum in fundamento aedificii,non dissolvetur; sic et cor confirmatum in cogitatione consilii, nullus timor illud commovebit."
,"20":"Cor firmatum in cogitatu intellegentiae,sicut ornatus in pariete polito."
,"21":"Sicut pali in excelsis et caementa sine impensa posita,contra faciem venti non permanebunt,"
,"22":"sic et cor timidum in cogitatione stulti,contra impetum timoris non resistet. (23)"
,"24":"Pungens oculum deducit lacrimas, et, qui pungit cor, pellit amicitiam."
,"25":"Mittens lapidem in volatilia fugat illa; sic et qui conviciatur amico, dissolvit amicitiam."
,"26":"Ad amicum etsi produxeris gladium, non desperes: est enim regressus; ad amicum "
,"27":"si aperueris os triste, non timeas: est enim concordatio, excepto convicio et improperio et superbia,et mysterii revelatione et plaga dolosa; in his omnis effugiet amicus."
,"28":"Fidem posside cum amico in paupertate illius, ut et in bonis illius communices;"
,"29":"in tempore tribulationis illius permane illi fidelis, ut et in hereditate illius coheres sis."
,"30":"Ante ignem camini vapor et fumus, sic et ante sanguinem maledicta et contumeliae et minae."
,"31":"Amicum tegere non confundar, a facie illius non me abscondam; et, si mala mihi evenerint per illum, sustinebo:"
,"32":"omnis, qui audiet, cavebit se ab eo."
,"33":"Quis dabit ori meo custodiam,et super labia mea signaculum aptum, ut non cadam ab ipsis, et lingua mea perdat me?"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Domine, pater et dominator vitae meae, ne derelinquas me in consilio eorum,nec sinas me cadere in illis."
,"2":"Quis superponet in cogitatu meo flagella,et in corde meo doctrinam sapientiae, ut ignorationibus meis non parcant mihi, et non appareant delicta mea,"
,"3":"et ne adincrescant ignorantiae meae, et multiplicentur delicta mea, et peccata mea abundent, et incidam in conspectu adversariorum meorum, et gaudeat super me inimicus meus?"
,"4":"Domine, pater et Deus vitae meae, ne derelinquas me in cogitatu illorum."
,"5":"Extollentiam oculorum meorum ne dederis mihi,et omne desiderium averte a me."
,"6":"Aufer a me ventris concupiscentias, et concubitus concupiscentiae ne apprehendant me, et animae irreverenti et infrunitae ne tradas me."
,"7":"De doctrina oris. Doctrinam oris audite, filii; et, qui custodierit illam, non capietur labiis,nec scandalizabitur in operibus nequissimis."
,"8":"In labiis suis apprehendetur peccator, et maledicus et superbus scandalizabitur in illis."
,"9":"Iurationi non assuescas os tuum: multi enim casus in illa."
,"10":"Nominatio vero Dei non sit assidua in ore tuo, et nominibus sanctorum non admiscearis, quoniam non eris immunis ab eis."
,"11":"Sicut enim servus exquisitus assidue,livore carere non poterit, sic omnis iurans et nominans in toto,a peccato non purgabitur."
,"12":"Vir multum iurans implebitur iniquitate, et non discedet a domo illius plaga."
,"13":"Et, si frustraverit, delictum illius super ipsum erit; et, si dissimulaverit, delinquet dupliciter."
,"14":"Et, si in vacuum iuraverit, non iustificabitur: replebitur enim malis domus illius."
,"15":"Est et alia loquela morti comparanda: non inveniatur in hereditate Iacob."
,"16":"Etenim a timoratis omnia haec sunt remota, et in delictis non volutabuntur."
,"17":"Indisciplinatae turpitudini non assuescat os tuum: est enim in illa verbum peccati."
,"18":"Memento patris et matris tuae, in medio enim magnatorum consistis;"
,"19":"ne forte obliviscaris tui in conspectu illorum,et assiduitate tua infatuatus improperium patiaris,et maluisses non nasci et diem nativitatis tuae maledicas."
,"20":"Homo assuetus in verbis improperii,in omnibus diebus suis non erudietur."
,"21":"Duo genera abundant in peccatis, et tertium adducit iram et perditionem:"
,"22":"anima calida quasi ignis ardens,non exstinguetur, donec consumatur;"
,"23":"et homo fornicarius in corpore carnis suae,non desinet, donec incendat ignem."
,"24":"Homini fornicario omnis panis dulcis: non cessabit nisi in morte."
,"25":"Omnis homo, qui transgreditur super lectum suum,contemnens in anima sua et dicens: ' Quis me videt?"
,"26":"Tenebrae circumdant me, et parietes cooperiunt me, et nemo circumspicit me; quem vereor?,Delictorum meorum non memorabitur Altissimus '"
,"27":"et non intellegit quoniam omnia videt oculus illius, quoniam expellit a se timorem Dei huiusmodi hominis timor. Et oculi hominum sunt timor illius,"
,"28":"et non cognovit quoniam oculi Domini,multo plus lucidiores sunt super solem,circumspicientes omnes vias hominum et profundum abyssi,et hominum corda intuentes in absconditas partes."
,"29":"Domino enim Deo, antequam crearentur, omnia sunt agnita; sic et, postquam perfecta sunt, respicit omnia."
,"30":"Hic in plateis civitatis vindicabitur,et quasi pullus equinus fugabitur,et, ubi non speravit, apprehendetur;"
,"31":"et erit dedecus omnibus, eo quod non intellexerit timorem Domini."
,"32":"Sic et mulier omnis relinquens virum suum,et statuens hereditatem ex alieno matrimonio."
,"33":"Primo enim in lege Altissimi incredibilis fuit, secundo in virum suum deliquit, tertio in adulterio fornicata est,et ex alio viro filios statuit sibi."
,"34":"Haec in ecclesiam adducetur,et in filios eius respicietur;"
,"35":"non tradent filii eius radices, et rami eius non dabunt fructum:"
,"36":"derelinquet in maledictum memoriam suam, et dedecus illius non delebitur."
,"37":"Et agnoscent, qui derelicti sunt, quoniam nihil melius est quam timor Dei, et nihil dulcius quam attendere mandatis Domini."
,"38":"Gloria magna est sequi Dominum; longitudo enim dierum assumetur ab eo."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Laus sapientiae. Sapientia laudabit animam suam et in Deo honorabitur,et in medio populi sui gloriabitur"
,"2":"et in ecclesia Altissimi aperiet os suum,et in conspectu virtutis illius gloriabitur"
,"3":"et in medio populi sui exaltabitur,et in plenitudine sancta admirabitur"
,"4":"et in multitudine electorum habebit laudem,et inter benedictos benedicetur dicens:"
,"5":"' Ego ex ore Altissimi prodivi, primogenita ante omnem creaturam."
,"6":"Ego feci in caelis, ut oriretur lumen indeficiens, et sicut nebula texi omnem terram."
,"7":"Ego in altissimis habitavi, et thronus meus in columna nubis."
,"8":"Gyrum caeli circuivi sola,et in profundum abyssi ambulavi,"
,"9":"in fluctibus maris et in omni terra steti"
,"10":"et in omni populo et in omni gente primatum habui"
,"11":"et omnium excellentium et humilium corda virtute calcavi. In his omnibus requiem quaesivi: cuius in hereditate morabor?"
,"12":"Tunc praecepit et dixit mihi Creator omnium, et, qui creavit me, quietem dedit tabernaculo meo"
,"13":"et dixit mihi: 'In Iacob inhabita et in Israel hereditare,et in electis meis mitte radices'."
,"14":"Ab initio ante saecula creata sum,et usque ad futurum saeculum non desinam."
,"15":"Et in tabernaculo sancto coram ipso ministravi, et sic in Sion firmata sum,et in civitate similiter dilecta requievi, et in Ierusalem potestas mea."
,"16":"Et radicavi in populo honorificato,et in parte Domini, in hereditate illius, et in plenitudine sanctorum detentio mea."
,"17":"Quasi cedrus exaltata sum in Libano, et quasi cupressus in montibus Hermon."
,"18":"Quasi palma exaltata sum in Engaddi, et quasi plantatio rosae in Iericho."
,"19":"Quasi oliva speciosa in campis, et quasi platanus exaltata sum iuxta aquam in plateis."
,"20":"Sicut cinnamomum et balsamum aromatizans odorem dedi; quasi myrrha electa dedi suavitatem odoris."
,"21":"Et quasi storax et galbanus et ungula et gutta, et quasi libani vapor in tabernaculo."
,"22":"Ego quasi terebinthus extendi ramos meos, et rami mei rami honoris et gratiae."
,"23":"Ego quasi vitis germinavi gratiam, et flores mei fructus honoris et honestatis."
,"24":"Ego mater pulchrae dilectionis et timoris,et agnitionis et sanctae spei."
,"25":"In me gratia omnis viae et veritatis, in me omnis spes vitae et virtutis."
,"26":"Transite ad me, omnes, qui concupiscitis me, et a generationibus meis implemini."
,"27":"Doctrina enim mea super mel dulcis, et hereditas mea super mel et favum;"
,"28":"memoria mea in generationes saeculorum."
,"29":"Qui edunt me, adhuc esurient; et, qui bibunt me, adhuc sitient."
,"30":"Qui audit me, non confundetur; et, qui operantur in me, non peccabunt:"
,"31":"qui elucidant me, vitam aeternam habebunt '."
,"32":"Haec omnia liber testamenti Altissimi,"
,"33":"lex, quam mandavit nobis Moyses, hereditas domui Iacob."
,"34":"Posuit David puero suo excitare regem ex ipso fortissimum, et in throno honoris sedentem in sempiternum."
,"35":"Lex, quae implet quasi Phison sapientiam,et sicut Tigris in diebus novorum,"
,"36":"quae adimplet quasi Euphrates sensum,et quasi Iordanis in tempore messis,"
,"37":"quae redundavit disciplina sicut Nilus,et assistens quasi Geon in die vindemiae."
,"38":"Non perfecit primus scire ipsam, sic nec ultimus investigavit eam."
,"39":"Super mare enim abundavit cogitatio eius, et consilium illius super abyssum magnam."
,"40":"Ego sapientia effudi flumina,"
,"41":"ego quasi trames aquae immensae de fluvio,et sicut aquaeductus exivi in paradisum."
,"42":"Dixi: ' Rigabo hortum meum plantationum,et inebriabo prati mei fructum '."
,"43":"Et ecce factus est mihi trames in fluvium, et fluvius meus appropinquavit ad mare."
,"44":"Quoniam doctrinam quasi antelucanum illuminabo,et enarrabo illam usque ad longinquum."
,"45":"Penetrabo omnes inferiores partes terrae,et inspiciam omnes dormientes,et illuminabo omnes sperantes in Domino;"
,"46":"adhuc doctrinam quasi prophetiam effundam,et relinquam illam in generationes saeculorum,et non desinam in progenies illorum usque in aevum sanctum."
,"47":"Videte quoniam non soli mihi laboravi, sed omnibus exquirentibus illam."
}`)
	CurrentBook.AddChapter(25, `{
"1":"In tribus placitum est spiritui meo, quae sunt probata coram Deo et hominibus:"
,"2":"concordia fratrum et amor proximorum,et vir et mulier bene sibi consentientes."
,"3":"Tres species odivit anima mea, et aggravor valde animae illorum:"
,"4":"pauperem superbum, divitem mendacem, senem fatuum et insensatum."
,"5":"In iuventute tua non congregasti; quomodo in senectute tua invenies?"
,"6":"Quam speciosum canitiei iudicium, et presbyteris cognoscere consilium!"
,"7":"Quam speciosa veteranis sapientia, et gloriosis intellectus et consilium!"
,"8":"Corona senum multa peritia, et gloria illorum timor Dei."
,"9":"Novem insuspicabilia cordis magnificavi, et decimum dicam in lingua hominibus:"
,"10":"homo, qui iucundatur in filiis, vivens et videns subversionem inimicorum suorum;"
,"11":"beatus, qui habitat cum muliere sensata,et non arat in bove et in asino simul; et qui lingua sua non est lapsus, et qui non servivit indigno se;"
,"12":"beatus, qui invenit amicum verum, et qui enarrat iustitiam auri audienti;"
,"13":"quam magnus, qui invenit sapientiam et scientiam, sed non est super timentem Dominum."
,"14":"Timor Dei super omnia excedit;"
,"15":"qui tenet illum, cui assimilabitur?"
,"16":"Timor Dei initium dilectionis eius; fides autem initium adhaesionis ei."
,"17":"Omnis plaga tristitia cordis est, et omnis malitia nequitia mulieris."
,"18":"Et omnem plagam et non plagam cordis;"
,"19":"et omnem nequitiam et non nequitiam mulieris;"
,"20":"et omnem calamitatem et non calamitatem odientium;"
,"21":"et omnem vindictam et non vindictam inimicorum."
,"22":"Non est venenum nequius super venenum colubri,"
,"23":"et non est ira super iram mulieris; commorari leoni et draconi placebit,quam habitare cum muliere nequam."
,"24":"Nequitia mulieris immutat faciem eius,et obscurat vultum eius tamquam ursus. In medio proximorum eius accumbet vir eius"
,"25":"et invitus suspirabit amare."
,"26":"Parva omnis malitia prae malitia mulieris: sors peccatorum cadat super illam."
,"27":"Sicut ascensus arenosus in pedibus veterani, sic mulier linguata homini quieto."
,"28":"Ne incidas in mulieris speciem,et non concupiscas mulieris opes."
,"29":"Ira et irreverentia et confusio magna"
,"30":"mulier, si primatum habeat super virum suum."
,"31":"Cor humile et facies tristis,et plaga cordis mulier nequam."
,"32":"Manus debiles et genua dissoluta,mulier, quae non beatificat virum suum."
,"33":"A muliere initium factum est peccati, et per illam omnes morimur."
,"34":"Non des aquae tuae exitum, nec modicum, nec mulieri nequam veniam prodeundi."
,"35":"Si non ambulaverit ad manum tuam, confundet te in conspectu inimicorum;"
,"36":"a carnibus tuis abscinde illam,et dimitte illam de domo tua."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Mulieris bonae beatus vir: numerus enim dierum illius duplex."
,"2":"Mulier fortis oblectat virum suum,et annos vitae illius in pace implebit."
,"3":"Pars bona mulier bona; in parte timentium Deum dabitur viro pro factis bonis."
,"4":"Divitis autem vel pauperis cor bonum; in omni tempore vultus illorum hilaris."
,"5":"A tribus timuit cor meum, et de quarto facies mea metuit:"
,"6":"delaturam civitatis et collectionem populi,"
,"7":"calumniam mendacem, super mortem omnia gravia;"
,"8":"dolor cordis et luctus mulier zelotypa in mulierem;"
,"9":"et flagellum linguae omnibus communicans."
,"10":"Sicut boum iugum, quod movetur, ita et mulier nequam; qui tenet illam, quasi qui apprehendat scorpionem."
,"11":"Mulier ebriosa ira magna et contumelia, et turpitudo illius non tegetur."
,"12":"Fornicatio mulieris in extollentia oculorum,et in palpebris illius agnoscetur."
,"13":"In filia pervicaci firma custodiam, ne, inventa occasione, utatur sibi."
,"14":"Ab omni irreverentia oculorum eius cave,et ne mireris, si te neglexerit."
,"15":"Sicut viator sitiens ad fontem os aperiet,et ab omni aqua proxima bibet,et contra omnem palum sedebit,et contra omnem sagittam aperiet pharetram, donec deficiat."
,"16":"Gratia mulieris sedulae delectabit virum suum, et ossa illius impinguabit "
,"17":"disciplina illius. Datum Dei est "
,"18":"mulier sensata et tacita; non est commutatio eruditae animae."
,"19":"Gratia super gratiam mulier sancta et pudorata;"
,"20":"omnis autem ponderatio non est digna continentis animae."
,"21":"Sicut sol oriens mundo in altissimis Dei, sic mulieris bonae species in ornamentum domus eius."
,"22":"Lucerna splendens super candelabrum sanctum, et species faciei super staturam stabilem;"
,"23":"columnae aureae super bases argenteas, et pedes speciosi super plantas stabiles mulieris."
,"24":"Fundamenta aeterna supra petram solidam, et mandata Dei in corde mulieris sanctae."
,"25":"In duobus contristatum est cor meum, et in tertio iracundia mihi advenit:"
,"26":"vir bellator deficiens per inopiam,et vir sensatus contemptus"
,"27":"et qui transgreditur a iustitia ad peccatum; Deus parabit eum ad romphaeam."
,"28":"Duae species difficiles et periculosae mihi apparuerunt: difficile eruitur negotians a neglegentia, et non iustificabitur caupo a peccatis."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Propter lucrum multi deliquerunt; et, qui quaerit locupletari, avertet oculum suum."
,"2":"Sicut in medio compaginis lapidum palus figitur, sic et inter medium venditionis et emptionis constringitur peccatum.(3)"
,"4":"Si non in timore Domini tenueris te, instanter cito subvertetur domus tua."
,"5":"Sicut in percussura cribri remanent quisquiliae, sic peripsemata hominis in cogitatu illius."
,"6":"Vasa figuli probat fornax, et homines iustos tentatio tribulationis."
,"7":"Sicut rusticationem ligni ostendit fructus illius, sic verbum ex cogitatu cordis hominis."
,"8":"Ante sermonem non laudes virum: haec enim tentatio est hominum."
,"9":"Si sequaris iustitiam, apprehendes illam,et indues quasi poderem honoris,et inhabitabis cum ea, et proteget te in sempiternum, et in die agnitionis invenies firmamentum."
,"10":"Volatilia ad sibi similia conveniunt, et veritas ad eos, qui operantur illam, revertetur."
,"11":"Leo venationi insidiatur semper, sic peccata operantibus iniquitates."
,"12":"Loquela timorati semper in sapientia manet; stultus autem sicut luna mutatur."
,"13":"In medio insensatorum serva tempus, in medio autem cogitantium assiduus esto."
,"14":"Loquela stultorum odiosa, et risus illorum in deliciis peccati."
,"15":"Loquacitas multum iurantis horripilationem capiti statuet, et rixa illorum obturatio aurium."
,"16":"Effusio sanguinis rixa superborum, et maledictio illorum auditus gravis."
,"17":"Qui denudat arcana, amici fidem perdit,et non inveniet amicum ad animum suum:"
,"18":"dilige amicum et coniungere fide cum illo;"
,"19":"quod, si denudaveris absconsa illius, non persequeris post eum."
,"20":"Sicut enim homo, qui extulit mortuum suum, sic et qui perdit amicitiam proximi sui;"
,"21":"et sicut qui dimittit avem de manu sua, sic dereliquisti proximum tuum et non eum capies."
,"22":"Non illum sequaris, quoniam longe abest; effugit enim quasi caprea de laqueo, quoniam vulnerata est anima eius;"
,"23":"ultra eum non poteris colligare. Et maledicti est concordatio,"
,"24":"denudare autem amici mysteria,amputatio spei est."
,"25":"Annuens oculo fabricat iniqua; qui novit eum, recedet ab illo."
,"26":"In conspectu oculorum tuorum condulcabit os suum,et super sermones tuos admirabitur; novissime autem pervertet os suum,et in verbis tuis dabit scandalum."
,"27":"Multa odivi et non coaequavi ei, et Dominus odiet illum."
,"28":"Qui in altum mittit lapidem, super caput eius cadet, et plaga dolosa dolosi dividet vulnera."
,"29":"Qui foveam fodit, incidet in eam, et, qui statuit lapidem proximo, offendet in eo, et, qui laqueum alii ponit, capietur in illo."
,"30":"Facienti nequissimum consilium, super ipsum devolvetur, et non agnoscet, unde adveniat illi."
,"31":"Illusio et improperium superbo, et vindicta sicut leo insidiabitur illi."
,"32":"Laqueo capientur, qui oblectantur casu iustorum, dolor autem consumet illos, antequam moriantur."
,"33":"Ira et furor utraque exsecrabilia sunt, et vir peccator continens erit illorum."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Qui vindicari vult, a Domino inveniet vindictam, et peccata illius servans servabit."
,"2":"Dimitte proximo tuo nocenti te, et tunc deprecanti tibi peccata tua solventur."
,"3":"Homo homini reservat iram,et a Deo quaerit medelam?"
,"4":"In hominem similem sibi non habet misericordiam,et de peccatis suis deprecatur?"
,"5":"Ipse, cum caro sit, reservat iram,et propitiationem petit a Deo?,Quis exorabit pro delictis illius?"
,"6":"Memento novissimorum et desine inimicari,"
,"7":"tabitudinis et mortis et permane in mandatis eius."
,"8":"Memorare mandatorum et non irascaris proximo."
,"9":"Memorare testamentum Altissimi,et ne respicias ignorantiam proximi."
,"10":"Abstine te a lite et minues peccata:"
,"11":"homo enim iracundus incendit litem, et vir peccator turbabit amicos,et in medio pacem habentium immittet inimicitiam."
,"12":"Secundum enim ligna silvae sic ignis exardescit, et secundum virtutem hominis sic iracundia illius erit, et secundum substantiam suam exaltabit iram suam."
,"13":"Certamen festinatum incendit ignem, et lis festinans effundit sanguinem, et lingua testificans adducit mortem."
,"14":"Si sufflaveris in scintillam, quasi ignis exardebit; et, si exspueris super illam, exstinguetur: utraque ex ore tuo proficiscuntur."
,"15":"Susurro et bilinguis maledictus: multos enim perdidit pacem habentes."
,"16":"Lingua tertia multos commovit,et dispersit illos de gente in gentem;"
,"17":"civitates muratas divitum destruxit,et domos magnatorum evertit;"
,"18":"virtutes populorum concidit,et gentes fortes dissolvit."
,"19":"Lingua tertia mulieres viratas eiecit,et privavit illas laboribus suis."
,"20":"Qui respicit illam, non habebit requiem,nec habebit amicum, in quo requiescat."
,"21":"Flagelli plaga livorem facit, plaga autem linguae comminuet ossa;"
,"22":"multi ceciderunt in ore gladii, sed non sic quasi qui interierunt per linguam suam."
,"23":"Beatus, qui tectus est ab ea, qui in iracundiam illius non transivit, et qui non attraxit iugum illius,et in vinculis eius non est ligatus."
,"24":"Iugum enim illius iugum ferreum est, et vinculum illius vinculum aereum est;"
,"25":"mors illius mors nequissima, et utilis potius infernus quam illa."
,"26":"Non obtinebit imperium iustorum, et in flamma eius non comburentur;"
,"27":"qui relinquunt Deum, incident in illam, et exardebit in illis et non exstinguetur,et immittetur in illos quasi leo,et quasi pardus laedet illos."
,"28":"Saepi aures tuas spinis, linguam nequam noli audire,et ori tuo facito ostia et seras."
,"29":"Aurum tuum et argentum tuum obsigna,et verbis tuis facito stateram et frenos ori tuo rectos."
,"30":"Et attende, ne forte labaris in lingua, ne cadas in conspectu inimicorum insidiantium tibi, et sit casus tuus insanabilis in mortem."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Qui facit misericordiam, feneratur proximo suo; et, qui confortat manu, mandata servat."
,"2":"Fenerare proximo tuo in tempore necessitatis illius,et iterum redde proximo in tempore suo."
,"3":"Confirma verbum et fideliter age cum illo, et omni tempore invenies, quod tibi necessarium est."
,"4":"Multi quasi inventionem aestimaverunt fenus,et praestiterunt molestiam his, qui se adiuverunt."
,"5":"Donec accipiat, osculatur manus dantis,et de possessionibus proximi humiliat vocem suam;"
,"6":"et in tempore redditionis postulabit tempus, et reddet verba taedii et murmurationum et tempus causabitur."
,"7":"Si autem potuerit reddere, adversabitur; solidi vix reddet dimidium,et computabit illud quasi inventionem."
,"8":"Sin autem, fraudabit illum pecunia sua,et possidebit illum inimicum gratis."
,"9":"Et convicia et maledicta reddet illi,et pro honore et beneficio reddet illi contumeliam."
,"10":"Multi non causa nequitiae non fenerati sunt, sed fraudari gratis timuerunt."
,"11":"Verumtamen super humilem longanimis esto,et pro eleemosyna non trahas illum."
,"12":"Propter mandatum assume pauperem,et propter inopiam eius ne dimittas eum vacuum."
,"13":"Perde pecuniam propter fratrem et amicum tuum,et non abscondas illam sub lapide in perditionem."
,"14":"Pone thesaurum tuum in praeceptis Altissimi, et proderit tibi magis quam aurum."
,"15":"Conclude eleemosynam in corde pauperis, et haec pro te exorabit ab omni malo. (16 17)"
,"18":"Super scutum roboris et super lanceam ponderis,adversus inimicum tuum pugnabit pro te."
,"19":"Vir bonus fidem facit pro proximo suo; et, qui perdiderit confusionem, fugiet repromissorem."
,"20":"Gratiam fideiussoris ne obliviscaris: dedit enim pro te animam suam. (21)"
,"22":"Bona repromissoris dissipabit peccator, et ingratus sensu derelinquet liberantem se. (23)"
,"24":"Repromissio multos perdidit recte agentes,et commovit illos quasi fluctus maris;"
,"25":"viros potentes transmigrare fecit, et vagati sunt in gentibus alienis."
,"26":"Peccator transgrediens mandata Domini,incidet in repromissionem, et, qui conatur lucrum sectari, incidet in iudicium."
,"27":"Sponde pro proximo secundum virtutem tuam, sed attende tibi, ne incidas."
,"28":"Initium vitae hominis aqua et panis et vestimentum,et domus protegens turpitudinem."
,"29":"Melior est victus pauperis sub tegmine asserum,quam epulae splendidae in peregre sine domicilio."
,"30":"Super parvo et magno placeat tibi, et improperium peregrinationis non audies."
,"31":"Vita nequam hospitandi de domo in domum, et ubi hospitabitur, non fiducialiter aget, nec aperiet os."
,"32":"Hospitaberis et pasceris et potaberis sine gratia, et ad haec amara audiet:"
,"33":"' Transi, hospes, et orna mensam,et, si quae in manu habes, ciba me! '."
,"34":"' Exi a facie honoratioris!,Necessitudine domus meae hospitio mihi factus est frater '."
,"35":"Gravia haec homini habenti sensum: obiurgatio peregrinationis et improperium feneratoris."
}`)
	CurrentBook.AddChapter(30, `{
"1":"De filiis. Qui diligit filium suum, assi duat illi flagella, ut laetetur in novissimo suo."
,"2":"Qui docet filium suum, fructum habebit in illo,et in medio domesticorum in illo gloriabitur."
,"3":"Qui docet filium suum, in zelum mittet inimicum,et in medio amicorum gloriabitur in illo."
,"4":"Mortuus est pater eius et quasi non est mortuus: similem enim reliquit sibi post se."
,"5":"In vita sua vidit et laetatus est in illo, in obitu suo non est contristatus. Nec confusus est coram inimicis:"
,"6":"reliquit enim defensorem domus contra inimicos,et amicis reddentem gratiam."
,"7":"Qui blanditur filio, colligabit vulnera eius, et super omnem vocem turbabuntur viscera sua."
,"8":"Equus indomitus evadit durus, et filius remissus evadet praeceps."
,"9":"Lacta filium, et paventem te faciet; lude cum eo, et contristabit te."
,"10":"Non corrideas illi, ne doleas, et in novissimo obstupescent dentes tui."
,"11":"Non des illi potestatem in iuventute,et ne despicias errata illius."
,"12":"Curva cervicem eius in iuventute,et tunde latera eius, dum infans est, ne forte induret et non credat tibi, et erit tibi ab illo dolor animae."
,"13":"Doce filium tuum et operare in illo, ne in turpitudinem illius offendas."
,"14":"Melior est pauper sanus et fortis viribus,quam dives imbecillis et flagellatus in carne sua."
,"15":"Salus carnis melior est omni auro et argento, et spiritus validus quam census immensus."
,"16":"Non est census super censum salutis corporis, et non est oblectatio super cordis gaudium."
,"17":"Melior est mors quam vita amara, et requies aeterna quam languor perseverans."
,"18":"Bona effusa in ore clauso,quasi appositiones epularum circumpositae sepulcro."
,"19":"Quid proderit libatio idolo?,Nec enim manducabit nec odorabitur:"
,"20":"sic qui effugatur a Domino,portans mercedes iniquitatis,"
,"21":"videns oculis et ingemiscens,sicut spado complectens virginem et suspirans."
,"22":"Tristitiam non des animae tuae,et non affligas temetipsum in consilio tuo."
,"23":"Iucunditas cordis haec est vita hominis,et thesaurus sine defectione sanctitatis, et exsultatio viri est longaevitas."
,"24":"Indulge animae tuae et consolare cor tuum,et tristitiam longe repelle a te."
,"25":"Multos enim occidit tristitia, et non est utilitas in illa;"
,"26":"zelus et iracundia minuunt dies, et ante tempus senectam adducet cogitatus."
,"27":"Splendidum cor et bonum in epulis est; epulae enim illius diligenter fiunt."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Vigilia divitis tabefacit carnes, et cogitatus illius aufert somnum;"
,"2":"cogitatus victus avertit somnum, et infirmitas gravis a somno excitat."
,"3":"Laboravit dives in congregatione substantiae,et, si requiescit, replebitur deliciis suis;"
,"4":"laboravit pauper in penuria victus,et, si requiescit, inops fit."
,"5":"Qui aurum diligit, non iustificabitur, et, qui insequitur lucrum, in eo oberrabit."
,"6":"Multi dati sunt in ruinam auri gratia, et facta est in facie ipsorum perditio illorum."
,"7":"Lignum offensionis est aurum sacrificantium; vae illis, qui sectantur illud: et omnis imprudens capietur in illo."
,"8":"Beatus dives, qui inventus est sine macula,et qui post aurum non abiit,nec speravit in pecunia et thesauris."
,"9":"Quis est hic, et laudabimus eum?,Fecit enim mirabilia in populo suo."
,"10":"Quis probatus est in illo et perfectus est?,Erit illi gloria aeterna. Quis potuit transgredi et non est transgressus, facere mala et non fecit?"
,"11":"Ideo stabilita sunt bona illius in Domino, et eleemosynas illius enarrabit omnis ecclesia sanctorum."
,"12":"De continentia. Supra mensam magnam sedisti?,Non aperias super illam faucem tuam prior."
,"13":"Non dicas: 'Multa sunt, quae super illam sunt!'."
,"14":"Memento quoniam malum est oculus nequam; oculum nequam odit Deus."
,"15":"Nequius oculo quid creatum est?,Ideo ab omni facie lacrimatur."
,"16":"Quocumque aspexerit, ne extendas manum tuam prior,et invidia contaminatus erubescas;"
,"17":"nec comprimaris cum eo in catino."
,"18":"Intellege, quae sunt proximi tui, ex teipso,et de omni verbo cogita;"
,"19":"utere quasi homo frugi his, quae tibi apponuntur, ne, cum manducas multum, odio habearis."
,"20":"Cessa prior disciplinae causa,et noli nimius esse, ne forte offendas."
,"21":"Et, si in medio multorum sedisti, prior illis ne extendas manum tuam nec prior poscas bibere."
,"22":"Quam sufficiens est homini erudito vinum exiguum!,Et in dormiendo non laborabis ab illo et non senties dolorem."
,"23":"Vigilia, cholera et tortura ventris viro infrunito;"
,"24":"somnus sanitatis in homine parco: dormiet usque mane, et anima illius cum ipso delectabitur."
,"25":"Et, si coactus fueris in edendo multum, surge e medio, evome, et refrigerabit te, et non adduces corpori tuo infirmitatem."
,"26":"Audi me, fili, et ne spernas me,et in novissimo invenies verba mea."
,"27":"In omnibus operibus tuis esto modestus, et omnis infirmitas non occurret tibi."
,"28":"Splendidum in panibus benedicent labia multorum, et testimonium bonitatis illius fidele;"
,"29":"nequissimo in pane murmurabit civitas, et testimonium nequitiae illius verum est."
,"30":"In vino noli provocare; multos enim exterminavit vinum."
,"31":"Fornax probat aciem ferri in intinctione: sic vinum in lite corda superborum."
,"32":"Quasi vita hominibus vinum, si bibas illud moderate."
,"33":"Quae est vita ei, qui minuitur vino?"
,"34":"Quid defraudat vitam? Mors."
,"35":"Vinum in iucunditatem creatum est,et non in ebrietatem, ab initio."
,"36":"Exsultatio animae et gaudium et voluptas cordis,vinum moderate potatum in tempore;"
,"37":"sanitas est animae et corpori sobrius potus."
,"38":"Vinum multum potatum irritationem,et iram et ruinas multas facit."
,"39":"Amaritudo animae vinum multum potatum,in irritatione et ruina."
,"40":"Ebrietas multiplicat animositatem imprudentis in offensionem, minorans virtutem et faciens vulnera."
,"41":"In convivio vini non arguas proximum,et non despicias eum in iucunditate illius;"
,"42":"verba improperii non dicas illi,et non premas illum in repetendo."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Rectorem te posuerunt? Noli extolli: esto in illis quasi unus ex ipsis."
,"2":"Curam illorum habe et sic conside,et omni cura tua explicita recumbe,"
,"3":"ut laeteris propter illos,et decentiae gratia accipias coronam,et dignationem consequaris corrogationis."
,"4":"Loquere, maior natu: decet enim te"
,"5":"primum verbum in diligenti scientia; et non impedias musicam."
,"6":"Ubi convivium, non effundas sermonem,et importune noli extolli in sapientia tua."
,"7":"Gemmula carbunculi in ornamento auri, et concentus musicorum in convivio vini;"
,"8":"sicut in fabricatione aurea signum est smaragdi, sic numerus musicorum in iucundo et moderato vino."
,"9":"Audi tacens, et pro reverentia accedet tibi bona gratia."
,"10":"Adulescens, loquere in tua causa vix;"
,"11":"bis, si interrogatus fueris."
,"12":"Recapitula sermonem, in paucis multa; esto quasi scius et simul tacens."
,"13":"In medio magnatorum non praesumas,et, ubi sunt senes, non multum loquaris."
,"14":"Ante tonitruum praeibit coruscatio, et ante verecundum praeibit gratia."
,"15":"Et hora surgendi non te trices; praecurre autem prior in domum tuam,et illic avocare et illic lude"
,"16":"et age conceptiones tuas,et noli peccare in verbo superbo."
,"17":"Et super his omnibus benedicito Dominum, qui fecit te,et inebriantem te ab omnibus bonis suis."
,"18":"Qui timet Dominum, excipiet doctrinam; et, qui vigilaverint ad illum, invenient benedictionem."
,"19":"Qui quaerit legem, replebitur ab ea; et, qui insidiose agit, scandalizabitur in ea."
,"20":"Qui timent Dominum, invenient iudicium iustum,et iustitias quasi lumen accendent."
,"21":"Peccator homo vitabit correptionem,et secundum voluntatem suam inveniet comparationem."
,"22":"Vir consilii non despiciet intellegentiam; alienus et superbus non pertimescet timorem. (23)"
,"24":"Fili, sine consilio nihil facias,et post factum non paenitebis."
,"25":"In via ruinae non eas,et non offendes bis in lapides; ne credas te viae inexploratae, ne ponas animae tuae scandalum."
,"26":"Et a filiis tuis cave,et a domesticis tuis attende."
,"27":"In omni opere tuo confide animae tuae: haec est enim conservatio mandatorum."
,"28":"Qui credit legi, attendit mandatis; et, qui confidit in Domino, non minorabitur."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Timenti Dominum non occurrent mala, sed in tentatione Deus illum iterum conservabit et liberabit a malis."
,"2":"Sapiens non odit mandata et iustitias,et non illidetur quasi in procella navis."
,"3":"Homo sensatus credit verbo Dei, et lex illi fidelis sicut qui interrogationem manifestat."
,"4":"Para verba et sic deprecatus exaudieris,et conservabis disciplinam et tunc respondebis."
,"5":"Praecordia fatui quasi rota carri, et quasi axis versatilis cogitatus illius."
,"6":"Equus admissarius, sic et amicus subsannator: sub omni suprasedente hinnit."
,"7":"Quare dies diem superat, si omnis lux anni a sole?"
,"8":"A Domini scientia separati sunt,"
,"9":"et immutavit tempora et dies festos ipsorum."
,"10":"Ex ipsis exaltavit et magnificavit Deus,et ex ipsis posuit in numerum dierum. Et omnes homines de solo, et ex terra creatus est Adam."
,"11":"In multitudine disciplinae Dominus separavit eos,et immutavit vias eorum:"
,"12":"ex ipsis benedixit et exaltavit,et ex ipsis sanctificavit et ad se applicavit; ex ipsis maledixit et humiliavit,et convertit illos a statione ipsorum."
,"13":"Quasi lutum figuli in manu ipsius,plasmare illud et disponere"
,"14":"secundum beneplacitum eius, sic homo in manu illius, qui se fecit,et reddet illi secundum iudicium suum."
,"15":"Contra malum bonum est, et contra mortem vita; sic et contra virum iustum peccator. Et sic intuere in omnia opera Altissimi, duo et duo, et unum contra unum."
,"16":"Et ego novissimus evigilavi,et, quasi qui colligit acinos post vindemiatores,"
,"17":"in benedictione Dei et ipse praecessi,et, quasi qui vindemiat, replevi torcular."
,"18":"Respicite quoniam non mihi soli laboravi,sed omnibus exquirentibus disciplinam."
,"19":"Audite me, magnates populi; et rectores ecclesiae, auribus percipite."
,"20":"Filio et mulieri, fratri et amico,non des potestatem super te in vita tua; et non dederis alii possessionem tuam, ne forte paeniteat te et depreceris pro illis."
,"21":"Dum adhuc superes et aspiras, non commutes teipsum cum omni carne."
,"22":"Melius est enim, ut filii tui te rogent, quam te respicere in manus filiorum tuorum."
,"23":"In omnibus operibus tuis praecellens esto,"
,"24":"ne dederis maculam in gloria tua. In die consummationis dierum vitae tuae,et in tempore exitus tui distribue hereditatem tuam."
,"25":"Cibaria et virga et onus asino, panis et disciplina et opus servo."
,"26":"Operare per servum et invenies requiem; laxa manus illi, et quaeret libertatem."
,"27":"Iugum et lorum curvant collum, et servum inclinant operationes assiduae."
,"28":"Servo malevolo tortura et compedes, mitte illum in operationem, ne vacet:"
,"29":"multam enim malitiam docuit otiositas."
,"30":"In opera constitue eum, sic enim condecet illum; quod si non obaudierit, curva illum compedibus, sed non immoderate in omnem carnem; verum sine iudicio nihil facias grave."
,"31":"Si est tibi servus unicus, sit tibi quasi anima tua, quoniam sicut te indigebis illo. Si est tibi servus unicus, quasi fratrem sic eum tracta, ne in sanguinem animae tuae irascaris."
,"32":"Si laeseris eum iniuste, in fugam convertetur;"
,"33":"et, si surgens discesserit, in qua via quaeras illum, nescis."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Vana spes et mendax viro insensato, et somnia extollunt imprudentes."
,"2":"Quasi qui apprehendit umbram et persequitur ventum, sic et qui attendit ad visa noctis."
,"3":"Hoc secundum hoc visio somniorum, ante faciem hominis similitudo faciei."
,"4":"Ab immundo quid mundabitur?,Et a mendace quid verum dicetur?"
,"5":"Divinationes et auguria et somnia vanitas est,"
,"6":"et, sicut parturientis, cor phantasias patitur. Nisi ab Altissimo fuerit emissa visitatio, ne dederis in illis cor tuum."
,"7":"Multos enim errare fecerunt somnia, et exciderunt sperantes in illis."
,"8":"Sine mendacio consummabitur verbum legis, et sapientia in ore fideli consummatio."
,"9":"Vir, qui peregrinatus est, multa didicit, et, qui multa expertus est, enarrabit scienter."
,"10":"Qui non est expertus, pauca recognoscit, qui autem peregrinatus est, multiplicat astutiam. (11)"
,"12":"Multa vidi errando,et plurima verba intellexi;"
,"13":"aliquoties usque ad mortem periclitatus sum,et horum causa liberatus sum."
,"14":"Spiritus timentium Dominum vivet, et in respectu illius benedicetur."
,"15":"Spes enim illorum in salvantem illos, et oculi Dei in diligentes se."
,"16":"Qui timet Dominum, nihil trepidabit,et non pavebit, quoniam ipse est spes eius."
,"17":"Timentis Dominum beata est anima eius."
,"18":"Ad quem respicit? Et quis est fortitudo eius?"
,"19":"Oculi Domini super timentes eum: protector potentiae, firmamentum virtutis, tegimen ardoris et umbraculum meridiani,"
,"20":"custodia offensionis et adiutorium casus, exaltans animam et illuminans oculos, dans sanitatem vitae et benedictionem."
,"21":"Dominus solus sustinentibus se,in via veritatis et iustitiae."
,"22":"Immolantis ex iniquo, oblatio maculata, et non sunt beneplacitae hostiae iniustorum."
,"23":"Dona iniquorum non probat Altissimus,nec respicit in oblationes iniquorum,nec in multitudine sacrificiorum eorum propitiabitur peccatis."
,"24":"Qui offert sacrificium ex substantia pauperum, quasi qui victimat filium in conspectu patris sui."
,"25":"Panis egentium vita pauperum est; qui defraudat illum, homo sanguinis est."
,"26":"Qui aufert in sudore panem, quasi qui occidit proximum suum;"
,"27":"et effundit sanguinem, qui fraudem facit mercennario."
,"28":"Unus aedificans et unus destruens; quid prodest illis nisi labor?"
,"29":"Unus orans et unus maledicens; cuius vocem exaudiet Deus?"
,"30":"Qui baptizatur a mortuo et iterum tangit eum: quid proficit lavatio illius?"
,"31":"Sic homo, qui ieiunat pro peccatis suis, et iterum vadens et eadem faciens. Orationem illius quis exaudiet?,Aut quid proficit humiliando se?"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Qui conservat legem, multiplicat oblationes:"
,"2":"sacrificium salutare est attendere mandatis. (3)"
,"4":"Qui retribuit gratiam, offert similaginem, et, qui facit eleemosynam, offert sacrificium laudis."
,"5":"Beneplacitum est Domino recedere ab iniquitate, et deprecatio pro peccatis recedere ab iniustitia."
,"6":"Non apparebis ante conspectum Domini vacuus:"
,"7":"haec enim omnia propter mandatum Dei fiunt."
,"8":"Oblatio iusti impinguat altare, et odor suavitatis illius est in conspectu Altissimi;"
,"9":"sacrificium iusti acceptum est, et memoriam eius non obliviscetur Dominus."
,"10":"Bono oculo gloriam redde Deo,et non minuas primitias manuum tuarum;"
,"11":"in omni dato hilarem fac vultum tuum,et in exsultatione sanctifica decimas tuas;"
,"12":"da Altissimo secundum datum eius,et in bono oculo ad inventionem facito manuum tuarum,"
,"13":"quoniam Dominus retribuens est,et septies tantum reddet tibi."
,"14":"Noli offerre munera prava, non enim suscipiet illa;"
,"15":"et noli confidere in sacrificio iniusto, quoniam Dominus iudex est, et non est apud illum gloria personae."
,"16":"Non accipiet personam in pauperem,et deprecationem laesi exaudiet."
,"17":"Non despiciet preces pupilli,nec viduam, si effundat loquelam gemitus."
,"18":"Nonne lacrimae viduae ad maxillam descendunt, et exclamatio eius super deducentem eas?"
,"19":"A maxilla enim ascendunt usque ad caelum, et Dominus exauditor non delectabitur in illis."
,"20":"Qui adorat Deum, in beneplacito suscipietur, et deprecatio illius usque ad nubes propinquabit."
,"21":"Oratio humilis nubes penetrabit,et, donec propinquet, non consolabitur; et non discedet, donec Altissimus aspiciat, et iudex iustus faciat iudicium."
,"22":"Et Dominus non tardabit, et Fortissimus non habebit in illis patientiam, donec contribulet dorsum crudelium"
,"23":"et gentibus reddet vindictam, donec tollat multitudinem superborum,et sceptra iniquorum contribulet,"
,"24":"donec reddat hominibus secundum actus suos,et opera Adae secundum praesumptionem illius,"
,"25":"donec iudicet iudicium plebis suae,et oblectabit istos misericordia sua."
,"26":"Speciosa misericordia in tempore tribulationis, quasi nubes pluviae in tempore siccitatis."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Miserere nostri, Deus omnium, et respice nos,et ostende nobis lucem miserationum tuarum;"
,"2":"et immitte timorem tuum super gentes, quae non exquisierunt te, ut cognoscant quia non est Deus nisi tu, et enarrent magnalia tua."
,"3":"Alleva manum tuam super gentes alienas, ut videant potentiam tuam."
,"4":"Sicut enim in conspectu eorum sanctificatus es in nobis, sic in conspectu nostro magnificaberis in eis,"
,"5":"ut cognoscant, sicut et nos cognovimus, quoniam non est Deus praeter te, Domine."
,"6":"Innova signa et itera mirabilia,"
,"7":"glorifica manum et firma brachium dextrum,"
,"8":"excita furorem et effunde iram,"
,"9":"tolle adversarium et afflige inimicum."
,"10":"Festina tempus et memento praefinitionis, et enarrentur mirabilia tua."
,"11":"In ira flammae devoretur, qui salvatur; et, qui pessimant plebem tuam, inveniant perditionem."
,"12":"Contere caput principum inimicorum,dicentium: ' Non est alius praeter nos!'."
,"13":"Congrega omnes tribus Iacob,et hereditabis eos sicut ab initio."
,"14":"Miserere plebi tuae, super quam invocatum est nomen tuum, et Israel, quem coaequasti primogenito tuo."
,"15":"Miserere civitati sanctificationis tuae, Ierusalem, loco requiei tuae."
,"16":"Reple Sion maiestate tua,et gloria tua templum tuum."
,"17":"Da testimonium his, qui ab initio creaturae tuae sunt, et suscita praedicationes, quas locuti sunt in nomine tuo."
,"18":"Da mercedem sustinentibus te, ut prophetae tui fideles inveniantur. Et exaudi orationes servorum tuorum,"
,"19":"secundum beneplacitum super populo tuo, et dirige nos in viam iustitiae, et sciant omnes, qui habitant terram, quia tu es Deus saeculorum."
,"20":"Omnem escam manducabit venter, et est cibus cibo melior;"
,"21":"fauces percipiunt cibum ferae, et cor sensatum verba mendacia."
,"22":"Cor pravum dabit tristitiam, et homo peritus retribuet illi."
,"23":"Omnem masculum excipiet mulier, est autem filia melior filia."
,"24":"Species mulieris exhilarat faciem viri sui, et super omnem concupiscentiam hominis superducit desiderium."
,"25":"Insuper, si est super lingua eius curatio,et mitigatio et misericordia, non est vir illius secundum filios hominum."
,"26":"Qui possidet mulierem bonam, inchoat possessionem, adiutorium secundum illum est et columna requiei."
,"27":"Ubi non est saepes, diripietur vinea, et ubi non est mulier, ingemiscet errans."
,"28":"Quis credit ei, qui non habet nidum,et deflectens ubicumque obscuraverit, quasi succinctus latro exsiliens de civitate in civitatem?"
}`)
	CurrentBook.AddChapter(37, `{
"1":"Omnis amicus dicet: ' Et ego amicitiam copulavi! '; sed est amicus solo nomine amicus. Nonne tristitia appropinquans usque ad mortem:"
,"2":"sodalis et amicus ad inimicitiam conversus?"
,"3":"O praesumptio nequissima, unde creata es,cooperire aridam malitia et dolositate illius?"
,"4":"Sodalis amico coniucundatur in oblectationibus,et in tempore tribulationis adversarius erit;"
,"5":"sodalis amico condolet causa ventris,et contra hostem accipiet scutum."
,"6":"Non obliviscaris amici tui in animo tuo,et non immemor sis illius in opibus tuis."
,"7":"Noli consiliari cum eo, qui tibi insidiatur, et a zelantibus te absconde consilium."
,"8":"Omnis consiliarius prodit consilium, sed est consiliarius pro semetipso."
,"9":"A consiliario serva animam tuam,et prius scito quae sit illius necessitas,' et ipse enim animo suo cogitabit '"
,"10":"ne forte mittat super te sortem,et dicat tibi: "
,"11":"' Bona est via tua ',et stet e contrario videre quid tibi eveniat."
,"12":"Noli consiliari cum invido,et a zelante te consilium absconde; nec cum muliere de ea, quae ei aemulatur, cum timido de bello, cum negotiatore de traiecticio, cum emptore de venditione, cum viro livido de gratiis agendis,"
,"13":"cum impio de pietate, cum inhonesto de honestate, cum operario otioso de omni opere,"
,"14":"cum mercennario annuali de consummatione anni, cum servo pigro de multa operatione: non attendas his in omni consilio."
,"15":"Sed cum viro timorato assiduus esto, quemcumque cognoveris observantem mandata,"
,"16":"cuius anima est secundum animam tuam, et qui, cum titubaveris in tenebris, condolebit tibi."
,"17":"Et consilium cordis statue tecum; non est enim tibi aliud fidelius illo."
,"18":"Anima viri enuntiat aliquando vera,quam septem circumspectores sedentes in excelso ad speculandum."
,"19":"Et in his omnibus deprecare Altissimum, ut dirigat in veritate viam tuam."
,"20":"Ante omnia opera verbum verax praecedat te, et ante omnem actum consilium stabile."
,"21":"Radix consiliorum cor, ex quo partes quattuor oriuntur: bonum et malum, vita et mors; et dominatrix illorum est assidua lingua."
,"22":"Est vir peritus multorum eruditor,et animae suae inutilis est."
,"23":"Est qui sophistice loquitur et odibilis est; in omni cibo voluptatis defraudabitur."
,"24":"Non est illi data a Domino gratia: omni enim sapientia defraudatus est."
,"25":"Est sapiens animae suae sapiens, et fructus sensus illius super corpus suum."
,"26":"Vir sapiens plebem suam erudit, et fructus sensus illius fideles sunt."
,"27":"Vir sapiens implebitur benedictionibus, et omnes videntes illum beatum dicent."
,"28":"Vita viri in numero dierum; dies autem Israel innumerabiles sunt."
,"29":"Sapiens in populo hereditabit honorem, et nomen illius erit vivens in aeternum."
,"30":"Fili, in vita tua tenta animam tuam,et vide si quid obnoxium ei est: non des illi."
,"31":"Non enim omnia omnibus expediunt, et non omni animae omne genus placet."
,"32":"Noli avidus esse in omni epulatione,et non te effundas super omnem escam."
,"33":"In multis enim escis erit infirmitas, et aviditas appropinquabit usque ad choleram."
,"34":"Propter crapulam multi obierunt; qui autem abstinens est, adiciet vitam."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Honora medicum propter necessitatem; etenim illum creavit Altissimus."
,"2":"A Deo est enim illi sapientia, et a rege accipiet donationem."
,"3":"Disciplina medici exaltabit caput illius, et in conspectu magnatorum collaudabitur."
,"4":"Altissimus creavit de terra medicamenta, et vir prudens non abhorrebit illa."
,"5":"Nonne a ligno indulcata est aqua amara,"
,"6":"ut agnoscerent homines virtutem illius?,Et dedit hominibus scientiam Altissimus, ut honoraretur in mirabilibus suis."
,"7":"In his curans mitigabit dolorem, et unguentarius faciet pigmenta suavitatis, ut non consumantur opera eius:"
,"8":"et salus super faciem terrae."
,"9":"Fili, in tua infirmitate ne despicias teipsum, sed ora Dominum, et ipse curabit te."
,"10":"Averte a delicto et dirige manus,et ab omni peccato munda cor tuum;"
,"11":"da suavitatem et memoriam similaginis,et impingua oblationem pro opibus tuis. Et da locum medico, "
,"12":"etenim illum Dominus creavit; et non discedat a te, quia opera eius sunt necessaria."
,"13":"Est enim tempus, quando per manus illorum est solacium."
,"14":"Ipsi vero Dominum deprecabuntur, ut dirigat ad rectam cognitionem,et prosperet curationem."
,"15":"Qui delinquit in conspectu eius, qui fecit eum, incidet in manus medici."
,"16":"Fili, in mortuum produc lacrimas,et, quasi dira passus, incipe lamentationem,et secundum iudicium contege corpus illius,et non despicias sepulturam illius."
,"17":"Amare fer fletum et perfice lamentum"
,"18":"et fac luctum secundum meritum eius, uno die vel duobus propter detractionem, et consolare propter tristitiam."
,"19":"A tristitia enim festinat mors, et tristitia cordis flectit virtutem."
,"20":"In abductione permanet tristitia, et vita inopis maledictio cordis."
,"21":"Ne dederis in tristitia cor tuum, sed repelle eam a te et memento novissimorum."
,"22":"Ne ultra memineris: neque enim est conversio; et huic nihil proderis et teipsum pessimabis."
,"23":"Memor esto iudicii eius, sic enim erit et tuum: mihi heri, et tibi hodie."
,"24":"In requie mortui requiescere fac memoriam eius,et consolare in illo in exitu spiritus sui."
,"25":"Sapientia scribae in opportunitate vacationis; et, qui minoratur operatione, ipse sapientia replebitur. Qua sapientia replebitur, "
,"26":"qui tenet aratrum,et qui gloriatur in iaculo stimuli?,Boves agitat et conversatur in operibus eorum, et enarratio eius in filiis taurorum."
,"27":"Cor suum dabit ad versandos sulcos, et vigilia eius in sagina vaccarum."
,"28":"Sic omnis faber et architectus, qui noctem tamquam diem transigit, qui sculpit signacula sculptilia, et assiduitas eius variare picturam; cor suum dabit in similitudinem picturae, et vigilia sua perficere opus."
,"29":"Sic faber ferrarius sedens iuxta incudem,et considerans opus ferri; vapor ignis uret carnes eius, et in calore fornacis concertatur."
,"30":"Vox mallei exsurdat aurem eius, et contra similitudinem vasis oculus eius."
,"31":"Cor suum dabit in consummationem operum,et vigilia sua ornare in perfectionem."
,"32":"Sic figulus sedens ad opus suum, convertens pedibus suis rotam, qui in sollicitudine positus est semper propter opus suum, et in numero est omnis operatio eius;"
,"33":"in brachio suo formabit lutum,et ante canos suos curvabit virtutem suam:"
,"34":"cor suum dabit, ut consummet linitionem, et vigilia sua mundare fornacem."
,"35":"Omnes hi in manibus suis speraverunt, et unusquisque in arte sua sapiens est."
,"36":"Sine his omnibus non aedificabitur civitas,"
,"37":"et non inhabitabunt nec inambulabunt. Verumtamen in consilium populi non requirentur,et in ecclesiam non transilient;"
,"38":"super sellam iudicis non sedebunt,et decretum iudicii non intellegent,neque palam facient disciplinam et iudicium,et in parabolis non invenientur;"
,"39":"sed creaturam laboris confirmabunt, et sollicitudo illorum in operatione artis."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Qui autem accommodat animam suam ad timorem Dei,et in lege Altissimi meditatur, sapientiam omnium antiquorum exquiret,et in prophetiis vacabit."
,"2":"Narrationem virorum nominatorum conservabit,et in versutias parabolarum simul introibit."
,"3":"Occulta proverbiorum exquiret,et in absconditis parabolarum conversabitur."
,"4":"In medio magnatorum ministrabit,et in conspectu principum apparebit."
,"5":"In terram alienigenarum gentium pertransiet; bona enim et mala in hominibus tentabit."
,"6":"Cor suum tradet ad vigilandum diluculo,ad Dominum, qui fecit illum, et in conspectu Altissimi deprecabitur."
,"7":"Aperiet os suum in oratione,et pro delictis suis deprecabitur."
,"8":"Si enim Dominus magnus voluerit, spiritu intellegentiae replebitur."
,"9":"Ipse tamquam imbres mittet eloquia sapientiae suae,et in oratione confitebitur Domino."
,"10":"Et ipse diriget consilium et disciplinam,et in absconditis eius considerabit."
,"11":"Ipse palam faciet disciplinam doctrinae suae,et in lege testamenti Domini gloriabitur."
,"12":"Collaudabunt multi sapientiam eius, et usque in saeculum non delebitur."
,"13":"Non recedet memoria eius, et nomen eius requiretur a generatione in generationem;"
,"14":"sapientiam eius enarrabunt gentes, et laudem eius enuntiabit ecclesia."
,"15":"Si permanserit, nomen derelinquet plus quam mille, et, si requieverit, proderit sibi."
,"16":"Adhuc meditabor et enarrabo; ut luna die duodecimo repletus sum."
,"17":"Obaudite me, filii pii, et quasi rosa plantata super rivos aquarum florebit caro vestra;"
,"18":"quasi libanus odorem suavitatis habete,"
,"19":"florete flores quasi lilium. Date vocem et collaudate canticum,et benedicite Dominum in omnibus operibus suis."
,"20":"Date nomini eius magnificentiam,et confitemini illi in laudatione eius,et in canticis labiorum et citharis; et sic dicetis in confessione:"
,"21":"' Opera Domini universa bona valde, et omne, quod praecepit, tempore suo erit! '. Non est dicere: ' Quid est hoc? ' aut ' Ad quid istud? '; omnia enim in tempore suo conquirentur."
,"22":"In verbo eius stetit aqua sicut congeries, et in sermone oris illius exceptoria aquarum;"
,"23":"quoniam in praecepto ipsius placor fit, et non est minoratio in salutare ipsius."
,"24":"Opera omnis carnis coram illo, et non est quidquam absconditum ab oculis eius."
,"25":"A saeculo usque in saeculum respicit, et nihil est mirabile in conspectu eius."
,"26":"Non est dicere: ' Quid est hoc! ' aut ' Ad quid istud? '; omnia enim in usum suum creata sunt."
,"27":"Benedictio illius quasi fluvius inundavit"
,"28":"et sicut cataclysmus aridam inebriavit. Sic ira ipsius gentes, quae non exquisierunt eum, disperdet,"
,"29":"quomodo convertit aquas in salsuginem. Viae illius sanctis directae sunt; sic peccatoribus offensiones in ira eius."
,"30":"Bona bonis creata sunt ab initio, sic peccatoribus bona et mala."
,"31":"Primum necessaria vitae hominum aqua, ignis et ferrum, sal, lac et panis similagineus et mel et sanguis uvae et oleum et vestimentum:"
,"32":"haec omnia sanctis in bona, sic et impiis et peccatoribus in mala convertentur."
,"33":"Sunt spiritus, qui ad vindictam creati sunt,et in furore suo confirmaverunt tormenta sua;"
,"34":"in tempore consummationis effundent virtutem,et furorem eius, qui fecit illos, placabunt:"
,"35":"ignis, grando, fames et mors, omnia haec ad vindictam creata sunt;"
,"36":"bestiarum dentes et scorpii et serpentes,et romphaea vindicans in exterminium impios:"
,"37":"in mandatis eius gaudebunt,et super terram in necessitates praeparabuntur,et in temporibus suis non praeterient verbum."
,"38":"Propterea ab initio confirmatus,et consiliatus sum et cogitavi et scriptis mandavi:"
,"39":"' Opera Domini omnia bona, et omnem usum hora sua subministrabit '."
,"40":"Non est dicere: ' Hoc illo nequius est ': omnia enim in tempore suo comprobabuntur."
,"41":"Et nunc in omni corde et ore collaudate,et benedicite nomen Domini."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Occupatio magna creata est omnibus hominibus, et iugum grave super filios Adam,a die exitus de ventre matris eorum,usque in diem reditus in matrem omnium:"
,"2":"cogitationes eorum et timores cordis, adinventio exspectationis, dies finitionis."
,"3":"A residente super sedem gloriosam, usque ad humiliatum in terra et cinere;"
,"4":"ab eo, qui portat hyacinthum et coronam, usque ad eum, qui operitur lino crudo: furor, zelus, tumultus, fluctuatio,et timor mortis et iracundia perseverans et contentio."
,"5":"Et in tempore requiei in cubili,somnus noctis immutat scientiam eius."
,"6":"Modicum tamquam nihil in requie, et ab eo in somnis quasi in die laborat"
,"7":"conturbatus in visu cordis sui,tamquam qui evaserit a facie belli; in tempore somni necessarii exsurrexit,et admirans ad nullum timorem."
,"8":"Cum omni carne ab homine usque ad pecus; et super peccatores septuplum amplius:"
,"9":"ad haec mors, sanguis, contentio et romphaea, oppressiones, fames et contritio et flagella."
,"10":"Super iniquos creata sunt haec omnia, et propter illos factus est cataclysmus."
,"11":"Omnia, quae de terra sunt, in terram convertentur, et omnia, quae de aquis sunt, in mare revertentur."
,"12":"Omne munus corruptionis et iniquitas delebitur, et fides in saeculum stabit."
,"13":"Substantiae iniustorum sicut fluvius siccabuntur,et sicut tonitruum magnum in pluvia evanescent."
,"14":"In aperiendo manus suas laetabitur, sic praevaricatores in consummationem deficient."
,"15":"Nepotes impiorum non multiplicabunt ramos, et radices immundae super cacumen petrae."
,"16":"Viriditas super omnem aquam et ad oram fluminis,ante omne fenum evelletur."
,"17":"Gratia sicut paradisus in benedictionibus, et eleemosyna in saeculum permanet."
,"18":"Vita sibi sufficientis et operarii condulcabitur, et super utrumque, eius qui inveniet thesaurum."
,"19":"Filii et aedificatio civitatis confirmant nomen, et super haec mulier immaculata computabitur."
,"20":"Vinum et musica laetificant cor, et super utraque dilectio sapientiae."
,"21":"Tibiae et psalterium suavem faciunt melodiam, et super utraque lingua suavis."
,"22":"Gratiam et speciem desiderabit oculus, et super haec virides sationes."
,"23":"Amicus et sodalis in tempore convenientes, et super utrosque mulier cum viro."
,"24":"Fratres et adiutorium in tempore tribulationis, et super utraque eleemosyna liberabit."
,"25":"Aurum et argentum firmant pedem, et super utrumque consilium acceptum habetur."
,"26":"Facultates et virtutes exaltant cor, et super haec timor Domini."
,"27":"Non est in timore Domini minoratio, et non est super eo inquirere adiutorium."
,"28":"Timor Domini sicut paradisus benedictionis, et super omnem gloriam obumbratio eius."
,"29":"Fili, in tempore vitae tuae ne indigeas; melius est enim mori quam indigere."
,"30":"Vir respiciens in mensam alienam, non est vita eius in computatione vitae. Contaminat enim animam suam cibis alienis;"
,"31":"vir autem disciplinatus et eruditus custodiet se."
,"32":"In ore impudentis condulcabitur mendicatio, et in ventre eius ignis ardebit."
}`)
	CurrentBook.AddChapter(41, `{
"1":"O mors, quam amara est memoria tua,homini pacem habenti in substantiis suis,"
,"2":"viro quieto et, cuius viae directae sunt in omnibus, et adhuc valenti accipere voluptatem!"
,"3":"O mors, bonum est iudicium tuum,homini indigenti et, qui minoratur viribus,"
,"4":"defecto aetate et, cui de omnibus cura est, qui fiduciam amisit et perdidit patientiam!"
,"5":"Noli metuere iudicium mortis; memento eorum, qui ante te fuerunt,et qui superventuri sunt tibi: hoc iudicium a Domino omni carni;"
,"6":"et quid resistis beneplacito Altissimi?,Sive decem sive centum sive mille anni,"
,"7":"non est enim in inferno accusatio vitae."
,"8":"Filii abominationum fiunt filii peccatorum, et qui conversantur in sedibus impiorum;"
,"9":"filiorum peccatorum periet hereditas, et cum semine illorum assiduitas opprobrii."
,"10":"De patre impio queruntur filii, quoniam propter illum sunt in opprobrio."
,"11":"Vae vobis, viri impii, qui dereliquistis legem Domini Altissimi!"
,"12":"Et, si nati fueritis, in maledictione nascemini; et, si mortui fueritis, in maledictione erit pars vestra."
,"13":"Omnia, quae de terra sunt, in terram convertentur, sic impii a maledicto in perditionem."
,"14":"Luctus hominum in corpore ipsorum; nomen autem impiorum non bonum delebitur."
,"15":"Curam habe de bono nomine; hoc enim magis permanebit tibi,quam mille thesauri pretiosi et magni:"
,"16":"bonae vitae numerus dierum, bonum autem nomen permanebit in aevum."
,"17":"Melior est homo, qui abscondit stultitiam suam, quam homo, qui abscondit sapientiam suam. Sapientia enim abscondita et thesaurus invisibilis, quae utilitas in utrisque?"
,"18":"Disciplinam in pace conservate, filii;"
,"19":"verumtamen reveremini iudicium meum:"
,"20":"non est enim bonum omnem reverentiam observare, et non omnis pudor probatus."
,"21":"Erubescite a patre et a matre de fornicatione,et a praesidente et a potente de mendacio,"
,"22":"a principe et a iudice de delicto, a synagoga et plebe de iniquitate,"
,"23":"a socio et amico de iniustitia,et de loco, in quo habitas, "
,"24":"de furto, de veritate Dei et testamento, de impositione cubiti super mensam,et a despectione dati et accepti,"
,"25":"a salutantibus de silentio, a respectu mulieris fornicariae,et ab aversione vultus cognati"
,"26":"et ab auferendo partem et non restituendo"
,"27":"et a respiciendo mulierem alieni viri,et a curiositate in ancillam eius, neque steteris ad lectum eius;"
,"28":"ab amicis de sermonibus improperii, et, cum dederis, ne improperes;"
}`)
	CurrentBook.AddChapter(42, `{
"1":"et ab iteratione sermonis auditus,et a revelatione sermonis absconditi. Et eris vere sine confusione,et invenies gratiam in conspectu omnium hominum. Ne pro his omnibus confundaris, ne accipias personam, ut delinquas:"
,"2":"de lege Altissimi et testamento,et de iudicio, iustificans impium,"
,"3":"de ratione sociorum et viatorum,et de datione hereditatis alienorum,"
,"4":"de aequalitate staterae et ponderum, de acquisitione multorum et paucorum,"
,"5":"de pretio emptionis negotiatorum,et de multa disciplina filiorum,et servo pessimo latus sanguinare."
,"6":"Super mulierem nequam bonum est signum;"
,"7":"ubi manus multae sunt, claude,et, quodcumque trades, numera et appende: datum vero et acceptum omne describe."
,"8":"De disciplina insensati et fatui,et de seniore, qui iudicatur de fornicatione; et eris eruditus in veritate,et probatus in conspectu omnium vivorum."
,"9":"Filia patri est abscondita vigilia, et sollicitudo eius aufert somnum: in adulescentia sua, ne forte adulta efficiatur, viro nuptum locata, ne odibilis fiat;"
,"10":"ne quando polluatur in virginitate sua,et in paternis suis gravida inveniatur; ne forte viro desponsata transgrediatur,aut, cum eo commorata, ne sterilis inveniatur."
,"11":"Super filiam immodestam confirma custodiam, ne quando faciat te in opprobrium venire inimicis, in detractionem in civitate et obiectionem plebis, et confundat te in multitudine populi."
,"12":"Omni homini ne det speciem,et in medio mulierum non commoretur;"
,"13":"de vestimentis enim procedit tinea, et a muliere iniquitas mulieris."
,"14":"Melior est enim iniquitas viri quam mulier benefaciens, et mulier confundens in opprobrium."
,"15":"Memor ero igitur operum Domini,et, quae vidi, annuntiabo: in sermonibus Domini opera eius, et factum est in voluntate sua iudicium."
,"16":"Sol illuminans per omnia respexit, et gloria Domini plenum est opus eius."
,"17":"Non valent sancti Domini,enarrare omnia mirabilia eius. Confirmavit Dominus exercitus suos,stabiliri coram gloria sua."
,"18":"Abyssum et cor hominum investigavit,et in astutia eorum excogitavit."
,"19":"Cognovit enim Dominus omnem scientiam,et inspexit in signum aevi,annuntians, quae praeterierunt et quae superventura sunt, et revelans vestigia occultorum."
,"20":"Non praeterit illum omnis cogitatus, et non abscondit se ab eo ullus sermo."
,"21":"Magnalia sapientiae suae ordinavit, unicus est ante saeculum et usque in saeculum; neque augetur "
,"22":"neque minuitur,et non eget alicuius consilio."
,"23":"Quam desiderabilia omnia opera eius, et tamquam scintilla spectatu!"
,"24":"Omnia haec vivunt et manent in saeculum, et in omni necessitate omnia obaudiunt ei;"
,"25":"omnia duplicia, unum contra unum, et non fecit quidquam deficiens."
,"26":"Alterum alterius confirmat bonum; et quis satiabitur videns gloriam eius?"
}`)
	CurrentBook.AddChapter(43, `{
"1":"Gloria altitudinis firmamentum puritatis, species caeli in visione gloriae."
,"2":"Sol in apparitione annuntians in processu: vas admirabile, opus Excelsi."
,"3":"In meridiano suo exurit terram; et in conspectu ardoris eius quis poterit sustinere?,Fornacem ventilans in operibus ardoris tripliciter,"
,"4":"sol exurens montes, vapores igneos exsufflans,et refulgens radiis suis obcaecat oculos."
,"5":"Magnus Dominus, qui fecit illum,et sermonibus eius festinavit iter."
,"6":"Et luna stat in tempus suum, in ostensionem temporis et signum aevi."
,"7":"A luna signum diei festi; luminare, quod minuitur in consummatione."
,"8":"Mensis secundum nomen eius est, crescens mirabiliter in consummatione."
,"9":"Vas castrorum in excelsis, in firmamento caeli resplendens gloriose."
,"10":"Species caeli gloria stellarum, mundum illuminans in excelsis Domini."
,"11":"In verbis Sancti stabunt iuxta praeceptum,et non deficient in vigiliis suis."
,"12":"Vide arcum et benedic eum, qui fecit illum; valde speciosus est in splendore suo."
,"13":"Gyravit caelum in circuitu gloriae suae, manus Excelsi tetenderunt illum."
,"14":"Imperio suo acceleravit nivem,et properat coruscationes iudicii sui."
,"15":"Propterea aperti sunt thesauri, et evolaverunt nebulae sicut aves."
,"16":"In magnitudine sua firmavit nubes, et confracti sunt lapides grandinis. Vox tonitrui eius tremefacit terram,"
,"17":"in conspectu eius commovebuntur montes. In voluntate eius aspirabit notus,"
,"18":"tempestas aquilonis et congregatio spiritus."
,"19":"Et, sicut aves deponentes ad sedendum, aspergit nivem, et, sicut locusta demergens, descensus eius:"
,"20":"pulchritudinem candoris eius admirabitur oculus, et super imbrem eius expavescet cor."
,"21":"Gelu sicut salem effundet super terram, et, dum gelaverit, fit tamquam cacumina tribuli."
,"22":"Frigidus ventus aquilo flabit, et gelabit crystallus super aquam; super omnem congregationem aquarum requiescet, et sicut lorica induet se aqua."
,"23":"Devorabit montes et exuret desertum,et exstinguet viridem sicut ignis."
,"24":"Medicina omnium in festinatione nebulae, et ros obvians ab ardore hilarescet."
,"25":"Cogitatione sua placavit abyssum,et plantavit in illa insulas."
,"26":"Qui navigant mare, enarrant pericula eius, et audientes auribus nostris admiramur."
,"27":"Illic praeclara opera et mirabilia, varia bestiarum genera et omnium pecorum et creatura belluarum."
,"28":"Propter ipsum iter prosperat angelus eius, et in sermone eius composita sunt omnia."
,"29":"Multa dicemus et deficiemus verbis; consummatio autem sermonum: ' Ipse est omnia!'."
,"30":"Glorificantes ad quid valebimus?,Ipse enim Magnus super omnia opera sua."
,"31":"Terribilis Dominus et magnus vehementer, et mirabilis potentia ipsius."
,"32":"Glorificantes Dominum exaltate, quantumcumque potueritis: supervalebit enim adhuc, et admirabilis magnificentia eius.(33)"
,"34":"Exaltantes eum replemini virtute; ne laboretis, non enim pervenietis usquam."
,"35":"Quis vidit eum et enarrabit?,Et quis magnificabit eum sicut est?"
,"36":"Multa abscondita sunt maiora his; pauca enim vidimus operum eius."
,"37":"Omnia autem Dominus fecit,et pie agentibus dedit sapientiam."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Laus patrum. Laudemus viros gloriosos,et parentes nostros in generatione sua."
,"2":"Multam gloriam fecit Dominus, magnificentiam suam a saeculo."
,"3":"Dominantes in potestatibus suis, homines magni virtute,et prudentia sua praediti, nuntiantes in prophetiis,"
,"4":"regentes populum in consiliis,et peritia scripturae populos; verba sapientiae in disciplina eorum,"
,"5":"requirentes modos musicos,et narrantes carmina scripturarum;"
,"6":"homines divites innixi virtute, pulchritudinis studium habentes, pacificantes in domibus suis."
,"7":"Omnes isti in generationibus gentis suae gloriam adepti sunt,et a diebus suis habentur in laudibus."
,"8":"De illis nati sunt, qui reliquerunt nomen,narrandi laudes eorum."
,"9":"Et sunt quorum non est memoria: perierunt quasi qui non fuerint; et nati sunt quasi non nati, et filii ipsorum post ipsos."
,"10":"Sed hi viri misericordiae sunt, quorum pietates non fuerunt in oblivione."
,"11":"Cum semine eorum permanent, bona hereditas, nepotes eorum,"
,"12":"et in testamentis stetit semen eorum;"
,"13":"et filii eorum propter illos. Usque in aeternum manet semen eorum, et gloria eorum non derelinquetur."
,"14":"Corpora ipsorum in pace sepulta sunt, et nomen eorum vivit in generationem et generationem;"
,"15":"sapientiam ipsorum narrent populi, et laudem eorum nuntiet ecclesia."
,"16":"Henoch placuit Deo et translatus est in paradisum, ut det gentibus paenitentiam."
,"17":"Noe inventus est perfectus iustus,et in tempore iracundiae factus est reconciliatio;"
,"18":"propter eum dimissum est reliquum terrae, cum factum est diluvium:"
,"19":"testamenta saeculi posita sunt apud illum, ne deleri posset diluvio omnis caro."
,"20":"Abraham magnus pater multitudinis gentium, et non est inventa macula in gloria eius; qui conservavit legem Excelsi,et fuit in testamento cum illo."
,"21":"In carne eius stare fecit testamentum, et in tentatione inventus est fidelis."
,"22":"Ideo iure iurando statuit illi,benedici gentes in semine eius, crescere illum quasi terrae cumulum"
,"23":"et ut stellas exaltare semen eius,et hereditare illos a mari usque ad mare,et a Flumine usque ad terminos terrae."
,"24":"Et in Isaac eodem modo statuit,propter Abraham patrem eius."
,"25":"Benedictionem omnium gentium dedit illi Dominus,et testamentum confirmavit super caput Iacob."
,"26":"Agnovit eum in benedictionibus suis,et dedit illi hereditatem,et divisit illi partem in tribubus duodecim."
,"27":"Et eduxit ex illo hominem misericordiae,invenientem gratiam in oculis omnis carnis,"
}`)
	CurrentBook.AddChapter(45, `{
"1":"dilectum a Deo et hominibus,Moysen, cuius memoria in benedictione est."
,"2":"Similem illum fecit in gloria sanctorum,et magnificavit eum in timore inimicorum,et in verbis suis signa acceleravit."
,"3":"Glorificavit illum in conspectu regum,et ius dedit illi ad populum suum,et ostendit illi gloriam suam."
,"4":"In fide et lenitate ipsius sanctum fecit illum,et elegit eum ex omni carne."
,"5":"Auditam fecit illi vocem suam,et induxit illum in nubem;"
,"6":"et dedit illi coram praecepta,et legem vitae et disciplinae, docere Iacob testamentum suum,et iudicia sua Israel."
,"7":"Excelsum fecit Aaron sanctum similem ei, fratrem eius de tribu Levi."
,"8":"Statuit illum in testamentum aeternum,et dedit illi sacerdotium gentis, et beatificavit illum in gloria"
,"9":"et circumcinxit eum zona gloriae. Et induit eum perfecto decore,et coronavit eum in vasis virtutis:"
,"10":"femoralia et tunicam et umerale posuit ei,et cinxit illum tintinnabulis aureis, malis granatis plurimis in gyro,"
,"11":"ut daret sonitum in incessu suo, auditum faceret sonitum in templo,in memoriam filiis gentis suae."
,"12":"Stola sancta auro et hyacintho et purpura, opus textile rationale iudicii et cingulum,"
,"13":"tortum coccum opere artificis, gemmae pretiosae super rationale,in ligatura auri, opere lapidarii sculptis, in memoriam cum scriptura sculpta secundum numerum tribuum Israel."
,"14":"Corona aurea super mitram eius, lamina cum signo sanctitatis, gloria honoris, opus virtutis et desideria oculorum, perfecta pulchritudo."
,"15":"Sic pulchra ante ipsum non fuerunt talia in sempiternum;"
,"16":"non induet illa alienigena aliquis, sed tantum filii ipsius soli,et nepotes eius per omne tempus."
,"17":"Sacrificium ipsius consumitur,igne cotidie iuge bis."
,"18":"Complevit Moyses manus eius,et unxit illum oleo sancto."
,"19":"Factum est illi in testamentum aeternum,et semini eius sicut dies caeli: ministrare illi et fungi sacerdotio,et benedicere populum suum in nomine eius."
,"20":"Ipsum elegit ab omni vivente,offerre sacrificium Deo, incensum et adipes,et incendere bonum odorem et memoriale,et placare pro populo suo."
,"21":"Et dedit illi in praeceptis suis potestatem, in testamentis iudiciorum: docere Iacob testimonia,et in lege sua lucem dare Israel."
,"22":"Quia contra illum steterunt alieni, et propter invidiam circumdederunt illum homines in deserto, qui erant cum Dathan et Abiram, et congregatio Core in iracundia furoris sui."
,"23":"Vidit Dominus Deus, et non placuit illi, et consumpti sunt in impetu iracundiae eius."
,"24":"Fecit illis monstra,et consumpsit illos in flamma ignis."
,"25":"Et addidit Aaron gloriam,et dedit illi hereditatem,et primitias frugum terrae divisit illi."
,"26":"Panem ipsis in primis paravit in satietatem, nam et sacrificia Domini edent, quae dedit illi et semini eius."
,"27":"Ceterum in terra gentis non hereditabit, et pars non est illi in gente: ipse est enim pars eius et hereditas."
,"28":"Et Phinees filius Eleazari tertius in gloria est, zelando timorem Domini;"
,"29":"et stetit in ruptura pro gente, in bonitate et alacritate animae suae placuit Deo pro lsrael."
,"30":"Ideo statuit illi testamentum pacis, principem sanctorum et gentis suae, ut sit illi et semini eius,sacerdotii dignitas in aeternum."
,"31":"Et testamentum David regi filio Iesse de tribu Iudae, hereditas viri coram gloria eius, hereditas Aaron et semini eius. Det vobis sapientiam in cor vestrum,iudicare gentem suam in iustitia, ne abolerentur bona ipsorum, et gloria ipsorum in generationes aeternas."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Fortis in bello Iesus filius Nun, successor Moysi in prophetis, qui fuit secundum nomen suum"
,"2":"maximus in salutem electorum Dei, qui vindicet in insurgentes hostes, ut heredem faciat Israel."
,"3":"Quam gloriam adeptus est in tollendo manus suas,et iactando contra civitatem acinacem!"
,"4":"Quis ante illum restitit?,Nam bella Domini ipse perduxit."
,"5":"An non in manu eius impeditus est sol, et una dies facta est quasi duo?"
,"6":"Invocavit Altissimum potentem,in oppugnando inimicos undique; et audivit illum magnus Dominus,in saxis grandinis virtutis valde fortis."
,"7":"Impetum fecit contra gentem hostilem,et in descensu perdidit contrarios,"
,"8":"ut cognoscant gentes armaturam eius, quia contra Deum bellum eorum est: etenim secutus est a tergo Potentis."
,"9":"Et in diebus Moysi misericordiam fecit, ipse et Chaleb filius Iephonne, stare contra congregationem, prohibere gentem a peccatis,et perfringere murmur malitiae."
,"10":"Ideo et ipsi duo liberati sunt,a numero sescentorum milium peditum, ut inducerent illos in hereditatem, in terram, quae manat lac et mel."
,"11":"Et dedit Dominus ipsi Chaleb fortitudinem, et usque in senectutem permansit illi, ut ascenderet in excelsum terrae locum; et semen ipsius obtinuit hereditatem,"
,"12":"ut viderent omnes filii Israel,quia bonum est obsequi Domino."
,"13":"Et iudices singuli suo nomine, quorum non est corruptum cor, qui non aversi sunt a Domino:"
,"14":"sit memoria illorum in benedictione, et ossa eorum pullulent de loco suo,"
,"15":"et nomen eorum renovet,filiis illorum sanctorum virorum."
,"16":"Dilectus a Domino suo Samuel,propheta Domini instituit imperium,et unxit principes in gente sua."
,"17":"In lege Domini congregationem iudicavit, et visitavit Deus Iacob, et in fide sua probatus est propheta;"
,"18":"et cognitus est in verbis suis fidelis in visione."
,"19":"Et invocavit Dominum omnipotentem, in oppugnando hostes circumstantes undique, in oblatione agni lactentis."
,"20":"Et intonuit de caelo Dominus,et in sonitu magno auditam fecit vocem suam"
,"21":"et contrivit principes Tyriorum,et omnes duces Philisthim."
,"22":"Et ante tempus dormitionis aeternae,testimonium praebuit in conspectu Domini et christi eius: ' Pecunias et usque ad calceamenta,ab omni carne non accepi '; et non accusavit illum homo."
,"23":"Et, postquam dormivit, prophetavit,et notum fecit regi et ostendit illi finem vitae suae,et exaltavit vocem suam de terra in prophetia,ad delendam impietatem gentis."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Post hunc surrexit Nathan,propheta in diebus David."
,"2":"Et quasi adeps separatus a sacrificio salutari, sic David a filiis Israel."
,"3":"Cum leonibus lusit quasi cum agnis,et in ursis similiter fecit, sicut in agnis ovium."
,"4":"In iuventute sua numquid non occidit gigantem,et abstulit opprobrium de gente?"
,"5":"In agitando manu fundam,deiecit exsultationem Goliath."
,"6":"Nam invocavit Dominum altissimum, et dedit in dextera eius virtutem,tollere hominem fortem in bello,et exaltare cornu gentis suae."
,"7":"Sic de decem milibus glorificaverunt eum,et laudaverunt eum in benedictionibus Domini, in offerendo illi coronam gloriae."
,"8":"Contrivit enim inimicos undique,et humiliavit Philisthim contrarios, usque in hodiernum diem contrivit cornu ipsorum."
,"9":"In omni opere suo dedit confessionem,Sancto et Excelso in verbo gloriae;"
,"10":"de omni corde suo laudavit Dominum,et dilexit Deum, qui fecit illum."
,"11":"Et stare fecit cantores contra altare,et in sono eorum dulces fecit modos."
,"12":"Dedit in celebrationibus decus,et ornavit tempora usque ad consummationem anni, dum laudarent nomen sanctum Domini, et ante mane resonaret sanctuarium."
,"13":"Dominus purgavit peccata ipsius,et exaltavit in aeternum cornu eius et dedit illi testamentum regni,et sedem gloriae in Israel."
,"14":"Post ipsum surrexit filius sensatus, et propter illum habitavit in securitate."
,"15":"Salomon imperavit in diebus pacis; cui Deus requiem dedit in circuitu, ut conderet domum in nomine suo et pararet sanctuarium in sempiternum. Quemadmodum eruditus es in iuventute tua "
,"16":"et impletus es quasi flumen sapientia!,Terram retexit anima tua,"
,"17":"et replesti eam in comparationibus aenigmatum. Ad insulas longe divulgatum est nomen tuum, et dilectus es in pace tua."
,"18":"In cantilenis et proverbiis,et comparationibus et interpretationibus,te miratae sunt terrae."
,"19":"In nomine Domini Dei, cui est cognomen Deus Israel,"
,"20":"collegisti quasi orichalcum aurum,et ut plumbum cumulasti argentum."
,"21":"Sed reclinasti femora tua mulieribus, subiugatus es in corpore tuo."
,"22":"Dedisti maculam in gloria tua,et profanasti semen tuum, inducens iracundiam ad liberos tuos,et ingemiscere faciens super stultitia tua,"
,"23":"ut fieret imperium bipartitum, et ex Ephraim inciperet imperium infidele."
,"24":"Deus autem non derelinquet misericordiam suam,et non corrumpet nec delebit verba sua,neque perdet a stirpe nepotes electi sui,et semen eius, qui diligit Dominum, non corrumpet."
,"25":"Dedit autem reliquum Iacob,et David de ipso stirpem."
,"26":"Et finem habuit Salomon cum patribus suis"
,"27":"et dereliquit post se de semine suo,gentis stultitiam "
,"28":"et imminutum prudentia, Roboam, qui avertit gentem consilio suo."
,"29":"Et Ieroboam filius Nabat, qui peccare fecit Israel,et dedit viam peccandi Ephraim; et plurima redundaverunt peccata ipsorum valde,"
,"30":"ita ut expelleret illos a terra sua."
,"31":"Et exquisierunt omnes nequitias, usque dum perveniret super illos vindicta."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Et surrexit Elias propheta quasi ignis, et verbum ipsius quasi facula ardebat."
,"2":"Qui induxit in illos famem,et zelo suo paucos fecit eos."
,"3":"Verbo Domini continuit caelum,et deiecit de caelo ignem ter."
,"4":"Quam amplificatus es, Elias, in mirabilibus tuis!,Et quis potest similiter gloriari tibi?"
,"5":"Qui suscitasti mortuum de sorte mortis,ab inferis in verbo Domini."
,"6":"Qui deiecisti reges ad perniciem,et gloriosos de lecto suo,et confregisti facile potentiam ipsorum;"
,"7":"qui audis in Sinai indicium,et in Horeb iudicia vindictae."
,"8":"Qui ungis reges ad retributionem,et prophetas facis successores post te;"
,"9":"qui receptus es in turbine ignis,et in curru equorum igneorum;"
,"10":"qui scriptus es paratus in tempora,lenire iracundiam Domini ante furorem, convertere cor patris ad filium,et restituere tribus Iacob."
,"11":"Beati sunt, qui te viderunt,et in amicitia tua dormierunt!"
,"12":"Nam et nos vita quidem vivemus, post mortem autem non erit tale nomen nostrum."
,"13":"Elias quidem in turbine tectus est, et in Eliseo completus est spiritus eius. In diebus suis non pertimuit principem, et potentia nemo vicit illum;"
,"14":"nec superavit illum verbum aliquod, et mortuum prophetavit corpus eius."
,"15":"In vita sua fecit monstra,et in morte mirabilia operatus est."
,"16":"In omnibus istis non paenituit populum, et non recesserunt a peccatis suis, usque dum eiecti sunt de terra sua,et dispersi sunt in omnem terram;"
,"17":"et relicta est gens perpauca, et princeps in domo David."
,"18":"Quidam ipsorum fecerunt, quod placeret Deo; alii autem multiplicaverunt peccata."
,"19":"Ezechias munivit civitatem suam,et induxit in medium ipsius aquam et fodit ferro rupem,et aedificavit ad aquam puteum."
,"20":"In diebus ipsius ascendit Sennacherib,et misit Rabsacen et discessit, et sustulit manum suam in Sion,et superbus factus est in exaltatione sua."
,"21":"Tunc mota sunt corda et manus ipsorum, et doluerunt quasi parturientes mulieres"
,"22":"et invocaverunt Dominum misericordem,et expandentes manus suas extulerunt ad eum, et Sanctus audivit cito vocem ipsorum."
,"23":"Non est commemoratus peccatorum illorum,neque dedit illos inimicis suis, sed purgavit eos in manu Isaiae sancti prophetae;"
,"24":"percussit castra Assyriorum,et contrivit illos angelus eius."
,"25":"Nam fecit Ezechias quod placuit Deo,et fortiter ivit in via David patris sui, quam mandavit illi Isaias propheta, magnus et fidelis in visione sua."
,"26":"In diebus ipsius retro rediit sol, et addidit regi vitam."
,"27":"Spiritu magno vidit ultima,et consolatus est lugentes in Sion; usque in sempiternum ostendit futura"
,"28":"et abscondita, antequam evenirent."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Memoria Iosiae in compositionem odoris,facta opere pigmentarii;"
,"2":"in omni ore quasi mel indulcabitur eius memoria,et ut musica in convivio vini."
,"3":"Ipse est directus divinitus in paenitentia gentis,et tulit abominationes impietatis;"
,"4":"et gubernavit ad Dominum cor suum,et in diebus peccatorum corroboravit pietatem."
,"5":"Praeter David et Ezechiam et Iosiam, omnes peccatum commiserunt;"
,"6":"nam reliquerunt legem Altissimi reges Iudae,et contempserunt timorem Dei;"
,"7":"dederunt enim regnum suum aliis,et gloriam suam alienae genti;"
,"8":"incenderunt electam sanctuarii civitatem,et desertas fecerunt vias ipsius in manu Ieremiae."
,"9":"Nam male tractaverunt illum, ipse autem a ventre matris consecratus est propheta,evertere et eruere et perdere,et iterum aedificare et plantare et renovare."
,"10":"Ezechiel, qui vidit visionem gloriae, quam ostendit illi in curru cherubim."
,"11":"Nam et commemoratus est inimicorum in imbre,et benefacere illis, qui ostenderunt rectas vias."
,"12":"Et duodecim prophetarum ossa pullulent de loco suo; nam corroboraverunt Iacob,et redemerunt eos in fide virtutis."
,"13":"Quomodo amplificemus Zorobabel?,Nam et ipse quasi signum in dextera manu;"
,"14":"sic et Iesua filius Iosedec. Qui in diebus suis aedificaverunt domum,et exaltaverunt templum sanctum Domino,paratum in gloriam sempiternam."
,"15":"Et Nehemias: in memoria multi temporis, qui erexit nobis muros eversos,et stare fecit portas et seras; qui erexit domos nostras."
,"16":"Nemo creatus est in terra qualis Henoch; nam et ipse assumptus est a terra."
,"17":"Neque ut Ioseph natus est homo, princeps fratrum, firmamentum gentis;"
,"18":"et ossa ipsius visitata sunt,et post mortem prophetaverunt."
,"19":"Seth et Sem apud homines gloriam adepti sunt,et super omnem animam in origine Adam."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Simon, Oniae filius, sacerdos magnus, qui in vita sua suffulsit domum,et in diebus suis corroboravit templum."
,"2":"Templi etiam altitudo ab ipso fundata est, substructura elata parietis templi."
,"3":"In diebus ipsius excisa est piscina aquarum, lacus, quasi maris superficies eius."
,"4":"Qui curavit gentem suam a latrone,et firmavit eam ab obsidione."
,"5":"Quam gloriosus apparuit, cum prospiceret e tabernaculo,in egressu domus velamenti!"
,"6":"Quasi stella matutina in medio nebulae,et quasi luna plena in diebus festi"
,"7":"et quasi sol refulgens super templum Dei."
,"8":"Quasi arcus refulgens inter nebulas gloriae,et quasi flos rosarum in diebus vernis,et quasi lilia, quae sunt in transitu aquae, et quasi flos Libani in diebus aestatis;"
,"9":"quasi ignis effulgens et tus ardens in igne,"
,"10":"quasi vas auri solidum,ornatum omni lapide pretioso,"
,"11":"quasi oliva pullulans fructibus,et cupressus in nubes se extollens, in accipiendo ipsum stolam gloriae et vestiri eum in consummationem magnificentiae."
,"12":"In ascensu altaris sancti, cum gloriam daret peribolo sanctuarii"
,"13":"et acciperet partes de manu sacerdotum, et ipse stans iuxta aram, et circa illum corona fratrum, quasi plantatio cedri in monte Libano,"
,"14":"sic circa illum steterunt quasi rami palmae,omnes filii Aaron in gloria sua."
,"15":"Oblatio autem Domini in manibus ipsorum,coram omni synagoga Israel, et consummatione fungens in ara, ordinans oblationem Omnipotentis."
,"16":"Porrexit manum suam in libatione,et libavit de sanguine uvae;"
,"17":"effudit in fundamento altaris,odorem divinum excelso Principi."
,"18":"Tunc exclamaverunt filii Aaron, in tubis productilibus sonuerunt,et auditam fecerunt vocem magnam,in memoriam coram Deo altissimo."
,"19":"Tunc omnis populus simul properaverunt,et ceciderunt in faciem super terram,adorare Dominum Deum suum,et dare preces omnipotenti Deo excelso."
,"20":"Et laudaverunt psallentes in vocibus suis, et magnus resonabat cantus suavitatis plenus."
,"21":"Et rogavit populus Dominum excelsum in prece coram Misericorde, usque dum perfectus est honor Domini; et munus suum perfecerunt."
,"22":"Tunc descendens manus suas extulit,in omnem congregationem filiorum Israel,dare benedictionem Domini in labiis suis,et in nomine ipsius gloriari;"
,"23":"et iteraverunt adorationem suam, ut acciperent benedictionem Altissimi."
,"24":"Et nunc benedicite Deum omnium, qui magna facit in omni terra, exaltans dies nostros a ventre matris nostrae,et faciens nobiscum secundum suam misericordiam."
,"25":"Det nobis iucunditatem cordis,et fieri pacem in diebus nostris in Israel per dies sempiternos;"
,"26":"credere Israel nobiscum esse Dei misericordiam, ut liberet nos in diebus nostris."
,"27":"Duas gentes odit anima mea, tertia autem non est quidem gens:"
,"28":"qui sedent in monte Seir et Philisthim,et stultus populus, qui habitat in Sichimis."
,"29":"Doctrinam sapientiae et disciplinae,scripsit in codice isto Iesus filius Sirach, Ierosolymita, qui effudit sapientiam de corde suo."
,"30":"Beatus, qui in istis versatur sermonibus; qui ponit illa in corde suo, sapiens erit semper."
,"31":"Si enim haec fecerit, ad omnia valebit, quia timor Domini vestigium eius est."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Oratio Iesu filii Sirach. ' Confitebor tibi, Domine rex; et collaudabo te Deum salvatorem meum."
,"2":"Confitebor nomini tuo, quoniam adiutor et protector factus es mihi"
,"3":"et liberasti corpus meum a perditione, a laqueo linguae iniquae,et a labiis operantium mendacium, et in conspectu insurgentium factus es mihi adiutor."
,"4":"Et liberasti me, secundum magnitudinem misericordiae et nominis tui, a laqueis praeparatis ad escam,"
,"5":"de manibus quaerentium animam meam,et de multis tribulationibus, quae circumdederunt me,"
,"6":"a pressura flammae, quae circumdedit me, et de medio ignis, ubi non sum aestuatus;"
,"7":"de altitudine ventris inferi,et a lingua coinquinata et a verbo mendacii, a iaculo linguae iniustae."
,"8":"Appropinquavit usque ad mortem anima mea,"
,"9":"et vita mea appropinquans erat in inferno deorsum."
,"10":"Circumdederunt me undique, et non erat qui adiuvaret; respiciens eram ad adiutorium hominum, et non erat."
,"11":"Memoratus autem sum misericordiae tuae, Domine, et operationis tuae, quae a saeculo est,"
,"12":"quoniam eruis sustinentes te, Domine, et liberas eos de manibus iniquorum."
,"13":"Exaltavi de terra supplicationem meam,et pro morte defluente deprecatus sum."
,"14":"Invocavi Dominum: 'Pater meus es tu, ne derelinquas me in die tribulationis meae,et in tempore superborum sine adiutorio."
,"15":"Laudabo nomen tuum assidue,et collaudabo illud in confessione'. Et exaudita est oratio mea."
,"16":"Et liberasti me de perditione,et eripuisti me de tempore iniquo."
,"17":"Propterea confitebor et laudem dicam tibi,et benedicam nomini Domini."
,"18":"Cum adhuc iunior essem, priusquam oberrarem, quaesivi sapientiam palam in oratione mea;"
,"19":"ante templum postulabam pro illa,et usque in novissimis inquiram eam, et effloruit tamquam praecox uva."
,"20":"Laetatum est cor meum in ea, ambulavit pes meus iter rectum; a iuventute mea investigabam eam."
,"21":"Inclinavi modice aurem meam et excepi illam"
,"22":"et multam inveni mihimetipsi sapientiam,et multum profeci in ea:"
,"23":"danti mihi sapientiam dabo gloriam."
,"24":"Consiliatus sum enim, ut facerem illam; et quaesivi bonum et non confundar."
,"25":"Colluctata est anima mea in illa, et in faciendo legem diligens fui."
,"26":"Manus meas extendi in altum,et incognoscibilia eius intellexi."
,"27":"Animam meam direxi ad illam,et in purificatione inveni eam."
,"28":"Possedi cum ipsa cor ab initio; propter hoc non derelinquar."
,"29":"Venter meus conturbatus est quaerendo illam; propterea bonam possedi possessionem."
,"30":"Dedit mihi Dominus linguam mercedem meam, et in ipsa laudabo eum."
,"31":"Appropiate ad me, indocti, et congregate vos in domo disciplinae."
,"32":"Quid adhuc retardatis in his, dum animae vestrae sitiunt vehementer?"
,"33":"Aperui os meum et locutus sum: 'Comparate vobis sine argento"
,"34":"et collum vestrum subicite iugo, et suscipiat anima vestra disciplinam: in proximo est enim invenire eam."
,"35":"Videte oculis vestris quia modicum laboravi,et inveni mihi multam requiem."
,"36":"Assumite disciplinam in multo numero argenti,et copiosum aurum possidete in ea."
,"37":"Laetetur anima vestra in misericordia eius, et non confundemini in laude ipsius."
,"38":"Operamini opus vestrum ante tempus, et dabit vobis mercedem vestram in tempore suo' '."
}`)

}
func LA_NVBSE_LoadVSIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Vir erat in terra Us nomine Iob, et erat vir ille simplex et rectus ac timens Deum et recedens a malo."
,"2":"Natique sunt ei septem filii et tres filiae."
,"3":"Et fuit possessio eius septem milia ovium et tria milia camelorum, quingenta quoque iuga boum et quingentae asinae ac familia multa nimis; eratque vir ille magnus inter omnes Orientales."
,"4":"Et ibant filii eius et faciebant convivium per domos unusquisque in die suo; et mittentes vocabant tres sorores suas, ut comederent et biberent cum eis."
,"5":"Cumque in orbem transissent dies convivii, mittebat ad eos Iob et sanctificabat illos; consurgensque diluculo offerebat holocausta pro singulis. Dicebat enim: ' Ne forte peccaverint filii mei et benedixerint Deo in cordibus suis '. Sic faciebat Iob cunctis diebus."
,"6":"Quadam autem die, cum venissent filii Dei, ut assisterent coram Domino, affuit inter eos etiam Satan."
,"7":"Cui dixit Dominus: ' Unde venis? '. Qui respondens ait: ' Circuivi terram et perambulavi eam '."
,"8":"Dixitque Dominus ad eum: ' Numquid considerasti servum meum Iob, quod non sit ei similis in terra, homo simplex et rectus ac timens Deum et recedens a malo? '."
,"9":"Cui respondens Satan ait: ' Numquid Iob frustra timet Deum?"
,"10":"Nonne tu vallasti eum ac domum eius universamque substantiam per circuitum, operibus manuum eius benedixisti, et possessio eius crevit in terra?"
,"11":"Sed extende paululum manum tuam et tange cuncta, quae possidet, nisi in faciem benedixerit tibi '."
,"12":"Dixit ergo Dominus ad Satan: ' Ecce, universa, quae habet, in manu tua sunt; tantum in eum ne extendas manum tuam '. Egressusque est Satan a facie Domini."
,"13":"Cum autem quadam die filii et filiae eius comederent et biberent vinum in domo fratris sui primogeniti,"
,"14":"nuntius venit ad Iob, qui diceret: ' Boves arabant, et asinae pascebantur iuxta eos;"
,"15":"et irruerunt Sabaei tuleruntque eos et pueros percusserunt gladio, et evasi ego solus, ut nuntiarem tibi '."
,"16":"Cumque adhuc ille loqueretur, venit alter et dixit: ' Ignis Dei cecidit e caelo et ussit oves puerosque consumpsit, et effugi ego solus, ut nuntiarem tibi '."
,"17":"Sed et illo adhuc loquente, venit alius et dixit: ' Chaldaei fecerunt tres turmas et invaserunt camelos et tulerunt eos necnon et pueros percusserunt gladio, et ego fugi solus, ut nuntiarem tibi '."
,"18":"Adhuc loquebatur ille, et ecce alius intravit et dixit: ' Filiis tuis et filiabus vescentibus et bibentibus vinum in domo fratris sui primogeniti,"
,"19":"repente ventus vehemens irruit a regione deserti et concussit quattuor angulos domus; quae corruens oppressit liberos tuos, et mortui sunt, et effugi ego solus, ut nuntiarem tibi '."
,"20":"Tunc surrexit Iob et scidit vestimenta sua et, tonso capite, corruens in terram adoravit"
,"21":"et dixit: ' Nudus egressus sum de utero matris meae,et nudus revertar illuc. Dominus dedit, Dominus abstulit; sicut Domino placuit, ita factum est: sit nomen Domini benedictum '."
,"22":"In omnibus his non peccavit Iob labiis suis neque stultum quid contra Deum locutus est."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Factum est autem, cum quadam die venissent filii Dei, ut starent coram Domino, venit quoque Satan inter eos, ut staret in conspectu eius."
,"2":"Dixit Dominus ad Satan: ' Unde venis? '. Qui respondens ait: ' Circuivi terram et perambulavi eam '."
,"3":"Et dixit Dominus ad Satan: ' Numquid considerasti servum meum Iob, quod non sit ei similis in terra, vir simplex et rectus ac timens Deum et recedens a malo et adhuc retinens innocentiam? Tu autem commovisti me adversus eum, ut affligerem eum frustra '."
,"4":"Cui respondens Satan ait: ' Pellem pro pelle et cuncta, quae habet, homo dabit pro anima sua."
,"5":"Alioquin mitte manum tuam et tange os eius et carnem; et tunc videbis, si in faciem benedicet tibi '."
,"6":"Dixit ergo Dominus ad Satan: ' Ecce, in manu tua est; verumtamen animam illius serva '."
,"7":"Egressus igitur Satan a facie Domini, percussit Iob ulcere pessimo a planta pedis usque ad verticem eius."
,"8":"Qui testa saniem radebat, sedens in sterquilinio."
,"9":"Dixit autem illi uxor sua: ' Adhuctu permanes in simplicitate tua?,Benedic Deo et morere '."
,"10":"Qui ait ad illam: ' Quasi una de stultis mulieribus,locuta es!,Si bona suscepimus de manu Dei, mala quare non suscipiamus? '. In omnibus his non peccavit Iob labiis suis."
,"11":"Igitur, audientes tres amici Iob omne malum, quod accidisset ei, venerunt singuli de loco suo, Eliphaz Themanites et Baldad Suhites et Sophar Naamathites. Condixerant enim, ut pariter venientes visitarent eum et consolarentur."
,"12":"Cumque elevassent procul oculos suos, non cognoverunt eum et exclamantes ploraverunt; scissisque vestibus, sparserunt pulverem super caput suum in caelum."
,"13":"Et sederunt cum eo in terra septem diebus et septem noctibus, et nemo loquebatur ei verbum; videbant enim dolorem esse vehementem."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Post haec aperuit Iob os suum et maledixit diei suo"
,"2":"et locutus est:"
,"3":"' Pereat dies, in qua natus sum, et nox, in qua dictum est: 'Conceptus est homo'."
,"4":"Dies ille vertatur in tenebras; non requirat eum Deus desuper, et non illustretur lumine."
,"5":"Obscurent eum tenebrae et umbra mortis; occupet eum caligo, et involvatur amaritudine."
,"6":"Noctem illam tenebrosus turbo possideat; non computetur in diebus anni,nec numeretur in mensibus."
,"7":"Sit nox illa solitaria nec laude digna;"
,"8":"maledicant ei, qui maledicunt diei, qui parati sunt suscitare Leviathan."
,"9":"Obtenebrentur stellae crepusculi eius; exspectet lucem, et non sit, nec videat palpebras aurorae,"
,"10":"quia non conclusit ostia ventris, qui portavit me, nec abstulit mala ab oculis meis."
,"11":"Quare non in vulva mortuus sum?,Egressus ex utero non statim perii? "
,"12":"Quare exceptus genibus?,Cur lactatus uberibus?"
,"13":"Nunc enim dormiens silerem,et somno meo requiescerem"
,"14":"cum regibus et consulibus terrae, qui aedificant sibi solitudines,"
,"15":"aut cum principibus, qui possident aurum,et replent domos suas argento."
,"16":"Aut sicut abortivum absconditum non subsisterem, vel qui concepti non viderunt lucem."
,"17":"Ibi impii cessaverunt a tumultu, et ibi requieverunt fessi robore."
,"18":"Et quondam vincti pariter sine molestia,non audierunt vocem exactoris."
,"19":"Parvus et magnus ibi sunt, et servus liber a domino suo."
,"20":"Quare misero data est lux, et vita his, qui in amaritudine animae sunt?"
,"21":"Qui exspectant mortem, et non venit, et effodiunt quaerentes illam magis quam thesauros;"
,"22":"gaudentque vehementer,et laetantur sepulcro."
,"23":"Viro, cuius abscondita est via, et circumdedit eum Deus tenebris. "
,"24":"Antequam comedam, suspiro, et quasi inundantes aquae sic rugitus meus."
,"25":"Quia timor, quem timebam, evenit mihi, et, quod verebar, accidit."
,"26":"Non dissimulavi, non silui, non quievi, et venit super me indignatio '."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Respondens autem Eliphaz Themanites dixit:"
,"2":"' Si coeperimus loqui tibi, forsitan moleste accipies; sed conceptum sermonem tenere quis poterit?"
,"3":"Ecce, docuisti multos,et manus lassas roborasti;"
,"4":"vacillantes confirmaverunt sermones tui, et genua trementia confortasti."
,"5":"Nunc autem venit super te plaga, et defecisti; tetigit te, et conturbatus es."
,"6":"Nonne timor tuus est fiducia tua, spes tua est perfectio viarum tuarum?"
,"7":"Recordare, obsecro te, quis umquam innocens periit, aut quando recti deleti sunt?"
,"8":"quin potius vidi eos, qui operantur iniquitatem,et seminant dolores et metunt eos, "
,"9":"flante Deo perisse, et spiritu irae eius esse consumptos. "
,"10":"Rugitus leonis et vox leaenae,et dentes catulorum leonum contriti sunt."
,"11":"Leo periit, eo quod non haberet praedam, et catuli leonis dissipati sunt."
,"12":"Porro ad me furtive verbum delatum est, et suscepit auris mea sussurrum eius."
,"13":"In horrore visionis nocturnae, quando solet sopor occupare homines,"
,"14":"pavor tenuit me et tremor, et omnia ossa mea perterrita sunt. "
,"15":"Et cum spiritus, me praesente, transiret, inhorruerunt pili carnis meae."
,"16":"Stetit quidam, cuius non agnoscebam vultum, imago coram oculis meis, et vocem quasi aurae lenis audivi:"
,"17":"'Numquid homo Dei comparatione iustificabitur, aut factore suo purior erit vir?'."
,"18":"Ecce, in servis suis fiduciam non habet,et in angelis suis reperit pravitatem. "
,"19":"Quanto magis hi, qui habitant domos luteas, quorum fundamentum est in pulvere. Consumentur velut tinea!"
,"20":"De mane usque ad vesperam succidentur,et, quia nullus intellegit, in aeternum peribunt."
,"21":"Nonne evulsum est reliquum eorum ab eis?,Morientur, et non in sapientia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Voca ergo, si est qui tibi re spondeat!,Ad quem sanctorum converteris?"
,"2":"Vere stultum interficit iracundia, et fatuum occidit invidia."
,"3":"Ego vidi stultum firma radice,et maledixi sedi eius statim."
,"4":"Longe fient filii eius a salute,et conterentur in porta, et non erit qui eruat."
,"5":"Cuius messem famelicus comedet, et ipsum rapiet armatus, et bibent sitientes divitias eius."
,"6":"Quia non egreditur ex pulvere nequitia, et de humo non oritur dolor."
,"7":"Sed homo generat laborem, et aves elevant volatum."
,"8":"Quam ob rem ego deprecabor Dominum,et ad Deum ponam eloquium meum,"
,"9":"qui facit magna et inscrutabilia,et mirabilia absque numero;"
,"10":"qui dat pluviam super faciem terrae,et irrigat aquis rura;"
,"11":"qui ponit humiles in sublime,et maerentes erigit sospitate;"
,"12":"qui dissipat cogitationes malignorum, ne possint implere manus eorum, quod coeperant;"
,"13":"qui apprehendit sapientes in astutia eorum,et consilium pravorum dissipat."
,"14":"Per diem incurrent tenebras,et, quasi in nocte, sic palpabunt in meridie."
,"15":"Porro salvum faciet egenum a gladio oris eorum,et de manu violenti pauperem;"
,"16":"et erit egeno spes, iniquitas autem contrahet os suum."
,"17":"Beatus homo, qui corripitur a Deo; increpationem ergo Omnipotentis ne reprobes."
,"18":"Quia ipse vulnerat et medetur, percutit, et manus eius sanabunt."
,"19":"In sex tribulationibus liberabit te, et in septem non tanget te malum. "
,"20":"In fame eruet te de morte,et in bello de manu gladii."
,"21":"A flagello linguae absconderis,et non timebis vastationem, cum venerit."
,"22":"In vastitate et fame ridebis,et bestias terrae non formidabis."
,"23":"Sed cum lapidibus campi pactum tuum, et bestiae terrae pacificae erunt tibi. "
,"24":"Et scies quod pacem habeat tabernaculum tuum, et visitans habitationem tuam non falleris."
,"25":"Scies quoque quoniam multiplex erit semen tuum, et progenies tua quasi herba terrae."
,"26":"Ingredieris in abundantia sepulcrum, sicut infertur acervus tritici in tempore suo."
,"27":"Ecce hoc, ut investigavimus, ita est; oboedi illi et tu sapias tibi '."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Respondens autem Iob dixit:"
,"2":"' Utinam appenderetur aegritu do mea, et calamitatem meam assumerent in statera!"
,"3":"Nunc vero arena maris haec gravior apparet, inde verbis meis haesito."
,"4":"Quia sagittae Omnipotentis in me sunt, quarum venenum ebibit spiritus meus; et terrores Dei militant contra me."
,"5":"Numquid rugiet onager, cum habuerit herbam?,Aut mugiet bos, cum ante praesepe plenum steterit?"
,"6":"Aut poterit comedi insulsum, quod non est sale conditum?,Aut poterit gustari herba insulsa?"
,"7":"Quae prius nolebat tangere anima mea, nunc prae angustia cibi mei sunt."
,"8":"Quis det, ut veniat petitio mea, et, quod exspecto, tribuat mihi Deus?"
,"9":"Utinam Deus me conterat; solvat manum suam et succidat me! "
,"10":"Et haec mihi sit consolatio, et exsultabo vel in pavore, qui non parcat, nec celabo sermones Sancti."
,"11":"Quae est enim fortitudo mea, ut sustineam?,Aut quis finis meus, ut patienter agam?"
,"12":"Num fortitudo lapidum, fortitudo mea?,Num caro mea aenea est?"
,"13":"An non est auxilium mihi in me, et virtus quoque remota est a me?"
,"14":"Qui tollit ab amico suo misericordiam, timorem Omnipotentis derelinquit. "
,"15":"Fratres mei mentiti sunt me,sicut alveus torrentium, qui evanescunt"
,"16":"nigrescentes glacie, cum ingruit super eos nix."
,"17":"Tempore, quo diffluunt, arescunt,et, ut incaluerit, solvuntur de loco suo."
,"18":"Deflectunt viatorum turmae de viis suis, ascendentes per desertum pereunt. "
,"19":"Commeatus Thema consideraverunt, viatores Saba speraverunt in eis."
,"20":"Confusi sunt, quia speraverunt; venerunt eo usque, et pudore cooperti sunt."
,"21":"Ita nunc vos facti estis mihi; videntes plagam meam, timetis."
,"22":"Numquid dixi: Afferte mihi,et de substantia vestra donate mihi? "
,"23":"vel: Liberate me de manu hostis,et de manu robustorum eruite me? "
,"24":"Docete me, et ego tacebo, et, si quid forte ignoravi, instruite me."
,"25":"Quare detraxistis sermonibus veritatis, cum e vobis nullus sit, qui possit arguere me?"
,"26":"Ad increpandum tantum eloquia concinnatis, sed in ventum verba desperati."
,"27":"Super pupillum irruitis,et subvertere nitimini amicum vestrum."
,"28":"Nunc, quaeso, convertimini ad me, et in faciem vestram non mentiar."
,"29":"Revertite! Nulla erit improbitas. Revertite! Adhuc praesens adest iustitia mea."
,"30":"Estne in lingua mea improbitas?,An palatum meum non discernit nequitiam?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Nonne militia est vita hominis super terram, et sicut dies mercennarii dies eius? "
,"2":"Sicut servus desiderat umbram, et sicut mercennarius praestolatur mercedem suam,"
,"3":"sic et ego habui menses vacuos,et noctes laboriosas enumeravi mihi. "
,"4":"Si dormiero, dicam: Quando consurgam?,Et rursum exspectabo vesperam,et replebor doloribus usque crepusculum."
,"5":"Induta est caro mea putredine et sordibus pulveris; cutis mea scinditur et diffluit."
,"6":"Dies mei velocius transierunt quam navicula texentis,et consumpti sunt deficiente filo."
,"7":"Memento quia ventus est vita mea, et non revertetur oculus meus, ut videat bona."
,"8":"Nec aspiciet me visus hominis; oculi tui in me, et non subsistam."
,"9":"Sicut consumitur nubes et pertransit, sic, qui descenderit ad inferos, non ascendet"
,"10":"nec revertetur ultra in domum suam, neque cognoscet eum amplius locus eius."
,"11":"Quapropter et ego non parcam ori meo; loquar in tribulatione spiritus mei, confabulabor cum amaritudine animae meae."
,"12":"Numquid mare ego sum aut cetus, quia posuisti super me custodiam? "
,"13":"Si dixero: Consolabitur me lectulus meus, et assumet stratum meum querelam meam,"
,"14":"terrebis me per somnia,et per visiones horrore concuties."
,"15":"Quam ob rem eligit suspendium anima mea, et mortem ossa mea."
,"16":"Desperavi; nequaquam ultra iam vivam. Parce mihi, nihil enim sunt dies mei."
,"17":"Quid est homo, quia magnificas eum?,Aut quid apponis erga eum cor tuum?"
,"18":"Visitas eum diluculo,et singulis momentis probas illum. "
,"19":"Usquequo non avertes oculos a me?,Nec dimittis me, ut glutiam salivam meam?"
,"20":"Peccavi; quid faciam tibi, o custos hominum?,Quare posuisti me contrarium tibi, et factus sum mihimetipsi gravis?"
,"21":"Cur non tollis peccatum meum,et quare non aufers iniquitatem meam?,Ecce, nunc in pulvere dormiam; et, si mane me quaesieris, non subsistam! '."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Respondens autem Baldad Suhites dixit:"
,"2":"' Usquequo loqueris talia, et spiritus vehemens sermones oris tui?"
,"3":"Numquid Deus supplantat iudicium, aut Omnipotens subvertit, quod iustum est?"
,"4":"Et si filii tui peccaverunt ei, et dimisit eos in manu iniquitatis suae,"
,"5":"tu tamen, si diluculo consurrexeris ad Deum,et Omnipotentem fueris deprecatus, "
,"6":"si mundus et rectus incesseris, statim evigilabit ad te,et pacatum reddet habitaculum iustitiae tuae;"
,"7":"in tantum ut, si priora tua fuerint parva, et novissima tua multiplicentur nimis."
,"8":"Interroga enim generationem pristinam,et diligenter investiga patrum memoriam."
,"9":"Hesterni quippe sumus et ignoramus, quoniam sicut umbra dies nostri sunt super terram."
,"10":"Nonne ipsi docebunt te, loquentur tibi,et de corde suo proferent eloquia?"
,"11":"Numquid virere potest scirpus absque umore, aut crescere carectum sine aqua?"
,"12":"Cum adhuc sit in flore, nec carpatur manu, ante omnes herbas arescit."
,"13":"Sic viae omnium, qui obliviscuntur Deum, et spes impii peribit."
,"14":"Cuius spes filum tenue, et sicut tela aranearum fiducia eius. "
,"15":"Innitetur super domum suam et non stabit; fulciet eam et non consurget."
,"16":"Umectus videtur, antequam veniat sol, et in horto suo germen eius egredietur."
,"17":"Super acervum petrarum radices eius densabuntur, et inter lapides commorabitur."
,"18":"Si absorbuerit eum de loco suo, negabit eum et dicet: 'Non novi te'."
,"19":"Haec est enim laetitia viae eius, ut rursum de terra alii germinentur. "
,"20":"Deus non proiciet simplicem,nec porriget manum malignis,"
,"21":"donec impleatur risu os tuum, et labia tua iubilo."
,"22":"Qui oderunt te, induentur confusione, et tabernaculum impiorum non subsistet '."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Et respondens Iob ait:"
,"2":"' Vere scio quod ita sit, et quomodo iustificabitur homo compositus Deo?"
,"3":"Si voluerit contendere cum eo, non poterit ei respondere unum pro mille."
,"4":"Sapiens corde est et fortis robore; quis restitit ei, et pacem habuit?"
,"5":"Qui transtulit montes, et nescierunt hi, quos subvertit in furore suo."
,"6":"Qui commovet terram de loco suo, et columnae eius concutiuntur."
,"7":"Qui praecipit soli, et non oritur, et stellas claudit quasi sub signaculo."
,"8":"Qui extendit caelos solus,et graditur super fluctus maris."
,"9":"Qui facit Arcturum et Oriona,et Hyadas et interiora austri."
,"10":"Qui facit magna et incomprehensibilia,et mirabilia, quorum non est numerus."
,"11":"Si venerit ad me, non videbo eum; si abierit, non intellegam."
,"12":"Si repente arripiet, quis eum impediet?,Vel quis dicere potest: 'Quid facis?'."
,"13":"Deus non retinet iram suam, et sub eo curvantur auxilia Rahab. "
,"14":"Quantus ergo sum ego, ut respondeam ei,et loquar delectis verbis cum eo?"
,"15":"Quia, etiamsi iustus essem, non responderem, sed meum iudicem deprecarer;"
,"16":"et, cum invocantem exaudierit me, non credam quod audierit vocem meam."
,"17":"In turbine enim conteret me,et multiplicabit vulnera mea etiam sine causa."
,"18":"Non concedit requiescere spiritum meum,et implet me amaritudinibus."
,"19":"Si fortitudo quaeritur, robustissimus est; si iudicium, quis eum arcesserit?"
,"20":"Si iustificare me voluero, os meum condemnabit me; si innocentem ostendero, pravum me comprobabit."
,"21":"Etiamsi simplex fuero, hoc ipsum ignorabit anima mea, et contemnam vitam meam."
,"22":"Unum est, quod locutus sum: Et innocentem et impium ipse consumit."
,"23":"Si subito flagellum occidat, de afflictione innocentium ridebit. "
,"24":"Terra data est in manus impii, vultum iudicum eius operit; quod si non ille est, quis ergo est?"
,"25":"Dies mei velociores fuerunt cursore: fugerunt et non viderunt bonum;"
,"26":"pertransierunt quasi naves arundineae, sicut aquila volans ad escam."
,"27":"Cum dixero: Obliviscar maerorem meum, commutabo faciem meam et hilaris fiam,"
,"28":"vereor omnes dolores meos, sciens quod non iustificaveris me."
,"29":"Si autem et sic impius sum, quare frustra laboravi?"
,"30":"Si lotus fuero quasi aquis nivis, et lixivo mundavero manus meas,"
,"31":"tamen sordibus intinges me, et abominabuntur me vestimenta mea."
,"32":"Neque enim viro, qui similis mei est, respondebo; nec vir, quocum in iudicio contendam."
,"33":"Non est qui utrumque valeat arguere,et ponere manum suam in ambobus."
,"34":"Auferat a me virgam suam, et pavor eius non me terreat."
,"35":"Loquar et non timebo eum; quia sic non mecum ipse sum."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Taedet animam meam vitae meae; dimittam adversum me eloquium meum, loquar in amaritudine animae meae."
,"2":"Dicam Deo: Noli me condemnare, indica mihi cur me ita iudices."
,"3":"Numquid bonum tibi videtur, si opprimas me,et calumnieris me, opus manuum tuarum, et super consilium impiorum arrideas?"
,"4":"Numquid oculi carnei tibi sunt, aut, sicut videt homo, et tu videbis? "
,"5":"Numquid sicut dies hominis dies tui, et anni tui sicut humana sunt tempora,"
,"6":"ut quaeras iniquitatem meam,et peccatum meum scruteris,"
,"7":"cum scias quia nihil impium fecerim, et sit nemo, qui de manu tua possit eruere?"
,"8":"Manus tuae fecerunt me,et plasmaverunt me totum in circuitu; et sic repente praecipitas me?"
,"9":"Memento, quaeso, quod sicut lutum feceris me,et in pulverem reduces me."
,"10":"Nonne sicut lac mulsisti me,et sicut caseum me coagulasti?"
,"11":"Pelle et carnibus vestisti me; ossibus et nervis compegisti me."
,"12":"Vitam et misericordiam tribuisti mihi, et visitatio tua custodivit spiritum meum."
,"13":"Licet haec celes in corde tuo, tamen scio haec in animo tuo versari."
,"14":"Si peccaverim, observas me,et ab iniquitate mea mundum me esse non pateris."
,"15":"Et si impius fuero, vae mihi est; et si iustus, non levabo caput, saturatus afflictione et miseria."
,"16":"Si superbia extollar, quasi catulum leonis capies me,et iterum mirabilem te exhibebis in me."
,"17":"Instauras testes tuos contra me,et multiplicas iram tuam adversum me, et poenae militant in me."
,"18":"Quare de vulva eduxisti me?,Qui utinam consumptus essem, ne oculus me videret!"
,"19":"Fuissem quasi non essem, de utero translatus ad tumulum."
,"20":"Numquid non paucitas dierum meorum finietur brevi?,Dimitte ergo me, ut refrigerem paululum dolorem meum,"
,"21":"antequam vadam, et non revertar, ad terram tenebrarum et umbrae mortis,"
,"22":"terram caliginis et tenebrarum, ubi umbra mortis et nullus ordo, sed sempiternus horror inhabitat '."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Respondens autem Sophar Naamathites dixit:"
,"2":"' Numquid illi, qui multa loquitur, non et respondetur?,Aut vir verbosus iustificabitur?"
,"3":"Vaniloquium tuum viros tacere faciet, et, cum ceteros irriseris, a nullo confutaberis?"
,"4":"Dixisti enim: 'Purus est sermo meus, et mundus sum in conspectu tuo'. "
,"5":"Atque utinam Deus ipse loqueretur tecum,et aperiret labia sua tibi,"
,"6":"ut ostenderet tibi secreta sapientiae,et arcana consilia eius, et intellegeres quod multo minora quaerat a te, quam meretur iniquitas tua."
,"7":"Forsitan vestigia Dei comprehendes,et usque ad perfectum Omnipotentem reperies?"
,"8":"Excelsior caelo est, et quid facies?,Profundior inferno, et quid cognosces?"
,"9":"Longior terra mensura eius,et latior mari."
,"10":"Si subverterit vel concluserit et coarctaverit, quis contradicet ei?"
,"11":"Ipse enim novit hominum vanitatem; et videns iniquitatem nonne considerat?"
,"12":"Sed et vir vacuus cordatus fit, et homo tamquam pullum onagri nascitur."
,"13":"Tu autem, si cor tuum firmaveris,et expanderis ad eum manus tuas, "
,"14":"si iniquitatem, quae est in manu tua, abstuleris a te, et non manserit in tabernaculo tuo iniustitia,"
,"15":"tunc levare poteris faciem tuam absque macula,et eris stabilis et non timebis."
,"16":"Miseriae quoque oblivisceris,et quasi aquarum, quae praeterierunt, recordaberis."
,"17":"Et quasi meridianus fulgor consurget tibi ad vesperam, et, cum te caligine tectum putaveris, orieris ut lucifer."
,"18":"Et habebis fiduciam, proposita tibi spe, et defossus securus dormies."
,"19":"Requiesces, et non erit qui te exterreat; et deprecabuntur faciem tuam plurimi."
,"20":"Oculi autem impiorum deficient, et effugium peribit ab eis; et spes illorum exhalatio animae '."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Respondens autem Iob dixit:"
,"2":"' Ergo vos estis soli homines, et vobiscum morietur sapientia."
,"3":"Et mihi est cor sicut et vobis, nec inferior vestri sum; quis enim haec, quae nostis, ignorat?"
,"4":"Qui deridetur ab amico suo sicut ego, invocabit Deum, et exaudiet eum; deridetur enim iusti integritas."
,"5":"Lampas contempta apud cogitationes eorum, qui securi sunt, parata iis, qui vacillant pede."
,"6":"Tranquilla sunt tabernacula praedonum,et secura iis, qui provocant Deum, iis, qui Deum tenent manu sua."
,"7":"Nimirum interroga iumenta, et docebunt te, et volatilia caeli, et indicabunt tibi. "
,"8":"Loquere terrae, et docebit te; et narrabunt pisces maris."
,"9":"Quis ignorat in omnibus his,quod manus Domini hoc fecerit?"
,"10":"In cuius manu anima omnis viventis,et spiritus universae carnis hominis. "
,"11":"Nonne auris verba diiudicat, et palatum cibum sibi gustat?"
,"12":"In senibus est sapientia, et in longaevis prudentia."
,"13":"Apud ipsum est sapientia et fortitudo; ipse habet consilium et intellegentiam."
,"14":"Si destruxerit, nemo est, qui aedificet; si incluserit hominem, nullus est, qui aperiat."
,"15":"Si continuerit aquas, arescent; et, si emiserit eas, subvertent terram."
,"16":"Apud ipsum est fortitudo et sapientia; ipse novit et decipientem et eum qui decipitur."
,"17":"Inducit consiliarios spoliatos,et iudices in stuporem."
,"18":"Balteum regum dissolvit,et praecingit fune renes eorum."
,"19":"Inducit sacerdotes spoliatos,et optimates supplantat,"
,"20":"commutans labium veracium,et doctrinam senum auferens."
,"21":"Effundit despectionem super principes,et cingulum fortium relaxat."
,"22":"Qui revelat profunda de tenebris,et producit in lucem umbram mortis."
,"23":"Qui multiplicat gentes et perdit eas,et subversas in integrum restituit."
,"24":"Qui immutat cor principum populi terrae et decipit eos,et errare eos faciet per invium desertum."
,"25":"Palpabunt quasi in tenebris et non in luce, et errare eos faciet quasi ebrios."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Ecce, omnia haec vidit oculus meus, et audivit auris mea, et intellexi singula."
,"2":"Secundum scientiam vestram, et ego novi; nec inferior vestri sum."
,"3":"Sed tamen ad Omnipotentem loquar,et disputare cum Deo cupio;"
,"4":"vos autem ostendam fabricatores mendacii, medicos vanos vos omnes."
,"5":"Atque utinam taceretis, ut sit vobis in sapientiam!"
,"6":"Audite ergo correptionem meam,et contentiones labiorum meorum attendite."
,"7":"Numquid pro Deo profertis mendacium,et pro illo loquimini dolos?"
,"8":"Numquid faciem eius accipitis,et pro Deo in iudicio contendere nitimini?"
,"9":"Aut bonum est quod vos excutiat?,Aut, ut illuditur homini, illudetis ei?"
,"10":"Ipse vos arguet, cum in abscondito faciem accipitis. "
,"11":"Nonne maiestas eius turbabit vos, et terror eius irruet super vos?"
,"12":"Sententiae vestrae sunt proverbia cineris; thoraces lutei thoraces vestri."
,"13":"Tacete paulisper, ut loquar ipse, et transeat super me quodcumque."
,"14":"Quare sumam carnes meas dentibus meis,et animam meam ponam in manibus meis?"
,"15":"Etiamsi occiderit me, in ipso sperabo; verumtamen vias meas in conspectu eius arguam."
,"16":"Et hoc erit salus mea: non enim veniet in conspectu eius omnis impius."
,"17":"Audite sermonem meum,et explicationem meam percipite auribus vestris."
,"18":"Ecce iudicium paravi; scio quod iustus inveniar."
,"19":"Quis est qui contendat mecum?,Tunc enim tacebo et consummabor."
,"20":"Duo tantum ne facias mihi, et tunc a facie tua non abscondar: "
,"21":"Manum tuam longe fac a me, et formido tua non me terreat."
,"22":"Voca me, et ego respondebo tibi; aut ipse loquar, et tu respondebis mihi."
,"23":"Quantas habeo iniquitates et peccata?,Scelera mea et delicta ostende mihi. "
,"24":"Cur faciem tuam abscondis,et arbitraris me inimicum tuum?"
,"25":"Contra folium, quod vento rapitur, dure agis,et stipulam siccam persequeris."
,"26":"Scribis enim contra me amaritudines,et occupatum me vis peccatis adulescentiae meae."
,"27":"Posuisti in nervo pedem meum,et observasti omnes semitas meas,et vestigia pedum meorum considerasti."
,"28":"Qui quasi uter consumendus sum, et quasi vestimentum, quod comeditur a tinea."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Homo natus de muliere, brevi vivens tempore, commotione satiatur."
,"2":"Qui quasi flos egreditur et arescit,et fugit velut umbra et non permanet."
,"3":"Et dignum ducis super huiuscemodi aperire oculos tuos,et adducere eum tecum in iudicium?"
,"4":"Quis potest facere mundum de immundo?,Ne unus quidem!"
,"5":"Si statuti dies hominis sunt, et numerus mensium eius apud te est, et constituti sunt termini eius, quos non praeteribit,"
,"6":"averte oculos tuos ab eo, ut quiescat, donec solvat, sicut mercennarius, dies suos."
,"7":"Nam lignum habet spem; si praecisum fuerit, rursum virescet, et rami eius non deficient."
,"8":"Si senuerit in terra radix eius, et in pulvere emortuus fuerit truncus illius,"
,"9":"ad odorem aquae germinabit,et faciet comam quasi novellae."
,"10":"Homo vero cum mortuus fuerit et debilitatur, exspirat homo et, ubi, quaeso, est?"
,"11":"Recedent aquae de mari, et fluvius vacuefactus arescet;"
,"12":"sic homo, cum dormierit, non resurget: donec atteratur caelum, non evigilabit,nec consurget de somno suo."
,"13":"Quis mihi hoc tribuat, ut in inferno seponas me,et abscondas me, donec pertranseat furor tuus, et constituas mihi tempus, in quo recorderis mei?"
,"14":"Putasne mortuus homo rursum vivat?,Cunctis diebus, quibus nunc milito, exspectarem, donec veniat immutatio mea."
,"15":"Vocares me, et ego responderem tibi; opus manuum tuarum requireres."
,"16":"Tu quidem nunc gressus meos dinumerares, sed parceres peccatis meis."
,"17":"Signares quasi in sacculo delicta mea, sed dealbares iniquitatem meam."
,"18":"Mons cadens decidit, et saxum transfertur de loco suo;"
,"19":"lapides excavant aquae, et alluvione terra inundatur: et spem hominis perdes."
,"20":"Praevales adversus eum, et in perpetuum transiet; immutas faciem eius et emittis eum."
,"21":"Sive nobiles fuerint filii eius, non novit; sive ignobiles, non intellegit."
,"22":"Attamen caro eius, dum vivet, dolet, et anima illius super semetipso luget '."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Respondens autem Eliphaz Themanites dixit:"
,"2":"' Numquid sapiens respondebit sapientia ventosa,et implebit vento urente stomachum suum?"
,"3":"Arguens verbis, quae nihil prosunt, et sententiis, quae nihil iuvant?"
,"4":"Tu autem pietatem dissolvis,et detrahis meditationi coram Deo. "
,"5":"Docet enim iniquitas tua os tuum, et assumis linguam callidorum."
,"6":"Condemnabit te os tuum et non ego, et labia tua respondebunt tibi."
,"7":"Numquid primus homo tu natus es,et ante colles formatus?"
,"8":"Numquid consilium Dei audisti,et tibi attrahis sapientiam?"
,"9":"Quid nosti, quod nos ignoremus?,Quid intellegis, quod nos nesciamus?"
,"10":"Et senes et antiqui sunt inter nos, multo vetustiores quam pater tuus. "
,"11":"Numquid parum tibi sunt consolationes Dei?,Et verbum lene tecum factum?"
,"12":"Quid te elevat cor tuum, et cur attonitos habes oculos?"
,"13":"Quid vertis contra Deum spiritum tuum,et profers de ore tuo huiuscemodi sermones?"
,"14":"Quid est homo, ut immaculatus sit, et ut iustus appareat natus de muliere?"
,"15":"Ecce, sanctis suis non fidit, et caeli non sunt mundi in conspectu eius;"
,"16":"quanto magis abominabilis et corruptus homo, qui bibit quasi aquam iniquitatem. "
,"17":"Ostendam tibi, audi me; quod vidi, narrabo tibi,"
,"18":"quod sapientes confitentur, et non celaverunt eos patres eorum: "
,"19":"quibus solis data est terra, et non transivit alienus per eos."
,"20":"Cunctis diebus suis impius cruciatur, et numerus annorum incertus est tyranno."
,"21":"Sonitus terroris semper in auribus illius, quasi, cum pax sit, vastator irruat in eum."
,"22":"Non credit quod reverti possit de tenebris, cum sit destinatus gladio."
,"23":"Cum se moverit ad quaerendum panem: 'Ubinam?', novit quod paratus sit in manu eius tenebrarum dies."
,"24":"Terrebit eum tribulatio et angustia, vallabit eum sicut regem, qui praeparatur ad proelium."
,"25":"Tetendit enim adversus Deum manum suam, et contra Omnipotentem roboratus est."
,"26":"Cucurrit adversus eum erecto collo, spisso scuto armatus."
,"27":"Operuit faciem eius crassitudo, et de lateribus eius arvina dependet."
,"28":"Habitavit in civitatibus desolatis,et in domibus desertis, quae in tumulos sunt redactae."
,"29":"Non ditabitur, nec perseverabit substantia eius; nec mittet in terra radicem suam."
,"30":"Non recedet de tenebris; ramos eius arefaciet flamma, et auferet ventus florem eius."
,"31":"Ne credat vanitati errore deceptus, quia vanitas erit remuneratio eius."
,"32":"Antequam dies eius impleantur, abscindentur, et ramus eius non virescet."
,"33":"Laedetur quasi vinea in primo flore botrus eius, et quasi oliva proiciens florem suum."
,"34":"Cangregatio enim impii sterilis, et ignis devorabit tabernacula eorum, qui munera libenter accipiunt."
,"35":"Concepit dolorem et peperit iniquitatem, et venter eius praeparat dolos."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Respondens autem Iob dixit:"
,"2":"' Audivi frequenter talia!,onsolatores molesti omnes vos estis."
,"3":"Numquid habebunt finem verba ventosa, aut quid te exacerbat, ut respondeas?"
,"4":"Poteram et ego similia vestri loqui, si esset anima vestra pro anima mea!,Concinnarem super vos sermones,et moverem caput meum super vos."
,"5":"Roborarem vos ore meo,et motum labiorum meorum non cohiberem."
,"6":"Si locutus fuero, non quiescet dolor meus,et, si tacuero, non recedet a me;"
,"7":"nunc autem defatigavit me dolor meus, et tu vastasti omnem coetum meum."
,"8":"Rugae meae testimonium dicunt contra me; et suscitatur falsiloquus adversus faciem meam contradicens mihi,"
,"9":"Ira eius discerpsit me et adversata est mihi, et infremuit contra me dentibus suis. Hostis meus acuit oculos suos in me."
,"10":"Aperuerunt super me ora sua,et exprobrantes percusserunt maxillam meam, simul conferti contra me."
,"11":"Concludit me Deus apud iniquum,et manibus impiorum me tradit."
,"12":"Ego, ille quondam tranquillus, repente contritus sum. Tenuit cervicem meam, confregit me,et posuit me sibi quasi in signum."
,"13":"Circumdedit me lanceis suis, scidit lumbos meos, non pepercit,et effudit in terra iecur meum."
,"14":"Dirupit me rumpens et diruens, irruit in me quasi gigas."
,"15":"Saccum consui super cutem meam,et dimisi in terram cornu meum."
,"16":"Facies mea rubuit a fletu, et palpebrae meae caligaverunt;"
,"17":"attamen absque iniquitate manus meae, cum haberem mundas preces."
,"18":"Terra, ne operias sanguinem meum, neque inveniat in te locum latendi clamor meus."
,"19":"Ecce enim in caelo testis meus, et conscius meus in excelsis."
,"20":"Interpretes mei sunt cogitationes meae: ad Deum stillat oculus meus."
,"21":"Atque utinam sic iudicaretur vir cum Deo, sicut iudicatur filius hominis cum collega suo."
,"22":"Ecce enim breves anni transeunt, et semitam, per quam non revertar, ambulo."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Spiritus meus attenuatus est, dies mei exstincti, et solum mihi superest sepulcrum."
,"2":"Nonne irrisiones circumdant me, et in amaritudinibus moratur oculus meus?"
,"3":"Pone pignus pro me iuxta te; et quis umquam spondens percutiet manum meam?"
,"4":"Cor eorum longe fecisti a disciplina; propterea non exaltabuntur."
,"5":"Praedam pollicetur sociis, sed oculi filiorum eius deficient."
,"6":"Posuit me quasi in proverbium vulgi,et conspuendum in faciem."
,"7":"Caligavit ab indignatione oculus meus, et membra mea quasi in umbram redacta sunt."
,"8":"Stupebunt iusti super hoc, et innocens contra impium excitabitur."
,"9":"Et tenebit iustus viam suam, et mundus manibus addet fortitudinem."
,"10":"Igitur omnes vos convertimini et venite, et non inveniam in vobis ullum sapientem."
,"11":"Dies mei transierunt, cogitationes meae dissipatae sunt,et desideria cordis mei."
,"12":"Noctem verterunt in diem; et rursum post tenebras properat lux."
,"13":"Si sustinuero, infernus domus mea est; et in tenebris stravi lectulum meum."
,"14":"Putredini dixi: Pater meus es!; Mater mea et soror mea! vermibus."
,"15":"Ubi est ergo nunc praestolatio mea, et patientiam meam quis considerat?"
,"16":"In profundissimum infernum descendent omnia mea; simul in pulvere erit requies mihi? '."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Respondens autem Baldad Suhites dixit:"
,"2":"' Usque ad quem finem verba iactabitis?,Intellegite prius, et sic loquamur."
,"3":"Quare reputati sumus ut iumenta,et sorduimus coram vobis?"
,"4":"Qui perdis animam tuam in furore tuo, numquid propter te derelinquetur terra, et transferentur rupes de loco suo?"
,"5":"Etenim lux impii exstinguetur, nec splendebit flamma ignis eius."
,"6":"Lux obtenebrescet in tabernaculo illius, et lucerna, quae super eum est, exstinguetur."
,"7":"Arctabuntur gressus virtutis eius, et praecipitabit eum consilium suum."
,"8":"Immissi sunt in rete pedes eius, et in reticulo ambulat."
,"9":"Tenet plantam illius laqueus, et firmatur super eum tendiculum."
,"10":"Abscondita est in terra pedica eius, et decipula illius super semitam."
,"11":"Undique terrent eum formidines,et involvunt pedes eius."
,"12":"Attenuatur fame robur eius, et pernicies parata costis illius."
,"13":"Devorat partes cutis eius, consumat membra illius primogenitus mortis."
,"14":"Avellitur de tabernaculo suo fiducia eius, et urges eum ad regem formidinum."
,"15":"Habitas in tabernaculo, quod iam non est ei; aspergitur in habitatione eius sulphur."
,"16":"Deorsum radices eius siccantur, sursum autem atteruntur rami eius."
,"17":"Memoria illius periit de terra, et non celebrabitur nomen eius in plateis."
,"18":"Expellent eum de luce in tenebras,et de orbe transferent eum."
,"19":"Non erit semen eius neque progenies in populo suo, nec ullae reliquiae in commoratione eius."
,"20":"In die eius stupebunt novissimi, et primos invadet horror."
,"21":"Haec sunt ergo tabernacula iniqui; et iste locus eius, qui ignorat Deum '."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Respondens autem Iob dixit:"
,"2":"' Usquequo affligitis ani mam meam,et atteritis me sermonibus?"
,"3":"En decies obiurgatis me,et non erubescitis opprimentes me."
,"4":"Nempe, etsi erravi, mecum erit error meus."
,"5":"Si vos contra me erigimini,et arguitis me opprobriis meis,"
,"6":"saltem nunc intellegite quia Deus non aequo iudicio afflixerit me,et rete suo me cinxerit."
,"7":"Etsi clamo: Vim patior!, non exaudior; si vociferor, non est qui iudicet."
,"8":"Semitam meam circumsaepsit, et transire non possum; et in calle meo tenebras posuit."
,"9":"Spoliavit me gloria mea,et abstulit coronam de capite meo."
,"10":"Destruxit me undique, et pereo, et evellit quasi arborem spem meam."
,"11":"Iratus est contra me furor eius, et sic me habuit quasi hostem suum."
,"12":"Simul venerunt turmae eius,et fecerunt sibi viam adversus me,et obsederunt in gyro tabernaculum meum."
,"13":"Fratres meos longe fecit a me, et noti mei quasi alieni recesserunt a me."
,"14":"Dereliquerunt me propinqui mei, et, qui me noverant, obliti sunt mei."
,"15":"Inquilini domus meae et ancillae meae sicut alienum habuerunt me, et quasi peregrinus fui in oculis eorum."
,"16":"Servum meum vocavi, et non respondit; ore proprio deprecabar illum."
,"17":"Halitum meum exhorruit uxor mea, et fetui filiis uteri mei."
,"18":"Vel infantes despiciebant me,et, cum surgerem, detrahebant mihi."
,"19":"Abominati sunt me quondam consiliarii mei; et, quem maxime diligebam, aversatus est me."
,"20":"Pelli meae, consumptis carnibus, adhaesit os meum, et evanuit cutis mea circa dentes meos."
,"21":"Miseremini mei, miseremini mei, saltem vos, amici mei, quia manus Domini tetigit me."
,"22":"Quare persequimini me sicut Deus,et carnibus meis non saturamini?"
,"23":"Quis mihi tribuat, ut scribantur sermones mei?,Quis mihi det, ut exarentur in libro"
,"24":"stilo ferreo et plumbeo, in aeternum sculpantur in silice?"
,"25":"Scio enim quod redemptor meus vivit,et in novissimo super pulvere stabit;"
,"26":"et post pellem meam hanc, quam abstraxerunt, et de carne mea videbo Deum."
,"27":"Quem visurus sum ego ipse, et oculi mei conspecturi sunt, et non alienum. Consumpti sunt renes mei in sinu meo."
,"28":"Si ergo nunc dicitis: 'Quomodo persequemur eum,et radicem verbi inveniemus contra eum?',"
,"29":"timete a facie gladii, quoniam ultor iniquitatum gladius est; et scitote esse iudicium '."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Respondens autem Sophar Naamathites dixit:"
,"2":"' Idcirco cogitationes meae reducunt me, eo quod intellectus effulsit in me."
,"3":"Doctrinam, qua me arguis, audiam, at spiritus intellegentiae meae respondebit mihi."
,"4":"Scisne hoc a principio, ex quo positus est homo super terram,"
,"5":"quod exsultatio iniquorum brevis sit, et gaudium impiorum ad instar puncti?"
,"6":"si ascenderit usque ad caelum superbia eius, et caput eius nubes tetigerit,"
,"7":"quasi sterquilinium in finem perdetur, et, qui eum viderant, dicent: 'Ubi est?'."
,"8":"Velut somnium avolans non invenietur, transiet sicut visio nocturna."
,"9":"Oculus, qui eum viderat, non videbit, neque ultra intuebitur eum locus suus."
,"10":"Filii eius satagent complacere pauperibus, et manus illius reddent ei possessionem suam."
,"11":"Ossa eius, quae implebantur adulescentia, cum eo in pulvere dormient."
,"12":"Cum enim dulce fuerit in ore eius malum, abscondet illud sub lingua sua."
,"13":"Parcet illi et non derelinquet illud,et celabit in gutture suo."
,"14":"Panis eius in visceribus illius,vertetur in fel aspidum intrinsecus."
,"15":"Divitias, quas devoravit, evomet, et de ventre illius extrahet eas Deus."
,"16":"Venenum aspidum sugebat, et occidet eum lingua viperae."
,"17":"Non videat rivulos olei, torrentes mellis et butyri."
,"18":"Restituet quaestum suum nec deglutiet, de opibus venditionum non laetabitur."
,"19":"Quoniam confringens deseruit pauperes, domum rapuit et non aedificavit eam."
,"20":"Nec est satiatus venter eius; et cum desideriis suis evadere non potuit."
,"21":"Non fuerunt reliquiae de cibo eius, et propterea nihil permanebit de bonis eius."
,"22":"Cum satiatus fuerit, arctabitur; et omnis dolor irruet super eum."
,"23":"Impleat ventrem suum: emittet Deus in eum iram furoris sui,et pluet super illum bellum suum."
,"24":"Fugiet arma ferrea,et irruet in arcum aereum."
,"25":"Sagitta transverberabit corpus eius, et fulgur iecur eius; vadent et venient super eum horribilia."
,"26":"Omnes tenebrae absconditae sunt in occultis eius, devorabit eum ignis, qui non succenditur; affligetur relictus in tabernaculo suo."
,"27":"Revelabunt caeli iniquitatem eius, et terra consurget adversus eum."
,"28":"Auferetur germen domus illius, detrahetur in die furoris Dei."
,"29":"Haec est pars hominis impii a Deo, et hereditas verborum eius a Domino '."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Respondens autem Iob dixit:"
,"2":"' Audite, quaeso, sermones,meos, et sint haec consolationes vestrae."
,"3":"Sustinete me, et ego loquar; et post verba mea ridebitis."
,"4":"Numquid contra hominem disputatio mea est, ut merito non debeam impatiens fieri?"
,"5":"Attendite me et obstupescite,et superponite digitum ori vestro."
,"6":"Et ego, quando recordatus fuero, pertimesco, et concutit carnem meam tremor."
,"7":"Quare ergo impii vivunt, senuerunt confortatique sunt divitiis?"
,"8":"Semen eorum permanet coram eis, et progenies eorum in conspectu eorum."
,"9":"Domus eorum securae sunt et pacatae, et non est virga Dei super illos."
,"10":"Bos eorum concepit et non abortivit, vacca peperit et non est privata fetu suo."
,"11":"Egrediuntur quasi greges parvuli eorum, et infantes eorum exsultant lusibus."
,"12":"Tenent tympanum et citharam,et gaudent ad sonitum organi."
,"13":"Ducunt in bonis dies suos,et in puncto ad inferna descendunt."
,"14":"Qui dixerant Deo: 'Recede a nobis!,Scientiam viarum tuarum nolumus."
,"15":"Quis est Omnipotens, ut serviamus ei, et quid nobis prodest, si oraverimus illum?'."
,"16":"Sint in manu eorum bona sua; consilium vero impiorum longe sit a me."
,"17":"Quam saepe lucerna impiorum exstinguitur, et superveniet eis pernicies, et dolores dividet in furore suo?"
,"18":"Erunt sicut paleae ante faciem venti, et sicut favilla, quam turbo dispergit."
,"19":"'Servabitne Deus filiis iniquitatem eius?'. Retribuat illi, ut sciat."
,"20":"Videbunt oculi eius interfectionem suam, et de furore Omnipotentis bibet."
,"21":"Quid enim ad eum pertinet de domo sua post se, et si numerus mensium eius recidetur?"
,"22":"Numquid Deum docebit quispiam scientiam, qui excelsos iudicat?"
,"23":"Iste moritur robustus et sanus, dives et felix;"
,"24":"viscera eius plena sunt adipe, et medullis ossa illius irrigantur."
,"25":"Alius vero moritur in amaritudine animae,absque ullis opibus;"
,"26":"et tamen simul in pulvere dormient, et vermes operient eos."
,"27":"Certe novi cogitationes vestras,et sententias contra me iniquas."
,"28":"Dicitis enim: 'Ubi est domus principis, et ubi tabernacula impiorum?'."
,"29":"Nonne interrogastis quemlibet de viatoribus,et signa eorum non agnovistis?"
,"30":"Quia in diem perditionis servatur malus,et ad diem furoris abducetur."
,"31":"Quis arguet coram eo viam eius, et, quae fecit, quis reddet illi?"
,"32":"Ipse ad sepulcra ducetur, et super tumulum vigilabunt."
,"33":"Dulces erunt ei glebae vallis, et post se omnem hominem trahet,et ante se innumerabiles."
,"34":"Quomodo igitur consolamini me frustra, et responsionis vestrae restat perfidia? '."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Respondens autem Eliphaz Themanites dixit:"
,"2":"' Numquid Deo prodesse potest homo, cum vix intellegens sibi ipse proderit?"
,"3":"Quid prodest Omnipotenti, si iustus fueris, aut quid ei confers, si immaculatam feceris viam tuam?"
,"4":"Numquid pro tua pietate arguet te,et veniet tecum in iudicium?"
,"5":"Et non propter malitiam tuam plurimam,et infinitas iniquitates tuas?"
,"6":"Sumpsisti enim pignori fratres tuos sine causa,et nudos spoliasti vestibus."
,"7":"Aquam lasso non dedisti,et esurienti cohibuisti panem."
,"8":"Numquid viro forti brachio erit terra, et acceptus sedebit in ea?"
,"9":"Viduas dimisisti vacuas,et lacertos pupillorum comminuisti. "
,"10":"Propterea circumdatus es laqueis, et conturbat te subita formido."
,"11":"Vel tenebras non vides, et impetus aquarum opprimit te."
,"12":"'Nonne Deus excelsior caelo?,Et inspice stellarum verticem: quam sublimis!'."
,"13":"Et dicis: 'Quid enim novit Deus,et quasi per caliginem iudicat?"
,"14":"Nubes latibulum eius, nec nostra considerat; et circa orbem caeli perambulat'."
,"15":"Numquid semitam saeculorum custodire cupis, quam calcaverunt viri iniqui?"
,"16":"Qui sublati ante tempus suum, et fluvius subvertit fundamentum eorum."
,"17":"Qui dicebant Deo: 'Recede a nobis!',et 'Quid faciet Omnipotens nobis?'."
,"18":"Cum ille implesset domos eorum bonis, quorum sententia procul erat ab eo."
,"19":"Videbunt iusti et laetabuntur, et innocens subsannabit eos:"
,"20":"'Vere succisus est status eorum, et reliquias eorum devoravit ignis'. "
,"21":"Acquiesce igitur ei, et habeto pacem; et per haec habebis fructus optimos."
,"22":"Suscipe ex ore illius legem,et pone sermones eius in corde tuo."
,"23":"Si reversus fueris ad Omnipotentem, aedificaberis,et longe facies iniquitatem a tabernaculo tuo."
,"24":"Comparabis tamquam terram aurum,et tamquam glaream torrentis Ophir."
,"25":"Eritque Omnipotens metallum tuum, et argentum coacervabitur tibi."
,"26":"Tunc super Omnipotentem deliciis afflues,et elevabis ad Deum faciem tuam. "
,"27":"Supplex rogabis eum, et exaudiet te, et vota tua reddes."
,"28":"Decernes rem, et veniet tibi, et in viis tuis splendebit lumen."
,"29":"Quia humiliat eum, qui loquitur superba, et demissus oculis ipse salvabitur."
,"30":"Eripiet innocentem, eripietur autem in munditia manuum suarum '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Respondens autem Iob ait:"
,"2":"' Nunc quoque in amaritu tudine est querela mea, et manus eius aggravata est super gemitum meum."
,"3":"Quis mihi tribuat, ut cognoscam et inveniam illum,et veniam usque ad solium eius?"
,"4":"Ponam coram eo iudicium,et os meum replebo increpationibus,"
,"5":"ut sciam verba, quae mihi respondeat, et intellegam quid loquatur mihi."
,"6":"Num multa fortitudine contendet mecum?,Non! Ipse tantum audiat!"
,"7":"Tunc iustus disceptabit cum illo, et ego evaderem in perpetuo a iudice meo."
,"8":"Si ad orientem iero, non apparet; si ad occidentem, non intellegam eum."
,"9":"Si ad sinistram pergam, non apprehendam eum; si me vertam ad dexteram, non videbo illum."
,"10":"Ipse vero scit viam meam, et, si probaverit me, quasi aurum egrediar."
,"11":"Vestigia eius secutus est pes meus, viam eius custodivi et non declinavi ex ea."
,"12":"A mandatis labiorum eius non recessi,et in sinu meo abscondi verba oris eius."
,"13":"Ipse enim solus est, et quis repellet eum?,Et anima eius, quodcumque voluit, hoc fecit."
,"14":"Cum expleverit in me voluntatem suam, et alia multa similia praesto sunt ei;"
,"15":"et idcirco a facie eius turbatus sum,et considerans eum timore sollicitor."
,"16":"Deus mollivit cor meum, et Omnipotens conturbavit me."
,"17":"Non enim perii propter imminentes tenebras, nec faciem meam operuit caligo."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Cur ab Omnipotente non sunt abscondita tempora, qui autem noverunt eum, ignorant dies illius?"
,"2":"Alii terminos transtulerunt, diripuerunt greges et paverunt eos."
,"3":"Asinum pupillorum abegerunt,et abstulerunt pro pignore bovem viduae."
,"4":"Subverterunt pauperum viam, et simul se occultare coacti sunt mansueti terrae."
,"5":"Alii, quasi onagri in deserto, egrediuntur ad opus suum: vigilantes ad praedam,in terra arida ad panem liberis."
,"6":"Agrum non suum demetunt,et vineam peccatoris vindemiant."
,"7":"Nudi pernoctant sine indumento, nec est eis operimentum in frigore."
,"8":"Imbre montium rigantur,et non habentes refugium adhaerent rupibus."
,"9":"Abripuerunt pupillum ab ubere,et pauperem pignori sumpserunt;"
,"10":"nudi et incedentes absque vestitu,et esurientes portant spicas."
,"11":"Inter muros oleum expresserunt,et calcatis torcularibus sitiunt."
,"12":"De civitatibus morientes ingemuerunt, et anima vulneratorum clamavit, et Deus non ponit aurem ad precem."
,"13":"Ipsi fuerunt rebelles lumini, nescierunt vias eius,nec morati sunt in semitis eius."
,"14":"Mane primo consurgit homicida, interficit egenum et pauperem; per noctem vero erit quasi fur."
,"15":"Oculus adulteri observat caliginem,dicens: 'Non me videbit oculus'; et operiet vultum suum."
,"16":"Perfodit in tenebris domos, interdiu sese abdiderunt,et ignoraverunt lucem."
,"17":"Si subito apparuerit aurora, arbitrantur umbram mortis, nam sunt assueti terroribus umbrae mortis."
,"18":"'Levis est super faciem aquae; maledicta est pars eius in terra, nec est qui se dirigat ad vineas eius."
,"19":"Siccitas et calor abstulerunt aquas nivium, et inferi eos, qui peccaverunt."
,"20":"Sinus matris obliviscatur eius, dulcedo illius vermes fiant; non sit in recordatione, sed conteratur quasi lignum iniquitas."
,"21":"Male egit cum sterili, quae non parit, et viduae bene non fecit."
,"22":"Detraxit fortes in fortitudine sua,et, cum steterit, ille non credet vitae suae."
,"23":"Dedit ei locum securitatis, quo sustentetur; oculi autem eius sunt in viis illius."
,"24":"Elevati sunt ad modicum et non subsistent, et humiliabuntur sicut omnia et auferentur,et sicut summitates spicarum conterentur'."
,"25":"Quod si non est ita, quis me potest arguere esse mentitum,et ponere in nihilum verba mea? '. "
}`)
	CurrentBook.AddChapter(25, `{
"1":"Respondens autem Baldad Suhites dixit:"
,"2":"' Potestas et terror apud eum est, qui facit pacem in sublimibus suis."
,"3":"Numquid est numerus militum eius?,Et super quem non surget lumen illius?"
,"4":"Numquid iustificari potest homo comparatus Deo, aut apparere mundus natus de muliere?"
,"5":"Ecce luna etiam non splendet, et stellae non sunt mundae in conspectu eius;"
,"6":"quanto magis homo putredo, et filius hominis vermis '."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Respondens autem Iob dixit:"
,"2":"' Quomodo adiuvisti imbecillem?,Et sustentas brachium eius, qui non est fortis?"
,"3":"Quod dedisti illi consilium, qui non habet sapientiam?,Et prudentiam tuam ostendisti plurimam!"
,"4":"Quem docere voluisti?,Et cuius est spiritus, qui egreditur ex te?"
,"5":"Ecce umbrae gemunt sub aquis, et qui habitant cum eis."
,"6":"Nudus est infernus coram illo, et nullum est operimentum Perditioni."
,"7":"Qui extendit aquilonem super vacuum,et appendit terram super nihilum."
,"8":"Qui ligat aquas in nubibus suis, ut non erumpant pariter deorsum."
,"9":"Qui operit faciem solii sui,expandens super illud nebulam suam."
,"10":"Terminum circumdedit aquis, usque dum finiantur lux et tenebrae."
,"11":"Columnae caeli contremiscunt,et pavent ab increpatione eius."
,"12":"In fortitudine sua terruit mare,et prudentia sua percussit Rahab."
,"13":"Spiritus eius serenavit caelos, et manus eius confodit colubrum fugientem."
,"14":"Ecce haec sunt termini viarum eius; et, cum vix parvam stillam sermonis eius audierimus, quis poterit tonitruum magnitudinis illius intueri? '."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Addidit quoque Iob assu mens parabolam suam et dixit:"
,"2":"' Vivit Deus, qui abstulit ius meum, et Omnipotens, qui ad amaritudinem adduxit animam meam,"
,"3":"quia, donec superest halitus in me, et spiritus Dei in naribus meis,"
,"4":"non loquentur labia mea iniquitatem, nec lingua mea meditabitur mendacium!"
,"5":"Absit a me, ut iustos vos esse iudicem; donec exspirem, non recedam ab innocentia mea."
,"6":"Iustificationem meam, quam coepi tenere, non deseram, neque enim reprehendit me cor meum in omni vita mea."
,"7":"Sit ut impius inimicus meus, et adversarius meus quasi iniquus."
,"8":"Quae est enim spes impii, cum secet, cum rapiat Deus animam eius?"
,"9":"Numquid Deus audiet clamorem eius, cum venerit super eum angustia?"
,"10":"Aut poterit in Omnipotente delectari,et invocare Deum omni tempore?"
,"11":"Docebo vos manum Dei, quae Omnipotens habeat, nec abscondam."
,"12":"Ecce vos omnes observastis, et quid sine causa vana loquimini?"
,"13":"Haec est pars hominis impii apud Deum, et hereditas violentorum, quam ab Omnipotente suscipient."
,"14":"Si multiplicati fuerint filii eius, in gladio erunt, et nepotes eius non saturabuntur pane."
,"15":"Qui reliqui fuerint ex eo, sepelientur in interitu, et viduae illius non plorabunt."
,"16":"Si comportaverit quasi terram argentum,et sicut lutum praeparaverit vestimenta,"
,"17":"praeparabit quidem, sed iustus vestietur illis, et argentum innocens dividet."
,"18":"Aedificavit sicut aranea domum suam, et sicut custos fecit umbraculum."
,"19":"Dives, cum dormierit, nihil secum auferet; aperiet oculos suos et nihil inveniet. "
,"20":"Apprehendet eum quasi aqua inopia, nocte opprimet eum tempestas."
,"21":"Tollet eum ventus urens et auferet, et velut turbo rapiet eum de loco suo."
,"22":"Et mittet super eum et non parcet; de manu eius fugiens fugiet."
,"23":"Complodet super eum manus suas,et sibilabit eum de loco suo."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Habet argentum venarum principia,et auro locus est, in quo conflatur."
,"2":"Ferrum de terra tollitur, et lapis solutus calore in aes vertitur."
,"3":"Terminum posuit tenebris,et universorum finem ipse scrutatur, lapidem quoque caliginis et umbrae."
,"4":"Aperuit cuniculos gens peregrina, ipsique obliti sunt pedes, penduli haerent plus quam vir nutans."
,"5":"Terra, de qua oriebatur panis, in profundo subversa est sicut per ignem."
,"6":"Locus sapphiri lapides eius, et glebae illius aurum."
,"7":"Semitam ignoravit avis rapax, nec intuitus est eam oculus vulturis."
,"8":"Non calcaverunt eam filii superbiae, nec pertransivit per eam leaena."
,"9":"Ad silicem extendit manum suam, subvertit a radicibus montes."
,"10":"In petris canales excidit, et omne pretiosum vidit oculus eius."
,"11":"Profunda quoque fluviorum scrutatus est,et abscondita in lucem produxit."
,"12":"Sapientia vero ubi invenitur?,Et quis est locus intellegentiae?"
,"13":"Nescit homo structuram eius, nec invenitur in terra viventium."
,"14":"Abyssus dicit: 'Non est in me'; et mare loquitur: 'Non est mecum'."
,"15":"Non dabitur aurum obryzum pro ea, nec appendetur argentum in commutatione eius."
,"16":"Non appendetur auro Ophir,nec lapidi sardonycho pretiosissimo vel sapphiro."
,"17":"Non adaequabitur ei aurum vel vitrum, nec commutabuntur pro ea vasa auri."
,"18":"Corallia et crystallum non memorabuntur comparatione eius; et possessio sapientiae potior margaritis."
,"19":"Non adaequabitur ei topazius de Aethiopia,nec auro mundissimo componetur."
,"20":"Unde ergo sapientia venit, et quis est locus intellegentiae?"
,"21":"Abscondita est ab oculis omnium viventium, volucres quoque caeli latet."
,"22":"Perditio et mors dixerunt: 'Auribus nostris audivimus famam eius'."
,"23":"Deus intellegit viam eius, et ipse novit locum illius."
,"24":"Ipse enim fines mundi intuetur,et omnia, quae sub caelo sunt, respicit."
,"25":"Qui fecit ventis pondus,et aquas appendit in mensura,"
,"26":"quando ponebat pluviis legem,et viam procellis sonantibus,"
,"27":"tunc vidit illam et enarravit,et praeparavit et investigavit."
,"28":"Et dixit homini: 'Ecce timor Domini, ipsa est sapientia; et recedere a malo intellegentia' '."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Addidit quoque Iob assumens parabolam suam et di xit:"
,"2":"' Quis mihi tribuat, ut sim iuxta menses pristinos, secundum dies, quibus Deus custodiebat me?"
,"3":"Quando splendebat lucerna eius super caput meum, et ad lumen eius ambulabam in tenebris."
,"4":"Sicut fui in diebus adulescentiae meae, quando familiaris Deus erat in tabernaculo meo,"
,"5":"quando erat Omnipotens mecum, et in circuitu meo pueri mei,"
,"6":"quando lavabam pedes meos lacte, et petra fundebat mihi rivos olei."
,"7":"Quando procedebam ad portam civitatis,et in platea parabam cathedram mihi,"
,"8":"videbant me iuvenes et abscondebantur, et senes assurgentes stabant."
,"9":"Principes cessabant loqui,et digitum superponebant ori suo."
,"10":"Vocem suam cohibebant duces, et lingua eorum palato suo adhaerebat."
,"11":"Auris audiens beatificabat me, et oculus videns testimonium reddebat mihi,"
,"12":"eo quod liberassem pauperem vociferantem,et pupillum, cui non esset adiutor."
,"13":"Benedictio perituri super me veniebat, et cor viduae iubilare feci."
,"14":"Iustitia indutus sum et vestivi me, sicut vestimento et diademate, iudicio meo."
,"15":"Oculus fui caeco,et pes claudo;"
,"16":"pater eram pauperum,et causam viri ignoti diligentissime investigabam."
,"17":"Conterebam molas iniqui,et de dentibus illius auferebam praedam."
,"18":"Dicebamque: In nidulo meo moriar,et sicut palma multiplicabo dies."
,"19":"Radix mea aperta est secus aquas, et ros morabitur in ramis meis."
,"20":"Gloria mea semper innovabitur, et arcus meus in manu mea instaurabitur."
,"21":"Qui me audiebant, blandiebantur,et intenti tacebant ad consilium meum."
,"22":"Verbis meis addere nihil audebant, et super illos stillabat eloquium meum."
,"23":"Exspectabant me sicut pluviam,et os suum aperiebant quasi ad imbrem serotinum."
,"24":"Si quando ridebam ad eos, non credebant, et lux vultus mei non cadebat in terram."
,"25":"Si voluissem ire ad eos, sedebam primus; cumque sederem quasi rex, circumstante exercitu, eram tamen maerentium consolator."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Nunc autem derident me,iuniores tempore, quorum non dignabar patres,ponere cum canibus gregis mei;"
,"2":"quorum virtus manuum mihi erat pro nihilo, et robur iuvenile perierat totum."
,"3":"Egestate et fame steriles, qui rodebant in solitudine, serotino tempore fiebant turbo et vastatio;"
,"4":"et mandebant herbas et arborum frutices, et radix iuniperorum erat cibus eorum."
,"5":"De medio eiciebantur, clamabant contra eos tamquam fures;"
,"6":"ad ripas habitabant torrentium,et in cavernis terrae et petrarum;"
,"7":"inter frutices rudebant, sub sentibus se congerebant;"
,"8":"filii stultorum et ignobilium,et de terra penitus exturbati."
,"9":"Nunc in eorum canticum versus sum,et factus sum eis in proverbium."
,"10":"Abominantur me et longe fugiunt a me,et faciem meam conspuere non verentur."
,"11":"Pharetram enim suam aperuit et afflixit me,et frenum in os meum immisit."
,"12":"Ad dexteram progenies surrexerunt; pedes meos subverterunt,et complanaverunt contra me semitas ruinae."
,"13":"Dissipaverunt itinera mea, insidiati sunt mihi et praevaluerunt, et non fuit qui ferret auxilium."
,"14":"Quasi rupto muro et aperto irruerunt super me,et sub ruinis devoluti sunt."
,"15":"Versi sunt contra me in terrores, persequitur quasi ventus principatum meum, et velut nubes pertransiit salus mea."
,"16":"Nunc autem in memetipso effunditur anima mea; et possident me dies afflictionis."
,"17":"Nocte os meum perforatur doloribus; et, qui me comedunt, non dormiunt."
,"18":"In multitudine roboris tenent vestimentum meum,et quasi capitio tunicae succinxerunt me."
,"19":"Proiecit me in lutum, et assimilatus sum favillae et cineri."
,"20":"Clamo ad te, et non exaudis me; sto, et non respicis me."
,"21":"Mutatus es mihi in crudelem,et in duritia manus tuae adversaris mihi."
,"22":"Elevasti me,et quasi super ventum ponens dissolvisti me."
,"23":"Scio quia morti trades me, ubi constituta est domus omni viventi."
,"24":"Verumtamen non ad ruinam mittit manum; et in exitio eius erit salvatio."
,"25":"An non flebam quondam super eo, qui afflictus erat, et compatiebatur anima mea pauperi?"
,"26":"Exspectabam bona, et venerunt mihi mala; praestolabar lucem, et eruperunt tenebrae."
,"27":"Interiora mea efferbuerunt absque ulla requie; praevenerunt me dies afflictionis."
,"28":"Taetro vultu incedebam sine consolatione, consurgens in turba clamabam."
,"29":"Frater fui draconum,et socius struthionum."
,"30":"Cutis mea denigrata est super me, et ossa mea aruerunt prae caumate."
,"31":"Versa est in luctum cithara mea, et organum meum in vocem flentium."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Pepigi foedus cum oculis meis,ut ne cogitarem quidem de virgine."
,"2":"Quae enim pars mea apud Deum desuper, et quae hereditas apud Omnipotentem in excelsis?"
,"3":"Numquid non perditio est iniquo, et alienatio operantibus iniustitiam?"
,"4":"Nonne ipse considerat vias meas,et cunctos gressus meos dinumerat?"
,"5":"Si ambulavi in vanitate, et festinavit in dolo pes meus,"
,"6":"appendat me in statera iusta,et sciat Deus integritatem meam."
,"7":"Si declinavit gressus meus de via, et si secutum est oculos meos cor meum, et si manibus meis adhaesit macula,"
,"8":"seram, et alius comedat, et progenies mea eradicetur."
,"9":"Si deceptum est cor meum super muliere, et si ad ostium amici mei insidiatus sum,"
,"10":"molat pro alio uxor mea, et super illam incurventur alii."
,"11":"Hoc enim nefas est,et iniquitas iudicialis;"
,"12":"ignis est usque ad perditionem devorans,et omnia eradicans genimina."
,"13":"Si contempsi subire iudicium cum servo meo et ancilla mea, cum disceptarent adversum me,"
,"14":"quid enim faciam, cum surrexerit ad iudicandum Deus; et, cum quaesierit, quid respondebo illi?"
,"15":"Numquid non in ventre fecit me, qui et illum operatus est, et formavit me in visceribus unus?"
,"16":"Si negavi, quod volebant, pauperibus,et oculos viduae languescere feci;"
,"17":"si comedi buccellam meam solus, et non comedit pupillus ex ea,"
,"18":"quia ab infantia mea educavi eum ut pater,et de ventre matris meae direxi eam;"
,"19":"si despexi pereuntem, eo quod non habuerit indumentum, et absque operimento pauperem;"
,"20":"si non benedixerunt mihi latera eius, et de velleribus ovium mearum calefactus est;"
,"21":"si levavi super pupillum manum meam, cum viderem in porta adiutorium mihi,"
,"22":"umerus meus a iunctura sua cadat, et brachium meum cum ossibus lacertorum confringatur,"
,"23":"quia timor super me calamitas a Deo, et contra maiestatem eius nihil valerem!"
,"24":"Si putavi aurum securitatem meam,et obryzo dixi: Fiducia mea!;"
,"25":"si laetatus sum super multis divitiis meis, et quia plurima repperit manus mea;"
,"26":"si vidi solem, cum fulgeret, et lunam incedentem clare,"
,"27":"et decepit me in abscondito cor meum, et osculatus sum manum meam ore meo,"
,"28":"quae est iniquitas iudicialis, eo quod negassem Deum desuper;"
,"29":"si gavisus sum ad ruinam eius, qui me oderat, et exsultavi quod invenisset eum malum,"
,"30":"cum non dederim ad peccandum guttur meum, ut expeterem maledicens animam eius;"
,"31":"si non dixerunt viri tabernaculi mei: 'Quis det, qui de carnibus eius non saturatus sit?';"
,"32":"foris non mansit peregrinus, ostium meum viatori patuit;"
,"33":"si abscondi quasi homo peccatum meum,et celavi in sinu meo iniquitatem meam;"
,"34":"si expavi ad multitudinem nimiam, et despectio propinquorum terruit me, et magis tacui nec egressus sum ostium."
,"35":"Quis mihi tribuat auditorem?,Ecce signum meum! Omnipotens respondeat mihi!,Ecce liber, quem scripsit vir litis meae,"
,"36":"ut in umero meo portem illum,et alligem illum quasi coronam mihi."
,"37":"Numerum graduum meorum pronuntiabo illi,et quasi principem adibo eum."
,"38":"Si adversum me terra mea clamat, et cum ipsa sulci eius deflent;"
,"39":"si fructus eius comedi absque pecunia,et animam agricolarum eius afflixi,"
,"40":"pro frumento oriatur mihi tribulus, et pro hordeo herba foetida! '. Finita sunt verba Iob."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Omiserunt autem tres viri isti respondere Iob, eo quod iustus sibi videretur."
,"2":"Et iratus indignatusque est Eliu filius Barachel Buzites de cognatione Ram; iratus est autem adversum Iob, eo quod iustum se esse diceret coram Deo."
,"3":"Porro adversum amicos eius indignatus est, eo quod non invenissent responsionem, sed tantummodo condemnassent Iob."
,"4":"Igitur Eliu exspectavit Iob loquentem, eo quod seniores essent, qui loquebantur;"
,"5":"cum autem vidisset Eliu quod tres respondere non potuissent, iratus est vehementer."
,"6":"Respondensque Eliu filius Barachel Buzites dixit: ' Iunior sum tempore, vos autem antiquiores; idcirco veritus sum et timui,vobis indicare meam sententiam."
,"7":"Dixi: Aetas loquetur, et annorum multitudo docebit sapientiam."
,"8":"Sed, ut video, spiritus est in hominibus, et inspiratio Omnipotentis dat intellegentiam."
,"9":"Non sunt longaevi sapientes, nec senes intellegunt iudicium."
,"10":"Ideo dicam: Audite me, ostendam vobis etiam ego meam sapientiam."
,"11":"Exspectavi enim sermones vestros, intendi aurem in prudentiam vestram, donec investigaretis,"
,"12":"et ut vos intellegerem nitebar. Sed, ut video, non est qui possit arguere Iob,et respondere ex vobis sermonibus eius."
,"13":"Ne forte dicatis: 'Invenimus sapientiam; Deus proiecit eum, non homo'."
,"14":"Non parabo mihi verba, et ego non secundum sermones vestros respondebo illi."
,"15":"Extimuerunt nec responderunt ultra; abstuleruntque a se eloquia."
,"16":"Quoniam igitur exspectavi, et non sunt locuti, steterunt, nec ultra responderunt,"
,"17":"respondebo et ego partem meam,et ostendam scientiam meam."
,"18":"Plenus sum enim sermonibus, et coarctat me spiritus pectoris mei;"
,"19":"en venter meus quasi mustum absque spiraculo, quod lagunculas novas disrumpit."
,"20":"Loquar et respirabo paululum, aperiam labia mea et respondebo."
,"21":"Non accipiam personam viri,et nulli homini blandiar."
,"22":"Nescio enim blandiri, quia in brevi tolleret me Factor meus."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Audi igitur, Iob, eloquia mea,et omnes sermones meos ausculta."
,"2":"Ecce aperui os meum, loquatur lingua mea in faucibus meis."
,"3":"Ex recto corde sermones mei sunt, et sententiam puram labia mea loquentur."
,"4":"Spiritus Dei fecit me, et spiraculum Omnipotentis vivificavit me."
,"5":"Si potes, responde mihi, praepara te coram me et consiste."
,"6":"Ecce ego sicut tu coram Deo sum,et de eodem luto abscissus sum et ego."
,"7":"Verumtamen terror meus non te terreat, et onus meum non sit tibi grave."
,"8":"Dixisti ergo in auribus meis, et vocem verborum tuorum audivi:"
,"9":"'Mundus sum ego et absque delicto; immaculatus, et non est iniquitas in me."
,"10":"Quia querelas in me repperit, ideo arbitratus est me inimicum sibi;"
,"11":"posuit in nervo pedes meos, custodivit omnes semitas meas'."
,"12":"Hoc est ergo, in quo non es iustificatus, respondebo tibi, quia maior est Deus homine."
,"13":"Quare adversus eum contendis, quod non ad omnia verba responderit tibi?"
,"14":"Semel loquitur Deus, et secundo idipsum non repetit."
,"15":"Per somnium in visione nocturna, quando irruit sopor super homines, et dormiunt in lectulo,"
,"16":"tunc aperit aures virorum,et in visionibus terret eos,"
,"17":"ut avertat hominem ab his, quae facit, et liberet eum de superbia,"
,"18":"eruens animam eius a fovea,et vitam illius, ut non transeat canalem mortis."
,"19":"Increpat quoque per dolorem in lectulo, et tremitus ossium eius continuus."
,"20":"Abominabilis ei fit in vita sua panis, et animae illius cibus ante desiderabilis."
,"21":"Tabescet caro eius in conspectu, et ossa, quae non videbantur, nudabuntur."
,"22":"Appropinquavit corruptioni foveae, et vita illius mortiferis sedibus."
,"23":"Si fuerit apud eum angelus, unus de milibus interpres, ut annuntiet homini aequitatem,"
,"24":"miserebitur eius et dicet: 'Libera eum, ut non descendat in foveam; inveni, in quo ei propitier'."
,"25":"Revirescet caro eius plus quam in iuventute, revertetur ad dies adulescentiae suae."
,"26":"Deprecabitur Deum, et placabilis ei erit; et videbit faciem eius in iubilo, et reddet homini iustitiam suam."
,"27":"Canit ad homines et dicit: 'Peccavi et iustitiam perverti,et non debui satisfacere."
,"28":"Liberavit animam suam, ne pergeret in foveam, sed vivens lucem videret'."
,"29":"Ecce haec omnia operatur Deus,duobus, tribus vicibus cum homine,"
,"30":"ut revocet animas eorum a fovea,et illuminet luce viventium."
,"31":"Attende, Iob, et audi me,et tace, dum ego loquor."
,"32":"Si autem habes quod loquaris, responde mihi; loquere, volo enim te apparere iustum."
,"33":"Quod si non habes, audi me; tace, et docebo te sapientiam '."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Pronuntians itaque Eliu etiam haec locutus est:"
,"2":"' Audite, sapientes, verba mea; et eruditi, auscultate me."
,"3":"Auris enim verba probat, et guttur escas gustu diiudicat."
,"4":"Iudicium eligamus nobis,et inter nos videamus quid sit melius."
,"5":"Quia dixit Iob: 'Iustus sum, et Deus avertit iudicium meum;"
,"6":"in iudicando enim me mendacium est, violenta sagitta mea absque ullo peccato'."
,"7":"Quis est vir, ut est Iob, qui bibit subsannationem quasi aquam,"
,"8":"qui graditur una cum operantibus iniquitatem,et ambulat cum viris impiis?"
,"9":"Dixit enim: 'Non prodest viro, etiamsi cum Deo familiariter agit'."
,"10":"Ideo, viri cordati, audite me: Absit a Deo impietas, et ab Omnipotente iniquitas."
,"11":"Opus enim hominis reddet ei,et iuxta vias singulorum restituet eis."
,"12":"Vere enim Deus non operatur malum, nec Omnipotens subvertet iudicium."
,"13":"Quis commisit ei terram suam, aut quis posuit totum orbem?"
,"14":"Si direxerit ad se cor suum, spiritum illius et halitum ad se trahat,"
,"15":"deficiet omnis caro simul, et homo in cinerem revertetur."
,"16":"Si habes ergo intellectum, audi hoc,et ausculta vocem eloquii mei:"
,"17":"Numquid, qui non amat iudicium, reget imperio?,Num iustum magnum condemnabis,"
,"18":"qui dicet regi: 'Nequam!', qui vocabit duces: 'Impios!',"
,"19":"qui non accipit personas principum,nec cognovit opulentum, cum disceptaret contra pauperem?,Opus enim manuum eius sunt universi."
,"20":"Subito morientur; et in media nocte,turbabuntur populi et pertransibunt, et auferent violentum absque conatu."
,"21":"Oculi enim eius super vias hominum, et omnes gressus eorum considerat."
,"22":"Non sunt tenebrae, et non est umbra mortis, ut abscondantur ibi, qui operantur iniquitatem."
,"23":"Nec enim ultra homini ponit conveniendi locum, ut veniat ad Deum in iudicium."
,"24":"Conteret potentes sine inquisitione,et stare faciet alios pro eis."
,"25":"Novit enim opera eorum,et idcirco inducet noctem, et conterentur."
,"26":"Quasi impios percussit eos,in loco videntium,"
,"27":"qui quasi de industria recesserunt ab eo,et omnes vias eius intellegere noluerunt,"
,"28":"cum induceret ad se clamorem egeni et audiret vocem pauperum."
,"29":"Ipse enim si quieverit, quis est qui condemnet?,Et si absconderit vultum, quis est qui contempletur eum, super gentem et super homines simul?"
,"30":"Ne regnet homo impius, ne sint laquei populo."
,"31":"Si enim dixit quispiam Deo: 'Ferre debui! Iam non perverse agam."
,"32":"Dum videam, tu doce me; si iniquitatem operatus sum, ultra non addam'."
,"33":"Numquid pro te Deus satisfaciet, quia respuisti?,Tu enim eliges, et non ego; et si quid nosti melius, loquere."
,"34":"Viri intellegentes loquentur mihi, et vir sapiens, qui audiet me:"
,"35":"'Iob autem non in sapientia locutus est, et verba illius non sonant disciplinam'."
,"36":"Utique, probetur Iob usque ad finem,de responsionibus hominum iniquitatis."
,"37":"Quia addit super peccata sua delictum, inter nos plaudit manibus,et multiplicat sermones suos contra Deum '."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Igitur Eliu haec rursum locutus est:"
,"2":"' Numquid aequa tibi videtur tua cogitatio, ut diceres: 'Iustificatio mea coram Deo'?"
,"3":"Dixisti enim: 'Quid ad te?,Vel quid tibi proderit, si ego peccavero?'."
,"4":"Itaque ego respondebo sermonibus tuis,et amicis tuis tecum."
,"5":"Suspice caelum et intuere,et contemplare nubes quod altiores te sint."
,"6":"Si peccaveris, quid facies ei?,Et si multiplicatae fuerint iniquitates tuae, quid facies contra eum?"
,"7":"Porro si iuste egeris, quid donabis ei?,Aut quid de manu tua accipiet?"
,"8":"Homini, qui similis tui est, nocebit impietas tua, et filium hominis adiuvabit iustitia tua."
,"9":"Propter multitudinem oppressorum clamabunt,et eiulabunt propter vim brachii tyrannorum,"
,"10":"sed nemo dixit: 'Ubi est Deus, qui fecit me, qui dedit carmina in nocte,"
,"11":"qui docet nos super iumenta terrae,et super volucres caeli erudit nos?'."
,"12":"Ibi clamabunt, et non exaudiet, propter superbiam malorum."
,"13":"Etiam, frustra: non audiet Deus, et Omnipotens non intuebitur."
,"14":"Omnino cum dixeris: 'Non considerat', iudicium est coram illo, et exspectas eum."
,"15":"Et nunc cum dicis: 'Ira eius poenas non infert, nec ulciscitur scelus valde',"
,"16":"Iob frustra aperit os suum,et absque scientia verba multiplicat '."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Addens quoque Eliu haec locutus est:"
,"2":"' Sustine me paululum, et indicabo tibi: adhuc enim habeo quod pro Deo loquar."
,"3":"Repetam scientiam meam a longe,et Factori meo tribuam iustitiam."
,"4":"Vere enim absque mendacio sermones mei, et perfectus scientia adest tecum."
,"5":"Deus potens est; non abicit, potens virtute cordis."
,"6":"Non vivere faciet impium, sed iudicium pauperibus tribuit."
,"7":"Non auferet a iusto oculos suos,et reges in solio collocat in perpetuum, et illi eriguntur."
,"8":"Et si fuerint vincti compedibus,et vinciantur funibus paupertatis,"
,"9":"indicabit eis opera eorum,et scelera eorum, quia violenti fuerunt."
,"10":"Revelabit quoque aurem eorum, ut corripiat, et loquetur, ut revertantur ab iniquitate."
,"11":"Si audierint et observaverint, complebunt dies suos in bono,et annos suos in deliciis."
,"12":"Si autem non audierint, transibunt per canalem mortis,et consumentur in stultitia."
,"13":"Impii corde sibi reponent iram Dei,neque clamabunt, cum vincti fuerint."
,"14":"Morietur in iuventute anima eorum, et vita eorum in adulescentia."
,"15":"Eripiet de angustia sua pauperem,et revelabit in tribulatione aurem eius."
,"16":"Igitur salvabit te de ore angusto, amplitudo et non angustiae erunt sub te; requies autem mensae tuae erit plena pinguedine."
,"17":"Causa tua quasi impii iudicata est, causam iudiciumque tenebunt."
,"18":"Cave, ne te seducat abundantia, nec multitudo donorum inclinet te."
,"19":"Nonne proferetur clamor tuus nisi in angustia?,Et omnes conatus roboris?"
,"20":"Ne inhies nocti, ut ascendat turba pro eis."
,"21":"Cave, ne declines ad iniquitatem; propter hoc enim expertus es miseriam."
,"22":"Ecce, Deus excelsus in fortitudine sua. Quis ei similis doctor?"
,"23":"Quis poterit scrutari vias eius, aut quis potest ei dicere: 'Operatus es iniquitatem'?"
,"24":"Memento, ut magnifices opus eius, de quo cecinerunt viri."
,"25":"Omnes homines vident eum, unusquisque intuetur procul."
,"26":"Ecce, Deus magnus vincens scientiam nostram; numerus annorum eius inaestimabilis."
,"27":"Qui aufert stillas pluviae,et effundit imbres ad instar fluminis,"
,"28":"quos nubes effundunt, stillantes super homines multos."
,"29":"Profecto quis intellegit dilatationem nubium, strepitum tabernaculi eius?"
,"30":"Ecce extendit circum se lumen suum,et fundamenta maris texit."
,"31":"Per haec enim iudicat populos,et dat escas copiose."
,"32":"In manibus abscondit lucem,et praecipit ei, ut percutiat."
,"33":"Fragor eius de eo annuntiat, zelans ira contra iniquitatem."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Super hoc expavit cor meum,et emotum est de loco suo."
,"2":"Audite fremitum vocis eius,et murmur de ore illius procedens."
,"3":"Subter omnes caelos ipsum revolvit, et lumen illius super terminos terrae."
,"4":"Post eum rugiet sonitus, tonabit voce magnitudinis suae; et non retardabit, cum audita fuerit vox eius."
,"5":"Tonabit Deus in voce sua mirabiliter, qui facit magna et inscrutabilia."
,"6":"Qui praecipit nivi, ut descendat in terram, et hiemis pluviis et imbri, ut roborentur."
,"7":"Qui in manu omnium hominum signat, ut noverint singuli opera sua."
,"8":"Ingredietur bestia latibulum,et in antro suo morabitur."
,"9":"Ab interioribus egredietur tempestas, et ab Arcturo frigus."
,"10":"Flante Deo, datur gelu, et expansio aquarum solidatur."
,"11":"Fulgur proicitur a nube, et nubes spargunt lumen suum;"
,"12":"quae lustrant per circuitum, quocumque eas voluntas gubernantis duxerit, ad omne, quod praeceperit illis super faciem orbis terrarum,"
,"13":"sive in castigatione terrae suae, sive in misericordia eas iusserit inveniri."
,"14":"Ausculta haec, Iob; sta et considera mirabilia Dei."
,"15":"Numquid scis quando praeceperit Deus, ut ostenderent lucem nubes eius?"
,"16":"Numquid nosti semitas nubium magnas,et mirabilia perfecti scientia?"
,"17":"Nonne vestimenta tua calida sunt, cum quieverit terra austro?"
,"18":"Tu forsitan cum eo expandisti caelos, qui solidissimi, quasi aere, fusi sunt?"
,"19":"Ostende nobis quid dicamus illi; nos disponere verba nescimus propter tenebras."
,"20":"Quis narrabit ei, quae loquor?,Et, si locutus fuerit, homo deglutietur."
,"21":"At nunc non vident lucem: aer offuscatus est nubibus, sed ventus transiens fugabit eas."
,"22":"Ab aquilone splendor auri venit; et circa Deum terribilis maiestas."
,"23":"Omnipotentem attingere non possumus: magnus fortitudine; et iudicium et multam iustitiam deprimere non potest."
,"24":"Ideo timebunt eum homines, non contemplabitur omnes, qui sibi videntur corde sapientes '."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Respondens autem Dominus Iob de turbine dixit:"
,"2":"' Quis est iste obscurans consilium,sermonibus imperitis?"
,"3":"Accinge sicut vir lumbos tuos; interrogabo te, et edoce me."
,"4":"Ubi eras, quando ponebam fundamenta terrae?,Indica mihi, si habes intellegentiam."
,"5":"Quis posuit mensuras eius, si nosti?,Vel quis tetendit super eam lineam?"
,"6":"Super quo bases illius solidatae sunt?,Aut quis demisit lapidem angularem eius,"
,"7":"cum clamarent simul astra matutina, et iubilarent omnes filii Dei?"
,"8":"Quis conclusit ostiis mare, quando erumpebat quasi de visceribus procedens,"
,"9":"cum ponerem nubem vestimentum eius,et caligine illud quasi fascia obvolverem?"
,"10":"Definivi illud terminis meis,et posui vectem et ostia"
,"11":"et dixi: Usque huc venies et non procedes amplius,et hic confringes tumentes fluctus tuos."
,"12":"Numquid in diebus tuis praecepisti diluculo,et assignasti aurorae locum suum,"
,"13":"et, cum extrema terrae teneres, excussi sunt impii ex ea?"
,"14":"Vertetur in lutum signatum,et stabit sicut vestimentum."
,"15":"Cohibetur ab impiis lux sua, et brachium excelsum confringetur. "
,"16":"Numquid ingressus es scaturigines maris,et in novissimis abyssi deambulasti?"
,"17":"Numquid apertae sunt tibi portae mortis, et ostia tenebrosa vidisti?"
,"18":"Numquid considerasti latitudinem terrae?,Indica mihi, si nosti omnia:"
,"19":"In qua via lux habitet, et tenebrarum quis locus sit;"
,"20":"ut ducas unumquodque ad terminos suos,et intellegas semitas domus eius?"
,"21":"Novisti, nam tunc natus eras, et numerus dierum tuorum multus!"
,"22":"Numquid ingressus es thesauros nivis,aut thesauros grandinis aspexisti,"
,"23":"quae praeparavi in tempus angustiae, in diem pugnae et belli?"
,"24":"Per quam viam spargitur lux, diffunditur ventus urens super terram?"
,"25":"Quis dedit vehementissimo imbri cursum,et viam fulmini tonanti,"
,"26":"ut plueret super terram absque homine, in deserto, ubi nullus mortalium commoratur,"
,"27":"ut impleret inviam et desolatam,et produceret herbas in terra arida?"
,"28":"Quis est pluviae pater, vel quis genuit stillas roris?"
,"29":"De cuius sinu egressa est glacies, et pruinam de caelo quis genuit?"
,"30":"In similitudinem lapidis aquae durantur, et superficies abyssi constringitur."
,"31":"Numquid coniungere valebis nexus stellarum Pleiadum,aut funiculum Arcturi poteris solvere?"
,"32":"Numquid produces Coronam in tempore suo,et Ursam cum filiis ducis tu?"
,"33":"Numquid nosti leges caeli,et pones scripturam eius in terra?"
,"34":"Numquid elevabis in nebula vocem tuam, et impetus aquarum operiet te?"
,"35":"Numquid mittes fulgura, et ibunt,et dicent tibi: 'Adsumus!'?"
,"36":"Quis posuit in visceribus ibis sapientiam, vel quis dedit gallo intellegentiam?"
,"37":"Quis recensebit nubes in sapientia, et utres caeli quis declinabit,"
,"38":"quando funditur pulvis in solidum, et glebae compinguntur?"
,"39":"Numquid capies leaenae praedam,et animam catulorum eius implebis,"
,"40":"quando cubant in antris,et in specubus insidiantur?"
,"41":"Quis praeparat corvo escam suam, quando pulli eius clamant ad Deum vagantes, eo quod non habeant cibos?"
}`)
	CurrentBook.AddChapter(39, `{
"1":"Numquid nosti tempus partus ibicum in petris,vel parturientes cervas observasti?"
,"2":"Dinumerasti menses conceptus earum,et scisti tempus partus earum?"
,"3":"Incurvantur ad fetum et pariunt,et fetus suos emittunt."
,"4":"Impinguantur filii earum et adolescunt in campo, egrediuntur et non revertuntur ad eas."
,"5":"Quis dimisit onagrum liberum, et vincula ipsius quis solvit?"
,"6":"Cui dedi in solitudine domum,et tabernacula eius in terra salsuginis."
,"7":"Contemnit multitudinem civitatis, clamorem exactoris non audit."
,"8":"Explorat montes pascuae suae,et virentia quaeque perquirit."
,"9":"Numquid volet taurus ferus servire tibi,aut morabitur ad praesepe tuum?"
,"10":"Numquid alligabis taurum ferum ad arandum loro tuo, aut confringet glebas vallium post te?"
,"11":"Numquid fiduciam habebis in magna fortitudine eius,et derelinques ei labores tuos?"
,"12":"Numquid credes illi quod revertatur,et sementem in aream tuam congreget?"
,"13":"Ala struthionis laeta est, penna vero ciconiae et avolat."
,"14":"Quando derelinquit ova sua in terra, in pulvere calefiunt."
,"15":"Obliviscitur quod pes conculcet ea, aut bestia agri conterat."
,"16":"Duratur ad filios suos quasi non sint sui; frustra laborans nullo timore anxiatur."
,"17":"Privavit enim eam Deus sapientia,nec dedit illi intellegentiam."
,"18":"Cum tempus fuerit, in altum alas erigit, deridet equum et ascensorem eius."
,"19":"Numquid praebebis equo fortitudinem,aut circumdabis collo eius iubam?"
,"20":"Numquid suscitabis eum quasi locustas?,Gloria hinnitus eius terror;"
,"21":"vallem ungula fodit, exsultat audacter, in occursum pergit armatis."
,"22":"Contemnit pavorem nec territur,neque cedit gladio."
,"23":"Super ipsum sonabit pharetra, micat hasta et acinaces."
,"24":"Fervens et fremens sorbet terram,nec consistet, cum tubae sonaverit clangor."
,"25":"Ubi audierit bucinam, dicit: 'Uah!'. Procul odoratur bellum, exhortationem ducum et ululatum exercitus."
,"26":"Numquid per sapientiam tuam plumescit accipiter, expandens alas suas ad austrum?"
,"27":"Numquid ad praeceptum tuum elevabitur aquila,et in arduis ponet nidum suum?"
,"28":"In petris manet,et in praeruptis silicibus commoratur,atque in culmine et arce."
,"29":"Inde contemplatur escam, et de longe oculi eius prospiciunt."
,"30":"Pulli eius lambent sanguinem; et, ubicumque cadaver fuerit, statim adest '."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Et respondens Dominus locutus est ad Iob:"
,"2":"' Numquid contendit cum Omnipotente reprehensor?,Qui arguit Deum, debet respondere ad ea '."
,"3":"Respondens autem Iob Domino dixit:"
,"4":"' Ecce leviter locutus sum, quid respondebo tibi?,Manum meam ponam super os meum."
,"5":"Unum locutus sum, quod non repetam, et alterum, quibus ultra non addam '."
,"6":"Respondens autem Dominus Iob de turbine dixit:"
,"7":"' Accinge sicut vir lumbos tuos; interrogabo te, et edoce me."
,"8":"Numquid irritum facies iudicium meum,et condemnabis me, ut tu iustificeris?"
,"9":"Et si habes brachium sicut Deus,et si voce simili tonas?"
,"10":"Circumda tibi decorem et sublimitatem; gloria et decore induere."
,"11":"Effunde vehementiam furoris tui,et respiciens omnem arrogantem humilia."
,"12":"Respice cunctos superbos et confunde eos,et contere impios in loco suo."
,"13":"Absconde eos in pulvere simul,et facies eorum claude in fovea;"
,"14":"et ego confitebor,quod salvare te possit dextera tua."
,"15":"Ecce Behemoth, quem feci tecum; fenum quasi bos comedit."
,"16":"Fortitudo eius in lumbis eius, et virtus illius in umbilico ventris eius."
,"17":"Stringit caudam suam quasi cedrum, nervi femorum eius perplexi sunt."
,"18":"Ossa eius velut fistulae aeris, cartilago illius quasi laminae ferreae."
,"19":"Ipse est principium viarum Dei; qui fecit eum, applicabit gladium eius."
,"20":"Huic montes tributum ferunt, omnes bestiae agri ludunt ibi."
,"21":"Sub lotis silvestribus dormit, in secreto calami et in locis umentibus;"
,"22":"loti silvestres umbra eum protegunt, circumdant eum salices torrentis."
,"23":"Si fluvius intumescat, non tremit; securus est, si prorumpat fluctus ad os eius."
,"24":"In oculis eius quis capiet eum,et in sudibus perforabit nares eius?"
,"25":"An extrahere poteris Leviathan hamo,et fune ligabis linguam eius?"
,"26":"Numquid pones iuncum in naribus eius,aut spina perforabis maxillam eius? "
,"27":"Numquid multiplicabit ad te preces,aut loquetur tibi mollia?"
,"28":"Numquid feriet tecum pactum, et accipies eum servum sempiternum?"
,"29":"Numquid illudes ei quasi avi,aut ligabis eum pro puellis tuis?"
,"30":"Speculabuntur super eum socii, divident illum negotiatores?"
,"31":"Numquid implebis telis pellem eius,et iaculo hamato piscium caput illius?"
,"32":"Pone super eum manum tuam; memento belli nec ultra addas."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Ecce spes eius frustrabitur eum, et aspectu eius praecipitabitur."
,"2":"Nemo tam audax, ut suscitet eum. Quis enim resistere potest vultui eius?"
,"3":"Quis eum aggressus est et salvus fuit?,Sub omni caelo quisnam?"
,"4":"Non tacebo super membra eius,et eloquar robur et gratiam struis. "
,"5":"Quis revelabit faciem indumenti eius, et duplicia mandibulae eius quis intrabit?"
,"6":"Portas vultus eius quis aperiet?,Per gyrum dentium eius formido."
,"7":"Corpus illius quasi scuta fusilia, compactum sigillo siliceo:"
,"8":"unum uni coniungitur, et ne spiraculum quidem incedit per ea;"
,"9":"unum alteri adhaeret, et tenentes se nequaquam separantur."
,"10":"Sternutatio eius favillae ignis, et oculi eius ut palpebrae diluculi."
,"11":"De ore eius lampades procedunt, sicut scintillae ignis emittuntur."
,"12":"De naribus eius procedit fumus, sicut ollae succensae atque ferventis."
,"13":"Halitus eius prunas ardere facit, et flamma de ore eius egreditur."
,"14":"In collo eius morabitur fortitudo, et faciem eius praecedit angor."
,"15":"Palearia eius cohaerentia sibi,compressa non moventur."
,"16":"Cor eius induratur tamquam lapis,et duratur quasi mola inferior."
,"17":"Cum surrexerit, tremunt fortes,et ab undis retrorsum convertuntur."
,"18":"Qui impegerit in eum, gladius eius non stabit,nec hasta neque pilum neque thorax;"
,"19":"reputat enim quasi paleas ferrum,et quasi lignum putridum aes."
,"20":"Non fugat eum vir sagittarius, in stipulam versi sunt ei lapides fundae."
,"21":"Quasi stipulam aestimat fustem,et deridet vibrantem acinacem."
,"22":"Sub ipso acumina testae, et sternit tribula super lutum."
,"23":"Fervescere facit quasi ollam profundum,et mare ponit quasi vas unguentarium."
,"24":"Post se illuminat semitam, aestimatur abyssus quasi canescens."
,"25":"Non est super terram potestas, quae comparetur ei, qui factus est, ut nullum timeret."
,"26":"Omne sublime videt: ipse est rex super universos filios superbiae '."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Respondens autem Iob Domino dixit:"
,"2":"' Scio quia omnia potes, et nulla te latet cogitatio."
,"3":"Quis est iste, qui celat consilium,absque scientia?,Ideo insipienter locutus sum,et mirabilia, quae excederent scientiam meam."
,"4":"Audi, et ego loquar; interrogabo te, et responde mihi."
,"5":"Auditu auris audivi te; nunc autem oculus meus videt te."
,"6":"Idcirco ipse me reprehendo,et ago paenitentiam in favilla et cinere '."
,"7":"Postquam autem locutus est Dominus verba haec ad Iob, dixit ad Eliphaz Themanitem: ' Iratus est furor meus in te et in duos amicos tuos, quoniam non estis locuti coram me rectum sicut servus meus Iob."
,"8":"Sumite ergo vobis septem tauros et septem arietes et ite ad servum meum Iob et offerte holocaustum pro vobis; Iob autem servus meus orabit pro vobis. Faciem eius suscipiam, ut non vobis imputetur stultitia; neque enim locuti estis ad me recta sicut servus meus Iob '."
,"9":"Abierunt ergo Eliphaz Themanites et Baldad Suhites et Sophar Naamathites et fecerunt, sicut locutus fuerat Dominus ad eos, et suscepit Dominus faciem Iob."
,"10":"Dominus vertit sortem Iob, cum oraret ille pro amicis suis; et addidit Dominus omnia, quaecumque fuerant Iob, duplicia."
,"11":"Venerunt autem ad eum omnes fratres sui et universae sorores suae et cuncti, qui noverant eum prius; et comederunt cum eo panem in domo eius et moverunt super eum caput et consolati sunt eum super omni malo, quod intulerat Dominus super eum; et dederunt ei unusquisque argenteum unum et inaurem auream unam."
,"12":"Dominus autem benedixit novissimis Iob magis quam principio eius; et facta sunt ei quattuordecim milia ovium et sex milia camelorum et mille iuga boum et mille asinae."
,"13":"Et fuerunt ei septem filii et tres filiae;"
,"14":"et vocavit nomen unius Columbam et nomen secundae Cassiam et nomen tertiae Cornustibii."
,"15":"Non sunt autem inventae mulieres speciosae sicut filiae Iob in universa terra; deditque eis pater suus hereditatem inter fratres earum."
,"16":"Vixit autem Iob post haec centum quadraginta annis et vidit filios suos et filios filiorum suorum usque ad quartam generationem; et mortuus est senex et plenus dierum."
}`)

}
func LA_NVBSE_LoadVSPRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Parabolae Salomonis filii David regis Israel"
,"2":"ad sciendam sapientiam et disciplinam, ad intellegenda verba prudentiae;"
,"3":"ad suscipiendam eruditionem doctrinae, iustitiam et iudicium et aequitatem,"
,"4":"ut detur parvulis astutia, adulescenti scientia et recogitatio."
,"5":"Audiat sapiens et addet doctrinam, et intellegens dispositiones possidebit:"
,"6":"animadvertet parabolam et allegoriam, verba sapientium et aenigmata eorum."
,"7":"Timor Domini principium scientiae. Sapientiam atque doctrinam stulti despiciunt."
,"8":"Audi, fili mi, disciplinam patris tui,et ne reicias legem matris tuae,"
,"9":"quia diadema gratiae sunt capiti tuo, et torques collo tuo."
,"10":"Fili mi, si te lactaverint peccatores, ne acquiescas eis."
,"11":"Si dixerint: ' Veni nobiscum, insidiemur sanguini, abscondamus tendiculas contra insontem frustra;"
,"12":"deglutiamus eos sicut infernus viventes,et integros quasi descendentes in lacum:"
,"13":"omnem pretiosam substantiam reperiemus, implebimus domos nostras spoliis;"
,"14":"sortem mitte nobiscum, marsupium unum sit omnium nostrum ';"
,"15":"fili mi, ne ambules cum eis, prohibe pedem tuum a semitis eorum."
,"16":"Pedes enim illorum ad malum currunt,et festinant, ut effundant sanguinem."
,"17":"Frustra autem iacitur rete ante oculos pinnatorum."
,"18":"Ipsique contra sanguinem suum insidiantur,et moliuntur fraudes contra animas suas."
,"19":"Sic semitae omnis ad rapinam intenti: animam ipsius possidentis rapiunt."
,"20":"Sapientia foris praedicat, in plateis dat vocem suam,"
,"21":"in capite viarum frequentium clamitat, in foribus portarum urbis profert verba sua:"
,"22":"' Usquequo, parvuli, diligitis infantiam, et derisores sibi derisionem cupient, et imprudentes odibunt scientiam?"
,"23":"Convertimini ad correptionem meam; en proferam vobis spiritum meum,et ostendam vobis verba mea."
,"24":"Quia vocavi, et renuistis, extendi manum meam, et non fuit qui aspiceret;"
,"25":"despexistis omne consilium meum,et increpationes meas neglexistis."
,"26":"Ego quoque in interitu vestro ridebo,et subsannabo, cum terror vobis advenerit,"
,"27":"cum irruerit ut procella terror, et interitus quasi tempestas ingruerit, quando venerit super vos tribulatio et angustia '."
,"28":"Tunc invocabunt me, et non exaudiam, instanter quaerent me et non invenient me,"
,"29":"eo quod exosam habuerint disciplinam,et timorem Domini non elegerint"
,"30":"nec acquieverint consilio meo,et despexerint universam correptionem meam."
,"31":"Comedent igitur fructus viae suae,suisque consiliis saturabuntur."
,"32":"Aversio parvulorum interficiet eos, et securitas stultorum perdet illos."
,"33":"Qui autem me audierit, absque terrore requiescet,et tranquillus erit timore malorum sublato."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Fili mi, si susceperis sermones meos,et mandata mea absconderis penes te,"
,"2":"intendens ad sapientiam aurem tuam, inclinans cor tuum ad cognoscendam prudentiam;"
,"3":"si enim sapientiam invocaveris,et dederis vocem tuam prudentiae, "
,"4":"si quaesieris eam quasi pecuniam,et sicut thesauros conquisieris illam,"
,"5":"tunc intelleges timorem Domini,et scientiam Dei invenies."
,"6":"Quia Dominus dat sapientiam, et ex ore eius scientia et prudentia. "
,"7":"Thesaurizabit rectis sollertiam,et clipeus erit gradientibus simpliciter"
,"8":"servans semitas iustitiae,et vias sanctorum custodiens."
,"9":"Tunc intelleges iustitiam et iudicium,et aequitatem et omnem semitam bonam,"
,"10":"quia intrabit sapientia cor tuum, et scientia animae tuae placebit."
,"11":"Consilium custodiet te, et prudentia servabit te,"
,"12":"ut eruaris a via mala,et ab homine, qui perversa loquitur;"
,"13":"qui relinquunt iter rectum, ut ambulent per vias tenebrosas;"
,"14":"qui laetantur, cum malefecerint, et exsultant in rebus pessimis:"
,"15":"quorum viae perversae sunt, et pravi gressus eorum."
,"16":"Ut eruaris a muliere aliena,et ab extranea, quae mollit sermones suos"
,"17":"et relinquit ducem pubertatis suae,et pacti Dei sui oblita est."
,"18":"Inclinata est enim ad mortem domus eius, et ad inferos semitae ipsius;"
,"19":"omnes, qui ingrediuntur ad eam, non revertentur,nec apprehendent semitas vitae."
,"20":"Ut ambules in via bonorum,et calles iustorum custodias:"
,"21":"qui enim recti sunt, habitabunt in terra, et simplices permanebunt in ea;"
,"22":"impii vero de terra perdentur, et, qui inique agunt, auferentur ex ea."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Fili mi, ne obliviscaris legis meae, et praecepta mea cor tuum custodiat;"
,"2":"longitudinem enim dierum et annos vitae,et pacem apponent tibi."
,"3":"Misericordia et veritas te non deserant; circumda eas gutturi tuo,et describe in tabulis cordis tui,"
,"4":"et invenies gratiam et successum bonum,coram Deo et hominibus."
,"5":"Habe fiduciam in Domino ex toto corde tuo,et ne innitaris prudentiae tuae."
,"6":"In omnibus viis tuis cogita illum, et ipse diriget gressus tuos."
,"7":"Ne sis sapiens apud temetipsum; time Dominum et recede a malo."
,"8":"Sanitas quippe erit umbilico tuo, et irrigatio ossibus tuis."
,"9":"Honora Dominum de tua substantia,et de primitiis omnium frugum tuarum,"
,"10":"et implebuntur horrea tua frumento, et vino torcularia tua redundabunt."
,"11":"Disciplinam Domini, fili mi, ne abicias,nec asperneris, cum ab eo corriperis:"
,"12":"quem enim diligit, Dominus corripit,et quasi pater in filio complacet sibi."
,"13":"Beatus homo, qui invenit sapientiam,et qui affluit prudentia:"
,"14":"melior est acquisitio eius negotiatione argenti, et auro primo fructus eius."
,"15":"Pretiosior est cunctis gemmis, et omnia pretiosa tua huic non valent comparari;"
,"16":"longitudo dierum in dextera eius, et in sinistra illius divitiae et gloria."
,"17":"Viae eius viae pulchrae, et omnes semitae illius pacificae."
,"18":"Lignum vitae est his, qui apprehenderint eam; et, qui tenuerit eam, beatus."
,"19":"Dominus sapientia fundavit terram, stabilivit caelos prudentia;"
,"20":"sapientia illius eruperunt abyssi, et nubes rorem stillant."
,"21":"Fili mi, ne effluant haec ab oculis tuis; custodi prudentiam atque consilium,"
,"22":"et erit vita animae tuae, et gratia collo tuo;"
,"23":"tunc ambulabis fiducialiter in via tua, et pes tuus non impinget."
,"24":"Si dormieris, non timebis; quiesces, et suavis erit somnus tuus."
,"25":"Ne paveas repentino terrore,et irruentem tibi turbinem impiorum, cum venerit."
,"26":"Dominus enim erit in latere tuo,et custodiet pedem tuum, ne capiaris."
,"27":"Noli prohibere beneficium ab eo, cui debetur, si in potestate manus tuae est, ut facias."
,"28":"Ne dicas amico tuo: ' Vade et revertere, cras dabo tibi ', cum statim possis dare."
,"29":"Ne moliaris amico tuo malum, cum ille apud te sedeat cum fiducia."
,"30":"Ne contendas adversus hominem frustra, cum ipse tibi nihil mali fecerit."
,"31":"Ne aemuleris hominem iniustum,nec imiteris omnes vias eius,"
,"32":"quia abominatio Domini est omnis pravus, et cum simplicibus societas eius."
,"33":"Maledictio a Domino in domo impii, habitacula autem iustorum benedicentur."
,"34":"Ipse deludet illusores,et mansuetis dabit gratiam;"
,"35":"gloriam sapientes possidebunt, stultorum exaltatio ignominia."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Audite, filii, disciplinam patris,et attendite, ut sciatis prudentiam;"
,"2":"quoniam doctrinam bonam tribuam vobis, legem meam ne derelinquatis."
,"3":"Nam et ego filius fui patris mei, tenellus et unigenitus coram matre mea;"
,"4":"et docebat me atque dicebat: ' Suscipiat verba mea cor tuum, custodi praecepta mea et vives."
,"5":"Posside sapientiam, posside prudentiam, ne obliviscaris neque declines a verbis oris mei."
,"6":"Ne dimittas eam, et custodiet te, dilige eam, et servabit te."
,"7":"Principium sapientiae: posside sapientiam,et in omni possessione tua acquire prudentiam."
,"8":"Arripe illam, et exaltabit te, glorificaberis ab ea, cum eam fueris amplexatus."
,"9":"Dabit capiti tuo diadema gratiae, et corona inclita proteget te '."
,"10":"Audi, fili mi, et suscipe verba mea, ut multiplicentur tibi anni vitae."
,"11":"Viam sapientiae monstravi tibi; duxi te per semitas aequitatis,"
,"12":"quas cum ingressus fueris, non arctabuntur gressus tui, et currens non habebis offendiculum."
,"13":"Tene disciplinam nec laxes; custodi illam, quia ipsa est vita tua."
,"14":"Ne ingrediaris in semitas impiorum,nec procedas in malorum via."
,"15":"Fuge ab ea nec transeas per illam; declina et desere eam."
,"16":"Non enim dormiunt, nisi malefecerint, et rapitur somnus ab eis, nisi supplantaverint."
,"17":"Comedunt enim panem impietatis,et vinum iniquitatis bibunt."
,"18":"Iustorum autem semita quasi lux splendens,procedit et crescit usque ad perfectam diem."
,"19":"Via impiorum tenebrosa; nesciunt, ubi corruant."
,"20":"Fili mi, ausculta sermones meos,et ad eloquia mea inclina aurem tuam;"
,"21":"ne recedant ab oculis tuis, custodi ea in medio cordis tui:"
,"22":"vita enim sunt invenientibus ea, et universae carni sanitas."
,"23":"Omni custodia serva cor tuum, quia ex ipso vita procedit."
,"24":"Remove a te os pravum, et detrahentia labia sint procul a te."
,"25":"Oculi tui recta videant, et palpebrae tuae dirigantur coram te."
,"26":"Observa semitam pedum tuorum, et omnes viae tuae stabilientur."
,"27":"Ne declines ad dexteram neque ad sinistram, averte pedem tuum a malo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Fili mi, attende ad sapientiam meam, et prudentiae meae inclina aurem tuam,"
,"2":"ut custodias cogitationes, et disciplinam labia tua conservent."
,"3":"Favum enim stillant labia meretricis, et nitidius oleo guttur eius;"
,"4":"novissima autem illius amara quasi absinthium,et acuta quasi gladius biceps."
,"5":"Pedes eius descendunt in mortem, et ad inferos gressus illius tendunt;"
,"6":"cum non observet semitam vitae, vagi sunt gressus eius, et ipsa nescit."
,"7":"Nunc ergo, fili mi, audi me,et ne recedas a verbis oris mei."
,"8":"Longe fac ab ea viam tuam,et ne appropinques foribus domus eius."
,"9":"Ne des alienis honorem tuum,et annos tuos crudeli,"
,"10":"ne forte impleantur extranei viribus tuis, et labores tui sint in domo aliena,"
,"11":"et gemas in novissimis, quando consumpseris carnes tuas et corpus tuum"
,"12":"et dicas: ' Cur detestatus sum disciplinam, et increpationes renuit cor meum,"
,"13":"nec audivi vocem docentium me,et magistris non inclinavi aurem meam?"
,"14":"Paene fui in omni malo, in medio ecclesiae et synagogae '."
,"15":"Bibe aquam de cisterna tua,et fluenta putei tui,"
,"16":"ne deriventur fontes tui foras, et in plateis rivi aquarum;"
,"17":"habeto eas solus, nec sint alieni participes tui."
,"18":"Sit vena tua benedicta, et laetare cum muliere adulescentiae tuae;"
,"19":"cerva carissima et gratissimus hinnulus, blanditiae eius inebrient te in omni tempore, in amore eius delectare iugiter."
,"20":"Quare seduceris, fili mi, ab aliena,et foveris in sinu extraneae?"
,"21":"Quoniam ante Dominum viae hominis, et omnes gressus eius considerat."
,"22":"Iniquitates suae capient impium, et funibus peccatorum suorum constringetur."
,"23":"Ipse morietur, quia non habuit disciplinam, et in multitudine stultitiae suae decipietur."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Fili mi, si spoponderis pro amico tuo, defixisti apud extraneum manum tuam;"
,"2":"illaqueatus es verbis oris tui,et captus propriis sermonibus."
,"3":"Fac ergo, quod dico, fili mi, et temetipsum libera, quia incidisti in manum proximi tui; discurre, prosternere, insta amico tuo."
,"4":"Ne dederis somnum oculis tuis,nec palpebris tuis dormitationem."
,"5":"Eruere quasi dammula de rete, et quasi avis de manu aucupis."
,"6":"Vade ad formicam, o piger, et considera vias eius et disce sapientiam."
,"7":"Quae, cum non habeat ducem,nec praeceptorem nec principem,"
,"8":"parat in aestate cibum sibi,et congregat in messe, quod comedat."
,"9":"Usquequo, piger, dormies?,Quando consurges e somno tuo?"
,"10":"Paululum dormis, paululum dormitas, paululum conseres manus, ut dormias;"
,"11":"et veniet tibi quasi viator egestas, et pauperies quasi vir armatus."
,"12":"Homo iniquus, vir inutilis, graditur ore perverso;"
,"13":"annuit oculis, terit pede, digito loquitur."
,"14":"Prava in corde suo machinatur, malum in omni tempore, iurgia seminat."
,"15":"Ideo extemplo veniet perditio sua, et subito conteretur nec habebit medicinam."
,"16":"Sex sunt, quae odit Dominus, et septem detestatur anima eius:"
,"17":"oculos sublimes, linguam mendacem, manus effundentes innoxium sanguinem,"
,"18":"cor machinans cogitationes pravas, pedes veloces ad currendum in malum,"
,"19":"proferentem mendacia, testem fallacem,et eum, qui seminat inter fratres discordias."
,"20":"Conserva, fili mi, praecepta patris tui,et ne reicias legem matris tuae;"
,"21":"liga ea in corde tuo iugiter,et circumda gutturi tuo."
,"22":"Cum ambulaveris, dirigent te, cum dormieris, custodient te,et, cum evigilaveris, colloquentur tecum."
,"23":"Quia mandatum lucerna est, et lex lux, et via vitae increpatio disciplinae,"
,"24":"ut custodiant te a muliere mala,et a blanda lingua extraneae;"
,"25":"non concupiscat pulchritudinem eius cor tuum, nec capiaris nutibus illius:"
,"26":"pretium enim scorti vix est torta panis, mulier autem viri pretiosam animam capit."
,"27":"Numquid potest homo abscondere ignem in sinu suo, et vestimenta illius non ardebunt?"
,"28":"Aut ambulare super prunas, et non comburentur plantae eius?"
,"29":"Sic qui ingreditur ad mulierem proximi sui; non erit mundus, quicumque tetigerit eam."
,"30":"Non contemptui erit fur, cum furatus fuerit, ut esurientem impleat animam."
,"31":"Deprehensus quoque reddet septuplum,et omnem substantiam domus suae tradet."
,"32":"Qui autem adulter est cum muliere, vecors est; perdet animam suam, qui hoc fecerit."
,"33":"Plagam et ignominiam congregat sibi, et opprobrium illius non delebitur."
,"34":"Quia zelus est furor viri, et non parcet in die vindictae"
,"35":"nec accipiet personam tuam in piaculum,nec suscipiet dona plurima."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Fili mi, custodi sermones meos,et praecepta mea reconde tibi."
,"2":"Serva mandata mea et vives, et legem meam quasi pupillam oculi tui."
,"3":"Liga ea in digitis tuis, scribe illa in tabulis cordis tui."
,"4":"Dic sapientiae: ' Soror mea es ',et prudentiam voca Amicam,"
,"5":"ut custodiat te a muliere extranea,et ab aliena, quae verba sua dulcia facit."
,"6":"De fenestra enim domus meae,per cancellos prospexi"
,"7":"et video inter parvulos; considero inter filios vecordem iuvenem,"
,"8":"qui transit per plateam iuxta angulum,et prope viam domus illius graditur"
,"9":"in obscuro advesperascente die, in mediis tenebris et caligine."
,"10":"Et ecce, occurrit illi mulier ornatu meretricio, cauta corde, garrula et rebellans,"
,"11":"quietis impatiens,nec valens in domo consistere pedibus suis:"
,"12":"nunc foris, nunc in plateis,et iuxta angulos insidians."
,"13":"Apprehensumque deosculatur iuvenem,et procaci vultu blanditur dicens:"
,"14":"' Victimas pro salute vovi, hodie reddidi vota mea;"
,"15":"idcirco egressa sum in occursum tuum,desiderans te videre et repperi."
,"16":"Stragulatis vestibus lectulum meum stravi, linteis pictis ex Aegypto;"
,"17":"aspersi cubile meum myrrha,et aloe et cinnamomo."
,"18":"Veni, inebriemur voluptatibus, usque mane fruamur amoribus."
,"19":"Non est enim vir in domo sua; abiit via longissima,"
,"20":"sacculum pecuniae secum tulit, in die plenae lunae reversurus est in domum suam '."
,"21":"Irretivit eum multis sermonibus,et blanditiis labiorum protraxit illum."
,"22":"Stultus eam sequitur quasi bos ductus ad victimam, sicut irretitur vinculo cervus,"
,"23":"donec transfigat sagitta iecur eius; velut si avis festinet ad laqueum,et nescit quod de periculo animae illius agitur."
,"24":"Nunc ergo, fili mi, audi me,et attende verbis oris mei."
,"25":"Ne abstrahatur in viis illius mens tua, neque decipiaris semitis eius."
,"26":"Multos enim vulneratos deiecit, et fortissimi quique interfecti sunt ab ea:"
,"27":"viae inferi domus eius,penetrantes in interiora mortis."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Numquid non sapientia clamitat, et prudentia dat vocem suam?"
,"2":"In summis verticibus,supra viam in mediis semitis stans,"
,"3":"iuxta portas ad introitum civitatis, in ipsis foribus conclamat:"
,"4":"' O viri, ad vos clamito, et vox mea ad filios hominum."
,"5":"Intellegite, parvuli, astutiam; et insipientes, animadvertite."
,"6":"Audite, quoniam de rebus magnis locutura sum, et aperientur labia mea, ut recta praedicent."
,"7":"Veritatem meditabitur guttur meum, et labia mea detestabuntur impium."
,"8":"Iusti sunt omnes sermones oris mei, non est in eis pravum quid neque perversum;"
,"9":"omnes recti sunt intellegentibus,et aequi invenientibus scientiam."
,"10":"Accipitc disciplinam meam et non pecuniam, doctrinam magis quam aurum electum."
,"11":"Melior est enim sapientia gemmis, et omne desiderabile ei non potest comparari '."
,"12":"Ego sapientia habito cum prudentia,et artem excogitandi invenio."
,"13":"Timor Domini odisse malum; arrogantiam et superbiam et viam pravam,et os bilingue detestor."
,"14":"Meum est consilium et prudentia, mea est intellegentia, mea est fortitudo."
,"15":"Per me reges regnant, et principes iusta decernunt;"
,"16":"per me duces imperant, et potentes decernunt iustitiam."
,"17":"Ego diligentes me diligo; et, qui mane vigilant ad me, invenient me."
,"18":"Mecum sunt divitiae et gloria, opes superbae et iustitia."
,"19":"Melior est enim fructus meus auro et obryzo, et genimina mea argento electo."
,"20":"In viis iustitiae ambulo, in medio semitarum iudicii,"
,"21":"ut ditem diligentes me,et thesauros eorum repleam."
,"22":"Dominus possedit me in initio viarum suarum, antequam quidquam faceret a principio;"
,"23":"ab aeterno ordinata sum,et ex antiquis, antequam terra fieret."
,"24":"Nondum erant abyssi, et ego iam concepta eram, necdum fontes graves aquis,"
,"25":"priusquam montes demergerentur, ante colles ego parturiebar."
,"26":"Adhuc terram non fecerat et campos,et initium glebae orbis terrae."
,"27":"Quando praeparabat caelos, aderam, quando certa lege et gyro vallabat abyssos,"
,"28":"quando nubes firmabat sursum, et praevaluerunt fontes abyssi,"
,"29":"quando circumdabat mari terminum suum,et aquis, ne transirent fines suos, quando iecit fundamenta terrae,"
,"30":"cum eo eram ut artifex: delectatio eius per singulos dies, ludens coram eo omni tempore,"
,"31":"ludens in orbe terrarum, et deliciae meae esse cum filiis hominum."
,"32":"Nunc ergo, filii, audite me: beati, qui custodiunt vias meas;"
,"33":"audite disciplinam et estote sapientes,et nolite abicere eam."
,"34":"Beatus homo, qui audit me,et qui vigilat ad fores meas cotidie,et observat ad postes ostii mei."
,"35":"Qui me invenerit, inveniet vitam,et hauriet delicias a Domino."
,"36":"Qui autem in me peccaverit, laedet animam suam: omnes, qui me oderunt, diligunt mortem."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Sapientia aedificavit sibi domum, excidit columnas septem;"
,"2":"immolavit victimas suas, miscuit vinum,et proposuit mensam suam."
,"3":"Misit ancillas suas, ut vocarent,ad arcem et ad excelsa civitatis:"
,"4":"' Si quis est parvulus, veniat ad me '. Et vecordi locuta est:"
,"5":"' Venite, comedite panem meum,et bibite vinum, quod miscui vobis; "
,"6":"relinquite infantiam et vivite,et ambulate per vias prudentiae '."
,"7":"Qui erudit derisorem, ipse iniuriam sibi facit; et, qui arguit impium, sibi maculam generat."
,"8":"Noli arguere derisorem, ne oderit te; argue sapientem, et diliget te."
,"9":"Da sapienti, et sapientior fiet; doce iustum, et addet doctrinam."
,"10":"Principium sapientiae timor Domini, et scientia Sancti est prudentia."
,"11":"Per me enim multiplicabuntur dies tui, et addentur tibi anni vitae."
,"12":"Si sapiens fueris, tibimetipsi eris; si autem illusor, solus portabis malum."
,"13":"Mulier stulta est clamosa, fatua et nihil sciens;"
,"14":"sedit in foribus domus suae,super sellam in excelsis urbis,"
,"15":"ut vocaret transeuntes per viam,et pergentes itinere suo:"
,"16":"' Qui est parvulus, declinet ad me '. Et vecordi locuta est:"
,"17":"' Aquae furtivae dulciores sunt, et panis in abscondito suavior '."
,"18":"Et ignoravit quod ibi sint umbrae, et in profundis inferni convivae eius."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Parabolae Salomonis. Filius sapiens laetificat pa trem, filius vero stultus maestitia est matris suae."
,"2":"Nil proderunt thesauri impietatis, iustitia vero liberabit a morte."
,"3":"Non affliget Dominus fame animam iusti,et cupiditatem impiorum subvertet."
,"4":"Egestatem operata est manus remissa, manus autem fortium divitias parat."
,"5":"Qui congregat in messe, filius sapiens est; qui autem stertit aestate, filius confusionis."
,"6":"Benedictiones Domini super caput iusti, os autem impiorum operit violentiam."
,"7":"Memoria iusti in benedictione erit, et nomen impiorum putrescet."
,"8":"Sapiens corde praecepta suscipit, et stultus labiis corruet."
,"9":"Qui ambulat simpliciter, ambulat confidenter; qui autem depravat vias suas, manifestus erit."
,"10":"Qui annuit oculo, dabit dolorem, et stultus labiis corruet."
,"11":"Vena vitae os iusti, et os impiorum operit violentiam."
,"12":"Odium suscitat rixas, et universa delicta operit caritas."
,"13":"In labiis sapientis invenitur sapientia, et virga in dorso eius, qui indiget corde."
,"14":"Sapientes recondunt scientiam, os autem stulti ruinae proximum est."
,"15":"Substantia divitis urbs fortitudinis eius, ruina pauperum egestas eorum."
,"16":"Opus iusti ad vitam, fructus autem impii ad peccatum."
,"17":"Graditur ad vitam, qui custodit disciplinam; qui autem increpationes relinquit, errat."
,"18":"Abscondunt odium labia mendacia; qui profert contumeliam, insipiens est."
,"19":"In multiloquio non deerit peccatum; qui autem moderatur labia sua, prudentissimus est."
,"20":"Argentum electum lingua iusti, cor autem impiorum pro nihilo."
,"21":"Labia iusti erudiunt plurimos; qui autem indocti sunt, in cordis egestate morientur."
,"22":"Benedictio Domini divites facit, nec addet ei labor quidquam."
,"23":"Quasi per risum stultus operatur scelus, sapientia autem est viro prudentiae."
,"24":"Quod timet impius, veniet super eum; desiderium suum iustis dabitur."
,"25":"Quasi tempestas transiens non erit impius, iustus autem quasi fundamentum sempiternum."
,"26":"Sicut acetum dentibus et fumus oculis, sic piger his, qui miserunt eum."
,"27":"Timor Domini apponet dies, et anni impiorum breviabuntur."
,"28":"Exspectatio iustorum laetitia, spes autem impiorum peribit."
,"29":"Fortitudo simplici via Domini,et ruina his, qui operantur malum."
,"30":"Iustus in aeternum non commovebitur, impii autem non habitabunt super terram."
,"31":"Os iusti germinabit sapientiam, lingua prava abscindetur."
,"32":"Labia iusti considerant placita, et os impiorum perversa."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Statera dolosa abominatio est apud Dominum, et pondus aequum voluntas eius."
,"2":"Venit superbia, veniet et contumelia; apud humiles autem sapientia."
,"3":"Simplicitas iustorum diriget eos, et supplantatio perversorum vastabit illos."
,"4":"Non proderunt divitiae in die ultionis, iustitia autem liberabit a morte."
,"5":"Iustitia simplicis diriget viam eius, et in impietate sua corruet impius."
,"6":"Iustitia rectorum liberabit eos, et in insidiis suis capientur iniqui."
,"7":"Mortuo homine impio, nulla erit ultra spes; et exspectatio divitiarum peribit."
,"8":"Iustus de angustia liberatus est, et tradetur impius pro eo."
,"9":"Simulator ore decipit amicum suum, iusti autem liberabuntur scientia."
,"10":"In bonis iustorum exsultabit civitas, et in perditione impiorum erit laudatio."
,"11":"Benedictione iustorum exaltabitur civitas,et ore impiorum subvertetur."
,"12":"Qui despicit amicum suum, indigens corde est, vir autem prudens tacebit."
,"13":"Qui ambulat susurrans, revelat arcana; qui autem fidelis est animi, celat commissum."
,"14":"Ubi non adsunt dispositiones, populus corruet; salus autem, ubi multa consilia."
,"15":"Affligetur malo, qui fidem facit pro extraneo; qui autem odit sponsores, securus erit."
,"16":"Mulier gratiosa inveniet gloriam, et robusti habebunt divitias."
,"17":"Benefacit animae suae vir misericors; qui autem crudelis est, carnem suam affligit."
,"18":"Impius facit opus fallax, seminanti autem iustitiam merces fidelis."
,"19":"Firmus in iustitia praeparat vitam, et sectator malorum mortem."
,"20":"Abominabile Domino cor pravum, et voluntas eius in iis, qui simpliciter ambulant."
,"21":"Manus in manu, non erit impunitus malus, semen autem iustorum salvabitur."
,"22":"Circulus aureus in naribus suis,mulier pulchra et fatua."
,"23":"Desiderium iustorum omne bonum est, praestolatio impiorum furor."
,"24":"Alii dividunt propria et ditiores fiunt, alii parciores iusto semper in egestate sunt."
,"25":"Anima, quae benedicit, impinguabitur; et, qui inebriat, ipse quoque inebriatur."
,"26":"Qui abscondit frumenta, maledicetur in populis, benedictio autem super caput vendentium."
,"27":"Qui instanter quaerit bonum, quaerit beneplacitum; qui autem investigator malorum est, haec advenient ei."
,"28":"Qui confidit in divitiis suis, corruet, iusti autem quasi virens folium germinabunt."
,"29":"Qui conturbat domum suam, possidebit ventos; et, qui stultus est, serviet sapienti."
,"30":"Fructus iusti lignum vitae; et suscipit animas, qui sapiens est."
,"31":"Si iustus in terra rependitur, quanto magis impius et peccator."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Qui diligit disciplinam, diligit scientiam; qui autem odit increpationes, insipiens est."
,"2":"Qui bonus est, hauriet gratiam a Domino, virum autem versutum ipse condemnabit."
,"3":"Non roborabitur homo ex impietate, et radix iustorum non commovebitur."
,"4":"Mulier diligens corona est viro suo, et quasi putredo in ossibus eius, quae est inhonesta."
,"5":"Cogitationes iustorum iudicia, et consilia impiorum fraudulentia."
,"6":"Verba impiorum insidiantur sanguini, os iustorum liberabit eos."
,"7":"Subvertuntur impii et iam non sunt, domus autem iustorum permanebit."
,"8":"Ad doctrinam suam laudabitur vir; qui autem perversus corde est, patebit contemptui."
,"9":"Melior est pauper, qui ministrat sibi, quam gloriosus et indigens pane."
,"10":"Curat iustus iumentorum suorum animas, viscera autem impiorum crudelia."
,"11":"Qui operatur terram suam, satiabitur panibus; qui autem sectatur vana, vecors est."
,"12":"Desiderat impius laqueum pessimorum, radix autem iustorum proficiet."
,"13":"Propter peccata labiorum irretitur malus, effugiet autem iustus de angustia."
,"14":"De fructu oris sui unusquisque replebitur bonis, et iuxta opera manuum suarum retribuetur ei."
,"15":"Via stulti recta in oculis eius; qui autem sapiens est, audit consilia."
,"16":"Fatuus statim indicat iram suam, dissimulat autem iniuriam callidus."
,"17":"Qui spirat veritatem, index iustitiae est, testis autem mendax, fraudulentiae."
,"18":"Est qui temere loquitur et quasi gladio pungit, lingua autem sapientium sanitas est."
,"19":"Labium veritatis firmum erit in perpetuum, ad momentum autem lingua mendacii."
,"20":"Dolus in corde cogitantium mala; qui autem pacis ineunt consilia, sequitur eos gaudium."
,"21":"Nulla calamitas obveniet iusto, impii autem replebuntur malo."
,"22":"Abominatio est Domino labia mendacia, qui autem fideliter agunt, placent ei."
,"23":"Homo versutus celat scientiam, et cor insipientium provocat stultitiam."
,"24":"Manus fortium dominabitur, quae autem remissa est, tributis serviet."
,"25":"Maeror in corde viri humiliabit illum, et sermo bonus laetificabit eum."
,"26":"In rectum ducit amicum iustus, iter autem impiorum decipiet eos."
,"27":"Non assabit ignavia praedam suam, sed substantia pretiosa erit viro industrio."
,"28":"In semita iustitiae vita, est autem etiam iter apertum ad mortem."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Filius sapiens disciplina patris; qui autem illusor est, non audit, cum arguitur."
,"2":"De fructu oris sui homo satiabitur bonis, anima autem praevaricatorum violentia."
,"3":"Qui custodit os suum, custodit animam suam; qui autem incautus est eloquio, ruina est ei."
,"4":"Vult et non habet piger, anima autem operantium impinguabitur."
,"5":"Verbum mendax iustus detestabitur, impius autem confundit et dehonestat."
,"6":"Iustitia custodit innocentem in via, impietas autem peccatorem supplantat."
,"7":"Est qui quasi dives habetur, cum nihil habeat; et est qui quasi pauper, cum in multis divitiis sit."
,"8":"Redemptio animae viri divitiae suae; qui autem pauper est, increpationem non sustinet."
,"9":"Lux iustorum laetificat, lucerna autem impiorum exstinguetur."
,"10":"Inter superbos tantum iurgia sunt, et apud humiles sapientia."
,"11":"Substantia festinata minuetur; qui autem colligit manu, multiplicat."
,"12":"Spes, quae differtur, affligit animam, lignum vitae desiderium veniens."
,"13":"Qui contemnit verbum, ipse se obligat; qui autem timet praeceptum, retribuetur ei."
,"14":"Lex sapientis fons vitae, ut declinet a laqueis mortis."
,"15":"Intellegentia bona dabit gratiam, in itinere infidelium vorago."
,"16":"Omnis astutus agit cum consilio; qui autem fatuus est, aperit stultitiam."
,"17":"Nuntius impius cadet in malum, legatus autem fidelis sanitas."
,"18":"Egestas et ignominia ei, qui deserit disciplinam; qui autem acquiescit arguenti, glorificabitur."
,"19":"Desiderium, si compleatur, delectat animam; detestantur stulti fugere mala."
,"20":"Qui cum sapientibus graditur, sapiens erit; amicus stultorum malus efficietur."
,"21":"Peccatores persequitur malum, et iustis retribuentur bona."
,"22":"Bonus relinquit heredes filios et nepotes; et custoditur iusto substantia peccatoris."
,"23":"Multi cibi in novalibus pauperum, et est qui perit, deficiente iudicio."
,"24":"Qui parcit virgae, odit filium suum; qui autem diligit illum, instanter erudit."
,"25":"Iustus comedit et replet animam suam, venter autem impiorum insaturabilis."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sapientia mulierum aedificat domum suam, insipientia eam manibus destruet."
,"2":"Ambulans recto itinere timet Deum; despicit illum, qui infami graditur via."
,"3":"In ore stulti virga superbiae, labia autem sapientium custodiunt eos."
,"4":"Ubi non sunt boves, praesepe vacuum est; plurimae autem segetes in fortitudine bovis."
,"5":"Testis fidelis non mentitur, profert autem mendacium dolosus testis."
,"6":"Quaerit derisor sapientiam et non invenit; doctrina prudentibus facilis."
,"7":"Cede coram viro stulto, quia nescies labia prudentiae."
,"8":"Sapientia callidi est intellegere viam suam, et imprudentia stultorum errans."
,"9":"Stulti parvipendent peccatum, et inter iustos morabitur gratia."
,"10":"Cor novit amaritudinem animae suae, in gaudio eius non miscebitur extraneus."
,"11":"Domus impiorum delebitur, tabernacula vero iustorum germinabunt."
,"12":"Est via, quae videtur homini recta, novissima autem eius deducunt ad mortem."
,"13":"Etiam in risu cor dolore miscebitur, et extrema gaudii luctus occupat."
,"14":"Viis suis replebitur stultus, et super eum erit vir bonus."
,"15":"Simplex credit omni verbo, astutus considerat gressus suos."
,"16":"Sapiens timet et declinat a malo, stultus transilit et confidit."
,"17":"Impatiens operabitur stultitiam, et vir versutus odiosus est."
,"18":"Possidebunt simplices stultitiam, et astuti coronabuntur scientia."
,"19":"Procumbunt mali ante bonos, et impii ante portas iustorum."
,"20":"Etiam proximo suo pauper odiosus erit, amici vero divitum multi."
,"21":"Qui despicit proximum suum, peccat; qui autem miseretur pauperis, beatus erit."
,"22":"Nonne errant, qui operantur malum?,Misericordia et veritas iis, qui praeparant bona."
,"23":"In omni labore erit abundantia; verbum autem labiorum tendit tantummodo ad egestatem."
,"24":"Corona sapientium divitiae eorum, fatuitas stultorum fatuitas est."
,"25":"Liberat animas testis fidelis, et profert mendacia versipellis."
,"26":"In timore Domini fiducia fortis, et filiis eius erit spes."
,"27":"Timor Domini fons vitae, declinans a laqueis mortis."
,"28":"In multitudine populi dignitas regis, et in paucitate plebis ruina principis."
,"29":"Qui patiens est, multa gubernatur prudentia; qui autem impatiens est, exaltat stultitiam."
,"30":"Vita carnium sanitas cordis, putredo ossium invidia."
,"31":"Qui calumniatur egentem, exprobrat Factori eius; honorat autem eum, qui miseretur pauperis."
,"32":"In malitia sua impelletur impius, sperat autem iustus in integritate sua."
,"33":"In corde prudentis requiescit sapientia, at in medio stultorum agnoscetur?"
,"34":"Iustitia elevat gentem, vituperium autem populorum est peccatum."
,"35":"Acceptus est regi minister intellegens, et iracundia ei, qui turpiter agit."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Responsio mollis frangit iram, sermo durus suscitat furorem."
,"2":"Lingua sapientium stillat scientiam, os fatuorum ebullit stultitiam."
,"3":"In omni loco oculi Domini,contemplantur malos et bonos."
,"4":"Lingua placabilis lignum vitae, sed obliquitas in ea conteret spiritum."
,"5":"Stultus irridet disciplinam patris sui; qui autem custodit increpationes, astutior fiet."
,"6":"In domo iusti divitiae plurimae, et in fructibus impii conturbatio."
,"7":"Labia sapientium disseminabunt scientiam; cor stultorum non rectum erit."
,"8":"Victimae impiorum abominabiles Domino; vota iustorum grata sunt ei."
,"9":"Abominatio est Domino via impii; qui sequitur iustitiam, diligetur."
,"10":"Admonitio mala deserenti viam; qui increpationes odit, morietur."
,"11":"Infernus et Perditio coram Domino, quanto magis corda filiorum hominum!"
,"12":"Non amat derisor eum, qui se corripit, nec ad sapientes graditur."
,"13":"Cor gaudens exhilarat faciem, in maerore animi deicitur spiritus."
,"14":"Cor sapientis quaerit doctrinam, et os stultorum pascitur stultitia."
,"15":"Omnes dies pauperis mali; hilaris autem corde quasi iuge convivium."
,"16":"Melius est parum cum timore Domini,quam thesauri magni cum sollicitudine."
,"17":"Melius est demensum holerum cum caritate,quam vitulus saginatus cum odio."
,"18":"Vir iracundus provocat rixas; qui patiens est, mitigat lites."
,"19":"Iter pigrorum quasi saepes spinarum, via sollertium complanata."
,"20":"Filius sapiens laetificat patrem, et stultus homo despicit matrem suam."
,"21":"Stultitia gaudium sensu carenti; et vir prudens dirigit gressus suos."
,"22":"Dissipantur cogitationes, ubi non est consilium; ubi vero sunt plures consiliarii, confirmantur."
,"23":"Laetatur homo in responsione oris sui, et sermo opportunus est optimus."
,"24":"Semita vitae sursum est viro erudito, ut declinet de inferno deorsum."
,"25":"Domum superborum demolietur Dominus,et firmos faciet terminos viduae."
,"26":"Abominatio Domini cogitationes malae, et purus sermo pulcherrimus."
,"27":"Conturbat domum suam, qui sectatur avaritiam; qui autem odit munera, vivet."
,"28":"Mens iusti meditatur, ut respondeat; os impiorum redundat malis."
,"29":"Longe est Dominus ab impiis,et orationes iustorum exaudiet."
,"30":"Lux oculorum laetificat animam, fama bona impinguat ossa."
,"31":"Auris, quae audit increpationes vitae, in medio sapientium commorabitur."
,"32":"Qui abicit disciplinam, despicit animam suam; qui autem acquiescit increpationibus, possessor est cordis."
,"33":"Timor Domini disciplina sapientiae, et gloriam praecedit humilitas."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Hominis est animum praeparare, et Domini est responsio linguae."
,"2":"Omnes viae hominis purae sunt oculis eius, spirituum ponderator est Dominus."
,"3":"Revela Domino opera tua, et dirigentur cogitationes tuae."
,"4":"Universa secundum proprium finem operatus est Dominus; impium quoque ad diem malum."
,"5":"Abominatio Domini est omnis arrogans; manus in manu, non erit innocens."
,"6":"Misericordia et veritate redimitur iniquitas, et in timore Domini declinatur a malo."
,"7":"Cum placuerint Domino viae hominis, inimicos quoque eius convertet ad pacem."
,"8":"Melius est parum cum iustitia,quam multi fructus sine aequitate."
,"9":"Cor hominis disponit viam suam, sed Domini est dirigere gressus eius."
,"10":"Divinatio in labiis regis, in iudicio non errabit os eius."
,"11":"Pondus et statera iusta Domini sunt, et opera eius omnes lapides sacculi."
,"12":"Abominantur reges agere impie, quoniam iustitia firmatur solium."
,"13":"Voluntas regum labia iusta; qui recta loquitur, diligetur."
,"14":"Indignatio regis nuntii mortis, et vir sapiens placabit eam."
,"15":"In lumine vultus regis vita, et voluntas eius quasi imber serotinus."
,"16":"Possidere sapientiam quanto melius est auro; et acquirere prudentiam pretiosius est argento."
,"17":"Semita iustorum declinare a malo; custos animae suae, qui servat viam suam."
,"18":"Contritionem praecedit superbia, et ante ruinam exaltatio spiritus."
,"19":"Melius est humiliari cum mitibus,quam dividere spolia cum superbis."
,"20":"Eruditus in verbo reperiet bona; et, qui sperat in Domino, beatus est."
,"21":"Qui sapiens est corde, appellabitur prudens; et dulcedo labiorum addet doctrinam."
,"22":"Fons vitae eruditio possidentis; poena stultorum stultitia."
,"23":"Cor sapientis erudiet os eius,et labiis eius addet doctrinam."
,"24":"Favus mellis composita verba, dulcedo animae et sanitas ossium."
,"25":"Est via, quae videtur homini recta, et novissima eius ducunt ad mortem."
,"26":"Anima laborantis laborat sibi, quia compulit eum os suum."
,"27":"Vir impius fodit malum, et in labiis eius quasi ignis ardens."
,"28":"Homo perversus suscitat lites, et mussitator separat familiares."
,"29":"Vir iniquus lactat amicum suum,et ducit eum per viam non bonam."
,"30":"Qui attonitis oculis cogitat prava, comprimens labia sua perficit malum."
,"31":"Corona dignitatis canities, quae in viis iustitiae reperietur."
,"32":"Melior est patiens viro forti, et, qui dominatur animo suo, expugnatore urbium."
,"33":"Sortes mittuntur in sinum, sed a Domino temperantur."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Melior est buccella sicca cum pace,quam domus plena victimis cum iurgio."
,"2":"Servus sapiens dominabitur filiis inhonestis,et inter fratres hereditatem dividet."
,"3":"Sicut igne probatur argentum et aurum camino, ita corda probat Dominus."
,"4":"Malus oboedit labio iniquo, et fallax obtemperat linguae mendaci."
,"5":"Qui despicit pauperem, exprobrat Factori eius; et, qui in ruina laetatur alterius, non erit impunitus."
,"6":"Corona senum filii filiorum, et gloria filiorum patres eorum."
,"7":"Non decent stultum verba composita, nec principem labium mentiens."
,"8":"Gemma gratissima munus in oculis domini eius; quocumque se verterit, prospere aget."
,"9":"Qui celat delictum, quaerit amicitias; qui sermone repetit, separat foederatos."
,"10":"Plus proficit correptio apud prudentem,quam centum plagae apud stultum."
,"11":"Semper iurgia quaerit malus; angelus autem crudelis mittetur contra eum."
,"12":"Expedit magis ursae occurrere, raptis fetibus, quam fatuo confidenti in stultitia sua."
,"13":"Qui reddit mala pro bonis, non recedet malum de domo eius."
,"14":"Aquarum proruptio initium est iurgiorum; et, antequam exacerbetur contentio, desere."
,"15":"Qui iustificat impium et qui condemnat iustum, abominabilis est uterque apud Dominum."
,"16":"Ad quid pretium in manu stulti?,Ad emendam sapientiam, cum careat corde?"
,"17":"Omni tempore diligit, qui amicus est, et frater ad angustiam natus est."
,"18":"Stultus homo iungit manus, cum spoponderit pro amico suo."
,"19":"Qui diligit delictum, diligit rixas; et, qui exaltat ostium, quaerit effracturam."
,"20":"Qui perversi cordis est, non inveniet bonum; et, qui vertit linguam, incidet in malum."
,"21":"Qui generat stultum, maerorem generat sibi, sed nec pater in fatuo laetabitur."
,"22":"Animus gaudens aetatem floridam facit, spiritus tristis exsiccat ossa."
,"23":"Munera de sinu impius accipit, ut pervertat semitas iudicii."
,"24":"In facie prudentis lucet sapientia, oculi stultorum in finibus terrae."
,"25":"Ira patris filius stultus,et dolor matris, quae genuit eum."
,"26":"Non est bonum multam inferre iusto,nec percutere principem contra rectitudinem."
,"27":"Qui moderatur sermones suos, novit scientiam, et lenis spiritu est vir prudens."
,"28":"Stultus quoque, si tacuerit, sapiens reputabitur,et, si compresserit labia sua, intellegens."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Occasiones quaerit, qui vult recedere ab amico; omni consilio exacerbatur."
,"2":"Non delectatur stultus prudentia,sed in revelatione cordis sui."
,"3":"Cum venerit impius, veniet et contemptio, et cum ignominia opprobrium."
,"4":"Aqua profunda verba ex ore viri, et torrens redundans fons sapientiae."
,"5":"Accipere personam impii non est bonum, ut declines iustum in iudicio."
,"6":"Labia stulti miscent se rixis, et os eius plagas provocat."
,"7":"Os stulti ruina eius, et labia ipsius laqueus animae eius."
,"8":"Verba susurronis quasi dulcia, et ipsa perveniunt usque ad interiora ventris."
,"9":"Qui mollis et dissolutus est in opere suo, frater est viri dissipantis."
,"10":"Turris fortissima nomen Domini; ad ipsum currit iustus et exaltabitur."
,"11":"Substantia divitis urbs roboris eius,et quasi murus excelsus in cogitatione eius."
,"12":"Antequam conteratur, exaltatur cor hominis; et, antequam glorificetur, humiliatur."
,"13":"Qui prius respondet quam audiat, stultitia est ei et contumelia."
,"14":"Spiritus viri sustentat imbecillitatem suam; spiritum vero confractum, quis poterit sustinere?"
,"15":"Cor prudens possidebit scientiam, et auris sapientium quaerit doctrinam."
,"16":"Donum hominis dilatat viam eius,et ante principes deducit eum."
,"17":"Qui prior in contentione loquitur, putatur iustus; venit amicus eius et arguet eum."
,"18":"Lites comprimit sors,et inter potentes quoque diiudicat."
,"19":"Frater, qui offenditur, durior est civitate firma, et lites quasi vectes urbium."
,"20":"De fructu oris viri replebitur venter eius, et genimina labiorum ipsius saturabunt eum."
,"21":"Mors et vita in manu linguae; qui diligunt eam, comedent fructus eius."
,"22":"Qui invenit mulierem bonam, invenit bonum,et hausit gratiam a Domino."
,"23":"Cum obsecrationibus loquetur pauper, et dives effabitur rigide."
,"24":"Vir cum amicis concuti potest, sed est amicus, qui adhaereat magis quam frater."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Melior est pauper, qui ambulat in simplicitate sua, quam qui torquet labia et est insipiens."
,"2":"Ubi non est scientia animae, non est bonum; et, qui festinus est pedibus, offendit. "
,"3":"Stultitia hominis supplantat gressus eius, et contra Deum fervet animo suo."
,"4":"Divitiae addunt amicos plurimos; pauper autem ab amico suo separatur."
,"5":"Testis falsus non erit impunitus; et, qui mendacia loquitur, non effugiet."
,"6":"Multi blandiuntur faciei potentis, et omnes amici sunt dona tribuenti."
,"7":"Omnes fratres hominis pauperis oderunt eum, insu7per et amici procul recesserunt ab eo; qui tantum verba sectatur, nihil habebit."
,"8":"Qui autem possessor est mentis, diligit animam suam, et custos prudentiae inveniet bona. "
,"9":"Falsus testis non erit impunitus; et, qui loquitur mendacia, peribit."
,"10":"Non decent stultum deliciae, nec servum dominari principibus."
,"11":"Doctrina viri mitigat iram eius, et gloria eius est iniqua praetergredi."
,"12":"Sicut fremitus leonis ita et regis ira, et sicut ros super herbam ita et gratia eius."
,"13":"Calamitas patris filius stultus; et tecta iugiter perstillantia litigiosa mulier."
,"14":"Domus et divitiae hereditas patrum, a Domino autem uxor prudens."
,"15":"Pigredo immittit soporem, et anima dissoluta esuriet."
,"16":"Qui custodit mandatum, custodit animam suam; qui autem neglegit viam suam, mortificabitur."
,"17":"Feneratur Domino, qui miseretur pauperis, et vicissitudinem suam reddet ei."
,"18":"Erudi filium tuum, dum spes est; ad interfectionem autem eius ne ponas animam tuam."
,"19":"Qui impatiens est, sustinebit multam; et, si eum abripere vis, aliud appones."
,"20":"Audi consilium et suscipe disciplinam, ut sis sapiens in novissimis tuis."
,"21":"Multae cogitationes in corde viri, voluntas autem Domini permanebit."
,"22":"Desiderabile in homine est misericordia eius; et melior est pauper quam vir mendax."
,"23":"Timor Domini ad vitam, et in plenitudine commorabitur absque visitatione mali."
,"24":"Abscondit piger manum suam in catino,nec ad os suum applicat eam."
,"25":"Derisore flagellato vel parvulus sapientior erit; si autem corripueris sapientem, intelleget disciplinam."
,"26":"Qui affligit patrem et fugat matrem, filius inhonestus et ignominiosus."
,"27":"Acquiesce, fili, ut audias doctrinam,nec erres a sermonibus scientiae."
,"28":"Testis iniquus deridet iudicium, et os impiorum devorat iniquitatem."
,"29":"Paratae sunt derisoribus virgae, et plagae stultorum corporibus."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Luxuriosa res vinum, et tumultuosa sicera; quicumque his delectatur, non erit sapiens."
,"2":"Sicut rugitus leonis ita et terror regis: qui provocat eum, peccat in animam suam."
,"3":"Honor est homini separari a contentionibus; omnes autem stulti miscentur contumeliis."
,"4":"Propter frigus piger arare noluit; mendicabit ergo aestate, et non dabitur illi."
,"5":"Sicut aqua profunda consilium in corde viri, sed homo sapiens exhauriet illud."
,"6":"Multi homines misericordes vocantur; virum autem fidelem quis inveniet?"
,"7":"Iustus, qui ambulat in simplicitate sua, beatos post se filios derelinquet."
,"8":"Rex, qui sedet in solio iudicii, dissipat omne malum intuitu suo."
,"9":"Quis potest dicere: ' Mundavi cor meum, purus sum a peccato '?"
,"10":"Pondus et pondus, mensura et mensura, utrumque abominabile est apud Dominum."
,"11":"Ex studiis suis intellegitur puer, si munda et recta sint opera eius."
,"12":"Aurem audientem et oculum videntem, Dominus fecit utrumque."
,"13":"Noli diligere somnum, ne te egestas opprimat; aperi oculos tuos et saturare panibus."
,"14":"' Malum est, malum est! ' dicit omnis emptor,et, cum recesserit, tunc gloriabitur."
,"15":"Est aurum et multitudo gemmarum,et vas pretiosum labia scientiae."
,"16":"Tolle vestimentum eius, quia fideiussor exstitit alieni, et pro extraneis aufer pignus ab eo."
,"17":"Suavis est homini panis mendacii, et postea implebitur os eius calculo. "
,"18":"Cogitationes consiliis firmantur, et dispensationibus tractanda sunt bella."
,"19":"Ei, qui revelat mysteria et calumniatur,et dilatat labia sua, ne commiscearis."
,"20":"Qui maledicit patri suo et matri, exstinguetur lucerna eius in mediis tenebris."
,"21":"Hereditas, ad quam festinatur in principio, in novissimo benedictione carebit."
,"22":"Ne dicas: ' Reddam malum '; exspecta Dominum, et liberabit te. "
,"23":"Abominatio est apud Dominum pondus et pondus; statera dolosa non est bona in oculis eius."
,"24":"A Domino diriguntur gressus viri; quis autem hominum intellegere potest viam suam?"
,"25":"Laqueus est homini inconsulte dicere: ' Sanctum! ',et post vota retractare."
,"26":"Ventilat impios rex sapiens,et incurvat super eos rotam."
,"27":"Lucerna Domini spiraculum hominis, quae investigat omnia secreta ventris."
,"28":"Misericordia et veritas custodiunt regem, et roboratur clementia thronus eius."
,"29":"Ornamentum iuvenum fortitudo eorum, et honor senum canities."
,"30":"Livor vulneris absterget mala, et plagae in secretioribus ventris."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Sicut rivi aquarum cor regis in manu Domini: quocumque voluerit, inclinabit illud."
,"2":"Omnis via viri recta sibi videtur; appendit autem corda Dominus."
,"3":"Facere misericordiam et iudicium,magis placet Domino quam victimae."
,"4":"Exaltatio oculorum et dilatatio cordis, lucerna impiorum: peccatum."
,"5":"Cogitationes sollertis semper in abundantiam; omnis autem festinus semper in egestate est."
,"6":"Qui congregat thesauros lingua mendacii, vento impingetur ad laqueos mortis."
,"7":"Violentia impiorum detrahet eos, quia noluerunt facere iudicium."
,"8":"Perversa via viri aliena est; qui autem mundus est, rectum opus eius."
,"9":"Melius est sedere in angulo domatis,quam cum muliere litigiosa et in domo communi."
,"10":"Anima impii desiderat malum; non miserebitur proximo suo."
,"11":"Multato derisore sapientior erit parvulus; et, si instruatur sapiens, sumet scientiam."
,"12":"Excogitat Iustus de domo impii, ut praecipitet impios in malum."
,"13":"Qui obturat aurem suam ad clamorem pauperis, et ipse clamabit, et non exaudietur."
,"14":"Munus absconditum exstinguit iras, et donum in sinu indignationem maximam."
,"15":"Gaudium iusto est facere iudicium, et ruina operantibus iniquitatem."
,"16":"Vir, qui erraverit a via prudentiae, in coetu umbrarum commorabitur."
,"17":"Qui diligit convivia, in egestate erit; qui amat vinum et pinguia, non ditabitur."
,"18":"Redemptio pro iusto impius, et pro rectis iniquus."
,"19":"Melius est habitare in terra deserta,quam cum muliere rixosa et iracunda."
,"20":"Thesaurus desiderabilis et pinguis in habitaculo sapientis, et imprudens homo dissipabit illum."
,"21":"Qui sequitur iustitiam et misericordiam, inveniet vitam et iustitiam et gloriam."
,"22":"Civitatem fortium ascendit sapiens,et destruit robur fiduciae eius."
,"23":"Qui custodit os suum et linguam suam, custodit ab angustiis animam suam."
,"24":"Superbus et arrogans vocatur derisor, qui operatur in ira superbiae."
,"25":"Desideria occidunt pigrum; noluerunt enim quidquam manus eius operari:"
,"26":"tota die concupiscit et desiderat; qui autem iustus est, tribuet et non parcit."
,"27":"Hostiae impiorum abominabiles, eo magis quia offeruntur ex scelere."
,"28":"Testis mendax peribit; vir oboediens loquetur in victoriam."
,"29":"Vir impius obfirmat vultum suum; qui autem rectus est, corrigit viam suam."
,"30":"Non est sapientia, non est prudentia, non est consilium contra Dominum."
,"31":"Equus paratur ad diem belli, Dominus autem salutem tribuit."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Melius est nomen bonum quam divitiae multae, super argentum et aurum gratia bona."
,"2":"Dives et pauper obviaverunt sibi: utriusque operator est Dominus."
,"3":"Callidus vidit malum et abscondit se; simplices pertransierunt et afflicti sunt damno."
,"4":"Praemium modestiae timor Domini, divitiae et gloria et vita."
,"5":"Spinae et laquei in via perversi, custos autem animae suae longe recedit ab eis."
,"6":"Institue adulescentem iuxta viam suam; etiam cum senuerit, non recedet ab ea."
,"7":"Dives pauperibus imperat; et, qui accipit mutuum, servus est fenerantis."
,"8":"Qui seminat iniquitatem, metet mala,et virga irae suae consummabitur."
,"9":"Qui bono oculo est, benedicetur, de panibus enim suis dedit pauperi."
,"10":"Eice derisorem, et exibit cum eo iurgium; cessabuntque causae et contumeliae."
,"11":"Qui diligit cordis munditiam, propter gratiam labiorum suorum habebit amicum regem."
,"12":"Oculi Domini custodiunt scientiam, et supplantantur verba iniqui."
,"13":"Dicit piger: ' Leo est foris, in medio platearum occidendus sum '."
,"14":"Fovea profunda os alienae; cui iratus est Dominus, incidet in eam."
,"15":"Stultitia colligata est in corde pueri, et virga disciplinae fugabit eam."
,"16":"Opprimis pauperem? Ipse augebit divitias suas. Donas ditiori? Ipse egebis."
,"17":"Inclina aurem tuam et audi verba sapientium, appone autem cor ad doctrinam meam,"
,"18":"quia pulchra erunt, cum servaveris ea in ventre tuo, et redundabunt in labiis tuis."
,"19":"Ut sit in Domino fiducia tua, ostendi ea tibi hodie."
,"20":"Nonne descripsi ea tibi nudiustertius,in cogitationibus et scientia,"
,"21":"ut ostenderem tibi firmitatem verborum veritatis, ut respondeas illi, qui misit te?"
,"22":"Non facias violentiam pauperi, quia pauper est, neque conteras egenum in porta,"
,"23":"quia iudicabit Dominus causam eorum, et anima spoliabit spoliatores."
,"24":"Noli esse amicus homini iracundo,neque ambules cum viro furioso,"
,"25":"ne forte discas semitas eius,et sumas scandalum animae tuae."
,"26":"Noli esse cum his, qui iungunt manus suas,et qui vades se offerunt pro debitis:"
,"27":"si enim non habes unde restituas, quid causae est ut tollat lectum tuum subter te?"
,"28":"Ne transferas terminos antiquos, quos posuerunt patres tui."
,"29":"Vidisti virum velocem in opere suo: coram regibus stabit nec erit ante ignobiles."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Quando sederis, ut comedas cum principe, diligenter attende, quae apposita sunt ante faciem tuam,"
,"2":"et statue cultrum in gutture tuo, si avidus es."
,"3":"Ne desideres de cibis eius, quia est panis mendacii."
,"4":"Noli laborare, ut diteris, sed in prudentia tua acquiesce."
,"5":"Si erigas oculos tuos ad opes, iam non sunt; quia facient sibi pennas quasi aquilae et volabunt in caelum."
,"6":"Ne comedas cum homine invido,et ne desideres cibos eius;"
,"7":"quoniam sicut aestimavit in animo suo, ita ipse est. ' Comede et bibe ' dicet tibi, et mens eius non est tecum."
,"8":"Buccellam, quam comederas, evomes,et perdes pulchros sermones tuos."
,"9":"In auribus insipientium ne loquaris, quia despicient doctrinam eloquii tui."
,"10":"Ne attingas terminos viduae,et agrum pupillorum ne introeas:"
,"11":"redemptor enim illorum fortis est, et ipse iudicabit contra te causam illorum."
,"12":"Introduc ad doctrinam cor tuum,et aures tuas ad verba scientiae."
,"13":"Noli subtrahere a puero disciplinam; si enim percusseris eum virga, non morietur:"
,"14":"tu virga percuties eum,et animam eius de inferno liberabis."
,"15":"Fili mi, si sapiens fuerit cor tuum, gaudebit tecum et cor meum,"
,"16":"et exsultabunt renes mei, cum locuta fuerint rectum labia tua."
,"17":"Non aemuletur cor tuum peccatores, sed in timore Domini esto tota die,"
,"18":"quia est tibi posteritas, et praestolatio tua non auferetur."
,"19":"Audi, fili mi, et esto sapiens,et dirige in via animum tuum."
,"20":"Noli esse in conviviis potatorum,nec in comissationibus carnis,"
,"21":"quia vacantes potibus et comissatores consumentur, et vestietur pannis dormitatio."
,"22":"Audi patrem tuum, qui genuit te, et ne contemnas, cum senuerit mater tua."
,"23":"Veritatem eme et noli vendere; sapientiam eme et doctrinam et intellegentiam."
,"24":"Exsultat gaudio pater iusti; qui sapientem genuit, laetabitur in eo;"
,"25":"gaudeat pater tuus et mater tua, et exsultet, quae genuit te."
,"26":"Praebe, fili mi, cor tuum mihi, et oculi tui vias meas custodiant."
,"27":"Fovea enim profunda est meretrix, et puteus angustus aliena,"
,"28":"nam insidiatur ipsa in via quasi latro,et iniquos in hominibus addet."
,"29":"Cui ' Vae '? Cui ' Eheu '?,Cui rixae? Cui querela?,Cui sine causa vulnera? Cui suffusio oculorum?"
,"30":"His, qui commorantur in vino,et eunt, ut scrutentur mixtum."
,"31":"Ne intuearis vinum, quando flavescit, cum splenduerit in calice color eius: ingreditur blande,"
,"32":"sed in novissimo mordebit ut coluber,et sicut regulus vulnerat."
,"33":"Oculi tui videbunt extranea, et cor tuum loquetur perversa;"
,"34":"et eris sicut dormiens in medio mari,et quasi sopitus ad malum navis:"
,"35":"' Verberaverunt me, sed non dolui, percusserunt me, et ego non sensi; quando evigilabo et rursus illud requiram? '."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Ne aemuleris viros malos,nec desideres esse cum eis,"
,"2":"quia rapinas meditatur mens eorum, et perniciem labia eorum loquuntur."
,"3":"Sapientia aedificabitur domus, et prudentia roborabitur."
,"4":"In doctrina replebuntur cellaria, universa substantia pretiosa et pulcherrima."
,"5":"Vir sapiens fortis est, et vir doctus firmat robur."
,"6":"Quia cum dispositione parabis tibi bellum, et erit salus, ubi multa consilia sunt."
,"7":"Excelsa stulto sapientia, in porta non aperiet os suum."
,"8":"Qui cogitat mala facere, vir perniciosus vocabitur."
,"9":"Cogitatio stulti peccatum est, et abominatio hominum detractor. "
,"10":"Si fueris lassus in die angustiae, coartabitur fortitudo tua."
,"11":"Erue eos, qui ducuntur ad mortem; et, qui trahuntur ad interitum, retine."
,"12":"Si dixeris: ' Nesciebamus hoc '; nonne qui ponderator est cordis, ipse intellegit, et servatorem animae tuae nihil fallit,reddetque homini iuxta opera sua?"
,"13":"Comede, fili mi, mel, quia bonum est,et favum dulcissimum gutturi tuo."
,"14":"Sic, scito, est sapientia animae tuae; quam cum inveneris, erit tibi posteritas, et spes tua non peribit."
,"15":"Ne insidieris, o nequam, domui iusti,neque vastes requiem eius."
,"16":"Septies enim cadet iustus et resurget; impii autem corruent in malum."
,"17":"Cum ceciderit inimicus tuus, ne gaudeas, et in ruina eius ne exsultet cor tuum,"
,"18":"ne forte videat Dominus, et displiceat ei,et auferat ab eo iram suam."
,"19":"Ne succendas ira in pessimos,nec aemuleris impios,"
,"20":"quoniam non erit posteritas maligno, et lucerna impiorum exstinguetur."
,"21":"Time Dominum, fili mi, et regem,et cum nova sectantibus non commiscearis,"
,"22":"quoniam repente consurget perditio eorum, et ruinam utriusque quis novit?"
,"23":"Haec quoque sapientibus: Dignoscere personam in iudicio non est bonum."
,"24":"Qui dicit impio: ' Iustus es ', maledicent ei populi, et detestabuntur eum tribus."
,"25":"Qui vero arguunt eum, laudabuntur, et super ipsos veniet benedictio boni."
,"26":"Labia deosculatur, qui recta verba respondet."
,"27":"Praepara foris opus tuum,et diligenter exerce illud in agro tuo, ut postea aedifices domum tuam."
,"28":"Ne sis testis frustra contra proximum tuum,nec decipias quemquam labiis tuis."
,"29":"Ne dicas: ' Quomodo fecit mihi, sic faciam ei, reddam viro secundum opus suum '."
,"30":"Per agrum hominis pigri transivi,et per vineam viri sensu carentis:"
,"31":"et ecce totum repleverant urticae, et operuerant superficiem eius spinae, et maceria lapidum destructa erat; "
,"32":"quod cum vidissem, posui in corde meo, vidi, didici disciplinam:"
,"33":"' Parum dormies, modicum dormitabis, pauxillum manus conseres, ut quiescas,"
,"34":"et veniet tibi quasi cursor egestas, et mendicitas quasi vir armatus '."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Hae quoque parabolae Salomonis, quas transcripse runt viri Ezechiae regis Iudae."
,"2":"Gloria Dei est celare verbum, et gloria regum investigare sermonem."
,"3":"Caelum prae altitudine et terra prae profunditate, et cor regum inscrutabile."
,"4":"Aufer scorias de argento, et egredietur vas pro argentario."
,"5":"Aufer impium de conspectu regis, et firmabitur iustitia thronus eius."
,"6":"Ne gloriosus appareas coram rege,et in loco magnorum ne steteris."
,"7":"Melius est enim ut dicatur tibi: ' Ascende huc ', quam ut humilieris coram principe."
,"8":"Quae viderunt oculi tui, ne proferas in iurgio cito, quoniam quid facies postea, cum dehonestaverit te amicus tuus?"
,"9":"Causam tuam tracta cum amico tuo,et secretum extranei ne reveles,"
,"10":"ne forte insultet tibi, cum audierit, et contumelia tua revocari non poterit."
,"11":"Mala aurea in ornatibus argenteis, verbum prolatum in tempore suo."
,"12":"Inauris aurea et margaritum fulgens,sapiens, qui arguit super aurem audientem."
,"13":"Sicut frigus nivis in die messis, ita legatus fidelis ei, qui misit eum: animam ipsius recreat."
,"14":"Nubes et ventus et pluviae non sequentes,vir gloriosus et promissa non complens."
,"15":"Patientia lenietur princeps, et lingua mollis confringet ossa."
,"16":"Mel invenisti? Comede, quod sufficit tibi, ne forte satiatus evomas illud."
,"17":"Subtrahe pedem tuum de domo proximi tui, ne quando satiatus oderit te."
,"18":"Malleus et gladius et sagitta acuta,homo, qui loquitur contra proximum suum falsum testimonium."
,"19":"Dens putridus et pes vacillans, qui sperat super infideli in die angustiae."
,"20":"Sicut exuens pallium in die frigoris, sicut acetum in nitro, qui cantat carmina cordi tristi."
,"21":"Si esurierit inimicus tuus, ciba illum; si sitierit, pota illum:"
,"22":"prunas enim congregabis super caput eius, et Dominus reddet tibi."
,"23":"Ventus aquilo parturit pluvias, et faciem tristem lingua detrahens. "
,"24":"Melius est sedere in angulo domatis,quam cum muliere litigiosa et in domo communi."
,"25":"Aqua frigida animae sitienti,et nuntius bonus de terra longinqua."
,"26":"Fons turbatus pede et vena corrupta,iustus cadens coram impio."
,"27":"Mel nimium comedere non est bonum, nec quaestus gloriae est gloria."
,"28":"Urbs diruta et absque muro,vir, qui non potest cohibere spiritum suum."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Quomodo nix in aestate et pluvia in messe, sic indecens est stulto gloria."
,"2":"Sicut avis ad alia transvolans et hirundo volitans, sic maledictum frustra prolatum non superveniet."
,"3":"Flagellum equo et camus asino,et virga dorso stultorum."
,"4":"Ne respondeas stulto iuxta stultitiam suam, ne tu quoque efficiaris ei similis;"
,"5":"responde stulto iuxta stultitiam suam, ne sibi sapiens esse videatur."
,"6":"Amputat sibi pedes et iniuriam bibit, qui mittit verba per manum stulti."
,"7":"Quomodo molles claudo tibiae, sic in ore stultorum parabola."
,"8":"Sicut qui celat lapidem in acervo, ita qui tribuit insipienti honorem."
,"9":"Spina crescens in manu temulenti, sic parabola in ore stultorum."
,"10":"Sagittarius, qui conicit ad omnia, ita qui stultum conducit et qui vagos conducit."
,"11":"Sicut canis, qui revertitur ad vomitum suum, sic stultus, qui iterat stultitiam suam."
,"12":"Vidisti hominem sapientem sibi videri?,Magis illo spem habebit stultus."
,"13":"Dicit piger: ' Leaena est in via, et leo in plateis '."
,"14":"Ostium vertitur in cardine suo, et piger in lectulo suo."
,"15":"Abscondit piger manum in catino,et laborat, si ad os suum eam converterit."
,"16":"Sapientior sibi piger videtur,septem viris respondentibus sententias."
,"17":"Apprehendit auribus canem, qui transiens commiscetur rixae alterius."
,"18":"Sicut insanit, qui mittit sagittas,et lanceas in mortem,"
,"19":"ita vir, qui decipit amicum suum,et dicit: ' Nonne ludens feci? '."
,"20":"Cum defecerint ligna, exstinguetur ignis, et, susurrone subtracto, iurgia conquiescent."
,"21":"Sicut carbones ad prunas et ligna ad ignem, sic homo litigiosus ad inflammandas rixas."
,"22":"Verba susurronis quasi dulcia,et ipsa perveniunt ad intima ventris."
,"23":"Sicut argentum sordidum ornans vas fictile, sic labia levia et cor malum."
,"24":"Labiis suis se dissimulabit inimicus, cum in corde tractaverit dolos:"
,"25":"quando mollierit vocem suam, ne credideris ei, quoniam septem abominationes sunt in corde illius;"
,"26":"operiet odium fraudulenter, revelabitur autem malitia eius in concilio."
,"27":"Qui fodit foveam, incidet in eam; et, qui volvit lapidem, revertetur ad eum."
,"28":"Lingua fallax non amat veritatem, et os lubricum operatur ruinas."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Ne glorieris in crastinum,ignorans, quid superventura pariat dies."
,"2":"Laudet te alienus et non os tuum, extraneus et non labia tua."
,"3":"Grave est saxum et onerosa arena, sed ira stulti utroque gravior."
,"4":"Saevitas et erumpens furor, et coram zelo consistere quis poterit?"
,"5":"Melior est manifesta correptio,quam amor absconditus."
,"6":"Veriora sunt vulnera diligentis,quam fraudulenta oscula odientis."
,"7":"Anima saturata calcabit favum, et anima esuriens etiam amarum pro dulci sumet."
,"8":"Sicut avis transmigrans de nido suo, sic vir errans longe a loco suo."
,"9":"Unguento et ture delectatur cor,et dulcedine amici in consilio ex animo."
,"10":"Amicum tuum et amicum patris tui ne dimiseris,et domum fratris tui ne ingrediaris in die afflictionis tuae. Melior est vicinus iuxta quam frater procul."
,"11":"Stude sapientiae, fili mi, et laetifica cor meum, ut possim exprobranti mihi respondere sermonem."
,"12":"Astutus videns malum absconditus est; simplices transeuntes multati sunt."
,"13":"Tolle vestimentum eius, qui spopondit pro extraneo, et pro alienis aufer ei pignus."
,"14":"Qui benedicit proximo suo voce grandi mane consurgens, maledictio reputabitur ei."
,"15":"Tecta perstillantia in die frigoris,et litigiosa mulier comparantur;"
,"16":"qui retinet eam, quasi qui ventum teneat, et oleum dextera sua tenere reperietur."
,"17":"Ferrum ferro exacuitur, et homo exacuit faciem amici sui."
,"18":"Qui servat ficum, comedet fructus eius; et, qui custos est domini sui, glorificabitur."
,"19":"Quomodo in aqua facies prospicit ad faciem, sic cor hominis ad hominem."
,"20":"Infernus et Perditio numquam implentur, similiter et oculi hominum insatiabiles."
,"21":"Quomodo probatur in conflatorio argentum et in fornace aurum, sic probatur homo ore laudantis."
,"22":"Si pilo contuderis stultum in pila quasi ptisanas, non auferetur ab eo stultitia eius."
,"23":"Diligenter agnosce vultum pecoris tui; appone cor tuum ad greges,"
,"24":"non enim habebis iugiter divitias. Num corona tribuetur in generationem et generationem?"
,"25":"Nudata sunt prata, et apparuerunt herbae virentes, et collecta sunt fena de montibus;"
,"26":"agni ad vestimentum tuum, et haedi ad agri pretium;"
,"27":"sufficiat tibi lac caprarum in cibum tuum,et in cibum domus tuae et ad victum ancillis tuis."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Fugit impius, nemine persequente; iustus autem quasi leo confidens."
,"2":"Propter peccata terrae multi principes eius; et propter hominem intellegentem et sapientem,rectus ordo longior erit."
,"3":"Vir pauper et calumnians pauperes,similis est imbri vehementi, in quo paratur fames."
,"4":"Qui derelinquunt legem, laudant impium; qui custodiunt, succenduntur contra eum."
,"5":"Viri mali non intellegunt iudicium; qui autem requirunt Dominum, animadvertunt omnia."
,"6":"Melior est pauper ambulans in simplicitate sua,quam perversus in viis suis, quamquam dives."
,"7":"Qui custodit legem, filius sapiens est; qui autem comissatores pascit, confundit patrem suum."
,"8":"Qui coacervat divitias suas usuris et fenore, liberali in pauperes congregat eas."
,"9":"Qui declinat aures suas, ne audiat legem, oratio quoque eius erit exsecrabilis."
,"10":"Qui decipit iustos in via mala, in interitu suo corruet, et simplices possidebunt bona eius."
,"11":"Sapiens sibi videtur vir dives, pauper autem prudens scrutabitur eum."
,"12":"In exsultatione iustorum multa gloria est, et, cum exaltantur impii, abscondit se homo."
,"13":"Qui abscondit scelera sua, non prosperabit; qui autem confessus fuerit et reliquerit ea, misericordiam consequetur."
,"14":"Beatus homo, qui semper est pavidus; qui vero indurat cor suum, corruet in malum."
,"15":"Leo rugiens et ursus esuriens,princeps impius super populum pauperem."
,"16":"Dux indigens prudentia multos opprimet; qui autem odit avaritiam, longi fient dies eius."
,"17":"Hominem, animae cuiusdam sanguine gravatum, si usque ad lacum fugerit, nemo sustineat."
,"18":"Qui ambulat simpliciter, salvus erit; qui perversis graditur viis, subito concidet."
,"19":"Qui operatur terram suam, satiabitur panibus; qui autem sectatur otium, replebitur egestate."
,"20":"Vir fidelis multum laudabitur; qui autem festinat ditari, non erit innocens."
,"21":"Qui dignoscit in iudicio faciem, non benefacit; et pro buccella panis praevaricatur homo."
,"22":"Festinat ditari vir invidus, ignorat quod egestas superveniet ei."
,"23":"Qui corripit hominem, gratiam postea inveniet,magis quam ille, qui lingua blanditur."
,"24":"Qui abripit aliquid a patre suo et a matre,et dicit: ' Hoc non est peccatum ', particeps homicidae est."
,"25":"Qui desiderium dilatat, iurgia concitat; qui vero sperat in Domino, impinguabitur."
,"26":"Qui confidit in corde suo, stultus est; qui autem graditur sapienter, ipse salvabitur."
,"27":"Qui dat pauperi, non indigebit; qui autem occultat oculos, abundabit maledictis."
,"28":"Cum surrexerint impii, abscondentur homines; cum illi perierint, multiplicabuntur iusti."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Vir, qui correptiones dura cervice contemnit, subito conteretur absque sanatione."
,"2":"In multiplicatione iustorum laetabitur vulgus; et in dominatione impii gemet populus."
,"3":"Vir, qui amat sapientiam, laetificat patrem suum; qui autem nutrit scorta, perdet substantiam."
,"4":"Rex in iustitia erigit terram; vir acceptor donorum destruet eam."
,"5":"Homo, qui blanditur amico suo, rete expandit gressibus eius."
,"6":"In peccato vir iniquus irretitur laqueo, et iustus exsultabit atque gaudebit."
,"7":"Novit iustus causam pauperum, impius ignorat scientiam."
,"8":"Homines pestilentes dissipant civitatem; sapientes vero avertunt furorem."
,"9":"Vir sapiens, si cum stulto iudicio contenderit, sive irascatur sive rideat, non inveniet requiem."
,"10":"Viri sanguinum oderunt simplicem; iusti autem quaerunt animam eius."
,"11":"Totum spiritum suum profert stultus; sapiens mitigat eum in posterum."
,"12":"Princeps, qui libenter audit verba mendacii, omnes ministros habet impios."
,"13":"Pauper et oppressor obviaverunt sibi, utriusque oculorum illuminator est Dominus."
,"14":"Rex, qui iudicat in veritate pauperes, thronus eius in aeternum firmabitur."
,"15":"Virga atque correptio tribuit sapientiam; puer autem, qui dimittitur voluntati suae, confundit matrem suam."
,"16":"In multiplicatione impiorum multiplicabuntur scelera, et iusti ruinas eorum videbunt."
,"17":"Erudi filium tuum, et refrigerabit te,et dabit delicias animae tuae."
,"18":"Cum visio defecerit, dissipabitur populus; qui vero custodit legem, beatus est."
,"19":"Servus verbis non potest erudiri, quia intellegit et respondere contemnit."
,"20":"Vidisti hominem velocem ad loquendum?,Magis illo spem habebit insipiens."
,"21":"Qui delicate a pueritia nutrit servum suum, postea sentiet eum contumacem."
,"22":"Vir iracundus provocat rixas; et, qui ad indignandum facilis est, erit ad peccandum proclivior."
,"23":"Superbia hominis humiliabit eum, et humilis spiritu suscipiet gloriam."
,"24":"Qui cum fure participat, odit animam suam; adiuramentum audit et non indicat."
,"25":"Timor hominis inducit laqueum; qui sperat in Domino, sublevabitur."
,"26":"Multi requirunt faciem principis; et iudicium a Domino egreditur singulorum."
,"27":"Abominantur iusti virum impium; et abominantur impii eos, qui recta sunt via."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Verba Agur filii Iaces ex Massa. Oraculum hominis ad Itiel, ad Itiel et Ucal."
,"2":"Quoniam stultissimus sum virorum, et sapientia hominum non est mecum;"
,"3":"et non didici sapientiam,et scientiam sanctorum non novi."
,"4":"Quis ascendit in caelum atque descendit?,Quis continuit spiritum in manibus suis?,Quis colligavit aquas quasi in vestimento?,Quis statuit omnes terminos terrae?,Quod nomen est eius, et quod nomen filii eius, si nosti?"
,"5":"Omnis sermo Dei probatus,clipeus est sperantibus in eum."
,"6":"Ne addas quidquam verbis illius: et arguaris inveniarisque mendax."
,"7":"Duo rogavi te, ne deneges mihi, antequam moriar:"
,"8":"vanitatem et verba mendacia longe fac a me, mendicitatem et divitias ne dederis mihi, tribue tantum victum demensum mihi,"
,"9":"ne forte satiatus illiciar ad negandum,et dicam: ' Quis est Dominus? ',aut egestate compulsus furer,et periurem nomen Dei mei."
,"10":"Ne calumnieris servum ad dominum suum, ne forte maledicat tibi, et puniaris."
,"11":"Generatio, quae patri suo maledicit,et quae matri suae non benedicit."
,"12":"Generatio, quae sibi munda videtur,et non est lota a sordibus suis."
,"13":"Generatio, cuius oculi quam excelsi sunt, et palpebrae eius in alta surrectae!"
,"14":"Generatio, quae pro dentibus gladios habet, et cultri molares eius, ut comedat inopes de terra,et pauperes ex hominibus."
,"15":"Sanguisugae duae sunt filiae: ' Affer, affer! '. Tria sunt insaturabilia, et quattuor, quae numquam dicunt: ' Sufficit! ':"
,"16":"infernus et venter sterilis, terra, quae non satiatur aqua, ignis, qui numquam dicit: ' Sufficit! '."
,"17":"Oculum, qui subsannat patrem,et qui despicit obsequium matris suae, effodiant eum corvi de torrente, et comedant eum filii aquilae."
,"18":"Tria sunt nimis difficilia mihi, et quattuor penitus ignoro:"
,"19":"viam aquilae in caelo, viam colubri super petram, viam navis in medio mari,et viam viri in adulescentula."
,"20":"Talis est et via mulieris adulterae, quae comedit et tergens os suum dicit: ' Non sum operata malum '."
,"21":"Per tria movetur terra, et quattuor non potest sustinere:"
,"22":"per servum, cum regnaverit, per stultum, cum saturatus fuerit cibo,"
,"23":"per odiosam mulierem, cum in matrimonio fuerit assumpta, et per ancillam, cum fuerit heres dominae suae."
,"24":"Quattuor sunt minima terrae, et ipsa sunt sapientiora sapientibus:"
,"25":"formicae populus infirmus, quae praeparant in messe cibum sibi;"
,"26":"hyraces plebs invalida, qui collocant in petra cubile suum;"
,"27":"regem locusta non habet,et egreditur universa per turmas suas;"
,"28":"stellio manibus nititur,et moratur in aedibus regis."
,"29":"Tria sunt, quae bene gradiuntur, et quattuor, quae incedunt feliciter:"
,"30":"leo fortissimus bestiarum,ad nullius pavebit occursum,"
,"31":"gallus succinctus lumbos et aries,et rex, qui secum habet exercitum."
,"32":"Si stultum te praebuisti, postquam elevatus es in sublime, et si considerasti, ori impone manum."
,"33":"Qui enim fortiter premit lac, exprimit butyrum, et, qui vehementer emungit nares, elicit sanguinem, et, qui provocat iras, producit discordias."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Verba Lamuelis regis Massa, quae erudivit eum mater eius."
,"2":"Quid, fili mi? Quid, fili uteri mei?,Quid, fili votorum meorum?"
,"3":"Ne dederis mulieribus substantiam tuam,et vias tuas illis, quae delent reges."
,"4":"Non decet reges, o Lamuel, non decet reges bibere vinum, nec magistratus desiderare siceram,"
,"5":"ne forte bibant et obliviscantur iudiciorum,et mutent causam omnium filiorum pauperis."
,"6":"Date siceram pereunti,et vinum his, qui amaro sunt animo:"
,"7":"bibat et obliviscatur egestatis suae,et doloris sui non recordetur amplius."
,"8":"Aperi os tuum pro muto,et causis omnium filiorum, qui pereunt;"
,"9":"aperi os tuum, decerne, quod iustum est, et iudica inopem et pauperem."
,"10":"ALEPH. Mulierem fortem quis inveniet?,Longe super gemmas pretium eius."
,"11":"BETH. Confidit in ea cor viri sui et spoliis non indigebit."
,"12":"GHIMEL. Reddet ei bonum et non malum omnibus diebus vitae suae."
,"13":"DALETH. Quaesivit lanam et linum,et operata est delectatione manuum suarum."
,"14":"HE. Facta est quasi navis institoris,de longe portans panem suum."
,"15":"VAU. Et de nocte surrexit,deditque praedam domesticis suis,et cibaria ancillis suis."
,"16":"ZAIN. Consideravit agrum et emit eum; de fructu manuum suarum plantavit vineam."
,"17":"HETH. Accinxit fortitudine lumbos suos,et roboravit brachium suum."
,"18":"TETH. Gustavit et vidit quia bona est negotiatio eius; non exstinguetur in nocte lucerna eius."
,"19":"IOD. Manum suam misit ad colos, et digiti eius apprehenderunt fusum."
,"20":"CAPH. Palmas suas aperuit inopi,et manum suam extendit ad pauperem."
,"21":"LAMED. Non timebit domui suae a frigoribus nivis: omnes enim domestici eius vestiti sunt duplicibus."
,"22":"MEM. Stragulatam vestem fecit sibi; byssus et purpura indumentum eius."
,"23":"NUN. Nobilis in portis vir eius, quando sederit cum senatoribus terrae."
,"24":"SAMECH. Sindonem fecit et vendidit,et cingulum tradidit Chananaeo."
,"25":"Ain. Fortitudo et decor indumentum eius, et ridebit in die novissimo."
,"26":"PHE. Os suum aperuit sapientiae, et lex clementiae in lingua eius."
,"27":"SADE. Consideravit semitas domus suae,et panem otiosa non comedit."
,"28":"COPH. Surrexerunt filii eius et beatissimam praedicaverunt, vir eius et laudavit eam:"
,"29":"RES. ' Multae filiae fortiter operatae sunt, tu supergressa es universas '."
,"30":"SIN. Fallax gratia et vana est pulchritudo; mulier timens Dominum ipsa laudabitur."
,"31":"TAU. Date ei de fructu manuum suarum, et laudent eam in portis opera eius."
}`)

}
func LA_NVBSE_LoadVSPSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Beatus vir, qui non abiit in consilio impiorum,et in via peccatorum non stetit,et in conventu derisorum non sedit,"
,"2":"sed in lege Domini voluntas eius, et in lege eius meditatur die ac nocte."
,"3":"Et erit tamquam lignum plantatum secus decursus aquarum, quod fructum suum dabit in tempore suo; et folium eius non defluet, et omnia, quaecumque faciet, prosperabuntur."
,"4":"Non sic impii, non sic, sed tamquam pulvis, quem proicit ventus."
,"5":"Ideo non consurgent impii in iudicio, neque peccatores in concilio iustorum."
,"6":"Quoniam novit Dominus viam iustorum, et iter impiorum peribit."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quare fremuerunt gentes, et populi meditati sunt inania?"
,"2":"Astiterunt reges terrae, et principes convenerunt in unum,adversus Dominum et adversus christum eius:"
,"3":"' Dirumpamus vincula eorum,et proiciamus a nobis iugum ipsorum! '."
,"4":"Qui habitat in caelis, irridebit eos, Dominus subsannabit eos."
,"5":"Tunc loquetur ad eos in ira sua,et in furore suo conturbabit eos:"
,"6":"' Ego autem constitui regem meum super Sion, montem sanctum meum! '."
,"7":"Praedicabo decretum eius. Dominus dixit ad me: ' Filius meus es tu; ego hodie genui te."
,"8":"Postula a me, et dabo tibi gentes hereditatem tuam,et possessionem tuam terminos terrae."
,"9":"Reges eos in virga ferrea,et tamquam vas figuli confringes eos '."
,"10":"Et nunc, reges, intellegite; erudimini, qui iudicatis terram."
,"11":"Servite Domino in timore,et exsultate ei cum tremore."
,"12":"Apprehendite disciplinam, ne quando irascatur, et pereatis de via, cum exarserit in brevi ira eius. Beati omnes, qui confidunt in eo."
}`)
	CurrentBook.AddChapter(3, `{
"1":"PSALMUS. David, cum fugit a filio suo Absalom."
,"2":"Domine, quid multiplicati sunt, qui tribulant me?,Multi insurgunt adversum me,"
,"3":"multi dicunt animae meae: ' Non est salus ipsi in Deo '."
,"4":"Tu autem, Domine, protector meus es, gloria mea et exaltans caput meum."
,"5":"Voce mea ad Dominum clamavi, et exaudivit me de monte sancto suo."
,"6":"Ego obdormivi et soporatus sum, exsurrexi, quia Dominus suscepit me."
,"7":"Non timebo milia populi circumdantis me. Exsurge, Domine salvum me fac, Deus meus;"
,"8":"quoniam tu percussisti in maxillam omnes adversantes mihi, dentes peccatorum contrivisti."
,"9":"Domini est salus, et super populum tuum benedictio tua."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Magistro chori. Fidibus. PSALMUS. David."
,"2":"Cum invocarem, exaudivit me Deus iustitiae meae. In tribulatione dilatasti mihi; miserere mei et exaudi orationem meam."
,"3":"Filii hominum, usquequo gravi corde?,Ut quid diligitis vanitatem et quaeritis mendacium?"
,"4":"Et scitote quoniam mirificavit Dominus sanctum suum; Dominus exaudiet, cum clamavero ad eum."
,"5":"Irascimini et nolite peccare; loquimini in cordibus vestris, in cubilibus vestris et conquiescite."
,"6":"Sacrificate sacrificium iustitiae,et sperate in Domino."
,"7":"Multi dicunt: ' Quis ostendit nobis bona? '. Leva in signum super nos lumen vultus tui, Domine!"
,"8":"Maiorem dedisti laetitiam in corde meo, quam cum multiplicantur frumentum et vinum eorum."
,"9":"In pace in idipsum dormiam et requiescam, quoniam tu, Domine, singulariter in spe constituisti me."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Magistro chori. Ad tibias. PSALMUS. David."
,"2":"Verba mea auribus percipe, Domine; intellege gemitum meum."
,"3":"Intende voci clamoris mei, rex meus et Deus meus."
,"4":"Quoniam ad te orabo, Domine, mane exaudies vocem meam; mane astabo tibi et exspectabo."
,"5":"Quoniam non Deus volens iniquitatem tu es; neque habitabit iuxta te malignus,"
,"6":"neque permanebunt iniusti ante oculos tuos."
,"7":"Odisti omnes, qui operantur iniquitatem, perdes omnes, qui loquuntur mendacium; virum sanguinum et dolosum abominabitur Dominus."
,"8":"Ego autem in multitudine misericordiae tuae,introibo in domum tuam; adorabo ad templum sanctum tuum in timore tuo."
,"9":"Domine, deduc me in iustitia tua propter inimicos meos, dirige in conspectu meo viam tuam."
,"10":"Quoniam non est in ore eorum veritas, cor eorum fovea; sepulcrum patens est guttur eorum, molliunt linguas suas."
,"11":"Iudica illos, Deus; decidant a cogitationibus suis; secundum multitudinem impietatum eorum expelle eos, quoniam irritaverunt te, Domine."
,"12":"Et omnes, qui sperant in te, laetentur, in aeternum exsultent. Obumbrabis eis, et gloriabuntur in te, qui diligunt nomen tuum;"
,"13":"quoniam tu benedices iusto, Domine, quasi scuto, bona voluntate coronabis eum."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Magistro chori. Fidibus. Super octavam. PSALMUS. David."
,"2":"Domine, ne in furore tuo arguas me,neque in ira tua corripias me."
,"3":"Miserere mei, Domine, quoniam infirmus sum; sana me, Domine, quoniam conturbata sunt ossa mea."
,"4":"Et anima mea turbata est valde, sed tu, Domine, usquequo?"
,"5":"Convertere, Domine, eripe animam meam; salvum me fac propter misericordiam tuam."
,"6":"Quoniam non est in morte, qui memor sit tui; in inferno autem quis confitebitur tibi?"
,"7":"Laboravi in gemitu meo, lavabam per singulas noctes lectum meum; lacrimis meis stratum meum rigabam."
,"8":"Turbatus est a maerore oculus meus, inveteravi inter omnes inimicos meos."
,"9":"Discedite a me, omnes, qui operamini iniquitatem, quoniam exaudivit Dominus vocem fletus mei."
,"10":"Exaudivit Dominus deprecationem meam, Dominus orationem meam suscepit."
,"11":"Erubescant et conturbentur vehementer omnes inimici mei; convertantur et erubescant valde velociter."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Lamentatio David, quam cantavit Domino propter Chus Beniaminitam."
,"2":"Domine Deus meus, in te speravi; salvum me fac ex omnibus persequentibus me et libera me,"
,"3":"ne quando rapiat ut leo animam meam,discerpens, dum non est qui salvum faciat."
,"4":"Domine Deus meus, si feci istud, si est iniquitas in manibus meis,"
,"5":"si reddidi retribuenti mihi mala,et exspoliavi inimicum meum dimittens inanem,"
,"6":"persequatur inimicus animam meam et comprehendat,et conculcet in terra vitam meam,et gloriam meam in pulverem deducat."
,"7":"Exsurge, Domine, in ira tua,et exaltare contra indignationem inimicorum meorum,et exsurge, Deus meus, in iudicio, quod mandasti."
,"8":"Et synagoga populorum circumdabit te, et super hanc in altum regredere:"
,"9":"Dominus iudicat populos. Iudica me, Domine, secundum iustitiam meam,et secundum innocentiam meam, quae est in me."
,"10":"Consumatur nequitia peccatorum; et iustum confirma: scrutans corda et renes Deus iustus."
,"11":"Adiutorium meum apud Deum, qui salvos facit rectos corde."
,"12":"Deus iudex iustus, fortis, irascens per singulos dies."
,"13":"Nonne iterum gladium suum exacuit, arcum suum tetendit et paravit illum?"
,"14":"Et paravit sibi vasa mortis, sagittas suas ardentes effecit."
,"15":"Ecce parturiit iniustitiam, concepit dolorem et peperit iniquitatem;"
,"16":"lacum aperuit et effodit eum,et incidit in foveam, quam fecit."
,"17":"Convertetur dolor eius in caput eius, et in verticem ipsius iniquitas eius descendet."
,"18":"Confitebor Domino secundum iustitiam eius,et psallam nomini Domini Altissimi."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Magistro chori. Ad modum cantici ' Torcularia... '. PSALMUS. David."
,"2":"Domine, Dominus noster, quam admirabile est nomen tuum in universa terra, quoniam elevata est magnificentia tua super caelos."
,"3":"Ex ore infantium et lactantium perfecisti laudem,propter inimicos tuos, ut destruas inimicum et ultorem."
,"4":"Quando video caelos tuos, opera digitorum tuorum, lunam et stellas, quae tu fundasti,"
,"5":"quid est homo, quod memor es eius, aut filius hominis, quoniam visitas eum?"
,"6":"Minuisti eum paulo minus ab angelis, gloria et honore coronasti eum"
,"7":"et constituisti eum super opera manuum tuarum. Omnia subiecisti sub pedibus eius:"
,"8":"oves et boves universas, insuper et pecora campi,"
,"9":"volucres caeli et pisces maris, quaecumque perambulant semitas maris."
,"10":"Domine, Dominus noster, quam admirabile est nomen tuum in universa terra!"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Magistro chori. Ad modum cantici ' Mut labben '. PSALMUS. David."
,"2":"ALEPH. Confitebor tibi, Domine, in toto corde meo, narrabo omnia mirabilia tua."
,"3":"Laetabor et exsultabo in te, psallam nomini tuo, Altissime."
,"4":"BETH. Cum convertuntur inimici mei retrorsum, infirmantur et pereunt a facie tua."
,"5":"Quoniam fecisti iudicium meum et causam meam, sedisti super thronum, qui iudicas iustitiam."
,"6":"GHIMEL. Increpasti gentes, perdidisti impium; nomen eorum delesti in aeternum et in saeculum saeculi."
,"7":"Inimici defecerunt, solitudines sempiternae factae sunt; et civitates destruxisti: periit memoria eorum cum ipsis."
,"8":"HE. Dominus autem in aeternum sedebit, paravit in iudicium thronum suum;"
,"9":"et ipse iudicabit orbem terrae in iustitia, iudicabit populos in aequitate."
,"10":"VAU. Et erit Dominus refugium oppresso, refugium in opportunitatibus, in tribulatione."
,"11":"Et sperent in te, qui noverunt nomen tuum, quoniam non dereliquisti quaerentes te, Domine."
,"12":"ZAIN. Psallite Domino, qui habitat in Sion; annuntiate inter gentes studia eius."
,"13":"Quoniam requirens sanguinem recordatus est eorum, non est oblitus clamorem pauperum."
,"14":"HETH. Miserere mei, Domine; vide afflictionem meam de inimicis meis, qui exaltas me de portis mortis,"
,"15":"ut annuntiem omnes laudationes tuas in portis filiae Sion, exsultem in salutari tuo."
,"16":"TETH. Infixae sunt gentes in fovea, quam fecerunt; in laqueo isto, quem absconderunt, comprehensus est pes eorum."
,"17":"Manifestavit se Dominus iudicium faciens; in operibus manuum suarum comprehensus est peccator."
,"18":"IOD. Convertentur peccatores in infernum, omnes gentes, quae obliviscuntur Deum."
,"19":"CAPH. Quoniam non in finem oblivio erit pauperis; exspectatio pauperum non peribit in aeternum."
,"20":"Exsurge, Domine, non confortetur homo; iudicentur gentes in conspectu tuo."
,"21":"Constitue, Domine, terrorem super eos; sciant gentes quoniam homines sunt."
}`)
	CurrentBook.AddChapter(10, `{
"1":"LAMED. Ut quid, Domine, stas a longe, abscondis te in opportunitatibus, in tribulatione?"
,"2":"Dum superbit, impius insequitur pauperem; comprehendantur in consiliis, quae cogitant."
,"3":"Quoniam gloriatur peccator in desideriis animae suae, et avarus sibi benedicit."
,"4":"NUN. Spernit Dominum peccator in arrogantia sua: ' Non requiret; non est Deus '."
,"5":"Hae sunt omnes cogitationes eius; prosperantur viae illius in omni tempore. Excelsa nimis iudicia tua a facie eius; omnes inimicos suos aspernatur."
,"6":"Dixit enim in corde suo: ' Non movebor; in generationem et generationem ero sine malo '."
,"7":"PHE. Cuius maledictione os plenum est et fraudulentia et dolo, sub lingua eius labor et nequitia."
,"8":"Sedet in insidiis ad vicos, in occultis interficit innocentem."
,"9":"SADE. Oculi eius in pauperem respiciunt; insidiatur in abscondito quasi leo in spelunca sua. Insidiatur, ut rapiat pauperem; rapit pauperem, dum attrahit in laqueum suum."
,"10":"Irruit et inclinat se, et miseri cadunt,in fortitudine brachiorum eius."
,"11":"Dixit enim in corde suo: ' Oblitus est Deus; avertit faciem suam, non videbit in finem '. -"
,"12":"COPH. Exsurge, Domine Deus, exalta manum tuam, ne obliviscaris pauperum."
,"13":"Propter quid spernit impius Deum?,Dixit enim in corde suo: ' Non requires '."
,"14":"RES. Vidisti: tu laborem et dolorem consideras, ut tradas eos in manus tuas. Tibi derelictus est pauper, orphano tu factus es adiutor."
,"15":"SIN. Contere brachium peccatoris et maligni; quaeres peccatum illius et non invenies."
,"16":"Dominus rex in aeternum et in saeculum saeculi: perierunt gentes de terra illius."
,"17":"TAU. Desiderium pauperum exaudisti, Domine; confirmabis cor eorum, intendes aurem tuam"
,"18":"iudicare pupillo et humili, ut non apponat ultra inducere timorem homo de terra."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Magistro chori. David. In Domino confido, quomodo dicitis animae meae: ' Transmigra in montem sicut passer!"
,"2":"Quoniam ecce peccatores intenderunt arcum, paraverunt sagittas suas super nervum, ut sagittent in obscuro rectos corde."
,"3":"Quando fundamenta evertuntur, iustus quid faciat? '."
,"4":"Dominus in templo sancto suo, Dominus, in caelo sedes eius. Oculi eius in pauperem respiciunt, palpebrae eius interrogant filios hominum."
,"5":"Dominus interrogat iustum et impium; qui autem diligit iniquitatem, odit anima eius."
,"6":"Pluet super peccatores carbones ignis et sulphur; et spiritus procellarum pars calicis eorum."
,"7":"Quoniam iustus Dominus et iustitias dilexit, recti videbunt vultum eius."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Magistro chori. Super octavam. PSALMUS. David."
,"2":"Salvum me fac, Domine, quoniam defecit sanctus, quoniam deminuti sunt fideles a filiis hominum."
,"3":"Vana locuti sunt unusquisque ad proximum suum; in labiis dolosis, in duplici corde locuti sunt."
,"4":"Disperdat Dominus universa labia dolosa,et linguam magniloquam."
,"5":"Qui dixerunt: ' Lingua nostra magnificabimur, labia nostra a nobis sunt; quis noster dominus est? '."
,"6":"' Propter miseriam inopum et gemitum pauperum, nunc exsurgam, dicit Dominus; ponam in salutari illum, quem despiciunt '."
,"7":"Eloquia Domini eloquia casta, argentum igne examinatum, separatum a terra, purgatum septuplum."
,"8":"Tu, Domine, servabis nos et custodies nos,a generatione hac in aeternum. In circuitu impii ambulant, cum exaltantur sordes inter filios hominum."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Magistro chori. PSALMUS. David."
,"2":"Usquequo, Domine, oblivisceris me in finem?,Usquequo avertes faciem tuam a me?"
,"3":"Usquequo ponam consilia in anima mea, dolorem in corde meo per diem?,Usquequo exaltabitur inimicus meus super me?"
,"4":"Respice et exaudi me, Domine Deus meus. Illumina oculos meos, ne quando obdormiam in morte,"
,"5":"ne quando dicat inimicus meus: ' Praevalui adversus eum! '; neque exsultent, qui tribulant me, si motus fuero."
,"6":"Ego autem in misericordia tua speravi. Exsultabit cor meum in salutari tuo; cantabo Domino, qui bona tribuit mihi."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Magistro chori. David. Dixit insipiens in corde suo: ' Non est Deus '. Corrupti sunt et abominationes operati sunt; non est qui faciat bonum."
,"2":"Dominus de caelo prospexit super filios hominum, ut videret si est intellegens aut requirens Deum."
,"3":"Omnes declinaverunt, simul corrupti sunt; non est qui faciat bonum, non est usque ad unum."
,"4":"Nonne scient omnes, qui operantur iniquitatem, qui devorant plebem meam sicut escam panis?,Dominum non invocaverunt;"
,"5":"illic trepidaverunt timore, quoniam Deus cum generatione iusta est."
,"6":"Vos consilium inopis confundetis, Dominus autem spes eius est."
,"7":"Quis dabit ex Sion salutare Israel?,Cum converterit Dominus captivitatem plebis suae, exsultabit Iacob, et laetabitur Israel."
}`)
	CurrentBook.AddChapter(15, `{
"1":"PSALMUS. David. Domine, quis habitabit in tabernaculo tuo?,Quis requiescet in monte sancto tuo?"
,"2":"Qui ingreditur sine macula et operatur iustitiam, qui loquitur veritatem in corde suo,"
,"3":"qui non egit dolum in lingua sua,nec fecit proximo suo malum,et opprobrium non intulit proximo suo."
,"4":"Ad nihilum reputatus est in conspectu eius malignus, timentes autem Dominum glorificat. Qui iuravit in detrimentum suum et non mutat,"
,"5":"qui pecuniam suam non dedit ad usuram,et munera super innocentem non accepit. Qui facit haec, non movebitur in aeternum."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Miktam. David. Conserva me, Deus, quoniam speravi in te."
,"2":"Dixi Domino: ' Dominus meus es tu, bonum mihi non est sine te '."
,"3":"In sanctos, qui sunt in terra, inclitos viros, omnis voluntas mea in eos."
,"4":"Multiplicantur dolores eorum, qui post deos alienos acceleraverunt. Non effundam libationes eorum de sanguinibus,neque assumam nomina eorum in labiis meis."
,"5":"Dominus pars hereditatis meae et calicis mei: tu es qui detines sortem meam."
,"6":"Funes ceciderunt mihi in praeclaris; insuper et hereditas mea speciosa est mihi."
,"7":"Benedicam Dominum, qui tribuit mihi intellectum; insuper et in noctibus erudierunt me renes mei."
,"8":"Proponebam Dominum in conspectu meo semper; quoniam a dextris est mihi, non commovebor."
,"9":"Propter hoc laetatum est cor meum, et exsultaverunt praecordia mea; insuper et caro mea requiescet in spe."
,"10":"Quoniam non derelinques animam meam in inferno,nec dabis sanctum tuum videre corruptionem."
,"11":"Notas mihi facies vias vitae, plenitudinem laetitiae cum vultu tuo, delectationes in dextera tua usque in finem."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Precatio. David. Exaudi, Domine, iustitiam meam, intende deprecationem meam. Auribus percipe orationem meam, non in labiis dolosis."
,"2":"De vultu tuo iudicium meum prodeat; oculi tui videant aequitates."
,"3":"Proba cor meum et visita nocte; igne me examina, et non invenies in me iniquitatem."
,"4":"Non transgreditur os meum ad opera hominum, propter verba labiorum tuorum custodivi me a viis violenti."
,"5":"Retine gressus meos in semitis tuis, ut non moveantur vestigia mea."
,"6":"Ego ad te clamavi, quoniam exaudis me, Deus; inclina aurem tuam mihi et exaudi verba mea."
,"7":"Mirifica misericordias tuas, qui salvos facis ab insurgentibus,sperantes in dextera tua."
,"8":"Custodi me ut pupillam oculi, sub umbra alarum tuarum protege me"
,"9":"a facie impiorum, qui me afflixerunt. Inimici mei in furore circumdederunt me,"
,"10":"adipem suum concluserunt; os eorum locutum est superbiam."
,"11":"Incedentes nunc circumdederunt me, oculos suos statuerunt prosternere in terram."
,"12":"Aspectus eorum quasi leonis parati ad praedam,et sicut catuli leonis recubantis in abditis."
,"13":"Exsurge, Domine, praeveni eum, supplanta eum; eripe animam meam ab impio framea tua,"
,"14":"a mortuis manu tua, Domine, a mortuis, quorum defecit portio vitae. De reconditis tuis adimpleas ventrem eorum, saturentur filii et dimittant reliquias parvulis suis."
,"15":"Ego autem in iustitia videbo faciem tuam; satiabor, cum evigilavero, conspectu tuo."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Magistro chori. David, servi Domini, qui locutus est ad Dominum verba huius cantici, quando Dominus eum liberaverat,e potestate omnium inimicorum suorum"
,"2":"et e manu Saul. Dixit igitur: Diligam te, Domine, fortitudo mea."
,"3":"Domine, firmamentum meum et refugium meum et liberator meus; Deus meus, adiutor meus, et sperabo in eum; protector meus et cornu salutis meae et susceptor meus."
,"4":"Laudabilem invocabo Dominum, et ab inimicis meis salvus ero."
,"5":"Circumdederunt me fluctus mortis, et torrentes Belial conturbaverunt me;"
,"6":"funes inferni circumdederunt me, praeoccupaverunt me laquei mortis."
,"7":"In tribulatione mea invocavi Dominum,et ad Deum meum clamavi; exaudivit de templo suo vocem meam, et clamor meus in conspectu eius introivit in aures eius."
,"8":"Commota est et contremuit terra; fundamenta montium concussa sunt,et commota sunt, quoniam iratus est."
,"9":"Ascendit fumus de naribus eius, et ignis de ore eius devorans; carbones succensi processerunt ab eo."
,"10":"Inclinavit caelos et descendit, et caligo sub pedibus eius."
,"11":"Et ascendit super cherub et volavit, ferebatur super pennas ventorum."
,"12":"Et posuit tenebras latibulum suum, in circuitu eius tabernaculum eius, tenebrosa aqua, nubes aeris."
,"13":"Prae fulgore in conspectu eius nubes transierunt, grando et carbones ignis."
,"14":"Et intonuit de caelo Dominus, et Altissimus dedit vocem suam: grando et carbones ignis."
,"15":"Et misit sagittas suas et dissipavit eos, fulgura iecit et conturbavit eos."
,"16":"Et apparuerunt fontes aquarum, et revelata sunt fundamenta orbis terrarum,ab increpatione tua, Domine, ab inspiratione spiritus irae tuae."
,"17":"Misit de summo et accepit me,et assumpsit me de aquis multis;"
,"18":"eripuit me de inimicis meis fortissimis,et ab his, qui oderunt me, quoniam confortati sunt super me."
,"19":"Oppugnaverunt me in die afflictionis meae, et factus est Dominus fulcimentum meum;"
,"20":"et eduxit me in latitudinem, salvum me fecit, quoniam voluit me."
,"21":"Et retribuet mihi Dominus secundum iustitiam meam,et secundum puritatem manuum mearum reddet mihi,"
,"22":"quia custodivi vias Domini,nec impie recessi a Deo meo."
,"23":"Quoniam omnia iudicia eius in conspectu meo, et iustitias eius non reppuli a me;"
,"24":"et fui immaculatus cum eo,et observavi me ab iniquitate."
,"25":"Et retribuit mihi Dominus secundum iustitiam meam,et secundum puritatem manuum mearum,in conspectu oculorum eius."
,"26":"Cum sancto sanctus eris,et cum viro innocente innocens eris"
,"27":"et cum electo electus eris,et cum perverso callidus eris."
,"28":"Quoniam tu populum humilem salvum facies,et oculos superborum humiliabis."
,"29":"Quoniam tu accendis lucernam meam, Domine; Deus meus illuminat tenebras meas."
,"30":"Quoniam in te aggrediar hostium turmas,et in Deo meo transiliam murum."
,"31":"Deus, impolluta via eius, eloquia Domini igne examinata; protector est omnium sperantium in se."
,"32":"Quoniam quis Deus praeter Dominum?,Aut quae munitio praeter Deum nostrum?"
,"33":"Deus, qui praecinxit me virtute,et posuit immaculatam viam meam;"
,"34":"qui perfecit pedes meos tamquam cervorum,et super excelsa statuit me;"
,"35":"qui docet manus meas ad proelium, et tendunt arcum aereum brachia mea."
,"36":"Et dedisti mihi scutum salutis tuae, et dextera tua suscepit me, et exauditio tua magnificavit me."
,"37":"Dilatasti gressus meos subtus me, et non sunt infirmata vestigia mea."
,"38":"Persequebar inimicos meos et comprehendebam illos,et non convertebar, donec deficerent."
,"39":"Confringebam illos, nec poterant stare, cadebant subtus pedes meos."
,"40":"Et praecinxisti me virtute ad bellum,et supplantasti insurgentes in me subtus me."
,"41":"Et inimicos meos dedisti mihi dorsum,et odientes me disperdidisti."
,"42":"Clamaverunt, nec erat qui salvos faceret, ad Dominum, nec exaudivit eos."
,"43":"Et comminui eos ut pulverem ante faciem venti, ut lutum platearum contrivi eos."
,"44":"Eripuisti me de contradictionibus populi, constituisti me in caput gentium. Populus, quem non cognovi, servivit mihi,"
,"45":"in auditu auris oboedivit mihi. Filii alieni blanditi sunt mihi,"
,"46":"filii alieni inveterati sunt, contremuerunt in abditis suis."
,"47":"Vivit Dominus, et benedictus Adiutor meus, et exaltetur Deus salutis meae."
,"48":"Deus, qui das vindictas mihi,et subdis populos sub me, liberator meus de inimicis meis iracundis;"
,"49":"et ab insurgentibus in me exaltas me, a viro iniquo eripis me."
,"50":"Propterea confitebor tibi in nationibus, Domine, et nomini tuo psalmum dicam,"
,"51":"magnificans salutes regis sui,et faciens misericordiam christo suo,David et semini eius usque in saeculum."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Magistro chori. PSALMUS. David."
,"2":"Caeli enarrant gloriam Dei, et opera manuum eius annuntiat firmamentum."
,"3":"Dies diei eructat verbum, et nox nocti indicat scientiam."
,"4":"Non sunt loquelae neque sermones, quorum non intellegantur voces:"
,"5":"in omnem terram exivit sonus eorum, et in fines orbis terrae verba eorum."
,"6":"Soli posuit tabernaculum in eis, et ipse, tamquam sponsus procedens de thalamo suo, exsultavit ut gigas ad currendam viam."
,"7":"A finibus caelorum egressio eius, et occursus eius usque ad fines eorum, nec est quod se abscondat a calore eius."
,"8":"Lex Domini immaculata, reficiens animam, testimonium Domini fidele, sapientiam praestans parvulis."
,"9":"Iustitiae Domini rectae, laetificantes corda, praeceptum Domini lucidum, illuminans oculos."
,"10":"Timor Domini mundus, permanens in saeculum saeculi; iudicia Domini vera, iusta omnia simul,"
,"11":"desiderabilia super aurum et lapidem pretiosum multum, et dulciora super mel et favum stillantem."
,"12":"Etenim servus tuus eruditur in eis; in custodiendis illis retributio multa."
,"13":"Errores quis intellegit?,Ab occultis munda me"
,"14":"et a superbia custodi servum tuum, ne dominetur mei, Tunc immaculatus ero,et emundabor a delicto maximo."
,"15":"Sint ut complaceant eloquia oris mei, et meditatio cordis mei in conspectu tuo. Domine, adiutor meus et redemptor meus."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Magistro chori. PSALMUS. David."
,"2":"Exaudiat te Dominus in die tribulationis, protegat te nomen Dei Iacob."
,"3":"Mittat tibi auxilium de sancto,et de Sion tueatur te."
,"4":"Memor sit omnis sacrificii tui,et holocaustum tuum pingue habeat."
,"5":"Tribuat tibi secundum cor tuum,et omne consilium tuum adimpleat."
,"6":"Laetabimur in salutari tuo,et in nomine Dei nostri levabimus signa; impleat Dominus omnes petitiones tuas."
,"7":"Nunc cognovi quoniam salvum fecit Dominus christum suum: exaudivit illum de caelo sancto suo, in virtutibus salutis dexterae eius."
,"8":"Hi in curribus, et hi in equis, nos autem nomen Domini Dei nostri invocavimus."
,"9":"Ipsi incurvati sunt et ceciderunt, nos autem surreximus et erecti sumus."
,"10":"Domine, salvum fac regem, et exaudi nos in die, qua invocaverimus te."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Magistro chori. PSALMUS. David."
,"2":"Domine, in virtute tua laetabitur rex,et super salutare tuum exsultabit vehementer."
,"3":"Desiderium cordis eius tribuisti ei,et voluntatem labiorum eius non denegasti."
,"4":"Quoniam praevenisti eum in benedictionibus dulcedinis; posuisti in capite eius coronam de auro purissimo."
,"5":"Vitam petiit a te, et tribuisti ei,longitudinem dierum in saeculum et in saeculum saeculi."
,"6":"Magna est gloria eius in salutari tuo, magnificentiam et decorem impones super eum;"
,"7":"quoniam pones eum benedictionem in saeculum saeculi, laetificabis eum in gaudio ante vultum tuum."
,"8":"Quoniam rex sperat in Domino,et in misericordia Altissimi non commovebitur."
,"9":"Inveniet manus tua omnes inimicos tuos, dextera tua inveniet, qui te oderunt."
,"10":"Pones eos ut clibanum ignis in tempore vultus tui: Dominus in ira sua deglutiet eos, et devorabit eos ignis."
,"11":"Fructum eorum de terra perdes,et semen eorum de filiis hominum."
,"12":"Quoniam intenderunt in te mala, cogitaverunt consilia: nihil potuerunt."
,"13":"Quoniam pones eos dorsum, arcus tuos tendes in vultum eorum."
,"14":"Exaltare, Domine, in virtute tua; cantabimus et psallemus virtutes tuas."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Magistro chori. Ad modum cantici ' Cerva diluculo '. PSALMUS. David."
,"2":"Deus, Deus meus, quare me dereliquisti?,Longe a salute mea verba rugitus mei."
,"3":"Deus meus, clamo per diem, et non exaudis, et nocte, et non est requies mihi."
,"4":"Tu autem sanctus es, qui habitas in laudibus Israel."
,"5":"In te speraverunt patres nostri, speraverunt, et liberasti eos;"
,"6":"ad te clamaverunt et salvi facti sunt, in te speraverunt et non sunt confusi."
,"7":"Ego autem sum vermis et non homo, opprobrium hominum et abiectio plebis."
,"8":"Omnes videntes me deriserunt me; torquentes labia moverunt caput:"
,"9":"' Speravit in Domino: eripiat eum, salvum faciat eum, quoniam vult eum '."
,"10":"Quoniam tu es qui extraxisti me de ventre, spes mea ad ubera matris meae."
,"11":"In te proiectus sum ex utero, de ventre matris meae Deus meus es tu."
,"12":"Ne longe fias a me, quoniam tribulatio proxima est, quoniam non est qui adiuvet."
,"13":"Circumdederunt me vituli multi, tauri Basan obsederunt me."
,"14":"Aperuerunt super me os suum,sicut leo rapiens et rugiens."
,"15":"Sicut aqua effusus sum, et dissoluta sunt omnia ossa mea. Factum est cor meum tamquam cera,liquescens in medio ventris mei."
,"16":"Aruit tamquam testa palatum meum, et lingua mea adhaesit faucibus meis, et in pulverem mortis deduxisti me."
,"17":"Quoniam circumdederunt me canes multi, concilium malignantium obsedit me. Foderunt manus meas et pedes meos,"
,"18":"et dinumeravi omnia ossa mea. Ipsi vero consideraverunt et inspexerunt me;"
,"19":"diviserunt sibi vestimenta mea,et super vestem meam miserunt sortem."
,"20":"Tu autem, Domine, ne elongaveris; fortitudo mea, ad adiuvandum me festina."
,"21":"Erue a framea animam meam,et de manu canis unicam meam."
,"22":"Salva me ex ore leonis,et a cornibus unicornium humilitatem meam."
,"23":"Narrabo nomen tuum fratribus meis, in medio ecclesiae laudabo te."
,"24":"Qui timetis Dominum, laudate eum; universum semen Iacob, glorificate eum. Metuat eum omne semen Israel,"
,"25":"quoniam non sprevit neque despexit afflictionem pauperis,nec avertit faciem suam ab eo,et, cum clamaret ad eum, exaudivit."
,"26":"Apud te laus mea in ecclesia magna; vota mea reddam in conspectu timentium eum."
,"27":"Edent pauperes et saturabuntur; et laudabunt Dominum, qui requirunt eum: ' Vivant corda eorum in saeculum saeculi! '."
,"28":"Reminiscentur et convertentur ad Dominum,universi fines terrae, et adorabunt in conspectu eius,universae familiae gentium."
,"29":"Quoniam Domini est regnum, et ipse dominabitur gentium."
,"30":"Ipsum solum adorabunt omnes, qui dormiunt in terra; in conspectu eius procident omnes, qui descendunt in pulverem. Anima autem mea illi vivet,"
,"31":"et semen meum serviet ipsi. Narrabitur de Domino generationi venturae;"
,"32":"et annuntiabunt iustitiam eius,populo, qui nascetur: ' Haec fecit Dominus! '."
}`)
	CurrentBook.AddChapter(23, `{
"1":"PSALMUS. David. Dominus pascit me, et nihil mihi deerit:"
,"2":"in pascuis virentibus me collocavit, super aquas quietis eduxit me,"
,"3":"animam meam refecit. Deduxit me super semitas iustitiae propter nomen suum."
,"4":"Nam et si ambulavero in valle umbrae mortis, non timebo mala, quoniam tu mecum es. Virga tua et baculus tuus, ipsa me consolata sunt."
,"5":"Parasti in conspectu meo mensam,adversus eos, qui tribulant me; impinguasti in oleo caput meum, et calix meus redundat."
,"6":"Etenim benignitas et misericordia subsequentur me,omnibus diebus vitae meae, et inhabitabo in domo Domini,in longitudinem dierum."
}`)
	CurrentBook.AddChapter(24, `{
"1":"David. PSALMUS. Domini est terra, et plenitudo eius, orbis terrarum, et qui habitant in eo."
,"2":"Quia ipse super maria fundavit eum,et super flumina firmavit eum. -"
,"3":"Quis ascendet in montem Domini, aut quis stabit in loco sancto eius?"
,"4":"Innocens manibus et mundo corde, qui non levavit ad vana animam suam,nec iuravit in dolum."
,"5":"Hic accipiet benedictionem a Domino,et iustificationem a Deo salutari suo."
,"6":"Haec est generatio quaerentium eum, quaerentium faciem Dei Iacob."
,"7":"Attollite, portae, capita vestra, et elevamini, portae aeternales, et introibit rex gloriae."
,"8":"Quis est iste rex gloriae?,Dominus fortis et potens, Dominus potens in proelio."
,"9":"Attollite, portae, capita vestra, et elevamini, portae aeternales, et introibit rex gloriae."
,"10":"Quis est iste rex gloriae?,Dominus virtutum ipse est rex gloriae."
}`)
	CurrentBook.AddChapter(25, `{
"1":"David. ALEPH. Ad te, Domine, levavi animam meam,"
,"2":"BETH. Deus meus, in te confido; non erubescam. Neque exsultent super me inimici mei,"
,"3":"GHIMEL. etenim universi, qui sustinent te, non confundentur. Confundantur infideliter agentes propter vanitatem."
,"4":"DALETH. Vias tuas, Domine, demonstra mihi,et semitas tuas edoce me."
,"5":"HE. Dirige me in veritate tua et doce me, quia tu es Deus salutis meae, VAU. et te sustinui tota die."
,"6":"ZAIN. Reminiscere miserationum tuarum, Domine, et misericordiarum tuarum, quoniam a saeculo sunt."
,"7":"HETH. Peccata iuventutis meae et delicta mea ne memineris; secundum misericordiam tuam memento mei tu, propter bonitatem tuam, Domine."
,"8":"TETH. Dulcis et rectus Dominus, propter hoc peccatores viam docebit;"
,"9":"IOD. diriget mansuetos in iudicio, docebit mites vias suas."
,"10":"CAPH. Universae viae Domini misericordia et veritas,custodientibus testamentum eius et testimonia eius."
,"11":"LAMED. Propter nomen tuum, Domine, propitiaberis peccato meo: multum est enim."
,"12":"MEM. Quis est homo, qui timet Dominum?,Docebit eum viam, quam eligat."
,"13":"NUN. Anima eius in bonis demorabitur, et semen eius hereditabit terram."
,"14":"SAMECH. Familiariter aget Dominus cum timentibus eum, ut testamentum suum manifestet illis."
,"15":"AIN. Oculi mei semper ad Dominum, quoniam ipse evellet de laqueo pedes meos."
,"16":"PHE. Respice in me et miserere mei, quia unicus et pauper sum ego."
,"17":"SADE. Dilata angustias cordis mei,et de necessitatibus meis erue me."
,"18":"Vide humilitatem meam et laborem meum,et dimitte universa delicta mea."
,"19":"RES. Respice inimicos meos, quoniam multiplicati sunt,et odio crudeli oderunt me."
,"20":"SIN. Custodi animam meam et erue me; non erubescam, quoniam speravi in te."
,"21":"TAU. Innocentia et aequitas custodiant me, quia sustinui te."
,"22":"PHE. Libera, Deus, Israel,ex omnibus tribulationibus suis."
}`)
	CurrentBook.AddChapter(26, `{
"1":"David. Iudica me, Domine, quoniam ego in innocentia mea ingressus sum,et in Domino sperans non infirmabor."
,"2":"Proba me, Domine, et tenta me; ure renes meos et cor meum. -"
,"3":"Quoniam misericordia tua ante oculos meos est, et ambulavi in veritate tua."
,"4":"Non sedi cum viris vanitatis,et cum occulte agentibus non introibo."
,"5":"Odivi ecclesiam malignantium,et cum impiis non sedebo."
,"6":"Lavabo in innocentia manus meas,et circumdabo altare tuum, Domine,"
,"7":"ut auditas faciam voces laudis,et enarrem universa mirabilia tua."
,"8":"Domine, dilexi habitaculum domus tuae,et locum habitationis gloriae tuae."
,"9":"Ne colligas cum impiis animam meam,et cum viris sanguinum vitam meam,"
,"10":"in quorum manibus iniquitates sunt, dextera eorum repleta est muneribus."
,"11":"Ego autem in innocentia mea ingressus sum; redime me et miserere mei."
,"12":"Pes meus stetit in directo, in ecclesiis benedicam Domino."
}`)
	CurrentBook.AddChapter(27, `{
"1":"David. Dominus illuminatio mea et salus mea; quem timebo?,Dominus protector vitae meae; a quo trepidabo?"
,"2":"Dum appropiant super me nocentes, ut edant carnes meas; qui tribulant me et inimici mei, ipsi infirmati sunt et ceciderunt."
,"3":"Si consistant adversum me castra, non timebit cor meum; si exsurgat adversum me proelium, in hoc ego sperabo."
,"4":"Unum petii a Domino, hoc requiram: ut inhabitem in domo Domini,omnibus diebus vitae meae, ut videam voluptatem Domini,et visitem templum eius."
,"5":"Quoniam occultabit me in tentorio suo,in die malorum. Abscondet me in abscondito tabernaculi sui, in petra exaltabit me."
,"6":"Et nunc exaltatur caput meum,super inimicos meos in circuitu meo. Immolabo in tabernaculo eius hostias vociferationis, cantabo et psalmum dicam Domino."
,"7":"Exaudi, Domine, vocem meam, qua clamavi; miserere mei et exaudi me."
,"8":"De te dixit cor meum: ' Exquirite faciem meam! '. Faciem tuam, Domine, exquiram."
,"9":"Ne avertas faciem tuam a me, ne declines in ira a servo tuo. Adiutor meus es tu, ne me reicias,neque derelinquas me, Deus salutis meae."
,"10":"Quoniam pater meus et mater mea dereliquerunt me, Dominus autem assumpsit me."
,"11":"Ostende mihi, Domine, viam tuam,et dirige me in semitam rectam propter inimicos meos."
,"12":"Ne tradideris me in animam tribulantium me, quoniam insurrexerunt in me testes iniqui, et qui violentiam spirant."
,"13":"Credo videre bona Domini in terra viventium."
,"14":"Exspecta Dominum, viriliter age, et confortetur cor tuum, et sustine Dominum."
}`)
	CurrentBook.AddChapter(28, `{
"1":"David. Ad te, Domine, clamabo; Deus meus, ne sileas a me. Ne quando taceas a me, et assimilabor descendentibus in lacum."
,"2":"Exaudi vocem deprecationis meae, dum clamo ad te, dum extollo manus meas ad templum sanctum tuum."
,"3":"Ne simul trahas me cum peccatoribus,et cum operantibus iniquitatem. Qui loquuntur pacem cum proximo suo, mala autem in cordibus eorum."
,"4":"Da illis secundum opera eorum,et secundum nequitiam adinventionum ipsorum. Secundum opus manuum eorum tribue illis, redde retributionem eorum ipsis."
,"5":"Quoniam non intellexerunt opera Domini,et opus manuum eius, destruet illos et non aedificabit eos."
,"6":"Benedictus Dominus, quoniam exaudivit vocem deprecationis meae;"
,"7":"Dominus adiutor meus et protector meus, in ipso speravit cor meum, et adiutus sum, et exsultavit cor meum, et in cantico meo confitebor ei."
,"8":"Dominus fortitudo plebi suae, et refugium salvationum christi sui est."
,"9":"Salvum fac populum tuum et benedic hereditati tuae,et pasce eos et extolle illos usque in aeternum."
}`)
	CurrentBook.AddChapter(29, `{
"1":"PSALMUS. David. Afferte Domino, filii Dei, afferte Domino gloriam et potentiam,"
,"2":"afferte Domino gloriam nominis eius, adorate Dominum in splendore sancto."
,"3":"Vox Domini super aquas; Deus maiestatis intonuit, Dominus super aquas multas."
,"4":"Vox Domini in virtute, vox Domini in magnificentia."
,"5":"Vox Domini confringentis cedros; et confringet Dominus cedros Libani."
,"6":"Et saltare faciet, tamquam vitulum, Libanum, et Sarion, quemadmodum filium unicornium. -"
,"7":"Vox Domini intercidentis flammam ignis,"
,"8":"vox Domini concutientis desertum, et concutiet Dominus desertum Cades."
,"9":"Vox Domini properantis partum cervarum, et denudabit condensa; et in templo eius omnes dicent gloriam."
,"10":"Dominus super diluvium habitat, et sedebit Dominus rex in aeternum."
,"11":"Dominus virtutem populo suo dabit, Dominus benedicet populo suo in pace."
}`)
	CurrentBook.AddChapter(30, `{
"1":"PSALMUS. Canticum festi Dedicationis Templi. David."
,"2":"Exaltabo te, Domine, quoniam extraxisti me,nec delectasti inimicos meos super me."
,"3":"Domine Deus meus, clamavi ad te, et sanasti me."
,"4":"Domine, eduxisti ab inferno animam meam, vivificasti me, ut non descenderem in lacum."
,"5":"Psallite Domino, sancti eius, et confitemini memoriae sanctitatis eius,"
,"6":"quoniam ad momentum indignatio eius, et per vitam voluntas eius. Ad vesperum demoratur fletus, ad matutinum laetitia."
,"7":"Ego autem dixi in securitate mea: ' Non movebor in aeternum '."
,"8":"Domine, in voluntate tua,praestitisti decori meo virtutem; avertisti faciem tuam a me, et factus sum conturbatus."
,"9":"Ad te, Domine, clamabam,et ad Deum meum deprecabar."
,"10":"Quae utilitas in sanguine meo, dum descendo in corruptionem?,Numquid confitebitur tibi pulvis,aut annuntiabit veritatem tuam?"
,"11":"Audivit Dominus et misertus est mei, Dominus factus est adiutor meus."
,"12":"Convertisti planctum meum in choros mihi, conscidisti saccum meum et accinxisti me laetitia,"
,"13":"ut cantet tibi gloria mea et non taceat. Domine Deus meus, in aeternum confitebor tibi."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Magistro chori. PSALMUS. David."
,"2":"In te, Domine, speravi, non confundar in aeternum; in iustitia tua libera me."
,"3":"Inclina ad me aurem tuam, accelera, ut eruas me. Esto mihi in rupem praesidii,et in domum munitam, ut salvum me facias."
,"4":"Quoniam fortitudo mea et refugium meum es tu,et propter nomen tuum deduces me et pasces me."
,"5":"Educes me de laqueo, quem absconderunt mihi, quoniam tu es fortitudo mea."
,"6":"In manus tuas commendo spiritum meum; redemisti me, Domine, Deus veritatis."
,"7":"Odisti observantes vanitates supervacuas, ego autem in Domino speravi."
,"8":"Exsultabo et laetabor in misericordia tua, quoniam respexisti humilitatem meam; agnovisti necessitates animae meae"
,"9":"nec conclusisti me in manibus inimici; statuisti in loco spatioso pedes meos."
,"10":"Miserere mei, Domine, quoniam tribulor; conturbatus est in maerore oculus meus, anima mea et venter meus."
,"11":"Quoniam defecit in dolore vita mea, et anni mei in gemitibus; infirmata est in paupertate virtus mea, et ossa mea contabuerunt."
,"12":"Apud omnes inimicos meos factus sum opprobrium,et vicinis meis valde et timor notis meis: qui videbant me foras, fugiebant a me."
,"13":"Oblivioni a corde datus sum tamquam mortuus; factus sum tamquam vas perditum."
,"14":"Quoniam audivi vituperationem multorum: horror in circuitu; in eo dum convenirent simul adversum me, auferre animam meam consiliati sunt."
,"15":"Ego autem in te speravi, Domine; dixi: ' Deus meus es tu,"
,"16":"in manibus tuis sortes meae '. Eripe me de manu inimicorum meorum,et a persequentibus me;"
,"17":"illustra faciem tuam super servum tuum, salvum me fac in misericordia tua."
,"18":"Domine, non confundar, quoniam invocavi te; erubescant impii et obmutescant in inferno."
,"19":"Muta fiant labia dolosa, quae loquuntur adversus iustum proterva,in superbia et in abusione."
,"20":"Quam magna multitudo dulcedinis tuae, Domine, quam abscondisti timentibus te. Perfecisti eis, qui sperant in te, in conspectu filiorum hominum."
,"21":"Abscondes eos in abscondito faciei tuae,a conturbatione hominum; proteges eos in tabernaculo,a contradictione linguarum."
,"22":"Benedictus Dominus, quoniam mirificavit misericordiam suam mihi in civitate munita."
,"23":"Ego autem dixi in trepidatione mea: ' Praecisus sum a conspectu oculorum tuorum '. Verumtamen exaudisti vocem orationis meae, dum clamarem ad te."
,"24":"Diligite Dominum, omnes sancti eius: fideles conservat Dominus,et retribuit abundanter facientibus superbiam."
,"25":"Viriliter agite, et confortetur cor vestrum, omnes, qui speratis in Domino."
}`)
	CurrentBook.AddChapter(32, `{
"1":"David. Maskil. Beatus, cui remissa est iniquitas, et obtectum est peccatum."
,"2":"Beatus vir, cui non imputavit Dominus delictum, nec est in spiritu eius dolus."
,"3":"Quoniam tacui, inveteraverunt ossa mea, dum rugirem tota die."
,"4":"Quoniam die ac nocte gravata est super me manus tua, immutatus est vigor meus in ardoribus aestatis."
,"5":"Peccatum meum cognitum tibi feci,et delictum meum non abscondi. Dixi: ' Confitebor adversum me iniquitatem meam Domino '. Et tu remisisti impietatem peccati mei."
,"6":"Propter hoc orabit ad te omnis sanctus in tempore opportuno. Et in diluvio aquarum multarum,ad eum non approximabunt."
,"7":"Tu es refugium meum, a tribulatione conservabis me; exsultationibus salutis circumdabis me."
,"8":"Intellectum tibi dabo et instruam te in via, qua gradieris; firmabo super te oculos meos."
,"9":"Nolite fieri sicut equus et mulus, quibus non est intellectus; in camo et freno si accedis ad constringendum, non approximant ad te."
,"10":"Multi dolores impii, sperantem autem in Domino misericordia circumdabit."
,"11":"Laetamini in Domino et exsultate, iusti; et gloriamini, omnes recti corde."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Exsultate, iusti, in Domino; rectos decet collaudatio."
,"2":"Confitemini Domino in cithara, in psalterio decem chordarum psallite illi."
,"3":"Cantate ei canticum novum, bene psallite ei in vociferatione,"
,"4":"quia rectum est verbum Domini, et omnia opera eius in fide."
,"5":"Diligit iustitiam et iudicium; misericordia Domini plena est terra."
,"6":"Verbo Domini caeli facti sunt, et spiritu oris eius omnis virtus eorum."
,"7":"Congregans sicut in utre aquas maris, ponens in thesauris abyssos."
,"8":"Timeat Dominum omnis terra, a facie autem eius formident omnes inhabitantes orbem."
,"9":"Quoniam ipse dixit, et facta sunt, ipse mandavit, et creata sunt."
,"10":"Dominus dissipat consilia gentium, irritas facit cogitationes populorum."
,"11":"Consilium autem Domini in aeternum manet, cogitationes cordis eius in generatione et generationem."
,"12":"Beata gens, cui Dominus est Deus, populus, quem elegit in hereditatem sibi."
,"13":"De caelo respexit Dominus, vidit omnes filios hominum."
,"14":"De loco habitaculi sui respexit,super omnes, qui habitant terram,"
,"15":"qui finxit singillatim corda eorum, qui intellegit omnia opera eorum."
,"16":"Non salvatur rex per multam virtutem, et gigas non liberabitur in multitudine virtutis suae."
,"17":"Fallax equus ad salutem, in abundantia autem virtutis suae non salvabit."
,"18":"Ecce oculi Domini super metuentes eum, in eos, qui sperant super misericordia eius,"
,"19":"ut eruat a morte animas eorum,et alat eos in fame."
,"20":"Anima nostra sustinet Dominum, quoniam adiutor et protector noster est;"
,"21":"quia in eo laetabitur cor nostrum, et in nomine sancto eius speravimus."
,"22":"Fiat misericordia tua, Domine, super nos, quemadmodum speravimus in te."
}`)
	CurrentBook.AddChapter(34, `{
"1":"David, quando se mente alienatum simulavit,coram Abimelech et, ab illo dimissus, abiit."
,"2":"ALEPH. Benedicam Dominum in omni tempore, semper laus eius in ore meo."
,"3":"BETH. In Domino gloriabitur anima mea, audiant mansueti et laetentur."
,"4":"GHIMEL. Magnificate Dominum mecum, et exaltemus nomen eius in idipsum."
,"5":"DALETH. Exquisivi Dominum, et exaudivit me,et ex omnibus terroribus meis eripuit me."
,"6":"HE. Respicite ad eum, et illuminamini, et facies vestrae non confundentur."
,"7":"ZAIN. Iste pauper clamavit, et Dominus exaudivit eum,et de omnibus tribulationibus eius salvavit eum."
,"8":"HETH. Vallabit angelus Domini in circuitu timentes eum,et eripiet eos."
,"9":"TETH. Gustate et videte quoniam suavis est Dominus; beatus vir, qui sperat in eo."
,"10":"IOD. Timete Dominum, sancti eius, quoniam non est inopia timentibus eum."
,"11":"CAPH. Divites eguerunt et esurierunt, inquirentes autem Dominum non deficient omni bono."
,"12":"LAMED. Venite, filii, audite me: timorem Domini docebo vos."
,"13":"MEM. Quis est homo, qui vult vitam, diligit dies, ut videat bonum? -"
,"14":"NUN. Prohibe linguam tuam a malo, et labia tua, ne loquantur dolum."
,"15":"SAMECH. Diverte a malo et fac bonum, inquire pacem et persequere eam."
,"16":"AIN. Oculi Domini super iustos, et aures eius in clamorem eorum."
,"17":"PHE. Vultus autem Domini super facientes mala, ut perdat de terra memoriam eorum."
,"18":"SADE. Clamaverunt, et Dominus exaudivit,et ex omnibus tribulationibus eorum liberavit eos."
,"19":"COPH. Iuxta est Dominus iis, qui contrito sunt corde, et confractos spiritu salvabit."
,"20":"RES. Multae tribulationes iustorum, et de omnibus his liberabit eos Dominus."
,"21":"SIN. Custodit omnia ossa eorum, unum ex his non conteretur."
,"22":"TAU. Interficiet peccatorem malitia; et, qui oderunt iustum, punientur."
,"23":"PHE. Redimet Dominus animas servorum suorum; et non punientur omnes, qui sperant in eo."
}`)
	CurrentBook.AddChapter(35, `{
"1":"David. Iudica, Domine, iudicantes me; impugna impugnantes me."
,"2":"Apprehende clipeum et scutum,et exsurge in adiutorium mihi."
,"3":"Effunde frameam et securim,adversus eos, qui persequuntur me. Dic animae meae: ' Salus tua ego sum '."
,"4":"Confundantur et revereantur,quaerentes animam meam; avertantur retrorsum et confundantur,cogitantes mihi mala."
,"5":"Fiant tamquam pulvis ante ventum, et angelus Domini impellens eos;"
,"6":"fiat via illorum tenebrae et lubricum, et angelus Domini persequens eos."
,"7":"Quoniam gratis absconderunt mihi laqueum suum, gratis foderunt foveam animae meae."
,"8":"Veniat illi calamitas, quam ignorat, et captio, quam abscondit, apprehendat eum, et in eandem calamitatem ipse cadat."
,"9":"Anima autem mea exsultabit in Domino,et delectabitur super salutari suo."
,"10":"Omnia ossa mea dicent: ' Domine, quis similis tibi?,Eripiens inopem de manu fortiorum eius, egenum et pauperem a diripientibus eum '."
,"11":"Surgentes testes iniqui, quae ignorabam, interrogabant me;"
,"12":"retribuebant mihi mala pro bonis, desolatio est animae meae."
,"13":"Ego autem, cum infirmarentur, induebar cilicio, humiliabam in ieiunio animam meam; et oratio mea in sinu meo convertebatur."
,"14":"Quasi pro proximo et quasi pro fratre meo ambulabam, quasi lugens matrem contristatus incurvabar."
,"15":"Cum autem vacillarem, laetati sunt et convenerunt; convenerunt contra me percutientes, et ignoravi."
,"16":"Diripuerunt et non desistebant; tentaverunt me, subsannaverunt me subsannatione, frenduerunt super me dentibus suis."
,"17":"Domine, quamdiu aspicies?,Restitue animam meam a malignitate eorum, a leonibus unicam meam."
,"18":"Confitebor tibi in ecclesia magna, in populo multo laudabo te."
,"19":"Non supergaudeant mihi inimici mei mendaces, qui oderunt me gratis et annuunt oculis."
,"20":"Etenim non pacifice loquebantur,et contra mansuetos terrae dolos cogitabant."
,"21":"Et dilataverunt super me os suum; dixerunt: ' Euge, euge, viderunt oculi nostri '. -"
,"22":"Vidisti, Domine, ne sileas; Domine, ne discedas a me."
,"23":"Exsurge et evigila ad iudicium meum, Deus meus et Dominus meus, ad causam meam."
,"24":"Iudica me secundum iustitiam tuam, Domine Deus meus, et non supergaudeant mihi."
,"25":"Non dicant in cordibus suis: ' Euge animae nostrae '; nec dicant: ' Devoravimus eum '."
,"26":"Erubescant et revereantur simul, qui gratulantur malis meis; induantur confusione et reverentia, qui magna loquuntur super me"
,"27":"Exsultent et laetentur, qui volunt iustitiam meam, et dicant semper: ' Magnificetur Dominus, qui vult pacem servi sui '."
,"28":"Et lingua mea meditabitur iustitiam tuam, tota die laudem tuam."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Magistro chori. David, servi Domini."
,"2":"Susurrat iniquitas ad impium in medio cordis eius; non est timor Dei ante oculos eius."
,"3":"Quoniam blanditur ipsi in conspectu eius, ut non inveniat iniquitatem suam et oderit."
,"4":"Verba oris eius iniquitas et dolus, desiit intellegere, ut bene ageret."
,"5":"Iniquitatem meditatus est in cubili suo, astitit omni viae non bonae, malitiam autem non odivit."
,"6":"Domine, in caelo misericordia tua, et veritas tua usque ad nubes;"
,"7":"iustitia tua sicut montes Dei, iudicia tua abyssus multa: homines et iumenta salvabis, Domine."
,"8":"Quam pretiosa misericordia tua, Deus!,Filii autem hominum in tegmine alarum tuarum sperabunt;"
,"9":"inebriabuntur ab ubertate domus tuae, et torrente voluptatis tuae potabis eos."
,"10":"Quoniam apud te est fons vitae, et in lumine tuo videbimus lumen."
,"11":"Praetende misericordiam tuam scientibus te,et iustitiam tuam his, qui recto sunt corde."
,"12":"Non veniat mihi pes superbiae, et manus peccatoris non moveat me."
,"13":"Ibi ceciderunt, qui operantur iniquitatem, expulsi sunt nec potuerunt stare."
}`)
	CurrentBook.AddChapter(37, `{
"1":"David. ALEPH. Noli aemulari in malignantibus,neque zelaveris facientes iniquitatem,"
,"2":"quoniam tamquam fenum velociter arescent,et quemadmodum herba virens decident."
,"3":"BETH. Spera in Domino et fac bonitatem, et inhabitabis terram et pasceris in fide."
,"4":"Delectare in Domino, et dabit tibi petitiones cordis tui."
,"5":"GHIMEL. Committe Domino viam tuam et spera in eo, et ipse faciet;"
,"6":"et educet quasi lumen iustitiam tuam,et iudicium tuum tamquam meridiem."
,"7":"DALETH. Quiesce in Domino et exspecta eum; noli aemulari in eo, qui prosperatur in via sua, in homine, qui molitur insidias."
,"8":"HE. Desine ab ira et derelinque furorem, noli aemulari, quod vertit ad malum,"
,"9":"quoniam qui malignantur, exterminabuntur, sustinentes autem Dominum ipsi hereditabunt terram."
,"10":"VAU. Et adhuc pusillum et non erit peccator, et quaeres locum eius et non invenies."
,"11":"Mansueti autem hereditabunt terram,et delectabuntur in multitudine pacis."
,"12":"ZAIN. Insidiabitur peccator iusto,et stridebit super eum dentibus suis."
,"13":"Dominus autem irridebit eum, quoniam prospicit quod veniet dies eius."
,"14":"HETH. Gladium evaginaverunt peccatores, intenderunt arcum suum, ut deiciant pauperem et inopem, ut trucident recte ambulantes in via."
,"15":"Gladius eorum intrabit in corda ipsorum, et arcus eorum confringetur."
,"16":"TETH. Melius est modicum iusto,super divitias peccatorum multas,"
,"17":"quoniam brachia peccatorum conterentur, confirmat autem iustos Dominus."
,"18":"IOD. Novit Dominus dies immaculatorum, et hereditas eorum in aeternum erit."
,"19":"Non confundentur in tempore malo,et in diebus famis saturabuntur."
,"20":"CAPH. Quia peccatores peribunt, inimici vero Domini ut decor camporum deficient, quemadmodum fumus deficient."
,"21":"LAMED. Mutuatur peccator et non solvet, iustus autem miseretur et tribuet."
,"22":"Quia benedicti eius hereditabunt terram, maledicti autem eius exterminabuntur."
,"23":"MEM. A Domino gressus hominis confirmantur, et viam eius volet."
,"24":"Cum ceciderit, non collidetur, quia Dominus sustentat manum eius."
,"25":"NUN. Iunior fui et senui,et non vidi iustum derelictum,nec semen eius quaerens panem."
,"26":"Tota die miseretur et commodat, et semen illius in benedictione erit."
,"27":"SAMECH. Declina a malo et fac bonum, et inhabitabis in saeculum saeculi,"
,"28":"quia Dominus amat iudicium,et non derelinquet sanctos suos. AIN. Iniusti in aeternum disperibunt, et semen impiorum exterminabitur."
,"29":"Iusti autem hereditabunt terram,et inhabitabunt in saeculum saeculi super eam."
,"30":"PHE. Os iusti meditabitur sapientiam, et lingua eius loquetur iudicium;"
,"31":"lex Dei eius in corde ipsius, et non vacillabunt gressus eius."
,"32":"SADE. Considerat peccator iustum,et quaerit mortificare eum;"
,"33":"Dominus autem non derelinquet eum in manibus eius,nec damnabit eum, cum iudicabitur illi."
,"34":"COPH. Exspecta Dominum et custodi viam eius, et exaltabit te, ut hereditate capias terram; cum exterminabuntur peccatores, videbis."
,"35":"RES. Vidi impium superexaltatum,et elevatum sicut cedrum virentem;"
,"36":"et transivi, et ecce non erat, et quaesivi eum, et non est inventus."
,"37":"SIN. Observa innocentiam et vide aequitatem, quoniam est posteritas homini pacifico."
,"38":"Iniusti autem disperibunt simul, posteritas impiorum exterminabitur."
,"39":"TAU. Salus autem iustorum a Domino, et protector eorum in tempore tribulationis."
,"40":"Et adiuvabit eos Dominus et liberabit eos,et eruet eos a peccatoribus et salvabit eos, quia speraverunt in eo."
}`)
	CurrentBook.AddChapter(38, `{
"1":"PSALMUS. David. Ad commemorandum."
,"2":"Domine, ne in furore tuo arguas me,neque in ira tua corripias me,"
,"3":"quoniam sagittae tuae infixae sunt mihi, et descendit super me manus tua."
,"4":"Non est sanitas in carne mea a facie indignationis tuae, non est pax ossibus meis a facie peccatorum meorum."
,"5":"Quoniam iniquitates meae supergressae sunt caput meum,et sicut onus grave gravant me nimis. -"
,"6":"Putruerunt et corrupti sunt livores mei,a facie insipientiae meae."
,"7":"Inclinatus sum et incurvatus nimis; tota die contristatus ingrediebar."
,"8":"Quoniam lumbi mei impleti sunt ardoribus, et non est sanitas in carne mea."
,"9":"Afflictus sum et humiliatus sum nimis, rugiebam a gemitu cordis mei."
,"10":"Domine, ante te omne desiderium meum, et gemitus meus a te non est absconditus."
,"11":"Palpitavit cor meum, dereliquit me virtus mea, et lumen oculorum meorum, et ipsum non est mecum."
,"12":"Amici mei et proximi mei,procul a plaga mea steterunt, et propinqui mei de longe steterunt."
,"13":"Et laqueos posuerunt, qui quaerebant animam meam; et, qui requirebant mala mihi, locuti sunt insidias,et dolos tota die meditabantur."
,"14":"Ego autem tamquam surdus non audiebam,et sicut mutus non aperiens os suum;"
,"15":"et factus sum sicut homo non audiens,et non habens in ore suo redargutiones."
,"16":"Quoniam in te, Domine, speravi, tu exaudies, Domine Deus meus."
,"17":"Quia dixi: 'Ne quando supergaudeant mihi; dum commoventur pedes mei, magnificantur super me '."
,"18":"Quoniam ego in lapsum paratus sum, et dolor meus in conspectu meo semper."
,"19":"Quoniam iniquitatem meam annuntiabo,et sollicitus sum de peccato meo."
,"20":"Inimici autem mei vivunt et confirmati sunt; et multiplicati sunt, qui oderunt me inique."
,"21":"Retribuentes mala pro bonis detrahebant mihi, pro eo quod sequebar bonitatem."
,"22":"Ne derelinquas me, Domine; Deus meus, ne discesseris a me."
,"23":"Festina in adiutorium meum, Domine, salus mea."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Magistro chori, Idithun. PSALMUS. David."
,"2":"Dixi: ' Custodiam vias meas, ut non delinquam in lingua mea; ponam ori meo custodiam, donec consistit peccator adversum me '."
,"3":"Tacens obmutui et silui absque ullo bono, et dolor meus renovatus est."
,"4":"Concaluit cor meum intra me, et in meditatione mea exarsit ignis."
,"5":"Locutus sum in lingua mea: ' Notum fac mihi, Domine, finem meum; et numerum dierum meorum quis est, ut sciam quam brevis sit vita mea '."
,"6":"Ecce paucorum palmorum fecisti dies meos, et spatium vitae meae tamquam nihilum ante te. Etenim universa vanitas omnis homo constitutus est."
,"7":"Etenim ut imago pertransit homo. Etenim vanitas est et concitatur; thesaurizat et ignorat quis congregabit ea."
,"8":"Et nunc quae est exspectatio mea, Domine?,Spes mea apud te est."
,"9":"Ab omnibus iniquitatibus meis erue me, opprobrium insipienti ne ponas me."
,"10":"Obmutui et non aperiam os meum, quoniam tu fecisti."
,"11":"Amove a me plagas tuas: ab ictu manus tuae ego defeci."
,"12":"In increpationibus, propter iniquitatem, corripuisti hominem, et tabescere fecisti, sicut tinea, desiderabilia eius. Etenim vanitas omnis homo."
,"13":"Exaudi orationem meam, Domine, et clamorem meum auribus percipe. Ad lacrimas meas ne obsurdescas, quoniam advena ego sum apud te, peregrinus sicut omnes patres mei."
,"14":"Avertere a me, ut refrigerer, priusquam abeam et non sim amplius."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Magistro chori. David. PSALMUS."
,"2":"Exspectans exspectavi Dominum, et intendit mihi."
,"3":"Et exaudivit clamorem meum,et eduxit me de lacu miseriae et de luto faecis; et statuit super petram pedes meos,et firmavit gressus meos."
,"4":"Et immisit in os meum canticum novum, carmen Deo nostro. Videbunt multi et timebunt,et sperabunt in Domino."
,"5":"Beatus vir, qui posuit Dominum spem suam,et non respexit superbos et declinantes in mendacium."
,"6":"Multa fecisti tu, Domine Deus meus, mirabilia tua, et cogitationes tuas pro nobis: non est qui similis sit tibi. Si nuntiare et eloqui voluero, multiplicabuntur super numerum."
,"7":"Sacrificium et oblationem noluisti, aures autem fodisti mihi. Holocaustum et pro peccato non postulasti,"
,"8":"tunc dixi: ' Ecce venio. In volumine libri scriptum est de me."
,"9":"Facere voluntatem tuam, Deus meus, volui; et lex tua in praecordiis meis '."
,"10":"Annuntiavi iustitiam tuam in ecclesia magna; ecce labia mea non prohibebo, Domine, tu scisti."
,"11":"Iustitiam tuam non abscondi in corde meo, veritatem tuam et salutare tuum dixi. Non abscondi misericordiam tuam,et veritatem tuam ab ecclesia magna."
,"12":"Tu autem, Domine, ne prohibeas miserationes tuas a me; misericordia tua et veritas tua semper suscipiant me,"
,"13":"quoniam circumdederunt me mala, quorum non est numerus; comprehenderunt me iniquitates meae, et non potui videre. Multiplicatae sunt super capillos capitis mei, et cor meum dereliquit me."
,"14":"Complaceat tibi, Domine, ut eruas me; Domine, ad adiuvandum me festina."
,"15":"Confundantur et revereantur simul, qui quaerunt animam meam, ut auferant eam. Avertantur retrorsum et erubescant, qui volunt mihi mala."
,"16":"Obstupescant propter confusionem suam, qui dicunt mihi: ' Euge, euge '."
,"17":"Exsultent et laetentur in te omnes quaerentes te; et dicant semper: ' Magnificetur Dominus ', qui diligunt salutare tuum."
,"18":"Ego autem egenus et pauper sum; Dominus sollicitus est mei. Adiutor meus et liberator meus tu es; Deus meus, ne tardaveris."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Magistro chori. PSALMUS. David."
,"2":"Beatus, qui intellegit de egeno; in die mala liberabit eum Dominus."
,"3":"Dominus servabit eum et vivificabit eum,et beatum faciet eum in terra,et non tradet eum in animam inimicorum eius."
,"4":"Dominus opem feret illi super lectum doloris eius; universum stratum eius versabis in infirmitate eius."
,"5":"Ego dixi: ' Domine, miserere mei; sana animam meam, quia peccavi tibi '."
,"6":"Inimici mei dixerunt mala mihi: ' Quando morietur, et peribit nomen eius? '."
,"7":"Et si ingrediebatur, ut visitaret, vana loquebatur; cor eius congregabat iniquitatem sibi, egrediebatur foras et detrahebat."
,"8":"Simul adversum me susurrabant omnes inimici mei; adversum me cogitabant mala mihi:"
,"9":"' Maleficium effusum est in eo; et, qui decumbit, non adiciet ut resurgat '."
,"10":"Sed et homo pacis meae, in quo speravi, qui edebat panem meum, levavit contra me calcaneum."
,"11":"Tu autem, Domine, miserere mei,et resuscita me, et retribuam eis."
,"12":"In hoc cognovi quoniam voluisti me, quia non gaudebit inimicus meus super me;"
,"13":"me autem propter innocentiam suscepisti,et statuisti me in conspectu tuo in aeternum."
,"14":"Benedictus Dominus, Deus Israel, a saeculo et usque in saeculum. Fiat, fiat."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Magistro chori. Maskil. Filiorum Core."
,"2":"Quemadmodum desiderat cervus ad fontes aquarum, ita desiderat anima mea ad te, Deus."
,"3":"Sitivit anima mea ad Deum, Deum vivum; quando veniam et apparebo ante faciem Dei?"
,"4":"Fuerunt mihi lacrimae meae panis die ac nocte, dum dicitur mihi cotidie: ' Ubi est Deus tuus? '."
,"5":"Haec recordatus sum et effudi in me animam meam; quoniam transibam in locum tabernaculi admirabilis,usque ad domum Dei,in voce exsultationis et confessionis,multitudinis festa celebrantis."
,"6":"Quare tristis es, anima mea, et quare conturbaris in me?,Spera in Deo, quoniam adhuc confitebor illi, salutare vultus mei et Deus meus."
,"7":"In meipso anima mea contristata est; propterea memor ero tui,de terra Iordanis et Hermonim, de monte Misar."
,"8":"Abyssus abyssum invocat in voce cataractarum tuarum; omnes gurgites tui et fluctus tui super me transierunt."
,"9":"In die mandavit Dominus misericordiam suam, et nocte canticum eius apud me est: oratio ad Deum vitae meae."
,"10":"Dicam Deo: ' Susceptor meus es. Quare oblitus es mei, et quare contristatus incedo, dum affligit me inimicus? '."
,"11":"Dum confringuntur ossa mea, exprobraverunt mihi, qui tribulant me, dum dicunt mihi quotidie: ' Ubi est Deus tuus? '. -"
,"12":"Quare tristis es, anima mea, et quare conturbaris in me?,Spera in Deo, quoniam adhuc confitebor illi, salutare vultus mei et Deus meus."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Iudica me, Deus, et discerne causam meam de gente non sancta; ab homine iniquo et doloso erue me."
,"2":"Quia tu es Deus refugii mei; quare me reppulisti, et quare tristis incedo, dum affligit me inimicus?"
,"3":"Emitte lucem tuam et veritatem tuam; ipsae me deducant et adducant,in montem sanctum tuum et in tabernacula tua."
,"4":"Et introibo ad altare Dei, ad Deum laetitiae exsultationis meae. Confitebor tibi in cithara, Deus, Deus meus."
,"5":"Quare tristis es, anima mea, et quare conturbaris in me?,Spera in Deo, quoniam adhuc confitebor illi, salutare vultus mei et Deus meus."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Magistro chori. Filiorum Core. Maskil."
,"2":"Deus, auribus nostris audivimus; patres nostri annuntiaverunt nobis,opus, quod operatus es in diebus eorum, in diebus antiquis."
,"3":"Tu manu tua gentes depulisti et plantasti illos, afflixisti populos et dilatasti eos."
,"4":"Nec enim in gladio suo possederunt terram, et brachium eorum non salvavit eos; sed dextera tua et brachium tuum,et illuminatio vultus tui, quoniam complacuisti in eis."
,"5":"Tu es rex meus et Deus meus, qui mandas salutes Iacob."
,"6":"In te inimicos nostros proiecimus, et in nomine tuo conculcavimus insurgentes in nos. -"
,"7":"Non enim in arcu meo sperabo, et gladius meus non salvabit me."
,"8":"Tu autem salvasti nos de affligentibus nos,et odientes nos confudisti."
,"9":"In Deo gloriabimur tota die,et in nomine tuo confitebimur in saeculum."
,"10":"Nunc autem reppulisti et confudisti nos,et non egredieris, Deus, cum virtutibus nostris."
,"11":"Convertisti nos retrorsum coram inimicis nostris; et, qui oderunt nos, diripuerunt sibi."
,"12":"Dedisti nos tamquam oves ad vescendum,et in gentibus dispersisti nos."
,"13":"Vendidisti populum tuum sine lucro,nec ditior factus es in commutatione eorum."
,"14":"Posuisti nos opprobrium vicinis nostris, subsannationem et derisum his, qui sunt in circuitu nostro."
,"15":"Posuisti nos similitudinem in gentibus, commotionem capitis in populis."
,"16":"Tota die verecundia mea contra me est, et confusio faciei meae cooperuit me"
,"17":"a voce exprobrantis et obloquentis, a facie inimici et ultoris."
,"18":"Haec omnia venerunt super nos, nec obliti sumus te,et inique non egimus in testamentum tuum."
,"19":"Et non recessit retro cor nostrum, nec declinaverunt gressus nostri a via tua;"
,"20":"sed humiliasti nos in loco vulpium,et operuisti nos umbra mortis."
,"21":"Si obliti fuerimus nomen Dei nostri,et si expanderimus manus nostras ad deum alienum,"
,"22":"nonne Deus requiret ista?,Ipse enim novit abscondita cordis."
,"23":"Quoniam propter te mortificamur tota die, aestimati sumus sicut oves occisionis."
,"24":"Evigila, quare obdormis, Domine?,Exsurge et ne repellas in finem."
,"25":"Quare faciem tuam avertis, oblivisceris inopiae nostrae et tribulationis nostrae?"
,"26":"Quoniam humiliata est in pulvere anima nostra, conglutinatus est in terra venter noster. Exsurge, Domine, adiuva nos,et redime nos propter misericordiam tuam."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Magistro chori. Secundum ' Lilia... '. Filiorum Core. Maskil. Canticum amoris."
,"2":"Eructavit cor meum verbum bonum, dico ego opera mea regi. Lingua mea calamus scribae velociter scribentis."
,"3":"Speciosus forma es prae filiis hominum, diffusa est gratia in labiis tuis, propterea benedixit te Deus in aeternum."
,"4":"Accingere gladio tuo super femur tuum, potentissime, magnificentia tua et ornatu tuo."
,"5":"Et ornatu tuo procede, currum ascende,propter veritatem et mansuetudinem et iustitiam. Et doceat te mirabilia dextera tua:"
,"6":"sagittae tuae acutae,- populi sub te cadent -,in corda inimicorum regis."
,"7":"Sedes tua, Deus, in saeculum saeculi; sceptrum aequitatis sceptrum regni tui."
,"8":"Dilexisti iustitiam et odisti iniquitatem, propterea unxit te Deus, Deus tuus, oleo laetitiae prae consortibus tuis."
,"9":"Myrrha et aloe et casia omnia vestimenta tua; e domibus eburneis chordae delectant te."
,"10":"Filiae regum in pretiosis tuis; astitit regina a dextris tuis ornata auro ex Ophir. -"
,"11":"Audi, filia, et vide et inclina aurem tuam,et obliviscere populum tuum et domum patris tui;"
,"12":"et concupiscet rex speciem tuam. Quoniam ipse est dominus tuus, et adora eum."
,"13":"Filia Tyri cum muneribus; vultum tuum deprecabuntur divites plebis."
,"14":"Gloriosa nimis filia regis intrinsecus, texturis aureis circumamicta."
,"15":"In vestibus variegatis adducetur regi; virgines post eam, proximae eius, afferuntur tibi."
,"16":"Afferuntur in laetitia et exsultatione, adducuntur in domum regis."
,"17":"Pro patribus tuis erunt tibi filii; constitues eos principes super omnem terram."
,"18":"Memor ero nominis tui,in omni generatione et generatione; propterea populi confitebuntur tibi in aeternum,et in saeculum saeculi."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Magistro chori. Filiorum Core. Secundum ' Virgines... '. Canticum."
,"2":"Deus est nobis refugium et virtus, adiutorium in tribulationibus inventus est nimis."
,"3":"Propterea non timebimus, dum turbabitur terra, et transferentur montes in cor maris."
,"4":"Fremant et intumescant aquae eius, conturbentur montes in elatione eius."
,"5":"Fluminis rivi laetificant civitatem Dei, sancta tabernacula Altissimi."
,"6":"Deus in medio eius, non commovebitur; adiuvabit eam Deus mane diluculo."
,"7":"Fremuerunt gentes, commota sunt regna; dedit vocem suam, liquefacta est terra."
,"8":"Dominus virtutum nobiscum, refugium nobis Deus Iacob."
,"9":"Venite et videte opera Domini, quae posuit prodigia super terram. Auferet bella usque ad finem terrae,"
,"10":"arcum conteret et confringet arma,et scuta comburet igne."
,"11":"Vacate et videte quoniam ego sum Deus: exaltabor in gentibus et exaltabor in terra."
,"12":"Dominus virtutum nobiscum, refugium nobis Deus Iacob."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Magistro chori. Filiorum Core. PSALMUS."
,"2":"Omnes gentes, plaudite manibus, iubilate Deo in voce exsultationis,"
,"3":"quoniam Dominus Altissimus, terribilis, rex magnus super omnem terram."
,"4":"Subiecit populos nobis,et gentes sub pedibus nostris."
,"5":"Elegit nobis hereditatem nostram, gloriam Iacob, quem dilexit."
,"6":"Ascendit Deus in iubilo, et Dominus in voce tubae."
,"7":"Psallite Deo, psallite; psallite regi nostro, psallite."
,"8":"Quoniam rex omnis terrae Deus, psallite sapienter."
,"9":"Regnavit Deus super gentes, Deus sedet super sedem sanctam suam."
,"10":"Principes populorum congregati sunt,cum populo Dei Abraham, quoniam Dei sunt scuta terrae: vehementer elevatus est."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Canticum. PSALMUS. Filiorum Core."
,"2":"Magnus Dominus et laudabilis nimis,in civitate Dei nostri."
,"3":"Mons sanctus eius collis speciosus, exsultatio universae terrae. Mons Sion, extrema aquilonis, civitas regis magni."
,"4":"Deus in domibus eius notus,factus est ut refugium."
,"5":"Quoniam ecce reges congregati sunt, convenerunt in unum."
,"6":"Ipsi cum viderunt, sic admirati sunt, conturbati sunt, diffugerunt;"
,"7":"illic tremor apprehendit eos, dolores ut parturientis."
,"8":"In spiritu orientis,conteres naves Tharsis."
,"9":"Sicut audivimus, sic vidimus,in civitate Domini virtutum, in civitate Dei nostri; Deus fundavit eam in aeternum."
,"10":"Recogitamus, Deus, misericordiam tuam,in medio templi tui."
,"11":"Secundum nomen tuum, Deus, sic et laus tua in fines terrae; iustitia plena est dextera tua."
,"12":"Laetetur mons Sion, et exsultent filiae Iudae,propter iudicia tua."
,"13":"Circumdate Sion et complectimini eam, numerate turres eius."
,"14":"Ponite corda vestra in virtute eius,et percurrite domos eius, ut enarretis in progenie altera."
,"15":"Quoniam hic est Deus, Deus noster,in aeternum et in saeculum saeculi; ipse ducet nos in saecula."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Magistro chori. Filiorum Core. PSALMUS."
,"2":"Audite haec, omnes gentes; auribus percipite, omnes, qui habitatis orbem:"
,"3":"quique humiles et viri nobiles, simul in unum dives et pauper!"
,"4":"Os meum loquetur sapientiam, et meditatio cordis mei prudentiam."
,"5":"Inclinabo in parabolam aurem meam, aperiam in psalterio aenigma meum."
,"6":"Cur timebo in diebus malis, cum iniquitas supplantantium circumdabit me?"
,"7":"Qui confidunt in virtute sua,et in multitudine divitiarum suarum gloriantur."
,"8":"Etenim seipsum non redimet homo; non dabit Deo propitiationem suam."
,"9":"Nimium est pretium redemptionis animae eius: ad ultimum deficiet,"
,"10":"ut vivat usque in finem nec videat interitum."
,"11":"Et videbit sapientes morientes; simul insipiens et stultus peribunt,et relinquent alienis divitias suas."
,"12":"Sepulcra eorum domus illorum in aeternum; tabernacula eorum in progeniem et progeniem, etsi vocaverunt nominibus suis terras suas."
,"13":"Et homo, cum sit in honore, non permanebit; comparatus est iumentis, quae pereunt, et similis factus est illis."
,"14":"Haec via illorum, quorum fiducia in semetipsis, et finis eorum, qui complacent in ore suo."
,"15":"Sicut oves in inferno positi sunt, mors depascet eos; descendent praecipites ad sepulcrum, et figura eorum erit in consumptionem: infernus habitaculum eorum."
,"16":"Verumtamen Deus redimet animam meam, de manu inferi vere suscipiet me."
,"17":"Ne timueris, cum dives factus fuerit homo, et cum multiplicata fuerit gloria domus eius,"
,"18":"quoniam, cum interierit, non sumet omnia, neque descendet cum eo gloria eius."
,"19":"Cum animae suae in vita ipsius benedixerit: ' Laudabunt te quod benefecisti tibi ',"
,"20":"tamen introibit ad progeniem patrum suorum, qui in aeternum non videbunt lumen."
,"21":"Homo, cum in honore esset, non intellexit; comparatus est iumentis, quae pereunt, et similis factus est illis."
}`)
	CurrentBook.AddChapter(50, `{
"1":"PSALMUS. Asaph. Deus deorum, Dominus, locutus est,et vocavit terram a solis ortu usque ad occasum."
,"2":"Ex Sion speciosa decore Deus illuxit,"
,"3":"Deus noster veniet et non silebit: ignis consumens est in conspectu eius, et in circuitu eius tempestas valida."
,"4":"Advocabit caelum desursum,et terram discernere populum suum:"
,"5":"' Congregate mihi sanctos meos, qui disposuerunt testamentum meum in sacrificio '."
,"6":"Et annuntiabunt caeli iustitiam eius, quoniam Deus iudex est."
,"7":"' Audi, populus meus, et loquar, Israel, et testificabor adversum te: Deus, Deus tuus, ego sum."
,"8":"Non in sacrificiis tuis arguam te; holocausta enim tua in conspectu meo sunt semper."
,"9":"Non accipiam de domo tua vitulos,neque de gregibus tuis hircos."
,"10":"Quoniam meae sunt omnes ferae silvarum, iumentorum mille in montibus."
,"11":"Cognovi omnia volatilia caeli; et, quod movetur in agro, meum est."
,"12":"Si esuriero non dicam tibi; meus est enim orbis terrae et plenitudo eius."
,"13":"Numquid manducabo carnes taurorum,aut sanguinem hircorum potabo?"
,"14":"Immola Deo sacrificium laudis,et redde Altissimo vota tua;"
,"15":"et invoca me in die tribulationis: eruam te, et honorificabis me '."
,"16":"Peccatori autem dixit Deus: ' Quare tu enarras praecepta mea,et assumis testamentum meum in os tuum?"
,"17":"Tu vero odisti disciplinam,et proiecisti sermones meos retrorsum."
,"18":"Si videbas furem, currebas cum eo; et cum adulteris erat portio tua."
,"19":"Os tuum dimittebas ad malitiam, et lingua tua concinnabat dolos."
,"20":"Sedens adversus fratrem tuum loquebaris,et adversus filium matris tuae proferebas opprobrium."
,"21":"Haec fecisti, et tacui. Existimasti quod eram tui similis. Arguam te et statuam illa contra faciem tuam."
,"22":"Intellegite haec, qui obliviscimini Deum, ne quando rapiam, et non sit qui eripiat."
,"23":"Qui immolabit sacrificium laudis, honorificabit me; et, qui immaculatus est in via, ostendam illi salutare Dei '."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Magistro chori. PSALMUS. David,"
,"2":"cum venit ad eum Nathan propheta, postquam cum Bethsabee peccavit."
,"3":"Miserere mei, Deus, secundum misericordiam tuam; et secundum multitudinem miserationum tuarum,dele iniquitatem meam."
,"4":"Amplius lava me ab iniquitate mea,et a peccato meo munda me."
,"5":"Quoniam iniquitatem meam ego cognosco, et peccatum meum contra me est semper."
,"6":"Tibi, tibi soli peccavi et malum coram te feci, ut iustus inveniaris in sententia tua et aequus in iudicio tuo."
,"7":"Ecce enim in iniquitate generatus sum, et in peccato concepit me mater mea."
,"8":"Ecce enim veritatem in corde dilexisti,et in occulto sapientiam manifestasti mihi."
,"9":"Asperges me hyssopo, et mundabor; lavabis me, et super nivem dealbabor."
,"10":"Audire me facies gaudium et laetitiam, et exsultabunt ossa, quae contrivisti."
,"11":"Averte faciem tuam a peccatis meis,et omnes iniquitates meas dele."
,"12":"Cor mundum crea in me, Deus, et spiritum firmum innova in visceribus meis."
,"13":"Ne proicias me a facie tua,et spiritum sanctum tuum ne auferas a me."
,"14":"Redde mihi laetitiam salutaris tui,et spiritu promptissimo confirma me."
,"15":"Docebo iniquos vias tuas, et impii ad te convertentur."
,"16":"Libera me de sanguinibus, Deus, Deus salutis meae, et exsultabit lingua mea iustitiam tuam."
,"17":"Domine, labia mea aperies, et os meum annuntiabit laudem tuam."
,"18":"Non enim sacrificio delectaris; holocaustum, si offeram, non placebit."
,"19":"Sacrificium Deo spiritus contribulatus; cor contritum et humiliatum, Deus, non despicies."
,"20":"Benigne fac, Domine, in bona voluntate tua Sion, ut aedificentur muri Ierusalem."
,"21":"Tunc acceptabis sacrificium iustitiae, oblationes et holocausta; tunc imponent super altare tuum vitulos."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Magistro chori. Maskil. David,"
,"2":"postquam Doeg Edomita ad Saul venit,eique narravit dicens: ' David intravit in domum Abimelech '."
,"3":"Quid gloriaris in malitia, qui potens es iniquitate?"
,"4":"Tota die insidias cogitasti; lingua tua sicut novacula acuta, qui facis dolum."
,"5":"Dilexisti malitiam super benignitatem, mendacium magis quam loqui aequitatem."
,"6":"Dilexisti omnia verba perditionis, lingua dolosa."
,"7":"Propterea Deus destruet te in finem; evellet te et emigrabit te de tabernaculo,et radicem tuam de terra viventium."
,"8":"Videbunt iusti et timebunt,et super eum ridebunt:"
,"9":"' Ecce homo, qui non posuit Deum refugium suum, sed speravit in multitudine divitiarum suarum,et praevaluit in insidiis suis '."
,"10":"Ego autem sicut virens oliva in domo Dei. Speravi in misericordia Dei,in aeternum et in saeculum saeculi."
,"11":"Confitebor tibi in saeculum, quia fecisti; et exspectabo nomen tuum, quoniam bonum est, in conspectu sanctorum tuorum."
}`)
	CurrentBook.AddChapter(53, `{
"1":"Magistro chori. Secundum ' Mahalat '. Maskil. David. Dixit insipiens in corde suo: ' Non est Deus '."
,"2":"Corrupti sunt et abominationes operati sunt; non est qui faciat bonum."
,"3":"Deus de caelo prospexit super filios hominum, ut videat si est intellegens, aut requirens Deum."
,"4":"Omnes declinaverunt, simul corrupti sunt; non est qui faciat bonum, non est usque ad unum."
,"5":"Nonne scient omnes, qui operantur iniquitatem, qui devorant plebem meam ut cibum panis?,Deum non invocaverunt;"
,"6":"illic trepidaverunt timore, et non erat timor. Quoniam Deus dissipavit ossa eorum, qui te obsidebant, confusi sunt, quoniam Deus sprevit eos. -"
,"7":"Quis dabit ex Sion salutare Israel?,Cum converterit Deus captivitatem plebis suae, exsultabit Iacob, et laetabitur Israel."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Magistro chori. Fidibus. Maskil. David,"
,"2":"postquam Ziphaei ad Saul venerunt dicentes: ' Ecce David apud nos abditus latet '."
,"3":"Deus, in nomine tuo salvum me fac,et in virtute tua iudica me."
,"4":"Deus, exaudi orationem meam, auribus percipe verba oris mei!"
,"5":"Quoniam superbi insurrexerunt adversum me, et fortes quaesierunt animam meam,et non proposuerunt Deum ante conspectum suum."
,"6":"Ecce enim Deus adiuvat me, et Dominus susceptor est animae meae."
,"7":"Converte mala super inimicos meos et in veritate tua disperde illos."
,"8":"Voluntarie sacrificabo tibi, confitebor nomini tuo, Domine, quoniam bonum est;"
,"9":"quoniam ex omni tribulatione eripuit me, et super inimicos meos despexit oculus meus."
}`)
	CurrentBook.AddChapter(55, `{
"1":"Magistro chori. Fidibus. Maskil. David."
,"2":"Auribus percipe, Deus, orationem meam,et ne abscondaris a deprecatione mea;"
,"3":"intende mihi et exaudi me. Excussus sum in meditatione mea et conturbatus sum"
,"4":"a voce inimici et a tribulatione peccatoris. Quoniam devolverunt in me iniquitatem,et in ira molesti erant mihi."
,"5":"Cor meum torquetur intra me, et formido mortis cecidit super me."
,"6":"Timor et tremor venerunt super me, et contexit me pavor. -"
,"7":"Et dixi: ' Quis dabit mihi pennas sicut columbae, et volabo et requiescam?"
,"8":"Ecce elongabo fugiens,et manebo in solitudine."
,"9":"Exspectabo eum, qui salvum me faciat,a spiritu procellae et tempestate '."
,"10":"Dissipa, Domine, divide linguas eorum, quoniam vidi violentiam et contentionem in civitate."
,"11":"Die ac nocte circumeunt eam super muros eius,"
,"12":"iniquitas et labor et insidiae in medio eius; et non defecit de plateis eius fraudulentia et dolus."
,"13":"Quoniam si inimicus meus maledixisset mihi, sustinuissem utique; et si is qui oderat me, super me magnificatus fuisset, abscondissem me forsitan ab eo."
,"14":"Tu vero, homo coaequalis meus, familiaris meus et notus meus,"
,"15":"qui simul habuimus dulce consortium: in domo Dei ambulavimus in concursu."
,"16":"Veniat mors super illos, et descendant in infernum viventes, quoniam nequitiae in habitaculis eorum, in medio eorum."
,"17":"Ego autem ad Deum clamabo, et Dominus salvabit me."
,"18":"Vespere et mane et meridie meditabor et ingemiscam, et exaudiet vocem meam."
,"19":"Redimet in pace animam meam ab his, qui impugnant me, quoniam in multis sunt adversum me."
,"20":"Exaudiet Deus et humiliabit illos, qui est ante saecula. Non enim est illis commutatio, et non timuerunt Deum."
,"21":"Extendit manum suam in socios; contaminavit foedus suum."
,"22":"Lene super butyrum est os eius, pugna autem cor illius: molliti sunt sermones eius super oleum, et ipsi sunt gladii destricti. -"
,"23":"Iacta super Dominum curam tuam, et ipse te enutriet; non dabit in aeternum fluctuationem iusto."
,"24":"Tu vero, Deus, deduces eos in puteum interitus. Viri sanguinum et dolosi non dimidiabunt dies suos; ego autem sperabo in te, Domine."
}`)
	CurrentBook.AddChapter(56, `{
"1":"Magistro chori. Secundum ' Ionat elem rehoqim '. David. Miktam. Cum Gath Philistaei eum tenerent."
,"2":"Miserere mei, Deus, quoniam conculcavit me homo, tota die impugnans oppressit me."
,"3":"Conculcaverunt me inimici mei tota die, quoniam multi pugnant adversum me, Altissime."
,"4":"In quacumque die timebo, ego in te sperabo."
,"5":"In Deo, cuius laudabo sermonem, in Deo speravi; non timebo: quid faciet mihi caro?"
,"6":"Tota die rem meam perturbabant, adversum me omnes cogitationes eorum in malum."
,"7":"Concitabant iurgia, insidiabantur, ipsi calcaneum meum observabant. Sicut quaesierunt animam meam,"
,"8":"ita pro iniquitate retribue illis, in ira populos prosterne, Deus."
,"9":"Peregrinationes meas tu numerasti: pone lacrimas meas in utre tuo; nonne in supputatione tua?"
,"10":"Tunc convertentur inimici mei retrorsum, in quacumque die invocavero: ecce cognovi quoniam Deus meus es."
,"11":"In Deo, cuius laudabo sermonem, in Domino, cuius laudabo sermonem,"
,"12":"in Deo speravi; non timebo: quid faciet mihi homo?"
,"13":"Super me sunt, Deus, vota tua; reddam laudationes tibi,"
,"14":"quoniam eripuisti animam meam de morte,et pedes meos de lapsu, ut ambulem coram Deo in lumine viventium."
}`)
	CurrentBook.AddChapter(57, `{
"1":"Magistro chori. Secundum ' Ne destruxeris '. David. Miktam. Quando a Saul in cavernam fugit."
,"2":"Miserere mei, Deus, miserere mei, quoniam in te confugit anima mea; et in umbra alarum tuarum confugiam, donec transeant insidiae."
,"3":"Clamabo ad Deum Altissimum, Deum, qui benefecit mihi."
,"4":"Mittet de caelo et liberabit me; dabit in opprobrium conculcantes me. Mittet Deus misericordiam suam et veritatem suam."
,"5":"Anima mea recumbit in medio catulorum leonum,devorantium filios hominum. Dentes eorum arma et sagittae, et lingua eorum gladius acutus."
,"6":"Exaltare super caelos, Deus, super omnem terram gloria tua."
,"7":"Laqueum paraverunt pedibus meis, et incurvavit se anima mea; foderunt ante faciem meam foveam, et ipsi inciderunt in eam."
,"8":"Paratum cor meum, Deus, paratum cor meum;"
,"9":"cantabo et psalmum dicam. Exsurge, gloria mea; exsurge, psalterium et cithara, excitabo auroram."
,"10":"Confitebor tibi in populis, Domine, et psalmum dicam tibi in nationibus,"
,"11":"quoniam magnificata est usque ad caelos misericordia tua, et usque ad nubes veritas tua."
,"12":"Exaltare super caelos, Deus, super omnem terram gloria tua."
}`)
	CurrentBook.AddChapter(58, `{
"1":"Magistro chori. Secundum ' Ne destruxeris '. David. Miktam."
,"2":"Numquid vere, potentes, iustitiam loquimini, recte iudicatis filios hominum?"
,"3":"Etenim in corde iniquitates operamini, in terra violentiam manus vestrae concinnant."
,"4":"Alienati sunt peccatores ab utero; erraverunt a ventre, qui loquuntur falsa."
,"5":"Venenum illis in similitudinem serpentis, sicut aspidis surdae et obturantis aures suas,"
,"6":"quae non exaudiet vocem incantantium,et venefici incantantis sapienter."
,"7":"Deus, contere dentes eorum in ore ipsorum; molas leonum confringe, Domine."
,"8":"Diffluant tamquam aqua decurrens, sicut fenum conculcatum arescant."
,"9":"Sicut limax, quae tabescens transit, sicut abortivum mulieris, quod non vidit solem."
,"10":"Priusquam sentiant ollae vestrae rhamnum, sicut viventes, sicut ardor irae absorbet eos."
,"11":"Laetabitur iustus, cum viderit vindictam, pedes suos lavabit in sanguine peccatoris."
,"12":"Et dicet homo: ' Utique est fructus iusto, utique est Deus iudicans eos in terra '."
}`)
	CurrentBook.AddChapter(59, `{
"1":"Magistro chori. Secundum ' Ne destruxeris '. David. Miktam. Quando Saul viros misit, qui domum observarent et eum occiderent."
,"2":"Eripe me de inimicis meis, Deus meus, et ab insurgentibus in me protege me."
,"3":"Eripe me de operantibus iniquitatem,et de viris sanguinum salva me."
,"4":"Quia ecce insidiati sunt animae meae, irruerunt in me fortes."
,"5":"Neque delictum neque peccatum in me est, Domine; sine iniquitate mea currunt et praeparantur. Exsurge in occursum meum et vide;"
,"6":"et tu, Domine, Deus virtutum, Deus Israel, evigila ad visitandas omnes gentes; non miserearis omnibus, qui infideliter operantur."
,"7":"Revertentur ad vesperam et latrabunt ut canes,et circuibunt civitatem."
,"8":"Ecce eructabunt ore suo, et gladius in labiis eorum: ' Quis enim audit? '."
,"9":"Et tu, Domine, deridebis eos, subsannabis omnes gentes."
,"10":"Fortitudo mea, tibi attendam, quia, Deus, praesidium meum es."
,"11":"Deus meus, misericordia eius praeveniet me. Deus faciet, ut despiciam inimicos meos."
,"12":"Ne occidas eos, ne quando obliviscatur populus meus; disperge illos in virtute tua,et prosterne eos, protector meus, Domine."
,"13":"Peccatum oris eorum, sermo labiorum ipsorum, et comprehendantur in superbia sua. Propter exsecrationem et mendacium, quod loquuntur,"
,"14":"consume eos in furore, consume, et non erunt; et scient quia Deus dominabitur Iacob et finium terrae."
,"15":"Revertentur ad vesperam et latrabunt ut canes,et circuibunt civitatem."
,"16":"Ipsi errabunt ad manducandum; si vero non fuerint saturati, murmurabunt."
,"17":"Ego autem cantabo fortitudinem tuam,et exsultabo mane misericordiam tuam, quia factus es praesidium meum,et refugium meum in die tribulationis meae."
,"18":"Fortitudo mea, tibi psallam, quia, Deus, praesidium meum es: Deus meus misericordia mea."
}`)
	CurrentBook.AddChapter(60, `{
"1":"Magistro chori. Secundum ' Lilium praecepti '. Miktam. David. Ad docendum."
,"2":"Quando contra Aram Naharaim et Aram Soba egressus est, et quando Ioab reversus devicit Edom in valle Salis: duodecim milia (hominum)."
,"3":"Deus, reppulisti nos, destruxisti nos. Iratus es. Convertere ad nos!"
,"4":"Concussisti terram, confregisti eam; sana contritiones eius, quia commota est."
,"5":"Ostendisti populo tuo dura, potasti nos vino vertiginis."
,"6":"Dedisti metuentibus te signum, ut fugiant a facie arcus."
,"7":"Ut liberentur dilecti tui, salvos fac dextera tua et exaudi nos."
,"8":"Deus locutus est in sancto suo: ' Laetabor et partibor Sichimam,et convallem Succoth metibor."
,"9":"Meus est Galaad, et meus est Manasses, et Ephraim fortitudo capitis mei. Iuda sceptrum meum,"
,"10":"Moab olla lavacri mei. Super Idumaeam extendam calceamentum meum, super Philistaeam vociferabor '."
,"11":"Quis adducet me in civitatem munitam?,Quis deducet me usque in Idumaeam?"
,"12":"Nonne tu, Deus, qui reppulisti nos; et non egredieris, Deus, in virtutibus nostris?,Da nobis auxilium de tribulatione, quia vana salus hominis."
,"13":"In Deo faciemus virtutem, et ipse conculcabit tribulantes nos."
}`)
	CurrentBook.AddChapter(61, `{
"1":"Magistro chori. Fidibus. David."
,"2":"Exaudi, Deus, deprecationem meam, intende orationi meae."
,"3":"A finibus terrae ad te clamavi, dum anxiaretur cor meum. In petram inaccessam mihi deduc me!"
,"4":"Quia factus es spes mea, turris fortitudinis a facie inimici."
,"5":"Inhabitabo in tabernaculo tuo in saecula, protegar in velamento alarum tuarum,"
,"6":"quoniam tu, Deus meus, exaudisti vota mea, dedisti hereditatem timentium nomen tuum."
,"7":"Dies super dies regis adicies, annos eius usque in diem generationis et generationis."
,"8":"Sedeat in aeternum in conspectu Dei; misericordia et veritas servent eum."
,"9":"Sic psalmum dicam nomini tuo in saeculum saeculi, ut reddam vota mea de die in diem."
}`)
	CurrentBook.AddChapter(62, `{
"1":"Magistro chori. Secundum Iduthun. PSALMUS. David."
,"2":"In Deo tantum quiesce, anima mea, ab ipso enim salutare meum."
,"3":"Verumtamen ipse refugium meum et salutare meum, praesidium meum; non movebor amplius."
,"4":"Quousque irruitis in hominem, contunditis universi vos,tamquam parietem inclinatum et maceriam depulsam?"
,"5":"Verumtamen de excelso suo cogitaverunt depellere; delectabantur mendacio. Ore suo benedicebant et corde suo maledicebant."
,"6":"In Deo tantum quiesce, anima mea, quoniam ab ipso patientia mea."
,"7":"Verumtamen ipse Deus meus et salutare meum, praesidium meum; non movebor."
,"8":"In Deo salutare meum et gloria mea; Deus fortitudinis meae, et refugium meum in Deo est."
,"9":"Sperate in eo, omnis congregatio populi, effundite coram illo corda vestra; Deus refugium nobis."
,"10":"Verumtamen vanitas filii Adam, mendacium filii hominum. In stateram si conscendant, super fumum leves sunt omnes."
,"11":"Nolite sperare in violentia,et in rapina nolite decipi; divitiae si affluant, nolite cor apponere."
,"12":"Semel locutus est Deus, duo haec audivi: quia potestas Deo est,"
,"13":"et tibi, Domine, misericordia; quia tu reddes unicuique iuxta opera sua."
}`)
	CurrentBook.AddChapter(63, `{
"1":"PSALMUS. David, cum in deserto Iudae commoraretur."
,"2":"Deus, Deus meus es tu, ad te de luce vigilo. Sitivit in te anima mea, te desideravit caro mea. In terra deserta et arida et inaquosa,"
,"3":"sic in sancto apparui tibi, ut viderem virtutem tuam et gloriam tuam."
,"4":"Quoniam melior est misericordia tua super vitas, labia mea laudabunt te."
,"5":"Sic benedicam te in vita mea,et in nomine tuo levabo manus meas."
,"6":"Sicut adipe et pinguedine repleatur anima mea, et labiis exsultationis laudabit os meum."
,"7":"Cum memor ero tui super stratum meum, in matutinis meditabor de te,"
,"8":"quia fuisti adiutor meus, et in velamento alarum tuarum exsultabo."
,"9":"Adhaesit anima mea post te, me suscepit dextera tua."
,"10":"Ipsi vero in ruinam quaesierunt animam meam, introibunt in inferiora terrae,"
,"11":"tradentur in potestatem gladii, partes vulpium erunt."
,"12":"Rex vero laetabitur in Deo; gloriabuntur omnes, qui iurant in eo, quia obstructum est os loquentium iniqua."
}`)
	CurrentBook.AddChapter(64, `{
"1":"Magistro chori. PSALMUS. David."
,"2":"Exaudi, Deus, vocem meam in meditatione mea; a timore inimici custodi animam meam."
,"3":"Protege me a conventu malignantium, a multitudine operantium iniquitatem."
,"4":"Qui exacuerunt ut gladium linguas suas, intenderunt sagittas suas, venefica verba,"
,"5":"ut sagittent in occultis immaculatum. Subito sagittabunt eum et non timebunt,"
,"6":"firmaverunt sibi consilium nequam. Disputaverunt, ut absconderent laqueos, dixerunt: ' Quis videbit eos? '."
,"7":"Excogitaverunt iniqua, perfecerunt excogitata consilia. Interiora hominis et cor eius abyssus."
,"8":"Et sagittavit illos Deus; subito factae sunt plagae eorum,"
,"9":"et infirmavit eos lingua eorum. Caput movebunt omnes, qui videbunt eos,"
,"10":"et timebit omnis homo; et annuntiabunt opera Dei,et facta eius intellegent."
,"11":"Laetabitur iustus in Domino et sperabit in eo, et gloriabuntur omnes recti corde."
}`)
	CurrentBook.AddChapter(65, `{
"1":"Magistro chori. PSALMUS. David. Canticum."
,"2":"Te decet hymnus, Deus, in Sion; et tibi reddetur votum in Ierusalem."
,"3":"Qui audis orationem, ad te omnis caro veniet propter iniquitatem."
,"4":"Etsi praevaluerunt super nos impietates nostrae, tu propitiaberis eis."
,"5":"Beatus, quem elegisti et assumpsisti; inhabitabit in atriis tuis. Replebimur bonis domus tuae, sanctitate templi tui."
,"6":"Mirabiliter in aequitate,exaudies nos, Deus salutis nostrae, spes omnium finium terrae et maris longinqui."
,"7":"Firmans montes in virtute tua, accinctus potentia."
,"8":"Compescens sonitum maris, sonitum fluctuum eius,et tumultum populorum."
,"9":"Et timebunt, qui habitant terminos terrae, a signis tuis; exitus orientis et occidentis delectabis."
,"10":"Visitasti terram et inebriasti eam; multiplicasti locupletare eam. Flumen Dei repletum est aquis; parasti frumenta illorum, quoniam ita parasti eam."
,"11":"Sulcos eius irrigans, glebas eius complanans; imbribus emollis eam, benedicis germini eius."
,"12":"Coronasti annum benignitate tua, et vestigia tua stillabunt pinguedinem."
,"13":"Stillabunt pascua deserti, et exsultatione colles accingentur."
,"14":"Induta sunt ovibus prata, et valles abundabunt frumento; clamabunt, etenim hymnum dicent."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Magistro chori. Canticum. PSALMUS. Iubilate Deo, omnis terra,"
,"2":"psalmum dicite gloriae nominis eius, glorificate laudem eius."
,"3":"Dicite Deo: ' Quam terribilia sunt opera tua. Prae multitudine virtutis tuae blandientur tibi inimici tui."
,"4":"Omnis terra adoret te et psallat tibi, psalmum dicat nomini tuo '."
,"5":"Venite et videte opera Dei, terribilis in adinventionibus super filios hominum."
,"6":"Convertit mare in aridam, et in flumine pertransibunt pede; ibi laetabimur in ipso."
,"7":"Qui dominatur in virtute sua in aeternum, oculi eius super gentes respiciunt; rebelles non exaltentur in semetipsis."
,"8":"Benedicite, gentes, Deum nostrum,et auditam facite vocem laudis eius;"
,"9":"qui posuit animam nostram ad vitam,et non dedit in commotionem pedes nostros."
,"10":"Quoniam probasti nos, Deus; igne nos examinasti, sicut examinatur argentum."
,"11":"Induxisti nos in laqueum, posuisti tribulationes in dorso nostro."
,"12":"Imposuisti homines super capita nostra, transivimus per ignem et aquam, et eduxisti nos in refrigerium."
,"13":"Introibo in domum tuam in holocaustis; reddam tibi vota mea,"
,"14":"quae protulerunt labia mea, et locutum est os meum in tribulatione mea."
,"15":"Holocausta medullata offeram tibi cum incenso arietum, offeram tibi boves cum hircis."
,"16":"Venite, audite, et narrabo, omnes, qui timetis Deum, quanta fecit animae meae."
,"17":"Ad ipsum ore meo clamavi,et exaltavi in lingua mea."
,"18":"Iniquitatem si aspexi in corde meo, non exaudiet Dominus."
,"19":"Propterea exaudivit Deus, attendit voci deprecationis meae."
,"20":"Benedictus Deus, qui non amovit orationem meam,et misericordiam suam a me."
}`)
	CurrentBook.AddChapter(67, `{
"1":"Magistro chori. Fidibus. PSALMUS. Canticum."
,"2":"Deus misereatur nostri et benedicat nobis; illuminet vultum suum super nos,"
,"3":"ut cognoscatur in terra via tua, in omnibus gentibus salutare tuum."
,"4":"Confiteantur tibi populi, Deus; confiteantur tibi populi omnes."
,"5":"Laetentur et exsultent gentes, quoniam iudicas populos in aequitate,et gentes in terra dirigis."
,"6":"Confiteantur tibi populi, Deus; confiteantur tibi populi omnes."
,"7":"Terra dedit fructum suum; benedicat nos Deus, Deus noster,"
,"8":"benedicat nos Deus, et metuant eum omnes fines terrae."
}`)
	CurrentBook.AddChapter(68, `{
"1":"Magistro chori. David. PSALMUS. Canticum."
,"2":"Exsurgit Deus, et dissipantur inimici eius; et fugiunt, qui oderunt eum, a facie eius."
,"3":"Sicut dissipatur fumus, tu dissipas; sicut fluit cera a facie ignis, sic pereunt peccatores a facie Dei."
,"4":"Et iusti laetentur et exsultent in conspectu Dei,et delectentur in laetitia."
,"5":"Cantate Deo, psalmum dicite nomini eius; iter facite ei, qui fertur super nubes: Dominus nomen illi. Iubilate in conspectu eius;"
,"6":"pater orphanorum et iudex viduarum, Deus in habitaculo sancto suo."
,"7":"Deus, qui inhabitare facit desolatos in domo, qui educit vinctos in prosperitatem; verumtamen rebelles habitabunt in arida terra. -"
,"8":"Deus, cum egredereris in conspectu populi tui, cum pertransires in deserto,"
,"9":"terra mota est, etiam caeli distillaverunt,a facie Dei Sinai, a facie Dei Israel."
,"10":"Pluviam voluntariam effundebas, Deus; hereditatem tuam infirmatam, tu refecisti eam."
,"11":"Animalia tua habitabant in ea, parasti in bonitate tua pauperi, Deus."
,"12":"Dominus dat verbum; virgines annuntiantes bona sunt agmen ingens:"
,"13":"' Reges exercituum fugiunt, fugiunt, et species domus dividit spolia."
,"14":"Et vos dormitis inter medias caulas: alae columbae nitent argento, et pennae eius pallore auri."
,"15":"Dum dispergit Omnipotens reges super eam, nive dealbatur Selmon '."
,"16":"Mons Dei mons Basan, mons cacuminum mons Basan."
,"17":"Ut quid invidetis, montes cacuminum, monti, in quo beneplacitum est Deo inhabitare?,Etenim Dominus habitabit in finem."
,"18":"Currus Dei decem milia milium: Dominus venit de Sinai in sancta."
,"19":"Ascendisti in altum, captivam duxisti captivitatem; accepisti in donum homines, ut etiam rebelles habitent apud Dominum Deum."
,"20":"Benedictus Dominus die cotidie; portabit nos Deus salutarium nostrorum."
,"21":"Deus noster, Deus ad salvandum; et Domini, Domini exitus mortis."
,"22":"Verumtamen Deus confringet capita inimicorum suorum, verticem capillatum perambulantium in delictis suis."
,"23":"Dixit Dominus: ' Ex Basan reducam, reducam de profundo maris,"
,"24":"ut intingatur pes tuus in sanguine, lingua canum tuorum ex inimicis portionem inveniat '."
,"25":"Viderunt ingressus tuos, Deus, ingressus Dei mei, regis mei in sancta."
,"26":"Praecedunt cantores, postremi veniunt psallentes. in medio iuvenculae tympanistriae."
,"27":"' In ecclesiis benedicite Deo, Domino, vos de fontibus Israel '."
,"28":"Ibi Beniamin adulescentulus ducens eos, principes Iudae cum turma sua, principes Zabulon, principes,Nephthali."
,"29":"Manda, Deus, virtuti tuae; confirma hoc, Deus, quod operatus es in nobis."
,"30":"A templo tuo in Ierusalem,tibi afferent reges munera."
,"31":"Increpa feram arundinis, congregationem taurorum in vitulis populorum: prosternant se cum laminis argenti. Dissipa gentes, quae bella volunt."
,"32":"Venient optimates ex Aegypto, Aethiopia praeveniet manus suas Deo."
,"33":"Regna terrae, cantate Deo, psallite Domino, psallite Deo,"
,"34":"qui fertur super caelum caeli ad orientem; ecce dabit vocem suam, vocem virtutis."
,"35":"Tribuite virtutem Deo. Super Israel magnificentia eius, et virtus eius in nubibus."
,"36":"Mirabilis, Deus, de sanctuario tuo!,Deus Israel ipse tribuet virtutem et fortitudinem plebi suae. Benedictus Deus!"
}`)
	CurrentBook.AddChapter(69, `{
"1":"Magistro chori. Secundum ' Lilia... '. David."
,"2":"Salvum me fac, Deus, quoniam venerunt aquae usque ad guttur meum."
,"3":"Infixus sum in limo profundi, et non est substantia; veni in profunda aquarum, et fluctus demersit me."
,"4":"Laboravi clamans, raucae factae sunt fauces meae; defecerunt oculi mei, dum spero in Deum meum."
,"5":"Multiplicati sunt super capillos capitis mei, qui oderunt me gratis. Confortati sunt, qui persecuti sunt me inimici mei mendaces; quae non rapui, tunc exsolvebam."
,"6":"Deus, tu scis insipientiam meam, et delicta mea a te non sunt abscondita."
,"7":"Non erubescant in me, qui exspectant te, Domine, Domine virtutum. Non confundantur super me, qui quaerunt te, Deus Israel."
,"8":"Quoniam propter te sustinui opprobrium, operuit confusio faciem meam;"
,"9":"extraneus factus sum fratribus meis,et peregrinus filiis matris meae."
,"10":"Quoniam zelus domus tuae comedit me, et opprobria exprobrantium tibi ceciderunt super me."
,"11":"Et flevi in ieiunio animam meam, et factum est in opprobrium mihi."
,"12":"Et posui vestimentum meum cilicium, et factus sum illis in parabolam."
,"13":"Adversum me loquebantur, qui sedebant in porta, et in me canebant, qui bibebant vinum."
,"14":"Ego vero orationem meam ad te, Domine, in tempore beneplaciti, Deus. In multitudine misericordiae tuae exaudi me, in veritate salutis tuae."
,"15":"Eripe me de luto, ut non infigar, eripiar ab iis, qui oderunt me, et de profundis aquarum."
,"16":"Non me demergat fluctus aquarum, neque absorbeat me profundum, neque urgeat super me puteus os suum."
,"17":"Exaudi me, Domine, quoniam benigna est misericordia tua; secundum multitudinem miserationum tuarum respice in me."
,"18":"Et ne avertas faciem tuam a puero tuo; quoniam tribulor, velociter exaudi me."
,"19":"Accede ad animam meam, vindica eam, propter inimicos meos redime me."
,"20":"Tu scis opprobrium meum,et confusionem meam et reverentiam meam. -,In conspectu tuo sunt omnes, qui tribulant me;"
,"21":"opprobrium contrivit cor meum, et elangui. Et sustinui, qui simul contristaretur, et non fuit, et qui consolaretur, et non inveni."
,"22":"Et dederunt in escam meam fel,et in siti mea potaverunt me aceto."
,"23":"Fiat mensa eorum coram ipsis in laqueum,et in retributiones et in scandalum."
,"24":"Obscurentur oculi eorum, ne videant, et lumbos eorum semper infirma."
,"25":"Effunde super eos iram tuam, et furor irae tuae comprehendat eos."
,"26":"Fiat commoratio eorum deserta, et in tabernaculis eorum non sit qui inhabitet."
,"27":"Quoniam, quem tu percussisti, persecuti sunt, et super dolorem eius, quem vulnerasti, addiderunt."
,"28":"Appone iniquitatem super iniquitatem eorum, et non veniant ad iustitiam tuam."
,"29":"Deleantur de libro viventium,et cum iustis non scribantur."
,"30":"Ego autem sum pauper et dolens; salus tua, Deus, suscipit me."
,"31":"Laudabo nomen Dei cum cantico,et magnificabo eum in laude."
,"32":"Et placebit Domino super taurum, super vitulum cornua producentem et ungulas."
,"33":"Videant humiles et laetentur; quaerite Deum, et vivet cor vestrum,"
,"34":"quoniam exaudivit pauperes Dominus,et vinctos suos non despexit."
,"35":"Laudent illum caeli et terra, maria et omnia reptilia in eis."
,"36":"Quoniam Deus salvam faciet Sion,et aedificabit civitates Iudae; et inhabitabunt ibi et possidebunt eam."
,"37":"Et semen servorum eius hereditabunt eam; et, qui diligunt nomen eius, habitabunt in ea."
}`)
	CurrentBook.AddChapter(70, `{
"1":"Magistro chori. David. Ad commemorandum."
,"2":"Deus, in adiutorium meum intende; Domine, ad adiuvandum me festina."
,"3":"Confundantur et revereantur, qui quaerunt animam meam. Avertantur retrorsum et erubescant, qui volunt mihi mala."
,"4":"Convertantur propter confusionem suam, qui dicunt mihi: ' Euge, euge '."
,"5":"Exsultent et laetentur in te omnes, qui quaerunt te; et dicant semper: ' Magnificetur Deus ', qui diligunt salutare tuum."
,"6":"Ego vero egenus et pauper sum; Deus, ad me festina. Adiutor meus et liberator meus es tu; Domine, ne moreris."
}`)
	CurrentBook.AddChapter(71, `{
"1":"In te, Domine, speravi, non confundar in aeternum."
,"2":"In iustitia tua libera me et eripe me; inclina ad me aurem tuam et salva me."
,"3":"Esto mihi in rupem praesidii,et in domum munitam, ut salvum me facias, quoniam fortitudo mea et refugium meum es tu."
,"4":"Deus meus, eripe me de manu peccatoris,et de manu contra legem agentis et iniqui."
,"5":"Quoniam tu es exspectatio mea, Domine; Domine, spes mea a iuventute mea."
,"6":"Super te innixus sum ex utero, de ventre matris meae tu es susceptor meus; in te laus mea semper."
,"7":"Tamquam prodigium factus sum multis, et tu adiutor fortis. -"
,"8":"Repleatur os meum laude tua, tota die magnitudine tua."
,"9":"Ne proicias me in tempore senectutis; cum defecerit virtus mea, ne derelinquas me."
,"10":"Quia dixerunt inimici mei mihi, et, qui observabant animam meam, consilium fecerunt in unum"
,"11":"dicentes: ' Deus dereliquit eum!,Persequimini et comprehendite,eum, quia non est qui eripiat '."
,"12":"Deus, ne elongeris a me; Deus meus, in auxilium meum festina."
,"13":"Confundantur et deficiant adversantes animae meae; operiantur confusione et pudore, qui quaerunt mala mihi."
,"14":"Ego autem semper sperabo,et adiciam super omnem laudem tuam."
,"15":"Os meum annuntiabit iustitiam tuam, tota die salutare tuum: quae dinumerare nescivi."
,"16":"Veniam ad potentias Domini; Domine, memorabor iustitiae tuae solius."
,"17":"Deus, docuisti me a iuventute mea; et usque nunc annuntiabo mirabilia tua."
,"18":"Et usque in senectam et senium, Deus, ne derelinquas me, donec annuntiem brachium tuum,generationi omni, quae ventura est. Potentia tua "
,"19":"et iustitia tua, Deus, usque in altissima, qui fecisti magnalia: Deus, quis similis tibi?"
,"20":"Quantas ostendisti mihi tribulationes multas et malas; iterum vivificasti me,et de abyssis terrae iterum reduxisti me."
,"21":"Multiplicabis magnitudinem meam et conversus consolaberis me."
,"22":"Nam et ego confitebor tibi,in psalterio veritatem tuam, Deus meus; psallam tibi in cithara, Sanctus Israel."
,"23":"Exsultabunt labia mea, cum cantavero tibi, et anima mea, quam redemisti;"
,"24":"sed et lingua mea tota die meditabitur iustitiam tuam, cum confusi et reveriti fuerint, qui quaerunt mala mihi."
}`)
	CurrentBook.AddChapter(72, `{
"1":"Salomonis. Deus, iudicium tuum regi da,et iustitiam tuam filio regis;"
,"2":"iudicet populum tuum in iustitia,et pauperes tuos in iudicio."
,"3":"Afferant montes pacem populo, et colles iustitiam."
,"4":"Iudicabit pauperes populi,et salvos faciet filios inopis,et humiliabit calumniatorem."
,"5":"Et permanebit cum sole et ante lunam,in generatione et generationem."
,"6":"Descendet sicut pluvia in gramen, et sicut imber irrigans terram."
,"7":"Florebit in diebus eius iustitia et abundantia pacis, donec auferatur luna."
,"8":"Et dominabitur a mari usque ad mare,et a flumine usque ad terminos orbis terrarum."
,"9":"Coram illo procident incolae deserti, et inimici eius terram lingent."
,"10":"Reges Tharsis et insulae munera offerent, reges Arabum et Saba dona adducent."
,"11":"Et adorabunt eum omnes reges, omnes gentes servient ei."
,"12":"Quia liberabit inopem clamantem,et pauperem, cui non erat adiutor."
,"13":"Parcet pauperi et inopi,et animas pauperum salvas faciet."
,"14":"Ex oppressione et violentia redimet animas eorum, et pretiosus erit sanguis eorum coram illo. -"
,"15":"Et vivet, et dabitur ei de auro Arabiae, et orabunt pro ipso semper; tota die benedicent ei."
,"16":"Et erit ubertas frumenti in terra, in summis montium fluctuabit, sicut Libanus fructus eius; et florebunt de civitate sicut fenum terrae."
,"17":"Sit nomen eius benedictum in saecula, ante solem permanebit nomen eius. Et benedicentur in ipso omnes tribus terrae, omnes gentes magnificabunt eum."
,"18":"Benedictus Dominus Deus, Deus Israel, qui facit mirabilia solus."
,"19":"Et benedictum nomen maiestatis eius in aeternum; et replebitur maiestate eius omnis terra. Fiat, fiat. "
}`)
	CurrentBook.AddChapter(73, `{
"1":"PSALMUS. Asaph. Quam bonus rectis est Deus, Deus his, qui mundo sunt corde!"
,"2":"Mei autem paene moti sunt pedes, paene effusi sunt gressus mei,"
,"3":"quia zelavi super gloriantes, pacem peccatorum videns."
,"4":"Quia non sunt eis impedimenta, sanus et pinguis est venter eorum."
,"5":"In labore mortalium non sunt,et cum hominibus non flagellantur."
,"6":"Ideo quasi torques est eis superbia, et tamquam indumentum operuit eos violentia."
,"7":"Prodit quasi ex adipe iniquitas eorum, erumpunt cogitationes cordis."
,"8":"Subsannaverunt et locuti sunt nequitiam, iniquitatem ab excelso locuti sunt."
,"9":"Posuerunt in caelo os suum, et lingua eorum transivit in terra."
,"10":"Ideo in alto sedent, et aquae plenae non pervenient ad eos."
,"11":"Et dixerunt: ' Quomodo scit Deus, et si est scientia in Excelso? '."
,"12":"Ecce ipsi peccatores et abundantes in saeculo,multiplicaverunt divitias."
,"13":"Et dixi: ' Ergo sine causa mundavi cor meum,et lavi in innocentia manus meas;"
,"14":"et fui flagellatus tota die, et castigatio mea in matutinis '."
,"15":"Si dixissem: ' Loquar ut illi ', ecce generationem filiorum tuorum prodidissem."
,"16":"Et cogitabam, ut cognoscerem hoc; labor erat in oculis meis,"
,"17":"donec intravi in sanctuarium Dei,et intellexi novissima eorum."
,"18":"Verumtamen in lubrico posuisti eos, deiecisti eos in ruinas."
,"19":"Quomodo facti sunt in desolationem!,Subito defecerunt, perierunt prae horrore."
,"20":"Velut somnium evigilantis, Domine, surgens imaginem ipsorum contemnes."
,"21":"Quia exacerbatum est cor meum, et renes mei compuncti sunt;"
,"22":"et ego insipiens factus sum et nescivi: ut iumentum factus sum apud te."
,"23":"Ego autem semper tecum; tenuisti manum dexteram meam."
,"24":"In consilio tuo deduces me,et postea cum gloria suscipies me."
,"25":"Quis enim mihi est in caelo?,Et tecum nihil volui super terram."
,"26":"Defecit caro mea et cor meum; Deus cordis mei, et pars mea Deus in aeternum."
,"27":"Quia ecce, qui elongant se a te, peribunt; perdidisti omnes, qui fornicantur abs te."
,"28":"Mihi autem adhaerere Deo bonum est, ponere in Domino Deo spem meam, ut annuntiem omnes operationes tuas,in portis filiae Sion."
}`)
	CurrentBook.AddChapter(74, `{
"1":"Maskil. Asaph. Ut quid, Deus, reppulisti in finem, iratus est furor tuus super oves pascuae tuae?"
,"2":"Memor esto congregationis tuae, quam possedisti ab initio. Redemisti virgam hereditatis tuae: mons Sion, in quo habitasti."
,"3":"Leva gressus tuos in ruinas sempiternas: omnia vastavit inimicus in sancto."
,"4":"Rugierunt, qui oderunt te, in medio congregationis tuae; posuerunt signa sua in signa."
,"5":"Visi sunt quasi in altum securim vibrantes,in silva condensa."
,"6":"Exciderunt ianuas eius in idipsum; in securi et ascia deiecerunt."
,"7":"Incenderunt igni sanctuarium tuum, in terram polluerunt tabernaculum nominis tui;"
,"8":"dixerunt in corde suo: ' Opprimamus eos simul '. Combusserunt omnes congregationes Dei in terra."
,"9":"Signa nostra non vidimus; iam non est propheta, et apud nos non est qui cognoscat amplius."
,"10":"Usquequo, Deus, improperabit inimicus, spernet adversarius nomen tuum in finem?"
,"11":"Ut quid avertis manum tuam,et tenes dexteram tuam in medio sinu tuo?"
,"12":"Deus autem rex noster ante saecula, operatus est salutes in medio terrae."
,"13":"Tu conscidisti in virtute tua mare, contribulasti capita draconum in aquis."
,"14":"Tu confregisti capita Leviathan, dedisti eum escam monstris maris."
,"15":"Tu dirupisti fontes et torrentes; tu siccasti fluvios perennes."
,"16":"Tuus est dies, et tua est nox, tu fabricatus es luminaria et solem."
,"17":"Tu statuisti omnes terminos terrae, aestatem et hiemem, tu plasmasti ea."
,"18":"Memor esto huius: inimicus improperavit Domino, et populus insipiens sprevit nomen tuum."
,"19":"Ne tradas bestiis animas confitentes tibi,et animas pauperum tuorum ne obliviscaris in finem."
,"20":"Respice in testamentum, quia repleta sunt latibula terrae tentoriis violentiae."
,"21":"Ne revertatur humilis factus confusus; pauper et inops laudabunt nomen tuum."
,"22":"Exsurge, Deus, iudica causam tuam; memor esto improperiorum tuorum, quae ab insipiente fiunt tota die."
,"23":"Ne obliviscaris voces inimicorum tuorum; tumultus adversariorum tuorum ascendit semper."
}`)
	CurrentBook.AddChapter(75, `{
"1":"Magistro chori. Secundum ' Ne destruxeris '. PSALMUS. Asaph. Canticum."
,"2":"Confitebimur tibi, Deus; confitebimur et invocabimus nomen tuum: narrabimus mirabilia tua."
,"3":"Cum statuero tempus, ego iustitias iudicabo."
,"4":"Si liquefacta est terra et omnes, qui habitant in ea, ego confirmavi columnas eius."
,"5":"Dixi gloriantibus: ' Nolite gloriari! ',et delinquentibus: 'Nolite exaltare cornu!"
,"6":"Nolite exaltare in altum cornu vestrum; nolite loqui adversus Deum proterva '."
,"7":"Quia neque ab oriente neque ab occidente,neque a desertis exaltatio."
,"8":"Quoniam Deus iudex est: hunc humiliat et hunc exaltat."
,"9":"Quia calix in manu Domini,vini meri plenus mixto. Et inclinavit ex hoc in hoc; verumtamen usque ad faeces epotabunt, bibent omnes peccatores terrae."
,"10":"Ego autem annuntiabo in saeculum, cantabo Deo Iacob."
,"11":"Et omnia cornua peccatorum confringam, et exaltabuntur cornua iusti."
}`)
	CurrentBook.AddChapter(76, `{
"1":"Magistro chori. Fidibus. PSALMUS. Asaph. Canticum."
,"2":"Notus in Iudaea Deus, in Israel magnum nomen eius."
,"3":"Et est in Salem tabernaculum eius, et habitatio eius in Sion."
,"4":"Ibi confregit coruscationes arcus, scutum, gladium et bellum."
,"5":"Illuminans tu, Mirabilis, a montibus direptionis."
,"6":"Spoliati sunt potentes corde, dormierunt somnum suum, et non invenerunt omnes viri fortes manus suas."
,"7":"Ab increpatione tua, Deus Iacob, dormitaverunt auriga et equus."
,"8":"Tu terribilis es, et quis resistet tibi?,Ex tunc ira tua."
,"9":"De caelo auditum fecisti iudicium; terra tremuit et quievit,"
,"10":"cum exsurgeret in iudicium Deus, ut salvos faceret omnes mansuetos terrae."
,"11":"Quoniam furor hominis confitebitur tibi, et reliquiae furoris diem festum agent tibi."
,"12":"Vovete et reddite Domino Deo vestro; omnes in circuitu eius afferant munera Terribili,"
,"13":"ei, qui aufert spiritum principum, terribili apud reges terrae."
}`)
	CurrentBook.AddChapter(77, `{
"1":"Magistro chori. Secundum Idithun. Asaph. PSALMUS."
,"2":"Voce mea ad Dominum clamavi; voce mea ad Deum, et intendit mihi."
,"3":"In die tribulationis meae Deum exquisivi, manus meae nocte expansae sunt,et non fatigantur. Renuit consolari anima mea;"
,"4":"memor sum Dei et ingemisco, exerceor, et deficit spiritus meus."
,"5":"Vigiles tenuisti palpebras oculi mei; turbatus sum et non sum locutus."
,"6":"Cogitavi dies antiquos,et annos aeternos in mente habui."
,"7":"Meditatus sum nocte cum corde meo,et exercitabar et scobebam spiritum meum."
,"8":"Numquid in aeternum proiciet Deus, aut non apponet, ut complacitior sit adhuc?"
,"9":"Aut deficiet in finem misericordia sua, cessabit verbum a generatione in generationem?"
,"10":"Aut obliviscetur misereri Deus, aut continebit in ira sua misericordias suas?"
,"11":"Et dixi: ' Hoc vulnus meum: mutatio dexterae Excelsi '."
,"12":"Memor ero operum Domini, memor ero ab initio mirabilium tuorum."
,"13":"Et meditabor in omnibus operibus tuis,et in adinventionibus tuis exercebor."
,"14":"Deus, in sancto via tua; quis deus magnus sicut Deus noster?"
,"15":"Tu es Deus, qui facis mirabilia, notam fecisti in populis virtutem tuam."
,"16":"Redemisti in brachio tuo populum tuum, filios Iacob et Ioseph."
,"17":"Viderunt te aquae, Deus, viderunt te aquae et doluerunt; etenim commotae sunt abyssi."
,"18":"Effuderunt aquas nubila, vocem dederunt nubes, etenim sagittae tuae transeunt."
,"19":"Vox tonitrui tui in rota; illuxerunt coruscationes tuae orbi terrae, commota est et contremuit terra."
,"20":"In mari via tua, et semitae tuae in aquis multis; et vestigia tua non cognoscuntur."
,"21":"Deduxisti sicut oves populum tuum,in manu Moysi et Aaron."
}`)
	CurrentBook.AddChapter(78, `{
"1":"Maskil. Asaph. Attendite, popule meus, doctrinam meam; inclinate aurem vestram in verba oris mei."
,"2":"Aperiam in parabolis os meum, eloquar arcana aetatis antiquae."
,"3":"Quanta audivimus et cognovimus ea, et patres nostri narraverunt nobis,"
,"4":"non occultabimus a filiis eorum, generationi alteri narrantes,laudes Domini et virtutes eius,et mirabilia eius, quae fecit."
,"5":"Constituit testimonium in Iacob,et legem posuit in Israel; quanta mandaverat patribus nostris,nota facere ea filiis suis,"
,"6":"ut cognoscat generatio altera, filii, qui nascentur. Exsurgent et narrabunt filiis suis,"
,"7":"ut ponant in Deo spem suam,et non obliviscantur operum Dei,et mandata eius custodiant."
,"8":"Ne fiant sicut patres eorum, generatio rebellis et exasperans; generatio, quae non firmavit cor suum, et non fuit fidelis Deo spiritus eius."
,"9":"Filii Ephraim, intendentes et mittentes arcum, conversi sunt in die belli."
,"10":"Non custodierunt testamentum Dei,et in lege eius renuerunt ambulare."
,"11":"Et obliti sunt factorum eius,et mirabilium eius, quae ostendit eis."
,"12":"Coram patribus eorum fecit mirabilia,in terra Aegypti, in campo Taneos."
,"13":"Scidit mare et perduxit eos,et statuit aquas quasi in utre."
,"14":"Et deduxit eos in nube per diem,et per totam noctem in illuminatione ignis."
,"15":"Scidit petram in eremo,et adaquavit eos velut abyssus multa."
,"16":"Et eduxit rivulos de petra,et deduxit tamquam flumina aquas."
,"17":"Et apposuerunt adhuc peccare ei, in iram excitaverunt Excelsum in inaquoso."
,"18":"Et tentaverunt Deum in cordibus suis, petentes escas animabus suis;"
,"19":"et contra Deum locuti sunt, dixerunt: ' Numquid poterit Deus parare mensam in deserto? '."
,"20":"Ecce percussit petram, et fluxerunt aquae, et torrentes inundaverunt. ' Numquid et panem poterit dare,aut parare carnes populo suo? '."
,"21":"Ideo audivit Dominus et exarsit, et ignis accensus est in Iacob, et ira ascendit in Israel."
,"22":"Quia non crediderunt in Deo,nec speraverunt in salutari eius."
,"23":"Verumtamen mandavit nubibus desuper,et ianuas caeli aperuit;"
,"24":"et pluit illis manna ad manducandum,et panem caeli dedit eis:"
,"25":"panem angelorum manducavit homo; cibaria misit eis ad abundantiam."
,"26":"Excitavit austrum in caelo,et induxit in virtute sua africum;"
,"27":"et pluit super eos sicut pulverem carnes,et sicut arenam maris volatilia pennata:"
,"28":"et ceciderunt in medio castrorum eorum, circa tabernacula eorum."
,"29":"Et manducaverunt et saturati sunt nimis, et desiderium eorum attulit eis."
,"30":"Nondum recesserant a desiderio suo, adhuc escae eorum erant in ore ipsorum,"
,"31":"et ira Dei ascendit super eos,et occidit pingues eorum,et electos Israel prostravit."
,"32":"In omnibus his peccaverunt adhuc,et non crediderunt in mirabilibus eius;"
,"33":"et consumpsit in halitu dies eorum,et annos eorum cum festinatione."
,"34":"Cum occideret eos, quaerebant eum,et conversi veniebant diluculo ad eum;"
,"35":"et rememorati sunt quia Deus adiutor est eorum, et Deus Excelsus redemptor eorum est."
,"36":"Et suaserunt ei in ore suo,et lingua sua mentiti sunt ei;"
,"37":"cor autem eorum non erat rectum cum eo, nec fideles erant in testamento eius."
,"38":"Ipse autem est misericors,et propitiatur iniquitati et non disperdit. Saepe avertit iram suam,et non accendit omnem furorem suum."
,"39":"Et recordatus est quia caro sunt, spiritus vadens et non rediens."
,"40":"Quoties exacerbaverunt eum in deserto, in iram concitaverunt eum in inaquoso!"
,"41":"Et reversi sunt et tentaverunt Deum,et Sanctum Israel exacerbaverunt."
,"42":"Non sunt recordati manus eius, diei, qua redemit eos de manu tribulantis."
,"43":"Cum posuit in Aegypto signa sua,et prodigia sua in campo Taneos."
,"44":"Convertit in sanguinem flumina eorum,et rivulos eorum, ne biberent."
,"45":"Misit in eos coenomyiam et comedit eos, ranam et perdidit eos."
,"46":"Dedit brucho fructus eorum, labores eorum locustae."
,"47":"Occidit in grandine vineas eorum, moros eorum in pruina."
,"48":"Tradidit grandini iumenta eorum,et greges eorum flammae ignis."
,"49":"Misit in eos ardorem irae suae, indignationem et comminationem et angustiam, immissionem angelorum malorum."
,"50":"Complanavit semitam irae suae; non pepercit a morte animabus eorum,et vitam eorum in peste conclusit."
,"51":"Percussit omne primogenitum in terra Aegypti, primitias roboris eorum in tabernaculis Cham."
,"52":"Abstulit sicut oves populum suum,et perduxit eos tamquam gregem in deserto."
,"53":"Deduxit eos in spe, et non timuerunt, et inimicos eorum operuit mare."
,"54":"Et induxit eos in fines sanctificationis suae, in montem, quem acquisivit dextera eius."
,"55":"Et eiecit a facie eorum gentes,et divisit eis terram in funiculo hereditatis,et habitare fecit in tabernaculis eorum tribus Israel."
,"56":"Et tentaverunt et exacerbaverunt Deum Excelsum,et testimonia eius non custodierunt."
,"57":"Recesserunt et praevaricati sunt, quemadmodum patres eorum; conversi sunt retro ut arcus pravus."
,"58":"In iram concitaverunt eum in collibus suis,et in sculptilibus suis ad aemulationem eum provocaverunt."
,"59":"Audivit Deus et exarsit,et sprevit valde Israel."
,"60":"Et reppulit habitaculum Silo, tabernaculum, ubi habitavit in hominibus."
,"61":"Et tradidit in captivitatem virtutem suam,et pulchritudinem suam in manus inimici."
,"62":"Et conclusit in gladio populum suum,et in hereditatem suam exarsit."
,"63":"Iuvenes eorum comedit ignis, et virgines eorum non sunt desponsatae."
,"64":"Sacerdotes eorum in gladio ceciderunt, et viduae eorum non plorabantur."
,"65":"Et excitatus est tamquam dormiens Dominus, tamquam potens crapulatus a vino."
,"66":"Et percussit inimicos suos in posteriora, opprobrium sempiternum dedit illis."
,"67":"Et reppulit tabernaculum Ioseph,et tribum Ephraim non elegit,"
,"68":"sed elegit tribum Iudae, montem Sion, quem dilexit."
,"69":"Et aedificavit sicut excelsum sanctuarium suum, sicut terram, quam fundavit in saecula."
,"70":"Et elegit David servum suum,et sustulit eum de gregibus ovium,"
,"71":"de post fetantes accepit eum: pascere Iacob populum suum,et Israel hereditatem suam."
,"72":"Et pavit eos in innocentia cordis sui,et in prudentia manuum suarum deduxit eos."
}`)
	CurrentBook.AddChapter(79, `{
"1":"PSALMUS. Asaph. Deus, venerunt gentes in hereditatem tuam, polluerunt templum sanctum tuum, posuerunt Ierusalem in ruinas."
,"2":"Dederunt morticina servorum tuorum escas volatilibus caeli, carnes sanctorum tuorum bestiis terrae."
,"3":"Effuderunt sanguinem eorum tamquam aquam,in circuitu Ierusalem, et non erat qui sepeliret."
,"4":"Facti sumus opprobrium vicinis nostris, subsannatio et illusio his, qui in circuitu nostro sunt."
,"5":"Usquequo, Domine? Irasceris in finem?,Accendetur velut ignis zelus tuus?"
,"6":"Effunde iram tuam in gentes, quae te non noverunt, et in regna, quae nomen tuum non invocaverunt,"
,"7":"quia comederunt Iacob,et sedem eius desolaverunt."
,"8":"Ne memineris iniquitatum patrum nostrorum, cito anticipent nos misericordiae tuae, quia pauperes facti sumus nimis."
,"9":"Adiuva nos, Deus salutaris nostri, propter gloriam nominis tui et libera nos; et propitius esto peccatis nostris propter nomen tuum."
,"10":"Quare dicent in gentibus: ' Ubi est Deus eorum? '. Innotescat in nationibus coram oculis nostris,ultio sanguinis servorum tuorum, qui effusus est."
,"11":"Introeat in conspectu tuo gemitus compeditorum; secundum magnitudinem brachii tui,superstites relinque filios mortis."
,"12":"Et redde vicinis nostris septuplum in sinu eorum, improperium ipsorum, quod exprobraverunt tibi, Domine."
,"13":"Nos autem, populus tuus et oves pascuae tuae, confitebimur tibi in saeculum; in generationem et generationem annuntiabimus laudem tuam."
}`)
	CurrentBook.AddChapter(80, `{
"1":"Magistro chori. Secundum ' Lilium praecepti '. Asaph. PSALMUS."
,"2":"Qui pascis Israel, intende, qui deducis velut ovem Ioseph. Qui sedes super cherubim, effulge"
,"3":"coram Ephraim, Beniamin et Manasse. Excita potentiam tuam et veni, ut salvos facias nos."
,"4":"Deus, converte nos, illustra faciem tuam, et salvi erimus."
,"5":"Domine, Deus virtutum, quousque irasceris super orationem populi tui?"
,"6":"Cibasti nos pane lacrimarum,et potum dedisti nobis in lacrimis copiose."
,"7":"Posuisti nos in contradictionem vicinis nostris, et inimici nostri subsannaverunt nos."
,"8":"Deus virtutum, converte nos, illustra faciem tuam, et salvi erimus."
,"9":"Vineam de Aegypto transtulisti, eiecisti gentes et plantasti eam."
,"10":"Purgasti locum in conspectu eius, plantasti radices eius, et implevit terram."
,"11":"Operti sunt montes umbra eius, et ramis eius cedri Dei;"
,"12":"extendit palmites suos usque ad mare,et usque ad flumen propagines suas."
,"13":"Ut quid destruxisti maceriam eius, et vindemiant eam omnes, qui praetergrediuntur viam?"
,"14":"Exterminavit eam aper de silva, et singularis ferus depastus est eam."
,"15":"Deus virtutum, convertere, respice de caelo et vide et visita vineam istam."
,"16":"Et protege eam, quam plantavit dextera tua, et super filium hominis, quem confirmasti tibi."
,"17":"Incensa est igni et suffossa; ab increpatione vultus tui peribunt."
,"18":"Fiat manus tua super virum dexterae tuae, super filium hominis, quem confirmasti tibi."
,"19":"Et non discedemus a te, vivificabis nos, et nomen tuum invocabimus."
,"20":"Domine, Deus virtutum, converte nos,et illustra faciem tuam, et salvi erimus."
}`)
	CurrentBook.AddChapter(81, `{
"1":"Magistro chori. Secundum ' Torcularia... '. Asaph."
,"2":"Exsultate Deo adiutori nostro; iubilate Deo Iacob."
,"3":"Sumite psalmum et date tympanum, psalterium iucundum cum cithara."
,"4":"Bucinate in neomenia tuba, in die plenae lunae, in sollemnitate nostra."
,"5":"Quia praeceptum in Israel est, et iudicium Deo Iacob."
,"6":"Testimonium in Ioseph posuit illud, cum exiret de terra Aegypti; sermonem, quem non noveram, audivi:"
,"7":"' Diverti ab oneribus dorsum eius; manus eius a cophino recesserunt."
,"8":"In tribulatione invocasti me, et liberavi te, exaudivi te in abscondito tempestatis, probavi te apud aquam Meriba."
,"9":"Audi, populus meus, et contestabor te; Israel, utinam audias me!"
,"10":"Non erit in te deus alienus, neque adorabis deum extraneum."
,"11":"Ego enim sum Dominus Deus tuus, qui eduxi te de terra Aegypti; dilata os tuum, et implebo illud."
,"12":"Et non audivit populus meus vocem meam, et Israel non intendit mihi."
,"13":"Et dimisi eos secundum duritiam cordis eorum, ibunt in adinventionibus suis."
,"14":"Si populus meus audisset me, Israel si in viis meis ambulasset!"
,"15":"In brevi inimicos eorum humiliassem,et super tribulantes eos misissem manum meam."
,"16":"Inimici Domini blandirentur ei, et esset sors eorum in saecula;"
,"17":"et cibarem eos ex adipe frumenti,et de petra melle saturarem eos '."
}`)
	CurrentBook.AddChapter(82, `{
"1":"PSALMUS. Asaph. Deus stetit in concilio divino, in medio deorum iudicat."
,"2":"' Usquequo iudicabitis inique,et facies peccatorum sumetis?"
,"3":"Iudicate egeno et pupillo, humilem et pauperem iustificate."
,"4":"Eripite pauperem,et egenum de manu peccatoris liberate '."
,"5":"Nescierunt neque intellexerunt, in tenebris ambulant; movebuntur omnia fundamenta terrae."
,"6":"Ego dixi: ' Dii estis, et filii Excelsi omnes '."
,"7":"Vos autem sicut homines moriemini,et sicut unus de principibus cadetis."
,"8":"Surge, Deus, iudica terram, quoniam tu hereditabis in omnibus gentibus."
}`)
	CurrentBook.AddChapter(83, `{
"1":"Canticum. PSALMUS. Asaph."
,"2":"Deus, ne quiescas, ne taceas,neque compescaris, Deus,"
,"3":"quoniam ecce inimici tui fremuerunt, et, qui oderunt te, extulerunt caput."
,"4":"Adversus populum tuum malignaverunt consilium,et cogitaverunt adversus eos, quos abscondisti tibi."
,"5":"Dixerunt: ' Venite, et disperdamus eos de gente, et non memoretur nomen Israel ultra! '."
,"6":"Quoniam cogitaverunt unanimiter, adversum te testamentum statuerunt:"
,"7":"tabernacula Idumaeorum et Ismaelitae, Moab et Agareni,"
,"8":"Gebal et Ammon et Amalec, Philistaea cum habitantibus Tyrum."
,"9":"Etenim Assur sociabatur cum illis; facti sunt in adiutorium filiis Lot."
,"10":"Fac illis sicut Madian et Sisarae, sicut Iabin in torrente Cison."
,"11":"Disperierunt in Endor, facti sunt ut stercus super terram."
,"12":"Pone duces eorum sicut Oreb et Zeb,et Zebee et Salmana, omnes principes eorum,"
,"13":"qui dixerunt: ' Hereditate possideamus pascua Dei! '."
,"14":"Deus meus, pone illos ut rotam,et sicut stipulam ante ventum."
,"15":"Sicut ignis, qui comburit silvam, et sicut flamma devorans montes,"
,"16":"ita persequeris illos in tempestate tua,et in procella tua turbabis eos."
,"17":"Imple facies eorum ignominia, et quaerent nomen tuum, Domine."
,"18":"Erubescant et conturbentur in saeculum saeculi,et confundantur et pereant;"
,"19":"et cognoscant quia nomen tibi Dominus: tu solus Altissimus super omnem terram."
}`)
	CurrentBook.AddChapter(84, `{
"1":"Magistro chori. Secundum ' Torcularia '. Filiorum Core. PSALMUS."
,"2":"Quam dilecta tabernacula tua, Domine virtutum!"
,"3":"Concupiscit et deficit anima mea in atria Domini. Cor meum et caro mea exsultaverunt in Deum vivum."
,"4":"Etenim passer invenit sibi domum, et turtur nidum sibi, ubi ponat pullos suos: altaria tua, Domine virtutum, rex meus et Deus meus."
,"5":"Beati, qui habitant in domo tua: in perpetuum laudabunt te."
,"6":"Beatus vir, cuius est auxilium abs te, ascensiones in corde suo disposuit."
,"7":"Transeuntes per vallem sitientem,in fontem ponent eam, etenim benedictionibus vestiet eam pluvia matutina."
,"8":"Ibunt de virtute in virtutem, videbitur Deus deorum in Sion."
,"9":"Domine, Deus virtutum, exaudi orationem meam; auribus percipe, Deus Iacob."
,"10":"Protector noster aspice, Deus, et respice in faciem christi tui."
,"11":"Quia melior est dies una in atriis tuis super milia, elegi ad limen esse in domo Dei mei,magis quam habitare in tabernaculis peccatorum."
,"12":"Quia sol et scutum est Dominus Deus, gratiam et gloriam dabit Dominus; non privabit bonis eos, qui ambulant in innocentia."
,"13":"Domine virtutum, beatus homo, qui sperat in te."
}`)
	CurrentBook.AddChapter(85, `{
"1":"Magistro chori. Filiorum Core. PSALMUS."
,"2":"Complacuisti tibi, Domine, in terra tua, convertisti captivitatem Iacob."
,"3":"Remisisti iniquitatem plebis tuae, operuisti omnia peccata eorum."
,"4":"Contraxisti omnem iram tuam, revertisti a furore indignationis tuae."
,"5":"Converte nos, Deus, salutaris noster, et averte iram tuam a nobis."
,"6":"Numquid in aeternum irasceris nobis,aut extendes iram tuam a generatione in generationem?"
,"7":"Nonne tu conversus vivificabis nos, et plebs tua laetabitur in te?"
,"8":"Ostende nobis, Domine, misericordiam tuam,et salutare tuum da nobis."
,"9":"Audiam, quid loquatur Dominus Deus, quoniam loquetur pacem ad plebem suam et sanctos suos,et ad eos, qui convertuntur corde."
,"10":"Vere prope timentes eum salutare ipsius, ut inhabitet gloria in terra nostra."
,"11":"Misericordia et veritas obviaverunt sibi, iustitia et pax osculatae sunt."
,"12":"Veritas de terra orta est, et iustitia de caelo prospexit."
,"13":"Etenim Dominus dabit benignitatem, et terra nostra dabit fructum suum."
,"14":"Iustitia ante eum ambulabit,et ponet in via gressus suos."
}`)
	CurrentBook.AddChapter(86, `{
"1":"Precatio. David. Inclina, Domine, aurem tuam et exaudi me, quoniam inops et pauper sum ego."
,"2":"Custodi animam meam, quoniam sanctus sum; salvum fac servum tuum, Deus meus, sperantem in te"
,"3":"Miserere mei, Domine, quoniam ad te clamavi tota die."
,"4":"Laetifica animam servi tui, quoniam ad te, Domine, animam meam levavi."
,"5":"Quoniam tu, Domine, suavis et mitis,et multae misericordiae omnibus invocantibus te. -"
,"6":"Auribus percipe, Domine, orationem meam,et intende voci deprecationis meae."
,"7":"In die tribulationis meae clamavi ad te, quia exaudies me."
,"8":"Non est similis tui in diis, Domine, et nihil sicut opera tua."
,"9":"Omnes gentes, quascumque fecisti, venient,et adorabunt coram te, Domine, et glorificabunt nomen tuum,"
,"10":"quoniam magnus es tu et faciens mirabilia: tu es Deus solus."
,"11":"Doce me, Domine, viam tuam, et ingrediar in veritate tua; simplex fac cor meum, ut timeat nomen tuum."
,"12":"Confitebor tibi, Domine Deus meus, in toto corde meo,et glorificabo nomen tuum in aeternum,"
,"13":"quia misericordia tua magna est super me, et eruisti animam meam ex inferno inferiori."
,"14":"Deus, superbi insurrexerunt super me, et synagoga potentium quaesierunt animam meam,et non proposuerunt te in conspectu suo."
,"15":"Et tu, Domine, Deus miserator et misericors, patiens et multae misericordiae et veritatis,"
,"16":"respice in me et miserere mei; da fortitudinem tuam puero tuo,et salvum fac filium ancillae tuae."
,"17":"Fac mecum signum in bonum, ut videant, qui oderunt me, et confundantur, quoniam tu, Domine, adiuvisti me et consolatus es me."
}`)
	CurrentBook.AddChapter(87, `{
"1":"Filiorum Core. PSALMUS. Canticum. Fundamenta eius in montibus sanctis;"
,"2":"diligit Dominus portas Sion,super omnia tabernacula Iacob."
,"3":"Gloriosa dicta sunt de te, civitas Dei! -"
,"4":"Memor ero Rahab et Babylonis inter scientes me; ecce Philistaea et Tyrus cum Aethiopia: hi nati sunt illic."
,"5":"Et de Sion dicetur: ' Hic et ille natus est in ea; et ipse firmavit eam Altissimus '."
,"6":"Dominus referet in librum populorum: ' Hi nati sunt illic '."
,"7":"Et cantant sicut choros ducentes: ' Omnes fontes mei in te '."
}`)
	CurrentBook.AddChapter(88, `{
"1":"Canticum. PSALMUS. Filiorum Core. Magistro chori. Secundum ' Mahalat '. Ad cantandum. Maskil. Heman Ezrahitae."
,"2":"Domine, Deus salutis meae, in die clamavi et nocte coram te."
,"3":"Intret in conspectu tuo oratio mea; inclina aurem tuam ad precem meam."
,"4":"Quia repleta est malis anima mea, et vita mea inferno appropinquavit."
,"5":"Aestimatus sum cum descendentibus in lacum, factus sum sicut homo sine adiutorio."
,"6":"Inter mortuos liber, sicut vulnerati dormientes in sepulcris; quorum non es memor amplius, et ipsi de manu tua abscissi sunt."
,"7":"Posuisti me in lacu inferiori, in tenebrosis et in umbra mortis."
,"8":"Super me gravatus est furor tuus, et omnes fluctus tuos induxisti super me."
,"9":"Longe fecisti notos meos a me, posuisti me abominationem eis; conclusus sum et non egrediar."
,"10":"Oculi mei languerunt prae afflictione. Clamavi ad te, Domine, tota die, expandi ad te manus meas. -"
,"11":"Numquid mortuis facies mirabilia, aut surgent umbrae et confitebuntur tibi?"
,"12":"Numquid narrabit aliquis in sepulcro misericordiam tuam,et veritatem tuam in loco perditionis?"
,"13":"Numquid cognoscentur in tenebris mirabilia tua, et iustitia tua in terra oblivionis?"
,"14":"Et ego ad te, Domine, clamavi, et mane oratio mea praeveniet te."
,"15":"Ut quid, Domine, repellis animam meam, abscondis faciem tuam a me?"
,"16":"Pauper sum ego et moriens a iuventute mea; portavi pavores tuos et conturbatus sum."
,"17":"Super me transierunt irae tuae, et terrores tui exciderunt me."
,"18":"Circuierunt me sicut aqua tota die, circumdederunt me simul."
,"19":"Elongasti a me amicum et proximum, et noti mei sunt tenebrae."
}`)
	CurrentBook.AddChapter(89, `{
"1":"Maskil. Ethan Ezrahitae."
,"2":"Misericordias Domini in aeternum cantabo; in generationem et generationem,annuntiabo veritatem tuam in ore meo."
,"3":"Quoniam dixisti: ' In aeternum misericordia aedificabitur ', in caelis firmabitur veritas tua."
,"4":"' Disposui testamentum electo meo, iuravi David servo meo:"
,"5":"Usque in aeternum confirmabo semen tuum,et aedificabo in generationem et generationem sedem tuam '."
,"6":"Confitebuntur caeli mirabilia tua, Domine, etenim veritatem tuam in ecclesia sanctorum."
,"7":"Quoniam quis in nubibus aequabitur Domino, similis erit Domino in filiis Dei?"
,"8":"Deus, metuendus in consilio sanctorum, magnus et terribilis super omnes, qui in circuitu eius sunt."
,"9":"Domine, Deus virtutum, quis similis tibi?,Potens es, Domine, et veritas tua in circuitu tuo."
,"10":"Tu dominaris superbiae maris, elationes fluctuum eius tu mitigas."
,"11":"Tu conculcasti sicut vulneratum Rahab, in brachio virtutis tuae dispersisti inimicos tuos."
,"12":"Tui sunt caeli, et tua est terra, orbem terrae et plenitudinem eius tu fundasti;"
,"13":"Aquilonem et austrum tu creasti, Thabor et Hermon in nomine tuo exsultabunt."
,"14":"Tibi brachium cum potentia; firma est manus tua, et exaltata dextera tua."
,"15":"Iustitia et iudicium firmamentum sedis tuae. Misericordia et veritas praecedent faciem tuam."
,"16":"Beatus populus, qui scit iubilationem. Domine, in lumine vultus tui ambulabunt"
,"17":"et in nomine tuo exsultabunt tota die et in iustitia tua exaltabuntur,"
,"18":"quoniam decor virtutis eorum tu es, et in beneplacito tuo exaltabitur cornu nostrum."
,"19":"Quia Domini est scutum nostrum, et Sancti Israel rex noster."
,"20":"Tunc locutus es in visione sanctis tuis et dixisti: ' Posui adiutorium in potente,et exaltavi electum de plebe."
,"21":"Inveni David servum meum; oleo sancto meo unxi eum."
,"22":"Manus enim mea firma erit cum eo, et brachium meum confortabit eum."
,"23":"Nihil proficiet inimicus in eo, et filius iniquitatis non opprimet eum."
,"24":"Et concidam a facie ipsius inimicos eius,et odientes eum percutiam."
,"25":"Et veritas mea et misericordia mea cum ipso, et in nomine meo exaltabitur cornu eius."
,"26":"Et ponam super mare manum eius,et super flumina dexteram eius."
,"27":"Ipse invocabit me: 'Pater meus es tu, Deus meus et refugium salutis meae'."
,"28":"Et ego primogenitum ponam illum, excelsum prae regibus terrae."
,"29":"In aeternum servabo illi misericordiam meam; et testamentum meum fidele ipsi."
,"30":"Et ponam in saeculum saeculi semen eius; et thronum eius sicut dies caeli."
,"31":"Si autem dereliquerint filii eius legem meam,et in iudiciis meis non ambulaverint,"
,"32":"si iustificationes meas profanaverint,et mandata mea non custodierint,"
,"33":"visitabo in virga delictum eorum,et in verberibus iniquitatem eorum."
,"34":"Misericordiam autem meam non avertam ab eo,neque mentiar in veritate mea."
,"35":"Non profanabo testamentum meum et, quae procedunt de labiis meis, non faciam irrita."
,"36":"Semel iuravi in sancto meo: David non mentiar."
,"37":"Semen eius in aeternum manebit, et thronus eius sicut sol in conspectu meo"
,"38":"et sicut luna firmus stabit in aeternum,et testis in caelo fidelis '."
,"39":"Tu vero reppulisti et reiecisti, iratus es contra christum tuum;"
,"40":"evertisti testamentum servi tui, profanasti in terram diadema eius."
,"41":"Destruxisti omnes muros eius, posuisti munitiones eius in ruinas."
,"42":"Diripuerunt eum omnes transeuntes viam, factus est opprobrium vicinis suis."
,"43":"Exaltasti dexteram deprimentium eum, laetificasti omnes inimicos eius."
,"44":"Avertisti aciem gladii eius,et non es auxiliatus ei in bello."
,"45":"Finem posuisti splendori eius,et sedem eius in terram collisisti."
,"46":"Minorasti dies iuventutis eius, perfudisti eum confusione."
,"47":"Usquequo, Domine, absconderis in finem, exardescet sicut ignis ira tua?"
,"48":"Memorare, quam brevis mea substantia. Ad quam vanitatem creasti omnes filios hominum?"
,"49":"Quis est homo, qui vivet et non videbit mortem, eruet animam suam de manu inferi?"
,"50":"Ubi sunt misericordiae tuae antiquae, Domine, sicut iurasti David in veritate tua?"
,"51":"Memor esto, Domine, opprobrii servorum tuorum, quod continui in sinu meo, multarum gentium,"
,"52":"quo exprobraverunt inimici tui, Domine, quo exprobraverunt vestigia christi tui."
,"53":"Benedictus Dominus in aeternum. Fiat, fiat."
}`)
	CurrentBook.AddChapter(90, `{
"1":"Precatio. Moysis viri Dei. Domine, refugium factus es nobis,a generatione in generationem."
,"2":"Priusquam montes nascerentur, aut gigneretur terra et orbis, a saeculo et usque in saeculum tu es Deus."
,"3":"Reducis hominem in pulverem; et dixisti: ' Revertimini, filii hominum '."
,"4":"Quoniam mille anni ante oculos tuos,tamquam dies hesterna, quae praeteriit, et custodia in nocte."
,"5":"Auferes eos, somnium erunt:"
,"6":"mane sicut herba succrescens, mane floret et crescit, vespere decidit et arescit."
,"7":"Quia defecimus in ira tua,et in furore tuo turbati sumus."
,"8":"Posuisti iniquitates nostras in conspectu tuo, occulta nostra in illuminatione vultus tui."
,"9":"Quoniam omnes dies nostri evanuerunt in ira tua, consumpsimus ut suspirium annos nostros."
,"10":"Dies annorum nostrorum sunt septuaginta anni,aut in valentibus octoginta anni, et maior pars eorum labor et dolor, quoniam cito transeunt, et avolamus."
,"11":"Quis novit potestatem irae tuae,et secundum timorem tuum indignationem tuam?"
,"12":"Dinumerare dies nostros sic doce nos, ut inducamus cor ad sapientiam."
,"13":"Convertere, Domine, usquequo?,Et deprecabilis esto super servos tuos."
,"14":"Reple nos mane misericordia tua, et exsultabimus et delectabimur omnibus diebus nostris."
,"15":"Laetifica nos pro diebus, quibus nos humiliasti, pro annis, quibus vidimus mala."
,"16":"Appareat servis tuis opus tuum, et decor tuus filiis eorum."
,"17":"Et sit splendor Domini Dei nostri super nos, et opera manuum nostrarum confirma super nos,et opus manuum nostrarum confirma."
}`)
	CurrentBook.AddChapter(91, `{
"1":"Qui habitat in protectione Altissimi, sub umbra Omnipotentis commorabitur."
,"2":"Dicet Domino: ' Refugium meum,et fortitudo mea, Deus meus, sperabo in eum '."
,"3":"Quoniam ipse liberabit te de laqueo venantium,et a verbo maligno."
,"4":"Alis suis obumbrabit tibi, et sub pennas eius confugies; scutum et lorica veritas eius."
,"5":"Non timebis a timore nocturno, a sagitta volante in die,"
,"6":"a peste perambulante in tenebris, ab exterminio vastante in meridie."
,"7":"Cadent a latere tuo mille,et decem milia a dextris tuis; ad te autem non appropinquabit."
,"8":"Verumtamen oculis tuis considerabis,et retributionem peccatorum videbis."
,"9":"Quoniam tu es, Domine, refugium meum. Altissimum posuisti habitaculum tuum."
,"10":"Non accedet ad te malum, et flagellum non appropinquabit tabernaculo tuo,"
,"11":"quoniam angelis suis mandabit de te, ut custodiant te in omnibus viis tuis."
,"12":"In manibus portabunt te, ne forte offendas ad lapidem pedem tuum."
,"13":"Super aspidem et basiliscum ambulabis,et conculcabis leonem et draconem."
,"14":"Quoniam mihi adhaesit, liberabo eum; suscipiam eum, quoniam cognovit nomen meum."
,"15":"Clamabit ad me, et ego exaudiam eum; cum ipso sum in tribulatione; eripiam eum et glorificabo eum."
,"16":"Longitudine dierum replebo eum,et ostendam illi salutare meum."
}`)
	CurrentBook.AddChapter(92, `{
"1":"PSALMUS. Canticum. Pro die Sabbati."
,"2":"Bonum est confiteri Domino,et psallere nomini tuo, Altissime,"
,"3":"annuntiare mane misericordiam tuam,et veritatem tuam per noctem"
,"4":"in decachordo et psalterio, cum cantico in cithara."
,"5":"Quia delectasti me, Domine, in factura tua, et in operibus manuum tuarum exsultabo."
,"6":"Quam magnificata sunt opera tua, Domine: nimis profundae factae sunt cogitationes tuae."
,"7":"Vir insipiens non cognoscet, et stultus non intelleget haec."
,"8":"Cum germinaverint peccatores sicut fenum, et floruerint omnes, qui operantur iniquitatem, hoc tamen erit ad interitum in saeculum saeculi;"
,"9":"tu autem altissimus in aeternum, Domine."
,"10":"Quoniam ecce inimici tui, Domine, quoniam ecce inimici tui peribunt, et dispergentur omnes, qui operantur iniquitatem."
,"11":"Exaltabis sicut unicornis cornu meum, perfusus sum oleo uberi."
,"12":"Et despiciet oculus meus inimicos meos, et in insurgentibus in me malignantibus audiet auris mea. -"
,"13":"Iustus ut palma florebit, sicut cedrus Libani succrescet."
,"14":"Plantati in domo Domini, in atriis Dei nostri florebunt."
,"15":"Adhuc fructus dabunt in senecta, uberes et bene virentes erunt,"
,"16":"ut annuntient quoniam rectus Dominus, refugium meum, et non est iniquitas in eo."
}`)
	CurrentBook.AddChapter(93, `{
"1":"Dominus regnavit! Decorem indutus est; indutus est Dominus, fortitudine praecinxit se. Etenim firmavit orbem terrae, qui non commovebitur."
,"2":"Firmata sedes tua ex tunc, a saeculo tu es."
,"3":"Elevaverunt flumina, Domine. elevaverunt flumina vocem suam, elevaverunt flumina fragorem suum."
,"4":"Super voces aquarum multarum, super potentes elationes maris, potens in altis Dominus."
,"5":"Testimonia tua credibilia facta sunt nimis; domum tuam decet sanctitudo Domine, in longitudinem dierum."
}`)
	CurrentBook.AddChapter(94, `{
"1":"Deus ultionum, Domine, Deus ultionum, effulge."
,"2":"Exaltare, qui iudicas terram, redde retributionem superbis."
,"3":"Usquequo peccatores, Domine, usquequo peccatores exsultabunt?"
,"4":"Effabuntur et loquentur proterva, gloriabuntur omnes, qui operantur iniquitatem. -"
,"5":"Populum tuum, Domine, humiliant,et hereditatem tuam vexant."
,"6":"Viduam et advenam interficiunt,et pupillos occidunt."
,"7":"Et dixerunt: ' Non videbit Dominus, nec intelleget Deus Iacob '."
,"8":"Intellegite, insipientes in populo; et stulti, quando sapietis?"
,"9":"Qui plantavit aurem, non audiet, aut qui finxit oculum, non respiciet?"
,"10":"Qui corripit gentes, non arguet, qui docet hominem scientiam?"
,"11":"Dominus scit cogitationes hominum, quoniam vanae sunt."
,"12":"Beatus homo, quem tu erudieris, Domine, et de lege tua docueris eum,"
,"13":"ut mitiges ei a diebus malis, donec fodiatur peccatori fovea."
,"14":"Quia non repellet Dominus plebem suam,et hereditatem suam non derelinquet."
,"15":"Quia ad iustitiam revertetur iudicium, et sequentur illam omnes, qui recto sunt corde."
,"16":"Quis consurget mihi adversus malignantes, aut quis stabit mecum adversus operantes iniquitatem?"
,"17":"Nisi quia Dominus adiuvit me, paulo minus habitasset in loco silentii anima mea."
,"18":"Si dicebam: ' Motus est pes meus ', misericordia tua, Domine, sustentabat me."
,"19":"In multitudine sollicitudinum mearum in corde meo, consolationes tuae laetificaverunt animam meam."
,"20":"Numquid sociabitur tibi sedes iniquitatis, quae fingit molestiam contra praeceptum?"
,"21":"Irruunt in animam iusti,et sanguinem innocentem condemnant."
,"22":"Et factus est mihi Dominus in praesidium, et Deus meus in rupem refugii mei;"
,"23":"et reddet illis iniquitatem ipsorum,et in malitia eorum disperdet eos,"
,"24":"disperdet illos Dominus Deus noster."
}`)
	CurrentBook.AddChapter(95, `{
"1":"Venite, exsultemus Domino; iubilemus Deo salutari nostro."
,"2":"Praeoccupemus faciem eius in confessione,et in psalmis iubilemus ei."
,"3":"Quoniam Deus magnus Dominus, et rex magnus super omnes deos."
,"4":"Quia in manu eius sunt profunda terrae, et altitudines montium ipsius sunt."
,"5":"Quoniam ipsius est mare, et ipse fecit illud, et siccam manus eius formaverunt."
,"6":"Venite, adoremus et procidamus,et genua flectamus ante Dominum, qui fecit nos,"
,"7":"quia ipse est Deus noster, et nos populus pascuae eius et oves manus eius."
,"8":"Utinam hodie vocem eius audiatis: ' Nolite obdurare corda vestra,"
,"9":"sicut in Meriba, secundum diem Massa in deserto, ubi tentaverunt me patres vestri: probaverunt me, etsi viderunt opera mea."
,"10":"Quadraginta annis taeduit me generationis illius,et dixi: Populus errantium corde sunt isti."
,"11":"Et ipsi non cognoverunt vias meas; ideo iuravi in ira mea: Non introibunt in requiem meam '."
}`)
	CurrentBook.AddChapter(96, `{
"1":"Cantate Domino canticum novum, cantate Domino, omnis terra."
,"2":"Cantate Domino, benedicite nomini eius, annuntiate de die in diem salutare eius."
,"3":"Annuntiate inter gentes gloriam eius, in omnibus populis mirabilia eius."
,"4":"Quoniam magnus Dominus et laudabilis nimis, terribilis est super omnes deos."
,"5":"Quoniam omnes dii gentium inania, Dominus autem caelos fecit."
,"6":"Magnificentia et pulchritudo in conspectu eius, potentia et decor in sanctuario eius."
,"7":"Afferte Domino, familiae populorum, afferte Domino gloriam et potentiam,"
,"8":"afferte Domino gloriam nominis eius. Tollite hostias et introite in atria eius,"
,"9":"adorate Dominum in splendore sancto. Contremiscite a facie eius, universa terra;"
,"10":"dicite in gentibus: ' Dominus regnavit! '. Etenim correxit orbem terrae, qui non commovebitur; iudicabit populos in aequitate."
,"11":"Laetentur caeli, et exsultet terra, sonet mare et plenitudo eius;"
,"12":"gaudebunt campi et omnia, quae in eis sunt. Tunc exsultabunt omnia ligna silvarum"
,"13":"a facie Domini, quia venit, quoniam venit iudicare terram. Iudicabit orbem terrae in iustitia,et populos in veritate sua."
}`)
	CurrentBook.AddChapter(97, `{
"1":"Dominus regnavit! Exsultet terra, laetentur insulae multae."
,"2":"Nubes et caligo in circuitu eius, iustitia et iudicium firmamentum sedis eius."
,"3":"Ignis ante ipsum praecedet,et inflammabit in circuitu inimicos eius."
,"4":"Illustrarunt fulgura eius orbem terrae: vidit et contremuit terra."
,"5":"Montes sicut cera fluxerunt a facie Domini, a facie Domini omnis terra."
,"6":"Annuntiaverunt caeli iustitiam eius, et viderunt omnes populi gloriam eius."
,"7":"Confundantur omnes, qui adorant sculptilia, et qui gloriantur in simulacris suis. Adorate eum, omnes angeli eius."
,"8":"Audivit et laetata est Sion, et exsultaverunt filiae Iudae,propter iudicia tua, Domine."
,"9":"Quoniam tu Dominus, Altissimus super omnem terram, nimis exaltatus es super omnes deos."
,"10":"Qui diligitis Dominum, odite malum; custodit ipse animas sanctorum suorum, de manu peccatoris liberabit eos."
,"11":"Lux orta est iusto, et rectis corde laetitia."
,"12":"Laetamini, iusti, in Domino,et confitemini memoriae sanctitatis eius."
}`)
	CurrentBook.AddChapter(98, `{
"1":"PSALMUS. Cantate Domino canticum novum, quia mirabilia fecit. Salvavit sibi dextera eius, et brachium sanctum eius."
,"2":"Notum fecit Dominus salutare suum, in conspectu gentium revelavit iustitiam suam."
,"3":"Recordatus est misericordiae suae,et veritatis suae domui Israel. Viderunt omnes termini terrae,salutare Dei nostri."
,"4":"Iubilate Deo, omnis terra; erumpite, exsultate et psallite."
,"5":"Psallite Domino in cithara, in cithara et voce psalmi;"
,"6":"in tubis ductilibus et voce tubae corneae, iubilate in conspectu regis Domini."
,"7":"Sonet mare et plenitudo eius, orbis terrarum et qui habitant in eo."
,"8":"Flumina plaudent manu, simul montes exsultabunt"
,"9":"a conspectu Domini, quoniam venit iudicare terram. Iudicabit orbem terrarum in iustitia,et populos in aequitate."
}`)
	CurrentBook.AddChapter(99, `{
"1":"Dominus regnavit! Commoveantur populi,sedet super cherubim, moveatur terra."
,"2":"Dominus in Sion magnus,et excelsus super omnes populos."
,"3":"Confiteantur nomini tuo magno et terribili, quoniam sanctum est."
,"4":"Rex potens iudicium diligit: tu statuisti, quae recta sunt, iudicium et iustitiam in Iacob tu fecisti."
,"5":"Exaltate Dominum Deum nostrum,et adorate ad scabellum pedum eius, quoniam sanctus est."
,"6":"Moyses et Aaron in sacerdotibus eius, et Samuel inter eos, qui invocant nomen eius. Invocabant Dominum, et ipse exaudiebat eos,"
,"7":"in columna nubis loquebatur ad eos. Custodiebant testimonia eius,et praeceptum, quod dedit illis."
,"8":"Domine Deus noster, tu exaudiebas eos; Deus, tu propitius fuisti eis, ulciscens autem adinventiones eorum."
,"9":"Exaltate Dominum Deum nostrum,et adorate ad montem sanctum eius, quoniam sanctus Dominus Deus noster."
}`)
	CurrentBook.AddChapter(100, `{
"1":"PSALMUS. Ad gratiarum actionem."
,"2":"Iubilate Domino, omnis terra, servite Domino in laetitia; introite in conspectu eius in exsultatione."
,"3":"Scitote quoniam Dominus ipse est Deus; ipse fecit nos, et ipsius sumus, populus eius et oves pascuae eius."
,"4":"Introite portas eius in confessione, atria eius in hymnis, confitemini illi, benedicite nomini eius."
,"5":"Quoniam suavis est Dominus; in aeternum misericordia eius, et usque in generationem et generationem veritas eius."
}`)
	CurrentBook.AddChapter(101, `{
"1":"David. PSALMUS. Misericordiam et iudicium cantabo; tibi, Domine, psallam."
,"2":"Intellegam in via immaculata; quando venies ad me?,Perambulabo in innocentia cordis mei, in medio domus meae."
,"3":"Non proponam ante oculos meos rem iniustam; facientem praevaricationes odio habebo, non adhaerebit mihi."
,"4":"Cor pravum recedet a me, malignum non cognoscam."
,"5":"Detrahentem secreto proximo suo, hunc cessare faciam; superbum oculo et inflatum corde, hunc non sustinebo."
,"6":"Oculi mei ad fideles terrae, ut sedeant mecum; qui ambulat in via immaculata, hic mihi ministrabit."
,"7":"Non habitabit in medio domus meae, qui facit superbiam; qui loquitur iniqua, non stabit in conspectu oculorum meorum."
,"8":"In matutino cessare faciam omnes peccatores terrae, ut disperdam de civitate Domini omnes operantes iniquitatem."
}`)
	CurrentBook.AddChapter(102, `{
"1":"Preces afflicti, qui defessus,angorem suum ante Dominum profundit."
,"2":"Domine, exaudi orationem meam, et clamor meus ad te veniat."
,"3":"Non abscondas faciem tuam a me; in quacumque die tribulor, inclina ad me aurem tuam. In quacumque die invocavero te, velociter exaudi me."
,"4":"Quia defecerunt sicut fumus dies mei, et ossa mea sicut cremium aruerunt."
,"5":"Percussum est ut fenum et aruit cor meum, etenim oblitus sum comedere panem meum."
,"6":"A voce gemitus mei,adhaesit os meum carni meae."
,"7":"Similis factus sum pellicano solitudinis, factus sum sicut nycticorax in ruinis."
,"8":"Vigilavi et factus sum sicut passer solitarius in tecto."
,"9":"Tota die exprobrabant mihi inimici mei, exardescentes in me per me iurabant."
,"10":"Quia cinerem tamquam panem manducabam,et potum meum cum fletu miscebam,"
,"11":"a facie irae et increpationis tuae, quia elevans allisisti me."
,"12":"Dies mei sicut umbra declinaverunt, et ego sicut fenum arui."
,"13":"Tu autem, Domine, in aeternum permanes, et memoriale tuum in generationem et generationem."
,"14":"Tu exsurgens misereberis Sion, quia tempus miserendi eius, quia venit tempus,"
,"15":"quoniam placuerunt servis tuis lapides eius, et pulveris eius miserentur."
,"16":"Et timebunt gentes nomen tuum, Domine, et omnes reges terrae gloriam tuam,"
,"17":"quia aedificavit Dominus Sion,et apparuit in gloria sua."
,"18":"Respexit in orationem inopum,et non sprevit precem eorum."
,"19":"Scribantur haec pro generatione altera, et populus, qui creabitur, laudabit Dominum."
,"20":"Quia prospexit de excelso sanctuario suo, Dominus de caelo in terram aspexit,"
,"21":"ut audiret gemitus compeditorum, ut solveret filios mortis;"
,"22":"ut annuntient in Sion nomen Domini,et laudem eius in Ierusalem,"
,"23":"cum congregati fuerint populi in unum,et regna, ut serviant Domino."
,"24":"Humiliavit in via virtutem meam, abbreviavit dies meos. Dicam: ' Deus meus,"
,"25":"ne auferas me in dimidio dierum meorum; in generationem et generationem sunt anni tui."
,"26":"Initio terram fundasti; et opera manuum tuarum sunt caeli."
,"27":"Ipsi peribunt, tu autem permanes; et omnes sicut vestimentum veterascent, et sicut opertorium mutabis eos, et mutabuntur."
,"28":"Tu autem idem ipse es, et anni tui non deficient."
,"29":"Filii servorum tuorum habitabunt, et semen eorum in conspectu tuo firmabitur '."
}`)
	CurrentBook.AddChapter(103, `{
"1":"David. Benedic, anima mea, Domino, et omnia, quae intra me sunt, nomini sancto eius."
,"2":"Benedic, anima mea, Domino,et noli oblivisci omnes retributiones eius."
,"3":"Qui propitiatur omnibus iniquitatibus tuis, qui sanat omnes infirmitates tuas;"
,"4":"qui redimit de interitu vitam tuam, qui coronat te in misericordia et miserationibus;"
,"5":"qui replet in bonis aetatem tuam: renovabitur ut aquilae iuventus tua."
,"6":"Faciens iustitias Dominus,et iudicium omnibus iniuriam patientibus."
,"7":"Notas fecit vias suas Moysi, filiis Israel adinventiones suas. -"
,"8":"Miserator et misericors Dominus, longanimis et multae misericordiae."
,"9":"Non in perpetuum contendet,neque in aeternum irascetur."
,"10":"Non secundum peccata nostra fecit nobis,neque secundum iniquitates nostras retribuit nobis."
,"11":"Quoniam, quantum exaltatur caelum a terra, praevaluit misericordia eius super timentes eum;"
,"12":"quantum distat ortus ab occidente, longe fecit a nobis iniquitates nostras."
,"13":"Quomodo miseretur pater filiorum, misertus est Dominus timentibus se."
,"14":"Quoniam ipse cognovit figmentum nostrum, recordatus est quoniam pulvis sumus."
,"15":"Homo: sicut fenum dies eius, tamquam flos agri sic efflorebit."
,"16":"Spirat ventus in illum, et non subsistet, et non cognoscet eum amplius locus eius."
,"17":"Misericordia autem Domini ab aeterno,et usque in aeternum super timentes eum; et iustitia illius in filios filiorum,"
,"18":"in eos, qui servant testamentum eius,et memores sunt mandatorum ipsius ad faciendum ea."
,"19":"Dominus in caelo paravit sedem suam, et regnum ipsius omnibus dominabitur."
,"20":"Benedicite Domino, omnes angeli eius, potentes virtute, facientes verbum illius,in audiendo vocem sermonum eius."
,"21":"Benedicite Domino, omnes virtutes eius, ministri eius, qui facitis voluntatem eius."
,"22":"Benedicite Domino, omnia opera eius, in omni loco dominationis eius. Benedic, anima mea, Domino."
}`)
	CurrentBook.AddChapter(104, `{
"1":"Benedic, anima mea, Domino. Domine Deus meus, magnificatus es vehementer!,Maiestatem et decorem induisti,"
,"2":"amictus lumine sicut vestimento. Extendens caelum sicut velum,"
,"3":"qui exstruis in aquis cenacula tua. Qui ponis nubem ascensum tuum, qui ambulas super pennas ventorum."
,"4":"Qui facis angelos tuos spiritus,et ministros tuos ignem urentem."
,"5":"Qui fundasti terram super stabilitatem suam, non inclinabitur in saeculum saeculi."
,"6":"Abyssus sicut vestimentum operuit eam, super montes stabant aquae."
,"7":"Ab increpatione tua fugiunt, a voce tonitrui tui formidant."
,"8":"Ascendunt in montes et descendunt in valles, in locum, quem statuisti eis."
,"9":"Terminum posuisti, quem non transgredientur, neque convertentur operire terram."
,"10":"Qui emittis fontes in torrentes; inter medium montium pertransibunt,"
,"11":"potabunt omnes bestias agri, exstinguent onagri sitim suam."
,"12":"Super ea volucres caeli habitabunt, de medio ramorum dabunt voces."
,"13":"Rigas montes de cenaculis tuis, de fructu operum tuorum satias terram."
,"14":"Producis fenum iumentis,et herbam servituti hominum, educens panem de terra"
,"15":"et vinum, quod laetificat cor hominis; exhilarans faciem in oleo, panis autem cor hominis confirmat."
,"16":"Saturabuntur ligna Domini,et cedri Libani, quas plantavit."
,"17":"Illic passeres nidificabunt, erodii domus in vertice earum."
,"18":"Montes excelsi cervis, petrae refugium hyracibus."
,"19":"Fecit lunam ad tempora signanda, sol cognovit occasum suum."
,"20":"Posuisti tenebras, et facta est nox: in ipsa reptabunt omnes bestiae silvae,"
,"21":"catuli leonum rugientes, ut rapiant,et quaerant a Deo escam sibi."
,"22":"Oritur sol, et congregantur,et in cubilibus suis recumbunt."
,"23":"Exit homo ad opus suum,et ad operationem suam usque ad vesperum."
,"24":"Quam multiplicata sunt opera tua, Domine!,Omnia in sapientia fecisti, impleta est terra creatura tua."
,"25":"Hoc mare magnum et spatiosum et latum: illic reptilia, quorum non est numerus, animalia pusilla cum magnis;"
,"26":"illic naves pertransibunt, Leviathan, quem formasti ad ludendum cum eo."
,"27":"Omnia a te exspectant, ut des illis escam in tempore suo."
,"28":"Dante te illis, colligent, aperiente te manum tuam, implebuntur bonis."
,"29":"Avertente autem te faciem, turbabuntur; auferes spiritum eorum, et deficient,et in pulverem suum revertentur."
,"30":"Emittes spiritum tuum, et creabuntur, et renovabis faciem terrae."
,"31":"Sit gloria Domini in saeculum; laetetur Dominus in operibus suis."
,"32":"Qui respicit terram et facit eam tremere, qui tangit montes, et fumigant."
,"33":"Cantabo Domino in vita mea, psallam Deo meo quamdiu sum."
,"34":"Iucundum sit ei eloquium meum, ego vero delectabor in Domino."
,"35":"Deficiant peccatores a terra,et iniqui, ita ut non sint. Benedic, anima mea, Domino."
}`)
	CurrentBook.AddChapter(105, `{
"1":"ALLELUIA. Confitemini Domino et invocate nomen eius, annuntiate inter gentes opera eius."
,"2":"Cantate ei et psallite ei, meditamini in omnibus mirabilibus eius."
,"3":"Laudamini in nomine sancto eius, laetetur cor quaerentium Dominum."
,"4":"Quaerite Dominum et potentiam eius, quaerite faciem eius semper."
,"5":"Mementote mirabilium eius, quae fecit, prodigia eius et iudicia oris eius,"
,"6":"semen Abraham, servi eius, filii Iacob, electi eius."
,"7":"Ipse Dominus Deus noster; in universa terra iudicia eius."
,"8":"Memor fuit in saeculum testamenti sui, verbi, quod mandavit in mille generationes,"
,"9":"quod disposuit cum Abraham, et iuramenti sui ad Isaac."
,"10":"Et statuit illud Iacob in praeceptum,et Israel in testamentum aeternum"
,"11":"dicens: ' Tibi dabo terram Chanaan,funiculum hereditatis vestrae '."
,"12":"Cum essent numero brevi, paucissimi et peregrini in ea,"
,"13":"et pertransirent de gente in gentem,et de regno ad populum alterum,"
,"14":"non permisit hominem nocere eis,et corripuit pro eis reges:"
,"15":"' Nolite tangere christos meos,et in prophetis meis nolite malignari '."
,"16":"Et vocavit famem super terram,et omne baculum panis contrivit."
,"17":"Misit ante eos virum, in servum venumdatus est Ioseph."
,"18":"Strinxerunt in compedibus pedes eius, in ferrum intravit collum eius,"
,"19":"donec veniret verbum eius, eloquium Domini purgaret eum."
,"20":"Misit rex et solvit eum, princeps populorum, et dimisit eum;"
,"21":"constituit eum dominum domus suae,et principem omnis possessionis suae,"
,"22":"ut erudiret principes eius sicut semetipsum,et senes eius prudentiam doceret."
,"23":"Et intravit Israel in Aegyptum, et Iacob peregrinus fuit in terra Cham."
,"24":"Et auxit populum suum vehementer,et confortavit eum super inimicos eius."
,"25":"Convertit cor eorum, ut odirent populum eius,et dolum facerent in servos eius."
,"26":"Misit Moysen servum suum, Aaron, quem elegit."
,"27":"Posuit in eis verba signorum suorum,et prodigiorum in terra Cham."
,"28":"Misit tenebras et obscuravit, et restiterunt sermonibus eius."
,"29":"Convertit aquas eorum in sanguinem,et occidit pisces eorum."
,"30":"Edidit terra eorum ranas,in penetralibus regum ipsorum."
,"31":"Dixit, et venit coenomyia,et scinifes in omnibus finibus eorum."
,"32":"Posuit pluvias eorum grandinem, ignem comburentem in terra ipsorum."
,"33":"Et percussit vineas eorum et ficulneas eorum,et contrivit lignum finium eorum."
,"34":"Dixit, et venit locusta,et bruchus, cuius non erat numerus,"
,"35":"et comedit omne fenum in terra eorum,et comedit fructum terrae eorum."
,"36":"Et percussit omne primogenitum in terra eorum, primitias omnis roboris eorum."
,"37":"Et eduxit eos cum argento et auro; et non erat in tribubus eorum infirmus."
,"38":"Laetata est Aegyptus in profectione eorum, quia incubuit timor eorum super eos."
,"39":"Expandit nubem in protectionem,et ignem, ut luceret eis per noctem."
,"40":"Petierunt, et venit coturnix, et pane caeli saturavit eos."
,"41":"Dirupit petram, et fluxerunt aquae, abierunt in sicco flumina."
,"42":"Quoniam memor fuit verbi sancti sui,ad Abraham puerum suum."
,"43":"Et eduxit populum suum in exsultatione, electos suos in laetitia."
,"44":"Et dedit illis regiones gentium, et labores populorum possederunt,"
,"45":"ut custodiant iustificationes eius,et leges eius servent. ALLELUIA."
}`)
	CurrentBook.AddChapter(106, `{
"1":"ALLELUIA. Confitemini Domino, quoniam bonus, quoniam in saeculum misericordia eius."
,"2":"Quis loquetur potentias Domini, auditas faciet omnes laudes eius?"
,"3":"Beati, qui custodiunt iudicium,et faciunt iustitiam in omni tempore."
,"4":"Memento nostri, Domine, in beneplacito populi tui, visita nos in salutari tuo,"
,"5":"ut videamus bona electorum tuorum, ut laetemur in laetitia gentis tuae, ut gloriemur cum hereditate tua."
,"6":"Peccavimus cum patribus nostris, iniuste egimus, iniquitatem fecimus."
,"7":"Patres nostri in Aegypto non intellexerunt mirabilia tua, non fuerunt memores multitudinis misericordiarum tuarum,et irritaverunt ascendentes in mare, mare Rubrum."
,"8":"Et salvavit eos propter nomen suum, ut notam faceret potentiam suam. -"
,"9":"Et increpuit mare Rubrum, et exsiccatum est, et deduxit eos in abyssis sicut in deserto."
,"10":"Et salvavit eos de manu odientis,et redemit eos de manu inimici."
,"11":"Et operuit aqua tribulantes eos: unus ex eis non remansit."
,"12":"Et crediderunt verbis eius,et cantaverunt laudem eius."
,"13":"Cito obliti sunt operum eius,et non sustinuerunt consilium eius;"
,"14":"et concupierunt concupiscentiam in deserto,et tentaverunt Deum in inaquoso."
,"15":"Et dedit eis petitionem ipsorum,et misit saturitatem in animas eorum."
,"16":"Et zelati sunt Moysen in castris, Aaron sanctum Domini."
,"17":"Aperta est terra et deglutivit Dathan,et operuit super congregationem Abiram."
,"18":"Et exarsit ignis in synagoga eorum, flamma combussit peccatores."
,"19":"Et fecerunt vitulum in Horeb,et adoraverunt sculptile;"
,"20":"et mutaverunt gloriam suam,in similitudinem tauri comedentis fenum."
,"21":"Obliti sunt Deum, qui salvavit eos, qui fecit magnalia in Aegypto,"
,"22":"mirabilia in terra Cham, terribilia in mari Rubro."
,"23":"Et dixit quia disperderet eos, nisi affuisset Moyses electus eius: stetit in confractione in conspectu eius, ut averteret iram eius, ne destrueret eos."
,"24":"Et pro nihilo habuerunt terram desiderabilem, non crediderunt verbo eius."
,"25":"Et murmuraverunt in tabernaculis suis, non exaudierunt vocem Domini."
,"26":"Et elevavit manum suam super eos, ut prosterneret eos in deserto"
,"27":"et ut deiceret semen eorum in nationibus,et dispergeret eos in regionibus."
,"28":"Et adhaeserunt Baalphegor,et comederunt sacrificia mortuorum;"
,"29":"et irritaverunt eum in adinventionibus suis, et irrupit in eos ruina."
,"30":"Et stetit Phinees et fecit iudicium, et cessavit quassatio,"
,"31":"et reputatum est ei in iustitiam,in generationem et generationem usque in sempiternum."
,"32":"Et irritaverunt eum ad aquas Meriba, et vexatus est Moyses propter eos,"
,"33":"quia exacerbaverunt spiritum eius, et temere locutus est in labiis suis."
,"34":"Non disperdiderunt gentes, quas dixit Dominus illis."
,"35":"Et commixti sunt inter gentes,et didicerunt opera eorum."
,"36":"Et servierunt sculptilibus eorum, et factum est illis in scandalum."
,"37":"Et immolaverunt filios suos,et filias suas daemoniis."
,"38":"Et effuderunt sanguinem innocentem, sanguinem filiorum suorum et filiarum suarum, quas sacrificaverunt sculptilibus Chanaan. Et infecta est terra in sanguinibus,"
,"39":"et contaminati sunt in operibus suis,et fornicati sunt in adinventionibus suis."
,"40":"Et exarsit ira Dominus in populum suum,et abominatus est hereditatem suam"
,"41":"et tradidit eos in manus gentium, et dominati sunt eorum, qui oderunt eos."
,"42":"Et tribulaverunt eos inimici eorum, et humiliati sunt sub manibus eorum."
,"43":"Saepe liberavit eos; ipsi autem exacerbaverunt eum in consilio suo,et corruerunt in iniquitatibus suis."
,"44":"Et vidit tribulationem eorum, cum audivit clamorem eorum. -"
,"45":"Et memor fuit testamenti sui,et paenituit eum secundum multitudinem misericordiae suae."
,"46":"Et dedit eos in miserationes,in conspectu omnium, qui captivos duxerant eos."
,"47":"Salvos nos fac, Domine Deus noster, et congrega nos de nationibus, ut confiteamur nomini sancto tuo,et gloriemur in laude tua."
,"48":"Benedictus Dominus, Deus Israel, a saeculo et usque in saeculum. Et dicet omnis populus: ' Fiat, fiat '. "
}`)
	CurrentBook.AddChapter(107, `{
"1":"ALLELUIA. Confitemini Domino, quoniam bonus, quoniam in saeculum misericordia eius."
,"2":"Dicant, qui redempti sunt a Domino, quos redemit de manu adversarii"
,"3":"et de regionibus congregavit eos, a solis ortu et occasu, ab aquilone et mari."
,"4":"Erraverunt in solitudine, in inaquoso, viam civitatis habitationis non invenerunt."
,"5":"Esurientes et sitientes, anima eorum in ipsis defecit."
,"6":"Et clamaverunt ad Dominum, cum tribularentur, et de necessitatibus eorum eripuit eos."
,"7":"Et deduxit eos in viam rectam, ut irent in civitatem habitationis."
,"8":"Confiteantur Domino propter misericordiam eius,et mirabilia eius in filios hominum,"
,"9":"quia satiavit animam sitientem,et animam esurientem replevit bonis."
,"10":"Sedentes in tenebris et umbra mortis, vincti in mendicitate et ferro,"
,"11":"quia exacerbaverunt eloquia Dei,et consilium Altissimi spreverunt."
,"12":"Et humiliavit in laboribus cor eorum, infirmati sunt, nec fuit qui adiuvaret."
,"13":"Et clamaverunt ad Dominum, cum tribularentur, et de necessitatibus eorum liberavit eos."
,"14":"Et eduxit eos de tenebris et umbra mortis,et vincula eorum dirupit."
,"15":"Confiteantur Domino propter misericordiam eius,et mirabilia eius in filios hominum,"
,"16":"quia contrivit portas aereas,et vectes ferreos confregit."
,"17":"Stulti facti sunt in via iniquitatis suae,et propter iniustitias suas afflicti sunt;"
,"18":"omnem escam abominata est anima eorum, et appropinquaverunt usque ad portas mortis."
,"19":"Et clamaverunt ad Dominum, cum tribularentur, et de necessitatibus eorum liberavit eos."
,"20":"Misit verbum suum et sanavit eos,et eripuit eos de interitionibus eorum."
,"21":"Confiteantur Domino propter misericordiam eius,et mirabilia eius in filios hominum;"
,"22":"et sacrificent sacrificium laudis,et annuntient opera eius in exsultatione."
,"23":"Qui descendunt mare in navibus, facientes operationem in aquis multis,"
,"24":"ipsi viderunt opera Domini,et mirabilia eius in profundo."
,"25":"Dixit et excitavit spiritum procellae, et exaltati sunt fluctus eius."
,"26":"Ascendunt usque ad caelos,et descendunt usque ad abyssos; anima eorum in malis tabescebat."
,"27":"Turbati sunt et moti sunt sicut ebrius, et omnis sapientia eorum devorata est."
,"28":"Et clamaverunt ad Dominum, cum tribularentur, et de necessitatibus eorum eduxit eos."
,"29":"Et statuit procellam eius in auram, et tacuerunt fluctus eius."
,"30":"Et laetati sunt, quia siluerunt, et deduxit eos in portum voluntatis eorum."
,"31":"Confiteantur Domino propter misericordiam eius,et mirabilia eius in filios hominum;"
,"32":"et exaltent eum in ecclesia plebis,et in conventu seniorum laudent eum."
,"33":"Posuit flumina in desertum,et exitus aquarum in sitim,"
,"34":"terram fructiferam in salsuginem,a malitia inhabitantium in ea."
,"35":"Posuit desertum in stagna aquarum,et terram sine aqua in exitus aquarum."
,"36":"Et collocavit illic esurientes, et constituerunt civitatem habitationis."
,"37":"Et seminaverunt agros et plantaverunt vineas, et fecerunt fructum in proventum suum."
,"38":"Et benedixit eis, et multiplicati sunt nimis, et iumenta eorum non minoravit."
,"39":"Et pauci facti sunt et vexati sunt,a tribulatione malorum et dolore."
,"40":"Effudit contemptionem super principes,et errare fecit eos in deserto invio."
,"41":"Et suscepit pauperem de inopia,et posuit sicut oves familias."
,"42":"Videbunt recti et laetabuntur, et omnis iniquitas oppilabit os suum."
,"43":"Quis sapiens, et custodiet haec,et intelleget misericordias Domini?."
}`)
	CurrentBook.AddChapter(108, `{
"1":"Canticum. PSALMUS. David."
,"2":"Paratum cor meum, Deus, paratum cor meum, cantabo et psallam. Euge, gloria mea!"
,"3":"Exsurge, psalterium et cithara, excitabo auroram."
,"4":"Confitebor tibi in populis, Domine, et psallam tibi in nationibus,"
,"5":"quia magna est usque ad caelos misericordia tua, et usque ad nubes veritas tua."
,"6":"Exaltare super caelos, Deus, et super omnem terram gloria tua."
,"7":"Ut liberentur dilecti tui, salvum fac dextera tua et exaudi me."
,"8":"Deus locutus est in sancto suo: ' Exsultabo et dividam Sichimam,et convallem Succoth dimetiar;"
,"9":"meus est Galaad, et meus est Manasses, et Ephraim fortitudo capitis mei, Iuda sceptrum meum."
,"10":"Moab lebes lavacri mei; super Idumaeam extendam calceamentum meum, super Philistaeam vociferabor '."
,"11":"Quis deducet me in civitatem munitam?,Quis deducet me usque in Idumaeam?."
,"12":"Nonne, Deus, qui reppulisti nos?,Et non exibis, Deus, in virtutibus nostris?"
,"13":"Da nobis auxilium de tribulatione, quia vana salus hominis."
,"14":"In Deo faciemus virtutem, et ipse conculcabit inimicos nostros."
}`)
	CurrentBook.AddChapter(109, `{
"1":"Magistro chori. David. PSALMUS. Deus laudis meae, ne tacueris,"
,"2":"quia os peccatoris et os dolosi super me apertum est. Locuti sunt adversum me lingua dolosa"
,"3":"et sermonibus odii circumdederunt me,et expugnaverunt me gratis."
,"4":"Pro dilectione mea adversabantur mihi; ego autem orabam."
,"5":"Et posuerunt adversum me mala pro bonis,et odium pro dilectione mea."
,"6":"Constitue super eum peccatorem, et adversarius stet a dextris eius."
,"7":"Cum iudicatur, exeat condemnatus, et oratio eius fiat in peccatum."
,"8":"Fiant dies eius pauci, et ministerium eius accipiat alter."
,"9":"Fiant filii eius orphani, et uxor eius vidua."
,"10":"Instabiles vagentur filii eius et mendicent,et eiciantur de ruinis suis. -"
,"11":"Scrutetur fenerator omnem substantiam eius, et diripiant alieni labores eius."
,"12":"Non sit qui praebeat illi misericordiam, nec sit qui misereatur pupillis eius."
,"13":"Fiant nati eius in interitum, in generatione una deleatur nomen eorum."
,"14":"In memoriam redeat iniquitas patrum eius in conspectu Domini, et peccatum matris eius non deleatur."
,"15":"Fiant contra Dominum semper, et disperdat de terra memoriam eorum."
,"16":"Pro eo quod non est recordatus facere misericordiam,et persecutus est hominem inopem et mendicum,et compunctum corde, ut mortificaret."
,"17":"Et dilexit maledictionem: et veniat ei; et noluit benedictionem: et elongetur ab eo."
,"18":"Et induit maledictionem sicut vestimentum: et intret sicut aqua in interiora eius, et sicut oleum in ossa eius."
,"19":"Fiat ei sicut indumentum, quo operitur, et sicut zona, qua semper praecingitur."
,"20":"Haec retributio eorum, qui adversantur mihi apud Dominum, et qui loquuntur mala adversus animam meam."
,"21":"Et tu, Domine, Domine, fac mecum propter nomen tuum, quia suavis est misericordia tua; libera me, "
,"22":"quia egenus et pauper ego sum, et cor meum vulneratum est intra me."
,"23":"Sicut umbra, cum declinat, pertransii, excussus sum sicut locustae."
,"24":"Genua mea infirmata sunt ieiunio, et caro mea contabuit absque oleo."
,"25":"Et ego factus sum opprobrium illis: viderunt me et moverunt capita sua."
,"26":"Adiuva me, Domine Deus meus, salvum me fac secundum misericordiam tuam."
,"27":"Et sciant quia manus tua haec: tu, Domine, hoc fecisti."
,"28":"Maledicant illi, et tu benedicas; qui insurgunt in me, confundantur, servus autem tuus laetabitur."
,"29":"Induantur, qui detrahunt mihi, pudore,et operiantur sicut diploide confusione sua."
,"30":"Confitebor Domino nimis in ore meo,et in medio multorum laudabo eum,"
,"31":"quia astitit a dextris pauperis, ut salvam faceret a iudicantibus animam eius."
}`)
	CurrentBook.AddChapter(110, `{
"1":"David. PSALMUS. Dixit Dominus Domino meo: ' Sede a dextris meis, donec ponam inimicos tuos scabellum pedum tuorum '."
,"2":"Virgam potentiae tuae emittet Dominus ex Sion: dominare in medio inimicorum tuorum."
,"3":"Tecum principatus in die virtutis tuae, in splendoribus sanctis, ex utero ante luciferum genui te."
,"4":"Iuravit Dominus et non paenitebit eum: ' Tu es sacerdos in aeternum secundum ordinem Melchisedech '."
,"5":"Dominus a dextris tuis, conquassabit in die irae suae reges."
,"6":"Iudicabit in nationibus: cumulantur cadavera, conquassabit capita in terra spatiosa."
,"7":"De torrente in via bibet, propterea exaltabit caput."
}`)
	CurrentBook.AddChapter(111, `{
"1":"ALLELUIA. ALEPH. Confitebor Domino in toto corde meo, BETH. in consilio iustorum et congregatione."
,"2":"GHIMEL. Magna opera Domini, DALETH. exquirenda omnibus, qui cupiunt ea."
,"3":"HE. Decor et magnificentia opus eius, VAU. et iustitia eius manet in saeculum saeculi."
,"4":"ZAIN. Memoriam fecit mirabilium suorum, HETH. misericors et miserator Dominus."
,"5":"TETH. Escam dedit timentibus se; IOD. memor erit in saeculum testamenti sui."
,"6":"CAPH. Virtutem operum suorum annuntiavit populo suo, LAMED. ut det illis hereditatem gentium;"
,"7":"MEM. opera manuum eius veritas et iudicium. NUN. Fidelia omnia mandata eius,"
,"8":"SAMECH. confirmata in saeculum saeculi, AIN. facta in veritate et aequitate."
,"9":"PHE. Redemptionem misit populo suo, SADE. mandavit in aeternum testamentum suum. COPH. Sanctum et terribile nomen eius."
,"10":"RES. Initium sapientiae timor Domini, SIN. intellectus bonus omnibus facientibus ea; TAU. laudatio eius manet in saeculum saeculi."
}`)
	CurrentBook.AddChapter(112, `{
"1":"ALLELUIA. ALEPH. Beatus vir, qui timet Dominum, BETH. in mandatis eius cupit nimis."
,"2":"GHIMEL. Potens in terra erit semen eius, DALETH. generatio rectorum benedicetur."
,"3":"HE. Gloria et divitiae in domo eius, VAU. et iustitia eius manet in saeculum saeculi."
,"4":"ZAIN. Exortum est in tenebris lumen rectis, HETH. misericors et miserator et iustus."
,"5":"TETH. Iucundus homo, qui miseretur et commodat, IOD. disponet res suas in iudicio,"
,"6":"CAPH. quia in aeternum non commovebitur. LAMED. In memoria aeterna erit iustus,"
,"7":"MEM. ab auditione mala non timebit. NUN. Paratum cor eius, sperans in Domino,"
,"8":"SAMECH. confirmatum est cor eius, non timebit, AIN. donec despiciat inimicos suos."
,"9":"PHE. Distribuit, dedit pauperibus; SADE. iustitia eius manet in saeculum saeculi, COPH. cornu eius exaltabitur in gloria."
,"10":"RES. Peccator videbit et irascetur, SIN. dentibus suis fremet et tabescet. TAU. Desiderium peccatorum peribit."
}`)
	CurrentBook.AddChapter(113, `{
"1":"ALLELUIA. Laudate, pueri Domini, laudate nomen Domini."
,"2":"Sit nomen Domini benedictum,ex hoc nunc et usque in saeculum."
,"3":"A solis ortu usque ad occasum,laudabile nomen Domini."
,"4":"Excelsus super omnes gentes Dominus, super caelos gloria eius."
,"5":"Quis sicut Dominus Deus noster, qui in altis habitat"
,"6":"et se inclinat, ut respiciat,in caelum et in terram?"
,"7":"Suscitans de terra inopem, de stercore erigens pauperem,"
,"8":"ut collocet eum cum principibus, cum principibus populi sui."
,"9":"Qui habitare facit sterilem in domo, matrem filiorum laetantem."
}`)
	CurrentBook.AddChapter(114, `{
"1":"ALLELUIA. In exitu Israel de Aegypto, domus Iacob de populo barbaro,"
,"2":"factus est Iuda sanctuarium eius, Israel potestas eius."
,"3":"Mare vidit et fugit, Iordanis conversus est retrorsum;"
,"4":"montes saltaverunt ut arietes, et colles sicut agni ovium. -"
,"5":"Quid est tibi, mare, quod fugisti?,Et tu, Iordanis, quia conversus es retrorsum?"
,"6":"Montes, quod saltastis sicut arietes, et colles, sicut agni ovium?"
,"7":"A facie Domini contremisce, terra, a facie Dei Iacob,"
,"8":"qui convertit petram in stagna aquarum,et silicem in fontes aquarum."
}`)
	CurrentBook.AddChapter(115, `{
"1":"Non nobis, Domine, non nobis, sed nomini tuo da gloriam,super misericordia tua et veritate tua."
,"2":"Quare dicent gentes: ' Ubi est Deus eorum? '."
,"3":"Deus autem noster in caelo; omnia, quaecumque voluit, fecit."
,"4":"Simulacra gentium argentum et aurum, opera manuum hominum."
,"5":"Os habent et non loquentur, oculos habent et non videbunt."
,"6":"Aures habent et non audient, nares habent et non odorabunt."
,"7":"Manus habent et non palpabunt, pedes habent et non ambulabunt; non clamabunt in gutture suo."
,"8":"Similes illis erunt, qui faciunt ea, et omnes, qui confidunt in eis."
,"9":"Domus Israel speravit in Domino: adiutorium eorum et scutum eorum est."
,"10":"Domus Aaron speravit in Domino: adiutorium eorum et scutum eorum est."
,"11":"Qui timent Dominum, speraverunt in Domino: adiutorium eorum et scutum eorum est."
,"12":"Dominus memor fuit nostri,et benedicet nobis: benedicet domui Israel, benedicet domui Aaron,"
,"13":"benedicet omnibus, qui timent Dominum, pusillis cum maioribus."
,"14":"Adiciat Dominus super vos, super vos et super filios vestros."
,"15":"Benedicti vos a Domino, qui fecit caelum et terram."
,"16":"Caeli, caeli sunt Domino, terram autem dedit filiis hominum."
,"17":"Non mortui laudabunt te, Domine, neque omnes, qui descendunt in silentium,"
,"18":"sed nos, qui vivimus, benedicimus Domino,ex hoc nunc et usque in saeculum."
}`)
	CurrentBook.AddChapter(116, `{
"1":"ALLELUIA. Dilexi, quoniam exaudit Dominus,vocem deprecationis meae."
,"2":"Quia inclinavit aurem suam mihi, cum in diebus meis invocabam."
,"3":"Circumdederunt me funes mortis, et angustiae inferni invenerunt me. Tribulationem et dolorem inveni"
,"4":"et nomen Domini invocabam: ' O Domine, libera animam meam '."
,"5":"Misericors Dominus et iustus, et Deus noster miseretur."
,"6":"Custodiens parvulos Dominus; humiliatus sum, et salvum me faciet."
,"7":"Convertere, anima mea, in requiem tuam, quia Dominus benefecit tibi;"
,"8":"quia eripuit animam meam de morte, oculos meos a lacrimis, pedes meos a lapsu."
,"9":"Ambulabo coram Domino,in regione vivorum. -"
,"10":"Credidi, etiam cum locutus sum: ' Ego humiliatus sum nimis '."
,"11":"Ego dixi in trepidatione mea: ' Omnis homo mendax '."
,"12":"Quid retribuam Domino,pro omnibus, quae retribuit mihi?"
,"13":"Calicem salutaris accipiam,et nomen Domini invocabo."
,"14":"Vota mea Domino reddam,coram omni populo eius."
,"15":"Pretiosa in conspectu Domini,mors sanctorum eius."
,"16":"O Domine, ego servus tuus, ego servus tuus et filius ancillae tuae. Dirupisti vincula mea:"
,"17":"tibi sacrificabo hostiam laudis,et nomen Domini invocabo."
,"18":"Vota mea Domino reddam,coram omni populo eius"
,"19":"in atriis domus Domini, in medio tui, Ierusalem."
}`)
	CurrentBook.AddChapter(117, `{
"1":"ALLELUIA. Laudate Dominum, omnes gentes; collaudate eum, omnes populi."
,"2":"Quoniam confirmata est super nos misericordia eius, et veritas Domini manet in aeternum."
}`)
	CurrentBook.AddChapter(118, `{
"1":"ALLELUIA. Confitemini Domino, quoniam bonus, quoniam in saeculum misericordia eius."
,"2":"Dicat nunc Israel, quoniam bonus, quoniam in saeculum misericordia eius."
,"3":"Dicat nunc domus Aaron, quoniam in saeculum misericordia eius."
,"4":"Dicant nunc, qui timent Dominum, quoniam in saeculum misericordia eius."
,"5":"De tribulatione invocavi Dominum, et exaudivit me educens in latitudinem Dominus."
,"6":"Dominus mecum, non timebo, quid faciat mihi homo."
,"7":"Dominus mecum adiutor meus, et ego despiciam inimicos meos."
,"8":"Bonum est confugere ad Dominum,quam confidere in homine."
,"9":"Bonum est confugere ad Dominum,quam confidere in principibus."
,"10":"Omnes gentes circuierunt me, et in nomine Domini excidi eos."
,"11":"Circumdantes circumdederunt me, et in nomine Domini excidi eos."
,"12":"Circumdederunt me sicut apes,et exarserunt sicut ignis in spinis, et in nomine Domini excidi eos."
,"13":"Impellentes impulerunt me, ut caderem, et Dominus adiuvit me."
,"14":"Fortitudo mea et laus mea Dominus,et factus est mihi in salutem."
,"15":"Vox iubilationis et salutis,in tabernaculis iustorum: ' Dextera Domini fecit virtutem!"
,"16":"Dextera Domini exaltata est; dextera Domini fecit virtutem! '."
,"17":"Non moriar, sed vivam,et narrabo opera Domini."
,"18":"Castigans castigavit me Dominus,et morti non tradidit me."
,"19":"Aperite mihi portas iustitiae; ingressus in eas confitebor Domino."
,"20":"Haec porta Domini; iusti intrabunt in eam. -"
,"21":"Confitebor tibi, quoniam exaudisti me,et factus es mihi in salutem."
,"22":"Lapidem quem reprobaverunt aedificantes, hic factus est in caput anguli;"
,"23":"a Domino factum est istud,et est mirabile in oculis nostris."
,"24":"Haec est dies, quam fecit Dominus: exsultemus et laetemur in ea."
,"25":"O Domine, salvum me fac; o Domine, da prosperitatem!"
,"26":"Benedictus, qui venit in nomine Domini. Benedicimus vobis de domo Domini."
,"27":"Deus Dominus et illuxit nobis. Instruite sollemnitatem in ramis condensis,usque ad cornua altaris."
,"28":"Deus meus es tu, et confitebor tibi, Deus meus, et exaltabo te."
,"29":"Confitemini Domino, quoniam bonus, quoniam in saeculum misericordia eius."
}`)
	CurrentBook.AddChapter(119, `{
"1":"ALLELUIA. ALEPH. Beati immaculati in via, qui ambulant in lege Domini."
,"2":"Beati, qui servant testimonia eius, in toto corde exquirunt eum."
,"3":"Non enim operati sunt iniquitatem, in viis eius ambulaverunt."
,"4":"Tu mandasti,mandata tua custodiri nimis."
,"5":"Utinam dirigantur viae meae,ad custodiendas iustificationes tuas!"
,"6":"Tunc non confundar, cum perspexero in omnibus praeceptis tuis."
,"7":"Confitebor tibi in directione cordis, in eo quod didici iudicia iustitiae tuae."
,"8":"Iustificationes tuas custodiam, non me derelinquas usquequaque."
,"9":"BETH. In quo mundabit adulescentior viam suam?,In custodiendo sermones tuos."
,"10":"In toto corde meo exquisivi te; ne errare me facias a praeceptis tuis."
,"11":"In corde meo abscondi eloquia tua, ut non peccem tibi."
,"12":"Benedictus es, Domine; doce me iustificationes tuas."
,"13":"In labiis meis,numeravi omnia iudicia oris tui."
,"14":"In via testimoniorum tuorum delectatus sum,sicut in omnibus divitiis."
,"15":"In mandatis tuis exercebor,et considerabo vias tuas."
,"16":"In iustificationibus tuis delectabor, non obliviscar sermonem tuum."
,"17":"GHIMEL. Benefac servo tuo, et vivam,et custodiam sermonem tuum."
,"18":"Revela oculos meos, et considerabo mirabilia de lege tua."
,"19":"Incola ego sum in terra, non abscondas a me praecepta tua."
,"20":"Defecit anima mea in desiderando iudicia tua,in omni tempore."
,"21":"Increpasti superbos; maledicti, qui errant a praeceptis tuis."
,"22":"Aufer a me opprobrium et contemptum, quia testimonia tua servavi."
,"23":"Etsi principes sedent et adversum me loquuntur, servus tamen tuus exercetur in iustificationibus tuis."
,"24":"Nam et testimonia tua delectatio mea, et consilium meum iustificationes tuae."
,"25":"DALETH. Adhaesit pulveri anima mea; vivifica me secundum verbum tuum."
,"26":"Vias meas enuntiavi, et exaudisti me; doce me iustificationes tuas."
,"27":"Viam mandatorum tuorum fac me intellegere, et exercebor in mirabilibus tuis."
,"28":"Lacrimata est anima mea prae maerore; erige me secundum verbum tuum."
,"29":"Viam mendacii averte a me,et legem tuam da mihi benigne."
,"30":"Viam veritatis elegi, iudicia tua proposui mihi."
,"31":"Adhaesi testimoniis tuis, Domine; noli me confundere."
,"32":"Viam mandatorum tuorum curram, quia dilatasti cor meum."
,"33":"HE. Legem pone mihi, Domine, viam iustificationum tuarum, et servabo eam semper."
,"34":"Da mihi intellectum, et servabo legem tuam,et custodiam illam in toto corde meo."
,"35":"Deduc me in semitam praeceptorum tuorum, quia ipsam volui."
,"36":"Inclina cor meum in testimonia tua,et non in avaritiam."
,"37":"Averte oculos meos, ne videant vanitatem; in via tua vivifica me."
,"38":"Suscita servo tuo eloquium tuum, quod est ad timorem tuum."
,"39":"Amove opprobrium meum, quod suspicatus sum, quia iudicia tua iucunda."
,"40":"Ecce concupivi mandata tua; in iustitia tua vivifica me."
,"41":"VAU. Et veniat super me misericordia tua, Domine, salutare tuum secundum eloquium tuum."
,"42":"Et respondebo exprobrantibus mihi verbum, quia speravi in sermonibus tuis."
,"43":"Et ne auferas de ore meo verbum veritatis usquequaque, quia in iudiciis tuis supersperavi."
,"44":"Et custodiam legem tuam semper, in saeculum et in saeculum saeculi."
,"45":"Et ambulabo in latitudine, quia mandata tua exquisivi."
,"46":"Et loquar de testimoniis tuis in conspectu regum,et non confundar."
,"47":"Et delectabor in praeceptis tuis, quae dilexi."
,"48":"Et levabo manus meas ad praecepta tua, quae dilexi; et exercebor in iustificationibus tuis. -"
,"49":"ZAIN. Memor esto verbi tui servo tuo, in quo mihi spem dedisti."
,"50":"Hoc me consolatum est in humiliatione mea, quia eloquium tuum vivificavit me."
,"51":"Superbi deriserunt me vehementer; a lege autem tua non declinavi."
,"52":"Memor fui iudiciorum tuorum a saeculo, Domine, et consolatus sum."
,"53":"Indignatio tenuit me,propter peccatores derelinquentes legem tuam."
,"54":"Cantica factae sunt mihi iustificationes tuae,in loco peregrinationis meae."
,"55":"Memor fui nocte nominis tui, Domine, et custodiam legem tuam."
,"56":"Hoc factum est mihi, quia mandata tua servavi."
,"57":"HETH. Portio mea Dominus: dixi custodire verba tua."
,"58":"Deprecatus sum faciem tuam in toto corde meo; miserere mei secundum eloquium tuum."
,"59":"Cogitavi vias meas,et converti pedes meos in testimonia tua."
,"60":"Festinavi et non sum moratus, ut custodiam praecepta tua."
,"61":"Funes peccatorum circumplexi sunt me, et legem tuam non sum oblitus."
,"62":"Media nocte surgebam ad confitendum tibi,super iudicia iustitiae tuae."
,"63":"Particeps ego sum omnium timentium te,et custodientium mandata tua."
,"64":"Misericordia tua, Domine, plena est terra; iustificationes tuas doce me."
,"65":"TETH. Bonitatem fecisti cum servo tuo, Domine, secundum verbum tuum."
,"66":"Bonitatem et prudentiam et scientiam doce me, quia praeceptis tuis credidi."
,"67":"Priusquam humiliarer ego erravi; nunc autem eloquium tuum custodiam."
,"68":"Bonus es tu et benefaciens, doce me iustificationes tuas."
,"69":"Excogitaverunt contra me dolosa superbi, ego autem in toto corde meo servabo mandata tua."
,"70":"Incrassatum est sicut adeps cor eorum, ego vero in lege tua delectatus sum."
,"71":"Bonum mihi quia humiliatus sum, ut discam iustificationes tuas."
,"72":"Bonum mihi lex oris tui,super milia auri et argenti."
,"73":"IOD. Manus tuae fecerunt me et plasmaverunt me; da mihi intellectum, et discam praecepta tua."
,"74":"Qui timent te, videbunt me et laetabuntur, quia in verba tua supersperavi."
,"75":"Cognovi, Domine, quia aequitas iudicia tua, et in veritate humiliasti me."
,"76":"Fiat misericordia tua, ut consoletur me, secundum eloquium tuum servo tuo."
,"77":"Veniant mihi miserationes tuae, et vivam, quia lex tua delectatio mea est."
,"78":"Confundantur superbi, quoniam dolose incurvaverunt me, ego autem exercebor in mandatis tuis."
,"79":"Convertantur mihi timentes te, et qui noverunt testimonia tua."
,"80":"Fiat cor meum immaculatum in iustificationibus tuis, ut non confundar."
,"81":"CAPH. Defecit in salutare tuum anima mea, et in verbum tuum supersperavi."
,"82":"Defecerunt oculi mei in eloquium tuum, dicentes: ' Quando consolaberis me? '."
,"83":"Quia factus sum sicut uter in fumo; iustificationes tuas non sum oblitus."
,"84":"Quot sunt dies servi tui?,Quando facies de persequentibus me iudicium?"
,"85":"Foderunt mihi foveas superbi, qui non sunt secundum legem tuam."
,"86":"Omnia praecepta tua veritas; dolose persecuti sunt me; adiuva me."
,"87":"Paulo minus consummaverunt me in terra, ego autem non dereliqui mandata tua."
,"88":"Secundum misericordiam tuam vivifica me, et custodiam testimonia oris tui. -"
,"89":"LAMED. In aeternum, Domine, verbum tuum constitutum est in caelo."
,"90":"In generationem et generationem veritas tua; firmasti terram, et permanet."
,"91":"Secundum iudicia tua permanent hodie, quoniam omnia serviunt tibi."
,"92":"Nisi quod lex tua delectatio mea est, tunc forte periissem in humilia tione mea."
,"93":"In aeternum non obliviscar man data tua, quia in ipsis vivificasti me."
,"94":"Tuus sum ego: salvum me fac, quoniam mandata tua exqui sivi."
,"95":"Me exspectaverunt peccatores, ut perderent me; testimonia tua intellexi."
,"96":"Omni consummationi vidi finem, latum praeceptum tuum nimis."
,"97":"MEM. Quomodo dilexi legem tuam, Domine; tota die meditatio mea est."
,"98":"Super inimicos meos sapientem me fecit praeceptum tuum, quia in aeternum mihi est."
,"99":"Super omnes docentes me prudens factus sum, quia testimonia tua meditatio mea est."
,"100":"Super senes intellexi, quia mandata tua servavi."
,"101":"Ab omni via mala prohibui pedes meos, ut custodiam verba tua."
,"102":"A iudiciis tuis non declinavi, quia tu legem posuisti mihi."
,"103":"Quam dulcia faucibus meis eloquia tua, super mel ori meo."
,"104":"A mandatis tuis intellexi; propterea odivi omnem viam mendacii."
,"105":"NUN. Lucerna pedibus meis verbum tuum,et lumen semitis meis."
,"106":"Iuravi et statui,custodire iudicia iustitiae tuae."
,"107":"Humiliatus sum usquequaque, Domine; vivifica me secundum verbum tuum."
,"108":"Voluntaria oris mei beneplacita sint, Domine, et iudicia tua doce me."
,"109":"Anima mea in manibus meis semper, et legem tuam non sum oblitus."
,"110":"Posuerunt peccatores laqueum mihi, et de mandatis tuis non erravi."
,"111":"Hereditas mea testimonia tua in aeternum, quia exsultatio cordis mei sunt."
,"112":"Inclinavi cor meum ad faciendas iustificationes tuas,in aeternum, in finem."
,"113":"SAMECH. Duplices corde odio habui,et legem tuam dilexi."
,"114":"Tegmen et scutum meum es tu, et in verbum tuum supersperavi."
,"115":"Declinate a me, maligni, et servabo praecepta Dei mei."
,"116":"Suscipe me secundum eloquium tuum, et vivam; et non confundas me ab exspectatione mea."
,"117":"Sustenta me, et salvus ero,et delectabor in iustificationibus tuis semper."
,"118":"Sprevisti omnes discedentes a iustificationibus tuis, quia mendacium cogitatio eorum."
,"119":"Quasi scoriam delesti omnes peccatores terrae; ideo dilexi testimonia tua."
,"120":"Horruit a timore tuo caro mea; a iudiciis enim tuis timui."
,"121":"AIN. Feci iudicium et iustitiam; non tradas me calumniantibus me."
,"122":"Sponde pro servo tuo in bonum; non calumnientur me superbi."
,"123":"Oculi mei defecerunt in desiderio salutaris tui,et eloquii iustitiae tuae."
,"124":"Fac cum servo tuo secundum misericordiam tuam,et iustificationes tuas doce me."
,"125":"Servus tuus sum ego; da mihi intellectum, ut sciam testimonia tua."
,"126":"Tempus faciendi Domino; dissipaverunt legem tuam."
,"127":"Ideo dilexi praecepta tua,super aurum et obryzum."
,"128":"Propterea ad omnia mandata tua dirigebar, omnem viam mendacii odio habui. -"
,"129":"PHE. Mirabilia testimonia tua, ideo servavit ea anima mea."
,"130":"Declaratio sermonum tuorum illuminat,et intellectum dat parvulis."
,"131":"Os meum aperui et attraxi spiritum, quia praecepta tua desiderabam."
,"132":"Convertere in me et miserere mei,secundum iudicium tuum cum diligentibus nomen tuum."
,"133":"Gressus meos dirige secundum eloquium tuum, et non dominetur mei omnis iniquitas."
,"134":"Redime me a calumniis hominum, ut custodiam mandata tua."
,"135":"Faciem tuam illumina super servum tuum,et doce me iustificationes tuas."
,"136":"Rivulos aquarum deduxerunt oculi mei, quia non custodierunt legem tuam."
,"137":"SADE. Iustus es, Domine, et rectum iudicium tuum."
,"138":"Mandasti in iustitia testimonia tua,et in veritate nimis."
,"139":"Consumpsit me zelus meus, quia obliti sunt verba tua inimici mei."
,"140":"Ignitum eloquium tuum vehementer, et servus tuus dilexit illud."
,"141":"Adulescentulus sum ego et contemptus; mandata tua non sum oblitus."
,"142":"Iustitia tua iustitia in aeternum, et lex tua veritas."
,"143":"Tribulatio et angustia invenerunt me; praecepta tua delectatio mea est."
,"144":"Iustitia testimonia tua in aeternum; intellectum da mihi, et vivam."
,"145":"COPH. Clamavi in toto corde, exaudi me, Domine; iustificationes tuas servabo."
,"146":"Clamavi ad te, salvum me fac, ut custodiam testimonia tua."
,"147":"Praeveni diluculo et clamavi, in verba tua supersperavi."
,"148":"Praevenerunt oculi mei vigilias, ut meditarer eloquia tua."
,"149":"Vocem meam audi secundum misericordiam tuam, Domine, secundum iudicium tuum vivifica me."
,"150":"Appropinquaverunt persequentes me in malitia, a lege autem tua longe facti sunt."
,"151":"Prope es tu, Domine, et omnia praecepta tua veritas."
,"152":"Ab initio cognovi de testimoniis tuis, quia in aeternum fundasti ea."
,"153":"RES. Vide humiliationem meam et eripe me, quia legem tuam non sum oblitus."
,"154":"Iudica causam meam et redime me; propter eloquium tuum vivifica me."
,"155":"Longe a peccatoribus salus, quia iustificationes tuas non exquisierunt."
,"156":"Misericordiae tuae multae, Domine; secundum iudicia tua vivifica me."
,"157":"Multi, qui persequuntur me et tribulant me; a testimoniis tuis non declinavi."
,"158":"Vidi praevaricantes, et taeduit me, quia eloquia tua non custodierunt."
,"159":"Vide quoniam mandata tua dilexi, Domine; secundum misericordiam tuam vivifica me."
,"160":"Principium verborum tuorum veritas, in aeternum omnia iudicia iustitiae tuae."
,"161":"SIN. Principes persecuti sunt me gratis, et a verbis tuis formidavit cor meum."
,"162":"Laetabor ego super eloquia tua, sicut qui invenit spolia multa."
,"163":"Mendacium odio habui et abominatus sum; legem autem tuam dilexi."
,"164":"Septies in die laudem dixi tibi,super iudicia iustitiae tuae."
,"165":"Pax multa diligentibus legem tuam, et non est illis scandalum."
,"166":"Exspectabam salutare tuum, Domine, et praecepta tua feci."
,"167":"Custodivit anima mea testimonia tua, et dilexi ea vehementer."
,"168":"Servavi mandata tua et testimonia tua, quia omnes viae meae in conspectu tuo."
,"169":"TAU. Appropinquet deprecatio mea in conspectu tuo, Domine; iuxta verbum tuum da mihi intellectum."
,"170":"Intret postulatio mea in conspectu tuo; secundum eloquium tuum libera me."
,"171":"Eructabunt labia mea hymnum, cum docueris me iustificationes tuas."
,"172":"Cantet lingua mea eloquium tuum, quia omnia praecepta tua iustitia."
,"173":"Fiat manus tua, ut adiuvet me, quoniam mandata tua elegi."
,"174":"Concupivi salutare tuum, Domine, et lex tua delectatio mea est."
,"175":"Vivet anima mea et laudabit te, et iudicia tua adiuvabunt me."
,"176":"Erravi sicut ovis, quae periit; quaere servum tuum, quia praecepta tua non sum oblitus."
}`)
	CurrentBook.AddChapter(120, `{
"1":"Canticum ascensionum. Ad Dominum, cum tribularer, clamavi, et exaudivit me."
,"2":"Domine, libera animam meam a labiis mendacii, a lingua dolosa."
,"3":"Quid detur tibi aut quid apponatur tibi, lingua dolosa?"
,"4":"Sagittae potentis acutae,cum carbonibus iuniperorum."
,"5":"Heu mihi, quia peregrinatus sum in Mosoch, habitavi ad tabernacula Cedar!"
,"6":"Multum incola fuit anima mea,cum his, qui oderunt pacem."
,"7":"Ego eram pacificus; cum loquebar, illi impugnabant me."
}`)
	CurrentBook.AddChapter(121, `{
"1":"Canticum ascensionum. Levabo oculos meos in montes: unde veniet auxilium mihi?"
,"2":"Auxilium meum a Domino, qui fecit caelum et terram."
,"3":"Non dabit in commotionem pedem tuum,neque dormitabit, qui custodit te."
,"4":"Ecce non dormitabit neque dormiet, qui custodit Israel."
,"5":"Dominus custodit te, Dominus umbraculum tuum,ad manum dexteram tuam."
,"6":"Per diem sol non percutiet te, neque luna per noctem."
,"7":"Dominus custodiet te ab omni malo; custodiet animam tuam Dominus."
,"8":"Dominus custodiet introitum tuum et exitum tuum,ex hoc nunc et usque in saeculum."
}`)
	CurrentBook.AddChapter(122, `{
"1":"Canticum ascensionum. David. Laetatus sum in eo, quod dixerunt mihi: ' In domum Domini ibimus '."
,"2":"Stantes iam sunt pedes nostri,in portis tuis, Ierusalem."
,"3":"Ierusalem, quae aedificata est ut civitas, sibi compacta in idipsum."
,"4":"Illuc enim ascenderunt tribus, tribus Domini, testimonium Israel, ad confitendum nomini Domini."
,"5":"Quia illic sederunt sedes ad iudicium, sedes domus David."
,"6":"Rogate, quae ad pacem sunt Ierusalem: ' Securi sint diligentes te!"
,"7":"Fiat pax in muris tuis, et securitas in turribus tuis! '."
,"8":"Propter fratres meos et proximos meos,loquar: ' Pax in te! '."
,"9":"Propter domum Domini Dei nostri,exquiram bona tibi."
}`)
	CurrentBook.AddChapter(123, `{
"1":"Canticum ascensionum. Ad te levavi oculos meos, qui habitas in caelis."
,"2":"Ecce sicut oculi servorum ad manus dominorum suorum, sicut oculi ancillae ad manus dominae suae, ita oculi nostri ad Dominum Deum nostrum, donec misereatur nostri."
,"3":"Miserere nostri, Domine, miserere nostri, quia multum repleti sumus despectione;"
,"4":"quia multum repleta est anima nostra,derisione abundantium et despectione superborum."
}`)
	CurrentBook.AddChapter(124, `{
"1":"Canticum ascensionum. David. Nisi quia Dominus erat in nobis, dicat nunc Israel,"
,"2":"nisi quia Dominus erat in nobis, cum exsurgerent homines in nos:"
,"3":"forte vivos deglutissent nos, cum irasceretur furor eorum in nos."
,"4":"Forsitan aqua absorbuisset nos, torrens pertransisset animam nostram;"
,"5":"forsitan pertransissent animam nostram,aquae intumescentes."
,"6":"Benedictus Dominus, qui non dedit nos in direptionem dentibus eorum."
,"7":"Anima nostra sicut passer erepta est,de laqueo venantium: laqueus contritus est, et nos erepti sumus."
,"8":"Adiutorium nostrum in nomine Domini, qui fecit caelum et terram."
}`)
	CurrentBook.AddChapter(125, `{
"1":"Canticum ascensionum. Qui confidunt in Domino, sicut mons Sion: non commovebitur, in aeternum manet."
,"2":"Ierusalem, montes in circuitu eius, et Dominus in circuitu populi sui,ex hoc nunc et usque in saeculum."
,"3":"Quia non requiescet virga iniquitatis super sortem iustorum, ut non extendant iusti ad iniquitatem manus suas."
,"4":"Benefac, Domine, bonis,et rectis corde."
,"5":"Declinantes autem per vias pravas,adducet Dominus cum operantibus iniquitatem. Pax super Israel!"
}`)
	CurrentBook.AddChapter(126, `{
"1":"Canticum ascensionum. In convertendo Dominus captivitatem Sion, facti sumus quasi somniantes."
,"2":"Tunc repletum est gaudio os nostrum, et lingua nostra exsultatione. Tunc dicebant inter gentes: ' Magnificavit Dominus facere cum eis '."
,"3":"Magnificavit Dominus facere nobiscum; facti sumus laetantes."
,"4":"Converte, Domine, captivitatem nostram, sicut torrentes in austro."
,"5":"Qui seminant in lacrimis, in exsultatione metent."
,"6":"Euntes ibant et flebant,semen spargendum portantes; venientes autem venient in exsultatione,portantes manipulos suos."
}`)
	CurrentBook.AddChapter(127, `{
"1":"Canticum ascensionum. Salomonis. Nisi Dominus aedificaverit domum, in vanum laborant, qui aedificant eam. Nisi Dominus custodierit civitatem, frustra vigilat, qui custodit eam."
,"2":"Vanum est vobis ante lucem surgere et sero quiescere, qui manducatis panem laboris, quia dabit dilectis suis somnum."
,"3":"Ecce hereditas Domini filii, merces fructus ventris."
,"4":"Sicut sagittae in manu potentis, ita filii iuventutis."
,"5":"Beatus vir, qui implevit pharetram suam ex ipsis: non confundetur, cum loquetur inimicis suis in porta."
}`)
	CurrentBook.AddChapter(128, `{
"1":"Canticum ascensionum. Beatus omnis, qui timet Dominum, qui ambulat in viis eius."
,"2":"Labores manuum tuarum manducabis, beatus es, et bene tibi erit."
,"3":"Uxor tua sicut vitis fructifera,in lateribus domus tuae; filii tui sicut novellae olivarum,in circuitu mensae tuae."
,"4":"Ecce sic benedicetur homo, qui timet Dominum."
,"5":"Benedicat tibi Dominus ex Sion, et videas bona Ierusalem,omnibus diebus vitae tuae;"
,"6":"et videas filios filiorum tuorum. Pax super Israel!"
}`)
	CurrentBook.AddChapter(129, `{
"1":"Canticum ascensionum. Saepe expugnaverunt me a iuventute mea, dicat nunc Israel,"
,"2":"saepe expugnaverunt me a iuventute mea, etenim non potuerunt adversum me."
,"3":"Supra dorsum meum araverunt aratores, prolongaverunt sulcos suos."
,"4":"Dominus autem iustus,concidit cervices peccatorum."
,"5":"Confundantur et convertantur retrorsum,omnes, qui oderunt Sion."
,"6":"Fiant sicut fenum tectorum, quod, priusquam evellatur, exaruit;"
,"7":"de quo non implevit manum suam, qui metit, et sinum suum, qui manipulos colligit."
,"8":"Et non dixerunt, qui praeteribant: ' Benedictio Domini super vos, benedicimus vobis in nomine Domini '."
}`)
	CurrentBook.AddChapter(130, `{
"1":"Canticum ascensionum. De profundis clamavi ad te, Domine;"
,"2":"Domine, exaudi vocem meam. Fiant aures tuae intendentes,in vocem deprecationis meae."
,"3":"Si iniquitates observaveris, Domine, Domine, quis sustinebit?"
,"4":"Quia apud te propitiatio est, ut timeamus te."
,"5":"Sustinui te, Domine, sustinuit anima mea in verbo eius; speravit 6 anima mea in Domino,magis quam custodes auroram. Magis quam custodes auroram"
,"7":"speret Israel in Domino, quia apud Dominum misericordia, et copiosa apud eum redemptio."
,"8":"Et ipse redimet Israel,ex omnibus iniquitatibus eius."
}`)
	CurrentBook.AddChapter(131, `{
"1":"Canticum ascensionum. David. Domine, non est exaltatum cor meum, neque elati sunt oculi mei, neque ambulavi in magnis,neque in mirabilibus super me."
,"2":"Vere pacatam et quietam,feci animam meam; sicut ablactatus in sinu matris suae, sicut ablactatus, ita in me est anima mea."
,"3":"Speret Israel in Domino,ex hoc nunc et usque in saeculum."
}`)
	CurrentBook.AddChapter(132, `{
"1":"Canticum ascensionum. Memento, Domine, David,et omnis mansuetudinis eius,"
,"2":"quia iuravit Domino, votum vovit Potenti Iacob:"
,"3":"' Non introibo in tabernaculum domus meae, non ascendam in lectum strati mei,"
,"4":"non dabo somnum oculis meis,et palpebris meis dormitationem,"
,"5":"donec inveniam locum Domino, tabernaculum Potenti Iacob '."
,"6":"Ecce audivimus eam esse in Ephratha, invenimus eam in campis Iaar."
,"7":"Ingrediamur in tabernaculum eius, adoremus ad scabellum pedum eius. -"
,"8":"Surge, Domine, in requiem tuam, tu et arca fortitudinis tuae."
,"9":"Sacerdotes tui induantur iustitiam, et sancti tui exsultent."
,"10":"Propter David servum tuum,non avertas faciem christi tui."
,"11":"Iuravit Dominus David veritatem,et non recedet ab ea: ' De fructu ventris tui,ponam super sedem tuam."
,"12":"Si custodierint filii tui testamentum meum,et testimonia mea, quae docebo eos, filii eorum usque in saeculum,sedebunt super sedem tuam '."
,"13":"Quoniam elegit Dominus Sion, desideravit eam in habitationem sibi:"
,"14":"' Haec requies mea in saeculum saeculi; hic habitabo, quoniam desideravi eam."
,"15":"Cibaria eius benedicens benedicam, pauperes eius saturabo panibus."
,"16":"Sacerdotes eius induam salutari, et sancti eius exsultatione exsultabunt."
,"17":"Illic germinare faciam cornu David, parabo lucernam christo meo."
,"18":"Inimicos eius induam confusione, super ipsum autem efflorebit diadema eius '."
}`)
	CurrentBook.AddChapter(133, `{
"1":"Canticum ascensionum. David. Ecce quam bonum et quam iucundum,habitare fratres in unum:"
,"2":"sicut unguentum optimum in capite, quod descendit in barbam, barbam Aaron, quod descendit in oram vestimenti eius;"
,"3":"sicut ros Hermon, qui descendit in montes Sion, quoniam illic mandavit Dominus benedictionem, vitam usque in saeculum."
}`)
	CurrentBook.AddChapter(134, `{
"1":"Canticum ascensionum. Ecce benedicite Dominum, omnes servi Domini, qui statis in domo Domini per noctes."
,"2":"Extollite manus vestras ad sanctuarium,et benedicite Dominum."
,"3":"Benedicat te Dominus ex Sion, qui fecit caelum et terram."
}`)
	CurrentBook.AddChapter(135, `{
"1":"ALLELUIA. Laudate nomen Domini, laudate, servi Domini,"
,"2":"qui statis in domo Domini, in atriis domus Dei nostri."
,"3":"Laudate Dominum, quia bonus Dominus; psallite nomini eius, quoniam suave."
,"4":"Quoniam Iacob elegit sibi Dominus, Israel in peculium sibi."
,"5":"Quia ego cognovi quod magnus est Dominus, et Deus noster prae omnibus diis."
,"6":"Omnia, quaecumque voluit, Dominus fecit in caelo et in terra, in mari et in omnibus abyssis."
,"7":"Adducens nubes ab extremo terrae, fulgura in pluviam facit, producit ventos de thesauris suis."
,"8":"Qui percussit primogenita Aegypti,ab homine usque ad pecus."
,"9":"Misit signa et prodigia in medio tui, Aegypte, in pharaonem et in omnes servos eius."
,"10":"Qui percussit gentes multas,et occidit reges fortes:"
,"11":"Sehon regem Amorraeorum,et Og regem Basan,et omnia regna Chanaan."
,"12":"Et dedit terram eorum hereditatem, hereditatem Israel populo suo."
,"13":"Domine, nomen tuum in aeternum; Domine, memoriale tuum in generationem et generationem."
,"14":"Quia iudicabit Dominus populum suum,et servorum suorum miserebitur."
,"15":"Simulacra gentium argentum et aurum, opera manuum hominum."
,"16":"Os habent et non loquentur, oculos habent et non videbunt."
,"17":"Aures habent et non audient; neque enim est spiritus in ore ipsorum."
,"18":"Similes illis erunt, qui faciunt ea, et omnes, qui confidunt in eis."
,"19":"Domus Israel, benedicite Domino; domus Aaron, benedicite Domino;"
,"20":"domus Levi, benedicite Domino; qui timetis Dominum, benedicite Domino."
,"21":"Benedictus Dominus ex Sion, qui habitat in Ierusalem. ALLELUIA."
}`)
	CurrentBook.AddChapter(136, `{
"1":"ALLELUIA. Confitemini Domino, quoniam bonus, quoniam in aeternum misericordia eius."
,"2":"Confitemini Deo deorum, quoniam in aeternum misericordia eius."
,"3":"Confitemini Domino dominorum, quoniam in aeternum misericordia eius."
,"4":"Qui facit mirabilia magna solus, quoniam in aeternum misericordia eius."
,"5":"Qui fecit caelos in intellectu, quoniam in aeternum misericordia eius."
,"6":"Qui expandit terram super aquas, quoniam in aeternum misericordia eius."
,"7":"Qui fecit luminaria magna, quoniam in aeternum misericordia eius:"
,"8":"solem, ut praeesset diei, quoniam in aeternum misericordia eius;"
,"9":"lunam et stellas, ut praeessent nocti, quoniam in aeternum misericordia eius."
,"10":"Qui percussit Aegyptum in primogenitis eorum, quoniam in aeternum misericordia eius."
,"11":"Qui eduxit Israel de medio eorum, quoniam in aeternum misericordia eius,"
,"12":"in manu potenti et brachio extento, quoniam in aeternum misericordia eius."
,"13":"Qui divisit mare Rubrum in divisiones, quoniam in aeternum misericordia eius."
,"14":"Et traduxit Israel per medium eius, quoniam in aeternum misericordia eius."
,"15":"Et excussit pharaonem et virtutem eius in mari Rubro, quoniam in aeternum misericordia eius."
,"16":"Qui traduxit populum suum per desertum, quoniam in aeternum misericordia eius."
,"17":"Qui percussit reges magnos, quoniam in aeternum misericordia eius;"
,"18":"et occidit reges potentes, quoniam in aeternum misericordia eius:"
,"19":"Sehon regem Amorraeorum, quoniam in aeternum misericordia eius;"
,"20":"et Og regem Basan, quoniam in aeternum misericordia eius."
,"21":"Et dedit terram eorum hereditatem, quoniam in aeternum misericordia eius,"
,"22":"hereditatem Israel servo suo, quoniam in aeternum misericordia eius."
,"23":"Qui in humilitate nostra memor fuit nostri, quoniam in aeternum misericordia eius;"
,"24":"et redemit nos ab inimicis nostris, quoniam in aeternum misericordia eius."
,"25":"Qui dat escam omni carni, quoniam ìn aeternum misericordia eius."
,"26":"Confitemini Deo caeli, quoniam in aeternum misericordia eius."
}`)
	CurrentBook.AddChapter(137, `{
"1":"Super flumina Babylonis, illic sedimus et flevimus, cum recordaremur Sion."
,"2":"In salicibus in medio eius,suspendimus citharas nostras."
,"3":"Quia illic rogaverunt nos, qui captivos duxerunt nos, verba cantionum, et, qui affligebant nos, laetitiam: ' Cantate nobis de canticis Sion '."
,"4":"Quomodo cantabimus canticum Domini,in terra aliena?"
,"5":"Si oblitus fuero tui, Ierusalem, oblivioni detur dextera mea;"
,"6":"adhaereat lingua mea faucibus meis, si non meminero tui, si non praeposuero Ierusalem,in capite laetitiae meae."
,"7":"Memor esto, Domine, adversus filios Edom,diei Ierusalem; qui dicebant: ' Exinanite, exinanite,usque ad fundamentum in ea '."
,"8":"Filia Babylonis devastans, beatus, qui retribuet tibi retributionem tuam, quam retribuisti nobis;"
,"9":"beatus, qui tenebit,et allidet parvulos tuos ad petram."
}`)
	CurrentBook.AddChapter(138, `{
"1":"David. Confitebor tibi, Domine, in toto corde meo, quoniam audisti verba oris mei. In conspectu angelorum psallam tibi,"
,"2":"adorabo ad templum sanctum tuum; et confitebor nomini tuo,propter misericordiam tuam et veritatem tuam, quoniam magnificasti super omne nomen eloquium tuum."
,"3":"In quacumque die invocavero te, exaudi me; multiplicabis in anima mea virtutem."
,"4":"Confitebuntur tibi, Domine, omnes reges terrae, quia audierunt eloquia oris tui."
,"5":"Et cantabunt vias Domini, quoniam magna est gloria Domini;"
,"6":"quoniam excelsus Dominus et humilem respicit,et superbum a longe cognoscit."
,"7":"Si ambulavero in medio tribulationis, vivificabis me; et contra iram inimicorum meorum extendes manum tuam, et salvum me faciet dextera tua."
,"8":"Dominus perficiet pro me; Domine, misericordia tua in saeculum: opera manuum tuarum ne despicias."
}`)
	CurrentBook.AddChapter(139, `{
"1":"Magistro chori. David. PSALMUS. Domine, scrutatus es et cognovisti me,"
,"2":"tu cognovisti sessionem meam et resurrectionem meam. Intellexisti cogitationes meas de longe,"
,"3":"semitam meam et accubitum meum investigasti. Et omnes vias meas perspexisti,"
,"4":"quia nondum est sermo in lingua mea, et ecce, Domine, tu novisti omnia."
,"5":"A tergo et a fronte coartasti me,et posuisti super me manum tuam."
,"6":"Mirabilis nimis facta est scientia tua super me, sublimis, et non attingam eam."
,"7":"Quo ibo a spiritu tuo,et quo a facie tua fugiam?"
,"8":"Si ascendero in caelum, tu illic es; si descendero in infernum, ades."
,"9":"Si sumpsero pennas aurorae,et habitavero in extremis maris,"
,"10":"etiam illuc manus tua deducet me, et tenebit me dextera tua."
,"11":"Si dixero: ' Forsitan tenebrae compriment me, et nox illuminatio erit circa me ',"
,"12":"etiam tenebrae non obscurabuntur a te, et nox sicut dies illuminabitur,C sicut tenebrae eius ita et lumen eius -."
,"13":"Quia tu formasti renes meos, contexuisti me in utero matris meae."
,"14":"Confitebor tibi, quia mirabiliter plasmatus sum; mirabilia opera tua, et anima mea cognoscit nimis."
,"15":"Non sunt abscondita ossa mea a te, cum factus sum in occulto, contextus in inferioribus terrae."
,"16":"Imperfectum adhuc me viderunt oculi tui, et in libro tuo scripti erant omnes dies: ficti erant, et nondum erat unus ex eis."
,"17":"Mihi autem nimis pretiosae cogitationes tuae, Deus; nimis gravis summa earum."
,"18":"Si dinumerabo eas, super arenam multiplicabuntur; si ad finem pervenerim, adhuc sum tecum."
,"19":"Utinam occidas, Deus, peccatores; viri sanguinum, declinate a me."
,"20":"Qui loquuntur contra te maligne: exaltantur in vanum contra te."
,"21":"Nonne, qui oderunt te, Domine, oderam,et insurgentes in te abhorrebam?"
,"22":"Perfecto odio oderam illos, et inimici facti sunt mihi."
,"23":"Scrutare me, Deus, et scito cor meum; proba me et cognosce semitas meas"
,"24":"et vide, si via vanitatis in me est, et deduc me in via aeterna."
}`)
	CurrentBook.AddChapter(140, `{
"1":"Magistro chori. PSALMUS. David."
,"2":"Eripe me, Domine, ab homine malo, a viro violentiae serva me."
,"3":"Qui cogitaverunt mala in corde, tota die constituebant proelia."
,"4":"Acuerunt linguas suas sicut serpentis, venenum aspidum sub labiis eorum."
,"5":"Custodi me, Domine, de manu peccatoris,et a viro violentiae serva me, qui cogitaverunt supplantare gressus meos."
,"6":"Absconderunt superbi laqueum mihi,et funes extenderunt in rete, iuxta iter offendicula posuerunt mihi."
,"7":"Dixi Domino: ' Deus meus es tu; auribus percipe, Domine, vocem deprecationis meae '."
,"8":"Domine, Domine, virtus salutis meae, obumbrasti caput meum in die belli."
,"9":"Ne concedas, Domine, desideria impii; consilia eius ne perficias. Exaltant 10 caput, qui circumdant me; malitia labiorum ipsorum operiat eos."
,"11":"Cadant super eos carbones ignis, in foveas deicias eos, et non exsurgant."
,"12":"Vir linguosus non firmabitur in terra, virum violentiae mala capient in interitu."
,"13":"Cognovi quia faciet Dominus iudicium inopis,et vindictam pauperum."
,"14":"Verumtamen iusti confitebuntur nomini tuo, et habitabunt recti in conspectu tuo."
}`)
	CurrentBook.AddChapter(141, `{
"1":"PSALMUS. David. Domine, clamavi ad te, ad me festina; intende voci meae, cum clamo ad te."
,"2":"Dirigatur oratio mea sicut incensum in conspectu tuo, elevatio manuum mearum ut sacrificium vespertinum. -"
,"3":"Pone, Domine, custodiam ori meo,et vigiliam ad ostium labiorum meorum."
,"4":"Non declines cor meum in verbum malitiae,ad machinandas machinationes in impietate,cum hominibus operantibus iniquitatem; et non comedam ex deliciis eorum."
,"5":"Percutiat me iustus in misericordia et increpet me; oleum autem peccatoris non impinguet caput meum, quoniam adhuc et oratio mea in malitiis eorum."
,"6":"Deiecti in manus duras iudicum eorum, audient verba mea, quoniam suavia erant."
,"7":"Sicut frusta dolantis et dirumpentis in terra, dissipata sunt ossa eorum ad fauces inferni."
,"8":"Quia ad te, Domine, Domine, oculi mei; ad te confugi, non effundas animam meam."
,"9":"Custodi me a laqueo, quem statuerunt mihi, et a scandalis operantium iniquitatem."
,"10":"Cadent in retiacula sua peccatores simul, ego autem ultra pertranseam."
}`)
	CurrentBook.AddChapter(142, `{
"1":"Maskil. David, cum esset in caverna. Precatio."
,"2":"Voce mea ad Dominum clamo, voce mea ad Dominum deprecor;"
,"3":"effundo in conspectu eius lamentationem meam, et tribulationem meam ante ipsum pronuntio."
,"4":"Cum deficit in me spiritus meus, tu nosti semitas meas. In via, qua ambulabam, absconderunt laqueum mihi."
,"5":"Considerabam ad dexteram et videbam, et non erat qui cognosceret me. Periit fuga a me, et non est qui requirat animam meam. -"
,"6":"Clamavi ad te, Domine; dixi: ' Tu es refugium meum, portio mea in terra viventium."
,"7":"Intende ad deprecationem meam, quia humiliatus sum nimis. Libera me a persequentibus me, quia confortati sunt super me."
,"8":"Educ de custodia animam meam,ad confitendum nomini tuo; me circumdabunt iusti, cum retribueris mihi '."
}`)
	CurrentBook.AddChapter(143, `{
"1":"PSALMUS. David. Domine, exaudi orationem meam, auribus percipe obsecrationem meam in veritate tua; exaudi me in tua iustitia."
,"2":"Et non intres in iudicium cum servo tuo, quia non iustificabitur in conspectu tuo omnis vivens."
,"3":"Quia persecutus est inimicus animam meam, contrivit in terra vitam meam, collocavit me in obscuris sicut mortuos a saeculo."
,"4":"Et anxiatus est in me spiritus meus, in medio mei obriguit cor meum."
,"5":"Memor fui dierum antiquorum, meditatus sum in omnibus operibus tuis, in factis manuum tuarum recogitabam."
,"6":"Expandi manus meas ad te, anima mea sicut terra sine aqua tibi."
,"7":"Velociter exaudi me, Domine; defecit spiritus meus. Non abscondas faciem tuam a me, ne similis fiam descendentibus in lacum."
,"8":"Auditam fac mihi mane misericordiam tuam, quia in te speravi. Notam fac mihi viam, in qua ambulem, quia ad te levavi animam meam."
,"9":"Eripe me de inimicis meis, Domine, ad te confugi."
,"10":"Doce me facere voluntatem tuam, quia Deus meus es tu. Spiritus tuus bonus deducet me in terram rectam;"
,"11":"propter nomen tuum, Domine, vivificabis me. In iustitia tua educes de tribulatione animam meam"
,"12":"et in misericordia tua disperdes inimicos meos; et perdes omnes, qui tribulant animam meam, quoniam ego servus tuus sum."
}`)
	CurrentBook.AddChapter(144, `{
"1":"David. Benedictus Dominus, adiutor meus, qui docet manus meas ad proelium,et digitos meos ad bellum."
,"2":"Misericordia mea et fortitudo mea, refugium meum et liberator meus; scutum meum, et in ipso speravi, qui subdit populum meum sub me."
,"3":"Domine, quid est homo, quod agnoscis eum, aut filius hominis, quod reputas eum?"
,"4":"Homo vanitati similis factus est, dies eius sicut umbra praeteriens."
,"5":"Domine, inclina caelos tuos et descende; tange montes, et fumigabunt."
,"6":"Fulgura coruscationem et dissipa eos; emitte sagittas tuas et conturba eos."
,"7":"Emitte manum tuam de alto; eripe me et libera me de aquis multis, de manu filiorum alienigenarum,"
,"8":"quorum os locutum est vanitatem, et dextera eorum dextera mendacii."
,"9":"Deus, canticum novum cantabo tibi, in psalterio decachordo psallam tibi,"
,"10":"qui das salutem regibus, qui redimis David servum tuum de gladio maligno."
,"11":"Eripe me et libera me,de manu filiorum alienigenarum, quorum os locutum est vanitatem, et dextera eorum dextera mendacii."
,"12":"Filii nostri sicut novellae crescentes,in iuventute sua; filiae nostrae sicut columnae angulares, sculptae ut structura templi."
,"13":"Promptuaria nostra plena, redundantia omnibus bonis; oves nostrae in milibus,innumerabiles in campis nostris,"
,"14":"boves nostrae crassae. Non est ruina maceriae neque egressus,neque clamor in plateis nostris."
,"15":"Beatus populus, cui haec sunt; beatus populus, cui Dominus est Deus."
}`)
	CurrentBook.AddChapter(145, `{
"1":"Laudes. David. ALEPH. Exaltabo te, Deus meus, rex, et benedicam nomini tuo,in saeculum et in saeculum saeculi."
,"2":"BETH. Per singulos dies benedicam tibi,et laudabo nomen tuum,in saeculum et in saeculum saeculi."
,"3":"GHIMEL. Magnus Dominus et laudabilis nimis, et magnitudinis eius non est investigatio."
,"4":"DALETH. Generatio generationi laudabit opera tua, et potentiam tuam pronuntiabunt."
,"5":"HE. Magnificentiam gloriae maiestatis tuae loquentur,et mirabilia tua enarrabunt."
,"6":"VAU. Et virtutem terribilium tuorum dicent,et magnitudinem tuam narrabunt."
,"7":"ZAIN. Memoriam abundantiae suavitatis tuae eructabunt,et iustitia tua exsultabunt."
,"8":"HETH. Miserator et misericors Dominus, longanimis et multae misericordiae."
,"9":"TETH. Suavis Dominus universis, et miserationes eius super omnia opera eius."
,"10":"IOD. Confiteantur tibi, Domine, omnia opera tua; et sancti tui benedicant tibi."
,"11":"CAPH. Gloriam regni tui dicant,et potentiam tuam loquantur,"
,"12":"LAMED. ut notas faciant filiis hominum potentias tuas,et gloriam magnificentiae regni tui."
,"13":"MEM. Regnum tuum regnum omnium saeculorum, et dominatio tua in omnem generationem et generationem. NUN. Fidelis Dominus in omnibus verbis suis,et sanctus in omnibus operibus suis."
,"14":"SAMECH. Allevat Dominus omnes, qui corruunt, et erigit omnes depressos."
,"15":"AIN. Oculi omnium in te sperant, et tu das illis escam in tempore opportuno."
,"16":"PHE. Aperis tu manum tuam,et imples omne animal in beneplacito."
,"17":"SADE. Iustus Dominus in omnibus viis suis,et sanctus in omnibus operibus suis."
,"18":"COPH. Prope est Dominus omnibus invocantibus eum, omnibus invocantibus eum in veritate."
,"19":"RES. Voluntatem timentium se faciet,et deprecationem eorum exaudiet et salvos faciet eos."
,"20":"SIN. Custodit Dominus omnes diligentes se,et omnes peccatores disperdet."
,"21":"TAU. Laudationem Domini loquetur os meum, et benedicat omnis caro nomini sancto eius,in saeculum et in saeculum saeculi."
}`)
	CurrentBook.AddChapter(146, `{
"1":"ALLELUIA. Lauda, anima mea, Dominum;"
,"2":"laudabo Dominum in vita mea, psallam Deo meo, quamdiu fuero."
,"3":"Nolite confidere in principibus, in filiis hominum, in quibus non est salus."
,"4":"Exibit spiritus eius, et revertetur in terram suam; in illa die peribunt cogitationes eorum."
,"5":"Beatus, cuius Deus Iacob est adiutor, cuius spes in Domino Deo suo,"
,"6":"qui fecit caelum et terram, mare et omnia, quae in eis sunt; qui custodit veritatem in saeculum,"
,"7":"facit iudicium oppressis, dat escam esurientibus. Dominus solvit compeditos,"
,"8":"Dominus illuminat caecos, Dominus erigit depressos, Dominus diligit iustos,"
,"9":"Dominus custodit advenas, pupillum et viduam sustentat,et viam peccatorum disperdit."
,"10":"Regnabit Dominus in saecula, Deus tuus, Sion, in generationem et generationem."
}`)
	CurrentBook.AddChapter(147, `{
"1":"ALLELUIA. Laudate Dominum, quoniam bonum est psallere Deo nostro, quoniam iucundum est celebrare laudem."
,"2":"Aedificans Ierusalem Dominus, dispersos Israelis congregabit."
,"3":"Qui sanat contritos corde,et alligat plagas eorum;"
,"4":"qui numerat multitudinem stellarum,et omnibus eis nomina vocat."
,"5":"Magnus Dominus noster et magnus virtute, sapientiae eius non est numerus."
,"6":"Sustentat mansuetos Dominus, humilians autem peccatores usque ad terram."
,"7":"Praecinite Domino in confessione, psallite Deo nostro in cithara."
,"8":"Qui operit caelum nubibus,et parat terrae pluviam. Qui producit in montibus fenum,et herbam servituti hominum."
,"9":"Qui dat iumentis escam ipsorum,et pullis corvorum invocantibus eum."
,"10":"Non in fortitudine equi delectatur, nec in tibiis viri beneplacitum est ei."
,"11":"Beneplacitum est Domino super timentes eum,et in eis, qui sperant super misericordia eius."
,"12":"Lauda, Ierusalem, Dominum; collauda Deum tuum, Sion."
,"13":"Quoniam confortavit seras portarum tuarum, benedixit filiis tuis in te."
,"14":"Qui ponit fines tuos pacem,et adipe frumenti satiat te."
,"15":"Qui emittit eloquium suum terrae, velociter currit verbum eius."
,"16":"Qui dat nivem sicut lanam, pruinam sicut cinerem spargit."
,"17":"Mittit crystallum suam sicut buccellas; ante faciem frigoris eius quis sustinebit?"
,"18":"Emittet verbum suum et liquefaciet ea, flabit spiritus eius, et fluent aquae."
,"19":"Qui annuntiat verbum suum Iacob, iustitias et iudicia sua Israel."
,"20":"Non fecit taliter omni nationi,et iudicia sua non manifestavit eis. ALLELUIA."
}`)
	CurrentBook.AddChapter(148, `{
"1":"ALLELUIA. Laudate Dominum de caelis, laudate eum in excelsis."
,"2":"Laudate eum, omnes angeli eius, laudate eum, omnes virtutes eius."
,"3":"Laudate eum, sol et luna, laudate eum, omnes stellae lucentes."
,"4":"Laudate eum, caeli caelorum,et aquae omnes, quae super caelos sunt. -"
,"5":"Laudent nomen Domini, quia ipse mandavit, et creata sunt;"
,"6":"statuit ea in aeternum et in saeculum saeculi; praeceptum posuit, et non praeteribit."
,"7":"Laudate Dominum de terra, dracones et omnes abyssi,"
,"8":"ignis, grando, nix, fumus, spiritus procellarum, qui facit verbum eius,"
,"9":"montes et omnes colles, ligna fructifera et omnes cedri,"
,"10":"bestiae et universa pecora, serpentes et volucres pennatae."
,"11":"Reges terrae et omnes populi, principes et omnes iudices terrae,"
,"12":"iuvenes et virgines, senes cum iunioribus"
,"13":"laudent nomen Domini, quia exaltatum est nomen eius solius. Magnificentia eius super caelum et terram,"
,"14":"et exaltavit cornu populi sui. Hymnus omnibus sanctis eius, filiis Israel, populo, qui propinquus est ei. ALLELUIA."
}`)
	CurrentBook.AddChapter(149, `{
"1":"ALLELUIA. Cantate Domino canticum novum; laus eius in ecclesia sanctorum."
,"2":"Laetetur Israel in eo, qui fecit eum, et filii Sion exsultent in rege suo."
,"3":"Laudent nomen eius in choro, in tympano et cithara psallant ei,"
,"4":"quia beneplacitum est Domino in populo suo, et honorabit mansuetos in salute."
,"5":"Iubilent sancti in gloria, laetentur in cubilibus suis."
,"6":"Exaltationes Dei in gutture eorum, et gladii ancipites in manibus eorum,"
,"7":"ad faciendam vindictam in nationibus, castigationes in populis,"
,"8":"ad alligandos reges eorum in compedibus,et nobiles eorum in manicis ferreis,"
,"9":"ad faciendum in eis iudicium conscriptum. Gloria haec est omnibus sanctis eius. ALLELUIA."
}`)
	CurrentBook.AddChapter(150, `{
"1":"ALLELUIA. Laudate Dominum in sanctuario eius, laudate eum in firmamento virtutis eius."
,"2":"Laudate eum in magnalibus eius, laudate eum secundum multitudinem magnitudinis eius."
,"3":"Laudate eum in sono tubae, laudate eum in psalterio et cithara,"
,"4":"laudate eum in tympano et choro, laudate eum in chordis et organo,"
,"5":"laudate eum in cymbalis benesonantibus, laudate eum in cymbalis iubilationis: omne quod spirat, laudet Dominum. ALLELUIA."
}`)

}
func LA_NVBSE_LoadVSSPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Diligite iustitiam, qui iudicatis terram, sentite de Domino in bonitate,et in simplicitate cordis quaerite illum,"
,"2":"quoniam invenitur ab his, qui non tentant illum, se autem manifestat eis, qui fidem habent in illum."
,"3":"Perversae enim cogitationes separant a Deo, probata autem virtus corripit insipientes."
,"4":"Quoniam in malevolam animam non introibit sapientia,nec habitabit in corpore subdito peccatis."
,"5":"Spiritus enim sanctus disciplinae effugiet fictum,et auferet se a cogitationibus insensatis,et corripietur a superveniente iniquitate."
,"6":"Spiritus enim diligens hominem est sapientia,et non absolvet maledicum a labiis suis, quoniam renum illius testis est Deus,et cordis illius scrutator verus,et linguae eius auditor;"
,"7":"quoniam spiritus Domini replevit orbem terrarum, et ipse, qui continet omnia, scientiam habet vocis."
,"8":"Propter hoc, qui loquitur iniqua, non potest latere, nec praeteriet illum iudicium corripiens."
,"9":"In cogitationibus enim impii interrogatio erit, sermonum autem illius auditio ad Dominum veniet,ad correptionem iniquitatum illius;"
,"10":"quoniam auris zeli audit omnia, et tumultus murmurationum non absconditur."
,"11":"Custodite ergo vos a murmuratione, quae nihil prodest, et a detractione parcite linguae, quoniam sermo absconditus in vacuum non ibit; os autem, quod mentitur, occidit animam."
,"12":"Nolite zelare mortem in errore vitae vestrae,neque acquiratis perditionem in operibus manuum vestrarum,"
,"13":"quoniam Deus mortem non fecit,nec laetatur in perditione vivorum;"
,"14":"creavit enim, ut essent omnia, et sanabiles sunt generationes orbis terrarum, et non est in illis medicamentum exterminii, nec inferorum regnum in terra:"
,"15":"iustitia enim est immortalis."
,"16":"Impii autem manibus et verbis accersierunt illam; aestimantes illam amicam defluxerunt,et sponsionem posuerunt ad illam, quoniam digni sunt, qui sint ex parte illius."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Dixerunt enim cogitantes apud se non recte: ' Exiguum et cum taedio est tempus vitae nostrae, et non est refrigerium in fine hominis, et non est agnitus, qui sit reversus ab inferis."
,"2":"Quia ex tempore nati sumus,et post hoc erimus, tamquam non fuerimus, quoniam fumus flatus est in naribus nostris, et sermo scintilla in motu cordis nostri;"
,"3":"qua exstincta, cinis fiet corpus nostrum, et spiritus diffundetur tamquam mollis aer."
,"4":"Et nomen nostrum oblivioni tradetur per tempus, et nemo memoriam habebit operum nostrorum; et transibit vita nostra tamquam vestigium nubis, et sicut nebula dissolvetur, quae fugata est a radiis solis,et a calore illius aggravata."
,"5":"Umbrae enim transitus est tempus nostrum, et non est reversio finis nostri, quoniam consignata est, et nemo revertitur."
,"6":"Venite ergo, et fruamur bonis, quae sunt, et utamur creatura tamquam in iuventute sollicite."
,"7":"Vino pretioso et unguentis nos impleamus, et non praetereat nos flos temporis verni;"
,"8":"coronemus nos calycibus rosarum, antequam marcescant,"
,"9":"nullum pratum exsors sit luxuriae nostrae; ubique relinquamus signa laetitiae, quoniam haec est pars nostra, et haec est sors."
,"10":"Opprimamus pauperem iustum,et non parcamus viduae,nec veterani revereamur canos multi temporis."
,"11":"Sit autem fortitudo nostra lex iustitiae; quod enim infirmum est, inutile invenitur."
,"12":"Circumveniamus ergo iustum, quoniam inutilis est nobis,et contrarius est operibus nostris,et improperat nobis peccata legis,et diffamat in nos peccata disciplinae nostrae."
,"13":"Promittit se scientiam Dei habere,et filium Dei se nominat."
,"14":"Factus est nobis in accusationem cogitationum nostrarum; gravis est nobis etiam ad videndum,"
,"15":"quoniam dissimilis est aliis vita illius, et immutatae sunt viae eius."
,"16":"Tamquam scoria aestimati sumus ab illo, et abstinet se a viis nostris tamquam ab immunditiis; beata dicit novissima iustorum,et gloriatur patrem se habere Deum."
,"17":"Videamus ergo, si sermones illius veri sint, et tentemus, quae in exitu eius erunt:"
,"18":"si enim est verus filius Dei, suscipiet illum,et liberabit eum de manibus contrariorum."
,"19":"Contumelia et tormento interrogemus eum, ut sciamus modestiam eius,et probemus patientiam illius;"
,"20":"morte turpissima condemnemus eum: erit enim ei visitatio ex sermonibus illius '."
,"21":"Haec cogitaverunt et erraverunt; excaecavit enim illos malitia eorum,"
,"22":"et nescierunt sacramenta Dei,neque mercedem speraverunt sanctitatis,nec iudicaverunt honorem animarum immaculatarum."
,"23":"Quoniam Deus creavit hominem in incorruptibilitate,et imaginem similitudinis suae fecit illum;"
,"24":"invidia autem Diaboli mors introivit in orbem terrarum; experiuntur autem illam, qui sunt ex parte illius."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Iustorum autem animae in manu Dei sunt, et non tanget illos tormentum mortis."
,"2":"Visi sunt oculis insipientium mori, et aestimata est afflictio exitus illorum,"
,"3":"et, quod a nobis est iter, exterminium; illi autem sunt in pace."
,"4":"Etenim, si coram hominibus tormenta passi sunt, spes illorum immortalitate plena est;"
,"5":"et in paucis correpti, in multis bene disponentur, quoniam Deus tentavit eos,et invenit illos dignos se."
,"6":"Tamquam aurum in fornace probavit illos,et quasi holocausti hostiam accepit illos,"
,"7":"et in tempore visitationis illorum fulgebunt,et tamquam scintillae in arundineto discurrent;"
,"8":"iudicabunt nationes et dominabuntur populis, et regnabit Dominus illorum in perpetuum."
,"9":"Qui confidunt in illo, intellegent veritatem, et fideles in dilectione acquiescent illi, quoniam gratia et misericordia est sanctis eius, et visitatio electis eius."
,"10":"Impii autem, secundum quae cogitaverunt, correptionem habebunt; qui neglexerunt iustum et a Domino recesserunt."
,"11":"Sapientiam enim et disciplinam qui despicit, infelix est, et vacua est spes illorum, et labores sine fructu, et inutilia opera eorum."
,"12":"Mulieres eorum insensatae sunt, et nequissimi filii eorum, maledicta generatio eorum."
,"13":"Quoniam felix est sterilis et incoinquinata, quae nescivit torum in delicto; habebit fructum in respectione animarum."
,"14":"Et spado, qui non operatus est per manus suas iniquitatem,nec cogitavit adversus Dominum nequissima, dabitur enim illi fidei donum electum, et sors in templo Domini acceptissima."
,"15":"Bonorum enim laborum gloriosus est fructus; et, quae non concidat, radix sapientiae."
,"16":"Filii autem adulterorum in inconsummatione erunt, et ab iniquo toro semen exterminabitur."
,"17":"Et, si quidem longae vitae erunt, in nihilum computabuntur, et sine honore erit in novissimo senectus illorum;"
,"18":"et, si celerius defuncti fuerint, non habebunt spem,nec in die agnitionis allocutionem:"
,"19":"generationis enim iniquae dirae sunt consummationes."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Melius est absque liberis esse cum virtute; immortalitas est enim in memoria illius, quoniam et apud Deum nota est et apud homines."
,"2":"Cum praesens est, imitantur illam; et desiderant eam, cum se eduxerit; et in perpetuum coronata triumphat, incoinquinatorum certaminum praemium vincens."
,"3":"Multigena autem impiorum multitudo non erit utilis,et spuriis vitulaminibus non dabit radicem in profundum altam,nec stabile firmamentum collocabit."
,"4":"Etenim, si in ramis ad tempus germinaverit, infirmiter posita a vento commovebitur,et a nimietate ventorum eradicabitur."
,"5":"Confringentur rami inconsummati, et fructus illorum inutilis et acerbus ad manducandum,et ad nihilum aptus."
,"6":"Ex iniquis enim somnis filii, qui nascuntur, testes sunt nequitiae adversus parentes,in interrogatione sua."
,"7":"Iustus autem, si morte praeoccupatus fuerit, in refrigerio erit."
,"8":"Senectus enim venerabilis, non quae est diuturna, neque annorum numero computatur;"
,"9":"cani autem sunt sensus hominis, et aetas senectutis vita immaculata."
,"10":"Placens Deo factus est dilectus,et vivens inter peccatores translatus est;"
,"11":"raptus est, ne malitia mutaret intellectum eius, aut ne fictio deciperet animam illius."
,"12":"Fascinatio enim nugacitatis obscurat bona, et inconstantia concupiscentiae transvertit sensum sine malitia."
,"13":"Consummatus in brevi,explevit tempora multa;"
,"14":"placita enim erat Deo anima illius, propter hoc properavit educere illum de medio iniquitatis. Populi autem videntes et non intellegentes,nec ponentes in praecordiis talia,"
,"15":"quoniam gratia et misericordia est in electis eius, et visitatio in sanctis illius."
,"16":"Condemnat autem iustus mortuus vivos impios, et iuventus celerius consummata longaevam senectutem iniusti."
,"17":"Videbunt enim finem sapientis,et non intellegent quid cogitaverit de illo Deus, et quare munierit illum Dominus."
,"18":"Videbunt et contemnent; illos autem Dominus irridebit."
,"19":"Et erunt post haec tamquam corpus sine honore,et in contumeliam inter mortuos in perpetuum, quoniam disrumpet illos praecipites sine voce,et commovebit illos a fundamentis, et usque ad supremum desolabuntur,et erunt in dolore, et memoria illorum peribit."
,"20":"Venient in computatione peccatorum suorum timidi, et traducent illos ex adverso iniquitates ipsorum."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tunc stabit iustus in magna constantia,adversus eos, qui angustiaverunt illum,et qui spreverunt labores eius."
,"2":"Videntes turbabuntur timore horribili,et mirabuntur in subitatione insperatae salutis"
,"3":"dicentes intra se, paenitentiam agentes,et prae angustia spiritus gementes:"
,"4":"' Hic erat, quem habuimus aliquando in derisum,et in similitudinem improperii. Nos insensati vitam eius aestimabamus insaniam,et finem illius sine honore."
,"5":"Quomodo computatus est inter filios Dei, et inter sanctos sors illius est?"
,"6":"Ergo erravimus a via veritatis, et iustitiae lumen non luxit nobis, et sol non est ortus nobis;"
,"7":"implicati sumus tribulis iniquitatis et perditionis,et ambulavimus per deserta inaccessa, viam autem Domini ignoravimus."
,"8":"Quid nobis profuit superbia?,Aut divitiae cum iactantia quid contulerunt nobis?"
,"9":"Transierunt omnia illa tamquam umbra,et tamquam nuntius percurrens"
,"10":"et tamquam navis, quae pertransit fluctuantem aquam, cuius, cum praeterierit, non est vestigium invenire,neque semitam carinae illius in fluctibus;"
,"11":"aut tamquam avis, quae transvolat in aere, nullum invenitur argumentum itineris, sed alarum sonitu ventus levis verberatus,et scissus per vim stridoris,commotis alis permeatur, et post hoc nullum signum invenitur itineris;"
,"12":"aut tamquam sagittae emissae in locum destinatum: divisus aer continuo in se resolvitur, ut ignoretur transitus illius."
,"13":"Sic et nos, nati, continuo desivimus esse,et virtutis quidem nullum signum valuimus ostendere; in malignitate autem nostra consumpti sumus '."
,"14":"Quoniam spes impii tamquam lanugo est, quae a vento tollitur, et tamquam spuma gracilis, quae a procella dispergitur, et tamquam fumus, qui a vento diffusus est, et tamquam memoria hospitis unius diei praeteriit."
,"15":"Iusti autem in perpetuum vivunt, et in Domino est merces eorum, et cogitatio illorum apud Altissimum."
,"16":"Ideo accipient coronam decoris,et diadema speciei de manu Domini, quoniam dextera sua teget eos,et brachio suo defendet illos."
,"17":"Accipiet pro armatura zelum suum,et armabit creaturam ad ultionem inimicorum,"
,"18":"induet pro thorace iustitiam,et accipiet pro galea iudicium non fictum;"
,"19":"sumet pro scuto inexpugnabili sanctitatem."
,"20":"Acuet autem duram iram in lanceam,et pugnabit cum illo orbis terrarum contra insensatos."
,"21":"Ibunt recta emissiones fulgurum,et tamquam a bene curvato arcu nubium ad signum insilient,"
,"22":"et ab ira saxa iaculante,ira plenae mittentur grandines; excandescet in illos aqua maris, et flumina concurrent duriter."
,"23":"Contra illos stabit spiritus virtutis,et tamquam turbo dissipabit illos. Et ad eremum perducet omnem terram iniquitas, et malignitas evertet sedes potentium."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Audite ergo, reges, et intellegite; discite, iudices finium terrae."
,"2":"Praebete aures, vos, qui continetis multitudines,et placetis vobis in turbis nationum."
,"3":"Quoniam data est a Domino potestas vobis,et dominatio ab Altissimo, qui interrogabit opera vestra,et cogitationes scrutabitur,"
,"4":"quoniam, cum essetis ministri regni illius, non recte iudicastis,nec custodistis legem,neque secundum voluntatem Dei ambulastis."
,"5":"Horrende et cito instabit vobis, quoniam iudicium durissimum his, qui praesunt, fiet;"
,"6":"exiguo enim conceditur misericordia, potentes autem potenter tormento interrogabuntur."
,"7":"Non enim subtrahet personam cuiusquam Deus,nec verebitur magnitudinem cuiusquam, quoniam pusillum et magnum ipse fecit, et aequaliter cura est illi de omnibus;"
,"8":"potentibus autem durum instat scrutinium."
,"9":"Ad vos ergo, reges, sunt hi sermones mei, ut discatis sapientiam et non excidatis."
,"10":"Qui enim custodierint iusta iuste, iustificabuntur; et, qui didicerint ista, invenient defensionem."
,"11":"Concupiscite ergo sermones meos, diligite illos et habebitis disciplinam."
,"12":"Clara est et, quae numquam marcescit, sapientia; et facile videtur ab his, qui diligunt eam, et invenitur ab his, qui quaerunt illam."
,"13":"Praeoccupat, qui eam concupiscunt, ut prior se ostendat illis."
,"14":"Qui de luce vigilaverit ad illam, non laborabit, assidentem enim illam foribus suis inveniet."
,"15":"Cogitare ergo de illa sensus est consummatio; et, qui vigilaverit propter illam, cito securus erit."
,"16":"Quoniam dignos se ipsa circuit quaerens,et in viis ostendit se illis hilariter,et in omni providentia occurrit illis."
,"17":"Initium enim illius verissima est disciplinae concupiscentia, cura vero disciplinae dilectio est,"
,"18":"et dilectio custodia legum illius est, custoditio autem legum confirmatio incorruptionis est,"
,"19":"incorruptio autem facit esse proximum Deo;"
,"20":"concupiscentia itaque sapientiae deducit ad regnum."
,"21":"Si ergo delectamini sedibus et sceptris, o reges populi, colite sapientiam, ut in perpetuum regnetis."
,"22":"Quid est autem sapientia et quemadmodum facta sit, referam,et non abscondam a vobis sacramenta Dei, sed ab initio nativitatis investigabo,et ponam in lucem scientiam illius,et non praeteribo veritatem."
,"23":"Neque cum invidia tabescente iter habebo, quoniam ista non erit particeps sapientiae."
,"24":"Multitudo autem sapientium sanitas est orbis terrarum, et rex sapiens stabilimentum populi est."
,"25":"Ergo accipite disciplinam per sermones meos, et proderit vobis."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Sum quidem et ego mortalis homo similis omnibus,et ex genere terreni illius, qui prior factus est, et in ventre matris figuratus sum caro;"
,"2":"decem mensium tempore coagulatus in sanguine,ex semine viri et delectamento somni conveniente."
,"3":"Et ego natus traxi communem aerem,et decidi in terram, quae omnia similiter patitur, prima voce simili omnibus pariter plorans."
,"4":"In involumentis nutritus sum et curis;"
,"5":"nullus enim rex aliud habuit nativitatis initium."
,"6":"Unus autem introitus est omnibus ad vitam, et similis exitus."
,"7":"Propter hoc optavi, et datus est mihi sensus; et invocavi, et venit in me spiritus sapientiae."
,"8":"Praeposui illam regnis et sedibus,et divitias nihil esse duxi in comparatione illius;"
,"9":"nec comparavi illi lapidem pretiosum, quoniam omne aurum in comparatione illius arena est exigua, et tamquam lutum aestimabitur argentum in conspectu illius."
,"10":"Super salutem et speciem dilexi illam,et proposui pro luce habere illam, quoniam inexstinguibile est lumen illius."
,"11":"Venerunt autem mihi omnia bona pariter cum illa, innumerabiles divitiae in manibus illius,"
,"12":"et laetatus sum in omnibus, quoniam sapientia antecedit ista, et ignorabam quoniam horum omnium mater est;"
,"13":"quam sine fictione didici et sine invidia communico; divitias illius non abscondo."
,"14":"Infinitus enim thesaurus est hominibus; quem qui acquisierunt, ad amicitiam in Deum se paraverunt,propter disciplinae dona commendati."
,"15":"Mihi autem det Deus dicere secundum sententiam,et sentire digna horum, quae mihi data sunt, quoniam ipse sapientiae dux est,et sapientium emendator;"
,"16":"in manu enim illius et nos et sermones nostri,et omnis sapientia et operum scientia."
,"17":"Ipse enim dedit mihi horum, quae sunt, scientiam veram, ut sciam dispositionem orbis terrarum et virtutes elementorum,"
,"18":"initium et consummationem et medietatem temporum, vicissitudinum permutationes et commutationes temporum,"
,"19":"anni cursus et stellarum dispositiones,"
,"20":"naturas animalium et iras bestiarum, vim spirituum et cogitationes hominum, differentias virgultorum et virtutes radicum."
,"21":"Et, quaecumque sunt absconsa et manifesta, didici; omnium enim artifex docuit me sapientia."
,"22":"Est enim in illa spiritus intellegens, sanctus, unicus, multiplex, subtilis, mobilis, perspicuus, incoinquinatus, lucidus, innocens, amans bonum, acutus,"
,"23":"quem nihil vetat, benefaciens, humanus, benignus, stabilis, certus, securus, omnem habens virtutem, omnia prospiciens,et penetrans omnes spiritus,intellegibiles, mundos, subtilissimos."
,"24":"Omni enim motu mobilior est sapientia; pertransit autem et penetrat omnia propter munditiam."
,"25":"Halitus est enim virtutis Dei,et emanatio claritatis Omnipotentis sincera; ideo nihil inquinatum in eam incurrit:"
,"26":"candor est enim lucis aeternae,et speculum sine macula Dei potentiae,et imago bonitatis illius."
,"27":"Et, cum sit una, omnia potest; et in se permanens, omnia innovat,et per generationes in animas sanctas se transferens,amicos Dei et prophetas constituit."
,"28":"Nihil enim diligit Deus, nisi eum, qui cum sapientia inhabitat."
,"29":"Est enim haec speciosior sole,et super omnem dispositionem stellarum; luci comparata invenitur splendidior:"
,"30":"illi enim succedit nox, sapientiam autem non vincit malitia."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Attingit ergo a fine usque ad finem fortiter,et disponit omnia suaviter."
,"2":"Hanc amavi et exquisivi a iuventute mea,et quaesivi sponsam mihi eam assumere,et amator factus sum formae illius."
,"3":"Generositatem suam glorificat contubernium habens Dei, sed et omnium Dominus dilexit illam."
,"4":"Doctrix enim est disciplinae Dei,et electrix operum illius."
,"5":"Et, si divitiae sunt desiderabilis possessio in vita, quid sapientia locupletius, quae operatur omnia?"
,"6":"Si autem sensus operatur, quis horum, quae sunt, magis quam illa est artifex?"
,"7":"Et, si iustitiam quis diligit, labores huius sunt virtutes: sobrietatem enim et prudentiam docet, iustitiam et fortitudinem, quibus utilius nihil est in vita hominibus."
,"8":"Et, si multam peritiam desiderat quis, scit praeterita et futura conicit, novit versutias sermonum et solutiones aenigmatum, signa et monstra scit, antequam fiant, et eventus momentorum et temporum."
,"9":"Proposui ergo hanc adducere mihi ad convivendum, sciens quoniam erit mihi consiliaria bonorum,et consolatio sollicitudinum et taedii."
,"10":"Habebo propter hanc claritatem ad turbas,et honorem apud seniores iuvenis;"
,"11":"acutus inveniar in iudicio,et in conspectu potentium admirabilis ero."
,"12":"Tacentem me sustinebunt,et loquentem me respicient,et, sermocinante me plura, manus ori suo imponent."
,"13":"Habebo per hanc immortalitatem,et memoriam aeternam his, qui post me futuri sunt, relinquam."
,"14":"Disponam populos, et nationes mihi erunt subditae;"
,"15":"timebunt me audientes reges horrendi, in multitudine videbor bonus,et in bello fortis."
,"16":"Intrans in domum meam, conquiescam cum illa; non enim habet amaritudinem conversatio illius,nec taedium convictus illius, sed laetitiam et gaudium."
,"17":"Haec cogitans apud me,et commemorans in corde meo,quoniam immortalitas est in cognatione sapientiae,"
,"18":"et in amicitia illius delectatio bona, et in laboribus manuum illius divitiae sine defectione, et in certamine loquelae illius sapientia, et praeclaritas in communicatione sermonum ipsius, circuibam quaerens, ut mihi illam assumerem."
,"19":"Puer autem eram ingeniosus,et sortitus sum animam bonam;"
,"20":"quin potius, cum essem bonus, veni in corpus incoinquinatum."
,"21":"Et, ut scivi quoniam aliter non possem esse continens, nisi Deus det, C et hoc ipsum erat sapientiae scire, cuius esset hoc donum C,adii Dominum et deprecatus sum illum,et dixi ex toto corde meo:"
}`)
	CurrentBook.AddChapter(9, `{
"1":"' Deus patrum meorum et Domine misericordiae, qui fecisti omnia verbo tuo"
,"2":"et sapientia tua constituisti hominem, ut dominaretur creaturis, quae a te factae sunt,"
,"3":"et disponeret orbem terrarum in sanctitate et iustitia,et in directione cordis iudicium iudicaret,"
,"4":"da mihi sedium tuarum assistricem sapientiam,et noli me reprobare a pueris tuis,"
,"5":"quoniam servus tuus sum ego et filius ancillae tuae, homo infirmus et exigui temporis,et minor ad intellectum iudicii et legum."
,"6":"Nam, et si quis erit consummatus inter filios hominum, si ab illo abfuerit sapientia tua, in nihilum computabitur."
,"7":"Tu elegisti me regem populo tuo,et iudicem filiorum tuorum et filiarum;"
,"8":"dixisti me aedificare templum in monte sancto tuo,et in civitate habitationis tuae altare, similitudinem tabernaculi sancti, quod praeparasti ab initio."
,"9":"Et tecum sapientia, quae novit opera tua, quae et affuit tunc, cum orbem terrarum faceres, et sciebat quid esset placitum in oculis tuis,et quid directum in praeceptis tuis."
,"10":"Emitte illam de caelis sanctis tuis,et a sede magnitudinis tuae mitte illam, ut mecum sit et mecum laboret, ut sciam quid acceptum sit apud te."
,"11":"Scit enim illa omnia et intellegit,et deducet me in operibus meis sobrie,et custodiet me in sua gloria."
,"12":"Et erunt accepta opera mea, et diiudicabo populum tuum iuste,et ero dignus sedium patris mei."
,"13":"Quis enim hominum poterit scire consilium Dei?,Aut quis poterit cogitare quid velit Dominus?"
,"14":"Cogitationes enim mortalium timidae, et incertae providentiae nostrae:"
,"15":"corpus enim, quod corrumpitur, aggravat animam, et terrena inhabitatio deprimit sensum multa cogitantem."
,"16":"Et difficile conicimus, quae in terra sunt, et, quae in prospectu sunt, invenimus cum labore; quae autem in caelis sunt, quis investigabit?"
,"17":"Consilium autem tuum quis sciet, nisi tu dederis sapientiam,et miseris spiritum sanctum tuum de altissimis?"
,"18":"Et sic correctae sunt semitae eorum, qui sunt in terris; et, quae tibi placent, didicerunt homines,et salvati per sapientiam sunt '."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Haec illum, qui primus formatus est, pater orbis terrarum, cum solus esset creatus, custodivit,et eduxit illum a delicto suo"
,"2":"et dedit illi virtutem continendi omnia."
,"3":"Ab hac ut recessit iniustus in ira sua, in furoribus fraternae caedis deperiit;"
,"4":"propter quem, cum demergeretur terra, sanavit eam iterum sapientia,per contemptibile lignum iustum gubernans."
,"5":"Haec et in consensu nequitiae, cum se nationes confudissent, scivit iustum et conservavit sine querela Deo,et super filii viscera fortem custodivit."
,"6":"Haec iustum a pereuntibus impiis liberavit fugientem, descendente igne in Pentapolim;"
,"7":"cuius adhuc in testimonium nequitiae,fumigabunda constat deserta terra, et incertis temporibus fructus habentes arbores, et incredibilis animae memoria stans figmentum salis."
,"8":"Sapientiam enim praetereuntes,non tantum in hoc lapsi sunt, ut ignorarent bona, sed et insipientiae suae reliquerunt hominibus memoriam, ut in his, quae peccaverunt, nec latere potuissent."
,"9":"Sapientia autem hos, qui eam observant, a laboribus liberavit."
,"10":"Haec profugum irae fratris iustum,deduxit per vias rectas,et ostendit illi regnum Dei,et dedit illi scientiam sanctorum; honestavit illum in laboribus,et complevit labores illius."
,"11":"In avaritia circumvenientium illum affuit illi,et honestum fecit illum."
,"12":"Custodivit illum ab inimicis,et ab insidiantibus tutavit illum; et post certamen forte bravium dedit illi, ut sciret quoniam omnium potentior est pietas."
,"13":"Haec venditum iustum non dereliquit, sed a peccato liberavit eum;"
,"14":"descenditque cum illo in foveam,et in vinculis non dereliquit illum, donec afferret illi sceptrum regni,et potentiam adversus eos, qui eum deprimebant, et mendaces ostendit, qui maculaverunt illum, et dedit illi claritatem aeternam."
,"15":"Haec populum sanctum et semen sine querela,liberavit a nationibus, quae illum deprimebant."
,"16":"Intravit in animam servi Domini,et stetit contra reges horrendos in portentis et signis."
,"17":"Reddidit sanctis mercedem laborum suorum,et deduxit illos in via mirabili,et fuit illis in velamento diei,et in luce stellarum per noctem."
,"18":"Transtulit illos per mare Rubrum,et transvexit illos per aquam nimiam"
,"19":"inimicos autem illorum demersit,et ab altitudine abyssi eduxit illos."
,"20":"Ideo iusti tulerunt spolia impiorum,et decantaverunt, Domine, nomen sanctum tuum,et victricem manum tuam laudaverunt unanimiter,"
,"21":"quoniam sapientia aperuit os mutorum,et linguas infantium fecit disertas."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Direxit opera eorum,in manibus prophetae sancti."
,"2":"Iter fecerunt per deserta, quae non habitabantur, et in locis inviis fixerunt casas;"
,"3":"steterunt contra hostes,et de inimicis se vindicaverunt."
,"4":"Sitierunt et invocaverunt te; et data est illis aqua de petra altissima, et remedium sitis de lapide duro."
,"5":"Per quae enim poenas passi sunt inimici illorum, per haec, cum illis deessent, bene cum illis actum est."
,"6":"Nam pro fonte quidem perennis fluminis, tabescente sanguine turbidi"
,"7":"in traductionem decreti infanticidae, dedisti illis abundantem aquam insperate,"
,"8":"ostendens per sitim, quae tunc fuit, quemadmodum adversarios excruciares."
,"9":"Cum enim tentati sunt, etsi cum misericordia disciplinam accipientes, scierunt quemadmodum cum ira iudicati,impii tormenta paterentur."
,"10":"Hos quidem tamquam pater monens probasti, illos autem tamquam durus rex condemnans tormento interrogasti."
,"11":"Absentes enim et praesentes similiter torquebantur;"
,"12":"duplex enim illos acceperat taedium,et gemitus cum memoria praeteritorum."
,"13":"Cum enim audirent per sua tormenta,bene secum agi, senserunt Dominum."
,"14":"Quem enim in expositione olim proiectum reiecerunt deridentes, in finem eventuum mirati sunt, non similiter iustis sitientes."
,"15":"Pro cogitationibus autem insensatis iniquitatis illorum, in quibus errantes colebant mutos serpentes et bestias supervacuas, immisisti illis multitudinem mutorum animalium in vindictam,"
,"16":"ut scirent quia, per quae peccat quis, per haec et torquetur."
,"17":"Non enim impossibilis erat omnipotens manus tua, quae creavit orbem terrarum ex materia informi, immittere illis multitudinem ursorum aut audaces leones"
,"18":"aut recens conditas ira plenas ignotas bestias,aut vaporem igneum spirantes,aut fumi fremitum proferentes,aut horrendas ab oculis scintillas fulgurantes,"
,"19":"quarum non solum laesura poterat illos exterminare, sed et aspectus per timorem occidere."
,"20":"Sed et sine his uno spiritu poterant occidi, persecutionem passi a iustitia, et dispersi per spiritum virtutis tuae. Sed omnia in mensura et numero et pondere disposuisti."
,"21":"Multum enim valere tibi soli subest semper, et virtuti brachii tui quis resistet?"
,"22":"Quoniam tamquam momentum staterae, sic est ante te totus orbis terrarum, et tamquam gutta roris antelucani, quae descendit in terram."
,"23":"Sed misereris omnium, quia omnia potes; et dissimulas peccata hominum propter paenitentiam."
,"24":"Diligis enim omnia, quae sunt, et nihil odisti eorum, quae fecisti; nec enim, si odisses, aliquid constituisses."
,"25":"Quomodo autem posset aliquid permanere, nisi tu voluisses?,Aut, quod a te vocatum non esset, conservaretur?"
,"26":"Parcis autem omnibus, quoniam tua sunt, Domine, qui amas animas."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Incorruptibilis enim spiritus tuus est in omnibus."
,"2":"Ideoque eos, qui exerrant, paulatim corripis,et, de quibus peccant, admones et corrigis, ut, relicta malitia, credant in te, Domine."
,"3":"Illos enim antiquos inhabitatores terrae sanctae tuae, quos exhorruisti,"
,"4":"quoniam odibilia faciebant, opera medicaminum et sacrificia impia;"
,"5":"et filiorum necatores sine misericordia,et comestores viscerum,C humanarum carnium epulationem et sanguinis -,participes mysteriorum e medio comissationis"
,"6":"et auctores caedis parentes ipsos animarum inauxiliatarum,perdere voluisti per manus parentum nostrorum,"
,"7":"ut dignam perciperet peregrinationem puerorum Dei, quae tibi omnium carissima est terra."
,"8":"Sed et his tamquam hominibus pepercisti,et misisti antecessores exercitus tui vespas, ut illos paulatim exterminarent."
,"9":"Non quia impotens eras in acie subicere impios iustis,aut bestiis saevis aut verbo duro simul exterminare;"
,"10":"sed, paulatim iudicans, dabas locum paenitentiae, non ignorans quoniam nequam erat generatio eorum, et naturalis malitia ipsorum, et quoniam non poterat mutari cogitatio illorum in perpetuum:"
,"11":"semen enim erat maledictum ab initio. Nec timens aliquem, veniam dabas peccatis illorum;"
,"12":"quis enim dicet tibi: ' Quid fecisti? '. Aut quis stabit contra iudicium tuum?,Aut quis tibi imputabit, si perierint nationes, quas tu fecisti?,Aut quis in contentionem tecum veniet, vindex iniquorum hominum?"
,"13":"Non enim est alius Deus quam tu, cui cura est de omnibus, ut ostendas quoniam non iniuste iudicasti."
,"14":"Neque rex neque tyrannus in conspectu tuo,resistere poterit tibi de his, quos perdidisti."
,"15":"Cum autem sis iustus, iuste omnia disponis; ipsum quoque, qui non debet puniri, condemnare,exterum aestimas a tua virtute."
,"16":"Fortitudo enim tua iustitiae initium est, et ob hoc, quod omnium Dominus es, omnibus te parcere facit."
,"17":"Fortitudinem enim ostendis, cum non crederis esse in potentia consummatus, et horum, qui te nesciunt, audaciam traducis."
,"18":"Tu autem, dominator virtutis, cum clementia iudicas,et cum magna indulgentia disponis nos: subest enim tibi, cum volueris, posse."
,"19":"Docuisti autem populum tuum per talia opera, quoniam oportet iustum esse humanum, et bonae spei fecisti filios tuos, quoniam das super peccatis paenitentiam."
,"20":"Si enim inimicos servorum tuorum et debitos morti,cum tanta castigasti attentione et remissione,dans tempus et locum, per quae possent mutari a malitia,"
,"21":"cum quanta diligentia iudicasti filios tuos, quorum parentibus iuramenta,et conventiones dedisti bonarum promissionum!"
,"22":"Cum ergo das nobis disciplinam, inimicos nostros multipliciter flagellas, ut bonitatem tuam cogitemus iudicantes,et, cum de nobis iudicatur, speremus misericordiam."
,"23":"Unde et illis, qui in insipientia vitae iniuste vixerunt, per abominationes suas dedisti tormenta."
,"24":"Etenim in erroris viis diutius erraverunt, deos aestimantes, quae etiam inter animalia e turpibus sunt vilia, infantium insensatorum more decepti:"
,"25":"propter hoc, tamquam pueris insensatis, iudicium in derisum dedisti."
,"26":"Qui autem ludibriis increpationis non sunt correcti, dignum Dei iudicium experientur;"
,"27":"in quibus enim ipsi patientes indignabantur, per haec, quos putabant deos, in ipsis, cum exterminarentur, videntes, illum, quem olim negabant se nosse, verum Deum agnoverunt; propter quod et finis condemnationis venit super illos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Vani autem sunt natura omnes homines, in quibus non subest scientia Dei; et de his, quae videntur bonis, non potuerunt intellegere eum, qui est, neque operibus attendentes agnoverunt artificem."
,"2":"Sed aut ignem aut spiritum aut citatum aerem,aut gyrum stellarum aut violentam aquam aut luminaria caeli, rectores orbis terrarum, deos putaverunt."
,"3":"Quorum si specie delectati, illa deos putaverunt, sciant quanto his dominator eorum melior est: speciei enim principium et auctor constituit ea."
,"4":"Si autem virtutem et operationem eorum mirati, intellegant ab illis quanto, qui haec fecit, fortior est illis:"
,"5":"a magnitudine enim et pulchritudine creaturarum,cognoscibiliter potest creator horum videri."
,"6":"Sed tamen in his minor est querela, et hi enim fortasse errant,Deum quaerentes et volentes invenire."
,"7":"Etenim, cum in operibus illius conversentur, inquirunt,et credunt visui, quoniam pulchra sunt, quae videntur."
,"8":"Iterum autem nec his potest ignosci:"
,"9":"si enim tantum valuerunt scire, ut possent aestimare saeculum, quomodo huius Dominum non facilius invenerunt?"
,"10":"Infelices autem, et in rebus mortuis sunt spes illorum, qui appellaverunt deos opera manuum hominum, aurum et argentum, artis inventionem,et similitudines animalium,aut lapidem inutilem, opus manus antiquae."
,"11":"Aut si quis artifex faber de silva tractabile lignum secuerit,C huius docte erasit omnem corticem,et arte sua usus diligenter,fabricavit vas utile in conversationem vitae;"
,"12":"reliquiis autem eius operis,ad praeparationem escae abusus, satiatus est,"
,"13":"et reliquum horum, quod ad nullos usus facit, lignum curvum et nodis concretum accipiens, sculpsit diligenter per vacuitatem suam,et per scientiam tempore requiei figuravit illud -,assimilavit illud imagini hominis"
,"14":"aut alicui ex vilibus animalibus illud comparavit, perliniens rubrica et rubicundum faciens fuco colorem illius,et omnem maculam, quae in illo erat, perliniens"
,"15":"et faciens ei dignam habitationem,in pariete posuit illud, confirmans ferro."
,"16":"Ne igitur forte caderet providit illi, sciens quoniam non potest se ipsum adiuvare: imago enim est, et opus est illi adiutorium."
,"17":"Et de substantiis et de nuptiis et de filiis votum faciens, non erubescit loqui cum illo, quod sine anima est, et pro sanitate quidem infirmum deprecatur"
,"18":"et pro vita rogat mortuum,et in adiutorium rem omnino inutilem invocat, et pro itinere petit ab eo, quod ambulare non potest,"
,"19":"et de acquirendo et de operando et de bono manuum eventu,petit utilitatem ab eo, quod prorsus inutile est manibus."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Iterum alius navigare cogitans,et per feros fluctus iter facere incipiens, ligno portante se, fragilius lignum invocat."
,"2":"Illud enim cupiditas acquirendi excogitavit, et artifex sapientia fabricavit."
,"3":"Tua autem, Pater, providentia gubernat, quoniam dedisti et in mari viam,et inter fluctus semitam firmissimam,"
,"4":"ostendens quoniam potens es ex omnibus salvare, etiamsi sine arte aliquis adeat mare."
,"5":"Tu autem vis, ut non sint vacua sapientiae tuae opera, propter hoc etiam et exiguo ligno credunt homines animas suas,et, transeuntes fluctus per ratem, liberati sunt."
,"6":"Sed et ab initio, cum perirent superbi gigantes, spes orbis terrarum ad ratem confugiens, reliquit saeculo semen nativitatis, quae manu tua erat gubernata."
,"7":"Benedictum est enim lignum, per quod fit iustitia;"
,"8":"per manus autem, quod fit, maledictum et ipsum et qui fecit illud, quia ille quidem operatus est, illud autem, cum esset corruptibile, deus cognominatus est."
,"9":"Similiter autem odio sunt Deo impius et impietas eius:"
,"10":"etenim, quod factum est, cum illo, qui fecit, tormenta patietur."
,"11":"Propter hoc et in idolis nationum erit visitatio, quoniam in creatura Dei in abominationem facta sunt,et in tentationem animabus hominum,et in muscipulam pedibus insipientium."
,"12":"Initium enim fornicationis est exquisitio idolorum, et adinventio illorum corruptio vitae est;"
,"13":"neque enim erant ab initio, neque erunt in perpetuum."
,"14":"Supervacuitate enim hominum haec advenerunt in orbem terrarum, et ideo brevis illorum finis est inventus."
,"15":"Acerbo enim luctu dolens pater, cito sibi rapti filii fecit imaginem,et illum, qui tunc homo mortuus fuerat, nunc tamquam deum colere coepit,et tradidit subiectis sacra et sacrificia."
,"16":"Deinde, interveniente tempore, convalescens iniqua consuetudo,tamquam lex custodita est, et tyrannorum imperio colebantur figmenta;"
,"17":"quos cum in palam homines honorare non possent, propter hoc quod longe essent, e longinquo figura eorum efficta, evidentem imaginem regis, quem honorare volebant, fecerunt, ut illum, qui aberat, tamquam praesentem colerent sua sollicitudine."
,"18":"Ad incrementum autem huius culturae,provexit et hos, qui ignorabant, artificis eximia diligentia;"
,"19":"ille enim volens forsitan placere illi, qui se assumpsit, elaboravit arte sua, ut similitudinem in melius figuraret."
,"20":"Multitudo autem hominum abducta per speciem operis,eum, qui paulo ante tamquam homo honoratus fuerat, nunc deum aestimaverunt."
,"21":"Et haec fuit vitae humanae deceptio, quoniam aut necessitati aut regibus deservientes homines,incommunicabile nomen lapidibus et lignis imposuerunt."
,"22":"Postea non suffecit errasse eos circa Dei scientiam, sed et in magno viventes inscientiae bello, tot et tam magna mala pacem appellant."
,"23":"Aut enim filios suos sacrificantes aut obscura sacrificia facientes,aut insaniae plenas peregrinorum rituum vigilias habentes,"
,"24":"neque vitam neque nuptias mundas iam custodiunt, sed alius alium per insidias occidit aut adulterans contristat."
,"25":"Et omnia commixta sunt: sanguis et homicidium, furtum et fictio, corruptio et infidelitas, turbatio et periurium,"
,"26":"tumultus bonorum, gratiarum immemoratio, animarum inquinatio, generis immutatio, nuptiarum inordinatio, moechia et impudicitia."
,"27":"Infandorum enim idolorum cultura,omnis mali initium et causa est et finis."
,"28":"Aut enim, dum laetantur, insaniunt aut vaticinantur falsa,aut vivunt iniuste aut peierant cito."
,"29":"Dum enim confidunt in idolis, quae sine anima sunt, male iurantes noceri se non sperant."
,"30":"Utraque autem illis evenient digne, quoniam male censerunt de Deo attendentes idolis,et iuraverunt iniuste in dolo contemnentes sanctitatem."
,"31":"Non enim iuratorum virtus, sed peccantium poena,perambulat semper iniustorum praevaricationem."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Tu autem, Deus noster, suavis et verus es, patiens et in misericordia disponens omnia."
,"2":"Etenim, si peccaverimus, tui sumus, scientes potentiam tuam; non peccabimus autem, scientes quoniam apud te sumus computati."
,"3":"Nosse enim te consummata iustitia est, et scire virtutem tuam radix est immortalitatis."
,"4":"Nec enim in errorem induxit nos hominum malae artis excogitatio, nec adumbrantium labor sine fructu, effigies maculata per varios colores,"
,"5":"cuius aspectus insensatis in concupiscentiam venit, et diligit mortuae imaginis effigiem sine anima."
,"6":"Malorum amatores digni sunt, qui spem habeant in talibus,et qui faciunt illos et qui diligunt et qui colunt."
,"7":"Sed et figulus, mollem terram premens laboriose, fingit ad usus nostros unumquodque vas; et de eodem luto fingit, quae mundis operibus in usum sunt, vasa, et quae his sunt contraria, omnia similiter; horum autem singulorum vasorum quis utriusque sit usus, iudex est figulus."
,"8":"Et cum malo labore deum vanum fingit de eodem luto,ille, qui paulo ante de terra factus fuerat, et post pusillum reducit se, unde acceptus est, repetitus animae debitum."
,"9":"Sed cura est illi, non quia laboraturus est, nec quoniam brevis illi vita est, sed concertatur aurificibus et argentariis,et aerarios imitatur,et gloriam praefert, quoniam res supervacuas fingit."
,"10":"Cinis est cor eius, et terra despectior spes illius, et luto vilior vita eius,"
,"11":"quoniam ignoravit, qui se finxit,et qui inspiravit illi animam, quae operatur, et qui insufflavit ei spiritum vitalem."
,"12":"Sed et aestimavit lusum esse vitam nostram,et conversationem vitae compositam ad lucrum; oportere enim dicit undecumque etiam ex malo acquirere."
,"13":"Hic enim scit se super omnes delinquere, qui ex terrae materia,fragilia vasa et sculptilia fingit."
,"14":"Omnes enim insipientes et infelices supra modum animae infantis,sunt inimici populi tui et per potentiam opprimentes illum."
,"15":"Quoniam omnia idola nationum deos aestimaverunt, quibus neque oculorum usus est ad videndum, neque nares ad percipiendum spiritum, neque aures ad audiendum, neque digiti manuum ad tractandum, sed et pedes eorum pigri ad ambulandum."
,"16":"Homo enim fecit illos, et, qui spiritum mutuatus est, is finxit illos; nemo enim sibi similem homo poterit deum fingere:"
,"17":"cum autem sit mortalis, mortuum fingit manibus iniquis. Melior enim est ipse his, quos colit, quia ipse quidem vixit, cum esset mortalis, illi autem numquam."
,"18":"Sed et animalia miserrima colunt; in insipientia enim, aliis comparata, his sunt deteriora."
,"19":"Nec pulchra in his inveniuntur, quantum desiderari possit, ut fit in animalium conspectu; effugerunt autem et Dei laudem et benedictionem eius."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Propter haec per his similia castigati sunt digne,et per multitudinem bestiarum tormenta passi sunt."
,"2":"Pro qua castigatione bene disponens populum tuum,ad concupiscentiam delectamenti sui, novum saporem, escam parasti eis ortygometram:"
,"3":"ut illi quidem concupiscentes escam,propter foeditatem eorum animalium, quae missa sunt, etiam a necessaria concupiscentia averterentur; hi autem in brevi inopes facti,etiam novam gustarent escam."
,"4":"Oportebat enim illis quidem sine excusatione,supervenire interitum exercentibus tyrannidem, his autem tantum ostendere,quemadmodum inimici eorum exterminabantur."
,"5":"Etenim, cum illis supervenit saeva bestiarum ira, morsibus perversorum colubrorum exterminabantur; sed non in perpetuum ira tua permansit,"
,"6":"sed ad correptionem in brevi turbati sunt, signum habentes salutis ad commemorationem mandati legis tuae."
,"7":"Qui enim conversus est, non per hoc, quod videbat, sanabatur, sed per te omnium salvatorem."
,"8":"In hoc autem ostendisti inimicis nostris,quia tu es, qui liberas ab omni malo."
,"9":"Illos enim locustarum et muscarum occiderunt morsus, et non est inventa sanitas animae illorum, quia digni erant ab huiusmodi exterminari;"
,"10":"filios autem tuos nec draconum venenatorum vicerunt dentes: misericordia enim tua adveniens sanabat illos."
,"11":"In memoriam enim sermonum tuorum,pungebantur et velociter salvabantur, ne in altam incidentes oblivionem,non possent distrahi a tua beneficientia."
,"12":"Etenim neque herba neque malagma sanavit eos, sed tuus, Domine, sermo, qui sanat omnia."
,"13":"Tu enim vitae et mortis habes potestatem, et deducis ad portas mortis et reducis."
,"14":"Homo autem occidit quidem per malitiam suam,et spiritum, qui exierit, restituere non potest, nec liberare animam, quae recepta est."
,"15":"Sed tuam manum effugere impossibile est:"
,"16":"negantes enim te nosse impii,per fortitudinem brachii tui flagellati sunt, novis pluviis et grandinibus et imbribus persecutionem passi,et per ignem consumpti."
,"17":"Quod enim valde mirabile erat, in aqua, quae omnia exstinguit, plus ignis valebat; vindex est enim orbis iustorum."
,"18":"Quodam enim tempore mansuetabatur flamma, ne combureret, quae ad impios missa erant, animalia, sed ut ipsi videntes,scirent quoniam Dei iudicio patiuntur persecutionem."
,"19":"Quodam autem tempore et in medio aquarum,supra virtutem ignis exardescit, ut iniquae terrae genimina exterminet."
,"20":"Pro quibus angelorum esca nutrivisti populum tuum,et paratum panem de caelo praestitisti illis sine labore, omne delectamentum in se habentem,et ad omnem gustum aptum."
,"21":"Substantia enim tua dulcedinem tuam in filios ostendebat; et deserviens sumentis voluntati, ad quod quisque volebat, convertebatur."
,"22":"Nix autem et glacies sustinebant ignem et non tabescebant, ut scirent quoniam fructus inimicorum,exterminabat ignis ardens in grandine et in pluviis coruscans;"
,"23":"hic autem iterum, ut nutrirentur iusti, etiam suae virtutis oblitus est."
,"24":"Creatura enim tibi Factori deserviens,invalescit in tormentum adversus iniustos,et lenior fit ad benefaciendum,pro his, qui in te confidunt."
,"25":"Propter hoc, et tunc in omnia transfigurata, omnium nutrici gratiae tuae deserviebat,ad voluntatem eorum, qui a te desiderabant,"
,"26":"ut discerent filii tui, quos dilexisti, Domine, quoniam non nativitates fructuum pascunt homines, sed sermo tuus credentes in te conservat."
,"27":"Quod enim ab igne non poterat exterminari, statim ab exiguo radio solis calefactum tabescebat,"
,"28":"ut notum esset quoniam oportet praevenire solem,ad benedictionem tuam,et ad ortum lucis te adorare."
,"29":"Ingrati enim spes tamquam hibernalis glacies tabescet,et disperiet tamquam aqua supervacua."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Magna sunt enim iudicia tua et inenarrabilia; propter hoc indisciplinatae animae erraverunt."
,"2":"Dum enim persuasum habent iniqui posse dominari nationi sanctae, captivi tenebrarum et longae noctis compediti, inclusi sub tectis, fugitivi perpetuae providentiae iacuerunt."
,"3":"Et dum putant se latere in obscuris peccatis, tenebroso oblivionis velamento,dispersi sunt, paventes horrende, et umbris perturbati."
,"4":"Neque enim, quae continebat illos, spelunca sine timore custodiebat, quoniam sonitus descendentes perturbabant illos, et phantasmata tristi vultu maerentia apparebant."
,"5":"Et ignis quidem nulla vis poterat illis lumen praebere, nec siderum limpidae flammae,illuminare poterant illam noctem horrendam."
,"6":"Apparebat autem illis tantum subitaneus ignis timore plenus, et timore perculsi illius, quae non videbatur, visionis,aestimabant deteriora esse, quae videbantur;"
,"7":"et magicae artis appositi erant derisus, et in sapientia gloriae correptio cum contumelia."
,"8":"Illi enim, qui promittebant,timores et perturbationes expellere se ab anima languente, hi cum ridiculo timore languebant."
,"9":"Nam, etsi nihil turbulenti illos terrebat, transitu animalium et serpentium sibilatione commoti, tremebundi peribant, et aerem, quem nulla ratione quis effugere posset, negantes se videre."
,"10":"Formidinis enim suae propriae nequitia dat testimonium, cum sit condemnata; semper autem praesumit saeva perturbata conscientia."
,"11":"Nihil enim est timor nisi proditio auxiliorum, quae sunt a cogitatione;"
,"12":"et, dum ab intus minor est exspectatio, maiorem computat inscientiam eius causae, quae tormentum praestat."
,"13":"Illi autem per impotentem vere noctem,et ab impotentis inferni speluncis supervenientem, eundem somnum dormientes,"
,"14":"aliquando a monstris exagitabantur phantasmatum, aliquando animae deficiebant proditione: subitaneus enim illis et insperatus timor infundebatur."
,"15":"Itaque, si quisquam illic decidisset, custodiebatur in carcere sine ferro reclusus."
,"16":"Sive enim rusticus quis erat aut pastor,aut agri laborum operarius praeoccupatus, ineffugibilem sustinebat necessitatem, una enim catena tenebrarum omnes erant colligati."
,"17":"Sive spiritus sibilans,aut inter spissos arborum ramos avium sonus suavis,aut numerus aquae decurrentis nimium,aut sonus durus praecipitatarum petrarum"
,"18":"aut ludentium animalium cursus invisus,aut mugientium ferissimarum bestiarum vox,aut resonans de cavitate montium echo,deficientes faciebant illos prae timore."
,"19":"Omnis enim orbis terrarum limpido illuminabatur lumine,et non impeditis operibus continebatur;"
,"20":"solis autem illis superposita erat gravis nox, imago tenebrarum, quae illos recepturae erant: ipsi ergo sibi erant graviores tenebris."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Sanctis autem tuis maxima erat lux; et horum quidem vocem illi audiebant, sed figuram non videbant,et, quia non et ipsi eadem passi erant, magnificabant;"
,"2":"quoniam autem, qui ante laesi erant, non laedebant, gratias agebant,et, quod eos ante distulissent, donum petebant."
,"3":"Propter quod ignis ardentem columnam, ducem ignotae viae, et solem sine laesura gloriosae peregrinationis praestitisti."
,"4":"Digni quidem illi carere luce,et pati carcerem tenebrarum, qui inclusos custodierant filios tuos, per quos incipiebat incorruptum legis lumen saeculo dari."
,"5":"Cum cogitarent iustorum occidere infantes,C et uno exposito filio et liberato - in traductionem illorum multitudinem filiorum abstulisti,et pariter illos perdidisti in aqua valida."
,"6":"Illa nox ante cognita est a patribus nostris, ut vere scientes, quibus iuramentis crediderunt, animaequiores essent."
,"7":"Suscepta est a populo tuo sanitas quidem iustorum, iniustorum autem exterminatio;"
,"8":"sicut enim punivisti adversarios, sic et nos provocans magnificasti."
,"9":"Absconse enim sacrificabant iusti pueri bonorum,et divinitatis legem in concordia disposuerunt; similiter et bona et pericula recepturos sanctos,patrum iam ante decantantes laudes."
,"10":"Resonabat autem inconveniens inimicorum clamor, et flebilis perferebatur vox ploratorum infantium."
,"11":"Simili autem poena servus cum domino afflictus est, et popularis homo regi similia passus;"
,"12":"similiter ergo omnes uno nomine mortis,mortuos habebant innumerabiles. Nec enim ad sepeliendum vivi sufficiebant, quoniam uno momento, quae erat praeclarior generatio illorum, exterminata erat."
,"13":"De omnibus enim non credentes propter veneficia, in exterminio primogenitorum,confessi sunt populum filium Dei esse."
,"14":"Cum enim quietum silentium contineret omnia, et nox in suo cursu medium iter haberet,"
,"15":"omnipotens sermo tuus de caelo a regalibus sedibus,durus bellator in mediam exterminii terram prosilivit, gladium acutum insimulatum imperium tuum portans;"
,"16":"et stans replevit omnia morte,et usque ad caelum attingebat stans in terra."
,"17":"Tunc continuo visus somniorum terribilium turbaverunt illos, et timores supervenerunt insperati,"
,"18":"et alius alibi proiectus semivivus, propter quam moriebatur causam, demonstrabat."
,"19":"Visiones enim, quae illos turbaverunt, haec praemonebant, ne inscii quare mala patiebantur, perirent."
,"20":"Tetigit autem et iustos tentatio mortis, et interitus in eremo factus est multitudinis, sed non diu permansit ira tua."
,"21":"Properans enim homo sine querela propugnavit, proferens servitutis suae scutum: orationem et per incensum deprecationem; restitit irae et finem imposuit necessitati, ostendens quoniam tuus est famulus."
,"22":"Vicit autem iram non in virtute corporis, nec armaturae potentia, sed verbo illum, qui se vexabat, subiecit, iuramenta parentum et testamentum commemorans."
,"23":"Cum enim iam acervatim cecidissent super alterutrum mortui, interstitit et amputavit impetum,et divisit illam, quae ad vivos ducebat, viam."
,"24":"In veste enim poderis, quam habebat, totus erat orbis terrarum, et parentum magnalia in quattuor ordinum lapidum sculptura, et magnificentia tua in diademate capitis illius."
,"25":"His cessit, qui exterminabat, et haec extimuit; erat enim sola tentatio irae sufficiens."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Impiis autem usque in novissimum sine misericor dia ira supervenit; praesciebat enim et futura illorum, "
,"2":"quoniam, cum ipsi permisissent, ut se educerent, et cum magna sollicitudine praemisissent illos, consequebantur illos paenitentia acti."
,"3":"Adhuc enim inter manus habentes luctus,et deplorantes ad monumenta mortuorum, aliam sibi assumpserunt cogitationem inscientiae,et, quos rogantes proiecerant, hos tamquam fugitivos persequebantur."
,"4":"Trahebat enim illos ad hunc finem digna necessitas; et horum, quae acciderant, oblivionem immisit, ut eam, quae deerat tormentis, suppleret punitionem,"
,"5":"et populus quidem tuus mirabile iter tentaret, illi autem novam mortem invenirent."
,"6":"Omnis enim creatura in suo genere iterum ab initio refigurabatur, deserviens tuis praeceptis, ut pueri tui custodirentur illaesi."
,"7":"Nam nubes castra eorum obumbrans, et ex aqua, quae ante erat, emersio terrae aridae apparuit: e mari Rubro via sine impedimento, et campus germinans de fluctu violento,"
,"8":"per quem cum tota natione transierunt, qui tegebantur tua manu, videntes tua mirabilia monstra."
,"9":"Tamquam enim equi depaverunt escam,et tamquam agni exsultaverunt, magnificantes te, Domine, qui liberasti illos."
,"10":"Memores enim erant adhuc eorum, quae in incolatu illorum facta fuerant, quemadmodum pro natione animalium eduxit terra muscas, et pro piscibus eructavit fluvius multitudinem ranarum."
,"11":"Novissime autem viderunt novam creaturam avium, cum, adducti concupiscentia, postulaverunt escas epulationis:"
,"12":"in consolationem enim desiderii ascendit illis de mari ortygometra."
,"13":"Et vexationes peccatoribus supervenerunt, non sine illis, quae ante facta erant, argumentis per vim fulminum: iuste enim patiebantur secundum suas nequitias; etenim detestabiliorem inhospitalitatem instituerunt."
,"14":"Alii quidem ignotos non recipiebant advenas, isti autem beneficos hospites in servitutem redigebant."
,"15":"Et non solum haec, sed et alius quidam respectus erit illorum, quoniam inviti recipiebant extraneos;"
,"16":"isti autem, qui cum laetitia receperunt hos, qui eisdem usi erant iustitiis, saevissimis afflixerunt doloribus."
,"17":"Percussi sunt autem caecitate,sicut illi in foribus iusti, cum, vastis cooperti tenebris, unusquisque transitum ostii sui quaerebat."
,"18":"Inter se enim elementa convertuntur, sicut in psalterio voces numeri nomen immutant, semper tamen suum sonum custodiunt; quod quidem ex ipso visu eorum, quae facta sunt, certo aestimari potest."
,"19":"Agrestia enim in aquatica convertebantur, et, quaecumque erant natantia, in terram transibant."
,"20":"Ignis in aqua valebat supra suam virtutem, et aqua exstinguentis naturae obliviscebatur."
,"21":"Flammae e contrario corruptibilium animalium,non vexaverunt carnes inambulantium, nec dissolvebant illud, quod facile dissolvebatur, glaciei simile genus immortalis escae."
,"22":"In omnibus enim magnificasti populum tuum, Domine, et honorasti et non despexisti, in omni tempore et in omni loco assistens eis."
}`)

}
