package bibles

func PT_BS_LoadInfo(CurrentBible *Bible) {
	CurrentBible.SetInfo("pt.bs", "Biblia Sagrada")
	CurrentBible.AddBook("VPGN", "Génesis")
	CurrentBible.AddBook("VPEX", "Êxodo")
	CurrentBible.AddBook("VPLV", "Levítico")
	CurrentBible.AddBook("VPNM", "Números")
	CurrentBible.AddBook("VPDT", "Deuteronómio")
	CurrentBible.AddBook("VHIE", "Josué")
	CurrentBible.AddBook("VHID", "Juízes")
	CurrentBible.AddBook("VH1S", "1 Samuel")
	CurrentBible.AddBook("VH2S", "2 Samuel")
	CurrentBible.AddBook("VH1R", "1 Reis")
	CurrentBible.AddBook("VH2R", "2 Reis")
	CurrentBible.AddBook("VH1P", "1 Crónicas")
	CurrentBible.AddBook("VH2P", "2 Crónicas")
	CurrentBible.AddBook("VHED", "Esdras")
	CurrentBible.AddBook("VHNH", "Neemias")
	CurrentBible.AddBook("VH1M", "1 Macabeus")
	CurrentBible.AddBook("VH2M", "2 Macabeus")
	CurrentBible.AddBook("VMIS", "Isaías")
	CurrentBible.AddBook("VMIE", "Jeremias")
	CurrentBible.AddBook("VMEZ", "Ezequiel")
	CurrentBible.AddBook("VNOS", "Oseias")
	CurrentBible.AddBook("VNIL", "Joel")
	CurrentBible.AddBook("VNAM", "Amós")
	CurrentBible.AddBook("VNAB", "Abdias")
	CurrentBible.AddBook("VNIN", "Jonas")
	CurrentBible.AddBook("VNMI", "Miqueias")
	CurrentBible.AddBook("VNNH", "Naum")
	CurrentBible.AddBook("VNHA", "Habacuc")
	CurrentBible.AddBook("VNSO", "Sofonias")
	CurrentBible.AddBook("VNAG", "Ageu")
	CurrentBible.AddBook("VNZA", "Zacarias")
	CurrentBible.AddBook("VNML", "Malaquias")
	CurrentBible.AddBook("VMDN", "Daniel")
	CurrentBible.AddBook("VSIB", "Job")
	CurrentBible.AddBook("VSPR", "Provérbios")
	CurrentBible.AddBook("VSEE", "Coelet")
	CurrentBible.AddBook("VSCC", "Cântico")
	CurrentBible.AddBook("VHRT", "Rute")
	CurrentBible.AddBook("VMLM", "Lamentações")
	CurrentBible.AddBook("VHET", "Ester")
	CurrentBible.AddBook("VHTB", "Tobias")
	CurrentBible.AddBook("VHIH", "Judite")
	CurrentBible.AddBook("VMBR", "Baruc")
	CurrentBible.AddBook("VSSP", "Sabedoria")
	CurrentBible.AddBook("VSEI", "Eclesiástico")
	CurrentBible.AddBook("VSPS", "Salmos")
	CurrentBible.AddBook("NEMT", "Mateus")
	CurrentBible.AddBook("NEMC", "Marcos")
	CurrentBible.AddBook("NELC", "Lucas")
	CurrentBible.AddBook("NEIO", "João")
	CurrentBible.AddBook("NTAA", "Atos")
	CurrentBible.AddBook("NPRM", "Romanos")
	CurrentBible.AddBook("NP1C", "1 Coríntios")
	CurrentBible.AddBook("NP2C", "2 Coríntios")
	CurrentBible.AddBook("NPGA", "Gálatas")
	CurrentBible.AddBook("NPEP", "Efésios")
	CurrentBible.AddBook("NPPP", "Filipenses")
	CurrentBible.AddBook("NPCL", "Colossenses")
	CurrentBible.AddBook("NPPM", "Filémon")
	CurrentBible.AddBook("NP1E", "1 Tessalonicenses")
	CurrentBible.AddBook("NP2E", "2 Tessalonicenses")
	CurrentBible.AddBook("NP1I", "1 Timóteo")
	CurrentBible.AddBook("NP2I", "2 Timóteo")
	CurrentBible.AddBook("NPTT", "Tito")
	CurrentBible.AddBook("NTHB", "Hebreus")
	CurrentBible.AddBook("NCIB", "Tiago")
	CurrentBible.AddBook("NC1P", "1 Pedro")
	CurrentBible.AddBook("NC2P", "2 Pedro")
	CurrentBible.AddBook("NCID", "Judas")
	CurrentBible.AddBook("NC1I", "1 João")
	CurrentBible.AddBook("NC2I", "2 João")
	CurrentBible.AddBook("NC3I", "3 João")
	CurrentBible.AddBook("NTAI", "Apocalipse")
}

func PT_BS_LoadBooks(CurrentBible *Bible) {
	for x := range CurrentBible.Codes {
		var cb *Book = NewBook(CurrentBible.Codes[x], CurrentBible.Names[x])
		switch CurrentBible.Codes[x] {
		case "VPGN":
			PT_BS_LoadVPGNChapters(cb)
		case "VPEX":
			PT_BS_LoadVPEXChapters(cb)
		case "VPLV":
			PT_BS_LoadVPLVChapters(cb)
		case "VPNM":
			PT_BS_LoadVPNMChapters(cb)
		case "VPDT":
			PT_BS_LoadVPDTChapters(cb)
		case "VHIE":
			PT_BS_LoadVHIEChapters(cb)
		case "VHID":
			PT_BS_LoadVHIDChapters(cb)
		case "VH1S":
			PT_BS_LoadVH1SChapters(cb)
		case "VH2S":
			PT_BS_LoadVH2SChapters(cb)
		case "VH1R":
			PT_BS_LoadVH1RChapters(cb)
		case "VH2R":
			PT_BS_LoadVH2RChapters(cb)
		case "VH1P":
			PT_BS_LoadVH1PChapters(cb)
		case "VH2P":
			PT_BS_LoadVH2PChapters(cb)
		case "VHED":
			PT_BS_LoadVHEDChapters(cb)
		case "VHNH":
			PT_BS_LoadVHNHChapters(cb)
		case "VH1M":
			PT_BS_LoadVH1MChapters(cb)
		case "VH2M":
			PT_BS_LoadVH2MChapters(cb)
		case "VMIS":
			PT_BS_LoadVMISChapters(cb)
		case "VMIE":
			PT_BS_LoadVMIEChapters(cb)
		case "VMEZ":
			PT_BS_LoadVMEZChapters(cb)
		case "VNOS":
			PT_BS_LoadVNOSChapters(cb)
		case "VNIL":
			PT_BS_LoadVNILChapters(cb)
		case "VNAM":
			PT_BS_LoadVNAMChapters(cb)
		case "VNAB":
			PT_BS_LoadVNABChapters(cb)
		case "VNIN":
			PT_BS_LoadVNINChapters(cb)
		case "VNMI":
			PT_BS_LoadVNMIChapters(cb)
		case "VNNH":
			PT_BS_LoadVNNHChapters(cb)
		case "VNHA":
			PT_BS_LoadVNHAChapters(cb)
		case "VNSO":
			PT_BS_LoadVNSOChapters(cb)
		case "VNAG":
			PT_BS_LoadVNAGChapters(cb)
		case "VNZA":
			PT_BS_LoadVNZAChapters(cb)
		case "VNML":
			PT_BS_LoadVNMLChapters(cb)
		case "VMDN":
			PT_BS_LoadVMDNChapters(cb)
		case "VSIB":
			PT_BS_LoadVSIBChapters(cb)
		case "VSPR":
			PT_BS_LoadVSPRChapters(cb)
		case "VSEE":
			PT_BS_LoadVSEEChapters(cb)
		case "VSCC":
			PT_BS_LoadVSCCChapters(cb)
		case "VHRT":
			PT_BS_LoadVHRTChapters(cb)
		case "VMLM":
			PT_BS_LoadVMLMChapters(cb)
		case "VHET":
			PT_BS_LoadVHETChapters(cb)
		case "VHTB":
			PT_BS_LoadVHTBChapters(cb)
		case "VHIH":
			PT_BS_LoadVHIHChapters(cb)
		case "VMBR":
			PT_BS_LoadVMBRChapters(cb)
		case "VSSP":
			PT_BS_LoadVSSPChapters(cb)
		case "VSEI":
			PT_BS_LoadVSEIChapters(cb)
		case "VSPS":
			PT_BS_LoadVSPSChapters(cb)
		case "NEMT":
			PT_BS_LoadNEMTChapters(cb)
		case "NEMC":
			PT_BS_LoadNEMCChapters(cb)
		case "NELC":
			PT_BS_LoadNELCChapters(cb)
		case "NEIO":
			PT_BS_LoadNEIOChapters(cb)
		case "NTAA":
			PT_BS_LoadNTAAChapters(cb)
		case "NPRM":
			PT_BS_LoadNPRMChapters(cb)
		case "NP1C":
			PT_BS_LoadNP1CChapters(cb)
		case "NP2C":
			PT_BS_LoadNP2CChapters(cb)
		case "NPGA":
			PT_BS_LoadNPGAChapters(cb)
		case "NPEP":
			PT_BS_LoadNPEPChapters(cb)
		case "NPPP":
			PT_BS_LoadNPPPChapters(cb)
		case "NPCL":
			PT_BS_LoadNPCLChapters(cb)
		case "NPPM":
			PT_BS_LoadNPPMChapters(cb)
		case "NP1E":
			PT_BS_LoadNP1EChapters(cb)
		case "NP2E":
			PT_BS_LoadNP2EChapters(cb)
		case "NP1I":
			PT_BS_LoadNP1IChapters(cb)
		case "NP2I":
			PT_BS_LoadNP2IChapters(cb)
		case "NPTT":
			PT_BS_LoadNPTTChapters(cb)
		case "NTHB":
			PT_BS_LoadNTHBChapters(cb)
		case "NCIB":
			PT_BS_LoadNCIBChapters(cb)
		case "NC1P":
			PT_BS_LoadNC1PChapters(cb)
		case "NC2P":
			PT_BS_LoadNC2PChapters(cb)
		case "NCID":
			PT_BS_LoadNCIDChapters(cb)
		case "NC1I":
			PT_BS_LoadNC1IChapters(cb)
		case "NC2I":
			PT_BS_LoadNC2IChapters(cb)
		case "NC3I":
			PT_BS_LoadNC3IChapters(cb)
		case "NTAI":
			PT_BS_LoadNTAIChapters(cb)
		}
		CurrentBible.Books = append(CurrentBible.Books, *cb)
	}
}

func PT_BS_LoadNC1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Aquilo que existia desde o princípio, o que ouvimos, o que vimos com os nossos olhos, o que contemplámos,e o que as nossas mãos apalparam: falamos da Palavra, que é a Vida."
,"2":"Porque a Vida manifestou-se, nós vimo-la, damos testemunho dela, e vos anunciamos a Vida Eterna. Ela estava voltada para o Pai,e manifestou-se-nos."
,"3":"O que vimos e ouvimos, isso agora vos anunciamos, para que estejais,em comunhão connosco. A nossa comunhão é com o Pai,e com seu Filho Jesus Cristo."
,"4":"Escrevemo-vos estas coisas, para que a vossa alegria seja completa."
,"5":"É esta a mensagem que ouvimos d'Ele e que agora vos anunciamos: Deus é luz e n'Ele não há trevas."
,"6":"Se dizemos que estamos em comunhão com Deus e no entanto andamos em trevas, somos mentirosos e não praticamos a Verdade."
,"7":"Mas, se caminhamos na luz, como Deus está na luz, estamos em comunhão uns com os outros, e o sangue de Jesus, o Filho de Deus, purifica-nos de todo o pecado."
,"8":"Se dissermos que não temos pecado, enganamo-nos a nós mesmos, e a Verdade não está em nós."
,"9":"Se reconhecemos os nossos pecados, Deus que é fiel e justo perdoará os nossos pecados e nos purificará de toda a injustiça."
,"10":"Se dissermos que nunca pecamos, afirmamos que Deus é mentiroso, e a sua palavra não está em nós."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Meus filhinhos, escrevo-vos estas coisas para que não pequeis. Entretanto, se alguém pecou, temos um advogado junto do Pai: Jesus Cristo, o justo."
,"2":"Ele é a vítima de expiação pelos nossos pecados; e não só pelos nossos, mas também pelos pecados do mundo inteiro."
,"3":"Para sabermos se conhecemos a Deus, basta ver se cumprimos os seus mandamentos."
,"4":"Quem diz que conhece a Deus, mas não cumpre os seus mandamentos, é um mentiroso, e a Verdade não está nele."
,"5":"Por outro lado, o amor de Deus realiza-se de facto em quem observa a Palavra de Deus. É assim que reconhecemos que estamos com Ele:"
,"6":"quem diz que está com Deus deve comportar-se como Jesus Se comportou."
,"7":"Caríssimos, não vos comunico um mandamento novo, mas o mandamento antigo, que recebestes desde o princípio. O mandamento antigo é a Palavra que ouvistes."
,"8":"E, no entanto, o mandamento que vos comunico é novo - pois é verdadeiro em Jesus e em vós - porque as trevas já se estão a afastar e a verdadeira luz já brilha."
,"9":"Quem afirma que está na luz, mas odeia o seu irmão, ainda está nas trevas."
,"10":"Quem ama o seu irmão permanece na luz, e nele não há ocasião de queda."
,"11":"Mas quem odeia o seu irmão está nas trevas: caminha nas trevas e não sabe aonde vai, porque as trevas lhe cegaram os olhos."
,"12":"Escrevo-vos, filhinhos, porque os vossos pecados foram perdoados pelo poder do Nome de Jesus."
,"13":"Escrevo-vos, ó pais, porque conheceis Aquele que existe desde o princípio. Escrevo-vos, ó jovens, porque vencestes o Maligno."
,"14":"Escrevo-vos, filhinhos, porque conheceis o Pai. Escrevo-vos, ó pais, porque conheceis Aquele que existe desde o princípio. Escrevo-vos, jovens, porque sois fortes, e a palavra de Deus permanece em vós e porque vencestes o Maligno."
,"15":"Não ameis o mundo nem o que há no mundo. Se alguém ama o mundo, o amor do Pai não está nele."
,"16":"Pois tudo o que há no mundo - os baixos apetites, os olhos insaciáveis, a arrogância do dinheiro - são coisas que não vêm do Pai, mas do mundo."
,"17":"E o mundo passa com os seus desejos insaciáveis. Mas quem faz a vontade de Deus permanece para sempre."
,"18":"Filhinhos, já chegou a última hora. Não ouvistes dizer que o Anticristo devia chegar? Pois vede quantos anticristos já vieram! Daí reconhecemos que a última hora já chegou."
,"19":"Esses anticristos saíram do meio de nós, mas não eram dos nossos. Se tivessem sido dos nossos, teriam permanecido connosco. Mas era preciso que ficasse claro que nem todos eram dos nossos."
,"20":"Vós, porém, recebestes a unção que vem do Santo, de modo que todos possuís a sabedoria."
,"21":"Escrevi-vos, não porque ignoreis a Verdade, mas porque a conheceis e sabeis que da Verdade não saem mentiras."
,"22":"Quem é mentiroso? É quem nega que Jesus é o Messias. Esse é o Anticristo, aquele que nega o Pai e o Filho."
,"23":"Todo aquele que nega o Filho, também nega o Pai. Quem reconhece o Filho, também reconhece o Pai."
,"24":"Quanto a vós, tudo o que ouvistes desde o princípio permaneça em vós. Se permanecer em vós tudo aquilo que ouvistes desde o princípio, também vós permanecereis no Filho e no Pai."
,"25":"Esta é a promessa que Ele nos fez: a Vida eterna."
,"26":"Escrevi-vos isto, por causa daqueles que procuram desencaminhar-vos."
,"27":"Recebestes de Jesus a unção que permanece em vós, e já não tendes necessidade de que alguém vos ensine; pelo contrário, como a sua unção, que é verdadeira e não mentirosa, vos ensina tudo aquilo que Jesus vos tinha ensinado, permanecei com Ele."
,"28":"Agora, portanto, filhinhos, permanecei com Jesus; assim, quando Ele Se manifestar, sentir-nos-emos seguros, e não fracassados como os que estiverem longe d'Ele no dia da sua Vinda."
,"29":"Vós sabeis que jesus é justo; reconhecei, portanto, que todo aquele que pratica a justiça nasceu de Deus."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Vede que prova de amor o Pai nos deu chamando-nos filhos de Deus. E somo-lo de facto! Se o mundo não nos reconhece, é porque também não reconheceu a Deus."
,"2":"Amados, desde agora já somos filhos de Deus, embora ainda não se tenha tornado claro o que vamos ser. Sabemos que, quando Jesus Se manifestar, seremos semelhantes a Ele, porque O veremos como Ele é."
,"3":"Todo aquele que deposita esta esperança em Jesus purifica-se, para ser puro como Jesus é puro."
,"4":"Todo aquele que comete pecado, comete também violação da lei, porque o pecado é violação da lei."
,"5":"Mas vós sabeis que Jesus Se manifestou para tirar os pecados, e que n'Ele não existe pecado."
,"6":"Todo aquele que n'Ele permanece, não peca. Todo aquele que peca, não O viu nem O conheceu."
,"7":"Filhinhos, que ninguém vos desencaminhe. Quem pratica a justiça é justo, assim como Jesus é justo."
,"8":"Quem comete pecado pertence ao Diabo, porque o Diabo é pecador desde o princípio. Foi para isto que o Filho de Deus Se manifestou: para destruir as obras do Diabo."
,"9":"Todo aquele que nasceu de Deus não comete pecado, porque leva dentro de si a semente de Deus: não pode pecar, porque nasceu de Deus."
,"10":"Deste modo, torna-se claro quais são os filhos de Deus e quais são os filhos do Diabo: todo aquele que não pratica a justiça, isto é, que não ama o seu irmão, não é de Deus."
,"11":"Porque esta é a mensagem que ouvistes desde o princípio: que nos amemos uns aos outros."
,"12":"Não como Caim: pertencendo ao Maligno, matou o próprio irmão. E porque o matou? Porque as obras de Caim eram más, e as do seu irmão eram justas."
,"13":"Não estranheis, irmãos, se o mundo vos odeia."
,"14":"Nós sabemos que passámos da morte para a vida, porque amamos os irmãos. Quem não ama, permanece na morte."
,"15":"Todo aquele que odeia o seu irmão é assassino, e sabeis que nenhum assassino tem dentro de si a vida eterna."
,"16":"Compreendemos o que é o amor, porque Jesus deu a sua vida por nós; portanto, nós também, devemos dar a vida pelos irmãos."
,"17":"Se alguém possui bens deste mundo e, vendo o seu irmão em necessidade, lhe fecha o coração, como pode o amor de Deus permanecer nele?"
,"18":"Filhinhos, não amemos com palavras nem com a língua, mas com obras e de verdade."
,"19":"Deste modo saberemos que estamos do lado da verdade; e diante de Deus poderemos tranquilizar a nossa consciência;"
,"20":"e isto, mesmo que a nossa consciência nos condene, porque Deus é maior do que a nossa consciência e conhece todas as coisas."
,"21":"Amados, quando a consciência não nos condena, sentimos confiança para nos dirigirmos a Deus,"
,"22":"e recebemos tudo o que Lhe pedimos, porque cumprimos os seus mandamentos e fazemos o que Lhe agrada."
,"23":"E o seu mandamento é este: que tenhamos fé no nome do seu Filho Jesus Cristo e nos amemos uns aos outros, como Ele nos mandou."
,"24":"Quem cumpre os mandamentos está com Deus, e Deus está com ele. Assim, graças ao Espírito que Ele nos deu, reconhecemos que Deus está connosco."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Amados, não deis crédito a todos os que se dizem inspirados; antes, examinai os espíritos, para saberdes se vêm de Deus, pois no mundo já apareceram muitos falsos profetas."
,"2":"Para saber se alguém é inspirado por Deus, segui esta norma: fala da parte de Deus todo aquele que reconhece que Jesus Cristo encarnou."
,"3":"Todo aquele que não reconhece a Jesus não fala da parte de Deus. Esse tal é o espírito do Anticristo, do qual já ouvistes dizer que há-de vir, e que já está no mundo."
,"4":"Filhinhos, vós sois de Deus e já vencestes os anticristos, pois Aquele que está convosco é maior do que aquele que está com o mundo."
,"5":"Eles pertencem ao mundo; por isso falam a linguagem do mundo e o mundo os ouve."
,"6":"Nós, porém, somos de Deus. Por isso, quem conhece a Deus, ouve-nos; e quem não é de Deus, não nos ouve. Com isto podemos distinguir o espírito da Verdade do espírito do erro."
,"7":"Amados, amemo-nos uns aos outros, pois o amor vem de Deus. E todo aquele que ama, nasceu de Deus e conhece a Deus."
,"8":"Quem não ama não conhece a Deus, porque Deus é amor."
,"9":"Nisto se tornou visível o amor de Deus entre nós: Deus enviou o seu Filho único a este mundo, para nos dar a vida por meio d'Ele."
,"10":"E o amor consiste no seguinte: não fomos nós que amámos a Deus, mas foi Ele que nos amou e nos enviou o seu Filho como vítima expiatória pelos nossos pecados."
,"11":"Amados, se Deus nos amou a tal ponto, também nós devemos amar-nos uns aos outros."
,"12":"Ninguém jamais viu a Deus. Se nos amamos uns aos outros, Deus está connosco, e o seu amor realiza-se completamente entre nós."
,"13":"Nisto reconhecemos que permanecemos com Deus, e Ele connosco: Ele deu-nos o seu Espírito."
,"14":"E nós vimos e testemunhamos que o Pai enviou o seu Filho como Salvador do mundo."
,"15":"Quando alguém confessa que Jesus é o Filho de Deus, Deus permanece nele, e ele em Deus."
,"16":"E nós reconhecemos o amor que Deus tem por nós e acreditamos nesse amor. Deus é amor: quem permanece no amor permanece em Deus, e Deus permanece nele."
,"17":"Nisto se realizou completamente o amor entre nós: o facto de termos plena confiança no dia do julgamento, porque tal como Jesus é, assim somos nós neste mundo."
,"18":"No amor não existe medo; pelo contrário, o amor perfeito lança fora o medo, porque o medo supõe castigo. Por conseguinte, quem sente medo ainda não está realizado no amor."
,"19":"Quanto a nós, amemos, porque Ele nos amou primeiro."
,"20":"Se alguém diz: «Eu amo a Deus», e no entanto odeia o seu irmão, é mentiroso; pois quem não ama o seu irmão, a quem vê, não poderá amar a Deus, a quem não vê."
,"21":"E este é precisamente o mandamento que d'Ele recebemos: quem ama a Deus, ame também o seu irmão."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Quem acredita que Jesus é o Messias, nasceu de Deus; e quem ama Aquele que gerou, ama também Aquele que por Ele foi gerado."
,"2":"Nisto reconhecemos que amamos os filhos de Deus: quando amamos a Deus e cumprimos os seus mandamentos."
,"3":"Porque amar a Deus significa observar os seus mandamentos. E os seus mandamentos não são pesados,"
,"4":"porque todo aquele que nasceu de Deus venceu o mundo. E esta é a vitória que venceu o mundo: a nossa fé."
,"5":"De facto, quem pode vencer o mundo, senão aquele que acredita que Jesus é o Filho de Deus?"
,"6":"Este é Aquele que veio pela água e pelo sangue: Jesus Cristo. (Ele não veio apenas pela água, mas pela água e pelo sangue.) E é o Espírito quem dá testemunho, porque o Espírito é a Verdade."
,"7":"Portanto, são três que dão testemunho:"
,"8":"o Espírito, a água e o sangue, e os três estão de acordo entre si."
,"9":"Se aceitamos o testemunho dos homens, com maior razão aceitamos o testemunho de Deus. E o testemunho de que falamos é de Deus: Ele deixou o testemunho que deu de seu Filho."
,"10":"Quem acredita no Filho de Deus, tem esse testemunho dentro de si mesmo. Quem não acredita em Deus, faz d'Ele um mentiroso, porque não acredita no testemunho que Ele deu de seu Filho."
,"11":"E o testemunho é este: Deus deu-nos a Vida eterna, e esta Vida está em seu Filho."
,"12":"Quem tem o Filho, tem a Vida; quem não tem o Filho de Deus, não tem a Vida."
,"13":"Escrevo-vos tudo isto para saberdes que tendes a vida eterna, vós que credes no nome do Filho de Deus."
,"14":"Ao dirigirmo-nos a Deus, podemos ter esta confiança: quando pedimos alguma coisa conforme o seu projecto, Ele ouve-nos."
,"15":"E, se sabemos que Ele nos ouve em tudo o que Lhe pedimos, estamos certos de que já obtivemos o que Lhe pedimos."
,"16":"Se alguém vê o seu irmão cometer um pecado que não leva à morte, reze, e Deus dará a vida a esse irmão. Isso quando o pecado cometido não leva à morte. Existe um pecado que leva à morte, mas não é a respeito desse que eu digo para se rezar."
,"17":"Toda a injustiça é pecado, mas há pecados que não levam à morte."
,"18":"Nós sabemos que todo aquele que nasceu de Deus não peca; Jesus, que foi gerado por Deus, guarda-o, e por isso o Maligno não o pode atingir."
,"19":"Nós sabemos que so-mos de Deus, ao passo que o mundo inteiro está sob o poder do Maligno."
,"20":"Sabemos que o Filho de Deus veio e nos deu inteligência para conhecermos o Deus verdadeiro. E nós estamos com o Verdadeiro, graças a seu Filho Jesus Cristo. Este é o Deus verdadeiro e a Vida eterna."
,"21":"Filhinhos, cuidado com os ídolos..."
}`)

}
func PT_BS_LoadNC1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Pedro, Apóstolo de Jesus Cristo, aos que vivem dispersos como estrangeiros no Ponto, na Galácia, Capadócia, Ásia e Bitínia. Fostes escolhidos"
,"2":"de acordo com a presciência de Deus Pai e através da santificação do Espírito, para obedecerdes a Jesus Cristo e serdes purificados pelo seu sangue. Que a graça e a paz vos sejam dadas em abundância."
,"3":"Bendito seja Deus e Pai de nosso Senhor Jesus Cristo pela sua grande misericórdia. Ressuscitando a Jesus Cristo dentre os mortos, Ele fez-nos renascer para uma esperança viva,"
,"4":"para uma herança que não se corrompe, não se mancha e não murcha. Essa herança está reservada no Céu para vós"
,"5":"que, graças à fé, estais guardados pela força de Deus para a salvação que está prestes a revelar-se no final dos tempos."
,"6":"Por isso, deveis alegrar-vos, mesmo que agora, se necessário, fiqueis tristes por algum tempo, devido às várias provações."
,"7":"Deste modo, a vossa fé será provada como o ouro que passa pelo fogo. O ouro vai desaparecer, mas a vossa fé, que vale muito mais, não se perderá, até ao dia da revelação de Jesus Cristo. Então, por essa fé, recebereis louvor, glória e honra."
,"8":"Vós nunca vistes Jesus e, apesar disso, amai-l'O; não O vedes mas acreditais n'Ele. E por isso sentis alegria extraordinária e gloriosa,"
,"9":"porque alcançais a meta da fé, que é a vossa salvação."
,"10":"Essa salvação já foi objecto de busca e investigação dos profetas, quando de antemão anunciavam a graça que Deus tinha reservado para nós."
,"11":"Eles procuravam descobrir em que tempo e circunstâncias se verificariam as indicações por eles próprios recebidas do Espírito de Cristo, que estava presente neles. Foi assim que falaram dos sofrimentos de Cristo e das glórias que viriam depois."
,"12":"E foi-lhes revelado que eles mesmos não veriam essas coisas, mas que, anunciando-as, estavam a trabalhar para vós. Agora, porém, os pregadores do Evangelho manifestaram-nas, guiados pelo Espírito Santo enviado do Céu: são coisas que até os anjos gostariam de contemplar."
,"13":"Por isso, dispondo o espírito para agir, sede sóbrios e ponde toda a esperança na graça que vos será dada quando Jesus Cristo Se manifestar."
,"14":"Como filhos obedientes, já não deveis viver como dantes, quando ainda éreis ignorantes e vos deixáveis guiar pelas paixões."
,"15":"Pelo contrário, assim como é santo o Deus que vos chamou, também vós tornai-vos santos em todo o comportamento,"
,"16":"porque a Escritura diz: «Sede santos, porque Eu sou santo»."
,"17":"Vós chamais Pai Àquele que não faz distinção entre as pessoas, mas que julga cada um segundo as próprias obras. Portanto, comportai-vos com temor durante o tempo em que vos encontrais fora da pátria."
,"18":"Pois bem sabeis que não foi com coisas perecíveis, isto é, com prata nem ouro, que fostes resgatados da vida inútil que herdastes dos vossos antepassados."
,"19":"Vós fostes resgatados pelo precioso sangue de Cristo, como o de um cordeiro sem defeito e sem mancha."
,"20":"Ele era conhecido antes da fundação do mundo, mas foi manifestado no fim dos tempos por vossa causa."
,"21":"Por meio d'Ele é que acreditais em Deus, que O ressuscitou dos mortos e Lhe deu a glória, de modo que a vossa fé e a vossa esperança estejam em Deus."
,"22":"Pela obediência à verdade vos purificastes, a fim de praticar um amor fraterno sem hipocrisia. Com ardor e de coração sincero, amai-vos uns aos outros."
,"23":"Nascestes de novo, não de uma semente mortal, mas imortal, por meio da Palavra de Deus, que é viva e permanece."
,"24":"De facto, toda a carne é como a erva e toda a sua glória é como flor da erva: seca-se a erva e cai a flor;"
,"25":"mas a Palavra do Senhor permanece para sempre. Esta é a Palavra que vos foi anunciada."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Portanto, rejeitai qualquer maldade, toda a mentira, todas as formas de hipocrisia e inveja e toda a maledicência."
,"2":"Como crianças recém-nascidas, desejai o leite puro da Palavra, a fim de que, com esse leite, cresçais para a salvação,"
,"3":"pois já experimentastes como o Senhor é bom."
,"4":"Aproximai-vos do Senhor, a pedra viva rejeitada pelos homens, mas escolhida e preciosa aos olhos de Deus."
,"5":"Do mesmo modo, vós também, como pedras vivas, entrai na construção dum templo espiritual, formando um sacerdócio santo, destinado a oferecer sacrifícios espirituais que Deus aceita por meio de Jesus Cristo."
,"6":"De facto, lê-se nas Escrituras: «Eis que ponho em Sião uma pedra angular, escolhida e preciosa. Quem nela acreditar não ficará confundido»."
,"7":"Isto é: para vós que acreditais, ela será tesouro precioso; mas, para os que não acreditam, a pedra que os construtores rejeitaram tornou-se a pedra angular,"
,"8":"uma pedra de tropeço e uma rocha que faz cair. Eles tropeçam porque não acreditam na Palavra, pois foram para isso destinados."
,"9":"Vós, porém, sois raça eleita, sacerdócio régio, nação santa, povo adquirido por Deus, para proclamar as obras maravilhosas d'Aquele que vos chamou das trevas para a sua luz maravilhosa."
,"10":"Vós que antes não éreis povo, agora sois povo de Deus; vós que não tínheis alcançado misericórdia, agora alcançastes misericórdia."
,"11":"Amados, sois peregrinos e forasteiros. Por isso, recomendo-vos que fiqueis longe dos desejos baixos que provocam guerra contra vós."
,"12":"Comportai-vos de modo exemplar entre os pagãos, a fim de que eles, mesmo falando mal de vós como se fôsseis malfeitores, ao verem as boas obras que fazeis glorifiquem a Deus no dia do julgamento."
,"13":"Submetei-vos a toda a criatura humana por causa do Senhor, seja ao rei como soberano,"
,"14":"seja aos governadores como enviados dele para punir os malfeitores e para louvar os que fazem o bem."
,"15":"Pois esta é a vontade de Deus: praticar o bem, fazendo calar a ignorância dos insensatos."
,"16":"Comportai-vos como homens livres, não usando a liberdade como desculpa para o mal, mas como servos de Deus."
,"17":"Respeitai a todos, amai os irmãos, temei a Deus e respeitai o rei."
,"18":"Vós, servos, com todo o temor submetei-vos aos vossos patrões, não só aos bons e compreensivos, mas também aos que são duros."
,"19":"É louvável alguém suportar maus tratos, sofrendo injustamente por amor de Deus."
,"20":"Que mérito haveria em suportar com paciência, se fôsseis esbofeteados por terdes agido mal? Pelo contrário, se sois pacientes no sofrimento quando fazeis o bem, isto sim é acção louvável diante de Deus."
,"21":"De facto, para isto é que,fostes chamados, pois Cristo também sofreu por vós, deixando-vos o exemplo,para que sigais os seus passos."
,"22":"Ele não cometeu nenhum pecado,e mentira nenhuma foi encontrada na sua boca."
,"23":"Quando insultado, não insultava; ao sofrer, não ameaçava. Antes, depositava a sua causa,nas mãos d'Aquele que julga com justiça."
,"24":"Sobre o madeiro,levou os nossos pecados,no seu próprio corpo, a fim de que nós, mortos para os nossos pecados, vivêssemos para a justiça. Através dos seus ferimentos,é que fostes curados,"
,"25":"pois éreis como ovelhas desgarradas, mas agora voltastes ao vosso Pastor e Guarda."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Do mesmo modo, vós, mulheres, submetei-vos aos vossos maridos. Assim, se alguns são rebeldes à Palavra, a conduta das suas mulheres poderá ganhá-los sem palavras,"
,"2":"ao notarem o recato cuidadoso da vossa conduta."
,"3":"Que o vosso adorno não seja apenas de coisas exteriores, como penteado, uso de jóias de ouro ou roupas finas,"
,"4":"mas de qualidades internas, isto é, o ornamento inalterável de carácter suave e sereno. Isso sim é coisa preciosa diante de Deus."
,"5":"De facto, era assim que se enfeitavam as santas mulheres de outrora, que punham a sua esperança em Deus, submissas a seus maridos."
,"6":"É o que vemos em Sara: ela foi obediente a Abraão, chamando-lhe seu senhor. Tornar-vos-eis filhas de Sara se praticardes o bem e não vos deixardes dominar pelo medo."
,"7":"Do mesmo modo, vós, maridos, sede compreensivos na vida conjugal, mostrando consideração para com as esposas, por serem de constituição mais delicada e também por serem herdeiras como vós do dom da vida. Assim, a vossa oração não ficará sem resposta."
,"8":"Finalmente, tende todos a mesma atitude, sede compassivos, cheios de amor fraterno, misericordiosos e de espírito humilde."
,"9":"Não pagueis o mal com o mal, nem o insulto com outro insulto; pelo contrário, abençoai, porque para isso é que fostes chamados, isto é, para serdes herdeiros da bênção."
,"10":"De facto, aquele que ama a vida,e deseja ver dias felizes,guarde a sua língua do mal,e os seus lábios de proferir mentiras;"
,"11":"afaste-se do mal e pratique o bem, busque a paz e procure segui-la."
,"12":"porque os olhos do Senhor,estão sobre os justos,e os seus ouvidos estão atentos,às suas preces. Mas o rosto do Senhor volta-se,contra os que praticam o mal."
,"13":"E quem vos fará mal, se vos empenhardes em fazer o bem?"
,"14":"Se sofreis por causa da justiça, felizes de vós! Não tenhais medo deles, nem fiqueis assustados."
,"15":"Pelo contrário, reconhecei Cristo como Senhor, estando sempre prontos a dar a razão da vossa esperança a todo aquele que vos perguntar,"
,"16":"mas com bons modos, com respeito e mantendo a consciência limpa. Assim, quando fordes difamados em alguma coisa, aqueles que criticam o vosso bom comportamento em Cristo ficarão confundidos."
,"17":"Pois, se é da vontade de Deus que sofrais, é melhor que seja por praticardes o bem, e não o mal."
,"18":"De facto, o próprio Cristo morreu uma vez por todas pelos pecados, o justo pelos injustos, a fim de vos conduzir a Deus. Ele sofreu a morte em seu corpo, mas recebeu vida pelo Espírito."
,"19":"Foi então que Ele proclamou a vitória, inclusive para os espíritos aprisionados;"
,"20":"falo das pessoas que foram rebeldes outrora, nos tempos de Noé, quando Deus Se demorava em castigar o mundo. Entretanto, Noé construía a arca, na qual somente oito pessoas foram salvas da água."
,"21":"Aquela água representava o baptismo que agora vos salva; não se trata de limpeza corporal, mas do compromisso solene de uma boa consciência diante de Deus, mediante a ressurreição de Jesus Cristo."
,"22":"Ele subiu ao Céu e está sentado à direita de Deus, após ter submetido os anjos, as dominações e os poderes."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Uma vez que Cristo sofreu na carne, também vós deveis ter esta convicção: aquele que sofreu na carne, rompeu com o pecado,"
,"2":"a fim de viver o resto dos seus dias guiado pela vontade de Deus e não por paixões humanas."
,"3":"Vós passastes muito tempo vivendo conforme o estilo pagão, entregues a uma vida de dissolução, cobiça, embriaguez, comezainas, bebedeiras e idolatrias abomináveis."
,"4":"Agora, os outros estranham que não vos entregueis à mesma torrente de perdição e por isso cobrem-vos de insultos;"
,"5":"mas eles terão de prestar contas disso Àquele que em breve há-de julgar os vivos e os mortos."
,"6":"Porque é que o Evangelho também foi anunciado aos mortos? A fim de que eles vivam pelo Espírito a vida de Deus, depois de receberem, na sua carne mortal, a sentença comum a todos os homens."
,"7":"O fim de todas as coisas está próximo. Sede, portanto, moderados e sóbrios, para vos dedicardes à oração."
,"8":"Sobretudo, conservai entre vós um grande amor, porque o amor cobre uma multidão de pecados."
,"9":"Praticai a hospitalidade uns com os outros, sem murmurar."
,"10":"Cada um viva de acordo com a graça recebida e ponde-vos ao serviço dos outros, como bons administradores da graça que Deus vos concedeu."
,"11":"Quem fala, seja porta-voz de Deus; quem se dedica ao serviço, faça-o com as forças que Deus lhe dá, a fim de que em tudo Deus seja glorificado por meio de Jesus Cristo, ao qual pertencem a glória e o poder para sempre. Ámen!"
,"12":"Amados, não fiqueis alarmados com o incêndio que se espalha entre vós para vos provar, como se estivesse acontecendo algo estranho no meio de vós."
,"13":"Pelo contrário, alegrai-vos por participardes dos sofrimentos de Cristo, para que também vos alegreis e exulteis ao revelar-se a sua glória."
,"14":"Felizes de vós, quando fordes insultados por causa do nome de Cristo; isso significa que o Espírito da glória, o Espírito de Deus, repousa sobre vós."
,"15":"Que ninguém de vós sofra por ser assassino ou ladrão, malfeitor ou delator."
,"16":"Todavia, se alguém sofre como cristão, não se sinta envergonhado; mas glorifique a Deus por ter o nome de cristão."
,"17":"De facto, chegou a hora do julgamento, e está a começar pela casa de Deus. Se o nosso julgamento é o começo, qual será o fim dos que não obedecem ao Evangelho de Deus?"
,"18":"Se com dificuldade o justo consegue salvar-se, em que situação estão o ímpio e o pecador?"
,"19":"Portanto, os que sofrem de acordo com o projecto de Deus põem a sua confiança em Deus criador praticando o bem."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Faço uma admoestação aos presbíteros que estão entre vós, eu que sou presbítero como eles, testemunha dos sofrimentos de Cristo e participante da glória que vai ser revelada:"
,"2":"cuidai do rebanho de Deus que vos foi confiado, não por imposição, mas de livre e espontânea vontade, como Deus quer; não por causa de lucro, mas com generosidade;"
,"3":"não como donos daqueles que vos foram confiados, mas como modelos para o rebanho."
,"4":"Deste modo, quando aparecer o supremo Pastor, recebereis a coroa de glória que não murcha."
,"5":"Igualmente, vós, ó jovens, obedecei aos mais velhos. Revesti-vos de humildade no relacionamento mútuo, porque Deus resiste aos soberbos, mas dá a graça aos humildes."
,"6":"Humilhai-vos diante da poderosa mão de Deus, a fim de que no momento certo Ele vos levante."
,"7":"Colocai nas mãos de Deus qualquer preocupação, pois é Ele que cuida de vós."
,"8":"Sede sóbrios e vigiai! Pois o diabo, vosso inimigo, anda ao redor de vós, como um leão que ruge, procurando a quem devorar."
,"9":"Resisti-lhe, permanecendo firmes na fé, sabendo que essa mesma espécie de sofrimento atinge os vossos irmãos que estão espalhados pelo mundo."
,"10":"Depois de sofrerdes um pouco, o Deus de toda a graça, Aquele que vos chamou em Cristo para a sua glória eterna, vos restabelecerá, firmará e fortalecerá, e tornar-vos-á inabaláveis."
,"11":"A Deus pertence todo o poder para sempre. Ámen!"
,"12":"Por meio de Silvano, que considero irmão fiel, escrevi-vos estas poucas palavras, para vos admoestar e dar testemunho de que esta é a verdadeira graça de Deus. Permanecei firmes nela."
,"13":"A comunidade que vive em Babilónia, eleita como vós, manda saudações. Marcos, meu filho, também manda saudações."
,"14":"Saudai-vos uns aos outros com o beijo da caridade. Que a paz esteja com todos vós que estais em Cristo."
}`)

}
func PT_BS_LoadNC2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"O Ancião à Senhora eleita e a seus filhos, a quem amo sinceramente - não apenas eu, mas todos os que conheceram a Verdade -"
,"2":"por causa da verdade que permanece em nós e estará connosco para sempre."
,"3":"Graça, misericórdia e a paz da parte de Deus Pai e de Jesus Cristo, o Filho do Pai, na verdade e no amor."
,"4":"Fiquei muito alegre por ter encontrado alguns teus filhos que andam na verdade, segundo o mandamento que recebemos do Pai."
,"5":"E agora rogo-te, Senhora, não como quem te escreve um novo mandamento, mas o mesmo que temos desde o princípio: amemo-nos uns aos outros."
,"6":"O amor consiste nisto: em viver conforme os mandamentos d'Ele. E o primeiro mandamento, como aprendestes desde o princípio, é que vivais no amor."
,"7":"Porque muitos sedutores, que não reconhecem Jesus como Messias encarnado, espalharam-se pelo mundo. Eles são o Sedutor, o Anticristo."
,"8":"Tomai cuidado, para não perderdes o fruto dos nossos trabalhos; mas, pelo contrário, para receberdes plena recompensa."
,"9":"Todo aquele que se afasta e não permanece no ensinamento de Cristo não possui a Deus. Aquele que permanece no ensinamento é o que possui o Pai e o Filho."
,"10":"Se alguém for ter convosco, e não levar este ensinamento, não o recebais em vossa casa, nem o cumprimenteis."
,"11":"Aquele que o cumprimentar participa nas suas obras más."
,"12":"Eu teria ainda muitas coisas para vos escrever, mas não quis fazê-lo com papel e tinta. Contudo, espero ir visitar-vos e falar convosco de viva voz, para que a nossa alegria seja completa."
,"13":"Os filhos de tua irmã Eleita saúdam-te."
}`)

}
func PT_BS_LoadNC2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Simão Pedro, servo e Apóstolo de Jesus Cristo, aos que receberam, pela justiça do nosso Deus e Salvador Jesus Cristo, uma fé preciosa como a nossa."
,"2":"Que haja abundância de graça e paz, mediante o conhecimento de Deus e de Jesus Cristo nosso Senhor."
,"3":"Com o seu divino poder, Deus concedeu-nos todas as condições necessárias para a vida e a piedade, através do conhecimento de Jesus que nos chamou pela sua própria glória e virtude."
,"4":"Por meio delas é que Ele nos deu os bens extraordinários e preciosos que tinham sido prometidos, a fim de que vos tornásseis participantes da natureza divina, depois de escapardes à corrupção que o egoísmo provoca neste mundo."
,"5":"Por isso, esforçai-vos por colocar mais virtude na fé, mais conhecimento na virtude,"
,"6":"mais autodomínio no conhecimento, mais perseverança no autodomínio, mais piedade na perseverança,"
,"7":"mais fraternidade na piedade e mais amor na fraternidade."
,"8":"De facto, se tiverdes essas virtudes em abundância, elas não permitirão que vos torneis inúteis ou infrutíferos no conhecimento de nosso Senhor Jesus Cristo."
,"9":"Mas aquele que não tem essas virtudes é cego e míope, pois esqueceu-se de que foi purificado dos seus antigos pecados."
,"10":"Por isso mesmo, irmãos, procurai firmar a vossa vocação e eleição. Agindo desse modo, nunca tropeçareis."
,"11":"De facto, é assim que vos será amplamente aberta a entrada no Reino eterno de nosso Senhor e Salvador Jesus Cristo."
,"12":"Por isso, procurarei sempre recordar-vos estas coisas, embora já as conheçais e estejais firmes na verdade que alcançastes."
,"13":"Considero meu dever manter-vos despertos com as minhas admoestações, enquanto estiver nesta tenda,"
,"14":"pois sei que em breve devo despojar-me dela, conforme Jesus Cristo me revelou."
,"15":"Portanto, vou fazer de tudo para que vos lembreis sempre delas depois da minha partida."
,"16":"De facto, não tirámos de fábulas complicadas o que vos ensinámos sobre o poder e a vinda de nosso Senhor Jesus Cristo. Pelo contrário, falámos porque fomos testemunhas oculares da sua majestade."
,"17":"Pois Ele recebeu de Deus Pai a honra e a glória, quando uma voz vinda da sua Glória Lhe disse: «Este é o meu Filho amado: n'Ele encontro o meu agrado»."
,"18":"Esta voz veio do Céu, e nós próprios a ouvimos quando estávamos com Ele no monte santo."
,"19":"Por isso, acreditamos com mais firmeza na palavra dos profetas. E vós fazeis bem em considerá-la como uma luz que brilha num lugar escuro, até que venha o dia em que a estrela da manhã brilhe nos vossos corações."
,"20":"Antes de mais nada, sabei que nenhuma profecia da Escritura provém de interpretação particular,"
,"21":"pois a profecia jamais veio por vontade humana. Pelo contrário, impelidos pelo Espírito Santo, os homens falaram como porta-vozes de Deus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Houve falsos profetas no povo de Israel, e entre vós também aparecerão falsos mestres que introduzirão heresias perniciosas; negarão o Senhor que os resgatou e atrairão sobre si repentina destruição."
,"2":"Muitos seguirão as suas doutrinas dissolutas e, por causa deles, o caminho da verdade cairá em descrédito."
,"3":"Levados pelo amor ao dinheiro, procurarão, com palavras enganosas, explorar-vos. Mas o julgamento contra eles já há muito que começou, e a sua destruição não vai tardar."
,"4":"De facto, Deus não poupou os anjos que haviam pecado, mas lançou-os nos tenebrosos abismos do inferno, onde estão guardados, à espera do dia do julgamento."
,"5":"Também não poupou o mundo antigo, mas salvou Noé, o mensageiro da justiça, juntamente com outras sete pessoas, enquanto fazia cair o dilúvio sobre o mundo dos ímpios."
,"6":"E também condenou à destruição as cidades de Sodoma e Gomorra, reduzindo-as a cinzas, como exemplo do que havia de acontecer aos ímpios."
,"7":"No entanto, salvou o justo Lot, que se entristecia com o comportamento dissoluto daqueles perversos."
,"8":"Porque o justo Lot, que morava entre eles, sofria diariamente no seu coração com as obras iníquas que via e ouvia."
,"9":"Isso tudo mostra que o Senhor sabe libertar da prova aqueles que O servem, e reserva os ímpios para o castigo no dia do julgamento,"
,"10":"principalmente aqueles que seguem a carne, entregando-se a paixões imundas, e desprezam a autoridade do Senhor. Atrevidos e autosuficientes, esses homens não hesitam em blasfemar contra os seres gloriosos; "
,"11":"ao passo que os anjos, embora superiores em força e poder, não pronunciam contra eles nenhum julgamento blasfemo na presença do Senhor."
,"12":"Estes homens, porém, como animais irracionais destinados por natureza à prisão e à morte, insultam o que não conhecem e vão perecer com a mesma morte,"
,"13":"recebendo a injustiça como salário da sua injustiça. Eles sentem prazer em fazer orgias em pleno dia. Que nojo e que vergonha quando se banqueteiam convosco, divertindo-se com os seus prazeres!"
,"14":"Não podem ver mulher sem desejá-la e não se cansam de pecar. Seduzem as pessoas inseguras. O seu coração está treinado para a ambição. São uns malditos!"
,"15":"Deixaram o bom caminho e desviaram-se, seguindo o caminho de Balaão, filho de Bosor, que se deixou levar por uma recompensa injusta,"
,"16":"mas foi repreendido pela sua maldade: um animal mudo, falando com voz humana, refreou a loucura do profeta."
,"17":"Estes homens são como fontes sem água e nuvens arrastadas por vento tempestuoso; para eles está reservada a escuridão das trevas."
,"18":"Com discursos pomposos e vazios, excitam as paixões e desejos impuros dos seus ouvintes e conseguem seduzir aqueles que tinham acabado de se afastar dos que vivem no erro."
,"19":"Prometem-lhes liberdade, mas eles próprios são escravos da corrupção, pois cada um é escravo daquele que o vence."
,"20":"De facto, depois de escapar às imundícies do mundo mediante o conhecimento de nosso Senhor Jesus Cristo, se de novo são seduzidos e se deixam vencer por elas, o seu último estado torna-se pior do que o primeiro."
,"21":"Assim, melhor seria que não tivessem conhecido o caminho da justiça do que, depois de tê-lo conhecido, desviarem-se do santo mandamento que lhes fora confiado."
,"22":"Aconteceu com eles o que diz o provérbio: «O cão volta ao seu próprio vómito»; e ainda: «A porca, apenas lavada, torna a revolver-se na lama»."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Amados, esta já é a segunda carta que vos escrevo. Nas duas procurei despertar em vós, com alguns conselhos, uma sã compreensão,"
,"2":"a fim de que vos recordeis das palavras dos santos profetas de outrora e dos preceitos que o Senhor e Salvador confiou aos seus Apóstolos."
,"3":"Em primeiro lugar, sabei que nos últimos dias aparecerão pessoas que zombarão de tudo e se comportarão ao sabor dos seus próprios desejos."
,"4":"E dirão: «On-de está a promessa da sua vinda? De facto, desde que os nossos pais morreram, tudo continua como no princípio da Criação!»"
,"5":"No entanto, eles fingem não perceber que no começo existiam os céus e a terra, e que pela Palavra de Deus a terra foi tirada da água e firmada no meio da água."
,"6":"E pela mesma Palavra de Deus este mundo pereceu inundado pela água."
,"7":"Ora, os céus e a terra de agora estão reservados ao fogo pela mesma Palavra, aguardando o dia do julgamento e da destruição dos homens ímpios."
,"8":"Há, porém, uma coisa, amados, que não deveis ignorar: para o Senhor, um dia é como mil anos, e mil anos são como um dia."
,"9":"O Senhor não retarda o cumprimento da sua promessa, como alguns pensam, achando que há demora; é que Deus usa de paciência para convosco, porque não quer que ninguém se perca, mas que todos cheguem a converter-se."
,"10":"O Dia do Senhor chegará como um ladrão, e então os céus dissolver-se-ão com estrondo, os elementos derreter-se-ão, devorados pelas chamas, e a Terra e todas as obras, que nela há, desaparecerão."
,"11":"Em vista desta desintegração universal, qual não deve ser a vossa santidade de vida e piedade,"
,"12":"enquanto esperais e apressais a vinda do Dia de Deus? Nesse dia, em que ardendo em chamas, os céus se dissolverão, e os elementos se fundirão consumidos pelo fogo."
,"13":"O que nós esperamos, conforme a sua promessa, são novos céus e nova terra, onde habitará a justiça."
,"14":"Por isso, queridos irmãos, durante este tempo de espera, esforçai-vos para que Deus vos encontre sem mancha e sem culpa, vivendo em paz."
,"15":"Considerai que a paciência de Deus para connosco tem em vista a nossa salvação, conforme vos escreveu o nosso amado irmão Paulo, segundo a sabedoria que lhe foi dada."
,"16":"Em todas as suas cartas ele fala disso. É verdade que nelas há alguns pontos difíceis de entender, que os ignorantes e vacilantes distorcem, como fazem com as outras Escrituras, para a sua própria perdição."
,"17":"Assim, queridos irmãos, agora que estais avisados, tomai cuidado para que esses ímpios não vos enganem, fazendo-vos perder a firmeza e cair."
,"18":"Crescei na graça e no conhecimento de Jesus Cristo, nosso Senhor e Salvador. A Ele pertence a glória, desde agora e até ao dia da eternidade. Ámen!"
}`)

}
func PT_BS_LoadNC3IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"O Ancião ao caríssimo Gaio, a quem amo sinceramente."
,"2":"Caro amigo: desejo que prosperes em tudo e que a saúde do teu corpo esteja tão bem como a da tua alma."
,"3":"Fiquei muito contente com a chegada dos irmãos e com o testemunho que deram a respeito da tua verdade, isto é, do modo como vives na verdade."
,"4":"Para mim, não há maior alegria do que saber que os meus filhos vivem na verdade."
,"5":"Caríssimo, tu procedes fielmente em tudo o que fazes com os teus irmãos, apesar de serem estrangeiros."
,"6":"Diante da Igreja reunida, eles testemunharam o amor que tens. Farás bem provendo-os do necessário para a viagem, de modo digno de Deus."
,"7":"É pelo nome de Deus que eles se puseram a caminho, sem nada receberem dos pagãos."
,"8":"Devemos, portanto, acolher esses homens, para sermos cooperadores da Verdade."
,"9":"Escrevi algumas palavras à Igreja. Mas Diótrefes, que ambiciona dominar, não nos aceita."
,"10":"Por isso, quando eu aí for, não deixarei de reprovar o modo como ele age, pois difama-nos com palavras mal intencionadas. Não contente com isso, recusa-se a receber os irmãos e impede aqueles que desejariam fazê-lo, expulsando-os da Igreja."
,"11":"Caríssimo, não imites o mal, mas o bem. Quem faz o bem, é de Deus. Quem faz o mal, não viu a Deus."
,"12":"Quanto a Demétrio, todos dão bom testemunho dele, inclusive a própria Verdade. Nós também testemunhamos em favor dele, e tu bem sabes que o nosso testemunho é verdadeiro."
,"13":"Teria muitas coisas a escrever-te, mas não quero fazê-lo com tinta e pena."
,"14":"Espero ver-te em breve, e então conversaremos pessoalmente."
,"15":"Que a paz esteja contigo. Os amigos mandam saudações. Saúda os nossos amigos um por um."
}`)

}
func PT_BS_LoadNCIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Tiago, servo de Deus e do Senhor Jesus Cristo, às doze tribos espalhadas pelo mundo: saudações!"
,"2":"Meus irmãos, ficai em grande alegria por terdes de passar por todo o tipo de provações,"
,"3":"pois bem sabeis que aprendeis a perseverar quando a vossa fé é posta à prova."
,"4":"Mas é preciso que a perseverança complete a sua obra em vós, para que sejais homens completos e autênticos, sem nenhuma deficiência."
,"5":"Se alguém de vós tem falta de sabedoria, que a peça a Deus, e Ele lha dará, porque é generoso e dá sem impor condições."
,"6":"Todavia é preciso pedir com fé, sem duvidar, porque aquele que duvida é como a onda do mar que o vento leva de um lado para outro."
,"7":"Quem é assim, não pense que vai receber alguma coisa do Senhor,"
,"8":"pois é indeciso e instável em tudo o que faz."
,"9":"Que o irmão pobre se orgulhe da sua alta dignidade,"
,"10":"e o rico se orgulhe de perder a sua posição social, porque o rico desaparecerá como a flor da erva."
,"11":"O Sol desponta, vem o calor e seca a erva, e lá se foi a beleza do seu viço! É assim que o rico vai perecer no meio dos seus negócios!"
,"12":"Feliz o homem que suporta com paciência a provação! Porque, uma vez provado, receberá a coroa da vida, que o Senhor prometeu àqueles que O amam."
,"13":"Quando tentado, que ninguém diga: «É Deus que me tenta». Porque Deus não pode ser tentado a fazer o mal nem tenta ninguém."
,"14":"Cada um é tentado pelo seu próprio desejo, que o atrai e seduz;"
,"15":"a seguir, o desejo concebe e dá à luz o pecado, e o pecado, uma vez consumado, gera a morte."
,"16":"Não vos enganeis, meus queridos irmãos:"
,"17":"qualquer dom precioso e qualquer dádiva perfeita vêm do alto, descem do Pai das luzes, no qual não há fases ou períodos de mudança."
,"18":"Por sua própria iniciativa, gerou-nos por meio da Palavra da verdade, para que nos tornássemos as primeiras dentre as suas criaturas."
,"19":"Sabei isto, meus queridos irmãos: cada um deve ser pronto para ouvir, mas lento para falar e lento para ficar com raiva,"
,"20":"porque a raiva do homem não produz a justiça que Deus quer."
,"21":"Por isso, deixai de lado qualquer imundície e sinal de malícia, e recebei com docilidade a Palavra que vos foi plantada no coração e que pode salvar-vos."
,"22":"Sede praticantes da Palavra, e não apenas ouvintes, iludindo-vos a vós mesmos."
,"23":"Quem ouve a Palavra e não a pratica, é como alguém que observa o seu rosto num espelho;"
,"24":"observa-se a si mesmo e depois vai-se embora, esquecendo a própria aparência."
,"25":"Mas, quem se concentra numa lei perfeita, a Lei da liberdade, e nela continua firme, não como ouvinte distraído, mas praticando o que ela ordena, esse encontrará a felicidade no que faz."
,"26":"Se alguém pensa que é religioso e não sabe controlar a língua está a enganar-se a si mesmo, e a sua religião não vale nada."
,"27":"Religião pura e sem mancha diante de Deus, nosso Pai, é esta: socorrer os órfãos e as viúvas em aflição, e manter-se livre da corrupção do mundo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Queridos irmãos, não mistureis com certos favoritismos pessoais a fé que tendes em nosso Senhor Jesus Cristo, Senhor da glória."
,"2":"Por exemplo: entra na vossa assembleia uma pessoa com anéis de ouro e vestida com elegância; e entra também uma pessoa pobre, vestida com roupas velhas."
,"3":"Suponhamos que deis atenção à pessoa que está vestida com elegância, dizendo-lhe: «Sente-se aqui, neste lugar confortável»; mas dizeis à pessoa pobre: «Fica aí de pé»; ou então: «Senta-te aí no chão, perto do estrado dos meus pés»."
,"4":"Nesse caso, estais a fazer distinção entre vós mesmos e a julgar os outros com péssimos critérios."
,"5":"Ouvi, meus queridos irmãos: não foi Deus que escolheu os que são pobres aos olhos do mundo, para os tornar ricos na fé e herdeiros do Reino que Ele prometeu àqueles que O amam?"
,"6":"E, no entanto, desprezastes o pobre! Ora, não são os ricos que vos oprimem e arrastam aos tribunais?"
,"7":"Não são eles que difamam o Nome sublime que sobre vós foi invocado?"
,"8":"Se cumprirdes a lei mais importante da Escritura: «Amarás o teu próximo como a ti mesmo», procedereis bem."
,"9":"Mas, se fazeis distinção entre as pessoas, cometeis pecado, e a Lei condena-vos como culpados."
,"10":"Aquele que observa toda a Lei, mas falha num só ponto, torna-se culpado de violar a Lei inteira."
,"11":"De facto, Aquele que disse: «Não cometerás adultério», também disse: «Não matarás». Portanto, se não cometes adultério, mas matas, serás condenado como violador da Lei."
,"12":"Falai e procedei como pessoas que vão ser julgadas pela lei da liberdade,"
,"13":"porque o julgamento será sem misericórdia para quem não tiver agido com misericórdia. Os misericordiosos não têm motivo de temer o julgamento."
,"14":"Meus irmãos, se alguém diz que tem fé, mas não tem obras, que adianta isso? Será que a fé poderá salvá-lo?"
,"15":"Por exem-plo: um irmão ou irmã não têm que vestir e falta-lhes o pão de cada dia."
,"16":"Então, se algum de vós lhes disser: «Ide em paz, aquecei-vos e comei bastante» e, no entan-to, não lhes dá o necessário para o corpo, que adianta isso?"
,"17":"Assim também é a fé: sem as obras, está completamente morta."
,"18":"Alguém poderia dizer ainda: «Tu tens a fé, e eu tenho as obras. Pois bem! Mostra-me a tua fé sem as obras, e eu, com as minhas obras, te mostrarei a minha fé»."
,"19":"Tu acreditas que existe um só Deus? Muito bem! Só que os demónios também acreditam, e tremem!"
,"20":"Insensato, queres ver como a fé sem as obras não tem valor?"
,"21":"Quando o nosso pai Abraão ofereceu o filho Isaac sobre o altar, não foi pelas obras que ele se tornou justo?"
,"22":"Repara que a fé cooperou com as suas obras, e que pelas obras essa fé se tornou perfeita."
,"23":"E assim se cumpriu a Escritura que diz: «Abraão acreditou em Deus, e isso foi-lhe creditado como justiça». E Abraão foi chamado amigo de Deus."
,"24":"Como vedes, o homem é justificado pelas obras, e não somente pela fé."
,"25":"Do mesmo modo, a prostituta Raab: ao dar hospitalidade aos mensageiros e ao fazê-los voltar por outro caminho, não foi ela justificada pelas suas obras?"
,"26":"De facto, do mesmo modo que o corpo sem o espírito é cadáver, assim também a fé: sem as obras é cadáver."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Meus irmãos, não vos arvoreis em mestres. Vós bem sabeis que seremos julgados com maior severidade,"
,"2":"pois todos nós estamos sujeitos a muitos erros. Aquele que não peca no falar é homem perfeito, capaz de pôr freio ao corpo todo."
,"3":"Quando colocamos o freio na boca dos cavalos para que nos obedeçam, dirigimos todo o seu corpo."
,"4":"Vede também os navios: são tão grandes e empurrados por fortes ventos! Entretanto, por um pequenino leme são conduzidos para onde o piloto quer levá-los."
,"5":"A mesma coisa acontece com a língua: é um pequeno membro e, no entanto, gaba-se de grandes coisas. Vede como uma faúlha pode incendiar uma grande floresta! "
,"6":"A língua é como um fogo, um mundo de maldade. A língua, colocada entre os nossos membros, contamina o corpo inteiro, e acendida na geena, incendeia o curso da nossa vida, tirando a sua chama da geena."
,"7":"Todas as espécies de animais ou de aves, de répteis ou de seres marinhos são e foram domadas pela raça humana;"
,"8":"mas nenhum homem consegue domar a língua. Ela não tem freio e está cheia de veneno mortal."
,"9":"Com ela bendizemos o Senhor e Pai, e com ela amaldiçoamos os homens, feitos à semelhança de Deus."
,"10":"Da mesma boca sai bênção e maldição. Meus irmãos, isto não pode acontecer!"
,"11":"Acaso, a fonte pode fazer jorrar da mesma bica água doce e água salobra?"
,"12":"Porventura, meus irmãos, pode a figueira dar azeitonas, ou a videira dar figos? Assim também uma fonte de água salgada não pode dar água doce."
,"13":"Quem é sábio e inteligente entre vós? Pois então, mostre com a boa conduta que as suas acções são de uma sabedoria humilde."
,"14":"Mas, se tendes no coração ciúme amargo e espírito de rivalidade, não vos gabeis nem mintais contra a verdade."
,"15":"Esse tipo de sabedoria não vem do alto; é sabedoria terrena, animal, demoníaca."
,"16":"De facto, onde há ciúme e espírito de rivalidade, existe também desordem e todo o género de más acções."
,"17":"Ao contrário, a sabedoria que vem do alto é, antes de tudo, pura, pacífica, humilde, compreensiva, cheia de misericórdia e bons frutos, sem discriminações e sem hipocrisia."
,"18":"Na verdade, o fruto da justiça é semeado na paz por aqueles que trabalham pela paz."
}`)
	CurrentBook.AddChapter(4, `{
"1":"De onde surgem os conflitos e competições que existem entre vós? Não vêm precisamente dos prazeres que combatem nos vossos membros?"
,"2":"Cobiçais e nada tendes; então matais. Tendes inveja, e não conseguis nada; então lutais e fazeis guerra. Não recebeis, porque não pedis;"
,"3":"e pedis, mas não recebeis, porque pedis mal, com intenção de gastar nos vossos prazeres."
,"4":"Idólatras! Não sabeis que a amizade com o mundo é inimizade com Deus? Quem quer ser amigo do mundo é inimigo de Deus."
,"5":"Ou achais que é à toa que a Escritura diz: «Deus reclama com ciúme o espírito que Ele fez habitar em nós»?"
,"6":"Mas Ele dá uma graça maior. É por isso que a Escritura diz: «Deus resiste aos soberbos, e aos humildes dá a sua graça»."
,"7":"Portanto, sede submissos a Deus; resisti ao diabo, e ele fugirá de vós."
,"8":"Aproximai-vos de Deus, e Ele Se aproximará de vós. Pecadores, purificai as mãos! Indecisos, purificai o coração!"
,"9":"Reconhecei a própria miséria, cobri-vos de luto e chorai! Que o vosso riso se transforme em luto, e a alegria em tristeza!"
,"10":"Humilhai-vos diante do Senhor, e Ele vos elevará."
,"11":"Irmãos, não faleis mal uns dos outros! Quem critica o irmão ou julga o seu irmão, critica a lei e julga a lei. Ora, se tu julgas a lei, já não és alguém que obedece à lei, mas alguém que a julga."
,"12":"Ora, só um é o legislador e juiz: Aquele que pode salvar e destruir. Quem és tu para julgares o teu próximo?"
,"13":"Agora vamos aos que dizem: «Hoje ou amanhã iremos a tal cidade, passaremos lá um ano, negociaremos e ganharemos dinheiro»."
,"14":"E, no entanto, nem sabem o que vai acontecer amanhã! O que é a vossa vida? Uma neblina que aparece por um instante e depois desaparece!"
,"15":"Deveríeis dizer: «Se o Senhor quiser, viveremos e faremos isto ou aquilo»."
,"16":"Em vez disso, gloriais-vos da vossa arrogância. Todo o orgulho desse género é mau."
,"17":"Portanto, quem sabe como fazer o bem e não o faz, comete pecado."
}`)
	CurrentBook.AddChapter(5, `{
"1":"E agora vós, ó ricos: chorai em altos gritos por causa das desgraças que estão para cair sobre vós."
,"2":"As vossas riquezas estão podres e as vossas roupas foram roídas pela traça;"
,"3":"o vosso ouro e a vossa prata estão enferrujados; e a sua ferrugem será testemunha contra vós, e devorará a vossa carne como o fogo. Amontoastes tesouros para o fim dos tempos."
,"4":"Vede o salário dos trabalhadores que fizeram a colheita nos vossos campos; retido por vós, esse salário clama, e os protestos dos ceifeiros chegaram aos ouvidos do Senhor dos exércitos."
,"5":"Tivestes na Terra uma vida de conforto e luxo; estais a ficar gordos para o dia da matança!"
,"6":"Condenastes o justo, e ele não conseguiu defender-se."
,"7":"Irmãos, sede pacientes até à vinda do Senhor. Vede como o agricultor espera pacientemente o fruto precioso da terra, até receber a chuva do Outono e da Primavera."
,"8":"Tende também vós paciência; fortalecei os corações, pois a vinda do Senhor está próxima."
,"9":"Irmãos, não vos queixeis uns dos outros, para não serdes julgados. Eis que o juiz está à porta."
,"10":"Irmãos, tomai como exemplo de sofrimento e paciência os profetas que falaram em nome do Senhor."
,"11":"Nós consideramos felizes os que foram perseverantes. Ouvistes falar da constância de Job e conhecestes o fim que o Senhor lhe reservou, porque o Senhor é rico em compaixão e misericórdia."
,"12":"Sobretudo, irmãos, não jureis: nem pelo Céu, nem pela Terra, nem por qualquer outra coisa; que o vosso «sim» seja sim, e que o vosso «não» seja não, para não incorrerdes em julgamento."
,"13":"Alguém de vós está a sofrer? Reze. Está alegre? Cante."
,"14":"Alguém de vós está doente? Mande chamar os presbíteros da Igreja para que rezem por ele, ungindo-o com óleo, em nome do Senhor."
,"15":"A oração feita com fé salvará o doente: o Senhor o levantará, e, se tiver pecados, será perdoado."
,"16":"Confessai uns aos outros os vossos pecados e rezai uns pelos outros, para serdes curados. A oração do justo, feita com insistência, tem muita força."
,"17":"Elias era homem fraco como nós. No entanto, rezou bastante para que não chovesse, e não choveu sobre a terra durante três anos e meio."
,"18":"Depois rezou de novo, e o céu mandou chuva, e a terra produziu o seu fruto."
,"19":"Meus irmãos, se alguém de vós se afastar da verdade e alguém o converter,"
,"20":"fique a saber que a pessoa que reconduz um pecador do caminho errado, se salvará a si mesma da morte e apagará uma multidão de pecados."
}`)

}
func PT_BS_LoadNCIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Judas, servo de Jesus Cristo, irmão de Tiago, aos eleitos que são amados por Deus Pai e guardados por Jesus Cristo."
,"2":"Que a misericórdia, a paz e o amor vos sejam concedidos em abundância."
,"3":"Amados, tendo um grande desejo de vos escrever a respeito da nossa salvação comum, fui obrigado a fazê-lo, a fim de vos encorajar a lutar pela fé que foi transmitida aos fiéis de uma vez por todas."
,"4":"De facto, infiltraram-se no meio de vós alguns indivíduos ímpios que, desde há muito, estão condenados. Eles convertem em libertinagem a graça do nosso Deus e negam Jesus Cristo, o nosso único soberano e Senhor."
,"5":"Embora já conheçais definitivamente todas estas coisas, quero lembrar-vos que o Senhor, depois de ter salvo o povo da terra do Egipto, destruiu em seguida aqueles que não queriam acreditar."
,"6":"Quero lembrar-vos também que os anjos que não conservaram a sua dignidade, mas abandonaram a própria moradia, o Senhor os mantém presos eternamente nas trevas, para o julgamento do grande Dia."
,"7":"De igual modo, Sodoma e Gomorra e as cidades vizinhas, que igualmente se entregaram à libertinagem e correram atrás de vícios contra a natureza; elas servem de exemplo, sofrendo as penas de um fogo eterno."
,"8":"O mesmo acontece com esses indivíduos: levados pelos seus devaneios, contaminam o próprio corpo, desprezando o senhorio de Cristo e insultando os seres gloriosos."
,"9":"Na luta com o diabo para disputar o corpo de Moisés, o arcanjo Miguel não teve a ousadia de o acusar com palavras ofensivas; apenas disse: «Que o Senhor te castigue»!"
,"10":"Esses indivíduos, porém, dizem blasfémias contra tudo o que não conhecem; e o que conhecem instintivamente, à maneira de animais, é que os conduz à ruína."
,"11":"Ai deles, porque enveredaram pelo caminho de Caim; por causa do lucro entregaram-se às aberrações de Balaão e foram destruídos na rebelião de Coré."
,"12":"São eles que participam descaradamente nas vossas refeições fraternas, apascentando-se a si mesmos com irreverência. São como nuvens sem água, levadas pelo vento, ou como árvores no fim do Outono que não dão fruto, duas vezes mortas e arrancadas pela raiz."
,"13":"São como as alterosas ondas do mar, que espumam a própria indecência. São como astros errantes, para os quais está reservada a escuridão das trevas eternas."
,"14":"Também Henoc, o sétimo depois de Adão, profetizou acerca desses indivíduos, quando disse: «Eis que o Senhor veio com os seus exércitos de an-jos"
,"15":"para fazer o julgamento universal e convencer todos os ímpios de todas as suas impiedades criminosas e de todas as palavras insolentes que os pecadores ímpios proferiram contra Ele»."
,"16":"São uns murmuradores que renegam a própria sorte e agem de acordo com as suas paixões; a sua boca profere palavras orgulhosas e por interesse adulam as pessoas."
,"17":"Vós, porém, amados, lembrai-vos das coisas que foram ditas anteriormente pelos Apóstolos de nosso Senhor Jesus Cristo."
,"18":"Eles diziam-vos: «No fim dos tempos aparecerão impostores que se comportarão conforme as suas paixões»."
,"19":"São esses indivíduos! Eles causam divisões, são homens sensuais que não possuem o Espírito."
,"20":"Vós, porém, amados, edificai sobre o alicerce da vossa santíssima fé; rezai movidos pelo Espírito Santo;"
,"21":"mantende-vos no amor de Deus, esperando que a misericórdia de nosso Senhor Jesus Cristo vos dê a vida eterna."
,"22":"Procurai convencer os hesitantes:"
,"23":"salvai uns, arrancando-os do fogo; tende compaixão dos outros, mas com temor. Detestai até as vestes contaminadas pelos instintos egoístas dos ímpios."
,"24":"Àquele que pode preservar-vos de qualquer falta e pode fazer que compareçais sem defeitos e na alegria diante da sua glória,"
,"25":"ao Deus único, nosso Salvador, por meio de nosso Senhor Jesus Cristo, seja dada a glória e a majestade, a força e o poder, desde o princípio dos tempos, agora e para sempre. Ámen!"
}`)

}
func PT_BS_LoadNEIOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No começo a Palavra já existia: a Palavra estava voltada para Deus,e a Palavra era Deus."
,"2":"No começo Ela estava voltada,para Deus."
,"3":"Tudo foi feito por meio d'Ela, e, de tudo o que existe, nada foi feito sem Ela."
,"4":"N'Ela estava a Vida, e a Vida era a luz dos homens."
,"5":"Essa luz brilha nas trevas, e as trevas não conseguiram apagá-la."
,"6":"Apareceu um homem enviado por Deus, que se chamava João."
,"7":"Ele veio como testemunha, para dar testemunho da luz, a fim de que todos acreditassem por meio dele."
,"8":"Ele não era a luz, mas apenas a testemunha da luz."
,"9":"A luz verdadeira, aquela que ilumina todo o homem, estava a chegar ao mundo."
,"10":"A Palavra estava no mundo, o mundo foi feito por meio d'Ela, mas o mundo não A conheceu."
,"11":"Ela veio para a sua casa, mas os seus não A receberam."
,"12":"Ela, porém, deu o poder,de se tornarem filhos de Deus,a todos aqueles que A receberam, isto é, àqueles que acreditam,no seu Nome."
,"13":"Estes não nasceram do sangue, nem do impulso da carne, nem do desejo do homem, mas nasceram de Deus."
,"14":"E a Palavra fez-Se Homem,e habitou entre nós. E nós contemplámos a sua glória: glória do Filho único do Pai,cheio de amor e fidelidade."
,"15":"João dava testemunho d'Ele, proclamando: «Este é Aquele a respeito de quem eu disse: Aquele Homem que vem depois de Mim passou à minha frente, porque existia antes de Mim»."
,"16":"Porque da sua plenitude,todos nós recebemos, e um amor que corresponde,ao seu amor."
,"17":"Porque a Lei foi dada por Moisés, o amor e a fidelidade vieram através de Jesus Cristo."
,"18":"Ninguém jamais viu a Deus; quem nos revelou Deus foi o Filho único que está junto do Pai."
,"19":"O testemunho de João foi assim: as autoridades dos judeus enviaram de Jerusalém sacerdotes e levitas para perguntarem a João: «Quem és tu?»"
,"20":"João confessou e não negou. Ele confessou: «Eu não sou o Messias»."
,"21":"Eles perguntaram: «Então, quem és tu? És Elias?» João disse: «Não sou». Eles perguntaram: «És o Profeta?» Ele respondeu: «Não»."
,"22":"Então perguntaram: «Quem és tu? Temos que levar uma resposta àqueles que nos enviaram. Que dizes de ti mesmo?»"
,"23":"João declarou: «Eu sou uma voz que grita no deserto: 'Aplanai o caminho do Senhor', como disse o profeta Isaías»."
,"24":"Os que tinham sido enviados eram da parte dos fariseus."
,"25":"Eles continuaram a perguntar: «Então, porque é que baptizas, se não és o Messias, nem Elias, nem o Profeta?»"
,"26":"João respondeu: «Eu baptizo com água, mas no meio de vós está Alguém que vós não conheceis"
,"27":"e que vem depois de Mim. Eu não mereço nem sequer desatar-Lhe a correia das sandálias»."
,"28":"Isto aconteceu em Betânia, na outra margem do Jordão, onde João estava a baptizar."
,"29":"No dia seguinte, João viu Jesu que Se aproximava dele. E disse: «Eis o Cordeiro de Deus, Aquele que tira o pecado do mundo."
,"30":"Este é Aquele de quem eu disse: 'Depois de Mim vem um Homem que passou à minha frente, porque existia antes de Mim'."
,"31":"Eu também não O conhecia. Mas vim baptizar com água, a fim de que Ele Se manifeste a Israel»."
,"32":"E João testemunhou: «Eu vi o Espírito descer do céu, como uma pomba, e pousar sobre Ele."
,"33":"Eu também não O conhecia. Aquele que me enviou para baptizar com água foi Ele que me disse: 'Aquele sobre quem vires o Espírito descer e pousar, Esse é quem baptiza com o Espírito Santo'."
,"34":"E eu vi e dou testemunho de que Ele é o Filho de Deus»."
,"35":"No dia seguinte, João estava lá de novo, com dois discípulos."
,"36":"Vendo Jesus que passava, apontou: «Eis o Cordeiro de Deus»."
,"37":"Ouvindo estas palavras, os dois discípulos seguiram Jesus."
,"38":"Jesus virou-Se e, vendo que O seguiam, perguntou: «Que procurais?» Eles disseram: «Rabi (que quer dizer Mestre), onde moras?»"
,"39":"Jesus respondeu: «Vinde ver». Então eles foram e viram onde Jesus morava. E começaram a viver com Ele naquele mesmo dia. Eram mais ou menos quatro horas da tarde."
,"40":"André, irmão de Simão Pedro, era um dos dois que ouviram as palavras de João e seguiram Jesus."
,"41":"Ele encontrou primeiro o seu irmão Simão e disse-lhe: «Encontrámos o Messias (que quer dizer Cristo)»."
,"42":"Então André apresentou Simão a Jesus. Jesus olhou bem para Simão e disse: «Tu és Simão, filho de João. Vais chamar-te Cefas (que quer dizer Pedra)»."
,"43":"No dia seguinte, Jesus decidiu partir para a Galileia. Encontrou Filipe e disse: «Segue-Me»."
,"44":"Filipe era de Betsaida, cidade de André e Pedro."
,"45":"Filipe encontrou-se com Natanael e disse: «Encontrámos Aquele de quem Moisés escreveu na Lei e também os profetas: é Jesus de Nazaré, filho de José»."
,"46":"Natanael disse: «De Nazaré pode sair coisa boa?» Filipe respondeu: «Vem e verás»."
,"47":"Jesus viu Natanael aproximar-se e comentou: «Eis um israelita verdadeiro, sem falsidade»."
,"48":"Natanael perguntou: «De onde me conheces?» Jesus respondeu: «Antes que Filipe te chamasse, Eu vi-te quando estavas debaixo da figueira»."
,"49":"Natanael respondeu: «Rabi, Tu és o Filho de Deus, Tu és o rei de Israel!»"
,"50":"Disse-lhe Jesus: «Acreditas só porque te disse: 'Vi-te debaixo da figueira'? No entanto, verás coisas maiores do que estas»."
,"51":"E Jesus continuou: «Eu vos garanto: vereis o céu aberto e os anjos de Deus subindo e descendo sobre o Filho do Homem»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"No terceiro dia, houve um casamento em Caná da Galileia e a Mãe de Jesus estava presente."
,"2":"Jesus também tinha sido convidado para esse casamento com os seus discípulos."
,"3":"Faltou o vinho e a Mãe de Jesus disse-Lhe: «Eles já não têm vinho!»"
,"4":"Jesus respondeu: «Mulher, que existe entre nós? A minha hora ainda não chegou»."
,"5":"A Mãe de Jesus disse aos servidores: «Fazei o que Ele mandar»."
,"6":"Havia ali seis talhas de pedra de uns cem litros cada uma, que serviam para os ritos de purificação dos judeus."
,"7":"Jesus disse aos servidores: «Enchei de água essas talhas». Eles encheram as talhas até cima."
,"8":"Depois Jesus disse: «Agora tirai e levai ao chefe de mesa». Então levaram ao chefe de mesa."
,"9":"Este provou a água transformada em vinho, sem saber de onde vinha. Os que serviam sabiam, pois foram eles que tiraram a água. Então o chefe de mesa chamou o noivo"
,"10":"e disse: «Todos servem primeiro o vinho bom e, quando os convidados estão bêbedos, servem o pior. Tu, porém, guardaste o vinho bom até agora»."
,"11":"Foi assim que, em Caná da Galileia, Jesus começou os seus sinais. Ele manifestou a sua glória e os seus discípulos acreditaram n'Ele."
,"12":"Depois disso, Jesus desceu para Cafarnaum com sua Mãe, seus irmãos e seus discípulos. E ficaram ali apenas alguns dias."
,"13":"A Páscoa dos judeus estava próxima, e Jesus subiu a Jerusalém."
,"14":"No Templo, Jesus encontrou os vendedores de bois, ovelhas e pombas, e os cambistas sentados."
,"15":"Então fez um chicote de cordas e expulsou-os a todos do Templo juntamente com as ovelhas e os bois; espalhou as moedas e derrubou as mesas dos cambistas."
,"16":"E disse aos que vendiam pombas: «Tirai tudo isto daqui! Não transformeis a casa de meu Pai num mercado»."
,"17":"Os seus discípulos lembraram-se do que diz a Escritura: «O zelo pela tua casa me consome»."
,"18":"Então os dirigentes dos judeus perguntaram a Jesus: «Que sinal nos mostras que justifique este teu procedimento?»"
,"19":"Jesus respondeu: «Destruí este Templo e em três dias Eu o levantarei»."
,"20":"Os dirigentes dos judeus disseram: «A construção deste Templo demorou quarenta e seis anos, e Tu levantá-lo-ás em três dias?»"
,"21":"Mas o Templo de que Jesus falava era o seu corpo."
,"22":"Quando Ele ressuscitou, os discípulos lembraram-se do que Jesus tinha dito e acreditaram na Escritura e na palavra de Jesus."
,"23":"Jesus estava em Jerusalém durante a festa da Páscoa. Vendo os sinais que Ele fazia, muitos acreditaram no seu nome."
,"24":"Mas Jesus não confiava neles, pois conhecia-os a todos."
,"25":"Ele não precisava de informações a respeito de ninguém, porque conhecia o homem por dentro."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Entre os fariseus havia um homem chamado Nicodemos. Era um judeu importante."
,"2":"Ele foi encontrar-se de noite com Jesus, e disse: «Rabi, sabemos que és um Mestre vindo da parte de Deus. Realmente, ninguém pode realizar os sinais que Tu fazes, se Deus não está com ele»."
,"3":"Jesus respondeu: «Garanto-te: se alguém não nascer de novo, não poderá ver o Reino de Deus»."
,"4":"Nicodemos disse: «Como é que um homem pode nascer de novo, se já é velho? Poderá entrar outra vez no ventre de sua mãe e renascer?»"
,"5":"Jesus respondeu: «Eu te garanto: ninguém pode entrar no Reino de Deus se não nasce da água e do Espírito."
,"6":"Quem nasce da carne é carne, quem nasce do Espírito é espírito."
,"7":"Não te admires de Eu dizer que é preciso nascerdes de novo."
,"8":"O vento sopra onde quer, ouves o barulho, mas não sabes de onde vem nem para onde vai. Acontece a mesma coisa com quem nasceu do Espírito»."
,"9":"Nicodemos perguntou: «Como é que isso pode acontecer?»"
,"10":"Jesus respondeu: «Tu és mestre em Israel e não sabes estas coisas?"
,"11":"Garanto-te: nós falamos do que sabemos e damos testemunho daquilo que vimos, mas, apesar disso, vós não aceitais o nosso testemunho."
,"12":"Se não acreditais quando falo sobre as coisas da Terra, como podereis acreditar quando vos falar das coisas do Céu?"
,"13":"Ninguém subiu ao Céu, a não ser Aquele que desceu do Céu: o Filho do Homem."
,"14":"Assim como Moisés levantou a serpente no deserto, do mesmo modo é preciso que o Filho do Homem seja levantado."
,"15":"Assim, todo aquele que n'Ele acreditar, n'Ele terá a vida eterna»."
,"16":"«Pois Deus amou de tal forma o mundo que entregou o seu Filho único, para que todo o que n'Ele acredita não morra, mas tenha a vida eterna."
,"17":"De facto, Deus enviou o seu Filho ao mundo, não para condenar o mundo, mas para que o mundo seja salvo por meio d'Ele."
,"18":"Quem acredita n'Ele não está condenado; quem não acredita já está condenado, porque não acreditou no Nome do Filho único de Deus."
,"19":"O julgamento é este: a luz veio ao mundo, mas os homens preferiram as trevas à luz, porque as suas acções eram más."
,"20":"Quem pratica o mal odeia a luz e não se aproxima da luz, para que as suas acções não sejam desmascaradas."
,"21":"Mas, quem age conforme a verdade aproxima-se da luz, para que as suas acções sejam vistas, porque são feitas como Deus quer»."
,"22":"Depois disto, Jesus foi para a região da Judeia com os seus discípulos. Ficou ali com eles e baptizava."
,"23":"João também estava a baptizar em Enon, perto de Salim, onde havia bastante água. As pessoas iam e eram baptizadas."
,"24":"João ainda não tinha sido preso."
,"25":"Então começou uma discussão entre os discípulos de João e um judeu sobre a purificação."
,"26":"Eles foram ter com João e disseram: «Rabi, Aquele que estava contigo na outra margem do Jordão e de quem deste testemunho, agora está a baptizar e todos vão ter com Ele!»."
,"27":"E João respondeu: «Ninguém pode receber alguma coisa se esta não lhe for dada do Céu."
,"28":"Vós mesmos sois testemunhas daquilo que eu disse: 'Eu não sou o Messias, mas fui enviado à frente d'Ele'."
,"29":"É o noivo que recebe a noiva, e o amigo, que espera, enche-se de alegria quando ouve a voz do noivo. Esta é a minha alegria e é muito grande."
,"30":"É preciso que Ele cresça e eu diminua»."
,"31":"«Aquele que vem do alto está acima de todos. Quem é da Terra, pertence à Terra e fala como terrestre. Aquele que vem do Céu,"
,"32":"dá testemunho daquilo que viu e ouviu, mas ninguém aceita o seu testemunho."
,"33":"E quem aceita o seu testemunho comprova que Deus é verdadeiro."
,"34":"De facto, Aquele que Deus enviou refere as palavras de Deus, porque Deus Lhe dá o Espírito sem medida."
,"35":"O Pai ama o Filho, e entregou tudo nas suas mãos."
,"36":"Aquele que acredita no Filho possui a vida eterna. Quem rejeita o Filho nunca verá a vida, pois a ira de Deus permanece sobre ele»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Os fariseus vieram a saber que Jesus atraía discípulos e baptizava mais do que João."
,"2":"(Na verdade, não era Jesus que baptizava, mas os seus discípulos)."
,"3":"Ao saber disto, Jesus deixou a Judeia e foi de novo para a Galileia."
,"4":"Jesus tinha que atravessar a Samaria."
,"5":"Chegou, então, a uma cidade da Samaria chamada Sicar, perto do campo que Jacob tinha dado a seu filho José."
,"6":"Estava ali o poço de Jacob. Cansado da viagem, Jesus sentou-Se junto do poço. Era quase meio-dia."
,"7":"Então chegou uma mulher da Samaria para tirar água. Jesus pediu-lhe: «Dá-Me de beber»."
,"8":"(Os discípulos tinham ido à cidade para comprar mantimentos)."
,"9":"A samaritana perguntou: «Como é que Tu, sendo judeu, me pedes de beber a mim que sou samaritana?» (De facto, os judeus não se dão bem com os samaritanos)."
,"10":"Jesus respondeu: «Se conhecesses o dom de Deus e quem te pede de beber, tu é que Lhe pedirias. E Ele dar-te-ia água viva»."
,"11":"A mulher disse a Jesus: «Senhor, não tens um balde e o poço é fundo. De onde vais tirar a água viva?"
,"12":"Certamente não pretendes ser maior do que o nosso pai Jacob, que nos deu este poço, do qual ele bebeu com seus filhos e animais!»"
,"13":"Jesus respondeu: «Quem bebe desta água volta a ter sede."
,"14":"Mas aquele que beber a água que Eu vou dar, nunca mais terá sede. E a água que Eu lhe darei vai tornar-se dentro dele uma fonte de água que jorra para a vida eterna»."
,"15":"A mulher disse a Jesus: «Senhor, dá-me dessa água, para que nunca mais tenha sede nem precise vir aqui tirá-la»."
,"16":"Jesus disse à samaritana: «Vai chamar o teu marido e volta aqui»."
,"17":"A mulher respondeu: «Não tenho marido». Jesus disse: «Tens razão em dizer que não tens marido."
,"18":"De facto, tiveste cinco maridos. E o homem que agora tens não é teu marido. Nisso disseste a verdade»."
,"19":"A mulher então disse a Jesus: «Senhor, vejo que és um profeta!"
,"20":"Os nossos pais adoraram a Deus nesta montanha. E vós judeus dizeis que é em Jerusalém o lugar onde se deve adorar»."
,"21":"Jesus disse: «Mulher, acredita em Mim. Vai chegar a hora, em que não adorareis o Pai, nem sobre esta montanha e nem em Jerusalém."
,"22":"Vós adorais O que não conheceis, nós adoramos O que conhecemos, porque a salvação vem dos judeus."
,"23":"Mas vai chegar a hora, e é agora, em que os verdadeiros adoradores vão adorar o Pai em espírito e verdade. Porque são estes os adoradores que o Pai procura."
,"24":"Deus é espírito, e aqueles que O adoram devem adorá-l'O em espírito e verdade»."
,"25":"A mulher disse a Jesus: «Eu sei que vai chegar um Messias (Aquele que Se chama Cristo); e, quando chegar, Ele mostrar-nos-á todas as coisas»."
,"26":"Jesus disse: «Esse Messias sou Eu, que estou a falar contigo»."
,"27":"Nesse momento, os discípulos de Jesus chegaram. E ficaram admirados de ver Jesus a falar com uma mulher, mas ninguém Lhe perguntou o que Ele queria, ou por que razão estava a falar com a mulher."
,"28":"Então a mulher deixou o balde, foi à cidade e disse às pessoas:"
,"29":"«Vinde ver um homem que me disse tudo o que eu fiz. Não será Ele o Messias?»"
,"30":"Eles saíram da cidade e foram ao encontro de Jesus."
,"31":"Entretanto, os discípulos insistiam com Jesus, dizendo: «Mestre, come alguma coisa»."
,"32":"Jesus disse: «Eu tenho para comer um alimento que vós não conheceis»."
,"33":"Os discípulos comentavam: «Será que alguém trouxe alguma coisa para Ele comer?»"
,"34":"Jesus disse: «O meu alimento é fazer a vontade d'Aquele que Me enviou e realizar a sua obra."
,"35":"Vós não dizeis que faltam quatro meses para a colheita? Pois Eu digo-vos: erguei os olhos e olhai os campos: já estão dourados para a colheita."
,"36":"Aquele que colhe, recebe desde já o salário, e recolhe fruto para a vida eterna; deste modo, aquele que semeia alegra-se com aquele que colhe."
,"37":"Na verdade é como diz o provérbio: 'Um semeia e outro colhe'."
,"38":"Eu enviei-vos para colher aquilo que vós não trabalhastes. Outros trabalharam e vós aproveitastes-vos do seu trabalho»."
,"39":"Muitos samaritanos daquela cidade acreditaram em Jesus, por causa do testemunho que a mulher tinha dado: «Ele disse-me tudo o que eu fiz»."
,"40":"Os samaritanos então foram ao encontro de Jesus e pediram-Lhe que ficasse com eles. E Jesus ficou lá dois dias."
,"41":"Muitas outras pessoas acreditaram em Jesus ao ouvir a sua palavra."
,"42":"E diziam à mulher: «Já não acreditamos por causa daquilo que disseste. Agora, nós mesmos ouvimos e sabemos que Este é, de facto, o Salvador do mundo»."
,"43":"Dois dias depois, Jesus foi para a Galileia."
,"44":"Mas o próprio Jesus tinha declarado: «Um profeta nunca é bem recebido na sua terra»."
,"45":"Entretanto, quando Ele chegou à Galileia, os galileus receberam-n'O bem, porque tinham visto tudo o que Jesus havia feito em Jerusalém durante a festa. Pois também eles tinham ido à festa."
,"46":"Jesus voltou para Caná da Galileia, onde havia transformado a água em vinho. Ora, em Cafarnaum havia um funcionário do rei que tinha um filho doente."
,"47":"Ele ouviu dizer que Jesus tinha ido da Judeia para a Galileia. Saiu ao encontro de Jesus e pediu-Lhe que fosse a Cafarnaum curar o seu filho que estava a morrer."
,"48":"Jesus disse-lhe: «Se não vedes sinais e prodígios não acreditais»."
,"49":"O funcionário do rei disse: «Senhor, desce, antes que o meu filho morra!»"
,"50":"Jesus disse-lhe: «Podes ir, que o teu filho está vivo». O homem acreditou na palavra de Jesus e foi-se embora."
,"51":"Enquanto descia para Cafarnaum os seus empregados vieram-lhe ao encontro e disseram-lhe: «O teu filho está vivo»."
,"52":"O funcionário perguntou a que horas o menino tinha melhorado. Eles responderam: «A febre desapareceu ontem pela uma hora da tarde»."
,"53":"O pai percebeu que tinha sido exactamente nessa hora que Jesus lhe havia dito: «O teu filho está vivo». Então acreditou, juntamente com toda a sua família."
,"54":"Este foi o segundo sinal de Jesus. Foi realizado quando voltou da Judeia para a Galileia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Depois disto, houve uma festa judaica, e Jesus foi a Jerusalém."
,"2":"Em Jerusalém, junto da porta das Ovelhas, existe uma piscina rodeada por cinco corredores cobertos. Em hebraico, a piscina chama-se Betesda."
,"3":"Muitos doentes ficavam ali deitados: eram cegos, coxos e paralíticos, à espera que a água se movesse ("
,"4":"porque um anjo do Senhor descia de vez em quando e agitava a água da piscina. O primeiro doente que entrasse na piscina, depois de a água ser agitada, ficava curado de qualquer doença que tivesse)."
,"5":"Encontrava-se lá um homem que estava doente havia trinta e oito anos."
,"6":"Jesus viu o homem deitado e soube que estava doente há tanto tempo. Então perguntou-lhe: «Queres ficar curado?»"
,"7":"O doente respondeu: «Senhor, não tenho ninguém que me lance na piscina quando a água começa a agitar-se. Quando lá chego, já outro entrou na minha frente»."
,"8":"Jesus disse: «Levanta-te, toma a tua cama e anda»."
,"9":"No mesmo instante, o homem ficou curado, tomou a sua cama e começou a andar. Era um dia de sábado. "
,"10":"Por isso, as autoridades dos judeus disseram ao homem que tinha sido curado: «Hoje é dia de sábado. A lei não permite que leves a cama»."
,"11":"Ele respondeu: «O homem que me curou disse: 'Toma a tua cama e anda'»."
,"12":"Então os dirigentes dos judeus perguntaram-lhe: «Quem foi que te disse para tomares a cama e andar?»"
,"13":"O homem que tinha sido curado não sabia quem era, porque Jesus tinha desaparecido no meio das pessoas que estavam reunidas naquele lugar."
,"14":"Mais tarde, Jesus encontrou aquele homem no Templo e disse-lhe: «Ficaste curado. Não peques de novo, para que não te aconteça alguma coisa pior»."
,"15":"O homem saiu e disse às autoridades dos judeus que tinha sido Jesus quem o havia curado."
,"16":"Então as autoridades dos judeus começaram a perseguir Jesus, porque Ele havia curado em dia de sábado."
,"17":"Jesus então disse-lhes: «Meu Pai trabalha continuamente e Eu também trabalho»."
,"18":"Por isso, as autoridades dos judeus tinham mais vontade ainda de matar Jesus, porque, além de violar a lei do sábado, chegava até a dizer que Deus era seu Pai, fazendo-Se assim igual a Deus."
,"19":"Então Jesus disse às autoridades dos judeus: «Eu vos garanto: o Filho não pode fazer nada por sua própria conta; Ele faz apenas o que vê fazer ao Pai. O que o Pai faz, o Filho também o faz."
,"20":"O Pai ama o Filho e mostra-Lhe tudo o que Ele mesmo faz. E mostrar-Lhe-á obras ainda maiores, que vos deixarão admirados."
,"21":"Assim como o Pai ressuscita os mortos e lhes dá a vida, o Filho também dá a vida a quem Ele a quer dar."
,"22":"O Pai não julga ninguém. Ele deu ao Filho todo o poder de julgar,"
,"23":"para que todos honrem o Filho da mesma forma que honram o Pai. Quem não honra o Filho também não honra o Pai que O enviou."
,"24":"Eu vos garanto: quem ouve a minha palavra e acredita n'Aquele que Me enviou, possui a vida eterna. Não será condenado, porque já passou da morte para a vida."
,"25":"Eu vos garanto: vai chegar, ou melhor, já chegou a hora em que os mortos ouvirão a voz do Filho de Deus: aqueles que ouvirem a sua voz terão a vida."
,"26":"Porque assim como o Pai possui a vida em Si mesmo, do mesmo modo concedeu ao Filho possuir a vida em Si mesmo."
,"27":"Além disso, deu ao Filho o poder de julgar, porque é Filho do Homem."
,"28":"Não fiqueis admirados com isto, porque vai chegar a hora em que todos os mortos que estão nos túmulos ouvirão a voz do Filho"
,"29":"e sairão dos túmulos: aqueles que fizeram o bem vão ressuscitar para a vida; os que praticaram o mal vão ressuscitar para a condenação."
,"30":"Eu não posso fazer nada por Mim mesmo. Eu julgo conforme o que escuto e o meu julgamento é justo, porque não procuro fazer a minha vontade, mas sim a vontade d'Aquele que Me enviou»."
,"31":"«Se dou testemunho de Mim mesmo, o meu testemunho não vale."
,"32":"Mas há Outro que dá testemunho de Mim e sei que o testemunho que Ele dá de Mim é válido."
,"33":"Vós mandastes mensageiros a João e ele deu testemunho da verdade."
,"34":"Eu não preciso do testemunho de um homem, mas digo isto para que sejais salvos."
,"35":"João era uma lâmpada que estava acesa e iluminava. Vós quisestes alegrar-vos com a sua luz."
,"36":"Mas eu tenho um testemunho maior que o de João: são as obras que o Pai Me concedeu realizar. As obras que faço dão testemunho de Mim, mostrando que o Pai Me enviou."
,"37":"E o Pai que Me enviou deu testemunho a meu favor. Vós nunca ouvistes a sua voz nem vistes a sua face."
,"38":"Desse modo, a sua palavra não permanece em vós, porque não acreditais n'Aquele que Ele enviou."
,"39":"Viveis a estudar as Escrituras, pensando que encontrareis nelas a vida eterna. No entanto, as Escrituras dão testemunho de Mim."
,"40":"Mas não quereis vir a Mim para terdes a vida eterna."
,"41":"Eu não aceito elogios dos homens."
,"42":"Quanto a vós, conheço-vos muito bem: o amor de Deus não está dentro de vós."
,"43":"Eu vim em nome de meu Pai e não Me recebestes. Mas, se outro vier em seu próprio nome, recebê-lo-eis."
,"44":"Como é que podereis acreditar, se viveis a elogiar-vos uns aos outros e não buscais a glória que vem do Deus único?"
,"45":"Não penseis que vos vou acusar diante do Pai. Já existe alguém que vos acusa: é Moisés, no qual pondes a vossa esperança."
,"46":"Se acreditásseis em Moisés, também acreditaríeis em Mim, porque foi a respeito de Mim que Moisés escreveu."
,"47":"Mas, se não acreditais naquilo que ele escreveu, como ireis acreditar nas minhas palavras?»"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Depois disto, Jesus foi para a outra margem do mar da Galileia, também chamado Tiberíades."
,"2":"Uma grande multidão seguia Jesus porque as pessoas viram os sinais que Ele fazia, curando os doentes."
,"3":"Jesus subiu à montanha e sentou-Se lá com os discípulos."
,"4":"Estava próxima a Páscoa, festa dos judeus."
,"5":"Jesus ergueu os olhos e viu uma grande multidão que vinha ao seu encontro. Então Jesus disse a Filipe: «Onde vamos comprar pão para eles comerem?» "
,"6":"Jesus disse isto para experimentar Filipe, pois sabia muito bem o que ia fazer."
,"7":"Filipe respondeu: «Nem meio ano de salário bastaria para dar um pedaço a cada um»."
,"8":"Um discípulo de Jesus, André, o irmão de Simão Pedro, disse:"
,"9":"«Aqui há um rapaz que tem cinco pães de cevada e dois peixes. Mas o que é isso para tanta gente?»."
,"10":"Então Jesus disse: «Dizei ao povo para se sentar». Havia muita erva naquele lugar e todos se sentaram. Estavam lá cerca de cinco mil pessoas."
,"11":"Jesus tomou os pães, agradeceu a Deus e distribuiu-os aos que estavam sentados. Fez a mesma coisa com os peixes. E todos comeram quanto queriam."
,"12":"Quando ficaram satisfeitos, Jesus disse aos discípulos: «Recolhei os pedaços que sobraram, para que não se desperdice nada»."
,"13":"Eles recolheram os pedaços e encheram doze cestos com as sobras dos cinco pães de que haviam comido."
,"14":"As pessoas viram o sinal que Jesus tinha realizado e disseram: «Este é mesmo o Profeta que devia vir ao mundo»."
,"15":"Mas Jesus percebeu que iam tomá-l'O para O fazerem rei. Então retirou-Se novamente sozinho para a montanha."
,"16":"Ao cair da tarde, os discípulos de Jesus desceram ao mar."
,"17":"Entraram na barca e foram em direcção a Cafarnaum, do outro lado do mar. Já era noite, e Jesus ainda não tinha ido ao encontro deles."
,"18":"Soprava um vento forte e o mar estava agitado."
,"19":"Os discípulos tinham remado mais ou menos cinco ou seis quilómetros, quando viram Jesus a andar sobre as águas e a aproximar-Se da barca. Então ficaram com medo,"
,"20":"mas Jesus disse: «Sou Eu. Não tenhais medo»."
,"21":"Eles quiseram recolher Jesus na barca, mas nesse instante a barca chegou à margem para onde iam."
,"22":"No dia seguinte, a multidão, que tinha ficado do outro lado do mar, viu que só lá havia uma barca. Viu também que Jesus não tinha entrado na barca com os discípulos e que eles tinham ido sozinhos."
,"23":"Então chegaram outras barcas de Tiberíades, perto do lugar onde eles tinham comido o pão, depois que o Senhor agradeceu a Deus."
,"24":"Quando a multidão viu que nem Jesus nem os discípulos estavam lá, entraram nas barcas e foram procurar Jesus em Cafarnaum."
,"25":"Quando encontraram Jesus no outro lado do lago, perguntaram-Lhe: «Rabi, quando é que chegaste aqui?»"
,"26":"Jesus respondeu: «Eu vos garanto: vós procurais-Me, não porque vistes os sinais, mas porque comestes os pães e ficastes satisfeitos."
,"27":"Não trabalheis pelo alimento que se estraga; trabalhai pelo alimento que dura para a vida eterna. É este alimento que o Filho do Homem vos dará, porque é Ele quem Deus Pai marcou com o seu selo»."
,"28":"Então perguntaram-Lhe: «O que é que devemos fazer para realizar as obras de Deus?»"
,"29":"Jesus respondeu: «A obra de Deus é que acrediteis n'Aquele que Ele enviou»."
,"30":"Eles perguntaram: «Que sinal realizas para que possamos ver e acreditar em Ti? Qual é a tua obra?"
,"31":"Os nossos pais comeram o maná no deserto, como diz a Escritura: 'Ele deu-lhes um pão que veio do Céu'»."
,"32":"Jesus respondeu: «Eu vos garanto: não foi Moisés que vos deu o pão que veio do Céu. Meu Pai é que vos dá o verdadeiro pão que vem do Céu,"
,"33":"porque o pão de Deus é aquele que desce do Céu e dá vida ao mundo»."
,"34":"Então eles pediram-Lhe: «Senhor, dá-nos sempre desse pão»."
,"35":"Jesus disse: «Eu sou o pão da vida. Quem vem a Mim nunca mais terá fome, e quem acredita em Mim nunca mais terá sede."
,"36":"Eu já vos disse: vós vistes-Me e não acreditastes."
,"37":"Todos aqueles que o Pai me dá virão a Mim. E Eu nunca rejeitarei aquele que vem a Mim,"
,"38":"pois Eu desci do céu, não para fazer a minha própria vontade, mas para fazer a vontade d'Aquele que Me enviou."
,"39":"E a vontade d'Aquele que Me enviou é esta: que Eu não perca nenhum daqueles que Ele Me deu, mas que Eu os ressuscite no último dia."
,"40":"Esta é a vontade de meu Pai: que todo o homem que vê o Filho e n'Ele acredita tenha a vida eterna, e Eu ressuscitá-lo-ei no último dia»."
,"41":"As autoridades dos judeus começaram a criticar, porque Jesus tinha dito: «Eu sou o pão que desceu do Céu»."
,"42":"E comentavam: «Esse Jesus não é o filho de José? Nós conhecemos o pai e a mãe d'Ele. Como é que Ele diz que desceu do Céu?»"
,"43":"Jesus respondeu: «Deixai de criticar."
,"44":"Ninguém pode vir a Mim se o Pai que Me enviou não o atrai, e Eu ressuscitá-lo-ei no último dia."
,"45":"Está escrito nos Profetas: 'Todos os homens serão instruídos por Deus'. Todo aquele que escuta o Pai e recebe a sua instrução vem a Mim."
,"46":"Não que alguém já tenha visto o Pai. O único que viu o Pai é Aquele que vem de Deus."
,"47":"Eu vos garanto: quem acredita, possui a vida eterna."
,"48":"Eu sou o pão da vida."
,"49":"Os vossos pais comeram o maná no deserto e, no entanto, morreram."
,"50":"Eis aqui o pão que desceu do Céu: quem dele comer nunca morrerá»."
,"51":"E Jesus continuou: «Eu sou o pão vivo que desceu do Céu. Quem come deste pão viverá para sempre. E o pão que Eu vou dar é a minha própria carne, para que o mundo tenha a vida»."
,"52":"As autoridades dos judeus começaram a discutir entre si: «Como pode este homem dar-nos a sua carne a comer?»"
,"53":"Jesus respondeu: «Eu vos garanto: se não comerdes a carne do Filho do Homem e não beberdes o seu sangue, não tereis a vida em vós."
,"54":"Quem come a minha carne e bebe o meu sangue tem a vida eterna, e Eu ressuscitá-lo-ei no último dia."
,"55":"Porque a minha carne é verdadeira comida e o meu sangue é verdadeira bebida."
,"56":"Quem come a minha carne e bebe o meu sangue vive em Mim e Eu vivo nele."
,"57":"E como o Pai, que vive, Me enviou e Eu vivo pelo Pai, assim aquele que me receber como alimento viverá por Mim."
,"58":"Este é o pão que desceu do Céu. Não é como o pão que os vossos pais comeram e depois morreram. Quem come deste pão viverá para sempre»."
,"59":"Jesus disse estas coisas quando ensinava na sinagoga de Cafarnaum."
,"60":"Depois de ouvirem estas coisas, muitos discípulos de Jesus disseram: «Este modo de falar é duro de mais. Quem pode continuar a ouvir isto?»"
,"61":"Jesus sabia que os seus discípulos estavam a criticar o que Ele tinha dito. Então perguntou-lhes: «Isto escandaliza-vos?"
,"62":"E se virdes o Filho do Homem subir para o lugar onde estava antes?"
,"63":"O Espírito é que dá a vida, a carne não serve para nada. As palavras que vos disse são espírito e vida."
,"64":"Mas entre vós há alguns que não acreditam». Jesus sabia desde o começo quais eram aqueles que não acreditavam e quem seria o traidor."
,"65":"E acrescentou: «É por isso que Eu disse: 'Ninguém pode vir a Mim, se isso não lhe é concedido pelo Pai'»."
,"66":"A partir desse momento, muitos discípulos voltaram atrás e já não andavam com Jesus."
,"67":"Então Jesus disse aos Doze: «Vós também vos quereis ir embora?»"
,"68":"Simão Pedro respondeu: «Para quem iremos, Senhor? Tu tens palavras de vida eterna."
,"69":"Agora nós acreditamos e sabemos que Tu és o Santo de Deus»."
,"70":"Jesus disse aos Doze: «Não sois vós os Doze que Eu escolhi? Apesar disso, um de vós é um demónio»."
,"71":"Jesus falava de Judas, filho de Simão Iscariotes, porque Judas iria trair Jesus, apesar de ser um dos Doze Apóstolos."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Depois disto, Jesus começou a andar pela Galileia. Ele evitava andar pela Judeia, porque os judeus queriam matá-l'O."
,"2":"Entretanto, a festa judaica das Tendas estava próxima."
,"3":"Então os irmãos de Jesus disseram-Lhe: «Tu deves sair daqui e ir para a Judeia, para que também os teus discípulos possam ver as obras que fazes."
,"4":"Quem quer ter fama não faz nada às escondidas. Se fazes estas obras, mostra-Te ao mundo»."
,"5":"Na verdade, nem mesmo os irmãos de Jesus acreditavam n'Ele."
,"6":"Jesus disse: «O momento certo ainda não chegou para Mim. Para vós, qualquer momento é bom."
,"7":"O mundo não tem motivo para vos odiar. Mas o mundo odeia-Me, porque Eu dou testemunho de que as suas acções são más."
,"8":"Ide vós para a festa. Eu não vou para esta festa, porque o momento certo ainda não chegou para Mim»."
,"9":"Jesus disse isto e ficou na Galileia."
,"10":"Depois de os seus irmãos terem ido para a festa, Jesus também foi; Ele não foi publicamente, mas às escondidas."
,"11":"As autoridades dos judeus procuravam Jesus durante a festa, perguntando: «Onde está Ele?»"
,"12":"Todos falavam de Jesus, mas em voz baixa. Uns diziam: «É uma boa pessoa». Outros, porém, diziam: «De modo nenhum. É um homem que engana o povo»."
,"13":"Mas em público ninguém falava nada a respeito de Jesus, com medo das autoridades dos judeus."
,"14":"Quando a festa já ia a meio, Jesus foi ao Templo e começou a ensinar."
,"15":"As autoridades dos judeus ficaram admiradas e diziam: «Como é que este homem tem tanta instrução, se nunca estudou?»"
,"16":"Então Jesus respondeu: «A minha doutrina não vem de Mim, mas d'Aquele que Me enviou."
,"17":"Se alguém está disposto a fazer a vontade de Deus, saberá se a minha doutrina vem de Deus, ou se falo por Mim mesmo."
,"18":"Quem fala por si mesmo busca o próprio prestígio. Mas quem busca o prestígio d'Aquele que O enviou é verdadeiro, e n'Ele não há falsidade."
,"19":"Não foi Moisés quem vos deu a Lei? No entanto, nenhum de vós obedece à Lei. Porque é que Me quereis matar?»"
,"20":"A multidão respondeu: «Estás louco! Quem é que Te quer matar?»"
,"21":"Jesus respondeu: «Eu fiz só uma coisa, e todos vós ficais admirados."
,"22":"Moisés mandou fazer a circuncisão (na verdade, ela não vem de Moisés, mas dos patriarcas) e, no entanto, vós circuncidais em dia de sábado."
,"23":"Assim, uma pessoa pode receber a circuncisão em dia de sábado sem violar a Lei de Moisés. Então, porque é que vos irritais comigo por ter curado totalmente um homem no sábado?"
,"24":"Não julgueis pelas aparências, mas conforme a verdade»."
,"25":"Algumas pessoas de Jerusalém comentavam: «Não é a Este que procuram matar?"
,"26":"Ele está ali a falar em público e ninguém diz nada! Será que até as autoridades reconheceram que Ele é o Messias?"
,"27":"Entretanto, nós sabemos de onde vem este Jesus, mas, quando chegar o Messias, ninguém saberá de onde Ele vem»."
,"28":"Jesus estava a ensinar no Templo. Então Ele gritou: «Será que de facto Me conheceis e sabeis de onde Eu sou? Eu não vim por Mim mesmo. Quem Me enviou é verdadeiro e vós não O conheceis."
,"29":"Mas Eu conheço-O, porque venho de junto d'Ele e foi Ele quem Me enviou»."
,"30":"Então tentaram prender Jesus. Mas ninguém pôs a mão em cima d'Ele, porque a sua hora ainda não tinha chegado."
,"31":"Muitas pessoas do povo acreditaram n'Ele e diziam: «Quando o Messias vier, será que vai fazer mais sinais do que Este fez?»"
,"32":"Os fariseus ouviram o que a multidão murmurava sobre Jesus. Então, os sumos sacerdotes e fariseus mandaram guardas para prenderem Jesus."
,"33":"E Jesus disse: «Ainda vou ficar mais um pouco de tempo convosco."
,"34":"Ireis procurar-Me mas não Me encontrareis, porque não podeis ir para onde Eu vou'»."
,"35":"Os judeus comentavam: «Para onde é que Ele irá, de modo que não possamos encontrá-l'O? Irá ter com aqueles que estão espalhados entre os gregos? Será que vai ensinar aos gregos?"
,"36":"Que significará o que Ele disse: 'Ireis procurar-Me, mas não Me encontrareis'; e também: 'Não podeis ir para onde Eu vou'?»."
,"37":"No último dia da festa, que é o mais solene, Jesus ficou de pé e gritou: «Se alguém tem sede, venha a Mim,"
,"38":"e aquele que acredita em Mim, beba. É como diz a Escritura: 'Do seu seio jorrarão rios de água viva'»."
,"39":"Jesus disse isto, referindo-se ao Espírito que deveriam receber os que acreditassem n'Ele. De facto, ainda não viera o Espírito, porque Jesus ainda não tinha sido glorificado."
,"40":"Ouvindo estas palavras, alguns diziam no meio da multidão: «De facto, este homem é mesmo o Profeta!»"
,"41":"Outros diziam: «Ele é o Messias». Outros ainda afirmavam: «Mas o Messias virá da Galileia?"
,"42":"A Escritura não diz que o Messias será da descendência de David e que virá da povoação de Belém, de onde era David?»"
,"43":"Por isso, houve uma divisão no meio do povo por causa de Jesus."
,"44":"Alguns queriam prendê-l'O, mas ninguém Lhe pôs as mãos."
,"45":"Os guardas do Templo foram então ter com os sumos sacerdotes e fariseus. E estes perguntaram: «Porque é que não trouxestes Jesus?»"
,"46":"Os guardas responderam: «Nunca ninguém falou como esse homem!»"
,"47":"Então os fariseus perguntaram: «Será que Ele também vos enganou?"
,"48":"Já vistes algum dos nossos chefes ou fariseu que acreditasse n'Ele?"
,"49":"Esse povinho que não conhece a Lei é maldito»."
,"50":"Mas Nicodemos, um dos fariseus, aquele que tinha ido encontrar-se com Jesus, disse:"
,"51":"«Será que a nossa Lei julga alguém antes de o ouvir e saber o que ele faz?»"
,"52":"Eles responderam: «Também és galileu? Estuda e verás que da Galileia não sai nenhum profeta»."
,"53":"E cada um voltou para sua casa."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Jesus foi para o monte das Oliveiras."
,"2":"Ao amanhecer, voltou ao Templo e todo o povo ia ao seu encontro. Então Jesus sentou-Se e começou a ensinar."
,"3":"Chegaram os doutores da Lei e os fariseus com uma mulher que tinha sido apanhada a cometer adultério. Colocaram a mulher no meio"
,"4":"e disseram a Jesus: «Mestre, esta mulher foi apanhada em flagrante a cometer adultério."
,"5":"A lei de Moisés manda que estas mulheres devem ser apedrejadas. E Tu, que dizes?»"
,"6":"Eles diziam isto para pôr Jesus à prova e terem um motivo para O acusar. Então Jesus inclinou-Se e começou a escrever no chão com o dedo."
,"7":"Os doutores da Lei e os fariseus continuaram a insistir na pergunta. Então Jesus levantou-Se e disse: «Quem de vós não tiver pecado, atire-lhe a primeira pedra»."
,"8":"E, inclinando-Se de novo, continuou a escrever no chão."
,"9":"Ouvindo isto, eles foram saindo um a um, começando pelos mais velhos. E Jesus ficou sozinho. Ora, a mulher continuava ali no meio."
,"10":"Jesus então levantou-Se e perguntou: «Mulher, onde estão os outros? Ninguém te condenou?»"
,"11":"Ela respondeu: «Ninguém, Senhor». Então Jesus disse: «Eu também não te condeno. Podes ir, e não voltes a pecar»."
,"12":"Jesus continuou a afirmar: «Eu sou a luz do mundo. Quem Me segue não andará nas trevas, mas possuirá a luz da vida»."
,"13":"Então os fariseus disseram: «O teu testemunho não vale, porque estás a dar testemunho de Ti mesmo»."
,"14":"Jesus respondeu: «Embora Eu dê testemunho de Mim mesmo, o meu testemunho é válido, porque Eu sei de onde venho e para onde vou."
,"15":"Vós julgais como homens, mas Eu não julgo ninguém."
,"16":"Mesmo que Eu julgue, o meu julgamento é válido, porque não estou sozinho, mas o Pai que Me enviou está comigo."
,"17":"Na vossa Lei está escrito que o testemunho de duas pessoas é válido."
,"18":"Eu dou testemunho de Mim mesmo, e o Pai que Me enviou dá testemunho de Mim»."
,"19":"Então perguntaram-Lhe: «Onde está o teu Pai?» Jesus respondeu: «Vós não conheceis nem a Mim nem ao meu Pai. Se Me conhecêsseis, também conheceríeis o meu Pai»."
,"20":"Jesus disse estas coisas enquanto estava a ensinar no Templo, perto da sala do Tesouro. E ninguém O prendeu, porque a sua hora ainda não havia chegado."
,"21":"Jesus disse-lhes ainda: «Eu vou-Me embora. Vós haveis de procurar-Me e morrereis no vosso pecado. Para onde Eu vou, vós não podeis ir»."
,"22":"As autoridades dos judeus comentavam: «Irá Ele matar-Se? Pois está a dizer: 'Para onde Eu vou, vós não podeis ir'»."
,"23":"Jesus continuou a dizer-lhes: «Vós sois cá de baixo, Eu sou lá de cima. Vós sois deste mundo, mas Eu não sou deste mundo."
,"24":"É por isso que Eu digo que vós ireis morrer nos vossos pecados. Se não acreditais que Eu Sou, morrereis nos vossos pecados»."
,"25":"Então as autoridades dos judeus perguntaram: «Quem és Tu?» Jesus respondeu: «O que estou a dizer desde o princípio."
,"26":"Eu poderia dizer muitas coisas a vosso respeito e condenar-vos. Mas Aquele que Me enviou é verdadeiro, e Eu digo ao mundo as coisas que Lhe ouvi»."
,"27":"Eles não compreenderam que Jesus lhes falava do Pai."
,"28":"Jesus disse ainda: «Quando levantardes o Filho do Homem, então sabereis que Eu Sou e que não faço nada por Mim mesmo, pois digo apenas aquilo que o Pai Me ensinou."
,"29":"Aquele que Me enviou está comigo. Ele não Me deixou sozinho, porque faço sempre o que Lhe agrada»."
,"30":"Enquanto Jesus dizia estas coisas, muitos acreditaram n'Ele."
,"31":"Então Jesus disse às autoridades dos judeus que tinham acreditado n'Ele: «Se guardardes a minha palavra, sereis de facto meus discípulos;"
,"32":"conhecereis a verdade e a verdade vos libertará»."
,"33":"Eles disseram: «Nós somos descendentes de Abraão e nunca fomos escravos de ninguém. Como podes dizer: 'ficareis livres'?»"
,"34":"Jesus respondeu: «Garanto-vos: quem comete o pecado é escravo do pecado."
,"35":"O escravo não fica para sempre na casa, mas o filho fica lá para sempre."
,"36":"Por isso, se o Filho vos libertar, ficareis realmente livres."
,"37":"Eu sei que sois descendentes de Abraão; no entanto, procurais matar-Me, porque a minha palavra não entra na vossa cabeça."
,"38":"Eu falo das coisas que vi junto do Pai; vós também deveis fazer o que ouvis ao vosso pai»."
,"39":"As autoridades dos judeus disseram a Jesus: «O nosso pai é Abraão». Jesus disse: «Se sois filhos de Abraão, fazei as obras de Abraão."
,"40":"Agora, porém, quereis matar-Me, e o que Eu fiz foi dizer a verdade que ouvi junto de Deus. Abraão nunca fez isso."
,"41":"Vós fazeis a obra do vosso pai». Então eles replicaram: «Não somos filhos ilegítimos; só temos um pai, que é Deus»."
,"42":"Jesus disse: «Se Deus fosse vosso Pai, amar-Me-íeis, porque Eu saí de Deus e venho d'Ele. Não vim pela minha própria vontade, mas foi Ele que Me enviou."
,"43":"Por que motivo não compreendeis o que Eu digo? É porque não sois capazes de ouvir a minha palavra."
,"44":"O vosso pai é o diabo, e quereis realizar o desejo do vosso pai. Desde o começo ele é assassino e nunca esteve com a verdade, porque nele não existe verdade. Quando ele profere a mentira fala do que é dele, porque ele é mentiroso e pai da mentira."
,"45":"Eu falo a verdade, e por isso não acreditais em Mim."
,"46":"Quem de vós pode acusar-Me de pecado? Se digo a verdade, porque é que não acreditais em Mim?"
,"47":"Quem é de Deus ouve as palavras de Deus. Vós, porém, não ouvis, porque não sois de Deus»."
,"48":"As autoridades dos judeus disseram: «Não temos razão em dizer que és um samaritano e que estás louco?»"
,"49":"Jesus respondeu: «Eu não estou louco. Eu honro meu Pai e vós desonrais-Me."
,"50":"Eu não pro-curo a minha glória. Existe Alguém que a procura e julga."
,"51":"Garanto-vos: se alguém guardar a minha palavra, jamais verá a morte»."
,"52":"Os judeus disseram: «Agora sabemos que estás louco. Abraão morreu e os profetas também. E Tu dizes: 'Se alguém guarda a minha palavra, nunca vai experimentar a morte'."
,"53":"Acaso és maior que o nosso pai Abraão, que morreu? Os profetas também morreram. Quem é que pretendes ser?»"
,"54":"Jesus respondeu: «Se Me glorifico a Mim mesmo, a minha glória não vale nada. Quem Me glorifica é o meu Pai, Aquele que dizeis ser o vosso Pai."
,"55":"Vós não O conheceis, mas Eu conheço-O. Se dissesse que não O conheço, seria mentiroso como vós. Mas Eu conheço-O e guardo a sua palavra."
,"56":"Abraão, vosso pai, alegrou-se porque viu o meu dia. Ele viu e encheu-se de alegria»."
,"57":"Então os judeus disseram: «Ainda não tens cinquenta anos e viste Abraão?»"
,"58":"Jesus respondeu: «Garanto-vos: antes que Abraão existisse, Eu Sou»."
,"59":"Então eles apanharam pedras para Lhas atirar. Mas Jesus escondeu-Se e saiu do Templo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Ao passar, Jesus viu um cego de nascença."
,"2":"Os discípulos perguntaram: «Mestre, quem foi que pecou, para que nascesse cego? Foi ele ou seus pais?»"
,"3":"Jesus respondeu: «Não foi ele que pecou, nem seus pais, mas é cego para que nele se manifestem as obras de Deus."
,"4":"Nós temos que realizar as obras d'Aquele que Me enviou, enquanto é dia. Vai chegar a noite, e ninguém poderá trabalhar."
,"5":"Enquanto estou no mundo sou a luz do mundo»."
,"6":"Dizendo isto, Jesus cuspiu no chão, fez barro com a saliva, e com o barro ungiu os olhos do cego."
,"7":"E disse: «Vai lavar-te na piscina de Siloé». (Esta palavra quer dizer «O Enviado»). O cego foi, lavou-se e voltou vendo."
,"8":"Os vizinhos e os que costumavam ver o cego, pois era mendigo, perguntavam: «Não é ele que ficava sentado a pedir esmola?»"
,"9":"Uns diziam: «É ele mesmo». Outros, porém, diziam: «Não é ele, não, mas parece-se com ele». Ele, no entanto, dizia: «Sou eu mesmo»."
,"10":"Então perguntaram-lhe: «Como é que os teus olhos se abriram?»"
,"11":"Ele respondeu: «O homem que se chama Jesus fez barro, ungiu os meus olhos e disse-me: 'Vai lavar-te à piscina de Siloé'. Eu fui, lavei-me e comecei a ver»."
,"12":"Perguntaram-lhe: «Onde está esse homem?» Ele disse: «Não sei»."
,"13":"Então levaram aos fariseus aquele que tinha sido cego."
,"14":"Era sábado o dia em que Jesus fez o barro e abriu os olhos do cego."
,"15":"Então os fariseus perguntaram-lhe como é que tinha recuperado a vista. Ele disse: «Alguém colocou barro nos meus olhos, eu lavei-me e vejo»."
,"16":"Então os fariseus disseram: «Esse homem não pode vir de Deus; Ele não guarda o sábado». Outros diziam: «Mas como pode um pecador realizar estes sinais?»"
,"17":"E havia divisão entre eles. Perguntaram outra vez ao que tinha sido cego: «O que dizes do homem que abriu os teus olhos?» Ele respondeu: «É um profeta»."
,"18":"As autoridades dos judeus não acreditaram que ele tinha sido cego e que tinha recuperado a vista, enquanto não chamaram os pais dele."
,"19":"Perguntaram-lhes: «É este o vosso filho que dizeis ter nascido cego? Como é que ele agora vê?»"
,"20":"Os pais disseram: «Sabemos que é o nosso filho e que nasceu cego."
,"21":"Como é que agora vê, isso não sabemos. Também não sabemos quem foi que lhe abriu os olhos. Perguntai-lho. É maior de idade e pode dar uma explicação»."
,"22":"Os pais do cego disseram isto porque tinham medo das autoridades dos judeus, que haviam combinado expulsar da sinagoga quem confessasse que Jesus era o Messias."
,"23":"Foi por isso que os pais disseram: «É maior de idade; perguntai-lho»."
,"24":"Então as autoridades dos judeus chamaram de novo o homem que tinha sido cego e disseram-lhe: «Confessa a verdade. Nós sabemos que esse homem é um pecador»."
,"25":"Ele respondeu: «Se ele é pecador, isso não sei; só sei que eu era cego e agora vejo»."
,"26":"Eles insistiram: «Que é que Ele fez? Como foi que te abriu os olhos?»"
,"27":"Ele respondeu: «Eu já vo-lo disse e não me escutastes. Porque é que quereis ouvir novamente? Será que também quereis tornar-vos seus discípulos?»"
,"28":"Então insultaram o cego curado e disseram: «Tu é que és discípulo d'Ele. Nós somos discípulos de Moisés."
,"29":"Sabemos que Deus falou a Moisés, mas quanto a esse homem, nem sabemos de onde Ele é»."
,"30":"Ele respondeu: «Isso é de admirar! Não sabeis de onde Ele é. No entanto, Ele abriu os meus olhos."
,"31":"Sabemos que Deus não ouve os pecadores, mas ouve aquele que O respeita e faz a sua vontade."
,"32":"Nunca se ouviu dizer que alguém tenha aberto os olhos de um cego de nascença."
,"33":"Se esse homem não vem de Deus, não poderia fazer nada»."
,"34":"Eles disseram: «Nasceste inteirinho no pecado e queres ensinar-nos?» E expulsaram-no."
,"35":"Jesus, ouvindo dizer que tinham expulsado aquele que fora cego, foi à procura dele e perguntou-lhe: «Acreditas no Filho do Homem?»"
,"36":"Ele respondeu: «Quem é Ele, Senhor, para que eu acredite n'Ele?»"
,"37":"Jesus disse: «Estás a vê-l'O; é Aquele que está a falar contigo»."
,"38":"O cego que tinha sido curado disse: «Eu acredito, Senhor». E ajoelhou-se diante de Jesus."
,"39":"Então Jesus disse: «Eu vim a este mundo para um julgamento, a fim de que os que não vêem vejam, e os que vêem se tornem cegos»."
,"40":"Alguns fariseus que estavam perto d'Ele ouviram isto e disseram: «Será que também somos cegos?»"
,"41":"Jesus respondeu: «Se fôsseis cegos, não teríeis nenhum pecado. Mas como dizeis: 'Nós vemos', o vosso pecado permanece»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"«Eu vos garanto: aquele que não entra pela porta no redil das ovelhas, mas sobe por outro lugar, é ladrão e salteador."
,"2":"Mas aquele que entra pela porta é o pastor das ovelhas."
,"3":"O porteiro abre-lhe a porta e as ovelhas ouvem a sua voz; chama cada uma das suas ovelhas pelo nome e leva-as para fora."
,"4":"Depois de fazer sair todas as suas ovelhas, ele caminha à frente delas; e as ovelhas seguem-no porque conhecem a sua voz."
,"5":"Elas nunca seguirão um estranho; ao contrário, vão fugir dele, porque não conhecem a voz dos estranhos»."
,"6":"Jesus contou-lhes esta parábola, mas eles não entenderam o que Jesus queria dizer-lhes."
,"7":"Jesus voltou a dizer-lhes: «Garanto-vos: Eu sou a porta das ovelhas."
,"8":"Todos os que vieram antes de Mim são ladrões e salteadores, mas as ovelhas não os ouviram."
,"9":"Eu sou a porta. Quem entra por Mim será salvo. Entrará e sairá e encontrará pastagem."
,"10":"O ladrão só vem para roubar, matar e destruir. Eu vim para que tenham vida e a tenham em abundância."
,"11":"Eu sou o bom pastor. O bom pastor dá a vida pelas suas ovelhas."
,"12":"O mercenário, que não é pastor e a quem as ovelhas não pertencem, quando vê chegar o lobo abandona as ovelhas e foge. Então o lobo ataca e dispersa as ovelhas."
,"13":"O mercenário foge porque trabalha só por dinheiro e não se importa com as ovelhas."
,"14":"Eu sou o bom pastor: conheço as minhas ovelhas e elas conhecem-Me,"
,"15":"assim como o Pai Me conhece e Eu conheço o Pai. Eu dou a vida pelas ovelhas."
,"16":"Tenho também outras ovelhas que não são deste redil. Também tenho de as conduzir; elas ouvirão a minha voz e haverá um só rebanho e um só pastor."
,"17":"O Pai ama-Me, porque dou a minha vida para voltar a tomá-la."
,"18":"Ninguém Me tira a vida; Eu dou-a livremente. Tenho poder para a dar e para tornar a tomá-la. Este é o mandamento que recebi de meu Pai»."
,"19":"Estas palavras causaram de novo divisão entre as autoridades dos judeus."
,"20":"Muitos diziam: «Ele tem um demónio! Está louco! Porque é que O escutais?»"
,"21":"Outros diziam: «Estas palavras não são de um possesso, porque um demónio não pode abrir os olhos a um cego»."
,"22":"Em Jerusalém celebrava-se a festa da Dedicação. Era Inverno."
,"23":"Jesus passeava pelo Templo, no pórtico de Salomão."
,"24":"Então as autoridades dos judeus rodearam-n'O e disseram-Lhe: «Até quando nos irás deixar em dúvida? Se Tu és o Messias, diz-no-lo abertamente»."
,"25":"Jesus respondeu: «Eu já vo-lo disse, mas não acreditastes em Mim. As obras que faço em nome do meu Pai dão testemunho de Mim;"
,"26":"vós, porém, não quereis acreditar, porque não sois minhas ovelhas."
,"27":"As minhas ovelhas ouvem a minha voz; Eu conheço-as e elas seguem-Me."
,"28":"Eu dou-lhes a vida eterna e elas nunca morrerão. Ninguém vai arrancá-las da minha mão."
,"29":"O Pai, que tudo Me entregou, é maior do que todos. Ninguém pode arrancá-las da mão do meu Pai."
,"30":"O Pai e Eu somos um»."
,"31":"As autoridades dos judeus pegaram outra vez em pedras para apedrejar Jesus."
,"32":"Então Jesus disse: «Por ordem de meu Pai, tenho feito muitas coisas boas na vossa presença. Por qual delas me quereis apedrejar?»"
,"33":"As autoridades dos judeus responderam: «Não queremos apedrejar-Te por boas obras, mas por blasfémia: Tu és apenas um homem e fazes-Te passar por Deus»."
,"34":"Jesus disse: «Não é na vossa Lei que está escrito: 'Eu disse: vós sois deuses'?"
,"35":"Ninguém pode anular a Escritura. Ora, a Lei chama deuses as pessoas às quais a palavra de Deus foi dirigida."
,"36":"O Pai consagrou-Me e enviou-Me ao mundo. Porque me acusais de blasfémia, por Eu dizer que sou Filho de Deus?"
,"37":"Se não faço as obras do meu Pai, não precisais de acreditar em Mim."
,"38":"Mas se as faço, mesmo que não queirais acreditar em Mim, acreditai pelo menos nas minhas obras. Assim conhecereis que o Pai está presente em Mim e Eu no Pai»."
,"39":"Eles tentaram outra vez prender Jesus, mas Ele escapou-Se das suas mãos."
,"40":"Jesus atravessou de novo o rio Jordão e foi para o lugar onde antes João tinha baptizado. E ali ficou."
,"41":"Muitos foram ao seu encontro. E diziam: «João não realizou nenhum sinal, mas tudo o que ele disse a respeito deste homem é verdade»."
,"42":"E muitos ali acreditaram em Jesus."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Um certo Lázaro tinha adoecido. Era natural de Betânia, aldeia de Maria e de sua irmã Marta. "
,"2":"Maria era aquela que tinha ungido o Senhor com perfume e que Lhe tinha enxugado os pés com os cabelos. Lázaro, que estava doente, era irmão dela."
,"3":"Então as irmãs mandaram a Jesus um recado que dizia: «Senhor, aquele a quem amas está doente»."
,"4":"Ouvindo o recado, Jesus disse: «Essa doença não é para a morte, mas para a glória de Deus, para que o Filho de Deus seja glorificado por meio dela»."
,"5":"Jesus amava Marta, a irmã dela, e Lázaro."
,"6":"Quando ouviu dizer que ele estava doente, ficou ainda dois dias no lugar onde estava."
,"7":"Só então disse aos discípulos: «Vamos outra vez à Judeia»."
,"8":"Os discípulos responderam-Lhe: «Mestre, ainda agora os judeus queriam apedrejar-Te e vais para lá?»."
,"9":"Jesus respondeu: «Não são doze as horas do dia? Se alguém caminha de dia, não tropeça, porque vê a luz deste mundo."
,"10":"Mas se alguém caminha de noite tropeça, porque nele não há luz»."
,"11":"Disse isto e acrescentou: «O nosso amigo Lázaro adormeceu. Eu vou acordá-lo»."
,"12":"Os discípulos disseram: «Senhor, se está a dormir vai salvar-se»."
,"13":"Jesus referia-se à morte de Lázaro, mas os discípulos pensaram que Ele falava do sono natural."
,"14":"Então Jesus disse-lhes claramente: «Lázaro está morto."
,"15":"E Eu alegro-Me por não termos estado lá, para que acrediteis. Agora vamos ter com ele»."
,"16":"Então Tomé, chamado Gémeo, disse aos companheiros: «Vamos nós também, para morrermos com Ele»."
,"17":"Quando Jesus chegou, havia já quatro dias que Lázaro estava no túmulo."
,"18":"Betânia ficava perto de Jerusalém; uns três quilómetros apenas."
,"19":"Muitos judeus tinham ido à casa de Marta e Maria para as consolar por causa do irmão."
,"20":"Quando Marta ouviu dizer que Jesus estava a chegar, foi ao encontro d'Ele. Maria, porém, ficou sentada em casa."
,"21":"Então Marta disse a Jesus: «Senhor, se estivesses aqui, meu irmão não teria morrido."
,"22":"Mas ainda agora eu sei: tudo o que pedires a Deus, Ele To concederá»."
,"23":"Jesus disse: «Teu irmão vai ressuscitar»."
,"24":"Marta disse: «Eu sei que vai ressuscitar na ressurreição, no último dia»."
,"25":"Jesus disse: «Eu sou a ressurreição e a vida. Quem acredita em Mim, mesmo que morra, viverá."
,"26":"E todo aquele que vive e acredita em Mim nunca morrerá. Acreditas nisto?»"
,"27":"Ela respondeu: «Sim, Senhor. Eu acredito que Tu és o Messias, o Filho de Deus que devia vir a este mundo»."
,"28":"Dito isto, Marta foi chamar sua irmã Maria. Falou com ela em voz baixa: «O Mestre está cá e chama-te»."
,"29":"Quando Maria ouviu isto, levantou-se depressa e foi ao encontro de Jesus."
,"30":"Jesus ainda não tinha entrado na aldeia, mas estava no mesmo lugar onde Marta O havia encontrado."
,"31":"Os judeus estavam com Maria em casa e procuravam consolá-la. Quando viram Maria levantar-se depressa e sair foram atrás dela, pensando que iria ao túmulo para lá chorar."
,"32":"Então Maria foi ao lugar onde estava Jesus. Vendo-O, ajoelhou-se a seus pés e disse: «Senhor, se estivesses aqui, o meu irmão não teria morrido»."
,"33":"Jesus viu que Maria e os judeus que vinham com ela estavam a chorar. Então Ele perturbou-Se e ficou comovido."
,"34":"E perguntou: «Onde colocastes Lázaro?» Disseram-Lhe: «Senhor, vem e vê»."
,"35":"Jesus começou a chorar."
,"36":"Então os judeus disseram: «Vede como Ele o amava!»"
,"37":"Alguns deles, porém, comentaram: «Ele que abriu os olhos ao cego, não poderia ter impedido que este homem morresse?»"
,"38":"Jesus, de novo intimamente comovido, chegou ao túmulo. Era uma gruta, fechada com uma pedra."
,"39":"Jesus disse: «Tirai a pedra». Marta, irmã do falecido, disse: «Senhor, já cheira mal. Já aqui está há quatro dias»."
,"40":"Jesus disse: «Eu não te disse que, se acreditares, verás a glória de Deus?»"
,"41":"Então tiraram a pedra. Jesus levantou os olhos para o alto e disse: «Pai, Eu Te dou graças porque Me ouviste."
,"42":"Eu sei que sempre Me ouves. Mas Eu falo por causa das pessoas que Me rodeiam, para que acreditem que Tu Me enviaste»."
,"43":"Dizendo isto, gritou bem forte: «Lázaro, sai para fora!»"
,"44":"O morto saiu. Tinha os braços e as pernas amarrados com panos e o rosto coberto com um sudário. Jesus disse aos presentes: «Desligai-o e deixai-o ir»."
,"45":"Então, muitos judeus que tinham ido a casa de Maria e que viram o que Jesus fez, acreditaram n'Ele."
,"46":"Alguns, porém, foram ter com os fariseus e contaram o que Jesus tinha feito."
,"47":"Então os sumos sacerdotes e os fariseus reuniram o Conselho e disseram: «Que é que vamos fazer? Esse homem está realizando muitos sinais."
,"48":"Se deixamos que Ele continue assim, todos vão acreditar n'Ele; os romanos virão e destruirão o Templo e toda a nação»."
,"49":"Um deles, chamado Caifás, sumo sacerdote nesse ano, disse: «Vós não sabeis nada."
,"50":"Não compreendeis que é melhor um só homem morrer pelo povo, do que perecer a nação inteira?»."
,"51":"Caifás não disse isto por si mesmo. Sendo sumo sacerdote naquele ano, profetizou que Jesus ia morrer pela nação."
,"52":"E não só pela nação, mas também para reunir os filhos de Deus que estavam dispersos."
,"53":"A partir desse dia, as autoridades dos judeus decidiram matar Jesus."
,"54":"Por isso, Jesus já não andava em público entre os judeus. Retirou-Se para uma região perto do deserto. Foi para uma cidade chamada Efraim, onde ficou com os seus discípulos."
,"55":"A Páscoa dos judeus estava próxima, e muita gente do campo foi a Jerusalém para se purificar antes da Páscoa."
,"56":"Eles procuravam Jesus, e quando se reuniram no Templo comentavam: «Que vos parece? Será que Ele não vem à festa?»"
,"57":"Os sumos sacerdotes e os fariseus tinham dado uma ordem: quem soubesse onde Jesus estava, devia denunciá-l'O, para que eles O pudessem prender."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Seis dias antes da Páscoa, Jesus foi a Betânia, onde morava Lázaro, que Ele havia ressuscitado dos mortos."
,"2":"Ali ofereceram um jantar a Jesus. Marta servia e Lázaro era um dos que estavam à mesa com Jesus."
,"3":"Então Maria levou quase meio litro de perfume de nardo puro e muito caro. Ungiu com ele os pés de Jesus e enxugou-os com os seus cabelos. A casa inteira encheu-se com o perfume."
,"4":"Judas Iscariotes, um dos discípulos, aquele que ia trair Jesus, disse:"
,"5":"«Porque não se vendeu este perfume por trezentas moedas de prata, para dar aos pobres?»"
,"6":"Judas disse isto, não porque se preocupasse com os pobres, mas porque era ladrão. Ele tomava conta da bolsa comum e roubava do que nela era depositado."
,"7":"Jesus, porém, disse: «Deixai-a. Ela guardou este perfume para Me ungir no dia da minha sepultura."
,"8":"No meio de vós sempre haverá pobres; ao passo que Eu não estarei sempre convosco»."
,"9":"Muitos judeus tiveram conhecimento de que Jesus estava em Betânia. Então foram lá não só por causa de Jesus, mas também para verem Lázaro, que Jesus havia ressuscitado dos mortos."
,"10":"Então os sumos sacerdotes decidiram matar também Lázaro,"
,"11":"porque, por causa dele, muitos judeus deixavam os seus chefes e acreditavam em Jesus."
,"12":"No dia seguinte, a grande multidão que tinha ido para a festa ouviu dizer que Jesus estava a chegar a Jerusalém."
,"13":"Então pegaram em ramos de palmeira e saíram ao encontro de Jesus, gritando: «Hosana! Bendito Aquele que vem em nome do Senhor, o rei de Israel!»"
,"14":"Jesus, encontrando um jumentinho, montou nele, como está dito na Escritura:"
,"15":"«Não tenhas medo, cidade de Sião. Eis que o teu rei vem, montado num jumentinho!»."
,"16":"Naquele momento, os discípulos não entenderam o que se passava. Mas quando Jesus foi glorificado, lembraram-se de que haviam feito com Jesus aquilo que a Escritura dizia."
,"17":"A multidão que estivera presente quando Jesus ressuscitou Lázaro, mandando-o sair do túmulo, dava testemunho do que tinha visto."
,"18":"A multidão ia ao encontro de Jesus, porque sabiam que Ele tinha realizado esse sinal."
,"19":"Então os fariseus disseram uns aos outros: «Vedes como não conseguis nada? Toda a gente vai atrás de Jesus!»."
,"20":"Entre os que tinham ido à festa para adorar a Deus havia alguns gregos."
,"21":"Eles aproximaram-se de Filipe, que era de Betsaida da Galileia, e disseram: «Senhor, queremos ver Jesus»."
,"22":"Filipe falou com André; e os dois foram falar com Jesus."
,"23":"Jesus respondeu-lhes, dizendo: «Chegou a hora em que o Filho do Homem vai ser glorificado."
,"24":"Garanto-vos: se o grão de trigo não cai na terra e não morre, fica sozinho. Mas, se morre, produz muito fruto."
,"25":"Quem tem apego à sua vida vai perdê-la; quem despreza a sua vida neste mundo vai conservá-la para a vida eterna."
,"26":"Se alguém quer servir-Me, que Me siga. E onde Eu estiver, aí também estará o meu servo. Se alguém Me serve, o Pai honrá-lo-á."
,"27":"Agora estou muito perturbado. E o que vou dizer? Pai, livra-Me desta hora? Mas foi precisamente para esta hora que Eu vim."
,"28":"Pai, manifesta a glória do teu Nome!». Então veio uma voz do céu: «Eu manifestei a glória do meu Nome e vou manifestá-la de novo». "
,"29":"A multidão que ali estava ouviu a voz e dizia que tinha sido um trovão. Outros diziam: «Foi um anjo que falou com Ele»."
,"30":"Jesus disse: «Esta voz não se fez ouvir por causa de Mim, mas por causa de vós."
,"31":"Agora é o julgamento deste mundo. Agora o príncipe deste mundo vai ser expulso"
,"32":"e, quando Eu for levantado da terra, atrairei todos a Mim»."
,"33":"Jesus dizia isto para indicar de que morte ia morrer."
,"34":"A multidão disse a Jesus: «A Lei diz-nos que o Messias vai permanecer aqui para sempre. Como podes dizer que é preciso que o Filho do Homem seja levantado? Quem é esse Filho do Homem?»"
,"35":"Jesus respondeu: «A luz ainda estará no meio de vós por um pouco de tempo. Procurai caminhar enquanto tendes a luz, para que as trevas não vos surpreendam. Quem caminha nas trevas não sabe para onde vai."
,"36":"Enquanto tendes a luz, acreditai na luz, para que vos torneis filhos da luz». Depois de dizer isto, Jesus retirou-Se e escondeu-Se deles."
,"37":"Apesar de Jesus ter realizado na presença deles tantos sinais, não acreditaram n'Ele."
,"38":"Assim se cumpriu a palavra dita pelo profeta Isaías: «Senhor, quem acreditou na nossa mensagem? A quem foi revelada a força do Senhor?»"
,"39":"O próprio Isaías mostrou a razão pela qual eles não podiam acreditar:"
,"40":"«Deus cegou-lhes os olhos e endureceu-lhes o coração, para que não vejam com os olhos e não compreendam com o coração, a fim de que não se convertam e Eu tenha que curá-los»."
,"41":"Isaías falou assim, porque viu a glória de Jesus e falou a respeito d'Ele."
,"42":"Entretanto, até mesmo entre os chefes dos judeus houve quem acreditasse em Jesus. Mas, por causa dos fariseus, não se atreviam a confessá-lo em público, para não serem expulsos da sinagoga."
,"43":"É que eles preferiam a glória humana à glória que vem de Deus."
,"44":"Então Jesus, levantando a voz, disse: «Quem acredita em Mim, não é em Mim que acredita, mas n'Aquele que Me enviou."
,"45":"Quem Me vê, vê também Aquele que Me enviou."
,"46":"Eu vim ao mundo como luz, para que todo aquele que acredita em Mim não fique nas trevas."
,"47":"Eu não condeno quem ouve as minhas palavras e não lhes obedece, porque Eu não vim para condenar o mundo, mas para salvar o mundo."
,"48":"Quem Me rejeita e não aceita as minhas palavras já tem o seu juiz: a Palavra que Eu anunciei será o seu juiz no último dia."
,"49":"Porque Eu não falei por Mim mesmo. O Pai que Me enviou, Ele é que Me ordenou o que Eu devia dizer e anunciar."
,"50":"Eu sei que o seu mandamento é a vida eterna. Portanto, o que digo, digo-o conforme o Pai me disse»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Antes da festa da Páscoa, Jesus sabia que tinha chegado a sua hora, a hora de passar deste mundo para o Pai. Ele, que tinha amado os seus que estavam no mundo, amou-os até ao fim."
,"2":"Durante a ceia, o demónio já tinha posto no coração de Judas Iscariotes, filho de Simão, o projecto de trair Jesus."
,"3":"Jesus sabia que o Pai tinha colocado tudo nas suas mãos. Sabia também que tinha saído de junto de Deus e que voltava para Deus."
,"4":"Então Jesus levantou-Se da mesa, tirou o manto, pegou numa toalha e atou-a à cintura."
,"5":"Deitou água numa bacia e começou a lavar os pés aos discípulos e a enxugá-los com a toalha que tinha à cintura."
,"6":"Chegou a vez de Simão Pedro. Este disse: «Senhor, Tu vais lavar-me os pés?»"
,"7":"Jesus respondeu: «O que estou a fazer não o podes compreender agora. Compreendê-lo-ás mais tarde»."
,"8":"Pedro disse: «Tu nunca vais lavar-me os pés!» Jesus respondeu-lhe: «Se te não lavar, não terás parte comigo»."
,"9":"Simão Pedro disse: «Senhor, então podes lavar não só os meus pés, mas até as mãos e a cabeça»."
,"10":"Jesus respondeu-lhe: «Quem já tomou banho só precisa de lavar os pés, porque está todo limpo. Vós também estais limpos, mas nem todos»."
,"11":"Jesus sabia quem O iria trair; por isso é que Ele disse: «Nem todos estais limpos»."
,"12":"Depois de lavar os pés aos discípulos, Jesus vestiu o manto, sentou-Se de novo e perguntou: «Compreendestes o que acabei de fazer?"
,"13":"Vós dizeis que Eu sou o Mestre e o Senhor. E tendes razão, porque o sou."
,"14":"Pois bem: Eu, que sou o Mestre e o Senhor, lavei-vos os pés; por isso vós deveis lavar os pés uns aos outros."
,"15":"Dei-vos o exemplo: vós deveis fazer a mesma coisa que Eu fiz."
,"16":"Garanto-vos: o servo não é maior do que o senhor, nem o mensageiro é maior do que aquele que o enviou."
,"17":"Se compreendestes isto, sereis felizes se o puserdes em prática»."
,"18":"«Eu não falo de todos vós. Eu conheço aqueles que escolhi, mas é preciso que se cumpra o que está na Escritura: 'Aquele que come o pão comigo é o primeiro a trair-me!'"
,"19":"Digo isto agora, antes que aconteça, para que, quando acontecer, acrediteis que Eu Sou."
,"20":"Garanto-vos: quem recebe aquele que Eu envio, recebe-Me a Mim, e quem Me recebe, recebe Aquele que Me enviou»."
,"21":"Depois de dizer estas coisas, Jesus ficou profundamente comovido e disse com toda a clareza: «Garanto-vos que um de vós vai trair-Me»."
,"22":"Desconcertados, os discípulos olhavam uns para os outros, pois não sabiam de quem Jesus falava."
,"23":"Um deles, aquele que Jesus amava, estava à mesa ao lado de Jesus."
,"24":"Simão Pedro fez-lhe um sinal para que ele procurasse saber de quem é que Jesus falava."
,"25":"Então o discípulo inclinou-se sobre o peito de Jesus e perguntou: «Senhor, quem é?»"
,"26":"Jesus respondeu: «É aquele a quem vou dar o pedaço de pão que estou humedecendo no molho». Então Jesus pegou num pedaço de pão, molhou-o e deu-o a Judas Iscariotes, filho de Simão."
,"27":"Nesse momento, depois do pão, Satanás entrou em Judas. Então Jesus disse-lhe: «O que pretendes fazer, fá-lo depressa»."
,"28":"Nenhum dos presentes compreendeu porque é que Jesus lhe disse isto."
,"29":"Como Judas era o responsável pela bolsa comum, alguns discípulos pensaram que Jesus o tinha mandado comprar o necessário para a festa ou dar alguma coisa aos pobres."
,"30":"Judas tomou o pe-daço de pão e saiu imediatamente. Era noite."
,"31":"Depois de Judas Iscariotes ter saí-do, Jesus disse: «Agora o Filho do Homem foi glorificado e também Deus foi glorificado n'Ele."
,"32":"Deus também O há-de glorificar em Si mesmo, e glorificá-l'O-á sem demora."
,"33":"Filhinhos: vou ficar convosco só mais um pouco. Ireis procurar-Me e Eu digo-vos agora o que já disse aos judeus: para onde Eu vou, vós não podeis ir."
,"34":"Dou-vos um mandamento novo: amai-vos uns aos outros. Assim como Eu vos amei, também vós deveis amar-vos uns aos outros."
,"35":"Se tiverdes amor uns para com os outros, todos reconhecerão que sois meus discípulos»."
,"36":"Simão Pedro perguntou: «Senhor, para onde vais?» Jesus respondeu: «Para onde Eu vou, tu não podes seguir-Me. Seguir-Me-ás mais tarde»."
,"37":"Pedro disse: «Senhor, porque não posso seguir-Te agora? Eu daria a minha própria vida por Ti»."
,"38":"Jesus respondeu: «Darias a vida por Mim? Eu te garanto: antes que o galo cante, negar-Me-ás três vezes»."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Jesus continuou dizendo: «Não fique perturbado o vosso coração. Acreditai em Deus e acreditai também em Mim."
,"2":"Existem muitas moradas na casa de meu Pai. Se não fosse assim, Eu ter-vo-lo-ia dito, porque vou preparar-vos um lugar."
,"3":"E quando Eu for e vos tiver preparado um lugar, voltarei e levar-vos-ei comigo, para que onde Eu estiver, vós estejais também."
,"4":"E para onde Eu vou, vós já conheceis o caminho»."
,"5":"Tomé disse a Jesus: «Senhor, não sabemos para onde vais; como podemos conhecer o caminho?»"
,"6":"Jesus respondeu: «Eu sou o Caminho, a Verdade e a Vida. Ninguém vai ao Pai senão por Mim."
,"7":"Se Me conheceis, conhecereis também o meu Pai. Desde agora O conheceis e já O vistes»."
,"8":"Filipe disse a Jesus: «Senhor, mostra-nos o Pai e isso nos basta»."
,"9":"Jesus respondeu: «Há tanto tempo que estou no meio de vós e ainda não Me conheces, Filipe? Quem Me viu, viu o Pai. Como é que dizes: 'Mostra-nos o Pai'?"
,"10":"Não acreditas que Eu estou no Pai e que o Pai está em Mim? As palavras que vos digo, não as digo por Mim mesmo, mas o Pai que permanece em Mim, Ele é que realiza as suas obras."
,"11":"Acreditai em Mim: Eu estou no Pai e o Pai está em Mim. Acreditai nisto, ao menos por causa destas obras."
,"12":"Eu vos garanto: quem acredita em Mim fará as obras que Eu faço, e fará ainda maiores do que estas, porque Eu vou para o Pai."
,"13":"O que pedirdes em meu nome Eu o farei, para que o Pai seja glorificado no Filho."
,"14":"Se pedirdes qualquer coisa em meu Nome, Eu o farei»."
,"15":"«Se Me amais, obedecereis aos meus mandamentos."
,"16":"Então Eu pedirei ao Pai e Ele dar-vos-á outro Advogado, para que permaneça convosco para sempre."
,"17":"Ele é o Espírito da Verdade, que o mundo não pode acolher, porque não O vê, nem O conhece. Vós conhecei-l'O, porque Ele mora convosco e estará convosco."
,"18":"Não vos deixarei órfãos, mas voltarei para vós."
,"19":"Mais um pouco e o mundo não Me verá, mas vós ver-Me-eis, porque Eu vivo, e também vós vivereis."
,"20":"Nesse dia, conhecereis que Eu estou em meu Pai, vós em Mim e Eu em vós."
,"21":"Quem aceita os meus mandamentos e lhes obedece, esse é que Me ama. E quem Me ama será amado por meu Pai. Eu também o amarei e manifestar-Me-ei a ele»."
,"22":"Judas, não o Iscariotes, perguntou: «Senhor, porque vais manifestar-Te a nós e não ao mundo?»"
,"23":"Jesus respondeu: «Se alguém Me ama, guarda a minha palavra e meu Pai o amará. Eu e meu Pai viremos e faremos nele a nossa morada."
,"24":"Quem não Me ama não guarda as minhas palavras. E a palavra que ouvis não é minha, mas é a palavra do Pai que Me enviou."
,"25":"Estas são as coisas que tinha para vos dizer estando ainda convosco."
,"26":"Mas o Advogado, o Espírito Santo, que o Pai vai enviar em meu nome, Ele ensinar-vos-á todas as coisas e vos fará recordar tudo o que Eu vos disse»."
,"27":"«Deixo-vos a paz, dou-vos a minha paz. A paz que vos dou não é a paz que o mundo dá. Não fiqueis perturbados nem tenhais medo."
,"28":"Ouvistes o que vos disse: 'Eu vou, mas voltarei para vós'. Se Me amásseis, alegrar-vos-íeis porque vou para o Pai, pois o Pai é maior do que Eu."
,"29":"Digo-vos isto agora, antes que aconteça, para que, quando acontecer, acrediteis."
,"30":"Já não tenho muito tempo para falar convosco, pois o príncipe deste mundo vai chegar. Ele não tem poder sobre Mim,"
,"31":"mas vem para que o mundo reconheça que amo o Pai, e é por isso que faço tudo o que o Pai Me mandou. Levantai-vos. Vamos sair daqui»."
}`)
	CurrentBook.AddChapter(15, `{
"1":"«Eu sou a verdadeira videira e meu Pai é o agricultor."
,"2":"Todo o ramo que não dá fruto em Mim, o Pai corta-o. Os ramos que dão fruto, poda-os para que dêem mais fruto ainda."
,"3":"Vós já estais limpos por causa da Palavra que vos dirigi."
,"4":"Ficai unidos a Mim e Eu ficarei unido a vós. O ramo que não fica unido à videira não pode dar fruto. Vós também não podereis dar fruto, se não ficardes unidos a Mim."
,"5":"Eu sou a videira e vós os ramos. Quem fica unido a Mim, e Eu a ele, dará muito fruto, porque sem Mim não podeis fazer nada."
,"6":"Quem não fica unido a Mim será lançado fora como um ramo, e secará. Esses ramos são juntados, lançados ao fogo e queimados»."
,"7":"«Se ficardes unidos a Mim e as minhas palavras permanecerem em vós, pedi o que quiserdes e ser-vos-á concedido."
,"8":"A glória de meu Pai manifesta-se quando dais muitos frutos e vos tornais meus discípulos."
,"9":"Assim como meu Pai Me amou, Eu também vos amei: permanecei no meu amor."
,"10":"Se obedeceis aos meus mandamentos, permanecereis no meu amor, assim como Eu obedeci aos mandamentos do meu Pai e permaneço no seu amor."
,"11":"Disse-vos isto para que a minha alegria esteja em vós e a vossa alegria seja completa."
,"12":"O meu mandamento é este: amai-vos uns aos outros como Eu vos amei."
,"13":"Não existe amor maior do que dar a vida pelos amigos."
,"14":"Sereis meus amigos se fizerdes o que vos mando."
,"15":"Não vos chamo empregados, pois o empregado não sabe o que o patrão faz; chamo-vos amigos, porque vos comuniquei tudo o que ouvi a meu Pai."
,"16":"Não fostes vós que Me escolhestes, mas fui Eu que vos escolhi. Eu destinei-vos para irdes e dardes fruto e para que o vosso fruto permaneça. O Pai dar-vos-á tudo o que Lhe pedirdes em meu nome."
,"17":"O que vos mando é que vos ameis uns aos outros»."
,"18":"«Se o mundo vos odiar, sabei que Me odiou primeiro a Mim."
,"19":"Se fôsseis do mundo, o mundo amaria o que é dele. Mas o mundo odiar-vos-á, porque não sois do mundo, pois Eu escolhi-vos e tirei-vos do mundo."
,"20":"Lembrai-vos do que vos disse: nenhum empregado é maior do que o seu patrão. Se Me perseguiram a Mim, perseguir-vos-ão também a vós; se guardardes a minha palavra, guardarão também a vossa palavra."
,"21":"Far-vos-ão tudo isto por causa do meu No-me, pois não reconhecem Aquele que Me enviou."
,"22":"Se Eu não tivesse vindo e não lhes tivesse falado, não seriam culpados de pecado. Mas agora não têm nenhuma desculpa do seu pecado."
,"23":"Quem Me odeia, odeia também o meu Pai."
,"24":"Se Eu não tivesse feito no meio deles obras como nenhum outro fez, não seriam culpados de pecado. Mas eles viram o que Eu fiz e apesar disso odiaram-Me a Mim e a meu Pai."
,"25":"Deste modo realiza-se o que está escrito na Lei deles: 'Odiaram-Me sem motivo'."
,"26":"O Advogado, que vos mandarei de junto do Pai, é o Espírito da Verdade que procede do Pai. Quando vier, dará testemunho de Mim."
,"27":"Vós também dareis testemunho de Mim, porque estais comigo desde o princípio»."
}`)
	CurrentBook.AddChapter(16, `{
"1":"«Disse-vos tudo isto para que vos não acovardeis."
,"2":"Expulsar-vos-ão das sinagogas. E vai chegar a hora em que alguém, ao matar-vos, pensará prestar um serviço a Deus."
,"3":"Eles farão assim porque não conhecem nem o Pai nem a Mim."
,"4":"Disse-vos tudo isto para que, quando chegar a hora, vos lembreis do que Eu disse». «Não vos disse tudo isto, logo no princípio, porque estava convosco. "
,"5":"Mas agora vou para Aquele que Me enviou. E ninguém de vós pergunta para onde Eu vou?"
,"6":"Mas porque vos disse estas coisas, a tristeza encheu o vosso coração."
,"7":"Entretanto, digo-vos a verdade: é melhor para vós que eu Eu vá, porque, se não for, o Advogado não virá a vós. Mas, se Eu for, enviar-vo-l'O-ei."
,"8":"Quando o Advogado vier, Ele vai desmascarar o mundo, mostrando quem é pecador, quem é o Justo e quem é o condenado."
,"9":"Quem é pecador? Aqueles que não acreditaram em Mim."
,"10":"Quem é o Justo? Sou Eu. Mas não Me vereis mais, porque vou para o Pai."
,"11":"Quem é o condenado? É o príncipe deste mundo, que já foi condenado»."
,"12":"«Ainda tenho muitas coisas para vos dizer, mas agora não seríeis capazes de as suportar."
,"13":"Quando vier o Espírito da Verdade, Ele vos encaminhará para toda a verdade, porque o Espírito não falará em seu Nome, mas dirá o que escutou e anunciar-vos-á as coisas que vão acontecer."
,"14":"O Espírito da Verdade manifestará a minha glória porque vai receber daquilo que é meu e vo-lo interpretará."
,"15":"Tudo o que pertence ao Pai também é meu. Por isso é que Eu disse: o Espírito vai receber daquilo que é meu e vo-lo interpretará."
,"16":"Daqui a pouco não Me vereis mais; porém, mais um pouco, e tornareis a ver-Me»."
,"17":"Alguns discípulos comentaram: «O que é que Ele quer dizer com isto: 'Daqui a pouco não Me vereis mais, porém, mais um pouco, e tornareis a ver-Me'? E ainda: 'Eu vou para o Pai'?»"
,"18":"E diziam: «Que significa este 'um pouco'? Não compreendemos o que Ele quer dizer»."
,"19":"Jesus percebeu que eles queriam fazer-Lhe perguntas. E disse: «Discutis por Eu ter dito: 'Daqui a pouco não Me vereis mais, porém, mais um pouco, e tornareis a ver-Me'?"
,"20":"Eu garanto-vos: ides gemer e lamentar-vos, enquanto o mundo vai alegrar-se. Ficareis angustiados, mas a vossa angústia transformar-se-á em alegria."
,"21":"Quando a mulher está para dar à luz, sente angústia, porque chegou a sua hora. Mas quando a criança nasce, já nem se lembra da aflição, porque fica alegre por ter posto um homem no mundo."
,"22":"Agora também vós estais angustiados. Mas, quando tornardes a ver-Me, ficareis alegres, e essa alegria ninguém vo-la tirará."
,"23":"Nesse dia não Me fareis perguntas. Garanto-vos: se pedirdes alguma coisa a meu Pai em meu Nome, Ele vo-la concederá."
,"24":"Até agora não pedistes nada em meu Nome: pedi e recebereis, para que a vossa alegria seja completa»."
,"25":"«Até agora falei-vos através de comparações. Vai chegar a hora em que não falarei através de comparações, mas vos falarei claramente a respeito do Pai."
,"26":"Nesse dia pedireis em meu nome e não será necessário que vos recomende ao Pai,"
,"27":"pois o próprio Pai vos ama, porque Me amastes e acreditastes que saí de junto de Deus."
,"28":"Eu saí de junto do Pai e vim ao mundo; agora deixo o mundo e volto para o Pai»."
,"29":"Os discípulos disseram: «Agora falas claramente e sem comparações."
,"30":"Agora sabemos que sabes todas as coisas e que é inútil alguém fazer-Te perguntas. Agora sim, acreditamos que saíste de junto de Deus»."
,"31":"Jesus disse: «Agora acreditais em Mim?"
,"32":"Aproxima-se a hora, e já chegou, em que vos dispersareis, cada um para seu lado, e Me deixareis sozinho. Mas Eu não estou sozinho, pois o Pai está comigo."
,"33":"Disse-vos estas coisas para que tenhais a minha paz. Neste mundo tereis aflições, mas tende coragem: Eu venci o mundo»."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Depois de dizer estas coisas, Jesus ergueu os olhos ao céu e disse: «Pai, chegou a hora. Glorifica o teu Filho, para que o Filho Te glorifique a Ti,"
,"2":"pois Lhe deste poder sobre todos os homens, para que Ele dê a vida eterna a todos aqueles que Lhe deste."
,"3":"Ora a vida eterna é esta: que Te conheçam a Ti, o único Deus verdadeiro, e Aquele que enviaste, Jesus Cristo."
,"4":"Eu glorifiquei-Te na Terra, completei a obra que Me deste a fazer."
,"5":"E agora, Pai, glorifica-Me junto de Ti, com a glória que Eu tinha junto de Ti antes que o mundo existisse»."
,"6":"«Eu manifestei o teu Nome aos homens que Me deste do meio do mundo. Eles eram teus e Tu Mos deste, e eles guardaram a tua palavra."
,"7":"Agora eles conhecem que tudo o que Me deste provém de Ti,"
,"8":"e que as palavras que lhes dei são aquelas que Me deste. Eles receberam-nas e conheceram verdadeiramente que saí de junto de Ti e acreditaram que Me enviaste."
,"9":"Eu peço por eles. Não peço pelo mundo, mas por aqueles que Me deste, porque são teus."
,"10":"E tudo o que é meu é teu, e tudo o que é teu é meu, e assim sou glorificado neles."
,"11":"Já não estou no mundo. Eles permanecem no mundo, enquanto Eu vou para junto de Ti. Pai santo, guarda-os em teu Nome, o Nome que Me deste, para que eles sejam um, assim como Nós somos um. "
,"12":"Quando estava com eles, guardava-os em teu Nome, o Nome que Me deste. Protegi-os e nenhum deles se perdeu, a não ser o filho da perdição, para que se cumprisse a Escritura."
,"13":"Agora vou para junto de Ti. Entretanto, continuo a dizer estas coisas neste mundo, para que eles possuam toda a minha alegria."
,"14":"Dei-lhes a tua Palavra e o mundo odiou-os, porque não pertencem ao mundo, como Eu não pertenço ao mundo."
,"15":"Não Te peço que os tires do mundo, mas que os guardes do Maligno."
,"16":"Eles não pertencem ao mundo, como Eu não pertenço ao mundo."
,"17":"Consagra-os na verdade: a verdade é a tua Palavra."
,"18":"Assim como Tu Me enviaste ao mundo, Eu também os envio ao mundo."
,"19":"Eu consagro-Me por eles, a fim de que também eles sejam consagrados na verdade»."
,"20":"«Eu não Te peço só por estes, mas também por aqueles que vão acreditar em Mim por causa da sua palavra,"
,"21":"para que todos sejam um, como Tu, Pai, estás em Mim e Eu em Ti. E para que também eles estejam em Nós, a fim de que o mundo acredite que Tu Me enviaste."
,"22":"Eu mesmo lhes dei a glória que Tu Me deste, para que eles sejam um, como Nós somos um."
,"23":"Eu neles e Tu em Mim, para que sejam perfeitos na unidade e para que o mundo reconheça que Tu Me enviaste e que os amaste, como Me amaste a Mim."
,"24":"Pai, aqueles que Tu Me deste, quero que eles estejam comigo, onde Eu estiver, para que eles contemplem a glória que Me deste, pois Me amaste antes da criação do mundo."
,"25":"Pai justo, o mundo não Te reconheceu, mas Eu reconheci-Te. Estes também reconheceram que Me enviaste."
,"26":"Tornei-lhes conhecido o teu Nome. E continuarei a torná-lo conhecido, para que o amor com que Me amaste esteja neles e Eu mesmo esteja neles»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Tendo dito isto, Jesus saiu com os seus discípulos e foi para o outro lado da torrente do Cédron, onde havia um jardim. Entrou no jardim com os discípulos."
,"2":"Jesus já Se tinha reunido ali muitas vezes com os seus discípulos. Por isso, Judas, que ia trair Jesus, também conhecia o lugar."
,"3":"Judas, com soldados e alguns guardas dos sumos sacerdotes e fariseus, chegou ao jardim com lanternas, tochas e armas."
,"4":"Então Jesus, sabendo tudo o que Lhe ia acontecer, saiu e perguntou-lhes: «Quem procurais?»"
,"5":"Eles responderam: «Jesus de Nazaré». Jesus disse: «Sou Eu». Judas, que O ia trair, também estava com eles."
,"6":"Quando Jesus disse: «Sou Eu», eles recuaram e caíram no chão."
,"7":"Então Jesus perguntou de novo: «Quem procurais?» Eles responderam: «Jesus de Nazaré»."
,"8":"Jesus respondeu: «Já vos disse que sou Eu. Se Me procurais, deixai partir estes»."
,"9":"Era para se cumprir a Escritura que diz: «Não perdi nenhum daqueles que Me deste»."
,"10":"Simão Pedro tinha uma espada. Desembainhou-a e feriu um empregado do sumo sacerdote, decepando-lhe a orelha direita. O nome do empregado era Malco."
,"11":"Mas Jesus disse a Pedro: «Guarda a espada na bainha. Não beberei o cálice que o Pai Me deu?»"
,"12":"Então os soldados, o comandante e os guardas das autoridades dos judeus prenderam e amarraram Jesus."
,"13":"A primeira coisa que fizeram foi levar Jesus até Anás, que era sogro de Caifás, sumo sacerdote naquele ano."
,"14":"Caifás é aquele que tinha dado um conselho aos judeus: «É preciso que um homem morra pelo povo»."
,"15":"Simão Pedro e o outro discípulo seguiam Jesus. Esse discípulo era conhecido do sumo sacerdote e entrou com Jesus no pátio do sumo sacerdote."
,"16":"Mas Pedro ficou fora, perto da porta. Então o outro discípulo, que era conhecido do sumo sacerdote, saiu, conversou com a porteira e levou Pedro para dentro."
,"17":"A empregada, que tomava conta da porta, perguntou a Pedro: «Tu não és também um dos discípulos desse homem?» Pedro disse: «Eu não»."
,"18":"Os empregados e os guardas tinham acendido uma fogueira para se aquecerem, porque estava frio. Pedro estava com eles a aquecer-se."
,"19":"Então o sumo sacerdote interrogou Jesus a respeito dos seus discípulos e do seu ensinamento."
,"20":"E Jesus respondeu: «Eu falei abertamente ao mundo. Eu sempre ensinei nas sinagogas e no Templo, onde todos os judeus se reúnem. Não disse nada em segredo."
,"21":"Porque Me interrogas? Pergunta aos que ouviram o que Eu lhes disse. Eles sabem o que Eu disse»."
,"22":"Quando Jesus disse isto, um dos guardas que ali estava deu uma bofetada em Jesus e disse: «É assim que respondes ao sumo sacerdote?»"
,"23":"Jesus respondeu: «Se falei mal, mostra o que há de mal. Mas se falei bem, porque Me bates?»"
,"24":"Então Anás mandou Jesus, amarrado, ao sumo sacerdote Caifás."
,"25":"Simão Pedro ainda estava lá fora a aquecer-se. Perguntaram-lhe: «Tu não és também um dos discípulos d'Ele?» Pedro negou: «Eu não»."
,"26":"Então um dos empregados do sumo sacerdote, parente daquele a quem Pedro tinha decepado a orelha, disse: «Então eu não te vi no jardim com Ele?»"
,"27":"Pedro negou de novo. E, na mesma hora, o galo cantou."
,"28":"De Caifás levaram Jesus para o palácio do governador. Era de manhã. Mas eles não entraram no palácio, pois não queriam ficar impuros, para poderem comer a ceia pascal."
,"29":"Então Pilatos veio cá fora e conversou com eles: «Que acusação apresentais contra este homem?»"
,"30":"Eles responderam: «Se Ele não fosse malfeitor, não O teríamos trazido até aqui»."
,"31":"Pilatos disse: «Encarregai-vos vós mesmos de O julgar segundo a vossa Lei». Os judeus responderam: «Não temos permissão de condenar ninguém à morte»."
,"32":"Era para se cumprir o que Jesus tinha dito, significando o género de morte com que Ele deveria morrer."
,"33":"Então Pilatos entrou de novo no palácio. Chamou Jesus e perguntou-Lhe: «Tu és o rei dos judeus?»"
,"34":"Jesus respondeu: «Dizes isso por ti mesmo, ou foram outros que to disseram a meu respeito?»"
,"35":"Pilatos respondeu: «Acaso sou eu judeu? O teu povo e os sumos sacerdotes é que Te entregaram a mim. Que fizeste?»"
,"36":"Jesus respondeu: «O meu reino não é deste mundo. Se o meu reino fosse deste mundo, os meus guardas lutariam para que Eu não fosse entregue às autoridades dos judeus. Mas agora o meu reino não é daqui»."
,"37":"Pilatos disse a Jesus: «Então Tu és rei?» Jesus respondeu: «Tu estás a dizer que Eu sou rei. Eu nasci e vim ao mundo para dar testemunho da verdade. Todo aquele que está com a verdade ouve a minha voz»."
,"38":"Pilatos disse: «O que é a verdade?»,Ao dizer isto, Pilatos saiu ao encontro das autoridades dos judeus e disse-lhes: «Eu não encontro n'Ele nenhum motivo de condenação. "
,"39":"Contudo, existe um costume entre vós: que vos solte alguém na Páscoa. Quereis que vos solte o rei dos judeus?»"
,"40":"Então eles começaram a gritar de novo: «Ele não. Solta Barrabás». Barrabás era um salteador."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Então Pilatos tomou Jesus e mandou-O flagelar."
,"2":"Os soldados entrançaram uma coroa com espinhos e colocaram-na na cabeça de Jesus. Vestiram Jesus com um manto vermelho."
,"3":"Aproximavam-se d'Ele e diziam: «Salve, rei dos judeus!» E davam-Lhe bofetadas."
,"4":"Pilatos saiu de novo e disse: «Vede. Eu vou mandar trazer aqui fora o Homem, para que saibais que não encontro nenhuma culpa n'Ele»."
,"5":"Então Jesus saiu. Trazia a coroa de espinhos e o manto vermelho. Pilatos disse-lhes: «Eis o Homem!»"
,"6":"Vendo Jesus, os sumos sacerdotes e os guardas começaram a gritar: «Crucifica-O! Crucifica-O!» Pilatos disse-lhes: «Encarregai-vos vós mesmos de O crucificar, pois eu não encontro nenhum crime n'Ele»."
,"7":"Os judeus responderam: «Nós temos uma Lei, e segundo a Lei Ele deve morrer, porque Se fez Filho de Deus»."
,"8":"Quando ouviu estas palavras, Pilatos ficou com mais medo ainda."
,"9":"Pilatos entrou outra vez no palácio e perguntou a Jesus: «De onde és Tu?» Jesus ficou calado."
,"10":"Então Pilatos perguntou: «Não me respondes? Não sabes que tenho autoridade para Te soltar e autoridade para Te crucificar?»"
,"11":"Jesus respondeu: «Não terias nenhuma autoridade sobre Mim se ela não te fosse dada por Deus. Por isso, aquele que Me entregou a ti tem pecado maior»."
,"12":"Por causa disso, Pilatos esforçava-se por soltar Jesus. Mas os judeus gritavam: «Se soltas esse homem, não és amigo de César. Todo aquele que pretende ser rei coloca-se contra César». "
,"13":"Ouvindo estas palavras, Pilatos levou Jesus para fora. Fez com que Jesus Se sentasse numa cadeira de juiz, no lugar chamado «Pavimento», que em hebraico se diz «Gábata»."
,"14":"Era véspera da Páscoa, por volta do meio-dia. Pilatos disse aos judeus: «Aqui está o vosso rei»."
,"15":"Eles começaram a gritar: «Fora! Fora! Crucifica-O!» Pilatos perguntou: «Hei-de crucificar o vosso rei?» Os sumos sacerdotes responderam: «Não temos outro rei além de César»."
,"16":"Então, finalmente, Pilatos entregou-lhes Jesus para que fosse crucificado. Eles levaram Jesus. "
,"17":"Jesus, levando a cruz às costas, saiu para um lugar chamado «Lugar da Caveira», que em hebraico se diz «Gólgota»."
,"18":"E ali crucificaram Jesus com outros dois homens, um de cada lado, e Jesus no meio."
,"19":"Pilatos mandou também escrever um letreiro e colocou-o na cruz. Estava escrito: JESUS NAZARENO, O REI DOS JUDEUS."
,"20":"Muitos judeus puderam ver o letreiro, porque o lugar em que Jesus foi crucificado ficava perto da cidade. O letreiro estava escrito em hebraico, latim e grego."
,"21":"Então os sumos sacerdotes dos judeus disseram a Pilatos: «Não deixes escrito: 'O Rei dos judeus', mas coloca: 'Este homem disse: Eu sou o rei dos judeus'»."
,"22":"Mas Pilatos respondeu: «O que escrevi, está escrito»."
,"23":"Quando crucificaram Jesus, os soldados repartiram as suas vestes em quatro partes, uma parte para cada soldado. Deixaram de lado a túnica. Era uma túnica sem costura, feita de uma peça única, de alto a baixo."
,"24":"Então eles combinaram: «Não vamos repartir a túnica. Vamos deitar sortes, para ver com quem fica». Isto era para se cumprir a Escritura que diz: «Repartiram as minhas vestes e sortearam a minha túnica». E foi assim que os soldados fizeram."
,"25":"A Mãe de Jesus, a irmã de sua Mãe, Maria de Cléofas, e Maria Madalena estavam junto à cruz."
,"26":"Jesus viu sua Mãe e, ao lado d'Ela, o discípulo que Ele amava. Então disse a sua Mãe: «Mulher, eis aí o teu filho»."
,"27":"Depois disse ao discípulo: «Eis aí a tua Mãe». E, dessa hora em diante, o discípulo recebeu-A em sua casa."
,"28":"Depois disto, sabendo que tudo estava realizado, para que se cumprisse a Escritura, Jesus disse: «Tenho sede»."
,"29":"Havia ali uma jarra cheia de vinagre. Amarraram uma esponja ensopada de vinagre a uma vara e aproximaram a esponja da boca de Jesus."
,"30":"Ele tomou o vinagre e disse: «Tudo está realizado». E, inclinando a cabeça, entregou o espírito."
,"31":"Era dia de preparativos para a Páscoa. Os judeus queriam evitar que os corpos ficassem na cruz durante o sábado, porque esse sábado era muito solene para eles. Então pediram a Pilatos que mandasse quebrar as pernas aos crucificados e os tirasse da cruz."
,"32":"Os soldados foram e quebraram as pernas de um e depois do outro, que estavam crucificados com Jesus."
,"33":"E aproximaram-se de Jesus. Vendo que já estava morto não Lhe quebraram as pernas,"
,"34":"mas um soldado atravessou-Lhe o lado com uma lança, e imediatamente saiu sangue e água."
,"35":"E aquele que viu dá testemunho, e o seu testemunho é verdadeiro. E ele sabe que diz a verdade, para que também vós acrediteis."
,"36":"Isto aconteceu para se cumprir a Escritura que diz: «Não Lhe quebraram nenhum osso»."
,"37":"E outra passagem que diz: «Olharão para Aquele que trespassaram»."
,"38":"José de Arimateia era discípulo de Jesus, mas às escondidas, porque tinha medo das autoridades dos judeus. Depois disto, ele foi pedir a Pilatos para retirar o corpo de Jesus. Pilatos deu-lhe autorização. Então ele foi e retirou o corpo de Jesus."
,"39":"Nicodemos também foi. Nicodemos era aquele que antes tinha ido de noite encontrar-se com Jesus. Levou mais de trinta quilos de uma mistura de mirra e resina perfumada."
,"40":"Então tomaram o corpo de Jesus e envolveram-n'O com panos de linho e perfumes, como os judeus costumam sepultar."
,"41":"No lugar onde Jesus fora crucificado havia um jardim, onde estava um túmulo, em que ninguém ainda tinha sido sepultado."
,"42":"Então, por causa do dia de preparativos para a Páscoa e porque o túmulo estava perto, colocaram lá Jesus."
}`)
	CurrentBook.AddChapter(20, `{
"1":"No primeiro dia da semana, Maria Madalena foi ao túmulo de Jesus bem de madrugada, quando ainda estava escuro. Ela viu que a pedra tinha sido retirada do túmulo."
,"2":"Então saiu a correr e foi ter com Simão Pedro e o outro discípulo que Jesus amava. E disse-lhes: «Tiraram do túmulo o Senhor e não sabemos onde O colocaram»."
,"3":"Então Pedro e o outro discípulo saíram e foram ao túmulo."
,"4":"Os dois corriam juntos. Mas o outro discípulo correu mais depressa do que Pedro e chegou primeiro ao túmulo."
,"5":"Inclinando-se, viu os panos de linho no chão, mas não entrou."
,"6":"Então Pedro, que vinha atrás, chegou também e entrou no túmulo. Viu os panos de linho estendidos no chão"
,"7":"e o sudário que tinha sido usado para cobrir a cabeça de Jesus. Mas o sudário não estava, com os panos de linho, no chão; estava enrolado num lugar à parte."
,"8":"Então o outro discípulo, que tinha chegado primeiro ao túmulo, entrou também. Ele viu e acreditou."
,"9":"De facto, ainda não tinham compreendido a Escritura que diz: «Ele deve ressuscitar dos mortos»."
,"10":"Os discípulos, então, voltaram para casa."
,"11":"Maria tinha ficado fora, a chorar junto ao túmulo. Enquanto ainda chorava, inclinou-se e olhou para dentro do túmulo."
,"12":"Viu então dois anjos vestidos de branco, sentados onde o corpo de Jesus tinha sido colocado, um à cabeceira e outro aos pés."
,"13":"Então os anjos perguntaram: «Mulher, porque choras?» Ela respondeu: «Porque levaram o meu Senhor e não sei onde O colocaram»."
,"14":"Depois de dizer isto, Maria virou-se e viu Jesus de pé; mas não sabia que era Jesus."
,"15":"E Jesus perguntou: «Mulher, porque choras? Quem procuras?» Maria pensou que fosse o jardineiro e disse: «Se foste tu que O levaste, diz-me onde O puseste para eu ir buscá-l'O»."
,"16":"Então Jesus disse: «Maria». Ela virou-se e exclamou em hebraico: «Rabuni!» (que quer dizer: Mestre)."
,"17":"Jesus disse: «Não Me segures, porque ainda não voltei para o Pai. Mas vai dizer aos meus irmãos: 'Subo para junto de meu Pai, que é vosso Pai, de meu Deus, que é o vosso Deus'»."
,"18":"Então Maria Madalena foi e anunciou aos discípulos: «Eu vi o Senhor». E contou o que Jesus tinha dito."
,"19":"Era o primeiro dia da semana. Ao anoitecer desse dia, estando fechadas as portas do lugar onde se achavam os discípulos por medo das autoridades dos judeus, Jesus entrou. Ficou no meio deles e disse: «A paz esteja convosco»."
,"20":"Dizendo isto, mostrou-lhes as mãos e o lado. Então os discípulos ficaram contentes por ver o Senhor."
,"21":"Jesus disse-lhes novamente: «A paz esteja convosco. Assim como o Pai Me enviou, também Eu vos envio a vós»."
,"22":"E, tendo dito isto, Jesus soprou sobre eles, dizendo: «Recebei o Espírito Santo."
,"23":"Os pecados daqueles a quem perdoardes serão perdoados. Os pecados daqueles a quem não perdoardes não serão perdoados»."
,"24":"Tomé, chamado Gémeo, que era um dos Doze, não estava com eles quando Jesus veio."
,"25":"Os outros discípulos disseram-lhe: «Nós vimos o Senhor». Tomé disse: «Se não vir a marca dos pregos nas mãos de Jesus, se não colocar o meu dedo na marca dos pregos e se não meter a mão no seu lado, não acreditarei»."
,"26":"Uma semana depois, os discípulos estavam outra vez reunidos. Desta vez, Tomé estava com eles. Estando fechadas as portas, Jesus entrou. Ficou no meio deles e disse: «A paz esteja convosco»."
,"27":"Depois disse a Tomé: «Chega aqui o teu dedo e vê as minhas mãos. Estende a tua mão e mete-a no meu lado. Não sejas incrédulo, mas crente»."
,"28":"Tomé respondeu a Jesus: «Meu Senhor e meu Deus!»"
,"29":"Jesus disse: «Acreditaste porque viste. Felizes os que acreditam sem terem visto»."
,"30":"Jesus realizou diante dos discípulos muitos outros sinais que não estão escritos neste livro."
,"31":"Estes sinais foram escritos para que acrediteis que Jesus é o Messias, o Filho de Deus. E para que, acreditando, tenhais a vida em seu Nome."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Jesus apareceu aos discípulos na margem do mar de Tiberíades. E apareceu deste modo:"
,"2":"Estavam juntos Simão Pedro, Tomé, chamado Gémeo, Natanael de Caná da Galileia, os filhos de Zebedeu e outros dois discípulos de Jesus."
,"3":"Simão Pedro disse: «Eu vou pescar». Eles disseram: «Nós também vamos». Saíram e entraram na barca. Mas naquela noite não pescaram nada."
,"4":"Quando amanheceu, Jesus estava na margem. Mas os discípulos não sabiam que era Jesus."
,"5":"Então Jesus disse: «Rapazes, tendes alguma coisa para comer?» Eles responderam: «Não»."
,"6":"Então Jesus disse: «Lançai a rede para o lado direito da barca e achareis peixe». Eles lançaram a rede e não conseguiam puxá-la para fora, devido à grande quantidade de peixe que apanharam."
,"7":"Então o discípulo que Jesus amava disse a Pedro: «É o Senhor». Simão Pedro, ouvindo dizer que era o Senhor, vestiu a roupa, pois estava nu, e lançou-se ao mar."
,"8":"Os outros discípulos, que estavam a uns cem metros da margem, foram na barca e puxaram a rede com os peixes."
,"9":"Logo que saltaram para terra, viram um peixe nas brasas e pão."
,"10":"Jesus disse: «Trazei alguns dos peixes que acabais de pescar»."
,"11":"Então Simão Pedro subiu para a barca e arrastou a rede para a praia. Estava cheia de cento e cinquenta e três peixes grandes. Apesar de tantos peixes, a rede não rebentou."
,"12":"Jesus disse-lhes: «Vinde comer». Nenhum dos discípulos se atrevia a perguntar-Lhe quem era, pois sabiam que era o Senhor."
,"13":"Jesus aproximou-Se, tomou o pão e distribuiu-lho. Fez a mesma coisa com o peixe."
,"14":"Esta foi a terceira vez que Jesus, ressuscitado dos mortos, apareceu aos discípulos."
,"15":"Depois de comerem, Jesus perguntou a Simão Pedro: «Simão, filho de João, amas-Me mais do que estes?» Pedro respondeu: «Sim, Senhor, Tu sabes que Te amo». Jesus disse: «Cuida dos meus cordeiros»."
,"16":"Jesus perguntou de novo a Pedro: «Simão, filho de João, tu amas-Me?» Pedro respondeu: «Sim, Senhor, Tu sabes que Te amo». Jesus disse: «Toma conta das minhas ovelhas»."
,"17":"Pela terceira vez Jesus perguntou a Pedro: «Simão, filho de João, tu amas-Me?» Então Pedro ficou triste, porque Jesus perguntou três vezes se ele O amava. Disse a Jesus: «Senhor, Tu conheces tudo e sabes que Te amo». Jesus disse: «Cuida das minhas ovelhas."
,"18":"Eu te garanto: quando eras mais novo, punhas o cinto e ias para onde querias. Quando fores mais velho, estenderás as mãos e outro te apertará o cinto e te levará para onde não queres ir»."
,"19":"Jesus disse isto aludindo ao tipo de morte com que Pedro iria glorificar a Deus. E Jesus acrescentou: «Segue-Me»."
,"20":"Pedro virou-se e viu atrás de si aquele outro discípulo que Jesus amava, o mesmo que estivera bem perto de Jesus durante a ceia e que havia perguntado: «Senhor, quem é que Te vai trair?»"
,"21":"Quando Pedro viu aquele discípulo, perguntou a Jesus: «Senhor, o que lhe vai acontecer a ele?»"
,"22":"Jesus respondeu: «Se Eu quero que ele viva até que Eu venha, o que é que tens com isso? Quanto a ti, segue-Me»."
,"23":"Então correu a notícia entre os irmãos de que aquele discípulo não iria morrer. Porém Jesus não disse que ele não ia morrer, mas disse: «Se Eu quero que ele viva até que Eu venha, o que é que tens com isso?»."
,"24":"Este é o discípulo que dá testemunho destas coisas e as escreveu. E nós sabemos que o seu testemunho é verdadeiro."
,"25":"Jesus fez ainda muitas outras coisas. Se fossem escritas uma por uma, penso que os livros que seriam escritos não caberiam no mundo."
}`)

}
func PT_BS_LoadNELCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Muitas pessoas já tentaram escrever a história dos acontecimentos que se passaram entre nós."
,"2":"Elas começaram do que nos foi transmitido por aqueles que, desde o princípio, foram testemunhas oculares e ministros da Palavra."
,"3":"Assim, após fazer um estudo cuidadoso de tudo o que aconteceu desde o princípio, também eu decidi escrever uma narração bem ordenada, excelentíssimo Teófilo."
,"4":"Deste modo, poderás verificar a solidez dos ensinamentos que recebeste."
,"5":"No tempo de Herodes, rei da Judeia, havia um sacerdote chamado Zacarias. Era do grupo de Abias. Sua esposa chamava-se Isabel e era descendente de Aarão."
,"6":"Os dois eram justos diante de Deus: obedeciam fielmente a todos os mandamentos e ordens do Senhor."
,"7":"Não tinham filhos, porque Isabel era estéril, e os dois já eram de idade avançada."
,"8":"Certa ocasião, Zacarias fazia o serviço religioso no Templo, pois era a vez do seu grupo realizar as cerimónias."
,"9":"Conforme o costume do serviço sacerdotal, no sorteio coube-lhe entrar no Santuário e fazer a oferta do incenso."
,"10":"Na hora do incenso, toda a assembleia do povo estava a rezar no lado de fora."
,"11":"Então apareceu a Zacarias um anjo do Senhor. Estava de pé, à direita do altar do incenso."
,"12":"Ao vê-lo, Zacarias ficou perturbado e cheio de medo."
,"13":"Mas o anjo disse: «Não tenhas medo, Zacarias! Deus ouviu o teu pedido; a tua esposa Isabel vai ter um filho, e dar-lhe-ás o nome de João."
,"14":"Ficarás alegre e feliz, e muita gente se alegrará com o nascimento do menino,"
,"15":"porque vai ser grande diante do Senhor. Não beberá vinho nem bebida fermentada e, desde o ventre materno, ficará cheio do Espírito Santo."
,"16":"Ele reconduzirá muitos do povo de Israel ao Senhor seu Deus."
,"17":"Caminhará à frente deles, com o espírito e o poder de Elias, a fim de converter os corações dos pais aos filhos e os rebeldes à sabedoria dos justos, preparando para o Senhor um povo bem disposto»."
,"18":"Zacarias perguntou ao anjo: «Como vou saber se isto é verdade? Sou velho e a minha mulher é de idade avançada»."
,"19":"O anjo respondeu: «Eu sou Gabriel. Estou sempre na presença de Deus, e Ele mandou-me dar-te esta boa notícia."
,"20":"Vais ficar mudo e não poderás falar, até ao dia em que estas coisas acontecerem, porque não acreditaste nas minhas palavras que se cumprirão na altura própria»."
,"21":"O povo aguardava Zacarias e estava admirado com a sua demora no Santuário."
,"22":"Quando saiu, não podia falar, e compreenderam que ele tinha tido uma visão no Santuário. Zacarias falava com sinais e continuava mudo."
,"23":"Depois de terminar os seus dias de serviço no Santuário, Zacarias voltou para casa."
,"24":"Algum tempo depois, sua esposa Isabel ficou grávida, e escondeu-se durante cinco meses."
,"25":"Ela dizia: «Eis o que o Senhor fez por mim, nos dias em que Ele Se dignou tirar-me da humilhação pública!»."
,"26":"No sexto mês, o anjo Gabriel foi enviado por Deus a uma cidade da Galileia chamada Nazaré."
,"27":"Foi a uma virgem, prometida em casamento a um homem chamado José, que era descendente de David. E o nome da virgem era Maria."
,"28":"O anjo entrou onde Ela estava, e disse: «Alegra-Te, cheia de graça! O Senhor está contigo!»"
,"29":"Ouvindo isto, Maria ficou preocupada e perguntava a Si mesma o que a saudação queria dizer."
,"30":"O anjo disse: «Não tenhas medo, Maria, porque encontraste graça diante de Deus."
,"31":"Eis que vais ficar grávida, terás um Filho e dar-Lhe-ás o nome de Jesus."
,"32":"Ele será grande e será chamado Filho do Altíssimo. E o Senhor dar-Lhe-á o trono de seu pai David,"
,"33":"e Ele reinará para sempre sobre os descendentes de Jacob. E o seu reino não terá fim»."
,"34":"Maria perguntou ao anjo: «Como vai acontecer isso, se não vivo com nenhum homem?»"
,"35":"O anjo respondeu: «O Espírito Santo virá sobre Ti e o poder do Altíssimo Te cobrirá com a sua sombra. Por isso, o Santo que vai nascer de Ti será chamado Filho de Deus."
,"36":"Também a tua parenta Isabel, apesar da sua velhice, concebeu um filho. Aquela que era considerada estéril já há seis meses que está grávida."
,"37":"Para Deus nada é impossível»."
,"38":"Maria disse: «Eis a escrava do Senhor. Faça-se em mim segundo a tua palavra».E o anjo deixou-A."
,"39":"Naqueles dias, Maria partiu para a região montanhosa, dirigindo-Se, à pressa, a uma cidade da Judeia."
,"40":"Entrou na casa de Zacarias e saudou Isabel."
,"41":"Quando Isabel ouviu a saudação de Maria, a criança agitou-se no seu ventre e Isabel ficou cheia do Espírito Santo."
,"42":"Com um grande grito, exclamou: «Bendita és Tu entre as mulheres e bendito é o fruto do teu ventre!"
,"43":"Como posso merecer que a Mãe do meu Senhor me venha visitar?"
,"44":"Logo que a tua saudação chegou aos meus ouvidos, a criança saltou de alegria no meu ventre."
,"45":"Bem-aventurada Aquela que acreditou, porque vai acontecer o que o Senhor Lhe prometeu»."
,"46":"Então Maria disse: «A minha alma proclama a grandeza do Senhor,"
,"47":"e o meu espírito se alegra em Deus, meu Salvador,"
,"48":"porque olhou para a humilhação,da sua serva. Doravante todas as gerações,me felicitarão,"
,"49":"porque o Todo-poderoso realizou,grandes obras em meu favor: o seu Nome é santo,"
,"50":"a sua misericórdia chega,aos que O temem, de geração em geração."
,"51":"Ele realiza proezas com o seu braço: dispersa os soberbos de coração,"
,"52":"derruba do trono os poderosos,e eleva os humildes;"
,"53":"aos famintos enche-os de bens, e despede os ricos de mãos vazias."
,"54":"Socorre Israel, seu servo, lembrando-Se da sua misericórdia,"
,"55":"- conforme prometera,aos nossos pais -,em favor de Abraão,e da sua descendência, para sempre»."
,"56":"Maria ficou três meses com Isabel; e depois voltou para casa."
,"57":"Terminou para Isabel o tempo de gravidez e ela deu à luz um filho."
,"58":"Os vizinhos e parentes ouviram dizer como o Senhor tinha sido bom para Isabel e alegraram-se com ela."
,"59":"No oitavo dia, foram circuncidar o menino e queriam dar-lhe o nome de seu pai, Zacarias."
,"60":"A mãe, porém, disse: «Não! Ele vai chamar-se João»."
,"61":"Os outros disseram: «Não tens nenhum parente com esse nome!»"
,"62":"Então fizeram sinais ao pai, perguntando como queria que o menino se chamasse."
,"63":"Zacarias pediu uma tabuinha e escreveu: «O nome dele é João».E todos ficaram admirados."
,"64":"No mesmo instante, a boca de Zacarias abriu-se, a sua língua soltou-se e começou a louvar a Deus."
,"65":"Todos os vizinhos ficaram com medo, e a notícia espalhou-se por toda a região montanhosa da Judeia."
,"66":"E todos os que ouviram a notícia ficavam a pensar: «O que irá ser este menino?» De facto, a mão do Senhor estava com ele."
,"67":"O pai Zacarias, cheio do Espírito Santo, profetizou, dizendo:"
,"68":"«Bendito seja o Senhor, Deus de Israel, porque visitou e redimiu o seu povo."
,"69":"Fez aparecer uma força de salvação,na casa de David, seu servo;"
,"70":"conforme tinha sido anunciado,desde outrora,pela boca dos seus santos profetas."
,"71":"É a salvação que nos livra,dos nossos inimigos,e da mão de todos os que nos odeiam."
,"72":"Ele realizou a misericórdia,que teve com os nossos pais, recordando a sua santa aliança,"
,"73":"e o juramento que fez,ao nosso pai Abraão."
,"74":"Para nos conceder que, livres do medo,e arrancados das mãos dos inimigos, nós O sirvamos"
,"75":"com santidade e justiça, na sua presença, todos os nossos dias."
,"76":"E tu, menino, serás chamado profeta,do Altíssimo, porque irás à frente do Senhor, para Lhe preparar os caminhos,"
,"77":"anunciando ao seu povo a salvação, o perdão dos pecados."
,"78":"Graças ao misericordioso coração,do nosso Deus, o sol que nasce do alto nos visitará,"
,"79":"para iluminar os que vivem nas trevas,e na sombra da morte; para guiar os nossos passos,no caminho da paz»."
,"80":"O menino ia crescendo e ficando forte de espírito. João viveu no deserto até ao dia em que se manifestou a Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Naqueles dias, o imperador Augusto publicou um decreto, ordenando o recenseamento em todo o império."
,"2":"Este primeiro recenseamento foi feito quando Quirino era governador da Síria."
,"3":"Todos iam registar-se, cada um na sua cidade natal."
,"4":"José era da família e descendência de David. Subiu da cidade de Nazaré, na Galileia, até à cidade de David, chamada Belém, na Judeia,"
,"5":"para se registar com Maria, sua esposa, que estava grávida."
,"6":"Enquanto estavam em Belém, completaram-se os dias para o parto,"
,"7":"e Maria deu à luz o seu filho primogénito. Ela enfaixou-O e colocou-O numa manjedoura, pois não havia lugar para eles na hospedaria."
,"8":"Naquela região havia pastores, que passavam a noite nos campos, tomando conta do rebanho."
,"9":"Um anjo do Senhor apareceu aos pastores; a glória do Senhor envolveu-os em luz e eles ficaram com muito medo."
,"10":"Mas o anjo disse aos pastores: «Não tenhais medo! Eu anuncio-vos a Boa Notícia, que será uma grande alegria para todo o povo:"
,"11":"hoje, na cidade de David, nasceu-vos um Salvador, que é o Messias, o Senhor."
,"12":"Isto vos servirá de sinal: encontrareis um recém-nascido, envolto em faixas e deitado numa manjedoura»."
,"13":"De repente, juntou-se ao anjo uma grande multidão de anjos. Cantavam louvores a Deus, dizendo:"
,"14":"«Glória a Deus no mais alto dos céus e paz na terra aos homens por Ele amados»."
,"15":"Quando os anjos se afastaram, voltando para o céu, os pastores combinaram entre si: «Vamos a Belém ver este acontecimento que o Senhor nos revelou»."
,"16":"Foram, então, à pressa, e encontraram Maria e José e o Recém-nascido deitado na manjedoura."
,"17":"Tendo-O visto, contaram o que o anjo lhes anunciara sobre o Menino."
,"18":"E todos os que ouviam os pastores ficavam maravilhados com aquilo que contavam."
,"19":"Maria, porém, conservava todos estes factos e meditava sobre eles no seu coração."
,"20":"Os pastores voltaram, glorificando e louvando a Deus por tudo o que haviam visto e ouvido, conforme o anjo lhes tinha anunciado."
,"21":"Quando se completaram os oito dias para a circuncisão do Menino, deram-Lhe o nome de Jesus, como fora chamado pelo anjo antes de ser concebido."
,"22":"Terminados os dias da purificação deles, conforme a Lei de Moisés, levaram o Menino a Jerusalém, a fim de O apresentarem ao Senhor,"
,"23":"conforme está escrito na Lei do Senhor: «Todo o primogénito de sexo masculino será consagrado ao Senhor»."
,"24":"Ofereceram em sacrifício um par de rolas ou dois pombinhos, conforme ordena a Lei do Senhor."
,"25":"Havia em Jerusalém um homem chamado Simeão. Era justo e piedoso. Esperava a consolação de Israel e o Espírito Santo estava com ele."
,"26":"O Espírito Santo tinha revelado a Simeão que não morreria sem primeiro ver o Messias prometido pelo Senhor."
,"27":"Movido pelo Espírito, Simeão foi ao Templo. Quando os pais levaram o Menino Jesus, para cumprirem as prescrições da Lei a seu respeito,"
,"28":"Simeão tomou o Menino nos braços e louvou a Deus, dizendo:"
,"29":"«Agora, Senhor, conforme a tua promessa, podes deixar o teu servo partir em paz."
,"30":"Porque os meus olhos viram,a tua salvação,"
,"31":"que preparaste diante de todos os povos:"
,"32":"luz para iluminar as nações,e glória do teu povo Israel»."
,"33":"O pai e a mãe estavam maravilhados com o que se dizia do Menino."
,"34":"Simeão abençoou-os e disse a Maria, mãe do Menino: «Eis que este Menino vai ser causa de queda e elevação de muitos em Israel. Ele será um sinal de contradição."
,"35":"Quanto a Ti, uma espada há-de atravessar-Te a alma. Assim serão revelados os pensamentos de muitos corações»."
,"36":"Havia também uma profetisa chamada Ana, de idade muito avançada. Era filha de Fanuel, da tribo de Aser. Tinha-se casado muito jovem e vivera sete anos com o marido."
,"37":"Depois ficou viúva e viveu assim até aos oitenta e quatro anos. Nunca deixava o Templo, servindo a Deus noite e dia, com jejuns e orações."
,"38":"Ela chegou nesse instante, louvava a Deus e falava do Menino a todos os que esperavam a libertação de Jerusalém."
,"39":"Quando acabaram de cumprir todas as coisas, conforme a Lei do Senhor, voltaram para Nazaré, sua cidade, que ficava na Galileia."
,"40":"O Menino crescia e fortalecia-Se, cheio de sabedoria. E a graça de Deus estava com Ele."
,"41":"Os pais de Jesus iam todos os anos a Jerusalém, para a festa da Páscoa."
,"42":"Quando o Menino completou doze anos, subiram para a festa, como de costume."
,"43":"Passados os dias da Páscoa, voltaram, mas o Menino Jesus ficou em Jerusalém, sem que seus pais o notassem."
,"44":"Pensando que o Menino estivesse na caravana, caminharam um dia inteiro. Depois começaram a procurá-l'O entre parentes e conhecidos."
,"45":"Não O tendo encontrado, voltaram a Jerusalém à procura d'Ele."
,"46":"Três dias depois, encontraram o Menino no Templo. Estava sentado no meio dos doutores, a ouvi-los e a fazer-lhes perguntas."
,"47":"Todos os que ouviam o Menino estavam maravilhados com a inteligência das suas respostas."
,"48":"Ao vê-l'O, os seus pais ficaram emocionados. Sua Mãe disse-Lhe: «Meu filho, porque fizeste isto connosco? Olha que teu pai e eu andávamos angustiados, à tua pro-cura»."
,"49":"Jesus respondeu: «Porque Me procuráveis? Não sabíeis que Eu devo estar na casa do meu Pai?»"
,"50":"Mas eles não compreenderam o que o Menino acabava de lhes dizer."
,"51":"Jesus desceu então com seus pais para Nazaré e obedecia-lhes. E sua mãe conservava no coração todas estas coissas."
,"52":"E Jesus crescia em sabedoria, em estatura e graça, diante de Deus e dos homens."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Havia quinze anos que Tibério era imperador de Roma. Pôncio Pilatos era governador da Judeia; Herodes governava a Galileia; seu irmão Filipe, a Itureia e a Traconítide; e Lisânias, a Abilena."
,"2":"Anás e Caifás eram sumos sacerdotes. Foi nesse tempo que Deus enviou a sua palavra a João, filho de Zacarias, no deserto."
,"3":"E João percorria toda a região do rio Jordão, pregando um baptismo de conversão para o perdão dos pecados,"
,"4":"conforme está escrito no livro do profeta Isaías: «Esta é a voz daquele que grita no deserto: preparai o caminho do Senhor, endireitai as suas estradas."
,"5":"Todo o vale será aterrado, toda a montanha e colina serão aplanadas; as estradas curvas ficarão rectas e os caminhos esburacados serão nivelados."
,"6":"E todo o homem verá a salvação de Deus»."
,"7":"João Baptista dizia às multidões que acorriam para serem baptizadas por ele: «Raça de cobras venenosas, quem vos ensinou a fugir da ira que vai chegar?"
,"8":"Fazei obras que provem que vos convertestes, e não comeceis a pensar: 'Abraão é nosso pai'. Porque eu vos digo: até destas pedras Deus pode fazer nascer filhos de Abraão."
,"9":"O machado já está posto à raiz das árvores. E toda a árvore que não der bom fruto será cortada e lançada ao fogo»."
,"10":"As multidões perguntavam a João: «O que é que devemos fazer?»"
,"11":"Ele respondia: «Quem tiver duas túnicas, dê uma a quem não tem. E quem tiver comida, faça a mesma coisa»."
,"12":"Alguns cobradores de impostos também foram para ser baptizados e perguntaram: «Mestre, que devemos fazer?»"
,"13":"João respondeu: «Não cobreis nada além da taxa estabelecida»."
,"14":"Alguns soldados também perguntaram: «E nós, que devemos fazer?» Ele respondeu: «Não maltrateis ninguém; não façais acusações falsas e contentai-vos com o vosso salário»."
,"15":"O povo esperava pelo Messias. E todos perguntavam a si mesmos se João não seria o Messias."
,"16":"Por isso, João declarou a todos: «Eu baptizo-vos com água. Mas vai chegar Alguém mais forte do que eu. E eu não sou digno nem sequer de Lhe desatar a correia das sandálias. Ele é que vos baptizará com o Espírito Santo e com fogo."
,"17":"Ele terá na mão uma pá; vai limpar a sua eira e recolher o trigo no seu celeiro; mas a palha Ele vai queimá-la no fogo que não se apaga»."
,"18":"João anunciava a Boa Notícia ao povo de muitos outros modos."
,"19":"João repreendeu o governador Herodes, porque este se casara com Herodíades, a mulher do irmão, e porque tinha feito muitas outras maldades."
,"20":"Herodes ainda fez outra acção pior: mandou prender João."
,"21":"Todo o povo fora baptizado. Jesus, depois de baptizado, estava a rezar. Então o céu abriu-se,"
,"22":"e o Espírito Santo desceu sobre Ele em forma corpórea, como pomba. E do céu veio uma voz: «Tu és o meu Filho amado! Em Ti encontro o meu agrado»."
,"23":"Jesus tinha cerca de trinta anos quando começou a sua actividade pública. E, conforme se pensava, Ele era filho de José, filho de Eli,"
,"24":"filho de Matat, filho de Levi, filho de Melqui, filho de Janai, filho de José,"
,"25":"filho de Matatias, filho de Amós, filho de Naum, filho de Esli, filho de Nagai,"
,"26":"filho de Maat, filho de Matatias, filho de Semein, filho de José, filho de Judá,"
,"27":"filho de Joanã, filho de Ressa, filho de Zorobabel, filho de Salatiel, filho de Neri,"
,"28":"filho de Melqui, filho de Adi, filho de Cosã, filho de Almadã, filho de Her,"
,"29":"filho de Jesus, filho de Eliezer, filho de Jorim, filho de Matat, filho de Levi,"
,"30":"filho de Simeão, filho de Judá, filho de José, filho de Jonã, filho de Eliacim,"
,"31":"filho de Meleia, filho de Mená, filho de Matatá, filho de Natã, filho de David,"
,"32":"filho de Jessé, filho de Obed, filho de Booz, filho de Salá, filho de Naásson,"
,"33":"filho de Aminadab, filho de Admin, filho de Arni, filho de Esron, filho de Farés, filho de Judá,"
,"34":"filho de Jacob, filho de Isaac, filho de Abraão, filho de Taré, filho de Nacor,"
,"35":"filho de Seruc, filho de Ragau, filho de Faleg, filho de Éber, filho de Salá,"
,"36":"filho de Cainã, filho de Arfaxad, filho de Sem, filho de Noé, filho de Lamec,"
,"37":"filho de Matusalém, filho de Henoc, filho de Jared, filho de Malaleel, filho de Cainã,"
,"38":"filho de Enós, filho de Set, filho de Adão, filho de Deus."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Repleto do Espírito Santo, Jesus voltou do rio Jordão e era conduzido pelo Espírito através do deserto."
,"2":"Ali foi tentado pelo demónio durante quarenta dias. Não comeu nada nesses dias e, depois disso, sentiu fome."
,"3":"Então o demónio disse a Jesus: «Se és Filho de Deus, ordena a esta pedra que se transforme em pão»."
,"4":"Jesus respondeu: «A Escritura diz: 'Não só de pão vive o homem'»."
,"5":"O diabo levou Jesus para o alto. Mostrou-Lhe por um instante todos os reinos do mundo."
,"6":"E disse-Lhe: «Dar-Te-ei todo o poder e riqueza destes reinos, porque tudo isto me foi entregue e posso dá-lo a quem eu quiser."
,"7":"Portanto, se Te ajoelhares diante de mim, tudo isto será teu»."
,"8":"Jesus respondeu: «A Escritura diz: 'Adorarás o Senhor teu Deus, e só a Ele servirás'»."
,"9":"Depois o demónio levou Jesus a Jerusalém, colocou-O na parte mais alta do Templo. E disse-Lhe: «Se és Filho de Deus, atira-Te daqui abaixo."
,"10":"Porque a Escritura diz: 'Deus ordenará aos seus anjos a teu respeito, que Te guardem com cuidado'."
,"11":"E mais ainda: 'Eles hão-de levar-Te nas mãos, para que não tropeces em nenhuma pedra'»."
,"12":"Mas Jesus respondeu: «A Escritura diz: 'Não tentarás o Senhor teu Deus'»."
,"13":"Tendo esgotado todas as formas de tentação, o demónio afastou-se de Jesus, para voltar em tempo oportuno."
,"14":"Jesus voltou para a Galileia, com a força do Espírito, e a sua fama espalhou-se por toda a redondeza."
,"15":"Ensinava nas sinagogas e todos O elogiavam."
,"16":"Jesus foi à cidade de Nazaré, onde Se havia criado. Conforme seu costume, no sábado entrou na sinagoga e levantou-Se para fazer a leitura."
,"17":"Deram-Lhe o livro do profeta Isaías. Abrindo o livro, Jesus encontrou a passagem onde está escrito:"
,"18":"«O Espírito do Senhor está sobre mim, porque Ele me consagrou com a unção, para anunciar a Boa Notícia aos pobres; enviou-me para proclamar a libertação aos presos, e aos cegos a recuperação da vista; para libertar os oprimidos"
,"19":"e para proclamar um ano de graça do Senhor»."
,"20":"Em seguida Jesus fechou o livro, entregou-o ao ajudante e sentou-Se. Todos os que estavam na sinagoga tinham os olhos fixos n'Ele."
,"21":"Então Jesus começou a dizer-lhes: «Hoje cumpriu-se esta passagem da Escritura que acabais de ouvir»."
,"22":"Todos aprovavam Jesus, admirados com as palavras cheias de encanto que saíam da sua boca. E diziam: «Não é este o filho de José?»"
,"23":"Mas Jesus disse: «Sem dúvida ireis citar-Me o provérbio: Médico, cura-te a ti mesmo. Faz também aqui, na tua terra, tudo o que ouvimos dizer que fizeste em Cafarnaum»."
,"24":"E acrescentou: «Garanto-vos: nenhum profeta é bem recebido na sua pátria."
,"25":"De facto, digo-vos que havia muitas viúvas em Israel, no tempo do profeta Elias, quando não caiu chuva do céu durante três anos e seis meses e houve grande fome em toda a região."
,"26":"No entanto, a nenhuma delas foi enviado Elias, mas a uma viúva estrangeira, que vivia em Sarepta, na Sidónia."
,"27":"Havia também muitos leprosos em Israel no tempo do profeta Eliseu. Apesar disso, nenhum deles foi curado, a não ser o estrangeiro Naamã, que era sírio»."
,"28":"Quando ouviram estas palavras de Jesus, todos na sinagoga ficaram furiosos."
,"29":"Levantaram-se e expulsaram Jesus da cidade. Levaram-n'O até ao alto do monte, sobre o qual a cidade estava construída, com intenção de O lançarem no precipício."
,"30":"Mas Jesus, passando por meio deles, continuou o seu caminho."
,"31":"Jesus foi a Cafarnaum, cidade da Galileia, e ali ensinava aos sábados."
,"32":"As pessoas ficavam admiradas com o seu ensinamento, porque Jesus falava com autoridade."
,"33":"Na sinagoga havia um homem possuído pelo espírito de um demónio mau, que gritou em alta voz:"
,"34":"«O que queres de nós, Jesus Nazareno? Vieste para nos destruir? Eu sei quem Tu és: Tu és o Santo de Deus!»"
,"35":"Jesus ameaçou-o, dizendo: «Cala-te e sai dele!» Então o demónio lançou o homem ao chão, saiu dele e não lhe fez mal nenhum."
,"36":"O espanto tomou conta de todos e eles comentavam entre si: «Que palavra é esta? Ele manda nos espíritos maus com autoridade e poder e eles saem»."
,"37":"E a fama de Jesus espalhava-se por todos os lugares da redondeza."
,"38":"Jesus saiu da sinagoga e foi para a casa de Simão. A sogra de Simão estava com febre alta e pediram a Jesus em favor dela."
,"39":"Inclinando-Se para ela, Jesus ameaçou a febre e esta deixou a mulher. Então, no mesmo instante, ela levantou-se e começou a servi-los."
,"40":"Ao pôr do sol, todos os que tinham doentes atingidos por diversos males levavam-nos a Jesus. Jesus colocava as mãos sobre cada um deles e curava-os."
,"41":"De muitas pessoas também saíam demónios, gritando: «Tu és o Filho de Deus».Jesus ameaçava-os e não os deixava falar, porque os demónios sabiam que Ele era o Messias."
,"42":"Ao raiar do dia, Jesus saiu e foi para um lugar deserto. As multidões procuravam-n'O e, indo ter com Ele, não queriam deixar que Se fosse embora."
,"43":"Mas Jesus disse: «Devo anunciar a Boa Notícia do Reino de Deus também às outras cidades, porque para isso é que fui enviado»."
,"44":"E Jesus pregava nas sinagogas da Judeia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Certo dia, Jesus estava na margem do lago de Genesaré. A multidão apertava-se ao seu redor para ouvir a palavra de Deus."
,"2":"Jesus viu duas barcas paradas na margem do lago; os pescadores haviam desembarcado e lavavam as redes."
,"3":"Subindo para uma das barcas, que era de Simão, pediu que se afastasse um pouco da margem. Depois sentou-Se e, da barca, ensinava as multidões."
,"4":"Quando acabou de falar, disse a Simão: «Avança para águas mais profundas e lança as redes para a pesca»."
,"5":"Simão respondeu: «Mestre, tentámos a noite inteira e não pescámos nada. Mas, em atenção à tua palavra, vou lançar as redes»."
,"6":"Assim fizeram, e apanharam tamanha quantidade de peixes que as redes se rompiam."
,"7":"Então fizeram sinal aos companheiros da outra barca, para que os viessem ajudar. Vieram e encheram as duas barcas, a ponto de quase se afundarem."
,"8":"Ao ver isto, Simão Pedro atirou-se aos pés de Jesus, dizendo: «Senhor, afasta-Te de mim, porque sou um pecador!»"
,"9":"É que o espanto tinha tomado conta de Simão e de todos os seus companheiros, por causa da pesca que acabavam de fazer."
,"10":"Tiago e João, filhos de Zebedeu, que eram sócios de Simão, também ficaram espantados. Mas Jesus disse a Simão: «Não tenhas receio! De hoje em diante serás pescador de homens»."
,"11":"Então levaram as barcas para a margem, deixaram tudo e seguiram Jesus."
,"12":"Aconteceu que Jesus estava numa cidade, e havia ali um homem leproso. Vendo Jesus, caiu a seus pés e pediu: «Senhor, se quiseres, tens poder para me purificar»."
,"13":"Jesus estendeu a mão, tocou nele e disse: «Quero, fica purificado».No mesmo instante a lepra deixou-o."
,"14":"Jesus ordenou-lhe que não dissesse nada a ninguém. E disse: «Vai pedir ao sacerdote que te examine, e depois oferece pela tua purificação o sacrifício que Moisés ordenou, para que seja um testemunho para eles»."
,"15":"No entanto, a fama de Jesus espalhava-se cada vez mais e numerosas multidões reuniam-se para O ouvirem e serem curadas das suas doenças."
,"16":"Mas Jesus retirava-Se para lugares desertos, a fim de rezar."
,"17":"Certo dia, Jesus estava a ensinar. Estavam ali sentados fariseus e doutores da Lei, vindos de todos os povoados da Galileia, da Judeia e até de Jerusalém. E o poder do Senhor estava em Jesus, fazendo-O realizar curas."
,"18":"Chegaram, então, algumas pessoas que traziam, numa cama, um homem que estava paralítico; tentavam introduzi-lo e colocá-lo diante de Jesus."
,"19":"Mas, por causa da multidão, não conseguiam introduzi-lo. Subiram então ao terraço e, através das telhas, desceram o homem com a cama, no meio, diante de Jesus."
,"20":"Vendo a fé que eles tinham, Jesus disse: «Homem, os teus pecados estão perdoados»."
,"21":"Os doutores da Lei e os fariseus começaram a pensar: «Quem é este que profere blasfémias? Ninguém pode perdoar pecados, porque só Deus tem poder para isso!»"
,"22":"Mas Jesus percebeu o que eles estavam a pensar. Tomou então a palavra e disse: «Porque pensais assim?"
,"23":"O que é mais fácil? Dizer: 'Os teus pecados estão perdoados', ou dizer: 'Levanta-te e anda?'"
,"24":"Pois bem: para que saibais que o Filho do Homem tem poder para perdoar pecados, - disse Jesus ao paralítico - Eu te ordeno: Levanta-te, pega na tua cama e volta para casa»."
,"25":"No mesmo instante, o homem levantou-se à vista deles, pegou na cama onde estava deitado e foi para casa, louvando a Deus."
,"26":"Todos ficaram admirados e louvavam a Deus. Ficaram cheios de medo e diziam: «Hoje vimos coisas estranhas»."
,"27":"Depois disto, Jesus saiu e viu um cobrador de impostos chamado Levi, que estava no lugar de cobrança. Jesus disse-lhe: «Segue-Me»."
,"28":"Levi deixou tudo, levantou-se e seguiu Jesus."
,"29":"Depois, Levi preparou em casa um grande banquete para Jesus. Estava ali numerosa multidão de cobradores de impostos e outras pessoas sentadas à mesa com eles."
,"30":"Os fariseus e doutores da Lei murmuravam e diziam aos discípulos de Jesus: «Porque é que comeis e bebeis com os cobradores de impostos e com os pecadores?»"
,"31":"Jesus respondeu: «As pessoas que têm saúde não precisam de médico, mas só as que estão doentes."
,"32":"Eu não vim para chamar os justos, mas os pecadores ao arrependimento»."
,"33":"Eles disseram a Jesus: «Os discípulos de João, e também os discípulos dos fariseus, jejuam com frequência e fazem orações, mas os teus discípulos comem e bebem»."
,"34":"Mas Jesus disse-lhes: «Achais que os convidados de um casamento podem fazer jejum enquanto o noivo está com eles?"
,"35":"Mas vão chegar dias em que o noivo será tirado do meio deles; nesses dias eles vão jejuar»."
,"36":"Jesus contou-lhes ainda uma parábola: «Ninguém recorta um remendo de roupa nova para remendar roupa velha; senão, vai rasgar a roupa nova e o remendo novo não combina com a roupa velha."
,"37":"Ninguém coloca vinho novo em barris velhos; porque, de facto, o vinho novo rebenta os barris velhos, derrama-se, e os barris perdem-se."
,"38":"O vinho novo de-ve ser colocado em barris novos."
,"39":"E ninguém, depois de beber vinho velho, deseja vinho novo, porque diz: o velho é melhor»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Num dia de sábado, Jesus passava por uns campos de trigo. Os discípulos arrancavam e comiam as espigas, debulhando-as com as mãos."
,"2":"Então alguns fariseus disseram: «Porque é que fazeis o que vos não é permitido em dia de sábado?»"
,"3":"Jesus respondeu: «Então não lestes o que David e seus companheiros fizeram quando sentiram fome?"
,"4":"David entrou na casa de Deus, tomou e comeu dos pães oferecidos a Deus, e ainda os deu aos seus companheiros. No entanto, só os sacerdotes podem comer desses pães»."
,"5":"E Jesus acrescentou: «O Filho do Homem é senhor até do sábado»."
,"6":"Num outro sábado, Jesus entrou na sinagoga e começou a ensinar. Encontrava-se ali um homem com a mão direita ressequida."
,"7":"Os doutores da Lei e os fariseus espiavam, para ver se Jesus iria curá-lo durante o sábado e assim encontrarem motivo para O acusarem."
,"8":"Mas Jesus conhecia os seus pensamentos e disse ao homem da mão ressequida: «Levanta-te e fica no meio».Ele levantou-se e ficou de pé."
,"9":"Jesus disse aos outros: «Eu pergunto-vos: a Lei permite no sábado fazer o bem ou fazer o mal, salvar uma vida ou deixar que se perca?»"
,"10":"Então Jesus olhou para todos os que estavam ao seu redor e disse ao homem: «Estende a mão».O homem estendeu-a e a sua mão ficou boa."
,"11":"Eles ficaram com muita raiva e começaram a conversar sobre o que poderiam fazer contra Jesus."
,"12":"Naqueles dias, Jesus foi para a montanha a fim de rezar. E passou toda a noite em oração a Deus."
,"13":"Ao amanhecer, chamou os seus discípulos e escolheu doze entre eles, aos quais deu o nome de Apóstolos:"
,"14":"Simão, a quem também deu o nome de Pedro, e seu irmão André; Tiago e João; Filipe e Bartolomeu;"
,"15":"Mateus e Tomé; Tiago, filho de Alfeu, e Simão, chamado Zelota;"
,"16":"Judas, filho de Tiago, e Judas Iscariotes, aquele que se tornou traidor."
,"17":"Jesus desceu da montanha com os doze Apóstolos e parou num lugar plano. Estava ali a numerosa multidão dos seus discípulos com muita gente do povo de toda a Judeia, de Jerusalém e do litoral de Tiro e Sidónia."
,"18":"Foram para ouvir Jesus e serem curados das suas doenças. E aqueles que estavam atormentados por espíritos maus foram curados."
,"19":"Toda a multidão procurava tocar em Jesus, porque uma força saía d'Ele e a todos curava."
,"20":"Levantando os olhos para os discípulos, Jesus disse: «Felizes de vós, os pobres, porque o Reino de Deus vos pertence."
,"21":"Felizes de vós que agora tendes fome, porque sereis saciados. Felizes de vós que agora chorais, porque haveis de rir."
,"22":"Felizes de vós se os homens vos odeiam, se vos expulsam, vos insultam e amaldiçoam o vosso nome, por causa do Filho do Homem."
,"23":"Alegrai-vos nesse dia, saltai de alegria, pois será grande a vossa recompensa no Céu, porque era assim que os seus antepassados tratavam os profetas."
,"24":"Mas ai de vós, os ricos, porque já tendes a vossa consolação!"
,"25":"Ai de vós, que agora tendes fartura, porque ireis passar fome! Ai de vós, que agora rides, porque ireis ficar aflitos e ireis chorar!"
,"26":"Ai de vós, se todos vos elogiam, porque era assim que os vossos antepassados tratavam os falsos profetas»."
,"27":"«Mas Eu digo-vos a vós que Me escutais: Amai os vossos inimigos e fazei o bem aos que vos odeiam."
,"28":"Desejai o bem aos que vos amaldiçoam e rezai por aqueles que vos caluniam."
,"29":"Se alguém vos bater numa face, oferecei-lhe também a outra; se alguém vos leva a capa, deixai que leve também a túnica."
,"30":"Dá a quem te pede e, se alguém se apodera do que é teu, não lhe peças que to devolva."
,"31":"O que desejais que os outros vos façam, fazei-lho vós também."
,"32":"Se amais somente aqueles que vos amam, que gratuitidade é essa? Até mesmo os pecadores amam aqueles que os amam."
,"33":"Se fazeis o bem somente aos que vos fazem bem, que gratuitidade é essa? Até mesmo os pecadores fazem assim."
,"34":"E se emprestais somente àqueles de quem esperais receber, que gratuitidade é essa? Até mesmo os pecadores emprestam aos pecadores, para receberem a mesma quantia."
,"35":"Vós, porém, amai os inimigos, fazei o bem e emprestai, sem esperar coisa alguma em troca. Então, a vossa recompensa será grande e sereis filhos do Altíssimo, porque Deus é bondoso também para com os ingratos e maus."
,"36":"Sede misericordiosos, como também o vosso Pai é misericordioso»."
,"37":"«Não julgueis e não sereis julgados; não condeneis e não sereis condenados; perdoai e sereis perdoados."
,"38":"Dai e dar-se-vos-á; colocarão nos vossos braços uma boa medida, calcada, sacudida, transbordante. Porque a mesma medida que usardes para os outros será usada para vós»."
,"39":"Jesus contou uma parábola aos discípulos: «Pode um cego guiar outro cego? Não cairão os dois num buraco?"
,"40":"Nenhum discípulo é maior do que o mestre; e todo o discípulo bem formado será como o seu mestre."
,"41":"Porque olhas para o argueiro que está no olho do teu irmão e não prestas atenção à trave que está no teu olho?"
,"42":"Como é que podes dizer ao teu irmão: 'Irmão, deixa-me tirar o argueiro do teu olho', quando não vês a trave no teu próprio olho? Hipócrita! Tira primeiro a trave do teu olho e então verás para tirar o argueiro do olho do teu irmão»."
,"43":"«Não existe árvore boa que dê maus frutos, nem árvore má que dê bons frutos;"
,"44":"porque toda a árvore é conhecida pelos seus frutos. Não se colhem figos de espinheiros, nem se apanham uvas de plantas espinhosas."
,"45":"O homem bom tira coisas boas do bom tesouro do seu coração, mas o homem mau tira do seu mal coisas más, porque a boca fala daquilo de que o coração está cheio»."
,"46":"«Porque Me chamais: 'Senhor! Senhor!', e não fazeis o que Eu digo?"
,"47":"Vou mostrar-vos com quem se parece todo aquele que ouve as minhas palavras e as põe em prática."
,"48":"É semelhante a um homem que construiu uma casa: cavou fundo e colocou o alicerce sobre a rocha. Veio a enchente, a enxurrada bateu contra a casa mas não conseguiu derrubá-la, porque estava bem construída."
,"49":"Aquele que ouve e não põe em prática é semelhante a um homem que construiu uma casa sobre a terra, sem alicerce. A enxurrada bateu contra a casa e ela imediatamente desabou; e foi grande a ruína daquela casa»."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Depois que terminou de falar ao povo que O escutava, Jesus entrou na cidade de Cafarnaum."
,"2":"Havia ali um oficial romano que tinha um empregado, a quem estimava muito. O empregado estava doente, a ponto de morrer."
,"3":"O oficial ouviu falar de Jesus, e enviou alguns anciãos dos judeus para pedir a Jesus que fosse salvar o empregado."
,"4":"Chegados junto de Jesus, pediram-Lhe com insistência: «O oficial merece que lhe faças esse favor,"
,"5":"porque ele estima o nosso povo e até nos construiu uma sinagoga»."
,"6":"Então Jesus pôs-Se a caminho com eles. Porém, quando já estava perto da casa, o oficial mandou alguns amigos dizer a Jesus: «Senhor, não Te incomodes, pois eu não sou digno de que entres em minha casa;"
,"7":"nem sequer me atrevi a ir pessoalmente ao teu encontro. Mas diz uma palavra e o meu empregado ficará curado."
,"8":"Pois eu também estou sob a autoridade de oficiais superiores e tenho soldados sob as minhas ordens. E digo a um: Vai, e ele vai; e a outro: Vem, e ele vem; e ao meu empregado: Faz isto, e ele faz»."
,"9":"Ouvindo isto, Jesus ficou admirado. Voltou-Se para a multidão que O seguia, e disse: «Declaro-vos que nem mesmo em Israel encontrei tamanha fé»."
,"10":"Os mensageiros voltaram para a casa do oficial e encontraram o empregado em perfeita saúde."
,"11":"Em seguida, Jesus foi para uma cidade chamada Naim. Com Ele iam os discípulos e uma grande multidão."
,"12":"Quando chegou à porta da cidade, eis que levavam um defunto para enterrar; era filho único e sua mãe era viúva. Grande multidão da cidade ia com ela."
,"13":"Ao vê-la, o Senhor teve compaixão dela e disse-lhe: «Não chores!»"
,"14":"Depois aproximou-Se, tocou no caixão, e os que o transportavam pararam. Então Jesus disse: «Jovem, Eu te ordeno, levanta-te!»"
,"15":"O morto sentou-se e começou a falar. E Jesus entregou-o à mãe."
,"16":"Todos ficaram com muito medo e glorificavam a Deus, dizendo: «Um grande profeta apareceu entre nós, e Deus veio visitar o seu povo»."
,"17":"E a notícia do facto espalhou-se pela Judeia inteira e por toda a redondeza."
,"18":"Os discípulos de João informaram-no de todos estes factos. Então João chamou dois dos seus discípulos"
,"19":"e mandou-os perguntar ao Senhor: «És Tu Aquele que há-de vir ou devemos esperar outro?»"
,"20":"Eles foram ter com Jesus e disseram: «João Baptista mandou-nos vir ter contigo para perguntar: «És tu Aquele que há-de vir, ou devemos esperar outro?»"
,"21":"Nessa mesma hora, Jesus curou muitas pessoas das suas doenças, males e espíritos maus e fez com que muitos cegos recuperassem a vista."
,"22":"Depois respondeu: «Voltai e contai a João o que vistes e ouvistes: os cegos recuperam a vista, os paralíticos andam, os leprosos são purificados, os surdos ouvem, os mortos ressuscitam e a Boa Notícia é anunciada aos pobres."
,"23":"E feliz é aquele que não se escandaliza por causa de Mim!»"
,"24":"Depois de os mensageiros de João terem partido, Jesus começou a falar sobre João às multidões: «Que fostes ver ao deserto? Uma cana agitada pelo vento?"
,"25":"Que fostes ver então? Um homem vestido com roupas finas? Ora, os que se vestem com roupas preciosas e vivem no luxo estão nos palácios dos reis."
,"26":"Então, o que fostes ver? Um profeta? Eu garanto-vos que sim: alguém que é mais do que um profeta."
,"27":"É de João que a Escritura afirma: 'Eis que envio o meu mensageiro à tua frente: ele vai preparar o teu caminho diante de Ti'."
,"28":"Eu digo-vos: entre os nascidos de mulher ninguém é maior do que João. No entanto, o menor no Reino de Deus é maior do que ele."
,"29":"Todo o povo e até mesmo os cobradores de impostos deram ouvidos à pregação de João. Reconheceram a justiça de Deus e receberam o baptismo de João."
,"30":"Mas os fariseus e os especialistas em leis, rejeitando o baptismo de João, tornaram inútil para si mesmos o projecto de Deus»."
,"31":"«Com quem poderei comparar os homens desta geração? Com quem se parecem eles?"
,"32":"São como crianças que se sentam nas praças e se dirigem aos colegas, dizendo: 'Tocámos flauta e não dançastes; cantámos música triste e não chorastes'."
,"33":"Pois veio João Baptista, que não comia nem bebia, e dissestes: 'Está com um demónio!'"
,"34":"Veio o Filho do Homem, que come e bebe, e dizeis: 'É um comilão e beberrão, amigo dos cobradores de impostos e dos pecadores!'"
,"35":"Mas a sabedoria foi justificada por todos os seus filhos»."
,"36":"Certo fariseu convidou Jesus para uma refeição em casa. Jesus entrou em casa do fariseu e pôs-Se à mesa."
,"37":"Apareceu então certa mulher, conhecida na cidade como pecadora. Ela, sabendo que Jesus estava à mesa na casa do fariseu, levou um frasco de alabastro com perfume."
,"38":"A mulher colocou-se por detrás, chorando aos pés de Jesus; com as lágrimas começou a banhar-Lhe os pés. Em seguida, enxugava-os com os cabelos, cobria-os de beijos e ungia-os com perfume."
,"39":"Vendo isso, o fariseu que havia convidado Jesus pensou: «Se este homem fosse mesmo um profeta, saberia que tipo de mulher Lhe está a tocar, porque é pecadora»."
,"40":"Jesus disse então ao fariseu: «Simão, tenho uma coisa a dizer-te».Simão respondeu: «Fala, Mestre»."
,"41":"«Certo credor tinha dois devedores. Um devia-lhe quinhentas moedas de prata e o outro devia-lhe cinquenta."
,"42":"Como não tivessem com que pagar, o homem perdoou aos dois. Qual deles o amará mais?»"
,"43":"Simão respondeu: «Acho que é aquele a quem ele perdoou mais».Jesus disse-lhe: «Julgaste bem»."
,"44":"Então Jesus voltou-Se para a mulher e disse a Simão: «Vês esta mulher? Quando entrei em tua casa, não Me ofereceste água para lavar os pés; ela, porém, banhou-Me os pés com lágrimas e enxugou-os com os cabelos."
,"45":"Não Me deste o beijo de saudação; ela, porém, desde que entrei, não deixou de Me beijar os pés."
,"46":"Não derramaste óleo na minha cabeça; ela, porém, ungiu-Me os pés com perfume."
,"47":"Por essa razão, Eu te declaro: os muitos pecados que ela cometeu estão perdoados, porque demonstrou muito amor. Aquele a quem foi perdoado pouco, demonstra pouco amor»."
,"48":"E Jesus disse à mulher: «Os teus pecados estão perdoados»."
,"49":"Então os convidados começaram a pensar: «Quem é este que até perdoa pecados?»"
,"50":"Mas Jesus disse à mulher: «Salvou-te a tua fé. Vai em paz!»"
}`)
	CurrentBook.AddChapter(8, `{
"1":"Depois disto, Jesus andava por cidades e povoados, pregando e anunciando a Boa Notícia do Reino de Deus. Os Doze iam com Ele"
,"2":"e também algumas mulheres que haviam sido curadas de espíritos maus e doenças: Maria, chamada Madalena, da qual haviam saído sete demónios;"
,"3":"Joana, mulher de Cuza, alto funcionário de Herodes; Susana e várias outras mulheres, que ajudavam Jesus e os discípulos com os bens que possuíam."
,"4":"Juntou-se uma grande multidão, e de todas as cidades as pessoas iam ter com Jesus. Então Ele contou esta parábola:"
,"5":"«O semeador saiu para semear a sua semente. Enquanto semeava, uma parte caiu à beira do caminho; foi pisada e os passarinhos comeram tudo."
,"6":"Outra parte caiu sobre a rocha; brotou e secou, porque não havia humidade."
,"7":"Outra parte caiu no meio de espinhos; os espinhos cresceram e sufocaram-na."
,"8":"Outra parte caiu em terra boa; brotou e deu fruto, cem por um». Dizendo isto, Jesus exclamou: «Quem tem ouvidos para ouvir, oiça»."
,"9":"Os discípulos perguntaram a Jesus o significado desta parábola."
,"10":"Jesus respondeu: «A vós foi dado conhecer os mistérios do Reino de Deus. Mas aos outros ele vem por meio de parábolas, para que olhando não vejam e ouvindo não compreendam»."
,"11":"«A parábola quer dizer o seguinte: a semente é a Palavra de Deus."
,"12":"Os que estão à beira do caminho são aqueles que ouviram; mas, depois, chega o demónio e tira-lhes a Palavra do coração, para que não acreditem nem se salvem."
,"13":"Os que caíram sobre a rocha são aqueles que, ouvindo, acolheram com alegria a Palavra. Mas não têm raiz: por um momento, acreditam; mas na hora da tentação voltam atrás."
,"14":"A que caiu entre os espinhos são aqueles que ouvem, mas, continuando a caminhar, afogam-se nas preocupações, na riqueza e nos prazeres da vida e não chegam a amadurecer."
,"15":"A que caiu em terra boa são aqueles que, ouvindo de coração bom e generoso, conservam a Palavra e dão fruto na perseverança»."
,"16":"«Ninguém acende uma lâmpada para a cobrir com uma vasilha ou para a colocar debaixo da cama. Coloca-a no velador, a fim de que todos os que entram vejam a luz."
,"17":"De facto, tudo o que está escondido deverá tornar-se manifesto; e tudo o que está em segredo deverá tornar-se conhecido e claramente manifesto."
,"18":"Portanto, prestai atenção ao modo como ouvis: a quem tem alguma coisa, será dado ainda mais; àquele que não tem, ser-lhe-á tirado até mesmo o que ele pensa ter»."
,"19":"A Mãe e os irmãos de Jesus aproximaram-se mas não podiam chegar perto d'Ele por causa da multidão."
,"20":"Então anunciaram a Jesus: «A tua Mãe e os teus irmãos estão lá fora e querem ver-Te»."
,"21":"Jesus respondeu: «Minha Mãe e meus irmãos são aqueles que ouvem a Palavra de Deus e a põem em prática»."
,"22":"Certo dia, Jesus entrou numa barca com os seus discípulos e disse: «Vamos para o outro lado do lago».E partiram."
,"23":"Enquanto navegavam, Jesus adormeceu. Nisto, um vento forte atingiu o lago: a barca enchia-se de água e eles corriam perigo."
,"24":"Os discípulos aproximaram-se e acordaram Jesus, dizendo: «Mestre, Mestre, vamos morrer».Então Jesus levantou-Se e ameaçou o vento e o furor das águas. Estes pararam e a calma voltou."
,"25":"Jesus disse aos discípulos: «Onde está a vossa fé?» Tomados de medo, ficaram admirados e diziam entre si: «Quem é este homem que dá ordens aos ventos e à água e eles obedecem-Lhe?»."
,"26":"Jesus e os discípulos desembarcaram na região dos gerasenos, que está defronte da Galileia."
,"27":"Ao descer para terra, um homem da cidade foi ao encontro de Jesus. Era possuído por demónios, e há muito tempo não se vestia, nem morava em casa, mas nos túmulos."
,"28":"Vendo Jesus, o homem começou a gritar, caiu-Lhe aos pés e gritou com voz forte: «Que há entre mim e Ti, Jesus, Filho do Deus Altíssimo? Peço-Te que não me atormentes!»"
,"29":"O homem falou assim porque Jesus tinha ordenado que o espírito mau saísse dele. De facto, muitas vezes o espírito tinha tomado posse dele. Para o proteger, prendiam-no com correntes e algemas; ele, porém, rebentava as correntes, e o demónio levava-o para lugares desertos."
,"30":"Então Jesus perguntou-lhe: «Qual é o teu nome?» Ele respondeu: «O meu nome é Legião».Pois muitos demónios tinham entrado nele."
,"31":"Os demónios pediam a Jesus que não os mandasse para o abismo."
,"32":"Andava ali perto uma numerosa vara de porcos a pastar na montanha. Os demónios pediram a Jesus que os deixasse entrar nos porcos. Jesus concedeu-lho."
,"33":"Os demónios saíram do homem e entraram nos porcos. E a vara dos porcos atirou-se pelo monte abaixo para dentro do lago, onde se afogou."
,"34":"Vendo o que havia acontecido, os homens que cuidavam dos porcos fugiram e espalharam a notícia na cidade e nos campos."
,"35":"E as pessoas foram ver o que tinha acontecido. Foram ter com Jesus e encontraram o homem, de quem os demónios tinham saído, sentado aos pés de Jesus; estava vestido e no seu perfeito juízo. E ficaram com medo."
,"36":"Os que tinham presenciado o facto contaram-lhes como o endemoninhado tinha sido salvo."
,"37":"E todo o povo da região dos gerasenos pediu que Jesus Se retirasse para longe deles, porque estavam tomados de grande medo. Jesus entrou na barca e foi-Se embora."
,"38":"O homem de quem os demónios tinham saído pedia para ficar com Jesus. Mas Jesus despediu-o, dizendo:"
,"39":"«Volta para casa e conta tudo o que Deus fez por ti».E ele foi-se embora, proclamando pela cidade inteira tudo o que Jesus lhe fizera."
,"40":"Ao voltar, Jesus foi recebido pela multidão, pois todos O esperavam."
,"41":"Naquele momento, chegou um homem chamado Jairo, chefe da sinagoga do lugar. Caiu aos pés de Jesus e pediu com insistência que Jesus fosse a sua casa,"
,"42":"porque tinha uma filha única, de doze anos, que estava a morrer. Enquanto Jesus caminhava, as multidões apertavam-n'O."
,"43":"Em certo momento chegou uma mulher que sofria de hemorragia havia doze anos, e ninguém tinha conseguido curá-la."
,"44":"Ela foi por detrás e tocou na capa de Jesus. No mesmo instante a hemorragia parou."
,"45":"Então Jesus perguntou: «Quem foi que tocou em Mim?» Todos negaram, e Pedro disse: «Mestre, as multidões cercam-Te e apertam-Te!»"
,"46":"Então Jesus disse: «Alguém Me tocou, pois Eu senti que uma força saiu de Mim»."
,"47":"A mulher, vendo que tinha sido descoberta, aproximou-se a tremer e caiu aos pés de Jesus. Contou diante de todos o motivo por que havia tocado em Jesus e como tinha sido curada no mesmo instante."
,"48":"Jesus disse à mulher: «Minha filha, foi a tua fé que te curou. Vai em paz»."
,"49":"Jesus ainda estava a falar quando um mensageiro da casa do chefe da sinagoga veio dizer: «A tua filha morreu; não incomodes mais o Mestre»."
,"50":"Jesus ouviu a notícia e disse a Jairo: «Não tenhas medo; crê somente e ela será salva»."
,"51":"Quando chegou a casa, Jesus não deixou ninguém entrar com Ele, a não ser Pedro, João e Tiago, com o pai e a mãe da menina."
,"52":"Todos choravam e batiam no peito por causa dela. Jesus disse: «Não choreis: ela não morreu. Está apenas a dormir»."
,"53":"Os presentes começaram a zombar de Jesus, pois sabiam que a menina já estava morta."
,"54":"No entanto, Jesus tomou a menina pela mão e chamou-a, dizendo: «Menina, levanta-te!»"
,"55":"A menina voltou a respirar, levantou-se no mesmo instante e Jesus mandou que lhe dessem de comer."
,"56":"Os pais ficaram muito admirados. E Jesus ordenou-lhes que não dissessem nada a ninguém sobre o que havia acontecido."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jesus convocou os Doze e deu-lhes autoridade sobre os demónios e para curar doenças."
,"2":"E enviou-os a pregar o Reino de Deus e a curar."
,"3":"E disse-lhes: «Não leveis nada para o caminho: nem bastão, nem sacola, nem pão, nem dinheiro, nem duas túnicas."
,"4":"Em qualquer casa onde entrardes, ficai ali até vos retirardes do lugar."
,"5":"Quanto aos que vos não receberem, ao sair da cidade sacudi a poeira dos pés, como protesto contra eles»."
,"6":"Os discípulos partiram, e percorriam os povoados, anunciando a Boa Notícia e fazendo curas em todos os lugares."
,"7":"O governador Herodes ouviu falar de tudo o que se passava e ficou sem saber o que pensar, porque alguns diziam que João Baptista tinha ressuscitado dos mortos;"
,"8":"outros diziam que Elias tinha aparecido; outros ainda, que um dos antigos profetas tinha ressuscitado."
,"9":"Então Herodes disse: «Eu mandei degolar João. Quem é este homem, de quem oiço dizer semelhantes coisas?» E queria ver Jesus."
,"10":"Os Apóstolos voltaram e contaram a Jesus tudo o que haviam feito. Jesus levou-os consigo e retirou-Se para um lugar afastado na direcção de uma cidade chamada Betsaida."
,"11":"No entanto, as multidões souberam disso e seguiram-n'O. Jesus acolheu-as e falava-lhes sobre o Reino de Deus e restituía a saúde a todos os que precisavam de cura."
,"12":"A tarde aproximava-se. Os doze Apóstolos aproximaram-se de Jesus e disseram-Lhe: «Despede a multidão. Assim eles podem ir aos povoados e campos vizinhos para procurar alojamento e comida, porque estamos num lugar deserto»."
,"13":"Mas Jesus disse: «Vós é que tendes de lhes dar de comer».Eles responderam: «Só temos cinco pães e dois peixes... A não ser que vamos comprar comida para toda esta gente!»"
,"14":"De facto, estavam ali mais ou menos cinco mil homens. Mas Jesus disse aos discípulos: «Mandai-os sentar em grupos de cinquenta»."
,"15":"Os discípulos assim fizeram, e todos se sentaram."
,"16":"Então Jesus tomou os cinco pães e os dois peixes, ergueu os olhos ao céu, pronunciou sobre eles a bênção, partiu-os, e ia-os dando aos discípulos a fim de que os distribuíssem à multidão."
,"17":"Todos comeram, ficaram satisfeitos, e ainda se encheram doze cestos com os pedaços que sobraram."
,"18":"Certo dia, Jesus estava a rezar num lugar retirado e os discípulos estavam com Ele. Então Jesus perguntou-lhes: «Quem dizem as multidões que Eu sou?»"
,"19":"Eles responderam: «Alguns dizem que és João Baptista; outros, que és Elias; mas outros acham que és algum dos antigos profetas que ressuscitou»."
,"20":"Jesus perguntou: «E vós, quem dizeis que Eu sou?» Pedro respondeu: «O Messias de Deus»."
,"21":"Então Jesus proibiu severamente que contassem isto a alguém."
,"22":"E acrescentou: «O Filho do Homem deve sofrer muito, ser rejeitado pelos anciãos, pelos sumos sacerdotes e doutores da Lei, deve ser morto e ressuscitar ao terceiro dia»."
,"23":"Depois Jesus disse a todos: «Se alguém quer seguir-Me, renuncie a si mesmo, tome cada dia a sua cruz e siga-Me."
,"24":"Pois, quem quiser salvar a vida, vai perdê-la; mas, quem perde a vida por minha causa, salvá-la-á."
,"25":"De facto, que adianta um homem ganhar o mundo inteiro, perdendo-se e destruindo-se a si mesmo?"
,"26":"Se alguém se envergonhar de Mim e das minhas palavras, o Filho do Homem também Se envergonhará dele quando vier na sua glória, na glória do Pai e dos santos anjos."
,"27":"Garanto-vos: alguns aqui presentes não morrerão sem terem visto o Reino de Deus»."
,"28":"Oito dias após dizer estas palavras, Jesus tomou consigo Pedro, João e Tiago, e subiu à montanha para rezar."
,"29":"Enquanto rezava, o seu rosto mudou de aparência e as suas vestes ficaram muito brancas e brilhantes."
,"30":"Nisto, dois homens conversavam com Jesus: eram Moisés e Elias."
,"31":"Apareceram na glória, e conversavam sobre o êxodo de Jesus que iria acontecer em Jerusalém."
,"32":"Pedro e os companheiros dormiam profundamente. Quando acordaram, viram a glória de Jesus e os dois homens que estavam com Ele."
,"33":"E quando estes homens já se afastavam, Pedro disse a Jesus: «Mestre, é bom ficarmos aqui. Vamos fazer três tendas: uma para Ti, outra para Moisés e outra para Elias».Pedro não sabia o que estava a dizer."
,"34":"Quando ainda falava, desceu uma nuvem e encobriu-os com a sua sombra. Os discípulos ficaram com medo quando entraram na nuvem."
,"35":"Mas da nuvem saiu uma voz que dizia: «Este é o meu Filho, o Escolhido. Escutai o que Ele diz!»"
,"36":"Quando a voz se fez ouvir, Jesus estava sozinho. Os discípulos guardaram silêncio e nesses dias não contaram a ninguém nada do que tinham visto."
,"37":"No dia seguinte, quando desceram da montanha, uma grande multidão foi ao encontro deles."
,"38":"Um homem gritou do meio da multidão: «Mestre, eu Te peço, vem ver o meu filho, pois é o meu único filho."
,"39":"Um espírito apodera-se dele e, de repente, solta gritos, sacode-o e fá-lo espumar."
,"40":"Eu pedi aos teus discípulos para expulsarem o espírito, mas eles não conseguiram»."
,"41":"Jesus disse: «Ó geração sem fé e pervertida! Até quando deverei ficar convosco e ter que vos suportar? Traz cá o teu filho»."
,"42":"Quando o menino se aproximava, o demónio atirou-o ao chão e sacudiu-o. Então Jesus ordenou ao espírito mau e curou o menino. Depois entregou-o ao pai."
,"43":"Todos ficaram admirados com a grandeza de Deus. O povo estava admirado com tudo o que Jesus fazia. Então Jesus disse aos discípulos: "
,"44":"«Prestai bem atenção ao que vou dizer-vos: o Filho do Homem vai ser entregue às mãos dos homens»."
,"45":"Mas os discípulos não compreendiam o que Jesus dizia. Isto estava-lhes escondido, para que não entendessem. E tinham receio de fazer perguntas sobre o assunto."
,"46":"Houve entre os discípulos uma discussão, para saber qual deles seria o maior."
,"47":"Jesus sabia o que eles pensavam. Pegou então numa criança, colocou-a junto de Si"
,"48":"e disse-lhes: «Quem receber esta criança em meu nome, é a Mim que recebe. E quem Me receber, recebe Aquele que Me enviou. Pois, quem for o menor entre vós, esse é o maior»."
,"49":"João disse a Jesus: «Mestre, vimos um homem expulsar demónios em teu nome. Mas nós proibimo-lho, porque ele não anda connosco»."
,"50":"Jesus disse-lhes: «Não lho proibais. Pois, quem não está contra vós, está a vosso favor»."
,"51":"Estava a chegar o tempo de Jesus ser levado para o Céu. Então tomou a firme decisão de partir para Jerusalém,"
,"52":"e enviou mensageiros à sua frente. Estes puseram-se a caminho e entraram num povoado de samaritanos, para conseguir alojamento para Jesus."
,"53":"Mas os samaritanos não O receberam, porque Jesus dava a impressão de quem se dirigia para Jerusalém."
,"54":"Vendo isto, os discípulos Tiago e João disseram: «Senhor, queres que mandemos descer fogo do céu para acabar com eles?»"
,"55":"Jesus, porém, voltou-Se e repreendeu-os."
,"56":"E partiram para outro povoado."
,"57":"Enquanto iam a caminho, alguém disse a Jesus: «Seguir-Te-ei para onde quer que fores»."
,"58":"Mas Jesus respondeu-lhe: «As raposas têm tocas e os pássaros têm ninhos; mas o Filho do Homem não tem onde repousar a cabeça»."
,"59":"Jesus disse a outro: «Segue-Me».Ele respondeu: «Deixa-me primeiro ir sepultar meu pai»."
,"60":"Jesus respondeu: «Deixa que os mortos sepultem os seus próprios mortos; mas tu, vai anunciar o Reino de Deus»."
,"61":"Outro ainda disse-Lhe: «Seguir-Te-ei, Senhor, mas deixa que primeiro vá despedir-me da gente da minha casa»."
,"62":"Mas Jesus respondeu-lhe: «Quem põe a mão no arado e olha para trás, não serve para o Reino de Deus»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"O Senhor escolheu outros setenta e dois discípulos e enviou-os dois a dois, à sua frente, a todas as cidades e lugares aonde Ele próprio devia ir."
,"2":"E dizia-lhes: «A colheita é grande, mas os trabalhadores são poucos. Por isso pedi ao dono da colheita que mande trabalhadores para a colheita."
,"3":"Ide! Envio-vos como cordeiros para o meio de lobos."
,"4":"Não leveis bolsa, nem sacola, nem sandálias, e não pareis no caminho para cumprimentar ninguém."
,"5":"Em qualquer casa onde entrardes, dizei primeiro: 'A paz esteja nesta casa!'"
,"6":"Se ali morar alguém de paz, a vossa paz irá repousar sobre ele; se não, ela voltará para vós."
,"7":"Permanecei nessa casa, comei e bebei do que tiverem, porque o trabalhador merece o seu salário. Não andeis de casa em casa."
,"8":"Quando entrardes numa cidade e fordes bem recebidos, comei o que vos servirem,"
,"9":"curai os doentes que nela houver. E dizei ao povo: 'O Reino de Deus está próximo de vós!'"
,"10":"Mas quando entrardes numa cidade e não fordes bem recebidos, saí pelas ruas e dizei:"
,"11":"'Até a poeira desta cidade, que se pegou aos nossos pés, sacudimos contra vós. Apesar disso, sabei que o Reino de Deus está próximo'."
,"12":"Eu vos afirmo: no dia do julgamento, Deus será mais tolerante com Sodoma do que com aquela cidade."
,"13":"Ai de ti, Corazim! Ai de ti, Betsaida! Porque, se em Tiro e Sidónia tivessem sido realizados os milagres que foram feitos no meio de vós, há muito tempo teriam feito penitência, vestindo-se de cilício e sentando-se sobre cinzas."
,"14":"Pois bem: no dia do julgamento, Tiro e Sidónia terão uma sentença menos dura que vós."
,"15":"Ai de ti, Cafarnaum! Serás erguida até ao céu? Serás mas é lançada no inferno!"
,"16":"Quem vos ouve, a Mim ouve, e quem vos rejeita, rejeita-Me a Mim; mas quem Me rejeita, rejeita Aquele que Me enviou»."
,"17":"Os setenta e dois voltaram muito alegres, dizendo: «Senhor, até os demónios nos obedecem por causa do teu nome»."
,"18":"Jesus respondeu: «Eu vi Satanás cair do céu como um relâmpago."
,"19":"Olhai que vos dei poder de andar sobre cobras e escorpiões e sobre toda a força do inimigo, e nada vos poderá fazer mal."
,"20":"Contudo, não vos alegreis porque os maus espíritos vos obedecem; antes, alegrai-vos porque os vossos nomes estão escritos no Céu»."
,"21":"Nesse instante, Jesus alegrou-Se no Espírito Santo e disse: «Eu Te louvo, Pai, Senhor do Céu e da Terra, porque escondeste estas coisas aos sábios e inteligentes e as revelaste aos pequeninos. Sim, Pai, porque assim foi do teu agrado."
,"22":"Meu Pai entregou-Me tudo a Mim. Ninguém conhece quem é o Filho, a não ser o Pai, e ninguém conhece quem é o Pai a não ser o Filho e aquele a quem o Filho O quiser revelar»."
,"23":"E Jesus voltou-Se para os discípulos, e disse-lhes em particular: «Felizes os olhos que vêem o que vós vedes."
,"24":"Pois Eu digo-vos que muitos profetas quiseram ver o que vós vedes e não puderam ver; quiseram ouvir o que vós ouvis e não puderam ouvir»."
,"25":"Um especialista em leis levantou-se e, para tentar Jesus, perguntou: «Mestre, que devo fazer para receber em herança a vida eterna?»"
,"26":"Jesus disse-lhe: «O que é que está escrito na Lei? Como é que lês?»"
,"27":"Ele então respondeu: «Amarás o Senhor, teu Deus, com todo o teu coração, com toda a tua alma, com todas as tuas forças e com toda a tua mente; e ao teu próximo como a ti mesmo»."
,"28":"Jesus disse-lhe: «Respondeste bem. Faz isso e viverás!»"
,"29":"Mas o especialista em leis, querendo justificar-se, disse a Jesus: «E quem é o meu próximo?»"
,"30":"Jesus respondeu: «Um homem descia de Jerusalém para Jericó, e caiu nas mãos de salteadores, que lhe roubaram tudo e o espancaram. Depois foram-se embora e deixaram-no quase morto."
,"31":"Por acaso, um sacerdote descia por aquele caminho; quando viu o homem, passou adiante, pelo outro lado."
,"32":"O mesmo aconteceu com um levita: chegou ao lugar, viu, e passou adiante, pelo outro lado."
,"33":"Mas um samaritano, que ia de viagem, chegou perto dele, viu, e teve compaixão."
,"34":"Aproximou-se dele e fez-lhe o curativo, derramando azeite e vinho nas feridas. Depois colocou-o no seu animal e levou-o a uma pensão, onde cuidou dele."
,"35":"No dia seguinte, pegou em duas moedas de prata e entregou-as ao dono da pensão, recomendando: 'Toma conta dele. Quando eu voltar, vou pagar o que ele tiver gasto a mais'».E Jesus perguntou:"
,"36":"«Na tua opinião, qual dos três foi o próximo do homem que caiu nas mãos dos salteadores?»"
,"37":"O especialista em leis respondeu: «Aquele que usou de misericórdia para com ele». Então Jesus disse-lhe: «Vai e faz a mesma coisa»."
,"38":"Enquanto caminhavam, Jesus entrou numa aldeia, e certa mulher, de nome Marta, recebeu-O em sua casa."
,"39":"Sua irmã, chamada Maria, sentou-se aos pés do Senhor e escutava a sua palavra."
,"40":"Marta estava ocupada com muitos afazeres. Aproximou-se e disse: «Senhor, não Te importas que minha irmã me deixe sozinha com todo o serviço? Diz-lhe que me venha ajudar!»"
,"41":"O Senhor, porém, respondeu: «Marta, Marta! Preocupas-te e andas agitada com muitas coisas;"
,"42":"porém, uma só coisa é necessária. Maria escolheu a melhor parte, que lhe não será tirada»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Um dia, Jesus fazia oração em certo lugar. Quando terminou, um dos discípulos pediu: «Senhor, ensina-nos a rezar, como também João ensinou os seus discípulos»."
,"2":"Jesus respondeu: «Quando rezardes, dizei: Pai, santificado seja o teu nome. Venha o teu Reino."
,"3":"Dá-nos em cada dia o pão de amanhã,"
,"4":"e perdoa-nos os nossos pecados, pois também nós perdoamos a todos aqueles que nos ofendem; e não nos deixes cair em tentação»."
,"5":"Jesus acrescentou: «Se alguém de vós tivesse um amigo e fosse procurá-lo à meia-noite, dizendo: 'Amigo, empresta-me três pães,"
,"6":"porque um amigo meu chegou de viagem e não tenho nada para lhe oferecer'."
,"7":"E se o outro, lá de dentro, respondesse: 'Não me incomodes! Já tranquei a porta, os meus filhos e eu já nos deitámos; não posso levantar-me para te dar os pães!'"
,"8":"Eu vos declaro: mesmo que o outro não se levante para dar os pães porque é seu amigo, vai levantar-se ao menos por causa da impertinência dele e dar tudo aquilo que o amigo necessita."
,"9":"Portanto, Eu vos digo: pedi e ser-vos-á dado! Procurai e encontrareis! Batei e abrir-vos-ão a porta!"
,"10":"Pois, todo aquele que pede, recebe; quem procura, acha; e a quem bate, a porta será aberta."
,"11":"Será que alguém de vós que é pai, se o filho lhe pede um peixe, em lugar do peixe lhe dá uma cobra?"
,"12":"Ou ainda: se pede um ovo, será que lhe vai dar um escorpião?"
,"13":"Se vós, que sois maus, sabeis dar coisas boas aos filhos, quanto mais o Pai do céu! Ele dará o Espírito Santo àqueles que Lh'O pedirem»."
,"14":"Jesus estava a expulsar um demónio que era mudo. Quando o demónio saiu, o mudo começou a falar, e as multidões ficaram admiradas."
,"15":"Mas alguns disseram: «É por Belzebu, o príncipe dos demónios, que Ele expulsa os demónios»."
,"16":"Outros, para tentar Jesus, pediram-Lhe um sinal do céu."
,"17":"Mas, conhecendo o pensamento deles, Jesus disse: «Todo o reino dividido em grupos que lutam entre si será destruído; e uma casa cairá sobre outra."
,"18":"Ora, se até Satanás está dividido contra si mesmo, como é que o seu reino poderá sobreviver? Vós dizeis que é por Belzebu que Eu expulso os demónios."
,"19":"Se é através de Belzebu que Eu expulso os demónios, através de quem é que os vossos filhos os expulsam? Por isso, eles mesmos hão-de julgar-vos."
,"20":"Mas, se é pelo dedo de Deus que Eu expulso os demónios, então o Reino de Deus chegou até vós."
,"21":"Quando um homem forte e bem armado guarda a sua casa, os seus bens estão em segurança."
,"22":"Mas, quando chega um homem mais forte do que ele e o vence, arranca-lhe a armadura em que ele confiava e reparte o que roubou."
,"23":"Quem não está comigo, está contra Mim. E quem não recolhe comigo, espalha»."
,"24":"«Quando um espírito mau sai de um homem, vagueia por lugares desertos à procura de repouso, e não o encontra. Então diz: 'Vou voltar para a casa de onde saí»."
,"25":"Quando chega, encontra a casa varrida e arrumada."
,"26":"Então vai e traz consigo outros sete espíritos piores do que ele. Entram, instalam-se ali e, no fim, aquele homem fica em condições piores do que antes»."
,"27":"Enquanto Jesus dizia estas coisas, uma mulher levantou a voz no meio da multidão e disse-Lhe: «Feliz o ventre que Te trouxe e os seios que Te amamentaram»."
,"28":"Jesus respondeu: «Mais felizes são aqueles que ouvem a Palavra de Deus e a põem em prática»."
,"29":"Quando as multidões se reuniram, Jesus começou a dizer: «Esta geração é uma geração má. Ela busca um sinal, mas nenhum sinal lhe será dado, a não ser o sinal de Jonas."
,"30":"De facto, assim como Jonas foi um sinal para os ninivitas, assim também será o Filho do Homem para esta geração."
,"31":"No dia do julgamento, a rainha do Sul levantar-se-á contra os homens desta geração e condená-los-á. Porque ela veio de uma terra distante para ouvir a sabedoria de Salomão. E aqui está quem é maior do que Salomão."
,"32":"No dia do julgamento, os homens da cidade de Nínive levantar-se-ão contra esta geração. Porque eles fizeram penitência quando ouviram Jonas pregar. E aqui está quem é maior do que Jonas»."
,"33":"«Ninguém acende uma lâmpada para a colocar em lugar escondido ou debaixo de uma vasilha, mas para a colocar no candeeiro, a fim de que todos os que entram vejam a luz."
,"34":"A lâmpada do corpo é o olho. Quando o olho é são, o corpo inteiro também fica iluminado. Mas, se ele está doente, o corpo também fica na escuridão."
,"35":"Portanto, vê se a luz que es-tá em ti não é escuridão."
,"36":"Se o teu cor-po inteiro é luminoso, sem nenhuma parte escura, ficará todo luminoso, como quando a lâmpada te ilumina com o seu clarão»."
,"37":"Enquanto Jesus falava, um fariseu convidou-O para jantar em sua casa. Jesus entrou e pôs-Se à mesa."
,"38":"O fariseu ficou admirado ao ver que Jesus não tinha lavado as mãos antes da refeição."
,"39":"O Senhor disse ao fariseu: «Vós, fariseus, limpais o copo e o prato por fora, mas o vosso interior está cheio de roubo e maldade."
,"40":"Gente sem juízo! Aquele que fez o exterior não fez também o interior?"
,"41":"Antes, dai em esmola o que possuís e tudo para vós ficará puro."
,"42":"Mas ai de vós, fariseus, porque pagais o dízimo da hortelã, da arruda e de todas as outras ervas, mas deixais de lado a justiça e o amor de Deus. Deveríeis praticar isto, sem deixar de lado aquilo."
,"43":"Ai de vós, fariseus, porque gostais dos lugares de honra nas sinagogas e de serdes cumprimentados nas praças públicas."
,"44":"Ai de vós, porque sois como túmulos que não se vêem, e os homens passam sobre eles sem saber»."
,"45":"Um especialista em leis tomou a palavra e disse: «Mestre, falando assim também nos insultas a nós!»"
,"46":"Jesus respondeu: «Ai de vós também, especialistas em leis! Porque impondes sobre os homens cargas insuportáveis e vós mesmos não tocais essas cargas nem com um só dedo."
,"47":"Ai de vós, porque construís túmulos para os profetas; no entanto, foram os vossos pais que os mataram."
,"48":"Com isto, sois testemunhas e aprovais as obras dos vossos pais, pois eles mataram os profetas e vós construís os túmulos."
,"49":"É por isso que a sabedoria de Deus disse: 'Enviar-lhes-ei profetas e apóstolos. Eles matá-los-ão e persegui-los-ão,"
,"50":"a fim de que se peça contas a esta geração do sangue de todos os profetas, derramado desde a criação do mundo,"
,"51":"desde o sangue de Abel até ao sangue de Zacarias, que foi morto entre o altar e o santuário'. Sim, Eu vos digo: pedirão contas disso a esta geração."
,"52":"Ai de vós, especialistas em leis, porque vos apoderastes da chave da ciência. Vós mesmos não entrastes e impedistes os que queriam entrar»."
,"53":"Quando Jesus saiu dali, os doutores da Lei e os fariseus começaram a tratá-l'O mal e a provocá-l'O sobre muitos pontos."
,"54":"Armavam ciladas, para O apanharem de surpresa em qualquer coisa que saísse da sua boca."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Entretanto, milhares de pessoas reuniram-se, a ponto de se pisarem uns aos outros. Jesus começou a dizer primeiro aos seus discípulos: «Tomai cuidado com o fermento dos fariseus, que é a hipocrisia."
,"2":"Não há nada de escondido que não venha a ser revelado, e não há nada oculto que não venha a ser conhecido."
,"3":"Pelo contrário, tudo o que tiverdes feito na escuridão será ouvido à luz do dia; e o que tiverdes pronunciado em segredo, nos quartos, será proclamado sobre os telhados»."
,"4":"«Pois bem, digo-vos a vós, meus amigos: não tenhais medo daqueles que matam o corpo, e depois disso nada mais podem fazer."
,"5":"Vou mostrar-vos a quem deveis temer: temei Aquele que, depois de matar, tem poder para vos lançar no inferno. Eu digo-vos: é a Este que deveis temer."
,"6":"Não se vendem cinco pardais por algumas moedas? No entanto, nenhum deles é esquecido por Deus."
,"7":"Até mesmo os cabelos da vossa cabeça estão todos contados. Não tenhais medo! Valeis mais do que muitos pardais."
,"8":"Eu digo-vos: todo aquele que der testemunho de Mim diante dos homens, o Filho do Homem também dará testemunho dele diante dos anjos de Deus."
,"9":"Mas aquele que Me renegar diante dos homens será renegado diante dos anjos de Deus."
,"10":"Todo aquele que disser alguma coisa contra o Filho do Homem será perdoado. Mas quem blasfemar contra o Espírito Santo não será perdoado."
,"11":"Quando vos levarem às sinagogas, magistrados e autoridades, não fiqueis preocupados com a vossa defesa ou com o que haveis de dizer."
,"12":"Pois nessa hora o Espírito Santo vos ensinará o que deveis dizer»."
,"13":"Do meio da multidão, alguém disse a Jesus: «Mestre, diz a meu irmão que reparta a herança comigo»."
,"14":"Jesus respondeu-lhe: «Homem, quem Me encarregou de julgar ou dividir os bens entre vós?»"
,"15":"Depois Jesus disse a todos: «Atenção! Eliminai toda a espécie de ganância. Porque, mesmo que alguém tenha muitas coisas, a sua vida não depende dos seus bens»."
,"16":"E contou-lhes uma parábola: «A terra de um homem rico deu uma grande colheita."
,"17":"E o homem pensou: 'Que vou fazer? Não tenho onde guardar a minha colheita'."
,"18":"Então resolveu: 'Já sei o que devo fazer! Vou derrubar os meus celeiros e construir outros maiores; e neles vou guardar todo o meu trigo, juntamente com os meus bens."
,"19":"Então poderei dizer a mim mesmo: Possuis um bom depósito, uma reserva para muitos anos; descansa, come e bebe, alegra-te!'"
,"20":"Mas Deus disse-lhe: 'Louco! Nesta mesma noite vais ter que devolver a tua vida. E as coisas que preparaste, para quem vão ficar?'"
,"21":"Assim acontece com quem junta tesouros para si mesmo mas não é rico diante de Deus»."
,"22":"Então Jesus disse aos seus discípulos: «Por isso Eu digo-vos: não vos preocupeis com a vida, com o que comer; nem com o corpo, com o que vestir."
,"23":"Pois a vida vale mais do que a comida, e o corpo mais do que o vestuário."
,"24":"Observai os corvos: eles não semeiam nem colhem, não possuem celeiros ou armazéns. E, no entanto, Deus alimenta-os. Valeis muito mais do que as aves."
,"25":"Quem de vós pode crescer um centímetro à custa de se preocupar com isso?"
,"26":"Portanto, se não podeis nem sequer fazer a menor coisa, porque vos inquietais com o resto?"
,"27":"Observai como crescem os lírios: não fiam, nem tecem. Porém, digo-vos que nem mesmo o rei Salomão, em toda a sua glória, se vestiu como um deles."
,"28":"Se Deus veste assim a erva do campo, que hoje existe e amanhã é queimada no forno, quanto mais fará por vós, gente de pouca fé!"
,"29":"Quanto a vós, não vos inquieteis com o que haveis de comer ou de beber."
,"30":"Porque os pagãos deste mundo é que procuram tudo isto. O Pai bem sabe que tendes necessidade destas coisas."
,"31":"Portanto, buscai o seu Reino, e Deus dar-vos-á essas coisas em acréscimo."
,"32":"Não tenhas medo, pequeno rebanho, porque o vosso Pai tem prazer em dar-vos o Reino."
,"33":"Vendei os bens e dai o dinheiro em esmola. Fazei bolsas que não envelhecem, um tesouro que não perde o seu valor no céu: lá o ladrão não chega nem a traça rói."
,"34":"De facto, onde está o teu tesouro aí estará também o teu coração»."
,"35":"«Permanecei com os rins cingidos e com as lâmpadas acesas."
,"36":"Sede como homens que esperam o seu senhor ao voltar da festa de casamento: logo que ele chega e bate, eles imediatamente vão abrir a porta."
,"37":"Felizes dos empregados que o senhor encontra acordados quando chega. Eu vos garanto: ele mesmo se cingirá, os fará sentar à mesa, e, passando, os servirá."
,"38":"E caso ele chegue à meia-noite ou às três da madrugada, felizes serão se assim os encontra!"
,"39":"Mas ficai certos: se o dono da casa soubesse a hora em que o ladrão iria chegar, não deixaria que lhe arrombasse a casa."
,"40":"Vós também estai preparados! Porque o Filho do Homem vai chegar na hora em que menos esperais»."
,"41":"Então Pedro disse a Jesus: «Senhor, contaste esta parábola só para nós, ou para todos?»"
,"42":"E o Senhor respondeu: «Quem é o administrador fiel e prudente que o senhor coloca à frente do pessoal da sua casa, para dar a refeição a todos na hora certa?"
,"43":"Feliz o empregado que o senhor, ao chegar, encontrar fazendo assim!"
,"44":"Em verdade vos digo: o senhor confiar-lhe-á a administração de todos os seus bens."
,"45":"Mas, se esse empregado pensar: 'O meu patrão vai demorar-se', e começar a bater nos criados e criadas, a comer, beber e embriagar-se,"
,"46":"o senhor desse empregado chegará num dia inesperado e numa hora imprevista. O senhor expulsá-lo-á de casa, fazendo-lhe partilhar a sorte dos infiéis."
,"47":"Todavia aquele empregado que, mesmo conhecendo a vontade do seu senhor, não ficou preparado, nem agiu conforme a vontade dele, será chicoteado muitas vezes."
,"48":"Mas o empregado que não sabia e fez coisas que merecem castigo, será chicoteado poucas vezes. A quem muito foi dado, muito será pedido; a quem muito foi confiado, muito mais será exigido»."
,"49":"«Vim para lançar fogo sobre a Terra: e como gostaria que já estivesse aceso!"
,"50":"Devo ser baptizado com um baptismo, e como estou ansioso até que isso se cumpra!"
,"51":"Pensais que vim trazer a paz à terra? Pelo contrário, Eu digo-vos, vim trazer divisão."
,"52":"Pois, daqui em diante, numa família de cinco pessoas, três ficarão divididas contra duas, e duas contra três."
,"53":"Ficarão divididos: o pai contra o filho, e o filho contra o pai; a mãe contra a filha, e a filha contra a mãe; a sogra contra a nora, e a nora contra a sogra»."
,"54":"Jesus dizia também às multidões: «Quando vedes uma nuvem vinda do Ocidente, logo dizeis que vem chuva; e assim acontece."
,"55":"Quando sentis soprar o vento do Sul, dizeis que vai fazer calor; e assim acontece."
,"56":"Hipócritas! Sabeis interpretar o aspecto da terra e do céu. Como é que não sabeis interpretar o tempo presente?"
,"57":"Porque não julgais por vós mesmos o que é justo?"
,"58":"Quando, pois, estiveres para te apresentar com o teu adversário diante do magistrado, procura resolver o caso com o adversário enquanto ides a caminho, senão este levar-te-á ao juiz, e o juiz entregar-te-á ao guarda, e o guarda meter-te-á na cadeia."
,"59":"Eu digo-te que não sairás de lá enquanto não pagares até ao último centavo»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Nessa ocasião, chegaram algumas pessoas levando notícias a Jesus sobre os galileus que Pilatos tinha matado, enquanto ofereciam sacrifícios."
,"2":"Jesus respondeu-lhes: «Pensais que esses galileus, por terem sofrido tal sorte, eram mais pecadores do que todos os outros galileus?"
,"3":"De modo nenhum, vo-lo digo Eu. E se não vos converterdes, todos morrereis do mesmo modo."
,"4":"E aqueles dezoito que morreram quando a torre de Siloé caiu sobre eles? Pensais que eram mais culpados do que todos os outros moradores de Jerusalém?"
,"5":"De modo algum, vo-lo digo Eu. E se não vos converterdes, todos morrereis do mesmo modo»."
,"6":"Então Jesus contou esta parábola: «Certo homem tinha uma figueira plantada no meio da vinha. Foi até ela procurar figos, e não encontrou."
,"7":"Então disse ao agricultor: 'Olha! Há já três anos que venho procurar figos a esta figueira e não encontro nada! Corta-a. Ela só está a esgotar a terra'."
,"8":"Mas o agricultor respondeu: 'Senhor, deixa a figueira ainda este ano. Vou cavar em volta dela e deitar adubo."
,"9":"Quem sabe, talvez venha a dar fruto! Se não der, então cortá-la-ás'»."
,"10":"Jesus ensinava numa sinagoga em dia de sábado."
,"11":"Estava lá uma mulher que, havia dezoito anos, estava com um espírito que a tornava doente. Era encurvada e incapaz de se endireitar."
,"12":"Vendo-a, Jesus dirigiu-Se a ela e disse: «Mulher, estás livre da tua doença»."
,"13":"Jesus colocou as mãos sobre ela, e imediatamente a mulher endireitou-se e começou a louvar a Deus."
,"14":"O chefe da sinagoga ficou furioso, porque Jesus tinha feito uma cura em dia de sábado. E tomando a palavra, começou a dizer à multidão: «Há seis dias para trabalhar. Vinde, então, nesses dias para serdes curados, e não em dia de sábado»."
,"15":"O Senhor respondeu-lhe: «Hipócritas! Cada um de vós não solta o boi ou o jumento para lhe dar de beber, mesmo que seja dia de sábado?"
,"16":"Está aqui uma filha de Abraão que Satanás amarrou durante dezoito anos. Será que não deveria ser libertada dessa prisão em dia de sábado?»"
,"17":"Esta resposta deixou confusos todos os inimigos de Jesus. E toda a multidão se alegrava com as maravilhas que Jesus fazia."
,"18":"E Jesus dizia: «A que é semelhante o Reino de Deus, e com que poderia compará-lo?"
,"19":"É como a semente de mostarda que um homem toma e semeia na sua horta. A semente cresce, torna-se árvore, e as aves do céu fazem os ninhos nos seus ramos»."
,"20":"Jesus disse ainda: «Com que poderia comparar o Reino de Deus?"
,"21":"É como o fermento que uma mulher toma e mistura com três porções de farinha, até que tudo fique fermentado»."
,"22":"Jesus atravessava cidades e aldeias, ensinando e seguindo a caminho de Jerusalém."
,"23":"Alguém Lhe perguntou: «Senhor, é verdade que são poucos aqueles que se salvam?» Jesus respondeu:"
,"24":"«Esforçai-vos por entrar pela porta estreita, porque vos digo: muitos tentarão entrar e não conseguirão."
,"25":"Uma vez que o dono da casa se levante e feche a porta, ficareis fora. E começareis a bater à porta, dizendo: 'Senhor, abre-nos a porta!' E Ele responderá: 'Não sei de onde sois'."
,"26":"E começareis a dizer: 'Nós comíamos e bebíamos diante de Ti e ensinavas nas nossas praças!'"
,"27":"Mas Ele responderá: 'Não sei de onde sois. Afastai-vos de Mim, todos vós que praticais a injustiça!'"
,"28":"Lá haverá choro e ranger de dentes, quando virdes Abraão, Isaac e Jacob com todos os profetas no Reino de Deus, e vós postos fora."
,"29":"Muita gente virá do Oriente e do Ocidente, do Norte e do Sul, e tomarão lugar à mesa no Reino de Deus."
,"30":"Há últimos que serão primeiros, e primeiros que serão últimos»."
,"31":"Naquele momento, alguns fariseus aproximaram-se e disseram a Jesus: «Parte daqui, porque Herodes quer matar-Te»."
,"32":"Jesus disse: «Ide dizer a essa raposa: eu expulso demónios e faço curas hoje e amanhã; e no terceiro dia terminarei o meu trabalho."
,"33":"Entretanto preciso de caminhar hoje, amanhã e depois de amanhã, porque não convém que um profeta morra fora de Jerusalém»."
,"34":"«Jerusalém, Jerusalém, tu que matas os profetas e apedrejas os que te foram enviados! Quantas vezes Eu quis reunir os teus filhos, como a galinha reúne os pintainhos debaixo das asas, mas tu não quiseste!"
,"35":"Eis que a vossa casa ficará abandonada. Eu vos digo: não Me vereis, até que chegue o tempo em que digais: Bendito Aquele que vem em nome do Senhor»."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Num dia de sábado aconteceu que Jesus foi comer em casa de um dos chefes dos fariseus, que O observavam."
,"2":"Havia um homem hidrópico diante de Jesus."
,"3":"Tomando a palavra, Jesus falou aos especialistas em leis e aos fariseus: «A Lei permite ou não curar em dia de sábado?»"
,"4":"Mas eles ficaram em silêncio. Então Jesus tomou o homem pela mão, curou-o e despediu-o."
,"5":"Depois disse-lhes: «Se a alguém de vós um filho ou um boi cair num poço, não o irá logo retirar, mesmo em dia de sábado?»"
,"6":"E eles não foram capazes de responder a isto."
,"7":"Jesus notou como os convidados escolhiam os primeiros lugares. Então contou-lhes uma parábola:"
,"8":"«Se alguém te convidar para uma festa de casamento, não ocupes o primeiro lugar. Pode ser que tenha sido convidado alguém mais importante do que tu;"
,"9":"e o dono da casa, que convidou os dois, venha dizer-te: 'Dá o lugar a este'. Então ficarás envergonhado e irás ocupar o último lugar."
,"10":"Pelo contrário, quando fores convidado, vai sentar-te no último lugar. Assim, quando chegar quem te convidou, dir-te-á: 'Amigo, vem mais para cima'. E isso vai ser uma honra para ti na presença de todos os convidados."
,"11":"De facto, quem se eleva será humilhado e quem se humilha será ele-vado»."
,"12":"Jesus disse também ao fariseu que O tinha convidado: «Quando deres um almoço ou jantar, não convides amigos, nem irmãos, nem parentes, nem vizinhos ricos. Porque eles irão, por sua vez, convidar-te. E isso será para ti uma recompensa."
,"13":"Pelo contrário, quando deres uma festa, convida pobres, aleijados, coxos e cegos."
,"14":"Então serás feliz! Porque eles não te podem retribuir. E receberás a recompensa na ressurreição dos justos»."
,"15":"Ouvindo isto, um homem que estava à mesa disse a Jesus: «Feliz aquele que come pão no Reino de Deus!»"
,"16":"Jesus respondeu: «Um homem deu um grande banquete e convidou muitas pessoas."
,"17":"Na hora do banquete, mandou o seu empregado dizer aos convidados: 'Vinde, pois tudo está pronto'."
,"18":"Mas todos, um a um, começaram a desculpar-se. O primeiro disse: 'Comprei um campo e preciso de ir vê-lo. Peço-te que aceites as minhas desculpas'."
,"19":"Outro disse: 'Comprei cinco juntas de bois e vou experimentá-las. Peço-te que aceites as minhas desculpas'."
,"20":"Um terceiro disse: 'Acabo de me casar e, por isso, não posso ir'."
,"21":"O empregado voltou e contou tudo ao patrão. Então o dono da casa ficou muito zangado e disse ao empregado: 'Sai depressa às praças e às ruas da cidade. Traz para cá os pobres, os aleijados, os cegos e os coxos'."
,"22":"O empregado disse: 'Senhor, o que mandaste fazer foi feito, e ainda há lugar'."
,"23":"O patrão disse ao empregado: 'Sai às estradas e caminhos e obriga as pessoas a virem aqui, para que a casa fique cheia."
,"24":"Pois eu digo-vos: nenhum daqueles que foram convidados vai provar do meu banquete'»."
,"25":"Grandes multidões acompanhavam Jesus. Voltando-Se, Ele disse:"
,"26":"«Se alguém vem a Mim, e não dá mais preferência a Mim do que ao pai, à mãe, à mulher, aos filhos, aos irmãos, às irmãs, e até mesmo à sua própria vida, não pode ser meu discípulo."
,"27":"Quem não toma a sua cruz e não caminha atrás de Mim, não pode ser meu discípulo."
,"28":"De facto, se alguém de vós quer construir uma torre, será que não vai primeiro sentar-se e calcular os gastos, para ver se tem o suficiente para a terminar?"
,"29":"Caso contrário, lançará o alicerce e não será capaz de acabar. E todos os que virem isso começarão a fazer troça dele, dizendo:"
,"30":"'Este homem começou a construir e não foi capaz de acabar!'"
,"31":"Ou ainda: Se um rei pretende sair para guerrear contra outro, será que não vai sentar-se primeiro e examinar bem se, com dez mil homens, poderá enfrentar o outro que marcha contra ele com vinte mil?"
,"32":"Se vê que não pode, envia mensageiros para negociar as condições de paz, enquanto o outro rei ainda está longe."
,"33":"Do mesmo modo, portanto, qualquer de vós, se não renunciar a tudo o que tem, não pode ser meu discípulo."
,"34":"O sal é bom. Mas se até o sal perde o sabor, com que o salgaremos?"
,"35":"Já não serve para nada: nem para a terra, nem para estrume. Por isso, deitam-no fora. Quem tem ouvidos para ouvir, ouça»."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Todos os cobradores de impostos e pecadores se aproximavam de Jesus para O escutar."
,"2":"Mas os fariseus e os doutores da Lei criticavam Jesus, dizendo: «Este homem acolhe os pecadores e come com eles!»."
,"3":"Então Jesus contou-lhes esta parábola:"
,"4":"«Se um de vós tem cem ovelhas e perde uma, será que não deixa as noventa e nove no campo para ir procurar a ovelha que se perdeu, até a encontrar?"
,"5":"E, quando a encontra, com muita alegria coloca-a aos ombros."
,"6":"Chegando a casa, reúne amigos e vizinhos, para dizer: 'Alegrai-vos comigo! Encontrei a minha ovelha que estava perdida'."
,"7":"E Eu declaro-vos: assim, haverá mais alegria no Céu por um só pecador que se converte, do que por noventa e nove justos que não precisam de conversão»."
,"8":"«Se uma mulher tem dez moedas de prata e perde uma, será que não acende uma lâmpada, varre a casa e procura cuidadosamente, até encontrar a moeda?"
,"9":"Quando a encontra, reúne amigas e vizinhas, para dizer: 'Alegrai-vos comigo! Encontrei a moeda que tinha perdido'."
,"10":"E Eu declaro-vos: os anjos de Deus sentem a mesma alegria por um só pecador que se converte»."
,"11":"Jesus continuou: «Um homem tinha dois filhos."
,"12":"O filho mais novo disse ao pai: 'Pai, dá-me a parte da herança que me cabe'. E o pai dividiu os bens entre eles."
,"13":"Poucos dias depois, o filho mais novo juntou o que era seu e partiu para um lugar distante. E aí esbanjou tudo numa vida desenfreada."
,"14":"Quando tinha gasto tudo o que possuía, houve uma grande fome nessa região e ele começou a passar necessidade."
,"15":"Então foi pedir trabalho a um homem do lugar, que o mandou para os seus campos cuidar dos porcos."
,"16":"O rapaz queria matar a fome com a vianda que os porcos comiam, mas nem isso lhe davam."
,"17":"Então, caindo em si, disse: 'Quantos empregados do meu pai têm pão com fartura, e eu aqui a morrer de fome..."
,"18":"Vou levantar-me, vou ter com meu pai e dizer-lhe: Pai, pequei contra Deus e contra ti;"
,"19":"já não mereço que me chamem teu filho. Trata-me como um dos teus empregados'."
,"20":"Então levantou-se e foi ter com o pai. Quando ainda estava longe, o pai avistou-o e teve compaixão. Correu ao seu encontro, abraçou-o e cobriu-o de beijos. "
,"21":"Então o filho disse: 'Pai, pequei contra Deus e contra ti; já não mereço que me chamem teu filho'."
,"22":"Mas o pai disse aos empregados: 'Depressa, trazei a melhor túnica para vestir o meu filho. E colocai-lhe um anel no dedo e sandálias nos pés."
,"23":"Pegai no novilho gordo e matai-o. Vamos fazer um banquete."
,"24":"Porque este meu filho estava morto e tornou a viver; estava perdido e foi encontrado'. E começaram a festa."
,"25":"O filho mais velho estava no campo. Ao voltar, já perto de casa, ouviu música e barulho de dança."
,"26":"Então chamou um dos criados e perguntou o que estava a acontecer."
,"27":"O criado respondeu: 'É o teu irmão que voltou. E teu pai, porque o recuperou são e salvo, matou o novilho gordo'."
,"28":"Então, o irmão ficou com raiva e não queria entrar. O pai saiu e insistiu com ele."
,"29":"Mas ele respondeu ao pai: 'Eu trabalho para ti há tantos anos, nunca desobedeci a nenhuma ordem tua; e nunca me deste um cabrito para eu festejar com os meus amigos."
,"30":"Quando chegou esse teu filho, que devorou os teus bens com prostitutas, matas o novilho gordo!'"
,"31":"Então o pai disse-lhe: 'Filho, estás sempre comigo e tudo o que é meu é teu."
,"32":"Mas era preciso festejar e alegrar-nos, porque este teu irmão estava morto e tornou a viver; estava perdido, e foi encontrado'»."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Jesus dizia aos discípulos: «Um homem rico tinha um administrador que foi denunciado por lhe esbanjar os bens."
,"2":"Então chamou-o e disse-lhe: 'Que é isto que ouço contar a teu respeito? Presta contas da tua administração, porque não podes continuar a ser meu administrador'."
,"3":"Então o administrador começou a reflectir: 'O senhor vai tirar-me a administração. Que vou fazer? Para cavar, não tenho forças; de mendigar, tenho vergonha."
,"4":"Ah! Já sei o que vou fazer quando me afastarem da administração'."
,"5":"E começou a chamar um por um os que deviam ao seu senhor. Perguntou ao primeiro: 'Quanto deves ao meu patrão?'"
,"6":"Ele respondeu: 'Cem talhas de azeite!' O administrador disse: 'Pega na tua conta, senta-te depressa e escreve cinquenta'."
,"7":"Depois perguntou a outro: 'E tu, quanto deves?' Ele respondeu: 'Cem sacas de trigo'. O administrador disse: 'Pega na tua conta e escreve oitenta'»."
,"8":"E o senhor elogiou o administrador desonesto, porque agiu com esperteza. De facto, os que pertencem a este mundo são mais espertos, no trato com os seus semelhantes, do que aqueles que pertencem à luz."
,"9":"E Eu declaro-vos: «Usai o dinheiro injusto para fazer amigos, e assim, quando o dinheiro faltar, os amigos receber-vos-ão nas moradas eternas."
,"10":"Quem é fiel nas pequenas coisas, também é fiel nas grandes; e quem é injusto nas pequenas, também é injusto nas grandes."
,"11":"Por isso, se não sois fiéis no uso do dinheiro injusto, quem vos confiará o verdadeiro bem?"
,"12":"E se não sois fiéis no que é dos outros, quem vos dará aquilo que é vosso?"
,"13":"Nenhum empregado pode servir a dois senhores; porque, ou odiará um e amará o outro, ou se apegará a um e desprezará o outro. Não podeis servir a Deus e ao dinheiro»."
,"14":"Os fariseus, que eram amigos do dinheiro, ouviam tudo isto e troçavam de Jesus."
,"15":"Então Jesus disse-lhes: «Vós gostais de parecer justos diante dos homens, mas Deus conhece os vossos corações. De facto, o que é importante para os homens é detestável para Deus."
,"16":"A Lei e os profetas chegaram até João; daí para a frente o Reino de Deus é anunciado, e cada um esforça-se por entrar nele, com violência."
,"17":"É mais fácil desaparecer o céu e a terra do que cair da Lei uma só vírgula."
,"18":"Todo o homem que se divorcia da sua mulher e se casa com outra, comete adultério; e quem se casa com uma mulher divorciada do seu marido comete adultério»."
,"19":"«Havia um homem rico que se vestia de púrpura e linho fino e se banqueteava todos os dias."
,"20":"Um pobre, chamado Lázaro, cheio de feridas, estava caído à porta do rico."
,"21":"Ele queria matar a fome com as sobras que caíam da mesa do rico. E ainda vinham os cães lamber-lhe as feridas."
,"22":"Aconteceu que o pobre morreu e os anjos levaram-no para junto de Abraão. Morreu também o rico e foi enterrado."
,"23":"No inferno, no meio dos tormentos, o rico levantou os olhos e viu de longe Abraão, com Lázaro a seu lado."
,"24":"Então o rico gritou: 'Pai Abraão, tem piedade de mim! Manda Lázaro molhar a ponta do dedo para me refrescar a língua, porque este fogo atormenta-me'."
,"25":"Mas Abraão respondeu: 'Lembra-te, filho: tu recebeste os teus bens durante a vida, enquanto Lázaro recebeu males. Agora, porém, ele encontra consolo aqui e tu és atormentado."
,"26":"Além disso, há um grande abismo entre nós: por mais que alguém desejasse, nunca poderia passar daqui para junto de vós, nem os daí poderiam atravessar para junto de nós'."
,"27":"O rico insistiu: 'Pai, eu te suplico, manda Lázaro à casa de meu pai,"
,"28":"porque eu tenho cinco irmãos. Manda preveni-los, para que não venham também para este lugar de tormento'."
,"29":"Mas Abraão respondeu: 'Eles têm Moisés e os profetas: que os escutem!'"
,"30":"O rico insistiu: 'Não, pai Abraão! Se um dos mortos for até eles, eles vão converter-se'."
,"31":"Mas Abraão disse-lhe: 'Se eles não escutam Moisés e os profetas, mesmo que um dos mortos ressuscite, eles não ficarão convencidos'»."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Jesus disse aos seus discípulos: «É inevitável que aconteçam escândalos, mas ai daquele que produz escândalos!"
,"2":"Seria melhor para ele que lhe amarrassem uma pedra de moinho ao pescoço e o lançassem ao mar, do que escandalizar um destes pequeninos."
,"3":"Prestai atenção! Se o teu irmão peca contra ti, avisa-o. Se ele se arrepender, perdoa-lhe."
,"4":"Se ele pecar contra ti sete vezes num só dia e sete vezes vier ter contigo, dizendo: 'Estou arrependido', deves perdoar-lhe»."
,"5":"Os Apóstolos disseram ao Senhor: «Aumenta a nossa fé!»"
,"6":"O Senhor respondeu: «Se tivésseis fé do tamanho de uma semente de mostarda, poderíeis dizer a esta montanha: 'Arranca-te daí e planta-te no mar'. E ela obedecer-vos-ia."
,"7":"Se alguém de vós tem um empregado que trabalha a terra ou cuida dos animais, porventura vai dizer-lhe, quando ele volta do campo: 'Vem depressa para a mesa'?"
,"8":"Pelo contrário, não vai dizer ao empregado: 'Prepara-me o jantar, cinge-te e serve-me, enquanto eu como e bebo; depois disso comerás e beberás'?"
,"9":"Será que vai agradecer ao empregado, por ter feito o que lhe mandou?"
,"10":"Assim também vós: quando tiverdes cumprido tudo o que vos mandarem fazer, dizei: 'Somos empregados inúteis; fizemos o que devíamos fazer'»."
,"11":"Caminhando para Jerusalém, aconteceu que Jesus passava entre a Samaria e a Galileia."
,"12":"Quando estava para entrar numa aldeia, dez leprosos foram ao encontro d'Ele. Mantiveram-se à distância"
,"13":"e gritaram: «Jesus, Mestre, tem compaixão de nós!»"
,"14":"Ao vê-los, Jesus disse: «Ide apresentar-vos aos sacerdotes».Enquando caminhavam, aconteceu que ficaram curados."
,"15":"Ao perceber que estava curado, um deles voltou atrás dando glória a Deus em alta voz."
,"16":"Prostrou-se por terra, aos pés de Jesus, e agradeceu-Lhe. Era um samaritano."
,"17":"Então Jesus perguntou-lhe: «Não foram dez os curados? E os outros nove, onde estão?"
,"18":"Não houve quem voltasse para dar glória a Deus a não ser este estrangeiro?»"
,"19":"E disse-lhe: «Levanta-te e vai. A tua fé te salvou»."
,"20":"Os fariseus perguntaram a Jesus quando chegaria o Reino de Deus. Jesus respondeu: «O reino de Deus não vem ostensivamente."
,"21":"Nem se poderá dizer: 'Está aqui' ou: 'Está ali', porque o Reino de Deus está no meio de vós»."
,"22":"Jesus disse aos discípulos: «Virão dias em que desejareis ver um só dia do Filho do Homem e não podereis vê-lo."
,"23":"Dir-vos-ão: 'Ele está ali' ou: 'Ele está aqui'. Não saiais a procurá-lo."
,"24":"Pois como o relâmpago brilha de um lado ao outro do céu, assim também será o dia do Filho do Homem."
,"25":"Antes, porém, Ele deverá sofrer muito e ser rejeitado por esta geração."
,"26":"Como aconteceu nos dias de Noé, assim também acontecerá nos dias do Filho do Homem."
,"27":"Eles comiam, bebiam, casavam-se e davam-se em casamento, até ao dia em que Noé entrou na arca. Então chegou o dilúvio e fez com que todos morressem."
,"28":"Acontecerá como nos dias de Lot: comiam e bebiam, compravam, plantavam e construíam."
,"29":"Mas, no dia em que Lot saiu de Sodoma, Deus fez chover do céu fogo e enxofre e fez com que todos morressem."
,"30":"O mesmo acontecerá no dia em que o Filho do Homem for revelado."
,"31":"Nesse dia, quem estiver no terraço não desça para apanhar os bens que estão em casa, e quem estiver nos campos não volte para trás."
,"32":"Lembrai-vos da mulher de Lot."
,"33":"Quem procura ganhar a sua vida, vai perdê-la; e quem a perde, vai conservá-la."
,"34":"Eu digo-vos: nessa noite, dois estarão numa cama. Um será tomado e o outro será deixado."
,"35":"Duas mulheres estarão a moer juntas. Uma será tomada e a outra deixada."
,"36":"Dois homens estarão no campo. Um será levado e o outro será deixado»."
,"37":"Os discípulos perguntaram: «Senhor, onde acontecerá isto?» Jesus respondeu: «Onde estiver o corpo, aí se reunirão os abutres»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jesus contou aos discípulos uma parábola, para lhes mostrar a necessidade de rezar sempre, sem nunca desistir. Ele dizia:"
,"2":"«Numa cidade havia um juiz que não temia a Deus e não respeitava os homens."
,"3":"Na mesma cidade havia uma viúva que ia à procura do juiz, pedindo: 'Faz-me justiça contra o meu adversário!'"
,"4":"Durante muito tempo, o juiz recusou-se. Por fim pensou: 'Eu não temo a Deus e não respeito os homens;"
,"5":"mas esta viúva já me está a aborrecer. Vou fazer-lhe justiça, para que ela não venha continuamente incomodar-me'»."
,"6":"E o Senhor acrescentou: «Escutai o que diz este juiz injusto."
,"7":"E Deus não faria justiça aos seus escolhidos que dia e noite gritam por Ele? Será que vai fazê-los esperar?"
,"8":"Eu vos declaro que Deus lhes fará justiça, e bem depressa. Mas o Filho do Homem, quando vier, será que vai encontrar fé sobre a Terra?»."
,"9":"Para alguns que confiavam na sua própria justiça e desprezavam os outros, Jesus contou esta parábola:"
,"10":"«Dois homens subiram ao Templo para rezar; um era fariseu, o outro era cobrador de impostos."
,"11":"O fariseu, de pé, rezava assim no seu íntimo: 'Ó Deus, eu Te agradeço, porque não sou como os outros homens, que são ladrões, desonestos, adúlteros, nem como este cobrador de impostos."
,"12":"Eu faço jejum duas vezes por semana e dou o dízimo de todos os meus rendimentos'."
,"13":"O cobrador de impostos ficou à distância e nem se atrevia a levantar os olhos para o céu, mas batia no peito, dizendo: 'Meu Deus, tem piedade de mim, que sou pecador!'"
,"14":"Eu declaro-vos: este último voltou para casa justificado e o outro não. Pois quem se eleva será humilhado, e quem se humilha será elevado»."
,"15":"Alguns levaram criancinhas para que Jesus lhes tocasse. Vendo isto, os discípulos repreendiam-nos."
,"16":"Jesus, porém, chamou os discípulos e disse-lhes: «Deixai as crianças vir a Mim. Não lho proibais, porque o Reino de Deus pertence-lhes."
,"17":"Garanto-vos: quem não receber como criança o Reino de Deus, nunca entrará nele»."
,"18":"Uma pessoa importante perguntou a Jesus: «Bom Mestre, que devo fazer para receber em herança a vida eterna?»"
,"19":"Jesus respondeu: «Porque Me chamas bom? Só Deus é bom, e ninguém mais."
,"20":"Conheces os mandamentos: Não cometas adultério; não mates; não roubes; não levantes falso testemunho; honra teu pai e tua mãe»."
,"21":"O homem disse: «Desde jovem tenho observado todas estas coisas»."
,"22":"Ouvindo isto, Jesus disse: «Falta-te ainda uma coisa para fazer: vende tudo o que possuis, distribui o dinheiro aos pobres e terás um tesouro no Céu. Depois vem e segue-Me»."
,"23":"Quando ouviu isto o homem ficou triste, porque era muito rico."
,"24":"Vendo isto, Jesus disse: «Como é difícil para os ricos entrar no Reino de Deus!"
,"25":"De facto, é mais fácil um camelo entrar pelo buraco de uma agulha, do que um rico entrar no Reino de Deus»."
,"26":"Os que ouviram isto, disseram: «Então, quem pode ser salvo?»"
,"27":"Jesus disse: «As coisas impossíveis aos homens são possíveis a Deus»."
,"28":"Então Pedro disse: «Vê: nós deixámos os nossos bens e seguimos-Te»."
,"29":"Jesus disse: «Eu vos garanto: quem tiver deixado casa, mulher, irmãos, pais, filhos, por causa do Reino de Deus,"
,"30":"não ficará sem receber muito mais durante esta vida e, no mundo futuro, vai receber a vida eterna»."
,"31":"Jesus chamou à parte os Doze e disse-lhes: «Olhai: subimos para Jerusalém e vai cumprir-se tudo o que foi escrito pelos profetas a respeito do Filho do Homem."
,"32":"Pois Ele será entregue aos pagãos, será escarnecido, ultrajado e coberto de escarros."
,"33":"Vão torturá-l'O e matá-l'O, e ao terceiro dia Ele vai ressuscitar»."
,"34":"Mas eles não compreenderam nada disto. Aquela linguagem era obscura para eles e não compreendiam o que Jesus dizia."
,"35":"Quando Jesus Se aproximava de Jericó, um cego estava sentado à beira do caminho, a pedir esmola."
,"36":"Ouvindo a multidão passar, perguntou o que era aquilo."
,"37":"Disseram-lhe que era Jesus Nazareno que passava por ali."
,"38":"Então o cego gritou: «Jesus, filho de David, tem piedade de mim!»"
,"39":"As pessoas que iam à frente mandavam-no calar. Mas ele gritava cada vez mais: «Filho de David, tem piedade de mim!»"
,"40":"Jesus parou e mandou que Lhe levassem o cego. Quando o cego chegou perto, Jesus perguntou:"
,"41":"«Que queres que Eu te faça?» O cego respondeu: «Senhor, eu quero ver de novo»."
,"42":"Jesus disse: «Vê. Salvou-te a tua fé»."
,"43":"No mesmo instante, o cego começou a ver e seguia Jesus, glorificando a Deus. Vendo isto, todo o povo louvou a Deus."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Jesus tinha entrado em Jericó e atravessava a cidade."
,"2":"Havia ali um homem chamado Zaqueu: era chefe dos cobradores de impostos e muito rico."
,"3":"Zaqueu desejava ver quem era Jesus, mas não o conseguia, por causa da multidão, pois era muito baixo."
,"4":"Então correu à frente, subiu a um sicômoro para O ver, pois Jesus devia passar por ali."
,"5":"Quando Jesus chegou ao lugar, olhou para cima e disse: «Desce depressa, Zaqueu, porque hoje preciso de ficar em tua casa»."
,"6":"Ele desceu rapidamente e recebeu Jesus com alegria."
,"7":"Vendo isto, todos começaram a criticar, dizendo: «Ele foi hospedar-Se na casa de um pecador!»"
,"8":"Zaqueu ficou de pé e disse ao Senhor: «Senhor, vou dar metade dos meus bens aos pobres; e, se roubei alguém, vou devolver quatro vezes mais»."
,"9":"Jesus disse-lhe: «Hoje a salvação entrou nesta casa, porque também este homem é um filho de Abraão."
,"10":"De facto, o Filho do Homem veio procurar e salvar o que estava perdido»."
,"11":"Tendo eles ouvido isto, Jesus acrescentou uma parábola, porque estava perto de Jerusalém, e eles pensavam que o Reino de Deus ia chegar imediatamente."
,"12":"Então Jesus disse: «Um homem nobre partiu para um país distante a fim de ser coroado rei e depois voltar."
,"13":"Chamou então dez dos seus empregados, entregou cem moedas de prata a cada um, e disse: 'Negociai até que eu volte'."
,"14":"Os seus concidadãos, porém, odiavam-no e enviaram uma embaixada atrás dele, dizendo: 'Não queremos que este homem reine sobre nós'."
,"15":"Mas o homem foi coroado rei e voltou. Mandou chamar os empregados, aos quais havia dado o dinheiro, a fim de saber quanto haviam lucrado."
,"16":"O primeiro chegou e disse: 'Senhor, as cem moedas renderam dez vezes mais'."
,"17":"O homem disse: 'Muito bem, empregado bom. Como foste fiel em coisas pequenas, recebe o governo de dez cidades'."
,"18":"O segundo chegou e disse: 'Senhor, as cem moedas renderam cinco vezes mais'."
,"19":"O homem disse também a este: 'Recebe também tu o governo de cinco cidades'."
,"20":"Chegou o outro empregado e disse: 'Senhor, aqui estão as cem moedas que guardei num lenço."
,"21":"Pois eu tinha medo de ti, porque és um homem severo. Tomas o que não deste e colhes o que não semeaste'."
,"22":"O homem disse: 'Empregado mau, eu julgo-te pela tua própria boca. Sabias que sou um homem severo, que tomo o que não dei e colho o que não semeei."
,"23":"Então, porque não depositaste o meu dinheiro no banco? Ao chegar, iria retirá-lo com juros'."
,"24":"Depois disse aos que ali estavam presentes: 'Tirai-lhe as cem moedas e dai-as àquele que tem mil'."
,"25":"Os presentes disseram: 'Senhor, ele já tem mil moedas!'"
,"26":"Ele respondeu: 'Eu digo-vos: a todo aquele que já possui, será dado mais ainda. Mas àquele que nada tem, será tirado até mesmo o que tem."
,"27":"E quanto a esses meus inimigos, que não queriam que eu reinasse sobre eles, trazei-os aqui e matai-os na minha frente'."
,"28":"Depois de dizer estas coisas, Jesus partiu à frente deles, subindo para Jerusalém."
,"29":"Quando Jesus Se aproximou de Betfagé e de Betânia, perto do chamado monte das Oliveiras, enviou dois discípulos,"
,"30":"dizendo: «Ide à aldeia em frente. Quando entrardes nela, encontrareis preso um jumentinho que nunca foi montado. Soltai-o e trazei-o."
,"31":"Se alguém vos perguntar: 'Porque o soltais?', respondereis: 'Porque o Senhor precisa dele'»."
,"32":"Os discípulos foram e encontraram as coisas como Jesus havia dito."
,"33":"Quando estavam a soltar o jumentinho, os donos perguntaram: «Porque soltais o jumentinho?»"
,"34":"Os discípulos responderam: «Porque o Senhor precisa dele»."
,"35":"Então levaram o jumentinho a Jesus. Colocaram os próprios mantos sobre o jumentinho e fizeram montar Jesus."
,"36":"Enquanto caminhavam, as pessoas estendiam os próprios mantos pelo caminho."
,"37":"Quando Jesus estava junto à descida do monte das Oliveiras, toda a multidão de discípulos começou, alegre, a louvar a Deus em voz alta, por todos os milagres que tinha visto."
,"38":"E diziam: «Bendito seja Aquele que vem como Rei, em nome do Senhor! Paz no Céu e glória no mais alto do Céu»."
,"39":"No meio da multidão, alguns fariseus disseram a Jesus: «Mestre, manda que os teus discípulos se calem»."
,"40":"Jesus respondeu: «Eu digo-vos: se eles se calarem, as pedras gritarão»."
,"41":"Jesus aproximou-Se e, quando viu a cidade, começou a chorar."
,"42":"E disse: «Se também tu compreendesses hoje o caminho da paz! Agora, porém, isto está escondido aos teus olhos!"
,"43":"Vão chegar dias em que os inimigos farão trincheiras contra ti, te cercarão e apertarão de todos os lados."
,"44":"Eles esmagar-te-ão a ti e aos teus filhos e não deixarão em ti pedra sobre pedra. Porque não reconheceste o tempo em que Deus veio visitar-te»."
,"45":"Jesus entrou no Templo e começou a expulsar os que lá vendiam."
,"46":"E disse: «Está nas Escrituras: 'A minha casa será casa de oração'. No entanto, vós fizestes dela um covil de ladrões»."
,"47":"Jesus ensinava todos os dias no Templo. Os sumos sacerdotes, os doutores da Lei e os notáveis do povo procuravam maneira de O matar."
,"48":"Mas não sabiam o que fazer, porque o povo ficava fascinado, quando ouvia Jesus falar."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Num daqueles dias, Jesus estava no Templo, a ensinar o povo e a anunciar a Boa Notícia. Então os sumos sacerdotes, os doutores da lei e os anciãos apareceram"
,"2":"e disseram: «Diz-nos com que autoridade fazes estas coisas. Quem foi que Te deu essa autoridade?»"
,"3":"Jesus respondeu: «Eu também vou fazer-vos uma pergunta. Dizei-me:"
,"4":"O baptismo de João vinha do Céu ou dos homens?»"
,"5":"Mas eles comentaram entre si: «Se respondemos que vinha do Céu, Ele vai dizer: 'Porque então não acreditastes em João?'"
,"6":"Se dizemos que vinha dos homens, todo o povo nos apedrejará, porque está convencido de que João era um profeta»."
,"7":"Então eles responderam que não sabiam de onde vinha."
,"8":"E Jesus disse: «Pois então também Eu vos não digo com que autoridade faço estas coisas»."
,"9":"Então Jesus começou a contar ao povo esta parábola: «Um homem plantou uma vinha, arrendou-a a uns agricultores e partiu para uma longa viagem ao estrangeiro."
,"10":"Na época da vindima, mandou um empregado aos agricultores, para que lhe dessem uma parte dos frutos da vinha. Mas os agricultores bateram-lhe e mandaram-no embora sem nada."
,"11":"O dono mandou outro empregado. Os agricultores também lhe bateram, insultaram-no e mandaram-no embora sem nada."
,"12":"O dono mandou ainda um terceiro empregado. Os agricultores também o feriram e deitaram-no fora da vinha."
,"13":"Então o dono da vinha disse: 'Que farei? Vou mandar o meu filho querido. Talvez o respeitem'."
,"14":"Mas, ao vê-lo, os agricultores comentaram entre si: 'Este é o herdeiro. Vamos matá-lo, para ficarmos com a herança'."
,"15":"Então, lançando-o fora da vinha, mataram-no. Pois bem: o que é que o dono da vinha fará a esses agricultores? "
,"16":"Ele virá, destruirá esses agricultores e entregará a vinha a outros».Ouvindo isto, eles disseram: «Que isso não aconteça!»"
,"17":"Jesus olhou atentamente para eles e disse: «Que significa então esta passagem das Escrituras: 'A pedra que os construtores deixaram de lado tornou-se a pedra mais importante'?"
,"18":"Todo o homem que cair sobre esta pedra ficará em pedaços, e aquele sobre quem ela cair ficará esmagado»."
,"19":"Então, naquele momento, os doutores da Lei e os sumos sacerdotes procuraram prender Jesus. Eles tinham entendido muito bem que Jesus havia contado esta parábola contra eles. Mas tiveram medo da multidão."
,"20":"Os doutores da Lei e os sumos sacerdotes ficaram à espreita. Mandaram espiões, fingindo que eram justos, a fim de surpreender Jesus em alguma palavra. Deste modo eles poderiam entregá-l'O ao poder e autoridade do governador."
,"21":"Os espiões perguntaram a Jesus: «Mestre, sabemos que falas e ensinas com rectidão. Não levas em conta as aparências, mas ensinas de verdade o caminho de Deus."
,"22":"É lícito ou não é pagar o tributo a César?»"
,"23":"Jesus, porém, conhecendo-lhes a astúcia, respondeu-lhes:"
,"24":"«Mostrai-me a moeda. De quem é a figura e a inscrição que está nessa moeda?» Eles responderam: «De César»."
,"25":"Então Jesus disse: «Pois dai a César o que é de César, e a Deus o que é de Deus»."
,"26":"E não puderam surpreender Jesus em nenhuma palavra diante do povo. Admirados com a resposta de Jesus, ficaram em silêncio."
,"27":"Os saduceus afirmam que não existe ressurreição. Alguns deles aproximaram-se de Jesus"
,"28":"e propuseram-Lhe este caso: «Mestre, Moisés prescreveu-nos: 'Se alguém morrer e deixar a esposa sem filhos, o irmão desse homem deve casar-se com a viúva, a fim de que possam ter filhos em nome do irmão que morreu'."
,"29":"Ora, havia sete irmãos. O primeiro casou e morreu sem ter filhos."
,"30":"Também o segundo"
,"31":"e o terceiro se casaram com a viúva. E assim os sete. Todos morreram sem deixar filhos."
,"32":"Por fim, morreu também a mulher."
,"33":"E agora? Na ressurreição, de qual deles será ela esposa? Todos os sete se casaram com ela!»"
,"34":"Jesus respondeu: «Nesta vida, os homens e as mulheres casam-se,"
,"35":"mas os que Deus julgar dignos da ressurreição dos mortos e de participar na vida futura não se casarão,"
,"36":"porque já não podem morrer, pois serão como os anjos. E serão filhos de Deus, porque ressuscitaram."
,"37":"E que os mortos ressuscitam, já Moisés o indica na passagem da sarça, quando chama ao Senhor 'o Deus de Abraão, o Deus de Isaac e o Deus de Jacob'."
,"38":"Deus não é Deus de mortos, mas de vivos, pois para Ele todos vivem»."
,"39":"Alguns doutores da Lei disseram a Jesus: «Foi uma boa resposta, Mestre»."
,"40":"E ninguém mais tinha coragem de perguntar coisa nenhuma a Jesus."
,"41":"Então Jesus disse-lhes: «Como podem dizer que o Messias é filho de David?"
,"42":"Pois o próprio David diz no livro dos Salmos: 'O Senhor disse ao meu Senhor: Senta-Te à minha direita,"
,"43":"até que Eu ponha os teus inimigos como lugar onde apoias os pés'."
,"44":"Portanto, se David Lhe chamou Senhor, como pode, então, o Messias ser seu Filho?»."
,"45":"Enquanto todo o povo O escutava, Jesus disse aos discípulos:"
,"46":"«Tende cuidado com os doutores da Lei. Eles gostam de andar com vestes compridas e de ser cumprimentados nas praças públicas. Gostam dos primeiros lugares nas sinagogas e dos lugares de honra nos banquetes."
,"47":"No entanto, exploram as viúvas e roubam as suas casas, e, para disfarçar, fazem longas orações. Por isso, eles vão receber condenação mais severa»."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Erguendo os olhos, Jesus viu pessoas ricas que depositavam ofertas no Tesouro do Templo."
,"2":"Viu também uma viúva pobre que depositou duas pequenas moedas."
,"3":"Então disse: «Garanto-vos: esta viúva pobre depositou mais do que todos."
,"4":"Pois todos os outros depositaram do que lhes sobrava. Mas a viúva, na sua pobreza, depositou tudo o que possuía para viver»."
,"5":"Algumas pessoas discorriam sobre o Templo, enfeitado com pedras bonitas e com ofertas votivas. Então Jesus disse:"
,"6":"«Estais a admirar essas coisas? Dias virão em que não ficará pedra sobre pedra. Tudo será destruído»."
,"7":"Eles perguntaram: «Mestre, quando vai acontecer isso? Qual será o sinal de que essas coisas estarão para acontecer?»"
,"8":"Jesus respondeu: «Cuidado para não serdes enganados, porque muitos virão em meu nome, dizendo: 'Sou eu!' E ainda: 'O tempo já chegou'. Não sigais essa gente."
,"9":"Quando ouvirdes falar de guerras e revoluções, não fiqueis apavorados. Primeiro essas coisas devem acontecer, mas não será logo o fim»."
,"10":"E Jesus continuou: «Uma nação lutará contra outra, um reino contra outro reino."
,"11":"Haverá grandes terremotos, fomes e pestes em vários lugares. Vão acontecer coisas pavorosas e grandes sinais vindos do céu»."
,"12":"Mas, antes que essas coisas aconteçam, sereis presos e perseguidos; entregar-vos-ão às sinagogas e sereis metidos na prisão; sereis levados perante reis e governadores, por causa do meu nome."
,"13":"Isso acontecerá para que deis testemunho."
,"14":"Portanto, tirai da cabeça a ideia de que deveis planear com antecedência a própria defesa;"
,"15":"porque Eu vos darei palavras de sabedoria, de tal modo que nenhum dos inimigos vos poderá resistir ou rebater."
,"16":"Sereis entregues até mesmo pelos próprios pais, irmãos, parentes e amigos. E eles matarão alguns de vós."
,"17":"Sereis odiados por todos, por causa do meu nome."
,"18":"Mas não perdereis um só cabelo."
,"19":"É permanecendo firmes que ireis ganhar a vida!»"
,"20":"«Quando virdes Jerusalém cercada de acampamentos, ficai sabendo que a sua destruição está próxima."
,"21":"Então, os que estiverem na Judeia, devem fugir para as montanhas; os que estiverem no meio da cidade, devem afastar-se; os que estiverem no campo, não entrem na cidade."
,"22":"Pois esses dias são de vingança, para que se cumpra tudo o que dizem as Escrituras."
,"23":"Infelizes das mulheres grávidas e daquelas que estiverem amamentando nesses dias, pois haverá uma grandes desgraça nesta terra e uma ira contra este povo."
,"24":"Serão mortos pela espada e levados presos para todas as nações. Jerusalém será pisada pelos pagãos, até que o tempo dos pagãos se complete»."
,"25":"«Haverá sinais no Sol, na Lua e nas estrelas. E, na Terra, as nações cairão no desespero, apavoradas com o barulho do mar e das ondas."
,"26":"Os homens desmaiarão de medo e ansiedade, pelo que vai acontecer ao Universo, porque os poderes do espaço ficarão abalados."
,"27":"Então verão o Filho do Homem vir sobre uma nuvem, com grande poder e glória."
,"28":"Quando estas coisas começarem a acontecer, levantai-vos e erguei a cabeça, porque a vossa libertação está pró-xima»."
,"29":"E Jesus contou uma parábola: «Olhai a figueira e todas as árvores."
,"30":"Vendo que elas começam a lançar rebentos, sabeis que o Verão está perto."
,"31":"Também, quando virdes acontecer estas coisas, sabei que o Reino de Deus está perto."
,"32":"Garanto-vos: tudo isto vai acontecer, antes que passe esta geração."
,"33":"O céu e a terra desaparecerão, mas as minhas palavras não desaparecerão."
,"34":"Tomai cuidado para que os vossos corações não fiquem insensíveis por causa da gula, da embriaguez e das preocupações da vida, e esse dia não caia de repente sobre vós."
,"35":"Pois esse dia cairá, subitamente, sobre todos aqueles que habitam a face de toda a Terra."
,"36":"Ficai atentos e rezai continuamente, a fim de terdes força para escapar de tudo o que deve acontecer e para ficardes de pé diante do Filho do Homem»."
,"37":"De dia, Jesus ensinava no Templo. Ao anoitecer, saía e passava a noite no chamado monte das Oliveiras."
,"38":"De manhã cedo, todo o povo ia ao templo para O ouvir."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Estava próxima a festa dos Ázimos, que se chamava Páscoa."
,"2":"Os sumos sacerdotes e os doutores da Lei procuravam uma maneira de acabar com Jesus, pois tinham medo do povo."
,"3":"Satanás entrou em Judas, chamado Iscariotes, que era um dos Doze."
,"4":"Então ele saiu e foi tratar com os sumos sacerdotes e com os oficiais da guarda do Templo, sobre a maneira de entregar Jesus."
,"5":"Eles ficaram contentes e combinaram dar-lhe dinheiro."
,"6":"Judas concordou e começou a procurar uma boa oportunidade para entregar Jesus, sem o povo saber."
,"7":"Chegou o dia dos Ázimos, em que se matavam os cordeiros para a Páscoa."
,"8":"Jesus mandou Pedro e João, dizendo: «Ide e preparai tudo para comermos a Páscoa»."
,"9":"Eles perguntaram: «Onde queres que a preparemos?»"
,"10":"Jesus respondeu: «Quando entrardes na cidade, um homem com uma bilha de água virá ao vosso encontro. Segui-o até à casa onde ele entrar"
,"11":"e dizei ao dono da casa: «O Mestre manda dizer: 'Onde é a sala em que Eu e os meus discípulos vamos comer a Páscoa?'"
,"12":"Então ele mostrar-vos-á, no andar de cima, uma sala grande, arrumada com almofadas. Preparai tudo aí»."
,"13":"Os discípulos foram e encontraram tudo como Jesus havia dito. E prepararam a Páscoa."
,"14":"Quando chegou a hora, Jesus pôs-Se à mesa com os Apóstolos."
,"15":"E disse: «Desejei muito comer convosco esta ceia pascal, antes de sofrer."
,"16":"Pois digo-vos: nunca mais a comerei, até que ela se realize no Reino de Deus»."
,"17":"Então Jesus tomou o cálice, agradeceu a Deus e disse: «Tomai e reparti entre vós;"
,"18":"pois Eu vos digo que nunca mais beberei do fruto da videira, até que venha o Reino de Deus»."
,"19":"A seguir, Jesus tomou um pão, agradeceu a Deus, partiu-o e distribuiu-lho, dizendo: «Isto é o meu corpo, que é dado por vós. Fazei isto em memória de Mim»."
,"20":"Depois da ceia, Jesus fez o mesmo com o cálice, dizendo: «Este cálice é a nova aliança do meu sangue, que é derramado por vós."
,"21":"Mas vede: a mão do homem que Me vai trair está comigo à mesa."
,"22":"Sim, o Filho do Homem vai morrer, conforme Deus determinou, mas ai daquele homem que O vai trair!»"
,"23":"Então os Apóstolos começaram a perguntar uns aos outros qual deles iria fazer tal coisa."
,"24":"Entre eles houve também uma discussão sobre qual deles deveria ser considerado o maior."
,"25":"Jesus, porém, disse: «Os reis das nações têm poder sobre elas, e os que sobre elas exercem autoridade são chamados benfeitores."
,"26":"Mas entre vós não deverá ser assim. Pelo contrário, o maior entre vós seja como o mais novo; e quem governa, seja como aquele que serve. "
,"27":"Afinal, quem é o maior: aquele que está sentado à mesa, ou aquele que serve? Não é aquele que está sentado à mesa? Eu, porém, estou no meio de vós como quem serve."
,"28":"Vós ficastes comigo nas minhas provações."
,"29":"Por isso, assim, como o meu Pai Me confiou o Reino, também Eu vos confio o Reino a vós."
,"30":"Vós haveis de comer e beber à minha mesa no meu Reino, e sentar-vos em tronos para julgar as doze tribos de Israel»."
,"31":"«Simão, Simão! Olha que Satanás pediu autorização para vos joeirar como trigo."
,"32":"Eu, porém, rezei por ti, para que a tua fé não desfaleça. E tu, quando tiveres voltado para Mim, fortalece os teus irmãos»."
,"33":"Mas Simão disse: «Senhor, contigo estou pronto a ir até mesmo para a prisão e para a morte!»"
,"34":"Jesus, porém, respondeu: «Pedro, Eu te digo que hoje, antes que o galo cante, três vezes negarás conhecer-Me»."
,"35":"Jesus perguntou aos Apóstolos: «Quando vos enviei sem bolsa, sem sacola, sem sandálias, faltou-vos alguma coisa?» Eles responderam: «Nada»."
,"36":"Jesus continuou: «Agora, porém, quem tiver bolsa deve tomá-la, como também uma sacola; e quem não tiver espada, venda o manto para comprar uma."
,"37":"Porque Eu declaro-vos: É preciso que se cumpra em Mim a palavra da Escritura: 'Ele foi incluído entre os malfeitores'. E o que foi dito a meu respeito vai realizar-se»."
,"38":"Eles disseram: «Senhor, aqui estão duas espadas».Jesus respondeu: «Chega»!"
,"39":"Jesus saiu e, como de costume, foi para o monte das Oliveiras. Os discípulos acompanharam-n'O."
,"40":"Chegando ao lugar, Jesus disse-lhes: «Rezai para não cairdes em tentação»."
,"41":"Então, afastou-Se uns trinta metros e, de joelhos, começou a rezar:"
,"42":"«Pai, se queres, afasta de Mim este cálice. Contudo, não se faça a minha vontade, mas a tua!»"
,"43":"Apareceu-Lhe um anjo do Céu que O confortava."
,"44":"Tomado de angústia, Jesus rezava com mais insistência. O seu suor tornou-se como gotas de sangue, que caíam no chão."
,"45":"Levantando-Se da oração, Jesus foi para junto dos discípulos e encontrou-os a dormir, vencidos pela tristeza."
,"46":"E perguntou-lhes: «Porque estais a dormir? Levantai-vos e rezai, para não cairdes em tentação»."
,"47":"Enquanto Jesus ainda falava, chegou uma multidão. Na frente vinha Judas, um dos Doze. Ele aproximou-se de Jesus e saudou-O com um beijo."
,"48":"Jesus disse: «Judas, é com um beijo que atraiçoas o Filho do Homem?»"
,"49":"Vendo o que ia acontecer, os que estavam com Jesus disseram: «Senhor, vamos atacar com a espada»?"
,"50":"E um deles feriu o empregado do sumo sacerdote, cortando-lhe a orelha direita."
,"51":"Mas Jesus ordenou: «Parai com isso!» E, tocando a orelha do homem, curou-o."
,"52":"Depois Jesus disse aos sumos sacerdotes, aos oficiais da guarda do Templo e aos anciãos, que tinham ido para O prender: «Saístes com espadas e paus, como se Eu fosse um bandido?"
,"53":"Todos os dias Eu estava convosco no Templo e nunca pusestes a mão em Mim. Mas esta é a vossa hora e do poder das trevas»."
,"54":"Eles prenderam e levaram Jesus, e conduziram-n'O a casa do sumo sacerdote. Pedro seguia Jesus de longe."
,"55":"Acenderam uma fogueira no meio do pátio e sentaram-se ao redor. Pedro sentou-se no meio deles."
,"56":"Ora, uma criada viu Pedro sentado perto do lume. Encarou-o bem e disse: «Este aqui também estava com Jesus!»"
,"57":"Mas Pedro negou: «Mulher, eu nem O conheço»."
,"58":"Pouco depois, outro viu Pedro e disse: «Tu também és um deles».Mas Pedro respondeu: «Homem, não sou, não»."
,"59":"Passou mais ou menos uma hora, e outro insistia: «De facto este aqui também estava com Jesus, porque é galileu»."
,"60":"Mas Pedro respondeu: «Homem, não sei do que estás a falar!» Nesse momento, enquanto Pedro ainda falava, um galo cantou."
,"61":"Então o Senhor voltou-Se e olhou para Pedro. E Pedro lembrou-se de que o Senhor lhe havia dito: «Hoje, antes de o galo cantar, negar-Me-ás três vezes»."
,"62":"Então Pedro saiu para fora e chorou amargamente."
,"63":"Os guardas troçavam de Jesus e espancavam-n'O."
,"64":"Cobriam-Lhe o rosto e diziam: «Faz uma profecia! Quem foi que te bateu?»"
,"65":"E insulta-vam-n'O de muitos outros modos."
,"66":"Ao amanhecer, os anciãos do povo, os sumos sacerdotes e os doutores da Lei reuniram-se em conselho e levaram Jesus para o Sinédrio."
,"67":"E começaram: «Se Tu és o Messias, declara-no-lo!» Jesus respondeu: «Se Eu disser, vós não acreditareis"
,"68":"e, se vos fizer perguntas, não Me respondereis."
,"69":"Mas, de agora em diante, o Filho do Homem estará sentado à direita do Deus todo-poderoso»."
,"70":"Então todos perguntaram: «Tu és, portanto, o Filho de Deus?» Jesus respondeu: «Vós dizeis que Eu sou»."
,"71":"Eles disseram: «Que necessidade temos ainda de testemunhas? Nós mesmos o ouvimos da sua boca!»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Em seguida, toda a assembleia se levantou e levaram Jesus a Pilatos."
,"2":"Começaram a acusação, dizendo: «Achámos este homem a subverter o nosso povo, proibindo pagar tributo ao imperador e a afirmar ser Ele mesmo o Messias, o Rei»."
,"3":"Pilatos interrogou Jesus: «Tu és o rei dos judeus?» Jesus respondeu, declarando: «És tu que o dizes!»"
,"4":"Então Pilatos disse aos sumos sacerdotes e à multidão: «Não encontro neste homem nenhum motivo de condenação»."
,"5":"Eles, porém, insistiam: «Ele provoca revolta entre o povo, com o seu ensinamento. Começou na Galileia, passou por toda a Judeia e agora chegou aqui»."
,"6":"Quando ouviu isto, Pilatos perguntou se Jesus era galileu."
,"7":"Ao saber que Jesus estava sob a jurisdição de Herodes, Pilatos mandou-O a Herodes, pois também Herodes estava em Jerusalém nesses dias."
,"8":"Herodes ficou muito contente ao ver Jesus, pois já ouvira falar a respeito d'Ele e há muito tempo desejava vê-l'O. Esperava ver Jesus fazer algum milagre."
,"9":"Herodes interrogou-O com muitas perguntas. Jesus, porém, não respondeu nada."
,"10":"Entretanto, os sumos sacerdotes e os doutores da Lei estavam presentes e faziam violentas acusações contra Jesus."
,"11":"Herodes e os seus soldados trataram Jesus com desprezo, escarneceram d'Ele e vestiram-n'O com uma capa brilhante. E enviaram-n'O de novo a Pilatos."
,"12":"Nesse dia, Herodes e Pilatos ficaram amigos, pois antes eram inimigos."
,"13":"Então Pilatos convocou os sumos sacerdotes, os chefes e o povo"
,"14":"e disse-lhes: «Trouxestes este homem como se fosse um agitador do povo. Pois bem! Eu já O interroguei diante de vós e não encontrei n'Ele nenhum dos crimes de que O acusais."
,"15":"Herodes também não encontrou, visto que no-l'O enviou de novo. Como podeis ver, Ele não fez nada para merecer a morte."
,"16":"Portanto, vou castigá-l'O e depois soltá-l'O-ei»."
,"17":"Ora, em cada festa da Páscoa, Pilatos devia soltar-lhes um prisioneiro."
,"18":"Toda a multidão começou a gritar: «Mata esse homem! Solta-nos Barrabás!»"
,"19":"Barrabás tinha sido preso por causa de uma revolta na cidade e por homicídio."
,"20":"Pilatos queria libertar Jesus e falou outra vez à multidão."
,"21":"Mas eles gritavam: «Crucifica-O! Crucifica-O!»."
,"22":"E Pilatos disse pela terceira vez: «Mas que mal fez este homem? Não encontrei n'Ele nenhum crime que mereça a morte. Portanto, vou castigá-l'O, e depois soltá-l'O-ei»."
,"23":"Mas eles continuaram a gritar com toda a força, pedindo que Jesus fosse crucificado. E a gritaria deles aumentava cada vez mais."
,"24":"Então Pilatos pronunciou a sentença: que fosse feito o que eles pediam."
,"25":"Soltou o homem que eles queriam, aquele que tinha sido preso por revolta e homicídio, e entregou-lhes Jesus para o que eles queriam."
,"26":"Enquanto levavam Jesus para ser crucificado, pegaram em certo Simão, da cidade de Cirene, que voltava do campo, e forçaram-no a levar a cruz atrás de Jesus."
,"27":"Uma grande multidão do povo seguia Jesus. E mulheres batiam no peito e choravam por Jesus."
,"28":"Jesus, porém, voltou-Se e disse: «Mulheres de Jerusalém, não choreis por Mim! Chorai por vós mesmas e por vossos filhos!"
,"29":"Porque dias virão, em que se dirá: 'Felizes as mulheres que nunca tiveram filhos, os ventres que nunca deram à luz e os seios que nunca amamentaram'."
,"30":"Então começarão a pedir às montanhas: 'Caí em cima de nós!' E às colinas: 'Escondei-nos!'"
,"31":"Porque, se assim fazem com a árvore verde, o que não farão com a árvore seca?»"
,"32":"Com Ele levavam também outros dois criminosos, para serem mortos."
,"33":"Quando chegaram ao chamado «lugar da Caveira», ali crucificaram Jesus e os criminosos, um à sua direita e outro à sua esquerda."
,"34":"E Jesus dizia: «Pai, perdoa-lhes! Eles não sabem o que fazem!» Deitaram sortes para repartirem entre si as vestes de Jesus."
,"35":"O povo permanecia ali a observar. Os chefes, porém, zombavam de Jesus, dizendo: «Salvou os outros. Que Se salve a Si mesmo, se é de facto o Messias de Deus, o Escolhido!»"
,"36":"Os soldados também escarneciam d'Ele. Aproximavam-se, ofereciam-Lhe vinagre"
,"37":"e diziam: «Se Tu és o rei dos judeus, salva-Te a Ti mesmo!»"
,"38":"Por cima d'Ele havia um letreiro: «Este é o Rei dos judeus»."
,"39":"Um dos criminosos crucificados insultava-O, dizendo: «Não és Tu o Messias? Salva-Te a Ti mesmo e a nós também!»"
,"40":"Mas o outro repreendeu-o, dizendo: «Nem tu temes a Deus, sofrendo a mesma condenação?"
,"41":"Quanto a nós é justo, porque recebemos o que merecemos; mas Ele não fez nada de mal»."
,"42":"E acrescentou: «Jesus, lembra-Te de mim, quando vieres no teu Reino»."
,"43":"Jesus respondeu: «Eu te garanto: hoje mesmo estarás comigo no Paraíso»."
,"44":"Já era mais ou menos meio-dia, e uma escuridão cobriu toda a região até às três horas da tarde,"
,"45":"pois o sol deixou de brilhar. A cortina do santuário rasgou-se ao meio."
,"46":"Então Jesus deu um forte grito: «Pai, em tuas mãos entrego o meu espírito».Dizendo isto, expirou."
,"47":"O oficial do exército viu o que tinha acontecido e glorificou a Deus, dizendo: «De facto este homem era justo!»"
,"48":"E todas as multidões que ali estavam e que tinham vindo para assistir, viram o que havia acontecido e voltaram para casa, batendo no peito."
,"49":"Todos os conhecidos de Jesus, assim como as mulheres que O acompanhavam desde a Galileia, ficaram à distância, observando estas coisas."
,"50":"Havia um homem bom e justo, chamado José. Era membro do Conselho,"
,"51":"mas não tinha aprovado a decisão nem a acção dos outros membros. Ele era de Arimateia, cidade da Judeia, e esperava a vinda do reino de Deus."
,"52":"José foi ter com Pilatos e pediu-lhe o corpo de Jesus."
,"53":"Desceu o corpo da cruz, envolveu-o num lençol e colocou-o num túmulo escavado na rocha, onde ninguém ainda tinha sido sepultado."
,"54":"Era o dia da preparação da Páscoa, e o sábado já estava a começar."
,"55":"As mulheres, que tinham ido com Jesus desde a Galileia, foram com José para ver o túmulo, e como o corpo de Jesus tinha sido colocado."
,"56":"Depois voltaram para casa e prepararam perfumes e bálsamos. E no sábado descansaram, conforme ordenava a Lei."
}`)
	CurrentBook.AddChapter(24, `{
"1":"No primeiro dia da semana, bem de madrugada, as mulheres foram ao túmulo de Jesus, levando os perfumes que haviam preparado."
,"2":"Encontraram a pedra do túmulo removida."
,"3":"Mas, ao entrar, não encontraram o corpo do Senhor Jesus"
,"4":"e ficaram sem saber o que estava a acontecer. Nisto, dois homens, com roupas brilhantes, pararam perto delas."
,"5":"Cheias de medo, elas olhavam para o chão. No entanto, os dois homens disseram: «Porque procurais entre os mortos Aquele que está vivo?"
,"6":"Ele não está aqui! Ressuscitou! Lembrai-vos do que Ele disse, quando ainda estava na Galileia:"
,"7":"'O Filho do Homem deve ser entregue nas mãos dos pecadores, ser crucificado e ressuscitar ao terceiro dia'»."
,"8":"Então as mulheres lembraram-se das palavras de Jesus."
,"9":"Voltaram do túmulo e anunciaram tudo isto aos Onze, bem como a todos os outros."
,"10":"Eram Maria Madalena, Joana, e Maria, mãe de Tiago. Também as outras mulheres que estavam com elas contaram estas coisas aos Apóstolos."
,"11":"Contudo, os Apóstolos acharam que eram tolices o que as mulheres contavam e não acreditaram nelas."
,"12":"Pedro, porém, levantou-se e correu ao túmulo. Inclinou-se e viu apenas os lençóis de linho. Então voltou para casa, admirado com o que havia acontecido."
,"13":"Nesse mesmo dia, dois discípulos iam para uma aldeia, chamada Emaús, distante onze quilómetros de Jerusalém."
,"14":"Conversavam a respeito de tudo o que tinha acontecido."
,"15":"Enquanto conversavam e discutiam, o próprio Jesus aproximou-Se e começou a caminhar com eles."
,"16":"Os discípulos, porém, estavam como que cegos e não O reconheceram."
,"17":"Então Jesus perguntou: «O que é que conversais pelo caminho?» Eles pararam, com o rosto triste."
,"18":"Um deles, chamado Cléofas, disse: «Tu és o único peregrino em Jerusalém que não sabe o que ali aconteceu nestes últimos dias?»"
,"19":"Jesus perguntou: «Que foi?» Os discípulos responderam: «O que aconteceu a Jesus, o Nazareno, que foi um profeta poderoso em acção e palavras, diante de Deus e de todo o povo."
,"20":"Os nossos sumos sacerdotes e os nossos chefes entregaram-n'O para ser condenado à morte e crucificaram-n'O."
,"21":"Nós esperávamos que Ele fosse o libertador de Israel, mas, apesar de tudo isso, já há três dias que tudo isso aconteceu!"
,"22":"É verdade que algumas mulheres do nosso grupo nos assustaram. Elas foram de madrugada ao túmulo"
,"23":"e não encontraram o corpo de Jesus. Então voltaram, dizendo que tinham visto anjos, e estes afirmaram que Jesus está vivo."
,"24":"Alguns dos nossos foram ao túmulo e encontraram tudo como as mulheres tinham dito. Mas a Jesus ninguém O viu»."
,"25":"Então Jesus disse-lhes: «Como vos custa entender e como demorais a acreditar em tudo o que os profetas anunciaram!"
,"26":"Será que o Messias não devia sofrer tudo isto, para entrar na sua glória?»"
,"27":"Então, começando por Moisés e continuando por todos os Profetas, Jesus explicava aos discípulos todas as passagens da Escritura que falavam a respeito d'Ele."
,"28":"Quando chegaram perto do povoado para onde iam, Jesus fez de conta que ia mais adiante."
,"29":"Eles, porém, insistiram com Jesus, dizendo: «Fica connosco, pois já é tarde e a noite já se aproxima!» Então Jesus entrou para ficar com eles."
,"30":"Sentou-Se à mesa com os dois, tomou o pão e abençoou-o, depois partiu-o e entregou-lho."
,"31":"Nisto os olhos dos discípulos abriram-se e eles reconheceram Jesus. Jesus, porém, desapareceu da sua presença."
,"32":"Então um disse ao outro: «Não ardia o nosso coração quando Ele nos falava pelo caminho e nos explicava as Escrituras?»"
,"33":"Na mesma hora, levantaram-se e voltaram para Jerusalém, onde encontraram os Onze, reunidos com os outros."
,"34":"E estes confirmaram: «Realmente, o Senhor ressuscitou e apareceu a Simão!»"
,"35":"Então os dois contaram o que tinha acontecido no caminho, e como tinham reconhecido Jesus quando Ele partiu o pão."
,"36":"Ainda estavam a falar, quando Jesus apareceu no meio deles, e disse: «A paz esteja convosco»."
,"37":"Espantados e cheios de medo, pensavam ver um espírito."
,"38":"Então Jesus disse: «Porque estais perturbados, e porque é que o vosso coração está cheio de dúvidas?"
,"39":"Vede as minhas mãos e os meus pés: sou Eu mesmo. Tocai-Me e vede: um espírito não tem carne e ossos, como podeis ver que Eu tenho»."
,"40":"E dizendo isto, Jesus mostrou-lhes as mãos e os pés."
,"41":"E como eles ainda não acreditassem, por causa da alegria e porque estavam espantados, Jesus disse: «Tendes aí alguma coisa para comer?»"
,"42":"Eles ofereceram-Lhe um pedaço de peixe grelhado."
,"43":"Jesus, tomando o peixe, comeu-o diante deles."
,"44":"Jesus disse: «Foram estas as palavras que vos disse, quando ainda estava convosco: é preciso que se cumpra tudo o que está escrito a meu respeito na Lei de Moisés, nos Profetas e nos Salmos»."
,"45":"Então Jesus abriu-lhes a mente para entenderem as Escrituras."
,"46":"E continuou: «Assim está escrito: 'O Messias sofrerá e ressuscitará dos mortos ao terceiro dia,"
,"47":"e em seu nome serão anunciados a conversão e o perdão dos pecados a todas as nações, começando por Jerusalém'."
,"48":"Vós sois testemunhas disso."
,"49":"Agora vou enviar-vos Aquele que meu Pai prometeu. Por isso, esperai na cidade, até que sejais revestidos da força do alto»."
,"50":"Então Jesus levou os discípulos para fora da cidade, até Betânia. Ali, ergueu as mãos e abençoou-os."
,"51":"Enquanto os abençoava, afastou-Se deles e foi levado para o céu."
,"52":"Eles adoraram-n'O e depois voltaram para Jerusalém, com grande alegria."
,"53":"E estavam sempre no Templo, bendizendo a Deus."
}`)

}
func PT_BS_LoadNEMCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Começo da Boa Notícia de Jesus, o Messias, o Filho de Deus."
,"2":"Está escrito no livro do profeta Isaías: «Eis que envio o meu mensageiro à tua frente, para preparar o teu caminho."
,"3":"Esta é a voz daquele que grita no deserto: Preparai o caminho do Senhor, endireitai as suas estradas!»"
,"4":"E foi assim que João Baptista apareceu no deserto, a pregar um baptismo de conversão para o perdão dos pecados."
,"5":"Toda a região da Judeia e todos os moradores de Jerusalém iam ao encontro de João. Confessavam os seus pecados e João baptizava-os no rio Jordão."
,"6":"João vestia-se com uma pele de camelo, usava um cinto de couro e comia gafanhotos e mel silvestre."
,"7":"E pregava: «Depois de mim, vai chegar Alguém mais forte do que eu. E eu não sou digno nem sequer de me abaixar para desatar as suas sandálias."
,"8":"Eu baptizei-vos com água, mas Ele baptizar-vos-á com o Espírito Santo»."
,"9":"Por aqueles dias, Jesus veio de Nazaré da Galileia e foi baptizado por João no rio Jordão."
,"10":"Logo que Jesus saiu da água, viu os céus abertos, e o Espírito, como pomba, descer sobre Ele."
,"11":"E do céu veio uma voz: «Tu és o meu Filho amado; em Ti encontro o meu agrado»."
,"12":"Em seguida o Espírito impeliu Jesus para o deserto."
,"13":"E Jesus ficou no deserto durante quarenta dias e ali foi tentado por Satanás. Jesus vivia entre os animais selvagens e os anjos serviam-n'O."
,"14":"Depois de João Baptista ter sido preso, Jesus voltou para a Galileia, a pregar a Boa Notícia de Deus:"
,"15":"«O tempo já se cumpriu e o Reino de Deus está próximo. Convertei-vos e acreditai na Boa Notícia»."
,"16":"Passando ao longo do mar da Galileia, Jesus viu Simão e seu irmão André que lançavam a rede ao mar, pois eram pescadores."
,"17":"Jesus disse-lhes: «Segui-Me e farei que vos torneis pescadores de homens»."
,"18":"Eles imediatamente deixaram as redes e seguiram a Jesus."
,"19":"Caminhando mais um pouco, Jesus viu Tiago e João, filhos de Zebedeu. Estavam na barca a consertar as redes."
,"20":"Jesus logo os chamou. E eles deixaram seu pai Zebedeu na barca com os empregados e partiram, seguindo a Jesus."
,"21":"Foram à cidade de Cafarnaum e, ao sábado, Jesus entrou na sinagoga e começou a ensinar."
,"22":"As pessoas ficavam admiradas com o seu ensinamento, porque Jesus ensinava como quem tem autoridade e não como os doutores da Lei."
,"23":"Nesse momento, estava na sinagoga um homem possuído por um espírito mau, que começou a gritar:"
,"24":"«Que queres de nós, Jesus Nazareno? Vieste para nos destruir? Eu sei quem Tu és: Tu és o Santo de Deus!»"
,"25":"Jesus ameaçou o espírito mau: «Cala-te e sai dele!»"
,"26":"Então o espírito mau sacudiu o homem com violência, deu um grande grito e saiu dele."
,"27":"Todos ficaram muito espantados e perguntavam uns aos outros: «O que é isto? Um ensinamento novo, dado com autoridade... Ele manda até nos espíritos maus e eles obedecem!»"
,"28":"E a fama de Jesus logo se espalhou por toda a parte, em todas as redondezas da Galileia."
,"29":"Saíram da sinagoga e foram logo para casa de Simão e André, com Tiago e João."
,"30":"A sogra de Simão estava de cama, com febre, e logo eles contaram isso a Jesus."
,"31":"Jesus foi aonde ela estava, pegou-lhe na mão e ajudou-a a levantar-se. Então a febre deixou-a, e ela começou a servi-los."
,"32":"À tarde, depois do pôr do sol, levaram a Jesus todos os doentes e os que estavam possuídos pelo demónio."
,"33":"A cidade inteira reuniu-se em frente da casa."
,"34":"Jesus curou muitas pessoas de várias espécies de doença e expulsou muitos demónios. Os demónios sabiam quem era Jesus, e por isso Jesus não deixava que eles falassem."
,"35":"De madrugada, quando ainda estava escuro, Jesus levantou-Se e foi rezar num lugar deserto."
,"36":"Simão e os seus companheiros foram à procura de Jesus"
,"37":"e, quando O encontraram, disseram: «Todos Te procuram»."
,"38":"Jesus respondeu: «Vamos para outros lugares, para as aldeias das redondezas. Devo pregar também ali, pois foi para isso que Eu vim»."
,"39":"E Jesus andava por toda a Galileia, pregando nas sinagogas e expulsando os demónios."
,"40":"Um leproso chegou junto de Jesus e pediu de joelhos: «Se quiseres, tens poder para me purificar»."
,"41":"Jesus ficou cheio de ira, estendeu a mão, tocou nele e disse: «Quero, fica purificado»."
,"42":"No mesmo instante a lepra desapareceu e o homem ficou purificado»."
,"43":"Então Jesus mandou-o logo embora, ameaçando-o severamente:"
,"44":"«Não contes nada a ninguém! Vai pedir ao sacerdote que te examine, e depois oferece pela tua purificação o sacrifício que Moisés ordenou, para lhes servir de testemunho»."
,"45":"Mas o homem foi-se embora e começou a pregar muito e a espalhar a notícia. Por isso, Jesus já não podia entrar publicamente numa cidade: ficava fora, em lugares desertos. E de toda a parte as pessoas iam ter com Ele."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Alguns dias depois, Jesus entrou de novo na cidade de Cafarnaum. Logo se espalhou a notícia de que Jesus estava em casa."
,"2":"E tanta gente se reuniu ali que já não havia lugar nem em frente da casa. E Jesus anunciava a Palavra."
,"3":"Trouxeram então um paralítico, transportado por quatro homens."
,"4":"Mas eles não conseguiam chegar até Jesus, por causa da multidão. Então fizeram um buraco no tecto, por cima do lugar onde Jesus estava, e pela abertura desceram a cama em que o paralítico estava deitado."
,"5":"Vendo a fé que eles tinham, Jesus disse ao paralítico: «Filho, os teus pecados estão perdoados»."
,"6":"Ora, alguns doutores da Lei estavam ali sentados e começaram a pensar:"
,"7":"«Porque é que este homem fala assim? Ele blasfema! Ninguém pode perdoar pecados, porque só Deus tem poder para isso!»"
,"8":"Jesus percebeu logo o que eles estavam a pensar no seu íntimo, e disse: «Porque pensais assim?"
,"9":"Que é mais fácil dizer ao paralítico: 'Os teus pecados estão perdoados', ou dizer: 'Levanta-te, pega na tua cama e anda'?"
,"10":"Pois bem, para que saibais que o Filho do Homem tem poder na Terra para perdoar pecados - disse Jesus ao paralítico -"
,"11":"Eu te ordeno: Levanta-te, pega na tua cama e vai para casa»."
,"12":"O paralítico então levantou-se e, pegando na sua cama, saiu à vista de todos. E todos ficaram muito admirados e louvaram a Deus, dizendo: «Nunca vimos uma coisa assim!»"
,"13":"Jesus saiu de novo para a beira-mar. Toda a multidão ia ao seu encontro. E Jesus ensinava-os."
,"14":"Enquanto ia caminhando, Jesus viu Levi, o filho de Alfeu, sentado na cobrança de impostos, e disse-lhe: «Segue-Me». Levi levantou-se e seguiu-O."
,"15":"Mais tarde, Jesus estava a comer em casa de Levi. Havia vários cobradores de impostos e pecadores à mesa com Jesus e os seus discípulos; com efeito, eram muitos os que O seguiam."
,"16":"Alguns doutores da Lei, que eram fariseus, viram que Jesus estava a comer com pecadores e cobradores de impostos. Então perguntaram aos discípulos: «Porque é que Jesus come e bebe com os cobradores de impostos e pecadores?»"
,"17":"Jesus ouviu e respondeu: «As pessoas que têm saúde não precisam de médico, mas só as que estão doentes. Eu não vim para chamar os justos, mas os pecadores»."
,"18":"Os discípulos de João Baptista e os fariseus estavam a jejuar. Então alguns perguntaram a Jesus: «Porque é que os discípulos de João e os discípulos dos fariseus jejuam e os teus discípulos não jejuam?»"
,"19":"Jesus respondeu: «Achais que os convidados de um casamento podem jejuar enquanto o noivo está com eles? Enquanto o noivo está presente, os convidados não podem jejuar."
,"20":"Mas vão chegar dias em que o noivo será tirado do meio deles. Nesse dia eles vão jejuar."
,"21":"Ninguém põe um remendo de pano novo em roupa velha; porque o remendo novo repuxa o pano e o rasgão fica ainda maior."
,"22":"Ninguém coloca vinho novo em barris velhos; porque o vinho novo rebenta os barris velhos, e o vinho e os barris perdem-se. Por isso, o vinho novo deve ser colocado em barris novos»."
,"23":"Num dia de sábado passava Jesus por um campo de trigo. Os discípulos iam abrindo caminho e colhiam espigas."
,"24":"Então os fariseus perguntaram a Jesus: «Porque é que os teus discípulos fazem o que não é permitido em dia de sábado?»"
,"25":"Jesus perguntou aos fariseus: «Nunca lestes o que David e os seus companheiros fizeram quando tiveram necessidade e sentiram fome?"
,"26":"David entrou na casa de Deus, no tempo em que Abiatar era sumo sacerdote, comeu dos pães oferecidos a Deus e deu-os também aos seus companheiros. No entanto só os sacerdotes podem comer desses pães»."
,"27":"E Jesus acrescentou: «O sábado foi feito para servir o homem, e não o homem para servir o sábado."
,"28":"Portanto, o Filho do Homem é senhor até mesmo do sábado»."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Jesus entrou de novo na sinagoga, onde estava um homem com uma mão ressequida."
,"2":"Havia ali algumas pessoas a espiar, para verem se Jesus ia curá-lo em dia de sábado, e assim poderem acusá-l'O."
,"3":"Jesus disse ao homem da mão ressequida: «Levanta-te e vem para o meio»."
,"4":"Depois perguntou aos outros: «O que é que a Lei permite no sábado: fazer o bem ou fazer o mal, salvar uma vida ou matá-la?» Mas eles não disseram nada."
,"5":"Jesus então olhou ao seu redor, cheio de ira e tristeza, porque eles eram duros de coração. Depois disse ao homem: «Estende a mão». O homem estendeu a mão e ela ficou boa."
,"6":"Logo que saíram da sinagoga, os fariseus, com alguns do partido de Herodes, fizeram um plano para matar Jesus."
,"7":"Jesus retirou-Se para a beira do mar com os seus discípulos. Muita gente da Galileia O seguia."
,"8":"E também muita gente da Judeia, de Jerusalém, da Idumeia, do outro lado do Jordão, dos territórios de Tiro e de Sidónia, veio ter com Jesus, porque tinha ouvido falar de tudo o que Ele fazia."
,"9":"Então Jesus pediu aos discípulos que preparassem uma barca, para Ele não ficar oprimido pela multidão."
,"10":"Com efeito, Jesus tinha curado muitas pessoas, e todos os que sofriam de algum mal lançavam-se sobre Ele para Lhe tocarem."
,"11":"Vendo Jesus, os espíritos maus caíam a seus pés, gritando: «Tu és o Filho de Deus!»"
,"12":"Mas Jesus ordenava-lhes severamente que não dissessem quem Ele era."
,"13":"Jesus subiu ao monte e chamou os que desejava escolher. E foram ter com Ele."
,"14":"Então Jesus constituiu o grupo dos Doze, para que ficassem com Ele e para os enviar a pregar,"
,"15":"com autoridade para expulsar os demónios."
,"16":"Constituiu assim os Doze: Simão, a quem deu o nome de Pedro;"
,"17":"Tiago e João, filhos de Zebedeu, aos quais deu o nome de Boanerges, que quer dizer «filhos do trovão»;"
,"18":"André, Filipe, Bartolomeu, Mateus, Tomé, Tiago, filho de Alfeu, Tadeu, Simão o cananeu,"
,"19":"e Judas Iscariotes, aquele que depois O traiu."
,"20":"Jesus foi para casa, e de novo se reuniu tanta gente, que eles não podiam comer nem sequer um pedaço de pão."
,"21":"Quando souberam disso, os parentes de Jesus foram segurá-l'O, porque eles mesmos diziam que Jesus tinha ficado louco."
,"22":"Alguns doutores da Lei, que tinham ido de Jerusalém, diziam: «Ele está possuído por Belzebu»; e também: «É pelo príncipe dos demónios que Ele expulsa os demónios»."
,"23":"Então Jesus chamou as pessoas e disse-lhes em parábolas: «Como é que Satanás pode expulsar Satanás?"
,"24":"Se um reino se divide em grupos que lutam entre si, esse reino acabará por se destruir;"
,"25":"se uma família se divide em grupos que brigam entre si, essa família não poderá durar."
,"26":"Portanto, se Satanás se levanta e se divide em grupos que lutam entre si, ele não poderá sobreviver, mas também será destruído."
,"27":"Ninguém pode entrar na casa de um homem forte para roubar as suas coisas, se antes não amarrar o homem forte. Só depois poderá roubar a sua casa."
,"28":"Eu vos garanto: tudo será perdoado aos homens, tanto os pecados como as blasfémias que tiverem dito."
,"29":"Mas quem blasfemar contra o Espírito Santo nunca será perdoado, pois a culpa desse pecado dura para sempre»."
,"30":"Jesus disse-lhes isto porque eles afirmavam: «Ele está possuído por um espírito mau»."
,"31":"Nisto chegaram a Mãe e os irmãos de Jesus; ficaram do lado de fora e mandaram chamá-l'O."
,"32":"Havia uma multidão sentada ao redor de Jesus. Então disseram-Lhe: «A tua Mãe e os teus irmãos estão lá fora e procuram-Te»."
,"33":"Jesus perguntou: «Quem é a minha Mãe e meus irmãos?»"
,"34":"Então Jesus olhou para as pessoas que estavam sentadas ao seu redor e disse: «Aqui estão minha mãe e meus irmãos."
,"35":"Quem faz a vontade de Deus, esse é meu irmão, minha irmã e minha mãe»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Jesus começou a ensinar de novo nas margens do mar da Galileia. Uma multidão reuniu-se em volta d'Ele. Por isso, Jesus entrou numa barca e sentou-Se. A barca estava no mar, enquanto a multidão estava junto ao mar, na praia."
,"2":"Jesus ensinava-lhes muitas coisas em parábolas. No seu ensinamento dizia-lhes:"
,"3":"«Escutai. Um homem saiu para semear."
,"4":"Enquanto semeava, uma parte da semente caiu à beira do caminho; os passarinhos foram e comeram tudo."
,"5":"Outra parte caiu em terreno pedregoso, onde não havia muita terra; brotou logo, porque a terra não era profunda."
,"6":"Porém, quando o sol se ergueu, os rebentos queimaram-se e secaram, porque não tinham raiz."
,"7":"Outra parte caiu no meio dos espinhos. Os espinhos cresceram, sufocaram-na, e não deu fruto."
,"8":"Outra parte caiu em terra boa e deu fruto, brotando e crescendo: rendeu trinta, sessenta e até cem por um»."
,"9":"E Jesus dizia: «Quem tem ouvidos para ouvir, oiça!»"
,"10":"Quando Jesus ficou sozinho, os que estavam com Ele, juntamente com os Doze, perguntaram-Lhe o que significavam as parábolas."
,"11":"Jesus disse-lhes: «A vós é dado conhecer o mistério do Reino de Deus; aos que estão fora tudo se lhes propõe em parábolas,"
,"12":"para que olhem mas não vejam, escutem mas não compreendam, para que não se convertam e não sejam perdoados»."
,"13":"Jesus perguntou-lhes: «Não compreendeis esta parábola? Como compreendereis então as outras parábolas?"
,"14":"O semeador semeia a Palavra."
,"15":"Os que estão à beira do caminho são aqueles nos quais a Palavra foi semeada; logo que a ouvem, chega Satanás e tira a Palavra que foi semeada neles."
,"16":"Do mesmo modo, os que recebem a semente em terreno pedregoso são aqueles que ouvem a Palavra e a recebem com alegria;"
,"17":"mas não têm raiz em si mesmos: são inconstantes e, quando chega uma tribulação ou perseguição por causa da Palavra, logo desistem."
,"18":"Outros recebem a semente entre os espinhos: são aqueles que ouvem a Palavra;"
,"19":"mas surgem as preocupações do mundo, a ilusão da riqueza e todos os outros desejos, que sufocam a Palavra, e ela fica sem dar fruto."
,"20":"Por fim, aqueles que receberam a semente em terreno bom são os que ouvem a Palavra, a recebem e dão fruto; um dá trinta, outro sessenta e outro cem por um»."
,"21":"Jesus continuou: «Quem é que traz uma lâmpada para a colocar debaixo de uma vasilha ou debaixo da cama? Não a coloca no velador?"
,"22":"Com efeito, tudo o que está escondido deverá tornar-se manifesto, e tudo o que está em segredo deverá ser descoberto."
,"23":"Se alguém tem ouvidos para ouvir, ouça»."
,"24":"E Jesus dizia ainda: «Prestai atenção ao que ouvis: com a mesma medida com que medirdes é que sereis medidos; e ainda vos será dado mais."
,"25":"Àquele que tem alguma coisa, será dado ainda mais; àquele que não tem, até mesmo o que tem lhe será tirado»."
,"26":"E Jesus continuou dizendo: «O Reino de Deus é como um homem que lançou a semente à terra."
,"27":"Depois dorme e acorda, noite e dia, e a semente vai brotando e crescendo, mas o homem não sabe como isso acontece."
,"28":"A terra produz fruto por si mesma: primeiro aparecem as folhas, depois a espiga e, por fim, os grãos enchem a espiga."
,"29":"Quando as espigas estão maduras, logo o homem mete a foice, porque chegou o tempo da ceifa»."
,"30":"Jesus dizia ainda: «A que podemos comparar o Reino de Deus? Que parábola podemos usar?"
,"31":"O Reino é como uma semente de mostarda, que é a menor de todas as sementes da terra."
,"32":"Mas, quando é semeada, a mostarda cresce e torna-se maior que todas as plantas; dá ramos grandes, de modo que os pássaros do céu podem fazer ninhos na sua sombra»."
,"33":"Jesus anunciava a Palavra usando muitas parábolas como esta, conforme eles podiam compreender."
,"34":"À multidão Jesus só falava em parábolas, mas, quando estava sozinho com os discípulos, Ele explicava tudo."
,"35":"Naquele dia, quando chegou a tarde, Jesus disse aos seus discípulos: «Vamos para o outro lado do mar»."
,"36":"Então os discípulos deixaram a multidão e levaram-n'O na barca, onde Jesus já Se encontrava. E acompanharam-n'O outras embarcações."
,"37":"Começou a soprar um vento muito forte, e as ondas lançavam-se contra a barca, de modo que a barca já se estava enchendo de água."
,"38":"Jesus estava na parte de trás da barca, dormindo com a cabeça num travesseiro. Os discípulos acordaram-n'O e disseram-Lhe: «Mestre, não Te importa que morramos?»"
,"39":"Então Jesus levantou-Se, ameaçou o vento e disse ao mar: «Cala-te! Acalma-te!» O vento parou e tudo ficou calmo."
,"40":"Depois Jesus perguntou aos discípulos: «Porque sois tão medrosos? Ainda não tendes fé?»"
,"41":"Os discípulos ficaram muito cheios de medo e diziam uns aos outros: «Quem é este homem, a quem até o vento e o mar obedecem?»"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Jesus e os seus discípulos chegaram à outra margem do mar, à região dos gerasenos."
,"2":"Logo que Jesus saiu da barca, um homem possuído por um espírito mau saiu de um cemitério e foi ao seu encontro."
,"3":"Esse homem morava no meio dos túmulos e ninguém conseguia amarrá-lo, nem mesmo com correntes."
,"4":"Muitas vezes tinha sido amarrado com grilhões e correntes, mas rebentara as correntes e despedaçara os grilhões. E ninguém era capaz de o dominar."
,"5":"Dia e noite vagueava entre os túmulos e pelos montes, gritando e ferindo-se com pedras."
,"6":"Vendo Jesus de longe, o endemoninhado correu, caiu de joelhos diante d'Ele"
,"7":"e gritou bem alto: «Que há entre mim e Ti, Jesus, Filho do Deus altíssimo? Eu Te peço por Deus: não me atormentes!»"
,"8":"O homem falou assim, porque Jesus tinha dito: «Espírito mau, sai deste homem!»"
,"9":"Então Jesus perguntou: «Qual é o teu nome?» O homem respondeu: «O meu nome é 'Legião', porque somos muitos»."
,"10":"E pedia com insistência para que Jesus não o expulsasse da região."
,"11":"Havia ali perto uma grande vara de porcos, a pastar na montanha."
,"12":"Os espíritos maus suplicaram: «Manda-nos para os porcos, para que entremos neles»."
,"13":"Jesus consentiu. Os espíritos maus saíram do homem e entraram nos porcos. E a vara - mais ou menos uns dois mil porcos - atirou-se pelo monte abaixo para dentro do mar, onde se afogou."
,"14":"Os homens que guardavam os porcos fugiram e espalharam a notícia na cidade e nos campos. As pessoas foram ver o que tinha acontecido."
,"15":"Ao chegarem junto de Jesus, viram o endemoninhado sentado, vestido e no seu perfeito juízo, ele que antes estava possuído pela Legião. E ficaram com medo."
,"16":"Os que tinham presenciado o facto explicaram às pessoas o que tinha acontecido com o endemoninhado e com os porcos."
,"17":"Então começaram a suplicar a Jesus para que Se retirasse do seu território."
,"18":"Enquanto Jesus entrava de novo na barca, o homem que tinha sido endemoninhado pediu-Lhe que o deixasse ficar com Ele."
,"19":"Jesus, porém, não deixou. E, em troca, disse-lhe: «Vai para casa, para junto dos teus, e anuncia-lhes tudo o que o Senhor, na sua misericórdia, fez por ti»."
,"20":"Então o homem retirou-se e começou a pregar pela Decápole tudo o que Jesus tinha feito por ele. E todos ficavam admirados."
,"21":"Jesus atravessou de barca novamente para o outro lado do mar. Uma numerosa multidão reuniu-se junto d'Ele, e Jesus ficou na praia."
,"22":"Aproximou-se um dos chefes da sinagoga, chamado Jairo. Quando viu Jesus, caiu a seus pés"
,"23":"e pediu-Lhe com insistência: «A minha filhinha está a morrer. Vem e põe as mãos sobre ela, para que sare e viva»."
,"24":"Jesus acompanhou Jairo. E numerosa multidão O seguia e O apertava de todos os lados."
,"25":"Eis que chegou uma mulher que sofria de hemorragia havia doze anos;"
,"26":"tinha padecido nas mãos de muitos médicos, gastou tudo o que tinha e, em vez de melhorar, piorava cada vez mais."
,"27":"A mulher tinha ouvido falar de Jesus. Então veio por entre a multidão, aproximou-se de Jesus por detrás e tocou-Lhe na capa,"
,"28":"porque pensava: «Mesmo que toque só na sua capa, ficarei curada»."
,"29":"A hemorragia parou imediatamente. E a mulher sentiu no corpo que estava curada da doença."
,"30":"Jesus percebeu imediatamente que uma força tinha saído d'Ele. Então virou-Se no meio da multidão e perguntou: «Quem foi que tocou nas minhas vestes?»"
,"31":"Os discípulos disseram: «Vês como a multidão Te aperta e ainda perguntas: 'quem Me tocou?'»."
,"32":"Mas Jesus continuava a olhar em volta para ver quem O tinha tocado."
,"33":"A mulher, cheia de medo e a tremer, percebeu o que lhe havia acontecido. Então foi, caiu aos pés de Jesus e contou toda a verdade."
,"34":"Jesus disse à mulher: «Minha filha, foi a tua fé que te curou. Vai em paz e fica curada dessa doença»."
,"35":"Jesus ainda estava a falar, quando chegaram algumas pessoas da casa do chefe da sinagoga e disseram a Jairo: «A tua filha morreu. Porque é que ainda incomodas o Mestre?»"
,"36":"Jesus ouviu a notícia e disse ao chefe da sinagoga: «Não tenhas receio; crê somente»."
,"37":"E Jesus não deixou que ninguém O acompanhasse, a não ser Pedro, Tiago e seu irmão João."
,"38":"Quando chegaram a casa do chefe da sinagoga, Jesus viu a confusão e ouviu as pessoas a chorar e a gritar."
,"39":"Jesus entrou e disse: «Porquê esta confusão e este choro? A criança não morreu. Ela está apenas a dormir»."
,"40":"As pessoas começaram a zombar d'Ele. Mas Jesus mandou que saíssem todos, menos o pai e a mãe da menina e os três discípulos que O acompanhavam. Depois entraram no quarto onde a menina estava."
,"41":"Jesus tomou a menina pela mão e disse: «Talita cúmi», que quer dizer: «Menina, - Eu te digo - levanta-te!»"
,"42":"A menina levantou-se imediatamente e começou a andar, pois já tinha doze anos. E todos ficaram muito admirados."
,"43":"Jesus recomendou com insistência que ninguém soubesse disto. E mandou dar de comer à menina."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Jesus foi para Nazaré, sua terra, e os seus discípulos acompanharam-n'O."
,"2":"Quando chegou o sábado, Jesus começou a ensinar na sinagoga. Muitos que O escutavam ficavam admirados e diziam: «De onde vem tudo isto? Onde foi que arranjou tanta sabedoria? E esses milagres que são realizados pelas suas mãos?"
,"3":"Este homem não é o carpinteiro, filho de Maria e irmão de Tiago, de José, de Judas e de Simão? E suas irmãs não moram aqui connosco?» E ficaram escandalizados por causa de Jesus."
,"4":"Então Jesus dizia-lhes que um profeta só não é estimado na sua pátria, entre os seus parentes na sua família."
,"5":"E Jesus não pôde fazer milagres em Nazaré. Apenas curou alguns doentes, pondo as mãos sobre eles."
,"6":"E Jesus ficou admirado com a falta de fé daquela gente. Jesus começou a percorrer as redondezas, ensinando nos povoados."
,"7":"Chamou os doze discípulos, começou a enviá-los dois a dois e dava-lhes poder sobre os espíritos maus."
,"8":"Jesus recomendou que não levassem nada para o caminho, além de um bastão; nem pão, nem sacola, nem dinheiro na cintura."
,"9":"Mandou que andassem de sandálias e que não levassem duas túnicas."
,"10":"E Jesus disse ainda: «Quando entrardes numa casa, ficai nela até partirdes."
,"11":"Se fordes mal recebidos num lugar e o povo não vos escutar, quando sairdes sacudi a poeira dos pés como protesto contra eles»."
,"12":"Então os discípulos partiram e pregaram para que as pessoas se convertessem."
,"13":"Expulsavam muitos demónios e curavam muitos doentes, ungindo-os com óleo."
,"14":"O rei Herodes ouviu falar de Jesus, cujo nome se tornara famoso. Alguns diziam: «João Baptista ressuscitou dos mortos. É por isso que os poderes agem nesse homem»."
,"15":"Outros diziam: «É Elias». Outros diziam ainda: «É um profeta como os profetas antigos»."
,"16":"Ouvindo estas coisas, Herodes disse: «Ele é João Baptista. Eu mandei-o decapitar, mas ele ressuscitou!»"
,"17":"De facto, Herodes tinha mandado prender João e pô-lo a ferros na prisão. Fez isto por causa de Herodíades, com quem tinha casado, apesar de ela ser a mulher do seu irmão Filipe."
,"18":"João dizia a Herodes: «Não te é permitido casar com a mulher do teu irmão»."
,"19":"Por isso, Herodíades ficou com raiva de João e queria matá-lo, mas não podia."
,"20":"Com efeito, Herodes temia João, pois sabia que ele era justo e santo, e por isso o protegia. Gostava de ouvi-lo, embora ficasse embaraçado quando o escutava."
,"21":"Finalmente chegou o dia oportuno. Era o aniversário de Herodes. Ele ofereceu um banquete aos grandes da corte, aos oficiais e aos cidadãos importantes da Galileia."
,"22":"A filha de Herodíades entrou e dançou, agradando a Herodes e os seus convidados. Então o rei disse à jovem: «Pede-me o que quiseres e eu to darei»."
,"23":"E jurou: «Juro que te darei qualquer coisa que me pedires, mesmo que seja metade do meu reino»."
,"24":"A jovem saiu e perguntou à mãe: «Que vou eu pedir?» A mãe respondeu: «A cabeça de João Baptista»."
,"25":"A jovem correu para a sala e pediu ao rei: «Quero que me dês agora, num prato, a cabeça de João Baptista»."
,"26":"O rei ficou muito triste, mas não pôde recusar, pois tinha feito o juramento na frente dos convidados."
,"27":"Imediatamente o rei mandou que um soldado fosse buscar a cabeça de João. O soldado saiu, foi à prisão e cortou a cabeça de João."
,"28":"Depois levou a cabeça num prato, deu-a à jovem, e esta entregou-a à sua mãe."
,"29":"Ao terem conhecimento disto, os discípulos de João foram, levaram o cadáver e sepultaram-no."
,"30":"Os apóstolos reuniram-se com Jesus e contaram tudo o que haviam feito e ensinado."
,"31":"Havia ali tanta gente que chegava e saía, a tal ponto que Jesus e os discípulos não tinham tempo nem para comer. Então Jesus disse-lhes: «Vamos sozinhos para algum lugar deserto, para que descanseis um pouco»."
,"32":"Então foram sozinhos, de barca, para um lugar deserto e afastado."
,"33":"Muitas pessoas, porém, viram-nos partir. Sabendo que eram eles, saíram de todas as cidades, acorreram a pé e chegaram lá antes deles."
,"34":"Quando saiu da barca, Jesus viu uma grande multidão e teve compaixão, porque estavam como ovelhas sem pastor. Então começou a ensinar-lhes muitas coisas."
,"35":"Quando começou a entardecer, os discípulos chegaram perto de Jesus e disseram-Lhe: «Este lugar é deserto e já é tarde."
,"36":"Despede o povo, para que possa ir aos campos e povoados vizinhos comprar alguma coisa para comer»."
,"37":"Mas Jesus respondeu: «Vós é que tendes de lhes dar de comer». Os discípulos perguntaram-Lhe: «Devemos gastar meio ano de salário e comprar pão para lhes dar de comer?»"
,"38":"Jesus perguntou: «Quantos pães tendes? Ide ver». Eles foram e responderam: «Cinco pães e dois peixes»."
,"39":"Então Jesus mandou que todos se sentassem na relva, formando grupos."
,"40":"E todos se sentaram, formando grupos de cem e de cinquenta pessoas."
,"41":"Depois Jesus tomou os cinco pães e os dois peixes, ergueu os olhos ao céu, pronunciou a bênção, partiu os pães e ia-os dando aos discípulos, para que os distribuíssem. Dividiu entre todos também os dois peixes."
,"42":"Todos comeram, ficaram satisfeitos,"
,"43":"e recolheram doze cestos cheios de pedaços de pão e também dos peixes."
,"44":"O número dos que comeram os pães era de cinco mil homens."
,"45":"Logo em seguida Jesus obrigou os discípulos a entrar na barca e ir à frente para Betsaida, enquanto Ele despedia a multidão."
,"46":"Logo depois de se despedir da multidão subiu ao monte para rezar."
,"47":"Ao anoitecer, a barca estava no meio do mar e Jesus sozinho em terra."
,"48":"Viu que os discípulos estavam cansados de remar, porque o vento era contrário. Então, entre as três e as seis horas da madrugada, Jesus foi ter com os discípulos andando sobre o mar, e queria passar à frente deles."
,"49":"Quando os discípulos O avistaram a andar sobre o mar, pensaram que era um fantasma e começaram a gritar."
,"50":"Com efeito, todos O tinham visto e ficaram assustados. Mas Jesus falou-lhes imediatamente: «Coragem! Sou Eu, não tenhais medo!»"
,"51":"Então subiu para a barca. E o vento parou. Mas os discípulos ficaram ainda mais espantados,"
,"52":"porque não tinham compreendido o acontecimento dos pães. O seu coração estava endurecido."
,"53":"Acabando de atravessar, chegaram a terra, em Genesaré, e amarraram a barca."
,"54":"Logo que desceram da barca, as pessoas imediatamente reconheceram Jesus."
,"55":"Iam de toda a região, levando os doentes deitados em suas camas para o lugar onde ouviam dizer que Jesus estava."
,"56":"E onde Ele entrava, tanto nos povoados como nas cidades ou nos campos, colocavam os doentes nas praças e pediam que pudessem ao menos tocar a franja da sua capa. E todos os que O tocaram ficaram curados."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Os fariseus e alguns doutores da Lei, vindos de Jerusalém, reuniram-se em volta de Jesus."
,"2":"Viram então que alguns discípulos comiam pão com mãos impuras, isto é, sem lavar as mãos."
,"3":"Os fariseus, assim como todos os judeus, seguem a tradição que receberam dos antigos: só comem depois de lavar bem as mãos."
,"4":"Quando chegam da praça pública, lavam-se antes de comer. E seguem muitos outros costumes que receberam por tradição: a maneira certa de lavar copos, jarras e vasilhas de cobre."
,"5":"Os fariseus e os doutores da Lei perguntaram então a Jesus: «Porque é que os teus discípulos não seguem a tradição dos antigos, pois comem pão sem lavar as mãos?»"
,"6":"Jesus respondeu: «Isaías profetizou bem sobre vós, hipócritas, como está escrito: 'Este povo honra-Me com os lábios, mas o seu coração está longe de Mim."
,"7":"Não adianta prestarem-Me culto, porque ensinam preceitos humanos'."
,"8":"Vós abandonais o mandamento de Deus para seguir a tradição dos homens»."
,"9":"E Jesus acrescentou: «Vós sois bastante espertos para deixar de lado o mandamento de Deus a fim de guardar as vossas tradições."
,"10":"Com efeito, Moisés ordenou: 'Honra teu pai e tua mãe'. E ainda: 'Quem amaldiçoar o pai ou a mãe deve morrer'."
,"11":"Mas vós ensinais que é lícito a alguém dizer ao pai ou à mãe: 'O sustento que poderíeis receber de mim é Corbã, isto é, consagrado a Deus'."
,"12":"E essa pessoa fica dispensada de ajudar o pai ou a mãe."
,"13":"Assim esvaziais a Palavra de Deus com a tradição que vindes transmitindo. E fazeis muitas outras coisas como estas»."
,"14":"Em seguida, Jesus chamou de novo a multidão para junto de Si, e disse: «Escutai todos e compreendei:"
,"15":"o que vem de fora e entra numa pessoa não a torna impura; as coisas que saem de dentro da pessoa é que a tornam impura."
,"16":"Quem tem ouvidos para ouvir, oiça»."
,"17":"Quando Jesus entrou em casa, longe da multidão, os discípulos interrogaram-n'O sobre esta parábola."
,"18":"Jesus disse: «Será que nem vós entendeis? Não compreendeis que nada do que vem de fora e entra numa pessoa pode torná-la impura,"
,"19":"porque não entra no seu coração, mas no estômago, e vai para a privada?» (Assim Jesus declarava que todos os alimentos eram puros)."
,"20":"Jesus continuou a dizer: «O que sai da pessoa é que a torna impura."
,"21":"Pois é de dentro do coração da pessoa que saem as más intenções, como a imoralidade, roubos,"
,"22":"crimes, adultérios, ambições sem limite, maldades, malícia, devassidão, inveja, calúnia, orgulho, falta de juízo."
,"23":"Todas estas coisas más saem de dentro da pessoa, e são elas que a tornam impura»."
,"24":"Então Jesus saiu dali e foi para a região de Tiro e Sidónia. Entrou numa casa e não queria que ninguém soubesse onde Ele estava. Mas não conseguiu ficar escondido."
,"25":"Uma mulher, que tinha uma filha com um espírito mau, ouviu falar de Jesus. Foi ter com Ele e caiu a seus pés."
,"26":"A mulher era pagã, nascida na Fenícia da Síria. Ela suplicou a Jesus que expulsasse de sua filha o demónio."
,"27":"Jesus disse-lhe: «Deixa que primeiro os filhos fiquem saciados, porque não está certo tirar o pão dos filhos e dá-lo aos cachorrinhos»."
,"28":"A mulher respondeu: «É verdade, Senhor; mas também os cachorrinhos ficam debaixo da mesa e comem as migalhas que as crianças deixam cair»."
,"29":"Então Jesus disse: «Por causa disso que acabas de dizer, podes voltar para casa; o demónio já saiu da tua filha»."
,"30":"Ela voltou para casa e encontrou a filha recostada na cama, pois o demónio já tinha saído dela."
,"31":"Jesus saiu de novo da região de Tiro, passou por Sidónia e continuou até ao mar da Galileia, atravessando a região da Decápole."
,"32":"Levaram então a Jesus um homem surdo e que falava com dificuldade, e pediram a Jesus que pusesse a mão sobre ele."
,"33":"Jesus afastou-Se com o homem para longe da multidão; em seguida pôs os dedos no ouvido do homem, cuspiu e com a sua saliva tocou-lhe a língua."
,"34":"Depois olhou para o céu, suspirou e disse: «Efatá!», que quer dizer: «Abre-te!»"
,"35":"Imediatamente os ouvidos do homem se abriram, a língua soltou-se e ele começou a falar sem dificuldade."
,"36":"Jesus recomendou com insistência que não contassem nada a ninguém. No entanto, quanto mais Ele recomendava, mais eles vam."
,"37":"Estavam muito impressionados e diziam: «Jesus faz bem todas as coisas. Faz os surdos ouvir e os mudos falar»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Naqueles dias, havia de novo uma grande multidão e não tinham que comer. Jesus chamou os discípulos e disse:"
,"2":"«Tenho compaixão desta multidão, porque há já três dias que está comigo e não tem nada para comer."
,"3":"Se os mandar para casa sem comer, vão desmaiar pelo caminho, porque muitos deles vieram de longe»."
,"4":"Os discípulos disseram: «Como poderá alguém saciá-los de pão, aqui no deserto?»"
,"5":"Jesus perguntou: «Quantos pães tendes?» Eles responderam: «Sete»."
,"6":"Jesus mandou que a multidão se sentasse no chão. Depois pegou nos sete pães, deu graças, partiu-os e ia-os dando aos discípulos, para que os distribuíssem."
,"7":"Tinham também alguns peixinhos. Depois de pronunciar a bênção sobre eles, mandou que os distribuíssem também."
,"8":"Comeram e ficaram satisfeitos, e recolheram sete cestos dos pedaços que sobraram."
,"9":"Eram mais ou menos quatro mil. Em seguida Jesus despediu-os."
,"10":"Jesus entrou na barca com os discípulos e foi para a região de Dalmanuta."
,"11":"Apareceram então os fariseus e começaram a discutir com Jesus. E, para O experimentarem, pediam-Lhe um sinal do céu."
,"12":"Mas Jesus suspirou profundamente e disse: «Porque é que esta geração pede um sinal? Garanto-vos: A esta geração não será dado nenhum sinal»."
,"13":"E, deixando-os, Jesus entrou de novo na barca e dirigiu-Se para a outra margem."
,"14":"Os discípulos tinham-se esquecido de levar pães. Tinham consigo na barca um só pão."
,"15":"Então Jesus advertiu-os: «Prestai atenção e tomai cuidado com o fermento dos fariseus e com o fermento de Herodes»."
,"16":"Os discípulos diziam entre si: «É porque não temos pão»."
,"17":"Mas Jesus percebeu e perguntou: «Porque é que discutis a falta de pães? Ainda não entendeis nem compreendeis? Estais com o coração endurecido?"
,"18":"Ten-des olhos e não vedes, tendes ouvidos e não ouvis? Não vos lembrais"
,"19":"de quando reparti cinco pães para cinco mil pessoas? Quantos cestos recolhestes cheios de pedaços?» Eles responderam: «Doze»."
,"20":"Jesus perguntou: «E quando reparti sete pães para quatro mil pessoas, quantos cestos recolhestes cheios de pedaços?» Eles responderam: «Sete»."
,"21":"Jesus disse: «Ainda não compreendestes?»."
,"22":"Chegaram a Betsaida. Algumas pessoas trouxeram um cego e pediram a Jesus que tocasse nele."
,"23":"Jesus pegou no cego pela mão, levou-o para fora do povoado, cuspiu-lhe nos olhos, pôs as mãos sobre ele e perguntou: «Estás a ver alguma coisa?»"
,"24":"O homem levantou os olhos e disse: «Vejo os homens; parecem árvores a andar»."
,"25":"Então Jesus pôs de novo as mãos sobre os olhos dele, e ele viu claramente. Ficou curado e via todas as coisas com nitidez, mesmo de longe."
,"26":"Jesus mandou-o para casa, dizendo: «Não entres na aldeia»."
,"27":"Jesus partiu com os discípulos para as aldeias de Cesareia de Filipe. No caminho, perguntou aos discípulos: «Quem dizem os homens que Eu sou?»"
,"28":"Eles responderam: «Alguns dizem que Tu és João Baptista; outros, que és Elias; outros, ainda, que és um dos profetas»."
,"29":"Então Jesus perguntou-lhes: «E vós, quem dizeis que Eu sou?» Pedro respondeu: «Tu és o Messias»."
,"30":"Então Jesus proibiu severamente que falassem a alguém a respeito d'Ele."
,"31":"Em seguida, Jesus começou a ensinar os discípulos, dizendo: «O Filho do Homem deve sofrer muito, ser rejeitado pelos anciãos, pelos sumos sacerdotes e doutores da Lei, deve ser morto e ressuscitar depois de três dias»."
,"32":"E Jesus dizia isto abertamente. Então Pedro tomou Jesus à parte e começou a repreendê-l'O."
,"33":"Jesus virou-Se, olhou para os discípulos e repreendeu Pedro, dizendo: «Fica longe de mim, satanás! Não pensas as coisas de Deus, mas só as coisas dos homens»."
,"34":"Então Jesus chamou a multidão e os discípulos. E disse: «Se alguém quiser seguir-Me, renuncie a si mesmo, tome a sua cruz e siga-Me."
,"35":"Pois, quem quiser salvar a sua vida, vai perdê-la; mas, quem perde a sua vida por causa da Boa Notícia, vai salvá-la."
,"36":"Com efeito, que adianta ao homem ganhar o mundo inteiro se perde a própria vida?"
,"37":"Que é que um homem poderia dar em troca da própria vida?"
,"38":"Se alguém se envergonhar de Mim e das minhas palavras diante desta geração adúltera e pecadora, também o Filho do Homem Se envergonhará dele, quando vier na glória do seu Pai com os santos anjos»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"E Jesus dizia:«Garanto-vos: alguns dos que estão aqui não morrerão sem terem visto o Reino de Deus chegar com poder»."
,"2":"Seis dias depois, Jesus tomou consigo Pedro, Tiago e seu irmão João, e levou-os sozinhos a um lugar à parte, sobre uma alta montanha. E transfigurou-Se diante deles. "
,"3":"As suas vestes ficaram brilhantes e tão brancas, como nenhuma lavadeira no mundo as poderia branquear."
,"4":"Apareceram-lhes Elias e Moisés, que estavam a conversar com Jesus."
,"5":"Então Pedro tomou a palavra e disse a Jesus: «Mestre, é bom ficarmos aqui. Vamos fazer três tendas: uma para Ti, outra para Moisés e outra para Elias»."
,"6":"Pedro não sabia o que dizia, pois estavam cheios de medo."
,"7":"Então desceu uma nuvem e cobriu-os com a sua sombra. E da nuvem saiu uma voz: «Este é o meu Filho amado. Escutai o que Ele diz!»"
,"8":"E, de repente, olharam em volta e não viram mais ninguém, a não ser somente Jesus com eles."
,"9":"Ao descerem da montanha, Jesus recomendou-lhes que não contassem a ninguém o que tinham visto, até que o Filho do Homem tivesse ressuscitado dos mortos."
,"10":"Eles observaram a recomendação e discutiam uns com os outros o que queria dizer «ressuscitar dos mortos»."
,"11":"Os discípulos perguntaram a Jesus: «Porque é que os doutores da Lei dizem que antes deve vir Elias?»"
,"12":"Jesus respondeu: «Antes vem Elias, para pôr tudo em ordem. Mas, como dizem as Escrituras, o Filho do Homem deve sofrer muito e ser rejeitado."
,"13":"Eu, porém, digo-vos: Elias já veio e fizeram dele tudo o que queriam, exactamente como está escrito nas Escrituras a respeito dele»."
,"14":"Quando Jesus, Pedro, Tiago e João chegaram perto dos outros discípulos, viram que eles estavam rodeados por uma grande multidão. Alguns doutores da Lei estavam a discutir com eles."
,"15":"Logo que a multidão viu Jesus, ficou surpreendida e acorreu a saudá-l'O."
,"16":"Jesus perguntou aos discípulos: «Que é que estais a discutir com eles?»"
,"17":"Alguém da multidão respondeu: «Mestre, eu trouxe-Te o meu filho que tem um espírito mudo."
,"18":"Cada vez que o espírito o ataca, lança-o ao chão e ele começa a espumar, range os dentes e fica completamente rijo. Eu pedi aos teus discípulos para expulsarem o espírito, mas eles não conseguiram»."
,"19":"Jesus disse: «Ó gente sem fé! Até quando deverei ficar convosco? Até quando vos hei-de suportar? Trazei-mo cá»."
,"20":"E levaram-Lhe o menino. Quando o espírito viu Jesus, sacudiu violentamente o menino, que caiu no chão e começou a rolar e a espumar pela boca."
,"21":"Jesus perguntou ao pai: «Há quanto tempo lhe sucede isto?» O pai respondeu: «Desde criança."
,"22":"E muitas vezes já o lançou ao fogo e à água para o matar. Se podes fazer alguma coisa, tem piedade de nós e ajuda-nos»."
,"23":"Jesus disse: «Se podes!... Tudo é possível a quem tem fé»."
,"24":"O pai do menino gritou: «Eu tenho fé, mas ajuda a minha falta de fé»."
,"25":"Jesus viu que a multidão corria para junto d'Ele. Então ordenou ao espírito mau: «Espírito mudo e surdo, Eu te ordeno que saias do menino e nunca mais entres nele»."
,"26":"O espírito sacudiu o menino com violência, deu um grito e saiu. O menino ficou como morto e por isso todos diziam: «Morreu!»"
,"27":"Mas Jesus pegou na mão do menino, levantou-o, e o menino ficou de pé."
,"28":"Depois que Jesus entrou em casa, os discípulos perguntaram-Lhe à parte: «Porque é que nós não conseguimos expulsar o espírito?»"
,"29":"Jesus respondeu: «Esta espécie de demónios não pode ser expulsa de nenhum modo, a não ser pela oração»."
,"30":"Partindo dali, Jesus e os discípulos atravessavam a Galileia. Jesus não queria que ninguém soubesse onde Ele estava,"
,"31":"porque estava a ensinar os seus discípulos. E dizia-lhes: «O Filho do Homem vai ser entregue nas mãos dos homens, que O matarão. Mas, quando estiver morto, depois de três dias ressuscitará»."
,"32":"Mas os discípulos não compreendiam o que Jesus lhes dizia e tinham medo de Lhe fazer perguntas."
,"33":"Quando chegaram à cidade de Cafarnaum e estavam em casa, Jesus perguntou aos discípulos: «O que é que discutíeis pelo caminho?»"
,"34":"Os discípulos ficaram calados, porque tinham discutido sobre qual deles era o maior."
,"35":"Então Jesus sentou-Se, chamou os Doze e disse-lhes: «Se alguém quer ser o primeiro, deverá ser o último e ser aquele que serve a todos»."
,"36":"Depois Jesus pegou numa criança e colocou-a no meio deles. Abraçou a criança e disse:"
,"37":"«Quem receber em meu nome uma destas crianças, é a Mim que recebe. E quem Me receber, não Me recebe a Mim, mas Àquele que Me enviou»."
,"38":"João disse a Jesus: «Mestre, vimos um homem que expulsa demónios em teu nome. Mas nós proibimos-lho, porque ele não nos segue»."
,"39":"Jesus disse: «Não lho proibais, pois ninguém faz um milagre em meu nome e depois vai dizer mal de Mim."
,"40":"Quem não está contra nós está a nosso favor."
,"41":"Eu vos garanto: quem vos der um copo de água porque sois de Cristo, não ficará sem receber a sua recompensa."
,"42":"E se alguém escandalizar um destes pequeninos que acreditam, seria melhor que fosse lançado ao mar com uma pedra de moinho amarrada no pescoço."
,"43":"Se a tua mão é ocasião de escândalo para ti, corta-a. É melhor entrares na vida sem uma das mãos, do que ter as duas mãos e ir para o inferno, onde o fogo nunca se apaga."
,"44":"Ali o verme nunca morre e o fogo nunca se apaga."
,"45":"Se o teu pé é ocasião de escândalo para ti, corta-o. É melhor entrares na vida sem um dos pés, do que ter os dois pés e seres lançado no inferno."
,"46":"Ali o verme nunca morre e o fogo nunca se apaga."
,"47":"Se o teu olho é ocasião de escândalo para ti, arranca-o. É melhor entrares no Reino de Deus com um olho só, do que ter os dois olhos e ser lançado no inferno,"
,"48":"onde o verme nunca morre e o fogo nunca se apaga."
,"49":"Com efeito, todos serão salgados com fogo."
,"50":"O sal é bom. Mas, se o sal se tornar insosso, com que lhe dareis sabor? Tende sal em vós mesmos e vivei em paz uns com os outros»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Jesus partiu dali e foi para o território da Judeia, do outro lado do rio Jordão. As multidões reuniram-se de novo em torno de Jesus. E Ele, como de costume, ensinava-as."
,"2":"Alguns fariseus aproximaram-se de Jesus. Queriam tentá-l'O e perguntaram-Lhe se a Lei permitia a um homem divorciar-se da sua mulher."
,"3":"Jesus perguntou: «O que é que Moisés vos mandou fazer?»"
,"4":"Os fariseus responderam: «Moisés permitiu escrever uma certidão de divórcio e depois mandar a mulher embora»."
,"5":"Jesus então disse: «Foi por causa da dureza do vosso coração que Moisés escreveu esse mandamento."
,"6":"Mas, desde o início da Criação, Deus fê-los homem e mulher."
,"7":"Por isso, o homem deixará pai e mãe,"
,"8":"e os dois serão uma só carne. Portanto, eles já não são dois, mas uma só carne."
,"9":"Portanto, o que Deus uniu, o homem não o deve separar»."
,"10":"Quando chegaram a casa, os discípulos fizeram de novo perguntas sobre o mesmo assunto."
,"11":"Jesus respondeu: «O homem que se divorciar de sua mulher e se casar com outra comete adultério contra a primeira mulher."
,"12":"E se a mulher se divorciar do seu marido e se casar com outro homem, ela comete adultério»."
,"13":"Depois disto, alguns trouxeram crianças para que Jesus as tocasse. Mas os discípulos repreendiam-nos."
,"14":"Vendo isto, Jesus ficou zangado e disse: «Deixai vir a Mim as crianças. Não as afasteis, porque o Reino de Deus pertence-lhes."
,"15":"Eu vos garanto: quem não receber como criança o Reino de Deus, nunca entrará nele»."
,"16":"Então Jesus abraçou as crianças e abençoou-as, pondo a mão sobre elas."
,"17":"Quando Jesus Se pôs de novo a caminho, um homem aproximou-se a correr, ajoelhou-se diante d'Ele e perguntou: «Bom Mestre, que devo fazer para herdar a vida eterna?»"
,"18":"Jesus respondeu: «Porque Me chamas bom? Só Deus é bom, e ninguém mais."
,"19":"Conheces os mandamentos: Não mates; não cometas adultério; não roubes; não levantes falso testemunho; não enganes; honra teu pai e tua mãe»."
,"20":"O homem afirmou: «Mestre, desde jovem tenho observado todas essas coisas»."
,"21":"Jesus olhou para ele com amor e disse-lhe: «Falta-te só fazer uma coisa: vai, vende tudo, dá o dinheiro aos pobres e terás um tesouro no Céu. Depois vem e segue-Me»."
,"22":"Quando ouviu isto, o homem ficou abatido e afastou-se cheio de tristeza, porque era muito rico."
,"23":"Jesus então olhou em volta e disse aos discípulos: «Como é difícil para os ricos entrar no Reino de Deus!»"
,"24":"Os discípulos admiraram-se com o que Jesus disse. Mas Ele continuou: «Meus filhos, como é difícil entrar no Reino de Deus!"
,"25":"É mais fácil passar um camelo pelo buraco de uma agulha, do que um rico entrar no Reino de Deus!»"
,"26":"Os discípulos ficaram muito espantados quando ouviram isto, e perguntavam uns aos outros: «Quem pode então salvar-se?»"
,"27":"Jesus olhou para os discípulos e disse: «Aos homens isso é impossível, mas não a Deus. A Deus tudo é possível»."
,"28":"Pedro começou a dizer a Jesus: «Eis que nós deixámos tudo e Te seguimos»."
,"29":"Jesus respondeu: «Eu vos garanto: quem tiver deixado casa, irmãos, irmãs, mãe, filhos, campos, por causa de Mim e da Boa Notícia,"
,"30":"vai receber cem vezes mais. Agora, durante esta vida, vai receber casas, irmãos, irmãs, mãe, filhos e campos, juntamente com perseguições. E, no mundo futuro, vai receber a vida eterna."
,"31":"Muitos que agora são os primeiros serão os últimos, e muitos que agora são os últimos serão os primeiros»."
,"32":"Jesus e os discípulos iam a caminho, subindo para Jerusalém. Jesus ia à frente. Os discípulos estavam espantados, e aqueles que iam atrás estavam com medo. Jesus chamou de novo os Doze à parte e começou a dizer-lhes o que estava para acontecer com Ele:"
,"33":"«Eis que estamos a subir para Jerusalém, e o Filho do Homem vai ser entregue aos sumos sacerdotes e aos doutores da Lei. Estes condená-l'O-ão à morte e entregá-l'O-ão aos pagãos."
,"34":"Vão escarnecê-l'O, cuspir n'Ele, vão torturá-l'O e matá-l'O. E depois de três dias Ele ressuscitará»."
,"35":"Tiago e João, filhos de Zebedeu, foram ter com Jesus e disseram-Lhe: «Mestre, queremos que nos faças o que Te vamos pedir»."
,"36":"Jesus perguntou: «O que quereis que vos conceda?»"
,"37":"Eles responderam: «Quando estiveres na glória, deixa-nos sentar um à tua direita e o outro à tua esquerda»."
,"38":"Jesus então disse-lhes: «Não sabeis o que estais a pedir. Acaso podeis beber o cálice que Eu vou beber? Podeis ser baptizados com o baptismo com que Eu vou ser baptizado?»"
,"39":"Eles responderam: «Podemos». Jesus então disse-lhes: «Ides beber o cálice que Eu vou beber e ser baptizados com o baptismo com que Eu vou ser baptizado."
,"40":"Mas não depende de Mim conceder o lugar à minha direita ou esquerda. É Deus quem dará esses lugares àqueles para os quais Ele os reservou»."
,"41":"Quando os outros dez discípulos ouviram isto, começaram a ficar com raiva de Tiago e João."
,"42":"Jesus chamou-os e disse: «Sabeis como aqueles que se dizem governadores das nações têm poder sobre elas, e os seus dirigentes exercem sobre elas a sua autoridade."
,"43":"Mas entre vós não deverá ser assim: quem de vós quiser ser grande, deve tornar-se o vosso servidor,"
,"44":"e quem de vós quiser ser o primeiro, deverá tornar-se o servo de todos."
,"45":"Porque o Filho do Homem não veio para ser servido. Ele veio para servir e para dar a sua vida como resgate em favor de muitos»."
,"46":"Chegaram a Jericó. Jesus saiu de Jericó, com os seus discípulos e uma grande multidão. À beira do caminho havia um cego que se chamava Bartimeu, filho de Timeu; estava sentado, pedindo esmola."
,"47":"Quando ouviu dizer que era Jesus Nazareno que passava, o cego começou a gritar: «Jesus, filho de David, tem piedade de mim!»"
,"48":"Muitos repreendiam-no para que se calasse. Mas ele gritava mais ainda: «Filho de David, tem piedade de mim!»"
,"49":"Então Jesus parou e disse: «Chamai o cego». Eles chamaram o cego e disseram: «Coragem, levanta-te, porque Jesus chama-te»."
,"50":"O cego largou o manto, deu um pulo e foi até Jesus."
,"51":"Então Jesus perguntou-lhe: «Que queres que te faça?» O cego respondeu: «Mestre, eu quero ver de novo»."
,"52":"Jesus disse: «Podes ir, foi a tua fé que te curou». No mesmo instante o cego começou a ver de novo e seguia Jesus pelo caminho."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jesus e os discípulos aproximaram-Se de Jerusalém, diante de Betfagé e de Betânia, perto do monte das Oliveiras. Então Jesus enviou dois discípulos,"
,"2":"dizendo: «Ide à povoação que está em frente de vós, e logo que nela entrardes encontrareis preso um jumentinho que nunca foi montado; soltai-o e trazei-o."
,"3":"Se alguém vos perguntar: 'Porque fazeis isso?', dizei: 'O Senhor precisa dele, mas logo o devolverá'»."
,"4":"Então eles foram e encontraram um jumentinho preso, do lado de fora, na rua, junto de uma porta, e soltaram-no."
,"5":"Algumas pessoas que lá estavam disseram: «Que fazeis, soltando o jumentinho?»"
,"6":"Os discípulos responderam como Jesus havia dito, e então permitiram que fizessem isso."
,"7":"Então levaram o jumentinho a Jesus, colocaram os próprios mantos sobre ele, e Jesus montou."
,"8":"Muitas pessoas estenderam os seus mantos pelo caminho; outros puseram ramos que haviam apanhado nos campos."
,"9":"Os que iam à frente e os que seguiam gritavam: «Hosana! Bendito Aquele que vem em nome do Senhor!"
,"10":"Bendito seja o Reino que vem, o reino de nosso pai David! Hosana no mais alto do céu!»"
,"11":"Jesus entrou em Jerusalém, no Templo, e olhou tudo ao redor. Mas, como já era tarde, saiu para Betânia com os Doze."
,"12":"No dia seguinte, quando voltavam de Betânia, Jesus sentiu fome."
,"13":"Viu ao longe uma figueira coberta de folhas e foi até lá ver se encontrava algum fruto. Quando chegou perto, encontrou somente folhas, pois não era tempo de figos."
,"14":"Então Jesus disse à figueira: «Que ninguém mais coma dos teus figos». E os discípulos ouviram o que Ele disse."
,"15":"Chegaram a Jerusalém. Jesus entrou no Templo e começou a expulsar os que vendiam e os que compravam no Templo. Derrubou as mesas dos cambistas e as cadeiras dos vendedores de pombas."
,"16":"Ele não permitia que se transportasse qualquer objecto através do Templo."
,"17":"E ensinava o povo, dizendo: «Não está nas Escrituras: 'A minha casa será chamada casa de oração para todos os povos'? No entanto, vós fizestes dela um covil de ladrões»."
,"18":"Os sumos sacerdotes e os doutores da Lei ouviram isto e começaram a procurar um modo de O matar. Mas tinham medo de Jesus, porque a multidão estava maravilhada com os seus ensinamentos."
,"19":"Ao entardecer, Jesus e os discípulos saíram da cidade."
,"20":"Na manhã seguinte, Jesus e os discípulos, passando, viram a figueira que tinha secado até à raiz."
,"21":"Pedro lembrou-se e disse a Jesus: «Olha, Mestre: a figueira que amaldiçoaste secou»."
,"22":"Jesus disse-lhes: «Tende fé em Deus."
,"23":"Eu vos garanto: se alguém disser a esta montanha: 'Levanta-te e lança-te ao mar', e não duvidar no seu coração, mas acreditar que isso vai acontecer, assim acontecerá."
,"24":"É por isso que Eu vos digo: tudo o que pedirdes na oração, acreditai que já o recebestes, e assim será."
,"25":"Quando estiverdes para rezar, perdoai tudo o que tiverdes contra alguém, para que o vosso Pai que está no céu também perdoe os vossos pecados."
,"26":"Mas, se não perdoardes, o vosso Pai que está no céu não perdoará os vossos pecados»."
,"27":"Jesus e os discípulos foram de novo a Jerusalém. Andando Jesus pelo Templo, os sumos sacerdotes, os doutores da Lei e os anciãos aproximaram-se d'Ele."
,"28":"Perguntaram-Lhe: «Com que autoridade fazes estas coisas? Quem Te deu autoridade para fazeres isto?»"
,"29":"Jesus respondeu: «Vou fazer-vos uma só pergunta. Respondei-me, e Eu direi com que autoridade faço isto."
,"30":"O baptismo de João vinha do Céu ou dos homens? Respondei-me»."
,"31":"Eles comentavam entre si: «Se respondemos que vinha do Céu, Ele vai dizer: 'Então, porque não acreditastes em João?'"
,"32":"Devemos então dizer que vinha dos homens?» Mas tinham medo da multidão, porque todos consideravam João como verdadeiro profeta."
,"33":"Então responderam a Jesus: «Não sabemos». E Jesus disse: «Pois então também Eu vos não digo com que autoridade faço estas coisas»."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Jesus começou a falar-lhes em parábolas: «Um homem plantou uma vinha, cercou-a, fez um tanque para pisar a uva e construiu uma torre de guarda. Depois arrendou a vinha a alguns agricultores e partiu para o estrangeiro."
,"2":"Na época da colheita, mandou um empregado aos agricultores para receber a sua parte dos frutos da vinha."
,"3":"Mas os agricultores pegaram no empregado, bateram-lhe e mandaram-no sem nada."
,"4":"Então o dono da vinha mandou mais um empregado. Os agricultores bateram-lhe na cabeça e insultaram-no."
,"5":"Então o dono mandou mais um, e eles mataram-no. Trataram da mesma maneira muitos outros, batendo nuns e matando outros."
,"6":"Restou ao dono apenas um: o seu filho querido. Por último, mandou o filho aos agricultores, pensando: 'Eles vão respeitar o meu filho'."
,"7":"Mas os agricultores comentaram: 'Este é o herdeiro. Vamos matá-lo, e a herança será nossa'."
,"8":"Então agarraram no filho, mataram-no e lançaram-no fora da vinha."
,"9":"Que fará o dono da vinha? Ele virá, destruirá os agricultores e entregará a vinha a outros."
,"10":"Acaso não lestes na Escritura: 'A pedra que os construtores deixaram de lado tornou-se a pedra mais importante;"
,"11":"isto foi feito pelo Senhor e é admirável aos nossos olhos'?»"
,"12":"Então os chefes dos judeus procuraram prender Jesus. Eles tinham entendido muito bem que Jesus havia contado esta parábola contra eles. Mas ficaram com medo da multidão e, por isso, deixaram Jesus e retiraram-se."
,"13":"Então as autoridades mandaram alguns fariseus e alguns partidários de Herodes, para apanharem Jesus em alguma palavra."
,"14":"Quando chegaram, disseram a Jesus: «Mestre, sabemos que és verdadeiro, porque não dás preferência a ninguém. Com efeito, não levas em conta as aparências e ensinas de verdade o caminho de Deus. Diz-nos: É lícito ou não pagar o imposto a César? Devemos pagar ou não?»"
,"15":"Jesus percebeu a hipocrisia deles e respondeu: «Porque Me tentais? Trazei-me uma moeda para Eu ver»."
,"16":"Eles levaram-Lhe a moeda e Jesus perguntou: «De quem é a figura e a inscrição que está nesta moeda?» Eles responderam: «É de César»."
,"17":"Então Jesus disse: «Pois dai a César o que é de César, e a Deus o que é de Deus». E eles ficaram admirados com Jesus."
,"18":"Os saduceus afirmam que não existe ressurreição. Alguns deles foram ter com Jesus e propuseram-Lhe este caso:"
,"19":"«Mestre, Moisés prescreveu-nos: 'Se alguém morrer, e deixar a esposa sem filhos, o irmão desse homem deve casarse com a viúva, a fim de que possam ter filhos em nome do irmão que morreu'."
,"20":"Ora, havia sete irmãos: o primeiro casou-se e morreu sem ter filhos."
,"21":"O segundo casou-se com a viúva e morreu sem ter filhos. A mesma coisa aconteceu com o terceiro."
,"22":"E nenhum dos sete teve filhos. Por último, morreu também a mulher."
,"23":"Na ressurreição, quando eles ressuscitarem, de qual deles será ela mulher? Todos os sete se casaram com ela!»"
,"24":"Jesus respondeu: «Estais enganados, porque não conheceis as Escrituras nem o poder de Deus."
,"25":"Com efeito, quando os mortos ressuscitarem, os homens e as mulheres não se casarão, pois serão como os anjos do Céu."
,"26":"E, quanto ao facto de que os mortos vão ressuscitar, não lestes, no livro de Moisés, a passagem da sarça ardente? Deus disse a Moisés: 'Eu sou o Deus de Abraão, o Deus de Isaac e o Deus de Jacob'."
,"27":"Ora, Ele não é Deus de mortos, mas de vivos! Andais muito enganados»."
,"28":"Um doutor da Lei que ali estava ouviu a discussão. Vendo que Jesus tinha respondido bem, aproximou-se d'Ele e perguntou: «Qual é o primeiro de todos os mandamentos?»"
,"29":"Jesus respondeu: «O primeiro mandamento é este: Ouve, ó Israel! O Senhor nosso Deus é o único Senhor!"
,"30":"E amarás ao Senhor teu Deus com todo o teu coração, com toda a tua alma, com todo o teu entendimento e com todas as tuas forças."
,"31":"O segundo mandamento é este: Amarás ao teu próximo como a ti mesmo. Não existe outro mandamento mais importante do que estes dois»."
,"32":"O doutor da Lei disse a Jesus: «Muito bem, Mestre! Como disseste, Ele é, na verdade, o único Deus, e não existe outro além d'Ele."
,"33":"E amá-l'O com todo o coração, com toda a mente, e com todas as forças, e amar o próximo como a si mesmo é melhor do que todos os holocaustos e do que todos os sacrifícios»."
,"34":"Jesus viu que o doutor da Lei tinha respondido com inteligência, e disse: «Não estás longe do Reino de Deus». E ninguém mais tinha coragem de fazer perguntas a Jesus."
,"35":"Jesus ensinava no Templo, dizendo: «Como é que os doutores da Lei dizem que o Messias é filho de David?"
,"36":"O próprio David, movido pelo Espírito Santo, disse: 'O Senhor disse ao meu Senhor: Senta-te à minha direita, até que eu ponha os teus inimigos debaixo dos teus pés'."
,"37":"Portanto, o próprio David chama-Lhe Senhor. Como é que Ele pode então ser seu filho?» E uma grande multidão ouvia-O com agrado."
,"38":"E Jesus continuava a ensinar: «Tende cuidado com os doutores da Lei. Eles gostam de andar com vestes compridas, de ser cumprimentados nas praças públicas;"
,"39":"gostam dos primeiros lugares nas sinagogas e dos lugares de honra nos banquetes."
,"40":"No entanto, exploram as viúvas e roubam as suas casas, e, para disfarçar, fazem longas orações. Por isso vão receber uma condenação mais severa»."
,"41":"Jesus estava sentado em frente do Tesouro do Templo e observava a multidão que depositava moedas no Tesouro. Muitos ricos depositavam muito dinheiro."
,"42":"Então chegou uma viúva pobre e depositou duas pequenas moedas, que valiam a quarta parte de um asse."
,"43":"Então Jesus chamou os discípulos e disse-lhes: «Eu vos garanto: esta viúva pobre depositou mais do que todos os outros que deitaram moedas no Tesouro."
,"44":"Porque todos deitaram do que lhes sobrava. Mas a viúva, na sua pobreza, depositou tudo o que tinha, tudo o que possuía para viver»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Quando Jesus saiu do Templo, um discípulo comentou: «Mestre, olha que pedras e que construções!»"
,"2":"Jesus respondeu: «Vês estas grandes construções? Não ficará pedra sobre pedra; tudo será destruído»."
,"3":"Jesus estava sentado no monte das Oliveiras, virado para o Templo. Então Pedro, Tiago, João e André disseram-Lhe em particular:"
,"4":"«Diz-nos: quando é que tudo isto vai acontecer e qual será o sinal de que todas estas coisas estarão para acabar?»"
,"5":"Jesus começou a dizer-lhes: «Cuidado para que ninguém vos engane."
,"6":"Muitos virão em meu nome, dizendo: 'Sou eu'. E enganarão muita gente."
,"7":"Quando ouvirdes falar de guerras e de rumores de guerra, não fiqueis assustados. Essas coisas devem acontecer, mas ainda não é o fim."
,"8":"Com efeito, uma nação lutará contra outra, e um reino contra outro reino. Haverá terramotos em vários lugares, e também haverá fome. Isto será o começo das dores»."
,"9":"«Tomai muito cuidado! Entregar-vos-ão aos tribunais. Sereis torturados nas sinagogas, comparecereis diante de governadores e reis por minha causa, para dardes testemunho diante deles."
,"10":"Mas antes a Boa Notícia deve ser anunciada a todas as nações."
,"11":"Quando vos conduzirem para serdes entregues, não vos preocupeis com aquilo que devereis dizer: dizei o que vos vier à mente nesse momento, porque não sereis vós a falar, mas o Espírito Santo."
,"12":"Um irmão entregará o próprio irmão à morte, e o pai entregará o filho; os filhos ficarão contra os pais e entregá-los-ão à morte."
,"13":"Sereis odiados por todos por causa do meu nome. Quem perseverar até ao fim, será salvo»."
,"14":"«Quando virdes a abominação da desolação estabelecida no lugar onde não deveria estar, - que o leitor entenda! - então os que estiverem na Judeia devem fugir para as montanhas."
,"15":"Quem estiver no terraço, não desça para tomar coisa alguma dentro de casa."
,"16":"Quem estiver no campo, não volte para buscar a capa."
,"17":"Infelizes as mulheres grávidas e aquelas que estiverem amamentando nesses dias!"
,"18":"Rezai para que isto não aconteça no Inverno."
,"19":"Porque, nesses dias, haverá uma tribulação como nunca houve, desde o início da Criação feita por Deus, até agora; e nunca mais haverá outra igual."
,"20":"Se o Senhor não abreviasse esses dias, ninguém conseguiria salvar-se. Mas Ele abreviou aqueles dias, por causa dos eleitos que escolheu."
,"21":"Se alguém vos disser: 'O Messias está aqui', ou: 'Ele está ali', não acrediteis."
,"22":"Porque vão aparecer falsos messias e falsos profetas, que farão sinais e prodígios para enganar até mesmo os eleitos, se fosse possível."
,"23":"Prestai atenção! Eu estou a falar-vos de tudo isto, antes que aconteça»."
,"24":"«Nesses dias, depois da tribulação, o Sol vai ficar escuro, a Lua deixará de brilhar,"
,"25":"as estrelas começarão a cair do céu e os poderes do espaço ficarão abalados."
,"26":"Então, verão o Filho do Homem vir sobre as nuvens com grande poder e glória."
,"27":"Ele enviará os anjos aos quatro cantos da Terra e reunirá as pessoas que Deus escolheu, do extremo da Terra ao extremo do céu»."
,"28":"«Aprendei, portanto, a parábola da figueira: quando os seus ramos ficam verdes e as folhas começam a brotar, sabeis que o Verão está perto."
,"29":"Vós também, quando virdes acontecer estas coisas, sabei que ele está perto, já está às portas."
,"30":"Eu vos garanto: tudo isso vai acontecer antes que morra esta geração que agora vive."
,"31":"O céu e a terra desaparecerão, mas as minhas palavras não desaparecerão."
,"32":"Quanto a esse dia e a essa hora, ninguém sabe nada, nem os anjos no Céu, nem o Filho. Somente o Pai é que sabe."
,"33":"Prestai atenção! Vigiai, porque não sabeis quando vai ser o momento."
,"34":"Vai acontecer como a um homem que partiu para o estrangeiro. Ele deixou a casa, distribuiu uma tarefa a cada um dos empregados e mandou ao porteiro que vigiasse."
,"35":"Vigiai, portanto, porque não sabeis quando o dono da casa vai voltar; pode ser à tarde, à meia-noite, de madrugada ou ao amanhecer."
,"36":"Se ele vier de repente, não deve encontrá-los a dormir."
,"37":"O que vos digo a vós, digo-o a todos: Vigiai»."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Faltavam dois dias para a festa da Páscoa e para a festa dos Ázimos. Os sumos sacerdotes e os doutores da Lei procuravam um modo de prender Jesus e depois matá-l'O."
,"2":"Eles diziam: «A fim de que, durante a festa, não haja confusão no meio do povo»."
,"3":"Jesus estava em Betânia, na casa de Simão, o leproso. Enquanto faziam a refeição, chegou uma mulher com um vaso de alabastro, cheio de um perfume de nardo puro, muito caro. Ela quebrou o vaso e derramou o perfume sobre a cabeça de Jesus."
,"4":"Alguns que ali estavam ficaram com raiva e comentavam: «Porquê desperdiçar este perfume?"
,"5":"O perfume poderia ser vendido por mais de trezentas moedas de prata, que poderiam ser dadas aos pobres». E criticavam a mulher."
,"6":"Mas Jesus disse-lhes: «Deixai-a; porque estais a atormentá-la? Ela fez-Me uma coisa muito boa."
,"7":"Sempre tereis pobres entre vós e podereis fazer-lhes bem quando quiserdes. Mas Eu não vou estar sempre convosco."
,"8":"Ela fez o que podia: derramou perfume no meu corpo, preparando-o para a sepultura."
,"9":"Eu vos garanto: por toda a parte, onde a Boa Notícia for pregada, também contarão o que ela fez, e ela será lembrada»."
,"10":"Judas Iscariotes, um dos doze discípulos, foi ter com os sumos sacerdotes, para entregar Jesus."
,"11":"Eles ficaram muito contentes quando ouviram isto e prometeram dar dinheiro a Judas. Então Judas começou a procurar uma boa oportunidade para entregar Jesus."
,"12":"No primeiro dia dos Ázimos, quando matavam os cordeiros para a Páscoa, os discípulos perguntaram a Jesus: «Onde queres que façamos os preparativos para que comas a Páscoa?»"
,"13":"Jesus mandou então dois dos seus discípulos, dizendo: «Ide à cidade. Um homem transportando um jarro de água virá ao vosso encontro. Segui-o"
,"14":"e dizei ao dono da casa onde ele entrar: 'O Mestre manda dizer: Onde é a sala em que Eu e os meus discípulos vamos comer a Páscoa?'"
,"15":"Então ele mostrar-vos-á, no andar de cima, uma sala grande, arrumada com almofadas. Preparai aí tudo para nós»."
,"16":"Os discípulos partiram e foram à cidade. Encontraram tudo como Jesus havia dito e prepararam a Páscoa."
,"17":"Ao cair da tarde, Jesus chegou com os Doze."
,"18":"Enquanto estavam à mesa e comiam, Jesus disse: «Eu vos garanto: um de vós vai trair-Me. É alguém que come comigo»."
,"19":"Os discípulos começaram a ficar tristes e, um após outro, perguntaram a Jesus: «Serei eu?»"
,"20":"Jesus disse-lhes: «É um dos Doze. É aquele que mete comigo a mão no prato."
,"21":"O Filho do Homem vai morrer, conforme diz a Escritura acerca d'Ele. Contudo, ai daquele que trair o Filho do Homem! Seria melhor que nunca tivesse nascido!»"
,"22":"Enquanto comiam, Jesus tomou um pão e, tendo pronunciado a bênção, partiu-o, distribuiu-o aos discípulos e disse: «Tomai, isto é o meu corpo»."
,"23":"Em seguida, tomou um cálice, deu graças e entregou-lho. E todos eles beberam."
,"24":"E Jesus disse-lhes: «Isto é o meu sangue, o sangue da aliança, que é derramado em favor de muitos."
,"25":"Eu vos garanto: nunca mais beberei do fruto da videira, até ao dia em que beberei o vinho novo no Reino de Deus»."
,"26":"Depois de terem cantado os salmos, foram para o monte das Oliveiras."
,"27":"Então Jesus disse aos discípulos: «Todos ireis ficar desorientados, porque a Escritura diz: 'Ferirei o pastor, e as ovelhas dispersar-se-ão'."
,"28":"Mas, depois de ressuscitar, Eu irei à vossa frente para a Galileia»."
,"29":"Pedro declarou a Jesus: «Mesmo que todos fiquem desorientados, eu não ficarei»."
,"30":"Jesus disse a Pedro: «Eu te garanto: ainda hoje, esta noite, antes que o galo cante duas vezes, negar-Me-ás três vezes»."
,"31":"Mas Pedro repetiu com mais força: «Ainda que tenha de morrer contigo, mesmo assim não Te negarei». E todos disseram a mesma coisa."
,"32":"Chegaram a um lugar chamado Getsémani. Então Jesus disse aos discípulos: «Sentai-vos aqui, enquanto Eu vou rezar»."
,"33":"Jesus levou consigo Pedro, Tiago e João, e começou a ficar com medo e angústia."
,"34":"Então disse-lhes: «A minha alma está numa tristeza de morte. Ficai aqui e vigiai»."
,"35":"Jesus foi um pouco mais adiante, prostrou-Se por terra e pedia que, se fosse possível, aquela hora se afastasse d'Ele."
,"36":"Ele rezava: «Abbá! Pai! Tudo é possível para Ti! Afasta de Mim este cálice! Contudo, não se faça o que Eu quero, mas o que Tu queres»."
,"37":"Depois Jesus voltou, encontrou os três discípulos a dormir, e disse a Pedro: «Simão, estás a dormir? Não pudeste vigiar nem sequer uma hora?"
,"38":"Vigiai e rezai, para não cairdes em tentação! Porque o espírito está pronto para resistir, mas a carne é fraca»."
,"39":"Jesus afastou-Se de novo e rezou, repetindo as mesmas palavras."
,"40":"Voltou novamente e encontrou os discípulos a dormir, porque os seus olhos estavam pesados de sono. E eles não sabiam o que dizer a Jesus."
,"41":"Então Jesus voltou pela terceira vez e disse: «Agora podeis dormir e descansar. Basta! Chegou a hora! Eis que o Filho do Homem vai ser entregue nas mãos dos pecadores."
,"42":"Levantai-vos! Vamos! Já se aproxima aquele que Me vai trair»."
,"43":"Enquanto Jesus ainda falava, chegou Judas, um dos Doze, com uma multidão armada de espadas e paus. Vinham da parte dos sumos sacerdotes, dos doutores da Lei e dos anciãos do povo."
,"44":"O traidor tinha combinado com eles um sinal, dizendo: «Jesus é Aquele que eu beijar. Prendei-O e levai-O bem guardado»."
,"45":"Judas aproximou-se imediatamente de Jesus, dizendo: «Mestre!» E beijou-O."
,"46":"Então eles lançaram as mãos sobre Jesus e prenderam-n'O."
,"47":"Mas um dos presentes puxou da espada e feriu o empregado do sumo sacerdote, cortando-lhe a orelha."
,"48":"Jesus disse-lhes: «Saístes com espadas e paus para Me prender, como se Eu fosse um ladrão."
,"49":"Todos os dias Eu estava convosco no Templo, a ensinar, e não me prendestes. Mas isto é para se cumprirem as Escrituras»."
,"50":"Então todos fugiram, abandonando Jesus."
,"51":"Um jovem, vestido só com um lençol, seguia Jesus, e eles prenderamno."
,"52":"Mas o jovem largou o lençol e fugiu nu."
,"53":"Então eles levaram Jesus a casa do sumo sacerdote. Todos os sumos sacerdotes, os anciãos e os doutores da Lei se reuniram."
,"54":"Pedro seguiu Jesus de longe e entrou no pátio da casa do sumo sacerdote. Sentou-se com os guardas, a aquecer-se ao lume."
,"55":"Ora, os sumos sacerdotes e todo o Sinédrio procuravam contra Jesus algum testemunho, a fim de O condenar à morte. E nada encontraram,"
,"56":"porque muitos testemunhavam falsamente contra Jesus mas os seus testemunhos não eram concordes."
,"57":"Alguns levantaram-se e testemunharam falsamente contra Jesus,"
,"58":"dizendo: «Nós ouvimo-l'O dizer: 'Vou destruir este Templo feito por homens, e em três dias construirei um outro, que não será feito pelos homens!'»"
,"59":"Mas nem mesmo assim o seu testemunho concordava."
,"60":"Então o sumo sacerdote levantou-se e, no meio de todos, interrogou Jesus: «Não respondes nada ao que estes testemunham contra Ti?»"
,"61":"Mas Jesus continuou calado e nada respondeu. O sumo sacerdote interrogou-O de novo: «És Tu o Messias, o Filho do Deus Bendito?»"
,"62":"Jesus respondeu: «Sou. E vereis o Filho do Homem sentado à direita do Todo-poderoso, e vir sobre as nuvens do céu»."
,"63":"Então o sumo sacerdote rasgou as próprias vestes e disse: «Que necessidade temos ainda de testemunhas?"
,"64":"Ouvistes a blasfémia! Que vos parece?» Então todos eles decretaram que Jesus era réu de morte."
,"65":"Então alguns começaram a cuspir em Jesus. Cobriram o rosto de Jesus e esbofeteavam-n'O, dizendo: «Faz uma profecia!» E os guardas davam-Lhe bofetadas."
,"66":"Pedro estava em baixo, no pátio. Chegou então uma criada do sumo sacerdote,"
,"67":"e quando viu Pedro a aquecer-se, olhou bem para ele e disse: «Tu também estavas com Jesus Nazareno!»"
,"68":"Mas Pedro negou: «Não sei nem compreendo o que dizes!» E o galo cantou."
,"69":"A criada viu Pedro e começou a dizer novamente aos que estavam perto: «Esse aí é um deles!»"
,"70":"Mas Pedro negou outra vez. Pouco depois, os que ali estavam diziam novamente a Pedro: «É claro que és um deles, pois és da Galileia»."
,"71":"Então Pedro começou a maldizer e a jurar, dizendo: «Nem conheço esse homem de quem falais!»"
,"72":"Nesse instante, o galo cantou pela segunda vez. Pedro lembrou-se de que Jesus lhe havia dito: «Antes de o galo cantar duas vezes, negar-Me-ás três vezes». Então Pedro começou a chorar."
}`)
	CurrentBook.AddChapter(15, `{
"1":"De manhã, os sumos sacerdotes, com os anciãos, os doutores da Lei e todo o Sinédrio, reuniram-se em conselho. Amarraram Jesus, levaram-n'O e entregaram-n'O a Pilatos."
,"2":"Pilatos interrogou Jesus: «Tu és o rei dos judeus?» Jesus respondeu: «Tu o disseste»."
,"3":"E os sumos sacerdotes faziam muitas acusações contra Jesus."
,"4":"Pilatos interrogou-O novamente: «Nada tens a responder? Vê de quantas coisas Te acusam!»"
,"5":"Mas Jesus não respondeu mais nada, e Pilatos ficou impressionado."
,"6":"Na festa da Páscoa, Pilatos costumava soltar-lhes um prisioneiro que eles pedissem."
,"7":"Nesse tempo, um homem chamado Barrabás estava preso com os rebeldes que tinham cometido um assassinato na revolta."
,"8":"A multidão subiu e começou a pedir a Pilatos que fizesse como costumava."
,"9":"Pilatos perguntou: «Quereis que solte o rei dos judeus?»"
,"10":"Pilatos bem sabia que os sumos sacerdotes haviam entregado Jesus por inveja."
,"11":"Porém os sumos sacerdotes atiçaram a multidão para que Pilatos soltasse Barrabás."
,"12":"Pilatos perguntou de novo: «Que farei então com Jesus, a quem chamais rei dos judeus?»"
,"13":"Mas eles gritaram de novo: «Crucifica-O!»"
,"14":"Pilatos perguntou: «Mas que mal fez Ele?» Eles, porém, gritaram com mais força: «Crucifica-O!»"
,"15":"Pilatos queria agradar à multidão. Soltou Barrabás, mandou flagelar Jesus e entregou-O para ser crucificado."
,"16":"Então os soldados levaram Jesus para o pátio, dentro do palácio do governador, e convocaram toda a tropa."
,"17":"Vestiram Jesus com um manto vermelho, teceram uma coroa de espinhos e puseram-Lha na cabeça."
,"18":"Depois começaram a cumprimentá-l'O: «Salve, rei dos judeus!»"
,"19":"E batiam-Lhe na cabeça com uma vara. Cuspiam n'Ele e, dobrando os joelhos, prestavam-Lhe homenagem."
,"20":"Depois de zombarem de Jesus, tiraram-Lhe o manto vermelho, vestiram-n'O de novo com as próprias roupas e levaram-n'O para fora, a fim de O crucificarem."
,"21":"Passava por ali um homem chamado Simão Cireneu, pai de Alexandre e Rufo. Voltava do campo para a cidade. Então os soldados obrigaram-no a levar a cruz de Jesus."
,"22":"Levaram Jesus para o lugar chamado Gólgota, que quer dizer «Lugar da Caveira»."
,"23":"Deram-Lhe vinho misturado com mirra, mas Jesus não quis beber."
,"24":"Crucificaram-n'O e repartiram as suas vestes, fazendo um sorteio, para ver a parte de cada um."
,"25":"Eram nove horas da manhã quando crucificaram Jesus."
,"26":"E havia uma inscrição, com o motivo da condenação: «O Rei dos Judeus»."
,"27":"Com Ele crucificaram dois ladrões, um à direita e outro à esquerda."
,"28":"Deste modo cumpriu-se a Escritura que diz: «Ele foi incluído entre os malfeitores»."
,"29":"As pessoas que passavam por ali insultavam-n'O, meneando a cabeça e dizendo: «Olá! Tu que ias destruir o Templo e construí-lo de novo em três dias,"
,"30":"salva-Te a Ti mesmo! Desce da cruz!»"
,"31":"Do mesmo modo, os sumos sacerdotes, com os doutores da Lei, zombavam d'Ele, dizendo: «Salvou os outros... e não pode salvar-Se a Si mesmo!"
,"32":"O Messias, o rei de Israel... Desça agora da cruz, para que vejamos e acreditemos!» Os que foram crucificados com Jesus também O insultavam."
,"33":"Ao chegar o meio-dia e até às três horas da tarde, houve escuridão sobre toda a Terra."
,"34":"Pelas três horas da tarde, Jesus deu um forte grito: «Eloi, Eloi, lamá sabactâni?», que quer dizer: «Meu Deus, meu Deus, porque Me abandonaste?»"
,"35":"Alguns dos que ali estavam, ao ouvir isto, disseram: «Vede, Ele está a chamar por Elias!»"
,"36":"Alguém correu, encheu de vinagre uma esponja, colocou-a na ponta de uma vara, e deu-Lhe, dizendo: «Deixai, vamos ver se Elias vem tirá-l'O da cruz!»"
,"37":"Então Jesus lançou um forte grito e expirou."
,"38":"Nesse momento, a cortina do santuário rasgou-se de alto a baixo, em duas partes."
,"39":"O oficial do exército, que estava em frente da cruz, viu como Jesus havia expirado e disse: «De facto, este homem era mesmo o Filho de Deus!»"
,"40":"Estavam ali também algumas mulheres, a observar de longe. Entre elas estava Maria Madalena, Maria, mãe de Tiago, o menor, e de José, e Salomé."
,"41":"Elas haviam acompanhado e servido Jesus, desde quando Ele estava na Galileia. Muitas outras mulheres estavam ali, pois tinham ido com Jesus a Jerusalém."
,"42":"Ao entardecer, como era o dia da Preparação, isto é, a véspera do sábado,"
,"43":"chegou José de Arimateia. Ele era membro importante do Sinédrio e também esperava o Reino de Deus. José encheu-se de coragem, foi ter com Pilatos e pediu-lhe o corpo de Jesus."
,"44":"Pilatos ficou admirado que Jesus já tivesse morrido. Chamou o oficial do exército e perguntou se Jesus já estava morto."
,"45":"Depois de informado pelo oficial, Pilatos mandou entregar o cadáver a José."
,"46":"José comprou um lençol de linho, desceu o corpo da cruz e envolveu-o no lençol. Em seguida, colocou Jesus num túmulo, que tinha sido cavado na rocha, e rolou uma pedra para fechar a entrada do túmulo."
,"47":"Maria Madalena e Maria, mãe de José, observaram onde Jesus tinha sido colocado."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Quando o sábado passou, Maria Madalena, Maria mãe de Tiago, e Salomé, compraram perfumes para ungir o corpo de Jesus."
,"2":"E bem cedo, no primeiro dia da semana, ao nascer do sol, foram ao túmulo."
,"3":"E diziam entre si: «Quem nos vai tirar a pedra da entrada do túmulo?»"
,"4":"Era uma pedra muito grande. Mas, quando olharam, viram que a pedra já havia sido tirada."
,"5":"Então entraram no túmulo e viram um jovem, sentado do lado direito, vestido de branco. E ficaram muito assustadas."
,"6":"Mas o jovem disse-lhes: «Não vos assusteis. Procurais Jesus de Nazaré, que foi crucificado? Ele ressuscitou! Não está aqui! Vede o lugar onde O puseram."
,"7":"Agora deveis ir e dizer aos seus discípulos e a Pedro que Ele vai à vossa frente para a Galileia. Lá O vereis, como Ele mesmo disse»."
,"8":"Então as mulheres saíram do túmulo a correr, porque estavam com medo e assustadas. E não disseram nada a ninguém, porque tinham medo."
,"9":"Depois de ressuscitar na madrugada do primeiro dia após o sábado, Jesus apareceu primeiro a Maria Madalena, da qual havia expulsado sete demónios."
,"10":"Ela foi anunciar isto aos seguidores de Jesus, que estavam de luto e chorosos."
,"11":"Quando ouviram que Ele estava vivo e fora visto por ela, não quiseram acreditar."
,"12":"Em seguida, Jesus apareceu a dois deles, com outra aparência, enquanto estavam a caminho do campo."
,"13":"Eles também voltaram e anunciaram isto aos outros, que também não acreditaram neles."
,"14":"Por fim, Jesus apareceu aos onze discípulos enquanto estavam a comer. Jesus repreendeu-os por causa da falta de fé e pela dureza de coração, porque não tinham acreditado naqueles que O tinham visto ressuscitado."
,"15":"Então Jesus disse-lhes: «Ide pelo mundo inteiro e anunciai a Boa Notícia a toda a humanidade."
,"16":"Quem acreditar e for baptizado, será salvo. Quem não acreditar, será condenado."
,"17":"Os sinais que acompanharão aqueles que acreditarem são estes: expulsarão demónios em meu nome, falarão novas línguas;"
,"18":"se pegarem em cobras ou beberem algum veneno, não sofrerão nenhum mal; quando colocarem as mãos sobre os doentes, estes ficarão curados»."
,"19":"Depois de falar com os discípulos, o Senhor Jesus foi arrebatado ao céu e sentou-Se à direita de Deus."
,"20":"Os discípulos então saíram e pregaram por toda a parte. O Senhor ajudava-os e, por meio dos sinais que os acompanhavam, provava que o seu ensinamento era verdadeiro."
}`)

}
func PT_BS_LoadNEMTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Livro da origem de Jesus Cristo, filho de David, filho de Abraão."
,"2":"Abraão foi o pai de Isaac; Isaac foi o pai de Jacob;"
,"3":"Jacob foi o pai de Judá e de seus irmãos. Judá, com Tamar, foi o pai de Farés e Zara; Farés foi o pai de Esrom; Esrom foi o pai de Aram."
,"4":"Aram foi o pai de Aminadab; Aminadab foi o pai de Naasson; Naasson foi o pai de Salmon."
,"5":"Salmon, com Raab, foi o pai de Booz; Booz, com Rute, foi o pai de Jobed; Jobed foi o pai de Jessé;"
,"6":"Jessé foi o pai de David. David, com aquela que foi mulher de Urias, foi o pai de Salomão. "
,"7":"Salomão foi o pai de Roboão; Roboão foi o pai de Abias; Abias foi o pai de Asa."
,"8":"Asa foi o pai de Josafá; Josafá foi o pai de Jorão; Jorão foi o pai de Ozias."
,"9":"Ozias foi o pai de Joatão; Joatão foi o pai de Acaz; Acaz foi o pai de Ezequias."
,"10":"Ezequias foi o pai de Manassés; Manassés foi o pai de Amon; Amon foi o pai de Josias."
,"11":"Josias foi o pai de Jeconias e de seus irmãos, no tempo do exílio na Babilónia."
,"12":"Depois do exílio na Babilónia, Jeconias foi o pai de Salatiel; Salatiel foi o pai de Zorobabel."
,"13":"Zorobabel foi o pai de Abiud; Abiud foi o pai de Eliaquim; Eliaquim foi o pai de Azor."
,"14":"Azor foi o pai de Sadoc; Sadoc foi o pai de Aquim; Aquim foi o pai de Eliud."
,"15":"Eliud foi o pai de Eleazar; Eleazar foi o pai de Matã; Matã foi o pai de Jacob."
,"16":"Jacob foi o pai de José, o esposo de Maria, da qual nasceu Jesus, que é chamado o Messias."
,"17":"Assim, as gerações desde Abraão até David são catorze; de David até ao exílio na Babilónia, catorze gerações; e do exílio na Babilónia até ao Messias, catorze gerações."
,"18":"A origem de Jesus, o Messias, foi assim: Maria, sua Mãe, estava prometida em casamento a José, e, antes de viverem juntos, Ela ficou grávida pela acção do Espírito Santo."
,"19":"José, seu marido, era justo. Não queria denunciar Maria e pensava em deixá-l'A, sem ninguém saber."
,"20":"Enquanto José pensava nisso, o Anjo do Senhor apareceu-lhe em sonho e disse: «José, filho de David, não tenhas medo de receber Maria como esposa, porque Ela concebeu pela acção do Espírito Santo."
,"21":"Ela dará à luz um Filho, ao qual darás o nome de Jesus, pois Ele vai salvar o seu povo dos seus pecados»."
,"22":"Tudo isto aconteceu para se cumprir o que o Senhor havia dito pelo profeta:"
,"23":"«Vede: a Virgem conceberá e dará à luz um Filho. Ele será chamado Emanuel, que quer dizer: Deus está connosco»."
,"24":"Quando acordou, José fez conforme o Anjo do Senhor havia mandado: levou Maria para casa,"
,"25":"e, sem ter relações com Ela, Maria deu à luz um Filho. E José deu-Lhe o nome de Jesus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tendo nascido Jesus na cidade de Belém, na Judeia, no tempo do rei Herodes, alguns magos do Oriente chegaram a Jerusalém"
,"2":"e perguntaram: «Onde está o Rei dos judeus recém-nascido? Nós vimos a sua estrela no Oriente e viemos para Lhe prestar homenagem»."
,"3":"Ao saber disso, o rei Herodes ficou alarmado, assim como toda a cidade de Jerusalém."
,"4":"Herodes reuniu todos os sumos sacerdotes e os doutores da Lei e perguntou-lhes onde o Messias deveria nascer."
,"5":"Eles responderam: «Em Belém, na Judeia, porque assim está escrito por meio do profeta:"
,"6":"'E tu, Belém, terra de Judá, não és de modo nenhum a menor entre as principais cidades de Judá, porque de ti sairá um Chefe, que vai apascentar Israel, meu povo'»."
,"7":"Então Herodes chamou secretamente os magos, e investigou junto deles sobre o tempo exacto em que a estrela havia aparecido."
,"8":"Depois, mandou-os a Belém, dizendo: «Ide e procurai obter informações exactas sobre o Menino. E avisai-me quando O encontrardes, para que também eu vá prestar-Lhe homenagem»."
,"9":"Depois de terem ouvido o rei, partiram. E a estrela, que tinham visto no Oriente, ia adiante deles, até que parou sobre o lugar onde estava o Menino."
,"10":"Ao verem de novo a estrela, os magos ficaram radiantes de alegria."
,"11":"Quando entraram na casa, viram o Menino com Maria, sua Mãe. Ajoelharam-se diante d'Ele e prestaram-Lhe homenagem. Depois, abriram os seus cofres e ofereceram presentes ao Menino: ouro, incenso e mirra."
,"12":"Avisados em sonho para não voltarem a Herodes, regressaram à sua terra, seguindo por outro caminho."
,"13":"Depois que os magos partiram, o Anjo do Senhor apareceu em sonho a José e disse-lhe: «Levanta-te, toma o Menino e sua Mãe e foge para o Egipto! Fica lá até que te avise. Porque Herodes vai procurar o Menino para O matar»."
,"14":"José levantou-se de noite, tomou o Menino e sua Mãe e partiu para o Egipto."
,"15":"Lá ficou até à morte de Herodes, para se cumprir o que o Senhor havia dito por meio do profeta: «Do Egipto chamei o meu Filho»."
,"16":"Quando Herodes percebeu que os magos o haviam enganado, ficou furioso. Mandou matar todos os meninos de Belém e de todo o território ao redor, de dois anos para baixo, calculando a idade pelo que tinha averiguado dos magos."
,"17":"Então cumpriu-se o que fora dito pelo profeta Jeremias:"
,"18":"«Ouviu-se um grito em Ramá, choro e grande lamento: é Raquel que chora os seus filhos, e não quer ser consolada, porque eles já não existem»."
,"19":"Quando Herodes morreu, o Anjo do Senhor apareceu em sonho a José, no Egipto,"
,"20":"e disse-lhe: «Levanta-te, toma o Menino e sua Mãe e volta para a terra de Israel, pois já estão mortos aqueles que procuravam matar o Menino»."
,"21":"José levantou-se, pegou no Menino e na sua Mãe e voltou para a terra de Israel."
,"22":"Mas, quando soube que Arquelau reinava na Judeia, como sucessor de Herodes, seu pai, teve medo de ir para lá. Por isso, depois de receber aviso em sonho, José partiu para a região da Galileia"
,"23":"e foi morar numa cidade chamada Nazaré. Isso aconteceu para se cumprir o que foi dito pelos profetas: «Ele será chamado Nazareno»."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Naqueles dias, apareceu João Baptista, a pregar no deserto da Judeia:"
,"2":"«Convertei-vos, porque o Reino do Céu está próximo»."
,"3":"João foi anunciado pelo profeta Isaías, que disse: «Esta é a voz daquele que grita no deserto: Preparai o caminho do Senhor, endireitai as suas estradas!»"
,"4":"João usava roupa feita de pêlos de camelo e cinto de couro na cintura; comia gafanhotos e mel silvestre."
,"5":"Os moradores de Jerusalém, de toda a Judeia e de todos os lugares em volta do rio Jordão, iam ao encontro de João."
,"6":"Confessavam os próprios pecados, e João baptizava-os no rio Jordão."
,"7":"Quando viu muitos fariseus e saduceus que vinham para o baptismo, João disse-lhes: «Raça de cobras venenosas, quem vos ensinou a fugir da ira que vai chegar?"
,"8":"Fazei coisas que provem que vos convertestes."
,"9":"Não penseis que basta dizer: 'Abraão é nosso pai'. Porque eu digo-vos: até destas pedras Deus pode fazer nascer filhos de Abraão."
,"10":"O machado já está posto à raiz das árvores. E toda a árvore que não der bom fruto será cortada e lançada no fogo."
,"11":"Eu baptizo-vos com água para a conversão. Mas Aquele que vem depois de mim é mais forte do que eu. E eu não sou digno nem de Lhe descalçar as sandálias. Ele é quem vos baptizará com o Espírito Santo e com fogo."
,"12":"Ele terá na mão uma pá: vai limpar a sua eira e recolher o seu trigo no celeiro; mas a palha Ele vai queimá-la no fogo que não se apaga»."
,"13":"Jesus foi da Galileia para o rio Jordão, a fim de Se encontrar com João e ser baptizado por ele."
,"14":"Mas João procurava impedi-l'O, dizendo: «Sou eu que devo ser baptizado por Ti, e Tu vens a mim?»"
,"15":"Jesus, porém, respondeu-lhe: «Por enquanto deixa como está! Porque devemos cumprir toda a justiça». E João concordou."
,"16":"Depois de ser baptizado, Jesus saiu logo da água. Então, o Céu abriu-se, e Jesus viu o Espírito de Deus descer como pomba e poisar sobre Ele."
,"17":"E do Céu veio uma voz, que dizia: «Este é o meu Filho amado, que muito Me agrada»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Então o Espírito conduziu Jesus ao deserto, para ser tentado pelo demónio."
,"2":"Jesus jejuou durante quarenta dias e quarenta noites, e, depois disso, sentiu fome."
,"3":"Então, o tentador aproximou-se e disse a Jesus: «Se Tu és Filho de Deus, manda que estas pedras se tornem pães!»"
,"4":"Mas Jesus respondeu: «A Escritura diz: 'Não só de pão vive o homem, mas de toda a palavra que sai da boca de Deus'»."
,"5":"Então o demónio levou-o à Cidade Santa e colocou-O na parte mais alta do Templo."
,"6":"E disse-Lhe: «Se és Filho de Deus, lança-Te daqui abaixo! Porque a Escritura diz: 'Deus ordenará aos seus anjos a teu respeito, e eles te levarão nas mãos, para que não tropeces em nenhuma pedra'»."
,"7":"Jesus respondeu-lhe: «A Escritura também diz: 'Não tentarás o Senhor teu Deus'»."
,"8":"O demónio tornou a levar Jesus, agora para um monte muito alto. Mostrou-Lhe todos os reinos do mundo e as suas riquezas."
,"9":"E disse-Lhe: «Dar-Te-ei tudo isto, se te ajoelhares diante de mim, para me adorar»."
,"10":"Jesus disse-lhe: «Vai-te, Satanás, porque a Escritura diz: 'Adorarás ao Senhor teu Deus e somente a Ele servirás'»."
,"11":"Então o demónio deixou-O. E os anjos de Deus aproximaram-se e serviram Jesus."
,"12":"Ao saber que João tinha sido preso, Jesus voltou para a Galileia."
,"13":"Deixou Nazaré e foi morar em Cafarnaum, que fica nas margens do mar da Galileia, nos confins de Zabulão e Neftali,"
,"14":"para se cumprir o que foi dito pelo profeta Isaías:"
,"15":"«Terra de Zabulão, terra de Neftali, caminho do mar, região do outro lado do rio Jordão, Galileia dos que não são judeus!"
,"16":"O povo que vivia nas trevas viu uma grande luz; e uma luz brilhou para os que viviam na região escura da morte»."
,"17":"Daí em diante, Jesus começou a pregar, dizendo: «Convertei-vos, porque o Reino do Céu está próximo»."
,"18":"Jesus andava à beira do mar da Galileia, quando viu dois irmãos: Simão, também chamado Pedro, e seu irmão André. Estavam a lançar a rede ao mar, pois eram pescadores."
,"19":"Jesus disse-lhes: «Segui-Me, e farei de vós pescadores de homens»."
,"20":"Eles deixaram imediatamente as redes e seguiram a Jesus."
,"21":"Indo mais adiante, Jesus viu outros dois irmãos: Tiago e João, filhos de Zebedeu. Estavam na barca com seu pai Zebedeu, a consertar as redes. E Jesus chamou-os."
,"22":"Eles deixaram imediatamente a barca e o pai e seguiram a Jesus."
,"23":"Jesus andava por toda a Galileia, ensinando nas suas sinagogas, pregando a Boa Notícia do Reino, e curando toda a espécie de doença e enfermidade do povo."
,"24":"E a fama de Jesus espalhou-se por toda a Síria. Levaram-Lhe todos os doentes atingidos por diversos males e tormentos: endemoninhados, epilépticos e paralíticos. E Jesus curou-os."
,"25":"Numerosas multidões da Galileia, da Decápole, de Jerusalém, da Judeia e do outro lado do rio Jordão começaram a seguir Jesus."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Jesus viu as multidões, subiu à montanha e sentou-Se. Os discípulos aproximaram-se"
,"2":"e Jesus começou a ensiná-los:"
,"3":"«Felizes os pobres em espírito, porque deles é o Reino do Céu."
,"4":"Felizes os aflitos, porque serão consolados."
,"5":"Felizes os mansos, porque possuirão a Terra."
,"6":"Felizes os que têm fome e sede de justiça, porque serão saciados."
,"7":"Felizes os que são misericordiosos, porque encontrarão misericórdia."
,"8":"Felizes os puros de coração, porque verão a Deus."
,"9":"Felizes os que promovem a paz, porque serão chamados filhos de Deus."
,"10":"Felizes os que são perseguidos por causa da justiça, porque deles é o Reino do Céu."
,"11":"Felizes de vós, se fordes insultados e perseguidos, e se disserem toda a espécie de calúnia contra vós por causa de Mim."
,"12":"Ficai alegres e contentes, porque será grande para vós a recompensa no Céu. Do mesmo modo perseguiram os profetas que vieram antes de vós»."
,"13":"«Vós sois o sal da terra. Ora, se o sal perde o sabor, com que poderemos salgá-lo? Não serve para mais nada; só serve para ser lançado fora e ser pisado pelos homens."
,"14":"Vós sois a luz do mundo. Não pode ficar escondida uma cidade construída sobre um monte."
,"15":"Ninguém acende uma lâmpada para a colocar debaixo de uma vasilha, mas sim para a colocar no candeeiro, onde ela brilha para todos os que estão em casa."
,"16":"Assim também: que a vossa luz brilhe diante dos homens, para que eles vejam as boas obras que fazeis e louvem o vosso Pai que está nos céus»."
,"17":"«Não penseis que Eu vim abolir a Lei e os Profetas. Não vim abolir, mas dar-lhes pleno cumprimento."
,"18":"Eu vos garanto: antes que o Céu e a Terra deixem de existir, nem sequer uma letra ou vírgula serão tiradas da Lei, sem que tudo aconteça."
,"19":"Portanto, quem desobedecer a um só destes mandamentos, por menor que seja, e ensinar os outros a fazer o mesmo, será considerado o menor no Reino do Céu. Por outro lado, quem os praticar e ensinar, será considerado grande no Reino do Céu."
,"20":"Com efeito, Eu vos garanto: se a vossa justiça não superar a dos doutores da Lei e dos fariseus, não entrareis no Reino do Céu»."
,"21":"«Ouvistes o que foi dito aos antigos: 'Não matarás! Quem matar será condenado pelo tribunal'."
,"22":"Eu, porém, digo-vos: todo aquele que fica com raiva do seu irmão, torna-se réu perante o tribunal. Quem diz ao seu irmão: 'imbecil', torna-se réu perante o Sinédrio; quem chama ao irmão 'idiota', merece o fogo do inferno."
,"23":"Portanto, se fores até ao altar para levares a tua oferta, e aí te lembrares de que o teu irmão tem alguma coisa contra ti,"
,"24":"deixa a oferta aí diante do altar e vai primeiro fazer as pazes com o teu irmão; depois, volta para apresentar a oferta."
,"25":"Se alguém fez alguma acusação contra ti, procura logo entrar em acordo com ele, enquanto estais a caminho do tribunal; senão o acusador entregar-te-á ao juiz, o juiz entregar-te-á ao guarda, e irás para a prisão."
,"26":"Eu te garanto: daí não sairás, enquanto não pagares até ao último centavo'»."
,"27":"«Ouvistes o que foi dito: 'Não cometerás adultério'."
,"28":"Eu, porém, digo-vos: todo aquele que olha para uma mulher e deseja possuí-la, já cometeu adultério com ela no coração."
,"29":"Se o olho direito te leva a pecar, arranca-o e lança-o fora! É melhor perder um membro do que o teu corpo todo ser lançado no inferno."
,"30":"Se a mão direita te leva a pecar, corta-a e lança-a fora! É melhor perder um membro do que o teu corpo ir para o inferno."
,"31":"Também foi dito: 'Quem se divorciar de sua mulher, dê-lhe uma certidão de divórcio'."
,"32":"Eu, porém, digo-vos: todo aquele que se divorcia de sua mulher, a não ser por causa de fornicação, faz com que ela se torne adúltera; e quem se casa com a mulher divorciada comete adultério»."
,"33":"«Ouvistes também o que foi dito aos antigos: 'Não jurarás falso', mas 'cumprirás os teus juramentos para com o Senhor'."
,"34":"Eu, porém, digo-vos: não jureis de modo algum: nem pelo Céu, porque é o trono de Deus;"
,"35":"nem pela Terra, porque é o suporte onde Ele apoia os pés; nem por Jerusalém, porque é a cidade do grande Rei."
,"36":"Não jures nem mesmo pela tua própria cabeça, porque não podes fazer com que um só dos teus cabelos fique branco ou preto."
,"37":"Diz apenas 'sim', quando é 'sim'; e 'não', quando é 'não'. O que disseres para além disto vem do Maligno»."
,"38":"«Ouvistes o que foi dito: 'Olho por olho e dente por dente!'"
,"39":"Eu, porém, digo-vos: não vos vingueis de quem vos fez mal. Pelo contrário: se alguém te bater na face direita, oferece-lhe também a esquerda!"
,"40":"Se alguém faz um processo para te tirar a túnica, dá-lhe também a capa!"
,"41":"Se alguém te obriga a andar um quilómetro, caminha dois quilómetros com ele!"
,"42":"Dá a quem te pedir e não vires as costas a quem te pedir emprestado»."
,"43":"«Ouvistes o que foi dito: 'Amarás o teu próximo e odiarás o teu inimigo!'"
,"44":"Eu, porém, digo-vos: amai os vossos inimigos e rezai por aqueles que vos perseguem!"
,"45":"Assim tornar-vos-eis filhos do Pai que está no Céu, porque Ele faz nascer o sol sobre maus e bons e cair a chuva sobre justos e injustos."
,"46":"Pois, se amais somente aqueles que vos amam, que recompensa tereis? Os cobradores de impostos não fazem a mesma coisa?"
,"47":"E se cumprimentais somente os vossos irmãos, o que é que fazeis de extraordinário? Os pagãos não fazem a mesma coisa?"
,"48":"Portanto, sede perfeitos como é perfeito o vosso Pai que está no Céu»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"«Prestai atenção! Não pratiqueis a vossa justiça diante dos homens só para serdes elogiados por eles. Fazendo assim, não tereis a recompensa do vosso Pai que está no Céu»."
,"2":"«Por isso, quando deres esmola, não mandes tocar trombeta à tua frente, como fazem os hipócritas nas sinagogas e nas ruas, para serem elogiados pelos homens. Eu vos garanto: já receberam a recompensa."
,"3":"Ao contrário, quando deres esmola, que a tua esquerda não saiba o que fez a tua direita,"
,"4":"para que a tua esmola fique escondida; e teu Pai, que vê o escondido, recompensar-te-á»."
,"5":"«Quando rezardes, não sejais como os hipócritas, que gostam de rezar de pé nas sinagogas e nas esquinas para serem vistos pelos homens. Eu vos garanto: eles já receberam a recompensa."
,"6":"Ao contrário, quando rezares, entra no teu quarto, fecha a porta e reza ao teu Pai ocultamente; e teu Pai, que vê o escondido, recompensar-te-á»."
,"7":"«Quando rezardes, não useis muitas palavras, como fazem os pagãos. Eles pensam que serão ouvidos por causa do seu palavreado."
,"8":"Não sejais como eles, pois o vosso Pai sabe do que precisais antes de vós Lho pedirdes."
,"9":"Deveis rezar assim: Pai nosso, que estais nos céus, santificado seja o vosso nome;"
,"10":"venha a nós o vosso reino; seja feita a vossa vontade, assim na Terra como no Céu."
,"11":"O pão nosso de cada dia nos dai hoje."
,"12":"Perdoai-nos as nossas dívidas, assim como nós perdoamos aos nossos devedores."
,"13":"E não nos deixeis cair em tentação, mas livrai-nos do mal."
,"14":"De facto, se perdoardes aos homens os males que eles fizeram, o vosso Pai que está no Céu também vos perdoará."
,"15":"Mas, se não perdoardes aos homens, o vosso Pai também não perdoará os males que tiverdes feito»."
,"16":"«Quando jejuardes, não fiqueis de cara triste, como os hipócritas. Eles desfiguram o rosto para que os homens vejam que jejuam. Eu vos garanto: já receberam a recompensa."
,"17":"Quando jejuares, perfuma a cabeça e lava o rosto,"
,"18":"para que os homens não vejam que jejuas, mas somente teu Pai, que está no escondido; e teu Pai, que vê no escondido, recompensar-te-á»."
,"19":"«Não acumuleis riquezas aqui na Terra, onde a traça e a ferrugem corroem, e onde os ladrões assaltam e roubam."
,"20":"Acumulai riquezas no Céu, onde nem a traça nem a ferrugem corroem, e onde os ladrões não assaltam nem roubam."
,"21":"De facto, onde está o teu tesouro, aí estará também o teu coração."
,"22":"A lâmpada do corpo é o olho. Se o olho é são, o corpo inteiro fica iluminado."
,"23":"Se o olho está doente, o corpo inteiro fica na escuridão. Assim, se a luz que existe em ti é escuridão, como será grande a escuridão!"
,"24":"Ninguém pode servir a dois senhores. Porque, ou odiará a um e amará o outro, ou será fiel a um e desprezará o outro. Não podeis servir a Deus e às riquezas»."
,"25":"«Por isso é que Eu vos digo: não fiqueis preocupados com a vida, com o que comer; nem com o corpo, com o que vestir. Afinal, a vida não vale mais do que o alimento? E o corpo não vale mais do que o vestuário?"
,"26":"Olhai os pássaros do céu: eles não semeiam, não colhem, nem juntam em armazéns. No entanto, o Pai que está no céu alimenta-os. Será que não valeis mais do que os pássaros?"
,"27":"Quem de vós pode crescer um só centímetro, à custa de se preocupar com isso?"
,"28":"E porque vos preocupais com o vestuário? Olhai como crescem os lírios do campo: eles não trabalham nem fiam."
,"29":"Porém, Eu digo-vos: nem o rei Salomão, em toda a sua glória, jamais se vestiu como um deles."
,"30":"Ora, se Deus assim veste a erva do campo, que hoje existe e amanhã é queimada no fogo, muito mais Ele fará por vós, gente de pouca fé!"
,"31":"Portanto, não fiqueis preocupados, dizendo: Que vamos comer? Que vamos beber? Que vamos vestir?"
,"32":"Os pagãos é que procuram essas coisas. O vosso Pai, que está no Céu, sabe que precisais de tudo isso."
,"33":"Pelo contrário, em primeiro lugar buscai o Reino de Deus e a sua justiça, e Deus vos dará, em acréscimo, todas essas coisas."
,"34":"Portanto, não vos preocupeis com o dia de amanhã, pois o dia de amanhã terá as suas preocupações. Basta a cada dia a própria dificuldade»."
}`)
	CurrentBook.AddChapter(7, `{
"1":"«Não julgueis, e não sereis julgados."
,"2":"De facto, sereis julgados com o mesmo julgamento com que julgardes e sereis medidos com a mesma medida com que medirdes."
,"3":"Porque olhas para o argueiro no olho do teu irmão e não prestas atenção à trave que está no teu próprio olho?"
,"4":"Ou, como te atreves a dizer ao irmão: 'Deixa-me tirar o argueiro do teu olho', quando tu mesmo tens uma trave no teu?"
,"5":"Hipócrita, tira primeiro a trave do teu próprio olho, e então verás bem para tirar o argueiro do olho do teu irmão»."
,"6":"«Não deis aos cães o que é santo, nem atireis pérolas aos porcos; eles poderiam pisá-las com os pés e, virando-se, despedaçar-vos»."
,"7":"«Pedi e ser-vos-á dado! Procurai e encontrareis! Batei e abrir-vos-ão a porta!"
,"8":"Pois todo aquele que pede, recebe; quem procura, acha; e a quem bate, a porta será aberta."
,"9":"Quem de vós dá ao filho uma pedra, quando ele pede um pão?"
,"10":"Ou lhe dá uma cobra, quando ele pede um peixe?"
,"11":"Se vós, que sois maus, sabeis dar coisas boas aos vossos filhos, quanto mais o vosso Pai que está no Céu dará coisas boas aos que Lhas pedirem!»."
,"12":"«Tudo o que desejais que os outros vos façam, fazei-o também a eles. Pois nisso consistem a Lei e os Profetas»."
,"13":"«Entrai pela porta estreita, porque é larga a porta e espaçoso o caminho que leva à perdição, e são muitos os que entram por ela!"
,"14":"Como é estreita a porta e apertado o caminho que leva à vida, e são poucos os que o encontram!»."
,"15":"«Cuidado com os falsos profetas: apresentam-se vestidos com peles de ovelha, mas por dentro são lobos ferozes."
,"16":"Conhecê-los-eis pelos seus frutos. Acaso colhem-se uvas de espinheiros ou figos de urtigas?"
,"17":"Assim, toda a árvore boa produz bons frutos, e toda a árvore má produz maus frutos."
,"18":"Uma árvore boa não pode dar frutos maus, e uma árvore má não pode dar bons frutos."
,"19":"Toda a árvore que não der bons frutos será cortada e lançada ao fogo."
,"20":"Pelos frutos é que os conhecereis»."
,"21":"«Nem todo aquele que Me diz 'Senhor, Senhor', entrará no Reino do Céu. Só entrará aquele que põe em prática a vontade do meu Pai que está no céu."
,"22":"Naquele dia muitos Me dirão: 'Senhor, Senhor, não foi em teu nome que profetizámos? Não foi em teu nome que expulsámos demónios? E não foi em teu nome que fizemos tantos milagres?'"
,"23":"Então, dir-lhes-ei: Nunca vos conheci. Afastai-vos de Mim, malfeitores!»."
,"24":"«Portanto, quem ouve estas minhas palavras e as põe em prática é como o homem prudente que construiu a sua casa sobre a rocha."
,"25":"Caiu a chuva, vieram as enxurradas, os ventos sopraram com força contra a casa, mas a casa não caiu, porque fora construída sobre a rocha."
,"26":"Por outro lado, quem ouve estas minhas palavras e não as põe em prática é como o homem sem juízo, que construiu a sua casa sobre a areia."
,"27":"Caiu a chuva, vieram as enxurradas, os ventos sopraram com força contra a casa, e a casa caiu, e a sua ruína foi completa!»."
,"28":"Quando Jesus acabou de dizer estas palavras, as multidões ficaram admiradas com o seu ensinamento,"
,"29":"porque Jesus ensinava como alguém que tem autoridade e não como os doutores da Lei."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quando Jesus desceu da montanha, grandes multidões começaram a segui-l'O."
,"2":"Eis que um leproso se aproximou e se ajoelhou diante de Jesus, dizendo: «Senhor, se quiseres, tens poder para me purificar»."
,"3":"Jesus estendeu a mão, tocou nele e disse: «Quero, fica purificado». No mesmo instante o homem ficou purificado da lepra."
,"4":"Então Jesus disse-lhe: «Não contes isto a ninguém! Vai pedir ao sacerdote para te examinar, e depois faz a oferta que Moisés mandou, a fim de que seja um testemunho para eles»."
,"5":"Jesus estava a entrar em Cafarnaum, quando um oficial romano se aproximou d'Ele, suplicando:"
,"6":"«Senhor, o meu empregado está em casa, de cama, sofrendo muito com uma paralisia»."
,"7":"Jesus respondeu: «Eu vou curá-lo»."
,"8":"O oficial disse: «Senhor, eu não sou digno de que entres em minha casa. Diz uma só palavra e o meu empregado ficará curado."
,"9":"Pois eu também recebo ordens e tenho soldados às minhas ordens. E digo a um: vai, e ele vai; e a outro: vem, e ele vem; e digo ao meu empregado: faz isto, e ele faz»."
,"10":"Quando ouviu isto, Jesus ficou admirado e disse aos que O seguiam: «Eu vos garanto: nunca encontrei uma fé igual a esta em ninguém de Israel!"
,"11":"Eu digo-vos: muitos virão do Oriente e do Ocidente e sentar-se-ão à mesa no Reino do Céu juntamente com Abraão, Isaac e Jacob,"
,"12":"enquanto os herdeiros do Reino serão lançados nas trevas exteriores onde haverá choro e ranger de dentes»."
,"13":"Então Jesus disse ao oficial: «Vai, e seja feito conforme acreditaste». E nessa mesma hora o empregado do oficial ficou curado."
,"14":"Jesus entrou na casa de Pedro e viu a sogra de Pedro deitada, com febre."
,"15":"Então Jesus tocou-lhe na mão e a febre deixou-a. Ela levantou-se e começou a servi-los."
,"16":"À tarde, levaram a Jesus muitas pessoas que estavam possuídas pelo demónio. Jesus, com a sua palavra, expulsou os espíritos e curou todos os doentes,"
,"17":"para que se cumprisse o que fora dito pelo profeta Isaías: «Ele tomou as nossas enfermidades e carregou as nossas doenças»."
,"18":"Vendo grandes multidões ao seu redor, Jesus mandou passar para a outra margem."
,"19":"Então um doutor da Lei aproximou-se e disse: «Mestre, seguir-Te-ei para onde quer que fores»."
,"20":"Mas Jesus respondeu-lhe: «As raposas têm tocas e as aves do céu têm ninhos; mas o Filho do Homem não tem onde repousar a cabeça»."
,"21":"Outro, que era discípulo, disse a Jesus: «Senhor, deixa primeiro que eu vá sepultar meu pai»."
,"22":"Mas Jesus respondeu-lhe: «Segue-Me, e deixa que os mortos sepultem os seus próprios mortos»."
,"23":"Então Jesus entrou na barca e os discípulos acompanharam-n'O."
,"24":"E eis que houve grande agitação no mar, de modo que a barca estava sendo coberta pelas ondas. Jesus, porém, dormia."
,"25":"Os discípulos aproximaram-se e acordaram-n'O, dizendo: «Senhor, salva-nos, porque estamos a afundar-nos!»"
,"26":"Jesus respondeu: «Porque tendes medo, homens de pouca fé?» E, levantando-Se, ameaçou os ventos e o mar, e tudo ficou calmo."
,"27":"Os homens ficaram admirados e disseram: «Quem é este Homem, a quem até o vento e o mar obedecem?»."
,"28":"Quando Jesus chegou à outra margem, à terra dos gadarenos, foram ao encontro d'Ele dois homens possuídos pelo demónio. Saíam do meio dos túmulos e eram tão ferozes que ninguém podia passar por aquele caminho."
,"29":"Então eles gritaram: «Que é que há entre nós, Filho de Deus? Vieste aqui para nos atormentar antes do tempo?»."
,"30":"Ao longe, andava a pastar uma grande vara de porcos."
,"31":"Os demónios suplicavam: «Se nos expulsas, manda-nos para a vara de porcos»."
,"32":"Jesus disse: «Podeis ir». Os demónios saíram, e foram para os porcos; e eis que toda a vara de porcos se atirou pelo monte abaixo para dentro do mar e morreu afogada."
,"33":"Os homens que guardavam os porcos fugiram, foram à cidade e contaram tudo, inclusive o caso dos possuídos pelo demónio."
,"34":"Então toda a cidade saiu ao encontro de Jesus. Vendo-O, começaram a suplicar a Jesus que Se retirasse daquela região."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Jesus subiu para uma barca, passou para a outra margem e chegou à sua cidade."
,"2":"Nisto, levaram-Lhe um paralítico deitado numa cama. Vendo a fé que eles tinham, Jesus disse ao paralítico: «Coragem, filho! Os teus pecados estão perdoados»."
,"3":"Então alguns doutores da Lei pensaram: «Este homem blasfema!»"
,"4":"Mas Jesus, conhecendo os seus pensamentos, disse: «Porque é que pensais coisas más?"
,"5":"O que é mais fácil dizer: 'Os teus pecados estão perdoados'; ou dizer: 'Levanta-te e anda'?"
,"6":"Pois bem, para que saibais que o Filho do Homem tem poder na terra para perdoar pecados - disse Jesus ao paralítico: - Levanta-te, pega na tua cama e vai para tua casa»."
,"7":"O paralítico levantou-se e foi para casa."
,"8":"Vendo isto, a multidão ficou com medo e louvou a Deus, por ter dado tal poder aos homens."
,"9":"Saindo dali, Jesus viu um homem chamado Mateus, sentado na cobrança de impostos, e disse-lhe: «Segue-Me!» Ele levantou-se e seguiu Jesus."
,"10":"Estando Jesus à mesa em casa de Mateus, muitos cobradores de impostos e pecadores foram e sentaram-se à mesa com Jesus e os seus discípulos."
,"11":"Alguns fariseus viram isto e perguntaram aos discípulos: «Porque é que o vosso Mestre come com os cobradores de impostos e os pecadores?»"
,"12":"Jesus ouviu a pergunta e respondeu: «As pessoas que têm saúde não precisam de médico, mas só as que estão doentes."
,"13":"Aprendei, pois, o que significa: 'Eu quero a misericórdia e não o sacrifício'. Porque Eu não vim para chamar os justos, mas os pecadores»."
,"14":"Então os discípulos de João aproximaram-se de Jesus e perguntaram: «Nós e os fariseus fazemos jejum. Porque é que os teus discípulos não jejuam?»"
,"15":"Jesus respondeu: «Achais que os convidados de um casamento podem estar de luto enquanto o noivo está com eles? Mas chegarão dias em que o noivo será tirado do meio deles. Então hão-de jejuar."
,"16":"Ninguém põe um remendo de pano novo em roupa velha, porque o remendo repuxa o pano e o rasgão fica maior ainda."
,"17":"Também não se deita vinho novo em barris velhos, senão os barris rebentam, o vinho derrama-se e os barris estragam-se. Mas deita-se o vinho novo em barris novos e assim ambos se conservam»."
,"18":"Enquanto Jesus lhes dizia estas coisas, um chefe aproximou-se, ajoelhou-se diante de Jesus e disse: «A minha filha acaba de morrer; mas vem, põe a tua mão sobre ela e ela viverá»."
,"19":"Jesus levantou-Se e seguiu-o com os discípulos."
,"20":"Nesse momento, chegou uma mulher que havia doze anos sofria de hemorragia. Ela foi por detrás e tocou a orla do manto de Jesus,"
,"21":"porque pensava: «Ainda que eu toque só no seu manto, ficarei curada»."
,"22":"Jesus virou-Se, e, ao vê-la, disse: «Coragem, filha! Foi a tua fé que te curou». E, desde aquele momento, a mulher ficou curada."
,"23":"Chegando à casa do chefe, Jesus viu os tocadores de flauta e uma multidão fazendo barulho. Então disse:"
,"24":"«Retirai-vos, porque a menina não morreu. Ela está apenas a dormir». As pessoas começaram a fazer troça d'Ele."
,"25":"Quando a multidão foi afastada, Jesus entrou e tomou a menina pela mão. Então a menina levantou-se."
,"26":"E esta notícia espalhou-se por toda aquela região."
,"27":"Quando Jesus saiu dali, seguiram-n'O dois cegos, gritando: «Tem piedade de nós, filho de David»."
,"28":"Ao chegar a casa, os cegos aproximaram-se d'Ele. Então Jesus perguntou: «Credes que Eu posso fazer isso?» Eles responderam: «Sim, Senhor»."
,"29":"Então Jesus tocou nos olhos deles, dizendo: «Que aconteça conforme acreditastes». E os olhos deles abriram-se."
,"30":"Então Jesus ordenou-lhes: «Tomai cuidado para que ninguém o saiba»."
,"31":"Mas eles saíram e espalharam a notícia por toda aquela região."
,"32":"Depois de os dois cegos terem saído, levaram a Jesus um mudo que estava possuído pelo demónio."
,"33":"Quando o demónio foi expulso, o mudo falou, e as multidões ficaram admiradas, e diziam: «Nunca se viu uma coisa assim em Israel»."
,"34":"Mas os fariseus diziam: «É pelo príncipe dos demónios que Ele expulsa os demónios»."
,"35":"Jesus percorria todas as cidades e povoados, ensinando nas suas sinagogas, pregando a Boa Notícia do Reino, e curando toda a espécie de doenças e enfermidades."
,"36":"Vendo as multidões, Jesus teve compaixão, porque estavam cansadas e abatidas, como ovelhas que não têm pastor."
,"37":"Então Jesus disse aos seus discípulos: «A seara é grande, mas os trabalhadores são poucos!"
,"38":"Por isso, pedi ao dono da seara que mande trabalhadores para a seara»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Então Jesus chamou os Discípulos e deu-lhes poder para expulsar os espíritos maus e para curar qualquer espécie de doença e enfermidade."
,"2":"São estes os nomes dos Doze Apóstolos: primeiro Simão, chamado Pedro, e seu irmão André; Tiago e seu irmão João, filhos de Zebedeu;"
,"3":"Filipe e Bartolomeu; Tomé e Mateus, o cobrador de impostos; Tiago, filho de Alfeu, e Tadeu;"
,"4":"Simão, o Cananeu, e Judas Iscariotes, que foi o traidor de Jesus."
,"5":"Jesus enviou os Doze com estas recomendações: «Não sigais pelo caminho dos pagãos e não entreis nas cidades dos samaritanos."
,"6":"Ide primeiro às ovelhas perdidas da casa de Israel."
,"7":"Ide e anunciai: 'O Reino dos Céus está próximo'."
,"8":"Curai os doentes, ressuscitai os mortos, purificai os leprosos, expulsai os demónios. Recebestes de graça, dai também de graça!"
,"9":"Não leveis nos cintos moedas de ouro, de prata ou de cobre;"
,"10":"nem sacola para o caminho, nem duas túnicas, nem calçado, nem bastão, porque o operário tem direito ao seu alimento."
,"11":"Em qualquer cidade ou povoado onde entrardes, informai-vos para saber se há alguém que seja digno. Permanecei na sua casa até partirdes."
,"12":"Ao entrardes na casa, fazei a saudação."
,"13":"Se a casa for digna, desça sobre ela a vossa paz; se ela não for digna, que a paz volte para vós."
,"14":"Se alguém não vos receber bem e não escutar a vossa palavra, ao sairdes dessa casa e dessa cidade sacudi a poeira dos pés."
,"15":"Eu vos garanto: no dia do julgamento as cidades de Sodoma e Gomorra serão tratadas com menor rigor do que aquela cidade»."
,"16":"«Eis que Eu vos envio como ovelhas para o meio dos lobos. Portanto, sede prudentes como as serpentes e simples como as pombas."
,"17":"Tende cuidado com os homens, porque vos entregarão aos tribunais e vos açoitarão nas sinagogas."
,"18":"Sereis levados perante governadores e reis, por minha causa, a fim de serdes testemunhas para eles e para as nações."
,"19":"Quando vos entregarem, não fiqueis preocupados como ou com aquilo que deveis dizer, porque, nessa hora, ser-vos-á sugerido o que deveis dizer."
,"20":"Com efeito, não sereis vós a falar, o Espírito do vosso Pai é quem falará através de vós."
,"21":"O irmão entregará à morte o próprio irmão; o pai entregará o filho; os filhos levantar-se-ão contra seus pais e matá-los-ão."
,"22":"Sereis odiados de todos, por causa do meu nome. Mas aquele que perseverar até ao fim, esse será salvo."
,"23":"Quando vos perseguirem numa cidade, fugi para outra. Eu vos garanto que não acabareis de percorrer as cidades de Israel antes que venha o Filho do Homem."
,"24":"O discípulo não está acima do mestre, nem o servo acima do seu senhor."
,"25":"Para o discípulo basta ser como o seu mestre, e para o servo ser como o seu senhor. Se chamaram Belzebu ao dono da casa, quanto mais aos que são da casa dele!»."
,"26":"«Não tenhais medo deles, pois não há nada de escondido que não venha a ser revelado, e não existe nada de oculto que não venha a ser conhecido."
,"27":"O que vos digo na escuridão, repeti-o à luz do dia, e o que escutais em segredo, proclamai-o sobre os telhados."
,"28":"Não tenhais medo daqueles que matam o corpo mas não podem matar a alma. Pelo contrário, tende medo d'Aquele que pode arruinar a alma e o corpo no inferno!"
,"29":"Não se vendem dois pardais por algumas moedas? No entanto, nenhum deles cai no chão sem o consentimento do vosso Pai."
,"30":"Quanto a vós, até os cabelos da cabeça estão todos contados."
,"31":"Não tenhais medo! Valeis mais do que muitos pardais."
,"32":"Portanto, todo aquele que der testemunho de Mim diante dos homens, também Eu darei testemunho dele diante do meu Pai que está no Céu."
,"33":"Aquele, porém, que Me renegar diante dos homens, também Eu o renegarei diante do meu Pai que está no Céu»."
,"34":"«Não penseis que vim trazer paz à Terra; não vim trazer a paz, mas a espada."
,"35":"De facto, vim separar o filho do seu pai, a filha da sua mãe, a nora da sogra."
,"36":"E os inimigos do homem serão os seus próprios familiares."
,"37":"Quem ama o pai ou a mãe mais do que a Mim não é digno de Mim. Quem ama o filho ou a filha mais do que a Mim não é digno de Mim."
,"38":"Quem não toma a sua cruz e Me segue não é digno de Mim."
,"39":"Quem procura conservar a própria vida, vai perdê-la. E quem perde a sua vida por causa de Mim, vai encontrá-la»."
,"40":"«Quem vos recebe, a Mim recebe; e quem Me recebe, recebe Aquele que Me enviou."
,"41":"Quem recebe um profeta, por ser profeta, receberá a recompensa de profeta. E quem recebe um justo, por ser justo, receberá a recompensa de justo."
,"42":"Quem der ainda que seja apenas um copo de água fresca a um destes pequeninos, por ser meu discípulo, Eu vos garanto: não perderá a sua recompensa»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Quando Jesus terminou de dar estas instruções aos seus doze Discípulos, partiu dali, a fim de ensinar e pregar nas cidades deles."
,"2":"João estava na prisão. Quando ouviu falar das obras do Messias, enviou-Lhe alguns discípulos,"
,"3":"para Lhe perguntarem: «És Tu aquele que há-de vir, ou devemos esperar outro?»"
,"4":"Jesus respondeu: «Voltai e contai a João o que vedes e ouvis:"
,"5":"os cegos recuperam a vista, os paralíticos andam, os leprosos ficam limpos, os surdos ouvem, os mortos ressuscitam e aos pobres é anunciada a Boa Notícia."
,"6":"E feliz aquele que não se escandaliza por causa de Mim!»"
,"7":"Os discípulos de João partiram, e Jesus começou a falar às multidões a respeito de João: «Que fostes ver ao deserto? Uma cana agitada pelo vento?"
,"8":"Que fostes ver? Um homem vestido com roupas finas? Mas aqueles que vestem roupas finas moram em palácios de reis."
,"9":"Então, que é que fostes ver? Um profeta? Sim, Eu vo-lo digo: alguém que é mais do que um profeta."
,"10":"É de João que a Escritura diz: 'Eis que Eu envio o meu mensageiro à tua frente; Ele vai preparar o teu caminho diante de Ti'."
,"11":"Eu vos garanto: de todos os homens que já nasceram, nenhum é maior do que João Baptista. No entanto, o menor no Reino do Céu é maior do que ele."
,"12":"Desde os dias de João Baptista até agora, o Reino do Céu sofre violência, e são os violentos que procuram tomá-lo."
,"13":"De facto, todos os Profetas e a Lei profetizaram até João."
,"14":"E se o quiserdes aceitar, João é Elias que devia vir."
,"15":"Quem tem ouvidos, oiça»."
,"16":"«Com quem vou comparar esta geração? São como crianças sentadas nas praças, que se dirigem aos colegas e dizem:"
,"17":"'Tocámos flauta e não dançastes; cantámos uma música triste e não batestes no peito'."
,"18":"Veio João, que não come nem bebe, e disseram: 'Está com um demónio'."
,"19":"Veio o Filho do Homem, que come e bebe, e dizem: 'É um comilão e beberrão, amigo dos cobradores de impostos e dos pecadores'. Mas a sabedoria foi justificada pelas suas obras»."
,"20":"Então Jesus começou a falar contra as cidades onde havia realizado a maior parte dos seus milagres, porque elas não se tinham convertido."
,"21":"Ele dizia: «Ai de ti, Corazim! Ai de ti, Betsaida! Porque, se em Tiro e Sidónia tivessem sido realizados os milagres que foram feitos no meio de vós, há muito tempo que elas teriam feito penitência, vestindo-se de cilício e cobrindo-se de cinza."
,"22":"Pois bem! Eu digo-vos: no dia do julgamento, Tiro e Sidónia terão uma sentença menos dura que vós."
,"23":"E tu, Cafarnaum! Serás erguida até ao céu? Serás precipitada no inferno! Porque, se em Sodoma tivessem acontecido os milagres que em ti se realizaram, ela ainda hoje existiria!"
,"24":"Eu te digo: no dia do julgamento, Sodoma terá uma sentença menos dura do que tu»."
,"25":"Naquele tempo, Jesus disse: «Eu Te louvo, Pai, Senhor do Céu e da Terra, porque escondeste estas coisas aos sábios e inteligentes, e as revelaste aos pequeninos."
,"26":"Sim, Pai, porque assim foi do teu agrado."
,"27":"Meu Pai entregou-Me tudo a Mim. Ninguém conhece o Filho, a não ser o Pai, e ninguém conhece o Pai, a não ser o Filho e aquele a quem o Filho O quiser revelar."
,"28":"Vinde a Mim todos os que estais cansados de carregar o peso do vosso fardo e Eu vos darei descanso."
,"29":"Carregai a minha carga e aprendei de Mim, porque sou manso e humilde de coração, e encontrareis descanso para as vossas vidas."
,"30":"Porque a minha carga é suave e o meu fardo é leve»."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Naquele tempo, Jesus passou por uns campos de trigo, num dia de sábado. Os seus discípulos sentiram fome e começaram a apanhar espigas para comer."
,"2":"Vendo isso, os fariseus disseram: «Eis que os teus discípulos estão a fazer o que não é permitido em dia de sábado!»"
,"3":"Jesus perguntou aos fariseus: «Nunca lestes o que David e seus companheiros fizeram, quando sentiram fome?"
,"4":"Como ele entrou na casa de Deus, e comeram os pães oferecidos a Deus? Ora, nem a David, nem aos que estavam com ele era permitido comer os pães reservados apenas aos sacerdotes."
,"5":"Não lestes também, na Lei, que em dia de sábado, no Templo, os sacerdotes violam o sábado, sem cometer falta?"
,"6":"Pois Eu digo-vos: aqui está quem é maior do que o Templo."
,"7":"Se tivésseis compreendido o que significa: 'Quero a misericórdia e não o sacrifício', não teríeis condenado estes homens que não estão em falta."
,"8":"Portanto, o Filho do Homem é senhor do sábado»."
,"9":"Jesus saiu daquele lugar e foi para a sinagoga deles."
,"10":"Encontrava-se lá um homem com uma das mãos paralisada. E, para poderem acusar Jesus, os fariseus perguntaram: «É permitido fazer curas em dia de sábado?»"
,"11":"Jesus respondeu: «Suponde que um de vós tem uma só ovelha e ela cai num poço em dia de sábado. Será que ele não pegaria nela e não a tiraria de lá?"
,"12":"Ora, um homem vale muito mais do que uma ovelha! Logo, é permitido fazer uma boa acção em dia de sábado»."
,"13":"Então Jesus disse ao homem: «Estende a mão». O homem estendeu a mão e ela ficou boa e sã como a outra."
,"14":"Logo depois, os fariseus saíram e fizeram um plano para matar Jesus."
,"15":"Jesus soube disso, e foi-Se embora daquele lugar. Numerosas multidões O seguiram, e Ele a todos curou."
,"16":"Jesus ordenou que não dissessem quem Ele era."
,"17":"Isto aconteceu para se cumprir o que foi dito pelo profeta Isaías:"
,"18":"«Eis aqui o meu servo, que escolhi; o meu amado, no qual a minha alma se compraz. Colocarei sobre Ele o meu Espírito, e Ele anunciará o julgamento às nações."
,"19":"Não discutirá, nem gritará e ninguém ouvirá a sua voz nas praças."
,"20":"Não esmagará a cana quebrada, nem apagará o pavio que ainda fumega, até que leve o julgamento à vitória."
,"21":"E as nações depositarão a sua esperança no seu nome»."
,"22":"Então levaram a Jesus um endemoninhado cego e mudo. Jesus curou-o, de modo que ele falava e via."
,"23":"E todas as multidões ficaram admiradas, e perguntavam: «Não será Ele o filho de David?»"
,"24":"Os fariseus, ao ouvirem isto, e disseram: «Ele expulsa os demónios através de Belzebu, o príncipe dos demónios!»."
,"25":"Sabendo o que eles estavam a pensar, Jesus disse: «Todo o reino dividido em grupos que lutam entre si será arruinado. E toda a cidade ou família dividida em grupos que brigam entre si não poderá durar."
,"26":"E se Satanás expulsa Satanás, ele está dividido contra si mesmo. Como é que o seu reino poderá subsistir?"
,"27":"Se é através de Belzebu que Eu expulso os demónios, através de quem os expulsam os vossos filhos? Por isso, serão eles mesmos que vos julgarão."
,"28":"Mas se é através do Espírito de Deus que Eu expulso os demónios, então o Reino de Deus chegou até vós."
,"29":"Como pode alguém entrar na casa de um homem forte e apoderar-se das suas coisas, se antes o não amarrar? Só depois poderá roubar a sua casa."
,"30":"Quem não está comigo, está contra Mim. E quem não recolhe comigo, espalha."
,"31":"É por isso que Eu vos digo: todo o pecado e blasfémia será perdoado aos homens; mas a blasfémia contra o Espírito não será perdoada."
,"32":"Quem disser alguma coisa contra o Filho do Homem será perdoado. Mas quem disser algo contra o Espírito Santo nunca será perdoado, nem neste mundo, nem no mundo que há-de vir»."
,"33":"«Se plantardes uma árvore boa, o seu fruto será bom; mas se plantardes uma árvore má, também o seu fruto será mau, porque é pelo fruto que se conhece a árvore."
,"34":"Raça de cobras venenosas! Como é que sendo maus podeis dizer coisas boas? Pois a boca fala aquilo de que o coração está cheio."
,"35":"O homem bom tira coisas boas do seu bom tesouro, e o homem mau tira coisas más do seu mau tesouro."
,"36":"Eu digo-vos: no dia do julgamento, todos devem prestar contas de cada palavra inútil que tiverem dito."
,"37":"Porque serás justificado pelas tuas próprias palavras e serás condenado pelas tuas próprias palavras»."
,"38":"Então alguns doutores da Lei e fariseus disseram a Jesus: «Mestre, queremos ver um sinal realizado por Ti»."
,"39":"Jesus respondeu: «Uma geração má e adúltera pede um sinal, mas nenhum sinal lhe será dado, a não ser o sinal do profeta Jonas."
,"40":"De facto, assim como Jonas passou três dias e três noites no ventre da baleia, assim também o Filho do Homem passará três dias e três noites no seio da terra."
,"41":"No dia do julgamento, os homens da cidade de Nínive ficarão de pé contra esta geração e condená-la-ão. Porque eles fizeram penitência quando ouviram Jonas pregar. E aqui está quem é maior do que Jonas."
,"42":"No dia do julgamento, a rainha do Sul levantar-se-á contra esta geração e condená-la-á. Porque ela veio de uma terra distante para ouvir a sabedoria de Salomão. E aqui está quem é maior do que Salomão»."
,"43":"«Quando um espírito mau sai de um homem, ele fica a vaguear em lugares desertos, procurando repouso, e não o encontra."
,"44":"Então diz: 'Vou já voltar para a casa de onde saí'. Quando chega, encontra a casa vazia, varrida e arrumada."
,"45":"Então vai e toma consigo outros sete espíritos piores do que ele. Entram e instalam-se nessa casa; no fim, esse homem fica em condição pior do que antes. É o que vai acontecer com esta geração má»."
,"46":"Jesus ainda estava a falar às multidões. Sua Mãe e seus irmãos ficaram do lado de fora, procurando falar com Ele."
,"47":"Alguém disse a Jesus: «Olha! Tua Mãe e teus irmãos estão lá fora, e querem falar contigo»."
,"48":"Jesus perguntou àquele que tinha falado: «Quem é minha Mãe e quem são os meus irmãos?»"
,"49":"E, estendendo a mão para os discípulos, Jesus disse: «Aqui estão minha Mãe e meus irmãos,"
,"50":"pois todo aquele que faz a vontade do meu Pai que está no Céu, esse é meu irmão, minha irmã e minha mãe»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Naquele dia, Jesus saiu de casa, e foi sentar-Se na margem do mar da Galileia."
,"2":"Numerosas multidões reuniram-se em volta d'Ele. Por isso, Jesus entrou numa barca e sentou-Se, enquanto a multidão ficava de pé na praia."
,"3":"E Jesus falou-lhes de muitas coisas em parábolas: «O semeador saiu para semear."
,"4":"Enquanto semeava, algumas sementes caíram à beira do caminho, e os passarinhos foram e comeram-nas."
,"5":"Outras sementes caíram em terreno pedregoso, onde não havia muita terra. As sementes logo brotaram, porque a terra não era profunda."
,"6":"Porém, quando o sol se levantou, queimou as plantas e elas secaram, porque não tinham raiz."
,"7":"Outras sementes caíram no meio dos espinhos e os espinhos cresceram e sufocaram as plantas."
,"8":"Outras sementes, porém, caíram em terra boa, e renderam cem, sessenta e trinta frutos por um."
,"9":"Quem tem ouvidos, oiça!»."
,"10":"Os discípulos aproximaram-se e perguntaram a Jesus: «Porque usas parábolas para falar com eles?»"
,"11":"Jesus respondeu: «Porque a vós foi dado conhecer os mistérios do Reino do Céu, mas a eles não."
,"12":"Pois, a quem tem, será dado ainda mais, será dado em abundância; mas àquele que não tem, será tirado até o pouco que tem."
,"13":"É por isso que Eu uso parábolas para falar com eles: assim olham e não vêem, ouvem e não escutam nem compreendem."
,"14":"Deste modo se cumpre para eles a profecia de Isaías: 'É certo que ouvireis, porém nada compreendereis. É certo que vereis, mas nada percebereis."
,"15":"Porque o coração deste povo tornou-se insensível. São duros de ouvido e fecharam os olhos para não ver com os olhos, e não ouvir com os ouvidos, não compreender com o coração e não se converter. Assim não podem ser curados'."
,"16":"Vós, porém, sois felizes, porque os vossos olhos vêem e os vossos ouvidos ouvem."
,"17":"Eu vos garanto: muitos profetas e justos desejaram ver o que estais a ver e não puderam ver; desejaram ouvir o que estais a ouvir e não puderam ouvir»."
,"18":"«Ouvi, portanto, o que a parábola do semeador quer dizer:"
,"19":"Todo aquele que ouve a Palavra do Reino e não a compreende é como a semente que caiu à beira do caminho: vem o Maligno e rouba o que foi semeado no seu coração."
,"20":"A semente que caiu em terreno pedregoso é aquele que ouve a Palavra e logo a recebe com alegria."
,"21":"Mas não tem raiz em si mesmo, é inconstante: quando chega uma tribulação ou perseguição por causa da Palavra, desiste logo."
,"22":"A semente que caiu no meio dos espinhos é aquele que ouve a Palavra, mas a preocupação do mundo e a ilusão da riqueza sufocam a Palavra e ela fica sem dar fruto."
,"23":"A semente que caiu em terra boa é aquele que ouve a Palavra e a compreende. Esse com certeza produz fruto. Um dá cem, outro sessenta e outro trinta por um»."
,"24":"Jesus contou outra parábola à multidão: «O Reino do Céu é como um homem que semeou boa semente no seu campo."
,"25":"Uma noite, quando todos dormiam, veio o inimigo dele, semeou joio no meio do trigo e foi-se embora."
,"26":"Quando o trigo cresceu e as espigas começaram a formar-se, apareceu também o joio."
,"27":"Os empregados foram procurar o dono e disseram-lhe: 'Senhor, não semeaste boa semente no teu campo? Donde veio então o joio?'"
,"28":"O dono respondeu: 'Foi algum inimigo que fez isso'. Os empregados perguntaram-lhe: 'Queres que arranquemos o joio?'"
,"29":"O dono respondeu: 'Não. Pode acontecer que, arrancando o joio, arranqueis também o trigo."
,"30":"Deixai crescer um e outro até à colheita. E no tempo da colheita direi aos ceifeiros: Apanhai primeiro o joio e amarrai-o em feixes para ser queimado. Depois recolhei o trigo no meu celeiro!'»"
,"31":"E Jesus contou outra parábola: «O Reino do Céu é como uma semente de mostarda que um homem toma e semeia no seu campo."
,"32":"Embora ela seja a menor de todas as sementes, quando cresce fica maior do que as outras plantas. E torna-se uma árvore, de modo que os pássaros do céu vêm e fazem ninhos em seus ramos»."
,"33":"Jesus contou-lhes ainda outra parábola: «O Reino do Céu é como o fermento que uma mulher toma e mistura com três porções de farinha, até que tudo esteja fermentado»."
,"34":"Tudo isto disse Jesus em parábolas às multidões. Nada lhes dizia sem ser em parábolas,"
,"35":"para se cumprir o que foi dito pelo profeta: «Abrirei a boca para usar parábolas; vou proclamar coisas escondidas desde a criação do mundo»."
,"36":"Então Jesus deixou as multidões e foi para casa. Os discípulos aproximaram-se d'Ele e disseram: «Explica-nos a parábola do joio»."
,"37":"Jesus respondeu: «Quem semeia a boa semente é o Filho do Homem."
,"38":"O campo é o mundo. A boa semente são os que pertencem ao Reino. O joio são os que pertencem ao Maligno."
,"39":"O inimigo que semeou o joio é o demónio. A colheita é o fim dos tempos. Os ceifeiros são os anjos."
,"40":"Assim como o joio é recolhido e queimado no fogo, o mesmo também acontecerá no fim dos tempos:"
,"41":"o Filho do Homem enviará os seus anjos e eles recolherão todos os que levam os outros a pecar e os que praticam o mal,"
,"42":"e depois lançá-los-ão na fornalha de fogo. Aí eles vão chorar e ranger os dentes."
,"43":"Então os justos brilharão como o Sol no Reino de seu Pai. Quem tem ouvidos, oiça»."
,"44":"«O Reino do Céu é como um tesouro escondido no campo. Um homem encontra-o e volta a escondê-lo. Cheio de alegria, vai, vende todos os seus bens e compra esse campo."
,"45":"O Reino do Céu é também como um negociante que procura pérolas preciosas."
,"46":"Quando encontra uma pérola de grande valor, vai, vende todos os seus bens e compra essa pérola»."
,"47":"«O Reino do Céu é ainda como uma rede lançada ao mar. Ela apanha peixes de todo a espécie."
,"48":"Quando está cheia, os pescadores puxam a rede para a praia, sentam-se e escolhem: os peixes bons vão para os cestos, os que não prestam são deitados fora."
,"49":"Assim acontecerá no fim dos tempos: os anjos virão para separar os homens maus dos que são bons."
,"50":"E lançarão os maus na fornalha de fogo. Ali vão chorar e ranger os dentes»."
,"51":"«Compreendestes tudo isto?» Eles responderam: «Sim»."
,"52":"Então Jesus acrescentou: «E assim todo o doutor da Lei, que se torna discípulo do Reino do Céu, é como um pai de família que tira do seu baú coisas novas e velhas»."
,"53":"Quando Jesus acabou de contar estas parábolas, saiu daquele lugar"
,"54":"e voltou para a sua terra. Ensinava as pessoas na sinagoga, de modo que ficavam admiradas. Diziam: «De onde vêm esta sabedoria e estes milagres?"
,"55":"Este homem não é o filho do carpinteiro? A sua Mãe não se chama Maria, e seus irmãos não são Tiago, José, Simão e Judas?"
,"56":"E suas irmãs não moram connosco? Então, de onde vem tudo isto?»"
,"57":"E ficaram escandalizados por causa de Jesus. Mas Jesus disse: «Um profeta só não é estimado na sua própria pátria e na sua família»."
,"58":"E Jesus não fez ali muitos milagres por causa da falta de fé deles."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Naquele tempo, Herodes, governador da Galileia, ouviu falar da fama de Jesus."
,"2":"Disse então aos seus oficiais: «Ele é João Baptista que ressuscitou dos mortos. É por isso que os poderes agem nesse homem»."
,"3":"De facto, Herodes tinha mandado prender João, algemá-lo e colocá-lo na prisão. Fez isto por causa de Herodíades, a mulher do seu irmão."
,"4":"Porque João dizia a Herodes: «Não te é permitido tê-la contigo»."
,"5":"Herodes queria matar João, mas tinha medo da multidão, que o considerava um profeta."
,"6":"Quando chegou o aniversário de Herodes, a filha de Herodíades dançou diante de todos e agradou a Herodes."
,"7":"Então Herodes prometeu com juramento que lhe daria tudo o que ela pedisse."
,"8":"Pressionada pela mãe, disse: «Dá-me aqui, num prato, a cabeça de João Baptista»."
,"9":"O rei ficou triste, mas por causa do juramento na frente dos convidados ordenou que atendessem o pedido dela"
,"10":"e mandou cortar a cabeça de João na prisão."
,"11":"Depois a cabeça foi levada num prato, foi entregue à jovem e esta levou-a a sua mãe."
,"12":"Os discípulos de João foram buscar o cadáver e sepultaram-no. Depois foram contar a Jesus o que tinha acontecido."
,"13":"Quando soube da morte de João Baptista, Jesus partiu e foi de barca para um lugar deserto e afastado. Mas, quando as multidões souberam disso, saíram das cidades e seguiram-n'O a pé."
,"14":"Ao sair da barca, Jesus viu grande multidão. Teve compaixão deles e curou os que estavam doentes."
,"15":"Ao entardecer, os discípulos chegaram perto de Jesus e disseram: «Este lugar é deserto e a hora já vai adiantada. Despede as multidões, para que possam ir aos povoados comprar alguma coisa para comer»."
,"16":"Mas Jesus disse-lhes: «Eles não precisam de se ir embora. Dai-lhes vós de comer»."
,"17":"Os discípulos responderam: «Só temos aqui cinco pães e dois peixes»."
,"18":"Jesus disse: «Trazei-mos cá»."
,"19":"Jesus mandou que as multidões se sentassem na relva. Depois tomou os cinco pães e os dois peixes, ergueu os olhos ao céu, pronunciou a bênção, partiu os pães e deu-os aos discípulos; os discípulos distribuíram-nos às multidões."
,"20":"Todos comeram, ficaram satisfeitos, e ainda recolheram doze cestos cheios de pedaços que sobraram."
,"21":"O número dos que comeram era mais ou menos cinco mil homens, sem contar mulheres e crianças."
,"22":"Logo em seguida, Jesus obrigou os discípulos a entrar na barca e a ir à frente, para o outro lado do mar, enquanto Ele despedia as multidões."
,"23":"Logo depois de despedir as multidões, Jesus subiu sozinho ao monte para rezar. Ao anoitecer, Jesus continuava ali sozinho."
,"24":"A barca, porém, já longe da terra, era batida pelas ondas, porque o vento era contrário."
,"25":"Entre as três e as seis da madrugada, Jesus foi ter com os discípulos, andando sobre o mar."
,"26":"Quando os discípulos O avistaram, andando sobre o mar, ficaram apavorados e disseram: «É um fantasma!» E gritaram de medo."
,"27":"Jesus, porém, logo lhes disse: «Coragem! Sou Eu. Não temais»."
,"28":"Então Pedro disse-Lhe: «Senhor, se és Tu, manda-me ir ao teu encontro, caminhando sobre a água»."
,"29":"Jesus respondeu: «Vem». Pedro desceu da barca e começou a andar sobre a água em direcção a Jesus."
,"30":"Mas ficou com medo quando sentiu o vento e, começando a afundar, gritou: «Senhor, salva-me»."
,"31":"Jesus logo estendeu a mão, segurou Pedro e disse-lhe: «Homem de pouca fé, porque duvidaste?»."
,"32":"Então entraram na barca. E o vento parou."
,"33":"Os que estavam na barca ajoelharam-se diante de Jesus, dizendo: «De facto, Tu és o Filho de Deus»."
,"34":"Acabando de atravessar, desembarcaram em Genesaré."
,"35":"Os homens daquele lugar, reconhecendo-O, espalharam a notícia por toda a região. Então levaram a Jesus todos os doentes"
,"36":"e pediram que pudessem ao menos tocar a orla da sua capa. E todos os que a tocaram ficaram curados."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Alguns fariseus e diversos doutores da Lei, de Jerusalém, aproximaram-se de Jesus e perguntaram:"
,"2":"«Porque é que os teus discípulos desobedecem à tradição dos antigos? De facto, comem pão sem lavar as mãos!»"
,"3":"Jesus respondeu: «Porque é que vós também desobedeceis ao mandamento de Deus em nome da vossa tradição?"
,"4":"Pois Deus disse: 'Honra teu pai e tua mãe'. E ainda: 'Quem amaldiçoar o pai ou a mãe deve morrer'."
,"5":"E no entanto vós ensinais que alguém pode dizer ao seu pai e à sua mãe: 'O sustento que poderíeis receber de mim é consagrado a Deus'."
,"6":"E essa pessoa fica dispensada de honrar seu pai ou sua mãe. Assim esvaziastes a palavra de Deus com a vossa tradição."
,"7":"Hipócritas! Isaías profetizou muito bem sobre vós quando disse:"
,"8":"'Este povo honra-Me com os lábios, mas o seu coração está longe de Mim."
,"9":"Não adianta nada prestarem-Me culto, porque ensinam preceitos humanos'»."
,"10":"Em seguida, Jesus chamou a multidão para perto d'Ele e disse: «Escutai e compreendei."
,"11":"Não é o que entra na boca que torna o homem impuro, mas o que sai da boca isso é que torna o homem impuro»."
,"12":"Então os discípulos aproximaram-se e disseram a Jesus: «Sabes que os fariseus ficaram escandalizados com o que disseste?»"
,"13":"Jesus respondeu: «Toda a planta que não foi plantada por meu Pai celeste será arrancada."
,"14":"Não vos preocupeis com eles. São cegos guiando cegos. Ora, se um cego guia outro cego, os dois cairão num buraco»."
,"15":"Então Pedro disse a Jesus: «Explica-nos esta parábola»."
,"16":"Jesus respondeu: «Será que ainda não entendeis?"
,"17":"Não compreendeis que tudo o que entra na boca passa pelo estômago e vai para a privada?"
,"18":"Ao contrário, as coisas que saem da boca vêm do coração e essas é que tornam o homem impuro."
,"19":"Pois é do coração que vêm as más intenções: crimes, adultério, imoralidade, roubos, falsos testemunhos, calúnias."
,"20":"Essas coisas é que tornam o homem impuro; mas comer sem lavar as mãos não torna o homem impuro»."
,"21":"Jesus saiu dali e foi para a região de Tiro e Sidónia."
,"22":"Então, uma mulher cananeia, que morava nessa região, gritou a Jesus: «Senhor, filho de David, tem piedade de mim. A minha filha está cruelmente atormentada por um demónio!»."
,"23":"Mas Jesus nem lhe deu resposta. Então os discípulos aproximaram-se e pediram-Lhe: «Manda embora essa mulher, porque ela vem gritando atrás de nós»."
,"24":"Jesus respondeu: «Eu fui mandado somente para as ovelhas perdidas do povo de Israel»."
,"25":"Mas a mulher, aproximando-se, ajoelhou-se diante de Jesus e começou a implorar: «Senhor, ajuda-me»."
,"26":"Jesus disse-lhe: «Não está certo tirar o pão dos filhos e lançá-lo aos cachorrinhos»."
,"27":"A mulher disse: «Sim, Senhor, é verdade; mas também os cachorrinhos comem as migalhas que caem da mesa dos seus donos»."
,"28":"Diante disso, Jesus disse-lhe: «Mulher, é grande a tua fé! Seja feito como desejas». E desde aquele momento a filha dela ficou curada."
,"29":"Saindo dali, Jesus foi para a margem do mar da Galileia, subiu a montanha e sentou-Se."
,"30":"Numerosas multidões se aproximaram de Jesus, levando consigo coxos, aleijados, cegos, mudos e muitos outros doentes. Então colocaram-nos aos pés de Jesus. E Ele curou-os."
,"31":"As multidões ficaram admiradas, vendo que os mudos falavam, os aleijados saravam, os coxos andavam e os cegos viam. E glorificaram o Deus de Israel."
,"32":"Jesus chamou os seus discípulos e disse-lhes: «Tenho compaixão desta multidão, porque há já três dias que está comigo e não tem nada para comer. Não quero mandá-los embora sem comer, para que não desmaiem pelo caminho»."
,"33":"Os discípulos disseram: «Onde vamos buscar, neste deserto, tantos pães para matar a fome de tão grande multidão?»"
,"34":"Jesus perguntou: «Quantos pães tendes?» Eles responderam: «Sete, e alguns peixinhos»."
,"35":"Jesus mandou que a multidão se sentasse no chão."
,"36":"Depois tomou os sete pães e os peixes, deu graças, partiu-os, e ia-os dando aos discípulos, e os discípulos às multidões."
,"37":"Todos comeram e ficaram satisfeitos. E encheram sete cestos com os pedaços que sobraram."
,"38":"Os que tinham comido eram quatro mil homens, sem contar mulheres e crianças."
,"39":"Tendo despedido as multidões, Jesus subiu para a barca e foi para o território de Magadã."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Os fariseus e saduceus aproximaram-se de Jesus e, para O tentarem, pediram-Lhe que lhes mostrasse um sinal do céu."
,"2":"Jesus, porém, respondeu: «Ao pôr do sol dizeis: 'Vai fazer bom tempo, porque o céu está vermelho'."
,"3":"E de manhã: 'Hoje vai chover, porque o céu está vermelho-escuro'. Olhando o céu, sabeis prever o tempo, mas não sois capazes de interpretar os sinais dos tempos."
,"4":"Uma geração má e adúltera busca um sinal, mas nenhum sinal lhe será dado, a não ser o sinal de Jonas». Então Jesus deixou-os e foi-Se embora."
,"5":"Quando atravessaram para o outro lado do mar, os discípulos esqueceram-se de levar pães."
,"6":"Então Jesus disse: «Prestai atenção e tomai cuidado com o fermento dos fariseus e dos saduceus»."
,"7":"Os discípulos pensavam consigo mesmos: «É porque não trouxemos pães»."
,"8":"Mas Jesus percebeu e perguntou: «Porque estais a pensar na falta de pães, homens de pouca fé?"
,"9":"Ainda não compreendeis nem mesmo vos lembrais dos cinco pães para cinco mil homens, e de quantos cestos recolhestes?"
,"10":"Nem dos sete pães para quatro mil homens, e quantos cestos recolhestes?"
,"11":"Como é que não compreendeis que não era de pão que vos falava? Tende cuidado com o fermento dos fariseus e saduceus»."
,"12":"Então perceberam que Jesus não tinha falado para terem cuidado com o fermento de pão, mas com o ensinamento dos fariseus e saduceus."
,"13":"Jesus chegou à região de Cesareia de Filipe e perguntou aos seus discípulos: «Quem dizem os homens que é o Filho do Homem»?"
,"14":"Eles responderam: «Alguns dizem que é João Baptista; outros, que é Elias; outros ainda, que é Jeremias ou algum dos profetas»."
,"15":"Então Jesus perguntou-lhes: «E vós, quem dizeis que Eu sou?»"
,"16":"Simão Pedro respondeu: «Tu és o Messias, o Filho do Deus vivo»."
,"17":"Jesus disse: «És feliz, Simão, filho de Jonas, porque não foi um ser humano que te revelou isso, mas o meu Pai que está no Céu."
,"18":"Por isso Eu te digo: tu és Pedro, e sobre esta pedra construirei a minha Igreja, e o poder da morte nunca poderá vencê-la."
,"19":"Dar-te-ei as chaves do Reino do Céu, e o que ligares na Terra será ligado no Céu, e o que desligares na Terra será desligado no Céu»."
,"20":"Jesus, então, ordenou aos discípulos que não dissessem a ninguém que Ele era o Messias."
,"21":"E Jesus começou a mostrar aos seus discípulos que devia ir a Jerusalém e sofrer muito da parte dos anciãos, dos sumos sacerdotes e dos doutores da Lei e que devia ser morto e ressuscitar ao terceiro dia."
,"22":"Então Pedro tomou Jesus à parte e repreendeu-O, dizendo: «Deus não permita tal coisa, Senhor! Que isso nunca Te aconteça!»"
,"23":"Jesus, porém, voltou-Se para Pedro e disse: «Afasta-te de mim, Satanás! És uma pedra de tropeço para Mim, porque não pensas as coisas de Deus mas as coisas dos homens!»."
,"24":"Então Jesus disse aos discípulos: «Se alguém quer seguir-Me, renuncie a si mesmo, tome a sua cruz e siga-Me."
,"25":"Pois, quem quiser salvar a sua vida, vai perdê-la; mas, quem perde a sua vida por causa de Mim, vai encontrá-la."
,"26":"Com efeito, que adianta ao homem ganhar o mundo inteiro se perder a sua vida? O que pode um homem dar em troca da sua vida?"
,"27":"Porque o Filho do Homem virá na glória de seu Pai, com os seus anjos, e então retribuirá a cada um de acordo com a própria conduta."
,"28":"Eu vos garanto: alguns daqueles que estão aqui não morrerão sem terem visto o Filho do Homem vir com o seu Reino»."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Seis dias depois, Jesus tomou consigo Pedro, os irmãos Tiago e João, e levou-os a um lugar à parte, sobre uma alta montanha."
,"2":"E transfigurou-Se diante deles: o seu rosto brilhou como o Sol e as suas roupas ficaram brancas como a luz."
,"3":"Nisto apareceram-lhes Moisés e Elias a conversar com Jesus."
,"4":"Então Pedro tomou a palavra e disse a Jesus: «Senhor, é bom ficarmos aqui. Se queres, vou fazer aqui três tendas: uma para Ti, outra para Moisés e outra para Elias»."
,"5":"Pedro ainda estava a falar, quando uma nuvem luminosa os cobriu com a sua sombra, e da nuvem saiu uma voz que dizia: «Este é o meu Filho amado, que muito Me agrada. Escutai o que Ele diz»."
,"6":"Quando ouviram isto, os discípulos ficaram muito assustados e caíram com o rosto por terra."
,"7":"Jesus aproximou-Se, tocou neles e disse: «Levantai-vos e não temais»."
,"8":"Os discípulos ergueram os olhos e não viram mais ninguém, a não ser somente Jesus."
,"9":"Ao descerem da montanha, Jesus ordenou-lhes: «Não conteis a ninguém esta visão até que o Filho do Homem tenha ressuscitado dos mortos»."
,"10":"Os discípulos de Jesus perguntaram-Lhe: «O que querem dizer os doutores da Lei, quando afirmam que Elias deve vir antes?»"
,"11":"Jesus respondeu: «Elias vem para colocar tudo em ordem."
,"12":"Mas Eu digo-vos: Elias já veio e eles não o reconheceram. Fizeram com ele tudo o que quiseram. E o Filho do Homem será maltratado por eles do mesmo modo»."
,"13":"Então os discípulos compreenderam que Jesus falava de João Baptista."
,"14":"Foram ter com a multidão. Um homem aproximou-se de Jesus, ajoelhou-se"
,"15":"e disse: «Senhor, tem piedade do meu filho. Ele é epiléptico e tem ataques tão fortes que muitas vezes cai no fogo ou na água."
,"16":"Eu levei-o aos teus discípulos, mas eles não conseguiram curá-lo!»"
,"17":"Jesus respondeu: «Gente sem fé e pervertida! Até quando deverei ficar convosco? Até quando terei que vos suportar? Trazei-mo cá»."
,"18":"Então Jesus ordenou, e o demónio saiu. E na mesma hora o menino ficou curado."
,"19":"Os discípulos aproximaram-se de Jesus e perguntaram-Lhe em particular: «Porque é que nós não conseguimos expulsar o demónio?»"
,"20":"Jesus respondeu: «É porque não tendes bastante fé. Eu vos garanto: se tiverdes fé do tamanho de um grão de mostarda, podeis dizer a esta montanha: 'Vai daqui para acolá', e ela irá. E nada vos será impossível."
,"21":"Só a oração e o jejum podem expulsar este tipo de demónios»."
,"22":"Quando os discípulos estavam reunidos na Galileia, Jesus disse-lhes: «O Filho do Homem vai ser entregue na mão dos homens."
,"23":"Eles matá-l'O-ão, mas ao terceiro dia ressuscitará». E os discípulos ficaram muito tristes."
,"24":"Quando chegaram a Cafarnaum, os fiscais do imposto do Templo aproximaram-se de Pedro e perguntaram: «O vosso Mestre não paga o imposto do Templo?»"
,"25":"Pedro respondeu: «Paga, sim». Ao entrar em casa, Jesus adiantou-Se e perguntou: «O que é que achas, Simão? De quem é que os reis da Terra recebem taxas ou impostos: dos filhos ou dos estrangeiros?»"
,"26":"Pedro respondeu: «Dos estrangeiros!» Então Jesus disse: «Isso quer dizer que os filhos não precisam de pagar."
,"27":"Mas, para não provocar escândalo, vai ao mar e lança o anzol. Na boca do primeiro peixe que apanhares encontrarás o dinheiro para pagar o imposto. Toma-o e dá-lho por Mim e por ti»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Naquele momento, os discípulos aproximaram-se de Jesus e perguntaram-Lhe: «Quem é o maior no Reino do Céu?»"
,"2":"Jesus chamou uma criança, colocou-a no meio deles"
,"3":"e disse: «Garanto-vos que se não vos converterdes e não vos tornardes como crianças nunca entrareis no Reino do Céu."
,"4":"Quem se abaixa e se torna como esta criança, esse será o maior no Reino do Céu."
,"5":"E quem recebe em meu nome uma criança como esta é a Mim que recebe»."
,"6":"«Quem escandalizar um destes pequeninos que acreditam em Mim, melhor seria para ele pendurar uma pedra de moinho ao pescoço e ser lançado ao fundo do mar."
,"7":"Ai do mundo por causa dos escândalos! É inevitável que aconteçam escândalos, mas ai do homem que causa escândalo!"
,"8":"Se a tua mão ou o teu pé é para ti ocasião de escândalo, corta-o e lança-o para longe de ti. É melhor para ti entrares na vida sem uma das mãos ou sem um dos pés do que teres as duas mãos ou os dois pés e seres lançado no fogo eterno."
,"9":"E se o teu olho é para ti ocasião de escândalo, arranca-o e lança-o para longe de ti. É melhor para ti entrares na vida com um olho só, do que teres os dois olhos e seres lançado no inferno de fogo»."
,"10":"«Cuidado em não desprezar nenhum destes pequeninos, pois Eu digo-vos: os seus anjos, no Céu, estão sempre na presença do meu Pai que está no Céu."
,"11":"O Filho do Homem veio para salvar o que estava perdido."
,"12":"Que vos parece? Se um homem tem cem ovelhas e uma delas se perde, será que ele não vai deixar as noventa e nove nas montanhas para procurar aquela que se perdeu?"
,"13":"Eu vos garanto: quando ele a encontra, fica muito mais feliz com ela do que com as noventa e nove que não se perderam."
,"14":"Do mesmo modo, o Pai que está no céu não quer que nenhum destes pequeninos se perca»."
,"15":"«Se o teu irmão pecar, vai e mostra-lhe o seu erro, mas em particular, só entre vós os dois. Se ele te der ouvidos, terás ganho o teu irmão."
,"16":"Se ele não te der ouvidos, toma contigo mais uma ou duas pessoas, para que toda a questão seja decidida sob a palavra de duas ou três testemunhas."
,"17":"Caso ele não te dê ouvidos, comunica-o à Igreja. Se nem mesmo à Igreja ele der ouvidos, seja tratado como se fosse um pagão ou um cobrador de impostos."
,"18":"Eu vos garanto: tudo o que ligardes na Terra será ligado no Céu, e tudo o que desligardes na Terra será desligado no Céu."
,"19":"Digo ainda mais: se dois de vós na Terra estiverem de acordo sobre qualquer coisa que queiram pedir, isso lhes será concedido por meu Pai que está no Céu."
,"20":"Pois onde dois ou três estiverem reunidos em meu nome, Eu estou no meio deles»."
,"21":"Pedro aproximou-se de Jesus e perguntou-Lhe: «Senhor, quantas vezes devo perdoar, se meu irmão pecar contra mim? Até sete vezes?»"
,"22":"Jesus respondeu: «Não te digo até sete vezes, mas até setenta vezes sete."
,"23":"Porque o Reino do Céu é como um rei que resolveu acertar contas com os seus empregados."
,"24":"Logo ao princípio trouxeram-lhe um que devia dez mil talentos."
,"25":"Como o empregado não tinha com que pagar, o patrão mandou que fosse vendido como escravo, juntamente com a mulher e os filhos e tudo o que possuía, para que pagasse a dívida."
,"26":"O empregado, porém, caiu aos pés do patrão e, ajoelhado, suplicava: 'Dá-me um prazo, e eu te pagarei tudo'."
,"27":"Levado pela compaixão, o patrão soltou o empregado e perdoou-lhe a dívida."
,"28":"Ao sair dali, aquele empregado encontrou um dos seus companheiros que lhe devia cem moedas de prata. Agarrou-o pelo pescoço e começou a sufocá-lo, dizendo: 'Paga já o que me deves'."
,"29":"O companheiro, caindo a seus pés, suplicava: 'Dá-me um prazo, e eu te pagarei'."
,"30":"Mas o empregado não quis saber disso. Saiu e mandou metê-lo na prisão até que pagasse o que lhe devia."
,"31":"Vendo o que havia acontecido, os outros empregados ficaram muito tristes, procuraram o patrão e contaram-lhe tudo."
,"32":"O patrão mandou chamar o empregado e disse-lhe: 'Empregado miserável! Perdoei-te toda a tua dívida, porque me suplicaste."
,"33":"Não devias também ter compaixão do teu companheiro, como eu tive de ti?'"
,"34":"O patrão indignou-se e mandou entregá-lo aos torturadores até que pagasse toda a dívida."
,"35":"É assim que procederá convosco o meu Pai que está no Céu, se cada um não perdoar do fundo do coração a seu irmão»."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Quando Jesus acabou de dizer estas palavras, partiu da Galileia e foi para o território da Judeia, no outro lado do rio Jordão."
,"2":"Numerosas multidões O seguiram, e Jesus curou-as ali."
,"3":"Alguns fariseus aproximaram-se de Jesus e perguntaram-Lhe, para O tentar: «É permitido ao homem divorciar-se da sua mulher por qualquer motivo?»"
,"4":"Jesus respondeu: «Nunca lestes que o Criador, desde o início, os fez homem e mulher?"
,"5":"E que disse: 'Por isso, o homem deixará o pai e a mãe e se unirá à sua mulher e os dois serão uma só carne'?"
,"6":"Portanto, já não são dois, mas uma só carne. Portanto, o que Deus uniu, o homem não o deve separar»."
,"7":"Os fariseus perguntaram: «Então, como é que Moisés mandou dar certidão de divórcio ao despedir a mulher?»"
,"8":"Jesus respondeu: «Moisés permitiu o divórcio, porque sois duros de coração. Mas não foi assim desde o início."
,"9":"Por isso digo-vos: quem se divorciar da sua mulher, a não ser em caso de fornicação, e casar com outra, comete adultério»."
,"10":"Os discípulos disseram a Jesus: «Se a situação do homem com a mulher é assim, então é melhor não se casar»."
,"11":"Jesus respondeu: «Nem todos entendem isto, a não ser aqueles a quem é concedido."
,"12":"De facto, há homens castrados, porque nasceram assim; outros, porque os homens os fizeram assim; outros ainda castraram-se por causa do Reino do Céu. Quem puder entender, entenda»."
,"13":"Então trouxeram crianças para que Jesus lhes impusesse as mãos e rezasse por elas. Mas os discípulos repreendiam-nas."
,"14":"Jesus, porém, disse: «Deixai as crianças e não as proibais de vir a Mim, porque delas é o Reino do Céu»."
,"15":"E depois de impor as mãos sobre as crianças, Jesus partiu dali."
,"16":"Um jovem aproximou-se e disse a Jesus: «Mestre, que devo fazer de bom para alcançar a vida eterna?»"
,"17":"Jesus respondeu: «Porque me interrogas sobre o que é bom? Bom é um só. Se queres entrar na vida, guarda os mandamentos»."
,"18":"O homem perguntou: «Quais mandamentos?» Jesus respondeu: «Não matarás; não cometerás adultério; não roubarás; não levantarás falso testemunho;"
,"19":"honra teu pai e tua mãe; e ama o teu próximo como a ti mesmo»."
,"20":"O jovem disse a Jesus: «Tenho observado todas essas coisas. O que é que ainda me falta fazer?»"
,"21":"Jesus respondeu: «Se queres ser perfeito, vai, vende tudo o que tens, dá o dinheiro aos pobres e terás um tesouro no Céu. Depois vem e segue-Me»."
,"22":"Ao ouvir isto, o jovem retirou-se cheio de tristeza, porque era muito rico."
,"23":"Então Jesus disse aos discípulos: «Eu vos garanto: um rico dificilmente entrará no Reino do Céu."
,"24":"E digo ainda: é mais fácil um camelo entrar pelo buraco de uma agulha do que um rico entrar no Reino de Deus»."
,"25":"Ouvindo isto, os discípulos ficaram muito espantados e perguntaram: «Então, quem pode ser salvo?»"
,"26":"Jesus olhou para os discípulos e disse: «Aos homens isto é impossível, mas a Deus tudo é possível»."
,"27":"Então Pedro tomou a palavra e disse: «Vê! Nós deixámos tudo e seguimos-Te. O que vamos receber?»"
,"28":"Jesus respondeu: «Eu vos garanto: no mundo novo, quando o Filho do Homem Se sentar no trono da sua glória, vós, que Me seguistes, também vos sentareis em doze tronos para julgar as doze tribos de Israel."
,"29":"E todo aquele que tiver deixado casas, irmãos, irmãs, pai, mãe, filhos, campos, por causa do meu nome, receberá muitas vezes mais e terá como herança a vida eterna."
,"30":"Muitos que agora são os primeiros, serão os últimos; e muitos que agora são os últimos, serão os primeiros»."
}`)
	CurrentBook.AddChapter(20, `{
"1":"«De facto, o Reino do Céu é como um patrão que saiu de madrugada para contratar trabalhadores para a sua vinha."
,"2":"Combinou com os trabalhadores uma moeda de prata por dia e mandou-os para a vinha."
,"3":"Às nove horas da manhã, o patrão saiu de novo. Viu outros que estavam desocupados na praça"
,"4":"e disse-lhes: 'Ide vós também para a minha vinha. Eu pagar-vos-ei o que for justo'."
,"5":"E eles foram. O patrão saiu de novo ao meio-dia e às três horas da tarde e fez a mesma coisa."
,"6":"Saindo outra vez pelas cinco horas da tarde, encontrou outros que estavam na praça e disse-lhes: 'Porque estais aí o dia inteiro desocupados?'"
,"7":"Eles responderam: 'Porque ninguém nos contratou'. O patrão disse-lhes: 'Ide vós também para a minha vinha'."
,"8":"Quando chegou a tarde, o patrão disse ao administrador: 'Chama os trabalhadores e paga uma diária a todos. Começa pelos últimos e acaba nos primeiros'."
,"9":"Chegaram aqueles que tinham sido contratados pelas cinco da tarde, e cada um recebeu uma moeda de prata."
,"10":"Em seguida chegaram os que foram contratados primeiro, e pensavam que iam receber mais. No entanto, cada um deles recebeu também uma moeda de prata."
,"11":"Ao receberem o pagamento, começaram a resmungar contra o patrão:"
,"12":"'Estes últimos trabalharam uma hora só, e tu igualaste-os a nós, que suportámos o cansaço e o calor do dia inteiro!'"
,"13":"E o patrão disse a um deles: 'Amigo, eu não fui injusto contigo. Não combinámos uma moeda de prata?"
,"14":"Toma o que é teu e volta para casa. Eu quero dar também a este, que foi contratado por último, o mesmo que te dei a ti."
,"15":"Acaso não tenho o direito de fazer o que quero com aquilo que me pertence? Ou estás com ciúme por eu estar a ser generoso?'"
,"16":"Assim, os últimos serão os primeiros e os primeiros serão os úl-timos»."
,"17":"Enquanto subia para Jerusalém, Jesus tomou consigo os doze discípulos em particular e, durante a caminhada, disse-lhes:"
,"18":"«Eis que estamos a subir para Jerusalém, e o Filho do Homem vai ser entregue aos sumos sacerdotes e aos doutores da Lei. Eles condená-l'O-ão à morte,"
,"19":"e entregá-l'O-ão aos pagãos para zombarem d'Ele, flagelá-l'O e crucificá-l'O. E no terceiro dia Ele ressuscitará»."
,"20":"A mãe dos filhos de Zebedeu apro-ximou-se de Jesus com seus filhos e ajoelhou-se para pedir alguma coisa."
,"21":"Jesus perguntou: «Que queres?» Ela respondeu: «Promete que os meus dois filhos se sentem, um à tua direita e o outro à tua esquerda, no teu Reino»."
,"22":"Jesus, então, disse: «Não sabeis o que estais a pedir. Acaso podeis beber o cálice que Eu vou beber?» Eles responderam: «Podemos»."
,"23":"Então Jesus disse: «Bebereis o meu cálice. Mas não depende de Mim conceder o lugar à minha direita ou esquerda. É para aqueles para quem meu Pai o tem reservado»."
,"24":"Quando os outros dez discípulos ouviram isto ficaram com raiva dos dois irmãos."
,"25":"Mas Jesus chamou-os e disselhes: «Sabeis que os governadores das nações têm poder sobre elas e os grandes exercem sobre elas a sua autoridade."
,"26":"Entre vós não deverá ser assim: quem de vós quiser ser grande deve tornar-se o vosso servidor;"
,"27":"e quem de vós quiser ser o primeiro deverá tornar-se vosso servo."
,"28":"Pois o Filho do Homem não veio para ser servido. Ele veio para servir e para dar a sua vida como resgate em favor de muitos»."
,"29":"Quando iam a sair de Jericó, uma grande multidão seguiu Jesus."
,"30":"Dois cegos estavam sentados à beira do caminho. Ouvindo dizer que Jesus ia a passar, começaram a gritar: «Senhor, filho de David, tem piedade de nós!»"
,"31":"A multidão repreendeu-os e ordenou-lhes que ficassem calados. Mas eles gritaram mais forte ainda: «Senhor, filho de David, tem piedade de nós!»"
,"32":"Então Jesus parou, chamou os dois cegos e disse-lhes: «Que quereis que vos faça?»"
,"33":"Eles responderam: «Senhor, queremos que os nossos olhos se abram»."
,"34":"Cheio de compaixão, Jesus tocou-lhes nos olhos e eles imediatamente começaram a ver. E seguiram a Jesus."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Jesus e os seus discípulos aproximaram-se de Jerusalém e chegaram a Betfagé, perto do monte das Oliveiras. Então Jesus enviou dois discípulos,"
,"2":"dizendo: «Ide à aldeia que está em frente de vós. E logo encontrareis uma jumenta amarrada e um jumentinho com ela. Soltai-os e trazei-mos."
,"3":"Se alguém vos disser alguma coisa, respondereis: 'O Senhor precisa deles, mas logo os devolverá'»."
,"4":"Isto aconteceu para se cumprir o que foi dito pelo profeta:"
,"5":"«Dizei à filha de Sião: eis que o teu rei vem ao teu encontro. Ele é manso e está montado num jumento, num jumentinho, cria de um animal de carga»."
,"6":"Os discípulos foram e fizeram como Jesus tinha mandado."
,"7":"Levaram a jumenta e o jumentinho, colocaram os mantos sobre eles, e Jesus montou."
,"8":"Uma grande multidão estendeu os seus mantos pelo caminho; outros cortaram ramos de árvores e espalharam-nos pelo caminho."
,"9":"As multidões, que iam à frente e atrás de Jesus, gritavam: «Hosana ao Filho de David! Bendito Aquele que vem em nome do Senhor! Hosana no mais alto do céu!»"
,"10":"Quando Jesus entrou em Jerusalém, toda a cidade ficou agitada e perguntavam: «Quem é Ele?»"
,"11":"E as multidões respondiam: «É Jesus, o profeta de Nazaré da Galileia»."
,"12":"Jesus entrou no Templo e expulsou todos os que vendiam e compravam no Templo. Derrubou as mesas dos cambistas e as cadeiras dos vendedores de pombas."
,"13":"E disse: «Está nas Escrituras: 'A minha casa será chamada casa de oração'. No entanto, vós fizestes dela um covil de ladrões»."
,"14":"Os cegos e aleijados aproximaram-se de Jesus no Templo e Ele curou-os."
,"15":"Os sumos sacerdotes e doutores da Lei ficaram indignados, quando viram as maravilhas que Jesus fazia, e as crianças gritando no Templo: «Hosana ao filho de David!»"
,"16":"Então disseram a Jesus: «Ouves o que eles dizem?» Jesus respondeu: «Sim, oiço. Nunca lestes na Escritura: 'Da boca dos pequeninos e das crianças de peito tiraste um louvor'?»"
,"17":"Jesus então deixou-os, saiu da cidade e foi para Betânia, onde passou a noite."
,"18":"Na manhã seguinte, voltando para a cidade, Jesus sentiu fome."
,"19":"Viu uma figueira perto do caminho, aproximou-Se mas não encontrou nela senão folhas. Então Jesus disse à figueira: «Que nunca mais dês frutos». E, no mesmo instante, a figueira secou."
,"20":"Vendo isto, os discípulos ficaram espantados e disseram: «Como é que secou tão depressa?»"
,"21":"Jesus respondeu: «Garanto-vos que se tiverdes fé, e não duvidardes, fareis não só o que Eu fiz com a figueira, mas também podereis dizer a esta montanha: 'Tira-te daqui e lança-te ao mar', e isso acontecerá."
,"22":"E tudo o que na oração pedirdes com fé, recebê-lo-eis»."
,"23":"Jesus entrou no Templo. Enquanto ensinava, os sumos sacerdotes e os anciãos do povo aproximaram-se e perguntaram: «Com que autoridade fazes estas coisas? Quem foi que te deu esta autoridade?»"
,"24":"Jesus respondeu: «Eu também vou fazer-vos uma pergunta. Se responderdes, também vos direi com que autoridade faço isto."
,"25":"De onde era o baptismo de João? Do Céu ou dos homens?» Mas eles raciocinavam, pensando: «Se respondemos que vinha do Céu, ele vai dizer: 'Então, porque não acreditastes em João?'"
,"26":"Se respondemos que vinha dos homens, temos medo da multidão, pois todos consideram João como um profeta»."
,"27":"Eles então responderam a Jesus: «Não sabemos». E Jesus disse-lhes: «Pois também Eu vos não digo com que autoridade faço estas coisas»."
,"28":"«Que vos parece? Certo homem tinha dois filhos. Dirigiu-se ao mais velho e disse-lhe: 'Filho, vai hoje trabalhar para a vinha'."
,"29":"O filho respondeu: 'Não quero'. Mas depois arrependeu-se, e foi."
,"30":"O pai dirigiu-se ao outro filho e disse a mesma coisa. Ele respondeu: 'Sim, senhor, eu vou'. Mas não foi."
,"31":"Qual dos dois fez a vontade do pai?» Os sumos sacerdotes e os anciãos do povo responderam: «O filho mais velho». Então Jesus disse-lhes: «Pois Eu garanto-vos: os cobradores de impostos e as prostitutas vão entrar antes de vós no Reino do Céu."
,"32":"Porque João veio até vós para vos mostrar o caminho da justiça e não acreditastes nele. Os cobradores de impostos e as prostitutas acreditaram nele. Vós, porém, mesmo vendo isso, não vos arrependestes para acreditar nele»."
,"33":"«Escutai outra parábola: Certo proprietário plantou uma vinha, cercou-a, fez um tanque para pisar as uvas e construiu uma torre de guarda. Depois arrendou a vinha a alguns agricultores e ausentou-se para o estrangeiro."
,"34":"Quando chegou o tempo da colheita, o proprietário mandou os seus empregados aos agricultores para receber os frutos."
,"35":"Os agricultores, porém, agarraram os empregados, bateram num, mataram outro e apedrejaram o terceiro."
,"36":"O proprietário mandou de novo outros empregados, em maior número que os primeiros. Mas eles trataram-nos da mesma forma."
,"37":"Finalmente, o proprietário enviou-lhes o seu próprio filho, pensando: 'Eles vão respeitar o meu filho'."
,"38":"Os agricultores, porém, ao verem o filho, pensaram: 'Este é o herdeiro. Vinde, vamos matá-lo e tomar posse da sua herança'."
,"39":"Então agarraram o filho, lançaram-no para fora da vinha e mataram-no."
,"40":"Pois bem: quando o dono da vinha voltar, o que irá fazer a esses agricultores?»"
,"41":"Os sumos sacerdotes e os anciãos do povo responderam: «É claro que mandará matar de modo violento esses perversos e arrendará a vinha a outros agricultores que lhe entregarão os frutos no devido tempo»."
,"42":"Então Jesus disse-lhes: «Nunca lestes na Escritura: 'A pedra que os construtores deixaram de lado tornou-se a pedra mais importante; isso foi feito pelo Senhor e é admirável aos nossos olhos'?"
,"43":"Por isso Eu vos afirmo: o Reino de Deus ser-vos-á tirado e será entregue a uma nação que produzirá os seus frutos."
,"44":"Quem cair sobre esta pedra ficará em pedaços; e aquele sobre quem ela cair será esmagado»."
,"45":"Os sumos sacerdotes e os fariseus ouviram as parábolas de Jesus e compreenderam que falava deles."
,"46":"Procuraram prender Jesus, mas tiveram medo das multidões, pois elas consideravam Jesus um profeta."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Jesus voltou a falar em parábolas aos sumos sacerdotes e aos anciãos do povo."
,"2":"Ele dizia: «O Reino do Céu é como um rei que preparou a festa de casamento do seu filho."
,"3":"E mandou os seus empregados chamar os convidados para a festa, mas eles não quiseram ir."
,"4":"O rei mandou outros empregados, ordenando-lhes: 'Dizei aos convidados que já preparei o banquete, os bois e animais gordos já foram abatidos e tudo está pronto. Que venham para a festa'."
,"5":"Mas os convidados não deram a menor atenção; um foi para o seu campo, outro foi fazer os seus negócios"
,"6":"e outros agarraram os empregados, bateram neles e mataram-nos."
,"7":"Indignado, o rei mandou as suas tropas, que mataram aqueles assassinos e lhes incendiaram a cidade."
,"8":"Em seguida, o rei disse aos empregados: 'A festa de casamento está pronta, mas os convidados não a mereceram."
,"9":"Portanto, ide até às encruzilhadas dos caminhos e convidai para a festa todos os que encontrardes'."
,"10":"Então os empregados saíram pelos caminhos e reuniram todos os que encontraram, maus e bons. E a sala da festa ficou cheia de convidados."
,"11":"Quando o rei entrou para ver os convidados, viu alguém que não trazia o traje de festa."
,"12":"E perguntou-lhe: 'Amigo, como foi que entraste aqui sem o traje de festa?' Mas o homem nada respondeu."
,"13":"Então o rei disse aos que serviam: 'Amarrai os pés e as mãos deste homem e lançai-o fora na escuridão. Ali haverá choro e ranger de dentes'."
,"14":"Porque muitos são chamados e poucos são escolhidos»."
,"15":"Então os fariseus retiraram-se e fizeram um plano para apanhar Jesus em alguma palavra."
,"16":"Mandaram os seus discípulos acompanhados de alguns partidários de Herodes para dizerem a Jesus: «Mestre, sabemos que és verdadeiro e que ensinas de facto o caminho de Deus. Não dás preferência a ninguém, porque não levas em conta as aparências."
,"17":"Diz-nos, então, o que pensas: É lícito ou não, pagar imposto a César?»"
,"18":"Jesus percebeu a maldade deles e disse: «Hipócritas! Porque me tentais?"
,"19":"Mostrai-me a moeda do imposto». Levaram-Lhe então a moeda."
,"20":"E Jesus perguntou: «De quem é a figura e inscrição nesta moeda?»"
,"21":"Eles responderam: «É de César». Então Jesus disse: «Pois dai a César o que é de César, e a Deus o que é de Deus»."
,"22":"Ouvindo isto, eles ficaram admirados. Deixaram Jesus e foram-se embora."
,"23":"Os saduceus afirmam que não existe ressurreição. Alguns deles aproximaram-se de Jesus e propuseram-Lhe este caso:"
,"24":"«Mestre, Moisés disse: 'Se alguém morrer sem ter filhos, o irmão desse homem deve casar-se com a viúva a fim de que possam ter filhos em nome do irmão que morreu'."
,"25":"Pois bem, havia entre nós sete irmãos. O primeiro casou-se e morreu sem ter filhos, deixando a mulher para o seu irmão."
,"26":"Do mesmo modo, aconteceu com o segundo e o terceiro e assim com os sete."
,"27":"Depois de todos eles, morreu também a mulher."
,"28":"Na ressurreição, de qual dos sete ela será mulher? De facto, todos a tiveram»."
,"29":"Jesus respondeu: «Estais enganados, porque não conheceis as Escrituras nem o poder de Deus."
,"30":"De facto, na ressurreição, os homens e as mulheres não se casarão, pois serão como os anjos do Céu."
,"31":"E, quanto à ressurreição, será que não lestes o que Deus vos disse:"
,"32":"'Eu sou o Deus de Abraão, o Deus de Isaac e o Deus de Jacob'? Ora, Ele não é Deus dos mortos, mas dos vivos»."
,"33":"Ouvindo isto, as multidões ficaram impressionadas com o ensinamento de Jesus."
,"34":"Os fariseus ouviram dizer que Jesus tinha feito calar os saduceus. Então reuniram-se em grupo"
,"35":"e um deles perguntou a Jesus para O tentar:"
,"36":"«Mestre, qual é o maior mandamento da Lei?»"
,"37":"Jesus respondeu: «Amarás ao Senhor teu Deus com todo o teu coração, com toda a tua alma e com todo o teu entendimento."
,"38":"Este é o maior e o primeiro mandamento."
,"39":"O segundo é semelhante a este: Amarás ao teu próximo como a ti mesmo."
,"40":"Toda a Lei e os profetas dependem destes dois mandamentos»."
,"41":"Os fariseus estavam reunidos e Jesus perguntou-lhes:"
,"42":"«O que é que vós pensais do Messias? De quem é filho?» Os fariseus responderam: «De David»."
,"43":"Então Jesus disse: «Como é que David, pelo Espírito, Lhe chama Senhor, quando afirma:"
,"44":"'O Senhor disse ao meu Senhor: senta-te à minha direita, até que Eu ponha os teus inimigos debaixo dos teus pés?'"
,"45":"Se o próprio David Lhe chama Senhor, como é que Ele pode ser seu filho?»"
,"46":"E ninguém podia responder a Jesus uma só palavra. Desse dia em diante, ninguém mais se arriscou a fazer perguntas a Jesus."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Jesus falou assim às multidões e aos seus discípulos:"
,"2":"«Os doutores da Lei e os fariseus têm autoridade para interpretar a Lei de Moisés."
,"3":"Por isso, vós deveis fazer e observar tudo o que eles dizem. Mas não imiteis as suas acções, pois eles dizem e não praticam."
,"4":"Amarram pesados fardos e colocam-nos aos ombros dos outros, mas eles mesmos não estão dispostos a movê-los, nem sequer com um dedo."
,"5":"Fazem todas as suas acções só para serem vistos pelos outros. Vede como eles usam faixas largas na testa e nos braços, e como põem na roupa longas franjas, com trechos da Escritura."
,"6":"Gostam dos lugares de honra nos banquetes e dos primeiros lugares nas sinagogas;"
,"7":"gostam de ser cumprimentados nas praças públicas e de que as pessoas lhes chamem mestre."
,"8":"Quanto a vós, nunca vos deixeis tratar por mestre, pois um só é o vosso Mestre, e todos vós sois irmãos."
,"9":"Na Terra, não chameis pai a ninguém, pois um só é o vosso Pai, Aquele que está no Céu."
,"10":"Não deixeis que os outros vos chamem guias, pois um só é o vosso Guia: o Messias."
,"11":"Pelo contrário, o maior de vós deve ser aquele que vos serve."
,"12":"Quem se eleva será humilhado e quem se humilha será elevado»."
,"13":"«Ai de vós, doutores da Lei e fariseus hipócritas! Fechais o Reino do Céu aos homens. Nem vós entrais, nem deixais entrar aqueles que desejam."
,"14":"Ai de vós, doutores da Lei e fariseus hipócritas! Explorais as viúvas e roubais as suas casas e, para disfarçar, fazeis longas orações! Por isso recebereis uma condenação mais severa."
,"15":"Ai de vós, doutores da Lei e fariseus hipócritas! Percorreis o mar e a terra para converter alguém, e, quando conseguis, tornai-lo merecedor do inferno duas vezes mais do que vós."
,"16":"Ai de vós, guias cegos! Dizeis: 'Se alguém jura pelo Templo, não fica obrigado, mas se alguém jura pelo ouro do Templo, fica obrigado'."
,"17":"Irresponsáveis e cegos! O que vale mais: o ouro ou o Templo que santifica o ouro?"
,"18":"Dizeis também: 'Se alguém jura pelo altar, não fica obrigado; mas se alguém jura pela oferta que está sobre o altar, fica obrigado'."
,"19":"Cegos! O que vale mais: a oferta ou o altar que santifica a oferta?"
,"20":"De facto, quem jura pelo altar, jura por ele e por tudo o que está sobre ele."
,"21":"E quem jura pelo Templo, jura por ele e por Deus que habita no Templo."
,"22":"E quem jura pelo Céu, jura pelo trono de Deus e por Aquele que nele está sentado."
,"23":"Ai de vós, doutores da Lei e fariseus hipócritas! Pagais o dízimo da hortelã, da erva-doce e do cominho, e deixais de lado os ensinamentos mais importantes da lei, como a justiça, a misericórdia e a fidelidade. Deveríeis praticar isto, sem deixar aquilo."
,"24":"Guias cegos! Coais um mosquito mas engolis um camelo."
,"25":"Ai de vós, doutores da Lei e fariseus hipócritas! Limpais o copo e o prato por fora, mas por dentro estais cheios de desejos de roubo e cobiça."
,"26":"Fariseu cego! Limpa primeiro o copo por dentro, e assim o lado de fora também ficará limpo."
,"27":"Ai de vós, doutores da Lei e fariseus hipócritas! Sois como sepulcros caiados: por fora parecem bonitos, mas por dentro estão cheios de ossos de mortos e podridão!"
,"28":"Assim também vós: por fora, pareceis justos diante dos outros, mas por dentro estais cheios de hipocrisia e injustiça."
,"29":"Ai de vós, doutores da Lei e fariseus hipócritas! Construís sepulcros para os profetas e enfeitais os túmulos dos justos,"
,"30":"e dizeis: 'Se tivéssemos vivido no tempo de nossos pais, não teríamos sido cúmplices na morte dos profetas'."
,"31":"Com isto, confessais que sois filhos daqueles que mataram os profetas."
,"32":"Pois bem: acabai de encher a medida dos vossos pais!"
,"33":"Serpentes, raça de cobras venenosas! Como é que poderíeis escapar à condenação do inferno?"
,"34":"É por isso que Eu vos envio profetas, sábios e doutores: a uns matareis e crucificareis, a outros torturareis nas vossas sinagogas e persegui-los-eis de cidade em cidade."
,"35":"Deste modo, cairá sobre vós todo o sangue justo derramado sobre a Terra, desde o sangue de Abel, o justo, até ao sangue de Zacarias, filho de Baraquias, que assassinastes entre o santuário e o altar."
,"36":"Eu vos garanto: tudo isto acontecerá a esta geração»."
,"37":"«Jerusalém, Jerusalém, que matas os profetas e apedrejas os que te foram enviados! Quantas vezes Eu quis reunir os teus filhos, como a galinha reúne os pintainhos debaixo das asas, mas tu não quiseste!"
,"38":"Vede: a vossa casa ficará deserta."
,"39":"De facto, Eu digo-vos que daqui em diante não Me vereis mais, até que digais: Bendito seja Aquele que vem em nome do Senhor!»"
}`)
	CurrentBook.AddChapter(24, `{
"1":"Jesus saiu do Templo e ia-Se embora, quando os discípulos se aproximaram d'Ele para Lhe mostrar as construções do Templo."
,"2":"Jesus respondeu: «Estais a ver tudo isto? Eu vos garanto: aqui não ficará pedra sobre pedra; tudo será destruído»."
,"3":"Jesus estava sentado no monte das Oliveiras. Os seus discípulos aproximaram-se d'Ele em particular e disseram: «Diz-nos quando vai acontecer isso, e qual será o sinal da tua vinda e do fim do mundo»."
,"4":"Jesus respondeu: «Cuidado, para que ninguém vos engane."
,"5":"Porque muitos virão em meu nome, dizendo: 'Eu sou o Messias'. E enganarão muita gente."
,"6":"Ouvireis falar de guerras e rumores de guerra. Prestai atenção e não vos assusteis, pois estas coisas devem acontecer, mas ainda não é o fim."
,"7":"De facto, uma nação lutará contra outra, e um reino contra outro reino. Haverá fome e terremotos em vários lugares."
,"8":"Mas tudo isto é o começo das dores»."
,"9":"«Então os homens irão entregar-vos à tribulação e matar-vos. Sereis odiados por todas as nações por causa do meu nome."
,"10":"Muitos ficarão escandalizados, mutuamente se hão-de trair e odiar."
,"11":"Vão surgir muitos falsos profetas que enganarão muita gente."
,"12":"A maldade espalhar-se-á tanto, que o amor de muitos se resfriará."
,"13":"Mas, quem perseverar até ao fim, será salvo."
,"14":"E esta Boa Notícia sobre o Reino será anunciada pelo mundo inteiro, como um testemunho para todas as nações. Então chegará o fim»."
,"15":"«Quando virdes a abominação da desolação, de que falou o profeta Daniel, estabelecida no lugar onde não deveria estar, - que o leitor entenda! -"
,"16":"então os que estiverem na Judeia fujam para as montanhas."
,"17":"Quem estiver no terraço, não desça para tirar os bens de sua casa."
,"18":"Quem estiver no campo, não volte para buscar o manto."
,"19":"Infelizes as mulheres grávidas e aquelas que estiverem amamentando nesses dias!"
,"20":"Rezai para que a vossa fuga não aconteça no Inverno, nem num dia de sábado."
,"21":"Pois nessa hora haverá uma grande tribulação, como nunca houve outra igual."
,"22":"Se esses dias não fossem abreviados, ninguém conseguiria salvar-se. Mas esses dias serão abreviados por causa dos eleitos."
,"23":"Se alguém vos disser: 'Aqui está o Messias', ou: 'Ele está ali', não acrediteis."
,"24":"Porque vão aparecer falsos messias e falsos profetas, que farão grandes sinais e prodígios, a ponto de enganar até mesmo os eleitos, se fosse possível."
,"25":"Estou a dizer-vos isto antes que aconteça."
,"26":"Se vos disserem: 'O Messias está no deserto', não saiais; 'Ele está aqui no esconderijo', não acrediteis."
,"27":"Porque a vinda do Filho do Homem será como o relâmpago que sai do Oriente e brilha até ao Ocidente."
,"28":"Onde estiver o cadáver, aí se reunirão os abutres»."
,"29":"«Logo depois da tribulação daqueles dias, o Sol vai ficar escuro, a Lua não brilhará mais e as estrelas cairão do céu, e os poderes do espaço ficarão abalados."
,"30":"Então aparecerá o sinal do Filho do Homem no céu; todas as tribos da terra baterão no peito, e verão o Filho do Homem vindo sobre as nuvens do céu com poder e grande glória."
,"31":"Ele enviará os seus anjos que tocarão bem alto a trombeta e que reunirão os seus eleitos desde os quatro cantos da terra, de um extremo do céu até ao outro»."
,"32":"Aprendei, portanto, a parábola da figueira: quando os seus ramos ficam verdes e as folhas começam a brotar, sabeis que o Verão está perto."
,"33":"Assim também, quando virdes todas estas coisas, ficai sabendo que ele está perto, já está às portas."
,"34":"Eu vos garanto: tudo isto vai acontecer antes que morra esta geração que agora vive."
,"35":"O céu e a terra desaparecerão, mas as minhas palavras não desaparecerão."
,"36":"Quanto àquele dia e àquela hora, ninguém sabe nada, nem os anjos do Céu, nem o Filho. Só o Pai é que sabe."
,"37":"A vinda do Filho do Homem será como no tempo de Noé."
,"38":"Porque, nos dias antes do dilúvio, todos comiam e bebiam, casavam-se e davam-se em casamento, até ao dia em que Noé entrou na arca."
,"39":"E eles nada perceberam, até que veio o dilúvio e arrastou a todos. Assim acontecerá também na vinda do Filho do Homem."
,"40":"Dois homens estarão a trabalhar no campo: um será levado e o outro será deixado."
,"41":"Duas mulheres estarão a moer no moinho: uma será levada, a outra será deixada."
,"42":"Portanto, vigiai! Porque não sabeis em que dia virá o vosso Senhor."
,"43":"Compreendei bem isto: se o dono da casa soubesse a que horas viria o ladrão, certamente ficaria a vigiar e não deixaria que a sua casa fosse arrombada."
,"44":"Por isso, também vós estai preparados. Porque o Filho do Homem virá na hora em que menos esperardes."
,"45":"Qual é o empregado fiel e prudente? É aquele que o senhor colocou como responsável pelos outros empregados, para lhes dar de comer na hora certa."
,"46":"Feliz o empregado cujo senhor o encontrar a agir assim quando voltar."
,"47":"Eu vos garanto: ele colocará esse empregado à frente de todos os seus bens."
,"48":"Mas, se for mau empregado, pensará: 'O meu senhor vai demorar-se'."
,"49":"Então começará a bater nos companheiros, a comer e a beber com os bêbados."
,"50":"O senhor desse empregado virá num dia em que ele não espera e numa hora que ele não conhece."
,"51":"Então o senhor castigá-lo-á severamente e fá-lo-á participar da mesma sorte dos hipócritas. Ali haverá choro e ranger de dentes»."
}`)
	CurrentBook.AddChapter(25, `{
"1":"«Naquele dia, o Reino do Céu será como dez virgens que tomaram as suas lâmpadas de azeite e saíram ao encontro do noivo."
,"2":"Cinco delas não tinham juízo e as outras cinco eram prudentes."
,"3":"As sem juízo ao tomarem as suas lâmpadas não levaram azeite consigo."
,"4":"As prudentes, porém, levaram vasilhas com azeite, juntamente com as lâmpadas."
,"5":"Como o noivo se demorasse, começaram a dormitar e adormeceram."
,"6":"No meio da noite, ouviu-se um grito: 'O noivo está a chegar. Ide ao seu encontro!'."
,"7":"Então as dez virgens levantaram-se e prepararam as lâmpadas."
,"8":"As sem juízo disseram às prudentes: 'Dai-nos um pouco do vosso azeite, porque as nossas lâmpadas estão a apagar-se'."
,"9":"As prudentes responderam: 'De modo nenhum, porque o azeite pode não chegar para nós e para vós. É melhor irdes aos vendedores comprá-lo'."
,"10":"Enquanto elas foram comprar azeite, o noivo chegou, e as que estavam preparadas entraram com ele para a festa de casamento. E a porta fechou-se."
,"11":"Por fim, chegaram também as outras virgens, e disseram: 'Senhor, Senhor, abre-nos a porta!'."
,"12":"Ele, porém, respondeu: 'Eu vos garanto que não vos conheço'."
,"13":"Vigiai, pois, porque não sabeis o dia nem a hora»."
,"14":"«Acontecerá como um homem que ia viajar para o estrangeiro. Chamando os seus empregados, entregou-lhes os seus bens."
,"15":"A um deu cinco talentos, a outro dois, e um ao terceiro: a cada qual de acordo com a própria capacidade. Em seguida, viajou para o estrangeiro."
,"16":"O empregado que havia recebido cinco talentos saiu logo, trabalhou com eles e lucrou outros cinco."
,"17":"Do mesmo modo, o que havia recebido dois lucrou outros dois."
,"18":"Mas aquele que havia recebido um só, saiu, cavou um buraco na terra e escondeu o dinheiro do seu patrão."
,"19":"Depois de muito tempo, o patrão voltou e foi ajustar contas com os empregados."
,"20":"O empregado que havia recebido cinco talentos entregou-lhe mais cinco, dizendo: 'Senhor, entregaste-me cinco talentos. Aqui estão mais cinco que lucrei'."
,"21":"O patrão disse: 'Muito bem, empregado bom e fiel! Como foste fiel na administração de tão pouco, eu confiar-te-ei muito mais. Vem participar da minha alegria'."
,"22":"Chegou também o que havia recebido dois talentos e disse: 'Senhor, entregaste-me dois talentos. Aqui estão mais dois que lucrei'."
,"23":"O patrão disse: 'Muito bem, empregado bom e fiel! Como foste fiel na administração de tão pouco, eu confiar-te-ei muito mais. Vem participar da minha alegria'."
,"24":"Por fim, chegou aquele que havia recebido um talento e disse: 'Senhor, eu sei que és um homem severo, pois colhes onde não plantaste e recolhes onde não semeaste."
,"25":"Por isso, fiquei com medo e escondi o teu talento na terra. Aqui tens o que te pertence'."
,"26":"O patrão respondeu-lhe: 'Empregado mau e preguiçoso! Sabias que eu colho onde não plantei e que recolho onde não semeei."
,"27":"Então devias ter depositado o meu dinheiro no banco, para que, no meu regresso, eu recebesse com juros o que me pertence'."
,"28":"Em seguida o patrão ordenou: 'Tirai-lhe o talento e dai-o ao que tem dez."
,"29":"Porque, a todo aquele que tem, será dado mais, e terá em abundância. Mas ao que não tem, até o que tem lhe será tirado."
,"30":"Quanto a este empregado inútil, lançai-o lá fora, na escuridão. Ali haverá choro e ranger de dentes'»."
,"31":"«Quando o Filho do Homem vier na sua glória, acompanhado de todos os anjos, então sentar-Se-á no seu trono glorioso."
,"32":"Todos os povos da Terra se reunirão diante d'Ele, e Ele separará uns dos outros, como o pastor separa as ovelhas dos cabritos."
,"33":"E colocará as ovelhas à sua direita e os cabritos à sua esquerda."
,"34":"Então o Rei dirá aos que estiverem à sua direita: 'Vinde vós, os abençoados por meu Pai. Recebei como herança o Reino que meu Pai vos preparou desde a criação do mundo."
,"35":"Pois estava com fome, e destes-Me de comer; estava com sede, e destes-Me de beber; era estrangeiro, e recebestes-Me na vossa casa;"
,"36":"estava sem roupa, e vestistes-Me; estava doente, e cuidastes de Mim; estava na prisão, e fostes visitar-Me'."
,"37":"Então os justos perguntar-Lhe-ão: 'Senhor, quando foi que te vimos com fome e te demos de comer, com sede e te demos de beber?"
,"38":"Quando foi que te vimos como estrangeiro e te recebemos em casa, e sem roupa e te vestimos?"
,"39":"Quando foi que te vimos doente ou preso e te fomos visitar?'"
,"40":"Então o Rei responder-lhes-á: 'Eu vos garanto: todas as vezes que fizestes isto a um dos menores dos meus irmãos, foi a Mim que o fizestes'."
,"41":"Depois o Rei dirá aos que estiverem à sua esquerda: 'Afastai-vos de Mim, malditos. Ide para o fogo eterno, preparado para o demónio e seus anjos."
,"42":"Porque Eu estava com fome, e não Me destes de comer; estava com sede, e não Me destes de beber;"
,"43":"era estrangeiro, e não Me recebestes em casa; estava sem roupa, e não Me vestistes; estava doente e na prisão, e não Me fostes visitar'."
,"44":"Também estes responderão: 'Senhor, quando foi que Te vimos com fome, ou com sede, como estrangeiro, ou sem roupa, doente ou preso, e não Te servimos?'"
,"45":"Então o Rei responder-lhes-á: 'Eu vos garanto: todas as vezes que não fizestes isto a um destes pequeninos, foi a Mim que não o fizestes'."
,"46":"Portanto, estes irão para o castigo eterno, enquanto os justos irão para vida eterna»."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Tendo Jesus acabado de dizer todas estas palavras, disse aos seus discípulos:"
,"2":"«Sabeis que daqui a dois dias vai ser a festa da Páscoa, e o Filho do Homem será entregue para ser crucificado»."
,"3":"Então os sumos sacerdotes e os anciãos do povo reuniram-se no palácio de Caifás, o sumo sacerdote."
,"4":"Decidiram juntos que prenderiam Jesus com esperteza e O matariam."
,"5":"Mas diziam: «Não vamos fazer isto durante a festa, para que não haja confusão no meio do povo»."
,"6":"Jesus encontrava-Se em Betânia, em casa de Simão, o leproso."
,"7":"Então chegou uma mulher com um vaso de alabastro, cheio de perfume muito precioso. Ela derramou o perfume sobre a cabeça de Jesus, enquanto Ele estava à mesa."
,"8":"Vendo isto, os discípulos ficaram com raiva e disseram: «Porquê este desperdício?"
,"9":"Poderia ser vendido bem caro, para dar o dinheiro aos pobres»."
,"10":"Jesus percebeu e disse: «Porque aborreceis esta mulher? Ela fez-Me uma coisa muito boa."
,"11":"Tereis sempre pobres entre vós, mas Eu não vou estar sempre convosco."
,"12":"Ela derramou este perfume sobre o meu corpo, preparando-Me para a sepultura."
,"13":"Eu vos garanto: por toda a parte onde esta Boa Notícia for pregada, também contarão o que ela fez, e ela será lembrada»."
,"14":"Então um dos Doze, chamado Judas Iscariotes, foi ter com os sumos sacerdotes"
,"15":"e disse: «O que é que me dareis para eu vos entregar Jesus?» Combinaram, então, trinta moedas de prata."
,"16":"E a partir daquele momento, Judas procurava uma boa oportunidade para entregar Jesus."
,"17":"No primeiro dia dos ázimos, os discípulos aproximaram-se de Jesus e perguntaram: «Onde queres que façamos os preparativos para comermos a Páscoa?»"
,"18":"Jesus respondeu: «Ide à cidade, procurai certo homem e dizei-lhe: 'O Mestre manda dizer: O meu tempo está próximo, Eu vou celebrar a Páscoa em tua casa, com os meus discípulos'»."
,"19":"Os discípulos fizeram como Jesus mandou e prepararam a Páscoa."
,"20":"Ao cair da tarde, Jesus pôs-Se à mesa com os doze discípulos."
,"21":"Enquanto comiam, Jesus disse: «Eu vos garanto: um de vós vai trair-Me»."
,"22":"Eles ficaram muito tristes e, um por um, começaram a perguntar-Lhe: «Senhor, serei eu?»"
,"23":"Jesus respondeu: «Quem Me vai trair é aquele que mete comigo a mão no prato."
,"24":"O Filho do Homem vai morrer, conforme está escrito a respeito d'Ele. Porém, ai daquele que trair o Filho do Homem. Seria melhor que nunca tivesse nascido!»"
,"25":"Então Judas, o traidor, perguntou: «Mestre, serei eu?» Jesus respondeu-lhe: «É como acabas de dizer»."
,"26":"Enquanto comiam, Jesus tomou um pão e, tendo pronunciado a bênção, partiu-o, distribuiu-o aos discípulos e disse: «Tomai e comei, isto é o meu corpo»."
,"27":"Em seguida, tomou um cálice, deu graças e deu-lho, dizendo: «Bebei dele todos,"
,"28":"pois isto é o meu sangue, o sangue da aliança, que é derramado em favor de muitos, para a remissão dos pecados."
,"29":"Eu digo-vos: de hoje em diante não beberei deste produto da videira, até ao dia em que beberei o vinho novo convosco no reino de meu Pai»."
,"30":"Depois de terem cantado salmos, foram para o monte das Oliveiras."
,"31":"Então Jesus disse aos discípulos: «Esta noite todos ireis ficar desorientados por minha causa, porque a Escritura diz: 'Ferirei o pastor, e as ovelhas do rebanho dispersar-se-ão'."
,"32":"Mas depois de ressuscitar, irei à vossa frente para a Galileia»."
,"33":"Pedro disse a Jesus: «Ainda que todos fiquem desorientados por tua causa, eu jamais ficarei»."
,"34":"Jesus declarou: «Eu te garanto: esta noite, antes que o galo cante, negar-Me-ás três vezes»."
,"35":"Pedro respondeu: «Ainda que eu tenha de morrer contigo, mesmo assim não Te negarei». E todos os discípulos disseram a mesma coisa."
,"36":"Então Jesus foi com eles para um lugar chamado Getsémani. E disse aos discípulos: «Sentai-vos aqui, enquanto Eu vou até ali para rezar»."
,"37":"Jesus levou consigo Pedro e os dois filhos de Zebedeu e começou a ficar triste e angustiado."
,"38":"Então disse-lhes: «A minha alma está numa tristeza de morte. Ficai aqui e vigiai comigo»."
,"39":"Jesus foi um pouco mais adiante, prostrou-Se com o rosto por terra e rezou: «Meu Pai, se é possível, afaste-se de Mim este cálice. Contudo, não seja feito como Eu quero, mas como Tu queres»."
,"40":"Voltando para junto dos discípulos, Jesus encontrou-os a dormir. Disse a Pedro: «Nem sequer pudeste vigiar uma hora comigo?"
,"41":"Vigiai e orai, para não cairdes em tentação, porque o espírito está pronto mas a carne é fraca»."
,"42":"Jesus afastou-Se pela segunda vez e rezou: «Meu Pai, se este cálice não pode passar sem que Eu o beba, seja feita a tua vontade!»"
,"43":"Voltou de novo e encontrou os discípulos a dormir, porque os seus olhos estavam pesados de sono."
,"44":"Deixando-os, Jesus afastou-Se e rezou pela terceira vez, repetindo as mesmas palavras."
,"45":"Então voltou para junto dos discípulos e disse: «Agora podeis dormir e descansar. Já se aproxima a hora: o Filho do Homem vai ser entregue ao poder dos pecadores."
,"46":"Levantai-vos! Vamos! Aquele que Me vai trair já está a chegar»."
,"47":"Jesus falava ainda, quando chegou Judas, um dos Doze, com uma grande multidão armada de espadas e paus. Iam da parte dos sumos sacerdotes e dos anciãos do povo."
,"48":"O traidor tinha combinado com eles um sinal, dizendo: «Jesus é aquele que eu beijar; prendei-O»."
,"49":"Judas aproximou-se imediatamente de Jesus, e disse: «Salve, Mestre». E beijou-O."
,"50":"Jesus disse-lhe: «Amigo, faz já o que tens a fazer». Então os outros avançaram, lançaram as mãos sobre Jesus e prenderam-n'O."
,"51":"Nesse momento, um dos que estavam com Jesus estendeu a mão, puxou da espada e feriu um empregado do sumo sacerdote, cortando-lhe a orelha."
,"52":"Jesus, porém, disse-lhe: «Guarda a espada na bainha. Pois todos os que usam a espada, pela espada morrerão."
,"53":"Ou pensas que Eu não poderia pedir socorro ao meu Pai? Ele mandar-Me-ia logo mais de doze legiões de anjos."
,"54":"E, então, como se cumpririam as Escrituras, que dizem que isto deve acontecer?»"
,"55":"Então Jesus disse às multidões: «Saístes com espadas e paus para Me prender, como se Eu fosse um bandido. Todos os dias, no Templo, Me sentava para ensinar, e não Me prendestes»."
,"56":"Porém, tudo isto aconteceu para se cumprir o que os profetas escreveram. Então todos os discípulos, abandonando Jesus, fugiram."
,"57":"Aqueles que prenderam Jesus levaram-n'O a casa do sumo sacerdote Caifás, onde os doutores da Lei e os anciãos estavam reunidos."
,"58":"Pedro seguiu Jesus de longe, até ao pátio da casa do sumo sacerdote. Entrou e sentou-se com os guardas, para ver como terminaria tudo aquilo."
,"59":"Ora, os sumos sacerdotes e todo o Sinédrio procuravam algum falso testemunho contra Jesus, a fim de O condenarem à morte."
,"60":"E nada encontraram, embora se apresentassem muitas falsas testemunhas. Por fim, apresentaram-se duas testemunhas"
,"61":"e afirmaram: «Este homem declarou: 'Posso destruir o Templo de Deus e reconstruí-lo de novo em três dias'»."
,"62":"Então o sumo sacerdote levantou-se e perguntou a Jesus: «Nada tens a responder ao que estes testemunham contra Ti?»"
,"63":"Mas Jesus continuou calado. E o sumo sacerdote disse: «Eu te conjuro pelo Deus vivo que nos digas se Tu és o Messias, o Filho de Deus»."
,"64":"Jesus respondeu: «É como acabaste de dizer. Além disso, Eu digo-vos: de agora em diante, vereis o Filho do Homem sentado à direita do Todo-poderoso e vindo sobre as nuvens do céu»."
,"65":"Então o sumo sacerdote rasgou as próprias vestes e disse: «Blasfemou! Que necessidade temos ainda de testemunhas? Pois agora mesmo acabais de ouvir uma blasfémia."
,"66":"Que vos parece?» Responderam: «É réu de morte!»"
,"67":"Então cuspiram no rosto de Jesus e esbofetearam-n'O. Outros deram-Lhe bordoadas,"
,"68":"dizendo: «Adivinha, ó Messias, quem foi que Te bateu?»"
,"69":"Pedro estava sentado fora, no pátio. Uma criada chegou perto dele e disse: «Tu também estavas com Jesus, o galileu!»"
,"70":"Mas Pedro negou diante de todos: «Não sei o que estás a dizer»."
,"71":"E saiu para a entrada do pátio. Então outra criada viu Pedro e disse aos que ali estavam: «Este também estava com Jesus, o Nazareno»."
,"72":"Pedro negou outra vez, jurando: «Nem conheço esse homem!»"
,"73":"Pouco depois, os que ali estavam aproximaram-se de Pedro e disseram: «É claro que também és um deles, pois o teu modo de falar denuncia-te»."
,"74":"Então Pedro começou a maldizer e a jurar, dizendo: «Nem conheço esse homem!» Nesse instante, o galo cantou."
,"75":"Pedro lembrou-se então do que Jesus tinha dito: «Antes de o galo cantar, negar-Me-ás três vezes». E, saindo, chorou amargamente."
}`)
	CurrentBook.AddChapter(27, `{
"1":"De manhã cedo, todos os sumos sacerdotes e os anciãos do povo convocaram um conselho contra Jesus, para O condenarem à morte."
,"2":"Eles amarraram-n'O e levaram-n'O a Pilatos, o governador."
,"3":"Então Judas, o traidor, ao ver que Jesus fora condenado, sentiu remorso e foi devolver as trinta moedas de prata aos sumos sacerdotes e anciãos,"
,"4":"dizendo: «Pequei, entregando à morte sangue inocente». Eles responderam: «E o que é que nós temos a ver com isso? O problema é teu»."
,"5":"Judas atirou as moedas para o santuário, saiu e foi enforcar-se."
,"6":"Recolhendo as moedas, os sumos sacerdotes disseram: «É contra a Lei colocá-las no tesouro do Templo, porque é preço de sangue»."
,"7":"Então discutiram em conselho, e deram-nas em troca pelo Campo do Oleiro, para lá fazerem o cemitério dos estrangeiros."
,"8":"É por isso que esse campo até hoje é chamado «Campo de Sangue»."
,"9":"Assim se cumpriu o que tinha dito o profeta Jeremias: «Tomaram as trinta moedas de prata - preço com que os israelitas O avaliaram -"
,"10":"e deram-nas em troca pelo Campo do Oleiro, conforme o Senhor me ordenou»."
,"11":"Jesus foi posto diante do governador, que Lhe perguntou: «Tu és o rei dos judeus?» Jesus declarou: «Tu o dizes»."
,"12":"E nada respondeu quando foi acusado pelos sumos sacerdotes e anciãos."
,"13":"Então Pilatos perguntou: «Não ouves de quantas coisas eles Te acusam?»"
,"14":"Mas Jesus não respondeu uma só palavra, e o governador ficou vivamente impressionado."
,"15":"Na festa da Páscoa, o governador costumava soltar o prisioneiro que a multidão quisesse."
,"16":"Nessa ocasião tinham um prisioneiro famoso, chamado Barrabás."
,"17":"Então Pilatos perguntou à multidão reunida: «Quem quereis que eu solte: Barrabás, ou Jesus, chamado Messias?»"
,"18":"De facto, Pilatos bem sabia que eles haviam entregado Jesus por inveja."
,"19":"Enquanto Pilatos estava sentado no tribunal, a sua mulher mandou dizer-lhe: «Não te envolvas com esse justo, porque esta noite, em sonhos, sofri muito por causa d'Ele»."
,"20":"Porém os sumos sacerdotes e os anciãos convenceram as multidões para que pedissem Barrabás e fizessem morrer Jesus."
,"21":"O governador tornou a perguntar: «Qual dos dois quereis que eu solte?» Eles gritaram: «Barrabás»."
,"22":"Pilatos perguntou: «E o que vou fazer com Jesus, chamado Messias?» Todos gritaram: «Seja crucificado!»"
,"23":"Pilatos insistiu: «Mas que mal fez Ele?» Eles, porém, gritaram com mais força: «Seja crucificado!»"
,"24":"Pilatos viu que nada conseguia e que poderia haver uma revolta. Então mandou trazer água, lavou as mãos diante da multidão e disse: «Eu não sou responsável pelo sangue deste homem. É um problema vosso»."
,"25":"Todo o povo respondeu: «Que o seu sangue caia sobre nós e sobre os nossos filhos»."
,"26":"Então Pilatos soltou Barrabás, mandou flagelar Jesus e entregou-O para ser crucificado."
,"27":"Em seguida, os soldados de Pilatos levaram Jesus ao palácio do governador e reuniram toda a tropa em volta de Jesus."
,"28":"Despiram-n'O e vestiram-Lhe um manto vermelho;"
,"29":"depois teceram uma coroa de espinhos, puseram-Lha sobre a cabeça, e uma vara na mão direita. Então ajoelharam-se diante de Jesus e zombaram d'Ele, dizendo: «Salve, rei dos judeus!»"
,"30":"Cuspiram n'Ele e, com a vara, bateram-Lhe na cabeça."
,"31":"Depois de zombarem de Jesus, tiraram-Lhe o manto vermelho e vestiram-n'O de novo com as suas roupas; daí O levaram para ser crucificado."
,"32":"Quando saíram, encontraram um homem chamado Simão, da cidade de Cirene, e obrigaram-no a levar a cruz de Jesus."
,"33":"E chegaram a um lugar chamado Gólgota, que quer dizer «Lugar da Caveira»."
,"34":"Ali deram-Lhe a beber vinho misturado com fel. Ele provou, mas não quis beber."
,"35":"Depois de O crucificarem, fizeram um sorteio, repartindo entre si as suas vestes."
,"36":"E ficaram ali sentados, a guardá-l'O."
,"37":"Por cima da cabeça de Jesus puseram o motivo da sua condenação: «Este é Jesus, o Rei dos Judeus»."
,"38":"Com Jesus, crucificaram também dois ladrões, um à direita e outro à esquerda."
,"39":"As pessoas que passavam por ali insultavam-n'O meneando a cabeça"
,"40":"e dizendo: «Tu que destruías o Templo e em três dias o reedificavas, salva-te a Ti mesmo! Se és o Filho de Deus, desce da cruz!»"
,"41":"Do mesmo modo, os sumos sacerdotes, com os doutores da Lei e os anciãos, também zombavam de Jesus:"
,"42":"«Salvou os outros e não pode salvar-Se a Si mesmo! Se é o Rei de Israel... desça agora da cruz, e acreditaremos n'Ele."
,"43":"Confiou em Deus; que Deus O livre agora, se é que O ama! Pois Ele disse: Eu sou o Filho de Deus»."
,"44":"Do mesmo modo, também os dois ladrões que foram crucificados com Jesus O insultavam."
,"45":"Desde o meio-dia até às três horas da tarde houve escuridão sobre toda a Terra."
,"46":"Pelas três horas da tarde Jesus deu um forte grito: «Eli, Eli, lamá sabactâni?», isto é: «Meu Deus, meu Deus, porque Me abandonaste?»"
,"47":"Alguns dos que ali estavam, ouvindo isto, disseram: «Está a chamar por Elias!»"
,"48":"E logo um deles correu imediatamente, tomou uma esponja, ensopou-a em vinagre e, colocando-a na ponta de uma vara, dava-Lhe de beber."
,"49":"Outros, porém, disseram: «Deixa, vamos ver se Elias vem salvá-l'O!»."
,"50":"Então Jesus deu outra vez um forte grito e entregou o espírito."
,"51":"Imediatamente a cortina do santuário se rasgou em duas partes, de alto a baixo; a terra tremeu e as rochas fenderam-se."
,"52":"Os túmulos abriram-se e muitos santos falecidos ressuscitaram."
,"53":"Saindo dos túmulos depois da ressurreição de Jesus, apareceram na Cidade Santa e foram vistos por muitas pessoas."
,"54":"O oficial e os soldados que com ele guardavam Jesus, ao notarem o terremoto e tudo o que havia acontecido, ficaram com muito medo e disseram: «De facto, Ele era mesmo Filho de Deus!»"
,"55":"Grande número de mulheres estavam ali, a observar de longe. Elas haviam acompanhado Jesus desde a Galileia, prestando-Lhe serviços."
,"56":"Entre elas estavam Maria Madalena, Maria, mãe de Tiago e de José, e a mãe dos filhos de Zebedeu."
,"57":"Ao entardecer, chegou um homem rico de Arimateia, chamado José, que também se tornara discípulo de Jesus."
,"58":"Ele foi procurar Pilatos e pediu-lhe o corpo de Jesus. Então Pilatos deu ordem para que o cadáver fosse entregue a José."
,"59":"José, tomando o corpo, envolveu-o num lençol limpo,"
,"60":"e colocou-o num túmulo novo, que ele mesmo havia mandado escavar na rocha. Em seguida, rolou uma grande pedra para fechar a entrada do túmulo e retirou-se."
,"61":"Maria Madalena e a outra Maria estavam ali sentadas, em frente do sepulcro."
,"62":"No dia seguinte, um dia depois da Preparação, os sumos sacerdotes e os fariseus foram ter com Pilatos,"
,"63":"e disseram-lhe: «Senhor, lembrámo-nos de que aquele impostor, quando ainda estava vivo, disse: 'Depois de três dias Eu ressuscitarei'."
,"64":"Portanto, manda guardar o sepulcro até ao terceiro dia, para não acontecer que os discípulos venham roubar o corpo e digam ao povo: 'Ele ressuscitou dos mortos!' Então essa última mentira seria pior do que a primeira»."
,"65":"Pilatos respondeu: «Tendes a guarda à vossa disposição: ide e guardai o sepulcro o melhor que puderdes»."
,"66":"Então eles foram manter o sepulcro em segurança: lacraram a pedra e montaram guarda."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Depois do sábado, ao amanhecer do primeiro dia da semana, Maria Madalena e a outra Maria foram ver a sepultura."
,"2":"De repente houve um grande tremor de terra: o anjo do Senhor desceu do Céu e, aproximando-se, retirou a pedra e sentou-se nela."
,"3":"O seu aspecto era como o de um relâmpago e as suas vestes eram brancas como a neve."
,"4":"Os guardas tremeram de medo diante do anjo e ficaram como mortos."
,"5":"Então o anjo disse às mulheres: «Não tenhais medo. Eu sei que procurais Jesus, que foi crucificado."
,"6":"Ele não está aqui. Ressuscitou, como havia dito! Vinde ver o lugar onde Ele estava."
,"7":"Ide depressa contar aos discípulos que Ele ressuscitou dos mortos e que vai à vossa frente para a Galileia. Lá O vereis. É o que tenho a dizer-vos»."
,"8":"As mulheres saíram depressa do túmulo; estavam com medo, mas correram com muita alegria para dar a notícia aos discípulos."
,"9":"De repente, Jesus foi ao encontro delas e disse: «Alegrai-vos!» As mulheres aproximaram-se e ajoelharam-se diante de Jesus, abraçando-Lhe os pés."
,"10":"Então Jesus disse-lhes: «Não tenhais medo. Ide anunciar aos meus irmãos que se dirijam para a Galileia. Lá Me verão»."
,"11":"Quando as mulheres partiram, alguns guardas do túmulo foram à cidade, e comunicaram aos sumos sacerdotes tudo o que havia acontecido."
,"12":"Os sumos sacerdotes reuniram-se com os anciãos e deram uma grande soma de dinheiro aos soldados,"
,"13":"dizendo-lhes: «Dizei que os seus discípulos foram durante a noite e roubaram o corpo, enquanto vós dormíeis."
,"14":"Se o governador vier a saber disto, nós convencê-lo-emos e não precisais de vos preocupar»."
,"15":"Os soldados pegaram no dinheiro e agiram de acordo com as instruções recebidas. E assim, esta mentira espalhou-se entre os judeus, até ao dia de hoje."
,"16":"Os onze discípulos partiram para a Galileia, para o monte que Jesus lhes tinha indicado."
,"17":"Quando viram Jesus, ajoelharam-se diante d'Ele. Mesmo assim, alguns duvidaram."
,"18":"Então Jesus aproximou-Se e disse: «Toda a autoridade Me foi dada no Céu e sobre a Terra."
,"19":"Portanto, ide e fazei com que todos os povos se tornem meus discípulos, baptizando-os em nome do Pai, e do Filho, e do Espírito Santo,"
,"20":"e ensinando-os a observar tudo o que vos ordenei. Eis que Eu estarei convosco todos os dias, até ao fim do mundo»."
}`)

}
func PT_BS_LoadNP1CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Apóstolo de Jesus Cristo por vontade e chamamento de Deus, e o irmão Sóstenes,"
,"2":"à Igreja de Deus que está em Corinto. Dirigimo-nos àqueles que foram santificados em Jesus Cristo e chamados a ser santos, juntamente com todos os que invocam em todo o lugar o nome de nosso Senhor Jesus Cristo, Senhor deles e nosso."
,"3":"Graça e paz vos sejam dadas da parte de Deus nosso Pai e do Senhor Jesus Cristo."
,"4":"Sem cessar, agradeço a Deus por vossa causa, em vista da graça de Deus que vos foi concedida em Jesus Cristo."
,"5":"Pois em Jesus é que recebestes todas as riquezas, tanto da palavra como do conhecimento."
,"6":"Na verdade, o testemunho de Cristo tornou-se firme em vós,"
,"7":"a tal ponto que não vos falta nenhum dom, a vós que esperais a Revelação de nosso Senhor Jesus Cristo."
,"8":"É Ele que também vos fortalecerá até ao fim, para que não sejais acusados no Dia de nosso Senhor Jesus Cristo."
,"9":"O Deus que vos chamou para a comunhão com o seu Filho Jesus Cristo, nosso Senhor, Ele é fiel."
,"10":"Peço-vos, irmãos, em nome de nosso Senhor Jesus Cristo: mantende-vos de acordo uns com os outros, para que não haja divisões. Sede estreitamente unidos no mesmo espírito e no mesmo modo de pensar."
,"11":"Meus irmãos, alguns da casa de Cloé informaram-me que entre vós existem contendas."
,"12":"Eu explico-me. É que uns dizem: «Eu sou de Paulo!» E outros: «Eu sou de Apolo!» E outros mais: «Eu sou de Pedro!» Outros ainda: «Eu sou de Cristo!»"
,"13":"Será que Cristo está dividido? Será que Paulo foi crucificado em vosso favor? Ou será que fostes baptizados em nome de Paulo?"
,"14":"Agradeço a Deus o facto de eu não ter baptizado ninguém de vós, a não ser Crispo e Caio."
,"15":"Portanto, ninguém pode dizer que foi baptizado em meu nome."
,"16":"Ah! Sim. Baptizei também a família de Estéfanas. Fora deles, não me lembro de ter baptizado mais alguém."
,"17":"De facto, Cristo não me enviou a baptizar, mas a anunciar o Evangelho, sem recorrer à sabedoria da linguagem, a fim de que não se torne inútil a cruz de Cristo."
,"18":"Pois a linguagem da cruz é loucura para aqueles que se perdem. Mas, para aqueles que se salvam, para nós, é poder de Deus."
,"19":"Pois a Escritura diz: «Destruirei a sabedoria dos sábios e rejeitarei a inteligência dos inteligentes»."
,"20":"Onde está o sábio? Onde está o homem culto? Onde está o argumentador deste mundo? Porventura Deus não tornou louca a sabedoria deste mundo?"
,"21":"De facto, quando Deus mostrou a sua sabedoria, o mundo não reconheceu a Deus através da sabedoria. Por isso, através da loucura que pregamos, Deus quis salvar os que acreditam."
,"22":"Os judeus pedem sinais e os gregos procuram a sabedoria;"
,"23":"nós, porém, anunciamos Cristo crucificado, escândalo para os judeus e loucura para os pagãos."
,"24":"Mas, para aqueles que são chamados, tanto judeus como gregos, Ele é o Messias, poder de Deus e sabedoria de Deus."
,"25":"A loucura de Deus é mais sábia do que os homens e a fraqueza de Deus é mais forte do que os homens."
,"26":"Portanto, irmãos, vós que recebestes o chamamento de Deus, vede bem quem sois: entre vós não há muitos intelectuais, nem muitos poderosos, nem muitos da alta sociedade."
,"27":"Mas Deus escolheu o que é loucura no mundo, para confundir os sábios; e Deus escolheu o que é fraqueza no mundo, para confundir o que é forte."
,"28":"E aquilo que o mundo despreza, acha vil e diz que não tem valor, foi isso que Deus escolheu para destruir o que o mundo pensa que é importante."
,"29":"Deste modo, nenhuma criatura se pode orgulhar na presença de Deus."
,"30":"Ora, é por iniciativa de Deus que existis em Jesus Cristo, o qual Se tornou para nós sabedoria que vem de Deus, justiça, santificação e libertação,"
,"31":"a fim de que, como diz a Escritura: «Aquele que se gloria, que se glorie no Senhor»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Irmãos, eu mesmo, quando fui ter convosco, não me apresentei com o prestígio da oratória ou da sabedodoria para vos anunciar o mistério de Deus."
,"2":"Entre vós, eu não quis saber outra coisa a não ser Jesus Cristo, e Jesus Cristo crucificado."
,"3":"Estive no meio de vós cheio de fraqueza, receio e tremor;"
,"4":"a minha palavra e a minha pregação não tinham brilho nem artifícios para seduzir os ouvintes, mas a demonstração residia no poder do Espírito,"
,"5":"para que acrediteis, não por causa da sabedoria dos homens, mas por causa do poder de Deus."
,"6":"Na realidade, é aos perfeitos na fé que falamos de uma sabedoria que não foi dada por este mundo, nem pelas autoridades passageiras deste mundo."
,"7":"Ensinamos uma coisa misteriosa e escondida: a sabedoria de Deus, aquela que Ele projectou desde o princípio do mundo para nos levar à sua glória."
,"8":"Nenhuma autoridade do mundo conheceu tal sabedoria, pois se a tivessem conhecido não teriam crucificado o Senhor da glória."
,"9":"Mas, como diz a Escritura: «O que os olhos não viram, os ouvidos não ouviram e o coração do homem não percebeu, foi isso que Deus preparou para aqueles que O amam». Deus, porém, revelou-o a nós pelo Espírito."
,"10":"Pois o Espírito sonda todas as coisas, até mesmo as profundidades de Deus."
,"11":"Quem conhece a fundo a vida íntima do homem é o espírito do homem que nele reside. Da mesma forma, só o Espírito de Deus conhece o que está em Deus."
,"12":"Quanto a nós, não recebemos o espírito do mundo, mas o Espírito que vem de Deus, para conhecermos os dons da graça de Deus."
,"13":"Para falar desses dons, não usamos a linguagem ensinada pela sabedoria humana, mas a linguagem que o Espírito ensina, falando de realidades espirituais em termos espirituais."
,"14":"Fechado em si mesmo, o homem não aceita o que vem do Espírito de Deus. É uma loucura para ele, e não pode compreender, porque são coisas que devem ser avaliadas espiritualmente."
,"15":"Ao contrário, o homem espiritual julga a respeito de tudo, e por ninguém é julgado."
,"16":"Pois, quem conhece o pensamento do Senhor para Lhe dar lições? Nós, porém, temos o pensamento de Cristo."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Quanto a mim, irmãos, não pude falar-vos como a homens perfeitos na fé, mas apenas a uma gente fraca, como a crianças em Cristo."
,"2":"Dei-vos a beber leite, não alimento sólido, pois não o podíeis suportar. Nem mesmo agora podeis,"
,"3":"pois ainda vos deixais levar por instintos egoístas. De facto, se entre vós há invejas e contendas, não será pelo facto de serdes guiados por instintos egoístas e por vos comportardes como qualquer um?"
,"4":"Quando alguém declara: «Eu sou de Paulo», e outro diz: «Eu sou de Apolo», não estareis a comportar-vos como qualquer um?"
,"5":"Quem é Apolo? Quem é Paulo? Apenas servidores, através dos quais fostes levados à fé; cada um deles agiu conforme os dons que o Senhor lhe concedeu."
,"6":"Eu plantei, Apolo regou, mas era Deus que fazia crescer."
,"7":"Assim, aquele que planta não é nada, e aquele que rega também não é nada: só Deus é que conta, pois é Ele quem faz crescer."
,"8":"Aquele que planta e aquele que rega são iguais; e cada um vai receber o seu próprio salário, segundo a medida do seu trabalho."
,"9":"Nós trabalhamos juntos na obra de Deus, mas o campo e a construção de Deus sois vós."
,"10":"Eu, como bom arquitecto, lancei os alicerces conforme o dom que Deus me concedeu; outro constrói por cima do alicerce. Mas cada um veja como constrói!"
,"11":"Ninguém pode colocar um alicerce diferente daquele que já foi posto: Jesus Cristo."
,"12":"Se alguém constrói sobre o alicerce com ouro, prata, pedras preciosas, madeira, feno ou palha,"
,"13":"a obra de cada um ficará em evidência. No dia do julgamento, a obra ficará conhecida, pois o julgamento vai ser através do fogo, e o fogo provará o que vale a obra de cada um."
,"14":"Se a obra construída sobre o alicerce resistir, o operário receberá uma recompensa."
,"15":"Aquele, porém, que tiver a sua obra queimada, perderá a recompensa. Entretanto, o operário salvar-se-á, mas como alguém que escapa de incêndio."
,"16":"Não sabeis que sois templo de Deus e que o Espírito de Deus habita em vós?"
,"17":"Se alguém destrói o templo de Deus, Deus o destruirá. Pois o templo de Deus é santo, e esse templo sois vós."
,"18":"Ninguém se iluda. Se alguém de vós pensa que é sábio segundo os critérios deste mundo, torne-se louco para chegar a ser sábio;"
,"19":"pois a sabedoria deste mundo é loucura diante de Deus. De facto, a Escritura diz: «Deus apanha os sábios na sua própria esperteza»."
,"20":"E ainda: «O Senhor conhece os pensamentos dos sábios e sabe que são um sopro»."
,"21":"Portanto, ninguém coloque o seu orgulho nos homens, pois tudo vos pertence:"
,"22":"Paulo, Apolo, Pedro, o mundo, a vida, a morte, as coisas presentes e as futuras. Tudo é vosso;"
,"23":"mas vós sois de Cristo e Cristo é de Deus."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Que os homens nos considerem como servidores de Cristo e administradores dos mistérios de Deus."
,"2":"Ora, o que se espera dos administradores é que sejam dignos de confiança."
,"3":"Quanto a mim, pouco me importa ser julgado por vós ou por qualquer tribunal humano. Nem eu me julgo a mim mesmo."
,"4":"É verdade que a minha consciência de nada me acusa, mas isso não significa que eu esteja inocente: quem me julga é o Senhor."
,"5":"Ele porá às claras tudo o que se esconde nas trevas e manifestará as intenções dos corações. Então, cada um vai receber de Deus o louvor que lhe corresponde."
,"6":"Irmãos, vós obrigastes-me a aplicar estas verdades a Apolo e a mim. Aprendei a não vos sentirdes superiores por serdes partidários de um contra o outro."
,"7":"Vejamos: em que és mais do que os outros? O que é que possuis que não tenhas recebido?"
,"8":"Já estais ricos e satisfeitos e sentis-vos reis sem nós! Tomara mesmo que vos tivésseis tornado reis; assim nós também poderíamos reinar convosco!"
,"9":"Pelo que vejo, Deus reservou o último lugar para nós que somos Apóstolos, como se estivéssemos condenados à morte, porque nos tornámos espectáculo para o mundo, para os anjos e para os homens!"
,"10":"Nós somos loucos por causa de Cristo; e vós, como sois prudentes em Cristo! Nós somos fracos, vós sois fortes! Vós sois bem considerados, nós somos desprezados!"
,"11":"Até agora passámos fome, sede, frio e maus tratos; não temos lugar certo para morar;"
,"12":"e esgotamo-nos, trabalhando com as nossas próprias mãos. Somos amaldiçoados, e abençoamos; perseguidos, e suportamos;"
,"13":"caluniados, e consolamos. Até hoje somos considerados como o lixo do mundo, o esterco do universo."
,"14":"Não escrevo estas coisas para vos envergonhar, mas para vos chamar a atenção, como se faz com filhos queridos."
,"15":"De facto, ainda que tivésseis dez mil pedagogos em Cristo, não teríeis muitos pais, porque fui eu quem vos gerou em Jesus Cristo, através do Evangelho."
,"16":"Portanto, dou-vos um conselho: sede meus imitadores."
,"17":"Foi para isso que vos enviei Timóteo, meu filho amado e fiel no Senhor; ele fará com que vos lembreis das minhas normas de vida em Jesus Cristo, aquelas mesmas que eu ensino por toda a parte, em todas as Igrejas."
,"18":"Alguns encheram-se de orgulho, como se eu nunca mais fosse visitar-vos."
,"19":"Contudo, se o Senhor quiser, brevemente irei ter convosco, e então verei não o que esses orgulhosos dizem, mas o que fazem."
,"20":"Pois o Reino de Deus não consiste em palavras, mas em poder."
,"21":"Que preferis: que vos visite com a vara, ou com amor e suavidade?"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todos dizem que entre vós existe imoralidade, e tal imoralidade que não se encontra nem mesmo entre os pagãos, a ponto de uma pessoa conviver com a mulher do seu pai."
,"2":"E vós encheis-vos de orgulho em vez de ficardes tristes, para que o autor desse mal seja eliminado do meio de vós."
,"3":"Pois bem! Ausente de corpo, mas presente em espírito, como se estivesse presente, eu já fiz o julgamento daquele que fez isso."
,"4":"Em nome de nosso Senhor Jesus, vós e o meu espírito reunidos em assembleia com o poder de nosso Senhor Jesus,"
,"5":"vamos entregar esse homem a Satanás; humanamente ele ficará arrasado, mas o seu espírito será salvo no dia do Senhor."
,"6":"O motivo do orgulho que tendes não é coisa digna! Não sabeis que um pouco de fermento leveda a massa toda?"
,"7":"Purificai-vos do velho fermento, para serdes massa nova, já que sois sem fermento. De facto, Cristo, nossa páscoa, foi imolado."
,"8":"Portanto, celebremos a festa, não com o velho fermento, nem com fermento de malícia e perversidade, mas com pães sem fermento, isto é, na sinceridade e na verdade."
,"9":"Na minha carta, escrevi-vos para não vos relacionardes com gente imoral."
,"10":"Não quis dizer que devíeis separar-vos dos imorais deste mundo, ou dos avarentos, ladrões e idólatras; se assim fosse teríeis que sair deste mundo!"
,"11":"Não! Escrevi que não deveis associar-vos com alguém que traz o nome de irmão, e no entanto é imoral, avarento, idólatra, caluniador, beberrão ou ladrão. Com pessoas assim, não deveis nem sequer sentar-vos à mesa."
,"12":"Porventura, compete a mim julgar aqueles que estão fora? Não são os de dentro que deveis julgar?"
,"13":"Deus é quem vai julgar os que estão fora. Afastai do meio de vós o homem mau."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Quando alguém de vós tem uma questão com outro, como ousais levar o caso para ser julgado pelos pagãos e não pelos membros da comunidade?"
,"2":"Então vós não sabeis que os cristãos é que vão julgar o mundo? E se é por vós que o mundo vai ser julgado, sereis vós indignos de julgar coisas menos importantes?"
,"3":"Não sabeis que nós haveremos de julgar os anjos? Quanto mais as coisas da vida quotidiana!"
,"4":"No entanto, quando tendes processos desta vida para serem julgados, tomais como juízes pessoas que não têm autoridade na Igreja."
,"5":"Digo isto para que vos envergonheis. Será que entre vós não existe ninguém suficientemente sábio para servir de juiz entre os irmãos?"
,"6":"No entanto, um irmão é intimado em juízo por outro irmão, e isto diante de infiéis!"
,"7":"Só o facto de existirem questões entre vós já mostra que falhastes completamente. Não seria melhor sofrer uma injustiça? Não seria melhor ser roubado?"
,"8":"Pelo contrário, sois vós que roubais e cometeis injustiça; e isto com os próprios irmãos!"
,"9":"Não sabeis que os injustos não herdarão o Reino de Deus? Não vos iludais! Nem os imorais, nem os idólatras, nem os adúlteros, nem os depravados,"
,"10":"nem os efeminados, nem os sodomitas, nem os ladrões, nem os avarentos, nem os bêbados, nem os caluniadores irão herdar o Reino de Deus."
,"11":"Alguns de vós eram assim. Mas lavastes-vos, fostes santificados e reabilitados pelo Nome do Senhor Jesus Cristo e pelo Espírito do nosso Deus."
,"12":"«Posso fazer tudo o que quero». Sim, mas nem tudo me convém. «Posso fazer tudo o que quero», mas não deixarei que nada me escravize."
,"13":"«Os alimentos são para o estômago e o estômago para os alimentos». Sim, mas Deus destruirá tanto aquele como estes. Ora, o corpo não é para a imoralidade mas para o Senhor; e o Senhor é para o corpo."
,"14":"Deus, que ressuscitou o Senhor, ressuscitar-nos-á também pelo seu poder."
,"15":"Não sabeis que os vossos corpos são membros de Cristo? Tomarei, então, os membros de Cristo para os fazer membros de uma prostituta? Claro que não!"
,"16":"E vós não sabeis que aquele que se une a uma prostituta forma com ela um só corpo? Pois assim está na Escritura: «Os dois serão uma só carne»."
,"17":"Ao contrário, aquele que se une ao Senhor forma com Ele um só espírito."
,"18":"Fugi da imoralidade. Qualquer outro pecado que o homem comete é exterior ao seu corpo; mas quem se entrega à imoralidade peca contra o seu próprio corpo."
,"19":"Ou não sabeis que o vosso corpo é templo do Espírito Santo, que está em vós e vos foi dado por Deus? Vós já não pertenceis a vós mesmos."
,"20":"Alguém pagou alto preço pelo vosso resgate. Portanto, glorificai a Deus no vosso corpo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Passemos agora ao que me escrevestes: «É bom que o homem se abstenha de mulher»."
,"2":"Todavia, para evitar a imoralidade, cada homem tenha a sua esposa, e cada mulher o seu marido."
,"3":"O marido cumpra o dever conjugal para com a esposa, e a esposa faça o mesmo com o marido."
,"4":"A esposa não é dona do seu próprio corpo, mas sim o marido. Do mesmo modo, o marido não é dono do seu próprio corpo, mas sim a esposa."
,"5":"Não se recusem um ao outro, a não ser que estejam de comum acordo e por algum tempo, para se entregarem à oração; depois disso, voltem a unir-se, a fim de que Satanás não os tente por não poderem dominar-se."
,"6":"Digo isto como concessão, e não como ordem."
,"7":"Eu gostaria que todos os homens fossem como eu. Mas cada um recebe de Deus o seu dom particular; um tem este dom, e outro tem aquele."
,"8":"Aos solteiros e às viúvas, digo que seria melhor que ficassem como eu."
,"9":"Mas, se não são capazes de dominar os seus desejos, então casem-se, pois é melhor casar-se do que ficar abrasado."
,"10":"Aos que estão casados, ordeno. Aliás, não eu, mas o Senhor: a esposa não se separe do marido;"
,"11":"e caso venham a separar-se, não se case de novo, ou então reconcilie-se com o marido. E o marido não se divorcie da sua esposa."
,"12":"Aos outros, sou eu que digo, não o Senhor: Se algum irmão tem esposa que não é cristã, e ela concorda em viverem juntos, não se divorcie dela."
,"13":"E se alguma mulher tem marido que não é cristão, e ele concorda em viverem juntos, não se divorcie dele."
,"14":"Pois o marido não cristão é santificado pela esposa cristã; e a esposa não cristã é santificada pelo marido cristão. Se assim não fosse, os seus filhos seriam impuros, quando na realidade são consagrados a Deus."
,"15":"Se o não cristão quiser separar-se, que se separe. Nesse caso, o irmão ou irmã não estão vinculados, pois foi para viver em paz que Deus nos chamou."
,"16":"Na verdade, ó mulher, como podes ter a certeza de que salvarás o teu marido? E tu, marido, como podes saber que salvarás a tua mulher?"
,"17":"De resto, cada um continue a viver na condição em que o Senhor o colocou, tal como vivia quando foi chamado. É o que ordeno em todas as Igrejas."
,"18":"Alguém foi chamado à fé quando já era circuncidado? Não procure disfarçar a sua circuncisão. Alguém não era circuncidado quando foi chamado à fé? Não se faça circuncidar."
,"19":"Não tem nenhuma importância estar ou não estar circuncidado. O que importa é observar os mandamentos de Deus."
,"20":"Cada um permaneça na condição em que se encontrava quando foi chamado."
,"21":"Eras escravo quando foste chamado? Não te preocupes com isso. Mas, se podes tornar-te livre, não deixes passar a oportunidade."
,"22":"Porque o escravo, que foi chamado no Senhor, é liberto no Senhor. Da mesma forma, aquele que era livre quando foi chamado, é escravo de Cristo."
,"23":"Alguém pagou alto preço pelo vosso resgate: não vos torneis escravos de homens."
,"24":"Irmãos, cada um permaneça diante de Deus na condição em que se encontrava quando foi chamado."
,"25":"Quanto às pessoas virgens, não tenho nenhum preceito do Senhor. Porém, como homem que pela misericórdia do Senhor é digno de confiança, dou apenas um conselho:"
,"26":"considero boa a condição das pessoas virgens, por causa das angústias presentes. Claro, é bom que o homem continue assim."
,"27":"Estás ligado a uma mulher? Não te separes. Não estás ligado a uma mulher? Não procures mulher."
,"28":"Contudo, se casares, não estarás a cometer pecado; e se uma virgem se casar, não comete pecado. No entanto essas pessoas terão que suportar fardos pesados, e eu desejaria poupar-vos."
,"29":"Uma coisa vos digo, irmãos: o tempo tornou-se breve. De agora em diante, aqueles que têm esposa comportem-se como se não a tivessem;"
,"30":"aqueles que choram, como se não chorassem; aqueles que se alegram, como se não se alegrassem; aqueles que compram, como se não possuíssem;"
,"31":"os que tiram partido deste mundo, como se não desfrutassem. Porque a aparência deste mundo é passageira."
,"32":"Eu gostaria que estivésseis livres de preocupações. Quem não tem esposa, cuida das coisas do Senhor e do modo de agradar ao Senhor."
,"33":"Quem tem esposa, cuida das coisas do mundo e de como agradar à esposa,"
,"34":"e fica dividido. Assim também, a mulher solteira e a virgem cuidam das coisas do Senhor, a fim de serem santas de corpo e espírito. Mas a mulher casada cuida das coisas do mundo e de como possa agradar ao marido."
,"35":"Digo isto para o vosso bem, não para armar uma cilada; simplesmente para que façais o que é mais nobre e possais permanecer sem distracção junto do Senhor."
,"36":"Se alguém, transbordando de paixão, acha que não conseguirá respeitar a noiva, e que as coisas devem seguir o seu curso, faça o que quiser. Não peca; que se casem."
,"37":"Ao contrário, se alguém, por firme convicção, sem constrangimento e no pleno uso da sua vontade, resolve respeitar a sua noiva, está agindo bem."
,"38":"Portanto, quem se casa com a sua noiva faz bem; e quem não se casa, procede melhor ainda."
,"39":"A esposa está ligada ao marido durante todo o tempo em que ele viver. Se o marido morrer, ela ficará livre para casar-se com quem quiser; mas apenas no Senhor."
,"40":"A meu ver, porém, ela será mais feliz se ficar como está. Penso que eu também possuo o Espírito de Deus."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quanto às carnes sacrificadas a ídolos, «sabemos que todos nós temos conhecimento». Mas o conhecimento envaidece; o amor é que constrói."
,"2":"Quando alguém julga ter alcançado o saber, é porque ainda não sabe onde está o verdadeiro conhecimento."
,"3":"Ao contrário, se alguém ama a Deus, é conhecido por Deus."
,"4":"Portanto, quanto ao consumo de carnes imoladas a ídolos, «sabemos que um ídolo não é nada no mundo, e não existe outro deus a não ser o Deus único»."
,"5":"É verdade que existem aqueles que são chamados deuses, tanto no céu como na terra, e neste sentido há muitos deuses e muitos senhores."
,"6":"Contudo para nós existe um só Deus: o Pai. D'Ele tudo procede, e é para Ele que existimos. E há um só Senhor, Jesus Cristo, por quem tudo existe e por meio do qual também nós existimos."
,"7":"Mas nem todos têm esse conhecimento. Alguns, até há pouco acostumados ao culto dos ídolos, comem a carne dos sacrifícios como se fosse realmente oferecida aos ídolos. E a consciência deles, que é fraca, fica manchada."
,"8":"Não são os alimentos que nos aproximam de Deus: se deixamos de comer, nada perdemos; e se comemos, nada lucramos."
,"9":"Cuidai, porém, que a vossa liberdade não se torne ocasião de queda para os fracos."
,"10":"Tu tens a consciência esclarecida: mas alguém te vê sentado à mesa num templo de ídolo, será que esse alguém, tendo consciência fraca, não se verá arrastado a comer carne sacrificada aos ídolos?"
,"11":"Deste modo, por causa do conhecimento que tendes, perecerá o fraco, esse irmão pelo qual Cristo morreu."
,"12":"Se pecais assim contra os próprios irmãos e feris a consciência deles, que é fraca, é contra Cristo que pecais."
,"13":"Ora, se um alimento for motivo de queda para o meu irmão, deixarei de comer carne para sempre, a fim de não causar a queda do meu irmão."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Acaso não sou livre? Não sou Apóstolo? Não vi Jesus nosso Senhor? E vós não sois obra minha no Senhor?"
,"2":"Ainda que para outros eu não seja Apóstolo, ao menos para vós eu sou-o; porque o selo no meu apostolado no Senhor sois vós."
,"3":"Esta é a minha resposta para aqueles que me acusam."
,"4":"Será que não temos o direito de comer e beber?"
,"5":"Ou não temos o direito de levar connosco nas viagens uma mulher cristã, como fazem os outros Apóstolos e os irmãos do Senhor, e Pedro?"
,"6":"Ou somente eu e Barnabé não temos o direito de ser dispensados de trabalhar?"
,"7":"Alguém vai à guerra alguma vez, com os seus próprios recursos? Quem é que planta uma vinha, e não come do seu fruto? Quem apascenta um rebanho, e não se alimenta do leite do rebanho?"
,"8":"Será que estou dizendo isto apenas como considerações humanas? E a Lei, não diz a mesma coisa?"
,"9":"De facto, na Lei de Moisés está escrito: «Não açaimarás o boi que debulha o grão». Por acaso, é com os bois que Deus Se preocupa?"
,"10":"Não será por causa de nós que Ele fala assim? Claro que é por causa de nós que isto foi escrito. De facto, aquele que trabalha deve trabalhar com esperança de receber a sua parte."
,"11":"Se semeamos bens espirituais em vós, será muito colher bens materiais de vós?"
,"12":"Se outros exercem sobre vós tal direito, porque não o poderíamos nós, e com maior razão? Todavia, não usamos esse direito. Pelo contrário, tudo suportamos para não criar obstáculo ao Evangelho de Cristo."
,"13":"Não sabeis que aqueles que desempenham funções sagradas vivem dos rendimentos do templo? E que aqueles que servem ao altar têm parte no que é oferecido sobre o altar?"
,"14":"Da mesma forma, o Senhor ordenou que aqueles que anunciam o Evangelho vivam do Evangelho."
,"15":"Contudo, não tirei vantagem dos meus direitos. E agora não estou a escrever para reclamar coisa alguma. Antes morrer que... Não! Ninguém me tirará este título de glória."
,"16":"Anunciar o Evangelho não é título de glória para mim; pelo contrário, é uma necessidade que me foi imposta. Ai de mim, se eu não anunciar o Evangelho!"
,"17":"Se eu o anunciasse de própria iniciativa, teria direito a um salário; no entanto, já que o faço por obrigação, desempenho um cargo que me foi confiado."
,"18":"Qual é então o meu salário? É que, pregando o Evangelho, prego-o gratuitamente, sem usar dos direitos que a pregação do Evangelho me confere."
,"19":"Embora eu seja livre em relação a todos, tornei-me o servo de todos, a fim de ganhar o maior número possível."
,"20":"Com os judeus, comportei-me como judeu, a fim de ganhar os judeus; com os que estão sujeitos à Lei, comportei-me como se estivesse sujeito à Lei - embora eu não esteja sujeito à Lei -, a fim de ganhar aqueles que estão sujeitos à Lei."
,"21":"Com aqueles que vivem sem a Lei, comportei-me como se vivesse sem a Lei, - embora eu não viva sem a lei de Deus, pois estou sob a lei de Cristo -, para ganhar aqueles que vivem sem a Lei."
,"22":"Com os fracos, tornei-me fraco, a fim de ganhar os fracos. Tornei-me tudo para todos, a fim de salvar alguns a qualquer custo."
,"23":"Faço tudo isto por causa do Evangelho, para me tornar participante dele."
,"24":"Não sabeis que no estádio todos os atletas correm, mas só um ganha o prémio? Portanto, correi, para conseguir o prémio."
,"25":"Os atletas abstêm-se de tudo; eles, para ganhar uma coroa perecível; nós, para ganharmos uma coroa imperecível."
,"26":"Quanto a mim, também eu corro, mas não como quem vai sem rumo. Pratico o pugilato, mas não como quem luta contra o ar."
,"27":"Trato com dureza o meu corpo e submeto-o, para não acontecer que proclame a mensagem aos outros, e eu mesmo venha a ser reprovado."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Irmãos, não quero que ignoreis uma coisa: todos os nossos antepassados estiveram sob a nuvem; todos atravessaram o mar"
,"2":"e, na nuvem e no mar, todos receberam um baptismo que os ligava a Moisés."
,"3":"Todos comeram o mesmo alimento espiritual,"
,"4":"e todos beberam a mesma bebida espiritual, pois bebiam de uma rocha espiritual que os acompanhava; e essa rocha era Cristo."
,"5":"Apesar disso, a maioria deles não agradou a Deus e caíram mortos no deserto."
,"6":"Ora, esses factos aconteceram como exemplo para nós, para que não cobicemos coisas más, como eles cobiçaram."
,"7":"Não vos torneis idólatras, como alguns deles, conforme está na Escritura: «O povo sentou-se para comer e beber; depois levantaram-se para se divertir»."
,"8":"Nem nos entreguemos à imoralidade, como alguns deles se entregaram, de modo que num só dia morreram vinte e três mil."
,"9":"Não tentemos ao Senhor, como alguns deles tentaram, e morreram vitimados pelas serpentes."
,"10":"Não murmureis, como alguns deles murmuraram, e pereceram às mãos do anjo exterminador."
,"11":"Tais coisas aconteceram-lhes como exemplo, e foram escritas para nossa instrução, a nós que vivemos no fim dos tempos."
,"12":"Portanto, aquele que julga estar de pé tome cuidado para não cair."
,"13":"Não fostes tentados além do que podíeis suportar, porque Deus é fiel e não permitirá que sejais tentados acima das vossas forças. Mas, juntamente com a tentação, ele também vos dará os meios de sair dela e a força para a suportar."
,"14":"Por isso, amados, fugi da idolatria."
,"15":"Falo-vos como a pessoas sensatas; julgai vós mesmos o que digo."
,"16":"O cálice da bênção que abençoamos não é comunhão com o sangue de Cristo? O pão que partimos não é comunhão com o corpo de Cristo?"
,"17":"E como há um único pão, nós, embora muitos, somos um só corpo, pois participamos todos desse único pão."
,"18":"Considerai o povo de Israel: quando comem as vítimas sacrificadas, não estão em comunhão com o altar?"
,"19":"E o que quero eu dizer com isto? Que a carne sacrificada aos ídolos seja alguma coisa? Ou que os próprios ídolos sejam alguma coisa?"
,"20":"Não! O que digo é o seguinte: aquilo que os pagãos sacrificam, sacrificam-no aos demónios, e não a Deus. Ora, eu não quero que entreis em comunhão com os demónios."
,"21":"Vós não podeis beber o cálice do Senhor e o cálice dos demónios. Não podeis participar da mesa do Senhor e da mesa dos demónios."
,"22":"Ou queremos provocar o ciúme do Senhor? Seríamos nós mais fortes do que Ele?"
,"23":"«Tudo é permitido». Mas nem tudo convém. «Tudo é permitido». Mas nem tudo edifica."
,"24":"Ninguém procure satisfazer os seus próprios interesses, mas os do próximo."
,"25":"Comei de tudo o que se vende no mercado, sem levantar dúvidas por motivo de consciência,"
,"26":"pois a Terra e tudo o que ela contém pertence ao Senhor."
,"27":"Se algum pagão vos convidar e aceitardes o convite, comei de tudo o que vos for oferecido, sem levantar dúvidas por motivo de consciência."
,"28":"Mas se alguém vos disser: «Isto é carne sacrificada aos ídolos», não comais, por causa daquele que vos avisou e por motivo de consciência."
,"29":"Falo da consciência dele, não da vossa. Por que motivo a minha liberdade deveria ser julgada por outra consciência?"
,"30":"Se eu tomo alimento dando graças, porque seria eu censurado por alguma coisa, pela qual dou graças?"
,"31":"Portanto, quer comais, quer bebais, quer façais qualquer outra coisa, fazei tudo para a glória de Deus."
,"32":"Não vos torneis ocasião de escândalo, nem para judeus, nem para gregos, nem para a Igreja de Deus."
,"33":"Fazei como eu, que me esforço por agradar a todos em todas as coisas, não procurando os meus interesses pessoais, mas o interesse do maior número de pessoas, a fim de que sejam salvas."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Sede meus imitadores, como também eu o sou de Cristo."
,"2":"Elogio-vos, porque em todas as ocasiões vos lembrais de mim, e porque conservais as tradições conforme eu vo-las transmiti."
,"3":"Todavia, quero que saibais que a cabeça de todo o homem é Cristo, que a cabeça da mulher é o homem, e a cabeça de Cristo é Deus."
,"4":"Todo o homem que reza ou profetiza de cabeça coberta, desonra a sua cabeça."
,"5":"Mas, toda a mulher que reza ou profetiza de cabeça descoberta, desonra a sua cabeça; é como se estivesse com a cabeça rapada."
,"6":"Se a mulher não se cobre com o véu, mande cortar os cabelos. Mas, se é vergonhoso para uma mulher ter os cabelos cortados ou rapados, então cubra a cabeça."
,"7":"O homem não deve cobrir a cabeça, porque é a imagem e a glória de Deus; mas a mulher é a glória do homem."
,"8":"Pois o homem não foi tirado da mulher, mas a mulher foi tirada do homem."
,"9":"E o homem não foi criado para a mulher, mas a mulher foi criada para o homem."
,"10":"Sendo assim, a mulher deve trazer sobre a cabeça o sinal da sua dependência, por causa dos anjos."
,"11":"Portanto, diante do Senhor, a mulher é inseparável do homem, e o homem da mulher."
,"12":"Pois, se a mulher foi tirada do homem, o homem nasce da mulher, e tudo vem de Deus."
,"13":"Julgai por vós mesmos: será conveniente que uma mulher reze a Deus sem estar coberta com o véu?"
,"14":"A própria natureza ensina que é desonroso para o homem ter cabelos compridos;"
,"15":"no entanto, para a mulher é glória ter longa cabeleira, porque os cabelos lhe foram dados como véu."
,"16":"Contudo, se alguém quiser contestar, não temos esse costume, e nem as Igrejas de Deus."
,"17":"Dito isto, não posso elogiar-vos, porque as vossas assembleias, em vez de vos ajudarem a progredir, prejudicam-vos."
,"18":"Antes de tudo, ouço dizer que, quando vos reunis em assembleia, há divisões entre vós. E, em parte, acredito nisso."
,"19":"É preciso mesmo que haja divisões entre vós, a fim de que se veja quem dentre vós resiste a essa prova."
,"20":"De facto, quando vos reunis, o que fazeis não é comer a Ceia do Senhor,"
,"21":"porque cada um se apressa a comer a sua própria ceia. E, enquanto um passa fome, outro fica embriagado."
,"22":"Será que não tendes as vossas casas para nelas comer e beber? Ou desprezais a Igreja de Deus e quereis envergonhar aqueles que nada têm? Que devo dizer-vos? Devo elogiar-vos? Não! Neste ponto não vos elogio."
,"23":"De facto, recebi pessoalmente do Senhor aquilo que vos transmiti: Na noite em que foi entregue, o Senhor Jesus tomou o pão"
,"24":"e, depois de dar graças, partiu-o e disse: «Isto é o meu corpo que será entregue por vós; fazei isto em memória de Mim»."
,"25":"Do mesmo modo, depois da Ceia, tomou também o cálice, dizendo: «Este cálice é a Nova Aliança no meu sangue; todas as vezes que beberdes dele, fazei-o em memória de Mim»."
,"26":"Portanto, todas as vezes que comerdes deste pão e beberdes deste cálice, anunciais a morte do Senhor, até que Ele venha."
,"27":"Por isso, todo aquele que comer do pão ou beber do cálice do Senhor indignamente, será réu do corpo e do sangue do Senhor."
,"28":"Portanto, cada um examine-se a si mesmo antes de comer deste pão e beber deste cálice,"
,"29":"pois aquele que come e bebe sem discernir o Corpo, come e bebe a própria condenação."
,"30":"É por isso que entre vós há tantos fracos e enfermos, e muitos morreram."
,"31":"Se nos examinássemos a nós mesmos, não seríamos julgados;"
,"32":"mas o Senhor corrige-nos por meio dos seus julgamentos, para que não sejamos condenados com o mundo."
,"33":"Em resumo, irmãos, quando vos reunirdes para a Ceia, esperai uns pelos outros."
,"34":"Se alguém tem fome, coma em sua casa. Assim não vos reunireis para a vossa própria condenação. Quanto ao resto, darei instruções quando aí chegar."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Sobre os dons do Espírito, irmãos, não quero que fiqueis na ignorância."
,"2":"Sabeis que, quando éreis pagãos, vos sentíeis irresistivelmente arrastados para os ídolos mudos."
,"3":"Por isso, eu declaro-vos que ninguém, falando sob a acção do Espírito de Deus, jamais poderá dizer: «Maldito Jesus!» E ninguém poderá dizer: «Jesus é o Senhor!» a não ser sob a acção do Espírito Santo."
,"4":"Existem dons diferentes, mas o Espírito é o mesmo;"
,"5":"diferentes serviços, mas o Senhor é o mesmo;"
,"6":"diferentes modos de agir, mas é o mesmo Deus que realiza tudo em todos."
,"7":"Cada um recebe o dom de manifestar o Espírito para a utilidade de todos."
,"8":"A um, o Espírito dá a palavra de sabedoria; a outro, a palavra de ciência segundo o mesmo Espírito;"
,"9":"a outro, o mesmo Espírito dá a fé; a outro ainda, o único e mesmo Espírito concede o dom das curas;"
,"10":"a outro, o poder de fazer milagres; a outro, a profecia; a outro, o discernimento dos espíritos; a outro, o dom de falar em línguas; a outro ainda, o dom de as interpretar."
,"11":"Mas é o único e mesmo Espírito quem realiza tudo isto, distribuindo os seus dons a cada um, conforme Ele quer."
,"12":"De facto, o corpo é um só, mas tem muitos membros; e no entanto, apesar de serem muitos, todos os membros do corpo formam um só corpo. Assim acontece também com Cristo."
,"13":"Pois todos fomos baptizados num só Espírito para sermos um só corpo, quer sejamos judeus ou gregos, quer escravos ou livres. E todos bebemos de um só Espírito."
,"14":"O corpo não é feito de um só membro, mas de muitos."
,"15":"Se o pé diz: «Eu não sou mão; logo, não pertenço ao corpo», nem por isso deixa de fazer parte do corpo."
,"16":"E se o ouvido diz: «Eu não sou olho; logo, não pertenço ao corpo», nem por isso deixa de fazer parte do corpo."
,"17":"Se o corpo inteiro fosse olho, onde estaria o ouvido? Se todo ele fosse ouvido, onde estaria o olfacto?"
,"18":"Deus é que dispôs cada um dos membros no corpo, segundo a sua vontade."
,"19":"Se o conjunto fosse um só membro, onde estaria o corpo?"
,"20":"Há, portanto, muitos membros, mas um só corpo."
,"21":"O olho não pode dizer à mão: «Não preciso de ti; e a cabeça não pode dizer aos pés: «Não preciso de vós»."
,"22":"Os membros do Corpo que parecem mais fracos são os mais necessários;"
,"23":"e aqueles membros do corpo que parecem menos dignos de honra, são os que cercamos de maior honra; e os nossos membros que são menos decentes, nós tratamo-los com maior decência;"
,"24":"os que são decentes, não precisam desses cuidados. Deus dispôs o corpo de modo a conceder maior honra ao que é menos nobre,"
,"25":"a fim de que não haja divisão no corpo, mas os membros tenham igual cuidado uns para com os outros."
,"26":"Se um membro sofre, todos os membros participam do seu sofrimento; se um membro é honrado, todos os membros participam da sua alegria."
,"27":"Ora, vós sois o corpo de Cristo e sois seus membros, cada um no seu lugar."
,"28":"Aqueles que Deus estabeleceu na Igreja são, em primeiro lugar, Apóstolos; em segundo lugar, profetas; em terceiro lugar, mestres... A seguir vêm os dons dos milagres, das curas, da assistência, da direcção e o dom de falar em línguas."
,"29":"Acaso, são todos Apóstolos? Todos profetas? Todos mestres? Todos realizam milagres?"
,"30":"Têm todos o dom de curar? Todos falam línguas? Todos as interpretam?"
,"31":"Aspirai aos dons mais altos. Aliás, vou indicar-vos um caminho que ultrapassa a todos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Ainda que eu falasse línguas, as dos homens e dos anjos, se não tivesse amor, seria como sino ruidoso,ou como címbalo estridente."
,"2":"Ainda que tivesse o dom,da profecia, o conhecimento de todos,os mistérios e de toda a ciência; ainda que tivesse toda a fé, a ponto de transportar montanhas, se não tivesse amor, nada seria."
,"3":"Ainda que eu distribuísse,todos os meus bens aos famintos, ainda que entregasse,o meu corpo às chamas, se não tivesse amor, nada disso me adiantaria."
,"4":"O amor é paciente, o amor é prestativo; não é invejoso, não se ostenta, não se incha de orgulho."
,"5":"Nada faz de inconveniente, não procura o seu próprio interesse, não se irrita, não guarda rancor."
,"6":"Não se alegra com a injustiça, mas regozija-se com a verdade."
,"7":"Tudo desculpa, tudo crê, tudo espera, tudo suporta."
,"8":"O amor jamais passará. As profecias desaparecerão, as línguas cessarão, a ciência também desaparecerá."
,"9":"Pois o nosso conhecimento,é limitado; limitada é também a nossa profecia."
,"10":"Mas, quando vier a perfeição, desaparecerá o que é limitado."
,"11":"Quando eu era criança, falava como criança, pensava como criança, raciocinava como criança. Depois que me tornei adulto, deixei o que era próprio de criança."
,"12":"Agora vemos como em espelho,e de maneira confusa; mas depois veremos face a face. Agora o meu conhecimento,é limitado, mas depois conhecerei,como sou conhecido."
,"13":"Agora, portanto, permanecem estas três coisas: a fé, a esperança e o amor. A maior delas, porém, é o amor."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Procurai o amor. Entretanto, aspirai aos dons do Espírito, principalmente à profecia."
,"2":"Pois aquele que fala línguas não fala aos homens, mas a Deus. Ninguém o entende, pois ele, em espírito, diz coisas incompreensíveis."
,"3":"Mas aquele que profetiza fala aos homens: edifica, exorta, consola."
,"4":"Aquele que fala línguas edifica-se a si mesmo, ao passo que aquele que profetiza edifica a assembleia."
,"5":"Eu desejo que todos vós faleis línguas, mas prefiro que profetizeis. Aquele que profetiza é maior do que aquele que fala línguas, a menos que ele mesmo as interprete, para que a assembleia seja edificada."
,"6":"Suponde, irmãos, que eu vá ter convosco falando em línguas: como vos seria útil, se a minha palavra não vos levasse nem revelação, nem ciência, nem profecia, nem ensinamento?"
,"7":"O mesmo acontece com os instrumentos musicais, como a flauta ou a cítara: se não produzirem sons distintos, como reconhecer quem toca a flauta ou quem toca a cítara?"
,"8":"E se a trombeta produzir um som confuso, quem se preparará para a guerra?"
,"9":"Assim também vós: se a vossa linguagem não se exprime em palavras inteligíveis, como se poderá compreender o que dizeis? Sereis como quem fala ao vento."
,"10":"No mundo existem não sei quantas espécies de linguagem e não existe nada sem linguagem."
,"11":"Ora, se eu não conheço a força da linguagem, serei como estrangeiro para aquele que fala, e aquele que fala será um estrangeiro para mim."
,"12":"Assim também vós: já que aspirais aos dons do Espírito, procurai tê-los em abundância para edificardes a Igreja."
,"13":"Por isso, aquele que fala em línguas deve rezar para que ele mesmo possa interpretá-las."
,"14":"Se rezo em línguas, o meu espírito está em oração, mas a minha inteligência não colhe fruto nenhum."
,"15":"O que fazer então? Rezarei com o meu espírito, mas rezarei também com a minha inteligência; cantarei com o meu espírito, mas cantarei também com a minha inteligência."
,"16":"De facto, se é apenas com o teu espírito que dás graças a Deus, como poderá o ouvinte não iniciado dizer «Ámen» ao agradecimento que fazes, uma vez que ele não sabe o que dizes?"
,"17":"A acção de graças que fazes é sem dúvida valiosa, mas o outro não se edifica."
,"18":"Agradeço a Deus por falar em línguas mais do que todos vós."
,"19":"Numa assembleia, porém, prefiro dizer cinco palavras com a minha inteligência para instruir também os outros, que dizer dez mil palavras em línguas."
,"20":"Irmãos, não sejais crianças quanto ao modo de julgar; sede crianças quanto à malícia, mas quanto ao modo de julgar sede adultos."
,"21":"Está escrito na Lei: «Falarei a este povo por meio de homens de outra língua e por meio de lábios estrangeiros, e mesmo assim eles não me escutarão, diz o Senhor»."
,"22":"Portanto, as línguas são um sinal, não para os que acreditam, mas para os que não acreditam. A profecia, ao contrário, não é para os incrédulos, mas para os que acreditam."
,"23":"Por exemplo: se a Igreja se reunir e todos falarem em línguas, será que os simples ouvintes e os incrédulos que entrarem não vão dizer que estais loucos?"
,"24":"Ao contrário, se todos profetizarem, o incrédulo ou o simples ouvinte que entrar sentir-se-á persuadido do seu erro por todos, julgado por todos;"
,"25":"e os segredos do seu coração serão desvendados; ele prostrar-se-á com o rosto por terra, adorará a Deus e proclamará que Deus está realmente no meio de vós."
,"26":"Que fazer então, irmãos? Quando estais reunidos, cada um pode entoar um cântico, dar um ensinamento ou revelação, falar em línguas ou interpretá-las. Mas que tudo seja para edificação!"
,"27":"Se existe alguém que fale em línguas, falem dois ou no máximo três, um após o outro. E que alguém as interprete."
,"28":"Se não há intérprete, que o irmão se cale na assembleia; fale a si mesmo e a Deus."
,"29":"Quanto aos profetas, que dois ou três falem, e os outros profetas dêem o seu parecer."
,"30":"Se alguém que está sentado recebe uma revelação, cale-se aquele que está a falar."
,"31":"Todos vós podeis profetizar, mas um após outro, para que todos sejam instruídos e encorajados."
,"32":"Os espíritos dos profetas estão submissos aos profetas."
,"33":"Pois Deus não é um Deus de desordem, mas de paz."
,"34":"Que as mulheres fiquem caladas nas assembleias, como se faz em todas as Igrejas dos cristãos, pois não lhes é permitido tomar a palavra. Devem ficar submissas, como diz também a Lei."
,"35":"Se desejam instruir-se sobre algum ponto, perguntem aos maridos em casa; não é conveniente que a mulher fale nas assembleias."
,"36":"Porventura a Palavra de Deus teve a sua origem em vós? Ou fostes vós os únicos que a recebestes?"
,"37":"Se alguém julga ser profeta ou inspirado pelo Espírito, reconheça um mandamento do Senhor nas coisas que vos escrevo."
,"38":"Todavia, se alguém não reconhecer isso, é porque também não é reconhecido por Deus."
,"39":"Portanto, irmãos, aspirai ao dom da profecia e não impeçais que alguém fale em línguas."
,"40":"Mas que tudo seja feito de modo conveniente e com ordem."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Irmãos, lembro-vos o Evangelho que vos anunciei, que recebestes e no qual permaneceis firmes."
,"2":"É pelo Evangelho que sereis salvos, contanto que o guardeis do modo como eu vo-lo anunciei; de contrário, tereis acreditado em vão."
,"3":"Transmiti-vos, em primeiro lugar, aquilo que eu mesmo recebi, isto é: Cristo morreu pelos nossos pecados, conforme as Escrituras;"
,"4":"foi sepultado, ressuscitou ao terceiro dia, conforme as Escrituras;"
,"5":"apareceu a Pedro e depois aos Doze."
,"6":"Em seguida, apareceu a mais de quinhentos irmãos de uma só vez; a maioria deles ainda vive e alguns já morreram."
,"7":"Depois apareceu a Tiago e, a seguir, a todos os Apóstolos."
,"8":"Em último lugar apareceu-me também a mim, que sou um aborto."
,"9":"De facto eu sou o menor dos Apóstolos e não mereço ser chamado Apóstolo, pois persegui a Igreja de Deus."
,"10":"Mas aquilo que sou devo-o à graça de Deus; e a graça que Ele me deu não foi estéril. Pelo contrário: trabalhei mais do que todos eles; não eu, mas a graça de Deus que está comigo."
,"11":"Portanto, aqui está o que nós pregamos, tanto eu como eles; aqui está aquilo em que vós acreditastes."
,"12":"Ora, se nós pregamos que Cristo ressuscitou dos mortos, como é que alguns de vós dizem que não há ressurreição dos mortos?"
,"13":"Se não há ressurreição dos mortos, então Cristo também não ressuscitou;"
,"14":"e, se Cristo não ressuscitou, a nossa pregação é vazia e também é vazia a fé que tendes."
,"15":"Se os mortos não ressuscitam, então somos testemunhas falsas de Deus, pois testemunhamos contra Deus, quando dizemos que Deus ressuscitou a Cristo."
,"16":"Pois, se os mortos não ressuscitam, Cristo também não ressuscitou."
,"17":"E, se Cristo não ressuscitou, a fé que tendes é ilusória e ainda permaneceis nos vossos pecados."
,"18":"E, desse modo, aqueles que morreram em Cristo estão perdidos."
,"19":"Se a nossa esperança em Cristo é somente para esta vida, nós somos os mais infelizes de todos os homens."
,"20":"Mas não! Cristo ressuscitou dos mortos como primeiro fruto dos que morreram."
,"21":"De facto, já que a morte veio através de um homem, também por um homem vem a ressurreição dos mortos."
,"22":"Como em Adão todos morrem, assim em Cristo todos receberão a vida."
,"23":"Cada um, porém, na sua própria ordem: Cristo, como primeiro fruto; depois, aqueles que pertencem a Cristo, por ocasião da sua vinda."
,"24":"A seguir, chegará o fim, quando Cristo entregar o Reino a Deus Pai, depois de ter destruído todo o principado, toda a autoridade, todo o poder."
,"25":"Pois é preciso que Ele reine, até que tenha posto todos os seus inimigos debaixo dos seus pés."
,"26":"O último inimigo a ser destruído será a morte,"
,"27":"pois Deus tudo colocou debaixo dos pés de Cristo. Mas, quando se diz que tudo Lhe será submetido, é claro que se deve excluir Deus, que tudo submeteu a Cristo."
,"28":"E quando todas as coisas Lhe tiverem sido submetidas, então o próprio Filho Se submeterá Àquele que tudo Lhe submeteu, para que Deus seja tudo em todos."
,"29":"Se não fosse assim, que ganhariam aqueles que se fazem baptizar em favor dos mortos? Se os mortos realmente não ressuscitam, porquê fazer-se baptizar em favor deles?"
,"30":"E nós mesmos, porque nos expomos ao perigo a todo o momento?"
,"31":"Diariamente corro perigo de morte, tão certo, irmãos, quanto sois vós a minha glória em Jesus Cristo nosso Senhor."
,"32":"Para mim, de que teria adiantado lutar contra os animais em Éfeso, se eu tivesse apenas interesses humanos? Se os mortos não ressuscitam, comamos e bebamos, pois amanhã morreremos."
,"33":"Não vos deixeis iludir: as más companhias corrompem os bons costumes."
,"34":"Voltai a viver a vida séria e correcta; e não pequeis. Pois alguns de vós ignoram tudo a respeito de Deus. Digo isto para que sintais vergonha."
,"35":"Todavia alguém dirá: «Como é que os mortos ressuscitam? Com que corpo voltarão?»"
,"36":"Insensato! Aquilo que semeias não volta à vida, a não ser que morra."
,"37":"E o que semeias não é o corpo da futura planta que deve nascer, mas simples grão de trigo ou de qualquer outra espécie."
,"38":"A seguir, Deus dá-lhe corpo como quer: Ele dá a cada uma das sementes o corpo que lhe é próprio."
,"39":"Nenhuma carne é igual às outras: a carne dos homens é de um tipo, a dos animais é de outro, e de outro a das aves e de outro ainda a dos peixes."
,"40":"Há corpos celestes e há corpos terrestres. O brilho dos celestes, porém, é diferente do brilho dos terrestres."
,"41":"Uma coisa é o brilho do Sol, outra o brilho da Lua, e outra o brilho das estrelas. E até de estrela para estrela há diferença de brilho."
,"42":"O mesmo acontece com a ressurreição dos mortos: o corpo é semeado corruptível, mas ressuscita incorruptível;"
,"43":"é semeado desprezível, mas ressuscita glorioso; é semeado na fraqueza, mas ressuscita cheio de força;"
,"44":"é semeado corpo animal, mas ressuscita corpo espiritual. Se existe um corpo animal, também existe um corpo espiritual, pois a Escritura diz que"
,"45":"Adão, o primeiro homem, tornou-se um ser vivo, mas o último Adão tornou-se espírito que dá a vida."
,"46":"O primeiro a ser feito não foi o corpo espiritual, mas o animal, e depois o espiritual."
,"47":"O primeiro homem foi tirado da terra e é terrestre; o segundo homem vem do Céu."
,"48":"O homem feito da terra foi o modelo dos homens terrestres; o homem do Céu é o modelo dos homens celestes."
,"49":"E assim como trouxemos a imagem do homem terrestre, assim também traremos a imagem do homem celeste."
,"50":"O que vos digo, irmãos, é que a carne e o sangue não podem receber em herança o Reino de Deus, nem a corrupção herdar a incorruptibilidade."
,"51":"Vou revelar-vos um mistério: nem todos morreremos, mas todos seremos transformados,"
,"52":"num instante, num abrir e fechar de olhos, ao som da trombeta final. Sim, a trombeta tocará e os mortos ressurgirão incorruptíveis; e nós seremos transformados."
,"53":"De facto, é necessário que este ser corruptível seja revestido de incorruptibilidade, e que este ser mortal seja revestido de imortalidade."
,"54":"Portanto, quando este ser corruptível for revestido de incorruptibilidade e este ser mortal for revestido de imortalidade, então se cumprirá a palavra da Escritura: «A morte foi engolida pela vitória."
,"55":"Morte, onde está a tua vitória? Morte, onde está o teu aguilhão?»"
,"56":"O aguilhão da morte é o pecado, e a força do pecado é a lei."
,"57":"Graças sejam dadas a Deus, que nos dá a vitória por meio de nosso Senhor Jesus Cristo."
,"58":"Assim, queridos irmãos, sede firmes, inabaláveis, fazei continuamente progressos na obra do Senhor, sabendo que a vossa fadiga não é inútil no Senhor."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Quanto à colecta em favor dos irmãos, fazei o mesmo que ordenei às Igrejas da Galácia."
,"2":"No primeiro dia da semana, cada um coloque de lado aquilo que conseguiu economizar; deste modo, não precisareis de esperar que eu chegue para fazer a colecta."
,"3":"Quando eu chegar, mandarei com uma carta minha aqueles que tiverdes escolhido para levar as vossas ofertas a Jerusalém."
,"4":"Se for conveniente que eu mesmo vá, eles farão a viagem comigo."
,"5":"Irei ter convosco depois de passar pela Macedónia, pois pretendo apenas atravessar a Macedónia."
,"6":"Mas talvez eu fique convosco ou até passe aí o Inverno, para que me forneçais os meios para prosseguir viagem."
,"7":"Não quero ver-vos apenas de passagem; se o Senhor permitir, espero ficar algum tempo convosco."
,"8":"Vou permanecer em Éfeso até ao Pentecostes,"
,"9":"pois abriu-se ali uma porta larga e cheia de perspectivas para mim, e os adversários são muitos."
,"10":"Quando Timóteo for ter convosco, procurai que esteja sem receios no meio de vós, pois ele trabalha como eu na obra do Senhor."
,"11":"Portanto, que ninguém o despreze. Dai-lhe os meios para voltar em paz para junto de mim, pois eu com os irmãos o esperamos."
,"12":"Quanto ao nosso irmão Apolo, insisti que ele fosse visitar-vos com os irmãos, mas ele não quis de modo nenhum ir agora. Irá quando tiver oportunidade."
,"13":"Sede vigilantes, permanecei firmes na fé, sede homens, sede fortes."
,"14":"Fazei tudo com amor."
,"15":"Mais uma recomendação, irmãos: vós conheceis a família de Estéfanas, que é o primeiro fruto da Acaia; eles dedicaram-se ao serviço dos irmãos."
,"16":"Sede atenciosos para com pessoas de tal valor e para com todos os que colaboram e se afadigam na mesma obra."
,"17":"Eu alegro-me com a visita de Estéfanas, Fortunato e Acaico, pois eles compensaram a vossa ausência"
,"18":"e tranquilizaram o meu espírito e o vosso. Tende apreço por pessoas de tal valor."
,"19":"As Igrejas da Ásia mandam saudações. Áquila e Prisca, com a Igreja que se reúne em sua casa, mandam efusivas saudações no Senhor."
,"20":"Todos os irmãos mandam saudações. Saudai-vos uns aos outros com o beijo santo."
,"21":"A saudação é do meu próprio punho: Paulo."
,"22":"Se alguém não ama o Senhor, seja anátema. Marana-tá."
,"23":"Que a graça do Senhor Jesus esteja convosco."
,"24":"Eu amo-vos a todos em Jesus Cristo."
}`)

}
func PT_BS_LoadNP1EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Silvano e Timóteo à Igreja dos Tessalonicenses, que está em Deus Pai e no Senhor Jesus Cristo. Para vós, graça e paz."
,"2":"Agradecemos continuamente a Deus por todos vós, sempre que nos lembramos de vós nas nossas orações."
,"3":"Com efeito, diante de Deus nosso Pai lembramo-nos sempre da fé activa, do amor capaz de sacrifícios e da firme esperança que depositais em nosso Senhor Jesus Cristo."
,"4":"Irmãos amados por Deus, sabemos que fostes escolhidos por Ele."
,"5":"De facto, o Evangelho que pregámos não foi apresentado somente com palavras, mas com poder, com o Espírito Santo e com plena convicção. Sabeis o que fizemos entre vós para vosso bem."
,"6":"E imitastes o nosso exemplo e o exemplo do Senhor, acolhendo a Palavra com a alegria do Espírito Santo, apesar de tantas tribulações."
,"7":"Assim vos tornastes modelo para todos os fiéis da Macedónia e da Acaia."
,"8":"Partindo de vós, a Palavra do Senhor propagou-se, não apenas pela Macedónia e Acaia, mas também por toda a parte se espalhou a fé que tendes em Deus, de modo que sobre isto nada precisamos de dizer."
,"9":"Eles mesmos falam do acolhimento que tivemos entre vós, e de como vos convertestes, deixando os ídolos e voltando-vos para Deus, a fim de servir ao Deus vivo e verdadeiro."
,"10":"Falam também de como esperais que Jesus venha do Céu, o Filho de Deus, a quem Deus ressuscitou dentre os mortos. É Ele que nos liberta da ira futura."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Irmãos, vós acolhestes-nos e bem sabeis que não foi em vão."
,"2":"Apesar de maltratados e insultados em Filipos, como sabeis, encontrámos no nosso Deus a coragem de vos anunciar o Evangelho de Deus no meio de forte oposição."
,"3":"É que a nossa pregação não nasce do erro, nem de segundas intenções, nem de esperteza."
,"4":"Pelo contrário: Deus achou-nos dignos de nos confiar o Evangelho, e assim o pregamos, não para agradar aos homens, mas a Deus, que sonda os nossos corações."
,"5":"Como sabeis, nunca usámos de adulação, nem fomos levados por motivos interesseiros: Deus é testemunha."
,"6":"Nem estávamos à procura de elogio dos homens, seja de vós, seja de outros,"
,"7":"embora, como Apóstolos de Cristo, pudéssemos recorrer à nossa autoridade. Pelo contrário, tratámo-vos com bondade, qual mãe aquecendo os filhos que amamenta."
,"8":"Queríamo-vos tanto bem, que estávamos prontos a dar-vos não somente o Evangelho de Deus, mas até a nossa própria vida, por tanto gostarmos de vós."
,"9":"Irmãos, vós ainda vos lembrais dos nossos trabalhos e fadigas. Pregámo-vos o Evangelho trabalhando de noite e de dia, a fim de não sermos de peso para ninguém."
,"10":"Vós sois testemunhas, e o próprio Deus também, de como foi santo, justo e irrepreensível o nosso comportamento em relação a vós que acreditais."
,"11":"Sabeis muito bem que tratámos a cada um de vós como um pai trata os seus filhos."
,"12":"Nós vos exortamos, encorajamos e admoestamos a viverdes de modo digno de Deus, que vos chama para o seu Reino e glória."
,"13":"O motivo do nosso contínuo agradecimento a Deus é este: quando ouvistes a Palavra de Deus que vos anunciámos, acolheste-la não como palavra humana, mas como ela realmente é, como Palavra de Deus, que age com eficácia em vós que acreditais."
,"14":"Irmãos, vós imitastes as Igrejas de Deus que estão na Judeia, as Igrejas de Jesus Cristo, pois sofrestes da parte dos vossos compatriotas, assim como também elas sofreram por causa dos judeus."
,"15":"Estes mataram o Senhor Jesus e os profetas, e agora perseguem-nos. Desagradam a Deus e são inimigos de todos os homens."
,"16":"Eles querem impedir-nos de pregar a salvação aos pagãos. E com isso vão enchendo cada vez mais a medida dos seus pecados, até que a ira de Deus acabe por cair sobre eles."
,"17":"Irmãos, já há algum tempo que estamos separados de vós, longe dos olhos mas não do coração, e por isso temos o mais vivo e ardente desejo de vos tornar a ver."
,"18":"Quisemos visitar-vos. Eu mesmo, Paulo, por mais de uma vez quis fazê-lo. Satanás, porém, impediu-nos."
,"19":"De facto, quem, senão vós, será a nossa esperança, a nossa alegria e a nossa coroa diante de nosso Senhor Jesus, no dia da sua vinda?"
,"20":"Sim, a nossa glória e alegria sois vós!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Assim, não podendo esperar mais, resolvemos ficar sozinhos em Atenas,"
,"2":"e enviar-vos Timóteo, nosso irmão e colaborador na pregação do Evangelho de Cristo. Nós o enviámos para vos fortalecer e encorajar na fé,"
,"3":"para que ninguém fique abalado com as presentes tribulações. Vós bem sabeis que este é o nosso destino."
,"4":"Quando estávamos convosco, já vos predizíamos que havíamos de sofrer tribulações. Foi o que aconteceu, como sabeis."
,"5":"É por isso que, não podendo esperar mais, mandei pedir informações sobre a vossa fé. Eu temia que o tentador vos tivesse seduzido e o nosso trabalho acabasse em nada."
,"6":"Agora Timóteo acaba de chegar da visita que vos fez, trazendo boas notícias sobre a vossa fé e amor. Ele disse que vos lembrais sempre de nós com afecto, e que desejais rever-nos, como também nós gostaríamos de vos ver."
,"7":"Assim, irmãos, a vossa fé é um consolo para nós no meio de todas as nossas angústias e tribulações."
,"8":"Agora já nos sentimos reanimados, pois sabemos que estais firmes no Senhor."
,"9":"Como poderíamos agradecer a Deus por vossa causa, pela alegria que nos destes diante do nosso Deus?"
,"10":"Noite e dia rezamos com insistência para que possamos rever-vos, a fim de completar o que ainda falta à vossa fé."
,"11":"Que Deus, nosso Pai, e nosso Senhor Jesus dirijam o nosso caminho até vós."
,"12":"Que o Senhor vos faça crescer e aumentar no amor mútuo e para com todos, assim como é o nosso amor para convosco,"
,"13":"a fim de que o vosso coração permaneça firme e irrepreensível na santidade diante de Deus, nosso Pai, por ocasião da vinda de nosso Senhor Jesus com todos os seus santos."
}`)
	CurrentBook.AddChapter(4, `{
"1":"De resto, irmãos, pedimos e suplicamos no Senhor Jesus: vós aprendestes de nós como deveis comportar-vos para agradar a Deus. Vós já vos comportais assim. Continuai a progredir!"
,"2":"Conheceis as instruções que vos demos em nome do Senhor Jesus."
,"3":"A vontade de Deus é que vivais consagrados a Ele, que vos afasteis da libertinagem,"
,"4":"que cada um saiba usar o próprio corpo na santidade e no respeito,"
,"5":"sem se deixar arrastar por paixões libidinosas, como os pagãos que não conhecem a Deus."
,"6":"Quanto a isto, que ninguém ofenda ou prejudique o irmão, porque o Senhor vinga-Se de todas estas coisas, como já dissemos e demos provas."
,"7":"Deus não nos chamou para a imoralidade, mas para a santidade."
,"8":"Portanto, quem despreza estas normas não despreza um homem, mas o próprio Deus, que vos dá o Espírito Santo."
,"9":"Não precisamos de vos escrever a respeito do amor fraterno, pois aprendestes do próprio Deus a amar-vos uns aos outros."
,"10":"E é isso que fazeis com todos os irmãos da Macedónia. Mas aconselhamo-vos, irmãos, a progredirdes cada vez mais."
,"11":"Que seja para vós uma questão de honra viver em paz, ocupando-vos com as coisas que vos pertencem e trabalhando com as próprias mãos, conforme recomendámos."
,"12":"Assim levareis uma vida honrada aos olhos dos estranhos e não precisareis da ajuda de ninguém."
,"13":"Irmãos, não queremos que ignoreis coisa alguma a respeito dos mortos, para não ficardes tristes como os outros que não têm esperança."
,"14":"Se acreditamos que Jesus morreu e ressuscitou, acreditamos também que aqueles que morreram em Jesus, Deus os levará consigo."
,"15":"Eis o que vos declaramos, baseando-nos na Palavra do Senhor: nós, que ainda estaremos vivos por ocasião da vinda do Senhor, não teremos nenhuma vantagem sobre aqueles que já tiverem morrido."
,"16":"De facto, a uma ordem, à voz do arcanjo e ao som da trombeta divina, o próprio Senhor descerá do Céu. Então os mortos em Cristo ressuscitarão primeiro;"
,"17":"depois nós, os vivos, que estivermos ainda na Terra, seremos arrebatados com eles para as nuvens, ao encontro do Senhor nos ares. E então estaremos para sempre com o Senhor."
,"18":"Consolai-vos, pois, uns aos outros com estas palavras."
}`)
	CurrentBook.AddChapter(5, `{
"1":"No que diz respeito ao tempo e circunstâncias, não preciso de vos escrever nada, irmãos."
,"2":"Vós já sabeis que o dia do Senhor chegará como um ladrão, de noite."
,"3":"Quando as pessoas disserem: «Estamos em paz e segurança», então de repente a ruína cairá sobre elas, como dores de parto para a mulher grávida, e não conseguirão escapar."
,"4":"Mas vós, irmãos, não viveis nas trevas, de tal modo que esse dia possa surpreender-vos como um ladrão."
,"5":"Porque todos vós sois filhos da luz e filhos do dia. Não somos da noite nem das trevas."
,"6":"Portanto, não durmamos como os outros. Estejamos acordados e sóbrios."
,"7":"Pois os que dormem, dormem de noite, e os que se embriagam, embriagam-se de noite."
,"8":"Nós, porém, que somos do dia, sejamos sóbrios, revestidos com a couraça da fé e do amor e com o capacete da esperança da salvação."
,"9":"Pois Deus não nos destinou à sua ira, mas para a salvação através de nosso Senhor Jesus Cristo,"
,"10":"o qual morreu por nós a fim de que, acordados ou dormindo, fiquemos unidos a Ele."
,"11":"Portanto, consolai-vos mutuamente e ajudai-vos uns aos outros a crescer, como aliás já fazeis."
,"12":"Irmãos, pedimo-vos que tenhais consideração para com aqueles que se afadigam em vos dirigir e admoestar no Senhor."
,"13":"Deveis tratá-los com muito respeito e amor, por causa do trabalho que eles realizam. Vivei em paz entre vós."
,"14":"Por favor, irmãos: corrigi os que não fazem nada, encorajai os tímidos, sustentai os fracos e sede pacientes com todos."
,"15":"Cuidai que ninguém retribua o mal com o mal, mas procurai sempre o bem uns dos outros e de todos."
,"16":"Andai sempre alegres,"
,"17":"rezai sem cessar."
,"18":"Dai graças em todas as circunstâncias, porque esta é a vontade de Deus a vosso respeito em Jesus Cristo."
,"19":"Não extingais o Espírito,"
,"20":"não desprezeis as profecias;"
,"21":"examinai tudo e ficai com o que é bom."
,"22":"Conservai-vos longe de toda a espécie de mal."
,"23":"Que o próprio Deus da paz vos conceda a plena santidade. Que o vosso espírito, alma e corpo sejam conservados de modo irrepreensível para a vinda de nosso Senhor Jesus Cristo."
,"24":"Quem vos chamou é fiel e realizará tudo isto."
,"25":"Irmãos, rezai também por nós."
,"26":"Saudai todos os irmãos com o beijo santo."
,"27":"Peço-vos encarecidamente que esta carta seja lida a todos os irmãos."
,"28":"Que a graça de nosso Senhor Jesus Cristo esteja convosco."
}`)

}
func PT_BS_LoadNP1IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Apóstolo de Jesus Cristo por ordem de Deus nosso Salvador e de Jesus Cristo nossa esperança,"
,"2":"a Timóteo, meu verdadeiro filho na fé: graça, misericórdia e paz da parte de Deus Pai e de Jesus Cristo nosso Senhor."
,"3":"Ao partir para a Macedónia, recomendei que ficasses em Éfeso, a fim de impedir que alguns continuassem a ensinar doutrinas diferentes,"
,"4":"e para que não se ocupassem com fábulas e genealogias sem fim; estas favorecem mais as discussões do que o projecto de Deus, que se realiza na fé."
,"5":"A finalidade desta ordem é o amor que procede de um coração puro, de uma boa consciência e de uma fé sem hipocrisia."
,"6":"Alguns desviaram-se desta linha e perderam-se num palavreado inútil;"
,"7":"pretendem passar por doutores da Lei, mas não sabem nem o que dizem nem o que afirmam."
,"8":"Sabemos que a Lei é boa, contanto que a tomemos como uma lei."
,"9":"Ela não é destinada ao justo, mas aos iníquos e rebeldes, ímpios e pecadores, sacrílegos e profanadores, parricidas e matricidas, homicidas,"
,"10":"impudicos, pederastas, mercadores de escravos, mentirosos, para os que juram falso, e para tudo o que se oponha à sã doutrina,"
,"11":"de acordo com o Evangelho glorioso do Deus bendito, que me foi confiado."
,"12":"Agradeço Àquele que me deu força, a Jesus Cristo nosso Senhor, que me considerou digno de confiança, tomando-me para o seu serviço,"
,"13":"apesar de eu ter sido um blasfemo, perseguidor e insolente. Mas obtive misericórdia porque agia sem saber, longe da fé."
,"14":"Sim, Ele concedeu-me com maior abundância a sua graça, com a fé e o amor que estão em Jesus Cristo."
,"15":"Esta palavra é segura e digna de ser acolhida por todos: Jesus Cristo veio ao mundo para salvar os pecadores, dos quais eu sou o primeiro."
,"16":"Mas exactamente por causa disto é que eu obtive misericórdia: Jesus Cristo quis demonstrar toda a sua generosidade primeiramente em mim, como exemplo para os que depois iriam acreditar n'Ele, a fim de terem a vida eterna."
,"17":"Ao rei dos séculos, ao Deus incorruptível, invisível e único, honra e glória para sempre. Ámen!"
,"18":"Timóteo, meu filho, esta é a instrução que te confio, conforme as profecias que foram outrora pronunciadas a teu respeito. Apoiado nelas combate o bom combate,"
,"19":"com fé e boa consciência. Alguns rejeitaram a boa consciência e acabaram por naufragar na fé."
,"20":"Entre esses encontram-se Himeneu e Alexandre, que entreguei a Satanás, a fim de que aprendam a não blasfemar."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Antes de tudo, recomendo que façais pedidos, orações, súplicas e acções de graças em favor de todos os homens,"
,"2":"pelos reis e por todos os que têm autoridade, a fim de que levemos uma vida calma e serena, com toda a piedade e dignidade."
,"3":"Isso é bom e agradável diante de Deus nosso Salvador."
,"4":"Ele quer que todos os homens sejam salvos e cheguem ao conhecimento da verdade."
,"5":"Pois há um só Deus e um só mediador entre Deus e os homens: Jesus Cristo, homem"
,"6":"que Se entregou para resgatar a todos. Esse é o testemunho dado nos tempos estabelecidos por Deus,"
,"7":"e para o qual eu fui designado pregador e Apóstolo - digo a verdade, não minto, - doutor das nações na fé e na verdade."
,"8":"Quero, portanto, que os homens orem em todo o lugar, erguendo mãos puras, sem ira e sem discussões."
,"9":"Quanto às mulheres, que elas se apresentem em trajes decentes e se enfeitem com pudor e modéstia. Não usem tranças, nem objectos de ouro, pérolas ou vestuário luxuoso;"
,"10":"mas enfeitem-se com boas obras, como convém a mulheres que dizem ser piedosas."
,"11":"Durante a instrução, a mulher deve ficar em silêncio, com toda a submissão."
,"12":"Eu não permito que a mulher ensine ou domine o homem. Portanto, que ela permaneça em silêncio."
,"13":"Porque primeiro foi formado Adão, depois Eva."
,"14":"E não foi Adão que foi seduzido, mas a mulher que, seduzida, pecou."
,"15":"Entretanto, ela será salva pela sua maternidade, desde que permaneça com modéstia na fé, no amor e na santidade."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Écerto que se alguém aspira a um cargo de direcção, aspira a uma coisa nobre."
,"2":"É preciso, porém, que o dirigente seja irrepreensível, esposo de uma única mulher, ajuizado, equilibrado, educado, hospitaleiro, capaz de ensinar,"
,"3":"não dado à bebida, nem brigão, mas indulgente, pacífico e sem interesse por dinheiro."
,"4":"Deve ser homem que saiba dirigir bem a própria casa, e cujos filhos lhe obedeçam e o respeitem."
,"5":"Pois, se alguém não sabe dirigir bem a própria casa, como poderá dirigir bem a Igreja de Deus?"
,"6":"Que não seja recém-convertido, a fim de que não fique cheio de soberba e seja condenado como o foi o diabo."
,"7":"Exige-se ainda que tenha boa fama entre os de fora, para não cair no descrédito e nos laços do diabo."
,"8":"Os diáconos igualmente devem ser dignos de respeito, homens de palavra, não inclinados à bebida, nem ávidos de lucros vergonhosos."
,"9":"Conservem o mistério da fé com a consciência limpa."
,"10":"Também eles devem ser primeiramente experimentados e, em seguida, se forem irrepreensíveis, sejam admitidos na função de diáconos."
,"11":"Também as mulheres devem ser dignas de respeito, não maldizentes, ajuizadas, fiéis em todas as coisas."
,"12":"Que os diáconos sejam esposos de uma única mulher, dirigindo bem os filhos e a própria casa."
,"13":"Pois aqueles que exercem bem o diaconado conquistam lugar de honra, e também muita coragem na fé em Cristo Jesus."
,"14":"Escrevo-te estas coisas esperando encontrar-te em breve."
,"15":"Se me atrasar, saberás como proceder na casa de Deus, que é a Igreja do Deus vivo, coluna e sustentáculo da verdade."
,"16":"De facto, como é grande o mistério da piedade: ele manifestou-se na carne, foi justificado no Espírito, apareceu aos anjos, foi anunciado aos pagãos, foi acreditado no mundo e exaltado na glória!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"O Espírito diz claramente que nos últimos tempos alguns renegarão a fé, para dar atenção a espíritos sedutores e a doutrinas demoníacas."
,"2":"Serão seduzidos por homens hipócritas e mentirosos, que têm a própria consciência como que marcada a ferro quente."
,"3":"Eles proibirão o casamento, exigirão abstinência de certos alimentos, embora Deus tenha criado essas coisas para serem recebidas com acção de graças por aqueles que têm fé e conhecem a verdade."
,"4":"De facto, tudo o que Deus criou é bom, e nada é desprezível se tomado com acção de graças,"
,"5":"porque é santificado pela Palavra de Deus e pela oração."
,"6":"Ensinando estas coisas aos irmãos, comportar-te-ás como bom servidor de Jesus Cristo, alimentado com as palavras da fé e da boa doutrina que tens seguido."
,"7":"Rejeita, porém, as fábulas ímpias, coisas de pessoas caducas. Exercita-te na piedade."
,"8":"Vale pouco o exercício corporal, ao passo que a piedade é proveitosa para tudo, pois contém a promessa da vida presente e futura."
,"9":"Esta palavra é fiel e digna de toda a aceitação."
,"10":"De facto, se nós trabalhamos e lutamos, é porque colocamos a nossa esperança no Deus vivo, salvador de todos os homens, principalmente dos que têm fé."
,"11":"Proclama e ensina estas coisas."
,"12":"Que ninguém te despreze por seres jovem. Quanto a ti mesmo, sê para os fiéis um modelo na palavra, na conduta, no amor, na fé, na pureza."
,"13":"Enquanto aguardas a minha chegada, dedica-te à leitura, animação e ensinamento."
,"14":"Não descuides o dom da graça que há em ti e que te foi dado através da profecia, com a imposição das mãos do grupo dos presbíteros."
,"15":"Cuida bem destas coisas e persevera nelas, a fim de que o teu progresso seja manifesto a todos."
,"16":"Vigia-te a ti mesmo e ao ensinamento, e sê perseverante. Desse modo salvar-te-ás a ti mesmo e aos teus ouvintes."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Não repreendas duramente um ancião, mas exorta-o como se fosse um pai. Aos rapazes, como a irmãos."
,"2":"Às senhoras, como a mães. Às jovens, como a irmãs, com toda a pureza."
,"3":"Honra as viúvas que são realmente viúvas."
,"4":"Porém, se alguma viúva tiver filhos ou netos, que estes aprendam primeiramente a cumprir os seus deveres para com a própria família e a recompensar os seus pais, pois isso é agradável diante de Deus."
,"5":"Aquela que é verdadeiramente viúva, que ficou sozinha, deposita a sua confiança em Deus e persevera dia e noite em súplicas e orações."
,"6":"Mas a viúva que só busca prazer, mesmo que viva, já está morta."
,"7":"Portanto, ordena tudo isto, a fim de que elas sejam irrepreensíveis."
,"8":"Se alguém não cuida dos seus e principalmente dos que são da sua própria casa, renegou a fé e é pior que um incrédulo."
,"9":"A mulher só será inscrita no grupo das viúvas com sessenta anos e não menos, se tiver sido esposa de um só marido,"
,"10":"se tiver em seu favor o testemunho das suas boas obras, criado filhos, sido hospitaleira, lavado os pés dos fiéis, socorrido os atribulados, aplicada a toda a boa obra."
,"11":"Rejeita as viúvas mais jovens; pois, quando os seus desejos se afastam de Cristo, elas querem casar-se,"
,"12":"tornando-se censuráveis por terem rompido o seu primeiro compromisso."
,"13":"Além disso, aprendem a viver ociosas, correndo de casa em casa; não são apenas desocupadas, mas também bisbilhoteiras e indiscretas, falando do que não convém."
,"14":"Desejo, pois, que as viúvas jovens se casem, criem filhos e dirijam a sua casa para não darem ao adversário nenhuma ocasião de maledicência."
,"15":"Porque já existem algumas que se desviaram, seguindo a Satanás."
,"16":"Se um fiel tem viúvas na sua família, preste-lhes socorro; não se onere a Igreja, a fim de que possa ajudar aquelas que são verdadeiramente viúvas."
,"17":"Os presbíteros que exercem bem a presidência são dignos de dupla remuneração, sobretudo os que trabalham no ministério da Palavra e da instrução."
,"18":"De facto, assim diz a Escritura: «Não amordaçarás o boi que debulha». E ainda: «O operário é digno do seu salário»."
,"19":"Não aceites denúncia contra um presbítero, a não ser sob depoimento de duas ou três testemunhas."
,"20":"Repreende, diante de todos, os presbíteros que pecam, a fim de que os demais temam."
,"21":"Conjuro-te diante de Deus, de Jesus Cristo e dos anjos eleitos: observa estas regras sem preconceitos, nada fazendo por favoritismo."
,"22":"Não te apresses a impor as mãos em alguém, para não seres cúmplice dos pecados de outrem. Conserva-te puro."
,"23":"Não continues a beber somente água; toma um pouco de vinho, por causa do estômago e das frequentes fraquezas que tens."
,"24":"Os pecados de alguns homens manifestam-se antes do julgamento, os de outros manifestam-se depois."
,"25":"Do mesmo modo, as boas obras são evidentes; e as outras não conseguem ficar ocultas."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Aqueles que se encontram sob o jugo da escravidão devem tratar os seus patrões com todo o respeito, para que o Nome de Deus e o ensinamento não sejam blasfemados."
,"2":"Os que têm patrões que acreditam, não os desrespeitem, porque são irmãos. Pelo contrário: sirvam-nos melhor ainda, pois aqueles que beneficiam dos seus trabalhados, são fiéis e irmãos amados. Isto é o que deves ensinar e recomendar. "
,"3":"Pois, quem ensina coisas diferentes, que não concordam com as sãs palavras de nosso Senhor Jesus Cristo e com o ensinamento conforme a piedade,"
,"4":"é cego, não entende nada, é doente à procura de discussões e brigas de palavras. É daí que nascem invejas, brigas, blasfémias, suspeitas,"
,"5":"polémicas intermináveis, coisas típicas de homens de espírito corrupto e desprovidos da verdade."
,"6":"Eles supõem que a piedade é fonte de lucro. De facto, a piedade é grande fonte de lucro, mas para quem sabe contentar-se."
,"7":"Pois não trouxemos nada para o mundo, e dele nada podemos levar."
,"8":"Se temos que comer e com que nos vestir, fiquemos contentes com isso."
,"9":"Aqueles, porém, que querem tornar-se ricos, caem na armadilha da tentação e em muitos desejos insensatos e perniciosos, que fazem mergulhar os homens na ruína e perdição."
,"10":"Porque a raiz de todos os males é o amor ao dinheiro. Por causa dessa ânsia de dinheiro, alguns afastaram-se da fé e afligem-se a si mesmos com muitos tormentos."
,"11":"Tu, porém, homem de Deus, foge dessas coisas. Procura a justiça, a piedade, a fé, o amor, a perseverança, a mansidão."
,"12":"Combate o bom combate da fé, conquista a vida eterna, para a qual foste chamado. Isso já o reconheceste numa bela profissão de fé diante de muitas testemunhas."
,"13":"Diante de Deus, que dá a vida a todas as coisas, e de Jesus Cristo, que deu testemunho diante de Pôncio Pilatos numa bela profissão de fé, eu te ordeno:"
,"14":"guarda o mandamento puro, de modo irrepreensível, até à Aparição de nosso Senhor Jesus Cristo."
,"15":"Essa Aparição mostrará, nos tempos estabelecidos, o Bendito e único Soberano, o Rei dos reis e Senhor dos senhores,"
,"16":"o único que possui a imortalidade, que habita uma luz inacessível, que nenhum homem viu, nem pode ver. A Ele, honra e poder eterno. Ámen!"
,"17":"Admoesta os ricos deste mundo, para que não sejam orgulhosos e não coloquem a sua esperança na incerteza das riquezas, mas em Deus, que nos dá tudo com abundância para que nos alegremos."
,"18":"Que eles façam o bem, se enriqueçam de boas obras, sejam prontos a distribuir, capazes de partilhar."
,"19":"Desse modo, estão acumu-lando para si mesmos um belo tesouro para o futuro, a fim de obterem a verdadeira vida."
,"20":"Timóteo, guarda o depósito. Evita o palavreado irreverente e as objecções dessa falsa ciência,"
,"21":"pois alguns professaram-na e desviaram-se da fé. A graça esteja convosco."
}`)

}
func PT_BS_LoadNP2CChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Apóstolo de Jesus Cristo pela vontade de Deus, e o irmão Timóteo, à Igreja de Deus que está em Corinto, e também a todos os cristãos que se encontram por toda a Acaia."
,"2":"A graça e a paz vos sejam dadas da parte de Deus nosso Pai e do Senhor Jesus Cristo."
,"3":"Bendito seja o Deus e Pai de nosso Senhor Jesus Cristo, o Pai das misericórdias e Deus de toda a consolação!"
,"4":"Ele nos consola em todas as nossas tribulações, para que possamos consolar os que estão em qualquer tribulação, através da consolação que nós mesmos recebemos de Deus."
,"5":"Na verdade, assim como os sofrimentos de Cristo são numerosos para nós, assim também é grande a nossa consolação por meio de Cristo."
,"6":"Se somos atribulados é para vossa consolação e salvação. Se somos consolados, é para vossa consolação, para que possais suportar os mesmos sofrimentos que também nós padecemos."
,"7":"E a nossa esperança a vosso respeito é firme, pois sabemos que, se participais dos nossos sofrimentos, também haveis de participar da nossa consolação."
,"8":"Irmãos, não queremos que ignoreis isto: a tribulação que sofremos na Ásia fez-nos sofrer muito, além das nossas forças, a ponto de perdermos a esperança de sobreviver."
,"9":"Sim, nós sentíamo-nos como condenados à morte: a nossa confiança já não podia estar apoiada em nós, mas em Deus que ressuscita os mortos."
,"10":"Foi Deus que nos libertou dessa morte e dela nos libertará; n'Ele colocamos a esperança de que ainda nos libertará da morte."
,"11":"Para isso vós ides colaborar através da oração. Deste modo, a graça que obteremos pela intercessão de muitas pessoas provocará a acção de graças de muitos em nosso favor."
,"12":"Este é o nosso motivo de orgulho: o testemunho da consciência de que nos comportámos no mundo, e mais particularmente em relação a vós, com a santidade e sinceridade que vêm de Deus. Não foram razões humanas que nos moveram, mas a graça de Deus."
,"13":"De facto não há nada em nossas cartas além daquilo que ledes e compreendeis. E espero que compreendais plenamente,"
,"14":"assim como em parte já nos compreendestes que somos para vós motivo de glória, assim como vós o sereis para nós, no Dia do Senhor Jesus."
,"15":"Animado por esta certeza, eu pretendia em primeiro lugar ir ter convosco, para que recebêsseis uma segunda graça;"
,"16":"depois seguiria para a Macedónia; e, finalmente, da Macedónia iria outra vez ter convosco, a fim de que me preparásseis a viagem para a Judeia."
,"17":"Será que fui leviano ao fazer este projecto? Será que os meus planos foram inspirados por objectivos puramente humanos, de tal modo que em mim existe «sim e não» ao mesmo tempo?"
,"18":"Deus é testemunha fiel de que a palavra que vos dirigimos não é «sim e não»."
,"19":"De facto, Jesus Cristo, o Filho de Deus, que eu, Silvano e Timóteo vos anunciámos, não foi «sim e não», mas unicamente «sim»."
,"20":"Todas as promessas de Deus encontraram n'Ele o seu sim; por isso, é por meio d'Ele que dizemos «Ámen» a Deus, para a glória de Deus."
,"21":"Quem nos fortalece juntamente convosco em Cristo e nos dá a unção, é Deus."
,"22":"Deus marcou-nos com um selo e colocou em nossos corações a garantia do Espírito."
,"23":"Quanto a mim, invoco a Deus como testemunha da minha vida: foi para vos poupar que não voltei a Corinto."
,"24":"Não é nossa intenção dominar a fé que tendes, mas colaborar para que tenhais alegria. Quanto à fé, vós estais firmes."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por isso, preferi não ir visitar-vos, para não provocar tristeza."
,"2":"De facto, se vos causo tristeza, quem me dará alegria? Somente vós, a quem entristeci."
,"3":"A finalidade da minha carta era evitar que, ao chegar, eu experimentasse tristeza daqueles que me deveriam proporcionar alegria. Quanto a vós, estou convencido de que a minha alegria é também a alegria de todos vós."
,"4":"De facto, quando escrevi, estava tão preocupado e aflito que até chorava; não pretendia entristecer-vos, mas escrevi para que compreendais o imenso amor que vos tenho."
,"5":"Se alguém causou tristeza, não foi a mim, mas de certo modo (não vamos exagerar) a todos vós."
,"6":"Para tal pessoa, basta o castigo que a comunidade resolveu impor-lhe."
,"7":"Mas agora é melhor que lhe perdoeis e o consoleis, para que ele não fique sob o peso de tristeza excessiva."
,"8":"Peço-vos, portanto, que deis provas de amor a essa pessoa."
,"9":"Realmente, ao escrever-vos, eu queria pôr à prova a vossa obediência e verificar se era uma obediência total."
,"10":"A quem vós perdoais, eu também perdoo. Se perdoei - na medida que tinha de perdoar - fi-lo diante de Cristo em vosso favor."
,"11":"Deste modo, não seremos enganados por Satanás, pois não ignoramos as suas intenções."
,"12":"Cheguei então a Tróade para lá pregar o Evangelho de Cristo. Embora o Senhor me tivesse aberto uma grande porta,"
,"13":"não tive paz de espírito, pois não encontrei o meu irmão Tito. Por isso despedi-me deles e parti para a macedónia."
,"14":"Graças sejam dadas a Deus, que nos faz participar do seu triunfo em Cristo e que, através de nós, espalha o perfume do seu conhecimento no mundo inteiro."
,"15":"De facto, diante de Deus nós somos o bom perfume de Cristo entre aqueles que se salvam e entre aqueles que se perdem:"
,"16":"para uns, perfume de morte para a morte; para outros, perfume de vida para a vida. E quem estaria à altura de tal missão?"
,"17":"Nós não somos como aqueles que falsificam a Palavra de Deus; pelo contrário, é com sinceridade e como enviados de Deus que falamos a respeito de Cristo na vossa presença."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Vamos começar de novo a fazer recomendação de nós mesmos? Ou precisamos de vos apresentar cartas de recomendação, como fazem alguns? Ou, então, pedir-vos essa carta?"
,"2":"A nossa carta de recomendação sois vós mesmos, carta escrita em nossos corações, conhecida e lida por todos os homens."
,"3":"De facto, é evidente que sois vós uma carta de Cristo, da qual nós fomos o instrumento; carta escrita, não com tinta, mas nas tábuas de carne do vosso coração."
,"4":"Esta é a convicção que temos diante de Deus, graças a Cristo."
,"5":"Não nos atreveríamos a pensar que esta obra é devida a algum mérito nosso; pelo contrário, é de Deus que vem a nossa capacidade."
,"6":"Foi Ele que nos tornou capazes de sermos ministros de uma aliança nova, não aliança da letra, mas do Espírito; pois a letra mata e o Espírito é que dá a vida."
,"7":"O ministério da morte, gravado com letras sobre a pedra, ficou tão marcado pela glória, que os israelitas não podiam fixar os olhos no rosto de Moisés, por causa do fulgor que nele havia - fulgor, aliás, passageiro."
,"8":"Quanto mais glorioso não será o ministério do Espírito!"
,"9":"Na verdade, se o ministério da condenação foi glorioso, muito mais glorioso será o ministério da justiça."
,"10":"Mesmo a glória que aí se verificou já não pode ser considerada glória, em comparação com a glória actual, que lhe é muito superior."
,"11":"De facto, se foi marcado pela glória o que é passageiro, com maior razão há-de ser glorioso o que é permanente."
,"12":"Fortalecidos por tal esperança, estamos plenamente confiantes:"
,"13":"nós não fazemos como Moisés que colocava um véu sobre a face para que os filhos de Israel não percebessem o fim daquilo que era passageiro..."
,"14":"No entanto, o seu entendimento ficou obscurecido. Sim, até hoje, quando eles lêem o Antigo Testamento, esse mesmo véu permanece; não é retirado, porque é em Cristo que ele desaparece."
,"15":"Sim, até hoje, todas as vezes que lêem Moisés, há um véu sobre o seu coração."
,"16":"Somente pela conversão ao Senhor é que o véu cai,"
,"17":"pois o Senhor é o Espírito; e onde se acha o Espírito do Senhor, aí existe a liberdade."
,"18":"E nós que, com a face descoberta, reflectimos como num espelho a glória do Senhor, somos transfigurados nessa mesma imagem, cada vez mais resplandecente pela acção do Senhor, que é Espírito."
}`)
	CurrentBook.AddChapter(4, `{
"1":"É este o nosso ministério que nos foi concedido pela misericórdia de Deus; por isso, não perdemos a coragem."
,"2":"Dissemos «não» aos procedimentos secretos e vergonhosos, não agimos com astúcia, nem falsificámos a Palavra de Deus. Ao contrário, manifestando a verdade, recomendamo-nos diante de Deus à consciência de cada homem."
,"3":"Portanto, se o nosso Evangelho continua obscuro, está obscuro para aqueles que se perdem,"
,"4":"para os incrédulos, cuja inteligência o deus deste mundo obscureceu a fim de que não vejam brilhar a luz do Evangelho da glória de Cristo, de Cristo que é a imagem de Deus."
,"5":"Não pregamos a nós mesmos, mas a Cristo Jesus, Senhor. Quanto a nós mesmos é como vossos servos que nos apresentamos, por causa de Jesus."
,"6":"Pois o Deus que disse: «Do meio das trevas brilhe a luz!», foi Ele mesmo que reluziu em nossos corações para fazer brilhar o conhecimento da glória de Deus, que resplandece na face de Cristo."
,"7":"Todavia, esse tesouro trazemo-lo em vasos de barro, para que todos reconheçam que esse incomparável poder pertence a Deus e não é propriedade nossa."
,"8":"Somos atribulados por todos os lados, mas não desanimamos; somos postos em extrema dificuldade, mas não somos vencidos por nenhum obstáculo;"
,"9":"somos perseguidos, mas não abandonados; prostrados por terra, mas não aniquilados."
,"10":"Sem cessar e por toda a parte levamos no nosso corpo a morte de Jesus, a fim de que também a vida de Jesus se manifeste no nosso corpo."
,"11":"De facto, embora estejamos vivos, somos a toda a hora entregues à morte por causa de Jesus, a fim de que também a vida de Jesus se manifeste na nossa carne mortal."
,"12":"Deste modo, em nós opera a morte; e, em vós, a vida."
,"13":"Animados pelo mesmo espírito de fé, sobre o qual está escrito: «Acreditei, por isso falei», também nós acreditamos e por isso falamos."
,"14":"Pois sabemos que Aquele que ressuscitou o Senhor Jesus também nos ressuscitará com Jesus e nos colocará ao lado d'Ele juntamente convosco."
,"15":"E tudo isto se realiza em vosso favor, para que a graça, multiplicando-se entre muitos, faça transbordar a acção de graças para a glória de Deus."
,"16":"É por isso que nós não perdemos a coragem. Pelo contrário: embora o nosso físico se vá desfazendo, o nosso homem interior vai-se renovando a cada dia."
,"17":"Pois a nossa tribulação momentânea é leve, em relação ao peso extraordinário da glória eterna que ela nos prepara."
,"18":"Não procuramos as coisas visíveis, mas as invisíveis; porque as coisas visíveis duram apenas um momento, enquanto as invisíveis duram para sempre."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Nós sabemos: quando a nossa morada terrestre, a nossa tenda for desfeita, receberemos de Deus uma habitação no Céu, uma casa eterna não construída por mãos humanas."
,"2":"Por isso, suspiramos neste nosso estado, desejosos de vestir o nosso corpo celeste;"
,"3":"e isso será possível se formos encontrados vestidos, e não nus."
,"4":"Pois nós, que estamos nesta tenda, gememos acabrunhados, porque não queremos ser despojados da nossa veste, mas revestir a outra por cima desta, e, assim, aquilo que é mortal seja absorvido pela vida."
,"5":"E quem para isso nos preparou foi Deus, o qual nos deu a garantia do Espírito."
,"6":"Por esta razão, estamos sempre confiantes, sabendo que enquanto habitamos neste corpo, estamos fora de casa, isto é, longe do Senhor,"
,"7":"pois caminhamos pela fé e não pela visão..."
,"8":"Sim, estamos cheios de confiança e preferimos deixar a mansão deste corpo, para irmos morar junto do Senhor."
,"9":"Em todo o caso, quer fiquemos na nossa morada, quer a deixemos, esforçamo-nos por agradar ao Senhor."
,"10":"De facto, todos deveremos comparecer diante do tribunal de Cristo, a fim de que cada um receba a recompensa daquilo que tiver feito durante a sua vida no corpo, tanto para o bem, como para o mal."
,"11":"Portanto, compenetrados do temor do Senhor, procuramos convencer os homens. Somos plenamente conhecidos por Deus; espero que também sejamos plenamente conhecidos pela vossa consciência."
,"12":"Não nos recomendamos novamente a vós, mas queremos apenas dar-vos ocasião de vos orgulhardes de nós, a fim de que possais dar uma resposta àqueles que se gloriam somente pelas aparências e não pelo que está no coração."
,"13":"Se perdemos o bom senso, foi por causa de Deus; se nos comportámos com sensatez, foi por vossa causa."
,"14":"O amor de Cristo é que nos impulsiona, quando consideramos que um só morreu por todos, e consequentemente todos morreram."
,"15":"Ora, Cristo morreu por todos, e assim, aqueles que vivem, já não vivem para si, mas para Aquele que por eles morreu e ressuscitou."
,"16":"Por isso, doravante não conhecemos mais ninguém pelas aparências. Mesmo que tenhamos conhecido Cristo segundo as aparências, agora já não O conhecemos assim."
,"17":"Se alguém está em Cristo, é nova criatura. As coisas antigas passaram; eis que uma realidade nova apareceu."
,"18":"Tudo isto vem de Deus, que nos reconciliou consigo por meio de Cristo e nos confiou o ministério da reconciliação."
,"19":"Pois era Deus quem reconciliava com Ele mesmo o mundo por meio de Cristo, não levando em conta os pecados dos homens e colocando em nós a Palavra da reconciliação."
,"20":"Sendo assim exercemos a função de embaixadores em nome de Cristo, e é por meio de nós que o próprio Deus vos exorta. Em nome de Cristo, suplicamos: reconciliai-vos com Deus."
,"21":"Aquele que nada tinha a ver com o pecado, Deus fê-l'O pecado por causa de nós, a fim de que por meio d'Ele sejamos reabilitados por Deus."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Visto que somos colaboradores de Deus, nós vos exortamos para que não recebais a graça de Deus em vão."
,"2":"Pois Deus diz na Escritura: «Eu escutei-te no tempo favorável, e no dia da salvação vim em teu auxílio». É agora o momento favorável. É agora o dia da salvação."
,"3":"Da nossa parte, evitamos dar qualquer motivo de escândalo, para que o nosso ministério não seja criticado."
,"4":"Pelo contrário, em tudo nos recomendamos como ministros de Deus: pela grande perseverança nas tribulações, necessidades, angústias,"
,"5":"açoites, prisões, desordens, fadigas, vigílias e jejuns;"
,"6":"pela pureza, ciência, paciência e bondade, pela actuação do Espírito Santo, pelo amor sem fingimento,"
,"7":"pela palavra da verdade, pelo poder de Deus, pelas armas ofensivas e defensivas da justiça;"
,"8":"na glória e no desprezo, na boa e na má fama; tidos como impostores e, no entanto, dizendo a verdade;"
,"9":"como desconhecidos e, no entanto, conhecidos; como agonizantes e, no entanto, estamos vivos; como castigados e, no entanto, livres da morte;"
,"10":"como tristes e, no entanto, sempre alegres; como indigentes e, no entanto, enriquecendo a muitos; nada tendo, mas tudo possuindo."
,"11":"Coríntios, digo-vos com franqueza: O meu coração está aberto para vós."
,"12":"mim, não falta lugar para vos acolher, mas em troca tendes o coração estreito. "
,"13":"Pagai-nos com a mesma moeda. Falo-vos como a filhos; abri também o vosso coração!"
,"14":"Não vos submetais ao mesmo jugo com os infiéis. Que relação pode haver entre justiça e iniquidade? Que união pode haver entre luz e trevas?"
,"15":"Que harmonia pode haver entre Cristo e Belial? Que relação entre quem acredita e quem não acredita?"
,"16":"Que há de comum entre o templo de Deus e os ídolos? Ora, nós somos o templo do Deus vivo, como disse o próprio Deus: «Habitarei no meio deles e com eles caminharei. Serei o seu Deus e eles serão o meu povo."
,"17":"Portanto, saí do meio dessa gente e afastai-vos dela, diz o Senhor. Não toqueis naquilo que é impuro e Eu vos acolherei."
,"18":"Serei para vós um Pai e vós sereis para Mim filhos e filhas, diz o Senhor todo-poderoso»."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Caríssimos, já que temos tais promessas, vamos purificar-nos de toda a mancha do corpo e do espírito. E levemos a cabo a nossa santificação no temor de Deus."
,"2":"Acolhei-nos nos vossos corações. Não fizemos injustiça a ninguém, a ninguém causámos dano, a ninguém explorámos."
,"3":"Não digo isto para vos condenar, porque já vos disse: «Vós estais no nosso coração para a vida e para a morte»."
,"4":"A minha confiança em vós é grande; e eu orgulho-me muito de vós. Estou cheio de consolação, transbordando de alegria no meio de todas as nossas tribulações."
,"5":"Na verdade, quando chegámos à Macedónia, a nossa pobre pessoa não teve um momento de sossego; sofremos toda a espécie de tribulação: por fora, lutas; por dentro, temores."
,"6":"Deus, porém, que consola os humildes, confortou-nos com a chegada de Tito."
,"7":"E não somente com a chegada dele, mas também pelo conforto que ele tinha recebido de vós. Contou-nos que tínheis profundo carinho, que estáveis sentidos com o que acontecera e que vos preocupáveis comigo. E eu fiquei muito contente."
,"8":"Se vos causei tristeza com a minha carta, não me arrependo. E se a princípio me arrependi - pois vejo que essa carta vos entristeceu, embora por pouco tempo -"
,"9":"agora alegro-me, não por vos haver entristecido, mas porque a tristeza fez que vos arrependêsseis. Entristecestes-vos segundo Deus, e assim não sofrestes nenhum dano da nossa parte."
,"10":"De facto, a tristeza que vem de Deus produz arrependimento que leva à salvação e não volta atrás; a tristeza segundo este mundo produz a morte."
,"11":"Vede antes o que produziu em vós a tristeza que vem de Deus: quantas desculpas, quanta indignação, que temor, que desejo ardente, que afecto, que punição! Demonstrastes, de todos os modos, que estáveis inocentes naquela questão."
,"12":"Numa palavra: se vos escrevo, não foi por causa daquele que me injuriou, nem por do ofendido, mas para que ficasse bem claro entre vós, diante de Deus, quanto vos sentis preocupados por nós."
,"13":"Foi por isso que nos sentimos confortados. Mas, além desse conforto pessoal, alegrei-me muito ao ver que Tito estava contente devido à maneira como o recebestes e tranquilizastes. "
,"14":"Se diante dele me gloriei de vós, não tive de que me envergonhar. Assim como sempre vos dissemos a verdade, ficou igualmente comprovado que era verdadeiro o elogio que de vós fizemos a Tito."
,"15":"Ele sente por vós afecto ainda maior, ao lembrar-se da vossa obediência e de como o acolhestes com temor e tremor."
,"16":"Alegro-me, portanto, de poder confiar em vós, aconteça o que acontecer."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Irmãos, agora damo-vos a conhecer a graça que Deus concedeu às Igrejas da Macedónia."
,"2":"No meio de muitas tribulações que puseram à prova essas Igrejas, com grande alegria, apesar da sua extrema pobreza, transbordaram em riquezas de generosidade."
,"3":"Eu sou testemunha de que eles, conforme os seus meios e até além dos seus meios, com toda a espontaneidade"
,"4":"e com muita insistência, nos rogaram a graça de tomarem parte nesse serviço em favor dos cristãos."
,"5":"Ultrapassando as nossas expectativas, eles entregaram-se primeiramente ao Senhor, e pela vontade de Deus, também a nós."
,"6":"Por isso, rogámos a Tito que termine essa obra de generosidade, que ele já havia começado entre vós."
,"7":"Em tudo vós sobressaís: na fé, no dom da palavra, no conhecimento e entusiasmo, além do amor que tendes por nós. Pois então, procurai também distinguir-vos nessa obra de generosidade."
,"8":"Não digo isto para vos impor uma ordem. Se vos falo do exemplo de outros, é para vos dar ocasião de provar a sinceridade do amor que tendes."
,"9":"De facto, conheceis a generosidade de nosso Senhor Jesus Cristo; Ele, embora fosse rico, tornou-Se pobre por vossa causa, para com a sua pobreza vos enriquecer."
,"10":"A propósito, vou dar-vos uma sugestão, e é o que vos convém, já que fostes os primeiros, desde o ano passado, não só a realizar, mas também a querer realizar essa obra."
,"11":"Agora, portanto, executai-a até ao fim, de modo que a essa boa disposição da vontade corresponda a realização, segundo os vossos meios."
,"12":"Quando existe boa vontade, somos bem aceites com os recursos que temos; pouco importa o que não temos."
,"13":"Não queremos que o alívio para os outros seja causa de aflição para vós; mas que haja igualdade."
,"14":"Neste momento, o que vos sobra vai compensar a carência deles, a fim de que o supérfluo deles venha um dia compensar a vossa carência. Assim haverá igualdade,"
,"15":"como está na Escritura: «A quem recolhia muito, nada lhe sobrava; e a quem recolhia pouco, nada lhe faltava»."
,"16":"Graças sejam dadas a Deus, que colocou no coração de Tito o mesmo zelo por vós."
,"17":"Ele acolheu o meu pedido e, mais apressado que nunca, vai espontaneamente ter convosco."
,"18":"Enviámos, juntamente com ele, esse irmão que é elogiado em todas as Igrejas, pela pregação do Evangelho."
,"19":"Mais ainda: foi escolhido pelas Igrejas para ser nosso companheiro de viagem nesta obra de generosidade, serviço que empreendemos para dar glória ao Senhor e realizar as nossas boas intenções."
,"20":"Tomámos esta precaução para evitar qualquer crítica na administração da grande quantia que nos confiaram."
,"21":"De facto, estamos preocupados com o bem, não somente aos olhos de Deus, mas também diante dos homens."
,"22":"Junto com os representantes, enviámos também o nosso irmão, cuja dedicação muitas vezes e de muitos modos temos experimentado e que agora se mostra muito mais disposto, já que deposita plena confiança em vós."
,"23":"Quanto a Tito, ele é meu companheiro e colaborador junto de vós, ao passo que os nossos irmãos são os enviados das Igrejas, as quais são a glória de Cristo."
,"24":"Portanto, diante das Igrejas, dai-lhes provas do vosso amor, e fazei que eles vejam como é justo o motivo do nosso orgulho a respeito de vós."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Quanto ao serviço a ser prestado aos cristãos, é inútil que vos escreva."
,"2":"Conheço a vossa boa vontade e elogiei-a junto dos macedónios, dizendo-lhes: «A Acaia está preparada desde o ano passado.» E o vosso zelo tem servido de estímulo para a maioria das Igrejas."
,"3":"Entretanto, enviei-vos os nossos irmãos, a fim de que o elogio que fiz de vós não seja desmentido nesse ponto e para que - como eu dizia antes - estejais realmente preparados."
,"4":"Se alguns macedónios fossem comigo e não vos encontrassem preparados, essa plena confiança seria motivo de nos envergonharmos, para não dizer que seria motivo de vos envergonhardes."
,"5":"Julguei, portanto, necessário pedir aos irmãos que fossem à nossa frente ter convosco e organizassem as ofertas já prometidas; uma vez recolhidas, tais ofertas seriam sinal de autêntica generosidade e não demonstração de avareza."
,"6":"Lembrai-vos disto: quem semeia com mesquinhez, com mesquinhez há-de colher; quem semeia com generosidade, com generosidade há-de colher."
,"7":"Cada um dê conforme decidir em seu coração, sem pena ou constrangimento, porque Deus ama quem dá com alegria."
,"8":"Deus pode enriquecer-vos com toda a espécie de graças, para que tenhais sempre o necessário em tudo e ainda sobre alguma coisa para poderdes colaborar em qualquer boa obra,"
,"9":"conforme diz a Escritura: «Ele distribuiu e deu aos pobres; a sua justiça permanece para sempre»."
,"10":"Deus, que dá semente ao semeador, também dará o pão em alimento; multiplicar-vos-á a semente, e ainda fará crescer o fruto da vossa justiça."
,"11":"E sereis enriquecidos de todos os modos para praticardes toda a espécie de generosidade, que provocará a acção de graças a Deus por meio de nós."
,"12":"De facto, o serviço desta colecta não deve apenas remediar as necessidades dos cristãos, mas há-de ser ocasião de dar efusivas acções de graças a Deus."
,"13":"Tal serviço será para eles uma prova; e eles agradecerão a Deus pela obediência que professais ao Evangelho de Cristo e pela generosidade com que repartis os bens com eles e com todos."
,"14":"Manifestarão a sua ternura, rezando por vós por causa da graça extraordinária que Deus vos concedeu."
,"15":"Graças sejam dadas a Deus pelo seu dom extraordinário."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Sou eu mesmo, Paulo, quem vos suplica com a mansidão e a bondade de Cristo. Eu que sou «tão humilde quando estou no meio de vós e tão prepotente quando estou longe»."
,"2":"Rogo-vos que não me obrigueis, quando eu estiver aí em pessoa, a mostrar-me prepotente, recorrendo à audácia com que pretendo agir contra aqueles que nos julgam, como se nos comportássemos com interesses humanos."
,"3":"Embora seja homem, não luto por interesses humanos."
,"4":"De facto, as armas da nossa luta não são humanas; o seu poder vem de Deus e são capazes de destruir fortalezas. Nós destruímos os raciocínios presunçosos"
,"5":"e qualquer poder altivo que se levante contra o conhecimento de Deus. Obrigamos toda a inteligência a obedecer a Cristo,"
,"6":"e estamos dispostos a punir qualquer desobediência, desde que a vossa obediência seja perfeita."
,"7":"Olhai as coisas de frente. Se alguém está convencido de pertencer a Cristo, tome consciência, de uma vez por todas, de que assim como ele pertence a Cristo, também nós pertencemos a Cristo."
,"8":"E ainda que eu me orgulhasse um pouco mais do poder que Deus nos deu para edificar e não para vos destruir, eu não me envergonharia disso."
,"9":"Não quero dar a impressão de vos estar a ameaçar com as minhas cartas,"
,"10":"pois, como dizem alguns, «as cartas são duras e fortes, mas a presença dele é fraca e a sua palavra é desprezível»."
,"11":"Aquele que diz isso fique sabendo que, assim como somos pela linguagem e por carta quando estamos ausentes, tais seremos por nossos actos quando estivermos presentes."
,"12":"É verdade que não temos a ousadia de nos igualar ou de nos comparar a alguns que fazem recomendação de si mesmos, que se tornam insensatos, porque se medem de acordo com a sua própria medida e se comparam a si mesmos."
,"13":"Quanto a nós, não nos orgulharemos além da justa medida; ao contrário, tomaremos como medida a própria regra que Deus nos assinalou: a de termos chegado até vós."
,"14":"Não nos gloriaremos indevidamente, como seria o caso se não tivéssemos chegado até vós, pois na verdade fomos até vós anunciando o Evangelho de Cristo."
,"15":"Não nos orgulhamos desmedidamente, apoiados em trabalhos alheios. E temos a esperança de que, com o progresso da vossa fé, cresceremos mais e mais segundo a nossa regra."
,"16":"Desse modo, levaremos o Evangelho para além das fronteiras da vossa região, sem contudo entrarmos em campo alheio, para não nos orgulharmos de trabalhos realizados por outros, como se fossem feitos por nós."
,"17":"Quem se orgulha, que se orgulhe no Senhor."
,"18":"Pois é aprovado não aquele que faz recomendação de si próprio, mas aquele que Deus recomenda."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Oxalá pudésseis suportar um pouco da minha loucura! É claro que me suportais!"
,"2":"Sinto por vós um ciúme semelhante ao ciúme de Deus. Eu entreguei-vos a um único esposo, a Cristo, a quem devo apresentar-vos como virgem pura."
,"3":"Receio, porém, que assim como a serpente, com a sua astúcia, seduziu Eva, os vossos pensamentos se corrompam, desviando-se da simplicidade devida a Cristo."
,"4":"De facto, se chega alguém e vos prega um Jesus diferente d'Aquele que vos pregámos, ou se vós acolheis um espírito diferente d'Aquele que recebestes, ou um evangelho diverso daquele que abraçastes, vós o suportais de bom grado."
,"5":"Todavia, não me considero inferior em coisa alguma a esses «super-apóstolos!»"
,"6":"Ainda que eu não seja hábil no falar, eu sou-o no saber. Em tudo e de todos os modos, já demostrámos isso."
,"7":"Será que foi um erro meu humilhar-me para vos exaltar, porque vos anunciei gratuitamente o Evangelho de Deus?"
,"8":"Despojei outras Igrejas, recebendo delas o necessário para viver, a fim de vos servir."
,"9":"E quando passei necessidade entre vós, não fui pesado a ninguém, porque os irmãos que vieram da Macedónia supriram às minhas necessidades. Em tudo evitei ser-vos pesado e continuarei a evitá-lo."
,"10":"Pela verdade de Cristo que está em mim, declaro que esse título de glória não me será tirado nas regiões da Acaia."
,"11":"E porquê? Será porque não vos amo? Deus o sabe!"
,"12":"O que faço, continuarei a fazê-lo, a fim de tirar qualquer pretexto àqueles que procuram algum para se gabarem dos mesmos títulos que nós temos."
,"13":"Esses tais são falsos apóstolos, operários fraudulentos, disfarçados de apóstolos de Cristo."
,"14":"E não é de estranhar! O próprio Satanás se disfarça em anjo de luz!"
,"15":"Por isso, não me surpreendo de que os ministros de Satanás se disfarcem como servidores da justiça. Mas o fim deles corresponderá às suas obras."
,"16":"Repito: que ninguém me considere louco, ou então: que me suportem como louco, a fim de que também eu possa gabar-me um pouco."
,"17":"O que vou dizer, não o direi conforme o Senhor, mas como louco, certo de que tenho motivos para me gabar."
,"18":"Visto que muitos se gabam dos seus títulos humanos, também eu vou gabar-me."
,"19":"Vós, assim tão sensatos, suportais de boa vontade os loucos."
,"20":"E suportais que vos escravizem, que vos devorem, que vos despojem, que vos tratem com soberba, que vos esbofeteiem."
,"21":"Digo isto para vossa vergonha: até parece que nós é que somos fracos... Aquilo que outros têm a ousadia de apresentar - falo como louco - eu também tenho. "
,"22":"São hebreus? Eu também. São israelitas? Eu também. São descendentes de Abraão? Eu também."
,"23":"São ministros de Cristo? Falo como louco: eu sou-o muito mais. Muito mais pelas fadigas; muito mais pelas prisões; infinitamente mais pelos açoites; frequentemente em perigo de morte;"
,"24":"dos judeus recebi cinco vezes os quarenta golpes menos um."
,"25":"Fui flagelado três vezes; uma vez fui apedrejado; três vezes naufraguei; passei um dia e uma noite no alto mar."
,"26":"Fiz muitas viagens. Sofri perigos nos rios, perigos por parte dos ladrões, perigos por parte dos meus irmãos de raça, perigos por parte dos pagãos, perigos na cidade, perigos no deserto, perigos no mar, perigos por parte dos falsos irmãos."
,"27":"Mais ainda: morto de cansaço, muitas noites sem dormir, fome e sede, muitos jejuns, com frio e sem agasalho."
,"28":"E isto para não contar o resto: a minha preocupação quotidiana, a atenção que tenho por todas as Igrejas."
,"29":"Quem fraqueja, sem que eu também me sinta fraco? Quem cai, sem que eu me sinta com febre?"
,"30":"Se é preciso gabar-se, é da minha fraqueza que vou gabar-me."
,"31":"O Deus e Pai do Senhor Jesus, que é bendito para sempre, sabe que não minto."
,"32":"Em Damasco, o governador do rei Aretas guardava a cidade dos damascenos com a intenção de me prender;"
,"33":"mas fizeram-me descer de uma janela, ao longo da muralha, dentro de um cesto; e assim eu escapei das mãos dele."
}`)
	CurrentBook.AddChapter(12, `{
"1":"É preciso gabar-se? Embora não convenha, vou mencionar as visões e revelações do Senhor."
,"2":"Conheço um homem em Cristo que há catorze anos foi arrebatado ao terceiro céu. Se estava em seu corpo, não sei; se fora do corpo, não sei; Deus o sabe."
,"3":"Sei apenas que esse homem - se no corpo ou fora do corpo não sei; Deus o sabe! -"
,"4":"foi arrebatado até ao paraíso e ouviu palavras inefáveis, que não são permitidas ao homem repetir."
,"5":"Quanto a esse homem, eu gabar-me-ei; mas quanto a mim, só vou gabar-me das minhas fraquezas."
,"6":"Se eu quisesse gabar-me, não seria louco, pois estaria a dizer a verdade. Mas não o faço, a fim de que ninguém tenha de mim conceito superior àquilo que vê em mim ou me ouve dizer."
,"7":"Para que eu não me inchasse de soberba por causa dessas revelações extraordinárias, foi-me dado um espinho na carne, um anjo de Satanás para me espancar, a fim de que eu não me encha de soberba."
,"8":"Por esse motivo, três vezes pedi ao Senhor que o afastasse de mim."
,"9":"Ele, porém, respondeu-me: «Basta-te a minha graça, pois é na fraqueza que a força manifesta todo o seu poder». Portanto, com muito gosto, prefiro gabar-me das minhas fraquezas, para que a força de Cristo habite em mim."
,"10":"E é por isso que eu me alegro nas fraquezas, humilhações, necessidades, perseguições e angústias, por causa de Cristo. Pois, quando sou fraco, então é que sou forte."
,"11":"Procedi como louco! Mas vós é que me forçastes a isso. Mas vós é que me devíeis recomendar. Pois, embora eu não seja coisa alguma, em nada esses «super-apóstolos» são superiores a mim."
,"12":"De facto, realizaram-se entre vós os sinais do verdadeiro Apóstolo: paciência a toda a prova, sinais, milagres e prodígios."
,"13":"O que é que tivestes menos do que as outras Igrejas, se não o facto de que eu não fui pesado para vós? Perdoai-me esta injustiça!"
,"14":"Estou pronto para ir ter convosco pela terceira vez. E não vos serei pesado, pois o que procuro não são os bens que possuís, mas vós mesmos. Não são os filhos que devem acumular bens para os pais, mas sim os pais para os filhos."
,"15":"Quanto a mim, de boa vontade me gastarei e me desgastarei totalmente em vosso favor. Será que dedicando-vos mais amor, serei por causa disso menos amado?"
,"16":"«Tudo bem», dirão alguns. Eu não vos fui pesado, mas, esperto como sou, conquistei-vos com fraude!"
,"17":"Acaso vos explorei através de algum daqueles que vos enviei?"
,"18":"Pedi a Tito que fosse ter convosco e com ele enviei o outro irmão. Será que Tito vos explorou? Será que não caminhamos no mesmo espírito? E não seguimos os mesmos passos?"
,"19":"Já há muito tempo que pensais que nós queremos justificar-nos diante de vós. Não! Perante Deus, em Cristo, é que falámos. E tudo, caríssimos, para vossa edificação."
,"20":"De facto, receio que, quando aí chegar, não vos encontre tais como desejo encontrar-vos e que vós não me encontreis tal como desejais. Tenho receio de que entre vós haja discórdia, inveja, animosidade, rivalidade, maledicências, falsas acusações, arrogância, desordens."
,"21":"Tenho receio de que, quando voltar a encontrar-vos, o meu Deus me humilhe em relação a vós, e que eu tenha de chorar por muitos que pecaram no passado e ainda não se tenham convertido da impureza, da fornicação e dos vícios que antes praticavam."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Esta é a terceira vez que vou ter convosco. «Qualquer questão será resolvida pela palavra de duas ou três testemunhas»."
,"2":"Eu já o disse antes e, hoje, estando ausente, repito-o, como por ocasião da minha segunda visita, àqueles que pecaram no passado e a todos os outros: quando eu voltar, não usarei de meias medidas,"
,"3":"visto que procurais uma prova de que é Cristo quem fala em mim. Ele não é fraco para convosco, mas mostra o seu poder entre vós."
,"4":"De facto, Ele foi crucificado pela sua fraqueza, mas está vivo pelo poder de Deus. Também nós somos fracos n'Ele, mas com Ele viveremos pelo poder de Deus, para actuar entre vós."
,"5":"Examinai-vos a vós próprios e vede se estais firmes na fé. Fazei uma revisão de vós mesmos. Será que não reconheceis que Jesus Cristo está em vós? A não ser que não passeis na prova!"
,"6":"Espero que reconheçais que nós somos aprovados."
,"7":"Pedimos a Deus que não pratiqueis nenhum mal. O nosso desejo não é aparecer como aprovados, mas sim que vós pratiqueis o bem, ainda que devamos passar como não aprovados."
,"8":"Nada podemos contra a verdade; só temos poder em favor da verdade."
,"9":"E alegramos-nos todas as vezes que nos sentimos fracos, e vós vos sentis fortes. E o que pedimos nas nossas orações é que vos torneis cada vez mais perfeitos."
,"10":"Escrevo essas coisas estando ausente; assim, quando aí chegar, não terei que recorrer à severidade, conforme o poder que o Senhor me deu para construir e não para destruir."
,"11":"Quanto ao resto, irmãos, sede alegres. Procurai a perfeição e animai-vos. Tede os mesmos sentimentos, vivei na paz e o Deus do amor e da paz estará convosco."
,"12":"Saudai-vos uns aos outros com o beijo santo. Todos os cristãos vos enviam saudações."
,"13":"Que a graça do Senhor Jesus Cristo, o amor de Deus e a comunhão do Espírito Santo estejam com todos vós."
}`)

}
func PT_BS_LoadNP2EChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Silvano e Timóteo à Igreja dos Tessalonicenses que está em Deus Pai e no Senhor Jesus Cristo."
,"2":"Para vós, graça e paz da parte de Deus Pai e do Senhor Jesus Cristo."
,"3":"Irmãos, devemos agradecer sempre a Deus por vós! É justo que o façamos, pois a vossa fé está a crescer cada vez mais, e o amor que tendes uns pelos outros está a tornar-se cada vez maior."
,"4":"Deste modo, podemos gloriar-nos de vós entre as Igrejas de Deus, por causa da firmeza e da fé que mostrais no meio de todas as perseguições e tribulações que suportais."
,"5":"Estas provas são o sinal do justo julgamento de Deus: elas existem para que vos torneis dignos do Reino de Deus, pelo qual estais a sofrer."
,"6":"Deus fará o que é justo: vai mandar tribulações àqueles que vos oprimem,"
,"7":"e a vós, que agora sois oprimidos, como também a nós, Ele dará descanso, quando o Senhor Jesus Se manifestar. Ele virá do Céu com os seus anjos poderosos,"
,"8":"no meio de uma chama ardente. Virá para Se vingar daqueles que não conhecem a Deus e não obedecem ao Evangelho do Senhor Jesus."
,"9":"O seu castigo será a ruína eterna, longe da face do Senhor e longe do esplendor da sua majestade."
,"10":"Nesse dia, o Senhor virá para ser glorificado nos seus santos e para ser admirado em todos aqueles que acreditaram. E vós acreditastes no nosso testemunho!"
,"11":"É também por isso que rezamos continuamente por vós, a fim de que o nosso Deus vos torne dignos do chamamento que vos dirigiu. Rezamos também para que Deus, com o seu poder, vos faça realizar todo o bem que desejais e dinamizeis o trabalho da vossa fé."
,"12":"Deste modo, o nome do Senhor Jesus será glorificado em vós e vós também sereis glorificados n'Ele, conforme a graça do nosso Deus e do Senhor Jesus Cristo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Agora, irmãos, quanto à vinda de nosso Senhor Jesus Cristo e ao nosso encontro com Ele, pedimo-vos o seguinte:"
,"2":"não vos deixeis perturbar tão facilmente! Nem vos assusteis, como se o Dia do Senhor estivesse para chegar em breve, mesmo que isso esteja a ser veiculado por alguma suposta inspiração, palavra, ou carta atribuída a nós."
,"3":"Não vos deixeis enganar de nenhum modo! Primeiro deverá chegar a apostasia. Depois aparecerá o homem ímpio, o filho da perdição:"
,"4":"ele é o adversário que se opõe e se levanta contra todo o ser que se chama Deus ou é adorado, chegando até mesmo a sentar-se no templo de Deus e a proclamar-se Deus."
,"5":"Não vos recordais de que eu já dizia essas coisas quando estava convosco?"
,"6":"E agora vós já sabeis o que impede a manifestação do adversário, que acontecerá a seu tempo."
,"7":"O mistério da impiedade já está em acção. Falta apenas desaparecer aquele que o segura até agora."
,"8":"Só então se manifestará o ímpio. O Senhor Jesus destruí-lo-á com o sopro da sua boca e aniquilá-lo-á com o esplendor da sua vinda."
,"9":"A vinda do ímpio vai acontecer graças ao poder de Satanás, com toda a espécie de falsos milagres, sinais e prodígios,"
,"10":"e com toda a sedução que a injustiça exerce sobre os que se perdem, por não se terem aberto ao amor da verdade, amor que os teria salvo."
,"11":"Por isso Deus manda agir neles o poder da sedução, para que acreditem na mentira."
,"12":"Deste modo serão condenados todos os que não acreditaram na verdade, mas preferiram permanecer na injustiça."
,"13":"Nós, porém, devemos sempre agradecer a Deus por vós, irmãos amados do Senhor, porque, desde o início, Deus vos escolheu para serdes salvos pelo Espírito que santifica e pela fé na verdade."
,"14":"Para isso é que Ele vos chamou por meio do nosso Evangelho, a fim de possuirdes a glória de nosso Senhor Jesus Cristo."
,"15":"Por isso, irmãos, permanecei firmes e conservai as tradições que vos ensinámos de viva voz ou por meio da nossa carta."
,"16":"O próprio nosso Senhor Jesus Cristo e Deus nosso Pai, que nos amou e por sua graça nos dá consolo eterno e esperança feliz,"
,"17":"consolem os vossos corações e os fortaleçam para que façam e digam tudo o que é bom."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por fim, irmãos, rezai por nós, a fim de que a palavra do Senhor se espalhe rapidamente e seja bem recebida, como acontece entre vós."
,"2":"Rezai também para que Deus nos livre dos homens ímpios e maus, porque nem todos têm fé."
,"3":"O Senhor, porém, é fiel. Ele vos manterá firmes e vos guardará do Maligno."
,"4":"Temos plena confiança no Senhor de que fazeis e continuareis a fazer o que mandamos."
,"5":"Que o Senhor vos dirija o coração para o amor a Deus e a perseverança de Cristo."
,"6":"Irmãos, em nome de nosso Senhor Jesus Cristo ordenamos: afastai-vos de todo o irmão que vive sem fazer nada e não segue a tradição que recebeu de nós."
,"7":"Vós sabeis como deveis imitar-nos: nós não ficámos sem fazer nada quando estivemos entre vós,"
,"8":"nem pedimos a ninguém o pão que comemos; pelo contrário, trabalhámos com fadiga e esforço, noite e dia, para não sermos de peso para nenhum de vós."
,"9":"Não porque não tivéssemos direito a isso, mas porque nós quisemos ser um exemplo a imitar."
,"10":"De facto, quando estávamos entre vós, demos esta norma: quem não quer trabalhar, também não coma."
,"11":"Ouvimos dizer que há entre vós pessoas que vivem à toa, sem fazer nada e em contínua agitação."
,"12":"A essas pessoas mandamos e pedimos, no Senhor Jesus Cristo, que comam o próprio pão, trabalhando em paz."
,"13":"Quanto a vós, irmãos, não vos canseis de fazer o bem."
,"14":"Se alguém não obedecer ao que dizemos nesta carta, assinalai-o e não contacteis com ele, para que se envergonhe;"
,"15":"mas não o trateis como um inimigo; ao contrário, corrigi-o como a um irmão."
,"16":"Que o próprio Senhor da paz vos conceda a paz, sempre e de todos os modos. O Senhor esteja com todos vós."
,"17":"A saudação é de meu próprio punho: Paulo. Este é o sinal que distingue as minhas cartas. É a minha letra."
,"18":"Que a graça de nosso Senhor Jesus Cristo esteja com todos vós!"
}`)

}
func PT_BS_LoadNP2IChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Apóstolo de Jesus Cristo por vontade de Deus, para anunciar a promessa da vida em Jesus Cristo,"
,"2":"ao amado filho Timóteo: graça, misericórdia e paz da parte de Deus Pai e de Jesus Cristo nosso Senhor."
,"3":"Agradeço a Deus, a quem sirvo com consciência limpa como os meus antepassados, enquanto me recordo sempre de ti nas minhas orações, noite e dia."
,"4":"Quando me lembro das lágrimas que derramaste, sinto grande desejo de te voltar a ver e, assim, transbordar de alegria."
,"5":"Lembro-me da fé sincera que há em ti, a mesma que havia antes na tua avó Lóide, depois na tua mãe Eunice e que agora, estou convencido, também há em ti."
,"6":"Por esse motivo, convido-te a reavivar o dom de Deus que está em ti pela imposição das minhas mãos."
,"7":"De facto, Deus não nos deu um espírito de medo, mas um espírito de força, de amor e de sabedoria."
,"8":"Não te envergonhes, portanto, de dar testemunho de nosso Senhor, nem de mim, seu prisioneiro; pelo contrário, participa do meu sofrimento pelo Evangelho, confiando no poder de Deus."
,"9":"Ele salvou-nos e chamou-nos com uma vocação santa, não por causa das nossas obras, mas conforme o seu próprio projecto e graça. Esta graça foi-nos concedida em Jesus Cristo desde a eternidade,"
,"10":"mas somente agora foi revelada pela aparição do nosso Salvador Jesus Cristo. Ele não só venceu a morte, mas também fez brilhar a vida e a imortalidade por meio do Evangelho,"
,"11":"do qual eu fui constituído anunciador, Apóstolo e mestre."
,"12":"Esta é a causa dos males que estou a sofrer. Todavia, não me envergonho, porque sei em quem coloquei a minha fé, e estou certo de que Ele tem poder para guardar o meu depósito até àquele Dia."
,"13":"Toma por modelo as sãs palavras que ouviste de mim, com a fé e o amor que estão em Jesus Cristo."
,"14":"Guarda o bom depósito com o auxílio do Espírito Santo que habita em nós."
,"15":"Sabes que todos os da Ásia me abandonaram, e entre eles Figelo e Hermógenes."
,"16":"Que o Senhor conceda misericórdia à família de Onesíforo, porque ele muitas vezes me confortou e não se envergonhou de eu estar preso;"
,"17":"pelo contrário, quando chegou a Roma, procurou-me com insistência, até me encontrar."
,"18":"Que o Senhor lhe conceda misericórdia junto a Deus naquele Dia. E quanto aos serviços que ele me prestou em Éfeso, tu sabe-lo melhor do que eu."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tu, porém, fortifica-te sempre na graça que está em Jesus Cristo."
,"2":"O que ouviste de mim na presença de muitas testemunhas, transmite-o a homens de confiança que, por sua vez, estejam em grau de o ensinar a outros."
,"3":"Participa dos sofrimentos como bom soldado de Jesus Cristo."
,"4":"Ao alistar-se no exército, ninguém se deixará envolver pelas questões da vida civil, se quiser satisfazer a quem o alistou no regimento."
,"5":"Do mesmo modo, um atleta não receberá a coroa se não tiver lutado conforme as regras."
,"6":"O agricultor que trabalha deve ser o primeiro a participar dos frutos."
,"7":"Procura compreender o que estou a tentar dizer-te, e o Senhor certamente dar-te-á inteligência em todas as coisas."
,"8":"Lembra-te de que Jesus Cristo, descendente de David, ressuscitou dos mortos. Este é o meu Evangelho,"
,"9":"pelo qual eu sofro, a ponto de estar acorrentado como um malfeitor. Mas a Palavra de Deus não está algemada."
,"10":"É por isso que tudo suporto por causa dos escolhidos, para que também eles alcancem a salvação que está em Jesus Cristo, com a glória eterna."
,"11":"Estas palavras são verdadeiras: Se com Ele morremos, com Ele viveremos;"
,"12":"se com Ele sofremos, com Ele reinaremos. Se O renegamos, também Ele nos renegará."
,"13":"Se Lhe formos infiéis, Ele permanece fiel, pois não pode renegar-Se,a Si mesmo."
,"14":"Lembra-te destas coisas, testemunhando diante de Deus que é preciso evitar as discussões inúteis, que não servem para nada, a não ser para a perdição dos que as ouvem."
,"15":"Procura apresentar-te a Deus como homem digno de aprovação, como trabalhador que não tem de que se envergonhar e que distribui com rectidão a Palavra da verdade."
,"16":"Evita o palavreado inútil dessa gente que se vai tornando cada vez mais ímpia;"
,"17":"a sua palavra é como gangrena que se alastra. Entre eles encontram-se Himeneu e Fileto."
,"18":"Estes desviaram-se da verdade, dizendo que a ressurreição já aconteceu e estão a perverter a fé em várias pessoas."
,"19":"Apesar disso, o sólido alicerce colocado por Deus permanece, marcado pelo selo desta palavra: «O Senhor conhece os que são seus». E ainda: «Afaste-se da injustiça todo aquele que pronuncia o nome do Senhor»."
,"20":"Numa casa grande, não há somente vasos de ouro e prata; há também de madeira e barro. Alguns são para uso nobre, outros para uso comum."
,"21":"Aquele que se purificar desses erros será vaso nobre, santificado, útil para o seu dono e preparado para toda a boa obra."
,"22":"Foge das paixões da juventude; segue a justiça e a fé, o amor e a paz com aqueles que invocam de coração puro o nome do Senhor."
,"23":"Evita questões loucas e não educativas que provocam brigas."
,"24":"Um servo do Senhor não deve ser quezilento, mas manso para com todos, competente no ensino, paciente nas ofensas sofridas."
,"25":"É com suavidade que deves educar os opositores, esperando que Deus lhes dará não só a conversão, para conhecerem a verdade,"
,"26":"mas também o retorno ao bom senso, libertando-os do laço do diabo, que os conservava presos para lhe fazerem a vontade."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Sabe, porém, que nos últimos dias haverá momentos difíceis."
,"2":"Os homens serão egoístas, gananciosos, soberbos, blasfemos, rebeldes com os pais, ingratos, iníquos,"
,"3":"sem afecto, implacáveis, mentirosos, incontinentes, cruéis, inimigos do bem,"
,"4":"traidores, atrevidos, enfatuados, mais amigos dos prazeres do que de Deus;"
,"5":"manterão aparências de piedade, mas negarão a sua força interior. Evita essas pessoas!"
,"6":"Entre esses encontram-se os que entram nas casas e cativam mulherzinhas cheias de pecados e possuídas por todo o tipo de desejos,"
,"7":"que estão sempre a aprender, mas não conseguem chegar ao conhecimento da verdade."
,"8":"E assim como Janes e Jambres se opuseram a Moisés, também esses se opõem à verdade; são homens de espírito corrupto e fé inconsistente."
,"9":"Mas não irão longe, pois a sua loucura será desmascarada diante de todos, como aconteceu com aqueles dois."
,"10":"Tu, porém, seguiste-me de perto no ensino e no comportamento, nos projectos, na fé, na paciência, no amor e na perseverança,"
,"11":"nas perseguições e sofrimentos que tive em Antioquia, em Icónio e Listra. Que perseguições sofri! Mas de todas elas o Senhor me livrou."
,"12":"Assim, também, todos os que querem viver com piedade em Jesus Cristo serão perseguidos."
,"13":"Quanto aos maus e impostores, eles progredirão no mal, enganando e sendo enganados."
,"14":"Quanto a ti, permanece firme naquilo que aprendeste e aceitaste como certo, pois sabes de quem o aprendeste."
,"15":"Desde a infância que conheces as Sagradas Escrituras; elas têm o poder de te comunicar a sabedoria que conduz à salvação pela fé em Jesus Cristo."
,"16":"Toda a Escritura é inspirada por Deus e é útil para ensinar, para refutar, para corrigir, para educar na justiça,"
,"17":"a fim de que o homem de Deus seja perfeito, preparado para toda a boa obra."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Rogo-te diante de Deus e de Jesus Cristo, que há-de vir para julgar os vivos e os mortos, pela sua manifestação e pelo seu Reino:"
,"2":"proclama a Palavra, insiste no tempo oportuno e inoportuno, advertindo, reprovando e aconselhando com toda a paciência e doutrina."
,"3":"Pois vai chegar o tempo em que já não se suportará a doutrina; pelo contrário, desejosos de ouvir novidades, os homens rodear-se-ão de mestres a seu bel-prazer."
,"4":"Desviarão os ouvidos da verdade orientando-os para as fábulas."
,"5":"Quanto a ti, sê sóbrio em tudo, suporta o sofrimento, faz o trabalho de um anunciador do Evangelho, realiza plenamente o teu ministério."
,"6":"Quanto a mim, o meu sangue está para ser derramado em libação, e chegou o tempo da minha partida."
,"7":"Combati o bom combate, terminei a minha corrida, conservei a fé."
,"8":"Agora só me resta a coroa da justiça que o Senhor, justo Juiz, me entregará naquele Dia; e não somente a mim, mas a todos os que tiverem esperado com amor a sua manifestação."
,"9":"Apressa-te a vir ter comigo,"
,"10":"pois Demas abandonou-me, preferindo o mundo presente. Ele partiu para Tessalónica, Crescente para a Galácia, Tito para a Dalmácia."
,"11":"Somente Lucas está comigo. Procura Marcos e traze-o contigo, porque ele pode ajudar-me no ministério."
,"12":"Mandei Tíquico para Éfeso."
,"13":"Quando vieres, traz-me o manto que deixei em Tróade, em casa de Carpo. Traz também os livros, principalmente os pergaminhos."
,"14":"Alexandre, o ferreiro, fez-me muito mal. O Senhor o recompensará conforme as suas obras."
,"15":"Tu também, toma cuidado com ele, pois ele opôs-se muito à nossa pregação."
,"16":"Na minha primeira defesa no tribunal, ninguém ficou ao meu lado; todos me abandonaram. Que Deus não lhes ponha isso na conta!"
,"17":"Mas o Senhor ficou comigo e encheu-me de força, a fim de que pudesse anunciar toda a mensagem, e ela chegasse aos ouvidos de todas as nações. E assim fui libertado da boca do leão."
,"18":"O Senhor me libertará de todo o mal e me levará para o seu Reino eterno. Ao Senhor, glória para sempre. Ámen!"
,"19":"Saudações a Prisca e Áquila e à família de Onesíforo."
,"20":"Erasto ficou em Corinto. Deixei Trófimo doente em Mileto."
,"21":"Procura vir antes do Inverno. Êubulo, Pudente, Lino, Cláudia e todos os irmãos enviam-te saudações."
,"22":"O Senhor esteja com o teu espírito. A graça esteja com todos vós."
}`)

}
func PT_BS_LoadNPCLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Apóstolo de Jesus Cristo pela vontade de Deus, juntamente com o irmão Timóteo,"
,"2":"aos cristãos de Colossos, fiéis irmãos em Cristo. Que a graça e a paz de Deus, nosso Pai, estejam convosco."
,"3":"Damos graças a Deus, Pai de nosso Senhor Jesus Cristo, sempre que rezamos por vós."
,"4":"De facto, ouvimos falar da fé que tendes em Jesus Cristo, e do vosso amor por todos os cristãos,"
,"5":"por causa da esperança daquilo que vos está reservado no céu. Tal esperança já vos foi anunciada pela Palavra da Verdade, o Evangelho,"
,"6":"que chegou até vós. Assim como o Evangelho dá fruto e cresce no mundo inteiro, o mesmo acontece entre vós, desde o dia em que ouvistes e conhecestes na verdade a graça de Deus."
,"7":"Aprendestes a conhecê-la pela pregação de Épafras, nosso querido companheiro de serviço, que nos substituiu fielmente como ministro de Cristo."
,"8":"Foi ele quem nos contou sobre o amor com que o Espírito vos anima."
,"9":"Por essa razão, desde que soubemos disso, rezamos continuamente por vós. Pedimos que Deus vos conceda pleno conhecimento da sua vontade, com toda a sabedoria e discernimento que vêm do Espírito."
,"10":"Deste modo, vivereis uma vida digna do Senhor, fazendo tudo o que Ele aprova: dareis fruto em toda a actividade boa e crescereis no conhecimento de Deus,"
,"11":"fortalecidos em todos os sentidos pelo poder da sua glória. Assim tereis perseverança e paciência a toda a prova."
,"12":"Com alegria, dai graças ao Pai, que vos permitiu participar da herança dos cristãos, na luz."
,"13":"Deus Pai arrancou-nos do poder das trevas e transferiu-nos para o Reino do seu Filho amado,"
,"14":"no qual temos a redenção, a remissão dos pecados."
,"15":"Ele é a imagem do Deus invisível, o Primogénito, anterior a qualquer criatura;"
,"16":"porque n'Ele foram criadas,todas as coisas, tanto as celestes como as terrestres, tanto as visíveis como as invisíveis: tronos, soberanias, principados,e autoridades. Tudo foi criado por meio d'Ele,e para Ele."
,"17":"Ele existe antes de todas as coisas, e tudo n'Ele subsiste."
,"18":"Ele é também a Cabeça do corpo, que é a Igreja. Ele é o Princípio, o primeiro daqueles,que ressuscitam dos mortos, para em tudo ter a primazia."
,"19":"Porque Deus, a Plenitude total, quis n'Ele habitar,"
,"20":"para, por meio d'Ele, reconciliar consigo todas as coisas, tanto as terrestres como as celestes, estabelecendo a paz,pelo seu sangue derramado na cruz."
,"21":"Antigamente éreis estrangeiros e inimigos de Deus, por causa das obras más que praticáveis e pensáveis."
,"22":"Agora, porém, com a morte que Cristo sofreu no seu corpo mortal, Deus reconciliou-vos para vos tornar santos, sem mancha e sem reprovação diante d'Ele."
,"23":"Isto tudo, sob a condição de permanecerdes alicerçados e firmes na fé, sem vos deixardes afastar da esperança no Evangelho que ouvistes e que foi anunciado a toda a criatura que vive debaixo do céu. Eu, Paulo, tornei-me ministro desse Evangelho."
,"24":"Agora eu alegro-me de sofrer por vós, pois vou completando na minha carne o que falta aos sofrimentos de Cristo, a favor do seu corpo, que é a Igreja."
,"25":"Eu tornei-me ministro da Igreja, quando Deus me confiou este encargo em vosso benefício: anunciar a realização da Palavra de Deus,"
,"26":"o mistério escondido desde o começo dos tempos e gerações, e que agora é revelado aos cristãos."
,"27":"Deus quis manifestar aos cristãos a riqueza gloriosa que este mistério representa para os pagãos, isto é, o facto de que Cristo, a glória esperada, está em vós."
,"28":"É a esse Cristo que anunciamos, aconselhando e ensinando a todos com plena sabedoria, para que todos sejam cristãos perfeitos."
,"29":"É para isso que me esforço e luto, sustentado pela força de Cristo que age de forma poderosa em mim."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quero que saibais da difícil luta que enfrento por vós, pelos de Laodiceia e por todos aqueles que nunca me viram pessoalmente."
,"2":"Sofro para que eles sejam confortados e assim, estreitamente unidos no amor, se enriqueçam com a plenitude da compreensão, a fim de conhecerem o mistério de Deus: Cristo,"
,"3":"no qual estão escondidos todos os tesouros da sabedoria e ciência."
,"4":"Digo isto para que ninguém vos engane com belos discursos."
,"5":"Pois, embora eu esteja fisicamente ausente, estou convosco em espírito, alegrando-me por ver que viveis em ordem e firmes na fé em Cristo. Enraizados em Cristo - "
,"6":"Já que aceitastes Jesus Cristo como Senhor, vivei como cristãos:"
,"7":"enraizados n'Ele, edificais-vos sobre Ele e apoiais-vos na fé que vos foi ensinada, transbordando em acções de graças."
,"8":"Cuidado para que ninguém vos escravize através de filosofias enganosas e vãs, de acordo com tradições humanas, que se baseiam nos elementos do mundo, e não em Cristo."
,"9":"É em Cristo que habita, em forma corporal, toda a plenitude da divindade."
,"10":"Em Cristo tendes tudo de modo pleno. Ele é a cabeça de todo o principado e de toda a autoridade."
,"11":"Em Cristo fostes circuncidados com uma circuncisão não feita por mãos humanas, mas com a circuncisão de Cristo, a qual consiste em despojar-se do corpo carnal."
,"12":"Com Ele, fostes sepultados no baptismo, e n'Ele fostes também ressuscitados mediante a fé no poder de Deus, que ressuscitou Cristo dos mortos."
,"13":"Vós estáveis mortos por causa das faltas e da incircuncisão da carne, mas Deus concedeu-vos a vida juntamente com Cristo: Ele perdoou todas as nossas faltas,"
,"14":"anulou o título de dívida,que havia contra nós, deixando de lado,as exigências legais; fez desaparecer o título, pregando-o na cruz;"
,"15":"destituiu os principados,e autoridades, oferecendo-os,em espectáculo público, após triunfar sobre eles,por meio de Cristo."
,"16":"Ninguém, pois, vos julgue pelo que comeis ou bebeis, ou por causa de festas anuais, mensais ou de sábados."
,"17":"Tudo isso é apenas sombra daquilo que devia vir. A realidade é Cristo."
,"18":"Que ninguém, com humildade afectada ou culto aos anjos, vos impeça de conseguir a vitória; essas pessoas fecham-se nas suas visões e incham-se de orgulho com o seu modo de pensar."
,"19":"Eles não estão unidos à Cabeça, a qual, através de junturas e articulações, dá alimento e coesão ao corpo inteiro, fazendo-o crescer como Deus quer."
,"20":"Se morrestes com Cristo para os elementos do mundo, porque vos submeteis a normas, como se ainda estivésseis sujeitos ao mundo,"
,"21":"normas como estas: «Não pegues, não proves, não toques»?"
,"22":"Todas essas coisas se desgastam pelo uso. E essas proibições são preceitos e doutrinas de homens."
,"23":"Tais regras de piedade, humildade e severidade com o corpo têm ares de sabedoria, mas na verdade não têm nenhum valor, a não ser a satisfação da carne."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Se ressuscitastes com Cristo, procurai as coisas do alto, onde Cristo está sentado à direita de Deus."
,"2":"Pensai nas coisas do Alto, e não nas coisas da Terra."
,"3":"Vós estais mortos, e a vossa vida está escondida com Cristo em Deus."
,"4":"Quando Cristo Se manifestar, Ele que é a nossa vida, então também vós vos manifestareis com Ele na glória."
,"5":"Fazei morrer aquilo que em vós pertence à terra: fornicação, impureza, paixão, desejos maus e a cobiça de possuir, que é uma idolatria."
,"6":"Isso é o que atrai a ira de Deus sobre os rebeldes."
,"7":"Outrora, também vós éreis assim, quando vivíeis entre eles."
,"8":"Agora, porém, abandonai tudo isso: ira, raiva, maldade, maledicência e palavras obscenas que saem da vossa boca."
,"9":"Não mintais uns aos outros. De facto, fostes despojados do homem velho e das suas acções,"
,"10":"e revestistes-vos do homem novo que, através do conhecimento, se vai renovando à imagem do seu Criador."
,"11":"E aí já não há grego nem judeu, circunciso ou incircunciso, estrangeiro ou bárbaro, escravo ou livre, mas apenas Cristo, que é tudo em todos."
,"12":"Como escolhidos de Deus, santos e amados, revesti-vos de sentimentos de compaixão, bondade, humildade, mansidão, paciência."
,"13":"Suportai-vos uns aos outros e perdoai-vos mutuamente, sempre que tiverdes queixa contra alguém. Cada um perdoe ao outro, do mesmo modo que o Senhor vos perdoou."
,"14":"E acima de tudo, revesti-vos com o amor, que é o laço da perfeição."
,"15":"Que a paz de Cristo reine no vosso coração. Para essa paz fostes chamados, como membros de um mesmo corpo. Sede agradecidos."
,"16":"Que a palavra de Cristo permaneça em vós com toda a sua riqueza, ensinando-vos e admoestando-vos mutuamente com toda a sabedoria. Inspirados pela graça, cantai a Deus, de todo o coração, salmos, hinos e cânticos espirituais."
,"17":"E tudo o que fizerdes através de palavras ou acções, fazei-o em nome do Senhor Jesus, dando graças a Deus Pai por meio d'Ele."
,"18":"Mulheres, sede submissas aos vossos maridos, pois assim convém a mulheres cristãs."
,"19":"Maridos, amai as vossas mulheres e não sejais grosseiros com elas."
,"20":"Filhos, obedecei em tudo a vossos pais, porque isso agrada ao Senhor."
,"21":"Pais, não irriteis os vossos filhos, para que eles não desanimem."
,"22":"Escravos, obedecei em tudo aos vossos senhores humanos, não só quando vigiados, para agradar aos homens, mas com simplicidade de coração, por temor ao Senhor."
,"23":"Tudo o que fizerdes fazei-o de coração, como quem obedece ao Senhor, e não aos homens,"
,"24":"sabendo que recebereis do Senhor a herança como recompensa. O Senhor, a quem servis, é Cristo."
,"25":"Quem comete injustiça, receberá a injustiça, pois não há distinção de pessoas."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Senhores, tratai os vossos escravos com justiça e igualdade, sabendo que tendes um Senhor no Céu."
,"2":"Sede constantes na oração; que ela vos mantenha vigilantes, dando graças a Deus."
,"3":"Ao mesmo tempo, pedi por nós, para que Deus nos abra uma porta para a pregação, a fim de anunciarmos o mistério de Cristo, por quem estou preso."
,"4":"Pedi para que eu anuncie esse mistério com linguagem conveniente."
,"5":"Usai de sabedoria com os que não são cristãos, aproveitando bem as ocasiões."
,"6":"Que a vossa conversa seja sempre agradável, temperada com sal, sabendo responder a cada um como convém."
,"7":"O querido irmão Tíquico, ministro fiel e companheiro no Senhor, dar-vos-á todas as informações a meu respeito."
,"8":"É com essa finalidade que eu o envio, para vos animar e para que saibais de tudo a nosso respeito."
,"9":"Com ele vai Onésimo, nosso querido e fiel irmão, e que pertence ao vosso grupo. Eles contarão tudo o que acontece por aqui."
,"10":"Aristarco, meu companheiro de prisão, e Marcos, primo de Barnabé, mandam saudações. Sobre Marcos já mandei recomendações; se ele for visitar-vos, acolhei-o bem."
,"11":"Jesus, apelidado Justo, também manda saudações. Estes são os únicos judeus que trabalham comigo pelo Reino de Deus, e são de grande consolação para mim."
,"12":"Épafras, do vosso grupo e servo de Jesus Cristo, manda saudações. Com as suas orações, ele não cessa de lutar em vosso favor, para que vos mantenhais perfeitos, observando plenamente a vontade de Deus."
,"13":"Eu sou testemunha de que ele se empenha muito por vós e por aqueles que estão em Laodiceia e Hierápolis."
,"14":"Lucas, o querido médico, e Demas mandam saudações."
,"15":"Saudai os irmãos de Laodiceia, como também Ninfas e a Igreja que se reúne em sua casa."
,"16":"Depois de lerdes esta carta, fazei que seja lida também na igreja de Laodiceia. E vós, lede a de Laodiceia."
,"17":"Por fim, dizei a Arquipo: «Procura realizar bem o ministério que recebeste do Senhor»."
,"18":"A saudação é de minha própria mão: Paulo. Lembrai-vos de que estou preso!,A graça esteja convosco."
}`)

}
func PT_BS_LoadNPEPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Apóstolo de Jesus Cristo pela vontade de Deus, aos cristãos que estão em Éfeso e fiéis em Jesus Cristo."
,"2":"Que a graça e a paz da parte de Deus nosso Pai e do Senhor Jesus Cristo estejam convosco."
,"3":"Bendito seja o Deus,e Pai de nosso Senhor Jesus Cristo: Ele nos abençoou com todas,as bênçãos espirituais, no Céu, em Cristo."
,"4":"Ele nos escolheu em Cristo,antes de criar o mundo,para que sejamos santos,e sem defeito diante d'Ele, no amor."
,"5":"Ele nos predestinou para sermos seus filhos adoptivos,por meio de Jesus Cristo, conforme a benevolência,da sua vontade,"
,"6":"para o louvor da sua glória,e da graça que Ele derramou,abundantemente sobre nós,por meio do seu Filho querido."
,"7":"Por meio do sangue de Cristo,é que fomos libertos, e n'Ele,as nossas faltas foram perdoadas, conforme a riqueza da sua graça."
,"8":"Deus derramou sobre nós,essa graça, abrindo-nos para toda a sabedoria e inteligência."
,"9":"Ele fez-nos conhecer o mistério,da sua vontade, a livre decisão,que havia tomado outrora"
,"10":"de levar a História à sua plenitude, reunindo o Universo inteiro, tanto as coisas celestes,como as terrestres, sob uma só Cabeça, Cristo."
,"11":"Em Cristo recebemos,a nossa parte na herança, conforme o projecto d'Aquele,que tudo conduz,segundo a sua vontade: fomos predestinados"
,"12":"a ser o louvor da sua glória, nós, que já antes esperávamos,em Cristo."
,"13":"Em Cristo, também vós ouvistes,a Palavra da verdade, o Evangelho que vos salva. Em Cristo, ainda, acreditastes, e fostes marcados com o selo,do Espírito prometido, o Espírito Santo,"
,"14":"que é a garantia da nossa herança, enquanto esperamos,a completa libertação do povo,que Deus adquiriu para o louvor,da sua glória."
,"15":"Tenho ouvido falar da fé que tendes no Senhor Jesus e do vosso amor para com todos os cristãos."
,"16":"Por isso, não cesso de dar graças a vosso respeito, quando vos menciono nas minhas orações."
,"17":"Que o Deus de nosso Senhor Jesus Cristo, o Pai a quem pertence a glória, vos dê um espírito de sabedoria que vos revele Deus e faça que O conheçais profundamente."
,"18":"Que vos ilumine os olhos da mente, para que compreendais a esperança para a qual Ele vos chamou; para que entendais como é rica e gloriosa a herança destinada ao seu povo;"
,"19":"e compreendais o grandioso poder com que Ele age em favor de nós que acreditamos, conforme a sua força poderosa e eficaz."
,"20":"Ele manifestou-a em Cristo, quando O ressuscitou dos mortos e O fez sentar-Se à sua direita no Céu,"
,"21":"muito acima de qualquer principado, autoridade, poder e soberania, e de qualquer outro nome que se possa nomear, não só no presente, mas também no futuro."
,"22":"De facto, Deus colocou tudo debaixo dos pés de Cristo e colocou-O acima de todas as coisas, como Cabeça da Igreja,"
,"23":"a qual é o seu corpo, a plenitude d'Aquele que plenifica tudo em todas as coisas."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Vós estáveis mortos por causa das faltas e pecados que cometíeis."
,"2":"Outrora vivíeis nessas faltas e pecados, seguindo o modo de pensar deste mundo, seguindo o príncipe do poder do ar, o espírito que agora age nos homens desobedientes."
,"3":"Antigamente também nós andávamos como eles, submetidos aos desejos da carne, obedecendo aos caprichos do instinto e da imaginação; como os outros, éramos, por natureza, merecedores da ira de Deus."
,"4":"Mas Deus, que é rico em misericórdia, pelo grande amor com que nos amou,"
,"5":"deu-nos a vida juntamente com Cristo, quando estávamos mortos por causa das nossas faltas. Fostes salvos pela graça!"
,"6":"Na pessoa de Jesus Cristo, Deus ressuscitou-nos e fez-nos sentar no Céu."
,"7":"Assim, com a sua bondade para connosco em Jesus Cristo, Ele quis mostrar para os tempos futuros a incomparável riqueza da sua graça."
,"8":"De facto, fostes salvos pela graça, por meio da fé; e isto não vem de vós, mas é dom de Deus."
,"9":"Isto não vem das obras, para que ninguém se encha de orgulho."
,"10":"Porque foi Deus quem nos fez, e em Jesus Cristo fomos criados para as boas obras que Deus já havia preparado, a fim de que nos ocupássemos com elas."
,"11":"Lembrai-vos de que vós, pagãos de nascimento, éreis chamados incircuncisos por aqueles que se dizem circuncidados, devido à circuncisão que se faz na carne com mão humana."
,"12":"Lembrai-vos de que nesse tempo estáveis sem Cristo, afastados da cidadania de Israel, estranhos para as alianças da promessa, sem esperança e sem Deus neste mundo."
,"13":"Mas agora, em Jesus Cristo, vós que estáveis longe fostes trazidos para perto, graças ao sangue de Cristo."
,"14":"Cristo é a nossa paz. De dois povos, Ele fez um só. Na sua carne derrubou o muro da separação: o ódio."
,"15":"Aboliu a Lei dos mandamentos e preceitos. Ele quis, a partir do judeu e do pagão, criar em Si mesmo um homem novo, estabelecendo a paz."
,"16":"Quis reconciliá-los com Deus num só corpo, por meio da cruz; foi nela que Cristo matou o ódio."
,"17":"Ele veio anunciar a paz a vós, que estáveis longe, e a paz àqueles que estavam perto."
,"18":"Por meio de Cristo, podemos, uns e outros, apresentar-nos diante do Pai, num só Espírito."
,"19":"Vós, portanto, já não sois estrangeiros nem hóspedes, mas concidadãos do povo de Deus e membros da família de Deus."
,"20":"Pertenceis ao edifício que tem como alicerce os Apóstolos e os profetas; e o próprio Jesus Cristo é a pedra principal dessa construção."
,"21":"Em Cristo, toda a construção se ergue, bem ajustada, para formar um templo santo no Senhor."
,"22":"Em Cristo, também vós sois integrados nessa construção, para vos tornardes morada de Deus, por meio do Espírito."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por isso, é que eu, Paulo, estou prisioneiro de Cristo em favor de vós, os pagãos..."
,"2":"Certamente ouvistes falar do modo como a graça de Deus me foi confiada em vosso benefício."
,"3":"Foi por revelação que Deus me fez conhecer o mistério que acabo de expor brevemente."
,"4":"Lendo esta carta, podereis entender a percepção que eu tenho do mistério de Cristo."
,"5":"Deus não manifestou esse mistério às gerações passadas da mesma forma com que o revelou agora, pelo Espírito, aos seus santos Apóstolos e profetas:"
,"6":"em Jesus Cristo, por meio do Evangelho, os pagãos são chamados a participar da mesma herança, a formar o mesmo corpo e a participar da mesma promessa."
,"7":"Eu fui feito ministro desse Evangelho pelo dom da graça que Deus me concedeu através do seu poder eficaz."
,"8":"A mim, o menor de todos os cristãos, foi dada a graça de anunciar aos pagãos a incalculável riqueza de Cristo,"
,"9":"e de esclarecer a todos como se realiza o mistério que esteve sempre escondido em Deus, o Criador do Universo."
,"10":"Deste modo, os principados e as autoridades no Céu doravante conhecem, graças à Igreja, a multiforme sabedoria de Deus,"
,"11":"conforme o projecto eterno que Ele executou em Jesus Cristo nosso Senhor."
,"12":"N'Ele ousamos aproximar-nos de Deus com aquela confiança que a fé em Cristo nos dá."
,"13":"Peço-vos: não fiqueis abatidos com as tribulações que eu enfrento por vossa causa, pois elas são motivo de glória para vós."
,"14":"É por isso que eu dobro os joelhos diante do Pai,"
,"15":"de quem recebe o nome toda a família, no Céu e na Terra."
,"16":"Que Ele Se digne, segundo a riqueza da sua glória, fortalecer-vos a todos no seu Espírito, para que o homem interior de cada um se fortifique."
,"17":"Que Ele faça habitar Cristo no vosso coração pela fé. Enraizados e alicerçados no amor,"
,"18":"tornar-vos-ei capazes de compreender, com todos os cristãos, qual é a largura e o comprimento, a altura e a profundidade,"
,"19":"de conhecer o amor de Cristo, que supera qualquer conhecimento, para que fiqueis repletos de toda a plenitude de Deus."
,"20":"Deus, por meio do seu poder que age em nós, pode realizar muito mais do que pedimos ou imaginamos;"
,"21":"a Ele seja dada a glória na Igreja e em Jesus Cristo por todas as gerações, para sempre. Ámen!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Por isso, eu, prisioneiro no Senhor, peço que vos comporteis de modo digno da vocação que recebestes."
,"2":"Sede humildes, amáveis, pacientes e suportai-vos uns aos outros no amor."
,"3":"Mantende entre vós laços de paz, para conservar a unidade do Espírito."
,"4":"Há um só corpo e um só Espírito, assim como fostes chamados a uma só esperança:"
,"5":"há um só Senhor, uma só fé, um só baptismo."
,"6":"Há um só Deus e Pai de todos, que está acima de todos, que age por meio de todos e está presente em todos."
,"7":"Cada um de nós, entretanto, recebeu a graça na medida que Cristo a concedeu."
,"8":"Por isso diz a Escritura: «Subiu às alturas levando prisioneiros; distribuiu dons aos homens»."
,"9":"Que quer dizer «subiu»? Quer dizer que primeiro desceu aos lugares mais baixos da Terra."
,"10":"Aquele que desceu é o mesmo que subiu acima de todos os céus, para plenificar o Universo."
,"11":"Foi Ele quem estabeleceu alguns como Apóstolos, outros como profetas, outros como evangelistas e outros como pastores e mestres."
,"12":"Assim, Ele preparou os cristãos para o trabalho do ministério que constrói o Corpo de Cristo."
,"13":"A meta é que todos juntos nos encontremos unidos na mesma fé e no conhecimento do Filho de Deus, para chegarmos a ser o homem perfeito que, na maturidade do seu desenvolvimento, é a plenitude de Cristo."
,"14":"Então, já não seremos crianças, arrastados pelas ondas e levados para cá e para lá por qualquer vento de doutrina, presos pela artimanha dos homens e pela astúcia com que eles nos induzem ao erro."
,"15":"Pelo contrário, vivendo um amor autêntico, cresceremos sob todos os aspectos em direcção a Cristo, que é a Cabeça."
,"16":"Ele organiza e dá coesão ao corpo inteiro, através de uma rede de articulações, que são os membros, cada um com a sua actividade própria, para que o corpo cresça e se construa a si próprio no amor."
,"17":"Portanto, em nome do Senhor, vos digo e recomendo: não vivais como os pagãos, cuja mente é vazia."
,"18":"A sua inteligência tornou-se cega e vivem muito longe da vida de Deus, porque o endurecimento do seu coração é que os mantém na ignorância."
,"19":"Perderam a sensibilidade e deixaram-se levar pela libertinagem, entregando-se com avidez a todo o tipo de imoralidade."
,"20":"Não foi assim que aprendestes a conhecer Cristo,"
,"21":"se é que de facto Lhe destes ouvidos e fostes mesmo instruídos segundo a verdade que há em Jesus."
,"22":"Deveis deixar de viver como vivíeis antes, como homem velho que se corrompe com paixões enganadoras."
,"23":"É preciso que vos renoveis pela transformação espiritual da inteligência"
,"24":"e vos revistais do homem novo, criado segundo Deus na justiça e na santidade que vem da verdade."
,"25":"Por isso, abandonai a mentira: cada um diga a verdade ao seu próximo, pois somos membros uns dos outros."
,"26":"Se vos irardes, não pequeis; o Sol não se ponha sobre a vossa ira."
,"27":"Não deis ocasião ao diabo."
,"28":"Quem roubava, não roube mais; antes, ocupe-se trabalhando com as próprias mãos em algo útil e tenha assim que repartir com os pobres."
,"29":"Que nenhuma palavra inconveniente saia da vossa boca; ao contrário, se for necessário, dizei uma boa palavra, que seja capaz de edificar e fazer o bem aos que ouvem."
,"30":"Não entristeçais o Espírito Santo, com que Deus vos marcou para o dia da libertação."
,"31":"Afastai de vós qualquer aspereza, desdém, raiva, gritaria, insulto, e toda a espécie de maldade."
,"32":"Sede bons e compreensivos uns com os outros, perdoando-vos mutuamente, assim como Deus vos perdoou em Cristo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Sede imitadores deDeus, como filhos queridos."
,"2":"Vivei no amor, assim como Cristo nos amou e Se entregou a Deus por nós, como oferta e vítima, como perfume agradável."
,"3":"Fornicação, impureza e avareza não sejam nem assunto de conversa entre vós, pois isso não convém a cristãos."
,"4":"O mesmo se diga a respeito de piadas indecentes, picantes ou maliciosas. São coisas inconvenientes. Em vez disso, dai graças a Deus."
,"5":"Podeis estar certos de uma coisa: nenhuma pessoa imoral, impura ou avarenta - pois a avareza é uma idolatria - jamais terá herança no reino de Cristo e de Deus."
,"6":"Ninguém vos engane com argumentos vazios, porque essas coisas atraem a ira de Deus sobre os desobedientes."
,"7":"Não sejais seus cúmplices!"
,"8":"Outrora éreis trevas, mas agora sois luz no Senhor. Por isso, comportai-vos como filhos da luz."
,"9":"O fruto da luz consiste em toda a bondade, justiça e verdade."
,"10":"Procurai discernir o que é agradável ao Senhor."
,"11":"Não participeis das obras infrutuosas das trevas; pelo contrário, denunciai tais obras."
,"12":"Dá até vergonha dizer o que eles fazem às escondidas."
,"13":"Porém, tudo o que é denunciado torna-se manifesto pela luz,"
,"14":"pois tudo o que se torna manifesto é luz. É por isso que se diz: «Desperta, tu que dormes. Levanta-te dentre os mortos e Cristo te iluminará»."
,"15":"Estai atentos à maneira como viveis: não vivais como tolos, mas como homens sensatos,"
,"16":"aproveitando o tempo presente, porque os dias são maus."
,"17":"Não sejais insensatos; antes, procurai compreender a vontade do Senhor."
,"18":"Não vos embriagueis com vinho, que leva à libertinagem, mas procurai a plenitude do Espírito."
,"19":"Juntos recitai salmos, hinos e cânticos inspirados, cantando e louvando ao Senhor de todo o coração."
,"20":"Agradecei sempre a Deus Pai por todas as coisas, em nome de nosso Senhor Jesus Cristo."
,"21":"Sede submissos uns aos outros no temor de Cristo."
,"22":"As mulheres sejam submissas aos seus maridos, como ao Senhor."
,"23":"De facto, o marido é a cabeça da sua esposa, assim como Cristo, salvador do Corpo, é a cabeça da Igreja."
,"24":"E assim como a Igreja está submissa a Cristo, assim também as mulheres sejam submissas em tudo aos seus maridos."
,"25":"Maridos, amai as vossas mulheres, como Cristo amou a Igreja e Se entregou por ela;"
,"26":"assim, Ele a purificou com o banho de água e a santificou pela Palavra,"
,"27":"para apresentar a Si mesmo uma Igreja gloriosa, sem mancha nem ruga ou qualquer outro defeito, mas santa e imaculada."
,"28":"Portanto, os maridos devem amar as suas mulheres como aos seus próprios corpos. Quem ama a sua mulher, está amando a si mesmo."
,"29":"Ninguém odeia a sua própria carne; pelo contrário, nutre-a e cuida dela, como Cristo faz com a Igreja,"
,"30":"porque somos membros do seu corpo."
,"31":"Por isso o homem deixará seu pai e sua mãe e unir-se-á à sua mulher, e os dois serão uma só carne."
,"32":"Este mistério é grande: eu refiro-me a Cristo e à Igreja."
,"33":"Portanto, cada um de vós ame a sua mulher como a si mesmo, e a mulher respeite o seu marido."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Filhos, obedecei a vossos pais no Senhor, pois isso é justo."
,"2":"«Honra teu pai e tua mãe» é o primeiro mandamento, e vem acompanhado de uma promessa:"
,"3":"«para que sejas feliz e tenhas vida longa sobre a Terra»."
,"4":"Pais, não deis aos filhos motivo de revolta contra vós; criai os filhos, educando-os e corrigindo-os como quer o Senhor."
,"5":"Escravos, obedecei aos vossos senhores nesta vida, com temor e tremor, com simplicidade de coração, como a Cristo."
,"6":"Não sirvais somente quando vigiados ou para que os homens vos elogiem, mas sede como servos de Cristo, que cumprem de todo o coração a vontade de Deus."
,"7":"Servi de bom grado, como se servísseis ao Senhor e não a homens."
,"8":"Vós sabeis que cada um, escravo ou livre, receberá do Senhor o bem que tiver feito."
,"9":"Senhores, tratai os vossos servos do mesmo modo. Deixai de lado as ameaças: bem sabeis que tanto eles como vós tendes o mesmo Senhor, que está no Céu e não faz distinção de pessoas."
,"10":"Quanto ao mais, fortalecei-vos no Senhor e na força do seu poder."
,"11":"Vesti a armadura de Deus para poderdes resistir às manobras do diabo."
,"12":"A nossa luta, de facto, não é contra homens de carne e osso, mas contra os principados e as autoridades, contra os dominadores deste mundo de trevas, contra os espíritos do mal, que habitam as regiões celestes."
,"13":"Por isso vesti a armadura de Deus para que, no dia mau, possais resistir e permanecer firmes, superando todas as provas."
,"14":"Ficai, portanto, bem firmes: cingidos com o cinturão da verdade, vestidos com a couraça da justiça,"
,"15":"os pés calçados com o zelo para propagar o evangelho da paz;"
,"16":"tende sempre na mão o escudo da fé, e assim podereis apagar as flechas inflamadas do Maligno."
,"17":"Ponde o capacete da salvação e empunhai a espada do Espírito, que é a Palavra de Deus."
,"18":"Rezai incessantemente no Espírito, com toda a espécie de orações e súplicas, vigílias, intercedendo, sem cansaço, por todos os cristãos."
,"19":"Rezai também por mim: que a Palavra seja colocada na minha boca, para anunciar ousadamente o mistério do Evangelho,"
,"20":"do qual sou embaixador aprisionado. Que eu possa anunciá-lo com ousadia, como é meu dever."
,"21":"Desejo que também vós saibais qual é a minha situação e o que estou fazendo. Tíquico, o irmão querido e fiel ministro no Senhor, dar-vos-á todas as notícias."
,"22":"Eu o envio, para que recebais notícias nossas e sejais reconfortados."
,"23":"Aos irmãos, a paz, o amor e a fé, da parte de Deus Pai e do Senhor Jesus Cristo."
,"24":"A graça esteja com todos aqueles que amam nosso Senhor Jesus Cristo com amor perene."
}`)

}
func PT_BS_LoadNPGAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, Apóstolo não da parte dos homens, nem por meio de um homem, mas da parte de Jesus Cristo e de Deus Pai, que O ressuscitou dos mortos."
,"2":"Eu e todos os irmãos que estão comigo, às Igrejas da Galácia."
,"3":"Que a graça e a paz de Deus nosso Pai e do Senhor Jesus Cristo estejam convosco."
,"4":"Cristo entregou-Se pelos nossos pecados para nos arrancar deste mundo mau, segundo a vontade do nosso Deus e Pai."
,"5":"A Deus seja dada glória para sempre. Ámen."
,"6":"Estou admirado por estardes a abandonar tão depressa Aquele que vos chamou por meio da graça de Cristo, para aceitardes outro Evangelho."
,"7":"Na realidade, porém, não existe outro Evangelho. Há somente pessoas que semeiam confusão entre vós e querem deturpar o Evangelho de Cristo."
,"8":"Maldito aquele que vos anunciar um evangelho diferente daquele que vos anunciámos, ainda que sejamos nós mesmos ou algum anjo do céu."
,"9":"Já vos dissemos antes e agora repetimos: Maldito seja quem vos anunciar um evangelho diferente daquele que recebestes."
,"10":"Porventura procuro a aprovação dos homens, ou a aprovação de Deus? Ou procuro agradar aos homens? Se procurasse agradar aos homens, não seria servo de Cristo."
,"11":"Irmãos, eu vos declaro: o Evangelho por mim anunciado não é invenção humana."
,"12":"E, além disso, não o recebi nem aprendi através de um homem, mas por revelação de Jesus Cristo."
,"13":"Certamente ouvistes falar do que eu fazia quando estava no judaísmo. Sabeis como eu perseguia com violência a Igreja de Deus e fazia de tudo para a arrasar."
,"14":"Eu superava no judaísmo a maior parte dos compatriotas da minha idade e procurava seguir com todo o zelo as tradições dos meus antepassados."
,"15":"Deus, porém, escolheu-me antes de eu nascer e chamou-me por sua graça. Quando Ele resolveu"
,"16":"revelar em mim o seu Filho, para que eu O anunciasse entre os pagãos, não consultei ninguém,"
,"17":"nem subi a Jerusalém para me encontrar com aqueles que eram Apóstolos antes de mim. Pelo contrário, fui para a Arábia e depois voltei a Damasco."
,"18":"Três anos mais tarde, fui a Jerusalém para conhecer Pedro e fiquei com ele quinze dias."
,"19":"Entretanto, não vi nenhum outro Apóstolo, a não ser Tiago, o irmão do Senhor."
,"20":"Deus é testemunha: o que vos escrevo não é mentira."
,"21":"Depois fui para as regiões da Síria e da Cilícia,"
,"22":"de modo que as Igrejas de Cristo na Judeia não me conheciam pessoalmente."
,"23":"Elas apenas ouviam dizer: «Aquele que nos perseguia, agora anuncia a fé que antes procurava destruir»."
,"24":"E louvavam a Deus por minha causa."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Catorze anos depois, voltei a Jerusalém com Barnabé e levei também Tito comigo."
,"2":"Fui lá seguindo uma revelação. Expus-lhes o Evangelho que anuncio aos pagãos, mas expu-lo reservadamente às pessoas mais notáveis, para não me arriscar a correr ou ter corrido em vão."
,"3":"Nem Tito, meu companheiro, que é grego, foi obrigado a circuncidar-se."
,"4":"Nem mesmo por causa dos falsos irmãos, os intrusos que se infiltraram para espiar a liberdade que temos em Jesus Cristo, a fim de nos tornar escravos."
,"5":"Mas para que a verdade do Evangelho continuasse firme entre vós, em nenhum momento nos submetemos a essas pessoas."
,"6":"No que se refere àqueles mais notáveis - pouco me importa o que eles eram então, porque Deus não faz diferença entre as pessoas - esses mesmos notáveis nada mais me impuseram."
,"7":"Pelo contrário, viram que a mim fora confiada a evangelização dos não circuncidados, assim como a Pedro fora confiada a evangelização dos circuncidados."
,"8":"De facto, Aquele que tinha agido em Pedro para o apostolado entre os circuncidados, também tinha agido em mim a favor dos pagãos."
,"9":"Por isso, Tiago, Pedro e João, considerados como colunas, reconheceram a graça que me fora concedida, estenderam a mão a mim e a Barnabé em sinal de comunhão: nós trabalharíamos com os pagãos e eles com os circuncidados."
,"10":"Eles recomendaram-nos apenas que nos lembrássemos dos pobres, o que procurei fazer com grande solicitude."
,"11":"Quando Pedro foi a Antioquia, enfrentei-o em público, porque ele estava claramente errado."
,"12":"De facto, antes de chegarem algumas pessoas da parte de Tiago, ele comia com os pagãos; mas, depois que chegaram, Pedro começou a evitar os pagãos e já não se misturava com eles, pois tinha medo dos circuncidados."
,"13":"Os outros judeus também começaram a fingir com ele, de modo que até Barnabé se deixou levar pela hipocrisia dele."
,"14":"Quando vi que eles não estavam a agir conforme a verdade do Evangelho, disse a Pedro, na frente de todos: «Tu és judeu, mas vives como os pagãos e não como os judeus. Como podes, então, obrigar os pagãos a viverem como judeus?»"
,"15":"Nós somos judeus de nascimento, e não pagãos pecadores."
,"16":"Sabemos, entretanto, que o homem não se torna justo pelas obras da Lei, mas somente pela fé em Jesus Cristo. Nós também acreditamos em Jesus Cristo, a fim de nos tornarmos justos pela fé em Cristo e não pela observância da Lei, pois com a observância da Lei ninguém se tornará justo."
,"17":"Nós procuramos tornar-nos justos em Cristo; mas também somos pecadores como os outros. Então, será que Cristo estaria ao serviço do pecado? Claro que não!"
,"18":"De facto, se eu reconstruo o que destruí, eu próprio me torno culpável."
,"19":"Quanto a mim, foi através da Lei que eu morri para a Lei, a fim de viver para Deus. Fui morto na cruz com Cristo."
,"20":"Eu vivo, mas já não sou eu que vivo, pois é Cristo que vive em mim. E esta vida que agora vivo, eu vivo-a pela fé no Filho de Deus, que me amou e Se entregou por mim."
,"21":"Portanto, não torno inútil a graça de Deus, porque, se a justiça vem através da Lei, então Cristo morreu em vão."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Gálatas insensatos! Quem vos enfeitiçou, vós que tivestes diante dos próprios olhos uma descrição clara de Jesus Cristo crucificado?"
,"2":"Respondei-me somente uma coisa: foi por causa da observância da Lei que recebestes o Espírito, ou foi porque ouvistes a mensagem da fé?"
,"3":"Sois tão insensatos, a ponto de ter começado com o Espírito e agora terminar na carne?"
,"4":"Foi em vão que fizestes tantas experiências? Se é que foi em vão!"
,"5":"Aquele que vos dá o Espírito e realiza milagres entre vós, será que Ele o faz por causa da observância da Lei, ou é porque ouvistes a mensagem da fé?"
,"6":"Foi assim que Abraão teve fé em Deus, e isso foi-lhe creditado como justiça."
,"7":"Sabei, portanto, que somente aqueles que têm fé são filhos de Abraão."
,"8":"É por isso que a Escritura, prevendo que Deus tornaria justos os pagãos através da fé, predisse a Abraão esta boa notícia: «Em ti todas as nações serão abençoadas»."
,"9":"Portanto, aqueles que têm fé são os abençoados juntamente com Abraão, que acreditou."
,"10":"Os que observam a Lei, porém, estão todos debaixo do peso da maldição, pois a Escritura diz: «Maldito seja todo aquele que não é fiel a todas as coisas que estão escritas no livro da Lei para serem praticadas»."
,"11":"Além disso, é evidente que ninguém pode tornar-se justo diante de Deus através da Lei, pois o justo viverá pela fé."
,"12":"Ora, a Lei não se baseia sobre a fé, pois diz: «Quem praticar os preceitos da Lei, viverá por meio deles»."
,"13":"Cristo resgatou-nos da maldição da Lei, tornando-Se Ele próprio maldição por nós, como diz a Escritura: «Maldito seja todo aquele que for suspenso no madeiro»."
,"14":"Isso aconteceu para que, em Jesus Cristo, a bênção de Abraão se estendesse aos pagãos e para que nós recebêssemos, pela fé, o Espírito prometido."
,"15":"Irmãos, vou fazer uma comparação: ninguém pode invalidar ou modificar um testamento legitimamente feito."
,"16":"Ora, as promessas foram feitas a Abraão e ao seu descendente. A Escritura não diz no plural: «e aos descendentes»; mas no singular: «e ao seu descendente», isto é, a Cristo."
,"17":"O que eu quero dizer é o seguinte: Deus firmou um testamento de modo legítimo. A Lei, que veio quatrocentos e trinta anos mais tarde, não pode invalidar esse testamento, anulando assim a promessa."
,"18":"De facto, se é através da Lei que se recebe a herança, já não é mediante a promessa. Ora, foi por meio de uma promessa que Deus concedeu a sua graça a Abraão."
,"19":"Então, porque é que foi dada a Lei? Ela foi acrescentada para mostrar as transgressões, até à chegada do descendente, em vista do qual foi feita a promessa. A Lei foi promulgada pelos anjos, e um homem serviu de intermediário."
,"20":"Ora, esse intermediário não representa uma pessoa só, e Deus é um só."
,"21":"Então, a Lei estará contra as promessas de Deus? Claro que não! Se tivesse sido dada uma lei capaz de comunicar a vida, então sim, realmente a justiça viria da Lei."
,"22":"A Escritura, porém, colocou tudo sob o domínio do pecado, a fim de que a promessa fosse concedida aos que acreditam, mediante a fé em Jesus Cristo."
,"23":"Antes que chegasse a fé, a Lei tomava conta de nós, à espera da fé que devia ser revelada."
,"24":"A Lei, portanto, é para nós como um pedagogo que nos conduziu a Cristo, para que nos tornássemos justos mediante a fé."
,"25":"Chegada a fé, já não estamos sob os cuidados de um pedagogo."
,"26":"De facto, todos vós sois filhos de Deus pela fé em Jesus Cristo,"
,"27":"pois todos vós, que fostes baptizados em Cristo, vos revestistes de Cristo."
,"28":"Já não há diferença entre judeu e grego, entre escravo e homem livre, entre homem e mulher, pois todos vós sois um só em Jesus Cristo."
,"29":"E se pertenceis a Cristo, então sois de facto a descendência de Abraão e herdeiros conforme a promessa."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Vou dar-vos outro exemplo: durante todo o tempo em que o herdeiro é criança, embora seja dono de tudo, é como se fosse um escravo."
,"2":"Até chegar à data fixada pelo pai, ele fica sob tutores e pessoas que administram os seus negócios."
,"3":"O mesmo aconteceu connosco: éramos como crianças e andávamos como es-cravos, submetidos aos elementos do mundo."
,"4":"Quando, porém, chegou a plenitude dos tempos, Deus enviou o seu Filho. Ele nasceu de uma mulher, submetido à Lei"
,"5":"para resgatar aqueles que estavam submetidos à Lei, a fim de que fôssemos adoptados como filhos."
,"6":"A prova de que sois filhos é o facto de que Deus enviou aos nossos corações o Espírito do seu Filho que clama: Abba, Pai!"
,"7":"Portanto, já não és escravo, mas filho; e, se és filho, és também herdeiro por vontade de Deus."
,"8":"No passado, quando não conhecíeis a Deus, éreis escravos de deuses, que na realidade não são deuses."
,"9":"Agora, porém, conheceis a Deus, ou melhor, agora Deus conhece-vos. Então, como é que quereis voltar de novo àqueles elementos fracos e sem valor? Porque quereis novamente ficar escravos deles?"
,"10":"Vós observais cuidadosamente os dias, os meses, as estações e os anos!"
,"11":"Receio ter-me cansado inutilmente por vós."
,"12":"Irmãos, peço-vos que sejais como eu, porque eu também me tornei como vós. Não me ofendestes em nada."
,"13":"E sabei que foi por causa de uma doença física que eu vos evangelizei na primeira vez."
,"14":"E vós não me desprezastes nem me rejeitastes, apesar do meu físico ser para vós uma provação. Pelo contrário, acolhestes-me como a um anjo de Deus ou até como a Jesus Cristo."
,"15":"Onde está a alegria que experimentastes então? Pois eu dou testemunho de que, se fosse possível, teríeis arrancado os próprios olhos para mos dar."
,"16":"E agora, será que me tornei inimigo, só porque vos disse a verdade?"
,"17":"Esses homens mostram grande interesse por vós, mas a intenção deles não é boa; o que eles querem é separar-vos de mim, para que vos interesseis por eles."
,"18":"Seria bom que vos interessásseis sempre pelo bem, e não só quando estou presente entre vós."
,"19":"Meus filhos, sofro novamente como que dores de parto, até que Cristo esteja formado em vós."
,"20":"Gostaria de estar junto de vós neste momento, e de mudar o tom da minha voz, porque já não sei que atitude tomar convosco."
,"21":"Vós que quereis ficar submetidos à Lei, dizei-me uma coisa: será que não ouvis o que diz a Lei?"
,"22":"De facto, nela está escrito que Abraão teve dois filhos, um da escrava e outro da mulher livre."
,"23":"O filho da escrava nasceu de modo natural, enquanto o filho da mulher livre nasceu por causa da promessa. Simbolicamente"
,"24":"isso quer dizer o seguinte: as duas mulheres representam as duas alianças. Uma, a do monte Sinai, gera para a escravidão e é representada por Agar"
,"25":"(pois o monte Sinai está na Arábia, que é o país de Agar). E Agar corresponde à Jerusalém actual, que é escrava juntamente com os seus filhos."
,"26":"Mas a Jerusalém do alto é livre, e é a nossa mãe."
,"27":"Porque está na Escritura: «Alegra-te, estéril, tu que não davas à luz! Grita de alegria, tu que não conheceste as dores do parto, porque os filhos da abandonada são mais numerosos do que os filhos daquela que tem marido»."
,"28":"Vós, irmãos, sois filhos da promessa, como Isaac."
,"29":"Acontece agora como acontecia naquele tempo: o que nasceu de modo natural persegue aquele que nasceu segundo o Espírito."
,"30":"Mas o que é que diz a Escritura? «Expulsa a escrava e o filho dela, porque o filho da escrava não receberá a herança juntamente com o filho da mulher livre»."
,"31":"Portanto, irmãos, nós não somos filhos da escrava, mas da mulher livre."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cristo libertou-nos para que sejamos verdadeiramente livres. Portanto, permanecei firmes e não vos submetais de novo ao jugo da escravidão."
,"2":"Eu, Paulo, declaro-vos: se vos fazeis circuncidar, Cristo de nada adiantará para vós."
,"3":"E a todo o homem que se faz circuncidar, eu declaro: agora está obrigado a observar toda a Lei."
,"4":"Vós que procurais a justiça na Lei desligastes-vos de Cristo e separastes-vos da graça."
,"5":"Nós, de facto, aguardamos no Espírito a esperança de nos tornarmos justos através da fé,"
,"6":"porque, em Jesus Cristo, o que conta não é a circuncisão ou a não circuncisão, mas a fé que age por meio do amor."
,"7":"Vós corríeis bem. Quem vos impediu de obedecer à verdade?"
,"8":"Tal influência não vem d'Aquele que vos chama."
,"9":"Um pouco de fermento basta para levedar toda a massa!"
,"10":"Confio no Senhor que vós estais de acordo com isto. Aquele, porém, que vos perturba, seja ele quem for, sofrerá a condenação."
,"11":"Quanto a mim, irmãos, se é verdade que ainda prego a circuncisão, porque sou então perseguido? Nesse caso, o escândalo da cruz estaria anulado!"
,"12":"Oxalá aqueles que vos perturbam se mutilem de uma vez por todas!"
,"13":"Irmãos, fostes chamados para serdes livres. Que essa liberdade, porém, não se torne desculpa para viverdes satisfazendo os instintos egoístas. Pelo contrário, fazei-vos servos uns dos outros através do amor."
,"14":"Pois toda a Lei encontra a sua plenitude num só mandamento: «Amarás o teu próximo como a ti mesmo»."
,"15":"Mas, se vos mordeis e vos devorais uns aos outros, tomai cuidado! Podereis acabar por vos destruirdes uns aos outros."
,"16":"Por isso é que vos digo: vivei segundo o Espírito, e já não fareis o que os instintos egoístas desejam."
,"17":"Porque os instintos egoístas têm desejos que estão contra o Espírito, e o Espírito contra os instintos egoístas; os dois estão em conflito, de modo que não fazeis o que quereis."
,"18":"Mas, se fordes conduzidos pelo Espí-rito, já não estareis submetidos à Lei."
,"19":"Além disso, as obras dos instintos egoístas são bem conhecidas: fornicação, impureza, libertinagem,"
,"20":"idolatria, feitiçaria, ódio, discórdia, ciúme, ira, rivalidade, divisão, sectarismo,"
,"21":"inveja, bebedeira, orgias e outras coisas semelhantes. Repito o que já disse: os que fazem tais coisas não herdarão o Reino de Deus."
,"22":"Mas o fruto do Espírito é amor, alegria, paz, paciência, bondade, benevolência, fé,"
,"23":"mansidão e domínio de si. Contra essas coisas não existe lei."
,"24":"Os que pertencem a Cristo crucificaram os instintos egoístas juntamente com as suas paixões e desejos."
,"25":"Se vivemos pelo Espírito, caminhemos também sob o impulso do Espírito."
,"26":"Não sejamos ambiciosos de glória, provocando-nos mutuamente e tendo inveja uns dos outros."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Irmãos, se alguém for apanhado em alguma falta, vós que sois espirituais, admoestai com mansidão essa pessoa. E cada um cuide de si mesmo, para não ser também tentado."
,"2":"Levai os fardos uns dos outros, e assim cumprireis a lei de Cristo."
,"3":"Se alguém pensa que é importante, quando de facto não o é, está-se enganando a si mesmo."
,"4":"Cada um examine a sua conduta, e então achará motivo de satisfação na sua própria pessoa, e não por comparação com os outros,"
,"5":"porque cada um deve levar a sua própria carga."
,"6":"Aquele que recebe o ensinamento da Palavra deve repartir todos os bens com o catequista."
,"7":"Não vos iludais, pois com Deus não se brinca: cada um colherá aquilo que tiver semeado."
,"8":"Quem semeia nos instintos egoístas, dos instintos egoístas colherá corrupção; quem semeia no Espírito, do Espírito colherá a vida eterna."
,"9":"Não nos cansemos de fazer o bem; se não desanimarmos, quando chegar o tempo, colheremos."
,"10":"Portanto, enquanto temos tempo, façamos o bem a todos, especialmente aos que pertencem à nossa família na fé."
,"11":"Vede com que letras grandes vos escrevo de meu próprio punho."
,"12":"Os que querem impor-vos a circuncisão, são aqueles que estão preocupados em fazer boa figura. Fazem isso para não serem perseguidos por causa da cruz de Cristo."
,"13":"De facto, nem mesmo os próprios circuncidados observam a Lei. Eles querem que vos circuncideis, apenas para eles se gloriarem de terem marcado o vosso corpo."
,"14":"Quanto a mim, que eu não me glorie, a não ser na cruz de nosso Senhor Jesus Cristo, por meio do qual o mundo foi crucificado para mim e eu para o mundo."
,"15":"O que importa não é a circuncisão ou a não circuncisão, mas sim a nova criação."
,"16":"Que a paz e a misericórdia estejam sobre todos os que seguirem esta norma, assim como sobre todo o Israel de Deus."
,"17":"De agora em diante ninguém mais me moleste, pois trago no meu corpo as marcas de Jesus."
,"18":"Irmãos, que a graça de nosso Senhor Jesus Cristo esteja com o vosso espírito. Ámen."
}`)

}
func PT_BS_LoadNPPMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, prisioneiro de Jesus Cristo, e o irmão Timóteo, a Filémon, nosso amigo e colaborador,"
,"2":"e também à irmã Ápia, a Arquipo, nosso companheiro de luta, e à Igreja que se reúne em casa de Filémon."
,"3":"Que a graça e a paz da parte de Deus, nosso Pai, e do Senhor Jesus Cristo estejam convosco."
,"4":"Dou graças ao meu Deus sempre que me lembro de ti nas minhas orações."
,"5":"De facto, ouço falar do amor e da fé que tens para com o Senhor Jesus e em favor de todos os cristãos."
,"6":"Peço a Deus que a participação que tens na fé seja eficaz para compreenderes que todos os bens que temos são para Cristo."
,"7":"Caro irmão: o teu amor tem-me dado muita alegria e coragem, pois graças a ti os cristãos sentem-se tranquilos."
,"8":"Tenho toda a liberdade em Cristo para te ordenar o que deves fazer,"
,"9":"mas prefiro pedir por amor. Quem faz este pedido sou eu, o velho Paulo, agora também prisioneiro de Jesus Cristo."
,"10":"Peço-te em favor de Onésimo, o filho que eu gerei na prisão."
,"11":"Antes ele era inútil para ti, mas agora é útil, tanto para ti, como para mim."
,"12":"Vou enviar-to novamente; ele é como se fosse o meu próprio coração."
,"13":"Gostaria que ele ficasse comigo para me servir em teu lugar, enquanto estou preso por causa do Evangelho."
,"14":"Eu, porém, não quis fazer nada sem o teu consentimento. Não quero que a tua bondade seja forçada, mas espontânea."
,"15":"Talvez Onésimo se tenha afastado de ti por algum tempo, para que o recuperes para sempre."
,"16":"Agora tê-lo-ás, não já como escravo, mas muito mais do que escravo: tê-lo-ás como irmão querido; ele é querido para mim, e sê-lo-á muito mais para ti, seja como homem, seja como cristão."
,"17":"Assim, se me consideras como irmão na fé, recebe Onésimo como se fosse eu mesmo."
,"18":"Se te causou algum prejuízo ou te deve alguma coisa, põe isso na minha conta."
,"19":"Eu, Paulo, escrevo com a minha própria mão: eu pagarei... É claro que não preciso de te lembrar que também me deves a tua própria vida."
,"20":"Sim, irmão, permite-me que abuse da tua bondade no Senhor. Conforta, em Cristo, o meu coração."
,"21":"Escrevo na certeza de que me vais obedecer, e sei que farás mais ainda do que te estou a pedir."
,"22":"Peço também que prepares um quarto para mim, porque espero ser-vos devolvido, graças às orações que estais a fazer."
,"23":"Saudações de Épafras, meu companheiro de prisão em Jesus Cristo,"
,"24":"como também de Marcos, Aristarco, Demas e Lucas, meus colaboradores."
,"25":"A graça do Senhor Jesus Cristo esteja convosco."
}`)

}
func PT_BS_LoadNPPPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Eu, Paulo, e Timóteo, servos de Jesus Cristo, enviamos esta carta a todos os cristãos que moram na cidade de Filipos, assim como aos seus dirigentes e diáconos."
,"2":"Que a graça e a paz de Deus, nosso Pai, e do Senhor Jesus Cristo estejam convosco."
,"3":"Agradeço ao meu Deus todas as vezes que me lembro de vós."
,"4":"E sempre, nas minhas orações, rezo por todos com alegria,"
,"5":"porque cooperastes no anúncio do Evangelho, desde o primeiro dia até agora."
,"6":"Tenho a certeza de que Deus, que em vós começou esse bom trabalho, vai continuá-lo até que seja concluído no dia de Jesus Cristo."
,"7":"É justo que eu pense assim de todos vós, porque estais no meu coração. De facto participais comigo da graça que recebi, seja nas prisões, seja na defesa e confirmação do Evangelho."
,"8":"Deus é testemunha de que eu vos quero bem a todos com a ternura de Jesus Cristo."
,"9":"Este é o meu pedido: que o vosso amor cresça cada vez mais em perspicácia e sensibilidade em todas as coisas."
,"10":"Deste modo, podereis distinguir o que é melhor, e assim chegar íntegros e inocentes ao dia de Cristo."
,"11":"Estareis repletos então dos frutos de justiça obtidos por meio de Jesus Cristo, para a glória e louvor de Deus."
,"12":"Irmãos, quero que saibais: o que me aconteceu ajudou o Evangelho a progredir."
,"13":"Tanto no pretório como em outros lugares, todos ficaram a saber que estou na prisão por causa de Cristo."
,"14":"E a maioria dos irmãos, vendo que estou na prisão, têm mais confiança no Senhor, e mais ousadia para anunciar sem medo a Palavra."
,"15":"É verdade que alguns proclamam Cristo por inveja e espírito de competição; outros, porém, anunciam com boa intenção."
,"16":"Estes proclamam a Cristo por amor, sabendo que a minha missão é defender o Evangelho."
,"17":"Os outros não anunciam com sinceridade, mas por competição, pensando que vão aumentar os meus sofrimentos enquanto estou na prisão."
,"18":"Mas, que importância tem isso? Com boas ou más intenções, o que interessa é que Cristo está a ser anunciado, e eu fico contente com isso e continuarei a alegrar-me."
,"19":"De facto, sei que tudo isto há-de servir para a minha salvação, através das vossas orações e do Espírito de Jesus Cristo, que me socorre."
,"20":"O que desejo e espero é não fracassar, mas, agora como sempre, manifestar com toda a coragem a glória de Cristo no meu corpo, tanto na vida como na morte."
,"21":"Pois, para mim o viver é Cristo, e o morrer é lucro."
,"22":"Mas, se eu ainda continuar a viver, poderei fazer algum trabalho útil. Por isso é que não sei bem o que escolher."
,"23":"Fico na indecisão: o meu desejo é partir desta vida e estar com Cristo, o que é muito melhor."
,"24":"No entanto, por vossa causa, é mais necessário que eu continue a viver."
,"25":"Convencido disso, sei que vou ficar convosco. Sim, vou ficar com todos vós, para vos ajudar a progredir e a ter alegria na fé."
,"26":"Assim, quando eu voltar para junto de vós, o vosso orgulho em Jesus Cristo irá aumentar por causa de mim."
,"27":"Uma só coisa: comportai-vos como pessoas dignas do Evangelho de Cristo. Deste modo, indo ver-vos ou estando longe, que eu oiça dizer que estais firmes num só espírito, lutando juntos numa só alma pela fé do Evangelho,"
,"28":"e que não temeis os vossos adversários. Para eles, isso é sinal de perdição, mas para vós é sinal de salvação, e isso vem de Deus."
,"29":"Pois Deus concedeu-vos não só a graça de acreditar em Cristo, mas também de sofrer por Ele,"
,"30":"empenhados na mesma luta em que me vistes empenhado, e na qual, como sabeis, ainda agora me empenho."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Portanto, se há um conforto em Cristo, uma consolação no amor, se existe uma comunhão de espírito, se existe ternura e compaixão,"
,"2":"completai a minha alegria: tende uma só aspiração, um só amor, uma só alma e um só pensamento."
,"3":"Não façais nada por competição e por desejo de receber elogios, mas por humildade, cada um considerando os outros superiores a si mesmo."
,"4":"Que cada um pro-cure, não o próprio interesse, mas o interesse dos outros."
,"5":"Tende em vós os mesmos sentimentos que havia em Jesus Cristo:"
,"6":"Ele tinha a condição divina, mas não Se apegou à sua igualdade com Deus."
,"7":"Pelo contrário, esvaziou-Se a Si mesmo, assumindo a condição de servo e tornando-Se semelhante aos homens. Assim, apresentando-Se como simples homem,"
,"8":"humilhou-Se a Si mesmo, tornando-Se obediente até à morte, e morte de cruz!"
,"9":"Por isso, Deus O exaltou grandemente, e Lhe deu o Nome que está acima de qualquer outro nome;"
,"10":"para que, ao Nome de Jesus, se dobre todo o joelho no Céu, na Terra e sob a Terra;"
,"11":"e toda a língua confesse que Jesus Cristo é o Senhor, para glória de Deus Pai."
,"12":"Portanto, meus amados, obedecendo como sempre, não só como no tempo em que eu estava aí presente, mas muito mais agora que estou longe, continuai a trabalhar com temor e tremor, para a vossa salvação."
,"13":"De facto, é Deus que desperta em vós a vontade e a acção, conforme a sua benevolência."
,"14":"Fazei tudo sem murmurações e sem críticas,"
,"15":"para serdes inocentes e íntegros, como perfeitos filhos de Deus que vivem no meio de gente pecadora e corrompida, onde brilhais como astros no mundo,"
,"16":"apegando-vos firmemente à Palavra da vida. Deste modo, no Dia de Cristo, orgulhar-me-ei de não ter corrido nem trabalhado em vão."
,"17":"E mesmo que o meu sangue seja derramado sobre o sacrifício e sobre a oferta da vossa fé, fico contente e alegro-me com todos vós."
,"18":"Assim, também vós alegrai-vos e congratulai-vos comigo."
,"19":"Espero no Senhor Jesus enviar-vos brevemente Timóteo, para que também eu me anime com as vossas notícias."
,"20":"De facto, ele é o único que sente como eu e se preocupa sinceramente com os vossos problemas."
,"21":"Porque todos os outros buscam os próprios interesses, e não os de Jesus Cristo."
,"22":"Vós mesmos sabeis como Timóteo deu provas do seu valor: como filho junto do pai, ele colocou-se ao meu lado ao serviço do Evangelho."
,"23":"Espero, portanto, enviar-vo-lo logo que eu veja claro como vai ficar a minha situação."
,"24":"Além disso, tenho fé no Senhor de que também eu irei ver-vos brevemente."
,"25":"Entretanto, achei necessário enviar-vos Epafrodito, este nosso irmão que é também meu companheiro de trabalho e de luta, que me enviastes para me socorrer nas minhas necessidades."
,"26":"Ele estava com muita saudade de todos vós, e ficou muito preocupado, porque soubestes que ele estava doente."
,"27":"De facto, ele esteve muito doente, e quase morreu. Deus, porém, teve pena dele, e não só dele, mas também de mim, para que eu não ficasse numa tristeza ainda maior."
,"28":"Por isso, apressei-me a mandá-lo: assim podereis vê-lo de novo, ficareis contentes, e eu já não ficarei preocupado."
,"29":"Recebei Epafrodito no Senhor, com grande alegria. Tende grande estima por pessoas como ele,"
,"30":"pois quase morreu pela causa de Cristo, arriscando a sua vida para atender às minhas necessidades, em vosso nome."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Quanto ao resto, meus irmãos, alegrai-vos no Senhor. Escrever-vos sempre as mesmas coisas não é penoso para mim, e é útil para vós."
,"2":"Cuidado com os cães, cuidado com os maus operários, cuidado com os falsos circuncidados."
,"3":"Os verdadeiros circuncidados somos nós, que prestamos culto, movidos pelo Espírito de Deus. Nós colocamos a nossa glória em Jesus Cristo e não confiamos na carne."
,"4":"Eu, aliás, até poderia confiar na carne. Se alguém acha que pode confiar na carne, eu mais ainda:"
,"5":"fui circuncidado ao oitavo dia, sou israelita de nascimento, da tribo de Benjamim, hebreu filho de hebreus. Quanto à Lei judaica, fariseu;"
,"6":"quanto ao zelo, perseguidor da Igreja; quanto à justiça que se alcança pela observância da Lei, sem reprovação."
,"7":"Por causa de Cristo, porém, tudo o que eu considerava como lucro, agora considero-o como perda."
,"8":"E mais ainda: considero tudo uma perda, diante do bem superior que é o conhecimento do meu Senhor Jesus Cristo. Por causa d'Ele perdi tudo, e considero tudo como lixo, a fim de ganhar Cristo,"
,"9":"e estar com Ele. E isso, não mediante uma justiça minha, vinda da Lei, mas com a justiça que vem através da fé em Cristo, aquela justiça que vem de Deus e se apoia sobre a fé."
,"10":"Quero, assim, conhecer a Cristo, o poder da sua ressurreição e a comunhão nos seus sofrimentos, para me tornar semelhante a Ele na sua morte,"
,"11":"a fim de alcançar, se possível, a ressurreição dos mortos."
,"12":"Não que eu já tenha conquistado o prémio ou que já tenha chegado à perfeição; apenas continuo a correr para o conquistar, porque eu também fui conquistado por Jesus Cristo."
,"13":"Irmãos, não acho já ter alcançado o prémio, mas uma coisa faço: esqueço-me do que fica para trás e avanço para o que está adiante."
,"14":"Lanço-me em direcção à meta, em vista do prémio do alto, que Deus nos chama a receber em Jesus Cristo."
,"15":"Portanto, todos nós que somos perfeitos, devemos ter este sentimento. E, se em alguma coisa pensais de maneira diferente, Deus vos esclarecerá."
,"16":"Entretanto, qualquer que seja o ponto a que chegámos, caminhemos na mesma direcção."
,"17":"Irmãos, sede meus imitadores e observai os que vivem de acordo com o modelo que tendes em nós."
,"18":"Já vos disse muitas vezes, e agora repito-o com lágrimas: há muitos que são inimigos da cruz de Cristo."
,"19":"O seu fim é a perdição; o seu Deus é o ventre, a sua glória está no que é vergonhoso, e os seus pensamentos em coisas da terra."
,"20":"A nossa cidadania, porém, está no Céu, de onde esperamos ansiosamente o Senhor Jesus Cristo como Salvador."
,"21":"Ele vai transformar o nosso corpo miserável, tornando-o semelhante ao seu corpo glorioso, graças ao poder que Ele possui de submeter a Si todas as coisas."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Assim, meus queridos e saudosos irmãos, minha alegria e minha coroa, continuai firmes no Senhor, ó amados."
,"2":"Peço a Evódia e a Síntique que façam as pazes no Senhor."
,"3":"E a ti, Sízigo, meu fiel companheiro, peço que as ajudes, porque elas me ajudaram na luta pelo Evangelho, com Clemente e os meus outros colaboradores. Os seus nomes estão no livro da vida."
,"4":"Alegrai-vos sempre no Senhor! Repito: alegrai-vos!"
,"5":"Que a vossa bondade seja notada por todos. O Senhor está próximo."
,"6":"Não vos inquieteis com nada. Apresentai a Deus todas as vossas necessidades através da oração e da súplica, em acção de graças."
,"7":"Então a paz de Deus, que ultrapassa toda a compreensão, guardará em Jesus Cristo os vossos corações e os vossos pensamentos."
,"8":"Finalmente, irmãos, ocupai-vos com tudo o que é verdadeiro, nobre, justo, puro, amável, honroso, virtuoso, ou que de algum modo mereça louvor."
,"9":"Praticai tudo o que aprendestes e recebestes como herança, o que ouvistes e observastes em mim. Então o Deus da paz estará convosco."
,"10":"Foi grande a minha alegria no Senhor, porque finalmente vi florescer de novo o vosso interesse por mim. Na verdade, já tínheis esse interesse antes, mas faltava oportunidade para o demonstrar."
,"11":"Não digo isto por estar a passar privações, pois aprendi a arranjar-me em qualquer situação."
,"12":"Aprendi a viver na necessidade e na abundância; estou acostumado a toda e qualquer situação: viver saciado e passar fome, ter abundância e passar necessidade."
,"13":"Tudo posso n'Aquele que me fortalece."
,"14":"Entretanto, fizestes bem, tomando parte na minha aflição."
,"15":"Vós bem sabeis, filipenses, que no início da pregação do Evangelho, quando parti da Macedónia, nenhuma outra Igreja, senão vós, teve contacto comigo em questão de dar e receber."
,"16":"Já em Tessalónica me enviastes ajuda por mais de uma vez, para aliviar as minhas necessidades."
,"17":"Não que eu espere presentes. Pelo contrário, quero ver mais lucro na vossa conta."
,"18":"De momento, tenho tudo em abundância; tenho até de sobra, especialmente agora que Epafrodito me trouxe aquilo que me enviastes. É como um perfume de suave odor, sacrifício agradável que Deus aceita."
,"19":"O meu Deus, por sua vez, atenderá com grandeza a todas as vossas necessidades, conforme a sua riqueza em Jesus Cristo."
,"20":"Ao nosso Deus e Pai seja dada a glória para sempre. Ámen."
,"21":"Saudai a todos os cristãos. Os irmãos que estão comigo vos saúdam."
,"22":"Todos os cristãos vos saúdam, especialmente os da casa de César."
,"23":"A graça do Senhor Jesus Cristo esteja convosco."
}`)

}
func PT_BS_LoadNPRMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, servo de Jesus Cristo, chamado a ser Apóstolo e escolhido para anunciar o Evangelho de Deus,"
,"2":"que por Deus foi prometido através dos seus profetas nas Santas Escrituras."
,"3":"Esse Evangelho refere-se ao Filho de Deus que, como homem, foi descendente de David,"
,"4":"e, segundo o Espírito Santo, foi constituído Filho de Deus com poder, através da ressurreição dos mortos: Jesus Cristo nosso Senhor."
,"5":"Através de Jesus, recebemos a graça de ser Apóstolo, a fim de conduzir todos os povos pagãos à obediência da fé, para a glória do seu Nome."
,"6":"Entre eles, estais também vós, chamados por Jesus Cristo."
,"7":"Escrevo a todos vós que estais em Roma e que sois amados por Deus e chamados à santidade. Que a graça e a paz da parte de Deus nosso Pai, e do Senhor Jesus Cristo, estejam convosco."
,"8":"Antes de tudo, dou graças ao meu Deus por meio de Jesus Cristo, a respeito de vós, pois a fama da vossa fé espalhou-se pelo mundo inteiro."
,"9":"Deus, a quem sirvo no meu espírito anunciando o Evangelho do seu Filho, é testemunha de que sem cessar me lembro de vós,"
,"10":"e nas minhas orações peço sempre que, por vontade de Deus, eu tenha ocasião de poder visitar-vos."
,"11":"De facto, tenho muita vontade de vos ver, a fim de vos comunicar algum dom espiritual para vos fortalecer,"
,"12":"ou melhor, para ser reconfortado convosco e entre vós, através da fé que eu e vós temos em comum."
,"13":"Por outro lado, irmãos, quero que saibais que muitas vezes pensei em visitar-vos, mas até agora fui impedido de ir; esperava recolher algum fruto entre vós, como entre outras nações."
,"14":"Estou em dívida com gregos e bárbaros, com sábios e ignorantes."
,"15":"Deste modo, naquilo que depende de mim, estou pronto para anunciar o Evangelho também a vós que estais em Roma."
,"16":"Não me envergonho do Evangelho, pois é força de Deus para a salvação de todo aquele que acredita, do judeu em primeiro lugar, mas também do grego."
,"17":"De facto, no Evangelho a justiça revela-se única e exclusivamente através da fé, conforme diz a Escritura: «o justo vive pela fé»."
,"18":"A ira de Deus manifesta-se do Céu contra toda a impiedade e injustiça dos homens, que com a injustiça sufocam a verdade."
,"19":"Pois aquilo que é possível conhecer de Deus, foi manifestado aos homens; e foi o próprio Deus quem o manifestou."
,"20":"De facto, desde a criação do mundo, as perfeições invisíveis de Deus, tais como o seu poder eterno e a sua divindade, podem ser contempladas, através da inteligência, nas obras que Ele realizou. Os homens, portanto, não têm desculpa,"
,"21":"porque, embora conhecendo a Deus, não O glorificaram como Deus, nem Lhe deram graças. Pelo contrário, perderam-se em raciocínios vazios, e a sua mente ficou obscurecida."
,"22":"Pretendendo ser sábios, tornaram-se tolos,"
,"23":"trocando a glória do Deus imortal por estátuas de homem mortal, de pássaros, animais e répteis."
,"24":"Foi por isso que Deus os entregou, conforme os desejos do seu coração, à impureza com que desonram os seus próprios corpos."
,"25":"Trocaram a verdade de Deus pela mentira e adoraram e serviram a criatura em lugar do Criador, que é bendito para sempre. Ámen."
,"26":"Por isso, Deus entregou os homens a paixões vergonhosas: suas mulheres mudaram a relação natural em relação contra a natureza."
,"27":"Os homens fizeram o mesmo: deixaram a relação natural com a mulher e arderam de paixão uns com os outros, cometendo actos torpes entre si, recebendo dessa maneira em si próprios a paga pela sua aberração."
,"28":"Os homens desprezaram o conhecimento de Deus; por isso, Deus os abandonou ao sabor de uma mente incapaz de julgar. Deste modo, fazem o que não deveriam fazer:"
,"29":"estão cheios de toda a espécie de injustiça, perversidade, avidez e malícia; cheios de inveja, homicídio, rixas, fraudes e malvadezas; são difamadores,"
,"30":"caluniadores, inimigos de Deus, insolentes, soberbos, fanfarrões, engenhosos no mal, rebeldes para com os pais,"
,"31":"insensatos, desleais, gente sem coração e sem misericórdia."
,"32":"E apesar de conhecerem o julgamento de Deus, que considera digno de morte quem pratica tais coisas, eles não só as cometem, mas até aprovam quem se comporta assim."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Homem, tu julgas os outros? Quem quer que tu sejas, não tens desculpa. Pois, se julgas os outros e fazes o mesmo que eles fazem, condenas-te a ti próprio."
,"2":"Sabemos, porém, que Deus é justo quando condena os que praticam tais coisas."
,"3":"Mas tu, que fazes as mesmas coisas que condenas nos outros, pensas que escaparás ao julgamento de Deus?"
,"4":"Ou será que desprezas a riqueza da bondade de Deus, da sua paciência e generosidade, desconhecendo que a sua bondade te convida à conversão?"
,"5":"Pela teimosia e dureza de coração, estás amontoando ira contra ti mesmo para o dia da ira, quando o justo julgamento de Deus se vai revelar,"
,"6":"retribuindo a cada um conforme as suas próprias acções:"
,"7":"a vida eterna para aqueles que perseveram na prática do bem, buscando a glória, a honra e a imortalidade;"
,"8":"pelo contrário, ira e indignação para aqueles que se revoltam e rejeitam a verdade, para obedecerem à injustiça."
,"9":"Haverá tribulação e angústia para todo aquele que pratica o mal, primeiro para o judeu, depois para o grego."
,"10":"Mas haverá glória, honra e paz para todo aquele que pratica o bem, primeiro para o judeu, depois para o grego."
,"11":"Pois Deus não faz distinção de pessoas."
,"12":"Todos os que pecaram sem a Lei, sem a Lei também perecerão. Todos os que pecaram sob o regime da Lei, pela Lei serão julgados."
,"13":"Pois não são aqueles que ouvem a Lei que são justos diante de Deus, mas aqueles que praticam o que a Lei manda."
,"14":"Os pagãos não têm a Lei. Mas, embora não a tenham, se fazem espontaneamente o que a Lei manda, eles próprios são Lei para si mesmos."
,"15":"Assim mostram que os preceitos da Lei estão escritos nos seus corações; a sua consciência também testemunha isso, assim como os julgamentos interiores, que ora os condenam, ora os aprovam."
,"16":"É o que vai acontecer no dia em que Deus, segundo o meu Evangelho, vai julgar, por meio de Jesus Cristo, o comportamento secreto dos homens."
,"17":"Tu que te dizes judeu, que te apoias sobre a Lei e que colocas o teu orgulho em Deus;"
,"18":"tu, que conheces a vontade de Deus e que, instruído pela Lei, sabes distinguir o que é melhor:"
,"19":"tu, que estás convencido de ser o guia dos cegos, a luz daqueles que estão nas trevas,"
,"20":"o educador dos ignorantes, o mestre das pessoas simples, porque possuis na Lei a própria expressão do conhecimento e da verdade..."
,"21":"Muito bem! Ensinas aos outros e não ensinas a ti próprio! Pregas que não se deve roubar, e tu mesmo roubas!"
,"22":"Proíbes o adultério, e tu mesmo o cometes! Odeias os ídolos, mas roubas os objectos dos templos!"
,"23":"Glorias-te da Lei, mas desonras a Deus, transgredindo a Lei!"
,"24":"Assim diz a Escritura: «Por vossa causa, o nome de Deus é blasfemado entre os pagãos»."
,"25":"A circuncisão é útil quando praticas a Lei; mas, se desobedeces à Lei, é como se não estivesses circuncidado."
,"26":"Se um pagão não circuncidado observa os preceitos da Lei, não será tido como circuncidado, ainda que não o seja?"
,"27":"E o pagão que cumpre a Lei, embora não circuncidado fisicamente, julgar-te-á a ti que desobedeces à Lei, embora tenhas a Lei escrita e a circuncisão."
,"28":"De facto, aquilo que faz o judeu não é o que se vê, nem é a marca visível na carne que faz a circuncisão."
,"29":"Pelo contrário, o que faz o judeu é aquilo que está escondido, e circuncisão é a do coração; e isso vem do espírito e não da letra da Lei. Tal homem recebe aprovação, não dos homens, mas de Deus."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Então, qual é a superioridade do judeu? Qual é a utilidade da circuncisão?"
,"2":"Muita, sob todos os aspectos. Em primeiro lugar, porque as revelações de Deus foram confiadas aos judeus."
,"3":"E daí? Alguns deles negaram a fé. A sua incredulidade não anula a fidelidade de Deus?"
,"4":"De modo nenhum! Antes, fica confirmado que Deus é verdadeiro, enquanto todo o homem é mentiroso, conforme diz a Escritura: «Para que sejas reconhecido como justo nas tuas palavras e triunfes quando fores julgado»."
,"5":"Se a nossa injustiça realça a justiça de Deus, o que é que podemos dizer? Que Deus é injusto, quando descarrega sobre nós a sua ira? Falo como os homens costumam falar."
,"6":"De maneira alguma! Se assim fosse, como poderia Deus julgar o mundo?"
,"7":"Mas se através da minha mentira resplandece mais a verdade de Deus para sua glória, então porque sou julgado como pecador?"
,"8":"Porque não haveríamos de fazer o mal, para que venha o bem? Aliás, alguns caluniadores afirmam que nós ensinamos isso. Essas pessoas merecem condenação."
,"9":"E então? Nós, judeus, somos porventura superiores? De modo nenhum! Pois acabámos de provar que todos estão debaixo do império do pecado, tanto os judeus como os gregos,"
,"10":"como diz a Escritura:"
,"11":"Não há homem justo, não há um sequer. Não há homem sensato, não há quem busque a Deus."
,"12":"Todos se desviaram, e juntos se corromperam; não há quem faça o bem, não há um sequer."
,"13":"A sua garganta é um túmulo aberto, com a língua armam ciladas; em seus lábios há veneno de cobra."
,"14":"A sua boca está cheia de maldições e de amargor."
,"15":"Os seus pés são velozes,para derramar sangue;"
,"16":"ruína e desgraça,enchem os seus caminhos."
,"17":"Não conhecem o caminho da paz,"
,"18":"e não aprenderam a temer a Deus."
,"19":"Sabemos que tudo o que a Lei diz se aplica aos que vivem debaixo da Lei. Isso para que todos calem a boca e o mundo inteiro se reconheça culpado diante de Deus."
,"20":"Porque ninguém se tornará justo diante de Deus através da observância da Lei, pois a função da Lei é dar consciência do pecado."
,"21":"Agora, porém, independente da Lei, manifestou-se a justiça de Deus, testemunhada pela Lei e pelos Profetas."
,"22":"A justiça de Deus realiza-se através da fé em Jesus Cristo, para todos aqueles que acreditam. E não há distinção:"
,"23":"todos pecaram e estão privados da glória de Deus,"
,"24":"mas tornam-se justos gratuitamente pela sua graça, mediante a libertação realizada por meio de Jesus Cristo."
,"25":"Deus destinou-O a ser vítima que, mediante o seu próprio sangue, nos consegue o perdão, contanto que acreditemos. Assim Deus manifestou a sua justiça, pois antes deixava pecar sem intervir:"
,"26":"eram os tempos da paciência de Deus. Mas, no tempo presente, Ele manifesta a sua justiça para ser justo e para tornar justo quem tem fé em Jesus."
,"27":"Então, onde está o motivo de se gloriar? Foi eliminado. Por qual lei? Pela lei das obras? Não, pela lei da fé."
,"28":"Pois esta é a nossa tese: o homem torna-se justo através da fé, sem a observância da Lei."
,"29":"Então, será que Deus só é Deus dos judeus? Não será também Deus dos pagãos? Sim, Ele é Deus também dos pagãos."
,"30":"De facto, há um só Deus que justifica, pela fé, tanto os circuncidados como os não circuncidados."
,"31":"Então, pela fé anulamos a Lei? De modo nenhum! Pelo contrário, nós confirmamo-la."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Em vista disto, que vantagem podemos dizer que obteve Abraão, pai da nossa raça?"
,"2":"Se Abraão se tornou justo pelas suas obras, tem algo de que se gloriar, mas não diante de Deus."
,"3":"De facto, o que diz a Escritura? «Abraão teve fé em Deus, e isso foi-lhe creditado como justiça»."
,"4":"Para quem trabalha, o salário não é considerado como gratificação, mas como dívida;"
,"5":"para quem não trabalha, mas acredita n'Aquele que torna justo o ímpio, a sua fé é-lhe creditada como justiça."
,"6":"É desse modo que David proclama feliz o homem a quem Deus credita a justiça, independentemente das obras:"
,"7":"«Felizes aqueles cujas ofensas foram perdoadas e cujos pecados foram cobertos."
,"8":"Feliz o homem a quem o Senhor não leva em conta o pecado»."
,"9":"Essa felicidade é só para os circuncidados ou é também para os não circuncidados? Nós dizemos que a fé foi creditada a Abraão como justiça."
,"10":"Mas, quando é que lhe foi creditada? Quando já era circuncidado, ou quando ainda não era? Certamente não depois da circuncisão, mas antes."
,"11":"De facto, ele recebeu o sinal da circuncisão como selo da justiça que vem da fé, que ele já tinha obtido quando ainda não era circuncidado. Assim é que ele se tornou pai de todos os não circuncidados que acreditam, para que a justiça fosse creditada também para estes;"
,"12":"e tornou-se pai também dos circuncidados, daqueles que não só receberam a circuncisão, mas que também seguem o caminho da fé percorrido por Abraão, nosso pai, antes de ter sido circuncidado."
,"13":"Não foi por causa da Lei, mas por causa da justiça da fé que a promessa de receber o mundo em herança foi feita a Abraão ou à sua descendência."
,"14":"Se os herdeiros recebem a herança por causa da Lei, a fé não tem sentido e a promessa fica anulada."
,"15":"De facto, a Lei provoca a ira; mas, onde não há Lei, também não há transgressão."
,"16":"A herança, portanto, vem através da fé, para que seja gratuita e para que a promessa seja garantida a toda a descendência, não só à descendência segundo a Lei, mas também à descendência segundo a fé de Abraão, que é o pai de todos nós."
,"17":"De facto, a Escritura diz: «Constituí-te pai de muitas nações». Abraão é o nosso pai perante Aquele em quem acreditou, o Deus que dá vida aos mortos e que chama à existência aquilo que não existe."
,"18":"Esperando contra toda a esperança, Abraão acreditou e tornou-se o pai de muitas nações, conforme lhe foi dito: «Assim será a tua descendência»."
,"19":"Ele não fraquejou na fé, embora já visse o próprio corpo sem vigor - ele tinha quase cem anos - e o ventre de Sara já estivesse amortecido."
,"20":"Diante da promessa divina, não duvidou, mas foi fortalecido pela fé e deu glória a Deus."
,"21":"Ele estava plenamente convencido de que Deus podia realizar o que havia prometido."
,"22":"Eis o motivo pelo qual isso lhe foi creditado como justiça."
,"23":"Ora, não é para um só que está escrito: «Isso foi-lhe creditado»;"
,"24":"mas também para nós. Será igualmente creditado para nós, pois acreditamos n'Aquele que ressuscitou dos mortos, Jesus nosso Senhor,"
,"25":"o qual foi entregue à morte pelos nossos pecados e foi ressuscitado para nos tornar justos."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Assim, justificados pela fé, estamos em paz com Deus, por meio de nosso Senhor Jesus Cristo."
,"2":"Por meio d'Ele e através da fé, temos acesso à graça, em que nos mantemos e nos gloriamos, na esperança da glória de Deus."
,"3":"E não só isso. Nós gloriamo-nos também nas tribulações, sabendo que a tribulação produz a perseverança,"
,"4":"a perseverança produz a fidelidade comprovada, e a fidelidade comprovada produz a esperança."
,"5":"E a esperança não engana, pois o amor de Deus foi derramado em nossos corações pelo Espírito Santo que nos foi dado."
,"6":"De facto, quando ainda éramos fracos, Cristo, no momento oportuno, morreu pelos ímpios."
,"7":"Dificilmente se encontra alguém disposto a morrer em favor de um justo; talvez haja alguém que tenha coragem de morrer por um homem de bem."
,"8":"Mas Deus demonstra o seu amor para connosco porque Cristo morreu por nós quando ainda éramos pecadores."
,"9":"Assim, tornados justos pelo sangue de Cristo, com maior razão seremos salvos da ira por meio d'Ele."
,"10":"Se quando éramos inimigos fomos reconciliados com Deus por meio da morte do seu Filho, muito mais agora, já reconciliados, seremos salvos pela sua vida."
,"11":"E não só isso. Também nos gloriamos em Deus por meio de nosso Senhor Jesus Cristo, do qual obtivemos agora a reconciliação."
,"12":"Assim como o pecado entrou no mundo através de um só homem e com o pecado veio a morte, assim também a morte atingiu todos os homens, porque todos pecaram."
,"13":"De facto, já antes da Lei existia pecado no mundo, embora o pecado não possa ser levado em conta quando não existe Lei."
,"14":"Ora, a morte reinou de Adão até Moisés, mesmo sobre aqueles que não haviam pecado, cometendo uma transgressão igual à de Adão, que é figura d'Aquele que devia vir."
,"15":"O dom da graça, porém, não é como a falta. Se todos morreram devido à falta de um só, muito mais abundantemente se derramou sobre todos a graça de Deus e o dom gratuito de um só homem, Jesus Cristo."
,"16":"Também não acontece com o dom da graça, como aconteceu com o pecado de um só que pecou: a partir do pecado de um só, o julgamento levou à condenação, enquanto que, a partir de numerosas faltas, o dom da graça levou à justificação."
,"17":"Porque se através de um só homem reinou a morte por causa da falta de um só, com muito mais razão reinarão na vida aqueles que recebem a abundância da graça e do dom da justiça, por meio de um só: Jesus Cristo."
,"18":"Portanto, assim como pela falta de um só resultou a condenação para todos os homens, do mesmo modo foi pela justiça de um só que resultou para todos os homens a justificação que dá a vida."
,"19":"Assim como, pela desobediência de um só homem, todos se tornaram pecadores, do mesmo modo, pela obediência de um só, todos se tornarão justos."
,"20":"A Lei sobreveio para dar plena consciência da falta; mas, onde foi grande o pecado, foi bem maior a graça,"
,"21":"para que, assim como o pecado havia reinado através da morte, do mesmo modo a graça reine através da justiça para a vida eterna, por meio de nosso Senhor Jesus Cristo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Que diremos então? Devemos permanecer no pecado para que haja abundância da graça?"
,"2":"De modo nenhum! Uma vez que já morremos para o pecado, como poderíamos ainda viver no pecado?"
,"3":"Ou não sabeis que todos nós, que fomos baptizados em Jesus Cristo, fomos baptizados na sua morte?"
,"4":"Pelo baptismo fomos sepultados com Ele na morte, para que, assim como Cristo foi ressuscitado dos mortos por meio da glória do Pai, assim também nós possamos caminhar numa vida nova."
,"5":"Se permanecermos completamente unidos a Cristo com morte semelhante à sua, também permaneceremos com ressurreição semelhante à d'Ele."
,"6":"Sabemos muito bem que o nosso homem velho foi crucificado com Cristo, para que o corpo de pecado fosse destruído e assim já não sejamos mais escravos do pecado."
,"7":"De facto, quem está morto está livre do pecado."
,"8":"Mas, se estamos mortos com Cristo, acreditamos que também viveremos com Ele,"
,"9":"pois sabemos que Cristo, ressuscitado dos mortos, já não morre; a morte já não tem poder sobre Ele."
,"10":"Porque, morrendo, Cristo morreu de uma vez por todas para o pecado; vivendo, Ele vive para Deus."
,"11":"Assim também vós considerai-vos mortos para o pecado e vivos para Deus, em Jesus Cristo."
,"12":"Que o pecado não reine no vosso corpo mortal, submetendo-vos às suas paixões."
,"13":"Não ofereçais os membros como instrumento de injustiça para o pecado. Pelo contrário, oferecei-vos a Deus como pessoas vivas, que voltaram dos mortos; e oferecei os membros como instrumento da justiça para Deus."
,"14":"Pois o pecado não vos dominará nunca mais porque já não estais debaixo da Lei, mas sob a graça."
,"15":"E daí? Devemos cometer pecados, porque já não estamos debaixo da Lei, mas sob a graça? De modo nenhum!"
,"16":"Não sabeis que, oferecendo-vos a alguém como escravos para lhe obedecerdes, vos tornais escravos daquele a quem obedeceis, seja do pecado que leva à morte, seja da obediência que conduz à justiça?"
,"17":"Damos graças a Deus, porque éreis escravos do pecado, mas obedecestes de coração ao ensinamento básico que vos foi transmitido."
,"18":"Assim, livres do pecado, tornastes-vos escravos da justiça."
,"19":"Falo com palavras simples por causa da vossa fraqueza. Assim como antes colocastes os vossos membros ao serviço da imoralidade e da desordem que conduzem à revolta contra Deus, agora ponde os vossos membros ao serviço da justiça para a vossa santificação."
,"20":"Quando éreis escravos do pecado, éreis livres em relação à justiça."
,"21":"Que frutos colhestes então? Frutos de que agora vos envergonhais, pois o seu fim é a morte."
,"22":"Mas agora, livres do pecado e tornados escravos de Deus, dais frutos que conduzem à santificação e o fim deles é a vida eterna."
,"23":"Pois a morte é o salário do pecado, mas o dom gratuito de Deus é a vida eterna em Jesus Cristo, nosso Senhor."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Ou não sabeis, irmãos, - falo a pessoas competentes em matéria de lei - que a lei tem domínio sobre alguém só enquanto ele vive?"
,"2":"Por exemplo: a mulher casada está ligada por lei ao marido enquanto este vive; mas, se ele morre, ela fica livre da lei conjugal."
,"3":"Por isso, enquanto o marido está vivo, se ela se tornar mulher de outro homem, será chamada adúltera. Mas, se o marido morre, está livre em relação à lei, de modo que não será adúltera se casar com outro homem."
,"4":"Meus irmãos, o mesmo acontece convosco: pelo corpo de Cristo, morrestes para a Lei, a fim de pertencerdes a outro, que ressuscitou dos mortos, e assim produzirdes frutos para Deus."
,"5":"De facto, quando vivíamos submetidos a instintos egoístas, as paixões pecaminosas serviam-se da Lei para agir em nossos membros, a fim de que produzíssemos frutos para a morte."
,"6":"Mas agora, morrendo para aquilo que nos aprisionava, fomos libertos da Lei, a fim de servirmos sob o regime novo do Espírito, e não sob o velho regime da letra."
,"7":"Que diremos então? Que a Lei é pecado? De modo nenhum! Mas eu não teria conhecido o pecado se não existisse a Lei, nem teria conhecido a cobiça se a Lei não tivesse dito: «Não cobiçarás»."
,"8":"Mas o pecado aproveitou a ocasião desse mandamento e despertou em mim toda a espécie de cobiça, porque, sem a Lei, o pecado está morto."
,"9":"Antes eu vivia sem a Lei; mas, quando veio o mandamento, o pecado reviveu,"
,"10":"e eu morri. O mandamento que devia dar a vida tornou-se para mim motivo de morte."
,"11":"Porque o pecado aproveitou a ocasião do mandamento, seduziu-me e, através dele, matou-me."
,"12":"A Lei é santa e o mandamento é santo, justo e bom."
,"13":"Então uma coisa boa transformou-se em morte para mim? De modo nenhum! Foi o pecado que fez isso. Pois o pecado, através do que é bom, produziu em mim a morte, a fim de que o pecado, por meio do mandamento, aparecesse em toda a sua gravidade."
,"14":"Sabemos que a Lei é espiritual, mas eu sou humano e fraco, vendido como escravo ao pecado."
,"15":"Não consigo entender nem mesmo o que faço; pois não faço aquilo que quero, mas aquilo que mais detesto."
,"16":"Ora, se faço o que não quero, reconheço que a Lei é boa;"
,"17":"portanto, não sou eu que faço, mas é o pecado que mora em mim."
,"18":"Sei que o bem não mora em mim, isto é, nos meus instintos egoístas. O querer o bem está em mim, mas não sou capaz de fazê-lo."
,"19":"Não faço o bem que quero, mas o mal que não quero."
,"20":"Ora, se faço aquilo que não quero, não sou eu que o faço, mas é o pecado que mora em mim."
,"21":"Assim, encontro em mim esta lei: quando quero fazer o bem, acabo por encontrar o mal."
,"22":"No meu íntimo, eu amo a lei de Deus;"
,"23":"mas vejo nos meus membros outra lei que luta contra a lei da minha razão e que me torna escravo da lei do pecado que está nos meus membros."
,"24":"Infeliz de mim! Quem me libertará deste corpo de morte?"
,"25":"Sejam dadas graças a Deus, por meio de Jesus Cristo, nosso Senhor. Assim, pela razão sirvo a lei de Deus, mas pelos instintos egoístas sirvo a lei do pecado."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Agora, porém, já não existe nenhuma condenação para aqueles que estão em Jesus Cristo."
,"2":"A lei do Espírito, que dá a vida em Jesus Cristo, libertou-nos da lei do pecado e da morte."
,"3":"Deus tornou possível aquilo que para a Lei era impossível, porque os instintos egoístas tornaram-na impotente. Ele enviou o seu próprio Filho numa condição semelhante à do pecado, em vista do pecado, e assim condenou o pecado na sua carne mortal."
,"4":"Deus fez isto para que a justiça exigida pela Lei se realizasse em nós, que vivemos segundo o Espírito e não sob o domínio dos instintos egoístas."
,"5":"Os que vivem segundo os instintos egoístas inclinam-se para os instintos egoístas; mas os que vivem segundo o Espírito inclinam-se para aquilo que é próprio do Espírito."
,"6":"Os desejos dos instintos egoístas levam à morte; enquanto os desejos do Espírito levam à vida e à paz."
,"7":"De facto, os desejos dos instintos egoístas estão em revolta contra Deus, porque não se submetem à lei de Deus; e nem podem,"
,"8":"porque os que vivem segundo os instintos egoístas não podem agradar a Deus."
,"9":"Uma vez que o Espírito de Deus habita em vós, já não estais sob o domínio dos instintos egoístas, mas sob o Espírito, pois quem não tem o Espírito de Cristo não Lhe pertence."
,"10":"Se Cristo está em vós, o corpo está morto por causa do pecado, e o Espírito é vida por causa da justiça."
,"11":"Se o Espírito d'Aquele que ressuscitou Jesus dos mortos habita em vós, Aquele que ressuscitou Cristo dos mortos também dará a vida aos vossos corpos mortais, por meio do seu Espírito que habita em vós."
,"12":"Portanto, irmãos, nós somos devedores, mas não dos instintos egoístas para vivermos de acordo com eles."
,"13":"Se viveis segundo os instintos egoístas, morrereis; mas se com a ajuda do Espírito fazeis morrer as obras do corpo, vivereis."
,"14":"Todos os que são guiados pelo Espírito de Deus são filhos de Deus."
,"15":"Vós não recebestes um Espírito de escravos para recair no medo, mas recebestes um Espírito de filhos adoptivos, por meio do qual clamamos: Abbá! Pai!"
,"16":"O próprio Espírito assegura ao nosso espírito que somos filhos de Deus."
,"17":"E, se somos filhos, somos também herdeiros: herdeiros de Deus, herdeiros com Cristo, uma vez que, tendo participado nos seus sofrimentos, também participaremos da sua glória."
,"18":"Penso que os sofrimentos do momento presente não se comparam com a glória futura que deverá ser revelada em nós."
,"19":"A própria Criação espera com impaciência a manifestação dos filhos de Deus."
,"20":"Entregue ao poder do nada - não por sua própria vontade, mas por vontade d'Aquele que a submeteu - a Criação abriga a esperança,"
,"21":"pois ela também será liberta da escravidão da corrupção, para participar da liberdade e da glória dos filhos de Deus."
,"22":"Sabemos que toda a Criação tem gemido e sofrido dores de parto até agora."
,"23":"E não somente ela, mas também nós, que possuímos os primeiros frutos do Espírito, gememos no íntimo, esperando a adopção, a libertação do nosso corpo."
,"24":"Na esperança, já fomos salvos. Ver o que se espera, já não é esperar: como se pode esperar o que já se vê?"
,"25":"Mas, se esperamos o que não vemos, é na perseverança que o aguardamos."
,"26":"Do mesmo modo, também o Espírito vem em auxílio da nossa fraqueza, pois nem sabemos o que nos convém pedir; mas o próprio Espírito intercede por nós com gemidos inefáveis."
,"27":"E Aquele que sonda os corações sabe quais são os desejos do Espírito, pois o Espírito intercede pelos cristãos de acordo com a vontade de Deus."
,"28":"Sabemos que todas as coisas concorrem para o bem dos que amam a Deus, daqueles que são chamados segundo o seu projecto."
,"29":"Aqueles que Deus antecipadamente conheceu, também os predestinou a serem conformes à imagem do seu Filho, para que Este fosse o primogénito entre muitos irmãos."
,"30":"E aqueles que Deus predestinou, também os chamou. E aos que chamou, também os tornou justos. E aos que tornou justos, também os glorificou."
,"31":"O que nos resta dizer? Se Deus está a nosso favor, quem estará contra nós?"
,"32":"Ele não poupou o seu próprio Filho, mas entregou-O por todos nós. Como não havia de nos dar também todas as coisas com o seu Filho?"
,"33":"Quem acusará os escolhidos de Deus? É Deus quem torna justo!"
,"34":"Quem condenará? Jesus Cristo? Ele que morreu, ou melhor, que ressuscitou, que está à direita de Deus e intercede por nós?"
,"35":"Quem nos poderá separar do amor de Cristo? A tribulação, a angústia, a perseguição, a fome, a nudez, o perigo, a espada?"
,"36":"Como diz a Escritura: «Por tua causa somos entregues à morte o dia inteiro, somos considerados como ovelhas destinadas ao matadouro»."
,"37":"Mas, em todas estas coisas somos mais do que vencedores por meio d'Aquele que nos amou."
,"38":"Estou convencido de que nem a morte nem a vida, nem os anjos nem os principados, nem o presente nem o futuro, nem os poderes"
,"39":"nem as forças das alturas ou das profundidades, nem qualquer outra criatura, nada nos poderá separar do amor de Deus, manifestado em Jesus Cristo, nosso Senhor."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Digo a verdade em Cristo, não minto, e disso me dá testemunho a minha consciência pelo Espírito Santo:"
,"2":"tenho uma grande dor e um contínuo sofrimento no coração."
,"3":"Sim, eu gostaria de ser amaldiçoado e separado de Cristo em favor dos meus irmãos de raça e sangue."
,"4":"Eles são israelitas e possuem a adopção filial, a glória, as alianças, a legislação, o culto e as promessas;"
,"5":"deles são os patriarcas e deles nasceu Cristo segundo a condição humana, o qual está acima de tudo. Deus seja bendito para sempre. Ámen."
,"6":"A palavra de Deus, porém, não falhou, pois nem todos os nascidos de Israel são Israel,"
,"7":"e nem todos os descendentes de Abraão são filhos de Abraão. Não: «É de Isaac que sairá a descendência de Abraão»."
,"8":"Isto é, não é a geração natural que torna filhos de Deus, mas os filhos da promessa é que são considerados descendentes."
,"9":"De facto, as palavras da promessa são estas: «Por essa época voltarei, e Sara terá um filho»."
,"10":"E isto não é tudo. Também Rebeca concebeu de um só homem, de Isaac, nosso pai."
,"11":"Quando os filhos dela ainda não haviam nascido e nada tinham feito de bem ou de mal - isto para que ficasse confirmada a liberdade da escolha de Deus,"
,"12":"dependendo não das obras, mas d'Aquele que chama - então foi dito a Rebeca: «O mais velho será servo do mais novo»,"
,"13":"como diz a Escritura: «Amei mais a Jacob do que a Esaú»."
,"14":"Que diremos então? Que Deus é injusto? De modo nenhum!"
,"15":"Ele mesmo disse a Moisés: «Farei misericórdia a quem entendo usar de misericórdia, e terei piedade de quem entendo ter piedade»."
,"16":"Portanto, a escolha não depende da vontade ou do esforço do homem, mas da misericórdia de Deus."
,"17":"Por isso a Escritura diz ao Faraó: «Eu fiz-te nascer precisamente para em ti mostrar o meu poder e para que o meu Nome seja celebrado em toda a Terra»."
,"18":"Portanto, Deus usa de misericórdia com quem quer e endurece a quem quer."
,"19":"Dir-me-ás então: «Porque é que Deus ainda Se queixa? Quem pode resistir à sua vontade?»"
,"20":"Mas, quem és tu, homem, para discutires com Deus? Porventura o vaso de barro diz ao oleiro: «Porque me fizeste assim?»"
,"21":"Acaso o oleiro não é dono da argila, para fazer com a mesma massa dois vasos, um para uso nobre e outro para uso comum?"
,"22":"Ora, Deus quis manifestar a sua ira e mostrar o seu poder, suportando com muita paciência os vasos da ira, já prontos para a perdição."
,"23":"Deus assim fez para mostrar a riqueza da sua glória para com os vasos de misericórdia, que Ele havia preparado para a glória,"
,"24":"isto é, para connosco, a quem Deus chamou, não só dentre os judeus, mas também dentre os pagãos..."
,"25":"Como Ele diz em Oseias: «Chamarei Meu-Povo àquele que não é meu povo, e Amada àquela que não é amada."
,"26":"E acontecerá que, no mesmo lugar onde lhes foi dito: 'Vós não sois o meu povo', aí mesmo serão chamados filhos do Deus vivo»."
,"27":"E quanto a Israel, Isaías proclama: «Mesmo que o número dos israelitas seja como a areia do mar, o resto é que será salvo;"
,"28":"porque Deus cumprirá a sua palavra sobre a Terra com plenitude e rapidez»."
,"29":"E ainda como Isaías havia predito: «Se o Senhor dos Exércitos não nos tivesse deixado uma descendência, ficaríamos como Sodoma e tornar-nos-íamos como Gomorra»."
,"30":"O que diremos então? Os pagãos, que não procuravam a justiça, alcançaram a justiça, mas a justiça que vem da fé;"
,"31":"ao passo que Israel procurava uma lei que lhe trouxesse a justiça, mas não conseguiu essa lei."
,"32":"Porquê? Porque não a procurou através da fé, mas através das obras. Esbarraram na pedra de tropeço,"
,"33":"conforme diz a Escritura: «Eis que eu ponho em Sião uma pedra de tropeço, uma pedra de escândalo; mas quem acreditar nela não será confundido»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Irmãos, o desejo do meu coração e a súplica que faço a Deus, em favor deles, é que se salvem."
,"2":"Pois eu dou testemunho de que eles têm zelo por Deus, mas um zelo pouco esclarecido."
,"3":"Desconhecem a justiça de Deus e procuram afirmar a própria justiça e, assim, não se submetem à justiça de Deus."
,"4":"Pois o fim da Lei é Cristo, para que todo aquele que acredita se torne justo."
,"5":"Moisés assim descreve a justiça que vem da Lei: «Quem praticar os preceitos da Lei, viverá por meio deles»."
,"6":"Mas a justiça que vem da fé diz o seguinte: «Não perguntes a ti mesmo: 'Quem subirá ao céu?' Isto é: para fazer Cristo descer."
,"7":"Ou: 'Quem descerá ao abismo?' Isto é: para fazer Cristo subir dos mortos»."
,"8":"Mas, afinal, o que diz a Escritura? «A palavra está perto de ti, na tua boca e no teu coração». Isto é: a palavra da fé que nós pregamos."
,"9":"Pois se confessas com a boca que Jesus é o Senhor, e acreditas com o coração que Deus O ressuscitou dos mortos, serás salvo."
,"10":"É acreditando de coração que se obtém a justiça, e é confessando com a boca que se chega à salvação."
,"11":"De facto, a Escritura diz: «Todo aquele que acredita n'Ele não será confundido»."
,"12":"Não há distinção entre judeu e grego, pois Ele é o Senhor de todos, rico para com todos aqueles que O invocam."
,"13":"Porque todo aquele que invoca o Nome do Senhor será salvo."
,"14":"Ora, como poderão invocar Aquele em quem não acreditaram? Como poderão acreditar, se não ouviram falar d'Ele? E como poderão ouvir, se não houver quem O anuncie?"
,"15":"Como poderão anunciar se ninguém for enviado? Como diz a Escritura: «Como são belos os pés daqueles que anunciam boas notícias!»"
,"16":"Mas nem todos obedeceram ao Evangelho. Isaías diz: «Senhor, quem acreditou na nossa pregação?»"
,"17":"A fé depende, portanto, da pregação, e a pregação é o anúncio da palavra de Cristo."
,"18":"Agora, pergunto: Será que eles não ouviram? Ao contrário: pela Terra inteira correu a voz deles e as suas palavras foram até aos confins do mundo."
,"19":"Pergunto ainda: Será que Israel não entendeu? Moisés já dizia: «Farei com que tenhais ciúmes de um povo que não é povo; provocarei a vossa ira contra um povo insensato»."
,"20":"Isaías até ousa dizer: «Fui encontrado por aqueles que não Me procuravam; manifestei-Me àqueles que não perguntavam por Mim»."
,"21":"Enquanto que, sobre Israel, Isaías diz: «Todos os dias estendi as minhas mãos a um povo desobediente e rebelde»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Pergunto então: Será que Deus rejeitou o seu povo? De modo nenhum! Eu também sou israelita, da descendência de Abraão, da tribo de Benjamim."
,"2":"Deus não rejeitou o seu povo, que Ele conheceu desde o princípio. Ou não sabeis o que a Escritura diz na passagem em que Elias acusa Israel diante de Deus?"
,"3":"«Senhor, mataram os teus profetas, arrasaram os teus altares; fiquei apenas eu, e ainda procuram tirar-me a vida»."
,"4":"O que é que a voz divina lhe respondeu? «Reservei para Mim sete mil homens que não dobraram o joelho diante de Baal»."
,"5":"É o que continua a acontecer hoje: sobrou um resto, conforme a livre escolha da graça."
,"6":"E isso acontece pela graça, e não pelas obras; de contrário, a graça já não seria graça."
,"7":"Que dizer então? Israel não conseguiu aquilo que procurava, mas os escolhidos conseguiram. Os demais ficaram endurecidos,"
,"8":"como diz a Escritura: «Deus deu-lhes um espírito de torpor, olhos para não verem e ouvidos para não ouvirem, até ao dia de hoje»."
,"9":"E David diz: «Que a mesa deles se transforme em cilada, em armadilha, em motivo de tropeço e justo castigo."
,"10":"Que os seus olhos fiquem escuros para não verem, e faz com que as suas costas fiquem sempre encurvadas»."
,"11":"Agora pergunto: Será que tropeçaram para ficarem caídos? De modo nenhum! Mas assim aconteceu para que a queda de Israel tornasse possível a salvação para os pagãos, e para que Israel ficasse com ciúme."
,"12":"Ora, se a queda de Israel se tornou riqueza para o mundo e se a sua decadência se tornou riqueza para os pagãos, o que não será a total participação de Israel na salvação!"
,"13":"Portanto, digo-vos a vós, pagãos: como Apóstolo dos pagãos, honro o meu ministério,"
,"14":"para ver se provoco o ciúme dos que pertencem à minha raça e se consigo salvar alguns deles."
,"15":"Pois se o facto de serem rejeitados trouxe a reconciliação do mundo, o efeito da sua reintegração será a ressurreição dos mortos."
,"16":"Se os primeiros frutos são santos, toda a massa também será santa; se a raiz é santa, os ramos também serão santos."
,"17":"Se alguns ramos foram cortados, e tu, oliveira bravia, foste enxertada no lugar deles e agora recebes a seiva das raízes,"
,"18":"não te envaideças nem desprezes os ramos. Se te orgulhas, deves saber que não és tu que sustentas a raiz, mas é a raiz que te sustenta."
,"19":"Poderás dizer: «Os ramos foram cortados para eu ser enxertada»."
,"20":"Certamente! Mas eles foram cortados por causa da sua falta de fé, enquanto tu permaneces firme pela fé. Não fiques cheia de soberba, mas de temor,"
,"21":"porque, se Deus não poupou os ramos naturais, também não te poupará a ti."
,"22":"Considera, portanto, a bondade e severidade de Deus: severidade para com aqueles que caíram, mas bondade de Deus para contigo, com a condição, porém, de que sejas fiel a essa bondade. De outtro modo, também serás cortada."
,"23":"Quanto a eles, se não permanecerem na falta de fé, serão enxertados, pois Deus é capaz de os enxertar de novo."
,"24":"Pois, se tu foste cortada de uma oliveira bravia e contra a natureza foste enxertada numa oliveira boa, tanto mais eles poderão ser enxertados na própria oliveira boa à qual pertencem."
,"25":"Irmãos, não quero que ignoreis este mistério, para que não vos torneis convencidos: o endurecimento de uma parte de Israel vai durar até que chegue a plenitude das nações."
,"26":"Então, todo o Israel será salvo, como diz a Escritura: «De Sião sairá o Libertador, Ele vai tirar as impiedades de Jacob;"
,"27":"essa será a minha aliança com eles, quando Eu perdoar os seus pecados»."
,"28":"Quanto ao Evangelho, eles são inimigos, para vossa vantagem; mas, quanto à eleição, eles são amados, por causa dos patriarcas,"
,"29":"porque os dons e o chamamento de Deus são irrevogáveis."
,"30":"Vós fostes desobedientes a Deus, e agora, pela desobediência deles, conseguistes misericórdia."
,"31":"Do mesmo modo, também eles agora desobedeceram, a fim de que, pela misericórdia feita a vós, eles também obtenham misericórdia para eles."
,"32":"Deus encerrou todos na desobediência, para ser misericordioso com todos."
,"33":"Como é profunda a riqueza, a sabedoria e a ciência de Deus! Como são insondáveis as suas decisões, e como são impenetráveis os seus caminhos!"
,"34":"Quem poderá compreender o pensamento do Senhor? Quem foi o seu conselheiro?"
,"35":"Quem Lhe emprestou alguma coisa, para que Ele tenha algo a devolver?"
,"36":"Porque todas as coisas vêm d'Ele, por meio d'Ele e vão para Ele. A Ele pertence a glória para sempre. Ámen."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Irmãos, pela misericórdia de Deus, peço que ofereçais os vossos corpos como sacrifício vivo, santo e agradável a Deus. Este é o vosso culto autêntico."
,"2":"Não vos amoldeis às estruturas deste mundo, mas transformai-vos pela renovação da mente, a fim de distinguir qual é a vontade de Deus: o que é bom, o que Lhe é agradável, o que é perfeito."
,"3":"Em nome da graça que me foi concedida, eu digo a cada um de vós: não tenhais de vós mesmos conceito maior do que convém, mas um conceito justo, de acordo com a fé, na medida que Deus concedeu a cada um."
,"4":"Num só corpo há muitos membros, e esses membros não têm todos a mesma função."
,"5":"O mesmo acontece connosco: embora sendo muitos, formamos um só corpo em Cristo, e, cada um por sua vez, é membro dos outros."
,"6":"Mas temos dons diferentes, conforme a graça concedida a cada um de nós. Quem tem o dom da profecia, deve exercê-lo de acordo com a fé;"
,"7":"se tem o dom do serviço, que o exerça servindo; se do ensino, que ensine;"
,"8":"se é de aconselhar, aconselhe; se é de distribuir donativos, faça-o com simplicidade; se é de presidir à comunidade, faça-o com zelo; se é de exercer misericórdia, faça-o com alegria."
,"9":"Que o vosso amor seja sem hipocrisia: detestai o mal e apegai-vos ao bem;"
,"10":"no amor fraterno, sede carinhosos uns com os outros, rivalizando na mútua estima."
,"11":"Quanto ao zelo, não sejais preguiçosos; sede fervorosos de espírito, servindo ao Senhor."
,"12":"Sede alegres na esperança, pacientes na tribulação e perseverantes na oração."
,"13":"Sede solidários com os cristãos nas suas necessidades e aperfeiçoai-vos na prática da hospitalidade."
,"14":"Abençoai os que vos perseguem; abençoai e não amaldiçoeis."
,"15":"Alegrai-vos com os que se alegram e chorai com os que choram."
,"16":"Vivei em harmonia uns com os outros. Não vos deixeis levar pela mania de grandeza, mas afeiçoai-vos às coisas modestas. Não vos considereis sábios."
,"17":"Não pagueis a ninguém o mal com o mal; a vossa preocupação seja fazer o bem a todos os homens."
,"18":"Se for possível, no que depende de vós, vivei em paz com todos."
,"19":"Amados, não façais justiça por própria conta, mas deixai a ira de Deus agir, pois o Senhor diz na Escritura: «A Mim pertence a vingança; Eu mesmo vou retribuir»."
,"20":"Mas, se o teu inimigo tiver fome, dá-lhe de comer; se tiver sede, dá-lhe de beber; desse modo, farás o outro corar de vergonha."
,"21":"Não te deixes vencer pelo mal, mas vence o mal com o bem."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Submetei-vos todos às autoridades constituídas, pois não há autoridade que não venha de Deus, e as que existem foram instituídas por Deus."
,"2":"Quem se opõe à autoridade, opõe-se à ordem estabelecida por Deus. Aqueles que se opõem, atraem sobre si a condenação."
,"3":"Na verdade, os que governam não devem ser temidos quando se faz o bem, mas quando se faz o mal. Se não queres ter medo da autoridade, faz o bem, e ela te elogiará."
,"4":"A autoridade é o instrumento de Deus para teu bem, mas, se praticas o mal, teme, pois não é à toa que a autoridade usa a espada: quando castiga, ela está ao serviço de Deus, para manifestar a sua ira contra o malfeitor."
,"5":"Por isso, é preciso submeter-se, não só por medo do castigo, mas também por dever de consciência."
,"6":"É também por isso que pagais impostos, pois os que têm esse encargo são funcionários de Deus."
,"7":"Dai a cada um o que lhe é devido: o imposto e a taxa, a quem deveis imposto e taxa; o temor, a quem deveis temor; a honra, a quem deveis honra."
,"8":"Não fiqueis a dever nada a ninguém, a não ser o amor mútuo. Pois, quem ama o próximo cumpriu plenamente a Lei."
,"9":"De facto, os mandamentos: não cometerás adultério, não matarás, não roubarás, não cobiçarás, e todos os outros, resumem-se nesta sentença: «Amarás o teu próximo como a ti mesmo»."
,"10":"O amor não pratica o mal contra o próximo, pois o amor é o pleno cumprimento da Lei."
,"11":"Comportai-vos desta maneira, principalmente porque conheceis o tempo, e já é hora de acordardes: a nossa salvação está agora mais próxima do que quando começámos a acreditar."
,"12":"A noite vai avançada e o dia está próximo. Deixemos, portanto, as obras das trevas e vistamos as armas da luz."
,"13":"Vivamos honestamente, como em pleno dia: não em orgias e bebedeiras, prostituição e libertinagem, brigas e ciúmes."
,"14":"Mas revesti-vos do Senhor Jesus Cristo, e não sigais os desejos dos instintos egoístas."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Acolhei o fraco na fé sem lhe criticar os escrúpulos."
,"2":"Um acredita que pode comer de tudo; outro, sendo fraco, só come legumes."
,"3":"Quem come de tudo, não despreze quem não come. E quem não come, não julgue aquele que come, porque Deus acolhe-o assim mesmo."
,"4":"Quem és tu para julgar um servo alheio? Se ele fica de pé ou cai, isso é lá com o patrão dele; mas ele ficará de pé, pois o Senhor é poderoso para o sustentar."
,"5":"Há quem faça diferença entre um dia e outro, enquanto outro acha que todos os dias são iguais. Cada qual siga a sua convicção."
,"6":"Quem distingue o dia, faz isso em honra do Senhor. Quem come de tudo, fá-lo em honra do Senhor, porque agradece a Deus. E quem não come, não come em honra do Senhor, e também agradece a Deus."
,"7":"Porque nenhum de vós vive para si mesmo, e ninguém morre para si mesmo."
,"8":"Se vivemos, é para o Senhor que vivemos; se morremos, é para o Senhor que morremos. Quer vivamos, quer morramos, pertencemos ao Senhor."
,"9":"Cristo morreu e voltou à vida para ser o Senhor dos mortos e dos vivos."
,"10":"Quanto a ti, porque julgas o teu irmão? E porque desprezas o teu irmão? Todos nós devemos comparecer diante do tribunal de Deus."
,"11":"Porque a Escritura diz: «Por minha vida, diz o Senhor, diante de Mim se dobrará todo o joelho, e toda a língua dará glória a Deus»."
,"12":"Portanto, cada um de nós prestará contas de si mesmo a Deus."
,"13":"Deixemos, portanto, de nos julgar uns aos outros. Pelo contrário, preocupai-vos em não ser causa de tropeço ou escândalo para o irmão."
,"14":"Sei e estou convencido no Senhor Jesus: nada é impuro por si mesmo. Mas, se alguém acha que alguma coisa é impura, essa coisa torna-se impura para ele."
,"15":"Se, por questão de alimento, entristeces o teu irmão, não estás a agir com amor. Portanto, o alimento que comes não seja causa de perdição para aquele por quem Cristo morreu."
,"16":"Não deis motivo a que outros falem mal daquilo que para vós é bom."
,"17":"O Reino de Deus não é questão de comida ou bebida; é justiça, paz e alegria no Espírito Santo."
,"18":"Quem serve a Cristo nessas coisas agrada a Deus e é estimado pelos homens."
,"19":"Portanto, busquemos sempre as coisas que trazem paz e edificação mútua."
,"20":"Não destruas a obra de Deus por uma questão de comida! Todas as coisas são puras. Mas é mau que um homem coma provocando escândalo."
,"21":"É melhor não comer carne, nem beber vinho ou qualquer outra coisa, quando isso é ocasião de tropeço, escândalo e queda para o irmão."
,"22":"Guarda para ti, diante de Deus, a convicção que tens. Feliz aquele que não se condena a si mesmo na decisão que toma."
,"23":"Mas quem duvida e assim mesmo toma o alimento é condenado, pois o seu comportamento não provém de uma convicção. E tudo o que não provém de uma convicção é pecado."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Nós, que somos os fortes, devemos suportar a fraqueza dos fracos, e não procurarmos o que nos agrada."
,"2":"Cada um de nós procure agradar ao seu próximo."
,"3":"Cristo não procurou agradar a Si mesmo; pelo contrário, como diz a Escritura: «Os insultos daqueles que Te insultam caíram sobre Mim»."
,"4":"Ora, tudo isto que foi escrito antes de nós, foi escrito para nossa instrução, para que, em virtude da perseverança e consolação que as Escrituras nos dão, conservemos a esperança."
,"5":"O Deus da perseverança e da consolação conceda que tenhais os mesmos sentimentos uns com os outros, a exemplo de Jesus Cristo."
,"6":"E assim vós, juntos e a uma só voz, dai glória ao Deus e Pai de nosso Senhor Jesus Cristo."
,"7":"Acolhei-vos uns aos outros, como Cristo vos acolheu, para a glória de Deus."
,"8":"Digo-vos que Cristo Se tornou servidor dos judeus em vista da fidelidade de Deus, a fim de cumprir as promessas feitas aos patriarcas."
,"9":"As nações pagãs, porém, dão glória a Deus por causa da misericórdia d'Ele, conforme diz a Escritura: «Por isso eu Te celebrarei entre as nações pagãs e cantarei hinos ao teu Nome»."
,"10":"A Escritura também diz: «Nações pagãs, alegrai-vos com o povo de Deus»."
,"11":"E diz ainda: «Nações pagãs todas, louvai ao Senhor, e todos os povos O celebrem»."
,"12":"E Isaías também diz: «Aparecerá o rebento de Jessé, Aquele que Se levanta para governar as nações pagãs. N'Ele as nações pagãs colocarão a sua esperança»."
,"13":"Que o Deus da esperança vos encha de completa alegria e paz na fé, para que transbordeis de esperança, pela força do Espírito Santo."
,"14":"Meus irmãos, também eu estou pessoalmente convencido de que estais cheios de bondade e repletos de todo o conhecimento, para vos corrigirdes uns aos outros."
,"15":"Todavia, escrevi-vos, em parte com certa ousadia, para vos reavivar a memória, em vista da graça que me foi concedida por Deus."
,"16":"Sou ministro de Jesus Cristo entre os pagãos, e a minha função sagrada é anunciar o Evangelho de Deus, a fim de que os pagãos se tornem oferta aceite e santificada pelo Espírito Santo."
,"17":"Tenho, portanto, motivo para me orgulhar em Jesus Cristo a propósito da obra de Deus."
,"18":"Eu não ousaria mencionar nada, a não ser o que Cristo fez, através de mim, para levar os pagãos à obediência pela palavra e pela acção,"
,"19":"mediante o poder dos sinais e prodígios, pelo poder do Espírito de Deus. Assim, desde Jerusalém e seus arredores até à Ilíria, levei a cabo o anúncio do Evangelho de Cristo."
,"20":"Fiz questão de anunciar o Evangelho onde o Nome de Cristo ainda não havia sido anunciado, a fim de não construir sobre alicerces que outro havia colocado."
,"21":"Deste modo, faço o que a Escritura diz: «Aqueles aos quais não tinha sido anunciado, verão; e os que não tinham ouvido, compreenderão»."
,"22":"Foi este o motivo que muitas vezes me impediu de vos visitar."
,"23":"Mas agora já não tenho tanto campo de acção nestas regiões. E porque há muitos anos tenho grande desejo de vos visitar,"
,"24":"quando eu for para a Espanha, espero ver-vos por ocasião da minha passagem. Espero também receber a vossa ajuda para ir até lá, depois de ter desfrutado um pouco a vossa companhia."
,"25":"Agora vou a Jerusalém prestar um serviço aos cristãos."
,"26":"A Macedónia e a Acaia resolveram fazer uma colecta em favor dos cristãos pobres da comunidade de Jerusalém."
,"27":"Resolveram fazer isso, porque lhes são devedores. De facto, se os pagãos participaram nos bens espirituais dos judeus, têm obrigação de os ajudar nas suas necessidades materiais."
,"28":"Quando eu tiver concluído essa tarefa e tiver entregue oficialmente o fruto da colecta, irei para a Espanha, passando por aí."
,"29":"Sei que, indo até vós, irei com a plenitude da bênção de Cristo."
,"30":"Irmãos, por nosso Senhor Jesus Cristo e pelo amor do Espírito, peço que luteis comigo nas orações que dirigis a Deus em meu favor."
,"31":"Rezai para que eu escape dos infiéis que estão na Judeia e para que o meu serviço a favor de Jerusalém seja bem aceite por aquela comunidade."
,"32":"Assim, se Deus quiser, poderei visitar-vos com alegria e descansar um pouco aí entre vós."
,"33":"Que o Deus da paz esteja com todos vós. Ámen."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Recomendo-vos a nossa irmã Febe, diaconisa da Igreja de Cêncreas."
,"2":"Recebei-a no Senhor, como convém a cristãos. Dai-lhe toda a ajuda de que precisar, pois ela tem ajudado muita gente e a mim também."
,"3":"Saudações a Prisca e Áquila, meus colaboradores em Jesus Cristo,"
,"4":"que arriscaram a própria cabeça para salvar a minha vida. Sou grato não somente a eles, mas também a todas as Igrejas dos pagãos."
,"5":"Saudai também a Igreja que se reúne na casa deles. Saudações ao meu caro Epéneto, o primeiro fruto da Ásia para Cristo."
,"6":"Saudações a Maria, que trabalhou muito por vós."
,"7":"Saudai Andrónico e Júnia, meus parentes e companheiros de prisão; eles são apóstolos importantes e converteram-se a Cristo antes de mim."
,"8":"Saudai Amplíato, meu caro amigo no Senhor."
,"9":"Saudai Urbano, nosso colaborador em Cristo, e também o meu caro Estáquis."
,"10":"Saudai Apeles, que provou ser bom cristão. Saudai os familiares de Aristóbulo. "
,"11":"Saudai Herodião, meu parente. Saudai os cristãos da família de Narciso."
,"12":"Saudai Trifena e Trifosa, que trabalharam pelo Senhor."
,"13":"Saudai Rufo, o eleito do Senhor, e sua mãe, que é minha também."
,"14":"Saudai Asíncrito, Flegonte, Hermes, Pátrobas, Hermas e os irmãos que vivem com eles."
,"15":"Saudai Filólogo e Júlia, Nereu e sua irmã, Olimpas e todos os cristãos que vivem com eles."
,"16":"Saudai-vos uns aos outros com o beijo santo. Todas as Igrejas de Cristo vos saúdam."
,"17":"Irmãos, peço-vos que tenhais cuidado com aqueles que provocam divisões e obstáculos contra a doutrina que aprendestes."
,"18":"Afastai-vos deles, porque não servem a Cristo nosso Senhor, mas ao próprio estômago; com palavras doces e aduladoras, enganam o coração das pessoas simples."
,"19":"A vossa obediência é conhecida de todos. Para mim sois um motivo de alegria, mas desejo que sejais sábios para o bem e sem compromissos com o mal."
,"20":"O Deus da paz não tardará em esmagar Satanás debaixo dos vossos pés. Que a graça de nosso Senhor Jesus Cristo esteja convosco."
,"21":"O meu colaborador Timóteo e os meus parentes Lúcio, Jasão e Sosípatro mandam saudações."
,"22":"Eu, Tércio, que escrevi esta carta, mando saudações no Senhor."
,"23":"Saudações de Gaio, que me hospeda a mim e a toda a comunidade. Erasto, que é o administrador da cidade, e o irmão Quarto também mandam saudações."
,"25":"Seja dada glória a Deus, que tem o poder de vos conservar firmes, de acordo com o meu Evangelho e a mensagem de Jesus Cristo. Esta é a revelação de um mistério que estava envolvido no silêncio desde os tempos eternos."
,"26":"Agora, este mistério foi manifestado pelos escritos proféticos e, por disposição do Deus eterno, foi anunciado a todos os pagãos, para os conduzir à obediência da fé."
,"27":"A Deus, o único sábio, por meio de Jesus Cristo, seja dada a glória para sempre. Ámen!"
}`)

}
func PT_BS_LoadNPTTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Paulo, servo de Deus, Apóstolo de Jesus Cristo para levar os escolhidos de Deus à fé e ao conhecimento daquela verdade que conduz à piedade"
,"2":"e se fundamenta sobre a esperança da vida eterna. Deus, que não mente, prometeu-nos essa vida antes dos tempos eternos,"
,"3":"e no tempo certo manifestou-a com a sua Palavra, através da pregação que me foi confiada por ordem de Deus, nosso Salvador."
,"4":"A ti, Tito, meu verdadeiro filho na fé comum, graça e paz da parte de Deus e de Jesus Cristo, nosso Salvador."
,"5":"Eu deixei-te em Creta para que cuidasses de organizar o que ainda restava para fazer, e para que nomeasses em cada cidade os presbíteros das Igrejas, conforme as instruções que te deixei:"
,"6":"o candidato deve ser irrepreensível, esposo de uma única mulher, e seus filhos devem ter fé e não ser acusados de maus costumes nem de desobediência."
,"7":"De facto, sendo administrador de Deus, o dirigente deve ser irrepreensível, não arrogante, nem beberrão ou violento, nem ávido de lucro desonesto."
,"8":"Pelo contrário, deve ser hospitaleiro, bondoso, ponderado, justo, piedoso, disciplinado,"
,"9":"e de tal modo fiel à fé verdadeira, conforme o ensinamento transmitido, que seja capaz de aconselhar segundo a sã doutrina e também de refutar quando a contradizem."
,"10":"De facto, há muitos rebeldes, faladores e enganadores, principalmente entre os que vieram do judaísmo."
,"11":"É preciso fazer com que eles se calem, pois estão a perverter famílias inteiras, ensinando o que não devem, com a intenção vergonhosa de ganhar dinheiro."
,"12":"Um dos seus profetas disse: «Os habitantes da ilha de Creta são sempre mentirosos, animais ferozes, comilões preguiçosos»."
,"13":"E o que ele disse é verdade. Por isso, repreende-os com firmeza, para que sejam sãos na fé,"
,"14":"e não dêem ouvidos a fábulas judaicas ou a mandamentos de homens desviados da verdade."
,"15":"Tudo é puro para os puros; mas nada é puro para os impuros e descrentes, porque a sua mente e a sua consciência estão corrompidas."
,"16":"Dizem que conhecem a Deus, mas negam-no com os próprios actos, pois são cheios de ódio, desobedientes e incapazes de fazer qualquer obra boa."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quanto a ti, ensina o que é conforme à sã doutrina."
,"2":"Que os velhos sejam sóbrios, respeitáveis, sensatos, fortes na fé, no amor e na paciência."
,"3":"As mulheres idosas também devem comportar-se como convém a pessoas sensatas: não sejam caluniadoras, nem escravas de bebida excessiva;"
,"4":"pelo contrário, sejam capazes de dar bons conselhos, de modo que as recém-casadas aprendam com elas a amar os seus maridos e filhos,"
,"5":"a ser ajuizadas, castas, boas donas de casa, submissas aos seus esposos, amáveis, a fim de que a Palavra de Deus não seja difamada."
,"6":"Aconselha igualmente os jovens, para que em tudo tenham bom senso."
,"7":"E tu mesmo sê exemplo de boa conduta, sincero e sério no teu ensino,"
,"8":"exprimindo-te numa linguagem digna e irrepreensível, para que o adversário nada tenha a dizer contra nós e fique envergonhado."
,"9":"Os servos devem ser em tudo obedientes aos seus senhores, dando-lhes motivo de alegria; não devem ser teimosos,"
,"10":"nem roubar; pelo contrário, devem dar provas de inteira fidelidade, para em tudo honrar a doutrina de Deus, nosso Salvador."
,"11":"A graça de Deus manifestou-se para a salvação de todos os homens."
,"12":"Essa graça ensina-nos a abandonar a impiedade e as paixões mundanas, para vivermos neste mundo com autodomínio, justiça e piedade,"
,"13":"aguardando a bendita esperança, isto é, a manifestação da glória de Jesus Cristo, nosso grande Deus e Salvador."
,"14":"Ele entregou-Se a Si mesmo por nós, para nos resgatar de toda a iniquidade e para purificar um povo que Lhe pertence, e que seja zeloso nas boas obras."
,"15":"Diz-lhes todas estas coisas. Exorta-os e repreende-os com toda a autoridade. Que ninguém te despreze."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Lembra-lhes que devem ser submissos aos magistrados e autoridades, que devem obedecer e estar prontos para toda a boa obra;"
,"2":"não devem difamar ninguém, nem meter-se em brigas, mas antes ser pacíficos e atenciosos no trato com todos."
,"3":"Também nós, antigamente, éramos insensatos, desobedientes, extraviados, escravos de todo o tipo de paixões e prazeres, vivendo na perversidade e na inveja, dignos de ódio e odiando-nos uns aos outros."
,"4":"Mas a bondade e o amor de Deus, nosso Salvador, manifestaram-se. Ele salvou-nos,"
,"5":"não por causa dos actos justos que tivéssemos praticado, mas porque fomos lavados pela sua misericórdia através do poder regenerador e renovador do Espírito Santo."
,"6":"Deus derramou abundantemente o Espírito sobre nós, por meio de Jesus Cristo nosso Salvador,"
,"7":"para que, justificados pela sua graça, nos tornássemos herdeiros da esperança da vida eterna."
,"8":"Esta é uma palavra digna de fé. Por isso quero que insistas nestas coisas, a fim de que aqueles que acreditam em Deus sejam os primeiros a praticar o bem. Estas coisas são boas e úteis para os homens."
,"9":"Evita controvérsias inúteis, genealogias, discussões e debates sobre a Lei, porque para nada servem e são vazias."
,"10":"Depois de um primeiro e um segundo conselho, nada mais tens a fazer com um herege,"
,"11":"pois sabemos que um homem desse tipo se perverteu e se entregou ao pecado, condenando-se a si mesmo."
,"12":"Vou enviar-te Ártemas ou Tíquico. Quando chegar aí, faz o possível por vires ter comigo a Nicópolis, onde resolvi passar o Inverno."
,"13":"E esforça-te por ajudar Zenas, o jurista, e Apolo, de modo que nada lhes falte para a viagem."
,"14":"Todos os da nossa gente precisam de aprender a praticar boas obras, de modo que sejam capazes de atender às necessidades urgentes e assim não vivam uma vida inútil."
,"15":"Todos os que estão comigo te mandam saudações. Saudações a todos os que nos amam na fé. Que a graça esteja com todos vós."
}`)

}
func PT_BS_LoadNTAAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No meu primeiro livro, ó Teófilo, já tratei de tudo o que Jesus começou a fazer e a ensinar, desde o princípio"
,"2":"até o dia em que foi levado para o céu. Antes disso, Ele deu instruções aos Apóstolos que escolhera, movido pelo Espírito Santo."
,"3":"Foi aos Apóstolos que Jesus, com numerosas provas, Se mostrou vivo depois da sua paixão: durante quarenta dias apareceu-lhes e falou-lhes do Reino de Deus."
,"4":"Estando com os Apóstolos numa refeição, Jesus deu-lhes esta ordem: «Não vos afasteis de Jerusalém. Esperai que se realize a promessa do Pai, da qual ouvistes falar:"
,"5":"'João baptizou com água; vós, porém, dentro de poucos dias, sereis baptizados com o Espírito Santo'»."
,"6":"Então, os que estavam reunidos perguntaram a Jesus: «Senhor, é agora que vais restaurar o Reino de Israel?»"
,"7":"Jesus respondeu: «Não pertence a vós saber os tempos e as datas que o Pai reservou à sua própria autoridade."
,"8":"Mas o Espírito Santo descerá sobre vós, e d'Ele recebereis força para serdes as minhas testemunhas em Jerusalém, em toda a Judeia e Samaria, e até aos extremos da Terra»."
,"9":"Depois de dizer isto, Jesus foi levado ao Céu à vista deles. E quando uma nuvem O cobriu, eles não puderam vê-l'O mais."
,"10":"Os Apóstolos continuavam a olhar para o Céu, enquanto Jesus Se afastava. Mas, de repente, dois homens vestidos de branco apareceram-lhes"
,"11":"e disseram: «Homens da Galileia, porque estais aí parados a olhar para o Céu? Esse Jesus que vos foi tirado e levado para o céu, virá do mesmo modo como O vistes partir para o Céu»."
,"12":"Os Apóstolos voltaram para Jerusalém, pois encontravam-se no chamado monte das Oliveiras, não muito longe de Jerusalém: a uma caminhada de sábado."
,"13":"Entraram na cidade e subiram para a sala de cima, onde costumavam hospedar-se. Ali estavam Pedro e João, Tiago e André, Filipe e Tomé, Bartolomeu e Mateus, Tiago, filho de Alfeu, Simão Zelota e Judas, filho de Tiago."
,"14":"Todos eles tinham os mesmos sentimentos e eram assíduos na oração, juntamente com algumas mulheres, entre as quais Maria, Mãe de Jesus, e com os irmãos de Jesus."
,"15":"Naqueles dias, estava ali reunido um grupo de mais ou menos cento e vinte pessoas. Pedro levantou-se no meio dos irmãos e disse:"
,"16":"«Irmãos, era preciso que se cumprisse aquilo que o Espírito Santo, por meio de David, tinha anunciado na Escritura a respeito de Judas, que se tornou o guia daqueles que prenderam Jesus."
,"17":"Judas era um do nosso grupo e participava do nosso serviço."
,"18":"Ele comprou um terreno com o salário da sua iniquidade; depois caiu de cabeça, rebentou e as suas entranhas espalharam-se."
,"19":"A notícia chegou a todos os habitantes de Jerusalém que deram àquele terreno o nome de Hacéldama, que quer dizer 'campo de sangue', conforme a sua língua."
,"20":"Pois no livro dos Salmos está escrito: 'Que a sua moradia fique deserta e ninguém habite nela.' E ainda: 'Que outro ocupe o seu cargo'."
,"21":"Há outros homens que nos acompanharam durante todo o tempo em que o Senhor vivia no meio de nós,"
,"22":"desde o baptismo de João até ao dia em que foi levado ao Céu. Agora, é preciso que um deles se junte a nós para testemunhar a ressurreição'."
,"23":"Então eles apresentaram dois homens: José, chamado Bársabas e apelidado o Justo, e também Matias."
,"24":"Em seguida fizeram esta oração: «Senhor, Tu conheces o coração de todos. Mostra-nos qual destes dois escolheste"
,"25":"para ocupar, no serviço do apostolado, o lugar que Judas abandonou para seguir o seu destino»."
,"26":"Então tiraram à sorte entre os dois. E a sorte caiu em Matias, que foi juntado ao número dos onze Apóstolos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quando chegou o dia de Pentecostes, todos eles estavam reunidos no mesmo lugar."
,"2":"De repente, veio do céu um barulho como o sopro de um forte vendaval, e encheu a casa onde eles se encontravam."
,"3":"Apareceram então uma espécie de línguas de fogo, que se espalharam e foram poisar sobre cada um deles."
,"4":"Todos ficaram repletos do Espírito Santo, e começaram a falar em outras línguas, conforme o Espírito lhes concedia que falassem."
,"5":"Acontece que em Jerusalém moravam judeus devotos de todas as nações do mundo."
,"6":"Quando ouviram o barulho, todos se reuniram e ficaram confusos, pois cada um ouvia os discípulos a falar na sua própria língua."
,"7":"Espantados e surpreendidos, diziam: «Estes homens que estão a falar não são todos galileus?"
,"8":"Como é que cada um de nós os ouve na nossa língua materna?"
,"9":"Entre nós há Partos, Medos e Elamitas; gente da Mesopotâmia, da Judeia e da Capadócia, do Ponto e da Ásia,"
,"10":"da Frígia e da Panfília, do Egipto e da região da Líbia vizinha de Cirene; alguns de nós viemos de Roma,"
,"11":"outros são judeus ou pagãos convertidos; também há Cretenses e Árabes. E cada um de nós na sua própria língua os ouve anunciar as maravilhas de Deus!»"
,"12":"Todos estavam admirados e perplexos, e cada um perguntava ao outro: «O que quer dizer isto?»"
,"13":"Outros escarneciam e diziam: «Eles estão embriagados com vinho doce»."
,"14":"Então Pedro, que estava ali com os outros onze Apóstolos, levantou-se e disse em voz alta: «Homens da Judeia e todos os que vos encontrais em Jerusalém! Compreendei o que está a acontecer e prestai atenção às minhas palavras:"
,"15":"estes homens não estão embriagados como pensais, pois são apenas nove horas da manhã."
,"16":"Pelo contrário, está a acontecer aquilo que o profeta Joel anunciou:"
,"17":"'Nos últimos dias, diz o Senhor, Eu derramarei o meu Espírito sobre todas as pessoas. Os vossos filhos e filhas vão profetizar, os jovens terão visões e os anciãos terão sonhos."
,"18":"E, naqueles dias, derramarei o meu Espírito também sobre os meus servos e servas, e eles profetizarão."
,"19":"Farei prodígios no alto do céu e sinais em baixo na terra: sangue, fogo e nuvens de fumo."
,"20":"O Sol transformar-se-á em trevas e a Lua em sangue, antes que chegue o dia do Senhor, dia grande e glorioso."
,"21":"E todo aquele que invocar o Nome do Senhor será salvo'."
,"22":"Homens de Israel, escutai estas palavras: Jesus de Nazaré foi um homem que Deus confirmou entre vós, realizando por meio d'Ele os milagres, prodígios e sinais que bem conheceis."
,"23":"E Deus, com a sua vontade e presciência, permitiu que Jesus vos fosse entregue, e vós, através de ímpios, mataste-l'O, pregando-O numa cruz."
,"24":"Deus, porém, ressuscitou Jesus, libertando-O das cadeias da morte, porque não era possível que ela O dominasse."
,"25":"De facto, David assim falou a respeito de Jesus: 'Eu via sempre o Senhor diante de mim, porque Ele está à minha direita, para que eu não vacile."
,"26":"Por isso, o meu coração se alegra, a minha língua exulta e a minha carne repousa com esperança."
,"27":"Porque não me abandonarás na região dos mortos, nem permitirás que o teu santo conheça a corrupção."
,"28":"Tu me ensinaste os caminhos da vida e me encherás de alegria na tua presença'."
,"29":"Irmãos, quanto ao patriarca David, permiti que vos diga com franqueza: ele morreu, foi sepultado e o seu túmulo está entre nós até hoje."
,"30":"Mas era profeta e sabia que Deus lhe havia jurado solenemente fazer com que um seu descendente lhe sucedesse no trono."
,"31":"Por isso, previu a ressurreição de Cristo e disse: 'Ele não foi abandonado na região dos mortos e a sua carne não conheceu a corrupção'."
,"32":"Deus ressuscitou este Jesus. E nós todos somos testemunhas disso."
,"33":"Ele foi exaltado à direita de Deus, recebeu do Pai o Espírito prometido e comunicou-O: é o que vedes e ouvis."
,"34":"De facto, David não subiu ao céu, mas disse: 'O Senhor disse ao meu Senhor: senta-Te à minha direita,"
,"35":"até que faça de teus inimigos um lugar para apoiares os teus pés'."
,"36":"Que todo o povo de Israel fique a saber com certeza que Deus tornou Senhor e Cristo aquele Jesus que vós crucificastes»."
,"37":"Quando ouviram isto, todos ficaram de coração aflito e perguntaram a Pedro e aos outros discípulos: «Irmãos, que devemos fazer?»"
,"38":"Pedro respondeu: «Arrependei-vos, e cada um de vós seja baptizado em nome de Jesus Cristo, para o perdão dos pecados; depois recebereis do Pai o dom do Espírito Santo."
,"39":"Pois a promessa é em favor de vós e de vossos filhos, e para todos aqueles que estão longe, todos aqueles que o Senhor nosso Deus chamar»."
,"40":"Com muitas outras palavras, Pedro lhes dava testemunho e exortava, dizendo: «Livrai-vos da gente corrompida»."
,"41":"Os que acolheram a palavra de Pedro receberam o baptismo. E nesse dia uniram-se a eles cerca de três mil pessoas."
,"42":"Eram perseverantes em ouvir o ensinamento dos Apóstolos, na comunhão fraterna, no partir do pão e nas orações."
,"43":"Em todos eles havia temor, por causa dos numerosos prodígios e sinais que os Apóstolos realizavam."
,"44":"Todos os que abraçaram a fé eram unidos e colocavam em comum todas as coisas;"
,"45":"vendiam as suas propriedades e os seus bens e repartiam o dinheiro entre todos, conforme a necessidade de cada um."
,"46":"Diariamente, todos juntos frequentavam o Templo e nas casas partiam o pão, tomando alimento com alegria e simplicidade de coração."
,"47":"Louvavam a Deus e eram estimados por todo o povo. E todos os dias o Senhor acrescentava à comunidade outras pessoas que iam aceitando a salvação."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pedro e João subiam ao Templo para a oração das três horas da tarde,"
,"2":"quando viram trazer um homem, coxo de nascença. Costumavam colocá-lo todos os dias à porta do Templo chamada Formosa, para pedir esmola aos que entravam no Templo."
,"3":"Quando viu Pedro e João a entrar no Templo, o homem pediu-lhes esmola."
,"4":"Pedro e João olharam bem para o homem. E Pedro disse: «Olha para nós»."
,"5":"O homem olhou para eles com atenção, esperando receber alguma coisa."
,"6":"Então Pedro disse: «Não tenho ouro nem prata, mas vou dar-te o que tenho: em nome de Jesus Cristo, o Nazareno, levanta-te e começa a andar!»"
,"7":"Depois Pedro pegou na mão direita do homem e ajudou-o a levantar-se. No mesmo instante, os pés e tornozelos do homem ficaram firmes."
,"8":"Então ele deu um pulo, ficou de pé e começou a andar. E entrou no Templo com Pedro e João, andando, pulando e louvando a Deus."
,"9":"Todos viram o homem a andar e a louvar a Deus."
,"10":"Reconheceram que era ele que pedia esmola à porta Formosa do Templo. E ficaram admirados e espantados com o que lhe havia acontecido."
,"11":"O homem curado não deixava Pedro e João. E todo o povo, assombrado, acorreu ao chamado «Pórtico de Salomão»."
,"12":"Ao ver isso, Pedro dirigiu-se ao povo: «Israelitas, porque vos admirais com o que aconteceu? Porque olhais para nós, como se tivéssemos feito andar este homem com o nosso próprio poder ou piedade?"
,"13":"O Deus de Abraão, de Isaac e de Jacob, o Deus dos nossos antepassados glorificou o seu servo Jesus que vós entregastes e negastes diante de Pilatos, que estava decidido a soltá-l'O."
,"14":"Vós, porém, renegastes o Santo e o Justo e pedistes clemência para um assassino."
,"15":"Matastes o Autor da vida, mas Deus ressuscitou-O dos mortos. E disto nós somos testemunhas."
,"16":"Graças à fé no nome de Jesus, esse Nome acaba de fortalecer este homem que vedes e reconheceis. A fé em Jesus deu saúde perfeita a este homem que está na vossa presença."
,"17":"Apesar disso, meus irmãos, sei que agistes por ignorância, assim como os vossos chefes."
,"18":"Deus, porém, cumpriu deste modo o que havia anunciado através de todos os profetas: que o seu Messias haveria de sofrer."
,"19":"Portanto arrependei-vos e convertei-vos, para que os vossos pecados sejam perdoados."
,"20":"Assim podereis alcançar o tempo do repouso que vem do Senhor. E Ele enviará Jesus, o Messias que vos havia destinado."
,"21":"No entanto, é necessário que o céu O receba, até que se cumpra o tempo da restauração de todas as coisas, conforme disse Deus nos tempos passados pela boca dos seus santos profetas."
,"22":"De facto, Moisés afirmou: 'O Senhor Deus fará surgir, entre os vossos irmãos, um pro-feta como eu. Escutai tudo o que Ele vos disser."
,"23":"Quem não der ouvidos a esse profeta, será eliminado do meio do povo'."
,"24":"E todos os profetas que falaram, desde Samuel e seus sucessores, também eles anunciaram estes dias."
,"25":"Sois filhos dos profetas e dos homens com quem Deus fez a Aliança, quando disse a Abraão: 'Através da tua descendência, serão abençoadas todas as famílias da Terra'."
,"26":"Após ter ressuscitado o seu servo, Deus enviou-O em primeiro lugar a vós, para vos abençoar e para que cada um de vós se converta das suas maldades»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Pedro e João ainda estavam a falar ao povo, quando chegaram os sacerdotes, o chefe da guarda do Templo e os saduceus."
,"2":"Estavam irritados porque os Apóstolos ensinavam o povo e anunciavam que a ressurreição dos mortos tinha acontecido em Jesus."
,"3":"Prenderam Pedro e João e meteram-nos na prisão até ao dia seguinte, porque já estava a anoitecer."
,"4":"Todavia, muitos daqueles que tinham ouvido o discurso acreditaram. E o número dos homens chegou a uns cinco mil."
,"5":"No dia seguinte reuniram-se em Jerusalém os chefes, os anciãos e os doutores da Lei."
,"6":"Estavam lá o sumo sacerdote Anás e também Caifás, João, Alexandre e todos os que pertenciam às famílias dos sumos sacerdotes."
,"7":"Fizeram Pedro e João comparecer diante deles e interrogaram-nos: «Com que poder, ou em nome de quem, fizestes isto?»"
,"8":"Então Pedro, cheio do Espírito Santo, disse-lhes: «Chefes do povo e anciãos!"
,"9":"Hoje somos interrogados em julgamento sobre o bem que fizemos a um enfermo e sobre o modo como ele foi curado."
,"10":"Pois ficai sabendo todos vós, e também todo o povo de Israel: É pelo Nome de Jesus Cristo, de Nazaré, - Aquele que crucificastes e que Deus ressuscitou dos mortos, - é pelo seu Nome, e por nenhum outro, que este homem está curado diante de vós."
,"11":"Jesus é a pedra que vós, construtores, rejeitastes, e que se tornou a pedra angular."
,"12":"Não existe salvação em nenhum outro, pois debaixo do céu não existe outro nome dado aos homens, pelo qual possamos ser salvos»."
,"13":"Eles ficaram admirados ao ver a segurança com que Pedro e João falavam, pois eram pessoas simples e sem instrução. Reconheceram que eles eram companheiros de Jesus."
,"14":"No entanto, viam de pé, junto deles, o homem que tinha sido curado. E não podiam dizer nada em contrário."
,"15":"Mandaram-nos sair para fora do Sinédrio e começaram a discutir entre si:"
,"16":"«Que vamos fazer com estes homens? Eles realizaram um milagre claríssimo, e o facto tornou-se de tal modo conhecido por todos os habitantes de Jerusalém, que não podemos negá-lo."
,"17":"Contudo, a fim de que a coisa não se espalhe ainda mais entre o povo, vamos ameaçá-los, para que não falem a mais ninguém a respeito do Nome de Jesus»."
,"18":"Chamaram de novo Pedro e João e ordenaram-lhes que não falassem ou ensinassem em nome de Jesus."
,"19":"Pedro e João responderam: «Julgai vós mesmos se é justo diante de Deus que obedeçamos a vós e não a Ele!"
,"20":"Quanto a nós, não podemos calar-nos sobre o que vimos e ouvimos»."
,"21":"Então, insistindo nas suas ameaças, deixaram Pedro e João em liberdade, já que não descobriam maneira de os castigar, por causa do povo. Pois todos glorificavam a Deus pelo que tinha acontecido."
,"22":"De facto, o homem que tinha sido milagrosamente curado tinha mais de quarenta anos."
,"23":"Logo que foram postos em liberdade, Pedro e João voltaram para junto dos irmãos e contaram tudo o que os sumos sacerdotes e os anciãos haviam dito."
,"24":"Depois de os terem ouvido, todos elevaram a voz a Deus, dizendo: «Senhor, Tu criaste o céu, a terra, o mar e tudo o que neles existe."
,"25":"Por meio do Espírito Santo disseste através do teu servo David, nosso pai: 'Porque se amotinam as nações, e os povos planeiam em vão?"
,"26":"Os reis da terra insurgem-se e os príncipes conspiram unidos contra o Senhor e contra o seu Messias'."
,"27":"Foi o que aconteceu nesta cidade: Herodes e Pôncio Pilatos uniram-se com os pagãos e os povos de Israel contra Jesus, teu santo servo, a quem ungiste,"
,"28":"a fim de executarem tudo o que a tua mão e a tua vontade tinham predeterminado que sucedesse."
,"29":"Agora, Senhor, olha as ameaças que fazem e concede que os teus servos anunciem corajosamente a tua Palavra."
,"30":"Estende a mão para que se realizem curas, sinais e prodígios por meio do Nome do teu santo servo Jesus»."
,"31":"Quando terminaram a oração, estremeceu o lugar em que estavam reunidos. Todos, então, ficaram cheios do Espírito Santo e, com coragem, anunciavam a Palavra de Deus."
,"32":"A multidão dos fiéis era um só coração e uma só alma. Ninguém considerava propriedade particular as coisas que possuía, mas tudo era posto em comum entre eles."
,"33":"Com grande poder, os Apóstolos davam testemunho da ressurreição do Senhor Jesus. E todos eles gozavam de grande aceitação."
,"34":"Entre eles ninguém passava necessidade, pois aqueles que possuíam terras ou casas vendiam-nas, traziam o dinheiro"
,"35":"e colocavam-no aos pés dos Apóstolos; depois, era distribuído a cada um conforme a sua necessidade."
,"36":"Foi assim que procedeu José, um levita nascido em Chipre, apelidado pelos Apóstolos com o nome de Barnabé, que significa «filho da exortação»."
,"37":"Ele vendeu o campo que possuía, trouxe o dinheiro e colocou-o aos pés dos Apóstolos."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Um homem chamado Ananias fez um acordo com a esposa Safira: vendeu uma propriedade que possuía,"
,"2":"reteve uma parte do dinheiro para si e entregou a outra parte, colocando-a aos pés dos Apóstolos."
,"3":"Pedro perguntou-lhe: «Ananias, porque deixaste que Satanás tomasse posse do teu coração? Porque mentes ao Espírito Santo, conservando uma parte do preço do terreno?"
,"4":"Não podias conservá-lo para ti sem o vender? E mesmo que o vendesses não podias ficar com todo o dinheiro? Então, porque fizeste isso? Tu não mentiste aos homens, mas a Deus»."
,"5":"Ao ouvir isto, Ananias caiu no chão e morreu. E um grande temor se apoderou de todos os assistentes."
,"6":"Os mais jovens levantaram-se, enrolaram o corpo de Ananias num lençol e levaram-no a enterrar."
,"7":"Umas três horas mais tarde, chegou a esposa de Ananias, sem saber o que havia acontecido."
,"8":"Pedro perguntou-lhe: «É verdade que vendestes o terreno por esse preço?» Ela respondeu: «Sim, foi por esse preço»."
,"9":"Então Pedro disse: «Porque combinastes tentar o Espírito do Senhor? Olha! Os que foram enterrar o teu marido estão a chegar. Eles vão levar-te também a ti!»"
,"10":"No mesmo instante, Safira caiu aos pés de Pedro e morreu. Quando os jovens entraram, encontraram-na morta, levaram-na e sepultaram-na ao lado do marido."
,"11":"E grande temor se espalhou por toda a Igreja e entre todos aqueles que ouviram falar do que havia acontecido."
,"12":"Muitos sinais e prodígios eram realizados entre o povo pelas mãos dos Apóstolos. E todos os fiéis se reuniam em grupo no Pórtico de Salomão."
,"13":"Os outros não se atreviam a juntar-se a eles, mas o povo elogiava-os muito."
,"14":"Uma multidão cada vez maior de homens e mulheres aderia ao Senhor, pela fé."
,"15":"Chegaram ao ponto de transportar doentes para as praças, em esteiras e camas, para que Pedro, ao passar, pelo menos a sua sombra cobrisse alguns deles."
,"16":"A multidão vinha até das cidades vizinhas de Jerusalém, trazendo doentes e pessoas atormentadas por espíritos maus. E todos eram curados."
,"17":"Então o sumo sacerdote, com todo o seu partido - isto é, o partido dos saduceus - ficaram cheios de raiva,"
,"18":"e mandaram prender os Apóstolos e metê-los na prisão."
,"19":"Durante a noite, porém, o anjo do Senhor abriu as portas da prisão e fê-los sair, dizendo:"
,"20":"«Ide ao Templo e lá anunciai ao povo toda a mensagem da vida»."
,"21":"Eles obedeceram e, ao amanhecer, entraram no Templo e começaram a ensinar. O sumo sacerdote chegou com os seus partidários e convocou o Sinédrio, isto é, o Conselho das pessoas importantes do povo de Israel. Então mandaram buscar os Apóstolos à prisão. "
,"22":"Os servos, ao chegarem à prisão, não os encontraram, e voltaram dizendo:"
,"23":"«Encontrámos a prisão cuidadosamente fechada e os guardas estavam de sentinela à porta. Mas, quando abrimos a porta, não encontrámos ninguém lá dentro»."
,"24":"Ao ouvir esta notícia, o chefe da guarda do Templo e os sumos sacerdotes não sabiam o que pensar e perguntavam a si próprios o que poderia ter acontecido."
,"25":"Chegou alguém que lhes disse: «Os homens que metestes na prisão estão no Templo a ensinar o povo!»"
,"26":"Então o chefe da guarda do Templo saiu com os guardas e trouxe os Apóstolos, mas sem violência, porque tinham medo que o povo os apedrejasse."
,"27":"Levaram os Apóstolos e apresentaram-nos ao Sinédrio. O sumo sacerdote disse:"
,"28":"«Nós tínhamo-vos proibido expressamente ensinar em nome de Jesus e, no entanto, enchestes Jerusalém com a vossa doutrina. E quereis tornar-nos responsáveis pela morte desse homem!»"
,"29":"Então Pedro e os outros Apóstolos responderam: «É preciso obedecer antes a Deus do que aos homens."
,"30":"O Deus dos nossos antepassados ressuscitou Jesus, que vós matastes, suspendendo-O numa cruz."
,"31":"Mas Deus com a sua direita exaltou-O, tornando-O Chefe supremo e Salvador, para dar ao povo a oportunidade de se arrepender e receber o perdão dos pecados."
,"32":"E nós somos testemunhas destas coisas, nós e o Espírito Santo, que Deus concedeu àqueles que Lhe obedecem»."
,"33":"Enfurecidos com estas palavras, os conselheiros pensaram em matar os Apóstolos."
,"34":"Levantou-se, então, no Sinédrio, um fariseu chamado Gamaliel. Era doutor da Lei, e todo o povo o estimava. Gamaliel mandou que os acusados saíssem por um instante."
,"35":"Depois disse: «Homens de Israel, vede bem o que estais para fazer contra estes homens."
,"36":"Há algum tempo apareceu Teudas, que se fazia passar por uma pessoa importante, e juntaram-se-lhe cerca de quatrocentos homens. Depois foi morto, e todos os que o seguiam debandaram e nada mais restou."
,"37":"Depois dele, no tempo do recenseamento, apareceu Judas, o galileu, que arrastou o povo atrás de si. Contudo, também ele acabou mal, e todos os seus seguidores se dispersaram."
,"38":"Quanto ao que agora está a acontecer, dou-vos um conselho: não vos preocupeis com estes homens, e soltai-os. Porque, se o seu projecto ou actividade é de origem humana, será destruído;"
,"39":"mas, se vem de Deus, não conseguireis aniquilá-los. Cuidado, não corrais o risco de vos meterdes contra Deus!» Os participantes no Sinédrio aceitaram o parecer de Gamaliel."
,"40":"Chamaram os Apóstolos, mandaram-nos açoitar, proibiram-nos de falar em nome de Jesus, e depois soltaram-nos."
,"41":"Os Apóstolos saíram do Conselho muito contentes por terem merecido sofrer insultos por causa do nome de Jesus."
,"42":"E cada dia, no Templo e pelas casas, não cessavam de ensinar e anunciar a Boa Notícia de Jesus Messias."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Naqueles dias, o número dos discípulos tinha aumentado, e os fiéis de origem grega começaram a queixar-se contra os fiéis de origem hebraica. Os de origem grega diziam que as suas viúvas eram deixadas de lado no atendimento diário."
,"2":"Então os Doze convocaram uma assembleia geral dos discípulos e disseram: «Não está certo que nós deixemos a pregação da Palavra de Deus para servirmos à mesa."
,"3":"Irmãos, é melhor que escolhais entre vós sete homens de boa fama, repletos do Espírito e de sabedoria, e encarregá-los-emos dessa tarefa."
,"4":"Deste modo, nós poderemos dedicar-nos inteiramente à oração e ao serviço da Palavra»."
,"5":"A proposta agradou a toda a assembleia. Então escolheram Estêvão, homem cheio de fé e do Espírito Santo; e também Filipe, Prócoro, Nicanor, Timon, Parmenas e Nicolau de Antioquia, um pagão que seguia a religião dos judeus."
,"6":"Todos estes foram apresentados aos Apóstolos, que oraram e impuseram as mãos sobre eles."
,"7":"Entretanto, a Palavra do Senhor espalhava-se. O número dos discípulos crescia muito em Jerusalém, e um grande número de sacerdotes judeus obedecia à fé cristã."
,"8":"Cheio de graça e poder, Estêvão fazia grandes prodígios e sinais entre o povo."
,"9":"No entanto, alguns membros da sinagoga dos Libertos, com cireneus e alexandrinos, e alguns da Cilícia e da Ásia começaram a discutir com Estêvão."
,"10":"Mas não conseguiam resistir à sabedoria e ao Espírito com que Estêvão falava."
,"11":"Então subornaram alguns indivíduos que disseram: «Ouvimos este homem proferir palavras blasfemas contra Moisés e contra Deus»."
,"12":"Deste modo, incitaram o povo e os anciãos. Os doutores da Lei prenderam Estêvão e conduziram-no ao Sinédrio."
,"13":"Ali apresentaram falsas testemunhas que diziam: «Este homem não cessa de falar contra este lugar santo e contra a Lei."
,"14":"De facto, nós ouvimo-lo afirmar que Jesus, o Nazareno, destruirá este lugar e subverterá os costumes que Moisés nos transmitiu»."
,"15":"Todos os que estavam sentados no Sinédrio tinham os olhos fixos em Estêvão e viram o seu rosto como o rosto de um anjo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Então o sumo sacerdote perguntou a Estêvão: «É verdade o que eles afirmam?»"
,"2":"Estêvão respondeu: «Irmãos e pais, escutai. O Deus da glória apareceu ao nosso pai Abraão quando ele ainda estava na Mesopotâmia, antes de habitar em Harã."
,"3":"E disse-lhe: 'Sai da tua terra e da tua família e vai para a terra que Eu te vou mostrar'."
,"4":"Abraão saiu, então, da terra dos caldeus e estabeleceu-se em Harã. E depois da morte do pai, Deus fê-lo emigrar daí para esta terra onde agora vós morais."
,"5":"Deus não lhe deu nenhuma propriedade nesta terra, nem mesmo o espaço para ele pousar o pé. Mas prometeu a posse dela a ele e depois à sua descendência, embora Abraão não tivesse filhos."
,"6":"Deus falou assim: 'A descendência de Abraão habitará em terra estrangeira, será escravizada e maltratada durante quatrocentos anos."
,"7":"Mas Eu pedirei contas à nação da qual eles forem escravos. Depois disso, sairão livres e prestar-Me-ão culto neste lugar'."
,"8":"Depois Deus concedeu a Abraão a aliança da circuncisão. Deste modo, Abraão gerou Isaac e circunci-dou-o no oitavo dia; Isaac gerou Jacob; e Jacob gerou os doze patriarcas."
,"9":"Os patriarcas, porém, por inveja venderam José como escravo para o Egipto. Mas Deus estava com ele,"
,"10":"e libertou-o de todas as aflições, e concedeu-lhe graça e sabedoria diante do Faraó, rei do Egipto. Este nomeou-o administrador do Egipto e de toda a sua casa."
,"11":"Sobreveio então uma carestia em todo o Egipto e em Canaã; a miséria era grande e os nossos pais não encontravam nada para comer."
,"12":"Sabendo que no Egipto havia mantimentos, Jacob enviou para lá os nossos pais uma primeira vez."
,"13":"Na segunda vez, José deu-se a conhecer aos seus irmãos. E o Faraó veio a conhecer de que raça era José."
,"14":"Então José mandou chamar o pai Jacob e toda a família, ao todo setenta e cinco pessoas."
,"15":"Jacob desceu ao Egipto e aí morreu, como também os nossos pais."
,"16":"E eles foram transportados para Siquém e colocados no sepulcro que Abraão tinha comprado em Siquém, a preço de prata, aos filhos de Hemor."
,"17":"Quando se aproximava o tempo de se realizar a promessa que Deus tinha feito a Abraão, o povo cresceu e multiplicou-se no Egipto,"
,"18":"até que no Egipto surgiu outro rei que não tinha conhecido José."
,"19":"Esse rei, agindo com astúcia contra a nossa raça, perseguiu os nossos pais e obrigou-os a abandonar os filhos recém-nascidos, para que não sobrevivessem."
,"20":"Nesse tempo, nasceu Moisés, que era belo aos olhos de Deus. Durante três meses Moisés foi criado na casa de seu pai."
,"21":"Depois, quando foi abandonado, a filha do Faraó recolheu-o e criou-o como seu próprio filho."
,"22":"Assim Moisés foi iniciado em toda a sabedoria dos egípcios e era poderoso no falar e no agir."
,"23":"Quando completou quarenta anos, Moisés desejou visitar os seus irmãos israelitas."
,"24":"Vendo que um deles era maltratado, tomou a sua defesa e, para o vingar, matou o egípcio."
,"25":"Ele acreditava que os seus irmãos iriam compreender que Deus, por meio dele, os libertaria; mas não compreenderam."
,"26":"No dia seguinte, Moisés apresentou-se a dois dos seus irmãos que brigavam e procurava reconciliá-los, dizendo: 'Porquê, sendo irmãos, vos agredis um ao outro?'"
,"27":"Nesse momento, aquele que agredia o companheiro respondeu: 'Quem te nomeou chefe ou juiz sobre nós?"
,"28":"Acaso queres matar-me como fizeste ontem com o egípcio?»"
,"29":"Ao ouvir isto, Moisés fugiu e foi morar na região de Madiã, onde teve dois filhos."
,"30":"Quarenta anos depois, apareceu-lhe no deserto do monte Sinai um anjo na chama de uma sarça que ardia."
,"31":"Moisés ficou admirado ao ver a aparição. Queria aproximar-se para ver melhor, quando então se ouviu a voz do Senhor:"
,"32":"'Eu sou o Deus de teus pais, o Deus de Abraão, de Isaac e de Jacob'. Moisés tremia e não ousava levantar os olhos."
,"33":"Então o Senhor disse-lhe: 'Tira as sandálias dos pés, porque o lugar onde estás é terra santa."
,"34":"Eu vi a miséria do meu povo no Egipto. Ouvi os seus gemidos e desci para o libertar. Agora vem cá, pois Eu quero mandar-te ao Egipto'."
,"35":"Assim, aquele Moisés que os israelitas haviam renegado, dizendo: 'Quem te nomeou chefe e juiz?', Deus enviou-o como chefe e libertador, por meio do anjo que lhe tinha aparecido na sarça."
,"36":"Foi ele que nos fez sair do Egipto, realizando sinais e prodígios no Egipto, no Mar Vermelho e durante quarenta anos no deserto."
,"37":"Foi Moisés que disse aos israelitas: 'Deus suscitará entre os vossos irmãos um profeta como eu'."
,"38":"Foi ele que, na assembleia do deserto, serviu de intermediário entre o anjo que lhe falava no monte Sinai e os nossos pais. Ele recebeu as palavras de vida, para no-las transmitir."
,"39":"Os nossos pais, porém, não quiseram dar-lhe ouvidos. Ao contrário, rejeitaram-no e, no seu desejo, voltaram ao Egipto,"
,"40":"dizendo a Aarão: 'Faz-nos deuses que nos guiem, porque não sabemos o que aconteceu a esse Moisés que nos tirou do Egipto'."
,"41":"Naqueles dias, construíram um bezerro, ofereceram um sacrifício ao ídolo e celebraram a obra das suas próprias mãos."
,"42":"Então Deus afastou-Se deles e deixou que adorassem os astros do céu, como está escrito no livro dos profetas: 'Oferecestes-Me, porventura, vítimas e sacrifícios durante quarenta anos no deserto, ó casa de Israel?"
,"43":"Pelo contrário, levastes a tenda de Moloc e a estrela do deus Refã, imagens que vós mesmos fabricastes para adorar. Por isso exilar-vos-ei para além da Babilónia'."
,"44":"Os nossos pais no deserto tinham a Tenda da presença de Deus. E Deus, que falava com Moisés, mandou que a construísse de acordo com o modelo que tinha visto."
,"45":"Nossos pais receberam a Tenda e, sob a direcção de Josué, levaram-na para a terra das nações que Deus expulsou diante dos nossos pais. E a Tenda ficou ali até ao tempo de David."
,"46":"E David encontrou graça diante de Deus e pediu-Lhe autorização para construir uma casa ao Deus de Jacob."
,"47":"No entanto, foi Salomão quem construiu a casa."
,"48":"O Altíssimo, porém, não mora em casas feitas por mãos humanas, conforme diz o profeta:"
,"49":"'O Céu é o meu trono, e a Terra é o lugar onde apoio os meus pés. Que casa Me construireis?, diz o Senhor, e qual será o lugar do meu descanso?"
,"50":"Não foi a minha mão que fez todas as coisas?'"
,"51":"Homens teimosos, insensíveis e fechados à vontade de Deus! Vós sempre resististes ao Espírito Santo. Sois como os vossos pais!"
,"52":"Qual foi o profeta que os vossos pais não tenham perseguido? Mataram aqueles que anunciavam a vinda do Justo, do qual agora vos tornastes traidores e assassinos."
,"53":"Recebestes a Lei, promulgada através dos anjos, e não a observastes!»"
,"54":"Ao ouvirem estas palavras, ficaram enfurecidos e rangeram os dentes contra Estêvão."
,"55":"Repleto do Espírito Santo, Estêvão olhou para o Céu e viu a glória de Deus, e Jesus, de pé, à direita de Deus."
,"56":"Então disse: «Vejo o Céu aberto e o Filho do Homem, de pé, à direita de Deus»."
,"57":"Então soltaram fortes gritos, taparam os ouvidos e avançaram todos juntos contra Estêvão."
,"58":"Arrastaram-no para fora da cidade e começaram a apedrejá-lo. As testemunhas deixaram os seus mantos aos pés de um jovem chamado Saulo."
,"59":"Atiravam pedras contra Estêvão, que repetia esta invocação: «Senhor Jesus, recebe o meu espírito»."
,"60":"Depois dobrou os joelhos e gritou forte: «Senhor, não os condenes por este pecado». E, ao dizer isto, adormeceu."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Saulo era um daqueles que aprovavam a morte de Estêvão. Naquele dia, desencadeou-se uma grande perseguição contra a Igreja de Jerusalém. E todos, à excepção dos Apóstolos, se espalharam pelas regiões da Judeia e da Samaria."
,"2":"Algumas pessoas piedosas sepultaram Estêvão e fizeram por ele um grande luto."
,"3":"Saulo, porém, devastava a Igreja: entrava nas casas e arrastava para fora homens e mulheres, para os meter na prisão."
,"4":"E aqueles que se dispersaram iam de um lugar para outro, anunciando a Palavra."
,"5":"Filipe desceu a uma cidade da região de Samaria e aí começou a anunciar Cristo."
,"6":"As multidões seguiam com atenção tudo o que Filipe dizia, e todos em peso o escutavam, pois viam os milagres que ele fazia."
,"7":"Dando grandes gritos, os espíritos maus saíam de muitos endemoninhados. Numerosos paralíticos e aleijados também foram curados."
,"8":"E a cidade encheu-se de alegria."
,"9":"Na mesma cidade, havia um homem chamado Simão, que desde algum tempo praticava a magia. Ele impressionava o povo da Samaria, fazendo-se passar como uma pessoa importante."
,"10":"Todos, pequenos e grandes, aderiam a Simão, dizendo: «Este homem é o poder de Deus, que é chamado Grande»."
,"11":"Aderiam a ele, porque há longo tempo Simão os deixava impressionados com as suas artes mágicas."
,"12":"Quando começaram a acreditar em Filipe, que anunciava a Boa Notícia do Reino de Deus e do nome de Jesus Cristo, tanto os homens como as mulheres apresentavam-se para o baptismo."
,"13":"Simão também aderiu à fé e, depois de baptizado, não se separava de Filipe. Simão ficou muito impressionado ao ver os sinais e os grandes prodígios que aconteciam."
,"14":"Os Apóstolos, que estavam em Jerusalém, souberam que a Samaria acolhera a Palavra de Deus, e enviaram para lá Pedro e João."
,"15":"Ao chegarem, Pedro e João rezaram pelos samaritanos, a fim de receberem o Espírito Santo."
,"16":"De facto, o Espírito ainda não viera sobre nenhum deles; e os samaritanos tinham apenas recebido o baptismo em nome do Senhor Jesus."
,"17":"Então Pedro e João impuseram as mãos sobre os samaritanos, e eles receberam o Espírito Santo."
,"18":"Simão, ao ver que o Espírito Santo era comunicado através da imposição das mãos, ofereceu dinheiro a Pedro e João, dizendo:"
,"19":"«Dai-me também esse poder, a fim de que receba o Espírito todo aquele sobre o qual eu impuser as mãos»."
,"20":"Mas Pedro respondeu: «Que tu pereças juntamente com o teu dinheiro, pois julgaste poder comprar com dinheiro aquilo que é dom de Deus."
,"21":"De nenhum modo podes participar nesta realidade espiritual, porque a tua consciência não é correcta diante de Deus."
,"22":"Arrepende-te dessa maldade e suplica ao Senhor que te perdoe a má intenção que tiveste,"
,"23":"pois vejo que estás envolvido pela iniquidade, como de fel amargo»."
,"24":"Simão respondeu: «Suplicai por mim ao Senhor, para que não me aconteça nada do que acabais de dizer»."
,"25":"Depois de ter testemunhado e anunciado a Palavra do Senhor, Pedro e João voltaram para Jerusalém, levando a Boa Notícia a muitas aldeias da Samaria."
,"26":"Um anjo do Senhor falou a Filipe e disse-lhe: «Prepara-te e dirige-te para o Sul, pelo caminho que desce de Jerusalém para Gaza; é o caminho que se acha no deserto». Filipe levantou-se e foi."
,"27":"Nisto apareceu um eunuco etíope, ministro de Candace, rainha da Etiópia, administrador geral do tesouro. Tinha ido a Jerusalém em peregrinação,"
,"28":"e regressava a casa. Ia sentado no seu carro, a ler o profeta Isaías."
,"29":"Então o Espírito disse a Filipe: «Aproxima-te desse carro e acompanha-o»."
,"30":"Filipe correu, ouviu o eunuco a ler o profeta Isaías e perguntou: «Entendes o que estás a ler?»"
,"31":"O eunuco respondeu: «Como posso entender, se ninguém me explica?» Então convidou Filipe a subir e a sentar-se junto dele."
,"32":"A passagem da Escritura que o eunuco estava a ler era esta: «Ele foi levado como ovelha ao matadouro. E como um cordeiro perante o seu tosquiador, Ele ficava mudo e não abria a boca."
,"33":"Eles humilharam-n'O e negaram-Lhe a justiça. Quem poderá contar a sua geração, pois O arrancaram da terra dos vivos?»"
,"34":"Então o eunuco disse a Filipe: «Por favor, explica-me: de quem fala o profeta? Fala de si mesmo ou refere-se a outra pessoa?»"
,"35":"Então Filipe foi explicando. E, tomando esta passagem da Escritura como ponto de partida, anunciou Jesus ao eunuco."
,"36":"Continuando o caminho, chegaram a um lugar onde havia água. Então o eunuco disse a Filipe: «Aqui há água. Que é que impede que eu seja baptizado?»"
,"37":"Filipe disse-lhe: «É possível, se acreditas com todo o coração». O eunuco respondeu: «Eu acredito que Jesus Cristo é o Filho de Deus!»"
,"38":"Então o eunuco mandou parar o carro. Ambos desceram à água e Filipe baptizou o eunuco."
,"39":"Quando saíram da água, o Espírito arrebatou Filipe, e o eunuco não o viu mais. Então prosseguiu a sua viagem, cheio de alegria."
,"40":"E Filipe foi parar a Azoto; e, partindo dali, evangelizava todas as cidades, até chegar a Cesareia."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Saulo só respirava ameaças e morte contra os discípulos do Senhor. Ele apresentou-se ao sumo sacerdote"
,"2":"e pediu-lhe cartas de recomendação para as sinagogas de Damasco, a fim de levar presos para Jerusalém todos os homens e mulheres que encontrasse a seguir o Caminho."
,"3":"Durante a viagem, quando já estava perto de Damasco, Saulo viu-se repentinamente cercado por uma luz que vinha do Céu."
,"4":"Caiu por terra e ouviu uma voz que lhe dizia: «Saulo, Saulo, porque Me persegues?»"
,"5":"Saulo perguntou: «Quem és Tu, Senhor?» A voz respondeu: «Eu sou Jesus, a quem tu persegues."
,"6":"Agora levanta-te, entra na cidade, e aí te dirão o que deves fazer»."
,"7":"Os homens que acompanhavam Saulo ficaram cheios de espanto, porque ouviam a voz, mas não viam ninguém."
,"8":"Saulo levantou-se do chão e abriu os olhos, mas não conseguia ver nada. Então levaram-no pela mão para Damasco."
,"9":"E Saulo ficou três dias sem poder ver, e não comeu nem bebeu nada."
,"10":"Em Damasco havia um discípulo chamado Ananias. O Senhor chamou-o numa visão: «Ananias!» E Ananias respondeu: «Aqui estou, Senhor!»"
,"11":"E o Senhor disse: «Prepara-te e vai até à rua que se chama rua Direita e procura, na casa de Judas, um homem chamado Saulo, apelidado Saulo de Tarso. Ele está a rezar"
,"12":"e acaba de ter uma visão». De facto, ele viu um homem chamado Ananias, entrar e impor-lhe as mãos para que recuperasse a vista. "
,"13":"Ananias respondeu: «Senhor, já ouvi muita gente falar desse homem e do mal que ele fez aos teus fiéis em Jerusalém."
,"14":"E aqui em Damasco ele tem plenos poderes, que recebeu dos sumos sacerdotes, para prender todos os que invocam o teu Nome»."
,"15":"Mas o Senhor disse a Ananias: «Vai, porque esse homem é um instrumento que escolhi para anunciar o meu Nome aos pagãos, aos reis e ao povo de Israel."
,"16":"Eu vou mostrar a Saulo quanto ele deve sofrer por causa do meu Nome»."
,"17":"Então Ananias saiu, entrou na casa e impôs as mãos sobre Saulo, dizendo: «Saulo, meu irmão, o Senhor Jesus, que te apareceu quando vinhas pelo caminho, mandou-me aqui para que recuperes a vista e fiques cheio do Espírito Santo»."
,"18":"Imediatamente caiu dos olhos de Saulo alguma coisa parecida com escamas, e ele recuperou a vista. Em seguida Saulo levantou-se e foi baptizado."
,"19":"Logo depois comeu e ficou forte como antes. Saulo passou então alguns dias com os discípulos em Damasco. "
,"20":"E logo começou a pregar nas sinagogas, afirmando que Jesus é o Filho de Deus."
,"21":"Os ouvintes ficavam impressionados e comentavam: «Não é este o homem que descarregava em Jerusalém a sua fúria contra os que invocam o Nome de Jesus? E não é ele que veio aqui expressamente para os prender e levar aos sumos sacerdotes?»"
,"22":"No entanto, Saulo fortalecia-se cada vez mais e deixava confusos os judeus que moravam em Damasco, demonstrando que Jesus é o Messias."
,"23":"Passado algum tempo, os judeus combinaram armar uma cilada para matar Saulo,"
,"24":"mas os seus planos chegaram ao conhecimento de Saulo. Os judeus montavam guarda dia e noite também junto às portas da cidade, a fim de o eliminarem."
,"25":"Os discípulos dele, porém, tomaram-no de noite e fizeram-no descer pela muralha, dentro de um cesto."
,"26":"Saulo chegou a Jerusalém e procurava juntar-se aos discípulos. Mas todos tinham medo dele, pois não acreditavam que ele fosse discípulo."
,"27":"Então Barnabé tomou Saulo consigo, apresentou-o aos Apóstolos, e contou-lhes como Saulo no caminho tinha visto o Senhor, como o Senhor lhe havia falado, e como ele havia pregado corajosamente em nome de Jesus na cidade de Damasco."
,"28":"Daí em diante Saulo ficou em Jerusalém com eles e pregava corajosamente em nome do Senhor."
,"29":"Saulo também falava e discutia com os judeus de língua grega, mas eles procuravam um modo de o matar."
,"30":"Quando souberam disto, os irmãos levaram Saulo para a cidade de Cesareia, e dali mandaram-no para a cidade de Tarso."
,"31":"E a Igreja vivia em paz em toda a Judeia, Galileia e Samaria. Ela edificava-se e progredia no temor do Senhor, e crescia em número com a ajuda do Espírito Santo."
,"32":"Pedro, que percorria todos os lugares, visitou também os fiéis que moravam em Lida."
,"33":"Aí encontrou um homem chamado Eneias, que estava paralítico e há oito anos jazia na cama."
,"34":"Pedro disse-lhe: «Eneias, Jesus Cristo vai curar-te! Levanta-te e arruma a tua cama!» Imediatamente Eneias levantou-se."
,"35":"Todos os habitantes de Lida e da região do Saron viram isto e converteram-se ao Senhor."
,"36":"Em Jope havia uma discípula chamada Tabita, nome que quer dizer Gazela. Ela praticava muitas obras boas e dava grandes esmolas."
,"37":"Nesses dias, ela ficou doente e morreu. Então lavaram-lhe o corpo e colocaram-no no andar superior da casa."
,"38":"Como Lida ficava perto de Jope, os discípulos, ouvindo dizer que Pedro estava lá, mandaram dois homens com um recado: «Vem sem demora ter connosco!»"
,"39":"Pedro partiu imediatamente com eles. Logo que chegou, os presentes levaram-no ao andar superior, onde as viúvas foram ao seu encontro. Chorando, todas mostravam a Pedro as túnicas e mantos que Tabita havia feito quando vivia com elas."
,"40":"Pedro mandou que todas saíssem; em seguida pôs-se de joelhos e rezou. Depois, voltou-se para o corpo e disse: «Tabita, levanta-te!» Ela então abriu os olhos, viu Pedro e sentou-se."
,"41":"Pedro deu-lhe a mão e ajudou-a a levantar-se. Depois chamou os fiéis e as viúvas, e apresentou-lhes Tabita viva."
,"42":"O facto ficou conhecido em toda a cidade de Jope, e muitos acreditaram no Senhor."
,"43":"Pedro ficou vários dias em Jope, hospedado na casa de um curtidor de peles chamado Simão."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Na cidade de Cesareia morava um homem chamado Cornélio, centurião da coorte Itálica."
,"2":"Era piedoso e, com todos os da sua família, pertencia ao grupo dos tementes a Deus; dava muitas esmolas ao povo e orava sempre a Deus."
,"3":"Certo dia, pelas três horas da tarde, Cornélio teve uma visão. Viu claramente que um anjo de Deus vinha ao seu encontro, chamando: «Cornélio!»"
,"4":"E Cornélio olhou para ele; e cheio de medo perguntou: «O que há, Senhor?» O anjo respondeu: «As orações e esmolas que fizeste foram aceites por Deus em teu favor."
,"5":"Agora, manda alguns homens a Jope para que tragam um certo Simão, também chamado Pedro."
,"6":"Ele está hospedado na casa de um curtidor chamado Simão, que vive perto do mar»."
,"7":"Quando o anjo que lhe falava desapareceu, Cornélio chamou dois empregados e um soldado piedoso que estava ao seu serviço."
,"8":"Explicou-lhes tudo e mandou-os a Jope."
,"9":"No dia seguinte, enquanto eles estavam a caminho e se aproximavam da cidade, ao meio-dia Pedro subiu ao terraço para rezar."
,"10":"Sentiu fome e quis comer; mas, enquanto preparavam a comida, Pedro entrou em êxtase."
,"11":"Viu o céu aberto e uma coisa que descia para a terra; parecia uma grande toalha sustentada pelas quatro pontas."
,"12":"Dentro dela havia toda a espécie de quadrúpedes, e também répteis da terra e aves do céu."
,"13":"E uma voz disse-lhe: «Levanta-te, Pedro, mata e come!»"
,"14":"Mas Pedro respondeu: «De modo nenhum, Senhor! Porque eu nunca comi coisa profana e impura!»"
,"15":"A voz disse-lhe pela segunda vez: «Não consideres impuro o que Deus purificou»."
,"16":"Isto repetiu-se por três vezes. Depois a coisa foi recolhida para o céu."
,"17":"Pedro ficou muito perplexo e perguntava a si mesmo o que podia significar a visão que acabava de ter. Nesse momento, os homens enviados por Cornélio perguntaram pela casa de Simão e apresentaram-se à porta."
,"18":"Chamaram e perguntaram se lá estava hospedado um certo Simão, chamado Pedro."
,"19":"E Pedro ainda estava pensando na visão, quando o Espírito lhe disse: «Estão ali três homens a procurar por ti."
,"20":"Levanta-te, desce e vai com eles sem hesitar, porque fui Eu que os mandei»."
,"21":"Pedro desceu ao encontro dos homens e disse: «Sou eu mesmo quem procurais. Qual é o motivo que vos traz aqui?»"
,"22":"Eles responderam: «O centurião Cornélio, homem justo e temente a Deus, estimado por todo o povo judeu, recebeu de um anjo a ordem de te convidar para ires a sua casa, a fim de ouvir o que tens para lhe dizer»."
,"23":"Pedro então fê-los entrar e deu-lhes hospedagem. No dia seguinte, Pedro partiu com eles, e alguns irmãos de Jope acompanharam-no. "
,"24":"E no outro dia chegou a Cesareia."
,"25":"Quando Pedro estava para entrar, Cornélio saiu-lhe ao encontro, caiu a seus pés e ajoelhou-se diante dele."
,"26":"Mas Pedro levantou-o, dizendo: «Levanta-te. Eu também sou apenas um homem»."
,"27":"Depois, continuando a conversar com Cornélio, entrou em casa. Encontrou muitas pessoas reunidas e disse:"
,"28":"«Sabeis que é proibido a um judeu relacionar-se com um estrangeiro ou entrar em sua casa. Deus, porém, mostrou-me que não se deve dizer que homem algum é profano ou impuro."
,"29":"Por isso, sem hesitar eu vim logo que me mandastes chamar. Agora pergunto: por qual motivo me fizestes vir?»"
,"30":"Cornélio então respondeu: «Há quatro dias, a esta mesma hora, eu estava em casa a recitar a oração das três horas da tarde, quando se apresentou diante de mim um homem com vestes resplandecentes"
,"31":"e me disse: «Cornélio, a tua oração foi ouvida e as tuas esmolas foram lembradas diante de Deus."
,"32":"Por isso, manda procurar em Jope um certo Simão, chamado Pedro. Ele está hospedado na casa do curtidor Simão, à beira-mar»."
,"33":"Imediatamente mandei chamar-te, e foi bom teres vindo. Agora, portanto, estamos todos aqui, na presença de Deus, prontos para ouvir o que o Senhor te encarregou de nos dizeres»."
,"34":"Pedro então começou a dizer: «De facto, agora compreendo que Deus não faz diferença entre as pessoas."
,"35":"Pelo contrário, Ele aceita quem O teme e pratica a justiça, seja qual for a nação a que pertença."
,"36":"Deus enviou a sua palavra aos israelitas e anunciou-lhes a Boa Notícia da paz por meio de Jesus Cristo, que é o Senhor de todos."
,"37":"Vós sabeis o que aconteceu em toda a Judeia, a começar pela Galileia, depois do baptismo pregado por João."
,"38":"Refiro-me a Jesus de Nazaré: Deus ungiu-O com o Espírito Santo e com poder. E Jesus andou por toda a parte, fazendo o bem e curando todos os que estavam dominados pelo diabo; porque Deus estava com Jesus."
,"39":"E nós somos testemunhas de tudo o que Jesus fez na terra dos judeus e em Jerusalém. Eles mataram Jesus, suspendendo-O numa cruz."
,"40":"Deus, porém, ressuscitou-O ao terceiro dia e concedeu-Lhe manifestar a sua presença,"
,"41":"não a todo o povo, mas às testemunhas que Deus já havia escolhido: a nós, que comemos e bebemos com Jesus, depois que Ele ressuscitou dos mortos."
,"42":"E Jesus mandou-nos pregar ao povo e testemunhar que Deus O constituiu Juiz dos vivos e dos mortos."
,"43":"Sobre Ele todos os profetas dão o seguinte testemunho: todo aquele que acredita em Jesus recebe, em seu Nome, o perdão dos pecados»."
,"44":"Pedro ainda estava a falar, quando o Espírito Santo desceu sobre todos os que ouviam a Palavra."
,"45":"Os fiéis de origem judaica, que tinham ido com Pedro, ficaram admirados por o dom do Espírito Santo também ser derramado sobre os pagãos."
,"46":"De facto, eles ouviam-nos falar em línguas estranhas e louvar a grandeza de Deus. Então Pedro disse:"
,"47":"«Será que podemos negar a água do baptismo a estas pessoas que receberam o Espírito Santo, da mesma forma que nós recebemos?»"
,"48":"Então Pedro mandou que fossem baptizados em nome de Jesus Cristo. Depois pediram a Pedro que ficasse alguns dias com eles."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Os Apóstolos e os irmãos que viviam na Judeia souberam que também os pagãos haviam acolhido a Palavra de Deus."
,"2":"Quando Pedro subiu a Jerusalém, os fiéis de origem judaica começaram a discutir com ele, dizendo:"
,"3":"«Tu entraste em casa de incircuncisos e comeste com eles!»"
,"4":"Então Pedro começou a relatar-lhes, passo a passo, o que havia acontecido:"
,"5":"«Eu estava na cidade de Jope e, ao fazer oração, entrei em êxtase e tive a seguinte visão: vi uma coisa parecida com uma grande toalha que, sustentada pelas quatro pontas, descia do céu e chegava até mim."
,"6":"Olhei atentamente e vi dentro dela quadrúpedes, animais selvagens, répteis da terra e aves do céu."
,"7":"Depois ouvi uma voz que me dizia: 'Levanta-te, Pedro, mata e come'."
,"8":"Eu respondi: 'De modo nenhum, Senhor! Porque jamais coisa profana e impura entrou na minha boca'."
,"9":"A voz disse-me pela segunda vez: 'Não chames impuro ao que Deus purificou'."
,"10":"Isto repetiu-se por três vezes. Depois a coisa foi novamente levantada para o céu."
,"11":"Nesse momento, três homens apresentaram-se na casa em que nos encontrávamos. Tinham sido enviados de Cesareia, à minha procura."
,"12":"O Espírito disse-me que fosse com eles sem hesitar. Os seis irmãos que estão aqui acompanharam-me, e entrámos na casa daquele homem."
,"13":"Ele contou-nos que tinha visto um anjo apresentar-se em sua casa e dizer: 'Manda alguém a Jope para fazer com que Simão, também chamado Pedro, venha até aqui."
,"14":"Ele fará uma apresentação dos acontecimentos que vão trazer a salvação a ti e a toda a tua família'."
,"15":"Logo que comecei a falar, o Espírito Santo desceu sobre eles, da mesma forma que desceu sobre nós no princípio."
,"16":"Então lembrei-me do que o Senhor havia dito: 'João baptizou com água, mas vós sereis baptizados no Espírito Santo'."
,"17":"Deus concedeu-lhes o mesmo dom que nos deu a nós por termos acreditado no Senhor Jesus Cristo. Quem seria eu para me opor à acção de Deus?»"
,"18":"Ao ouvirem isto, os fiéis de origem judaica acalmaram-se e glorificaram a Deus, dizendo: «Também aos pagãos Deus concedeu a conversão que leva à vida!»"
,"19":"Aqueles que se haviam espalhado por causa da tribulação que se seguiu à morte de Estêvão, chegaram à Fenícia, à ilha de Chipre e à cidade de Antioquia, embora não pregassem a Palavra a ninguém que não fosse judeu."
,"20":"Contudo, alguns deles, habitantes de Chipre e da cidade de Cirene, chegaram a Antioquia e começaram a pregar tam-bém aos gregos, anunciando-lhes a Boa Notícia do Senhor Jesus."
,"21":"A mão do Senhor estava com eles, de modo que foi grande o número dos que acredita-ram e se converteram ao Senhor."
,"22":"A notícia chegou aos ouvidos da Igreja de Jerusalém, e esta enviou Barnabé a Antioquia."
,"23":"Quando Barnabé chegou e viu a graça de Deus, ficou muito contente e animou-os a permanecerem de todo o coração ligados ao Senhor."
,"24":"Barnabé era homem bom, cheio do Espírito Santo e de fé. E uma considerável multidão uniu-se ao Senhor."
,"25":"Barnabé foi, então, para Tarso em busca de Saulo."
,"26":"Encontrou-o e levou-o para Antioquia. Passaram um ano inteiro a trabalhar juntos nessa Igreja, e instruíram muita gente. Foi em Antioquia que os discípulos receberam, pela primeira vez, o nome de «cristãos»."
,"27":"Nesses dias, alguns profetas desceram de Jerusalém para Antioquia."
,"28":"Um deles, chamado Ágabo, iluminado pelo Espírito, anunciou que uma grande fome viria sobre a Terra. De facto, essa fome sobreveio no tempo do imperador Cláudio."
,"29":"Os discípulos decidiram, então, mandar uma ajuda, cada qual segundo as suas possibilidades, aos irmãos que viviam na Judeia."
,"30":"Assim o fizeram. E enviaram a ajuda aos anciãos por meio de Saulo e Barnabé."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Nesse tempo, o rei Herodes começou a perseguir alguns membros da Igreja,"
,"2":"e mandou matar à espada Tiago, irmão de João."
,"3":"Vendo que isso agradava aos judeus, decidiu prender também Pedro. Eram os dias da festa dos pães sem fermento."
,"4":"Depois de o prender, meteu-o na prisão e confiou-o à guarda de quatro grupos de quatro soldados cada um. Herodes tinha a intenção de apresentar Pedro ao povo a seguir à Páscoa."
,"5":"Pedro estava vigiado na prisão, mas a oração fervorosa da Igreja subia continuamente até Deus, intercedendo em favor dele."
,"6":"Herodes estava para apresentar Pedro. Nessa mesma noite, Pedro dormia entre dois soldados. Estava preso com duas correntes, e os guardas vigiavam a porta da prisão."
,"7":"De repente, apareceu o anjo do Senhor, e a cela ficou toda iluminada. O anjo tocou no ombro de Pedro, acordou-o, e disse-lhe: «Levanta-te depressa». As correntes caíram das mãos de Pedro."
,"8":"E o anjo continuou: «Aperta o cinto e calça as sandálias». Pedro obedeceu, e o anjo disse-lhe: «Embrulha-te na capa e vem comigo»."
,"9":"Pedro acompanhou o anjo, sem saber se era mesmo realidade o que o anjo fazia, pois achava que tudo aquilo era uma visão."
,"10":"Depois de passarem pela primeira e segunda guarda, chegaram ao portão de ferro que dava para a cidade. O portão abriu-se sozinho. Eles saíram, entraram numa rua, e logo depois o anjo deixou-o."
,"11":"Então Pedro caiu em si e disse: «Agora sei que o Senhor de facto enviou o seu anjo para me libertar do poder de Herodes e de tudo o que o povo judeu queria fazer-me»."
,"12":"Pedro então reflectiu e foi para casa de Maria, mãe de João, também chamado Marcos, onde muitos se haviam reunido para rezar."
,"13":"Bateu à porta, e uma empregada, chamada Rosa, foi abrir."
,"14":"A empregada reconheceu a voz de Pedro, mas a sua alegria foi tanta que, em vez de abrir a porta, correu a anunciar que Pedro estava ali, junto à porta."
,"15":"Os presentes disseram: «Estás louca!» Mas ela insistia. Eles disseram: «Então deve ser o seu anjo!»"
,"16":"Pedro, entretanto, continuava a bater. Por fim, eles abriram a porta: era realmente Pedro. Eles ficaram sem palavras."
,"17":"Com a mão Pedro fez sinal para se calarem. Contou-lhes como o Senhor o fizera sair da prisão. E acrescentou: «Contai isto a Tiago e aos irmãos». Depois, Pedro saiu e pôs-se a caminho para outro lugar."
,"18":"Ao amanhecer, houve grande confusão entre os soldados: o que teria acontecido a Pedro?"
,"19":"Herodes mandou procurá-lo. Como não o encontrassem, procedeu ao interrogatório dos guardas e deu ordens para que fossem executados. Depois desceu da Judeia para a Cesareia, onde permaneceu algum tempo."
,"20":"Herodes estava enfurecido com os habitantes de Tiro e Sidónia. Estes fizeram um acordo entre si e apresentaram-se diante de Herodes, depois de conquistarem as graças de Blasto, o camareiro real. Eles pediam a paz, já que o seu país recebia mantimentos do território do rei."
,"21":"No dia marcado, Herodes vestiu-se com os trajes reais, sentou-se na tribuna e dirigiu-lhes a palavra oficial."
,"22":"O povo começou a clamar: «É a voz de um deus e não de um homem!»"
,"23":"Mas, imediatamente, o anjo do Senhor feriu Herodes, porque ele não tinha dado glória a Deus. E Herodes expirou, roído pelos vermes."
,"24":"A Palavra de Deus, entretanto, crescia e multiplicava-se."
,"25":"Barnabé e Saulo terminaram o seu serviço em favor de Jerusalém, e voltaram, levando consigo João, também chamado Marcos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Havia profetas e mestres na Igreja de Antioquia. Eram eles: Barnabé, Simeão, chamado o Negro, Lúcio, da cidade de Cirene, Manaém, companheiro de infância do governador Herodes, e Saulo."
,"2":"Certo dia, enquanto faziam uma reunião litúrgica com jejum, o Espírito Santo disse: «Separai para Mim Barnabé e Saulo a fim de fazerem o trabalho a que Eu os chamei»."
,"3":"Então eles jejuaram e rezaram; depois impuseram as mãos sobre Barnabé e Saulo e despediram-se deles."
,"4":"Enviados pelo Espírito Santo, Barnabé e Saulo desceram a Selêucia e dali navegaram para Chipre."
,"5":"Quando chegaram a Salamina, começaram a anunciar a Palavra de Deus nas sinagogas dos judeus, tendo João como ajudante."
,"6":"Atravessaram toda a ilha até Pafos e encontraram lá um judeu, mago e falso profeta, que se chamava Bar-Jesus."
,"7":"Este encontrava-se na casa do procônsul Sérgio Paulo, homem ponderado, que mandou chamar Barnabé e Saulo, pois desejava escutar a Palavra de Deus."
,"8":"Porém, o mago Elimas - assim se traduz o seu nome - opôs-se, procurando afastar da fé o procônsul."
,"9":"Então Saulo, também chamado Paulo, cheio de Espírito Santo, fixou os olhos em Elimas,"
,"10":"e disse: «Filho do diabo, cheio de falsidade e malícia, inimigo de toda a justiça, quando é que deixarás de perverter os rectos caminhos do Senhor?"
,"11":"Eis que a mão do Senhor vai cair agora sobre ti. Ficarás cego e, por algum tempo, não verás o sol». No mesmo instante escuridão e trevas envolveram Elimas, e começou a andar às cegas, procurando alguém que lhe desse a mão."
,"12":"Ao ver o que acontecera, o procônsul abraçou a fé, pois ficara impressionado com a doutrina do Senhor."
,"13":"Paulo e seus companheiros embarcaram em Pafos e chegaram a Perge da Panfília. João, porém, separou-se do grupo e voltou para Jerusalém."
,"14":"Barnabé e Paulo partiram de Perge e chegaram a Antioquia da Pisídia. No sábado, entraram na sinagoga e sentaram-se."
,"15":"Depois da leitura da Lei e dos Profetas, os chefes da sinagoga mandaram dizer-lhes: «Irmãos, se tendes alguma palavra de encorajamento para o povo, podeis falar»."
,"16":"Paulo então levantou-se, fez sinal com a mão e disse: «Homens de Israel, e vós que temeis a Deus, escutai!"
,"17":"O Deus deste povo, o Deus de Israel, escolheu os nossos antepassados e multiplicou o povo durante o exílio na terra do Egipto. Depois, tirou-os de lá, com braço poderoso."
,"18":"E, durante mais ou menos quarenta anos, cercou-os de cuidados no deserto."
,"19":"Destruiu sete nações na terra de Canaã e deu-lhes a posse do seu território,"
,"20":"por cerca de quatrocentos e cinquenta anos. Depois disso concedeu-lhes juízes, até ao profeta Samuel."
,"21":"Em seguida, pediram um rei e Deus concedeu-lhes Saul, filho de Cis, da tribo de Benjamim, que reinou durante quarenta anos."
,"22":"Após depor Saul da realeza, Deus suscitou o rei David, do qual prestou o seguinte testemunho: 'Encontrei David, filho de Jessé, homem segundo o meu coração; ele cumprirá todas as minhas vontades'."
,"23":"Conforme havia prometido, Deus fez surgir da descendência de David um Salvador para Israel, que é Jesus."
,"24":"E João, o precursor, havia preparado a chegada de Jesus, pregando a todo o povo de Israel um baptismo de arrependimento."
,"25":"Estando para terminar a sua missão, João declarou: 'Não sou aquele que vós pensais! Depois de mim é que vem Aquele do qual não mereço nem sequer desatar as sandálias!'"
,"26":"Irmãos, descendentes de Abraão e não-judeus que adorais a Deus, esta mensagem de salvação foi-nos enviada a nós."
,"27":"Porque os habitantes de Jerusalém e os seus chefes não reconheceram Jesus e, ao condená-l'O, cumpriram as profecias que são lidas aos sábados."
,"28":"Embora não encontrassem nenhum motivo para condenar Jesus à morte, pediram a Pilatos que O mandasse matar."
,"29":"Depois de fazerem tudo o que a Escritura diz a respeito de Jesus, tiraram-n'O da cruz e puseram-n'O num túmulo."
,"30":"Mas Deus ressuscitou-O dos mortos,"
,"31":"e durante muitos dias Ele apareceu àqueles que O acompanharam da Galileia para Jerusalém. Agora eles são testemunhas de Jesus diante do povo."
,"32":"Nós anunciamo-vos este Evangelho: a promessa que Deus fez aos antepassados,"
,"33":"cumpriu-a plenamente para nós, seus filhos, quando ressuscitou Jesus, como está escrito no segundo Salmo: 'Tu és meu Filho, Eu hoje Te gerei'."
,"34":"Deus ressuscitou Jesus dos mortos, para que nunca voltasse à corrupção. Ele disse-o desta maneira: 'Cumprirei para vós a promessa fiel que fiz a David'."
,"35":"Por isso diz também em outro lugar: 'Não permitirás que o teu fiel conheça a corrupção'."
,"36":"Ora, tendo cumprido a missão que Deus lhe dera para a sua época, David morreu, foi para junto de seus pais e conheceu a corrupção."
,"37":"Mas Aquele que Deus ressuscitou não conheceu a corrupção."
,"38":"Portanto, ficai sabendo, irmãos, que por meio d'Ele é anunciado o perdão dos pecados."
,"39":"E, por meio d'Ele, todo aquele que acredita é justificado de todas as coisas de que não pudestes ser justificados pela Lei de Moisés."
,"40":"Portanto, tende cuidado para que vos não aconteça o que os profetas disseram:"
,"41":"'Olhai, desprezadores, admirai-vos e desaparecei! Porque nos nossos dias vou realizar uma coisa que não acreditaríeis se vos fosse contada'!»"
,"42":"Ao saírem, Paulo e Barnabé foram convidados a continuar a falar sobre o mesmo assunto no sábado seguinte."
,"43":"Depois da reunião, muitos judeus e outras pessoas convertidas ao judaísmo seguiram Paulo e Barnabé. Os dois conversavam com essas pessoas e insistiam para que continuassem fiéis à graça de Deus."
,"44":"No sábado seguinte, quase toda a cidade se reuniu para ouvir a Palavra de Deus."
,"45":"Quando os judeus viram aquela multidão, ficaram cheios de inveja, e com blasfémias opunham-se ao que Paulo dizia."
,"46":"Então, com mais coragem ainda, Paulo e Barnabé declararam: «Era preciso anunciar a Palavra de Deus, em primeiro lugar a vós, judeus. Porém, visto que a rejeitais e não vos julgais dignos da vida eterna, vamos dedicar-nos aos pagãos."
,"47":"Porque é esta a ordem que o Senhor nos deu: 'Eu coloquei-te como luz para as nações, para que leves a salvação até aos extremos da Terra'»."
,"48":"Os pagãos ficaram muito contentes ao ouvirem isto, e começaram a elogiar a Palavra do Senhor. E todos os que estavam destinados à vida eterna abraçaram a fé."
,"49":"Deste modo, a Palavra do Senhor espalhava-se por toda a região."
,"50":"No entanto, os judeus instigaram algumas senhoras ricas e piedosas, e também os mais importantes da cidade; provocaram uma perseguição contra Paulo e Barnabé e expulsaram-nos do seu território."
,"51":"Então os Apóstolos sacudiram contra eles a poeira dos pés e foram para a cidade de Icónio."
,"52":"Os discípulos, porém, estavam cheios de alegria e do Espírito Santo."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Em Icónio, Paulo e Barnabé entraram também na sinagoga dos judeus e falaram de tal modo que uma grande multidão de judeus e gregos abraçou a fé."
,"2":"Contudo, os judeus que se negaram a acreditar incitaram os pagãos e indispuseram-nos contra os irmãos."
,"3":"Apesar disso, Paulo e Barnabé permaneceram longo tempo em Icónio. Estavam cheios de coragem no Senhor, que através deles operava sinais e prodígios, e confirmava assim a pregação com a sua graça."
,"4":"A população da cidade dividiu-se. Uns estavam do lado dos judeus, outros do lado dos Apóstolos."
,"5":"Pagãos e judeus, com os seus chefes à frente, estavam dispostos a ultrajá-los e apedrejá-los."
,"6":"Ao saberem disso, Paulo e Barnabé fugiram para Listra e Derbe, cidades da Licaónia, e arredores,"
,"7":"onde começaram a anunciar a Boa Notícia."
,"8":"Em Listra havia um homem paralítico das pernas; era coxo de nascença e nunca tinha conseguido andar."
,"9":"Ele escutava o discurso de Paulo. Este, fixando nele o olhar e notando que tinha fé para ser curado,"
,"10":"disse-lhe em voz alta: «Levanta-te direito sobre os teus pés». O homem deu um salto e começou a andar."
,"11":"Vendo o que Paulo acabara de fazer, a multidão exclamou em dialecto licaónico: «Os deuses desceram até nós em forma humana!»"
,"12":"Chamavam Júpiter a Barnabé e Mercúrio a Paulo, porque era Paulo quem falava."
,"13":"Os sacerdotes de Júpiter, cujo templo ficava à entrada da cidade, levaram para a porta touros ornados de grinaldas e queriam oferecer um sacrifício; com isso concordava toda a multidão."
,"14":"Ao saberem disso, os Apóstolos Barnabé e Paulo rasgaram as vestes e foram para o meio da multidão, gritando:"
,"15":"«Homens, que fazeis? Nós também somos homens mortais como vós. Anunciamo-vos que precisais de deixar estes ídolos vazios e converter-vos ao Deus vivo, que fez o Céu, a Terra, o mar e tudo o que neles existe."
,"16":"Nas gerações passadas, Deus permitiu que todas as nações seguissem o próprio caminho."
,"17":"No entanto, Ele não deixou de dar testemunho de Si mesmo através dos seus benefícios. Do céu Ele manda chuvas e colheitas, dando alimento e alegrando o vosso coração»."
,"18":"E falando assim, a muito custo conseguiram que a multidão desistisse de lhes oferecer um sacrifício."
,"19":"De Antioquia e Icónio chegaram judeus que convenceram as multidões. Então, apedrejaram Paulo e arrastaram-no para fora da cidade, pensando que ele estivesse morto."
,"20":"Mas, enquanto os discípulos o rodeavam, Paulo levantou-se e entrou na cidade. No dia seguinte, partiu para Derbe com Barnabé."
,"21":"Depois de anunciar o Evangelho nessa cidade e ganhar aí numerosos discípulos, Paulo e Barnabé voltaram para Listra, Icónio e Antioquia."
,"22":"Eles fortaleciam o ânimo dos discípulos, exortando-os a perseverarem na fé e dizendo-lhes que é preciso passar por muitas tribulações para entrar no Reino de Deus."
,"23":"Os Apóstolos designaram anciãos para cada comunidade; rezavam, jejuavam e confiavam-nos ao Senhor, no qual haviam acreditado."
,"24":"Depois, Paulo e Barnabé atravessaram a região da Pisídia e chegaram à região da Panfília."
,"25":"Anunciaram a Palavra em Perge e depois desceram para o porto de Atália."
,"26":"Daí embarcaram para Antioquia da Síria, seu ponto de partida, onde tinham sido entregues à graça de Deus para o trabalho que acabavam de realizar."
,"27":"Quando chegaram a Antioquia, reuniram a comunidade e contaram tudo o que Deus havia feito por meio deles: o modo como Deus tinha aberto a porta da fé aos pagãos."
,"28":"E passaram então algum tempo com os discípulos."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Chegaram alguns homens da Judeia que doutrinavam os irmãos de Antioquia, dizendo: «Se não fordes circuncidados, como ordena a Lei de Moisés, não vos podereis salvar»."
,"2":"Isso provocou alvoroço e uma discussão muito séria deles com Paulo e Barnabé. Então ficou decidido que Paulo, Barnabé e mais alguns iriam a Jerusalém para tratar desta questão com os Apóstolos e anciãos."
,"3":"Com o apoio e solidariedade da Igreja de Antioquia, eles atravessaram a Fenícia e a Samaria. Contaram a conversão dos pagãos e deram uma grande alegria a todos os irmãos."
,"4":"Quando chegaram a Jerusalém, foram acolhidos pela Igreja, pelos Apóstolos e anciãos, e contaram as maravilhas que Deus tinha realizado por meio deles."
,"5":"Alguns daqueles que tinham pertencido ao partido dos fariseus e que haviam abraçado a fé intervieram, declarando que era preciso circuncidar os pagãos e mandar que observassem a Lei de Moisés."
,"6":"Então os Apóstolos e os anciãos reuniram-se para tratar desse assunto."
,"7":"Depois de longa discussão, Pedro levantou-se e disse: «Irmãos, sabeis que, desde os primeiros dias, Deus me escolheu entre vós, para que os pagãos ouvissem da minha boca a palavra da Boa Notícia e acreditassem."
,"8":"Ora, Deus, que conhece os corações, testemunhou a favor deles, dando-lhes o Espírito Santo como a nós."
,"9":"E não fez nenhuma distinção entre nós e eles, purificando-lhes o coração mediante a fé."
,"10":"Então, porque tentais agora a Deus, querendo impor aos discípulos um jugo que nem os nossos pais nem nós mesmos tivemos força para suportar?"
,"11":"Ao contrário, é pela graça do Senhor Jesus que acreditamos ser salvos, exactamente como eles»."
,"12":"Houve então um silêncio em toda a assembleia. Depois ouviram Barnabé e Paulo contar todos os sinais e prodígios que Deus havia realizado por meio deles entre os pagãos."
,"13":"Quando Barnabé e Paulo acabaram de falar, Tiago tomou a palavra e disse: «Irmãos, ouvi-me:"
,"14":"Simão acaba de nos lembrar como, desde o começo, Deus tomou homens das nações pagãs para formar um povo dedicado ao seu Nome."
,"15":"Isto concorda com as palavras dos profetas, pois está escrito:"
,"16":"'Depois disto, Eu voltarei e reconstruirei a tenda de David que havia caído; reconstruirei as ruínas que ficaram e reerguê-la-ei,"
,"17":"a fim de que o resto dos homens procure o Senhor com todas as nações que foram consagradas ao meu Nome. É o que diz o Senhor,"
,"18":"que tornou estas coisas conhecidas desde há séculos'."
,"19":"Por isso, eu sou do parecer que não devemos importunar os pagãos que se convertem a Deus."
,"20":"Vamos somente prescrever que evitem o que está contaminado pelos ídolos, as uniões ilegítimas, comer carne sufocada e o sangue."
,"21":"De facto, desde os tempos antigos, em cada cidade Moisés tem os seus pregadores, que o lêem todos os sábados nas sinagogas»."
,"22":"Então os Apóstolos e os anciãos, de acordo com toda a comunidade de Jerusalém, resolveram escolher alguns da comunidade para os enviar com Paulo e Barnabé a Antioquia. Escolheram Judas, chamado Bársabas, e Silas, que eram muito respeitados pelos irmãos."
,"23":"Através deles enviaram a seguinte carta: «Nós, os Apóstolos e os anciãos, vossos irmãos, saudamos os irmãos que vêm do paganismo e que estão em Antioquia e nas regiões da Síria e da Cilícia."
,"24":"Tivemos conhecimento de que alguns dos nossos provocaram perturbações com palavras que transtornaram o vosso espírito. Eles não foram enviados por nós."
,"25":"Então decidimos, de comum acordo, escolher alguns representantes e mandá-los até vós, com os nossos queridos irmãos Barnabé e Paulo,"
,"26":"homens que arriscaram a vida pelo Nome de nosso Senhor Jesus Cristo."
,"27":"Por isso, enviamos Judas e Silas, que pessoalmente vos transmitirão a mesma mensagem."
,"28":"Porque decidimos, o Espírito Santo e nós, não vos impor nenhum fardo, além destas coisas indispensáveis:"
,"29":"abster-se de carnes sacrificadas aos ídolos, do sangue, das carnes sufocadas e das uniões ilegítimas. Fareis bem se evitardes estas coisas. Saudações!»"
,"30":"Depois da despedida, Judas e Silas foram a Antioquia, reuniram a assembleia e entregaram a carta."
,"31":"A sua leitura causou alegria por causa do estímulo que continha."
,"32":"Judas e Silas, que também eram profetas, encorajaram e fortificaram os irmãos."
,"33":"Depois de algum tempo, foram despedidos em paz pelos irmãos e voltaram para aqueles que os tinham enviado. /"
,"34":"/."
,"35":"Quanto a Paulo e Barnabé, permaneceram em Antioquia. E com muitos outros ensinavam e anunciavam a Boa Notícia da Palavra do Senhor."
,"36":"Depois de alguns dias, Paulo disse a Barnabé: «Vamos voltar para fazer uma visita a todas as cidades onde anunciámos a Palavra do Senhor, para ver como estão»."
,"37":"Barnabé queria levar também João, chamado Marcos."
,"38":"Paulo, porém, era de opinião que não deviam levar consigo uma pessoa que se havia separado deles na Panfília e não os acompanhara no trabalho."
,"39":"Houve desacordo entre eles, a tal ponto que tiveram de separar-se um do outro. Barnabé levou Marcos consigo e embarcou para Chipre."
,"40":"Paulo, por sua vez, escolheu Silas, e partiu, recomendado pelos irmãos à graça do Senhor."
,"41":"Atravessaram então a Síria e a Cilícia, dando nova força às Igrejas."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Paulo dirigiu-se a Derbe e a Listra. Havia em Listra um discípulo chamado Timóteo, filho de uma judia que se tornara cristã e de pai grego."
,"2":"Os irmãos de Listra e Icónio davam bom testemunho de Timóteo."
,"3":"Paulo quis então que Timóteo partisse com ele. Tomou-o e circuncidou-o, por causa dos judeus que se encontravam nessas regiões, pois todos sabiam que o pai de Timóteo era grego."
,"4":"Percorrendo as cidades, Paulo e Timóteo transmitiam as decisões que os Apóstolos e anciãos de Jerusalém haviam tomado, e recomendavam que fossem observadas."
,"5":"As Igrejas fortaleciam-se na fé, e de dia para dia cresciam em número."
,"6":"Paulo e Timóteo atravessaram a Frígia e a região da Galácia, uma vez que o Espírito Santo os proibira de pregar a Palavra de Deus na Ásia."
,"7":"Chegando perto da Mísia, tentaram entrar na Bitínia, mas o Espírito de Jesus impediu-os."
,"8":"Então atravessaram a Mísia e desceram para Tróade."
,"9":"Durante a noite, Paulo teve uma visão: na sua frente estava de pé um macedónio que lhe suplicava: «Vem à Macedónia e ajuda-nos!»"
,"10":"Depois desta visão, procurámos imediatamente partir para a Macedónia, pois estávamos convencidos de que Deus acabava de nos chamar para aí anunciar a Boa Notícia."
,"11":"Embarcámos em Tróade e navegámos directamente para a ilha de Samotrácia. No dia seguinte, ancorámos em Neápolis,"
,"12":"de onde passámos para Filipos, que é uma das principais cidades da Macedónia e que tem direitos de colónia romana. Passámos alguns dias nesta cidade."
,"13":"No sábado, saímos além da porta da cidade para um lugar junto ao rio, onde nos parecia haver oração. Sentámo-nos e começámos a falar com as mulheres que lá estavam reunidas."
,"14":"Uma delas chamava-se Lídia; era comerciante de púrpura, da cidade de Tiatira. Lídia acreditava em Deus e escutava com atenção. O Senhor abrira o seu coração para que aderisse às palavras de Paulo."
,"15":"Após ter sido baptizada, assim como toda a sua família, ela convidou-nos: «Se me considerais fiel ao Senhor, permanecei em minha casa». E forçou-nos a aceitar."
,"16":"Um dia, quando íamos para a oração, veio ao nosso encontro uma jovem escrava, que estava possuída por um espírito de adivinhação; fazia oráculos e dava muito lucro aos seus patrões."
,"17":"Começou a seguir Paulo e a nós, gritando: «Estes homens são servos do Deus Altíssimo e anunciam-vos o caminho da salvação»."
,"18":"Isto aconteceu durante muitos dias. Por fim, não suportando mais a situação, Paulo voltou-se e disse ao espírito: «Eu te ordeno em Nome de Jesus Cristo: sai desta mulher!» E o espírito saiu imediatamente."
,"19":"Os patrões da jovem, vendo que tinham perdido a esperança de lucros, agarraram Paulo e Silas e arrastaram-nos até à praça principal, diante dos chefes da cidade."
,"20":"Apresentaram-nos aos magistrados e disseram: «Estes homens provocam a desordem na nossa cidade; são judeus"
,"21":"e pregam costumes que a nós, romanos, não é permitido aceitar nem seguir»."
,"22":"A multidão amotinou-se contra Paulo e Silas. Os magistrados arrancaram-lhes as vestes e mandaram-nos açoitar com varas."
,"23":"Depois de os açoitar bastante, lançaram-nos na prisão, ordenando ao carcereiro que os guardasse com toda a segurança."
,"24":"Ao receber esta ordem, o carcereiro levou-os para o fundo da prisão e prendeu-lhes os pés no tronco."
,"25":"À meia noite, Paulo e Silas rezavam e cantavam hinos a Deus; os outros companheiros de prisão escutavam."
,"26":"De repente, houve um terremoto tão violento que sacudiu os alicerces da prisão. Todas as portas se abriram e as correntes de todos desprenderam-se."
,"27":"O carcereiro acordou e viu as portas da prisão abertas. Pensando que os prisioneiros tivessem fugido, puxou da espada e estava para se suicidar."
,"28":"Mas Paulo gritou: «Não faças isso! Nós estamos todos aqui»."
,"29":"Então o carcereiro pediu tochas, correu para dentro e, a tremer, lançou-se aos pés de Paulo e Silas."
,"30":"Conduzindo-os para fora, perguntou: «Senhores, que devo fazer para ser salvo?»"
,"31":"Paulo e Silas responderam: «Acredita no Senhor Jesus, e serás salvo tu e todos os da tua casa»."
,"32":"Então Paulo e Silas anunciaram a Palavra do Senhor ao carcereiro e a todos os da sua casa."
,"33":"Naquela hora da noite, o carcereiro levou-os consigo para lavar as feridas causadas pelos açoites. A seguir, foi baptizado com todos os seus."
,"34":"Depois, fez Paulo e Silas subir para a sua casa, preparou-lhes um jantar e alegrou-se com todos os seus familiares por ter acreditado em Deus."
,"35":"Quando amanheceu, os magistrados enviaram à prisão os oficiais de justiça, ordenando ao carcereiro: «Solta esses homens»."
,"36":"O carcereiro anunciou a Paulo: «Os magistrados mandaram soltar-vos. Portanto, podeis sair e ir embora em paz»."
,"37":"Mas Paulo mandou dizer: «Fomos açoitados em público sem nenhum processo e fomos lançados na prisão sem terem em conta que somos cidadãos romanos; e agora querem que nos vamos embora às escondidas? De modo nenhum! Que venham soltar-nos pessoalmente»."
,"38":"Os oficiais de justiça comunicaram as palavras de Paulo aos magistrados. Ao saberem que se tratava de cidadãos romanos, ficaram alarmados,"
,"39":"e foram conversar com eles. E soltaram-nos, pedindo que deixassem a cidade."
,"40":"Ao sair da prisão, Paulo e Silas foram a casa de Lídia. Lá encontraram os irmãos, encorajaram-nos e depois partiram."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Passando por Anfípolis e Apolónia, Paulo e Silas chegaram a Tessalónica, onde os judeus tinham uma sinagoga."
,"2":"Conforme o seu costume, Paulo foi procurá-los e, durante três sábados seguidos, discutiu com eles. Partindo das Escrituras,"
,"3":"explicava e demonstrava-lhes que o Messias devia morrer e ressuscitar dos mortos. E acrescentava: «O Messias é este Jesus que eu vos anuncio»."
,"4":"Alguns judeus convenceram-se disso e uniram-se a Paulo e Silas, assim como um grande número de gregos que adoravam o Deus único, e muitas mulheres da alta sociedade."
,"5":"Os judeus ficaram com inveja e reuniram alguns indivíduos maus e vagabundos; e provocaram um tumulto, alvoroçando a cidade. Alguns apresentaram-se em casa de Jasão à procura de Paulo e Silas, a fim de os levarem à presença da assembleia do povo."
,"6":"Não encontrando Paulo e Silas, arrastaram Jasão e alguns irmãos diante das autoridades; e gritavam: «Estes homens que estão a transtornar o mundo inteiro, chegaram agora aqui também,"
,"7":"e Jasão deu-lhes hospedagem. Todos eles vão contra a lei do Imperador, afirmando que existe outro rei chamado Jesus»."
,"8":"Ouvindo isto, a multidão e as autoridades ficaram agitadas."
,"9":"Exigiram uma caução por parte de Jasão e dos outros irmãos. Depois soltaram-nos."
,"10":"Imediatamente, os irmãos fizeram partir Paulo e Silas de noite para Bereia. Logo que lá chegaram, entraram na sinagoga dos judeus."
,"11":"Estes eram mais abertos que os de Tessalónica e acolheram a Palavra com toda a disponibilidade. Todos os dias examinavam as Escrituras para verificarem se tudo era de facto assim."
,"12":"Muitos deles abraçaram a fé e também um número considerável de gregos, tanto mulheres de condição elevada como muitos homens."
,"13":"Mas, quando os judeus de Tessalónica souberam que Paulo anunciava a Palavra de Deus também em Bereia, foram lá para agitar e confundir o povo."
,"14":"Imediatamente os irmãos fizeram partir Paulo em direcção ao mar, enquanto Silas e Timóteo permaneceram lá."
,"15":"Os que acompanhavam Paulo conduziram-no até Atenas. Depois, voltaram com ordens para que Silas e Timóteo fossem ter com ele o mais depressa possível."
,"16":"Enquanto Paulo os esperava em Atenas, ficou revoltado ao ver a cidade cheia de ídolos."
,"17":"Por isso, discutia na sinagoga com os judeus e pagãos que adoravam o Deus único. E todos os dias discutia na praça pública com aqueles que ia encontrando."
,"18":"Também alguns filósofos epicureus e estóicos começaram a conversar com ele. Alguns diziam: «O que quererá dizer este charlatão?» Outros diziam: «Deve ser um pregador de divindades estrangeiras». Porque Paulo anunciava Jesus e a Ressurreição."
,"19":"Tomando Paulo consigo, levaram-no ao Areópago, dizendo: «Podemos saber que nova doutrina é essa que ensinas?"
,"20":"De facto, as coisas que dizes são-nos estranhas; queremos, portanto, saber do que se trata»."
,"21":"Com efeito, todos os atenienses e os estrangeiros residentes passavam o tempo a contar ou a ouvir as últimas novidades."
,"22":"De pé, no meio do Areópago, Paulo disse: «Senhores de Atenas, em tudo eu vejo que sois extremamente religiosos."
,"23":"De facto, passando e observando os vossos monumentos sagrados, encontrei também um altar com esta inscrição: 'Ao Deus desconhecido'. Pois bem, esse Deus que adorais sem conhecer, é exactamente Aquele que eu vos anuncio."
,"24":"O Deus que fez o mundo e tudo o que nele existe. Sendo Senhor do Céu e da Terra, não habita em santuários feitos por mãos humanas."
,"25":"Também não é servido por mãos humanas, como se precisasse de alguma coisa; pois é Ele que a todos dá vida, respiração e tudo o mais."
,"26":"De um só homem, fez toda a raça humana para habitar sobre toda a face da Terra, tendo fixado os tempos previamente estabelecidos e os limites da sua habitação."
,"27":"Assim fez, para que procurassem a Deus e para ver se O descobririam, ainda que seja às apalpadelas. Ele não está longe de cada um de nós,"
,"28":"pois n'Ele vivemos, nos movemos e existimos, como alguns dentre os vossos poetas disseram: 'Somos da raça do próprio Deus'."
,"29":"Sendo, portanto, da raça de Deus, não devemos pensar que a divindade é semelhante ao ouro, à prata ou à pedra, trabalhados pela arte e imaginação do homem."
,"30":"Mas Deus, sem levar em conta os tempos da ignorância, agora anuncia aos homens que todos e em todo o lugar se arrependam,"
,"31":"pois Ele estabeleceu um dia em que irá julgar o mundo com justiça, por meio do Homem que designou e creditou diante de todos, ressuscitando-O dos mortos»."
,"32":"Quando ouviram falar de ressurreição dos mortos, alguns troçavam e outros diziam: «Ouvir-te-emos falar disso em outra ocasião»."
,"33":"Foi assim que Paulo saiu do meio deles."
,"34":"Alguns, porém, uniram-se a ele e abraçaram a fé. Entre esses estava Dionísio, o areopagita, uma mulher chamada Dâmaris e outros com eles."
}`)
	CurrentBook.AddChapter(18, `{
"1":"A seguir, Paulo deixou Atenas e foi para Corinto."
,"2":"Encontrou ali um judeu chamado Áquila, natural do Ponto, que acabara de chegar da Itália com a esposa Priscila, pois o imperador Cláudio tinha decretado que todos os judeus saíssem de Roma. Paulo entrou em contacto com eles."
,"3":"E como eram da mesma profissão - fabricantes de tendas -, Paulo passou a morar com eles e trabalhavam juntos."
,"4":"Todos os sábados, Paulo discutia na sinagoga, procurando convencer judeus e gregos."
,"5":"Quando Silas e Timóteo chegaram da Macedónia, Paulo dedicou-se inteiramente à Palavra, testemunhando diante dos judeus que Jesus era o Messias."
,"6":"Mas, por causa da resistência e blasfémias deles, Paulo sacudiu as vestes e disse: «Sois responsáveis pelo que acontecer. Não tenho nada a ver com isso. De agora em diante, vou dirigir-me aos pagãos»."
,"7":"Então Paulo foi para a casa de um pagão adorador do Deus único, um certo Tício Justo, que morava ao lado da sinagoga."
,"8":"Crispo, o chefe da sinagoga, acreditou no Senhor com toda a sua família; e muitos coríntios, que escutavam Paulo, acreditavam e recebiam o baptismo."
,"9":"Uma noite o Senhor em visão disse a Paulo: «Não tenhas medo, continua a falar, não te cales,"
,"10":"porque Eu estou contigo. Ninguém porá as mãos em ti para te fazer mal. Nesta cidade há um povo numeroso que Me pertence»."
,"11":"Assim, Paulo ficou um ano e meio entre eles, ensinando a Palavra de Deus."
,"12":"Na época em que Galião era procônsul na Acaia, os judeus insurgiram-se em massa contra Paulo e levaram-no diante do tribunal,"
,"13":"dizendo: «Este homem induz o povo a adorar a Deus de modo contrário à Lei»."
,"14":"Paulo ia tomar a palavra, quando Galião respondeu aos judeus: «Judeus, se fosse por causa de um delito ou de uma acção criminosa, seria justo que eu atendesse a vossa queixa."
,"15":"Mas, como é questão de palavras, de nomes e da vossa Lei, tratai disso vós mesmos. Eu não quero ser juiz nessas coisas»."
,"16":"E Galião mandou-os sair do tribunal."
,"17":"Então, todos agarraram Sóstenes, o chefe da sinagoga, e espancaram-no diante do tribunal. E Galião nem se incomodou com isso."
,"18":"Paulo permaneceu ainda vários dias em Corinto. Depois, despediu-se dos irmãos e embarcou para a Síria, em companhia de Priscila e Áquila. Em Cêncreas, Paulo rapou a cabeça, pois tinha feito uma promessa."
,"19":"Quando chegaram a Éfeso, Paulo deixou-os e entrou sozinho na sinagoga, onde começou a discutir com os judeus."
,"20":"Estes pediam-lhe que permanecesse mais tempo, mas Paulo recusou."
,"21":"Todavia, ao despedir-se, disse-lhes: «Voltarei de novo para junto de vós, se Deus quiser». E partiu para Éfeso."
,"22":"Desembarcando em Cesareia, foi saudar a Igreja, e depois desceu para Antioquia,"
,"23":"onde permaneceu por algum tempo. Em seguida partiu de novo, percorrendo sucessivamente as regiões da Galácia e da Frígia, fortalecendo todos os discípulos."
,"24":"Chegou a Éfeso um judeu chamado Apolo, natural de Alexandria. Era homem eloquente, instruído nas Escrituras."
,"25":"Fora instruído no Caminho do Senhor e, com muito entusiasmo, falava e ensinava com exactidão a respeito de Jesus, embora só conhecesse o baptismo de João."
,"26":"Ele começou, então, a falar com muita convicção na sinagoga. Ao escutá-lo, Priscila e Áquila tomaram-no consigo e, com mais precisão, expuseram-lhe o Caminho de Deus."
,"27":"Como ele queria partir para a Acaia, os irmãos apoiaram-no e escreveram aos discípulos que o acolhessem bem. Graças à iniciativa divina, a presença de Apolo foi muito útil aos fiéis."
,"28":"De facto, ele rebatia vigorosamente os judeus em público, demonstrando pelas Escrituras que Jesus é o Messias."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Enquanto Apolo estava em Corinto, Paulo atravessou as regiões mais altas e chegou a Éfeso. Encontrou lá alguns discípulos"
,"2":"e perguntou-lhes: «Quando abraçastes a fé, recebestes o Espírito Santo?» Eles responderam: «Nós nem sequer ouvimos dizer que existe um Espírito Santo»."
,"3":"Paulo perguntou: «Que baptismo recebestes?» Eles responderam: «O baptismo de João»."
,"4":"Então Paulo explicou: «João baptizava como sinal de arrependimento e pedia ao povo que acreditasse n'Aquele que devia vir depois dele, isto é, em Jesus»."
,"5":"Ao ouvir isto, fizeram-se baptizar em nome do Senhor Jesus."
,"6":"Logo que Paulo lhes impôs as mãos, o Espírito Santo desceu sobre eles e começaram a falar em línguas e a profetizar."
,"7":"Eram, ao todo, doze homens."
,"8":"Em seguida, Paulo foi à sinagoga e, durante três meses, falava com toda a convicção, discutindo e procurando convencer os ouvintes sobre o Reino de Deus."
,"9":"Todavia, como alguns se obstinavam na incredulidade e falavam mal do Caminho diante da multidão, Paulo rompeu com eles, separou os discípulos e, diariamente, ensinava-os na escola de um homem chamado Tiranos."
,"10":"Isto durou dois anos, de modo que todos os habitantes da Ásia, judeus e gregos, puderam ouvir a Palavra do Senhor."
,"11":"Deus realizava milagres extraordinários pelas mãos de Paulo,"
,"12":"a tal ponto que pegavam em lenços e aventais usados por Paulo para os colocar sobre os doentes, e estes eram libertados das suas doenças e os espíritos maus eram afastados."
,"13":"Alguns exorcistas judeus itinerantes começaram a invocar o nome do Senhor Jesus sobre aqueles que tinham espíritos maus. E diziam: «Eu vos esconjuro por este Jesus que Paulo prega»."
,"14":"Os que faziam isto eram os sete filhos de Ceva, um sumo sacerdote judeu."
,"15":"Mas o espírito mau reagiu, dizendo: «Eu conheço Jesus e sei quem é Paulo; mas vós, quem sois?»"
,"16":"E o homem que estava possesso do espírito mau lançou-se a eles com tanta violência, que tiveram de fugir daquela casa, sem roupas e cobertos de ferimentos."
,"17":"E toda a população de Éfeso, judeus e gregos, tiveram conhecimento deste facto. O temor apossou-se de todos. E a grandeza do Nome de Jesus era exaltada."
,"18":"Muitos fiéis acorriam para confessar em voz alta as suas práticas mágicas,"
,"19":"e um bom número dos que praticavam magia amontoaram os seus livros e queimaram-nos em praça pública. O valor desses livros foi calculado em cinquenta mil moedas de prata."
,"20":"Assim, a Palavra do Senhor crescia e firmava-se com grande poder."
,"21":"Depois destes acontecimentos, Paulo resolveu ir a Jerusalém, passando pela Macedónia e pela Acaia. Ele dizia: «Depois de ir até lá, eu devo ir também a Roma»."
,"22":"Paulo enviou à Macedónia dois dos seus ajudantes, Timóteo e Erasto, e ficou ainda por algum tempo na Ásia."
,"23":"Foi nessa época que rebentou um grave tumulto a respeito do Caminho."
,"24":"Havia um homem chamado Demétrio, que era ourives e fabricava nichos de prata da deusa Ártemis. E isso dava muito lucro aos artesãos."
,"25":"Ele reuniu esses artesãos, juntamente com outros que trabalhavam no ramo, e disse-lhes: «Amigos, sabeis que o nosso bem-estar provém desta nossa actividade."
,"26":"Ora, vós mesmos podeis verificar e ouvir por aí que Paulo, com a sua propaganda, está a desencaminhar muita gente, não só em Éfeso, mas em quase toda a Ásia. Ele afirma que os deuses fabricados pelas nossas mãos não são deuses."
,"27":"Não é só a nossa profissão que corre o risco de cair em descrédito, mas também o santuário da grande deusa Ártemis acabará por ser desacreditado e, assim, ficará despojada de majestade aquela que toda a Ásia e o mundo inteiro adora»."
,"28":"Ao ouvirem isto, ficaram furiosos e não cessavam de gritar: «Grande é a Ártemis dos efésios!»"
,"29":"O tumulto espalhou-se por toda a cidade. A multidão dirigiu-se em massa ao teatro, arrastando os macedónios Gaio e Aristarco, companheiros de viagem de Paulo."
,"30":"Paulo queria apresentar-se à assembleia, mas os discípulos não deixaram."
,"31":"Também algumas pessoas importantes da província, que eram seus amigos, lhe mandaram pedir que não se arriscasse a comparecer no teatro."
,"32":"Um gritava uma coisa, outro gritava o contrário, e a confusão era geral na assembleia. A maioria nem sequer sabia por que motivo ali se encontrava."
,"33":"E, no meio da multidão, algumas pessoas convenceram um certo Alexandre a falar. Ele tinha sido colocado à frente pelos judeus. Fez sinal com a mão, mostrando que queria dar explicações à assembleia."
,"34":"Mas, quando se aperceberam de que era judeu, todos se puseram a gritar numa só voz, durante quase duas horas: «Grande é a Ártemis dos efésios!»"
,"35":"Por fim, o secretário conseguiu acalmar a multidão e disse: «Cidadãos de Éfeso, quem dentre os homens não sabe que a cidade de Éfeso guarda o templo da grande Ártemis e a sua estátua que caiu do céu?"
,"36":"Quanto a isso, não resta dúvida. Portanto, permanecei calmos e não cometais nenhuma loucura."
,"37":"Estes homens que trouxestes até aqui não profanaram o templo, nem blasfemaram contra a nossa deusa."
,"38":"Portanto, se Demétrio e os artesãos que estão com ele têm acusações para fazer contra alguém, sejam feitas audiências, e os procônsules estão à disposição. Que as partes apresentem acusações recíprocas."
,"39":"E, se houver qualquer outra questão, será resolvida em assembleia legal."
,"40":"De contrário, corremos o risco de sermos acusados de revolta por causa do que aconteceu hoje, pois não existe nenhum motivo que justifique esta reunião»."
,"41":"Com esta declaração, dissolveu a assembleia."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Quando o tumulto acabou, Paulo mandou chamar os discípulos de Éfeso. Depois de os encorajar, despediu-se deles e partiu para a Macedónia."
,"2":"Percorreu essas regiões, falando com frequência aos fiéis para os encorajar. E assim chegou à Grécia,"
,"3":"onde permaneceu três meses. Quando estava para embarcar rumo à Síria, decidiu fazer a viagem através da Macedónia, porque os judeus tinham organizado uma conspiração contra ele."
,"4":"Os companheiros de Paulo eram: Sópatros, filho de Pirro, da Bereia; Aristarco e Segundo, de Tessalónica; Gaio, de Derbe; Timóteo, Tíquico e Trófimo, da província da Ásia."
,"5":"Estes, porém, partiram antes de nós e esperaram-nos em Tróade."
,"6":"Nós embarcámos em Filipos, logo após os dias dos pães sem fermento, e alcançámo-los cinco dias depois em Tróade, onde permanecemos uma semana."
,"7":"No primeiro dia da semana, estávamos reunidos para a fracção do pão. Paulo, que devia partir no dia seguinte, dirigia a palavra aos fiéis e prolongou o discurso até à meia-noite."
,"8":"Havia muitas lâmpadas na sala superior, onde estávamos reunidos."
,"9":"Um jovem, chamado Êutico, que estava sentado sobre a janela, adormeceu durante o prolongado discurso de Paulo; vencido pelo sono, caiu do terceiro andar. Quando o levantaram, estava morto."
,"10":"Então Paulo desceu, inclinou-se sobre o jovem e, abraçando-o, disse: «Não vos preocupeis, porque ele está vivo»."
,"11":"Depois subiu novamente, partiu o pão e comeu. Ficou conversando com eles até de madrugada, e depois partiu."
,"12":"Quanto ao jovem, levaram-no vivo, e sentiram-se muito confortados."
,"13":"Nós, porém, continuámos a viagem e embarcámos num navio para Assos, onde iríamos encontrar Paulo. Assim Paulo havia determinado, pois que ele iria por terra."
,"14":"Quando nos alcançou em Assos, nós recolhemo-lo a bordo e prosseguimos para Mitilene."
,"15":"Daí embarcámos no dia seguinte e chegámos à altura de Quio; um dia depois, aportámos em Samos. Tivemos outro dia de viagem e, depois de pararmos em Trogílio, chegámos a Mileto."
,"16":"Paulo tinha decidido não passar por Éfeso, a fim de não prolongar de mais a sua permanência na Ásia. Tinha pressa de estar em Jerusalém, se possível para o dia de Pentecostes."
,"17":"De Mileto, Paulo mandou emissários a Éfeso para chamar os anciãos dessa Igreja."
,"18":"Quando os anciãos chegaram, Paulo disse-lhes: «Vós bem sabeis de que maneira me comportei em relação a vós durante todo o tempo, desde o primeiro dia em que cheguei à Ásia."
,"19":"Servi o Senhor com toda a humildade, com lágrimas e no meio das provações que sofri por causa das ciladas dos judeus."
,"20":"Nunca deixei de anunciar aquilo que vos pudesse ser de proveito, nem de anunciar publicamente e também de casa em casa."
,"21":"Com insistência, convidei judeus e gregos a arrependerem-se diante de Deus e a acreditarem em Jesus nosso Senhor."
,"22":"E agora, prisioneiro do Espírito, vou para Jerusalém, sem saber o que lá me acontecerá."
,"23":"Só sei que, de cidade em cidade, o Espírito Santo me adverte, dizendo que me aguardam cadeias e tribulações."
,"24":"Mas de modo nenhum considero a minha vida preciosa para mim mesmo, contanto que leve a bom termo a minha carreira e o serviço que recebi do Senhor Jesus, ou seja, testemunhar o Evangelho da graça de Deus."
,"25":"Agora, porém, tenho a certeza de que não mais vereis o meu rosto, vós todos entre os quais passei pregando o Reino."
,"26":"Portanto, hoje dou testemunho diante de vós: se alguém de vós se perder, eu não sou responsável,"
,"27":"pois não deixei de vos anunciar todos os projectos de Deus."
,"28":"Cuidai de vós mesmos e de todo o rebanho, pois o Espírito Santo vos constituiu como guardiães, para apascentardes a Igreja de Deus, que Ele adquiriu para Si com o sangue do seu próprio Filho."
,"29":"Eu sei: depois da minha partida, aparecerão lobos vorazes no meio de vós, e não terão pena do rebanho."
,"30":"E do meio de vós mesmos surgirão alguns dizendo coisas pervertidas, para arrastar os discípulos atrás de si."
,"31":"Portanto, vigiai e lembrai-vos de que durante três anos, dia e noite, não cessei de admoestar, com lágrimas, cada um de vós."
,"32":"Agora, pois, eu entrego-vos ao Senhor e à Palavra da sua graça, que tem o poder de edificar e de vos dar a herança entre todos os santificados."
,"33":"Nunca cobicei prata, nem ouro nem vestes de ninguém."
,"34":"Vós mesmos sabeis que estas minhas mãos providenciaram o que era necessário para mim e para os que estavam comigo."
,"35":"Em tudo vos mostrei que é trabalhando assim que devemos ajudar os fracos, recordando as palavras do próprio Senhor Jesus, que disse: «Há mais felicidade em dar do que em receber»."
,"36":"Após estas palavras, Paulo ajoelhou-se e rezou com todos eles."
,"37":"Então todos começaram a chorar muito; e, lançando-se ao pescoço de Paulo, beijavam-no."
,"38":"Estavam muito tristes, principalmente porque havia dito que eles nunca mais veriam o seu rosto. E acompanharam-no até ao navio."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Quando chegou o momento de partir, fomos como que arrancados dos seus braços e navegámos directamente para a ilha de Cós. No dia seguinte, chegámos a Rodes, e daí fomos até Pátara,"
,"2":"onde encontrámos um navio que fazia a travessia para a Fenícia; embarcámos e seguimos viagem."
,"3":"Chegando à vista de Chipre, deixámo-la à esquerda e continuámos a nossa viagem em direcção à Síria. Desembarcámos em Tiro, onde o navio devia descarregar."
,"4":"Encontrámos os discípulos e ficámos ali sete dias. Movidos pelo Espírito, os discípulos diziam a Paulo que não subisse a Jerusalém."
,"5":"Quando chegou o dia de nos irmos embora, partimos. Todos quiseram acompanhar-nos, com as mulheres e crianças, até fora da cidade. Na praia, ajoelhámo-nos para rezar."
,"6":"Depois da despedida, embarcámos e eles voltaram para casa."
,"7":"Continuando a nossa viagem por mar, de Tiro chegámos a Ptolemaida. Aí cumprimentámos os irmãos e ficámos um dia com eles."
,"8":"No dia seguinte, partimos e chegámos a Cesareia. Aí fomos a casa de Filipe, o Evangelista, que era um dos sete, e hospedámo-nos em sua casa."
,"9":"Filipe tinha quatro filhas solteiras que profetizavam."
,"10":"Enquanto passávamos vários dias aí, desceu da Judeia um profeta chamado Ágabo."
,"11":"Ele veio ao nosso encontro, pegou no cinto de Paulo e, amarrando os próprios pés e mãos, declarou: «Isto é o que diz o Espírito Santo: o homem a quem pertence este cinto será amarrado deste modo pelos judeus em Jerusalém e será entregue às mãos dos pagãos»."
,"12":"Quando ouvimos isto, nós e os irmãos da cidade, insistimos com Paulo para que não subisse a Jerusalém."
,"13":"Mas Paulo respondeu: «Porque chorais e afligis o meu coração? Eu estou pronto, não somente para ser preso, mas até para morrer em Jerusalém pelo nome do Senhor Jesus»."
,"14":"Não conseguimos convencê-lo. Então desistimos, dizendo: «Seja feita a vontade do Senhor»."
,"15":"Depois de alguns dias, terminámos os nossos preparativos e subimos a Jerusalém."
,"16":"Alguns discípulos de Cesareia acompanharam-nos e levaram-nos para nos hospedar na casa de um certo Mnásson, que era antigo discípulo, natural de Chipre."
,"17":"Quando chegámos a Jerusalém, os irmãos receberam-nos com alegria."
,"18":"No dia seguinte, Paulo foi connosco a casa de Tiago, onde todos os anciãos estavam reunidos."
,"19":"Depois de os cumprimentar, Paulo expôs minuciosamente o que Deus fizera aos pagãos através do seu serviço."
,"20":"Ouvindo Paulo, glorificavam a Deus. Mas a seguir disseram-lhe: «Como vês, irmão, há milhares de judeus que abraçaram a fé, e todos são fiéis observantes da Lei."
,"21":"Eles estão a par de coisas que dizem a teu respeito, isto é, que andas ensinando a todos os judeus que vivem no meio dos pagãos para abandonarem Moisés e aconselhando-os a não circuncidarem os filhos e a não continuarem a seguir as tradições."
,"22":"Que vamos fazer? Certamente hão-de ouvir dizer que estás aqui."
,"23":"Portanto, faz o que te vamos sugerir. Estão aqui quatro homens que têm uma promessa para cumprir."
,"24":"Leva-os contigo, purifica-te com eles, paga as despesas para que possam mandar rapar a cabeça. Assim, todos saberão que os boatos a teu respeito não têm fundamento e que também és fiel na observância da Lei."
,"25":"Quanto aos pagãos que abraçaram a fé, já lhes escrevemos sobre as nossas decisões: abster-se de carnes imoladas aos ídolos, de carnes sufocadas e de uniões ilegítimas»."
,"26":"Então Paulo levou os homens consigo. No dia seguinte, purificou-se com eles e entrou no Templo, comunicando o prazo em que devia ser oferecido o sacrifício por cada um deles, logo após os dias da purificação."
,"27":"Os sete dias estavam a chegar ao fim, quando os judeus da Ásia, reparando que Paulo estava no Templo, amotinaram toda a multidão e agarraram-no,"
,"28":"gritando: «Israelitas, socorro! Este é o homem que ensina a todos e por toda a parte contra o nosso povo, contra a Lei e contra este Lugar. Além disso, ele trouxe gregos para dentro do Templo, profanando este santo Lugar»."
,"29":"De facto, antes eles tinham visto Trófimo, o efésio, com Paulo na cidade, e julgavam que Paulo o tivesse introduzido no Templo."
,"30":"A cidade toda ficou agitada e houve ajuntamento do povo. Apoderaram-se de Paulo e arrastaram-no para fora do Templo e fecharam imediatamente as portas."
,"31":"Já se preparavam para o matar, quando chegou ao tribuno da coorte esta notícia: «Jerusalém inteira está amotinada»."
,"32":"O tribuno destacou imediatamente soldados e oficiais, e atacou os manifestantes. Estes, vendo o tribuno e os soldados, deixaram de bater em Paulo."
,"33":"Então, o tribuno aproximou-se, deteve Paulo e mandou que o prendessem com duas correntes; depois perguntou quem ele era e o que havia feito."
,"34":"Na multidão, uns gritavam uma coisa e outros, outra. Não podendo obter uma informação segura por causa do tumulto, o tribuno ordenou que conduzissem Paulo para a fortaleza."
,"35":"Quando chegou junto aos degraus, Paulo teve que ser levado pelos soldados, por causa da violência da multidão."
,"36":"Com efeito, o povo seguia-o em massa a gritar: «À morte! À morte!»"
,"37":"Paulo, quando estava para entrar na fortaleza, disse ao tribuno: «Posso falar contigo?» O tribuno perguntou: «Tu falas grego?"
,"38":"Não és o egípcio que há tempos subverteu e arrastou para o deserto quatro mil sicários?»"
,"39":"Paulo respondeu: «Eu sou judeu, cidadão de Tarso, uma cidade importante da Cilícia. E, agora, peço-te que me deixes falar com o povo»."
,"40":"O tribuno deu-lhe permissão. E Paulo, de pé sobre os degraus, fez sinal com a mão ao povo. Houve grande silêncio e Paulo dirigiu-lhes a palavra em língua hebraica."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Paulo disse: «Irmãos e pais, escutai a defesa que eu agora vos apresento»."
,"2":"Vendo que Paulo lhes falava em língua hebraica, fizeram mais silêncio ainda. E Paulo continuou:"
,"3":"«Eu sou judeu. Nasci em Tarso da Cilícia, mas fui educado nesta cidade, formado na escola de Gamaliel, seguindo a linha mais escrupulosa dos nossos antepassados, cheio de zelo por Deus, como todos vós o sois agora."
,"4":"Persegui mortalmente este Caminho, prendendo e lançando na prisão homens e mulheres,"
,"5":"como o sumo sacerdote e todos os anciãos podem testemunhar. Eles até me deram carta de recomendação para os irmãos de Damasco, e para lá me dirigi, a fim de trazer algemados os que lá estivessem, a fim de serem punidos aqui em Jerusalém."
,"6":"No entanto, aconteceu que, na viagem, estando já perto de Damasco, aí pelo meio-dia, de repente uma grande luz que vinha do céu brilhou ao redor de mim."
,"7":"Então caí por terra e ouvi uma voz que me dizia: 'Saulo, Saulo, porque Me persegues?'"
,"8":"Eu perguntei: 'Quem és Tu, Senhor?' Ele respondeu-me: 'Eu sou Jesus, o Nazareno, a quem estás perseguindo!'"
,"9":"Os meus companheiros viram a luz, mas não ouviram a voz que me falava."
,"10":"Então perguntei: 'Senhor, que devo fazer?' E o Senhor respondeu-me: 'Levanta-te e vai para Damasco. Lá te explicarão tudo o que Deus quer que faças.'"
,"11":"Como eu não podia ver por causa do brilho daquela luz, cheguei a Damasco guiado pela mão dos meus companheiros."
,"12":"Havia na cidade um certo Ananias, homem piedoso e fiel à Lei, muito respeitado por todos os judeus que ali moravam."
,"13":"Ele veio ao meu encontro e disse-me: 'Saulo, meu irmão, recupera a vista!' No mesmo instante recuperei a vista e pude vê-lo."
,"14":"Então ele disse-me: 'O Deus dos nossos antepassados destinou-te a conhecer a sua vontade, a ver o Justo e a ouvir a sua própria voz."
,"15":"Porque vais ser a sua testemunha, diante de todos os homens, de todas as coisas que viste e ouviste."
,"16":"Agora, não percas tempo: levanta-te, recebe o baptismo e lava os teus pecados, invocando o seu Nome'."
,"17":"Depois eu voltei a Jerusalém, e enquanto rezava no Templo, entrei em êxtase."
,"18":"Vi o Senhor que me dizia: 'Depressa, sai imediatamente de Jerusalém, porque não aceitarão o testemunho que dás a meu respeito'."
,"19":"Então respondi: 'Mas, Senhor, eles sabem que era eu que, nas sinagogas, prendia e batia nos que acreditavam em Ti."
,"20":"E quando o sangue de Estêvão, tua testemunha, foi derramado, eu mesmo estava lá, apoiando aqueles que o matavam e guardando-lhes as roupas'."
,"21":"Então o Senhor disse-me: 'Vai! É para longe, é para os pagãos que te vou enviar'»."
,"22":"Os judeus escutaram Paulo até a este ponto. Mas, quando ele disse estas palavras, começaram a gritar: «Tira da Terra esse indivíduo! Ele não merece viver!»"
,"23":"Gritavam, atiravam com as capas e lançavam terra para o ar."
,"24":"Então o tribuno mandou recolher Paulo na fortaleza, ordenando que o interrogassem debaixo de açoites, para saber por que motivo gritavam tanto contra ele."
,"25":"Enquanto amarravam Paulo com correias, ele disse ao centurião de serviço: «É-vos permitido açoitar um cidadão romano sem ter sido julgado?»"
,"26":"Diante destas palavras, o centurião foi prevenir o tribuno: «Vê bem o que vais fazer! Este homem é cidadão romano!»"
,"27":"Então o tribuno foi e perguntou a Paulo: «Diz-me: és cidadão romano?» Ele respondeu: «Sou, sim»."
,"28":"O tribuno disse: «Eu precisei de muito dinheiro para adquirir essa cidadania!»"
,"29":"Paulo respondeu: «Pois eu tenho essa cidadania de nascença». Os que o iam torturar afastaram-se imediatamente. Até o tribuno ficou com medo ao saber que Paulo era cidadão romano, e que mesmo assim o havia acorrentado."
,"30":"No dia seguinte, querendo saber com certeza do que era acusado pelos judeus, o tribuno soltou-o e mandou reunir os chefes dos sacerdotes e todo o Sinédrio. Depois, mandou buscar Paulo e apresentou-o perante eles."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Com o olhar fixo no Sinédrio, Paulo falou assim: «Irmãos, até hoje eu comportei-me diante de Deus em perfeita boa consciência»."
,"2":"Mas o sumo sacerdote Ananias ordenou aos que estavam perto que batessem na boca de Paulo."
,"3":"Então Paulo disse-lhe: «Deus vai ferir-te, parede caiada! Sentas-te para me julgar segundo a Lei e, violando a Lei, ordenas que me batam?»"
,"4":"Os que estavam a seu lado disseram-lhe: «Tu insultas o sumo sacerdote de Deus!»"
,"5":"Paulo respondeu: «Irmãos, eu não sabia que era o Sumo Sacerdote. Pois está escrito: 'Não amaldiçoarás o chefe do teu povo'»."
,"6":"A seguir, sabendo que uma parte dos presentes eram saduceus, e a outra parte eram fariseus, Paulo exclamou no Sinédrio: «Irmãos, eu sou fariseu e filho de fariseus. É pela nossa esperança, a ressurreição dos mortos, que estou a ser julgado»."
,"7":"Apenas disse isto, armou-se um conflito entre fariseus e saduceus, e a assembleia dividiu-se."
,"8":"De facto, os saduceus dizem que não há ressurreição, nem anjos, nem espíritos, enquanto os fariseus sustentam uma coisa e outra."
,"9":"Levantou-se uma enorme gritaria. Então, alguns doutores da Lei, do partido dos fariseus, começaram a protestar, dizendo: «Não encontramos nenhum mal neste homem. E se um espírito ou anjo tivesse falado com ele?»"
,"10":"E o conflito crescia cada vez mais. Receando que Paulo fosse esmagado por eles, o tribuno ordenou que o destacamento descesse e o tirasse do meio deles, levando-o de novo para a fortaleza."
,"11":"Na noite seguinte, o Senhor aproximou-Se de Paulo e disse-lhe: «Tem confiança. Assim como deste testemunho de Mim em Jerusalém, é preciso que também dês testemunho em Roma»."
,"12":"No dia seguinte, os judeus fizeram uma conspiração e comprometeram-se, sob juramento, a não comer nem beber enquanto não matassem Paulo."
,"13":"Os que tinham feito essa conjura eram mais de quarenta homens."
,"14":"Foram, então, procurar os sumos sacerdotes e os anciãos, dizendo: «Acabámos de jurar solenemente, sob anátema, que nada vamos comer enquanto não matarmos Paulo."
,"15":"Portanto, agora, de acordo com o Sinédrio, pedi ao tribuno que o traga, sob pretexto de examinardes mais minuciosamente o caso. Quanto a nós, estamos prontos para o matar antes que ele aqui chegue»."
,"16":"Entretanto, o sobrinho de Paulo soube da trama, foi à fortaleza, entrou e preveniu Paulo."
,"17":"Então Paulo chamou um dos centuriões e disse: «Leva este rapaz ao tribuno, porque ele tem algo a comunicar»."
,"18":"O centurião conduziu o rapaz ao tribuno e disse-lhe: «O prisioneiro Paulo chamou-me e pediu-me que trouxesse este rapaz, que tem algo a dizer-te»."
,"19":"Tomando o rapaz pela mão, o tribuno levou-o à parte e perguntou-lhe: «O que é que tens para me comunicar?»"
,"20":"O rapaz respondeu: «Os judeus combinaram pedir-te que faças Paulo descer amanhã ao Sinédrio, sob pretexto de examinarem mais minuciosamente a sua causa."
,"21":"Não acredites neles. Mais de quarenta homens estão de emboscada contra Paulo. Eles juraram, sob anátema, não comer nem beber enquanto não o matarem. Agora estão preparados e só esperam a tua autorização»."
,"22":"O tribuno despediu o rapaz, recomendando: «Não digas a ninguém que me trouxeste estas informações»."
,"23":"Então o tribuno chamou dois centuriões e ordenou: «Tende preparados, desde as nove horas da noite, duzentos soldados, setenta cavaleiros e duzentos lanceiros para irem até Cesareia."
,"24":"E também cavalos, para que Paulo possa viajar e ser conduzido são e salvo ao governador Félix»."
,"25":"Depois, o tribuno escreveu a seguinte carta:"
,"26":"«Cláudio Lísias ao excelentíssimo governador Félix, saudações!"
,"27":"Este homem caiu em poder dos judeus e estava para ser morto por eles. Então cheguei com a tropa e arranquei-o das mãos deles, ao saber que era cidadão romano."
,"28":"Querendo averiguar o motivo por que o acusavam, mandei-o comparecer diante do Sinédrio."
,"29":"Verifiquei que ele era incriminado por questões referentes à Lei que os rege, não havendo nenhum crime que justificasse morte ou prisão."
,"30":"Informado que existia, por parte dos judeus, um atentado contra este homem, tratei de to enviar. Comuniquei aos acusadores que devem expor na tua presença o que têm contra este homem»."
,"31":"Conforme lhes fora ordenado, os soldados tomaram Paulo e levaram-no de noite até Antipátride."
,"32":"No dia seguinte, os soldados voltaram à fortaleza e deixaram os cavaleiros seguir viagem com Paulo."
,"33":"Chegando a Cesareia, os cavaleiros entregaram a carta ao governador e apresentaram-lhe Paulo."
,"34":"Depois de ler a carta, o governador quis saber qual era a província de origem de Paulo. Informado que era da Cilícia, disse-lhe:"
,"35":"«Quando os teus acusadores chegarem, eu ouvir-te-ei». E mandou que Paulo ficasse preso no palácio de Herodes."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Cinco dias depois, o sumo sacerdote Ananias foi a Cesareia com alguns anciãos e um advogado chamado Tértulo. Eles apresentaram-se ao governador como acusadores de Paulo."
,"2":"Quando Paulo foi chamado, Tértulo começou a acusação dizendo: «Excelentíssimo governador Félix. Gozamos de paz profunda graças à tua direcção e às reformas feitas em favor deste povo."
,"3":"Reconhecemos e agradecemos todos estes benefícios realizados sempre e em toda a parte."
,"4":"Mas, para não te deter muito tempo, peço a tua atenção por um instante, pois conhecemos a tua benevolência."
,"5":"Verificámos que este homem é uma peste: ele promove conflitos entre os judeus do mundo inteiro e é também um dos cabecilhas da seita dos nazarenos."
,"6":"Ele tentou inclusive profanar o Templo; por isso o prendemos. Pretendíamos julgá-lo segundo a nossa Lei,"
,"7":"mas o tribuno Lísias interveio, arrancou-o das nossas mãos com muita violência e ordenou aos seus acusadores que comparecessem diante de ti."
,"8":"Interrogando-o, poderás certifi-car-te de todas as coisas de que nós o acusamos»."
,"9":"Os judeus também apoiavam Tértulo, sustentando que as coisas eram assim mesmo."
,"10":"Então o governador fez sinal para que Paulo falasse. E este começou: «Eu sei que há muitos anos és juiz desta nação e, por isso, me sinto à vontade para defender a minha causa."
,"11":"Como podes comprovar, há apenas doze dias que subi em peregrinação a Jerusalém."
,"12":"Ora, nem no Templo, nem nas sinagogas, nem pela cidade, alguém me viu discutir com outra pessoa ou provocar desordem na multidão."
,"13":"Eles não podem provar aquilo de que agora me acusam."
,"14":"Confesso-te, porém, uma coisa: eu estou ao serviço do Deus dos nossos pais, segundo o Caminho, a que eles chamam seita. Acredito em tudo o que está conforme a Lei e em tudo o que se encontra escrito nos Profetas."
,"15":"Tenho em Deus a mesma esperança que eles têm, ou seja: que todos vão ressuscitar, tanto os justos como os injustos."
,"16":"Por isso, eu também me esforço por manter sempre a consciência limpa diante de Deus e dos homens."
,"17":"Depois de muitos anos, vim trazer esmolas ao meu povo e também apresentar ofertas."
,"18":"Quando eu estava a fazer isso, depois de ter feito a cerimónia da purificação, eles encontraram-me no Templo. Não havia ajuntamento nem tumulto."
,"19":"Alguns judeus da Ásia, porém... São eles que deveriam apresentar-se a ti e acusar-me, caso tivessem algo contra mim."
,"20":"Ou então, que estes homens aqui digam se encontraram em mim algum crime quando compareci diante do Sinédrio."
,"21":"A não ser que se trate desta única frase que gritei no meio deles: 'É por causa da ressurreição dos mortos que estou hoje a ser julgado diante de vós'»."
,"22":"Félix estava bem informado a respeito do Caminho e adiou a causa, dizendo: «Quando o tribuno Lísias chegar, eu resolverei o vosso caso»."
,"23":"E ordenou que o centurião mantivesse Paulo preso, mas que lhe desse bom tratamento e não impedisse que os amigos o visitassem."
,"24":"Alguns dias mais tarde, Félix veio com a sua esposa Drusila, que era judia. Mandou chamar Paulo e ouviu-o falar da fé em Jesus Cristo."
,"25":"Mas, quando Paulo começou a discorrer sobre a justiça, a continência e o julgamento futuro, Félix ficou com medo e disse: «Por agora podes ir. Quando eu tiver mais tempo, mandar-te-ei chamar»."
,"26":"Além disso, Félix esperava que Paulo lhe desse dinheiro. Por isso, mandava chamá-lo frequentemente e conversava com ele."
,"27":"Dois anos depois, Pórcio Festo ocupou o lugar de Félix. Entretanto, querendo agradar aos judeus, Félix deixou Paulo na prisão."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Três dias depois de chegar à província, Festo subiu de Cesareia a Jerusalém."
,"2":"Os sumos sacerdotes e os mais notáveis dentre os judeus apresentaram-se para acusar Paulo. Pediam com insistência,"
,"3":"movidos contra Paulo, o especial favor de o transferir para Jerusalém. É que preparavam uma emboscada para matar Paulo durante a viagem."
,"4":"Festo, porém, respondeu que o lugar da prisão de Paulo era Cesareia e que ele mesmo partiria muito em breve para lá."
,"5":"E completou: «Aqueles que dentre vós estiverem habilitados, desçam comigo a Cesareia. E se alguma coisa existe de irregular nesse homem, apresentem acusação contra ele»."
,"6":"Festo ficou com eles não mais de oito ou dez dias e foi para Cesareia. No dia seguinte, sentou-se no tribunal e mandou trazer Paulo."
,"7":"Quando Paulo chegou, os judeus que tinham ido de Jerusalém rodearam-no, apresentando muitas e graves acusações, que no entanto não conseguiam provar."
,"8":"Paulo defendeu-se, dizendo: «Eu não fiz nada contra a Lei dos judeus, nem contra o Templo, nem contra o Imperador»."
,"9":"Querendo agradar aos judeus, Festo disse a Paulo: «Queres subir a Jerusalém para lá seres julgado, na minha presença, a respeito dessas coisas?»"
,"10":"Paulo respondeu: «Estou diante do tribunal de César, e é aqui que devo ser julgado. Não pratiquei nenhum crime contra os judeus, como perfeitamente reconheces."
,"11":"Se cometi uma injustiça ou alguma coisa que mereça a morte, não recuso morrer. Mas, se não há nada daquilo de que me acusam, ninguém pode entregar-me a eles. Apelo para César»."
,"12":"Então Festo conferenciou com o seu conselho e disse: «Apelaste para César; então irás a César»."
,"13":"Alguns dias depois, o rei Agripa e Berenice chegaram a Cesareia e foram cumprimentar Festo."
,"14":"Como se demorassem alguns dias, Festo expôs ao rei o caso de Paulo, dizendo: «Está aqui um homem que Félix deixou como prisioneiro."
,"15":"Quando eu estive em Jerusalém, os sumos sacerdotes e os anciãos dos judeus apresentaram acusações contra ele e pediram-me que o condenasse."
,"16":"Mas eu respondi-lhes que os romanos não costumam entregar um homem antes que o acusado tenha sido confrontado com os acusadores e possa defender-se da acusação."
,"17":"Eles vieram para cá e, no dia seguinte, sem demora, sentei-me no tribunal e mandei trazer o homem."
,"18":"Os acusadores compareceram diante dele, mas não apresentaram nenhuma acusação dos crimes de que eu suspeitava."
,"19":"Tinham somente certas questões sobre a sua própria religião e a respeito de um certo Jesus que já morreu, mas que Paulo afirma estar vivo."
,"20":"Eu não sabia o que fazer para averiguar o assunto. Perguntei então a Paulo se ele preferia ir a Jerusalém, para lá ser julgado."
,"21":"Mas Paulo apelou para que a sua causa fosse reservada ao juízo do Augusto Imperador. Ordenei, então, que ficasse preso até que eu pudesse enviá-lo a César»."
,"22":"Agripa disse então a Festo: «Eu também gostaria de ouvir esse homem»."
,"23":"No dia seguinte, Agripa e Berenice chegaram com grande pompa e foram à sala de audiências, com os tribunos e as pessoas importantes da cidade. Festo deu uma ordem e Paulo foi introduzido."
,"24":"Então Festo disse: «Rei Agripa e cidadãos aqui presentes: aqui está o homem por causa de quem toda a comunidade dos judeus recorreu a mim, tanto em Jerusalém como aqui, gritando que ele não devia continuar vivo."
,"25":"No entanto, eu verifiquei que ele não fez nada que mereça a morte; mas, como ele mesmo apelou para César, decidi enviar-lho."
,"26":"Acontece que nada tenho de concreto sobre ele para escrever ao soberano. Por isso, faço-o comparecer diante de vós, principalmente diante de ti, rei Agripa, a fim de que, após o interrogatório, eu tenha alguma coisa para escrever."
,"27":"Com efeito, pareceu-me absurdo enviar um prisioneiro sem indicar as acusações que fazem contra ele»."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Agripa dirigiu-se a Paulo: «Tens autorização para falar em tua defesa». Então Paulo estendeu a mão e começou a sua defesa:"
,"2":"«Rei Agripa, considero-me feliz por poder, na tua presença, defender-me de todas as coisas de que os judeus me acusam."
,"3":"Ainda mais que estás a par dos costumes e controvérsias dos judeus. Portanto, peço-te que me escutes com paciência."
,"4":"Todos os judeus sabem como foi a minha vida desde a minha juventude, no meio do meu povo e em Jerusalém, desde o início."
,"5":"Eles conhecem-me de longa data e, se quiserem, podem testemunhar que vivi como fariseu, conforme a seita mais rígida da nossa religião."
,"6":"E hoje estou a ser julgado por causa da esperança prometida por Deus aos nossos pais"
,"7":"e que as nossas doze tribos esperam conseguir, servindo a Deus dia e noite, com perseverança. É por causa dessa esperança, ó rei, que estou a ser acusado pelos judeus."
,"8":"Porque é que acham tão incrível que Deus ressuscite os mortos?"
,"9":"Eu também antes acreditava ser meu dever combater com todas as forças o nome de Jesus, o Nazareno."
,"10":"E foi isso que eu fiz em Jerusalém: prendi muitos cristãos com autorização dos sumos sacerdotes, e dei o meu voto para que fossem condenados à morte."
,"11":"Em todas as sinagogas eu procurava obrigá-los a blasfemar por meio de torturas e, no auge do furor, eu perseguia-os até nas cidades estrangeiras."
,"12":"Com essa intenção, eu ia a caminho de Damasco, com autorização e a mando dos sumos sacerdotes."
,"13":"Ó rei, eu ia a caminho, quando aí pelo meio-dia vi uma luz vinda do céu, mais brilhante que o Sol. Essa luz envolveu-me, a mim e aos que me acompanhavam."
,"14":"Todos nós caímos por terra. Então ouvi uma voz que me dizia em hebraico: 'Saulo, Saulo, porque Me persegues? É difícil recalcitrares contra o aguilhão!'"
,"15":"Eu respondi: 'Quem és Tu, Senhor?' E o Senhor respondeu-me: 'Eu sou Jesus, Aquele que tu persegues."
,"16":"Mas agora levanta-te e fica de pé. O motivo pelo qual te apareci é este: Eu constituí-te para seres servo e testemunha desta visão, na qual Me viste, e também de outras visões, nas quais Eu te aparecerei."
,"17":"Eu vou livrar-te deste povo e dos pagãos, aos quais te envio,"
,"18":"para que lhes abras os olhos e assim se convertam das trevas para a luz, da autoridade de Satanás para Deus. Deste modo, pela fé em Mim, receberão o perdão dos pecados e a herança entre os santificados'."
,"19":"E eu, ó rei Agripa, não me rebelei contra essa visão celeste."
,"20":"Pelo contrário: vivendo da maneira que corresponde a essa conversão, anunciei o arrependimento e a conversão a Deus, primeiro aos habitantes de Damasco, aos de Jerusalém e de toda a Judeia, e depois aos pagãos."
,"21":"É por isso que os judeus me agarraram e tentaram matar-me."
,"22":"Mas, com a protecção de Deus, eu continuo até hoje a dar testemunho diante de pequenos e grandes. Não prego nada mais do que os Profetas e Moisés disseram que havia de acontecer,"
,"23":"isto é, que o Messias devia sofrer e que, sendo o primeiro a ressuscitar dentre os mortos, Ele devia anunciar a luz ao povo e aos pagãos»."
,"24":"Paulo estava assim a falar em sua defesa, quando Festo o interrompeu em alta voz: «Estás a ficar louco, Paulo. Todo esse teu saber leva-te à loucura!»"
,"25":"Mas Paulo respondeu: «Não estou louco, excelentíssimo Festo, mas digo palavras verdadeiras e sensatas."
,"26":"O próprio rei, a quem me dirijo com toda a coragem, certamente está a par destas coisas. Acredito que nada disto lhe é desconhecido, porque estas coisas não aconteceram num lugar distante."
,"27":"Rei Agripa, acreditas nos Profetas? Eu sei que acreditas»."
,"28":"Então Agripa disse a Paulo: «Ainda um pouco, e convences-me a tornar-me cristão!»"
,"29":"Paulo respondeu: «Ainda um pouco ou ainda muito, tomara que Deus fizesse que não somente tu, mas todos os que me escutam hoje, se tornassem como eu, mas sem estas correntes!»"
,"30":"O rei levantou-se, e com ele o governador, Berenice e todos os que tomavam parte na sessão."
,"31":"Enquanto saíam, conversavam e diziam: «Um homem como este não pode ter feito nada que mereça a morte ou a prisão»."
,"32":"E Agripa disse a Festo: «Este homem bem podia ser posto em liberdade, se não tivesse apelado para César»."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Quando foi decidido que embarcaríamos para a Itália, Paulo e alguns outros prisioneiros foram entregues a um centurião chamado Júlio, da coorte Augusta."
,"2":"Embarcámos num navio de Adramítio, que ia partir para as costas da Ásia, e começámos a viagem. Estava connosco Aristarco, macedónio de Tessalónica."
,"3":"No dia seguinte, fizemos escala em Sidónia. Tratando Paulo com humanidade, Júlio permitiu que ele fosse ter com os amigos para deles receber assistência."
,"4":"Partindo dali, navegámos rente à ilha de Chipre, pois os ventos eram contrários."
,"5":"Tendo atravessado o mar ao longo da Cilícia e da Panfília, depois de quinze dias, desembarcámos em Mira, na Lícia."
,"6":"Lá o centurião encontrou um navio de Alexandria que estava de partida para a Itália e transferiu-nos para ele."
,"7":"Durante vários dias, navegámos lentamente e chegámos com dificuldade à altura de Cnido. Como o vento era contrário, navegámos rente à ilha de Creta, junto ao cabo Salmone."
,"8":"Costeando a ilha com dificuldade, chegámos a um lugar chamado Bons Portos, perto da cidade de Lasaia."
,"9":"Transcorrido muito tempo, a viagem estava a tornar-se perigosa, porque o Jejum já havia passado. Então Paulo advertiu:"
,"10":"«Amigos, vejo que a viagem está a ponto de acabar, com muito dano e prejuízo, não só da carga e do navio, mas também das nossas vidas»."
,"11":"Mas o centurião acreditou mais no piloto e no armador do que em Paulo."
,"12":"Aliás, o porto não era propício para passar o Inverno. A maioria foi de opinião que se devia partir dali e tentar chegar até Fénix. Este é um porto de Creta, ao abrigo dos ventos Noroeste e Sudoeste. Ali poderiam passar o Inverno."
,"13":"Quando o vento Sul começou a soprar levemente, pensaram que poderiam realizar o que haviam projectado. Levantaram âncoras e foram costeando Creta mais de perto."
,"14":"Pouco depois, desencadeou-se do lado da ilha um furacão chamado Euroaquilão."
,"15":"Incapaz de resistir ao vento, o navio foi arrastado violentamente e ficámos sem direcção."
,"16":"Passando rente a uma pequena ilha chamada Cauda, com dificuldade conseguimos recolher o bote."
,"17":"Após tê-lo içado, os tripulantes usaram os recursos de emergência, amarrando o navio com cordas de segurança. Contudo, temendo encalhar em Sirte, soltaram a âncora e continuaram sem direcção."
,"18":"No dia seguinte, batidos furiosamente pela tempestade, começaram a lançar a carga ao mar."
,"19":"No terceiro dia, com as próprias mãos lançaram ao mar até o equipamento do navio."
,"20":"Por vários dias, não vimos nem o sol, nem as estrelas, e a tempestade continuava a bater fortemente. Por fim perdemos toda a esperança de salvação."
,"21":"Havia já muito tempo que ninguém comia. Então Paulo pôs-se de pé no meio deles e disse: «Amigos, se me tivésseis escutado e não tivésseis saído de Creta, teríamos evitado este perigo e este prejuízo."
,"22":"Apesar disso, aconselho que sejais corajosos, porque ninguém de vós vai morrer: só o navio se vai perder."
,"23":"Esta noite apareceu-me um anjo do Deus ao qual pertenço e a quem adoro."
,"24":"O anjo disse-me: 'Não tenhas medo, Paulo. Deves comparecer diante de César. E Deus concede-te a vida de todos os teus companheiros de viagem'."
,"25":"Portanto, coragem, amigos! Confio em Deus que as coisas acontecerão como me foi dito."
,"26":"Entretanto, devemos encalhar em alguma ilha»."
,"27":"Havia já catorze noites que éramos lançados de um lado para outro no mar Adriático, quando, aí pela meia-noite, os marinheiros viram sinal de terra."
,"28":"Então lançaram a sonda e deu trinta e seis metros de profundidade; um pouco mais adiante, lançaram de novo a sonda e deu vinte e sete metros."
,"29":"Com medo de que o navio batesse em rochas, eles desceram quatro âncoras do lado de trás do navio e esperavam ansiosamente que o dia surgisse."
,"30":"Entretanto, os marinheiros tentavam fugir do navio. Com o pretexto de irem largar as âncoras do lado dianteiro, deitaram o bote ao mar."
,"31":"Então Paulo disse ao centurião e aos soldados: «Se eles não ficarem no navio, não podereis salvar-vos»."
,"32":"Então os soldados cortaram as cordas do bote e deixaram-no cair."
,"33":"Esperando que amanhecesse, Paulo insistia que todos comessem. E dizia: «Já há catorze dias que esperais, em jejum, sem comer nada."
,"34":"Aconselho-vos que vos alimenteis, porque é necessário para a saúde. Pois não vai perder-se nenhum cabelo da vossa cabeça»."
,"35":"Dizendo isto, Paulo tomou o pão, deu graças a Deus diante de todos, partiu-o e começou a comer."
,"36":"Então reanimaram-se e alimentaram-se."
,"37":"No navio éramos ao todo duzentas e setenta e seis pessoas."
,"38":"Depois de comerem com fartura, lançaram o trigo ao mar, aliviando assim o navio."
,"39":"Quando amanheceu, os marinheiros não reconheceram a terra. Vendo uma enseada com uma praia, conversaram para ver se poderiam conduzir o navio até lá."
,"40":"Soltaram as âncoras, deixando o navio ao movimento do mar. Ao mesmo tempo, desamarraram as cordas dos lemes, levantaram a vela da frente e dirigiram o navio para a praia."
,"41":"Mas o navio foi de encontro a um banco de areia e encalhou. A parte dianteira, atolada, ficou imóvel, mas a parte traseira começou a desconjuntar-se pela violência das ondas."
,"42":"Então, os soldados decidiram matar os prisioneiros, para evitar que alguns deles escapassem a nado."
,"43":"Mas o oficial romano, querendo salvar Paulo, não aceitou a ideia. Mandou aos que sabiam nadar que saltassem primeiro e alcançassem a terra."
,"44":"Depois mandou que os outros fossem atrás, agarrados em pranchas ou em qualquer pedaço do navio. Assim todos chegaram a terra, sãos e salvos."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Estando já a salvo, soubemos que a ilha se chamava Malta."
,"2":"Os nativos trataram-nos com extraordinária bondade. Acolheram-nos a todos ao redor de uma grande fogueira que tinham aceso, pois estava a chover e fazia frio."
,"3":"Paulo recolhera um feixe de lenha seca e estava a lançá-la na fogueira. Então uma cobra, fugindo do calor, saiu e enrolou-se na mão de Paulo."
,"4":"Vendo a cobra dependurada na sua mão, os nativos disseram: «Este homem certamente é um assassino: escapou do naufrágio, mas a justiça divina não o deixa viver»."
,"5":"Paulo, porém, sacudiu a cobra para dentro do fogo e não sentiu nada."
,"6":"Os nativos esperavam que ele inchasse e caísse morto de repente. Depois de esperarem muito tempo, e vendo que nada acontecia, mudaram de ideia e começaram a dizer que ele era um deus."
,"7":"Perto desse lugar ficava a propriedade do Chefe da ilha, que se chamava Públio. Ele recebeu-nos com gentileza e hospedou-nos durante três dias."
,"8":"O pai de Públio estava com febre e disenteria. Paulo foi visitá-lo, rezou, impôs as mãos sobre ele e curou-o."
,"9":"Depois disto, os doentes da ilha começaram a ir ao encontro de Paulo e eram curados."
,"10":"Demonstraram, então, muitos sinais de estima e, na altura da partida, proveram-nos de tudo o que precisávamos."
,"11":"Passados três meses, embarcámos num navio alexandrino, que passara o Inverno na ilha e que tinha os Dióscuros como emblema."
,"12":"Fizemos escala em Siracusa e aí permanecemos três dias."
,"13":"Em seguida, costeando, chegámos a Régio. No dia seguinte, levantou-se o vento sul e em dois dias chegámos a Putéoli."
,"14":"Ali encontrámos alguns irmãos que nos pediram para ficar com eles sete dias. Em seguida fomos para Roma."
,"15":"Os irmãos de Roma, prevenidos da nossa chegada, foram receber-nos no Foro Ápio e nas Três Tabernas. Ao vê-los, Paulo deu graças a Deus e sentiu-se encorajado."
,"16":"Quando entrámos em Roma, Paulo foi autorizado a morar em casa particular, sob a vigilância de um soldado."
,"17":"Três dias depois, Paulo convocou os chefes dos judeus. Quando estavam reunidos, disse-lhes: «Irmãos, eu não fiz nada contra o nosso povo, nem contra as tradições dos nossos antepassados. No entanto, vim de Jerusalém como prisioneiro, e assim fui entregue nas mãos dos romanos."
,"18":"Interrogado por eles no tribunal e não havendo nada em mim que merecesse a morte, queriam soltar-me."
,"19":"Mas os judeus opuseram-se e eu fui obrigado a apelar para César, sem nenhuma intenção de acusar a minha nação."
,"20":"É por isso que eu pedi para vos ver e para vos falar, pois estou acorrentado por causa da esperança de Israel»."
,"21":"Então eles disseram a Paulo: «Nós não recebemos da Judeia carta alguma a teu respeito, e nenhum dos irmãos que aqui chegaram relatou qualquer mal de ti."
,"22":"No entanto, gostaríamos de ouvir da tua própria boca o que pensas, pois sabemos que a tua seita encontra oposição em toda a parte»."
,"23":"Então marcaram um dia e foram com mais gente para se encontrar com ele no seu alojamento. Desde o amanhecer até à tarde, Paulo fez uma exposição baseada na Lei de Moisés e nos Profetas, dando testemunho do Reino de Deus e procurando convencê-los a respeito de Jesus."
,"24":"Alguns aceitaram o que ele dizia, mas outros não quiseram acreditar."
,"25":"Houve, assim, discordância entre eles. Enquanto iam saindo, Paulo disse: «Bem falou o Espírito Santo aos vossos antepassados por meio do profeta Isaías:"
,"26":"'Vai ter com esse povo e diz-lhe: Ouvireis mas não compreendereis; olhareis mas não vereis."
,"27":"O coração deste povo está endurecido. Taparam os ouvidos e fecharam os olhos, para que não vejam com os olhos, nem ouçam com os ouvidos, e não entendam com o coração, nem se convertam e Eu não os cure!'"
,"28":"Pois então, ficai agora sabendo: esta salvação de Deus é enviada aos pagãos, e eles hão-de escutá-la»."
,"30":"Paulo morou dois anos numa casa alugada, vivendo às custas do seu próprio trabalho. Recebia todos os que o procuravam,"
,"31":"pregando o Reino de Deus. Com toda a coragem e sem obstáculos, ensinava as coisas que se referiam ao Senhor Jesus Cristo."
}`)

}
func PT_BS_LoadNTAIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Esta é a revelação de Jesus Cristo, que Deus Lhe concedeu para mostrar aos seus servos as coisas que devem acontecer muito em breve. Deus enviou ao seu servo João o Anjo, que lhe mostrou estas coisas através de sinais."
,"2":"João testemunha que tudo quanto viu é Palavra de Deus e Testemunho de Jesus Cristo."
,"3":"Feliz aquele que lê e aqueles que escutam as palavras desta profecia, se praticarem o que nela está escrito. Pois o tempo está próximo."
,"4":"João às sete Igrejas que estão na região da Ásia. Desejo-vos a graça e a paz da parte d'Aquele que é, que era e que vem; da parte dos sete Espíritos que estão diante do trono de Deus;"
,"5":"e da parte de Jesus Cristo, a Testemunha fiel, o Primeiro a ressuscitar dos mortos, o Chefe dos reis da Terra. A Jesus, que nos ama e nos libertou dos nossos pecados por meio do seu sangue, "
,"6":"e nos fez reis e sacerdotes para Deus, seu Pai, - a Jesus, a glória e o poder para sempre. Ámen."
,"7":"Ele vem com as nuvens; e todos O verão, até mesmo aqueles que,O trespassaram. E todos os povos do mundo,baterão no peito por causa d'Ele. É isso mesmo! Assim seja!"
,"8":"Eu sou o Alfa e o Ómega, diz o Senhor Deus, Aquele que é, que era e que vem, o Deus todo-poderoso."
,"9":"Eu, João, vosso irmão e companheiro neste tempo de tribulação, na realeza e na perseverança em Jesus, estava exilado na ilha de Patmos, por causa da Palavra de Deus e do testemunho de Jesus."
,"10":"No dia do Senhor, o Espírito tomou conta de mim. E atrás de mim ouvi uma voz forte como trombeta, que dizia:"
,"11":"«Escreve em livro tudo o que vês. Depois, envia-o às sete Igrejas: Éfeso, Esmirna, Pérgamo, Tiatira, Sardes, Filadélfia e Laodiceia»."
,"12":"Virei-me para ver a voz que me falava. E vi sete candelabros de ouro."
,"13":"No meio dos candelabros estava Alguém: parecia um Filho de Homem, vestido de longa túnica; no peito, um cinto de ouro;"
,"14":"cabelos brancos como lã branca como a neve; os olhos pareciam uma chama de fogo;"
,"15":"os pés eram como bronze no forno, cor de brasa; a voz era como o ruído de águas torrenciais;"
,"16":"na mão direita tinha sete estrelas; da sua boca saía uma espada afiada de dois gumes; o seu rosto era como o Sol brilhante do meio-dia."
,"17":"Quando O vi, caí como morto a seus pés. Ele colocou a mão direita sobre mim e encorajou-me: «Não tenhas medo. Eu sou o Primeiro e o Último."
,"18":"Sou o Vivente. Estive morto, mas estou vivo para sempre. Tenho as chaves da morte e da morada dos mortos."
,"19":"Escreve o que viste: tanto as coisas presentes como as que devem acontecer depois delas."
,"20":"Queres saber o mistério das sete estrelas que viste na minha mão direita, e dos sete candelabros de ouro? As sete estrelas são os Anjos das sete Igrejas; e os sete candelabros são as sete Igrejas»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"«Escreve ao Anjo da Igreja de Éfeso. Assim diz Aquele que tem na mão direita as sete estrelas e que anda no meio dos sete candelabros de ouro:"
,"2":"Conheço a tua conduta, o teu esforço e a tua perseverança. Sei que não suportas os maus. Apareceram alguns dizendo que eram apóstolos. Puseste-os à prova e descobriste que não eram. Eram mentirosos."
,"3":"És perseverante. Sofreste por causa do meu Nome, e não desanimaste."
,"4":"Mas há uma coisa que te reprovo: abandonaste o teu primeiro amor."
,"5":"Presta atenção: repara onde caíste, converte-te e retoma o caminho de antes. Caso contrário, se não te converteres, irei ter contigo e arrancarei da posição em que está o candelabro que tens."
,"6":"Tens, porém, uma coisa boa: detestas a conduta dos nicolaítas. Também Eu a detesto."
,"7":"Quem tem ouvidos, ouça o que o Espírito diz às Igrejas. Ao vencedor, como prémio, dar-lhe-ei a comer da árvore da vida que está no paraíso de Deus»."
,"8":"«Escreve ao Anjo da Igreja de Esmirna. Assim diz o Primeiro e o Último, Aquele que esteve morto mas voltou à vida:"
,"9":"Conheço a tua tribulação e a tua pobreza. Mas és rico. Alguns que se dizem judeus andaram a blasfemar. Mas eles de facto não são judeus. Formam, sim, uma sinagoga de Satanás."
,"10":"Não tenhas medo do sofrimento que vai chegar. O diabo vai levar alguns de vós para a cadeia. Será para vós uma provação. Mas a tribulação não vai durar mais que dez dias. Sê fiel até à morte. Eu dar-te-ei como prémio a coroa da vida."
,"11":"Quem tem ouvidos, ouça o que o Espírito diz às Igrejas. O vencedor ficará livre da segunda morte»."
,"12":"«Escreve ao Anjo da Igreja de Pérgamo. Assim diz Aquele que tem a espada afiada de dois gumes:"
,"13":"Conheço o lugar onde moras, que é onde está o trono de Satanás. Manténs firme o meu Nome e não renegaste a fé, nem mesmo no tempo de Antipas. Ele era minha testemunha fiel, e foi morto no meio de vós, aí onde mora Satanás."
,"14":"Mas tens umas coisas que Eu reprovo: muita gente por aí segue a doutrina de Balaão, aquele que ensinava Balac a colocar pedras de tropeço no caminho do povo de Israel. Ele queria que os filhos de Israel comessem da carne oferecida aos ídolos. Queria que se prostituíssem."
,"15":"Muita gente por aí também vai atrás da doutrina dos nicolaítas."
,"16":"Vamos! Converte-te! Caso contrário, irei brevemente combater-vos com a espada da minha boca."
,"17":"Quem tem ouvidos, ouça o que o Espírito diz às Igrejas. Ao vencedor darei um prémio: o maná escondido. Darei também uma pedrinha branca a cada um. Nela está escrito um nome novo que ninguém conhece; só quem a recebe»."
,"18":"«Escreve ao Anjo da Igreja de Tiatira. Assim diz o Filho de Deus, que tem os olhos como chamas de fogo e os pés como bronze em brasa:"
,"19":"Conheço a tua conduta: o teu amor, a tua fé, a tua dedicação, a tua perseverança e as tuas obras mais recentes, ainda mais numerosas que as primeiras."
,"20":"Mas há uma coisa que te reprovo: nem sequer te incomodas com Jezabel, essa mulher que se diz profetisa. Ela ensina e seduz os meus servos a prostituírem-se e a comerem carne oferecida aos ídolos."
,"21":"Já lhe dei um prazo para ela se converter. Mas ela não quer largar a sua prostituição."
,"22":"Vou lançá-la num leito de doença, e aos que cometem adultério com ela vou lançá-los numa grande tribulação, a menos que se convertam da sua conduta."
,"23":"Farei também com que os seus filhos morram, para que as Igrejas fiquem a saber quem Eu sou: conheço bem, dentro de cada um, os rins e o coração; vou retribuir de acordo com a conduta de cada um."
,"24":"Sei que muitos de vós, em Tiatira, não seguem essa doutrina, não conhecem as 'profundezas de Satanás', como dizem eles. Sobre vós Eu não coloco outro peso."
,"25":"Mas ficai firmes com aquele que já tendes, até que Eu venha."
,"26":"Ao vencedor, ao que observar a minha conduta até ao fim, Eu lhe darei autoridade sobre as nações;"
,"27":"o vencedor guiará com ceptro de ferro, podendo quebrar as nações como vasos de barro."
,"28":"Pois também Eu recebi do Pai esse poder. Vou dar ao vencedor a Estrela da manhã."
,"29":"Quem tem ouvidos, ouça o que o Espírito diz às Igrejas»."
}`)
	CurrentBook.AddChapter(3, `{
"1":"«Escreve ao Anjo da Igreja de Sardes. Assim diz Aquele que tem os sete Espíritos de Deus e as sete estrelas: Conheço a tua conduta: tens fama de estares vivo, mas estás morto."
,"2":"Presta muita atenção em não deixares morrer o resto que ainda está vivo, pois acho que a tua conduta não é perfeita diante do meu Deus."
,"3":"Lembra-te de como recebeste e ouviste a Palavra. Pratica-a e converte-te! Se não vigiares, Eu virei como um ladrão. E não saberás a que hora virei."
,"4":"Sei que aí em Sardes existem algumas pessoas que não sujaram a roupa. Estas vão andar comigo, vestidas de branco, pois são pessoas dignas."
,"5":"O vencedor vestirá roupa branca. E o seu nome não será apagado do livro da vida. Faço questão de dizer o seu nome diante de meu Pai e dos seus anjos."
,"6":"Quem tem ouvidos, ouça o que o Espírito diz às Igrejas»."
,"7":"«Escreve ao Anjo da Igreja de Filadélfia. Assim diz o Santo, o Verdadeiro, Aquele que tem a chave de David, Aquele que abre e ninguém fecha, Aquele que fecha e ninguém mais abre:"
,"8":"Conheço a tua conduta; coloquei à tua frente uma porta aberta, que ninguém mais poderá fechar. Pois tens pouca força, mas guardaste a minha Palavra e não renegaste o meu Nome."
,"9":"Sei que existem por aí alguns que se dizem judeus; são mentirosos, da sinagoga de Satanás. Vou entregar-tos. Eles vão ter que ajoelhar a teus pés e reconhecer que te amo."
,"10":"Uma vez que guardaste a minha ordem para perseverar, Eu também te guardarei da hora da tentação. Essa hora virá sobre o mundo inteiro, para colocar à prova os habitantes da Terra."
,"11":"Eu venho em breve! Segura firmemente o que tens para que ninguém tome a tua coroa."
,"12":"Do vencedor, farei uma coluna no templo do meu Deus; e aí ficará firme para sempre. Gravarei nele o Nome do meu Deus; gravarei o nome da Cidade do meu Deus: 'A Nova Jerusalém, que desce do Céu, de junto do meu Deus'. Gravarei no vencedor o meu novo Nome."
,"13":"Quem tem ouvidos, ouça o que o Espírito diz às Igrejas»."
,"14":"«Escreve ao Anjo da Igreja de Laodiceia. Assim diz o Ámen, a Testemunha fiel e verdadeira, o Princípio da criação de Deus:"
,"15":"Conheço a tua conduta: não és frio nem quente. Quem dera que fosses frio ou quente!"
,"16":"Porque és morno, nem frio nem quente, estou quase a vomitar-te da minha boca."
,"17":"Porque dizes: 'Sou rico! E agora que sou rico, não preciso de mais nada'. Pois então escuta: és infeliz, miserável, pobre, cego e nu. E nem sabes disso."
,"18":"Queres um conselho? Queres mesmo ficar rico? Então compra o meu ouro, ouro puro, derretido no fogo. Queres vestir bem? Compra as minhas roupas brancas, para cobrir a vergonha da tua nudez. Queres ver? Pois Eu tenho o colírio para os teus olhos."
,"19":"Quanto a Mim, repreendo e educo todos aqueles que amo. Portanto, sê fervoroso e muda de vida!"
,"20":"Já estou à porta e bato. Quem ouvir a minha voz e abrir a porta, entro em sua casa e janto com ele, e ele comigo."
,"21":"Ao vencedor, darei um prémio: vai sentar-se comigo no meu trono, assim como Eu venci e estou sentado com meu Pai no seu trono."
,"22":"Quem tem ouvidos, ouça o que o Espírito diz às Igrejas»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Depois de escrever as cartas às Igrejas, eu, João, tive uma visão. Havia uma porta aberta no Céu, e a primeira voz, que eu tinha ouvido falar-me como trombeta, disse: «Sobe até aqui, para que te mostre as coisas que devem acontecer depois destas»."
,"2":"Imediatamente o Espírito tomou conta de mim. Havia no Céu um trono e, no trono, Alguém sentado."
,"3":"Aquele que estava sentado parecia uma pedra de jaspe e cornalina; um arco-íris envolvia o trono com reflexos de esmeralda."
,"4":"Ao redor desse trono havia outros vinte e quatro; e neles vinte e quatro Anciãos estavam sentados, todos eles vestidos de branco e com uma coroa de ouro na cabeça."
,"5":"Do trono saíam relâmpagos, vozes e trovões. Diante do trono estavam acesas sete lâmpadas de fogo, que são os sete Espíritos de Deus."
,"6":"Na frente do trono havia como que um mar de vidro, como cristal. No meio do trono e ao redor estavam quatro Seres vivos, cheios de olhos pela frente e por detrás."
,"7":"O primeiro Ser vivo parece um leão; o segundo parece um touro; o terceiro tem rosto de homem; o quarto parece uma águia em pleno voo."
,"8":"Cada um dos quatro Seres vivos tem seis asas e são cheios de olhos ao redor e por dentro. Dia e noite sem parar, eles proclamam: «Santo! Santo! Santo!,Senhor Deus todo-poderoso!,Aquele que é, que era e que há-de vir!»"
,"9":"Os Seres vivos dão glória, honra e acção de graças ao que está sentado no trono e que vive para sempre."
,"10":"E todas as vezes que os Seres vivos fazem isso, os vinte e quatro Anciãos ajoelham-se diante d'Aquele que está sentado no trono, para adorar Aquele que vive para sempre. Cada Ancião tira a coroa da cabeça e coloca-a diante do trono de Deus. E todos eles proclamam:"
,"11":"«Senhor, nosso Deus, Tu és digno,de receber a glória, a honra e o poder. Porque criaste todas as coisas. Pela tua vontade elas começaram,a existir e foram criadas»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Vi depois um livro na mão direita d'Aquele que estava sentado no trono. Era um livro escrito por dentro e por fora e estava lacrado com sete selos."
,"2":"Vi então um Anjo forte que proclamava em alta voz: «Quem é capaz de romper os selos e de abrir o livro?»"
,"3":"Ninguém, nem no Céu, nem na Terra, nem no mundo dos mortos, era capaz de abrir o livro ou de ler o que nele estava escrito."
,"4":"Eu chorava muito, porque ninguém foi considerado capaz de abrir ou de ler o livro."
,"5":"Um dos Anciãos consolou-me: «Não chores! O Leão da tribo de Judá, o Rebento de David venceu! Ele é capaz de romper os selos e abrir o livro»."
,"6":"De facto, vi um Cordeiro. Estava entre o trono com os quatro Seres vivos e os Anciãos. Estava de pé, como que imolado. O Cordeiro tinha sete chifres e sete olhos, que são os sete Espíritos de Deus enviados por toda a Terra."
,"7":"Então, o Cordeiro veio receber o livro da mão direita d'Aquele que está sentado no trono."
,"8":"Quando Ele recebeu o livro, os quatro Seres vivos e os vinte e quatro Anciãos ajoelharam-se diante do Cordeiro. Cada um tinha uma harpa e taças de ouro cheias de incenso, que são as orações dos santos."
,"9":"E entoaram um canto novo: «Tu és digno de receber o livro e abrir os seus selos, porque foste imolado, e com o teu sangue adquiriste,para Deus homens de toda a tribo, língua, povo e nação."
,"10":"Deles fizeste para o nosso Deus,um reino de sacerdotes. E eles reinarão sobre a Terra»."
,"11":"Na minha visão, ouvi ainda o clamor de uma multidão de anjos em volta do trono, dos Seres vivos e dos Anciãos. Eram milhões e milhões e milhares de milhares,"
,"12":"que proclamavam em alta voz: «O Cordeiro imolado é digno,de receber o poder, a riqueza, a sabedoria, a força, a honra, a glória e o louvor»."
,"13":"Nesse momento, todas as criaturas do Céu, da Terra, de debaixo da Terra e do mar, todos os seres vivos proclamaram: «O louvor, a honra, a glória e o poder pertencem,Àquele que está sentado no trono,e ao Cordeiro,pelos séculos dos séculos»."
,"14":"Os quatro Seres vivos diziam: «Ámen!» E os Anciãos ajoelharam-se e adoraram."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Vi quando o Cordeiro abriu o primeiro dos sete selos. E ouvi o primeiro dos quatro Seres vivos falar com uma voz de trovão: «Vem!»"
,"2":"Olhei e vi um cavalo branco. O cavaleiro tinha um arco, e deram-lhe uma coroa. Ele partiu, vitorioso e para vencer ainda mais."
,"3":"Vi quando o Cordeiro abriu o segundo selo. E ouvi o segundo Ser vivo dizer: «Vem!»"
,"4":"Apareceu então outro cavalo, era vermelho. O seu cavaleiro recebeu poder para tirar a paz da terra, a fim de os homens se matarem uns aos outros. E entregaram-lhe uma grande espada."
,"5":"Vi quando o Cordeiro abriu o terceiro selo. E ouvi o terceiro Ser vivo dizer: «Vem!» Apareceu então um cavalo preto. O cavaleiro tinha na mão uma balança."
,"6":"Ouvi uma voz que vinha do meio dos quatro Seres vivos, e dizia: «Um quilo de trigo por um dia de trabalho! Três quilos de cevada por um dia de trabalho! Não danifiqueis o azeite e o vinho»."
,"7":"Vi quando o Cordeiro abriu o quarto selo. E ouvi o quarto Ser vivo dizer: «Vem!»"
,"8":"Vi aparecer um cavalo esverdeado. O seu cavaleiro era a Morte. E vinha acompanhado pelo mundo dos mortos. Deram-lhe poder sobre a quarta parte da Terra, para que matasse pela espada, pela fome, pela peste e pelas feras da Terra."
,"9":"Quando o Cordeiro abriu o quinto selo, vi debaixo do altar as vidas daqueles que tinham sido imolados por causa da Palavra de Deus e por causa do testemunho que dela tinham dado."
,"10":"Eles gritaram em alta voz: «Senhor santo e verdadeiro, até quando tardarás em fazer justiça, vingando o nosso sangue,contra os habitantes da Terra?»"
,"11":"Então foi dada a cada um deles uma veste branca. Também lhes foi dito que descansassem ainda algum tempo, até que ficasse completo o número dos seus companheiros e irmãos que iriam ser mortos como eles."
,"12":"Vi quando o Cordeiro abriu o sexto selo. Houve, então, um grande terremoto. O Sol ficou negro como saco de carvão. A Lua inteira, cor de sangue."
,"13":"As estrelas do céu caíram sobre a Terra, como figueiras soltando figos verdes quando sacudidas por um vento forte."
,"14":"O céu enrolou-se como uma folha de pergaminho. Todas as montanhas e ilhas foram arrancadas do lugar."
,"15":"Os reis da terra, os magnatas, os capitães, os ricos e os poderosos, todos, escravos e homens livres, esconderam-se nas cavernas e rochedos das montanhas,"
,"16":"clamando aos montes e pedras: «Caí sobre nós e escondei-nos da Face d'Aquele que está no trono, e da ira do Cordeiro."
,"17":"Pois chegou o grande Dia da sua ira. E quem poderá ficar de pé?»"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Depois disto vi quatro Anjos, um em cada canto da Terra. Eles seguravam os quatro ventos da Terra. Assim, o vento não podia soprar na Terra, nem no mar, nem nas árvores."
,"2":"Vi também outro Anjo que vinha do Oriente, trazendo o selo do Deus vivo. Ele gritou em alta voz aos quatro Anjos, que tinham sido encarregados de fazer mal à Terra e ao mar:"
,"3":"«Não prejudiqueis a Terra, nem o mar, nem as árvores! Primeiro vamos marcar a fronte dos servos do nosso Deus»."
,"4":"Ouvi então o número dos que receberam a marca: cento e quarenta e quatro mil, de todas as tribos do povo de Israel."
,"5":"Foram marcados doze mil da tribo de Judá; doze mil da tribo de Rúben; doze mil da tribo de Gad;"
,"6":"doze mil da tribo de Aser; doze mil da tribo de Neftali; doze mil da tribo de Manassés;"
,"7":"doze mil da tribo de Simeão; doze mil da tribo de Levi; doze mil da tribo de Issacar;"
,"8":"doze mil da tribo de Zabulão; doze mil da tribo de José; doze mil da tribo de Benjamim."
,"9":"Depois disto vi uma grande multidão, que ninguém podia contar: gente de todas as nações, tribos, povos e línguas. Estavam todos de pé diante do trono e diante do Cordeiro. Vestiam vestes brancas e traziam palmas na mão."
,"10":"Em alta voz, a multidão proclamava: «A salvação pertence ao nosso Deus, que está sentado no trono, e ao Cordeiro»."
,"11":"Todos os Anjos que estavam ao redor do trono, dos Anciãos e dos quatro Seres vivos, ajoelharam-se diante do trono para adorar a Deus."
,"12":"E diziam: «Ámen! O louvor, a glória, a sabedoria, a acção de graças, a honra, o poder e a força,pertencem ao nosso Deus, para sempre. Ámen!»"
,"13":"Um dos Anciãos tomou a palavra e perguntou-me: «Sabes quem são e de onde vieram os que estão vestidos com roupas brancas?»"
,"14":"Eu respondi: «Não sei não, Senhor! Vós é que o sabeis!» Ele então explicou-me: «São os que vieram da grande tribulação. Eles lavaram e branquearam as suas roupas no sangue do Cordeiro."
,"15":"É por isso que ficam diante do trono de Deus, servindo-O dia e noite no seu Templo. Aquele que está sentado no trono abrigá-los-á na sua tenda."
,"16":"Nunca mais terão fome, nem sede; nunca mais serão queimados pelo sol, nem pelo calor ardente."
,"17":"Pois o Cordeiro que está no meio do trono será seu pastor; vai conduzi-los até às fontes de água da vida. E Deus enxugar-lhes-á toda a lágrima dos olhos»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quando o Cordeiro abriu o sétimo selo, houve no Céu um silêncio de meia hora..."
,"2":"Vi então os sete Anjos que estão diante de Deus. Eles receberam sete trombetas."
,"3":"E outro Anjo colocou-se perto do altar: tinha nas mãos um turíbulo de ouro. Ele recebeu uma grande quantidade de incenso para ser oferecido, juntamente com as orações de todos os santos, sobre o altar de ouro que está diante do trono."
,"4":"Da mão do Anjo subia até Deus o fumo do incenso com as orações dos santos."
,"5":"Depois, o Anjo pegou no turíbulo e encheu-o com o fogo do altar e lançou-o sobre a terra. Houve então trovões, clamores, relâmpagos e grandes terremotos."
,"6":"E os sete Anjos com as sete trombetas prepararam-se para tocar."
,"7":"O primeiro Anjo tocou. Caiu então sobre a Terra granizo e fogo, misturados com sangue. A terça parte da terra queimou-se. A terça parte das árvores queimou-se. O que existia de verde queimou-se."
,"8":"O segundo Anjo tocou. Foi lançada ao mar uma coisa parecida com uma grande montanha em brasa. A terça parte do mar foi transformada em sangue."
,"9":"A terça parte das criaturas do mar morreu. A terça parte dos navios foi destruída."
,"10":"O terceiro Anjo tocou. Caiu do céu uma grande estrela, ardendo como tocha acesa. Caiu sobre a terça parte dos rios e sobre as fontes."
,"11":"O nome dessa estrela é «Amargura». A terça parte da água ficou amarga. Muita gente morreu por causa da água, porque ficou amarga."
,"12":"O quarto Anjo tocou. Atingiu um terço do Sol, um terço da Lua e um terço das estrelas, de modo que ofuscou a terça parte deles. O dia perdeu a terça parte da claridade. E a noite também."
,"13":"Vi e ouvi uma Águia que voava no mais alto do céu, dizendo em alta voz: «Ai! Ai! Ai dos que vivem na Terra! Ainda faltam três toques de trombeta. E os Anjos estão prontos para tocar»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"O quinto Anjo tocou. Vi então uma estrela que tinha caído do Céu sobre a Terra. Ela recebeu a chave do poço do Abismo."
,"2":"E abriu o poço do Abismo e dele subiu uma fumarada como a de uma grande fornalha. O Sol e o ar escureceram com a fumarada do poço."
,"3":"Da fumarada saíram gafanhotos que voaram sobre a Terra. Tinham poder de matar como os escorpiões."
,"4":"Receberam ordem de não estragar a vegetação da Terra, nem o verde, nem as árvores. Só podiam ferir os homens que não tivessem na fronte a marca de Deus."
,"5":"Os gafanhotos não tinham permissão de matar. Mas podiam atormentar os homens durante cinco meses, com dores fortes, como picadas de escorpião."
,"6":"Naqueles dias, os homens vão correr em busca da morte, mas não saberão onde ela está. Vão querer a morte, mas a morte fugirá deles."
,"7":"Os gafanhotos pareciam cavalos aparelhados para a guerra; parecia que tinham na cabeça coroas de ouro, e os seus rostos pareciam rostos humanos."
,"8":"Tinham cabelos compridos como as mulheres, e dentes de leão."
,"9":"Tinham couraças que pareciam de ferro, e o barulho das suas asas parecia o barulho de carros com muitos cavalos, correndo para a batalha."
,"10":"Tinham ferrão na cauda, como os escorpiões. E era na cauda que estava o poder de atormentar os homens durante cinco meses."
,"11":"O seu rei era o Anjo do Abismo. O nome desse Anjo é Abadon, na língua hebraica; em grego é Apolion."
,"12":"O primeiro Ai passou. Mas depois destas coisas ainda vêm outros dois Ais."
,"13":"O sexto Anjo tocou. Ouvi então uma voz que vinha dos quatro chifres do altar de ouro que estava colocado diante de Deus."
,"14":"A voz dizia ao sexto Anjo que estava com a trombeta: «Liberta os quatro Anjos que estão presos no grande rio Eufrates»."
,"15":"E os quatro Anjos que estavam prontos para a hora, o dia, o mês e o ano foram então libertados para matar a terça parte dos homens."
,"16":"O número dos cavaleiros do exército dos quatro Anjos era de duzentos milhões. Ouvi bem o número."
,"17":"Na minha visão, os cavalos e cavaleiros eram assim: vestiam couraça cor de fogo, jacinto e enxofre. A cabeça dos cavalos parecia de leão, e da sua boca saía fogo, fumo e enxofre."
,"18":"A terça parte dos homens morreu por causa destas pragas: o fogo, o fumo e o enxofre que saíam da boca dos cavalos."
,"19":"De facto, o poder desses cavalos está na boca e na cauda. As suas caudas parecem cobras: têm cabeças e com elas causam dano."
,"20":"Os outros homens que não foram mortos por estas pragas, nem mesmo assim renunciaram às obras das suas mãos. Não deixaram de adorar os demónios, os ídolos de ouro, prata, bronze, pedra e madeira, que não podem ver, nem ouvir, nem andar."
,"21":"Também não se converteram dos seus homicídios, magias, devassidões e roubos."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Depois disto, vi outro Anjo. Era forte e vinha descendo do Céu envolvido numa nuvem, e sobre a sua cabeça estava o arco-íris. O rosto era como o Sol; as pernas pareciam colunas de fogo."
,"2":"Tinha na mão um livrinho aberto. Colocou o pé direito sobre o mar e o esquerdo sobre a Terra,"
,"3":"e soltou um forte grito como um leão que ruge. Quando ele gritou, os sete trovões ribombaram."
,"4":"E quando os sete trovões fizeram esse ribombo, eu estava pronto para escrever. Mas ouvi uma voz do céu que me dizia: «Guarda em segredo o que os sete trovões disseram. Não escrevas nada»."
,"5":"Então o Anjo forte, que estava de pé sobre o mar e a Terra, levantou a mão direita para o Céu."
,"6":"E jurou por Aquele que vive para sempre, que criou o Céu e tudo o que nele existe, a Terra e tudo o que nela existe, o mar e tudo o que nele existe: «Já não há mais tempo."
,"7":"Quando o sétimo Anjo tocar a trombeta, então vai realizar-se o mistério de Deus, conforme Ele anunciou aos seus servos, os profetas!»"
,"8":"Aquela mesma voz do Céu, que eu já tinha ouvido, tornou a falar comigo: «Vai. Toma o livrinho aberto da mão do Anjo que está de pé sobre o mar e sobre a Terra»."
,"9":"Eu fui, e pedi ao Anjo que me entregasse o livrinho. Ele disse-me: «Toma, come-o. Será amargo no estômago, mas na boca será doce como mel»."
,"10":"Tomei o livrinho da mão do Anjo e comi-o. Na boca era doce como mel, mas quando o engoli, o meu estômago ficou cheio de amargura."
,"11":"Então disseram-me: «Ainda tens que profetizar contra muitos povos, nações, línguas e reis»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Depois disto, deram-me um bastão parecido com uma vara e disseram-me: «Levanta-te e mede o Templo de Deus, o altar e os que lá estão em adoração."
,"2":"Deixa de lado o pátio externo do Templo; não precisas de medi-lo; pois o pátio foi entregue ao poder das nações; elas vão pisar a Cidade Santa durante quarenta e dois meses."
,"3":"Mas vou permitir que as minhas duas testemunhas possam profetizar, vestidas de saco, durante mil duzentos e sessenta dias»."
,"4":"Essas duas testemunhas são as duas oliveiras e os dois candelabros que estão diante do Senhor da Terra."
,"5":"Se alguém quiser prejudicá-las, um fogo sairá da sua boca e devorará os seus inimigos. Sim, se alguém quiser prejudicá-las, é assim que vai morrer."
,"6":"Elas têm o poder de fechar o Céu, para que não caia nenhuma chuva enquanto durar a sua missão profética. Elas têm também o poder de transformar as águas em sangue. E quantas vezes elas quiserem, podem ferir a Terra com toda a espécie de pragas."
,"7":"Quando terminarem o seu testemunho, a Besta que sobe do Abismo vai combater contra elas, vai vencê-las e matá-las."
,"8":"E os cadáveres das duas testemunhas vão ficar expostos na praça da Grande Cidade. Esta cidade chama-se simbolicamente Sodoma e Egipto, onde o seu Senhor também foi crucificado."
,"9":"Gente de todos os povos, raças, línguas e nações vêem os seus cadáveres durante três dias e meio. E não deixam que os corpos sejam sepultados."
,"10":"Os habitantes da Terra fazem festa pela morte das testemunhas, ficam alegres e trocam presentes, porque estes dois profetas haviam incomodado os habitantes da Terra."
,"11":"Depois dos três dias e meio, um sopro de vida veio de Deus e penetrou nos dois profetas. E eles ficaram de pé. Todos aqueles que os contemplavam ficaram com muito medo."
,"12":"Ouvi então uma voz forte vinda do Céu que lhes dizia: «Subi para aqui!» Eles subiram ao Céu numa nuvem, à vista dos inimigos."
,"13":"Naquela mesma hora aconteceu um grande terremoto. A décima parte da cidade desmoronou-se, e sete mil pessoas morreram no desastre. Os sobreviventes ficaram apavorados e deram glória ao Deus do Céu."
,"14":"Passou o segundo Ai. E o terceiro virá em breve."
,"15":"O sétimo Anjo tocou a trombeta. E vozes bem fortes começaram a gritar no Céu: «A realeza do mundo,passou agora para Nosso Senhor,e para o seu Cristo. E Cristo vai reinar para sempre»."
,"16":"Os vinte e quatro Anciãos que estão sentados nos seus tronos diante de Deus ajoelharam-se e adoraram a Deus. Eles diziam:"
,"17":"«Nós Te damos graças, Senhor Deus todo-poderoso, Aquele que é e Aquele que era. Porque assumiste,o teu grande poder,e passaste a reinar."
,"18":"As nações tinham-se enfurecido, mas chegou a tua ira,e o tempo de julgar os mortos, de dar recompensa,aos teus servos, os profetas, aos santos e aos que temem,o teu Nome, pequenos e grandes, e o tempo de destruir,os que destroem a Terra»."
,"19":"Abriu-se então o Templo de Deus que está no Céu e apareceu no Templo a arca da aliança. Houve relâmpagos, vozes, trovões, terremotos e uma grande tempestade de granizo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Apareceu no céu um grande sinal: uma Mulher vestida com o Sol, tendo a Lua debaixo dos pés, e sobre a cabeça uma coroa de doze estrelas."
,"2":"Estava grávida e gritava, entre as dores do parto, atormentada para dar à luz."
,"3":"Apareceu então outro sinal no céu: um grande Dragão, cor de fogo. Tinha sete cabeças e dez chifres. Sobre as cabeças sete coroas."
,"4":"Com a cauda varria a terça parte das estrelas do céu, lançando-as sobre a Terra. O Dragão colocou-se diante da Mulher que estava para dar à luz, pronto para Lhe devorar o Filho, logo que Ele nascesse."
,"5":"Nasceu o Filho da Mulher. Era menino homem. Nasceu para governar todas as nações com ceptro de ferro. Mas o Filho foi levado para junto de Deus e do seu trono."
,"6":"A Mulher fugiu para o deserto onde Deus Lhe tinha preparado um lugar para ali ser alimentada durante mil duzentos e sessenta dias."
,"7":"Travou-se então uma batalha no Céu: Miguel e os seus Anjos guerrearam contra o Dragão."
,"8":"O Dragão batalhou juntamente com os seus Anjos, mas foi derrotado, e no Céu não houve mais lugar para eles."
,"9":"Esse grande Dragão é a antiga Serpente, é o chamado Diabo ou Satanás. É aquele que seduz todos os habitantes da terra. O Dragão foi expulso para a Terra, e os Anjos do Dragão foram expulsos com ele."
,"10":"Ouvi, então, uma voz forte no Céu, proclamando: «Agora realizou-se a salvação, o poder e a realeza do nosso Deus,e a autoridade do seu Cristo. Porque foi expulso o acusador,dos nossos irmãos, aquele que os acusava dia e noite,diante do nosso Deus."
,"11":"Eles, porém, venceram o Dragão,pelo sangue do Cordeiro,e pela palavra do testemunho,que deram, pois diante da morte,desprezaram a própria vida."
,"12":"Por isso, alegrai-vos, ó Céus. Alegrem-se os que neles vivem. Mas, ai da Terra e do mar, porque o Diabo desceu sobre vós. Ele está cheio de grande furor, sabendo que lhe resta pouco tempo»."
,"13":"Quando viu que tinha sido expulso para a Terra, o Dragão começou a perseguir a Mulher, Aquela que tinha dado à luz um menino varão."
,"14":"Mas a Mulher recebeu as duas asas da grande águia e voou para o deserto, para um lugar bem longe da Serpente. Aí, a Mulher é alimentada por um tempo, dois tempos e meio tempo."
,"15":"A Serpente não desistiu: vomitou um rio de água atrás da Mulher, para que Ela se afogasse."
,"16":"Mas a Terra socorreu a Mulher: abriu a boca e engoliu o rio que o Dragão tinha vomitado."
,"17":"Cheio de raiva por causa da Mulher, o Dragão começou então a atacar o resto dos seus filhos, os que obedecem aos mandamentos de Deus e mantêm o testemunho de Jesus."
,"18":"Depois o Dragão ficou de pé na praia do mar."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Vi, então, uma Besta que subia do mar. Tinha dez chifres e sete cabeças. Em cima dos chifres havia dez coroas, e nomes blasfemos sobre as cabeças."
,"2":"A Besta que eu vi parecia uma pantera. As patas eram de urso e a boca era de leão. O Dragão entregou à Besta o seu poder, o seu trono e uma grande autoridade."
,"3":"Uma das cabeças da Besta parecia ferida de morte, mas a ferida mortal foi curada. A terra inteira encheu-se de admiração e seguiu a Besta,"
,"4":"e adorou o Dragão por ter entregue a autoridade à Besta. E adoraram também a Besta, dizendo: «Quem é como a Besta? E quem pode lutar contra ela?»"
,"5":"A Besta recebeu uma boca para dizer insolências e blasfémias. Recebeu também poder para agir durante quarenta e dois meses."
,"6":"Então a Besta abriu a boca em blasfémias contra Deus, blasfemando contra o seu Nome e a sua morada santa e contra os que moram no Céu."
,"7":"Foi-lhe permitido guerrear contra os santos e vencê-los. Recebeu autoridade sobre toda a tribo, povo, língua e nação."
,"8":"Então todos os habitantes da terra adoraram a Besta. Mas os seus nomes não estão escritos desde a criação do mundo no livro da vida do Cordeiro imolado."
,"9":"Se alguém tem ouvidos, ouça:"
,"10":"Se alguém está destinado à prisão, irá para a prisão. Se alguém deve morrer pela espada, é pela espada que deve morrer. Aqui se fundamenta a perseverança e a fé dos santos."
,"11":"Depois disto, vi outra Besta sair da Terra. Tinha dois chifres semelhantes aos de um cordeiro, mas falava como dragão."
,"12":"Esta segunda Besta exerce toda a autoridade na presença da primeira Besta. Ela faz com que a Terra e seus habitantes adorem a primeira Besta, cuja ferida mortal tinha sido curada."
,"13":"A segunda Besta opera grandes maravilhas: faz cair fogo do Céu sobre a Terra, à vista dos homens."
,"14":"Por causa do poder de fazer essas maravilhas, sempre na presença da primeira Besta, a segunda Besta acaba por seduzir os habitantes da Terra. Ela seduz a humanidade a fazer uma imagem em honra da Besta que tinha sido ferida pela espada, mas que voltou à vida."
,"15":"Foi-lhe permitido até mesmo infundir espírito na imagem da primeira Besta, de modo que esta pudesse falar e fazer com que morressem todos os que não adorassem a imagem da primeira Besta."
,"16":"A segunda Besta faz também com que todos, pequenos e grandes, ricos e pobres, livres e escravos, recebam uma marca na mão direita ou na fronte."
,"17":"E ninguém pode comprar nem vender se não tiver a marca, o nome da Besta ou o número do seu nome."
,"18":"Aqui é preciso entender: quem é esperto, calcule o número da Besta; é um número de homem; o número é seiscentos e sessenta e seis."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Depois disto, tive esta visão: o Cordeiro estava de pé sobre o monte Sião. Com Ele, os cento e quarenta e quatro mil que traziam a fronte marcada com o seu nome e o nome de seu Pai."
,"2":"Ouvi uma voz que vinha do Céu; parecia o barulho de águas torrenciais e o estrondo de um forte trovão. O barulho que ouvi era como o som de músicos a tocar harpa."
,"3":"Estavam diante do trono, dos quatro Seres vivos e dos Anciãos e cantavam um cântico novo. Era um cântico que ninguém podia aprender; só os cento e quarenta e quatro mil marcados que foram resgatados da Terra."
,"4":"São os que não se contaminaram com mulheres; são virgens. Eles seguem o Cordeiro por onde quer que Ele vá. Foram resgatados do meio dos homens e foram os primeiros a serem oferecidos a Deus e ao Cordeiro."
,"5":"Na sua boca nunca foi encontrada a mentira. São íntegros!"
,"6":"Depois disto, vi outro Anjo que voava no meio do Céu, com um evangelho eterno, para o anunciar aos habitantes da Terra, a toda a nação, tribo, língua e povo."
,"7":"O Anjo dizia em alta voz: «Temei a Deus e dai-Lhe glória, porque chegou a hora,do seu julgamento. Adorai Aquele que fez,o Céu e a Terra, o mar e as fontes»."
,"8":"Apareceu um segundo Anjo,e continuou: «Caiu, caiu Babilónia, a Grande. Aquela que embebedou,todas as nações,com o vinho do furor,da sua prostituição»."
,"9":"Apareceu um terceiro Anjo e continuou em alta voz: «Se alguém adora a Besta e a sua imagem, e recebe a sua marca na fronte ou na mão,"
,"10":"esse também vai beber o vinho do furor de Deus, derramado sem mistura na taça da sua ira. Será atormentado com fogo e enxofre diante dos santos Anjos e diante do Cordeiro."
,"11":"O fumo do seu tormento subirá para sempre: os que adoram a Besta e a sua imagem, e quem quer que receba a marca do seu nome, nunca terá descanso, nem de dia, nem de noite...»."
,"12":"Aqui está a perseverança dos santos, daqueles que guardam os mandamentos de Deus e a fé em Jesus."
,"13":"Ouvi, então, uma voz que vinha do Céu, dizendo: «Escreve: Felizes os mortos, aqueles que desde agora morrem no Senhor. Sim, diz o Espírito, descansem das suas fadigas, pois as suas obras os acompanham»."
,"14":"Depois disto olhei: havia uma nuvem branca, e sobre a nuvem Alguém estava sentado. Parecia um Filho de Homem. Tinha na cabeça uma coroa de ouro, e nas mãos uma foice afiada."
,"15":"Nesse momento, outro Anjo saiu do Templo, gritando em alta voz para Aquele que estava sentado na nuvem: «Lança a tua foice e ceifa. Chegou a hora da colheita, pois a seara da Terra está madura»."
,"16":"Aquele que estava sentado na nuvem lançou a foice à terra, e a terra foi ceifada."
,"17":"Depois, saiu do Templo do céu outro Anjo. Também ele tinha nas mãos uma foice afiada."
,"18":"Do altar saiu outro Anjo, o Anjo que tem poder sobre o fogo. Ele gritou em alta voz para o outro que segurava a foice afiada: «Lança a foice e colhe os cachos da videira da Terra, porque as uvas já estão maduras»."
,"19":"O Anjo lançou a foice à terra e colheu as uvas da Terra. Depois despejou as uvas no grande lagar do furor de Deus."
,"20":"O lagar foi pisado fora da cidade, e dele saiu sangue que subiu até à altura do freio dos cavalos, numa extensão de trezentos quilómetros."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Eu vi no Céu outro sinal grande e maravilhoso: sete Anjos prontos com sete pragas. Estas eram as últimas pragas, pois com elas o furor de Deus ficará consumado."
,"2":"Vi também como que um mar de vidro misturado com fogo. Sobre esse mar estavam de pé todos aqueles que venceram a Besta, a sua imagem e o número do nome da Besta. Os vencedores seguravam as harpas de Deus"
,"3":"e entoavam o cântico de Moisés, o servo de Deus, e o cântico do Cordeiro: «Grandes e maravilhosas,são as tuas obras, Senhor Deus todo-poderoso!,Os teus caminhos,são justos e verdadeiros, Rei das nações!"
,"4":"Quem não temeria, Senhor, e não glorificaria o teu Nome?,Sim! Só Tu és santo!,Todas as nações virão ajoelhar-se diante de Ti, porque as tuas justas decisões,se tornaram manifestas!»"
,"5":"Depois disto vi abrir-se o Templo da Tenda do Testemunho que está no Céu."
,"6":"Saíram do Templo os sete Anjos com as sete pragas. Os Anjos estavam vestidos de linho puro e brilhante, cingidos à altura do peito com cintos de ouro."
,"7":"Um dos quatro Seres vivos entregou aos sete Anjos sete taças de ouro, cheias do furor do Deus que vive para sempre."
,"8":"O Templo encheu-se de fumo, por causa da glória e do poder de Deus. Ninguém podia entrar no Templo, enquanto não estivessem consumadas as sete pragas dos sete Anjos."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Depois ouvi: do Templo vinha uma voz forte que dizia aos sete Anjos: «Ide! Despejai sobre a Terra as sete taças do furor de Deus!»"
,"2":"Saiu o primeiro Anjo, e despejou a sua taça sobre a Terra. E todas as pessoas que tinham a marca da Besta e todas as que adoravam a imagem da Besta ficaram com o corpo cheio de úlceras malignas e dolorosas."
,"3":"O segundo Anjo despejou a sua taça sobre o mar. E o mar converteu-se em sangue, como sangue de um morto. E todos os seres vivos do mar morreram."
,"4":"O terceiro Anjo despejou a sua taça nos rios e nas fontes. E os rios e fontes transformaram-se em sangue."
,"5":"Ouvi, então, o Anjo das águas dizer: «Justo és Tu, Aquele que é e que era, ó Santo, porque julgaste estas coisas."
,"6":"Esta gente derramou o sangue,de santos e profetas, e Tu deste-lhes sangue a beber!,Eles merecem-no!»"
,"7":"Ouvi, então, a voz do altar: «Sim, Senhor Deus Todo-poderoso, os teus julgamentos são verdadeiros e justos»."
,"8":"O quarto Anjo despejou a sua taça sobre o Sol. E o Sol recebeu a permissão de queimar os homens com fogo."
,"9":"E os homens ficaram tão abrasados com esse calor intenso, que começaram a blasfemar contra o nome do Deus que tem poder sobre essas pragas. Mas não se converteram para dar glória a Deus."
,"10":"O quinto Anjo despejou a sua taça sobre o trono da Besta, e o seu reino ficou em trevas. Os homens mordiam a língua de dor."
,"11":"Blasfemaram contra o Deus do Céu por causa da dor e das feridas, mas não se arrependeram da sua conduta."
,"12":"O sexto Anjo despejou a sua taça sobre o grande rio Eufrates. A água do rio secou, e os reis do Oriente ficaram com o caminho livre para atacar."
,"13":"Nesse momento eu vi: da boca do Dragão, da boca da Besta e da boca do falso profeta saíram três espíritos impuros que pareciam sapos."
,"14":"São espíritos de demónios. Fazem maravilhas, e vão até aos reis de toda a Terra, a fim de os reunir para a guerra no Grande Dia do Deus todo-poderoso."
,"15":"(Eis que venho como um ladrão: feliz aquele que vigia e conserva as suas vestes, para não andar nu e não deixar que vejam a sua vergonha!)"
,"16":"Então os espíritos reuniram os reis no lugar que, em hebraico, se chama Harmagedon."
,"17":"O sétimo Anjo despejou a sua taça no ar. Nisto, saiu uma forte voz do Templo, dizendo: «Está realizado!»"
,"18":"Houve, então, relâmpagos, trovões e um forte terremoto. Desde que o homem apareceu na Terra, nunca tinha acontecido terremoto assim tão violento."
,"19":"A Grande Cidade partiu-se em três pedaços, e as cidades das nações caíram. Deus lembrou-Se então de Babilónia, a Grande, para lhe dar o cálice do vinho do furor da sua ira."
,"20":"As ilhas fugiram, as montanhas desapareceram."
,"21":"Caiu do céu sobre os homens uma grande chuva de granizo, pedras com mais de trinta quilos. E os homens blasfemaram contra Deus por causa dessa praga de granizo, pois o seu flagelo é muito grande."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Um dos Anjos das sete taças veio convidar-me: «Vem! Vou mostrar-te como será julgada a grande prostituta, que está sentada à beira de muitas águas."
,"2":"Os reis da Terra prostituíram-se com ela. Os habitantes da Terra ficaram bêbados com o vinho da sua prostituição»."
,"3":"E o Anjo levou-me em espírito até ao deserto e vi uma mulher sentada sobre uma Besta de cor escarlate, cheia de títulos blasfemos. A Besta tinha sete cabeças e dez chifres."
,"4":"A mulher estava vestida de púrpura e escarlate. Estava toda enfeitada de ouro, pedras preciosas e pérolas. Tinha na mão um cálice de ouro cheio de abominações, que são as impurezas da sua prostituição."
,"5":"Na fronte da mulher estava escrito um nome misterioso: «Babilónia, a Grande, a mãe das prostitutas e das abominações da Terra»."
,"6":"Reparei que a mulher estava embriagada com o sangue dos santos e com o sangue das testemunhas de Jesus. Vendo a mulher, fiquei profundamente admirado. "
,"7":"O Anjo, porém, disse-me: «Porque te admiras? Vou explicar-te o mistério da mulher e da Besta com sete cabeças e dez chifres que traz a mulher."
,"8":"A Besta que viste existia, mas já não existe. Ela está para subir do Abismo, porém caminha para a perdição. Os habitantes da Terra vão ficar admirados ao verem a Besta. São os que desde a fundação do mundo não têm o nome escrito no livro da vida. Ficarão admirados porque a Besta existia, já não existe, mas vai aparecer de novo."
,"9":"Aqui é preciso ter inteligência para entender: as sete cabeças são sete montes, sobre os quais a mulher está sentada. São também sete reis."
,"10":"Cinco já caíram, um existe, e o outro ainda não veio; mas, quando vier, ficará por pouco tempo."
,"11":"A Besta que existia e já não existe, ela mesma é o oitavo rei, e também um dos sete, mas caminha para a perdição."
,"12":"Os dez chifres que viste são dez reis, que ainda não receberam um reino. Estes, porém, receberão autoridade como reis, por uma hora apenas, juntamente com a Besta."
,"13":"Esses reis pensam a mesma coisa: entregar o poder e a autoridade à Besta."
,"14":"Todos juntos farão guerra contra o Cordeiro. Mas o Cordeiro vencê-los-á, porque o Cordeiro é Senhor dos senhores e Rei dos reis. E, com Ele, vencerão também os chamados, os escolhidos e os fiéis»."
,"15":"O Anjo continuou a explicar-me: «Viste aquela prostituta que está sentada perto de muitas águas. Essas águas são povos, multidões, nações e línguas diversas."
,"16":"Os dez chifres que viste, juntamente com a Besta, começarão a odiar aquela prostituta, despojá-la-ão das suas vestes e deixá-la-ão nua. Comerão as suas carnes e queimá-la-ão."
,"17":"Pois Deus pôs nos seus corações o desejo de realizar o seu próprio plano: vão entregar a sua realeza à Besta, até que as palavras de Deus estejam cumpridas."
,"18":"Essa mulher que viste é a Grande Cidade que reina sobre os reis da Terra»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Depois de tudo isto, vi outro Anjo descer do Céu. Tinha grande poder, e a Terra ficou toda iluminada com a sua glória."
,"2":"Ele gritou com voz forte: «Caiu! Caiu Babilónia, a Grande!,Tornou-se morada de demónios, abrigo de todos os espíritos maus, abrigo de aves impuras e nojentas."
,"3":"Porque ela embriagou as nações,com o vinho do furor,da sua prostituição. Com ela se prostituíram os,reis da Terra. Os mercadores da Terra,ficaram ricos,graças ao seu luxo desenfreado»."
,"4":"Ouvi outra voz que dizia: «Sai dela, meu povo, para que não sejas cúmplice,dos seus pecados, nem atingido pelas suas pragas."
,"5":"Porque os seus pecados,amontoaram-se até ao Céu, e Deus lembrou-Se,das suas iniquidades."
,"6":"Pagai-lhe com a mesma moeda. Retribuí-lhe com o dobro,dos seus malefícios. Dai-lhe o dobro na taça que ela vos deu a beber."
,"7":"Dai-lhe dor e luto,na mesma medida,em que fez ostentação,do seu luxo e da sua glória. Toda cheia de si ela pensava: 'Estou sentada como rainha. Não sou viúva,nem jamais vestirei luto...'"
,"8":"Por isso, num só dia, virão sobre ela os flagelos: morte, luto e fome. Ela será devorada pelo fogo, porque o Senhor Deus que a julgou é forte»."
,"9":"Os reis da Terra, que se prostituíram com ela, aqueles que participavam do seu luxo, quando virem o fumo do seu incêndio vão chorar e bater no peito."
,"10":"Manter-se-ão à distância, com medo dos sofrimentos. E dirão: «Ai, ai, a Grande Cidade!,Ó Babilónia, cidade poderosa, uma hora apenas bastou,para o teu julgamento!»"
,"11":"Os mercadores de toda a Terra também choram e ficam de luto por causa da ruína de Babilónia, porque ninguém mais vai comprar as suas mercadorias:"
,"12":"carregamentos de ouro e prata, pedras preciosas e pérolas, linho e púrpura, seda e escarlate, madeiras perfumadas, objectos de marfim e de madeira preciosa, de cobre, de ferro e de mármore,"
,"13":"cravo e especiarias, perfumes, mirra e incenso, vinho e azeite, flor de farinha e trigo, bois e ovelhas, cavalos e carros, escravos e vidas humanas..."
,"14":"As riquezas que desejavas,afastaram-se de ti!,Tudo o que é grandeza e esplendor,está perdido para ti, e nunca, nunca mais voltará!"
,"15":"Os mercadores que vendiam os seus produtos à Grande Cidade e que se enriqueceram com eles, manter-se-ão à distância, com medo de participarem nos seus sofrimentos."
,"16":"E dirão: «Ai, ai, ó Grande Cidade!,Tu que vestias linho puro, roupas de púrpura e escarlate. E te enfeitavas com ouro, pedras preciosas e pérolas!"
,"17":"Bastou uma hora para a tua riqueza,se reduzir a nada!»,Todos os pilotos e navegadores, marinheiros e todos os que trabalham no mar mantiveram-se à distância. "
,"18":"Viram o fumo do incêndio e gritaram: «Que cidade houve semelhante à Grande Cidade?»"
,"19":"Esses homens do mar lançaram cinza sobre a cabeça, choraram, ficaram de luto e gritavam: «Ai, ai, ó Grande Cidade!,Com a tua grandeza,todos os que tinham navios,no mar enriqueceram. Bastou uma hora,para ficares arruinada!»"
,"20":"«Alegra-te, ó Céu, com a sua ruína, e vós também, santos, apóstolos e profetas, pois Deus a julgou com justiça!»"
,"21":"Então, um Anjo forte levantou uma pedra, do tamanho de uma pedra de moinho, e lançou-a ao mar, dizendo: «Com esta força será precipitada,Babilónia, a Grande Cidade. E nunca mais voltará a ser vista."
,"22":"E o canto de harpistas e músicos, de flautistas e tocadores de trombeta,nunca mais se ouvirá em ti; e nenhum artista de qualquer arte,jamais se encontrará em ti; e o canto do moinho,em ti nunca mais se ouvirá;"
,"23":"e a luz da lâmpada,nunca mais em ti brilhará; e a voz do esposo e da esposa,em ti nunca mais se ouvirá. Porque os teus mercadores,eram os grandes da Terra, e com magia enfeitiçaste,todas as nações."
,"24":"Nela foi encontrado o sangue,de profetas e santos, e de todos os que foram,imolados sobre a Terra»."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Depois disto, ouvi no Céu um forte barulho de uma grande multidão que aclamava: «Aleluia!,A salvação, a glória,e o poder pertencem ao nosso Deus,"
,"2":"porque os seus julgamentos,são verdadeiros e justos. Sim! Deus julgou,a grande Prostituta, que corrompeu a Terra,com a sua prostituição, e vingou nela o sangue,dos seus servos»."
,"3":"A multidão continuou o canto: «Aleluia!,Dela sobe o fumo para sempre!»"
,"4":"Os vinte e quatro Anciãos e os quatro Seres vivos ajoelharam-se diante de Deus que está sentado no trono, e disseram: «Ámen! Aleluia!»"
,"5":"E do trono saiu uma voz, convidando: «Louvai o nosso Deus, vós todos, os seus servos, todos os que O temem, pequenos e grandes!»"
,"6":"Depois, ouvi o rumor de uma grande multidão. Parecia o estrondo de águas torrenciais e o ribombar de fortes trovões. A multidão aclamava: «Aleluia!,O Senhor, o Deus todo-poderoso,tomou posse do seu Reino."
,"7":"Vamos ficar alegres e contentes, vamos dar glória a Deus, porque chegou o tempo,do casamento do Cordeiro, e a sua esposa já está pronta:"
,"8":"concederam-lhe que se vestisse,de linho puro e brilhante», -pois o linho representa,o comportamento justo dos santos."
,"9":"Logo em seguida, o Anjo disse-me: «Escreve: Felizes os convidados para o banquete do casamento do Cordeiro». E disse ainda: «Estas são as verdadeiras palavras de Deus»."
,"10":"Eu caí de joelhos para adorar o Anjo, mas ele disse-me: «Não! Não faças isso! Eu sou um servo como tu e como os teus irmãos que mantêm o testemunho de Jesus. É a Deus que deves adorar!» Com efeito, o espírito da profecia é o testemunho de Jesus."
,"11":"Vi, então, o Céu aberto: apareceu um cavalo branco, e o seu cavaleiro chama-Se Fiel e Verdadeiro. Ele julga e combate com justiça."
,"12":"Os seus olhos são semelhantes a uma chama de fogo. Sobre a sua cabeça há muitas coroas. E Ele traz escrito um Nome que ninguém conhece, a não ser Ele mesmo."
,"13":"Está vestido com um manto embebido em sangue, e é chamado «Palavra de Deus»."
,"14":"Os exércitos do Céu acompanham-n'O, montados em cavalos brancos, com roupas de linho branco e brilhante."
,"15":"Da sua boca sai uma espada afiada para com ela ferir as nações. Ele é que apascentará as nações com ceptro de ferro. Ele é que pisa o lagar do vinho do furor da ira de Deus, o Todo-poderoso."
,"16":"No manto e na coxa tem um nome escrito: «Rei dos reis e Senhor dos senhores»."
,"17":"Vi depois um Anjo, de pé sobre o Sol. Ele gritou com voz forte a todas as aves que voavam através do Céu: «Vinde! Reuni-vos para o grande banquete de Deus,"
,"18":"para comer carnes de reis, carnes de chefes militares, carnes de poderosos, carnes de cavalos e cavaleiros, carnes de todos os homens, livres e escravos, pequenos e grandes»."
,"19":"Vi, então, a Besta reunida com os reis da Terra e com os seus exércitos, para guerrear contra o Cavaleiro e o seu exército."
,"20":"A Besta, porém, foi capturada, e com ela o Falso Profeta, que operava maravilhas na presença da Besta. Foi assim que ela seduziu todos os que haviam recebido a marca da Besta e adorado a sua imagem. Tanto a Besta como o Falso Profeta foram lançados vivos no lago do fogo e do enxofre."
,"21":"Os outros foram mortos pela espada que saía da boca do Cavaleiro. E as aves fartaram-se com as suas carnes."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Depois disto vi um Anjo descer do Céu. Nas mãos tinha a chave do Abismo e uma grande corrente."
,"2":"Ele subjugou o Dragão, a antiga Serpente, que é o Diabo, Satanás. Acorrentou o Dragão por mil anos"
,"3":"e lançou-o no Abismo. Depois trancou e lacrou o Abismo, para que o Dragão não seduzisse mais as nações da Terra, até que terminassem os mil anos. Depois disso, o Dragão vai ser solto, mas por pouco tempo."
,"4":"Vi então tronos, e os que se sentaram nos tronos receberam o poder de julgar. Vi também as vidas daqueles que foram decapitados por causa do Testemunho e da Palavra de Deus. Vi também as vidas daqueles que não tinham adorado a Besta, nem a sua imagem, nem tinham recebido na fronte ou na mão a marca da Besta. Eles voltaram a viver e reinaram com Cristo durante mil anos."
,"5":"Os outros mortos, porém, não voltaram a viver enquanto não terminaram os mil anos. Esta é a primeira ressurreição."
,"6":"Felizes e santos os que participam da primeira ressurreição! A segunda morte não tem poder sobre eles, e eles serão sacerdotes de Deus e de Cristo, e com Cristo reinarão durante mil anos."
,"7":"Quando se completarem os mil anos, Satanás será solto da prisão do Abismo."
,"8":"Ele vai sair e seduzir as nações dos quatro cantos da terra, Gog e Magog, reunindo-os para o combate. São numerosos como a areia do mar."
,"9":"Eles espalharam-se por toda a Terra e cercaram o acampamento dos santos e a Cidade amada. Mas desceu fogo do Céu e devorou-os."
,"10":"O Diabo, que os tinha seduzido a todos, foi lançado no lago de fogo e enxofre, onde já se achavam a Besta e o falso profeta. Lá serão atormentados dia e noite para sempre."
,"11":"Depois vi um grande trono branco e Alguém sentado nele. O Céu e a Terra fugiram da sua presença e não deixaram rasto."
,"12":"Vi então os mortos, grandes e pequenos, de pé diante do trono. E foram abertos livros. Foi também aberto outro livro, o livro da vida. Então os mortos foram julgados de acordo com a sua conduta, conforme o que estava escrito nos livros."
,"13":"O mar devolveu os mortos que nele estavam. A morte e a morada dos mortos entregaram os seus mortos. E cada um foi julgado conforme a sua conduta."
,"14":"A morte e a morada dos mortos foram, então, lançados no lago de fogo. O lago de fogo é a segunda morte."
,"15":"Quem não tinha o nome escrito no Livro da Vida também foi lançado no lago de fogo."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Vi, depois, um novo Céu e uma nova Terra. O primeiro Céu e a primeira Terra haviam desaparecido e o mar já não existia."
,"2":"Vi também descer do Céu, de junto de Deus, a Cidade Santa, uma Jerusalém nova, pronta como esposa que se enfeitou para o seu marido."
,"3":"Nisto, ouvi uma voz forte que saía do trono e que dizia: «Esta é a tenda de Deus,entre os homens. Ele vai morar com eles. Eles serão o seu povo e Ele, o Deus-com-eles, será o seu Deus."
,"4":"Ele enxugará as lágrimas,dos seus olhos, pois nunca mais haverá morte, nem luto, nem gritos, nem dor. Sim! As coisas antigas,desapareceram!»"
,"5":"Aquele que está sentado no trono declarou: «Eis que faço novas todas as coisas»."
,"6":"E disse-me ainda: «Elas realizaram-se. Eu sou o Alfa e o Ómega, o Princípio e o Fim. A quem tiver sede, dar-lhe-ei a beber, gratuitamente, da fonte de água da vida."
,"7":"O vencedor receberá esta herança: Eu serei seu Deus, e ele será meu filho."
,"8":"Quanto aos covardes, aos infiéis, aos corruptos, aos assassinos, aos imorais, aos feiticeiros, aos idólatras e a todos os mentirosos, o seu lugar é o lago ardente de fogo e enxofre, que é a segunda morte»."
,"9":"Depois disto, um dos sete Anjos das sete taças cheias com as últimas pragas veio ter comigo e disse-me: «Vem! Vou mostrar-te a noiva, a esposa do Cordeiro»."
,"10":"E levou-me em espírito ao cimo de um grande e alto monte. E mostrou-me a Cidade Santa, Jerusalém, que descia do Céu, de junto de Deus,"
,"11":"com a glória de Deus. O seu esplendor era semelhante a uma pedra preciosíssima, pedra de jaspe cristalino."
,"12":"Ela está cercada por alta e grossa muralha, com doze portas. Sobre as portas há doze Anjos. Cada porta tem um nome escrito: os nomes das doze tribos de Israel."
,"13":"São três portas no lado do Oriente, três portas ao Norte, três portas ao Sul e três portas no lado do Poente."
,"14":"A muralha da cidade tem doze alicerces. E nos alicerces está escrito o nome dos doze Apóstolos do Cordeiro."
,"15":"Aquele que falava comigo usava uma vara de ouro para medir a cidade, os portões e a muralha."
,"16":"A cidade é quadrada: o comprimento é igual à largura. O Anjo mediu a cidade com a vara: doze mil estádios. O comprimento, largura e altura são iguais."
,"17":"O Anjo mediu a muralha: cento e quarenta e quatro côvados. Ele media com medidas humanas."
,"18":"A muralha é de jaspe. A cidade é de ouro puro, tão puro que parece vidro transparente."
,"19":"Os alicerces da muralha da cidade estão adornados com toda a espécie de pedras preciosas: o primeiro alicerce é de jaspe; o segundo de safira, o terceiro de calcedónia, o quarto de esmeralda,"
,"20":"o quinto de sardónica, o sexto de cornalina, o sétimo de crisólito, o oitavo de berilo, o nono de topázio, o décimo de crisópraso, o décimo primeiro de jacinto e o décimo segundo de ametista."
,"21":"As doze portas são doze pérolas. Cada uma das portas é feita de uma só pérola. A praça da cidade é de ouro puro, como vidro transparente."
,"22":"Não vi na Cidade nenhum Templo, pois o seu Templo é o Senhor, o Deus todo-poderoso, e o Cordeiro."
,"23":"A Cidade não precisa do Sol nem da Lua para ficar iluminada, pois é iluminada pela glória de Deus e a sua lâmpada é o Cordeiro."
,"24":"As nações caminharão à sua luz, e os reis da Terra virão trazer-lhe,os seus tesouros."
,"25":"As suas portas nunca se fecharão, porque nunca mais haverá noite,na cidade,"
,"26":"e trazer-lhe-ão a glória e a riqueza,das nações."
,"27":"Nela jamais entrará,qualquer imundície, nem os que se entregam,à abominação e à mentira. Vão entrar somente aqueles,que têm o nome escrito,no Livro da Vida do Cordeiro."
}`)
	CurrentBook.AddChapter(22, `{
"1":"O Anjo mostrou-me o Rio da Água da Vida, brilhante como cristal; o rio brotava do trono de Deus e do Cordeiro."
,"2":"No meio da praça, de cada lado do rio, estão plantadas árvores da vida; dão fruto doze vezes por ano; todos os meses frutificam; as suas folhas servem para curar as nações."
,"3":"Nunca mais haverá maldições. Nela estará sempre o trono de Deus,e do Cordeiro, e os seus servos,prestar-Lhe-ão culto."
,"4":"Verão a sua face, e o seu nome estará,sobre as suas frontes."
,"5":"Não haverá mais noite: ninguém mais vai precisar da luz,da lâmpada, nem da luz do Sol. Porque o Senhor Deus vai brilhar sobre eles, e eles reinarão para sempre."
,"6":"Então o Anjo disse-me: «Estas palavras são fiéis e verdadeiras, pois o Senhor, o Deus que inspira os profetas, enviou o seu Anjo para mostrar aos seus servos o que deve acontecer muito em breve."
,"7":"Eis que venho em breve. Feliz aquele que observa as palavras da profecia deste livro»."
,"8":"Eu, João, fui ouvinte e testemunha ocular destas coisas. Tendo-as visto e ouvido, ajoelhei-me para adorar o Anjo que me havia mostrado estas coisas."
,"9":"Mas ele não deixou: «Não! Não faças isso! Eu sou servo como tu, como os teus irmãos, os profetas, e como aqueles que observam as palavras deste livro. É a Deus que deves adorar»."
,"10":"O Anjo disse-me ainda: «Não guardes em segredo as palavras deste livro, pois o tempo está próximo."
,"11":"O injusto, que continue com a sua injustiça; o impuro, que continue com suas impurezas; o justo, continue a praticar a justiça; o santo, continue a santificar-se!"
,"12":"Eis que virei em breve, e comigo trarei o salário para retribuir a cada um conforme o seu trabalho."
,"13":"Eu sou o Alfa e o Ómega, o Primeiro e o Último, o Princípio e o Fim."
,"14":"Felizes aqueles que lavam as suas vestes para terem direito à Árvore da Vida, e para entrarem na Cidade pelas portas."
,"15":"Vão ficar de fora os cães, os feiticeiros, os imorais, os assassinos, os idólatras e todos os que amam ou praticam a mentira»."
,"16":"Eu, Jesus, enviei o meu Anjo para vos testificar todas estas coisas a respeito das Igrejas. Eu sou o Rebento da família de David, a brilhante estrela da manhã."
,"17":"O Espírito e a Esposa dizem: «Vem!» Aquele que ouve isto diga também: «Vem!» Quem estiver com sede, venha! E quem quiser, receba gratuitamente a água da vida."
,"18":"A quem escuta as palavras da profecia deste livro, eu declaro: «Se alguém acrescentar qualquer coisa a este livro, Deus vai acrescentar a essa pessoa as pragas que aqui estão descritas."
,"19":"E se alguém tirar alguma palavra do livro desta profecia, Deus vai retirar dessa pessoa a sua parte na Árvore da Vida e na Cidade Santa, descritas neste livro»."
,"20":"Aquele que atesta estas coisas diz: «Sim! Venho muito em breve». Ámen! Vem, Senhor Jesus!"
,"21":"A graça do Senhor Jesus esteja com todos. Ámen!"
}`)

}
func PT_BS_LoadNTHBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Nos tempos antigos, muitas vezes e de muitos modos, Deus falou aos antepassados por meio dos profetas."
,"2":"No período final em que estamos, falou-nos por meio do Filho. Deus constituiu-O herdeiro de todas as coisas e, por meio d'Ele, também criou os mundos."
,"3":"O Filho é a irradiação da sua glória e n'Ele Deus exprimiu-Se tal como é em Si mesmo. O Filho pela sua Palavra poderosa é Aquele que mantém o Universo. Depois de realizar a purificação dos pecados, sentou-Se à direita da Majestade de Deus nas alturas."
,"4":"E le está acima dos anjos, da mesma forma que herdou um Nome muito superior ao deles."
,"5":"De facto, a qual dos anjos Deus disse alguma vez: «Tu és meu Filho, Eu hoje Te gerei?» Ou ainda: «Eu serei seu Pai, e Ele será meu Filho?»"
,"6":"E de novo, quando introduz o seu Filho primogénito no mundo, Ele diz: «Que todos os anjos O adorem»."
,"7":"Por outro lado, sobre os anjos Deus diz: «É Ele que faz os seus anjos como ventos, e os seus ministros como chamas de fogo»."
,"8":"Sobre o Filho, porém, afirma: «O teu trono, ó Deus, permanece para sempre, e o ceptro da rectidão é o ceptro do teu reino."
,"9":"Amaste a justiça e odiaste a iniquidade. Por isso, Deus, o teu Deus Te ungiu com perfume de festa, preferindo-Te aos teus companheiros»."
,"10":"E ainda: «Tu, Senhor, nas origens fundaste a Terra, e os céus são obra das tuas mãos."
,"11":"Eles desaparecerão, mas Tu permaneces; envelhecerão todos como uma veste,"
,"12":"e Tu os dobrarás como a um manto, e serão como uma veste que se muda; mas Tu permanecerás o mesmo, e os teus anos jamais terminarão»."
,"13":"A qual dos anjos Deus disse alguma vez: «Senta-Te à minha direita, até que Eu coloque os teus inimigos como estrado para teus pés?»"
,"14":"Não são todos eles espírito s encarregados para um serviço, enviados para servir aqueles que deverão herdar a salvação?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por isso, devemos levar mais a sério a mensagem que ouvimos, se não quisermos perder o rumo."
,"2":"De facto, se a palavra transmitida por meio dos anjos se mostrou válida, e toda a transgressão e desobediência recebeu um justo cas-tigo,"
,"3":"como poderemos nós escapar ao castigo, se não dermos atenção a uma salvação tão grande? De facto, depois de ter sido promulgada no início pelo Senhor, essa mesma salvação foi confirmada no meio de nós por aqueles que a tinham ouvido;"
,"4":"e Deus apoiava o seu testemunho, mediante sinais, prodígios, milagres diversos e dons do Espírito Santo, distribuídos conforme a sua própria vontade."
,"5":"Não foi a anjos que Deus submeteu o mundo futuro de que estamos a falar."
,"6":"Alguém atestou numa passagem da Escritura: «O que é o homem para dele Te lembrares, ou o ser humano para que dele cuides?"
,"7":"Tu fizeste-o pouco menor do que os anjos; de glória e honra o coroaste,"
,"8":"e puseste todas as coisas sob os seus pés». Submetendo todas as coisas ao homem, Deus não deixou nada que não estivesse submetido ao homem. Agora, ainda não vemos que tudo esteja submetido ao homem."
,"9":"Mas aquele Jesus, que por um pouco de tempo foi feito um pouco menor do que os anjos, nós vemo-l'O agora coroado de glória e honra, por causa da morte que sofreu. Deste modo, pela graça de Deus, Ele experimentou a morte em favor de todos."
,"10":"De facto, Deus, por quem e para quem todas as coisas existem, queria conduzir para a glória um grande número de filhos. Em vista disso, pareceu-Lhe conveniente levar à consumação, por meio do sofrimento, o Iniciador da salvação de todos eles."
,"11":"Pois, tanto Aquele que santifica, como aqueles que são santificados, todos têm a mesma origem. Por isso, Ele não Se envergonha de lhes chamar irmãos,"
,"12":"dizendo: «Anunciarei o teu nome aos meus irmãos, e no meio da assembleia cantarei os teus louvores»."
,"13":"E ainda: «N'Ele colocarei a minha confiança». E também: «Eis-me aqui, com os filhos que Deus Me deu»."
,"14":"Uma vez que os filhos têm todos em comum a carne e o sangue, Jesus também assumiu uma carne como a deles. Assim pôde, pela sua própria morte, destruir o poder do diabo, que reina por meio da morte."
,"15":"Deste modo, Jesus libertou os homens que ficavam paralisados a vida inteira por medo da morte."
,"16":"Ele não veio para ajudar os anjos, mas para ajudar a descendência de Abraão."
,"17":"Por isso, teve que ser semelhante em tudo aos seus irmãos, para Se tornar Sumo Sacerdote misericordioso e fiel em relação às coisas de Deus, a fim de expiar os pecados do povo."
,"18":"De facto, precisamente porque foi colocado à prova e porque sofreu pessoalmente, Ele é capaz de vir em auxílio daqueles que estão a ser provados."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Por isso, irmãos santos, participais de um chamamento que vem do Céu; por isso, fixai bem a mente em Jesus, o Apóstolo e Sumo Sacerdote da fé que nós professamos."
,"2":"Ele foi fiel a Deus, que Lhe confiou esse cargo, como também Moisés estava encarregado de toda a casa de Deus."
,"3":"Na verdade, a glória que corresponde a Jesus é muito maior que a glória de Moisés, pois não há comparação entre a casa e aquele que a constrói."
,"4":"Cada casa tem o seu construtor; mas é Deus quem constrói tudo."
,"5":"Sabemos que Moisés foi fiel em tudo o que se refere à casa de Deus, mas agiu como servidor, para testemunhar aquilo que devia ser anunciado mais tarde."
,"6":"Mas o caso de Cristo é diferente: Ele veio como Filho, e a Ele pertence a casa. E a casa de Cristo somos nós, se conservarmos a firmeza da esperança, que é o nosso orgulho."
,"7":"Por isso, escutemos o que diz o Espírito Santo: «Se hoje ouvirdes a sua voz,"
,"8":"não fiqueis de coração endurecido como no dia da revolta, no dia da tentação no deserto."
,"9":"Ali os vossos pais Me tentaram, colocando-Me à prova,"
,"10":"embora já tivessem visto as minhas obras durante quarenta anos. Por isso, aquela geração Me desgostou, e Eu disse: 'Eles têm sempre o coração transviado, não conheceram os meus caminhos."
,"11":"Por isso, Eu jurei na minha ira: Jamais entrarão no meu descanso'»."
,"12":"Portanto, irmãos, tende cuidado para que não haja entre vós nenhum homem de coração perverso e sem fé, que se distancie do Deus vivo."
,"13":"Animai-vos uns aos outros todos os dias, enquanto dura a proclamação desse hoje, a fim de que nenhum de vós se endureça, enganado pelo pecado."
,"14":"De facto, nós tornamo-nos participantes de Cristo, contanto que mantenhamos firme até ao fim a confiança que tivemos desde o início."
,"15":"Quando se diz: «Se hoje ouvirdes a sua voz, não fiqueis de coração endurecido como no dia da revolta»,"
,"16":"quais foram aqueles que se revoltaram depois de ter ouvido a sua voz? Não foram todos aqueles que tinham saído do Egipto graças a Moisés?"
,"17":"E quais foram aqueles de quem Deus Se desgostou por quarenta anos? Não foram aqueles que tinham pecado e cujos cadáveres caíram no deserto?"
,"18":"E a quem foi que Deus jurou que não entrariam no seu descanso? Àqueles que não tinham acreditado."
,"19":"Vemos assim que eles não puderam entrar por causa da sua falta de fé."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Por isso, tenhamos cuidado enquanto nos é oferecida a oportunidade para entrar no descanso de Deus. Não aconteça que alguém de vós fique para trás!"
,"2":"Nós também recebemos como eles uma boa notícia. Mas a mensagem que eles ouviram, de nada lhes adiantou, pois não permaneceram unidos na fé com aqueles que tinham ouvido."
,"3":"Nós, porque acreditamos, podemos entrar nesse descanso, conforme Deus disse: «Por isso, Eu jurei na minha ira: jamais entrarão no meu descanso». Aqui trata-se do descanso de Deus, depois de ter realizado as suas obras no princípio do mundo."
,"4":"Em algum lugar, a Escritura diz a respeito do sétimo dia: «E no sétimo dia Deus descansou de todas as suas obras»."
,"5":"E, de novo, no nosso texto: «Jamais entrarão no meu descanso»."
,"6":"Sabemos, portanto, que alguns entrarão no descanso. E os que receberam em primeiro lugar a boa notícia não entraram por causa da sua desobediência."
,"7":"Por isso, Deus fixa novamente um dia que Ele chama hoje, dizendo por meio de David, depois de muito tempo, o que lembrámos mais acima: «Se hoje ouvirdes a sua voz, não fiqueis de coração endurecido»."
,"8":"Se Josué os tivesse de facto introduzido nesse descanso, Deus não teria falado novamente de outro dia."
,"9":"Portanto, ainda está reservado um descanso sabático para o povo de Deus."
,"10":"Quem de facto já entrou no descanso de Deus, descansa de todas as suas obras, assim como Deus descansa das suas."
,"11":"Apressemo-nos, pois, a entrar nesse descanso, para que ninguém caia no mesmo tipo de desobediência."
,"12":"A Palavra de Deus é viva, eficaz e mais penetrante do que qualquer espada de dois gumes; ela penetra até ao ponto onde a alma e o espírito se encontram, e até onde as juntas e medulas se tocam; ela sonda os sentimentos e pensamentos mais íntimos."
,"13":"Não existe criatura que possa esconder-se de Deus; tudo fica nu e descoberto a seus olhos; e a Ele devemos prestar contas."
,"14":"Nós temos um sumo sacerdote eminente, que atravessou os céus: Jesus, o Filho de Deus. Por isso, mantenhamos firme a fé que professamos."
,"15":"De facto, não temos um sumo sacerdote incapaz de se compadecer das nossas fraquezas, pois Ele mesmo foi provado como nós, em todas as coisas, menos no pecado."
,"16":"Portanto, aproximemo-nos do trono da graça com plena confiança, a fim de alcançarmos misericórdia, encontrarmos graça e sermos ajudados no momento oportuno."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todo o sumo sacerdote, escolhido entre os homens, é constituído para o bem dos homens nas coisas que se referem a Deus. A sua função é oferecer dons e sacrifícios pelos pecados."
,"2":"Deste modo, ele é capaz de sentir justa compaixão por aqueles que ignoram e erram, porque também ele próprio está cercado de fraqueza;"
,"3":"e, por causa disso, ele deve oferecer sacrifícios, tanto pelos próprios pecados como pelos pecados do povo."
,"4":"Ninguém pode atribuir a si mesmo essa honra, se não for chamado por Deus, como o foi Aarão."
,"5":"Da mesma forma, Cristo não atribuiu a Si mesmo a glória de ser sumo sacerdote; esta foi-lhe conferida por Aquele que Lhe disse: «Tu és o meu Filho, Eu hoje Te gerei»."
,"6":"E, noutra passagem da Escritura, Ele diz: «Tu és sacerdote para sempre, segundo a ordem do sacerdócio de Melquisedec»."
,"7":"Durante a sua vida na Terra, Cristo fez orações e súplicas a Deus, em voz alta e com lágrimas, ao Deus que O podia salvar da morte. E Deus escutou-O, porque Ele foi submisso."
,"8":"Embora sendo Filho de Deus, aprendeu a ser obediente através dos seus sofrimentos."
,"9":"E, depois de atingir a perfeição, tornou-Se fonte de salvação eterna para todos aqueles que Lhe obedecem."
,"10":"De facto, Ele foi proclamado por Deus sumo sacerdote, segundo a ordem do sacerdócio de Melquisedec."
,"11":"Temos muito a dizer sobre este assunto, mas é difícil explicar, porque vos tornastes lentos para compreender."
,"12":"Depois de tanto tempo, já devíeis ser mestres; no entanto, ainda precisais de alguém que vos ensine as coisas mais elementares das palavras de Deus. Em vez de alimento sólido, ainda precisais de leite."
,"13":"Ora, quem precisa de leite ainda é criança e não tem experiência para distinguir o que é certo e o que é errado."
,"14":"E o alimento sólido é para os adultos que, pela prática, estão preparados para distinguir o que é bom e o que é mau."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Assim, deixando de lado as instruções elementares sobre Cristo, vamos tratar de assuntos de adultos. Não trataremos de coisas elementares, tais como: conversão das obras mortas e fé em Deus,"
,"2":"doutrina dos baptismos, imposição das mãos, ressurreição dos mortos e julgamento eterno."
,"3":"É o que tentaremos fazer, se Deus quiser."
,"4":"Há pessoas que foram iluminadas uma vez, saborearam o dom do céu, participaram do Espírito Santo"
,"5":"e experimentaram a boa Palavra de Deus e as maravilhas do mundo futuro;"
,"6":"no entanto, caíram. É impossível que sejam renovadas outra vez e sejam trazidas à conversão, pois crucificaram novamente o Filho de Deus e expuseram-n'O a injúrias."
,"7":"De facto, quando uma terra embebida de chuva abundante produz plantas úteis para quem a cultiva, essa terra tem a bênção de Deus."
,"8":"Mas, se produz espinhos e ervas daninhas, não tem nenhum valor e está a um passo da maldição e acabará por ser queimada."
,"9":"Embora falemos deste modo, estamos certos de que vós, caríssimos, estais do lado bom e da salvação."
,"10":"Deus não é injusto para esquecer o trabalho e o amor que demonstrais pelo seu Nome, já que servistes santos e ainda servis."
,"11":"Gostaríamos somente que cada um de vós demonstrasse o mesmo empenho em levar a esperança ao seu cumprimento até ao fim,"
,"12":"para que não sejais lentos na compreensão, mas imitadores daqueles que, com a fé e a perseverança, se tornam herdeiros das promessas."
,"13":"Quando Deus fez a promessa a Abraão, não podendo jurar por alguém superior a Ele, jurou por Si mesmo,"
,"14":"dizendo: «Eu te concederei copiosas bênçãos e te multiplicarei em grande número»."
,"15":"Abraão perseverou e alcançou a promessa."
,"16":"Na verdade, os homens juram por alguém superior a eles; assim, o juramento é uma garantia para eles e põe fim a qualquer discussão."
,"17":"Por isso, querendo mostrar mais claramente aos herdeiros da promessa que a sua decisão era irrevogável, Deus interveio através de juramento."
,"18":"E assim, dois actos irrevogáveis, nos quais é impossível Deus mentir, dão-nos um poderoso encorajamento, a nós que tudo deixámos para nos agarrarmos firmemente à esperança que nos foi oferecida."
,"19":"A esperança é como âncora para a nossa vida. Ela é segura e firme, é penetrante até ao outro lado da cortina do santuário,"
,"20":"onde Jesus entrou por nós como precursor, tendo-Se tornado sumo sacerdote para sempre, segundo a ordem do sacerdócio de Melquisedec."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Melquisedec era rei de Salém e sacerdote do Deus Altíssimo. Ele foi ao encontro de Abraão, quando este voltava vitorioso da batalha contra os reis. Ele abençoou Abraão,"
,"2":"e Abraão deu-lhe a décima parte de tudo. Traduzido, o nome Melquisedec significa «rei de justiça»; além disso, ele é rei de Salém, isto é, «rei de paz»."
,"3":"Sem pai, sem mãe, sem genealogia, sem começo nem fim de vida como o Filho de Deus, Melquisedec permanece sacerdote para sempre."
,"4":"Vede como Melquisedec era grande: Abraão, o patriarca, deu-lhe a décima parte daquilo que havia de melhor nos despojos."
,"5":"Segundo a Lei de Moisés, os descendentes de Levi que se tornam sacerdotes devem cobrar o dízimo do povo, isto é, dos seus irmãos, embora estes também sejam descendentes de Abraão."
,"6":"Melquisedec, porém, que não era descendente de Levi, cobrou de Abraão a décima parte e abençoou aquele que havia recebido as promessas de Deus."
,"7":"Ora, sem dúvida, quem é abençoado é inferior àquele que o abençoa."
,"8":"Além disso, os filhos de Levi que cobram o dízimo são homens que morrem; lá, porém, o dízimo foi cobrado por uma pessoa, da qual se declara que está viva."
,"9":"Por outro lado, podemos dizer que o próprio Levi que recebe o dízimo também entregou a sua décima parte na pessoa de Abraão."
,"10":"De facto, Levi ainda se encontrava no corpo do seu antepassado, quando aconteceu o encontro com Melquisedec."
,"11":"A perfeição não chegou com os sacerdotes filhos de Levi, embora se baseasse neles a Lei dada ao povo judaico. Caso contrário, que necessidade havia de se apresentar outro sacerdote? E porque se diz que ele seria sacerdote segundo a ordem do sacerdócio de Melquisedec, em vez de dizer: segundo a ordem do sacerdócio de Aarão?"
,"12":"Portanto existe mudança de sacerdócio, e isto supõe que também haja mudança de lei."
,"13":"Ora, a pessoa da qual se dizem estas coisas é de uma tribo diferente, da qual nunca nenhum membro esteve ao serviço do altar."
,"14":"De facto, sabe-se que nosso Senhor é descendente da tribo de Judá, da qual Moisés nada diz ao falar de sacerdotes."
,"15":"Isto fica ainda mais claro no momento que surge, à semelhança de Melquisedec, um sacerdote diferente,"
,"16":"que não Se tornou sacerdote por causa de uma filiação humana, mas pelo poder de uma vida indestrutível."
,"17":"De facto, a Escritura testemunha sobre Ele: «Tu és sacerdote para sempre, segundo a ordem do sacerdócio de Melquisedec»."
,"18":"Assim, fica abolida a lei anterior, por ser fraca e inútil;"
,"19":"de facto, a Lei não levou nada à perfeição. Por outro lado, introduziu-se uma esperança melhor, graças à qual nos aproximamos de Deus."
,"20":"Além do mais, isto não aconteceu sem juramento. Os outros tornavam-se sacerdotes sem juramento;"
,"21":"Jesus, porém, recebeu um juramento de Deus, que Lhe disse: «O Senhor jurou, e não voltará atrás: Tu és sacerdote para sempre»."
,"22":"Por essa razão, Jesus tornou-Se a garantia de uma aliança melhor."
,"23":"Mais ainda: os filhos de Levi tornaram-se sacerdotes em grande número, porque a morte os impedia de permanecer no cargo."
,"24":"Jesus, porém, não deixará de ser sacerdote, porque permanece vivo para sempre."
,"25":"Por essa razão, Jesus é capaz de salvar definitivamente aqueles que se dirigem a Deus por meio d'Ele. De facto, Jesus está sempre vivo para interceder em favor deles."
,"26":"Por isso, Jesus é o sumo sacerdote de quem tínhamos necessidade: santo, inocente, sem mancha, diferente dos pecadores e elevado acima dos céus."
,"27":"Ele não precisa, como precisam os outros sumos sacerdotes, de oferecer diariamente sacrifícios, antes pelos próprios pecados e depois pelos pecados do povo; porque Ele, oferecendo-Se a Si mesmo, fez isso uma vez por todas."
,"28":"A Lei constitui homens sujeitos à fraqueza humana como sumos sacerdotes; mas a palavra do juramento, que veio depois da Lei, constitui o Filho, que é perfeito para sempre."
}`)
	CurrentBook.AddChapter(8, `{
"1":"O ponto central das nossas explicações é este: nós temos um sumo sacerdote tão grande, que Se sentou à direita do trono da Majestade de Deus no Céu."
,"2":"Ele é ministro do santuário e da verdadeira Tenda, que foi construída pelo Senhor, e não por um homem."
,"3":"De facto, todo o sumo sacerdote é constituído para oferecer dons e sacrifícios. Daí ser necessário que também ele tenha alguma coisa para oferecer."
,"4":"Se Jesus estivesse na Terra, Ele nem sequer seria sacerdote, pois já existem aqueles que oferecem dons segundo a Lei."
,"5":"Estes, porém, realizam um serviço que é imitação e sombra das realidades celestes, con-forme aquilo que Deus disse a Moisés, quando este ia construir a Tenda: «Procura fazer tudo de acordo com o modelo que te foi mostrado sobre a montanha»."
,"6":"Jesus, porém, foi encarregado de um serviço sacerdotal superior, pois é mediador de uma aliança melhor, que promete melhores benefícios."
,"7":"De facto, se a primeira aliança não tivesse defeito, nem lugar haveria para segunda aliança."
,"8":"Mas Deus, queixando-Se contra o seu povo, diz: «Eis que virão dias, diz o Senhor, nos quais concluirei uma aliança nova com a casa de Israel e com a casa de Judá."
,"9":"Não será como a aliança que fiz com os seus antepassados, no dia em que os tomei pela mão para os fazer sair da terra do Egipto. Uma vez que não foram fiéis à minha aliança, também não Me preocupei mais com eles, diz o Senhor."
,"10":"Esta é a aliança que vou concluir com a casa de Israel, depois daqueles dias, diz o Senhor: Colocarei as minhas leis na sua mente e gravá-las-ei nos seus corações; Eu serei o seu Deus, e eles serão o meu povo."
,"11":"Nenhum deles ensinará o seu compatriota nem o seu próprio irmão, dizendo: 'Conhece o Senhor!' Pois todos Me conhecerão, desde o menor até ao maior."
,"12":"Porque Eu vou perdoar as suas faltas e não Me lembrarei mais dos seus pecados»."
,"13":"Dizendo «aliança nova», Deus declara que a primeira ficou antiquada; e aquilo que se torna antigo e envelhece está prestes a desaparecer."
}`)
	CurrentBook.AddChapter(9, `{
"1":"A primeira aliança tinha normas para o culto e para um santuário terrestre."
,"2":"De facto, foi construída uma tenda: trata-se da primeira tenda, chamada «Santo»; e nela estavam o candelabro, a mesa e os pães da oferta."
,"3":"Atrás do segundo véu havia outra tenda, chamada «Santo dos Santos»."
,"4":"Estavam lá o altar de ouro para o incenso e a arca da aliança toda recoberta de ouro, na qual se encontrava uma urna de ouro que continha o maná, a vara de Aarão, que tinha florescido, e as tábuas da aliança."
,"5":"Sobre a arca estavam os querubins da Glória, que com a sua sombra cobriam o lugar do perdão. Agora, porém, não é o momento de nos perdermos em pormenores."
,"6":"Estando tudo assim disposto, os sacerdotes a todo o momento entravam na primeira tenda para celebrar o culto."
,"7":"Na segunda tenda, porém, entrava somente o sumo sacerdote uma vez por ano, levando o sangue para oferecer por si mesmo e pelos pecados que o povo cometeu por ignorância."
,"8":"Deste modo, o Espírito Santo pretendia mostrar que, enquanto existisse a primeira tenda, o caminho para o santuário ainda não estava aberto."
,"9":"Trata-se de um símbolo do tempo presente. Nessa tenda são oferecidos dons e sacrifícios, que não podem tornar perfeita a consciência de quem os oferece."
,"10":"Esses alimentos, bebidas e diferentes tipos de purificação com água, são apenas prescrições humanas, válidas até ao tempo em que seriam corrigidas."
,"11":"Cristo, porém, veio como sumo sacerdote dos bens futuros. Ele atravessou uma tenda muito maior e mais perfeita, não construída por mãos humanas, isto é, atravessou uma tenda que não pertence a esta Criação."
,"12":"Ele entrou de uma vez por todas no santuário, e não com sangue de carneiros e de bezerros, mas com o seu próprio sangue, depois de conseguir para nós uma libertação definitiva."
,"13":"Sangue de carneiros e de touros e cinzas de novilha, espalhadas sobre pessoas impuras, santifica-as, concedendo-lhes uma pureza externa."
,"14":"Muito mais o sangue de Cristo que, com um Espírito eterno, Se ofereceu a Deus como vítima sem mancha! Ele purificará das obras da morte a nossa consciência, para que possamos servir ao Deus vivo."
,"15":"Deste modo, Ele é o mediador de uma Nova Aliança. Morrendo, livrou-nos das faltas cometidas durante a primeira aliança, para que os chamados recebam a herança definitiva que foi prometida."
,"16":"Onde existe testamento, é preciso que seja certificada a morte de quem fez o testamento."
,"17":"Pois um testamento só tem valor depois da morte, e não tem efeito nenhum enquanto ainda vive aquele que fez o testamento."
,"18":"É por isso que a primeira aliança também foi inaugurada com sangue."
,"19":"Quando anunciou a todo o povo cada um dos mandamentos da Lei, Moisés tomou sangue de bezerros e de carneiros, bem como água, lã vermelha e hissopo. Em seguida, aspergiu primeiro o próprio livro e todo o po-vo."
,"20":"E disse: «Este é o sangue da aliança que Deus faz convosco»."
,"21":"Do mesmo modo, aspergiu com sangue também a tenda e todos os objectos que serviam para o culto."
,"22":"E, segundo a Lei, quase todas as coisas são purificadas com sangue; e, sem derramamento de sangue, não existe perdão."
,"23":"Portanto, as figuras das realidades celestes são purificadas dessa maneira; mas as próprias realidades celestes devem ser purificadas com sacrifícios maiores do que aqueles."
,"24":"De facto, Cristo não entrou num santuário feito por mãos humanas, figura do verdadeiro santuário; Ele entrou no próprio Céu, a fim de Se apresentar agora diante de Deus em nosso favor."
,"25":"Ele não teve que Se oferecer muitas vezes, como o sumo sacerdote que todos os anos entra no santuário com sangue que não é seu."
,"26":"Se assim fosse, Ele deveria ter sofrido muitas vezes desde a criação do mundo. Entretanto, Ele manifestou-Se uma vez por todas no fim dos tempos, para abolir o pecado pelo sacrifício de Si mesmo."
,"27":"E dado que os homens morrem uma só vez e depois disso vem o julgamento,"
,"28":"assim também Cristo Se ofereceu de uma vez por todas, para tirar o pecado de muitos. Ele aparecerá uma segunda vez, sem nenhuma relação com o pecado, para aqueles que O esperam para a salvação."
}`)
	CurrentBook.AddChapter(10, `{
"1":"A Lei possui apenas uma sombra dos bens futuros, e não a realidade concreta das coisas. Por isso, mesmo oferecendo sacrifícios continuamente, ano após ano, a Lei não tem poder de conduzir à perfeição aqueles que participam nesses sacrifícios."
,"2":"Caso contrário, não se teria deixado de oferecer esses sacrifícios? De facto, os fiéis, purificados de uma vez por todas, já não teriam mais nenhum pecado na consciência."
,"3":"Contudo, por meio desses sacrifícios, a lembrança dos pecados é renovada ano após ano,"
,"4":"uma vez que é impossível eliminar os pecados com o sangue de touros e carneiros."
,"5":"Por esse motivo, ao entrar no mundo, Cristo disse: «Tu não quiseste sacrifício nem oferta. Em vez disso, deste-Me um corpo."
,"6":"Holocaustos e sacrifícios não são do teu agrado."
,"7":"Por isso Eu disse: Eis-Me aqui, ó Deus - como no rolo do livro está escrito a meu respeito - para fazer a tua vontade»."
,"8":"Primeiro diz: «Não queres e não Te agradam sacrifícios e ofertas, holocaustos e sacrifícios pelo pecado». Trata-se de coisas que são oferecidas segundo a Lei."
,"9":"Depois acrescenta: «Eis-Me aqui para fazer a tua vontade». Desse modo, Cristo suprime o primeiro culto para estabelecer o segundo."
,"10":"É por causa dessa vontade que nós fomos santificados pela oferta do Corpo de Jesus Cristo, realizada uma vez por todas."
,"11":"Cada sacerdote apresenta-se diariamente para celebrar o culto e oferecer muitas vezes os mesmos sacrifícios, que são incapazes de eliminar os pecados."
,"12":"Jesus, porém, ofereceu um só sacrifício pelos pecados e sentou-Se à direita de Deus."
,"13":"Doravante, Ele espera apenas que os seus inimigos sejam colocados debaixo de seus pés."
,"14":"De facto, com uma só oferta Ele tornou perfeitos para sempre os que Ele santifica."
,"15":"E é isso que o Espírito Santo atesta; de facto, após ter dito:"
,"16":"«Esta é a aliança que vou concluir com eles, depois daqueles dias, - diz o Senhor: Eu colocarei as minhas leis nos seus corações e gravá-las-ei na sua mente,"
,"17":"e não Me lembrarei mais dos seus pecados e das suas faltas»."
,"18":"Ora, quando os pecados já foram perdoados, já não é preciso fazer ofertas pelos pecados."
,"19":"Irmãos, com toda a segurança podemos entrar no santuário, por meio do sangue de Jesus."
,"20":"Ele inaugurou para nós esse caminho novo e vivo, através da cortina, isto é, da sua própria carne."
,"21":"Temos um sacerdote eminente à frente da casa de Deus."
,"22":"Aproximemo-nos, pois, de coração sincero, cheios de fé, com o coração purificado da má consciência e o corpo lavado com água pura."
,"23":"Sem vacilar, mantenhamos a profissão da nossa esperança, pois é fiel Aquele que fez a promessa."
,"24":"Tenhamos consideração uns pelos outros, para nos estimularmos no amor e nas boas obras."
,"25":"Não deixemos de frequentar as nossas reuniões, como alguns costumam deixar. Ao contrário, procuremos animar-nos cada vez mais, principalmente agora que vedes que se aproxima o Dia do Senhor."
,"26":"De facto, se continuarmos a pecar, depois de termos recebido o conhecimento da verdade, já não há sacrifícios que possam tirar os nossos pecados."
,"27":"Resta apenas uma terrível espera do julgamento e o ardor de um fogo para devorar os rebeldes."
,"28":"Quem desobedece à Lei de Moisés é condenado à morte sem piedade, tendo como base o testemunho de duas ou três pessoas."
,"29":"Vós podeis então imaginar o castigo bem mais severo que merecerá aquele que espezinhou o Filho de Deus, que profanou o sangue da aliança, pelo qual foi santificado, e que insultou o Espírito da graça!"
,"30":"Conhecemos Aquele que disse: «A Mim pertence a vingança, Eu é que retribuirei». E ainda: «O Senhor julgará o seu povo»."
,"31":"É terrível cair nas mãos do Deus vivo!"
,"32":"Lembrai-vos dos primeiros dias, depois de terdes sido iluminados: tivestes que suportar uma grande e penosa luta,"
,"33":"ora expostos publicamente a insultos e tribulações, ora tornando-vos solidários com aqueles que assim eram tratados."
,"34":"De facto, participastes no sofrimento dos prisioneiros e aceitastes com alegria ser despojados dos próprios bens, sabendo que possuís bens melhores e mais duráveis."
,"35":"Portanto, não percais agora a coragem, para a qual está reservada uma grande recompensa."
,"36":"Necessitais apenas de perseverança, a fim de cumprirdes a vontade de Deus, e assim alcançardes o que Ele prometeu."
,"37":"Porque falta apenas um pouco, e Aquele que deve vir vai chegar e não tardará."
,"38":"O meu justo vive pela fé; mas, se ele volta atrás, nele Eu não encontro mais nenhuma satisfação."
,"39":"Nós, porém, não somos como aqueles que voltam atrás para se perder, mas somos homens de fé, para salvar a nossa vida."
}`)
	CurrentBook.AddChapter(11, `{
"1":"A fé é um modo de já possuir aquilo que se espera, é um meio de conhecer realidades que não se vêem."
,"2":"Foi por causa da fé que os antigos foram aprovados por Deus."
,"3":"Pela fé, sabemos que a Palavra de Deus formou os mundos; foi assim que aquilo que vemos se originou de coisas invisíveis."
,"4":"Pela fé, Abel ofereceu a Deus um sacrifício melhor que o de Caim. E, por causa da fé, ele foi declarado justo, e o próprio Deus afirmou que aceitava os seus dons. Embora estando morto, Abel continua a falar pela sua fé."
,"5":"Pela fé, Henoc foi levado, para que não experimentasse a morte. E nunca mais foi encontrado, porque Deus o levou; e, antes de ser levado, foi dito que ele agradava a Deus."
,"6":"Mas é impossível agradar a Deus sem a fé. De facto, quem se aproxima de Deus deve acreditar que Ele existe e que recompensa aqueles que O procuram."
,"7":"Pela fé, ao ser avisado divinamente sobre coisas que ainda não via, Noé tomou o aviso a sério e construiu uma arca para salvar a sua família. Por essa fé, condenou o mundo e tornou-se herdeiro da justiça que provém da fé."
,"8":"Pela fé, Abraão, chamado por Deus, obedeceu e partiu para um lugar que deveria receber como herança. E partiu sem saber para onde."
,"9":"Pela fé, foi residir como estrangeiro na Terra Prometida. Morou em tendas juntamente com Isaac e Jacob, que também eram herdeiros da mesma promessa."
,"10":"Abraão esperava a cidade bem alicerçada, cujo arquitecto e construtor é o próprio Deus."
,"11":"Foi pela fé que também Sara, embora sendo velha, se tornou capaz de ter uma descendência, pois acreditou em Deus que lhe havia prometido isso."
,"12":"Assim, de um só homem, que estava praticamente morto, nasceu uma descendência tão numerosa como as estrelas do céu e inumerável como os grãos de areia da praia do mar."
,"13":"Todos eles morreram na fé. Não conseguiram a realização das promessas, mas só as viram e saudaram de longe; e confessaram que eram estrangeiros e peregrinos sobre a Terra."
,"14":"Falando assim, demonstraram que estavam em busca de uma pátria."
,"15":"Se pensassem que essa pátria era aquela de onde tinham saído, teriam a possibilidade de voltar para lá."
,"16":"Mas não; eles aspiravam por uma pátria melhor, isto é, a pátria celeste. Por isso, Deus não Se envergonha de ser chamado seu Deus; na verdade, Deus preparou-lhes uma cidade."
,"17":"Pela fé, Abraão, colocado à prova, ofereceu Isaac; e justamente ele, que havia recebido as promessas, ofereceu o seu único filho,"
,"18":"do qual fora dito: «De Isaac sairá uma descendência que terá o teu nome»."
,"19":"De facto, Abraão pensava que Deus é capaz de ressuscitar os mortos. Por isso, Abraão recuperou o seu filho. E isso tornou-se um símbolo."
,"20":"Pela fé, Isaac abençoou Jacob e Esaú, também a respeito de coisas futuras."
,"21":"Pela fé, Jacob, agonizante, abençoou cada um dos filhos de José, e prostrou-se, apoiando-se na extremidade do seu bastão."
,"22":"Pela fé, José mencionou, já no fim da vida, o êxodo dos filhos de Israel, e deu ordens sobre o que deveria ser feito com o seu cadáver."
,"23":"Pela fé, Moisés recém-nascido foi escondido pelos seus pais durante três meses, porque viram que o menino era bonito. Eles não tiveram medo do decreto do rei."
,"24":"Pela fé, quando já era adulto, Moisés recusou ser chamado filho da filha do Faraó;"
,"25":"preferiu ser maltratado com o povo de Deus, a gozar por pouco tempo os prazeres do pecado."
,"26":"Fez isto porque considerava a humilhação de Cristo uma riqueza maior do que os tesouros do Egipto; de facto, olhava para a recompensa."
,"27":"Pela fé, Moisés deixou o Egipto, sem temer a ira do rei; permaneceu firme, como se visse o invisível."
,"28":"Pela fé, celebrou a Páscoa e marcou as portas com sangue, para que o exterminador não matasse os primogénitos de Israel."
,"29":"Pela fé, atravessaram o Mar Vermelho como se fosse terra seca, enquanto os egípcios, tentando passar, se afogaram."
,"30":"Pela fé, caíram os muros de Jericó, após as voltas ao seu redor durante sete dias."
,"31":"Pela fé, a prostituta Raab não morreu com os incrédulos, porque acolheu bem os espiões israelitas."
,"32":"Que mais posso dizer? Faltar-me-ia tempo, se quisesse falar de Gedeão, de Barac, de Sansão, de Jefté, de David, de Samuel e dos profetas."
,"33":"Graças à fé, eles conquistaram reinos, implantaram a justiça, alcançaram as promessas, fecharam as bocas dos leões,"
,"34":"apagaram a violência do fogo, escaparam ao fio da espada, extraíram força da sua própria fraqueza, mostraram-se valentes na guerra e expulsaram invasores estrangeiros."
,"35":"E algumas mulheres recuperaram os seus mortos, por meio da ressurreição. Outros foram esquartejados, recusando a libertação que lhes era oferecida, a fim de alcançarem uma ressurreição mais valiosa. "
,"36":"Outros, enfim, foram humilhados e espancados, amarrados e lançados na prisão."
,"37":"Foram apedrejados, serrados ao meio, mortos ao fio de espada. Andaram errantes, vestidos de peles de ovelha e de cabra, necessitados, atribulados, maltratados."
,"38":"Esses homens tinham que vaguear por desertos e montanhas e refugiar-se em grutas e buracos. O mundo não era digno deles!"
,"39":"Todos eles foram aprovados por Deus por causa da fé que tinham. Mas nenhum deles alcançou a promessa."
,"40":"Deus preparou-nos algo de melhor, a fim de que, sem nós, eles não obtivessem a perfeição."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Portanto, estamos rodeados dessa grande nuvem de testemunhas. Deixemos de lado tudo o que nos embaraça e o pecado que se agarra a nós. Corramos com perseverança a corrida,"
,"2":"mantendo os olhos fixos em Jesus, autor e consumador da fé. Em troca da alegria que Lhe era proposta, Ele submeteu-Se à cruz, desprezando a vergonha, e sentou-Se à direita do trono de Deus."
,"3":"Para que vos não canseis e não percais o ânimo, pensai atentamente em Jesus, que suportou contra Si tão grande hostilidade por parte dos pecadores."
,"4":"Ainda não resististes até ao derramamento do sangue na luta contra o pecado,"
,"5":"e já vos esquecestes da exortação que vos foi dirigida como a filhos: «Meu filho, não desprezes a correcção do Senhor e não percas o ânimo quando fores repreendido por Ele;"
,"6":"pois o Senhor corrige a quem Ele ama e castiga a quem aceita como filho»."
,"7":"É para vossa correcção que sofreis. Deus trata-vos como filhos. E qual é o filho que não é corrigido pelo pai?"
,"8":"Pelo contrário, se não sois corrigidos, como acontece com todos, então sois bastardos e não filhos."
,"9":"Além disso, tivemos os nossos pais humanos que nos corrigiam e que nós respeitávamos. Será que não devemos submeter-nos muito mais ao Pai dos espíritos para termos a vida?"
,"10":"Os nossos pais corrigiam-nos durante pouco tempo e como melhor lhes pareceu; Deus, porém, corrige-nos para nosso bem, a fim de sermos participantes da sua própria santidade."
,"11":"No momento em que é aplicada, qualquer correcção parece não ser motivo de alegria, mas de tristeza; porém, mais tarde, produz um fruto de paz e de justiça naqueles que foram corrigidos."
,"12":"Por isso, levantai as mãos cansadas e fortalecei os joelhos enfraquecidos."
,"13":"Endireitai os caminhos por onde tereis que passar, a fim de que o aleijado não coxeie, mas seja curado."
,"14":"Procurai estar em paz com todos. Progredi na santidade, porque sem ela ninguém verá o Senhor."
,"15":"Vigiai para que ninguém abandone a graça de Deus. Que nenhuma raiz venenosa cresça no meio de vós, provocando perturbação e contaminando a comunidade."
,"16":"Não haja nenhum impudico ou profanador, como Esaú que vendeu os seus direitos de filho primogénito em troca de um prato de comida."
,"17":"E vós bem sabeis que a seguir foi rejeitado, quando quis obter a bênção como herança, porque não encontrou a possibilidade de o seu pai mudar de decisão, embora lho pedisse com lágrimas."
,"18":"Vós não vos aproximastes de uma realidade palpável. Ali havia fogo ardente, escuridão, trevas, tempestade,"
,"19":"som de trombeta e ruído de palavras. E as pessoas que ouviram isso, suplicaram a Deus que não dissesse mais nada,"
,"20":"pois não suportavam o que fora ordenado: «Até um animal será apedrejado se tocar a montanha»."
,"21":"Eles ficaram tão espantados com aquele espectáculo, que Moisés disse: «Estou apavorado e com medo»."
,"22":"Entretanto, vós aproximastes-vos do monte Sião e da Jerusalém celeste, a cidade do Deus vivo. Vós aproximastes-vos de milhares de anjos reunidos em festa,"
,"23":"e da assembleia dos primogénitos que têm o nome inscrito no Céu. Aproximastes-vos de Deus, que é juiz de todos. Aproximastes-vos dos espíritos justos que chegaram à meta final,"
,"24":"e de Jesus, o mediador de uma nova aliança. Aproximastes-vos do sangue da aspersão, que fala muito mais alto que o sangue de Abel."
,"25":"Cuidado! Não recuseis escutar Aquele que vos fala. As pessoas que recusaram escutar Aquele que as advertia na terra, não escaparam do castigo. E menos ainda escaparemos nós do castigo, se nos afastarmos de quem nos fala do alto do Céu."
,"26":"Aquele, cuja voz um dia abalou a Terra, agora diz: «Mais uma vez farei estremecer, não somente a Terra, mas também o Céu»."
,"27":"A expressão «mais uma vez» anuncia o desaparecimento de tudo aquilo que participa da instabilidade do mundo criado, para que permaneça só o que é inabalável."
,"28":"Já que recebemos um reino inabalável, conservemos bem essa graça. Por meio dela, sirvamos a Deus de tal modo que Lhe agrademos, isto é, com respeito e temor."
,"29":"Pois o nosso Deus é um fogo devorador."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Perseverai no amor fraterno."
,"2":"Não vos esqueçais da hospitalidade, pois algumas pessoas, graças a ela, sem saber acolheram anjos."
,"3":"Lembrai-vos dos presos como se estivésseis na prisão com eles. Lembrai-vos dos que são torturados, pois vós também tendes um corpo."
,"4":"Que todos respeitem o matrimónio e não desonrem o leito nupcial, pois Deus julgará os libertinos e adúlteros."
,"5":"Que a vossa conduta não seja inspirada pelo amor ao dinheiro. Cada um fique satisfeito com o que tem, pois Deus disse: «Eu nunca te deixarei, nunca te abandonarei»."
,"6":"Assim, podemos dizer com ânimo: «O Senhor está comigo, eu não temo. O que é que me poderá fazer um homem?»"
,"7":"Lembrai-vos dos dirigentes, que vos ensinaram a Palavra de Deus. Imitai a fé que eles tinham, tendo presente o modo como eles morreram. O verdadeiro culto - "
,"8":"Jesus Cristo é o mesmo, ontem e hoje, e será sempre o mesmo."
,"9":"Não vos deixeis levar por nenhum tipo de doutrinas estranhas. O melhor é fortalecer o coração pela graça, e não com regras alimentares, que de nada serviam para quem as observava."
,"10":"Nós temos um altar, do qual não têm direito de comer aqueles que ainda servem na Tenda."
,"11":"De facto, depois de o sumo sacerdote ter oferecido o sangue no santuário pelos pecados do povo, os corpos dos animais oferecidos em sacrifício são queimados fora do recinto sagrado."
,"12":"Por esse motivo, também Jesus sofreu a sua paixão fora de Jerusalém, quando purificou o povo com o seu próprio sangue."
,"13":"Portanto, saiamos também do recinto sagrado para ir ao encontro de Jesus, levando a sua humilhação."
,"14":"Pois nós não temos aqui a nossa pátria definitiva, mas buscamos a pátria futura."
,"15":"Portanto, ofereçamos continuamente, por meio de Jesus, um sacrifício de louvor a Deus, isto é, o fruto de lábios que confessam o seu Nome."
,"16":"Não vos esqueçais de ser generosos, e reparti com os outros, porque são esses os sacrifícios que agradam a Deus."
,"17":"Respeitai os dirigentes e sede-lhes dóceis, pois eles dedicam-se pelo vosso bem e terão que prestar contas disso. Assim, eles poderão fazê-lo com alegria e não gemendo, o que não seria vantajoso para vós."
,"18":"Rezai por nós, pois acreditamos que as nossas intenções são puras e só queremos agir bem em tudo."
,"19":"Rezai com insistência ainda maior para que eu possa voltar mais depressa para junto de vós."
,"20":"O Deus da paz, que ressuscitou dos mortos a Jesus nosso Senhor, que é o Pastor supremo das ovelhas por ter derramado o sangue da Aliança eterna,"
,"21":"vos torne perfeitos em todo o bem. Assim podereis cumprir a sua vontade, realizando em vós aquilo que agrada a Deus, por meio de Jesus Cristo. A Ele seja dada glória para sempre. Ámen."
,"22":"Irmãos, peço-vos que acolhais esta palavra de exortação. Foi por causa disso que vos escrevi poucas palavras."
,"23":"Quero informar-vos que o nosso irmão Timóteo foi posto em liberdade. Se vier depressa, levá-lo-ei comigo quando aí for ter convosco."
,"24":"Saudações a todos os dirigentes e a todos os cristãos. Os da Itália mandam-vos saudações."
,"25":"Que a graça esteja com todos vós."
}`)

}
func PT_BS_LoadVH1MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"O macedónio Alexandre, filho de Filipe, já era senhor da Hélade. Ele saiu do país de Cetim, venceu Dario, rei dos Persas e Medos, e tornou-se rei em seu lugar."
,"2":"Fez numerosas guerras, apoderou-se de fortalezas e exterminou os reis da terra."
,"3":"Chegou até aos confins do mundo, apoderando-se das riquezas de numerosas nações. O mundo calou-se diante dele. Depois disso, ele exaltou-se e encheu-se de orgulho."
,"4":"Formou um exército poderosíssimo, subjugou países, nações e ditadores, obrigando-os a pagar tributos."
,"5":"Depois, adoeceu gravemente e percebeu que ia morrer."
,"6":"Então convocou os seus oficiais, aqueles nobres que tinham sido seus companheiros desde a mocidade, e ainda vivo repartiu por eles o seu império."
,"7":"Alexandre reinou doze anos, e morreu."
,"8":"Os seus oficiais assumiram o poder, cada um na própria região."
,"9":"Todos eles se fizeram coroar reis, e depois passaram a coroa para os filhos durante muitos anos. E os males multiplicaram-se no mundo."
,"10":"Deles brotou um ramo perverso, chamado Antíoco Epifânio, filho do rei Antíoco. Ele estivera em Roma como refém, mas, no ano cento e trinta e sete da dominação grega, tornou-se rei."
,"11":"Nessa época, brotou em Israel uma geração de ímpios, que persuadiram muitas pessoas, dizendo: «Vamos fazer aliança com as nações vizinhas, porque, desde que nos afastámos delas, muitos males nos aconteceram»."
,"12":"Essa proposta agradou a muita gente."
,"13":"Alguns do povo tomaram a iniciativa e foram ter com o rei, que lhes deu permissão para introduzirem os costumes pagãos."
,"14":"Foi assim que construíram em Jerusalém uma praça para desportos de acordo com os usos pagãos."
,"15":"Disfarçaram a circuncisão e renegaram a aliança sagrada. Associaram-se às nações pagãs e venderam-se para praticar o mal."
,"16":"Tendo consolidado o seu reino, Antíoco projectou também tornar-se rei do Egipto, para dominar os dois reinos."
,"17":"Entrou no Egipto com um exército imponente, carros de guerra e elefantes, cavalaria e muitos navios."
,"18":"Entrou em combate contra Ptolomeu, rei do Egipto, que recuou e fugiu, ficando pelo chão muitos feridos."
,"19":"As cidades fortificadas do Egipto foram tomadas, e Antíoco saqueou as riquezas do país."
,"20":"Voltando no ano cento e quarenta e três, após ter vencido o Egipto, Antíoco atacou Israel e Jerusalém com um poderoso exército."
,"21":"Depois de entrar no Templo com toda a arrogância, Antíoco levou o altar de ouro, o candelabro com todos os acessórios,"
,"22":"a mesa dos pães oferecidos a Deus, as vasilhas para as libações, as taças, os incensórios de ouro, a cortina, as coroas e as placas de ouro que ornavam a fachada do Templo. Saqueou tudo."
,"23":"Levou também a prata, o ouro, os objectos de valor e até as riquezas escondidas que conseguiu encontrar."
,"24":"Tomou tudo e foi para a sua terra, depois de causar muitas mortes e proferir palavras de extrema arrogância."
,"25":"Em todo o Israel, em todos os lugares, houve uma grande lamentação:"
,"26":"«Chefes e anciãos gemeram, rapazes e raparigas perderam o seu vigor, e murchou a beleza das mulheres."
,"27":"Todo o recém-casado entoou um cântico fúnebre e a esposa ficou de luto no seu quarto de casal."
,"28":"A terra tremeu por causa dos seus habitantes, e toda a família de Jacob se cobriu de vergonha»."
,"29":"Dois anos depois, o rei mandou às cidades de Judá um cobrador de impostos, que entrou em Jerusalém acompanhado de poderoso exército."
,"30":"Com falsa proposta de paz, ganhou a confiança dos habitantes e, de repente, caiu sobre a cidade, aplicando-lhe violento golpe e provocando a morte de muita gente em Israel."
,"31":"Saqueou a cidade, incendiou-a e destruiu as suas casas e muralhas."
,"32":"Levaram prisioneiras mulheres e crianças, e roubaram todo o gado."
,"33":"Em seguida construíram ao redor da Cidade de David uma alta e resistente muralha, além de torres de guarda bem reforçadas, de modo que ficou a ser a fortaleza deles."
,"34":"Colocaram nela gente ímpia, homens cruéis, que lá se instalaram."
,"35":"Abasteceram a fortaleza com armas e alimentos, e lá depositaram o saque que haviam tirado a Jerusalém. Desse modo, transformaram-se num grande perigo,"
,"36":"em armadilha contra o Templo e ameaça contínua para Israel."
,"37":"Derramaram sangue inocente ao redor do Templo e profanaram o lugar santo."
,"38":"Por causa deles, os moradores de Jerusalém fugiram, e Jerusalém transformou-se em morada de estrangeiros. A cidade tornou-se estranha à sua própria gente, e os seus filhos abandonaram-na."
,"39":"O seu santuário tornou-se um deserto, as suas festas transformaram-se em luto, os seus sábados em vergonha e a sua honra em humilhação."
,"40":"A sua humilhação foi tão grande como o seu antigo prestígio, e o seu esplendor transformou-se em luto."
,"41":"O rei publicou um decreto, determinando que o reino inteiro formasse um só povo,"
,"42":"e cada qual deixasse de lado os seus costumes particulares. Todas as nações obedeceram ao decreto do rei."
,"43":"Entre os israelitas, muitos gostaram da religião do rei e passaram a oferecer sacrifícios aos ídolos e a profanar o sábado."
,"44":"Além disso, através de mensageiros, o rei mandou a Jerusalém e às cidades de Judá um documento com várias ordens: Tinham que adoptar a legislação estrangeira;"
,"45":"proibia oferecer holocaustos, sacrifícios e libações no Templo e também guardar os sábados e festas;"
,"46":"mandava contaminar o santuário e objectos sagrados,"
,"47":"construindo altares, templos e oratórios para os ídolos, e imolar porcos e outros animais impuros;"
,"48":"ordenava que não circuncidassem os filhos e que se profanassem a si próprios com todo o tipo de impurezas e abominações,"
,"49":"esquecendo a Lei e mudando todos os costumes."
,"50":"Quem não obedecia à ordem do rei, incorria em pena de morte."
,"51":"O rei mandou documentos escritos que continham as ordens para todo o seu reino. Nomeou fiscais sobre todo o povo e determinou que as cidades de Judá, uma após outra, deveriam oferecer sacrifícios."
,"52":"Muita gente do povo passou para o lado dos traidores da Lei. Começaram a praticar o mal no país,"
,"53":"e os israelitas tiveram que se esconder em qualquer refúgio disponível."
,"54":"No dia quinze do mês de Casleu do ano cento e quarenta e cinco, Antíoco colocou sobre o altar dos holocaustos a Abominação da Desolação. Pelas cidades de Judá em redor, construíram-se também outros altares."
,"55":"Passaram a queimar incenso até nas portas das casas e pelas praças."
,"56":"Rasgavam e queimavam os livros da Lei que encontravam."
,"57":"Quando encontravam um livro da Aliança em poder de alguém, ou se alguém concordasse em seguir a Lei, o decreto do rei condenava essa pessoa à morte."
,"58":"Como detinham o poder, cada mês faziam isso com todos os israelitas que encontravam pelas cidades."
,"59":"No dia vinte e cinco de cada mês, ofereciam-se sacrifícios no altar colocado sobre o altar dos holocaustos."
,"60":"De acordo com o decreto, matavam as mulheres que tinham circuncidado os seus filhos,"
,"61":"juntamente com os filhos que elas levavam ao colo, com os familiares e com as pessoas que tinham feito a circuncisão às crianças."
,"62":"Muitos israelitas, porém, permaneceram firmes, e não havia quem os fizesse comer alguma coisa que fosse impura."
,"63":"Antes preferiam morrer do que contaminar-se com esses alimentos e profanar a santa Aliança. E muitos morreram."
,"64":"Assim, desencadeou-se uma grande ira sobre Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Nessa ocasião, Matatias, filho de João e neto do sacerdote Simeão, da descendência de Joiarib, saiu de Jerusalém para ir morar em Modin."
,"2":"Tinha cinco filhos: João, que tinha o apelido de Gadi;"
,"3":"Simão, conhecido por Tasi;"
,"4":"Judas, chamado Macabeu;"
,"5":"Eleazar, chamado Auarã; e Jónatas, chamado Afus."
,"6":"Vendo os absurdos que aconteciam em Judá e Jerusalém,"
,"7":"Matatias disse: «Infeliz de mim! Para que fui nascer? Só para ver a desgraça do meu povo e da Cidade Santa? Para ficar aí sentado, enquanto ela vai sendo entregue nas mãos dos inimigos, enquanto o seu Templo sagrado cai nas mãos de estrangeiros?"
,"8":"O seu Templo parece um homem desonrado:"
,"9":"os adornos magníficos que o enfeitavam foram levados como saque; as suas crianças foram assassinadas nas praças, e os seus jovens foram mortos pela espada do inimigo."
,"10":"Qual foi a nação que não invadiu os seus palácios e não tomou posse dos seus despojos?"
,"11":"Tudo o que servia de enfeite foi roubado; era livre, e agora tornou-se escravo!"
,"12":"Vede! O nosso santuário, que era a nossa beleza e o nosso orgulho, está deserto, profanado pelos pagãos!"
,"13":"Para quê continuar a viver?»"
,"14":"Matatias e seus filhos rasgaram as vestes, vestiram-se com pano de saco e fizeram grande luto."
,"15":"Os funcionários do rei chegaram à cidade de Modin para fazer com que o povo mudasse de religião e oferecesse sacrifícios."
,"16":"Muitos israelitas aderiram a eles; porém, Matatias e seus filhos ficaram de lado."
,"17":"Os funcionários do rei disseram a Matatias: «Tu és uma personagem ilustre, homem importante nesta cidade, apoiado por filhos e parentes."
,"18":"Então vai à frente para cumprir as determinações do rei, conforme fizeram todas as nações, os cidadãos de Judá e os que ficaram em Jerusalém. Assim tu e os teus filhos passareis a fazer parte dos amigos do rei e sereis recompensados com prata, ouro e muitos presentes»."
,"19":"Matatias respondeu em voz alta: «Mesmo quando todas as nações que moram dentro dos domínios do rei obedecerem à sua ordem e abandonarem a religião dos seus antepassados para se conformarem com as determinações dele,"
,"20":"eu, os meus filhos e os meus parentes continuaremos a viver de acordo com a Aliança dos nossos antepassados."
,"21":"Deus nos livre de abandonar a Lei e as tradições!"
,"22":"Não! Nós não vamos obedecer às ordens do rei. Não vamos desviar-nos da nossa religião, nem para a direita, nem para a esquerda»."
,"23":"Mal acabava Matatias de dizer isto, quando um judeu tomou a dianteira, diante de todos, para oferecer o sacrifício no altar de Modin, seguindo as determinações do rei."
,"24":"Vendo isso, Matatias indignou-se, tremeu de raiva e, num impulso de ira santa, avançou sobre o apóstata e matou-o sobre o altar."
,"25":"Imediatamente matou também o funcionário do rei, que obrigava o povo a oferecer o sacrifício, e demoliu o altar."
,"26":"Ele estava a agir por amor à Lei, do mesmo modo como Fineias fez com Zambri, filho de Salu."
,"27":"Depois disso, Matatias foi gritando pela cidade: «Quem tiver amor pela Lei e quiser permanecer na Aliança, que me acompanhe»."
,"28":"Ele e os seus filhos fugiram para as montanhas, abandonando na cidade tudo o que possuíam."
,"29":"Muitos que amavam a justiça e o direito desceram ao deserto e lá ficaram"
,"30":"com os seus filhos, mulheres e rebanhos, pois a perseguição contra eles ia aumentando."
,"31":"Denunciaram aos oficiais do rei e à guarnição estabelecida em Jerusalém, na Cidade de David, que algumas pessoas tinham desobedecido às ordens do rei e descido para as cavernas do deserto."
,"32":"Muitos desses homens do rei correram atrás deles e alcançaram-nos. Acamparam em volta deles e organizaram-se para os atacar num dia de sábado."
,"33":"Quando tudo ficou pronto, disseram-lhes: «Agora chega! Saí daí, fazei aquilo que o rei ordenou, e a vossa vida estará salva»."
,"34":"Eles responderam: «Não vamos sair, nem cumprir a ordem do rei, profanando o dia de sábado»."
,"35":"Então aqueles começaram a atacá-los."
,"36":"Eles, porém, não reagiram, não atiraram uma única pedra, nem mesmo fecharam a entrada dos seus esconderijos."
,"37":"Disseram apenas: «Vamos morrer com a consciência limpa. O Céu e a Terra são testemunhas de que vós nos estais a matar injustamente»."
,"38":"Assim mesmo, os homens do rei atacaram-nos em dia de sábado. E eles morreram, com as suas mulheres, crianças e rebanhos. Eram cerca de mil pessoas."
,"39":"Ao saber do caso, Matatias e os seus companheiros choraram amargamente."
,"40":"E comentavam entre si: «Se todos fizermos como aqueles nossos irmãos, se não lutarmos contra os pagãos pela nossa vida e pelas nossas tradições, eles em breve nos eliminarão da face da Terra»."
,"41":"E, nesse mesmo dia, tomaram esta decisão: «Lutaremos abertamente contra todo aquele que nos atacar em dia de sábado. Assim não morreremos todos, como os nossos irmãos nos seus esconderijos»."
,"42":"A partir daí, uniu-se a eles o grupo dos assideus, que eram israelitas fortes, corajosos e fiéis à Lei."
,"43":"Além disso, todos os que conseguiam escapar das desgraças uniam-se a eles e reforçavam ainda mais o grupo."
,"44":"Desse modo, organizaram um exército e descarregaram a sua fúria contra os pecadores e a sua cólera contra os apóstatas. Os restantes fugiram, buscando refúgio entre os pagãos."
,"45":"Depois disso, Matatias e seus companheiros fizeram incursões pelo país, derrubando os altares"
,"46":"e circuncidando à força os meninos que encontravam sem circuncisão no território de Israel."
,"47":"Começaram a perseguir os soberbos, e a campanha teve sucesso."
,"48":"Defenderam a Lei diante da prepotência dos povos e reis, e não deram o braço a torcer aos pecadores."
,"49":"Quando se aproximou da morte, Matatias disse aos seus filhos: «Agora a insolência e o ultraje estão a ter muita força; é um tempo de destruição e ódio violento."
,"50":"Portanto, meus filhos, cuidai de cumprir a Lei com zelo e dai as vossas vidas para defender a Aliança dos vossos antepassados."
,"51":"Lembrai-vos de como agiram os antepassados no tempo deles, e conseguireis honra sem par e fama para sempre."
,"52":"Abraão foi fiel na prova, e isso foi-lhe considerado como justiça."
,"53":"José observou os mandamentos no tempo do perigo, e chegou a ser dono do Egipto."
,"54":"O nosso pai Fineias recebeu o encargo do sacerdócio permanente, por causa do seu grande zelo."
,"55":"Josué tornou-se juiz de Israel, por ter obedecido à Palavra."
,"56":"Caleb recebeu uma terra em herança, por ter dado testemunho diante da comunidade."
,"57":"David recebeu o trono de rei para sempre, por causa da sua bondade."
,"58":"Elias foi arrebatado ao céu, por causa do seu ardente zelo pela Lei."
,"59":"Ananias, Azarias e Misael foram salvos da fornalha, por causa da sua fé."
,"60":"Daniel ficou livre da boca dos leões, por causa da sua inocência."
,"61":"E assim, repassando as gerações, compreendereis que jamais fraquejam aqueles que esperam em Deus."
,"62":"Não temais as ameaças de um pecador, pois a sua glória transformar-se-á em esterco e podridão."
,"63":"Hoje ele é exaltado, mas amanhã desaparecerá: voltará ao pó de onde veio, e o seu projecto fracassará."
,"64":"Meus filhos, sede fortes e apegai-vos firmemente à Lei, pois ela será a vossa glória."
,"65":"Aí está Simeão, vosso irmão. Eu sei que ele é homem equilibrado. Obedecei-lhe sempre, e ele será um pai para vós."
,"66":"Judas Macabeu, homem corajoso desde novo, será o comandante do vosso exército e dirigirá a guerra contra os pagãos."
,"67":"Procurai reunir à vossa volta todos os que praticam a Lei, para vigiar o povo."
,"68":"Fazei com que os estrangeiros paguem pelo mal que fizeram, e observai sempre os mandamentos da Lei»."
,"69":"Depois, Matatias abençoou-os e reuniu-se aos seus antepassados."
,"70":"Morreu no ano cento e quarenta e seis, e foi sepultado em Modin, no túmulo da sua família. Todo o Israel lamentou muito a sua morte."
}`)
	CurrentBook.AddChapter(3, `{
"1":"No lugar de Matatias ficou o seu filho Judas, apelidado Macabeu."
,"2":"Seus irmãos e todos os que tinham ficado do lado de seu pai deram-lhe apoio e partiram com entusiasmo, lutando por Israel."
,"3":"Judas alargou a fama do seu povo; vestiu a couraça como gigante, empunhou as armas e sustentou muitas batalhas, defendendo o acampamento com a espada."
,"4":"Por suas façanhas parecia um leão, um leãozinho rugindo em cima da presa."
,"5":"Farejava e desentocava os apóstatas, e queimava os que perturbavam o seu povo."
,"6":"Com medo de Judas, os apóstatas acovardaram-se e os malfeitores ficaram confundidos. Por meio dele, a libertação triunfou."
,"7":"Ele causou dissabores a muitos reis, mas alegrou Jacob com as suas façanhas, e a sua memória será sempre elogiada."
,"8":"Percorreu as cidades de Judá, exterminando os injustos, e afastou de Israel a ira divina."
,"9":"A sua fama percorreu todo o país, porque ele reuniu um povo que estava a morrer."
,"10":"Apolónio reuniu pagãos e um forte contingente militar da Samaria, a fim de lutar contra Israel."
,"11":"Ao saber disso, Judas saiu para o enfrentar. Conseguiu vencer e matar Apolónio, do qual muitos soldados tombaram mortos, e o resto fugiu."
,"12":"Ao recolher os despojos, Judas pegou na espada de Apolónio e, daí para a frente, passou a lutar sempre com ela."
,"13":"Seron, general do exército sírio, ouviu dizer que Judas tinha reunido em torno de si um partido numeroso, formado de homens fiéis e dispostos para a guerra."
,"14":"Ele pensou: «Vou ficar famoso e ganhar prestígio no reino, lutando contra Judas e seus partidários, que desprezam as ordens do rei»."
,"15":"Então Seron preparou-se, e juntou-se a ele um grande exército de gente ímpia, que subiu com ele para se vingar dos israelitas."
,"16":"Seron avançou até à subida de Bet-Horon, onde Judas foi enfrentá-lo com pouca gente."
,"17":"Ao ver a multidão que se vinha aproximando para os enfrentar, os homens de Judas disseram-lhe: «Somos poucos. Como é que podemos enfrentar essa multidão forte e armada? Além disso, estamos cansados. Hoje ainda não comemos nada»."
,"18":"Judas respondeu: «Não é difícil que muitos caiam na mão de poucos. Não faz diferença para Deus salvar com poucos ou salvar com muitos."
,"19":"A vitória na guerra não depende da multidão de soldados, mas da força que vem do Céu."
,"20":"Eles vêm contra nós cheios de insolência e injustiça, para nos eliminar a nós, às nossas mulheres e aos nossos filhos, e levar tudo o que temos."
,"21":"Nós, porém, lutamos pela nossa vida e as nossas leis."
,"22":"Por isso, Deus vai esmagá-los diante de nós! Não tenhais medo»."
,"23":"Judas acabou de falar e atacou-os de surpresa. E Seron com o seu exército foram esmagados diante de Judas."
,"24":"Os homens de Judas perseguiram o inimigo pela baixa de Bet-Horon, até à planície. Seron perdeu oitocentos homens, e o resto fugiu para a região dos filisteus."
,"25":"Então Judas e seus companheiros começaram a ser temidos, e o pavor dominou as nações vizinhas."
,"26":"A sua fama chegou até ao rei, porque todas as nações comentavam as batalhas de Judas."
,"27":"Logo que soube disso, o rei Antíoco ficou furioso e mandou concentrar todas as forças do reino, formando um exército poderosíssimo."
,"28":"Abriu o seu tesouro e adiantou o soldo de um ano a todo o exército, ordenando que ficasse preparado para qualquer eventualidade."
,"29":"Percebeu, porém, que as reservas do tesouro não bastavam e as entradas que vinham das províncias eram poucas, por causa das revoltas e ruínas que ele tinha espalhado no país, para acabar com as leis antigas."
,"30":"E ficou com medo de não ter, como já havia acontecido outras vezes, o suficiente para as despesas e para os presentes que costumava distribuir mais que os reis anteriores."
,"31":"Vendo-se em apuros, resolveu recorrer à Pérsia, para recolher os tributos daquelas províncias e juntar grande soma de dinheiro."
,"32":"Antes disso, deixou Lísias, membro distinto da família real, à frente dos negócios do rei, desde o rio Eufrates até à fronteira do Egipto."
,"33":"Encarregou-o de cuidar do seu filho Antíoco, até ao seu regresso."
,"34":"Colocou sob o seu comando metade das suas tropas, inclusive os elefantes, e encarregou-o de tudo o que queria, especialmente em relação aos habitantes da Judeia e de Jerusalém."
,"35":"Lísias deveria mandar um exército para derrotar e destruir o exército de Israel e o que ainda restasse em Jerusalém, fazendo assim desaparecer desse lugar a lembrança dessa gente."
,"36":"Depois, Lísias deveria colocar estrangeiros em todo o território e dividir o país em lotes."
,"37":"Levando metade das suas tropas, o rei partiu de Antioquia, capital do seu reino, no ano cento e quarenta e sete. Depois de atravessar o rio Eufrates, percorreu as províncias do planalto."
,"38":"Lísias escolheu Ptolomeu, filho de Dorímenes, e Nicanor, juntamente com Górgias, homens poderosos e influentes no reino,"
,"39":"e enviou-os com quarenta mil homens de infantaria e sete mil cavaleiros, a fim de invadir o país de Judá e arrasá-lo, conforme as determinações do rei."
,"40":"Puseram-se em marcha com todo o exército e acamparam na planície, perto de Emaús."
,"41":"Quando os traficantes da região souberam da notícia, correram para o acampamento com grande quantidade de prata, ouro e correntes, a fim de comprar os israelitas como escravos. Ao exército juntaram-se ainda tropas edomitas e filisteias."
,"42":"Judas e os seus companheiros perceberam que a situação se estava a agravar muito: o exército inimigo já estava acampado na região. Eles ficaram também a saber que o rei tinha dado ordens para destruir e exterminar o povo."
,"43":"E comentaram: «Vamos reerguer da ruína o nosso povo. Vamos lutar pelo nosso povo e pelo Templo»."
,"44":"Então foi convocada uma assembleia, a fim de que todos pudessem estar preparados para a luta e também para rezar, pedindo a Deus piedade e compaixão."
,"45":"Jerusalém estava despovoada como um deserto. Nenhum dos seus filhos entrava ou saía. O santuário foi pisado e os estrangeiros ocupavam a fortaleza, transformada em hospedaria de pagãos. Jacob perdeu a alegria, e já não se ouviam mais nem a flauta nem a cítara."
,"46":"Reuniram-se todos e foram para Masfa, lugar que fica em frente de Jerusalém, porque foi aí o primeiro lugar de oração em Israel."
,"47":"Nesse dia, eles jejuaram, vestiram-se de luto, puseram cinza na cabeça e rasgaram as vestes."
,"48":"Depois desenrolaram o livro da Lei, para o consultar, da mesma forma que os pagãos consultavam os seus ídolos."
,"49":"Levaram também as vestimentas dos sacerdotes, os primeiros frutos e os dízimos, e convocaram os nazireus que tinham terminado o tempo do seu voto."
,"50":"Todos levantaram a voz ao céu, gritando: «Que podemos fazer desta gente? Para onde os levaremos?"
,"51":"O teu Templo foi pisado e profanado, os teus sacerdotes estão de luto e humilhados!"
,"52":"Vê! Os pagãos uniram-se contra nós, para nos aniquilar. Tu bem sabes o que eles planeiam contra nós."
,"53":"Como poderemos resistir, se Tu não nos ajudares?»"
,"54":"Em seguida, tocaram as trombetas e levantaram grande clamor."
,"55":"Então Judas nomeou os comandantes do exército: comandantes de mil, de cem, de cinquenta e de dez."
,"56":"Mandou voltar para casa os que andavam a construir, os que tinham acabado de se casar, os que estavam a cuidar das vinhas e os que andavam com medo, tudo conforme a Lei ordena."
,"57":"Então o exército levantou acampamento e foi acampar ao Sul de Emaús."
,"58":"Judas ordenou: «Preparai-vos. Sede firmes e corajosos e ficai prontos para amanhã entrar em combate contra esses pagãos. Eles aliaram-se contra nós, com a intenção de nos destruir, a nós e ao nosso Templo."
,"59":"É melhor morrer na batalha do que ficar a ver a desgraça do nosso povo e do nosso Templo."
,"60":"Seja feita a vontade de Deus»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Górgias pegou em cinco mil soldados de infantaria e mil cavaleiros escolhidos. Saiu de noite"
,"2":"para poder atacar de surpresa o acampamento dos judeus e acabar com eles de uma vez. A gente da fortaleza serviu-lhes de guia."
,"3":"Sabendo do plano, Judas levantou acampamento com o seu exército e foi atacar a parte do exército do rei que tinha ficado em Emaús,"
,"4":"enquanto alguns batalhões estavam longe do acampamento."
,"5":"Quando Górgias chegou, de noite, ao acampamento de Judas, não encontrou ninguém. Começou então a procurá-los pelas montanhas, pensando que tivessem fugido."
,"6":"Ao amanhecer, Judas chegou à planície com três mil homens, mas sem escudos e espadas suficientes."
,"7":"Quando viram que o acampamento dos pagãos era forte e estava bem guardado, rodeado de cavaleiros treinados para a guerra,"
,"8":"Judas disse aos seus homens: «Não tenhais medo da quantidade deles, nem vos apavoreis com o seu ataque."
,"9":"Lembrai-vos de como os nossos antepassados foram salvos no Mar Vermelho, quando o Faraó com o seu exército os perseguia."
,"10":"Vamos gritar a Deus para que nos ajude e Se lembre da Aliança com os nossos antepassados e derrote hoje este exército que está à nossa frente."
,"11":"Então todas as nações reconhecerão que existe Alguém que resgata e liberta Israel»."
,"12":"Quando os estrangeiros levantaram os olhos e os viram chegar pela frente,"
,"13":"saíram do acampamento para a batalha. Os homens de Judas tocaram a trombeta"
,"14":"e atacaram. Os pagãos foram derrotados e fugiram para a planície."
,"15":"Os que estavam na retaguarda foram mortos à espada. Os israelitas perseguiram-nos até Gazara e até às planícies da Idumeia, de Azoto e de Jâmnia. E o inimigo perdeu cerca de três mil homens."
,"16":"Ao voltar da perseguição aos fugitivos,"
,"17":"Judas falou aos soldados: «Não fiqueis cobiçando os despojos, pois temos mais um combate pela frente:"
,"18":"Górgias e o seu batalhão estão no monte aqui perto de nós. Sede firmes contra os nossos inimigos e lutai contra eles. Depois, podereis recolher os despojos com toda a tranquilidade»."
,"19":"Judas ainda falava, quando se avistou uma patrulha deles que espiava do alto do monte."
,"20":"A patrulha viu que os companheiros tinham fugido e que o acampamento estava incendiado: o fumo que se via denunciava o que tinha acontecido."
,"21":"Ao ver isso, ficaram completamente apavorados e, quando viram o exército de Judas na planície, preparado para o confronto,"
,"22":"fugiram todos para a região dos filisteus."
,"23":"Então Judas voltou para saquear o acampamento: capturou muito ouro e prata, tecidos de púrpura comum e de púrpura marinha, e muita coisa de valor."
,"24":"Voltaram cantando hinos e louvando a Deus, «porque Ele é bom e o seu amor é para sempre»."
,"25":"E, nesse dia, Israel conseguiu uma grande vitória."
,"26":"Os estrangeiros que fugiram foram contar a Lísias tudo o que tinha acontecido."
,"27":"Ao ouvir a notícia, ficou transtornado e abatido, pois as coisas contra Israel não tinham acontecido como ele esperava, e o resultado era o contrário do que o rei havia previsto."
,"28":"No ano seguinte, Lísias recrutou sessenta mil combatentes escolhidos e cinco mil cavaleiros, a fim de subjugar os judeus."
,"29":"Eles foram para a Idumeia e acamparam em Betsur, mas Judas saiu para os enfrentar com dez mil homens."
,"30":"Ao ver tão poderoso exército, Judas rezou: «Bendito sejas Tu, Salvador de Israel, que derrotaste a força de um gigante pela mão do teu servo David, e que entregaste o exército dos filisteus nas mãos de Jónatas, filho de Saul, e do seu escudeiro."
,"31":"Assim também, entrega este exército nas mãos do teu povo Israel, e que os seus soldados e cavaleiros fiquem envergonhados."
,"32":"Amedronta-os e quebra o orgulho do seu poderio, para que sejam afogados pela derrota."
,"33":"Derruba-os com a espada dos que Te amam, para que todos os que conhecem o teu Nome Te celebrem com hinos»."
,"34":"Avançaram uns contra os outros, e cerca de cinco mil do exército de Lísias caíram na luta corpo a corpo."
,"35":"Ao ver a derrota do seu exército e a coragem do grupo de Judas, disposto corajosamente a viver ou morrer, Lísias foi para Antioquia e começou a recrutar um exército ainda mais numeroso, a fim de voltar à Judeia."
,"36":"Judas e seus companheiros fizeram esta proposta: «Agora que derrotámos o inimigo, vamos purificar e consagrar o Templo»."
,"37":"O exército inteiro reuniu-se e subiu ao monte Sião."
,"38":"Aí viram o santuário abandonado, o altar profanado, as portas incendiadas, o mato a crescer nos pátios, como se fosse em campo aberto ou nas montanhas, e os aposentos destruídos."
,"39":"Então rasgaram as vestes e fizeram grande luto, lançando cinza na cabeça"
,"40":"e prostrando-se por terra. Depois tocaram a trombeta e clamaram ao céu."
,"41":"Judas destacou alguns homens para que contivessem os que estavam na fortaleza, enquanto se purificava o Templo."
,"42":"Para isso, escolheu sacerdotes sem defeito físico e que seguiam a Lei."
,"43":"Eles purificaram o Templo e lançaram as pedras que o contaminavam num lugar impuro."
,"44":"Puseram-se, então, a discutir a respeito do altar dos holocaustos que fora profanado,"
,"45":"e tiveram a ideia de o destruir. Assim não ficariam envergonhados pelo facto de os pagãos o terem profanado. Demoliram o altar"
,"46":"e puseram as pedras no monte do Templo, num lugar conveniente, até que aparecesse um profeta e resolvesse o caso."
,"47":"Então pegaram em pedras toscas, conforme manda a Lei, e com elas construíram um altar novo, igual ao anterior."
,"48":"Restauraram o Templo e consagraram a parte interna do santuário e os pátios."
,"49":"Fizeram novos objectos de culto, e colocaram dentro do Templo o candelabro, o altar do incenso e a mesa."
,"50":"Queimaram incenso sobre o altar e acenderam as lâmpadas do candelabro, para que iluminassem o Templo."
,"51":"Colocaram os pães em ordem sobre a mesa, dependuraram as cortinas e deram por terminado todo o trabalho."
,"52":"Na madrugada do dia vinte e cinco do nono mês, chamado Casleu, do ano cento e quarenta e oito,"
,"53":"ofereceram um sacrifício de acordo com a Lei, sobre o novo altar dos holocaustos que tinham construído."
,"54":"Exactamente no mesmo dia e mês em que os pagãos o tinham profanado, o altar foi consagrado no meio de cânticos e música ao som de cítaras, harpas e címbalos."
,"55":"Todo o povo se prostrou por terra, adorando e louvando a Deus, que lhes tinha dado sucesso."
,"56":"Celebraram a consagração do altar durante oito dias, oferecendo alegremente holocaustos com sacrifícios de comunhão e acção de graças."
,"57":"Enfeitaram a fachada do Templo com coroas douradas e escudos. Consagraram os portais e os aposentos, onde colocaram portas."
,"58":"A alegria do povo foi muito grande. Assim estava cancelada a afronta imposta pelos pagãos."
,"59":"Judas, com seus irmãos e toda a assembleia de Israel, determinou que se comemorasse anualmente a nova consagração do altar, com festas solenes durante oito dias, a partir do dia vinte e cinco do mês de Casleu."
,"60":"Nessa ocasião, construíram, em volta do monte Sião, muralhas altas com torres bem fortes, para que os pagãos nunca mais entrassem e as destruíssem, como haviam feito antes."
,"61":"Judas deixou lá um destacamento, para defender o monte. Também fortificou Betsur, para que o povo ficasse protegido contra a Idumeia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Quando as nações vizinhas souberam que os judeus tinham reconstruído o altar e consagrado novamente o santuário como antes, ficaram muito irritadas."
,"2":"Resolveram acabar com os descendentes de Jacob que viviam no meio delas, e começaram a matar e eliminar as pessoas do povo judeu."
,"3":"Então Judas atacou os descendentes de Esaú, moradores da Idumeia, na região de Acrabatena, que estavam a cercar Israel. Judas derrotou-os fragorosamente, humilhou-os e tomou-lhes os despojos."
,"4":"Depois Judas lembrou-se das maldades da gente de Beã, que era permanente armadilha e obstáculo para o povo, por causa das emboscadas que armavam pelos caminhos."
,"5":"Obrigou-os a refugiarem-se nas próprias torres. Depois de os cercar, destruiu-os: incendiou as torres com tudo e todos os que estavam dentro delas."
,"6":"Em seguida, marchou contra os amonitas, onde enfrentou um exército numeroso e bem armado, comandado por Timóteo."
,"7":"Teve de travar muitas batalhas. No final, porém, aqueles foram derrotados por Judas, que os esmagou."
,"8":"Depois de se apossar de Jazer com os seus distritos, Judas voltou para a Judeia."
,"9":"Os pagãos que moravam em Galaad também se aliaram contra os israelitas que viviam nos seus territórios, querendo eliminá-los. Os israelitas refugiaram-se na fortaleza de Datema,"
,"10":"e mandaram esta carta a Judas e seus irmãos, dizendo: «Os pagãos reuniram-se ao nosso redor contra nós, e querem destruir-nos."
,"11":"Já estão prontos para vir tomar a fortaleza onde nos refugiámos. O comandante do seu exército é Timóteo."
,"12":"Vem livrar-nos das suas mãos, pois muitos dos nossos já tombaram."
,"13":"Todos os nossos irmãos que moravam no distrito de Tobias foram mortos, as suas mulheres e filhos foram levados prisioneiros e os seus bens foram saqueados. Cerca de mil pessoas já morreram»."
,"14":"A gente de Judas ainda estava a ler a carta, quando chegaram outros mensageiros vindos da Galileia. Estavam com as vestes rasgadas e traziam esta notícia:"
,"15":"«Todos os de Ptolemaida, Tiro, Sidónia e da Galileia dos pagãos se uniram contra nós, para nos aniquilar»."
,"16":"Logo que Judas e os soldados ouviram contar tudo isto, foi convocada uma grande assembleia para resolver o que fazer em favor dos irmãos que estavam em dificuldade, perseguidos pelos pagãos."
,"17":"Judas disse a seu irmão Simão: «Escolhe os homens que quiseres e vai libertar os irmãos que estão na Galileia. Eu e o meu irmão Jónatas vamos para Galaad»."
,"18":"Para defender a Judeia, deixou o resto do exército, sob o comando de José, filho de Zacarias, e Azarias, chefe do povo."
,"19":"Recomendou-lhes: «Comandai as tropas, mas não entreis em combate contra os pagãos, enquanto não voltarmos»."
,"20":"As tropas de Simão eram de três mil homens, que deviam ir para a Galileia; as tropas de Judas eram de oito mil, que deviam ir para Galaad."
,"21":"Simão foi para a Galileia, onde travou várias batalhas contra os pagãos. Enfrentou, esmagou os pagãos"
,"22":"e perseguiu-os até às portas de Ptolemaida. Tombaram cerca de três mil deles, e Simão recolheu os despojos."
,"23":"Em seguida tomou os judeus da Galileia e de Arbates, juntamente com as mulheres, filhos e pertences, e com grande alegria levou-os para a Judeia."
,"24":"Enquanto isso, Judas Macabeu e seu irmão Jónatas atravessaram o rio Jordão e caminharam três dias pelo deserto."
,"25":"Aí cruzaram-se com os nabateus, que foram ao encontro deles amigavelmente e lhes contaram tudo o que havia acontecido aos seus irmãos em Galaad:"
,"26":"«Muitos deles estão cercados em Bosora, Bosor, Alimas, Casfo, Maced e Carnain, cidades grandes e fortificadas."
,"27":"Outros reuniram-se nas restantes cidades de Galaad, e o inimigo decidiu atacar amanhã as fortalezas, conquistá-las e exterminar, num só dia, todos os que nelas se encontram»."
,"28":"Imediatamente Judas e o seu exército mudaram de direcção e tomaram o rumo de Bosora, atravessando o deserto. Tomou a cidade, matou todos os homens à espada, recolheu os despojos e incendiou a cidade."
,"29":"Partiram de lá à noite e foram até à fortaleza."
,"30":"Ao amanhecer, avistaram um grande exército, que transportava escadas e máquinas de guerra, para conquistar a fortaleza, e já começavam a atacá-la."
,"31":"Percebendo que a luta já tinha começado e que a gritaria da cidade subia até ao céu no meio do som das trombetas e de um clamor intenso,"
,"32":"Judas disse aos seus homens: «Lutai hoje pelos vossos irmãos»."
,"33":"Distribuiu os combatentes em três alas, por detrás dos inimigos, tocando as trombetas e rezando em voz alta."
,"34":"Ao aperceber-se de que era o Macabeu, o exército de Timóteo fugiu em debandada, sofrendo uma grande derrota. Nesse dia caíram mortos cerca de oito mil soldados do exército de Timóteo."
,"35":"Daí, Judas dirigiu-se para Alimas, atacou e tomou a cidade, matou os homens, recolheu os despojos e incendiou a cidade."
,"36":"Daí, foi para Casfo, Maced, Bosor e outras cidades de Galaad, e tomou-as todas."
,"37":"Algum tempo depois destes acontecimentos, Timóteo organizou outro exército e acampou defronte de Rafon, do outro lado do riacho."
,"38":"Judas mandou espiar o acampamento dele, e recebeu estas informações: «Todas as nações vizinhas se aliaram a Timóteo, formando um exército muito grande."
,"39":"Também os árabes estão contratados para os ajudar, e estão todos acampados do outro lado do riacho, prontos para te atacar». Então Judas saiu para os enfrentar."
,"40":"No momento em que Judas e o seu exército se iam aproximando do riacho, Timóteo disse aos seus oficiais: «Se ele atravessar primeiro em nossa direcção, não poderemos resistir, porque ele certamente vencerá."
,"41":"Mas, se ele ficar com medo e acampar do lado de lá, então nós atravessaremos e vencê-lo-emos»."
,"42":"Quando chegou à beira da água, Judas colocou em formatura os oficiais de recrutamento ao longo da margem da torrente, e deu-lhes esta ordem: «Não deixeis que ninguém acampe. Fazei com que todos atravessem»."
,"43":"O próprio Judas foi o primeiro a atravessar em direcção ao inimigo, e todo o exército o acompanhou. Derrotaram os pagãos, que largaram as armas e se refugiaram no templo de Carnain."
,"44":"Os judeus tomaram a cidade e deitaram fogo ao templo, queimando todos os que se encontravam lá dentro. Destruída Carnain, ninguém mais opôs resistência a Judas."
,"45":"Em seguida, Judas reuniu todos os israelitas que viviam em Galaad, grandes e pequenos, com mulheres, filhos e pertences, uma grande multidão, para os levar para a Judeia."
,"46":"Assim chegaram a Efron, cidade importante e bem fortificada, que ficava no caminho. Não havia maneira de se desviar da cidade, nem por um lado nem por outro; era preciso passar por dentro dela."
,"47":"A gente da cidade fechou as portas e reforçou-as com pedras."
,"48":"Judas mandou uma embaixada, com esta mensagem de paz: «Precisamos de atravessar o vosso território, para voltarmos à nossa terra. Ninguém vos vai fazer mal. Só queremos atravessar». Eles, porém, não abriram as portas."
,"49":"Então Judas mandou avisar pelo acampamento que entrassem todos em forma prontos para o combate, no lugar onde estivessem."
,"50":"Ficaram todos preparados e, em seguida, começaram a lutar contra a cidade. O combate durou o dia e a noite toda, até que a cidade se rendeu."
,"51":"Mataram à espada todos os homens, demoliram a cidade, recolheram os despojos e atravessaram a cidade, passando por cima dos cadáveres."
,"52":"Em seguida, atravessaram o rio Jordão, em direcção à grande planície que fica diante de Betsã."
,"53":"Judas reunia os que estavam atrasados e animava o povo durante toda a viagem, até chegar à terra de Judá."
,"54":"Então subiram felizes e alegres ao monte Sião, e ofereceram holocaustos, pois tinham conseguido voltar em paz, sem que ninguém morresse."
,"55":"Enquanto Judas e Jónatas estavam em Galaad, e seu irmão Simão se encontrava na Galileia, diante de Ptolemaida,"
,"56":"os dois comandantes do exército, José, filho de Zacarias, e Azarias, ficaram a saber das façanhas que eles tinham realizado."
,"57":"E comentaram: «Vamos nós também ficar famosos! Vamos lutar contra as nações vizinhas»."
,"58":"Mandaram avisar os soldados do exército, que estava sob o seu comando, e puseram-se em marcha contra Jâmnia."
,"59":"Górgias e os seus homens saíram da cidade para os enfrentar."
,"60":"Aconteceu que José e Azarias foram derrotados e perseguidos até à fronteira da Judeia. Nessa ocasião, morreram cerca de dois mil homens das tropas de Israel."
,"61":"Foi uma grande derrota para o exército, causada pelo facto de José e Azarias não terem obedecido a Judas e seus irmãos. Eles queriam ficar famosos,"
,"62":"mas não eram da família dos homens destinados a libertar Israel."
,"63":"O valente Judas e seus irmãos tinham grande prestígio diante de todos os israelitas e também diante das outras nações, aonde chegava a sua fama."
,"64":"As pessoas aglomeravam-se em torno deles para os aplaudir."
,"65":"Judas e seus irmãos marcharam para lutar contra os descendentes de Esaú, na região que fica ao Sul. Tomaram Hebron e os seus distritos, destruíram as suas fortificações e incendiaram as torres que as rodeavam."
,"66":"Daí, partiram para a região dos filisteus, passando por Marisa."
,"67":"Foi nessa ocasião que alguns sacerdotes morreram na guerra, pois quiseram mostrar valentia e entraram em combate imprudentemente."
,"68":"Judas dirigiu-se para Azoto, região dos filisteus, e aí destruiu os altares, queimou as imagens dos deuses deles e saqueou a cidade. Depois, voltou para a terra de Judá."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Quando percorria as províncias do planalto, o rei Antíoco ouviu dizer que havia na Pérsia uma cidade chamada Elimaida, famosa pela sua riqueza em prata e ouro."
,"2":"Diziam que o templo dessa cidade era muito rico e que havia nele cortinas tecidas em ouro, couraças e armas aí deixadas pelo rei Alexandre, o macedónio, filho de Filipe, que foi o primeiro rei do império grego."
,"3":"Antíoco dirigiu-se para o local, pretendendo tomar e saquear a cidade. Mas não conseguiu, porque a gente da cidade, sabendo da sua pretensão,"
,"4":"preparou-se para a guerra e enfrentou-o. Antíoco teve de fugir, e foi com grande tristeza que deixou o lugar, a fim de voltar para a Babilónia."
,"5":"Ainda ele estava na Pérsia, quando recebeu a notícia de que as tropas enviadas contra a Judeia tinham sido derrotadas"
,"6":"e que Lísias tinha tomado a iniciativa de enfrentar os judeus com poderoso exército, mas teve de recuar. Soube também que os judeus estavam a ficar mais perigosos por causa da quantidade de armas, além de outros recursos e despojos que tomavam aos exércitos que iam derrotando."
,"7":"Contaram-lhe também que os judeus tinham retirado a abominação que ele colocara sobre o altar de Jerusalém, e que tinham cercado o Templo com muralhas altas como antigamente, fazendo o mesmo em Betsur, cidade que pertencia ao rei."
,"8":"Ao ouvir essas notícias, o rei ficou apavorado e totalmente atordoado, e caiu de cama, doente de tristeza, pois nada estava a acontecer como ele queria."
,"9":"Ficou lá muito tempo, cada vez mais deprimido. Percebendo que ia morrer,"
,"10":"chamou todos os grandes e disse-lhes: «O sono fugiu dos meus olhos, o meu coração está abatido de tanta aflição."
,"11":"Eu disse a mim mesmo: 'A que grau de aflição me vejo reduzido! Como é grande a onda em que me estou debatendo. Eu que era feliz e estimado quando estava no poder!"
,"12":"Agora, porém, recordo-me dos males que fiz a Jerusalém, de onde tirei todos os objectos de prata e ouro que nela havia. Lembro-me dos habitantes de Judá que mandei matar sem motivo."
,"13":"Reconheço que é por causa de tudo isso que hoje me acontecem estas desgraças. Agora estou a morrer, cheio de tristeza e em terra estrangeira'»."
,"14":"Chamou Filipe, um dos seus amigos, e passou-lhe a autoridade sobre todo o seu reino."
,"15":"Entregou-lhe a coroa, o manto e o anel, a fim de que levasse esses objectos ao seu filho Antíoco, a quem deveria educar e preparar para ser rei."
,"16":"E ali mesmo o rei Antíoco morreu, no ano cento e quarenta e nove."
,"17":"Logo que soube da morte do rei, Lísias proclamou como novo rei o filho Antíoco, a quem o mesmo Lísias tinha educado desde criança. E deu-lhe o nome de Eupátor."
,"18":"As tropas aquarteladas na fortaleza impediam sempre a passagem dos israelitas para o Templo, e prejudicavam-nos de todas as formas, dando assim apoio aos pagãos."
,"19":"Então Judas resolveu desalojá-los de lá. E convocou todo o exército para os cercar."
,"20":"Reuniram-se todos, e no ano cento e cinquenta fizeram o cerco da fortaleza: prepararam rampas e máquinas de assalto."
,"21":"Alguns, porém, conseguiram escapar do cerco, e a eles se aliaram vários israelitas traidores,"
,"22":"que foram juntos procurar o rei para lhe dizer: «Quando é que vais fazer justiça e vingar os nossos irmãos?"
,"23":"Nós submetemo-nos voluntariamente ao teu pai, seguindo as orientações e obedecendo fielmente às suas ordens."
,"24":"O resultado é que os nossos compatriotas cercaram a fortaleza e tratam-nos como estranhos. Mais ainda: mataram todos os nossos que lhes caíram nas mãos e saquearam as nossas propriedades."
,"25":"E não é só contra nós que eles estão erguendo a mão, mas também contra o território que te pertence a ti."
,"26":"Hoje, por exemplo, estão cercando a fortaleza de Jerusalém para tentar tomá-la, e já fortificaram o Templo e a cidade de Betsur."
,"27":"Se não os surpreenderes rapidamente, farão coisas ainda piores, e tu já não serás capaz de segurá-los»."
,"28":"Ao ouvir isto, o rei irritou-se. Reuniu todos os seus amigos, os generais do exército e os comandantes da cavalaria."
,"29":"Foram convocadas também tropas mercenárias, vindas de outros reinos e até das ilhas do mar."
,"30":"O contingente chegou a cem mil soldados de infantaria, vinte mil de cavalaria e trinta e dois elefantes treinados para a guerra."
,"31":"Atravessaram a Idumeia, acamparam perto de Betsur e lutaram contra a cidade durante muitos dias. Construíram máquinas de guerra, mas os judeus saíam da cidade, queimavam as máquinas e lutavam corajosamente."
,"32":"Então Judas deixou a fortaleza de Jerusalém e foi acampar em Bet-Zacarias, defronte ao acampamento do rei."
,"33":"Então o rei levantou-se de madrugada e transferiu o exército com todo o seu contingente para o caminho de Bet-Zacarias. Aí os dois exércitos prepararam-se para a batalha e tocaram as trombetas."
,"34":"Mostravam aos elefantes suco de uva e de amoras, a fim de os incentivarem para o combate."
,"35":"Distribuíram esses animais no meio das alas do exército. Junto de cada elefante colocaram mil homens encouraçados com malhas de ferro e capacetes de bronze. Além disso, quinhentos cavaleiros escolhidos foram destacados para cada elefante:"
,"36":"aonde o elefante ia, eles iam também, sem nunca se separarem do animal."
,"37":"Sobre cada elefante havia uma forte torre de madeira, toda coberta, que era presa ao animal por correias. Em cada torre, além do indiano, iam três soldados que combatiam de cima do animal."
,"38":"O restante da cavalaria, protegida pela infantaria, ia nos dois lados do exército, para atacar o inimigo e dar cobertura às alas."
,"39":"Quando o sol começou a brilhar nos escudos de ouro e bronze, a montanha inteira ficou a brilhar e a faiscar por causa dos escudos, que pareciam tochas acesas."
,"40":"Parte do exército do rei havia-se colocado no ponto mais alto dos montes; a outra parte estava mais abaixo. Eles marchavam compacta e ordenadamente."
,"41":"Quem ouvia a vozearia de tanta gente, o tropel dessa multidão e o ruído das armas, ficava apavorado, pois era realmente um exército muito numeroso e bem armado."
,"42":"Judas, porém, foi em frente com o seu exército, a fim de lutar. Do exército do rei caíram seiscentos homens."
,"43":"Eleazar, o Abaron, viu um dos elefantes revestido com as insígnias reais, mais alto do que os outros elefantes; crendo que o rei devia estar aí,"
,"44":"resolveu dar a vida para salvar o povo, esperando assim conquistar uma fama eterna:"
,"45":"corajosamente, ele foi-se enfiando pelo meio das alas do exército, matando à direita e à esquerda. Os pagãos afastavam-se dele para os lados."
,"46":"Acabou por chegar bem debaixo do elefante, cravou nele a espada e matou-o. O elefante, porém, caiu em cima de Eleazar, e este morreu ali mesmo."
,"47":"Ao ver a força do rei e a capacidade dos seus exércitos, os judeus bateram em retirada."
,"48":"Os soldados do exército do rei foram em direcção a Jerusalém, para lutar contra os judeus. O rei cercou a Judeia e o monte Sião."
,"49":"Fez também um acordo com os habitantes de Betsur. Estes saíram da cidade, porque já não tinham provisões para resistir ao cerco, pois era o ano sabático, o repouso da terra."
,"50":"Foi assim que o rei tomou Betsur. Instalou ali uma guarnição para defender a cidade."
,"51":"Ele ficou acampado em volta do Templo durante muitos dias. Construiu rampas e diversas máquinas de assalto, lança-chamas, atiradeiras, escorpiões para atirar projécteis, e fundas."
,"52":"Mas os judeus também fizeram máquinas de guerra que combatiam as do rei, e ficaram lutando durante muitos dias."
,"53":"Nos depósitos não havia mais alimentos, por ser o ano sabático e também porque os que tinham escapado das outras nações para a Judeia consumiram o que sobrara de mantimentos."
,"54":"Ficaram poucos homens no Templo, pois, forçada pela fome, a maioria dispersou-se, voltando cada qual para a própria terra."
,"55":"Lísias recebeu a notícia de que Filipe, aquele que o rei Antíoco antes de morrer tinha encarregado de educar o filho Antíoco para o fazer rei,"
,"56":"estava regressando da Pérsia e da Média, acompanhado dos exércitos que tinham ido com o rei. A intenção de Filipe era assumir o poder."
,"57":"Lísias ficou aflito e deu a entender que era preciso sair daquele lugar. Disse ao rei, aos generais e aos soldados: «Estamos a ficar cada dia mais fracos. As nossas provisões já são poucas e o lugar que estamos a cercar está bem armado. Além disso, os assuntos do reino esperam por nós."
,"58":"Vamos estender a mão a essa gente e fazer um acordo com eles e com todos os da sua nação."
,"59":"Vamos reconhecer o seu direito de viverem conforme as suas leis, como faziam antigamente, pois eles inflamaram-se e fizeram tudo isso por causa das suas leis, que nós quisemos abolir."
,"60":"A proposta agradou ao rei e aos generais. Então Lísias mandou aos judeus propostas de paz, que eles aceitaram."
,"61":"O rei e os generais confirmaram o acordo sob juramento, e os que estavam cercados na fortaleza puderam sair sob essas condições."
,"62":"Quando o rei chegou ao monte Sião, viu as fortificações do lugar. Mas, quebrando o juramento que havia feito, demoliu a muralha que havia ao redor de Sião."
,"63":"Em seguida, partiu à pressa para Antioquia, onde encontrou Filipe, que se havia apoderado da cidade. Lutou contra ele e tomou a cidade pela força."
}`)
	CurrentBook.AddChapter(7, `{
"1":"No ano cento e cinquenta e um, Demétrio, filho de Seleuco, partiu de Roma e desembarcou com poucos homens numa cidade do litoral, e aí se proclamou rei."
,"2":"Logo que entrou no palácio real dos seus pais, os militares prenderam Antíoco juntamente com Lísias, a fim de os apresentarem a Demétrio."
,"3":"Ao saber do caso, porém, Demétrio disse: «Não quero que me mostreis o rosto desses indivíduos!»"
,"4":"Então mataram os dois, e Demétrio ocupou o trono do seu reino."
,"5":"Alguns indivíduos apóstatas e ímpios do povo de Israel, conduzidos por Alcimo, que aspirava ao cargo de sumo sacerdote, apresentaram-se"
,"6":"e acusaram o seu povo diante do rei, dizendo: «Judas e os seus irmãos mataram todos os partidários do rei, e expulsaram-nos do nosso país."
,"7":"Manda alguém da tua confiança para examinar a devastação que Judas nos causou, a nós e à província do rei. Castiga-os a todos e àqueles que os apoiam»."
,"8":"O rei escolheu Báquides, um dos seus amigos, governador das regiões do outro lado do rio Eufrates, homem importante no reino e da confiança do rei."
,"9":"E mandou-o com o ímpio Alcimo, confirmado no cargo de sumo sacerdote, dando-lhe ordem para castigar os israelitas."
,"10":"Eles partiram para a Judeia com um grande exército. Báquides mandou alguns mensageiros a Judas e seus irmãos, com falsas propostas de paz."
,"11":"Estes, porém, não deram ouvidos às suas palavras, porque perceberam que tinham vindo com muitos soldados."
,"12":"Apesar de tudo, um grupo de escribas reuniu-se com Alcimo e Báquides, para encontrar uma solução justa."
,"13":"Os assideus foram os primeiros israelitas a pedir a paz."
,"14":"Pensavam assim: «Quem veio com o exército é um sacerdote da descendência de Aarão. Ele não nos vai trair»."
,"15":"Báquides conversou amigavelmente com eles e até jurou: «Nós não vamos fazer nenhum mal, nem a vós nem aos vossos amigos!»"
,"16":"Os assideus acreditaram neles. Porém Alcimo prendeu sessenta deles e matou-os no mesmo dia, conforme a passagem da Escritura:"
,"17":"«Espalharam em volta de Jerusalém os cadáveres e o sangue dos teus devotos, e não havia ninguém para os sepultar»."
,"18":"A partir daí, o medo e o pavor tomaram conta do povo. Diziam: «Eles não têm sinceridade nem honradez. Faltaram à palavra e ao juramento»."
,"19":"Báquides saiu de Jerusalém e foi acampar em Bet-Zet. Aí mandou prender muitos homens que tinham passado para o seu lado e mais alguns dentre o povo. Em seguida, matou-os a todos e lançou-os na cisterna grande."
,"20":"Depois confiou a região a Alcimo, deixou o exército com ele, a fim de lhe dar força, e voltou para junto do rei."
,"21":"Alcimo batalhava pelo cargo de sumo sacerdote."
,"22":"Em torno dele reuniram-se todos os agitadores do povo: conseguiram dominar a Judeia e fizeram um estrago enorme em Israel."
,"23":"Judas notou que o mal provocado por Alcimo e seus companheiros entre a gente de Israel era muito maior que o provocado pelos pagãos."
,"24":"Percorreu, então, todo o território da Judeia, castigando os traidores e impedindo-os de fazer incursões pelo país."
,"25":"Ao ver que Judas e os seus companheiros estavam a ficar mais fortes, e reconhecendo-se incapaz de lhes resistir, Alcimo voltou para junto do rei e acusou-os de muitas maldades."
,"26":"Então o rei mandou Nicanor, um dos seus generais mais importantes, inimigo mortal dos israelitas, para exterminar o povo."
,"27":"Nicanor chegou a Jerusalém com numeroso exército e mandou falsas mensagens de paz a Judas e seus irmãos. Dizia:"
,"28":"«Não é preciso haver guerra entre mim e vós! Vou aí com poucos homens para vos fazer uma visita de amigo»."
,"29":"E foi procurar Judas. Os dois cumprimentaram-se amavelmente, mas os inimigos estavam preparados para sequestrar Judas."
,"30":"No entanto, Judas percebeu que a visita de Nicanor era uma armadilha, e ficou com tal medo, que não quis tornar a vê-lo."
,"31":"Nicanor também percebeu que as suas intenções tinham sido descobertas e partiu para enfrentar Judas em Cafarsalama."
,"32":"Tombaram cerca de quinhentos homens de Nicanor, e os outros fugiram para a Cidade de David."
,"33":"Depois disso, Nicanor subiu ao monte Sião. Alguns sacerdotes e anciãos do povo saíram do Templo para o cumprimentarem cordialmente e mostrar-lhe o holocausto que era oferecido por intenção do rei."
,"34":"Nicanor, porém, zombou, ridicularizou-os, cuspiu neles e disse as maiores insolências."
,"35":"E jurou, com raiva: «Se não me entregardes agora mesmo Judas e o seu exército, juro que incendiarei este Templo quando eu voltar vitorioso». E saiu dali, furioso."
,"36":"Os sacerdotes entraram no Templo, ficaram de pé diante do altar e do santuário, e começaram a clamar a Deus, chorando:"
,"37":"«Tu escolheste esta casa para que o teu Nome fosse invocado nela, para que fosse uma casa de oração e prece para o teu povo."
,"38":"Executa a vingança contra esse indivíduo e o seu exército: que eles morram à espada! Lembra-Te das blasfémias deles, e não lhes concedas descanso»."
,"39":"Nicanor saiu de Jerusalém e foi acampar em Bet-Horon. Aí veio juntar-se a ele um exército da Síria."
,"40":"Judas acampou em Adasa, com três mil homens, e rezou assim:"
,"41":"«Quando os mensageiros do rei disseram insolências, o teu anjo foi ao acampamento deles e matou cento e oitenta e cinco mil homens."
,"42":"Da mesma forma, esmaga hoje este exército que está na nossa frente, para que todos fiquem a saber que Nicanor blasfemou contra o teu Templo. Condena-o na medida do mal que ele praticou!»"
,"43":"Os exércitos enfrentaram-se no dia treze do mês de Adar, e o exército de Nicanor foi derrotado. Ele foi o primeiro a tombar em combate."
,"44":"Os soldados, quando viram que Nicanor tinha caído morto, deixaram as armas e fugiram."
,"45":"Os judeus perseguiram-nos durante um dia, desde Adasa até perto de Gazara, tocando as trombetas atrás deles, com toque de alarme."
,"46":"De todos os povoados da Judeia, que ficavam próximos, o povo saía e cercava-os, de modo que uns se voltavam contra os outros. Dessa forma, caíram todos mortos à espada, sem sobrar nenhum."
,"47":"Recolheram os despojos e fizeram o saque. Cortaram a cabeça e a mão direita de Nicanor, que ele tinha levantado com desprezo, e levaram-na para a mostrar ao povo, em Jerusalém."
,"48":"O povo ficou muito alegre e comemorou esse dia como dia de festa."
,"49":"Resolveram celebrar esta data anualmente, no dia treze de Adar."
,"50":"Assim a Judeia ficou tranquila por algum tempo."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Judas ouviu falar da fama dos romanos, que eram poderosos e valentes. Diziam que eram bons para com os seus aliados e ofereciam acordo de amizade a quem quer que os procurasse."
,"2":"Falaram-lhe também das guerras e proezas que eles tinham realizado entre os gauleses, como os tinham derrotado e obrigado a pagar-lhes tributo."
,"3":"Falavam também do que eles tinham realizado na região da Espanha, para se apossarem das minas de prata e ouro que lá havia;"
,"4":"e ainda, como dominavam todos os lugares com prudência e persistência, mesmo que algum lugar ficasse muito distante deles. Falavam também dos reis que tinham vindo do outro lado do mundo para guerrear contra eles, e que foram derrotados fragorosamente; outros simplesmente pagavam-lhes tributo todos os anos."
,"5":"As notícias falavam também de Filipe e Perseu, reis dos macedónios, e também de outros que tentaram revoltar-se contra os romanos, mas foram subjugados."
,"6":"Diziam ainda que também Antíoco, o Grande, rei da Ásia, tinha enfrentado os romanos com cento e vinte elefantes, cavalaria e carros de guerra, além de numerosa infantaria, e fora esmagado por eles."
,"7":"Os romanos apanharam-no vivo e determinaram que ele e os seus sucessores pagariam altos tributos e entregariam reféns e territórios."
,"8":"Tomaram as regiões da Lícia, Mísia e Lídia, as mais bonitas da Ásia, e entregaram-nas ao rei Eumenes."
,"9":"Os gregos planearam lutar contra eles e derrotá-los,"
,"10":"mas o seu plano foi descoberto pelos romanos, que mandaram contra eles um general apenas. Um número imenso deles tombou, mulheres e crianças foram presas. Os romanos saquearam o que eles possuíam, subjugaram o país, destruíram as suas fortalezas, e fizeram-nos escravos, até ao dia de hoje."
,"11":"Outros reinos e ilhas que foram capazes de lhes resistir noutra ocasião, por fim foram derrotados e escravizados. Com os seus amigos, porém, e com todos os que confiavam no seu apoio, os romanos sempre conservaram a sua amizade."
,"12":"Eles dominaram reis, tanto de perto como de longe. Todos os que ouviam o seu nome ficavam com medo."
,"13":"Aqueles a quem eles querem ajudar nas suas pretensões ao trono, chegam a ser reis. A quem querem depor, eles depõem-nos. Estão no auge do poder."
,"14":"Apesar de tudo, nenhum deles usa coroa ou manto de púrpura para se engrandecer com essas coisas."
,"15":"Organizaram um senado de trezentos e vinte senadores. Diariamente se consultam uns aos outros a respeito do povo e da melhor maneira de governá-lo."
,"16":"Para cada ano, confiam a um deles o encargo de dirigir o Senado e governar o país. Todos obedecem a esse único homem, e não existe inveja nem rivalidade entre eles."
,"17":"Judas escolheu Eupolemo, filho de João, da família de Acos, e Jasão, filho de Eleazar, e mandou-os a Roma para firmarem um acordo de amizade e mútua defesa,"
,"18":"com a intenção de sacudir a dominação grega, pois sentiam que o reino dos gregos estava a reduzir Israel à escravidão."
,"19":"Eles partiram para Roma e, depois da longa viagem, entraram no Senado, e disseram:"
,"20":"«Judas Macabeu, seus irmãos e todo o povo judeu enviaram-nos a Vossas Excelências, a fim de estabelecer entre nós um acordo de amizade e mútua defesa, e para sermos contados entre os vossos amigos e aliados»."
,"21":"Os senadores aprovaram o pedido."
,"22":"Segue a resposta que mandaram escrever em placas de bronze e enviaram a Jerusalém, para ficar na posse dos judeus, documentando o acordo de amizade e a mútua defesa:"
,"23":"«Bem-estar aos romanos e aos judeus, na terra e no mar, para sempre. Longe deles a espada inimiga."
,"24":"Sempre que Roma for atacada, ou algum dos seus aliados, em todos os seus domínios,"
,"25":"o povo judeu lutará a seu lado, conforme lhe for possível na ocasião, mas com toda a boa vontade."
,"26":"Por decisão de Roma, aos agressores ninguém dará ou fornecerá trigo, armas, dinheiro ou navios. E observarão esses compromissos sem receber nada em troca."
,"27":"Da mesma forma, se o povo judeu for atacado, os romanos lutarão ao seu lado com todo o interesse, conforme lhes for possível na ocasião."
,"28":"Por decisão de Roma, aos agressores ninguém dará ou fornecerá trigo, armas, dinheiro ou navios. E observarão esse compromisso lealmente."
,"29":"Isto é o que ficou combinado entre romanos e judeus."
,"30":"Além do mais, se alguma das partes quiser acrescentar ou tirar alguma coisa, só se fará de comum acordo, e o que for acrescentado ou tirado terá força de lei."
,"31":"Quanto aos estragos que o rei Demétrio está a provocar aos judeus, nós já lhe escrevemos, nestes termos: 'Porque é que oprimes tiranicamente os judeus, nossos amigos e aliados?"
,"32":"Se eles vierem outra vez queixar-se de ti, nós defenderemos os seus direitos, atacando-te por terra e mar'»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Ao ouvir que Nicanor e o seu exército tinham sucumbido no combate, Demétrio resolveu mandar novamente Báquides e Alcimo até à Judeia, com a ala direita do exército."
,"2":"Tomaram o caminho da Galileia e acamparam perto de Masalot, no território de Arbelas. Tomaram a cidade e mataram muita gente."
,"3":"No primeiro mês do ano cento e cinquenta e dois, acamparam diante de Jerusalém."
,"4":"Depois saíram daí e foram em direcção a Beerzet, com vinte mil homens de infantaria e dois mil de cavalaria."
,"5":"Judas estava acampado em Elasa, com três mil homens escolhidos."
,"6":"Ao ver o tamanho do exército inimigo, muitos deles começaram a ficar com medo e abandonaram o acampamento, ficando apenas oitocentos homens."
,"7":"Judas viu que o seu exército se estava a desfazer e que a batalha era iminente. Ficou desencorajado, porque já não era possível reunir novamente os companheiros."
,"8":"Então disse aos que tinham ficado: «Vamos lutar contra o inimigo, se é que ainda podemos lutar contra ele!»"
,"9":"Os companheiros tentavam convencê-lo: «Não conseguiremos. Vamos agora salvar as nossas vidas. Depois voltaremos com os nossos irmãos, e então lutaremos contra eles. Agora somos muito poucos!»"
,"10":"Judas respondeu: «Fugir deles? De maneira nenhuma! Se a nossa hora chegou, vamos morrer com coragem, em favor dos nossos irmãos! Não vamos deixar mancha nenhuma na nossa fama!»"
,"11":"Enquanto isso, o exército inimigo saiu do acampamento e colocou-se na frente dos judeus. Dividiram a cavalaria em duas alas, enquanto os atiradores de funda e os arqueiros marchavam à frente de todo o exército, com os mais valentes na primeira fila. Báquides estava na ala direita."
,"12":"E o exército avançou dos dois lados, tocando trombetas. Os do lado de Judas também tocaram as trombetas,"
,"13":"e o solo tremeu com o barulho dos dois exércitos. Houve uma batalha sem trégua, desde o amanhecer até à tarde."
,"14":"Ao ver que Báquides e a parte mais forte do seu exército estavam do lado direito, Judas reuniu junto de si os que estavam com maior disposição,"
,"15":"e com eles atacou a ala direita. Conseguiu persegui-los até à serra de Azara."
,"16":"Os da ala esquerda, quando viram que a ala direita estava em apuros, perseguiram Judas e seus companheiros, e atacaram-nos por trás."
,"17":"A batalha ficou mais feroz ainda, e de ambos os lados caíram muitos mortos."
,"18":"Judas também caiu, e os outros fugiram."
,"19":"Jónatas e Simão, irmãos de Judas, tomaram o corpo dele e sepultaram-no no túmulo da família em Modin,"
,"20":"chorando muito. Todo o Israel fez muitas lamentações por ele, e guardou luto durante muitos dias, dizendo:"
,"21":"«Como pôde morrer o herói, aquele que salvava Israel?»"
,"22":"O resto das acções de Judas, as suas batalhas e façanhas e a sua grandeza não foram escritas, por serem demasiado numerosas."
,"23":"Depois da morte de Judas, os apóstatas começaram a levantar-se e reapareceram todos os malfeitores por todo o território israelita."
,"24":"Nessa época, alastrou uma fome terrível, de modo que o país inteiro aderiu a eles."
,"25":"Então Báquides escolheu alguns ímpios e colocou-os como chefes do país."
,"26":"Eles procuravam os partidários de Judas, para os levar a Báquides, que os castigava e humilhava."
,"27":"Israel caiu numa tribulação tão grande, como nunca tinha havido, desde que os profetas desapareceram."
,"28":"Então todos os partidários de Judas reuniram-se e disseram a Jónatas:"
,"29":"«Desde que o teu irmão Judas morreu, não surgiu outro homem igual para tomar a iniciativa na luta contra os nossos inimigos, especialmente esse Báquides e aqueles que odeiam o nosso povo."
,"30":"Por isso, elegemos-te para o lugar dele como nosso chefe e guia, para dirigires a nossa luta»."
,"31":"Assim Jónatas assumiu o comando em lugar do seu irmão Judas."
,"32":"Báquides soube disso e procurava matar Jónatas."
,"33":"Porém Jónatas, seu irmão Simão e todos os que estavam do seu lado, ao tomarem conhecimento disso, fugiram para o deserto de Técua e acamparam perto das águas da cisterna de Asfar."
,"34":"Ao saber disso, Báquides foi, num sábado, com todo o seu exército, para o outro lado do rio Jordão."
,"35":"Jónatas mandou seu irmão João à frente das tropas para pedir aos seus amigos nabateus que cuidassem de toda a bagagem dele, que era muita."
,"36":"A gente de Iambri, porém, vindo de Madaba, atacou e aprisionou João e tudo o que ele tinha, e foi-se, transportando a presa."
,"37":"Depois disso, contaram a Jónatas e Simão que a gente de Iambri faria uma grande festa de casamento e com muita solenidade; estavam trazendo de Nabata a noiva, que era filha de um dos grandes senhores de Canaã."
,"38":"Lembrando-se do assassinato do seu irmão João, eles subiram ao monte e aí se esconderam."
,"39":"Observando, notaram um tropel e grande aparato: era o noivo, acompanhado de seus amigos e irmãos, que vinha ao encontro da noiva, ao som de tamborins e outros instrumentos, e trazendo muitas armas."
,"40":"Os judeus, saindo do esconderijo, atacaram-nos e mataram-nos; muitos caíram feridos, e os outros fugiram para os montes. Os judeus recolheram os despojos que eles haviam abandonado."
,"41":"Assim, a festa de casamento transformou-se em pranto, e o som das suas músicas em cântico fúnebre."
,"42":"Após ter vingado a morte de seu irmão, voltaram para as margens pantanosas do rio Jordão."
,"43":"Ao saber disso, Báquides foi, num sábado, com todo o seu exército, para o outro lado do rio Jordão."
,"44":"Jónatas disse aos que estavam com ele: «Vamos lutar pela nossa própria vida, pois hoje não é como das outras vezes."
,"45":"Vamos ter luta pela frente e pelas costas, pois temos as águas do Jordão de um lado, pântano e matagal do outro. Não há por onde escapar."
,"46":"Portanto, clamai a Deus, pedindo que possamos salvar-nos das mãos dos nossos inimigos»."
,"47":"Travou-se a batalha. Jónatas esteve a ponto de atingir Báquides, mas este escapou desviando-se para trás."
,"48":"Então Jónatas e os seus companheiros lançaram-se ao rio Jordão e atravessaram-no a nado, mas a gente de Báquides não atravessou o rio para os perseguir."
,"49":"Nesse dia, Báquides perdeu cerca de mil homens."
,"50":"Báquides voltou para Jerusalém e passou a construir cidades fortificadas na Judeia. Construiu fortalezas em Jericó, Emaús, Bet-Horon, Betel, Tamnata, Faraton e Tefon, todas com muralhas bem altas, portões e trancas."
,"51":"Em cada uma delas colocou um pelotão de soldados para combater contra Israel."
,"52":"Fortificou também as cidades de Betsur, Gazara e a fortaleza, colocando nelas contingentes militares e mantimentos."
,"53":"Tomou os filhos dos dirigentes do país como reféns e deixou-os presos na fortaleza, em Jerusalém."
,"54":"No segundo mês do ano cento e cinquenta e três, Alcimo mandou derrubar o muro do pátio interno do Templo. Ele pretendia destruir o que os profetas tinham feito, mas apenas começou a executar a demolição."
,"55":"Na mesma ocasião, ele caiu doente, e as suas obras foram interrompidas. A sua boca ficou paralisada, de modo que não podia falar, nem dirigir a sua casa."
,"56":"Pouco depois, morreu no meio de grandes sofrimentos."
,"57":"Báquides, ao saber da morte de Alcimo, voltou para junto do rei, e a Judeia ficou tranquila durante dois anos."
,"58":"Todos os apóstatas se reuniram em conselho e combinaram: «Vede como Jónatas e os seus companheiros vivem tranquilos e seguros! Vamos trazer Báquides de volta, e ele será capaz de os prender a todos numa só noite»."
,"59":"Então foram conversar com Báquides."
,"60":"Este marchou com um grande exército e, ao mesmo tempo, mandou instruções secretas a todos os seus colaboradores na Judeia, para que ajudassem a capturar Jónatas e os seus companheiros. Mas nada conseguiram, porque o seu plano foi descoberto."
,"61":"Os companheiros de Jónatas prenderam e mataram uns cinquenta homens do território, que eram os cabecilhas dessa traição."
,"62":"Jónatas, Simão e seus companheiros fugiram para Bet-Basi, na região do deserto. Reconstruíram e reforçaram o lugar."
,"63":"Logo que soube disso, Báquides juntou todas as suas tropas, mandou avisar a gente da Judeia"
,"64":"e foi cercar Bet-Basi. Lutou contra a cidade durante muito tempo e fez até máquinas de assalto."
,"65":"Jónatas deixou o irmão Simão na cidade, e saiu para campo aberto com um número reduzido de companheiros."
,"66":"Derrotou Odomer e seus irmãos e também a gente de Farison, que estava no acampamento. Assim eles começaram a vencer e foram crescendo em forças."
,"67":"Enquanto isso, Simão e os que tinham ficado com ele saíram da cidade e deitaram fogo às máquinas de assalto."
,"68":"Em seguida, lutaram directamente contra Báquides, e derrotaram-no. Báquides ficou muito humilhado, porque o seu plano e campanha tinham sido inúteis."
,"69":"Ficou furioso contra os apóstatas, que lhe tinham aconselhado a fazer essa expedição; matou muitos, e resolveu voltar para a sua terra."
,"70":"Ao saber da decisão de Báquides, Jónatas mandou embaixadores para lhe propor a paz e a troca de prisioneiros."
,"71":"Ele aceitou, fez o que Jónatas propôs e jurou que nunca mais iria prejudicá-lo durante toda a vida."
,"72":"Devolveu os prisioneiros que tinha feito na Judeia, voltou para a sua terra e nunca mais fez incursões no território judaico."
,"73":"Assim Israel ficou livre da guerra. Jónatas foi morar em Macmas, começou a governar o povo e fez desaparecer os ímpios do meio de Israel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"No ano cento e sessenta, Alexandre, filho de Antíoco Epífanes, embarcou, tomou posse de Ptolemaida, foi bem recebido, e começou a reinar lá."
,"2":"Ao receber a notícia, o rei Demétrio reuniu um enorme exército e partiu para o enfrentar."
,"3":"Demétrio enviou a Jónatas uma carta com palavras amigas, prometendo engrandecê-lo muito."
,"4":"Ele pensava: «Vamos fazer já um acordo com ele, antes que ele faça acordo com Alexandre e contra nós."
,"5":"Caso contrário, ele poderá lembrar-se de todo o mal que nós lhe fizemos, a ele, aos seus irmãos e a toda a sua gente»."
,"6":"Nessa carta, dava-lhe autoridade para recrutar exército, fabricar armas e ser aliado seu, além de ordenar que lhe fossem entregues os reféns que estavam na fortaleza."
,"7":"Jónatas foi até Jerusalém e leu a carta a todo o povo, de modo que pudessem ouvir também os que estavam na fortaleza."
,"8":"Todos ficaram muito assustados ao ouvir que o rei lhe tinha dado autorização para recrutar exército."
,"9":"Os que estavam na fortaleza entregaram-lhe os reféns, que Jónatas devolveu às suas famílias."
,"10":"Jónatas passou a morar em Jerusalém, e começou a reconstruir e restaurar a cidade."
,"11":"Aos que estavam executando a reforma das muralhas, em volta do monte Sião, mandou que usassem pedras quadradas, para ficarem mais resistentes. Eles assim fizeram."
,"12":"Então os estrangeiros que estavam nas fortalezas, construídas por Báquides, fugiram."
,"13":"Cada um abandonou o posto e foi-se embora para a sua terra."
,"14":"Somente em Betsur ficaram alguns apóstatas que tinham abandonado a Lei e os mandamentos. Era ali o refúgio deles."
,"15":"O rei Alexandre soube das promessas que Demétrio tinha feito a Jónatas. Contaram-lhe também as batalhas e façanhas que Jónatas e seus irmãos tinham realizado e as dificuldades que tinham superado."
,"16":"Ele comentou: «Nunca iremos encontrar homem igual a esse! Vamos fazer dele um amigo e aliado nosso!»"
,"17":"Então, enviou-lhe uma carta nestes termos:"
,"18":"«Do rei Alexandre ao seu irmão Jónatas. Saudações!"
,"19":"Estamos bem informados a teu respeito e sabemos que és homem corajoso e forte, com qualidades para ser nosso amigo."
,"20":"Por isso, nós te nomeamos hoje sumo sacerdote do teu povo, e terás o título de amigo do rei. Nós confiamos que tu estarás connosco nos nossos objectivos e que serás sempre nosso amigo». E mandou-lhe um manto de púrpura e uma coroa de ouro."
,"21":"Na festa das Tendas, no sétimo mês do ano cento e sessenta, Jónatas começou a usar as vestes sagradas. Enquanto isso, ia também recrutando soldados e fabricando muitas armas."
,"22":"Demétrio ouviu falar disso, e ficou muito contrariado. Pensou:"
,"23":"«Que é que nós fizemos para que Alexandre tenha conseguido passar à nossa frente e conquistado a amizade dos judeus?"
,"24":"Também eu vou escrever-lhes palavras de encorajamento, de elogios e com promessa de donativos, para ficarem do meu lado»."
,"25":"E mandou-lhes uma carta redigida nestes termos: «Do rei Demétrio ao povo judeu. Saudações!"
,"26":"Ficámos muito contentes ao saber que estais observando os acordos feitos connosco, e que continuais nossos amigos fiéis, sem passar para o lado dos nossos inimigos."
,"27":"Continuai fiéis a nós e retribuiremos com benefícios tudo aquilo que fizerdes por nós:"
,"28":"isentar-vos-emos de muitos impostos e concederemos favores."
,"29":"A partir de agora, eu libero e isento todos os judeus de pagar o tributo e o imposto sobre o sal e sobre o ouro da coroa."
,"30":"Renuncio à terça parte da produção de plantações anuais e à metade do fruto das árvores a que eu teria direito. A partir de hoje e para todo o sempre, deixo de recolher tudo isso da Judeia e dos seus três distritos anexos da Samaria e da Galileia."
,"31":"Jerusalém seja uma cidade santa e isenta, juntamente com o seu território, sem dízimos e sem impostos."
,"32":"Renuncio também ao poder sobre a fortaleza que está em Jerusalém, passando-a para o sumo sacerdote, a fim de que coloque nela homens por ele escolhidos para a guardar."
,"33":"Dou gratuitamente a liberdade a todo o prisioneiro de guerra que tenha sido levado da Judeia para qualquer parte do meu reino. Todos ficarão livres de qualquer tributo, inclusive sobre os animais."
,"34":"Todos os dias de festa, sábados, luas novas, dias santos, como também os três dias antes e três dias depois de cada festa, serão dias de isenção e amnistia de impostos para todos os judeus que moram no meu reino."
,"35":"Ninguém estará autorizado a perturbar ou incomodar nenhum judeu por nenhum motivo."
,"36":"Serão recrutados cerca de trinta mil judeus para os exércitos do rei, e eles receberão o mesmo pagamento que as outras tropas reais."
,"37":"Alguns deles serão destacados para as maiores fortalezas do rei, e outros serão nomeados para cargos de confiança no reino. Os seus chefes e comandantes serão escolhidos entre eles, e todos poderão viver de acordo com as suas próprias leis, conforme o rei determina para toda a Judeia."
,"38":"Quanto aos três distritos da província da Samaria que foram anexados à Judeia, sejam com ela considerados dependentes de um só governo e não estejam debaixo de nenhuma outra autoridade que não seja a do sumo sacerdote."
,"39":"Faço doação de Ptolemaida e sua região ao Templo de Jerusalém, a fim de cobrir as despesas do culto."
,"40":"Farei também em cada ano um donativo pessoal de quinze mil moedas de prata, tiradas dentre as rendas do rei, que serão recolhidas em localidades mais convenientes."
,"41":"E o que ainda devo, isto é, o que não foi pago pelos meus encarregados, como se fazia no começo, agora será tudo entregue para as obras do Templo."
,"42":"Além disso, as cinco mil moedas de prata que eram recolhidas, em cada ano, das rendas do Templo, vou deixar de as recolher, porque pertencem aos sacerdotes oficiantes."
,"43":"Ficam amnistiados todos os que fugirem para o Templo ou para a sua área, por causa de impostos reais ou por qualquer outra cobrança, assim como lhes fica também garantida a posse de tudo o que é seu, dentro do meu reino."
,"44":"As despesas com a reconstrução e restauração do Templo ficam por conta do tesouro real."
,"45":"Também sairão do tesouro real as despesas para a reconstrução das muralhas de Jerusalém e para as fortificações ao seu redor. E a mesma coisa para se reerguerem outras muralhas na Judeia»."
,"46":"Jónatas e o povo ouviram as propostas de Demétrio, mas não acreditaram, nem as aceitaram, pois estavam muito bem lembrados do grande mal que ele tinha feito contra Israel e como os havia oprimido."
,"47":"Preferiram Alexandre, que foi o primeiro a enviar-lhes mensagens de paz, e tornaram-se aliados permanentes dele."
,"48":"Então o rei Alexandre reuniu grande exército e partiu para lutar contra Demétrio."
,"49":"Os dois reis travaram combate, e o exército de Demétrio acabou por fugir. Alexandre foi em sua perseguição e derrotou-o."
,"50":"A batalha foi muito dura e demorou até ao pôr do sol. E, nesse dia, Demétrio morreu."
,"51":"Alexandre enviou embaixadores a Ptolomeu, rei do Egipto, com a seguinte mensagem:"
,"52":"«Após voltar para o meu reino, e depois de me sentar no trono real dos meus pais e assumir o poder, esmaguei Demétrio e recuperei o nosso território."
,"53":"Travei batalha contra ele e o seu exército, e derrotei-o. Em seguida, sentei-me no trono real dele."
,"54":"Agora façamos aliança entre nós: dá-me a tua filha como esposa, e eu tornar-me-ei teu genro. A ti e a ela darei presentes dignos de ti»."
,"55":"O rei Ptolomeu respondeu: «Feliz o dia em que voltaste para a terra dos teus pais, e te sentaste no trono real!"
,"56":"Farei o que me propuseste na carta. Mas vem ao meu encontro em Ptolemaida, para que possamos ver-nos pessoalmente e tornar-me-ei teu sogro, como me pediste»."
,"57":"Ptolomeu partiu do Egipto, levando consigo a filha Cleópatra, e foi até Ptolemaida, no ano cento e sessenta e dois."
,"58":"O rei Alexandre foi ao seu encontro. Ptolomeu entregou-lhe sua filha Cleópatra e celebrou o casamento em Ptolemaida, com grandes solenidades, como os reis costumam fazer."
,"59":"O rei Alexandre escreveu também a Jónatas, convidan-do-o a ir ao seu encontro."
,"60":"Jónatas foi a Ptolemaida com todo o aparato, e aí encontrou os dois reis. Deu-lhes prata, ouro e muitos presentes, e aos seus amigos. Foi muito bem tratado por eles."
,"61":"Reuniu-se, porém, contra ele a peste de Israel, alguns apóstatas prontos para o acusarem. Mas o rei não lhes deu atenção."
,"62":"Pelo contrário, mandou Jónatas mudar de roupa, e revestiram-no com púrpura. E assim foi feito."
,"63":"Em seguida, o rei fez com que ele se sentasse ao seu lado. E disse aos oficiais: «Saí com ele pela cidade e fazei anunciar que ninguém o acuse de nada, nem o perturbe por motivo nenhum»."
,"64":"Quando os acusadores viram o prestígio de Jónatas, as proclamações do arauto e a púrpura com que estava vestido, fugiram todos."
,"65":"E o rei deu-lhe honra ainda maior, colocando-o entre os seus maiores amigos e nomeando-o general e governador."
,"66":"Jónatas voltou para Jerusalém tranquilo e feliz."
,"67":"No ano cento e sessenta e cinco, Demétrio, filho de Demétrio, foi de Creta para a terra de seus pais."
,"68":"Ao saber disso, o rei Alexandre ficou muito preocupado e voltou para Antioquia."
,"69":"Entretanto, Demétrio nomeou, como seu general, Apolónio, governador da Celessíria. Este reuniu grande exército e acampou perto de Jâmnia. E mandou dizer ao sumo sacerdote Jónatas:"
,"70":"«Tu és o único que se revoltou contra nós e me deixou em posição ridícula. Porque é que julgas ter vantagem contra nós entre as montanhas?"
,"71":"Se confias no teu exército, desce contra nós na planície. Vejamos quem pode mais, porque do meu lado estão as forças das cidades."
,"72":"Pergunta, e ficarás a saber quem sou eu e quem são os meus aliados. Vão dizer-te que vós não sereis capazes de ficar de pé diante de nós, pois os teus antepassados fugiram duas vezes no seu próprio país."
,"73":"Vós não sereis capazes de resistir à cavalaria e a este exército tão numeroso, na planície onde não existem pedras, pedreiras, nem lugar para onde fugir»."
,"74":"Ao receber o recado de Apolónio, Jónatas ficou alterado, escolheu dez mil homens e saiu de Jerusalém. Seu irmão Simão juntou-se a ele com reforços."
,"75":"Jónatas acampou diante de Jope. Como aí estava uma guarnição de Apolónio, a gente da cidade fechou as portas. Então Jónatas atacou a cidade."
,"76":"Os que estavam dentro ficaram com medo, abriram as portas e Jónatas tomou Jope."
,"77":"Ao saber disso, Apolónio convocou três mil cavaleiros, além de poderoso exército, e partiu na direcção de Azoto, como se quisesse atravessar a região. Ao mesmo tempo, porém, contando com a sua numerosa cavalaria, avançou pela planície."
,"78":"Jónatas marchou atrás dele, na direcção de Azoto, e os dois exércitos enfrentaram-se."
,"79":"Apolónio tinha deixado mil cavaleiros escondidos na retaguarda,"
,"80":"porém Jónatas sabia que tinha uma emboscada atrás de si. Deixou o seu exército ficar cercado e permitiu que atirassem flechas contra eles desde o amanhecer até ao entardecer."
,"81":"Os soldados resistiram de acordo com as instruções de Jónatas, até que os cavaleiros de Apolónio se cansaram."
,"82":"Quando a cavalaria se cansou, Simão avançou com as tropas e atacou. Os inimigos foram derrotados e começaram a fugir."
,"83":"Os cavaleiros ficaram perdidos pela planície; depois fugiram para Azoto e entraram em Bet-Dagon, templo do seu ídolo, tentando pôr-se a salvo."
,"84":"Jónatas, porém, incendiou Azoto e as cidades vizinhas, após recolher os despojos. Incendiou também o templo de Dagon com todos os que se haviam refugiado dentro dele."
,"85":"Aqueles que tombaram a fio de espada ou morreram queimados chegaram a oito mil."
,"86":"Jónatas partiu daí, e acampou diante de Ascalon. Os habitantes da cidade saíram e receberam-no com grande festa."
,"87":"Daí, Jónatas e os seus companheiros voltaram para Jerusalém, transportando muitos despojos."
,"88":"O rei Alexandre ouviu contar estes factos e resolveu conceder mais honrarias a Jónatas."
,"89":"Mandou-lhe, então, uma fivela de ouro, que é costume oferecer aos parentes do rei, e concedeu-lhe também, a título de doação, a propriedade de Acaron e todo o seu território."
}`)
	CurrentBook.AddChapter(11, `{
"1":"O rei do Egipto reuniu um exército, tão numeroso como a areia da praia, e muitos navios. Ele pretendia, com a astúcia, apoderar-se do reino de Alexandre e anexá-lo ao seu."
,"2":"Partiu para a Síria com propostas de amizade. A gente de cada cidade abria as portas e saía ao encontro dele, porque Alexandre tinha ordenado que o acolhessem, pois se tratava do seu sogro."
,"3":"Porém, logo que entrava numa cidade, Ptolomeu deixava aí uma guarnição militar."
,"4":"Quando chegou perto de Azoto, mostraram-lhe o templo de Dagon todo incendiado, Azoto e seus arredores em ruínas, cadáveres espalhados, e corpos queimados por Jónatas durante a guerra, pois eles tinham sido amontoados ao longo do caminho."
,"5":"Contaram ao rei tudo o que Jónatas fizera, esperando que o reprovasse, mas ele não disse nada."
,"6":"Entretanto, Jónatas foi ao encontro dele em Jope, com toda a pompa. Os dois cumprimentaram-se e aí passaram a noite."
,"7":"Depois Jónatas acompanhou o rei até ao rio Elêutero. Em seguida, voltou para Jerusalém."
,"8":"O rei Ptolomeu, por seu lado, foi tomando todas as cidades da orla marítima, até chegar a Selêucida, junto ao mar. Eram maus os seus planos contra Alexandre."
,"9":"Mandou emissários ao rei Demétrio com este recado: «Vem, vamos fazer uma aliança: eu dou-te por esposa a minha filha, mulher de Alexandre, e tu serás de facto o rei no reino de teu pai."
,"10":"Estou arrependido de ter dado a minha filha por esposa a Alexandre, porque agora ele quer matar-me»."
,"11":"Ptolomeu caluniou Alexandre, porque estava interessado no seu reino."
,"12":"Depois de lhe raptar a filha, entregou-a a Demétrio. Foi assim que ele mudou de atitude em relação a Alexandre, e a inimizade entre os dois tornou-se pública."
,"13":"A seguir, Ptolomeu entrou em Antioquia e fez-se coroar rei da Ásia. Ficou com duas coroas reais: a do Egipto e a da Ásia."
,"14":"Enquanto isso, o rei Alexandre estava na Cilícia, porque o povo dessas regiões se havia revoltado."
,"15":"Ao tomar conhecimento do que estava acontecendo, foi lutar contra Ptolomeu. No entanto, este enfrentou-o com forças maiores e derrotou-o."
,"16":"Alexandre fugiu para a Arábia, a fim de se esconder, enquanto o rei Ptolomeu recebia homenagens."
,"17":"O árabe Zabdiel cortou a cabeça de Alexandre e mandou-a a Ptolomeu."
,"18":"Entretanto, o rei Ptolomeu morreu três dias depois, e os soldados que ele tinha deixado nas fortalezas foram mortos pela gente que morava nessas cidades fortificadas."
,"19":"Deste modo, Demétrio começou a reinar no ano cento e sessenta e sete."
,"20":"Nessa mesma época, Jónatas reuniu os soldados da Judeia para atacar a fortaleza em Jerusalém, e mandou construir muitas máquinas de assalto para essa luta."
,"21":"Uns maus patriotas, apóstatas, foram dizer ao rei Demétrio que Jónatas tinha cercado a fortaleza."
,"22":"Ao ouvir isso, Demétrio ficou furioso, e resolveu partir imediatamente para Ptolemaida. Escreveu a Jónatas ordenando que suspendesse o cerco à fortaleza e fosse o mais breve possível ao seu encontro em Ptolemaida."
,"23":"Ao receber a carta, Jónatas mandou continuar o cerco. Em seguida, escolheu alguns anciãos de Israel e sacerdotes, e foi pessoalmente enfrentar o perigo."
,"24":"Levando prata e ouro, roupas e outros presentes, apresentou-se ao rei em Ptolemaida, e este recebeu-o bem."
,"25":"Alguns apóstatas continuaram a falar contra Jónatas,"
,"26":"mas o rei Demétrio tratou-o da mesma forma que os reis anteriores, elogiando-o diante de todos os amigos:"
,"27":"confirmou-o como sumo sacerdote e nos outros cargos importantes que ele tinha antes, e considerou-o como um dos seus principais amigos."
,"28":"Jónatas pediu ao rei que isentasse de impostos a Judeia e os três distritos da Samaria; em compensação, ele mandar-lhe-ia dez toneladas de prata."
,"29":"O rei concordou, e sobre isso escreveu-lhe a seguinte carta:"
,"30":"«Do rei Demétrio ao seu irmão Jónatas e à nação dos judeus. Saudações!"
,"31":"Aqui transcrevemos cópia da carta que escrevemos a vosso respeito ao nosso parente Lástenes, a fim de que possais dela tomar conhecimento:"
,"32":"Do rei Demétrio ao seu pai Lástenes. Saudações!"
,"33":"Nós achámos bem favorecer a nação dos judeus, que são nossos amigos e observam tudo o que nos parece justo, por causa das suas boas intenções a nosso respeito."
,"34":"Confirmámos-lhes a posse do território da Judeia e dos três distritos de Aferema, Lida e Ramataim, que eram da Samaria e foram anexados à Judeia, com tudo o que lhes pertence, em benefício dos sacerdotes de Jerusalém, como compensação pelos impostos que pagavam anualmente ao rei sobre a produção das plantações e dos frutos das árvores."
,"35":"Outros tributos que nos são devidos como dízimo, o imposto das salinas e as coroas que nos devem, a partir de hoje dispensamos os judeus de tudo isso."
,"36":"Nenhuma destas disposições será revogada, a partir de agora e para todo o sempre."
,"37":"Procura, pois, fazer uma cópia deste documento, que será entregue a Jónatas, a fim de que o coloque em lugar bem visível na montanha santa»."
,"38":"O rei Demétrio sentiu que o país estava calmo e que ninguém mais lhe fazia oposição. Dispensou, então, as suas forças armadas, voltando cada um para a sua casa, menos os batalhões mercenários recrutados entre as ilhas das nações. Todos os contingentes, porém, que eram do tempo dos seus pais, voltaram-se contra ele."
,"39":"Trifão, antigo partidário de Alexandre, notou que todos os quartéis andavam a reclamar contra Demétrio, e foi à procura do árabe Jâmlico, que estava a criar o menino Antíoco, filho de Alexandre."
,"40":"Pediu que lhe entregasse o menino para o fazer rei no lugar do pai Alexandre. Contou-lhe tudo o que Demétrio tinha feito e como as suas tropas o odiavam. E Trifão permaneceu aí muitos dias."
,"41":"Nesse meio tempo, Jónatas mandou pedir ao rei Demétrio que retirasse as guarnições da fortaleza de Jerusalém e das outras fortalezas, pois estavam continuamente a provocar Israel."
,"42":"Demétrio mandou a Jónatas esta resposta: «Não farei somente isso por ti e pela tua nação. Logo que me for dada oportunidade, dar-te-ei muito prestígio a ti e ao teu povo."
,"43":"Neste momento, eu gostaria que me mandasses alguns homens para lutar ao meu lado, porque todas as minhas tropas me abandonaram»."
,"44":"Então Jónatas mandou três mil homens valentes para Antioquia. Quando se apresentaram ao rei, este ficou muito contente."
,"45":"A população da cidade aglomerou-se no centro: eram cerca de cento e vinte mil pessoas que queriam matar o rei."
,"46":"Ele fugiu para dentro do palácio, enquanto o povo tomava conta das ruas e começava a atacar."
,"47":"Então o rei pediu ajuda aos judeus, que se reuniram todos do lado dele. Depois foram-se espalhando pela cidade, e nesse dia mataram cerca de cem mil pessoas."
,"48":"Nesse mesmo dia, incendiaram a cidade, recolheram muitos despojos e salvaram o rei."
,"49":"Os revoltosos viram que os judeus foram capazes de dominar a cidade como quiseram, e perderam a coragem. Começaram a gritar para o rei, dizendo:"
,"50":"«Vamos fazer as pazes, e que os judeus deixem de nos atacar, a nós e à nossa cidade»."
,"51":"Depuseram as armas e fizeram um acordo. Então os judeus cresceram em prestígio diante do rei e de todos os que viviam no seu reino. E voltaram para Jerusalém, levando muitos despojos."
,"52":"Então o rei Demétrio ocupou o trono, e o país ficou em paz sob o seu governo."
,"53":"Demétrio, porém, não cumpriu nenhuma das promessas: distanciou-se de Jónatas e, em lugar de retribuir os serviços que este lhe havia prestado, começou a causar-lhe muitos dissabores."
,"54":"Depois de tudo isso, Trifão voltou, trazendo Antíoco, ainda muito jovem. Antíoco foi proclamado rei e passou a usar a coroa."
,"55":"Todos os contingentes militares que Demétrio tinha dispensado passaram para o lado de Antíoco, lutaram contra Demétrio, que foi derrotado e teve de fugir."
,"56":"Trifão apossou-se dos elefantes e tomou a cidade de Antioquia."
,"57":"Então o jovem Antíoco escreveu uma carta a Jónatas, dizendo: «Confirmo-te como sumo sacerdote, entrego-te o governo dos quatro distritos e faço de ti um dos amigos do rei»."
,"58":"Mandou-lhe taças de ouro e talheres completos, dando-lhe o direito de beber em taças de ouro, de vestir o manto de púrpura e usar a fivela de ouro."
,"59":"Colocou o irmão dele, Simão, como comandante da região que ia desde a Escada de Tiro até à fronteira com o Egipto."
,"60":"Jónatas partiu em expedição pelas cidades do outro lado do rio, e as tropas da Síria reuniram-se ao seu lado, para auxiliar nos combates. Chegou assim até Ascalon e a gente da cidade recebeu-o com festas."
,"61":"Daí foi para Gaza, mas os habitantes da cidade trancaram as portas. Então Jónatas cercou a cidade, saqueou e incendiou os seus arredores."
,"62":"Os habitantes de Gaza pediram paz a Jónatas. Ele concedeu-a, mas prendeu os filhos dos seus governantes como reféns, e mandou-os para Jerusalém. Em seguida, atravessou o país até chegar a Damasco."
,"63":"Jónatas ouviu dizer que os generais de Demétrio estavam perto de Cedes na Galileia, com um forte exército, pretendendo cortar-lhe o caminho."
,"64":"Então marchou para os enfrentar, deixando o seu irmão Simão no país."
,"65":"Simão acampou em frente de Betsur, lutou muitos dias contra a cidade e, por fim, conseguiu fechar-lhe todas as saídas."
,"66":"Os habitantes pediram paz e ele concedeu-lha. Contudo, obrigou-os a abandonar a cidade, ocupou-a, e colocou nela uma guarnição."
,"67":"Enquanto isso, Jónatas e o seu exército acamparam perto do lago de Genesar, e de manhã cedo rumaram para a planície de Asor."
,"68":"O exército dos estrangeiros enfrentou-os na planície, mas deixaram nos montes uma emboscada contra Jónatas. Enquanto os primeiros o atacavam pela frente,"
,"69":"os da emboscada saíram e começaram também a lutar."
,"70":"Todos os companheiros de Jónatas fugiram. Ficaram apenas Matatias, filho de Absalão, e Judas, filho de Calfi, que eram generais do exército."
,"71":"Perante isso, Jónatas rasgou as vestes, cobriu a cabeça de terra e rezou."
,"72":"Depois saiu para a luta contra os inimigos e derrotou-os, obrigando-os a fugir."
,"73":"Os seus companheiros, que estavam fugindo, tornaram a unir-se a Jónatas e perseguiram os inimigos até Cedes, onde estava o acampamento inimigo. Ao chegarem aí, acamparam."
,"74":"Nesse dia, morreram cerca de três mil soldados estrangeiros. E Jónatas voltou para Jerusalém."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Vendo que o tempo estava a agir em seu favor, Jónatas escolheu alguns homens e mandou-os a Roma, para confirmar e renovar a amizade com os romanos."
,"2":"A Esparta e outros lugares, enviou cartas com a mesma finalidade."
,"3":"Tendo chegado a Roma, os mensageiros de Jónatas entraram no Senado e disseram: «O sumo sacerdote Jónatas e a nação dos judeus mandaram-nos aqui para renovar o acordo de amizade e mútua defesa, como antigamente»."
,"4":"Os romanos deram-lhes salvo-conduto, para que pudessem chegar à Judeia sãos e salvos."
,"5":"Cópia da carta que Jónatas escreveu aos espartanos:"
,"6":"«Do sumo sacerdote Jónatas, do conselho da nação, dos sacerdotes e do povo judeu em geral, aos irmãos espartanos. Saudações!"
,"7":"Já no passado foi enviada ao sumo sacerdote Onias uma carta da parte de Ario, vosso rei, dizendo que vós sois nossos irmãos. Anexamos uma cópia dessa carta."
,"8":"Onias recebeu com honras o portador da carta e aceitou a carta onde se falava de amizade e aliança."
,"9":"Nós, porém, não precisamos disso, pois temos o apoio dos livros sagrados que estão nas nossas mãos."
,"10":"Mesmo assim, estamos tentando renovar a nossa fraternidade e amizade convosco, para não nos tornarmos estranhos uns aos outros, pois há já muito tempo que nos mandastes a carta."
,"11":"Durante todo este tempo, sem qualquer interrupção, nas festas e outros dias estabelecidos, nos lembrámos de vós durante os sacrifícios que oferecemos e nas orações, como é necessário fazer quando a gente se lembra dos irmãos."
,"12":"Estamos contentes com o vosso sucesso."
,"13":"Nós, porém, estamos cercados de dificuldades e enfrentando muitas tribulações e guerras, pois os reis nossos vizinhos nos atacaram."
,"14":"Não quisemos incomodar-vos com essas guerras, como de resto a nenhum dos outros nossos amigos e aliados,"
,"15":"porque nós temos a ajuda do Céu. Deste modo, livrámo-nos dos nossos inimigos, que foram humilhados."
,"16":"Agora, escolhemos Numénio, filho de Antíoco, e Antípatro, filho de Jasão, como nossos embaixadores junto dos romanos, a fim de renovar a nossa antiga amizade e aliança com eles."
,"17":"Determinámos também que eles mesmos fossem transmitir-vos os nossos cumprimentos e levar esta carta, que tem por objectivo renovar a nossa fraternidade."
,"18":"Finalmente, gostaríamos de receber uma resposta vossa ao que nós aqui dizemos»."
,"19":"Cópia da carta que eles tinham mandado a Onias:"
,"20":"«De Ario, rei dos espartanos, ao grande sacerdote Onias. Saudações!"
,"21":"Em documento sobre os espartanos e os judeus, foi descoberto que são parentes, descendentes de Abraão."
,"22":"Assim, a partir do momento em que tivemos conhecimento disso, ficámos desejando muito que vós nos escrevêsseis, falando da vossa situação actual."
,"23":"Da nossa parte, queremos afirmar que o gado e as vossas riquezas são nossos, da mesma forma que é vosso tudo o que é nosso. Determinamos que vos fosse levada uma mensagem nesse sentido»."
,"24":"Jónatas ouviu dizer que os generais de Demétrio tinham voltado para o atacarem, trazendo um exército mais numeroso que o anterior."
,"25":"Então saiu de Jerusalém e foi enfrentá-los na região de Amatite, para que não lhe invadissem o território."
,"26":"Jónatas mandou espiões ao acampamento inimigo. Ao voltar, contaram que os generais de Demétrio estavam preparados para cair de surpresa sobre os judeus naquela mesma noite."
,"27":"Logo que o sol se pôs, Jónatas deu ordens para que os seus companheiros ficassem de vigia e estivessem armados, preparados para lutar a noite toda, e colocou sentinelas em torno do acampamento."
,"28":"Quando os inimigos souberam que Jónatas e os seus companheiros estavam preparados para a batalha, ficaram com medo e acovardaram-se; acenderam fogueiras no acampamento e retiraram-se."
,"29":"Jónatas e os seus companheiros, porém, não notaram nada até de manhã, pois viam as fogueiras acesas."
,"30":"Então saíram em perseguição contra eles, mas não conseguiram alcançá-los, porque já tinham atravessado o rio Elêutero."
,"31":"Jónatas voltou-se, então, para o lado dos árabes, chamados zabadeus, exterminou-os e recolheu os despojos."
,"32":"Em seguida, levantou acampamento e foi para Damasco, percorrendo toda a região."
,"33":"Também Simão partiu para a luta. Atravessou até Ascalon e outros lugares fortificados. Depois foi para Jope e tomou a cidade."
,"34":"De facto, ele tinha recebido notícia de que queriam entregar essa fortaleza aos partidários de Demétrio. Por isso, deixou ali um batalhão de guarda para vigiar a cidade."
,"35":"Jónatas voltou e, em seguida, convocou a assembleia dos anciãos do povo para resolver com eles acerca da construção de lugares fortificados na Judeia,"
,"36":"da elevação da muralha de Jerusalém e da construção de uma alta muralha entre a fortaleza e a cidade. Desse modo, haveria separação entre ambas, para que a fortaleza ficasse isolada e os seus ocupantes não pudessem vender nem comprar."
,"37":"Então reuniram-se para reconstruir a cidade. O muro junto do riacho no lado oriental caiu, e Jónatas reconstruiu essa parte chamada Cafenata."
,"38":"Simão, por seu lado, reconstruiu na planície a cidade de Adida, fortificou-a e colocou-lhe portões e trancas."
,"39":"Trifão ambicionava tornar-se rei da Ásia, usar coroa e eliminar o rei Antíoco,"
,"40":"mas temia que Jónatas não lho permitisse ou que o atacasse. Por isso, procurava maneiras de o capturar e matar. Levantou acampamento e foi para Betsã."
,"41":"Jónatas partiu para enfrentá-lo em Betsã, levando quarenta mil homens escolhidos para combate ordenado."
,"42":"Quando Trifão viu que Jónatas vinha com poderoso exército, teve medo de prendê-lo."
,"43":"Preparou-lhe, então, uma recepção festiva, apresentando-o a todos os seus amigos, deu-lhe muitos presentes e mandou que os seus amigos e todas as suas tropas lhe obedecessem, como se fosse a si próprio."
,"44":"E perguntou a Jónatas: «Para que estás a dar trabalho a um exército tão grande, quando não há ninguém a lutar contra nós?"
,"45":"Manda essa gente voltar para casa. Escolhe apenas alguns homens e vem comigo até Ptolemaida. Vou entregar-te a cidade com as outras fortalezas, o restante do exército e os encarregados de negócios. Em seguida, voltarei para casa. Foi para isso que vim até aqui»."
,"46":"Jónatas acreditou nele e fez o que ele propôs: dispensou o exército, que voltou para a Judeia,"
,"47":"e ficou com três mil homens apenas. Deixou dois mil na Galileia, e mil foram com ele."
,"48":"Logo que Jónatas entrou em Ptolemaida, a gente da cidade fechou as portas, prendeu Jónatas e matou à espada todos os seus acompanhantes."
,"49":"Em seguida, Trifão mandou o exército e a cavalaria até à Galileia e à grande planície, para acabar com todos os companheiros de Jónatas."
,"50":"Estes, porém, souberam que Jónatas e seus companheiros tinham sido presos e mortos. Animaram-se mutuamente e foram em coluna cerrada, prontos para entrar em luta."
,"51":"Os seus perseguidores viram que eles estavam dispostos a arriscar a vida, e voltaram para trás."
,"52":"Assim, todos puderam voltar tranquilamente para o país de Judá. Choraram Jónatas e os seus companheiros e ficaram com muito medo. E todo o Israel fez grande luto."
,"53":"As nações vizinhas começaram a pensar em acabar com os judeus, dizendo assim: «Eles já não têm chefe, nem onde se apoiar! Vamos atacá-los e apagar a sua lembrança do meio da humanidade»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Simão ouviu dizer que Trifão reunira um poderoso exército para devastar a Judeia."
,"2":"Viu que o povo estava apavorado e inquieto. Subiu, então, a Jerusalém, reuniu as tropas"
,"3":"e procurou animá-las, dizendo: «Vós sabeis o que eu e meus irmãos, a família de meu pai, já fizemos por causa da Lei e do Templo, e conheceis as nossas guerras e dificuldades."
,"4":"Todos os meus irmãos morreram pela causa de Israel; sobrei somente eu."
,"5":"Longe de mim, contudo, a ideia de poupar a minha vida, em momento nenhum de tribulação, pois não sou mais do que os meus irmãos."
,"6":"Pelo contrário, vingarei o meu povo, o Templo, as mulheres e os vossos filhos, pois todas as nações, movidas pelo ódio, se reuniram para nos esmagar»."
,"7":"Ao ouvir estas palavras, todos se encorajaram"
,"8":"e gritaram em alta voz: «Tu és o nosso comandante em lugar dos teus irmãos Judas e Jónatas!"
,"9":"Dirige a nossa guerra, e nós faremos tudo o que nos mandares»."
,"10":"Simão convocou então todos os homens em condições de lutar, mandou terminar a muralha de Jerusalém e fortificar todo o contorno da cidade."
,"11":"Depois enviou Jónatas, filho de Absalão, para Jope, com um grupo considerável. Jónatas expulsou os que ocupavam a cidade e estabeleceu-se nela."
,"12":"Trifão saiu de Ptolemaida com poderoso exército, a fim de ir à Judeia, levando Jónatas como prisioneiro."
,"13":"Simão tinha acampado em Adida, diante da planície."
,"14":"Ao saber que Simão tinha assumido o lugar do seu irmão Jónatas, e que se preparava para combatê-lo, Trifão mandou mensageiros, com este recado:"
,"15":"«Mantemos preso o teu irmão Jónatas por causa do dinheiro que ele deve ao tesouro real, pelos cargos que exercia."
,"16":"Manda três toneladas e meia de prata, com dois dos seus filhos como reféns, para que Jónatas não fique contra nós, quando for libertado. Então nós soltá-lo-emos»."
,"17":"Simão percebeu que falavam de má fé. No entanto mandou entregar o dinheiro e as crianças, a fim de não provocar mal-estar entre o povo,"
,"18":"já que poderiam dizer: «Jónatas morreu, porque Simão não mandou o dinheiro, nem os filhos a Trifão»."
,"19":"Então ele mandou as crianças e as três toneladas e meia de prata. Trifão, porém, faltou à palavra e não soltou Jónatas."
,"20":"Depois disso, Trifão marchou para invadir e saquear a região, rodeando pelo caminho de Adora. Simão e o seu exército seguiam-no por toda a parte."
,"21":"Os que estavam na fortaleza enviavam mensagens a Trifão, solicitando que fosse encontrar-se com eles através do deserto e que lhes mandasse alimentos."
,"22":"Trifão preparou toda a sua cavalaria, mas nessa noite nevou muito. Então ele afastou-se da região e foi para Galaad."
,"23":"Quando chegou perto de Bascama, matou Jónatas e aí o enterrou."
,"24":"Em seguida, voltou para a sua terra."
,"25":"Mais tarde, Simão mandou recolher os ossos do seu irmão Jónatas e sepultou-os em Modin, cidade de seus pais."
,"26":"Todo o Israel chorou muito por ele, e ficou de luto durante muitos dias."
,"27":"Simão construiu um túmulo no lugar onde estavam sepultados seu pai e seus irmãos. Fez um monumento alto, vistoso, com pedras polidas de um lado e do outro."
,"28":"Fez também sete pirâmides voltadas umas para as outras, em memória de seu pai, de sua mãe e de seus quatro irmãos."
,"29":"Para isso construiu adornos artísticos, rodeados de grandes colunas, e colocou armaduras nas colunas para recordação perpétua. Junto das armaduras fez umas figuras de navios, que podiam ser vistos por quem andasse a navegar no mar."
,"30":"Esse túmulo que ele construiu em Modin existe até ao dia de hoje."
,"31":"Trifão também agiu com falsidade para com o jovem rei Antíoco, e mandou-o matar."
,"32":"Reinou em lugar dele, usou a coroa de rei da Ásia, e acabou por provocar uma enorme desgraça no país."
,"33":"Simão reconstruiu as fortalezas da Judeia, cercou-as de altas torres e grandes muralhas com portões e trancas, e abasteceu-as de mantimentos."
,"34":"Depois escolheu alguns homens e mandou-os ao rei Demétrio, para conseguir a isenção de impostos para o país, pois tudo o que Trifão fazia era roubar."
,"35":"O rei Demétrio respondeu-lhe, com esta carta:"
,"36":"«Do rei Demétrio ao sumo sacerdote Simão, amigo dos reis, aos anciãos e à nação dos judeus. Saudações!"
,"37":"Recebemos a coroa de ouro e a palma que nos mandastes, e estamos prontos para fazer convosco uma paz duradoura e escrever aos encarregados dos nossos negócios para que vos isentem de impostos."
,"38":"Continua de pé o que já determinámos em vosso favor. As fortalezas que construístes ficam em vosso poder."
,"39":"Perdoamo-vos os erros e falhas que cometestes até à presente data, assim como o imposto real que nos deveis. Caso devais alguma contribuição em Jerusalém, não vos será exigida."
,"40":"Se alguns de vós desejarem alistar-se na nossa guarda pessoal, venham alistar-se. E reine a paz entre nós!»"
,"41":"Corria o ano cento e setenta, quando Israel ficou livre do jugo das outras nações."
,"42":"A partir daí, o povo passou a escrever assim as datas em documentos e contratos: «Ano um de Simão, o Grande, sumo sacerdote, general e chefe dos judeus...»"
,"43":"Nesses dias, Simão acampou contra Gazara, e cercou-a com o seu exército. Construiu uma torre móvel, aproximou-se da cidade, atacou-lhe uma das torres e conseguiu tomá-la."
,"44":"Os que estavam na torre móvel saltaram para dentro da cidade, provocando grande agitação."
,"45":"Os homens da cidade subiram para a muralha com as suas mulheres e filhos. Rasgando as vestes, pediam paz a Simão em altos gritos:"
,"46":"«Não nos trates segundo a nossa maldade, mas segundo a tua misericórdia!»"
,"47":"Simão não fez mal à população e suspendeu o ataque. Obrigou-os, porém, a sair da cidade e purificou as casas onde havia ídolos. Depois entrou na cidade entre hinos, cânticos e acções de graças."
,"48":"Tirou de lá tudo o que havia de impuro, e levou, para residir nesse lugar, gente que praticava a Lei. Fortificou a cidade e nela construiu uma casa para si."
,"49":"O batalhão aquartelado na fortaleza em Jerusalém estava impedido de sair pela vizinhança para comprar ou vender; passavam muita fome e muitos morriam."
,"50":"Eles clamaram a Simão, pedindo que lhes concedesse a paz. Simão concordou, mas expulsou-os dali e purificou a fortaleza de todas as abominações."
,"51":"Os judeus puderam entrar na fortaleza no dia vinte e três do segundo mês do ano cento e setenta e um. Entraram aos gritos, levando ramos, tocando cítaras, címbalos e harpas, entoando hinos e cânticos, pois acabava de ser derrotado o maior inimigo de Israel."
,"52":"Simão determinou que esse dia fosse comemorado todos os anos com muita alegria. Fortificou ainda mais o monte do Templo, ao lado da fortaleza, e lá ficou a residir com a sua família."
,"53":"Notando que o seu filho João era homem feito, nomeou-o comandante de todas as forças militares. E João foi morar em Gazara."
}`)
	CurrentBook.AddChapter(14, `{
"1":"No ano cento e setenta e dois, o rei Demétrio reuniu as suas tropas e foi para a Média, a fim de conseguir ajuda para a guerra contra Trifão."
,"2":"Arsaces, rei da Pérsia e da Média, soube que Demétrio tinha invadido o seu território e mandou um dos seus generais prendê-lo vivo."
,"3":"Ele foi, derrotou o exército de Demétrio, prendeu-o e levou-o a Arsaces, que o meteu na prisão."
,"4":"Durante toda a vida de Simão, a Judeia ficou em paz. Simão procurou o bem-estar do seu povo, que aprovou sempre o seu governo e a sua glória."
,"5":"Ele gloriosamente tomou Jope e fez dela o seu porto, abrindo caminho para as ilhas do mar."
,"6":"Alargou os limites da nação e manteve o país sob controlo."
,"7":"Juntou grande número de prisioneiros e dominou Gazara, Betsur e a fortaleza. Retirou delas as impurezas, e ninguém lhe pôde resistir."
,"8":"Cada um pôde cultivar em paz os seus campos; a terra dava as suas colheitas, e as árvores da planície os seus frutos."
,"9":"Os anciãos sentavam-se nas praças, todos a falar de prosperidade, enquanto os jovens se revestiam de glória, usando as suas vestimentas de guerra."
,"10":"Abasteceu as cidades de alimentos, e destinou armamentos de fortaleza para cada uma. E a fama do seu nome chegou até ao extremo da Terra."
,"11":"Consolidou a paz no país, e trouxe grande felicidade para Israel."
,"12":"Cada um podia ficar sentado debaixo da sua parreira e da sua figueira, sem que ninguém o incomodasse."
,"13":"Eliminou do país aqueles que lhe faziam guerra, e, nesses dias, os reis foram vencidos."
,"14":"Protegeu os pobres do seu povo, foi observante da Lei, e eliminou os apóstatas e perversos."
,"15":"Cobriu de esplendor o Templo e multiplicou os seus utensílios sagrados."
,"16":"A notícia da morte de Jónatas chegou até Roma e Esparta, e todos a lamentaram muito."
,"17":"Souberam, porém, que em lugar dele seu irmão Simão se tornara sumo sacerdote, e que tinha o domínio de todo o país e das cidades que dele faziam parte."
,"18":"Escreveram-lhe em placas de bronze, renovando com ele a amizade e a aliança que outrora tinham contraído com seus irmãos Judas e Jónatas."
,"19":"O texto foi lido em Jerusalém na presença da comunidade."
,"20":"Cópia da carta que os espartanos mandaram: «Dos magistrados e da cidade toda dos espartanos, ao grande sacerdote Simão, aos anciãos, aos sacerdotes e ao povo judeu em geral. Saudações aos irmãos!"
,"21":"Os embaixadores que enviastes ao nosso povo falaram a respeito do vosso prestígio e do respeito que impondes. Ficámos muito contentes com a vinda deles."
,"22":"O que foi dito por eles, nós transcrevemo-lo desta forma nos registos do povo: 'Numénio, filho de Antíoco, e Antípatro, filho de Jasão, embaixadores dos judeus, vieram até nós para renovar connosco o acordo de amizade."
,"23":"O povo acha conveniente receber esses homens com todas as homenagens e transcrever nos livros de Actas Públicas tudo o que eles disseram, a fim de que o povo de Esparta possa conservar a memória desses factos'». E transcreveram uma cópia de tudo para o sumo sacerdote Simão."
,"24":"Depois Simão mandou Numénio a Roma, levando um enorme escudo de seiscentos quilos de ouro, a fim de confirmar o acordo de amizade com eles."
,"25":"Ao ouvir contar tudo isto, o povo perguntava-se: «Como é que vamos pagar a Simão e aos seus filhos?"
,"26":"Ele e seus irmãos, a família toda de seu pai, tornaram-se fortes, combateram os inimigos, assegurando a liberdade a Israel!» Então gravaram uma inscrição em bronze e colocaram-na sobre colunas, no monte Sião."
,"27":"O texto da inscrição é este: «No dia dezoito de Elul do ano cento e setenta e dois, que corresponde ao terceiro ano de Simão como sumo sacerdote em Asaramel,"
,"28":"por ocasião de uma grande assembleia que reuniu sacerdotes, povo, autoridades e anciãos do país, observou-se o seguinte:"
,"29":"Como estavam a acontecer muitas guerras no país, o sacerdote Simão, da família de Joarib, filho de Matatias, e seus irmãos arriscaram a vida e enfrentaram os adversários do seu povo para salvar o Templo e a Lei, e cobriram de glórias o seu povo."
,"30":"Jónatas, depois de unificar o país e exercer a função de sumo sacerdote, foi juntar-se aos seus antepassados."
,"31":"Então os inimigos dos judeus quiseram invadir o país e apoderar-se do Templo."
,"32":"Simão, porém, levantou-se contra eles e lutou em favor da sua nação. Gastou muito dinheiro seu para armar os homens do seu exército e pagar-lhes o soldo."
,"33":"Fortificou as cidades da Judeia, inclusive Betsur, que fica no limite do país, antigo quartel inimigo, e aí deixou uma guarnição judaica."
,"34":"Fortificou também Jope, no litoral, e Gazara, na região de Azoto, onde antes ficavam os adversários. Aí estabeleceu colónias judaicas, providenciando o necessário para que funcionasse bem."
,"35":"Vendo a fidelidade de Simão e o seu interesse por engrandecer a pátria, o povo nomeou-o chefe e sumo sacerdote, em vista de tudo o que fizera, por causa da justiça e honestidade com que fortalecia a nação e procurava por todas as formas exaltar cada vez mais o seu povo."
,"36":"No seu tempo, expulsou os estrangeiros da região ocupada e os que estavam em Jerusalém, na Cidade de David. Eles tinham construído aí a fortaleza, de onde saíam para profanar as vizinhanças do Templo, causando grave atentado à sua pureza."
,"37":"Simão colocou na fortaleza soldados judeus para maior segurança do país e da cidade, e elevou as muralhas de Jerusalém."
,"38":"Por isso, o rei Demétrio confirmou-o como sumo sacerdote,"
,"39":"incluiu-o entre os seus amigos e cumulou-os de grande glória,"
,"40":"pois soube que os judeus estavam a ser chamados amigos, aliados e irmãos pelos romanos; soube também que os próprios romanos tinham recebido os embaixadores de Simão com todas as honras."
,"41":"Os sacerdotes e os judeus resolveram, portanto, considerar Simão como governante e como sumo sacerdote para sempre, até que surgisse um profeta legítimo."
,"42":"Além disso, resolveram que ele seria o comandante das suas tropas, para cuidar do Templo, nomear um administrador para obras públicas, outro para dirigir o país, e outro para se responsabilizar pelas armas e comandar as fortalezas."
,"43":"Ele teria toda a responsabilidade sobre o Templo, e todos lhe deveriam obedecer. Os documentos oficiais seriam todos escritos em seu nome, e ele vestiria o manto de púrpura com ornamentos de ouro."
,"44":"Ninguém do povo ou dos sacerdotes poderá desobedecer a nenhum desses pontos, ou contradizer as ordens que ele der, ou, sem sua autorização, convocar reuniões no país, vestir-se de púrpura ou usar a fivela de ouro."
,"45":"Será considerado passível de pena quem acrescentar ou revogar qualquer uma destas decisões»."
,"46":"Foi do agrado de todo o povo conferir a Simão o direito de agir de acordo com essas resoluções."
,"47":"Simão aceitou e assumiu com prazer as funções de sumo sacerdote, de comandante das tropas e chefe da nação dos judeus, inclusive dos sacerdotes, para ficar à frente de todos."
,"48":"Mandaram gravar esse documento em placas de bronze e colocá-lo no recinto do Templo, em lugar visível."
,"49":"Uma cópia do texto deveria ficar no tesouro do Templo, à disposição de Simão e seus filhos."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Antíoco, filho do rei Demétrio, enviou, das ilhas do mar, uma carta a Simão, sumo sacerdote e chefe da nação dos judeus, e a toda a nação."
,"2":"Era este o teor da carta: «Do rei Antíoco a Simão, sumo sacerdote e chefe da nação, e a todo o povo judeu. Saudações!"
,"3":"Certos indivíduos, verdadeiras pragas, tomaram o reino dos meus pais. Agora eu desejo recuperar o reino para o restabelecer na situação em que antes se encontrava. Recrutei grande exército e equipei navios de guerra,"
,"4":"pois quero percorrer o país e acertar as contas com aqueles que arruinaram a nossa terra e devastaram tantas cidades do meu reino."
,"5":"Agora, pois, confirmo-te todas as isenções de impostos concedidas pelos reis meus antecessores, como também todas as outras isenções que te foram concedidas."
,"6":"Permito-te cunhar moeda própria como dinheiro oficial do teu país."
,"7":"Jerusalém e o Templo ficam livres de qualquer imposto. Todas as armas que fabricaste e as fortalezas que construíste, e estão sob o teu domínio, ficam em teu poder."
,"8":"Tudo o que deves ao imposto real, e o que seria devido daqui em diante, fica cancelado para todo o sempre."
,"9":"Após reconquistar o nosso reino, homenagear-te-emos a ti, ao teu povo e ao Templo com honrarias tais, que o vosso prestígio alcançará toda a Terra»."
,"10":"No ano cento e setenta e quatro, Antíoco partiu para a terra de seus pais. Os contingentes militares passaram para o lado dele, de modo que poucos ficaram com Trifão."
,"11":"Antíoco perseguiu-o. Trifão, porém, fugiu dele e foi para Dora, cidade à beira-mar,"
,"12":"pois via que a desgraça lhe caía em cima, porque as suas tropas o haviam abandonado."
,"13":"Antíoco acampou perto de Dora, tendo sob o seu comando cento e vinte mil soldados de infantaria e oito mil cavaleiros."
,"14":"Cercou a cidade, enquanto os navios a atacavam do lado do mar. Rodeou a cidade por terra e mar, e não deixou entrar nem sair ninguém."
,"15":"Enquanto isso, Numénio e seus companheiros chegaram de Roma, trazendo cartas para os reis dos vários países. Nelas se dizia:"
,"16":"«De Lúcio, cônsul dos romanos, ao rei Ptolomeu. Saudações!"
,"17":"Vieram até nós, como amigos e aliados, alguns embaixadores dos judeus, enviados pelo sumo sacerdote Simão e pelo povo judeu, a fim de renovar a nossa antiga amizade e aliança."
,"18":"Trouxeram um escudo de ouro que pesa cerca de seiscentos quilos."
,"19":"Quisemos escrever aos reis dos vários países, a fim de que não lhes causem dano algum, nem façam guerra contra eles, contra as suas cidades e o seu território, nem se aliem com os inimigos deles."
,"20":"Achámos conveniente aceitar o escudo que eles nos ofereceram."
,"21":"Portanto, se alguns indivíduos perniciosos fugirem do país deles para o vosso, devereis entregá-los ao sumo sacerdote Simão, para que ele os julgue de acordo com a sua própria Lei»."
,"22":"Escreveram a mesma coisa ao rei Demétrio, a Átalo, Ariarates, Arsaces"
,"23":"e a todos os países, a Sampsames, Esparta, Delos, Mindos, Siciónia, Cária, Samos, Panfília, Lícia, Halicarnasso, Rodes, Fasélis, Cós, Side, Arados, Gortina, Cnido, Chipre e Cirene."
,"24":"E mandaram uma cópia dessas cartas ao sumo sacerdote Simão."
,"25":"O rei Antíoco mantinha o ataque contra Dora, na parte nova da cidade, atacando-a com os seus batalhões e construindo máquinas de assalto. Cercou Trifão, de maneira que ele não podia sair nem entrar."
,"26":"Simão mandou dois mil homens escolhidos para lutarem sob o comando de Antíoco, além de prata, ouro e muitos equipamentos."
,"27":"Antíoco, porém, não aceitou. Ao contrário, deixou de lado tudo o que antes tinha combinado com Simão, rompendo com ele."
,"28":"Mandou-lhe Atenóbio, um dos seus amigos, para conferenciar com ele e dizer: «Vós tomastes Jope, Gazara e também a fortaleza de Jerusalém, que são cidades do meu reino."
,"29":"Arruinastes as suas vizinhanças, provocastes enorme desgraça por todo o país e tomastes muitas cidades do meu reino."
,"30":"Agora, entregai as cidades que tomastes e também os impostos sobre os lugares que dominastes fora do território da Judeia."
,"31":"Caso contrário, dar-me-eis em troca dezassete toneladas de prata, e mais dezassete toneladas como indemnização por danos e prejuízos, e pelos impostos das cidades. Senão, faremos guerra contra vós»."
,"32":"Atenóbio, o amigo do rei, chegou a Jerusalém e aí pôde ver o luxo em que Simão vivia, os talheres de ouro e prata, o rico mobiliário, e ficou admirado. Transmitiu a Simão o recado do rei."
,"33":"Simão respondeu: «Não tomámos terra de ninguém, nem nos apoderámos do que não era nosso! Somente recuperámos a herança dos nossos antepassados. Dela, por um certo tempo, os nossos inimigos se haviam apoderado injustamente."
,"34":"Apenas aproveitámos a oportunidade que tivemos de recuperar a herança dos nossos antepassados."
,"35":"Quanto a Jope e Gazara, que tu reclamas, elas eram fonte de mal-estar para o nosso povo e o nosso país. Contudo, pagaremos por elas três toneladas e meia de prata»."
,"36":"Atenóbio nada respondeu. Furioso, voltou para junto do rei e contou-lhe tudo, falando do luxo de Simão e de tudo o que tinha visto. E o rei ficou enfurecido."
,"37":"Trifão conseguiu embarcar num navio e fugir para Ortosia."
,"38":"O rei nomeou Cendebeu como comandante-chefe do litoral e confiou-lhe as tropas de infantaria e cavalaria."
,"39":"Mandou-o acampar nas proximidades da Judeia, reconstruir a cidade de Quedron, fortalecer as suas portas e iniciar a guerra contra o povo, enquanto o rei perseguia Trifão."
,"40":"Cendebeu acampou perto de Jâmnia e começou a provocar o povo, invadindo a Judeia, fazendo prisioneiros e matando."
,"41":"Reconstruiu Quedron e nela instalou a cavalaria e infantaria, para que fizessem incursões e patrulhas pelas estradas da Judeia, conforme o rei lhe tinha ordenado."
}`)
	CurrentBook.AddChapter(16, `{
"1":"João deixou Gazara e foi contar a seu pai Simão o que Cendebeu estava a fazer."
,"2":"Simão chamou os seus dois filhos mais velhos, Judas e João, e disse-lhes: «Eu, os meus irmãos e toda a família do meu pai, combatemos os inimigos de Israel desde a nossa juventude até hoje, e com o nosso esforço conseguimos libertar Israel muitas vezes."
,"3":"Agora, porém, estou a ficar velho, enquanto que vós, pela misericórdia de Deus, estais em idade madura. Ocupai o meu lugar e o do meu irmão, e saí para combater em favor da nossa nação. Que Deus vos ajude!»"
,"4":"João escolheu no país vinte mil homens de infantaria e cavalaria, e foi com eles enfrentar Cendebeu. Pernoitaram em Modin,"
,"5":"levantaram-se de madrugada, saíram para a planície e viram o enorme exército de infantaria e cavalaria pronto para os enfrentar. Entre os dois exércitos que estavam para se enfrentar havia um rio."
,"6":"João acampou com o seu exército bem em frente do inimigo. Percebendo que os seus soldados estavam com medo de atravessar o rio, ele atravessou primeiro. Vendo isso, os soldados também atravessaram."
,"7":"Então ele organizou o exército, colocando a cavalaria no meio da infantaria, porque a cavalaria do inimigo era numerosa de mais."
,"8":"Tocaram, então, as trombetas. Cendebeu e o seu exército foram derrotados, caíram muitos feridos dentre eles, e os que conseguiram escapar fugiram para a fortaleza."
,"9":"Nessa ocasião Judas, irmão de João, ficou ferido. João perseguiu o exército de Cendebeu até chegar a Quedron, que fora reconstruída por Cendebeu."
,"10":"Alguns fugiram para as terras que existem ao redor de Azoto. João incendiou a cidade, causando duas mil baixas ao inimigo. Depois João regressou em paz para a Judeia."
,"11":"Ptolomeu, filho de Abubo, tinha sido nomeado comandante da planície de Jericó, e possuía muita prata e muito ouro,"
,"12":"pois era genro do sumo sacerdote."
,"13":"Enchendo-se com ideias de grandeza, quis tomar posse do país e começou a tramar a morte de Simão e seus filhos."
,"14":"Simão estava inspeccionando as cidades no interior do país, ocupado com os seus problemas administrativos. Chegou a Jericó acompanhado dos filhos Matatias e Judas, no ano cento e setenta e sete, no décimo primeiro mês, chamado Sabat."
,"15":"O filho de Abubo, que planeava uma traição, recebeu-os na fortaleza chamada Doc, que ele próprio tinha construído. Ofereceu-lhes um grande banquete, colocando aí alguns homens de emboscada."
,"16":"Quando Simão e seus filhos já estavam embriagados, Ptolomeu e seus companheiros levantaram-se, puxaram das suas armas, atacaram Simão na sala do banquete e mataram-no, juntamente com os seus dois filhos e alguns da sua comitiva."
,"17":"Assim, Ptolomeu praticou um grande crime, pagando o bem com o mal."
,"18":"Em seguida, Ptolomeu escreveu ao rei, contando o acontecido e pedindo que lhe mandasse tropas, a fim de o ajudar a tomar o país e as suas cidades."
,"19":"Mandou outros a Gazara para eliminar João. Enviou cartas aos generais, convidando-os a passarem para o seu lado, com a promessa de lhes dar prata, ouro e presentes."
,"20":"Mandou outros, enfim, tomar Jerusalém e a montanha do Templo."
,"21":"No entanto, alguém correu a contar a João em Gazara que o seu pai e seus irmãos tinham sido mortos, e que Ptolomeu tinha mandado matá-lo também a ele."
,"22":"Ao ouvir isso, João ficou muito perturbado, prendeu os homens que foram para o matarem e mandou executá-los, pois ele sabia que estavam atentando contra a sua vida."
,"23":"Os outros actos de João, as suas guerras e as proezas que praticou, a reforma das mura-lhas que executou, tudo o que ele fez,"
,"24":"está escrito no livro das actas do seu sumo sacerdócio, a partir do dia em que se tornou sumo sacerdote em lugar de seu pai."
}`)

}
func PT_BS_LoadVH1PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Adão, Set, Enós,"
,"2":"Cainã, Malaleel, Jared,"
,"3":"Henoc, Matusalém, Lamec,"
,"4":"Noé, Sem, Cam e Jafet."
,"5":"Descendentes de Jafet: Gomer, Magog, Madai, Javã, Tubal, Mosoc e Tiras."
,"6":"Descendentes de Gomer: Asquenez, Rifat e Togorma."
,"7":"Descendentes de Javã: Elisa, Társis, os Cetim e os Dodanim."
,"8":"Descendentes de Cam: Cuch, Mesraim, Fut e Canaã."
,"9":"Descendentes de Cuch: Seba, Hévila, Sabata, Regma, Sabataca. Descendentes de Regma: Sabá e Dadã."
,"10":"Cuch também foi pai de Nemrod, o primeiro valente da terra."
,"11":"Mesraim foi pai destes povos: Lud, Anam, Laab, Naftu,"
,"12":"Patros, Caslu e Cáftor, dos quais se originaram os filisteus."
,"13":"O primeiro filho de Canaã foi Sídon; depois, ele teve Het"
,"14":"e, em seguida, os jebuseus, amorreus, gergeseus,"
,"15":"heveus, araceus, sineus,"
,"16":"arádios, samareus e emateus."
,"17":"Descendentes de Sem: Elam, Assur, Arfaxad, Lud e Aram. Descendentes de Aram: Hus, Hul, Geter e Mes."
,"18":"Arfaxad foi pai de Salé, o qual foi pai de Héber."
,"19":"Héber teve dois filhos. O primeiro recebeu o nome de Faleg, porque foi na sua época que a terra foi dividida; o outro chamava-se Jectã."
,"20":"Jectã foi pai de Elmodad, Salef, Asarmot, Jaré,"
,"21":"Aduram, Uzal, Decla,"
,"22":"Ebal, Abimael, Sabá,"
,"23":"Ofir, Hévila e Jobab. Todos estes são filhos de Jectã."
,"24":"Sem, Arfaxad, Salé,"
,"25":"Héber, Faleg, Reú,"
,"26":"Sarug, Nacor, Taré,"
,"27":"Abrão, ou melhor, Abraão."
,"28":"Filhos de Abraão: Isaac e Ismael."
,"29":"Os descendentes destes dois foram: Nabaiot, o primeiro filho de Ismael; depois, vieram Cedar, Adbeel, Mabsam,"
,"30":"Masma, Duma, Massa, Hadad, Tema,"
,"31":"Jetur, Nafis e Cedma. São os descendentes de Ismael."
,"32":"Filhos que nasceram de Cetura, concubina de Abraão: ela deu-lhe Zamrã, Jecsã, Madã, Madiã, Jesboc e Sué. Descendentes de Jecsã: Sabá e Dadã."
,"33":"Descendentes de Madiã: Efa, Ofer, Henoc, Abida e Eldaá. São estes os filhos de Cetura."
,"34":"Depois Abraão teve Isaac. Filhos de Isaac: Esaú e Israel."
,"35":"Descendentes de Esaú: Elifaz, Reuel, Jeús, Jalam e Coré."
,"36":"Descendentes de Elifaz: Temã, Omar, Sefo, Gatam, Cenez, Tamna e Amalec."
,"37":"Descendentes de Reuel: Naat, Zara, Sama e Meza."
,"38":"Descendentes de Seir: Lotã, Sobal, Sebeon, Ana, Dison, Eser e Disã."
,"39":"Descendentes de Lotã: Hori e Emam. Tamna era irmã de Lotã."
,"40":"Descendentes de Sobal: Aliã, Manaat, Ebal, Sefo e Onam. Descendentes de Sebeon: Aía e Ana."
,"41":"Descendente de Ana: Dison. Descendentes de Dison: Hamrã, Esebã, Jetrã e Carã."
,"42":"Descendentes de Eser: Balaã, Zavã e Jacã. Descendentes de Disã: Hus e Arã."
,"43":"Os reis que governaram o país de Edom, antes que passasse para o domínio do rei israelita, foram os seguintes: Bela, filho de Beor. A sua capital era Danaba."
,"44":"Com a morte de Bela, reinou Jobab, filho de Zara, da cidade de Bosra."
,"45":"Ao morrer, Jobab foi substituído por Husam, da região dos temanitas."
,"46":"Quando Husam morreu, reinou Adad, filho de Badad, vencedor dos madianitas nos campos de Moab. A sua capital chamava-se Avit."
,"47":"Com a morte de Adad, Semla de Masreca tornou-se rei no lugar dele."
,"48":"O sucessor de Semla foi Saul, de Reobot Naar."
,"49":"Com a morte de Saul, o governo passou para as mãos de Baalanã, filho de Acobor."
,"50":"Quando Baalanã morreu, o trono passou para Adad, da cidade de Fau, casado com Meetabel, filha de Matred e neta de Mezaab."
,"51":"Quando Adad morreu, apareceram chefes em Edom: Tamna, Alva, Jetet,"
,"52":"Oolibama, Ela, Finon,"
,"53":"Cenez, Temã, Mabsar,"
,"54":"Magdiel e Iram. Estes foram os chefes de Edom."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Filhos de Israel: Rúben, Simeão, Levi, Judá, Issacar, Zabulon,"
,"2":"Dã, José, Benjamim, Neftali, Gad e Aser."
,"3":"Filhos de Judá: Her, Onam e Sela; os três nascidos de Bat-Sua, a cananeia. Her, o filho mais velho de Judá, fez o que Javé reprova, e Javé tirou-lhe a vida."
,"4":"Tamar, nora de Judá, deu-lhe dois filhos: Farés e Zara. Assim, foram cinco os filhos de Judá."
,"5":"Filhos de Farés: Hesron e Hamul."
,"6":"Filhos de Zara: Zambri, Etã, Emã, Calcol e Darda; cinco ao todo."
,"7":"Filho de Carmi: Acar, que chamou a desgraça sobre Israel, porque violou a lei do anátema."
,"8":"Filho de Etã: Azarias."
,"9":"Filhos de Hesron: Jerameel, Ram e Calubi."
,"10":"Ram foi pai de Aminadab, pai de Naasson, que foi um dos chefes da família de Judá."
,"11":"Naasson foi pai de Salma, pai de Booz."
,"12":"Booz foi pai de Obed, pai de Jessé."
,"13":"Jessé teve os seguintes filhos: Eliab, o mais velho; depois, Abinadab; em terceiro lugar, Samaá;"
,"14":"Natanael foi o quarto, Radai o quinto,"
,"15":"Asom o sexto, e David o sétimo."
,"16":"Eles tinham duas irmãs: Sárvia e Abigail. Filhos de Sárvia: Abisaí, Joab e Asael; três ao todo."
,"17":"Filho de Abigail: Amasa; o pai dele foi Jeter, o ismaelita."
,"18":"Caleb, filho de Hesron, com sua mulher Azuba, foi pai de Jeriot. Depois, ela ainda lhe deu Jaser, Sobab e Ardon."
,"19":"Depois que Azuba morreu, Caleb casou-se com Éfrata, que lhe deu o filho Hur."
,"20":"Hur foi pai de Uri, pai de Beseleel."
,"21":"Hesron casou-se com a filha de Maquir, pai de Galaad. Ele tinha sessenta anos quando se casou, e sua mulher deu-lhe um filho de nome Segub."
,"22":"Segub foi pai de Jair, que tinha vinte e três cidades na região de Galaad."
,"23":"Depois, Aram e Gessur tomaram as aldeias de Jair, isto é, Canat e suas vilas, sessenta povoados ao todo. Tudo isso pertencia aos filhos de Maquir, pai de Galaad."
,"24":"Depois da morte de Hesron, Caleb casou-se com Éfrata, viúva de seu pai, e ela deu-lhe o filho Asur, pai de Técua."
,"25":"Jerameel, primeiro filho de Hesron, teve os seguintes filhos: Ram, o mais velho; depois, Buna, Oren Asom e Aías."
,"26":"Jerameel teve outra mulher chamada Atara, que foi mãe de Onam."
,"27":"Filhos de Ram, o filho mais velho de Jerameel: Moos, Jamin e Acar."
,"28":"Filhos de Onam: Semei e Jada. Filhos de Semei: Nadab e Abisur."
,"29":"A mulher de Abisur chamava-se Abiail. Ela deu-lhe os filhos Aobã e Molid."
,"30":"Nadab tinha dois filhos: Saled e Efraim. Saled morreu sem filhos."
,"31":"Efraim foi pai de Jesi, pai de Sesã, pai de Oolai."
,"32":"Jada, irmão de Semei, foi pai de Jeter e Jónatas. Jeter não deixou filhos,"
,"33":"ao passo que Jónatas deixou Falet e Ziza. Descendência de Jerameel: "
,"34":"Sesã não teve filhos; só filhas. Ele tinha um escravo egípcio de nome Jaraá,"
,"35":"com quem casou uma das suas filhas, que lhe deu um filho de nome Etei."
,"36":"Etei foi pai de Natã, pai de Zabad,"
,"37":"pai de Oflal, pai de Obed,"
,"38":"pai de Jeú, pai de Azarias,"
,"39":"pai de Helés, pai de Elasa,"
,"40":"pai de Sisamoi, pai de Selum,"
,"41":"pai de Icamias, pai de Elisama."
,"42":"Filhos de Caleb, irmão de Jerameel: Mesa, o mais velho. Este foi pai de Zif e de Maresa, que foi pai de Hebron."
,"43":"Filhos de Hebron: Coré, Tafua, Recém e Sama."
,"44":"Sama foi pai de Raam, pai de Jercaam. Recém foi pai de Samai."
,"45":"O filho de Samai foi Maon, pai de Betsur."
,"46":"Efa, concubina de Caleb, deu-lhe estes filhos: Harã, Mosa e Gezez. Harã foi pai de Gezez."
,"47":"Filhos de Jaadai: Regom, Joatão, Gesã, Falet, Efa e Saaf."
,"48":"Maaca, outra concubina de Caleb, teve Saber e Tarana,"
,"49":"além de Saaf, pai de Madmana, e Sué, pai de Macbena e Gabaá. A filha de Caleb chamava-se Acsa."
,"50":"Estes foram os descendentes de Caleb. Filhos de Hur, o filho mais velho de Éfrata: Sobal, pai de Cariat-Iarim;"
,"51":"Salma, pai de Belém; Harif, pai de Bet-Gader."
,"52":"Filhos de Sobal, pai de Cariat-Iarim: Haroe, a metade dos manaatitas,"
,"53":"os clãs de Cariat-Iarim, os jetritas, os futitas, os sematitas e os maseritas. Deles descendem também os povos de Saraá e Estaol."
,"54":"Filhos de Salma: Belém, os netofatitas, Atarot-Bet-Joab, a outra metade dos manaatitas, os saraítas,"
,"55":"os clãs sofritas, moradores de Jabes, os tiriateus, os simeateus e os sucateus. Esses são os quenitas, descendentes de Emat, pai da família de Recab."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Filhos de David, nascidos em Hebron: o mais velho foi Amnon, e sua mãe era Aquinoam de Jezrael; o segundo foi Daniel, e sua mãe era Abigail de Carmel;"
,"2":"o terceiro foi Absalão, filho de Maaca, filha de Tolmai, rei de Gessur; o quarto, Adonias, era filho de Hagit;"
,"3":"o quinto, Safatias, filho de Abital; o sexto, Jetraam, filho de sua esposa Egla."
,"4":"Portanto, David teve seis filhos em Hebron, onde reinou sete anos e meio. Depois, David reinou trinta e três anos em Jerusalém. "
,"5":"Filhos que lhe nasceram em Jerusalém: Samua, Sobab, Natã e Salomão. A mãe destes era Betsabeia, filha de Amiel."
,"6":"Além deles: Jebaar, Elisama, Elifalet,"
,"7":"Noge, Nafeg, Jáfia,"
,"8":"Elisama, Eliada e Elifalet; nove ao todo."
,"9":"Eram todos filhos de David, sem falar dos filhos que teve com as concubinas, e estes tinham uma irmã de nome Tamar."
,"10":"Filho de Salomão: Roboão, pai de Abias, pai de Asa, pai de Josafá,"
,"11":"pai de Jorão, pai de Ocozias, pai de Joás,"
,"12":"pai de Amasias, pai de Azarias, pai de Joatão,"
,"13":"pai de Acaz, pai de Ezequias, pai de Manassés,"
,"14":"pai de Amon, pai de Josias."
,"15":"Filhos de Josias: Joanã, o mais velho; Joaquim, o segundo; Sedecias, o terceiro; Selum, o quarto."
,"16":"Filhos de Joaquim: Jeconias e Sedecias."
,"17":"Filhos de Jeconias, que foi levado para o exílio: primeiro, Salatiel;"
,"18":"depois, Melquiram, Fadaías, Senasser, Jecemias, Hosama e Nadabias."
,"19":"Filhos de Fadaías: Zorobabel e Semei. Filhos de Zorobabel: Mosolam e Hananias. Salomit era irmã deles."
,"20":"Filhos de Mosolam: Hasaba, Ool, Baraquias, Hasadias e Josab-Hesed; cinco ao todo."
,"21":"Filhos de Hananias: Faltias, Jeseías, Rafaías, Arnã, Abdias e Sequenias."
,"22":"Filhos de Sequenias: Semeías, Hatus, Jegaal, Barias, Naarias e Safat. Seis ao todo."
,"23":"Naarias teve três filhos: Elioenai, Ezequias e Ezricam."
,"24":"Elioenai teve sete filhos: Oduías, Eliasib, Feleã, Dalaías e Anani."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Filhos de Judá: Farés, Hesron, Carmi, Hur e Sobal."
,"2":"Reaías, filho de Sobal, foi pai de Jaat, pai de Aumai e Laad. São estes os clãs saraítas."
,"3":"Filhos de Etam: Jezrael, Jesema, Jedebos, e uma filha de nome Asalelfuni."
,"4":"Fanuel foi pai de Gedor, enquanto que Ezer foi pai de Hosa. Estes foram os filhos de Hur, filho mais velho de Éfrata, pai de Belém."
,"5":"Asur, pai de Técua, teve duas esposas: Halaá e Naara."
,"6":"Naara teve os seguintes filhos: Oozam, Héfer, os tamanitas e aastaritas. Todos estes são descendentes de Naara."
,"7":"Filhos de Halaá: Seret, Saar e Etnã."
,"8":"Cós foi pai de Anob, de Soboba e dos clãs de Aareel, filho de Arum."
,"9":"Jabes foi superior a seus irmãos. Sua mãe deu-lhe o nome de Jabes, explicando: «Com dores eu o gerei!»"
,"10":"Jabes invocou o Deus de Israel: «Peço que me abençoes, aumentando as minhas terras, protegendo-me com a tua mão, afastando de mim o mal e pondo fim à minha dor». E Deus concedeu-lhe o que ele pediu."
,"11":"Calub, irmão de Suaá, foi pai de Mair, pai de Eston."
,"12":"Eston foi pai de Bet-Rafa, Fesse, Teina, pai de Irnaás. Estes são os homens de Recab."
,"13":"Filhos de Cenez: Otoniel e Saraías. Filhos de Otoniel: Hatat e Maonati."
,"14":"Maonati foi pai de Ofra. Saraías foi pai de Joab, fundador do vale dos Artesãos, pois eram de facto artesãos."
,"15":"Filhos de Caleb, filho de Jefoné: Hir, Ela e Naam. Filho de Ela: Cenez."
,"16":"Filhos de Jaleleel: Zif, Zifa, Tirias, Asrael."
,"17":"Filhos de Ezra: Jeter, Mered, Éfer, Jalon. Betias gerou Maria, Samai e Jesba, pai de Estemo."
,"18":"A mulher judaíta de Mered deu-lhe Jared, pai de Gedor; Héber, pai de Soco; Icutiel, pai de Zanoe. São estes os filhos de Betias, filha de Faraó, casada com Mered."
,"19":"Filhos da mulher de Odias, irmã de Naam: o pai de Ceila, o garmita, e de Estemo, o maacatita."
,"20":"Filhos de Simão: Amnon, Rina, Ben-Hanã e Tilon. Filhos de Jesi: Zoet e Ben-Zoet."
,"21":"Sela, filho de Judá, teve os seguintes filhos: Her, pai de Leca; Laada, pai de Maresa; os clãs que trabalham com linho em Bet-Asbea;"
,"22":"Joaquim e os homens de Cozeba; Joás e Saraf, que foram casar-se em Moab antes de voltarem para Belém. São casos antigos."
,"23":"Eles eram oleiros e moraram em Nataim e Gadera, junto do rei, para quem trabalhavam."
,"24":"Filhos de Simeão: Namuel, Jamin, Jarib, Zara e Saul."
,"25":"Além destes: Selum, Mabsam e Masma."
,"26":"Filhos de Masma: Hamuel, Zacur e Semei."
,"27":"Semei teve dezasseis filhos e seis filhas. Seus irmãos, porém, não tiveram muitos filhos, de modo que as suas famílias não se multiplicaram como a família de Judá."
,"28":"Moravam em Bersabeia, Molada e Hasar-Sual,"
,"29":"Bala, Asem e Tolad,"
,"30":"Batuel, Horma e Siceleg,"
,"31":"Bet-Marcabot, Hasar-Susim, Bet-Berai e Saarim. Estas foram as suas cidades até à época do reinado de David."
,"32":"As suas aldeias foram: Etam, Aen, Remon, Toquen e Asã, isto é, cinco cidades,"
,"33":"com todas as aldeias vizinhas dessas cidades até Baalat. Aí moraram e aí foram registados:"
,"34":"Masobab, Jemlec, Josa, filho de Amasias;"
,"35":"Joel, Jeú, filho de Josabias, filho de Saraías, filho de Asiel;"
,"36":"Elioenai, Jacoba, Isuaías, Asaías, Adiel, Isimiel, Banaías,"
,"37":"Ziza, Ben-Sefei, Ben-Alon, Ben-Jedaías, Ben-Semri, Ben-Samaías."
,"38":"Estes, aqui lembrados nome por nome, eram chefes dos seus clãs, e as suas famílias foram muito numerosas."
,"39":"A vida deles era nómade: andavam de um lado para o outro no vale de Gerara, procurando pastagem para o rebanho."
,"40":"Aí encontraram muita pastagem e de boa qualidade, pois era uma região vasta, tranquila e pacífica. Antes, essa região era habitada pelos descendentes de Cam."
,"41":"No tempo de Ezequias, rei de Judá, os simeonitas acima registados chegaram a esse lugar e apoderaram-se do acampamento dos descendentes de Cam e também dos meunitas que aí se encontravam, eliminando-os totalmente, até ao dia de hoje. Depois, passaram a morar no lugar deles, porque havia ali pastagem para os seus rebanhos."
,"42":"Alguns descendentes de Simeão foram para a montanha de Seir. Eram quinhentos homens comandados por Faltias, Naarias, Rafaías e Oziel, filhos de Jesi."
,"43":"Acabaram com o resto dos amalecitas sobreviventes e passaram a morar nesse lugar, onde estão até hoje."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Filhos de Rúben, filho mais velho de Israel. Ele era o filho mais velho. No entanto, por ter desrespeitado a cama de seu pai, os seus direitos passaram para José, outro filho de Israel. Rúben deixou de ser considerado como primogénito."
,"2":"Judá passou à frente dos irmãos e conseguiu ter um filho chefe, mas o direito de filho mais velho pertencia de facto a José."
,"3":"Filhos de Rúben, filho mais velho de Israel: Henoc, Falu, Hesron e Carmi."
,"4":"Filhos de Joel: Samaías, Gog, Semei,"
,"5":"Micas, Reaías, Baal"
,"6":"e Beera, que Teglat-Falasar, rei da Assíria, levou para o exílio. Era chefe dos rubenitas."
,"7":"Por clãs, e agrupados conforme o parentesco, seus irmãos eram: primeiro, Jeiel; depois, Zacarias;"
,"8":"por fim, Bela, filho de Azaz, neto de Sama e bisneto de Joel. O clã de Rúben ficou a morar em Aroer, chegando até Nebo e Baal-Meon. "
,"9":"Para o lado oriental, ocupou o território que vai até à beira do deserto, desde o rio Eufrates, pois tinha muito gado na região de Galaad."
,"10":"Na época de Saul, eles tiveram que fazer guerra contra os agarenos, em cujas mãos acabaram por cair. Os agarenos passaram, então, a ocupar os acampamentos que eram deles em toda a parte oriental de Galaad."
,"11":"Ao lado da tribo de Rúben, os filhos de Gad ficaram a morar na região de Basã até Selca."
,"12":"Estavam em Basã: primeiro, Joel; depois, Safam, Janaí e Safat."
,"13":"Irmãos deles, família por família: Miguel, Mosolam, Sebe, Jorai, Jacã, Zie e Héber; sete ao todo."
,"14":"Filhos de Abiail: Ben-Uri, Ben-Jaroe, Ben-Galaad, Ben-Miguel, Ben-Jesesi, Ben-Jedo e Ben-Buz."
,"15":"O chefe da sua família era Ai, filho de Abdiel e neto de Guni."
,"16":"Eles ficaram a morar em Galaad, em Basã e arredores, nas pastagens do Saron, e nos seus limites."
,"17":"Todos eles foram registados na época em que Joatão era rei de Judá e Jeroboão era rei de Israel."
,"18":"As tribos de Rúben, de Gad e a meia-tribo de Manassés, que contavam com quarenta e quatro mil, setecentos e sessenta guerreiros, entre soldados armados de escudo e espada, atiradores de flechas treinados para a guerra e prontos para a luta,"
,"19":"entraram em combate contra os agarenos em Jetur, Nafis e Nodab."
,"20":"No meio do combate, clamaram ao seu Deus e, por terem confiado n'Ele, Deus ouviu a sua súplica e ajudou-os, submetendo ao seu poder os agarenos e aliados."
,"21":"Conseguiram, assim, apoderar-se das riquezas dos agarenos: cinquenta mil camelos, duzentas e cinquenta mil ovelhas e dois mil jumentos. Também fizeram cem mil prisioneiros,"
,"22":"e houve outros tantos mortos, porque essa guerra foi conduzida por Deus. Até ao exílio, eles ficaram a morar no lugar que tinha sido dos agarenos."
,"23":"Os filhos da meia tribo de Manassés ficaram a morar no território que fica entre Basã e Baal-Hermon, o Sanir e o monte Hermon. Eram numerosos."
,"24":"Eram estes os seus chefes de família: Éfer, Jesi, Eliel, Ezriel, Jeremias, Odoías e Jediel. Eram homens valentes e famosos, chefes das suas famílias."
,"25":"Eles, porém, foram infiéis ao Deus dos seus antepassados, pois prostituíram-se com os deuses dos povos nativos que Deus tinha destruído diante deles."
,"26":"Então o Deus de Israel incitou contra eles Pul, que é Teglat-Falasar, rei da Assíria. Este exilou Rúben, Gad e a meia tribo de Manassés, levando-os para Hala, Habor, Ara e para o rio Gozã, onde estão até hoje."
,"27":"Filhos de Levi: Gérson, Caat e Merari."
,"28":"Filhos de Caat: Amram, Isaar, Hebron e Oziel."
,"29":"Aarão, Moisés e Maria eram filhos de Amram. Filhos de Aarão: Nadab, Abiud, Eleazar e Itamar."
,"30":"Eleazar foi pai de Fineias, pai de Abisue,"
,"31":"pai de Boci, pai de Ozi,"
,"32":"pai de Zaraías, pai de Meraiot,"
,"33":"pai de Amarias, pai de Aquitob,"
,"34":"pai de Sadoc, pai de Aquimaás,"
,"35":"pai de Azarias, pai de Joanã,"
,"36":"pai de Azarias. Este foi sacerdote no Templo construído em Jerusalém por Salomão."
,"37":"Azarias foi pai de Amarias, pai de Aquitob,"
,"38":"pai de Sadoc, pai de Selum,"
,"39":"pai de Helcias, pai de Azarias,"
,"40":"pai de Saraías, pai de Josedec."
,"41":"Josedec foi para o exílio quando Javé, por meio de Nabucodonosor, exilou Judá e Jerusalém."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Filhos de Levi: Gersam, Caat e Merari."
,"2":"Filhos de Gersam: Lobni e Semei."
,"3":"Filhos de Caat: Amram, Isaar, Hebron e Oziel."
,"4":"Filhos de Merari: Mooli e Musi. São estes os clãs de Levi, por famílias."
,"5":"Filhos de Gersam: Lobni, Jaat, Zama,"
,"6":"Joa, Ado, Zara e Jetrai."
,"7":"Filhos de Caat: Aminadab, Coré, Asir,"
,"8":"Elcana, Abiasaf, Asir,"
,"9":"Taat, Uriel, Ozias e Saul."
,"10":"Filhos de Elcana: Amasai e Aquimot,"
,"11":"pai de Elcana, pai de Sofai, pai de Naat,"
,"12":"pai de Eliab, pai de Jeroam, pai de Elcana."
,"13":"Este teve dois filhos: Samuel, o mais velho, e Abias."
,"14":"Filhos de Merari: Mooli, Lobni, Semei, Oza,"
,"15":"Samaá, Hagias e Asaías."
,"16":"Vêm agora os que David encarregou de dirigir o canto no Templo de Javé, quando a Arca lá foi colocada."
,"17":"O ofício deles era cantar diante da Habitação da Tenda da reunião, até que Salomão construiu em Jerusalém o Templo de Javé. Daí por diante, eles exerciam o seu ofício no Templo, conforme o regulamento."
,"18":"Os encarregados do canto, com os seus descendentes, eram os seguintes: Filhos de Caat: Emã, o cantor, filho de Joel, filho de Samuel,"
,"19":"filho de Elcana, filho de Jeroam, filho de Eliel, filho de Toú,"
,"20":"filho de Suf, filho de Elcana, filho de Maat, filho de Amasai,"
,"21":"filho de Elcana, filho de Joel, filho de Azarias, filho de Sofonias,"
,"22":"filho de Taat, filho de Asir, filho de Abiasaf, filho de Coré,"
,"23":"filho de Isaar, filho de Caat, que era filho de Levi, filho de Israel."
,"24":"À sua direita, ficava o seu companheiro Asaf, que era filho de Baraquias, filho de Samaé,"
,"25":"filho de Miguel, filho de Basaías, filho de Melquias,"
,"26":"filho de Atanai, filho de Zara, filho de Adaías,"
,"27":"filho de Etã, filho de Zama, filho de Semei,"
,"28":"filho de Jet, filho de Gersam, que era filho de Levi."
,"29":"À esquerda, ficavam os outros seus irmãos, os filhos de Merari: Etã, filho de Cusi, filho de Abdi, filho de Maloc,"
,"30":"filho de Hasabias, filho de Amasias, filho de Helcias,"
,"31":"filho de Amasai, filho de Boni, filho de Somer,"
,"32":"filho de Mooli, filho de Musi, filho de Merari, que era filho de Levi."
,"33":"Os levitas, seus irmãos, estavam inteiramente dedicados ao serviço da Habitação do Templo de Deus."
,"34":"Aarão e seus filhos queimavam as ofertas sobre o altar dos holocaustos e também sobre o altar do incenso; faziam todo o serviço das coisas mais santas, especialmente das cerimónias de expiação dos pecados de Israel, tudo conforme determinou Moisés, o servo de Deus."
,"35":"Filhos de Aarão: Eleazar, depois Fineias, Abisue,"
,"36":"Boci, Ozi, Zaraías,"
,"37":"Meraiot, Amarias, Aquitob,"
,"38":"Sadoc e por fim Aquimaás."
,"39":"São estas as moradas dos filhos de Levi, conforme as divisões dos seus territórios: Aos filhos de Aarão, do clã de Caat, que foram sorteados em primeiro lugar,"
,"40":"deram Hebron, no território de Judá, com as pastagens vizinhas."
,"41":"A zona rural e as suas aldeias ficaram para Caleb, filho de Jefoné."
,"42":"Aos filhos de Aarão foram entregues as cidades de refúgio: Hebron, Lebna e suas pastagens, Jeter, Estemo e suas pastagens;"
,"43":"Helon e suas pastagens, Dabir e suas pastagens;"
,"44":"Asã e suas pastagens; Bet-Sames e suas pastagens."
,"45":"Da tribo de Benjamim foram entregues Gaba e suas pastagens, Almat e suas pastagens; Anatot e suas pastagens. Os seus clãs receberam ao todo treze cidades com suas pastagens."
,"46":"Aos outros descendentes de Caat, foram entregues, por sorteio, dez cidades, tomadas dos clãs das tribos de Efraim, Dã e da meia tribo de Manassés."
,"47":"Para os descendentes de Gersam, distribuídos por clãs, ficaram treze cidades, tomadas das tribos de Issacar, Aser, Neftali e da tribo de Manassés em Basã."
,"48":"Aos descendentes de Merari, por clãs, couberam por sorteio doze cidades, tomadas das tribos de Rúben, Gad e Zabulon."
,"49":"Foram estas as cidades que os israelitas entregaram aos descendentes de Levi, incluindo as pastagens."
,"50":"Por sorteio, entregaram-lhes também as cidades que eram das tribos de Judá, de Simeão e de Benjamim, às quais eles deram os nomes."
,"51":"Algumas cidades entregues aos clãs dos descendentes de Caat foram tomadas à tribo de Efraim."
,"52":"Entregaram-lhes também as cidades de refúgio: Siquém e suas pastagens, na região montanhosa de Efraim; Gazer e suas pastagens;"
,"53":"Jecmaam e suas pastagens, Bet-Horon e suas pastagens;"
,"54":"Aialon e suas pastagens; Gat-Remon e suas pastagens;"
,"55":"Aner e Balaam com as respectivas pastagens, que foram tiradas da meia tribo de Manassés. É o que foi entregue aos outros clãs dos descendentes de Caat."
,"56":"Dos clãs da meia tribo de Manassés foram entregues aos descendentes de Gersam: Golã e suas pastagens em Basã; Astarot e suas pastagens."
,"57":"Da tribo de Issacar: Cedes e suas pastagens; Daberet e suas pastagens;"
,"58":"Ramot e suas pastagens; Anem e suas pastagens."
,"59":"Da tribo de Aser foram entregues: Masal e suas pastagens; Abdon e suas pastagens;"
,"60":"Hucoc e suas pastagens; Roob e suas pastagens."
,"61":"Da tribo de Neftali: Cedes na Galileia e suas pastagens; Hamon e suas pastagens; Cariataim e suas pastagens."
,"62":"Para os outros descendentes de Merari, ficaram as seguintes cidades da tribo de Zabulon: Remon e suas pastagens; Tabor e suas pastagens,"
,"63":"do outro lado do Jordão, em direcção a Jericó, a Leste do rio. Da tribo de Rúben: Bosor, no deserto, e suas pastagens; Jasa e suas pastagens;"
,"64":"Cedimot e suas pastagens; Mefaat e suas pastagens."
,"65":"Da tribo de Gad: Ramot em Galaad e suas pastagens; Maanaim e suas pastagens;"
,"66":"Hesebon e suas pastagens; Jazer e suas pastagens."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Filhos de Issacar: Tola, Fua, Jasub e Semron. Quatro ao todo."
,"2":"Filhos de Tola, chefes das suas famílias: Ozi, Rafaías, Jeriel, Jemai, Jebsem e Samuel. O número de guerreiros que eles tinham por famílias no tempo de David era, no total, vinte e dois mil e seiscentos."
,"3":"Filho de Ozi: Izraías. Filhos de Izraías: Miguel, Abdias, Joel e Jesias. Eram cinco chefes."
,"4":"Sob a responsabilidade deles havia batalhões organizados com trinta e seis mil soldados, repartidos conforme a sua parentela e famílias. Eles tinham muitas mulheres e filhos."
,"5":"Os seus irmãos dos clãs de Issacar chegaram a ter oitenta e sete mil guerreiros no recenseamento."
,"6":"Filhos de Benjamim: Bela, Bocor e Jadiel. Três ao todo."
,"7":"Filhos de Bela: Esbon, Ozi, Oziel, Jerimot e Urai. Os cinco eram chefes de famílias, valentes guerreiros, somando vinte e dois mil e trinta e quatro homens."
,"8":"Filhos de Bocor: Zamira, Joás, Eliezer, Elioenai, Amri, Jerimot, Abias, Anatot e Almat, todos filhos de Bocor."
,"9":"O recenseamento deles, feito em base aos chefes das suas famílias, deu vinte mil e duzentos guerreiros."
,"10":"Filho de Jadiel: Balã. Filhos de Balã: Jeús, Benjamim, Aod, Canana, Zetã, Társis e Aisaar."
,"11":"Todos estes filhos de Jadiel se tornaram chefes de famílias, homens valentes, em número de dezassete mil e duzentos, aptos para guerra e combate."
,"12":"Sufam e Hufam. Filho de Ir: Hasim, cujo filho se chamava Aer."
,"13":"Filhos de Neftali: Jasiel, Guni, Jeser e Selum. Todos eram filhos de Bala."
,"14":"Filhos de Manassés: Esriel, dado à luz pela sua concubina arameia, que lhe deu também Maquir, pai de Galaad."
,"15":"Maquir tomou esposas para Hufam e Sufam. Tinha uma irmã chamada Maaca. O nome do seu outro irmão era Salfaad, que só teve filhas."
,"16":"Maaca, mulher de Maquir, teve um filho, e deu-lhe o nome de Farés. O irmão dele chamava-se Sares, cujos filhos eram Ulam e Recém."
,"17":"Filho de Ulam: Badã. São estes os descendentes de Galaad, filho de Maquir, que era filho de Manassés."
,"18":"A sua irmã Amaléquet foi a mãe de Isod, Abiezer e Moola."
,"19":"Filhos de Semida: Ain, Siquém, Leci e Aniam."
,"20":"Filhos de Efraim: Sutala, pai de Bared, pai de Taat, pai de Elada, pai de Taat,"
,"21":"pai de Zabad, pai de Sutala, e ainda Ezer e Elada. Uns indivíduos de Gad, nascidos no território, mataram estes dois últimos que tinham ido roubar gado."
,"22":"Efraim, o pai deles, ficou de luto por muito tempo, e seus irmãos foram consolá-lo."
,"23":"Depois voltou a unir-se à sua esposa; então ela ficou grávida e deu à luz um menino, a quem ele deu o nome de Berias, para lembrar que «a sua casa estava na infelicidade»."
,"24":"Filha de Efraim: Sara. Ela fundou as cidades de Bet-Horon superior e inferior e também Ozensara."
,"25":"À descendência de Efraim pertencem também: Rafa, pai de Sutala, pai de Taã,"
,"26":"pai de Laadã, pai de Amiud, pai de Elisama,"
,"27":"pai de Nun, pai de Josué."
,"28":"As suas propriedades e moradias eram em Betel e arredores; Norã, a Leste; Gazer e arredores, a Oeste; Siquém e arredores, até Ai e arredores."
,"29":"Em poder dos descendentes de Manassés estavam também: Betsã e arredores; Tanac e arredores; Meguido e arredores; Dor e arredores. Aí moravam os descendentes de José, filho de Israel."
,"30":"Filhos de Aser: Jemna, Jesua, Jessui, Beria, além de Sara, irmã deles."
,"31":"Filhos de Beria: Héber e Melquiel, pai de Barzait."
,"32":"Filhos de Héber: Jeflat, Somer, Hotam e uma irmã, Suaá."
,"33":"Filhos de Jeflat: Fosec, Bamaal e Asot. São estes os filhos de Jeflat."
,"34":"Filhos de seu irmão Somer: Roaga, Haba e Aram."
,"35":"O outro irmão, de nome Hélem, teve os seguintes filhos: Sufa, Jemna, Seles e Amal."
,"36":"Sufa foi pai de Sue, Harnafer, Sual, Beri, Jamra,"
,"37":"Bosor, Od, Sama, Salusa, Jetrã e Beera."
,"38":"Jetrã teve os seguintes filhos: Jefoné, Fasfa e Ara."
,"39":"Filhos de Ola: Area, Haniel e Resias."
,"40":"São estes os descendentes de Aser, chefes de famílias, homens escolhidos e valentes, chefes entre os príncipes. O recenseamento, feito em base à capacidade militar, somou vinte e seis mil homens."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Filhos de Benjamim: Bela, o mais velho; em segundo lugar, Asbel; em terceiro, Airam;"
,"2":"em quarto, Noaá; em quinto, Rafa."
,"3":"Filhos de Bela: Adar, Gera, pai de Aod,"
,"4":"Abisue, Naamã, Aoe,"
,"5":"Gera, Sefufam e Huram."
,"6":"Filhos de Aod, que foram chefes de famílias em Gaba e que foram exilados para Manaat:"
,"7":"Naamã, Aías e Gera. Este último conduziu-os cativos; ele foi pai de Oza e Aiud."
,"8":"Saaraim só teve filhos nos campos de Moab, depois de repudiar as suas duas mulheres, Husim e Baara."
,"9":"A sua nova mulher deu-lhe estes filhos: Jobab, Sebias, Mesa, Melcam,"
,"10":"Jeús, Sequias e Marma. Foram estes os seus filhos, que se tornaram chefes de famílias."
,"11":"Husim tinha gerado Abitob e Elfaal."
,"12":"Filhos de Elfaal: Héber, Misaam e Samad. Este foi o fundador de Ono e Lod com os seus arredores."
,"13":"Berias e Sama eram chefes de famílias dos moradores de Aialon, e foram eles que expulsaram os habitantes de Gat."
,"14":"Sesac era irmão de Berias. Jerimot,"
,"15":"Zabadias, Arod, Éder,"
,"16":"Miguel, Jesfa e Joá eram filhos de Berias."
,"17":"Zabadias, Mosolam, Hezeci, Haber,"
,"18":"Jesamari, Jeslias e Jobab eram filhos de Elfaal."
,"19":"Jacim, Zecri, Zabdi,"
,"20":"Elioenai, Seletai, Eliel,"
,"21":"Adaías, Baraías e Samarat eram filhos de Semei."
,"22":"Jesfã, Héber, Eliel,"
,"23":"Abdon, Zecri, Hanã,"
,"24":"Hananias, Elam, Anatotias,"
,"25":"Jefdaías e Fanuel eram filhos de Sesac."
,"26":"Semsari, Soorias, Otolias,"
,"27":"Jersias, Elias e Zecri eram filhos de Jeroam."
,"28":"Estes eram os chefes de famílias, agrupados segundo a sua parentela. Eles moravam em Jerusalém."
,"29":"Em Gabaon moravam Jeiel, pai de Gabaon. A sua mulher chamava-se Maaca."
,"30":"Os seus filhos foram: Abdon, o mais velho; depois, Sur, Cis, Baal, Ner, Nadab,"
,"31":"Gedor, Aio, Zaquer e Macelot."
,"32":"Macelot foi pai de Samaá. Mas estes dois, ao contrário dos seus irmãos, foram morar em Jerusalém, juntamente com os seus outros irmãos."
,"33":"Ner foi pai de Cis, pai de Saul, que teve os seguintes filhos: Jónatas, Melquisua, Abinadab e Isbaal."
,"34":"Jónatas teve um filho, Meribaal, pai de Micas."
,"35":"Filhos de Micas: Fiton, Melec, Taraá e Aaz."
,"36":"Aaz foi pai de Joada, pai de Almat, Azmot e Zambri. Zambri foi pai de Mosa,"
,"37":"pai de Banaá, pai de Rafa, pai de Elasa, pai de Asel,"
,"38":"que teve seis filhos com estes nomes: Ezricam, o mais velho; depois, Ismael, Sarias, Abdias e Hanã. Eram todos filhos de Asel."
,"39":"Filhos do seu irmão Esec: Ulam, o mais velho; Jeús, o segundo; Elifalet, o terceiro."
,"40":"Os filhos de Ulam eram guerreiros valentes, atiradores de flechas. Os seus filhos e netos aumentaram muito, chegando ao número de cento e cinquenta. Todos estes eram descendentes de Benjamim."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Todo o Israel foi registado em genealogias e estava inscrito no livro dos reis de Israel e Judá, quando, por causa das suas infidelidades, foi levado para o exílio na Babilónia."
,"2":"Os primeiros israelitas a residir em patrimónios e cidades foram os sacerdotes, os levitas e os oblatos."
,"3":"Em Jerusalém ficaram a morar alguns descendentes de Judá, Benjamim, Efraim e Manassés."
,"4":"Dos descendentes de Judá ficaram: Otei, filho de Amiud, filho de Amri, filho de Omrai, filho de Bani, filho de Farés, filho de Judá."
,"5":"Dos selanitas: Asaías, o primogénito, e seus filhos."
,"6":"Da descendência de Zara ficaram: Jeuel e seus irmãos, num total de seiscentas e noventa pessoas."
,"7":"Dos descendentes de Benjamim, ficaram em Jerusalém: Salo, filho de Mosolam, filho de Oduías, filho de Asana;"
,"8":"Joabnias, filho de Jeroam; Ela, filho de Ozi, filho de Mocori; Mosolam, filho de Safatias, filho de Reuel, filho de Jebanias."
,"9":"Com todos os irmãos, por famílias, somavam, no total, novecentas e cinquenta pessoas. Todos estes homens eram chefes de famílias."
,"10":"Os sacerdotes que ficaram: Jedaías, Joiarib, Jaquin,"
,"11":"Azarias, filho de Helcias, filho de Mosolam, filho de Sadoc, filho de Maraiot, filho de Aquitob, que era chefe do Templo de Deus."
,"12":"Também Adaías, filho de Jeroam, filho de Fassur, filho de Melquias; Maasai, filho de Adiel, filho de Jezra, filho de Mosolam, filho de Mosolamot, filho de Emer,"
,"13":"além dos irmãos, chefes de famílias. Eram, no total, mil e setecentos e sessenta homens aptos para a guerra, todos encarregados do serviço no Templo de Deus."
,"14":"Levitas que ficaram: Semeias, filho de Hassub, filho de Ezricam, filho de Hasabias, dos descendentes de Merari;"
,"15":"Bacbacar, Hares, Galal; Matanias, filho de Micas, filho de Zecri, filho de Asaf;"
,"16":"Abdias, filho de Semeias, filho de Galal, filho de Iditun; Baraquias, filho de Asa, filho de Elcana, que morava nas aldeias dos netofatitas."
,"17":"Porteiros que ficaram: Selum, Acub, Telmon e Aimã, com seus irmãos. Selum, o chefe,"
,"18":"permanece até hoje junto à porta Real, do lado Leste. Os porteiros dos acampamentos dos levitas eram os seguintes:"
,"19":"Selum, filho de Coré, filho de Abiasaf, filho de Cora, e seus irmãos de sangue, da mesma família dos coreítas. Dedicavam-se ao serviço litúrgico, guardavam a porta da Tenda, ao passo que seus pais, responsáveis pelo acampamento de Javé, guardavam a entrada."
,"20":"Fineias, filho de Eleazar, foi o chefe deles. Que Javé esteja com ele!"
,"21":"Zacarias, filho de Mosolamias, foi o porteiro à entrada da Tenda da reunião."
,"22":"Os porteiros escolhidos para guardar a entrada da porta eram ao todo duzentos e doze. Estavam agrupados nas suas aldeias. David e o vidente Samuel colocaram-nos como porteiros, por causa da honestidade deles."
,"23":"Eles e seus filhos tornaram-se os porteiros responsáveis pelas portas do Templo de Javé, ou seja, a Casa da Tenda."
,"24":"Os porteiros ficavam voltados para os quatro lados: Nascente, Poente, Norte e Sul."
,"25":"Os irmãos que estavam nas aldeias deviam revezar-se, de semana em semana, para ficarem sete dias com eles,"
,"26":"pois os quatro porteiros mais fortes ficavam lá constantemente. Eles eram levitas e cuidavam dos depósitos e provisões do Templo de Deus."
,"27":"Dormiam na vizinhança do Templo, pois estavam encarregados de o guardar; eram eles que abriam as portas, todas as manhãs."
,"28":"Alguns deles eram encarregados dos objectos do culto e tinham que conferir os objectos que chegavam e saíam."
,"29":"Outros eram encarregados do material de consumo, coisas sagradas como farinha de trigo, vinho, azeite, incenso e perfumes."
,"30":"Quem misturava as essências para preparar os perfumes eram os sacerdotes."
,"31":"O levita Matatias, filho mais velho de Selum, descendente de Coré, por causa da sua honestidade ficou responsável pelo que era feito nas assadeiras."
,"32":"Alguns da família dos descendentes de Caat ficaram encarregados de substituir, todos os sábados, os doze pães colocados em ordem no santuário."
,"33":"São estes os cantores, chefes de família da tribo de Levi. Moravam nos alojamentos do Templo e eram livres de outras funções, porque estavam ao serviço dia e noite."
,"34":"São estes os chefes de família da casa de Levi, conforme os seus clãs. Todos moravam em Jerusalém."
,"35":"Em Gabaon, morava Jeiel, pai de Gabaon. O nome de sua mulher era Maaca."
,"36":"Lá moravam o seu filho mais velho Abdon e também Sur, Cis, Baal, Ner, Nadab,"
,"37":"Gedor, Aio, Zacarias e Macelot."
,"38":"Macelot foi pai de Samaam. Ao contrário de seus irmãos, estes últimos moravam com os outros irmãos em Jerusalém."
,"39":"Ner foi pai de Cis, que foi pai de Saul. Saul teve estes filhos: Jónatas, Melquisua, Abinadab e Isbaal."
,"40":"O filho de Jónatas chamava-se Meribaal, pai de Micas."
,"41":"Filhos de Micas: Fiton, Melec e Taraá."
,"42":"Aaz foi pai de Jara, pai de Almat, Azmot e Zambri. Zambri foi pai de Mosa,"
,"43":"pai de Banaá, pai de Rafaías, Elasa e Asel."
,"44":"Asel teve seis filhos: Ezricam, o mais velho, Ismael, Sarias, Abdias e Hanã; são estes os filhos de Asel."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Os filisteus estavam em guerra contra Israel. Aconteceu então que os homens de Israel fugiram dos filisteus e, feridos, acabaram por cair mortos no monte Gelboé."
,"2":"Os filisteus perseguiram Saul e seus filhos, e mataram Jónatas, Abinadab e Melquisua, filhos de Saul."
,"3":"Então a luta concentrou-se sobre Saul. Os atiradores descobriram onde ele estava e acertaram-lhe com flechas."
,"4":"Saul disse ao seu escudeiro: «Puxa da tua espada e mata-me, senão esses incircuncisos vão rir-se de mim». O escudeiro não o quis fazer, pois teve muito medo. Então Saul pegou na sua própria espada e lançou-se sobre ela."
,"5":"O escudeiro ficou apavorado e, ao ver que Saul tinha morrido, lançou-se também sobre a própria espada e morreu."
,"6":"Desta forma, morreram Saul e os seus três filhos: a família inteira."
,"7":"Todos os israelitas que moravam no vale, ao verem que os homens de Israel tinham fugido e que Saul e seus filhos tinham morrido, abandonaram as suas cidades e fugiram. Então os filisteus vieram e ficaram lá a morar."
,"8":"No outro dia, quando os filisteus foram saquear os mortos no combate, encontraram Saul com os seus filhos, todos mortos, no monte Gelboé."
,"9":"Depois de despojar o corpo de Saul, levaram-lhe a cabeça e as armas para a terra dos filisteus, anunciando a boa notícia aos seus ídolos e ao seu povo."
,"10":"Em seguida, colocaram as armas de Saul no templo do deus deles e pregaram-lhe o crânio no templo de Dagon."
,"11":"Os habitantes de Jabes de Galaad tiveram conhecimento do que os filisteus tinham feito a Saul."
,"12":"Então todos os guerreiros foram buscar o corpo de Saul e de seus filhos, levando-os para Jabes. Sepultaram os corpos debaixo do terebinto de Jabes e jejuaram durante sete dias."
,"13":"Saul morreu por ter sido infiel a Javé: não seguiu a ordem de Javé e foi consultar uma mulher que invocava os mortos,"
,"14":"em vez de consultar a Javé. Então Javé entregou-o à morte e passou o reinado para David, filho de Jessé."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Todo o Israel se reuniu com David em Hebron e disse-lhe: «Vê bem! Nós somos do mesmo sangue."
,"2":"Há pouco tempo, quando Saul era rei, eras tu que chefiavas Israel nas guerras. E Javé, teu Deus, disse-te: 'Tu serás o pastor do meu povo Israel. Tu serás o chefe do meu povo Israel'»."
,"3":"Todos os anciãos de Israel foram procurar o rei a Hebron, e David fez, ali mesmo em Hebron, uma aliança com eles, na presença de Javé. Então eles ungiram David como rei de Israel, conforme a palavra de Javé, anunciada por Samuel."
,"4":"David, com todo o Israel, tomou o caminho para Jerusalém, que se chamava Jebus. Os jebuseus moravam nessa região."
,"5":"Então os moradores de Jebus disseram a David: «Aqui não entras!» Mas David tomou a fortaleza de Sião, que é a Cidade de David."
,"6":"Foi quando David disse: «Quem atacar primeiro os jebuseus será nomeado comandante-chefe». Quem atacou primeiro foi Joab, filho de Sárvia. Foi assim que ele se tornou comandante."
,"7":"David passou a morar nessa fortaleza e, por isso, deram-lhe o nome de Cidade de David."
,"8":"Ele reconstruiu a cidade em redor, tanto o Melo como as muralhas. E Joab reformou o resto da cidade."
,"9":"O poder de David aumentava cada vez mais, e Javé dos exércitos estava com ele."
,"10":"São estes os valentes de David, que se afirmaram com valor no seu reino e, juntamente com todo o Israel, o fizeram rei, conforme a palavra de Javé a respeito de Israel."
,"11":"Os valentes de David são os seguintes: Jesbaam, filho de Hacamon. Ele era o chefe dos Três. Foi ele que atirou a lança sobre trezentos, e abateu os trezentos de uma só vez."
,"12":"Além dele, Eleazar, filho de Dodó, o aoíta, que era um dos Três."
,"13":"Ele estava com David em Afes-Domim, quando os filisteus ali se reuniram para o combate. Havia nesse lugar um campo de cevada. O exército fugiu com medo dos filisteus,"
,"14":"mas Eleazar postou-se no meio da seara, defendeu-a e matou os filisteus. Javé concedeu uma grande vitória."
,"15":"Três dos Trinta desceram para perto de David, junto ao rochedo da gruta de Odolam. O acampamento filisteu estava armado no vale dos rafaim."
,"16":"David estava no esconderijo, enquanto em Belém havia uma guarnição de filisteus."
,"17":"Foi quando David manifestou um desejo: «Quem me dera beber da água do poço de Belém, que fica à entrada da cidade!»"
,"18":"Os três homens atravessaram o acampamento dos filisteus, tiraram água do poço que fica à entrada de Belém e levaram-na a David. Mas David não quis beber e derramou a água em libação a Javé,"
,"19":"dizendo: «Deus me livre de fazer uma coisa destas! Acaso vou beber o sangue destes homens que por mim arriscaram a vida? Eles trouxeram a água com risco de vida!» E de modo nenhum quis beber. Foi isto que os três valentes fizeram."
,"20":"Abisaí, irmão de Joab, era o chefe dos Trinta. Ele atirou a lança sobre trezentos e matou-os. Assim, ficou famoso entre os Trinta."
,"21":"Era o mais respeitado dos Trinta e tornou-se o chefe deles. Mas não fazia parte dos Três."
,"22":"Banaías, filho de Joiada, soldado de muitas façanhas, natural de Cabseel, matou os dois heróis de Moab e, em dia de neve, desceu e matou um leão dentro do poço."
,"23":"Ele também matou o egípcio de dois metros e meio de altura, que tinha na mão uma lança, que mais parecia um cilindro de tear: enfrentou-o com um cajado, tirou a lança da mão do egípcio, e com ela matou-o."
,"24":"Banaías, filho de Joiada, fez tudo isto, e ficou famoso entre os Trinta."
,"25":"Era o mais respeitado entre os Trinta, mas não fazia parte dos Três. David nomeou-o chefe da sua guarda pessoal."
,"26":"Os valentes de David eram estes: Asael, irmão de Joab; Elcanã, filho de Dodó, de Belém;"
,"27":"Samot, o harorita; Heles, o felonita;"
,"28":"Ira, filho de Aces, de Técua; Abiezer, de Anatot;"
,"29":"Sobocai, de Husa; Ilai, de Ao;"
,"30":"Maarai, de Netofa; Héled, filho de Baana, de Netofa;"
,"31":"Etai, filho de Ribai, de Gabaá dos filhos de Benjamim; Banaías, de Faraton;"
,"32":"Hurrai, das torrentes de Gaás; Abiel, de Bet-Arabá;"
,"33":"Azmot, de Baurim; Eliaba, de Saalbon;"
,"34":"Bené-Asem, de Gezon; Jónatas, filho de Saage, de Arar;"
,"35":"Aiam, filho de Sacar, de Arar; Elifalet, filho de Ur;"
,"36":"Héfer, de Maquera; Aías, o felonita;"
,"37":"Hesro, de Carmel; Naarai, filho de Azbai;"
,"38":"Joel, irmão de Natã; Mibaar, filho de Agarai;"
,"39":"Selec, o amonita; Naarai, de Beerot, escudeiro de Joab, filho de Sárvia;"
,"40":"Ira, de Jeter; Gareb, de Jeter;"
,"41":"Urias, o heteu; Zabad, filho de Ooli;"
,"42":"Adina, filho de Siza, o rubenita, chefe dos rubenitas e responsável pelos Trinta;"
,"43":"Hanã, filho de Maaca; Josafá, o matanita;"
,"44":"Ozias, de Astarot; Sama e Jaiel, filhos de Hotam, de Aroer;"
,"45":"Jediel, filho de Samri, e seu irmão Joás, o tasaíta;"
,"46":"Eliel, o maumita; Jeribai e Josaías, filhos de Elnaem; Jetma, o moabita;"
,"47":"Eliel, Obed e Jasiel, de Soba."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Lista dos que passaram para o lado de David, em Siceleg, quando ele ainda andava a esconder-se de Saul, filho de Cis. Eles eram valentes, companheiros de luta,"
,"2":"que manejavam o arco, tanto com a direita como com a esquerda, e sabiam atirar da mesma forma tanto pedras como flechas. Irmãos de Saul, da tribo de Benjamim: "
,"3":"o chefe Aiezer e Joás, filho de Samaá, de Gabaá; Jasiel e Falet, filho de Azmot; Baraca e Jeú, de Anatot;"
,"4":"Ismaías, de Gabaon, um dos Trinta e chefe dos Trinta;"
,"5":"Jeremias, Jeeziel, Joanã e Jozabad, de Gaderot;"
,"6":"Eluzaí, Jerimot, Baalias, Samarias, Safatias, de Harif;"
,"7":"Elcana, Jesias, Azareel, Joezer e Jesbaam, da família de Coré;"
,"8":"Joela e Zabadias, filhos de Jeroam, de Gedor."
,"9":"Muitos da tribo de Gad passaram para o lado de David, quando ele estava escondido no deserto. Eram guerreiros valentes, gente treinada para a guerra, bons no manejo do escudo e da lança. Pareciam leões, e eram espertos como gazelas nas montanhas."
,"10":"O chefe deles era Ezer; Abdias, o segundo; Eliab, o terceiro;"
,"11":"Masmana, o quarto; Jeremias, o quinto;"
,"12":"Eti, o sexto; Eliel, o sétimo;"
,"13":"Joanã, o oitavo; Elzebad, o nono;"
,"14":"Jeremias, o décimo; Macbanai, o décimo primeiro."
,"15":"Da tribo de Gad, eram estes os comandantes de batalhões, que tinham, cada um, entre cem e mil soldados."
,"16":"Foram estes que atravessaram o rio Jordão no primeiro mês do ano, quando ele transborda. E eles expulsaram todos os moradores do vale, de um e do outro lado do rio."
,"17":"Alguns indivíduos das tribos de Benjamim e Judá foram até ao esconderijo de David para se aliarem com ele."
,"18":"David saiu ao encontro deles e disse: «Se vindes como amigos, para me ajudar, eu estou pronto para me unir a vós. Agora, se é para me atraiçoar em favor dos meus inimigos, embora eu não tenha nenhum crime nas costas, que o Deus dos nossos antepassados veja, e Ele mesmo faça justiça!»"
,"19":"Então o espírito apoderou-se de Amasai, chefe dos Trinta, que exclamou: «Nós somos dos teus, David. Estamos contigo, filho de Isaí. Paz para ti e para os teus companheiros, porque o teu Deus está do teu lado». David então aceitou-os e colocou-os no comando de batalhões."
,"20":"Da tribo de Manassés, alguns juntaram-se a David, quando ele, ao lado dos filisteus, ia entrar em combate contra Saul. Mas David não ajudou os filisteus porque, reunidos em conselho, os chefes filisteus dispensaram a sua ajuda, dizendo: «Ele poderia desertar, passar para o lado de Saul e colocar em risco as nossas cabeças»."
,"21":"Quando David foi para Siceleg, saíram ao seu encontro estes indivíduos da tribo de Manassés: Ednas, Jozabad, Jediel, Miguel, Jozabad, Eliú, Salati, todos comandantes militares de Manassés."
,"22":"Eles passaram a ajudar David no comando do exército, pois eram todos guerreiros valentes e acabaram por se tornar oficiais do exército."
,"23":"Na verdade, David todos os dias ia recebendo novos reforços, de modo que o seu acampamento se tornava enorme."
,"24":"Número dos guerreiros armados que se apresentaram a David em Hebron, a fim de transferir para ele o reino de Saul, cumprindo assim a ordem de Javé:"
,"25":"Da tribo de Judá, com escudo e lança, seis mil e oitocentos homens armados para a guerra."
,"26":"Da tribo de Simeão, sete mil e cem combatentes."
,"27":"Da tribo de Levi, quatro mil e seiscentos,"
,"28":"além de Joiada, chefe dos descendentes de Aarão, com três mil e setecentos homens,"
,"29":"e ainda o jovem e valente guerreiro Sadoc, com vinte e dois oficiais da sua família."
,"30":"Da tribo de Benjamim, irmãos de Saul, eram três mil, e a maioria deles até então prestava serviço junto da família real de Saul."
,"31":"Da tribo de Efraim, vinte mil e oitocentos guerreiros, gente de fama na sua família."
,"32":"Da meia tribo de Manassés, dezoito mil, todos nomeados, um por um, para proclamar David rei."
,"33":"Da tribo de Issacar, gente que sabia escolher a ocasião e a maneira para Israel agir, eram duzentos chefes, que tinham sob as suas ordens todos os seus irmãos."
,"34":"Da tribo de Zabulon, cinquenta mil aptos para a guerra, dispostos em ordem de combate, armados e prontos a alistarem-se corajosamente para a guerra."
,"35":"Da tribo de Neftali, mil oficiais e trinta e sete mil soldados armados de lança e escudo."
,"36":"Da tribo de Dã, vinte e oito mil e seiscentos homens aptos para a guerra."
,"37":"Da tribo de Aser, quarenta mil homens prontos a partir para a guerra."
,"38":"Da Transjordânia, isto é, das tribos de Rúben, de Gad e da meia-tribo de Manassés, cento e vinte mil, munidos com toda a espécie de armas."
,"39":"Todos estes guerreiros, treinados e organizados, com toda a sinceridade, dirigiram-se até Hebron a fim de proclamar David rei de todo o Israel. E todo o restante da população de Israel também foi unânime em proclamar David rei."
,"40":"Durante três dias ficaram lá, comendo e bebendo com David, pois as suas famílias tinham preparado tudo para eles."
,"41":"Mesmo dos lugares mais próximos e até de Issacar, Zabulon e Neftali, as pessoas levavam comida em jumentos e camelos, mulas e bois. Levavam alimentos à base de farinha, figos e uvas secas, vinho e azeite, além de bois e ovelhas em abundância, porque Israel estava em festa."
}`)
	CurrentBook.AddChapter(13, `{
"1":"David convocou para uma reunião todos os chefes de mil e os chefes de cem, além de todos os comandantes."
,"2":"Então David dirigiu-se à assembleia geral dos israelitas: «Se é da vossa vontade e se o nosso Deus Javé aprova, vamos convidar os nossos irmãos de todas as regiões de Israel, assim como os sacerdotes e levitas de todas as suas cidades e campos, para que eles se juntem a nós."
,"3":"O objectivo é transportar para cá a Arca do nosso Deus, pois no tempo de Saul nós não nos preocupámos com ela»."
,"4":"A assembleia em peso decidiu que era isso mesmo que se devia fazer, pois todo o povo achou que a proposta era boa."
,"5":"Então David convocou a população de todo o Israel, desde Sior do Egipto até à Entrada de Emat, para ir buscar a Cariat-Iarim a Arca de Deus."
,"6":"David e todo o Israel dirigiram-se então para Baala ou Cariat-Iarim, em Judá, para transportar de lá a Arca do Deus que Se chama Javé, e está sentado sobre os querubins."
,"7":"Da casa de Abinadab em diante, a Arca de Deus foi transportada num carro novo. Oza e Aio eram os condutores."
,"8":"David e todo o Israel iam dançando diante de Deus, com todo o entusiasmo, cantando ao som de cítaras, harpas, tamborins, címbalos e trombetas."
,"9":"Estavam a chegar ao terreiro de Quidon, quando Oza estendeu a mão para segurar a Arca, porque os bois a faziam cair."
,"10":"Então a ira de Javé fulminou Oza e feriu-o, porque ele tocou na Arca. Ele morreu ali mesmo, na presença de Deus."
,"11":"David ficou desgostoso por Javé ter fulminado Oza. Então deu a esse lugar o nome de Farés-Oza, como é conhecido até hoje."
,"12":"Nesse dia, David ficou com medo de Deus e disse: «Como é que eu vou levar para minha casa a Arca de Deus?»"
,"13":"E David não levou a Arca para sua casa. Mandou que a levassem para a casa de Obed-Edom, que era da cidade de Gat."
,"14":"A Arca de Deus ficou três meses com a família de Obed-Edom, na casa dele. E Javé abençoou a casa de Obed-Edom e tudo o que lhe pertencia."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Hiram, rei de Tiro, mandou alguns emissários a David, levando madeira de cedro, pedreiros e carpinteiros, a fim de construir uma casa para ele."
,"2":"Então David teve a certeza de que Javé o confirmava como rei de Israel, e lhe engrandecia o reinado, por amor ao seu povo Israel."
,"3":"Em Jerusalém, David tomou para si outras mulheres e gerou mais filhos e filhas."
,"4":"E os nomes dos filhos que lhe nasceram em Jerusalém são os seguintes: Samua, Sobab, Natã, Salomão,"
,"5":"Jebaar, Elisua, Elfalet,"
,"6":"Noga, Nafeg, Jáfia,"
,"7":"Elisama, Baaliada e Elifalet."
,"8":"Quando ouviram dizer que David fora ungido rei de todo o Israel, os filisteus puseram-se em marcha para o prenderem. Sabendo disso, David partiu para os enfrentar."
,"9":"Os filisteus foram e espalharam-se pelo vale dos rafaim."
,"10":"Então David consultou a Deus: «Devo atacar os filisteus? Vais entregá-los em minhas mãos?» Javé respondeu-lhe: «Podes atacar. Eu vou entregá-los nas tuas mãos»."
,"11":"Os filisteus foram à luta em Baal-Farasim, e ali mesmo David os derrotou. Depois David disse: «Por minha mão, Deus abriu uma brecha no meio dos meus inimigos, como brecha feita pelas águas». Por isso, o nome desse lugar passou a chamar-se Baal-Farasim."
,"12":"Os filisteus abandonaram os seus deuses, que David mandou lançar ao fogo."
,"13":"Os filisteus insistiram e espalharam-se de novo pelo vale."
,"14":"David tornou a consultar a Deus, que lhe respondeu: «Não ataques. Dá a volta pelo outro lado e vai ao encontro deles em frente das amoreiras."
,"15":"Quando ouvires um rumor de passos ao fundo das amoreiras, começa o combate: é o sinal de que Deus sai à tua frente, para acabar com o exército filisteu»."
,"16":"David fez como Deus tinha mandado, e derrotou o exército filisteu desde Gabaon até Gazer."
,"17":"A fama de David correu por todo o território. E Javé tornou-o temido por todas as nações."
}`)
	CurrentBook.AddChapter(15, `{
"1":"David construiu para si um palácio na Cidade de David. E para a Arca de Deus, ele ergueu uma tenda."
,"2":"Depois disse: «A Arca de Deus só pode ser transportada pelos levitas, pois Javé escolheu-os para transportarem a Arca de Javé e estarem sempre ao seu serviço»."
,"3":"Então David convocou todo o Israel em Jerusalém, a fim de transferir a Arca de Javé para o lugar que havia preparado."
,"4":"Mandou reunir os descendentes de Aarão e os levitas."
,"5":"Eram os seguintes: Dos filhos de Caat: Uriel, o chefe, com cento e vinte companheiros."
,"6":"Dos filhos de Merari: Asaías, o chefe, com duzentos e vinte companheiros."
,"7":"Dos filhos de Gersam: Joel, o chefe, com cento e trinta companheiros."
,"8":"Dos filhos de Elisafã: Semeías, o chefe, com duzentos companheiros."
,"9":"Dos filhos de Hebron: Eliel, o chefe, com oitenta companheiros."
,"10":"Dos filhos de Oziel: Aminadab, o chefe, com cento e doze companheiros."
,"11":"Depois David convocou os sacerdotes Sadoc e Abiatar, os levitas Uriel, Asaías, Joel, Semeías, Eliel e Aminadab."
,"12":"E disse-lhes: «Vós sois os chefes de família dos levitas. Por isso, purificai-vos, vós e os vossos irmãos, para poderdes transportar a Arca de Javé, o Deus de Israel, para o lugar que eu preparei."
,"13":"Da primeira vez, vós não estáveis lá, e Javé feriu-nos, porque nós não O tratámos conforme o regulamento»."
,"14":"Os sacerdotes e levitas purificaram-se para transportar a Arca de Javé, o Deus de Israel."
,"15":"Depois os levitas transportaram a Arca de Deus, apoiada em varais sobre os ombros, conforme Moisés lhes havia mandado, segundo a palavra de Deus."
,"16":"David ordenou aos chefes dos levitas que entre os seus irmãos escolhessem cantores, para entoarem cânticos festivos acompanhados de cítaras, liras e címbalos."
,"17":"Os levitas escolheram Emã, filho de Joel; Asaf, seu parente, filho de Baraquias; Etã, filho de Casaías, da família de Merari e parente dos anteriores."
,"18":"Com eles, em lugar inferior, iam os seus parentes: eram os porteiros Zacarias, Jaziel, Semiramot, Jaiel, Ani, Eliab, Banaías, Maasias, Matatias, Elifalu, Macenias, Obed-Edom e Jeiel."
,"19":"Os músicos Emã, Asaf e Etã tocavam forte os címbalos de bronze."
,"20":"Zacarias, Oziel, Zemiramot, Jaiel, Ani, Eliab, Maasias e Banaías tocavam lira, para acompanhar vozes de soprano."
,"21":"Matatias, Elifalu, Macenias, Obed-Edom, Jeiel e Ozazias tocavam cítara oitavada, para marcar o ritmo."
,"22":"Conenias, chefe dos levitas encarregados do transporte, orientava tudo, pois nisso era experiente."
,"23":"Baraquias e Elcana faziam o papel de porteiros junto à Arca."
,"24":"Os sacerdotes Sebanias, Josafá, Natanael, Amasai, Zacarias, Banaías e Eliezer iam tocando trombeta à frente da Arca de Deus. Os outros dois porteiros junto à Arca eram Obed-Edom e Jeías."
,"25":"Lá estavam David, os anciãos de Israel e os chefes de mil, acompanhando com grande alegria a saída da Arca da Aliança de Javé, da casa de Obed-Edom."
,"26":"Foram feitos sacrifícios de sete bois e sete carneiros, pois Deus protegia os levitas que transportavam a Arca da Aliança de Javé."
,"27":"David, os levitas que transportavam a Arca, os cantores e Conenias, chefe dos carregadores, vestiam mantos de linho fino. David vestia o efod de linho."
,"28":"Todo o Israel participou na transferência da Arca da Aliança de Javé, no meio de aclamações, som de trombetas, clarins e címbalos, além da música de liras e cítaras."
,"29":"A Arca da Aliança de Javé estava a entrar na Cidade de David, quando Micol, filha de Saul, espreitou pela janela e viu o rei que dançava alegre. Então ela, dentro de si, começou a desprezá-lo."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Entraram com a Arca de Deus e instalaram-na dentro da tenda que David tinha armado para ela. Depois, na presença de Deus, ofereceram holocaustos e sacrifícios de comunhão."
,"2":"Tendo acabado de oferecer os holocaustos e os sacrifícios de comunhão, David abençoou o povo em nome de Javé."
,"3":"Em seguida, mandou dar a cada um dos israelitas, homens e mulheres, um pão, carne assada e um bolo de passas."
,"4":"David nomeou levitas para exercerem o ministério diante da Arca de Javé, a fim de celebrar, glorificar e louvar a Javé, o Deus de Israel."
,"5":"Asaf era o primeiro deles; o segundo era Zacarias; depois, Oziel, Semiramot, Jaiel, Matatias, Eliab, Banaías, Obed-Edom e Jeiel. Eles tocavam liras e cítaras, enquanto Asaf fazia soar os címbalos."
,"6":"Os sacerdotes Banaías e Jaziel tocavam continuamente as trombetas diante da Arca da Aliança de Deus."
,"7":"Nesse dia, pela primeira vez, David confiou a Asaf e a seus irmãos este louvor a Javé:"
,"8":"Celebrai Javé, invocai o seu nome, anunciai entre os povos,as suas façanhas!"
,"9":"Cantai-Lhe ao som de instrumentos, recitai todas as suas maravilhas."
,"10":"Orgulhai-vos do seu Nome santo, alegre-se o coração,dos que buscam a Javé!"
,"11":"Procurai Javé e a sua força, buscai sempre a sua face."
,"12":"Recordai as maravilhas que Ele fez, os seus prodígios,e as sentenças da sua boca."
,"13":"Descendentes do seu servo Israel, filhos de Jacob, seus escolhidos."
,"14":"Javé é o nosso Deus. Ele governa a terra inteira."
,"15":"Lembrai-vos para sempre,da sua aliança, da palavra empenhada,por mil gerações."
,"16":"Da aliança que Ele selou com Abraão, do juramento que fez a Isaac,"
,"17":"confirmado como lei para Jacob,e como aliança eterna para Israel:"
,"18":"«Eu te darei a terra de Canaã,como tua parte na herança»."
,"19":"Aí vós podíeis ser contados, éreis pouco numerosos, estrangeiros na terra."
,"20":"Eles iam e vinham de nação em nação, de um reino para outro povo diferente."
,"21":"Ele não deixou que ninguém os oprimisse. Por causa deles, até reis Ele castigou:"
,"22":"«Não toqueis nos meus ungidos!,Não façais mal aos meus profetas!»"
,"23":"Canta a Javé, ó terra inteira, proclama a sua vitória, dia após dia!"
,"24":"Anuncia a sua glória entre as nações,e as suas maravilhas a todos os povos!"
,"25":"Porque Javé é grande e digno de louvor, mais temível que todos os deuses."
,"26":"Pois os deuses dos povos são aparência, enquanto Javé é que fez o céu."
,"27":"Majestade e esplendor,caminham diante d'Ele, poder e beleza estão no seu Templo."
,"28":"Aclamai a Javé, famílias dos povos!,Aclamai a glória e o poder de Javé!"
,"29":"Aclamai a glória do nome de Javé, apresentai-vos a Ele trazendo ofertas, adorai a Javé no seu átrio sagrado."
,"30":"Terra inteira, treme na presença de Javé!,Ele firmou o mundo, que jamais tremerá."
,"31":"Que o céu se alegre e a terra exulte, e as nações proclamem: «Javé é rei!»"
,"32":"Estronde o mar, e o que ele contém!,Que o campo festeje, e o que nele existe!"
,"33":"As árvores da selva gritem de alegria,diante de Javé, porque Ele vem, Ele vem para governar a terra."
,"34":"Agradecei a Javé, porque Ele é bom, porque o seu amor é para sempre!"
,"35":"Dizei: «Salva-nos, ó Deus, nosso salvador!,Reúne e liberta das nações a todos nós, para que celebremos o teu Nome santo,e nos orgulhemos do teu louvor."
,"36":"Seja bendito Javé, o Deus de Israel, desde sempre e para sempre!»,E todo o povo respondeu: «Ámen! Aleluia!»"
,"37":"Junto da Arca da Aliança de Javé, David deixou Asaf e seus irmãos, para garantirem o serviço contínuo diante da Arca, conforme o ritual quotidiano."
,"38":"Como porteiros, deixou Obed-Edom, filho de Iditun, e Hosa, juntamente com sessenta e oito parentes."
,"39":"Os sacerdotes Sadoc e seus parentes ficaram junto da morada de Javé, no lugar alto que havia em Gabaon,"
,"40":"a fim de oferecerem holocaustos em honra de Javé sobre o altar dos holocaustos, de manhã e de tarde, para sempre, tudo de acordo com o que está escrito na Lei que o próprio Javé dera como norma a Israel."
,"41":"Com eles, ficaram Emã e Iditun com outros escolhidos, indicados nominalmente para o louvor de Deus, «porque o seu amor é para sempre»."
,"42":"Ficaram com eles também os tocadores de trombetas, címbalos e outros instrumentos que acompanham os cânticos de Deus. Os filhos de Iditun ficaram encarregados da porta de entrada."
,"43":"Então, todos voltaram para casa. David também voltou, para abençoar a sua casa."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Ao voltar para casa, David disse ao profeta Natã: «Vê! Eu estou a morar numa casa de cedro, ao passo que a Arca da Aliança de Javé está debaixo de uma tenda!»"
,"2":"Natã respondeu a David: «Faz o que o teu coração te inspirar, porque Deus está contigo»."
,"3":"Nessa mesma noite, Natã recebeu esta mensagem de Deus:"
,"4":"«Vai procurar o meu servo David e diz-lhe: Assim diz Javé: Não és tu quem vai construir uma casa para Eu morar."
,"5":"Porque, desde quando libertei Israel até hoje, Eu nunca morei numa casa. Andei sempre de tenda em tenda, de abrigo em abrigo."
,"6":"Durante todo o tempo em que caminhei com todo o Israel, acaso Eu perguntei alguma vez a um dos juízes de Israel, que coloquei como pastores do meu povo: 'Porque não Me construís uma casa de cedro?'"
,"7":"Portanto, diz ao meu servo David: Assim diz Javé dos exércitos: Fui Eu que te tirei do pastoreio das ovelhas, para seres o chefe do meu povo Israel."
,"8":"Estive contigo por toda a parte por onde ias. Exterminei da tua frente todos os teus inimigos. Agora, vou dar-te uma fama igual à dos maiores homens do mundo."
,"9":"Vou escolher um lugar para o meu povo Israel, e aí vou fixá-lo. Ele habitará nesse lugar, sem ser incomodado pelos maus, que não voltarão a oprimi-lo como antes,"
,"10":"desde o tempo em que coloquei juízes para dirigir o meu povo Israel. Submeterei todos os seus inimigos e engrandecer-te-ei. Javé anuncia que vai construir para ti uma dinastia."
,"11":"Quando completares a idade de ir para junto dos teus antepassados, Eu farei surgir um descendente depois de ti, um dos teus filhos, e Eu firmarei o seu reino."
,"12":"Ele construirá uma casa para Mim, e Eu firmarei o seu trono para sempre."
,"13":"Eu serei para ele um pai, e ele será para Mim um filho. Ele nunca perderá o meu favor, como perdeu Saul, que foi rei antes de ti."
,"14":"Eu o manterei para sempre na minha casa e no meu reino, e o seu trono será firme para sempre»."
,"15":"Natã comunicou a David todas estas palavras e toda esta visão."
,"16":"David entrou na tenda, sentou-se diante de Javé, e disse: «Quem sou eu, Javé Deus, e o que é a minha casa para que me tenhas trazido até aqui?"
,"17":"No entanto, isso ainda Te parece pouco, ó Deus, porque alargas as promessas à casa do teu servo até a um futuro distante, e consideras-me uma pessoa de importância, Javé Deus."
,"18":"Que mais poderia David fazer por Ti, em vista da fama que deste ao teu servo? Tu mesmo distinguiste o teu servo."
,"19":"Javé, por amor ao teu servo e conforme os teus projectos, realizaste esta obra extraordinária, para manifestar todas as tuas maravilhas."
,"20":"Javé, não há ninguém como Tu. Não há outro Deus além de Ti, como ouvimos com os nossos próprios ouvidos."
,"21":"E quem é como o teu povo Israel, o único povo do mundo que Deus mesmo veio resgatar, para o tornar seu povo e lhe dar um nome grande e estável? Tu expulsaste as nações diante do teu povo, que resgataste do Egipto."
,"22":"Decidiste que o teu povo Israel será o teu povo para sempre. E Tu, Javé, tornaste-Te o seu Deus."
,"23":"Agora, Javé, que a promessa que fizeste ao teu servo e à sua casa fique firme para sempre, e se cumpra tudo o que prometeste."
,"24":"Que essa promessa fique firme e que o teu nome seja engrandecido para sempre. Que se diga: 'Javé dos exércitos é o Deus de Israel'. Que a casa do teu servo David fique firme diante de Ti,"
,"25":"pois foste Tu, meu Deus, que revelaste ao teu servo que irias construir para ele uma dinastia. É por isso que o teu servo está aqui, a rezar diante de Ti."
,"26":"Sim, Javé, tu és Deus e fizeste essa promessa ao teu servo."
,"27":"Portanto, digna-Te abençoar a dinastia do teu servo, para que ela permaneça para sempre na tua presença. O que Tu abençoas fica abençoado para sempre»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Em seguida, David derrotou os filisteus e dominou-os, tomando-lhes a cidade de Gat e os seus arredores."
,"2":"Venceu também os moabitas, que passaram a ser seus súbditos e a pagar-lhe tributo."
,"3":"David derrotou também Adadezer, rei de Soba, quando este seguia em direcção a Emat, a fim de conquistar o rio Eufrates."
,"4":"Tomou-lhe mil carros de guerra, sete mil cavaleiros e vinte mil soldados de infantaria. David cortou os tendões de todos os cavalos, deixando apenas cem."
,"5":"Aram de Damasco foi ajudar Adadezer, rei de Soba, mas David matou vinte e dois mil arameus."
,"6":"Depois, colocou governadores em Aram de Damasco. E os arameus tornaram-se súbditos de David e pagaram-lhe tributo. Javé ia dando vitórias a David por toda a parte por onde ele andava."
,"7":"David tomou os escudos de ouro que os oficiais de Adadezer usavam, e levou-os para Jerusalém."
,"8":"Das cidades de Tebat e Cun, pertencentes a Adadezer, David levou grande quantidade de bronze. Foi com esse bronze que Salomão mandou fazer o Mar de bronze, as colunas e os utensílios de bronze."
,"9":"Toú, rei de Emat, soube que David tinha arrasado o exército de Adadezer, rei de Soba."
,"10":"Enviou então seu filho Adoram ao rei David, para o saudar e felicitar por ter guerreado contra Adadezer e o ter vencido, pois Adadezer também estava em guerra contra Toú. Mandou-lhe ainda toda a espécie de objectos de ouro, prata e bronze."
,"11":"David consagrou tudo a Javé, juntamente com o ouro e a prata que tinha tomado às outras nações: Edom, Moab, amonitas, filisteus e amalecitas."
,"12":"Abisaí, filho de Sárvia, derrotou os edomitas no vale do Sal. Eles eram dezoito mil."
,"13":"Depois, colocou governadores em Edom; e todos os edomitas se tornaram súbditos de David. Por onde David andasse, Deus concedia-lhe a vitória."
,"14":"David reinou sobre todo o Israel, exercendo o direito e a justiça para com todo o seu povo."
,"15":"Joab, filho de Sárvia, era o chefe do exército. Josafá, filho de Ailud, era o porta-voz."
,"16":"Sadoc, filho de Aquitob, e Aquimelec, filho de Abiatar, eram os sacerdotes. Susa era o secretário."
,"17":"E Banaías, filho de Joiada, comandava os cereteus e feleteus. Os filhos de David ocupavam os primeiros postos junto do rei."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Depois disso, morreu Naás, rei dos amonitas. E seu filho reinou em seu lugar."
,"2":"David pensou: «Vou procurar fazer amizade com Hanon, filho de Naás, porque o pai dele sempre procurou fazer amizade comigo». E mandou alguns representantes para lhe dar os pêsames pela morte do pai. Quando os representantes de David chegaram ao país dos amonitas, para dar os pêsames a Hanon,"
,"3":"os príncipes amonitas disseram a Hanon: «Tu pensas que David quer honrar teu pai, só porque mandou gente trazer-te os pêsames? Será que esses servos não vieram à tua casa para espiar, explorar e destruir o país?»"
,"4":"Então Hanon prendeu os emissários de David, rapou-lhes a barba, cortou-lhes o manto pelo meio, na altura da nádegas, e depois despediu-os."
,"5":"Ao ser informado do que tinha acontecido a esses homens, David mandou alguém ao encontro deles, porque estavam muito envergonhados. E o rei mandou dizer-lhes: «Ficai aí em Jericó, até que as vossas barbas cresçam. Depois voltareis»."
,"6":"Os amonitas perceberam que se haviam tornado odiosos para David. Então Hanon e os amonitas mandaram trinta e quatro mil quilos de prata, para comprar carros de guerra e cavaleiros arameus da Mesopotâmia, de Maaca e de Soba."
,"7":"Compraram, assim, trinta e dois mil carros de guerra, além de contratarem o rei de Maaca com o seu exército. Foram acampar em frente à cidade de Medaba. Enquanto isso, vindos de várias cidades, os amonitas iam-se reunindo para entrar em guerra."
,"8":"Ao saber disso, David mandou Joab com todo o exército dos valentes."
,"9":"Os amonitas puseram-se em marcha e organizaram-se para a luta, junto à porta da cidade, enquanto os reis que seguiram à parte ficaram em campo aberto."
,"10":"Ao ver que estava enfrentando uma luta pela vanguarda e pela retaguarda, Joab escolheu um grupo de jovens israelitas e organizou-os para combater os arameus."
,"11":"Confiou o restante do exército ao comando de seu irmão Abisaí; e esta parte organizou-se para combater os amonitas."
,"12":"Joab disse então: «Se os arameus estiverem mais fortes do que eu, vem tu socorrer-me. E se os amonitas te estiverem vencendo, eu irei socorrer-te."
,"13":"Força e coragem para defender o nosso povo e as cidades do nosso Deus! E seja feito o que Javé achar melhor»."
,"14":"Então Joab, com a parte do exército sob o seu comando, foi enfrentar os arameus, que fugiram diante dele."
,"15":"Os amonitas, vendo que os arameus fugiram, também fugiram de Abisaí, irmão de Joab, e entraram na cidade. Então Joab voltou para Jerusalém."
,"16":"Ao verem-se derrotados pelos israelitas, os arameus mandaram mensageiros procurar os outros arameus que moram do outro lado do rio Eufrates. Sofac, general de Adadezer, era quem os comandava."
,"17":"Ao saber disso, David reuniu todo o Israel, atravessou o rio Jordão e foi ao encontro deles. David fez os planos para enfrentar os arameus. Em seguida, começou a guerra contra eles."
,"18":"Os arameus fugiram dos israelitas, e David matou-lhes os cavalos de sete mil carros e quarenta mil homens de infantaria, além de matar Sofac, general do exército."
,"19":"Ao verem que estavam sendo derrotados pelos israelitas, os oficiais de Adadezer fizeram as pazes com David, tornaram-se súbditos dele e não quiseram mais socorrer os amonitas."
}`)
	CurrentBook.AddChapter(20, `{
"1":"No ano seguinte, na época em que os reis costumam sair para a guerra, Joab, no comando do escol do exército, foi arrasando o país dos amonitas, chegou até à capital Rabá, e cercou a cidade. Enquanto isso, David estava em Jerusalém. Joab tomou Rabá e destruiu-a."
,"2":"David tirou a coroa da cabeça do deus Melcom, e notou que pesava trinta e cinco quilos de ouro, e ainda tinha uma pedra preciosa. Daí em diante, ela passou a ficar na cabeça de David. E David levou da cidade um despojo muito grande."
,"3":"Tirou a população que havia na cidade e destinou-a para trabalhar com serras, picaretas e machados de ferro. E fez a mesma coisa com todas as outras cidades amonitas. Depois voltou para Jerusalém com o seu exército."
,"4":"Depois disso, ainda havia guerra em Gazer contra os filisteus. Então Sobocai, da cidade de Husa, matou Safai, um filho dos rafaim. Desta forma, eles foram dominados."
,"5":"Houve ainda outra guerra contra os filisteus. Desta vez, Elcanã, filho de Jair, matou Lami, filho de Golias de Gat. A lança deste mais parecia um cilindro de tear."
,"6":"A outra guerra foi em Gat. Havia lá um homem alto, que tinha vinte e quatro dedos: seis em cada mão e em cada pé, e que também era da família dos rafaim."
,"7":"Ele insultou Israel. Porém Jónatas, filho de Samaá, irmão de David, matou-o."
,"8":"Esses indivíduos eram de Rafa, na região de Gat. Tombaram sob as mãos de David e dos seus oficiais."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Satã insurgiu-se contra Israel e induziu David a fazer o recenseamento de Israel."
,"2":"David disse a Joab e aos chefes do povo: «Saí e fazei o recenseamento de Israel, desde Bersabeia até Dã. Depois voltai aqui, para eu ficar a saber quantos são»."
,"3":"Joab respondeu: «Que Javé multiplique o povo cem vezes mais, senhor meu rei! Porventura não são todos súbditos do meu senhor? Para quê faz o meu senhor esse recenseamento? Porque está a querer ser causa de pecado para Israel?»"
,"4":"Mas a ordem do rei prevaleceu, e Joab foi percorrer todo o país. Finalmente, voltou a Jerusalém."
,"5":"Entregou a David o resultado do recenseamento. Todo o Israel tinha um milhão e cem mil homens aptos para a guerra, e Judá tinha quatrocentos e setenta mil aptos para a guerra."
,"6":"Joab deplorou tanto a ordem do rei, que acabou por não recensear Levi nem Benjamim."
,"7":"Todo este caso não agradou a Deus, que castigou Israel."
,"8":"Então David disse a Deus: «Eu cometi um grande pecado, fazendo uma coisa destas! Perdoa o pecado do teu servo, pois cometi uma grande loucura!»"
,"9":"Então Javé disse a Gad, o vidente de David:"
,"10":"«Vai e diz a David: Assim diz Javé: Proponho-te três coisas. Escolhe uma, e Eu a executarei»."
,"11":"Gad foi ter com o rei e informou-o: «Assim diz Javé: Escolhe."
,"12":"Ou três anos de fome. Ou três meses fugindo do adversário, da espada do inimigo, até ela te alcançar. Ou ainda, a espada de Javé e três dias de peste no país, com o anjo do Senhor a devastar todo o território de Israel. Resolve agora o que devo responder Àquele que me enviou»."
,"13":"David respondeu a Gad: «Estou numa grande angústia! Prefiro cair nas mãos de Javé, pois a sua misericórdia é imensa, em vez de cair nas mãos dos homens»."
,"14":"Então Javé mandou uma peste sobre Israel, e morreram setenta mil israelitas."
,"15":"Depois Deus mandou o anjo a Jerusalém para a destruir. Javé, no entanto, viu e arrependeu-Se desse mal. E disse ao anjo exterminador: «Chega! Agora retira a mão». O anjo de Javé estava junto à eira de Ornã, o jebuseu."
,"16":"David ergueu os olhos e viu o anjo de Javé entre o céu e a terra, com a espada desembainhada e erguida sobre Jerusalém. Vestidos com panos de saco, David e os anciãos caíram com o rosto por terra."
,"17":"Então David disse a Deus: «Não fui eu quem mandou fazer o recenseamento? Não fui eu quem pecou e cometeu o mal? Quanto a esses, o rebanho, que foi que eles fizeram? Javé, meu Deus, que a tua mão caia sobre mim e sobre a minha família, mas que o teu povo escape da desgraça!»"
,"18":"O anjo de Javé disse então a Gad: «Ordena a David que suba e erga um altar a Javé na eira de Ornã, o jebuseu»."
,"19":"Então David subiu para lá, conforme Gad lhe havia dito em nome de Javé."
,"20":"Ao voltar-se, Ornã viu o anjo e escondeu-se com os seus quatro filhos. Ornã estava a debulhar trigo,"
,"21":"quando David foi encontrá-lo. Ornã viu David, saiu da eira e prostrou-se diante de David com o rosto por terra."
,"22":"David disse a Ornã: «Cede-me o lugar desta eira para que eu construa aqui um altar a Javé. Quero que me cedas a eira pelo seu valor em dinheiro. Deste modo, o povo ficará livre da peste»."
,"23":"Ornã respondeu a David: «Toma a eira, e que o senhor meu rei faça o que achar melhor. Vê! Eu dou os bois para o holocausto, as cangas como lenha e o trigo para a oblação. Eu entrego-te tudo»."
,"24":"Mas o rei David disse a Ornã: «De modo nenhum! Quero comprar a eira pelo seu valor em dinheiro. Não vou dar a Javé o que te pertence a ti, oferecendo holocaustos que não me custem nada!»"
,"25":"Então David deu a Ornã seis quilos de ouro."
,"26":"David construiu ali um altar a Javé e ofereceu holocaustos e sacrifícios de comunhão; invocou a Javé, que lhe respondeu, fazendo cair fogo do céu sobre o altar dos holocaustos."
,"27":"Então Javé ordenou ao anjo para recolocar a espada na bainha."
,"28":"Vendo que Javé o atendia na eira do jebuseu Ornã, David passou a oferecer holocaustos nesse lugar."
,"29":"Nessa época, a Habitação de Javé, que Moisés tinha feito no deserto, e também o altar dos holocaustos, ficavam no lugar alto de Gabaon."
,"30":"Mas David não pôde ir até lá, diante de Deus, porque a espada do anjo de Javé lhe causara medo."
}`)
	CurrentBook.AddChapter(22, `{
"1":"David disse então: «Aqui será construído o Templo de Javé Deus e o altar dos holocaustos de Israel»."
,"2":"Depois, David reuniu os estrangeiros que havia no país de Israel e determinou-lhes a tarefa de lavrar as pedras para a construção do Templo de Deus."
,"3":"Arranjou também muito ferro para os pregos e dobradiças das portas, bronze sem conta,"
,"4":"um sem-número de toros de cedro, que lhe foram enviados em abundância pelos sidónios e tírios."
,"5":"David pensava: «Meu filho Salomão é ainda jovem e frágil, e o Templo que ele deverá construir para Javé terá de ser algo de grandioso, de muito nome e admirado em todos os países. Por isso, vou fazer os preparativos». Foi assim que, antes de morrer, David arranjou muito material."
,"6":"Ele chamou o seu filho Salomão, e ordenou-lhe que construísse um Templo a Javé, o Deus de Israel."
,"7":"David disse a Salomão: «Meu filho, eu andava a planear construir um Templo ao Nome de Javé, meu Deus."
,"8":"Acontece, porém, que me chegou uma mensagem de Javé, dizendo: 'Tu derramaste muito sangue e fizeste guerras violentas. Não serás tu a construir um Templo ao meu Nome, porque derramaste muito sangue sobre a terra na minha presença."
,"9":"Vê! Tu terás um filho, que será homem pacífico. Vou fazer com que viva em paz com todos os inimigos vizinhos. O seu nome será Salomão. Nos seus dias, concederei paz e tranquilidade a Israel."
,"10":"É ele quem construirá um Templo ao meu Nome. Para Mim, ele será um filho; e para ele, Eu serei um pai, e firmarei para sempre o trono do seu reinado sobre Israel'."
,"11":"Agora, meu filho, que Javé esteja contigo. Mãos à obra. Constrói o Templo de Javé, teu Deus, conforme Ele projectou para ti."
,"12":"Basta que Javé te conceda bom senso e inteligência para governar Israel, cumprindo a lei de Javé, teu Deus."
,"13":"A tua prosperidade depende de tu observares e pores em prática os estatutos e normas que Javé ordenou a Israel por meio de Moisés. Força e coragem! Não tenhas medo, nem te acobardes."
,"14":"Vê bem: apesar da minha pobreza, eu arranjei para o Templo de Javé três mil e quatrocentas toneladas de ouro e trinta e quatro mil toneladas de prata, além de uma quantidade muito grande de bronze e ferro, que nem se pode calcular. Preparei também madeira e pedra, mas tu ainda terás que arranjar mais."
,"15":"Estarão à tua disposição muitos trabalhadores especializados em cortar e lavrar pedra e madeira, além de especialistas em qualquer profissão."
,"16":"Existe ouro, prata, bronze e ferro em abundância. Vamos! Mãos à obra. E que Javé esteja contigo»."
,"17":"David mandou também que todas as autoridades de Israel ajudassem seu filho Salomão. Ele disse:"
,"18":"«Porventura Javé, vosso Deus, não está convosco? Ele deu-vos descanso nas redondezas, ao entregar nas minhas mãos os moradores do país, subjugando esta terra a Javé e ao seu povo."
,"19":"Então, dedicai-vos de corpo e alma a buscar Javé, vosso Deus. Vamos! Construí o Santuário de Javé, vosso Deus, para nele colocarmos a Arca da Aliança de Javé e os objectos consagrados a Deus»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Quando ficou velho e idoso, David nomeou seu filho Salomão rei de Israel."
,"2":"Reuniu todos os chefes de Israel, os sacerdotes e os levitas."
,"3":"Mandou contar os levitas de trinta anos para cima. Contando só os homens, um por um, deu trinta e oito mil."
,"4":"Vinte e quatro mil deles dirigiam as actividades do Templo de Javé; seis mil eram magistrados e juízes;"
,"5":"quatro mil eram porteiros, e quatro mil deles louvavam a Javé com os instrumentos que David tinha inventado para essa finalidade."
,"6":"David repartiu os levitas em diferentes classes: Gérson, Caat e Merari."
,"7":"Filhos de Gérson: Leedã e Semei."
,"8":"Filhos de Leedã: Jaiel, o mais velho; Zetam e Joel. Três ao todo."
,"9":"Filhos de Semei: Salomit, Hoziel e Arã. Três ao todo. São estes os chefes de famílias de Leedã."
,"10":"Filhos de Semei: Jeet, Ziza, Jeús e Berias. São estes os filhos de Semei: quatro ao todo."
,"11":"Jeet era o mais velho; Ziza, o segundo; depois, Jeús e Berias que, não tendo muitos filhos, foram registados numa só família."
,"12":"Filhos de Caat: Amram, Isaar, Hebron e Oziel. Quatro ao todo."
,"13":"Os filhos de Amram foram Aarão e Moisés. Aarão foi escolhido para consagrar as coisas santíssimas. Ele e os seus descendentes, para sempre. A sua função é queimar incenso na presença de Javé, servi-l'O, e abençoar em seu nome, para sempre."
,"14":"Moisés foi um homem de Deus, e seus filhos receberam o nome da tribo de Levi."
,"15":"Filhos de Moisés: Gersam e Eliezer."
,"16":"O filho mais velho de Gersam era Subael."
,"17":"Roobias foi o filho mais velho de Eliezer, que não teve outros filhos. Roobias, porém, teve muitos filhos."
,"18":"O filho mais velho de Isaar era Salo-mit."
,"19":"Filhos de Hebron: Jerias, o mais velho; Amarias, o segundo; Jaaziel, o terceiro; Jecmaam, o quarto."
,"20":"Filhos de Oziel: Micas, o mais velho, e Jesias, o segundo."
,"21":"Filhos de Merari: Mooli e Musi. Filhos de Mooli: Eleazar e Cis."
,"22":"Eleazar não deixou filhos, mas só filhas, que se casaram com os seus parentes, os filhos de Cis."
,"23":"Musi teve três filhos: Mooli, Éder e Jerimot."
,"24":"Eram estes os descendentes de Levi, conforme as suas famílias, os chefes de famílias, como resultou do recenseamento feito por verificação nominal e individual. Eles tinham como encargo o culto no Templo de Javé, a partir da idade de vinte anos."
,"25":"Isto porque David tinha dito: «Javé, Deus de Israel, deu o descanso ao seu povo e passou a morar em Jerusalém para sempre."
,"26":"Os levitas, portanto, não terão mais de transportar a Habitação e os objectos destinados ao serviço dela»."
,"27":"Por isso, conforme as últimas disposições de David, os levitas eram recenseados a partir dos vinte anos."
,"28":"A função deles é estar à disposição dos descendentes de Aarão, para o serviço do Templo de Javé, nos átrios e nas salas, para limpar tudo o que é consagrado e para fazer o serviço do Templo de Deus."
,"29":"Também são encarregados de colocar em ordem os pães, a flor de farinha para a oblação, os pães sem fermento, as tortas cozidas sobre a chapa e as tortas fritas, e todas as medidas de capacidade e comprimento."
,"30":"Devem comparecer de manhã e de tarde para celebrar e louvar a Javé,"
,"31":"e também para oferecer todos os holocaustos a Javé nos sábados, luas novas e solenidades, conforme o número fixado pelo regulamento. Este é o encargo permanente que eles têm diante de Javé."
,"32":"Os levitas guardavam a Tenda da Reunião e o Santuário. Os seus irmãos aaronitas vigiavam o serviço do Templo de Javé."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Classes dos descendentes de Aarão. Filhos de Aarão: Nadab, Abiú, Eleazar e Itamar."
,"2":"Nadab e Abiú, porém, morreram antes de seu pai e não deixaram filhos. Eleazar e Itamar tornaram-se sacerdotes."
,"3":"David, juntamente com Sadoc, filho de Eleazar, e com Aquimelec, filho de Itamar, dividiu-os em classes, de acordo com as funções de cada um."
,"4":"Havia mais descendentes de Eleazar do que de Itamar. Por isso, foram assim classificados: dezasseis chefes de famílias de Eleazar, e oito de Itamar."
,"5":"Tanto uns como outros foram distribuídos por sorteio, de forma que havia oficiais do Santuário e oficiais de Deus, tanto na família de Eleazar como na família de Itamar."
,"6":"Semeías, secretário levita, filho de Natanael, registou-os na presença do rei, dos oficiais, do sacerdote Sadoc, de Aquimelec, filho de Abiatar, dos chefes de famílias, dos sacerdotes e dos levitas. Tirava-se a sorte, uma vez para a família de Eleazar e duas vezes para a família de Itamar."
,"7":"O primeiro a ser sorteado foi Joiarib; o segundo, Jedeías;"
,"8":"o terceiro, Harim; o quarto, Seorim;"
,"9":"o quinto, Melquias; o sexto, Mainã;"
,"10":"o sétimo, Acos; o oitavo, Abias;"
,"11":"o nono, Jesua; o décimo, Sequenias;"
,"12":"o décimo primeiro, Eliasib; o décimo segundo, Jacim;"
,"13":"o décimo terceiro, Hofa; o décimo quarto, Isbaal;"
,"14":"o décimo quinto, Belga; o décimo sexto, Emer;"
,"15":"o décimo sétimo, Hezir; o décimo oitavo, Hafses;"
,"16":"o décimo nono, Fetatias; o vigésimo, Ezequiel;"
,"17":"o vigésimo primeiro, Jaquin; o vigésimo segundo, Gamul;"
,"18":"o vigésimo terceiro, Dalaías; o vigésimo quarto, Maazias."
,"19":"Esta era a escala dos que prestavam serviço dentro do Templo de Javé, conforme as determinações dadas pelo seu antepassado Aarão, por ordem de Javé, o Deus de Israel."
,"20":"Quanto aos outros descendentes de Levi, os chefes eram estes: Subael, da família de Amram; Jeedias, da família de Subael."
,"21":"Da família de Roobias, o chefe era Jesias."
,"22":"Da família de Isaar, o chefe era Solomot. Da família de Solomot, o chefe era Jaat."
,"23":"Da família de Hebron: Jerias, o primeiro; Amarias, o segundo; Jaaziel, o terceiro; Jecmaam, o quarto."
,"24":"Da família de Oziel, Micas. Da família de Micas, Samir."
,"25":"Da família de Jesias, irmão de Micas, o chefe era Zacarias."
,"26":"Filhos de Merari: Mooli e Musi. Jazias também era seu filho."
,"27":"Descendentes de Merari, por parte de Jazias: Soam, Zacur e Hebri."
,"28":"Mooli foi pai de Eleazar, que não deixou filhos."
,"29":"Cis teve um filho: Jerameel."
,"30":"Filhos de Musi: Mooli, Éder e Jerimot. Esta era a descendência de Levi, dividida por famílias. "
,"31":"Da mesma forma como os seus irmãos da família de Aarão, estes também tiraram a sorte na presença do rei David, de Sadoc, de Aquimelec e dos chefes de famílias sacerdotais e levíticas. Foi a mesma coisa, tanto para as famílias principais dos levitas, como para as famílias menores."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Para o serviço do culto, David e os directores do culto destacaram os filhos de Asaf, de Emã e de Iditun, profetas que se serviam de liras, cítaras e címbalos. Lista das pessoas empregadas nesta tarefa:"
,"2":"Da família de Asaf: Zacur, José, Natanias e Asarela. Eles dependiam de Asaf, que executava a música segundo as instruções do rei."
,"3":"Da família de Iditun: Godolias, Sori, Jesaías, Hasabias e Matatias. Eram seis sob a direcção de seu pai Iditun. Este, ao som de liras, profetizava para celebrar e louvar a Javé."
,"4":"Da família de Emã: Bocias, Matanias, Oziel, Subael, Jerimot, Hananias, Hanani, Eliata, Gedelti, Romenti-Ezer, Jesbacasa, Meiloti, Otir e Maaziot."
,"5":"Eram todos filhos de Emã, o vidente do rei, a quem ele transmitia a palavra de Deus. Para lhe exaltar o poder, Deus deu a Emã catorze filhos e três filhas."
,"6":"Sob a direcção do pai, todos eles participavam nos cânticos do Templo de Javé, ao som de címbalos, cítaras e liras, prestando serviço no Templo de Deus sob as ordens do rei. Asaf, Iditun e Emã, "
,"7":"que tinham aprendido a cantar a Javé, foram contados com os seus parentes. Eram duzentos e oitenta e oito, todos hábeis no seu ofício."
,"8":"Deitaram sortes para a escala do serviço, com iguais oportunidades para grandes e pequenos, para experientes e principiantes."
,"9":"A sorte caiu primeiro na família de Asaf: O primeiro foi José; com seus filhos e irmãos, eram doze. O segundo foi Godolias; com seus filhos e irmãos, eram doze."
,"10":"O terceiro foi Zacur; com seus filhos e irmãos, eram doze."
,"11":"O quarto foi Isari; com seus filhos e irmãos, eram doze."
,"12":"O quinto foi Natanias; com seus filhos e irmãos, eram doze."
,"13":"O sexto foi Bocias; com seus filhos e irmãos, eram doze."
,"14":"O sétimo foi Isreela; com seus filhos e irmãos, eram doze."
,"15":"O oitavo foi Jesaías; com seus filhos e irmãos, eram doze."
,"16":"O nono foi Matanias; com seus filhos e irmãos, eram doze."
,"17":"O décimo foi Semei; com seus filhos e irmãos, eram doze."
,"18":"O décimo primeiro foi Azareel; com seus filhos e irmãos, eram doze."
,"19":"O décimo segundo foi Hasabias; com seus filhos e irmãos, eram doze."
,"20":"O décimo terceiro foi Subael; com seus filhos e irmãos, eram doze."
,"21":"O décimo quarto foi Matatias; com seus filhos e irmãos, eram doze."
,"22":"O décimo quinto foi Jerimot; com seus filhos e irmãos, eram doze."
,"23":"O décimo sexto foi Hananias; com seus filhos e irmãos, eram doze."
,"24":"O décimo sétimo foi Jesbacasa; com seus filhos e irmãos, eram doze."
,"25":"O décimo oitavo foi Hanani; com seus filhos e irmãos, eram doze."
,"26":"O décimo nono foi Meiloti; com seus filhos e irmãos, eram doze."
,"27":"O vigésimo foi Eliata; com seus filhos e irmãos, eram doze."
,"28":"O vigésimo primeiro foi Otir; com seus filhos e irmãos, eram doze."
,"29":"O vigésimo segundo foi Gedelti; com seus filhos e irmãos, eram doze."
,"30":"O vigésimo terceiro foi Maaziot; com seus filhos e irmãos, eram doze."
,"31":"O vigésimo quarto foi Romenti-Ezer; com seus filhos e irmãos, eram doze."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Lista dos porteiros: Da descendência de Meselemias, filho de outro Coré, que era descendente de Abiasaf."
,"2":"Filhos de Meselemias: o primeiro, Zacarias; o segundo, Jediel; o terceiro, Zabadias; o quarto, Jatanael;"
,"3":"o quinto, Elam; o sexto, Joanã; o sétimo, Elioenai."
,"4":"Filhos de Obed-Edom: Semeías, o mais velho; Jozabad, o segundo; Joaá, o terceiro; Sacar, o quarto; Natanael, o quinto;"
,"5":"Amiel, o sexto; Issacar, o sétimo; Folati, o oitavo, porque Deus o havia abençoado."
,"6":"Os filhos que Semeías teve foram chefes de famílias, pois eram homens valentes."
,"7":"Filhos de Semeías: Otni, Rafael, Obed, Elzabad e mais dois irmãos: Eliú e Samaquias. Todos homens de valor."
,"8":"E todos eles faziam parte da descendência de Obed-Edom. Com seus filhos e suas famílias, eram sessenta e dois descendentes de Obed-Edom, e eram todos competentes na sua função."
,"9":"Os filhos e irmãos de Meselemias eram dezoito homens valentes."
,"10":"Hosa, filho de Merari, teve os seguintes filhos: o primeiro, Semri, que, mesmo não sendo o mais velho, o seu pai fez dele o chefe;"
,"11":"Helcias, o segundo; Tebelias, o terceiro; Zacarias, o quarto. Os filhos e irmãos de Hosa eram treze homens ao todo."
,"12":"Estes grupos de porteiros, tanto os chefes como os irmãos, foram encarregados do serviço do Templo de Javé."
,"13":"Para cuidar de cada porta, eles deitaram sortes pelas famílias, quer fossem pequenas quer grandes."
,"14":"O lado do Nascente coube em sorte a Selemias, cujo filho Zacarias dava conselhos prudentes. Deitaram as sortes e o lado Norte coube a Zacarias."
,"15":"Para Obed-Edom, coube em sorte o lado Sul, enquanto que para seus filhos ficou a casa dos armazéns."
,"16":"Para Sefim e para Hosa, coube o lado Oeste, com a porta do Tronco Abatido, na ladeira. Os turnos da guarda eram proporcionais."
,"17":"Estavam assim organizados: seis por dia, do lado do Nascente; quatro ao Norte e quatro ao Sul; na casa dos armazéns, dois de cada lado;"
,"18":"e, no lado Oeste, onde havia uma sacada, ficavam quatro na rua e dois na sacada."
,"19":"Eram estas as classes dos porteiros, descendentes de Coré e Merari."
,"20":"Os seus irmãos levitas eram responsáveis pelo tesouro do Templo de Deus e por todas as ofertas votivas."
,"21":"Eram eles: Os filhos de Leedã que, através dele, eram descendentes de Gérson. Os seus chefes de famílias eram do ramo de Jaiel."
,"22":"Da família de Jaiel, Zatam e Joel, que eram tesoureiros do Templo de Javé."
,"23":"Havia também gente das famílias de Amram, Isaar, Hebron e Oziel."
,"24":"Subael, da descendência de Gérson, filho de Moisés, era chefe do tesouro."
,"25":"Havia também outros irmãos deles, descendentes de Eliezer: Roobias, Isaías, Jorão, Zecri e Salomit."
,"26":"Salomit, com os seus irmãos, era responsável pela guarda de tudo o que fora consagrado pelo rei David, pelos chefes de grupos familiares, pelos comandantes de mil e de cem e pelos oficiais do exército."
,"27":"Eram despojos de guerra doados por eles a fim de reforçar o tesouro do Templo de Javé,"
,"28":"e tudo o que fora doado pelo vidente Samuel, por Saul, filho de Cis, por Abner, filho de Ner, e por Joab, filho de Sárvia. Tudo o que se consagrava era confiado a Salomit e seus irmãos."
,"29":"Conenias e seus filhos, descendentes de Isaar, eram encarregados dos assuntos profanos que se referiam aos israelitas, como oficiais de justiça e juízes."
,"30":"Hasabias e seus irmãos, descendentes de Hebron, um total de mil e setecentos soldados, cuidavam da segurança de Israel do lado de lá do rio Jordão, a partir da planície; cuidavam dos interesses de Javé e do serviço do rei."
,"31":"O chefe dos descendentes de Hebron era Jerias. No ano quarenta do reinado de David, foi feita uma pesquisa sobre a árvore genealógica dos hebronitas e encontrou-se entre eles gente de armas em Jazer de Galaad."
,"32":"Essa família contava com dois mil e setecentos chefes de família guerreiros. Foi a eles que o rei David confiou as tribos de Rúben e Gad e a meia tribo de Manassés, para os afazeres de Deus e os assuntos do rei."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Aqui está a organização dos israelitas segundo o seu número, chefes de famílias, comandantes de mil e de cem, oficiais ao serviço do rei, para qualquer assunto. Durante o ano inteiro, faziam turnos de mês a mês. E cada classe compreendia vinte e quatro mil homens."
,"2":"Jesboam, filho de Zabdiel, estava à frente da primeira classe, responsável pelo primeiro mês. Esta classe tinha vinte e quatro mil homens."
,"3":"Ele era descendente de Farés e chefe dos oficiais de todo o primeiro mês."
,"4":"Dudi, filho de Aoé, comandava a classe encarregada do segundo mês. Esta classe tinha vinte e quatro mil homens."
,"5":"O chefe da terceira classe, nomeada para o terceiro mês, era Banaías, filho do sacerdote-chefe Joiada. Respondia por uma classe de vinte e quatro mil homens."
,"6":"Banaías era um dos trinta valentes. Ele respondia pelos Trinta e também pela sua classe. Amizabab era o nome do seu filho."
,"7":"Azael, irmão de Joab, estava encarregado do quarto mês. Seu filho Zabadias ficou em seu lugar. A classe era também de vinte e quatro mil homens."
,"8":"Samaot, da descendência de Zaré, foi o oficial nomeado para o quinto mês. A sua classe tinha vinte e quatro mil homens."
,"9":"Para o sexto mês foi nomeado Hira, filho de Aces, do povoado de Técua. Também a sua classe tinha vinte e quatro mil homens."
,"10":"O sétimo, encarregado do sétimo mês, era Heles, da descendência de Falet, da família de Efraim. A sua classe era de vinte e quatro mil homens."
,"11":"Sobocai, do povoado de Husa, da descendência de Zaré, foi encarregado do oitavo mês, com uma classe de vinte e quatro mil homens."
,"12":"Para o nono mês, foi nomeado Abiezer, da tribo de Benjamim e da cidade de Anatot. Chefiava também vinte e quatro mil homens."
,"13":"Marai, da descendência de Zaré e da cidade de Netofa, ficou em décimo lugar, nomeado para o décimo mês. A sua classe tinha também vinte e quatro mil homens."
,"14":"Para o décimo primeiro mês, o chefe era Banaías, da família de Faraton, filho de Efraim. A sua classe era de vinte e quatro mil homens."
,"15":"Em décimo segundo lugar, para cobrir o último mês, foi nomeado Holdai, da cidade de Netofa de Otoniel, com uma classe de vinte e quatro mil homens."
,"16":"Chefes das tribos de Israel: Da tribo de Rúben, o chefe era Eliezer, filho de Zecri. Da tribo de Simeão, era Safatias, filho de Maaca."
,"17":"Da tribo de Levi, era Hasabias, filho de Camuel. De Aarão era Sadoc."
,"18":"Eliú, irmão de David, comandava a tribo de Judá. Amri, filho de Miguel, comandava a de Issacar."
,"19":"Jesmaías, filho de Abdias, comandava a de Zabulon. O chefe da tribo de Neftali era Jerimot, filho de Ozriel."
,"20":"Da tribo de Efraim, era Oseias, filho de Ozazias. Da meia-tribo de Manassés, era Joel, filho de Fadaías."
,"21":"Da outra meia-tribo de Manassés, que vivia em Galaad, o chefe era Jado, filho de Zacarias. Da tribo de Benjamim, era Jesiel, filho de Abner."
,"22":"Finalmente, a tribo de Dã tinha como chefe Ezriel, filho de Jeroam. Eram estes os chefes das tribos de Israel."
,"23":"David não mandou fazer o recenseamento das pessoas de vinte anos para baixo, porque o próprio Javé tinha dito que multiplicaria os israelitas como as estrelas do céu."
,"24":"Joab, filho de Sárvia, começou o recenseamento, mas não o terminou, porque a ira caiu sobre Israel e, assim, esse número não corresponde ao número que está nos Anais do rei David."
,"25":"O responsável pelas provisões do rei era Azmot, filho de Adiel. O responsável pelas provisões na zona rural, nas cidades, povoados e fortalezas da província, era Jónatas, filho de Ozias."
,"26":"O responsável pelos lavradores e agricultores era Ezri, filho de Quelub."
,"27":"O responsável pelos vinhedos era Semei, do povoado de Ramá. O responsável pelos encarregados dos depósitos de vinho nos vinhedos era Zabdi, do povoado de Sefam."
,"28":"O responsável pelas oliveiras e sicômoros da Planície era Baalanã, do povoado de Gader. O responsável pelas reservas de azeite era Joás."
,"29":"O responsável pelo gado que pastava em Saron era Setrai, do povoado de Saron; o responsável pelo gado nos vales era Safat, filho de Adli."
,"30":"O responsável pelos camelos era Ubil, o ismaelita. O responsável pelas jumentas era Jadias, do povoado de Meranot."
,"31":"O responsável pelas ovelhas era Jaziz, o agareno. Eram estes os responsáveis pelos bens que pertenciam ao rei."
,"32":"Jónatas, tio de David, bom conselheiro, homem ponderado e culto, e Jaiel, filho de Hacamon, cuidavam dos filhos do rei."
,"33":"Aquitofel era conselheiro do rei. O araquita Cusai era o amigo do rei."
,"34":"Joiada, filho de Banaías, e Abiatar, sucederam a Aquitofel. Joab era o comandante dos exércitos do rei."
}`)
	CurrentBook.AddChapter(28, `{
"1":"David convocou em Jerusalém todas as autoridades de Israel, a saber: chefes de tribos, chefes das classes que serviam o rei, comandantes de mil e de cem, chefes de todos os bens e rebanhos do rei e dos seus filhos, os altos funcionários do palácio, os valentes e todos os guerreiros."
,"2":"David ficou de pé e tomou a palavra: «Irmãos e povo meu, escutai-me um pouco. Eu tinha a intenção de construir um Templo para ser a moradia da Arca da Aliança de Javé e que servisse de pedestal para o nosso Deus. Cheguei até a fazer os preparativos para a construção."
,"3":"Deus, porém, disse-me: 'Não és tu quem vai construir um Templo para o meu Nome, pois tu foste guerreiro e derramaste muito sangue'."
,"4":"Javé, o Deus de Israel, escolheu-me do meio de toda a minha família para ser rei de Israel para sempre. De facto, escolheu Judá como tribo-chefe. Dentro de Judá, escolheu a família de meu pai e, entre meus irmãos, escolheu-me a mim, para me fazer rei de todo o Israel."
,"5":"Entre os muitos filhos que Javé me deu, Ele escolheu Salomão para que ocupe o trono real de Javé sobre Israel."
,"6":"Javé disse-me: 'O teu filho Salomão construirá a minha residência e os meus átrios, pois Eu o escolhi como filho, e serei um pai para ele."
,"7":"Vou firmar o seu reino para sempre, se ele for fiel em praticar os meus mandamentos e normas, como tem feito até hoje'."
,"8":"Portanto, na presença de todo o Israel, a comunidade de Javé, tomando o nosso Deus como testemunha, guarde e pro-cure seguir todos os mandamentos de Javé, seu Deus, para que conserve a posse desta terra boa e a deixe como herança aos seus filhos, para sempre."
,"9":"Quanto a ti, Salomão, meu filho, reconhece o Deus de teu pai e serve-O de todo o coração e com generosidade de espírito, pois Javé sonda todos os corações e penetra todas as intenções do espírito. Se O procurares, Ele deixar-Se-á encontrar. Mas, se O abandonares, Ele afas-tar-Se-á para sempre."
,"10":"Vê bem! Javé escolheu-te para Lhe construíres um santuário. Coragem e mãos à obra!»"
,"11":"David entregou a seu filho Salomão o projecto do pórtico e do Templo, dos armazéns, das salas superiores, dos aposentos internos e da sala do propiciatório."
,"12":"Entregou também o projecto de tudo o que tinha em mente para os átrios do Templo de Javé, para as alas ao redor, para os tesouros do Templo de Deus e para as ofertas votivas."
,"13":"Entregou também o projecto para as classes de sacerdotes e levitas, para os serviços do culto no Templo e para os utensílios do Templo de Javé."
,"14":"Deixou também programada a quantidade de ouro que cada objecto de ouro deveria ter, conforme a sua serventia, e a quantidade de prata que, de acordo com a sua utilização, cada objecto de prata deveria ter."
,"15":"Entregou o desenho dos candelabros de ouro e de prata e das respectivas lâmpadas, determinando, conforme a finalidade de cada um, a quantidade de ouro ou prata que deveria ter."
,"16":"Deixou também marcada a quantidade de ouro para as mesas de ouro, que serviriam para os pães consagrados, como também a prata que se deveria empregar nas mesas de prata,"
,"17":"os garfos, as taças para a aspersão, as ânforas de ouro puro, a quantidade de ouro para cada tipo de taça."
,"18":"Também determinou a quantidade de ouro refinado que o altar do incenso deveria ter. Deu-lhe o modelo do carro dos querubins de ouro, que cobriam com as suas asas a Arca da Aliança de Javé."
,"19":"Tudo isso estava num escrito que Javé havia entregado a David, explicando a fabricação do modelo."
,"20":"Então David disse a seu filho Salomão: «Força! Coragem! Mãos à obra! Nada de medo ou receio, pois Javé Deus, o meu Deus, está contigo. Ele não te vai deixar nem abandonar, enquanto não terminares o serviço de construção do Templo de Javé."
,"21":"Aqui estão as classes de sacerdotes e levitas, para todo o serviço do Templo de Deus. Todos os profissionais de qualquer especialidade te ajudarão nessa obra. Os chefes e todo o povo estarão às tuas ordens»."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Depois David falou a toda a assembleia: «O meu filho Salomão, que Deus escolheu, é jovem e fraco. E a missão dele é grande, porque não se trata de construir uma casa para nenhum homem, mas um Templo para Javé Deus."
,"2":"Por isso, fui fazendo os preparativos, conforme pude: ouro, para os objectos de ouro; prata, para os objectos de prata; bronze, para os objectos de bronze; ferro, para os objectos de ferro; madeira para toda a mobília, pedras de ónix e de engastar, pedras ornamentais e coloridas, todo o tipo de pedra preciosa e muito alabastro."
,"3":"Por amor ao Templo do meu Deus, além de tudo o que preparei para o Santuário, entreguei também os meus tesouros em ouro e prata:"
,"4":"cem toneladas de ouro, ouro de Ofir, e duzentas e quarenta toneladas de prata refinada para revestir as paredes das salas,"
,"5":"para os objectos de ouro e prata e para o trabalho dos ourives. E pergunto: Quem está disposto a fazer hoje um donativo a Javé?»"
,"6":"Então os chefes de famílias, os chefes das tribos de Israel, os comandantes de mil e de cem, e os chefes de obras do rei prontificaram-se a fazer ofertas."
,"7":"Deram para a construção do Templo de Deus cento e setenta toneladas de ouro, dez mil moedas, trezentas e quarenta toneladas de prata, seiscentas toneladas de bronze e três mil e quatrocentas toneladas de ferro."
,"8":"Quem tinha pedras preciosas ofereceu-as também ao tesouro do Templo de Javé, confiando-as a Jaiel, descendente de Gérson."
,"9":"O povo, cheio de generosidade, alegrava-se em oferecer algo a Javé. Também David ficou muito contente."
,"10":"Então David bendisse a Javé diante de toda a assembleia. Ele disse: «Bendito sejas Tu, Javé, Deus do nosso pai Israel, desde sempre e para sempre."
,"11":"A Ti, Javé, pertencem a grandeza, o poder, o esplendor, a majestade e a glória, pois tudo o que existe no céu e na terra Te pertence. Teu é o reino, e a Ti cabe elevar-se como soberano acima de tudo."
,"12":"A riqueza e a glória vêm de Ti. E Tu governas todas as coisas. Na tua mão está a força e o vigor. Na tua mão está o poder de engrandecer e fortificar todas as coisas."
,"13":"E agora, Deus nosso, nós Te agradecemos e louvamos o teu Nome glorioso."
,"14":"Quem sou eu, e quem é o meu povo para podermos oferecer-Te tudo isto? Tudo vem de Ti, e a Ti ofertamos o que de tuas mãos recebemos."
,"15":"Todos nós, diante de Ti, somos imigrantes e estrangeiros, como foram todos os nossos antepassados. A nossa vida na Terra é apenas uma sombra sem esperança."
,"16":"Javé, nosso Deus, tudo o que preparámos para construir um Templo em honra do teu Nome, veio das tuas mãos e pertence-Te."
,"17":"Eu sei, ó meu Deus, que sondas o coração e amas a rectidão. E com recta intenção Te ofereço tudo isto, e vejo com alegria o teu povo aqui reunido, fazendo-Te as suas ofertas."
,"18":"Javé, Deus dos nossos antepassados Abraão, Isaac e Israel, conserva sempre no coração do teu povo esta disposição e sentimento. Mantém o seu coração fiel a Ti."
,"19":"A meu filho Salomão, concede um coração íntegro, para que pratique os teus mandamentos, as tuas ordens e leis, e para que construa este Templo que projectei para Ti»."
,"20":"Por fim, David disse à assembleia: «Bendizei todos a Javé, vosso Deus!». E toda a assembleia bendisse a Javé, Deus dos seus antepassados. E, prostrando-se, prestaram homenagem a Javé e ao rei."
,"21":"No dia seguinte, ofereceram a Javé sacrifícios e holocaustos. Foram sacrificados mil bois, mil carneiros e mil cordeiros, com as respectivas libações de vinho e numerosos sacrifícios por todo o Israel."
,"22":"Nesse dia, todos comeram e beberam com grande alegria na presença de Javé. Entronizaram pela segunda vez Salomão, filho de David, e ungiram-no como chefe em nome de Javé. Ungiram também Sadoc como sacerdote."
,"23":"Salomão sentou-se no trono de Javé, em lugar de seu pai David, e teve êxito. Todo o Israel lhe obedeceu."
,"24":"Todos os chefes, todos os valentes e todos os filhos de David se submeteram ao rei Salomão."
,"25":"Javé engrandeceu e aumentou o prestígio de Salomão aos olhos do povo de Israel, dando ao seu reinado um brilho como nunca tinha acontecido com qualquer outro rei antes dele em Israel."
,"26":"David, filho de Jessé, foi rei de todo o Israel."
,"27":"Reinou quarenta anos: sete em Hebron e trinta e três em Jerusalém."
,"28":"Por fim, morreu numa velhice feliz, tendo vivido muitos anos e tendo ficado rico e famoso. O seu filho Salomão foi seu sucessor no trono."
,"29":"A história do rei David, do começo ao fim, está escrita na história do vidente Samuel, na história do profeta Natã e do vidente Gad."
,"30":"Ali se encontra tudo o que se refere ao seu reinado e às suas guerras, e tudo o que aconteceu com ele, com Israel e com todos os reinos vizinhos."
}`)

}
func PT_BS_LoadVH1RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"O rei David ficou velho, com idade avançada; por mais que o cobrissem, ele não se aquecia."
,"2":"Os seus servos então sugeriram: «Procurai uma jovem solteira que dê assistência e cuide do senhor nosso rei: ela dormirá em seus braços, e o senhor nosso rei aquecer-se-á»."
,"3":"Então procuraram uma jovem bonita em todo o território de Israel. Encontraram Abisag, de Sunam, e levaram-na ao rei."
,"4":"A jovem era muito bela. Passou a cuidar do rei e a servi-lo. Mas o rei não teve relações com ela."
,"5":"Entretanto, Adonias, filho de Hagit, gabava-se dizendo: «Sou eu que vou reinar». Arranjou um carro e cavalos, além de uma escolta de cinquenta guardas, que caminhavam à sua frente."
,"6":"Enquanto vivia, o seu pai nunca o repreendeu, perguntando: «Porque fazes isto?» Adonias também era muito belo, mais jovem do que Absalão."
,"7":"Ele entrou em acordo com Joab, filho de Sárvia, e com o sacerdote Abiatar, que aderiram ao partido de Adonias."
,"8":"Por outro lado, o sacerdote Sadoc, Banaías, filho de Joiada, o profeta Natã, Semei e Reí, bem como os valentes de David, não estavam do lado de Adonias."
,"9":"Certa vez, Adonias imolou ovelhas, bois e bezerros gordos junto à Pedra-que-escorrega, perto da fonte do Pisoeiro. Convidou todos os seus irmãos, os filhos do rei, e todos os homens de Judá que estavam ao serviço do rei."
,"10":"Mas não convidou o profeta Natã, nem Banaías, nem os valentes de David, nem o seu próprio irmão Salomão."
,"11":"Natã disse então a Betsabeia, mãe de Salomão: «Já soubeste que Adonias, filho de Hagit, se proclamou rei, sem o nosso senhor David saber?"
,"12":"Vê bem: agora eu vou dar-te um conselho, para que salves a tua vida e a do teu filho Salomão."
,"13":"Vai ter com o rei David e diz-lhe: 'O senhor meu rei jurou à sua serva, dizendo: O teu filho Salomão reinará depois de mim e sentar-se-á no meu trono. Então, porque é que Adonias se proclamou rei?'"
,"14":"Enquanto estiveres lá a falar com o rei, eu entrarei e apoiarei as tuas palavras»."
,"15":"Betsabeia entrou no quarto do rei. O rei estava muito velho, e Abisag, de Sunam, servia-o."
,"16":"Betsabeia ajoelhou-se e prostrou-se diante do rei. E o rei perguntou-lhe: «Que queres?»"
,"17":"Betsabeia respondeu: «Meu senhor, juraste à tua serva, por Javé teu Deus: Quem vai reinar depois de mim e sentar-se no meu trono é o teu filho Salomão»."
,"18":"Ora, acontece que Adonias já se proclamou rei, sem conhecimento do rei, meu senhor."
,"19":"Ele imolou muitos bois, bezerros gordos e ovelhas, e convidou todos os filhos do rei, o sacerdote Abiatar e Joab, chefe do exército, mas não convidou o teu servo Salomão."
,"20":"Senhor meu rei, é em ti que todo o Israel tem postos os olhos, esperando que lhe anuncies quem vai sentar-se no trono depois de ti, senhor meu rei."
,"21":"Caso contrário, quando o senhor meu rei estiver a repousar com os seus antepassados, eu e o meu filho Salomão seremos considerados como usurpadores»."
,"22":"Betsabeia ainda estava a falar com o rei quando chegou o profeta Natã."
,"23":"E anunciaram ao rei: «O profeta Natã está aqui». Então Natã apresentou-se ao rei, prostrou-se diante dele com o rosto por terra,"
,"24":"e disse: «Senhor meu rei, acaso disseste: 'Adonias é quem vai reinar depois de mim e sentar-se no meu trono'?"
,"25":"Pois bem: hoje ele foi imolar muitos bois, bezerros gordos e ovelhas. Convidou todos os filhos do rei, os oficiais do exército e o sacerdote Abiatar. Todos estão a comer e a beber com ele, e aclamando: Viva o rei Adonias!"
,"26":"Mas ele não convidou este teu servo, nem o sacerdote Sadoc, nem Banaías, filho de Joiada, nem o teu servo Salomão."
,"27":"Será que foi o senhor meu rei quem o ordenou? Porque não deste a conhecer aos teus servos quem iria suceder no trono ao senhor meu rei?»"
,"28":"Então o rei David respondeu: «Chamai Betsabeia aqui». E Betsabeia apresentou-se ao rei e ficou de pé."
,"29":"Então o rei jurou: «Pela vida de Javé, que me livrou de todos os perigos,"
,"30":"eu jurei-te por Javé, o Deus de Israel: Quem vai reinar depois de mim e sentar-se no meu trono é o teu filho Salomão. Pois bem: hoje mesmo eu vou cumpri-lo»."
,"31":"Betsabeia ajoelhou-se com o rosto por terra, prostrou-se diante do rei e disse: «Viva o rei David, meu senhor, para sempre!»"
,"32":"Então o rei David ordenou: «Chamai o sacerdote Sadoc, o profeta Natã e Banaías, filho de Joiada». Eles apresentaram-se,"
,"33":"e o rei disse-lhes: «Tomai convosco os oficiais do rei. Fazei montar o meu filho Salomão na minha própria mula, e descei com ele até Gion."
,"34":"Ali o sacerdote Sadoc e o profeta Natã ungi-lo-ão rei de Israel, e vós tocareis a trombeta, aclamando: Viva o rei Salomão!"
,"35":"Depois subi atrás dele. Quando ele chegar, sentar-se-á no meu trono e reinará em meu lugar, pois é a ele que eu nomeio chefe de Israel e de Judá»."
,"36":"Banaías, filho de Joiada, respondeu ao rei: «Assim seja! Javé, Deus do meu senhor, confirme a ordem do rei."
,"37":"Javé esteja com Salomão, assim como esteve com o senhor meu rei, e torne o trono de Salomão mais glorioso do que o trono do rei David, meu senhor»."
,"38":"Então o sacerdote Sadoc, o profeta Natã, Banaías, filho de Joiada, os cereteus e os feleteus, desceram até Gion, levando Salomão, que ia montado na mula do rei David."
,"39":"O sacerdote Sadoc tomou da tenda o chifre de óleo e ungiu Salomão. Depois tocaram a trombeta. E todos aclamaram: «Viva o rei Salomão!»"
,"40":"Em seguida, todo o povo subiu atrás de Salomão, tocando flautas e fazendo tamanho barulho, que a terra tremia com os gritos."
,"41":"Adonias e seus convidados estavam a acabar de comer, quando ouviram o barulho. Joab ouviu o toque da trombeta e perguntou: «Porquê esse barulho e essa algazarra na cidade?»"
,"42":"Ainda ele estava a acabar de perguntar, quando chegou Jónatas, filho do sacerdote Abiatar. E Adonias disse: «Entra, pois és uma pessoa honesta, e certamente trazes boas notícias»."
,"43":"Jónatas respondeu: «Infelizmente não! O senhor nosso rei David acaba de proclamar Salomão como rei!"
,"44":"E com ele o rei mandou o sacerdote Sadoc, o profeta Natã, Banaías, filho de Joiada, e também os cereteus e feleteus, que o fizeram montar na mula do rei."
,"45":"Depois o sacerdote Sadoc e o profeta Natã ungiram Salomão rei em Gion, e regressaram de lá cheios de alegria. A cidade está em festa. É este o barulho que estais ouvindo."
,"46":"Salomão já está sentado no trono real,"
,"47":"e os oficiais do rei já foram cumprimentar David, nosso rei e senhor, dizendo: 'Que o teu Deus torne o nome de Salomão mais famoso que o teu, e engrandeça o trono dele mais que o teu'. Então o rei prostrou-se na cama,"
,"48":"e disse: 'Seja bendito Javé, o Deus de Israel! Porque hoje Ele colocou alguém sentado no meu trono, e os meus olhos puderam vê-lo!'»"
,"49":"Os convidados de Adonias ficaram apavorados, levantaram-se e dispersaram-se."
,"50":"Adonias, com medo de Salomão, levantou-se e foi agarrar-se às pontas do altar."
,"51":"E informaram Salomão: «Adonias ficou com medo de ti e está agarrado às pontas do altar, suplicando: 'Que o rei Salomão me jure hoje que não mandará matar o seu servo ao fio da espada'»."
,"52":"Salomão disse: «Se ele se comportar honestamente, não cairá por terra nem um só dos seus cabelos; mas, se for apanhado a maquinar traição, morrerá»."
,"53":"E o rei Salomão enviou gente para fazer descer Adonias do altar. Adonias foi e prostrou-se diante do rei Salomão, que lhe disse: «Vai para casa»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Aproximando-se o dia da sua morte, David ordenou a seu filho Salomão:"
,"2":"«Eu vou seguir o caminho de todos os mortais. Sê forte e comporta-te como homem."
,"3":"Cumpre as ordens de Javé, teu Deus, andando pelos seus caminhos e observando os seus estatutos, mandamentos, normas e testemunhos, como estão escritos na lei de Moisés, para que tenhas sucesso em tudo o que fizeres e projectares."
,"4":"Então Javé cumprirá o que me prometeu: 'Se os teus filhos mantiverem boa conduta e forem leais comigo, de todo o coração e de toda a alma, nunca faltará alguém da tua família no trono de Israel'."
,"5":"Por outro lado, tu sabes o que me fez Joab, filho de Sárvia: ele matou Abner, filho de Ner, e Amasa, filho de Jeter, os dois chefes do exército de Israel. Em tempo de paz, ele vingou o sangue derramado na guerra, manchando assim de sangue inocente o cinturão dos meus rins e a sandália dos meus pés."
,"6":"Portanto, age com sabedoria, mas não deixes que os seus cabelos brancos desçam em paz à morada dos mortos."
,"7":"Quanto aos filhos de Berzelai, o galaadita, trata-os com lealdade. Que estejam sempre entre os que comem à tua mesa, porque eles também foram leais comigo e ajudaram-me quando eu fugia do teu irmão Absalão."
,"8":"Também tens contigo Semei, filho de Gera, o benjaminita de Baurim. Ele amaldiçoou-me com violência no dia da minha partida para Maanaim. No entanto, ele desceu ao meu encontro no Jordão. Por isso eu jurei por Javé que não o mataria ao fio da espada."
,"9":"Agora, não o deixes impune: tu és sábio e saberás como o hás-de tratar para que os seus cabelos brancos desçam com sangue à morada dos mortos»."
,"10":"David repousou com os seus antepassados e foi enterrado na Cidade de David."
,"11":"David foi rei em Israel durante quarenta anos; reinou sete anos em Hebron, e trinta e três anos em Jerusalém."
,"12":"Salomão sucedeu no trono a seu pai David, e o seu reinado consolidou-se."
,"13":"Adonias, filho de Hagit, foi conversar com Betsabeia, mãe de Salomão. Ela perguntou: «A tua visita é de paz?» Ele respondeu: «Sim, é de paz»."
,"14":"E continuou: «Eu desejo pedir-te uma coisa». Ela disse: «O que é que queres?»"
,"15":"Então Adonias disse: «Tu sabes muito bem que a realeza me pertencia e que todo o Israel esperava que eu fosse rei, mas a realeza escapou-me e foi dada ao meu irmão, porque Javé a tinha destinado a ele."
,"16":"Agora peço-te um favor. Não mo recuses». Betsabeia respondeu: «Podes falar»."
,"17":"Adonias continuou: «Por favor, pede ao rei Salomão que me dê Abisag de Sunam como esposa. Ele não te negará nada»."
,"18":"Betsabeia respondeu: «Está bem. Vou falar com o rei sobre o assunto»."
,"19":"Betsabeia foi ter com o rei Salomão para lhe falar sobre Adonias. O rei levantou-se para a receber e inclinou-se diante dela. Depois sentou-se no trono, mandou trazer um trono para sua mãe, e Betsabeia sentou-se à sua direita."
,"20":"Então Betsabeia disse: «Vou pedir-te um pequeno favor. Não mo negues». Salomão respondeu: «Podes pedir, mãe. Não to negarei»."
,"21":"Ela continuou: «Dá Abisag de Sunam como esposa ao teu irmão Adonias»."
,"22":"Mas o rei Salomão respondeu: «Porque pedes que Abisag de Sunam seja dada a Adonias? Também podias pedir para ele a coroa! Afinal, ele é meu irmão mais velho, e tem do seu lado o sacerdote Abiatar e Joab, filho de Sárvia!»"
,"23":"Em seguida, o rei Salomão jurou por Javé: «Que Deus me castigue, se Adonias não pagar com a própria vida pelo pedido que fez."
,"24":"Pela vida de Javé, que me fez sentar firmemente no trono de meu pai David e que lhe deu uma dinastia como havia prometido, hoje mesmo Adonias será morto»."
,"25":"Então o rei Salomão deu uma ordem, e Banaías, filho de Joiada, matou Adonias."
,"26":"Salomão disse ao sacerdote Abiatar: «Vai para a tua propriedade em Anatot. Tu mereces a morte, mas não vou matar-te hoje, porque transportaste a arca de Javé diante de meu pai David e partilhaste dos seus sofrimentos»."
,"27":"Desse modo, Salomão excluiu Abiatar do sacerdócio de Javé, cumprindo a profecia de Javé feita em Silo, contra a família de Eli."
,"28":"Quando esta notícia chegou a Joab, que tinha apoiado Adonias, embora não tivesse apoiado Absalão, ele refugiou-se na tenda de Javé e agarrou-se às pontas do altar."
,"29":"Quando avisaram o rei Salomão de que Joab se havia refugiado na tenda de Javé e que estava junto do altar, Salomão mandou dizer a Joab: «O que é que aconteceu? Porque te refugiaste junto do altar?» Joab respondeu: «Fiquei com medo de ti e refugiei-me junto de Javé». Então Salomão ordenou a Banaías, filho de Joiada: «Vai matá-lo»."
,"30":"Banaías foi à tenda de Javé e disse a Joab: «O rei ordena que saias». Joab respondeu: «Não. Quero morrer aqui». Banaías levou a resposta de Joab ao rei,"
,"31":"e este ordenou: «Pois faz como ele quer. Mata-o e enterra-o. Deste modo, tirarás de cima de mim e da minha família o sangue inocente que Joab derramou."
,"32":"Javé faça recair o sangue dele sobre a sua cabeça, por ter matado dois homens mais justos e melhores do que ele, sem que o meu pai David soubesse: Abner, filho de Ner, chefe do exército de Israel, e Amasa, filho de Jeter, chefe do exército de Judá."
,"33":"Que o sangue desses homens caia sobre a cabeça de Joab e da sua descendência para sempre. Que David e a sua descendência, a sua família e o seu trono gozem sempre da paz de Javé»."
,"34":"Banaías, filho de Joiada, foi, matou Joab, e depois enterrou-o na própria casa de Joab, no deserto."
,"35":"Em lugar de Joab, o rei colocou Banaías, filho de Joiada, como chefe do exército; e, em lugar de Abiatar, colocou o sacerdote Sadoc."
,"36":"O rei mandou chamar Semei e disse-lhe: «Constrói uma casa em Jerusalém e habita nela. Não saias para nenhum lugar."
,"37":"No dia em que saíres e atravessares o riacho do Cedron, serás morto. A responsabilidade é tua»."
,"38":"Semei respondeu: «Está bem. O teu servo vai fazer o que o senhor meu rei ordenou». E Semei ficou muito tempo a viver em Jerusalém."
,"39":"No entanto, três anos depois, dois escravos de Semei fugiram e foram até Aquis, filho de Maaca, rei de Cat. E avisaram Semei: «Os teus escravos estão em Gat»."
,"40":"Então Semei selou o jumento e foi ter com Aquis, a Gat, procurar os seus escravos. Foi a Gat e trouxe os escravos de volta."
,"41":"Mas informaram Salomão de que Semei tinha ido de Jerusalém a Gat e já tinha voltado."
,"42":"O rei mandou chamar Semei e disse-lhe: «Não te fiz jurar por Javé, e não te avisei que no dia em que saísses para qualquer lugar, serias morto? Tu disseste-me que estavas de acordo."
,"43":"Porque não cumpriste o que juraste por Javé e a ordem que te dei?»"
,"44":"E o rei acrescentou: «Tu sabes muito bem todo o mal que fizeste ao meu pai David. Javé faça recair essa maldade sobre a tua própria cabeça."
,"45":"E bendito seja o rei Salomão, e que o trono de David permaneça diante de Javé para sempre»."
,"46":"Então o rei deu uma ordem a Banaías, filho de Joiada, que saiu e matou Semei. E assim a realeza se consolidou nas mãos de Salomão."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salomão tornou-se genro do Faraó, rei do Egipto; casou-se com a filha do Faraó, e levou-a para a Cidade de David, até que acabasse de construir o seu próprio palácio, o Templo de Javé e as muralhas de Jerusalém."
,"2":"Entretanto, o povo oferecia sacrifícios nos lugares altos, porque ainda não tinha sido construído o Templo para o nome de Javé."
,"3":"Salomão amava Javé, de modo que seguia os preceitos de seu pai David. Entretanto, oferecia sacrifícios e incenso nos lugares altos."
,"4":"O rei foi a Gabaon para oferecer sacrifícios, porque esse lugar alto era o mais importante de todos. E Salomão ofereceu mil holocaustos sobre esse altar."
,"5":"Em Gabaon, durante a noite, Javé apareceu em sonhos a Salomão. Deus disse-lhe: «Pede. O que queres que te dê?»"
,"6":"Salomão respondeu: «Tu demonstraste grande amor para com o teu servo David, meu pai, porque, diante de Ti, ele caminhou na fidelidade, na justiça e na rectidão de coração para contigo. Tu guardaste para com ele esse grande amor dando-lhe um filho que hoje está sentado no seu trono."
,"7":"Agora, Tu, Javé meu Deus, fizeste reinar o teu servo em lugar de David, meu pai. Eu sou muito jovem e não sei como governar."
,"8":"O teu servo encontra-se no meio do povo que escolheste, povo numeroso que não se pode contar nem calcular, tão grande ele é."
,"9":"Ensina-me a ouvir, para que saiba governar o teu povo e discernir entre o bem e o mal. Pois quem poderia governar este teu povo tão numeroso?»"
,"10":"Agradou ao Senhor que Salomão tivesse pedido estas coisas."
,"11":"Então Deus disse-lhe: «Porque pediste isto, e não vida longa, nem riquezas, nem a morte dos teus inimigos, mas discernimento para ouvir e julgar,"
,"12":"farei o que pediste. Dar-te-ei mente sábia e inteligente, como ninguém teve antes de ti e ninguém terá depois."
,"13":"Dar-te-ei também o que não pediste: riqueza e fama, de modo que não haverá nenhum rei que te iguale, durante toda a tua vida."
,"14":"E se andares nos meus caminhos e observares os meus estatutos e mandamentos, como fez o teu pai David, conceder-te-ei vida longa»."
,"15":"Então Salomão acordou e percebeu que tudo isso tinha sido um sonho. Foi para Jerusalém e ficou diante da arca de Javé. Em seguida, ofereceu holocaustos, sacrifícios de comunhão e deu um banquete a toda a sua corte."
,"16":"Duas prostitutas foram ter com o rei e apresentaram-se."
,"17":"Uma das mulheres disse: «Meu senhor, eu e esta mulher moramos na mesma casa. Eu tive um filho."
,"18":"Três dias depois de eu ter dado à luz, ela também teve uma criança. Não havia mais ninguém connosco. Nós estávamos sozinhas em casa."
,"19":"Aconteceu que certa noite esta mulher deitou-se sobre o próprio filho, e ele morreu."
,"20":"Ela levantou-se durante a noite e, enquanto eu dormia, pegou no meu filho que estava junto de mim e pô-lo ao seu lado. Depois, colocou junto de mim o seu filho morto."
,"21":"Quando acordei de manhã, para dar de mamar ao meu filho, vi que estava morto. Olhei bem e notei que não era o filho que eu tinha dado à luz»."
,"22":"A outra mulher disse: «Não é verdade! O meu filho está vivo. O dela é que morreu». A primeira contestou: «É mentira! O teu filho é que está morto e o meu é que está vivo». E começaram a discutir diante do rei."
,"23":"Então o rei interveio: «Uma diz: 'O meu filho está vivo e o teu está morto'. A outra diz: 'Mentira! O teu filho está morto e o meu está vivo'»."
,"24":"Então o rei ordenou: «Trazei-me uma espada». E trouxeram ao rei uma espada."
,"25":"O rei disse: «Cortai o menino vivo em duas partes e dai metade a cada uma»."
,"26":"Então a mãe do menino vivo sentiu as entranhas comoverem-se pelo filho, e suplicou: «Meu senhor, dá-lhe o menino vivo, não o mates». A outra, porém, dizia: «Não será nem para mim, nem para ti. Dividam o menino ao meio»."
,"27":"Então o rei pronunciou a sentença: «Entregai o menino vivo à primeira mulher. Não o mateis, pois é ela a sua mãe»."
,"28":"Todo o Israel soube da sentença que o rei tinha dado. E respeitavam-no, pois viram que ele possuía sabedoria divina para fazer justiça."
}`)
	CurrentBook.AddChapter(4, `{
"1":"O rei Salomão reinava sobre todo o Israel."
,"2":"E estes eram os principais membros do seu governo: Azarias, filho de Sadoc, sacerdote."
,"3":"Eliaf e Aías, filhos de Sisa, secretários. Josafá, filho de Ailud, porta-voz."
,"4":"Banaías, filho de Joiada, chefe do exército."
,"5":"Azarias, filho de Natã, chefe dos prefeitos. Zabud, filho de Natã, conselheiro particular do rei."
,"6":"Aisar, prefeito do palácio. Adoram, filho de Abda, chefe dos trabalhos forçados."
,"7":"Salomão tinha doze prefeitos em todo o Israel. Cada um devia prover o palácio real durante um mês do ano."
,"8":"Os nomes deles eram: um filho de Hur, na região montanhosa de Efraim."
,"9":"Um filho de Decar, em Maces, Salebim, Bet-Sames, Aialon e Bet-Hanã."
,"10":"Um filho de Hesed, em Arubot; também estavam sob a sua jurisdição Soco e todo o território de Héfer."
,"11":"Um filho de Abinadab, casado com Tabaat, filha de Salomão, em todo o distrito de Dor."
,"12":"Baana, filho de Ailud, em Tanac e Meguido, até além de Jecmam, e todo o território de Betsã, abaixo de Jezrael, desde Betsa até Bet-Maúla, perto de Sartã."
,"13":"Um filho de Gaber, em Ramot de Galaad; também entraram para a sua jurisdição as aldeias de Jair, filho de Manassés, que estão em Galaad, e a região de Argob em Basã: sessenta cidades com muralhas e trancas de bronze."
,"14":"Ainadab, filho de Ado, em Maanaim."
,"15":"Aquimaás, em Neftali; ele também se casou com uma filha de Salomão chamada Basemat."
,"16":"Baana, filho de Husi, em Aser e nos rochedos."
,"17":"Josafá, filho de Farué, em Issacar."
,"18":"Semei, filho de Ela, em Benjamim."
,"19":"Gaber, filho de Uri, na região de Gad, terra de Seon, rei dos amorreus, e de Og, rei de Basã. Além desses, havia um prefeito para o território de Judá."
,"20":"A população de Judá e Israel era numerosa como a areia da praia. E todos comiam, bebiam e viviam felizes."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Salomão tinha poder sobre todos os reinos, desde o rio Eufrates até à região filisteia e à fronteira do Egipto. Enquanto viveu, todos lhe pagaram tributo e lhe obedeceram."
,"2":"Salomão recebia diariamente para os seus gastos mil e quinhentos litros de flor de farinha e vinte e sete mil litros de farinha comum,"
,"3":"dez bois cevados, vinte bois de pasto, cem carneiros, além de veados, gazelas, antílopes e aves de ceva."
,"4":"Isto porque o seu poder se estendia até ao outro lado do Eufrates, desde Tafsa até Gaza, sobre todos os reis do outro lado do Rio. E havia paz em todas as suas fronteiras."
,"5":"Enquanto Salomão viveu, Judá e Israel viveram tranquilos, cada qual debaixo da sua vinha e da sua figueira, desde Dã até Bersabeia."
,"6":"Salomão possuía estábulos para quatro mil cavalos de tracção e doze mil cavalos de montaria."
,"7":"Os prefeitos acima mencionados providenciavam o sustento de Salomão e de todos os que comiam a expensas do rei, cada prefeito durante um mês, de modo que nada faltasse."
,"8":"Forneciam também cevada e palha para os cavalos de tracção e de montaria, no lugar onde fosse preciso, cada qual por seu turno."
,"9":"Deus concedeu a Salomão sabedoria e inteligência extraordinárias, e mente aberta como as praias do mar."
,"10":"A sabedoria de Salomão foi maior que a de todos os filhos do Oriente e maior que toda a sabedoria do Egipto."
,"11":"Foi mais sábio que qualquer pessoa: mais que Etã, o ezraíta, e mais que Emã, Calcol e Darda, filhos de Maol. A sua fama espalhou-se por todas as nações vizinhas."
,"12":"Ele compôs três mil provérbios, e mil e cinco cânticos."
,"13":"Falou sobre plantas, desde o cedro do Líbano até ao hissopo que cresce na parede. Falou também sobre animais, aves, répteis e peixes."
,"14":"De todas as nações vinha gente para ouvir a sabedoria de Salomão. Vinham também os reis dos países, onde se havia espalhado a fama da sua sabedoria."
,"15":"Hiram, rei de Tiro, tinha sido sempre aliado de David. Ao saber que Salomão tinha sucedido ao pai no trono, Hiram enviou uma embaixada a Salomão."
,"16":"E Salomão enviou a seguinte mensagem a Hiram:"
,"17":"«Tu sabes que meu pai David não pôde construir um Templo ao Nome de Javé seu Deus, por causa das guerras em que se envolveu, até que Javé lhe submeteu os inimigos debaixo dos pés."
,"18":"Agora, porém, Javé, meu Deus, concedeu-me a paz em todo o território: não tenho inimigos nem problemas graves."
,"19":"Por isso, resolvi construir um Templo ao Nome de Javé, meu Deus, de acordo com o que Javé disse a meu pai David: 'O teu filho, que porei no trono depois de ti, construirá um Templo ao meu Nome'."
,"20":"Portanto, ordena aos teus servos que me cortem cedros do Líbano. Os meus operários trabalharão com os teus, e eu pagarei o trabalho dos teus operários, conforme determinares. Tu sabes que entre nós não há ninguém que saiba cortar a madeira como os sidónios»."
,"21":"Quando Hiram ouviu o pedido de Salomão ficou cheio de alegria, e exclamou: «Que hoje seja bendito Javé, pois Ele deu a David um filho sábio para governar este grande povo»."
,"22":"Em resposta, Hiram mandou esta mensagem a Salomão: «Recebi a tua mensagem. Vou satisfazer o teu desejo, mandando-te madeira de cedro e cipreste."
,"23":"Os meus operários descerão a madeira do Líbano até ao mar, e ela seguirá para o lugar que me indicares. Então desembarcá-la-ei e recebê-la-ás. Em troca, fornecerás víveres para o meu palácio, conforme eu quiser»."
,"24":"Hiram forneceu a Salomão toda a madeira de cedro e cipreste de que este necessitava,"
,"25":"e Salomão deu a Hiram nove mil toneladas de trigo para o sustento do seu palácio, e nove mil litros de azeite virgem. Era o que Salomão mandava anualmente a Hiram."
,"26":"Javé concedeu sabedoria a Salomão, conforme lhe havia prometido. Houve bom entendimento entre Hiram e Salomão, e os dois fizeram uma aliança."
,"27":"O rei Salomão recrutou, em todo o Israel, mão-de-obra para os trabalhos forçados; conseguiu reunir trinta mil operários."
,"28":"Mandou-os para o Líbano em turnos, dez mil em cada mês: passavam um mês no Líbano e dois meses em casa. Adoram era o chefe dos trabalhos forçados."
,"29":"Salomão tinha também setenta mil carregadores e oitenta mil cortadores de pedras nas montanhas,"
,"30":"sem contar os capatazes, em número de três mil e trezentos, que dirigiam os trabalhos dos operários."
,"31":"O rei mandou extrair grandes blocos de pedra escolhida, a fim de construir os alicerces do templo."
,"32":"Os operários de Salomão, juntamente com os de Hiram e os giblitas, cortaram e prepararam a madeira e a pedra para a construção do Templo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"No ano quatrocentos e oitenta depois da saída dos israelitas do Egipto, quarto do reinado de Salomão em Israel, no mês de Ziv, que é o segundo mês, Salomão começou a construir o Templo de Javé."
,"2":"O Templo de Javé construído por Salomão media trinta metros de comprimento, dez de largura e quinze de altura."
,"3":"O vestíbulo diante do santuário do Templo tinha dez metros no sentido da largura do Templo e cinco no sentido do seu comprimento."
,"4":"No Templo, o rei fez janelas quadradas com grades."
,"5":"Encostado à parede do Templo, construiu um anexo que rodeava o santuário e o Santíssimo, com pisos, e fez aposentos laterais ao redor."
,"6":"De largura, o andar térreo tinha dois metros e meio; o intermediário, três metros; e o terceiro, três metros e meio. É que ele tinha feito, do lado de fora, saliências em torno do Templo, de modo que as vigas não ficavam presas nas paredes do Templo."
,"7":"E o Templo foi construído com pedras já talhadas, de modo que durante a sua construção não se ouviu barulho de martelo, de cinzel ou de qualquer outro instrumento de ferro."
,"8":"A entrada para o andar inferior ficava no canto direito do Templo e, por meio de escadas em caracol, subia-se para o andar do meio, e deste para o andar superior."
,"9":"Salomão terminou a construção do Templo, cobrindo-o com tecto de tábuas de cedro."
,"10":"Fez uma galeria anexa a todo o Templo, com dois metros e meio de altura, unida ao Templo por vigas de cedro."
,"11":"Então Javé disse a Salomão:"
,"12":"«Quan-to a esta casa que estás a construir, se te comportares de acordo com os meus estatutos, e observares as minhas normas e seguires os meus mandamentos, Eu cumprirei em teu favor a promessa que fiz a teu pai:"
,"13":"habitarei entre os israelitas e não abandonarei o meu povo Israel»."
,"14":"Quando Salomão terminou as obras do Templo,"
,"15":"revestiu o lado interno das paredes com placas de cedro, desde o chão até às vigas do tecto; revestiu as paredes internas com madeira e cobriu o chão com tábuas de ciprestre."
,"16":"Recobriu com tábuas de cedro os dez metros, a partir do fundo do Templo, desde o chão até às vigas, e separou-os do templo para formar o Santíssimo."
,"17":"O Templo, isto é, o santuário diante do Santíssimo, media vinte metros."
,"18":"O cedro do interior do Templo era esculpido com flores e festões; tudo era de cedro e não se via pedra nenhuma."
,"19":"Salomão construiu o Santíssimo ao fundo do Templo, para ali colocar a arca da aliança de Javé."
,"20":"O Santíssimo tinha dez metros de comprimento, dez metros de largura e dez de altura; e ele revestiu-o de ouro puríssimo. Fez um altar de cedro"
,"21":"diante do Santíssimo, e revestiu-o de ouro."
,"22":"Revestiu de ouro o Templo inteiro, que ficou totalmente coberto de ouro."
,"23":"Para o Santíssimo, Salomão fez dois querubins de oliveira brava, cada um com cinco metros de altura."
,"24":"Cada asa do querubim media dois metros e meio, de modo que a distância era de cinco metros de uma ponta à outra das asas."
,"25":"O segundo querubim também media cinco metros. Os dois tinham o mesmo tamanho e o mesmo formato."
,"26":"Os dois querubins mediam cinco metros de altura cada um."
,"27":"Os querubins foram colocados no meio da sala interior. Eles tinham as asas estendidas, de modo que a asa de um tocava uma parede, e a asa do outro tocava a outra parede, e as asas de ambos tocavam uma na outra, no meio da sala."
,"28":"Os querubins foram revestidos de ouro."
,"29":"Salomão mandou esculpir figuras de querubins, palmeiras e flores ao redor de todas as paredes do Templo, tanto por fora como por dentro,"
,"30":"e mandou cobrir de ouro o piso interior e exterior do Templo."
,"31":"Salomão mandou fazer a porta do Santíssimo com vigas de oliveira brava. O enquadramento da porta tinha cinco ângulos,"
,"32":"e os dois batentes eram de oliveira brava. Nos batentes foram esculpidas figuras de querubins, palmeiras e flores, tudo recoberto de ouro. Salomão mandou recobrir de ouro os querubins e as palmeiras."
,"33":"Também mandou fazer as portas do santuário com vigas de oliveira brava, com enquadramento de quatro ângulos."
,"34":"Os dois batentes das portas eram de cipreste, com painéis giratórios em cada batente."
,"35":"Nos batentes foram esculpidos querubins, palmeiras e flores, revestidos de ouro ajustado sobre a escultura."
,"36":"Salomão mandou ainda construir o muro do pátio interior com três fileiras de pedra talhada e uma fileira de vigas de cedro."
,"37":"No quarto ano, no mês de Ziv, foram lançados os alicerces do Templo. E no décimo primeiro ano, no mês de Bul, o oitavo mês, o Templo ficou concluído em todas as suas partes, conforme o projecto. Salomão levou sete anos a construir o Templo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Salomão levou treze anos a construir o seu palácio, até ficar completamente pronto."
,"2":"Construiu a Casa da Floresta do Líbano, que tinha cinquenta metros de comprimento, vinte e cinco de largura e quinze de altura. Foi construída sobre quatro filas de colunas de cedro, com vigas de cedro sobre as colunas."
,"3":"Sobre as vigas sustentadas pelas colunas, foi feito um revestimento de cedro."
,"4":"Havia três filas de janelas, quarenta e cinco ao todo; ficavam quinze em cada fila, cada uma na frente das outras, de três em três."
,"5":"Todas as portas e janelas tinham enquadramento rectangular e ficavam umas na frente das outras, de três em três."
,"6":"Salomão construiu o pórtico das colunas com vinte e cinco metros de comprimento e quinze de largura. Além disso, fez um vestíbulo diante das colunas, com uma varanda na frente."
,"7":"Fez o salão do trono ou da audiência, onde administrava a justiça; era revestido de cedro desde o pavimento até ao tecto."
,"8":"A sua residência pessoal, num outro pátio atrás do pórtico, era do mesmo estilo. Salomão fez também outro palácio, parecido com este pórtico, para a filha do Faraó, com quem se havia casado."
,"9":"Desde os alicerces até às vigas do tecto, todas as construções foram feitas de pedras escolhidas, cortadas sob medida, serradas por dentro e por fora, também do lado de fora, até ao grande pátio."
,"10":"Os alicerces eram de pedras escolhidas, em blocos de cinco por quatro metros,"
,"11":"e em cima delas pedras especiais, cortadas sob medida, e também madeira de cedro."
,"12":"O pátio maior tinha três filas de pedra talhada e uma fileira de tábuas de cedro; era semelhante ao pátio interno do templo de Javé e ao vestíbulo do palácio."
,"13":"Salomão mandou chamar Hiram, de Tiro,"
,"14":"filho de uma viúva da tribo de Neftali, cujo pai era natural de Tiro. Hiram trabalhava em bronze, e era dotado de grande habilidade, talento e inteligência para fazer qualquer trabalho em bronze. Ele apresentou-se ao rei Salomão e executou toda a obra."
,"15":"Fundiu duas colunas de bronze, cada uma com nove metros de altura e seis de circunferência."
,"16":"Fez dois capitéis de bronze fundido, cada um com dois metros e meio de altura, e colocou-os no alto das colunas."
,"17":"Para enfeitar os capitéis, fez dois entrançados em forma de corrente, um para cada capitel."
,"18":"Depois fez as romãs; havia duas fileiras de romãs em torno de cada entrançado, para cobrir os entrançados que ficavam no alto das colunas. Fez o mesmo com o segundo capitel."
,"19":"Os capitéis, no alto das colunas que estavam no vestíbulo, tinham forma de flor de lis, medindo dois metros."
,"20":"Além disso, esses capitéis, no alto das duas colunas, no centro que ficava por detrás dos entrançados, estavam enfeitados de romãs, colocadas em filas de duzentas ao redor de cada capitel."
,"21":"Em seguida, Hiram ergueu as colunas diante do vestíbulo do santuário: ergueu a coluna do lado direito e deu-lhe o nome de Firme; depois levantou a coluna do lado esquerdo e deu-lhe o nome de Forte."
,"22":"E assim terminou o trabalho das colunas."
,"23":"Hiram fez ainda o Mar, todo de metal fundido, com cinco metros de diâmetro. Era redondo, tinha dois metros e meio de altura e quinze metros de circunferência."
,"24":"Por baixo da borda, em toda a volta, havia duas séries de motivos vegetais, com vinte frutas em cada metro, fundidas numa só peça com o Mar."
,"25":"Este ficava apoiado sobre doze touros, que olhavam três para o Norte, três para o Oeste, três para o Sul e três para o Leste. O Mar apoiava-se sobre esses touros, que estavam com a parte posterior voltava para dentro."
,"26":"A espessura do Mar era de oito centímetros, e a sua borda tinha a forma de flor de lis. A sua capacidade era de noventa mil litros."
,"27":"Hiram fez também dez bases de bronze para as bacias: cada uma delas media dois metros de comprimento, dois de largura e um metro e meio de altura."
,"28":"Foram construídas com molduras no meio das travessas."
,"29":"Sobre essas molduras havia leões, touros e querubins, e sobre as travessas havia um suporte; abaixo dos leões e dos touros, havia grinaldas em forma de festões."
,"30":"Cada base tinha quatro rodas de bronze e eixos também de bronze; os seus quatro pés tinham suportes por baixo da bacia; eram de metal fundido e ficavam além de cada grinalda."
,"31":"O seu encaixe tinha meio metro, a partir do cruzamento dos suportes até ao alto; o encaixe era redondo, em forma de suporte de vaso; tinha setenta e cinco centímetros; e sobre o encaixe também havia esculturas, mas os painéis eram quadrangulares, e não redondos."
,"32":"As quatro rodas ficavam acima das travessas. Os eixos das rodas estavam no pedestal; a altura das rodas era de setenta e cinco centímetros."
,"33":"A forma das rodas era como de roda de carro, com eixos, aros, raios e cubos, tudo em metal fundido."
,"34":"Havia quatro suportes nos quatro cantos de cada base: a base e os seus suportes formavam uma peça única."
,"35":"Na parte superior da base havia um suporte com vinte e cinco centímetros de altura, feito de ferro circular; no topo da base havia esteios, e os painéis formavam uma só peça com a base."
,"36":"Sobre os painéis de cada travessa e sobre as molduras, mandou gravar querubins, leões e palmeiras dentro dos espaços livres, com grinaldas ao redor."
,"37":"As dez bases foram fundidas com o mesmo molde, idênticas na medida e na forma."
,"38":"Hiram fez dez bacias de bronze, cada uma com capacidade de mil e oitocentos litros, e media dois metros. Cada bacia estava montada sobre uma das dez bases."
,"39":"Colocou cinco dessas bases do lado direito do Templo, e as outras cinco do lado esquerdo. O Mar foi colocado do lado direito do Templo, a Sudoeste."
,"40":"Hiram fez também os recipientes para a cinza, as pás e as bacias para a aspersão. E terminou tudo o que o rei Salomão tinha encomendado para o Templo de Javé:"
,"41":"as duas colunas; os dois rolos dos capitéis para o alto das colunas; os dois entrançados para cobrir os dois rolos que estavam no alto das colunas;"
,"42":"as quatrocentas romãs para os dois entrançados, ficando as romãs de cada entrançado em duas fileiras;"
,"43":"as dez bases e as dez bacias;"
,"44":"o Mar, com os doze touros;"
,"45":"os recipientes para a cinza, as pás e as bacias para a aspersão. Hiram fez em bronze polido todos estes objectos para o rei Salomão, para o Templo de Javé."
,"46":"Ele fundiu-os na planície do Jordão, em terra argilosa, entre Sucot e Sartã."
,"47":"Não se pôde calcular o peso do bronze, por causa da sua enorme quantidade."
,"48":"Salomão colocou no Templo de Javé todos os objectos que tinha mandado fazer: o altar de ouro e a mesa de ouro, com os pães oferecidos a Deus;"
,"49":"os candelabros de ouro puro, cinco à direita e cinco à esquerda, diante do Santíssimo; as flores, as lâmpadas e as tenazes de ouro;"
,"50":"as bacias, as facas, as bacias para a aspersão; as taças e os incensórios de ouro puro; os gonzos de ouro para as portas do Santíssimo e do santuário."
,"51":"Quando foram terminadas todas as encomendas para o Templo de Javé, Salomão mandou trazer as ofertas de seu pai David - prata, ouro e vasos - e colocou-as no tesouro do Templo de Javé."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Salomão reuniu em Jerusalém os anciãos de Israel, todos os chefes das tribos e os chefes das famílias israelitas, para transportar, da Cidade de David, que é Sião, a Arca da aliança de Javé."
,"2":"Todos os homens de Israel se reuniram, durante a festa, com o rei Salomão, no mês de Etanim, que é o sétimo mês."
,"3":"Quando todos os anciãos de Israel chegaram, os sacerdotes carregaram a Arca"
,"4":"e, com a ajuda dos levitas, transportaram também a Tenda da Reunião e os utensílios sagrados que estavam na Tenda."
,"5":"O rei Salomão, juntamente com toda a comunidade de Israel reunida com ele diante da Arca, sacrificou tantas ovelhas e bois que não foi possível contá-los nem calculá-los."
,"6":"Os sacerdotes introduziram a Arca da aliança de Javé no seu lugar, isto é, no recinto do Templo chamado Santíssimo, sob as asas dos querubins."
,"7":"De facto, os querubins estendiam as asas sobre o lugar da Arca, protegendo a Arca e os seus varais."
,"8":"Como os varais eram compridos, quem estava no santuário podia ver as suas extremidades, mas não podia vê-las de fora. Eles ficaram ali até ao dia de hoje."
,"9":"Dentro da Arca não havia mais nada senão as duas tábuas de pedra que, no Horeb, Moisés ali tinha colocado, quando Javé concluiu a aliança com os israelitas, quando eles saíram do Egipto."
,"10":"Quando os sacerdotes saíram do santuário, a Nuvem encheu o Templo de Javé,"
,"11":"e os sacerdotes não puderam continuar o seu serviço, por causa da Nuvem: a glória de Javé encheu o Templo."
,"12":"Então Salomão disse: «Javé escolheu habitar a Nuvem escura."
,"13":"Eu construí para Ti um Templo, uma casa onde habitarás para sempre»."
,"14":"O rei voltou-se e abençoou toda a assembleia de Israel. E todos permaneceram de pé."
,"15":"Então o rei disse: «Seja bendito Javé, o Deus de Israel, que realizou com a mão o que a sua boca havia prometido a meu pai David:"
,"16":"'Desde o dia em que tirei do Egipto o meu povo Israel, não escolhi nenhuma cidade dentre todas as tribos de Israel, a fim de lá construir um Templo para o meu Nome, mas escolhi David para governar o meu povo Israel'."
,"17":"O meu pai David queria construir um Templo ao Nome de Javé, o Deus de Israel."
,"18":"Javé, porém, disse a meu pai David: 'Tu queres construir um Templo ao meu Nome, e fazes muito bem em quereres isso."
,"19":"Contudo, não és tu quem vai construir-Me o Templo, mas o teu filho, saído das tuas entranhas, ele é que vai construir o Templo ao meu Nome'."
,"20":"E Javé realizou a promessa que havia feito: sucedi a meu pai David e subi ao trono de Israel, como Javé havia prometido, e construí o Templo ao Nome de Javé, o Deus de Israel."
,"21":"E no Templo escolhi um lugar para a Arca, onde se acha a aliança que Javé fez com os nossos antepassados, quando os tirou da terra do Egipto»."
,"22":"Salomão ficou de pé diante do altar de Javé, na presença de toda a assembleia de Israel. Elevou as mãos ao Céu,"
,"23":"e disse: «Javé, Deus de Israel, não existe nenhum deus como Tu, nem no alto do céu, nem cá em baixo na Terra. Tu és fiel à aliança e ao amor para com os teus servos que caminham de todo o coração na tua presença."
,"24":"Cumpriste a promessa que havias feito ao teu servo David, meu pai, e o que prometeste com a boca, hoje realizaste-o com a mão."
,"25":"Agora, Javé, Deus de Israel, mantém a promessa que fizeste a teu servo David, meu pai: 'Nunca te faltará, diante de Mim, um descendente no trono de Israel, contanto que teus filhos saibam comportar-se, vivendo de acordo comigo, como tu mesmo viveste'."
,"26":"Agora, portanto, ó Deus de Israel, confirma a promessa que fizeste ao teu servo David, meu pai."
,"27":"Será possível que Deus habite na Terra? Se não cabes no Céu e no mais alto dos céus, muito menos neste Templo que construí."
,"28":"Atende a oração e a súplica do teu servo, ó Javé meu Deus! Ouve o clamor e a prece que o teu servo faz hoje diante de Ti."
,"29":"Que os teus olhos fiquem abertos dia e noite sobre este Templo, sobre este lugar onde quiseste que o teu Nome habitasse. Ouve a prece que o teu servo fará neste lugar»."
,"30":"«Ouve as súplicas do teu servo e do teu povo Israel, quando rezarem neste lugar. Escuta da tua morada no Céu. Escuta e perdoa."
,"31":"Quando alguém pecar contra o seu próximo e, porque lhe exigiram um juramento imprecatório, vier para jurar diante do teu altar neste Templo,"
,"32":"escuta do Céu e age. Julga os teus servos: condena o culpado, dando-lhe o que merece, e absolve o inocente, tratando-o segundo a sua justiça."
,"33":"Quando o teu povo Israel for derrotado pelo inimigo por ter pecado contra Ti, se ele se converter, der glória ao teu Nome, rezar e Te suplicar neste Templo,"
,"34":"escuta-o do Céu, perdoa o pecado do teu povo Israel, e faz com que ele volte para a Terra que deste aos seus antepassados."
,"35":"Quando o céu se fechar e não cair chuva, por terem pecado contra Ti, se eles rezarem neste lugar, confessarem o teu Nome e se arrependerem do seu pecado, porque os afligiste,"
,"36":"escuta do Céu, perdoa o pecado do teu servo e do teu povo Israel, mostrando-lhe o bom caminho que devem seguir, e rega com a chuva a Terra que deste como herança ao teu povo."
,"37":"Quando o país sofrer fome, peste, mela e ferrugem; quando vierem gafanhotos e pulgões; quando o inimigo deste povo cercar uma das suas cidades; quando acontecer alguma calamidade ou epidemia;"
,"38":"seja qual for a oração ou súplica de qualquer um do teu povo Israel, que sinta remorso de consciência; se ele erguer as mãos para este Templo,"
,"39":"escuta do Céu onde moras, perdoa e age. Paga a cada um conforme o seu comportamento, pois conheces o coração; és o único que conhece o coração de todos."
,"40":"Deste modo, eles Te respeitarão, enquanto viverem na Terra que deste aos nossos antepassados."
,"41":"Se o estrangeiro, que não pertence ao teu povo de Israel, também vier de uma terra distante por causa do teu Nome,"
,"42":"pois ouvirão falar do teu grande Nome, da tua mão forte e do teu braço estendido, se ele vier para orar neste Templo,"
,"43":"escuta do Céu onde moras, e atende a todos os pedidos do estrangeiro. Assim, todos os povos da terra reconhecerão o teu Nome e temer-Te-ão, como o teu povo Israel. Eles saberão que o teu Nome é invocado neste Templo que eu construí."
,"44":"Se o teu povo sair para guerrear contra os inimigos, e se no caminho por onde o mandares Te invocar, voltado para a cidade que escolheste e para o Templo que construí ao teu Nome,"
,"45":"escuta do Céu a sua oração e súplica, e faz-lhe justiça."
,"46":"Quando os israelitas pecarem contra Ti, pois não há ninguém que não peque, e Tu ficares irritado contra eles, entregando-os ao inimigo, e eles forem levados como cativos pelos vencedores para uma terra inimiga, distante ou próxima;"
,"47":"se nessa terra onde estiverem cativos, eles caírem em si e, na terra dos vencedores, suplicarem: 'Nós pecámos, agimos mal e pervertemo-nos';"
,"48":"se eles se voltarem para Ti de todo o coração e de toda a alma, na terra em que os inimigos os tiverem cativos; se Te invocarem voltados para a Terra que deste aos seus antepassados, para a cidade que escolheste e para o Templo que construí ao teu Nome,"
,"49":"escuta do Céu onde moras, escuta a sua oração e súplica e faz-lhes justiça."
,"50":"Perdoa ao teu povo que pecou contra Ti, perdoa todas as suas revoltas contra Ti, e faz que ele encontre a benevolência dos vencedores, e que estes usem de compaixão para com ele,"
,"51":"porque é o teu povo e a tua herança, que tiraste do Egipto, do meio duma fornalha de ferro."
,"52":"Que os teus olhos estejam abertos às súplicas do teu servo e do teu povo Israel, para ouvires todos os pedidos que eles Te fizerem."
,"53":"De facto, Senhor Javé, Tu os separaste como tua herança entre todos os povos da terra, como disseste através do teu servo Moisés, quando tiraste do Egipto os nossos antepassados!»"
,"54":"Quando Salomão acabou de dirigir a Javé toda esta oração e súplica, levantou-se diante do altar de Javé, no lugar em que estava ajoelhado e de mãos erguidas para o céu."
,"55":"Ficou de pé e abençoou toda a assembleia de Israel em voz alta:"
,"56":"«Javé seja bendito! Ele concedeu descanso ao seu povo Israel, conforme havia prometido. Não falhou nem uma só palavra das boas promessas que tinha feito através do seu servo Moisés."
,"57":"Javé nosso Deus esteja connosco, assim como esteve com os nossos antepassados. Que Ele não nos abandone, nem nos rejeite."
,"58":"Que faça voltar para Ele os nossos corações, a fim de andarmos nos seus caminhos e obedecermos aos seus mandamentos, estatutos e normas, que Ele ordenou aos nossos antepassados."
,"59":"Que estas súplicas por mim dirigidas a Javé estejam dia e noite presentes diante de Javé, nosso Deus, para que Ele faça justiça ao seu servo e ao seu povo Israel, conforme as necessidades de cada dia."
,"60":"Assim, todos os povos da Terra saberão que só Javé é Deus e que não há nenhum outro."
,"61":"Que o vosso coração seja íntegro para com Javé nosso Deus, observando os seus estatutos e obedecendo aos seus mandamentos, como fazeis hoje»."
,"62":"O rei e todo o povo de Israel ofereceram sacrifícios diante de Javé."
,"63":"Salomão ofereceu sacrifícios, e foram sacrifícios de comunhão que ele ofereceu a Javé: vinte e dois mil bois e cento e vinte mil ovelhas. Foi deste modo que o rei e todos os israelitas inauguraram o Templo de Javé."
,"64":"Nesse mesmo dia, o rei consagrou o interior do pátio que fica diante do Templo de Javé: ali ofereceu o holocausto, a oblação, as gorduras do sacrifício de comunhão, porque o altar de bronze que estava diante de Javé era muito pequeno para conter o holocausto, a oblação e as gorduras do sacrifício de comunhão."
,"65":"Nessa ocasião, Salomão celebrou a festa, e todo o Israel com ele, durante sete dias: houve uma grande assembleia diante de Javé, o nosso Deus, com gente que veio desde a entrada de Emat até à torrente do Egipto."
,"66":"No oitavo dia, ele despediu o povo. E todos abençoaram o rei e voltaram para as suas tendas, alegres e de coração contente por todos os benefícios que Javé havia feito ao seu servo David e a Israel, seu povo."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Salomão acabou de construir o Templo de Javé, o palácio real, e tudo o que pretendia construir."
,"2":"Então Javé apareceu-lhe pela segunda vez, como havia aparecido em Gabaon,"
,"3":"e disse-lhe: «Ouvi a oração e súplica que Me fizeste. Consagrei este Templo, que construíste, para que seja a morada do meu Nome para sempre: os meus olhos e o meu coração estarão aqui todos os dias."
,"4":"Se te comportares diante de Mim como o teu pai David, de coração íntegro e recto, fazendo tudo como Eu ordenei e obedeceres aos meus estatutos e normas,"
,"5":"manterei firme para sempre o teu trono real em Israel, como prometi ao teu pai David, dizendo: «Haverá sempre alguém da tua família para se sentar no trono de Israel»."
,"6":"Mas se vós e vossos filhos Me abandonardes, não obedecendo aos meus mandamentos e estatutos que vos dei, indo servir a outros deuses e prostrando-vos diante deles,"
,"7":"então arrancarei Israel da terra que lhe dei; afastarei para longe de Mim este Templo que consagrei ao meu Nome, e Israel será motivo de riso e chacota entre os povos;"
,"8":"então, este Templo, que é tão grandioso, tornar-se-á motivo de espanto para os que passarem diante dele. Eles vão assobiar e dizer: «Por que motivo Javé tratou assim esta terra e este Templo?»"
,"9":"E responderão: 'Foi porque eles abandonaram Javé seu Deus, que tirou os seus antepassados da terra do Egipto. Eles aderiram a outros deuses, prostrando-se diante deles e servindo-os. Foi por isso que Javé seu Deus mandou sobre eles todas essas desgraças'»."
,"10":"Durante vinte anos, Salomão construiu os dois edifícios, o Templo de Javé e o palácio real."
,"11":"E Hiram, rei de Tiro, forneceu a Salomão madeira de cedro, cipreste, ouro e tudo o que ele quis. Quando terminou as construções, o rei Salomão deu a Hiram vinte cidades no território da Galileia."
,"12":"Hiram saiu de Tiro para ver as cidades que Salomão lhe havia dado e não gostou delas."
,"13":"E protestou: «Meu irmão, que cidades são estas que me deste?» E chamou a essas cidades Terra de Cabul. E até hoje elas têm esse nome."
,"14":"E Hiram enviou ao rei Salomão quatro mil quilos de ouro."
,"15":"É o seguinte o relatório sobre os trabalhos forçados que o rei Salomão usou para construir o Templo de Javé, o seu palácio, o aterro, a muralha de Jerusalém, Hasor, Meguido, Gazer ("
,"16":"o Faraó, rei do Egipto, tinha feito uma expedição e apoderara-se de Gazer, incendiando-a e massacrando os cananeus que ali habitavam; depois deu Gazer como dote à sua filha, esposa de Salomão,"
,"17":"o qual a reconstruiu), Bet-Horon Inferior,"
,"18":"Baalat, Tamar, no deserto,"
,"19":"as cidades-entrepostos que lhe pertenciam, as cidades para guardar os carros e cavalos, e tudo o que julgou necessário construir em Jerusalém, no Líbano e nos países que lhe estavam submissos."
,"20":"Toda a população que restava dos amorreus, heteus, ferezeus, heveus e jebuseus, que não eram israelitas,"
,"21":"os filhos deles que ficaram no país e que os israelitas não haviam consagrado ao extermínio, Salomão recrutou-os para os trabalhos forçados até hoje."
,"22":"Salomão, porém, não reduziu os israelitas à escravidão, mas estavam ao seu serviço como soldados, funcionários, chefes, escudeiros, comandantes de carros e de cavalaria."
,"23":"Havia quinhentos e cinquenta chefes de inspectores que dirigiam os trabalhos de Salomão; eles dirigiam o pessoal que realizava os trabalhos."
,"24":"Salomão construiu o aterro logo depois de a filha do Faraó ter mudado da Cidade de David para o palácio que ele lhe construiu."
,"25":"Três vezes por ano, Salomão ofere-cia holocaustos e sacrifícios de comunhão sobre o altar que tinha construído a Javé. Ele queimava incenso diante de Javé e conservava o Templo em bom estado."
,"26":"O rei Salomão construiu uma frota em Asiongaber, perto de Elat, nas margens do Mar Vermelho, no país de Edom."
,"27":"Hiram enviou os seus servos marinheiros que conheciam bem o mar, para os navios com os servos de Salomão."
,"28":"Chegaram a Ofir donde trouxeram catorze mil quilos de ouro, que entregaram ao rei Salomão."
}`)
	CurrentBook.AddChapter(10, `{
"1":"A rainha de Sabá ouviu falar da fama de Salomão e foi submeter o rei à prova por meio de enigmas."
,"2":"Chegou a Jerusalém com uma imponente comitiva de camelos carregados de perfumes, muito ouro e pedras preciosas. Apresentou-se a Salomão e propôs-lhe tudo o que pensava."
,"3":"Salomão, porém, soube responder a todas as suas perguntas; não houve nenhuma pergunta demasiado difícil a que o rei não conseguisse responder."
,"4":"A rainha de Sabá ficou assombrada ao ver a sabedoria de Salomão, o palácio que havia construído,"
,"5":"as iguarias da sua mesa, a corte sentada, os serviços e uniformes dos empregados, as bebidas, os holocaustos que Salomão oferecia no Templo de Javé."
,"6":"Então disse ao rei: «É verdade tudo o que ouvi na minha terra a respeito de ti e da tua sabedoria."
,"7":"Eu não queria acreditar no que me diziam antes de vir para ver com os meus próprios olhos. O que me contaram não é nem metade: a tua sabedoria e riqueza são muito maiores do que eu tinha ouvido."
,"8":"A tua gente e os teus servos é que são felizes: podem desfrutar continuamente da tua presença e aprender da tua sabedoria!"
,"9":"Bendito seja Javé, teu Deus, que foi benevolente e te colocou sobre o trono de Israel. Javé ama Israel para sempre, e é por isso que te nomeou rei, a fim de exerceres o direito e a jus-tiça»."
,"10":"Então a rainha de Sabá deu ao rei quatro toneladas de ouro, grande quan-tidade de perfumes e de pedras precio-sas. Nunca houve tantos perfumes como os que a rainha de Sabá deu ao rei Salomão."
,"11":"Por sua vez, a frota de Hiram, que tinha trazido ouro de Ofir, trouxe também grande quantidade de madeira de sândalo e pedras preciosas."
,"12":"Com o sândalo, Salomão fez balaustradas para o Templo de Javé e para o palácio real, cítaras e harpas para os cantores. Nunca mais chegou madeira de sândalo como aquela, e nunca mais se viu dela até hoje."
,"13":"Em troca, o rei Salomão ofereceu à rainha de Sabá tudo o que ela quis e pediu, além do que o próprio rei a presenteou com grandiosidade. Depois a rainha de Sabá partiu e voltou com a sua comitiva para a sua terra."
,"14":"O ouro que Salomão recebia anualmente pesava vinte e três mil quilos,"
,"15":"sem contar o que recebia de tributo dos mercadores e do lucro dos comerciantes, dos reis da Arábia e dos governadores do país."
,"16":"O rei Salomão fez duzentos escudos grandes de ouro batido, gastando seis quilos e meio em cada escudo;"
,"17":"trezentos pequenos escudos de ouro batido, gastando meio quilo de ouro em cada um deles, e colocou-os no salão chamado Floresta do Líbano."
,"18":"O rei fez também um grande trono de marfim, revestido de ouro puro."
,"19":"O trono tinha seis degraus, com encosto arredondado na parte de cima, braços de cada lado do assento, dois leões de pé perto dos braços,"
,"20":"e doze leões colocados em cada lado dos seis degraus. Nunca se havia feito coisa igual em nenhum reino."
,"21":"Todas as taças que o rei Salomão usava para beber eram de ouro, e toda a baixela do salão da Floresta do Líbano era também de ouro puro. Não se fazia nada em prata, que não tinha valor no tempo de Salomão."
,"22":"De facto, o rei tinha no mar uma frota de grandes navios, juntamente com a frota de Hiram, e de três em três anos chegavam os navios carregados de ouro, prata, marfim, macacos e pavões."
,"23":"E o rei Salomão superou em riqueza e sabedoria todos os reis da terra."
,"24":"Toda a gente desejava visitar Salomão, para aprender a sabedoria que Deus lhe havia dado."
,"25":"E todos lhe traziam os seus presentes: vasilhas de prata e ouro, roupas, armas e aromas, cavalos e mulas."
,"26":"Salomão reuniu também carros e cavaleiros: tinha mil e quatrocentos carros e doze mil cavaleiros, que ficavam nas cidades dos carros e junto do rei em Jerusalém."
,"27":"Salomão fez com que a prata fosse tão comum em Jerusalém como as pedras, e os cedros como os sicômoros da Planície."
,"28":"Os cavalos de Salomão eram importados do Egipto e da Cilícia, onde os mercadores do rei os compravam com pagamento à vista."
,"29":"Cada carro era importado do Egipto por seis quilos e meio de prata, e cada cavalo por um quilo e meio. Os cavalos eram exportados, nas mesmas condições, para os reis dos heteus e os reis de Aram."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Além da filha do Faraó, o rei Salomão amou muitas mulheres estrangeiras: moabitas, amonitas, edomitas, sidónias e heteias."
,"2":"Essas mulheres pertenciam àquelas nações, das quais Javé tinha dito aos israelitas: «Não entrareis em contacto com elas, nem elas entrarão em contacto convosco. De contrário, elas acabarão por desviar o vosso coração para os seus deuses». Salomão, porém, enamorou-se perdidamente por elas:"
,"3":"teve setecentas esposas e trezentas concubinas."
,"4":"Quando ficou velho, as mulheres desviaram-lhe o coração para os deuses estrangeiros. E o coração de Salomão já não pertencia inteiramente a Javé, seu Deus, como o coração de seu pai David."
,"5":"Salomão seguiu Astarte, deusa dos sidónios, e Melcom, ídolo dos amonitas."
,"6":"Fez o que Javé reprova, e não foi plenamente fiel a Javé, como o seu pai David."
,"7":"Salomão construiu um santuário a Camos, ídolo dos moabitas, no monte a Leste de Jerusalém, e um santuário a Melcom, ídolo dos amonitas."
,"8":"Fez o mesmo para agradar às suas mulheres estrangeiras, que queimavam incenso e ofereciam sacrifícios aos seus deuses."
,"9":"Javé irritou-Se contra Salomão, porque o seu coração se tinha desviado de Javé, o Deus de Israel, que lhe tinha aparecido duas vezes"
,"10":"e havia proibido expressamente que Salomão seguisse outros deuses. Salomão, porém, não obedeceu ao que Javé lhe tinha ordenado."
,"11":"Então Javé disse a Salomão: «Já que te estás a comportar assim e não observas a minha aliança e as ordens que te dei, vou tirar-te o reino e entregá-lo a um dos teus servos."
,"12":"Não farei isso enquanto estiveres vivo, em consideração ao teu pai David. Eu arrancarei o reino da mão do teu filho."
,"13":"Não lhe tirarei o reino todo; deixarei ao teu filho uma tribo, em consideração ao meu servo David e a Jerusalém, a cidade que escolhi»."
,"14":"Javé fez surgir um adversário contra Salomão; era Adad, o edomita, da família real de Edom."
,"15":"Depois de David ter derrotado Edom, aconteceu que Joab, chefe do exército, foi enterrar os mortos e matou todos os homens de Edom."
,"16":"Joab e o exército israelita ficaram ali durante seis meses, até acabar com todos os homens de Edom."
,"17":"Adad, porém, conseguiu fugir para o Egipto com alguns edomitas, servos de seu pai. Adad era ainda criança."
,"18":"Partindo de Madiã, eles chegaram a Farã, ali juntaram alguns homens, foram para o Egipto e apresentaram-se ao Faraó, rei do Egipto. O Faraó deu a Adad uma casa, víveres e um terreno."
,"19":"Adad ganhou a simpatia do Faraó, que lhe deu como esposa a sua cunhada, irmã da rainha Táfnis."
,"20":"A mulher de Adad deu-lhe um filho, Genubat, e Táfnis educou-o no palácio do Faraó, de modo que Genubat morava no palácio com os filhos do Faraó."
,"21":"No Egipto, Adad ouviu dizer que David tinha morrido e que Joab, chefe do exército, também estava morto. Então pediu ao Faraó: «Deixa-me voltar para a minha terra»."
,"22":"O Faraó perguntou: «Queres voltar para a tua terra? Falta-te alguma coisa aqui em casa?» Adad respondeu: «Não me falta nada, mas deixa-me partir»."
,"23":"Javé fez surgir contra Salomão outro inimigo: era Razon, filho de Eliada, que tinha fugido do seu senhor Adadezer, rei de Soba."
,"24":"Razon reuniu-se com outros homens e tornou-se chefe de um bando. Quando David os dizimou, Razon foi para Damasco, onde se estabeleceu, e tornou-se rei de Damasco."
,"25a":"Razon foi adversário de Israel durante todo o reinado de Salomão."
,"25b":"Adad reinou em Edom, e não deixou Israel em paz."
,"26":"Jeroboão, filho de Nabat, era um efraimita de Sareda, e sua mãe era uma viúva chamada Sarva. Jeroboão estava ao serviço de Salomão e revoltou-se contra o rei,"
,"27":"pelo motivo seguinte: Salomão estava a construir o aterro para tapar a brecha da Cidade de David, seu pai."
,"28":"Jeroboão era um homem valente e forte. Salomão, vendo que o jovem trabalhava bem, nomeou-o capataz dos trabalhos forçados da casa de José."
,"29":"Certo dia, Jeroboão estava a sair de Jerusalém e encontrou-se no caminho com o profeta Aías de Silo, que vestia um manto novo. Os dois estavam sozinhos no campo."
,"30":"Aías pegou no seu manto novo, rasgou-o em doze pedaços,"
,"31":"e disse a Jeroboão: «Toma dez pedaços para ti, porque assim diz Javé, Deus de Israel: 'Vou arrancar o reino das mãos de Salomão e dar-te-ei dez tribos."
,"32":"Ele ficará com uma tribo, por consideração ao meu servo David e a Jerusalém, a cidade que escolhi dentre todas as tribos de Israel."
,"33":"Isto porque Salomão Me abandonou para adorar Astarte, deusa dos sidónios, Camos, deus de Moab, e Melcom, deus dos amonitas. Ele não andou nos meus caminhos fazendo o que Eu aprovo; não observou os meus estatutos e normas, como fez o seu pai David."
,"34":"Contudo, não lhe tirarei da mão nenhuma parte do reino, pois tornei-o chefe durante todo o tempo da sua vida, em consideração ao meu servo David, a quem escolhi, e que observou os meus mandamentos e estatutos."
,"35":"É ao filho dele que eu vou tirar o reino, e vou dar-te dez tribos."
,"36":"Deixarei ao filho dele uma tribo, para que o meu servo David tenha sempre uma lâmpada diante de Mim, em Jerusalém, a cidade que escolhi para lá colocar o meu Nome."
,"37":"Quanto a ti, escolhi-te para reinares sobre o que quiseres. Tu vais ser o rei de Israel."
,"38":"Se obedeceres a tudo o que Eu mandar, se seguires os meus caminhos e fizeres o que Eu aprovo; se observares os meus estatutos e mandamentos, como fez o meu servo David, então Eu estarei contigo e edificarei para ti uma dinastia estável, como fiz a David. Entregar-te-ei Israel"
,"39":"e, por causa disso, humilharei a descendência de David, mas não para sempre'»."
,"40":"Salomão tentou matar Jeroboão. Mas Jeroboão fugiu para o Egipto, onde reinava Sesac, rei do Egipto. E ficou no Egipto até à morte de Salomão."
,"41":"O resto da história de Salomão, com todos os seus feitos e a sua sabedoria, tudo está escrito no Livro da História de Salomão."
,"42":"E Salomão reinou em Jerusalém, sobre todo o Israel, durante quarenta anos."
,"43":"Depois Salomão morreu e foi enterrado com os seus antepassados, na Cidade de David, seu pai. E seu filho Roboão sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Roboão foi para Siquém, pois todo o Israel para ali se havia dirigido, a fim de o proclamar rei."
,"2":"Jeroboão, filho de Nabat, soube da notícia quando ainda estava no Egipto, porque havia fugido do rei Salomão e morava no Egipto."
,"3":"Mandaram chamar Jeroboão, e ele também foi com toda a assembleia de Israel. Então disseram a Roboão:"
,"4":"«O teu pai impôs-nos um fardo pesado. Se nos aliviares da dura escravidão e do fardo pesado que ele nos impôs, nós servir-te-emos»."
,"5":"Roboão respondeu: «Retirai-vos e voltai à minha presença daqui a três dias». Então o povo retirou-se."
,"6":"O rei Roboão pediu conselho aos anciãos que serviam a seu pai Salomão, quando este ainda vivia, e perguntou-lhes: «O que é que me aconselhais a responder a este povo?»"
,"7":"Eles disseram: «Se hoje te colocares ao serviço deste povo, se o servires e lhe responderes com boas palavras, então eles colocar-se-ão para sempre ao teu serviço»."
,"8":"Roboão, porém, desprezou o conselho dos anciãos e foi aconselhar-se com os jovens que tinham crescido com ele e que o serviam."
,"9":"E perguntou-lhes: «O que é que me aconselhais a responder a este povo que me disse: 'Alivia-nos do jugo que o teu pai nos impôs'»?"
,"10":"Os jovens, que tinham crescido com ele, disseram: «A esse povo que disse: 'Teu pai tornou pesado o nosso fardo; alivia este fardo que pesa sobre nós', responderás: 'O meu dedo mínimo é mais grosso do que a cintura de meu pai."
,"11":"O meu pai colocou sobre vós um fardo pesado. Pois bem! Eu aumentarei sobre vós esse fardo. Meu pai castigou-vos com chicotes, e eu castigar-vos-ei com ferrões'»."
,"12":"Como o rei lhes havia dito que voltassem depois de três dias, Jeroboão e todo o povo foram ao encontro de Roboão ao terceiro dia."
,"13":"O rei então respondeu duramente ao povo. Desprezando o conselho que os anciãos lhe haviam dado,"
,"14":"falou conforme o conselho dos jovens: «Meu pai colocou sobre vós um fardo pesado. Pois bem! Eu aumentarei sobre vós esse fardo! Meu pai castigou-vos com chicotes, e eu castigar-vos-ei com ferrões»."
,"15":"O rei não deu ouvidos ao povo. Foi a maneira usada por Javé para realizar o que dissera a Jeroboão, filho de Nabat, por meio de Aías de Silo."
,"16":"Todo o Israel viu que o rei não lhe dava atenção. Por isso o povo retrucou: «Que temos nós a ver com David? Não temos herança com o filho de Jessé. Volta para as tuas tendas, Israel. Agora, cuida da tua casa, David!» E Israel voltou para as suas tendas."
,"17":"Quanto aos israelitas que moravam nas cidades de Judá, continuaram submetidos a Roboão."
,"18":"Então o rei Roboão enviou Aduram, chefe dos trabalhos forçados, mas todo o Israel o apedrejou, e ele morreu. O rei Roboão conseguiu subir para o seu carro e fugiu para Jerusalém."
,"19":"E Israel revoltou-se contra a casa de David, até ao dia de hoje."
,"20":"Ao saber que Jeroboão tinha voltado, mandaram-no chamar para a assembleia, e proclamaram-no rei sobre todo o Israel. Somente a tribo de Judá seguiu a casa de David."
,"21":"Roboão foi para Jerusalém e reuniu toda a casa de Judá e a tribo de Benjamim: cento e oitenta mil guerreiros. Era para lutar contra a casa de Israel e restituir o reino a Roboão, filho de Salomão."
,"22":"Então a palavra de Deus foi dirigida a Semeías, homem de Deus:"
,"23":"«Diz a Roboão, filho de Salomão, rei de Judá, a toda a casa de Judá e de Benjamim, e ao resto do povo:"
,"24":"'Assim diz Javé: Não subais para lutar contra os vossos irmãos israelitas. Volte cada um para a sua casa, porque tudo o que aconteceu foi por minha decisão'». Eles obedeceram à palavra de Javé e regressaram, conforme a palavra de Javé."
,"25":"Jeroboão fortificou Siquém, na região montanhosa de Efraim, e ali residiu. Depois saiu dali e fortificou Fanuel."
,"26":"Jeroboão pensou: «Agora o reino poderá voltar para a casa de David."
,"27":"Se este povo for oferecer sacrifícios ao Templo de Javé em Jerusalém, o seu coração voltar-se-á para o seu senhor Roboão, rei de Judá. Eles acabarão por matar-me e voltar para Roboão, rei de Judá»."
,"28":"Então Jeroboão teve a ideia de fazer dois bezerros de ouro. E disse ao povo: «Não subais mais a Jerusalém. Israel, aqui está o teu Deus, Aquele que te tirou da terra do Egipto»."
,"29":"Colocou um dos bezerros em Betel e instalou o outro em Dã. Isso foi ocasião de pecado."
,"30":"O povo ia até Dã para adorar o bezerro."
,"31":"Jeroboão fez santuários nos lugares altos, e estabeleceu como sacerdotes pessoas tiradas do povo, que não eram levitas."
,"32":"Jeroboão celebrou também uma festa no dia quinze do oitavo mês, como se celebrava em Judá, e subiu ao altar. Fez isso em Betel, para oferecer sacrifícios aos bezerros que tinha fabricado, e estabeleceu em Betel sacerdotes dos lugares altos que ele mesmo havia instituído."
,"33":"Subiu ao altar que tinha feito em Betel no dia quinze do oitavo mês, data que escolheu arbitrariamente. Ele instituiu uma festa para os israelitas e subiu ao altar para queimar incenso."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Quando Jeroboão estava junto do altar a queimar incenso, chegou de Judá a Betel um homem de Deus, mandado por Javé."
,"2":"Ele gritou contra o altar esta ordem de Javé: «Altar, altar! Assim diz Javé: Um filho vai nascer na casa de David, e chamar-se-á Josias. Ele vai oferecer em sacrifício, sobre ti, os sacerdotes dos lugares altos que sobre ti queimam incenso. Ossos humanos serão queimados sobre ti!»"
,"3":"Nesse dia, o homem deu um sinal, dizendo: «Este é o sinal que Javé apresenta: o altar vai rachar, e a cinza que está sobre ele cairá por terra»."
,"4":"Ao ouvir as palavras que o homem de Deus gritava contra o altar de Betel, o rei Jeroboão estendeu o braço, que tinha posto sobre o altar, e disse: «Prendei esse homem!» Mas o braço estendido ficou paralisado, e ele não conseguia retirá-lo."
,"5":"O altar rachou, e a cinza do altar espalhou-se, conforme o sinal que o homem de Deus tinha dado por ordem de Javé."
,"6":"Então o rei suplicou ao homem de Deus: «Por favor, acalma Javé, o teu Deus. Pede-Lhe por mim, para que eu recupere o movimento do braço!» Então o homem de Deus acalmou Javé, e o rei recuperou o movimento do braço, que ficou como antes."
,"7":"O rei disse então ao homem de Deus: «Vem comigo até ao meu palácio para restaurares as tuas forças. Dar-te-ei um presente»."
,"8":"O homem de Deus respondeu ao rei: «Mesmo que me desses metade do teu palácio, não iria contigo. Não comerei nem beberei nada neste lugar,"
,"9":"pois a palavra de Javé ordenou-me que eu não comesse nem bebesse, e que eu não voltasse pelo mesmo caminho por onde vim»."
,"10":"E o homem de Deus partiu por outro caminho, e não voltou pelo mesmo caminho que tinha utilizado para chegar a Betel."
,"11":"Um velho profeta morava em Betel. Seus filhos foram e contaram-lhe tudo o que o homem de Deus havia feito naquele dia em Betel; referiram também ao pai as palavras que o homem havia dito ao rei."
,"12":"O pai disse-lhes: «Qual é o caminho que ele tomou?» Os filhos mostraram ao pai o caminho que o homem de Deus, vindo de Judá, tinha seguido."
,"13":"O profeta ordenou aos filhos: «Selai o meu jumento». Selaram então o jumento. Ele montou,"
,"14":"foi à procura do homem de Deus, e encontrou-o sentado debaixo de uma árvore. E perguntou-lhe: «És tu o homem de Deus que veio de Judá?» O homem respondeu: «Sou»."
,"15":"Então ele disse ao homem: «Vem comigo comer alguma coisa na minha casa»."
,"16":"Ele respondeu: «Eu não posso voltar nem ir contigo à tua casa. Eu não posso comer nem beber nada neste lugar,"
,"17":"porque a palavra de Javé ordenou-me que eu não comesse nem bebesse nada aqui, e que eu não voltasse pelo mesmo caminho por onde vim»."
,"18":"O profeta disse ao homem de Deus: «Eu também sou profeta como tu, e um anjo trouxe-me uma palavra de Javé, dizendo: 'Faz com que ele vá até à tua casa para comer e beber'». No entanto, ele estava a mentir."
,"19":"O homem de Deus voltou, comeu e bebeu na casa dele."
,"20":"Quando eles estavam a comer, a palavra de Javé foi dirigida ao profeta que o tinha feito voltar"
,"21":"e este gritou ao homem de Deus que tinha vindo de Judá: «Assim diz Javé: Porque transgrediste a ordem de Javé e não obedeceste ao mandamento que Javé teu Deus te ordenou,"
,"22":"voltaste, comeste e bebeste neste lugar no qual te proibira comer e beber, o teu cadáver não entrará no túmulo de teus pais»."
,"23":"Depois de ter comido e bebido, o velho profeta selou o jumento do profeta que ele tinha feito voltar, e este foi-se embora."
,"24":"No caminho, encontrou um leão que o matou. O seu cadáver ficou estendido no caminho, enquanto o jumento permaneceu parado de um lado do cadáver e o leão do outro lado."
,"25":"Alguns homens, que passaram por ali, viram o cadáver estendido no caminho e o leão ao lado do cadáver. Eles foram e contaram, na cidade onde morava o velho profeta, tudo o que tinham visto."
,"26":"Ao ouvir isto, o profeta que o havia feito voltar, disse: «Deve ser o homem de Deus que desobedeceu à ordem de Javé. E Javé entregou-o ao leão, que o matou e dilacerou, como Javé havia predito»."
,"27":"Então ordenou a seus filhos: «Selai o meu jumento». Os filhos selaram-no."
,"28":"O profeta partiu e encontrou o cadáver estendido no caminho, com o jumento e o leão ao lado; o leão não tinha devorado o cadáver, nem dilacerado o jumento."
,"29":"O profeta ergueu o cadáver do homem de Deus, acomodou-o sobre o jumento e levou-o para a cidade onde morava, para fazer o funeral e enterrá-lo."
,"30":"Colocou o cadáver no seu próprio túmulo, e cantou a lamentação: «Ai, meu irmão!»"
,"31":"Depois de o ter enterrado, o profeta disse aos seus filhos: «Quando eu morrer, enterrai-me na sepultura onde está enterrado este profeta. Colocai os meus ossos ao lado dos ossos dele,"
,"32":"porque certamente vai cumprir-se a maldição que ele gritou, por ordem de Javé, contra o altar de Betel e contra todos os santuários dos lugares altos, que estão nas cidades da Samaria»."
,"33":"Apesar disso, Jeroboão não se converteu do seu mau comportamento; continuou a nomear homens do povo como sacerdotes dos lugares altos. Todo aquele que o desejasse, ele consagrava-o sacerdote dos lugares altos."
,"34":"Esse comportamento fez cair em pecado a dinastia de Jeroboão e provocou a sua ruína e o extermínio do país."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Nessa época, Abias, filho de Jeroboão, ficou doente."
,"2":"E Jeroboão disse à sua mulher: «Disfarça-te para que não reconheçam que és a esposa de Jeroboão. Vai a Silo, onde está o profeta Aías. Ele profetizou-me que eu seria rei deste povo."
,"3":"Leva dez pães, roscas e um pote de mel, e apresenta-te a ele. Então ele dirá o que vai acontecer a este menino»."
,"4":"A mulher de Jeroboão assim fez. Foi a Silo e apresentou-se na casa de Aías. Ora, Aías estava quase cego e tinha os olhos meio apagados por causa da velhice."
,"5":"Javé, porém, tinha-lhe dito: «A esposa de Jeroboão virá aqui para te pedir um oráculo sobre o filho dele que está doente. Diz-lhe isto e isto. Ela virá disfarçada»."
,"6":"Logo que Aías ouviu o barulho de passos junto à porta, disse: «Entra, esposa de Jeroboão. Porque vens disfarçada? Fui enviado para te dar uma triste notícia."
,"7":"Diz a Jeroboão: 'Assim diz Javé, Deus de Israel: Eu tirei-te do meio do povo e coloquei-te como chefe do meu povo Israel."
,"8":"Tirei o reino à casa de David para o dar a ti. Mas tu não foste como o meu servo David, que observou os meus mandamentos e Me seguiu de todo o coração, fazendo apenas o que Eu aprovo."
,"9":"Comportaste-te de modo pior do que os que reinaram antes de ti. E até chegaste a fazer para ti outros deuses, imagens fundidas, para Me irritar, e voltaste-Me as costas."
,"10":"Por isso, vou enviar a desgraça à tua casa: eliminarei da casa de Jeroboão todos os varões, tanto os escravos como os livres em Israel. Eu varrerei a casa de Jeroboão, como se varre completamente o lixo."
,"11":"Os membros da família de Jeroboão que morrerem na cidade, serão devorados pelos cães; e os que morrerem no campo, serão devorados pelas aves do céu. É isto o que Javé tem a dizer'."
,"12":"Quanto a ti, levanta-te e volta para casa. Quando puseres os pés na cidade, o menino morrerá."
,"13":"Todo o Israel fará luto por ele e o enterrará, porque, da família de Jeroboão, somente este menino entrará num túmulo. De facto, dentro da família de Jeroboão, foi somente nele que Javé, Deus de Israel, encontrou alguma coisa de bom."
,"14":"Javé fará surgir em Israel um rei que vai eliminar a família de Jeroboão."
,"15":"Javé ferirá Israel como se faz com o caniço que é levado pelas águas: arrancará os israelitas desta boa terra que deu aos seus antepassados, e dispersá-los-á no outro lado do rio Eufrates, porque ergueram os seus postes sagrados, provocando a ira de Javé."
,"16":"Entregará os israelitas por causa dos pecados cometidos por Jeroboão e por causa dos pecados que ele fez cometer aos israelitas»."
,"17":"A mulher de Jeroboão levantou-se e partiu. E ao chegar a Tersa, mal ela atravessou a soleira da porta da casa, o menino morreu."
,"18":"E o menino foi enterrado, e todo o Israel fez luto por ele, como Javé havia dito por meio do seu servo, o profeta Aías."
,"19":"O resto da história de Jeroboão, as guerras que ele fez, o seu governo, tudo está escrito nos Anais dos Reis de Israel."
,"20":"Jeroboão reinou durante vinte e dois anos. Depois foi enterrado com os seus antepassados, e seu filho Nadab sucedeu-lhe no trono."
,"21":"Roboão, filho de Salomão, reinou em Judá. Tinha quarenta e um anos quando subiu ao trono. E reinou dezassete anos em Jerusalém, a cidade que Javé tinha escolhido entre todas as tribos de Israel, para ali colocar o seu Nome. A mãe de Roboão chamava-se Naama, a amonita."
,"22":"Os habitantes de Judá fizeram o que Javé reprova e provocaram o seu ciúme por causa dos pecados que cometeram, e que foram maiores do que os pecados cometidos pelos seus antepassados."
,"23":"Eles construíram lugares altos, ergueram estelas e postes sagrados nas colinas elevadas e debaixo de toda a árvore frondosa."
,"24":"Houve até prostituição sagrada no país. Imitaram todos os ritos abomináveis das nações que Javé havia expulsado da frente dos israelitas."
,"25":"No quinto ano do reinado de Roboão, aconteceu que Sesac, rei do Egipto, atacou Jerusalém."
,"26":"Tomou posse dos tesouros do Templo de Javé e do palácio real, e levou tudo, juntamente com os escudos de ouro que Salomão tinha mandado fazer."
,"27":"Para os substituir, o rei Roboão mandou fazer escudos de bronze, e confiou-os aos chefes da guarda que vigiavam a porta do palácio real."
,"28":"Cada vez que o rei ia ao Templo de Javé, os guardas levavam esses escudos e depois recolocavam-nos na sala dos guardas."
,"29":"O resto da história de Roboão e de tudo o que ele fez está escrito nos Anais dos Reis de Judá."
,"30":"Houve guerras contínuas entre Roboão e Jeroboão."
,"31":"Roboão morreu e foi enterrado com os seus antepassados na Cidade de David, e seu filho Abiam sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Abiam subiu ao trono de Judá no ano dezoito de Jeroboão, filho de Nabat."
,"2":"E reinou três anos em Jerusalém. Sua mãe chamava-se Maaca, e era filha de Absalão."
,"3":"Abiam imitou os pecados que seu pai havia cometido, e o seu coração não foi fiel a Javé, seu Deus, como tinha sido o coração de David, seu antepassado."
,"4":"Em consideração para com David, Javé seu Deus deixou-lhe uma lâmpada em Jerusalém, dando-lhe um filho e conservando Jerusalém."
,"5":"Isto porque David tinha feito o que Javé aprova, sem se desviar do que Javé lhe havia ordenado, em toda a sua vida, com excepção do caso de Urias, o heteu."
,"6":"Houve guerras contínuas entre Abiam e Jeroboão."
,"7":"O resto da história de Abiam e de tudo o que ele fez está escrito nos Anais dos Reis de Judá."
,"8":"Abiam morreu e foi enterrado com os seus antepassados na Cidade de David. E seu filho Asa sucedeu-lhe no trono."
,"9":"Asa subiu ao trono de Judá no ano vinte do reinado de Jeroboão em Israel."
,"10":"Reinou durante quarenta e um anos em Jerusalém. Sua avó chamava-se Maaca, filha de Absalão."
,"11":"Asa fez o que Javé aprova, como fizera o seu antepassado David."
,"12":"Expulsou do país a prostituição sagrada e retirou todos os ídolos que os seus antepassados haviam feito."
,"13":"Chegou até mesmo a retirar à sua avó o título de rainha-mãe, porque ela havia feito uma imagem de Aserá. Asa quebrou a imagem e queimou-a no vale do Cedron."
,"14":"Os lugares altos não desapareceram, mas o coração de Asa foi fiel a Javé durante toda a sua vida."
,"15":"Ele depositou no Templo de Javé as ofertas que seu pai havia consagrado e as suas próprias ofertas: prata, ouro e utensílios."
,"16":"Entre Asa e Baasa, rei de Israel, houve guerras contínuas."
,"17":"Baasa, rei de Israel, atacou Judá e fortificou Ramá, para impedir as comunicações com Asa, rei de Judá."
,"18":"Então Asa tomou a prata e o ouro que restavam nos tesouros do Templo de Javé e do palácio real, entregou-os aos seus servos e mandou-os a Ben-Adad, filho de Tabremon, filho de Hezion, rei de Aram, que residia em Damasco, com esta mensagem:"
,"19":"«Vamos fazer um tratado de paz, como fizeram o teu pai e o meu. Aqui te envio um presente de prata e ouro. Rompe a tua aliança com Baasa, rei de Israel, para que ele se retire do meu território»."
,"20":"Ben-Adad concordou com o rei Asa e enviou os chefes do seu exército contra as cidades de Israel; conquistou Aion, Dã, Abel-Betel-Maaca, a região do Neftali."
,"21":"Ao saber disso, Baasa suspendeu as obras em Ramá e voltou para Tersa."
,"22":"Então o rei Asa convocou todo o povo de Judá, sem excepção. Tiraram as pedras e madeiras com que Baasa estava a fortificar Ramá, e aproveitaram-nas para fortificar Gaba de Benjamim e Masfa."
,"23":"O resto da história de Asa, as suas façanhas militares e as cidades que construiu, tudo está escrito nos Anais dos Reis de Judá. Na sua velhice, Asa teve a doença da gota nos pés."
,"24":"Asa morreu e foi enterrado com os seus antepassados na Cidade de David, seu pai. E seu filho Josafá sucedeu-lhe no trono."
,"25":"Nadab, filho de Jeroboão, subiu ao trono de Israel no segundo ano do reinado de Asa, rei de Judá. Reinou dois anos em Israel."
,"26":"Fez o que Javé reprova: imitou o comportamento de seu pai e os pecados que ele fizera cometer em Israel."
,"27":"Baasa, filho de Aías, da tribo de Issacar, conspirou contra ele e assassinou-o em Gebeton, cidade filisteia, que Nadab e todo o Israel estavam cercando."
,"28":"Baasa matou-o no terceiro ano de Asa, rei de Judá, e sucedeu-lhe no trono."
,"29":"Logo que se tornou rei, Baasa matou toda a família de Jeroboão e massacrou-a, sem deixar nenhum sobrevivente, conforme a predição que Javé tinha feito por meio do seu servo Aías de Silo."
,"30":"A causa foram os pecados que ele cometera e fizera cometer a Israel, provocando a indignação de Javé, Deus de Israel."
,"31":"O resto da história de Nadab, e tudo o que ele fez, está escrito nos Anais dos Reis de Israel."
,"32":"Houve guerras contínuas entre Asa e Baasa, rei de Israel."
,"33":"Baasa, filho de Aías, subiu ao trono de Israel, em Tersa, no terceiro ano do reinado de Asa, rei de Judá. Reinou durante vinte e quatro anos."
,"34":"Fez o que Javé reprova, imitando o comportamento de Jeroboão e o pecado que ele fizera cometer a Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Então Javé dirigiu a sua palavra a Jeú, filho de Hanani, contra Baasa, dizendo:"
,"2":"«Eu tirei-te do pó e tornei-te chefe do meu povo Israel. Tu, porém, imitaste o comportamento de Jeroboão e fizeste com que o meu povo Israel cometesse pecados que Me irritam."
,"3":"Por isso, varrerei Baasa e a sua família, e deixá-la-ei como a família de Jeroboão, filho de Nabat."
,"4":"Todas as pessoas da família de Baasa, que morrerem na cidade, serão devoradas pelos cães, e quem morrer no campo será devorado pelas aves do céu»."
,"5":"O resto da história de Baasa, com as suas façanhas militares, está escrito nos Anais dos Reis de Israel."
,"6":"Baasa morreu e foi enterrado com os seus antepassados em Tersa. E seu filho Ela sucedeu-lhe no trono."
,"7":"Por meio do profeta Jeú, filho de Hanani, Javé dirigiu a sua palavra a Baasa e família, por ter imitado a família de Jeroboão, fazendo o que Javé reprova e irritando-O com as suas acções, e também porque exterminara a família de Jeroboão."
,"8":"Ela, filho de Baasa, subiu ao trono de Israel, em Tersa, no ano vinte e seis do reinado de Asa, rei de Judá. Reinou dois anos."
,"9":"O seu oficial Zambri, chefe de metade dos seus carros, conspirou contra ele, enquanto Ela se embebedava em Tersa, na casa de Arsa, mordomo do palácio."
,"10":"Zambri entrou e assassinou-o no ano vinte e sete do reinado de Asa, rei de Judá. E reinou em lugar de Ela."
,"11":"Logo que se tornou rei, Zambri massacrou toda a família de Baasa, eliminando todos os varões, tanto parentes como amigos de Baasa."
,"12":"Zambri acabou com a família de Baasa, como Javé havia predito contra Baasa, por meio do profeta Jeú."
,"13":"A causa disso foram os pecados que Baasa e seu filho Ela tinham cometido e fizeram cometer a Israel. Com os seus ídolos vazios, irritaram Javé, Deus de Israel."
,"14":"O resto da história de Ela, e de tudo o que fez, está escrito nos Anais dos Reis de Israel."
,"15":"Zambri ocupou o trono em Tersa durante sete dias, no ano vinte e sete do reinado de Asa, rei de Judá. Nessa ocasião, o exército estava acampado diante de Gebeton, que pertencia aos filisteus."
,"16":"Quando o acampamento recebeu a notícia de que Zambri tinha conspirado e matado o rei, os soldados proclamaram imediatamente Amri, chefe do exército, como rei de Israel."
,"17":"Amri saiu de Gebeton com todo o exército de Israel, e cercou Tersa."
,"18":"Quando Zambri percebeu que a cidade ia ser tomada, fechou-se na torre do palácio, deitou fogo ao palácio e morreu lá dentro."
,"19":"Isto aconteceu por causa do pecado que havia cometido. Ele fez o que Javé reprova, imitando o comportamento de Jeroboão e o pecado que este havia feito cometer a Israel."
,"20":"O resto da história de Zambri, e a conspiração que ele tramou, tudo está escrito nos Anais dos Reis de Israel."
,"21":"Os israelitas dividiram-se: metade apoiou Tebni, filho de Ginet, querendo proclamá-lo rei; a outra metade apoiou Amri."
,"22":"O partido de Amri acabou por vencer o de Tebni, filho de Ginet. Tebni morreu, e Amri tornou-se rei."
,"23":"Amri subiu ao trono de Israel no ano trinta e um do reinado de Asa, rei de Judá. Reinou doze anos. Nos primeiros seis anos, reinou em Tersa."
,"24":"Depois comprou a Semer o monte da Samaria por setenta quilos de prata. Construiu ali uma cidade e deu-lhe o nome de Samaria, por causa do nome de Semer, dono do monte."
,"25":"Amri fez o que Javé reprova e foi o pior de todos os que vieram antes dele."
,"26":"Imitou em tudo o comportamento de Jeroboão, filho de Nabat, e os pecados que este fizera cometer a Israel. Com os seus ídolos vazios, irritou Javé, Deus de Israel."
,"27":"O resto da história de Amri, com as suas façanhas militares, tudo está escrito nos Anais dos Reis de Israel."
,"28":"Amri morreu e foi enterrado em Samaria. E o seu filho Acab sucedeu-lhe no trono."
,"29":"Acab, filho de Amri, subiu ao trono de Israel no ano trinta e oito do reinado de Asa, rei de Judá. Reinou sobre Israel, em Samaria, vinte e dois anos."
,"30":"Acab, filho de Amri, fez o que Javé reprova, mais do que todos os que vieram antes dele."
,"31":"Além de imitar os pecados de Jeroboão, filho de Nabat, casou-se com Jezabel, filha de Etbaal, rei dos sidónios. E começou a servir e adorar a Baal."
,"32":"Chegou a construir em Samaria um templo e um altar a Baal."
,"33":"Acab levantou também um poste sagrado e cometeu outros pecados, irritando Javé, Deus de Israel, mais do que todos os reis de Israel que vieram antes dele."
,"34":"No seu tempo, Hiel de Betel reconstruiu Jericó: os alicerces custaram-lhe a vida do seu primogénito Abiram, e as portas custaram a vida de Segub, seu filho mais novo, como Javé havia predito por meio de Josué, filho de Nun."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Elias, o tesbita de Tesbi de Galaad, disse ao rei Acab: «Pela vida de Javé, o Deus de Israel, a quem sirvo: nestes anos não haverá orvalho nem chuva, a não ser quando eu mandar»."
,"2":"Javé dirigiu a palavra a Elias:"
,"3":"«Sai daqui, dirige-te para o Oriente e esconde-te junto da torrente Carit, que fica a Leste do Jordão."
,"4":"Poderás beber água da torrente. Eu ordenei aos corvos que te levem comida»."
,"5":"Então Elias partiu e fez como Javé tinha mandado: foi morar junto da torrente Carit, a Leste do Jordão."
,"6":"Os corvos levavam-lhe pão de manhã e carne à tarde. E ele bebia água da torrente."
,"7":"Algum tempo depois, a torrente secou, porque não tinha chovido na região."
,"8":"Então Javé dirigiu a palavra a Elias:"
,"9":"Levanta-te, vai para Sarepta, que pertence à região de Sidónia, e fica aí a morar. Porque Eu ordenei a uma viúva que te alimente»."
,"10":"«Elias levantou-se e foi para Sarepta. Chegando à porta da cidade, encontrou uma viúva que apanhava lenha. Elias chamou-a e disse: «Por favor! Traz-me um pouco de água no teu balde para eu beber»."
,"11":"Quando a mulher já ia buscar água, Elias gritou-lhe: «Traz-me também um pedaço de pão»."
,"12":"Ela respondeu: «Pela vida de Javé, teu Deus, não tenho nenhum pão feito; tenho apenas um pouco de farinha numa vasilha e um pouco de azeite na almotolia. Estou a apanhar alguma lenha para preparar esse resto para mim e meu filho. Depois, vamos comer e ficar à espera da morte»."
,"13":"Mas Elias disse-lhe: «Não tenhas medo! Vai e faz como disseste. Mas primeiro prepara um pãozinho com o que tens e traz-mo. Só depois prepararás um pão para ti e para o teu filho."
,"14":"Pois assim diz Javé, Deus de Israel: A vasilha de farinha não ficará vazia e a almotolia de azeite não se esgotará, até ao dia em que Javé mandar chuva sobre a terra»."
,"15":"A mulher foi fazer o que Elias tinha mandado. E comeram, tanto ele como ela e o filho, durante muito tempo."
,"16":"A vasilha de farinha não se esvaziou e a almotolia de azeite não se esgotou, como Javé tinha anunciado por meio de Elias."
,"17":"Depois disto, ficou doente o filho desta mulher, dona da casa, e a doença foi tão grave que ele acabou por morrer."
,"18":"Então ela disse a Elias: «Não quero nada contigo, homem de Deus. Será que vieste à minha casa para me lembrar as minhas culpas e provocar a morte do meu filho?»"
,"19":"Elias respondeu: «Dá-me o teu filho». Tomando o menino dos braços dela, Elias levou-o até ao quarto de cima, onde se achava hospedado, e deitou-o sobre a sua própria cama."
,"20":"Depois chamou por Javé, dizendo: «Javé, meu Deus, queres castigar até esta viúva que me hospeda, fazendo-lhe morrer o filho?»"
,"21":"Então Elias estendeu-se três vezes sobre o menino e invocou Javé: «Ó Javé, meu Deus, faz que este menino ressuscite!»"
,"22":"Javé atendeu a súplica de Elias, e o menino ressuscitou, tornando a viver."
,"23":"Elias pegou no menino, desceu do quarto de cima e entregou-o à mãe, dizendo: «Olha, o teu filho está vivo»."
,"24":"A mulher respondeu a Elias: «Agora sei que és um homem de Deus, e que de facto anuncias a palavra de Javé»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Muito tempo depois, no terceiro ano, Javé dirigiu a sua palavra a Elias: «Vai apresentar-te a Acab, porque vou mandar chuva sobre a terra»."
,"2":"Elias partiu e foi apresentar-se a Acab. Ora, em Samaria, a fome apertava cada vez mais."
,"3":"Acab mandou chamar Abdias, que era o chefe do palácio. Abdias era homem temente a Javé:"
,"4":"quando Jezabel massacrava os profetas de Javé, ele tomou cem profetas e escondeu-os numa gruta, em grupos de cinquenta, providenciando-lhes comida e bebida."
,"5":"Acab disse a Abdias: «Vem, vamos andar pelo país, a procurar todas as fontes e riachos. Talvez possamos encontrar pasto para sustentar os cavalos e burros, a fim de que não morram esses animais»."
,"6":"Acab e Abdias dividiram entre si a região a percorrer: cada um foi para seu lado."
,"7":"Enquanto Abdias caminhava, Elias foi ao encontro dele. Abdias reconheceu-o, caiu com o rosto por terra, e perguntou: «Meu senhor, és tu Elias?»"
,"8":"Elias respondeu: «Sou eu mesmo. Vai dizer ao teu patrão que Elias está aqui»."
,"9":"Abdias replicou: «Que pecado cometi eu para que me entregues nas mãos de Acab, para ele me matar?"
,"10":"Pela vida de Javé, teu Deus: não há nação, nem reino, aonde o meu patrão não te tenha mandado procurar. E quando diziam: 'Elias não está aqui', o meu patrão fazia jurar o reino e a nação que não te encontravas ali."
,"11":"E agora mandas-me dizer ao meu patrão que Elias está aqui?!"
,"12":"Quando eu sair daqui, o espírito de Javé transportar-te-á não sei para onde. Eu irei informar Acab, e se ele não te encontrar, matar-me-á. Ora, o teu servo teme a Javé desde a juventude."
,"13":"Porventura, não te contaram o que fiz quando Jezabel matava os profetas de Javé? Escondi numa gruta cem profetas de Javé, em grupos de cinquenta, e providenciei-lhes pão e água."
,"14":"E agora, mandas-me dizer ao meu patrão que Elias está aqui?! Ele vai matar-me!»"
,"15":"Elias respondeu: «Pela vida de Javé dos exércitos, a quem sirvo: hoje mesmo vou apresentar-me diante de Acab»."
,"16":"Então Abdias foi ter com Acab e contou o que havia acontecido. E Acab saiu ao encontro de Elias."
,"17":"Logo que o viu, disse-lhe: «Tu és a ruína de Israel!»"
,"18":"Elias respondeu: «Não sou eu que arruíno Israel. Pelo contrário, és tu e a tua família, porque abandonastes Javé e seguistes os ídolos."
,"19":"Pois bem! Manda reunir todo o Israel comigo no monte Carmelo, com os quatrocentos e cinquenta profetas de Baal, que comem à mesa de Jezabel»."
,"20":"Acab convocou todos os israelitas e reuniu os profetas no monte Carmelo."
,"21":"Então Elias aproximou-se do povo e disse: «Até quando coxeareis com as duas pernas? Se Javé é o Deus verdadeiro, segui a Javé. Se é Baal, segui a Baal». O povo nada respondeu."
,"22":"Então Elias continuou: «Fiquei sozinho como profeta de Javé, enquanto que os profetas de Baal são quatrocentos e cinquenta."
,"23":"Trazei-nos dois bezerros: eles escolherão um. Depois de o cortarem em pedaços, coloquem-no sobre a lenha, mas não acendam o fogo. Eu vou preparar o outro bezerro, colocá-lo-ei sobre a lenha e também não acenderei o fogo."
,"24":"Vós invocareis o vosso deus e eu invocarei Javé. O Deus que responder, e enviar fogo, é o Deus verdadeiro». Todo o povo concordou: «A proposta é boa»."
,"25":"Então Elias disse aos profetas de Baal: «Escolhei um bezerro e preparai-o primeiro, pois sois mais numerosos. Invocai o nome do vosso deus, mas não acendais o fogo»."
,"26":"Então eles tomaram o bezerro, prepararam-no e puseram-se a invocar o nome de Baal, desde o amanhecer até ao meio-dia, suplicando: «Baal, responde-nos». Mas não se ouvia nenhuma voz, nenhuma resposta, apesar de dançarem, dobrando os joelhos, ao redor do altar que tinham feito."
,"27":"Pelo meio-dia, Elias começou a zombar deles: «Gritai mais alto; Baal é deus, mas pode ser que esteja ocupado. Talvez tivesse que se ausentar. Ou então, está em viagem. Talvez esteja a dormir e seja preciso acordá-lo»."
,"28":"Então eles gritavam mais alto e, conforme o seu costume, fizeram talhos no próprio corpo com espadas e lanças, até escorrer sangue."
,"29":"Depois do meio-dia, entraram em transe até à hora da apresentação das ofertas. Mas não se ouvia nenhuma voz, nenhuma palavra, nenhuma resposta."
,"30":"Então Elias disse a todo o povo: «Aproximai-vos de mim». Todos se aproximaram, e Elias reconstruiu o altar de Javé, que estava demolido."
,"31":"Tomou doze pedras, conforme o número das doze tribos dos filhos de Jacob, a quem Javé tinha dito: «Tu chamar-te-ás Israel»."
,"32":"E com as pedras construiu um altar em honra de Javé. Fez em volta do altar um rego capaz de conter duas arrobas de semente."
,"33":"Empilhou a lenha, cortou o bezerro em pedaços e colocou-o sobre a lenha."
,"34":"Depois disse: «Enchei quatro baldes de água e derramai-a sobre a vítima e sobre a lenha». Eles assim fizeram. Então Elias disse: «Fazei tudo outra vez». E eles tornaram a fazer. Elias voltou a dizer: «Fazei-o pela terceira vez». Eles assim fizeram."
,"35":"A água escorreu ao redor do altar; até o rego ficou cheio de água."
,"36":"Ao chegar a hora da oferta, o profeta Elias aproximou-se e rezou: «Javé, Deus de Abraão, de Isaac e de Israel, que todos saibam hoje que Tu és Deus em Israel, que eu sou teu servo e que foi por tua ordem que eu fiz todas estas coisas."
,"37":"Responde-me, para que este povo reconheça que Tu, Javé, és o Deus verdadeiro, e que és Tu que convertes os seus corações»."
,"38":"Então Javé mandou um raio que consumiu a vítima, a lenha, as pedras e as cinzas, e secou a água que estava no rego."
,"39":"O povo viu tudo isso e prostrou-se no chão, exclamando: «Javé é o Deus verdadeiro! Javé é o Deus verdadeiro!»"
,"40":"Então Elias disse-lhes: «Prendei os profetas de Baal. Não deixeis escapar nenhum». E eles prenderam-nos. Elias fez descer os profetas de Baal até ao riacho Quison, e ali os degolou."
,"41":"Elias disse a Acab: «Vai comer e beber, pois já se ouve o barulho da chuva»."
,"42":"Enquanto Acab foi comer e beber, Elias subiu ao topo do monte Carmelo e inclinou-se até ao chão, colocando o rosto entre os joelhos."
,"43":"Depois disse ao seu servo: «Sobe e olha para o lado do mar». O servo subiu, olhou e disse: «Não se vê nada». Elias disse: «Volta até sete vezes»."
,"44":"Na sétima vez, o servo disse: «Uma nuvenzinha, do tamanho da mão de uma pessoa, vem subindo do mar». Então Elias ordenou: «Vai dizer a Acab que atrele os cavalos ao carro e desça, para que a chuva não o detenha»."
,"45":"Num instante o céu ficou escuro, com nuvens trazidas pelo vento, e caiu uma chuva torrencial. Acab subiu para o seu carro e foi para Jezrael."
,"46":"Elias, com a força de Javé, apertou o cinto e correu à frente de Acab até à entrada de Jezrael."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Acab contou a Jezabel o que Elias tinha feito e como tinha matado ao fio de espada todos os profetas."
,"2":"Então Jezabel mandou um mensageiro a Elias, com este recado: «Que os deuses me castiguem se amanhã, a esta hora, eu não te tiver feito o mesmo que fizeste aos profetas»."
,"3":"Elias ficou com medo, levantou-se e partiu para se salvar. Chegou a Bersabeia, em Judá, e aí deixou o seu servo."
,"4":"E continuou a caminhar mais um dia pelo deserto. Por fim, sentou-se debaixo de uma árvore e desejou a morte, dizendo: «Chega, Javé! Tira-me a vida, porque eu não sou melhor que meus pais»."
,"5":"Deitou-se debaixo da árvore e adormeceu. Então um anjo tocou-lhe e disse-lhe: «Levanta-te e come»."
,"6":"Elias abriu os olhos e viu bem perto da cabeça um pão cozido sobre pedras quentes, e uma jarra de água. Comeu, bebeu e deitou-se outra vez."
,"7":"Mas o anjo de Javé tocou-lhe de novo, e disse-lhe: «Levanta-te e come, pois o caminho é superior às tuas forças»."
,"8":"Elias levantou-se, comeu, bebeu e, sustentado pela comida, caminhou quarenta dias e quarenta noites até ao Horeb, a montanha de Deus."
,"9":"Elias entrou na gruta da montanha, e ali passou a noite. Então Javé dirigiu-lhe a palavra, perguntando: «Que fazes aqui, Elias?»"
,"10":"Elias respondeu: «O zelo por Javé dos exércitos me consome, porque os israelitas abandonaram a tua aliança, derrubaram os teus altares e mataram os teus profetas. Sobrei somente eu, e eles querem matar-me também»."
,"11":"Javé disse-lhe: «Sai e fica no alto da montanha, diante de Javé, pois Javé vai passar». Então veio um furacão tão violento que rachava as montanhas e quebrava as rochas diante de Javé. No entanto, Javé não estava no furacão. Depois do furacão, houve um terremoto. Javé porém não estava no terremoto."
,"12":"Depois do terremoto, apareceu fogo, e Javé não estava no fogo. Depois do fogo, ouviu-se uma brisa suave."
,"13":"Ouvindo-a, Elias cobriu o rosto com o manto, saiu e ficou à entrada da gruta. Ouviu então uma voz que lhe dizia: «Que fazes aqui, Elias?»"
,"14":"E Elias respondeu: «O zelo de Javé dos exércitos me consome, porque os israelitas abandonaram a tua aliança, derrubaram os teus altares e mataram os teus profetas ao fio de espada. Sobrei somente eu, e eles querem matar-me também»."
,"15":"Javé disse a Elias: «Toma o caminho e regressa, em direcção ao deserto de Damasco. Unge Hazarel como rei de Aram,"
,"16":"e Jeú, filho de Namsi, como rei de Israel. Unge também Eliseu, filho de Safat, natural de Abel-Meúla, como profeta em teu lugar."
,"17":"Quem escapar da espada de Hazael, será morto por Jeú. E quem escapar da espada de Jeú, será morto por Eliseu."
,"18":"Mas Eu vou poupar em Israel sete mil homens que não dobraram os joelhos diante de Baal e cujos lábios não o beijaram»."
,"19":"Elias partiu dali e encontrou Eliseu, filho de Safat, a lavrar com doze juntas de bois. Ele próprio dirigia a última junta. Elias passou perto de Eliseu e lançou o seu manto sobre ele."
,"20":"Eliseu deixou os bois, correu atrás de Elias, e disse: «Deixa-me dizer adeus aos meus pais. Depois seguir-te-ei». Elias respondeu: «Vai, mas volta depressa. Quem te impede de ir?»"
,"21":"Eliseu afastou-se de Elias, tomou a junta de bois e ofereceu-a em sacrifício. Aproveitou a madeira do arado para cozinhar a carne, e deu-a a comer à sua gente. Depois levantou-se, seguiu Elias, e colocou-se ao seu serviço."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Ben-Adad, rei de Aram, reuniu todo o seu exército e, acompanhado de trinta e dois reis vassalos, subiu com cavalos e carros, cercou e atacou Samaria."
,"2":"Mandou até à cidade emissários a Acab, rei de Israel,"
,"3":"com a seguinte mensagem: «Assim diz Ben-Adad: Entrega-me a prata e o ouro; fica com as tuas mulheres e filhos»."
,"4":"O rei de Israel mandou esta resposta: «Seja como ordenas. Eu pertenço-te com tudo o que possuo»."
,"5":"No entanto os mensageiros voltaram com outra mensagem: «Assim diz Ben-Adad: Eu te ordeno que me entregues a prata e o ouro, as tuas mulheres e filhos."
,"6":"Amanhã, a esta hora, enviar-te-ei os meus oficiais, para revistarem o teu palácio e os palácios dos teus ministros: eles tomarão o que quiserem»."
,"7":"Então o rei de Israel convocou todos os anciãos do país e disse-lhes: «Reparai e vede que esse homem quer arruinar-nos. Está a exigir-me as minhas mulheres e filhos, apesar de eu não lhe ter recusado entregar a minha prata e ouro»."
,"8":"Todos os anciãos e todo o povo responderam: «Não faças caso dele nem lhe obedeças»."
,"9":"Então o rei de Israel deu esta resposta aos mensageiros de Ben-Adad: «Dizei ao vosso rei: Farei o que propuseste na primeira vez, mas não posso aceitar essa última exigência». E os mensageiros foram levar a resposta."
,"10":"Então Ben-Adad mandou esta mensagem: «Que os deuses me castiguem se na Samaria houver pó suficiente para que cada um dos meus soldados possa apanhar um punhado»."
,"11":"Mas o rei de Israel respondeu: «Dizei a Ben-Adad que ninguém canta vitória com a espada na bainha, mas só quando a desembainha»."
,"12":"Ben-Adad estava a beber na tenda com os reis. Quando ouviu a resposta, ordenou aos oficiais: «A postos!» E eles tomaram posição contra a cidade."
,"13":"Nesse momento, um profeta apresentou-se a Acab, rei de Israel, e disse: «Assim diz Javé: Vês aquele exército imenso? Pois bem! Eu vou entregá-lo hoje mesmo nas tuas mãos, para que reconheças que Eu sou Javé»."
,"14":"Acab perguntou-lhe: «Por meio de quem?» O profeta respondeu: «Assim diz Javé: Por meio dos soldados jovens de cada chefe das províncias». Acab insistiu: «Quem vai atacar primeiro?» Ele respondeu: «Tu mesmo»."
,"15":"Acab passou em revista os jovens soldados de cada chefe das províncias: eram ao todo duzentos e trinta e dois. Em seguida, passou em revista todo o exército israelita, que chegava a sete mil."
,"16":"Ao meio-dia, fizeram uma investida, enquanto Ben-Adad se estava embebedando com os trinta e dois reis aliados."
,"17":"Saíram primeiro os soldados jovens de cada chefe das províncias. Então mandaram avisar Ben-Adad: «Saíram alguns homens de Samaria»."
,"18":"Ben-Adad ordenou: «Se saírem com intenção pacífica, sejam capturados vivos. E se saírem para combater, sejam capturados vivos também»."
,"19":"Então saíram da cidade os soldados jovens de cada chefe das províncias, seguidos pelo exército,"
,"20":"e cada um deles abateu o seu adversário. Os arameus fugiram, perseguidos pelos israelitas. Ben-Adad, rei de Aram, escapou a cavalo com alguns cavaleiros."
,"21":"Então o rei de Israel saiu, apoderou-se dos cavalos e carros, e causou grande derrota aos arameus."
,"22":"O profeta aproximou-se do rei de Israel e disse-lhe: «Coragem! Pensa bem no que deves fazer, porque, no próximo ano, o rei de Aram virá atacar-te novamente»."
,"23":"Os ministros do rei de Aram, por sua vez, propuseram: «O Deus dessa gente é um Deus de montanha. É por isso que nos venceram. Mas nós vamos lutar contra eles na planície e, com toda a certeza, venceremos."
,"24":"Faz o seguinte: destitui todos esses reis, substituindo-os por governadores."
,"25":"Recruta um exército como aquele que perdeste, com o mesmo número de cavalos e carros. Depois, vamos combatê-los na planície e, com toda a certeza, venceremos». Ben-Adad seguiu o conselho deles e assim fez."
,"26":"No ano seguinte, Ben-Adad passou em revista os arameus e subiu a Afec, para lutar contra Israel."
,"27":"Os israelitas, mobilizados e providos de víveres, saíram ao encontro de Ben-Adad. Acampados diante do inimigo, os israelitas eram como dois rebanhos de cabras, enquanto que os arameus enchiam a região toda."
,"28":"O homem de Deus aproximou-se do rei de Israel e disse-lhe: «Assim diz Javé: Os arameus disseram que Javé é um Deus de montanha e não de planície. Por isso, Eu vou entregar-te esse exército imenso, para que reconheças que Eu sou Javé»."
,"29":"Durante sete dias, os dois exércitos estiveram acampados um em frente do outro. No sétimo dia, começou a batalha, e num só dia os israelitas mataram cem mil soldados da infantaria dos arameus."
,"30":"Os sobreviventes fugiram para a cidade de Afec, porém as muralhas desabaram sobre os vinte e sete mil homens sobreviventes. Ben-Adad fugiu e, entrando na cidade, escondia-se de casa em casa."
,"31":"Os seus ministros disseram-lhe: «Ouvimos dizer que os reis de Israel são misericordiosos. Vamos vestir-nos com pano de saco, enrolar cordas ao pescoço e ir ao encontro do rei de Israel. Talvez ele te poupe a vida»."
,"32":"Vestiram-se, então, com pano de saco, enrolaram cordas ao pescoço e saíram ao encontro do rei de Israel, dizendo: «Assim diz o teu servo Ben-Adad: Deixa-me viver!» O rei respondeu: «Ben-Adad ainda está vivo? Ele é meu irmão!»"
,"33":"Os mensageiros acolheram estas palavras como bom augúrio, e apressaram-se a tomá-las ao pé da letra, dizendo: «Ben-Adad é irmão dele!» Acab respondeu: «Ide buscá-lo». Ben-Adad apresentou-se a Acab, e este fê-lo subir para o seu carro."
,"34":"Então Ben-Adad propôs-lhe: «Vou devolver-te as cidades que meu pai tomou ao teu pai, e poderás ter mercados em Damasco como o meu pai tinha na cidade de Samaria». Acab respondeu: «Vou fazer um pacto e deixar-te em liberdade». E Acab fez um pacto com Ben-Adad e deixou-o em liberdade."
,"35":"Então um dos filhos dos profetas disse a um seu companheiro, por ordem de Javé: «Fere-me!» Mas o companheiro não o quis ferir."
,"36":"O profeta disse-lhe: «Porque não obedeceste à ordem de Javé, um leão matar-te-á logo que te separares de mim». E enquanto ele se afastava, encontrou um leão, que o matou."
,"37":"O profeta encontrou-se com outro homem, e disse: «Fere-me!» O homem deu-lhe um golpe e deixou-o ferido."
,"38":"O profeta foi esperar o rei ao caminho, disfarçando-se com uma faixa sobre os olhos."
,"39":"Quando o rei passou, o profeta gritou: «O teu servo estava no meio da batalha, quando um homem se aproximou e me entregou outro homem, dizendo-me: 'Guarda este homem. Se ele desaparecer, deverás pagar com a vida ou com dinheiro'."
,"40":"Pois bem, enquanto eu estava ocupado, o homem desapareceu». O rei de Israel disse-lhe: «Esta é a tua sentença! Tu mesmo a pronunciaste»."
,"41":"Então o profeta tirou a faixa que tinha sobre os olhos e o rei de Israel percebeu que era um profeta."
,"42":"Então ele disse ao rei: «Assim diz Javé: Porque deixaste escapar o homem que Eu tinha consagrado ao extermínio, pagarás com a tua vida a vida dele, e com o teu exército o exército dele»."
,"43":"O rei de Israel foi para casa triste e aflito, e entrou em Samaria."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Depois disto, aconteceu o seguinte: Nabot de Jezrael possuía uma vinha em Jezrael, perto do palácio de Acab, rei de Samaria."
,"2":"Acab fez-lhe uma proposta: «Entrega-me a tua vinha, que eu vou transformá-la em pomar, porque está perto do meu palácio. Em troca, eu dar-te-ei uma vinha melhor, ou, se preferires, pagarei o seu valor em dinheiro»."
,"3":"Nabot, porém, respondeu: «Javé me livre de te entregar a herança de meus pais»."
,"4":"Acab voltou para casa, aborrecido e irritado por causa da resposta de Nabot de Jezrael: «Não te vou entregar a herança de meus pais». Deitou-se na cama, virou o rosto para a parede e não quis comer nada."
,"5":"A sua esposa Jezabel aproximou-se e disse-lhe: «Porque estás de mau humor e não queres comer?»"
,"6":"Ele respondeu: «É que eu falei com Nabot de Jezrael e propus-lhe que me vendesse a vinha dele, ou, se preferisse, que a trocasse por uma outra, mas ele disse-me: 'Não vou entregar-te a minha vinha'»."
,"7":"Então Jezabel disse ao marido: «Será que não és tu quem governa Israel? Levanta-te, come e que o teu coração se alegre, pois eu te entregarei a vinha de Nabot de Jezrael»."
,"8":"Então Jezabel escreveu umas cartas em nome de Acab, selou-as com o selo do rei e mandou-as aos anciãos e notáveis da cidade, concidadãos de Nabot."
,"9":"As cartas diziam: «Proclamai um jejum e fazei sentar Nabot nos primeiros lugares."
,"10":"Fazei comparecer diante dele dois homens sem escrúpulos, que façam a seguinte acusação: 'Tu amaldiçoaste a Deus e ao rei!' Depois, levai Nabot para fora e apedrejai-o até morrer»."
,"11":"Os homens da cidade, anciãos e notáveis, concidadãos de Nabot, fizeram como Jezabel tinha mandado, conforme estava escrito nas cartas que haviam recebido:"
,"12":"proclamaram um jejum e colocaram Nabot nos primeiros lugares."
,"13":"Então chegaram os dois homens sem escrúpulos, que se sentaram diante de Nabot e testemunharam contra ele, dizendo: «Nabot amaldiçoou a Deus e ao rei!» Então levaram-no para fora da cidade, apedrejaram-no, e ele morreu."
,"14":"Depois, mandaram a notícia a Jezabel: «Nabot foi apedrejado e está morto»."
,"15":"Quando Jezabel soube que Nabot tinha sido apedrejado e morrera, disse a Acab: «Levanta-te e toma posse da vinha de Nabot de Jezrael, que não te quis vender a vinha. Nabot já não está vivo; ele morreu»."
,"16":"Quando Acab soube que Nabot estava morto, levantou-se para descer até à vinha de Nabot de Jezrael, a fim de tomar posse dela."
,"17":"Então Javé dirigiu a palavra a Elias, o tesbita:"
,"18":"«Levanta-te e vai ao encontro de Acab, rei de Israel, que está em Samaria. Ele está na vinha de Nabot, aonde foi para dela tomar posse."
,"19":"Diz-lhe: Assim diz Javé: Mataste e agora roubas? Por isso, assim diz Javé: No mesmo lugar em que os cães lamberam o sangue de Nabot, lamberão também o teu»."
,"20":"Acab disse a Elias: «Apanhaste-me de novo, meu inimigo?» Elias respondeu: «Sim, apanhei-te. Pois deixaste-te subornar para fazer o que Javé reprova."
,"21":"Por isso, farei cair a desgraça sobre ti. Vou deixar-te sem descendência, vou exterminar todo o israelita varão da tua família, escravo ou livre."
,"22":"Farei à tua casa o que fiz à casa de Jeroboão, filho de Nabot, e à casa de Baasa, filho de Aías, porque provocaste a minha ira e fizeste pecar Israel»."
,"23":"Javé também pronunciou uma sentença contra Jezabel: «Os cães devorarão Jezabel no campo de Jezrael."
,"24":"A pessoa da família de Acab que morrer na cidade será devorada pelos cães, e quem morrer no campo será comido pelas aves do céu»."
,"25":"De facto, não houve ninguém que se tivesse vendido como Acab, incitado por sua mulher Jezabel, para fazer o que Javé reprova."
,"26":"Ele agiu de modo abominável, prestando culto aos ídolos, como faziam os amorreus que Javé tinha expulsado diante dos israelitas."
,"27":"Quando Acab ouviu estas palavras, rasgou as roupas, vestiu-se com pano de saco e fez jejum. Dormia vestido de pano de saco e andava abatido."
,"28":"Então Javé dirigiu a palavra a Elias, o tesbita:"
,"29":"«Viste como Acab se humilhou diante de Mim? Por se ter humilhado diante de Mim, não o castigarei durante a sua vida; mas castigarei a sua família no tempo do seu filho»."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Passaram-se três anos sem que houvesse guerra entre Aram e Israel."
,"2":"No terceiro ano, Josafá, rei de Judá, foi visitar o rei de Israel."
,"3":"Este disse aos seus próprios ministros: «Vós sabeis que Ramot de Galaad nos pertence, e nós não fazemos nada para a recuperar das mãos do rei de Aram»."
,"4":"Então o rei de Israel disse a Josafá: «Queres vir comigo guerrear contra Ramot de Galaad?» Josafá respondeu ao rei de Israel: «Tu e eu, o teu exército e o meu, a tua cavalaria e a minha, somos todos um só»."
,"5":"E acrescentou: «Consulta antes o oráculo de Javé»."
,"6":"O rei de Israel reuniu os profetas, cerca de quatrocentos homens, e perguntou-lhes: «Devo atacar Ramot de Galaad, ou não?» Eles responderam: «Podes ir, pois Javé a entregará nas mãos do rei»."
,"7":"Então Josafá perguntou: «Não haverá por aqui nenhum outro profeta de Javé, para que possamos consultá-lo?»"
,"8":"O rei de Israel respondeu a Josafá: «Existe ainda um: é Miqueias, filho de Jemla, através do qual podemos consultar a Javé. Mas eu não gosto dele, porque nunca me profetiza coisas boas, mas só desgraças». Josafá disse: «O rei não deve falar assim!»"
,"9":"Então o rei de Israel chamou um funcionário e ordenou: «Chama depressa Miqueias, filho de Jemla»."
,"10":"O rei de Israel e Josafá, rei de Judá, estavam sentados nos seus tronos com vestes reais, na praça junto à porta de Samaria, e todos os profetas profetizavam diante deles."
,"11":"Sedecias, filho de Canaana, fez para si mesmo uns chifres de ferro e disse: «Assim diz Javé: Com isto, ferirás os arameus até acabar com eles»."
,"12":"E todos os profetas faziam a mesma predição, dizendo: «Ataca Ramot de Galaad. Tu triunfarás, porque Javé vai entregá-la nas mãos do rei»."
,"13":"Entretanto, o mensageiro que tinha ido chamar Miqueias disse ao profeta: «Todos os profetas estão a falar em favor do rei. Procura falar como eles e predizer o sucesso»."
,"14":"Miqueias respondeu: «Pela vida de Javé! Vou dizer o que Javé me mandar»."
,"15":"Quando Miqueias se apresentou ao rei, este perguntou-lhe: «Miqueias, podemos atacar Ramot de Galaad, ou não?» Miqueias respondeu: «Podes ir. Serás bem sucedido. Javé vai entregá-la nas mãos do rei»."
,"16":"Mas o rei perguntou-lhe: «Quantas vezes terei de te pedir para jurares que só dizes a verdade em nome de Javé?»"
,"17":"Então Miqueias disse ao rei: «Estou a ver Israel espalhado pelas montanhas, como ovelhas sem pastor. E Javé disse-me: Eles não têm senhor. Que cada um volte em paz para casa»."
,"18":"O rei de Israel comentou então com Josafá: «Eu não te disse? Ele nunca me profetiza boa sorte, mas sempre desgraça»."
,"19":"Miqueias replicou: «Ouve a palavra de Javé. Eu vi Javé sentado no seu trono, e todo o exército do céu estava de pé, à direita e à esquerda de Javé."
,"20":"E Javé perguntou: 'Quem poderá enganar Acab, para que ele vá e morra em Ramot de Galaad?' Uns diziam uma coisa, e outros diziam outra."
,"21":"Então aproximou-se um espírito, apresentou-se diante de Javé, e disse: 'Eu posso enganá-lo'. Javé perguntou-lhe: 'De que modo?'"
,"22":"Ele respondeu: 'Irei e transformar-me-ei em oráculo falso na boca de todos os profetas'. Javé disse-lhe. 'Tu conseguirás enganá-lo. Vai e faz como disseste'."
,"23":"Como podes ver, Javé colocou oráculos falsos na boca de todos os profetas do rei, porque Javé decretou a ruína do rei»."
,"24":"Então Sedecias, filho de Canaana, aproximou-se de Miqueias, deu-lhe uma bofetada e disse: «Por qual caminho o espírito de Javé saiu de mim para te falar?»"
,"25":"Miqueias respondeu: «Vê-lo-ás no dia em que tiveres de andar de casa em casa para te esconderes»."
,"26":"Então o rei de Israel ordenou: «Prende Miqueias e leva-o ao governador Amon e ao príncipe Joás."
,"27":"Tu dir-lhe-ás: 'Por ordem do rei, metei este homem na prisão e tratai-o a pão e água, até que o rei volte vitorioso'»."
,"28":"Miqueias disse: «Se tu voltares vitorioso, é sinal de que Javé não falou pela minha boca»."
,"29":"O rei de Israel e Josafá, rei de Judá, marcharam contra Ramot de Galaad."
,"30":"O rei de Israel disse a Josafá: «Vou disfarçar-me antes de entrar em com-bate. Tu, porém, vai com as tuas vestes». E o rei de Israel disfarçou-se e foi para o combate."
,"31":"O rei de Aram tinha ordenado aos comandantes dos carros que não atacassem a ninguém nem pequeno nem grande, mas somente o rei de Israel."
,"32":"Quando os comandantes dos carros viram Josafá, comentaram: «Aquele é o rei de Israel». E lançaram-se contra ele. Mas Josafá soltou o seu grito de guerra"
,"33":"e os comandantes dos carros viram que ele não era o rei de Israel, e deixaram de o perseguir."
,"34":"Um soldado atirou com o arco, ao acaso, e atingiu o rei de Israel numa brecha da couraça. O rei disse ao condutor de seu carro: «Dá a volta e tira-me do campo de batalha, porque estou ferido»."
,"35":"Mas, nesse dia, o combate tornou-se mais violento, de modo que seguraram o rei de pé sobre o seu carro, diante dos arameus. E ele morreu ao entardecer. O sangue da sua ferida escorria no fundo do carro."
,"36":"Ao pôr do sol, um grito correu pelo acampamento: «Cada um volte para a sua cidade e para a sua terra!"
,"37":"O rei está morto!»,Levaram-no para Samaria, e ali o enterraram. "
,"38":"Lavaram o carro na piscina da Samaria, os cães lamberam-lhe o sangue e as prostitutas ali se lavaram, como Javé havia anunciado."
,"39":"O resto da história de Acab e do que ele fez, o palácio de marfim e as cidades que construiu, tudo está escrito nos Anais dos Reis de Israel."
,"40":"Acab morreu, e o seu filho Ocozias sucedeu-lhe no trono."
,"41":"Josafá, filho de Asa, tornou-se rei de Judá no quarto ano do reinado de Acab, rei de Israel."
,"42":"Quando subiu ao trono, Josafá tinha trinta e cinco anos, e reinou durante vinte e cinco anos em Jerusalém. Sua mãe chamava-se Azuba, filha de Selaqui."
,"43":"Ele seguiu em tudo o comportamento de seu pai Asa, sem se desviar, fazendo o que Javé aprova."
,"44":"Entretanto, os lugares altos não desapareceram, e ali nos lugares altos o povo continuou a oferecer sacrifícios e incenso."
,"45":"Josafá viveu em paz com o rei de Israel."
,"46":"O resto da história de Josafá, as vitórias que obteve e as guerras que fez, tudo está escrito nos Anais dos Reis de Judá."
,"47":"Ele expulsou do país o resto dos prostitutos sagrados que tinham ficado do tempo de seu pai Asa."
,"48":"Não havia rei em Edom. O rei"
,"49":"Josafá construiu navios de Társis para ir a Ofir em busca de ouro, mas não pôde fazer a viagem, porque a frota naufragou em Asiongaber."
,"50":"Então Ocozias, filho de Acab, disse a Josafá: «Os meus homens poderiam ir nos navios com os teus homens». Josafá, porém, não concordou."
,"51":"Josafá morreu e enterraram-no com os seus antepassados na Cidade de David, seu antecessor. E seu filho Jorão sucedeu-lhe no trono."
,"52":"Ocozias, filho de Acab, subiu ao trono de Israel, em Samaria, no ano dezassete de Josafá, rei de Judá. E reinou dois anos sobre Israel."
,"53":"Fez o que Javé reprova, imitando o comportamento de seu pai e de sua mãe e o exemplo de Jeroboão, filho de Nabot, que levou Israel a pecar."
,"54":"Prestou culto a Baal e adorou-o, provocando a ira de Javé, Deus de Israel, exactamente como seu pai tinha feito."
}`)

}
func PT_BS_LoadVH1SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Havia um homem de Ramataim, um sufita da região montanhosa de Efraim, que se chamava Elcana, filho de Jeroam, filho de Eliú, filho de Toú, filho de Suf. Era um efraimita."
,"2":"Elcana tinha duas mulheres: uma chamava-se Ana e a outra Fenena. Fenena tinha filhos; Ana, porém, não tinha nenhum."
,"3":"Todos os anos, Elcana subia da sua cidade a Silo, a fim de adorar e oferecer sacrifícios a Javé dos exércitos. Em Silo, estavam Hofni e Fineias, os dois filhos de Eli, que eram sacerdotes de Javé."
,"4":"No dia em que oferecia sacrifícios, Elcana dava porções à sua mulher Fenena e aos seus filhos e filhas."
,"5":"Embora tivesse maior amor por Ana, Elcana dava-lhe apenas uma porção, porque Javé a tornara estéril."
,"6":"Com humilhações, Fenena irritava Ana, a quem Javé tinha deixado estéril."
,"7":"Isso acontecia todos os anos; e sempre que subiam ao santuário de Javé, Fenena ofendia Ana. E Ana começava a chorar e ficava sem comer."
,"8":"Elcana, seu marido, perguntava-lhe: «Ana, porque choras e porque não comes nada? Porque estás triste? Não sou melhor para ti do que dez filhos?»"
,"9":"Depois de terem comido e bebido em Silo, Ana levantou-se e apresentou-se diante de Javé. O sacerdote Eli estava sentado na sua cadeira junto à porta do santuário de Javé."
,"10":"Cheia de amargura, Ana rezou a Javé, chorou muito,"
,"11":"e fez uma promessa, dizendo: «Javé dos exércitos, se quiseres prestar atenção à miséria da tua serva e Te lembrares de mim, e não Te esqueceres da tua serva, e lhe deres um filho varão, então eu o consagrarei a Javé por todos os dias da sua vida, e a navalha não passará sobre a sua cabeça»."
,"12":"Como Ana continuasse a rezar a Javé, Eli observava o movimento dos seus lábios."
,"13":"Ana apenas murmurava: os seus lábios moviam-se, mas não se conseguia ouvir o que ela dizia. Por isso, Eli pensou que ela estivesse embriagada."
,"14":"Então Eli perguntou: «Até quando vais ficar embriagada? Acaba primeiro com essa bebedeira!»"
,"15":"Ana, porém, respondeu: «Não, meu senhor. Eu sou uma mulher que sofre; não bebi vinho, nem bebida forte. Eu estava apenas a desabafar diante de Javé."
,"16":"Não penses que esta tua serva seja vadia. Falei até agora, porque estou muito triste e aflita»."
,"17":"Então Eli disse-lhe: «Vai em paz. Que o Deus de Israel te conceda o que Lhe pediste»."
,"18":"Ana respondeu: «Que esta tua serva possa encontrar sempre o teu favor». Ana foi-se embora, comeu, e já não parecia a mesma de antes."
,"19":"Levantaram-se de madrugada, adoraram a Javé e voltaram para casa. Chegando a Ramá, Elcana uniu-se à sua mulher Ana, e Javé lembrou-Se dela."
,"20":"Ana ficou grávida e, no devido tempo, deu à luz um filho, ao qual pôs o nome de Samuel, dizendo: «Eu pedi-o a Javé»."
,"21":"Um ano depois, seu marido Elcana foi com toda a família para oferecer a Javé o sacrifício anual e cumprir a promessa."
,"22":"Ana, porém, não foi. Ela disse ao marido: «Quando o menino for desmamado, então eu o levarei para o apresentar a Javé, e ele vai ficar lá para sempre»."
,"23":"O seu marido Elcana respondeu: «Faz o que achares melhor e espera até que o tenhas desmamado. E Javé permita que possas cumprir a promessa». Deste modo, Ana ficou em casa, e criou o menino até o desmamar."
,"24":"Logo que o desmamou, levou-o ao santuário de Javé em Silo, com um bezerro de três anos, quarenta e cinco quilos de farinha e quarenta e cinco litros de vinho. O menino era ainda muito pequeno."
,"25":"Eles imolaram o bezerro e levaram o menino a Eli."
,"26":"Ana disse: «Desculpa, senhor. Eu sou aquela mulher que esteve aqui, a rezar a Javé na tua presença."
,"27":"O que eu pedia era este menino, e Javé atendeu o meu pedido."
,"28":"Agora, entrego-o a Javé por toda a vida, para que Lhe pertença». E prostraram-se diante de Javé."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Então Ana rezou esta oração: «O meu coração alegra-se com Javé, em Deus sinto-me cheia de força. Agora, que eu possa responder,aos meus inimigos, pois me sinto feliz com a tua salvação."
,"2":"Ninguém é santo como Javé, não existe Rocha,como o nosso Deus."
,"3":"Não multipliqueis palavras soberbas, nem saia arrogância da vossa boca, porque Javé é um Deus que sabe, é Ele quem pesa as acções."
,"4":"O arco dos poderosos é quebrado, e os fracos são fortalecidos."
,"5":"Os saciados empregam-se por comida, enquanto os famintos,engordam com despojos. A mulher estéril dá à luz sete filhos, e a mãe de muitos filhos esgota-se."
,"6":"Javé faz morrer e faz viver, faz descer ao abismo e dele subir."
,"7":"Javé torna pobre e torna rico, Ele humilha e também levanta."
,"8":"Ele ergue da poeira o fraco,e tira do lixo o indigente, fazendo-os sentar com os príncipes,e herdar um trono glorioso; pois a Javé pertencem,as colunas da terra, e sobre elas Ele assentou o mundo."
,"9":"Ele guarda os passos dos seus fiéis, enquanto os injustos perecem nas trevas,-pois não é pela força,que o homem triunfa."
,"10":"Javé derrota os seus adversários, o Altíssimo troveja lá do céu. Javé julga os confins da terra. Ele dá força ao seu rei,e aumenta o poder do seu ungido»."
,"11":"Depois Elcana foi para sua casa em Ramá. O menino, porém, ficou ao serviço de Javé, sob as ordens do sacerdote Eli."
,"12":"No entanto, os filhos de Eli eram desonestos e não se preocupavam, nem com Javé,"
,"13":"nem com as obrigações dos sacerdotes para com o povo. Quando alguém oferecia um sacrifício, enquanto se cozinhava a carne, o ajudante do sacerdote ia com um garfo de três dentes,"
,"14":"enfiava-o no caldeirão ou na panela, no tacho ou na travessa, e tudo o que o garfo agarrava pertencia ao sacerdote. Assim faziam com todos os israelitas que iam a Silo."
,"15":"Antes de queimar a gordura, o ajudante do sacerdote também dizia à pessoa que ia oferecer o sacrifício: «Dá-me a carne, para que o sacerdote a asse como quiser. Deve ser carne crua, porque ele não aceitará carne cozida»."
,"16":"Se a pessoa respondia: «Primeiro é preciso queimar a gordura, depois poderás levar o que quiseres», o ajudante dizia: «Não. Ou me dás a carne agora mesmo, ou tomá-la-ei à força»."
,"17":"O pecado desses ajudantes era grave diante de Javé, porque desonravam a oferta feita a Javé."
,"18":"Samuel, por sua vez, prestava serviço diante de Javé, conforme podia fazer uma criança, e vestia um efod de linho."
,"19":"Sua mãe costumava fazer uma pequena túnica que lhe levava cada ano, quando ia com o marido oferecer o sacrifício anual."
,"20":"Eli abençoava Elcana e a esposa, e dizia: «Que Javé te dê descendência por meio desta mulher, como recompensa pelo empréstimo que ela fez a Javé». E eles voltaram para casa."
,"21":"Javé visitou Ana, e ela ficou grávida; deu à luz três filhos e duas filhas. Entretanto, Samuel crescia diante de Javé."
,"22":"Apesar de Eli já ser muito velho, estava sempre informado de tudo o que os seus filhos faziam com todos os israelitas, e que eles se deitavam com as mulheres que prestavam serviço à entrada da tenda da reunião."
,"23":"Eli disse-lhes: «Porque procedeis deste modo? As pessoas contam-me como vos comportais mal."
,"24":"Não, meus filhos, o que me contam não é nada bom. Vós estais a escandalizar o povo de Javé."
,"25":"Se um homem ofende outro homem, Deus poderá intervir em favor dele. Mas se alguém peca contra Javé, quem poderá interceder por ele?» Eles, porém, não deram ouvidos ao pai, porque Javé tinha decidido tirar-lhes a vida."
,"26":"Entretanto, o jovem Samuel crescia e era estimado por Javé e pelo povo."
,"27":"Um homem de Deus apresentou-se a Eli, e disse-lhe: «Assim diz Javé: Eu revelei-Me à família de teu pai, quando eles estavam no Egipto e eram escravos do Faraó."
,"28":"Eu escolhi-a entre todas as tribos de Israel para exercer o meu sacerdócio, para subir ao meu altar a fim de queimar a oferta e vestirem o efod diante de Mim. Eu concedi à família de teu pai toda a carne que os israelitas oferecessem a Javé."
,"29":"Porque tratais com desprezo os sacrifícios e as ofertas que mandei fazer no meu santuário? Porque respeitas mais os teus filhos do que a Mim, engordando-os com todas as ofertas de Israel, meu povo, diante de Mim?"
,"30":"Por causa disso - oráculo de Javé, Deus de Israel -, embora Eu tenha prometido que a tua família e a família de teu pai estariam sempre na minha presença, agora - oráculo de Javé - não será mais assim. Porque Eu honro os que Me honram, mas aqueles que Me desprezam serão humilhados."
,"31":"Vê! Vai chegar o dia em que cortarei o teu braço e o braço da família de teu pai, para que não haja nenhum velho na tua família."
,"32":"Tu olharás com inveja todo o bem que vou fazer a Israel; mas na tua família ninguém chegará a ser velho."
,"33":"Vou conservar um da tua família junto do meu altar, e isso fará consumir os teus olhos de tanto chorarem e a tua alma vai ficar desesperada. Todos os teus outros descendentes morrerão na flor da idade."
,"34":"O que vai acontecer aos teus dois filhos, Hofni e Fineias, servir-te-á de sinal: ambos vão morrer no mesmo dia."
,"35":"Depois disso, farei aparecer um sacerdote fiel, que fará o que Eu quero e desejo; vou dar-lhe uma família estável, e viverá sempre na presença do meu ungido."
,"36":"Aqueles que sobreviverem da tua família irão prostrar-se diante dele para mendigar uma moeda ou um pedaço de pão, pedindo: 'Por favor, dá-me alguma função sacerdotal, para que eu possa comer um pedaço de pão'»."
}`)
	CurrentBook.AddChapter(3, `{
"1":"O menino Samuel servia a Javé, sob as ordens de Eli. A palavra de Javé manifestava-se raramente naquele tempo e as visões não eram frequentes."
,"2":"Certo dia, Eli estava deitado no seu quarto. Os seus olhos começavam a enfraquecer e ele já mal podia ver."
,"3":"A lâmpada do santuário ainda não tinha sido apagada e Samuel estava deitado no santuário de Javé, onde se encontrava a arca de Deus."
,"4":"Javé chamou: «Samuel, Samuel». Ele respondeu: «Estou aqui»."
,"5":"Ele correu para junto de Eli e disse: «Estou aqui. Chamaste-me?» Eli respondeu: «Não, não te chamei. Vai deitar-te». Samuel foi deitar-se,"
,"6":"e Javé chamou-o outra vez. Samuel levantou-se, foi até onde Eli estava, e disse-lhe: «Estou aqui. Chamaste-me?» Eli respondeu: «Não te chamei, meu filho. Vai deitar-te»."
,"7":"Samuel ainda não conhecia Javé, e a palavra de Javé ainda não lhe tinha sido revelada."
,"8":"Javé tornou a chamar Samuel pela terceira vez. Samuel levantou-se, foi aonde Eli estava, e disse-lhe: «Estou aqui. Chamaste-me?» Então Eli compreendeu que era Javé quem chamava o menino."
,"9":"E disse a Samuel: «Vai e torna a deitar-te. Se alguém te chamar outra vez, responde: 'Fala, Javé, que o teu servo escuta'». E Samuel foi deitar-se."
,"10":"Javé apresentou-Se e chamou-o como antes: «Samuel, Samuel». Então Samuel respondeu: «Fala, que o teu servo escuta»."
,"11":"Javé disse a Samuel: «Olha. Vou fazer uma coisa em Israel que vai ficar a zunir nos ouvidos de todos os que a ouvirem."
,"12":"Nesse dia, vou executar contra Eli e a sua família tudo o que anunciei, desde o princípio até ao fim."
,"13":"Comunica a Eli que vou condenar a sua família para sempre, porque ele sabia que os seus filhos desonravam a Deus e não os repreendeu."
,"14":"Por isso, juro à família de Eli que a sua injustiça nunca será perdoada, nem com sacrifícios, nem com ofertas»."
,"15":"Samuel continuou deitado até de manhã. Depois abriu as portas do santuário. Estava com medo de contar a visão a Eli."
,"16":"Mas Eli chamou-o: «Samuel, meu filho». Samuel respondeu: «Estou aqui»."
,"17":"Eli perguntou: «O que foi que Ele te disse? Não me escondas nada. Que Deus te castigue, se me esconderes alguma coisa do que Ele disse»."
,"18":"Então Samuel contou-lhe tudo, e não escondeu nada. Eli comentou: «Ele é Javé. Que Ele faça o que Lhe parece melhor»."
,"19":"Samuel crescia, e Javé estava com ele. Nenhuma das palavras que Javé lhe disse deixou de se cumprir."
,"20":"E todo o Israel, desde Dã até Bersabeia, ficou a saber que Samuel era um profeta confirmado por Javé."
,"21":"E Javé continuou a manifestar-Se em Silo, onde Se tinha revelado a Samuel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"E a palavra de Samuel foi dirigida a todo o Israel como palavra de Javé. Eli estava muito velho. E os seus filhos continuavam a comportar-se mal diante de Javé. Nesse tempo, os filisteus uniram-se para fazer guerra contra Israel. Os israelitas saíram para combater contra eles e acamparam perto de Ebenezer, enquanto os filisteus acamparam em Afec. "
,"2":"Os filisteus colocaram-se em ordem de batalha contra Israel. No terrível combate, Israel foi vencido pelos filisteus: das suas fileiras, morreram no combate cerca de quatro mil homens."
,"3":"O exército voltou para o acampamento, e os anciãos de Israel disseram: «Porque é que Javé deixou que fôssemos hoje derrotados pelos filisteus? Vamos a Silo buscar a arca da aliança de Javé nosso Deus. Ela ficará no meio de nós e nos salvará dos nossos inimigos»."
,"4":"Mandaram então trazer de Silo a arca da aliança de Javé dos exércitos, entronizado entre os querubins. Hofni e Fineias, os dois filhos de Eli, acompanhavam a arca da aliança de Deus."
,"5":"Quando a arca da aliança de Javé chegou ao acampamento, todo o Israel lançou um grande grito de guerra, e a terra tremeu."
,"6":"Os filisteus ouviram o barulho do grito e perguntaram entre si: «Que significa aquele grito tão forte no acampamento dos hebreus?» Então souberam que a arca de Javé tinha chegado ao acampamento."
,"7":"Apavorados, diziam: «Deus chegou ao acampamento! Ai de nós! É a primeira vez que nos acontece isto!"
,"8":"Ai de nós! Quem nos livrará das mãos desse Deus poderoso? Ele feriu o Egipto com toda a espécie de calamidades e epidemias."
,"9":"Sede fortes, filisteus! Sede homens para não vos tornardes escravos dos hebreus, como eles foram vossos escravos. Sede homens e lutai»."
,"10":"Os filisteus começaram o combate. Israel foi vencido, e cada um fugiu para a sua tenda. A derrota foi grande, pois do lado de Israel foram mortos trinta mil guerreiros."
,"11":"A arca de Deus foi tomada e os dois filhos de Eli, Hofni e Fineias, morreram."
,"12":"Um benjaminita saiu a correr das fileiras e chegou a Silo no mesmo dia, com a roupa rasgada e a cabeça coberta de pó."
,"13":"Quando chegou, Eli estava sentado na sua cadeira, ao lado da porta, olhando para a estrada, porque estava preocupado com a arca de Deus. O homem entrou na cidade dando a notícia, e a população pôs-se a gritar."
,"14":"Eli ouviu a gritaria e perguntou: «O que é todo esse alvoroço?» Nesse momento, o benjaminita correu para dar a notícia a Eli."
,"15":"Ora, Eli estava com noventa e oito anos; tinha os olhos imóveis e não podia ver."
,"16":"O benjaminita disse a Eli: «Sou o homem que chegou do campo de batalha». Eli perguntou: «O que aconteceu, meu filho?»"
,"17":"O mensageiro respondeu: «Israel fugiu dos filisteus e a derrota do exército foi grande. Os teus dois filhos, Hofni e Fineias, morreram e a arca de Deus foi tomada»."
,"18":"Quando o homem falou da arca de Deus, Eli caiu da cadeira para trás, junto à porta, quebrou o pescoço e morreu. Ele já era velho e pesado. Tinha sido juiz em Israel durante quarenta anos."
,"19":"A nora de Eli, mulher de Fineias, estava grávida, e o momento do parto já se aproximava. Quando ouviu a notícia de que tinham tomado a arca de Deus e de que o sogro e o marido tinham morrido, chegaram as dores do parto; ela encurvou-se e deu à luz."
,"20":"Estando para morrer, as mulheres que lhe davam assistência disseram: «Ânimo! Tiveste um filho». Ela, porém, não respondeu, nem fez caso disso."
,"21":"Deu ao seu filho o nome de Icabod, dizendo: «A glória de Israel foi exilada». Falou assim, referindo-se à tomada da arca de Deus e também por causa do sogro e do marido."
,"22":"E repetia: «A glória de Israel foi exilada, porque tomaram a arca de Deus»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Os filisteus tomaram a arca de Deus e levaram-na de Ebenezer para Azoto."
,"2":"Tomaram a arca de Deus e colocaram-na no templo de Dagon, junto à estátua de Dagon."
,"3":"Na manhã seguinte os habitantes de Azoto levantaram-se e encontraram Dagon caído de bruços diante da arca de Javé. Pegaram em Dagon e puseram-no novamente no seu lugar."
,"4":"Na manhã seguinte levantaram-se e de novo encontraram Dagon caído de bruços diante da arca de Javé. A cabeça de Dagon e as duas mãos cortadas estavam sobre a soleira da porta. Só o tronco de Dagon estava no seu lugar."
,"5":"É por isso que os sacerdotes de Dagon e todos os que entram no seu templo, até ao dia de hoje, não pisam a soleira da porta do templo de Dagon, em Azoto."
,"6":"Depois disto, a mão de Javé caiu pesadamente contra os habitantes de Azoto e castigou-os com tumores, em Azoto e nas redondezas."
,"7":"Quando viram o que estava a acontecer, os habitantes de Azoto disseram: «A arca do Deus de Israel não deve ficar connosco, porque a sua mão está a pesar contra nós e contra o deus Dagon»."
,"8":"Então convocaram em Azoto todos os príncipes dos filisteus e perguntaram: «Que devemos fazer à arca do Deus de Israel?» Os príncipes decidiram: «Levai a arca do Deus de Israel para Gat». E assim fizeram."
,"9":"Mas, logo que a levaram, a mão de Javé caiu sobre a cidade, e houve um grande pânico, porque Javé feriu com tumores toda a população, tanto as crianças como os adultos."
,"10":"Levaram então a arca de Deus para Acaron. Logo que a arca de Deus lá chegou, o povo da cidade protestou: «Trouxestes a arca do Deus de Israel para nos matar, a nós e às nossas famílias!»"
,"11":"Então mandaram convocar os príncipes dos filisteus, e disseram: «Devolvei a arca do Deus de Israel. É melhor que volte para o seu lugar, antes que nos destrua a nós e às nossas famílias». O povo estava tomado de pavor mortal, porque a mão de Deus era muito pesada;"
,"12":"os que não morriam, ficavam cheios de tumores. E o clamor do povo subia até ao céu."
}`)
	CurrentBook.AddChapter(6, `{
"1":"A arca de Javé ficou sete meses na terra dos filisteus."
,"2":"Por fim, eles chamaram os sacerdotes e os adivinhos e perguntaram-lhes: «Que devemos fazer à arca de Javé? Dizei-nos como podemos devolvê-la ao seu lugar»."
,"3":"Eles responderam: «Se quereis devolver a arca do Deus de Israel, não a mandeis sem nada, mas pagai uma indemnização. Desse modo, recuperareis a saúde e sabereis por que motivo Deus vos castigou tanto»."
,"4":"O povo perguntou: «Que indemnização devemos pagar?» Eles responderam: «Cinco tumores de ouro e cinco ratos de ouro, em nome de cada príncipe dos filisteus, porque eles sofreram a mesma praga que vós."
,"5":"Fazei imagens dos vossos tumores e dos ratos que devastam o território, e oferecei-as como homenagem ao Deus de Israel. Talvez o peso da sua mão se afaste de vós, do vosso país e do vosso deus."
,"6":"Não fiqueis de coração enfurecido como os egípcios e o Faraó. Depois de Deus os ter tratado tão mal, eles acabaram por deixar partir os israelitas."
,"7":"Agora fazei um carro novo e tomai duas vacas com crias e que ainda não tenham usado canga; atrelai-as ao carro depois de terdes levado os seus vitelos para o curral."
,"8":"Tomai depois a arca de Javé e colocai-a no carro. Quanto aos objectos de ouro que servem para pagar a indemnização, colocai-os num cofre, ao lado da arca, e depois deixai-a ir."
,"9":"Ficai a observá-la: se tomar o caminho do seu próprio território, indo para Bet-Sames, foi Deus quem nos fez este grande mal; se não seguir esse caminho, saberemos que não foi a sua mão que nos atingiu, mas foi apenas um acaso»."
,"10":"Eles assim fizeram. Tomaram duas vacas com crias e atrelaram-nas ao carro, deixando os bezerros no curral."
,"11":"Colocaram a arca de Javé no carro e também o cofre com os ratos de ouro e as imagens dos tumores."
,"12":"As vacas foram logo pelo caminho de Bet-Sames. Iam mugindo, sem se desviarem nem para a direita nem para a esquerda. Os príncipes dos filisteus acompanharam-nas até às fronteiras de Bet-Sames."
,"13":"Os habitantes de Bet-Sames ceifavam o trigo no vale. Quando olharam, viram a arca e foram alegres ao seu encontro."
,"14":"O carro chegou ao campo de Josué, em Bet-Sames, e parou no lugar onde havia uma grande pedra. Então as pessoas racharam a madeira do carro e ofereceram as vacas em holocausto a Javé."
,"15":"Os levitas tinham tirado do carro a arca de Javé e o cofre com os objectos de ouro. Então colocaram tudo sobre a grande pedra. Nesse dia o povo de Bet-Sames ofereceu holocaustos e sacrifícios a Javé."
,"16":"Os cinco príncipes dos filisteus ficaram a observar e, no mesmo dia, voltaram para Acaron."
,"17":"Os tumores de ouro que os filisteus tinham pago como indemnização a Javé eram cinco: um por Azoto, um por Gaza, um por Ascalon, um por Gat e um por Acaron."
,"18":"Os ratos de ouro foram oferecidos em nome de todas as cidades dos filisteus, incluindo as cidades dos cinco príncipes, as cidades fortificadas e as aldeias do campo. A pedra grande onde colocaram a arca de Javé, ainda está como testemunha no campo de Josué, em Bet-Sames."
,"19":"Quando viram a arca de Javé, os filhos de Jeconias não fizeram festa como os outros. Por isso, é que Javé castigou setenta dos seus homens. O povo ficou de luto, porque Javé os tinha ferido com grande castigo."
,"20":"E os habitantes de Bet-Sames disseram: «Quem poderá ficar na presença de Javé, o Deus santo? Para onde podemos mandar a arca, para nos livrarmos dela?»"
,"21":"Mandaram então esta mensagem aos habitantes de Cariat-Iarim: «Os filisteus devolveram a arca de Javé. Vinde buscá-la»."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Os habitantes de Cariat-Iarim foram e levaram a arca de Javé. Colocaram a arca na casa de Abinadab, no alto da colina, e consagraram Eleazar, filho de Abinadab, para guardar a arca de Javé."
,"2":"Desde que a arca foi colocada em Cariat-Iarim, passou-se longo tempo: cerca de vinte anos. Todo o povo de Israel começou a lamentar-se diante de Javé."
,"3":"Então Samuel falou a todos os israelitas: «Se quereis converter-vos de todo o coração a Javé, tirai do meio de vós os deuses e deusas dos estrangeiros. Devotai-vos inteiramente a Javé e só a Ele servi. Assim Ele vos livrará do poder filisteu»."
,"4":"Então os israelitas livraram-se das imagens dos deuses e deusas dos estrangeiros, e começaram a servir somente a Javé."
,"5":"Samuel ordenou: «Reuni todo o Israel em Masfa, e eu rezarei a Javé por vós»."
,"6":"Eles reuniram-se em Masfa, tiraram água, e derramaram-na diante de Javé. Nesse dia, fizeram jejum e confessaram: «Pecámos contra Javé». E Samuel julgou os israelitas em Masfa."
,"7":"Os filisteus tiveram conhecimento de que os israelitas se haviam reunido em Masfa. Então os príncipes dos filisteus subiram contra Israel. Ao ouvir isso, os israelitas ficaram com medo dos filisteus,"
,"8":"e disseram a Samuel: «Não cesses de clamar por nós a Javé, nosso Deus, para que Ele nos liberte do poder filisteu»."
,"9":"Samuel tomou um cordeirinho que ainda mamava e ofereceu-o em holocausto. Depois clamou a Javé em favor de Israel, e Javé escutou-o."
,"10":"Enquanto Samuel oferecia o holocausto, os filisteus atacaram Israel. Nesse dia, porém, Javé mandou contra os filisteus uma grande tempestade, que os dispersou, e Israel derrotou-os."
,"11":"Os israelitas saíram de Masfa, perseguiram os filisteus e foram-nos derrotando até Bet-Car."
,"12":"Então Samuel tomou uma pedra e colocou-a entre Masfa e Sen; deu-lhe o nome de Ebenezer, explicando: «Javé socorreu-nos até aqui»."
,"13":"Os filisteus foram dominados e nunca mais invadiram o território de Israel, porque a mão de Javé pesou sobre eles enquanto Samuel viveu."
,"14":"Israel reconquistou as cidades que os filisteus tinham tomado. Deste modo, essas cidades, juntamente com os seus territórios, voltaram ao poder de Israel, desde Acaron até Gat. E houve paz entre Israel e os amorreus."
,"15":"Até à sua morte, Samuel foi juiz em Israel."
,"16":"Todos os anos ele visitava Betel, Guilgal e Masfa, e julgava Israel em todos esses lugares."
,"17":"Depois voltava a Ramá, onde ficava a sua residência e onde exercia as suas funções de juiz sobre Israel. Foi ali que construiu um altar a Javé."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quando já estava velho, Samuel estabeleceu os seus dois filhos como juízes em Israel."
,"2":"O seu primeiro filho chamava-se Joel, e o segundo Abias. Ambos exerceram o cargo de juiz em Bersabeia."
,"3":"Eles, porém, não seguiram o exemplo do pai, deixando-se levar pela ganância: aceitaram suborno e distorceram o direito."
,"4":"Então os anciãos de Israel reuniram-se e foram ter com Samuel, em Ramá."
,"5":"Disseram a Samuel: «Vê. Tu já estás velho e os teus filhos não seguem o teu exemplo. Por isso, dá-nos um rei, para que nos governe, como acontece em todas as nações»."
,"6":"Não agradou a Samuel a frase que eles disseram: «Dá-nos um rei para que nos governe». Então Samuel invocou Javé."
,"7":"E Javé disse a Samuel: «Atende à voz do povo em tudo o que eles pedirem, pois não é a ti que eles rejeitam, mas a Mim; não querem que Eu reine mais sobre eles."
,"8":"Assim como eles têm feito desde o dia em que os tirei do Egipto até hoje, abandonando-Me e servindo outros deuses, a mesma coisa eles fizeram contigo."
,"9":"Atende o seu pedido. Contudo, mostra com clareza e explica os direitos do rei que reinará sobre eles»."
,"10":"Samuel transmitiu todas as palavras de Javé ao povo que lhe pedia um rei."
,"11":"E disse-lhes: «Este é o direito do rei que vos governará: ele convocará os vossos filhos para cuidar dos seus carros e cavalos, e correr à frente do seu carro."
,"12":"Ele nomear-vos-á chefes de mil e chefes de cinquenta. Ele obrigar-vos-á a lavrar as suas terras, a fazer as suas colheitas, a fabricar as suas armas de guerra e as peças dos seus carros."
,"13":"As vossas filhas serão convocadas para trabalhar como perfumistas, cozinheiras e padeiras."
,"14":"Ele tomará os vossos campos, vinhas e os melhores olivais, para os dar aos ministros."
,"15":"Tomará a décima parte dos vossos olivais e vinhas, e dá-los-á aos seus oficiais e ministros."
,"16":"Os vossos melhores servos e servas, os bois e jumentos, ele tomá-los-á para que fiquem ao seu serviço,"
,"17":"e cobrará, como tributo, a décima parte dos rebanhos. E vós mesmos tornar-vos-eis seus escravos."
,"18":"Quando isso acontecer, queixar-vos-eis do rei que escolhestes. Nesse dia, porém, Javé não vos dará nenhuma resposta»."
,"19":"No entanto, o povo não quis ouvir as explicações de Samuel, e disse: «Não tem importância. Teremos um rei,"
,"20":"e seremos também como as outras nações: o nosso rei governar-nos-á, irá à nossa frente para comandar as nossas guerras»."
,"21":"Samuel ouviu tudo o que o povo disse e foi contá-lo a Javé."
,"22":"E Javé respondeu: «Se é isso que querem, dá-lhes um rei». Então Samuel disse aos israelitas: «Volte cada um para a sua cidade»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Entre os benjaminitas, havia um homem chamado Cis, filho de Abiel, filho de Seror, filho de Becorat, filho de Afia. Era um benjaminita muito importante."
,"2":"Esse homem tinha um filho chamado Saul, jovem de boa aparência. Era um israelita imponente: os outros apenas lhe chegavam aos ombros."
,"3":"As jumentas de Cis, pai de Saul, tinham-se extraviado. Cis disse ao filho Saul: «Chama um dos empregados e vai procurar as jumentas»."
,"4":"Eles cruzaram a região montanhosa de Efraim, atravessaram o território de Salisa, mas não as encontraram. Atravessaram a região de Salim, e nada. Atravessaram a região de Benjamim, e nem aí encontraram as jumentas."
,"5":"Quando chegaram ao território de Suf, Saul disse ao empregado que o acompanhava: «Vamos regressar, senão o meu pai vai ficar mais preocupado connosco do que com as jumentas»."
,"6":"O empregado, porém, sugeriu: «Olha, na cidade vizinha há um homem de Deus que é muito famoso. Tudo o que ele diz, acontece de facto. Vamos até lá. Quem sabe? Talvez ele nos possa orientar sobre o caminho que devemos seguir»."
,"7":"Saul disse ao empregado: «Podemos ir. Mas que vamos oferecer a esse homem? Já não temos pão na sacola. Não temos nada para oferecer a esse homem de Deus. Será que sobrou alguma coisa?»"
,"8":"O empregado respondeu: «Tenho aqui uma pequena moeda de prata. Vou oferecê-la ao homem de Deus, e ele dar-nos-á uma orientação»."
,"9":"(Em Israel, antigamente, quando alguém ia consultar a Deus, costumava dizer: 'Vamos ao vidente'. Porque, em lugar de 'profeta', como se diz hoje, dizia-se 'vidente')."
,"10":"Saul replicou: «Óptimo, vamos lá». E foram à cidade onde morava o homem de Deus."
,"11":"Quando subiam a ladeira para a cidade, encontraram duas jovens que iam buscar água. Então perguntaram-lhes: «É aqui que mora o vidente?»"
,"12":"As jovens responderam: «É sim. Ele acabou de chegar um pouco antes de vós. Ide depressa. Ele veio hoje à cidade, porque hoje o povo vai oferecer um sacrifício no lugar alto."
,"13":"Entrando na cidade, encontrá-lo-eis antes de ele subir ao lugar alto para comer. O povo não vai comer antes de ele chegar, porque é ele quem abençoa o sacrifício. Só depois é que os convidados podem comer. Subi depressa e encontrá-lo-eis»."
,"14":"Eles então subiram até à cidade. Quando passavam pela porta da cidade, Samuel ia na direcção deles para subir até ao lugar alto."
,"15":"Ora, um dia antes da chegada de Saul, Javé tinha feito uma revelação a Samuel:"
,"16":"«Amanhã, a esta mesma hora, vou mandar-te um homem da terra de Benjamim. Tu ungi-lo-ás como chefe do meu povo Israel, e ele libertará o povo do poder filisteu, porque Eu vi a miséria do meu povo, e o seu clamor chegou até junto de Mim»."
,"17":"Quando Samuel viu Saul, Javé avisou-o: «É este o homem de quem te falei. É ele quem vai dirigir o meu povo»."
,"18":"Saul chegou perto de Samuel, no meio da porta, e perguntou-lhe: «Podes dizer-me onde é a casa do vidente?»"
,"19":"Samuel respondeu: «Sou eu o vidente. Sobe à minha frente até ao lugar alto. Hoje comerás comigo, e amanhã de manhã partirás. Vou resolver a questão que te preocupa."
,"20":"Não te preocupes com as jumentas que perdeste há três dias. Elas já foram encontradas. Aliás, de quem é toda a riqueza de Israel? Não é, por acaso, tua e da família de teu pai?»"
,"21":"Saul respondeu: «Eu sou de Benjamim, a menor das tribos de Israel; o meu clã é o menos importante de todos os da tribo de Benjamim. Porque é que me dizes isso?»"
,"22":"Samuel levou Saul e o seu empregado até à sala e deu-lhes um lugar de honra entre os convidados, que eram cerca de trinta pessoas."
,"23":"Depois disse ao cozinheiro: «Traz a porção que te mandei preparar»."
,"24":"Então o cozinheiro levou o pernil e o rabo e serviu-os a Saul, enquanto Samuel dizia: «Aí está o que foi reservado para ti. Come, porque foi guardado para esta ocasião, a fim de que o comas acompanhado pelos convidados». E nesse dia Saul comeu ao lado de Samuel."
,"25":"Em seguida, desceram do lugar alto para a cidade, prepararam para Saul uma cama no terraço,"
,"26":"e ele deitou-se. Ao nascer do sol, Samuel chamou Saul no terraço, e disse: «Levanta-te, que eu vim para me despedir». Saul levantou-se e saíram juntos da casa com Samuel. "
,"27":"Quando chegaram aos limites da cidade, Samuel disse a Saul: «Diz ao empregado que vá à frente. Quanto a ti, espera um momento, para que te comunique a palavra de Deus»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Então Samuel tomou a vasilha de óleo, e derramou-o sobre a cabeça de Saul. Depois beijou-o e disse: «Javé ungiu-te para seres chefe sobre Israel, seu povo. Tu governarás o povo e libertá-lo-ás dos inimigos vizinhos. Eis o sinal de que Javé te ungiu como chefe da sua herança:"
,"2":"hoje, quando saíres daqui, encontrarás dois homens junto ao túmulo de Raquel, na fronteira de Benjamim. Eles dir-te-ão: 'Encontraram as jumentas que foste procurar. O teu pai esqueceu a história das jumentas e está preocupado contigo, e anda a perguntar: O que terá acontecido ao meu filho?'"
,"3":"Prosseguindo o caminho, chegarás ao Carvalho do Tabor, e então encontrarás três homens que sobem para o santuário de Deus em Betel, levando um três cabritos, outro três pães, e o terceiro uma vasilha com vinho."
,"4":"Eles vão cumprimentar-te e oferecer-te dois pães. Tu deves aceitar."
,"5":"Depois chegarás a Gabaá de Deus, onde estão os governadores filisteus. Entrando na cidade, encontrarás um grupo de profetas descendo do lugar alto, acompanhados de harpas, tamborins, flautas e cítaras, profetizando."
,"6":"Então o espírito de Javé virá sobre ti, e também tu profetizarás com eles e te transformarás noutro homem."
,"7":"Quando esses sinais se realizarem, faz o que achares melhor, porque Deus estará contigo."
,"8":"Desce para Guilgal antes de mim. Em seguida, irei encontrar-me contigo para oferecer holocaustos e sacrifícios de comunhão. Espera sete dias. Depois irei ao teu encontro e mostrar-te-ei o que deverás fazer»."
,"9":"Assim que Saul voltou as costas e deixou Samuel, Deus mudou-lhe o coração. E todos esses sinais aconteceram nesse mesmo dia."
,"10":"Daí, partiram para Gabaá, e um grupo de profetas foi ao encontro de Saul. O espírito de Javé desceu sobre ele, e pôs-se a profetizar no meio deles."
,"11":"Todos os que conheciam Saul há muito tempo viram-no a profetizar entre os profetas, e diziam uns para os outros: «O que é que aconteceu ao filho de Cis? Também Saul entre os profetas?»"
,"12":"Um homem da vizinhança perguntou: «Quem é o pai dele?» É por isso que se tornou provérbio esta frase: «Também Saul entre os profetas?»"
,"13":"Quando acabou de profetizar, Saul foi para casa."
,"14":"O tio de Saul perguntou-lhe a ele e ao empregado: «Aonde fostes?» Saul respondeu: «À procura das jumentas, mas não as encontrámos e por isso fomos ter com Samuel»."
,"15":"O tio de Saul perguntou: «Conta-me o que Samuel vos disse»."
,"16":"Saul disse ao tio: «Ele contou-nos que as jumentas já tinham sido encontradas». Mas não lhe disse nada do que Samuel tinha dito sobre a realeza."
,"17":"Em Masfa, Samuel convocou o povo em torno de Javé,"
,"18":"e disse aos israelitas: «Assim diz Javé, o Deus de Israel: Eu tirei Israel do Egipto, e libertei-vos do poder do Egipto e do poder de todos os reinos que vos oprimiam."
,"19":"Contudo, hoje rejeitastes o vosso Deus, que vos salvou de todos os males e angústias. Vós dissestes: 'Não importa, estabelece um rei para nós!' Agora, portanto, comparecei diante de Javé por tribos e clãs»."
,"20":"Samuel convocou todas as tribos de Israel, e foi sorteada a tribo de Benjamim."
,"21":"Convocou então a tribo de Benjamim por clãs, e o clã de Metri foi sorteado. E Saul, filho de Cis, foi apontado no sorteio. Procuraram Saul, mas não o encontraram."
,"22":"Consultaram, então, a Javé: «Saul está aqui?» Javé respondeu: «Ele está escondido entre as bagagens»."
,"23":"Correram a buscá-lo, e colocaram-no no meio do povo: os outros chegavam-lhe apenas aos ombros."
,"24":"Samuel disse a todo o povo: «Vedes quem Javé escolheu? Não há, entre todo o povo, ninguém igual a ele». E todo o povo começou a aclamar, gritando: «Viva o rei!»"
,"25":"Samuel explicou ao povo o direito do rei, e escreveu-o num livro, que colocou diante de Javé. Em seguida, despediu o povo, cada um para sua casa."
,"26":"Saul também voltou para sua casa em Gabaá, e com ele foram também os valentes, cujo coração Deus havia tocado."
,"27":"Os vadios, porém, comentaram: «Como é que esse indivíduo nos poderá salvar?» Desprezaram-no e não lhe deram presentes. E Saul calava-se."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Um mês depois, o amonita Naás fez uma incursão e acampou contra Jabes de Galaad. Todos os habitantes de Jabes propuseram a Naás: «Faz uma aliança connosco e seremos teus servos»."
,"2":"Naás, porém, respondeu: «Farei uma aliança convosco com a condição de vos furar o olho direito. Desse modo, provocarei todo o povo de Israel»."
,"3":"Então os anciãos de Jabes pediram-lhe: «Dá-nos uma trégua de sete dias. Mandaremos mensageiros a todo o território de Israel. Se ninguém nos ajudar, render-nos-emos a ti»."
,"4":"Os mensageiros chegaram a Gabaá de Saul, expuseram a situação a todo o povo, e todos começaram a chorar e a gritar."
,"5":"Ora, aconteceu que Saul chegava do campo, onde cuidava dos bois, e perguntou: «Que aconteceu? Porque é que o povo está a chorar deste modo?» Contaram-lhe, então, o que os homens de Jabes lhes haviam dito."
,"6":"Quando Saul ouviu a notícia, o espírito de Javé tomou conta dele. Saul ficou enfurecido,"
,"7":"tomou uma junta de bois, despedaçou-os e mandou-os por mensageiros a todo o território de Israel, com este recado: «Se alguém não acompanhar Saul e Samuel, a mesma coisa acontecerá aos seus bois». O terror de Javé abateu-se sobre o povo. E eles marcharam para a guerra, como se fossem um só homem."
,"8":"Saul, em Bezec, passou revista às tropas: de Israel havia trezentos mil, e de Judá trinta mil."
,"9":"Então Saul disse aos mensageiros: «Dizei aos habitantes de Jabes de Galaad: 'Amanhã, quando o sol aquecer, sereis socorridos'. Os mensageiros voltaram e deram a notícia aos habitantes de Jabes. Estes ficaram cheios de alegria,"
,"10":"e disseram a Naás: «Amanhã render-nos-emos, e fareis de nós o que vos aprouver»."
,"11":"No dia seguinte, Saul dividiu o seu exército em três grupos, que invadiram o acampamento de manhãzinha, e atacaram os amonitas até à hora em que o sol aqueceu. Os sobreviventes dispersaram-se, de modo a não ficarem dois juntos."
,"12":"Então o povo disse a Samuel: «Quais eram os que diziam que Saul não reinaria sobre nós? Diz-nos os seus nomes, que nós os mataremos»."
,"13":"Saul, porém, disse: «Hoje ninguém deverá ser morto, porque neste dia Javé salvou Israel»."
,"14":"Depois Samuel disse ao povo: «Vamos a Guilgal para inaugurar aí a realeza»."
,"15":"Todo o povo se reuniu em Guilgal, e ali mesmo, diante de Javé, proclamaram Saul como rei. Ofereceram a Javé sacrifícios de comunhão, e Saul com os israelitas fizeram uma grande festa."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Samuel disse a todo o Israel: «Como vistes, condescendi em tudo o que me pedistes e estabeleci um rei sobre vós."
,"2":"De agora em diante, é o rei quem estará à frente de vós. Eu já estou velho, de cabelos brancos, e os meus filhos estão no meio de vós. Fiquei à frente de vós desde a minha juventude até hoje."
,"3":"Aqui estou eu. Deponde contra mim diante de Javé e do seu ungido. A quem tomei um boi e a quem tomei um jumento? A quem explorei e a quem oprimi? De quem recebi dinheiro para fechar os olhos sobre o caso? Tudo vos restituirei»."
,"4":"Eles disseram: «Tu não exploraste, nem oprimiste, nem tiraste nada a ninguém»."
,"5":"Samuel disse-lhes: «Hoje, aqui Javé é testemunha contra vós, e o seu ungido é testemunha de que não encontrastes nada nas minhas mãos». Responderam: «Ele é testemunha»."
,"6":"Então Samuel disse ao povo: «Foi Javé quem agiu com Moisés e Aarão, e tirou da terra do Egipto os vossos antepassados."
,"7":"Agora esperai! Vou citar contra vós, diante de Javé, todos os actos de justiça que Javé realizou em vosso favor e dos vossos antepassados:"
,"8":"Quando Jacob esteve no Egipto, os egípcios oprimiram-no, e os vossos antepassados clamaram a Javé. Ele enviou Moisés e Aarão, que tiraram do Egipto os vossos antepassados, e aqui neste lugar os instalou."
,"9":"Mas eles esqueceram-se de Javé seu Deus, que os entregou ao poder de Sísara, chefe do exército de Hasor, ao poder dos filisteus e ao poder do rei de Moab, que fizeram guerra contra eles."
,"10":"Então eles clamaram a Javé: 'Pecámos, porque abandonámos Javé, para servir aos deuses e deusas dos cananeus. Mas agora, liberta-nos do poder dos nossos inimigos, e nós Te serviremos'."
,"11":"Então Javé mandou Jerobaal, Barac, Jefté e Samuel: libertou-vos do poder dos inimigos vizinhos, e vivestes em segurança."
,"12":"Mas, quando vistes Naás, rei dos amonitas, marchar contra vós, dissestes-me: 'Não importa. Queremos ser governados por um rei'. No entanto, Javé vosso Deus era o vosso rei!"
,"13":"Agora, aí está o rei que escolhestes e pedistes: Javé deu-vos um rei!"
,"14":"Se temerdes Javé e O servirdes, se Lhe obedecerdes e não vos opuserdes a Ele, tanto vós, como o rei que reina sobre vós, seguireis a Javé vosso Deus."
,"15":"Mas se não obedecerdes a Javé e vos opuserdes a Ele, então a mão de Javé pesará sobre vós e sobre o vosso rei."
,"16":"Esperai mais um pouco, e vede esta grande coisa que Javé realiza diante de vós:"
,"17":"Não é agora o tempo da colheita do trigo? Pois bem! Eu invocarei Javé, e Ele mandará trovões e chuva. Reconhecei e vede o grande mal que realizastes aos olhos de Javé, pedindo um rei!»"
,"18":"Então Samuel invocou a Javé, e Javé mandou trovões e chuva nesse dia. O povo temeu muito a Javé e a Samuel."
,"19":"E todo o povo disse a Samuel: «Intercede pelos teus servos junto de Javé teu Deus, para que não morramos, porque aos nossos pecados acrescentámos o mal de pedir um rei»."
,"20":"Samuel disse ao povo: «Não temais. De facto, cometestes todo esse mal. Agora não vos afasteis de Javé e servi-O de todo o coração."
,"21":"Não vos afasteis para correr atrás de ídolos que não servem para nada e não podem libertar, porque são vazios."
,"22":"É por causa do seu grande Nome que Javé não abandonará o seu povo, porque Javé decidiu fazer de vós o seu povo."
,"23":"Quanto a mim, longe de mim pecar contra Javé, deixando de interceder por vós. Continuarei a ensinar-vos o caminho bom e recto."
,"24":"Temei somente a Javé e servi-O com fidelidade e de todo o coração. Vede que coisas grandes Ele realizou no meio de vós!"
,"25":"Contudo, se praticardes o mal, tanto vós como o vosso rei perecereis»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Saul tinha trinta anos quando se tornou rei, e reinou sobre Israel durante vinte anos."
,"2":"Saul escolheu para si três mil israelitas: dois mil estavam com ele em Macmas e na montanha de Betel, enquanto mil estavam com Jónatas em Gabaá de Benjamim. Saul despediu o resto do povo, mandando cada um para a sua tenda."
,"3":"Jónatas matou o governador dos filisteus que estava em Gaba, e os filisteus ouviram a notícia. Então Saul mandou tocar a trombeta, por todo o território, dizendo: «Que os hebreus ouçam!»"
,"4":"Todo o Israel soube que Saul tinha matado o governador filisteu, e também que Israel se havia tornado odioso para os filisteus. Então o povo reuniu-se atrás de Saul, em Guilgal."
,"5":"Os filisteus reuniram-se para combater contra Israel: três mil carros, seis mil cavalos e uma tão numerosa multidão como os grãos de areia da praia. Subiram e acamparam em Macmas, a Oriente de Bet-Áven."
,"6":"Os israelitas viram-se em apuros, porque estavam muito perto uns dos outros. Então o povo escondeu-se em cavernas, buracos, rochas, grutas e poços."
,"7":"Alguns hebreus atravessaram o Jordão para o território de Gad e Galaad. Saul estava ainda em Guilgal e todo o povo, tremendo de medo, foi à procura dele. "
,"8":"Ele esperou sete dias pela reunião marcada com Samuel. Mas Samuel não chegou a Guilgal, e o povo começou a debandar, abandonando Saul."
,"9":"Então Saul disse: «Preparai o holocausto e os sacrifícios de comunhão». E ofereceu o holocausto."
,"10":"Ele estava a acabar de oferecer o holocausto, quando Samuel chegou. Saul foi ao encontro dele para o saudar."
,"11":"Samuel perguntou: «Que fizeste?» Saul respondeu: «Vi que o povo me abandonava e debandava, que tu não chegavas para a reunião no dia marcado, e que os filisteus estavam reunidos em Macmas."
,"12":"Então reflecti: 'Agora os filisteus vão cair sobre mim em Guilgal, sem que eu tenha oferecido sacrifícios a Javé'. Assim forçado, ofereci o holocausto»."
,"13":"Samuel disse a Saul: «Agiste como louco! Tu não obedeceste ao mandamento que Javé teu Deus te tinha ordenado. Certamente Javé teria confirmado para sempre o reinado que exercerias sobre Israel."
,"14":"Agora, porém, o teu reinado não se firmará. Javé encontrou um homem conforme o seu coração e nomeou-o chefe do seu povo, porque não obedeceste ao que Javé te tinha ordenado»."
,"15":"Samuel levantou-se e partiu de Guilgal para Gabaá de Benjamim. Saul então passou revista à tropa que seguia com ele. Havia cerca de seiscentos homens."
,"16":"Saul e seu filho Jónatas com as suas tropas fixaram-se em Gaba de Benjamim; os filisteus estavam acampados em Macmas."
,"17":"Do acampamento filisteu, um comando de ataque saiu dividido em três grupos: um tomou a direcção de Efra, no território de Sual,"
,"18":"outro dirigiu-se para Bet-Horon, e o terceiro foi para a elevação que domina o vale das Hienas, no caminho do deserto."
,"19":"No território de Israel, nesse tempo, não havia nenhum ferreiro, porque os filisteus haviam decidido que os hebreus não fabricariam espadas ou lanças."
,"20":"Por esse motivo, todos os israelitas tinham que ir até aos filisteus para afiar a relha, o machado, a enxada e a foice."
,"21":"Para afiar uma relha ou machado, os filisteus cobravam oito gramas de prata, e quatro gramas, para afiar as enxadas, forquilhas e guilhos."
,"22":"E assim, aconteceu que, na hora da batalha, nas mãos da gente que acompanhava Saul e Jónatas não havia nem espada nem lança, a não ser as de Saul e de seu filho Jónatas."
,"23":"Uma guarnição de filisteus partiu para o desfiladeiro de Macmas."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Certo dia, Jónatas, filho de Saul, disse ao seu escudeiro: «Vamos até à guarnição dos filisteus que está do outro lado». Mas Jónatas nada comunicou a seu pai."
,"2":"Saul estava na fronteira de Gaba, sentado debaixo da romãzeira que fica perto da eira, e com ele estava um exército de aproximadamente seiscentos homens."
,"3":"Quem trazia o efod era Aías, filho de Aquitob, irmão de Icabod, filho de Fineias, filho de Eli, sacerdote de Javé em Silo. Ninguém reparou que Jónatas havia partido."
,"4":"No desfiladeiro, que Jónatas procurava atravessar para chegar até à guarnição filisteia, havia dois morros: um chamava-se Boses e o outro Sene."
,"5":"O primeiro morro fica a Norte e o outro a Sul; o primeiro eleva-se em frente de Macmas, o segundo do lado de Gaba."
,"6":"Jónatas disse ao seu escudeiro: «Vamos atacar a guarnição desses incircuncisos. Talvez Javé faça alguma coisa por nós, pois Javé pode dar-nos a vitória, quer sejamos muitos ou poucos»."
,"7":"O escudeiro respondeu: «Faz o que quiseres; estou à tua disposição»."
,"8":"Jónatas disse: «Vamos em direcção a eles e deixaremos que nos vejam."
,"9":"Se nos disserem: 'Não vos movais até nos aproximarmos', então ficaremos parados e não avançaremos."
,"10":"Mas se nos disserem: 'Subi até aqui', então subiremos, porque Javé os entrega nas nossas mãos. Esse será o sinal»."
,"11":"Os dois deixaram que a guarnição filisteia os visse, e os filisteus comentaram: «Olhai! Alguns hebreus saíram das cavernas, onde estavam escondidos!»"
,"12":"Os da guarnição disseram a Jónatas e ao seu escudeiro: «Subi até aqui. Temos uma coisa para vos contar». Então Jónatas disse ao escudeiro: «Segue atrás de mim, porque Javé os entregou nas mãos de Israel»."
,"13":"Jónatas subiu rastejando e o seu escudeiro seguiu-o. Jónatas feria-os, e os escudeiro acabava de os matar."
,"14":"Foi a primeira matança que Jónatas e o seu escudeiro realizaram: cerca de vinte homens, num pequeno espaço de terreno."
,"15":"O terror espalhou-se no acampamento, na região e em todo o exército filisteu. A guarnição e os comandos de ataque ficaram com medo, a terra tremeu, e houve grande pânico."
,"16":"As sentinelas de Saul, que estavam em Gaba de Benjamim, perceberam que o exército fugia em debandada."
,"17":"Então Saul ordenou aos que estavam com ele: «Fazei uma chamada e vede quem está ausente». Fizeram a chamada e verificaram que faltavam Jónatas e o seu escudeiro."
,"18":"Saul ordenou a Aías: «Traz o efod». Porque nessa época era Aías quem tinha o efod em Israel."
,"19":"Enquanto Saul falava com o sacerdote, crescia cada vez mais a confusão no acampamento dos filisteus. Então Saul disse ao sacerdote: «Retira a tua mão»."
,"20":"Saul e todo o povo que estava com ele reuniram-se e foram para o campo de batalha. Os filisteus desembainhavam a espada uns contra os outros, e a confusão era muito grande."
,"21":"Então os hebreus que estavam ao serviço dos filisteus e tinham subido com eles para o acampamento, desertaram e aderiram a Israel, ficando do lado de Saul e Jónatas."
,"22":"E todos os israelitas, que se haviam escondido na região montanhosa de Efraim, ouvindo a notícia de que os filisteus estavam a fugir, também começaram a persegui-los e a combatê-los."
,"23":"Nesse dia, Javé deu a vitória a Israel. O combate estendeu-se até para além de Bet-Áven. "
,"24":"O povo de Israel já estava exausto nesse dia, e Saul pronunciou esta maldição: «Maldito seja quem comer alguma coisa antes da tarde, antes de eu me vingar dos meus inimigos». E ninguém comeu nada."
,"25":"Ora, no campo havia um favo de mel."
,"26":"O povo chegava perto do favo, via o mel a escorrer, mas ninguém lhe tocava, nem o levava à boca, porque tinham medo do juramento que Saul havia feito."
,"27":"Jónatas, porém, não sabia do juramento com que seu pai tinha comprometido o povo. Levantou a vara que tinha consigo, espetou-a no favo e levou-o à boca. Imediatamente a sua vista melhorou."
,"28":"Mas alguém do grupo viu o que ele tinha feito, e disse: «O teu pai obrigou o povo com juramento, amaldiçoando quem comesse qualquer coisa hoje»."
,"29":"Jónatas exclamou: «Meu pai quer arruinar o país! Vede como os meus olhos estão mais claros por ter provado um pouco deste mel."
,"30":"Se o povo tivesse comido hoje dos despojos que tomou aos inimigos, a derrota dos filisteus teria sido muito maior»."
,"31":"Nesse dia, os filisteus foram perseguidos desde Macmas até Aialon. Mas o povo estava exausto."
,"32":"Então o povo atirou-se sobre os despojos, tomou ovelhas, vacas e bezerros e degolou-os ali mesmo no chão. E comeram-nos com sangue."
,"33":"Foram então avisar Saul: «O povo está a cometer um pecado contra Javé, porque está a comer carne com sangue». Saul respondeu: «Vós fostes infiéis! Trazei-me uma grande pedra». "
,"34":"E acrescentou: «Ide por todo o povo e dizei-lhes que cada um traga aqui o seu boi ou a sua ovelha; imolai os animais aqui e depois comei-os. Mas não pequeis contra Javé, comendo carne com sangue». Ao anoitecer, cada um levou o que tinha, e Saul imolou os animais nesse lugar."
,"35":"E Saul construiu um altar a Javé, e foi esse o primeiro altar que ele construiu a Javé."
,"36":"Depois disse: «Vamos descer, durante a noite, para perseguir os filisteus, e saqueá-los-emos até ao amanhecer; não vamos deixar nenhum sobrevivente». Os da tropa responderam: «Faz o que achares melhor». O sacerdote propôs: «Vamos aproximar-nos para consultar a Deus»."
,"37":"E Saul consultou a Deus: «Devo descer para perseguir os filisteus? Tu entregá-los-ás em poder de Israel?» Nesse dia, porém, não houve resposta."
,"38":"Então Saul ordenou: «Chefes do povo, aproximai-vos. Vamos ver quem foi que cometeu hoje algum pecado."
,"39":"Pela vida de Javé que dá a vitória a Israel, mesmo que tenha sido o meu filho Jónatas, ele morrerá». Ninguém disse nada."
,"40":"Saul disse a todo Israel: «Ficai de um lado. Eu e o meu filho Jónatas ficaremos do outro lado». E a multidão respondeu a Saul: «Faz o que te parecer melhor»."
,"41":"Então Saul consultou Javé, Deus de Israel: «Porque não respondes hoje ao teu servo? Javé, Deus de Israel, se eu e o meu filho Jónatas somos culpados, que saia Urim. Se a falta foi cometida pelo povo de Israel, que saia Tumim». A sorte caiu em Jónatas e Saul, e o povo ficou livre."
,"42":"Saul disse então: «Lançai a sorte entre mim e o meu filho Jónatas». E a sorte caiu em Jónatas."
,"43":"Então Saul disse a Jónatas: «Conta-me o que fizeste». Jónatas respondeu: «Somente provei um pouco de mel com a ponta da vara que levava na mão. Estou pronto para morrer»."
,"44":"Saul disse-lhe: «Que Deus me castigue, se não morreres, Jónatas!»"
,"45":"Mas o povo disse a Saul: «Como é que pode morrer Jónatas, ele que proporcionou esta grande vitória a Israel? De modo nenhum. Pela vida de Javé, não cairá um só fio da cabeça de Jónatas, porque foi por Deus que ele pôde fazer hoje o que fez». Deste modo, o povo salvou a vida de Jónatas."
,"46":"Saul deixou de perseguir os filisteus, e estes voltaram para o seu território."
,"47":"Depois de ser proclamado rei de Israel, Saul lutou contra todos os inimigos vizinhos: Moab, os amonitas, Edom, o rei de Soba e os filisteus. E saiu vitorioso em todas as suas campanhas."
,"48":"Realizou proezas de valentia, derrotou os amalecitas e livrou Israel dos seus opressores."
,"49":"Os filhos de Saul eram Jónatas, Jesui e Melquisua. Tinha também duas filhas: a mais velha chamava-se Merob, e a mais nova era Micol."
,"50":"A mulher de Saul chamava-se Aquinoam, filha de Aquimaás. O chefe do seu exército era Abner, filho de Ner, tio de Saul."
,"51":"Cis, pai de Saul, e Ner, pai de Abner, eram filhos de Abiel."
,"52":"Durante todo o reinado de Saul, houve guerra aberta contra os filisteus. E Saul requisitava todos os bravos e valentes que conhecia."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Samuel disse a Saul: «Javé enviou-me para te ungir rei sobre o seu povo Israel. Agora, pois, escuta as palavras de Javé:"
,"2":"'Assim diz Javé dos exércitos: Vou pedir contas a Amalec pelo que ele fez contra Israel, cortando-lhe o caminho, quando Israel saía do Egipto."
,"3":"Agora, vai, ataca e condena ao extermínio tudo o que pertence a Amalec. Não tenhas piedade: mata homens e mulheres, crianças e recém-nascidos, bois e ovelhas, camelos e jumentos'»."
,"4":"Saul convocou a tropa e revistou-a em Telém: eram duzentos mil na infantaria e dez mil homens de Judá."
,"5":"Saul avançou até à cidade de Amalec e armou uma emboscada no vale."
,"6":"Mandou esta mensagem aos quenitas: «Fugi e afastai-vos dos amalecitas, para não serdes destruídos com eles, porque fostes amáveis com os israelitas, quando saíam do Egipto». Então os quenitas afastaram-se dos amalecitas."
,"7":"Saul derrotou os amalecitas desde Hévila até Sur, que fica na fronteira do Egipto."
,"8":"Capturou vivo Agag, rei dos amalecitas, e passou a fio de espada todo o povo, para cumprir a lei do extermínio."
,"9":"Contudo, Saul e a sua tropa pouparam Agag e o que havia de melhor em ovelhas e vacas, o gado mais gordo e os cordeiros. Não incluíram no extermínio o que havia de melhor; exterminaram apenas o que não valia nada."
,"10":"Javé dirigiu a palavra a Samuel, dizendo:"
,"11":"«Estou arrependido de ter feito Saul rei, porque ele se afastou de Mim e não executou as minhas ordens». Então Samuel ficou triste e suplicou a Javé a noite inteira."
,"12":"De manhã, Samuel madrugou e foi ao encontro de Saul. Informaram Samuel de que Saul tinha ido a Carmel, para ali construir um monumento para si, e que depois tinha ido para Guilgal."
,"13":"Samuel apresentou-se a Saul, que lhe disse: «Que Javé te abençoe. Eu cumpri a ordem de Javé»."
,"14":"Mas Samuel perguntou-lhe: «E o que são esses balidos e mugidos que estou a ouvir?»"
,"15":"Saul respondeu: «Nós trouxemo-los de Amalec. A tropa deixou com vida as melhores ovelhas e vacas para as oferecer em sacrifício a Javé teu Deus. Quanto ao resto, exterminámos tudo»."
,"16":"Samuel, porém, disse a Saul: «Cala-te! Deixa-me contar-te o que Javé me revelou esta noite». Saul respondeu: «Podes falar»."
,"17":"Samuel disse: «Embora te consideres pequeno, és o chefe das tribos de Israel, porque Javé te ungiu rei de Israel."
,"18":"Ele enviou-te nessa expedição e ordenou: 'Vai e extermina completamente esses amalecitas pecadores, combatendo-os até acabar com eles'."
,"19":"Porque não obedeceste a Javé? Porque te apoderaste dos despojos, fazendo o que Javé reprova?»"
,"20":"Saul respondeu a Samuel: «Mas eu obedeci a Javé! Fiz a expedição para a qual Ele me enviou, trouxe Agag, rei de Amalec, e cumpri a lei do extermínio contra os amalecitas."
,"21":"E se a tropa ficou com ovelhas e vacas dos despojos, o melhor daquilo que deveria ser exterminado, foi para sacrificar a Javé teu Deus em Guilgal»."
,"22":"Samuel, porém, replicou: «O que é que Javé prefere? Que Lhe ofereçam holocaustos e sacrifícios, ou que obedeçam à sua palavra? Obedecer vale mais do que oferecer sacrifícios. Ser dócil é mais importante do que a gordura de carneiros."
,"23":"A rebelião é um pecado de feitiçaria, e a obstinação é um crime de idolatria. Tu rejeitas a palavra de Javé. Por isso, Ele rejeita-te como rei»."
,"24":"Então Saul disse a Samuel: «Pequei. Desobedeci à ordem de Javé e ao que mandaste. Fiquei com medo da tropa e obedeci-lhe."
,"25":"Agora, porém, perdoa o meu pecado, vem comigo e eu adorarei a Javé»."
,"26":"Mas Samuel respondeu: «Não voltarei contigo. Porque rejeitaste a palavra de Javé, Javé rejeita-te como rei de Israel»."
,"27":"Quando Samuel se virou para partir, Saul agarrou-lhe a barra do manto, rasgando o manto."
,"28":"Samuel disse-lhe: «Javé arranca-te hoje o reinado sobre Israel e entrega-o a outro mais digno do que tu."
,"29":"O Esplendor de Israel não mente, nem Se arrepende, porque não é homem para Se arrepender»."
,"30":"Saul respondeu: «Está certo, eu pequei. Mas agora, salva a minha honra diante dos anciãos do povo e de Israel. Volta comigo, para que eu adore Javé teu Deus»."
,"31":"Então Samuel voltou em companhia de Saul, e este adorou a Javé."
,"32":"Depois Samuel disse: «Trazei-me Agag, o rei dos amalecitas». Agag aproximou-se a tremer, e disse: «É a hora amarga da morte!»"
,"33":"Samuel disse-lhe: «Assim como a tua espada deixou muitas mães sem filhos, também a tua mãe ficará entre elas sem o seu filho». E Samuel degolou Agag diante de Javé, em Guilgal."
,"34":"Depois Samuel voltou para Ramá. E Saul foi para sua casa, em Gabaá de Saul."
,"35":"Enquanto viveu, Samuel nunca mais viu Saul. Contudo, Samuel chorava por Saul, porque Javé Se havia arrependido de ter feito Saul rei de Israel."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Javé disse a Samuel: «Até quando vais ficar a lamentar Saul? Fui Eu mesmo que o rejeitei como rei de Israel. Enche a vasilha do óleo. Ordeno que vás ter com a família de Jessé, o belemita, porque eu escolhi um rei entre os seus filhos»."
,"2":"Samuel replicou: «Como posso ir? Saul matar-me-á se o souber!» Javé, porém, disse: «Leva um bezerro, e diz que foste fazer um sacrifício a Javé."
,"3":"Convida Jessé para o sacrifício e eu mostrarei o que deverás fazer; ungirás aquele que Eu apontar»."
,"4":"Samuel fez o que Javé mandou. Quando chegou a Belém, os anciãos da cidade foram ansiosos ao seu encontro, e perguntaram: «Vens em missão de paz?»"
,"5":"Samuel respondeu: «Sim. Eu vim para oferecer um sacrifício a Javé. Purificai-vos e vinde comigo para o sacrifício». Samuel purificou Jessé e os seus filhos e convidou-os para o sacrifício."
,"6":"Quando chegou, Samuel viu Eliab e pensou: «Certamente é este que Javé quer ungir!»"
,"7":"Javé, porém, disse a Samuel: «Não te impressiones com a sua aparência ou estatura. Não é esse que Eu quero, porque Deus não vê como o homem, porque o homem vê as aparências, e Javé vê o coração»."
,"8":"Jessé chamou Abinadab e apresentou-o a Samuel. E Samuel disse: «Também não foi este que Javé escolheu»."
,"9":"Jessé apresentou Sama, mas Samuel disse: «Também não foi este que Javé escolheu»."
,"10":"Jessé apresentou a Samuel sete dos seus filhos. E Samuel respondeu: «Não foi nenhum destes que Javé escolheu»."
,"11":"Então Samuel perguntou a Jessé: «Estão aqui todos os teus filhos?» Jessé respondeu: «Falta o mais novo. Ele está a tomar conta do rebanho». Então Samuel disse a Jessé: «Manda buscá-lo, porque não nos sentaremos à mesa enquanto ele não chegar»."
,"12":"Jessé mandou chamá-lo e fê-lo entrar: era ruivo, os seus olhos eram bonitos e de boa aparência. E Javé disse: «Levanta-te e unge o rapaz, porque é este»."
,"13":"Samuel pegou na vasilha de óleo e ungiu o rapaz na presença dos irmãos. Desse dia em diante, o espírito de Javé permaneceu sobre David. Depois Samuel voltou para Ramá."
,"14":"O espírito de Javé afastou-se de Saul, e ele começou a ficar agitado por um espírito mau, enviado por Javé."
,"15":"Então os servos de Saul disseram-lhe: «Estás a ser atormentado por um espírito mau enviado por Deus."
,"16":"Se o ordenares, nós, teus servos, iremos procurar alguém que saiba tocar harpa; deste modo, quando o espírito mau enviado por Deus te atormentar, alguém tocará para te acalmar»."
,"17":"Então Saul ordenou: «Procurai alguém que saiba tocar bem e trazei-mo»."
,"18":"Um dos servos disse: «Conheço um filho do belemita Jessé. Ele sabe tocar e é valente guerreiro. Além disso, fala bem, é de boa aparência e Javé está com ele»."
,"19":"Então Saul enviou mensageiros a Jessé com esta ordem: «Manda-me o teu filho David, que guarda o rebanho»."
,"20":"Jessé tomou cinco pães, uma vasilha com vinho e um cabrito, e mandou o seu filho David levar tudo a Saul."
,"21":"David chegou ao palácio e apresentou-se a Saul; o rei ficou muito bem impressionado com ele, e tornou-o seu escudeiro."
,"22":"E Saul mandou dizer a Jessé: «David ficará ao meu serviço, porque eu gosto dele»."
,"23":"Todas as vezes que o espírito de Deus atacava Saul, David pegava na harpa e tocava. Então Saul acalmava-se, sentia-se melhor, e o espírito mau deixava-o."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Os filisteus reuniram as suas tropas para a guerra e concentraram-se em Soco de Judá, e acamparam em Efes-Domim, entre Soco e Azeca."
,"2":"Saul e os israelitas reuniram-se, acamparam no vale do Terebinto, e puseram-se em ordem de batalha contra os filisteus."
,"3":"Os filisteus colocaram-se numa encosta da montanha, enquanto os israelitas ficaram na colina em frente, de modo que havia entre eles um vale."
,"4":"Saiu então do exército filisteu um guerreiro enorme chamado Golias, de Gat, com quase três metros de altura."
,"5":"Tinha na cabeça um capacete de bronze, vestia um colete de malha de bronze que pesava mais de cinquenta quilos,"
,"6":"usava polainas de bronze e tinha nos ombros um escudo de bronze."
,"7":"A haste da sua lança era como travessa de tear, e a ponta da lança pesava seis quilos. O seu escudeiro ia à frente."
,"8":"Golias apresentou-se diante das fileiras de Israel e gritou: «Porque saístes para lutar? Eu sou filisteu, e vós sois escravos de Saul. Escolhei alguém para lutar comigo."
,"9":"Se ele for mais forte e me derrotar, seremos vossos escravos. Se eu for mais forte e o vencer, então vós sereis nossos escravos e nos servireis»."
,"10":"E continuou: «Hoje lanço este desafio ao exército de Israel! Apresentai alguém, e lutaremos corpo a corpo!»"
,"11":"Saul e os israelitas ouviram o desafio do filisteu e ficaram cheios de medo."
,"12":"David era filho de um efrateu de Belém de Judá, chamado Jessé, que tinha oito filhos. No tempo de Saul, Jessé era velho, de idade avançada."
,"13":"Os três filhos mais velhos tinham-se alistado para a guerra, seguindo a Saul. O primeiro chamava-se Eliab, o segundo Abinadab, e o terceiro Sama."
,"14":"David era o mais novo. Os três mais velhos seguiram Saul,"
,"15":"e David ia e vinha da corte de Saul para cuidar do rebanho de seu pai em Belém."
,"16":"O filisteu apresentava-se de manhã e à tarde, e assim se apresentou durante quarenta dias."
,"17":"Jessé disse ao seu filho David: «Toma estas três arrobas de grão torrado e estes dez pães, e leva-os aos teus irmãos no acampamento."
,"18":"Leva também estes dez queijos para o comandante. Vê como está a saúde dos teus irmãos e traz-me uma prova de que estão vivos."
,"19":"Eles estão com Saul e os israelitas, a combater os filisteus no vale do Terebinto»."
,"20":"David levantou-se de madrugada, deixou o rebanho aos cuidados de um pastor, pegou na carga e partiu, como Jessé lhe havia ordenado. Quando chegou perto das trincheiras, o exército, saindo para tomar posição, lançava o grito de guerra."
,"21":"Israelitas e filisteus entraram em formação, frente a frente."
,"22":"David entregou a carga ao bagageiro, correu para a linha de batalha e perguntou aos irmãos se estavam bem."
,"23":"Enquanto conversava com eles, o guerreiro filisteu chamado Golias, de Gat, saiu das fileiras do exército filisteu e lançou o desafio. David ouviu tudo."
,"24":"E os israelitas, quando viram o homem, fugiram apavorados."
,"25":"Um israelita disse: «Vistes aquele homem que avançou? Ele veio para desafiar Israel. A quem o vencer, o rei enchê-lo-á de riquezas e dar-lhe-á a sua filha, além de deixar a sua família livre de impostos em Israel»."
,"26":"Então David perguntou aos que estavam com ele: «E o que vão dar ao homem que vencer esse filisteu e salvar a honra de Israel? Quem é esse filisteu incircunciso para desafiar o exército do Deus vivo?»"
,"27":"Os soldados repetiram a David o que já haviam dito: «Quem o vencer receberá tal prémio»."
,"28":"Eliab, o irmão mais velho, ouviu David a falar com os soldados e enfureceu-se: «O que é que vieste aqui fazer? Quem ficou a guardar as tuas ovelhas no deserto? Sei que és pretensioso e tens malícia no coração: vieste só para assistir à batalha!»"
,"29":"David respondeu: «Mas que mal fiz eu? Será que não se pode fazer uma pergunta?»"
,"30":"Separou-se do irmão, dirigiu-se a outra pessoa, fez a mesma pergunta, e todos lhe deram a mesma resposta."
,"31":"Quando se soube o que David dissera, contaram-no a Saul, e o rei chamou-o."
,"32":"David disse a Saul: «Ninguém deve ficar desanimado. Este teu servo irá lutar com esse filisteu!»"
,"33":"Saul respondeu a David: «Não podes lutar com o filisteu! Tu és apenas um rapaz! Ele é guerreiro desde a juventude!»"
,"34":"David replicou: «O teu servo é pastor das ovelhas de seu pai. Se chega um leão ou urso e agarra uma ovelha do rebanho,"
,"35":"eu persigo-o, ataco-o e arranco a ovelha da sua goela; se ele me ataca, eu agarro-o pela juba e mato-o com pauladas."
,"36":"O teu servo é capaz de matar leões e ursos. Pois bem: esse filisteu incircunciso, que desafiou o exército do Deus vivo, será como um deles»."
,"37":"E David acrescentou: «Javé livrou-me das garras do leão e do urso. Ele me livrará também das mãos desse filisteu». Então Saul disse-lhe: «Vai, e que Javé esteja contigo!»"
,"38":"Saul vestiu David com a sua própria armadura, colocou-lhe na cabeça um capacete de bronze, revestiu-o com a sua couraça,"
,"39":"e pôs-lhe a espada na cintura, sobre a armadura. Em vão David tentou andar, pois nunca tinha usado nada daquilo. Então disse a Saul: «Nem sequer consigo andar com estas coisas. Não estou acostumado». Tirou tudo,"
,"40":"pegou no cajado, escolheu cinco pedras bem lisas no riacho e colocou-as no bornal. Depois pegou na funda e foi ao encontro do filisteu."
,"41":"O filisteu, tendo na frente o escudeiro, foi-se aproximando cada vez mais de David."
,"42":"Olhou David de alto a baixo e desprezou-o, porque era jovem. Além disso, ruivo e de bela aparência."
,"43":"O filisteu disse a David: «Será que sou algum cão, para vires ao meu encontro com um pau?» Depois invocou os seus deuses para amaldiçoar David."
,"44":"E disse: «Vem cá. Vou dar a tua carne às aves do céu e aos animais do campo!»"
,"45":"Mas David replicou: «Tu vens contra mim armado de espada, lança e escudo. E eu vou contra ti em nome de Javé dos exércitos, o Deus do exército de Israel, que desafiaste."
,"46":"Hoje mesmo Javé te entregará nas minhas mãos: vou ferir-te e arrancar-te a cabeça; hoje mesmo vou entregar o teu cadáver e os cadáveres do exército dos filisteus às aves do céu e aos animais do campo. Deste modo, toda a Terra saberá que existe um Deus em Israel."
,"47":"Toda esta multidão saberá que não é com espada e lança que Javé sai vitorioso, porque se trata de uma guerra de Javé, e Ele vos entregará nas nossas mãos»."
,"48":"Enquanto o filisteu se aprumava e se aproximava de David pouco a pouco, David correu depressa para se posicionar e enfrentar o filisteu."
,"49":"David enfiou a mão no bornal, pegou numa pedra, atirou-a com a funda e acertou na testa do filisteu. A pedra penetrou na testa do filisteu, que caiu de bruços no chão."
,"50":"Assim David foi mais forte que o filisteu, apenas com uma funda e uma pedra: sem espada na mão, feriu e matou o filisteu."
,"51":"David correu, parou diante do filisteu, arrancou-lhe a espada da bainha e com ela acabou de o matar, cortando-lhe a cabeça. Quando os filisteus viram morto o seu herói, bateram em retirada."
,"52":"Os homens de Israel e Judá levantaram-se, deram o grito de guerra e puseram-se a perseguir os filisteus até à entrada de Gat e até às portas de Acaron. Cadáveres de filisteus foram caindo por terra no caminho de Saarim, até Gat e Acaron."
,"53":"Depois da perseguição aos filisteus, os israelitas voltaram e saquearam-lhes o acampamento."
,"54":"David tomou a cabeça do filisteu e levou-a para Jerusalém. Mas as armas levou-as para a sua própria tenda."
,"55":"Quando Saul viu David sair ao encontro do filisteu, disse a Abner, comandante do exército: «Abner, quem é o pai daquele jovem?» Abner respondeu: «Pela tua vida, ó rei, não sei»."
,"56":"O rei disse: «Então procura saber quem é o pai daquele rapaz»."
,"57":"Quando David voltou depois de ter morto o filisteu, Abner levou-o à presença de Saul. David trazia a cabeça do filisteu na mão."
,"58":"Saul perguntou-lhe: «Quem é teu pai, rapaz?» David respondeu: «Sou filho do teu servo Jessé, o belemita»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Quando David acabou de falar com Saul, Jónatas afeiçoou-se a David, e Jónatas amou-o como a si mesmo."
,"2":"Nesse dia, Saul reteve David e não deixou que ele voltasse para casa do pai."
,"3":"Jónatas fez um pacto com David, porque o amava como a si mesmo."
,"4":"Jónatas tirou o manto que usava e deu-o a David, juntamente com as suas roupas, a espada, o arco e o cinturão."
,"5":"Nas expedições, para onde quer que Saul mandava David, ele saía-se sempre bem. Então Saul estabeleceu-o como chefe dos homens de guerra. Ele era estimado por todo o povo e também pelos ministros de Saul."
,"6":"Quando regressavam, depois de David ter morto o filisteu, as mulheres de todas as cidades de Israel saíram cantando e dançando ao encontro do rei Saul, ao som de tamborins, címbalos e gritos de alegria."
,"7":"As mulheres dançavam e cantavam em coro: «Saul matou mil, mas David matou dez mil»."
,"8":"Saul ficou muito irritado, pois não gostou nada dessa afirmação. E disse: «Deram dez mil a David e a mim apenas mil. Que mais lhe falta, senão a realeza?»"
,"9":"E desse dia em diante, Saul olhava David com inveja."
,"10":"No dia seguinte, um espírito mau provindo de Deus tomou conta de Saul, que começou a delirar dentro de casa. Como de costume, David tocava harpa e Saul tinha a lança na mão."
,"11":"Saul atirou a lança, dizendo: «Vou cravar David na parede». David, porém, conseguiu escapar duas vezes."
,"12":"Saul tinha medo de David, porque Javé tinha abandonado Saul e agora estava com David."
,"13":"Por isso, Saul afastou David, nomeando-o chefe de uma ala do exército. E David comandava expedições do exército."
,"14":"Em todas as campanhas, David saía-se muito bem, e Javé estava com ele."
,"15":"Saul via que David era sempre bem sucedido, e entrou em pânico."
,"16":"Mas todos em Israel e Judá gostavam de David, porque era ele quem os guiava nas suas expedições."
,"17":"Saul disse a David: «Olha! Vou dar-te como esposa Merob, a minha filha mais velha, com a condição de me servires como guerreiro e fazeres as guerras de Javé». Na verdade, Saul pensava: «É melhor que ele seja morto pelos filisteus, e não por mim»."
,"18":"David respondeu a Saul: «Quem sou eu? E que importância tem a família de meu pai em Israel, para eu me tornar genro do rei?»"
,"19":"Mas, quando chegou o tempo de Saul dar a sua filha Merob a David, ela foi dada a Adriel de Meola."
,"20":"Micol, a outra filha de Saul, apaixonou-se por David. Contaram isso a Saul e ele gostou,"
,"21":"pensando: «Vou dar-lhe a minha filha como uma armadilha: assim David cairá em poder dos filisteus». E Saul disse a David: «Hoje vais ter uma segunda oportunidade de te tornares meu genro»."
,"22":"Então Saul ordenou aos servos: «Falai confidencialmente a David deste modo: 'Olha! O rei aprecia-te muito, e todos os seus ministros te estimam. Aceita ser genro do rei'»."
,"23":"Os ministros de Saul insinuaram isto a David, mas ele respondeu: «Achais que é pouca coisa ser genro do rei? Eu sou um homem pobre e sem recursos»."
,"24":"Os ministros comunicaram a Saul o que David tinha respondido."
,"25":"Então Saul disse: «Falai assim a David: 'O rei não quer dinheiro; ele contenta-se com cem prepúcios de filisteus, como vingança contra os seus inimigos'». Saul planeava que David caísse em poder dos filisteus."
,"26":"Os ministros de Saul comunicaram a proposta a David, e David achou que era uma condição justa para se tornar genro do rei. O prazo ainda não estava esgotado,"
,"27":"e David pôs-se em campanha com os seus homens. Matou duzentos filisteus, tirou-lhes os prepúcios e levou-os ao rei, para se tornar seu genro. Então Saul deu a David sua filha Micol como esposa."
,"28":"Saul percebeu que Javé estava com David e que a sua filha Micol estava apaixonada por ele."
,"29":"Então Saul ficou com mais medo ainda de David e tornou-se inimigo ferrenho de David."
,"30":"Os chefes dos filisteus saíram para a guerra, mas todas as vezes que saíam, David tinha mais sucesso do que os ministros de Saul. Deste modo, David conquistou grande fama."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Saul contou a seu filho Jónatas e a todos os seus ministros que queria matar David. Ora, Jónatas, filho de Saul, tinha grande afeição por David."
,"2":"Então Jónatas informou David: «O meu pai quer matar-te. Procura fugir amanhã cedo, e esconde-te em lugar seguro."
,"3":"Eu sairei e ficarei junto do meu pai no campo onde tu estiveres. Falar-lhe-ei de ti, ficarei a saber o que há e avisar-te-ei»."
,"4":"Jónatas falou bem de David a seu pai Saul, e disse: «Que o rei não ofenda o seu servo David. Ele não te fez nenhum mal. Pelo contrário: tudo o que ele fez é de grande vantagem para ti."
,"5":"David arriscou a vida, matou o filisteu, e Javé deu uma grande vitória a Israel. Tu viste isso e alegraste-te. Agora, não peques derramando sangue inocente, matando David sem motivo»."
,"6":"Saul atendeu o pedido de Jónatas e jurou: «Pela vida de Javé! David não morrerá»."
,"7":"Então Jónatas chamou David e contou-lhe tudo isto. Depois levou-o a Saul. E David voltou para a corte como antes."
,"8":"A guerra começou de novo e David saiu para lutar contra os filisteus. Estes foram derrotados e fugiram."
,"9":"Ora, um espírito mau, vindo da parte de Javé, apoderou-se de Saul, quando estava sentado em casa, com a lança na mão, enquanto David tocava harpa."
,"10":"Saul tentou cravar David na parede, mas David desviou-se e a lança cravou-se na parede. Então David salvou-se fugindo. Nessa mesma noite,"
,"11":"Saul mandou emissários para vigiarem a casa de David e o matarem de manhã. Então Micol, mulher de David, avisou-o: «Se não fugires esta noite, amanhã serás um homem morto»."
,"12":"Micol desceu-o pela janela, e David salvou-se fugindo."
,"13":"Depois Micol pegou no ídolo, deitou-o na cama, colocou na cabeça dele uma pele de cabra e estendeu sobre ele um manto."
,"14":"Quando chegaram os emissários de Saul para levar David, Micol disse: «Ele está doente»."
,"15":"Mas Saul mandou outra vez os emissários para que vissem David; e ordenou: «Trazei David com cama e tudo, pois eu quero matá-lo»."
,"16":"Os emissários entraram na casa e encontraram o ídolo na cama, com a pele de cabra em volta da cabeça."
,"17":"Então Saul disse a Micol: «Porque me enganaste? Deixaste escapar o meu inimigo». Micol respondeu: «Ele ameaçou-me, e disse que me mataria se não o deixasse partir»."
,"18":"Entretanto, David salvou-se fugindo. Foi ter com Samuel em Ramá, e contou-lhe tudo o que Saul havia feito. Então os dois foram alojar-se num convento de profetas."
,"19":"Quando comunicaram a Saul que David estava no convento, em Ramá,"
,"20":"Saul mandou emissários para prender David. Eles encontraram a comunidade de profetas em transe, e Samuel estava a presidir. Logo o espírito de Deus veio também sobre os emissários de Saul, e eles também entraram em transe."
,"21":"Informado do que estava a acontecer, Saul mandou outros emissários, e também esses entraram em transe. Saul enviou ainda um terceiro grupo de emissários, e também eles entraram em transe."
,"22":"Então o próprio Saul foi a Ramá. Ao chegar junto ao grande poço que estava em Soco, perguntou onde estavam Samuel e David. Responderam: «Estão no convento, em Ramá»."
,"23":"Saul dirigiu-se para o convento, em Ramá, e também ele foi tomado pelo espírito de Deus, entrou em transe e foi caminhando até chegar ao convento em Ramá."
,"24":"Saul despiu as vestes e ficou em transe diante de Samuel, e nu ficou deitado no chão; e assim ficou o dia inteiro e toda a noite. Daí o provérbio: «Até Saul entre os profetas?»"
}`)
	CurrentBook.AddChapter(20, `{
"1":"David fugiu do convento de Ramá, foi ter com Jónatas, e perguntou-lhe: «O que é que eu fiz? Que crime ou erro cometi contra o teu pai, para que ele me queira matar?»"
,"2":"Jónatas respondeu: «Não te preocupes com isso. Tu não vais morrer. O meu pai não faz nada que seja importante ou menos importante, sem antes me informar. Por que razão o meu pai me esconderia esse plano? Impossível»."
,"3":"Mas David insistiu: «O teu pai sabe muito bem que me ajudas, e por isso pensa: 'Que Jónatas o não saiba para que não fique triste'. Mas, pela vida de Javé e pela tua vida, eu estou a um passo da morte»."
,"4":"Jónatas disse a David: «O que queres que eu faça?»"
,"5":"David respondeu: «Amanhã é lua nova, e eu deveria jantar com o rei. Deixa-me partir. Vou esconder-me no campo até à tarde."
,"6":"Se o teu pai der pela minha falta, diz-lhe que te pedi licença para ir a Belém, minha cidade, porque todo o meu clã está lá a celebrar o sacrifício anual."
,"7":"Se ele disser que está bem, estou a salvo; se ele ficar furioso, é sinal de que decidiu matar-me."
,"8":"Sê leal com este servo, porque estamos unidos por um pacto sagrado. Se cometi algum crime, mata-me tu mesmo; não precisas de me entregar a teu pai»."
,"9":"Jónatas replicou: «Nem penses nisso. Se eu souber que o meu pai decidiu matar-te, juro que te avisarei»."
,"10":"David perguntou: «Quem me vai avisar, se o teu pai responder com aspereza?»"
,"11":"Jónatas respondeu: «Vamos para o campo». E os dois foram para o campo."
,"12":"Então Jónatas disse a David: «Por Javé, Deus de Israel, eu prometo-te que amanhã ou depois de amanhã, à mesma hora, vou sondar meu pai, para ver se tudo está bem em relação a ti. Caso contrário, mandar-te-ei secretamente um recado."
,"13":"Se ele planeia algum mal contra ti, que Javé me castigue se eu te não avisar para que te ponhas a salvo. Que Javé esteja contigo, como esteve com o meu pai."
,"14":"Se eu ainda estiver vivo, cumpre comigo o pacto sagrado; se eu estiver morto,"
,"15":"não deixes nunca de favorecer a minha família. E quando Javé aniquilar da face da terra os inimigos de David,"
,"16":"que o nome de Jónatas não seja eliminado da família de David. Que Javé peça contas aos inimigos de David!»"
,"17":"Jónatas repetiu o juramento feito a David, porque lhe queria bem e o amava como a si mesmo."
,"18":"E Jónatas disse-lhe: «Amanhã é lua nova e notarão a tua ausência, porque a tua cadeira estará vazia."
,"19":"Depois de amanhã, a tua ausência chamará muito a atenção. Vai para onde te escondeste da outra vez, e fica junto às pedras."
,"20":"Eu atirarei três flechas nessa direcção, como se estivesse a atirar a um alvo."
,"21":"Então mandarei um servo buscar as flechas. Se eu disser ao servo: 'As flechas estão atrás de ti, apanha-as!' Então poderás vir porque tudo está bem. Pela vida de Javé!"
,"22":"Mas, se eu lhe disser: 'As flechas estão mais adiante', é porque Javé te manda partir."
,"23":"Quanto ao que eu e tu combinámos, Javé é testemunha entre nós»."
,"24":"Então David escondeu-se no campo. A lua nova chegou e o rei estava sentado à mesa para comer."
,"25":"Como de costume, o rei estava sentado no lado da parede. Jónatas sentou-se em frente, e Abner sentou-se ao lado de Saul. O lugar de David ficou vazio."
,"26":"Nesse dia, Saul não disse nada, porque pensava: «É coincidência; ele não está puro, e ainda não se purificou»."
,"27":"No outro dia da lua nova, no segundo dia, o lugar de David continuou vazio. Então Saul disse a seu filho Jónatas: «Porque é que o filho de Jessé não veio comer nem ontem nem hoje?»"
,"28":"Jónatas respondeu a Saul: «David pediu-me com insistência para ir a Belém."
,"29":"Ele disse-me: 'Deixa-me ir, por favor, pois haverá na cidade um sacrifício para o nosso clã, e os meus irmãos querem que eu esteja presente; se te parece bem, deixa-me ir ter com os meus irmãos'. É por isso que ele não está presente à mesa do rei»."
,"30":"Então Saul ficou irado contra Jónatas e disse-lhe: «Filho de uma transviada! Pensas que eu não sei que estás do lado do filho de Jessé, para tua vergonha e para vergonha da nudez de tua mãe?"
,"31":"Enquanto o filho de Jessé estiver vivo na terra, nem tu nem o teu reino estarão seguros. Procura encontrá-lo e trá-lo aqui, porque ele merece a morte»."
,"32":"Jónatas perguntou a seu pai Saul: «Porque é que ele merece a morte? Que fez ele?»"
,"33":"Então Saul atirou a lança para matar Jónatas. Então Jónatas percebeu que seu pai tinha decidido matar David."
,"34":"Jónatas levantou-se da mesa enfurecido, e não comeu nada nesse segundo dia do mês, porque seu pai tinha insultado David."
,"35":"Na manhã seguinte, Jónatas foi ao campo, acompanhado de um jovem servo, para se encontrar com David."
,"36":"Disse então ao servo: «Corre e procura as flechas que vou atirar». O jovem correu, e Jónatas atirou uma flecha que o ultrapassou."
,"37":"Quando o servo chegou perto da flecha que tinha atirado, Jónatas gritou: «A flecha não está lá mais adiante?»"
,"38":"E Jónatas continuou: «Corre depressa; não fiques aí parado». O servo de Jónatas apanhou a flecha e foi entregá-la ao seu senhor."
,"39":"O servo não desconfiou de nada, porque só Jónatas e David sabiam do que se tratava."
,"40":"Então Jónatas entregou as suas armas ao servo e ordenou: «Volta e leva-as para a cidade»."
,"41":"Quando o servo partiu, David saiu do esconderijo, caiu com o rosto por terra e prostrou-se três vezes. Em seguida, os dois abraçaram-se e choraram bastante."
,"42":"Jónatas disse a David: «Nós jurámos um ao outro em nome de Javé. Que Javé seja sempre juiz entre mim e ti, e entre os meus e os teus filhos»."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Então David levantou-se e partiu. Jónatas voltou para a cidade."
,"2":"David chegou a Nob e foi encontrar-se com o sacerdote Aquimelec. Este foi ansiosamente ao encontro de David e perguntou-lhe: «Porque vieste sozinho, sem ninguém?»"
,"3":"David respondeu: «O rei encarregou-me de um assunto e disse-me que ninguém deveria saber nada das suas ordens e do assunto que me confiou. Marquei encontro com os meus homens em certo lugar."
,"4":"Agora, se tens à disposição cinco pães, dá-mos, ou então qualquer outra coisa que possas encontrar»."
,"5":"O sacerdote respondeu: «Não tenho pães comuns à minha disposição. Tenho só pães sagrados. Se os teus homens não tiverem tido contacto com mulheres, poderão comê-los»."
,"6":"David respondeu: «Claro. Quando saímos para uma expedição, ainda que seja de natureza profana, nós abstemo-nos de mulheres. Quanto mais hoje! Os rapazes estão puros»."
,"7":"Então o sacerdote deu-lhe pão sagrado, porque ali só havia pão oferecido a Javé, que era retirado da presença de Javé para ser substituído por pão do dia."
,"8":"Nesse dia, estava ali, preso no santuário, um dos empregados de Saul. Ele chamava-se Doeg, o edomita, e era o chefe dos pastores de Saul."
,"9":"David disse a Aquimelec: «Não tens à mão alguma lança ou espada? Eu não trouxe nem a minha espada, nem as minhas armas, porque a ordem do rei era urgente»."
,"10":"O sacerdote respondeu: «Está ali embrulhada num manto, atrás do efod, a espada de Golias, o filisteu que tu mataste no vale do Terebinto. Se quiseres, leva-a. Por aqui não há outra». David disse: «Não há nada melhor. Dá-me essa espada»."
,"11":"Nesse dia, David fugiu para longe de Saul e foi encontrar-se com Aquis, rei de Gat."
,"12":"Mas os servos de Aquis disseram: «Este não é David, o rei do país? Não era para ele que dançavam cantando: 'Saul matou mil, mas David matou dez mil'?»"
,"13":"David ouviu o comentário e ficou com medo de Aquis, rei de Gat."
,"14":"Então David fingiu-se louco diante deles e começou a comportar-se como um louco: começou a dar cabeçadas nas portas e deixava escorrer a baba pela barba."
,"15":"Aquis disse aos que o serviam: «Este homem está louco! Porque o trouxestes aqui?"
,"16":"Não tenho já loucos de sobra, para me trazerdes ainda mais um, e me aborrecer com as suas doidices? O que é que ele veio fazer ao meu palácio?»"
}`)
	CurrentBook.AddChapter(22, `{
"1":"David saiu dali e escondeu-se na caverna de Odolam. Quando os seus parentes e toda a sua família souberam, foram ter com ele."
,"2":"Todos os que estavam em dificuldades, todos os endividados e todos os descontentes reuniram-se ao seu redor, e David tornou-se chefe deles. Formou-se assim um grupo de quatrocentos homens."
,"3":"David partiu dali e foi para Masfa de Moab. Ele disse ao rei de Moab: «Permite que meu pai e minha mãe fiquem aqui convosco até que eu saiba o que Deus quer de mim»."
,"4":"David deixou-os com o rei de Moab, e eles ficaram com o rei durante todo o tempo em que David esteve escondido."
,"5":"O profeta Gad, porém, disse a David: «Não continues no esconderijo. Vai para o território de Judá». Então David foi e escondeu-se na floresta de Haret."
,"6":"Saul foi informado de que David fora visto com os homens que estavam com ele. Saul estava em Gabaá, debaixo de uma tamareira no alto da colina, com a lança na mão e rodeado por todos os seus ministros."
,"7":"Então Saul disse aos que o acompanhavam: «Ouvi, benjaminitas: Será que o filho de Jessé vai dar-vos terras e vinhas? Será que vai nomear-vos chefes e oficiais do seu exército,"
,"8":"para que estejais conspirando contra mim? Ninguém me avisou quando o meu filho fez um pacto com o filho de Jessé; ninguém se interessou por mim, nem me contou que o meu filho lançou contra mim o meu próprio servo, como está acontecendo hoje»."
,"9":"Doeg, o edomita, que estava entre os ministros de Saul, disse: «Eu vi o filho de Jessé chegar a Nob, à casa de Aquimelec, filho de Aquitob."
,"10":"E Aquimelec consultou Javé por David e também lhe deu provisões e a espada de Golias, o filisteu»."
,"11":"Então Saul mandou chamar o sacerdote Aquimelec, filho de Aquitob, juntamente com toda a sua família, os sacerdotes de Nob. Todos se apresentaram ao rei,"
,"12":"que lhes disse: «Escuta, filho de Aquitob». Ele respondeu: «Aqui estou, meu senhor»."
,"13":"Saul perguntou-lhe: «Porque é que tu e o filho de Jessé conspirastes contra mim? Deste-lhe de comer e uma espada, e consultaste a Deus em favor dele, para que se transformasse em meu inimigo, como está acontecendo hoje»."
,"14":"Aquimelec respondeu ao rei: «Quem é como David entre todos os ministros do rei? Ele é fiel, é genro do rei, chefe da sua guarda e honrado no teu palácio."
,"15":"Foi porventura a primeira vez que consultei a Deus por David? Longe de mim! Que o rei não lance tal acusação sobre o seu servo e toda a sua família. O teu servo não sabia nada sobre isso, nem muito, nem pouco»."
,"16":"O rei replicou: «Aquimelec, vais morrer com toda a tua família»."
,"17":"Em seguida, o rei ordenou aos da sua guarda: «Aproximai-vos e matai os sacerdotes de Javé, porque estão do lado de David; eles sabiam que David estava a fugir e não o denunciaram». Mas os guardas do rei não quiseram levantar a mão para matar os sacerdotes de Javé."
,"18":"Então o rei ordenou a Doeg: «Vai tu e mata os sacerdotes». Doeg, o edomita, foi e matou os sacerdotes. Nesse dia, morreram oitenta e cinco homens que vestiam o efod."
,"19":"Em Nob, a cidade dos sacerdotes, Saul passou a fio de espada homens e mulheres, crianças e recém-nascidos, bois, jumentos e ovelhas."
,"20":"Escapou apenas um filho de Aquimelec, filho de Aquitob. Ele chamava-se Abiatar, que fugiu e se refugiou junto de David."
,"21":"Abiatar contou a David que Saul tinha assassinado os sacerdotes de Javé."
,"22":"E David disse-lhe: «Naquele dia, eu percebi que Doeg, o edomita, estava presente e avisaria Saul. O responsável pela morte dos teus familiares sou eu."
,"23":"Fica comigo e não tenhas medo; quem quiser matar-me, também quererá matar-te. Comigo, estarás a salvo»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Mandaram avisar David que os filisteus estavam a atacar Ceila e a saquear as eiras."
,"2":"David consultou a Javé: «Posso ir atacar os filisteus?» Javé respondeu: «Podes ir. Tu vais derrotá-los e libertar Ceila»."
,"3":"Os homens de David, porém, disseram-lhe: «Estamos em Judá, e já estamos com medo. Quanto mais se formos a Ceila para lutar contra as tropas dos filisteus!»"
,"4":"David consultou outra vez a Javé. E Javé respondeu: «Podes descer até Ceila: Eu vou entregar os filisteus em teu poder»."
,"5":"Então David foi com seus homens para Ceila, atacou os filisteus, tomou-lhes o gado e derrotou-os completamente. Deste modo, conseguiu libertar os habitantes de Ceila."
,"6":"Quando Abiatar, filho de Aquimelec, fugiu para junto de David, também desceu a Ceila levando consigo o efod."
,"7":"Informaram Saul que David tinha entrado em Ceila. E Saul comentou: «Deus entregou-o em meu poder. Ele caiu numa armadilha, pois entrou numa cidade com portas e trancas»."
,"8":"Então Saul convocou todo o seu exército para a guerra, para descer até Ceila e matar David e os seus homens."
,"9":"Quando David soube que Saul estava tramando a sua ruína, pediu ao sacerdote Abiatar: «Traz o efod»."
,"10":"E David consultou: «Javé, Deus de Israel, o teu servo ouviu dizer que Saul se prepara para vir a Ceila e destruir a cidade por minha causa."
,"11":"Saul vai mesmo descer, como o teu servo ouviu dizer? Javé, Deus de Israel, responde-me!» Javé respondeu: «Ele vai descer»."
,"12":"David perguntou: «Será que os notáveis de Ceila me vão entregar juntamente com os meus homens ao poder de Saul?» Javé respondeu: «Sim. Eles vão entregar-te»."
,"13":"Então David e os seus homens, cerca de seiscentos, saíram de Ceila e ficaram andando sem rumo. Saul soube que David tinha escapado de Ceila. Então abandonou o plano."
,"14":"David foi morar no deserto, em lugares escondidos, na região montanhosa do deserto de Zif. E Saul andava continuamente à sua procura, mas Deus não deixava que David caísse nas suas mãos."
,"15":"David ficou com medo, quando estava no deserto de Zif, em Horesa, porque Saul tinha saído à sua procura para o matar."
,"16":"Jónatas, filho de Saul, foi encontrar-se com David em Horesa e encorajou-o em nome de Deus."
,"17":"Jónatas disse-lhe: «Não tenhas medo, porque a mão de meu pai Saul não te alcançará. Reinarás sobre Israel, e eu serei o segundo. Até meu pai Saul sabe disso»."
,"18":"E os dois fizeram um pacto diante de Javé. David ficou em Horesa, e Jónatas voltou para casa."
,"19":"Algumas pessoas de Zif foram a Gabaá para contar a Saul: «David está escondido entre nós, entre os refúgios de Horesa, na colina de Áquila, ao Sul da estepe."
,"20":"Agora, majestade, quando quiseres descer, desce. Cabe-nos a nós entregá-lo nas mãos do rei»."
,"21":"Saul respondeu: «Javé vos pague por vos interessardes por mim."
,"22":"Podeis ir. Investigai melhor. Procurai saber e ver o lugar por onde ele anda, se alguém o viu, porque me disseram que ele é muito esperto!"
,"23":"Procurai ver e saber acerca de todos os refúgios onde ele se esconde. Depois vinde ter comigo, quando tiverdes notícias seguras. Então eu irei convosco: se ele estiver no país, vou revirar todos os clãs de Judá até encontrá-lo»."
,"24":"Eles então partiram para Zif, na frente de Saul. David e os seus homens estavam no deserto de Maon, na Arabá, a Sul da estepe."
,"25":"Saul e os seus homens foram à procura de David. Ao ser informado, David desceu para Sela e ficou a morar no deserto de Maon. Saul soube e foi atrás de David no deserto de Maon."
,"26":"Saul ia por um lado da montanha, enquanto David e os seus homens iam pelo outro lado. David apertava o passo para escapar a Saul. E Saul com os seus homens já estavam a rodear David e os seus homens para os cercar,"
,"27":"quando chegou um mensageiro para Saul, com esta notícia: «Vem depressa, porque os filisteus fizeram uma incursão contra o país»."
,"28":"Então Saul deixou de perseguir David e voltou para enfrentar os filisteus. É por isso que deram àquele lugar o nome de Rocha da Divisão."
}`)
	CurrentBook.AddChapter(24, `{
"1":"David saiu dali e foi abrigar-se nos esconderijos de Engadi."
,"2":"Quando Saul voltou da perseguição aos filisteus, foi avisado: «David está no deserto de Engadi»."
,"3":"Saul tomou três mil homens escolhidos de todo o Israel e foi à procura de David e seus homens, junto às Rochas das Cabras."
,"4":"Chegou junto a uns currais de ovelhas que estavam perto do caminho. Havia ali uma caverna, e Saul entrou nela para fazer as suas necessidades. David e os seus homens estavam no fundo da caverna."
,"5":"E os companheiros de David disseram-lhe: «Hoje é o dia em que Javé te diz: Eu entrego-te o teu inimigo; faz dele o que quiseres». David levantou-se e cortou um pedaço da barra do manto de Saul, sem ele notar."
,"6":"Depois de fazer isto, David sentiu o coração bater forte por ter cortado um pedaço da barra do manto de Saul."
,"7":"Depois disse aos seus homens: «Que Javé me livre de fazer isso ao meu senhor, de levantar a mão contra ele, porque é o ungido de Javé»."
,"8":"Com estas palavras, David conteve os seus homens e impediu que atacassem Saul. Saul deixou a gruta e continuou o seu caminho. "
,"9":"Então David levantou-se, saiu da gruta e gritou: «Senhor, meu rei!» Saul voltou-se, e David inclinou-se até ao chão e prostrou-se."
,"10":"Depois disse a Saul: «Porque dás ouvidos àqueles que dizem que David te quer fazer mal?"
,"11":"Vê com os teus próprios olhos: hoje mesmo Javé entregou-te nas minhas mãos dentro da caverna. Disseram-me para te matar, mas eu respeitei-te e disse que não estenderia a mão contra o meu senhor, porque és o ungido de Javé."
,"12":"Meu pai, olha aqui na minha mão um pedaço do teu manto; se te cortei a barra do manto e não te matei, deves reconhecer que não sou maldoso nem traidor. Embora me persigas para me matar, eu não pequei contra ti."
,"13":"Que Javé seja nosso juiz. Ele poderá vingar-me de ti, mas contra ti a minha mão jamais se levantará."
,"14":"Como diz o antigo provérbio: 'Dos maus vem a maldade'. E a minha mão não se levantará contra ti."
,"15":"Contra quem saiu o rei de Israel? A quem está perseguindo? A um cão morto, a uma pulga!"
,"16":"Que Javé seja juiz entre nós e dê a sentença. Que Ele veja e defenda a minha causa, livrando-me das tuas mãos»."
,"17":"Quando David acabou de falar, Saul exclamou: «És mesmo tu que estás a falar, meu filho David?» E começou a gritar e a chorar."
,"18":"Depois disse a David: «Tu és inocente, e eu não. Tu fizeste-me o bem, e eu fiz-te o mal."
,"19":"Hoje fizeste-me o maior favor, pois Javé entregou-me nas tuas mãos e não me mataste."
,"20":"Se alguém encontra um inimigo, será que vai deixá-lo ir em paz? Que Javé te pague o bem que hoje me fizeste."
,"21":"Agora eu sei que serás rei, e que o reino de Israel se firmará na tua mão."
,"22":"Pois bem! Jura-me, por Javé, que não exterminarás a minha descendência e não farás desaparecer o meu nome e o nome da minha família»."
,"23":"Então David fez o juramento a Saul. Depois Saul voltou para casa, e David com seus homens subiram para o esconderijo."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Samuel morreu. Todo o Israel se reuniu e fez luto por ele e sepultou-o junto aos seus em Ramá. David continuou as suas andanças e desceu para o deserto de Farã."
,"2":"Em Maon havia um homem que tinha propriedades em Carmel; era homem muito importante e possuía três mil ovelhas e mil cabras. Nessa ocasião, ele estava em Carmel, a tosquiar as suas ovelhas."
,"3":"Ele chamava-se Nabal, e a sua mulher, Abigail. Ela era mulher sensata e muito bonita, mas o marido era intratável e prepotente; era um calebita."
,"4":"No deserto, David soube que Nabal estava a tosquiar as ovelhas."
,"5":"Mandou então dez homens, dizendo-lhes: «Subi até Carmel, apresentai-vos a Nabal e saudai-o em meu nome"
,"6":"deste modo: 'Saudações. A paz esteja contigo, com a tua família e com tudo o que possuis."
,"7":"Eu soube que estás a fazer a tosquia do teu rebanho. Pois bem. Os teus pastores estiveram entre nós; e nós não os incomodámos, nem lhes foi tirado nada enquanto estiveram em Carmel."
,"8":"Pergunta-o aos teus servos, e eles confirmarão o que estou a dizer. Atende bem estes homens, porque é um dia de festa para nós. Por favor, dá a estes teus servos e a David o que tiveres à mão'»."
,"9":"Os homens foram e disseram a Nabal tudo o que David tinha mandado; e ficaram à espera."
,"10":"Nabal respondeu-lhes: «Quem é David e quem é o filho de Jessé? Hoje em dia existem muitos servos que fogem do seu patrão."
,"11":"Será que eu vou tomar o pão, a água e as ovelhas, que abati para os meus tosquiadores, para os dar a homens que nem sei de onde vêm?»"
,"12":"Então os homens de David retomaram o caminho e regressaram. Ao chegarem junto de David, contaram-lhe tudo o que Nabal lhes dissera."
,"13":"David disse aos seus homens: «Cada um pegue na sua espada». Cada um pegou na sua e David também. Cerca de quatrocentos homens subiram com David, enquanto duzentos ficaram com as bagagens."
,"14":"Um dos servos informou Abigail, mulher de Nabal: «David enviou mensageiros do deserto para cumprimentar o nosso patrão, e ele expulsou-os."
,"15":"Ora, esses homens foram muito bons para nós, não nos incomodaram e não sentimos falta de nada no tempo em que caminhámos entre eles e estivemos no campo."
,"16":"Tanto de dia como de noite, eles protegeram-nos durante todo o tempo em que estivemos com eles pastoreando o nosso rebanho."
,"17":"Agora, decide e vê o que fazer, porque a destruição do nosso patrão e de toda a sua família está decidida. O patrão é homem grosseiro. Com ele não se pode conversar»."
,"18":"Imediatamente, Abigail tomou duzentos pães, duas vasilhas com vinho, cinco ovelhas preparadas, cinco medidas de trigo tostado, cem cachos de uvas passas, duzentos doces de figo, e carregou tudo sobre os jumentos."
,"19":"Depois disse aos seus servos: «Ide à frente, que eu seguirei atrás de vós». Ela, porém, não avisou o seu marido Nabal."
,"20":"Enquanto ela, montada num jumento, descia para um abrigo na montanha, David e os seus homens vinham na sua direcção, e encontraram-se."
,"21":"David tinha dito: «Foi em vão que eu protegi tudo o que pertence a esse indivíduo, não deixando que nada lhe fosse roubado: ele pagou-me o bem com o mal."
,"22":"Que Deus castigue David, se até amanhã cedo eu deixar vivo qualquer um de Nabal que urina na parede»."
,"23":"Quando Abigail viu David, apeou-se depressa do jumento, e prostrou-se diante dele com o rosto por terra."
,"24":"Lançando-se aos pés de David, disse: «Meu senhor, a culpa é minha. Deixa que a tua serva te fale. Escuta as palavras da tua serva."
,"25":"Que o meu senhor não dê atenção a esse homem grosseiro que é Nabal, pois o seu nome significa grosseiro, e a grossaria está mesmo com ele. Eu, tua serva, não cheguei a ver os homens que o meu senhor havia mandado."
,"26":"Agora, meu senhor, pela vida de Javé e pela tua, é Javé que te impede de derramar sangue e de fazer justiça por tuas próprias mãos. Que sejam como Nabal os inimigos e aqueles que procuram fazer o mal ao meu senhor."
,"27":"Esta homenagem que a tua serva te trouxe seja dada aos homens que te acompanham."
,"28":"Peço-te que perdoes a falta da tua serva, e Javé não deixará de te dar uma família estável, porque o meu senhor combate as guerras de Javé, e nada de mal te acontecerá em toda a tua vida."
,"29":"Se alguém se levantar para te perseguir e atentar contra a tua vida, a vida do meu senhor estará bem guardada no bornal da vida com Javé teu Deus, enquanto que a vida dos teus inimigos será lançada para longe como pedras com a funda."
,"30":"Quando Javé cumprir tudo o que prometeu ao meu senhor e te tiver feito chefe de Israel,"
,"31":"então o meu senhor não terá que ficar perturbado, nem sofrer remorso por ter derramado sangue inutilmente e ter feito justiça com as próprias mãos. Quando Javé te abençoar, lembra-te da tua serva»."
,"32":"Então David respondeu a Abigail: «Seja bendito Javé Deus de Israel, que hoje te enviou ao meu encontro."
,"33":"Bendita seja a tua sabedoria! Bendita sejas tu que hoje me impediste de derramar sangue e de fazer justiça com as minhas próprias mãos!"
,"34":"Viva Javé, Deus de Israel, que me impediu de te fazer mal. Porque, se não tivesses vindo imediatamente ao meu encontro, juro que ao amanhecer não restaria vivo para Nabal um só dos que urinam na parede»."
,"35":"Então David aceitou o que Abigail lhe tinha levado, e disse: «Volta em paz para casa. Eu atendi o que pediste e tratei-te com toda a consideração»."
,"36":"Abigail voltou para casa e encontrou Nabal a dar uma grande festa: parecia um festim real. Nabal estava alegre e completamente bêbado. Por isso, Abigail nada lhe contou até ao amanhecer."
,"37":"Pela manhã, quando Nabal melhorou da bebedeira, a sua mulher contou-lhe o que tinha acontecido. Nabal sentiu o coração parar no peito e ficou petrificado."
,"38":"Dez dias depois, Javé feriu Nabal e ele morreu."
,"39":"Ao saber que Nabal tinha morrido, David exclamou: «Bendito seja Javé, que defendeu a minha causa contra a afronta que Nabal me fez. Javé impediu-me de cometer um pecado: Ele fez recair sobre Nabal o mal que ele tinha planeado». David mandou pedir a mão de Abigail, para que se casasse com ele."
,"40":"Os servos de David foram a Carmel, à casa de Abigail, e disseram-lhe: «David mandou-nos para pedir que cases com ele»."
,"41":"Abigail imediatamente se inclinou com o rosto por terra, e disse: «Aqui está a sua serva disposta a lavar os pés dos servos do meu senhor»."
,"42":"Depois levantou-se depressa e montou no seu jumento; cinco servas a acompanhavam, e ela partiu com os mensageiros de David. E David casou-se com ela."
,"43":"David também se casou com Aquinoam de Jezrael. Ambas se tornaram suas mulheres."
,"44":"Saul tinha dado a sua filha Micol, mulher de David, a Falti, filho de Lais de Galim."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Os habitantes de Zif foram a Gabaá e disseram a Saul: «David está escondido na colina de Áquila, no lado que dá para o deserto»."
,"2":"Então Saul empreendeu a marcha para o deserto de Zif, com três mil soldados israelitas, a fim de fazer uma batida e encontrar David."
,"3":"Acampou na colina de Áquila, no lado que dá para o deserto, perto do caminho. David morava no deserto e, quando soube que Saul vinha no seu encalço,"
,"4":"mandou alguns espiões para averiguar onde Saul estava."
,"5":"Depois pôs-se a caminho e chegou ao lugar em que Saul estava acampado. Ficou perto do lugar em que estavam deitados Saul e Abner, filho de Ner, comandante do seu exército. Saul descansava entre os carros, e o exército estava acampado ao redor dele."
,"6":"David perguntou a Aquimelec, o heteu, e a Abisaí, filho de Sárvia, irmão de Joab: «Quem quer vir comigo até ao acampamento de Saul?» Abisaí respondeu: «Eu vou contigo»."
,"7":"Então David e Abisaí foram de noite ao acampamento. Saul estava deitado e dormia, com a lança cravada no chão, ao lado da cabeceira; Abner e os soldados dormiam ao redor."
,"8":"Então Abisaí disse a David: «Hoje Deus entrega o teu inimigo na tua mão. Deixa que eu o crave no chão com um só golpe de lança; não será preciso mais que um golpe»."
,"9":"Mas David respondeu: «Não o mates! Ninguém pode levantar a mão contra o ungido de Javé, e ficar sem castigo!»"
,"10":"E continuou: «Pela vida de Javé, o próprio Javé o ferirá. A sua hora vai chegar e ele morrerá, ou acabará por cair no campo de batalha."
,"11":"Javé me livre de atentar contra o seu ungido! Pega na lança que está à sua cabeceira e no cantil de água, e vamo-nos embora»."
,"12":"David pegou na lança e no cantil de água que estavam à cabeceira de Saul, e ambos se retiraram. Ninguém viu nem deu por nada, nem acordou: todos dormiam, porque caíra sobre eles um pesado sono enviado por Javé."
,"13":"David atravessou para o outro lado, subiu ao alto de um monte, ao longe. Havia uma boa distância entre eles."
,"14":"Então David gritou para o exército e para Abner, filho de Ner: «Não respondes, Abner?» E Abner respondeu: «Quem é que está a gritar para o rei?»"
,"15":"David continuou: «Afinal não és tu um homem? Quem é igual a ti em Israel? Então, porque não guardaste o rei, teu senhor? Alguém do povo tentou matá-lo."
,"16":"Tu não te comportaste bem. Pela vida de Javé, mereceis a morte porque não guardastes o rei, vosso senhor, o ungido de Javé. Vê onde estão a lança e o cantil de água que estavam à cabeceira dele!»"
,"17":"Então Saul reconheceu a voz de David e perguntou: «É a tua voz, meu filho David?» E David respondeu: «É a minha voz, meu senhor e meu rei»."
,"18":"E continuou: «Porque persegue o meu senhor o seu servo? Que fiz eu? Que culpa tenho?"
,"19":"Senhor meu rei, peço-te que escutes o que o teu servo tem a dizer: se é Javé que te lança contra mim, a oferta do altar O aplacará. Se são os homens, que sejam malditos por Javé, pois estão a expulsar-me hoje e impedem-me de participar da herança de Javé. É como se me dissessem: 'Vai servir a outros deuses!'"
,"20":"Que o meu sangue não caia longe de Javé, nesta terra, já que o rei de Israel saiu para me perseguir até à morte, como se estivesse caçando uma perdiz pelos montes»."
,"21":"Saul respondeu: «Pequei. Volta, meu filho David! De agora em diante, não vou mais fazer-te mal, pois hoje respeitaste a minha vida. Tenho agido como idiota e cometi muitos erros»."
,"22":"David então disse: «Aqui está a lança do rei. Que um dos teus homens venha buscá-la."
,"23":"Javé pagará conforme a justiça e de acordo com a fidelidade de cada um. Javé entregou-te hoje nas minhas mãos, e eu não quis atentar contra o ungido de Javé."
,"24":"Assim como hoje eu respeitei a tua vida, que Javé também respeite a minha e me livre de todo o perigo»."
,"25":"Então Saul disse a David: «Bendito sejas tu, meu filho David! Certamente terás sucesso em tudo o que fizeres». David continuou o seu caminho, e Saul voltou para casa."
}`)
	CurrentBook.AddChapter(27, `{
"1":"David pensou: «Mais dia menos dia, Saul vai acabar por me matar. Não tenho outra saída, a não ser refugiar-me na terra dos filisteus. Saul desistirá de me perseguir por todo o Israel, e eu estarei seguro»."
,"2":"David pôs-se a caminho, com os seus seiscentos homens, e foi para junto de Aquis, filho de Maoc, rei de Gat."
,"3":"David e os seus homens estabeleceram-se junto de Aquis em Gat, com as suas famílias. David levou as suas duas mulheres: Aquinoam de Jezrael e Abigail, mulher de Nabal de Carmel."
,"4":"Ao ser informado de que David se refugiara em Gat, Saul deixou de o perseguir."
,"5":"David disse a Aquis: «Se eu ganhei o teu favor, dá-me algum povoado na zona rural, onde eu possa morar. Porque haveria o teu servo de viver contigo na cidade real?»"
,"6":"Então, nesse dia, Aquis deu Siceleg a David. Por isso, Siceleg pertence aos reis de Judá até hoje."
,"7":"Assim, David permaneceu na zona rural dos filisteus durante um ano e quatro meses."
,"8":"Ele e os seus homens iam e atacavam os gessuritas, gersitas e amalecitas, que desde há muito tempo habitavam o território que vai desde Sur até à terra do Egipto."
,"9":"David aniquilava o território e não deixava ninguém vivo, nem homem nem mulher; tomava ovelhas e bois, jumentos, camelos e roupas. Depois voltava para junto de Aquis."
,"10":"E Aquis perguntava: «Onde é que atacaste hoje?» E David respondia que tinha sido contra o Negueb de Judá, ou o Negueb de Jerameel, ou o Negueb dos quenitas."
,"11":"E David não deixava ninguém vivo, homem ou mulher que pudesse ir até Gat, pois ele pensava: «Alguém pode trair-nos, contando o que eu fiz». Assim agiu ele durante todo o tempo em que esteve na zona rural dos filisteus."
,"12":"Aquis acabou por confiar em David, e dizia: «Ele é detestado pelo seu povo, em Israel, e por isso ficará para sempre ao meu serviço»."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Naqueles dias, os filisteus reuniram as suas tropas para atacar Israel. Então Aquis disse a David: «Tu e os teus homens vireis com o meu exército»."
,"2":"David respondeu: «Muito bem. Verás do que o teu servo é capaz». Então Aquis disse a David: «Eu nomeio-te meu guarda pessoal permanente»."
,"3":"Samuel tinha morrido. Todo o Israel participara dos funerais, e enterraram-no em Ramá, sua cidade. Saul tinha expulsado do país os necromantes e adivinhos."
,"4":"Os filisteus concentraram-se e acamparam em Sunam. Saul reuniu todo o Israel e acamparam em Gelboé."
,"5":"Quando viu o acampamento dos filisteus, Saul teve medo e começou a tremer."
,"6":"Consultou Javé; porém, Javé não lhe respondeu, nem por sonhos, nem pela sorte, nem pelos profetas."
,"7":"Então Saul disse aos seus servos: «Procurai uma necromante, para eu fazer uma consulta». Os servos responderam: «Há uma necromante em Endor»."
,"8":"Saul disfarçou-se, vestiu outra roupa, e à noite, acompanhado de dois homens, foi encontrar-se com a mulher. Saul disse-lhe: «Quero que me adivinhes o futuro, evocando os mortos. Faz aparecer a pessoa que eu te disser»."
,"9":"A mulher, porém, respondeu: «Sabes o que fez Saul, expulsando do país os necromantes e adivinhos. Porque me armas ciladas para eu ser morta?»"
,"10":"Então Saul jurou por Javé: «Pela vida de Javé, nenhum mal te vai acontecer»."
,"11":"A mulher perguntou: «Quem queres que eu chame?» Saul respondeu: «Chama Samuel»."
,"12":"Quando a mulher viu aparecer Samuel, deu um grito e disse a Saul: «Porque me enganaste? Tu és Saul!»"
,"13":"O rei tranquilizou-a: «Não tenhas medo. O que vês?» A mulher respondeu: «Vejo um espírito a subir da terra»."
,"14":"Saul perguntou: «Qual é a aparência dele?» A mulher respondeu: «É a de um ancião que sobe, vestido com um manto». Então Saul compreendeu que era Samuel, e prostrou-se com o rosto por terra."
,"15":"Samuel perguntou a Saul: «Porque me chamaste, perturbando o meu descanso?» Saul respondeu: «É que estou numa situação desesperada: os filisteus estão a guerrear contra mim. Deus afastou-Se de mim e já me não responde, nem pelos profetas, nem por meio de sonhos. Por isso, eu vim chamar-te, para que me digas o que devo fazer»."
,"16":"Samuel respondeu: «Porque me vieste consultar, se Javé Se afastou de ti e Se tornou teu inimigo?"
,"17":"Javé fez-te o que já te foi anunciado por mim: tirou-te a realeza e entregou-a a David,"
,"18":"porque não obedeceste a Javé e não executaste o ardor da ira d'Ele contra Amalec. É por isso que Javé hoje te trata deste modo."
,"19":"E Javé vai entregar Israel, juntamente contigo, nas mãos dos filisteus. Amanhã mesmo, tu e os teus filhos estareis comigo, e o acampamento de Israel também: Javé entregar-te-á nas mãos dos filisteus»."
,"20":"Saul caiu imediatamente no chão, apavorado com as palavras de Samuel. Estava enfraquecido, porque ficara todo o dia e toda a noite sem comer."
,"21":"A mulher aproximou-se de Saul e, vendo que ele estava apavorado, disse: «A tua serva obedeceu. Arrisquei a minha vida para fazer o que me pediste."
,"22":"Agora, também deves obedecer à tua serva. Vou trazer um pedaço de pão. Come e recupera as forças para partires»."
,"23":"Saul, porém, recusou: «Não vou comer nada». Mas os seus servos e a mulher insistiram tanto, que ele acabou por ceder: levantou-se do chão e sentou-se na cama."
,"24":"A mulher tinha um bezerro cevado. Abateu o bezerro, pegou em farinha, amassou-a e cozinhou uns pães sem fermento."
,"25":"Depois serviu Saul e os seus servos. Eles comeram e puseram-se a caminho naquela mesma noite."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Os filisteus concentraram as suas tropas em Afec, e Israel acampou junto à fonte de Jezrael."
,"2":"Os príncipes dos filisteus desfilavam por batalhões e destacamentos. David e seus homens iam na retaguarda com Aquis."
,"3":"Os chefes filisteus perguntaram: «O que fazem aqui estes hebreus?» Aquis respondeu: «É David, o servo de Saul, rei de Israel. Ele já está comigo há um ano ou dois, e desde o dia que passou para o meu lado até agora não tenho razões de queixa»."
,"4":"Os chefes filisteus opuseram-se, dizendo: «Manda embora esse homem. Que volte para o lugar que lhe havias reservado. Não suceda que, vindo para a guerra connosco, se volte contra nós em pleno combate. Que melhor forma teria ele de se reconciliar com o seu senhor senão com as cabeças dos nossos soldados?"
,"5":"Será que esse David não é o David de quem se cantava dançando: 'Saul matou mil, mas David matou dez mil'?»"
,"6":"Então Aquis mandou chamar David e disse-lhe: «Pela vida de Javé! Tu és leal, e eu não tenho queixa do teu comportamento no exército; não tenho nada a reprovar-te, desde que entraste no meu território até hoje. Mas não és bem visto pelos príncipes."
,"7":"Por isso, volta em paz, para eu não desagradar aos príncipes»."
,"8":"David respondeu a Aquis: «O que foi que eu fiz? Em que te ofendi, desde que me apresentei até hoje? Que é que me impede de combater contra os meus inimigos ao lado do meu senhor e rei?»"
,"9":"Aquis respondeu a David: «Eu sei. Eu estimo-te, como se fosses um enviado de Deus. Mas os chefes filisteus disseram que não querem que vás para a guerra connosco."
,"10":"Portanto, é melhor que tu e os teus servos madrugueis, e ao raiar do dia segui para o lugar que vos indiquei»."
,"11":"David e seus homens madrugaram e partiram de manhãzinha, voltando para o país dos filisteus. E os filisteus subiram a Jezrael."
}`)
	CurrentBook.AddChapter(30, `{
"1":"No terceiro dia em que David e seus homens estavam a caminho para Siceleg, os amalecitas atacaram o Negueb e Siceleg: arrasaram e incendiaram Siceleg,"
,"2":"aprisionando as mulheres, crianças e adultos que lá se encontravam; não mataram ninguém, mas levaram-nos todos como cativos para a sua terra."
,"3":"Quando David e seus homens chegaram, viram a cidade incendiada e souberam que as suas mulheres, filhos e filhas tinham sido levados cativos."
,"4":"David e a sua gente caíram em lágrimas e choraram até se esgotarem as suas forças."
,"5":"As duas mulheres de David, Aquinoam de Jezrael e Abigail, mulher de Nabal de Carmel, também tinham sido capturadas."
,"6":"David ficou muito angustiado, porque se dizia que o povo queria apedrejá-lo, pois todos estavam amargurados por causa de seus filhos e filhas. David, porém, recobrou ânimo em Javé seu Deus."
,"7":"Então David disse ao sacerdote Abiatar, filho de Aquimelec: «Traz-me o efod». E Abiatar levou o efod a David."
,"8":"E David consultou Javé: «Se eu perseguir essa gente, será que vou alcançá-la?» Javé respondeu: «Vai atrás deles, porque os alcançarás e libertarás os prisioneiros»."
,"9":"David e os seus seiscentos homens partiram e chegaram ao riacho de Besor."
,"10":"David e quatrocentos homens continuaram a perseguição, enquanto duzentos ficaram, pois estavam cansados para atravessar a torrente de Besor."
,"11":"Encontraram um egípcio no campo e levaram-no a David. Deram-lhe pão para comer e água para beber."
,"12":"Deram-lhe doce de figos e dois cachos de uvas passas. Depois de ter comido, ele recobrou as forças, porque passara três dias e três noites sem comer nem beber."
,"13":"Então David perguntou-lhe: «A quem pertences e de onde vens?» Ele respondeu: «Eu sou um jovem egípcio, escravo de um amalecita. Há três dias que o meu patrão me abandonou, porque eu estava doente."
,"14":"Nós atacámos o Negueb dos cereteus, os homens de Judá e o Negueb de Caleb; e também incendiámos Siceleg»."
,"15":"David disse-lhe: «És capaz de me conduzir até essa gente?» O egípcio respondeu: «Jura-me por Deus que não me matarás, nem me entregarás nas mãos do meu senhor, e eu conduzir-te-ei até essa gente»."
,"16":"Então o egípcio levou David até ao bando. Os amalecitas estavam espalhados pelo território, comendo, bebendo e fazendo festa com os grandes despojos que haviam tomado no país dos filisteus e no país de Judá."
,"17":"David aniquilou-os desde o amanhecer até à tarde do dia seguinte: ninguém escapou, excepto quatrocentos jovens que montavam came-los e que conseguiram fugir."
,"18":"David recuperou tudo o que os amalecitas haviam tomado, e também as suas duas mulheres."
,"19":"Não se perdeu nada do que lhes pertencia: coisas pequenas e grandes, os despojos que haviam tomado, filhos e filhas; David trouxe tudo de volta."
,"20":"David tomou todas as ovelhas e bois dos amalecitas. Aqueles que iam à frente desse rebanho diziam: «Aqui estão os despojos de David»."
,"21":"David chegou até onde estavam os duzentos homens que, cansados, não o tinham seguido e ficaram junto à torrente de Besor. Eles foram ao encontro de David e da sua tropa. David aproximou-se deles e saudou-os."
,"22":"Todos os homens maus e grosseiros que tinham seguido David disseram: «Já que eles não foram connosco, não lhes dês parte nenhuma dos despojos que recuperámos, a não ser a própria mulher e filhos; que os recebam e se retirem»."
,"23":"Então David replicou: «Nada disso, meus irmãos. Não façais isso com o que Javé nos deu. Ele protegeu-nos e entregou em nosso poder o bando que veio contra nós."
,"24":"Quem é que pode concordar com o que dizeis? De facto, a parte daquele que foi ao combate é a mesma daquele que ficou com as bagagens; reparti por igual»."
,"25":"Desse dia em diante, isso ficou como estatuto e norma para Israel, e permanece até ao dia de hoje."
,"26":"David entrou em Siceleg e enviou parte dos despojos aos anciãos de Judá, seus compatriotas, dizendo: «Aqui vai como presente para vós parte dos despojos tomados aos inimigos de Javé»."
,"27":"E mandou-a para os anciãos de Betul, de Ramá do Negueb, de Jatir,"
,"28":"de Aroer, de Sefamot, de Estemo,"
,"29":"de Carmel, das cidades de Jerameel, das cidades dos quenitas,"
,"30":"de Horma, de Bor-Asã, de Eter,"
,"31":"de Hebron, e para os anciãos de todos os lugares por onde David tinha passado com os seus homens."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Os filisteus fizeram guerra contra Israel, e os israelitas fugiram deles, e muitos caíram mortos no monte Gelboé."
,"2":"Os filisteus perseguiram Saul e seus filhos. Mataram Jónatas, Abinadab e Melquisua, filhos de Saul."
,"3":"Todo o peso do combate se concentrou sobre Saul. Os arqueiros surpreenderam-no e feriram-no gravemente."
,"4":"Então Saul disse ao escudeiro: «Desembainha a espada e trespassa-me, antes que esses incircuncisos cheguem e façam troça de mim». O escudeiro ficou apavorado e não quis obedecer. Então Saul tomou a sua espada e atirou-se sobre ela."
,"5":"Vendo que Saul estava morto, o escudeiro também se atirou sobre a sua espada e morreu com Saul."
,"6":"Deste modo, no mesmo dia morreram Saul, os seus três filhos, o seu escudeiro e todos os seus homens."
,"7":"Quando os israelitas que estavam no outro lado do vale, e os da Transjordânia, viram que os israelitas tinham sido derrotados e que Saul e seus filhos estavam mortos, abandonaram as suas cidades e fugiram. Então os filisteus foram e ocuparam-nas."
,"8":"No dia seguinte, os filisteus foram despojar os cadáveres e encontraram Saul e os seus três filhos mortos no monte Gelboé."
,"9":"Cortaram a cabeça de Saul, tiraram-lhe as armas e enviaram-nas por todo o território filisteu, anunciando a boa notícia aos seus ídolos e ao seu povo."
,"10":"Depositaram as armas de Saul no templo de Astarte e dependuraram o seu cadáver na muralha de Betsã."
,"11":"Os habitantes de Jabes de Galaad souberam o que os filisteus tinham feito a Saul."
,"12":"Então todos os guerreiros caminharam a noite inteira, tiraram da muralha de Betsã o cadáver de Saul e os dos seus filhos, e levaram-nos para Jabes, e ali os queimaram."
,"13":"Depois recolheram os ossos, enterraram-nos debaixo da tamareira de Jabes, e jejuaram durante sete dias."
}`)

}
func PT_BS_LoadVH2MChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Aos irmãos judeus que estão no Egipto. Saudações! Os irmãos judeus que moram em Jerusalém e na Judeia desejam-vos paz e prosperidade."
,"2":"Deus vos conceda as suas graças e Se lembre da aliança que fez com Abraão, Isaac e Jacob, seus servos fiéis."
,"3":"Que Ele vos dê a todos um coração capaz de O honrar e de praticar a sua vontade, um coração generoso e um espírito decidido."
,"4":"Que vos abra o coração para a sua Lei e seus mandamentos, e vos conceda a paz."
,"5":"Que Ele escute as vossas orações, Se reconcilie convosco e vos não abandone no tempo da desgraça."
,"6":"Nós rezamos por vós, aqui e agora."
,"7":"Durante o reinado de Demétrio, no ano cento e sessenta e nove, nós judeus tínhamo-vos escrito o seguinte: «No meio da grande tribulação que caiu sobre nós, nestes anos em que Jasão e seus companheiros traíram a terra santa e o reino,"
,"8":"quando incendiaram o portal do Templo e mataram inocentes, nós orámos ao Senhor, e Ele ouviu-nos. Então oferecemos um sacrifício e uma oblação de flor de farinha, acendemos as lâmpadas e apresentámos os pães»."
,"9":"Portanto, celebrai a festa das Tendas do mês de Casleu."
,"10":"Ano cento e oitenta e oito. Os judeus que moram em Jerusalém e na Judeia, o conselho dos Anciãos e Judas, a Aristóbulo, mestre do rei Ptolomeu e membro da família dos sacerdotes ungidos, e também a todos os judeus que vivem no Egipto. Saudações e prosperidade."
,"11":"Libertados por Deus dos maiores perigos, nós agradecemos-Lhe muito, como a Alguém que lutou connosco contra o rei,"
,"12":"pois Deus expulsou os que se haviam entrincheirado contra a cidade santa."
,"13":"De facto, o seu chefe foi para a Pérsia acompanhado de um exército que parecia invencível, mas que acabou por ser destroçado no templo de Naneia, através de uma cilada armada pelos sacerdotes da deusa."
,"14":"Antíoco foi para esse lugar, com os amigos que o acompanhavam, pretendendo casar-se com a deusa, a fim de receber como dote as grandes riquezas que havia nesse lugar."
,"15":"Os sacerdotes do templo Naneia mostraram-lhe as riquezas, e ele entrou no recinto sagrado com alguns companheiros. Logo que Antíoco entrou, os sacerdotes fecharam o templo,"
,"16":"abriram a porta secreta do sótão e mataram o rei à pedrada. Esquartejaram o rei e atiraram a cabeça dele aos que estavam do lado de fora."
,"17":"Por tudo isto, bendito seja o nosso Deus, que entregou esses ímpios à morte."
,"18":"Estando para celebrar a purificação do Templo, no dia vinte e cinco de Casleu, achámos que seria bom comunicar-vos isto, para que também vós a comemoreis de maneira semelhante à festa das Tendas e à festa do Fogo, que apareceu quando Neemias ofereceu os sacrifícios, depois da reconstrução do Templo e do altar."
,"19":"De facto, quando os nossos antepassados foram levados para a Pérsia, alguns sacerdotes piedosos tomaram fogo do altar e esconderam-no secretamente num poço seco. Deixaram a coisa tão segura, que ninguém ficou a saber onde era esse lugar."
,"20":"Passados muitos anos, quando Deus achou conveniente, Neemias, o enviado do rei da Pérsia, mandou os descendentes dos sacerdotes procurar o fogo que tinham escondido. Segundo nos contam, eles não encontraram o fogo, mas somente um líquido grosso. Neemias mandou que tirassem e trouxessem o tal líquido."
,"21":"Depois de colocarem em cima do altar tudo o que fazia parte do sacrifício, Neemias ordenou aos sacerdotes que molhassem com esse líquido a lenha e tudo o que estava sobre ela."
,"22":"Feito isto e passado algum tempo, o sol, até então encoberto pelas nuvens, começou a brilhar, e um fogo forte logo se acendeu, de tal maneira que todos ficaram admirados."
,"23":"Enquanto o sacrifício era queimado, os sacerdotes rezavam com todo o povo presente. Jónatas entoava e todos respondiam juntamente com Neemias."
,"24":"A oração era assim: «Senhor, Senhor Deus, Criador de todas as coisas, terrível, forte, justo, misericordioso, único rei, único bom,"
,"25":"único generoso, único justo, Todo-poderoso e eterno, Tu que salvas Israel de todo o mal, Tu que escolheste os nossos antepassados e os santificaste,"
,"26":"aceita o sacrifício em favor de todo o teu povo Israel. Guarda e santifica a tua herança."
,"27":"Reúne os nossos dispersos. Liberta os que são escravos no meio das nações. Olha para os que são marginalizados e desprezados. Assim as outras nações ficarão a saber que Tu és o nosso Deus."
,"28":"Castiga aqueles que nos oprimem, que nos humilham com soberba."
,"29":"Planta o teu povo no teu lugar santo, conforme disse Moisés»."
,"30":"Entretanto os sacerdotes entoavam os hinos."
,"31":"Logo que o sacrifício foi consumado, Neemias mandou deitar o resto do líquido sobre grandes pedras."
,"32":"Feito isto, brilhou uma chama, que logo se apagou, enquanto o fogo sobre o altar continuava aceso."
,"33":"Logo que o facto se tornou conhecido, contaram ao rei dos persas que, no lugar onde os sacerdotes exilados tinham escondido o fogo, aparecera uma água, com a qual os companheiros de Neemias purificaram as oferendas do sacrifício."
,"34":"Confirmado o facto, o rei mandou cercar o lugar e declarou-o sagrado."
,"35":"Dali se tiravam muitos lucros, que eram repartidos entre os favorecidos do rei."
,"36":"Os companheiros de Neemias deram então a esse líquido o nome de «neftar», que significa purificação. Muitos, porém, chamam-lhe «nafta»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Nos documentos lê-se que o profeta Jeremias mandou que os deportados levassem o fogo, conforme foi explicado acima."
,"2":"Dando-lhes a Lei, Jeremias mandou que não esquecessem os mandamentos do Senhor, nem deixassem desviar o próprio pensamento, ao verem as imagens de ouro ou de prata, ou os seus enfeites."
,"3":"Dizendo muitas coisas deste tipo, recomendou que não afastassem a Lei do seu coração."
,"4":"Esse documento também refere que o profeta, avisado por um oráculo, mandou que a Tenda e a Arca o acompanhassem, quando ele foi à montanha, à qual Moisés subiu para contemplar a herança de Deus."
,"5":"Ao chegar, Jeremias encontrou uma espécie de gruta, onde colocou a Tenda, a Arca e o altar do incenso. Em seguida, tapou a entrada."
,"6":"Mais tarde, alguns dos que tinham acompanhado Jeremias foram até lá para indicar o caminho, mas não conseguiram encontrar a gruta."
,"7":"Quando o soube, Jeremias repreendeu-os, dizendo: «O lugar ficará desconhecido, até que Deus Se mostre misericordioso e reúna novamente toda a comunidade do povo."
,"8":"Então o Senhor mostrará esses objectos. A glória do Senhor e a nuvem também vão aparecer, como apareceram no tempo de Moisés e quando Salomão pediu a Deus que santificasse grandiosamente o lugar»."
,"9":"Contava-se que Salomão, com toda a sua sabedoria, ofereceu o sacrifício de consagração e inauguração do Templo."
,"10":"Da mesma forma que Moisés rezou ao Senhor e desceu um fogo do céu para queimar o sacrifício, assim também Salomão rezou, e o fogo desceu do alto e queimou os holocaustos."
,"11":"Moisés disse também: «O sacrifício oferecido pelo pecado foi devorado pelo fogo, porque não foi comido»."
,"12":"Da mesma forma, também Salomão celebrou os oito dias de festa."
,"13":"Além destas coisas, também se conta, nos escritos e memórias de Neemias, como ele fundou uma biblioteca, e reuniu os Anais dos Reis, os escritos dos profetas e de David, e também as cartas dos reis sobre as oferendas consagradas."
,"14":"Também Judas reuniu os escritos, que estavam espalhados por causa da guerra que sofremos. Agora está tudo connosco."
,"15":"Se precisardes de alguma coisa, mandai alguém buscá-la."
,"16":"Nós estamos a escrever-vos, porque queremos celebrar a purificação do Templo. Vós fareis bem se celebrardes esses dias."
,"17":"Deus é quem salva todo o seu povo e dá a todos a herança, o reino, o sacerdócio e a santificação,"
,"18":"como Ele mesmo prometeu através da Lei. Por isso, esperamos que Deus em breve tenha misericórdia de nós e nos reúna, de todas as partes da Terra, no lugar santo. Ele nos livrou dos maiores males e purificou o lugar santo."
,"19":"Vou falar sobre o que aconteceu a Judas Macabeu e a seus irmãos, sobre a purificação do Templo grandioso e a consagração do altar."
,"20":"Falarei também das guerras contra Antíoco Epifânio e seu filho Eupátor."
,"21":"Contarei as aparições celestes que tiveram aqueles que corajosamente realizaram as maiores proezas em favor do judaísmo. Eles eram poucos; no entanto, conseguiram recuperar o país inteiro, perseguiram multidões de inimigos violentos,"
,"22":"retomaram o Templo, que é famoso no mundo inteiro, libertaram a cidade de Jerusalém e puseram novamente em vigor as leis que estavam a ser abolidas. É que o Senhor, com toda a consideração, foi muito misericordioso para com eles."
,"23":"Tudo isto é contado por Jasão de Cirene em cinco livros, mas nós tentaremos resumir tudo num só livro."
,"24":"São muitos os números, e a matéria também é muito vasta. Por isso, quem deseja embrenhar-se numa narrativa desses factos encontra dificuldades."
,"25":"A nossa preocupação foi dar prazer aos que buscam uma leitura agradável, facilitar o trabalho aos que a querem guardar na memória, e proporcionar algum proveito a todos os que tiverem esta obra nas mãos."
,"26":"A nós, porém, que nos dedicámos ao sacrifício de fazer este resumo, o trabalho não foi leve. Pelo contrário, custou suores e noites em claro."
,"27":"Não é fácil preparar um banquete; quem o faz, procura agradar a todos. Assim também, foi com prazer que nos dedicámos a esta tarefa, esperando o reconhecimento de grande número de pessoas."
,"28":"Ao historiador deixamos o julgamento sobre cada pormenor. Entregámo-nos a este trabalho, procurando seguir as normas de um resumo."
,"29":"É como o construtor de uma casa nova, que zela pelo conjunto da estrutura, enquanto o encarregado da pintura e dos arremates procura cuidar do material indicado para o acabamento. É este, penso eu, o nosso caso."
,"30":"Aprofundar e percorrer os factos, discutindo os pormenores de cada parte, é coisa própria do historiador."
,"31":"Quem faz um resumo tem o direito de procurar a síntese de tudo o que se conta, deixando de lado o desenvolvimento de cada facto."
,"32":"Agora, pois, vamos dar início à nossa narrativa, juntando apenas o seguinte ao que já foi dito: seria tolice prolongarmo-nos em considerações sobre a narrativa, e depois resumir a própria narrativa."
}`)
	CurrentBook.AddChapter(3, `{
"1":"A cidade santa vivia na mais completa paz, e os mandamentos eram observados da melhor maneira possível, por causa da santidade do sumo sacerdote Onias, e da sua firme oposição a tudo o que havia de mal."
,"2":"Os próprios reis respeitavam o lugar santo, e homenageavam o Templo com os mais belos donativos."
,"3":"Até Seleuco, rei da Ásia, com os seus recursos, sustentava todas as despesas necessárias para as funções dos sacrifícios."
,"4":"Porém um certo Simão, da tribo de Belga, que era administrador do Templo, desentendeu-se com o sumo sacerdote a propósito da administração da cidade."
,"5":"Como não foi capaz de derrotar Onias, foi procurar Apolónio de Tarso, que era o comandante da Celessíria e da Fenícia."
,"6":"Contou-lhe que o tesouro do Templo em Jerusalém estava cheio de riquezas indizíveis, e que a quantidade de dinheiro era incalculável. Disse-lhe também que isso não era necessário para os sacrifícios e poderia muito bem cair em poder do rei."
,"7":"Apolónio, ao ter uma audiência com o rei, contou-lhe tudo o que lhe tinha sido relatado. Então o rei destacou Heliodoro, encarregado da administração, e deu-lhe ordem para ir e retirar as tão faladas riquezas."
,"8":"Heliodoro partiu imediatamente. Dava a entender que andava apenas a percorrer as cidades da Celessíria e da Fenícia, mas afinal ia executar a tarefa que o rei lhe tinha confiado."
,"9":"Ao chegar a Jerusalém, foi recebido amigavelmente pelo sumo sacerdote da cidade. Falou-lhe da informação recebida, explicou-lhe o motivo da sua vinda, e perguntou-lhe se as coisas eram realmente assim."
,"10":"O sumo sacerdote, por sua vez, explicou que as coisas ali depositadas eram de viúvas e órfãos,"
,"11":"e que algumas coisas pertenciam a Hircano, filho de Tobias, homem poderoso e de alta posição. Diversamente do que estava a ser espalhado pelo irreverente Simão, disse também que havia um total de catorze toneladas de prata e sete de ouro."
,"12":"Disse ainda ser inconcebível que se cometesse tal injustiça contra os que confiaram no lugar santo, na sagrada inviolabilidade do Templo, venerado no mundo inteiro."
,"13":"Heliodoro, porém, seguindo as ordens recebidas do rei, afirmou resolutamente que tudo aquilo devia ser transferido para o tesouro real."
,"14":"Marcou uma data e apresentou-se para fazer um inventário das riquezas. Isso provocou uma enorme agitação em toda a cidade."
,"15":"Os sacerdotes, com as vestes sagradas e prostrados no chão diante do altar, invocavam o Céu, cuja Lei tinha determinado esses donativos e segundo a qual se deviam conservar intactos os bens em favor daqueles que os tinham depositado."
,"16":"Quem olhasse para o sumo sacerdote ficava de coração partido, pois o olhar e a palidez do seu rosto mostravam a agonia que lhe ia na alma."
,"17":"Ele estava cheio de pavor, e o tremor do seu corpo mostrava a todos os que o viam o sofrimento que tinha no coração."
,"18":"Aos bandos, vinham as pessoas a correr das suas casas para as rogações públicas, por causa do ultraje que ameaçava o lugar santo."
,"19":"Com saias de pano grosseiro, as mulheres amontoavam-se pelas ruas. As jovens, que costumavam ficar fechadas em casa, iam para as portas da casa, ou subiam para o muro, ou debruçavam-se na janela."
,"20":"Todas, porém, erguiam as mãos para o céu e faziam as suas preces."
,"21":"Era comovente a apreensão do povo em geral e a ansiedade do sumo sacerdote, tomado de profunda angústia."
,"22":"Pediam ao Senhor Todo-poderoso que guardasse intactos e em segurança os depósitos em favor daqueles que os tinham depositado."
,"23":"Heliodoro, porém, procurava executar o que fora decidido."
,"24":"Heliodoro já estava junto da sala do tesouro, quando o Senhor dos Espíritos e do Poder Se manifestou com tal esplendor, que todos os que se arriscaram a entrar ali ficaram desfalecidos e em pânico, atingidos pela força de Deus."
,"25":"Apareceu-lhes um cavalo ajaezado com belíssimo arreio e montado por um terrível cavaleiro. Ele avançou bruscamente, e o cavalo começou a dar coices em Heliodoro. O cavaleiro parecia ter armadura de ouro."
,"26":"Apareceram também a Heliodoro outros dois jovens extraordinariamente fortes, muito bonitos e com roupas magníficas. Puseram-se um de cada lado de Heliodoro e começaram a açoitá-lo, dando-lhe muitos golpes."
,"27":"Heliodoro caiu logo no chão. Envolto em densa escuridão, tiveram de o levantar e colocar numa maca."
,"28":"Foi assim que retiraram dali, inteiramente sem acção, aquele mesmo que tinha entrado na sala do tesouro com todo o acompanhamento e toda a sua guarda pessoal. Foram obrigados a reconhecer que o poder de Deus se havia manifestado com toda a clareza."
,"29":"Heliodoro, prostrado pelo poder de Deus, estava sem fala e sem qualquer esperança de salvação."
,"30":"Enquanto isso os judeus davam louvores a Deus, que tinha glorificado o seu lugar santo. Até há pouco o Templo estava cheio de pavor e preocupação. Agora, por causa da manifestação do Senhor Todo-poderoso, estava repleto de alegria e acções de graças."
,"31":"Alguns da comitiva de Heliodoro pediram a Onias que invocasse o Altíssimo, suplicando pela vida de quem já estava, sem dúvida, a agonizar."
,"32":"Preocupado e com medo de que o rei fosse imaginar que os judeus tinham armado algum acto criminoso contra Heliodoro, o sumo sacerdote ofereceu um sacrifício pela saúde do homem."
,"33":"No momento em que o sacerdote oferecia o sacrifício de expiação, os mesmos jovens apareceram de novo a Heliodoro, vestidos com o mesmo traje. De pé, eles disseram-lhe: «Tu deves agradecer muito ao sumo sacerdote Onias, porque é em consideração a ele que o Senhor te concede a vida."
,"34":"Tu foste chicoteado pelos Céus. Agora anuncia a todos o grandioso poder de Deus». E, ao dizerem isto, desapareceram."
,"35":"Heliodoro ofereceu um sacrifício ao Senhor, fez grandes promessas ao Deus que lhe devolvera a vida, despediu-se de Onias, e voltou com o seu exército para junto do rei."
,"36":"A todos ia dando testemunho das obras do Deus supremo, que ele tinha visto com os próprios olhos."
,"37":"Quando o rei lhe perguntou quem seria a pessoa mais indicada para ser mandada outra vez a Jerusalém, ele respondeu:"
,"38":"«Se Vossa Majestade tem algum inimigo, alguém que se opõe aos seus actos de governo, mande-o para lá, e ele regressará devidamente castigado, caso consiga escapar. Naquele lugar existe realmente uma força divina."
,"39":"Aquele que mora no céu é o guarda e protector daquele lugar. Ele fere e mata quem se aproxima do Templo, com más intenções»."
,"40":"Foi o que aconteceu a respeito de Heliodoro e da conservação do tesouro do Templo."
}`)
	CurrentBook.AddChapter(4, `{
"1":"O mesmo Simão, que foi traidor das riquezas e da pátria, começou a difamar Onias, como se tivesse sido este a ferir e causar males a Heliodoro."
,"2":"Ele teve a coragem de chamar agitador da ordem pública ao benfeitor da cidade, ao protector da sua gente e fervoroso cumpridor das leis."
,"3":"O clima de inimizade foi crescendo tanto, que alguns agentes de Simão acabaram por cometer assassínios."
,"4":"Onias percebeu o perigo dessa rivalidade. Vendo que Apolónio, filho de Menesteu e comandante da Celessíria e da Fenícia, apoiava as más intenções de Simão,"
,"5":"foi procurar o rei. Não foi denunciar cidadão nenhum, mas batalhar pelo bem comum e privado de todo o povo."
,"6":"Ele percebeu que, se o rei não tomasse providências, seria impossível alcançar a paz na vida pública, e que Simão não iria acabar com as suas loucuras."
,"7":"Depois da morte de Seleuco subiu ao trono o rei Antíoco, chamado Epifânio. Foi quando Jasão, irmão de Onias, conseguiu, com suborno, o cargo de sumo sacerdote."
,"8":"Numa audiência com o rei, Jasão prometeu-lhe treze toneladas de prata, mais três toneladas de outros rendimentos."
,"9":"Além disso, daria mais cinco toneladas, se o rei lhe desse permissão para construir uma praça de desporto e uma escola para jovens, além de fazer o recenseamento dos cidadãos antioquenos em Jerusalém."
,"10":"Com o consentimento do rei e após tomar posse do cargo, Jasão passou imediatamente a fazer com que os seus irmãos de raça adoptassem o estilo de vida dos gregos."
,"11":"Anulou os favores que o rei concedera aos judeus, graças à intervenção de João, pai de Eupolemo. Este Eupolemo é o mesmo que negociou o pacto de amizade e mútua defesa com os romanos. Jasão também aboliu as leis da constituição e procurava introduzir práticas contrárias à Lei."
,"12":"Foi com satisfação que construiu uma praça de desportos abaixo da Acrópole, e levou os melhores jovens a usar o chapéu chamado pétaso."
,"13":"Era o auge do helenismo, a exaltação do modo de viver dos estrangeiros. Tudo por causa da corrupção do ímpio e falso sumo sacerdote Jasão."
,"14":"As coisas chegaram a tal ponto, que os sacerdotes já não se interessavam pelas funções do altar. Deixavam de lado o Templo e, sem se preocupar com os sacrifícios, logo que era anunciado o lançamento de discos, corriam para a praça de desportos, a fim de participar dos jogos contrários à Lei."
,"15":"Ninguém ligava já às tradições nacionais e achavam muito mais importantes as glórias gregas."
,"16":"Por causa da própria cultura grega acabaram por se colocar numa situação crítica: aqueles mesmos, cujos costumes eles procuravam promover e a quem procuravam em tudo assemelhar-se, tornaram-se seus inimigos e carrascos."
,"17":"Porque desrespeitar as leis divinas não é coisa sem importância, como se verá no episódio seguinte."
,"18":"Realizavam-se em Tiro os jogos quinquenais, com a presença do rei."
,"19":"O abominável Jasão mandou alguns espectadores antioquenos de Jerusalém, encarregando-os de levar trezentas moedas de prata para o sacrifício em honra de Hércules. Os encarregados, porém, acharam melhor não usar esse dinheiro para o sacrifício, coisa inconveniente, mas empregá-lo noutras despesas."
,"20":"Assim, o dinheiro que fora enviado para o sacrifício em honra de Hércules, por iniciativa dos portadores, foi usado para a construção de navios a remo."
,"21":"Quando Apolónio, filho de Menesteu, foi enviado ao Egipto para a festa de casamento do rei Filométor, Antíoco soube que este rei estava a fazer projectos contrários aos seus interesses. Por isso, ele passou por Jope e chegou a Jerusalém."
,"22":"Aí foi recebido com toda a pompa por Jasão e pela cidade, à luz de tochas e sob aclamações. Em seguida, partiu com o seu exército para a Fenícia."
,"23":"Três anos depois, Jasão mandou Menelau, irmão do já mencionado Simão, levar o dinheiro ao rei e apresentar o relatório sobre alguns assuntos importantes."
,"24":"Menelau, porém, apresentou-se ao rei dando mostra de ser homem poderoso, e com adulações conseguiu para si o posto de sumo sacerdote, oferecendo dez toneladas de prata a mais do que Jasão."
,"25":"Depois de receber a nomeação do rei, ele voltou, sem trazer consigo coisa alguma que fosse digna de sumo sacerdote. Pelo contrário, trazia em si o furor de um tirano cruel e a fúria de um animal selvagem."
,"26":"E Jasão, que tinha suplantado o seu próprio irmão, foi por sua vez suplantado por outro, e teve que fugir para a região dos amonitas."
,"27":"Menelau assumiu o poder, mas não tomou qualquer providência no tocante ao dinheiro que tinha prometido ao rei,"
,"28":"apesar das cobranças feitas por Sóstrato, comandante da Acrópole, a quem cabia a questão dos tributos. Por essa razão, os dois foram convocados pelo rei."
,"29":"Menelau deixou seu irmão Lisímaco como substituto no sumo sacerdócio, enquanto Sóstrato deixou em seu lugar Crates, comandante dos soldados cipriotas."
,"30":"Enquanto isso, as cidades de Tarso e de Malos estavam em plena rebelião, por terem sido dadas como presente a Antioquide, concubina do rei."
,"31":"Então o rei partiu rapidamente com o intuito de normalizar a situação. Em seu lugar, deixou Andrónico, um dos seus altos ministros."
,"32":"Achando que era boa oportunidade para tanto, Menelau tirou do Templo alguns objectos de ouro e deu-os como presente a Andrónico. Além disso, vendeu outra parte em Tiro e nas cidades vizinhas."
,"33":"Onias tinha-se abrigado num lugar de refúgio em Dafne, perto de Antioquia. Ao saber o que Menelau fizera, Onias desaprovou-o."
,"34":"Por causa disso, Menelau sugeriu secretamente a Andrónico que acabasse com Onias. Então Andrónico procurou Onias e tentou convencê-lo com mentiras, dando-lhe até a mão direita como juramento. Embora Onias tivesse suspeitas, foi convencido por Andrónico a sair do refúgio. Este matou-o imediatamente, sem respeito algum pela justiça."
,"35":"Por isso, não somente os judeus, mas também muitos de outras nações ficaram indignados e condenaram totalmente o assassínio daquele homem."
,"36":"Quando o rei voltou dos citados lugares da Cilícia, os judeus da capital reuniram-se em torno dele, juntamente com os gregos, para denunciar o crime cometido contra Onias."
,"37":"Antíoco ficou profundamente amargurado e, tocado de compaixão, chorou por causa do equilíbrio e moderação do falecido."
,"38":"Inflamado em ira, mandou imediatamente tirar a Andrónico o manto de púrpura, rasgar-lhe as vestes, conduzi-lo por toda a cidade, levá-lo para o mesmo local onde tinha cometido o crime contra Onias, e ali executar o assassino. O Senhor aplicava assim a Andrónico o merecido castigo."
,"39":"Nesse meio tempo, muitos furtos de objectos sagrados foram cometidos por Lisímaco em Jerusalém, sob a conivência de Menelau. Quando a notícia se espalhou, muitos objectos de ouro já tinham sido desviados, e o povo revoltou-se contra Lisímaco."
,"40":"Realmente o povo estava revoltado e enfurecido. Então Lisímaco armou cerca de três mil homens e começou uma violenta repressão, dirigida por um certo Aurano, homem avançado em idade e muito mais em loucura."
,"41":"Quando perceberam o ataque de Lisímaco, alguns pegaram em pedras, outros armaram-se de bastões, outros ainda recolhiam punhados de terra do lugar e avançaram contra os homens de Lisímaco."
,"42":"Deste modo, feriram a muitos, mataram alguns e puseram-nos todos em fuga. Quanto ao ladrão dos objectos sagrados, conseguiram matá-lo ao lado da sala do tesouro."
,"43":"A propósito destes factos, foi aberto um processo contra Menelau."
,"44":"Quando o rei estava em Tiro, três emissários do conselho dos anciãos foram defender, junto do rei, a causa do povo."
,"45":"Menelau, sentindo-se perdido, prometeu grande soma de dinheiro a Ptolomeu, filho de Dorimeno, para que ele convencesse o rei em seu favor."
,"46":"Ptolomeu levou o rei para a sacada, como se fosse para tomar um pouco de ar, e conseguiu fazê-lo mudar de ideia."
,"47":"Foi assim que o rei absolveu Menelau, o causador de toda essa desgraça, e condenou à morte os três infelizes, que teriam sido absol-vidos como inocentes, até mesmo diante de um tribunal bárbaro."
,"48":"A injusta condenação foi imediatamente executada contra aqueles que estavam apenas a defender a cidade, o povo e os objectos sagrados."
,"49":"Por isso, alguns de Tiro, revoltados, forneceram generosamente tudo o que era preciso para a sepultura deles."
,"50":"Enquanto isso, Menelau, graças à ganância dos poderosos, continuou no poder, aumentando cada vez mais a sua própria crueldade e tornando-se o maior inimigo dos seus compatriotas."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Nesse tempo, Antíoco preparava a sua segunda expedição contra o Egipto."
,"2":"Aconteceu então que, durante quase quarenta dias, começaram a aparecer no ar, pela cidade inteira, cavaleiros vestidos de ouro, armados de lanças, organizados em pelotões e empunhando espadas."
,"3":"Viam-se brigadas de cavalaria em linha cerrada, ataques e contra-ataques de um lado e do outro, movimento de escudos, multidões de lanças, lançamento de projécteis, faiscar de adornos dourados e todo o tipo de couraças."
,"4":"Todos pediam para que essa aparição fosse de bom agouro."
,"5":"Correu então um falso boato de que Antíoco tinha morrido. Jasão reuniu mais de mil homens e atacou a cidade de surpresa. Ao serem derrotados aqueles que estavam na muralha e consumando-se a tomada da cidade, Menelau refugiou-se na Acrópole."
,"6":"Enquanto isso, Jasão promovia impiedosamente a matança dos seus próprios concidadãos, sem compreender que uma vitória sobre os seus irmãos era a sua maior derrota. Ele pensava estar a triunfar sobre inimigos e não sobre compatriotas."
,"7":"Contudo, não conseguiu tomar o poder. O resultado foi a humilhação que lhe veio por causa do seu motim, e teve de fugir novamente para a região dos amonitas."
,"8":"O seu comportamento perverso teve um triste fim: denunciado a Aretas, rei dos árabes, foi perseguido e teve de andar fugindo de cidade em cidade, detestado por todos como traidor das suas leis, repelido como inimigo da própria nação e dos próprios compatriotas e, por isso, expulso para o Egipto."
,"9":"Dessa forma, Jasão, que tinha exilado tantos da sua pátria, também foi morrer no exílio, já que se refugiou na terra dos lacedemónios, com a esperança de receber protecção devido aos laços de parentesco."
,"10":"Ele que havia deixado muitos mortos sem sepultura, morreu sem que alguém chorasse por ele, não teve nenhum tipo de funeral, nem foi sepultado junto dos seus antepassados."
,"11":"Quando chegou ao rei a notícia destes acontecimentos, ele pensou que a Judeia se tivesse revoltado. Voltando furioso do Egipto, ocupou militarmente a cidade."
,"12":"Mandou os soldados matar sem piedade quantos encontrassem, e trucidar os que procurassem refúgio nas casas."
,"13":"Houve grande matança de jovens e velhos, massacre de homens, mulheres e crianças, carnificina de raparigas e bebés."
,"14":"Em três dias, pereceram oitenta mil pessoas: quarenta mil foram assassinadas, e os vendidos como escravos não foram menos do que os mortos."
,"15":"Não satisfeito com tudo isto, Antíoco ainda teve a ousadia de entrar no Templo mais sagrado do mundo, tendo por guia Menelau, traidor das leis e da pátria."
,"16":"Com as suas mãos impuras, Antíoco pegou nas vasilhas sagradas e, com as suas mãos sacrílegas, levou embora os donativos aí depositados por outros reis para engrandecimento, glória e honra do lugar santo."
,"17":"Antíoco foi arrogante, sem perceber que o Senhor Se havia irritado durante breve tempo, por causa dos pecados dos habitantes da cidade. Era por isso que o Senhor Se descuidava do lugar santo."
,"18":"De facto, se eles não se tivessem envolvido em tantos pecados, Antíoco seria imediatamente barrado no seu atrevimento a poder de chicotadas, logo que chegasse, como aconteceu a Heliodoro, enviado pelo rei Seleuco para fiscalizar o tesouro."
,"19":"Contudo, o Senhor não escolheu o povo para o lugar santo, mas o lugar santo para o povo."
,"20":"Por isso, é que o lugar santo, havendo participado das desgraças que ocorreram ao povo, depois participou também da felicidade dele. Ficou abandonado no momento de ira do Todo-poderoso, mas foi restaurado em toda a sua glória, quando o Senhor novamente Se reconciliou."
,"21":"Depois de ter roubado sessenta e duas toneladas de ouro do Templo, Antíoco voltou imediatamente para Antioquia. No seu orgulho e insolência, ele acreditava que poderia navegar em terra firme e andar a pé dentro do mar."
,"22":"No entanto, ele deixou alguns superintendentes, para continuarem a maltratar o povo. Em Jerusalém colocou Filipe, de origem frígia, de carácter mais bárbaro do que aquele que o havia nomeado para o cargo."
,"23":"No Garizim, deixou Andrónico. Além destes, deixou também Menelau, que era pior que os outros na opressão contra os seus próprios compatriotas. Cheio de ódio profundo contra os cidadãos judeus, "
,"24":"o rei enviou o comandante Apolónio com vinte e dois mil soldados e com ordens para matar todos os adultos e vender as mulheres e os mais jovens."
,"25":"Ao chegar a Jerusalém, Apolónio, simulando atitude pacífica, aguardou o dia santificado do sábado. Surpreendeu os judeus em repouso, mandando os soldados fazer um desfile militar."
,"26":"Ordenou então que matassem todos os que saíam para ver o desfile. Depois, percorrendo a cidade com armas, provocou um terrível massacre."
,"27":"Então Judas, chamado Macabeu, reuniu cerca de dez homens, retirou-se para o deserto e, como os animais selvagens, passou a viver nas montanhas com os seus companheiros. Para não se contaminarem com alimentos impuros, comiam apenas ervas."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Não muito tempo depois, o rei mandou um ancião ateniense a convencer os judeus a que abandonassem as leis dos antepassados e deixassem de se governar segundo as leis de Deus."
,"2":"Mandou também profanar o Templo de Jerusalém e dedicá-lo a Júpiter Olímpico, e também dedicar o templo do monte Garizim a Júpiter Hospitaleiro, conforme o desejo dos moradores do lugar."
,"3":"Mesmo para a massa do povo, era difícil e insuportável o crescimento dessa maldade."
,"4":"De facto, o Templo ficou cheio de libertinagem e orgias de pagãos, que aí se divertiam com prostitutas e mantinham relações com mulheres no recinto sagrado do Templo, além de levarem para dentro objectos proibidos."
,"5":"O próprio altar estava repleto de ofertas proibidas pela Lei."
,"6":"Não se podia celebrar o sábado, nem as festas tradicionais, nem mesmo declarar-se judeu."
,"7":"Todos os meses eram forçados a participar no banquete sacrificial, que se realizava no dia do aniversário do rei. Quando chegavam as festas de Dionísio, eram obrigados a participar na procissão em honra de Dionísio, com ramos de hera na cabeça."
,"8":"Por sugestão dos habitantes de Ptolemaida, foi decretado que as cidades gregas vizinhas também seguissem as mesmas disposições contra os judeus, obrigando-os a comer a carne dos sacrifícios,"
,"9":"e matassem os que não quisessem aceitar os costumes gregos. Podia-se perceber a calamidade que estava para chegar."
,"10":"Duas mulheres foram presas por terem circuncidado os seus filhos. Depois de as fazer percorrer publicamente a cidade com os filhos pendurados ao seio, lançaram-nas da muralha abaixo."
,"11":"Outros, que tinham saído juntos para os arredores da cidade, para as cavernas, a fim de aí celebrar às escondidas o sábado, após serem denunciados a Filipe, foram queimados juntos, pois ficaram com escrúpulo de reagir, por respeito à santidade do dia."
,"12":"Recomendo àqueles que lerem este livro, que não fiquem perturbados por causa de tais calamidades. Pelo contrário, pensem que esses castigos não vieram para destruir, mas apenas para corrigir a nossa gente."
,"13":"É sinal de grande bondade não deixar por muito tempo sem castigo aqueles que cometem injustiça, mas aplicar-lhes logo a merecida punição."
,"14":"O Senhor não age connosco como faz com os outros povos, esperando pacientemente o tempo de os castigar, até que os seus pecados cheguem ao máximo. Ele quis agir dessa forma connosco,"
,"15":"para não chegarmos primeiro ao extremo dos nossos pecados, e só então nos castigar."
,"16":"Significa que Ele nunca retira de nós a sua misericórdia. Mesmo quando nos corrige com desgraças, não está abandonando o seu povo."
,"17":"O que acabámos de dizer fique apenas como aviso. Agora vamos passar já para a narrativa."
,"18":"Eleazar era um dos principais doutores da Lei, homem de idade avançada, mas com rosto de traços ainda belos. Queriam obrigá-lo a comer carne de porco, enfiando-lha na boca."
,"19":"Ele, porém, que antes preferia uma morte honrada do que viver envergonhado, dirigiu-se espontaneamente para a tortura do tímpano,"
,"20":"tendo antes cuspido fora o que tinha na boca. Assim é que devem fazer os que corajosamente querem resistir ao que não é permitido comer, nem mesmo por amor à própria vida."
,"21":"Os que dirigiam esse sacrifício proibido, velhos amigos de Eleazar, tomando-o à parte, propuseram-lhe que tomasse carne permitida, por ele mesmo preparada, fingindo que comia a carne do sacrifício ordenado pelo rei."
,"22":"Se ele assim fizesse, estaria livre da morte e, pela antiga amizade que havia entre eles, tratá-lo-iam com benevolência."
,"23":"Ele, porém, tomou uma nobre decisão, coerente com a sua idade e com o respeito da velhice, coerente com a dignidade dos seus cabelos brancos e com a vida correcta que levava desde a infância; acima de tudo, coerente com as santas leis dadas pelo próprio Deus. Ele respondeu prontamente: «Podeis mandar-me para a mansão dos mortos."
,"24":"Na minha idade não fica bem fingir, senão muitos dos mais jovens pensarão que um velho de noventa anos chamado Eleazar passou para os costumes estrangeiros."
,"25":"Com o seu fingimento, por causa de um pequeno resto de vida, eles seriam enganados, e eu só ganharia mancha e desprezo para a minha velhice."
,"26":"Mesmo que no presente eu me livrasse do castigo humano, nem vivo nem morto conseguiria escapar das mãos do Todo-poderoso."
,"27":"É por isso que, se eu passar corajosamente para a outra vida, mostrar-me-ei digno da minha idade."
,"28":"Aos mais novos posso deixar um exemplo honrado, mostrando como se deve morrer corajosa e dignamente pelas veneráveis e santas leis». Dito isto, foi imediatamente para o suplício."
,"29":"Os seus torturadores, que pouco antes queriam ser amáveis com ele, então tornaram-se cruéis por causa do que ele dissera, ao considerar tudo aquilo uma loucura."
,"30":"Já quase morto, no meio das torturas, Eleazar ainda disse entre gemidos: «O Senhor, que possui a santa sabedoria, sabe que eu, podendo escapar da morte, suporto no meu corpo as dores cruéis da tortura, mas na minha alma estou alegre, porque sofro por causa do temor d'Ele»."
,"31":"E assim terminou a sua vida. A sua morte deixou, não só aos jovens, mas também ao resto do povo, um exemplo memorável de heroísmo e virtude."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Aconteceu também que sete irmãos foram presos juntamente com sua mãe. Espancando-os com flagelos e chicotes, o rei pretendia obrigá-los a comer carne de porco, que era proibida."
,"2":"Um deles, falando em nome dos outros, disse: «Que queres perguntar ou saber de nós? Estamos prontos a morrer, antes que desobedecer às leis dos nossos antepassados»."
,"3":"Enfurecido, o rei mandou aquecer assadeiras e caldeirões."
,"4":"Logo que ficaram quentes, mandou cortar a língua, arrancar o couro cabeludo e decepar as extremidades daquele que tinha falado pelos outros, e tudo diante dos irmãos e da mãe."
,"5":"Já mutilado de todos os membros e enquanto ainda vivia, o rei mandou que o pusessem no fogo para assar. Da assadeira subia grande volume de fumo. E os seus irmãos com a mãe animavam-se entre si para enfrentarem corajosamente a morte, dizendo:"
,"6":"«O Senhor Deus observa-nos e certamente terá compaixão de nós, conforme afirmou claramente Moisés no seu cântico: 'Ele terá compaixão dos seus servos'»."
,"7":"Depois de o primeiro ter morrido, levaram o segundo para a tortura. Após terem-lhe arrancado o couro cabeludo, perguntaram: «Gostarias de comer, antes de o teu corpo ser torturado membro por membro?»"
,"8":"Ele, porém, respondeu na sua língua materna: «Não». Por isso, foi submetido às mesmas torturas do primeiro."
,"9":"Antes de dar o último suspiro, ainda disse: «Tu, malvado, tiras-nos desta vida presente, mas o rei do mundo far-nos-á ressuscitar para uma ressurreição eterna de vida, a nós que agora morremos pelas suas leis»."
,"10":"Depois deste, também o terceiro foi levado para a tortura. Intimado, deitou imediatamente a língua para fora e apresentou corajosamente as mãos,"
,"11":"dizendo com dignidade: «De Deus eu recebi estes membros, e agora, por causa das suas leis, eu os desprezo, pois espero que Ele mos devolva»."
,"12":"O rei e aqueles que o rodeavam ficaram admirados da coragem com que o rapaz enfrentava os sofrimentos, como se nada fossem."
,"13":"Logo que este morreu, começaram a torturar da mesma forma o quarto irmão."
,"14":"Estando para morrer, ele disse: «Vale a pena morrer pela mão dos homens, quando se espera que o próprio Deus nos ressuscite. Para ti, porém, não haverá ressurreição para a vida»."
,"15":"Imediatamente apresentaram o quinto e passaram a torturá-lo."
,"16":"Olhando bem para o rei, ele afirmou: «Mesmo sendo simples mortal, tu fazes o que queres, porque tens poder sobre os homens. Mas não penses que o nosso povo foi abandonado por Deus."
,"17":"Espera um pouco, e verás como o seu grande poder vai torturar-te e à tua descendência»."
,"18":"Depois deste, trouxeram também o sexto. Quando estava a morrer, ele ainda disse: «Não te iludas! Nós estamos a sofrer tudo isto pelas nossas culpas, porque pecámos contra o nosso Deus. Por isso nos acontecem estas coisas espantosas."
,"19":"Quanto a ti, que te atreveste a lutar contra Deus, não penses que ficarás sem castigo»."
,"20":"Extraordinariamente admirável, porém, e digna da mais respeitável lembrança, foi a mãe. Ela, vendo morrer os seus sete filhos num só dia, suportou tudo corajosamente, esperando no Senhor."
,"21":"Ela encorajava cada um dos filhos, na língua dos seus antepassados. Com atitude nobre, e animando a sua ternura feminina com força viril, assim falava com os filhos:"
,"22":"«Não sei como aparecestes no meu ventre. Não fui eu que vos dei o espírito e a vida, nem fui eu que dei forma aos membros de cada um de vós."
,"23":"Foi o Criador do mundo, que modela a humanidade e determina a origem de tudo. Ele, na sua misericórdia, devolver-vos-á o espírito e a vida, se agora vos sacrificardes pelas suas leis»."
,"24":"Antíoco pensou que a mulher o enganava e desconfiou que ela o estava a insultar. Restava, porém, o filho mais novo. E o rei tentava convencê-lo, e até lhe garantiu, sob juramento, que, se renegasse as tradições dos antepassados, ele o tornaria rico e feliz, o teria como amigo e lhe daria cargos importantes."
,"25":"Entretanto, o menino não lhe deu a menor atenção. Por isso, o rei chamou a mãe e pedia-lhe que aconselhasse o menino para o próprio bem dele."
,"26":"Depois de muita insistência do rei, ela aceitou falar com o filho."
,"27":"Abaixou-se e, enganando esse rei cruel, usou a língua dos antepassados e falou assim: «Meu filho, tem dó de mim. Eu trouxe-te no meu ventre durante nove meses. Amamentei-te durante três anos. Eduquei-te, criei-te e tratei-te até esta idade!"
,"28":"Meu filho, eu te imploro: olha para o céu e para a terra, e observa tudo o que neles existe. Deus criou tudo isso do nada, e a humanidade teve a mesma origem."
,"29":"Não fiques com medo deste carrasco. Pelo contrário, sê digno dos teus irmãos e enfrenta a morte. Deste modo, eu te recuperarei juntamente com os teus irmãos, no tempo da misericórdia»."
,"30":"Apenas ela acabou de falar, o rapazinho disse: «Que esperais? Eu não obedeço às ordens do rei. Obedeço às determinações da Lei que foi dada aos nossos antepassados através de Moisés."
,"31":"Quanto a ti, que estás procurando fazer tudo o que há de mau aos hebreus, tu não vais conseguir escapar das mãos de Deus."
,"32":"Nós estamos a sofrer por causa dos nossos pecados."
,"33":"Por um pouco de tempo, o Senhor vivo está irado connosco, castiga-nos e corrige-nos, mas Ele voltará a reconciliar-Se com os seus servos."
,"34":"Quanto a ti, ímpio e o pior criminoso do mundo, não te fiques exaltando à toa ou gritando esperanças que não têm fundamento, enquanto ergues as mãos contra os servos do Céu."
,"35":"Tu ainda não escapaste do julgamento do Deus Todo-poderoso, que tudo vê."
,"36":"Depois de suportar um sofrimento passageiro, os meus irmãos já estão a participar da vida eterna, na aliança com Deus. Em troca, no julgamento de Deus, tu receberás o castigo justo pela tua soberba."
,"37":"Quanto a mim, da mesma forma que os meus irmãos, entrego o meu corpo e a minha vida em favor das leis dos meus antepassados, suplicando que Deus Se compadeça depressa do meu povo. Enquanto isso, tu, à custa de castigos e flagelos, terás de reconhecer que Ele é o único Deus."
,"38":"Suplico que a ira do Todo-poderoso, que se abateu com toda a justiça contra o seu povo, se detenha em mim e nos meus irmãos»."
,"39":"O rei, sentindo-se envenenado pelo sarcasmo, ficou furioso, e tratou o menino com crueldade ainda mais feroz do que fizera com os outros."
,"40":"E o menino morreu sem mancha, confiando totalmente no Senhor."
,"41":"A mãe morreu por último, depois dos filhos."
,"42":"Por ora, basta o que contei sobre as refeições sacrificiais e as incríveis crueldades."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Nesse meio tempo, Judas, chamado Macabeu, com os seus companheiros, infiltravam-se nas aldeias. Convocando os compatriotas e recrutando os que continuavam fiéis ao judaísmo, reuniram cerca de seis mil pessoas."
,"2":"Suplicaram ao Senhor que olhasse para o povo, espezinhado por todos, e tivesse compaixão do Templo, profanado por ímpios;"
,"3":"que tivesse misericórdia da cidade de Jerusalém já destruída e em vias de ser arrasada ao solo; que escutasse o clamor do sangue que subia até Ele;"
,"4":"que Se lembrasse do criminoso massacre de crianças inocentes e das blasfémias contra o seu Nome, e pusesse em acção a sua vingança."
,"5":"Quando conseguiu organizar as pessoas, o Macabeu tornou-se invencível para os pagãos. Dessa forma, a ira do Senhor transformou-se em misericórdia."
,"6":"Judas chegava de surpresa e incendiava cidades e povoados, tomava os pontos estratégicos e punha em fuga muitos inimigos."
,"7":"Para esses ataques, escolhia de preferência a noite como sua aliada. E a fama da sua valentia espalhava-se por toda a parte."
,"8":"Quando viu que Judas ia pouco a pouco alcançando o sucesso, e subindo firmemente de vitória em vitória, Filipe escreveu a Ptolomeu, comandante da Celessíria e da Fenícia, pedindo que fosse socorrer os interesses do rei."
,"9":"Este imediatamente escolheu Nicanor, filho de Pátroclo, um dos principais amigos do rei, e colocou sob o seu comando mais de vinte mil homens pagãos de todas as nações, com ordem de liquidar a raça dos judeus. Juntamente com ele, mandou o comandante Górgias, homem experiente em questões de guerra."
,"10":"Nicanor planeou vender escravos judeus, para levantar a quantia de setenta toneladas de prata para o tributo que o rei devia aos romanos."
,"11":"Por isso, antes de mais nada, mandou alguém às cidades do litoral oferecer escravos judeus, propondo o preço de noventa escravos por trinta e cinco quilos de prata. Ele não imaginava o castigo que o Todo-poderoso lhe reservava."
,"12":"A notícia da vinda de Nicanor chegou até Judas, que preveniu os companheiros sobre a aproximação do inimigo."
,"13":"Os medrosos e aqueles que não confiavam na justiça de Deus abandonavam as suas posições e fugiam para se salvar."
,"14":"Os outros venderam tudo o que possuíam, e juntos suplicaram ao Senhor que os libertasse, pois já tinham sido vendidos como escravos pelo ímpio Nicanor."
,"15":"Pediam que Deus os atendesse, se não por causa deles próprios, pelo menos em vista da aliança feita com os seus antepassados e também por causa do próprio Nome sagrado e grandioso que estava a ser invocado."
,"16":"O Macabeu reuniu os seus companheiros em número de seis mil. Procurou animá-los, dizendo para não se apavorarem, nem se sentirem inferiorizados pela grande quantidade de pagãos que vinham fazer guerra injusta contra eles, mas que lutassem com bravura."
,"17":"Que tivessem diante dos olhos o desrespeito criminoso com que os inimigos trataram o nosso lugar santo, a vergonha da cidade humilhada e também a abolição das tradições dos nossos antepassados."
,"18":"Judas disse: «Os inimigos confiam nas armas e nos seus actos de bravura. Nós, porém, confiamos no Deus Todo-poderoso. Ele, com um simples gesto, é capaz de derrubar os nossos inimigos e até o mundo inteiro»."
,"19":"Lembrou-lhes também o socorro que tinha vindo de Deus a favor dos antepassados, como no caso de Senaquerib, quando morreram cento e oitenta e cinco mil."
,"20":"Lembrou-lhes também a batalha contra os gálatas na Babilónia, quando todos os que estavam em combate eram oito mil, além de quatro mil macedónios. Como os macedónios estivessem em dificuldade, os oito mil mataram cento e vinte mil com a ajuda que lhes veio do Céu, e ainda recolheram muitos despojos."
,"21":"Depois de os encorajar com estas palavras e tornando-os prontos para morrer pelas leis e pela pátria, Judas repartiu o exército em quatro divisões aproximadamente iguais."
,"22":"Como comandantes de cada uma das divisões nomeou seus irmãos Simão, José e Jónatas, ficando cada um com cerca de mil e quinhentos homens,"
,"23":"e também Eleazar. Lido o livro sagrado e dada a palavra de ordem: «Ajuda de Deus», Judas partiu contra Nicanor, comandando a primeira divisão."
,"24":"Como o Todo-poderoso Se tornou seu aliado, eles liquidaram mais de nove mil, enquanto feriram e mutilaram mais de metade do exército de Nicanor, obrigando todos os outros a fugir."
,"25":"Tomaram o dinheiro dos que tinham vindo com a intenção de os comprar. Perseguiram os fugitivos por longo tempo, mas desistiram por estar a ficar tarde,"
,"26":"pois era véspera de sábado. Por isso, não continuaram a persegui-los."
,"27":"Após lhes terem tomado as armas e despojado os cadáveres dos inimigos, celebraram o sábado de maneira extraordinária, louvando e agradecendo ao Senhor que nesse dia os libertou, marcando assim o início da sua misericórdia para com eles."
,"28":"Passado o sábado, repartiram os despojos dos inimigos entre os mutilados, viúvas e órfãos. Repartiram entre si e seus filhos tudo o que sobrou."
,"29":"Depois disso, fizeram uma súplica colectiva, pedindo ao Senhor misericordioso que Se reconciliasse totalmente com os seus servos."
,"30":"Em seguida, atacaram a gente de Timóteo e de Báquides. Mataram mais de vinte mil deles e, com muita facilidade, tomaram algumas fortalezas em pontos elevados. Dividiram então muitos despojos em partes iguais, entre si e com os mutilados, órfãos, viúvas e velhos."
,"31":"Recolheram cuidadosamente as armas dos inimigos, colocaram-nas todas em lugares convenientes e levaram para Jerusalém o resto dos despojos que tinham recolhido."
,"32":"Conseguiram matar o comandante da guarda pessoal de Timóteo, homem sanguinário que tinha feito sofrer muito os judeus."
,"33":"Quando estavam a celebrar na pátria a festa da vitória, queimaram vivos aqueles que tinham incendiado os portais sagrados e também esse tal Calístenes, que se havia refugiado numa casa. Assim eles receberam o castigo merecido pela profanação que tinham cometido."
,"34":"O bandido Nicanor, que tinha trazido mil negociantes para a venda de judeus,"
,"35":"foi humilhado, com a ajuda do Senhor, por aqueles mesmos que ele considerava os últimos. Teve que abandonar as suas roupas sumptuosas, e fugiu pelos campos como escravo, chegando a Antioquia sem nada, profundamente abatido pela derrota do seu exército."
,"36":"Assim, aquele que se havia responsabilizado por pagar o tributo devido aos romanos, mediante a venda de prisioneiros de Jerusalém, passou a proclamar que os judeus têm um Defensor e que, por essa razão, são invulneráveis, porque seguem as leis determinadas por Ele."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Por essa mesma ocasião, Antíoco foi forçado a voltar desordenadamente das regiões da Pérsia."
,"2":"Entrou em Persépolis, tentou despojar o templo e tomar a cidade. Perante isso, o povo revoltou-se e recorreu às armas. Foi quando Antíoco, derrotado e perseguido pelos habitantes, teve que bater em vergonhosa retirada."
,"3":"Quando estava perto de Ecbátana, chegou-lhe a notícia do que tinha acontecido a Nicanor e à gente de Timóteo."
,"4":"Então, furioso, pensava em fazer pagar aos judeus a injúria sofrida perante aqueles que o tinham posto em fuga. Por isso, mandou o seu cocheiro acelerar a carruagem, seguindo em frente sem parar. Entretanto, o julgamento do Céu já o estava a alcançar. De facto, na sua arrogância, ele tinha dito: «Vou transformar Jerusalém num cemitério de judeus. Basta eu chegar lá!»"
,"5":"O Senhor Deus de Israel, porém, que tudo vê, mandou-lhe uma doença incurável e invisível. Pois logo que acabou de dizer essas palavras, veio-lhe uma forte dor de barriga, uma terrível cólica de intestinos."
,"6":"Era uma coisa justa, porque ele havia torturado as entranhas de outros com muitas e refinadas torturas."
,"7":"Nem assim diminuiu a sua arrogância. Pelo contrário, ficou ainda mais exaltado e, furioso de raiva contra os judeus, mandou correr mais depressa. Aconteceu então que caiu da carruagem que corria precipitadamente e, por causa da queda violenta, todos os seus membros se quebraram."
,"8":"Aquele que, pouco antes, com insolência até desumana, se achava com poderes de dar ordens às ondas do mar, e que se imaginava a pesar na balança as altas montanhas, ficou estendido no chão, e teve de ser levado numa maca. Assim, a todos ele dava mostras evidentes do poder de Deus."
,"9":"A coisa foi tal, que do corpo desse renegado brotavam vermes. Ainda vivo, no meio de sofrimentos e dores, as suas carnes soltavam-se do corpo. Por todo o acampamento não se aguentava o mau cheiro da sua podridão."
,"10":"Aquele que pouco antes parecia capaz de tocar nas estrelas do céu, agora ninguém era capaz de o transportar, por causa do mau cheiro insuportável."
,"11":"Em tal situação, prostrado pela sua doença, Antíoco começou a ceder na sua arrogância. Atormentado cada vez mais pelas dores, chegou a reconhecer o castigo divino,"
,"12":"e já não podendo suportar o seu próprio cheiro, disse: «É justo que o mortal se submeta a Deus e não queira igualar-se à divindade»."
,"13":"Mas esse criminoso rezava ao Soberano, que já não Se compadecia dele. Então jurou"
,"14":"que proclamaria livre a cidade santa, contra a qual antes caminhava apressadamente, para a arrasar e transformar em cemitério."
,"15":"Jurou que daria os mesmos direitos dos atenienses a todos os judeus, sobre quem havia decretado que não mereciam sepultura, e deviam ser lançados com seus filhos para servir de comida às feras e aves de rapina."
,"16":"Jurou que enfeitaria, com os mais belos donativos, o Templo santo, que ele mesmo tinha despojado. Jurou que devolveria, em maior número, todos os objectos sagrados. Jurou que manteria, com as suas rendas pessoais, todas as despesas necessárias para os sacrifícios."
,"17":"Além de tudo isso, jurou que se tornaria judeu e percorreria todos os lugares habitados do mundo, anunciando o poder de Deus."
,"18":"Como as dores não passassem, pois a justa condenação de Deus o tinha atingido, e perdendo as esperanças de cura, Antíoco escreveu aos judeus, em tom de súplica, a seguinte carta:"
,"19":"«Aos ilustríssimos cidadãos judeus. O rei e governador Antíoco manda-vos muitas saudações e deseja saúde e bem-estar."
,"20":"Espero, graças ao Céu, que vós e os vossos filhos estejam bem, e os vossos negócios corram segundo os vossos desejos."
,"21":"Lembro com carinho o vosso respeito e bons sentimentos. Ao voltar da Pérsia, contraí uma grave doença e julguei necessário pensar na segurança pública. "
,"22":"No meu caso, não perdi a esperança. Pelo contrário, espero escapar desta doença."
,"23":"Lembro-me de que meu pai, todas as vezes que partia em campanha para a região do planalto, indicava o seu futuro sucessor."
,"24":"Desse modo, se acontecesse algo inesperado ou se chegasse alguma notícia má, a gente que estava no país não iria agitar-se, pois já saberia a quem fora confiado o governo."
,"25":"Além disso, considerando que os soberanos próximos e vizinhos do nosso reino estão à espera de uma oportunidade e observando o que acontece, nomeio como rei o meu filho Antíoco. É ele que tantas vezes tenho recomendado a muitos de vós, ao ausen-tar-me para as províncias do Norte. A ele escrevi a carta que segue abaixo."
,"26":"Assim, pois, eu vos exorto e vos peço que conserveis para com o meu filho a mesma boa vontade demonstrada para comigo, lembrados de tudo o que de bom fiz por vós, seja em comum para todos, seja em particular para cada um."
,"27":"Estou plenamente convencido de que o meu filho, seguindo a minha decisão, vos tratará com muita compreensão e cordialidade»."
,"28":"E assim, esse assassino e blasfemo, entre dores atrozes, morreu nas montanhas, em terra estrangeira. O seu final foi desastroso, da mesma forma como ele havia tratado a outros."
,"29":"Filipe, seu companheiro de infância, transportou os seus restos. Mas, com medo do filho de Antíoco, Filipe foi para o Egipto, para junto de Ptolomeu Filométor."
}`)
	CurrentBook.AddChapter(10, `{
"1":"O Macabeu, com os seus companheiros, guiados pelo Senhor, reconquistaram o Templo e a cidade de Jerusalém."
,"2":"Demoliram os altares construídos pelos estrangeiros na praça pública e os seus templos."
,"3":"Depois de purificar o santuário, construíram um novo altar para os holocaustos. Tiraram fogo das pedras e ofereceram sacrifícios, após uma interrupção de dois anos. Acenderam também o fogo do altar de incenso e as lâmpadas, e apresentaram os pães."
,"4":"Em seguida prostraram-se por terra e suplicaram ao Senhor que nunca mais os deixasse cair em tais desgraças. Caso voltassem a pecar, que Ele os corrigisse com moderação, sem os entregar nas mãos de bárbaros e blasfemadores."
,"5":"A purificação do Templo aconteceu na mesma data em que tinha sido profanado pelos estrangeiros, isto é, no dia vinte e cinco do mês de Casleu."
,"6":"Durante oito dias, fizeram uma comemoração semelhante à das Tendas, para lembrar que pouco tempo antes, durante a festa das Tendas, eles tiveram de andar pelos montes e cavernas, vivendo como animais selvagens."
,"7":"Por isso, transportando folhagens, ramos novos e folhas de palmeira, cantaram hinos ao Deus que lhes tinha dado a graça de purificar o seu lugar sagrado."
,"8":"Nessa ocasião, editaram um decreto público, confirmado por votação e aprovação geral, mandando que todo o povo judeu celebrasse essa data todos os anos."
,"9":"Foi este o fim de Antíoco, chamado Epifânio."
,"10":"Vamos relatar agora os factos ligados a Antíoco Eupátor, filho desse ímpio, procurando resumir os males causados pelas guerras."
,"11":"Logo que tomou posse do reino, Eupátor nomeou como encarregado da administração um certo Lísias, até então governador e comandante da Celessíria e da Fenícia."
,"12":"Entretanto, Ptolomeu, chamado Macron, que tinha tomado a iniciativa de tratar com justiça os judeus, a fim de reparar a injustiça contra eles cometida, projectava conduzir tranquilamente todos os assuntos que a eles se referiam."
,"13":"Por isso, Ptolomeu foi acusado diante de Eupátor pelos amigos deste rei. Ele era a todo o momento chamado traidor, por ter abandonado Chipre, que lhe fora confiada por Filométor, e por ter passado para o lado de Epifânio. Não conseguindo exercer o poder com toda a dignidade, ele suicidou-se, tomando veneno."
,"14":"Nesse meio tempo, Górgias tornou-se comandante dessas regiões. Ele mantinha um exército mercenário e provocava continuamente guerras contra os judeus."
,"15":"Da mesma forma os idumeus, que ocupavam fortalezas bem situadas, viviam provocando sempre os judeus, e atiçavam o clima de guerra, acolhendo refugiados de Jerusalém."
,"16":"Os companheiros do Macabeu, depois de fazer preces públicas e suplicar a Deus que Se aliasse a eles, atacaram as fortalezas dos idumeus."
,"17":"Assaltaram vigorosamente as fortalezas e conseguiram tomar essas posições, vencendo os inimigos que lutavam de cima da muralha. Mataram quantos estavam ao seu alcance e eliminaram pelo menos vinte mil."
,"18":"Entretanto, pelo menos nove mil conseguiram escapar para duas torres solidamente fortificadas e que tinham tudo para aguentar um cerco prolongado."
,"19":"O Macabeu deixou aí Simão e José, e também Zaqueu com os seus companheiros, o suficiente para manter o cerco, enquanto ele foi para outros lugares, onde a sua presença era mais necessária."
,"20":"Os companheiros de Simão, porém, cheios de ganância por dinheiro, foram subornados por alguns que estavam nas torres: receberam setenta mil dracmas e deixaram-nos fugir."
,"21":"Denunciaram ao Macabeu o que tinha acontecido. Então ele reuniu os chefes do exército e acusou-os de terem vendido os seus irmãos por dinheiro, deixando sair livres os inimigos que combatiam contra eles."
,"22":"Mandou matar os traidores e, sem mais, ocupou as duas torres."
,"23":"O Macabeu tinha sucesso em todas as lutas armadas, e só nessas duas fortalezas eliminou mais de vinte mil homens."
,"24":"Já antes derrotado pelos judeus, Timóteo reuniu numeroso e variado exército estrangeiro, recrutou numerosa cavalaria da Ásia e apareceu para ocupar militarmente a Judeia."
,"25":"Os companheiros do Macabeu reuniram-se com ele para rezar a Deus. Cobriram de pó a cabeça, vestiram-se com panos de saco"
,"26":"e, prostrados no degrau que fica em frente do altar, suplicaram a Deus que lhes fosse favorável, que Se tornasse inimigo dos seus inimigos e adversário dos seus adversários, como a Lei diz claramente."
,"27":"Terminada a oração, pegaram em armas e afastaram-se bastante da cidade. Entretanto, ao chegarem perto dos que vinham combater contra eles, pararam."
,"28":"Mal raiou a madrugada, uns e outros lançaram-se na luta. Uns, além da boa disposição, tinham como garantia de êxito e de vitória a protecção do Senhor. Os outros lutaram guiados pelo seu próprio furor."
,"29":"No auge do combate, os inimigos viram no céu cinco homens resplandecentes, montados em cavalos com rédeas de ouro e que se puseram como comandantes dos judeus."
,"30":"Colocaram o Macabeu no meio deles e protegeram-no com os seus escudos, tornando-o invulnerável, enquanto atiravam setas e raios contra os adversários. Desorientados por não poderem ver, os inimigos dos judeus dispersaram, totalmente confusos."
,"31":"Desta forma, foram eliminados vinte mil e quinhentos homens, além de seiscentos cavaleiros."
,"32":"Timóteo, porém, conseguiu refugiar-se na fortaleza chamada Gazara, que era muito bem fortificada e cujo comandante era Quéreas."
,"33":"Os companheiros do Macabeu, cheios de entusiasmo, cercaram a fortaleza durante quatro dias."
,"34":"Os que estavam dentro, confiando na segurança que o lugar oferecia, multiplicavam as blasfémias, dizendo palavras ímpias."
,"35":"Ao amanhecer do quinto dia, porém, vinte jovens dos companheiros do Macabeu, inflamados por causa dessas blasfémias e cheios de coragem, atacaram a muralha e, com furor selvagem, matavam quem chegasse ao seu alcance."
,"36":"Os demais subiram por outro lado, e, surpreendendo os de dentro, incendiaram as torres, provocando fogueiras e queimando vivos os que blasfemavam. Enquanto isso, os primeiros rebentaram as portas, abrindo caminho ao restante do exército. E conquistaram então a fortaleza."
,"37":"Mataram Timóteo, que se havia escondido numa cisterna, e também seu irmão Quéreas e Apolófanes."
,"38":"Depois de tudo isso, com hinos de acção de graças louvaram ao Senhor, que tinha feito tão grande benefício em favor de Israel, concedendo-lhes essa vitória."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Pouco tempo depois, Lísias, tutor e parente do rei, além de encarregado dos negócios, não suportou o que tinha acontecido."
,"2":"Reuniu oitenta mil soldados com toda a cavalaria, e partiu para enfrentar os judeus. A sua intenção era transformar Jerusalém em morada de gregos,"
,"3":"submeter o Templo a pagar tributo como os outros santuários das nações e, todos os anos, pôr à venda o cargo de sumo sacerdote."
,"4":"Confiando somente nas dezenas de milhares dos seus soldados de infantaria, nos seus milhares de cavaleiros e nos seus oitenta elefantes, nem lhe ocorria pensar no poder de Deus."
,"5":"Logo que entrou na Judeia, aproximou-se da fortaleza de Betsur, a umas cinco léguas de Jerusalém, e cercou-a."
,"6":"Quando os companheiros do Macabeu souberam que Lísias estava a cercar as fortalezas, suplicaram ao Senhor entre gemidos e lágrimas, juntamente com o povo, que mandasse um anjo bom para salvar Israel."
,"7":"O próprio Macabeu foi o primeiro a pegar em armas e a pôr-se à frente de todos. Assim convenceu os outros a enfrentar juntamente com ele o perigo, a fim de levar ajuda aos irmãos. Unidos e cheios de coragem, puseram-se em marcha."
,"8":"Estavam ainda perto de Jerusalém, quando apareceu, marchando à frente deles, um cavaleiro vestido de branco e empunhando armas de ouro."
,"9":"Todos juntos agradeceram ao Deus misericordioso, e ficaram tão animados e corajosos que iam dispostos a atacar não somente homens, mas até as feras mais selvagens e muralhas de ferro."
,"10":"Iam de armas em punho e com um aliado vindo do Céu, pois o Senhor havia-Se compadecido deles."
,"11":"Como leões, atacaram o inimigo e deixaram mortos onze mil soldados de infantaria e mil e seiscentos da cavalaria. Os outros foram obrigados a fugir."
,"12":"Muitos deles, depois de feridos, abandonavam as armas e escapavam. O próprio Lísias, para conservar a vida, teve de fugir vergonhosamente."
,"13":"Como não era tolo, Lísias reflectiu sobre a humilhação que sofrera, e percebeu que os hebreus eram invencíveis, porque o Deus Todo-poderoso lutava ao lado deles."
,"14":"Então mandou representantes, propondo acordo em termos justos, e prometendo convencer o rei a tornar-se amigo deles."
,"15":"O Macabeu, pensando no bem comum, concordou com o que Lísias propunha. E o rei concedeu tudo o que o Macabeu pediu por escrito a Lísias em favor dos judeus."
,"16":"A carta enviada por Lísias aos judeus dizia o seguinte: «De Lísias ao povo judeu. Saudações!"
,"17":"João e Absalão, vossos mensageiros, entregaram-me o documento, solicitando o que aí é proposto."
,"18":"Expliquei ao rei tudo o que era preciso ser explicado. Ele aprovou tudo o que se podia aceitar."
,"19":"Se conservardes boa vontade para com a administração pública, eu também me esforçarei, de ora em diante, por ser advogado dos vossos interesses."
,"20":"Ordenei aos vossos mensageiros e aos meus, que tratem convosco as questões em pormenor."
,"21":"Passai bem! Dia vinte e quatro de Dióscoro do ano cento e quarenta e oito»."
,"22":"A carta do rei dizia o seguinte: «Do rei Antíoco ao seu irmão Lísias. Saudações!"
,"23":"Depois de o nosso pai se ter mudado para junto dos deuses, decidimos que os habitantes do nosso reino podem cuidar dos seus interesses sem sofrerem a menor perturbação."
,"24":"Ouvimos dizer que os judeus não concordaram com a mudança para os costumes gregos, querida por meu pai, mas que preferem a sua própria maneira de viver. E eles estão a pedir autorização para seguir o que é conforme à sua própria Lei."
,"25":"Desejando também que esse povo viva sem temores, decidimos que o Templo lhes seja devolvido e que possam governar-se de acordo com os costumes dos seus antepassados."
,"26":"Por isso, farás muito bem, se mandares alguém até eles para fazer as pazes, a fim de que eles, tomando conhecimento destas nossas disposições, se sintam satisfeitos e alegres, e cuidem apenas dos seus assuntos particulares»."
,"27":"A carta do rei ao povo dizia o seguinte: «Do rei Antíoco ao conselho dos anciãos dos judeus e a todos os judeus. Saudações!"
,"28":"Esperamos que estejais passando bem. Nós também vamos indo bem."
,"29":"Menelau fez-nos ver que vós desejais voltar para cuidar das vossas coisas."
,"30":"Garantimos a imunidade a todos os que voltarem para casa até ao dia trinta do mês de Xântico. Dou permissão"
,"31":"para que esses judeus façam uso dos seus alimentos próprios e também das suas leis, como faziam antigamente. E que nenhum deles seja molestado por causa de faltas cometidas por ignorância."
,"32":"Menelau é o meu mensageiro para vos levar a minha aprovação."
,"33":"Passai bem! Dia quinze do mês de Xântico do ano cento e quarenta e oito»."
,"34":"Os romanos também enviaram aos judeus uma carta que dizia: «De Quinto Mémio, Tito Manílio e Mânio Sérgio, legados romanos, ao povo dos judeus. Saudações!"
,"35":"Nós concordamos com o que Lísias, parente do rei, vos concedeu."
,"36":"Agora, quanto aos pontos que ele determinou levar ao conhecimento do rei, mandai depressa alguém, depois de tudo bem analisado por vós, para nos falar sobre isso, a fim de que possamos apresentar as coisas conforme vos convêm, pois nós estamos indo para Antioquia."
,"37":"Por isso, vinde depressa e mandai alguém para tomarmos conhecimento das vossas propostas."
,"38":"Passai bem! Dia quinze do mês de Xântico do ano cento e quarenta e oito»."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Feitos estes acordos, Lísias voltou para junto do rei, e os judeus voltaram para os seus trabalhos no campo."
,"2":"Os governadores locais, como Timóteo e Apolónio, filho de Geneu, e também Jerónimo e Demofonte, como também Nicanor, governador de Chipre, não os deixavam tranquilos, nem viver em paz."
,"3":"Além disso, os habitantes de Jope chegaram ao extremo da maldade: sem apresentar a menor intenção hostil, convidaram os judeus que viviam com eles a entrarem com as suas mulheres e filhos em barcos que eles mesmos tinham preparado."
,"4":"Como se tratava de um decreto oficial da cidade, e já que os judeus desejavam viver em paz e não tinham nenhuma suspeita, aceitaram o convite. Quando, porém, o barco chegou ao alto mar, aqueles afundaram-no. E eram pelo menos duzentas pessoas."
,"5":"Quando soube da crueldade praticada contra os seus compatriotas, Judas mandou que os seus companheiros se preparassem."
,"6":"Depois de invocar a Deus, o justo Juiz, foi atacar os assassinos dos seus irmãos. À noite incendiou o porto, queimou as barcas, depois de ter passado a fio de espada os que aí se haviam refugiado."
,"7":"Como a cidade estava fechada, Judas foi-se embora, com planos de voltar e eliminar toda a população de Jope."
,"8":"Entretanto, foi informado de que os habitantes de Jâmnia queriam fazer o mesmo aos judeus que moravam na cidade."
,"9":"Então ele atacou Jâmnia de surpresa, também à noite, incendiou o porto e as embarcações, de modo que o clarão do incêndio foi visto até em Jerusalém, a quarenta e cinco quilómetros de distância."
,"10":"Judas havia-se afastado dois quilómetros dali para enfrentar Timóteo, quando pelo menos cinco mil árabes com quinhentos cavaleiros o atacaram."
,"11":"Aconteceu então uma luta violenta, e os companheiros de Judas, com a ajuda de Deus, ainda que menos numerosos, venceram. Os nómadas pediram a paz a Judas. E prometeram dar-lhe gado e ajudá-lo em tudo."
,"12":"Judas, percebendo que eles seriam realmente úteis em muitas coisas, achou conveniente fazer as pazes com eles. Assim, depois de darem as mãos, eles foram-se embora para as suas tendas."
,"13":"Judas atacou uma cidade, chamada Caspin, que era protegida por vales, rodeada de muralhas e habitada por gente de todas as raças."
,"14":"Os que estavam dentro da cidade, confiando na firmeza das muralhas e nos alimentos que tinham de reserva, tornaram-se cada vez mais provocadores para com os companheiros de Judas: zombavam, blasfemavam e diziam palavrões."
,"15":"A gente de Judas, porém, depois de invocar o grande Soberano do universo, que sem aríetes ou máquinas de guerra derrubou os muros de Jericó no tempo de Josué, avançaram como feras contra a muralha."
,"16":"Após tomar a cidade por vontade de Deus, fizeram uma indescritível matança. Um lago vizinho, com mais de quatrocentos metros de largura, parecia cheio de sangue que havia escorrido."
,"17":"Distanciando-se uns cento e quarenta quilómetros daí, chegaram a Cáraca, onde viviam os judeus chamados tubianos."
,"18":"Não encontraram Timóteo nessa região, porque este, não havendo conseguido nada até então, tinha partido, deixando no lugar apenas uma guarnição bem munida."
,"19":"Dositeu e Sosípatro, oficiais do exército do Macabeu, desviaram-se para esse lugar e mataram as tropas deixadas por Timóteo na fortaleza. E eliminaram mais de dez mil homens."
,"20":"O Macabeu dividiu o seu exército em grupos e colocou os dois na chefia desses grupos. Em seguida, partiu para atacar Timóteo, que tinha sob o seu comando cento e vinte mil soldados de infantaria e dois mil e quinhentos cavaleiros."
,"21":"Ao saber que Judas vinha atacá-lo, Timóteo mandou, à sua frente, para o lugar chamado Cárnion, as mulheres e as crianças com as bagagens. A posição era impossível de conquistar, e o local inacessível por causa dos muitos desfiladeiros que lá havia."
,"22":"Logo que apareceu o primeiro grupo do exército de Judas, os inimigos ficaram tomados de medo e apoderou-se deles o pânico, causado pela manifestação d'Aquele que tudo vê. Fugiram então desabaladamente, tropeçando uns nos outros, muitas vezes atrapalhando os próprios companheiros e ferindo-se gravemente com as suas próprias espadas."
,"23":"Judas perseguiu-os com toda a energia, fustigou esses criminosos e eliminou cerca de trinta mil homens."
,"24":"O próprio Timóteo caiu nas mãos dos soldados de Dositeu e Sosípatro. Com esperteza, Timóteo pediu que o deixassem partir com vida, afirmando que tinha em seu poder pais e irmãos de muitos deles, e poderia acontecer que eles fossem mortos."
,"25":"Conseguiu convencer os soldados com muitas palavras, prometendo que devolveria os prisioneiros são e salvos. Então deram-lhe a liberdade em troca da libertação dos irmãos."
,"26":"Em seguida, Judas marchou contra Cárnion e o santuário de Atargates, e matou aí vinte e cinco mil homens."
,"27":"Depois dessa reviravolta e matança, Judas dirigiu-se para o lado de Efron, cidade fortificada, onde moravam Lisânias e uma população de todas as raças. Jovens muito fortes ficavam na frente da muralha para lutar com bravura. Dentro havia máquinas de guerra e muitos projécteis."
,"28":"Após invocarem o Soberano, que com o seu poder esmaga as forças inimigas, tomaram a cidade e mataram vinte e cinco mil dos que nela moravam."
,"29":"Afastando-se daí, foram atacar Citópolis, a mais de cem quilómetros de Jerusalém."
,"30":"Contudo, os judeus que moravam nessa cidade disseram que os cidadãos do lugar demonstravam grande simpatia para com eles e sempre os ajudavam nos momentos difíceis."
,"31":"Então Judas e seus companheiros agradeceram-lhes e pediram que continuassem a ter no futuro a mesma consideração para com os seus irmãos de raça. Depois, voltaram para Jerusalém, bem perto da festa das Semanas."
,"32":"Após a festa denominada Pentecostes, atacaram Górgias, governador da Idumeia."
,"33":"Este saiu para os enfrentar, comandando três mil soldados de infantaria e quatrocentos cavaleiros."
,"34":"Começaram a luta, e alguns judeus caíram mortos."
,"35":"Um certo Dositeu, dos tubianos, fortíssimo soldado de cavalaria, enfrentou Górgias, agarrou-o pelo manto e foi-o arrastando com força, querendo prender vivo o amaldiçoado. Um cavaleiro trácio, porém, atacou Dositeu e cortou-lhe o ombro. Dessa forma, Górgias pôde fugir para Marisa."
,"36":"Os soldados de Esdrin já estavam exaustos de tanto lutar. Então Judas invocou o Senhor, suplicando-Lhe que Se mostrasse aliado e comandante dessa batalha."
,"37":"Em seguida, lançou o grito de guerra na língua materna e, cantando hinos, lançou-se de surpresa contra os soldados de Górgias, obrigando-os a fugir."
,"38":"Após reunir o seu exército, Judas chegou até à cidade de Odolam. No sétimo dia, depois de se purificarem conforme o costume, celebraram o sábado."
,"39":"No dia seguinte, como a tarefa era urgente, os homens de Judas foram recolher os corpos daqueles que tinham morrido na batalha, a fim de os sepultarem ao lado dos parentes, nos túmulos dos seus antepassados."
,"40":"Foi então que encontraram, por baixo das roupas de cada um dos mortos, objectos consagrados aos ídolos de Jâmnia, coisa que a Lei proibia aos judeus. Então ficou claro para todos o motivo da sua morte."
,"41":"E todos louvaram a maneira de agir do Senhor, que julga com justiça e coloca às claras as coisas escondidas."
,"42":"Puseram-se em oração, suplicando que o pecado cometido fosse totalmente cancelado. O nobre Judas pediu ao povo para se afastar do pecado, pois acabavam de ver, com os seus próprios olhos, o que tinha acontecido por causa do pecado daqueles que tinham morrido na batalha."
,"43":"Então fizeram uma colecta individual, reuniram duas mil moedas de prata e mandaram-nas a Jerusalém, a fim de que fosse oferecido um sacrifício pelo pecado. Ele agiu com grande rectidão e nobreza, pensando na ressurreição."
,"44":"Se não tivesse esperança na ressurreição dos que tinham morrido na batalha, seria coisa inútil e tola rezar pelos mortos."
,"45":"Mas, considerando que existe uma bela recompensa guardada para aqueles que são fiéis até à morte, então este era um pensamento santo e piedoso. Por isso, mandou oferecer um sacrifício pelo pecado dos que tinham morrido, para que fossem libertados do pecado."
}`)
	CurrentBook.AddChapter(13, `{
"1":"No ano cento e quarenta e nove, chegou até à gente de Judas a notícia de que Antíoco Eupátor estava a aproximar-se com grande exército para lutar contra a Judeia."
,"2":"Com ele vinha Lísias, que era o seu tutor e primeiro ministro. Os dois comandavam um exército grego de cento e dez mil soldados de infantaria, cinco mil e trezentos cavaleiros, vinte e dois elefantes e trezentos carros armados de foices."
,"3":"Menelau juntou-se a eles e, com muitos elogios, encorajava Antíoco. Ele não pensava na pátria, mas em recuperar o poder."
,"4":"O Rei dos reis, porém, provocou o ódio de Antíoco contra esse criminoso, quando Lísias mostrou que era Menelau o causador de todas essas desgraças. Então o rei mandou que o levassem para a Bereia e aí o matassem, segundo o costume do lugar."
,"5":"Havia ali uma torre de vinte e cinco metros de altura, cheia de cinzas, provida de máquina giratória inclinada de todos os lados em direcção à cinza."
,"6":"Ali são lançados para morrerem os condenados por roubo de coisas sagradas ou por outros crimes maiores."
,"7":"Foi dessa forma que Menelau encontrou a morte, sem merecer nem sequer a terra da sepultura."
,"8":"E isso com plena justiça, pois ele tinha cometido muitos pecados contra o altar, onde não só o fogo, mas até a cinza é pura. E na cinza ele encontrou a morte."
,"9":"O rei vinha com a fúria de um bárbaro, querendo mostrar aos judeus coisas ainda piores que as acontecidas no tempo de seu pai."
,"10":"Sabendo disso, Judas mandou que o povo invocasse dia e noite o Senhor, para que, agora também como em outras vezes, Ele socorresse os que estavam para ser privados da Lei, da pátria e do Templo sagrado;"
,"11":"e não permitisse que pagãos blasfemos submetessem o povo, que mal estava começando a respirar."
,"12":"Todos juntos fizeram isso, suplicando ao Senhor misericordioso com lágrimas, jejuns e prostrados no chão, durante três dias sem parar. Depois, Judas disse-lhes para se prepararem."
,"13":"Privadamente, ele reuniu-se com os anciãos e decidiu que iria sair para a luta, a fim de decidir a questão com a ajuda de Deus, em vez de esperar que o rei invadisse a Judeia com o seu exército e tomasse a cidade."
,"14":"Confiando o êxito ao Criador do mundo, animou os seus companheiros a lutarem nobremente até à morte, pela Lei, pelo Templo, pela cidade, pela pátria e pelos seus direitos de cidadãos. Em seguida, acampou perto de Modin."
,"15":"Deu aos seus comandados a palavra de ordem: «Vitória de Deus!» À noite, acompanhado de alguns jovens escolhidos entre os mais valentes, atacou a tenda do rei no seu próprio acampamento. Matou cerca de dois mil homens e também o maior dos elefantes, juntamente com o soldado que ficava na torrinha em cima do elefante."
,"16":"Em resumo, encheram de terror e confusão o acampamento deles. E foram bem sucedidos,"
,"17":"quando o dia já começava a raiar. Isso aconteceu por causa da protecção do Senhor, que auxiliou Judas."
,"18":"Depois de receber uma amostra da ousadia dos judeus, o rei tentou apoderar-se das suas posições, valendo-se de astúcia."
,"19":"Marchou contra Betsur, uma segura e bem armada fortaleza dos judeus. Mas foi diversas vezes rechaçado, derrotado e vencido."
,"20":"Judas conseguia mandar, para os que estavam dentro da fortaleza, tudo aquilo de que precisavam."
,"21":"Entretanto, um certo Rôdoco, das fileiras judaicas, passava os segredos de guerra para os inimigos. Ele foi procurado, preso e executado."
,"22":"Por uma segunda vez, o rei conferenciou com os que estavam em Betsur. Ofereceu a paz, aliou-se com eles e retirou-se. Atacou os companheiros de Judas, mas foi derrotado."
,"23":"O rei ficou a saber que Filipe, deixado na administração do governo em Antioquia, se tinha revoltado. Desolado, entrou em negociação com os judeus, aliou-se com eles e jurou respeitar todas as condições justas. Feito o acordo, ofereceu um sacrifício, honrou o Templo e teve consideração para com o lugar sagrado."
,"24":"Acolheu o Macabeu e deixou Hegemónida como comandante da região que vai desde Ptolemaida até ao país dos gerrénios."
,"25":"Em seguida, foi para Ptolemaida. Os cidadãos do lugar andavam descontentes com os acordos, pois estavam irritados com aqueles que queriam abolir os seus privilégios."
,"26":"Lísias subiu a um palanque, defendeu-se o melhor que pôde, convenceu-os, acalmou-os, conseguiu a adesão deles, e partiu para Antioquia. Assim terminou a expedição e o regresso do rei."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Três anos depois, os companheiros de Judas souberam que Demétrio, filho de Seleuco, tinha desembarcado no porto de Trípoli com grande exército e uma frota de navios,"
,"2":"e que tinha tomado o país, depois de eliminar Antíoco e o seu tutor Lísias."
,"3":"Um certo Alcimo, que tinha sido sumo sacerdote e se contaminara voluntariamente por ocasião da revolta, percebeu que para ele já não haveria salvação, e que nunca mais lhe seria permitido aproximar-se do altar sagrado."
,"4":"Por volta do ano cento e cinquenta e um, procurou o rei Demétrio, levando-lhe uma coroa de ouro, um ramo de palmeira e alguns dos ramos de oliveira que é costume oferecer no Templo. E nesse dia não pediu nada."
,"5":"Encontrou, porém, uma oportunidade favorável para a sua loucura, quando Demétrio o chamou diante do conselho. Interrogado sobre a disposição e intenções dos judeus, ele respondeu:"
,"6":"«Os judeus chamados assideus, dirigidos por Judas Macabeu, fomentam a guerra e provocam revoltas, impedindo que o reino alcance a desejada estabilidade."
,"7":"Por isso, depois de ter perdido o cargo que recebi de meus pais, isto é, o cargo de sumo sacerdote, aqui me apresento agora."
,"8":"Estou sinceramente querendo, em primeiro lugar, os interesses do rei e, em segundo, os interesses dos meus concidadãos, porque é pela falta de bom senso dos mencionados homens que o nosso povo está a sofrer muito."
,"9":"Desejo que o senhor rei se informe de tudo isso em pormenor e, segundo a sua bondade compreensiva para com todos, assuma o cuidado do país e do nosso povo, que está rodeado de perigos."
,"10":"Enquanto Judas viver, será impossível alcançar a paz»."
,"11":"Dito isto, logo os outros amigos do rei, irritados com os sucessos de Judas, começaram a inflamar Demétrio."
,"12":"Então ele escolheu Nicanor, comandante do batalhão dos elefantes, nomeou-o governador da Judeia e mandou-o para lá."
,"13":"Deu-lhe ordens para matar Judas, dispersar os seus companheiros, e colocar Alcimo como sumo sacerdote do grande Templo."
,"14":"Os pagãos da Judeia, que tinham fugido de Judas, juntaram-se em torno de Nicanor, imaginando que o fracasso e a desgraça dos judeus reverteriam em felicidade para eles."
,"15":"Logo que ouviram falar da expedição de Nicanor e que os pagãos estavam também contra eles, os judeus cobriram a cabeça com terra, começaram a rezar a Deus, que tinha feito deles o seu povo para sempre, e que sempre Se manifestava em socorro daqueles que eram a sua herança."
,"16":"Em seguida, a uma ordem do comandante, saíram imediatamente dali e foram enfrentar os homens de Nicanor no povoado de Dessau."
,"17":"Simão, irmão de Judas, enfrentou Nicanor. Contudo, foi obrigado a ceder por causa do aparecimento inesperado do inimigo."
,"18":"Apesar disso, ouvindo falar da coragem que os companheiros de Judas tinham e da disponibilidade que demonstravam em lutar pela pátria, Nicanor teve receio de resolver a questão com derramamento de sangue."
,"19":"Por isso, mandou Posidónio, Teódoto e Matatias para negociar a paz com os judeus."
,"20":"Depois de amplo debate sobre as condições, cada chefe comunicou-as às suas tropas, e todos concordaram com o tratado de paz."
,"21":"Marcaram a data para uma entrevista privada dos chefes num lugar determinado. De ambos os lados se adiantou uma liteira, e dispuseram cadeiras de honra."
,"22":"Judas, entretanto, tinha distribuído homens armados em lugares estratégicos, prontos para intervir, se o inimigo cometesse alguma traição. A entrevista realizou-se normalmente."
,"23":"Nicanor passou a viver em Jerusalém, mas nada fez de inconveniente. Pelo contrário, licenciou as tropas que, em massa, se haviam juntado a ele."
,"24":"Judas comparecia todos os dias à presença de Nicanor que era interiormente muito favorável a Judas."
,"25":"Nicanor chegou a aconselhar Judas a casar e ter filhos. E Judas casou e viveu feliz como cidadão comum."
,"26":"Alcimo, vendo a amizade entre os dois, pegou numa cópia do acordo que tinham feito e foi procurar Demétrio, para lhe dizer que Nicanor estava com intenções contrárias ao seu governo, pois até havia nomeado como seu sucessor a Judas, o agitador do reino."
,"27":"O rei ficou furioso e, provocado pelas acusações desse perverso, escreveu uma carta a Nicanor, condenando o acordo feito e dizendo que mandasse imediatamente o Macabeu preso para Antioquia."
,"28":"Ao receber essas ordens, Nicanor ficou inteiramente perdido. Era muito difícil para ele desfazer um acordo realizado com uma pessoa que nada tinha praticado de injusto."
,"29":"Contudo, como não podia contrariar as ordens do rei, ficou esperando uma ocasião para cumprir a ordem através de um estratagema."
,"30":"Judas, porém, percebeu que Nicanor o estava tratando com mais frieza, e que as relações normais se haviam tornado difíceis. Desconfiando que esse comportamento ríspido não era bom presságio, reuniu um bom número de companheiros e fugiu de Nicanor secretamente."
,"31":"Nicanor, ao perceber que tinha sido habilmente enganado por Judas, dirigiu-se imediatamente ao grandioso e santo Templo, e deu ordem aos que estavam apresentando os sacrifícios da praxe que entregassem Judas."
,"32":"Eles disseram e juraram que não sabiam onde se poderia encontrar o homem que ele procurava."
,"33":"Então, erguendo a mão na direcção do santuário, Nicanor jurou: «Se não me entregardes Judas preso, eu destruirei esta morada de Deus, demolirei o altar e erguerei aqui um belo templo a Dionísio»."
,"34":"Dito isso, retirou-se. Os sacerdotes, então, ergueram as mãos para o céu e invocaram a Deus, que sempre luta em favor da nossa nação, dizendo:"
,"35":"«Tu, Senhor, que de nada necessitas no mundo, julgaste bem colocar no meio de nós o Templo onde moras."
,"36":"Agora, Senhor santo e fonte de toda a santidade, conserva sempre sem contaminação esta casa que acaba de ser purificada»."
,"37":"Razias, membro do conselho de anciãos em Jerusalém, foi denunciado a Nicanor. Ele era defensor dos seus concidadãos, homem de muito boa fama e, por causa da sua bondade, era chamado «pai dos judeus»."
,"38":"Já havia algum tempo, na época da revolta, que ele também tinha sido acusado de praticar o judaísmo e se haver entregue ao judaísmo de corpo e alma, sem reservas."
,"39":"Nicanor, querendo mostrar hostilidade contra os judeus, mandou mais de quinhentos soldados para prender esse homem."
,"40":"Calculava que estaria dando um duro golpe nos judeus com a sua prisão."
,"41":"Quando as tropas estavam quase a tomar a torre e já forçavam a porta do pátio, foi dada a ordem de deitar fogo para incendiar as portas. Então Razias, sentindo-se cercado por todos os lados, atirou-se sobre a própria espada."
,"42":"Cheio de brio, ele preferiu morrer do que cair nas mãos desses criminosos e ter a sua dignidade insultada da maneira mais baixa."
,"43":"Mas, como o ferimento não foi tão certeiro por causa da precipitação da luta, e como o batalhão já entrava pelos pórticos, ele correu corajosamente até à muralha e valentemente se lançou contra o pelotão de soldados."
,"44":"Todos recuaram rapidamente, abrindo um espaço, onde ele caiu."
,"45":"Capaz ainda de respirar, e com o ânimo inflamado, ele levantou-se, perdendo sangue aos borbotões e, por mais agudas que fossem as dores, correu pelo meio do batalhão. Depois, subindo a uma pedra íngreme,"
,"46":"já completamente sem sangue, arrancou os próprios intestinos e com as duas mãos os atirou contra o pelotão de soldados. Suplicou ao Senhor da vida e do espírito que lhos devolvesse novamente. E morreu."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Nicanor soube que os homens de Judas estavam na Samaria. Então planeou atacá-los de modo seguro no dia do repouso."
,"2":"Alguns judeus, que estavam a ser forçados a acompanhá-lo, disseram: «Não os mates de maneira tão bárbara e selvagem! Respeita este dia, que foi honrado com o nome de santo por Aquele que olha por todas as coisas»."
,"3":"Mas o malvado perguntou se existe Alguém poderoso no céu, que tenha determinado celebrar o dia de sábado!"
,"4":"Eles responderam sem vacilar: «Sim. É o Senhor vivo, o Soberano do céu. Ele mandou celebrar o dia de sábado»."
,"5":"O outro continuou: «Eu sou o soberano da Terra. E ordeno que se pegue em armas e se defendam os interesses do rei». Apesar de tudo, ele não conseguiu levar o seu projecto maligno até ao fim."
,"6":"Nicanor, cheio de arrogância, pretendia fazer um troféu colectivo com as coisas que tomaria aos homens de Judas."
,"7":"Enquanto isso, o Macabeu não perdia a confiança, esperando receber do Senhor o socorro."
,"8":"Procurou animar os seus companheiros, para que não tivessem medo do ataque dos pagãos, mas que lembrassem os auxílios que o Céu lhes tinha concedido, e esperassem também agora a vitória que o Todo-poderoso lhes ia conceder."
,"9":"Em seguida, animou-os com textos da Lei e dos Profetas, e, recordando também as lutas pelas quais já tinham passado, tornou-os ainda mais entusiasmados."
,"10":"Depois de os animar, deu-lhes instruções, chamando-lhes a atenção para a falta de palavra dos pagãos que tinham violado os acordos."
,"11":"Tendo armado cada um dos seus soldados, não tanto com a segurança oferecida pelos escudos e lanças, mas principalmente com a força das boas palavras, Judas ainda lhes contou um sonho digno de fé, uma espécie de visão, que muito os alegrou."
,"12":"No sonho, ele viu o seguinte: Onias, o antigo sumo sacerdote, homem recto e bom, respeitoso no encontro com as pessoas, manso no comportamento, precavido e delicado no falar, e bem educado desde criança em todo o seu comportamento virtuoso, esse homem, de mãos erguidas, rezava em favor de toda a comunidade judaica."
,"13":"Da mesma forma, apareceu outra personagem extraordinária pela sua velhice e dignidade, envolta num clarão de majestade maravilhosa."
,"14":"Então Onias disse: «Este é o amigo dos seus irmãos, que está sempre a rezar muito pelo povo e pela cidade santa. É Jeremias, o profeta de Deus»."
,"15":"Então Jeremias estendeu a mão direita e entregou a Judas uma espada de ouro, dizendo:"
,"16":"«Recebe a espada santa, que é dom de Deus. Com ela, destruirás os inimigos»."
,"17":"Animados com as palavras de Judas, realmente belas e capazes de encorajar e encher de valentia o ânimo dos jovens, os judeus resolveram não continuar acampados, mas tomar ousadamente a ofensiva. Assim, lutando com toda a valentia, resolveram decidir a questão através das armas, pois tanto a cidade como a religião e o Templo corriam perigo."
,"18":"A preocupação deles não eram tanto as suas mulheres e crianças, irmãos e parentes. Eles preocupavam-se sobretudo com o Templo consagrado."
,"19":"Entretanto, não era menor a preocupação dos que tinham ficado na cidade, com medo da batalha em campo aberto."
,"20":"Enquanto todos estavam esperando o desfecho iminente, o inimigo concentrava-se, alinhando o exército para a batalha, colocando os elefantes em pontos estratégicos e distribuindo a cavalaria pelas alas."
,"21":"Ao ver as divisões do exército que se apresentavam, os vários tipos de armas e o aspecto selvagem dos elefantes, o Macabeu elevou as mãos para o céu e suplicou ao Senhor que faz prodígios, certo de que Ele concede a vitória aos que dela são dignos, não pelas armas, mas pelo meio que Ele mesmo deseja."
,"22":"Na sua oração, Judas disse: «Senhor, Tu mandaste, em favor do rei Ezequias de Judá, o teu mensageiro que eliminou do acampamento de Senaquerib cento e oitenta e cinco mil homens."
,"23":"Agora, Soberano do céu, envia um anjo bom à nossa frente para provocar terror e tremor."
,"24":"Que a grandeza do teu braço quebre aqueles que blasfemaram contra o teu povo santo». E assim terminou a sua oração."
,"25":"Os homens de Nicanor marchavam ao som das trombetas e gritos de guerra."
,"26":"Os de Judas, pelo contrário, foram-se infiltrando no meio dos inimigos, fazendo invocações e preces."
,"27":"Combatiam com as mãos e rezavam com o coração, deixando mais de trinta e cinco mil homens estendidos por terra. E transbordaram de alegria pela clara manifestação de Deus."
,"28":"Terminada a batalha, quando já se retiravam cheios de alegria, reconheceram Nicanor caído, com a sua armadura."
,"29":"No meio de gritarias e alvoroço, louvavam o Senhor na língua materna."
,"30":"Judas que sempre fora, de corpo e alma, o primeiro na luta pelos seus concidadãos e que nunca perdera a sua afeição juvenil para com os seus compatriotas, mandou cortar a cabeça e o braço de Nicanor, levando-os para Jerusalém."
,"31":"Chegando a Jerusalém, convocou os concidadãos e sacerdotes. E de pé, diante do altar, mandou chamar os que ocupavam a fortaleza."
,"32":"Então mostrou a cabeça do imundo Nicanor e a mão que o blasfemador tinha erguido, com toda a arrogância, contra a morada santa do Todo-poderoso."
,"33":"Arrancou a língua do desalmado Nicanor e mandou-a cortar em pedaços para os passarinhos. O braço, símbolo da sua loucura, mandou-o pendurar em frente do Templo."
,"34":"Todos elevaram os olhos ao céu, louvando o Senhor glorioso e dizendo: «Bendito seja Aquele que conservou sem contaminação o seu lugar sagrado»."
,"35":"Judas mandou pendurar na fortaleza a cabeça de Nicanor, como prova visível e clara da ajuda do Senhor."
,"36":"Então todos decidiram, de comum acordo, que esse dia nunca mais passaria despercebido, mas que seria sempre comemorado no dia treze do mês doze, em aramaico o mês de Adar, ou seja, na véspera do dia de Mardoqueu."
,"37":"Assim terminou a história de Nicanor. A partir desse tempo, a cidade passou a ser governada pelos hebreus. Por isso, aqui encerro a minha narrativa. "
,"38":"Se ficou boa e literariamente agradável, era o que eu queria. Se está fraca e medíocre, é o que fui capaz de fazer."
,"39":"É desagradável beber só vinho ou só água, ao passo que vinho misturado com água é agradável e gostoso. O mesmo acontece numa obra literária, onde o tempero do estilo é um prazer para o ouvido do leitor. E assim termino."
}`)

}
func PT_BS_LoadVH2PChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Salomão, filho de David, firmou-se na realeza. Javé, seu Deus, estava com ele e engrandeceu-o muito."
,"2":"Salomão convocou todo o Israel, os comandantes de mil e comandantes de cem, os juízes, todos os príncipes de Israel e os chefes de família."
,"3":"Com toda essa assembleia, Salomão foi até ao lugar alto de Gabaon, onde estava a Tenda da Reunião de Deus, feita no deserto por Moisés, servo de Javé."
,"4":"Quanto à Arca de Deus, David tinha-a transferido de Cariat-Iarim para o lugar por ele preparado; pois tinha feito para ela uma tenda em Jerusalém."
,"5":"O altar de bronze, feito por Beseleel, filho de Uri, filho de Hur, ficava diante da Habitação de Javé, aonde Salomão e a assembleia iam para consultar a Deus."
,"6":"Foi aí que Salomão, diante de Javé, subiu ao altar de bronze que estava diante da Tenda da Reunião, e ofereceu mil holocaustos."
,"7":"Nessa noite, Deus apareceu a Salomão e disse-lhe: «Pede o que quiseres»."
,"8":"Salomão respondeu a Deus: «Tu trataste com muito amor o meu pai David e colocaste-me como rei no lugar dele."
,"9":"Agora, Javé Deus, mantém a promessa que fizeste ao meu pai David, porque me puseste como rei sobre um povo tão numeroso como o pó da terra."
,"10":"Concede-me, então, sabedoria e conhecimento, para que eu possa conduzir bem este povo. De contrário, quem poderia governar este teu povo tão numeroso?»"
,"11":"Então Deus disse a Salomão: «Já que desejas isso, e não pediste riqueza, fortuna e glória, nem a morte dos inimigos ou muitos anos de vida para ti mesmo, mas pediste sabedoria e conhecimento para governar o meu povo, do qual Eu te fiz rei,"
,"12":"então receberás sabedoria e conhecimento. Além disso, Eu dou-te também riqueza, fortuna e glória, como nenhum dos teus antecessores teve, nem os teus sucessores terão»."
,"13":"Depois disto, Salomão saiu da Tenda da Reunião e voltou de Gabaon para Jerusalém. E reinou em Israel."
,"14":"Salomão reuniu carros e cavaleiros. Tinha mil e quatrocentos carros e doze mil cavaleiros, que ficavam nas cidades dos carros e junto do rei em Jerusalém."
,"15":"Salomão fez com que a prata e o ouro fossem tão comuns em Jerusalém como as pedras, e os cedros como os sicômoros da Planície."
,"16":"Os cavalos de Salomão eram importados do Egipto e da Cilícia, onde os mercadores do rei os compravam com pagamento à vista."
,"17":"Cada carro era importado do Egipto por seis quilos e meio de prata, e cada cavalo por um quilo e meio. Os cavalos eram exportados, nas mesmas condições, para os reis dos heteus e os reis de Aram."
,"18":"Salomão mandou construir um Templo para o Nome de Javé e um palácio real para si."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Recrutou setenta mil carregadores de pedra, oitenta mil arrancadores de pedra da montanha e três mil e seiscentos capatazes para fiscalizar os serviços."
,"2":"Salomão mandou a seguinte mensagem a Hiram, rei de Tiro: «Tempos atrás, enviaste cedro para que o meu pai David construísse uma casa para ele morar."
,"3":"Agora, eu resolvi construir um Templo para o Nome de Javé meu Deus, para Lho consagrar, a fim de queimar em sua honra o perfume do incenso, fazer as oferendas permanentes dos pães oferecidos a Deus, oferecer os holocaustos de manhã e de tarde, nos sábados, luas novas e festas de Javé nosso Deus. E assim se fará sempre em Israel."
,"4":"O Templo que pretendo construir deverá ser grande, porque o nosso Deus é o maior de todos os deuses."
,"5":"Quem se atreveria a construir um templo para Ele, quando o céu e o mais alto do céu são pequenos para contê-l'O? E quem sou eu, para Lhe construir um templo, ainda que seja só para queimar incenso na sua presença?"
,"6":"Agora, pois, peço que me mandes um homem competente para trabalhar em ouro, prata, bronze e ferro, e também com tecidos de púrpura, carmesim e damasco, e que seja entendido em fazer esculturas. Ele trabalhará com os outros mestres que já se encontram aqui comigo em Judá e Jerusalém, contratados pelo meu pai David."
,"7":"Peço também que me mandes madeira de cedro, carvalho e pinho do Líbano, pois eu sei que os teus servos são competentes para cortar madeira do Líbano. Os meus servos trabalharão juntamente com os teus,"
,"8":"para prepararem grande quantidade de madeira, porque o Templo que vou construir será grande e maravilhoso."
,"9":"Eu sustentarei os lenhadores com vinte mil sacas de trigo, vinte mil sacas de cevada, vinte mil barris de vinho e vinte mil barris de azeite»."
,"10":"Hiram, rei de Tiro, respondeu a Salomão com esta carta: «Javé ama o seu povo e, por isso, colocou-te como rei sobre ele»."
,"11":"A carta continuava: «Seja bendito Javé, o Deus de Israel. Ele fez o Céu e a Terra, deu ao rei David um filho sábio, sensato e prudente, capaz de construir um Templo para Javé e um palácio para si próprio."
,"12":"Estou a enviar-te Hiram-Abi, homem hábil e prudente,"
,"13":"filho de uma danita e de pai tírio. Ele é especialista no trabalho em ouro, prata, bronze, ferro, pedra, madeira, tecidos de púrpura, damasco, linho, carmesim, e também na arte de qualquer tipo de escultura. Ele executará todos os projectos que lhe derem, juntamente com os teus mestres e com os mestres de teu pai David, meu senhor."
,"14":"Quanto ao trigo, à cevada, ao óleo e ao vinho de que o meu senhor falou, podes mandá-los para os teus servos."
,"15":"Vamos cortar toda a madeira do Líbano de que precisas e vamos mandá-la embarcada por mar até Jope. Depois levá-la-ás até Jerusalém»."
,"16":"Salomão fez o recenseamento de todos os imigrantes que residiam no país de Israel, recenseamento esse posterior ao que tinha feito seu pai David. Encontrou cento e cinquenta e três mil e seiscentos homens."
,"17":"Destinou setenta mil para o transporte, oitenta mil para trabalhar nas pedreiras da montanha e três mil e seiscentos para fiscalizar o trabalho do pessoal."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salomão começou a construir o Templo de Javé em Jerusalém, no monte Moriá. Aí seu pai David tivera uma visão, no lugar que havia preparado na eira de Ornã, o jebuseu."
,"2":"Salomão começou a construir no segundo mês do quarto ano do seu reinado."
,"3":"Estas foram as medidas determinadas por Salomão para a construção do Templo de Deus: trinta metros de comprimento por dez de largura."
,"4":"O vestíbulo da frente, no sentido da largura do Templo, tinha dez metros de comprimento, cinco de profundidade e dez de altura. Salomão revestiu de ouro todo o seu interior."
,"5":"E mandou revestir a nave maior com madeira de carvalho, que recobriu de ouro puro, e no ouro mandou esculpir ramos de palmeira e cordões."
,"6":"Fez decorar o Templo com pedras preciosas de grande beleza. O ouro utilizado era de Parvaim."
,"7":"Com esse ouro, recobriu a nave, os travamentos, os portais, as paredes e as portas. Nas paredes mandou esculpir querubins."
,"8":"Construiu também o Santíssimo. Tinha dez metros de comprimento, acompanhando a largura do Templo, por dez de largura. Recobriu-o com vinte toneladas de ouro puro."
,"9":"Os pregos de ouro pesavam meio quilo. Revestiu de ouro as salas superiores."
,"10":"Salomão mandou também fundir, para o recinto do Santíssimo, dois querubins de metal, revestidos de ouro."
,"11":"As asas dos querubins tinham dez metros de comprimento; a asa do primeiro tinha dois metros e meio e tocava a parede interior do edifício. A outra asa, também com dois metros e meio, tocava na asa do segundo querubim."
,"12":"Uma asa do segundo querubim tocava na parede do outro lado. E a outra asa, com dois metros e meio, tocava na asa do primeiro querubim."
,"13":"Assim, as asas dos dois querubins cobriam uma extensão de dez metros. Os querubins estavam de pé e com o rosto voltado para dentro."
,"14":"Salomão mandou fazer a cortina de púrpura violeta e escarlate, de carmesim e de linho puro, com querubins bordados nela."
,"15":"Diante da nave mandou fazer duas colunas de dezassete metros e meio de altura, com capitéis de dois metros e meio."
,"16":"Fez também cordões em forma de colar, e colocou-os nos capitéis; fez também cem romãs, e colocou-as nos cordões."
,"17":"Colocou as colunas na entrada do Templo, uma à esquerda e outra à direita. À coluna da direita deu o nome de Firme, e à da esquerda o nome de Forte."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Salomão mandou fazer também um altar de bronze com dez metros de comprimento por dez de largura e cinco de altura."
,"2":"Fez também o Mar de metal fundido, redondo, com cinco metros de diâmetro e dois metros e meio de altura, com quinze de circunferência."
,"3":"Por baixo da borda, em todo o redor, havia animais semelhantes a bois. Eram duas fileiras de touros, vinte em cada metro, fundidas numa peça única."
,"4":"O Mar apoiava-se sobre doze touros, três voltados para o Norte, três para o Poente, três para o Sul e três para o Nascente. O Mar ficava em cima deles, e a parte traseira dos touros ficava voltada para dentro."
,"5":"As paredes do Mar tinham a espessura de um palmo, enquanto a borda, de tão fina, parecia a borda de uma taça e era igual a uma flor. A capacidade do Mar era de cento e trinta e cinco mil litros."
,"6":"Fez também dez bacias. Colocou cinco de cada lado, para aí lavarem as vítimas dos holocaustos. Os sacerdotes lavavam-se no Mar."
,"7":"Mandou fazer ainda os dez candelabros de ouro, conforme estava determinado, e colocou-os no Santo, de um lado e do outro."
,"8":"Fez as dez mesas, e colocou-as no Santo, cinco de cada lado. Fez também cem bacias de ouro para a aspersão."
,"9":"Construiu o pátio dos sacerdotes e o grande pátio com as suas portas, e recobriu-as de bronze."
,"10":"Colocou o Mar no lado direito, a Sudeste."
,"11":"Hiram fez os recipientes para as cinzas, e também as pás e as bacias para a aspersão. E terminou tudo o que o rei Salomão tinha encomendado para o Templo de Deus:"
,"12":"as duas colunas; os dois rolos de capitéis no alto das colu-nas; os dois entrançados para cobrir os dois rolos que estavam no alto das colunas;"
,"13":"as quatrocentas romãs para os dois entrançados, visto que as romãs de cada entrançado ficavam em duas fileiras;"
,"14":"as dez bases e as dez bacias;"
,"15":"o Mar único com os dois touros que o sustentavam;"
,"16":"os recipientes para as cinzas, e também as pás, os garfos e todos os outros acessórios que Hiram-Abi fez de bronze polido, a pedido do rei Salomão, para o Templo de Javé."
,"17":"Tudo isso o rei mandou fundir em terra argilosa na planície do Jordão, entre Sucot e Sardata."
,"18":"Salomão fez tudo em grande quantidade, pois tinha tanto bronze que não era possível calculá-lo."
,"19":"Portanto, foi Salomão quem fez todos os objectos para o Templo de Deus, como o altar de ouro e as mesas para colocar os pães oferecidos a Deus;"
,"20":"os candelabros de ouro puro com as suas lâmpadas, que deviam ficar sempre acesas diante do Santíssimo, conforme as normas;"
,"21":"as flores, as lâmpadas e as tenazes de ouro puro;"
,"22":"as facas, as bacias de aspersão, as taças e os incensórios de ouro puro. Fez também de ouro os gonzos das portas do Santíssimo e do Santo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Depois de terminar tudo o que fez para o Templo do Senhor, Salomão mandou levar para o Templo aquilo que o seu pai David tinha consagrado: a prata, o ouro e todos os utensílios. E colocou-os no tesouro do Templo de Deus."
,"2":"Salomão reuniu em Jerusalém todos os anciãos de Israel, todos os chefes das tribos e os chefes das famílias israelitas, para transportar, da cidade de David, que é Sião, a Arca da Aliança de Javé."
,"3":"Para a festa, todos os israelitas se reuniram com o rei no sétimo mês."
,"4":"Chegaram todos os anciãos de Israel, e quem transportou a Arca foram os levitas."
,"5":"Transportaram a Arca e a Tenda da Reunião, e também os utensílios sagrados que estavam na Tenda. Tudo foi transportado pelos sacerdotes levitas."
,"6":"O rei Salomão e toda a comunidade de Israel, reunida com ele diante da Arca, sacrificou tantas ovelhas e bois, que não foi possível contá-los nem calculá-los."
,"7":"Os sacerdotes introduziram a Arca da Aliança de Javé no seu lugar próprio, isto é, no Debir do Templo, quer dizer, no Santíssimo, sob as asas dos querubins."
,"8":"Os querubins estendiam as asas sobre o local da Arca, protegendo a Arca e os seus varais."
,"9":"Como os varais eram compridos, quem estava no Santo, diante do Santíssimo, podia ver as suas extremidades, mas não se podiam ver de fora. Eles lá estão até hoje."
,"10":"Dentro da Arca não havia nada além das duas tábuas que, no Horeb, Moisés lá havia colocado quando Javé concluiu a aliança com os israelitas, na ocasião em que eles saíram do Egipto."
,"11":"Todos os sacerdotes que estavam no Santuário se haviam purificado, sem distinção de classes. Quando os sacerdotes saíram do Santuário,"
,"12":"todos os levitas cantores das famílias de Asaf, de Emã e de Iditun, com seus filhos e irmãos, estavam vestidos de linho fino e tocavam címbalos, lira e cítara, todos de pé, a Leste do altar. Com eles havia cento e vinte sacerdotes que tocavam trombetas."
,"13":"Como se fossem um só, os tocadores de trombeta e os outros músicos puseram-se a tocar juntos, celebrando a Javé. Quando levantaram a voz ao som das trombetas, címbalos e outros instrumentos, celebrando a Javé, «porque Ele é bom, porque o seu amor é para sempre», o Templo encheu-se com a nuvem da glória de Javé."
,"14":"Por causa da nuvem, os sacerdotes não puderam continuar o culto, pois a glória de Javé tinha ocupado inteiramente o Templo de Deus."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Então Salomão disse: «Javé escolheu habitar a Nuvem escura."
,"2":"Eu construí-Te uma casa sublime, uma casa onde habitarás para sempre»."
,"3":"O rei voltou-se, e abençoou toda a assembleia de Israel, enquanto todos permaneciam de pé."
,"4":"O rei disse então: «Seja bendito Javé, o Deus de Israel, que realizou com a mão o que a sua boca havia prometido ao meu pai David:"
,"5":"'Desde o dia em que tirei o meu povo do Egipto, não escolhi nenhuma cidade dentre todas as tribos de Israel, a fim de lá construir um Templo para o meu Nome. Como também não escolhi um homem para ser chefe do meu povo Israel."
,"6":"Mas escolhi Jerusalém para lá fazer morar o meu Nome. Escolhi David para ser o chefe do meu povo Israel'."
,"7":"O meu pai David queria construir um Templo para o Nome de Javé, o Deus de Israel."
,"8":"Javé, porém, disse ao meu pai David: 'Projectaste construir um Templo para o meu Nome, e fazes muito bem em querer isso."
,"9":"Contudo, não és tu que vais construir o Templo, mas o teu filho, saído das tuas entranhas, ele é que vai construir o Templo para o meu Nome'."
,"10":"E Javé realizou a promessa que havia feito: eu sucedi ao meu pai David, e subi ao trono de Israel, como Javé havia prometido, e construí o Templo para o Nome de Javé, Deus de Israel."
,"11":"Nele coloquei a Arca, onde se acha a Aliança que Javé fez com os israelitas»."
,"12":"Salomão ficou de pé diante do altar de Javé, na presença de toda a assembleia de Israel, e estendeu as mãos."
,"13":"Salomão tinha mandado fazer, no meio do pátio do Templo, um estrado de bronze com dois metros e meio de largura e um metro e meio de altura. Subiu ao estrado e ajoelhou-se diante de toda a assembleia de Israel. Estendeu as mãos para o céu,"
,"14":"e disse: «Javé, Deus de Israel, não existe nenhum Deus como Tu, nem lá no alto céu, nem aqui em baixo na terra. Tu és fiel à aliança e ao amor para com os teus servos que caminham de todo o coração diante de Ti."
,"15":"Cumpriste a promessa que havias feito ao teu servo David, meu pai, e o que prometeste com a boca, hoje realizaste-o com a mão."
,"16":"Agora, Javé, Deus de Israel, mantém esta promessa que fizeste ao teu servo David, meu pai: 'Nunca te faltará, diante de Mim, um descendente no trono de Israel, contanto que os teus filhos saibam comportar-se de acordo com a minha lei, assim como tu te comportaste diante de Mim'."
,"17":"Portanto, Javé, Deus de Israel, confirma agora a promessa que fizeste ao teu servo David."
,"18":"É possível que Deus habite com os homens na Terra? Se o Céu e o mais alto do Céu não O podem conter, muito menos este Templo que construí!"
,"19":"Atende a oração e a súplica do teu servo, Javé meu Deus! Ouve o clamor e a prece que o teu servo faz diante de Ti."
,"20":"Que os teus olhos fiquem abertos dia e noite sobre este Templo, sobre este lugar, onde prometeste que o teu Nome iria habitar. Ouve a prece que o teu servo fará neste lugar»."
,"21":"«Ouve as súplicas do teu servo e do teu povo Israel, quando rezarem neste lugar. Escuta da tua morada no Céu! Ouve e perdoa!"
,"22":"Quando alguém pecar contra o seu próximo e, porque lhe foi exigido um juramento imprecatório, vier jurar diante do teu altar neste Templo,"
,"23":"ouve do Céu e age. Julga os teus servos: condena o culpado, dando-lhe o que merece, e absolve o inocente, tratando-o conforme a justiça dele."
,"24":"Quando o teu povo Israel, por ter pecado contra Ti, for derrotado pelo inimigo, se ele se converter, confessar o teu Nome, rezar e Te suplicar neste Templo,"
,"25":"ouve do Céu, perdoa o pecado do teu povo Israel, e faz com que ele volte para a terra que deste aos seus antepassados."
,"26":"Quando o céu se fechar e não houver chuva, por terem pecado contra Ti, se eles rezarem neste lugar, se confessarem o teu Nome e se arrependerem do próprio pecado porque os afligiste,"
,"27":"ouve do Céu, perdoa o pecado dos teus servos e do teu povo Israel, mostrando-lhes o bom caminho que devem seguir, e rega com a chuva a terra que deste como herança ao teu povo."
,"28":"Quando o país sofrer fome, peste, mela e ferrugem; quando vierem gafanhotos e pulgões; quando o inimigo deste povo cercar alguma das suas cidades; quando houver qualquer calamidade ou epidemia;"
,"29":"seja qual for a oração ou súplica de um indivíduo ou de todo o teu povo Israel, se sentirem remorso de consciência e dor, e erguerem as mãos para este Templo,"
,"30":"ouve do Céu onde moras, perdoa e paga conforme o comportamento de cada um, pois conheces o coração; és o único que conhece o coração dos homens."
,"31":"Desse modo Te respeitarão, e seguirão os teus caminhos em todos os dias que viverem sobre a terra que deste aos nossos antepassados."
,"32":"O estrangeiro, que não pertence ao teu povo Israel, se também ele vier de uma terra distante por causa da grandeza do teu Nome, da tua mão forte e do teu braço estendido, se ele vier orar neste Templo,"
,"33":"ouve do Céu onde moras, atende todos os pedidos do estrangeiro. Assim, todos os povos da terra reconhecerão o teu Nome e Te temerão, como faz o teu povo Israel; eles saberão que o teu Nome é invocado neste Templo que eu construí."
,"34":"Se o teu povo sair para guerrear contra os inimigos, e se no caminho em que o mandares, ele Te rezar voltado para a cidade que escolheste e para o Templo que construí para o teu Nome,"
,"35":"ouve do Céu a sua oração e súplica e faz-lhe justiça."
,"36":"Quando pecarem contra Ti, pois não há ninguém que não peque, e Tu ficares irritado contra eles, entregando-os ao inimigo, e então eles forem levados como cativos pelos vencedores para uma terra distante ou próxima;"
,"37":"se eles caírem em si na terra para onde tiverem sido levados, se se arrependerem e suplicarem na terra do seu exílio, dizendo: 'Pecámos, agimos mal e pervertemo-nos';"
,"38":"se eles se voltarem para Ti de todo o coração e de toda a alma, na terra do seu exílio, para onde tiverem sido deportados, e se rezarem voltados para a Terra que deste aos seus antepassados, para a cidade que escolheste e para o Templo que construí ao teu Nome,"
,"39":"ouve do Céu, onde moras, ouve a sua oração e súplica, fazendo-lhes justiça. Perdoa ao teu povo que pecou contra Ti."
,"40":"Agora, meu Deus, que os teus olhos estejam abertos e os teus ouvidos fiquem atentos às súplicas que forem feitas neste lugar."
,"41":"E agora, levanta-Te, Javé Deus, e vem para o teu repouso com a tua poderosa Arca. E os teus sacerdotes, Javé Deus, revistam-se de gala, e os teus fiéis exultem de alegria!"
,"42":"Javé Deus, não Te afastes do teu ungido. Lembra-Te do amor do teu servo David»."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Logo que Salomão terminou a sua oração, desceu fogo do céu e queimou o holocausto e os sacrifícios. E a glória de Javé encheu o Templo."
,"2":"Os sacerdotes não puderam entrar, porque a glória de Javé enchia o Templo de Javé."
,"3":"Ao ver o fogo que descia do céu e a glória de Javé que repousava sobre o Templo, todos os os israelitas se prostraram, com o rosto em terra sobre o pavimento, adorando e louvando a Javé, «porque Ele é bom, porque o seu amor é para sempre»."
,"4":"O rei e todo o povo ofereceram sacrifícios diante de Javé."
,"5":"O rei Salomão ofereceu em sacrifício vinte e dois mil bois e cento e vinte mil ovelhas. Foi assim que o rei e todo o povo inauguraram o Templo de Deus."
,"6":"Os sacerdotes executavam as suas funções e os levitas celebravam a Javé com os instrumentos musicais feitos pelo rei David para acompanhar os cânticos de Javé, «porque o seu amor é para sempre». Eram eles que executavam os louvores compostos por David. Ao lado deles, sacerdotes tocavam trombetas e todo o Israel permanecia de pé."
,"7":"Salomão consagrou o interior do pátio que fica diante do Templo de Javé. Ali ofereceu holocaustos e a gordura dos sacrifícios de comunhão, porque o altar de bronze que Salomão tinha feito era muito pequeno para conter os holocaustos, a oblação e as gorduras dos sacrifícios de comunhão."
,"8":"Nessa ocasião, Salomão celebrou a festa, e todo o Israel com ele, durante sete dias: havia uma grande assembleia, desde a entrada de Emat até à Torrente do Egipto."
,"9":"No oitavo dia, fizeram uma reunião solene. A inauguração do altar tinha durado sete dias, e também a festa tinha durado sete dias."
,"10":"No dia vinte e três do sétimo mês, o povo voltou para casa. Todos voltaram com o coração alegre e feliz por causa de todo o bem que Javé tinha feito a David, a Salomão e ao seu povo Israel."
,"11":"Salomão acabou de construir o Templo de Javé, o palácio real e tudo o que pretendia fazer para o Templo de Javé e para o palácio."
,"12":"Então Javé apareceu-lhe de noite, e disse-lhe: «Ouvi a tua oração e escolhi este lugar para Mim como a casa dos sacrifícios."
,"13":"Quando Eu fechar o céu e não cair chuva; quando Eu ordenar aos gafanhotos que devorem o país; quando mandar a peste contra o meu povo,"
,"14":"se o meu povo, sobre quem foi invocado o meu Nome, se humilhar, suplicando e procurando a minha presença, e se arrepender do seu mau comportamento, Eu ouvirei, do Céu, perdoarei os seus pecados e curarei o seu país."
,"15":"De agora em diante, os meus olhos ficarão abertos e os meus ouvidos estarão atentos à oração feita neste lugar."
,"16":"Escolhi e consagrei este Templo para que o meu Nome esteja para sempre neste lugar: os meus olhos e o meu coração estarão nele para sempre."
,"17":"Quanto a ti, se te comportares diante de Mim como o teu pai David, e agires conforme tudo o que ordenei e observares os meus estatutos e normas,"
,"18":"Eu manterei firme para sempre o teu trono real, como Me comprometi com o teu pai David, quando lhe disse: 'Nunca faltará alguém da tua família para governar Israel'."
,"19":"Contudo, se Me abandonardes, e deixardes de lado os meus estatutos e mandamentos que coloquei diante dos vossos olhos, para servirdes e prestardes culto a outros deuses,"
,"20":"então Eu arrancar-vos-ei da terra que vos dei; afastarei para longe de Mim este Templo que consagrei ao meu Nome, e farei dele objecto de riso e escárnio entre todos os povos."
,"21":"Este Templo tão sublime será motivo de espanto para todos os que por aqui passarem. Eles dirão: 'Porque é que Javé fez isto a esta Terra e este Templo?'"
,"22":"E responderão: 'Foi porque abandonaram Javé, o Deus de seus antepassados, que os havia tirado da terra do Egipto. Eles aderiram a outros deuses, prostrando-se diante deles e servindo-os. Foi por isso que Javé, seu Deus, mandou sobre eles toda esta desgraça'»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Vinte anos após ter construído o Templo de Javé e o seu próprio palácio,"
,"2":"Salomão reconstruiu também as cidades que Hiram lhe tinha dado, e colocou israelitas para nelas habitarem."
,"3":"Depois Salomão atacou Emat de Soba e conquistou-a."
,"4":"Reformou também Tadmor, no deserto, e todas as cidades-entrepostos que tinha construído no país de Emat."
,"5":"Depois reformou Bet-Horon superior e Bet-Horon inferior, cidades protegidas com muralhas, portas e trancas."
,"6":"Reformou também Baalat e todas as cidades-entrepostos pertencentes a Salomão, as cidades para guardar os carros e cavalos, e tudo o que julgou necessário construir em Jerusalém, no Líbano e nos países que lhe eram submissos."
,"7":"Toda a população que restava dos heteus, amorreus, ferezeus, heveus e jebuseus, que não eram israelitas"
,"8":"e tinham ficado depois deles no país, e que os israelitas não haviam consagrado ao extermínio, Salomão recrutou-os para os trabalhos forçados até hoje."
,"9":"Salomão, porém, não utilizou, como escravo para as suas obras, nenhum dos israelitas, pois estes serviam como soldados: eram chefes dos seus oficiais, comandantes dos seus carros e da sua cavalaria."
,"10":"Eram duzentos e cinquenta os chefes dos inspectores do rei Salomão, encarregados de governar o povo."
,"11":"Salomão transferiu a filha do Faraó da Cidade de David para o palácio que para ela tinha construído, dizendo: «Mulher nenhuma pode morar no palácio de David, rei de Israel, porque foi consagrado pela presença da Arca de Javé»."
,"12":"Salomão oferecia holocaustos a Javé sobre o altar de Javé, que tinha construído diante do pátio."
,"13":"Observava o rito diário dos holocaustos e as prescrições de Moisés referentes aos sábados, às luas novas e às três festas do ano: a festa dos Pães sem fermento, a festa das Semanas e a festa das Tendas."
,"14":"Seguindo as normas do seu pai David, Salomão estabeleceu também as classes sacerdotais, cada uma na sua função, e os levitas nas funções de cantar e oficiar na presença dos sacerdotes, conforme o ritual diário, e também os porteiros escalados para cada porta, pois era assim que tinha determinado David, homem de Deus."
,"15":"Ninguém se afastou das determinações que o rei tinha dado aos sacerdotes e levitas a respeito de todas as coisas, inclusive as relativas ao tesouro."
,"16":"Foi Salomão quem determinou todos os serviços, desde o dia em que lançou os alicerces do Templo de Javé, até à conclusão das obras."
,"17":"Salomão foi até Asiongaber e Elat, lugares à beira-mar, no país de Edom."
,"18":"Hiram mandou-lhe, através dos seus funcionários, navios e marinheiros, que foram com os funcionários de Salomão até Ofir, de onde trouxeram quinze mil quilos de ouro, que entregaram ao rei Salomão."
}`)
	CurrentBook.AddChapter(9, `{
"1":"A rainha de Sabá ouviu falar da fama de Salomão e foi a Jerusalém para submeter o rei à prova por meio de enigmas. Chegou com grandes riquezas, com camelos carregados de perfumes, muito ouro e pedras preciosas. Apresentou-se a Salomão e propôs-lhe tudo o que pensava."
,"2":"Salomão, porém, soube responder a todas as suas perguntas; não houve nenhuma questão, por mais difícil, que o rei não pudesse resolver."
,"3":"Quando a rainha de Sabá viu a sabedoria de Salomão, o palácio que havia construído,"
,"4":"as iguarias da sua mesa, os aposentos dos seus oficiais, os alojamentos e uniformes dos seus empregados, os copeiros com seus trajes, e os holocaustos que ele oferecia no Templo de Javé, ficou assombrada."
,"5":"Então disse ao rei: «É de facto verdade tudo o que ouvi na minha terra a respeito de ti e da tua sabedoria!"
,"6":"Eu não queria acreditar no que me diziam, antes de vir ver com os meus próprios olhos. O que me contaram não é nem metade: a grandeza da tua sabedoria é muito maior do que tudo o que eu tinha ouvido."
,"7":"A tua gente e os teus servos é que são felizes: podem desfrutar continuamente da tua presença e aprender da tua sabedoria."
,"8":"Seja bendito Javé, teu Deus, que foi benevolente e te colocou no trono como rei, em nome de Javé teu Deus. Javé ama Israel e deseja firmá-lo para sempre, e é por isso que te nomeou rei, a fim de que exerças o direito e a justiça»."
,"9":"Então a rainha de Sabá deu quatro toneladas de ouro ao rei, grandes quantidades de perfumes e de pedras preciosas. Nunca houve perfumes como esses que a rainha de Sabá trouxe para o rei Salomão."
,"10":"Os funcionários de Hiram e Salomão, que tinham trazido ouro de Ofir, trouxeram também madeira de sândalo e pedras preciosas."
,"11":"Com o sândalo, Salomão fez escadarias para o Templo de Javé e para o palácio real, e também cítaras e harpas para os cantores. Nunca se viu coisa igual na terra de Judá."
,"12":"Em troca, o rei Salomão ofereceu à rainha de Sabá tudo o que ela quis e pediu, superando o que ela lhe tinha trazido. Depois a rainha de Sabá partiu e voltou com a sua comitiva para a sua terra."
,"13":"O ouro que Salomão recebia anualmente era de vinte e três mil e trezentos quilos,"
,"14":"sem contar o que recebia como tributo dos mercadores e do lucro dos comerciantes. Além disso, todos os reis da Arábia e todos os governadores do país também traziam ouro e prata para Salomão."
,"15":"O rei Salomão fez duzentos escudos grandes de ouro batido, gastando seis quilos e meio em cada escudo,"
,"16":"trezentos escudos pequenos de ouro batido, gastando em cada um deles três quilos de ouro, e colocou-os no salão chamado Floresta do Líbano."
,"17":"O rei fez também um grande trono de marfim, e revestiu-o de ouro puro."
,"18":"O trono tinha seis degraus e um estrado de ouro, fixos no trono; tinha braços em ambos os lados do assento, com dois leões de pé, junto aos braços."
,"19":"Doze leões estavam colocados de cada lado dos seis degraus. Nunca se havia feito coisa igual em nenhum outro reino."
,"20":"Todas as taças que o rei Salomão usava para beber eram de ouro, e era também de ouro puro toda a baixela do salão da Floresta do Líbano, porque no tempo de Salomão a prata não tinha valor."
,"21":"De facto, o rei tinha uma frota de navios que ia a Társis com os funcionários de Hiram. Uma vez cada três anos, os navios voltavam de Társis carregados de ouro, prata, marfim, macacos e pavões."
,"22":"E o rei Salomão superou em riqueza e sabedoria todos os reis da Terra."
,"23":"Todos os reis do mundo queriam ser recebidos por Salomão, para aprenderem a sabedoria que Deus lhe tinha dado."
,"24":"E todos os anos, cada um deles trazia, como presente, objectos de prata e ouro, mantas, armas e aromas, cavalos e mulas."
,"25":"Salomão tinha nos seus estábulos quatro mil cavalos de tracção, carros, e doze mil cavalos de montaria. Colocou tudo nas cidades dos carros e junto do rei em Jerusalém."
,"26":"O domínio do seu reino ia desde o rio Eufrates até à terra dos filisteus e à fronteira com o Egipto."
,"27":"O rei fez com que a prata em Jerusalém fosse tão comum como as pedras, e os cedros como os sicômoros da Planície."
,"28":"Os cavalos de Salomão eram importados do Egipto e de outros países."
,"29":"O resto da história de Salomão, desde o começo até ao fim, está escrito na história do profeta Natã, nas profecias de Aías de Silo e na visão que Ido, o vidente, teve sobre Jeroboão, filho de Nabat."
,"30":"Salomão reinou em Jerusalém sobre todo o Israel, durante quarenta anos."
,"31":"Depois Salomão morreu e foi enterrado na Cidade de David, seu pai. E seu filho Roboão sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Roboão foi para Siquém, pois todo o Israel se dirigira para lá a fim de o proclamar rei."
,"2":"Jeroboão, filho de Nabat, estava no Egipto, para onde tinha fugido do rei Salomão. Ao saber da notícia, voltou do Egipto,"
,"3":"porque o tinham mandado chamar. Ele reuniu-se com todo o Israel, e disse a Roboão:"
,"4":"«O teu pai impôs-nos um fardo muito pesado. Se nos aliviares da dura escravidão e do fardo pesado que ele nos impôs, servir-te-emos»."
,"5":"Roboão respondeu: «Vinde ter comigo daqui a três dias!» E o povo foi-se embora."
,"6":"O rei Roboão pediu conselho aos anciãos que tinham servido ao seu pai Salomão, durante todo o tempo em que este viveu. Roboão perguntou-lhes: «Que resposta me aconselhais a dar a este povo?»"
,"7":"Eles disseram: «Se te mostrares bom para com este povo, se fores benevolente e souberes falar com ele, todos serão teus súbditos durante toda a vida»."
,"8":"Roboão, porém, desprezou o conselho dos anciãos e foi aconselhar-se com os jovens que tinha com ele e que o serviam."
,"9":"Roboão perguntou-lhes: «O que é que me aconselhais a responder a este povo? Ele pediu-me: 'Alivia-nos o jugo que o teu pai nos impôs'»."
,"10":"Os jovens que tinham crescido com ele disseram: «O povo disse-te: 'O teu pai tornou pesado o nosso fardo; alivia esse fardo que pesa sobre nós'. Pois bem, responde-lhe: 'O meu dedo mínimo é mais grosso do que a cintura do meu pai."
,"11":"Meu pai sobrecarregou-vos com um fardo pesado, mas eu aumentarei ainda mais esse fardo. Meu pai castigou-vos com chicotes, e eu castigar-vos-ei com ferrões'»."
,"12":"Daí a três dias, conforme o rei tinha pedido, Jeroboão e todo o povo foram ter com Roboão."
,"13":"O rei respondeu duramente ao povo. Desprezando o conselho que os anciãos lhe haviam dado,"
,"14":"falou conforme o conselho dos jovens: «Meu pai sobrecarregou-vos com um fardo pesado. Pois bem! Eu aumentar-vos-ei esse fardo. Meu pai castigou-vos com chicotes, e eu castigar-vos-ei com ferrões»."
,"15":"O rei não deu ouvidos ao povo. Esta disposição partiu de Deus, para realizar o que Javé dissera a Jeroboão, filho de Nabat, por meio de Aías de Silo."
,"16":"Vendo que o rei não tinha dado ouvidos ao povo, todo o Israel disse ao rei: «Que temos nós a ver com David? Não temos herança com o filho de Jessé. Volta para as tuas tendas, Israel. Agora cuida da tua casa, David». E todo o Israel voltou para as suas tendas. "
,"17":"Quanto aos israelitas que moravam nas cidades de Judá, continuaram submetidos a Roboão."
,"18":"Então o rei Roboão enviou Aduram, chefe dos trabalhos forçados, mas os israelitas apedrejaram-no e ele morreu. O rei Roboão conseguiu subir para o seu carro e fugiu para Jerusalém."
,"19":"E Israel revoltou-se contra a casa de David, até ao dia de hoje."
}`)
	CurrentBook.AddChapter(11, `{
"1":"De volta a Jerusalém, Roboão reuniu a casa de Judá e de Benjamim. Eram cento e oitenta mil guerreiros para lutar contra Israel e reconquistar o reino para Roboão."
,"2":"Então a palavra de Javé foi dirigida a Semeías, homem de Deus:"
,"3":"«Diz a Roboão, filho de Salomão, rei de Judá, e a todo o Israel que está em Judá e Benjamim:"
,"4":"'Assim diz Javé: Não subais para lutar contra os vossos irmãos. Voltai cada um para sua casa, porque tudo o que aconteceu foi por minha decisão'». Eles obedeceram à palavra de Javé, regressaram e desistiram de combater contra Jeroboão."
,"5":"Roboão ficou a morar em Jerusalém e começou a construir cidades fortificadas em Judá."
,"6":"Restaurou Belém, Etam, Técua,"
,"7":"Betsur, Soco, Odolam,"
,"8":"Gat, Maresa, Zif,"
,"9":"Aduram, Láquis, Azeca,"
,"10":"Saraá, Aialon e Hebron. Eram cidades fortificadas em Judá e Benjamim."
,"11":"Reforçou a defesa das cidades e colocou um comandante em cada uma, assim como depósitos de alimentos, azeite e vinho."
,"12":"Todas as cidades tinham escudos e lanças; estavam perfeitamente armadas. E Roboão reinou sobre Judá e Benjamim."
,"13":"Os sacerdotes e levitas que se achavam em todo o Israel deixavam o seu território para se unirem a Roboão."
,"14":"Os levitas abandonaram as suas terras e propriedades e foram morar em Judá e Jerusalém, pois Jeroboão e seus filhos haviam-lhes proibido exercer o sacerdócio de Javé."
,"15":"Ele próprio nomeava sacerdotes para os lugares altos e para o culto dos sátiros e dos bezerros que ele fabricou."
,"16":"Em consequência disso, pessoas de todas as tribos de Israel que tinham vontade de procurar Javé, o Deus de Israel, iam até Jerusalém para oferecer sacrifícios a Javé, Deus dos seus antepassados."
,"17":"Essas pessoas reforçaram o reino de Judá e confirmaram Roboão, filho de Salomão. Isso durou três anos, tempo em que ele foi fiel ao caminho de David e Salomão."
,"18":"Roboão ca-sou-se com Maalat, filha de Jerimot, o qual era filho de David com Abigail, filha de Eliab, que era filho de Jessé."
,"19":"Maalat deu a Roboão os seguintes filhos: Jeús, Somorias e Zoom."
,"20":"Depois ele casou-se com Maaca, filha de Absalão, a qual lhe gerou Abias, Etai, Ziza e Solomit."
,"21":"Roboão gostava de Maaca, filha de Absalão, mais que de todas as outras suas mulheres e concubinas. Ele teve dezoito mulheres e sessenta concubinas, e gerou vinte e oito filhos e sessenta filhas."
,"22":"Como chefe de todos eles, Roboão colocou Abias, filho de Maaca. Ele devia comandar os seus irmãos porque estava destinado a ser rei."
,"23":"Roboão foi esperto e distribuiu os seus filhos por todas as regiões de Judá e Benjamim, especialmente nas cidades fortificadas, forneceu-lhes bastante alimento e arranjou-lhes esposas."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Quando Roboão consolidou o seu reinado e se tornou forte, abandonou a Lei de Javé. E todo o Israel seguiu o seu exemplo."
,"2":"No quinto ano do reinado de Roboão, Sesac, rei do Egipto, atacou Jerusalém, pois ela tinha sido infiel a Javé."
,"3":"O exército de Sesac tinha mil e duzentos carros, sessenta mil cavaleiros e um exército incontável, formado de líbios, suquitas e etíopes, que vieram do Egipto com ele."
,"4":"Sesac tomou as cidades fortificadas de Judá e chegou a Jerusalém."
,"5":"O profeta Semeías procurou Roboão e os chefes de Judá que se haviam recolhido em Jerusalém por medo de Sesac. E Semeías disse-lhes: «Assim diz Javé: Vós abandonastes-Me! Por isso, Eu vos abandono nas mãos de Sesac»."
,"6":"Então os chefes de Israel e o rei humilharam-se e responderam: «Javé tem razão»."
,"7":"Ao ver que eles se tinham humilhado, Javé dirigiu a sua palavra a Semeías, dizendo: «Eles humilharam-se, e por isso não vou liquidá-los. Vou já deixar que escapem e não derramarei a minha cólera contra Jerusalém, por meio de Sesac."
,"8":"Eles, porém, ficarão submetidos a Sesac, e saberão qual é a diferença entre servir a Mim e servir aos reis das nações»."
,"9":"Sesac, rei do Egipto, atacou Jerusalém e levou tudo o que havia no tesouro do Templo de Javé e do palácio, inclusive os escudos de ouro que Salomão tinha feito."
,"10":"Depois Roboão mandou fazer outros escudos de bronze, para os colocar nas mãos dos comandantes dos guardas que vigiavam a porta do palácio."
,"11":"Todas as vezes que o rei ia ao Templo de Javé, os guardas empunhavam os escudos. Em seguida, colocavam-nos de novo na sala dos guardas."
,"12":"Porque o rei se humilhou, a ira de Javé voltou atrás e não destruiu tudo. Mesmo em Judá aconteciam coisas boas."
,"13":"E o rei Roboão pôde firmar-se em Jerusalém e continuar a reinar. Ele tinha quarenta e um anos quando começou a reinar, e ficou durante dezassete anos como rei em Jerusalém, cidade que Javé escolheu entre todas as tribos de Israel para aí colocar o seu Nome. A mãe dele chamava-se Naama e era amonita."
,"14":"Roboão, porém, praticou o mal, porque não se dedicou de coração a servir a Javé."
,"15":"A história de Roboão, desde o começo até ao fim, está escrita na história do profeta Semeías e do vidente Ado. Sempre houve guerra entre Roboão e Jeroboão."
,"16":"Roboão morreu e foi enterrado na Cidade de David. E seu filho Abias sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Foi no décimo oitavo ano do reinado de Jeroboão que Abias começou a reinar em Judá,"
,"2":"e reinou três anos em Jerusalém. O nome de sua mãe era Micaías, filha de Uriel. Ela era natural de Gabaá."
,"3":"Abias começou a batalhar com um exército de quatrocentos mil guerreiros valentes. E Jeroboão lutou contra ele com oitocentos mil guerreiros valentes."
,"4":"Então Abias colocou-se no alto do monte Semeron, na região montanhosa de Efraim, e gritou: «Jeroboão, israelitas, escutai-me!"
,"5":"Vós não sabeis que Javé, o Deus de Israel, entregou a David a realeza sobre Israel para sempre? Ele fez uma aliança inviolável com David e seus filhos."
,"6":"Jeroboão, filho de Nabat, servo de Salomão, filho de David, revoltou-se contra o seu senhor."
,"7":"Homens ociosos e perversos uniram-se a Jeroboão e impuseram-se a Roboão, filho de Salomão. Roboão era jovem e tímido, e não conseguiu impor-se."
,"8":"Agora vós pensais em resistir à realeza de Javé, que os filhos de David exercem. Aí estais vós, essa imensa multidão, acompanhando os bezerros de ouro que Jeroboão fabricou para serem vossos deuses!"
,"9":"Acaso não expulsastes os sacerdotes de Javé, os filhos de Aarão e os levitas? Vós nomeastes sacerdotes como os povos pagãos: quem levar um novilho e sete carneiros pode tornar-se sacerdote de falsos deuses!"
,"10":"Quanto a nós, Javé é o nosso Deus, e nós nunca O abandonámos. Os descendentes de Aarão é que são os sacerdotes ao serviço de Javé, e os levitas são os encarregados do culto."
,"11":"Todas as manhãs e todas as tardes, oferecemos holocaustos a Javé, incenso perfumado, pães colocados sobre a mesa pura, e temos o candelabro de ouro com as suas lâmpadas, que é aceso todas as tardes. Nós observamos as prescrições de Javé, o nosso Deus, que vós abandonastes."
,"12":"Sabei que Deus caminha à nossa frente. Os seus sacerdotes com as trombetas darão o toque de guerra contra vós. Israelitas, desisti de lutar contra Javé, o Deus dos vossos antepassados! Vós jamais podereis vencer!»"
,"13":"Enquanto isso, Jeroboão destacou uma patrulha para os atacar pela retaguarda. O grosso do exército ficou em frente de Judá e a patrulha foi pela retaguarda."
,"14":"Voltando-se, as tropas de Judá viram-se atacadas pela frente e pelas costas. Então clamaram a Javé. Os sacerdotes tocaram a trombeta,"
,"15":"os homens de Judá lançaram o grito de guerra e, enquanto eles gritavam, Deus derrotou Jeroboão e todo o Israel diante de Abias e de Judá."
,"16":"Os israelitas fugiram diante de Judá, e Deus entregou-os nas mãos de Judá."
,"17":"Abias e o seu exército conseguiram uma grande vitória, pois de Israel morreram quinhentos mil guerreiros."
,"18":"Nessa ocasião, os israelitas foram humilhados e os judaítas saíram vitoriosos, porque se apoiaram em Javé, Deus dos seus antepassados."
,"19":"Abias perseguiu Jeroboão e tomou-lhe a cidade de Betel com os arredores, Jesana com os arredores, Efron com os arredores."
,"20":"No tempo de Abias, Jeroboão não conseguiu recuperar. Por fim ele morreu, ferido por Javé."
,"21":"Abias, porém, tornou-se cada vez mais poderoso. Teve catorze mulheres, que lhe deram vinte e dois filhos e dezasseis filhas."
,"22":"O resto da história de Abias, as suas obras e palavras, estão escritos no comentário do profeta Ado."
,"23":"Depois Abias morreu e foi enterrado na Cidade de David. E seu filho Asa sucedeu-lhe no trono. E no tempo de Asa o país ficou tranquilo durante dez anos."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Asa fez o que Javé seu Deus aprova e estima."
,"2":"Acabou com os altares dos deuses estrangeiros e com os lugares altos, demoliu as estelas e derrubou os postes sagrados."
,"3":"Ordenou aos judeus que buscassem a Javé, o Deus dos seus antepassados, e que praticassem as suas leis e mandamentos."
,"4":"Acabou com os lugares altos e com os altares de incenso em todas as cidades de Judá. E o reino teve paz durante todo o seu reinado."
,"5":"Asa reconstruiu as cidades fortificadas de Judá, já que o país estava em paz e não fez nenhuma guerra nesses anos, porque Javé lhe deu descanso."
,"6":"Asa disse a Judá: «Vamos reconstruir essas cidades, cercá-las de muralhas e torres, de portas e trancas. A terra ainda nos pertence, porque servimos a Javé, nosso Deus, e Ele nos concedeu paz com os vizinhos». Executaram a reconstrução com pleno êxito."
,"7":"Os soldados que Asa tinha ao seu dispor eram, da parte de Judá, trezentos mil homens equipados de armaduras e lanças; e, da parte de Benjamim, duzentos e oitenta mil treinados para empunhar o escudo e manejar o arco. Todos eram valentes guerreiros."
,"8":"Zara, o etíope, marchou contra Judá com um exército de um milhão de homens e trezentos carros. Quando chegou a Maresa,"
,"9":"Asa foi enfrentá-lo. E prepararam-se para a luta no vale de Sefata, em Maresa."
,"10":"Então Asa invocou Javé seu Deus, dizendo: «Javé, quando queres ajudar, não distingues entre poderosos e fracos. Ajuda-nos, então, Javé nosso Deus, pois nós nos apoiamos em Ti, e em teu Nome vamos enfrentar essa multidão! Javé, Tu és o nosso Deus. Não Te deixes derrotar por um mortal»."
,"11":"Javé derrotou os etíopes à vista de Asa e de Judá. E os etíopes tiveram que fugir."
,"12":"Asa e o seu exército perseguiram os etíopes até Gerara. Todos foram mortos: não ficou nenhum sobrevivente. Foram estraçalhados quando quiseram enfrentar Javé e o seu exército. Os homens de Judá recolheram muitos despojos."
,"13":"Em seguida, atacaram as cidades vizinhas de Gerara, pois o terror de Javé tinha caído sobre elas. E saquearam-nas, pois havia nelas muitos despojos."
,"14":"Atacaram também as moradias da zona rural, e levaram muitas ovelhas e camelos. Por fim, voltaram para Jerusalém."
}`)
	CurrentBook.AddChapter(15, `{
"1":"O espírito de Deus desceu sobre Azarias, filho de Oded."
,"2":"Ele foi então ao encontro de Asa e disse-lhe: «Asa e homens de Judá e Benjamim, escutai! Javé estará sempre convosco, se estiverdes com Ele. Se O procurardes, Ele deixar-Se-á encontrar. Mas se O abandonardes, Ele também vos abandonará."
,"3":"Durante muito tempo Israel ficará sem o Deus verdadeiro, sem sacerdote para o ensinar, e sem Lei."
,"4":"Mas, na sua aflição, Israel voltará para Javé seu Deus, e procurá-l'O-á. Então Javé deixar-Se-á encontrar por ele."
,"5":"Nesse tempo, ninguém viverá em paz, pois todos os habitantes do país sofrerão grandes tribulações."
,"6":"Nações e cidades destruir-se-ão mutuamente, pois Deus vos perturbará com toda a espécie de tribulações."
,"7":"Mas ficai firmes, não desanimeis, porque as vossas obras serão recompensadas»."
,"8":"Ao ouvir esta mensagem do profeta, Asa decidiu eliminar os ídolos imundos de todo o país de Judá e Benjamim, e das cidades que ele havia tomado na região montanhosa de Efraim. Depois restaurou o altar de Javé que estava diante do vestíbulo de Javé."
,"9":"Reuniu os homens de Judá e Benjamim, bem como os de Efraim, Manassés e Simeão que moravam entre eles, pois muitos israelitas tinha passado para o lado de Asa, ao verem que Javé seu Deus estava com ele."
,"10":"Essa assembleia aconteceu em Jerusalém no terceiro mês do décimo quinto ano do reinado de Asa."
,"11":"Nesse dia, ofereceram em sacrifício a Javé setecentos bois e sete mil ovelhas dentre os despojos que tinham recolhido."
,"12":"Assumiram o compromisso de buscar a Javé, o Deus dos seus antepassados, com todo o coração e com toda a alma."
,"13":"Quem deixasse de buscar a Javé, o Deus de Israel, deveria ser morto, pequeno ou grande que fosse, homem ou mulher."
,"14":"Fizeram juramento a Javé em voz alta e por aclamação, ao som de trombetas e trompas."
,"15":"Judá inteiro ficou alegre com esse juramento, feito de todo o coração. Eles buscaram a Javé com sinceridade, e Javé deixou-Se encontrar por eles, e deu-lhes paz com os vizinhos."
,"16":"Maaca, avó do rei Asa, perdeu o título de Grande Dama, porque fizera um ídolo para Aserá. Asa quebrou e esmigalhou o ídolo e queimou-o junto ao riacho de Cedron."
,"17":"Os lugares altos não desapareceram de Israel, mas o coração de Asa foi íntegro durante toda a vida."
,"18":"Ele levou para o Templo de Deus os objectos que seu pai tinha ofertado, e também as suas próprias ofertas em prata, ouro e objectos."
,"19":"E até ao trigésimo quinto ano do reinado de Asa não houve nenhuma guerra."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Baasa, rei de Israel, no trigésimo sexto ano do reinado de Asa, marchou contra Judá, e fortificou Ramá, para cortar as comunicações com Asa, rei de Judá."
,"2":"Então Asa tirou ouro e prata dos tesouros do Templo de Javé e do palácio, e mandou-os a Ben-Adad, rei de Aram, que residia em Damasco, com esta mensagem:"
,"3":"«Vamos fazer um tratado de paz, como teu pai e o meu fizeram. Estou a mandar-te esta prata e este ouro, para que rompas a tua aliança com Baasa, rei de Israel, a fim de que ele saia do meu território»."
,"4":"Ben-Adad atendeu o rei Asa e mandou os comandantes do seu exército às cidades de Israel. Conquistou Aion, Dã, Abelmaim e todas as cidades-entrepostos da região de Neftali."
,"5":"Ao receber essa notícia, Baasa desistiu de fortificar Ramá e fez parar as obras."
,"6":"O rei Asa convocou Judá inteiro para transportar as pedras com que Baasa estava a fortificar Ramá, e aproveitou-as para fortificar Gaba e Masfa."
,"7":"Nessa ocasião, o vidente Hanani procurou Asa, rei de Judá, e disse-lhe: «Apoiaste-te no rei de Aram, e não em Javé teu Deus! Por isso, o exército do rei de Aram vai escapar ao teu controlo."
,"8":"Os etíopes e líbios também tinham numeroso exército com carros e cavalos. Tu pediste socorro a Javé, e Ele entregou-os nas tuas mãos."
,"9":"Os olhos de Javé percorreram a terra inteira para sustentar os que são sinceros para com Ele. Desta vez fizeste uma loucura. Por isso, daqui para a frente viverás em guerra»."
,"10":"Asa ficou com raiva do vidente e mandou prendê-lo, porque as suas palavras o irritaram. E, ao mesmo tempo, Asa começou a oprimir parte do povo."
,"11":"A história de Asa, desde o princípio até ao fim, está escrita nos Anais dos Reis de Judá e Israel."
,"12":"No trigésimo nono ano do seu reinado, Asa teve uma doença grave nos pés. Mesmo na doença, ele não recorreu a Javé, mas aos médicos."
,"13":"Asa morreu no ano quarenta e um do seu reinado, e reuniu-se com os seus antepassados."
,"14":"Enterraram-no no túmulo que ele tinha mandado cavar para si mesmo na Cidade de David. Colocaram o seu corpo num leito cheio de aromas, essências e perfumes, e fizeram uma grande fogueira em sua honra."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Josafá, filho de Asa, sucedeu-lhe no trono e conseguiu impor-se ao reino de Israel."
,"2":"Colocou batalhões de soldados em cada cidade fortificada de Judá e nomeou governadores no território de Judá e nas cidades de Efraim, que tinham sido conquistadas por seu pai Asa."
,"3":"Javé esteve com Josafá, pois a sua conduta foi a mesma que seu pai tinha seguido no começo. E não serviu aos ídolos."
,"4":"Ele buscou apenas o Deus de seu pai, comportou-se conforme os seus mandamentos e não imitou a conduta de Israel."
,"5":"Javé firmou o reino nas suas mãos. Judá inteiro pagava tributo a Josafá, de modo que ele adquiriu muita riqueza e prestígio."
,"6":"O seu coração manteve-se nos caminhos de Javé. E Josafá eliminou do território de Judá os lugares altos e postes sagrados."
,"7":"No terceiro ano do seu reinado, ele mandou os seus oficiais Ben-Hail, Abdias, Zacarias, Natanael e Miqueias para instruir as cidades de Judá."
,"8":"Alguns levitas acompanharam-nos: Semeías, Natanias, Zabadias, Asael, Semiramot, Jónatas, Adonias e Tobias, além dos sacerdotes Elisama e Jorão."
,"9":"Então, levando consigo o livro da Lei de Javé, começaram a ensinar em Judá. E percorreram todas as cidades de Judá, instruindo o povo."
,"10":"O terror de Javé atingiu todos os reinos dos países vizinhos de Judá. E nenhum deles tentou fazer guerra contra Josafá."
,"11":"Os filisteus pagavam-lhe muito tributo em dinheiro. Até os árabes lhe traziam gado miúdo: sete mil e setecentos carneiros e sete mil e setecentos bodes."
,"12":"Josafá foi ficando cada vez mais poderoso, e construiu fortalezas e cidades-entrepostos em Judá."
,"13":"Dispunha de muita mão-de-obra nas cidades de Judá. Os guerreiros valentes residiam em Jerusalém."
,"14":"Aqui está a relação deles segundo as famílias. Em Judá, os comandantes de mil eram os seguintes: Ednas, o chefe, com trezentos mil guerreiros."
,"15":"Às suas ordens estavam Joanã, comandante de duzentos e oitenta mil guerreiros,"
,"16":"e também Amasias, filho de Zecri, que servia a Javé como voluntário e comandava duzentos mil guerreiros."
,"17":"Em Benjamim, os comandantes de mil eram estes: Eliada, valente guerreiro, com duzentos mil homens armados de arco e escudos."
,"18":"Às suas ordens estava Jozabad, com cento e oitenta mil homens disponíveis."
,"19":"Todos eles estavam ao serviço do rei, sem contar os homens que ele havia colocado nas fortalezas de Judá."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Josafá tornou-se rico e poderoso, e aliou-se com Acab, através de um casamento."
,"2":"Alguns anos depois, ele foi visitar Acab à Samaria. Acab matou grande quantidade de ovelhas e bois, para ele e para a sua comitiva, e procurou convencê-lo a lutar contra Ramot de Galaad."
,"3":"Acab, rei de Israel, disse a Josafá, rei de Judá: «Queres vir comigo contra Ramot de Galaad?» Josafá respondeu: «Tu e eu, o teu exército e o meu, iremos juntos à guerra»."
,"4":"E acrescentou: «No entanto, consulta antes a resposta de Javé»."
,"5":"Então o rei de Israel reuniu os seus profetas, cerca de quatrocentos homens. E perguntou-lhes: «Devemos atacar Ramot de Galaad, ou não?» Eles responderam: «Vai! Deus entregou Ramot de Galaad nas tuas mãos»."
,"6":"Josafá, porém, disse: «Não existe outro profeta de Javé para o consultarmos?»"
,"7":"O rei de Israel respondeu a Josafá: «De facto, existe ainda outro homem, por meio de quem podemos consultar Javé. Mas eu tenho-lhe ódio, pois nunca me diz coisas agradáveis; só anuncia desgraças! É Miqueias, filho de Jemla». Josafá disse: «Não fales assim»."
,"8":"Então o rei de Israel chamou um funcionário e disse-lhe: «Depressa! Traz aqui Miqueias, filho de Jemla»."
,"9":"O rei de Israel e Josafá, rei de Judá ficaram sentados, cada um no seu trono e vestidos com os seus mantos reais. Estavam na praça diante da porta da cidade de Samaria, enquanto os profetas pronunciavam as suas profecias."
,"10":"Sedecias, filho de Canaana, fez para si dois chifres de ferro, e disse: «Assim diz Javé: 'Tu ferirás os arameus com estes chifres, até os destruíres'»."
,"11":"Todos os outros profetas prediziam: «Ataca Ramot de Galaad. Tu triunfarás, pois Javé entregá-la-á nas mãos do rei»."
,"12":"Enquanto isso, o mensageiro que tinha ido chamar Miqueias disse ao profeta: «Fica sabendo que todos os profetas estão a profetizar felicidade para o rei! Faz como eles. Anuncia felicidade»."
,"13":"Miqueias respondeu: «Juro por Javé, que só vou dizer o que o meu Deus me disse»."
,"14":"Ao chegar onde estava o rei, este logo perguntou: «Miqueias, devemos combater Ramot de Galaad, ou não?» Miqueias respondeu: «Podeis ir. Vós triunfareis; eles serão entregues nas vossas mãos»."
,"15":"O rei, porém, disse a Miqueias: «Quantas vezes tenho que te fazer jurar para que me digas somente a verdade em nome de Javé?»"
,"16":"Então Miqueias respondeu: «De facto, eu vejo Israel espalhado pelas montanhas, como rebanho sem pastor. E Javé diz-me: 'Eles já não têm chefe. Volte em paz cada um para sua casa'»."
,"17":"O rei de Israel comentou com Josafá: «Não te disse? Ele nunca me profetiza felicidade! Só anuncia desgraças!»"
,"18":"Miqueias, porém, continuou: «Escutai a palavra de Javé: Eu vi Javé sentado no seu trono e todo o exército do Céu, de pé, à sua direita e esquerda."
,"19":"Então Javé perguntou: 'Quem poderá enganar Acab, o rei de Israel, para que ele ataque e morra em Ramot de Galaad?' Um respondia isto, outro respondia aquilo."
,"20":"Então o espírito colocou-se diante de Javé e disse: 'Eu posso enganá-lo!' Javé perguntou: 'Como?'"
,"21":"Ele respondeu: 'Eu vou lá e transformo-me num espírito de mentira na boca de todos os profetas do rei'. E Javé disse: 'Tu conseguirás enganá-lo. Vai e faz isso'."
,"22":"Foi assim que Javé colocou um espírito de mentira na boca desses teus profetas, porque Javé decretou a tua ruína»."
,"23":"Então Sedecias, filho de Canaana, chegou perto de Miqueias e deu-lhe uma bofetada na boca, dizendo: «De que maneira o espírito de Javé saiu de mim para te falar a ti?»"
,"24":"Miqueias respondeu: «Vê-lo-ás no dia em que andares a esconder-te de quarto em quarto»."
,"25":"O rei de Israel ordenou: «Prendei Miqueias, e entregai-o a Amon, governador da cidade, e a Joás, filho do rei,"
,"26":"com a seguinte ordem do rei: 'Colocai este indivíduo na prisão e dai-lhe o mínimo de comida e bebida, até que eu volte vitorioso'»."
,"27":"Miqueias disse: «Se voltares vitorioso, é porque Javé não falou através de mim»."
,"28":"O rei de Israel e Josafá, rei de Judá, atacaram Ramot de Galaad."
,"29":"O rei de Israel disse a Josafá: «Vou disfarçar-me para entrar em combate. Tu vai com as tuas próprias roupas». O rei de Israel disfarçou-se. E começaram o combate."
,"30":"O rei de Aram tinha dado ordem aos comandantes de carros, dizendo: «Não ataqueis ninguém, nem grande nem pequeno. Lutai só contra o rei de Israel»."
,"31":"Quando os comandantes de carros viram Josafá, pensaram que era ele o rei de Israel e concentraram a luta em torno dele. Então Josafá gritou e Javé socor-reu-o, afastando dele os arameus."
,"32":"Os comandantes de carros perceberam que ele não era o rei de Israel, e afastaram-se."
,"33":"Alguém atirou uma flecha ao acaso e atingiu o rei de Israel no vão da articulação da armadura. Então o rei disse ao condutor do carro: «Dá a volta e tira-me da linha de combate, porque estou ferido»."
,"34":"Mas o combate nesse dia tornou-se mais violento, e o rei de Israel teve de ficar de pé no seu carro diante dos arameus, até à tarde. Ao pôr do sol, ele morreu."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Josafá, rei de Judá, voltou são e salvo para o seu palácio em Jerusalém."
,"2":"O vidente Jeú, filho de Hanani, foi ao seu encontro e disse: «Tu precisavas mesmo de ajudar um injusto? Como podes amar aqueles que odeiam a Javé? É por isso que Javé está indignado contra ti."
,"3":"Apesar de tudo, tens algo de bom, pois derrubaste os postes sagrados que havia no país, e mantiveste o teu coração na busca de Deus»."
,"4":"Josafá, rei de Judá, morava em Jerusalém, mas resolveu sair de lá para ir visitar o seu povo, desde Bersabeia até à região montanhosa de Efraim, a fim de o converter para Javé, o Deus dos seus antepassados."
,"5":"Josafá nomeou juízes para cada uma das cidades fortificadas de Judá."
,"6":"E disse aos juízes: «Cuidado com o que fazeis, porque não ireis julgar em nome dos homens, mas em nome de Javé. Ele estará convosco, quando pronunciardes uma sentença."
,"7":"Portanto, temei a Javé e procedei com cuidado, porque Javé, nosso Deus, não admite injustiça, favoritismo ou suborno»."
,"8":"Além disso, em Jerusalém, Josafá nomeou alguns levitas e sacerdotes, assim como alguns chefes de famílias israelitas, para pronunciarem as sentenças de Javé e julgarem os processos. Todos eles moravam em Jerusalém."
,"9":"E Josafá deu-lhes a seguinte ordem: «Desempenhai a vossa função com o temor de Javé, dentro da verdade e de coração íntegro."
,"10":"Os vossos irmãos que habitam nas vossas cidades virão trazer-vos processos de assassinato, ou consultar-vos sobre a Lei ou sobre algum mandamento, sobre estatutos ou normas. Resolvei tudo, para que eles não se tornem culpados diante de Javé, nem a sua ira se inflame contra vós e os vossos irmãos. Se agirdes assim, ficareis livres de culpa."
,"11":"O sacerdote-chefe Amarias será o vosso chefe em todos os assuntos religiosos. E Zabadias, filho de Ismael, chefe da casa de Judá, dirigirá as questões civis. Os levitas ficarão ao vosso serviço como escrivães. Coragem e mãos à obra! E Javé esteja com quem é bom»."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Tempos depois, os amonitas, moabitas e alguns meunitas foram lutar contra Josafá."
,"2":"Então informaram Josafá: «Uma grande multidão do outro lado do mar, do país de Edom, está vindo contra ti. Eles estão em Asasontamar, que é Engadi»."
,"3":"Josafá ficou com medo e recorreu a Javé, proclamando um jejum para Judá inteiro."
,"4":"Então o povo de todas as cidades de Judá reuniu-se para pedir conselho a Javé."
,"5":"E Josafá colocou-se diante da assembleia de Judá e dos habitantes de Jerusalém, reunida no Templo de Javé. De pé, diante do pátio novo,"
,"6":"Josafá exclamou: «Javé, Deus dos nossos antepassados, não és Tu o Deus que está no céu? Não és Tu que governas os reinos das nações? Em tuas mãos está o poder e a força, e ninguém Te pode resistir!"
,"7":"Não foste Tu, Deus nosso, que expulsaste os antigos habitantes desta terra em favor do teu povo Israel, e a entregaste para sempre aos descendentes do teu amigo Abraão?"
,"8":"Nela passaram a morar e construíram um santuário ao teu Nome, pensando:"
,"9":"'Se nos acontecer alguma desgraça, guerra, castigo, peste ou fome, viremos a este Templo, diante de Ti, pois o teu Nome está neste Templo. Do fundo da nossa angústia clamaremos a Ti, e Tu nos ouvirás e salvarás'."
,"10":"Aí estão os amonitas, moabitas e habitantes da montanha de Seir. Quando Israel vinha do Egipto, não deixaste que ele atravessasse o território deles. Em vez de os destruir, Israel afastou-se deles."
,"11":"Agora aí estão eles. Querem expulsar-nos da propriedade que nos deste como herança!"
,"12":"Deus nosso, Tu não vais julgá-los? Nós não podemos fazer nada contra essa multidão enorme que nos ataca. Nós não sabemos o que fazer, e por isso os nossos olhos se voltam para Ti»."
,"13":"Judá inteiro estava de pé, com as suas famílias, mulheres e filhos, na presença de Javé."
,"14":"No meio da assembleia o espírito de Javé desceu sobre Jaziel, filho de Zacarias, filho de Banaías, filho de Jeiel, filho do levita Matanias, um dos filhos de Asaf."
,"15":"Ele disse: «Prestai atenção, habitantes de Judá e Jerusalém, e tu também, rei Josafá: Assim diz Javé: Não tenhais medo e não vos acovardeis por causa desta grande multidão. Esta guerra não é vossa, mas de Deus."
,"16":"Amanhã descereis contra eles quando estiverem subindo a encosta de Cis. Ireis encontrá-los no fim do vale, em frente do deserto de Jeruel."
,"17":"Vós nem tereis que lutar! Ficai firmes e parados, observando como Javé vos salvará. Judá e Jerusalém, não tenhais medo nem vos acovardeis. Saí amanhã ao encontro deles, e Javé estará convosco»."
,"18":"Josafá prostrou-se com o rosto por terra, e todos os habitantes de Judá e Jerusalém se prostraram para adorar Javé."
,"19":"Os levitas da família de Caat e da família de Coré começaram então a louvar em alta voz a Javé, o Deus de Israel."
,"20":"De madrugada, foram para o deserto de Técua. Quando iam a sair, Josafá pediu a palavra e disse: «Escutai-me, habitantes de Judá e Jerusalém! Confiai em Javé, vosso Deus, e estareis seguros. Confiai nos seus profetas; e tudo correrá bem»."
,"21":"Depois de falar ao povo, Josafá encarregou um grupo com vestes sagradas para marchar na frente do batalhão, cantando e louvando a Javé com estas palavras: «Agradecei a Javé, porque o seu amor é para sempre»."
,"22":"Enquanto davam louvores com aclamações e cânticos, Javé armou uma emboscada contra os amonitas, moabitas e habitantes da montanha de Seir, que tinham vindo contra Judá. E todos eles foram derrotados."
,"23":"Então amonitas e moabitas decidiram destruir e aniquilar os habitantes da montanha de Seir. E quando acabaram com eles, começaram a destruir-se mutuamente."
,"24":"Quando os homens de Judá chegaram ao ponto de onde se avista o deserto, dispostos a enfrentar a multidão, viram pelo chão apenas cadáveres; ninguém havia escapado."
,"25":"Então Josafá e o seu exército saquearam os despojos. Encontraram muita coisa: mantimentos, gado, objectos de valor e roupas. Foram-se apossando de tudo, até não poderem carregar mais. Ficaram três dias procurando coisas, porque havia muito que tomar."
,"26":"No quarto dia, reuniram-se no vale da Bênção. Aí bendisseram a Javé. Por isso, chamaram ao lugar Vale da Bênção, nome que permanece até ao dia de hoje."
,"27":"Por fim, todos voltaram para Jerusalém, com Josafá à frente. Estavam cheios de alegria, porque Javé lhes tinha dado a vitória sobre os inimigos."
,"28":"Chegando a Jerusalém, desfilaram até ao Templo de Javé, ao som de liras, cítaras e trombetas."
,"29":"E o terror de Deus caiu sobre todos os reinos da região, pois todos ficaram a saber que Javé tinha combatido contra os inimigos de Israel."
,"30":"O reinado de Josafá seguiu tranquilo, porque Deus lhe concedeu paz com os seus vizinhos."
,"31":"Josafá reinou em Judá. Tinha trinta e cinco anos quando subiu ao trono. E reinou vinte e cinco anos em Jerusalém. O nome de sua mãe era Azuba, filha de Selaqui."
,"32":"Josafá comportou-se como seu pai Asa, e não se desviou, mas fez o que Javé aprova."
,"33":"Os lugares altos, porém, não foram eliminados, e o povo não foi fiel ao Deus dos seus antepassados."
,"34":"O resto da história de Josafá, desde o princípio até ao fim, está escrito na História de Jeú, filho de Hanani, incluída no Livro dos Reis de Israel."
,"35":"Josafá, rei de Judá, aliou-se com Ocozias, rei de Israel, que o levou a praticar o mal."
,"36":"Aliou-se com ele para construir navios que fossem a Társis, e construíram-nos em Asiongaber."
,"37":"Então o profeta Eliezer, filho de Dodias, da cidade de Maresa, profetizou assim contra Josafá: «Dado que fizeste aliança com Ocozias, Javé destruirá as tuas obras». De facto, os navios naufragaram e não puderam seguir para Társis."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Josafá morreu e foi enterrado com os seus antepassados na Cidade de David. E seu filho Jorão sucedeu-lhe no trono."
,"2":"Jorão tinha os seguintes irmãos, todos filhos de Josafá, rei de Israel: Azaria, Jaiel, Zacarias, Azarias, Miguel e Safatias."
,"3":"Seu pai tinha dado a todos eles muitos presentes em prata, ouro e jóias, além de cidades fortificadas em Judá. Mas deixou o trono a Jorão, que era o mais velho."
,"4":"Ao sentir-se seguro, após assumir o trono de seu pai, Jorão assassinou à espada todos os seus irmãos, além de alguns chefes de Israel."
,"5":"Jorão tinha trinta e dois anos quando começou a reinar. E reinou oito anos em Jerusalém."
,"6":"Imitou o comportamento dos reis de Israel, agindo como a casa de Acab, pois tinha-se casado com uma filha de Acab. Fez o que Javé reprova."
,"7":"Javé não quis destruir a dinastia de David, por causa da aliança que tinha feito com ele e a promessa de manter sempre acesa a sua lâmpada e a de seus filhos."
,"8":"Durante o governo de Jorão, Edom proclamou-se independente de Judá e estabeleceu rei próprio."
,"9":"Com os seus comandantes e todos os carros de guerra, Jorão atravessou a fronteira. À noite, ele teve de se levantar para enfrentar os edomitas, que o cercaram a ele e a todos os seus comandantes de carros."
,"10":"Foi assim que Edom ficou independente de Judá, até ao dia de hoje. Nessa mesma ocasião também Lebna se tornou independente. Jorão tinha abandonado Javé, o Deus dos seus antepassados. "
,"11":"Construiu lugares altos nas colinas de Judá, fez com que os moradores de Jerusalém se tornassem infiéis e levou Judá a extraviar-se."
,"12":"Entregaram-lhe um escrito do profeta Elias, que dizia o seguinte: «Assim diz Javé, o Deus de teu pai David: Tu não seguiste o comportamento de teu pai Josafá, nem de Asa, rei de Judá."
,"13":"Pelo contrário, imitaste o exemplo dos reis de Israel. Provocaste a idolatria em Judá e entre os habitantes de Jerusalém, copiando as práticas idolátricas da casa de Acab. Além disso, mataste os teus próprios irmãos, a família de teu pai, que eram melhores do que tu!"
,"14":"Por esse motivo, Javé provocará uma chaga enorme no teu povo, nos teus filhos, nas tuas mulheres e em tudo o que é teu."
,"15":"Tu mesmo ficarás com uma doença grave, doença que consumirá os teus intestinos dia após dia»."
,"16":"Javé provocou contra Jorão a hostilidade dos filisteus e também dos árabes, vizinhos dos etíopes."
,"17":"Eles atacaram, invadiram Judá, e levaram toda a riqueza que encontraram no palácio do rei e até mesmo as suas mulheres e filhos. Só ficou Ocozias, o mais novo."
,"18":"Depois, Javé feriu-o com uma doença incurável dos intestinos."
,"19":"Os dias foram passando e, dois anos depois, a doença consumiu-lhe os intestinos, vindo a morrer com dores terríveis. O povo não queimou perfumes em sua honra como tinha feito aos seus antecessores."
,"20":"Jorão tinha trinta e dois anos quando subiu ao trono. E reinou oito anos em Jerusalém. Desapareceu, e ninguém chorou por ele. Foi enterrado na Cidade de David, mas não na sepultura dos reis."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Como sucessor de Jorão, os moradores de Jerusalém proclamaram rei a Ocozias, seu filho mais novo, pois todos os outros tinham sido mortos pelo bando que tinha invadido o acampamento, juntamente com os árabes. Foi assim que Ocozias, filho de Jorão, acabou por se tornar rei de Judá."
,"2":"Tinha quarenta e dois anos quando começou a reinar, e reinou um ano em Jerusalém. Sua mãe chamava-se Atália e era filha de Amri."
,"3":"Ocozias também imitou o comportamento da casa de Acab, pois sua mãe aconselhava-o a cometer injustiças."
,"4":"Ele fez o que Javé reprova, como fizeram os da casa de Acab, pois foram estes que, para sua perdição, se haviam tornado conselheiros de Ocozias, depois da morte de seu pai."
,"5":"Seguindo o conselho deles, Ocozias acompanhou Jorão, filho de Acab, rei de Israel, para juntos guerrearem contra Hazael, rei de Aram, em Ramot de Galaad. Os arameus feriram Jorão,"
,"6":"e ele voltou para Jezrael, a fim de se recuperar dos ferimentos que tinha sofrido em Ramot de Galaad na guerra contra Hazael, rei de Aram. Então Ocozias, filho de Jorão, rei de Judá, foi a Jezrael para visitar Jorão, filho de Acab, porque ele estava doente."
,"7":"Com essa visita, Deus provocou a ruína de Ocozias. Foi durante a visita que ele acompanhou Jorão para combater Jeú, filho de Namsi, a quem Javé tinha ungido para exterminar a dinastia de Acab."
,"8":"Quando Jeú chegou para acertar as contas com a casa de Acab, encontrou também comandantes de Judá e sobrinhos de Ocozias que estavam ao serviço deste e matou-os a todos."
,"9":"Procurou também Ocozias. Conseguiram prendê-lo em Samaria, onde se tinha escondido. E levaram-no a Jeú, que o matou. Eles porém, enterraram-no, dizendo: «Ele era filho de Josafá, que buscou Javé de todo o coração». Não havia ninguém da família de Ocozias capaz de reinar."
,"10":"Quando Atália, mãe de Ocozias, soube que seu filho estava morto, resolveu acabar com a descendência real da casa de Judá."
,"11":"Mas Josaba, filha do rei, pegou em Joás, filho de Ocozias, dentre os filhos do rei que estavam a ser massacrados, e escondeu-o, com a ama dele, no quarto dos leitos. Assim Josaba, filha do rei Jorão, esposa do sacerdote Joiada e irmã de Ocozias, escondeu Joás da vista de Atália, evitando assim que ela o matasse."
,"12":"Joás ficou seis anos escondido com elas no Templo de Deus, enquanto Atália reinava no país."
}`)
	CurrentBook.AddChapter(23, `{
"1":"No sétimo ano, Joiada criou coragem e chamou os oficiais de cem. Eram eles: Azarias, filho de Jeroam; Ismael, filho de Joanã; Azarias, filho de Obed; Maasias, filho de Adaías; Elisafat, filho de Zecri. E fizeram entre si uma aliança."
,"2":"Percorreram Judá e reuniram os levitas de todas as cidades de Judá e os chefes de famílias de Israel. Em seguida, voltaram para Jerusalém."
,"3":"Então toda a assembleia fez uma aliança com o rei, no Templo de Deus. Joiada disse a todos: «Este é o filho do rei. É ele que deve reinar, conforme a promessa feita por Javé à descendência de David."
,"4":"Vós ides fazer o seguinte: Uma terça parte de vós, sacerdotes e levitas, que entrais de serviço no sábado, montará guarda nas entradas;"
,"5":"outra terça parte ficará no palácio real, e a outra na porta do Fundamento. Todo o povo ficará nos pátios do Templo de Javé."
,"6":"Ninguém entrará no Templo de Javé, a não ser os sacerdotes e levitas em serviço; eles podem entrar, porque são consagrados. O povo deverá observar as prescrições de Javé."
,"7":"Os levitas farão um círculo em torno do rei, de armas em punho, e acompanhá-lo-ão aonde quer que ele vá. Matai todo aquele que quiser entrar no Templo»."
,"8":"Os levitas e todos os de Judá fizeram como o sacerdote Joiada tinha mandado. Cada um deles reuniu os seus homens, tanto os que entravam de serviço no sábado, como os que saíam, pois o sacerdote Joiada não dispensou nenhuma classe."
,"9":"O sacerdote Joiada entregou aos oficiais de cem as lanças, com os escudos pequenos e grandes do rei David, que estavam no Templo de Deus."
,"10":"Colocou todo o povo, de armas em punho, desde o ângulo Sul até ao ângulo Norte do Templo, rodeando o altar e o Templo, para proteger o rei."
,"11":"Em seguida, levaram o filho do rei, colocaram-lhe a coroa e entregaram-lhe o documento da aliança. E proclamaram-no rei. Depois Joiada e seus filhos ungiram-no e aclamaram-no: «Viva o rei!»"
,"12":"Ouvindo os gritos do povo que corria e aclamava o rei, Atália foi ao encontro do povo no Templo de Javé."
,"13":"E quando viu, à entrada, o rei de pé no estrado, os oficiais e os tocadores de trombeta junto do rei, e todo o povo da terra gritando de alegria, as trombetas a tocar, e os cantores com os seus instrumentos acompanhando os cânticos de louvor, Atália rasgou as vestes e disse: «Traição! Traição!»"
,"14":"Então Joiada ordenou aos oficiais de cem, que comandavam as tropas: «Arrastai Atália para fora, por entre as fileiras. Se alguém a seguir, passai-o a fio de espada». O sacerdote, de facto, havia dito: «Não a mateis dentro do Templo de Javé»."
,"15":"Agarraram Atália e, chegando ao palácio real, à entrada da porta dos Cavalos, aí a mataram."
,"16":"Joiada concluiu entre o povo e o rei uma aliança, na qual o povo se comprometia a ser o povo de Javé."
,"17":"Em seguida, todo o povo foi até ao templo de Baal e arrasou-o: demoliram os altares e imagens, mataram Matã, sacerdote de Baal, diante dos altares."
,"18":"Joiada colocou guardas no Templo de Javé, sob as ordens dos sacerdotes e levitas. A eles é que David tinha entregue o Templo de Javé, para aí oferecerem, conforme está escrito na Lei de Moisés, holocaustos a Javé na alegria e com cânticos compostos por David."
,"19":"Joiada também colocou porteiros em cada entrada do Templo de Javé, para que nele não entrasse nada de impuro."
,"20":"Depois, reuniu os oficiais de cem, os notáveis, as autoridades do povo e todo o povo da terra, e pediu ao rei que saísse do Templo de Javé. Levaram o rei ao palácio real pela porta Superior e sentaram-no no trono dos reis."
,"21":"Todo o povo da terra fez festa, e a cidade ficou tranquila, porque Atália tinha sido morta a fio de espada."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Joás tinha sete anos quando subiu ao trono e reinou quarenta anos em Jerusalém. Sua mãe chamava-se Sebias e era natural de Bersabeia."
,"2":"Enquanto o sacerdote Joiada viveu, Joás fez o que Javé aprova."
,"3":"Joiada arranjou-lhe duas mulheres, que lhe deram filhos e filhas."
,"4":"Mais tarde, Joás resolveu restaurar o Templo de Javé."
,"5":"Reuniu os sacerdotes e levitas e disse-lhes: «Saí pelas cidades de Judá recolhendo dinheiro de todo o Israel, para restaurar o Templo do seu Deus, em cada ano, conforme a necessidade. Cuidai disso com urgência». Mas os levitas não se apressaram."
,"6":"Então o rei chamou Joiada, o chefe deles, e disse-lhe: «Porque é que não exigiste que os levitas recolhessem em Judá e Jerusalém o tributo imposto por Moisés, servo de Javé, e pela assembleia de Israel, em favor da Tenda do Testemunho?"
,"7":"Não sabes que a perversa Atália e seus filhos arruinaram o Templo de Deus e colocaram ao serviço dos ídolos tudo o que havia de sagrado no Templo de Javé?»"
,"8":"Então, por ordem do rei, fizeram um cofre e colocaram-no à porta do Templo de Javé, do lado de fora."
,"9":"Depois anunciaram, em Judá e Jerusalém, para que levassem a Javé o tributo que Moisés, servo de Deus, exigia a Israel no deserto."
,"10":"As autoridades e todo o povo levaram com alegria o seu tributo e colocaram-no no cofre, que ficou cheio."
,"11":"Todas as vezes que os levitas levavam o cofre para a inspecção real, e viam que havia muito dinheiro, o secretário do rei e o inspector do sumo sacerdote esvaziavam o cofre e colocavam-no novamente no mesmo lugar. Assim foram fazendo diariamente, e juntaram muito dinheiro."
,"12":"O rei e Joiada entregavam o dinheiro aos mestres de obras encarregados do Templo de Javé, e estes pagavam aos pedreiros e carpinteiros que trabalhavam no Templo de Javé, e também aos artesãos em ferro e bronze que restauravam o Templo de Javé."
,"13":"Os operários puseram-se a trabalhar, e as obras progrediram nas suas mãos. Eles reformaram o Templo de Deus e deram-lhe a estrutura primitiva e sólida."
,"14":"Terminado o serviço, levaram ao rei e a Joiada o dinheiro que sobrou. E com as sobras mandaram fazer utensílios para o Templo de Javé, objectos para o serviço e os holocaustos, taças e objectos de ouro e prata. Enquanto Joiada viveu, ofereceram continuamente holocaustos no Templo de Javé."
,"15":"Joiada ficou velho e morreu em idade avançada, com cento e trinta anos."
,"16":"Ele foi enterrado na Cidade de David, ao lado dos reis, pois só tinha feito o bem a Israel, a Deus e ao seu Templo."
,"17":"Depois da morte de Joiada, os chefes de Judá foram prostrar-se diante do rei, e este seguiu o conselho deles."
,"18":"Abandonaram o Templo de Javé, o Deus dos seus antepassados, prestaram culto aos postes sagrados e aos ídolos. Por causa desse pecado, a ira de Deus inflamou-se contra Judá e Jerusalém."
,"19":"Deus mandou-lhes profetas, a fim de os converter, mas eles não fizeram caso das suas críticas."
,"20":"Então o espírito de Deus apoderou-se de Zacarias, filho do sacerdote Joiada. Ele dirigiu-se ao povo e disse: «Assim diz Deus: Porque é que desobedeceis aos mandamentos de Javé? Ides arruinar-vos. Abandonastes Javé, e Ele também vos abandona!»"
,"21":"Então eles reuniram-se contra o profeta e, por ordem do rei, apedrejaram-no no pátio do Templo de Javé."
,"22":"Assim, o rei Joás, sem consideração por tudo o que de bom lhe tinha feito Joiada, pai de Zacarias, mandou matar o seu filho. Ao morrer, o profeta disse: «Que Javé julgue e dê a sentença»."
,"23":"Um ano depois, o exército arameu atacou Joás, invadiu Judá até Jerusalém, eliminou todos os chefes do povo e mandou ao rei de Damasco tudo o que tinha saqueado."
,"24":"O exército arameu tinha vindo com poucos homens, mas Javé entregou em seu poder um exército muito mais numeroso, porque o povo tinha abandonado Javé, o Deus dos seus antepassados. Quanto a Joás, os arameus castigaram-no:"
,"25":"ao partir, deixaram Joás muito ferido. Os seus ministros rebelaram-se contra ele para vingar o filho do sacerdote Joiada, e mataram-no na sua própria cama. Morto o rei, eles enterraram-no na Cidade de David, mas não na sepultura dos reis."
,"26":"Aqueles que conspiraram contra o rei foram Zabad, filho da amonita Semaat, e Jozabad, filho da moabita Semarit."
,"27":"Quanto aos filhos de Joás, quanto aos pesados tributos que teve de pagar e quanto à reforma do Templo de Deus, tudo está escrito no Comentário do Livro dos Reis. Seu filho Amasias sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Amasias tinha vinte e cinco anos quando subiu ao trono. E reinou vinte e nove anos em Jerusalém. Sua mãe chamava-se Joaden e era natural de Jerusalém."
,"2":"Fez o que Javé aprova, mas não com integridade de coração."
,"3":"Tendo consolidado o poder nas suas mãos, mandou matar os ministros que tinham assassinado o rei, seu pai."
,"4":"Mas não mandou matar os filhos dos assassinos, respeitando assim o que está escrito no livro da Lei de Moisés, onde Javé ordena: «Os pais não serão mortos pela culpa dos filhos, nem os filhos pela culpa dos pais. Cada um será executado por causa do seu próprio crime»."
,"5":"Amasias reuniu os homens de Judá e nomeou oficiais de cem e de mil, segundo as famílias, para todo o Judá e Benjamim. Fez o recenseamento dos maiores de vinte anos: havia trezentos mil homens aptos para a guerra, equipados com lanças e escudos."
,"6":"Também contratou em Israel cem mil mercenários, por três mil e quatrocentos quilos de prata."
,"7":"Um homem de Deus foi procurá-lo e disse: «Ó rei, a tropa de Israel não deve acompanhar-te, porque Javé não está com Israel, nem com os efraimitas."
,"8":"Se depositares neles a força para a guerra, Deus derrotar-te-á diante dos teus inimigos, porque Deus é que tem a força para derrotar ou dar a vitória»."
,"9":"Amasias perguntou ao homem de Deus: «E como ficam os três mil e quatrocentos quilos de prata que dei às tropas israelitas?» O homem de Deus respondeu: «Javé tem muito mais do que isso para te dar»."
,"10":"Então Amasias dispensou os mercenários que tinham vindo de Efraim, mandando-os regressar. Eles ficaram indignados contra Judá, e voltaram para casa enfurecidos."
,"11":"Amasias ganhou coragem e assumiu o comando do seu exército. Foi até ao vale do Sal, onde matou dez mil soldados de Seir."
,"12":"Judá prendeu vivos outros dez mil; levaram esses dez mil até ao alto de um rochedo e lançaram-nos de lá de cima, e eles morreram despedaçados."
,"13":"A tropa que Amasias tinha dispensado de ir para a guerra espalhou-se pelas cidades de Judá, desde Samaria até Bet-Horon, matando três mil pessoas e apossando-se de muitos despojos."
,"14":"Quando voltou da guerra contra os edomitas, Amasias trouxe consigo os deuses dos habitantes de Seir, adoptou-os como seus próprios deuses, adorou-os e queimou-lhes incenso."
,"15":"Então a ira de Javé inflamou-se contra Amasias, e enviou um profeta para lhe dizer: «Porque honras esses deuses que não foram capazes de livrar o seu povo das tuas mãos?»"
,"16":"O profeta ainda nem acabara de falar, quando Amasias respondeu: «Quem é que te fez conselheiro do rei? Pára com isso, se não queres morrer». O profeta não insistiu mais e concluiu: «Por aquilo que fizeste e por não teres escutado o meu conselho, tenho a certeza de que Deus decretou a tua ruína»."
,"17":"Amasias, rei de Judá, depois de pedir conselhos, mandou emissários a Joás, filho de Joacaz e neto de Jeú, rei de Israel, com esta mensagem: «Vem enfrentar-te comigo»."
,"18":"Joás, rei de Israel, respondeu a Amasias, rei de Judá, com esta mensagem: «O espinheiro do Líbano mandou dizer ao cedro do Líbano: 'Dá-me a tua filha como esposa para o meu filho'. Mas as feras do Líbano passaram e pisaram o espinheiro."
,"19":"Tu dizes: 'Eu derrotei Edom'. E enches-te de orgulho. Celebra a tua glória, mas fica em tua casa. Porque queres meter-te numa guerra desastrosa, provocando a tua ruína e a ruína de Judá?»"
,"20":"Amasias, porém, não fez caso, porque Deus queria entregá-lo nas mãos de Joás, por ter adorado os deuses de Edom."
,"21":"Então Joás, rei de Israel, foi enfrentar Amasias, rei de Judá, em Bet-Sames, que pertence a Judá."
,"22":"E Judá foi derrotado por Israel, e cada um fugiu para a sua tenda."
,"23":"Em Bet-Sames, Joás, rei de Israel, prendeu Amasias, rei de Judá, filho de Joás e neto de Joacaz, e levou-o para Jerusalém. Fez uma brecha de duzentos metros na muralha de Jerusalém, desde a porta de Efraim até à porta do Ângulo."
,"24":"Tomou posse do ouro, da prata e de todos os objectos que estavam no Templo de Deus, confiados a Obed-Edom, e no tesouro do palácio real. Além disso, tomou reféns, e voltou para a Samaria."
,"25":"Amasias, filho de Joás, rei de Judá, viveu ainda quinze anos depois da morte de Joás, filho de Joacaz, rei de Israel."
,"26":"O resto da história de Amasias, desde o princípio até ao fim, está tudo escrito no Livro dos Reis de Judá e de Israel."
,"27":"Desde o momento em que abandonou Javé, Amasias foi vítima de uma conspiração em Jerusalém. Ele fugiu para Láquis. E perseguido até Láquis, aí o mataram."
,"28":"Transportaram o seu corpo a cavalo, e enterraram-no na capital de Judá, junto dos seus antepassados."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Todo o povo de Judá escolheu Ozias, que tinha dezasseis anos, e proclamou-o rei em lugar de seu pai Amasias."
,"2":"Foi ele quem reconstruiu Elat, que reconquistou para Judá, depois da morte de Amasias."
,"3":"Ozias tinha dezasseis anos quando subiu ao trono. E reinou cinquenta e dois anos em Jerusalém. Sua mãe chamava-se Jequelias e era natural de Jerusalém."
,"4":"Fez o que Javé aprova, como seu pai Amasias tinha feito."
,"5":"Ele buscou a Deus enquanto viveu Zacarias, que o instruía no temor de Deus. E enquanto buscava a Javé, Deus fez que ele prosperasse."
,"6":"Ozias partiu para guerrear contra os filisteus e derrubou as muralhas de Gat, de Jabne e de Azoto. E reconstruiu cidades na região de Azoto e dos filisteus."
,"7":"Deus ajudou-o contra os filisteus, contra os árabes que moravam em Gur-Baal e contra os meunitas."
,"8":"Os amonitas pagaram tributo a Ozias. E a sua fama espalhou-se até à Entrada do Egito, pois ele tornou-se muito poderoso."
,"9":"Ozias construiu torres em Jerusalém, junto à porta do Ângulo, junto à porta do Vale e na Esquina, e fortificou-as."
,"10":"Construiu torres no deserto. Abriu muitos poços para os numerosos rebanhos que tinha na Planície e no Planalto. Possuía lavradores e vinhateiros na região montanhosa e nas terras de cultivo, porque gostava da agricultura."
,"11":"Ozias tinha um exército treinado e pronto para a guerra, agrupado em batalhões, conforme o recenseamento feito pelo secretário Jeiel e pelo comissário Maasias. O exército estava sob as ordens de Hananias, um dos oficiais do rei."
,"12":"Era de dois mil e seiscentos o número total dos chefes de família desses valentes guerreiros."
,"13":"Sob o comando deles havia um exército bem treinado, composto de trezentos e sete mil e quinhentos homens aptos para a guerra, com força e coragem para defender o rei contra os inimigos."
,"14":"E para todo o exército, Ozias providenciou escudos, lanças, capacetes, couraças, arcos, pedras e atiradeiras de pedras."
,"15":"Em Jerusalém, mandou fazer máquinas especialmente inventadas para colocar nas torres e ângulos, a fim de atirarem flechas e pedras grandes. Assim, a fama de Ozias espalhou-se até bem longe, pois a ajuda maravilhosa de Deus fê-lo poderoso."
,"16":"Tornando-se ele poderoso, o seu coração ficou cheio de orgulho, até se perder. Ele foi infiel a Javé seu Deus, e entrou no Santo de Javé para queimar incenso no altar dos perfumes."
,"17":"O sacerdote Azarias e oitenta corajosos sacerdotes de Javé foram ao seu encontro,"
,"18":"colocaram-se frente a frente com o rei Ozias e disseram-lhe: «Ozias, não é função tua queimar incenso a Javé. Somente os sacerdotes, descendentes de Aarão, foram consagrados para essa função. Sai do santuário, porque pecaste e já não tens direito à glória de Javé Deus!»"
,"19":"Ozias, que já estava com o incensório na mão, ficou indignado. No momento em que ele se indignava diante dos sacerdotes, no Templo de Javé, junto ao altar dos perfumes, a lepra surgiu na sua testa."
,"20":"O sumo sacerdote Azarias e os outros sacerdotes olharam e viram que a testa dele estava coberta de lepra. Imediatamente o expulsaram de lá. O próprio Ozias se apressou a sair, porque Javé o tinha castigado."
,"21":"O rei Ozias ficou leproso até ao fim da vida. Por isso, permaneceu fechado num quarto, e foi proibido de entrar no Templo de Javé. Seu filho Joatão era chefe do palácio e governava o povo."
,"22":"O resto da história de Ozias, desde o começo até ao fim, está escrito no Livro do profeta Isaías, filho de Amós."
,"23":"Ozias morreu e foi enterrado com os seus antepassados no campo do cemitério real, pois diziam: «Ele é leproso». E seu filho Joatão sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Joatão tinha vinte e cinco anos quando subiu ao trono. E reinou dezasseis anos em Jerusalém. Sua mãe chamava-se Jerusa, e era filha de Sadoc."
,"2":"Fez o que Javé aprova e imitou em tudo o comportamento de seu pai Ozias, mas não entrou no santuário de Javé. Entretanto, o povo continuava a corromper-se."
,"3":"Joatão construiu a porta Superior do Templo de Javé e fez muitas construções na muralha de Ofel."
,"4":"Construiu cidades na região montanhosa de Judá, e também fortalezas e torres nas matas."
,"5":"Guerreou contra o rei dos amonitas e venceu-o. Nesse ano, os amonitas pagaram o tributo de três mil e quatrocentos quilos de prata, cinco mil sacas de trigo e cinco mil de cevada. Isto foi o que os amonitas tiveram que pagar nesse ano e nos dois anos seguintes."
,"6":"Joatão adquiriu esse poder porque o seu caminho era firme diante de Javé, seu Deus."
,"7":"O resto da história de Joatão, suas guerras e obras, tudo está escrito nos Anais dos Reis de Israel e de Judá."
,"8":"Tinha vinte e cinco anos quando subiu ao trono. E reinou dezasseis anos em Jerusalém."
,"9":"Depois, Joatão morreu e foi enterrado na Cidade de David. E seu filho Acaz sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Acaz subiu ao trono com vinte anos. E reinou dezasseis anos em Jerusalém. Não fez, como o seu antepassado David, o que Javé aprova."
,"2":"Imitou o comportamento dos reis de Israel, fazendo estátuas para os ídolos."
,"3":"Queimou incenso no vale dos Filhos de Enom e chegou até mesmo a sacrificar os seus filhos no fogo, conforme os costumes abomináveis das nações que Javé tinha expulsado da frente dos israelitas."
,"4":"Ofereceu sacrifícios e queimou incenso nos lugares altos, nas colinas e debaixo de qualquer árvore frondosa."
,"5":"Javé, seu Deus, entregou-o nas mãos do rei de Aram, que o derrotou, capturou muitos prisioneiros e levou-os para Damasco. Javé também o entregou nas mãos do rei de Israel, que lhe causou grande derrota."
,"6":"Faceia, filho de Romelias, matou em Judá cento e vinte mil valentes guerreiros num só dia, porque eles tinham abandonado Javé, Deus dos seus antepassados."
,"7":"Zecri, valente de Efraim, matou Maasias, filho do rei, e Ezricam, chefe do palácio, e também Elcana, o segundo depois do rei."
,"8":"Os israelitas capturaram, dentre os seus irmãos, duzentos mil prisioneiros, entre mulheres, filhos e filhas, além de se apoderarem de muitos despojos, que levaram para a Samaria."
,"9":"Havia ali um profeta de Javé, chamado Oded. Ele foi ao encontro do exército que estava a chegar à Samaria, e disse: «Na sua cólera contra Judá, Javé, o Deus dos vossos antepassados, entregou-os nas vossas mãos. Mas o furor com que vós os massacrastes chegou até ao céu."
,"10":"E vós ainda pretendeis que os habitantes de Judá e Jerusalém se tornem vossos escravos e escravas! Será que não sois vós os principais responsáveis pelas faltas cometidas contra Javé, seu Deus?"
,"11":"Agora escutai-me: devolvei os prisioneiros que capturastes dentre os vossos irmãos, porque o furor da ira de Javé ameaça-vos!»"
,"12":"Então alguns chefes efraimitas tomaram a iniciativa. Eram eles: Azarias, filho de Joanã; Baraquias, filho de Mosolamot; Ezequias, filho de Selum; e Amasa, filho de Hadali. Eles colocaram-se contra os que estavam voltando da guerra,"
,"13":"e disseram: «Não tragais para cá esses prisioneiros, porque seríamos culpados diante de Javé. Procurais aumentar ainda mais os nossos pecados e faltas, quando a nossa culpa já é pesada, e o furor da ira de Javé ameaça Israel!»"
,"14":"Então os soldados entregaram os prisioneiros e despojos aos chefes e a toda a comunidade."
,"15":"Depois indicaram nominalmente homens para cuidarem dos prisioneiros. Com as roupas e sandálias dos despojos, eles vestiram os que estavam nus; deram-lhes comida e bebida, curaram-lhes os ferimentos, montaram em burros todos os que não podiam andar e levaram-nos até Jericó, a cidade das palmeiras, para junto dos seus irmãos. Em seguida, voltaram para Samaria."
,"16":"Nessa época, o rei Acaz mandou pedir ajuda ao rei da Assíria."
,"17":"Os edomitas tinham invadido Judá e capturado prisioneiros."
,"18":"Também os filisteus tinham feito incursões nas cidades da Planície e no Negueb de Judá. Haviam tomado Bet-Sames, Aialon, Gederot e Soco, com os seus arredores, além de Tamna com os seus arredores e Ganzo com os seus arredores. E ocuparam todos esses territórios."
,"19":"De facto, Javé estava a humilhar Judá, por causa de Acaz, rei de Judá, pois ele levava o povo a extraviar-se, e era infiel a Javé."
,"20":"No entanto, chegou Teglat-Falasar, rei da Assíria, não para ajudar, mas para o agredir e cercar."
,"21":"Acaz tinha tomado parte dos bens do Templo de Javé do palácio e dos altos funcionários, para dar ao rei da Assíria, mas isso não foi de nenhuma ajuda."
,"22":"Mesmo durante o cerco, o rei Acaz continuou na sua infidelidade a Javé,"
,"23":"oferecendo sacrifícios aos deuses de Damasco que o haviam derrotado. Acaz dizia: «Os deuses dos reis de Aram ajudam-nos na guerra. Por isso, eu ofereço-lhes sacrifícios para que eles me ajudem também». Esses deuses acabaram por se tornar uma armadilha para Acaz e para todo o Israel."
,"24":"Acaz ajuntou todos os objectos do Templo de Deus e quebrou tudo. Mandou fechar as portas do Templo de Javé e construiu altares em todas as esquinas de Jerusalém."
,"25":"Construiu lugares altos em todas as cidades de Judá, para queimar incenso aos deuses estrangeiros, provocando assim a ira de Javé, o Deus dos seus antepassados."
,"26":"O resto da história de Acaz, e tudo o que ele fez, desde o começo até ao fim, tudo está escrito nos Anais dos Reis de Judá e de Israel."
,"27":"Acaz morreu e foi enterrado na cidade de Jerusalém, mas não o colocaram no sepulcro dos reis de Judá. Seu filho Ezequias sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Ezequias tinha vinte e cinco anos quando subiu ao trono. E reinou vinte e nove anos em Jerusalém. Sua mãe chamava-se Abia, e era filha de Zacarias."
,"2":"Fez o que Javé aprova, seguindo em tudo o seu antepassado David."
,"3":"No primeiro ano do seu reinado, no primeiro mês, Ezequias mandou abrir e restaurar as portas do Templo de Javé."
,"4":"Chamou os sacerdotes e levitas, reuniu-os na praça do Oriente,"
,"5":"e disse-lhes: «Atenção, levitas! Agora purificai-vos, purificai o Templo de Javé, o Deus dos vossos antepassados. Retirai do santuário as abominações,"
,"6":"porque os nossos antepassados foram infiéis e fizeram o que Javé nosso Deus reprova. Eles abandonaram-n'O, descuidaram completamente a moradia de Javé e voltaram-Lhe as costas."
,"7":"Além disso, fecharam as portas do Vestíbulo, apagaram as lâmpadas e deixaram de queimar o incenso e de oferecer holocaustos no santuário, em honra do Deus de Israel."
,"8":"Isso provocou a indignação de Javé contra Judá e Jerusalém, fazendo com que eles se tornassem objecto de terror, espanto e zombaria, como podeis ver com os vossos próprios olhos."
,"9":"É por isso que os nossos antepassados caíram mortos pela espada, e os nossos filhos, filhas e mulheres foram feitos prisioneiros."
,"10":"Agora, eu tenho a intenção de fazer uma aliança com Javé, o Deus de Israel, para que Ele afaste de nós o ardor da sua ira."
,"11":"Meus filhos, não sejais omissos, pois foi a vós que Javé escolheu para ficar na sua presença, para O servir, para ser seus ministros e queimar-Lhe o incenso»."
,"12":"Apresentaram-se, então, os seguintes levitas: Da família de Caat: Maat, filho de Amasai, e Joel, filho de Azarias. Da família de Merari: Cis, filho de Abdi, e Azarias, filho de Jalaleel. Da família de Gérson: Joá, filho de Zema, e Eden, filho de Joá."
,"13":"Da família de Elisafã: Samri e Jeiel. Da família de Asaf: Zacarias e Matanias."
,"14":"Da família de Emã: Jaiel e Semei. Da família de Iditun: Semeías e Oziel."
,"15":"Eles reuniram os seus irmãos, purificaram-se e entraram para purificar o Templo de Javé, conforme havia ordenado o rei por ordem de Javé."
,"16":"Os sacerdotes entraram no Templo para o purificar e levaram para o pátio do Templo de Javé todos os objectos impuros que encontraram no Santo de Javé. Depois, os levitas levaram esses objectos e lançaram-nos fora, no vale do Cedron."
,"17":"Eles começaram a purificação no dia primeiro do primeiro mês e, no dia oito do mês, chegaram ao Vestíbulo de Javé. Durante oito dias, purificaram o Templo de Javé. Terminaram tudo no dia dezasseis do primeiro mês."
,"18":"Em seguida, apresentaram-se ao rei Ezequias e disseram-lhe: «Purificámos todo o Templo de Javé, o altar dos holocaustos e todos os seus utensílios, a mesa dos pães consagrados e todos os seus utensílios."
,"19":"Também consertámos e purificámos os utensílios que o rei Acaz profanou durante o seu ímpio reinado, e voltámos a colocá-los no lugar. Estão lá diante do altar de Javé»."
,"20":"Na manhã seguinte, bem cedo, o rei Ezequias reuniu os chefes da cidade e foi com eles ao Templo de Javé."
,"21":"Levaram sete bezerros, sete carneiros, sete cordeiros e sete bodes para o sacrifício pelo pecado, por intenção da realeza, do santuário e de Judá. Imediatamente, Ezequias mandou que os sacerdotes, descendentes de Aarão, os oferecessem sobre o altar de Javé."
,"22":"Então sacrificaram os bezerros. E os sacerdotes derramaram o sangue sobre o altar. Em seguida, sacrificaram os carneiros e derramaram o sangue sobre o altar. Sacrificaram os cordeiros e derramaram o sangue sobre o altar."
,"23":"Depois, levaram os bodes do sacrifício pelo pecado diante do rei e da comunidade, que impuseram as mãos sobre os animais."
,"24":"Então os sacerdotes sacrificaram-nos e derramaram-lhes o sangue sobre o altar, a fim de obter o perdão pelo pecado de todo o Israel, pois o rei tinha ordenado que tanto o holocausto como o sacrifício pelo pecado deviam ser feitos em favor de todo o Israel."
,"25":"O rei instalou os levitas no Templo de Javé, com címbalos, liras e cítaras, conforme as prescrições dadas por David, por Gad, o vidente do rei, e pelo profeta Natã. De facto, a ordem de Javé tinha sido dada através dos seus profetas."
,"26":"Assim, estavam lá presentes os levitas com os instrumentos de David, e os sacerdotes com as trombetas."
,"27":"Então, Ezequias mandou oferecer o holocausto sobre o altar. No momento em que começou o holocausto, começou também o cântico a Javé, o toque das trombetas, acompanhado pelos instrumentos de David, rei de Israel."
,"28":"Toda a assembleia permaneceu prostrada em adoração, o cântico prolongou-se e as trombetas tocaram; tudo isto até que terminou o holocausto."
,"29":"Quando acabou, o rei e toda a sua comitiva ajoelharam-se e prostraram-se."
,"30":"Em seguida, o rei Ezequias e os chefes ordenaram aos levitas que louvassem Javé com as palavras de David e do vidente Asaf. E eles fizeram-no de coração alegre. Depois, ajoelharam-se e prostraram-se."
,"31":"Então Ezequias tomou a palavra e disse: «Agora estais consagrados a Javé! Vinde e oferecei sacrifícios de acção de graças pelo Templo de Javé». A assembleia ofereceu sacrifícios de acção de graças, e os que tinham coração generoso levaram holocaustos."
,"32":"A quantidade de vítimas oferecidas pela assembleia foi de setenta bezerros, cem carneiros, duzentos cordeiros, tudo em holocausto a Javé."
,"33":"Além disso, foram sacrificados seiscentos bois e três mil ovelhas."
,"34":"Como os sacerdotes eram poucos e não davam conta para degolar todas as vítimas, os seus irmãos, os levitas, deram-lhes ajuda até terminar o serviço e até que os sacerdotes se purificassem. De facto, os levitas estavam mais dispostos para se purificar do que os sacerdotes."
,"35":"Além disso, houve muitos holocaustos, gordura de sacrifícios de comunhão e libações para os holocaustos. Assim, foi restabelecido o culto no Templo de Javé."
,"36":"Ezequias e todo o povo ficaram alegres, vendo tudo o que Deus havia realizado em favor do povo, pois tudo tinha sido feito de improviso."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Ezequias convidou todo o Israel e Judá, inclusive enviando cartas para Efraim e Manassés, a fim de que fossem ao Templo de Javé, em Jerusalém, para celebrar a Páscoa em honra de Javé, o Deus de Israel."
,"2":"O rei, as autoridades e toda a assembleia de Jerusalém decidiram celebrar a Páscoa no segundo mês."
,"3":"De facto, eles não tinham podido celebrá-la no devido tempo, porque ainda restavam muitos sacerdotes para se purificar e o povo não se havia reunido em Jerusalém."
,"4":"A proposta foi bem aceite pelo rei e por toda a assembleia."
,"5":"Decidiram, então, avisar todo o Israel, desde Bersabeia até Dã, convidando para que fossem a Jerusalém celebrar uma Páscoa em honra de Javé, o Deus de Israel, porque poucos a celebravam como está prescrito."
,"6":"Então os mensageiros partiram, levando as cartas escritas pelo rei e pelas autoridades a todo o Israel e Judá, com a seguinte ordem do rei: «Israelitas, voltai para Javé, o Deus de Abraão, de Isaac e de Israel, e Ele Se voltará para vós que sobrevivestes, escapando do poder dos reis da Assíria."
,"7":"Não façais como os vossos pais e irmãos, que foram infiéis a Javé, o Deus dos vossos antepassados, e que por Ele foram entregues à ruína, como vós mesmos podeis ver."
,"8":"Não tenhais a cabeça dura como os vossos pais. Comprometei-vos com Javé, dirigi-vos para o seu santuário, que Ele mesmo consagrou para sempre. Servi a Javé, o vosso Deus, e Ele afastará de vós o ardor da sua ira."
,"9":"Se vos voltardes para Javé, os vossos irmãos e filhos vão encontrar a compaixão daqueles que os levaram para o exílio, e deixá-los-ão voltar para esta terra. Porque Javé, o vosso Deus, tem piedade e compaixão. Ele jamais vos voltará as costas, se vos converterdes a Ele»."
,"10":"Os mensageiros passaram de cidade em cidade pela região de Efraim, Manassés e Zabulon, mas as pessoas riam e zombavam deles."
,"11":"Somente alguns de Aser, Manassés e Zabulon foram humildes e se dirigiram para Jerusalém."
,"12":"Em Judá, o poder de Deus agiu, fazendo com que todos concordassem em cumprir a ordem do rei e das autoridades, conforme a palavra de Javé."
,"13":"No segundo mês, grande multidão se reuniu em Jerusalém, para celebrar a festa dos Pães sem fermento. A assembleia era muito numerosa."
,"14":"Destruíram os altares para sacrifícios que havia em Jerusalém e eliminaram os altares de incenso. Lançaram tudo no vale do Cedron."
,"15":"No dia catorze do segundo mês, imolaram a Páscoa. Os sacerdotes e levitas confessaram os seus pecados, purificaram-se e levaram os holocaustos ao Templo de Javé."
,"16":"Cada um assumiu o seu posto, de acordo com a Lei de Moisés, homem de Deus. Os sacerdotes derramavam em libação o sangue recebido das mãos dos levitas."
,"17":"Como na assembleia havia muita gente que não se havia purificado, os levitas encarregaram-se de imolar as vítimas pascais de todos aqueles que não estavam purificados, para as consagrarem a Javé."
,"18":"Muita gente, principalmente de Efraim, Manassés, Issacar e Zabulon, não se havia purificado e comeu a Páscoa, sem obedecer ao que estava determinado. Por isso Ezequias rezou por eles, dizendo: «Javé, na tua bondade, perdoa o pecado"
,"19":"dos que de coração procuram a Deus, Javé, o Deus dos seus antepassados, mesmo que não tenham a pureza exigida para as coisas santas»."
,"20":"Javé ouviu Ezequias e não afligiu o povo."
,"21":"Os israelitas que se encontravam em Jerusalém celebraram, durante sete dias, a festa dos Pães sem fermento, com grande alegria. Todos os dias, os levitas e sacerdotes louvavam a Javé com grande entusiasmo."
,"22":"Ezequias felicitou todos os levitas pelas suas boas disposições para com Javé. Passaram os sete dias da festa oferecendo sacrifícios de comunhão e agradecendo a Javé, o Deus dos seus antepassados."
,"23":"Toda a assembleia resolveu continuar a festa por mais sete dias. E celebraram-na com alegria durante outros sete dias."
,"24":"Ezequias, rei de Judá, ofereceu à assembleia mil bezerros e sete mil ovelhas, e as autoridades também ofereceram à assembleia mil bezerros e dez mil ovelhas. Grande número de sacerdotes se purificou."
,"25":"Toda a assembleia de Judá se alegrou, juntamente com os sacerdotes e os levitas, com os que tinham vindo de Israel e com os imigrantes vindos de Israel ou que residiam em Judá."
,"26":"Foi grande a alegria em Jerusalém, pois desde os tempos de Salomão, filho de David, rei de Israel, que não acontecia uma coisa assim em Jerusalém."
,"27":"Por fim, os sacerdotes e os levitas puseram-se de pé e abençoaram o povo. A sua voz foi ouvida por Deus e a oração chegou até ao Céu, a santa morada."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Quando as festas terminaram, os israelitas que ali se encontravam percorreram as cidades de Judá, derrubando os postes sagrados, demolindo as estelas e destruindo os lugares altos e altares que havia em todo o Judá, Benjamim, Efraim e Manassés, até acabar com tudo. Depois os israelitas voltaram para as suas cidades, cada um para a sua casa."
,"2":"Ezequias organizou os sacerdotes e levitas por classes, cada um com a sua função: sacerdotes e levitas para os holocaustos, para os sacrifícios de comunhão, para o serviço litúrgico, para a acção de graças e os cânticos à porta dos acampamentos de Javé."
,"3":"O rei contribuiu com parte dos seus recursos para os holocaustos matutinos e vespertinos e para os holocaustos dos sábados, das luas novas e das festas, como está escrito na Lei de Javé."
,"4":"O rei ordenou aos habitantes de Jerusalém que dessem a parte dos sacerdotes e levitas, àqueles que pudessem dedicar-se à Lei de Javé."
,"5":"Logo que a ordem foi transmitida, os israelitas forneceram com abundância os primeiros frutos do trigo, do vinho, do azeite, do mel e de todos os produtos do campo. E entregaram fartamente o dízimo de tudo."
,"6":"Os israelitas e judaítas que moravam nas cidades de Judá levaram também o dízimo dos bois e ovelhas e fizeram montes com o dízimo das coisas consagradas a Javé, seu Deus."
,"7":"Começaram a fazer montes no terceiro mês e terminaram no sétimo."
,"8":"Ao verem esses montes, Ezequias e as autoridades bendisseram a Javé e ao seu povo Israel."
,"9":"Depois Ezequias pediu a opinião dos sacerdotes e levitas sobre o que deviam fazer com tudo aquilo."
,"10":"Azarias, chefe dos sacerdotes, da família de Sadoc, disse ao rei: «Desde que começaram a trazer as contribuições para o Templo de Javé, está a ser possível comermos até ficarmos satisfeitos, e ainda sobra com fartura, pois Javé abençoou o seu povo. E esse montão de coisas é o que sobra»."
,"11":"Ezequias mandou, então, construir depósitos no Templo de Javé. E assim fizeram."
,"12":"Depois transportaram os donativos, o dízimo e outras oferendas, com toda a honestidade. O chefe deles era o levita Conenias, ajudado pelo seu irmão Semei."
,"13":"Os fiscais eram Jaiel, Azarias, Naat, Asael, Jerimot, Jozabad, Eliel, Jesmaquias, Maat e Banaías. Estavam todos subordinados a Conenias e ao seu irmão Semei, sob a supervisão do rei Ezequias e de Azarias, chefe do Templo de Deus."
,"14":"O levita Coré, filho de Jemna, porteiro da entrada oriental, ficou encarregado das ofertas espontâneas que se faziam a Deus. Ele distribuía as ofertas feitas a Javé e as coisas santíssimas."
,"15":"Eram seus auxiliares: Eden, Miniamin, Jesua, Semeías, Amarias e Sequenias. Eles ficaram encarregados das cidades dos sacerdotes, para distribuir as porções aos irmãos, conforme as suas classes, a grandes e pequenos indistintamente,"
,"16":"e não só aos homens registados de três anos para cima. Por outras palavras, forneciam provisões a todos os que entravam diariamente no Templo de Javé para exercer o ministério, conforme as suas funções e segundo as suas classes."
,"17":"Os sacerdotes estavam registados por famílias, e também os levitas, a partir dos vinte anos, segundo as suas funções e classes."
,"18":"Deviam todos registar-se com a família inteira: mulheres, filhos e filhas e todo o grupo, pois deviam consagrar-se com fidelidade ao que é sagrado."
,"19":"Quanto aos sacerdotes aaronitas que viviam na zona rural das suas cidades, em cada cidade havia homens encarregados de distribuir pessoalmente as porções a todos os sacerdotes e a todos os levitas inscritos no registo."
,"20":"Assim fez Ezequias em todo o Judá. Ele praticou o que é bom, recto e honesto diante de Javé, seu Deus."
,"21":"Tudo o que ele realizou para a reforma do Templo de Deus, para a aplicação da Lei e dos mandamentos, fê-lo buscando a Deus de todo o coração. Por isso, foi bem sucedido."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Depois destes actos de fidelidade, aconteceu que Senaquerib, rei da Assíria, invadiu Judá. Sitiou as cidades fortificadas para as conquistar."
,"2":"Ezequias, vendo que Senaquerib se aproximava com a intenção de atacar Jerusalém,"
,"3":"ele com seus oficiais e guerreiros decidiram fechar todas as nascentes de água que havia fora da cidade. E todos ajudaram."
,"4":"Reuniram bastante gente para fechar as nascentes e o riacho que atravessava a cidade. Diziam: «Porque é que o rei da Assíria deveria encontrar tanta água ao chegar aqui?»"
,"5":"Ezequias mandou reforçar e reformar as muralhas em todos os pontos onde tinham sido derrubadas, levantou as torres e fez ainda outra muralha do lado de fora. Reforçou também os aterros da Cidade de David e preparou muitas armas e escudos."
,"6":"Nomeou comandantes que organizassem o exército para a luta, e reuniu-os consigo na praça que existe à porta da cidade. Ali encorajou-os, dizendo:"
,"7":"«Sede fortes e corajosos! Não tenhais medo nem receio do rei da Assíria ou dessa multidão de gente que está com ele. Nós contamos com Alguém mais poderoso do que ele."
,"8":"Do lado dele está o poder humano, mas do nosso lado está Javé, o nosso Deus, que vai socorrer-nos e combater ao nosso lado». E o povo ficou muito animado com as palavras de Ezequias, rei de Judá."
,"9":"Senaquerib, rei da Assíria, mandou ministros seus a Jerusalém, enquanto estava diante de Láquis com as suas tropas. Eles deviam dizer a Ezequias, rei de Judá, e a todo o povo de Judá que estava em Jerusalém:"
,"10":"«Assim diz Senaquerib, rei da Assíria: Em quem confiais vós para continuardes numa cidade cercada como Jerusalém?"
,"11":"Não vedes que Ezequias vos está a enganar e vos fará morrer de fome e sede? Ele anda a dizer: 'Javé, nosso Deus, livrar-nos-á da mão do rei da Assíria'."
,"12":"Não foi esse mesmo Ezequias que destruiu os lugares altos e altares de Javé, ordenando a Judá e Jerusalém que adorassem e queimassem incenso diante de um só altar?!"
,"13":"Acaso não sabeis o que fizemos, eu e os meus antepassados, a todos os povos dos outros países? Acaso os deuses dessas nações foram capazes de livrar os seus territórios das minhas mãos?"
,"14":"Qual dos deuses dessas nações, que meus pais consagraram ao extermínio, foi capaz de livrar o seu povo das minhas mãos? Será que o vosso Deus vai conseguir livrar-vos das minhas mãos?"
,"15":"Não vos deixeis enganar e iludir por Ezequias. Não acrediteis nele! Nenhuns deuses de outra nação ou reino foram capazes de livrar o seu povo das minhas mãos ou das mãos dos meus antepassados. O vosso Deus também não vos livrará das minhas mãos!»"
,"16":"Os ministros de Senaquerib disseram ainda muitas outras coisas contra Javé e contra o seu servo Ezequias."
,"17":"Senaquerib escreveu também mensagens insultando Javé, o Deus de Israel. Ele dizia: «Assim como os deuses das outras nações não livraram os seus povos da minha mão, o Deus de Ezequias também não livrará o seu povo da minha mão»."
,"18":"Depois começaram a gritar bem alto, em língua judaica, para a gente que estava sobre as muralhas, para a amedrontar e intimidar, e assim tomarem posse da cidade."
,"19":"Falaram do Deus de Jerusalém, como se Ele fosse igual aos deuses dos outros povos do mundo, que são produto de mãos humanas."
,"20":"Nesta situação, o rei Ezequias começou a rezar, juntamente com o profeta Isaías, filho de Amós, pedindo socorro aos céus."
,"21":"Então Javé enviou um anjo, que exterminou todos os soldados, chefes e oficiais do acampamento do rei da Assíria. Este voltou derrotado para o seu país e, ao entrar no templo do seu deus, ali mesmo foi assassinado pelos seus próprios filhos."
,"22":"Foi assim que Javé salvou Ezequias e os habitantes de Jerusalém das mãos de Senaquerib, rei da Assíria, e das mãos de todos os outros. E deu-lhes tranquilidade em todas as fronteiras."
,"23":"Depois disto, muita gente levou ofertas a Javé em Jerusalém e presentes a Ezequias, rei de Judá, que adquiriu grande prestígio aos olhos de todas as nações."
,"24":"Nessa ocasião, Ezequias ficou gravemente doente e implorou a Javé, que o ouviu e o agraciou com um milagre."
,"25":"Ezequias, porém, não correspondeu a esse benefício. Pelo contrário, encheu-se de orgulho e atraiu a ira de Javé sobre si, sobre Judá e sobre Jerusalém."
,"26":"Ezequias, porém, arrependeu-se do seu orgulho. O mesmo fizeram os habitantes de Jerusalém. Por isso, a ira de Javé não caiu sobre eles durante a vida de Ezequias."
,"27":"Ezequias tinha enorme riqueza e muitos bens. Construiu depósitos para prata, ouro, pedras preciosas, perfumes, jóias, objectos de valor e toda a espécie de coisas preciosas."
,"28":"Construiu ainda armazéns para as colheitas de trigo, de vinho e de azeite; estábulos para o gado e currais para as ovelhas."
,"29":"Comprou jumentos e grande quantidade de bois e ovelhas, porque Deus lhe concedeu muitos bens."
,"30":"Foi Ezequias quem fechou a saída superior das águas do Gion e as desviou, por um subterrâneo, para a parte ocidental da Cidade de David. Ezequias foi bem sucedido em tudo o que fez."
,"31":"Mas, quando os chefes de Babilónia lhe enviaram mensageiros para se informarem sobre o milagre acontecido no país, Deus abandonou-o para o pôr à prova e conhecer as suas intenções."
,"32":"O resto da história de Ezequias e a sua fidelidade estão escritos nas visões do profeta Isaías, filho de Amós, e nos Anais dos Reis de Judá e de Israel."
,"33":"Ezequias morreu e foi enterrado na parte mais alta dos túmulos dos filhos de David. Judá em peso e os habitantes de Jerusalém prestaram-lhe muitas homenagens por ocasião da sua morte. Seu filho Manassés sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Manassés tinha doze anos quando subiu ao trono. E reinou cinquenta e cinco anos em Jerusalém."
,"2":"Fez o que Javé reprova, imitando as abominações das nações que Javé tinha expulsado diante dos israelitas."
,"3":"Reconstruiu os lugares altos que seu pai Ezequias havia destruído. Ergueu altares aos ídolos. Levantou postes sagrados, e prostrou-se diante de todo o exército do céu, que ele adorou."
,"4":"Construiu também altares no Templo de Javé, acerca do qual Javé havia dito: «É em Jerusalém que o meu Nome estará para sempre»."
,"5":"Construiu altares em honra de todo o exército do céu, nos dois pátios do Templo de Javé."
,"6":"Sacrificou no fogo os seus próprios filhos no vale dos filhos de Enom. Praticou adivinhação e magia, estabelecendo necromantes e adivinhos. Ele provocou a ira de Javé, multiplicando as acções que Javé reprova."
,"7":"Chegou até ao ponto de tomar a imagem de um ídolo que tinha mandado fazer e de a colocar no Templo de Deus, do qual o próprio Deus tinha dito a David e a seu filho Salomão: «Farei residir para sempre o meu Nome neste Templo em Jerusalém, cidade que Eu escolhi entre todas as tribos de Israel."
,"8":"Nunca mais deixarei que o pé de Israel se torne errante, longe da Terra que dei aos seus antepassados, contanto que cumpram o que lhes ordenei, segundo toda a Lei, os estatutos e as normas transmitidos por Moisés»."
,"9":"Manassés, porém, levou o povo de Judá e de Jerusalém a cometer erros maiores que os erros das nações que Javé tinha arrasado diante dos israelitas."
,"10":"Javé falou a Manassés e ao seu povo, mas eles não o atenderam."
,"11":"Então Javé fez vir contra eles os generais do rei da Assíria, que algemaram Manassés, o acorrentaram e o levaram para a Babilónia."
,"12":"Ao ver-se em apuros, Manassés procurou agradar a Javé, seu Deus, humilhando-se profundamente diante do Deus dos seus antepassados."
,"13":"Suplicou a Javé, e Este comoveu-Se. Javé ouviu a sua súplica e trouxe-o de volta para Jerusalém, para o seu reino. Foi assim que Manassés reconheceu que Javé é o verdadeiro Deus."
,"14":"Depois disto, Manassés reconstruiu a muralha externa da Cidade de David, a Oeste do Gion, no vale, até à porta dos Peixes. A muralha rodeava o Ofel, e Manassés fê-la bem alta. Também colocou comandantes militares em todas as cidades fortificadas de Judá."
,"15":"Fez desaparecer do Templo de Javé os deuses estrangeiros e a estátua do ídolo. Tirou da cidade todos os altares que havia construído no monte do Templo e em Jerusalém."
,"16":"Reconstruiu o altar de Javé e imolou sobre ele sacrifícios de comunhão e de acção de graças. Deu ordens ao povo de Judá para prestar culto a Javé, o Deus de Israel."
,"17":"Mas o povo continuou a oferecer sacrifícios nos lugares altos, embora fossem para Javé, seu Deus."
,"18":"O resto da história de Manassés, a súplica que fez ao seu Deus e os oráculos dos videntes que lhe falavam em nome de Javé, o Deus de Israel, tudo está escrito nos Anais dos Reis de Israel."
,"19":"A sua súplica e como ele foi atendido, o seu pecado e rebeldia, os locais onde ele havia construído lugares altos e erguido postes sagrados e ídolos antes de se converter, tudo está escrito na História de Hozai."
,"20":"Manassés morreu e foi enterrado no seu palácio. Seu filho Amon sucedeu-lhe no trono."
,"21":"Amon tinha vinte e dois anos quando subiu ao trono. E reinou dois anos em Jerusalém."
,"22":"Fez o que Javé reprova, como seu pai Manassés: ofereceu sacrifícios e prestou culto a todos os ídolos que seu pai Manassés tinha feito."
,"23":"Ele, porém, não se humilhou diante de Javé como seu pai Manassés; pelo contrário, aumentou as suas culpas."
,"24":"Os seus ministros tramaram contra ele, e mataram-no no seu próprio palácio."
,"25":"O povo da terra, porém, matou todos os que tinham conspirado contra o rei Amon, e proclamou seu filho Josias como rei, em seu lugar."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Josias tinha oito anos quando subiu ao trono. E reinou trinta e um anos em Jerusalém."
,"2":"Fez o que Javé aprova e seguiu em tudo o comportamento do seu antepassado David, sem se desviar, nem para a direita, nem para a esquerda."
,"3":"No oitavo ano do seu reinado, sendo ainda adolescente, começou a procurar o Deus do seu antepassado David. E no seu décimo segundo ano de reinado, começou a purificar Judá e Jerusalém dos lugares altos, dos postes sagrados e dos ídolos de madeira e de metal."
,"4":"Por sua ordem, destruíram os altares dos ídolos, e ele próprio destruiu os altares de incenso que estavam sobre os altares, despedaçou os postes sagrados, os ídolos de madeira e de metal e, reduzindo-os a pó, espalhou o pó sobre os túmulos de quem lhes tinha oferecido sacrifícios."
,"5":"Queimou nesses altares os ossos dos sacerdotes e, assim, purificou Judá e Jerusalém."
,"6":"Nas cidades de Manassés, de Efraim, de Simeão e até de Neftali, em todos os lugares,"
,"7":"derrubou os altares e postes sagrados, quebrou e esmigalhou os ídolos e destruiu todos os altares de incenso em todo o país de Israel. Depois voltou para Jerusalém."
,"8":"No décimo oitavo ano do seu reinado, para purificar o país e o Templo, Josias mandou Safã, filho de Aslias, com Maasias, prefeito da cidade, e o arquivista Joá, filho de Joacaz, para reformarem o Templo de Javé, seu Deus."
,"9":"Eles procuraram o sumo sacerdote Helcias, e deram-lhe o dinheiro que tinham trazido para o Templo de Deus. Esse dinheiro fora colectado pelos levitas, guardiães do pátio, entre a gente de Manassés, de Efraim e de todo o resto de Israel, como também de Judá e Benjamim e dos habitantes de Jerusalém."
,"10":"Esse dinheiro foi entregue aos encarregados dos trabalhos e mestres de obras do Templo de Javé, que deviam pagar os trabalhos feitos na restauração e reforma do Templo."
,"11":"O dinheiro foi entregue aos carpinteiros e pedreiros para comprar pe-dras lavradas, vigas e traves de madeira para a estrutura e as vigas das construções que os reis de Judá tinham deixado cair em ruínas."
,"12":"Estes homens executaram fielmente o trabalho. Tinham como inspectores Jaat e Abdias, levitas descendentes de Merari, e Zacarias e Mosolam, levitas descendentes de Caat, assim como outros levitas que sabiam tocar instrumentos musicais."
,"13":"Estes também fiscalizavam os carregadores e dirigiam todos os que trabalhavam na obra, segundo a especialidade de cada um. Outros levitas eram secretários, inspectores e porteiros."
,"14":"Ao retirarem o dinheiro que tinha sido depositado no Templo de Javé, o sacerdote Helcias encontrou o livro da Lei de Javé transmitida por Moisés."
,"15":"Então Helcias disse ao secretário Safã: «Encontrei no Templo de Javé o Livro da Lei!» E entregou o livro a Safã."
,"16":"Então Safã levou o livro ao rei e informou-o: «Os teus servos fizeram tudo o que ordenaste."
,"17":"Estão a empregar o dinheiro recolhido no Templo de Javé para pagar aos mestres e aos trabalhadores da obra»."
,"18":"Ao mesmo tempo, o secretário Safã informou o rei: «O sacerdote Helcias entregou-me um livro». E começou a ler o livro ao rei."
,"19":"Ao ouvir o conteúdo da Lei, Josias rasgou as vestes."
,"20":"E imediatamente ordenou a Helcias, a Aicam, filho de Safã, a Abdon, filho de Micas, ao secretário Safã e a Asaías, ministro do rei:"
,"21":"«Ide consultar Javé por mim e pelos que restam de Israel, e por Judá, a respeito do livro que foi encontrado. Javé deve estar enfurecido connosco, porque os nossos antepassados não obedeceram à palavra de Javé e não agiram conforme o que está escrito neste livro»."
,"22":"Então Helcias e os mensageiros do rei foram procurar a profetisa Hulda, mulher de Selum, guarda dos vestiários, filho de Técua, neto de Haraas. Ela morava em Jerusalém, no Bairro Novo. Expuseram-lhe o caso."
,"23":"E ela respondeu: «Assim diz Javé, o Deus de Israel: Dizei a quem vos enviou:"
,"24":"Assim diz Javé: 'Vou fazer cair uma desgraça sobre este lugar e seus habitantes, vou enviar todas as maldições que estão neste livro que o rei de Judá leu."
,"25":"Eles abandonaram-Me e queimaram incenso a outros deuses, e irritaram-Me com as obras das suas mãos. Por isso, a minha ira inflamou-se contra este lugar, e não se apagará'."
,"26":"Dizei ao rei de Judá, que vos enviou para consultar Javé: 'Assim diz Javé, o Deus de Israel: Por teres ouvido estas palavras"
,"27":"com dor de coração, humilhando-te diante de Deus ao ouvires as suas ameaças contra este lugar e seus habitantes, porque te humilhaste diante de Mim, rasgaste as vestes e choraste na minha presença, Eu também te escuto - oráculo de Javé."
,"28":"Vou reunir-te aos teus antepassados e serás enterrado em paz. Os teus olhos não verão todos os males que Eu enviarei sobre este lugar e os seus habitantes'». Então eles levaram esta resposta ao rei."
,"29":"O rei convocou todos os anciãos de Judá e Jerusalém para uma reunião."
,"30":"Depois subiu ao Templo de Javé com todos os homens de Judá e todos os habitantes de Jerusalém: sacerdotes, levitas e todo o povo, adultos e crianças. Leu-lhes as palavras do Livro da Aliança encontrado no Templo de Javé."
,"31":"De pé sobre o estrado, o rei concluiu, diante de Javé, a aliança para seguir a Javé, obedecendo aos seus mandamentos, testemunhos e estatutos, de todo o coração e de toda a alma, cumprindo todas as palavras da aliança escrita nesse livro."
,"32":"Em seguida fez com que todos os que se encontravam em Jerusalém e em Benjamim se comprometessem com a aliança. A partir daí, os moradores de Jerusalém começaram a agir de acordo com a aliança do Deus dos seus antepassados."
,"33":"Josias retirou todas as abominações de todos os territórios pertencentes aos israelitas e obrigou todos os que encontrou em Israel a prestarem culto a Javé, seu Deus. Durante toda a vida de Josias, eles não se afastaram de Javé, o Deus dos seus antepassados."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Josias celebrou em Jerusalém uma Páscoa em honra de Javé. A Páscoa foi imolada no dia catorze do primeiro mês."
,"2":"Josias restabeleceu os sacerdotes nas suas funções, e confirmou-os no serviço do Templo de Javé."
,"3":"Josias disse aos levitas que instruíam o povo e eram consagrados a Javé: «Colocai a Arca santa no Templo construído por Salomão, filho de David, rei de Israel. Vós já não precisais de a transportar aos ombros. Dedicai-vos agora a servir a Javé, vosso Deus, e ao seu povo Israel."
,"4":"Organizai-vos em turnos por famílias, conforme David, rei de Israel, e seu filho Salomão determinaram por escrito."
,"5":"Ocupai os vossos postos no santuário, dividindo as vossas famílias, de tal forma que cada grupo levítico esteja encarregado de uma família do povo."
,"6":"Imolai a Páscoa, purificai-vos e preparai tudo para os vossos irmãos, fazendo tudo de acordo com a palavra de Javé, que foi transmitida por Moisés»."
,"7":"Aos homens do povo, Josias forneceu cordeiros e cabritos necessários para a celebração da Páscoa de todos os que se encontravam em Jerusalém. Foram trinta mil cabeças de gado miúdo, e três mil bois, tudo tirado das propriedades do rei."
,"8":"As autoridades fizeram uma oferta generosa ao povo, aos sacerdotes e levitas: Helcias, Zacarias e Jeiel, administradores do Templo de Deus, entregaram aos sacerdotes duas mil e seiscentas cabeças de gado miúdo para a celebração da Páscoa, e ainda trezentas cabeças de bois."
,"9":"Conenias, Semeías, seu irmão Natanael, Hasabias, Jeiel e Jozabad, chefes dos levitas, ofereceram aos levitas cinco mil cabeças de gado miúdo para a Páscoa e quinhentos bois."
,"10":"Quando a cerimónia estava preparada, os sacerdotes ocuparam os seus postos, e os levitas começaram a funcionar por classes, de acordo com as determinações do rei."
,"11":"E imolaram a Páscoa. Os sacerdotes sangravam e os levitas tiravam a pele."
,"12":"Separaram a parte que devia ser queimada, entregando o restante aos diversos ramos de famílias, da gente do povo, a fim de que todos pudessem fazer ofertas a Javé, conforme está escrito no livro de Moisés. O mesmo fizeram com os bois."
,"13":"Assaram os cordeiros pascais na brasa, de acordo com a regra, e cozinharam em panelas, caldeirões e caçarolas os outros alimentos sagrados, e levaram-nos rapidamente a toda a gente do povo."
,"14":"Em seguida, prepararam a Páscoa para si e para os sacerdotes da família de Aarão. Estes ficaram ocupados até ao anoitecer com os holocaustos e as gorduras. Foi por isso que os levitas prepararam os cordeiros da Páscoa para si e para os sacerdotes da família de Aarão."
,"15":"Os cantores da família de Asaf estavam no seu lugar segundo as ordens deixadas por David. Nem Asaf, nem Emã, nem Iditun, nem o vidente do rei, nem os porteiros tiveram que deixar as suas funções, pois os seus irmãos levitas prepararam tudo para eles."
,"16":"Toda a celebração a Javé foi feita no mesmo dia: celebrou-se a Páscoa e imolaram-se holocaustos no altar de Javé, tudo conforme a determinação do rei Josias."
,"17":"Foi nessa época que os israelitas presentes celebraram a Páscoa e, durante sete dias, a festa dos Pães sem fermento."
,"18":"Nunca se tinha celebrado em Israel uma Páscoa como essa, desde o tempo do profeta Samuel. Nenhum rei de Israel tinha celebrado uma Páscoa como a que Josias celebrou com os seus sacerdotes, levitas, todo o Judá, os israelitas presentes e os moradores de Jerusalém."
,"19":"Foi celebrada no décimo oitavo ano do rei Josias."
,"20":"Tempos depois de Josias ter restaurado o Templo, Necao, rei do Egipto, foi guerrear em Carquemis, na margem do rio Eufrates. Josias saiu para o enfrentar."
,"21":"Então Necao mandou-lhe mensageiros com este recado: «Não te intrometas nos meus assuntos, rei de Judá. Não vim lutar contra ti. Eu estou em guerra contra outra dinastia. Deus mandou-me fazer isto imediatamente. Não queiras contrariar a acção de Deus. Ele está comigo. Senão, Ele acabará contigo!»"
,"22":"Josias, porém, não desistiu de atacá-lo, pois estava decidido a guerrear. E não deu atenção ao que Necao lhe dizia em nome de Deus. E foi guerrear contra ele no vale de Meguido."
,"23":"Os atiradores acertaram com flechas no rei Josias, que disse aos seus ajudantes: «Tirai-me do combate, porque estou gravemente ferido»."
,"24":"Os ajudantes tiraram Josias do carro, puseram-no noutro e levaram-no para Jerusalém, onde morreu. Foi enterrado no túmulo dos seus antepassados, e todo o Judá e Jerusalém fizeram luto por ele."
,"25":"Jeremias compôs uma lamentação em honra de Josias, e até hoje os cantores ainda cantam essa lamentação por Josias. Tornou-se um cântico tradicional em Israel e encontra-se nas Lamentações."
,"26":"O resto da história de Josias, a sua fidelidade a tudo o que está escrito na Lei de Javé,"
,"27":"as suas obras, desde o começo até ao fim, tudo está escrito nos Anais dos Reis de Israel e de Judá."
}`)
	CurrentBook.AddChapter(36, `{
"1":"O povo da terra tomou o filho de Josias, chamado Joacaz, e colocou-o como rei em Jerusalém no lugar de seu pai."
,"2":"Joacaz tinha vinte e três anos quando subiu ao trono, e reinou três meses em Jerusalém."
,"3":"O rei do Egipto tirou Joacaz de Jerusalém e impôs ao país um tributo de três toneladas e meia de prata, e trinta e quatro quilos de ouro."
,"4":"Depois o rei do Egipto colocou Eliaquim, irmão de Joacaz, como rei de Judá e Jerusalém, mudando-lhe o nome para Joaquim. Quanto a Joacaz, o faraó Necao pren-deu-o e levou-o para o Egipto."
,"5":"Joaquim tinha vinte e cinco anos quando subiu ao trono. E reinou onze anos em Jerusalém. Fez o que Javé, seu Deus, reprova."
,"6":"Nabucodonosor, rei da Babilónia, guerreou contra ele, alge-mou-o e levou-o para a Babilónia."
,"7":"Dos objectos do Templo de Javé, Nabucodonosor levou uma parte para os guardar no seu palácio, em Babilónia."
,"8":"O resto da história de Joaquim, as abominações que praticou e tudo o que lhe aconteceu, tudo está escrito nos Anais dos Reis de Israel e de Judá. Seu filho Jeconias sucedeu-lhe no trono."
,"9":"Jeconias tinha dezoito anos quando subiu ao trono. E reinou três meses e dez dias em Jerusalém. Fez o que Javé reprova."
,"10":"Na passagem do ano, o rei Nabucodonosor mandou prendê-lo e levá-lo para a Babilónia com os objectos preciosos do Templo de Javé. Como rei sobre Jerusalém e Judá, ele colocou Sedecias, irmão de Jeconias."
,"11":"Sedecias tinha vinte e um anos quando subiu ao trono. E reinou onze anos em Jerusalém."
,"12":"Fez o que Javé, seu Deus, reprova, e não se humilhou diante do profeta Jeremias, que lhe falava em nome de Javé."
,"13":"Além disso, revoltou-se contra o rei Nabucodonosor, ao qual tinha jurado fidelidade em nome de Deus. Obstinou-se e não quis converter-se a Javé, o Deus de Israel."
,"14":"As autoridades, os sacerdotes e o povo também aumentaram os crimes que cometiam, imitando as abominações das nações. E profanaram o Templo que Javé tinha consagrado para Si em Jerusalém."
,"15":"Javé, o Deus dos seus antepassados, enviou os seus mensageiros, uns após outros, pois queria poupar o seu povo e a sua habitação."
,"16":"Mas eles troçavam dos mensageiros de Deus, levavam para a brincadeira as suas palavras, zombavam dos profetas, até que a ira de Javé contra o seu povo chegou a tal ponto que já não houve remédio."
,"17":"Então Javé mandou contra eles o rei dos caldeus, que matou a nossa gente à espada, até no Templo sagrado, sem poupar rapazes ou raparigas, adultos ou velhos. Deus entregou-os a todos nas mãos dele."
,"18":"O rei dos caldeus levou para a Babilónia todos os objectos pequenos e grandes do Templo de Javé, e também os tesouros do Templo de Javé, os tesouros do rei e dos seus oficiais."
,"19":"Em seguida, os caldeus lançaram fogo ao Templo de Deus, derrubaram as muralhas de Jerusalém, incendiaram todos os seus palácios e destruíram todos os objectos de valor."
,"20":"Levaram para o exílio na Babilónia todos os que escaparam da espada, a fim de servirem como escravos a eles e seus descendentes, até que chegou o reino persa."
,"21":"Desta forma, cumpriu-se o que Javé tinha dito por meio do profeta Jeremias: «Até que a terra desfrute os seus sábados, ela descansará durante todos os dias da desolação, até se passarem setenta anos»."
,"22":"No primeiro ano do reinado de Ciro, rei da Pérsia, Javé, cumprindo o que tinha dito por meio do profeta Jeremias, despertou a consciência de Ciro, rei da Pérsia. Este proclamou por todo o império, a viva voz e por escrito, o seguinte:"
,"23":"«Ciro, rei da Pérsia, decreta: Javé, o Deus do céu, entregou-me todos os reinos do mundo. Ele encarregou-me de Lhe construir um Templo em Jerusalém, na terra de Judá. Todos os que pertencem a esse povo e vivem entre nós, podem voltar para lá. E que Javé, seu Deus, esteja com eles»."
}`)

}
func PT_BS_LoadVH2RChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Depois da morte de Acab, Moab revoltou-se contra Israel."
,"2":"Ocozias caiu na sacada do seu quarto, em Samaria, e ficou ferido. Então mandou mensageiros com o seguinte encargo: «Consultai Baal-Zebub, deus de Acaron, para ver se vou sarar destas feridas»."
,"3":"Mas o anjo de Javé disse a Elias, o tesbita: «Levanta-te e vai ao encontro dos mensageiros do rei de Samaria e diz-lhes: 'Não há, porventura, um Deus em Israel, para irdes consultar Baal-Zebub, deus de Acaron?"
,"4":"Por isso, assim diz Javé: Tu não te levantarás da cama em que te deitaste, mas vais morrer'». E Elias foi-se embora."
,"5":"Os mensageiros voltaram, e o rei Ocozias perguntou-lhes: «Porque voltastes?»"
,"6":"Eles responderam: «Um homem veio ao nosso encontro e mandou-nos voltar para junto do rei que nos tinha enviado, para dizer: «Assim diz Javé: 'Não há, porventura, um Deus em Israel, para que mandes consultar Baal-Zebub, deus de Acaron? Por isso não te levantarás da cama em que estás deitado. Vais morrer'»."
,"7":"Ocozias perguntou: «Como era o aspecto do homem que foi ao vosso encontro e vos disse essas coisas?»"
,"8":"Eles responderam: «Ele estava vestido com roupa de pêlos e usava um cinto de couro». O rei disse: «É Elias, o tesbita!»"
,"9":"Então mandou um oficial com cinquenta soldados procurar Elias. O oficial subiu à procura de Elias, encontrou-o sentado no alto do monte e disse-lhe: «Homem de Deus, o rei manda que desças»."
,"10":"Elias respondeu: «Se eu sou homem de Deus, que um raio caia e te queime a ti e aos teus cinquenta soldados». Então um raio caiu e queimou o oficial e os seus cinquenta soldados."
,"11":"O rei mandou de novo outro oficial com cinquenta soldados. O oficial subiu e disse a Elias: «Homem de Deus, o rei mandou que descesses imediatamente»."
,"12":"Elias respondeu: «Se eu sou homem de Deus, que um raio caia e te queime a ti e aos teus cinquenta soldados». Então um raio caiu e queimou o oficial e os seus cinquenta soldados."
,"13":"O rei mandou, pela terceira vez, um oficial com cinquenta soldados. O oficial subiu, ajoelhou-se diante de Elias e suplicou: «Homem de Deus, que a minha vida e a vida destes cinquenta soldados, teus servos, tenha algum valor para ti."
,"14":"Caiu um raio e queimou dois oficiais, cada um com os seus cinquenta homens. Mas agora, que a minha vida tenha algum valor para ti!»"
,"15":"O anjo de Javé disse a Elias: «Desce com ele e não tenhas medo». Elias levantou-se, desceu com o oficial e foi falar com o rei."
,"16":"E disse-lhe: «Assim diz Javé: Uma vez que enviaste mensageiros para consultar Baal-Zebub, deus de Acaron, não te levantarás da cama em que estás deitado, mas vais morrer»."
,"17":"E o rei Ocozias morreu, conforme a palavra de Javé, anunciada por Elias. E Ocozias não tinha filhos. Por isso, o seu irmão Jorão subiu ao trono em seu lugar; e havia já dois anos que Jorão, filho de Josafá, era rei de Judá."
,"18":"O resto da história de Ocozias, e do que ele fez, tudo está escrito nos Anais dos Reis de Israel."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quando Javé arrebatou Elias ao céu num redemoinho, aconteceu o seguinte: Elias e Eliseu partiram de Guilgal."
,"2":"Elias disse a Eliseu: «Fica aqui, porque Javé me mandou ir sozinho a Betel». Eliseu respondeu: «Pela vida de Javé e pela tua vida, não deixarei de te acompanhar». E desceram juntos a Betel."
,"3":"Os irmãos profetas que moravam em Betel foram ao encontro de Eliseu, e disseram-lhe: «Não sabes que Javé hoje mesmo vai levar o teu mestre, nos ares, por cima da tua cabeça?» Eliseu respondeu: «Claro que sei, mas calai-vos»."
,"4":"Elias disse: «Eliseu, fica aqui, porque Javé me manda ir sozinho a Jericó». Mas Eliseu respondeu: «Pela vida de Javé e pela tua vida, não deixarei de te acompanhar». E foram para Jericó."
,"5":"Os irmãos profetas que moravam em Jericó aproximaram-se de Eliseu, e disseram-lhe: «Não sabes que Javé hoje mesmo vai levar o teu mestre, nos ares, por cima da tua cabeça?» Eliseu respondeu: «Claro que sei, mas calai-vos»."
,"6":"Elias disse a Eliseu: «Fica aqui, porque Javé me manda ir sozinho até ao Jordão». Mas Eliseu respondeu: «Pela vida de Javé e pela tua vida, não deixarei de te acompanhar». E eles foram juntos."
,"7":"Com eles foram cinquenta irmãos profetas. Estes ficaram a certa distância, enquanto os dois pararam na margem do rio Jordão."
,"8":"Então Elias pegou no manto, enro-lou-o e bateu com ele na água. A água dividiu-se em duas partes, de tal modo que os dois passaram o rio sem molhar os pés."
,"9":"Depois de terem atravessado o rio, Elias disse a Eliseu: «Pede o que quiseres, antes que eu seja arrebatado da tua presença». Eliseu pediu: «Deixa-me como herança o dobro do teu espírito»."
,"10":"Elias disse: «Pedes uma coisa difícil. Em todo o caso, se me vires quando eu for arrebatado da tua presença, o que pedes ser-te-á concedido; mas, se não me vires, não te será concedido»."
,"11":"E, enquanto iam andando e conversando, apareceu um carro de fogo com cavalos de fogo, que os separou um do outro. E Elias subiu ao céu num redemoinho."
,"12":"Eliseu, vendo isto, gritava: «Meu pai! Meu pai! Carro e cavalaria de Israel!» Depois não o viu mais. Então Eliseu pegou na sua própria túnica e rasgou-a em duas partes."
,"13":"Pegou no manto de Elias, que havia caído, e voltou para a margem do Jordão."
,"14":"Pegando no manto de Elias, bateu com ele na água, dizendo: «Onde está Javé, o Deus de Elias?» Bateu na água, que se dividiu em duas partes. E Eliseu atravessou o rio."
,"15":"Ao vê-lo, os irmãos profetas, que estavam a certa distância, comentaram: «O espírito de Elias repousa sobre Eliseu». Então foram ao seu encontro, prostraram-se diante dele,"
,"16":"e disseram: «Aqui, entre os teus servos, podes contar com cinquenta homens valentes. Permite que eles saiam para procurar o teu mestre. Talvez o espírito de Javé o tenha arrebatado e atirado sobre algum monte ou algum vale». Eliseu respondeu: «Não mandeis ninguém»."
,"17":"Eles, porém, insistiam tanto, a ponto de o aborrecerem. Por fim, ele disse: «Então mandai». Eles mandaram cinquenta homens, que procuraram Elias durante três dias, mas não o encontraram."
,"18":"Voltaram para junto de Eliseu, que tinha ficado em Jericó. Então Eliseu disse-lhes: «Não vos disse para não irdes?»"
,"19":"Os habitantes de Jericó disseram a Eliseu: «A localização da cidade é boa, como podes ver; mas a água é má e faz abortar as mulheres»."
,"20":"Eliseu pediu: «Trazei-me um prato novo com sal». Eles trouxeram-lhe o prato,"
,"21":"e Eliseu foi até à fonte das águas, deitou-lhes sal, e disse: «Assim diz Javé: Eu faço ficar saudáveis estas águas e elas nunca mais causarão nem morte nem esterilidade»."
,"22":"E a água tornou-se potável até ao dia de hoje, segundo a palavra que Eliseu pronunciara."
,"23":"Dali, Eliseu foi para Betel. Enquanto subia pelo caminho, um bando de garotos, que tinham saído da cidade, começaram a zombar dele, gritando: «Sobe, careca! Sobe, careca!»"
,"24":"Eliseu voltou-se, olhou para eles e amaldiçoou-os em nome de Javé. Então duas ursas saíram do bosque e despedaçaram quarenta e dois garotos."
,"25":"Eliseu foi para o monte Carmelo e depois voltou para Samaria."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Jorão, filho de Acab, subiu ao trono de Israel, em Samaria, no ano dezoito do reinado de Josafá, rei de Judá. Reinou doze anos."
,"2":"Fez o que Javé reprova, embora não tanto como seu pai e sua mãe, pois derrubou a estela de Baal, que seu pai tinha erguido."
,"3":"Contudo, repetiu os pecados que Jeroboão, filho de Na-bat, fez cometer a Israel, e deles não se afastou."
,"4":"Mesa, rei de Moab, era criador de gado e pagava ao rei de Israel cem mil cordeiros e cem mil carneiros, juntamente com a lã."
,"5":"Quando Acab morreu, Mesa revoltou-se contra Israel."
,"6":"Nesse tempo, o rei Jorão saiu de Samaria e passou em revista todo o Israel."
,"7":"Depois mandou dizer ao rei de Judá: «O rei de Moab revoltou-se contra mim. Queres ir comigo lutar contra Moab?» O rei de Judá respondeu: «Sim. Tu e eu, o teu exército e o meu, a tua cavalaria e a minha, somos todos um só»."
,"8":"E perguntou: «Que caminho seguiremos?» Jorão respondeu: «O caminho do deserto de Edom»."
,"9":"Então os reis de Israel, Judá e Edom partiram. Depois de marchar sete dias, faltou água para o exército e para os animais."
,"10":"Então o rei de Israel exclamou: «Ai de nós! Javé reuniu-nos aqui, os três reis, para nos entregar em poder de Moab!»"
,"11":"O rei de Judá perguntou: «Não existe por aqui algum profeta para podermos consultar Javé?» Um dos oficiais do rei de Israel respondeu: «Aqui há um certo Eliseu, filho de Safat, que derramava água nas mãos de Elias»."
,"12":"Josafá comentou: «A palavra de Javé está com ele». Então o rei de Israel, o rei de Judá e o rei de Edom foram ao encontro de Eliseu."
,"13":"Mas Eliseu disse ao rei de Israel: «Deixa-me em paz. Vai consultar os profetas do teu pai e da tua mãe». O rei de Israel replicou: «Javé reuniu-nos aqui, os três reis, para nos entregar em poder de Moab»."
,"14":"Eliseu então disse: «Pela vida de Javé dos exércitos, a quem sirvo, se não fosse por consideração ao rei de Judá, eu nem olharia para a tua cara."
,"15":"Apesar de tudo, trazei-me aqui um tocador de lira». Enquanto o músico tocava, a mão de Javé veio sobre Eliseu."
,"16":"E ele disse: «Assim diz Javé: 'Cavai diversos fossos neste vale',"
,"17":"pois assim diz Javé: 'Não vereis vento nem chuva, mas este vale ficará cheio de água e podereis beber vós, os vossos exércitos e os vossos animais'."
,"18":"Como isso não bastasse, Javé entregará Moab nas vossas mãos."
,"19":"Destruireis todas as cidades fortificadas, cortareis as suas árvores frutíferas, fechareis todas as fontes e cobrireis de pedras todos os campos férteis»."
,"20":"De facto, na manhã seguinte, à hora da apresentação da oferta, veio água dos lados de Edom, e toda a região ficou alagada."
,"21":"Os moabitas ficaram a saber que aqueles reis tinham chegado para os atacar. Então convocaram todos os que tinham idade para pegar em armas e tomaram posição na fronteira."
,"22":"De manhã, quando se levantaram e o sol brilhou sobre a água, os moabitas viram de longe a água, vermelha como sangue."
,"23":"Então disseram: «É sangue. Os reis lutaram entre si e mataram-se. E agora, Moab, vamos saquear»."
,"24":"Mas quando os moabitas chegaram ao acampamento israelita, os israelitas levantaram-se e derrotaram os moabitas, que fugiram. Os israelitas entraram no território de Moab e arrasaram-no:"
,"25":"destruíram as cidades, e cada um atirou pedras para os melhores campos até os cobrir, fecharam todas as fontes e cortaram todas as árvores frutíferas. Sobrou apenas Quir-Hares, que foi cercada e atacada pelos atiradores de pedras."
,"26":"Quando o rei de Moab percebeu que não conseguiria sustentar o combate, tomou consigo setecentos homens armados de espada, para abrir uma passagem e chegar até ao rei de Aram. Mas não conseguiu."
,"27":"Tomou, então, o seu filho primogénito, que lhe sucederia no trono, e ofereceu-o em holocausto sobre a muralha. Desencadeou-se então uma grande indignação contra os israelitas, que tiveram de se retirar e voltar para o seu país."
}`)
	CurrentBook.AddChapter(4, `{
"1":"A esposa de um dos irmãos profetas suplicou a Eliseu: «O meu marido, teu servo, morreu. E bem sabes que o teu servo temia a Javé. Mas um homem, a quem devíamos, veio para levar os meus dois filhos como escravos»."
,"2":"Eliseu perguntou: «Que posso fazer por ti? Diz-me o que tens em casa». A mulher respondeu: «Tudo o que tenho em casa é uma vasilha de azeite»."
,"3":"Então Eliseu ordenou: «Vai e pede aos vizinhos que te emprestem uma grande quantidade de ânforas vazias."
,"4":"Depois entra em casa, fecha a porta com os teus filhos dentro, e enche todas as vasilhas com azeite. Conforme as fores enchendo, põe-nas à parte»."
,"5":"A mulher foi e fechou-se em casa com os filhos. Estes traziam-lhe as vasilhas e a mulher enchia-as de azeite."
,"6":"Quando as vasilhas ficaram cheias, ela pediu ao filho: «Traz mais uma». E ele respondeu: «Não há mais». Então o azeite deixou de correr."
,"7":"A mulher foi contar isto ao homem de Deus, e ele disse: «Agora vai, vende o azeite, paga a dívida e usa o que sobrar, para viveres com os teus filhos»."
,"8":"Certo dia, Eliseu passou pela cidade de Sunam, onde morava uma mulher rica, que o convidou para uma refeição em sua casa. Depois disso, cada vez que passava por ali, Eliseu entrava para comer."
,"9":"A mulher disse ao marido: «Olha, este homem que passa com frequência pela nossa casa é um santo homem de Deus."
,"10":"Vamos fazer-lhe um quarto de tijolos no terraço, com cama, mesa, cadeira e lâmpada e poderá ficar nele quando vier à nossa casa»."
,"11":"Um dia que Eliseu passou por Sunam, subiu para o quarto do terraço e deitou-se."
,"12":"Ele disse ao seu servo Giezi: «Chama a sunamita». O servo chamou-a, e ela apresentou-se a Eliseu."
,"13":"E ele disse ao servo: «Diz-lhe: 'Tu preocupaste-te connosco. Que podemos fazer por ti? Queres alguma recomendação para o rei ou para o chefe do exército?'». A mulher respondeu: «Eu vivo no meio do meu povo»."
,"14":"Eliseu perguntou ao servo: «Que poderíamos fazer por ela?» Giezi respondeu: «Ela não tem filhos, e o marido dela já é idoso»."
,"15":"Eliseu disse: «Vai chamá-la». O servo chamou a mulher, e ela apareceu à porta."
,"16":"Eliseu disse: «Daqui a um ano, nesta mesma data, terás um filho nos braços». Ela, porém, respondeu: «Não, meu senhor, não enganes a tua serva»."
,"17":"A mulher, porém, ficou grávida e deu à luz um filho no ano seguinte, na época que Eliseu havia predito."
,"18":"O menino cresceu. Certo dia, foi ter com seu pai que estava junto dos ceifeiros,"
,"19":"e disse-lhe: «Estou com dor de cabeça». O pai disse a um dos servos: «Leva o menino à mãe»."
,"20":"O servo pegou no menino e levou-o à mãe. O menino ficou no colo da mãe até ao meio-dia, e depois morreu."
,"21":"A mãe subiu até ao terraço, colocou o menino sobre a cama do homem de Deus, fechou a porta e saiu."
,"22":"Depois chamou o marido e disse-lhe: «Manda-me um servo e uma jumenta para eu ir à casa do homem de Deus e voltar»."
,"23":"O marido perguntou: «O que é que lá vais fazer hoje? Não é lua nova nem sábado». Mas ela respondeu: «Fica sossegado»."
,"24":"Ela mandou selar a jumenta, e disse ao servo: «Vai à minha frente, e pára somente quando eu te disser»."
,"25":"Então a mulher foi ao encontro do homem de Deus no monte Carmelo. O homem de Deus viu a mulher de longe, e disse ao seu servo Giezi: «A sunamita vem aí."
,"26":"Corre ao encontro dela e pergunta-lhe: 'Estás bem? O teu marido está bem? O teu filho está bem?'» A mulher respondeu: «Estamos bem»."
,"27":"Quando chegou perto do homem de Deus, no alto da montanha, a mulher abraçou-lhe os pés. Giezi aproximou-se para a afastar, mas o homem de Deus disse-lhe: «Deixa-a. Ela está com a alma amargurada. Javé escondeu-me isto e nada me revelou»."
,"28":"Então a mulher perguntou: «Pedi-te eu, porventura, um filho? Eu pedi-te que não me enganasses»."
,"29":"Eliseu ordenou a Giezi: «Prepara-te, toma o meu bastão e põe-te a caminho. Se encontrares alguém, não o cumprimentes, e se alguém te cumprimentar, não respondas. Coloca o meu bastão sobre o rosto do menino»."
,"30":"Mas a mãe disse: «Pela vida de Javé e pela tua vida, eu não te deixarei». Então Eliseu levantou-se e seguiu-a."
,"31":"Giezi, que fora à frente, tinha colocado o bastão sobre o rosto do menino, mas o menino não falou nem reagiu. Então o servo voltou ao encontro de Eliseu e informou: «O menino não despertou»."
,"32":"Eliseu entrou na casa e encontrou o menino morto, estendido sobre a sua própria cama."
,"33":"Entrou, fechou a porta e rezou a Javé."
,"34":"Depois subiu para a cama, deitou-se sobre o menino, colocou a boca sobre a dele, os olhos sobre os dele, as mãos sobre as dele, estendeu-se sobre o menino. E o menino foi-se aquecendo."
,"35":"Então Eliseu começou a andar pelo quarto, de cá para lá. Depois subiu de novo para a cama e estendeu-se sobre o menino. Fez isto sete vezes. Então o menino espirrou e abriu os olhos."
,"36":"Eliseu chamou Giezi e disse-lhe: «Chama a sunamita». Giezi chamou-a. Quando ela chegou perto de Eliseu, este disse-lhe: «Toma o teu filho»."
,"37":"A mulher entrou, lançou-se aos pés de Eliseu e prostrou-se no chão. Depois pegou no filho e saiu."
,"38":"Quando Eliseu voltou para Guilgal, havia fome na região. Os irmãos profetas estavam sentados à sua frente. Então Eliseu disse ao seu servo: «Põe a panela grande ao lume, e prepara uma sopa para os irmãos profetas»."
,"39":"Um deles foi ao campo para apanhar verdura. Encontrou uvas bravas, apanhou-as e encheu o manto. Ao chegar, cortou-as em pedaços e deitou-as na panela da sopa, sem saber que eram venenosas."
,"40":"E serviram a sopa aos homens para que comessem. Logo que provaram a sopa, gritaram: «Homem de Deus, isto é veneno!»"
,"41":"Eliseu ordenou: «Trazei-me farinha». Então deitou farinha na panela e disse: «Serve as pessoas para que comam». E já não havia mais nada de amargo na panela."
,"42":"Um homem de Baal-Salisa levou ao homem de Deus pão da primeira colheita; levou vinte pães de cevada e trigo novo no bornal. Eliseu ordenou: «Distribui-os a estas pessoas para que comam»."
,"43":"O seu servo disse: «Como poderei com isto dar de comer a cem pessoas?» Eliseu insistiu: «Distribui-os a estas pessoas para que comam. Porque assim diz Javé: Elas comerão e ainda sobrará»."
,"44":"Então o servo distribuiu-os. Todos comeram e ainda sobrou, como Javé tinha dito."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Naamã, chefe do exército do rei de Aram, era homem estimado e favorecido pelo seu senhor. Foi por meio dele que Javé concedeu a vitória aos arameus. No entanto, esse homem valente ficou leproso."
,"2":"Numa incursão, os arameus tinham levado do território de Israel uma jovem, que ficou ao serviço da mulher de Naamã."
,"3":"Ela disse à patroa: «O meu senhor poderia ir ao profeta da Samaria. Ele certamente o livraria da lepra»."
,"4":"Naamã foi informar o seu senhor: «A jovem israelita disse isto»."
,"5":"O rei de Aram disse-lhe: «Vai até lá. Vou mandar uma carta ao rei de Israel». Naamã partiu levando trezentos e cinquenta quilos de prata, sessenta e oito quilos de ouro e dez vestes de festa."
,"6":"Naamã entregou ao rei de Israel a carta que dizia: «Quando receberes esta carta, verás que te estou mandando o meu servo Naamã para que o cures da lepra»."
,"7":"O rei de Israel leu a carta e rasgou as próprias roupas, exclamando: «Sou eu, porventura, um deus, capaz de dar a morte ou a vida, para que este me mande um homem para que eu o cure da lepra? Vede bem: ele procura algum pretexto contra mim!»"
,"8":"Eliseu, homem de Deus, soube que o rei de Israel tinha rasgado as próprias vestes, e mandou dizer-lhe: «Porque rasgaste as vestes? Deixa que ele venha ter comigo, e ficará sabendo que há um profeta em Israel»."
,"9":"Naamã chegou com os seus cavalos e o seu carro, e parou em frente da casa de Eliseu."
,"10":"Então Eliseu mandou-lhe um mensageiro com esta ordem: «Vai e lava-te sete vezes no rio Jordão. O teu corpo ficará limpo, e ficarás curado»."
,"11":"Naamã irritou-se e foi-se embora, dizendo: «Eu pensava que ele saísse e invocasse de pé o nome de Javé, seu Deus. Depois colocasse a mão no lugar da doença e, assim, me livrasse da lepra."
,"12":"Porventura o Abana e o Farfar, rios de Damasco, não são melhores que todas as águas de Israel? Eu não poderia lavar-me neles e ficar curado?» Voltou-se e foi-se embora indignado."
,"13":"Os seus servos aproximaram-se e disseram-lhe: «Se o profeta te tivesse mandado fazer alguma coisa difícil, não a farias? No entanto, ele só mandou isto: 'Lava-te, e ficarás curado'»."
,"14":"Então Naamã desceu e mergulhou sete vezes no rio Jordão, como o homem de Deus havia dito. A sua carne tornou-se como a carne de uma criança, e ficou curado."
,"15":"Então Naamã voltou com toda a sua comitiva ao homem de Deus. Entrou, parou diante do profeta e disse: «Agora sei que não há outro Deus na Terra, a não ser em Israel! Por favor, aceita um presente do teu servo»."
,"16":"Eliseu respondeu: «Pela vida de Javé, a quem eu sirvo: não aceitarei nenhum presente». Naamã insistiu para que ele aceitasse, mas ele recusou."
,"17":"Então Naamã pediu: «Já que não aceitas, ao menos permite que me seja dada, deste país, a quantidade de terra que duas mulas podem carregar, pois o teu servo não oferecerá mais holocaustos e sacrifícios a outros deuses, mas somente a Javé."
,"18":"E que Javé perdoe só uma coisa ao seu servo: quando o rei, meu senhor, vai ao templo de Remon para adorar, ele apoia-se no meu braço e eu também me prostro com ele no templo de Remon. Que Javé perdoe este gesto do teu servo»."
,"19":"Eliseu disse: «Vai em paz». Naamã já estava a uma certa distância, "
,"20":"quando Giezi, servo de Eliseu, pensou: «O meu senhor foi condescendente com este arameu Naamã, não aceitando o presente que ele lhe trouxe. Pela vida de Javé! Vou correr atrás dele e dar-me-á alguma coisa»."
,"21":"Então Giezi correu para alcançar Naamã. Quando Naamã viu que Giezi vinha a correr atrás dele, desceu do carro, foi ao seu encontro, e perguntou: «Está tudo bem?»."
,"22":"Giezi respondeu: «Tudo bem. Só que o meu senhor mandou dizer-te: 'Agora mesmo acabam de chegar, da região montanhosa de Efraim, dois jovens irmãos profetas. Por favor, dá-lhes trinta e cinco quilos de prata e duas vestes de festa'»."
,"23":"Naamã respondeu: «Aceita setenta quilos». Insistiu para que Giezi aceitasse. Depois Naamã colocou setenta quilos de prata e as vestes de festa em duas sacolas, e entregou-as a dois servos seus. Estes foram à frente de Giezi, levando as sacolas."
,"24":"Ao chegar a Ofel, Giezi pegou nos presentes, guardou-os em casa, despediu os homens, e eles foram-se embora."
,"25":"Depois Giezi foi ao encontro do seu senhor, e Eliseu perguntou-lhe: «Onde é que foste, Giezi?» Ele respondeu: «O teu servo não foi a lugar nenhum». Mas Eliseu retrucou:"
,"26":"«Pensas que o meu espírito não estava presente quando alguém desceu do carro e foi ao teu encontro? Agora que recebeste o dinheiro, com ele podes comprar roupas, olivais, vinhas, ovelhas, bois, servos e servas."
,"27":"Mas a lepra de Naamã passará para ti e teus descendentes para sempre». E Giezi saiu da presença de Eliseu, branco como a neve, por causa da lepra."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Os irmãos profetas disseram a Eliseu: «Como podes ver, o lugar onde moramos contigo é muito pequeno para nós."
,"2":"Vamos até ao rio Jordão, e cada um de nós tomará um tronco para construir ali uma casa». Eliseu disse: «Podeis ir»."
,"3":"Um deles pediu: «Por favor, vem com os teus servos». Eliseu respondeu: «Eu vou»."
,"4":"E foi com eles. Chegando ao rio Jordão, começaram a cortar madeira."
,"5":"Um dos irmãos estava a cortar um tronco e o machado caiu à água. Então ele gritou: «Meu senhor, era um machado emprestado!»"
,"6":"O homem de Deus perguntou: «Onde é que o machado caiu?» O irmão mostrou-lhe o lugar. Então Eliseu cortou um pedaço de madeira, ati-rou-o à água e o machado boiou."
,"7":"Eliseu disse: «Apanha o machado». O homem estendeu a mão e apanhou o machado."
,"8":"O rei de Aram estava em guerra contra Israel. Numa reunião com os seus oficiais, determinou: «Vamos fazer uma emboscada em tal lugar»."
,"9":"Mas Eliseu mandou dizer ao rei de Israel: «Cuidado com o tal lugar, porque os arameus estão lá acampados»."
,"10":"O rei de Israel mandou os seus homens para o lugar que Eliseu lhe havia indicado. Eliseu avisava, e o rei tomava precauções. E isto aconteceu várias vezes."
,"11":"O rei de Aram ficou perplexo com isto, convocou os seus oficiais e perguntou: «Dizei-me! Quem dos nossos nos está a trair junto do rei de Israel?»"
,"12":"Um dos oficiais respondeu: «Não é nenhum de nós, senhor meu rei. É Eliseu, profeta de Israel, que revela ao rei de Israel até as palavras que tu dizes no quarto de dormir»."
,"13":"Então o rei ordenou: «Ide e vede onde ele está, que eu o mandarei prender». Então informaram: «Eliseu está em Datã»."
,"14":"O rei mandou para lá cavalaria, carros e poderosa tropa, que chegaram de noite e cercaram a cidade."
,"15":"No dia seguinte, Eliseu madrugou para sair, e viu que um exército estava a cercar a cidade, com cavalos e carros. O seu servo disse-lhe: «Meu senhor, que vamos fazer?»"
,"16":"Eliseu respondeu: «Não tenhas medo. Os que estão connosco são mais numerosos que eles»."
,"17":"E Eliseu rezou: «Javé, abre os olhos do meu servo, para que ele possa ver». Javé abriu os olhos do servo, e ele viu a montanha cheia de cavalaria e carros de fogo em torno de Eliseu."
,"18":"Quando os arameus desceram contra ele, Eliseu pediu a Javé: «Confunde a vista desta gente». E Javé confundiu a vista deles, conforme Eliseu havia pedido."
,"19":"Então Eliseu disse-lhes: «Não é este o caminho, nem a cidade certa. Segui-me e levar-vos-ei ao homem que procurais». E levou-os para Samaria."
,"20":"Quando entraram em Samaria, Eliseu pediu: «Javé, abre-lhes os olhos, para que vejam bem». Javé abriu-lhes os olhos, e eles começaram a ver: estavam no centro de Samaria!"
,"21":"Ao vê-los, o rei de Israel perguntou: «Devo matá-los, meu pai?»"
,"22":"Ele respondeu: «Não os mates. Irias matar gente que não aprisionaste com a tua espada e o teu arco? Dá-lhes pão e água, para que comam e bebam, e depois voltem para o seu senhor»."
,"23":"O rei preparou-lhes um grande banquete. Eles comeram e beberam. Depois o rei despediu-os, e eles voltaram para o seu senhor. E os bandos arameus não voltaram a fazer incursões no território israelita."
,"24":"Tempos depois, Ben-Adad, rei de Aram, reuniu todo o seu exército e cercou a cidade de Samaria."
,"25":"Então houve grande fome em Samaria, e o cerco foi tão duro que um jumento chegou a valer novecentos gramas de prata, e sessenta gramas de raízes custavam sessenta gramas de prata."
,"26":"O rei de Israel estava passando pela muralha, e uma mulher gritou-lhe: «Socorro, senhor meu rei»."
,"27":"Ele respondeu: «Se Javé não te socorre, onde vou achar auxílio para te salvar? Na eira ou no lagar?»"
,"28":"Depois o rei perguntou: «O que te aconteceu?» Ela respondeu: «Esta mulher aqui disse-me: 'Traz o teu filho para o comermos hoje; amanhã comeremos o meu'."
,"29":"Nós cozinhámos o meu filho e comemo-lo. No dia seguinte, eu disse-lhe: 'Agora traz o teu filho para nós o comermos'. Mas ela escondeu o filho dela»."
,"30":"Quando o rei ouviu o que a mulher dizia, rasgou as próprias vestes. Aconteceu que o rei estava andando sobre a muralha, e todos puderam ver que ele usava um cilício."
,"31":"Então o rei disse: «Que Deus me castigue se Eliseu, filho de Safat, ainda hoje ficar com a cabeça em cima dos ombros»."
,"32":"Enquanto isso, Eliseu estava sentado em casa com os anciãos. O rei mandou um mensageiro na frente. Mas, antes que ele chegasse, Eliseu disse aos anciãos: «Ides ver como esse assassino mandou alguém para cortar a minha cabeça! Cuidado! Quando ele chegar, trancai a porta e não o deixeis entrar. Não será o barulho dos passos do senhor dele que vem logo atrás?»"
,"33":"Eliseu ainda estava a falar com eles, quando o rei chegou e disse: «Esta desgraça vem de Javé! Que mais posso esperar de Javé?»"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Eliseu respondeu: «Escutai a palavra de Javé: Assim diz Javé: Amanhã, a esta mesma hora, à porta de Samaria, uma arroba de flor de farinha vai custar onze gramas de prata, e duas arrobas de cevada valerão onze gramas»."
,"2":"O escudeiro, no qual o rei se apoiava, disse a Eliseu: «Mesmo que Javé abrisse janelas no céu, seria possível acontecer isso?» Eliseu respondeu: «Verás com os teus próprios olhos, mas não vais comer nada»."
,"3":"Quatro leprosos que estavam à entrada da cidade comentaram entre si: «Porque ficamos aqui à espera da morte?"
,"4":"Se resolvermos entrar na cidade, morreremos, porque nela reina a fome. Se ficarmos aqui, vamos morrer do mesmo modo. Então vamos para o lado do acampamento dos arameus: se nos deixarem viver, viveremos; se nos matarem, morreremos»."
,"5":"Ao cair da tarde, foram para o acampamento dos arameus e percorreram todo o acampamento. Não havia ninguém."
,"6":"O Senhor havia feito ouvir, no acampamento dos arameus, barulho de carros, de cavalos e de grande exército. Então os arameus disseram. «O rei de Israel deve ter contratado os reis heteus e os reis do Egipto para nos atacar!»"
,"7":"Ao anoitecer, eles levantaram-se e fugiram, abandonando tendas, cavalos, jumentos, e deixando o acampamento como estava. Eles fugiram para salvar a vida."
,"8":"Depois de percorrer o acampamento, os leprosos entraram numa tenda, onde comeram e beberam. Em seguida, tomaram prata, ouro e roupas, e esconderam tudo. Voltaram, entraram noutra tenda, pegaram em tudo o que encontraram e levaram-no para um esconderijo."
,"9":"Então comentaram: «Não estamos a agir bem. Hoje é um dia de boas notícias e nós estamos calados! Se esperarmos até amanhã de manhã, seremos castigados. Vamos levar a notícia ao palácio do rei»."
,"10":"Eles foram, chamaram os porteiros da cidade e informaram: «Fomos ao acampamento dos arameus: não há lá ninguém, não se ouve a voz de ninguém; há somente cavalos e jumentos amarrados, e as tendas estão abandonadas!»"
,"11":"Os porteiros gritaram para dentro e informaram o palácio do rei."
,"12":"Então o rei levantou-se de noite e disse aos seus oficiais: «Vou explicar-vos o que os arameus estão a tramar contra nós. Eles sabem que estamos a passar fome. Por isso, eles saíram do acampamento para se esconderem no campo. Estão a imaginar o seguinte: 'Eles vão sair da cidade. Então nós capturá-los-emos vivos e entraremos na cidade'»."
,"13":"Um dos oficiais sugeriu: «Vamos tomar cinco dos cavalos que estão vivos. O máximo que pode acontecer-lhes, é o que já está a acontecer a toda a multidão de Israel que resta na cidade, essa multidão de Israel que está a morrer. Vamos mandá-los e ver o que acontece!»"
,"14":"Então tomaram dois carros com os cavalos, e o rei mandou-os seguir o exército dos arameus, dizendo: «Ide lá e vede»."
,"15":"Eles foram até ao rio Jordão e viram que todo o caminho estava cheio de roupas e objectos que os arameus, cheios de pavor, tinham abandonado. Os mensageiros voltaram e contaram tudo ao rei."
,"16":"Então o povo saiu e saqueou o acampamento dos arameus. E uma arroba de flor de farinha passou a custar onze gramas de prata, e duas arrobas de cevada custavam onze gramas, conforme a palavra de Javé."
,"17":"O rei tinha posto como guarda da porta o escudeiro no qual se apoiava. O povo esmagou o escudeiro junto à porta, e ele morreu, como o homem de Deus havia predito. De facto ele havia predito isso quando o rei fora ter com ele."
,"18":"O homem de Deus tinha dito ao rei: «Amanhã, a esta mesma hora, à porta de Samaria, duas arrobas de cevada vão custar onze gramas de prata, e uma arroba de flor de farinha custará onze gramas»."
,"19":"E o escudeiro havia perguntado ao homem de Deus: «Mesmo que Javé abrisse janelas no céu, seria possível acontecer tal coisa?»,Eliseu respondera: «Vê-lo-ás com os teus próprios olhos, mas não vais comer nada». "
,"20":"Foi precisamente o que aconteceu: o povo esmagou o escudeiro à entrada da porta, e ele morreu."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Eliseu disse à mulher, cujo filho ele havia feito reviver: «Parte com a tua família e vai morar onde puderes, no estrangeiro, porque Javé mandou a fome, que já está a chegar ao país, e vai durar sete anos»."
,"2":"A mulher foi e fez o que o homem de Deus tinha mandado: partiu com a sua família e morou sete anos no território dos filisteus."
,"3":"Passados sete anos, ela voltou da terra dos filisteus, e foi reclamar junto do rei a respeito da sua casa e do seu terreno."
,"4":"O rei estava a conversar com Giezi, servo do homem de Deus. Ele dizia: «Conta-me todas as grandes coisas que Eliseu fez»."
,"5":"Giezi estava a contar ao rei a ressurreição do menino morto, quando a mulher, a quem Eliseu ressuscitara o filho, chegou para reclamar junto do rei a sua casa e o seu terreno. Giezi disse: «Senhor meu rei, é esta a mulher e este é o seu menino, que Eliseu ressuscitou»."
,"6":"O rei interrogou a mulher e ela contou o acontecido. Então o rei mandou que um funcionário a acompanhasse. E ordenou: «Seja restituído a esta mulher tudo o que lhe pertence e todos os rendimentos do terreno, desde o dia em que ela deixou o país até hoje»."
,"7":"Eliseu foi a Damasco, quando Ben-Adad, o rei de Aram, estava doente. Informaram o rei: «O homem de Deus está aqui»."
,"8":"Então o rei ordenou a Hazael: «Toma contigo um presente, vai ao encontro do homem de Deus e consulta Javé por meio dele, para saber se vou ficar curado desta doença»."
,"9":"Hazael foi ter com Eliseu, levando como presente quarenta camelos carregados de tudo o que havia de melhor em Damasco. Chegando à presença de Eliseu, disse: «O teu filho Ben-Adad, rei de Aram, mandou perguntar-te se ele vai ficar bom da doença»."
,"10":"Eliseu respondeu: «Diz ao rei que ele poderá curar-se. No entanto, Javé mostrou-me que ele certamente vai morrer»."
,"11":"Nesse momento, Eliseu ficou com o rosto imóvel e o olhar fixo. E o homem de Deus começou a chorar."
,"12":"Hazael perguntou: «Porque é que chora o meu senhor?» Eliseu respondeu: «Porque eu sei o mal que tu farás aos israelitas: vais incendiar fortalezas, passar ao fio de espada os jovens, esmagar as crianças e rasgar o ventre das mulheres grávidas!»"
,"13":"Hazael perguntou: «Mas será este teu servo um cão para fazer tais coisas?» Eliseu respondeu: «Javé mostrou-me numa visão que serás rei de Aram»."
,"14":"Hazael deixou Eliseu e voltou para o seu senhor. Este perguntou: «O que foi que Eliseu disse?» Hazael respondeu: «Ele disse que poderias curar-te»."
,"15":"No dia seguinte, Hazael tomou uma coberta, encharcou-a de água e colocou-a sobre o rosto de Ben-Adad, até que ele morreu. E Hazael reinou em seu lugar."
,"16":"Jorão, filho de Josafá, subiu ao trono de Judá no quinto ano do reinado de Jorão, filho de Acab, rei de Israel."
,"17":"Ele tinha trinta e dois anos quando subiu ao trono. E reinou oito anos em Jerusalém."
,"18":"Imitou o comportamento dos reis de Israel, como a família de Acab havia feito. Casou-se com uma mulher da família de Acab; e fez o que Javé reprova."
,"19":"Javé, porém, não quis destruir Judá, por causa do seu servo David, pois tinha-lhe prometido deixar sempre uma lâmpada na sua presença."
,"20":"No tempo de Jorão, rei de Judá, Edom conseguiu libertar-se do domínio de Judá e formar um reino independente."
,"21":"Jorão foi a Seira com todos os seus carros. Levantou-se de noite e, embora tivesse derrotado o exército edomita que o cercava e todos os seus comandantes de carros, a tropa de Jorão debandou e fugiu para as suas tendas."
,"22":"Deste modo, Edom tornou-se independente de Judá até hoje. Também foi nesta época que Lebna se rebelou."
,"23":"O resto da história de Jorão, e do que ele fez, tudo está escrito nos Anais dos Reis de Judá."
,"24":"Jorão morreu e foi enterrado com os seus antepassados na Cidade de David. E o seu filho Ocozias sucedeu-lhe no trono."
,"25":"Ocozias, filho de Jorão, subiu ao trono de Judá no ano doze do reinado de Jorão, rei de Israel, filho de Acab."
,"26":"Começou a reinar com vinte e dois anos. E reinou um ano em Jerusalém. Sua mãe chamava-se Atália e era filha de Amri, rei de Israel."
,"27":"Ocozias imitou o comportamento da família de Acab e, como esta, fez o que Javé reprova, pois era parente dessa família."
,"28":"Juntamente com Jorão, filho de Acab, Ocozias foi lutar em Ramot de Galaad contra Hazael, rei de Aram. Mas os arameus feriram Jorão,"
,"29":"que voltou para Jezrael, a fim de se tratar dos ferimentos que recebera dos arameus em Ramot, ao lutar contra Hazael, rei de Aram. Ocozias, filho de Jorão, rei de Judá, foi a Jezrael para visitar Jorão, filho de Acab, que estava ferido."
}`)
	CurrentBook.AddChapter(9, `{
"1":"O profeta Eliseu chamou um dos irmãos profetas, e ordenou-lhe: «Prepara-te, pega nesta vasilha de azeite e vai para Ramot de Galaad."
,"2":"Quando lá chegares, procura Jeú, filho de Josafá, neto de Namsi. Quando o encontrares, chama-o do meio dos seus companheiros e leva-o a um aposento separado."
,"3":"Pega então na vasilha e derrama o azeite sobre a sua cabeça, dizendo: 'Assim diz Javé: Eu te unjo rei de Israel'. Depois abre a porta e foge depressa»."
,"4":"O jovem foi para Ramot de Galaad."
,"5":"Ao chegar, encontrou os chefes do exército reunidos. E disse: «Chefe, tenho uma mensagem para ti». Jeú perguntou: «Para qual de nós?» O jovem respondeu: «Para ti, chefe»."
,"6":"Jeú levantou-se e entrou no aposento. Então o jovem derramou o azeite sobre a cabeça dele, e disse: «Assim diz Javé, o Deus de Israel: Eu te unjo rei de Israel, povo de Javé."
,"7":"Elimina a família de Acab, teu senhor, e Eu vingarei o sangue dos meus servos, os profetas, e de todos os servos de Javé, contra Jezabel"
,"8":"e contra toda a família de Acab. Eliminarei de Israel todos os homens da família de Acab, quer seja escravo quer seja livre."
,"9":"Tratarei a família de Acab como tratei a família de Jeroboão, filho de Nabat, e a família de Baasa, filho de Aías."
,"10":"Jezabel será devorada pelos cães no campo de Jezrael, e ninguém a enterrará». Dizendo isto, o jovem abriu a porta e fugiu."
,"11":"Jeú saiu para se reunir com os oficiais do seu senhor, e estes perguntaram-lhe: «Está tudo bem? O que é que esse louco queria?» Jeú respondeu: «Vós bem conheceis esse homem e o seu modo de falar»."
,"12":"Eles, porém, insistiram: «Vamos lá! Conta o que aconteceu». Jeú respondeu: «Ele disse-me o seguinte: 'Assim diz Javé: Eu te unjo rei de Israel'»."
,"13":"Imediatamente todos tomaram os seus mantos e estenderam-nos sobre os degraus, aos pés de Jeú. Depois tocaram a trombeta e aclamaram: «Jeú é rei!»"
,"14":"Jeú, filho de Josafá e neto de Namsi, organizou uma conspiração contra Jorão. Ora, Jorão estava com todo o Israel a defender Ramot de Galaad contra um ataque de Hazael, rei de Aram."
,"15":"O rei Jorão, porém, tinha voltado a Jezrael para se tratar dos ferimentos que recebera dos arameus na guerra contra Hazael, rei de Aram. Jeú disse aos chefes: «Se estais de acordo, não deixeis ninguém sair da cidade para levar a notícia a Jezrael». "
,"16":"Então Jeú subiu para o seu carro e partiu para Jezrael. Jorão estava lá, de cama, e Ocozias, rei de Judá, tinha vindo visitá-lo."
,"17":"A sentinela, que estava na torre de Jezrael, vendo aproximar-se o grupo de Jeú, disse: «Vejo aproximar-se uma tropa». Jorão ordenou: «Chama um cavaleiro e manda-o ao encontro deles para perguntar se trazem boas notícias»."
,"18":"O cavaleiro foi ao encontro de Jeú, e disse: «O rei manda perguntar se trazeis boas notícias». Jeú respondeu: «Que te importam as boas notícias? Segue-me». A sentinela anunciou: «O mensageiro chegou junto deles, mas não regressa»."
,"19":"Então o rei mandou outro cavaleiro, que se apresentou a Jeú, dizendo: «O rei manda perguntar se trazeis boas notícias». Jeú respondeu: «Que te importam as boas notícias? Segue-me»."
,"20":"A sentinela anunciou: «O mensageiro chegou junto deles, mas não regressa. Pelo modo de conduzir o carro, deve ser Jeú, neto de Namsi. Ele corre como um louco!»"
,"21":"Jorão disse: «Preparai o meu carro». O carro foi preparado, e Jorão, rei de Israel, e Ocozias, rei de Judá, cada qual no seu carro, saíram ao encontro de Jeú e encontraram-se com ele na propriedade de Nabot de Jezrael."
,"22":"Ao ver Jeú, Jorão perguntou: «Está tudo bem, Jeú?» Este respondeu: «Como pode estar tudo bem, se continuam as prostituições de tua mãe Jezabel e as inúmeras magias?»"
,"23":"Então Jorão virou o carro e fugiu, gritando para Ocozias: «É traição, Ocozias!»"
,"24":"Jeú, porém, já havia esticado o arco, e atingiu Jorão no meio das costas. A flecha atravessou o coração de Jorão, e ele caiu no carro."
,"25":"Jeú ordenou ao seu escudeiro Badacer: «Pega nele e atira-o para o terreno que pertencia a Nabot de Jezrael. Lembras-te de quando nós dois estávamos juntos num carro perseguindo Acab, o pai dele? Javé pronunciou então esta sentença contra ele:"
,"26":"'Ontem à tarde eu vi o sangue de Nabot e dos seus filhos, oráculo de Javé. Far-te-ei pagar na mesma moeda neste mesmo terreno, oráculo de Javé'. Agora, portanto, pega em Jorão e atira-o para este terreno, conforme a palavra de Javé»."
,"27":"Vendo isto, Ocozias, rei de Judá, fugiu pelo caminho de Bet-Gã. Jeú perseguiu-o e gritou: «Matai também Ocozias». Este foi ferido no seu carro, na subida de Gaver, perto de Jeblaam. Refugiou-se em Meguido, onde morreu."
,"28":"Foi levado num carro pelos seus servos para Jerusalém e enterrado no seu túmulo, juntamente com os seus antepassados, na Cidade de David."
,"29":"Ocozias tinha subido ao trono de Judá no ano onze do reinado de Jorão, filho de Acab."
,"30":"Jeú foi para Jezrael. Ao ser informada da sua chegada, Jezabel pintou os olhos, enfeitou a cabeça e pôs-se à janela."
,"31":"Quando Jeú atravessou a porta da cidade, ela perguntou: «Está tudo bem, ó Zambri, assassino do teu senhor?»"
,"32":"Jeú olhou para a janela e disse: «Quem está comigo?» Dois ou três funcionários disseram que estavam do lado dele."
,"33":"Então Jeú ordenou: «Atirai essa mulher daí abaixo». Eles atiraram-na. E o sangue dela salpicou as muralhas e os cavalos, que a esmagaram."
,"34":"Em seguida, Jeú entrou, comeu e bebeu. Depois disse: «Ide ver aquela maldita e enterrai-a, pois é filha de rei»."
,"35":"Mas, quando chegaram para a enterrar, só encontraram o crânio, os pés e as mãos."
,"36":"Foram contar a Jeú, e ele disse: «Esta foi a palavra que Javé pronunciou por meio do seu servo Elias, o tesbita: No campo de Jezrael, os cães devorarão a carne de Jezabel,"
,"37":"e o cadáver de Jezabel será como esterco espalhado pelo campo de Jezrael, de modo que não se poderá reconhecer que é Jezabel!»"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Em Samaria havia setenta filhos de Acab. Jeú escreveu cartas, e enviou-as para Samaria aos chefes da cidade, aos anciãos e tutores dos filhos de Acab. As cartas diziam:"
,"2":"«Quando esta carta chegar, vós, que tendes convosco os filhos do vosso senhor e possuís carros e cavalos, cidade fortificada e armas,"
,"3":"escolhei o melhor e o mais digno dos filhos do vosso senhor e colocai-o no trono do pai. Depois lutai pela família do vosso senhor!»"
,"4":"Eles, porém, ficaram com muito medo, e disseram: «Se dois reis não puderam resistir a Jeú, como é que nós vamos conseguir?»"
,"5":"Então o prefeito do palácio, o comandante da cidade, os anciãos e os tutores mandaram dizer a Jeú: «Somos teus servos. Faremos o que nos ordenares. Não vamos escolher nenhum rei. Faz o que achares melhor»."
,"6":"Jeú escreveu outra carta, dizendo: «Se estais do meu lado e quereis escutar-me, fazei o seguinte: pegai nas cabeças dos homens da família do vosso senhor e trazei-mas a Jezrael, amanhã, a esta mesma hora». Setenta filhos do rei moravam nas casas dos notáveis da cidade, onde eram educados."
,"7":"Quando a carta chegou, eles tomaram os filhos do rei, degolaram os setenta, puseram as cabeças dentro de cestos e mandaram-nas para Jezrael."
,"8":"Um mensageiro anunciou a Jeú: «Trouxeram as cabeças dos filhos do rei». Jeú ordenou: «Fazei com as cabeças dois montes à entrada, junto à porta da cidade, e deixai-as ali até amanhã de manhã»."
,"9":"E de manhã, Jeú saiu, e de pé falou a todo o povo: «Vós sois inocentes! De facto, eu conspirei contra o meu senhor e matei-o. Mas estes aqui, quem foi que os matou?"
,"10":"Pois ficai sabendo que não ficará sem se cumprir nenhuma palavra que Javé pronunciou contra a família de Acab. Javé realizou o que havia dito por meio do seu servo Elias»."
,"11":"E Jeú matou também todos os que restavam da família de Acab em Jezrael: notáveis, parentes e sacerdotes. Não sobrou nenhum."
,"12":"Jeú foi para Samaria. No caminho, em Curral dos Pastores,"
,"13":"encontrou parentes de Ocozias, rei de Judá, e perguntou: «Quem sois vós?» Eles responderam: «Somos parentes de Ocozias e vamos visitar os filhos do rei e os filhos da rainha-mãe»."
,"14":"Jeú ordenou: «Prendei vivos esses homens». Eles foram presos vivos e depois degolados junto do poço de Curral. Eram quarenta e dois, e não sobrou nenhum."
,"15":"Saindo dali, Jeú encontrou-se com Jonadab, filho de Recab, que vinha ao seu encontro, cumprimentou-o e disse-lhe: «És leal para mim como eu sou para ti?» Jonadab respondeu: «Sou». Jeú replicou: «Então, dá-me a mão». Jonadab estendeu-lhe a mão, e Jeú fê-lo subir para o seu lado no carro,"
,"16":"dizendo: «Vem comigo, e verás o zelo que eu tenho por Javé». E levou-o no carro."
,"17":"Ao entrar em Samaria, mandou matar todos os sobreviventes da família de Acab que estavam em Samaria. Exterminou toda a família de Acab, como Javé tinha dito a Elias."
,"18":"Jeú reuniu todo o povo e disse: «Acab prestou pouco culto a Baal. Jeú prestar-lhe-á muito mais."
,"19":"Agora, portanto, chamai todos os profetas de Baal, todos os seus fiéis e sacerdotes. Ninguém deve faltar, pois quero oferecer um grande sacrifício a Baal. Quem faltar, morrerá». Jeú agiu com astúcia para acabar com os fiéis de Baal."
,"20":"Jeú ordenou: «Convocai uma festa solene em honra de Baal». E eles convocaram-na."
,"21":"Jeú enviou mensageiros a todo o Israel, e todos os fiéis de Baal se apresentaram. Ninguém faltou. Foram para o templo de Baal, que ficou repleto."
,"22":"Jeú ordenou ao guarda do vestiário: «Traz vestes para todos os fiéis de Baal». E o guarda trouxe vestes para todos."
,"23":"Jeú e Jonadab, filho de Recab, foram para o templo. E Jeú disse aos fiéis de Baal: «Vede bem se aqui há somente devotos de Baal, e não de Javé»."
,"24":"Então Jeú aproximou-se para oferecer sacrifícios e holocaustos. Jeú, porém, tinha colocado do lado de fora oitenta homens, com esta ordem: «Quem deixar escapar uma só das pessoas que vos vou entregar pagará com a própria vida»."
,"25":"Quando acabou de oferecer o holocausto, Jeú ordenou aos guardas e escudeiros: «Entrai e matai-os todos. Não deixeis sair ninguém». Os guardas e escudeiros mataram-nos todos e atiraram-nos para fora. Depois voltaram ao templo de Baal,"
,"26":"arrancaram o poste sagrado do templo e queimaram-no."
,"27":"Derrubaram a estela de Baal, demoliram o templo de Baal e no lugar construíram latrinas, que ainda hoje lá estão."
,"28":"Jeú fez desaparecer Baal de Israel."
,"29":"Somente não se afastou dos pecados que Jeroboão, filho de Nabat, tinha feito cometer a Israel: os bezerros de ouro que estavam em Betel e Dã."
,"30":"Javé disse a Jeú: «Porque agiste bem, fazendo o que Eu aprovo, e trataste a família de Acab como Eu queria, os teus filhos sentar-se-ão no trono de Israel até à quarta geração»."
,"31":"Jeú, porém, não se preocupou em seguir de todo o coração a lei de Javé, Deus de Israel. Ele não se afastou dos pecados que Jeroboão tinha feito cometer a Israel."
,"32":"Nessa época, Javé começou a encurtar o território de Israel. Hazael venceu Israel em todas as fronteiras,"
,"33":"desde o rio Jordão até ao Oriente. E apossou-se de todo o território de Galaad, de Gad, de Rúben, de Manassés, desde Aroer, junto ao rio Arnon, assim como de Galaad e Basã."
,"34":"O resto da história de Jeú, e do que ele fez, tudo está escrito nos Anais dos Reis de Israel."
,"35":"Jeú morreu e foi enterrado em Samaria. E seu filho Joacaz sucedeu-lhe no trono."
,"36":"Jeú reinou vinte e oito anos sobre Israel, em Samaria."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Quando Atália, mãe de Ocozias, soube que o seu filho estava morto, resolveu acabar com a descendência real."
,"2":"Josaba, filha do rei Jorão e irmã de Ocozias, conseguiu salvar o seu sobrinho Joás dentre os filhos do rei que estavam a ser massacrados. Levou o menino, com a sua ama, para o quarto de dormir, escondendo-o de Atália. Assim, Joás escapou da morte."
,"3":"E Joás, com a sua ama, ficou seis anos escondido no Templo de Javé, enquanto Atália reinava no país."
,"4":"No sétimo ano, Joiada mandou chamar os oficiais dos mercenários e os guardas e reuniu-os no Templo de Javé. Ali concluiu uma aliança com eles, fez com que prestassem juramento e, então, mostrou-lhes o filho do rei."
,"5":"Em seguida, ordenou-lhes: «Eis o que deveis fazer: Um terço de vós, que entra em serviço no sábado para montar guarda no palácio real,"
,"6":"os que ficam na porta de Sur e os que ficam na porta atrás dos guardas, montarão guarda no Templo para controlar a entrada."
,"7":"Os outros dois grupos, que não trabalham no sábado, montarão guarda no Templo de Javé, junto do rei."
,"8":"Fazei em torno do rei um círculo, de armas em punho. Matai todo aquele que quiser forçar as fileiras. E estareis sempre junto do rei, aonde quer que ele vá»."
,"9":"Os oficiais fizeram como o sacerdote Joiada tinha mandado. Cada um deles reuniu os seus homens, tanto os que entravam em serviço no sábado como os que saíam, e foram ter com o sacerdote Joiada."
,"10":"O sacerdote entregou aos oficiais as lanças e escudos do rei David, que estavam no Templo de Javé."
,"11":"De armas em punho, os guardas tomaram os seus lugares, desde o ângulo Sul até ao ângulo Norte do Templo, rodeando o altar e o Templo, para protegerem o rei."
,"12":"Então Joiada mandou que trouxessem para fora o filho do rei, colocou-lhe a coroa e entregou-lhe o documento da aliança. Joás foi proclamado rei e ungido. Todos aplaudiram, aclamando: «Viva o rei!»"
,"13":"Ouvindo os gritos do povo, Atália foi ao encontro do povo no Templo de Javé."
,"14":"Mas quando viu o rei de pé no estrado, segundo o costume, os oficiais e os tocadores de trombeta junto do rei, todo o povo da terra gritando de alegria e tocando trombetas, ela rasgou as vestes e disse: «Traição, traição!»"
,"15":"Então o sacerdote Joiada ordenou aos oficiais das tropas: «Arrastai Atália para fora, por entre as fileiras. Se alguém a seguir, pas-sai-o a fio de espada». O sacerdote, de facto, havia dito: «Não a mateis dentro do Templo de Javé»."
,"16":"Agarraram Atália e, chegando ao palácio real, à entrada da porta dos Cavalos, ali a mataram."
,"17":"Joiada selou, entre Javé e o rei e o povo, a aliança, pela qual este se comprometia a ser o povo de Javé. Selou também uma aliança entre o rei e o povo."
,"18":"Em seguida, todo o povo foi até ao templo de Baal e arrasou-o: demoliram os altares e as imagens e, diante dos altares, executaram Matã, sacerdote de Baal. O sacerdote Joiada colocou guardas no Templo de Javé."
,"19":"Depois reuniu os oficiais, os mercenários, os guardas e todo o povo da terra. Levaram o rei desde o Templo de Javé até ao palácio real onde entrou pela porta dos Guardas. E Joás sentou-se no trono dos reis."
,"20":"Todo o povo da terra fez festa, e a cidade ficou tranquila, porque Atália tinha sido morta pela espada no palácio real."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Joás tinha sete anos quando começou a reinar."
,"2":"Subiu ao trono no sétimo ano de Jeú e reinou quarenta anos em Jerusalém. Sua mãe chamava-se Sebias e era natural de Bersabeia."
,"3":"Durante toda a sua vida, Joás fez o que Javé aprova, pois tinha sido educado pelo sacerdote Joiada."
,"4":"Contudo, os lugares altos não desapareceram, e o povo continuou a oferecer sacrifícios e a queimar incenso nos lugares altos."
,"5":"Joás disse aos sacerdotes: «Todo o dinheiro das ofertas sagradas oferecido ao Templo de Javé, o dinheiro que circula, o dinheiro das taxas individuais, o dinheiro das ofertas voluntárias, tudo seja levado para o Templo de Javé."
,"6":"Que os sacerdotes o recolham da mão de conhecidos seus, para fazer as reformas necessárias no Templo»."
,"7":"Aconteceu que, no ano vinte e três do reinado de Joás, os sacerdotes ainda não tinham feito as reformas necessárias no Templo de Javé."
,"8":"O rei Joás mandou chamar o sacerdote Joiada e os outros sacerdotes, e perguntou-lhes: «Porque não fizestes a reforma do Templo? De agora em diante, não ficareis mais com o dinheiro entregue pelos vossos conhecidos; tendes de entregá-lo para a reforma do Templo»."
,"9":"Os sacerdotes concordaram em não receber dinheiro do povo, e não serem mais os encarregados da reforma do Templo."
,"10":"Então o sacerdote Joiada tomou um cofre, fez um buraco na tampa e colo-cou-o junto do altar, no lado direito de quem entra no Templo de Javé. E os sacerdotes porteiros depositavam ali todo o dinheiro que era levado para o Templo."
,"11":"Quando eles viam que havia muito dinheiro no cofre, o secretário do rei e o sumo sacerdote iam, recolhiam e contavam o dinheiro que havia no Templo de Javé."
,"12":"Depois de ter conferido o dinheiro, entregavam-no aos mestres de obras encarregados do Templo de Javé. Estes utilizavam o dinheiro para pagar aos carpinteiros e construtores que trabalhavam no Templo de Javé,"
,"13":"pedreiros e escultores, e também para comprar madeira e pedra utilizadas na restauração do Templo de Javé."
,"14":"Com esse dinheiro oferecido para o Templo de Javé, não se faziam taças de prata, facas, bacias para aspersão, trombetas, nem objectos de ouro ou prata."
,"15":"O dinheiro era entregue aos mestres de obras, que o usavam na reforma do Templo de Javé."
,"16":"Nem se pediam contas aos homens que recebiam o dinheiro para pagar os operários, porque eles agiam com honestidade."
,"17":"Contudo, o dinheiro oferecido para os sacrifícios de reparação e os sacrifícios pelo pecado não era destinado ao Templo de Javé, mas aos sacerdotes."
,"18":"Hazael, rei de Aram, depois de fazer guerra contra Gat e de a tomar, resolveu subir para atacar Jerusalém."
,"19":"Então Joás, rei de Judá, tomou os objectos que seus antepassados, Josafá, Jorão e Ocozias, reis de Judá, haviam consagrado, e que ele próprio havia consagrado, todo o ouro que existia nos tesouros do Templo de Javé e no palácio real; tomou tudo isto e entregou-o a Hazael, rei de Aram. Então este retirou-se de Jerusalém."
,"20":"O resto da história de Joás, e do que ele fez, tudo está escrito nos Anais dos Reis de Judá."
,"21":"Os seus oficiais rebelaram-se e traíram-no: Joás foi morto em Bet-Melo, na descida do aterro."
,"22":"Foram os seus oficiais Jozacar, filho de Semaat, e Jozabad, filho de Somer, que o feriram de morte. Joás foi enterrado com os seus antepassados na Cidade de David. E seu filho Amasias sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Joacaz, filho de Jeú, começou a reinar sobre Israel, em Samaria, no ano vinte e três do rei Joás, filho de Ocozias, rei de Judá. Reinou dezassete anos."
,"2":"Fez o que Javé reprova: imitou os pecados que Jeroboão, filho de Nabat, havia feito cometer a Israel, e não os eliminou."
,"3":"Por isso, a ira de Javé inflamou-se contra Israel e, durante todo esse período, tornou-o submisso a Hazael, rei de Aram, e a Ben-Adad, filho de Hazael."
,"4":"Então Joacaz implorou a Javé, e Javé escutou-o, porque viu como o rei de Aram oprimia Israel."
,"5":"Javé deu a Israel um libertador, que o libertou do poder de Aram. E os israelitas puderam morar em suas tendas, como antes."
,"6":"Não se afastaram, porém, dos pecados que Jeroboão tinha feito cometer a Israel. Continuaram a cometê-los. Até mesmo o poste sagrado continuou erguido em Samaria."
,"7":"Foi por isso que Javé deixou a Joacaz somente cinquenta cavaleiros, dez carros e dez mil soldados de infantaria. O rei de Aram havia-os exterminado e reduzido à poeira da estrada."
,"8":"O resto da história de Joacaz, do que ele fez e suas façanhas, tudo está escrito nos Anais dos Reis de Israel."
,"9":"Joacaz morreu e foi enterrado em Samaria. E o seu filho Joás sucedeu-lhe no trono."
,"10":"Joás, filho de Joacaz, começou a reinar sobre Israel, na Samaria, no ano trinta e sete de Joás, rei de Judá. Reinou dezasseis anos."
,"11":"Fez o que Javé reprova, e não se afastou dos pecados que Jeroboão, filho de Nabat, havia feito cometer a Israel, e continuou a praticá-los."
,"12":"O resto da história de Joás, do que ele fez e as suas façanhas, a guerra que moveu contra Amasias, rei de Judá, tudo está escrito nos Anais dos Reis de Israel."
,"13":"Joás foi juntar-se aos seus antepassados. E Jeroboão sucedeu-lhe no trono. Joás foi enterrado em Samaria, com os reis de Israel."
,"14":"Quando Eliseu contraiu a doença que o levaria à morte, Joás, rei de Israel, foi visitá-lo. E chorou sobre ele, dizendo: «Meu pai, meu pai! Carro e cavalaria de Israel!»"
,"15":"Eliseu disse: «Vai buscar o arco e algumas flechas». Joás foi buscar o arco e algumas flechas."
,"16":"Então Eliseu ordenou ao rei: «Segura o arco». E Joás segurou o arco. Eliseu pôs as mãos sobre as mãos do rei,"
,"17":"e disse: «Abre a janela do lado do Oriente». E o rei abriu a janela. Eliseu ordenou: «Atira». E Joás atirou. Eliseu exclamou: «Flecha vitoriosa para Javé! Flecha vitoriosa contra Aram! Vencerás Aram em Afec até o eliminares»."
,"18":"E continuou: «Pega nas flechas». Joás pegou nas flechas. Eliseu ordenou ao rei: «Golpeia o chão». O rei disparou três flechas, e parou."
,"19":"O homem de Deus ficou irritado contra o rei e disse: «Deverias ter disparado cinco ou seis flechas! Então derrotarias Aram até o eliminares. Mas agora, só vencerás Aram três vezes!»"
,"20":"Eliseu morreu e foi a enterrar. Todos os anos, bandos moabitas faziam incursões no país."
,"21":"Certa vez, alguns homens que estavam a enterrar um morto avistaram um desses bandos. Atiraram o corpo para dentro do túmulo de Eliseu e fugiram. Aconteceu que o morto, ao tocar nos ossos de Eliseu, voltou à vida e pôs-se de pé."
,"22":"Hazael, rei de Aram, oprimiu os israelitas durante todo o tempo em que Joacaz viveu."
,"23":"Javé, porém, teve piedade e compadeceu-Se deles. Voltou-Se para eles, por causa da aliança que tinha feito com Abraão, Isaac e Jacob, e ainda não quis destruí-los, nem os afastou da sua presença."
,"24":"Hazael, rei de Aram, morreu. E seu filho Ben-Adad subiu ao trono em seu lugar."
,"25":"Então Joás, filho de Joacaz, retomou do poder de Ben-Adad, filho de Hazael, as cidades que Hazael tinha arrebatado a seu pai Joacaz durante a guerra. Joás venceu três vezes os arameus, e reconquistou as cidades de Israel."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Amasias, filho de Joás, começou a reinar em Judá no segundo ano do rei Joás, filho de Joacaz, rei de Israel."
,"2":"Tinha vinte e cinco anos quando subiu ao trono. E reinou vinte e nove anos em Jerusalém. Sua mãe chamava-se Joaden e era natural de Jerusalém."
,"3":"Fez o que Javé aprova, mas não como o seu antepassado David. Seguiu em tudo o seu pai Joás."
,"4":"Todavia, os lugares altos não desapareceram, e o povo continuou a oferecer sacrifícios e a queimar incenso nos lugares altos."
,"5":"Tendo consolidado o poder nas suas mãos, Amasias mandou matar os oficiais que tinham assassinado o rei, seu pai."
,"6":"Ele, porém, não mandou matar os filhos dos assassinos, respeitando assim o que está escrito no livro da Lei de Moisés, onde Javé ordena: «Os pais não serão mortos por causa de seus filhos, nem os filhos serão mortos por causa dos pais. Cada um morrerá por causa do seu próprio pecado»."
,"7":"Amasias derrotou os edomitas no Vale do Sal, cerca de dez mil homens. Durante a guerra, conquistou Rocha e mudou-lhe o nome para Jecetel, nome que se conserva até hoje."
,"8":"Amasias mandou, então, emissários a Joás, filho de Joacaz e neto de Jeú, rei de Israel, com esta mensagem: «Vem para me enfrentar»."
,"9":"Joás, rei de Israel, respondeu a Amasias, rei de Judá, com esta mensagem: «O espinheiro do Líbano mandou dizer ao cedro do Líbano: 'Dá-me a tua filha como esposa para o meu filho'. Mas as feras do Líbano passaram e esmagaram o espinheiro."
,"10":"Derrotaste Edom e encheste-te de orgulho. Celebra a tua glória, mas fica em casa. Porque queres entrar numa guerra desastrosa, provocando a tua ruína e a ruína de Judá?»"
,"11":"Amasias, porém, não fez caso. Então Joás, rei de Israel, foi enfrentar Amasias, rei de Judá, em Bet-Sames, que pertence a Judá."
,"12":"E Judá foi derrotado por Israel e cada um fugiu para a sua tenda."
,"13":"Em Bet-Sames, Joás, rei de Israel, prendeu Amasias, filho de Joás e neto de Ocozias, e levou-o para Jerusalém. Abriu uma brecha de duzentos metros na muralha de Jerusalém, desde a porta de Efraim até à porta do Ângulo,"
,"14":"e apoderou-se do ouro, da prata e de todos os objectos que estavam no Templo de Javé e no tesouro do palácio real. Além disso, tomou reféns, e voltou para Samaria."
,"15":"O resto da história de Joás, todas as suas façanhas militares e a guerra que fez contra Amasias, rei de Judá, tudo está escrito nos Anais dos Reis de Israel."
,"16":"Joás foi juntar-se aos seus antepassados e foi enterrado na Samaria, com os reis de Israel. E o seu filho Jeroboão sucedeu-lhe no trono."
,"17":"Amasias, filho de Joás, rei de Judá, viveu ainda quinze anos depois da morte de Joás, filho de Joacaz, rei de Israel."
,"18":"O resto da história de Amasias está escrito nos Anais dos Reis de Judá."
,"19":"Ele foi vítima de uma conspiração em Jerusalém e fugiu para Láquis. Mas foi perseguido até Láquis, e ali o mataram."
,"20":"Transportaram o seu corpo sobre um cavalo, e enterraram-no em Jerusalém, com os seus antepassados, na Cidade de David."
,"21":"Todo o povo de Judá escolheu então Ozias, que tinha dezasseis anos, e proclamaram-no rei em lugar de seu pai Amasias."
,"22":"Foi ele que reconstruiu Elat e a reconquistou para Judá, depois de Amasias ter morrido."
,"23":"Jeroboão, filho de Joás, começou a reinar sobre Israel, em Samaria, no ano quinze do rei Amasias, filho de Joás, rei de Judá. Reinou quarenta e um anos."
,"24":"Fez o que Javé reprova, e não se afastou de todos os pecados que Jeroboão, filho de Nabat, tinha feito cometer a Israel."
,"25":"Jeroboão restabeleceu as fronteiras de Israel, desde a entrada de Emat até ao mar da Arabá, conforme a palavra de Javé, o Deus de Israel, anunciada através do seu servo, o profeta Jonas, filho de Amati, natural de Gat-Ofer."
,"26":"De facto, Javé viu que a aflição de Israel era muito amarga, pois não havia nem escravo nem livre que fosse em socorro de Israel."
,"27":"Como Javé não decidira apagar o nome de Israel debaixo do céu, então libertou-o através de Jeroboão, filho de Joás."
,"28":"O resto da história de Jeroboão, do que ele fez, as suas façanhas e guerras, como reconquistou para Israel Damasco e Emat, que tinham pertencido a Judá, tudo isso está escrito nos Anais dos Reis de Israel."
,"29":"Jeroboão juntou-se aos seus antepassados e foi enterrado na Samaria, junto dos reis de Israel. E seu filho Zacarias sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Ozias, filho de Amasias, começou a reinar em Judá no ano vinte e sete de Jeroboão, rei de Israel."
,"2":"Tinha dezasseis anos quando subiu ao trono, e reinou cinquenta e dois anos em Jerusalém. Sua mãe chamava-se Jequelias e era natural de Jerusalém."
,"3":"Fez o que Javé aprova, como tinha feito seu pai Amasias."
,"4":"Os lugares altos, porém, não desapareceram, e o povo continuou a oferecer sacrifícios e a queimar incenso nos lugares altos."
,"5":"Contudo, Javé feriu o rei com lepra, que durou até à sua morte. Por isso ele ficou fechado num quarto, enquanto o seu filho Joatão, chefe do palácio, governava o povo."
,"6":"O resto da história de Ozias, e do que ele fez, tudo está escrito nos Anais dos Reis de Judá."
,"7":"Ozias morreu e foi enterrado com os seus antepassados na Cidade de David. E seu filho Joatão sucedeu-lhe no trono."
,"8":"Zacarias, filho de Jeroboão, começou a reinar sobre Israel, na Samaria, no ano trinta e oito de Ozias, rei de Judá. Reinou seis meses."
,"9":"Fez o que Javé reprova, como os seus antepassados, e não se afastou dos pecados que Jeroboão, filho de Nabat, tinha feito cometer a Israel."
,"10":"Selum, filho de Jabes, fez uma conspiração contra Zacarias, matou-o em Jeblaam e usurpou-lhe o trono."
,"11":"O resto da história de Zacarias está escrito nos Anais dos Reis de Israel."
,"12":"Aconteceu, então, o que Javé tinha dito a Jeú: «Os teus filhos sentar-se-ão no trono de Israel até à quarta geração»."
,"13":"Selum, filho de Jabes, começou a reinar no ano trinta e nove de Ozias, rei de Judá. Reinou um mês em Samaria."
,"14":"Manaém, filho de Gadi, partiu de Tersa, entrou em Samaria, matou Selum, filho de Jabes, e usurpou o trono."
,"15":"O resto da história de Selum e a conspiração que ele tramou, tudo está escrito nos Anais dos Reis de Israel."
,"16":"Manaém devastou Tafua e o seu território, matando todos os seus habitantes, porque não lhe haviam aberto as portas quando ele saiu de Tersa. Manaém arrasou a cidade e rasgou o ventre de todas as mulheres grávidas."
,"17":"Manaém, filho de Gadi, começou a reinar em Israel no ano trinta e nove de Ozias, rei de Judá. Reinou dez anos em Samaria."
,"18":"Fez o que Javé reprova, e não se afastou dos pecados que Jeroboão, filho de Nabat, fizera cometer a Israel. No seu tempo,"
,"19":"Pul, rei da Assíria, invadiu o país. Manaém pagou a Pul trinta e quatro toneladas de prata, para que Pul o apoiasse e o mantivesse no trono."
,"20":"Manaém requereu essa contribuição a todos os notáveis de Israel, a cada um cerca de meio quilo de prata, para a dar ao rei da Assíria. Então o rei da Assíria retirou-se, pondo fim à ocupação do país."
,"21":"O resto da história de Manaém, e do que ele fez, tudo está escrito nos Anais dos Reis de Israel."
,"22":"Manaém juntou-se aos seus antepassados. E o seu filho Faceias sucedeu-lhe no trono."
,"23":"Faceias, filho de Manaém, começou a reinar em Israel no ano cinquenta de Ozias, rei de Judá. Reinou dois anos na Samaria."
,"24":"Fez o que Javé reprova, e não se afastou dos pecados que Jeroboão, filho de Nabat, fizera cometer a Israel."
,"25":"O seu oficial Faceia, filho de Romelias, conspirou contra ele e assassinou-o na torre do palácio real, em Samaria. Trazendo consigo cinquenta homens de Galaad, Faceia matou o rei e usurpou o trono."
,"26":"O resto da história de Faceia está escrito nos Anais dos Reis de Israel."
,"27":"Faceia, filho de Romelias, começou a reinar em Israel no ano cinquenta e dois de Ozias, rei de Judá. Reinou vinte anos em Samaria."
,"28":"Fez o que Javé reprova, e não se afastou dos pecados que Jeroboão, filho de Nabat, fizera cometer a Israel."
,"29":"No tempo de Faceia, rei de Israel, Teglat-Falasar, rei da Assíria, apoderou-se de Aion, Abel-Bet-Maaca, Janoe, Cedes, Hasor, Galaad, Galileia e de toda a região de Neftali; e deportou os seus habitantes para a Assíria."
,"30":"No ano vinte de Joatão, filho de Ozias, Oseias, filho de Ela, fez uma conspiração contra Faceia, filho de Romelias, matou-o e usurpou-lhe o poder."
,"31":"O resto da história de Faceia, e do que ele fez, tudo está escrito nos Anais dos Reis de Israel."
,"32":"Joatão, filho de Ozias, começou a reinar em Judá no segundo ano de Faceia, filho de Romelias, rei de Israel."
,"33":"Tinha vinte e cinco anos quando subiu ao trono, e reinou dezasseis anos em Jerusalém. Sua mãe chamava-se Jerusa, e era filha de Sadoc."
,"34":"Fez o que Javé aprova e imitou em tudo o comportamento de seu pai Ozias."
,"35":"Os lugares altos, porém, não desapareceram, e o povo continuou a oferecer sacrifícios e a queimar incenso nos lugares altos. Foi ele que construiu a Porta Superior do Templo de Javé."
,"36":"O resto da história de Joatão, e do que ele fez, tudo está escrito nos Anais dos Reis de Judá."
,"37":"Nesses dias, Javé começou a enviar Rason, rei de Aram, e Faceia, filho de Romelias, contra Judá."
,"38":"Joatão morreu e foi enterrado com os seus antepassados na Cidade de David, seu antepassado. Seu filho Acaz sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Acaz, filho de Joatão, começou a reinar em Judá no ano dezassete de Faceia, filho de Romelias."
,"2":"Acaz subiu ao trono com vinte anos, e reinou dezasseis anos em Jerusalém. Não fez, como o seu antepassado David, o que Javé seu Deus aprova."
,"3":"Imitou o comportamento dos reis de Israel e chegou até a sacrificar o seu filho no fogo, conforme os costumes abomináveis das nações que Javé tinha expulsado diante dos israelitas."
,"4":"Ofereceu sacrifícios e queimou incenso nos lugares altos, nas colinas e debaixo de toda a árvore frondosa."
,"5":"Nesse tempo, Rason, rei de Aram, e Faceia, filho de Romelias e rei de Israel, subiram para atacar Jerusalém. Cercaram-na, mas não puderam conquistá-la."
,"6":"Na mesma época, o rei de Edom reconquistou Elat para os edomitas, expulsando os judaítas que ali moravam. Os edomitas ocuparam Elat e ali se estabeleceram até ao dia de hoje."
,"7":"Então Acaz mandou mensageiros a Teglat-Falasar, rei da Assíria, com esta mensagem: «Sou teu filho e servo. Vem libertar-me do poder do rei de Aram e do rei de Israel, que se levantaram contra mim»."
,"8":"Acaz tomou a prata e o ouro que havia no Templo de Javé e nos tesouros do palácio real, e enviou-os como presente ao rei da Assíria."
,"9":"O rei da Assíria atendeu o pedido de Acaz, lutou contra Damasco e apoderou-se dela; deportou os seus habitantes para Quir e mandou matar Rason."
,"10":"O rei Acaz foi a Damasco para se apresentar a Teglat-Falasar, rei da Assíria. Quando viu o altar que havia em Damasco, mandou ao sacerdote Urias o desenho do altar, com todos os pormenores."
,"11":"Antes que o rei voltasse de Damasco, o sacerdote Urias construiu um altar, seguindo todas as instruções que recebera do rei."
,"12":"Quando o rei Acaz voltou de Damasco, viu o altar, aproximou-se e subiu até junto dele."
,"13":"Queimou sobre o altar o seu holocausto e as suas ofertas, derramou a sua libação e espalhou o sangue dos seus sacrifícios de comunhão."
,"14":"Depois mandou tirar da fachada do Templo o antigo altar de bronze, que estava diante de Javé, isto é, entre o altar novo e o Templo, e colocou-o no lado Norte do novo altar."
,"15":"Depois ordenou ao sacerdote Urias: «É sobre o altar grande que deverás queimar o holocausto da manhã e a oferta da tarde, o holocausto e a oferta do rei, assim como o holocausto, a oferta e as libações de todo o povo. Derrama sobre ele todo o sangue dos holocaustos e dos sacrifícios. Eu ocupar-me-ei do altar de bronze»."
,"16":"O sacerdote Urias fez tudo o que o rei Acaz havia mandado."
,"17":"O rei Acaz arrancou as armações das bases e tirou as bacias das bases. Mandou retirar o Mar de bronze que ficava sobre os bois, e mandou-o colocar sobre um suporte de pedra."
,"18":"Em consideração ao rei da Assíria, tirou o estrado do trono que ficava no Templo de Javé e a entrada exterior do rei."
,"19":"O resto da história de Acaz, e do que ele fez, tudo está escrito nos Anais dos Reis de Judá."
,"20":"Acaz morreu e foi enterrado com os seus antepassados na Cidade de David. E o seu filho Ezequias sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Oseias, filho de Ela, começou a reinar em Israel no ano doze do reinado de Acaz, rei de Judá. Reinou nove anos na Samaria."
,"2":"Fez o que Javé reprova, mas não tanto como os reis de Israel que vieram antes dele."
,"3":"Salmanasar, rei da Assíria, atacou Oseias, e este teve que se submeter e pagar tributo."
,"4":"Mas o rei da Assíria descobriu que Oseias o estava a trair. De facto, Oseias tinha enviado mensageiros a Sô, rei do Egipto. E também deixara de pagar tributo ao rei da Assíria, como fazia todos os anos. Então o rei da Assíria prendeu-o e meteu-o na prisão."
,"5":"Em seguida, o rei da Assíria invadiu todo o país e cercou Samaria durante três anos."
,"6":"No ano nove do reinado de Oseias, o rei da Assíria tomou Samaria e deportou os israelitas para a Assíria. Os israelitas foram levados para Hala, para as margens do Habor, rio de Gozã, e também para as cidades da Média."
,"7":"Tudo isso aconteceu porque os israelitas pecaram contra Javé seu Deus, que os havia tirado da terra do Egipto e libertado da opressão do Faraó, rei do Egipto. Eles adoraram outros deuses,"
,"8":"e seguiram os costumes das nações que Javé havia expulsado diante deles."
,"9":"Os israelitas fizeram contra Javé seu Deus coisas que não deveriam ter feito: construíram para si lugares altos em todas as suas cidades, tanto nas torres de vigia como nas cidades fortificadas;"
,"10":"levantaram para si estelas e postes sagrados sobre todas as colinas altas e debaixo de toda a árvore frondosa;"
,"11":"queimaram incenso em todos os lugares altos, como faziam as nações que Javé havia expulsado diante deles; cometeram acções más, provocando a ira de Javé;"
,"12":"adoraram os ídolos, embora Javé tivesse dito: «Não façais tal coisa»."
,"13":"Javé tinha avisado Israel e Judá, por meio de todos os profetas e videntes, dizendo: «Convertei-vos do vosso mau comportamento, e obedecei aos meus mandamentos e estatutos, de acordo com toda a Lei que dei aos vossos antepassados e que vos transmiti através dos meus servos, os profetas»."
,"14":"Eles, porém, não obedeceram e foram mais teimosos ainda que os seus antepassados, que não tinham acreditado em Javé seu Deus."
,"15":"Desprezaram os seus estatutos e a aliança que Ele havia feito com os seus antepassados, bem como as advertências que lhes havia feito. Correram atrás de ídolos vazios, e esvaziaram-se, imitando as nações vizinhas, coisa que Javé lhes tinha proibido."
,"16":"Rejeitaram todos os mandamentos de Javé seu Deus; fabricaram ídolos de metal fundido, dois bezerros de ouro; fizeram um poste sagrado; adoraram todo o exército do céu e prestaram culto a Baal."
,"17":"Sacrificaram no fogo os seus filhos e filhas, praticaram a adivinhação e a magia, e venderam-se para praticar o mal diante de Javé, provocando a sua ira."
,"18":"Então Javé ficou irritado contra Israel, e atirou-o para longe de Si. Restou apenas a tribo de Judá."
,"19":"Também Judá não obedeceu aos mandamentos de Javé seu Deus, mas imitou o comportamento de Israel."
,"20":"Por isso, Javé rejeitou toda a descendência de Israel. Humilhou-a e entregou-a aos saqueadores e por fim atirou-a para longe de Si."
,"21":"Quando Javé separou Israel da casa de David, Israel proclamou rei a Jeroboão, filho de Nabat. E Jeroboão afastou Israel de Javé e levou-o a cometer um grande pecado."
,"22":"Os israelitas imitaram o pecado que Jeroboão tinha cometido, e não se afastaram dele."
,"23":"Finalmente, Javé afastou Israel da sua presença, conforme havia anunciado por meio dos seus servos, os profetas. Exilou os israelitas da sua terra para a Assíria, onde até hoje se encontram."
,"24":"O rei da Assíria mandou vir gente de Babilónia, de Cuta, Ava, Emat e Sefarvaim, e estabeleceu-os nas cidades da Samaria, em lugar dos israelitas. Tomaram posse da Samaria e instalaram-se nas suas cidades."
,"25":"Quando começaram a instalar-se no território, não temiam a Javé, e Javé mandou contra eles leões que os matavam."
,"26":"Eles então comunicaram ao rei da Assíria: «As pessoas que transferiste para as cidades da Samaria não conhecem o ritual do Deus da terra, e Ele mandou leões contra essas pessoas. Os leões matam-nas, porque elas não conhecem o ritual do Deus da terra»."
,"27":"Então o rei da Assíria ordenou: «Mandai para lá um dos sacerdotes deportados da Samaria, para que more lá, e ensine às pessoas o ritual do Deus da terra»."
,"28":"Então um dos sacerdotes que tinham sido deportados da Samaria foi, e fixou-se em Betel. Ele ensinou às pessoas como prestar culto a Javé."
,"29":"Cada grupo, porém, foi fabricando os seus próprios deuses, e colocou-os nos templos dos lugares altos que os samaritanos tinham feito. Cada grupo fez isso nas cidades em que morava."
,"30":"Os babilónios fizeram uma estátua de Sucot-Benot; os de Cuta, uma de Nergel; os de Emat, uma de Asima;"
,"31":"os de Ava, uma de Nebaaz e uma de Tartac; os de Sefarvaim queimavam os seus filhos em honra de Adramelec e de Anamelec, deuses de Sefarvaim."
,"32":"Também prestavam culto a Javé. Nomearam, como sacerdotes, pessoas comuns, para que servissem nos templos dos lugares altos."
,"33":"Temiam a Javé e também adoravam os seus deuses, conforme o costume das nações de onde tinham sido exilados."
,"34":"Ainda hoje seguem os seus ritos antigos. Não temem a Javé, nem praticam os seus estatutos e normas, nem a lei e os mandamentos que Javé ordenou aos filhos de Jacob, a quem tinha dado o nome de Israel."
,"35":"Javé tinha feito uma aliança com eles e ordenara: «Não adoreis outros deuses, não vos prostreis diante deles, não lhes presteis culto e não lhes ofereçais sacrifícios."
,"36":"Deveis prestar culto, adorar e oferecer sacrifícios somente a Javé, que vos tirou do Egipto, com grande força e braço estendido."
,"37":"Observai os estatutos e normas, a lei e os mandamentos que Javé vos deu por escrito. Procurai pô-los sempre em prática. Não presteis culto a outros deuses."
,"38":"Não esqueçais a aliança que fiz convosco, e não presteis culto a outros deuses."
,"39":"Temei somente a Javé vosso Deus, e Ele vos libertará de todos os vossos inimigos»."
,"40":"Eles, porém, não obedeceram e continuaram a viver conforme o costume antigo."
,"41":"Deste modo, esses grupos adoravam a Javé e, ao mesmo tempo, prestavam culto aos seus próprios ídolos. Os seus filhos e netos continuaram a fazer até hoje o que os seus antepassados haviam feito."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Ezequias, filho de Acaz, começou a reinar em Judá no terceiro ano do rei Oseias, filho de Ela, rei de Israel."
,"2":"Tinha vinte e cinco anos quando subiu ao trono, e reinou vinte e nove anos em Jerusalém. A sua mãe chamava-se Abia, e era filha de Zacarias."
,"3":"Ezequias fez o que Javé aprova, seguindo em tudo o seu antepassado David."
,"4":"Acabou com os lugares altos, quebrou as estelas e derrubou os postes sagrados. Despedaçou também a serpente de bronze que Moisés havia feito, porque os israelitas ainda queimavam incenso diante dela. Chamavam-lhe Noestã."
,"5":"Ezequias pôs a sua confiança em Javé, Deus de Israel. Tanto antes como depois não existiu nenhum rei em Judá que pudesse ser comparado a ele."
,"6":"Permaneceu fiel a Javé e nunca se afastou d'Ele, observando os mandamentos que Javé tinha ordenado a Moisés."
,"7":"Javé esteve com ele. Por isso, teve êxito em tudo o que fez. Revoltou-se contra o rei da Assíria e não lhe ficou submisso."
,"8":"Derrotou os filisteus até Gaza, devastando-lhes o território, tanto as torres de vigia como as cidades fortificadas."
,"9":"No quarto ano do reinado de Ezequias e sétimo de Oseias, filho de Ela, rei de Israel, Salmanasar, rei da Assíria, atacou e cercou Samaria."
,"10":"Após três anos, tomou a cidade. Samaria foi conquistada no sexto ano de Ezequias e nono ano de Oseias, rei de Israel."
,"11":"O rei da Assíria deportou os israelitas para a Assíria e levou-os para Hala, para as margens do Habor, rio de Gozã, e para as cidades da Média."
,"12":"Isto aconteceu porque os israelitas não obedeceram a Javé seu Deus e transgrediram a sua aliança: não ouviram nem praticaram tudo o que Moisés, servo de Javé, lhes havia ordenado."
,"13":"No ano catorze do reinado de Ezequias, Senaquerib, rei da Assíria, atacou todas as cidades fortificadas de Judá e apossou-se delas."
,"14":"Então Ezequias, rei de Judá, mandou esta mensagem ao rei da Assíria, que estava em Láquis: «Cometi um erro. Não me ataques. Eu aceitarei as condições que me impuseres». O rei da Assíria exigiu que Ezequias, rei de Judá, pagasse uma taxa de dez toneladas de prata e mil quilos de ouro."
,"15":"Então Ezequias entregou toda a prata que havia no Templo de Javé e no tesouro do palácio real."
,"16":"Mandou também tirar o ouro com que Ozias, rei de Judá, havia revestido as portas e os batentes do santuário de Javé, e entregou-o ao rei da Assíria."
,"17":"De Láquis, o rei da Assíria mandou o chefe do exército, o chefe dos funcionários e o chefe dos copeiros, para que fossem, com forte destacamento, até Jerusalém, ao encontro do rei Ezequias. Eles chegaram a Jerusalém e passaram perto do canal que leva água para o reservatório superior, no caminho do Campo do Pisoeiro."
,"18":"Chamaram o rei. Então saíram ao encontro deles Eliacim, filho de Helcias, administrador do palácio, o escrivão Sobna e o secretário Joaé, filho de Asaf."
,"19":"O chefe dos copeiros então disse-lhes: «Dizei a Ezequias: Assim fala o grande rei, o rei da Assíria: Onde está o fundamento da tua confiança?"
,"20":"Pensas que estratégia e valentia militares são questão de palavras! Em quem te apoias para me resistires?"
,"21":"Confias no Egipto, nesse bambu rachado que penetra e fura a mão de quem nele se apoia! O Faraó, rei do Egipto, é isso para quem nele confia."
,"22":"Talvez respondas: 'Nós colocamos a nossa confiança em Javé, nosso Deus'. Mas não foste tu mesmo, Ezequias, quem destruiu os lugares altos e os altares de Javé, dizendo ao povo de Judá e de Jerusalém: 'Somente diante do altar que está em Jerusalém é que deveis adorar'?"
,"23":"Pois bem! Faz uma aposta com o meu senhor, o rei da Assíria: eu dar-te-ei dois mil cavalos, se encontrares cavaleiros para os montarem!"
,"24":"Como é que vais conseguir derrotar um só dos menores servos do meu senhor? Puseste a tua confiança no Egipto para teres carros e cavaleiros!"
,"25":"Pensas que foi sem o consentimento de Javé que ataquei este lugar para o destruir? Foi Javé quem me mandou atacar e devastar este país!»"
,"26":"Eliacim, filho de Helcias, Sobna e Joaé pediram ao chefe dos copeiros: «Fala com os teus servos em aramaico, que nós entendemos. Não fales em hebraico, diante do povo que está nas muralhas»."
,"27":"O chefe dos copeiros então respondeu: «Não foi ao teu rei e a ti que o meu senhor mandou dizer estas coisas. Foi primeiro ao povo que está nas muralhas. Ele está condenado, como vós, a comer as próprias fezes e a beber a própria urina!»"
,"28":"Então o chefe dos copeiros gritou alto, em hebraico: «Escutai a palavra do grande rei, o rei da Assíria:"
,"29":"Assim fala o rei: Não deixeis que Ezequias vos engane, pois ele não poderá livrar-vos de mim."
,"30":"Que Ezequias vos não leve a confiar em Javé, dizendo que Javé vos salvará e que esta cidade não cairá em poder do rei da Assíria."
,"31":"Não deis ouvidos a Ezequias. Porque assim fala o rei da Assíria: Fazei as pazes comigo, rendei-vos, e cada um poderá comer o fruto da sua vinha e da sua figueira, e beber água do próprio poço,"
,"32":"até que eu venha e vos leve para uma terra boa como esta, terra que produz trigo e vinho, terra de pão e videiras, terra de azeite e mel. Assim vós vivereis e não morrereis. Não deis ouvidos a Ezequias, pois ele engana-vos, dizendo que Javé vos salvará."
,"33":"Porventura os deuses das nações puderam livrar os seus países do poder do rei da Assíria?"
,"34":"Onde estão os deuses de Emat e de Arfad? Onde estão os deuses de Sefarvaim? Acaso eles livraram a Samaria do meu poder?"
,"35":"De todos os deuses das nações, qual deles livrou o seu país do meu poder, para que Javé possa salvar Jerusalém?»"
,"36":"Eles ficaram quietos e não responderam nada, pois o rei tinha ordenado que não dessem nenhuma resposta."
,"37":"Eliacim, filho de Helcias, administrador do palácio, com o escrivão Sobna e o secretário Joaé, filho de Asaf, foram ter com o rei Ezequias com as vestes rasgadas, e comunicaram-lhe as palavras do chefe dos copeiros."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Ao ouvir a comunicação, o rei Ezequias rasgou as vestes, vestiu-se com pano de saco, e foi ao Templo de Javé."
,"2":"Mandou o administrador do palácio Eliacim, com o escrivão Sobna e os anciãos dos sacerdotes, todos vestidos com panos de saco, ao profeta Isaías, filho de Amós."
,"3":"Eles disseram a Isaías: «Assim fala Ezequias: Hoje é dia de angústia, castigo e humilhação. Os filhos estão para nascer, e não há força para dar à luz."
,"4":"Oxalá Javé, teu Deus, tenha ouvido todas as palavras do chefe dos copeiros, que o rei da Assíria, seu senhor, mandou dizer para insultar o Deus vivo. Oxalá Javé, teu Deus, dê o castigo merecido pelas palavras que Ele ouviu. Faz uma prece pelo resto que ainda sobrevive»."
,"5":"Os ministros do rei Ezequias apresentaram-se a Isaías,"
,"6":"e este respondeu-lhes: «Dizei ao vosso senhor: Assim fala Javé: Não fiques com medo das palavras que ouviste, das blasfémias que os servos do rei da Assíria lançaram contra Mim."
,"7":"Vou mandar-lhe um espírito. Ao ouvir um boato, ele voltará para o seu país, e ali mesmo o farei morrer ao fio da espada»."
,"8":"O chefe dos copeiros voltou e encontrou o rei da Assíria a guerrear contra Lebna. É que o chefe dos copeiros tinha ouvido dizer que o rei se retirara de Láquis,"
,"9":"ao receber a notícia de que Taraca, rei da Etiópia, tinha partido para guerrear contra ele. Senaquerib mandou outros mensageiros a Ezequias, para lhe dizer:"
,"10":"«Isto direis a Ezequias, rei de Judá: Que o Deus no qual confias não te engane, dizendo que Jerusalém não cairá em poder do rei da Assíria."
,"11":"Tu mesmo ouviste dizer o que os reis da Assíria fizeram a todas as nações, destruindo-as completamente. Como poderias escapar?"
,"12":"Porventura, os seus deuses libertaram as nações que os meus antepassados devastaram? Gozã, Aram, Resef, e os edenitas que moravam em Telbasar?"
,"13":"Onde estão os deuses de Emat, o rei de Arfad, o rei de Lair, de Sefarvaim, de Ana e de Ava?»"
,"14":"Ezequias tomou a carta da mão dos mensageiros e leu-a. Depois subiu ao Templo, abriu a carta diante de Javé,"
,"15":"e rezou: «Javé, Deus de Israel, que estás sentado sobre os querubins. Tu és o único Deus de todos os reinos do mundo. Tu fizeste o Céu e a Terra."
,"16":"Inclina os teus ouvidos, Javé, e escuta! Abre os teus olhos, Javé, e vê! Ouve as palavras de Senaquerib, que mandou mensageiros para insultar o Deus vivo!"
,"17":"É verdade, Javé: os reis da Assíria devastaram todos os países e os seus territórios."
,"18":"Queimaram todos os seus deuses, porque não são deuses, mas obras de mãos humanas. São madeira e pedra, e por isso eles conseguiram destruí-los."
,"19":"Agora, Javé nosso Deus, salva-nos das mãos deles, para que todos os reinos do mundo saibam que só Tu, Javé, és Deus»."
,"20":"Então Isaías, filho de Amós, mandou dizer a Ezequias: «Assim diz Javé, o Deus de Israel: Escutei o que Me pediste a respeito de Senaquerib, rei da Assíria."
,"21":"Eis o oráculo que Javé pronuncia contra ele: A virgem capital de Sião despreza-te e escarnece de ti. A cidade de Jerusalém meneia a cabeça atrás de ti."
,"22":"A quem insultaste e blasfemaste? Contra quem ergueste a voz e olhaste com desprezo? Contra o Santo de Israel!"
,"23":"Tu insultaste o Senhor por meio dos teus mensageiros, dizendo: 'Com os meus numerosos carros subi até ao alto dos montes e ao topo do Líbano. Cortei os seus cedros mais altos e os seus mais belos ciprestes. Cheguei ao teu ponto mais alto e ao teu bosque mais fechado."
,"24":"Cavei e bebi as águas estrangeiras e, com a planta dos meus pés, sequei todos os rios do Egipto'."
,"25":"Porventura não ouviste nada? Eu decidi isto há muito tempo. Preparei tudo isto em tempos distantes, e agora vou realizá-lo. A tua missão foi reduzir cidades fortificadas a um montão de ruínas."
,"26":"E os seus habitantes, já sem forças, com a vergonha da derrota, ficaram como a erva do campo, como a grama verdejante; ficaram como a erva dos telhados, queimada pelo vento Leste."
,"27":"Eu sei quando te levantas e quando te sentas, quando entras e quando sais."
,"28":"Porque te agitas contra Mim, e o teu atrevimento chega aos meus ouvidos, vou colocar a minha argola nas tuas narinas e o meu freio na tua boca. Vou fazer-te voltar pelo mesmo caminho por onde vieste."
,"29":"Eis o que te servirá de sinal, Ezequias: Neste ano, comereis do que nascer sem ser semeado. No ano que vem, do que brotar sem ser semeado. Mas, no terceiro ano, semeareis e colhereis, plantareis vinhas e comereis os seus frutos."
,"30":"O resto da casa de Judá que sobreviver produzirá novas raízes no solo e novos frutos em cima."
,"31":"Porque de Jerusalém sairá um resto, e do monte Sião os sobreviventes. O zelo de Javé dos exércitos fará tudo isto."
,"32":"Portanto, assim diz Javé sobre o rei da Assíria: Ele não entrará nesta cidade, nem lançará nenhuma flecha contra ela. Não se aproximará com o escudo, nem levantará aterro contra ela."
,"33":"Ele voltará por onde veio, e não entrará nesta cidade, oráculo de Javé."
,"34":"Eu protegerei esta cidade e salvá-la-ei, pela minha honra e pela honra do meu servo David»."
,"35":"Nessa mesma noite, o anjo de Javé saiu e feriu cento e oitenta e cinco mil homens no acampamento assírio. De manhã, ao despertar, só havia cadáveres."
,"36":"Senaquerib, rei da Assíria, levantou o acampamento e partiu. Voltou para Nínive e ali ficou."
,"37":"Certo dia, estava a fazer adoração no templo de Nesroc, seu deus. E seus filhos Adramelec e Sarasar mataram-no à espada e fugiram para o país de Ararat. O seu filho Asaradon reinou em seu lugar."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Nessa ocasião, Ezequias adoeceu de uma enfermidade mortal. O profeta Isaías, filho de Amós, foi visitá-lo e disse-lhe: «Assim diz Javé: Põe em ordem a tua casa, porque vais morrer, não vais escapar»."
,"2":"Então Ezequias virou o rosto para a parede e fez esta prece a Javé:"
,"3":"«Ah! Javé! Não Te esqueças: eu procurei andar sempre na tua presença com toda a fidelidade e de coração limpo. Procurei fazer sempre o que era bom aos teus olhos». E Ezequias começou a chorar convulsivamente."
,"4":"Isaías ainda não tinha deixado o pátio interno, quando recebeu a palavra de Javé:"
,"5":"«Volta e diz a Ezequias, chefe do meu povo: Assim diz Javé, o Deus do teu antepassado David: Escutei a tua oração, e vi as tuas lágrimas. Vou curar-te e, dentro de três dias, subirás ao Templo de Javé."
,"6":"Eu vou aumentar quinze anos à duração da tua vida, e vou livrar-te das mãos do rei da Assíria, a ti e a esta cidade. Vou proteger esta cidade pela honra do meu Nome e pela honra do meu servo David»."
,"7":"Isaías ordenou: «Trazei-me um pão de figos». Tomaram um pão e colocaram-no sobre a ferida, e o rei recuperou a saúde."
,"8":"Ezequias perguntou: «Qual é o sinal de que Javé vai curar-me, e de que subirei ao Templo de Javé dentro de três dias?»"
,"9":"Isaías respondeu: «O sinal de que Javé vai cumprir o que prometeu, é este: Queres que a sombra avance ou volte para trás dez degraus?»"
,"10":"Ezequias disse: «Avançar dez degraus é fácil para a sombra. Quero que ela recue dez degraus»."
,"11":"O profeta Isaías invocou Javé, e este fez a sombra recuar dez degraus que o sol já havia descido, os degraus do quarto superior de Acaz, dez degraus para trás."
,"12":"Naquele tempo, o rei da Babilónia, Merodac-Baladã, filho de Baladã, mandou cartas e um presente a Ezequias, pois tinha recebido notícia da sua enfermidade e convalescença."
,"13":"Ezequias ficou muito satisfeito com isso e mostrou toda a sua riqueza aos embaixadores: a prata, o ouro, os perfumes, o óleo fino e toda a casa de armas; enfim, tudo o que havia nos seus depósitos. Ezequias não deixou nada por mostrar de tudo o que havia no seu palácio e dependências."
,"14":"O profeta Isaías foi procurar o rei Ezequias e perguntou-lhe: «O que disseram esses indivíduos? De onde vieram eles?» Ezequias respondeu: «Eles vieram de um país muito distante. Vieram da Babilónia»."
,"15":"Isaías perguntou: «O que é que eles viram no teu palácio?» Ezequias respondeu: «Eles viram tudo o que existe no meu palácio. Não há nada do seu tesouro que eu não lhes tenha mostrado»."
,"16":"Isaías disse, então, a Ezequias: «Escuta a palavra de Javé:"
,"17":"Chegará o dia em que a Babilónia levará tudo o que existe no teu palácio, tudo o que os teus antepassados foram juntando até ao dia de hoje. Não vai sobrar nada - diz Javé."
,"18":"Alguns dos filhos que saíram de ti, que tu geraste, serão levados para que sirvam como eunucos no palácio do rei da Babilónia»."
,"19":"Ezequias disse a Isaías: «A palavra de Javé que me transmites é de felicidade». Pois ele pensava assim: «Pelo menos durante a minha vida haverá paz e segurança»."
,"20":"O resto da história de Ezequias, e do que ele fez, e como construiu o reservatório e o aqueduto para levar água à cidade, tudo está escrito nos Anais dos Reis de Judá."
,"21":"Ezequias morreu e foi sepultado. E seu filho Manassés sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Manassés tinha doze anos quando subiu ao trono, e reinou cinquenta e cinco anos em Jerusalém. A sua mãe chamava-se Hafsiba."
,"2":"Fez o que Javé reprova, imitando as abominações das nações que Javé havia expulsado diante dos israelitas."
,"3":"Reconstruiu os lugares altos que seu pai Ezequias havia destruído; ergueu altares a Baal e levantou um poste sagrado, como havia feito Acab, rei de Israel; prostrou-se diante de todo o exército do céu e adorou-o;"
,"4":"construiu altares pagãos no Templo de Javé, a respeito do qual Javé havia dito: «Em Jerusalém colocarei o meu Nome»;"
,"5":"ergueu também altares a todo o exército do céu nos dois pátios do Templo de Javé;"
,"6":"sacrificou o seu filho no fogo; praticou adivinhação e magia, estabelecendo necromantes e adivinhos. E multiplicando as acções que Javé reprova, provocou a sua ira."
,"7":"Fez e colocou o ídolo Aserá no Templo de Javé, do qual Javé havia dito a David e seu filho Salomão: «Colocarei o meu Nome para sempre neste Templo e em Jerusalém, que Eu escolhi entre todas as tribos de Israel."
,"8":"Jamais deixarei que os pés de Israel se tornem errantes, longe da terra que dei aos seus antepassados, contanto que eles procurem agir conforme tudo o que lhes mandei, conforme a Lei que o meu servo Moisés lhes ordenou»."
,"9":"Mas eles não obedeceram, pois Manassés corrompeu-os, a ponto de eles praticarem um mal ainda maior que as nações que Javé havia expulsado diante dos israelitas."
,"10":"Então Javé falou através dos seus servos, os profetas:"
,"11":"«Manassés, rei de Judá, cometeu essas abominações; praticou o mal, ainda mais do que haviam feito antes dele os amorreus; fez pecar Judá com os seus ídolos."
,"12":"Por isso, assim diz Javé, o Deus de Israel: Eu mandarei sobre Jerusalém e Judá uma desgraça tão grande que fará doer os dois ouvidos de quem ouvir falar delas."
,"13":"Vou estender sobre Jerusalém o mesmo cordel que passei sobre Samaria, e o mesmo nível que usei para a Família de Acab. Limparei Jerusalém, como se limpa um prato por dentro e por fora."
,"14":"Abandonarei o resto da minha herança e entregá-los-ei em poder dos seus inimigos e tornar-se-ão presa e despojo de todos os seus inimigos,"
,"15":"porque fizeram o que Eu reprovo, e provocaram a minha ira, desde o dia em que os seus antepassados saíram do Egipto até hoje»."
,"16":"Manassés também derramou sangue inocente, a ponto de inundar Jerusalém toda. Isso sem contar os pecados que ele fez cometer a Judá, praticando o que Javé reprova."
,"17":"O resto da história de Manassés, o que ele fez e os pecados que cometeu, tudo está escrito nos Anais dos Reis de Judá."
,"18":"Manassés reuniu-se com os seus antepassados e foi sepultado no jardim do palácio, o jardim de Oza. E seu filho Amon sucedeu-lhe no trono."
,"19":"Amon tinha vinte e dois anos quando subiu ao trono, e reinou dois anos em Jerusalém. A sua mãe chamava-se Mesalemet; era filha de Harus e natural de Jeteba."
,"20":"Amon fez o que Javé reprova, como seu pai Manassés."
,"21":"Imitou em tudo o comportamento de seu pai: adorou os ídolos que seu pai havia adorado e prostrou-se diante deles."
,"22":"Abandonou Javé, Deus dos seus antepassados, e não seguiu o caminho de Javé."
,"23":"Os oficiais de Amon fizeram uma conspiração contra ele, e mataram-no dentro do palácio."
,"24":"O povo da terra, porém, matou todos os que tinham conspirado contra o rei Amon e, em seu lugar, proclamou o seu filho Josias como rei."
,"25":"O resto da história de Amon, e o que ele fez, tudo isso está escrito nos Anais dos Reis de Judá."
,"26":"Foi sepultado no túmulo de seu pai, no jardim de Oza. E seu filho Josias sucedeu-lhe no trono."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Josias tinha oito anos quando subiu ao trono. E reinou trinta e um anos em Jerusalém. A sua mãe chamava-se Idida; era filha de Hadaia e natural de Besecat."
,"2":"Josias fez o que Javé aprova e seguiu em tudo o comportamento do seu antepassado David, sem se desviar, nem para a direita, nem para a esquerda."
,"3":"No ano dezoito do seu reinado, o rei Josias mandou o secretário Safã, filho de Aslias, neto de Mesolam, ao Templo de Javé, com esta ordem:"
,"4":"«Vai procurar o sumo sacerdote Helcias, e diz-lhe que deixe preparado o dinheiro oferecido ao Templo de Javé e que os guardas da porta recolhem do povo."
,"5":"Diz-lhe que entregue o dinheiro aos mestres de obras encarregados do Templo de Javé, a fim de que estes o distribuam aos operários que trabalham nas reformas do Templo de Javé:"
,"6":"aos carpinteiros, construtores e pedreiros. Que eles usem o dinheiro para comprar madeiras e pedras talhadas para a reforma do Templo."
,"7":"Não será necessário pedir contas do dinheiro que se lhes entrega, porque são honestos»."
,"8":"O sumo sacerdote Helcias informou o secretário Safã: «Achei o livro da Lei no Templo de Javé!» Entregou o livro a Safã, que o leu."
,"9":"O secretário Safã foi falar com o rei: «Os teus servos juntaram o dinheiro que havia no Templo e entregaram-no aos mestres de obras do Templo de Javé»."
,"10":"Em seguida, contou ao rei que o sacerdote Helcias lhe havia dado um livro. E Safã leu o livro diante do rei."
,"11":"Ao tomar conhecimento do conteúdo do livro da Lei, o rei rasgou as vestes,"
,"12":"e deu esta ordem ao sacerdote Helcias, a Aicam, filho de Safã, a Acobor, filho de Micas, ao secretário Safã e ao ministro Asaías:"
,"13":"«Ide consultar Javé por mim e pelo povo, a respeito do conteúdo do livro que foi encontrado. A ira de Javé deve ser grande contra nós, porque os nossos antepassados não obedeceram às palavras deste livro, e não praticaram tudo o que nele está escrito»."
,"14":"O sacerdote Helcias, Aicam, Acobor, Safã e Asaías foram ter com a profetisa Hulda, mulher do guarda dos vestiários, de nome Selum, filho de Tícua e neto de Haraas. Ela morava em Jerusalém, no Bairro Novo. Expuseram-lhe o caso,"
,"15":"e ela respondeu: «Assim diz Javé, o Deus de Israel. Dizei a quem vos enviou:"
,"16":"Assim diz Javé, Deus de Israel: 'Vou fazer cair uma desgraça sobre este lugar e sobre os seus habitantes. Vou enviar todas as maldições que estão neste livro, que o rei de Judá leu."
,"17":"Eles abandonaram-Me e queimaram incenso a outros deuses, e irritaram-Me com todas as obras das suas mãos. Por isso, a minha ira inflamou-se contra este lugar, e não se apagará'."
,"18":"E ao rei de Judá, que vos enviou para consultar Javé, direis: 'Assim diz Javé, o Deus de Israel: Porque, ouvindo a leitura do livro,"
,"19":"te comoveste de coração e te humilhaste diante de Javé; porque escutaste as palavras que pronunciei contra este lugar e seus habitantes, que serão objecto de espanto e maldição; porque rasgaste as vestes e choraste na minha frente, também Eu te ouvi - oráculo de Javé."
,"20":"Por isso reunir-te-ei aos teus antepassados. Vais ser enterrado em paz na tua sepultura, e os teus olhos não verão todos os males que vou enviar sobre este lugar'». Então eles foram levar ao rei a resposta da profetisa."
}`)
	CurrentBook.AddChapter(23, `{
"1":"O rei convocou todos os anciãos de Judá e Jerusalém para uma reunião."
,"2":"Depois subiu ao Templo de Javé com todos os homens de Judá e todos os habitantes de Jerusalém: sacerdotes, profetas e todo o povo, adultos e crianças. Leu-lhes as palavras do Livro da Aliança encontrado no Templo de Javé."
,"3":"De pé, sobre o estrado, o rei concluiu, diante de Javé, a aliança para seguir a Javé, obedecendo aos seus mandamentos, testemunhos e estatutos, com todo o coração e com toda a alma, cumprindo todas as palavras da aliança, escritas nesse livro. E todo o povo aderiu à aliança."
,"4":"O rei ordenou ao sumo sacerdote Helcias, aos sacerdotes de segunda ordem e aos guardas da porta, que tirassem do santuário de Javé todos os objectos feitos para o culto de Baal, do ídolo Aserá e de todo o exército do céu. Os objectos foram queimados fora de Jerusalém, nos campos do Cedron, e as suas cinzas foram levadas para Betel."
,"5":"Depois destituiu os falsos sacerdotes que os reis de Judá haviam estabelecido para queimarem incenso nos lugares altos das cidades de Judá e arredores de Jerusalém. Destituiu também aqueles que queimavam incenso a Baal, ao sol, à lua, às constelações e a todo o exército do céu."
,"6":"Retirou do Templo de Javé o ídolo Aserá, levando-o para fora de Jerusalém, para o riacho do Cedron. Queimou o ídolo junto ao riacho do Cedron, e reduziu-o a cinzas, que foram lançadas na vala comum."
,"7":"Destruiu as casas de prostituição sagrada que havia no Templo de Javé, onde as mulheres teciam vestes para Aserá."
,"8":"Mandou vir todos os sacerdotes das cidades de Judá e profanou os lugares altos onde esses sacerdotes haviam queimado incenso, desde Gaba até Bersabeia. Destruiu o lugar alto da porta, que ficava à entrada da porta de Josué, governador da cidade, à esquerda de quem entra pela porta da cidade."
,"9":"Os sacerdotes dos lugares altos foram proibidos de subir ao altar de Javé em Jerusalém, mas podiam comer os pães sem fermento no meio dos seus irmãos."
,"10":"Josias profanou o Tofet que existia no vale de Ben-Enom, para que ninguém sacrificasse no fogo o filho ou a filha em honra do deus Moloc."
,"11":"Eliminou os cavalos que os reis de Judá haviam instalado em honra do sol, à entrada do Templo de Javé, perto do aposento do funcionário Natã Melec, que ficava nas dependências. Queimou também os carros do sol."
,"12":"O rei destruiu os altares que estavam no terraço do aposento superior de Acaz e que tinham sido construídos pelos reis de Judá, e também os altares que Manassés tinha mandado fazer nos dois pátios do Templo de Javé; retirou-os daí e mandou lançar as cinzas ao riacho do Cedron."
,"13":"O rei profanou os lugares altos que ficavam na frente de Jerusalém, ao Sul do monte da Perdição, lugares que Salomão, rei de Israel, tinha construído em honra de Astarte, abominação dos sidónios, em honra de Camos, abominação dos moabitas, e em honra de Melcom, abominação dos amonitas."
,"14":"Quebrou as estelas, derrubou os postes sagrados e encheu o lugar com ossos humanos."
,"15":"Josias destruiu também o altar que estava em Betel, lugar alto que Jeroboão, filho de Nabat, havia construído e com o qual havia arrastado Israel ao pecado. Destruiu esse lugar alto, quebrou as suas pedras, reduzindo-as a pó, e queimou o poste sagrado."
,"16":"Josias voltou-se e viu os túmulos que estavam na montanha. Então mandou recolher os ossos daqueles túmulos e queimou-os sobre o altar. Deste modo, profanou o altar, cumprindo a palavra de Javé, que o homem de Deus havia anunciado quando Jeroboão, durante a festa, estava junto ao altar. Ao voltar-se, Josias ergueu os olhos para o túmulo do homem de Deus que havia anunciado estas coisas,"
,"17":"e perguntou: «De quem é este túmulo?» Os homens da cidade responderam: «É o túmulo do homem de Deus, que veio de Judá, e anunciou o que acabas de fazer com o altar de Betel»."
,"18":"Então o rei disse: «Deixai o homem de Deus em paz. Que ninguém toque nos seus ossos». Deixaram, assim, os ossos do homem de Deus em paz, bem como os ossos do profeta que tinha vindo da Samaria."
,"19":"Josias fez desaparecer também todos os templos dos lugares altos, que havia na cidade de Samaria. Esses templos tinham sido construídos pelos reis de Israel para irritar a Javé. Josias fez-lhes o mesmo que já havia feito em Betel."
,"20":"Josias imolou, sobre os altares, todos os sacerdotes dos lugares altos que aí se encontravam; e, por cima deles, queimou ossos humanos. Depois voltou para Jerusalém."
,"21":"O rei ordenou a todo o povo: «Celebrai a Páscoa em honra de Javé, vosso Deus, conforme está ordenado neste Livro da Aliança»."
,"22":"Nunca tinha sido celebrada uma Páscoa como essa, desde o tempo em que os juízes governavam Israel, nem durante todo o tempo dos reis de Israel e de Judá."
,"23":"Foi somente no ano dezoito do rei Josias que tal Páscoa foi celebrada em honra de Javé, em Jerusalém."
,"24":"Josias eliminou também os necromantes, os adivinhos, os deuses domésticos, os ídolos e todas as abominações que se viam no país de Judá e em Jerusalém, para cumprir as palavras da Lei escritas no livro que o sacerdote Helcias encontrou no Templo de Javé."
,"25":"Nenhum dos reis anteriores se voltou para Javé como ele se voltou de todo o coração, de toda a alma e com toda a sua força, conforme a Lei de Moisés. Mesmo depois, não surgiu outro como ele."
,"26":"Apesar disso, Javé não deixou de lado o furor da sua grande ira, que se havia inflamado contra Judá, por causa de todas as ofensas com que Manassés O tinha ofendido."
,"27":"Javé disse: «Também expulsarei Judá para longe da minha presença, da mesma forma como expulsei Israel. Vou rejeitar Jerusalém, esta cidade que Eu tinha escolhido, e o Templo sobre o qual Eu tinha dito: Nela estará o meu Nome»."
,"28":"O resto da história de Josias, e o que ele fez, tudo está escrito nos Anais dos Reis de Judá."
,"29":"No seu tempo, o Faraó Necao, rei do Egipto, subiu para se ir encontrar com o rei da Assíria, junto ao rio Eufrates. O rei Josias marchou contra ele, mas, na primeira batalha em Meguido, Necao matou-o."
,"30":"Os servos de Josias transportaram o seu corpo num carro, levaram-no de Meguido para Jerusalém, e sepultaram-no no seu túmulo. Então o povo da terra tomou Joacaz, filho de Josias, ungiu-o e colocou-o no trono em lugar de seu pai."
,"31":"Joacaz tinha vinte e três anos quando subiu ao trono, e reinou três meses em Jerusalém. A sua mãe chamava-se Hamital. Era filha de Jeremias e natural de Lebna."
,"32":"Ele fez o que Javé reprova, como haviam feito os seus antepassados."
,"33":"O Faraó Necao prendeu Joacaz em Rebla, no país de Emat, para que ele não reinasse mais em Jerusalém. O Faraó impôs ao país um tributo de três toneladas e meia de prata, e trinta e quatro quilos de ouro."
,"34":"Colocou no trono Eliacim, filho de Josias, em substituição de seu pai Josias, mudando-lhe o nome para Joaquim. Levou Joacaz para o Egipto, onde morreu."
,"35":"Joaquim pagou o tributo de prata e ouro ao Faraó. Mas, para pagar a quantia exigida pelo Faraó, teve que criar impostos no país. Conforme as possibilidades de cada um, exigiu a prata e o ouro necessários para pagar ao Faraó Necao."
,"36":"Joaquim tinha vinte e cinco anos quando subiu ao trono, e reinou onze anos em Jerusalém. A sua mãe chamava-se Zebida. Ela era filha de Fadaías e natural de Ruma."
,"37":"Joaquim fez o que Javé reprova, como haviam feito os seus antepassados."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Naquele tempo, Nabucodonosor, rei da Babilónia, marchou contra Joaquim, e submeteu-o durante três anos. Depois Joaquim revoltou-se de novo contra Nabucodonosor."
,"2":"Javé mandou contra Joaquim bandos de caldeus, arameus, moabitas e amonitas. Ele mandou-os para que destruíssem Judá, conforme a palavra que Javé tinha dito por meio dos seus servos, os profetas."
,"3":"Isto aconteceu a Judá, unicamente por ordem de Javé, para que Judá fosse expulso da sua presença. Foi por causa dos pecados de Manassés e de tudo o que ele fez,"
,"4":"e também por causa do sangue inocente que derramou e com o qual inundou Jerusalém; foi por isso que Javé não quis perdoar."
,"5":"O resto da história de Joaquim, e o que ele fez, tudo isso está escrito nos Anais dos Reis de Judá."
,"6":"Joaquim reuniu-se aos seus antepassados. E seu filho Jeconias sucedeu-lhe no trono."
,"7":"O rei do Egipto nunca mais saiu do seu país, porque o rei de Babilónia se havia apossado de todos os territórios que pertenciam ao rei do Egipto, desde a torrente do Egipto até ao rio Eufrates."
,"8":"Jeconias tinha dezoito anos quando subiu ao trono, e reinou três meses em Jerusalém. A sua mãe chamava-se Noesta. Ela era filha de Elnatã e natural de Jerusalém."
,"9":"Jeconias fez o que Javé reprova, como havia feito seu pai."
,"10":"Nesse tempo, os oficiais de Nabucodonosor, rei da Babilónia, marcharam contra Jerusalém e cercaram a cidade."
,"11":"Nabucodonosor, rei da Babilónia, foi em pessoa atacar a cidade que os seus oficiais haviam cercado."
,"12":"Então Jeconias, rei de Judá, juntamente com a sua mãe, os seus oficiais, os seus chefes e funcionários, entregou-se ao rei da Babilónia, e este fê-los prisioneiros. Isto aconteceu no oitavo ano do reinado de Jeconias."
,"13":"Nabucodonosor levou consigo todos os tesouros do Templo de Javé e os tesouros do palácio real. Quebrou todos os objectos de ouro que Salomão, rei de Israel, tinha feito para o Templo, conforme as ordens de Javé."
,"14":"Levou para o exílio toda a cidade de Jerusalém, todos os chefes e os notáveis, cerca de dez mil pessoas. Levou também todos os ferreiros e artesãos. Deixou no país somente o povo mais pobre."
,"15":"Exilou Jeconias para a Babilónia. Levou também, de Jerusalém para a Babilónia, a mãe do rei, as suas mulheres, os seus funcionários, a classe governante"
,"16":"e todos os ricos: cerca de sete mil pessoas. Levou ainda os ferreiros e artesãos: cerca de mil pessoas, todos os homens aptos para a guerra."
,"17":"Em lugar de Jeconias, Nabucodonosor nomeou rei a Matanias, tio de Jeconias, mudando-lhe o nome para Sedecias."
,"18":"Sedecias tinha vinte e um anos quando subiu ao trono, e reinou onze anos em Jerusalém. A sua mãe chamava-se Hamital. Era filha de Jeremias e natural de Lebna."
,"19":"Sedecias fez o que Javé reprova, como havia feito Jeconias."
,"20":"Isto aconteceu a Jerusalém e a Judá por causa da ira de Javé, que acabou por rejeitá-los da sua presença. Sedecias revoltou-se contra o rei da Babilónia."
}`)
	CurrentBook.AddChapter(25, `{
"1":"No nono ano do seu reinado, no dia dez do décimo mês, Nabucodonosor, rei da Babilónia, com todo o seu exército, atacou Jerusalém. Acampou diante da cidade e construiu ao redor dela torres de assalto."
,"2":"A cidade ficou cercada até ao ano onze do reinado de Sedecias,"
,"3":"até ao dia nove do quarto mês. A fome apertou na cidade, e o povo não tinha nada para comer."
,"4":"Então foi aberta uma brecha nas muralhas da cidade. E o rei, com todos os soldados, fugiu de noite pela porta que fica entre as duas muralhas, perto do jardim do rei. Tomaram o caminho da Arabá, enquanto os caldeus ainda cercavam a cidade."
,"5":"O exército caldeu perseguiu o rei e alcançou-o nas planícies de Jericó, enquanto os soldados dele o abandonaram e se dispersaram."
,"6":"Os caldeus prenderam o rei e levaram-no ao rei da Babilónia, que estava em Rebla e que pronunciou a sentença contra Sedecias."
,"7":"Nabucodonosor mandou degolar os filhos de Sedecias na presença do pai. Depois vasou os olhos do rei, algemou-o e levou-o para a Babilónia."
,"8":"No dia sete do quinto mês, correspondente ao ano dezanove de Nabucodonosor, rei da Babilónia, Nabuzardã, chefe da guarda e oficial do rei da Babilónia, chegou a Jerusalém."
,"9":"Incendiou o Templo de Javé, o palácio real e todas as casas de Jerusalém e todas as residências."
,"10":"Ao mesmo tempo, o exército caldeu, que acompanhava Nabuzardã, chefe da guarda, destruiu as muralhas que rodeavam Jerusalém."
,"11":"Nabuzardã exilou o resto do povo que tinha ficado na cidade, os desertores que tinham passado para o lado do rei da Babilónia e o resto da população."
,"12":"O chefe da guarda deixou uma parte do povo pobre da terra, para trabalhar nas vinhas e nos campos."
,"13":"Os caldeus quebraram as colunas de bronze, as bases entalhadas e o Mar de bronze que estavam no Templo de Javé, e levaram o bronze para a Babilónia."
,"14":"Levaram também os recipientes para cinzas, as pás, facas, taças e todos os objectos de bronze que eram usados no culto."
,"15":"O chefe da guarda tomou os incensórios, as vasilhas para aspersão e tudo o que era de ouro e prata."
,"16":"Quanto às duas colunas, ao Mar e às bases entalhadas, que Salomão tinha feito para o Templo de Javé, era impossível calcular o peso de bronze de todos esses objectos."
,"17":"Cada coluna tinha nove metros de altura e terminava num capitel de bronze de dois metros e meio de altura, enfeitado com um entrançado e romãs, em bronze."
,"18":"O chefe da guarda prendeu Saraías, sacerdote chefe, Sofonias, sacerdote que ocupava o segundo lugar, e os três guardas das portas."
,"19":"Na cidade, prendeu um funcionário, que era chefe do exército, cinco conselheiros do rei, que se encontravam na cidade, o secretário do chefe do exército, que mobilizava o povo da terra, e sessenta cidadãos que se encontravam na cidade."
,"20":"Nabuzardã, chefe da guarda, prendeu-os a todos e levou-os ao rei da Babilónia, em Rebla."
,"21":"O rei da Babilónia mandou matá-los em Rebla, no território de Emat. Deste modo, Judá foi exilado para longe do seu país."
,"22":"Nabucodonosor, rei da Babilónia, nomeou Godolias, filho de Aicam e neto de Safã, para governar o povo que Nabucodonosor deixou no território de Judá."
,"23":"Quando todos os oficiais das tropas e seus homens souberam que o rei da Babilónia tinha nomeado Godolias como governador, foram ter com ele a Masfa. Eram eles: Ismael, filho de Natanias; Joanã, filho de Carea; Saraías, filho de Taneumet, netofatita; e Jezonias, macaatita. Eles foram com os seus homens."
,"24":"Godolias jurou a todos eles: «Não tenhais medo e submetei-vos aos Caldeus. Ficai na terra, obedecei ao rei da Babilónia, e tudo vos correrá bem»."
,"25":"No sétimo mês, porém, Ismael, filho de Natanias e neto de Elisama, que era de descendência real, foi com dez homens e matou Godolias, juntamente com os judeus e caldeus que estavam com ele em Masfa."
,"26":"Então todo o povo, adultos e crianças, com os chefes das tropas, fugiram para o Egipto, porque ficaram com medo dos caldeus."
,"27":"No ano trinta e sete do exílio de Jeconias, rei de Judá, no dia vinte e sete do décimo segundo mês, Evil-Merodac, rei da Babilónia, no ano em que subiu ao trono, concedeu amnistia a Jeconias, rei de Judá, e tirou-o da prisão."
,"28":"Tratou-o amigavelmente e concedeu-lhe um trono mais alto que o dos outros reis que estavam com ele na Babilónia."
,"29":"Jeconias tirou as vestes de prisioneiro e começou a comer sempre à mesa do rei, durante todos os dias da sua vida."
,"30":"Enquanto viveu, o seu sustento foi sempre garantido pelo rei."
}`)

}
func PT_BS_LoadVH2SChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Depois da morte de Saul, David voltou da vitória sobre os amalecitas e ficou dois dias em Siceleg."
,"2":"No terceiro dia, chegou alguém do acampamento de Saul, com as roupas rasgadas e a cabeça coberta de pó. Ao chegar perto de David, lançou-se por terra e prostrou-se."
,"3":"David perguntou: «De onde vens?» O homem respondeu: «Escapei com vida do acampamento de Israel»."
,"4":"David perguntou: «O que foi que aconteceu? Diz depressa». O homem respondeu: «As tropas fugiram do campo de batalha, muitos caíram e estão mortos. Até Saul e o seu filho Jónatas morreram»."
,"5":"David perguntou ao jovem que o informava: «Como é que sabes que Saul e o seu filho Jónatas estão mortos?»"
,"6":"O mensageiro respondeu: «Eu estava casualmente no monte Gelboé e vi Saul atirar-se sobre a própria lança, enquanto os carros e cavaleiros se aproximavam."
,"7":"Saul virou-se, viu-me e chamou-me. Eu disse: 'Estou aqui'."
,"8":"Saul perguntou-me: 'Quem és tu?' Eu respondi: 'Sou um amalecita'."
,"9":"Então Saul disse-me: 'Aproxima-te e mata-me, pois estou a agonizar e não acabo de morrer'."
,"10":"Então eu aproximei-me dele e matei-o, porque eu sabia que ele não iria mesmo sobreviver depois de caído. Em seguida, tomei a coroa que ele trazia na cabeça e o bracelete que estava no seu braço e trouxe-os aqui para o meu senhor»."
,"11":"Então David rasgou as suas próprias vestes. E todos os homens que o acompanhavam fizeram o mesmo."
,"12":"Lamentaram, choraram e jejuaram até à tarde por Saul e por seu filho Jónatas, e também por causa do povo de Javé e pela casa de Israel, porque haviam sido mortos pela espada."
,"13":"Depois David perguntou ao jovem que havia trazido a notícia: «De onde és tu?» Ele respondeu: «Sou filho de um imigrante amalecita»."
,"14":"David perguntou-lhe: «E como é que te atreveste a levantar a mão para matar o ungido de Javé?»"
,"15":"Então David chamou um dos seus servos e ordenou: «Vem cá e mata este homem». O servo feriu o homem e ele morreu."
,"16":"E David disse: «És responsável pela tua morte, pois a tua boca testemunhou contra ti mesmo, dizendo que mataste o ungido de Javé»."
,"17":"David compôs esta lamentação por Saul e seu filho Jónatas,"
,"18":"e ordenou que fosse ensinada aos filhos de Judá. Ela encontra-se no Livro do Justo."
,"19":"A honra de Israel pereceu nas alturas. Como foi que os valentes caíram?"
,"20":"Não o conteis em Gat, nem o proclameis nas ruas de Ascalon. Que as jovens filisteias não se alegrem,e as filhas dos incircuncisos,não exultem."
,"21":"Montanhas de Gelboé, que o orvalho e a chuva,não caiam sobre vós,e nunca mais haja campos férteis, pois o escudo dos valentes,foi desonrado. O escudo de Saul não foi ungido,com óleo,"
,"22":"mas com o sangue dos feridos,e a gordura dos valentes. O arco de Jónatas não recuava,e a espada de Saul não voltava,sem sangue."
,"23":"Saul e Jónatas, amados e queridos, nem a vida nem a morte,os separaram. Eram mais velozes,do que as águias,e mais fortes do que os leões."
,"24":"Donzelas de Israel, chorai por Saul: ele vestiu-vos com púrpura,e linho, e enfeitou de ouro,os vossos vestidos."
,"25":"Como caíram os valentes no combate!,Jónatas, a tua morte despedaçou-me,o coração!"
,"26":"Como sofro por ti, Jónatas, meu irmão!,Como eu te queria bem!,Para mim, o teu amor,era mais caro,do que o amor das mulheres!"
,"27":"Como caíram os valentes!,Como pereceram as armas de guerra!"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Depois disso, David consultou Javé: «Posso ir para alguma cidade de Judá?» Javé respondeu: «Podes». David perguntou: «Para qual delas posso ir?» A resposta foi: «Hebron»."
,"2":"David subiu para lá e também as suas duas mulheres: Aquinoam de Jezrael e Abigail, mulher de Nabal de Carmel."
,"3":"Levou também todos os seus homens, juntamente com as suas famílias. E estabeleceram-se nas aldeias de Hebron."
,"4":"Os homens de Judá foram para lá e ungiram David como rei sobre a casa de Judá. Comunicaram a David que os habitantes de Jabes de Galaad tinham sepultado Saul."
,"5":"Então David enviou mensageiros aos habitantes de Jabes, dizendo: «Que Javé vos abençoe por terdes realizado esse acto de misericórdia para com o vosso senhor Saul e o terdes sepultado."
,"6":"Que Javé vos trate com misericórdia e fidelidade. Eu também vos recompensaria por essa boa acção."
,"7":"Agora, tende coragem e sede valentes. O vosso rei Saul está morto, mas a casa de Judá já me sagrou como seu rei»."
,"8":"Abner, filho de Ner, chefe do exército de Saul, tinha levado consigo Isbaal, filho de Saul, e tinha-o feito ir a Maanaim."
,"9":"Abner estabeleceu-o como rei sobre Galaad, sobre os de Aser, de Jezrael, Efraim, Benjamim e sobre todo o Israel."
,"10":"Isbaal, filho de Saul, tinha quarenta anos quando se tornou rei de Israel, e reinou durante dois anos. Somente a casa de Judá seguia David."
,"11":"E David reinou sobre a casa de Judá, em Hebron, durante sete anos e meio."
,"12":"Abner, filho de Ner, e os servos de Isbaal, filho de Saul, foram de Maanaim para Gabaon."
,"13":"Joab, filho de Sárvia, e os oficiais de David puseram-se a caminho e encontraram-nos perto do açude de Gabaon: os de Joab ficaram de um lado do açude, e do outro lado os de Abner."
,"14":"Então Abner propôs a Joab: «Deixa que alguns jovens venham lutar diante de nós». Joab respondeu: «Está bem»."
,"15":"Doze benjaminitas prepararam-se e atravessaram para lutar por Isbaal, filho de Saul; e doze dos oficiais de David também se apresentaram."
,"16":"Cada um deles agarrou a cabeça do adversário e enterrou-lhe a espada no flanco, de modo que todos caíram juntos. É por isso que esse lugar ficou a chamar-se Campo dos Flancos, e está localizado em Gabaon."
,"17":"Nesse dia, houve uma batalha violenta, e os oficiais de David derrotaram Abner e os israelitas."
,"18":"Estavam lá os três filhos de Sárvia: Joab, Abisaí e Asael. Ora, Asael corria como as gazelas selvagens,"
,"19":"e perseguiu Abner sem parar e sem se desviar de um lado para o outro."
,"20":"Abner olhou para trás e perguntou: «És tu, Asael?» E Asael respondeu: «Sou eu mesmo»."
,"21":"Então Abner disse: «Vai para a direita ou para a esquerda, agarra um dos meus homens e apodera-te das suas armas». Asael, porém, não quis deixar de o perseguir."
,"22":"Abner insistiu: «Deixa de me perseguir. Porque haveria eu de ferir-te e deixar-te no chão? Com que cara eu iria depois apresentar-me diante do teu irmão Joab?»"
,"23":"Como Asael não quis afastar-se, Abner furou-lhe a barriga com a parte de trás da lança, de modo que esta lhe saiu pelas costas. Asael caiu, e morreu ali mesmo. Todos os que chegavam ao lugar onde Asael estava caído e morto, paravam."
,"24":"Joab e Abisaí começaram a perseguir Abner e, ao pôr do sol, chegaram à colina de Ama, que está a Leste de Gaia, no caminho do deserto de Gabaon."
,"25":"Os benjaminitas concentraram-se atrás de Abner, em formação cerrada, e pararam no alto de uma colina."
,"26":"Então Abner gritou para Joab e disse: «Será que a espada vai continuar a devorar para sempre? Tu não sabes que no fim só vai ficar amargura? Quando é que vais ordenar aos teus homens que deixem de perseguir os seus irmãos?»"
,"27":"Joab respondeu: «Pela vida de Javé, se não tivesses falado, só pela manhã os meus homens deixariam de perseguir os seus irmãos»."
,"28":"Então Joab mandou soar a trombeta, e todo o exército suspendeu o combate e deixou de perseguir Israel. E terminou a luta."
,"29":"Abner e os seus homens caminharam toda a noite pelo deserto, atravessaram o Jordão e, depois de marcharem toda a manhã seguinte, chegaram a Maanaim."
,"30":"Joab deixou de perseguir Abner e reuniu toda a tropa: dos guerreiros de David morreram dezanove homens e também Asael."
,"31":"Mas tinham matado trezentos e sessenta homens de Benjamim e de Abner."
,"32":"Levaram o cadáver de Asael e enterraram-no em Belém, no túmulo de família. Joab e os seus homens marcharam a noite inteira e chegaram a Hebron ao amanhecer."
}`)
	CurrentBook.AddChapter(3, `{
"1":"A guer-raentre as famílias de Saul e David continuou, mas David fortalecia-se cada vez mais, ao passo que a família de Saul enfraquecia."
,"2":"David teve vários filhos em Hebron: o primeiro foi Amnon, nascido de Aquinoam de Jezrael;"
,"3":"o segundo, Queleab, nascido de Abigail, que tinha sido mulher de Nabal de Carmel; o terceiro, Absalão, nascido de Maaca, filha de Tolmai, rei de Gessur;"
,"4":"o quarto, Adonias, nascido de Hagit; o quinto, Safatias, nascido de Abital;"
,"5":"o sexto, Jetraam, nascido da esposa Egla. Foram estes os filhos que David teve em Hebron."
,"6":"Durante a luta entre as famílias de Saul e David, Abner foi adquirindo na família de Saul prestígio cada vez maior."
,"7":"Saul tinha tido uma concubina chamada Resfa, filha de Aías. Isbaal perguntou a Abner: «Porque te uniste com a concubina de meu pai?»"
,"8":"Abner ficou furioso com a pergunta de Isbaal e respondeu: «Serei eu algum cão? Sempre trabalhei lealmente pela família de teu pai Saul, pelos teus irmãos e amigos, e não te deixei cair nas mãos de David. E agora vens criticar-me por uma questão de mulher?"
,"9":"Que Deus me castigue, se eu não cumprir o juramento que Javé fez a David:"
,"10":"'Vou tirar a realeza à família de Saul e estabelecer o trono de David sobre Israel e sobre Judá, desde Dã até Bersabeia'»."
,"11":"Isbaal tinha medo de Abner, e não se atreveu a responder uma só palavra."
,"12":"Abner enviou mensageiros para dizerem a David: «De quem é o país?» Ele queria dizer: «Faz uma aliança comigo, e eu te ajudarei a reunir todo o Israel em torno de ti»."
,"13":"David respondeu: «Muito bem. Vou fazer uma aliança contigo. Só exijo uma coisa: quando vieres ao meu encontro só te receberei se me trouxeres Micol, filha de Saul»."
,"14":"David mandou também mensageiros a Isbaal, filho de Saul, dizendo: «Entrega-me a minha mulher Micol, que adquiri por cem prepúcios de filisteus»."
,"15":"Isbaal mandou tirar Micol ao seu marido Faltiel, filho de Lais."
,"16":"E Faltiel seguiu a esposa até Baurim. Então Abner disse-lhe: «Volta!» E ele voltou."
,"17":"Abner tinha conversado com os anciãos de Israel e tinha-lhes dito: «Há muito tempo que desejais ter David como rei."
,"18":"Pois bem, chegou o momento, porque Javé disse isto a respeito de David: 'É por meio do meu servo David que Eu livrarei o meu povo Israel do poder dos filisteus e de todos os seus inimigos'»."
,"19":"Abner falou também aos de Benjamim. Depois foi a Hebron contar a David tudo o que Israel e a família de Benjamim tinham aprovado."
,"20":"Acompanhado de vinte homens, Abner chegou a Hebron para conversar com David, e David ofereceu uma recepção a Abner e aos homens que tinham ido com ele."
,"21":"Então Abner disse a David: «Vou reunir todo o Israel ao redor do senhor meu rei: eles farão uma aliança contigo e reinarás conforme desejas». David despediu-se de Abner, e este partiu em paz."
,"22":"Os guerreiros de David e Joab tinham acabado de chegar da incursão, transportando muitos despojos. Abner já não estava em Hebron, pois David tinha-o despedido e ele tinha partido em paz."
,"23":"Quando Joab e a sua tropa chegaram, disseram a Joab que Abner, filho de Ner, tinha vindo e estado com o rei, e este o tinha deixado partir em paz."
,"24":"Então Joab foi conversar com o rei e disse-lhe: «Que fizeste? Abner esteve aqui, e deixaste-o partir?"
,"25":"Conheces bem Abner, filho de Ner! Ele veio para te enganar. Ele quer conhecer os teus movimentos e saber o que fazes»."
,"26":"Joab saiu do palácio e, sem que David soubesse, enviou mensageiros atrás de Abner, que o fizeram voltar desde o poço de Sira."
,"27":"Quando Abner voltou a Hebron, Joab chamou-o à parte, a um lado da entrada, para falar com ele a sós; e ali feriu-o mortalmente na barriga, por causa do seu irmão Asael."
,"28":"Quando David soube o que acontecera, disse: «Eu e o meu reino, diante de Javé, somos para sempre inocentes do sangue de Abner, filho de Ner."
,"29":"Que o sangue de Abner caia sobre a cabeça de Joab e sobre toda a sua família. Que na família de Joab nunca falte quem sofra de gonorreia ou seja leproso, assalariado, ou pessoas mortas pela espada ou de fome»."
,"30":"Joab e seu irmão Absaí tinham assassinado Abner porque ele matara seu irmão Asael no combate de Gabaon."
,"31":"Então David ordenou a Joab e seus acompanhantes: «Rasgai as vestes, vesti panos de saco e fazei luto por Abner». O rei David ia atrás, acompanhando o enterro."
,"32":"Enterraram Abner em Hebron. O rei soluçava alto junto à sepultura, e todo o povo também chorava."
,"33":"E o rei cantou esta lamentação por Abner: «Será que Abner precisava de morrer como insensato?"
,"34":"As suas mãos não conheciam correntes e os seus pés não estavam presos em grilhões. Mas caíste, como quem cai em poder de malfeitores». E todo o povo continuou a chorar."
,"35":"Depois o povo chamou David para o obrigar a comer, enquanto era dia. Mas David jurou: «Que Deus me castigue, se antes do pôr do sol eu comer pão ou qualquer outro alimento»."
,"36":"Todo o povo notou isso e achou bem, pois todos aprovavam o que o rei fazia."
,"37":"Nesse dia, todo o povo e todo o Israel viu que o rei não tinha nada a ver com o assassinato de Abner, filho de Ner."
,"38":"E o rei disse aos seus ministros: «Vós sabeis que hoje caiu em Israel um grande chefe."
,"39":"Eu ainda sou fraco, apesar de ter sido ungido rei. Esses homens, os filhos de Sárvia, são mais duros do que eu. Que Javé castigue o mau, conforme a sua maldade»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quandosoube que Abner tinha morrido em Hebron, Isbaal, filho de Saul, acovardou-se, e todo o Israel ficou alarmado."
,"2":"Isbaal, filho de Saul, tinha dois chefes de guerrilhas: um chamava-se Baana e o outro, Recab. Eram filhos de Remon de Berot e benjaminitas, porque Berot também se considerava da tribo de Benjamim."
,"3":"Os habitantes de Berot fugiram para Getaim, onde permanecem até hoje como imigrantes."
,"4":"Vivia ali um filho de Jónatas, filho de Saul, que era aleijado dos dois pés. Ele tinha cinco anos, quando chegou de Jezrael a notícia da morte de Saul e Jónatas. Então a ama pegou nele e fugiu; mas, na fuga apressada, a criança caiu e aleijou-se. Chamava-se Meribaal."
,"5":"Recab e Baana, filhos de Remon de Berot, partiram e chegaram a casa de Isbaal na hora mais quente do dia, quando Isbaal dormia a sesta."
,"6":"A porteira, que limpava o trigo, adormecera. Recab e seu irmão Baana entraram sem serem notados."
,"7":"Entraram na casa, enquanto Isbaal dormia na cama. Eles feriram-no e cortaram-lhe a cabeça. Depois levaram a cabeça, andando a noite toda pela estrada do deserto."
,"8":"Levaram a cabeça de Isbaal a David em Hebron, e disseram ao rei: «Aqui está a cabeça de Isbaal, filho de Saul, o inimigo te que queria matar. Javé trouxe hoje ao senhor meu rei uma vingança contra Saul e a sua descendência»."
,"9":"David, porém, dirigiu-se a Recab e a seu irmão Baana, filhos de Remon de Berot, e disse-lhes: «Pela vida de Javé, que me salvou a vida de todo o perigo!"
,"10":"Quem anunciou a morte de Saul, julgava que trazia uma boa notícia! Pois eu agarrei-o e matei-o em Siceleg, em troca da boa notícia!"
,"11":"Com maior razão ainda, será que não devo pedir-vos contas do sangue de Isbaal e fazer-vos desaparecer da face da terra, por terdes morto um homem honesto dentro de sua casa, enquanto dormia na sua cama?»"
,"12":"Então David ordenou aos seus homens que matassem Recab e Baana. Eles cortaram-lhes as mãos e os pés e penduraram os seus corpos perto do açude de Hebron. Depois tomaram a cabeça de Isbaal e enterraram-na no túmulo de Abner, em Hebron."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todas as tribosde Israel foram ter com David em Hebron e propuseram-lhe: «Vê! Somos do mesmo sangue."
,"2":"Já antes, quando Saul era nosso rei, o verdadeiro comandante de Israel eras tu. E Javé disse-te: 'Tu serás o pastor do meu povo Israel. Tu serás o chefe de Israel'»."
,"3":"Todos os anciãos de Israel foram visitar o rei a Hebron, e David fez um pacto com eles em Hebron, diante de Javé. E eles ungiram David como rei de Israel."
,"4":"David tinha trinta anos quando começou a reinar, e reinou durante quarenta anos."
,"5":"Em Hebron, ele reinou sete anos e meio sobre Judá. Depois, em Jerusalém, reinou trinta e três anos sobre todo o Israel e sobre Judá."
,"6":"David marchou com os seus homens sobre Jerusalém, contra os jebuseus que habitavam o território. Os jebuseus disseram a David: «Não entrarás aqui, porque bastam os cegos e aleijados para te repelir». Isto queria dizer que David não entraria na cidade."
,"7":"Mas David conquistou a fortaleza de Sião, que ficou a ser a cidade de David."
,"8":"Naquele dia, David disse: «Todo aquele que ferir os jebuseus e subir pelo canal... Quanto aos cegos e aleijados, David detesta-os». É por isso que se diz: «Os cegos e aleijados não poderão entrar no Templo»."
,"9":"David instalou-se na fortaleza e deu-lhe o nome de Cidade de David. Em seguida, construiu uma grande muralha ao seu redor, desde o Melo até ao interior."
,"10":"David ia crescendo em poder. E Javé, Deus dos exércitos, estava com ele."
,"11":"Hiram, rei de Tiro, enviou uma embaixada a David, com madeira de cedro, carpinteiros e pedreiros, para lhe construir um palácio."
,"12":"Então David compreendeu que Javé o tinha confirmado como rei sobre Israel e exaltava a sua realeza por causa de Israel, povo de Javé."
,"13":"Chegando de Hebron, David tomou concubinas e mulheres em Jerusalém, e teve filhos e filhas."
,"14":"Os nomes dos filhos que teve em Jerusalém são: Samua, Sobab, Natã, Salomão,"
,"15":"Jebaar, Elisua, Nafeg, Jáfia,"
,"16":"Elisama, Baaliada e Elifalet."
,"17":"Os filisteus souberam que David fora ungido rei de Israel e subiram todos para o capturar. Ao saber disso, David desceu para o refúgio."
,"18":"Os filisteus chegaram e espalharam-se pelo vale dos Rafaim."
,"19":"Então David consultou Javé: «Devo atacar os filisteus? Entregá-los-ás nas minhas mãos?» Javé respondeu a David: «Podes atacar. Eu os entregarei nas tuas mãos»."
,"20":"David foi para Senhor-das-Brechas e ali venceu os filisteus. David disse: «Javé abriu para mim uma brecha nos meus inimigos, como uma brecha feita pelas águas». É por isso que esse lugar se chama Senhor-das-Brechas."
,"21":"Os filisteus abandonaram ali os seus ídolos, e David e os seus homens levaram-nos."
,"22":"Os filisteus subiram outra vez e espalharam-se pelo vale dos Rafaim."
,"23":"David consultou Javé, que respondeu: «Não os ataques pela frente. Dá a volta por detrás deles e ataca-os pelo lado das amoreiras."
,"24":"Quando ouvires um rumor de passos na copa das amoreiras, então apressa-te, porque é Javé que avança diante de ti para derrotar o exército filisteu»."
,"25":"David fez exactamente o que Javé tinha mandado, e derrotou os filisteus desde Gabaon até à entrada de Gazer."
}`)
	CurrentBook.AddChapter(6, `{
"1":"David reuniu de novo os melhores homens de Israel, cerca de trinta mil."
,"2":"Partiu com o seu exército para Baala de Judá, a fim de trazer dali a arca de Deus que levava o nome de Javé dos exércitos, entre os querubins."
,"3":"Colocaram a arca de Deus num carro novo, tirando-a da casa de Abinadab, que ficava sobre uma colina. Oza e Aio, filhos de Abinadab, conduziam o carro novo."
,"4":"Oza caminhava à esquerda da arca de Deus e Aio ia à frente dela."
,"5":"David e toda a casa de Israel, entusiasmados, dançavam diante de Javé, cantando ao som de cítaras, harpas, tamborins, pandeiros e címbalos."
,"6":"Quando chegaram à eira de Nacon, como os bois estavam a fazer tombar a arca de Deus, Oza estendeu a mão para a segurar."
,"7":"Então a ira de Javé inflamou-se contra Oza, e Deus feriu-o por causa da sua falta; e Oza morreu ali mesmo, junto à arca de Deus."
,"8":"David ficou triste, por Javé ter castigado Oza; por isso, deram a esse lugar o nome de Castigo de Oza, nome que se conserva até hoje."
,"9":"Naquele dia, David teve medo de Javé, e disse: «Como é que a arca de Javé poderá ser introduzida em minha casa?»"
,"10":"Então David desistiu de transferir a arca de Javé para a cidade de David. Por isso levou-a para casa de Obed-Edom de Gat."
,"11":"A arca de Javé permaneceu três meses na casa de Obed-Edom de Gat. Por isso é que Javé abençoou Obed-Edom e toda a sua família."
,"12":"Então informaram o rei David: «Javé abençoou a família de Obed-Edom e todos os seus por causa da arca de Deus». Contente, David foi e transportou a arca de Deus da casa de Obed-Edom para a cidade de David."
,"13":"A cada seis passos que os transportadores da arca de Javé davam, David sacrificava um boi e um bezerro gordo."
,"14":"David dançava com todo o entusiasmo diante de Javé e vestia um efod de linho."
,"15":"Deste modo, David e toda a casa de Israel transportaram a arca de Javé, com aclamações e toques de trombeta."
,"16":"Quando a arca de Javé entrou na cidade de David, Micol, filha de Saul, estava a olhar pela janela e viu o rei David saltando e dançando diante de Javé; por isso, desprezou-o no seu íntimo."
,"17":"Levaram a arca de Javé e colocaram-na no lugar que lhe fora reservado, dentro da tenda que David tinha mandado armar. Depois, David ofereceu holocaustos diante de Javé e também sacrifícios de comunhão."
,"18":"Tendo terminado de oferecer holocaustos e sacrifícios de comunhão, David abençoou o povo em nome de Javé dos exércitos."
,"19":"E distribuiu a todo o povo e a toda a multidão de Israel, homens e mulheres, um pedaço de pão, um bolo de tâmaras e um doce de uvas passas por cada pessoa. Em seguida, cada um foi para sua casa."
,"20":"David voltou para abençoar a sua família. Então Micol, filha de Saul, saiu ao encontro dele, e disse: «Que bela figura fez hoje o rei de Israel, desnudando-se diante das servas de seus servos, como se fosse um homem qualquer!»"
,"21":"David respondeu a Micol: «Diante de Javé que me escolheu a mim, e não ao teu pai e à sua família, para me colocar como chefe sobre o povo de Javé, sobre Israel, eu dançarei diante de Javé,"
,"22":"e me humilharei ainda mais. Serei desprezível aos teus olhos, mas serei honrado aos olhos das servas, de que falaste»."
,"23":"E Micol, filha de Saul, não teve filhos até ao dia da sua morte."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Orei David foi morar no seu palácio e Javé livrou-o de todos os inimigos ao redor."
,"2":"Então ele disse ao profeta Natã: «Vê! Eu moro num palácio de cedro, enquanto a arca de Deus mora numa tenda!»"
,"3":"Natã respondeu ao rei: «Vai e faz o que te dita o coração, porque Javé está contigo»."
,"4":"Nessa mesma noite, porém, a palavra de Javé foi dirigida a Natã:"
,"5":"«Vai dizer ao meu servo David: Assim diz Javé: Queres construir uma casa para Eu morar?"
,"6":"Pois bem: Eu não morei em casa nenhuma desde o dia em que tirei os filhos de Israel do Egipto até hoje. Sempre andei errante sob uma tenda e um abrigo."
,"7":"Durante todo o tempo em que caminhei com os filhos de Israel, porventura Eu disse a algum dos juízes de Israel, que estabeleci como pastores do meu povo: 'Porque não Me constróis uma casa de cedro?'"
,"8":"Portanto, diz ao meu servo David: Assim diz Javé dos exércitos: Eu tirei-te do pastoreio, onde cuidavas das ovelhas, para te fazer chefe do meu povo Israel."
,"9":"Estive contigo em toda a parte por onde andavas, e destruí diante de ti todos os teus inimigos. Dar-te-ei um grande nome, como o nome dos grandes da terra."
,"10":"Prepararei um lugar para o meu povo Israel, fixá-lo-ei nele, para que habite no seu lugar próprio. E assim ele não precisará de andar errante. Os perversos não continuarão a oprimi-lo como antes,"
,"11":"como acontece desde o dia em que estabeleci juízes sobre o meu povo Israel. Eu livrar-te-ei de todos os teus inimigos. Javé informa que vai fundar uma dinastia para ti."
,"12":"E quando esgotares os teus dias e repousares com os teus antepassados, Eu exaltarei a tua descendência depois de ti, aquele que vai sair de ti. E firmarei a tua realeza."
,"13":"Ele é que vai construir uma casa para o meu nome. E Eu estabelecerei o seu trono real para sempre."
,"14":"Serei para ele um pai e ele será para Mim um filho. Se ele falhar, Eu corrigi-lo-ei com bastão e chicote, como se costuma fazer."
,"15":"Mas não desistirei de ser fiel para com ele, como desisti de Saul, que tirei da tua frente."
,"16":"A sua dinastia e realeza permanecerão firmes para sempre diante de Mim; o seu trono será sólido para sempre'»."
,"17":"Natã comunicou a David todas estas palavras e toda esta visão."
,"18":"O rei David foi apresentar-se diante de Javé, e disse: «Quem sou eu, Senhor Javé, e o que é a minha família para que me conduzisses até aqui?"
,"19":"E, no entanto, isso ainda é pouco para Ti, Senhor Javé! Fizeste ainda promessas à família do teu servo, para o futuro distante, enquanto existir a humanidade, Senhor Javé!"
,"20":"O que poderei eu, David, acrescentar às tuas palavras? Tu conheces o teu servo, Senhor Javé!"
,"21":"É por causa da tua palavra e segundo o teu coração que fizeste que o teu servo conhecesse todas essas grandes coisas."
,"22":"Por isso Tu és grande, Senhor Javé! Ninguém é como Tu, e não existe nenhum deus além de ti, como ouvimos com os nossos próprios ouvidos!"
,"23":"Quem é como o teu povo, como Israel, a única nação da Terra que Deus veio resgatar para ser seu povo e para lhe dar um nome? Realizaste coisas grandes e terríveis em favor dele, do teu país, do teu povo, que resgataste do Egipto, dentre as nações e deuses."
,"24":"Estabeleceste o teu povo Israel para ser o teu povo para sempre. Tu, Javé, tornaste-Te o seu Deus."
,"25":"Agora, Javé Deus, confirma para sempre a promessa que fizeste ao teu servo e à sua família, e faz como prometeste."
,"26":"E o teu nome será engrandecido para sempre. Então se dirá: Javé dos exércitos é o Deus de Israel. Então a família do teu servo David permanecerá firme diante de Ti."
,"27":"De facto, Javé dos exércitos e Deus de Israel, Tu mostraste uma visão ao teu servo e disseste: 'Construirei uma dinastia para ti'. É por isso que o teu servo encontrou coragem para Te fazer esta oração."
,"28":"Senhor Javé, Tu és Deus! E o que disseste é verdade. Tu prometeste estas coisas boas ao teu servo!"
,"29":"Agora, consente em abençoar a família do teu servo, para que esteja sempre na tua presença. Porque Tu falaste, Senhor Javé, e através da tua bênção a família do teu servo será abençoada para sempre»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Depois disso, David derrotou os filisteus e subjugou-os, tirando-lhes o controlo militar."
,"2":"Derrotou também os moabitas e, depois de os estender no chão, mediu-os com a corda: mediu duas cordas para os condenar à morte e uma corda inteira para os deixar com vida. Depois disso, os moabitas tornaram-se súbditos de David e começaram a pagar-lhe tributo."
,"3":"David derrotou também Adadezer, filho de Roob, rei de Soba, quando este pretendia estender o seu domínio sobre o rio Eufrates."
,"4":"David tomou-lhe mil e setecentos condutores de carro, vinte mil homens da infantaria, e cortou os tendões de todas as parelhas de cavalos, conservando apenas cem."
,"5":"Os arameus de Damasco foram socorrer Adadezer, rei de Soba, mas David feriu vinte e dois mil homens dentre os arameus."
,"6":"Depois colocou governadores em Aram de Damasco, e os arameus tornaram-se seus súbditos, pagando-lhe tributos. E Javé fazia David sair vitorioso em qualquer lugar aonde ele fosse."
,"7":"David ainda tomou os escudos de ouro que os guerreiros de Adadezer usavam e levou-os para Jerusalém."
,"8":"Tomou também grande quantidade de cobre de Tebá e Berotai, cidades de Adadezer."
,"9":"Toú, rei de Emat, soube que David tinha derrotado todo o exército de Adadezer."
,"10":"Ora, como Adadezer era inimigo de Toú, este enviou o seu filho Adoram para saudar David e o cumprimentar por ter enfrentado Adadezer e o ter derrotado. Adoram levou objectos de prata, ouro e bronze,"
,"11":"que o rei David consagrou a Javé, juntamente com o ouro e a prata que havia tomado às nações conquistadas:"
,"12":"a Aram e Moab, aos amonitas e filisteus, aos amalecitas e os despojos de Adadezer, filho de Roob, rei de Soba."
,"13":"A fama de David aumentou quando ele voltou vitorioso contra dezoito mil homens de Edom, no Vale do Sal."
,"14":"David estabeleceu governadores em todo o território de Edom, de modo que todos os edomitas se tornaram seus servos. E Javé estava com David em qualquer lugar aonde ele ia."
,"15":"David reinou sobre todo o Israel, exercendo o direito e a justiça para com todo o seu povo."
,"16":"Joab, filho de Sárvia, era o chefe do exército. Josafá, filho de Ailud, era o porta-voz."
,"17":"Sadoc e Abiatar, filho de Aquitob e neto de Aquimelec, eram os sacerdotes. Saraías era o secretário."
,"18":"E Banaías, filho de Joiada, comandava os cereteus e feleteus. Os filhos de David eram sacerdotes."
}`)
	CurrentBook.AddChapter(9, `{
"1":"David perguntou: «Existe ainda algum sobrevivente da família de Saul para que eu mostre benevolência para com ele, por causa de Jónatas?»"
,"2":"Na família de Saul havia um servo chamado Siba. Ele foi conduzido até David, e o rei perguntou-lhe: «Tu és Siba?» Ele respondeu: «Para te servir»."
,"3":"O rei perguntou: «Existe algum sobrevivente da família de Saul, para que eu demonstre a benevolência de Deus para com ele?» Siba disse ao rei: «Existe ainda um filho de Jónatas, aleijado dos dois pés»."
,"4":"David perguntou: «Onde está ele?» Siba respondeu: «Em casa de Maquir, filho de Amiel, em Lo-Dabar»."
,"5":"Então David mandou buscar o filho de Jónatas a casa de Maquir, filho de Amiel, em Lo-Dabar."
,"6":"Ao chegar diante de David, Meribaal, filho de Jónatas e neto de Saul, caiu com o rosto por terra e prostrou-se. David disse: «Meribaal!» Este respondeu: «Aqui está o teu servo»."
,"7":"David disse-lhe: «Não tenhas medo, pois vou usar de benevolência para contigo, por causa de teu pai Jónatas. Restituir-te-ei todas as terras do teu avô Saul, e comerás sempre à minha mesa»."
,"8":"Meribaal prostrou-se e disse: «Quem é o teu servo, para que te dirijas a um cão morto como eu?»"
,"9":"Então o rei chamou Siba, servo de Saul, e disse-lhe: «Tudo o que pertencia a Saul e à sua família, eu dou-o ao filho do teu senhor."
,"10":"Tu trabalharás a terra para ele, tu, os teus filhos e servos. Tu trarás o necessário para o sustento de Meribaal, filho do teu senhor, pois ele comerá sempre à minha mesa». Siba tinha quinze filhos e vinte servos."
,"11":"Ele disse ao rei: «Tudo o que o rei meu senhor mandar, assim o teu servo fará». E Meribaal começou a comer à mesa de David, como se fosse um filho do rei."
,"12":"Meribaal tinha um filho pequeno, chamado Micas, e todos os servos da casa de Siba estavam a serviço de Meribaal."
,"13":"Por isso, Meribaal foi morar em Jerusalém, pois comia sempre à mesa do rei. Ele era aleijado de ambos os pés."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Depois disto, o rei dos amonitas morreu, e seu filho Hanon reinou em seu lugar."
,"2":"David pensou: «Vou usar de benevolência para com Hanon, filho de Naás, do mesmo modo como o pai dele fez comigo». Então David enviou embaixadores para dar os pêsames a Hanon, por causa da morte do pai dele. Quando os servos de David entraram no país dos amonitas,"
,"3":"os príncipes amonitas disseram a Hanon, seu senhor: «Pensas que David quer honrar o teu pai, só porque mandou gente a apresentar-te os pêsames? Será que ele não enviou essa gente até aqui para observar a cidade, conhecer as defesas e depois destruí-la?»"
,"4":"Então Hanon mandou prender os embaixadores de David, rapar-lhes metade da barba e rasgar-lhes as vestes ao meio, até às nádegas. Depois mandou-os embora."
,"5":"Ao ser informado, David enviou imediatamente alguém ao encontro deles, porque estavam muito envergonhados. E o rei mandou dizer-lhes: «Ficai em Jericó até que a vossa barba cresça; depois voltareis»."
,"6":"Os amonitas perceberam que se haviam tornado odiosos a David. Por isso, mandaram contratar os arameus de Bet-Roob e os arameus de Soba, vinte mil homens de infantaria. Contrataram também o rei de Maaca com mil homens e gente de Tob, doze mil homens."
,"7":"Quando David soube disso, mandou Joab e todo o exército dos valentes."
,"8":"Os amonitas saíram da cidade e puseram-se em ordem de batalha à entrada da porta, enquanto os arameus de Soba e Roob, mais a gente de Tob e de Maaca, ficaram à parte, em campo aberto."
,"9":"Joab percebeu que iria ser atacado pela frente e pela retaguarda. Então escolheu todos os melhores de Israel e dispô-los para enfrentar os arameus,"
,"10":"confiando o resto da tropa a seu irmão Abisaí, dispondo-a para enfrentar os amonitas."
,"11":"E Joab disse a Abisaí: «Se os arameus levarem vantagem sobre mim, virás em meu auxílio; se os amonitas levarem vantagem sobre ti, então eu irei em teu auxílio."
,"12":"Sê corajoso, vamos ser corajosos, em favor do nosso povo e das cidades do nosso Deus! E seja feito o que Javé achar melhor!»"
,"13":"Então Joab avançou com a tropa que estava com ele para enfrentar os arameus, que fugiram diante dele."
,"14":"Ao verem que os arameus fugiam, os amonitas também fugiram de Abisaí, e entraram na cidade. Então Joab voltou da campanha contra os amonitas e reentrou em Jerusalém."
,"15":"Ao verem que tinham sido derrotados por Israel, os arameus reuniram-se."
,"16":"Adadezer mandou recado aos arameus, que estavam do outro lado do rio Eufrates, para que entrassem na luta. Eles foram para Helam, tendo à frente Sobac, chefe do exército de Adadezer."
,"17":"Informado, David reuniu todo o Israel, atravessou o Jordão e foi para Helam. Os arameus prepararam-se para enfrentar David e guerrear contra ele,"
,"18":"mas acabaram por fugir diante de Israel. E David destruiu setecentos carros e quarenta mil arameus condutores de carro. Também Sobac, chefe do seu exér-cito, foi ferido e ali mesmo veio a morrer."
,"19":"Todos os reis dependentes de Adadezer, vendo que tinham sido derrotados por Israel, fizeram a paz com Israel e tornaram-se seus dependentes. E os arameus nunca mais se arriscaram a ajudar os amonitas."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Na mudança do ano, quando os reis costumavam sair para a guerra, David mandou Joab, os seus guerreiros e todo o Israel. Eles foram, massacraram os amonitas e sitiaram a cidade de Rabá. Mas David ficou em Jerusalém."
,"2":"Numa tarde, levantando-se da cama, David foi passear no terraço do palácio real. Do terraço, ele viu uma mulher a tomar banho. Ela era muito bonita."
,"3":"David mandou colher informações sobre essa mulher. isseram-lhe: «Ela é Betsabeia, filha de Eliam e esposa de Urias, o heteu!»"
,"4":"Então David mandou emissários para que a trouxessem. Betsabeia foi e David teve relações com ela, que tinha acabado de se purificar das suas regras. Depois ela voltou para casa."
,"5":"Em consequência disso, Betsabeia concebeu, e mandou dizer a David: «Estou grávida!»"
,"6":"Então David mandou dizer a Joab: «Diz a Urias, o heteu, que venha falar comigo». E Joab mandou Urias ter com David."
,"7":"Quando Urias chegou, David perguntou-lhe como iam Joab, o exército e a guerra."
,"8":"Depois disse a Urias: «Vai para casa e lava os pés». Urias saiu do palácio e recebeu um presente da mesa do rei."
,"9":"Entretanto, Urias não foi para casa: dormiu à porta do palácio com os guardas do seu senhor."
,"10":"Informaram então David: «Urias não foi para casa». David perguntou a Urias: «Tu não chegaste de viagem? Porque não foste para casa?»"
,"11":"Urias respondeu: «A arca, Israel e Judá estão a viver em tendas, e o meu chefe Joab e os guerreiros do meu senhor estão acampados ao ar livre. Como posso ir para a minha casa, para comer e beber e dormir com a minha mulher? Pela tua própria vida, eu nunca faria uma coisa dessas!»"
,"12":"Então David disse a Urias: «Fica ainda hoje aqui. Amanhã deixar-te-ei partir». Urias ficou mais esse dia em Jerusalém. No dia seguinte,"
,"13":"David convidou Urias para comer e beber na sua presença, e embriagou-o. Pela tarde, Urias saiu e foi deitar-se no mesmo lugar em que dormiam os guardas do seu senhor, e não foi para casa."
,"14":"Na manhã seguinte, David escreveu uma carta a Joab e mandou-a por meio de Urias."
,"15":"Na carta, ele escreveu: «Coloca Urias no lugar mais perigoso da batalha e retirai-vos, deixando-o sozinho, para que seja ferido e morra»."
,"16":"Joab estava cercando a cidade e colocou Urias no lugar onde sabia que estavam os guerreiros mais valentes."
,"17":"Os que estavam defendendo a cidade saíram para atacar Joab, e do exército morreram alguns da guarda de David. E morreu também Urias, o heteu."
,"18":"Joab mandou a David um relatório sobre a guerra"
,"19":"e ordenou ao mensageiro: «Quando acabares de fazer o relatório ao rei,"
,"20":"o rei poderá ficar enfurecido e perguntar: 'Porque vos aproximastes da cidade para lutar? Não sabíeis que os arqueiros atiram do alto das muralhas?"
,"21":"Quem matou Abimelec, o filho de Jerobaal? Foi uma mulher que lançou do alto da muralha uma pedra de moinho, e Abimelec morreu em Tebes. Porque vos aproximastes da muralha?' Então dirás: 'Morreu também o teu servo Urias, o heteu'»."
,"22":"O mensageiro partiu, apresentou-se a David e relatou-lhe a mensagem de Joab. Então David ficou enfurecido contra Joab."
,"23":"Mas o mensageiro disse a David: «É que o inimigo atacou-nos de surpresa, saindo em campo aberto. Nós fizemo-lo recuar até à entrada da cidade,"
,"24":"e então os arqueiros dispararam do alto das muralhas. Alguns guerreiros do rei caíram mortos, e morreu também o teu servo Urias, o heteu»."
,"25":"Então David disse ao mensageiro: «Diz a Joab que não se preocupe com esse caso. A guerra é assim mesmo: um dia cai um, outro dia cai outro. Que ele redobre o ataque contra a cidade e a destrua. Procura animá-lo»."
,"26":"A mulher de Urias soube que o seu marido tinha morrido e ficou de luto."
,"27":"Quando terminou o luto, David mandou buscá-la e recolheu-a no seu palácio. David tomou-a como esposa, e ela deu à luz um filho. Javé, porém, reprovou o que David tinha feito."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Javé mandou o profeta Natã falar com David. Natã apresentou-se e disse a David: «Havia dois homens numa cidade: um era rico e o outro era pobre."
,"2":"O rico tinha muitos rebanhos de ovelhas e bois."
,"3":"O pobre tinha só uma ovelha, uma ovelhinha que ele havia comprado. O pobre criava-a e ela foi crescendo com ele, com os seus filhos, comendo do seu pão, bebendo do seu copo e dormindo no seu colo. Era como uma filha para ele."
,"4":"Ora, chegou uma visita à casa do homem rico, e este não quis tomar nenhuma das suas ovelhas ou vacas para servir ao viajante que o visitava. Então ele apoderou-se da ovelha do homem pobre e preparou-a para a sua visita»."
,"5":"David ficou furioso contra tal homem, e disse a Natã: «Pela vida de Javé, quem fez isso merece a morte."
,"6":"Por não respeitar o que pertencia a outro, deverá pagar quatro vezes o valor da ovelha»."
,"7":"Então Natã disse a David: «Pois esse homem és tu mesmo! Assim diz Javé, Deus de Israel: Eu ungi-te rei de Israel e salvei-te de Saul."
,"8":"Eu dei-te a casa do teu senhor. Coloquei nos teus braços as mulheres do teu senhor. Dei-te a casa de Israel e de Judá. E se isso ainda não te parece suficiente, dar-te-ei qualquer outra coisa."
,"9":"Então porque desprezaste Javé e fizeste o que Ele reprova? Assassinaste Urias, o heteu, para te casares com a mulher dele, e mataste Urias com a espada dos amonitas."
,"10":"Pois bem! A espada nunca mais se afastará da tua família, porque Me desprezaste e tomaste a mulher de Urias, o heteu, para te casares com ela."
,"11":"Assim diz Javé: Eu farei com que a desgraça surja contra ti de dentro da tua própria casa. Tomarei as tuas mulheres e dá-las-ei a outro diante dos teus olhos, e ele dormirá com as tuas mulheres à luz do sol."
,"12":"Agiste às escondidas, mas Eu farei tudo isto diante de todo o Israel e em pleno dia»."
,"13":"David disse a Natã: «Pequei contra Javé». Então Natã disse a David: «Javé perdoou o teu pecado. Tu não morrerás."
,"14":"Mas, por teres ultrajado Javé, com o teu comportamento, o filho que te nasceu morrerá»."
,"15":"E Natã voltou para casa. Javé atingiu o menino que a mulher de Urias dera a David, e o menino ficou gravemente enfermo. "
,"16":"David suplicou a Javé pelo menino, jejuou, ficou perto dele, e passou a noite prostrado no chão."
,"17":"Os anciãos da sua casa tentaram erguê-lo, mas ele recusou e não quis comer nada com eles."
,"18":"Sete dias depois, o menino morreu. Os servos de David ficaram com medo de lhe dar a notícia de que o menino tinha morrido, pois comentavam: «Quando o menino estava vivo, nós falámos com ele, e ele não nos atendeu. Como podemos agora dizer-lhe que o menino morreu? Ele pode cometer alguma loucura!»"
,"19":"David notou que os servos cochichavam entre si, e compreendeu que o menino tinha morrido. Então perguntou: «O menino morreu?» Eles responderam: «Morreu»."
,"20":"Então David levantou-se do chão, lavou-se, perfumou-se e mudou de roupa. Depois entrou no santuário de Javé e prostrou-se. Em seguida voltou para casa, mandou que servissem a refeição e comeu."
,"21":"Os servos perguntaram: «Que fazes? Enquanto o menino estava vivo, jejuaste e choraste; agora que ele morreu, levantas-te e pões-te a comer?»"
,"22":"David respondeu: «Enquanto o menino vivia, eu jejuei e chorei, pensando que talvez Javé tivesse piedade de mim e o menino ficasse curado."
,"23":"Mas agora ele morreu. Para que hei-de jejuar? Será que isso vai fazê-lo voltar? Eu é que vou para onde ele está, mas ele não voltará para mim»."
,"24":"David consolou sua mulher Betsabeia; entrou no aposento e dormiu com ela. Betsabeia deu à luz um filho, e David deu-lhe o nome de Salomão. Javé amou Salomão,"
,"25":"e manifestou-o através do profeta Natã. Este, por ordem de Javé, deu a Salomão o nome de Querido de Javé."
,"26":"Joab atacou Rabá dos amonitas e apoderou-se da cidade real."
,"27":"Em seguida, enviou mensageiros a David para o informar: «Ataquei Rabá e também me apoderei da cidade das águas."
,"28":"Agora reúne o resto do povo, cerca a cidade e apodera-te dela. De contrário, eu mesmo o farei, e ela receberá o meu nome»."
,"29":"Então David reuniu todo o povo, foi para Rabá, atacou-a e apoderou-se dela."
,"30":"Tirou da cabeça do deus Melcom a coroa, que pesava cerca de trinta e cinco quilos. Nela havia uma pedra preciosa, que foi colocada na coroa de David. E David levou da cidade um despojo muito grande."
,"31":"Tirou também a população da cidade e colocou-a a trabalhar com serra, picaretas e machados de ferro, e na fabricação de tijolos. E fez a mesma coisa com todas as outras cidades amonitas. Depois David e todo o povo voltaram para Jerusalém."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Depois disto, aconteceu o seguinte: Absalão, filho de David, tinha uma irmã bonita chamada Tamar. Amnon, filho de David, ficou apaixonado por ela."
,"2":"Amnon chegou a ponto de ficar doente por causa de sua irmã Tamar, pois ela era virgem e ele viu que era impossível fazer alguma coisa com ela."
,"3":"Amnon tinha um amigo muito esperto chamado Jonadab, filho de Sama, irmão de David."
,"4":"Ele disse a Amnon: «Filho do rei, porque estás tão deprimido todas as manhãs? Porque não me dizes o que está acontecendo?» Amnon respondeu: «É porque estou apaixonado por Tamar, a irmã do meu irmão Absalão»."
,"5":"Jonadab sugeriu: «Fica na cama fingindo-te doente. Quando o teu pai vier para te visitar, diz-lhe: 'Deixa que minha irmã Tamar me traga de comer: ela fará a comida à minha vista, para que eu veja; e ela própria me servirá'»."
,"6":"Então Amnon foi deitar-se, fingindo que estava doente. O rei foi vê-lo, e Amnon disse-lhe: «Deixa que minha irmã Tamar venha preparar, na minha frente, dois pastéis, e que ela mesma me sirva»."
,"7":"Então David mandou buscar Tamar à casa dela, dizendo: «Vem à casa de teu irmão Amnon para lhe preparares a comida»."
,"8":"Tamar foi e encontrou o irmão deitado. Ela tomou farinha, amassou, preparou os pastéis na frente dele, e levou-os para os cozer no fogo."
,"9":"Em seguida, pegou na panela, despejou-a no prato dele, mas ele não quis comer. Amnon disse: «Manda sair daqui toda esta gente!» E todos saíram."
,"10":"Então Amnon disse a Tamar: «Traz tu mesma a comida aqui ao quarto, para eu comer». Tamar pegou nos pastéis que tinha feito e levou-os ao seu irmão, no quarto."
,"11":"Quando ela apresentou a comida, ele agarrou-a e disse: «Dorme comigo, minha irmã»."
,"12":"Ela respondeu: «Não, meu irmão. Não me violentes, pois isso não se faz em Israel. Não cometas essa infâmia."
,"13":"Aonde eu iria esconder a minha vergonha? E tu serias um infame em Israel! Fala com o rei, e ele não recusará que eu me case contigo»."
,"14":"Amnon, porém, não deu atenção ao que ela dizia: dominou-a com violência e teve relações com ela."
,"15":"Depois Amnon ficou furioso. A aversão que teve para com Tamar foi maior do que a paixão com que a tinha amado. Ele disse: «Levanta-te e vai-te embora»."
,"16":"Ela respondeu: «Não. Se me mandares embora será um mal bem pior do que aquilo que me acabas de fazer». Ele, porém, não quis ouvi-la."
,"17":"Chamou o criado que o servia e disse: «Põe esta jovem fora daqui e tranca a porta»."
,"18":"Tamar vestia uma túnica de mangas compridas, porque era assim que se vestiam as filhas solteiras do rei. O criado fez com que ela saísse, e trancou a porta."
,"19":"Tamar colocou terra na cabeça, rasgou a túnica de mangas compridas, colocou as mãos na cabeça e saiu a gritar."
,"20":"Seu irmão Absalão disse-lhe: «O teu irmão Amnon esteve contigo? Agora, não digas nada: ele é teu irmão. Esquece o que aconteceu». E Tamar, desolada, foi morar em casa de seu irmão Absalão."
,"21":"O rei David soube do que tinha acontecido e ficou muito irritado, mas não quis castigar o seu filho Amnon, porque era o primogénito e ele amava-o muito."
,"22":"Por causa da violência que Amnon cometeu com sua irmã Tamar, Absalão rompeu com ele e passou a odiá-lo."
,"23":"Dois anos depois, Absalão estava a fazer a tosquia das ovelhas em Baal-Hasor, perto de Efraim. Então ele convidou todos os filhos do rei."
,"24":"Ele foi ter com o rei e disse-lhe: «O teu servo está a fazer a tosquia. Que o rei e seus ministros se dignem aceitar o convite»."
,"25":"O rei respondeu: «Não, meu filho. Se lá formos todos, será muito pesado para ti». Absalão insistiu, mas o rei não quis ir e abençoou-o."
,"26":"Absalão então disse: «Ao menos deixa ir o meu irmão Amnon». O rei perguntou: «Porque haveria ele de ir contigo?»"
,"27":"Mas Absalão insistiu, e o rei deixou que fossem com ele Amnon e todos os filhos do rei."
,"28":"Absalão ordenou aos seus servos: «Ficai alerta. Quando Amnon estiver alegre por causa do vinho, e eu vos disser para o ferirdes, matai-o. Não tenhais medo, porque sou eu quem vo-lo ordena. Tende coragem e sede valentes!»"
,"29":"Os servos de Absalão fizeram conforme ele havia mandado. Então todos os filhos do rei se levantaram, cada um montou no seu jumento, e fugiram."
,"30":"Ainda eles estavam a caminho, quando chegou aos ouvidos do rei este boato: «Absalão matou todos os filhos do rei e não sobrou nenhum deles!»"
,"31":"O rei levantou-se, rasgou as vestes e prostrou-se por terra; e todos os ministros ali presentes também rasgaram as suas vestes."
,"32":"Jonadab, filho de Sama, irmão de David, interveio: «Não pense o meu senhor que morreram todos os filhos do rei, porque de facto só Amnon morreu. Absalão tinha prometido fazer isso desde o dia em que Amnon violentou Tamar, sua irmã."
,"33":"Portanto, que o rei não fique preocupado, pensando que todos os filhos do rei morreram. Foi só Amnon que morreu,"
,"34":"e Absalão fugiu». O jovem que estava de guarda levantou os olhos e viu muita gente que avançava pelo caminho de Baurim. O jovem foi contar ao rei: «Vi gente no caminho de Baurim, na ladeira da montanha»."
,"35":"Então Jonadab disse ao rei: «São os filhos do rei que chegam! Foi mesmo como o teu servo contou»."
,"36":"Logo que acabou de falar, chegaram os filhos do rei e começaram a gritar e a chorar. Também o rei e todos os seus ministros começaram a chorar inconsolavelmente."
,"37a":"Absalão escondeu-se no território de Tolmai, filho de Amiud, rei de Gessur,"
,"38":"e ali ficou durante três anos."
,"37b":"O rei ficou de luto pelo seu filho durante todo esse tempo."
,"39":"Depois disso, o rei consolou-se da morte de Amnon e deixou de perseguir Absalão."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Joab, filho de Sárvia, percebeu que o rei estava contra Absalão."
,"2":"Então Joab mandou vir de Técua uma mulher esperta, e disse-lhe: «Faz o seguinte: finge que estás de luto, veste-te de luto e não te perfumes, como se fosses uma mulher que há muito tempo está de luto por um morto."
,"3":"Vai à casa do rei e diz o seguinte...». E Joab informou-a de tudo o que ela devia dizer."
,"4":"A mulher de Técua apresentou-se ao rei, caiu com o rosto por terra, e disse: «Salva-me, ó rei!»"
,"5":"O rei perguntou: «O que tens?» A mulher respondeu: «Ai de mim! Sou viúva. Meu marido morreu,"
,"6":"e deixou-me com dois filhos. Eles lutaram no campo, e não havia ninguém para os apartar. Um feriu o outro e matou-o."
,"7":"Então todo o clã se pôs contra mim e disse: 'Entrega-nos o fratricida, para que o matemos, como preço pela vida do irmão que ele matou. E assim acabaremos com o herdeiro'. Deste modo eles vão apagar a brasa que me resta e não deixarão que o meu marido tenha nem nome nem descendência sobre a terra»."
,"8":"O rei disse à mulher: «Vai para casa, que eu me encarrego do teu problema»."
,"9":"A mulher de Técua disse ao rei: «Senhor meu rei, que a responsabilidade caia sobre mim e sobre a minha família. O rei e o seu trono estão inocentes»."
,"10":"O rei respondeu: «Se alguém te ameaçar traze-o à minha presença, e ele nunca mais te molestará»."
,"11":"A mulher disse: «Ó rei, lembra-te de Javé teu Deus, a fim de que o vingador do sangue não aumente a desgraça, acabando com o meu filho». Então o rei disse: «Pela vida de Javé! Nem sequer um cabelo da cabeça do teu filho cairá no chão»."
,"12":"A mulher acrescentou: «Posso dizer mais uma coisa ao senhor meu rei?» O rei respondeu: «Fala»."
,"13":"Então a mulher disse: «Porque pensas fazer o mesmo contra o povo de Deus? Pronunciando esta sentença, o rei condenou-se a si próprio, porque o rei não deixa voltar o filho que desterrou."
,"14":"Nós devemos morrer e, como a água derramada no chão já não pode ser recolhida, Deus também não dará a vida a um cadáver. Que o rei faça voltar o exilado, para que ele não continue longe."
,"15":"Se eu vim contar isto ao rei meu senhor, foi porque alguns me amedrontaram, e a tua serva pensou: 'Vou falar com o rei, e talvez ele atenda o pedido da sua serva."
,"16":"Porque o rei atenderá a sua serva e a livrará das mãos daqueles que tentam tirar, a mim e a meu filho, a herança de Deus'."
,"17":"A tua serva pensou: 'A palavra do senhor meu rei vai trazer-me alívio, porque o rei é como um enviado de Deus, que sabe distinguir o bem e o mal'. Que Javé teu Deus esteja contigo»."
,"18":"Então o rei disse à mulher: «Não me escondas nada do que te vou perguntar». A mulher respondeu: «Fala, senhor meu rei»."
,"19":"O rei perguntou: «A mão de Joab não está por detrás de tudo o que me vieste contar?» A mulher respondeu: «Pela tua vida, senhor meu rei, a tua pergunta acertou no alvo: foi o teu servo Joab quem me mandou e colocou na minha boca todas as palavras que eu te disse."
,"20":"Ele imaginou isto, para não apresentar o assunto directamente, mas o meu senhor tem a sabedoria de um enviado de Deus e sabe tudo o que se passa na terra»."
,"21":"Então o rei disse a Joab: «Pois bem, eu já dei a minha palavra. Vai e traz de volta o jovem Absalão»."
,"22":"Joab caiu com o rosto por terra, prostrou-se, abençoou o rei, e disse: «Hoje o teu servo sabe que estás bem disposto comigo, pois atendeste o meu pedido»."
,"23":"Depois Joab partiu, foi a Gessur e trouxe Absalão de volta para Jerusalém."
,"24":"O rei, porém, ordenou: «Que ele vá para casa, porque eu não quero recebê-lo». E Absalão retirou-se para sua casa e não foi recebido pelo rei."
,"25":"Em todo o Israel não havia homem que fosse tão elogiado pela sua beleza como Absalão: da planta dos pés ao alto da cabeça, era sem defeito."
,"26":"Ele costumava cortar o cabelo no fim de cada ano, porque pesava muito; quando ele o cortava, o cabelo pesava mais de dois quilos, conforme o peso-padrão do rei."
,"27":"Absalão tinha três filhos, e uma filha chamada Tamar. Era uma linda mulher."
,"28":"Absalão ficou dois anos em Jerusalém sem ser recebido pelo rei."
,"29":"Então Absalão mandou chamar Joab, para que servisse de intermediário entre ele e o rei. Mas Joab não aceitou. Chamou-o, pela segunda vez, e Joab recusou de novo."
,"30":"Absalão disse então aos seus servos: «Vede: o campo de Joab é vizinho do meu e está semeado de cevada. Ide e deitai-lhe o fogo». Os servos de Absalão foram e incendiaram o campo."
,"31":"Joab procurou Absalão em sua casa, e perguntou-lhe: «Porque é que os teus servos incendiaram o meu campo?»"
,"32":"Absalão respondeu: «Mandei-te chamar para servires de intermediário e levares ao rei esta mensagem: 'Para quê voltei de Gessur? Lá eu estava melhor'. Agora quero ser recebido pelo rei. Se sou culpado, que ele me condene à morte»."
,"33":"Joab apresentou-se ao rei e relatou-lhe a mensagem. Então o rei chamou Absalão. Este apresentou-se e prostrou-se com o rosto por terra. E o rei beijou Absalão."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Depois disto, Absalão comprou para si um carro e cavalos, e também uma guarda pessoal composta de cinquenta homens."
,"2":"Absalão levantava-se bem cedo e ficava à beira do caminho junto da porta da cidade. A toda a pessoa que tinha um processo e ia para ser julgada pelo rei, Absalão perguntava: «De que cidade és tu?» Ela respondia: «O teu servo pertence a uma das tribos de Israel»."
,"3":"Então Absalão dizia-lhe: «A tua causa é boa e simples, mas não há ninguém, da parte do rei, que queira ouvi-la»."
,"4":"E continuava: «Se eu fosse constituído juiz em Israel, julgaria com justiça todo aquele que tivesse algum processo!»"
,"5":"E quando alguém se aproximava para se prostrar diante dele, Absalão estendia a mão, erguia-o e beijava-o."
,"6":"Fazia a mesma coisa com todos os israelitas que iam para ser julgados pelo rei. Deste modo, Absalão conquistava os corações dos israelitas."
,"7":"Passados quatro anos, Absalão disse ao rei: «Deixa-me ir a Hebron cumprir uma promessa que fiz a Javé,"
,"8":"pois quando eu estava em Gessur de Aram fiz uma promessa: 'Se Javé me permitir voltar para Jerusalém, oferecerei sacrifícios a Javé em Hebron'»."
,"9":"O rei respondeu: «Vai em paz». E Absalão partiu para Hebron."
,"10":"Então Absalão mandou emissários a todas as tribos de Israel, com este recado: «Quando ouvirdes o som da trombeta, podereis dizer: Absalão tornou-se rei em Hebron»."
,"11":"E Absalão convidou, para o acompanharem, duzentos homens de Jerusalém, que foram inocentemente, sem saber de nada."
,"12":"Enquanto fazia os sacrifícios, Absalão mandou buscar, à cidade de Gilo, o gilonita Aquitofel, que era conselheiro de David. A conspiração fortalecia-se e o partido de Absalão aumentava."
,"13":"Alguém informou David: «Os israelitas aderiram a Absalão!»"
,"14":"Então David disse a todos os ministros que estavam com ele em Jerusalém: «Vamos fugir. Caso contrário, não escaparemos a Absalão. Vamos partir depressa, para que ele não chegue antes e nos ataque, nos destrua e passe a cidade ao fio de espada»."
,"15":"Os ministros do rei responderam: «Qualquer que seja a,decisão do senhor nosso rei, ficaremos às tuas ordens». "
,"16":"O rei deixou dez concubinas a guardar o palácio, e partiu a pé com toda a sua família."
,"17":"O rei saiu a pé com todo o povo, e pararam na última casa."
,"18":"Todos os seus ministros se colocaram a seu lado, e os cereteus, os feleteus, Etai, e os gateus que tinham vindo de Gat, cerca de seiscentos homens, foram passando diante do rei."
,"19":"E o rei disse a Etai, o gateu: «Porque vieste connosco? Volta e fica com o rei, porque és um estrangeiro que vives longe do teu país."
,"20":"Chegaste ontem! Como posso permitir que saias hoje connosco, como errante, quando eu próprio estou andando sem rumo? Volta e leva contigo os teus irmãos. Que Javé seja misericordioso e fiel para contigo»."
,"21":"Etai, porém, respondeu: «Pela vida de Javé e pela vida do senhor meu rei, onde estiver o senhor meu rei, aí também estarei eu, tanto para a vida como para a morte»."
,"22":"Então David disse a Etai: «Vamos em frente». E Etai de Gat passou com todos os seus homens e toda a multidão que estava com ele."
,"23":"Todos choravam e gritavam. O rei parou na margem do riacho do Cedron, e todo o povo desfilou diante dele, em direcção ao deserto."
,"24":"Ali estavam também Sadoc e todos os levitas, que transportavam a arca de Deus. Eles puseram a arca de Deus diante de Abiatar, até que o povo todo acabou de sair da cidade."
,"25":"Então o rei disse a Sadoc: «Volta com a arca de Deus para a cidade. Se Javé for bondoso para comigo, Ele me deixará voltar, para rever a arca e a sua habitação."
,"26":"Mas se Ele me disser que não gosta de mim, aqui estou. Que Ele faça de mim o que quiser»."
,"27":"E continuou: «Volta em paz para a cidade com o teu filho Aquimaás, e Abiatar com o seu filho Jónatas."
,"28":"Vede: eu vou ficar andando pelos caminhos do deserto, à espera que me envieis notícias»."
,"29":"Sadoc e Abiatar voltaram com a arca de Deus para Jerusalém e aí permaneceram."
,"30":"David subiu a encosta das Oliveiras, chorando, com a cabeça coberta e os pés descalços. Todo o povo que o acompanhava ia de cabeça coberta e chorando."
,"31":"E disseram a David: «Aquitofel uniu-se à conspiração de Absalão». David, então, rezou: «Javé, faz com que o plano de Aquitofel fracasse»."
,"32":"Quando David chegou ao ponto mais alto, onde se adora a Deus, foi ao seu encontro o seu amigo Cusai, o araquita; chegou com as vestes rasgadas e a cabeça coberta de pó."
,"33":"David disse-lhe: «Se ficares comigo, serás um peso para mim."
,"34":"Mas podes fazer com que o plano de Aquitofel fracasse, se voltares para a cidade e disseres a Absalão: 'Senhor meu rei, eu sou teu servo: antes fui servo de teu pai, mas agora sou teu servo'."
,"35":"Lá terás do teu lado os sacerdotes Sadoc e Abiatar, a quem comunicarás tudo o que ouvires no palácio."
,"36":"Lá estarão também os dois filhos deles: Aquimaás, filho de Sadoc, e Jónatas, filho de Abiatar. Por meio deles comunicar-me-eis tudo o que observardes»."
,"37":"Cusai, amigo de David, foi para a cidade, e Absalão entrou em Jerusalém."
}`)
	CurrentBook.AddChapter(16, `{
"1":"David tinha descido um poucodo alto do monte, quando Siba, servo de Meribaal, foi ao seu encontro com dois jumentos, carregados com duzentos pães, cem cachos de uvas passas, cem frutos da estação e um pipo de vinho."
,"2":"O rei perguntou a Siba: «O que vais fazer com isso?» Siba respondeu: «Os jumentos servirão de montada para a família real; os pães e as frutas para os teus servos comerem, e o vinho para os que desmaiarem no deserto»."
,"3":"O rei perguntou: «Onde está o filho do teu senhor?» Siba respondeu: «Ele ficou em Jerusalém, porque espera que a casa de Israel lhe devolva agora o reino de seu pai»."
,"4":"Então o rei disse a Siba: «Tudo o que Meribaal possui te pertence». Siba disse: «Eu prostro-me diante de ti. Sê bondoso para comigo, senhor meu rei»."
,"5":"Quando o rei David chegou a Baurim, apareceu um homem do clã de Saul, chamado Semei, filho de Gera, gritando maldições."
,"6":"Começou a atirar pedras contra David e os ministros do rei, enquanto o povo e os soldados iam à direita e à esquerda do rei."
,"7":"E Semei amaldiçoava David: «Vai-te embora, vai-te embora, assassino, miserável!"
,"8":"Javé está a fazer-te pagar o sangue da família de Saul, a quem usurpaste o trono! Javé entregou o reino a teu filho Absalão, enquanto tu cais na desgraça, porque és um assassino»."
,"9":"Abisaí, filho de Sárvia, disse ao rei: «Porque é que esse cão morto há-de continuar a amaldiçoar o senhor meu rei? Vou lá e corto-lhe a cabeça»."
,"10":"Mas o rei disse: «Não vos intrometais na minha vida, filhos de Sárvia! Deixai que ele me amaldiçoe. Se foi Javé quem o mandou amaldiçoar David, quem poderá pedir-lhe contas?»"
,"11":"E David disse a Abisaí e a todos os seus ministros: «Vede: o meu filho, que saiu das minhas entranhas, quer matar-me! Com muito mais razão esse benjaminita. Deixai que ele me amaldiçoe, pois foi Javé quem o mandou."
,"12":"Talvez Javé considere a minha humilhação e me pague com bênçãos essas maldições de hoje»."
,"13":"David e os seus homens continuaram a caminhada. Semei caminhava ao lado, na encosta da montanha, e ia gritando maldições, atirando pedras e levantando poeira."
,"14":"O rei e todo o povo que o acompanhava chegaram cansados ao Jordão e ali descansaram."
,"15":"Absalão e os israelitas entraram em Jerusalém, e Aquitofel acompanhava-o."
,"16":"Cusai, o araquita, amigo de David, apresentou-se a Absalão e disse: «Viva o rei! Viva o rei!»"
,"17":"Absalão replicou: «É essa a tua lealdade para com o teu amigo? Porque não foste com ele?»"
,"18":"Cusai respondeu: «De modo nenhum! Quero ficar com aquele que foi escolhido por Javé, por este povo e pelos israelitas. Com ele viverei."
,"19":"Além disso, a quem devo servir? Porventura tu não és filho de David? Vou servir-te, como servi a teu pai»."
,"20":"Então Absalão perguntou a Aquitofel: «O que me aconselhais fazer?»"
,"21":"Aquitofel respondeu a Absalão: «Toma as concubinas de teu pai, que ele deixou aqui a guardar o palácio. Deste modo, todo o Israel saberá que rompeste com o teu pai. Então os teus partidários ficarão mais confiantes»."
,"22":"Armaram então uma tenda no terraço do palácio, e Absalão tomou as concubinas de seu pai aos olhos de todo o Israel."
,"23":"Nesse tempo, o conselho que Aquitofel dava era recebido como oráculo de Deus. O conselho de Aquitofel era assim considerado, tanto para David como para Absalão."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Aquitofeldisse a Absalão: «Deixa-me escolher doze mil homens, que eu irei esta noite mesmo perseguir David."
,"2":"Eu chegarei lá quando ele estiver cansado e vulnerável. Então aterrorizá-lo-ei, e todo o povo que está com ele fugirá. Vou matar o rei quando ele estiver sozinho."
,"3":"Assim farei voltar para ti todo o povo, pois o homem que procuras significa o regresso de todos; e todo o povo ficará em paz»."
,"4":"Tanto Absalão como os anciãos de Israel acharam que a proposta era boa."
,"5":"Absalão, porém, disse: «Chamai Cusai, o araquita, para ouvirmos também o que ele pensa»."
,"6":"Quando Cusai chegou à presença de Absalão, este disse-lhe: «Nós devemos agir conforme Aquitofel nos propôs? Se não, qual é a tua proposta?»"
,"7":"Cusai respondeu a Absalão: «Desta vez, Aquitofel não deu um conselho bom»."
,"8":"E continuou: «Sabes que o teu pai e os homens que estão com ele são valentes e estão enfurecidos como ursa que perdeu o filhote no campo. O teu pai é um guerreiro, e não passará a noite junto com o povo."
,"9":"Agora mesmo ele deve estar escondido em alguma gruta ou em qualquer outro lugar. No começo, podem morrer alguns dos nossos. Então alguém vai saber e espalhar que houve baixas entre os homens que seguem Absalão."
,"10":"E então, até mesmo alguém corajoso, que tenha coração de leão, perderá a coragem, pois todo o Israel sabe que teu pai é homem valente, e aqueles que o acompanham são corajosos."
,"11":"Por isso, eu aconselho o seguinte: Que se reúna todo o Israel junto de ti, desde Dã até Bersabeia, e será tão numeroso como a areia da praia, e tu mesmo marcharás no meio deles."
,"12":"Iremos para o lugar onde ele estiver, e cairemos sobre ele como orvalho sobre a terra, e não o deixaremos escapar, nem a ele, nem sequer a um só dos homens que o acompanham."
,"13":"Se ele se esconder em alguma cidade, todo o Israel levará cordas para essa cidade, a fim de arrastá-la até ao riacho, de tal modo que não fique dela nem uma única pedra»."
,"14":"Absalão e todos os homens de Israel concordaram: «O conselho de Cusai, o araquita, é melhor do que o conselho de Aquitofel». É que Javé tinha decretado malograr o conselho bom de Aquitofel, para fazer que a desgraça caísse sobre Absalão."
,"15":"Em seguida, Cusai foi dizer aos sacerdotes Sadoc e Abiatar: «Aquitofel deu tal conselho a Absalão e aos anciãos de Israel. Eu, porém, dei este outro conselho."
,"16":"Agora, portanto, mandai depressa avisar David que não fique esta noite nas planícies do deserto, mas que atravesse para o outro lado; senão, o rei e todo o povo que o segue serão destruídos»."
,"17":"Jónatas e Aquimaás estavam de guarda perto da fonte do Pisoeiro. Uma serva foi transmitir-lhes o recado, para que eles avisassem o rei David, pois eles não deviam ser vistos ao entrar na cidade."
,"18":"Um rapaz, porém, viu-os e foi informar Absalão. Então os dois partiram para Baurim e entraram a toda a pressa na casa de um homem. Havia um poço no pátio e eles esconderam-se lá dentro."
,"19":"A mulher pegou na tampa e colocou-a na boca do poço, espalhando grãos em cima, de modo que não se notava nada."
,"20":"Alguns servos de Absalão foram, entraram na casa e interrogaram a mulher: «Onde estão Aquimaás e Jónatas?» Ela respondeu: «Eles passaram por aqui em direcção ao rio». Os servos procuraram e, não encontrando nada, voltaram para Jerusalém."
,"21":"Quando eles partiram, Aquimaás e Jónatas saíram do poço e foram avisar o rei David: «Levantai-vos e atravessai depressa o rio, porque foi isto que Aquitofel disse a vosso respeito»."
,"22":"David e os homens que o acompanhavam puseram-se então a caminho e atravessaram o Jordão. Ao nascer do sol, não havia ninguém que não estivesse já do outro lado do Jordão."
,"23":"Quando Aquitofel notou que o seu conselho não fora seguido, selou o jumento, montou e foi para a sua casa na cidade. Colocou a casa em ordem e depois enforcou-se e morreu. Foi enterrado no túmulo de seu pai."
,"24":"David tinha chegado a Maanaim, quando Absalão atravessou o Jordão com todos os homens de Israel."
,"25":"Absalão tinha colocado Amasa na chefia do exército, substituindo Joab. Amasa era filho de Jetra, um ismaelita que se tinha unido a Abigail, filha de Jessé e irmã de Sárvia, a mãe de Joab."
,"26":"Israel e Absalão acamparam no território de Galaad."
,"27":"Logo que David chegou a Maanaim, Sobi, filho de Naás de Rabá dos amonitas, Maquir, filho de Amiel de Lo-Dabar, e Berzelai, o galaadita de Rogelim,"
,"28":"levaram colchões, tapetes, copos e vasilhas de barro. Havia trigo, cevada, farinha, grão torrado, favas, lentilhas,"
,"29":"mel, coalhada, queijos de leite de vaca e de ovelha, e ofereceram-nos a David e aos homens que o acompanhavam, para que se alimentassem. Pois diziam: «Estes homens estão cansados, com fome e sede no deserto»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"David revistou as suas tropas enomeou comandantes e oficiais."
,"2":"Depois dividiu o exército em três alas. Deixou um terço sob o comando de Joab; um terço sob o comando de Abisaí, filho de Sárvia e irmão de Joab; e um terço sob o comando de Etai de Gat. Depois, David disse às tropas: «Eu também irei convosco para lutar»."
,"3":"Mas os soldados disseram: «Tu não deves ir, porque, se nós tivermos de fugir, ninguém dará importância; se metade de nós morrer, também ninguém dará importância; mas tu vales por dez mil de nós. É melhor que fiques na cidade para nos ajudares»."
,"4":"David respondeu: «Farei o que achardes melhor». E o rei ficou ao lado da porta da cidade, enquanto o exército saía em unidades de cem e de mil."
,"5":"O rei ordenou a Joab, Abisaí e Etai: «Por favor, tratai bem o jovem Absalão». Todo o exército ouviu a ordem que o rei tinha dado aos chefes a respeito de Absalão."
,"6":"O exército de David saiu a campo aberto para guerrear contra Israel. A batalha teve lugar na floresta de Efraim."
,"7":"O exército de Israel foi derrotado pelo exército de David, e a derrota foi grande, pois morreram vinte mil."
,"8":"A luta espalhou-se por toda a região e, nesse dia, a floresta devorou mais vítimas do que a espada."
,"9":"Ora, aconteceu que Absalão se encontrou por acaso com um destacamento de David. Absalão ia montado num jumento, que se meteu debaixo dos galhos de um grande carvalho. A cabeça de Absalão prendeu-se nos galhos do carvalho, e ele ficou suspenso entre o céu e a terra, enquanto o animal seguia."
,"10":"Alguém o viu e avisou Joab: «Acabo de ver Absalão suspenso num carvalho»."
,"11":"Joab respondeu: «Tu viste Absalão? Porque não o mataste ali mesmo? Agora eu dar-te-ia dez moedas de prata e um cinturão»."
,"12":"O homem, porém, respondeu: «Mesmo que pusesses mil moedas de prata na minha mão, eu não levantaria a mão contra o filho do rei. Estávamos presentes quando o rei mandou que tu, Abisaí e Etai tratásseis bem o seu filho Absalão."
,"13":"Se eu cometesse tal infâmia, o rei viria a sabê-lo e tu mesmo ficarias contra mim»."
,"14":"Então Joab disse: «Não tenho tempo a perder contigo». Tomou três dardos e cravou-os no coração de Absalão, que ainda estava entre os galhos do carvalho."
,"15":"Logo depois, chegaram dez jovens, escudeiros de Joab, que cercaram Absalão e o golpearam até o matarem."
,"16":"Joab mandou tocar o trombeta para deter a tropa, e o exército deixou de atacar Israel."
,"17":"Tomaram o corpo de Absalão e atiraram-no para dentro de um grande buraco, no meio da floresta, e colocaram-lhe em cima um monte de pedras. E todo o Israel debandou, cada qual para a sua tenda."
,"18":"Enquanto estava vivo, Absalão tinha erguido uma estela, que se encontra no Vale do Rei, porque pensava: «Não tenho filho que conserve a memória do meu nome». Por isso, deu o seu nome ao monumento, que ainda hoje é conhecido por Monumento de Absalão."
,"19":"Aquimaás, filho de Sadoc, disse: «Irei a correr dar ao rei a boa notícia de que Javé lhe fez justiça e o livrou dos seus inimigos»."
,"20":"Joab porém replicou: «Hoje não serás portador de uma boa notícia. Deixa para outro dia, porque hoje morreu o filho do rei»."
,"21":"E Joab ordenou a um etíope: «Vai comunicar ao rei tudo o que viste». O etíope prostrou-se diante de Joab, e partiu a correr."
,"22":"Aquimaás, filho de Sadoc, insistiu com Joab: «Aconteça o que acontecer, também vou a correr atrás do etíope». Joab respondeu: «Para quê correr, meu filho? Não vais ganhar nada com essa notícia!»"
,"23":"Aquimaás replicou: «Seja como for, eu vou a correr». Então Joab disse-lhe: «Podes ir». Aquimaás partiu a correr e, atalhando o caminho pela planície, passou à frente do etíope."
,"24":"David estava sentado entre as duas portas da cidade. A sentinela subiu ao terraço da porta por cima da muralha. Levantou os olhos e viu um homem que corria sozinho."
,"25":"A sentinela gritou e avisou o rei. E o rei comentou: «Se ele vem sozinho, é porque traz boas notícias». Quando já estava a aproximar-se,"
,"26":"a sentinela avistou outro homem que vinha a correr, e gritou de cima da porta: «Vem além outro homem a correr sozinho». David comentou: «Esse também traz boas notícias»."
,"27":"A sentinela acrescentou: «Estou a reconhecer o modo de correr do primeiro: ele corre como Aquimaás, o filho de Sadoc». O rei comentou: «É um homem bom. Certamente ele vem com boas notícias»."
,"28":"Aquimaás aproximou-se do rei e saudou-o: «Paz». Depois prostrou-se com o rosto por terra diante do rei, e disse: «Bendito seja o teu Deus Javé, que te entregou os homens que se revoltaram contra o senhor meu rei»."
,"29":"O rei perguntou: «Está tudo bem com o jovem Absalão?» Aquimaás respondeu: «Vi uma confusão no momento em que Joab, servo do rei, me enviou, mas não sei o que aconteceu»."
,"30":"O rei disse: «Vem e espera aqui». Aquimaás obedeceu e esperou ali."
,"31":"Naquele momento, chegou o etíope e disse: «Senhor meu rei, recebe a boa notícia: Javé hoje acaba de fazer justiça, livrando-te de todos os que se revoltaram contra ti»."
,"32":"Então o rei perguntou: «Está tudo bem com o jovem Absalão?» O etíope respondeu: «Que acabem como ele todos os inimigos do senhor meu rei e todos os que se revoltaram contra ti para te fazer mal»."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Então o rei estremeceu, su-biupara a sala que fica por cima da porta, e começou a chorar, dizendo entre soluços: «Meu filho Absalão! Meu filho Absalão! Porque não morri em teu lugar? Absalão, meu filho, meu filho!»"
,"2":"E disseram a Joab: «O rei está a chorar e a lamentar-se por causa de Absalão»."
,"3":"Assim, a vitória desse dia transformou-se em luto para todo o exército, porque os soldados souberam que o rei estava aflito por causa do filho."
,"4":"Nesse dia, o exército entrou na cidade às escondidas, como entra um exército envergonhado fugido do combate."
,"5":"O rei estava com o rosto coberto e gritava: «Meu filho Absalão! Absalão, meu filho, meu filho!»"
,"6":"Joab entrou na casa e disse ao rei: «Hoje estás a cobrir de vergonha o rosto de todos os teus guerreiros, que hoje salvaram a tua vida e a vida de teus filhos e filhas, mulheres e concubinas."
,"7":"Tu amas aqueles que te odeiam, e odeias aqueles que te amam. Hoje mostras que os chefes e soldados não valem nada para ti. Agora vejo que, se nós todos tivéssemos morrido e Absalão estivesse vivo, acharias tudo muito bem."
,"8":"Vamos, sai e fala aos teus soldados. Porque eu juro por Javé que, se tu não saíres, não haverá ninguém que fique contigo esta noite. Para ti, isso vai ser uma desgraça muito maior do que todas as que te aconteceram, desde a tua mocidade até hoje»."
,"9":"O rei levantou-se e foi sentar-se à porta. E avisaram todo o exército: «O rei está sentado à porta da cidade». Então todo o exército se reuniu ao redor do rei. Os israelitas debandaram, e cada um foi para a sua tenda. "
,"10":"Nas tribos de Israel, todo o povo discutia e comentava: «Foi o rei David quem nos arrancou do poder dos nossos inimigos e nos livrou do poder dos filisteus. No entanto, agora ele teve que fugir do país para escapar de Absalão."
,"11":"E Absalão, que tínhamos ungido para nos governar, morreu na guerra. Porque não fazeis nada para que o rei volte?»"
,"12":"O rei David soube do que se dizia em todo o Israel, e então mandou dizer aos sacerdotes Sadoc e Abiatar: «Dizei aos anciãos de Judá: 'Sereis vós os últimos a fazer regressar o rei ao seu palácio?"
,"13":"Vós sois meus parentes, minha carne e meu sangue. Porque seríeis os últimos a reconduzir o rei?'"
,"14":"Dizei também a Amasa: 'Tu não és da minha carne e do meu sangue? Que Deus me castigue se não fores o comandante permanente do meu exército, em lugar de Joab'»."
,"15":"Assim David conquistou o coração dos homens de Judá, como se fossem um só homem. Então eles mandaram dizer ao rei: «Volta, juntamente com os teus ministros»."
,"16":"O rei voltou e chegou ao rio Jordão, enquanto os de Judá foram a Guilgal para se encontrarem com o rei e ajudá-lo na travessia do Jordão."
,"17":"Semei, filho de Gera, o benjaminita de Baurim, apressou-se a descer com os homens de Judá ao encontro do rei David."
,"18":"Iam com ele mil homens de Benjamim. Siba, o servo da família de Saul, seus quinze filhos e vinte servos entraram no Jordão antes do rei,"
,"19":"prepararam tudo para que a família do rei passasse e para agradar ao rei. Quando o rei estava a atravessar o Jordão, Semei, filho de Gera, atirou-se aos pés dele"
,"20":"e disse: «Que o meu senhor não me considere culpado e não se lembre do mal que o teu servo cometeu no dia em que o senhor meu rei deixou Jerusalém. Que o rei não guarde isso no coração,"
,"21":"porque o teu servo reconhece que pecou, e hoje é o primeiro da casa de José a descer ao encontro do senhor meu rei»."
,"22":"Abisaí, filho de Sárvia, contestou: «Há por acaso alguma desculpa para que Semei não seja morto? Ele amaldiçoou o ungido de Javé!»"
,"23":"Mas David interveio: «Não vos intrometais na minha vida, filhos de Sárvia. Não me tenteis. Hoje em Israel poderia alguém ser condenado à morte? Justamente hoje que vós me reconhecestes como rei de Israel?»"
,"24":"E o rei jurou a Semei: «Tu não vais morrer»."
,"25":"Meribaal, o filho de Saul, também foi ao encontro do rei. Ele não tinha lavado os pés e as mãos, nem aparado o bigode, nem lavado a roupa, desde o dia em que o rei tinha partido até ao dia em que regressou vitorioso."
,"26":"Quando ele chegou a Jerusalém, o rei perguntou: «Meribaal, porque é que não foste comigo?»"
,"27":"Meribaal respondeu: «O meu servo enganou-me, senhor meu rei. Porque eu pensei: 'Vou selar a minha mula, montar e partir com o rei', porque sou aleijado."
,"28":"Mas o meu servo caluniou-me diante do senhor meu rei. O senhor meu rei, porém, é como um anjo de Deus: faça o que achar melhor."
,"29":"Toda a família de meu pai merecia do senhor meu rei apenas a morte, mas tu recebeste-me entre os que comem à tua mesa. Que direito tenho de reclamar diante do rei?»"
,"30":"Então o rei disse: «Para quê tantas palavras? A minha decisão é que tu e Siba deveis repartir as terras»."
,"31":"Meribaal respondeu: «Ele pode ficar com tudo, pois o senhor meu rei voltou em paz para casa»."
,"32":"Berzelai, o galaadita, tinha descido de Rogelim e acompanhado o rei até ao Jordão, a fim de despedir-se dele."
,"33":"Berzelai era muito velho; tinha oitenta anos. Quando o rei passou por Maanaim, ele havia provido à manutenção do rei, porque era muito rico."
,"34":"O rei disse a Berzelai: «Continua comigo, e dar-te-ei tudo o que precisares em Jerusalém»."
,"35":"Mas Berzelai respondeu: «Quantos anos ainda me restam? Para quê subir com o rei a Jerusalém?"
,"36":"Estou com oitenta anos. Será que ainda sei distinguir entre o que é bom e o que é mau? Será que o teu servo ainda sente gosto no que come e no que bebe? Poderia ainda ouvir os cantores e cantoras? Então para que é que o teu servo iria ser agora de peso para o senhor meu rei?"
,"37":"Vou atravessar para acompanhar o rei um pouco mais além, mas não é preciso que o rei me recompense por isso."
,"38":"Deixa-me voltar e morrer na minha cidade, para ser enterrado no túmulo de meus pais. Aqui está o meu filho Camaam; ele ficará com o senhor meu rei. Trata-o como achares melhor»."
,"39":"Então o rei disse: «Que Camaam venha comigo, e eu farei por ele o que tu quiseres, e farei por ti tudo o que me pedires»."
,"40":"Todo o povo atravessou o Jordão, e o rei atravessou também. Beijou Berzelai e abençoou-o. E Berzelai voltou para sua casa."
,"41":"O rei continuou em direcção a Guilgal, e Camaam foi com ele. Todo o povo de Judá e metade de Israel acompanhavam o rei."
,"42":"Os israelitas foram ter com o rei e disseram-lhe: «Porque é que os nossos irmãos de Judá tomaram posse de ti e fizeram com que o rei, a sua família e todos os homens de David atravessassem o Jordão?»"
,"43":"Então todos os homens de Judá responderam aos de Israel: «É porque o rei é o nosso parente mais chegado! Porque é que vos irritais com isso? Porventura, comemos às custas do rei ou tirámos algum proveito dele?»"
,"44":"Os homens de Israel responderam aos de Judá: «Temos dez vezes mais direito sobre o rei e, mesmo para David, somos mais importantes que vós. Porque é que nos desprezastes? Não fomos nós os primeiros a fazer regressar o rei?» Contudo, os homens de Judá responderam com muita dureza aos de Israel."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Encontrava-se ali um vagabundochamado Seba, benjaminita, filho de Bocri. Ele tocou a trombeta e disse: «Nós não temos parte com David. Não temos herança com o filho de Jessé. Volta para as tuas tendas, Israel»."
,"2":"Todos os israelitas abandonaram David, e seguiram Seba, filho de Bocri. Mas os homens de Judá, desde o Jordão até Jerusalém, permaneceram fiéis ao rei."
,"3":"David foi para o seu palácio em Jerusalém. Ao chegar lá, tomou as dez concubinas que tinha deixado a tomar conta do palácio, e confinou-as no seu harém. Ele mantinha-as, mas nunca mais teve relações com elas: ficaram segregadas, como viúvas de uma pessoa viva, até ao dia em que morreram."
,"4":"O rei disse a Amasa: «Convoca os homens de Judá e apresenta-te aqui dentro de três dias»."
,"5":"Amasa partiu para convocar os homens de Judá, mas demorou-se mais tempo do que fora estabelecido."
,"6":"Então David disse a Abisaí: «Seba, filho de Bocri, é agora mais perigoso para nós do que Absalão. Toma os guerreiros do teu senhor e persegue-o, para que não alcance as cidades fortificadas e nos escape»."
,"7":"Depois de Abisaí, partiram também Joab, os cereteus, os feleteus e todos os homens valentes. Saíram de Jerusalém para perseguir Seba, filho de Bocri."
,"8":"Quando estavam perto da grande pedra, que se encontra em Gabaon, Amasa apareceu. Joab levava sobre o uniforme um cinto com a espada embainhada; a espada saiu da bainha e caiu."
,"9":"Joab cumprimentou Amasa: «A paz esteja contigo, meu irmão». E com a mão direita, segurou a barba de Amasa para o beijar."
,"10":"Amasa não percebeu que Joab estava com a espada na mão. Ele cravou a espada na barriga de Amasa, de modo que as suas entranhas se derramaram pelo chão. Amasa morreu. Nem foi preciso dar um segundo golpe. Joab e seu irmão Abisaí partiram em seguida, perseguindo Seba, filho de Bocri."
,"11":"Um dos homens de Joab parou perto de Amasa e disse: «Quem é amigo de Joab e está do lado de David, siga Joab»."
,"12":"Amasa estava caído no meio do caminho, numa poça de sangue. Vendo que todos paravam ali, o rapaz tirou Amasa do caminho, colocou-o no campo, e cobriu-lhe o corpo com um manto, porque observou que todos os que passavam perto dele paravam."
,"13":"Quando o cadáver de Amasa foi tirado do caminho, todos passavam sem parar, seguindo Joab, que perseguia Seba, filho de Bocri."
,"14":"Seba atravessou todas as tribos de Israel, até chegar a Abel-Bet-Maaca. E todo o clã de Bocri o acompanhou."
,"15":"Os outros foram e cercaram-no em Abel-Bet-Maaca, e levantaram junto à cidade um aterro que chegava até à muralha. E todo o exército que estava com Joab procurava derrubar a muralha, escavando-a."
,"16":"Uma mulher esperta gritou da cidade: «Escutai, escutai! Dizei a Joab que se aproxime, que eu quero falar com ele»."
,"17":"Quando Joab se aproximou, a mulher perguntou: «Tu és Joab?» Ele respondeu: «Sou». Então ela disse: «Ouve a palavra da tua serva». Joab respondeu: «Estou a ouvir-te»."
,"18":"A mulher então disse: «Antigamente costumavam dizer: 'Pedi conselho a Abel, e o assunto fica resolvido'."
,"19":"Eu sou aquilo que há de mais pacífico e seguro em Israel. Tu queres destruir uma grande cidade de Israel. Porque é que queres acabar com a herança de Javé?»"
,"20":"Joab respondeu: «De modo nenhum. Longe de mim destruir ou arruinar."
,"21":"Não se trata disso. É que um homem da região montanhosa de Efraim, chamado Seba, filho de Bocri, se revoltou contra o rei David. Entregai esse homem, e eu deixarei a cidade». A mulher disse a Joab: «Pois bem. Vamos lançar a cabeça dele por cima da muralha»."
,"22":"Com grande habilidade, a mulher falou com o povo, e degolaram Seba, filho de Bocri, e lançaram a cabeça dele a Joab. Então Joab tocou a trombeta e, deixando o cerco, cada um foi para a sua tenda. Joab, porém, voltou para Jerusalém, para junto do rei."
,"23":"Joab era o comandante de todo o exército de Israel. Banaías, filho de Joiada, comandava os cereteus e os feleteus."
,"24":"Adoram era o encarregado dos trabalhos forçados. Josafá, filho de Ailud, era o porta-voz."
,"25":"Siva era o secretário. Sadoc e Abiatar eram os sacerdotes."
,"26":"Além destes, Ira, o jairita, também era sacerdote de David."
}`)
	CurrentBook.AddChapter(21, `{
"1":"No tempo de David, houve fome durante três anos seguidos, e David consultou Javé. E Javé respondeu: «Saul e a sua família ainda estão manchados de sangue por terem matado os gabaonitas»."
,"2":"O rei convocou os gabaonitas e contou-lhes isto. Esses gabaonitas não pertenciam propriamente a Israel: eram apenas um resto dos amorreus, com quem os israelitas haviam feito um pacto. Saul, no seu zelo por Israel e por Judá, tinha procurado exterminá-los."
,"3":"David disse aos gabaonitas: «Que posso fazer por vós e como posso indemnizar-vos, para que abençoeis a herança de Javé?»"
,"4":"Os gabaonitas responderam: «De Saul e da sua família não queremos nem prata nem ouro. Também não queremos que ninguém morra em Israel». David disse-lhes: «Farei o que me pedirdes»."
,"5":"Então eles disseram: «Aquele homem quis exterminar-nos e pretendeu destruir-nos e expulsar-nos do território de Israel."
,"6":"Entreguem-nos sete dos seus filhos, e nós quebraremos os seus ossos diante de Javé, em Gabaon, na montanha de Javé». David respondeu: «Eu vo-los entregarei»."
,"7":"O rei poupou a vida de Meribaal, filho de Jónatas, filho de Saul, por causa do pacto sagrado que unia David e Jónatas, filho de Saul."
,"8":"O rei tomou Armoni e Meribaal, os dois filhos que Resfa, filha de Aías, tinha dado a Saul; tomou também os cinco filhos que Merob, filha de Saul, tinha dado a Adriel, filho de Berzelai de Meola,"
,"9":"e entregou-os aos gabaonitas. Estes quebraram-lhes os ossos na montanha, na presença de Javé. Os sete morreram juntos: foram executados durante a ceifa, ao começar a colheita da cevada."
,"10":"Resfa, filha de Aías, tomou um pano de saco e estendeu-o sobre a rocha; e, desde que começou a colheita da cevada até ao dia em que a chuva caiu sobre eles, ela ficou ali, dia e noite, espantando as aves e as feras."
,"11":"E contaram a David o que Resfa, filha de Aías, concubina de Saul, tinha feito."
,"12":"Então David foi pedir os ossos de Saul e de seu filho Jónatas aos cidadãos de Jabes de Galaad, que os tinham levado da praça de Betsã, onde os filisteus os haviam enforcado, quando venceram Saul em Gelboé."
,"13":"David tirou de lá os ossos de Saul e de seu filho Jónatas, e juntou-os aos ossos daqueles que tinham sido executados."
,"14":"Então tomaram os ossos de Saul, de seu filho Jónatas e dos que tinham sido executados, e sepultaram-nos na terra de Benjamim, em Sela, no túmulo de Cis, pai de Saul. Fizeram tudo o que o rei tinha ordenado, e por isso Deus compadeceu-Se do país."
,"15":"Houve novamente guerra entre os filisteus e Israel. David desceu com os seus soldados, travou combate contra os filisteus, e David ficou exausto."
,"16":"Havia um grande guerreiro, um dos descendentes de Rafa, que usava uma lança de bronze de três quilos e uma espada nova, dizendo que ia matar David."
,"17":"No entanto, Abisaí, filho de Sárvia, socorreu David, atingiu o filisteu e matou-o. Então os homens de David suplicaram-lhe: «Nunca mais saias connosco para a guerra, para que não se apague a lâmpada de Israel»."
,"18":"Depois, a guerra contra os filisteus recomeçou em Gob. Foi aí que Sobocai de Husa matou Saf, descendente de Rafa."
,"19":"Ainda em Gob, noutra guerra contra os filisteus, Elcanã, filho de Jair de Belém, matou Golias de Gat, que usava uma lança comprida como um cilindro de tear."
,"20":"Houve depois outra batalha em Gat. Encontrava-se ali um homem de grande estatura, com seis dedos em cada mão e em cada pé; vinte e quatro dedos no total. Ele também era descendente de Rafa."
,"21":"Ele desafiou Israel, mas Jónatas, filho de Sama, irmão de David, matou-o."
,"22":"Os quatro eram descendentes de Rafa, em Gat, e morreram às mãos de David e dos seus soldados."
}`)
	CurrentBook.AddChapter(22, `{
"1":"David dedicou a Javé este cântico, quando Javé o libertou de todos os seus inimigos e da mão de Saul."
,"2":"Ele disse: Javé é a minha rocha,e a minha fortaleza, o meu libertador."
,"3":"Ele é o meu Deus. N'Ele, meu rochedo, eu me abrigo,meu escudo e minha força,salvadora, minha torre forte, meu refúgio, meu salvador que me salva,da violência."
,"4":"Louvado seja! Eu invoquei Javé, e fui salvo dos meus inimigos."
,"5":"As ondas da Morte me envolviam, as torrentes de Belial me aterravam,"
,"6":"os laços do Xeol me cercavam, as ciladas da Morte me atingiam."
,"7":"Na minha angústia invoquei Javé, ao meu Deus lancei o meu grito. Do seu Templo Ele ouviu a minha voz, e o meu grito chegou aos seus ouvidos."
,"8":"A terra vacilou e tremeu, as bases do céu abalaram-se, por causa do seu furor estremeceram."
,"9":"Das suas narinas subiu fumo, e da sua boca um fogo devorador. Dela brotavam brasas ardentes."
,"10":"Ele inclinou o céu e desceu, tendo aos pés uma nuvem escura;"
,"11":"cavalgou um querubim e voou, planando sobre as asas do vento."
,"12":"Envolveu-Se de trevas como tenda, de águas escuras e de nuvens espessas."
,"13":"À sua frente, um clarão inflamava,granizo e brasas de fogo."
,"14":"Javé trovejou no céu. O Altíssimo fez ouvir a sua voz;"
,"15":"atirou as suas flechas e dispersou-os, e expulsou-os, lançando os seus raios."
,"16":"Então apareceu o leito do mar, as bases do mundo descobriram-se, por causa da ameaça de Javé, pelo vento que soprava,das suas narinas."
,"17":"Lá do alto, Ele me tomou, tirando-me das águas profundas,"
,"18":"e me livrou de um inimigo poderoso, de adversários mais fortes do que eu."
,"19":"Atacaram-me no dia da minha derrota, mas Javé foi um apoio para mim;"
,"20":"fez-me sair para um lugar espaçoso. Libertou-me, porque Ele me ama."
,"21":"Javé trata-me segundo a minha justiça, e retribui-me conforme a pureza,das minhas mãos;"
,"22":"pois eu observei os caminhos de Javé, e não fui infiel ao meu Deus."
,"23":"Os seus julgamentos estão todos,à minha frente, jamais apartei de mim os seus decretos."
,"24":"Sou íntegro para com Ele, e afasto-me da injustiça."
,"25":"Javé retribui-me,segundo a minha justiça, e a pureza das minhas mãos, que Ele vê com os seus olhos."
,"26":"Com o fiel, Tu és fiel; com o íntegro, Tu és íntegro;"
,"27":"puro com quem é puro; mas com o perverso mostras-Te astuto."
,"28":"Pois Tu salvas o povo pobre, e rebaixas os olhos altivos."
,"29":"Javé, Tu és a minha lâmpada!,Meu Deus, ilumina a minha treva!"
,"30":"Sim, contigo eu forço o muro, com o meu Deus eu salto a muralha."
,"31":"Deus é perfeito no seu caminho. A palavra de Javé é provada. Ele é um escudo,para todos aqueles,que n'Ele se abrigam."
,"32":"Pois, além de Javé, quem é Deus?,E quem é rochedo, a não ser o nosso Deus?"
,"33":"Ele é o Deus que me cinge de força, e torna perfeito o meu caminho"
,"34":"Ele iguala os meus pés,aos pés das corças, e sustenta-me de pé nas alturas."
,"35":"Ele instrui as minhas mãos,para a guerra, e o meu braço para esticar o arco,de bronze"
,"36":"Tu me dás o teu escudo salvador, e me atendes sem cessar"
,"37":"Alargas os meus passos, e os meus tornozelos não se torcem."
,"38":"Persigo os meus inimigos,e alcanço-os, e não volto atrás sem os ter destruído."
,"39":"Eu massacro-os, e não podem levantar-se; Eles caem debaixo dos meus pés."
,"40":"Tu me cinges de força para a guerra, e curvas sob os meus pés,os meus agressores."
,"41":"Tu me entregas a nuca,dos meus inimigos, e eu extermino os que me odeiam."
,"42":"Eles gritam, e não há quem os salve, gritam a Javé, mas Ele não responde."
,"43":"Eu piso-os como a poeira das praças; eu amasso-os como o barro das ruas."
,"44":"Tu livras-me dos processos dos povos, e colocas-me como chefe das nações. Um povo que eu não conheci serve-me,"
,"45":"os filhos dos estrangeiros,submetem-se a mim, dão-me ouvidos e obedecem-me."
,"46":"Os filhos dos estrangeiros,enfraquecem-se, e saem a tremer das suas fortalezas."
,"47":"Viva Javé! Bendito seja o meu Rochedo!,Seja exaltado o meu Deus salvador,"
,"48":"o Deus que me concede as vinganças, e me submete os povos."
,"49":"Livrando-me dos meus inimigos, Tu me exaltas sobre os meus agressores, e me libertas do homem violento."
,"50":"Por isso eu Te louvo entre as nações, ó Javé, e canto em honra do teu Nome:"
,"51":"«Ele dá grandes vitórias ao seu rei, e age pelo seu ungido com amor, por David e sua descendência,para sempre»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"São estas as últimas palavras de David: Oráculo de David, filho de Jessé, oráculo do homem que foi exaltado, do ungido do Deus de Jacob, do cantor de salmos de Israel."
,"2":"O espírito de Javé fala por mim, a sua palavra está na minha língua."
,"3":"O Deus de Jacob falou-me, a Rocha de Israel disse-me: «Quem governa os homens com justiça,e governa conforme o temor de Deus,"
,"4":"é como a luz da manhã ao nascer,do sol, manhã sem nuvens depois da chuva, que faz brilhar a relva da terra»."
,"5":"A minha casa está firme junto de Deus, pois a sua aliança comigo,é para sempre, em tudo ordenada e bem segura. Ele fará prosperar os meus desejos,de salvação."
,"6":"Os maus porém,serão como espinheiros, que se deitam fora e ninguém recolhe."
,"7":"Ninguém se aproxima deles, a não ser com o ferro e a madeira,da lança, e com fogo para os queimar."
,"8":"São estes os nomes dos valentes de David: Isbaal, o haquemonita, chefe dos Três, que manejou a lança, matando oitocentos de uma só vez."
,"9":"Depois dele, Eleazar, filho de Dodó, o aoíta, um dos três valentes. Ele estava com David em Afes-Domim, quando os filisteus ali se reuniram para o combate, e os israelitas recuaram."
,"10":"Eleazar, porém, ficou firme, e combateu os filisteus até a sua mão adormecer e ficar colada à espada. Nesse dia, Javé realizou uma grande vitória, e o exército voltou depois de Eleazar, mas só para recolher os despojos."
,"11":"Depois de Eleazar, houve Sama, filho de Ela, o ararita. Os filisteus tinham-se reunido em Queixada, onde havia um campo de lentilhas. O exército tinha fugido dos filisteus,"
,"12":"mas Sama colocou-se no meio do campo e defendeu-o, vencendo os filisteus. Javé realizou então uma grande vitória."
,"13":"Três dos Trinta foram ter com David, no começo da colheita, à gruta de Odolam, quando um destacamento dos filisteus estava acampado no vale dos Rafaim."
,"14":"Nessa ocasião, David estava no esconderijo, e a guarnição dos filisteus acampava em Belém."
,"15":"David teve sede e exclamou: «Quem me dera beber água do poço da porta de Belém!»"
,"16":"Os três valentes abriram passagem pelo acampamento filisteu, tiraram água do poço da porta de Belém e levaram-na a David. Mas David não quis beber a água e ofereceu-a em libação a Javé."
,"17":"Ele disse: «Javé me livre de fazer tal coisa! É o sangue dos homens que lá foram, arriscando a vida». Por isso, não quis beber. Foi o que fizeram os três valentes."
,"18":"Abisaí, irmão de Joab e filho de Sárvia, era o chefe dos Trinta. Manejando a sua lança, matou trezentos, e era famoso entre os Trinta."
,"19":"Ele ficou a ser o mais famoso dos Trinta, e tornou-se chefe deles, mas não fez parte do grupo dos Três."
,"20":"Banaías, filho de Joiada, natural de Cabseel, era um homem aguerrido, pródigo em façanhas: matou os dois moabitas, filhos de Ariel; foi também ele que desceu e no dia da neve matou um leão na cisterna."
,"21":"Ele matou também um egípcio muito alto, que trazia na mão uma lança: Banaías enfrentou-o com um cajado, arrancou a lança da mão do egípcio, e matou-o com a sua própria lança."
,"22":"Com esta façanha, Banaías, filho de Joiada, ficou famoso entre os trinta valentes."
,"23":"Ele foi mais famoso do que os Trinta, mas não fazia parte do grupo dos Três. David fê-lo chefe da sua guarda pessoal."
,"24":"Asael, irmão de Joab, estava entre os Trinta. Também faziam parte do grupo: Elcanã, filho de Dodó, de Belém;"
,"25":"Sama, de Harod; Elica, de Harod;"
,"26":"Heles, de Bet-Falet; Ira, filho de Aces, de Técua;"
,"27":"Abiezer, de Anatot; Sobocai, de Husa;"
,"28":"Selmon, de Ao; Maarai, de Netofa;"
,"29":"Héled, filho de Baana, de Netofa; Etai, filho de Ribai, de Gabaá de Benjamim;"
,"30":"Banaías, de Faraton; Hedai, das Torrentes de Gaás;"
,"31":"Abibaal, de Bet-Arabá; Azmot, de Baurim;"
,"32":"Eliaba, de Saalbon; Jasen, de Gimzo;"
,"33":"Jónatas, filho de Sama, de Arar; Aiam, filho de Sarar, de Arar;"
,"34":"Elifalet, filho de Aasbai, de Bet-Maaca; Eliam, filho de Aquitofel, de Gilo;"
,"35":"Hessai, de Carmel; Farai, de Arab."
,"36":"Igaal, filho de Natã, de Soba; Bani, o gadita;"
,"37":"Selec, o amonita; Naarai, de Berot, escudeiro de Joab, filho de Sárvia;"
,"38":"Ira, de Jeter; Gareb, de Jeter;"
,"39":"Urias, o heteu. Ao todo, trinta e sete."
}`)
	CurrentBook.AddChapter(24, `{
"1":"A ira deJavé inflamou-se contra os israelitas e instigou David contra eles: «Vai e faz o recenseamento de Israel e de Judá»."
,"2":"Então o rei disse a Joab e aos oficiais do seu exército: «Percorrei todas as tribos de Israel, desde Dã até Bersabeia, e fazei o recenseamento do povo, para que eu saiba quantos são»."
,"3":"Joab respondeu ao rei: «Que Javé teu Deus multiplique o povo cem vezes mais do que é agora, e que o senhor meu rei veja com os próprios olhos! Mas porque é que o senhor meu rei quer que isso seja feito?»"
,"4":"A ordem do rei, porém, impôs-se a Joab e aos oficiais do exército. Então eles saíram da presença do rei para irem recensear o povo de Israel."
,"5":"Atravessaram o Jordão, e começaram em Aroer e na cidade que fica dentro do vale, e entre os gaditas, perto de Jazer."
,"6":"Em seguida, foram para Galaad, para o território dos heteus em Cades. Depois foram para Dã e dirigiram-se para Sidónia."
,"7":"Seguiram para a fortaleza de Tiro e para todas as cidades dos heveus e cananeus. Dali foram para o deserto de Judá, até Bersabeia."
,"8":"Percorreram assim todo o país e, depois de nove meses e vinte dias, voltaram para Jerusalém."
,"9":"Joab apresentou ao rei o resultado do recenseamento do povo. Em Israel havia oitocentos mil homens aptos para a guerra, que podiam usar a espada. Em Judá havia quinhentos mil homens."
,"10":"No entanto, David ficou preocupado por ter recenseado o povo, e disse a Javé: «Cometi um grande pecado! Javé, perdoa esta maldade do teu servo, pois cometi uma grande loucura!»"
,"11":"Quando David se levantou de manhã, Javé havia transmitido esta mensagem ao profeta Gad, vidente de David:"
,"12":"«Vai dizer a David: Assim diz Javé: Proponho-te três coisas; escolhe uma, e Eu a executarei»."
,"13":"Gad foi ter com o rei e informou-o: «Que preferes: três anos de fome no teu país; fugir três meses do teu inimigo que te perseguirá; ou três dias de peste para o teu país? Pensa e decide o que devo responder Àquele que me enviou»."
,"14":"David respondeu a Gad: «Estou numa grande angústia! Em todo o caso, acho melhor cair nas mãos de Javé, pois a sua misericórdia é grande, do que cair nas mãos dos homens»."
,"15":"Então Javé enviou a peste sobre Israel, desde essa manhã até ao dia marcado. De Dã até Bersabeia, morreram setenta mil homens do povo."
,"16":"O anjo estava já com a mão estendida sobre Jerusalém para a destruir, quando Javé Se arrependeu desse mal, e disse ao anjo que exterminava o povo: «Chega! Agora retira a mão». O anjo de Javé estava junto à eira de Areúna, o jebuseu."
,"17":"Vendo o anjo que exterminava o povo, David disse a Javé: «Fui eu que pequei. Eu sou o culpado. Que fizeram estas ovelhas? Que a tua mão caia sobre mim e sobre a minha família»."
,"18":"Nesse dia, Gad foi dizer a David: «Vai construir um altar a Javé na eira de Areúna, o jebuseu»."
,"19":"Então David foi, obedecendo à ordem que Javé lhe tinha comunicado através de Gad."
,"20":"Areúna viu o rei e os seus oficiais aproximarem-se, saiu e prostrou-se diante do rei com o rosto por terra."
,"21":"E perguntou: «Porque veio o senhor meu rei até aqui?» David respondeu: «Para comprar a tua eira, a fim de construir um altar a Javé. Deste modo, o povo ficará livre da peste»."
,"22":"Então Areúna disse ao rei: «Que o senhor meu rei fique com a eira e ofereça em sacrifício o que achar melhor. Aqui estão os bois para o holocausto, a grade e a canga dos bois para servir de lenha."
,"23":"O servo do senhor meu rei oferece tudo ao rei». E acrescentou: «Que Javé teu Deus aceite o sacrifício que Lhe vais oferecer»."
,"24":"O rei respondeu a Areúna: «De modo nenhum! Quero comprar a eira a troco de dinheiro. Não vou oferecer a Javé, meu Deus, holocaustos que não me custem nada». Então David comprou a eira e os bois por meio quilo de prata."
,"25":"Construiu ali um altar a Javé e ofereceu holocaustos e sacrifícios de comunhão. Então Javé compadeceu-Se do país. E a peste deixou Israel."
}`)

}
func PT_BS_LoadVHEDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No primeiro ano do reinado de Ciro, rei da Pérsia, Javé, cumprindo o que tinha dito pelo profeta Jeremias, despertou a consciência de Ciro, rei da Pérsia, que proclamou por todo o império, a viva voz e por escrito, o seguinte:"
,"2":"«Ciro, rei da Pérsia, decreta: Javé, o Deus do céu, entregou-me todos os reinos do mundo. Ele encarregou-me de Lhe construir um Templo em Jerusalém, na terra de Judá."
,"3":"Quem de vós provém do povo d'Ele? Que o seu Deus esteja com ele. Volte para Jerusalém, na terra de Judá, para reconstruir o Templo de Javé, o Deus de Israel. Ele é o Deus que reside em Jerusalém."
,"4":"Todos os sobreviventes, de todo o lugar para onde tiverem imigrado, receberão da população local prata e ouro, bens e animais, além de ofertas espontâneas para o Templo de Deus, que está em Jerusalém»."
,"5":"Então todos os que se sentiram movidos por Deus - chefes de família de Judá e Benjamim, sacerdotes e levitas - puseram-se a caminho para reconstruir o Templo de Javé em Jerusalém."
,"6":"Os vizinhos deram-lhes de tudo: prata e ouro, bens, animais e jóias, além de ofertas espontâneas."
,"7":"O rei Ciro entregou também os objectos do Templo de Javé, que o rei Nabucodonosor tinha levado de Jerusalém e colocado no templo do seu deus."
,"8":"Entregou esses objectos por intermédio do tesoureiro Mitrídates, que os contou todos diante de Sasabassar, príncipe de Judá."
,"9":"Eram trinta cálices de ouro, mil cálices de prata, vinte e nove facas,"
,"10":"trinta copos de ouro, quatrocentos e dez copos de prata e mil outros objectos,"
,"11":"que davam no total cinco mil e quatrocentos objectos de ouro ou prata. Sasabassar levou tudo isso juntamente com os exilados que voltaram da Babilónia para Jerusalém."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Lista dos que pertenciam à província de Judá e que tinham sido exilados para a Babilónia, por Nabucodonosor, rei da Babilónia. Eles voltaram para Jerusalém e Judá, cada um para a sua cidade."
,"2":"Regressaram com Zorobabel, Josué, Neemias, Saraías, Raelaías, Naamani, Mardoqueu, Belsã, Mesfar, Beguai, Reum e Baana. Lista dos homens do povo de Israel: "
,"3":"Dois mil, cento e setenta e dois, da descendência de Faros."
,"4":"Trezentos e setenta e dois, da descendência de Safatias."
,"5":"Setecentos e setenta e cinco, da descendência de Area."
,"6":"Dois mil, oitocentos e doze, da descendência de Faat-Moab, ou seja, de Josué e de Joab."
,"7":"Mil duzentos e cinquenta e quatro, da descendência de Elam."
,"8":"Novecentos e quarenta e cinco, da descendência de Zetua."
,"9":"Setecentos e sessenta, da descendência de Zacai."
,"10":"Seiscentos e quarenta e dois, da descendência de Bani."
,"11":"Seiscentos e vinte e três, da descendência de Bebai."
,"12":"Mil duzentos e vinte e dois, da descendência de Azgad."
,"13":"Seiscentos e sessenta e seis, da descendência de Adonicam."
,"14":"Dois mil e cinquenta e seis, da descendência de Beguai."
,"15":"Quatrocentos e cinquenta e quatro, da descendência de Adin."
,"16":"Noventa e oito, da descendência de Ater, isto é, de Ezequias."
,"17":"Trezentos e vinte e três, da descendência de Besai."
,"18":"Cento e doze, da descendência de Jora."
,"19":"Duzentos e vinte e três, da descendência de Hasum."
,"20":"Noventa e cinco, da descendência de Gebar."
,"21":"Cento e vinte e três, da descendência de Belém."
,"22":"Cinquenta e seis homens, de Netofa."
,"23":"Cento e vinte e oito homens, de Anatot."
,"24":"Quarenta e dois, da descendência de Azmot."
,"25":"Setecentos e quarenta e três, da descendência de Cariat-Iarim, Cafira e Berot."
,"26":"Seiscentos e vinte e um, da descendência de Ramá e Gaba."
,"27":"Cento e vinte e dois homens, de Macmas."
,"28":"Duzentos e vinte e três, de Betel e Hai."
,"29":"Cinquenta e dois, da descendência de Nebo."
,"30":"Cento e cinquenta e seis, da descendência de Megbis."
,"31":"Mil duzentos e cinquenta e quatro, da descendência de outro Elam."
,"32":"Trezentos e vinte, da descendência de Harim."
,"33":"Setecentos e vinte e cinco, da descendência de Lod, Hadid e Ono."
,"34":"Trezentos e quarenta e cinco, da descendência de Jericó."
,"35":"E três mil seiscentos e trinta, da descendência de Sanaá."
,"36":"Regressaram os seguintes sacerdotes: Novecentos e setenta e três, da descendência de Jedaías, da família de Josué."
,"37":"Mil e cinquenta e dois, da descendência de Emer."
,"38":"Mil duzentos e quarenta e sete, da descendência de Fasur."
,"39":"E mil e dezassete, da descendência de Harim."
,"40":"Regressaram setenta e quatro levitas, da descendência de Josué e Cadmiel, filhos de Odovias."
,"41":"Cantores, descendentes de Asaf: Cento e vinte e oito."
,"42":"Da descendência de Selum, de Ater, de Telmon, de Acub, de Hatita e de Sobai, famílias de porteiros: Cento e trinta e nove."
,"43":"Regressaram também oblatos, das seguintes descendências: Sia, Hasula, Tabaot,"
,"44":"Ceros, Siá, Fadon,"
,"45":"Lebana, Hagaba, Acub,"
,"46":"Hagab, Semlai, Hanã,"
,"47":"Cidel, Gaer, Raaías,"
,"48":"Rasin, Necoda, Gazam,"
,"49":"Uza, Fasea, Besai,"
,"50":"Asena, meunitas, nefusitas,"
,"51":"Bacbuc, Hacufa, Harur,"
,"52":"Baslut, Maida, Harsa,"
,"53":"Bercos, Sísara, Tema,"
,"54":"Nasias e Hatifa."
,"55":"Regressaram ainda descendentes dos escravos de Salomão, das seguintes famílias: Sotai, Soferet, Feruda,"
,"56":"Jaala, Darcon, Gidel,"
,"57":"Safatias, Hatil, Foqueret-Assebaim e Ami."
,"58":"Os oblatos e os descendentes dos escravos de Salomão perfaziam um total de trezentas e noventa e duas pessoas."
,"59":"Os que regressaram de Tel-Mela, Tel-Harsa, Querub, Adon e Emer, e não puderam provar que a sua família era de origem israelita, são os seguintes:"
,"60":"Seiscentos e cinquenta e dois, da descendência de Dalaías, de Tobias e de Necoda,"
,"61":"além da gente das famílias de sacerdotes, descendentes de Habias, de Acos e de Berzelai. Este último casara com uma filha do galaadita Berzelai, do qual adoptou o nome."
,"62":"Todos estes procuraram o registo da sua genealogia, mas não o encontraram. Foram, assim, excluídos do sacerdócio como impuros."
,"63":"O governador deu ordem para eles não comerem dos alimentos sagrados, até aparecer um sacerdote que consultasse os Urim e os Tumim."
,"64":"O grupo todo que se reuniu era de quarenta e duas mil e trezentas e sessenta pessoas,"
,"65":"sem contar os sete mil e trezentos e trinta e sete escravos e escravas. Entre eles havia duzentos cantores e cantoras."
,"66":"Tinham setecentos e trinta e seis cavalos, duzentos e quarenta e cinco mulas,"
,"67":"quatrocentos e trinta e cinco camelos e seis mil setecentos e vinte jumentos."
,"68":"Vários chefes de família, ao chegarem ao Templo de Javé, que está em Jerusalém, fizeram as suas ofertas espontâneas, para que o Templo fosse reconstruído no mesmo lugar."
,"69":"Conforme cada um podia, deram para o tesouro do culto sessenta e uma mil dracmas de ouro, cinco mil minas de prata e cem túnicas sacerdotais."
,"70":"Os sacerdotes, os levitas e parte do povo passaram a morar em Jerusalém, enquanto os cantores, porteiros e doados, com todos os israelitas, foram morar cada um na sua cidade."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Quando chegou o sétimo mês, os israelitas já estavam nas suas cidades, e todo o povo se reuniu em Jerusalém como se fosse uma só pessoa."
,"2":"Então Josué, filho de Josedec, com os seus irmãos sacerdotes, e Zorobabel, filho de Salatiel, e seus irmãos, começaram a reconstruir o altar do Deus de Israel, para nele oferecerem holocaustos, conforme está escrito na lei de Moisés, homem de Deus."
,"3":"Apesar do medo que tinham das populações locais, reconstruíram o altar no seu antigo lugar e sobre ele ofereceram a Javé holocaustos matutinos e vespertinos."
,"4":"Celebraram a festa das Tendas, conforme está determinado, e ofereceram holocaustos diários, de acordo com o número marcado para cada dia."
,"5":"Depois, além do holocausto permanente, ofereceram os holocaustos que estão previstos para os sábados e as luas-novas, para todas as festas consagradas a Javé e todos os sacrifícios espontâneos que cada um quisesse oferecer a Javé."
,"6":"No dia primeiro do sétimo mês, começaram a oferecer holocaustos em honra de Javé, apesar de não estarem ainda colocados os alicerces do santuário."
,"7":"Conforme a autorização de Ciro, rei da Pérsia, contrataram cortadores de pedra e carpinteiros. Deram provisões, bebidas e azeite aos sidónios e tírios para que transportassem madeira de cedro do Líbano até Jaba, por via marítima."
,"8":"Dois anos depois de terem chegado ao Templo de Deus em Jerusalém, Zorobabel, filho de Salatiel, e Josué, filho de Josedec, juntamente com os seus irmãos sacerdotes e levitas e todos os que tinham voltado do cativeiro para Jerusalém, começaram a construção no segundo mês. Aos levitas com mais de vinte anos, confiaram a direcção dos trabalhos de construção do Templo de Javé."
,"9":"Então Josué, com os seus filhos e irmãos, Cadmiel com os seus filhos, e Odovias com os seus filhos, começaram a dirigir os operários que trabalhavam no Templo de Deus."
,"10":"Quando os pedreiros acabaram de fazer os alicerces do Templo de Javé, os sacerdotes, paramentados e com trombetas, e os levitas descendentes de Asaf, com címbalos, apresentaram-se para louvar a Javé, conforme David, rei de Israel, tinha ordenado."
,"11":"Louvaram e agradeceram a Javé, «porque Ele é bom, porque o seu amor é para sempre» em favor de Israel. Todo o povo erguia fortes gritos, dando louvores a Javé, porque os alicerces do Templo de Javé tinham sido lançados."
,"12":"Enquanto isso, muitos sacerdotes e levitas, e também chefes de família mais velhos que tinham conhecido o Templo antigo, ao verem os alicerces do Templo actual, choravam em alta voz, enquanto outros davam gritos de alegria."
,"13":"No meio do povo, ninguém conseguia distinguir entre os gritos de alegria e o clamor do choro, porque o povo vibrava em alvoroço, e de longe ouvia-se o rumor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Os adversários de Judá e Benjamim ouviram dizer que a gente vinda do exílio estava a construir o Templo de Javé, o Deus de Israel."
,"2":"Então foram procurar Zorobabel, Josué e os chefes de família. E disseram-lhes: «Queremos colaborar convosco na construção, porque nós buscamos o mesmo Deus que vós e oferecemos-Lhe sacrifícios, desde que Asaradon, rei da Assíria, vos instalou aqui»."
,"3":"Zorobabel, Josué e os chefes de família de Israel responderam: «Não construiremos juntos o Templo do nosso Deus. Nós construiremos sozinhos um Templo para Javé, o Deus de Israel, pois foi isso que Ciro, rei da Pérsia, nos ordenou»."
,"4":"Então a população local começou a desmoralizar os judeus e a intimidá-los, para que interrompessem a construção."
,"5":"Subornaram conselheiros para que fizessem fracassar os projectos dos judeus; isso, durante todo o tempo de Ciro, até ao reinado de Dario, rei da Pérsia."
,"6":"Logo no começo do reinado de Xerxes, a população local escreveu uma carta, acusando os habitantes de Judá e Jerusalém."
,"7":"No tempo de Artaxerxes, Mitrídates, Tabel e outros companheiros seus escreveram a Artaxerxes, rei da Pérsia, cartas contra Jerusalém. O texto do documento foi redigido em escrita e língua aramaicas."
,"8":"Depois, Reum, governador da Samaria, e o secretário Samsai, escreveram ao rei Artaxerxes, contra Jerusalém, uma carta nos seguintes termos:"
,"9":"«O governador Reum, o secretário Samsai, colegas juízes, legados e funcionários persas, povo de Uruc, Babilónia, Susa, ou seja Elam,"
,"10":"e outros povos que o grande Assurbanipal deportou das suas terras e instalou nas cidades da Samaria e em outros lugares do lado ocidental do rio Eufrates». E assim por diante."
,"11":"O texto da carta que mandaram é o seguinte: «Ao rei Artaxerxes, saudações da parte dos seus súbditos que moram no lado ocidental do rio Eufrates."
,"12":"Comunicamos ao rei que os judeus, vindos de junto de Vossa Majestade e que voltaram para Jerusalém, estão a reconstruir a cidade rebelde e perversa, estão a consertar as suas muralhas e já refizeram os alicerces."
,"13":"Que o rei tome conhecimento: se reconstruírem a cidade e consertarem as suas muralhas, eles nunca mais pagarão impostos, tributos e portagem, e o rei ficaria prejudicado."
,"14":"Dado que nós vivemos às custas da coroa, não podemos tolerar esta ofensa ao rei. Por isso lhe comunicamos o que está acontecendo."
,"15":"Investiguem os Anais dos seus predecessores, e o rei poderá ver que esta cidade é rebelde e causa prejuízo aos reis e províncias, e que dentro dela se pratica a subversão, desde os tempos mais antigos. Por isso é que esta cidade foi destruída."
,"16":"Queremos que o rei saiba de uma coisa: se esta cidade for reconstruída e as suas muralhas forem reformadas, o rei perderá imediatamente os territórios do lado de cá do rio Eufrates»."
,"17":"O rei mandou a seguinte resposta: «Saudações ao governador Reum, ao secretário Samsai e aos outros seus colegas que moram na Samaria e em todos os lugares do lado ocidental do rio Eufrates."
,"18":"Foi-me lida uma tradução da carta que vós me escrevestes."
,"19":"Mandei investigar o caso, e de facto descobriram que essa cidade, desde os tempos mais antigos, se rebelava contra os reis e aí se praticava a revolta e a subversão."
,"20":"Em Jerusalém, houve reis poderosos que dominaram toda a região do lado ocidental do rio Eufrates, cobrando impostos, tributos e portagem."
,"21":"Ordenai, portanto, que esses homens sejam proibidos de reconstruir a cidade, até nova ordem."
,"22":"Ficai pois atentos, para não vos descuidardes de fazer isso, a fim de que o mal não cresça, nem venha a causar problemas aos reis»."
,"23":"Logo que a carta do rei Artaxerxes foi lida diante do governador Reum, do secretário Samsai e dos outros seus colegas, eles correram para Jerusalém à procura dos judeus e, com a força das armas, fizeram com que eles interrompessem os trabalhos."
,"24":"Foi assim que os trabalhos de construção do Templo de Deus em Jerusalém foram interrompidos, e a construção ficou parada até ao segundo ano de governo de Dario, rei da Pérsia."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Os profetas Ageu e Zacarias, filho de Ado, começaram a profetizar aos judeus de Judá e Jerusalém, falando em nome do Deus de Israel, que os inspirava."
,"2":"Nessa época, Zorobabel, filho de Salatiel, e Josué, filho de Josedec, começaram a reconstruir o Templo de Deus em Jerusalém, acompanhados e incentivados pelos profetas de Deus."
,"3":"Tatanai, porém, governador da região ocidental do rio Eufrates, juntamente com Setar-Buzanai e outros colegas seus, foram ter com eles e perguntaram: «Quem vos deu permissão para reconstruir este Templo e restaurar estas paredes?"
,"4":"Como se chamam os homens responsáveis por esta construção?»"
,"5":"Deus, porém, velava pelos anciãos dos judeus, que não se viram obrigados a interromper o trabalho, enquanto não chegasse a Dario um relatório e ele não mandasse uma ordem oficial sobre a questão."
,"6":"Texto da carta que Tatanai, governador da região ocidental do rio Eufrates, e Setar-Buzanai com outros colegas, autoridades da província, mandaram ao rei Dario."
,"7":"O relatório que mandaram dizia assim: «Saudações ao rei Dario."
,"8":"Saiba o rei que nós fomos ao distrito de Judá, ao Templo do grande Deus. O Templo está a ser reconstruído em pedra talhada, as paredes são revestidas de madeira; trabalha-se com cuidado e a construção progride."
,"9":"Procurámos aqueles senhores e perguntámos quem lhes tinha dado ordens para reconstruir o Templo e restaurar as suas paredes."
,"10":"Pedimos também o nome das pessoas e tomámos por escrito o nome dos chefes, para informar o rei."
,"11":"Esta foi a resposta deles: Nós somos servidores do Deus do Céu e da Terra, e estamos a reconstruir um Templo que, no passado, esteve de pé por muitos anos, tendo sido construído por um grande rei de Israel, o qual levantou as paredes e fez o acabamento."
,"12":"Mas, como os nossos antepassados irritaram o Deus do Céu, Ele entregou-os nas mãos do caldeu Nabucodonosor, rei da Babilónia, que destruiu o Templo e exilou o povo para a Babilónia."
,"13":"Entretanto, no primeiro ano do seu reinado, o rei Ciro promulgou um decreto, mandando reconstruir este Templo de Deus."
,"14":"Até os objectos de ouro e prata que eram do Templo de Deus e que Nabucodonosor tinha tirado do Templo de Jerusalém para o templo da Babilónia, o rei Ciro retirou do templo da Babilónia e entregou a Sasabassar, a quem nomeou governador,"
,"15":"dizendo-lhe: Pega nesses objectos, coloca-os no Templo de Jerusalém e reconstrói o Templo de Deus no mesmo lugar."
,"16":"Sasabassar veio e lançou os alicerces do Templo de Deus em Jerusalém. Desde aquela época até agora, o Templo está a ser reconstruído, mas ainda não o terminámos."
,"17":"Portanto, se o rei achar conveniente, que se faça uma pesquisa nos arquivos reais da Babilónia, para ver se é verdade que o rei Ciro mandou reconstruir o Templo de Deus em Jerusalém. Depois, comuniquem-nos a decisão do rei»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Em vista disso, o rei Dario mandou investigar o tesouro da Babilónia, que também servia de arquivo."
,"2":"Verificou-se, então, que em Ecbátana, fortaleza da província da Média, havia um rolo onde estava escrito o seguinte:"
,"3":"«Memorando. No primeiro ano do seu governo, o rei Ciro promulgou o seguinte decreto: Templo de Deus em Jerusalém. O Templo deverá ser reconstruído para ser um lugar onde se ofereçam sacrifícios, e os seus alicerces devem ser restaurados. O templo terá trinta metros de altura e trinta de largura."
,"4":"Terá três fileiras de pedras talhadas e uma fileira de madeira. A despesa correrá por conta do palácio do rei."
,"5":"Também os objectos de ouro e prata do Templo de Deus, retirados do Templo de Jerusalém por Nabucodonosor e trazidos para a Babilónia, serão devolvidos. Desse modo, tudo voltará ao seu lugar no santuário de Jerusalém, e será colocado no Templo de Deus»."
,"6":"«Agora, pois, Tatanai, governador da região ocidental do rio Eufrates, juntamente com Setar-Buzanai e os colegas e autoridades do território ocidental do Eufrates, afastai-vos de lá."
,"7":"Deixai que o governador de Judá e os anciãos dos judeus trabalhem no Templo de Deus. Eles podem reconstruir o Templo de Deus no seu antigo lugar."
,"8":"A respeito do trabalho que os anciãos dos judeus estão a executar na reconstrução do Templo de Deus, ordeno que se pague tudo o que esses homens gastarem, pontualmente e sem interrupção, usando para isso as rendas reais dos impostos recolhidos na região ocidental do rio Eufrates."
,"9":"Todos os dias, sem falta, seja-lhes fornecido o necessário para os holocaustos em honra do Deus do Céu, isto é, bezerros, carneiros e cordeiros, e também trigo, sal, vinho e azeite, conforme os sacerdotes de Jerusalém pedirem."
,"10":"Deste modo, eles poderão oferecer ao Deus do Céu sacrifícios de odor agradável. E que eles rezem pela vida do rei e dos seus filhos."
,"11":"Se alguém desrespeitar o que está nesta carta, ordeno que seja tirada de sua própria casa uma viga de madeira, que será fincada no chão, para que a pessoa seja nela enforcada. Depois, transformem a casa dessa pessoa num monte de ruínas."
,"12":"E o Deus que aí fez habitar o seu Nome, destrua todo o rei e todo o povo que ouse modificar ou destruir o Templo de Deus em Jerusalém. Eu, Dario, dei esta ordem. Que seja fielmente cumprida»."
,"13":"Tatanai, governador da região ocidental do rio Eufrates, com Setar-Buzanai e os seus colegas, fizeram tudo exactamente como o rei Dario tinha mandado."
,"14":"Os anciãos dos judeus puderam, então, levar avante a construção. Tudo correu bem, graças ao incentivo das palavras inspiradas dos profetas Ageu e Zacarias, filho de Ado. Terminaram a construção conforme a ordem do Deus de Israel e segundo o decreto de Ciro, Dario e Artaxerxes, reis da Pérsia."
,"15":"Terminaram a construção no dia três do mês de Adar, no sexto ano do reinado de Dario."
,"16":"Cheios de alegria, os israelitas, ou seja, sacerdotes, levitas e outros repatriados, celebraram a dedicação do Templo de Deus."
,"17":"Nessa ocasião, ofereceram em sacrifício cem bezerros, duzentos carneiros, quatrocentos cordeiros e, como sacrifício pelo pecado de todo o Israel, doze bodes, de acordo com o número das tribos de Israel."
,"18":"Estabeleceram também os sacerdotes, divididos conforme as suas classes, e os levitas, segundo os seus turnos, para servirem no culto de Deus em Jerusalém, como manda a Lei de Moisés."
,"19":"Os repatriados celebraram a Páscoa no dia catorze do primeiro mês."
,"20":"Os levitas haviam-se purificado em conjunto; por isso estavam puros. Então imolaram a Páscoa para todos os repatriados, para os seus irmãos sacerdotes e para si próprios."
,"21":"Comeram a Páscoa os israelitas que tinham voltado do exílio e todos os que evitaram contaminar-se com a população local e que se uniram aos israelitas para aderir a Javé, o Deus de Israel."
,"22":"Durante sete dias, celebraram alegremente a festa dos Pães sem fermento. Festejaram Javé, porque Javé, mudando a atitude do rei da Assíria, lhes deu forças para trabalhar no Templo do Deus de Israel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Anos mais tarde, durante o reinado de Artaxerxes, rei da Pérsia, Esdras partiu da Babilónia. Ele era filho de Saraías, filho de Azarias, filho de Helcias,"
,"2":"filho de Selum, filho de Sadoc, filho de Arquitob,"
,"3":"filho de Amarias, filho de Azarias, filho de Maraiot,"
,"4":"filho de Zaraías, filho de Ozi, filho de Boci,"
,"5":"filho de Abisue, filho de Fineias, filho de Eleazar, que era filho do sumo sacerdote Aarão."
,"6":"Esdras era um escriba especialista na Lei de Moisés, dada por Javé, o Deus de Israel. A mão de Deus estava com ele e por isso o rei concedeu-lhe tudo o que ele pediu."
,"7":"No sétimo ano do reinado de Artaxerxes, voltaram também para Jerusalém muitos israelitas sacerdotes, levitas, cantores, porteiros e oblatos."
,"8":"Esdras chegou a Jerusalém no quinto mês do sétimo ano do reinado de Artaxerxes."
,"9":"Esdras saiu da Babilónia no dia primeiro do primeiro mês, e chegou a Jerusalém no dia primeiro do quinto mês. A mão bondosa do seu Deus estava sobre ele,"
,"10":"porque Esdras se havia dedicado a estudar a Lei de Javé, a fim de praticar e ensinar os seus estatutos e normas em Israel."
,"11":"Texto da carta que o rei Artaxerxes entregou ao sacerdote escriba Esdras, especialista nos mandamentos de Javé e nos estatutos que Ele deu a Israel:"
,"12":"«Artaxerxes, rei dos reis, deseja toda a paz a Esdras, sacerdote e doutor na lei do Deus do Céu."
,"13":"Determino que podem ir contigo israelitas, incluindo sacerdotes e levitas, que se encontram no meu reino e desejam voltar para Jerusalém."
,"14":"O rei e os seus sete conselheiros enviam-te para verificares como está a ser cumprida em Judá e Jerusalém a lei do teu Deus, a qual está nas tuas mãos."
,"15":"E levarás também a prata e o ouro que o rei e seus conselheiros oferecem ao Deus de Israel que mora em Jerusalém,"
,"16":"e ainda todo o ouro e prata que receberes em toda a província da Babilónia, além dos donativos espontâneos que o povo e os sacerdotes oferecem para o Templo do seu Deus em Jerusalém."
,"17":"Com esse dinheiro, comprarás bezerros, carneiros e cordeiros, bem como as oblações e libações que os acompanham, e oferecê-los-ás no altar do Templo do teu Deus em Jerusalém."
,"18":"E o que sobrar da prata e do ouro, empregai tudo como tu e os teus irmãos acharem melhor, de acordo com a vontade do vosso Deus."
,"19":"Os objectos de culto do Templo de Deus que te foram entregues, levá-los-ás de volta para o lugar da presença do teu Deus em Jerusalém."
,"20":"Tudo o mais que for necessário para o Templo do teu Deus, e que ainda ficaria para tu recolheres, tudo te será fornecido pelo tesouro do rei."
,"21":"Eu mesmo, o rei Artaxerxes, determino a todos os tesoureiros da região do lado ocidental do rio Eufrates: Fazei tudo o que vos pedir o sacerdote Esdras, doutor da lei do Deus do céu,"
,"22":"até ao limite de três mil e quatrocentos quilos de prata, cem sacos de trigo, cem barris de vinho, cem de azeite e sal à vontade."
,"23":"Fazei exactamente tudo o que o Deus do céu ordenar em relação ao seu Templo, para que a sua ira não caia sobre o império deste rei e de seus filhos."
,"24":"Faço também saber que nenhum imposto, tributo ou pedágio deverá ser cobrado aos sacerdotes, levitas, cantores, porteiros, oblatos, enfim, a todos os que servem no Templo de Deus."
,"25":"Quanto a ti, Esdras, de acordo com a sabedoria do teu Deus, que tens nas mãos, nomeia magistrados e juízes, que apliquem a justiça a todo o povo do lado ocidental do rio Eufrates, a todos os que conhecem a Lei do teu Deus. E ensina-a aos que não a conhecem."
,"26":"Quem não obedecer à Lei do teu Deus, que é a Lei do rei, será castigado rigorosamente, com morte ou exílio, multa ou prisão»."
,"27":"Seja bendito Javé, o Deus dos nossos antepassados, que abriu o coração do rei para honrar o Templo de Javé em Jerusalém,"
,"28":"e que me concedeu o favor do rei, dos seus conselheiros e de todas as autoridades militares. Fiquei, assim, cheio de coragem, porque senti que estava comigo a força de Javé, meu Deus. Então reuni alguns chefes de Israel para me acompanharem na viagem."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Lista dos chefes de família - cada qual com a sua genealogia - que voltaram comigo da Babilónia durante o reinado de Artaxerxes:"
,"2":"Descendente de Fineias: Gersam. Descendente de Itamar: Daniel. Descendente de David: Hatus,"
,"3":"filho de Sequenias. Descendente de Faros: Zacarias (com quem estavam registados cento e cinquenta homens)."
,"4":"Descendente de Faat-Moab: Elioenai, filho de Zaraías, e mais duzentos homens."
,"5":"Descendente de Zetua: Sequenias, filho de Jaaziel, e mais trezentos homens."
,"6":"Descendente de Adin: Abed, filho de Jónatas, e mais cinquenta homens."
,"7":"Descendente de Elam: Isaías, filho de Atalia, e mais setenta homens."
,"8":"Descendente de Safatias: Zebedias, filho de Miguel, e mais oitenta homens."
,"9":"Descendente de Joab: Abdias, filho de Jaiel, e mais duzentos e dezoito homens."
,"10":"Descendente de Bani: Salomit, filho de Josfias, mais cento e sessenta homens."
,"11":"Descendente de Bebai: Zacarias, filho de Bebai, e mais vinte e oito homens."
,"12":"Descendente de Azgad: Joanã, filho de Ectã, e mais cento e dez homens."
,"13":"Descendentes de Adonicam: os mais novos, cujos nomes são: Elifalet, Jeiel e Semeías, e mais sessenta homens."
,"14":"Descendente de Beguai: Utai, filho de Zabud, e mais setenta homens."
,"15":"Reuni toda esta gente na margem do rio que desce para Aava e aí acampámos durante três dias. Consegui descobrir gente do povo e sacerdotes, mas não encontrei nenhum levita."
,"16":"Então mandei procurar Eliezer, Ariel, Semeías, Elnatã, Jarib, Elnatã, Natã, Zacarias e Mosolam, homens sábios,"
,"17":"e mandei-os a Ado, que era chefe do lugar chamado Casfia, dando-lhes um recado que iriam transmitir a Ado e seus irmãos, residentes em Casfia: pedi que nos mandassem ministros para o Templo do nosso Deus."
,"18":"Dado que a mão bondosa de Javé estava connosco, eles mandaram-nos Serebias, homem equilibrado, filho de Mooli e descendente de Levi, filho de Israel. Ele com seus filhos e irmãos somavam o total de dezoito homens."
,"19":"Mandaram também Hasabias e Isaías, da família de Merari. Os dois irmãos com seus filhos somavam vinte homens."
,"20":"Mandaram ainda duzentos e vinte oblatos, daqueles que David e os chefes tinham colocado ao serviço dos levitas. Todos foram registados nominalmente."
,"21":"Junto ao rio Aava, proclamei um jejum como penitência diante do nosso Deus, a quem pedimos uma boa viagem para nós, para os nossos filhos e todos os nossos bens."
,"22":"Tivemos vergonha de pedir ao rei uma escolta e cavalaria para nos proteger dos inimigos, durante a viagem. Pelo contrário, tínhamos declarado ao rei: «O nosso Deus protege aqueles que O servem, mas o poder e a ira d'Ele recaem sobre todos aqueles que O abandonam»."
,"23":"Então jejuámos e suplicámos ao nosso Deus por essa intenção. E Ele ouviu-nos."
,"24":"Escolhi doze chefes dos sacerdotes, que eram Serebias e Hasabias, com mais dez dos seus irmãos."
,"25":"Pesei diante deles a prata, o ouro e os objectos preciosos que o rei, seus conselheiros, príncipes e todos os israelitas, que lá estavam, tinham oferecido para o Templo do nosso Deus."
,"26":"Pesei e entreguei-lhes vinte e dois mil quilos de prata, cem objectos de prata que pesavam sessenta e oito quilos, três mil e quatrocentos quilos de ouro,"
,"27":"vinte taças de ouro que valiam mil dáricos, e dois vasos de bronze fino dourado, preciosos como se fossem de ouro."
,"28":"Depois eu disse-lhes: «Vós estais consagrados a Javé. Também os objectos são sagrados. Esta prata e este ouro foram entregues a Javé, o Deus dos vossos antepassados."
,"29":"Tende, portanto, muito cuidado e guardai bem todas estas coisas, até poderdes pesá-las diante dos chefes dos sacerdotes, dos levitas e dos chefes de famílias de Israel, em Jerusalém, nas salas do Templo de Javé»."
,"30":"Os sacerdotes e levitas assumiram a responsabilidade pela prata, pelo ouro e pelos objectos que lhes foram entregues para serem levados para o Templo do nosso Deus em Jerusalém."
,"31":"No dia doze do primeiro mês, deixámos o rio Aava e partimos para Jerusalém. O nosso Deus protegeu-nos durante a viagem e livrou-nos de inimigos e assaltantes."
,"32":"Tendo chegado a Jerusalém, descansámos três dias."
,"33":"No quarto dia, a prata, o ouro e os objectos foram pesados no Templo do nosso Deus e entregues ao sacerdote Meremot, filho de Urias, ajudado por Eleazar, filho de Fineias, e pelos levitas Jozabad, filho de Josué, e Noadaías, filho de Benui."
,"34":"A quantidade e o peso estavam certos, e o peso total foi registado."
,"35":"Os exilados, que tinham voltado do cativeiro, ofereceram holocaustos ao Deus de Israel: doze bezerros por todo o Israel, noventa e seis carneiros, setenta e dois cordeiros, e doze bodes como sacrifício pelo pecado. Tudo foi queimado sobre o altar em honra de Javé."
,"36":"Mais tarde, entregaram os decretos do rei aos sátrapas e governadores da região do lado ocidental do rio Eufrates. Estes então passaram a dar apoio ao povo e ao Templo de Deus."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Depois disto, os chefes procuraram-me e disseram-me: «O povo de Israel, os sacerdotes e os levitas cometeram as mesmas abominações que a população local, formada de cananeus, heteus, ferezeus, jebuseus, amonitas, moabitas, egípcios e amorreus:"
,"2":"eles e os seus filhos casaram-se com mulheres estrangeiras, e a raça santa misturou-se com a população local. Os chefes e os magistrados foram os primeiros a praticar essa infidelidade»."
,"3":"Ao receber esta notícia, rasguei as vestes e o manto, arranquei os cabelos da cabeça e da barba e sentei-me desolado."
,"4":"Todos os que respeitavam a lei do Deus de Israel reuniram-se comigo, por causa da infidelidade dos repatriados. Fiquei sentado e angustiado até à hora da oblação da tarde."
,"5":"Na hora da oblação da tarde, levantei-me da minha desolação e, com as vestes e o manto rasgados, caí de joelhos e levantei as mãos para Javé, meu Deus,"
,"6":"e disse: «Meu Deus, eu estou envergonhado e sem coragem para levantar o rosto para Ti, porque os nossos pecados ultrapassam a nossa cabeça, e a nossa culpa chega até ao céu."
,"7":"Desde o tempo dos nossos antepassados até hoje, uma grande culpa pesa sobre nós: por causa dos nossos pecados, nós, os nossos reis e os nossos sacerdotes, fomos todos entregues nas mãos dos reis de outros países, fomos vítimas da espada, do exílio, do saque e da vergonha. E essa é a situação actual."
,"8":"Agora, porém, Javé, nosso Deus, concedeu-nos um momento de graça, deixando-nos um resto de sobreviventes e abrigando-nos no seu lugar santo. Deste modo, o nosso Deus dá brilho aos nossos olhos, e nós sentimos um pouco de vida no meio da escravidão."
,"9":"Éramos escravos, mas o nosso Deus não nos abandonou na escravidão. Pelo contrário, deu-nos o favor dos reis da Pérsia, e concedeu-nos vida para reconstruirmos o Templo do nosso Deus e restaurarmos as suas ruínas. Ele deu-nos assim um abrigo em Judá e Jerusalém."
,"10":"Mas agora, Deus nosso, o que podemos dizer depois disto? Abandonámos os mandamentos que"
,"11":"nos deste por meio dos teus servos, os profetas, dizendo: 'A terra que ides possuir é uma terra impura, por causa da imundície da população local e das abominações com que a encheram de um extremo ao outro com as suas impurezas."
,"12":"Portanto, não entregueis as vossas filhas aos filhos deles, nem caseis os vossos filhos com as filhas deles. Não contribuais para a prosperidade e o bem-estar deles. Deste modo, tornar-vos-eis fortes, comereis os frutos da terra e deixá-la-eis como herança aos vossos filhos para sempre'."
,"13":"Depois de tudo o que nos aconteceu por causa do mal que praticámos e por causa dos nossos grandes crimes, Tu, nosso Deus, ainda nos poupaste. Não tomaste em consideração os nossos pecados, e deixaste que este grupo sobrevivesse."
,"14":"Será que ainda assim poderíamos violar os teus mandamentos e aliar-nos a esta gente abominável? Não Te irritarás contra nós até acabar com tudo, sem deixar um resto de vida?"
,"15":"Javé, Deus de Israel, este resto, que hoje continua vivo, é uma prova de que és justo! Estamos diante de Ti como réus, porque não podemos ficar na tua presença depois do que aconteceu!»"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Enquanto Esdras rezava e fazia esta confissão chorando e prostrado diante do Templo de Deus, foi-se reunindo em torno dele uma grande multidão de israelitas, homens, mulheres e crianças, que choravam sem parar."
,"2":"Então Sequenias, filho de Jaiel, descendente de Elam, disse a Esdras: «Fomos infiéis ao nosso Deus, casando-nos com mulheres estrangeiras, tomadas da população local. Apesar disso, ainda há esperança para Israel."
,"3":"Nós comprometemo-nos, com o nosso Deus, a despedir todas as mulheres estrangeiras e os filhos que tivemos com elas, conforme o conselho do meu senhor e dos que observam o mandamento do nosso Deus. Que a Lei seja cumprida!"
,"4":"Levanta-te, porque este assunto é da tua conta. Estamos do teu lado. Coragem e mãos à obra!»"
,"5":"Esdras levantou-se e convidou os chefes dos sacerdotes e dos levitas, e todo o Israel, a jurar que agiriam conforme o que fora dito. E eles juraram."
,"6":"Então Esdras saiu do Templo de Deus e foi ao aposento de Joanã, filho de Eliasib, onde pernoitou. Ficou sem comer e sem beber, porque estava de luto por causa da infidelidade dos repatriados."
,"7":"Proclamaram, em Judá e Jerusalém, que todos os repatriados se reunissem em Jerusalém."
,"8":"Quem não comparecesse dentro de três dias, conforme a orientação dos chefes e dos anciãos, teria os seus bens confiscados para Javé e seria expulso da comu-nidade dos repatriados."
,"9":"No terceiro dia, todos os homens de Judá e de Benjamim estavam reunidos em Jerusalém. Era o dia vinte do nono mês. Todo o povo estava na praça do Templo de Deus, tremendo por causa do assunto e porque chovia forte."
,"10":"Então Esdras levantou-se e declarou: «Fostes infiéis ao casardes com mulheres estrangeiras, agravando a culpa de Israel."
,"11":"Agora, confessai isso a Javé, o Deus dos vossos antepassados, cumpri a sua vontade, e separai-vos da população local e das mulheres estrangeiras»."
,"12":"Toda a comunidade respondeu em alta voz: «Faremos o que dizes."
,"13":"No entanto, somos muitos, é tempo de chuva e ninguém aguenta ficar ao relento. O problema não se resolve num dia ou dois, porque são muitos os que cometeram essa rebeldia."
,"14":"Seria melhor que os nossos chefes representassem toda a comunidade. Todo aquele que, em qualquer das nossas cidades, se tiver casado com mulher estrangeira, virá aqui na data marcada, acompanhado pelos anciãos e pelos juízes da sua cidade, até que afastemos a ira do nosso Deus, que provocámos com este comportamento»."
,"15":"Só Jónatas, filho de Asael, e Jaasias, filho de Tícua, ficaram contra a proposta, e foram apoiados por Mosolam e pelo levita Sebetai."
,"16":"Os repatriados, porém, agiram conforme a proposta. O sacerdote Esdras escolheu alguns chefes de família, um por família, designados nominalmente. No dia primeiro do décimo mês, começaram a examinar os casos"
,"17":"e, no dia primeiro do primeiro mês, terminaram todos os processos dos homens que se haviam casado com mulheres estrangeiras."
,"18":"Descobriu-se que os seguintes sacerdotes se tinham casado com mulheres estrangeiras: Maasias, Eliezer, Jarib e Godolias, que eram filhos de Josué, filho de Josedec, e dos irmãos de Josué."
,"19":"Eles comprometeram-se a mandar embora as suas mulheres e a oferecer um carneiro em reparação pelo pecado."
,"20":"Outros sacerdotes que tinham mulheres estrangeiras: Hanani e Zabadias, descendentes de Emer."
,"21":"Maasias, Elias, Semeías, Jaiel e Ozias, descendentes de Harim."
,"22":"Elioenai, Maasias, Ismael, Natanael, Jozabad e Elasa, descendentes de Fasur."
,"23":"Entre os levitas: Jozabad, Semei, Celaías ou Calita, Petaías, Judá e Eliezer."
,"24":"Entre os cantores: Eliasib e Zacur. Entre os porteiros: Selum, Telém e Uri."
,"25":"Entre os israelitas: Remeías, Jezias, Melquias, Miamin, Eleazar, Melquias e Banaías, descendentes de Faros."
,"26":"Matanias, Zacarias, Jaiel, Abdi, Jerimot e Elias, descendentes de Elam."
,"27":"Elioenai, Eliasib, Matanias, Jerimot, Zabad e Aziza, descendentes de Zetua."
,"28":"Joanã, Hananias, Zabai e Atlai, descendentes de Bebai."
,"29":"Mosolam, Meluc, Adaías, Jasub, Saal e Jerimot, descendentes de Beguai."
,"30":"Ednas, Calal, Banaías, Maasias, Matanias, Beseleel, descendentes de Faat-Moab."
,"31":"Eliezer, Jesias, Melquias, Semeías, Simeão,"
,"32":"Benjamim, Meluc e Semerias, descendentes de Harim."
,"33":"Matanai, Matatias, Zabad, Elifalet, Jermai, Manassés, Semei, descendentes de Hasum."
,"34":"Maadai, Amram, Joel,"
,"35":"Banaías, Badaías, Quelias,"
,"36":"Vanias, Meremot, Eliasib,"
,"37":"Matanias, Matanai e Jasi, descendentes de Bani."
,"38":"Semei,"
,"39":"Selemias, Natã e Adaías, descendentes de Benui."
,"40":"Sisai, Sarai,"
,"41":"Azareel, Selemias, Semerias,"
,"42":"Selum, Amarias e José, descendentes de Zacai."
,"43":"Jeiel, Matatias, Zabad, Zabina, Jedu, Joel e Banaías, descendentes de Nebo."
,"44":"Todos eles se tinham casado com mulheres estrangeiras, e separaram-se das mulheres e dos filhos."
}`)

}
func PT_BS_LoadVHETChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1a":"No segundo ano do reinado do rei Assuero, no primeiro dia do mês de Nisã, Mardoqueu teve um sonho. Mardoqueu era filho de Jair, filho de Semei, filho de Cis, da tribo de Benjamim."
,"1b":"Era um judeu que vivia na cidade de Susa, homem notável, ligado à corte do rei."
,"1c":"Pertencia ao grupo dos exilados que Nabucodonosor, rei da Babilónia, tinha exilado de Jerusalém, juntamente com Jeconias, rei de Judá."
,"1d":"O sonho foi assim: Gritos e tumulto, trovões e terremotos, agitação sobre a Terra."
,"1e":"Dois enormes dragões avançam, prontos para a luta. Lançam um grande rugido"
,"1f":"e, ao ouvi-lo, todas as nações se preparam para a guerra, para o combate contra o povo dos justos."
,"1g":"É dia de trevas e escuridão, caem sobre a terra angústia e aflição, tribulação e pavor."
,"1h":"Todo o povo dos justos fica transtornado e, temendo desgraças, prepara-se para morrer e clama a Deus."
,"1i":"E ao clamor do povo brota, como de uma pequena fonte, um grande rio de águas caudalosas."
,"1j":"A luz e o sol levantam-se: os oprimidos são exaltados e devoram os poderosos."
,"1l":"Mardoqueu acordou do sonho e perguntou a si mesmo: «O que é que Deus quer fazer?» Continuou a reflectir nisso e ficou até à noite procurando decifrar de algum modo o significado."
,"1m":"Mardoqueu morava na corte com Bagatã e Tares, dois funcionários do rei, guardas do palácio."
,"1n":"Ouvindo a sua conversa e investigando os seus planos, ficou a saber que estavam a preparar um atentado contra o rei Assuero. Mardoqueu informou o rei."
,"1o":"E o rei interrogou os dois funcionários, que acabaram por confessar e foram condenados à morte."
,"1p":"O rei mandou escrever uma crónica desses factos, e também Mardoqueu, por conta própria, os deixou por escrito."
,"1q":"Depois o rei colocou Mardoqueu como funcionário na corte e recompensou-o com presentes."
,"1r":"Todavia, Amã, filho de Amadates, o agagita, tinha muito prestígio diante do rei e buscava um modo de prejudicar Mardoqueu e o seu povo, por causa dos dois funcionários do rei."
,"1":"Eis o que aconteceu no tempo do rei Assuero, aquele Assuero que reinou sobre cento e vinte e sete províncias, desde a Índia até à Etiópia."
,"2":"Nesse tempo, o rei Assuero reinava na fortaleza de Susa."
,"3":"No terceiro ano do seu reinado, Assuero ofereceu um banquete a todos os seus oficiais e ministros. Reuniram-se então para o banquete os chefes do exército da Pérsia e da Média, os nobres e os governadores das províncias."
,"4":"Assuero queria ostentar a riqueza e glória do seu reino com o fausto magnífico da sua grandeza. Por isso fez com que o banquete durasse cento e oitenta dias."
,"5":"Passados esses dias, o rei deu um banquete durante sete dias no jardim do palácio real, e convidou todo o povo que se encontrava na fortaleza de Susa, desde o maior até ao menor."
,"6":"Havia cortinas de linho fino e púrpura violeta suspensas em anéis de prata e colunas de mármore, e também divãs de ouro e prata sobre um piso de mosaico feito de malaquita, mármore branco e madrepérola."
,"7":"Para beber, havia taças de ouro, todas diferentes, e o vinho era abundante, de acordo com a liberalidade do rei."
,"8":"Bebia-se à vontade, como de costume, porque o rei tinha ordenado aos empregados de sua casa que deixassem cada um fazer o que quisesse."
,"9":"Também a rainha Vasti ofereceu um banquete às mulheres no palácio real de Assuero."
,"10":"No sétimo dia, alegre por causa do vinho, o rei ordenou que Maumã, Bazata, Harbona, Abgata, Bagata, Zetar e Carcas, sete funcionários que serviam pessoalmente o rei Assuero,"
,"11":"lhe apresentassem a rainha Vasti, com a coroa real, para exibir a beleza dela ao povo e aos oficiais, pois a rainha era muito bela."
,"12":"Ao receber a ordem dos funcionários, a rainha Vasti recusou apresentar-se. O rei ficou furioso, e a sua ira inflamou-se."
,"13":"Então consultou os sábios, especialistas em leis, pois toda a questão real devia ser tratada pelos peritos em direito."
,"14":"Os mais próximos eram Carsena, Setar, Admata, Társis, Mares, Marsana e Mamucã, os sete grandes do reino da Pérsia e da Média, que eram conselheiros do rei e ocupavam os primeiros postos no reino."
,"15":"Assuero perguntou: «Segundo a lei, o que se deve fazer à rainha Vasti por não ter obedecido à ordem do rei Assuero, transmitida pelos funcionários?»"
,"16":"Mamucã respondeu diante do rei e dos oficiais: «Não foi somente contra o rei que a rainha Vasti agiu mal, mas também contra todos os oficiais e todos os súbditos que vivem em todas as províncias do rei Assuero."
,"17":"De facto, o comportamento da rainha será conhecido por todas as mulheres, que desprezarão os seus maridos, dizendo: 'O rei Assuero mandou que a rainha Vasti se apresentasse, e ela recusou'."
,"18":"Hoje mesmo, as princesas da Pérsia e da Média, que ficarem a saber do comportamento da rainha, comentá-lo-ão com todos os oficiais do rei, e haverá muito desprezo e zombaria."
,"19":"Se o rei achar bem, proclame um decreto real, que seja incluído nas leis da Pérsia e da Média, e tenha carácter irrevogável: que a rainha Vasti nunca mais se apresente ao rei Assuero e que o título de rainha seja dado a outra, que seja melhor do que ela."
,"20":"Quando o decreto real for promulgado em todo o reino, todas as mulheres respeitarão os seus maridos, tanto as nobres, como as do povo»."
,"21":"O rei e os oficiais gostaram da proposta, e Assuero seguiu o que Mamucã tinha dito."
,"22":"Mandou cartas a todas as províncias reais, na escrita e na língua de cada povo, ordenando que o marido fosse o chefe da casa."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tempos depois, quando se acalmou, o rei lembrou-se de Vasti, do que ela fizera e do decreto que havia publicado contra ela."
,"2":"Então os cortesãos disseram ao rei: «Manda procurar jovens solteiras e bonitas."
,"3":"O rei pode nomear comissários em todas as províncias do reino, e eles reunirão todas as jovens solteiras e bonitas no harém da fortaleza de Susa. Elas ficarão sob os cuidados de Egeu, eunuco do rei, que lhes dará o necessário para os seus enfeites."
,"4":"A jovem que mais agradar ao rei substituirá a rainha Vasti». A proposta agradou ao rei, e assim se fez."
,"5":"Na fortaleza de Susa vivia um judeu chamado Mardoqueu, filho de Jair, filho de Semei, filho de Cis, da tribo de Benjamim."
,"6":"Ele fora exilado de Jerusalém, entre os que tinham sido deportados com Jeconias, rei de Judá, por Nabucodonosor, rei da Babilónia."
,"7":"Mardoqueu tinha criado Hadassa, que é Ester, sua prima, pois ela era órfã de pai e mãe. A jovem era muito bela e atraente e, quando os pais dela morreram, Mardoqueu adoptou-a como filha."
,"8":"Promulgado o decreto real, levaram muitas jovens para a fortaleza de Susa. E elas ficaram sob as ordens de Egeu. Levaram também Ester ao palácio, e deixaram-na aos cuidados de Egeu, o guarda das mulheres."
,"9":"Egeu gostou da jovem, e deu-lhe logo o necessário para os seus enfeites e comida, entregando-lhe sete escravas, todas escolhidas do palácio real. Depois transferiu-a com as escravas para um aposento melhor dentro do harém."
,"10":"Seguindo as recomendações de Mardoqueu, Ester não disse a qual povo ou família pertencia."
,"11":"Todos os dias Mardoqueu passeava pelo pátio do harém, para saber como Ester se sentia e como a tratavam."
,"12":"Conforme o regulamento das mulheres, cada jovem preparava-se durante doze meses para se apresentar ao rei Assuero. E este era o prazo para o tratamento de beleza: seis meses à base de óleo de mirra e outros seis meses com vários bálsamos e cremes."
,"13":"Quando chegava o tempo de se apresentar ao rei, a jovem recebia tudo o que quisesse levar do harém para o palácio real."
,"14":"Entrava no palácio à tarde e, na manhã seguinte, passava para um segundo harém, confiado a Sasagaz, eunuco real encarregado das concubinas. Ela não voltava mais para junto do rei, a não ser que o rei a desejasse e a chamasse pelo nome."
,"15":"Chegou a vez de Ester, filha de Abiail, tio de Mardoqueu, que a adoptara como filha, se apresentar ao rei. Ester, porém, nada pediu. Contentou-se com o que Egeu, eunuco real encarregado das mulheres, lhe havia dado. Ester atraía a simpatia de todos os que a conheciam."
,"16":"Foi levada ao palácio real, à presença do rei Assuero, no décimo mês, o mês de Tebet, no sétimo ano do seu reinado."
,"17":"E o rei preferiu Ester a todas as outras mulheres, tanto que a coroou e a nomeou rainha, em lugar de Vasti."
,"18":"Depois disso o rei deu um grande banquete em honra de Ester, e convidou todos os altos oficiais e ministros. Também concedeu um dia de descanso a todas as províncias, e distribuiu presentes com liberalidade régia."
,"19":"Ester passou depois para o segundo harém, como as outras jovens."
,"20":"Mas não disse a qual povo ou família pertencia. Mardoqueu proibira-a de o fazer, e ela continuava a obedecer-lhe, como quando vivia com ele."
,"21":"Nesse tempo Mardoqueu era funcionário da corte. Ora, Bagatã e Tares, dois funcionários do corpo da guarda, estavam descontentes e planeavam um atentado contra o rei Assuero."
,"22":"Mardoqueu ficou a saber do plano e informou a rainha Ester. Ela, por sua vez, contou tudo ao rei, em nome de Mardoqueu."
,"23":"Fizeram uma investigação, e todo o plano foi descoberto. Os dois funcionários foram enforcados, e o acontecimento foi registado nos anais do reino, na presença do rei."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Algum tempo depois, o rei Assuero promoveu Amã, filho de Amadates, do país de Agag, à mais alta dignidade, e concedeu-lhe um trono mais alto que o dos ministros, colegas de Amã."
,"2":"Todos os funcionários do palácio obedeciam à ordem do rei, e dobrando os joelhos prestavam homenagem a Amã. Mardoqueu, porém, recusou-se a dobrar os joelhos diante de Amã."
,"3":"Os funcionários do palácio perguntaram a Mardoqueu: «Porque é que desobedeces à ordem do rei?»"
,"4":"Perguntavam-lhe isso todos os dias, porém Mardoqueu não fazia caso. Então denunciaram o facto a Amã, para ver se Mardoqueu insistiria no seu comportamento, já que Mardoqueu lhes havia dito que era judeu."
,"5":"Amã comprovou que Mardoqueu não lhe prestava homenagem dobrando os joelhos, e ficou furioso."
,"6":"Mas não se contentou em vingar-se apenas de Mardoqueu. Como lhe tivessem contado a qual povo Mardoqueu pertencia, Amã planeou destruir com Mardoqueu todos os judeus que viviam no reino de Assuero."
,"7":"No primeiro mês, que é o mês de Nisã, no décimo segundo ano do rei Assuero, lançou-se o «Pur», isto é, as sortes, na presença de Amã, para escolher o dia e o mês. A sorte caiu no décimo segundo mês, chamado Adar."
,"8":"Então Amã disse ao rei Assuero: «Há um povo separado, espalhado entre todos os povos das províncias do teu reino. Eles têm leis diferentes de todos os outros, e não cumprem os decretos do rei. Não convém que o rei os tolere."
,"9":"Se o rei achar bem, decrete a sua extinção, e eu entregarei aos funcionários trezentas e quarenta toneladas de prata para o tesouro real»."
,"10":"Então o rei tirou da mão o próprio anel e entregou-o a Amã, filho de Amadates, do país de Agag, inimigo dos judeus,"
,"11":"e disse-lhe: «Fica com o dinheiro, e faz desse povo o que achares melhor»."
,"12":"No dia treze do primeiro mês, os escrivães do reino foram convocados. Conforme as ordens de Amã, eles redigiram um decreto para os sátrapas do rei, para os governadores de cada uma das províncias e para os chefes de cada povo. O decreto foi redigido na escrita de cada província e na língua de cada povo. Foi escrito em nome do rei Assuero e selado com o anel real."
,"13":"A seguir os documentos foram enviados por meio de correios a todas as províncias do reino. Ordenavam exterminar, matar e aniquilar todos os judeus, adolescentes e velhos, crianças e mulheres, e saquear todos os seus bens no mesmo dia, o dia treze do décimo segundo mês, chamado Adar."
,"13a":"Texto do decreto: «O Grande Rei Assuero, aos governadores das cento e vinte e sete províncias que vão da India até à Etiópia, e aos chefes de distrito, seus subordinados:"
,"13b":"Chefe de muitas nações e senhor de toda a Terra, eu procuro não embriagar-me com o orgulho do poder, mas governar com moderação e benevolência, a fim de que os meus súbditos gozem sempre de uma vida sem sobressaltos. Oferecendo os benefícios da civilização e a livre circulação dentro das nossas fronteiras, procuro estabelecer a paz, tão desejada por todos."
,"13c":"Consultei os meus conselheiros sobre como poderia atingir esse fim. Entre eles está Amã, que se distingue pela sua prudência, homem de dedicação sem igual, de fidelidade inabalável e comprovada, e cujas prerrogativas seguem imediatamente as do rei."
,"13d":"Amã informou-nos que entre todos os povos da Terra há um povo hostil, com regime jurídico oposto ao de todas as nações, povo que despreza continuamente as ordens reais, ao ponto de estorvar a política irrepreensível e recta que exercemos."
,"13e":"Portanto, considerando que esse povo singular, inimigo de todos e completamente diferente pela sua legislação, que é prejudicial aos nossos interesses, comete os piores crimes e chega a ameaçar a estabilidade do nosso reino:"
,"13f":"Ordenamos que no dia catorze do décimo segundo mês, que é Adar, do presente ano, todas as pessoas que forem nomeadas na carta de Amã, nosso chefe de governo, que é como nosso segundo pai, sejam completamente exterminadas com mulheres e crianças, pela espada de seus inimigos, sem piedade ou consideração alguma."
,"13g":"Deste modo, lançando violentamente na sepultura, num só dia, estes inimigos de ontem e de hoje, a nossa política poderá prosseguir no futuro com estabilidade e tranquilidade»."
,"14":"O texto do decreto, com força de lei para todas e cada uma das províncias, foi tornado público, a fim de que todos estivessem preparados para esse dia."
,"15":"Obedecendo ao rei, os correios partiram imediatamente. O decreto foi promulgado na fortaleza de Susa. E, enquanto o rei e Amã se banqueteavam, a cidade de Susa sentia-se perdida."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quando Mardoqueu soube do que estava a acontecer, rasgou as vestes, vestiu-se com pano de saco, pôs cinza na cabeça e saiu pela cidade, dando gritos de dor."
,"2":"Acabou por chegar à porta do palácio real, onde não se podia entrar vestido com pano de saco."
,"3":"Nas províncias, à medida que o decreto real era publicado, os judeus ficavam desolados: faziam jejum, choravam e ficavam de luto. O pano de saco e as cinzas tornaram-se a cama de muitos."
,"4":"As escravas e eunucos de Ester contaram-lhe tudo. A rainha ficou angustiada, e mandou roupas para que Mardoqueu se vestisse e tirasse o pano de saco. Mardoqueu, porém, não aceitou."
,"5":"Então Ester chamou Atac, um dos eunucos reais que a serviam, e mandou-o perguntar a Mardoqueu o que havia acontecido e por que motivo se comportava assim."
,"6":"Atac foi conversar com Mardoqueu, que se encontrava na praça, diante da porta do palácio."
,"7":"Mardoqueu contou-lhe o que havia acontecido. Informou-o de como Amã oferecera dinheiro para o tesouro real, em troca do extermínio dos judeus."
,"8":"Também lhe entregou uma cópia do decreto de extermínio, publicado em Susa. Pediu que o mostrasse a Ester e a informasse de tudo. Mandou que a rainha se apresentasse ao rei para interceder em favor do povo."
,"8a":"E dizia-lhe: «Lembra-te de quando eras pobre e eu te dava de comer. Amã, a segunda pessoa do reino, pediu ao rei a nossa morte."
,"8b":"Invoca o Senhor, fala ao rei em nosso favor, e livra-nos da morte»."
,"9":"Atac voltou e transmitiu a Ester tudo o que Mardoqueu lhe dissera."
,"10":"Então Ester mandou este recado a Mardoqueu:"
,"11":"«Os funcionários do rei e a gente das províncias do reino sabem que, por decreto real, qualquer homem ou mulher que se apresente ao rei no pátio interno, sem ter sido chamado, torna-se réu de morte, a menos que o rei lhe estenda o ceptro de ouro e lhe poupe a vida. Quanto a mim, há já um mês que não sou convidada a ir à presença do rei»."
,"12":"Mardoqueu recebeu o recado de Ester,"
,"13":"e respondeu: «Não penses que podes escapar com vida, só porque vives no palácio."
,"14":"Se te calares agora, a salvação e a libertação dos judeus virá de outro lugar, mas tu e a tua família morrereis. Quem sabe se não te tornaste rainha exactamente para esta ocasião?»"
,"15":"Então Ester mandou este recado a Mardoqueu:"
,"16":"«Reúne todos os judeus que vivem na cidade de Susa, e fazei jejum por mim. Não comais, nem bebais durante três dias e três noites. Eu e as minhas escravas também faremos jejum. Depois disso vou apresentar-me ao rei. Se for preciso morrer, morrerei»."
,"17":"Mardoqueu foi-se embora e fez o que Ester havia mandado."
,"17a":"Então, lembrando todas as façanhas do Senhor, Mardoqueu, rezou assim:"
,"17b":"«Senhor, Rei Todo-poderoso, tudo está debaixo do teu poder, e não há quem se oponha à tua vontade de salvar Israel."
,"17c":"Sim, Tu fizeste o Céu e a Terra e todas as maravilhas que estão debaixo do firmamento. Tu és o Senhor de todas as coisas, e não há quem Te possa resistir."
,"17d":"Tu conheces tudo! Se me nego a prostrar-me diante do soberbo Amã, Tu bem sabes, Senhor, que não é por arrogância, orgulho ou vaidade. Para salvar Israel, de boa vontade eu beijaria a planta dos seus pés!"
,"17e":"Procedi assim para não colocar a honra de um homem acima da glória de Deus. Eu não me prostro na frente de ninguém, a não ser diante de Ti, Senhor, e não faço isso por orgulho."
,"17f":"Pois bem, Senhor Deus, Rei, Deus de Abraão, poupa o teu povo, pois os nossos inimigos tramam a nossa morte e desejam aniquilar a tua antiga herança."
,"17g":"Não desprezes a porção que para Ti resgataste da terra do Egipto."
,"17h":"Ouve a minha súplica, tem piedade da tua herança e transforma o nosso luto em alegria, para que vivamos celebrando o teu Nome, Senhor. Não deixes emudecer a boca dos que Te louvam»."
,"17i":"E todos os israelitas clamavam a Deus com todas as forças, porque tinham a morte diante dos olhos."
,"17j":"Tomada de angústia mortal, a rainha Ester também procurou refúgio no Senhor. Tirou as vestes de luxo e vestiu-se com roupas de miséria e luto. Em lugar de perfumes finos, cobriu a cabeça com cinza e pó. Desfigurou-se completamente, e com os cabelos desgrenhados cobriu o corpo, que antes costumava enfeitar. E suplicou assim ao Senhor, o Deus de Israel:"
,"17l":"«Meu Senhor, nosso Rei, Tu és o único! Protege-me, porque estou só e não tenho outro defensor além de Ti, pois vou arriscar a minha vida."
,"17m":"Desde a infância aprendi com a minha família que Tu, Senhor, escolheste Israel entre todos os povos e os nossos pais entre todos os seus antepassados, para serem tua herança perpétua. E cumpriste o que lhes havias prometido."
,"17n":"Pecámos contra Ti, e entregaste-nos aos nossos inimigos, porque adorámos os seus deuses. Tu és justo, Senhor!"
,"17o":"Eles, porém, não se contentaram com a amargura da nossa escravidão. Comprometeram-se com os seus ídolos e juraram anular a palavra saída dos teus lábios e fazer desaparecer a tua herança e emudecer as bocas que Te louvam, para aniquilar o teu altar e a glória da tua casa."
,"17p":"Juraram abrir os lábios dos pagãos para que louvem os seus ídolos vazios e adorem eternamente um rei de carne."
,"17q":"Senhor, não entregues o teu ceptro a deuses que não existem. Que não se riam da nossa ruína. Volta os seus planos contra eles próprios, e que sirva de exemplo o primeiro que nos atacou."
,"17r":"Lembra-Te, Senhor, manifesta-Te a nós no dia da nossa tribulação. Quanto a mim, dá-me coragem, Rei dos deuses e Senhor dos poderosos."
,"17s":"Coloca na minha boca palavras certas, quando eu estiver diante do leão. Muda o seu coração para odiar o nosso inimigo, a fim de que pereça com todos os seus cúmplices."
,"17t":"Salva-nos com a tua mão e vem em meu auxílio, pois estou sozinha e só tenho a Ti, Senhor."
,"17u":"Tu conheces todas as coisas, sabes que odeio a glória dos ímpios, e que o leito dos incircuncisos e de qualquer estrangeiro me causa horror."
,"17v":"Tu conheces a minha angústia e sabes que detesto o sinal da minha grandeza, que levo na minha cabeça quando apareço em público. Eu detesto-o como trapo imundo, e não o uso fora das solenidades."
,"17x":"A tua serva não comeu à mesa de Amã, nem apreciou o banquete do rei, nem bebeu o vinho das libações."
,"17y":"A tua serva não se alegrou desde o dia em que mudou de condição até hoje, a não ser em Ti, Senhor, Deus de Abraão."
,"17z":"Ó Deus, mais forte que todos os poderosos, ouve a voz dos desesperados, liberta-nos da mão dos malfeitores, livra-me do medo!»"
}`)
	CurrentBook.AddChapter(5, `{
"1":"No terceiro dia, quando acabou de rezar, Ester tirou as vestes de luto e vestiu-se com as vestes de rainha."
,"1a":"Vestida com esplendor, invocou o Deus que cuida de todos e os salva. Tomou consigo duas escravas. Apoiava-se suavemente numa delas, com delicada elegância, enquanto a outra ia acompanhando e segurando a cauda do vestido."
,"1b":"No auge da beleza, Ester caminhava ruborizada, com o rosto alegre, como se ardesse de amor. O seu coração, porém, estava angustiado. {,I}1c Ultrapassando todas as portas, Ester encontrou-se na presença do rei. Ele estava sentado no trono real, vestido com os enfeites majestosos das suas aparições solenes, resplandecendo em ouro e pedras preciosas, e tinha um aspecto terrível. "
,"1d":"Ele ergueu o rosto incendiado de glória, dirigiu o seu olhar, cheio de cólera, à rainha que, ficando pálida, desmaiou e apoiou a cabeça na escrava que a seguia."
,"1e":"Deus, porém, tornou manso o coração do rei, que ansioso correu do trono e tomou Ester nos braços, até que ela se recuperasse, e reconfortou-a com palavras tranquilizadoras:"
,"1f":"«O que foi, Ester? Eu sou teu esposo. Coragem! Tu não vais morrer. A minha ordem é só para os súbditos. Aproxima-te»."
,"2":"Ergueu o ceptro de ouro, pousou-o no pescoço de Ester, beijou-a e pediu: «Fala comigo»."
,"2a":"Ester disse-lhe: «Senhor, eu vi-te como um anjo de Deus e fiquei com medo de tanto esplendor. Porque és, senhor, admirável e o teu rosto é fascinante»."
,"2b":"Enquanto falava, Ester desmaiou. O rei ficou perturbado e todos os cortesãos procuravam reanimá-la."
,"3":"O rei perguntou-lhe: «O que há, rainha Ester? Diz-me o que desejas, e eu dar-te-ei, nem que seja metade do meu reino»."
,"4":"Ester respondeu: «Se parecer bem ao rei, venha hoje com Amã ao banquete que para vós preparei»."
,"5":"O rei disse: «Mandai convocar imediatamente Amã, para fazer o que Ester deseja». O rei e Amã foram ao banquete preparado por Ester. "
,"6":"Enquanto bebiam vinho, o rei disse de novo a Ester: «Pede-me o que quiseres, e eu to darei. Mesmo que peças metade do meu reino, tê-la-ás»."
,"7":"Ester respondeu: «O meu pedido e o meu desejo é este:"
,"8":"se o rei quiser fazer-me um favor, se quiser ouvir o meu pedido e satisfazer o meu desejo, venha com Amã ao banquete que lhe vou preparar amanhã. Então lho direi»."
,"9":"Nesse dia, Amã saiu alegre e de bom humor. Mas, quando viu que Mardoqueu, à porta do palácio real, não se levantava nem se movia do lugar, ficou furioso contra Mardoqueu,"
,"10":"mas con-teve-se. Chegando a casa, chamou os seus amigos e Zares, sua mulher."
,"11":"Falou-lhes longamente do esplendor das suas riquezas, dos seus muitos filhos e de como o rei o tinha engrandecido, colocando-o acima dos seus altos funcionários e ministros."
,"12":"E acrescentou: «Além disso, a rainha Ester convidou-me somente a mim e ao rei para um banquete que ela ofereceu. E mais ainda: já estou de novo convidado para outro banquete com o rei, amanhã."
,"13":"Tudo isto, porém, não me satisfaz, enquanto eu continuar a ver o judeu Mardoqueu sentado à porta do palácio»."
,"14":"Então a sua mulher Zares e os seus amigos propuseram: «Manda preparar uma forca de vinte e cinco metros. De manhã pede ao rei que Mardoqueu seja nela enforcado. Depois poderás ir contente para o banquete». Amã gostou da proposta e mandou preparar a forca."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Nessa noite, o rei não conseguiu dormir. Então pediu que lhe trouxessem o livro dos Anais ou Crónicas. E leram-lho."
,"2":"Nele contava-se como Mardoqueu tinha denunciado Bagatã e Tares, funcionários do rei e guardas da porta que estavam a planear um atentado contra a vida de Assuero."
,"3":"E o rei perguntou: «Que prémio ou recompensa foi dada a esse Mardoqueu?» Os cortesãos que serviam o rei responderam: «Não lhe deram nada»."
,"4":"Então o rei perguntou: «Quem está no pátio?» Naquele momento Amã estava a chegar ao pátio externo do palácio, para pedir ao rei que mandasse enforcar Mardoqueu, na forca que ele havia preparado."
,"5":"Os cortesãos responderam: «É Amã quem está no pátio». O rei ordenou: «Mandai-o entrar»."
,"6":"Amã entrou, e o rei perguntou-lhe: «Como se deve tratar a um homem, a quem o rei quer honrar?» Amã pensou: «E quem é que o rei vai querer honrar, senão a mim?»"
,"7":"E respondeu: «Se o rei quer honrar alguém,"
,"8":"tomem-se vestes reais como as que o rei usa, traga-se o cavalo que o rei costuma montar, e coloque-se na cabeça dessa pessoa uma coroa real."
,"9":"Entreguem-se as vestes e o cavalo a um dos mais altos oficiais, e esse mesmo revestirá com essas vestes o homem a quem o rei quer honrar. Depois conduzirá o cavalo pela praça da cidade, gritando à sua frente: 'É assim que deve ser tratado o homem que o rei quer honrar'»."
,"10":"Então o rei disse a Amã: «Depressa. Toma as vestes e o cavalo e faz tudo isso que acabaste de dizer a Mardoqueu, o judeu funcionário da corte. Não omitas nenhum pormenor de tudo o que disseste»."
,"11":"Amã tomou as vestes e o cavalo, revestiu Mardoqueu e conduziu-o a cavalo pela praça da cidade, gritando à sua frente: «É assim que deve ser tratado o homem que o rei quer honrar»."
,"12":"Depois disto, Mardoqueu voltou para o seu posto no palácio, enquanto Amã corria para casa, enfurecido e cobrindo o rosto."
,"13":"Contou à sua mulher Zares e aos amigos tudo o que havia acontecido. Zares e seus amigos disseram-lhe: «Começaste a decair diante de Mardoqueu. Se ele é de raça judaica, não poderás nada contra ele. Pelo contrário, cairás completamente diante dele. Não poderás defender-te dele, porque o Deus vivo está com ele»."
,"14":"Ainda estavam a falar, quando chegaram os funcionários do rei e levaram imediatamente Amã para o banquete preparado por Ester."
}`)
	CurrentBook.AddChapter(7, `{
"1":"O rei e Amã foram ao banquete da rainha Ester."
,"2":"Neste segundo dia, enquanto bebiam vinho, o rei disse novamente a Ester: «Pede-me o que quiseres, rainha Ester, e eu to concederei. Qual é o teu pedido? Dar-te-ei até mesmo metade do meu reino»."
,"3":"A rainha Ester respondeu: «Se o rei quiser fazer-me um favor, se lhe parecer bem, o meu pedido é que me conceda a vida, e o meu desejo é a vida do meu povo."
,"4":"Porque eu e o meu povo fomos vendidos para sermos exterminados, mortos e aniquilados. Se nos tivessem vendido para sermos escravos e escravas, eu ficaria calada, pois tal desgraça não acarretaria prejuízo para o rei»."
,"5":"Então o rei perguntou à rainha Ester: «Quem é e onde está o homem que planeia fazer isso?»"
,"6":"Ester respondeu: «O perseguidor e inimigo é este perverso Amã». Então Amã ficou apavorado diante do rei e da rainha."
,"7":"Enfurecido, o rei levantou-se, deixou o banquete e foi para o jardim do palácio. Amã ficou ali, a implorar à rainha pela sua própria vida, pois compreen-dera que o rei já tinha decidido a sua desgraça."
,"8":"Quando o rei voltou do jardim do palácio para a sala do banquete, encontrou Amã caído sobre o divã, onde se encontrava Ester. E o rei gritou: «E tu ainda te atreves a violentar a rainha diante de mim, dentro do meu palácio!» O rei deu uma ordem, e imediatamente cobriram o rosto de Amã."
,"9":"Harbona, um dos eunucos, sugeriu ao rei: «Na casa de Amã há uma forca de vinte e cinco metros, que Amã tinha preparado para Mardoqueu, aquele que falou em defesa do rei». E o rei ordenou: «Enforcai nela Amã»."
,"10":"Então enforcaram Amã na forca que ele tinha preparado para Mardoqueu. E a ira do rei acalmou-se."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Nesse mesmo dia, o rei entregou à rainha Ester a casa de Amã, o perseguidor dos judeus. E Mardoqueu foi apresentado ao rei. Este já sabia, por meio de Ester, do parentesco que ele tinha com a rainha."
,"2":"O rei tirou o anel que tinha retomado a Amã e entregou-o a Mardoqueu. E Ester confiou a Mardoqueu a administração da casa de Amã."
,"3":"Ester tornou a falar com o rei. Caiu a seus pés e chorou, suplicando-lhe que anulasse o plano que Amã, o agagita, tinha maquinado contra os judeus."
,"4":"Quando o rei estendeu o ceptro de ouro a Ester, ela levantou-se e, de pé na presença do rei,"
,"5":"continuou: «Se lhe parecer bem, se o rei me quiser conceder, se o meu pedido lhe parecer justo e se está contente comigo, revogue por escrito o decreto que Amã, filho de Amadates, o agagita, mandou escrever para exterminar os judeus de todas as províncias reais."
,"6":"Como poderia eu contemplar a desgraça que atingiria o meu povo? Como poderia contemplar o extermínio da minha família?»"
,"7":"O rei Assuero respondeu à rainha Ester e ao judeu Mardoqueu: «Vós sabeis que dei a Ester a casa de Amã e que mandei enforcá-lo por atentar contra os judeus."
,"8":"Agora, em nome do rei, escrevei o que achardes melhor para os judeus, e lacrai o decreto com o anel do rei. Todo o decreto redigido em nome do rei e lacrado com o seu anel é irrevogável»."
,"9":"No dia vinte e três do terceiro mês, chamado Sivã, os escrivães do reino foram convocados e, exactamente como ordenou Mardoqueu, foi redigido um documento destinado aos judeus, aos sátrapas, governadores e chefes das províncias, para as cento e vinte e sete províncias, que se estendiam desde a Índia até à Etiópia. O documento foi mandado a cada província na escrita de cada uma e a cada povo na sua língua, e aos judeus no seu alfabeto e língua."
,"10":"Essas cartas, redigidas em nome do rei Assuero e lacradas com o selo real, foram levadas por correios montados em cavalos da estrebaria real."
,"11":"Nessas cartas o rei concedia aos judeus, em todas as cidades onde estivessem, o direito de se reunirem e defenderem, de exterminar, matar e aniquilar qualquer pessoa armada, de qualquer povo ou província, que os atacasse, inclusive mulheres e crianças, além do direito de lhes saquearem os bens."
,"12":"Isto aconteceria no mesmo dia, em todas as províncias do rei Assuero, isto é, no dia treze do décimo segundo mês, chamado Adar."
,"12a":"Texto do decreto:"
,"12b":"«O grande rei Assuero, aos sátrapas das cento e vinte e sete províncias, que se estendem da Índia à Etiópia, e aos que são fiéis aos nossos interesses. Saudações."
,"12c":"Muitos homens, quanto mais honrados pela suma generosidade dos benfeitores, mais se ensoberbecem e procuram não só prejudicar os nossos súbditos, mas, incapazes de moderar a própria soberba, tramam armadilhas contra os seus próprios benfeitores."
,"12d":"Não só anulam a gratuidade no meio dos homens, mas, embriagados pelo elogio de quem ignora o bem, orgulham-se de fugir de Deus, que tudo vê, e da sua justiça que odeia o mal."
,"12e":"De facto, muitas vezes, aconteceu que um mau conselho dessas pessoas, a quem foi confiado o controlo dos assuntos públicos, tornou muitos daqueles que detêm o poder corresponsáveis por acções sanguinárias reprováveis, provocando assim calamidades irremediáveis."
,"12f":"Com falsos raciocínios cheios de maldade, enganaram toda a boa fé dos soberanos."
,"12g":"É possível encontrar factos semelhantes, não só nas antigas histórias a que aludimos, mas também examinando as acções hoje realizadas pela baixeza daqueles que injustamente detêm o poder."
,"12h":"Para o futuro, será necessário assegurar, em favor de todos os homens, um reino pacífico e sem perturbações,"
,"12i":"fazendo mudanças oportunas e julgando com firmeza e equidade os casos que acontecem sob os nossos olhos."
,"12j":"Tal é o caso de Amã, um macedónio, filho de Amadates, na verdade um estrangeiro ao nosso sangue e muito longe da nossa bondade. Amã foi acolhido por nós com hospitalidade,"
,"12l":"usufruiu da amizade que dedicamos a todos os povos e chegou até a ser chamado «nosso pai» e ser reverenciado por todos com a prostração, como aquele que detém o segundo lugar junto do trono do rei."
,"12m":"Contudo, incapaz de conter o seu orgulho, Amã tramou privar-nos do poder e da vida."
,"12n":"Com falsos e subtis artifícios, ele pediu a pena de morte para Mardoqueu, o nosso salvador e benfeitor perpétuo, e também para Ester, nossa irrepreensível companheira no trono, juntamente com todo o seu povo."
,"12o":"Deste modo, ele pensava isolar-nos e passar o poder dos persas para os macedónios."
,"12p":"Nós, porém, achamos que os judeus, condenados ao extermínio por esse criminoso, não são malfeitores. Pelo contrário, eles vivem segundo leis justíssimas,"
,"12q":"são filhos do Deus Altíssimo, excelso e vivo, que, em nosso favor e dos nossos antepassados, dirige o reino do modo mais florescente."
,"12r":"Portanto fareis bem se não obedecerdes ao decreto enviado por Amã, filho de Amadates, porque o seu autor foi enforcado diante das portas de Susa, com toda a sua família. Deus, Senhor de todos os acontecimentos, fez recair imediatamente sobre ele o castigo que merecia."
,"12s":"Colocai em público cópias desta carta, e permiti que os judeus continuem a seguir livremente os seus costumes. Além disso, dai-lhes apoio para se defenderem de todos aqueles que os atacarem no dia da perseguição, isto é, no dia treze do décimo segundo mês, chamado Adar."
,"12t":"Porque Deus, Senhor de todas as coisas, transformou esse dia trágico em dia de alegria para o povo escolhido."
,"12u":"Quanto a vós, judeus, celebrai com toda a solenidade esse dia memorável, entre as vossas festas. Assim, hoje e no futuro, seja ele uma lembrança da salvação para nós e para os amigos dos persas, e uma lembrança da destruição para os nossos inimigos."
,"12v":"Toda a cidade e província que não seguir estas disposições, será devastada a ferro e fogo. Nenhum homem viverá nela e até os animais e pássaros a evitarão»."
,"13":"O texto do decreto, com força de lei para todas e cada uma das províncias, tornar-se-ia público, para que os judeus estivessem preparados, a fim de se vingarem dos seus inimigos nesse dia."
,"14":"Os correios montaram cavalos reais e partiram rapidamente para executarem a ordem do rei, enquanto o decreto era imediatamente promulgado na fortaleza de Susa."
,"15":"Mardoqueu saiu da presença do rei com vestes reais, de cor violeta e branca, uma grande coroa de ouro e um manto de linho e de púrpura vermelha. Toda a cidade de Susa saltava de alegria."
,"16":"Para os judeus foi um dia de luz e alegria, festa e triunfo."
,"17":"Em todas as províncias e em todas as cidades, aonde chegava a ordem do decreto real, os judeus alegravam-se com banquetes e festas. Muitos do país se tornaram judeus, porque o temor dos judeus caiu sobre eles."
}`)
	CurrentBook.AddChapter(9, `{
"1":"No dia treze do décimo segundo mês, chamado Adar, quando se devia executar o decreto do rei, no dia em que os inimigos dos judeus esperavam destruí-los, aconteceu o contrário: os judeus é que destruíram os seus inimigos."
,"2":"Os judeus concentraram-se nas suas cidades, em todas as províncias do rei Assuero, para atacar os que maquinavam a sua destruição. Ninguém lhes ofereceu resistência, porque o temor dos justos caiu sobre toda a população."
,"3":"Os chefes das províncias, os sátrapas, os governadores e funcionários reais apoiaram os judeus, porque tiveram medo de Mardoqueu."
,"4":"De facto, Mardoqueu ocupava um alto cargo no palácio, e a sua fama espalhava-se por todas as províncias. Mardoqueu tornava-se cada vez mais poderoso."
,"5":"Os judeus passaram a fio de espada todos os seus inimigos, matando e exterminando. Fizeram dos inimigos o que quiseram."
,"6":"Só na fortaleza de Susa, os judeus mataram e exterminaram quinhentos homens,"
,"7":"incluindo Farsandata, Delfon, Esfata,"
,"8":"Forata, Adalia, Aridata,"
,"9":"Fermesta, Arisai, Aridai, Jezata"
,"10":"e os dez filhos de Amã, filho de Amadates, o perseguidor dos judeus. Mas não praticaram o saque."
,"11":"No mesmo dia, comunicaram ao rei o número de vítimas na fortaleza de Susa."
,"12":"E o rei disse à rainha Ester: «Só na fortaleza de Susa, os judeus mataram e exterminaram quinhentos homens e os dez filhos de Amã. O que terão feito nas outras províncias do reino? Pede o que quiseres e dar-to-ei. Se queres mais alguma coisa, ser-te-á concedida»."
,"13":"Ester respondeu: «Se parecer bem ao rei, conceda que os judeus de Susa possam prorrogar o cumprimento do decreto até amanhã e que enforquem os cadáveres dos dez filhos de Amã»."
,"14":"O rei ordenou que assim fosse feito: prorrogou o decreto em Susa, e enforcaram os cadáveres dos dez filhos de Amã."
,"15":"Assim, os judeus de Susa concentraram-se também no dia catorze do mês de Adar e mataram mais trezentos homens, sem contudo praticar o saque."
,"16":"Os judeus das outras províncias do reino também se concentraram para se defender, eliminando os inimigos. Mataram setenta e cinco mil adversários, mas não praticaram o saque."
,"17":"Assim foi o dia treze do mês de Adar e no dia catorze descansaram, transformando-o em dia de festa."
,"18":"Os judeus de Susa reuniram-se nos dias treze e catorze; no dia quinze descansaram, transformando-o em dia de festa."
,"19":"É por isso que os judeus do campo, que vivem nas aldeias, fazem do dia catorze do mês de Adar um dia de alegria, banquete e festa, e trocam presentes."
,"19a":"Para os judeus das grandes cidades, o dia festivo é o dia quinze do mês de Adar, quando mandam presentes aos seus vizinhos."
,"20":"Mardoqueu registou por escrito todos estes acontecimentos. Depois mandou cartas a todos os judeus que viviam nas províncias do rei Assuero, próximas ou distantes,"
,"21":"ordenando-lhes que todos os anos celebrassem os dias catorze e quinze do mês de Adar,"
,"22":"porque nesses dias é que os judeus se livraram dos seus inimigos, e nesse mês a sua tristeza foi transformada em alegria e o seu luto em festa. Ele insistia para que os judeus festejassem esse dia, fazendo banquetes, trocando presentes e fazendo donativos aos pobres."
,"23":"Os judeus, que já haviam começado a praticar tudo isto, aceitaram o que Mardoqueu lhes pedia."
,"24":"De facto, Amã, filho de Amadates, o agagita, perseguidor de todos os judeus, tinha planeado a morte deles e lançado o «Pur», isto é, as sortes, para os eliminar e destruir."
,"25":"Mas quando Ester se apresentou ao rei, este ordenou, com documento escrito, que a perversa trama de Amã contra os judeus recaísse sobre ele próprio, e que ele e seus filhos fossem enforcados."
,"26":"Por isso, estes dias receberam o nome de «Purim», da palavra «pur». Conforme o texto desta carta, e de acordo com o que haviam presenciado e sabido por notícias,"
,"27":"os judeus assumiram para si próprios, para os seus descendentes e todos os que a eles se reunissem, o compromisso inviolável de todos os anos celebrarem estes dois dias, conforme este documento e nas datas fixadas."
,"28":"Estes dias são lembrados e celebrados de geração em geração, em cada família, província e cidade. São os dias dos «Purim», que nunca desaparecerão do meio dos judeus, e a sua lembrança jamais morrerá entre os seus descendentes."
,"29":"A rainha Ester, filha de Abiail, e o judeu Mardoqueu escreveram, exigindo o cumprimento da segunda carta sobre os dias dos «Purim»,"
,"30":"e enviaram cartas a todos os judeus das cento e vinte e sete províncias do reino de Assuero. Com palavras de paz e fidelidade,"
,"31":"ordenaram a observância destes dias dos «Purim» na data certa. Assim lhes ordenaram o judeu Mardoqueu e a rainha Ester, e os próprios judeus o assumiram para si e seus descendentes, acrescentando algumas cláusulas sobre jejuns e súplicas."
,"32":"Deste modo, o decreto de Ester fixou as normas para celebrar os dias dos «Purim», e ficou registado por escrito."
}`)
	CurrentBook.AddChapter(10, `{
"1":"O rei Assuero impôs tributo aos habitantes do continente e das ilhas."
,"2":"Acerca das suas vitórias militares e do relato pormenorizado da dignidade a que o rei elevou Mardoqueu, podem ser consultados os Anais do reino da Média e da Pérsia:"
,"3":"«O judeu Mardoqueu era o primeiro a seguir ao rei Assuero. Foi um homem considerado pelos judeus e amado pelos seus muitos compatriotas, porque procurava o bem do seu povo e se preocupava com a prosperidade da sua nação»."
,"3a":"Mardoqueu comentou: Estas coisas aconteceram por obra de Deus."
,"3b":"Lembro-me do sonho que tive sobre estes factos, e nenhum deles foi omitido:"
,"3c":"a pequena fonte que se torna rio, a luz que se levanta, o sol e a água abundante. O rio é Ester, que o rei desposou e constituiu rainha."
,"3d":"Os dois dragões, somos eu e Amã."
,"3e":"As nações são aquelas que se coligaram para destruir o nome dos judeus."
,"3f":"O meu povo é Israel, aqueles que invocaram a Deus e foram salvos. Sim, o Senhor salvou o seu povo, o Senhor libertou-nos de todos esses males. Deus realizou sinais e prodígios, como nunca houve entre as nações."
,"3g":"Por isso, Ele estabeleceu duas sortes: uma para o povo de Deus, e outra para as nações."
,"3h":"Essas duas sortes realizaram-se no devido momento e no dia estabelecido do julgamento diante de Deus, e em todas as nações."
,"3i":"Deus lembrou-Se do seu povo e fez justiça à sua herança."
,"3j":"Os dias catorze e quinze do mês de Adar serão celebrados com assembleia, alegria e contentamento diante de Deus, em Israel, seu povo, por todas as gerações e para sempre»."
,"31":"No quarto ano de Ptolomeu e de Cleópatra, Dositeu, sacerdote e levita, e seu filho Ptolomeu, trouxeram a presente carta sobre os «Purim». Eles consideraram-na autêntica e traduzida por Lisímaco, filho de Ptolomeu, que era da comunidade de Jerusalém."
}`)

}
func PT_BS_LoadVHIDChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Depois de Josué ter morrido, os israelitas consultaram Javé: «Quem de nós irá à frente para combater os cananeus?»"
,"2":"Javé respondeu: «Judá irá à frente, porque Eu entreguei a terra nas suas mãos»."
,"3":"Então Judá disse a seu irmão Simeão: «Vem comigo para a região que me coube por sorteio. Lutaremos contra os cananeus, e depois eu irei contigo até à região que te coube por sorteio». E Simeão foi com ele."
,"4":"Então Judá subiu, e Javé entregou-lhe os cananeus e ferezeus; derrotaram dez mil homens em Bezec."
,"5":"Quando derrotaram os cananeus e ferezeus, encontraram Adonibezec em Bezec, e lutaram contra ele."
,"6":"Adonibezec fugiu, mas eles perseguiram-no, apanharam-no e cortaram-lhe os polegares das mãos e dos pés."
,"7":"Adonibezec disse então: «Setenta reis, com os polegares cortados das mãos e dos pés, apanhavam as migalhas debaixo da minha mesa. Deus agora está a castigar-me por aquilo que eu mesmo fiz». E levaram Adonibezec para Jerusalém, onde morreu."
,"8":"Os descendentes de Judá atacaram Jerusalém e conquistaram-na. Mataram os habitantes a fio de espada e lançaram fogo à cidade."
,"9":"Em seguida, os descendentes de Judá desceram para atacar os cananeus que habitavam na região montanhosa, no Negueb e na planície."
,"10":"Judá também enfrentou os cananeus que moravam em Hebron, que antigamente se chamava Cariat-Arbe, e derrotou Sesai, Aimã e Tolmai."
,"11":"Dali, atacou os habitantes de Dafir, que antigamente se chamava Cariat-Seber."
,"12":"Caleb havia dito: «Darei como esposa a minha filha Acsa a quem tomar Cariat-Sefer de assalto»."
,"13":"Otoniel, filho de Cenez, irmão mais novo de Caleb, conquistou Cariat-Sefer, e Caleb deu-lhe a sua filha Acsa como esposa."
,"14":"No dia do casamento, Otoniel induziu Acsa a pedir um terreno ao pai. Ela então apeou-se do jumento, e Caleb perguntou-lhe: «Que queres?»"
,"15":"Ela respondeu: «Faz-me um favor. Deste-me terra árida; dá-me também alguma fonte de água». E Caleb deu-lhe as fontes de cima e as fontes de baixo."
,"16":"Os descendentes do sogro quenita de Moisés subiram da cidade das Palmeiras com os descendentes de Judá, foram para o deserto de Judá, ao Sul de Arad, e estabeleceram-se entre os amalecitas."
,"17":"Depois Judá acompanhou o seu irmão Simeão, e juntos derrotaram os cananeus que moravam em Sefat, e entregaram a cidade ao extermínio. Por isso a cidade ficou a chamar-se Horma."
,"18":"Judá tomou Gaza, Ascalon e Acaron, com os respectivos territórios."
,"19":"Javé estava com Judá, que expulsou os habitantes da região montanhosa, mas não conseguiu expulsar os habitantes da planície, porque estes possuíam carros de ferro."
,"20":"Conforme fora estabelecido por Moisés, Hebron foi dada a Caleb, que dali expulsou os três filhos de Enac."
,"21":"Os benjaminitas, porém, não expulsaram os jebuseus que habitavam em Jerusalém. Por isso os jebuseus habitam com os benjaminitas em Jerusalém até ao dia de hoje."
,"22":"Os da casa de José, por sua vez, subiram contra Betel, e Javé estava com eles."
,"23":"A casa de José mandou fazer um reconhecimento nas vizinhanças de Betel, cidade que antes se chamava Luza."
,"24":"Os espiões viram alguém a sair da cidade e disseram-lhe: «Mostra-nos por onde se entra na cidade, e poupar-te-emos a vida»."
,"25":"O homem mostrou-lhes por onde entrar na cidade. E eles passaram a cidade a fio de espada, mas pouparam esse homem e toda a sua família."
,"26":"Esse homem foi para a terra dos heteus e ali construiu uma cidade, à qual deu o nome de Luza. Esse é o seu nome até ao dia de hoje."
,"27":"Manassés não conseguiu expulsar os habitantes de Betsã, de Tanac, de Dor, de Jeblaam, de Meguido e dos respectivos arredores. E assim os cananeus continuaram a morar nessas regiões."
,"28":"Quando Israel se tornou mais forte, obrigou os cananeus a fazer trabalhos forçados, mas não conseguiu expulsá-los."
,"29":"Efraim também não conseguiu expulsar os cananeus que moravam em Gazer. E os cananeus continuaram a morar em Gazer, no meio de Efraim."
,"30":"Zabulon não conseguiu expulsar os habitantes de Cetron, nem os de Naalol. Por isso os cananeus continuaram no meio deles, embora submetidos a trabalhos forçados."
,"31":"Aser não conseguiu expulsar os habitantes de Aco, nem os de Sidónia, de Maaleb, de Aczib, de Helba, de Afec e de Roob."
,"32":"Os aseritas, portanto, ficaram a morar no meio dos cananeus da região, porque não conseguiram expulsá-los."
,"33":"Neftali não conseguiu expulsar os habitantes de Bet-Sames, nem os de Bet-Anat. Ficou a morar no meio dos cananeus da região, mas os habitantes de Bet-Sames e Bet-Anat serviam-nos com trabalhos forçados."
,"34":"Quanto aos danitas, os amorreus encurralaram-nos na região montanhosa, não lhes permitindo descer para o vale."
,"35":"Deste modo, os amorreus continuaram a morar em Ar-Hares, Aialon e Salebim. Mas quando a casa de José se fortaleceu, os amorreus foram submetidos a trabalhos forçados."
,"36":"O território dos edomitas estendia-se desde a subida dos Escorpiões e de Pedra para a frente."
}`)
	CurrentBook.AddChapter(2, `{
"1":"O anjo de Javé subiu de Guilgal para Betel, e disse: «Eu tirei-vos do Egipto e trouxe-vos para a terra que prometi aos vossos antepassados. Eu também tinha dito: 'Jamais romperei a minha aliança convosco,"
,"2":"contanto que não façais aliança com os habitantes desta terra, e destruais os seus altares'. Mas vós não me obedecestes. Porque fizestes assim?"
,"3":"Por isso, também Eu vos digo: 'Não expulsarei os cananeus diante de vós. Eles continuarão ao vosso lado, e os seus deuses serão uma armadilha para vós'»."
,"4":"Logo que o anjo de Javé disse tais palavras a todos os israelitas, o povo começou a chorar aos gritos."
,"5":"Por isso deram ao lugar o nome de Boquim. E ali ofereceram sacrifícios a Javé."
,"6":"Josué despediu o povo, e cada um dos israelitas foi tomar posse da propriedade que havia recebido como herança."
,"7":"O povo serviu a Javé durante todo o tempo que Josué viveu, e também durante toda a vida dos anciãos que continuaram vivos depois de Josué e que tinham visto todas as grandes obras que Javé tinha feito em favor de Israel."
,"8":"Josué, filho de Nun, servo de Javé, morreu com cento e dez anos."
,"9":"Foi sepultado no terreno da sua herança em Tamnat-Hares, na região montanhosa de Efraim, a Norte do monte Gaás."
,"10":"E toda essa geração foi também reunir-se com os seus antepassados. Veio depois outra geração que não conheceu Javé, nem as grandes obras que Ele tinha feito em favor de Israel. "
,"11":"Então os israelitas fizeram o que Javé reprova: prestaram culto aos ídolos,"
,"12":"abandonando Javé, Deus dos seus antepassados, que os tinha tirado do Egipto. Foram atrás de outros deuses, deuses de povos vizinhos, e adoraram-nos, provocando Javé."
,"13":"Abandonaram Javé e prestaram culto a Baal e a Astarte."
,"14":"A ira de Javé inflamou-se então contra Israel, e Ele entregou-os ao poder de assaltantes, que os despojaram e venderam aos inimigos vizinhos, de modo que os israelitas já não conseguiam resistir."
,"15":"Em qualquer coisa que realizavam, a mão de Javé estava contra eles, exactamente como Javé lhes tinha dito e jurado. E chegaram a uma situação desesperada."
,"16":"Então Javé fez surgir juízes que os libertavam dos assaltantes."
,"17":"No entanto, eles não davam ouvidos nem mesmo aos juízes. Pelo contrário, prostituíam-se com outros deuses e prostravam-se diante deles. Bem depressa se afastaram do caminho seguido pelos antepassados, que haviam obedecido aos mandamentos de Javé. Eles, porém, não agiram da mesma forma."
,"18":"Quando Javé lhes fazia surgir juízes, Javé estava com o juiz e libertava-os dos inimigos durante toda a vida do juiz. Javé compadecia-Se dos seus gemidos causados pela tirania dos opressores."
,"19":"No entanto, logo que o juiz morria, eles tornavam a corromper-se mais ainda que os seus antepassados, seguindo outros deuses, aos quais prestavam culto e diante deles se prostravam. Não desistiam das suas práticas, nem da sua conduta obstinada."
,"20":"Por isso, a ira de Javé inflamou-se contra Israel. E Javé declarou: «Já que esta gente violou a aliança que Eu fiz com os seus antepassados, e não Me obedeceu,"
,"21":"Eu também, por meu lado, não expulsarei da sua presença nenhuma das nações que Josué deixou ficar, quando morreu."
,"22":"Com essas nações Eu vou pôr Israel à prova, para ver se segue ou não o caminho de Javé, para ver se caminha por ele como os seus antepassados»."
,"23":"Foi por essa razão que Javé deixou ficar essas nações e não as expulsou nem as entregou a Josué."
}`)
	CurrentBook.AddChapter(3, `{
"1":"São estas as nações que Javé deixou ficar, para com elas provar os israelitas que não tinham conhecido as guerras de Canaã."
,"2":"(Foi para ensinar a estratégia militar para as novas gerações de israelitas, que não tinham experiência de guerra)."
,"3":"São estas as nações: os cinco principados filisteus, todos os cananeus, os sidónios, e também os heteus que habitam as montanhas do Líbano, desde o monte Baal-Hermon até à entrada de Emat."
,"4":"Estas nações serviram para provar Israel e ver se ele obedeceria aos mandamentos de Javé, promulgados aos seus antepassados por meio de Moisés."
,"5":"Assim, os israelitas viveram no meio dos cananeus, heteus, amorreus, ferezeus, heveus e jebuseus."
,"6":"Tomaram as filhas deles como esposas, deram-lhes as suas filhas em casamento, e prestaram culto aos seus deuses."
,"7":"Os israelitas fizeram o que Javé reprova: esqueceram-se de Javé seu Deus e serviram a Baal e Aserá."
,"8":"Então acendeu-se contra os israelitas a ira de Javé, que os entregou nas mãos de Cusã-Rasataim, rei de Aram Entre-Rios. E os israelitas ficaram submetidos a Cusã-Rasataim durante oito anos."
,"9":"Os israelitas clamaram por Javé. E Javé suscitou-lhes um salvador, que os libertou. Foi Otoniel, filho de Cenez, irmão mais novo de Caleb."
,"10":"O espírito de Javé esteve sobre Otoniel, que foi juiz em Israel. Ele saiu para a guerra, e Javé entregou em seu poder Cusã-Rasataim, rei de Aram. E ele triunfou sobre Cusã-Rasataim."
,"11":"A região ficou em paz durante quarenta anos. Depois Otoniel, filho de Cenez, morreu."
,"12":"Os israelitas tornaram a fazer o que Javé reprova. Então Javé fortaleceu Eglon, rei de Moab, contra os israelitas, porque faziam o que Javé reprova."
,"13":"Eglon aliou-se com os amonitas e amalecitas, e marchou contra Israel, derrotou-o e tomou-lhe a cidade das Palmeiras."
,"14":"Os israelitas tiveram que servir Eglon, rei de Moab, durante dezoito anos."
,"15":"Então eles clamaram por Javé, que lhes suscitou um salvador: Aod, filho de Gera, benjaminita, homem canhoto. Através dele, os israelitas mandaram um tributo a Eglon, rei de Moab."
,"16":"Aod mandou fazer um punhal de dois gumes, com um palmo de comprimento, e escondeu-o do lado direito, debaixo das roupas."
,"17":"Depois foi apresentar o tributo a Eglon, rei de Moab, que era homem muito gordo."
,"18":"Depois de entregar o tributo, Aod partiu com os carregadores."
,"19":"Ao chegar ao lugar chamado Ídolos, que fica perto de Guilgal, voltou e disse a Eglon: «Majestade, tenho uma mensagem secreta para te comunicar». O rei pediu que os deixassem a sós. E todos os que ali estavam se retiraram."
,"20":"Então Aod aproximou-se do rei, que estava sentado na sua sala particular de Verão, no andar superior, e disse-lhe: «Tenho uma mensagem de Deus para te comunicar». Quando o rei se levantou do trono,"
,"21":"Aod estendeu a mão esquerda, pegou no punhal do lado direito e enterrou-o na barriga de Eglon."
,"22":"Até o cabo entrou com a lâmina, e a gordura fechou-se por cima dela, porque Aod não retirou o punhal da barriga."
,"23":"Aod fugiu pela porta dos fundos, depois de trancar as portas da sala de cima."
,"24":"Logo que Aod saiu, chegaram os servos e, vendo que as portas da sala de cima estavam trancadas, pensaram: «Certamente ele está a fazer as suas necessidades na sala de Verão»."
,"25":"Esperaram bastante tempo, até que ficaram inquietos, pois o rei não abria as portas da sala de cima. Então pegaram na chave, abriram, e viram o seu senhor caído no chão e morto."
,"26":"Enquanto eles estavam à espera, Aod conseguiu escapar e, passando por Ídolos, refugiou-se em Seira."
,"27":"Logo que chegou, tocou a trombeta na região montanhosa de Efraim. E os israelitas desceram da região montanhosa, com Aod à frente."
,"28":"Aod disse-lhes então: «Segui-me, porque Javé entregou-vos os inimigos moabitas». Eles seguiram Aod, apoderaram-se dos vaus do Jordão para impedir a travessia dos moabitas, e não deixaram passar ninguém."
,"29":"Nessa ocasião, derrotaram cerca de dez mil moabitas, todos guerreiros, e ninguém escapou."
,"30":"Nesse dia, Moab foi dominado por Israel, e a região ficou em paz durante oitenta anos."
,"31":"Depois de Aod, veio Samgar, filho de Anat. Ele, com uma aguilhada, derrotou seiscentos filisteus. Também ele salvou Israel."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Depois de Aod ter morrido, os israelitas tornaram a fazer o que Javé reprova."
,"2":"E Javé entregou-os a Jabin, rei de Canaã, que reinava em Hasor. O general do exército era Sísara, e residia em Haroset-Goim."
,"3":"Os israelitas clamaram a Javé, porque Jabin tinha novecentos carros de ferro e oprimia-os duramente, havia vinte anos."
,"4":"Nesse tempo, era juiz em Israel a profetisa Débora, mulher de Lapidot."
,"5":"O seu tribunal ficava debaixo da palmeira de Débora, entre Ramá e Betel, nas montanhas de Efraim. E os israelitas procuravam-na para decidir as suas questões."
,"6":"Débora mandou chamar Barac, filho de Abinoem, que morava em Cedes de Neftali, e disse-lhe: «Javé, Deus de Israel, ordena que vás ao monte Tabor e reúnas dez mil homens das tribos de Neftali e Zabulon."
,"7":"Javé atrairá a ti, junto ao rio Quison, o chefe do exército de Jabin, Sísara, com os seus carros e as suas numerosas tropas, e entregar-to-á»."
,"8":"Barac respondeu: «Se fores comigo, eu vou. Se não fores, eu não vou»."
,"9":"Débora respondeu: «Está bem. Eu vou contigo. Mas a glória dessa expedição que vais realizar não será tua, pois Javé entregará Sísara nas mãos de uma mulher». E Débora dispôs-se para ir com Barac até Cedes."
,"10":"Barac convocou Zabulon e Neftali em Cedes: dez mil homens uniram-se a ele; e Débora também foi com ele."
,"11":"O quenita Héber tinha-se afastado da sua tribo, que era descendente de Hobab, sogro de Moisés, e tinha armado as suas tendas junto do carvalhal de Saananim, perto de Cedes."
,"12":"Informaram Sísara que Barac, filho de Abinoem, tinha subido ao monte Tabor."
,"13":"Então Sísara mobilizou os seus novecentos carros de ferro e toda a tropa de Haroset-Goim para ir ao rio Quison."
,"14":"Débora disse a Barac: «Vamos. Hoje mesmo Javé vai entregar Sísara em teu poder. Javé está marchando à tua frente». Barac desceu do monte Tabor com os seus dez mil homens."
,"15":"Javé derrotou Sísara com todos os seus carros e todo o seu exército, diante de Barac. Sísara teve que descer do carro e fugir a pé."
,"16":"Barac perseguiu o exército e os carros até Haroset-Goim. Todo o exército de Sísara caiu ao fio da espada, e nenhum homem conseguiu escapar."
,"17":"Entretanto, Sísara fugiu a pé até à tenda de Jael, mulher do quenita Héber, pois havia paz entre Jabin, rei de Hasor, e a família de Héber, o quenita."
,"18":"Jael saiu ao encontro de Sísara, e disse-lhe: «Entra, meu senhor. Entra sem medo, pois a casa é tua». Sísara entrou na tenda e Jael cobriu-o com um manto."
,"19":"Sísara pediu: «Dá-me um pouco de água para beber, pois estou com sede». Jael abriu uma vasilha com leite, deu-lhe de beber e cobriu-o."
,"20":"Sísara disse-lhe: «Fica à entrada da tenda. Se vier alguém e te perguntar se está alguém aqui dentro, dirás que não»."
,"21":"Mas Jael, mulher de Héber, tomou uma das estacas da tenda, pegou num martelo, aproximou-se na ponta dos pés e cravou a estaca nas têmporas de Sísara, até o pregar ao chão. E Sísara morreu, enquanto dormia profundamente, por causa do cansaço."
,"22":"Nesse momento, apareceu Barac, em perseguição de Sísara. Jael foi ao seu encontro, dizendo: «Vem comigo e mostrar-te-ei o homem que procuras». Barac entrou na tenda e viu Sísara caído e morto, com a estaca cravada nas têmporas."
,"23":"Naquele dia, Deus derrotou Jabin, rei de Canaã, diante dos israelitas."
,"24":"Estes tornaram-se cada vez mais fortes contra Jabin, rei de Canaã, até que o conseguiram eliminar."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Naquele dia, Débora e Barac, filho de Abinoem, entoaram este cântico:"
,"2":"Havia chefes em Israel,para assumir o comando; apresentaram-se voluntários,para se alistarem em massa. Bendizei todos a Javé!"
,"3":"Ouvi, ó reis! Escutai, ó governadores!,Eu vou cantar, cantar a Javé. Vou celebrar Javé, o Deus de Israel."
,"4":"Javé, quando saíste de Seir, avançando dos campos de Edom, a terra tremia, o céu ribombava,e as nuvens desfaziam-se em água;"
,"5":"os montes agitavam-se,diante de Javé, que vem do Sinai, diante de Javé, o Deus de Israel."
,"6":"No tempo de Samgar, filho de Anat, no tempo de Jael, as caravanas cessaram, os que viajavam seguiam por desvios,iam por caminhos tortuosos."
,"7":"Os camponeses saciaram-se. Em Israel saciaram-se com os despojos, quando tu, Débora, surgiste, quando tu, mãe de Israel, te levantaste."
,"8":"Os sacrifícios aos deuses cessaram, o pão faltou nos armazéns, sem que se visse escudo ou lança,entre os quarenta mil de Israel."
,"9":"O meu coração,está voltado,para os comandantes de Israel, para os voluntários do povo: bendizei todos a Javé!"
,"10":"Vós que montais jumentas brancas,e vos sentais em tapetes; vós que seguis pelos caminhos, cantai!"
,"11":"Juntai-vos ao grito dos homens,enfileirados entre os bebedouros. Ali eles celebram as vitórias de Javé, as vitórias dos camponeses em Israel, quando o povo de Javé,desceu às portas."
,"12":"Desperta, Débora, desperta!,Desperta e entoa um cântico. Vamos, Barac!,Vamos, filho de Abinoem!,Domina os que te haviam aprisionado."
,"13":"Então os sobreviventes,desceram com os nobres,e o povo de Javé ajudou-me,contra os poderosos."
,"14":"Os príncipes de Efraim estão no vale, e atrás de ti, com as tropas, vem Benjamim. De Maquir desceram os comandantes, e de Zabulon,os que trazem bastões de oficial."
,"15":"Os chefes de Issacar estão com Débora,e, no vale, também Barac,aperta o passo. Nos clãs de Rúben, os planos são grandes!"
,"16":"Porque ficaste sentado entre os currais, a escutar a flauta dos pastores?,Nos clãs de Rúben, os planos são grandes!"
,"17":"Galaad ficou do outro lado do Jordão, e Dã continua com os seus barcos. Aser permaneceu na orla do mar, e ficou junto às suas enseadas."
,"18":"Zabulon é um povo que arriscou,a vida, como Neftali em seus campos elevados!"
,"19":"Chegaram os reis,para o combate, os reis de Canaã combateram em Tanac, junto das águas de Meguido, mas nem sequer,uma peça de prata ganharam."
,"20":"Do alto céu as estrelas combateram, dos seus caminhos,lutaram contra Sísara."
,"21":"A torrente Quison arrastou-os, foi impetuosa a torrente Quison: a torrente esmagou os valentes."
,"22":"Os cascos dos cavalos martelaram, ao galope desenfreado dos corcéis."
,"23":"Amaldiçoai Meroz, amaldiçoai, diz o anjo de Javé; amaldiçoai os seus governantes, porque não auxiliaram Javé, não auxiliaram Javé,contra os poderosos."
,"24":"Que Jael seja bendita,entre as mulheres, a mulher de Héber, o quenita; bendita seja,entre as que habitam em tendas."
,"25":"Ele pediu água, ela deu-lhe leite; na taça dos nobres serviu-lhe coalhada."
,"26":"Com a esquerda tomou a estaca,e com a direita um martelo bem pesado; feriu Sísara, rachando-lhe a cabeça, e de um golpe atravessou-lhe,as têmporas."
,"27":"Ele encurvou-se entre os pés dela,e ficou estendido por terra; encurvou-se entre os pés dela e caiu; encurvado, ali mesmo caiu, e ficou aniquilado."
,"28":"A mãe de Sísara,olha pela janela,e lamenta-se por detrás da persiana: «Porque tarda em voltar o seu carro?,Porque são tão lentos os seus cavalos?»"
,"29":"A mais sábia das donzelas responde-lhe, e ela fica repetindo:"
,"30":"«Certamente encontraram despojos,e agora estão a reparti-los: uma ou duas mulheres,para cada guerreiro, e para Sísara panos coloridos, um despojo colorido e bordado; uma veste colorida e duas bordadas, e um despojo para o meu pescoço»."
,"31":"Deste modo pereçam,os teus inimigos, Javé, e os teus amigos sejam fortes,como o sol em seu fulgor. A região ficou em paz durante quarenta anos."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Os israelitas fizeram o que Javé reprova. E Javé entregou-os aos madianitas durante sete anos."
,"2":"O regime de Madiã foi tirânico sobre Israel. Para escapar de Madiã, os israelitas tiveram que usar as grutas nas montanhas, as cavernas e os esconderijos."
,"3":"Quando os israelitas semeavam, os madianitas, amalecitas e orientais atacavam-nos:"
,"4":"acampavam na terra dos israelitas e destruíam todos os produtos semeados até perto de Gaza. Não deixavam para Israel nenhum meio de sobrevivência, nenhum cordeiro, nenhum boi e nenhum jumento."
,"5":"Chegavam com os seus rebanhos e tendas, numerosos como gafanhotos, homens e camelos sem conta, invadindo e arrasando a terra."
,"6":"Deste modo, os madianitas reduziram Israel à miséria. Então os israelitas clamaram a Javé."
,"7":"Quando os israelitas clamaram a Javé por causa dos madianitas,"
,"8":"Javé enviou-lhes um profeta, que lhes falou deste modo: «Assim diz Javé, o Deus de Israel: Eu fiz-vos sair do Egipto e tirei-vos da casa da escravidão."
,"9":"Eu livrei-vos do poder egípcio e do poder daqueles que vos oprimiam. Eu expulsei-os diante de vós, e entreguei-vos a sua terra."
,"10":"Eu disse-vos: 'Eu sou Javé vosso Deus. Não tenhais medo dos deuses dos amorreus, em cuja terra ides morar'. Mas vós não Me ouvistes»."
,"11":"O anjo de Javé chegou e sentou-Se debaixo do carvalho que está em Efra, na propriedade de Joás, filho de Abiezer. Foi quando Gedeão, filho de Joás, estava a debulhar o trigo no lagar de pisar uvas, para o esconder dos madianitas."
,"12":"O anjo de Javé apareceu a Gedeão e disse-lhe: «Javé está contigo, valente guerreiro!»"
,"13":"Gedeão respondeu: «Meu Senhor, se Javé está connosco, porque nos aconteceu tudo isto? Onde estão as maravilhas de que os nossos antepassados falavam: 'Javé tirou-nos do Egipto...'? O facto é que agora Javé nos abandonou e nos entregou na mão dos madianitas»."
,"14":"Então Javé voltou-Se para Gedeão e disse: «Vai. Com as tuas próprias forças, salva Israel dos madianitas. Sou Eu que te envio»."
,"15":"Gedeão replicou: «Meu Senhor, como posso salvar Israel? O meu clã é o mais fraco da tribo de Manassés, e eu sou o mais novo da casa de meu pai!»"
,"16":"Javé disse-lhe: «Eu estarei contigo e tu derrotarás os madianitas como se fossem um só homem»."
,"17":"Gedeão insistiu: «Se alcancei o teu favor, dá-me um sinal de que és Tu quem fala comigo."
,"18":"Não Te vás embora antes que eu volte e Te faça uma oferta». Javé respondeu: «Ficarei aqui até que voltes»."
,"19":"Gedeão foi preparar um cabrito e fez pães sem fermento com uma medida de farinha. Colocou a carne numa cesta e o molho numa panela. Trouxe tudo e ofereceu-o a Javé, debaixo do carvalho."
,"20":"O anjo de Javé disse-lhe: «Toma a carne e os pães sem fermento, coloca-os sobre esta rocha, e derrama o molho por cima». Assim fez Gedeão."
,"21":"O anjo de Javé estendeu a ponta do bastão que tinha na mão, tocou na carne e nos pães sem fermento, e da rocha subiu um fogo que consumiu a carne e os pães. Nesse momento, o anjo de Javé desapareceu."
,"22":"Gedeão percebeu que era o anjo de Javé, e exclamou: «Ah! Meu Senhor Javé! Eu vi o anjo de Javé face a face!»"
,"23":"Javé respondeu-lhe: «Fica em paz e não tenhas medo, porque não morrerás»."
,"24":"Então Gedeão construiu ali um altar a Javé, e deu-lhe o nome de «Javé é Paz», um altar que existe em Efra de Abiezer, até ao dia de hoje."
,"25":"Nessa mesma noite, Javé disse a Gedeão: «Toma um boi do teu pai e outro boi de sete anos. Destrói o altar de Baal, que pertence a teu pai, e corta o poste sagrado que está ao lado."
,"26":"Em seguida, constrói um altar a Javé teu Deus no alto desse lugar, com pedras bem colocadas. Toma, então, o boi e oferece-o em holocausto sobre a lenha do poste sagrado que tiveres cortado»."
,"27":"Gedeão escolheu dez homens entre os seus servos, e fez o que Javé lhe havia mandado. Gedeão fez isso de noite e não de dia, pois tinha medo da sua família e do povo da cidade."
,"28":"No dia seguinte, bem cedo, o povo da cidade viu que o altar de Baal fora destruído, o poste sagrado que estava ao lado tinha sido cortado, e o boi fora sacrificado sobre o altar recém-construído."
,"29":"E comentaram: «Quem terá feito isto?» Perguntaram, fizeram averiguações e chegaram à conclusão: «Foi Gedeão, filho de Joás»."
,"30":"Os habitantes da cidade disseram então a Joás: «Entrega-nos o teu filho para que seja morto, pois ele destruiu o altar de Baal e cortou o poste sagrado que estava ao lado»."
,"31":"Joás respondeu a todos os que o ameaçavam: «Então vós tendes que defender Baal? Vós é que deveis ajudar Baal? Quem o defender, morrerá antes do nascer do sol. Se Baal é Deus, que se defenda, pois Gedeão é que destruiu o seu altar»."
,"32":"Nesse dia, puseram a Gedeão o apelido de Jerobaal, comentando: «Que Baal se defenda a si próprio, pois Gedeão destruiu o seu altar»."
,"33":"Os madianitas, amalecitas e orientais aliaram-se, atravessaram o rio Jordão e acamparam na planície de Jezrael."
,"34":"O espírito de Javé apoderou-se de Gedeão, que tocou a trombeta, e Abiezer juntou-se a ele."
,"35":"Gedeão mandou mensageiros a toda a tribo de Manassés, que se uniu a ele. Também enviou mensageiros a Aser, Zabulon e Neftali; e todos se aliaram a ele."
,"36":"Gedeão disse a Deus: «Se, de facto, Tu vais salvar Israel por meio de mim, como disseste,"
,"37":"vou colocar no terreiro um pedaço de lã de carneiro. Se o orvalho cair somente sobre o pedaço de lã, e o terreiro estiver seco, então ficarei a saber que Tu libertarás Israel por meio de mim, conforme disseste»."
,"38":"E assim fez Gedeão. Quando se levantou no dia seguinte, espremeu a lã, e com o orvalho que nela estava encheu um copo de água."
,"39":"Gedeão insistiu ainda com Deus: «Não Te irrites comigo se pedir mais uma vez. Permite que faça de novo a prova do pedaço de lã: que ele fique seco e a terra em volta se cubra de orvalho»."
,"40":"E Deus assim fez nessa noite: o pedaço de lã ficou seco, enquanto havia orvalho na terra em volta."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Jerobaal, que é Gedeão, madrugou e foi acampar junto a En-Harod com o povo que o acompanhava. O acampamento de Madiã ficava no vale ao Norte, junto à colina de Moré."
,"2":"Então Javé disse a Gedeão: «O povo que está contigo é numeroso de mais para que Eu entregue Madiã em teu poder. Israel poderia gloriar-se, dizendo: 'Eu consegui a vitória graças ao meu poder!'"
,"3":"Anuncia, portanto, a todo o povo: 'Quem estiver com medo e a tremer, pode voltar para trás'». E Gedeão pô-los à prova: vinte e dois mil homens voltaram para casa. E ainda ficaram dez mil."
,"4":"Javé disse a Gedeão: «Ainda é muita gente. Manda-os descer até à fonte, e ali farei uma escolha. A quem Eu disser que pode ir contigo, esse irá. Mas a quem eu disser que não pode ir contigo, esse não irá»."
,"5":"Gedeão mandou descer todo o povo até à beira da água, e Javé disse-lhe: «Todos os que beberem água com a língua, como faz o cão, colocá-los-ás de um lado; e os que se ajoelharem para beber, colocá-los-ás do outro lado»."
,"6":"Trezentos homens lamberam a água, levando as mãos à boca; os outros ajoelharam-se para beber."
,"7":"Então Javé disse a Gedeão: «Com os trezentos que lamberam a água, vou salvar-vos, entregando Madiã em teu poder. Os outros podem voltar para casa»."
,"8":"Eles pegaram nas provisões e nas trombetas, e Gedeão mandou regressar os israelitas, cada um para a sua tenda, ficando apenas com os trezentos homens. O acampamento de Madiã estava em baixo, no vale."
,"9":"Nessa noite, Javé disse a Gedeão: «Levanta-te e desce até ao acampamento inimigo, pois vou entregar-to."
,"10":"Se tens medo de descer, vai com o teu servo Fara."
,"11":"Quando ouvires o que eles dizem, ficarás animado e descerás para os atacar». E Gedeão foi com o seu servo Fara até à frente do acampamento."
,"12":"Os madianitas, amalecitas e orientais estavam deitados no vale. Eram numerosos como gafanhotos, e os seus camelos eram incontáveis como a areia da praia."
,"13":"Gedeão aproximou-se e ouviu um homem a contar um sonho ao companheiro: «Olha o que sonhei: um pão de cevada rolava no acampamento de Madiã, atingiu a tenda, chocou contra ela e fê-la cair por terra»."
,"14":"O companheiro respondeu: «Isso só pode ser a espada de Gedeão, filho de Joás, o israelita. Deus entregou Madiã e todo este acampamento nas suas mãos»."
,"15":"Quando Gedeão ouviu o sonho e a interpretação, prostrou-se por terra. Depois voltou ao acampamento israelita e disse: «Levantai-vos, porque Javé vos entrega o acampamento de Madiã»."
,"16":"Gedeão dividiu os trezentos homens em três grupos. Depois, a cada um distribuiu uma trombeta, um pote vazio e uma tocha dentro do pote,"
,"17":"dizendo: «Prestai atenção e fazei o que eu fizer. Quando eu chegar em frente do acampamento, fazei o que eu fizer."
,"18":"Eu e todos os que estão comigo vamos tocar a trombeta. Então, vós também tocareis as trombetas ao redor do acampamento, e gritareis: «Por Javé e por Gedeão!»"
,"19":"Gedeão e os cem homens que o acompanhavam chegaram em frente do acampamento ao render das sentinelas, à meia-noite. Quando se estava a fazer a troca da guarda, Gedeão tocou a trombeta e quebrou o pote que levava na mão."
,"20":"Nesse momento, os três grupos tocaram as trombetas e quebraram os potes. A seguir, levantaram a tocha na mão esquerda e a trombeta na direita, gritando: «Espada por Javé e por Gedeão!»"
,"21":"E ficaram parados, cada um no seu lugar, ao redor do acampamento. O acampamento inimigo ficou alvoroçado e começaram a gritar e a fugir."
,"22":"Enquanto os trezentos homens tocavam as trombetas, Javé fez com que no acampamento se matassem uns aos outros ao fio da espada. Depois fugiram até Bet-Seta, perto de Sartã, até junto de Abel-Meúla, perto de Tebat."
,"23":"Os israelitas de Neftali, de Aser e de todo o Manassés uniram-se e perseguiram Madiã."
,"24":"Gedeão tinha enviado mensageiros por todas as montanhas de Efraim, avisando: «Ocupai antes deles as fontes de água até Bet-Bera e o Jordão». Os efraimitas então reuniram-se e ocuparam as fontes de água até Bet-Bera e o Jordão."
,"25":"E prenderam Oreb e Zeb, os dois chefes dos madianitas. Mataram Oreb no rochedo de Oreb, e Zeb no lagar de pisar uvas de Zeb. Depois perseguiram os madianitas e levaram a Gedeão as cabeças de Oreb e Zeb, no outro lado do Jordão."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Os efraimitas queixaram-se a Gedeão: «Porque procedeste assim connosco? Porque não nos chamaste quando saíste para combater Madiã?» E discutiram violentamente com Gedeão."
,"2":"Ele, porém, respondeu: «Que fiz eu em comparação com o que vós me fizestes? Vale mais o restolho de Efraim do que a vindima de Abiezer!"
,"3":"Foi na vossa mão que Javé entregou Oreb e Zeb, os chefes de Madiã. Que fiz eu, em comparação com o que vós fizestes?» Ao ouvir isto, a ira dos efraimitas acalmou-se."
,"4":"Gedeão chegou ao rio Jordão e atravessou-o com os seus trezentos homens, já esgotados e famintos."
,"5":"Então Gedeão pediu ao povo de Sucot: «Por favor! Dai-me alguns pães para os homens que me acompanham pois estão cansados, e estou a perseguir Zebá e Sálmana, reis de Madiã»."
,"6":"As autoridades de Sucot perguntaram: «Porventura já prendestes Zebá e Sálmana para darmos comida ao vosso exército?»"
,"7":"Gedeão respondeu: «Muito bem. Quando Javé tiver entregue Zebá e Sálmana nas minhas mãos, vou rasgar-vos a carne com espinhos e cardos do deserto»."
,"8":"Depois, Gedeão subiu dali para Fanuel, e fez o mesmo pedido aos homens de Fanuel, que responderam como os de Sucot."
,"9":"Gedeão disse ao povo de Fanuel: «Quando eu voltar vitorioso, vou derrubar esta torre»."
,"10":"Zebá e Sálmana estavam em Carcar, com o seu exército, cerca de quinze mil homens. Era o que restava do exército dos orientais, pois as baixas tinham sido de cento e vinte mil homens."
,"11":"Gedeão subiu pela rota dos beduínos, a Leste de Nob e Jegbaá, e atacou o inimigo quando este menos esperava."
,"12":"Zebá e Sálmana fugiram, mas Gedeão perseguiu-os e capturou os dois reis de Madiã. O resto do exército debandou."
,"13":"Depois da batalha, Gedeão, filho de Joás, voltou pela encosta de Hares."
,"14":"Deteve um jovem de Sucot e perguntou-lhe o nome das autoridades e anciãos de Sucot. E o jovem deu por escrito o nome de setenta e sete homens."
,"15":"Gedeão, filho de Joás, dirigiu-se aos homens de Sucot e disse-lhes: «Aqui estão Zebá e Sálmana, a respeito dos quais zombastes de mim, dizendo: 'Porventura já prendestes Zebá e Sálmana para darmos comida aos vossos homens cansados'?»"
,"16":"Gedeão pegou nos anciãos da cidade e rasgou-lhes a carne com espinhos e cardos do deserto."
,"17":"Destruiu também a torre de Fanuel e massacrou os habitantes da cidade."
,"18":"Depois perguntou a Zebá e a Sálmana: «Como eram os homens que matastes no Tabor?» Eles responderam: «Eram como tu. Pareciam filhos de reis»."
,"19":"Gedeão exclamou: «Eram meus irmãos maternos! Pela vida de Javé, se os tivésseis deixado vivos, eu agora não vos mataria»."
,"20":"Então ordenou a Jeter, seu filho mais velho: «Vamos, mata-os». Mas o jovem não desembainhava a espada: era ainda muito novo e tinha medo."
,"21":"Zebá e Sálmana pediram: «Vamos, mata-nos tu, pois és um homem valente». Então Gedeão foi e matou Zebá e Sálmana, levando consigo os enfeites em forma de meia-lua que adornavam os seus camelos."
,"22":"Os israelitas disseram a Gedeão: «Sê nosso rei, e depois de ti o teu filho e o teu neto, pois nos salvaste dos madianitas»."
,"23":"Gedeão respondeu: «Nem eu, nem meu filho seremos vossos reis. O vosso rei será Javé»."
,"24":"E acrescentou: «Vou pedir-vos uma coisa: Cada um dê-me um anel da sua parte nos despojos». Os vencidos usavam anéis de ouro, porque eram ismaelitas."
,"25":"Eles responderam: «Dá-los-emos com prazer». Gedeão estendeu a capa, e cada um foi colocando um anel da sua parte nos despojos."
,"26":"O peso dos anéis que Gedeão pediu foi de dezanove quilos de ouro, sem contar os enfeites em forma de meia-lua, os brincos e as vestes de púrpura que os reis madianitas usavam, além dos colares dos camelos."
,"27":"Com tudo isto, Gedeão fez um efod e colocou-o na cidade de Efra. Todo o Israel ali se prostituiu, seguindo a Gedeão, e isso foi uma armadilha para Gedeão e sua família."
,"28":"Madiã foi derrotado diante dos israelitas e nunca mais levantou a cabeça. Deste modo, a região descansou quarenta anos, enquanto Gedeão viveu."
,"29":"E Jerobaal, filho de Joás, foi viver em sua casa."
,"30":"Gedeão teve setenta filhos, pois tinha muitas mulheres."
,"31":"Ele tinha uma concubina em Siquém, que lhe gerou um filho, a quem deu o nome de Abimelec."
,"32":"Gedeão, filho de Joás, morreu em velhice feliz, e enterraram-no na sepultura de seu pai, em Efra de Abiezer."
,"33":"Depois da morte de Gedeão, os israelitas voltaram a prostituir-se com os ídolos e tomaram Baal-Berit como deus."
,"34":"Os israelitas não se lembraram mais de Javé seu Deus, que os tinha livrado do poder de todos os inimigos vizinhos."
,"35":"Não se mostraram agradecidos à família de Jerobaal-Gedeão, por todo o bem que ele havia feito a Israel."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Abimelec, filho de Jerobaal, foi a Siquém para casa de seus tios maternos. E propôs o seguinte a eles e a todos os parentes do seu avô materno:"
,"2":"«Dizei aos senhores de Siquém: 'O que é melhor para vós? Que setenta homens, os filhos de Jerobaal, vos governem, ou que um só vos governe? E lembrai-vos de que eu sou do vosso mesmo sangue'»."
,"3":"Então os tios maternos de Abimelec comunicaram isto aos senhores de Siquém, e estes tomaram o partido de Abimelec, dizendo: «Ele é nosso parente»."
,"4":"Deram a Abimelec oitocentos gramas de prata do templo de Baal-Berit, e Abimelec usou esse dinheiro para contratar alguns homens ociosos e aventureiros, que se colocaram à sua disposição."
,"5":"Foi à casa de seu pai em Efra e matou sobre a mesma pedra os seus irmãos, os setenta filhos de Jerobaal. No entanto, Joatão, o filho mais novo de Jerobaal, escapou porque se havia escondido."
,"6":"Depois todos os senhores de Siquém e todos os de Bet-Melo se reuniram perto do carvalho da estela que está em Siquém, e proclamaram Abimelec como rei."
,"7":"Quando Joatão soube disso, subiu ao cimo do monte Garizim, e gritou: «Ouvi-me, senhores de Siquém, para que Deus também vos ouça."
,"8":"Certo dia, as árvores puseram-se a caminho para ungir um rei que reinasse sobre elas. Disseram à oliveira: 'Reina sobre nós'."
,"9":"A oliveira respondeu: 'Achais que vou deixar o meu azeite, que honra deuses e homens, para ficar balançando sobre as árvores'?"
,"10":"Então as árvores disseram à figueira: 'Vem tu, e reina sobre nós'."
,"11":"A figueira respondeu: 'Achais que vou deixar o meu doce fruto saboroso, para ficar balançando sobre as árvores?'"
,"12":"Então as árvores disseram à videira: 'Vem tu, e reina sobre nós'."
,"13":"A videira respondeu: 'Achais que vou deixar o meu vinho novo, que alegra deuses e homens, para ficar balançando sobre as árvores'?"
,"14":"Então todas as árvores disseram ao espinheiro: 'Vem tu, e reina sobre nós'."
,"15":"Então o espinheiro respondeu às árvores: 'Se quereis mesmo ungir-me para reinar sobre vós, vinde e abrigai-vos debaixo da minha sombra. Senão, sairá fogo do espinheiro e devorará os cedros do Líbano'."
,"16":"Pois bem! Será que procedestes com sinceridade e lealdade proclamando Abimelec como rei? Será que agistes bem com Jerobaal e a sua família? Será que vos comportastes com ele conforme os favores que ele vos fez?"
,"17":"O meu pai lutou por vós e até arriscou a vida para vos livrar do poder de Madiã."
,"18":"No entanto, hoje revoltastes-vos contra a família do meu pai, assassinastes sobre a mesma pedra os seus setenta filhos, e proclamastes rei dos senhores de Siquém esse Abimelec, filho de uma escrava do meu pai, com o pretexto de que ele é vosso parente."
,"19":"Muito bem! Se agistes com sinceridade e lealdade com Jerobaal e sua família, então fazei festa com Abimelec, e que ele festeje convosco."
,"20":"Caso contrário, que saia fogo de Abimelec e devore os senhores de Siquém e de Bet-Melo, e que saia fogo dos senhores de Siquém e de Bet-Melo e devore Abimelec»."
,"21":"Depois Joatão tornou a fugir e foi para Bera. Ali ficou, longe do seu irmão Abimelec."
,"22":"Abimelec governou Israel durante três anos."
,"23":"Depois disso, Deus enviou um espírito mau entre Abimelec e os senhores de Siquém, e estes traíram Abimelec."
,"24":"Deste modo, o assassinato dos setenta filhos de Jerobaal e o sangue deles caiu sobre Abimelec, que os havia assassinado, e sobre os senhores de Siquém, que tinham sido cúmplices no massacre."
,"25":"Os senhores de Siquém tinham armado emboscadas no alto dos montes e assaltavam todos os que passavam pelo caminho. E Abimelec foi informado disso."
,"26":"Gaal, filho de Obed, foi a Siquém com os seus irmãos e ganhou a confiança dos senhores de Siquém."
,"27":"Saíram ao campo para vindimar, pisaram as uvas e celebraram a festa. Foram ao templo do seu deus; ali comeram e beberam, amaldiçoando Abimelec."
,"28":"Gaal, filho de Obed, disse: «Quem é Abimelec e o que é Siquém, para ficarmos ao serviço deles? Acaso ele não é o filho de Jerobaal, e Zebul não é o governador deles? Que sirvam o povo de Hemor, pai de Siquém! Por que motivo deveríamos nós servir Abimelec?"
,"29":"Eu gostaria de ter poder sobre este povo. Então eu iria ter com Abimelec e dir-lhe-ia: 'Reforça o teu exército e vem para o combate!'»"
,"30":"Zebul, governador da cidade, ouviu o que havia dito Gaal, filho de Obed. Ficou cheio de raiva"
,"31":"e mandou secretamente mensageiros a Abimelec, avisando-o: «Gaal, filho de Obed, chegou com os seus irmãos a Siquém e estão a subverter a cidade contra ti."
,"32":"Vem de noite com a tua gente e fica de emboscada no campo."
,"33":"De manhãzinha, aparece e ataca a cidade. Quando Gaal e os que estão com ele saírem ao teu encontro, faz o que achares melhor»."
,"34":"Abimelec pôs-se a caminho de noite com a sua gente, e armaram uma emboscada diante de Siquém, divididos em quatro grupos."
,"35":"Gaal, filho de Obed, saiu e parou à porta da cidade. Então Abimelec, com a sua gente, saiu da emboscada."
,"36":"Vendo toda essa gente, Gaal disse a Zebul: «Vê! Há gente a descer do alto dos montes». Zebul respondeu: «O que estás a ver é a sombra dos montes, e pensas que é gente»."
,"37":"Gaal insistiu: «Há gente a descer do Umbigo da Terra, e mais um grupo vem pela estrada do carvalho dos Adivinhos»."
,"38":"Então Zebul disse-lhe: «Onde está agora essa boca que dizia: 'Quem é Abimelec, para que sejamos seus escravos?' São aqueles que desprezavas. Sai agora e luta contra eles»."
,"39":"Então Gaal saiu à frente dos senhores de Siquém e começou a lutar contra Abimelec."
,"40":"E Abimelec perseguiu-o. Gaal fugiu e muitos caíram mortos antes de chegar à porta da cidade."
,"41":"Abimelec voltou para Aruma, e Zebul expulsou, de Siquém, Gaal e os seus irmãos."
,"42":"No dia seguinte, o povo saiu para o campo, e Abimelec foi informado."
,"43":"Tomou então a sua gente, dividiu-a em três grupos, e pôs-se de emboscada no campo. Quando viu sair o povo da cidade, lançou-se ao ataque e massacrou-o."
,"44":"Abimelec e a sua gente avançaram e colocaram-se na entrada da porta da cidade, enquanto os outros dois grupos atacavam e massacravam os que tinham saído para o campo."
,"45":"Abimelec atacou a cidade o dia inteiro. Depois de a tomar, massacrou os habitantes, destruiu a cidade e espalhou sal sobre ela."
,"46":"Ao saber disso, todos os senhores da Torre de Siquém se refugiaram na cripta do templo de El-Berit."
,"47":"Quando Abimelec soube que todos os senhores da Torre de Siquém estavam reunidos,"
,"48":"subiu ao monte Selmon com toda a sua gente, pegou num machado, cortou um ramo de árvore, colocou-o aos ombros, e disse aos outros: «Depressa. Fazei a mesma coisa»."
,"49":"Cada um cortou um ramo de árvore e seguiu Abimelec. Amontoaram os ramos sobre a cripta e queimaram-nos sobre aqueles que ali estavam escondidos. Todos os habitantes da Torre de Siquém morreram, cerca de mil, entre homens e mulheres."
,"50":"Depois disto, Abimelec avançou contra Tebes, cercou-a e tomou-a."
,"51":"No centro da cidade havia uma torre fortificada, onde todos os homens, mulheres e senhores da cidade se refugiaram. Fecharam a porta e subiram ao terraço."
,"52":"Abimelec aproximou-se da torre, procurando assaltá-la. Quando chegou perto da porta para lhe atear fogo,"
,"53":"uma mulher lançou uma mó de moinho sobre a cabeça dele e fracturou-lhe o crânio."
,"54":"Abimelec chamou logo o escudeiro e disse: «Puxa da espada e mata-me, para não dizerem que uma mulher me matou». O escudeiro atravessou-o com a espada, e ele morreu."
,"55":"Quando os israelitas viram que Abimelec tinha morrido, voltou cada um para sua casa."
,"56":"Deste modo, Deus fez cair sobre Abimelec o mal que ele tinha feito a seu pai, massacrando os seus setenta irmãos."
,"57":"Do mesmo modo, Deus fez cair sobre os habitantes de Siquém todo o mal que haviam feito. E assim se cumpriu a maldição de Joatão, filho de Jerobaal."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Depois de Abimelec, surgiu Tola, filho de Fua, filho de Dodo, para livrar Israel. Ele era da tribo de Issacar e vivia em Samir, na região montanhosa de Efraim."
,"2":"Foi juiz em Israel durante vinte e três anos. Depois morreu, e foi sepultado em Samir."
,"3":"Depois de Tola, surgiu Jair de Galaad, que julgou Israel durante vinte e dois anos."
,"4":"Jair tinha trinta filhos, que montavam trinta jumentos, e possuíam trinta cidades, que ainda hoje se chamam Aldeias de Jair, em Galaad."
,"5":"Depois Jair morreu, e sepultaram-no em Camon."
,"6":"Os israelitas tornaram a fazer o que Javé reprova: prestaram culto a Baal e Astarte, e também aos deuses de Aram e de Sidónia, aos deuses de Moab e dos amonitas e filisteus. Abandonaram Javé, e já não Lhe prestavam culto."
,"7":"Então a ira de Javé inflamou-se contra Israel. E Javé entregou-o aos filisteus e amonitas,"
,"8":"que, a partir daquele momento, humilharam e oprimiram durante dezoito anos todos os israelitas que habitavam em Galaad, na Transjordânia, terra dos amorreus."
,"9":"Os amonitas atravessaram o Jordão, com intenção de lutar também contra Judá, Benjamim e a tribo de Efraim. E a situação de Israel chegou ao pior extremo."
,"10":"Então os israelitas clamaram a Javé: «Pecámos contra Ti. Abandonámos Javé, nosso Deus, para prestar culto aos ídolos»."
,"11":"Javé disse aos israelitas: «Porventura não vos libertei dos egípcios, amorreus, amonitas e filisteus?"
,"12":"Os sidónios, amalecitas e madianitas oprimiram-vos. Então clamastes a Mim, e Eu salvei-vos."
,"13":"No entanto, abandonastes-Me para servir a outros deuses. Por isso não vou mais salvar-vos."
,"14":"Ide clamar aos deuses que escolhestes. Eles que vos salvem na vossa angústia!»"
,"15":"Então os israelitas insistiram: «Nós pecámos. Faz de nós o que achares melhor, mas liberta-nos hoje»."
,"16":"Eles deixaram os deuses estrangeiros e prestaram culto a Javé. E Javé não pôde mais suportar o sofrimento de Israel."
,"17":"Os amonitas reuniram-se e acamparam em Galaad. Os israelitas também se reuniram e acamparam em Masfa."
,"18":"Então o povo e os chefes de Galaad comentaram: «Quem tiver coragem de atacar os amonitas é que vai ser o chefe de todos os habitantes de Galaad»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jefté, o galaadita, era um guerreiro valente, filho de Galaad e de uma prostituta."
,"2":"Galaad teve outros filhos com a sua esposa legítima. E quando cresceram, expulsaram Jefté, dizendo: «Tu não podes participar da herança do nosso pai, porque és filho de outra mulher»."
,"3":"Jefté fugiu para longe dos irmãos e estabeleceu-se na terra de Tob. Ali reuniu um grupo de ociosos, que andavam com ele."
,"4":"Algum tempo depois, os amonitas declararam guerra a Israel."
,"5":"Quando os amonitas começaram a atacar Israel, os anciãos de Galaad foram procurar Jefté, na terra de Tob,"
,"6":"e disseram-lhe: «Vem, sê o nosso comandante na guerra contra os amonitas»."
,"7":"Jefté, porém, respondeu: «Vós odiastes-me e expulsastes-me da casa de meu pai. Porque vindes procurar-me na hora do aperto?»"
,"8":"Os anciãos de Galaad disseram a Jefté: «Pois é. Agora vimos procurar-te, para que venhas lutar connosco contra os amonitas. Serás o nosso chefe e também o de todos os habitantes de Galaad»."
,"9":"Jefté respondeu aos anciãos: «Quereis que eu volte para lutar contra os amonitas? Pois bem! Se Javé os entregar na minha mão, então serei o vosso chefe»."
,"10":"Os anciãos de Galaad disseram a Jefté: «Que Javé nos castigue, se não fizermos o que agora dizes»."
,"11":"Então Jefté foi com os anciãos de Galaad. O povo nomeou-o chefe e comandante, e Jefté prestou juramento em Masfa, na presença de Javé."
,"12":"Jefté enviou emissários ao rei dos amonitas, com a seguinte mensagem: «O que foi que eu fiz, para vires atacar a minha terra?»"
,"13":"O rei dos amonitas respondeu aos emissários de Jefté: «Quando Israel veio do Egipto apoderou-se da minha terra, desde o rio Arnon até ao Jaboc e ao Jordão. Devolve-me agora, em paz, o que me tomaste»."
,"14":"Jefté enviou novamente emissários ao rei dos amonitas"
,"15":"com esta mensagem: «Assim diz Jefté: Os israelitas não se apoderaram do país de Moab, nem do país de Amon."
,"16":"Quando Israel veio do Egipto, caminhou pelo deserto até ao Mar Vermelho, e chegou a Cades."
,"17":"Então Israel enviou emissários ao rei de Edom, pedindo para atravessar o país. Mas o rei de Edom não fez caso. Israel enviou também emissários ao rei de Moab e também este não fez caso. Então Israel ficou em Cades,"
,"18":"e depois seguiu pelo deserto, contornou o país de Edom e de Moab, chegou à parte oriental de Moab e acampou no outro lado do rio Arnon, sem violar a fronteira, porque o Arnon é a fronteira de Moab."
,"19":"Em seguida, Israel enviou emissários a Seon, rei dos amorreus, que reinava em Hesebon, pedindo que os deixasse atravessar o seu território, para chegar ao próprio destino."
,"20":"Seon, porém, recusou, não acreditando no pedido de Israel para lhe atravessar a fronteira, e reuniu o seu exército, acampou em Jasa, e atacou Israel."
,"21":"Javé, Deus de Israel, entregou Seon e o seu exército nas mãos de Israel, que os derrotou e tomou posse da terra dos amorreus que habitavam nessa região."
,"22":"Foi assim que Israel tomou posse da região dos amorreus, desde o Arnon até ao Jaboc, e desde o deserto até ao Jordão."
,"23":"Pois bem! Se Javé, Deus de Israel, expulsou os amorreus diante do seu povo Israel, serás tu agora quem nos vai expulsar?"
,"24":"Tu possuis tudo o que o teu deus Camos te deu. E nós possuímos o que Javé nosso Deus tomou aos seus possuidores."
,"25":"Serás tu melhor do que Balac, filho de Sefor, rei de Moab? Ele atreveu-se a lutar contra Israel? Ele declarou guerra a Israel?"
,"26":"Há trezentos anos atrás, Israel estabeleceu-se em Hesebon e arredores, em Aroer e arredores, e em todas as cidades que estão ao longo do rio Arnon. Porque a não tomaste durante todo esse tempo?"
,"27":"Vê bem. Eu não te ofendi. Tu é que agiste mal, declarando guerra contra mim. Que Javé, o Juiz, julgue entre israelitas e amonitas»."
,"28":"Todavia, o rei dos amonitas não fez caso da mensagem de Jefté."
,"29":"Então o espírito de Javé desceu sobre Jefté, que atravessou o território de Galaad e Manassés, passou por Masfa e Galaad, e dali marchou contra os amonitas."
,"30":"E Jefté fez uma promessa a Javé: «Se entregares os amonitas nas minhas mãos,"
,"31":"então, quando eu voltar vitorioso da guerra contra eles, a primeira pessoa que sair para me receber à porta de casa, pertencerá a Javé, e eu a oferecerei em holocausto»."
,"32":"Jefté partiu para guerrear contra os amonitas, e Javé entregou-os em seu poder."
,"33":"Jefté derrotou-os desde Aroer até Menit, tomando vinte cidades, e foi até Abel-Carmim. Foi uma grande derrota, e os amonitas foram dominados pelos israelitas."
,"34":"Jefté voltou para sua casa em Masfa. E foi precisamente a sua filha quem saiu para o receber, dançando ao som de tamborins. Era sua filha única, pois Jefté não tinha outros filhos ou filhas."
,"35":"Logo que viu a filha, Jefté rasgou as vestes, e gritou: «Ai, minha filha, como sou infeliz! Tu és a minha desgraça, porque eu fiz uma promessa a Javé e não posso voltar atrás»."
,"36":"Ela respondeu: «Pai, se fizeste promessa a Javé, cumpre o que prometeste, porque Javé te concedeu vingares-te dos inimigos»."
,"37":"E pediu ao pai: «Concede-me apenas isto: deixa-me andar dois meses pelos montes, chorando com as minhas amigas, porque vou morrer virgem»."
,"38":"Jefté disse-lhe: «Vai». E deixou-a andar durante dois meses. Ela foi pelos montes com as suas amigas, chorando porque ia morrer virgem."
,"39":"Dois meses depois, ela voltou para casa, e o seu pai cumpriu a promessa que tinha feito. A jovem era virgem. Daí começou um costume em Israel:"
,"40":"todos os anos as jovens israelitas saem durante quatro dias para chorar a filha de Jefté, o galaadita."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Os efraimitas reuniram-se, atravessaram o Jordão a caminho do Norte, e perguntaram a Jefté: «Porque fizeste guerra contra os amonitas, sem nos convidares para irmos contigo? Vamos queimar a tua casa contigo lá dentro»."
,"2":"Jefté respondeu: «Eu e o meu povo tivemos um grande conflito com os amonitas. Pedi-vos ajuda e vós negastes-ma."
,"3":"Quando vi que ninguém aparecia para me ajudar, arrisquei a vida, marchei contra os amonitas e Javé entregou-os em meu poder. Porque é que vindes hoje contra mim?»"
,"4":"Então Jefté reuniu os galaaditas e atacou os efraimitas. Os efraimitas foram derrotados, porque diziam: «Vós, galaaditas, sois fugitivos de Efraim, pois Galaad fica entre Efraim e Manassés»."
,"5":"E os galaaditas ocuparam os vaus do Jordão, cortando a passagem de Efraim. Quando os efraimitas fugitivos pediam para passar, os galaaditas perguntavam: «Tu és efraimita?»"
,"6":"Se ele dizia que não, eles pediam: «Então diz Chibôlet». Ele dizia Cibôlet, porque não conseguia pronunciar de outro modo. Então agarravam-no e matavam-no nos vaus do Jordão. Naquele tempo, foram mortos quarenta e dois mil efraimitas."
,"7":"Jefté foi juiz em Israel durante seis anos. Depois morreu e foi sepultado na sua cidade, em Galaad."
,"8":"Depois de Jefté, o juiz em Israel foi Abesã, de Belém."
,"9":"Ele teve trinta filhos e trinta filhas. Casou as filhas fora, e trouxe de fora trinta mulheres para os seus filhos. Foi juiz em Israel durante sete anos."
,"10":"Depois morreu e foi sepultado em Belém."
,"11":"Depois de Abesã, o juiz em Israel foi Elon, de Zabulon. Foi juiz em Israel durante dez anos."
,"12":"Depois morreu e foi sepultado em Aialon, na terra de Zabulon."
,"13":"Depois de Elon, o juiz em Israel foi Abdon, filho de Ilel de Faraton."
,"14":"Ele teve quarenta filhos e trinta netos, que montavam setenta jumentos. Foi juiz em Israel durante oito anos."
,"15":"Depois morreu e foi sepultado em Faraton, na terra de Efraim, na região montanhosa dos amalecitas."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Os israelitas tornaram a fazer o que Javé reprova. E Javé entregou-os aos filisteus durante quarenta anos."
,"2":"Havia um homem de Saraá, do clã de Dã, que se chamava Manué. A sua mulher era estéril e não tinha filhos."
,"3":"O anjo de Javé apareceu à mulher e disse-lhe: «És estéril e não tens filhos, mas ficarás grávida e darás à luz um filho."
,"4":"Toma cuidado: não bebas vinho, nem qualquer outra bebida alcoólica, e não comas nada que seja impuro,"
,"5":"porque ficarás grávida e darás à luz um filho. A navalha não será passada sobre a cabeça do menino, porque desde o seio da mãe ele será consagrado a Deus. É ele quem começará a salvar Israel do poder dos filisteus»."
,"6":"A mulher foi falar assim ao marido: «Um homem de Deus veio visitar-me. Pela sua aparência majestosa, parecia um anjo de Deus. Eu não perguntei de onde ele vinha, nem ele me disse o seu nome."
,"7":"Ele só me disse o seguinte: 'Ficarás grávida e darás à luz um filho; toma cuidado em não beber vinho, nem qualquer outra bebida alcoólica, e não comas nada que seja impuro, porque o menino será consagrado a Deus, desde o seio de sua mãe até ao dia da sua morte'»."
,"8":"Então Manué rezou a Javé: «Eu Te peço, Senhor: que o homem de Deus que enviaste, volte e nos diga o que devemos fazer com o menino, quando ele nascer»."
,"9":"Deus ouviu a oração de Manué, e o anjo de Deus apareceu outra vez à mulher, quando ela estava no campo. O seu marido Manué não estava com ela."
,"10":"A mulher correu a avisar o marido: «O homem que me visitou no outro dia, voltou»."
,"11":"Manué seguiu a mulher e foi perguntar ao homem: «Foste tu que falaste com esta mulher?» Ele respondeu: «Sim. Fui eu mesmo»."
,"12":"Manué disse: «Quando se realizar a tua palavra, como será o comportamento do menino? O que é que ele deve fazer?»"
,"13":"O anjo de Javé respondeu a Manué: «A mulher não poderá fazer nada daquilo que lhe foi proibido:"
,"14":"não colocará na boca nada que seja feito de uva, não beberá vinho nem bebidas alcoólicas e não comerá nenhuma coisa impura. Ela deve observar tudo o que eu mandei»."
,"15":"Manué disse ao anjo de Javé: «Fica connosco, que vamos preparar-te um cabrito»."
,"16":"O anjo de Javé respondeu a Manué: «Mesmo que eu fique, não provarei a tua comida. Mas, se quiseres, prepara um holocausto e oferece-o a Javé». Manué não tinha percebido que aquele homem era o anjo de Javé."
,"17":"E Manué perguntou: «Qual é o teu nome, para que possamos agradecer-te quando as tuas palavras se realizarem?»"
,"18":"O anjo de Javé retrucou: «Porque queres saber o meu nome? Ele é misterioso»."
,"19":"Então Manué tomou o cabrito e a oferta, e ofereceu-o sobre a rocha em holocausto a Javé, que realiza coisas misteriosas. Manué e sua mulher ficaram a observar."
,"20":"Quando a chama do altar subiu para o céu, o anjo de Javé também subiu na chama. Vendo isto, Manué e sua mulher caíram com o rosto no chão."
,"21":"O anjo de Javé não apareceu mais, nem a Manué nem à sua mulher. Então Manué entendeu que era o anjo de Javé."
,"22":"Ele disse à sua mulher: «Certamente morreremos, porque vimos a Deus»."
,"23":"A mulher respondeu: «Se Javé nos quisesse matar, não teria aceite o holocausto e a oferta, não nos teria mostrado tudo o que vimos, nem nos teria comunicado estas coisas»."
,"24":"A mulher deu à luz um filho e deu-lhe o nome de Sansão. O menino cresceu e Javé abençoou-o."
,"25":"E o espírito de Javé começou a agitar Sansão no Acampamento de Dã, entre Saraá e Estaol."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sansão desceu a Tamna, e viu ali uma jovem filisteia."
,"2":"Quando voltou, disse a seus pais: «Eu vi uma jovem filisteia em Tamna. Pedi-a para que seja minha esposa»."
,"3":"Os seus pais responderam: «Será que não existe mulher nenhuma entre os teus parentes e no meio de todo o nosso povo, para te quereres casar com uma mulher desses filisteus incircuncisos?» Sansão insistiu com o pai: «Pede-a para que seja minha esposa, pois é dela que eu gosto»."
,"4":"Os seus pais não sabiam que era Javé quem fazia isso, buscando um pretexto contra os filisteus, porque nessa época os filisteus dominavam Israel."
,"5":"Sansão desceu a Tamna. Chegando perto dos vinhedos de Tamna, viu um leãozinho que vinha rugindo ao seu encontro."
,"6":"O espírito de Javé desceu sobre Sansão, e ele, sem ter nada nas mãos, despedaçou o leãozinho, como se despedaça um cabrito. Sansão, porém, não contou nada a seus pais."
,"7":"Ele desceu a Tamna, falou com a jovem e ficou a gostar dela."
,"8":"Algum tempo depois, quando ia para se casar com ela, desviou-se do caminho para ver o leão morto. Encontrou um enxame de abelhas com mel, na carcaça do leão."
,"9":"Recolheu o mel na mão e foi comendo pelo caminho. Quando alcançou os seus pais, deu-lhes mel, e eles comeram. Sansão, porém, não lhes disse que tinha tirado o mel da carcaça do leão."
,"10":"Desceu até à casa da jovem e ali ofereceu um banquete, como os jovens costumam fazer."
,"11":"Logo que o viram, escolheram trinta companheiros para ficarem com ele."
,"12":"Sansão disse aos companheiros: «Vou propor-vos uma adivinha. Se acertardes a resposta durante os sete dias do banquete, dar-vos-ei trinta peças de linho e trinta trajes."
,"13":"Mas se não adivinhardes a resposta, vós é que me deveis dar trinta peças de linho e trinta trajes de festa». Eles disseram: «Vamos lá. Qual é a adivinha?»"
,"14":"Sansão propôs: «Do que come saiu comida, e do forte saiu doçura». Três dias depois, eles ainda não tinham adivinhado a resposta."
,"15":"No quarto dia, disseram à mulher de Sansão: «Convence o teu marido a dizer a resposta da adivinha. Senão, nós vamos queimar-te a ti e à casa de teu pai. Ou será que nos convidaste só para nos deixares sem nada?»"
,"16":"A mulher de Sansão foi e dizia, a chorar no ombro dele: «Tu não me amas. O que sentes por mim é ódio. Propuseste uma adivinha para os homens do meu povo, e não me dizes qual é a resposta!» Sansão respondeu: «Nem aos meus pais eu a disse; por que razão iria dizer-ta a ti?»"
,"17":"No entanto, ela chorou no ombro dele durante os sete dias do banquete. Importunava tanto que, no sétimo dia, Sansão acabou por lhe dizer a resposta. E ela foi contar aos homens do seu povo."
,"18":"No sétimo dia, antes que Sansão fosse para o quarto de dormir, os homens da cidade chegaram e disseram: «O que é mais doce do que o mel, e o que é mais forte do que o leão?» Sansão replicou: «Se não tivésseis arado com a minha novilha, não teríeis acertado com a adivinha»."
,"19":"Então o espírito de Javé desceu sobre Sansão e apossou-se dele. Ele foi até Ascalon, matou trinta homens, tirou-lhes as roupas e deu-as aos que tinham adivinhado a resposta. Depois, cheio de raiva, voltou para casa do pai."
,"20":"A sua mulher foi então dada a um dos companheiros que haviam cuidado dele."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Algum tempo depois, durante a colheita do trigo, Sansão foi visitar a sua mulher, levando-lhe um cabrito, e pensando: «Vou entrar no quarto da minha mulher». Mas o sogro não o deixou entrar, e disse:"
,"2":"«Julguei que já não gostavas dela, e por isso dei-a a um dos teus companheiros. Mas olha que a irmã mais nova é mais bonita! Fica com ela em lugar da outra»."
,"3":"Sansão, porém, replicou: «Desta vez não sou culpado do mal que vou fazer aos filisteus»."
,"4":"Então Sansão foi, apanhou trezentas raposas, preparou tochas, prendeu as raposas duas a duas pelas caudas, e nelas amarrou as tochas."
,"5":"Depois ateou fogo às tochas e soltou as raposas no meio das searas dos filisteus. Deste modo, queimou não só os feixes de trigo já ceifado, mas também o que ainda estava por ceifar, e até as vinhas e olivais."
,"6":"Os filisteus perguntaram: «Quem foi que fez isto?» Responderam: «Foi Sansão, o genro do homem de Tamna. Ele fez isto porque o sogro lhe tirou a mulher e a deu a um seu companheiro». Então os filisteus subiram e deitaram fogo à mulher e à casa de seu pai."
,"7":"Sansão disse aos filisteus: «Já que fizestes isso, não vou parar, enquanto não me vingar de vós»."
,"8":"E caiu sobre eles, fazendo um massacre terrível. Depois foi para a gruta do rochedo de Etam e ficou a morar lá."
,"9":"Os filisteus subiram e acamparam contra Judá, saindo para atacar na região de Queixada."
,"10":"Os habitantes de Judá protestaram: «Por que motivo viestes contra nós?» Os filisteus responderam: «Estamos aqui para prender Sansão e fazer-lhe pagar o que ele nos fez»."
,"11":"Três mil homens de Judá foram à gruta do rochedo de Etam e disseram a Sansão: «Tu não sabes que estamos sob o domínio dos filisteus? Porque procedeste assim connosco?» Sansão respondeu: «Paguei-lhes com a mesma moeda»."
,"12":"Eles insistiram: «Viemos aqui para te prender e entregar-te aos filisteus». Sansão disse: «Jurai que não me matais»."
,"13":"Eles responderam: «Nós só queremos prender-te e entregar-te a eles. Não pretendemos matar-te!». Então amarraram-no com duas cordas novas e levaram-no para fora da gruta."
,"14":"Quando Sansão estava a chegar a Queixada, os filisteus foram recebê-lo com grande algazarra. O espírito de Javé invadiu Sansão, e as cordas que lhe amarravam os braços ficaram como fio de linho queimado, e os laços que prendiam as suas mãos soltaram-se."
,"15":"Vendo uma queixada de jumento ainda fresca, Sansão apanhou-a e com ela matou mil homens."
,"16":"Depois Sansão cantou: «Com uma queixada de jumento eu os amontoei. Com uma queixada de jumento, mil homens eu matei»."
,"17":"Quando acabou de cantar, atirou para longe a queixada. É por isso que se deu àquele lugar o nome de Alto da Queixada."
,"18":"Depois, Sansão ficou com muita sede e gritou a Javé: «Tu concedeste-me esta grande vitória. Será que agora vou morrer de sede e cair nas mãos destes incircuncisos?»"
,"19":"Então Deus fendeu a rocha que está em Queixada, e dela correu água. Sansão bebeu, recuperou as forças e reanimou-se. É por isso que deram o nome de Fonte do Grito à fonte que ainda existe em Queixada."
,"20":"Sansão foi juiz em Israel durante vinte anos, no tempo dos filisteus."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Sansão foi a Gaza, viu ali uma prostituta e dormiu com ela."
,"2":"E a notícia espalhou-se em Gaza: «Sansão está aqui». Fizeram rondas e todos passaram a noite a vigiar junto à porta da cidade. Passaram tranquilamente toda a noite, porque diziam: «De manhã é que o mataremos»."
,"3":"Sansão, porém, ficou deitado até à meia-noite. À meia-noite levantou-se, pegou nas portas da cidade, arrancou-as com a tranca e tudo, pô-las ao ombro e levou-as até ao alto da montanha que está diante de Hebron."
,"4":"Depois disto tudo, Sansão apaixonou-se por Dalila, mulher do vale de Sorec."
,"5":"Os chefes dos filisteus procuraram Dalila e propuseram-lhe: «Seduz Sansão e descobre onde está a sua grande força e de que modo o poderemos dominar, amarrar e prender. E cada um de nós dar-te-á mil e cem moedas de prata»."
,"6":"Dalila disse a Sansão: «Vamos, diz-me qual é o segredo da tua grande força e como é que deveriam prender-te para conseguirem dominar-te»."
,"7":"Sansão disse-lhe: «Se me amarrarem com sete cordas de arco novas, que ainda não foram postas a secar, eu perderei a minha força e ficarei como qualquer outro homem»."
,"8":"Os chefes dos filisteus levaram a Dalila sete cordas de arco novas que ainda não tinham sido postas a secar, e Dalila usou as cordas para amarrar Sansão."
,"9":"Ela havia escondido no quarto alguns homens. Depois gritou: «Sansão, os filisteus vão prender-te!» Mas Sansão rebentou as cordas como se fossem um fio de estopa meio queimado. E ninguém ficou a saber qual era o segredo da sua força."
,"10":"Dalila queixou-se a Sansão: «Escarneceste de mim e mentiste-me. Vamos, diz-me lá como seria possível dominar-te»."
,"11":"Sansão respondeu: «Se me amarrarem com cordas novas, que ainda não tenham sido usadas, eu perderei a minha força e ficarei como qualquer outro homem»."
,"12":"Então Dalila pegou em cordas novas, amarrou Sansão e gritou: «Sansão, os filisteus vão prender-te!» Ela havia escondido no quarto alguns homens, mas Sansão rebentou, como se fossem uma linha, as cordas que lhe amarravam os braços."
,"13":"Dalila queixou-se de novo: «Até agora só fizeste pouco de mim e me disseste mentiras. Vamos, diz-me como é que poderias ser dominado». Sansão respondeu: «Se teceres as sete tranças do meu cabelo com a urdidura de um tear, e as fixares com um pino, perderei a minha força e ficarei como qualquer outro homem»."
,"14":"Dalila fez adormecer Sansão, teceu as sete tranças do seu cabelo com a urdidura, prendeu-as com um pino, e gritou: «Sansão, os filisteus vão prender-te!» Sansão acordou e arrancou o pino do tear juntamente com a urdidura."
,"15":"Então Dalila disse-lhe: «Como é que podes dizer que me amas se não confias em mim? Já me enganaste três vezes e não me revelaste o segredo da tua grande força»."
,"16":"Como Dalila o importunasse e insistisse todos os dias com as suas queixas, Sansão caiu num desespero mortal,"
,"17":"e contou-lhe todo o segredo: «A navalha nunca passou sobre a minha cabeça, pois eu sou consagrado a Deus desde o seio de minha mãe. Se me cortarem o cabelo, perderei a minha força. Ficarei fraco e serei como qualquer outro homem»."
,"18":"Dalila sentiu que Sansão tinha revelado todo o segredo, e mandou chamar os chefes dos filisteus, dizendo: «Vinde, porque Sansão me revelou todo o segredo». Os chefes dos filisteus foram logo, levando o dinheiro."
,"19":"Dalila fez dormir Sansão no seu colo, chamou um homem, e este cortou as sete tranças do cabelo de Sansão. Sansão começou a ficar fraco e a sua força desapareceu."
,"20":"Então Dalila gritou: «Sansão, os filisteus vão prender-te!» Ele acordou e pensou: «Vou libertar-me como das outras vezes». Mas ele não percebeu que Javé o tinha abandonado."
,"21":"Os filisteus agarraram-no, vasaram-lhe os olhos e levaram-no para Gaza. Ali prenderam-no com duas correntes de bronze, e Sansão ficou na prisão a fazer girar a mó do moinho."
,"22":"Entretanto, o cabelo que tinha sido cortado começou a crescer de novo."
,"23":"Os chefes dos filisteus reuniram-se para oferecer um grande sacrifício ao deus Dagon e para festejar. Diziam: «O nosso deus entregou-nos o nosso inimigo Sansão!»"
,"24":"Ao ver Sansão, o povo começou a louvar o seu deus e a dizer: «O nosso deus entregou-nos o nosso inimigo Sansão, aquele que devastou as nossas terras e multiplicou os nossos mortos»."
,"25":"Quando já estavam bem alegres, disseram: «Mandai vir Sansão para ele nos divertir». Mandaram vir Sansão da prisão, para que dançasse diante deles. Quando o colocaram entre duas colunas,"
,"26":"Sansão disse ao jovem que o levava pela mão: «Deixa-me num lugar onde eu possa tocar as colunas que sustentam o templo, para que possa apoiar-me nelas»."
,"27":"O templo estava cheio de homens e mulheres, e também se encontravam ali todos os chefes dos filisteus. Havia gente até no terraço, ao todo cerca de três mil homens e mulheres, que se divertiam a ver Sansão dançar."
,"28":"Sansão invocou Javé: «Por favor, Senhor Javé, lembra-te de mim. Dá-me forças mais uma vez, para que me vingue dos filisteus com um só golpe por causa dos meus olhos»."
,"29":"Sansão tocou as duas colunas centrais que sustentavam o templo, apoiou-se numa com a direita e noutra com a esquerda,"
,"30":"e gritou: «Que eu morra juntamente com os filisteus». Empurrou as colunas com toda a força, e o templo desabou sobre os chefes e todo o povo que ali se encontrava. Deste modo, ao morrer, Sansão matou muito mais gente do que tinha matado durante toda a sua vida."
,"31":"Os seus parentes e toda a sua família vieram e levaram-no, enterrando-o entre Saraá e Estaol, no túmulo de seu pai Manué. Sansão foi juiz em Israel durante vinte anos."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Na região montanhosa de Efraim vivia um homem chamado Micas."
,"2":"Um dia, disse à mãe: «Lembras-te daquelas mil e cem moedas de prata que pensaste que tivessem sido roubadas, e até amaldiçoaste o ladrão, na minha frente? Aqui está o dinheiro. Fui eu que o tirei». A mãe disse-lhe: «Que Javé te abençoe, meu filho!»"
,"3":"Micas devolveu as mil e cem moedas à mãe, que disse: «Eu tinha reservado este dinheiro para Javé, em favor do meu filho, para fazer uma estátua e um ídolo de metal fundido»."
,"4":"E Micas devolveu o dinheiro à mãe. Ela tomou duzentas moedas e entregou-as ao ourives para que fizesse uma estátua e um ídolo de metal fundido, que foram colocados na casa de Micas. "
,"5":"Micas tinha um santuário. Fez um efod e uns ídolos domésticos, e consagrou como sacerdote um dos seus filhos."
,"6":"Nesse tempo não havia rei em Israel, e cada um fazia o que bem entendia."
,"7":"Havia, em Judá, um jovem de Belém, do clã de Judá, que era levita e morava ali como imigrante."
,"8":"Ele deixou a cidade de Belém em Judá, com intenção de se estabelecer onde pudesse. Enquanto viajava, passou pela região montanhosa de Efraim, e chegou à casa de Micas."
,"9":"E Micas perguntou-lhe: «De onde vens?» Ele respondeu: «Sou levita de Belém de Judá, e estou de viagem para me estabelecer onde puder»."
,"10":"Micas propôs-lhe: «Fica comigo, e sê para mim como pai e sacerdote. Eu dar-te-ei dez moedas de prata por ano, além da roupa e da comida»."
,"11":"O levita concordou em ficar com Micas, e este tratou-o como a um filho."
,"12":"Micas consagrou o levita, e o jovem ficou na casa de Micas como sacerdote."
,"13":"E Micas pensou: «Agora estou certo de que Javé vai favorecer-me, pois tenho este levita como sacerdote»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Naquele tempo não havia rei em Israel, e a tribo de Dã procurava um território para morar, porque ainda não tinha recebido a sua herança entre as tribos de Israel."
,"2":"Os danitas mandaram cinco homens valentes do seu clã, de Saraá e Estaol, para explorarem a terra. Foram até à região montanhosa de Efraim e chegaram à casa de Micas, onde passaram a noite."
,"3":"Quando estavam perto da casa de Micas, reconheceram a voz do levita e aproximaram-se, perguntando: «Quem te trouxe para cá? O que é que aqui estás a fazer e com quem trabalhas?»"
,"4":"O levita respondeu: «Micas contratou-me como sacerdote»."
,"5":"Então pediram-lhe: «Consulta Deus para sabermos se a viagem que estamos a fazer vai ter êxito»."
,"6":"O sacerdote respondeu: «Podeis ir em paz. A vossa viagem está sob os cuidados de Javé»."
,"7":"Os cinco homens partiram e chegaram a Laís. Viram que os habitantes do lugar viviam em segurança como os sidónios; viviam tranquilos e seguros, e não sofriam privações ou apertos de nenhuma natureza. Sidónia ficava longe, e eles não mantinham relações com os arameus."
,"8":"Os exploradores voltaram para junto dos irmãos em Saraá e Estaol, que lhes perguntaram: «Que notícias trazeis?»"
,"9":"Eles responderam: «Vamos lutar contra eles, pois vimos que a terra é excelente! Não fiqueis aí parados, não hesiteis em tomar posse do território."
,"10":"Quando lá chegardes, encontrareis um povo tranquilo. O território é extenso, e Deus entregou-o nas vossas mãos. É um lugar onde os produtos da terra são abundantes»."
,"11":"Então, cerca de seiscentos homens armados, do clã de Dã, emigraram de Saraá e Estaol."
,"12":"Subiram e acamparam em Cariat-Iarim, em Judá. É por isso que esse lugar até hoje se chama Acampamento de Dã."
,"13":"Dali passaram para a região montanhosa de Efraim e aproximaram-se da casa de Micas."
,"14":"Os cinco exploradores que ali tinham estado disseram aos seus irmãos: «Deveis saber que nestas casas há um efod e ídolos domésticos, uma estátua e um ídolo de metal fundido. Pensai bem no que ides fazer»."
,"15":"Eles dirigiram-se para lá, chegaram à casa do levita e saudaram-no."
,"16":"Os seiscentos danitas armados montaram guarda junto à porta,"
,"17":"e os cinco exploradores entraram na casa, tomaram a estátua, o efod, os ídolos domésticos e o ídolo de metal fundido. Entretanto, o sacerdote estava à entrada da porta com os seiscentos homens armados."
,"18":"Eles entraram na casa de Micas, tomaram a estátua, o efod, os ídolos domésticos e o ídolo de metal fundido. O sacerdote, então, perguntou-lhes: «O que é que estais a fazer?»"
,"19":"Eles responderam: «Cala-te e vem connosco para seres nosso pai e sacerdote. O que é melhor para ti? Seres sacerdote na casa de um homem, ou sacerdote de uma tribo e de um clã israelita?»"
,"20":"O sacerdote gostou. Pegou no efod, nos ídolos domésticos e na estátua, e foi com eles."
,"21":"Retomaram o caminho e partiram, colocando à frente as mulheres e as crianças, os animais e a bagagem."
,"22":"Já estavam longe da casa de Micas, quando os vizinhos de Micas deram o alarme e começaram a perseguir os danitas."
,"23":"Como vinham a gritar, os danitas voltaram para trás e perguntaram a Micas: «O que aconteceu? Porque gritas desse modo?»"
,"24":"Micas respondeu: «Roubastes o deus que eu havia feito e levastes-me também o sacerdote. Partistes deixando-me sem nada, e ainda me perguntais o que foi que aconteceu?»"
,"25":"Os danitas disseram: «Não digas mais nada. De contrário, alguns homens violentos poderiam atacar-te e perderias a vida juntamente com a tua família»."
,"26":"Os danitas continuaram a viagem; Micas, vendo que eles eram mais fortes, recuou e voltou para casa."
,"27":"Depois de se terem apossado do deus que Micas fizera e do sacerdote que vivia com ele, os danitas atacaram Laís, onde morava um povo tranquilo e confiante. Passaram-nos todos ao fio da espada e incendiaram a cidade,"
,"28":"sem que ninguém fosse socorrer os habitantes, porque a cidade ficava longe de Sidónia, e eles não se relacionavam com os arameus. A cidade estava situada no vale que se estende na direcção do Bet-Roob. Os danitas reconstruíram a cidade e ali se estabeleceram."
,"29":"Deram à cidade o nome de Dã, que era o pai dos danitas e filho de Israel. Antes, porém, a cidade chamava-se Laís."
,"30":"Os danitas instalaram a estátua, e Jónatas, filho de Gersam e neto de Moisés, assim como os seus filhos, foram sacerdotes da tribo de Dã, até ao dia em que as pessoas do território foram levadas para o exílio."
,"31":"Os danitas instalaram para seu uso a estátua que Micas havia feito, e essa estátua ficou ali durante todo o tempo em que existiu o santuário de Silo."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Nesse tempo, quando ainda não havia rei em Israel, um levita morava no fundo da região montanhosa de Efraim e tinha uma concubina, originária de Belém de Judá."
,"2":"A concubina foi-lhe infiel e deixou-o, voltando para a casa de seu pai em Belém de Judá, permanecendo ali durante quatro meses."
,"3":"O homem foi procurar a mulher para a convencer a regressar. Levou consigo um servo e dois jumentos. Quando estava prestes a chegar, o pai da jovem viu-o e saiu todo contente para o receber."
,"4":"O seu sogro, o pai da jovem, hospedou-o. E ele ficou ali três dias, comendo, bebendo e dormindo."
,"5":"No quarto dia, quando se levantaram de manhã, o levita preparou-se para partir. Então o pai da jovem disse ao genro: «Primeiro alimentai-vos, comei um pedaço de pão e depois partireis»."
,"6":"Sentaram-se, comeram e beberam juntos. O pai da jovem disse ao genro: «Por favor, peço-te que fiques mais esta noite e alegra o teu coração»."
,"7":"Como o levita se preparava para partir, o sogro insistiu; e então ele pernoitou."
,"8":"No quinto dia, o genro levantou-se de manhã para se ir embora. Então o pai da jovem disse: «Primeiro alimenta-te». Ficaram assim até quase ao fim do dia e comeram juntos."
,"9":"Quando o levita se levantou para partir com a sua concubina e o seu servo, o sogro, pai da jovem, disse-lhe: «Já se está a fazer tarde. Passa aqui a noite e alegra o teu coração. Amanhã madrugarás e partirás para casa»."
,"10":"Mas o levita não quis passar a noite. Partiu e chegou até perto de Jebus, isto é, Jerusalém. Levava consigo dois jumentos carregados, a mulher e o servo."
,"11":"Quando chegaram perto de Jebus, já havia entardecido, e o servo disse ao patrão: «Podemos dirigir-nos para esta cidade dos jebuseus e dormir lá»."
,"12":"O patrão replicou: «Não vamos sair do nosso caminho para pernoitar numa cidade de estrangeiros, de gente que não é israelita. Vamos continuar até Gabaá»."
,"13":"E acrescentou: «Vamos chegar até um destes lugares, Gabaá ou Ramá, e passaremos lá a noite»."
,"14":"Foram então mais longe e, ao pôr do sol, estavam perto de Gabaá de Benjamim."
,"15":"E entraram para passar a noite. O levita entrou e sentou-se na praça da cidade, mas ninguém o convidou para passar a noite em casa."
,"16":"Pela tarde, chegou um velho que voltava do trabalho no campo. Era de Efraim; e, portanto, também ele vivia como imigrante em Gabaá, enquanto os do lugar eram benjaminitas."
,"17":"O velho ergueu os olhos, viu o viajante na praça da cidade, e perguntou-lhe: «De onde vens e para onde vais?»"
,"18":"O outro respondeu: «Estamos viajando de Belém de Judá para a região montanhosa de Efraim. Eu sou de lá. Fui a Belém de Judá e estou de regresso a casa, mas ninguém me ofereceu hospedagem."
,"19":"Entretanto, temos palha e forragem para os nossos animais, e eu também tenho pão e vinho para mim, para minha mulher e para o servo que nos acompanha. Não precisamos de nada»."
,"20":"O velho disse: «Sê bem-vindo. Deixa-me ajudar-te no que precisares. Não passes a noite na praça»."
,"21":"Então o velho fez entrar o levita em sua casa e deu forragem aos jumentos. Os viajantes lavaram os pés e depois comeram e beberam."
,"22":"Estavam-se reconfortando, quando apareceram uns ociosos da cidade que rodearam a casa e, batendo na porta, diziam ao velho, dono da casa: «Manda sair o homem que entrou na tua casa. Queremos aproveitar-nos dele»."
,"23":"O dono da casa saiu e pediu: «Por favor, irmãos, não cometais esse crime. Ele é meu hóspede, não façais essa infâmia."
,"24":"Vede, tenho uma filha solteira: vou trazê-la para que façais o que quiserdes. Não façais, porém, uma infâmia contra este homem»."
,"25":"Mas eles não lhe deram ouvidos. Então o levita tomou a sua concubina e levou-a para fora. Eles violentaram-na, abusaram dela a noite toda, até de madrugada, e deixaram-na ao amanhecer."
,"26":"De madrugada, a mulher voltou e caiu diante da porta da casa onde o seu marido se havia hospedado. E ali ficou até ao amanhecer."
,"27":"De manhã, o marido levantou-se, abriu a porta da casa e ia a sair para continuar a viagem, quando encontrou a mulher caída à porta com as mãos sobre a soleira."
,"28":"E disse-lhe: «Levanta-te e vamos embora». Mas ela não respondeu. Então o levita colocou-a sobre o seu jumento e pôs-se a caminho."
,"29":"Quando chegou a casa, pegou numa faca, tomou o cadáver da sua mulher, cortou-o em doze pedaços e mandou-os a todo o território de Israel."
,"30":"Todos os que viram isto, comentavam: «Nunca aconteceu, nem se viu coisa igual, desde o dia em que os israelitas saíram do Egipto até hoje. Reflecti sobre o assunto e tomai uma decisão»."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Todos os israelitas, desde Dã até Bersabeia, incluindo o território de Galaad, foram como um só homem e reuniram-se em assembleia diante de Javé, em Masfa."
,"2":"Os chefes do povo e todas as tribos de Israel participaram da assembleia do povo de Deus. Eram quatrocentos mil guerreiros armados de espada."
,"3":"Os benjaminitas tiveram conhecimento de que os israelitas tinham ido a Masfa. Então os israelitas disseram: «Explicai-nos como é que este crime foi cometido»."
,"4":"O levita, marido da mulher que tinha sido morta, declarou: «Minha mulher e eu chegámos a Gabaá de Benjamim para passar a noite."
,"5":"Os moradores de Gabaá levantaram-se contra mim e, durante a noite, cercaram a casa onde eu estava. Eles queriam matar-me e violentaram a minha concubina, que acabou por morrer."
,"6":"Então peguei na minha concubina, cortei-a em pedaços e mandei-os a toda a herança de Israel, porque haviam cometido um crime infame em Israel."
,"7":"Todos vós sois israelitas. Conversai e tomai uma decisão»."
,"8":"Todo o povo se levantou como um só homem, dizendo: «Ninguém de nós voltará para a sua tenda ou para casa."
,"9":"Vamos fazer o seguinte contra Gabaá: vamos sortear os que deverão atacá-la."
,"10":"De todas as tribos de Israel, tomaremos dez homens de cada cem, cem de cada mil, e mil de cada dez mil. Eles se encarregarão dos mantimentos para o povo, para que o povo, chegando a Gabaá de Benjamim, trate a cidade de acordo com a infâmia que ela cometeu em Israel»."
,"11":"Deste modo, todos os israelitas se reuniram como um só homem contra a cidade."
,"12":"Então as tribos israelitas mandaram mensageiros a toda a tribo de Benjamim, dizendo: «Que crime é este que foi cometido entre vós?"
,"13":"Entregai-nos esses bandidos que estão em Gabaá, para que os executemos e eliminemos o mal do meio de Israel». Os benjaminitas, porém, não deram ouvidos aos seus irmãos israelitas. "
,"14":"Partiram das suas cidades e reuniram-se em Gabaá para guerrear contra os israelitas."
,"15":"Nesse dia, os benjaminitas, vindos das diversas cidades, alistaram-se: eram cerca de vinte e seis mil homens armados de espada, sem contar os habitantes de Gabaá."
,"16":"Nesse exército, alistaram-se setecentos homens escolhidos, canhotos, capazes de acertar com a funda num fio de cabelo, sem errar."
,"17":"Os homens de Israel também se alistaram, sem incluir Benjamim: eram quatrocentos mil homens armados de espada e preparados para a guerra."
,"18":"Foram a Betel e consultaram a Deus: «Quem de nós irá em primeiro lugar para guerrear contra os benjaminitas?» Javé respondeu: «Judá»."
,"19":"Os israelitas madrugaram, acamparam diante de Gabaá,"
,"20":"e saíram para combater Benjamim, colocando-se em ordem de batalha diante de Gabaá."
,"21":"Mas os benjaminitas saíram de Gabaá e nesse dia massacraram vinte e dois mil israelitas."
,"23":"Os israelitas voltaram a Betel para chorar até à tarde diante de Javé. Depois consultaram Javé, perguntando: «Devemos lutar de novo contra o nosso irmão Benjamim?» Javé respondeu: «Marchai contra ele»."
,"22":"Então os israelitas refizeram-se, e novamente formaram ordem de batalha no mesmo lugar do dia anterior."
,"24":"No segundo dia, os israelitas aproximaram-se dos benjaminitas,"
,"25":"mas nesse mesmo dia os benjaminitas saíram de Gabaá contra eles e massacraram mais dezoito mil israelitas, todos armados de espada."
,"26":"Então todos os israelitas foram a Betel com o povo, choraram ali sentados diante de Javé. Jejuaram nesse dia até à tarde, ofereceram a Javé holocaustos e sacrifícios de comunhão,"
,"27":"e depois consultaram a Javé. Nesse tempo, a arca da aliança de Deus estava naquela região."
,"28":"E Fineias, filho de Eleazar, filho de Aarão, oficiava junto dela. Eles perguntaram: «Devemos sair para combater o nosso irmão Benjamim, ou devemos desistir?» Javé respondeu: «Atacai, porque amanhã Eu vo-lo entregarei»."
,"29":"Então os israelitas armaram emboscadas em torno de Gabaá,"
,"30":"e no terceiro dia marcharam contra os benjaminitas e, como das outras vezes, organizaram-se para a batalha diante de Gabaá."
,"31":"Os benjaminitas saíram ao encontro dos israelitas e foram atraídos para longe da cidade. Como das outras vezes, começaram a ferir alguns do povo nos caminhos que vão para Betel e para Gabaon. Deste modo, mataram, em campo aberto, cerca de trinta israelitas."
,"32":"Os benjaminitas comentaram: «Venceremos como na primeira vez!» Mas os israelitas tinham combinado: «Vamos fugir para os atrair para os caminhos, para longe da cidade»."
,"33":"Então a maior parte dos israelitas abandonou as suas posições e organizou-se em Baal-Tamar. E a emboscada de Israel apareceu do lugar em que estava, a Oeste de Gaba."
,"34":"Dez mil homens escolhidos de Israel chegaram diante de Gabaá e começou um combate violento, sem que os benjaminitas percebessem a desgraça que os aguardava."
,"35":"Javé derrotou Benjamim diante de Israel. Nesse dia, os israelitas mataram vinte e cinco mil e cem homens, todos armados de espada."
,"36":"Os benjaminitas perceberam que tinham sido derrotados. Os israelitas cederam terreno a Benjamim, porque confiavam na emboscada que tinham preparado contra Gabaá."
,"37":"Então os que estavam na emboscada lançaram-se rapidamente contra Gabaá; apareceram de repente e passaram todo o povo da cidade ao fio da espada."
,"38":"Os israelitas tinham combinado um sinal com os que estavam na emboscada: estes deviam fazer subir da cidade uma nuvem de fumo como sinal;"
,"39":"nesse momento, os israelitas que estavam no combate recuariam, dando meia-volta. Os benjaminitas já tinham matado uns trinta israelitas, e comentavam: «Venceremos como no primeiro combate»."
,"40":"Nesse momento, porém, o fumo começou a subir da cidade. Os benjaminitas olharam para trás e viram que a cidade inteira ardia em chamas até ao céu."
,"41":"Então os israelitas deram meia-volta e os benjaminitas apavoraram-se, vendo que estavam perdidos."
,"42":"Então os benjaminitas fugiram dos israelitas, tomando a direcção do deserto, mas os perseguidores alcançaram-nos e os que vinham da cidade massacraram-nos, atacando-os pela retaguarda."
,"43":"Os israelitas cercaram os benjaminitas, perseguiram-nos sem tréguas e foram-nos esmagando até perto de Gaba, do lado Leste."
,"44":"Dezoito mil guerreiros benjaminitas caíram mortos."
,"45":"Na fuga, eles foram para o deserto, para os lados do Rochedo de Remon. Pelo caminho ainda caíram cerca de cinco mil. Depois os israelitas seguiram-nos de perto até Gadaam e mataram mais dois mil homens."
,"46":"O número total de benjaminitas que caíram nesse dia foi de vinte e cinco mil homens armados de espada, todos guerreiros."
,"47":"Na fuga, seiscentos homens foram para o deserto, na direcção do Rochedo de Remon, e ali ficaram quatro meses."
,"48":"Os israelitas voltaram-se contra os benjaminitas e passaram ao fio da espada a população masculina da cidade e até mesmo o gado e tudo o que encontraram. Também incendiaram todas as cidades que encontravam."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Os israelitas tinham feito este juramento em Masfa: «Ninguém de nós dará a sua filha em casamento a um benjaminita»."
,"2":"Foram para Betel e ficaram ali até à tarde, sentados diante de Deus, gemendo e chorando inconsoláveis."
,"3":"E diziam: «Javé, Deus de Israel, porque aconteceu isto em Israel? Hoje uma tribo de Israel desapareceu»."
,"4":"No dia seguinte, madrugaram, construíram ali um altar e ofereceram holocaustos e sacrifícios de comunhão."
,"5":"Depois perguntaram: «Quem das tribos de Israel não compareceu à assembleia diante de Javé?» Isto porque tinham feito juramento solene contra quem não se apresentasse diante de Javé em Masfa; quem não comparecesse tornar-se-ia réu de morte."
,"6":"Os israelitas ficaram com pena do seu irmão Benjamim, e diziam: «Hoje uma tribo foi cortada de Israel."
,"7":"Como podemos providenciar mulheres para os sobreviventes? Nós jurámos que nunca lhes daríamos as nossas filhas em casamento!»"
,"8":"Então eles perguntaram: «Quem das tribos de Israel não compareceu à assembleia diante de Javé em Masfa?» Perceberam então que ninguém de Jabes de Galaad tinha vindo ao acampamento onde se fizera a assembleia."
,"9":"Foram contados todos os que tinham comparecido e, de facto, ninguém de Jabes de Galaad tinha vindo."
,"10":"Então a comunidade mandou para lá doze mil homens armados, com esta ordem: «Ide e passai ao fio da espada todos os habitantes de Jabes de Galaad, inclusive mulheres e crianças."
,"11":"Fazei de modo que todos os homens e as mulheres casadas sejam mortos. Deixai com vida apenas as solteiras». E eles assim fizeram."
,"12":"Entre os habitantes de Jabes de Galaad encontraram quatrocentas jovens não casadas, e levaram-nas para o acampamento em Silo, na terra de Canaã."
,"13":"Então toda a comunidade mandou mensageiros com propostas de paz aos benjaminitas que estavam no Rochedo de Remon."
,"14":"Os benjaminitas voltaram, e os israelitas deram-lhes as mulheres de Jabes de Galaad, que tinham sido deixadas com vida. Mas elas não eram suficientes para todos eles."
,"15":"O povo teve piedade de Benjamim, porque Javé havia provocado um vazio entre as tribos de Israel."
,"16":"Os anciãos da comunidade perguntaram: «O que é que vamos fazer para que os restantes tenham mulheres, já que as mulheres benjaminitas estão mortas?»"
,"17":"E acrescentaram: «Como preservar um resto para os benjaminitas que escaparam, a fim de que não desapareça uma tribo de Israel?"
,"18":"Nós não lhes podemos dar mulheres dentre as nossas filhas, porque os israelitas fizeram um juramento, amaldiçoando quem desse mulher aos benjaminitas!»"
,"19":"E continuaram: «Há uma festa anual de Javé em Silo, que fica ao Norte de Betel, a Leste do caminho que sobe de Betel para Siquém, e a Sul de Lebona»."
,"20":"Sugeriram, então, aos benjaminitas: «Ide e escondei-vos entre as vinhas."
,"21":"Ficai a observar e, quando as jovens de Silo saírem para dançar, saí das vinhas e cada um de vós rapte uma mulher dentre as jovens de Silo e depois voltai com elas para o território de Benjamim."
,"22":"Se os pais ou irmãos delas forem reclamar convosco, nós lhes diremos: 'Procurai compreender: não podemos conseguir mulher para cada um deles na guerra, e vós também não poderíeis dar-lha, porque, nesse caso, vos tornaríeis culpados'»."
,"23":"Assim fizeram os benjaminitas. De acordo com o número deles, tomaram esposas entre as dançarinas que raptaram. Depois partiram e voltaram para o seu território; reconstruíram as cidades e estabeleceram-se nelas."
,"24":"Depois disto, os israelitas dispersaram-se, cada um para a sua tribo e o seu clã, saindo dali cada um para o seu território."
,"25":"Nesse tempo não havia rei em Israel, e cada um fazia o que achava melhor."
}`)

}
func PT_BS_LoadVHIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Depois da morte de Moisés, servo de Javé, Javé disse a Josué, filho de Nun, auxiliar de Moisés:"
,"2":"«O meu servo Moisés morreu. Agora levanta-te e atravessa o rio Jordão, com todo este povo, para a Terra que Eu vos vou dar."
,"3":"Todo o lugar que a planta dos vossos pés pisar, Eu vo-lo dei, conforme prometi a Moisés."
,"4":"O vosso território irá desde o deserto até ao Líbano, e desde o grande rio Eufrates até ao Mar Mediterrâneo, no Ocidente."
,"5":"Ninguém te poderá resistir durante toda a tua vida. Assim como estive com Moisés, estarei também contigo: nunca te abandonarei nem te deixarei desamparado."
,"6":"Sê firme e corajoso, porque farás com que este povo herde esta terra que jurei dar aos teus antepassados."
,"7":"Apenas sê firme e corajoso, para cumprir toda a Lei que o meu servo Moisés te ordenou. Não te desvies dela, nem para a direita nem para a esquerda, e terás sucesso em todos os teus empreendimentos."
,"8":"Que o livro desta Lei esteja sempre nos teus lábios: medita nele dia e noite, para agires de acordo com tudo o que nele está escrito. Deste modo, serás bem sucedido nos teus empreendimentos e sempre terás sucesso."
,"9":"Sou Eu que te ordeno que sejas firme e corajoso. Portanto, não tenhas medo e não te acovardes, porque Javé teu Deus está contigo em qualquer lugar para onde vás»."
,"10":"Então Josué ordenou aos oficiais do povo:"
,"11":"«Passai pelo meio do acampamento e dai esta ordem ao povo: 'Abastecei-vos de víveres, porque dentro de três dias atravessareis o rio Jordão para tomar posse da Terra que Javé vosso Deus vos dá'»."
,"12":"Josué disse aos rubenitas, aos gaditas e à meia tribo de Manassés:"
,"13":"«Lembrai-vos do que vos ordenou Moisés, servo de Javé: 'Javé vosso Deus concede-vos repouso e dá-vos esta Terra'."
,"14":"As vossas mulheres, crianças e rebanhos ficarão na terra que Moisés vos deu na Transjordânia. Vós, porém, todos os homens de guerra, atravessareis o Jordão bem armados, à frente dos vossos irmãos, para os ajudardes,"
,"15":"até que Javé con-ceda descanso aos vossos irmãos, da mesma forma que o deu a vós, e até que eles também tomem posse da Terra que Javé vosso Deus lhes dá. Então podereis voltar para a Terra que vos pertence e tomar posse da Terra que Moisés, servo de Javé, vos deu na Transjordânia, no lado oriental»."
,"16":"Eles responderam a Josué: «Faremos tudo o que nos ordenaste e iremos para onde nos mandares."
,"17":"Obedecer-te-emos da mesma forma que obedecíamos a Moisés. Basta que Javé esteja contigo, assim como estava com Moisés."
,"18":"Quem se revoltar e não obedecer às tuas ordens, sejam quais forem, será morto. Basta que sejas firme e corajoso»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"De Setim, Josué, filho de Nun, mandou secretamente dois espiões para examinar a terra, especialmente Jericó. Eles foram e entraram na casa de uma prostituta chamada Raab, e ali se hospedaram."
,"2":"Então alguém informou o rei de Jericó: «Cuidado! Esta noite chegaram aqui uns israelitas para espionar a terra»."
,"3":"Então o rei de Jericó mandou dizer a Raab: «Manda sair os homens que entraram em tua casa, porque eles vieram para espionar toda a terra»."
,"4":"A mulher, porém, escondeu logo os dois homens, e respondeu: «De facto, esses homens vieram aqui, mas eu não sabia de onde eram."
,"5":"Quando iam fechar a porta da cidade, à noite, eles foram-se embora, não sei para onde. Se os perseguirdes imediatamente, depressa os alcançareis»."
,"6":"Ela, porém, tinha feito subir os dois espiões ao terraço e escondera-os entre feixes de linho que lá estavam empilhados."
,"7":"Os guardas saíram em busca deles pelo caminho que leva aos vaus do Jordão. E a porta da cidade foi fechada depois de eles saírem."
,"8":"Antes de os espiões se deitarem, Raab subiu ao terraço,"
,"9":"e disse-lhes: «Eu sei que Javé vos entregou esta terra. Estamos apavorados, e todos os habitantes da terra tremem diante de vós."
,"10":"Porque soubemos como Javé secou a água do Mar Vermelho diante de vós, quando saístes do Egipto, e o que fizestes aos dois reis amorreus da Transjordânia, Seon e Og, que exterminastes."
,"11":"Ao ouvirmos isso, ficámos desencorajados, e já ninguém consegue respirar diante de vós, porque Javé vosso Deus é Deus tanto lá em cima no Céu, como cá em baixo na Terra."
,"12":"Agora, jurai-me por Javé que, assim como vos tratei com misericórdia, também vós tratareis com misericórdia a minha família. Dai-me um sinal seguro"
,"13":"de que deixareis com vida o meu pai, a minha mãe, os meus irmãos e irmãs e todos os meus familiares, e de que nos livrareis da matança»."
,"14":"Os homens juraram: «A nossa vida em troca da vossa vida, com a condição de que não nos denuncies. Quando Javé nos entregar esta terra, nós tratar-te-emos com lealdade e fidelidade»."
,"15":"Então ela desceu-os por uma corda pela janela, porque a casa onde vivia era pegada à muralha."
,"16":"E disse-lhes: «Fugi para a montanha, para que os perseguidores não vos encontrem. Escondei-vos durante três dias, até que eles voltem. Depois continuai o vosso caminho»."
,"17":"Os homens disseram: «Ficaremos livres do juramento que nos exigiste"
,"18":"se, quando chegarmos a esta terra, não prenderes este cordão vermelho na janela pela qual estamos descendo, e não reunires contigo, em tua casa, o teu pai, a tua mãe, os teus irmãos e toda a família de teu pai."
,"19":"Quem sair para a rua será responsável pela própria morte. Nós não teremos culpa. E nós seremos responsáveis pela morte de quem estiver contigo em tua casa, se alguém lhe tocar."
,"20":"Contudo, se nos denunciares, não responderemos pelo juramento que nos fizeste prestar»."
,"21":"Ela respondeu: «De acordo». E despediu-os. Eles foram-se embora, e ela prendeu o cordão vermelho na janela."
,"22":"Eles foram para a montanha e ali ficaram três dias, até que os perseguidores voltassem; por mais que estes procurassem, não conseguiram encontrar os espiões."
,"23":"Então os dois homens desceram da montanha, atravessaram o rio Jordão e foram ter com Josué, filho de Nun, contando tudo o que se tinha passado com eles."
,"24":"Disseram a Josué: «Realmente Javé está a entregar esta terra nas nossas mãos. Os habitantes tremem de medo diante de nós»."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Josué levantou-se de madrugada e partiu de Setim, juntamente com todos os israelitas. Chegaram ao Jordão e ali pernoitaram antes de atravessar."
,"2":"Três dias depois, os chefes passaram pelo acampamento,"
,"3":"dando esta ordem ao povo: «Quando virdes a arca da aliança de Javé vosso Deus e os sacerdotes levitas que a levam, deixai o lugar onde estais e começai a segui-la."
,"4":"Mas conservai sempre a distância de mais ou menos mil metros entre vós e a arca. Mantende-vos à distância, para ver o caminho que devereis seguir, porque nunca passastes por ele»."
,"5":"Josué ordenou ao povo: «Purificai-vos, porque amanhã Javé realizará maravilhas no meio de vós»."
,"6":"Aos sacerdotes, Josué ordenou: «Levai a arca da aliança e atravessai diante do povo». Eles levaram a arca e foram à frente do povo."
,"7":"Javé disse a Josué: «Hoje vou começar a engrandecer-te aos olhos de todo o Israel, para que saibam que estou contigo como estive com Moisés."
,"8":"Ordena aos sacerdotes que levam a arca da aliança: 'Ao chegardes à beira da água do Jordão, parai'»."
,"9":"Josué disse então aos israelitas: «Aproximai-vos para ouvir as palavras de Javé vosso Deus»."
,"10":"E continuou: «Com isto sabereis que o Deus vivo está no meio de vós e que expulsará de diante de vós os cananeus, heteus, heveus, ferezeus, gergeseus, amorreus e jebuseus."
,"11":"A arca da aliança do Senhor de toda a Terra vai atravessar diante de vós o Jordão."
,"12":"Agora, portanto, escolhei doze homens das tribos de Israel, um de cada tribo."
,"13":"Quando a planta dos pés dos sacerdotes, que levam a arca de Javé, Senhor de toda a Terra, tocar a água do Jordão, a água do Jordão ficará dividida: a água que vem de cima ficará parada num só monte»."
,"14":"Quando o povo deixou as tendas para atravessar o Jordão, os sacerdotes que levavam a arca da aliança caminhavam à frente do povo."
,"15":"Ao chegarem ao Jordão, quando os sacerdotes que levavam a arca molharam os pés na beira da água - pois o Jordão transborda sobre as margens durante o tempo da ceifa -"
,"16":"a água que vinha de cima parou, amontoando-se numa grande extensão, bem longe, em Adam, cidade que fica ao lado de Sartã; e a água que descia para o Mar da Arabá, o Mar Morto, escoou-se totalmente, de modo que o povo pôde atravessar em frente de Jericó."
,"17":"Os sacerdotes, que levavam a arca da aliança de Javé, ficaram parados no leito seco, no meio do Jordão, enquanto todo o Israel atravessava a pé enxuto, até que todos acabaram de atravessar."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quando todo o povo acabou de atravessar o Jordão, Javé disse a Josué:"
,"2":"«Escolhei doze homens do povo, um de cada tribo,"
,"3":"e mandai que tirem daqui, do meio do Jordão, do lugar onde os sacerdotes estiveram parados, doze pedras. Levai as pedras convosco e colocai-as no acampamento onde ireis pernoitar»."
,"4":"Josué chamou os doze homens que havia escolhido entre os israelitas, um de cada tribo,"
,"5":"e ordenou: «Passai à frente da arca de Javé vosso Deus para o meio do Jordão, e cada um leve ao ombro uma pedra, conforme o número das tribos de Israel,"
,"6":"a fim de que isto venha a ser um sinal no meio de vós. Amanhã, quando os vossos filhos vos perguntarem o que significam essas pedras,"
,"7":"respondereis: 'É que as águas do Jordão separaram-se diante da arca da aliança de Javé. Quando a arca passou pelo Jordão, as águas separaram-se, e estas pedras ficaram entre os israelitas como lembrança para sempre'»."
,"8":"Os israelitas fizeram o que Josué havia mandado: tomaram doze pedras do meio do Jordão, como Javé ordenara a Josué, segundo o número das tribos de Israel; e levaram-nas para o acampamento, e lá as colocaram."
,"9":"Josué levantou doze pedras no meio do Jordão, no lugar onde estiveram parados os pés dos sacerdotes que levavam a arca da aliança. E elas estão lá até ao dia de hoje."
,"10":"Os sacerdotes que levavam a arca ficaram parados no meio do Jordão, até que se cumpriu tudo o que Javé ordenara a Josué que dissesse ao povo, conforme tudo o que Moisés tinha ordenado a Josué. E o povo apressou-se a atravessar."
,"11":"Quando todos acabaram de atravessar, atravessou também a arca de Javé, e os sacerdotes colocaram-se diante do povo."
,"12":"À frente dos israelitas atravessaram os rubenitas, os gaditas e a meia tribo de Manassés, em ordem de batalha, conforme Moisés lhes havia ordenado."
,"13":"Cerca de quarenta mil homens de guerra, armados, atravessaram à frente de Javé para o combate, em direcção à planície de Jericó."
,"14":"Nesse dia, Javé engrandeceu Josué diante de todo o Israel, para que o respeitassem, da mesma forma que haviam respeitado Moisés enquanto viveu."
,"15":"Javé disse então a Josué:"
,"16":"«Ordena que os sacerdotes que levam a arca do testemunho saiam do Jordão»."
,"17":"Josué ordenou aos sacerdotes: «Saí do Jordão»."
,"18":"Quando os sacerdotes, que levavam a arca da aliança de Javé, saíram do meio do Jordão, assim que a planta dos pés dos sacerdotes tocou a terra seca, as águas do Jordão voltaram para o lugar e correram como antes, cobrindo inteiramente as duas margens."
,"19":"O povo atravessou o Jordão no dia dez do primeiro mês e acampou em Guilgal, no extremo Leste de Jericó."
,"20":"Josué colocou em Guilgal as doze pedras que haviam tirado do Jordão,"
,"21":"e disse aos israelitas: «Amanhã, quando os vossos filhos perguntarem aos pais o que significam estas pedras,"
,"22":"dir-lhes-eis: 'Israel atravessou o Jordão a pé enxuto."
,"23":"Javé vosso Deus secou a água do Jordão diante de vós, até o terdes atravessado, da mesma forma como Javé vosso Deus fez ao Mar Vermelho, que Ele secou diante de nós, até termos atravessado."
,"24":"Isso aconteceu para que todos os povos da Terra saibam como é forte a mão de Javé, a fim de que temais sempre a Javé vosso Deus'»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Todos os reis dos amorreus que se encontram a Oeste, na Cisjordânia, e todos os reis dos cananeus que habitavam junto ao mar, souberam que Javé tinha secado as águas do Jordão diante dos israelitas até que tivessem atravessado. Ficaram desencorajados, e ninguém mais conseguia respirar diante dos israelitas."
,"2":"Nesse tempo Javé disse a Josué: «Fabrica facas de pedra e circuncida de novo os israelitas»."
,"3":"Então Josué fez facas de pedra e circuncidou os israelitas na colina dos Prepúcios."
,"4":"O motivo desta circuncisão foi que todos os homens saídos do Egipto, todos os guerreiros, tinham morrido no caminho do deserto, depois de terem saído do Egipto."
,"5":"Todos os que tinham saído do Egipto eram circuncidados, mas todos os que nasceram no caminho do deserto, depois da saída do Egipto, não eram circuncidados."
,"6":"Os israelitas tinham caminhado pelo deserto durante quarenta anos, até que desapareceu toda a geração de guerreiros que tinham saído do Egipto e que não obedeceram a Javé. Javé havia-lhes jurado que eles não veriam a Terra que Javé tinha jurado dar a seus antepassados, uma Terra onde corre leite e mel."
,"7":"Javé, porém, deu-lhes descendentes, e foi a estes que Josué circuncidou, pois estavam sem circuncisão, uma vez que não tinham sido circuncidados no caminho."
,"8":"Quando acabaram de circuncidar a todos, ficaram no lugar do acampamento até se restabelecerem."
,"9":"Então Javé disse a Josué: «Hoje tirei de cima de vós a vergonha do Egipto». Por isso, deram a esse lugar o nome de Guilgal, até ao dia de hoje."
,"10":"Os israelitas ficaram acampados em Guilgal e celebraram a Páscoa no dia catorze do mesmo mês, à tarde, na planície de Jericó."
,"11":"A partir do dia a seguir à Páscoa, comeram dos produtos da terra; no mesmo dia, comeram pão sem fermento e trigo tostado."
,"12":"No dia seguinte, quando começaram a comer os produtos da terra, o maná deixou de cair. Não houve mais maná para os israelitas e, nesse ano, eles comeram dos frutos da terra de Canaã."
,"13":"Estando perto de Jericó, Josué levantou os olhos e viu de pé diante de si um homem com a espada desembainhada na mão. Josué aproximou-se dele e perguntou: «És a nosso favor ou a favor dos nossos inimigos?»"
,"14":"Ele respondeu: «Eu sou chefe do exército de Javé, e acabo de chegar». Então Josué prostrou-se com o rosto por terra e adorou-O. A seguir perguntou: «O que diz o meu Senhor ao seu servo?»"
,"15":"O chefe do exército de Javé respondeu: «Tira as sandálias dos pés, porque o lugar que pisas é sagrado». E Josué assim fez."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Jericó estava fechada e bem trancada por causa dos israelitas. Ninguém saía e ninguém entrava."
,"2":"Javé disse a Josué: «Vê! Eu entrego na tua mão a cidade de Jericó, juntamente com o rei e os soldados."
,"3":"Vós, todos os guerreiros, rodeai a cidade, dando uma volta ao redor. Fazei isso durante seis dias."
,"4":"Sete sacerdotes levarão sete trombetas à frente da arca; no sétimo dia dai sete voltas em torno da cidade, e os sacerdotes tocarão as trombetas."
,"5":"Quando for dado um toque longo e ouvirdes o toque da trombeta, todo o povo lançará o grito de guerra: as muralhas da cidade desabarão, e o povo a assaltará, cada um do seu lugar»."
,"6":"Josué, filho de Nun, convocou os sacerdotes e deu-lhes esta ordem: «Levai a arca da aliança; sete sacerdotes levem também sete trombetas à frente da arca de Javé»."
,"7":"E em seguida disse ao povo: «Ide e rodeai a cidade. Os guerreiros marchem à frente da arca de Javé»."
,"8":"E foi feito como Josué havia orde-nado ao povo. Sete sacerdotes com sete trombetas puseram-se em marcha à frente de Javé e começaram a tocar as trombetas. A arca da aliança de Javé ia atrás deles."
,"9":"Os guerreiros iam à frente dos sacerdotes que tocavam as trombetas. O restante ia atrás da arca; todos marchavam ao som das trombetas."
,"10":"Josué tinha ordenado ao povo: «Não lanceis o grito de guerra. Permanecei em silêncio. Não digais uma única palavra até que eu vos mande gritar. Só então gritareis»."
,"11":"A arca de Javé rodeou a cidade, dando uma volta. Depois voltaram ao acampamento, onde pernoitaram."
,"12":"Josué levantou-se de madrugada, e os sacerdotes levaram a arca de Javé;"
,"13":"os sete sacerdotes que levavam as sete trombetas iam à frente da arca de Javé, tocando as trombetas. Os guerreiros iam à frente dos sacerdotes que tocavam as trombetas. O restante ia atrás da arca de Javé; todos marchavam ao som das trombetas."
,"14":"No segundo dia, rodearam a cidade uma vez e depois voltaram para o acampamento. Fizeram isso durante seis dias."
,"15":"No sétimo dia, ao romper da aurora, levantaram-se e rodearam a cidade sete vezes, do mesmo modo. (Somente no sétimo dia rodearam a cidade sete vezes)."
,"16":"Na sétima volta, os sacerdotes tocaram as trombetas. Então Josué disse ao povo: «Gritai, porque Javé vos entregou a cidade."
,"17":"A cidade, com tudo o que nela existe, será consagrada ao extermínio em honra de Javé. Só ficarão com vida a prostituta Raab e todos os que estiverem com ela em casa, pois ela escondeu os mensageiros que enviámos."
,"18":"Quanto a vós, cuidado com as coisas consagradas ao extermínio; não pegueis naquilo que consagrastes ao extermínio. Isso faria com que o acampamento de Israel se tornasse consagrado ao extermínio, trazendo-lhe a desgraça."
,"19":"Toda a prata, ouro, objectos de bronze e de ferro serão consagrados a Javé e destinados ao tesouro de Javé»."
,"20":"O povo lançou o grito e tocaram-se as trombetas. Ao ouvir o toque de trombeta, o povo deu um grande grito e as muralhas da cidade desmoronaram-se. O povo entrou na cidade, cada um do seu lugar, e tomou a cidade."
,"21":"Consagraram ao extermínio tudo o que havia na cidade: homens e mulheres, jovens e velhos, vacas, ovelhas e burros; passaram tudo ao fio da espada."
,"22":"Josué disse, então, aos dois homens que haviam espionado a terra: «Ide à casa da prostituta e retirai-a de lá, com tudo o que estiver com ela, conforme lhe prometestes»."
,"23":"Os espiões foram e retiraram Raab, juntamente com o pai, a mãe, os irmãos e tudo o que ela possuía. Tiraram também todo o seu clã e deixaram-no fora do acampamento de Israel."
,"24":"Incendiaram a cidade e tudo o que nela havia. Quanto à prata, o ouro, os objectos de bronze e de ferro, levaram-nos para o tesouro de Javé."
,"25":"Josué conservou a vida da prostituta Raab, bem como a família de seu pai e tudo o que possuíam. Ela permanece no meio de Israel até ao dia de hoje, por ter escondido os mensageiros que Josué tinha enviado para espionar Jericó."
,"26":"Nesse tempo, Josué fez um juramento: «Seja maldito por Javé quem reconstruir esta cidade: os alicerces custar-lhe-ão o primogénito e as portas custar-lhe-ão o filho mais novo»."
,"27":"Javé estava com Josué e a sua fama correu por toda a terra."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Os israelitas cometeram um acto de infidelidade quanto às coisas consagradas ao extermínio: Acã, filho de Carmi, neto de Zabdi, bisneto de Zaré, da tribo de Judá, apossou-se de coisas consagradas. E a ira de Javé acendeu-se contra os israelitas."
,"2":"De Jericó, Josué mandou alguns homens até Hai, que está perto de Bet-Áven, a Leste de Betel, e ordenou-lhes: «Subi para espionar a terra». Os homens subiram e espionaram Hai."
,"3":"Voltando para junto de Josué, disseram-lhe: «Não é preciso que todo o povo suba; bastam dois ou três mil homens para conquistar Hai. Não é necessário cansar todo o povo, porque eles são poucos»."
,"4":"Então foram para Hai cerca de três mil homens do povo, mas tiveram que fugir diante dos habitantes de Hai."
,"5":"Os homens de Hai mataram trinta e seis deles e perseguiram os outros, desde a porta da cidade até Sabarim, derrotando-os na descida. O coração do povo derreteu-se e ficou como água."
,"6":"Então Josué rasgou as vestes e prostrou-se com o rosto por terra diante da arca de Javé até ao entardecer. Junto com ele estavam os anciãos de Israel, cobrindo de pó as suas cabeças."
,"7":"Josué suplicou: «Ah! Senhor Javé, porque fizeste este povo atravessar o Jordão? Foi para nos entregar na mão dos amorreus e nos fazer perecer? Oxalá nos tivéssemos contentado em ficar no outro lado do Jordão!"
,"8":"Perdão, Senhor! O que vou dizer, depois de Israel ter voltado as costas diante dos inimigos?"
,"9":"Os cananeus e todos os habitantes da terra vão ouvir isto, farão um cerco contra nós e apagarão o nosso nome da face da Terra! E o que farás Tu com o teu grande Nome?»"
,"10":"Javé respondeu a Josué: «Levanta-te. O que é que estás aí a fazer com o rosto por terra?"
,"11":"Israel pecou; eles violaram a aliança que Eu lhes ordenara: tomaram coisas consagradas ao extermínio, roubaram-nas e esconderam-nas, colocando-as entre as coisas deles."
,"12":"Por isso os israelitas não poderão resistir aos inimigos: fugirão dos inimigos, porque se tornaram consagrados ao extermínio. Não ficarei mais no meio de vós, se não fizerdes desaparecer do meio de vós o que foi consagrado ao extermínio."
,"13":"Levanta-te e purifica o povo, dizendo-lhes: 'Santificai-vos para amanhã, pois assim diz Javé, o Deus de Israel: Há uma coisa consagrada ao extermínio no meio de ti, Israel! E vós não podereis resistir aos inimigos, enquanto não eliminardes do meio de vós as coisas consagradas ao extermínio."
,"14":"Pela manhã, aproximar-vos-eis, por tribos: a tribo que Javé indicar por sorte aproximar-se-á por clãs; o clã que Javé indicar por sorte aproximar-se-á por famílias; a família que Javé indicar por sorte aproximar-se-á por pessoas."
,"15":"Quem for indicado por sorte como responsável pela coisa consagrada ao extermínio, será queimado com tudo o que possui, porque violou a aliança de Javé e cometeu uma infâmia em Israel'»."
,"16":"Josué levantou-se de madrugada e fez aproximar Israel por tribos. E a sorte caiu sobre a tribo de Judá."
,"17":"Fazendo aproximar os clãs de Judá, a sorte caiu sobre o clã de Zaré; fazendo aproximar o clã de Zaré por famílias, a sorte caiu sobre a família de Zabdi;"
,"18":"fazendo aproximar a família de Zabdi pessoa por pessoa, a sorte caiu sobre Acã, filho de Carmi, neto de Zabdi, bisneto de Zaré, da tribo de Judá."
,"19":"Então Josué disse a Acã: «Meu filho, dá glória a Javé, Deus de Israel, e apresenta-Lhe a tua confissão. Conta-me o que fizeste, e não me escondas nada»."
,"20":"Acã respondeu a Josué: «É verdade. Eu pequei contra Javé, Deus de Israel, pois fiz o seguinte:"
,"21":"entre os despojos, vi uma capa babilónica muito bonita, duzentas moedas de prata e uma barra de ouro que pesava meio quilo; cobicei-os e apanhei-os. Estão escondidos no chão, no meio da minha tenda, com a prata por baixo»."
,"22":"Josué mandou alguns, que inspeccionassem a tenda, e tudo lá estava escondido, com a prata por baixo."
,"23":"Pegaram então nos objectos do meio da tenda e levaram-nos a Josué e a todos os israelitas, colocando-os diante de Javé."
,"24":"Josué então pegou em Acã, bisneto de Zaré, com a prata, a capa e a barra de ouro, bem como os seus filhos e filhas, os seus bois, jumentos e ovelhas, a sua tenda e tudo o que possuía. Em companhia de todo o Israel, mandou-os subir ao Vale de Acor,"
,"25":"e Josué disse-lhe: «Tu desgraçaste-nos. Por isso, hoje mesmo Javé te desgraçará». Então todo o Israel apedrejou Acã. E depois de o apedrejarem, queimaram-no."
,"26":"Em seguida, levantaram sobre ele um montão de pedras, que permanece até ao dia de hoje. Foi assim que Javé aplacou o furor da sua ira. Por isso, esse lugar chamou-se Vale de Acor, até ao dia de hoje."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Javé disse a Josué: «Não tenhas medo e não te acovardes. Leva contigo todos os guerreiros. Levanta-te, e sobe contra Hai. Vê! Eu entrego-te nas mãos o rei de Hai, juntamente com o povo, a cidade e as suas terras."
,"2":"Faz com Hai e o seu rei como fizeste com Jericó e o seu rei. Podereis repartir entre vós os despojos e o gado. Armai uma emboscada contra a cidade, por detrás dela»."
,"3":"Josué e os guerreiros prepararam-se para atacar Hai. Josué escolheu trinta mil guerreiros valentes e enviou-os durante a noite,"
,"4":"ordenando: «Atenção! Armai uma emboscada por detrás da cidade; não vos afasteis muito da cidade e ficai de atalaia."
,"5":"Eu e a minha gente aproximar-nos-emos da cidade, e quando eles saírem ao nosso encontro como da primeira vez, nós vamos fugir deles."
,"6":"E eles vão perseguir-nos; assim os atrairemos para longe da cidade, pois pensarão: 'Estão fugindo de nós como da primeira vez'."
,"7":"Então saireis da emboscada e tomareis a cidade. Javé vosso Deus entregará a cidade nas vossas mãos."
,"8":"Depois de tomar a cidade, incendiá-la-eis, agindo de acordo com a palavra de Javé. Vede que isto é uma ordem!»"
,"9":"Josué enviou-os e eles foram colocar-se no lugar da emboscada, entre Betel e Hai, a Oeste de Hai. Entretanto, Josué passou a noite no meio do povo."
,"10":"No dia seguinte, levantou-se de madrugada e passou revista ao povo. Depois, juntamente com os anciãos de Israel, subiu contra Hai, à frente do povo."
,"11":"Todos os guerreiros que ficaram com ele subiram também e foram-se aproximando da cidade e acamparam ao Norte de Hai. Entre eles e Hai havia um vale."
,"12":"Josué havia tomado cerca de cinco mil homens e colocara-os de emboscada entre Betel e Hai, a Oeste da cidade."
,"13":"O povo ficou no acampamento maior a Norte da cidade, e a emboscada a Oeste da cidade. Nessa noite, Josué foi até ao meio do vale."
,"14":"Quando o rei de Hai viu isto, ele e todo o povo da cidade levantaram-se depressa e saíram para ir ao encontro de Israel e dar combate na descida, diante do deserto; o rei, porém, não sabia que havia uma emboscada contra ele, atrás da cidade."
,"15":"Josué e todo o Israel, fingindo-se derrotados, fugiram pelo caminho do deserto."
,"16":"Todo o povo da cidade saiu a gritar e a perseguir os israelitas. Ao perseguir Josué, eles afastaram-se da cidade."
,"17":"Em Hai não ficou um homem sequer; todos saíram a perseguir Israel; e ao perseguir Israel, deixaram a cidade aberta."
,"18":"Então Javé disse a Josué: «Estende contra Hai a lança que tens na mão, pois vou entregar-te esta cidade». E Josué estendeu contra a cidade a lança que tinha na mão."
,"19":"Quando estendeu a mão, os que estavam na emboscada saíram a correr do seu lugar, entraram na cidade, tomaram-na e incendiaram-na rapidamente."
,"20":"Os homens de Hai voltaram para trás e viram o fumo da cidade a subir ao céu. Nenhum deles sabia para que lado escapar, pois o povo que fugia para o deserto voltou para atacar os perseguidores."
,"21":"Vendo que os homens da emboscada tinham tomado a cidade, pois o fumo subia da cidade, Josué e todo o Israel voltaram e atacaram os homens de Hai."
,"22":"Os outros que estavam na cidade saíram, fazendo com que os homens de Hai ficassem encurralados entre os israelitas, que os derrotaram, a ponto de não sobrar nenhum sobrevivente ou fugitivo."
,"23":"O rei de Hai foi capturado vivo e levado a Josué."
,"24":"Quando Israel acabou de matar todos os habitantes de Hai no campo, no deserto onde os haviam perseguido, e depois de todos eles terem caído ao fio da espada, os israelitas voltaram para Hai e passaram ao fio da espada toda a população."
,"25":"O total dos que caíram nesse dia, entre homens e mulheres, foi de doze mil, isto é, toda a população de Hai."
,"26":"Josué não retirou a mão com que havia estendido a lança, enquanto não foram eliminados todos os habitantes de Hai."
,"27":"Entretanto, Israel tomou como saque o gado e os despojos daquela cidade, como Javé havia ordenado a Josué."
,"28":"Josué incendiou Hai e reduziu-a para sempre a um montão de ruínas, que permanece até ao dia de hoje."
,"29":"Quanto ao rei de Hai, mandou enforcá-lo numa árvore até ao entardecer. Ao pôr do sol, Josué mandou que descessem da árvore o cadáver. E lançaram o cadáver à porta da cidade e levantaram sobre ele um montão de pedras, que permanece até ao dia de hoje."
,"30":"Josué construiu, então, para Javé, Deus de Israel, um altar no monte Ebal,"
,"31":"conforme Moisés, servo de Javé, havia ordenado aos israelitas, segundo o que está escrito no livro da Lei de Moisés: um altar de pedras brutas, sobre as quais nenhum instrumento de ferro tenha sido passado. E sobre ele ofereceram holocaustos a Javé e apresentaram sacrifícios de comunhão."
,"32":"Josué escreveu sobre as pedras uma cópia da Lei que Moisés havia escrito diante dos israelitas."
,"33":"Todo o Israel, com os anciãos, os oficiais e os juízes, estava de ambos os lados da arca, diante dos sacerdotes levitas, que transportavam a arca da aliança de Javé. E estavam juntos, tanto imigrantes como nativos: metade deles diante do monte Garizim, e a outra metade diante do monte Ebal, conforme tinha ordenado Moisés, servo de Javé, quando abençoou o povo de Israel pela primeira vez."
,"34":"A seguir, Josué leu todas as palavras da Lei, as bênçãos e maldições, conforme tudo o que está escrito no livro da Lei."
,"35":"Josué não omitiu nenhuma palavra de tudo o que Moisés tinha ordenado; leu tudo à assembleia de Israel, inclusive às mulheres, crianças e imigrantes que viviam com eles."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Ouvindo estas notícias, todos os reis da Cisjordânia, da região montanhosa, da planície e de toda a costa do Mar Mediterrâneo, até ao Líbano, tanto heteus, como amorreus, cananeus, ferezeus, heveus e jebuseus,"
,"2":"aliaram-se de comum acordo para combater contra Josué e Israel."
,"3":"Os habitantes de Gabaon, ouvindo o que Josué tinha feito a Jericó e Hai,"
,"4":"usaram um estratagema: juntaram provisões, carregaram os jumentos com sacos velhos e odres de vinho velhos, rasgados e consertados;"
,"5":"calçaram sandálias velhas remendadas, vestiram-se com roupas velhas, e o pão que levavam para comer era seco e esmigalhado."
,"6":"Foram, então, ter com Josué ao acampamento em Guilgal, e disseram a Josué e aos israelitas: «Viemos de uma terra distante. Fazei aliança connosco»."
,"7":"Os israelitas responderam a esses heveus: «Certamente que viveis aqui perto. Como podemos fazer aliança convosco?!»"
,"8":"Eles responderam a Josué: «Somos teus servos». Josué insistiu: «Quem sois vós e de onde vindes?»"
,"9":"Eles responderam: «Os teus servos vêm de uma terra muito distante, por causa do nome de Javé teu Deus, pois ouvimos falar da fama d'Ele e de tudo o que realizou no Egipto."
,"10":"Sabemos de tudo o que Ele fez aos dois reis amorreus da Transjordânia: a Seon, rei de Hesebon, e a Og, rei de Basã, em Astarot."
,"11":"Os nossos anciãos e o povo da nossa terra aconselharam-nos: 'Tomai convosco provisões para o caminho, ide ao encontro deles, e fazei-lhes a proposta de vos tornardes seus servos'. Portanto, fazei aliança connosco."
,"12":"Vede o nosso pão: estava quente quando lhe pegámos em nossas casas, no dia em que partimos para vir ter convosco; e agora aqui está ele, seco e esmigalhado."
,"13":"Estes odres de vinho eram novos quando os enchemos; e agora aqui estão, todos rasgados. As nossas roupas e sandálias estão gastas por causa do longo caminho que fizemos»."
,"14":"Os oficiais de Josué comeram das provisões deles, mas não consultaram Javé."
,"15":"Josué tratou-os pacificamente e fez aliança com eles, comprometendo-se a respeitar-lhes a vida. Os responsáveis pela comunidade também lhes prestaram um juramento."
,"16":"Três dias depois de terem feito aliança com eles, vieram a saber que eram seus vizinhos e que viviam ali perto,"
,"17":"pois os israelitas partiram e chegaram três dias depois às suas cidades: Gabaon, Cafira, Berot e Cariat-Iarim."
,"18":"Os israelitas não os atacaram, porque os responsáveis pela comunidade haviam-lhes feito um juramento por Javé, Deus de Israel. Por isso, toda a comunidade murmurou contra os responsáveis."
,"19":"Então os responsáveis explicaram à comunidade: «Nós fizemos-lhes um juramento por Javé, Deus de Israel, e por isso agora não podemos tratá-los mal."
,"20":"Vamos fazer o seguinte: respeitar-lhes-emos a vida, para que não venha sobre nós um castigo, por causa do juramento que já lhes fizemos»."
,"21":"Os responsáveis então decidiram: «Eles ficarão vivos, mas tornar-se-ão rachadores de lenha e aguadeiros para toda a comunidade». Todos concordaram com a proposta dos responsáveis. "
,"22":"Então Josué mandou chamar os gabaonitas e disse-lhes: «Porque nos enganastes, dizendo que vínheis de longe, quando na verdade morais perto de nós?"
,"23":"Pois bem! Daqui para a frente sereis malditos. Não deixareis de ser escravos, rachando lenha e transportando água para a casa do meu Deus»."
,"24":"Eles responderam a Josué: «Nós, teus servos, fomos informados de que Javé teu Deus tinha garantido a Moisés, seu servo, que vos entregaria toda a terra e exterminaria, diante de vós, todos os habitantes. Nós tememos muito pela nossa vida, e por isso agimos assim."
,"25":"Agora estamos nas tuas mãos: trata-nos conforme te parecer melhor e justo»."
,"26":"E Josué tratou-os como havia combinado, livrando-os da mão dos israelitas, que não os mataram."
,"27":"Nesse dia, Josué colocou-os como rachadores de lenha e aguadeiros ao serviço da comunidade e do altar de Javé, no lugar escolhido por Javé, até ao dia de hoje."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Adonisedec, rei de Jerusalém, soube que Josué havia tomado Hai e a consagrara ao extermínio; que havia tratado Hai e o seu rei como fizera com Jericó e o seu rei; que os habitantes de Gabaon tinham feito aliança com Israel e viviam no meio dos israelitas."
,"2":"Adonisedec ficou apavorado, pois Gabaon era uma cidade grande, como as cidades reais; era uma cidade maior do que Hai, e os seus guerreiros eram todos valentes."
,"3":"Então Adonisedec, rei de Jerusalém, enviou mensageiros a Hoam, rei de Hebron; a Faram, rei de Jarmut; a Jáfia, rei de Laquis; e a Dabir, rei de Eglon:"
,"4":"«Subi até aqui e ajudai-me! Precisamos de derrotar Gabaon, porque esta cidade fez aliança com Josué e os israelitas»."
,"5":"Os cinco reis amorreus - os reis de Jerusalém, de Hebron, de Jarmut, de Laquis e de Eglon - reuniram-se, subiram com os seus exércitos, cercaram e atacaram Gabaon."
,"6":"Os gabaonitas mandaram dizer a Josué, ao acampamento de Guilgal: «Não abandones os teus servos; vinde depressa até aqui para nos salvar. Ajuda-nos, pois todos os reis amorreus que habitam na serra se reuniram contra nós»."
,"7":"Então Josué subiu de Guilgal, levando toda a gente de guerra e todos os guerreiros valentes."
,"8":"Javé disse a Josué: «Não tenhas medo deles, que Eu os entregarei nas tuas mãos, e nenhum deles te conseguirá opor resistência»."
,"9":"Josué partiu de Guilgal e, depois de ter marchado a noite toda, atacou de surpresa os reis."
,"10":"Javé dispersou os inimigos diante de Israel, causando-lhes uma grande derrota em Gabaon; e perseguiu-os até ao caminho da subida de Bet-Horon, derrotando-os até Azeca e Maceda."
,"11":"Enquanto eles fugiam diante de Israel, na descida de Bet-Horon, Javé mandou do céu uma forte chuva de pedras grandes, que matou os inimigos até Azeca. Morreu mais gente por causa da chuva de pedras do que pela espada dos israelitas."
,"12":"No dia em que Javé entregou os amorreus aos israelitas, Josué falou a Javé e disse na presença de Israel: «Sol, detém-te sobre Gabaon! E tu, ó Lua, pára sobre o vale de Aialon!»"
,"13":"E o sol deteve-se e a lua ficou parada, até que o povo se vingou dos inimigos. No Livro do Justo está escrito assim: «O sol ficou parado no meio do céu,e um dia inteiro ficou sem ocaso."
,"14":"Nem antes, nem depois,houve um dia como aquele, quando Javé obedeceu,à voz de um homem. É porque Javé lutava a favor de Israel»."
,"15":"Depois Josué voltou, com todo o Israel, para o acampamento de Guilgal."
,"16":"Os cinco reis amorreus fugiram e esconderam-se na caverna de Maceda."
,"17":"Informaram então Josué de que os cinco reis estavam escondidos na caverna de Maceda."
,"18":"Josué disse: «Rolai pedras grandes até à entrada da caverna e colocai guardas junto dela."
,"19":"Vós, porém, não pareis: persegui os inimigos, cortai a retaguarda e não os deixeis entrar nas suas cidades, pois Javé, vosso Deus, entregou-os nas vossas mãos»."
,"20":"Quando Josué e os israelitas acabaram de derrotar os inimigos, exterminando-os, aqueles que conseguiram escapar vivos entraram nas cidades fortificadas."
,"21":"Todo o povo voltou são e salvo para o acampamento de Josué, em Maceda. E ninguém abriu a boca contra Israel."
,"22":"Então Josué disse: «Abri a entrada da caverna, tirai de lá os cinco reis e trazei-mos aqui»."
,"23":"Foram e tiraram da caverna os cinco reis: os reis de Jerusalém, de Hebron, de Jarmut, de Laquis e de Eglon."
,"24":"Quando lhe levaram esses reis, Josué convocou todos os homens de Israel e disse aos comandantes que o haviam acompanhado: «Vinde aqui e colocai o pé sobre o pescoço de cada um destes reis». Eles aproximaram-se e puseram o pé sobre o pescoço dos reis."
,"25":"Josué disse: «Não tenhais medo, nem vos acovardeis. Sede fortes e corajosos, porque Javé tratará da mesma forma a todos os inimigos, contra os quais tereis que lutar»."
,"26":"Em seguida, Josué matou os reis e mandou pendurá-los em cinco árvores, onde eles ficaram suspensos até ao entardecer."
,"27":"Ao pôr do sol, Josué mandou que fossem tirados das árvores e metidos na caverna onde se haviam escondido. Colocaram pedras grandes à entrada da caverna, as quais permanecem ali até ao dia de hoje."
,"28":"Nesse mesmo dia, Josué tomou Maceda, passou os habitantes ao fio da espada, consagrando ao extermínio o rei e todas as pessoas que nela se encontravam. Não deixou nenhum sobrevivente e tratou o rei de Maceda como havia tratado o rei de Jericó."
,"29":"Então Josué passou, com todo o Israel, de Maceda para Lebna, e começou o combate contra Lebna."
,"30":"Javé entregou também Lebna nas mãos de Israel, que passou ao fio da espada o rei e todos os que viviam na cidade. Não deixou nenhum sobrevivente, e tratou o rei como havia tratado o rei de Jericó."
,"31":"Então Josué passou, com todo o Israel, de Lebna para Láquis. Acampou em frente e começou a combatê-la."
,"32":"Javé entregou Láquis na mão de Israel que, no dia seguinte, tomou a cidade e passou ao fio da espada todas as pessoas que ali viviam, da mesma forma como já havia feito com Lebna."
,"33":"Horam, rei de Gazer, subiu para socorrer Láquis, mas Josué derrotou-o juntamente com o seu exército, sem lhe deixar nenhum sobrevivente."
,"34":"Então Josué passou, com todo o Israel, de Láquis para Eglon. Acampou em frente e começou a combatê-la."
,"35":"Nesse mesmo dia, tomaram a cidade e passaram ao fio da espada os habitantes, consagrando ao extermínio todas as pessoas que nela viviam, conforme tudo o que já haviam feito a Láquis."
,"36":"Depois Josué subiu, com todo o Israel, de Eglon para Hebron e começou a combatê-la."
,"37":"Tomaram a cidade e passaram ao fio da espada o seu rei, e toda a sua população e as cidades dependentes. Não ficou nenhum sobrevivente, conforme o que já haviam feito com Eglon. Consagraram a cidade ao extermínio, juntamente com todas as pessoas que nela viviam."
,"38":"Em seguida, Josué voltou-se, com todo o Israel, para Dabir, e começou a combatê-la."
,"39":"Tomou a cidade, bem como o seu rei e todas as cidades dependentes; passaram a população ao fio da espada, consagrando ao extermínio todas as pessoas que nela viviam. Não ficou nenhum sobrevivente. Josué tratou Dabir e o seu rei da mesma forma como havia feito a Hebron, a Lebna e aos seus reis."
,"40":"Desse modo, Josué conquistou toda a região montanhosa, o Negueb, a planície e as descidas das águas, juntamente com os seus reis. Não deixou nenhum sobrevivente, mas consagrou ao extermínio todo o ser vivo, como Javé, o Deus de Israel, havia ordenado."
,"41":"Josué conquistou desde Cades Barne até Gaza e toda a terra de Gósen até Gabaon."
,"42":"Josué tomou todos esses reis e seus territórios de uma só vez, porque Javé, Deus de Israel, combatia em favor de Israel."
,"43":"E Josué voltou, com todo o Israel, para o acampamento em Guilgal."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Jabin, rei de Hasor, ao ter conhecimento destas coisas, mandou mensageiros a Jobab, rei de Merom; ao rei de Semeron; ao rei de Acsaf;"
,"2":"aos reis que estavam na região montanhosa do Norte e na planície ao Sul de Quineret, nas planícies e nos planaltos de Dor, junto ao mar;"
,"3":"e aos cananeus do Oriente e do Ocidente; aos amorreus, heteus, ferezeus, jebuseus da serra e heveus aos pés do Hermon, na terra de Masfa."
,"4":"Eles saíram com as suas tropas, um exército tão numeroso como a areia da praia, com muitíssimos cavalos e carros."
,"5":"Todos esses reis se aliaram e foram juntos acampar perto do riacho Merom, para lutar contra Israel."
,"6":"Javé disse a Josué: «Não tenhas medo deles, pois amanhã, a esta hora, Eu os entregarei todos mortos na frente de Israel. Corta os tendões dos cavalos e queima os carros»."
,"7":"Josué e a sua gente de guerra foram contra eles junto do riacho Merom e caíram sobre eles de surpresa."
,"8":"Javé entregou-os nas mãos de Israel, que os derrotou e perseguiu até à grande Sidónia, até Maserefot, a Oeste, e até ao vale de Masfa, a Leste. Os israelitas derrotaram-nos, a ponto de não deixar um único sobrevivente."
,"9":"Josué tratou-os como Javé lhe havia ordenado: cortou os tendões dos cavalos e queimou os carros."
,"10":"Nesse mesmo tempo, Josué voltou, tomou Hasor e matou o rei ao fio de espada. Hasor era antes a capital de todos estes reinos."
,"11":"Passaram também ao fio da espada todas as pessoas que nela viviam, consagrando-as ao extermínio; não deixou ficar um único ser vivo, e incendiou Hasor."
,"12":"Josué tomou todas estas cidades e seus reis e passou-os ao fio da espada, consagrando-os ao extermínio, conforme Moisés, servo de Javé, havia ordenado."
,"13":"Israel, porém, não incendiou as cidades que estavam sobre as colinas; a única excepção foi Hasor, incendiada por Josué."
,"14":"Os israelitas saquearam os despojos e o gado dessas cidades, mas passaram todas as pessoas ao fio da espada, não deixando nenhum sobrevivente."
,"15":"O que Javé tinha ordenado a Moisés, seu servo, também Moisés o ordenou a Josué, e Josué cumpriu: não deixou de realizar nada do que Javé tinha ordenado a Moisés."
,"16":"Deste modo, Josué tomou esta terra toda: a região montanhosa, o Negueb, toda a terra de Gósen, a planície, a Arabá, a serra de Israel e a sua planície,"
,"17":"desde o monte Pelado, que sobe na direcção de Seir, até Baal-Gad, no vale do Líbano, ao pé do monte Hermon. Também prendeu e matou todos os seus reis."
,"18":"Josué esteve muito tempo a guerrear contra todos esses reis."
,"19":"Com excepção dos heveus que habitavam em Gabaon, nenhuma cidade fez as pazes com os israelitas, que as conquistaram todas pela força das armas."
,"20":"De facto, Javé tinha endurecido o coração destes reis, para guerrearem contra Israel, a fim de serem exterminados sem piedade e completamente destruídos, como Javé tinha ordenado a Moisés."
,"21":"Nesse tempo, Josué eliminou os enacim da região montanhosa de Hebron, de Dabir, de Anab, de toda a serra de Judá e de toda a serra de Israel. Josué consagrou-os ao extermínio juntamente com as suas cidades."
,"22":"Nenhum dos enacim restou na terra de Israel; só ficaram alguns em Gaza, Gat e Azoto."
,"23":"Josué apoderou-se de toda a Terra, como Javé tinha prometido a Moisés. E Josué entregou a Terra como herança aos israelitas, repartindo-a em lotes, segundo as tribos. E a Terra ficou em paz, sem guerra."
}`)
	CurrentBook.AddChapter(12, `{
"1":"São estes os reis da terra que os israelitas derrotaram e de cuja terra tomaram posse na Transjordânia, do lado Leste, desde o ribeiro Arnon até ao monte Hermon, bem como toda a Arabá no lado oriental:"
,"2":"Seon, rei dos amorreus, que habitava em Hesebon e dominava desde Aroer, que está à beira do vale do Arnon, e desde o meio do vale e a metade de Galaad até ao rio Jaboc, fronteira dos amonitas;"
,"3":"desde a Arabá até ao mar de Genesaré para o Oriente, e até ao mar de Arabá, o Mar Morto, para o Oriente, no caminho de Bet-Jesimot, e para Sul, abaixo das encostas do Fasga."
,"4":"Em seguida, o território de Og, rei de Basã, um dos últimos dos rafaim, que habitava em Astarot e Edrai,"
,"5":"e dominava o monte Hermon, Saleca e todo o Basã até às fronteiras dos gessuritas e dos maacatitas, bem como a metade de Galaad, fronteira de Seon, rei de Hesebon."
,"6":"Moisés, servo de Javé, e os israelitas derrotaram-nos. E Moisés, servo de Javé, deu as terras deles como propriedade aos rubenitas, aos gaditas e à meia tribo de Manassés."
,"7":"São estes os reis da terra que Josué e os israelitas derrotaram na Cisjordânia, no Oeste, desde Baal-Gad, no vale do Líbano, até ao monte Pelado, que sobe para Seir, cujas terras Josué entregou como propriedade às tribos de Israel, repartindo-as em lotes,"
,"8":"na região montanhosa e na planície, na Arabá e nas encostas, no deserto e no Negueb, onde estavam os heteus, amorreus, cananeus, ferezeus, heveus e jebuseus:"
,"9":"Rei de Jericó, um. Rei de Hai, que está junto de Betel, um."
,"10":"Rei de Jerusalém, um. Rei de Hebron, um."
,"11":"Rei de Jarmut, um. Rei de Laquis, um."
,"12":"Rei de Eglon, um. Rei de Gazer, um."
,"13":"Rei de Dabir, um. Rei de Gader, um."
,"14":"Rei de Horma, um. Rei de Arad, um."
,"15":"Rei de Lebna, um. Rei de Odolam, um."
,"16":"Rei de Maceda, um. Rei de Betel, um."
,"17":"Rei de Tafua, um. Rei de Ofer, um."
,"18":"Rei de Afec, um. Rei de Saron, um."
,"19":"Rei de Merom, um. Rei de Hasor, um."
,"20":"Rei de Semeron Meron, um. Rei de Acsaf, um."
,"21":"Rei de Tanac, um. Rei de Meguido, um."
,"22":"Rei de Cedes, um. Rei de Jecnaam do Carmelo, um."
,"23":"Rei de Dor, na região de Dor, um. Rei de Goim, em Guilgal, um."
,"24":"Rei de Tersa, um. Ao todo, trinta e um reis."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Josué envelheceu e estava com idade avançada, quando Javé lhe disse: «Estás velho e com idade avançada, e ainda ficou muitíssima terra por conquistar."
,"2":"Eis a terra que ainda ficou: Todas as regiões dos filisteus e toda a Gessur,"
,"3":"desde Sior, que está frente ao Egipto, até ao território de Acaron, ao Norte, que é considerado como pertencente aos cananeus. Cinco principados filisteus: de Gaza, de Azoto, de Ascalon, de Gat, e de Acaron. E ainda há os aveus"
,"4":"do Sul. Toda a terra dos cananeus e Maara, que pertence aos sidónios, até Afeca, até à fronteira dos amorreus."
,"5":"E ainda a terra dos habitantes de Biblos, e todo o Líbano oriental, desde Baal-Gad, aos pés do monte Hermon, até à entrada de Emat."
,"6":"E todos os que habitam na região montanhosa, desde o Líbano até Maserefot, a Oeste. E todos os sidónios. Eu os expulsarei da frente dos israelitas. Deves repartir a Terra como herança a Israel, conforme te ordenei."
,"7":"Agora, portanto, reparte esta Terra, para que seja a herança das nove tribos e da meia tribo de Manassés»."
,"8":"Com a outra meia tribo de Manassés, os rubenitas e os gaditas já haviam recebido a sua herança na Transjordânia, a Leste, como já lha havia dado Moisés, servo de Javé:"
,"9":"de Aroer, que está na margem do vale do Arnon, juntamente com a cidade que está no meio do vale; todo o planalto de Madaba até Dibon;"
,"10":"e todas as cidades de Seon, rei dos amorreus que reinava em Hesebon, até à fronteira dos amonitas;"
,"11":"e ainda Galaad e o território dos gessuritas e dos maacatitas, como também todo o monte Hermon e todo o Basã até Saleca;"
,"12":"e todo o reino de Og em Basã, que reinava em Astarot e Edrai, que ficara do resto dos rafaim, que Moisés havia derrotado e expulsado."
,"13":"Os israelitas, porém, não puderam expulsar os gessuritas e maacatitas. Por isso Gessur e Maacat continuaram a habitar no meio de Israel até ao dia de hoje."
,"14":"Apenas à tribo de Levi não deu Moisés nenhuma herança: a sua herança são as ofertas feitas a Javé, Deus de Israel, como já lhe havia dito."
,"15":"Moisés deu uma parte à tribo dos rubenitas, segundo os seus clãs."
,"16":"O seu território vai desde Aroer, que está na margem do vale do Arnon, juntamente com a cidade que está no meio do vale, e todo o planalto de Medaba;"
,"17":"Hesebon e todas as cidades que estão no planalto: Dibon, Bamot-Baal, Bet-Baal-Meon,"
,"18":"Jasa, Cedimot, Mefaat,"
,"19":"Cariataim, Sábama, Sarat-Asaar na serra de Arabá,"
,"20":"Bet-Fegor; as encostas do Fasga; Bet-Jesimot;"
,"21":"todas as cidades do planalto e todo o reino de Seon, rei dos amorreus, que reinava em Hesebon, a quem Moisés derrotou, derrotando também os príncipes de Madiã, Evi, Recém, Sur, Hur e Rebe, vassalos de Seon, que habitavam na Terra."
,"22":"Quanto ao adivinho Balaão, filho de Beor, os israelitas mataram-no à espada juntamente com os outros."
,"23":"A fronteira dos rubenitas é o Jordão e suas imediações. Esta é a herança dos rubenitas, conforme os seus clãs: as cidades com as suas aldeias."
,"24":"Moisés deu uma parte à tribo de Gad, aos gaditas, conforme os seus clãs."
,"25":"O seu território é Jazer, todas as cidades de Galaad, metade da terra dos amonitas, até Aroer, que está defronte de Rabá;"
,"26":"desde Hesebon até Ramot-Masfa e Betonim, desde Maanaim até ao território de Lo-Dabar;"
,"27":"e, no vale, Bet-Aram, Bet-Nemra, Sucot e Safon, o resto do reino de Seon, rei de Hesebon, com o Jordão e imediações, até à extremidade do mar de Genesaré, na Transjordânia, a Leste."
,"28":"Esta é a herança dos gaditas, conforme os seus clãs: as cidades com as suas aldeias."
,"29":"Moisés deu uma parte à meia tribo de Manassés, conforme os seus clãs."
,"30":"O seu território vai desde Maanaim, todo o Basã, todo o reino de Og, rei de Basã, e todas as aldeias de Jair que estão em Basã: cerca de sessenta cidades;"
,"31":"metade de Galaad, Astarot e Edrai, cidades do reino de Og em Basã, foram dadas aos descendentes de Maquir, filho de Manassés, isto é, à metade dos maquiritas, conforme os seus clãs."
,"32":"Foi esta a herança que Moisés repartiu nas planícies de Moab, na Transjordânia, a Leste de Jericó."
,"33":"À tribo de Levi, porém, Moisés não deu nenhuma herança, porque Javé, Deus de Israel, é a sua herança, como já lhes havia dito."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Eis o que os israelitas herdaram na terra de Canaã, o que o sacerdote Eleazar, Josué filho de Nun, e os chefes de famílias das tribos dos israelitas lhes deram como herança."
,"2":"A herança foi dada por sorteio, como Javé ordenara por meio de Moisés, às nove tribos e à meia tribo,"
,"3":"uma vez que Moisés já havia dado na Transjordânia uma herança às duas tribos e à meia tribo. Aos levitas, porém, não deu nenhuma herança no meio dos outros."
,"4":"Os descendentes de José, de facto, formavam duas tribos: Manassés e Efraim. E aos levitas não foi dada uma parte na terra, mas apenas cidades para habitarem, com os arredores para os seus rebanhos e bens."
,"5":"Os israelitas agiram como Javé ordenara a Moisés, e repartiram a Terra."
,"6":"Os descendentes de Judá foram ao encontro de Josué em Guilgal. Então Caleb, filho de Jefoné, o cenezeu, disse-lhe: «Tu sabes o que Javé disse a Moisés, homem de Deus, em Cades Barne, a respeito de mim e de ti."
,"7":"Eu tinha quarenta anos quando Moisés, servo de Javé, me enviou de Cades Barne para explorar a Terra, e eu fiz-lhe um relatório merecedor de fé."
,"8":"Os meus irmãos que tinham ido comigo desanimaram o povo. Eu, porém, segui fielmente a Javé meu Deus."
,"9":"E nesse dia Moisés prometeu: 'A Terra onde puseste o teu pé pertencerá a ti e aos teus filhos, como herança para sempre, porque seguiste fielmente a Javé meu Deus'."
,"10":"Pois bem, Javé conservou-me vivo, conforme prometera. Quarenta e cinco anos se passaram desde que Javé disse isso a Moisés, quando Israel andava pelo deserto. Eis que agora eu tenho oitenta e cinco anos."
,"11":"Hoje ainda estou forte, como no dia em que Moisés me enviou: sinto-me agora tão forte como naquela ocasião, para ir e voltar da guerra."
,"12":"Dá-me, portanto, esta montanha, da qual Javé falou naquele dia; pois naquele dia ouviste dizer que viviam lá os enacim e havia grandes cidades fortificadas. Oxalá Javé esteja comigo, e eu consiga expulsá-los, como Javé prometeu»."
,"13":"Josué abençoou Caleb, filho de Jefoné, e deu-lhe Hebron como herança."
,"14":"É por isso que Hebron pertence a Caleb, filho de Jefoné, o cenezeu, até ao dia de hoje, visto que ele seguiu fielmente a Javé, Deus de Israel."
,"15":"Outrora o nome de Hebron era Cariat-Arbe. Arbe tinha sido o maior homem dentre os enacim. E a Terra ficou em paz, sem guerra."
}`)
	CurrentBook.AddChapter(15, `{
"1":"A porção que tocou à tribo dos descendentes de Judá, conforme os seus clãs, estende-se até à fronteira de Edom, a Sul do deserto de Sin, no extremo Sul."
,"2":"A sua fronteira Sul vai desde o Mar Morto, desde a língua de terra que olha para o Sul,"
,"3":"e se prolonga para o Sul da subida dos Escorpiões, passa por Sin e sobe ao Sul de Cades Barne; passa por Hesron, sobe a Adar e rodeia Carca;"
,"4":"depois corre por Asemona, prolonga-se até ao rio do Egipto, terminando no mar. «Esta será a vossa fronteira Sul»."
,"5":"A sua fronteira no lado oriental é o Mar Morto até à foz do Jordão. Do lado Norte, a fronteira vai desde a língua de mar na foz do Jordão,"
,"6":"sobe depois a Bet-Hogla, passa ao Norte de Bet-Arabá e sobe até à Pedra de Boen, filho de Rúben;"
,"7":"essa fronteira sobe ainda até Dabir, desde o vale de Acor, olhando para o Norte, rumo a Guilgal, que está defronte da encosta de Adomim, o Sul do riacho; daí, a fronteira passa junto das águas de En-Sames, para terminar na direcção de En-Roguel;"
,"8":"deste ponto, sobe pelo vale de Ben-Enom, pelo flanco Sul dos jebuseus - isto é, Jerusalém - e sobe até ao cimo do monte que está diante do vale de Enom, a Oeste, na extremidade do vale dos rafaim, a Norte;"
,"9":"a fronteira vira depois, desde o cimo do monte até à fonte das águas de Neftoa, prolonga-se até às cidades do monte Efron e vira na direcção de Baala, isto é, Cariat-Iarim."
,"10":"De Baala, a fronteira volta-se para Oeste até ao monte Seir; passa ao lado do monte de Jearim a Norte, isto é, Queslon; depois, descendo a Bet-Sames, passa por Tamna."
,"11":"A fronteira segue ainda ao lado de Acaron para o Norte e, indo a Secron, passa o monte de Baala, saindo de Jebneel, terminando no mar."
,"12":"O limite Oeste era o Grande Mar e imediações. Este é, de todos os lados, o território dos descendentes de Judá, conforme os seus clãs."
,"13":"A Caleb, filho de Jefoné, Josué deu uma parte no meio dos descendentes de Judá, como Javé lhe ordenara, isto é, Cariat-Arbe, que é Hebron. Arbe era o pai de Enac."
,"14":"Caleb expulsou de lá os três filhos de Enac: Sesai, Aimã e Tolmai, descendentes de Enac."
,"15":"Daí subiu contra os habitantes de Dabir, outrora chamada Cariat-Séfer."
,"16":"Disse Caleb: «A quem derrotar Cariat-Séfer e a capturar, darei minha filha Acsa por mulher»."
,"17":"E quem a tomou foi Otoniel, filho de Cenez, parente de Caleb; este deu-lhe a filha Acsa por mulher."
,"18":"Ora, desde que esta chegou, Otoniel insistiu com ela que pedisse ao pai um campo. Então ela apeou-se do jumento, e Caleb perguntou-lhe: «Que queres?»"
,"19":"Ela respondeu: «Dá-me um presente. Tu deste-me terra seca. Dá-me também fontes de água». Então ele deu-lhe as fontes de cima e as fontes de baixo."
,"20":"Esta é a herança da tribo dos descendentes de Judá, conforme os seus clãs."
,"21":"As cidades dos descendentes de Judá no extremo Sul, rumo à fronteira de Edom, no Negueb, são estas: Cabseel, Arad, Jagur,"
,"22":"Cina, Dimona, Aroer,"
,"23":"Cades, Hasor-Jetnã,"
,"24":"Zif, Telém, Balot,"
,"25":"Hasor-Adata, Cariot-Hesron - que é Hasor -,"
,"26":"Amam, Sama, Molada,"
,"27":"Haser-Gada, Hasemon, Bet-Félet,"
,"28":"Hasor-Sual, Bersabeia com as suas imediações,"
,"29":"Baala, Jim, Esem,"
,"30":"Eltolad, Cesil, Horma,"
,"31":"Siceleg, Madmana, Sensena,"
,"32":"Lebaot, Selim, Ain e Remon: ao todo, vinte e nove cidades com as suas aldeias."
,"33":"E na planície: Estaol, Saraá, Asena,"
,"34":"Zanoe, En-Ganim, Tafua, Enaim,"
,"35":"Jarmut, Odolam, Soco, Azeca,"
,"36":"Saraim, Aditaim, Gedera e Gederotaim: catorze cidades com as suas aldeias."
,"37":"Sanã, Hadasa, Magdol-Gad,"
,"38":"Deleã, Masfa, Jecetel,"
,"39":"Láquis, Bascat, Eglon,"
,"40":"Quebon, Leemas, Cetlis,"
,"41":"Gederot, Bet-Dagon, Naama e Maceda: dezasseis cidades com as suas aldeias."
,"42":"Lebna, Eter, Asã,"
,"43":"Jefta, Esna, Nesib,"
,"44":"Ceila, Aczib e Maresa: nove cidades com as suas aldeias."
,"45":"Acaron, com as suas vilas e aldeias;"
,"46":"e desde Acaron até ao mar, todas as que estão no lado de Azoto, com as suas aldeias."
,"47":"Azoto com as suas vilas e aldeias; Gaza com as suas vilas e aldeias até ao rio do Egipto e ao Grande Mar com as suas imediações."
,"48":"E na serra: Saamir, Jeter, Soco,"
,"49":"Dana, Cariat-Séfer, que é Dabir,"
,"50":"Anab, Estemo, Anim,"
,"51":"Gósen, Holon e Gilo: onze cidades com as suas aldeias."
,"52":"Arab, Duma, Esaã,"
,"53":"Janum, Bet-Tafua, Afeca,"
,"54":"Hamata, Cariat-Arbe, que é Hebron, e Sior: nove cidades com as suas aldeias."
,"55":"Maon, Carmel, Zif, Jota,"
,"56":"Jezrael, Jucadam, Zanoe,"
,"57":"Acain, Gabaá e Tamna: dez cidades com as suas aldeias."
,"58":"Halul, Bet-Sur, Gedor,"
,"59":"Maret, Bet-Anot e Eltecon: seis cidades com as suas aldeias. (Técua, Éfrata, hoje Belém, Fegor, Etam, Gulon, Tatam, Sores, Carem, Galim, Beter e Manaat: onze cidades com as suas aldeias)."
,"60":"Cariat-Baal, que é Cariat-Iarim, e Areba: duas cidades com as suas aldeias."
,"61":"No deserto: Bet-Arabá, Medin, Sacaca,"
,"62":"Nebsã, Cidade do Sal e Engadi: seis cidades com as suas aldeias."
,"63":"Os descendentes de Judá, porém, não conseguiram expulsar os jebuseus que habitavam em Jerusalém. É por isso que os jebuseus habitam com os descendentes de Judá em Jerusalém até ao dia de hoje."
}`)
	CurrentBook.AddChapter(16, `{
"1":"A sorte que tocou aos descendentes de José vai desde o Jordão, perto de Jericó, a Leste das águas de Jericó. É o deserto que sobe de Jericó pela montanha de Betel;"
,"2":"saindo de Betel, vai até Luza, passando pela fronteira dos araquitas, em Atarot,"
,"3":"e desce pelo Oeste até à fronteira dos jeflatitas, até à fronteira de Bet-Horon Inferior, e até Gazer, terminando no mar."
,"4":"Foi assim que Manassés e Efraim, filhos de José, tiveram também a sua herança."
,"5":"Eis o território dos efraimitas, conforme os seus clãs: A fronteira da sua herança a Leste é Atarot-Arac, até Bet-Horon superior;"
,"6":"a Oeste, a fronteira vai em direcção ao mar com Macmetat ao Norte, de onde volta para Leste até Tanat-Silo, passando depois a Leste de Janoe;"
,"7":"desce desde Janoe até Atarot e Naarata, chega a Jericó, terminando no Jordão;"
,"8":"de Tafua a fronteira vai para Oeste pelo riacho de Caná, terminando no mar. Esta é a herança da tribo dos efraimitas, conforme os seus clãs,"
,"9":"sem contar as cidades reservadas aos efraimitas no meio da herança dos manasseítas: todas estas cidades com as suas aldeias."
,"10":"Eles, porém, não conseguiram expulsar os cananeus que habitavam em Gazer. É por isso que os cananeus habitam no meio de Efraim até ao dia de hoje, mas estão sujeitos a trabalhos forçados."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Eis a porção que tocou à tribo de Manassés, por ser o primogénito de José. A Maquir, primogénito de Manassés, pai de Galaad, coube Galaad e Basã, pois ele era homem de guerra."
,"2":"Aos outros filhos de Manassés, conforme os seus clãs, coube o seguinte: aos filhos de Abiezer, aos filhos de Helec, aos filhos de Esriel, aos filhos de Sequem, aos filhos de Héfer, aos filhos de Semida, isto é, aos filhos de sexo masculino de Manassés, filho de José, conforme os seus clãs."
,"3":"Salfaad, filho de Héfer, filho de Galaad, filho de Maquir, filho de Manassés, não teve filhos, mas somente filhas, que se chamavam Maala, Noa, Hegla, Melca e Tersa."
,"4":"Elas apresentaram-se ao sacerdote Eleazar, a Josué, filho de Nun, e aos representantes. E disseram: «Javé ordenou a Moisés que nos desse uma herança no meio dos nossos irmãos». Então eles deram-lhes, conforme a ordem de Javé, uma herança no meio dos irmãos de seu pai."
,"5":"Deste modo, couberam também dez partes a Manassés, além da terra de Galaad e Basã, na Transjordânia,"
,"6":"pois as filhas de Manassés receberam uma herança no meio dos seus filhos, enquanto que a terra de Galaad ficou para os outros filhos de Manassés."
,"7":"A fronteira de Manassés vai desde Aser até Macmetat, a Leste de Siquém; pelo Sul essa fronteira vai até aos habitantes da fonte de Tafua."
,"8":"Manassés tinha a terra de Tafua. Tafua, porém, embora estivesse no território de Manassés, pertencia aos efraimitas."
,"9":"A fronteira desce então até ao riacho de Caná. As cidades, entre as de Manassés, a Sul do riacho, pertenciam a Efraim. E a fronteira de Manassés estava a Norte do riacho, terminando no mar."
,"10":"E o limite de Efraim a Sul e de Manassés a Norte, era o mar. Estavam em contacto com Aser a Norte e Issacar a Leste."
,"11":"Em Issacar e Aser, Manassés tinha Betsã e suas vilas, Jeblaam e suas vilas, os habitantes de Dor e suas vilas, os habitantes de Endor e suas vilas, os habitantes de Tanac e suas vilas, e os habitantes de Meguido e suas vilas: são as três colinas."
,"12":"Os descendentes de Manassés, porém, não conseguiram expulsar os habitantes dessas cidades, e os cananeus continuaram a habitar nessa terra."
,"13":"Quando se tornaram fortes, os israelitas submeteram os cananeus a trabalhos forçados, mas não chegaram a expulsá-los."
,"14":"Os descendentes de José reclamaram com Josué: «Porque nos deste como herança apenas uma porção, só uma parte, sendo nós um povo tão numeroso, visto que Javé nos abençoou até agora?»"
,"15":"Josué respondeu-lhes: «Se sois um povo tão numeroso, subi ao bosque e abri ali um lugar para vós na terra dos ferezeus e dos rafaim, já que a serra de Efraim é estreita de mais para vós»."
,"16":"Os descendentes de José replicaram: «A serra não é suficiente para nós, e além disso todos os cananeus que habitam na terra do vale têm carros de ferro, tanto aqueles que estão em Betsã e suas vilas, como aqueles que estão no vale de Jezrael»."
,"17":"Josué disse então a Efraim e Manassés, a família de José: «Vós sois um povo numeroso e forte. Por isso, não tereis apenas uma parte,"
,"18":"mas a serra toda será vossa. Embora seja um bosque, podeis cortá-lo e pertencer-vos-á todo, até às extremidades. Além disso, expulsareis os cananeus, embora eles tenham carros de ferro e sejam fortes»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Toda a comunidade dos israelitas se reuniu em Silo, e ali armaram a tenda da reunião. A terra tinha-lhes sido submetida."
,"2":"Contudo, dentre os israelitas restavam sete tribos que ainda não haviam recebido a sua herança."
,"3":"Josué disse então aos israelitas: «Até quando ides esperar para tomar posse da terra que Javé, Deus dos vossos antepassados, vos deu?"
,"4":"Escolhei três homens de cada tribo, e eu os enviarei. Eles dispor-se-ão, percorrerão a terra e farão dela um mapa dividido por heranças. Depois virão ter comigo."
,"5":"Dividirão a terra em sete partes: Judá permanecerá no seu território, a Sul, e a casa de José no seu, a Norte."
,"6":"Fazei o mapa da terra em sete partes e trazei-mo, para que eu faça um sorteio entre vós aqui diante de Javé, nosso Deus."
,"7":"Os levitas não têm nenhuma parte entre vós, porque a parte deles é serem sacerdotes de Javé. Quanto a Gad, a Rúben e à meia tribo de Manassés, já receberam na Transjordânia a herança que Moisés, servo de Javé lhes deu»."
,"8":"Quando os homens se dispuseram para partir, Josué ordenou aos que iam fazer o mapa da terra: «Percorrei a terra para fazer o mapa. Depois, vinde ter comigo, para que eu faça o sorteio entre vós, diante de Javé, em Silo»."
,"9":"Os homens partiram, atravessaram a terra e descreveram-na num livro, cidade por cidade, em sete partes. Depois foram ter com Josué, ao acampamento de Silo."
,"10":"Então Josué fez um sorteio entre eles, diante de Javé, em Silo. Foi ali que Josué fez a partilha da terra aos israelitas."
,"11":"Fez-se o sorteio para a tribo dos benjaminitas, conforme os seus clãs. O território que lhes coube no sorteio fica entre os descendentes de Judá e os descendentes de José."
,"12":"Do lado Norte, a sua fronteira parte do Jordão; sobe ao lado de Jericó para Norte; depois, sobe pela serra em direcção a Oeste, terminando no deserto, em Bet-Áven;"
,"13":"dali, a fronteira passa por Luza, ao lado de Luza - isto é, Betel - em direcção a Sul, descendo depois até Atarot-Adar, pelo monte que está a Sul de Bet-Horon Inferior."
,"14":"A fronteira então volta do lado Oeste para Sul, desde o monte que está diante de Bet-Horon a Sul, indo terminar em Cariat-Baal, isto é, Cariat-Iarim, cidade dos descendentes de Judá. Esse é o lado ocidental."
,"15":"O lado Sul começa em Cariat-Iarim. A fronteira segue para Oeste em direcção à fonte das águas de Neftoa;"
,"16":"depois, a fronteira desce até à extremidade do monte que está em frente do vale de Ben-Enom, a Norte do vale dos rafaim; e vai descendo o vale de Enom, ao lado dos jebuseus para Sul, indo até En-Roguel;"
,"17":"volta então para Norte, chega a En-Sames, de onde sai para o círculo de pedras que está diante da subida de Adomim, e desce até à Pedra de Boen, descendente de Rúben;"
,"18":"passa depois por Quetef, na encosta para Norte, diante de Arabá, e desce para a Arabá."
,"19":"A fronteira passa depois ao lado de Bet-Hegla a Norte, para terminar na laguna do mar Morto a Norte, na extremidade Sul do Jordão. Esta é a fronteira Sul."
,"20":"No lado oriental, a fronteira é o Jordão. Esta é a herança dos benjaminitas, conforme os seus clãs, com as fronteiras de todos os lados."
,"21":"E são estas as cidades da tribo dos benjaminitas, conforme os seus clãs: Jericó, Bet-Hegla, Amec-Casis,"
,"22":"Bet-Arabá, Samaraim, Betel,"
,"23":"Avim, Fara, Efra,"
,"24":"Cafar-Emona, Ofni e Gaba; são doze cidades com as suas aldeias."
,"25":"Gabaon, Ramá, Berot,"
,"26":"Masfa, Cafira, Mosa,"
,"27":"Recém, Jarafel, Tarala,"
,"28":"Sela-Elef, Jebus, que é Jerusalém, Gabaá e Cariat: catorze cidades com as suas aldeias. Esta é a herança dos benjaminitas, conforme os seus clãs."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Na segunda vez, o sorteio saiu a Simeão, à tribo dos simeonitas, conforme os seus clãs. A sua herança ficou no meio da herança dos descendentes de Judá."
,"2":"Tocou-lhes como herança: Bersabeia, Saba, Molada,"
,"3":"Haser-Sual, Bela, Asem,"
,"4":"Eltolad, Betul, Horma,"
,"5":"Siceleg, Bet-Marcabot, Haser-Susa,"
,"6":"Bet-Lebaot e Saroen: treze cidades com as suas aldeias."
,"7":"Ain, Remon, Atar e Asã: quatro cidades com as suas aldeias,"
,"8":"e também todas as aldeias que estão ao redor dessas mesmas cidades, até Baalat-Beer, que é Ramá do Negueb. Esta foi a herança da tribo dos simeonitas, conforme os seus clãs."
,"9":"A herança dos simeonitas foi tirada da parte dos descendentes de Judá, pois era demasiadamente grande para eles. É por isso que os simeonitas receberam a sua herança no meio da herança dos descendentes de Judá."
,"10":"Na terceira vez, o sorteio saiu a Zabulon, conforme os seus clãs. A fronteira da sua herança vai até Sadud,"
,"11":"sobe pelo Oeste até Merala, toca Debaset e chega até ao riacho que está na frente de Jecnaam."
,"12":"De Sadud, ela volta para Leste, para o sol nascente, até ao limite de Ceselet-Tabor; sai na direcção de Daberet e sobe até Jáfia;"
,"13":"daí, continua para Leste, passa por Gat-Héfer e Etacasim, continua até Remon e volta na direcção de Noa;"
,"14":"depois, a fronteira contorna pelo Norte de Hanaton, para terminar no vale de Jectael;"
,"15":"aí estão Catet, Naalol, Semeron, Jerala e Belém: doze cidades com as suas aldeias."
,"16":"Esta é a herança dos zabulonitas, conforme os seus clãs: todas estas cidades com as suas aldeias."
,"17":"Na quarta vez, o sorteio saiu a Issacar, para os descendentes de Issacar, conforme os seus clãs."
,"18":"O seu território compreende: Jezrael, Casalot, Suném,"
,"19":"Hafaraim, Seon, Anaarat,"
,"20":"Daberat, Cesion, Abes,"
,"21":"Ramet, En-Ganim, En-Hada, Bet-Fases."
,"22":"A fronteira chega ao Tabor, Seesima e Bet-Sames, terminando no Jordão: dezasseis cidades com as suas aldeias."
,"23":"Esta é a herança dos descendentes de Issacar, conforme os seus clãs: todas estas cidades com as suas aldeias."
,"24":"Na quinta vez, o sorteio saiu à tribo dos aseritas, conforme os seus clãs."
,"25":"O seu território compreende Halcat, Cali, Beten, Acsaf,"
,"26":"Elmelec, Amaad e Messal; a sua fronteira Oeste toca o Carmelo e o rio Labanat,"
,"27":"volta-se para Leste até Bet-Dagon, toca Zabulon e o vale de Jeftael, ao Norte de Bet-Emec e de Neiel, e sai pela esquerda em direcção a Cabul,"
,"28":"Abdon, Roob, Hamon e Caná, até à grande Sidónia;"
,"29":"a fronteira volta depois para Ramá, até à cidade fortificada de Tiro; torna então a Hosa, terminando no mar, na região de Aczib."
,"30":"Ali estão Aco, Afec e Roob: vinte e duas cidades com as suas aldeias."
,"31":"Esta é a herança da tribo dos descendentes de Aser, conforme os seus clãs: todas estas cidades com as suas aldeias."
,"32":"Na sexta vez, o sorteio saiu aos descendentes de Neftali, conforme os seus clãs:"
,"33":"a sua fronteira vai desde Helef e do carvalho de Saananim, Adami-Neceb, Jebnael, até Lecum, terminando no Jordão."
,"34":"A fronteira volta para Oeste até Aznot-Tabor, de onde passa para Hucoca: toca Zabulon a Sul, Aser a Oeste e o Jordão a Leste."
,"35":"As cidades fortificadas são: Asedim, Ser, Emat, Recat, Quineret,"
,"36":"Edema, Rama, Hasor,"
,"37":"Cedes, Edrai, En-Hasor,"
,"38":"Jeron, Magdalel, Horém, Bet-Anat e Bet-Sames: dezanove cidades com as suas aldeias."
,"39":"Esta é a herança da tribo dos descendentes de Neftali, conforme os seus clãs: todas estas cidades com as suas aldeias."
,"40":"Na sétima vez, o sorteio saiu à tribo dos danitas, conforme os seus clãs."
,"41":"O território da sua herança compreende Saraá, Estaol, Ir-Sames,"
,"42":"Salebi, Aialon, Silata,"
,"43":"Elon, Tamna, Acaron,"
,"44":"Eltece, Gebeton, Baalat,"
,"45":"Azor, Bené-Barac, Gat-Remon,"
,"46":"as águas do Jarcon e do Racon, com o território que está diante de Jope."
,"47":"O território dos danitas, contudo, saíra pequeno. Então os danitas subiram para guerrear contra Lesem, e tomaram-na, passando-a ao fio da espada. Apossaram-se dela e habitaram nela, dando-lhe o nome de Dã, por causa de Dã, o nome do seu antepassado."
,"48":"Esta foi a herança da tribo dos danitas, conforme os seus clãs: todas estas cidades com as suas aldeias."
,"49":"E assim acabaram de repartir a Terra em herança, conforme os seus territórios. Em seguida, os israelitas deram a Josué, filho de Nun, uma herança no meio deles."
,"50":"Conforme a ordem de Javé, deram-lhe a cidade que ele pedira, Tamnat-Saraá, na serra de Efraim. Ele reconstruiu a cidade e ali se estabeleceu."
,"51":"São estas as heranças que o sacerdote Eleazar e Josué, filho de Nun, juntamente com os chefes de família das tribos dos israelitas, repartiram, tirando a sorte em Silo, diante de Javé, à porta da tenda da reunião. E assim acabaram de repartir a Terra."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Javé disse a Josué:"
,"2":"«Diz aos israelitas: Separai as cidades de refúgio, sobre as quais vos falei por meio de Moisés."
,"3":"E assim poderá fugir para elas o homicida que sem querer tiver matado alguém. Assim elas servir-vos-ão de refúgio diante do vingador do sangue."
,"4":"O homicida poderá fugir para uma dessas cidades e, colocando-se à entrada da porta da cidade, poderá expor o caso aos anciãos dessa cidade. Estes acolhê-lo-ão na cidade e dar-lhe-ão um lugar para que habite com eles."
,"5":"Se o vingador do sangue o perseguir, eles não lhe poderão entregar o homicida, pois foi sem querer que matou o próximo, e não porque antes o tivesse odiado."
,"6":"Ele estabelecer-se-á nessa cidade até comparecer ao julgamento diante da comunidade, até à morte do chefe dos sacerdotes que estiver em função nesses dias. Depois disso, o homicida poderá regressar, voltando para a sua cidade e a sua casa, para a cidade de onde fugira»."
,"7":"Eles consagraram então Cedes, na Galileia, na serra de Neftali; Siquém, na serra de Efraim e Cariat-Arbe, que é Hebron, na serra de Judá."
,"8":"Na Transjordânia, a Leste de Jericó, separaram Bosor, no deserto, no planalto da tribo de Rúben. Ramot de Galaad, na tribo de Gad. E Golã, em Basã, na tribo de Manassés."
,"9":"Foram estas as cidades designadas para todos os israelitas e para o imigrante que estivesse a viver entre eles, a fim de que nelas pudesse refugiar-se quem tivesse matado involuntariamente. Deste modo, não morreria pela mão do vingador do sangue antes de ter comparecido diante da comunidade."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Os chefes de família de Levi apresentaram-se ao sacerdote Eleazar, a Josué, filho de Nun, e aos chefes de família das tribos dos israelitas,"
,"2":"em Silo, na terra de Canaã. E disseram-lhes: «Javé ordenou, por meio de Moisés, que nos fossem dadas cidades para habitar, juntamente com os seus arredores para os nossos rebanhos»."
,"3":"Então, conforme a ordem de Javé, os israelitas, da sua herança, deram aos levitas as seguintes cidades juntamente com os seus arredores:"
,"4":"O sorteio saiu aos clãs dos caatitas. Assim, os descendentes do sacerdote Aarão, dentre os levitas, receberam por sorteio treze cidades da tribo de Judá, da tribo de Simeão e da tribo de Benjamim."
,"5":"Os outros descendentes de Caat receberam por sorteio dez cidades dos clãs da tribo de Efraim, da tribo de Dã e da meia tribo de Manassés."
,"6":"Os descendentes de Gérson receberam por sorteio treze cidades em Basã, dos clãs da tribo de Issacar, da tribo de Neftali e da meia tribo de Manassés."
,"7":"Os descendentes de Merari, conforme os seus clãs, receberam por sorteio doze cidades da tribo de Rúben, da tribo de Gad e da tribo de Zabulon."
,"8":"Os israelitas deram aos levitas essas cidades juntamente com os arredores, fazendo sorteio, como Javé lhes havia ordenado por meio de Moisés."
,"9":"Da tribo dos descendentes de Judá e da tribo dos descendentes de Simeão, eles deram as seguintes cidades que vão ser designadas pelos nomes:"
,"10":"Aos descendentes de Aarão, pertencentes aos clãs dos caatitas, dentre os levitas - porquanto na primeira vez o sorteio lhes saiu a eles -"
,"11":"deram Cariat-Arbe, que é Hebron, na serra de Judá, com os arredores que a cercam. Arbe era o pai de Enac."
,"12":"O campo da cidade com as suas aldeias, porém, foi dado como propriedade a Caleb, filho de Jefoné."
,"13":"Como cidades de refúgio para o homicida, deram aos descendentes do sacerdote Aarão: Hebron com os arredores, Lebna com os arredores,"
,"14":"Jeter com os arredores, Estemo com os arredores,"
,"15":"Holon com os arredores, Dabir com os arredores,"
,"16":"Asã com os arredores, Jeta com os arredores, Bet-Sames com os arredores: nove cidades dessas duas tribos."
,"17":"Da tribo de Benjamim: Gabaon com os arredores, Gaba com os arredores,"
,"18":"Anatot com os arredores, Almon com os arredores: quatro cidades."
,"19":"Total das cidades dos sacerdotes, descendentes de Aarão: treze cidades com os arredores."
,"20":"Os clãs levíticos dos outros filhos de Caat receberam por sorteio cidades da tribo de Efraim."
,"21":"Como cidades de refúgio para o homicida deram-lhes: Siquém com os arredores na serra de Efraim, Gazer com os arredores,"
,"22":"Cibsaim com os arredores, Bet-Horon com os arredores: quatro cidades."
,"23":"Da tribo de Dã: Eltece com os arredores, Gebaton com os arredores,"
,"24":"Aialon com os arredores, Gat-Remon com os arredores: quatro cidades."
,"25":"Da meia tribo de Nanassés: Tanac com os arredores, Jeblaam com os arredores: duas cidades."
,"26":"Total: dez cidades com os arredores, para os clãs dos outros filhos de Caat."
,"27":"Aos descendentes de Gérson, dos clãs levíticos, deram como cidades de refúgio para o homicida, na meia tribo de Manassés: Golã em Basã com os arredores e Beesterá com os arredores: duas cidades."
,"28":"Da tribo de Issacar: Cesion com os arredores, Daberat com os arredores,"
,"29":"Jarmut com os arredores, En-Ganim com os arredores: quatro cidades."
,"30":"Da tribo de Aser: Masal com os arredores, Abdon com os arredores,"
,"31":"Helcat com os arredores, Roob com os arredores: quatro cidades."
,"32":"Da tribo de Neftali, deram como cidades de refúgio para o homicida: Cedes na Galileia com os arredores, Hamot-Dor com os arredores, Cartã com os arredores: três cidades."
,"33":"Total das cidades dos gersonitas, conforme os seus clãs: treze cidades com os arredores."
,"34":"Aos outros levitas dos clãs dos descendentes de Merari, deram da parte da tribo de Zabulon: Jecnaam com os arredores, Carta com os arredores,"
,"35":"Demna com os arredores, Naalol com os arredores: quatro cidades."
,"36":"Da tribo de Rúben: Bosor com os arredores, Jasa com os arredores,"
,"37":"Cedimot com os arredores, Mefaat com os arredores: quatro cidades."
,"38":"Da tribo de Gad, deram como cidades de refúgio para o homicida: Ramot de Galaad com os arredores, Maanaim com os arredores,"
,"39":"Hesebon com os arredores, Jazer com os arredores; total dessas cidades: quatro."
,"40":"Total das cidades que tocaram por sorteio aos outros descendentes de Merari conforme os seus clãs, que pertenciam aos clãs dos levitas: doze cidades."
,"41":"Total das cidades levíticas no meio da propriedade dos israelitas: quarenta e oito cidades com os arredores."
,"42":"Cada uma dessas cidades incluía os arredores. Assim acontecia com todas essas cidades."
,"43":"Deste modo, Javé deu a Israel toda a terra que jurara dar aos seus antepassados. Eles tomaram posse e estabeleceram-se nela."
,"44":"Javé concedeu-lhes repouso de todos os lados, conforme tudo o que havia jurado aos seus antepassados. Nenhum dos inimigos conseguiu resistir-lhes: Javé entregou-lhes todos os inimigos."
,"45":"Nenhuma falhou de todas as promessas que Javé havia feito à casa de Israel. Todas se cumpriram."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Então Josué convocou os rubenitas, os gaditas e a meia tribo de Manassés,"
,"2":"e disse-lhes: «Vós obedecestes a todas as ordens de Moisés, servo de Javé, e também fizestes tudo o que eu vos ordenei."
,"3":"Não abandonastes os vossos irmãos durante todo este tempo, até ao dia de hoje. Vós procurastes obedecer aos mandamentos de Javé vosso Deus."
,"4":"Agora, Javé vosso Deus concedeu aos vossos irmãos o descanso prometido. Podeis, portanto, voltar para as vossas tendas, para a terra que vos pertence, que Moisés, servo de Javé, vos deu na Transjordânia."
,"5":"Entretanto, procurai pôr em prática o mandamento e a Lei que Moisés, servo de Javé, vos ordenou: Amai Javé vosso Deus. Andai em todos os seus caminhos. Guardai os seus mandamentos. Apegai-vos a Javé e servi-O com todo o coração e com toda a alma»."
,"6":"E Josué, depois de os abençoar, despediu-se deles. E eles foram para as suas tendas."
,"7":"Moisés tinha dado terras em Basã à meia tribo de Manassés. À outra metade, Josué deu terras entre os seus irmãos, a Oeste, na Cisjordânia. Josué também os despediu para as suas tendas, abençoando-os:"
,"8":"«Voltai para as vossas tendas, cheios de riquezas, com muitos rebanhos, com prata e ouro, bronze e ferro, e muitas roupas. Reparti com os vossos irmãos os despojos dos vossos inimigos»."
,"9":"Então os rubenitas, os gaditas e a meia tribo de Manassés foram-se embora, deixando os israelitas em Silo, na terra de Canaã. Dirigiram-se para a terra de Galaad, que lhes pertencia e que haviam recebido como posse, por ordem de Javé, dada a Moisés."
,"10":"Quando chegaram à região do rio Jordão, na terra de Canaã, os rubenitas, os gaditas e a meia tribo de Manassés construíram ali, junto ao Jordão, um altar grande e bem visível."
,"11":"Os israelitas, ao saberem que os rubenitas, os gaditas e a meia tribo de Manassés haviam construído esse altar na frente da terra de Canaã, na região do rio Jordão, em território israelita,"
,"12":"reuniram a comunidade dos israelitas em Silo para fazer guerra contra eles."
,"13":"E para conversar com os rubenitas, os gaditas e a meia tribo de Manassés, os israelitas resolveram enviar Fineias, filho do sacerdote Eleazar,"
,"14":"e mais dez chefes, um de cada tribo de Israel, que eram chefes de família entre as famílias de Israel."
,"15":"Eles foram a Galaad para conversar com os rubenitas, os gaditas e a meia tribo de Manassés. E disseram-lhes:"
,"16":"«Assim fala toda a comunidade de Israel: Que infidelidade é essa que cometestes contra o Deus de Israel, deixando hoje de seguir Javé? Vós construístes um altar, revoltando-vos contra Javé!"
,"17":"Porventura, não nos basta o crime de Fegor, do qual ainda não estamos purificados até ao dia de hoje, e que atraiu uma praga sobre a comunidade de Javé?"
,"18":"Vós hoje estais a voltar as costas a Javé! E porque hoje vos estais a revoltar contra Javé, amanhã Ele vai ficar irado contra toda a comunidade de Israel."
,"19":"Se a terra que recebestes como propriedade está impura, passai para a terra da propriedade de Javé, onde se encontra a moradia de Javé, e estabelecei-vos no meio de nós. Mas não vos revolteis contra Javé, nem nos façais participar da vossa rebelião, construindo para vós um altar, além do altar oficial de Javé nosso Deus."
,"20":"Quando Acã, bisneto de Zaré, cometeu uma infidelidade em relação às coisas que estavam consagradas ao extermínio, não foi sobre toda a comunidade de Israel que veio a ira? Aquele homem não foi o único a morrer por causa do seu crime»."
,"21":"Os rubenitas, os gaditas e a meia tribo de Manassés responderam aos chefes de família de Israel:"
,"22":"«Javé, Deus dos deuses, Javé, Deus dos deuses bem o sabe! E Israel também deve saber: se houve uma revolta ou infidelidade contra Javé, que Ele hoje mesmo nos castigue."
,"23":"Se construímos um altar para voltar as costas a Javé, e para nele oferecer holocaustos, oblações e sacrifícios de comunhão, que Javé nos peça contas!"
,"24":"Pelo contrário, nós construímos um altar com esta preocupação: amanhã, os vossos filhos perguntarão aos nossos: 'O que é que tendes em comum com Javé, Deus de Israel?'"
,"25":"Javé colocou o rio Jordão como fronteira entre nós e vós, filhos de Rúben e de Gad. Vós não tendes relação nenhuma com Javé! Deste modo, os vossos filhos afastariam os nossos filhos do culto a Javé."
,"26":"Por isso decidimos: 'Vamos construir este altar, não para fazer holocaustos ou sacrifícios,"
,"27":"mas como testemunho entre nós e vós, e entre os nossos futuros descendentes, demonstrando que queremos servir a Javé na sua presença, com os nossos holocaustos e sacrifícios de comunhão'. Deste modo, os vossos filhos não poderão dizer um dia aos nossos filhos: 'Vós não tendes relação nenhuma com Javé!'"
,"28":"Então pensámos: 'Se amanhã nos disserem algo a nós ou aos nossos descendentes, nós explicaremos: Vede a forma deste altar de Javé que os nossos pais fizeram. Não é para fazer holocaustos ou apresentar sacrifícios, mas apenas para ser um testemunho entre nós e vós'."
,"29":"Longe de nós revoltarmo-nos contra Javé ou voltar-Lhe hoje as costas, construindo um altar para oferecer holocaustos, apresentar ofertas e sacrifícios de comunhão, fora do altar de Javé nosso Deus, que está diante da sua morada»."
,"30":"Quando o sacerdote Fineias, os responsáveis da comunidade e os chefes de família de Israel, que o acompanhavam, ouviram as explicações dos rubenitas, dos gaditas e dos manasseítas, ficaram satisfeitos."
,"31":"Então Fineias, filho do sacerdote Eleazar, disse aos rubenitas, aos gaditas e aos manasseítas: «Hoje sabemos que Javé está no meio de nós, pois vós não cometestes tal infidelidade contra Javé. Deste modo, livrastes os israelitas do castigo de Javé»."
,"32":"Fineias, filho do sacerdote Eleazar, e os responsáveis deixaram os rubenitas e os gaditas na terra de Galaad e voltaram para a terra de Canaã, para junto dos israelitas, informando-os de tudo."
,"33":"Os israelitas ficaram satisfeitos e deram graças a Deus. Ninguém mais falou em subir para guerrear contra eles, destruindo a terra em que os rubenitas e os gaditas habitavam."
,"34":"Por isso, os rubenitas e os gaditas chamaram ao altar «Ele é testemunho entre nós de que Javé é Deus»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Passou-se muito tempo desde que Javé havia dado descanso a Israel, no meio dos seus inimigos vizinhos. Já em idade avançada,"
,"2":"Josué convocou todo o Israel, os anciãos, os chefes de família, os juízes e os oficiais, e disse-lhes: «Eu já estou velho, de idade avançada."
,"3":"Vós vistes tudo o que Javé vosso Deus fez em vosso favor contra estas nações. Foi Javé vosso Deus quem lutou por vós."
,"4":"Vede: através de sorteio eu reparti para vós, como propriedade para as vossas tribos, todas essas nações que ainda restam, juntamente com aquelas que destruí, desde o rio Jordão até ao grande Mar, ao Ocidente."
,"5":"O próprio Javé vosso Deus expulsará essas nações diante de vós. Ele mesmo as desalojará, para que tomeis posse das suas terras, como vos prometeu Javé vosso Deus."
,"6":"Procurai ser muito fortes na observância e no cumprimento de tudo o que está escrito no livro da Lei de Moisés, sem vos desviardes, nem para a direita nem para a esquerda."
,"7":"Não vos mistureis com essas nações que ainda restam no meio de vós. Não invoqueis os seus deuses, nem jureis por eles. Não os sirvais nem os adoreis."
,"8":"Apegai-vos unicamente a Javé vosso Deus, como tendes feito até ao dia de hoje."
,"9":"Diante de vós, Javé expulsou nações grandes e poderosas, e até agora ninguém foi capaz de vos opor resistência."
,"10":"Um só de vós pôde perseguir mil, porque o próprio Javé vosso Deus lutava por vós, como Ele havia prometido."
,"11":"Portanto, prestai atenção a vós mesmos: Amai Javé vosso Deus."
,"12":"Todavia, se vos desviardes e unirdes a essas nações que ainda restam no meio de vós, se vos misturardes com elas, e elas convosco,"
,"13":"ficai certos de uma coisa: Javé vosso Deus já não expulsará essas nações diante de vós, e elas serão laço e armadilha para vós, chicote nas vossas costas, espinho nos vossos olhos, até que desapareçais completamente desta boa Terra que Javé vosso Deus vos deu."
,"14":"Vede! Hoje eu sigo o caminho de todo o homem. Reconhecei com todo o coração e com toda a alma: de todas as promessas que Javé vosso Deus vos fez, nenhuma delas ficou sem se cumprir. Tudo se realizou para vós. Nenhuma delas falhou."
,"15":"Assim como se realizaram para vós todas as promessas feitas por Javé vosso Deus, do mesmo modo Javé realizará contra vós todas as suas maldições, até vos eliminar totalmente desta boa Terra que Javé vosso Deus vos deu."
,"16":"Se transgredirdes a aliança que Javé vosso Deus fez convosco e servirdes a outros deuses, adorando-os, então a ira de Javé se acenderá contra vós e rapidamente desaparecereis da boa Terra que Ele vos deu»."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Josué reuniu as tribos de Israel em Siquém. Convocou todos os anciãos de Israel, os chefes, juízes e oficiais. E todos se apresentaram diante de Deus."
,"2":"Então Josué disse a todo o povo: «Assim diz Javé, o Deus de Israel: Outrora, os vossos antepassados, Taré, pai de Abraão e de Nacor, habitavam do outro lado do rio Eufrates e serviam a outros deuses."
,"3":"Eu, porém, tomei Abraão, vosso antepassado, e fi-lo sair do outro lado do Eufrates para percorrer toda a terra de Canaã. Multipliquei a sua descendência e dei-lhe Isaac."
,"4":"A Isaac, dei Jacob e Esaú. A Esaú, dei como herança a serra de Seir, enquanto que Jacob e seus filhos desceram para o Egipto."
,"5":"Então enviei Moisés e Aarão para castigar o Egipto com os prodígios que realizei e fiz-vos sair de lá."
,"6":"Tirei do Egipto os vossos antepassados que chegaram até ao mar. Os egípcios perseguiram os vossos antepassados com carros e cavaleiros, até ao Mar Vermelho."
,"7":"Vós clamastes a Javé, e Ele colocou uma densa nuvem entre vós e os egípcios; e fez voltar o mar contra eles, afogando-os. Vós vistes com os vossos próprios olhos o que fiz no Egipto. Depois, habitastes no deserto durante muito tempo."
,"8":"Do deserto, fiz-vos entrar na terra dos amorreus que habitavam na Transjordânia. Eles fizeram guerra contra vós, mas Eu entreguei-os nas vossas mãos, e vós tomastes posse da sua terra, depois de Eu os ter destruído diante de vós."
,"9":"Depois veio Balac, filho de Sefor, rei de Moab, e guerreou contra Israel. Ele mandou chamar Balaão, filho de Beor, para vos amaldiçoar."
,"10":"Mas Eu não quis ouvir Balaão: ele teve de vos abençoar, e Eu livrei-vos das suas mãos."
,"11":"A seguir, atravessastes o rio Jordão para chegar a Jericó. Mas os chefes de Jericó guerrearam contra vós. E todos eles: amorreus, ferezeus, cananeus, heteus, gergeseus, heveus e jebuseus, Eu os entreguei nas vossas mãos."
,"12":"Mandei vespas à vossa frente para expulsarem os dois reis amorreus. Isso não foi feito nem com a vossa espada nem com o vosso arco."
,"13":"Eu dei-vos uma Terra que não vos custou nada, cidades que não construístes e onde agora viveis, vinhas e olivais que não plantastes e dos quais vos alimentais."
,"14":"Agora, portanto, temei a Javé, servindo-O com integridade e fidelidade. Tirai do meio de vós os deuses, a quem os vossos antepassados serviram no outro lado do rio Eufrates e no Egipto. Servi a Javé."
,"15":"Contudo, se achais que não é bom servir a Javé, escolhei hoje a quem quereis servir: aos deuses que os vossos antepassados serviram no outro lado do rio Eufrates, ou aos deuses dos amorreus, em cujas terras agora habitais. Eu e a minha família serviremos a Javé»."
,"16":"Então o povo respondeu: «Longe de nós abandonar Javé para servir a outros deuses!"
,"17":"Foi Javé nosso Deus quem nos tirou, a nós e aos nossos antepassados, da terra do Egipto, da casa da escravidão. Foi Ele quem fez estes grandes sinais diante dos nossos olhos, e nos protegeu por todo o caminho que percorremos e entre todos os povos no meio dos quais atravessámos."
,"18":"Foi Javé quem expulsou diante de nós todos os povos e os amorreus que habitavam a terra. Portanto, nós também serviremos a Javé, pois Ele é o nosso Deus»."
,"19":"Josué replicou: «Vós não podereis servir a Javé, porque Ele é um Deus santo, um Deus ciumento. Ele não perdoará as vossas transgressões e pecados."
,"20":"Se abandonardes Javé para servir aos deuses estrangeiros, Ele voltar-Se-á de novo contra vós, vos maltratará e destruirá, depois de vos ter feito bem»."
,"21":"O povo respondeu a Josué: «Não! Nós serviremos a Javé»."
,"22":"Então Josué disse ao povo: «Vós sois testemunhas contra vós mesmos de que escolhestes servir a Javé». O povo respondeu: «Nós somos testemunhas»."
,"23":"Josué disse: «Pois bem! Deitai fora os deuses estrangeiros que tendes, e inclinai o coração para Javé, o Deus de Israel»."
,"24":"O povo disse a Josué: «Nós serviremos a Javé nosso Deus e a Ele obedeceremos»."
,"25":"Nesse dia, Josué fez uma aliança com o povo e, em Siquém, e deu-lhes um estatuto e um direito."
,"26":"Josué escreveu essas palavras no livro da Lei de Deus. Depois, pegou numa grande pedra e ergueu-a, debaixo do carvalho que está no santuário de Javé."
,"27":"Em seguida, disse ao povo: «Esta pedra será um testemunho contra nós, porque ela ouviu todas as palavras que Javé nos disse. Será um testemunho contra vós, para que não renegueis o vosso Deus»."
,"28":"Em seguida, Josué despediu o povo, e cada um voltou para a sua herança."
,"29":"Algum tempo depois morreu Josué, filho de Nun, servo de Javé, com cento e dez anos."
,"30":"Foi enterrado no território que recebeu como herança em Tamnat-Sare, que está na região montanhosa de Efraim, ao Norte do monte Gaás."
,"31":"Israel serviu a Javé enquanto viveu Josué e enquanto viveram depois de Josué todos os anciãos que tinham conhecido todas as obras que Javé tinha realizado em favor de Israel."
,"32":"Os ossos de José, que os filhos de Israel tinham trazido do Egipto, foram enterrados em Siquém, na parte do campo que Jacob havia comprado aos filhos de Hemor, pai de Siquém, por cem moedas de prata e que se tornara herança dos filhos de José."
,"33":"Depois morreu Eleazar, filho de Aarão. Foi enterrado em Gabaá, cidade que pertencia a seu filho Fineias, e que lhe fora dada na região montanhosa de Efraim."
}`)

}
func PT_BS_LoadVHIHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Era o décimo segundo ano do reinado de Nabucodonosor, rei da Assíria, em Nínive, a capital. Nesse tempo, Arfaxad reinava sobre os Medos, em Ecbátana."
,"2":"Arfaxad cercou Ecbátana com muralhas feitas com pedras de um metro e meio de largura por três de comprimento. A altura da muralha era de trinta e cinco metros, e a largura era de vinte e cinco metros."
,"3":"Sobre as portas levantou torres com cinquenta metros de altura e trinta metros de largura na base."
,"4":"Fez as portas com trinta e cinco metros de altura e vinte de largura, para que os soldados do seu exército pudessem sair, e a infantaria fazer as suas evoluções."
,"5":"Por esse tempo, o rei Nabucodonosor guerreou contra o rei Arfaxad na grande planície, que se encontra no território de Ragau."
,"6":"Os habitantes da montanha, todos os habitantes das regiões do Eufrates, do Tigre, do Hidaspes e os habitantes das planícies de Arioc, rei dos elimeus, aliaram-se a Nabucodonosor. E assim, muitas nações fizeram aliança para guerrear contra os filhos de Queleud."
,"7":"Nabucodonosor, rei da Assíria, enviou embaixadores à Pérsia e nações do Ocidente, à Cilícia, Damasco, Líbano e Antilíbano, aos habitantes do litoral"
,"8":"e aos povos do Carmelo, de Galaad, da Alta Galileia, da grande planície de Esdrelon,"
,"9":"aos habitantes de Samaria e suas cidades, aos que habitam além do Jordão até Jerusalém, em Batana, Quelus, Cades, o rio do Egipto, Táfnis, Ramsés e toda a terra de Gessen,"
,"10":"até chegar além de Tânis e de Mênfis, e a todos os egípcios, até à fronteira da Etiópia."
,"11":"Todos, porém, desprezaram o convite de Nabucodonosor, rei da Assíria, e não se aliaram com ele. Não respeitavam Nabucodonosor, porque achavam que ele era uma pessoa sem poder. Mandaram embora os embaixadores de mãos vazias e humilhados."
,"12":"Nabucodonosor ficou furioso com esses países e jurou, pelo seu trono e seu reino, vingar-se de todos os territórios da Cilícia, Damasco e Síria, e passar a fio de espada todos os moabitas, amonitas, judeus e egípcios, até chegar à fronteira dos dois mares."
,"13":"No décimo sétimo ano, Nabucodonosor guerreou contra o rei Arfaxad, venceu-o no combate e derrotou todo o seu exército, cavalaria e carros."
,"14":"Tomou posse das suas cidades e, chegando a Ecbátana, tomou as suas torres, saqueou as suas ruas e transformou a sua beleza em humilhação."
,"15":"Depois prendeu Arfaxad nas montanhas de Ragau, atravessou-o com as suas lanças e eliminou-o para sempre."
,"16":"Em seguida, voltou para Nínive com o seu exército, uma imensa multidão de soldados. Ficaram despreocupados, descansando e banqueteando-se durante cento e vinte dias."
}`)
	CurrentBook.AddChapter(2, `{
"1":"No dia vinte e dois do primeiro mês do ano décimo oitavo, no palácio de Nabucodonosor, rei da Assíria, deliberou-se sobre a vingança contra toda a terra, conforme o rei havia dito."
,"2":"Então ele convocou todos os ministros e conselheiros, expôs o seu plano secreto e decretou a destruição de todos esses territórios."
,"3":"Decidiram exterminar todos os que não tinham aceitado o convite de Nabucodonosor."
,"4":"Terminada a reunião, Nabucodonosor, rei da Assíria, convocou Holofernes, general do seu exército, o segundo homem no reino, e ordenou-lhe:"
,"5":"«Assim diz o grande rei, o senhor de toda a terra. Ao sair da minha presença, toma contigo homens experientes, uns cento e vinte mil de infantaria e forte contingente de cavalaria, com doze mil cavaleiros."
,"6":"Marcha contra toda a região ocidental, porque não aceitaram o meu convite."
,"7":"Obriga-os a colocar à minha disposição a terra e a água, porque vou marchar furioso contra eles. Vou cobrir o chão com os pés dos meus soldados e entregá-los ao saque."
,"8":"Os seus feridos encherão os vales e as torrentes, e os rios transbordarão de cadáveres,"
,"9":"e eu levarei os prisioneiros para os confins do mundo."
,"10":"Segue à minha frente e conquista para mim os seus territórios. Se eles se renderem a ti, deixa que eu os castigue."
,"11":"Não tenhas consideração para com os rebeldes. Entrega-os à matança e ao saque em toda a terra que tu conquistares."
,"12":"Pela minha vida e pelo meu império, vou cumprir o que estou a dizer."
,"13":"Não desobedeças a nenhuma ordem do teu senhor. Faz tudo conforme eu te ordenei. Não percas tempo»."
,"14":"Holofernes saiu da presença do seu senhor e convocou todos os chefes, generais e oficiais do exército da Assíria."
,"15":"Em seguida, escolheu um contingente de cento e vinte mil homens e doze mil arqueiros a cavalo, conforme o seu senhor tinha mandado."
,"16":"E organizou-os para o combate."
,"17":"Tomou então grande quantidade de camelos, jumentos e mulas, para transportar o equipamento, e também inumeráveis ovelhas, bois e cabras para o abastecimento."
,"18":"Cada soldado recebeu farta provisão e muito ouro e prata do palácio do rei."
,"19":"Então Holofernes saiu com todo o seu exército à frente do rei Nabucodonosor, para cobrir toda a região ocidental com carros, cavaleiros e tropas escolhidas."
,"20":"A eles juntou-se ainda um bando numeroso, incontável como os gafanhotos e como a areia da terra."
,"21":"Partiram de Nínive e caminharam três dias em direcção à planície de Bectilet. Acamparam fora de Bectilet, perto da montanha, ao Norte da Alta-Cilícia."
,"22":"Daí, com todo o seu exército, formado por infantaria, cavalaria e carros, Holofernes partiu para a região montanhosa."
,"23":"Devastou Fut e Lud, e saqueou todos os filhos de Rassis e de Ismael, que vivem na beira do deserto, ao Sul de Queleon."
,"24":"Depois costeou o rio Eufrates, atravessou a Mesopotâmia e destruiu todas as cidades fortificadas que estão junto ao riacho Abrona, até chegar ao mar."
,"25":"Tomou posse dos territórios da Cilícia, despedaçou todos os que resistiram e foi até à fronteira Sul de Jafé, diante da Arábia."
,"26":"Cercou todos os madianitas, incendiou as suas tendas e devastou os seus estábulos."
,"27":"A seguir, desceu para a planície de Damasco no tempo da colheita de trigo, e incendiou as searas, destruiu ovelhas e bois, saqueou as cidades, devastou as plantações e passou todos os jovens ao fio da espada."
,"28":"Um medo terrível caiu sobre os habitantes do litoral, sobre os sidónios e tírios, sobre os de Sur, de Oquina e de Jâmnia. Também os habitantes de Azoto e Ascalon ficaram aterrorizados."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Os habitantes do litoral enviaram mensageiros com propostas de paz, nestes termos: «Aqui estamos."
,"2":"Somos servos do grande rei Nabucodonosor e prostramos-nos diante de ti: faz de nós o que quiseres."
,"3":"Aqui estão à tua disposição os nossos estábulos, o nosso território, os campos de trigo, as ovelhas e os bois, e todos os nossos acampamentos. Serve-te como achares melhor."
,"4":"As nossas cidades e seus habitantes são teus escravos. Vem e trata-as como quiseres»."
,"5":"Então os mensageiros apresentaram-se a Holofernes, e transmitiram a mensagem."
,"6":"Holofernes desceu com o seu exército ao litoral, deixou guarnições nas cidades fortificadas e recrutou homens escolhidos para servirem de tropas auxiliares."
,"7":"Os habitantes das cidades e arredores receberam-no com coroas, danças e tamborins."
,"8":"Mas Holofernes destruiu os seus santuários, cortou as suas árvores sagradas e exterminou todos os deuses da terra, para que todas as nações só adorassem a Nabucodonosor, e todas as tribos o invocassem como deus, cada uma na própria língua."
,"9":"Quando chegou à vista de Esdrelon, perto de Dotain, aldeia que está diante da grande serra da Judeia,"
,"10":"Holofernes acampou entre Geba e Citópolis, e ficou lá durante um mês, recolhendo provisões para o exército."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Os israelitas da Judeia ficaram a saber de tudo o que Holofernes, general de Nabucodonosor, rei da Assíria, tinha feito às nações, atacando os seus templos e entregando-os ao saque."
,"2":"Então ficaram aterrorizados com Holofernes e temeram por Jerusalém e pelo Templo do Senhor seu Deus."
,"3":"Eles tinham voltado do exílio havia pouco tempo, e todo o povo da Judeia havia-se reunido novamente. Os utensílios, o altar e o Templo haviam sido recentemente purificados da profanação."
,"4":"Então mandaram mensageiros por todo o território da Samaria, a Coná, Bet-Horon, Belmain, Jericó, Coba, Aisora e ao vale de Salém."
,"5":"Ocuparam o cimo dos montes mais altos, fortificaram as aldeias da região montanhosa e juntaram provisões para a guerra, pois nesse tempo tinham acabado de fazer a colheita."
,"6":"O sumo sacerdote Joaquim, que nessa ocasião se achava em Jerusalém, escreveu aos habitantes de Betúlia e Betomestaim, que estão diante de Esdrelon, em frente da planície vizinha de Dotain."
,"7":"Ele mandou que ocupassem as passagens da serra, porque era por aí que passava o caminho para a Judeia. Desse modo, era fácil impedir que o inimigo avançasse, porque o desfiladeiro era tão estreito que somente se podia passar dois a dois."
,"8":"Os israelitas obedeceram ao sumo sacerdote Joaquim e ao conselho dos anciãos do povo de Israel, que residiam em Jerusalém."
,"9":"Ao mesmo tempo, cada israelita suplicou insistentemente a Deus, e todos se humilharam diante d'Ele."
,"10":"Eles e suas mulheres, seus filhos e rebanhos, e todos os imigrantes, mercenários e escravos vestiram-se com pano de saco."
,"11":"Os que viviam em Jerusalém, inclusive mulheres e crianças, prostraram-se diante do Templo, com cinzas na cabeça, e estenderam as mãos diante do Senhor."
,"12":"Cobriram o altar com panos de saco e clamaram, a uma só voz e com ardor, para que o Deus de Israel não entregasse os seus filhos ao saque, nem as suas mulheres ao exílio, nem à destruição as cidades que tinham herdado, nem o Templo à profanação e zombarias humilhantes das nações."
,"13":"O Senhor ouviu-lhes o grito e tomou conhecimento da tribulação deles. O povo jejuou durante dias seguidos em toda a Judeia e em Jerusalém, diante do Templo do Senhor Todo-poderoso."
,"14":"O sumo sacerdote Joaquim, juntamente com todos os sacerdotes e ministros do culto do Senhor, ofereciam o holocausto diário, as ofertas e os dons voluntários do povo. Vestidos com panos de saco"
,"15":"e com cinzas sobre os turbantes, chamavam com toda a força ao Senhor, para que protegesse a casa de Israel."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Holofernes, general do exército assírio, foi informado de que os israelitas se estavam a preparar para a guerra. Contaram-lhe que eles tinham fechado as passagens das montanhas, fortificado o cimo dos montes mais altos e preparado obstáculos nas planícies."
,"2":"Holofernes ficou enfurecido e convocou todos os chefes moabitas, generais amonitas, governadores do litoral,"
,"3":"e perguntou-lhes: «Cananeus, dizei-me: Que gente é essa que vive na serra? Em que cidades moram? Qual é a potência do seu exército? Em que ponto está o seu poder e a sua força? Que rei os governa?"
,"4":"Porque não se dignaram vir ao meu encontro, como fizeram todos os povos do Ocidente?»"
,"5":"Aquior, chefe de todos os amonitas, respondeu: «Escuta, meu senhor, o que este teu servo vai dizer. Vou contar-te a verdade sobre este povo que vive na serra, aqui perto. Não direi mentiras."
,"6":"Esse povo é descendente dos caldeus."
,"7":"Primeiro estiveram na Mesopotâmia, porque não quiseram seguir os deuses dos seus antepassados, que viviam na Caldeia."
,"8":"Abandonaram a religião dos seus antepassados e adoraram o Deus do céu, que reconheceram como Deus. Os caldeus, porém, expulsaram-nos da presença dos seus deuses, e tiveram que fugir para a Mesopotâmia, onde ficaram durante longo tempo."
,"9":"O Deus deles ordenou que saíssem de lá e fossem para a terra de Canaã. Instalaram-se lá e ficaram muito ricos em ouro, prata e rebanhos numerosos."
,"10":"Em seguida, foram para o Egipto por causa de uma fome que atingia o país de Canaã. E lá ficaram enquanto havia alimento. No Egipto, multiplicaram-se muito e transformaram-se num povo numeroso."
,"11":"O rei do Egipto, porém, esteve contra eles e explorou-os no trabalho de preparar tijolos, e eles foram humilhados e tratados como escravos."
,"12":"Então clamaram ao seu Deus, e Este castigou todo o país do Egipto com pragas incuráveis. Os egípcios, então, expulsaram-nos do país."
,"13":"Deus secou diante deles o Mar Vermelho"
,"14":"e conduziu-os pelo caminho do Sinai e de Cades Barne. Eles expulsaram todos os habitantes do deserto,"
,"15":"instalaram-se na terra dos amorreus, e exterminaram pela força todos os habitantes de Hesebon. Depois atravessaram o Jordão, tomaram posse de toda a serra,"
,"16":"expulsaram os cananeus, ferezeus, jebuseus, siquemitas e todos os gergeseus, e viveram lá durante muito tempo."
,"17":"Enquanto não pecaram contra o seu Deus, a prosperidade estava com eles, porque o seu Deus odeia a injustiça."
,"18":"Mas quando se afastaram do caminho que Deus lhes havia marcado, uma parte deles foi completamente exterminada em guerras, e a outra foi exilada para um país estrangeiro. O Templo do seu Deus foi arrasado e as suas cidades foram conquistadas pelos adversários."
,"19":"Mas agora eles voltaram para o seu Deus, regressaram da dispersão, ocuparam Jerusalém, onde está o seu Templo, e repovoaram a serra que tinha ficado deserta."
,"20":"Agora, meu soberano e senhor, se essa gente se desviou, pecando contra o seu Deus, comprovemos essa falta, e subamos para os atacar."
,"21":"Contudo, se eles não tiverem pecado, é melhor que os deixes em paz. Caso contrário, o seu Senhor e Deus vai protegê-los, e nós ficaremos envergonhados diante de todo o mundo»."
,"22":"Quando Aquior acabou de falar, todos os que estavam ao redor da tenda protestaram. Os oficiais de Holofernes, os habitantes do litoral e os moabitas queriam matar Aquior."
,"23":"E diziam: «Não vamos ficar com medo dos israelitas. É um povo sem exército e sem forças para aguentar um combate duro."
,"24":"Por isso, vamos lá. Serão presa fácil para todo o teu exército, senhor Holofernes»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Quando se acalmou o alvoroço dos que assistiam à reunião, Holofornes, general do exército assírio, disse a Aquior, na frente de toda a tropa estrangeira e de todos os moabitas:"
,"2":"«Quem és tu, Aquior, e esses mercenários de Efraim, para profetizardes dessa forma, aconselhando-nos a não lutar contra os israelitas, porque o seu Deus vai protegê-los? Quem é deus, além de Nabucodonosor? Nabucodonosor enviará a sua força e exterminará os israelitas da face da terra. E o Deus deles não conseguirá salvá-los."
,"3":"Nós, servos de Nabucodonosor, esmagá-los-emos como se fossem um só homem. Não poderão resistir à nossa cavalaria."
,"4":"Nós os queimaremos de uma só vez. Os seus montes ficarão embriagados com o sangue deles, e as suas planícies transbordarão de cadáveres. Eles não poderão ficar de pé diante de nós. Todos morrerão, diz o rei Nabucodonosor, o senhor de toda a terra. Ele assim disse, e as suas palavras não serão desmentidas."
,"5":"Quanto a ti, Aquior, mercenário amonita, disseste essas frases num momento de loucura. Por isso, não voltarás a ver-me até que eu castigue essa gente que escapou do Egipto."
,"6":"Então a espada dos meus soldados e a lança dos meus oficiais atravessarão as costelas deles, e tu cairás entre os feridos deles."
,"7":"Os meus servos vão levar-te para a montanha e deixar-te em alguma cidade dos desfiladeiros."
,"8":"Ficarás vivo para seres morto juntamente com eles."
,"9":"Se confias em que eles não serão capturados, não fiques de cabeça baixa. Nada do que eu disse ficará sem se realizar»."
,"10":"Holofernes ordenou aos servos, que estavam na tenda, para pegarem em Aquior, o levarem a Betúlia e o entregarem aos israelitas."
,"11":"Os servos agarraram Aquior e levaram-no para a planície, fora do acampamento. Daí dirigiram-se para a serra e chegaram às fontes que estão abaixo de Betúlia."
,"12":"Quando os homens da cidade os viram no alto dos montes, pegaram nas suas armas, saíram da cidade e foram para lá, enquanto os atiradores lançavam pedras sobre os homens de Holofernes, para impedir que subissem."
,"13":"Então estes desceram pela encosta dos montes, amarraram Aquior e deixaram-no ao pé do monte. E voltaram para junto do seu senhor."
,"14":"Então os israelitas desceram da cidade e foram ter com Aquior. Desamarraram-no e levaram-no a Betúlia para o apresentarem aos chefes da cidade."
,"15":"Nesse tempo, os chefes eram Ozias, filho de Micas, da tribo de Simeão; Cabris, filho de Gotoniel, e Carmis, filho de Melquiel."
,"16":"Eles convocaram todos os anciãos da cidade. Também os jovens e as mulheres foram à assembleia. Colocaram Aquior no meio de todos, e Ozias perguntou-lhe o que havia acontecido."
,"17":"Então Aquior contou-lhes o que haviam dito no conselho de Holofernes, o que ele próprio tinha dito aos chefes assírios e as ameaças de Holofernes contra Israel."
,"18":"Então o povo prostrou-se, adorou a Deus e suplicou:"
,"19":"«Senhor Deus do céu, olha do alto para o orgulho deles e tem piedade da humilhação da nossa gente. Acolhe hoje com boa vontade a presença daqueles que Te são consagrados»."
,"20":"Depois, animaram Aquior e elogiaram-no muito."
,"21":"Ozias levou-o para sua casa e ofereceu um banquete aos anciãos. E passaram toda essa noite a invocar o auxílio do Deus de Israel."
}`)
	CurrentBook.AddChapter(7, `{
"1":"No dia seguinte, Holofernes ordenou ao exército e às tropas aliadas que levantassem acampamento, avançassem contra Betúlia, ocupassem as passagens das montanhas e atacassem os israelitas."
,"2":"Nesse mesmo dia, todos os soldados levantaram acampamento. O exército contava com cento e setenta mil soldados de infantaria e doze mil cavaleiros, sem contar a bagagem e a multidão que os acompanhava a pé."
,"3":"Formaram-se em ordem de batalha no vale perto de Betúlia, junto à fonte, e estenderam-se ao largo, na direcção de Dotain, até Belbaim, e de Betúlia até Quiamon, que está diante de Esdrelon."
,"4":"Quando os israelitas viram essa multidão, ficaram aterrorizados e comentaram: «Eles vão engolir toda a face da terra. Nem os montes mais altos, nem os precipícios, nem as colinas suportarão tanto peso»."
,"5":"Cada um empunhou as suas armas, acenderam fogueiras nas torres e ficaram de guarda a noite inteira."
,"6":"No segundo dia, Holofernes fez avançar a cavalaria diante dos israelitas que estavam em Betúlia."
,"7":"Inspeccionou as subidas para a cidade, examinou as fontes e ocupou-as, deixando lá destacamentos militares. Depois voltou para junto do exército."
,"8":"Os oficiais edomitas, os chefes moabitas e os generais do litoral disseram a Holofernes:"
,"9":"«Senhor, ouve o nosso palpite, e o exército não sofrerá um só arranhão."
,"10":"Esses israelitas não confiam tanto nas armas. Eles confiam na altura dos montes onde vivem, porque não é fácil escalar o topo desses montes."
,"11":"Por isso, senhor, não os combatas como se faz em campo aberto, e não haverá nenhuma baixa no teu exército."
,"12":"Fica no acampamento com todo o exército e deixa que ocupemos a fonte que brota ao pé do monte."
,"13":"É dela que os habitantes de Betúlia se abastecem de água. A sede forçá-los-á a entregar-te a cidade. Nós subiremos com os nossos soldados ao topo dos montes vizinhos e montaremos acampamento, para impedir que alguém saia da cidade."
,"14":"A fome tomará conta deles, com as suas mulheres e crianças. Tu nem precisarás de usar a espada: eles cairão sozinhos pelas ruas da cidade."
,"15":"Desse modo, far-lhes-ás pagar bem caro por não terem ido pacificamente ao teu encontro»."
,"16":"Holofernes e os seus oficiais gostaram da proposta, e ele deu ordem para agir de acordo."
,"17":"Então uma tropa de moabitas e cinco mil assírios avançaram. Acamparam no vale e ocuparam as minas e fontes dos israelitas."
,"18":"Os edomitas e amonitas subiram a serra, acamparam diante de Dotain e mandaram destacamentos para Sul e para Leste, diante de Egrebel, perto de Cuch, sobre a torrente de Mocmur. O grosso do exército assírio acampou na planície, cobrindo toda a região. As tendas e equipamentos formavam um acampamento enorme, pois a multidão era imensa."
,"19":"Vendo-se cercados pelo inimigo e sem possibilidades de escapar, os israelitas ficaram desanimados e clamaram ao Senhor seu Deus."
,"20":"O exército assírio, com infantaria, cavalaria e carros, manteve o cerco durante trinta e quatro dias. A provisão de água dos habitantes de Betúlia esgotou-se,"
,"21":"e os poços ficaram vazios. Ninguém tinha com que saciar a sede nem por um dia sequer, porque a água estava racionada."
,"22":"As crianças desmaiavam e as mulheres e jovens desfaleciam de sede. Caíam pelas ruas e saídas das portas da cidade, completamente esgotados."
,"23":"Então todo o povo se reuniu contra Ozias e os chefes da cidade, juntamente com jovens, mulheres e crianças, gritando e dizendo a todos os anciãos:"
,"24":"«Que o Senhor seja o nosso juiz, porque causastes um grande mal, não querendo negociar a paz com os assírios."
,"25":"Agora não temos a quem recorrer, porque Deus nos entregou nas mãos deles e estamos morrendo de sede e grande destruição."
,"26":"Agora chamai os assírios e entregai a cidade inteira, para que o exército de Holofernes a saqueie."
,"27":"É preferível sermos saqueados. Seremos seus escravos, mas salvaremos a nossa vida, e não veremos morrer as nossas crianças e expirar as nossas mulheres e filhos."
,"28":"Se não fizerdes isso hoje mesmo, nós convocaremos o céu e a terra como testemunhas contra vós diante do nosso Deus, Senhor dos nossos antepassados, que nos está a castigar por causa dos nossos pecados e dos pecados dos nossos antepassados»."
,"29":"Então levantou-se da assembleia um pranto geral, e todos gritaram súplicas ao Senhor Deus."
,"30":"Então Ozias procurou animá-los: «Tende confiança, irmãos. Vamos resistir por mais cinco dias. O Senhor nosso Deus terá compaixão de nós. Ele não nos vai abandonar até ao fim."
,"31":"Depois desse prazo, se Ele não nos socorrer, farei o que estais a propor»."
,"32":"Então dispersou o povo, cada um para o seu lugar: os homens voltaram para as muralhas e torres da cidade, e mandaram as mulheres e crianças para casa. A cidade estava tomada pela angústia."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Nesses dias, a notícia chegou até Judite. Ela era filha de Merari, filho de Ox, filho de José, filho de Oziel, filho de Elquias, filho de Ananias, filho de Gedeão, filho de Rafaim, filho de Aquitob, filho de Elias, filho de Helcias, filho de Eliab, filho de Natanael, filho de Salamiel, filho de Surisadai, filho de Israel."
,"2":"Seu marido Manassés, da mesma tribo e parentela, tinha morrido durante a colheita da cevada."
,"3":"Ele estava a dirigir os que atavam feixes no campo, e teve uma insolação. Caiu de cama e morreu em Betúlia, sua cidade. E foi enterrado na sepultura de família, que ficava na sua propriedade, entre Dotain e Balamon."
,"4":"Judite era viúva havia três anos e quatro meses. Vivia em sua casa,"
,"5":"num quarto que mandara fazer no terraço. Vestia pano de saco e usava roupas de viúva."
,"6":"Desde que ficou viúva, jejuava diariamente, menos no dia de sábado e na véspera, no primeiro e último dia do mês, nas festas e comemorações israelitas."
,"7":"Era muito bonita e atraente. Manassés, seu marido, havia-lhe deixado ouro e prata, servos e servas, rebanhos e terras. E ela vivia disso."
,"8":"Ninguém podia fazer-lhe a mínima crítica, pois era muito temente a Deus."
,"9":"Judite ficou sabendo das palavras desesperadas que o povo tinha dito ao governador, porque estava desanimado com a falta de água. Soube também que Ozias tinha jurado entregar a cidade aos assírios dentro de cinco dias."
,"10":"Então Judite mandou a serva, que administrava os seus bens, chamar Cabris e Carmis, anciãos da cidade."
,"11":"Quando chegaram, ela disse: «Ouvi-me, chefes do povo de Betúlia. O que hoje dissestes ao povo foi um erro. Jurastes, obrigando-vos diante de Deus, a entregar a cidade ao inimigo, caso o Senhor não vos socorra dentro de cinco dias."
,"12":"Quem sois vós para tentar a Deus, colocando-vos hoje publicamente acima d'Ele?"
,"13":"Vós, que nunca entendestes nada, estais a pôr à prova o Senhor Todo-poderoso."
,"14":"Se sois incapazes de sondar a profundidade do coração humano e entender as razões dos seus pensamentos, como podeis sondar a Deus, criador de tudo, e compreender a sua mente e entender o seu projecto? Não, irmãos, não queirais irritar o Senhor nosso Deus."
,"15":"Ainda que não nos queira socorrer nestes cinco dias, Ele tem poder para nos proteger no dia que quiser, ou destruir-nos diante dos nossos inimigos."
,"16":"Não pretendais exigir garantias sobre os planos do Senhor nosso Deus, porque Deus não é um homem que possa ser intimidado, nem algum ser humano que possa ser pressionado."
,"17":"Por isso, enquanto esperamos pacientemente que Ele nos salve, vamos suplicar-Lhe que venha em nosso auxílio. Se Ele quiser, vai ouvir a nossa voz."
,"18":"É verdade que nos nossos tempos, e hoje mesmo, não tem havido entre nós nenhuma tribo, família, povo ou cidade que tenha adorado deuses feitos por mãos humanas, como acontecia outrora."
,"19":"Foi por isso que os nossos antepassados foram entregues à espada e ao saque, e caíram miseravelmente diante dos seus inimigos."
,"20":"Nós, pelo contrário, não conhecemos outro Deus além d'Ele. Por isso confiamos que Ele não nos vai desprezar, nem afastar-Se da nossa gente."
,"21":"Se formos capturados, o mesmo acontecerá com toda a Judeia, e o santuário será saqueado. Então deveremos pagar essa profanação com o nosso próprio sangue."
,"22":"Nas nações onde estivermos como escravos, seremos responsáveis pela morte dos nossos compatriotas, pelo exílio do povo da terra e pela desolação da nossa herança. Seremos assim motivo de zombaria e desprezo diante dos nossos dominadores."
,"23":"A nossa escravidão não nos fará ganhar o favor dos nossos dominadores. Pelo contrário, o Senhor nosso Deus transformá-la-á em desonra para nós."
,"24":"Portanto, irmãos, mostremos aos nossos irmãos que a sua vida depende de nós, e que de nós depende a segurança do santuário, do Templo e do altar."
,"25":"Agradeçamos ao Senhor nosso Deus por tudo isso, porque Ele nos está pondo à prova, como fez com os nossos antepassados."
,"26":"Lembrai-vos do que Ele fez com Abraão, como provou Isaac, e o que aconteceu com Jacob na Mesopotâmia da Síria, quando ele apascentava os rebanhos de Labão, seu tio materno."
,"27":"Deus provou-os com fogo para avaliar o seu coração, e está fazendo o mesmo connosco. O Senhor açoita os que d'Ele se aproximam, não para Se vingar, mas para os tornar conscientes»."
,"28":"Então Ozias disse-lhe: «Tudo o que disseste é muito sensato, e ninguém poderá dizer o contrário."
,"29":"Não é de hoje que toda a gente sabe que tu és sábia. Desde pequena, todos conhecem a tua inteligência e o teu bom coração."
,"30":"Mas o povo estava a morrer de sede e obrigou-nos a fazer o que fizemos, forçando-nos a um juramento que não podemos violar."
,"31":"Agora, tu que és mulher piedosa, suplica por nós. O Senhor mandará chuva para encher os poços, e nós não morreremos»."
,"32":"Judite respondeu: «Escutai-me com atenção. Vou fazer uma coisa que será comentada de geração em geração pelos filhos da nossa gente."
,"33":"Esta noite ficareis a vigiar à porta da cidade. Eu sairei com a minha serva e, antes do prazo que estabelecestes para entregar a cidade ao inimigo, o Senhor virá socorrer Israel através de mim."
,"34":"Quanto a vós, não pergunteis o que vou fazer. Só o contarei depois de o ter feito»."
,"35":"Ozias e os chefes disseram-lhe: «Vai em paz. Que o Senhor Deus te acompanhe, para que possas vingar-te do nosso inimigo»."
,"36":"E deixando o aposento dela, voltaram para os seus postos."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Era o momento em que acabavam de oferecer o incenso da tarde, no Templo de Jerusalém. Judite colocou cinza sobre a cabeça, tirou as vestes e prostrou-se no chão, vestida apenas com o pano de saco. Levantou a voz e gritou ao Senhor, dizendo:"
,"2":"«Senhor, Deus de meu pai Simeão, em cuja mão colocaste uma espada, para se vingar dos estrangeiros,que violentaram vergonhosamente,uma jovem, tiraram-lhe as roupas para a estuprar, e profanaram o seio dela,para sua desonra. E Tu havias dito: 'Não façais isso'. Mas eles fizeram-no."
,"3":"Por isso, entregaste os seus chefes,à morte. E o leito deles, manchado pelo engano, pelo engano ficou ensanguentado. Feriste os servos com os chefes, e os chefes juntamente com os servos."
,"4":"Entregaste as suas mulheres ao rapto,e as suas filhas à escravidão. Entregaste os seus despojos à partilha, em proveito dos filhos que amavas, e que, ardendo de zelo por Ti, abominaram a mancha do seu sangue,e invocaram o teu socorro. Deus, meu Deus, ouve esta pobre viúva."
,"5":"Tu fizeste o passado, e o que vem agora e o que virá depois. Tu projectas o presente e o futuro, e o que desejas acontece."
,"6":"Os teus projectos apresentam-se,e dizem: 'Aqui estamos'. Pois os teus caminhos,estão todos preparados, e os teus projectos,foram feitos de antemão."
,"7":"Aí estão os assírios!,Eles apoiam-se na sua força, orgulhosos dos seus cavalos e cavaleiros, e gabam-se da força da sua infantaria. Eles confiam no escudo e na lança, no arco e na funda, e não sabem que Tu és o Senhor,que acabas com as guerras."
,"8":"O teu nome é: 'O Senhor'!,Quebra a sua força com o teu poder, e, com a tua cólera, despedaça o seu domínio. Porque decidiram profanar,o teu santuário, manchar a tenda onde repousa,o teu Nome glorioso,e derrubar a ferro,as pontas do teu altar."
,"9":"Olha para a sua soberba,e descarrega a tua ira nas suas cabeças. Dá força a esta viúva, para fazer aquilo que ela decidiu."
,"10":"Através da minha língua sedutora, fere o servo juntamente com o chefe,e o chefe com o servo. Quebra a sua altivez,pela mão de uma mulher."
,"11":"A tua força não está no número, nem a tua autoridade nos guerreiros. Tu és o Deus dos humildes, o socorro dos oprimidos, o protector dos fracos, o abrigo dos abandonados, o salvador dos desesperados."
,"12":"Sim, Deus de meu pai, Deus da herança de Israel, Senhor do Céu e da Terra, Criador das águas, Rei de toda a criação. Ouve a minha súplica,"
,"13":"e concede-me falar com sedução, para ferir mortalmente,os que planearam,uma vingança cruel contra os teus fiéis, contra a tua morada santa, o monte Sião, e a casa dos teus filhos."
,"14":"Faz que todo o povo e todas as tribos,reconheçam que Tu és o único Deus, o Deus de toda a força,e de todo o poder, e que o povo de Israel,só tem a Ti como protector»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Quando acabou de suplicar ao Deus de Israel e terminou o que estava a dizer,"
,"2":"Judite levantou-se, chamou a serva e foi para a casa em que ficava nos dias de sábado e de festa."
,"3":"Tirou o pano de saco e o vestido de viúva, tomou banho, colocou perfume caro, penteou os cabelos, pôs um turbante na cabeça e vestiu-se com a roupa de festa, que usava enquanto seu marido Manassés era vivo."
,"4":"Calçou sandálias e enfeitou-se com braceletes, colares, anéis, brincos e todas as suas jóias. Ficou belíssima, capaz de seduzir os homens que a vissem."
,"5":"Depois entregou à serva uma vasilha de vinho e uma jarra de azeite, encheu uma sacola com farinha de cevada, bolos de frutas secas e pães puros. Embrulhou as provisões e entregou-as à serva."
,"6":"Em seguida, saíram para a porta da cidade de Betúlia e encontraram aí Ozias, Cabris e Carmis, dois anciãos da cidade."
,"7":"Ao vê-la com o rosto transformado e com outros vestidos, ficaram pasmados com tanta beleza, e disseram-lhe:"
,"8":"«Que o Deus dos nossos antepassados te ajude e permita que sejas bem sucedida nos teus planos, para a glória dos israelitas e a exaltação de Jerusalém»."
,"9":"Judite adorou a Deus, e disse-lhes: «Mandai abrir a porta da cidade. Sairemos para realizar o que estais a desejar». Eles ordenaram que os soldados lhe abrissem a porta, conforme ela tinha pedido."
,"10":"Assim fizeram, e Judite saiu com a serva. Os homens da cidade seguiram-na com o olhar, enquanto ela descia a encosta, até que atravessou o vale e desapareceu."
,"11":"Estavam caminhando em direcção ao vale, quando as sentinelas dos assírios foram ao encontro delas."
,"12":"Detiveram Judite e perguntaram-lhe: «De que lado estás? De onde vens? Para onde vais?» Judite respondeu: «Sou hebreia, e estou fugindo do meu povo, porque falta pouco para ele ser devorado por vós."
,"13":"Gostaria de me apresentar a Holofernes, general do vosso exército, para lhe dar informações seguras. Vou mostrar-lhe o caminho por onde poderá passar e conquistar toda a serra, sem arriscar um só dos seus homens»."
,"14":"Enquanto a escutavam, as sentinelas observavam-lhe o rosto, admirados com tanta beleza. E disseram-lhe:"
,"15":"«Salvaste a tua vida, vindo ao encontro do senhor nosso general. Podes ir até à tenda dele; alguns dos nossos vão escoltar-te até lá."
,"16":"Quando estiveres diante dele, não tenhas medo, diz-lhe o que nos disseste a nós, e ele tratar-te-á bem»."
,"17":"Então eles destacaram cem homens, que escoltaram Judite e a sua serva até à tenda de Holofernes."
,"18":"Ao correr pelas tendas a notícia da chegada de Judite, o acampamento ficou em alvoroço. Judite estava do lado de fora da tenda de Holofernes, esperando ser anunciada, e todos a rodearam."
,"19":"Estavam admirados com a sua beleza e, olhando para ela, não deixaram de admirar os israelitas. E comentavam: «Não podemos desprezar uma nação que tem mulheres tão bonitas. Não podemos poupar nenhum homem deles. Os que ficassem, seriam capazes de conquistar o mundo inteiro»."
,"20":"Os guarda-costas de Holofernes e os oficiais saíram e introduziram Judite na tenda."
,"21":"Holofernes estava a descansar na sua cama, debaixo de um mosquiteiro de púrpura, bordado a ouro e recamado com esmeraldas e pedras preciosas."
,"22":"Anunciaram Judite. Então ele saiu para a parte da frente da tenda, precedido de portadores de lâmpadas de prata."
,"23":"Quando Judite ficou na frente de Holofernes e dos oficiais, todos ficaram admirados com a beleza do seu rosto e ela prostrou-se diante de Holofernes. Mas os escravos levantaram-na."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Holofernes disse a Judite: «Coragem, mulher. Não tenhas medo. Nunca maltratei ninguém que estivesse disposto a servir a Nabucodonosor, rei do mundo inteiro."
,"2":"Até o teu povo que mora na serra: se ele não me tivesse desprezado, eu não estaria a lutar contra ele. Eles é que o provocaram."
,"3":"Agora, diz-me: Porque fugiste e passaste para o nosso lado? Vindo até nós, salvaste a tua vida. Podes confiar. Não correrás perigo, nem esta noite, nem depois."
,"4":"Ninguém vai maltratar-te. Pelo contrário, tratar-te-emos bem, como fazemos com os servos do rei Nabucodonosor, meu senhor»."
,"5":"Então Judite disse-lhe: «Permite-me que te fale e acolhe as palavras desta tua serva. Esta noite não vou dizer mentira nenhuma."
,"6":"Se seguires os conselhos desta tua serva, Deus ajudar-te-á na tua campanha, e os teus planos não falharão."
,"7":"Viva Nabucodonosor, rei de toda a terra, que te enviou para colocar a todos em ordem. Viva o seu poder! Graças a ti, não são apenas os homens que servem o rei. Graças ao seu poder, também as feras, os rebanhos e as aves do céu viverão à disposição de Nabucodonosor e do seu palácio."
,"8":"Ouvimos falar da tua sabedoria e astúcia. Todos comentam que és o melhor em todo o império, o conselheiro mais hábil e o estratega mais admirado."
,"9":"Nós ficámos a saber do relatório que Aquior fez no teu conselho. Os habitantes de Betúlia pouparam-no, e ele contou tudo o que havia dito diante de ti."
,"10":"Por isso, senhor poderoso, não desprezes a opinião dele. Podes crer nela, porque é verdadeira: a nossa gente não sofrerá castigo, nem as armas poderão submetê-la, a não ser que ela cometa pecado contra Deus."
,"11":"Agora, para que o meu senhor não fique decepcionado e de mãos vazias, saibas que a morte cairá sobre eles, porque são réus de um pecado com que irritam o seu Deus todas as vezes que o cometem."
,"12":"Quando lhes faltaram víveres e água, resolveram lançar mão do rebanho e consumir tudo o que Deus, por suas leis, lhes tinha proibido comer."
,"13":"Resolveram consumir até os primeiros frutos do trigo e os dízimos do vinho e do azeite, coisas consagradas aos sacerdotes que ministram diante do nosso Deus em Jerusalém, e que nenhum leigo pode jamais tocar."
,"14":"E como os habitantes de Jerusalém já estão a fazer o mesmo, mandaram até lá uma comissão, para que o conselho permita fazer isso."
,"15":"Logo que receberem a permissão e a colocarem em prática, nesse mesmo dia cairão em teu poder, meu senhor, e serão aniquilados."
,"16":"Quando percebi tudo isso, tratei de fugir. Deus mandou-me para realizar contigo uma façanha que assombrará todos os que dela ficarem sabendo."
,"17":"Esta tua serva é piedosa e serve ao Deus do céu dia e noite. Agora, eu gostaria de ficar junto de ti. Sairei todas as noites pelo vale, rezarei a Deus, e Ele me dirá quando a minha gente cometer o pecado."
,"18":"Eu revelar-to-ei, e então sairás com todo o teu exército, e nenhum deles te poderá resistir."
,"19":"Eu guiar-te-ei através da Judeia, até chegar a Jerusalém, e colocarei o teu trono bem no meio da cidade. Então manejá-los-ás como ovelhas sem pastor, e não haverá nem sequer um cão para latir diante de ti. Já estou a prever todas estas coisas. Tudo me foi anunciado, e eu fui enviada para tas contar»."
,"20":"As palavras de Judite agradaram a Holofernes e aos seus oficiais. Admirados com a sabedoria dela, disseram:"
,"21":"«De um extremo ao outro da Terra, não existe mulher tão bonita e que saiba falar tão bem»."
,"22":"Holofernes disse-lhe: «Deus fez bem mandando-te à frente do povo, para colocar o poder em nossas mãos e destruir todos os que desprezaram o meu senhor."
,"23":"Tu és bela e eloquente. Se fizeres o que me disseste, o teu Deus será o meu Deus, viverás no palácio do rei Nabucodonosor e serás famosa no mundo inteiro»."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Holofernes mandou levar Judite para o lugar onde era colocada a sua baixela de prata, e ordenou que lhe servissem a mesma comida e o mesmo vinho que ele tomava."
,"2":"Judite, porém, disse: «Não provarei nada disso, para não cair em pecado. Eu trouxe as minhas provisões»."
,"3":"Holofernes perguntou-lhe: «E se acabar o que trouxeste, onde poderemos arranjar comida igual? Entre nós, não há ninguém da tua gente»."
,"4":"Judite respondeu: «Pela tua vida, meu senhor, o que eu trouxe comigo não acabará antes que realizes o teu plano através de mim»."
,"5":"Os oficiais de Holofernes levaram Judite para a tenda, e ela repousou até à meia-noite. Depois levantou-se antes do amanhecer,"
,"6":"e mandou dizer a Holofernes: «Senhor, ordena que me deixem sair para rezar»."
,"7":"Holofernes ordenou aos guardas que a deixassem sair. E assim Judite passou três dias no acampamen-to. De noite, ela ia em direcção ao vale de Betúlia e tomava banho na fonte, no posto avançado do acampamento."
,"8":"Depois do banho, ela suplicava ao Senhor Deus de Israel que dirigisse o plano dela, para reerguer o seu povo."
,"9":"Depois de se purificar, voltava para a tenda e lá ficava até que lhe trouxessem o alimento à tarde."
,"10":"No quarto dia, Holofernes ofereceu um banquete somente ao seu pessoal de serviço, sem convidar nenhum oficial."
,"11":"Disse a Bagoas, seu mordomo: «Vai e vê se consegues convencer essa mulher hebreia, que está ao teu cuidado, para que venha comer e beber connosco."
,"12":"Seria uma vergonha não aproveitar a ocasião de ter relações com essa mulher. Se eu não a conquistar, vão zombar de mim»."
,"13":"Bagoas saiu da presença de Holofernes, foi ter com Judite, e disse-lhe: «Que esta bela jovem não tenha medo de se apresentar ao meu senhor como hóspede de honra. Beberás connosco, alegrar-te-ás e passarás o dia como uma das mulheres assírias, que vivem no palácio de Nabucodonosor»."
,"14":"Judite respondeu: «Quem sou eu para contrariar o meu senhor? Farei tudo o que lhe agradar, e isto será para mim uma lembrança agradável até ao dia da minha morte»."
,"15":"Então Judite levantou-se e enfeitou-se com as suas roupas e jóias. A sua serva foi na frente e estendeu no chão, diante de Holofernes, as peles que Bagoas lhe tinha dado, para que se reclinasse enquanto comia."
,"16":"Judite entrou e acomodou-se. Ao vê-la, Holofernes ficou arrebatado, e a paixão agitou-o com o desejo violento de se unir a ela. De facto, desde a primeira vez que a viu, ele espreitava uma ocasião para a seduzir."
,"17":"E Holofernes disse a Judite: «Vamos, bebe e alegra-te connosco»."
,"18":"Judite respondeu: «Claro que vou beber, meu senhor. Hoje é o dia mais feliz de toda a minha vida»."
,"19":"E Judite comeu e bebeu diante de Holofernes, servindo-se do que a sua serva tinha preparado para ela."
,"20":"Holofernes, entusiasmado com ela, bebeu muitíssimo vinho, como nunca havia feito antes, em toda a vida."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Quando se fez tarde, a gente de Holofernes retirou-se. Bagoas fechou a tenda por fora, depois de fazer com que todos os servos saíssem. Todos foram repousar, prostrados pelo excesso de bebida."
,"2":"Na tenda, ficaram apenas Judite e Holofernes caído na cama, completamente embriagado."
,"3":"Judite tinha dito à serva que ficasse do lado de fora do quarto, esperando que ela saísse, como nos outros dias. Tinha dito que sairia para rezar, e já havia falado disso a Bagoas."
,"4":"Todos saíram. Não ficou mais ninguém no quarto, nem pequeno nem grande. Então, de pé e junto ao leito de Holofernes, Judite rezou interiormente: «Senhor Deus de toda a força, volta agora o teu olhar para o que eu estou para fazer em favor da exaltação de Jerusalém."
,"5":"Chegou o momento de ajudares a tua herança e dares sucesso ao meu plano, ferindo o inimigo que se levantou contra nós»."
,"6":"Então Judite aproximou-se da coluna da cama, que ficava junto à cabeça de Holofernes, e pegou na espada dele."
,"7":"Depois chegou perto da cama, agarrou na cabeleira de Holofernes, e suplicou: «Dá-me força agora, Senhor Deus de Israel»."
,"8":"E com toda a força, deu dois golpes no pescoço de Holofernes e cortou-lhe a cabeça."
,"9":"Rolou o corpo do leito e tirou o mosquiteiro das colunas. Depois saiu, entregou a cabeça de Holofernes à serva,"
,"10":"que a colocou na sacola de alimentos. E saíram juntas, como de costume, para rezar. Atravessaram o acampamento, rodearam o vale, subiram a encosta de Betúlia e chegaram à porta da cidade."
,"11":"Judite gritou de longe às sentinelas das portas: «Abri! Abri a porta! O Senhor nosso Deus está connosco, demonstrando ainda a sua força em Israel e o seu poder contra o inimigo. Isso acaba de acontecer hoje»."
,"12":"Os homens da cidade ouviram, desceram logo até à porta e convocaram os anciãos."
,"13":"Adultos e crianças, todos vieram a correr. Parecia-lhes incrível que Judite tivesse voltado. Abriram a porta e receberam-nas. E logo fizeram uma grande fogueira para fazer claridade, e ajuntaram-se ao redor delas."
,"14":"Judite começou a gritar: «Louvai a Deus! Louvai a Deus! Louvai a Deus que não retirou a sua misericórdia da casa de Israel. Nesta noite, Ele matou o inimigo através da minha mão»."
,"15":"Então Judite tirou a cabeça de Holofernes que estava na sacola, mostrou-a e disse: «Esta é a cabeça de Holofernes, general do exército da Assíria. Este é o mosquiteiro, debaixo do qual ele dormia embriagado. O Senhor matou-o pela mão de uma mulher."
,"16":"Viva o Senhor, que me protegeu no meu plano. Juro-vos que o meu rosto seduziu Holofernes, para a sua ruína, mas ele não me fez pecar. A minha honra está intacta»."
,"17":"Todos ficaram assombrados e, inclinando-se em adoração a Deus, disseram a uma só voz: «Bendito sejas, nosso Deus, porque hoje aniquilaste os inimigos do teu povo!»"
,"18":"E Ozias disse a Judite: «Que o Deus Altíssimo te abençoe, minha filha, mais que a todas as mulheres da Terra. Bendito seja o Senhor Deus, criador do Céu e da Terra, que te guiou para cortares a cabeça do chefe dos nossos inimigos."
,"19":"Os que se lembrarem desta façanha de Deus, jamais perderão a confiança que tu inspiras."
,"20":"Que Deus te exalte sempre e te dê prosperidade, porque não vacilaste em expor a própria vida por causa da humilhação da nossa gente, mas vingaste a nossa ruína, indo directamente ao alvo, diante do nosso Deus». E todo o povo aclamou: «Ámen! Ámen!»"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Judite disse ao povo: «Escutai, irmãos. Pegai nesta cabeça e dependurai-a no parapeito da muralha."
,"2":"Quando a aurora raiar e o sol sair sobre a terra, cada um de vós pegue nas suas armas, e todos os homens fortes saiam da cidade. Colocai à frente um chefe, como se fossem descer para a planície contra as sentinelas dos assírios. Mas não desçais."
,"3":"Eles pegarão em armas, e irão ao acampamento para despertar os oficiais do exército assírio. Irão correndo à tenda de Holofernes e não o encontrarão. Então ficarão apavorados e fugirão de vós."
,"4":"Nesse momento, vós e todos os que vivem no território israelita persegui-los-eis para os abaterdes na fuga."
,"5":"Antes, porém, chamai Aquior, o amonita, para que ele veja e reconheça aquele que zombava dos israelitas e que o mandou até nós como réu de morte»."
,"6":"Então chamaram Aquior, que estava na casa de Ozias. Quando ele chegou e viu a cabeça de Holofernes na mão de um homem na assembleia do povo, desmaiou e caiu de bruços."
,"7":"Quando o levantaram, Aquior lançou-se aos pés de Judite e, prostrando-se diante dela, disse: «Bendita sejas tu em todas as tendas de Judá e entre todos os povos! Os que ouvirem a tua fama ficarão perturbados."
,"8":"Agora, conta-me o que foi que fizeste nestes dias». Judite, no meio do povo, contou tudo o que havia feito, desde o dia em que saíra de Betúlia até esse momento."
,"9":"Quando terminou, todos gritaram vivas e encheram a cidade com gritos de alegria."
,"10":"Aquior, vendo tudo o que o Deus de Israel tinha feito, acreditou firmemente em Deus, apresentou-se para a circuncisão e foi definitivamente admitido entre os israelitas."
,"11":"Ao raiar do dia, dependuraram a cabeça de Holofernes na muralha. Os homens empunharam armas e saíram, em esquadrões, para as encostas do monte."
,"12":"Ao vê-los, os assírios informaram os seus chefes, e estes informaram os generais, os comandantes e os oficiais."
,"13":"Quando chegaram à tenda de Holofernes, disseram ao mordomo: «Acorda o nosso chefe, porque esses escravos atreveram-se a descer para nos atacar. Querem ser completamente destruídos»."
,"14":"Bagoas entrou e bateu palmas diante da cortina, pensando que Holofernes estivesse a dormir com Judite."
,"15":"Como ninguém respondesse, Bagoas afastou as cortinas, entrou no quarto e encontrou Holofernes morto, prostrado na entrada: tinham-lhe cortado a cabeça."
,"16":"Bagoas soltou um grito e, rasgando as vestes, começou a chorar, soluçando e gritando."
,"17":"Correu para a tenda onde Judite se alojava. Não a encontrando, precipitou-se para a tropa, gritando:"
,"18":"«Os escravos traíram-nos. Uma só mulher hebreia desonrou a casa do rei Nabucodonosor. Holofernes está deitado no chão, com a cabeça cortada»."
,"19":"Ao ouvirem isto, os oficiais assírios rasgaram os mantos e ficaram completamente perturbados. Os seus gritos e clamores ressoaram por todo o acampamento."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Os soldados que ainda estavam nas tendas, ao ouvirem, ficaram espantados com o que acontecera."
,"2":"Entraram em pânico e, sem esperar um pelo outro, fugiram todos pelos caminhos da planície e da serra, numa debandada geral."
,"3":"Os que estavam acampados na serra, ao redor de Betúlia, também fugiram. Então todos os guerreiros israelitas lançaram-se contra eles."
,"4":"Ozias enviou mensageiros a Betomestaim, a Bebai, a Cobe, a Cola e a todo o território de Israel, comunicando o acontecido e pedindo que todos caíssem sobre o inimigo e o exterminassem."
,"5":"Informados disso, os israelitas caíram sobre todos eles, matando-os até Coba. Os habitantes de Jerusalém e todos os da serra, informados do que acontecera no acampamento inimigo, vieram ajudar. Também os de Galaad e da Galileia os atacaram pelos flancos, causando-lhes muitas baixas, até para além de Damasco e suas fronteiras."
,"6":"Os que ficaram em Betúlia caíram sobre o acampamento assírio e devastaram-no, recolhendo imensos despojos."
,"7":"Ao voltar da matança, os israelitas apossaram-se do resto. Os habitantes das aldeias e dos lugares da serra e da planície tomaram posse de muitos despojos. O saque foi enorme."
,"8":"O sumo sacerdote Joaquim e o conselho de anciãos israelitas de Jerusalém foram contemplar os benefícios que o Senhor tinha feito por Israel e também para conhecer Judite."
,"9":"Chegando à casa dela, todos a elogiaram, dizendo: «Tu és a glória de Jerusalém! Tu és a honra de Israel! Tu és o orgulho da nossa gente!"
,"10":"Tu fizeste essas coisas com a tua própria mão, realizando benefícios para Israel, e Deus alegrou-Se com isso. Que o Senhor Todo-poderoso te abençoe para todo o sempre!» E todos aclamaram: «Ámen»."
,"11":"O saque do acampamento durou trinta dias. Deram a Judite a tenda de Holofernes, com toda a sua prataria, leitos, vasilhas e móveis. Judite recolheu tudo e transportou-o sobre a sua mula. Atrelou os carros e empilhou tudo em cima deles."
,"12":"Todas as mulheres israelitas correram para ver Judite e dar-lhe uma boa recepção. Algumas organizaram uma dança em sua honra. Judite pegou em ramos e repartiu-os com as companheiras,"
,"13":"que fizeram coroas com folhas de oliveira para Judite e para si mesmas. Depois Judite foi à frente de todos, dirigindo a dança das mulheres. Os israelitas iam logo atrás, armados, coroados e cantando hinos."
,"14":"No meio de todos os israelitas, Judite entoou este cântico de acção de graças, enquanto todo o povo a acompanhava com refrões:"
}`)
	CurrentBook.AddChapter(16, `{
"1":"Louvai o meu Deus com pandeiros. Celebrai o Senhor com címbalos. Componde para Ele um salmo,de louvor. Exaltai e invocai,o seu nome."
,"2":"O Senhor é um Deus,que acaba com as guerras. Do seu acampamento no meio do povo, Ele me livrou,da mão dos perseguidores."
,"3":"A Assíria chegou,das montanhas do Norte, com os seus milhares de soldados. A sua multidão cercou as torrentes,e os seus cavalos cobriram as colinas."
,"4":"Ameaçou incendiar o meu território,e matar os meus jovens à espada. Ameaçou lançar ao chão,os meus bebés, tomar as minhas crianças como presa,e raptar as minhas jovens."
,"5":"Mas o Senhor Todo-poderoso,deixou-os frustrados,pela mão de uma mulher."
,"6":"O seu chefe não caiu,diante de soldados, nem foi ferido por filhos de titãs,ou atacado por gigantes enormes. Foi Judite, filha de Merari, que o desarmou com a beleza,do seu rosto."
,"7":"Ela deixou as vestes de viúva, para levantar os aflitos de Israel. Ungiu o rosto com perfume,"
,"8":"prendeu os cabelos com turbante,e vestiu-se de linho para o seduzir."
,"9":"A sua sandália cativou o olhar dele. A sua beleza escravizou-lhe a alma, e a espada cortou-lhe o pescoço!"
,"10":"Os Persas assustaram-se,com a audácia dela, e os Medos perturbaram-se,com a sua ousadia."
,"11":"Então os meus pobres,lançaram o grito de guerra, e eles ficaram assustados. Os meus fracos lançaram o seu grito, e eles encheram-se de terror. Levantaram a voz e eles recuaram."
,"12":"Filhos de escravos os transpassaram,e os feriram como a desertores. E eles pereceram,na batalha do meu Senhor."
,"13":"Cantarei ao meu Deus um cântico novo: Senhor, Tu és grande e glorioso, admirável e invencível em tua força!"
,"14":"Que toda a criação Te sirva, porque ordenaste, e os seres existiram. Enviaste o teu espírito, e eles foram feitos. E nada pode resistir à tua voz."
,"15":"As ondas sacudirão o alicerce,das montanhas,e, diante de Ti, as rochas derreter-se-ão como cera. E Tu serás favorável aos teus fiéis."
,"16":"Os sacrifícios de odor agradável,pouco valem, e a gordura dos holocaustos,e um nada, mas quem teme o Senhor,sempre será grande."
,"17":"Ai das nações que atacam,o meu povo!,O Senhor Todo-poderoso,castigá-las-á no dia do julgamento. Ele pôr-lhes-á fogo e vermes na carne, e eles chorarão de dor para sempre»."
,"18":"Chegando a Jerusalém, adoraram a Deus e, quando todos acabaram de se purificar, ofereceram holocaustos, sacrifícios espontâneos e ofertas votivas."
,"19":"Judite consagrou ao Senhor todos os objectos de Holofernes, que o povo lhe tinha dado, e também o mosquiteiro que ela mesma tirara do leito dele."
,"20":"O povo continuou a fazer festa em Jerusalém, perto do Templo, durante três meses. E Judite ficou entre eles."
,"21":"Depois disso, cada um voltou para a sua herança. Judite regressou a Betúlia e continuou a viver na sua propriedade. Durante toda a vida, ficou muito famosa em todo o país."
,"22":"Teve muitos pretendentes, mas, desde que seu marido Manassés morreu e se reuniu com os seus, ela nunca mais se casou."
,"23":"E a fama de Judite crescia cada vez mais. Viveu na casa de seu marido até à idade de cento e cinco anos. Deu liberdade à sua serva e morreu em Betúlia, sendo enterrada na sepultura de seu marido Manassés."
,"24":"Os israelitas fizeram luto durante sete dias. Antes de morrer, Judite repartiu os seus bens entre os parentes de seu marido Manassés e pelos seus próprios parentes."
,"25":"No seu tempo e depois, durante muitos anos, ninguém mais molestou os israelitas."
}`)

}
func PT_BS_LoadVHNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Memórias de Neemias, filho de Hacalias. No mês de Casleu do vigésimo ano, estava eu na fortaleza de Susa,"
,"2":"quando chegou o meu irmão Hanani com alguns homens de Judá. Pedi logo notícias dos judeus repatriados, e também de Jerusalém."
,"3":"Eles disseram-me: «Os sobreviventes do exílio estão lá, na província, em situação muito miserável e vergonhosa. As muralhas de Jerusalém estão em ruínas e as suas portas foram devoradas pelo fogo»."
,"4":"Ao ouvir tais notícias, sentei-me, chorei e fiquei de luto vários dias, jejuando e rezando ao Deus do céu."
,"5":"Eu disse: «Javé, Deus do céu, Deus grande e terrível, fiel à aliança e misericordioso com aqueles que Te amam e observam os teus mandamentos!"
,"6":"Estejam os teus ouvidos atentos e os teus olhos abertos para atender à súplica do teu servo. Dia e noite Te suplico em favor dos israelitas, teus servos, confessando os pecados que nós, israelitas, cometemos contra Ti. Também eu e a família do meu pai pecámos!"
,"7":"Nós agimos muito mal contigo, e não guardámos os mandamentos, estatutos e normas que transmitiste ao teu servo Moisés."
,"8":"Lembra-Te, porém, do que disseste ao teu servo Moisés: 'Se fordes infiéis, vou espalhar-vos entre as nações."
,"9":"Contudo, se voltardes para Mim, observardes e puserdes em prática os meus mandamentos, mesmo que os vossos exilados estejam espalhados pelos confins do mundo, Eu os recolherei de lá e os reconduzirei ao lugar que escolhi para nele fazer habitar o meu Nome'."
,"10":"Eles são teus servos e teu povo. Tu os resgataste com grande poder e mão forte!"
,"11":"Que os teus ouvidos, Senhor, estejam atentos à súplica do teu servo e dos outros teus servos, que desejam temer o teu Nome! Faz, então, com que eu tenha sucesso e possa conquistar a boa vontade deste homem!»,Eu era, então, copeiro do rei."
}`)
	CurrentBook.AddChapter(2, `{
"1":"No mês de Nisã do vigésimo ano do reinado de Artaxerxes, como era eu o responsável pelas bebidas, peguei no vinho e fui servir o rei. Eu nunca me apresentara triste na presença dele."
,"2":"Então o rei perguntou-me: «Porque é que estás com o rosto abatido? Não estás doente, mas tens o coração angustiado». Eu assustei-me,"
,"3":"mas respondi ao rei: «Viva o rei para sempre! Como não iria ficar triste, quando a cidade onde estão enterrados os meus antepassados está em ruínas e as suas portas devoradas pelo fogo?»"
,"4":"O rei então disse-me: «O que é que gostarias de fazer?» Rezei ao Deus do céu,"
,"5":"e respondi: «Se Vossa Majestade concorda e está satisfeito com o seu servo, deixe-me ir para Judá, a fim de reconstruir a cidade onde estão enterrados os meus antepassados»."
,"6":"O rei e a rainha, que estava sentada ao lado dele, perguntaram-me: «Quanto tempo vai durar a tua viagem? Quando voltarás?» Marquei uma data. O rei concordou e deixou-me partir."
,"7":"Então acrescentei: «Se Vossa Majestade estiver de acordo, dê-me cartas de recomendação para os governadores da região ocidental do rio Eufrates, a fim de que me facilitem a viagem até Judá."
,"8":"Dê-me também uma carta para Asaf, guarda do parque florestal do rei, a fim de que ele me forneça a madeira necessária para reformar as portas da fortaleza do Templo, as portas da muralha e também a casa onde vou morar». O rei deu-me as cartas, porque a mão bondosa do meu Deus estava do meu lado."
,"9":"Cheguei junto dos governadores da região ocidental do rio Eufrates, e apresentei as cartas do rei. E o rei concedeu-me também uma escolta formada por oficiais e cavaleiros do exército."
,"10":"Quando o horonita Sanabalat e o ministro amonita Tobias souberam da minha chegada, ficaram aborrecidos por ter chegado alguém para trabalhar em benefício dos israelitas."
,"11":"Cheguei a Jerusalém e descansei três dias."
,"12":"Depois levantei-me à noite, acompanhado de alguns homens, sem dizer a ninguém o que Deus me havia inspirado fazer em Jerusalém. Levava comigo apenas o jumento que eu montava."
,"13":"Saí de noite pela porta do Vale, e fui até à fonte do Dragão e à porta do Esterco. Comprovei que as muralhas de Jerusalém estavam cheias de brechas e as portas consumidas pelo fogo."
,"14":"Segui para a porta da Fonte e para o reservatório de água do rei. Como não havia espaço para o animal,"
,"15":"continuei a pé riacho acima, pela noite dentro. Observei as muralhas, entrei de novo pela porta do Vale, e voltei para casa."
,"16":"As autoridades não chegaram a saber por onde eu tinha andado ou o que é que pensava fazer. Eu ainda não tinha contado nada aos judeus, nem aos sacerdotes, nem às pessoas importantes, nem às autoridades ou responsáveis pelas obras."
,"17":"Mais tarde, disse-lhes: «Estais a ver a miséria em que nos encontramos. Jerusalém está em ruínas e as suas portas foram queimadas. Vamos reconstruir as muralhas de Jerusalém, e esta vergonha acabará»."
,"18":"Então contei de que maneira o meu Deus me ajudava, e tudo o que o rei me havia dito. Eles disseram: «Vamos começar o trabalho». E arregaçaram as mangas para realizar esse bom projecto."
,"19":"Quando o horonita Sanabalat, o ministro amonita de nome Tobias e o árabe Gosem souberam do facto, começaram a zombar e a fazer pouco de nós, dizendo: «Que é que andais a fazer? Quereis revoltar-vos contra o rei?»"
,"20":"Mas eu respondi-lhes: «O Deus do céu vai ajudar-nos. Nós, servos de Deus, continuaremos a reconstrução. Vós, porém, não tereis terrenos, nem direitos, nem lembrança em Jerusalém»."
}`)
	CurrentBook.AddChapter(3, `{
"1":"O sumo sacerdote Eliasib e os seus irmãos sacerdotes começaram a reconstruir a porta das Ovelhas. Montaram os portais, colocaram os batentes, as fechaduras e as trancas, reformaram a muralha até à torre dos Cem e a torre de Hananeel."
,"2":"Ao lado de Eliasib trabalharam os homens de Jericó e também Zacur, filho de Imri."
,"3":"A gente de Asená reconstruiu a porta dos Peixes, montou os portais, colocou os batentes, as fechaduras e as trancas."
,"4":"Ao lado deles trabalhavam na restauração Meremot, filho de Urias, da família de Acus, Mosolam, filho de Baraquias, da família de Mesezebel, e também Sadoc, filho de Baana."
,"5":"O povo de Técua reformou o trecho seguinte às muralhas, mas as pessoas importantes negaram-se a colaborar com os mestres de obras."
,"6":"Joiada, filho de Fasea, e Mosolam, filho de Besodias, restauraram a porta do bairro Novo. Montaram os portais e colocaram os batentes, as fechaduras e as trancas."
,"7":"Reformaram o trecho seguinte: Meltias de Gabaon e Jadon de Meronot, gente de Gabaon e Masfa, da jurisdição do governador da região ocidental do rio Eufrates."
,"8":"Ao lado deles trabalhavam Oziel, que era ourives, e Hananias, que era perfumista; estes puseram Jerusalém em ordem até à muralha larga."
,"9":"Ao lado deles trabalhava Rafaías, filho de Hur, chefe de um subdistrito de Jerusalém."
,"10":"Jedaías, filho de Haromaf, reformou a parte da muralha que fica em frente da sua casa. Hatus, filho de Hasebonias, reformou o trecho ao lado."
,"11":"O trecho seguinte, até à torre dos Fornos, foi reformado por Melquias, filho de Herem, e por Hasub, filho de Faat-Moab."
,"12":"Um outro chefe de subdistrito de Jerusalém, Selum, filho de Aloés, acompanhado pelos seus filhos, reformou o trecho ao lado."
,"13":"A porta do Vale foi reformada por Hanun e pelos moradores de Zarroe. Eles reconstruíram-na, colocaram os batentes, as fechaduras e as trancas, e reconstruíram também quinhentos metros da muralha até à porta do Esterco."
,"14":"O chefe do distrito de Bet-Acarem, de nome Melquias, filho de Recab, é que reparou a porta do Esterco. Ele reconstruiu-a, colocou-lhe os batentes, as fechaduras e as trancas."
,"15":"O chefe do distrito de Masfa, Selum, filho de Col-Hoza, reformou a porta da Fonte. Refez o tecto da entrada, colocou os batentes, as fechaduras e as trancas. Reconstruiu também as muralhas desde o reservatório de água de Siloé, ao lado do Jardim do Rei, até à escada que desce da Cidade de David."
,"16":"Daí para a frente, Neemias, filho de Azboc e chefe do subdistrito de Betsur, continuou o trabalho até ao cemitério de David, onde se encontra o reservatório artificial, perto da Casa dos Heróis."
,"17":"O trecho seguinte ficou para os levitas Reum, filho de Bani, e Hasabias, que era também chefe de um subdistrito de Ceila, para a parte que pertencia à sua jurisdição."
,"18":"Daí em frente, trabalharam outros seus irmãos levitas: o chefe de outro subdistrito de Ceila, Benui, filho de Henada,"
,"19":"com o chefe de Masfa, Azer, filho de Jesua, reformaram a parte ao lado. Eles refizeram totalmente a área da curva que fica na Esquina, em frente à subida do Arsenal."
,"20":"Seguindo em frente, Baruc, filho de Zabai, restaurou a parte que vai da Esquina até à porta da casa do sumo sacerdote Eliasib."
,"21":"A parte da muralha que vai da porta até ao fim da casa de Eliasib, foi totalmente refeita por Meremot, filho de Urias, da família de Acos."
,"22":"O pedaço seguinte foi reconstruído pelos sacerdotes que moravam na periferia:"
,"23":"Benjamim e Hasub reformaram a parte que fica em frente das suas casas; Azarias, filho de Maasias, filho de Ananias, reformou a parte que fica ao lado da sua casa."
,"24":"A parte seguinte, desde a casa de Azarias até à Esquina e até ao ângulo foi totalmente reconstruída por Benui, filho de Henadad."
,"25":"Falel, filho de Ozi, reformou a parte que fica em frente da Esquina, diante da torre que sobressai acima do palácio do rei e que dá para o pátio da prisão. Depois vem a parte retocada por Fadaías, filho de Faros,"
,"26":"até em frente da porta das Águas, do lado oriental, em frente da torre que sobressai."
,"27":"Desde essa grande torre até ao muro do Ofel, foram os moradores de Técua que cuidaram da reforma."
,"28":"A partir da porta dos Cavalos, os sacerdotes cuidaram das reformas, cada um fazendo a parte que estava em frente da própria casa."
,"29":"Foi assim que Sadoc, filho de Hemer, reformou a muralha em frente da sua casa, e o mesmo fez Semaías, filho de Sequenias, que era guarda da porta Oriental."
,"30":"Hananias, filho de Selemias, e Hanun, sexto filho de Selef, fizeram outro pedaço da muralha, no trecho seguinte. O próximo trecho foi reformado por Mosolam, filho de Baraquias, bem em frente da sua morada."
,"31":"Em seguida, o ourives Melquias consertou a parte que vai até à casa dos oblatos e dos comerciantes, em frente da porta do Vigia, até à sala alta do Ângulo."
,"32":"Da sala alta do Ângulo até à porta das Ovelhas, a reforma foi realizada pelos ourives e pelos comerciantes."
,"33":"Quando ouviu dizer que nós estávamos a reconstruir as muralhas, Sanabalat ficou furioso, e irritado começou a zombar dos judeus,"
,"34":"dizendo à sua gente e aos poderosos de Samaria: «O que é que esses judeus miseráveis andam a fazer? A reconstruir as muralhas e a oferecer sacrifícios? Querem terminar tudo num dia? Querem dar vida nova às pedras desses montes de cacos que sobraram do incêndio?»"
,"35":"O amonita Tobias estava ao lado dele, e completou: «Deixa-os construir! Basta que uma raposa lá suba, para a muralha cair!»"
,"36":"Escuta, nosso Deus, como zombam de nós! Devolve a essa gente o insulto que fazem! Manda-os para o exílio, para que outros zombem deles."
,"37":"Não perdoes o seu pecado. Não tires da tua vista o crime deles, pois estão a ofender os que trabalham na reconstrução."
,"38":"Continuámos a reconstruir a muralha, que foi restaurada por completo até à sua meia altura. O povo trabalhava com disposição."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Quando ouviram contar que a reforma das muralhas de Jerusalém prosseguia e que as brechas começavam a ficar fechadas, Sanabalat, Tobias, os árabes, a gente de Amon e a gente de Azoto ficaram irritados."
,"2":"Combinaram atacar Jerusalém e espalhar confusão dentro dela."
,"3":"Então invocámos o nosso Deus e colocámos guardas dia e noite para proteger a cidade."
,"4":"Os judeus diziam: «Os carregadores estão esgotados e as ruínas são muitas. Sozinhos, não conseguiremos reconstruir a muralha!»"
,"5":"Enquanto isso, os nossos inimigos comentavam: «Vamos infiltrar-nos entre eles, sem que percebam. Nós os mataremos, e a construção ficará paralisada»."
,"6":"Alguns judeus, que viviam entre eles, chegavam de diversos lugares e frequentemente nos contavam que eles iam atacar-nos."
,"7":"Então organizei o povo por famílias, todos armados de espadas, lanças e arcos, e coloquei-os em trincheiras por detrás das muralhas e nos lugares abertos."
,"8":"Notando que o povo estava assustado, chamei a atenção das pessoas importantes, das autoridades e de todo o povo, dizendo: «Não tenhais medo deles! Lembrai-vos de que o Senhor é grande e terrível! E lutai pelos vossos irmãos, filhos, filhas, mulheres e casas»."
,"9":"Quando os nossos inimigos perceberam que nós sabíamos de tudo, e que Deus tinha derrubado o plano deles, todos nós pudemos voltar para a reforma das muralhas, cada um para a sua tarefa."
,"10":"A partir desse dia, porém, metade dos meus homens trabalhava, enquanto a outra metade ficava de atalaia com lanças, escudos, arcos e couraças, porque andavam atrás de todos os judeus"
,"11":"que reconstruíam a muralha. Os carregadores também estavam armados: com uma das mãos faziam o serviço e com a outra seguravam a arma."
,"12":"Todos os construtores tinham a espada à cintura enquanto trabalhavam. Ao meu lado ficava sempre um tocador de trombeta,"
,"13":"porque eu havia dito às pessoas importantes, às autoridades e ao povo: «Temos muito trabalho, e numa extensão muito grande! Nós estamos muito espalhados, cada qual num ponto de muralha, longe um do outro."
,"14":"Quando ouvirdes a trombeta, estejais onde estiverdes, correi para vos reunir a nós. O nosso Deus vai combater por nós»."
,"15":"E assim continuámos, uns trabalhando e outros empunhando as lanças, desde o raiar da aurora até surgirem as primeiras estrelas."
,"16":"Nessa ocasião, eu disse também ao povo: «Todos pernoitarão em Jerusalém com os seus serventes. De noite montaremos guarda, e de dia trabalharemos»."
,"17":"Eu, os meus irmãos, os meus serventes e os meus guarda-costas dormíamos vestidos e com a arma ao alcance da mão."
}`)
	CurrentBook.AddChapter(5, `{
"1":"O povo pobre, sobretudo as mulheres, começaram a protestar fortemente contra os seus irmãos judeus."
,"2":"Uns diziam: «Fomos obrigados a vender os nossos filhos e filhas para comprar trigo, e assim comer e não morrer de fome»."
,"3":"Outros diziam: «Passámos tanta fome que precisámos de hipotecar os nossos campos, vinhas e casas para conseguir trigo»."
,"4":"Outros ainda diziam: «Tivemos que pedir dinheiro emprestado, penhorando os nossos campos e vinhas, para podermos pagar os impostos ao rei»."
,"5":"Pois bem! Nós somos iguais aos nossos irmãos, e os nossos filhos são como os filhos deles! Apesar disso, somos obrigados a sujeitar os nossos filhos e filhas à escravidão. E algumas das nossas filhas já foram reduzidas à escravidão, e não podemos fazer nada, pois os nossos campos e vinhas já pertencem a outros»."
,"6":"Fiquei indignado ao ouvir essas queixas e o que estava a acontecer."
,"7":"Não me contive e repreendi as pessoas importantes e os chefes, dizendo: «Vós estais agindo como usurários em relação aos vossos irmãos!» Convoquei contra eles uma assembleia geral,"
,"8":"e disse-lhes: «Nós, na medida que pudemos, resgatámos os nossos irmãos judeus que se tinham vendido aos estrangeiros. Vós, porém, vendeis os vossos irmãos para que os resgatemos». Eles não encontraram resposta e ficaram calados."
,"9":"Eu continuei: «O que fazeis não está certo. Não quereis agir conforme o temor de Deus, para que as nações inimigas não zombem de nós?"
,"10":"Eu, os meus irmãos e os meus ajudantes também emprestámos dinheiro e trigo a essas pessoas. Pois bem! Vamos perdoar essa dívida."
,"11":"Devolvei-lhes hoje mesmo os seus campos, vinhas, olivais e casas. Perdoai também as penhoras em dinheiro, trigo, vinho e azeite, que lhes tirastes»."
,"12":"Eles disseram: «Vamos devolver tudo, sem cobrar nada. Faremos como tu propuseste». Então chamei os sacerdotes e, na sua presença, fiz com que jurassem manter a palavra."
,"13":"Depois, sacudi a dobra do meu manto, e disse: «Que Deus sacuda para fora da sua própria casa e dos seus bens todo aquele que não mantiver a sua palavra. Será sacudido e despojado». Toda a assembleia respondeu: «Ámen!» e louvou a Javé. E eles cumpriram o que haviam prometido."
,"14":"Desde o dia em que o rei me nomeou governador do país de Judá, isto é, do vigésimo ao trigésimo segundo ano do rei Artaxerxes, durante doze anos, eu e os meus irmãos jamais comemos às custas do cargo."
,"15":"Os governadores anteriores exploravam o povo, exigindo diariamente quatrocentos gramas de prata para alimento e vinho. E até os seus subordinados se aproveitavam do povo. Eu, por temor de Deus, não fiz nada disso."
,"16":"Além do mais, trabalhei pessoalmente na reconstrução da muralha, embora não fosse proprietário de terreno, e os meus empregados passavam o dia na obra."
,"17":"À minha mesa comiam cento e cinquenta, entre pessoas importantes e chefes, além de outras pessoas dos povos vizinhos que nos vinham visitar."
,"18":"Cada dia, na minha casa, eram preparados um boi, seis ovelhas gordas e muitas aves. De dez em dez dias renovava-se com fartura a reserva de toda a espécie de vinho. E, com tudo isso, eu nunca cobrei a manutenção de governador, pois o encargo de impostos já pesava muito sobre o povo."
,"19":"Lembra-Te em meu favor, ó Deus, de tudo o que fiz de bom para este povo!"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Sanabalat, Tobias, o árabe Gosem e outros inimigos nossos souberam que eu tinha reconstruído a muralha e que já não havia brecha nenhuma. Eu só não tinha colocado as folhas das portas."
,"2":"Então Sanabalat e Gosem mandaram-me dizer: «Vem encontrar-te connosco em Cefirim no vale de Ono». Eles, porém, tinham más intenções,"
,"3":"e eu mandei-lhes responder: «Estou com muito trabalho e não posso ir. Não vou parar a obra para me encontrar convosco»."
,"4":"Quatro vezes eles mandaram o mesmo recado, quatro vezes eu dei a mesma resposta."
,"5":"À quinta vez, Sanabalat mandou o mesmo recado, através de um empregado seu que trazia na mão uma carta aberta."
,"6":"Nessa carta estava escrito: «Entre as nações corre a notícia - e Gosem confirma - segundo a qual tu e os judeus quereis promover uma revolução, e por isso é que estás a reconstruir as muralhas. Conforme os rumores, tu serias o rei"
,"7":"e terias nomeado profetas para proclamarem aí em Jerusalém que há um rei em Judá. Esses boatos vão chegar aos ouvidos do rei. Então, vem, e conversaremos sobre o assunto»."
,"8":"Eu mandei-lhe dizer: «Esses boatos não têm fundamento. São pura invenção tua»."
,"9":"Na verdade, eles queriam amedrontar-nos, pensando que iríamos abandonar a obra, deixando-a sem a acabar. Mas foi a partir de então que eu pus ainda mais coragem no trabalho."
,"10":"Certo dia, fui à casa de Semaías, filho de Delaías, da família de Metabeel, que se achava impedido. Ele disse-me: «Vamos para o Templo de Deus, para dentro do santuário. Vamos fechar bem as portas, porque estão vindo para te matar. Eles pensam matar-te esta noite»."
,"11":"Mas eu respondi-lhe: «Um homem como eu não foge, nem se esconde no Templo para salvar a vida. Não vou»."
,"12":"Percebi que não fora Deus que lhe tinha mandado fazer essa profecia. Tobias e Sanabalat é que tinham pago para ele fazer isso,"
,"13":"a fim de que eu ficasse com medo e fizesse o que eles queriam. Cometendo um erro, eu iria desonrar o meu nome, e eles poderiam desmoralizar-me."
,"14":"Lembra-Te, meu Deus, do que Tobias e Sanabalat fizeram! Lembra-Te também da profetisa Noadias e dos outros profetas que tentaram amedrontar-me."
,"15":"As muralhas ficaram prontas no dia vinte e cinco do mês de Elul, após cinquenta e dois dias de trabalho."
,"16":"Quando os nossos inimigos souberam e as nações vizinhas o viram, ficaram muito admirados e reconheceram que o nosso Deus era o autor dessa obra."
,"17":"Nesse tempo, as pessoas importantes de Judá mantinham muita correspondência de cartas com Tobias,"
,"18":"que tinha muitos aliados em Judá, pois era genro de Sequenias, filho de Area, e seu filho Joanã era casado com a filha de Mosolam, filho de Baraquias."
,"19":"Eles elogiavam-no muito na minha presença e contavam-lhe tudo o que eu dizia. E Tobias continuava sempre a mandar cartas para me intimidar."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Quando a muralha ficou pronta e eu coloquei as portas, foram nomeados os porteiros, cantores e levitas."
,"2":"Confiei a administração de Jerusalém ao meu irmão Hanani e a Hananias, chefe da fortaleza, homem fiel e que temia a Deus como poucos."
,"3":"Eu disse-lhes: «Não abrais as portas de Jerusalém antes que o sol comece a aquecer. À tarde, com o sol ainda alto, fechai e trancai as portas. Formai também corpos de guarda com os habitantes de Jerusalém, uns vigiando nos seus postos e outros diante da sua própria casa»."
,"4":"A cidade era espaçosa e grande, mas o povo que nela morava era diminuto e as casas ainda não estavam reconstruídas."
,"5":"Então Deus inspirou-me a reunir as pessoas importantes, os chefes e o povo, a fim de fazer o recenseamento das famílias. Encontrei o registo genealógico dos primeiros que tinham voltado do exílio, e achei escrito o seguinte:"
,"6":"Estes são os cidadãos da província que voltaram do exílio. São aqueles que Nabucodonosor, rei da Babilónia, tinha exilado, e que voltaram para Jerusalém e Judá, cada qual para a sua cidade."
,"7":"Eles vieram com Zorobabel, Josué, Neemias, Azarias, Raamias, Naamani, Mardoqueu, Belsã, Mesfarat, Beguai, Naum e Baana. Lista dos israelitas: "
,"8":"Duas mil, cento e setenta e duas pessoas, da descendência de Faros."
,"9":"Trezentas e setenta e duas pessoas, da descendência de Safatias."
,"10":"Seiscentas e cinquenta e duas, da descendência de Area."
,"11":"Duas mil oitocentas e dezoito, da descendência de Faat-Moab, isto é, da família de Josué e Joab."
,"12":"Mil duzentas e cinquenta e quatro pessoas, da descendência de Elam."
,"13":"Oitocentas e quarenta e cinco, da descendência de Zetua."
,"14":"Setecentas e sessenta, da descendência de Zacai."
,"15":"Seiscentas e quarenta e oito, da descendência de Benui."
,"16":"Seiscentas e vinte e oito, da descendência de Bebai."
,"17":"Duas mil trezentas e vinte e duas pessoas, da descendência de Azgad."
,"18":"Seiscentas e sessenta e sete, da descendência de Adonicam."
,"19":"Duas mil sessenta e sete, da descendência de Beguai."
,"20":"Seiscentas e cinquenta e cinco, da descendência de Adin."
,"21":"Noventa e oito, da descendência de Hasum."
,"23":"Trezentas e vinte e quatro, da descendência de Besai."
,"24":"Cento e doze, da descendência de Haref."
,"25":"Noventa e cinco, descendentes de Gabaon."
,"26":"Cento e oitenta e oito homens de Belém e de Netofa."
,"27":"Cento e vinte e oito homens de Anatot."
,"28":"Quarenta e duas pessoas originárias de Bet-Azmot."
,"29":"Setecentas e quarenta e três pessoas de Cariat-Iarim, Cafira e Beerot."
,"30":"Seiscentas e vinte e uma, de Ramá e Gaba."
,"31":"Cento e vinte e duas, de Macmas."
,"32":"Cento e vinte e três, de Betel e Hai."
,"33":"Cinquenta e duas pessoas originárias de outro Nebo."
,"34":"Mil duzentas e cinquenta e quatro, da descendência de outro Elam."
,"35":"Trezentas e vinte, da descendência de Harim."
,"36":"Trezentas e quarenta e cinco, descendentes de Jericó."
,"37":"Setecentas e vinte e uma, de Lod, Hadid e Ono."
,"38":"Três mil novecentas e trinta, descendentes de Senaá."
,"39":"Sacerdotes: Novecentos e setenta e três, descendentes de Jedaías, ou seja, da família de Josué."
,"40":"Mil e cinquenta e dois, descendentes de Emer."
,"41":"Mil duzentos e quarenta e sete, descendentes de Fasur."
,"42":"Mil e dezassete, descendentes de Harim."
,"43":"Levitas: Setenta e quatro, descendentes de Josué e Cadmiel, filhos de Odovias."
,"44":"Cantores: Cento e quarenta e oito, descendentes de Asaf."
,"45":"Porteiros: Cento e trinta e oito, descendentes de Selum, Ater, Telmon, Acub, Hatita e Sobai."
,"46":"Oblatos: descendentes de Siaá, Hasufa, Tabaot,"
,"47":"Ceros, Sia, Fadon,"
,"48":"Lebana, Hagaba, Selmai,"
,"49":"Hanã, Gidel, Gaar,"
,"50":"Raaías, Rasin, Necoda,"
,"51":"Gazam, Oza, Fasea,"
,"52":"Besai, meunitas e nefusitas."
,"53":"Descendentes de Bacbuc, Hacufa, Harur,"
,"54":"Baslut, Meida, Harsa,"
,"55":"Bercos, Sísara, Tema,"
,"56":"Nasias e Ha-tifa."
,"57":"Descendentes dos escravos de Salomão: Descendentes de Sotai, Soferet, Feruda,"
,"58":"Jaala, Darcon, Gidel,"
,"59":"Safatias, Hatil, Foqueret-Assebaim e Amon."
,"60":"Os oblatos e os descendentes dos escravos de Salomão eram ao todo trezentas e noventa e duas pessoas."
,"61":"As seguintes pessoas que voltaram de Tel-Mela, Tel-Harsa, Querub, Adon e Emer não puderam provar que a sua família e a sua raça eram de origem israelita:"
,"62":"Seiscentos e quarenta e dois, descendentes de Dalaías, Tobias e Necoda,"
,"63":"além da gente de família sacerdotal, descendentes de Hobias, Acos e Berzelai. Este casara-se com uma filha do galaadita Berzelai, e adoptara o nome dele."
,"64":"Todos eles procuraram o registo da sua genealogia, mas não o encontraram. Foram afastados do sacerdócio como impuros."
,"65":"Sua Excelência proibiu-os de comer os alimentos sagrados, até aparecer um sacerdote que consultasse os Urim e os Tumim."
,"66":"No total, a comunidade era de quarenta e duas mil trezentas e sessenta pessoas,"
,"67":"sem contar os sete mil trezentos e trinta e sete escravos. Entre eles, havia também duzentos e quarenta e cinco cantores e cantoras."
,"68":"Tinham quatrocentos e trinta e cinco camelos, e seis mil setecentos e vinte jumentos."
,"69":"Alguns chefes de família trouxeram donativos para as obras. Sua Excelência depositou no cofre mil dracmas de ouro, cinquenta cálices e trinta túnicas para os sacerdotes."
,"70":"Alguns chefes de família depositaram, no cofre das obras, vinte mil dracmas de ouro e duas mil e duzentas minas de prata."
,"71":"Os donativos feitos pelo resto do povo alcançaram a soma de vinte mil dracmas de ouro, duas mil minas de prata e sessenta e sete túnicas para os sacerdotes."
,"72":"Os sacerdotes, levitas e parte do povo passaram a morar em Jerusalém, enquanto os cantores, porteiros e oblatos, como todos os israelitas, foram morar cada um na sua cidade. No sétimo mês, os israelitas tinham-se estabelecido nas suas cidades."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Todo o povo, como se fosse uma única pessoa, reuniu-se na praça que fica em frente da porta das Águas. O povo pediu que Esdras, doutor da Lei, trouxesse o livro da Lei de Moisés, que Javé tinha dado a Israel."
,"2":"Então o sacerdote Esdras trouxe o livro da lei à presença da assembleia. Era o dia primeiro do sétimo mês, e estavam reunidos homens, mulheres e todos os que tinham o uso da razão."
,"3":"Na praça diante da porta das Águas, desde o amanhecer até ao meio-dia, Esdras leu o livro a todos os homens e mulheres e a todos os que tinham o uso da razão. Todo o povo seguia com atenção a leitura do livro da Lei."
,"4":"Esdras, doutor da Lei, estava sobre um palanque de madeira, feito para a ocasião. À sua direita encontravam-se Matatias, Sema, Anias, Urias, Helcias, Maasias. À esquerda estavam Fadaías, Misael, Melquias, Hasum, Hasbadana, Zacarias e Mosolam."
,"5":"Esdras abriu o livro à vista de todo o povo, pois estava em lugar mais alto. Quando ele abriu o livro, o povo ficou de pé."
,"6":"Esdras bendisse a Javé, o grande Deus, e todo o povo, com as mãos erguidas, respondeu: «Ámen! Ámen!» Depois ajoelharam-se e prostraram-se com o rosto por terra diante de Javé."
,"7":"Os levitas Josué, Bani, Serebias, Jamin, Acub, Sabatai, Hodias, Maasias, Celita, Azarias, Jozabad, Hanã e Falaías, explicavam a Lei ao povo, que permanecia de pé."
,"8":"Liam o livro da Lei de Deus, traduzindo-o e dando explicações, para que o povo entendesse a leitura."
,"9":"O governador Neemias, o sacerdote Esdras, doutor da Lei, e os levitas que instruíam o povo, vendo que as pessoas choravam ao escutar a leitura da Lei, disseram: «Hoje é dia consagrado a Javé, vosso Deus! Não fiqueis tristes e deixai de chorar!»"
,"10":"Em seguida, Esdras disse: «Ide para casa, fazei uma bela refeição, bebei um bom vinho e reparti com os que não têm nada, porque hoje é dia consagrado a nosso Senhor. Ninguém fique triste, pois a alegria de Javé é a vossa força»."
,"11":"Os levitas também acalmavam o povo, dizendo: «Ficai tranquilos, porque é dia santo. Não fiqueis tristes»."
,"12":"E o povo foi para casa comer e beber. Repartiram com quem não tinha nada e fizeram uma grande festa, porque haviam compreendido a mensagem que lhes fora explicada."
,"13":"No dia seguinte, os chefes de família de todo o povo, com os sacerdotes e os levitas, reuniram-se com Esdras, doutor da Lei, para estudar o livro da Lei."
,"14":"Encontraram escrito na Lei que Javé, por meio de Moisés, tinha mandado que os israelitas morassem em tendas, durante a festa do sétimo mês."
,"15":"Então anunciaram em todas as cidades e em Jerusalém: «Ide ao monte e trazei ramos de oliveira, pinheiro, murta, palmeira e outras árvores que dão muitos ramos, para fazer tendas, conforme está prescrito»."
,"16":"O povo foi, trouxe os ramos e fez tendas, uns no terraço de suas casas, outros nos pátios do Templo de Deus, na praça em frente da porta das Águas ou na praça da porta de Efraim."
,"17":"Assim a comunidade inteira dos que tinham voltado do exílio fez tendas e nelas acampou. Os israelitas não tinham feito isso desde os tempos de Josué, filho de Nun. Houve uma grande festa!"
,"18":"Todos os dias, do primeiro ao último, Esdras leu o livro da Lei de Deus. A festa durou sete dias e, no oitavo dia, foi feita uma assembleia solene, conforme está prescrito."
}`)
	CurrentBook.AddChapter(9, `{
"1":"No dia vinte e quatro desse mesmo mês, os israelitas reuniram-se para um jejum, vestidos de pano de saco e com a cabeça coberta de pó."
,"2":"As pessoas de origem israelita separaram-se de todos os estrangeiros e, de pé, puseram-se a confessar os próprios pecados e as culpas dos seus antepassados."
,"3":"Num quarto do dia, o povo ficava de pé onde estava, e era feita a leitura da Lei de Javé, seu Deus. No outro quarto do dia, eles confessavam os seus pecados, prostrando-se diante de Javé, seu Deus."
,"4":"Josué, Benui, Cadmiel, Sebanias, Buni, Serebias, Bani e Canani subiram ao palanque dos levitas e invocaram Javé, seu Deus."
,"5":"Os levitas Josué, Cadmiel, Bani, Hasabneias, Serebias, Hodias, Sebanias e Fetaías disseram: «Levantai-vos e bendizei a Javé, vosso Deus». Bendito sejas Tu, Javé, nosso Deus, desde sempre e para sempre. Bendito seja o teu Nome glorioso, que supera toda a bênção e louvor!"
,"6":"Javé, Tu és o único Deus!,Fizeste o céu e o mais alto dos céus, e todos os seus exércitos. Fizeste a Terra e o que ela contém. Fizeste os mares e o que neles existe. Dás vida a tudo isso, e o exército do céu Te adora."
,"7":"Tu és Javé, o Deus que escolheu Abrão. Tu o tiraste de Ur dos Caldeus,e lhe deste o nome de Abraão."
,"8":"Viste que o seu coração era fiel a Ti,e com ele fizeste aliança, para lhe dares a ele e à sua descendência,a terra dos cananeus, heteus e amorreus, dos ferezeus, jebuseus e gergeseus. E cumpriste a tua promessa, porque Tu és justo."
,"9":"Viste a aflição,dos nossos antepassados no Egipto, ouviste o seu clamor,junto ao Mar Vermelho."
,"10":"Realizaste sinais e prodígios,contra o Faraó, contra os seus ministros,e todo o povo do país, pois sabias que tinham oprimido,os nossos antepassados, e ganhaste uma fama que dura até hoje."
,"11":"Abriste o mar diante deles, e atravessaram o mar a pé enxuto. Lançaste no abismo,os seus perseguidores, como pedra em águas profundas."
,"12":"De dia, Tu os guiaste,na coluna de nuvem, e de noite, na coluna de fogo, para iluminar à frente deles,o caminho que deviam percorrer."
,"13":"Desceste ao monte Sinai, e do céu falaste com eles. Tu lhes deste normas justas,e leis verdadeiras, estatutos e mandamentos excelentes."
,"14":"Revelaste-lhes o teu santo sábado, e, por meio do teu servo Moisés, Tu lhes deste mandamentos, estatutos e a Lei."
,"15":"Quando tinham fome, Tu lhes deste o pão do céu. Quando tinham sede, fizeste brotar água do rochedo. Tu os mandaste tomar posse da Terra, que tinhas jurado dar-lhes."
,"16":"Os nossos antepassados, porém, encheram-se de orgulho, tornaram-se altivos,e desobedeceram,aos teus mandamentos."
,"17":"Não quiseram ouvir, nem lembrar,as maravilhas que realizaste,em favor deles. Ficaram altivos e empenharam-se,em voltar para a escravidão do Egipto. Tu, porém, és o Deus que perdoa, cheio de piedade e compaixão, lento para a cólera e cheio de amor, e não os abandonaste."
,"18":"Fizeram um bezerro de metal,e disseram: «Este é o teu Deus,que te tirou do Egipto!»,Cometeram uma ofensa terrível."
,"19":"Tu, porém, com grande compaixão, não os abandonaste no deserto. Não se afastou deles,a coluna de nuvem, que os guiava de dia pelo caminho, nem a coluna de fogo, que de noite lhes iluminava,o caminho que deviam percorrer."
,"20":"Deste-lhes o teu bom espírito,para os tornar prudentes. Não lhes tiraste da boca o maná, e, na sede, deste-lhes água."
,"21":"Durante quarenta anos,Tu os sustentaste no deserto, e de nada sentiram falta. As suas roupas não se gastaram,e seus pés não ficaram inchados."
,"22":"Entregaste-lhes reinos e povos, e entre eles repartiste o território. Tomaram posse da terra de Seon, rei de Hesebon, e da terra de Og, rei de Basã."
,"23":"Multiplicaste os seus filhos,como as estrelas do céu, e os introduziste na terra, cuja posse tinhas prometido,aos seus antepassados."
,"24":"Os filhos invadiram,e tomaram posse da Terra, e Tu derrotaste diante deles,os cananeus que moravam no país. Tu os entregaste nas suas mãos, e também os reis e os povos do país, para que os tratassem,como bem entendessem."
,"25":"Eles conquistaram cidades fortificadas,e terra fértil. Tomaram posse de casas,bem abastecidas, cisternas prontas, vinhas e olivais, e muitas árvores frutíferas. Eles comeram, fartaram-se e engordaram, desfrutando dos teus dons generosos."
,"26":"Depois disso, ficaram indóceis,e revoltaram-se contra Ti. Desprezaram a tua Lei,e mataram os profetas que os advertiam,a converterem-se a Ti. E cometeram graves ofensas."
,"27":"Então Tu os entregaste aos inimigos,que os oprimiram. Na angústia, porém, eles clamaram a Ti, e do céu Tu os escutaste. Com a tua grande compaixão,enviaste salvadores,que os libertaram dos inimigos."
,"28":"Mas logo que recuperavam a paz, faziam de novo aquilo que reprovas, e Tu os abandonavas aos inimigos,que os oprimiam. De novo, eles clamavam a Ti, e do céu Tu os escutavas. Tu os libertaste muitas vezes, por causa da tua grande compaixão."
,"29":"Chamaste a atenção deles, a fim de que voltassem para a tua Lei. Mas encheram-se de orgulho,e não obedeceram,aos teus mandamentos. Pecaram contra as tuas normas, que dão vida a quem as observa. Voltaram as costas com rebeldia, ficaram altivos e não obedeceram."
,"30":"Durante muitos anos, foste paciente com eles, e o teu espírito os advertiu,por meio dos profetas, mas eles não prestaram atenção. Por isso, os entregaste,aos povos pagãos."
,"31":"Tu, porém, com a tua grande compaixão, não os aniquilaste, nem os abandonaste, pois és um Deus,de piedade e compaixão."
,"32":"E agora, Deus nosso, Deus grande, poderoso e terrível, fiel à aliança e ao amor, não fiques indiferente às aflições,que se abateram sobre os nossos reis, sobre os nossos chefes, sacerdotes e profetas, sobre os nossos antepassados,e todo o teu povo, desde o tempo dos reis da Assíria, até ao dia de hoje."
,"33":"Estás inocente,de tudo o que nos aconteceu, porque agiste com fidelidade, enquanto nós praticávamos o mal."
,"34":"Sim! Os nossos reis, chefes, sacerdotes,e os nossos antepassados,não seguiram a tua Lei, nem deram atenção,aos teus mandamentos, nem às advertências,com que os avisavas."
,"35":"Mesmo durante o seu reinado, apesar dos bens que lhes concedias,e da terra vasta e fértil que lhes deste, não Te serviram, nem se converteram do seu mal."
,"36":"Por isso, agora estamos escravizados. Hoje nós somos escravos,na Terra que deste,aos nossos antepassados,para gozarem dos seus frutos e bens."
,"37":"Os seus produtos abundantes,vão para os reis, aos quais Tu nos sujeitaste,por causa dos nossos pecados. Eles dominam como querem, tanto a nós, como aos nossos rebanhos. Estamos em grande aflição!"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Por tudo isto, assumimos por escrito um compromisso sério. O documento foi assinado pelos nossos chefes, pelos nossos levitas e sacerdotes."
,"2":"O documento foi assinado por Neemias, filho de Hacalias, por Sedecias,"
,"3":"Saraías, Azarias, Jeremias,"
,"4":"Fasur, Amarias, Melquias,"
,"5":"Hatus, Sebanias, Meluc,"
,"6":"Harim, Meremot, Abdias,"
,"7":"Daniel, Genton, Baruc,"
,"8":"Mosolam, Abias, Miamin,"
,"9":"Maazias, Belgai e Semeías, que eram sacerdotes."
,"10":"Os levitas que assinaram foram: Josué, filho de Azanias, Benui, dos filhos de Henadad, Cadmiel"
,"11":"e seus irmãos, Sequenias, Odovias, Celita, Falaías, Hanã,"
,"12":"Micas, Roob, Hasebias,"
,"13":"Zacur, Serebias, Sebanias,"
,"14":"Odias, Bani e Canani."
,"15":"Os chefes do povo que assinaram foram: Faros, Faat-Moab, Elam, Zetu, Bani,"
,"16":"Buni, Azgad, Bebai,"
,"17":"Adonias, Beguai, Adin,"
,"18":"Ater, Ezequias, Azur,"
,"19":"Adias, Hasum, Besai,"
,"20":"Haref, Anatot, Nebai,"
,"21":"Megfias, Mosolam, Hazir,"
,"22":"Mesezebel, Sadoc, Jedua,"
,"23":"Feltias, Hanã, Anaías,"
,"24":"Oseias, Hananias, Hasub,"
,"25":"Aloés, Falea, Sobec,"
,"26":"Reum, Hasabna, Maasias,"
,"27":"Aías, Hanã, Anã,"
,"28":"Meluc, Harim, Baana."
,"29":"O resto do povo, os sacerdotes, os levitas, os porteiros, os cantores, os oblatos e todos os que se separaram da população local para se converter à Lei de Deus, juntamente com suas mulheres, filhos, filhas e todos os que tinham uso da razão,"
,"30":"uniram-se aos seus irmãos e chefes, e comprometeram-se solenemente a proceder segundo a Lei de Deus, dada por Moisés, servo de Deus, e a praticar todos os mandamentos, normas e estatutos de Javé, nosso Deus."
,"31":"Não dar as nossas filhas à população local e não casar os nossos filhos com as suas filhas."
,"32":"Não comprar em dia de sábado e dias de festa as mercadorias, principalmente o trigo que a população local vende no dia de sábado. A cada sete anos, renunciar à colheita e perdoar qualquer espécie de dívida."
,"33":"Nós comprometemo-nos também a entregar todos os anos a terça parte de um siclo para o culto do Templo do nosso Deus."
,"34":"Isto servirá para os pães oferecidos a Deus, para a oferta diária, para o holocausto diário, para as solenidades dos sábados, luas novas e festas, para as consagrações e sacrifícios pelo pecado de Israel, e para todo o serviço do Templo do nosso Deus."
,"35":"Nós, sacerdotes, levitas e povo, divididos por famílias, deitámos sortes para ver quem ofereceria a lenha que deveria ser levada ao Templo nas épocas certas, todos os anos, a fim de acender o fogo no altar de Javé, nosso Deus, conforme está escrito na Lei."
,"36":"Nós comprometemo-nos também a levar ao Templo de Javé, todos os anos, os primeiros frutos das nossas lavouras, os primeiros frutos de todas as árvores frutíferas,"
,"37":"e os primogénitos dos nossos filhos e rebanhos, conforme está escrito na Lei; e a entregar aos sacerdotes, que servem no Templo, os primogénitos dos nossos rebanhos graúdos e miúdos."
,"38":"A flor da nossa farinha de trigo, as nossas ofertas, toda a espécie de frutas, o nosso vinho e azeite, também os vamos levar aos sacerdotes para os armazéns do Templo do nosso Deus. Daremos o dízimo da nossa terra aos levitas. Os próprios levitas recolherão esse dízimo nos lugares que nós cultivamos."
,"39":"Um sacerdote, da descendência de Aarão, estará com os levitas, quando estes recolherem o dízimo. Os levitas levarão um décimo do dízimo para a sala do tesouro do Templo de Deus."
,"40":"É para essas mesmas salas do Templo de Deus que os israelitas e levitas levarão as oferendas de trigo, vinho e azeite. É também aí que devem ficar os objectos sagrados e os sacerdotes encarregados de os guardar, além dos porteiros e cantores. Nunca mais nos descuidaremos do Templo do nosso Deus!"
}`)
	CurrentBook.AddChapter(11, `{
"1":"Os chefes do povo ficaram a morar em Jerusalém. O resto do povo deitou sortes para que, em cada dez, um morasse na cidade santa de Jerusalém, e os outros nove nas outras cidades."
,"2":"O povo abençoou a todos os que se ofereceram para morar em Jerusalém."
,"3":"São estes os chefes de família da província que ficaram a morar em Jerusalém. Os sacerdotes, levitas, oblatos e descendentes dos escravos de Salomão ficaram a morar nas várias cidades de Judá, cada qual na sua propriedade."
,"4":"Em Jerusalém ficaram a morar os descendentes de Judá e Benjamim. Descendentes de Judá: Ataías, filho de Ozias, filho de Zacarias, filho de Amarias, filho de Safatias, filho de Malaleel, descendente de Farés."
,"5":"Maasias, filho de Baruc, filho de Col-Hoza, filho de Hazias, filho de Adaías, filho de Joiarib, filho de Zacarias, descendente de Sela."
,"6":"Total dos descendentes de Farés que ficaram a morar em Jerusalém: quatrocentos e sessenta e oito homens valentes."
,"7":"Descendentes de Benjamim: Salu, filho de Mosolam, filho de Joed, filho de Fadaías, filho de Calaías, filho de Maasias, filho de Eteel, filho de Isaías,"
,"8":"com os seus irmãos Gabai e Salai. Ao todo, novecentos e vinte e oito."
,"9":"Joel, filho de Zecri, era chefe deles. Como segunda autoridade na cidade, ficou Judá, filho de Senua."
,"10":"Sacerdotes: Jedaías, filho de Joaquim,"
,"11":"filho de Saraías, filho de Helcias, filho de Mosolam, filho de Sadoc, filho de Maraiot, filho de Aquitob, chefe do Templo de Deus,"
,"12":"e seus irmãos que exerciam as suas funções no Templo. Ao todo, oitocentos e vinte e dois. Além desses, havia ainda Adaías, filho de Jeroam, filho de Felelias, filho de Amsi, filho de Zacarias, filho de Fasur, filho de Melquias,"
,"13":"com seus irmãos, chefes de família. Ao todo, duzentos e quarenta e dois. Ficaram ainda: Amasai, filho de Azareel, filho de Aazi, filho de Mosolam, filho de Emer,"
,"14":"e seus irmãos, perfazendo um total de cento e vinte e oito homens valentes. O chefe deles era Zabdiel, filho de Agadol."
,"15":"Levitas: Semeías, filho de Asub, filho de Ezricam, filho de Hasabias, filho de Buni;"
,"16":"Sabatai e Jozabad, entre os chefes levitas, eram os encarregados dos serviços externos do Templo de Deus;"
,"17":"Matanias, filho de Micas, filho de Zabdi, filho de Asaf, dirigia os hinos e cantava a acção de graças na oração; Becbecias, que era o segundo da família, e Abdias, filho de Samua, filho de Galal, filho de Iditun."
,"18":"Havia duzentos e oitenta e quatro levitas na cidade santa."
,"19":"Porteiros: Acub, Telmon e seus irmãos. Ao todo, cento e setenta e dois, que guardavam as portas."
,"20":"Os outros israelitas, sacerdotes e levitas, ficaram espalhados pelas cidades de Judá, cada qual na sua propriedade."
,"21":"Os oblatos ficaram a morar no Ofel. À frente deles estavam Sia e Gasfa."
,"22":"O chefe dos levitas em Jerusalém era Ozi, filho de Bani, filho de Hasabias, filho de Matanias, filho de Micas. Ele fazia parte dos filhos de Asaf, cantores encarregados do serviço no Templo de Deus."
,"23":"Uma ordem do rei e um regulamento fixavam a tarefa diária dos cantores."
,"24":"Fetaías, filho de Mesezebel, descendente de Zara, filho de Judá, estava ao serviço do rei, para todos os assuntos relativos ao povo."
,"25":"Também nas aldeias e campos moravam judeus. Os descendentes de Judá ficaram a morar em Cariat-Arbe e suas aldeias, em Dibon e suas aldeias, em Cabseel e suas aldeias,"
,"26":"em Jesua, Molada, Bet-Falet,"
,"27":"Haser-Sual, Bersabeia e suas aldeias,"
,"28":"em Siceleg, Mecona e suas aldeias,"
,"29":"em En-Remon, Saraá, Jarmut,"
,"30":"Zanoe, Odolam e suas aldeias, em Laquis e seus campos, em Azeca e suas aldeias. Eles ocuparam toda a região, desde Bersabeia até ao vale de Enom."
,"31":"Os descendentes de Benjamim ficaram a morar em Gaba, Macmas, Aía, Betel e suas aldeias,"
,"32":"em Anatot, Nob, Ananias,"
,"33":"Hasor, Ramá, Getaim,"
,"34":"Hadid, Seboim, Nebalat,"
,"35":"Lod e Ono, e vale dos Artesãos."
,"36":"Um grupo de levitas ficou a morar na região de Judá e Benjamim."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Lista dos sacerdotes e levitas que chegaram com Zorobabel, filho de Salatiel, e com Josué: Saraías, Jeremias, Esdras,"
,"2":"Amarias, Meluc, Hatus,"
,"3":"Sequenias, Reum, Meremot,"
,"4":"Ado, Genton, Abias,"
,"5":"Miamin, Madias, Belga,"
,"6":"Semeías, Joiarib, Jedaías,"
,"7":"Salu, Amoc, Helcias, Jedaías. Eram estes os chefes dos sacerdotes e seus irmãos, no tempo de Josué."
,"8":"Os levitas eram: Josué, Benui, Cadmiel, Serebias, Judá e Matanias que, com os seus irmãos, dirigia os hinos de acção de graças,"
,"9":"enquanto os outros seus irmãos Becbecias e Ani ficavam em frente deles para entoar os cânticos."
,"10":"Josué foi o pai de Joaquim; Joaquim, o pai de Eliasib; Eliasib, o pai de Joiada;"
,"11":"Joiada, o pai de Joanã; e Joanã, o pai de Jedua."
,"12":"No tempo de Joaquim, os chefes das famílias sacerdotais eram: Maraías, chefe da família de Saraías; Hananias, da família de Jeremias;"
,"13":"Mosolam, da família de Esdras; Joanã, da família de Amarias;"
,"14":"Jónatas, da família de Meluc; José, da família de Sebanias;"
,"15":"Ednas, da família de Harim; Helci, da família de Maralot,"
,"16":"Zacarias, da família de Ado; Mosolam, da família de Genton;"
,"17":"Zecri, da família de Abias; Felti, da família de Miniamin e da Moadias;"
,"18":"Samua, da família de Belga; Jónatas, da família de Semeías;"
,"19":"Matanai, da família de Joiarib; Ozi, da família de Jedaías;"
,"20":"Celai, da família de Selai; Héber, da família de Amoc;"
,"21":"Hasabias, da família de Helcias; e Natanael, da família de Zedaías."
,"22":"No tempo de Eliasib, Joiada, Joanã e Jedua, foi feita uma lista dos chefes das famílias sacerdotais até ao começo do reinado de Dario, o persa."
,"23":"Levitas: Os chefes das famílias estão registados no Livro das Crónicas, mas só até ao tempo de Joanã, neto de Eliasib."
,"24":"Eram eles: Hasabias, Serebias, Josué, Benui, Cadmiel e seus irmãos, que ficavam em frente deles para entoar os hinos de louvor e acção de graças, conforme as determinações de David, homem de Deus, um grupo alternando com o outro."
,"25":"Estes eram Matanias, Becbecias e Abdias. Mosolam, Telmon e Acub eram porteiros, que ficavam a guardar os armazéns perto das portas da cidade."
,"26":"Estes homens são do tempo de Joaquim, filho de Josué, filho de Josedec, do tempo do governador Neemias e do sacerdote Esdras, doutor da Lei."
,"27":"Por ocasião da dedicação das muralhas de Jerusalém, os levitas foram convocados de todos os lugares onde moravam, para irem a Jerusalém, a fim de celebrar a dedicação com festa e acção de graças, ao som de címbalos, cítaras e harpas."
,"28":"Reuniram-se, então, levitas encarregados dos cânticos, vindos do distrito de Jerusalém e redondezas, das cidades dos netofatitas,"
,"29":"de Bet-Guilgal, da zona rural de Gaba e de Azmot, pois os cantores tinham construído aldeias nos arredores de Jerusalém."
,"30":"Os sacerdotes e levitas purificaram-se, e depois purificaram o povo, as portas e a muralha."
,"31":"Então mandei que os chefes de Judá subissem à muralha. E organizei duas grandes alas. Uma deveria caminhar pela direita, em direcção à porta do Esterco."
,"32":"Atrás dela, iam Osaías e metade dos chefes de Judá."
,"33":"Iam também Azarias, Esdras, Mosolam,"
,"34":"Judá, Benjamim, Semeías e Jeremias,"
,"35":"pertencentes ao coro dos sacerdotes com as trombetas. Depois, vinham Zacarias, filho de Jónatas, filho de Semeías, filho de Matanias, filho de Micas, filho de Zacur, filho de Asaf,"
,"36":"com seus irmãos Semeías, Azareel, Malalai, Galalai, Maai, Natanael, Judá e Hanani, levando os instrumentos musicais de David, homem de Deus. Esdras, doutor da Lei, ia à frente deles."
,"37":"Passaram pela porta da Fonte e, seguindo em linha recta, subiram as escadas da Cidade de David, e desceram pela encosta da muralha, junto ao palácio de David, até à porta das Águas, a Leste."
,"38":"A outra ala ia pela esquerda. Eu seguia-a com a outra metade dos chefes do povo. Fomos por cima da muralha, passámos pela torre dos Fornos e chegámos à muralha larga."
,"39":"Passámos depois por cima da porta de Efraim, da porta Velha, da porta dos Peixes, da torre de Hananeel, da torre dos Cem, da porta das Ovelhas, e parámos na porta da Guarda."
,"40":"Depois, as duas alas entraram no Templo de Deus. Comigo estavam metade dos chefes,"
,"41":"e também os sacerdotes Eliaquim, Maasias, Miniamin, Micas, Elioenai, Zacarias e Hananias, que levavam trombetas,"
,"42":"e também Maasias, Semeías, Eleazar, Ozi, Joanã, Melquias, Elam e Ezer. Os cantores entoaram um hino sob a direcção de Jezraías."
,"43":"Nesse dia, oferecemos sacrifícios solenes. E o povo fez festa, pois Deus havia-lhe dado grande motivo de alegria. Até as mulheres e crianças participaram na festa. Ouvia-se ao longe o barulho da festa em Jerusalém."
,"44":"Nesse tempo foram nomeados alguns homens para guardar as salas reservadas para as provisões, donativos, primeiros frutos e dízimo. Nelas esses homens deviam recolher, da zona rural das cidades, as partes devidas por lei aos sacerdotes e levitas. Os judeus estavam contentes com a função dos sacerdotes e levitas,"
,"45":"pois eles ocupavam-se do culto do seu Deus e do ritual de purificação, conforme as instruções de David e de seu filho Salomão. Também estavam contentes com os cantores e porteiros."
,"46":"Desde os tempos de David e Asaf, havia chefes de cantores e dos cânticos de louvor e acção de graças a Deus."
,"47":"É por isso que, nos tempos de Zorobabel e Neemias, os israelitas proviam diariamente às necessidades dos cantores e porteiros. Também faziam ofertas aos levitas que, por sua vez, entregavam aos descendentes de Aarão a parte que a estes cabia."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Nesse tempo, lendo ao povo o livro de Moisés, encontrámos escrito o seguinte: «O amonita e o moabita nunca poderão entrar na assembleia de Deus,"
,"2":"porque não foram com pão e água ao encontro dos filhos de Israel. Contrataram Balaão para os amaldiçoar, mas o nosso Deus transformou a maldição em bênção»."
,"3":"Quando ouviram a Lei, separaram de Israel todo o elemento estrangeiro que com ele estava misturado."
,"4":"Antes disso, porém, o sacerdote Eliasib tinha sido encarregado das salas do Templo do nosso Deus. Sendo parente de Tobias,"
,"5":"arranjou-lhe uma sala bem grande, onde antes se colocavam as ofertas, o incenso e os objectos do culto, o dízimo do trigo, do vinho e do azeite, isto é, as partes que cabiam aos levitas, aos cantores e aos porteiros, e o que era reservado para os sacerdotes."
,"6":"Enquanto isto acontecia, eu estava fora de Jerusalém, pois no trigésimo segundo ano de Artaxerxes, rei da Babilónia, eu tinha voltado para junto do rei. Depois de algum tempo, pedi licença ao rei,"
,"7":"e voltei para Jerusalém. Então vim a saber do mal que Eliasib tinha cometido em favor de Tobias, cedendo-lhe uma sala nas dependências do Templo de Deus."
,"8":"Fiquei indignado, e deitei para a rua toda a mobília de Tobias."
,"9":"Mandei purificar a sala e, depois, recolocar nela os objectos do Templo de Deus, as ofertas e o incenso."
,"10":"Também vim a saber que já não estavam a dar aos levitas as contribuições devidas, e que os levitas e cantores, encarregados do culto, tinham fugido cada qual para a sua propriedade."
,"11":"Enfrentei os ministros e disse-lhes: «Porque é que o Templo de Deus está abandonado?» Reuni de novo os levitas e reintegrei-os nas suas funções."
,"12":"Então, todos os judeus começaram a trazer de novo para os armazéns o dízimo do trigo, do vinho e do azeite."
,"13":"Coloquei, como encarregados dos armazéns, o sacerdote Selemias, o escrivão Sadoc e o levita Fadaías, ajudados por Hanã, filho de Zacur, filho de Matanias, pois eles tinham fama de serem íntegros. A sua função era distribuir as porções aos seus irmãos."
,"14":"Por tudo isto, lembra-Te de mim, ó meu Deus! Não deixes apagar da tua lembrança as boas acções que realizei pelo Templo de Deus e pelo seu culto."
,"15":"Nessa ocasião, vi em Judá gente a pisar uvas no lagar, em dia de sábado; gente que transportava trigo e o colocava sobre jumentos, e também vinho, uvas, figos e toda a espécie de carga, e levavam-nos para Jerusalém em dia de sábado! Chamei a atenção deles, para que não vendessem os seus produtos."
,"16":"Havia em Jerusalém até gente de Tiro, que trazia peixe e outras mercadorias, que eram vendidas aos judeus em dia de sábado."
,"17":"Repreendi as pessoas importantes de Judá, dizendo-lhes: «Estais a fazer uma coisa abominável, profanando o dia de sábado."
,"18":"Não foi isso que os vossos antepassados fizeram? Então Deus mandou todas aquelas desgraças sobre nós e sobre esta cidade. Com esta profanação do sábado, estais a aumentar a ira de Deus contra Israel»."
,"19":"Mandei que fechassem as portas de Jerusalém ao cair da tarde, antes do sábado, com ordem de as não abrirem enquanto o sábado não tivesse passado. Coloquei alguns dos meus homens perto das portas da cidade, para não deixarem entrar nenhum carregamento na cidade durante o sábado."
,"20":"Por uma ou duas vezes, alguns vendedores ambulantes e mercadores tiveram de passar a noite do lado de fora de Jerusalém."
,"21":"Então, eu avisei-os: «Porque é que estais a dormir ao pé da muralha? Se voltardes a fazer isso, vou prender-vos». Daí em diante, nunca mais voltaram aos sábados."
,"22":"Ordenei também que os levitas se purificassem e vigiassem as portas da cidade, para santificar o dia de sábado. Por tudo isso, lembra-Te de mim, ó meu Deus, e tem piedade de mim, pela tua grande misericórdia!"
,"23":"Nessa mesma ocasião, notei que os judeus se casavam com mulheres azotitas, amonitas e moabitas."
,"24":"Metade dos seus filhos falava a língua de Azoto e outras línguas estrangeiras, e já não sabiam falar a língua dos judeus."
,"25":"Eu reprovei-os e amaldiçoei-os, bati em alguns, arranquei cabelos a outros e fi-los jurar em nome de Deus que não dariam as suas filhas em casamento aos filhos deles, nem tomariam as filhas deles para os seus filhos ou para si próprios."
,"26":"Eu disse: «Não foi esse o pecado de Salomão, rei de Israel? Entre numerosas nações, não havia um rei como ele. E Deus amava-o tanto que o tornou rei de todo o Israel. Pois até a ele, as mulheres estrangeiras o fizeram pecar!"
,"27":"E agora, casando-vos com mulheres estrangeiras, cometeis esse grande crime de trair o nosso Deus!»"
,"28":"Um dos filhos de Joiada, filho de Eliasib, o sumo sacerdote, tornara-se genro do horonita Sanabalat. Expulsei-o para longe."
,"29":"Lembra-Te, ó meu Deus, da profanação que essa gente cometeu contra o sacerdócio e contra a aliança dos sacerdotes e levitas."
,"30":"Então purifiquei o povo de todos os costumes estrangeiros, e restabeleci as funções dos sacerdotes e levitas, determinando a tarefa de cada um."
,"31":"Também dei as normas sobre o fornecimento de lenha no devido tempo e sobre os primeiros frutos. Lembra-Te de mim, ó meu Deus, para meu bem!"
}`)

}
func PT_BS_LoadVHRTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No tempo em que os juízes governavam, houve um período de fome no país. Por isso, um homem de Belém de Judá emigrou para os Campos de Moab, com a mulher e os dois filhos."
,"2":"O homem chamava-se Elimelec, a mulher Noemi, e os dois filhos Maalon e Quelion. Eram do vale de Éfrata, de Belém de Judá. Chegaram aos Campos de Moab e ali fixaram morada."
,"3":"Elimelec, marido de Noemi, morreu. E ela ficou só com os dois filhos."
,"4":"Estes casaram-se com jovens moabitas; um casou-se com Orfa e o outro com Rute. E ali ficaram uns dez anos."
,"5":"Maalon e Quelion morreram. Noemi ficou sozinha, sem os dois filhos e sem o marido."
,"6":"Noemi resolveu voltar dos Campos de Moab, juntamente com as duas noras, pois soube que Javé tinha abençoado o seu povo, dando-lhe pão."
,"7":"Ela com as noras saiu do lugar onde tinha morado e pôs-se a caminho para voltar à terra de Judá."
,"8":"No caminho, Noemi perguntou às noras: «Porque não voltais para a casa da vossa mãe? Que Javé vos trate com a mesma bondade que tivestes para com os meus filhos e para comigo."
,"9":"Que Javé faça com que cada uma de vós encontre marido e viva feliz». Noemi beijou as noras e elas começaram a chorar alto, dizendo:"
,"10":"«De modo nenhum! Nós vamos contigo para o teu povo»."
,"11":"Noemi insistiu: «Voltai, minhas filhas. Porque é que quereis ir comigo? Ides esperar que eu tenha mais filhos para vos casardes com eles?"
,"12":"Voltai, minhas filhas, porque eu estou velha de mais para me casar outra vez. Mesmo que eu tivesse esperança, me casasse esta noite, e tivesse filhos,"
,"13":"será que deixaríeis de vos casar, para esperar que os meninos crescessem? Não, minhas filhas! A minha sorte é mais amarga que a vossa sorte, porque a mão de Javé está contra mim»."
,"14":"Elas começaram de novo a chorar. Depois, Orfa despediu-se da sogra e voltou para o seu povo. Rute, porém, ficou com Noemi."
,"15":"Então Noemi disse-lhe: «Olha: a tua cunhada voltou para o seu povo e o seu deus. Volta também com ela»."
,"16":"Rute respondeu: «Não insistas comigo. Não vou voltar, nem te vou deixar. Para onde fores, eu irei também. Onde tu viveres, eu também viverei. O teu povo será o meu povo, e o teu Deus será o meu Deus."
,"17":"Onde morreres, eu também morrerei e serei sepultada. Somente a morte nos poderá separar. Se eu fizer o contrário, que Javé me castigue!»"
,"18":"Noemi viu que Rute estava decidida a ir com ela, e não insistiu mais."
,"19":"Puseram-se a caminho e chegaram a Belém. Logo que entraram na cidade, toda a gente se alvoroçou, e as mulheres comentavam: «Não é a Noemi?»"
,"20":"Mas Noemi corrigia: «Não me chameis Noemi. Chamai-me Mara, porque o Todo-poderoso me encheu de amargura."
,"21":"Parti com as mãos cheias, e Javé faz-me regressar de mãos vazias! Não me chameis Noemi, porque Javé está contra mim e o Todo-poderoso me tornou infeliz»."
,"22":"Foi assim que Noemi voltou dos Campos de Moab, juntamente com sua nora Rute, a moabita. Chegaram a Belém quando se iniciava a colheita da cevada."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Noemi tinha um parente, por parte do marido. Era uma pessoa importante do clã de Elimelec, que se chamava Booz."
,"2":"Rute, a moabita, disse a Noemi: «Deixa-me ir ao campo onde estão a ceifar a cevada. Se alguém me deixar, irei atrás dele apanhando umas espigas». Noemi concordou: «Podes ir, minha filha»."
,"3":"E Rute foi ao campo apanhar espigas caídas, atrás dos ceifeiros. E por acaso foi parar a um dos campos de Booz, do clã de Elimelec."
,"4":"Nesse momento, Booz acabava de chegar de Belém e cumprimentava os ceifeiros: «Javé esteja convosco». Eles responderam: «Javé te abençoe»."
,"5":"Então Booz perguntou ao capataz: «Quem é aquela jovem?»"
,"6":"O capataz respondeu: «É uma moabita, que voltou com Noemi, dos Campos de Moab,"
,"7":"e me pediu para apanhar as espigas caídas. Ela chegou de manhã e está de pé até agora, sem parar um só momento»."
,"8":"Então Booz disse a Rute: «Escuta, minha filha. Não vás apanhar espigas em outro campo. Não te afastes daqui. Fica com as minhas empregadas."
,"9":"Observa o terreno que os homens estão a ceifar e vai atrás deles. Ordenei aos meus empregados que não te incomodem. Quando estiveres com sede, podes ir às bilhas e beber a água que os empregados tiverem trazido»."
,"10":"Então Rute prostrou-se com o rosto no chão e perguntou a Booz: «Porque é que estás a ser tão bom para comigo? Porque me estás a dar tanta atenção? Eu sou uma estrangeira!»"
,"11":"Booz respondeu: «Tive conhecimento de tudo o que fizeste pela tua sogra, depois de teres perdido o marido. Deixaste pai e mãe, abandonaste a tua terra natal e vieste viver no meio de um povo que não conhecias."
,"12":"Javé te pague pelo que fizeste. Que recebas uma grande recompensa de Javé, Deus de Israel, pois foi debaixo das suas asas que vieste buscar abrigo»."
,"13":"Rute disse: «Que eu mereça o favor que estás a fazer por mim. Tranquilizaste-me e falaste-me ao coração, embora eu nem sequer seja tua empregada»."
,"14":"Na hora de comer, Booz chamou Rute: «Vem cá. Come do nosso pão e molha o pão no molho». Rute sentou-se ao lado dos ceifeiros, e Booz ofereceu-lhe espigas assadas. Ainda sobrou depois de Rute ter comido e ter ficado satisfeita."
,"15":"Quando Rute se levantou para continuar a apanhar espigas, Booz ordenou aos empregados: «Deixai que aquela jovem apanhe espigas mesmo entre os feixes, e não a incomodeis."
,"16":"Deixai também cair algumas espigas dos feixes e não vos irriteis quando ela as recolher»."
,"17":"E Rute apanhou espigas no campo até à tarde. Depois malhou as espigas que tinha recolhido. Deu quase quarenta e cinco quilos."
,"18":"Rute pôs a cevada à cabeça e voltou para a cidade. E a sua sogra viu o que ela havia recolhido. Rute também deu à sogra algumas espigas assadas que tinham sobrado do almoço."
,"19":"A sogra perguntou: «Onde apanhaste essas espigas? Onde trabalhaste hoje? Bendito seja quem se interessou por ti». Rute contou à sogra com quem havia trabalhado, e disse: «O dono do campo onde trabalhei chama-se Booz»."
,"20":"Noemi disse à nora: «Que ele seja abençoado por Javé, que não deixa de ter misericórdia dos vivos e dos mortos». E continuou: «Esse homem é nosso parente próximo, é um dos que têm o direito de resgate sobre nós»."
,"21":"Rute, a moabita, disse: «Ele também me disse para ficar com os empregados até que terminem toda a colheita»."
,"22":"Noemi disse à sua nora Rute: «Minha filha, é bom que estejas com as empregadas dele. Noutro campo poderias ser maltratada»."
,"23":"Então Rute continuou com as empregadas de Booz, recolhendo espigas até ao fim da colheita da cevada e do trigo. Depois ficou a morar com a sogra."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Noemi disse a Rute: «Minha filha, tenho que procurar para ti uma situação melhor, para que te sintas feliz."
,"2":"Acontece que Booz é nosso parente e estiveste a trabalhar com as suas empregadas. Esta noite ele vai malhar a cevada na eira."
,"3":"Faz o seguinte: toma banho, perfuma-te, veste o teu manto e vai à eira. Não deixes que ele te veja, antes de ter acabado de comer e beber."
,"4":"Quando ele for dormir, olha bem onde ele se deita. Depois vai, tira a coberta dos pés dele e deita-te. Ele dirá o que deves fazer»."
,"5":"Rute respondeu: «Vou fazer tudo o que me disseste»."
,"6":"Rute foi para a eira e fez tudo o que a sogra havia mandado."
,"7":"Booz comeu, bebeu, ficou alegre e depois foi deitar-se ao lado de um monte de cevada. Então Rute chegou de mansinho, tirou a coberta dos pés dele e deitou-se."
,"8":"No meio da noite, Booz acordou de repente, sentou-se, e viu a mulher deitada a seus pés."
,"9":"Booz perguntou: «Quem és tu?» Ela respondeu: «Sou Rute, tua serva. Estende o teu manto sobre mim, porque tens o direito de resgate»."
,"10":"Booz disse: «Deus te abençoe, minha filha. Este teu novo acto de amor é maior do que o primeiro, porque não procuraste jovens, nem pobres nem ricos."
,"11":"Não tenhas medo, minha filha. Vou fazer tudo o que dizes. Na cidade todos sabem que és uma mulher de valor."
,"12":"Sei que tenho o direito de resgate, mas há outro parente mais próximo do que eu."
,"13":"Passa a noite aqui. Amanhã cedo vamos procurar o outro. Se ele te quiser resgatar, deixa que te resgate. Se ele não te quiser resgatar, então eu usarei o meu direito de resgate. Juro por Javé. Fica aqui deitada até ao amanhecer»."
,"14":"Rute ficou a dormir aos pés de Booz até ao amanhecer, e levantou-se quando ainda não dava para uma pessoa reconhecer a outra, pois Booz não queria que ninguém soubesse que ela tinha ido à eira."
,"15":"Booz então disse-lhe: «Abre o manto e segura-o». Rute segurou o manto e Booz encheu-o com uns vinte quilos de cevada. Depois ajudou-a a pôr a cevada aos ombros, e Rute voltou para a cidade."
,"16":"Quando chegou a casa, a sogra perguntou-lhe: «Como é que foi, minha filha?» Rute contou tudo o que Booz tinha feito por ela,"
,"17":"e acrescentou: «Ele deu-me estes vinte quilos de cevada, pois achou que eu não devia voltar para junto de ti de mãos vazias»."
,"18":"Noemi disse-lhe: «Fica tranquila, minha filha. Vais ver como tudo isto vai terminar bem: estou certa de que esse homem não vai descansar. Garanto-te que hoje mesmo ele vai resolver a questão»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Booz foi à porta da cidade e ali se sentou. Quando passou o parente do qual tinha falado, Booz chamou-o: «Olá, vem sentar-te aqui». O homem aproximou-se e sentou-se."
,"2":"Booz convidou dez anciãos da cidade, e disse-lhes: «Sentai-vos aqui». Todos se sentaram."
,"3":"Então Booz disse ao homem que tinha o direito de resgate: «Escuta! Noemi, que voltou dos Campos de Moab, quer vender o terreno que pertencia ao nosso irmão Elimelec."
,"4":"Venho informar-te para saber se estás interessado na compra. O povo que aqui está e os anciãos vão ser testemunhas. Se quiseres resgatar o terreno, podes resgatá-lo. Se o não quiseres resgatar, diz-mo, pois além de nós não há mais ninguém com direito a resgatar o terreno. O direito cabe primeiro a ti e depois a mim». O homem respondeu: «Muito bem. Aceito resgatá-lo»."
,"5":"Então Booz acrescentou: «Há mais uma coisa: comprando o terreno de Noemi, estarás a adquirir também Rute, a moabita, mulher do falecido. Deste modo, a herança do falecido continuará com o seu nome»."
,"6":"Então o homem que tinha o direito ao resgate disse: «Não posso fazer isso, porque acabaria por prejudicar os meus herdeiros. Entrego-te o meu direito. Podes resgatar o terreno, porque eu não posso fazê-lo»."
,"7":"Antigamente, quando se faziam resgates ou trocas em Israel, havia este costume: para dizer que o negócio estava garantido, a pessoa tirava a sandália e entregava-a ao parceiro. Era assim que se fechava um negócio em Israel."
,"8":"Foi o que fez aquele que tinha o direito de resgate. Ele disse a Booz: «Resgata tu o terreno». E entregou-lhe a sandália."
,"9":"Então Booz disse aos anciãos e ao povo: «Vós sois hoje testemunhas de que comprei a Noemi tudo o que pertencia a Elimelec, a Quelion e a Maalon."
,"10":"Ao mesmo tempo, adquiri como esposa a moabita Rute, viúva de Maalon, a fim de conservar o nome do falecido na sua herança, e para que o nome do falecido não desapareça do meio dos seus irmãos nem da porta da sua cidade. Vós sois testemunhas?»"
,"11":"Todos os que ali estavam presentes, à porta da cidade, juntamente com os anciãos, responderam: «Nós somos testemunhas. Que Javé torne essa mulher, ao entrar em tua casa, como Raquel e Lia, que formaram a casa de Israel. Quanto a ti, Booz, que sejas poderoso em Éfrata e tenhas fama em Belém."
,"12":"E pelos filhos que Javé te vai dar, por meio dessa jovem, que a tua casa seja como a casa de Farés, que Tamar deu à luz a Judá»."
,"13":"Booz casou-se com Rute. E ela tornou-se sua esposa. Booz teve relações com ela, e Javé deu a Rute a graça de engravidar, e ela deu à luz um filho."
,"14":"As mulheres diziam a Noemi: «Javé seja bendito! Ele não deixou que hoje te faltasse um resgatador. O seu nome tornar-se-á famoso em Israel."
,"15":"Ele será para ti um consolador e um apoio na velhice, pois quem o gerou é tua nora. Ela ama-te, e é melhor para ti do que sete filhos»."
,"16":"Noemi pegou no menino, pô-lo ao colo e foi para ele uma verdadeira mãe de criação."
,"17":"As vizinhas deram um nome ao menino, dizendo: «Nasceu um filho a Noemi». E deram-lhe o nome de Obed. Obed foi o pai de Jessé. E Jessé foi o pai de David."
,"18":"Esta é a descendência de Farés: Farés foi o pai de Hesron."
,"19":"Hesron foi o pai de Ram. Ram foi o pai de Aminadab."
,"20":"Aminadab foi o pai de Naasson. Naasson foi o pai de Salmon."
,"21":"Salmon foi o pai de Booz. Booz foi o pai de Obed."
,"22":"Obed foi o pai de Jessé. E Jessé foi o pai de David."
}`)

}
func PT_BS_LoadVHTBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"História de Tobit, filho de Tobiel, filho de Ananiel, filho de Aduel, filho de Gabael, descendente de Asiel, da tribo de Neftali."
,"2":"No tempo de Salmanasar, rei da Assíria, Tobit foi exilado de Tisbé, que fica a Sul de Cedes, em Neftali, na Galileia do Norte, acima de Hasor, a Ocidente, a Norte de Sefat."
,"3":"Eu, Tobit, durante toda a minha vida, andei pelos caminhos da verdade e da justiça. Sempre dei ajuda aos meus irmãos e compatriotas, exilados comigo em Nínive, no país da Assíria."
,"4":"Quando eu era jovem e estava na minha terra, no país de Israel, toda a tribo do meu antepassado Neftali se separou da dinastia de David e de Jerusalém, cidade escolhida por Deus, entre todas as tribos de Israel, para os sacrifícios. Aí foi construído e consagrado o Templo para ser a morada perpétua de Deus."
,"5":"Todos os meus irmãos e a tribo de Neftali ofereciam sacrifícios ao bezerro que Jeroboão, rei de Israel, tinha colocado em Dã, na região montanhosa da Galileia."
,"6":"Muitas vezes, eu era o único a ir em peregrinação a Jerusalém, por ocasião das festas, a fim de cumprir a Lei perpétua que obriga todo o Israel. Eu corria para Jerusalém com os primeiros produtos da lavoura e as primeiras crias dos animais, com o dízimo do gado e a primeira lã das ovelhas,"
,"7":"e entregava-os aos sacerdotes, filhos de Aarão, para o altar. Aos levitas que exerciam funções em Jerusalém, eu entregava o dízimo do trigo, do vinho, do azeite, das romãs, dos figos e das frutas. Durante seis anos consecutivos, eu converti o segundo dízimo em dinheiro e gastava-o em cada ano em Jerusalém."
,"8":"O terceiro dízimo, dava-o aos órfãos, às viúvas e aos estrangeiros convertidos que viviam com os israelitas, e dava-lho de três em três anos. Então comíamos juntos, conforme a lei de Moisés e a orientação que nos deixou Débora, mãe do nosso pai Ananiel, pois o meu pai tinha morrido, deixando-me órfão."
,"9":"Homem feito, casei-me com uma mulher nossa parente, de nome Ana. Ela deu-me um filho, a quem pus o nome de Tobias."
,"10":"Exilado na Assíria, levado como prisioneiro, cheguei a Nínive. Meus irmãos e compatriotas comiam alimentos dos pagãos,"
,"11":"mas eu tomei cuidado para não fazer o mesmo."
,"12":"Porque permaneci fiel a Deus com todo o meu coração,"
,"13":"o Altíssimo fez-me ganhar o favor de Salmanasar, e cheguei a ser seu procurador."
,"14":"Até à sua morte, eu costumava ir à Média e lá fazia as compras na casa de Gabael, irmão de Gabri, em Rages, na Média, onde deixei em depósito alguns sacos com trezentos quilos de prata."
,"15":"Depois Salmanasar morreu, e seu filho Senaquerib sucedeu-lhe no trono. Os caminhos para a Média foram fechados, e eu já não pude viajar para lá."
,"16":"No tempo de Salmanasar, dei muitas esmolas aos meus compatriotas."
,"17":"Eu dava o meu próprio alimento aos que estavam com fome, roupa aos que estavam mal vestidos, e quando via o cadáver de algum compatriota lançado fora das muralhas de Nínive, eu enterrava-o."
,"18":"Também sepultei os que Senaquerib matou, quando voltou fugindo da Judeia, por ocasião do castigo que o Rei do céu lhe aplicou por causa das blasfémias que ele proferiu. Nessa ocasião, enfurecido, ele matou muitos israelitas. Eu recolhia os corpos às escondidas e enterrava-os. Senaquerib mandava procurá-los, mas não os encontrava."
,"19":"Alguém de Nínive foi denunciar ao rei que era eu quem os enterrava às escondidas. Quando fiquei a saber que o rei estava informado a meu respeito e que me procuravam para me matar, fiquei com medo e fugi."
,"20":"Tudo o que eu possuía foi confiscado, e nada restou que não fosse levado para o tesouro do rei. Só ficaram a minha mulher Ana e o meu filho Tobias."
,"21":"Não se passaram quarenta dias, e os dois filhos de Senaquerib assassinaram-no e fugiram para os montes de Ararat. Seu filho Asaradon sucedeu-lhe no trono. Asaradon nomeou Aicar, filho do meu irmão Anael, para dirigir toda a economia do país, de modo que ele tinha poder sobre toda a administração."
,"22":"Então Aicar interveio em meu favor, e eu pude voltar para Nínive. A verdade é que Aicar tinha sido chefe dos copeiros, chanceler, administrador e encarregado das finanças durante o governo de Senaquerib, rei da Assíria. Por isso, Asaradon manteve-o no cargo. Aicar era da minha família, era meu sobrinho."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Durante o reinado de Asaradon, eu pude voltar para a minha casa e ter de novo a minha mulher Ana e o meu filho Tobias. Na nossa festa de Pentecostes, isto é, na festa das Semanas, prepararam-me um belo almoço e eu sentei-me à mesa para comer."
,"2":"Enquanto serviam a mesa e preparavam vários pratos, eu disse ao meu filho Tobias: «Filho, vai ver se encontras algum pobre entre os nossos compatriotas exilados em Nínive, alguém que permanece fiel a Deus de todo o coração, e trá-lo aqui para almoçar connosco. Vou esperar que voltes, meu filho!»"
,"3":"Então Tobias foi procurar um pobre entre os nossos compatriotas. Ao voltar, disse: «Meu pai!» Eu perguntei: «Que foi, meu filho?» Ele continuou: «Pai, assassinaram um compatriota nosso. Foi estrangulado e lançado na praça do mercado. Ainda lá está»."
,"4":"Imediatamente deixei a mesa, sem provar o almoço. Fui buscar o corpo e coloquei-o num quarto, esperando o pôr do sol para o enterrar."
,"5":"Voltando, lavei-me e fui almoçar cheio de tristeza,"
,"6":"lembrando-me das palavras que o profeta Amós disse contra Betel: «As vossas festas vão transformar-se em luto, e os vossos cânticos alegres em lamentações»."
,"7":"E comecei a chorar. Logo que o sol se pôs, saí de casa, fiz uma cova e enterrei o corpo."
,"8":"Os meus vizinhos zombavam de mim, dizendo: «Ele já não tem medo! Por este motivo, já foi procurado para ser morto. Da primeira vez, conseguiu fugir. Agora, anda aí de novo a enterrar os mortos!»"
,"9":"Nessa mesma noite, depois de tomar banho, fui para o pátio da minha casa e deitei-me junto ao muro do pátio, com o rosto descoberto por causa do calor."
,"10":"Não tinha notado, porém, que havia uns pardais no muro, mesmo por cima de mim. Caiu excremento quente nos meus olhos, produzindo neles manchas brancas. Fui aos médicos para me tratar. Porém, quanto mais pomadas aplicavam, mais as manchas aumentavam, até que fiquei completamente cego. Fiquei cego durante quatro anos. Todos os meus irmãos lamentaram muito a minha sorte. Aicar sustentou-me durante dois anos, até que se mudou para Elimaida."
,"11":"Nessa situação, a minha mulher Ana começou a trabalhar para ganhar dinheiro. Fiava lã e recebia tela para tecer."
,"12":"Entregava as encomendas, e os fregueses pagavam-lhe o trabalho. No dia sete do mês Distros, ela terminou uma dessas encomendas e entregou-a aos fregueses. Eles pagaram-lhe tudo e ainda lhe deram um cabrito para o almoço."
,"13":"Quando ela chegou a casa e o cabrito começou a berrar, eu chamei-a e perguntei-lhe: «De onde veio esse cabrito?! Não terá sido roubado? Devolve-o ao dono! Não podemos comer nada que seja roubado!»"
,"14":"Ana respondeu-me: «Eles deram-me o cabrito, além do pagamento». Eu não acreditei, e insisti para que devolvesse o cabrito aos donos. Eu estava envergonhado por causa dela. Então ela disse-me: «Onde estão as tuas esmolas? Onde está o bem que fizeste? Vês a que ponto chegaste?!»"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Muito entristecido com tudo isso, soluçando e chorando, comecei a rezar:"
,"2":"«Senhor, Tu és justo, e todas as tuas obras são justas. Tu ages com misericórdia e fidelidade. Tu és o juiz do mundo."
,"3":"Agora, Senhor, lembra-Te de mim,e olha para mim. Não me castigues pelos pecados e erros, meus e dos meus antepassados,"
,"4":"que cometemos na tua presença, desobedecendo aos teus mandamentos. Tu nos entregaste ao saque, ao exílio e à morte, transformando-nos em zombaria, comentário e desprezo,de todas as nações, por onde nos espalhaste."
,"5":"Sim, todas as tuas sentenças são justas, quando me tratas,segundo as minhas faltas, porque não cumprimos,os teus mandamentos, nem procedemos lealmente,na tua presença."
,"6":"Agora, faz de mim o que desejares. Manda que me tirem a vida, e eu desaparecerei da face da terra, e em terra me transformarei. Sim, é melhor morrer do que viver, pois sofro ultrajes que não mereço, e a tristeza me invade. Manda, Senhor, que eu seja liberto,desta prova. Deixa-me partir para a morada eterna, e não afastes o teu rosto,de mim, Senhor. Sim, é melhor morrer do que viver,aguentando esta prova e ouvindo,tantos ultrajes»."
,"7":"Nesse mesmo dia, Sara, filha de Raguel, que morava na Média, em Ecbátana, também teve que suportar os insultos de uma empregada de seu pai."
,"8":"Sara tinha-se casado com sete homens, porém Asmodeu, o pior dos demónios, tinha matado cada um deles, antes que tivessem relações conjugais com ela. A empregada dizia-lhe: «És tu mesma que matas os teus maridos. Já te casaste com sete homens, e nenhum deles consumou o casamento!"
,"9":"Queres castigar-nos a nós pela morte dos teus maridos? Pois vai ter com eles, e que nunca tenhas filho ou filha»."
,"10":"Então Sara, abatida, começou a chorar e subiu ao quarto de seu pai, pensando em enforcar-se. Depois, reflectiu melhor e pensou: «Ainda vão lançar esta afronta à cara de meu pai. Vão dizer que a sua única e querida filha se enforcou de tanta infelicidade! Desse modo, eu causaria tanta dor ao meu velho pai, que ele morreria. Em vez de me enforcar, é melhor pedir ao Senhor que me tire a vida, e eu nunca mais terei de ouvir estes insultos»."
,"11":"Nesse momento, ela estendeu os braços para a janela, e suplicou: «Bendito sejas Tu, Deus misericordioso!,Bendito seja o teu Nome eternamente, e que as tuas obras,Te bendigam para sempre."
,"12":"Para Ti levanto o meu rosto,e os meus olhos."
,"13":"Ordena que eu desapareça da terra, para não ouvir mais insultos."
,"14":"Tu sabes, Senhor, que eu estou pura,e que homem algum me tocou."
,"15":"Nunca desonrei o meu nome, nem o nome de meu pai, na terra do meu exílio. Sou filha única, e meu pai,não tem outro filho como herdeiro, nem irmão ou parente próximo,com quem eu possa casar-me. Já perdi sete maridos. Para quê viver mais?,Se não me quiseres tirar a vida, Senhor, trata-me com compaixão, para que eu não ouça mais insultos»."
,"16":"No mesmo instante, o Deus da glória escutou a oração dos dois,"
,"17":"e mandou Rafael para os curar: tirar as manchas dos olhos de Tobit, a fim de que ele pudesse ver a luz de Deus; e fazer com que Sara, filha de Raguel, se casasse com Tobias, filho de Tobit, livrando-a de Asmodeu, o pior dos demónios. De facto, Tobias tinha mais direito de casar-se com ela do que todos os outros pretendentes. No mesmo momento, Tobit voltava do pátio para dentro de casa, e Sara, filha de Raguel, descia do quarto do pai."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Nesse dia, Tobit lembrou-se do dinheiro que tinha deixado a Gabael em Rages, na Média,"
,"2":"e pensou: «Eu pedi a morte. Porque não chamar o meu filho Tobias e informá-lo sobre esse dinheiro, antes de morrer?»"
,"3":"Então chamou o filho Tobias, e disse-lhe: «Quando eu morrer, dá-me uma sepultura digna. Honra tua mãe, e não a abandones nunca, enquanto ela viver. Faz sempre o que for do agrado dela, e por nada lhe causes tristeza."
,"4":"Lembra-te, meu filho, de que ela passou muitos perigos por tua causa, quando tu estavas no seu ventre. Quando ela morrer, sepulta-a junto de mim, no mesmo túmulo."
,"5":"Meu filho, lembra-te do Senhor todos os dias. Não peques, nem transgridas os seus mandamentos. Pratica a justiça todos os dias da vida, e jamais andes pelos caminhos da injustiça."
,"6":"Se agires conforme a verdade, serás bem sucedido em tudo o que fizeres, como todos os que praticam a justiça."
,"7":"Dá esmolas daquilo que possuis, e não sejas mesquinho. Se vires um pobre, não desvies o rosto, e Deus não afastará o seu rosto de ti."
,"8":"Que a tua esmola seja proporcional aos bens que possuis: se tens muito, dá muito; se tens pouco, não tenhas receio de dar conforme esse pouco."
,"9":"Assim estarás guardando um tesouro para o dia da necessidade,"
,"10":"pois a esmola livra da morte e não deixa cair nas trevas."
,"11":"Quem dá esmola, apresenta uma boa oferta ao Altíssimo."
,"12":"Meu filho, afasta-te de qualquer união ilegal. Em primeiro lugar, escolhe uma esposa que pertença à família dos teus antepassados. Não te cases com mulher estrangeira, que não seja da tribo de teu pai, porque somos filhos de profetas. Lembra-te de Noé, Abraão, Isaac e Jacob, nossos antepassados mais antigos. Todos eles se casaram com mulheres da sua parentela, foram abençoados em seus filhos, e a sua descendência possuirá a terra como herança."
,"13":"Meu filho, ama os teus parentes, não te mostres orgulhoso diante dos teus irmãos, os filhos e filhas do teu povo, e escolhe entre elas a tua mulher. De facto, o orgulho é causa de ruína e muita inquietação. A preguiça traz pobreza e miséria, porque a preguiça é mãe da fome."
,"14":"Não atrases o pagamento de quem trabalha para ti. Paga sem demora e, se fores justo, Deus te recompensará. Meu filho, sê reservado em tudo o que fizeres, e bem educado em todo o teu comportamento."
,"15":"Não faças a ninguém aquilo que não gostas que te façam a ti. Não bebas vinho até te embriagares, e não deixes que a embriaguez seja tua companheira de caminho."
,"16":"Reparte o teu pão com quem tem fome, e as tuas roupas com quem está nu. Dá como esmola tudo o que tens de supérfluo, e não sejas mesquinho."
,"17":"Oferece o teu pão e vinho sobre o túmulo dos justos, em vez de os dares aos infiéis."
,"18":"Procura aconselhar-te com pessoas sensatas, e nunca desprezes um conselho útil."
,"19":"Bendiz ao Senhor Deus em todas as circunstâncias. Pede-Lhe que te guie em todos os caminhos, e que te faça ter sucesso em todas as iniciativas e projectos, pois nenhum povo possui a sabedoria. O Senhor é que concede todos os bens. Segundo o seu projecto, o Senhor exalta ou rebaixa até ao fundo da mansão dos mortos. Portanto, meu filho, lembra-te destas normas, e não permitas que elas desapareçam da tua memória."
,"20":"Meu filho, quero ainda contar-te que deixei trezentos quilos de prata em casa de Gabael, filho de Gabri, na cidade de Rages, na Média."
,"21":"Não tenhas medo, meu filho, por termos ficado pobres. Se temeres a Deus, se evitares todo o tipo de pecado e se fizeres o que agrada ao Senhor teu Deus, terás uma grande riqueza»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Tobias disse ao pai: «Meu pai, vou fazer tudo o que me mandaste."
,"2":"Mas como posso recuperar esse dinheiro? Gabael não me conhece e eu não o conheço. Que sinal posso dar-lhe para que ele me reconheça, acredite em mim e me entregue o dinheiro? Além disso, não conheço o caminho para ir até à Média»."
,"3":"Tobit respondeu: «Gabael deu-me um documento e eu dei-lhe outro a ele. Dividi o documento em duas partes, e cada um ficou com uma delas. Uma parte, eu deixei-a lá com o dinheiro, e a outra está comigo. Já se passaram vinte anos, desde que eu depositei esse dinheiro! Agora, meu filho, vai procurar uma pessoa de confiança que possa acompanhar-te na viagem, e nós pagar-lhe-emos quando voltardes. Vai e recupera esse dinheiro que está na posse de Gabael»."
,"4":"Tobias saiu para procurar uma pessoa que pudesse ir com ele até à Média e conhecesse o caminho. Logo que saiu, encontrou o anjo Rafael à frente dele, mas não sabia que era um anjo de Deus."
,"5":"Tobias perguntou-lhe: «De onde és, rapaz?» Ele respondeu: «Sou israelita, teu compatriota, e ando à procura de trabalho». Tobias perguntou-lhe: «Sabes o caminho para a Média?»"
,"6":"Ele respondeu: «Sim. Já lá estive muitas vezes e conheço bem todos os caminhos. Fui muitas vezes à Média, e hospedei-me em casa do nosso compatriota Gabael, que mora em Rages, na Média. São dois dias de viagem de Ecbátana até Rages, pois Rages fica na região montanhosa e Ecbátana fica na planície»."
,"7":"Tobias disse: «Espera aqui, rapaz, enquanto vou contar isso a meu pai. Estou a precisar de que viajes comigo. Eu pago-te depois»."
,"8":"Rafael disse: «Está bem. Vou esperar, mas não te demores»."
,"9":"Tobias entrou em casa e contou ao pai Tobit: «Pai, encontrei um israelita, que é nosso compatriota!» Tobit disse-lhe: «Chama-o para que eu saiba de que família e tribo ele é, e se é de confiança para viajar contigo, meu filho»."
,"10":"Tobias saiu para o chamar e disse: «Rapaz, o meu pai está a chamar-te!» O anjo entrou em casa, e Tobit apressou-se a cumprimentá-lo. O anjo disse: «Desejo-te muita alegria». Tobit respondeu: «Que alegria ainda posso ter? Sou cego, não vejo a luz do dia, vivo na escuridão com os mortos, que já não vêem a luz. Escuto a voz das pessoas, mas não posso vê-las». Rafael disse-lhe: «Coragem! Em breve, Deus vai curar-te. Tem confiança». Tobit disse-lhe: «O meu filho Tobias quer ir até à Média. Podes ir com ele para lhe ensinares o caminho? Eu pagar-te-ei por isso, meu irmão». Ele respondeu: «Posso ir. Conheço todas as estradas. Muitas vezes viajei até à Média e já percorri todas as suas planícies e montanhas, e conheço todos os caminhos por lá»."
,"11":"Tobit perguntou-lhe: «Meu irmão, de que família e tribo és? Diz-me»."
,"12":"O anjo respondeu: «Para que é que queres saber acerca da minha família e tribo?» Tobit insistiu: «Gostaria de saber de quem és filho e qual é o teu nome»."
,"13":"Rafael respondeu: «Sou Azarias, filho do grande Ananias, um teu compatriota»."
,"14":"Tobit disse: «Sê bem-vindo, meu irmão. Não leves a mal se eu procuro saber exactamente o teu nome e a tua família. Acontece que tu és meu parente e vens de uma família honesta e honrada. Conheço bem Ananias e Natã, os dois filhos do grande Semeías. Eles costumavam ir comigo a Jerusalém, para juntos adorarmos a Deus. Eles nunca se desviaram do caminho certo. Os teus parentes são homens de bem. Sê bem-vindo, porque vens de uma raiz muito boa»."
,"15":"E acrescentou: «Vou pagar-te uma dracma por dia, além do necessário para ti e meu filho."
,"16":"Acompanha o meu filho, que depois eu ainda posso aumentar-te o pagamento»."
,"17":"O rapaz respondeu: «Vou com ele. Não tenhas medo. Iremos e voltaremos sãos e salvos. O caminho é seguro». Tobit disse: «Deus te pague, meu irmão». Então Tobit chamou o filho e recomendou: «Filho, prepara o necessário para a viagem e parte com o teu parente. Que o Deus do céu vos proteja e vos traga sãos e salvos. Que o seu anjo vos acompanhe com a sua protecção, meu filho». Tobias beijou seu pai e sua mãe e partiu para a viagem, enquanto Tobit lhe dizia: «Boa viagem!» "
,"18":"A sua mãe começou a chorar, e disse a Tobit: «Porque mandaste o meu filho? Ele era o nosso apoio e sempre estava perto de nós!"
,"19":"O dinheiro não vale nada em comparação com o nosso filho."
,"20":"O que Deus nos dava era o bastante»."
,"21":"Tobit disse: «Não te preocupes! O nosso filho partiu e voltará são e salvo. Verás com os teus próprios olhos, quando ele voltar são e salvo."
,"22":"Não te preocupes nem te atormentes, minha irmã. Um anjo bom o acompanhará, lhe dará uma viagem tranquila e o trará são e salvo»."
,"23":"Então ela deixou de chorar."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Tobias partiu com o anjo, e o cão acompanhou-os. Caminharam até ao anoitecer e acamparam junto ao rio Tigre."
,"2":"Tobias foi lavar os pés no rio, quando um grande peixe saltou da água, tentando devorar-lhe o pé. Tobias deu um grito."
,"3":"Mas o anjo disse-lhe: «Agarra o peixe. Não o deixes fugir». Tobias conseguiu agarrar o peixe e tirou-o para fora da água."
,"4":"O anjo disse-lhe: «Abre o peixe, tira-lhe o fel, o coração e o fígado e guarda-os. Deita fora as tripas. O fel, o coração e o fígado desse peixe são excelentes remédios»."
,"5":"Tobias, então, abriu o peixe e tirou o fel, o coração e o fígado. Depois assou um pedaço, comeu e salgou o resto."
,"6":"E continuaram a viagem até chegarem perto da Média."
,"7":"Tobias perguntou ao anjo: «Azarias, meu irmão, que remédio se pode fazer do fígado, do coração e do fel deste peixe?»"
,"8":"Ele respondeu: «O coração e o fígado servem para serem queimados na presença de homem ou mulher atacados por algum demónio ou espírito mau. O fumo espanta o mal e faz com que o demónio desapareça para sempre."
,"9":"Se uma pessoa tem manchas brancas nos olhos, basta pôr-lhes o fel. Depois sopra-se sobre as manchas, e a pessoa fica curada»."
,"10":"Quando entraram na Média e estavam perto de Ecbátana,"
,"11":"Rafael disse: «Irmão Tobias!» Ele respondeu: «O que foi?» O anjo continuou: «Hoje devemos passar a noite em casa de Raguel. Ele é teu parente e tem uma filha chamada Sara."
,"12":"Ela é filha única. Tu és o parente mais próximo, tens mais direitos sobre ela do que os outros. Por isso, é justo que sejas tu o herdeiro dos bens do pai dela. A jovem é séria, corajosa e muito bonita, e o pai dela é de boa posição»."
,"13":"E continuou: «Tu tens o direito de te casares com ela. Presta atenção, meu irmão: hoje à noite vou falar com o pai dela, e pedir-lhe que te dê a sua filha em casamento. Quando voltarmos de Rages, faremos o casamento. Eu te garanto que Raguel não vai poder negar-te a filha, fazendo-a casar-se com outro. Nesse caso, ele seria réu de morte, conforme a sentença do Livro de Moisés, pois ele sabe que tu tens mais direito de te casares com a sua filha, que qualquer outro homem. Portanto, presta atenção, meu irmão: vamos falar esta noite sobre a jovem, e pedir a sua mão. Quando voltarmos de Rages, nós a receberemos e a levaremos para tua casa»."
,"14":"Tobias, porém, respondeu: «Azarias, meu irmão, ouvi dizer que ela já foi dada em casamento a sete homens, e que todos eles morreram no quarto, durante a noite de núpcias, quando iam unir-se a ela. Ouvi dizer que foi um demónio que os matou a todos."
,"15":"Eu tenho medo. O demónio não faz nada à jovem, porém mata qualquer um que se aproxime dela. Sou filho único. Tenho medo de morrer e levar meu pai e minha mãe à sepultura, pelo desgosto de me perderem. Eles não têm outro filho que possa sepultá-los»."
,"16":"Então o anjo disse a Tobias: «Tu não te lembras de que teu pai te disse para te casares com uma mulher da tua família? Pois presta atenção, meu irmão: não te preocupes com o demónio, e casa-te com ela. Eu tenho a certeza de que esta noite ela vai ser-te dada em casamento."
,"17":"Quando fores para o quarto nupcial, pega no fígado e no coração daquele peixe e coloca-os no queimador de incenso. Quando o fumo começar a subir e o demónio sentir o cheiro, ele fugirá e nunca mais aparecerá perto dela."
,"18":"Antes de te unires a ela, levantai-vos os dois e rezai, pedindo ao Senhor do céu que tenha misericórdia e vos proteja. Não tenhas medo. Ela foi-te destinada desde a eternidade, e tu é que vais salvá-la. Ela irá contigo, e eu estou certo de que te dará filhos, que serão para ti como irmãos. Não te preocupes!»"
,"19":"Quando Tobias ouviu o que Rafael lhe dizia, e soube que a jovem era sua parente, da mesma família de seu pai, ficou tão enamorado que o seu coração não conseguia separar-se dela."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Quando entraram em Ecbátana, Tobias disse: «Azarias, meu irmão, leva-me já à casa do nosso irmão Raguel». O anjo levou-o a casa de Raguel, que estava sentado junto ao portão. Eles cumprimentaram-no primeiro, e Raguel respondeu: «Como estais, irmãos? Sede bem-vindos!» E fê-los entrar em casa."
,"2":"E foi logo dizendo à sua mulher Edna: «Como este rapaz é parecido com o meu irmão Tobit!»"
,"3":"Edna perguntou-lhes: «De onde sois vós, meus irmãos?» Eles responderam: «Somos da tribo de Neftali e estamos exilados em Nínive!»"
,"4":"Ela perguntou: «Conheceis o nosso irmão Tobit?» Eles responderam: «Conhecemos, sim!» Ela continuou: «Ele está bem?»"
,"5":"Eles responderam: «Sim. Está vivo e passando bem». E Tobias acrescentou: «Tobit é meu pai!»"
,"6":"Raguel levantou-se, deu um beijo a Tobias e, chorando, disse: «Deus te abençoe, meu filho! Tu tens um pai justo e bom! Que infelicidade ficar cego um homem tão justo e bom!» E, lançando-se ao pescoço de Tobias, desatou a chorar."
,"7":"Sua mulher Edna e sua filha Sara também começaram a chorar."
,"8":"Em seguida, Raguel mandou matar um cordeiro do rebanho, e fez-lhes uma calorosa recepção."
,"9":"Depois de se lavarem e se purificarem, sentaram-se à mesa. Tobias disse então a Rafael: «Azarias, meu irmão, pede a Raguel que me dê minha irmã Sara em casamento!»"
,"10":"Raguel ouviu a conversa e disse ao rapaz: «Come, bebe e fica à vontade esta noite, pois, além de ti, meu irmão, não há outro homem que tenha o direito de se casar com minha filha Sara. Nem eu tenho o direito de a entregar a outro, porque tu és o meu parente mais próximo. Mas vou ser franco contigo, meu filho."
,"11":"Já dei a minha filha em casamento a sete homens nossos parentes, e todos morreram na noite em que entraram no quarto dela. Mas agora, meu filho, come e bebe. O Senhor cuidará de vós»."
,"12":"Tobias disse: «Não vou comer nem beber antes que me dês uma resposta!» Raguel respondeu: «Vou fazer o que me pedes. A minha filha vai ser-te dada em casamento, conforme está determinado no Livro de Moisés, e como Deus mandou fazer. Recebe então a tua irmã. Vós, a partir de agora, sois marido e mulher. Ela pertence-te de hoje para sempre. Que o Senhor do céu vos ajude esta noite, e vos conceda a sua misericórdia e a sua paz»."
,"13":"Então Raguel chamou a sua filha Sara, que se apresentou. Ele tomou-a pela mão e entregou-a a Tobias, dizendo: «Recebe Sara. Conforme a Lei e a sentença que está escrita no Livro de Moisés, ela é-te dada por esposa. Recebe-a e volta são e salvo para a casa de teu pai. Que o Deus do céu vos acompanhe com a sua paz»."
,"14":"Então chamou a mãe da jovem e mandou trazer uma folha de papiro. Escreveu o contrato de casamento, segundo o qual concedia a própria filha como esposa de Tobias, conforme a sentença da lei de Moisés. Depois disso, começaram a comer e beber."
,"15":"Raguel chamou a sua esposa Edna e disse: «Irmã, prepara o outro quarto e leva para lá a nossa filha»."
,"16":"Ela foi preparar a cama no quarto e levou a filha para lá. Depois começou a chorar pela filha, enxugou as lágrimas e disse:"
,"17":"«Coragem, filha! Que o Senhor do céu transforme a tua tristeza em alegria. Coragem, filha!» E saiu."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quando acabaram de comer e beber, foram dormir. Acompanharam o rapaz até ao quarto."
,"2":"Tobias lembrou-se do que Rafael tinha dito: pegou no fígado e no coração do peixe, que estavam na sua sacola, e colocou-os no queimador de incenso."
,"3":"O cheiro do peixe expulsou o demónio, que fugiu para as regiões do alto Egipto. Rafael perseguiu-o, agarrou-o e acorrentou-o."
,"4":"Os outros tinham saído e fechado a porta do quarto. Tobias levantou-se e disse a Sara: «Levanta-te, minha irmã! Vamos rezar e suplicar ao Senhor que nos conceda misericórdia e salvação»."
,"5":"Então ela levantou-se, e os dois começaram a rezar, pedindo que Deus os protegesse. Eles diziam: «Bendito sejas Tu, Deus dos nossos antepassados, e bendito seja o teu Nome,para todo o sempre!,Que o céu e as tuas criaturas todas,Te bendigam para todo o sempre."
,"6":"Tu criaste Adão,e, como ajuda e apoio, criaste Eva, sua mulher, e dos dois nasceu a raça humana. Tu mesmo disseste: «Não é bom que o homem fique só. Façamos para ele uma auxiliar,que lhe seja semelhante»."
,"7":"Se eu me caso com minha prima, não é para satisfazer a minha paixão. Eu caso-me com recta intenção. Por favor, tem piedade de mim e dela,e faz que juntos cheguemos à velhice»."
,"8":"E os dois disseram juntos: «Ámen! Ámen!»"
,"9":"Depois dormiram a noite inteira."
,"10":"Raguel, porém, levantou-se e chamou os empregados que tinha em casa para abrirem uma sepultura. Ele pensava assim: «Se eu não fizer isso e ele morrer, nós vamos ser objecto de riso e zombaria»."
,"11":"Quando acabaram de abrir a sepultura, Raguel entrou em casa, chamou a mulher"
,"12":"e disse: «Manda uma empregada entrar no quarto deles a ver se Tobias está vivo. Se tiver morrido, vamos sepultá-lo imediatamente, para que ninguém fique a sabê-lo»."
,"13":"Mandaram a empregada, acenderam um lampião e abriram a porta. A empregada entrou e encontrou os dois deitados juntos e a dormir."
,"14":"Saindo do quarto, ela contou que ele estava vivo e que nada de mau parecia ter acontecido."
,"15":"Raguel deu graças ao Deus do céu, dizendo: «Bendito sejas Tu, ó Deus, com todo o louvor mais sincero!,Sê bendito para sempre!"
,"16":"Bendito sejas Tu, pela alegria que me deste, pois não aconteceu o mal que eu temia. Tu nos trataste,segundo a tua grande misericórdia."
,"17":"Bendito sejas Tu, que tiveste compaixão,de dois filhos únicos. Tem piedade deles, Senhor, e concede-lhes a tua salvação. Faz com que eles cheguem,ao fim da sua vida,na alegria e na graça»."
,"18":"Em seguida, Raguel ordenou aos empregados que tapassem a sepultura, antes que amanhecesse."
,"19":"Raguel disse à sua mulher para fazer muitos pães. Foi ao estábulo, escolheu dois bois e quatro carneiros, e mandou preparar tudo. E começaram os preparativos."
,"20":"Depois chamou Tobias e disse-lhe: «Durante catorze dias não sairás daqui, mas ficarás em minha casa, comendo e bebendo comigo e alegrando o coração da minha filha, que estava tão abatida."
,"21":"Depois tomarás metade do que é meu e voltarás são e salvo para junto de teu pai. Quando eu e minha mulher morrermos, também a outra metade será vossa. Coragem, filho! Eu sou teu pai e Edna é tua mãe. De hoje em diante, nós pertencemos a ti e à tua esposa. Coragem, filho»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Tobias chamou, então, Rafael e disse-lhe:"
,"2":"«Azarias, meu irmão, leva contigo quatro criados e dois camelos,"
,"3":"vai até Rages e procura a casa de Gabael. Entrega-lhe o documento, recebe o dinheiro e convida-o a vir até aqui para a festa do casamento."
,"4":"Sabes que o meu pai está contando os dias, e se eu me atrasar um dia que seja, vou causar-lhe muita preocupação. E sabes também que não posso quebrar o compromisso com Raguel»."
,"5":"Então Rafael partiu para Rages, acompanhado dos quatro criados e levando os dois camelos. Hospedaram-se na casa de Gabael. E Rafael entregou-lhe o documento, deu-lhe a notícia de que Tobias, filho de Tobit, se havia casado e que o convidava para a festa do casamento. Gabael foi depressa buscar as sacolas ainda lacradas e contou-as na presença de Rafael. Depois carregaram tudo sobre os camelos."
,"6":"Os dois madrugaram, e juntos partiram para a festa do casamento. Ao entrarem na casa de Raguel, encontraram Tobias à mesa. Ele levantou-se imediatamente para o cumprimentar. Então Gabael abençoou-o chorando e dizendo: «Filho bom de um homem excelente, justo e bom! Que Deus te dê a bênção do céu, a ti e à tua esposa, ao pai e à mãe da tua esposa. Bendito seja Deus, porque vejo em ti o retrato vivo do meu primo Tobit»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Enquanto isso, Tobit ficava contando, um a um, os dias da viagem de Tobias, quantos eram necessários para a ida e quantos para a volta. Quando, porém, terminou esse prazo e o seu filho não chegou,"
,"2":"ele pôs-se a pensar: «Quem sabe se ele teve algum contratempo! Será que Gabael morreu e não lhe quiseram entregar o dinheiro?»"
,"3":"E começou a ficar preocupado."
,"4":"Ana, sua mulher, dizia: «O meu filho morreu, já não faz parte do mundo dos vivos». E começou a chorar e a lamentar-se por causa do filho. Dizia:"
,"5":"«Que desgraça para mim! Filho meu, porque te deixei partir? Tu que eras a luz dos meus olhos«!"
,"6":"Tobit, porém, disse: «Fica calma! Não te preocupes, irmã! Ele está bem. Talvez tenha tido algum imprevisto. O companheiro dele é de confiança, é um dos nossos irmãos. Não te preocupes, minha irmã. Em breve ele estará aqui»."
,"7":"Ela respondeu: «Não me fales assim, não queiras enganar-me! O meu filho morreu mesmo!» E todos os dias, ela saía e ficava a olhar para a estrada por onde o filho tinha partido. Não acreditava em mais ninguém. Somente ao pôr do sol ela voltava para casa e passava a noite inteira em claro, chorando e lamentando-se."
,"8":"Passados os catorze dias da festa de casamento, que Raguel tinha mandado fazer para a sua filha, Tobias dirigiu-se-lhe, dizendo: «Deixa-me partir. Estou certo de que meu pai e minha mãe já perderam a esperança de me rever. Por favor, pai, deixa-me voltar para casa. Já te expliquei em que situação o deixei»."
,"9":"Raguel insistiu: «Fica, meu filho, fica comigo! Mandarei um mensageiro dar notícias tuas a teu pai Tobit». Mas Tobias respondeu: «De maneira nenhuma! Por favor, deixa-me voltar imediatamente para casa do meu pai»."
,"10":"Então Raguel entregou a esposa de Tobias e metade de todos os seus bens: empregados e empregadas, bois e ovelhas, jumentos e camelos, roupas, dinheiro e utensílios."
,"11":"E deixou-os partir em paz. Despedindo-se de Tobias, disse-lhe: «Passa bem, meu filho! Vai em paz. Que o Senhor do céu te conduza e à tua esposa Sara pelo bom caminho. Talvez, antes de morrer, eu ainda possa ver os vossos filhos»."
,"12":"E disse à filha Sara: «Vai para casa do teu sogro, que a partir de agora eles são teus pais, da mesma forma como nós, que te demos a vida. Vai em paz, minha filha! Que eu tenha sempre boas notícias tuas durante toda a minha vida». E saudando-os despediu-se deles."
,"13":"Edna disse a Tobias: «Meu filho Tobias, meu irmão querido, que o Senhor um dia te faça voltar e que, antes de morrer, eu possa ver os teus filhos e de minha filha Sara. Diante do Senhor, eu te confio a minha filha Sara. Não lhe causes tristeza durante todos os dias da tua vida. Vai em paz, filho. A partir de agora eu sou tua mãe e Sara é tua irmã. Que bom se pudéssemos viver todos juntos e felizes por toda a vida!» Em seguida, beijou os dois, e deixou-os partir."
,"14":"Tobias partiu feliz da casa de Raguel, cantando e louvando ao Senhor do céu e da terra, ao Rei de todas as coisas, pelo sucesso da viagem. Ao despedir-se de Raguel e Edna, Tobias disse: «Que eu seja digno de vós todos os dias da minha vida»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Quando estavam perto de Caserin, já defronte de Nínive, Rafael disse:"
,"2":"«Tu sabes em que estado deixámos teu pai."
,"3":"Vamos à frente, antes da tua esposa, para preparar a casa, enquanto os outros vão chegando»."
,"4":"Então os dois foram juntos, à frente. O anjo disse a Tobias: «Traz contigo o fel do peixe». E o cão ia atrás deles."
,"5":"Ana estava sentada, olhando para a estrada pela qual o filho tinha partido."
,"6":"Percebendo antes de todos a chegada dele, ela disse a Tobit: «O teu filho está a chegar com o companheiro!»"
,"7":"Antes de chegarem à casa do pai, Rafael disse a Tobias: «Eu tenho a certeza de que os olhos dele se vão abrir!"
,"8":"Coloca o fel do peixe nos seus olhos. O remédio vai fazer com que as manchas brancas diminuam e desapareçam. Então teu pai vai recuperar a vista e poderá ver»."
,"9":"Ana correu e lançou-se ao pescoço do filho, dizendo: «Vi-te de novo, meu filho! Agora posso morrer». E começou a chorar."
,"10":"Tobit levantou-se e, tropeçando, conseguiu chegar até ao portão."
,"11":"Tobias foi ao seu encontro, levando na mão o fel do peixe. Soprou nos olhos do pai, enquanto o abraçava, e disse: «Coragem, pai!» Aplicou-lhe o remédio nos olhos e apertou um pouco."
,"12":"Depois, com as duas mãos, tirou uma pele dos cantos dos olhos do pai."
,"13":"Tobit, então, lançou-se ao pescoço do filho, chorou e disse: «Estou a ver-te, meu filho, luz dos meus olhos!»"
,"14":"E continuou: «Bendito seja Deus! Bendito seja o seu Nome grandioso! Benditos sejam os seus santos anjos! Que o seu Nome glorioso nos proteja. Porque, num momento Ele me castigou, mas depois compadeceu-Se, e agora estou a ver o meu filho Tobias!»"
,"15":"Em seguida, Tobias entrou feliz em casa, bendizendo a Deus em voz alta. Depois contou ao pai que a viagem tinha corrido bem. Trazia o dinheiro e tinha casado com Sara, a filha de Raguel. Ela estava a chegar às portas de Nínive."
,"16":"Tobit saiu, então, em direcção à porta de Nínive, para ir ao encontro da noiva. Estava alegre e dando graças a Deus. Os ninivitas ficaram admirados ao vê-lo caminhar com passo firme, sem ninguém que o ajudasse. Tobit testemunhava a todos que Deus tinha tido misericórdia dele e lhe tinha devolvido a visão."
,"17":"Ao aproximar-se de Sara, esposa de seu filho Tobias, deu-lhe a bênção e disse: «Sê bem-vinda, minha filha! Bendito seja o teu Deus, que te trouxe para junto de nós! Bendito seja o teu pai, e abençoado seja também o meu filho Tobias. Bendita sejas tu, minha filha! Sê bem-vinda a esta tua casa. Fica alegre e está à vontade. Entra, minha filha»."
,"18":"Nesse dia, todos os judeus que viviam em Nínive fizeram uma grande festa."
,"19":"Aicar e Nadab, primos de Tobit, foram participar na sua alegria. E, durante sete dias, festejaram alegremente o casamento de Tobias."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Terminada a festa do casamento, Tobit chamou o seu filho Tobias e disse-lhe: «Filho, está na hora de pagares a esse homem que te acompanhou e de lhe dares também alguma gratificação»."
,"2":"Tobias respondeu: «Pai, quanto lhe devo dar? Mesmo que eu lhe dê metade dos bens que trago comigo, não me faria falta."
,"3":"Ele conduziu-me são e salvo, libertou a minha mulher, resgatou o dinheiro e ainda o curou a si. Como é que vou pagar-lhe?»"
,"4":"Tobit disse: «Filho, ele merece bem metade de tudo o que trouxeste!»"
,"5":"Então Tobias chamou-o e disse: «Como pagamento, leva metade de tudo o que trouxemos e vai em paz»."
,"6":"Mas ele chamou os dois à parte, e disse: «Bendizei a Deus e proclamai diante de todos os seres vivos os benefícios que Ele vos concedeu. Bendizei e cantai ao seu Nome. Anunciai a todos os homens, como convém, as obras de Deus. E não vos canseis de Lhe agradecer."
,"7":"É bom manter oculto o segredo do rei, mas é necessário revelar e manifestar as obras de Deus. Praticai o bem, e não vos acontecerá nenhuma desgraça."
,"8":"Vale mais a oração com jejum e a esmola com justiça, do que a riqueza adquirida com a injustiça. É melhor praticar a esmola do que acumular ouro."
,"9":"A esmola livra da morte e purifica de todo o pecado. Quem pratica a esmola, terá vida longa."
,"10":"Os pecadores e injustos são inimigos de si próprios."
,"11":"Vou revelar-vos toda a verdade, sem ocultar nada. Já vos expliquei que é bom manter oculto o segredo do rei, mas as obras de Deus devem ser proclamadas publicamente."
,"12":"Quando tu e Sara rezáveis, era eu que apresentava as vossas súplicas diante do Senhor glorioso. A mesma coisa eu fazia quando sepultavas os mortos."
,"13":"Quando não tiveste dúvidas em deixar a refeição, para ires esconder um morto, eu fui mandado para provar a tua fé."
,"14":"Da mesma forma, fui mandado para te curar, a ti e a Sara, tua nora."
,"15":"Eu sou Rafael, um dos sete anjos que estão sempre prontos para entrar na presença do Senhor glorioso»."
,"16":"Os dois ficaram assustados e caíram com o rosto por terra, cheios de medo."
,"17":"Rafael, porém, disse-lhes: «Não tenhais medo! Que a paz esteja convosco! Bendizei a Deus para sempre."
,"18":"Se estive convosco, não foi por vontade minha, mas de Deus. É a Ele que deveis sempre bendizer e cantar hinos."
,"19":"Vós julgáveis que eu comia, mas era só aparência."
,"20":"Agora, bendizei ao Senhor na Terra, e agradecei a Deus. Vou voltar para Aquele que me enviou. Escrevei tudo o que vos aconteceu». E o anjo desapareceu. "
,"21":"Quando se levantaram, já não o puderam ver mais."
,"22":"Então louvaram a Deus e entoaram hinos, agradecendo-Lhe as maravilhas que Ele tinha realizado, porque um anjo de Deus lhes tinha aparecido."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Tobias disse:"
,"2":"«Bendito seja Deus,que vive eternamente. E bendito o seu reino, que dura para sempre, pois é Ele quem castiga e tem piedade. Ele faz descer à mansão dos mortos,e subir da grande perdição. E ninguém pode fugir da sua mão."
,"3":"Celebrai a Deus, israelitas, diante das nações, porque Ele vos dispersou entre elas,"
,"4":"para proclamar a sua grandeza. Exaltai a Deus,diante de todo o ser vivo, porque Ele é o nosso Senhor. Ele é o nosso Deus. Ele é o nosso Pai. Ele é Deus para todo o sempre."
,"5":"Se vos castiga por causa das injustiças, também terá compaixão de todos vós, e vos reunirá de todas as nações, entre as quais fostes espalhados."
,"6":"Se vos voltardes para Ele,com todo o coração,e com toda a alma, para praticar a verdade diante d'Ele, então Ele voltar-Se-á para vós, e nunca mais vos esconderá a sua face."
,"7":"Considerai o que Ele fez por vós,e agradecei-Lhe em alta voz. Bendizei o Senhor da justiça, e exaltai o rei dos séculos."
,"8":"Eu celebro-O na terra do meu exílio, e mostro a sua força e grandeza,a um povo de pecadores. Voltai-vos para Ele, pecadores, e diante d'Ele praticai a justiça. Talvez Ele vos seja favorável, e vos trate com misericórdia."
,"9":"Eu exalto o meu Deus, minha alma louva o rei do céu, e alegra-se com a sua grandeza."
,"10":"Que todos O louvem,e em Jerusalém O celebrem. Jerusalém, cidade santa, Deus castigou-te pelas obras,de teus filhos, mas de novo terá piedade,do povo justo."
,"11":"Celebra,dignamente o Senhor,e bendiz o Rei dos séculos, para que o seu Templo,seja reconstruído com alegria:"
,"12":"para que alegre em ti todos os exilados, e em ti ame todos os miseráveis, por todas as gerações futuras."
,"13":"Uma luz brilhante iluminará,todas as regiões da terra. De longe, numerosos povos virão a ti, e habitantes de todos os extremos,da Terra virão visitar,o Nome do Senhor Deus, com ofertas para o rei do céu. Gerações sem fim,cantarão em ti a sua alegria, e o nome da Eleita permanecerá,pelas gerações futuras."
,"14":"Malditos sejam os que te insultarem!,Malditos sejam os que te arruinarem!,Malditos sejam os que te derrubarem,as muralhas, demolirem as torres,e incendiarem as casas!,Benditos sejam para sempre,aqueles que te reconstruírem!"
,"15":"Então exultarás,e alegrar-te-ás por causa do povo justo, pois todos se reunirão em ti, para bendizer o Senhor dos séculos. Felizes os que te amam. Felizes os que te desejam a paz!"
,"16":"Felizes os que sofrem,com as tuas desgraças. Contigo eles se alegrarão,ao verem a tua perpétua alegria. Bendiz, ó minha alma, ao Senhor, ao Rei soberano,"
,"17":"porque Jerusalém será reconstruída, e o seu Templo ali estará para sempre. Feliz de mim, se restar alguém,do meu sangue,para ver a sua glória,e louvar o Rei do céu. As portas de Jerusalém,serão reconstruídas,com safiras e esmeraldas, e todas as suas muralhas,com pedras preciosas. As torres de Jerusalém,serão construídas com ouro, e com ouro puro os seus baluartes. As ruas de Jerusalém serão calcetadas,com turquesas e pedras de Ofir."
,"18":"As portas de Jerusalém ressoarão,com cantos de júbilo, e em todas as suas casas aclamarão: Aleluia!,Bendito seja o Deus de Israel!,Benditos aqueles que bendizem,o seu Nome santo, para todo o sempre!»"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Aqui terminam as palavras do cântico de Tobit."
,"2":"E Tobit morreu em paz com a idade de cento e doze anos, e foi sepultado em Nínive com todas as honras. Tinha sessenta e dois anos quando ficou cego e, depois de ter recuperado a vista, viveu feliz, praticou a esmola e continuou a bendizer a Deus e a celebrar a sua grandeza."
,"3":"Quando estava para morrer, chamou o seu filho Tobias e deu-lhe estas recomendações: «Filho, toma os teus filhos"
,"4":"e parte para a Média, pois eu creio na palavra de Deus a respeito de Nínive, pronunciada pelo profeta Naum. Vai cumprir-se e realizar-se tudo o que os profetas de Israel, enviados por Deus, anunciaram contra a Assíria e contra Nínive. Nada ficará sem se realizar. Tudo acontecerá no devido tempo. Haverá mais segurança na Média do que na Assíria ou na Babilónia. Pois eu sei e acredito que vai acontecer tudo o que Deus disse, e não falhará uma só palavra do que foi dito. Os nossos irmãos que estão na terra de Israel serão recenseados e exilados para longe da sua bela pátria. Toda a terra de Israel se transformará num deserto. A Samaria e Jerusalém ficarão desertas. O Templo será incendiado e ficará durante algum tempo em ruínas. "
,"5":"Mas Deus terá novamente misericórdia do seu povo e vai fazê-lo regressar à terra de Israel. Eles reconstruirão o Templo, menos belo que o primeiro, até que chegue o tempo determinado. Então todos voltarão do exílio, reconstruirão Jerusalém no seu esplendor, e o Templo de Deus será reconstruído como os profetas de Israel anunciaram."
,"6":"Todas as nações da Terra se converterão e temerão a Deus com sinceridade. Todos eles abandonarão os ídolos, que os enganaram com mentiras, e bendirão, como é justo, o Deus dos séculos."
,"7":"Nesse dia, todos os israelitas que se salvarem, se lembrarão de Deus com sinceridade. Irão reunir-se em Jerusalém, e daí em diante habitarão com segurança na terra de Abraão, que será propriedade deles. E aqueles que amam a Deus com sinceridade serão felizes, mas todos os que praticam o pecado e a injustiça serão eliminados da Terra."
,"8":"Agora, meus filhos, recomendo-vos: Servi a Deus com sinceridade e fazei sempre o que Ele aprova. Ensinai aos vossos filhos a prática da justiça e da esmola e a lembrarem-se de Deus e louvarem o seu Nome por todo o tempo, com sinceridade e com todas as forças."
,"9":"Quanto a ti, meu filho, sai de Nínive, não fiques aqui. No dia em que sepultares a tua mãe comigo, não pernoites mais nesta região. Aqui há muita injustiça, acontecem muitas fraudes e ninguém se sente envergonhado."
,"10":"Vê, meu filho, quanta coisa Nadab fez a Aicar, seu pai de criação! Não é verdade que ele queria enterrá-lo vivo? No entanto, Deus fez com que o criminoso pagasse pela sua injustiça diante da sua própria vítima, pois Aicar voltou à luz, enquanto Nadab desceu às trevas eternas, como castigo por ter atentado contra a vida de Aicar. Devido às suas boas obras, Aicar escapou da armadilha mortal que Nadab lhe havia preparado, enquanto que Nadab caiu na armadilha e morreu."
,"11":"Portanto, meus filhos, vede quais são os frutos da esmola, e quais são os frutos da injustiça, que mata! Estou a perder a respiração...» Então deitaram Tobit na cama. E ele morreu e foi sepultado com honra."
,"12":"Quando sua mãe morreu, Tobias sepultou-a junto do seu pai. Em seguida, partiu para a Média com a mulher e os filhos, e ficou a morar com o sogro Raguel, em Ecbátana."
,"13":"Cuidou, como devia, da velhice dos sogros e sepultou-os em Ecbátana, na Média. Herdou o que era da família de Raguel e também o que era do seu pai Tobit."
,"14":"Cercado de respeito, Tobias morreu em Ecbátana, na Média, com cento e dezassete anos."
,"15":"Antes da sua morte, porém, viu e ouviu falar da destruição de Nínive. Viu os prisioneiros ninivitas serem levados para o exílio na Média por Ciáxares, rei da Média. Tobias bendisse a Deus pelo castigo dos ninivitas e assírios. Antes de morrer, ainda pôde alegrar-se com a desgraça de Nínive, e bendisse o Senhor Deus para todo o sempre."
}`)

}
func PT_BS_LoadVMBRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Livro escrito por Baruc, filho de Nerias, filho de Maasias, filho de Sedecias, filho de Asadias, filho de Helcias, quando estava na Babilónia,"
,"2":"no sétimo dia do mês, no quinto ano da época em que os caldeus tomaram Jerusalém e a incendiaram."
,"3":"Baruc leu este texto na presença de Jeconias, filho de Joaquim, rei de Judá, e também na presença de todo o povo que veio ouvir a leitura:"
,"4":"autoridades, gente do rei, conselheiros, o povo todo, pequenos e grandes, que residiam na Babilónia, nas margens do rio Sud."
,"5":"Então todos começaram a chorar, a jejuar e a fazer preces ao Senhor."
,"6":"Fizeram também uma colecta em dinheiro, dando cada um o que podia,"
,"7":"e mandaram a soma para Jerusalém, ao sacerdote Joaquim, filho de Helcias, filho de Salom, e para os outros sacerdotes e o povo que com ele tinha ficado em Jerusalém."
,"8":"Foi então que Baruc, no décimo dia do mês de Sivã, recuperou os objectos da casa do Senhor, tirados do Templo, e os devolveu à terra de Judá. Eram os objectos de prata que Sedecias, filho de Josias, rei de Judá, tinha mandado fazer,"
,"9":"depois de Nabucodonosor, rei da Babilónia, ter levado para o exílio na Babilónia o rei Jeconias, as autoridades, os artesãos, os poderosos e os cidadãos de Jerusalém."
,"10":"A carta dizia: «Aqui vos enviamos algum dinheiro. É para comprardes com ele vítimas para o holocausto e vítimas expiatórias, para o incenso e para as ofertas. Oferecei tudo isto sobre o altar do Senhor nosso Deus,"
,"11":"rezando pela saúde de Nabucodonosor, rei da Babilónia, e pela saúde de seu filho Baltasar, a fim de que os seus dias sejam tão longos como a idade do céu."
,"12":"O Senhor nos conceda forças e nos ilumine, para podermos viver protegidos por Nabucodonosor, rei da Babilónia, e pelo seu filho Baltasar, trabalhando para eles por muito tempo e gozando o seu favor."
,"13":"Rezai também por nós ao Senhor nosso Deus, pois pecámos contra o Senhor nosso Deus, e até hoje a ira e o furor do Senhor não se afastaram de nós."
,"14":"Proclamai este documento que vos enviamos para ser lido em público no Templo do Senhor, tanto em dia de festa, como em outras ocasiões»."
,"15":"Eis o texto: Confessamos que o Senhor nosso Deus é justo e a nós cabe hoje a vergonha, a nós, cidadãos de Judá e habitantes de Jerusalém,"
,"16":"reis e autoridades nossas, sacerdotes, profetas e antepassados nossos,"
,"17":"porque pecámos contra o Senhor,"
,"18":"desobedecemos, não ouvimos a voz do Senhor nosso Deus, deixámos de seguir as orientações que Ele nos colocou diante dos olhos."
,"19":"Desde o dia em que o Senhor tirou os nossos antepassados do Egipto até hoje, nós só desobedecemos ao Senhor nosso Deus e não fizemos caso de ouvir a sua voz."
,"20":"Assim nos acompanham até aos dias de hoje desgraças e maldições com que o Senhor ameaçou o seu servo Moisés, quando tirou os nossos antepassados do Egipto para nos dar uma Terra onde corre leite e mel."
,"21":"Nós, porém, nunca demos atenção à voz do Senhor nosso Deus, que nos falava pela palavra dos profetas que nos enviava."
,"22":"Pelo contrário, cada um de nós seguia as suas más inclinações, prestando culto aos deuses estrangeiros e praticando o que é mau aos olhos do Senhor nosso Deus."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por isso, o Senhor cumpriu as ameaças feitas contra nós e os nossos juízes que governavam Israel, contra os nossos reis e as nossas autoridades, contra todos os cidadãos de Israel e Judá."
,"2":"Debaixo do céu, jamais aconteceu coi-sa igual a tudo o que aconteceu em Jerusalém, conforme está escrito na lei de Moisés:"
,"3":"que pessoas chegassem ao ponto de comer a carne de seus próprios filhos e filhas."
,"4":"O Senhor entregou os israelitas nas mãos de todos os reinos ao redor e deixou o seu território desolado, tornando-os objecto de escárnio e desprezo dos povos, entre os quais o Senhor os espalhou."
,"5":"Foi assim que se tornaram vassalos e não senhores, pois pecámos contra o Senhor nosso Deus, quando deixámos de dar atenção à sua voz."
,"6":"O Senhor nosso Deus é justo; hoje a vergonha pesa sobre nós e os nossos antepassados."
,"7":"Todas as ameaças que o Senhor havia pronunciado caíram sobre nós;"
,"8":"contudo, não aplacámos a ira do Senhor, convertendo-nos da nossa atitude perversa."
,"9":"Por isso, o Senhor prestou atenção e enviou-nos as desgraças com que nos havia ameaçado. O Senhor foi justo em tudo o que fez contra nós,"
,"10":"porque não Lhe obedecemos, pondo em prática o que nos havia mandado."
,"11":"Senhor, Deus de Israel, que tiraste o teu povo do Egipto com mão poderosa, com sinais e prodígios, com grande força e braço firme, criando para Ti uma fama que dura até hoje:"
,"12":"Nós pecámos, agimos impiamente, praticámos a injustiça, ó Senhor, nosso Deus, contra todos os teus mandamentos;"
,"13":"afasta de nós a tua ira, pois nos tornámos um pequeno resto entre as nações por onde nos espalhaste."
,"14":"Ouve, Senhor, a nossa prece e a nossa súplica, libertando-nos por causa da tua honra. Faz com que ganhemos o favor daqueles que nos exilaram,"
,"15":"a fim de que a Terra fique a saber que Tu és o Senhor nosso Deus, pois o teu Nome foi invocado sobre Israel e seus descendentes."
,"16":"Senhor, do alto da tua santa morada, olha para nós. Inclina, Senhor, o teu ouvido e escuta."
,"17":"Abre, Senhor, os teus olhos e observa: os mortos no túmulo com os seus corpos já sem vida não podem cantar a tua glória e a tua justiça."
,"18":"Aquele que geme sob o peso, andando encurvado e esgotado, olhos baixos, passando fome, é que reconhece a tua glória e a tua justiça, Senhor."
,"19":"Não é apoiados no que os nossos antepassados ou os nossos reis praticaram de bom, que vimos implorar a tua misericórdia, Senhor nosso Deus."
,"20":"O furor e a ira que derramaste sobre nós estão de acordo com o que disseste por meio dos profetas, teus servos. Eles disseram:"
,"21":"'Assim diz o Senhor: Dobrai a cerviz e submetei-vos ao rei da Babilónia, para ficardes na Terra que dei aos vossos antepassados."
,"22":"E se desobedecerdes ao Senhor e não vos submeterdes ao rei da Babilónia,"
,"23":"deixarei desertos os povoados de Judá e tirarei de Jerusalém os gritos de alegria, o barulho da festa, a voz do noivo e da noiva, e o país transformar-se-á num lugar deserto e sem habitantes'."
,"24":"Nós, porém, não obedecemos à tua ordem de nos submetermos ao rei da Babilónia, e Tu cumpriste a tua palavra anunciada pelos profetas, teus servos: tiraram da sepultura os ossos dos nossos reis e antepassados"
,"25":"e deixaram-nos expostos ao calor do dia e ao frio da noite. Muitos morreram em situações terríveis: à fome, ao fio da espada ou de peste."
,"26":"Por causa da maldade da casa de Israel e da casa de Judá, reduziste ao estado em que se encontra hoje o Templo sobre o qual o teu Nome foi invocado."
,"27":"No entanto, agiste connosco, Senhor nosso Deus, em conformidade com a tua imensa piedade e compaixão,"
,"28":"conforme falaste por meio do teu servo Moisés, quando lhe mandaste escrever a tua Lei na presença de Israel:"
,"29":"'Se não ouvirdes a minha palavra, esta grande multidão ficará reduzida a uns poucos no meio das nações para onde a espalharei."
,"30":"Eu sei que eles não Me irão obedecer, porque são todos um povo que não baixa a cabeça. Contudo, no exílio eles converter-se-ão"
,"31":"e reconhecerão que Eu sou o Senhor seu Deus. Então dar-lhes-ei inteligência e ouvidos dóceis"
,"32":"e, na terra do seu exílio, louvar-Me-ão e lembrar-se-ão do meu nome."
,"33":"Eles arrepender-se-ão da sua rebeldia e do mau comportamento, pois lembrar-se-ão do caminho dos seus antepassados, que pecaram contra o Senhor."
,"34":"Então, fá-los-ei voltar para a Terra que jurei dar aos seus antepassados Abraão, Isaac e Jacob. Tomarão posse dela, multiplicá-los-ei e nunca mais diminuirão."
,"35":"Farei com eles uma aliança eterna: Eu serei o seu Deus e eles serão o meu povo. Nunca mais vou expulsar o meu povo Israel da Terra que lhe dei'."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Senhor todo-poderoso, Deus de Israel: é uma alma angustiada e um espírito aflito que clama por Ti."
,"2":"Ouve, Senhor, tem piedade, pois pecámos contra Ti."
,"3":"Tu reinas para sempre, e nós morremos para sempre."
,"4":"Senhor todo-poderoso, Deus de Israel, ouve as preces daqueles que já estão mortos em Israel e as súplicas dos filhos daqueles que pecaram contra Ti: eles desobedeceram ao Senhor seu Deus, e nós somos perseguidos pelas desgraças."
,"5":"Não Te lembres das injustiças dos nossos antepassados; lembra-Te, nesta hora, do teu poder e do teu Nome."
,"6":"Sim, porque Tu és o nosso Deus, e nós Te louvamos, ó Senhor."
,"7":"Pois foi para isso que puseste o teu temor em nossos corações, para que invocássemos o teu Nome. Nós Te louvamos agora no exílio, pois afastámos do nosso coração toda a injustiça dos nossos antepassados, que pecaram contra Ti."
,"8":"Hoje estamos no exílio, para onde nos expulsaste, a fim de sofrermos vergonha, maldição e insultos, para pagarmos por todas as injustiças dos nossos antepassados, que se revoltaram contra o Senhor nosso Deus»."
,"9":"Ouve, israel, os mandamentos da vida, presta atenção para aprender a prudência."
,"10":"Diz, Israel: porque estás numa terra inimiga, a envelhecer numa terra estrangeira?"
,"11":"Porque te contaminas,com os cadáveres,e és contado entre os que vão,para a mansão dos mortos?"
,"12":"É porque abandonaste,a fonte da sabedoria!"
,"13":"Se tivesses andado,nos caminhos de Deus, terias sempre vivido em paz."
,"14":"Aprende agora onde está a prudência, a força e a inteligência, para compreenderes,onde está a vida longa, onde está a luz dos olhos e a paz."
,"15":"Mas quem descobriu,a morada da sabedoria, quem penetrou em seus depósitos?"
,"16":"Onde estão os governantes das nações, os que dominam as feras da terra?"
,"17":"Onde estão os que se divertem,com as aves do céu, os que juntam prata e ouro, riquezas em que os homens confiam,e em cuja posse não põem limites?"
,"18":"Onde estão os que lavram a prata,e a cinzelam, sem revelar o segredo,dos seus trabalhos?"
,"19":"Desapareceram, desceram,à mansão dos mortos, e outros surgiram,e tomaram o seu lugar."
,"20":"Novas gerações viram a luz,e vieram habitar a Terra, mas não conheceram o caminho,da ciência,"
,"21":"nem aprenderam as suas veredas; nem mesmo os seus filhos,a puderam alcançar; pelo contrário, afastaram-se,do seu caminho."
,"22":"Em Canaã jamais se ouviu falar,da sabedoria, e em Temã nunca foi vista."
,"23":"Nem mesmo os filhos de Agar, que procuram a sabedoria,em toda a Terra, ou os comerciantes de Merrã,e de Temã, que contam histórias,e buscam o saber, nem eles conheceram os caminhos,da sabedoria, nem se lembraram das suas veredas."
,"24":"Como é grande, ó Israel, o Templo de Deus!,Como é espaçoso o lugar,dos seus domínios;"
,"25":"grande e sem fim, alto e sem medidas!"
,"26":"Ali surgiram os famosos gigantes,dos tempos antigos,de enorme estatura,e treinados para a guerra."
,"27":"Não foi, porém, a eles,que Deus escolheu,nem lhes ensinou o caminho,da ciência:"
,"28":"morreram porque não tinham,prudência, pereceram por falta de reflexão."
,"29":"Quem subiu ao céu para se apoderar,da sabedoria,e a fazer descer das nuvens?"
,"30":"Quem atravessou o mar,para a encontrar, e a comprar a preço de ouro puro?"
,"31":"Ninguém conhece o seu caminho, nem descobre as suas veredas."
,"32":"Aquele que tudo sabe, conhece a sabedoria,e penetrou-a com a sua inteligência. Aquele que criou a Terra para sempre,e a encheu de animais;"
,"33":"Ele envia a luz, e ela vai; chama-a, e ela obedece com tremor."
,"34":"As estrelas brilham alegres, cada uma no seu lugar;"
,"35":"Ele chama-as, e elas respondem: «Presente!»,E brilham de alegria para Aquele,que as criou."
,"36":"Ele é o nosso Deus, e nenhum outro a Ele se compara."
,"37":"Foi Ele que encontrou,o caminho da ciência,e o deu ao seu filho Jacob,e ao seu amado Israel."
,"38":"Por isso, ela apareceu sobre a Terra,e viveu entre os homens."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ela é o livro dos mandamentos de Deus, a lei decretada para sempre: os que a guardam viverão, os que a abandonam morrerão."
,"2":"Volta-te para ela, Jacob, e recebe-a; caminha na claridade,do seu esplendor;"
,"3":"não entregues a outros a glória,que te pertence, nem a tua dignidade,a um povo estrangeiro."
,"4":"Felizes somos nós, Israel, pois conhecemos o que agrada a Deus."
,"5":"Coragem, povo meu, que trazes o nome de Israel!"
,"6":"Não fostes vendidos às nações, para serdes destruídos. Porque provocastes a ira de Deus, então fostes entregues aos inimigos."
,"7":"Irritastes o vosso criador, sacrificando aos demónios, e não a Deus;"
,"8":"esquecestes o Deus eterno que vos alimentou e provocastes a tristeza de Jerusalém que vos sustentou."
,"9":"Jerusalém viu cair sobre vós a ira de Deus e disse: «Escutai, cidades vizinhas de Sião! Deus trouxe-me um grande sofrimento:"
,"10":"Eu vi o cativeiro dos meus filhos e filhas, que o Eterno lhes infligiu."
,"11":"Com alegria eu os tinha criado, deles me despedi, chorando e gemendo."
,"12":"Ninguém se alegre comigo, pois agora estou viúva e abandonada. Se agora fiquei só e vazia, foi por causa dos pecados dos meus filhos, que se desviaram da lei de Deus."
,"13":"Eles não entenderam os seus mandamentos, afastaram-se dos caminhos da lei de Deus e não andaram nas veredas da disciplina e da justiça."
,"14":"Vinde, cidades vizinhas de Sião: lembrai-vos do cativeiro dos meus filhos e filhas, infligido pelo Eterno."
,"15":"Pois Ele fez vir contra os meus filhos um povo distante, um povo cruel e de linguagem estranha, que não respeitou os velhos nem teve dó das crianças."
,"16":"Levaram os filhos queridos da viúva e deixaram-na sozinha e sem filhas»."
,"17":"E eu, que posso fazer por vós?"
,"18":"Somente Aquele que vos enviou a desgraça poderá libertar-vos do inimigo."
,"19":"Ide-vos, meus filhos, ide-vos, enquanto eu fico sozinha."
,"20":"Tirei o manto da paz e vesti a roupa de suplicante. Ficarei a vida inteira clamando ao Deus eterno."
,"21":"Coragem, meus filhos! Clamai a Deus, e Ele vos livrará da opressão e das mãos dos inimigos."
,"22":"De minha parte, espero da mão do Eterno a vossa salvação; já recebi a alegria que vem do Deus santo, porque o Eterno, vosso salvador, em breve terá misericórdia de vós."
,"23":"Entre lágrimas e gemidos me despedi de vós; Deus, porém, vos fará voltar a mim, com festa e alegria que nunca irão terminar."
,"24":"Da mesma forma que as cidades vizinhas de Sião viram há pouco o vosso cativeiro, assim, dentro em breve, verão a salvação que Deus vos concederá, pois é com grande glória e brilho do Eterno que ela vos chegará."
,"25":"Filhos meus, suportai, animados, a ira de Deus que se voltou contra vós. O inimigo perseguiu-vos, mas em breve vereis a sua derrota e lhes poreis o pé sobre o pescoço."
,"26":"Os meus filhos mimados passaram por caminhos pedregosos levados pelo inimigo como gado roubado."
,"27":"Coragem, meus filhos, clamai a Deus! Ele mesmo que vos provou, lembrar-Se-á de vós."
,"28":"Da mesma forma como vos veio, um dia, a ideia de abandonar a Deus, agora procurai-O com redobrado empenho."
,"29":"Aquele que vos enviou tanta desgraça, mandar-vos-á também a alegria eterna da salvação."
,"30":"Jerusalém, tem coragem! Aquele que te deu um nome, consolar-te-á."
,"31":"Malditos os que te fizeram mal ou ficaram contentes com a tua derrota!"
,"32":"Malditas as cidades onde os teus filhos foram escravos! E maldita também aquela que deteve os teus filhos."
,"33":"Pois, da mesma forma que se alegrou com a tua derrota e festejou a tua queda, assim também ela chorará pela sua própria destruição!"
,"34":"Tirar-lhe-ei a alegria de ser muito povoada, e o seu atrevimento mudar-se-á em luto."
,"35":"Sobre ela virá, durante muito tempo, um fogo mandado pelo Eterno, e os demónios nela habitarão por longos anos."
,"36":"Olha para o Nascente, Jerusalém, e vê a alegria que Deus te manda."
,"37":"Olha! Eis que regressam os filhos que viste partir: reunidos pela palavra do Deus santo, desde o Nascente até ao Poente, vêm festejando a glória de Deus."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Jerusalém, tira as vestes de luto e de aflição e veste para sempre o esplendor da glória que vem de Deus."
,"2":"Veste o manto da justiça de Deus e põe na cabeça a coroa gloriosa do Eterno,"
,"3":"pois Deus mostrará o teu esplendor a todos os que vivem debaixo do céu."
,"4":"Deus dar-te-á um nome para sempre: Paz-da-Justiça e Glória-da-Piedade."
,"5":"Levanta-te, Jerusalém, toma posição em lugar alto, olha para o Nascente e contempla os teus filhos, reunidos do Nascente e do Poente pela voz do Santo, que invocam alegremente a Deus."
,"6":"Eles partiram a pé, levados pelo inimigo, mas Deus recondu-los a ti, em triunfo, como sobre uma carruagem real."
,"7":"Deus mandou baixar toda a colina alta ou monte antigo e aterrar os lugares mais fundos, para aplanar o chão, a fim de que Israel possa passar com segurança, guiado pela glória de Deus."
,"8":"Por ordem de Deus, todas as árvores e plantas aromáticas darão sombra a Israel,"
,"9":"porque Deus, com a sua justiça e a sua misericórdia, conduzirá festivamente Israel à luz da sua glória."
}`)
	CurrentBook.AddChapter(6, `{
"0":"Cópia da carta que Jeremias mandou aos prisioneiros que estavam para ser levados para a Babilónia pelo rei da Babilónia, a fim de lhes transmitir o que Deus lhe havia ordenado."
,"1":"Por causa dos pecados que cometestes contra Deus é que sois levados prisioneiros para a Babilónia, sob as ordens do seu rei, Nabucodonosor."
,"2":"Quando chegardes a Babilónia, ali ficareis durante muitos anos, um longo tempo, ou seja, durante sete gerações; depois disso, tirar-vos-ei de lá em paz."
,"3":"Durante esse tempo, vereis na Babilónia deuses de prata, de ouro e de madeira, que costumam ser levados aos ombros e provocam temor entre os pagãos."
,"4":"Cuidado para não vos parecerdes também com esses estrangeiros, nem vos deixardes influenciar pelo temor desses deuses."
,"5":"Quando virdes as multidões ajoelhadas na frente e atrás deles, pensai dentro de vós mesmos: «É só a Ti, Senhor, que devemos adorar»."
,"6":"Pois o meu anjo estará sempre convosco e defenderá as vossas vidas."
,"7":"A língua desses deuses foi feita por um artista; ela está coberta de prata ou de ouro, mas é de mentira e não pode falar."
,"8":"Como se faz com a jovem que gosta de enfeites, pegam em ouro e fazem uma coroa para colocar na cabeça dos seus deuses."
,"9":"De vez em quando, os sacerdotes roubam o ouro e a prata aos seus deuses para seu próprio proveito, ou para o dar a prostitutas de bordéis."
,"10":"Eles enfeitam com ricas vestes, como se fossem homens, esses deuses de prata, de ouro ou de madeira. Mas eles não podem livrar-se da ferrugem nem do caruncho."
,"11":"Depois de os vestirem com roupas caras, são obrigados a limpar-lhes o rosto, por causa do pó que lhes caiu em cima."
,"12":"Um deus fica com o ceptro na mão, como se fosse um governador de província, mas não é capaz de destruir quem o ofende."
,"13":"Outro tem uma faca ou machadinha na mão, e não é capaz de se defender de inimigos ou ladrões."
,"14":"Por aí se vê que não são deuses, e não deveis temê-los."
,"15":"Como a vasilha que se quebra e perde a serventia, assim também são esses deuses, instalados nos seus templos."
,"16":"Os olhos desses deuses vivem cheios de pó levantado pelos pés daqueles que entram no templo."
,"17":"Da mesma forma como se fecham com segurança todas as portas por detrás de alguém que ofendeu o rei e fica preso e condenado à morte, assim também os sacerdotes fecham os templos com portas, trancas e ferrolhos, para que os seus deuses não sejam roubados pelos ladrões."
,"18":"Acendem-lhes mais lâmpadas que para si mesmos, embora esses deuses não sejam capazes de ver nenhuma delas."
,"19":"Como as vigas do templo, cujo interior dizem estar carcomido pelas térmites saídas do chão, assim também esses deuses nada sentem quando as suas vestes ou eles próprios são corroídos."
,"20":"O seu rosto fica escuro por causa do fumo do templo."
,"21":"Em volta deles, por cima das suas cabeças, voam morcegos, andorinhas e outros passarinhos, e até os gatos."
,"22":"Por aí se vê que eles não são deuses, e não deveis temê-los."
,"23":"Quanto ao ouro de que são revestidos para ficarem bonitos, se ninguém lhe dá lustro, não brilha. Eles mesmos, nem quando foram fundidos sentiram coisa alguma."
,"24":"Embora não tenham vida, foram comprados por um preço muito caro."
,"25":"Sem pés, são levados aos ombros, mostrando aos homens a sua falta de valor. Até quem cuida deles passa vergonha, pois se um desses deuses cai ao chão, ele é que tem de levantá-lo."
,"26":"E quando alguém os põe de pé, eles não são capazes de andar por si mesmos; se tombam, não podem endireitar-se. Os dons são-lhes oferecidos como a mortos."
,"27":"Para proveito próprio, os sacerdotes vendem o que foi sacrificado a esses deuses; a outra parte, as mulheres salgam-na, sem darem nada aos pobres e necessitados. Até a mulher menstruada ou que acaba de dar à luz toca nesses sacrifícios."
,"28":"Portanto, sabendo que não são deuses, não tenhais medo deles."
,"29":"Como poderiam ser deuses? As mulheres é que oferecem sacrifícios a esses deuses de prata, de ouro e de madeira."
,"30":"Nos seus templos, os sacerdotes circulam com a roupa rasgada, a barba e o cabelo cortado e a cabeça descoberta, em sinal de luto."
,"31":"Urram e gritam diante dos seus deuses, como alguns fazem nas cerimónias fúnebres."
,"32":"Os sacerdotes tiram a roupa aos deuses para vestirem as suas mulheres e crianças."
,"33":"E esses deuses, favorecidos ou prejudicados por alguém, não são capazes de retribuir. Não podem nomear nem destronar reis."
,"34":"Eles também não são capazes de dar a ninguém riqueza alguma, nem sequer uma única moeda. Se alguém lhes faz uma promessa e depois não cumpre, eles não podem reclamar."
,"35":"Não podem salvar ninguém da morte, nem podem livrar o fraco das mãos do poderoso."
,"36":"Não são capazes de devolver a vista ao cego, nem de livrar do perigo homem nenhum;"
,"37":"não têm compaixão pela viúva, nem prestam ajuda nenhuma ao órfão."
,"38":"Esses deuses de madeira prateada ou dourada parecem pedras tiradas da montanha: quem se ocupa deles só vai passar vergonha."
,"39":"Como, então, pensar ou dizer que são deuses?"
,"40":"Até mesmo os caldeus os desrespeitam. Quando vêem alguém mudo, incapaz de falar, apresentam-no ao deus Bel, pedindo-lhe que o faça falar, como se ele fosse capaz de ouvir."
,"41":"Mas, porque não têm bom senso, são incapazes de reflectir nisso e de abandonar esses deuses."
,"42":"As mulheres põem uma corda à cintura e sentam-se à beira do caminho, queimando farelo como incenso."
,"43":"Quando uma delas é levada por algum homem que passa, a fim de dormir com ele, começa a desprezar a companheira, que não teve a mesma honra nem lhe foi desatada a corda."
,"44":"Tudo o que fazem com eles é falso. Então, como é que se vai pensar ou dizer que são deuses?"
,"45":"Esses deuses foram fabricados por escultores e ourives, e não podem ser mais nada do que aquilo que os seus autores queriam que fossem."
,"46":"Aqueles que os fizeram não vivem muitos anos; então, como pode ser deus aquilo que eles fizeram?"
,"47":"Deixaram apenas mentira e vergonha aos seus descendentes."
,"48":"Quando surge uma guerra ou desgraça muito grande, os sacerdotes discutem a maneira de se esconderem juntamente com esses deuses."
,"49":"Assim, vê-se que não são deuses, pois não são capazes de se livrarem a si mesmos durante uma guerra ou catástrofe."
,"50":"Não sendo mais que objectos de madeira, dourados ou prateados, por aí descobrirão todos que são mentira. Que eles não são deuses, fique claro para todos os povos e reis; são apenas criação do trabalho humano, e nenhuma acção divina existe neles."
,"51":"Então, quem é que não vê que eles não são deuses?"
,"52":"Esses deuses nunca farão surgir um rei para uma região, nem mandarão chuva para os homens."
,"53":"Jamais defenderão a própria causa, nem libertarão nenhum oprimido, pois são impotentes, como gralhas que voam entre o céu e a terra."
,"54":"Se aparecer um fogo no templo desses deuses de madeira, dourados ou prateados, os seus sacerdotes poderão fugir para se salvarem, mas eles serão queimados juntamente com o madeiramento."
,"55":"Eles não são capazes de resistir a um rei ou aos inimigos."
,"56":"Então, como é que se pode admitir ou imaginar que são deuses?"
,"57":"Esses deuses de madeira, deuses dourados ou prateados, nem sequer podem escapar aos ladrões ou assaltantes. Mais fortes, os ladrões arrancam-lhes o ouro ou a prata e vão-se embora levando as roupas que esses deuses vestiam, sem que eles se possam defender a si mesmos."
,"58":"Mais vale um rei que mostra bravura ou mesmo um objecto de utilidade em casa, do qual o dono se pode servir, do que esses deuses falsos. Mais vale uma porta que, numa casa, protege tudo o que está dentro, do que esses falsos deuses. Mais vale uma coluna de madeira no palácio, do que esses falsos deuses."
,"59":"O Sol, a Lua e as estrelas, brilhando, cumprem espontaneamente a missão de ser úteis."
,"60":"O relâmpago, quando aparece, é bem visível. O próprio vento sopra em qualquer região."
,"61":"As nuvens obedecem, quando Deus as manda percorrer o mundo inteiro. O raio, mandado lá de cima para devastar montes e matas, cumpre o que lhe é determinado."
,"62":"Esses deuses, porém, não podem ser comparados com essas coisas, nem na aparência nem na força."
,"63":"Portanto, como é possível pensar que sejam deuses ou chamá-los assim? São incapazes de promover a justiça ou de fazer qualquer coisa boa para os homens."
,"64":"Portanto, sabendo que não são deuses, não tenhais medo deles."
,"65":"Esses deuses não podem amaldiçoar nem abençoar os reis;"
,"66":"não podem servir aos pagãos como sinais no céu, pois não brilham como o Sol, nem são claros como a Lua."
,"67":"Até as feras valem mais do que eles, pois as feras podem fazer alguma coisa por si mesmas, ao menos conseguem fugir para um esconderijo."
,"68":"Então, em nada mostram ser deuses. Por isso, não tenhais medo deles."
,"69":"Como espantalho que num meloal o não guarda, assim são esses deuses de madeira, dourados ou prateados."
,"70":"Esses deuses de madeira, dourados ou prateados, parecem-se com um espinheiro num jardim, onde os passarinhos vêm pousar ou, então, com um cadáver lançado numa cova escura."
,"71":"Pelas roupas de púrpura ou linho que vão apodrecendo em cima deles, já podeis saber que não são deuses. Pelo contrário, eles também serão comidos e tornar-se-ão vergonha para o país."
,"72":"Então, é melhor a condição do homem honrado que não tem ídolos, pois assim não terá de que se envergonhar."
}`)

}
func PT_BS_LoadVMDNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No terceiro ano do reinado de Joaquim em Judá, Nabucodonosor, rei da Babilónia, foi até Jerusalém e cercou a cidade."
,"2":"O Senhor entregou-lhe nas mãos Joaquim, rei de Judá, e parte dos objectos do Templo de Deus. Ele então levou tudo para a terra de Senaar e guardou os objectos na sala do tesouro do templo do seu deus."
,"3":"Depois o rei deu ordem a Asfenez, chefe dos eunucos, para escolher, entre os israelitas da família real ou de outras famílias importantes,"
,"4":"alguns jovens sem nenhum defeito físico, de boa aparência, instruídos em toda a espécie de sabedoria, práticos em conhecimento, gente de ciência, capazes de servir na corte do rei; deu também ordem para que lhes ensinasse a literatura e a língua dos caldeus."
,"5":"O próprio rei destinou-lhes uma ração diária da comida e do vinho da mesa real. Eles deveriam ser preparados durante três anos, e depois passariam a servir o rei."
,"6":"Entre eles estavam Daniel, Ananias, Misael e Azarias, que eram judeus."
,"7":"O chefe dos eunucos deu-lhes outros nomes: Daniel passou a chamar-se Baltassar; Ananias, Sidrac; Misael, Misac; e Azarias, Abdénago."
,"8":"Daniel resolveu que não iria contaminar-se com as comidas e o vinho da mesa real. Pediu ao chefe dos eunucos permissão para não aceitar essas comidas."
,"9":"O Senhor fez com que Daniel conquistasse a simpatia do chefe dos eunucos."
,"10":"Este disse-lhe: «Tenho medo do rei, meu senhor, que determinou pessoalmente o que deveis comer e beber. Se ele perceber que os vossos rostos estão mais pálidos que os dos outros jovens da mesma idade, tornar-me-eis culpado de crime de morte aos olhos do rei»."
,"11":"Daniel disse ao funcionário, a quem o chefe dos eunucos havia confiado Daniel, Ananias, Misael e Azarias:"
,"12":"«Faz uma experiência connosco: durante dez dias não nos dês a comer senão vegetais, e água a beber."
,"13":"Depois, compara a nossa aparência com a dos outros jovens que comem da mesa do rei. Depois agirás connosco como achares melhor»."
,"14":"O funcionário aceitou a proposta e fez a experiência durante dez dias."
,"15":"No final dos dez dias, estavam com boa aparência e corpo mais saudável que todos os jovens que comiam da mesa do rei."
,"16":"Então o funcionário tirou definitivamente a comida e o vinho da mesa dos jovens e passou a dar-lhes somente legumes."
,"17":"Aos quatro jovens Deus concedeu o conhecimento e a compreensão de toda a literatura e também sabedoria. A Daniel especialmente, deu o dom de interpretar visões e sonhos."
,"18":"Terminado o tempo que o rei havia fixado para os jovens serem apresentados, o chefe dos eunucos levou-os à presença de Nabucodonosor."
,"19":"O rei conversou com eles e não encontrou ninguém melhor do que Daniel, Ananias, Misael e Azarias. E, a partir desse momento, entraram ao serviço do rei."
,"20":"Por tudo o que procurou saber deles em termos de conhecimento e sabedoria, o rei achou que eram dez vezes mais capazes que todos os magos e adivinhos que havia no seu reino."
,"21":"Daniel ficou ali até ao primeiro ano do reinado de Ciro."
}`)
	CurrentBook.AddChapter(2, `{
"1":"No segundo ano do seu reinado, Nabucodonosor teve um sonho e ficou tão assustado que chegou a perder o sono."
,"2":"Mandou chamar os magos, astrólogos, agoureiros e adivinhos para interpretarem o sonho. Chegaram e foram levados à sua presença."
,"3":"Então o rei disse-lhes: «Tive um sonho que me assustou e quero saber o que ele significa»."
,"4":"Os adivinhos disseram ao rei: «Viva o rei para sempre! Conta-nos o sonho e dar-te-emos a explicação»."
,"5":"O rei respondeu aos adivinhos: «Esta é a minha decisão: se não me expuserdes o conteúdo do sonho que tive, nem me derdes a sua interpretação, sereis feitos em pedaços e as vossas casas serão transformadas em ruínas."
,"6":"Porém, se me contardes qual foi o meu sonho e qual é a sua interpretação, recebereis de mim donativos, presentes e muitas homenagens. Dizei qual foi o meu sonho e qual é a sua interpretação»."
,"7":"Os adivinhos disseram: «Majestade, conta-nos o sonho, e dar-te-emos a interpretação»."
,"8":"O rei respondeu: «Estou a ver que quereis ganhar tempo. Sabeis que dei uma ordem,"
,"9":"e se não me contardes o meu sonho, tereis todos a mesma sentença. Combinastes mentir e enganar-me, esperando que a situação mude. Dizei-me qual foi o meu sonho, e eu terei a certeza de que sereis capazes de o interpretar»."
,"10":"Os adivinhos disseram ao rei: «Não há ninguém no mundo que possa fazer o que o rei nos pede. Nenhum rei, governador ou chefe jamais pediu uma coisa dessas a qualquer mago, astrólogo ou adivinho."
,"11":"O que o rei exige é sobre-humano; somente os deuses, que não habitam com os mortais, podem dar ao rei a solução»."
,"12":"Ao ouvir isto, o rei ficou furioso e mandou matar todos os sábios da Babilónia."
,"13":"Quando foi publicado o decreto que condenava à morte todos os sábios, procuraram Daniel e seus companheiros, a fim de os executarem também."
,"14":"Então Daniel falou com inteligência e bons modos a Arioc, o carrasco-chefe do rei, encarregado de matar todos os sábios da Babilónia."
,"15":"E disse-lhe: «Qual é a razão de um decreto tão rigoroso do rei?» Então Arioc contou o caso a Daniel."
,"16":"E Daniel mandou pedir ao rei que lhe fosse dado um prazo, a fim de poder dar a interpretação do sonho."
,"17":"Daniel vol-tou para casa e contou o facto aos companheiros Ananias, Misael e Azarias."
,"18":"Disse-lhes para pedirem ao Senhor do céu a graça de desvendar o segredo, para não serem mortos com os outros sábios da Babilónia."
,"19":"Então o mistério foi revelado a Daniel numa visão nocturna. E ele glorificou o Deus do céu:"
,"20":"«Que o nome do Senhor seja louvado, desde agora e para sempre, pois a Ele pertencem,a sabedoria e o poder."
,"21":"Ele modifica os tempos e as estações, depõe e entroniza dos reis, dá sabedoria aos sábios,e ciência aos inteligentes."
,"22":"Ele revela os segredos mais profundos,e sabe o que as trevas escondem, pois a luz mora com Ele."
,"23":"A Ti, Deus de meus pais, eu louvo e celebro, porque me deste sabedoria e poder. Tu me revelaste o que Te pedi,e revelaste-me o caso do rei»."
,"24":"Depois disto Daniel procurou Arioc, a quem o rei tinha encarregado de matar os sábios da Babilónia. Aproximando-se dele, disse-lhe: «Não precisas de matar os sábios. Leva-me ao rei, e eu interpretarei o sonho que ele teve»."
,"25":"Arioc apressou-se a levar Daniel à presença do rei, dizendo-lhe: «Encontrei este jovem entre os judeus aqui exilados e que é capaz de interpretar o sonho do rei»."
,"26":"O rei perguntou a Daniel, cujo nome era Baltassar: «És mesmo capaz de me contar e interpretar o sonho que tive?»"
,"27":"Daniel respondeu ao rei: «Os sábios, astrólogos, magos e adivinhos não são capazes de desvendar o segredo que Vossa Majestade lhes propôs."
,"28":"Mas há no Céu um Deus que revela os segredos. Ele revelou ao rei Nabucodonosor o que acontecerá nos últimos dias. Este é o sonho que Vossa Majestade viu quando estava deitado:"
,"29":"Vossa Majestade estava na sua cama e pensava naquilo que ia acontecer no futuro. Então, Aquele que revela os segredos fez-lhe conhecer o que acontecerá."
,"30":"Não é por em mim haver maior sabedoria que nos outros homens que este mistério me foi revelado; foi apenas para poder dar a Vossa Majestade a explicação e interpretação das imagens que lhe povoaram a mente."
,"31":"Vossa Majestade teve uma visão: Era uma grande estátua, alta e muito brilhante. Ela estava diante de Vossa Majestade e tinha uma aparência impressionante."
,"32":"A cabeça da estátua era de ouro maciço, o peito e os braços eram de prata, o ventre e as coxas eram de bronze,"
,"33":"as pernas de ferro e os pés eram parte de ferro e parte de barro."
,"34":"Vossa Majestade estava a contemplar a estátua, quando, sem intervenção de mãos, uma pedra se desprendeu da montanha e veio bater exactamente nos pés de ferro e barro da estátua, quebrando-os."
,"35":"Ao mesmo tempo quebrou-se tudo o que era de ferro, de barro, de bronze, de prata e de ouro. Ficou tudo como se fosse palha na eira depois da debulha, palha que o vento leva sem deixar sinal. Depois, a pedra que tinha atingido a estátua transformou-se numa enorme montanha que cobriu o mundo inteiro."
,"36":"Foi este o sonho. Agora vamos dar a Vossa Majestade a interpretação."
,"37":"Vossa Majestade é o rei dos reis, a quem o Deus do céu concedeu o reino e o poder, o domínio e a glória."
,"38":"Em todo o mundo habitado Ele entregou-vos os seres humanos, as feras e as aves do céu, para que Vossa Majestade domine sobre tudo isso. Assim, Vossa Majestade é a cabeça de ouro."
,"39":"Depois de Vossa Majestade, vai aparecer outro reino, menor que o vosso; depois, um terceiro reino, o de bronze, que dominará sobre toda a Terra."
,"40":"O quarto reino será duro como o ferro, pois assim como o ferro esmaga e esmigalha tudo, assim também ele quebrará e esmigalhará todos os outros."
,"41":"Os pés e os dedos que Vossa Majestade viu, parte de ferro e parte de barro, significam um reino dividido. Ele tem a dureza do ferro, pois Vossa Majestade viu ferro misturado com uma parte feita de barro."
,"42":"Os dedos dos pés, metade de ferro e metade de barro, significam um reino firme por um lado, mas fraco por outro."
,"43":"O ferro que Vossa Majestade viu misturado com barro significa que as pessoas se juntarão por casamentos, mas não se ligarão umas com as outras, assim como o ferro não faz liga com o barro."
,"44":"Durante este último reinado, o Deus do céu fará aparecer um reino que nunca será destruído. Será um reino que não passará para as mãos de outro povo, mas, pelo contrário, humilhará e liquidará todos os outros reinos, enquanto que ele continuará firme para sempre."
,"45":"Esse reino é a pedra que rolou do monte sem ninguém a empurrar e esmigalhou o que era de barro, ferro, bronze, prata e ouro. O grande Deus mostrou ao rei o que acontecerá daqui em diante. O sonho tem sentido e a sua interpretação é digna de fé»."
,"46":"Então o rei Nabucodonosor deitou-se com o rosto por terra na frente de Daniel, mandando oferecer-lhe sacrifícios e queimar-lhe incenso."
,"47":"E o rei disse a Daniel: «De facto, o vosso Deus é o Deus dos deuses, o Senhor dos reis; Ele revela os mistérios, pois só tu foste capaz de desvendar este segredo»."
,"48":"Em seguida, o rei promoveu Daniel: deu-lhe uma quantidade enorme de presentes e quis fazer dele o governador de todas as províncias da Babilónia e o chefe geral de todos os sábios do país."
,"49":"Daniel, porém, pediu ao rei que nomeasse Sidrac, Misac e Abdénago para a administração das províncias, enquanto Daniel ficaria a servir na ante-sala do rei."
}`)
	CurrentBook.AddChapter(3, `{
"1":"O rei Nabucodonosor mandou fazer uma estátua de ouro com trinta metros de altura por três metros de diâmetro, e colocou-a na planície de Dura, província da Babilónia."
,"2":"Depois, mandou reunir os governadores, ministros, prefeitos, conselheiros, tesoureiros, letrados, magistrados e autoridades das províncias para assistirem à inauguração da estátua que o rei Nabucodonosor havia erguido."
,"3":"Reuniram-se os governadores, ministros, prefeitos, conselheiros, tesoureiros, letrados, magistrados e autoridades das províncias para a inauguração da estátua construída pelo rei Nabucodonosor. Todos estavam de pé diante da estátua."
,"4":"Então o porta-voz do rei gritou em alta voz: «Esta é a mensagem para todos os povos, nações e línguas:"
,"5":"quando ouvirdes o som da trombeta, flauta, cítara, harpa, saltério, gaita e outros instrumentos musicais, todos deveis prostrar-vos para adorar a estátua de ouro erguida pelo rei Nabucodonosor."
,"6":"Quem não se prostrar e não adorar será imediatamente lançado na fornalha ardente»."
,"7":"Quando ouviram o som da trombeta, flauta, cítara, harpa, saltério, gaita e outros instrumentos musicais, todos os povos, nações e línguas se prostraram em adoração diante da estátua de ouro erguida pelo rei Nabucodonosor."
,"8":"Alguns caldeus foram denunciar os judeus."
,"9":"Procuraram o rei Nabucodonosor e disseram: «Viva o rei para sempre!"
,"10":"Vossa Majestade decretou que toda a pessoa que ouvisse o som da trombeta, flauta, cítara, harpa, saltério, gaita e outros instrumentos musicais, deveria imediatamente cair de joelhos, adorando a estátua de ouro."
,"11":"E quem não se ajoelhasse para adorar, seria lançado na fornalha ardente."
,"12":"Pois bem! Alguns judeus que Vossa Majestade nomeou administradores das províncias da Babilónia - e são eles: Sidrac, Misac e Abdénago - não obedecem à ordem do rei. Eles não veneram os deuses nem adoram a estátua de ouro erguida por Vossa Majestade»."
,"13":"Nabucodonosor, com raiva e ódio, mandou comparecer Sidrac, Misac e Abdénago. Eles chegaram à presença do rei"
,"14":"e este perguntou-lhes: «Sidrac, Misac e Abdénago, é verdade que não venerais os meus deuses nem adorais a estátua de ouro que eu ergui?"
,"15":"Então, estai preparados, e quando ouvirdes o som da trombeta, flauta, cítara, harpa, saltério, gaita e outros instrumentos musicais, caireis de joelhos para adorar a estátua de ouro que Eu fiz. Se não adorardes, sereis imediatamente lançados na fornalha ardente; e quero ver qual é o deus que vos livrará da minha mão»."
,"16":"Sidrac, Misac e Abdénago responderam ao rei: «Não precisamos de vos responder."
,"17":"Existe o nosso Deus, a quem adoramos, e que nos pode livrar da fornalha ardente, libertando-nos da mão de Vossa Majestade."
,"18":"Mesmo que isso não aconteça, fique Vossa Majestade a saber que nós não adoraremos o vosso deus, nem adoraremos a estátua de ouro construída por Vossa Majestade»."
,"19":"Nabucodonosor ficou tão furioso contra Sidrac, Misac e Abdénago que o seu rosto empalideceu. Então mandou acender na fornalha um fogo sete vezes mais forte que o de costume,"
,"20":"e depois mandou que os soldados mais fortes do seu exército amarrassem Sidrac, Misac e Abdénago e os lançassem na fornalha ardente."
,"21":"Então amarraram-nos, vestidos com as suas túnicas, calções, gorros e outras roupas, e atiraram-nos à fornalha ardente."
,"22":"Como a ordem do rei era rigorosa e o fogo da fornalha era extremamente forte, aconteceu que as labaredas de fogo mataram aqueles que nela lançaram Sidrac, Misac e Abdénago."
,"23":"Os três jovens, porém, foram cair, amarrados, dentro da fornalha ardente."
,"24":"Sidrac, Misac e Abdénago passeavam no meio das labaredas, cantando hinos a Deus e louvando o Senhor."
,"25":"Azarias, de pé, soltando a voz no meio do fogo, rezou:"
,"26":"«Bendito sejas Tu, Senhor, Deus dos nossos pais, Tu és digno de louvor e o teu Nome,é glorificado para sempre!"
,"27":"Porque Tu és justo em tudo,o que nos fizeste, e todas as tuas obras são verdadeiras; os teus caminhos são rectos, e todos os teus julgamentos são justos."
,"28":"Foi justa a sentença que decretaste, todo o sofrimento que mandaste,sobre nós,e sobre Jerusalém, a cidade santa,dos nossos antepassados. Pois é segundo a verdade e o direito,que nos fizeste acontecer,todas estas coisas, por causa dos nossos pecados."
,"29":"Sim! Pecámos, cometendo um crime,ao afastarmo-nos de Ti; sim, pecámos gravemente em tudo. Não obedecemos,aos teus mandamentos,"
,"30":"nem os observámos, nem agimos conforme nos ordenavas, para que tudo nos corresse bem."
,"31":"Por isso, o que nos fizeste acontecer, tudo o que Tu mesmo nos fizeste, foi com julgamento justo,que o fizeste."
,"32":"Tu nos entregaste nas mãos,dos nossos inimigos, a uma gente sem lei, aos piores dos ímpios, a um rei injusto, o mais malvado,de toda a terra."
,"33":"Nesta hora, nem sequer nos deixam,abrir a boca; a decepção e a vergonha caíram,sobre os teus servos,e sobre os que Te adoram."
,"34":"Não nos entregues para sempre, não rejeites a tua aliança, por causa do teu Nome."
,"35":"Não nos retires a tua misericórdia, por amor de Abraão, teu amigo, por amor de Isaac, teu servo, e de Israel, teu santo."
,"36":"Falaste-lhes, prometendo,que a sua descendência seria,tão numerosa,como as estrelas do céu,e como a areia que existe à beira-mar."
,"37":"No entanto, Senhor, nós estamos diminuídos,no meio de todas as nações; estamos hoje humilhados,na terra inteira, por causa dos nossos pecados."
,"38":"Neste nosso tempo, não há chefe, profeta ou dirigente, nem holocausto, sacrifício, oferenda,ou incenso; não existe lugar onde oferecer-Te,os primeiros frutos,e alcançar misericórdia."
,"39":"Mas, com alma despedaçada,e espírito humilhado, sejamos aceites como se viéssemos,com holocaustos de carneiros, touros,e milhares de gordos carneiros."
,"40":"Seja este o sacrifício,que Te oferecemos, e, diante de Ti, que ele seja completo, pois jamais haverá decepção,para os que confiam em Ti."
,"41":"Mas agora nós vamos seguir-Te,de todo o coração; vamos temer-Te e procurar a tua face."
,"42":"Ah! Não nos deixes decepcionados, mas trata-nos,com toda a tua bondade,e conforme a abundância,da tua misericórdia."
,"43":"Liberta-nos, segundo as tuas maravilhas, e glorifica o teu Nome, Senhor."
,"44":"Fiquem envergonhados,aqueles que prejudicam,os teus servos; que fiquem cobertos de vergonha, privados de todo o seu poder, e que a sua força seja esmagada."
,"45":"Que eles saibam, Senhor, que Tu és o único Deus, glorioso sobre toda a Terra»."
,"46":"Contudo, os funcionários do rei que tinham lançado os três jovens na fornalha não paravam de alimentar o fogo com óleo combustível, pez, estopa e lenha seca,"
,"47":"tanto que as labaredas subiam uns vinte e dois metros acima da fornalha,"
,"48":"alcançando e queimando os caldeus que se encontravam junto dela."
,"49":"O Anjo do Senhor, porém, tinha descido à fornalha para junto de Azarias e seus companheiros. Afastou da fornalha as labaredas de fogo"
,"50":"e formou no meio da fornalha um vento húmido refrescante. O fogo nem tocou neles, nem lhes causou nenhum sofrimento ou incómodo."
,"51":"Os três cantavam hinos, glorificavam e louvavam a Deus, a uma só voz, dentro da fornalha:"
,"52":"«Bendito és Tu, Senhor, Deus dos nossos pais; a Ti, glória e louvor para sempre. Bendito é o teu Nome santo,e glorioso; a ele, glória e louvor para sempre."
,"53":"Bendito és Tu no teu Templo,santo e glorioso; a Ti, glória e louvor para sempre."
,"54":"Bendito és Tu no trono do teu reino; a Ti, glória e louvor para sempre."
,"55":"Bendito és Tu, que sondas os abismos, sentado sobre os querubins; a Ti, glória e louvor para sempre."
,"56":"Bendito és Tu, no firmamento do céu; a Ti, glória e louvor para sempre."
,"57":"Bendizei o Senhor, todas as obras do Senhor; exaltai o Senhor com hinos,para sempre."
,"58":"Anjos do Senhor, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"59":"Céus, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"60":"Águas todas acima do céu, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"61":"Todas as potências, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"62":"Sol e lua, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"63":"Estrelas do céu, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"64":"Chuva e orvalho, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"65":"Todos os ventos, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"66":"Fogo e calor, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"67":"Frio e ardor, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"68":"Chuvas e orvalhos, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"69":"Gelo e frio, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"70":"Geada e neve, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"71":"Noites e dias, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"72":"Luz e trevas, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"73":"Relâmpagos e nuvens, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"74":"Terra, bendiz o Senhor; louva e exalta o Senhor para sempre."
,"75":"Montanhas e colinas, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"76":"Tudo o que germina na terra, bendiz o Senhor; louva e exalta o Senhor para sempre."
,"77":"Fontes, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"78":"Mares e rios, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"79":"Baleias e peixes, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"80":"Aves do céu, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"81":"Animais selvagens e domésticos, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"82":"Criaturas humanas, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"83":"Israelitas, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"84":"Sacerdotes do Senhor, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"85":"Servos do Senhor, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"86":"Espíritos e almas dos justos, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"87":"Santos e humildes de coração, bendizei o Senhor; louvai e exaltai o Senhor para sempre."
,"88":"Ananias, Azarias e Misael, bendizei o Senhor; louvai e exaltai o Senhor para sempre. Porque Ele nos tirou da mansão,dos mortos,e nos salvou do poder da morte; livrou-nos das chamas,da fornalha ardente,e retirou-nos do meio do fogo."
,"89":"Dai graças ao Senhor, porque Ele é bom, louvai e exaltai o Senhor para sempre."
,"90":"Todos os que adorais o Senhor, Deus dos deuses, bendizei o Senhor: louvai e dai graças ao Senhor, porque a sua misericórdia,é para sempre»."
,"91":"Nabucodonosor ficou muito admirado. Levantou-se repentinamente e disse aos seus ministros: «Não foram três os jovens que lançámos amarrados à fornalha?» Eles responderam ao rei: «Sem dúvida, Majestade»."
,"92":"Então ele disse: «Como é que vejo quatro jovens soltos a andar dentro da fornalha ardente, sem qualquer incómodo, e a aparência do quarto é de um filho de deuses?»"
,"93":"Nabucodonosor chegou à boca da fornalha ardente e disse: «Sidrac, Misac e Abdénago, servos do Deus altíssimo, saí e vinde cá». Imediatamente os três jovens saíram da fornalha."
,"94":"Reuniram-se os governadores, ministros, prefeitos e conselheiros para ver os jovens. A fornalha não teve força nenhuma sobre os seus corpos, nem os cabelos das suas cabeças ficaram queimados, nem as suas roupas sofreram coisa alguma e nem mesmo o cheiro do fumo os atingiu."
,"95":"Nabucodonosor disse então: «Bendito seja o Deus de Sidrac, Misac e Abdénago, que mandou o seu anjo libertar os seus servos que n'Ele confiaram. Eles não fizeram caso do decreto do rei e entregaram o próprio corpo, pois não prestam culto nem adoram nenhum outro deus que não seja o seu Deus."
,"96":"Faço, pois, um decreto, mandando que qualquer povo, raça ou língua que disser uma blasfémia contra o Deus de Sidrac, Misac e Abdénago, seja feito em pedaços e a sua casa seja totalmente destruída, pois deus igual a Este, capaz de salvar, não existe outro»."
,"97":"E promoveu novamente Sidrac, Misac e Abdénago a cargos públicos na província da Babilónia."
,"98":"«O rei Nabucodonosor a todos os povos, nações e línguas que existem na Terra: paz e prosperidade."
,"99":"Tantos sinais e prodígios operou em meu favor o Deus altíssimo, que me pareceu bom publicá-los."
,"100":"Como são grandiosos os seus sinais, quanta força em seus prodígios! O seu reino é eterno e o seu poder atravessa as gerações!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Eu, Nabucodonosor, vivia tranquilo em minha casa, feliz no meu palácio."
,"2":"Então tive um sonho que me assustou; as imaginações que me vieram enquanto estava na cama e as visões que me passaram pela mente perturbaram-me."
,"3":"Por isso, publiquei um decreto em que mandava vir à minha presença todos os sábios da Babilónia, para que me dessem a interpretação do meu sonho."
,"4":"Vieram os magos, astrólogos, agoureiros e adivinhos. Eu contei-lhes o meu sonho, mas eles não foram capazes de dar a interpretação."
,"5":"Então veio Daniel, chamado Baltassar em honra do meu deus. Ele tinha o espírito dos deuses santos. Contei-lhe, então, o meu sonho:"
,"6":"«Baltassar, chefe dos magos, eu sei que possuis o espírito dos deuses santos e que nenhum segredo é difícil para ti. Escuta a visão que tive num sonho e, depois, dá-me a sua interpretação."
,"7":"As imagens que me vinham à cabeça, quando estava na minha cama são estas: havia uma árvore gigantesca no centro da terra."
,"8":"A árvore cresceu e ficou forte, e a sua copa chegou até ao céu: podia ser vista do extremo da terra."
,"9":"A sua folhagem era bonita e tinha frutos abundantes; nela havia alimentos para todos. À sua sombra abrigavam-se as feras da terra e nos seus ramos aninhavam-se as aves do céu. Dela se alimentava todo o ser vivo."
,"10":"Eu estava na cama, observando as imagens que se formavam na minha cabeça, quando apareceu um guardião sagrado que descia do céu."
,"11":"Com voz forte, ele gritou: 'Derrubai a árvore, cortai-lhe os ramos, arrancai-lhe as folhas, e atirai para longe os seus frutos. Feras, fugi da sua sombra; pássaros, fugi dos seus ramos."
,"12":"Mas deixai no chão o tronco com as raízes, ligado com correntes de ferro e bronze, no meio da erva do campo. Que ele seja banhado pelo orvalho do céu e que a erva do campo seja a sua parte com as feras do campo."
,"13":"Perderá o instinto de homem e adquirirá instinto de fera. E ficará assim durante sete anos."
,"14":"Esta é a sentença dos guardiães, é o que anunciam os santos, para que todo o ser vivo reconheça que o Altíssimo domina sobre os reinos dos homens; Ele concede o reino a quem quiser e coloca no trono o mais humilde'."
,"15":"Tal foi o sonho que tive eu, o rei Nabucodonosor. Agora, tu, Baltassar, dá-me a interpretação deste sonho. Nenhum sábio do meu reino foi capaz de me dar essa explicação, mas tu podes, porque tens o espírito dos deuses santos»."
,"16":"Daniel, que tinha também o nome de Baltassar, ficou assustado e perturbado em seus pensamentos. O rei disse-lhe: «Baltassar, não deixes que este sonho ou o seu significado te assustem». Baltassar respondeu: «Meu senhor, que o sonho seja para os vossos inimigos, que o seu significado seja para os vossos adversários. "
,"17":"Vossa Majestade viu uma árvore muito grande e forte; a sua copa atingia o céu e podia ser vista do mundo inteiro;"
,"18":"a sua folhagem era bonita e tinha frutos abundantes para alimentar o mundo todo; à sombra dela viviam as feras do campo e nos seus ramos aninhavam-se as aves do céu."
,"19":"Pois bem! Essa árvore é Vossa Majestade, tão grandioso e magnífico. O domínio de Vossa Majestade chega ao céu e o vosso império chega até aos confins do mundo."
,"20":"Vossa Majestade viu também um guardião sagrado, que descia do céu e dizia: 'Derrubai e destruí a árvore. Mas deixai no chão o tronco com as raízes ligado com uma corrente de ferro e bronze, no meio da erva do campo. Que ele seja banhado pelo orvalho do céu e que a erva do campo seja a sua parte com as feras do campo. E ficará assim durante sete anos'."
,"21":"Esta é a explicação, Majestade, e estes são os decretos do Altíssimo que atingem Vossa Majestade, meu senhor:"
,"22":"Vossa Majestade será tirado da companhia dos homens e irá morar com as feras do campo. Comerá erva como os bois e será molhado pelo orvalho. E ficará assim durante sete anos, até aprender que o Altíssimo domina sobre os reinos dos homens e dá o poder a quem Ele quer."
,"23":"Mandaram deixar o tronco com as raízes, porque Vossa Majestade voltará a reinar quando reconhecer que Deus é soberano."
,"24":"Agora dou-vos um conselho: pagai os vossos pecados com obras de justiça, e os vossos crimes socorrendo os pobres. Talvez assim a vossa felicidade possa durar»."
,"25":"Tudo isto aconteceu ao rei Nabucodonosor."
,"26":"Doze meses depois, estava ele passeando no terraço do seu palácio em Babilónia."
,"27":"Dizia: «Aí está a grande Babilónia que eu construí para moradia do rei, com o poder da minha autoridade e para esplendor da minha glória!»"
,"28":"Ele ainda estava a falar, quando uma voz do Céu lhe disse: «Rei Nabucodonosor, é a ti que falo: perderás o reino"
,"29":"e expulsar-te-ão da companhia dos homens, viverás no meio das feras do campo, comerás erva como os bois, ficarás molhado pelo orvalho e assim viverás até reconheceres que o Altíssimo é quem domina sobre os reinos dos homens e dá o poder a quem Ele quer»."
,"30":"No mesmo instante, esta palavra cumpriu-se para Nabucodonosor: ele foi retirado da companhia das pessoas, passou a comer erva como os bois. O seu corpo foi molhado pelo orvalho do céu. Os seus cabelos ficaram compridos como penas de águia e as suas unhas cresceram como garras de aves de rapina."
,"31":"«Passado o tempo, eu, Nabucodonosor, levantei os olhos para o céu e recuperei a razão. Então passei a bendizer o Altíssimo, a louvar e glorificar Aquele que vive eternamente, dizendo: 'O seu domínio é eterno e o seu reino atravessa as gerações."
,"32":"Os habitantes do mundo para Ele nada valem; Ele trata como quer os astros do céu e os habitantes do mundo. Ninguém pode atentar contra Ele ou pedir-Lhe contas do que faz'."
,"33":"Nesse momento, recuperei a razão e, para o esplendor da minha autoridade de rei, também voltaram a minha glória e majestade. Os meus conselheiros e ministros foram procurar-me, e eu fui restabelecido na minha autoridade de rei, e o meu poder ficou ainda maior."
,"34":"Agora, eu, Nabucodonosor, louvo, exalto e glorifico o Rei do céu, porque as suas obras são justas e os seus caminhos são rectos, e humilha aqueles que caminham com soberba»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"O rei Baltasar fez um grande banquete para mil altos funcionários seus e pôs-se a beber vinho na presença deles."
,"2":"Tocado pelo vinho, Baltasar mandou trazer os cálices de ouro e prata, que seu pai Nabucodonosor havia tirado do Templo de Jerusalém, para neles beberem o rei, os altos funcionários, as suas mulheres e concubinas."
,"3":"Trouxeram os cálices de ouro tirados do Templo de Jerusalém; então o rei, os altos funcionários, mulheres e concubinas começaram a beber nesses cálices."
,"4":"Bebiam vinho e louvavam os seus deuses de ouro, prata, bronze, ferro, madeira e pedra."
,"5":"De repente, surgiram dedos de mão humana que escreviam, por detrás do candelabro, na cal da parede do palácio do rei. O rei, ao ver a mão que escrevia,"
,"6":"mudou de cor; os seus pensamentos confundiram-se, a espinha desconjuntou-se e os joelhos batiam um no outro."
,"7":"Aos gritos, ele chamou os astrólogos, magos e adivinhos, e disse aos sábios da Babilónia: «Quem conseguir decifrar esta inscrição e dar a sua interpretação, vestirá o manto vermelho com o cordão de ouro ao pescoço e será a terceira autoridade do reino»."
,"8":"Chegaram todos os sábios da Babilónia, mas ninguém conseguia decifrar a inscrição nem dar a sua interpretação."
,"9":"O rei ficava cada vez mais desorientado e pálido, e os seus funcionários perdidos de susto."
,"10":"Foi então que a rainha, atraída pelos gritos do rei e funcionários, entrou na sala do banquete e disse: «Viva o rei para sempre! Que os teus pensamentos não te apavorem, nem fiques pálido!"
,"11":"Existe uma pessoa no teu reino que tem o espírito dos deuses santos: no tempo do rei teu pai, achavam que ele tinha uma luz e uma inteligência parecidas com a sabedoria dos deuses. Teu pai, o rei Nabucodonosor, fez dele o chefe dos magos, astrólogos, agoureiros e adivinhos."
,"12":"Pois bem! Já que esse Daniel, a quem o rei deu o nome de Baltassar, tem tanto espírito, conhecimento e luz para interpretar sonhos, decifrar enigmas e resolver problemas, manda-o chamar para que dê a interpretação»."
,"13":"Daniel foi levado à presença do rei, que lhe perguntou: «Então tu és Daniel, um dos judeus exilados que meu pai trouxe de Judá?"
,"14":"O que se ouve dizer é que tens o espírito dos deuses, muita luz, muita inteligência e muita sabedoria."
,"15":"Compareceram na minha presença os sábios e astrólogos para decifrarem a inscrição e descobrir-lhe o sentido, mas eles não foram capazes de mostrar o significado de coisa nenhuma."
,"16":"Ouvi dizer que és capaz de interpretar e resolver problemas. Se fores capaz de decifrar a inscrição e explicar o seu significado, vestirás o manto vermelho com o cordão de ouro ao pescoço, e serás a terceira autoridade no reino»."
,"17":"Daniel respondeu ao rei: «Fica com os teus presentes e dá a outros os teus prémios. No entanto, eu vou decifrar a inscrição e explicar o seu significado."
,"18":"O Deus Altíssimo deu império e poder, glória e honra ao teu pai Nabucodonosor."
,"19":"Por causa da grandeza que Deus lhe deu, todos os povos, nações e línguas temiam e tremiam diante dele, pois ele possuía poder sobre a vida e a morte, exaltava e humilhava conforme queria."
,"20":"Mas quando ficou com ideias de grandeza e espírito soberbo, tornando-se orgulhoso, foi derrubado do seu trono real e perdeu a dignidade:"
,"21":"foi afastado da companhia dos seres humanos e, com instinto de fera, passou a morar com burros selvagens e a alimentar-se de erva como os bois, enquanto o orvalho banhava o seu corpo. Assim ficou até reconhecer que o Deus Altíssimo domina sobre os reinos dos homens e dá o trono a quem Ele quer."
,"22":"Tu, porém, Baltasar, seu filho, mesmo sabendo de tudo isto, não te quiseste humilhar."
,"23":"Revoltaste-te contra o Senhor do céu e trouxeste os cálices do Templo, para tu, os teus funcionários, mulheres e concubinas beberdes vinho neles, louvando deuses de prata, ouro, bronze, ferro, madeira e pedra, deuses que não vêem, não ouvem e não entendem. Não glorificaste a Deus em cujas mãos está a tua vida e todo o teu caminho."
,"24":"Por isso, Deus mandou esta mão escrever isso."
,"25":"Eis o que está escrito: 'Contado, pesado, dividido'."
,"26":"A explicação é a seguinte: 'Contado': Deus contou os dias do teu reinado e já marcou o limite."
,"27":"'Pesado': Deus pesou-te na balança e faltou peso."
,"28":"'Dividido': o teu reino será dividido e entregue aos Medos e Persas»."
,"29":"Baltasar mandou vestir Daniel com o manto vermelho e colocar-lhe o cordão de ouro ao pescoço, proclamando-o terceira autoridade no reino."
,"30":"Nessa mesma noite, porém, Baltasar, rei dos Caldeus, foi morto."
}`)
	CurrentBook.AddChapter(6, `{
"1":"E Dario, o Medo, sucedeu-lhe no trono, com a idade de sessenta e dois anos."
,"2":"Dario decidiu nomear, em todo o reino, cento e vinte sátrapas com autoridade."
,"3":"Acima deles havia três ministros, aos quais os governadores deviam prestar contas, para que o rei não fosse defraudado. Um dos três era Daniel."
,"4":"Contudo, Daniel estava tão acima dos outros ministros e governadores por causa do seu talento extraordinário, que o rei decidiu dar-lhe autoridade sobre todo o império."
,"5":"Então os ministros e governadores procuraram uma oportunidade para apanharem Daniel em algum deslize nas coisas de interesse do império. Mas nada conseguiram encontrar de errado, pois ele era muito honesto, e nada conseguiram achar de incorrecto."
,"6":"Reconheceram, então: «Não encontraremos motivo algum de acusação contra Daniel, a não ser no que diz respeito à sua religião»."
,"7":"Então os ministros e governadores correram a dizer ao rei: «Viva o rei Dario para sempre!"
,"8":"Todos os ministros, prefeitos, governadores, autoridades das províncias e conselheiros estão de acordo que Vossa Majestade determine e faça um decreto segundo o qual toda a pessoa que, no prazo de trinta dias, fizer alguma prece a outro deus ou homem que não seja Vossa Majestade, tal pessoa seja lançada na cova dos leões."
,"9":"Majestade, sancionai essa lei, assinando este documento, para que não possa ser alterada ou revogada, de acordo com a legislação dos Medos e dos Persas»."
,"10":"E o rei Dario assinou o documento, sancionando a lei."
,"11":"Ao saber que o rei tinha assinado o documento, Daniel foi para casa. No andar de cima havia uma janela que dava para o lado de Jerusalém. Três vezes por dia ele ajoelhava ali para rezar e louvar o seu Deus, e assim fazia sempre."
,"12":"Aqueles homens correram até lá e encontraram Daniel a rezar e a fazer preces ao seu Deus."
,"13":"Depois foram dizer ao rei: «Vossa Majestade não assinou um decreto, segundo o qual toda a pessoa que, no prazo de trinta dias, fizer alguma prece a outro deus ou homem que não seja Vossa Majestade, tal pessoa será lançada na cova dos leões?» O rei respondeu: «A decisão é definitiva e não pode ser revogada, em conformidade com a legislação dos Medos e dos Persas»."
,"14":"Eles disseram ao rei: «Daniel, um dos exilados da Judeia, não deu importância ao decreto de Vossa Majestade, à lei que Vossa Majestade assinou, e continua a fazer as suas orações três vezes ao dia»."
,"15":"Ao ouvir essa notícia, o rei, muito pesaroso, ficou preocupado com Daniel, querendo salvá-lo. Até ao pôr do sol ficou tentando livrá-lo."
,"16":"Aqueles homens foram procurar o rei e disseram: «Vossa Majestade sabe que é lei entre os Medos e Persas que um decreto sancionado pelo rei não pode ser modificado»."
,"17":"Então o rei mandou trazer Daniel e lançá-lo na cova dos leões. E o rei disse a Daniel: «O teu Deus, a quem tu adoras, vai livrar-te»."
,"18":"Levaram uma pedra para tapar a entrada da cova. Em seguida, o rei lacrou a pedra com a sua marca e a marca dos seus secretários, para que ninguém pudesse alterar nada em favor de Daniel."
,"19":"O rei voltou para o seu palácio e ficou em jejum aquela noite; não lhe levaram as mulheres e ele perdeu o sono."
,"20":"No dia seguinte, ele levantou-se bem cedo e foi depressa à cova dos leões."
,"21":"Ao chegar à cova onde estava Daniel, o rei, aflito, gritou: «Daniel, servo do Deus vivo, o teu Deus, a quem sempre adoras, foi capaz de te livrar dos leões?»"
,"22":"Daniel disse ao rei: «Viva o rei para sempre!"
,"23":"O meu Deus mandou o seu anjo para fechar a boca dos leões, e eles não me incomodaram, pois fui considerado inocente diante d'Ele, e também nada fiz de errado contra Vossa Majestade»."
,"24":"O rei ficou contentíssimo e mandou que tirassem Daniel da cova. Quando o tiraram, não encontraram nele nenhum arranhão, pois ele confiou no seu Deus."
,"25":"Então o rei mandou trazer aqueles homens que tinham caluniado Daniel e mandou lançá-los na cova dos leões juntamente com os seus filhos e mulheres. Ainda não tinham chegado ao fundo da cova e já os leões os tinham agarrado e despedaçado."
,"26":"Então o rei Dario escreveu a todos os povos, nações e línguas da terra: «Paz e prosperidade!"
,"27":"Estou promulgando o seguinte decreto: Por toda a parte aonde chega o poder da minha autoridade de rei, todos estão obrigados a temer e respeitar o Deus de Daniel, pois Ele é o Deus vivo, que permanece para sempre; o seu reino nunca será destruído e o seu domínio não conhecerá fim."
,"28":"Ele salva e liberta, faz sinais e prodígios no céu e na terra. Ele salvou Daniel das garras dos leões»."
,"29":"Daniel teve muito sucesso, tanto no reinado de Dario, como no de Ciro, rei dos Persas."
}`)
	CurrentBook.AddChapter(7, `{
"1":"No primeiro ano de Baltasar, rei da Babilónia, Daniel teve um sonho. Escreveu imediatamente as imagens que lhe povoaram a mente enquanto dormia."
,"2":"Daniel fez o seguinte relato: Durante a noite, tive esta visão: os quatro ventos reviravam o mar imenso. "
,"3":"Quatro enormes feras surgiram do meio do mar, cada uma diferente da outra."
,"4":"A primeira parecia um leão com asas de águia. Eu estava a olhar, quando lhe arrancaram as asas, e as patas foram-se erguendo do chão: ela ficou de pé como um homem, e deram-lhe um coração humano."
,"5":"Depois apareceu uma segunda fera, que parecia um urso. Estava de pé só sobre um dos lados e tinha na boca três costelas entre os dentes. Disseram-lhe: «Vamos! Come bastante carne»."
,"6":"Depois vi uma outra fera parecida com um leopardo. Tinha no lombo quatro asas de ave e quatro cabeças. E deram-lhe o poder."
,"7":"Em seguida, tive outra visão nocturna: Vi uma quarta fera, que era medonha, terrível e muito forte. Tinha enormes dentes de ferro, com os quais comia e esmagava tudo, e calcava com os pés o que sobrava. Era diferente das outras feras, porque tinha dez chifres."
,"8":"Eu observava esses chifres, quando no meio deles apontou um outro chifre pequeno. Os três chifres que estavam mais perto deste foram arrancados para lhe ceder o lugar. Nesse chifre havia olhos humanos e uma boca que falava com arrogância."
,"9":"Eu continuava a olhar: uns tronos foram instalados e um Ancião sentou-Se, vestido de veste branca como a neve, cabelos claros como a lã. O seu trono era como labaredas de fogo, com rodas de fogo em brasa."
,"10":"Um rio de fogo brotava da frente d'Ele. Milhares e milhares O serviam e milhões estavam às suas ordens. Começou a sessão e os livros foram abertos."
,"11":"Eu continuava a olhar, atraído pelos insultos que aquele chifre gritava; vi que mataram a fera, a fizeram em pedaços e a lançaram ao fogo."
,"12":"Quanto às outras feras, foi-lhes tirado o poder, mas foi-lhes dado um prolongamento de vida até um tempo determinado."
,"13":"Em imagens nocturnas, tive esta visão: entre as nuvens do céu vinha Alguém como um filho de homem. Chegou até perto do Ancião e foi levado à sua presença."
,"14":"Foi-Lhe dado poder, glória e reino, e todos os povos, nações e línguas O serviram. O seu poder é um poder eterno, que nunca Lhe será tirado. E o seu reino é tal que jamais será destruído."
,"15":"Eu, Daniel, senti-me com o espírito perturbado dentro de mim. As visões da minha mente deixaram-me apavorado."
,"16":"Cheguei perto de um dos presentes e perguntei-lhe o que era tudo aquilo. Ele respondeu-me, dando-me a explicação completa:"
,"17":"«As quatro feras enormes são os quatro reinos que surgirão na Terra,"
,"18":"mas os santos do Altíssimo receberão o reino e possuí-lo-ão para sempre»."
,"19":"Depois eu quis saber o que significava a quarta fera, que era diferente das outras: medonha, com enormes dentes de ferro e unhas de bronze; que comia, esmagava e triturava todo o resto com os pés."
,"20":"Quis saber também o que significavam os dez chifres que havia na sua cabeça, e aquele outro chifre que apareceu e fez cair os três que lhe estavam mais perto, e que tinha olhos e uma boca que falava com arrogância e parecia maior que os outros chifres."
,"21":"Observando, vi que esse chifre fazia guerra contra os santos e os derrotava,"
,"22":"até chegar o Ancião para fazer justiça aos santos do Altíssimo. E chegou a hora, quando os santos tomaram posse do reino."
,"23":"Ele então explicou-me: «Surgirá no mundo um quarto reino, que será diferente dos outros reinos. Ele devorará o mundo inteiro e, depois, pisará e esmagará."
,"24":"Os seus dez chifres são dez reis que surgirão nesse reino, e depois deles surgirá outro rei. Ele será diferente dos dez primeiros e derrubará do trono três reis."
,"25":"Blasfemará contra o Altíssimo e perseguirá os seus santos; pretenderá modificar o calendário e a Lei de Deus. Os fiéis serão entregues nas suas mãos durante três anos e meio."
,"26":"O tribunal, porém, instalar-se-á e retirar-lhe-á o poder e esse rei será destruído e aniquilado até ao fim."
,"27":"O reino, o império e a grandeza de todos os reinos que existem debaixo do céu serão entregues ao povo dos santos do Altíssimo. O seu reino será um reino eterno, e todos os impérios o servirão e lhe prestarão obediência»."
,"28":"Aqui termina a história. Eu, Daniel, fiquei com os pensamentos perturbados, empalideci e guardei tudo na memória."
}`)
	CurrentBook.AddChapter(8, `{
"1":"No terceiro ano do reinado de Baltasar, eu, Daniel, tive uma visão, depois daquela que já havia tido."
,"2":"Observando, vi que estava em Susa, capital da província de Elam. Eu estava a olhar e vi que me encontrava junto ao rio Ulai."
,"3":"Levantei os olhos e vi junto ao rio, de pé, um carneiro. Tinha chifres altos, e um era mais alto que o outro, e esse mais alto foi o último a aparecer."
,"4":"Notei que o carneiro dava chifradas para o Poente, para o Norte e para o Sul. E nenhum animal lhe resistia. Ninguém lhe escapava, pois fazia o que queria, e aumentava sempre o seu poder."
,"5":"Pensava eu nisso, quando apareceu um bode, vindo do Poente, sobrevoando o mundo inteiro sem tocar o chão. O bode tinha um chifre bem visível entre os olhos."
,"6":"Ele veio em direcção ao carneiro de dois chifres, que eu tinha visto junto do rio Ulai, e atirou-se contra ele com toda a fúria."
,"7":"Eu vi que ele atacou o carneiro, agredindo-o furiosamente e quebrando-lhe os dois chifres. O carneiro não teve forças para resistir. Ele derrubou o carneiro ao chão, pisou-o e não houve quem livrasse o carneiro do seu poder."
,"8":"O bode cresceu muito mais ainda; porém, no auge da sua grande força, o seu grande chifre quebrou-se e, no lugar dele, brotaram quatro chifres, cada um voltado para um lado da Terra."
,"9":"De um desses chifres nasceu um chifre pequeno, que depois cresceu muito em direcção ao Sul, para o Nascente e para o lado da nossa Terra deliciosa."
,"10":"Cresceu até às alturas do exército do céu, deitou por terra algumas estrelas desse exército e calcou-as aos pés."
,"11":"Até contra o Comandante do exército do céu ele quis levantar-se, abolindo o sacrifício permanente e abalando as bases do santuário."
,"12":"Entregaram-lhe o exército e o sacrifício quotidiano e expiatório; ele deitou por terra a verdade; e tudo o que fez prosperou."
,"13":"Ouvi dois santos que conversavam. Um perguntava: «Quanto tempo vai durar a visão do sacrifício quotidiano e expiatório, do ídolo abominável, do santuário e do exército calcados aos pés?»"
,"14":"O outro respondeu: «Vai durar duas mil e trezentas tardes e manhãs. Depois será feita justiça ao santuário»."
,"15":"Eu, Daniel, estava a olhar procurando entender a visão, quando de repente apareceu de pé diante de mim a figura de um homem."
,"16":"Então, vinda do rio Ulai, ouvi uma voz que gritava: «Gabriel, explica-lhe a visão»."
,"17":"Ele dirigiu-se para o lugar onde eu estava. Quando se aproximou, eu assustei-me e caí de bruços por terra. Ele disse: «Homem, fica a saber que esta visão se refere ao tempo final»."
,"18":"Ele falava comigo e eu, desmaiado, continuava de bruços no chão. Tocou em mim e fez-me ficar de pé como estava antes."
,"19":"Depois continuou: «Eu vou explicar-te o que acontecerá no tempo final da ira, porque é do tempo final que se trata."
,"20":"O carneiro de dois chifres que viste é o reino dos Medos e dos Persas."
,"21":"O bode é o rei da Grécia, e o chifre enorme que tinha entre os olhos é o primeiro rei."
,"22":"Quebrado este, os quatro chifres que cresceram no seu lugar são os quatro reis que substituirão o primeiro, mas não com o mesmo poder."
,"23":"E, no final dos seus reinados, depois de se completarem os seus crimes, surgirá um rei ousado e esperto nas intrigas,"
,"24":"de força indomável, prodigiosamente destruidor e bem sucedido em tudo o que faz. Destruirá poderosos e também o povo dos santos."
,"25":"Com a sua astúcia, fará triunfar a fraude nas suas acções. Ele inchar-se-á de orgulho e destruirá muita gente com a surpresa. Até contra o Chefe dos chefes ele se levantará; mas, sem ninguém fazer nada, ele será destruído."
,"26":"A visão das tardes e manhãs é verdadeira; tu, porém, guardarás em segredo a visão, porque só acontecerá daqui a muito tempo»."
,"27":"Eu, Daniel, desmaiei e fiquei doente durante alguns dias. Depois, levantei-me e continuei a tratar dos assuntos do rei. Ainda estava assustado com a visão e sem poder compreendê-la."
}`)
	CurrentBook.AddChapter(9, `{
"1":"No primeiro ano do reinado de Dario, filho de Xerxes, que era da linhagem dos Medos e tinha sido colocado como rei dos Caldeus,"
,"2":"no primeiro ano do seu reinado, eu, Daniel, lia atentamente no livro das profecias de Jeremias o número dos anos que Jerusalém devia permanecer em ruínas: eram setenta anos."
,"3":"Voltei o meu olhar para o Senhor Deus, procurando fazer preces e súplicas com jejum, vestido de pano de saco e coberto de cinza."
,"4":"Então, fiz uma oração ao Senhor Deus, confessando e dizendo: «Ah! Senhor, Deus imenso e terrível, cumpridor da aliança e do amor para com os que Te amam e observam os teus mandamentos!"
,"5":"Pecámos, praticámos crimes e impiedades, fomos rebeldes e desviámo-nos dos teus mandamentos e das tuas sentenças."
,"6":"Não quisemos escutar os profetas, teus servos, que em teu Nome falavam aos nossos reis e autoridades, aos nossos pais e a todos os cidadãos."
,"7":"Senhor, do teu lado está a justiça, e a nós só resta a vergonha que hoje estamos passando, tanto o cidadão de Judá como o habitante de Jerusalém, e todo o Israel: tanto os que estão perto, como os que estão longe, por todos os países por onde os espalhaste, por causa dos crimes que praticaram contra Ti."
,"8":"Sim, ó Javé, a nós, aos nossos reis, às nossas autoridades e aos nossos pais, só resta a vergonha que estamos passando, pois pecámos contra Ti."
,"9":"Com o Senhor nosso Deus está a misericórdia e o perdão, porque nos revoltámos contra Ele."
,"10":"Não obedecemos a Javé nosso Deus, para andarmos de acordo com as leis que Ele nos deu por meio dos profetas, seus servos."
,"11":"Todo o Israel desrespeitou a tua Lei e se afastou para não Te obedecer. Então caíram sobre nós as maldições e ameaças que estão escritas na lei de Moisés, servo de Deus, pois pecámos contra o Senhor."
,"12":"Ele cumpriu as ameaças que tinha feito contra nós e nossos governantes, mandando sobre Jerusalém uma calamidade como jamais aconteceu debaixo do céu."
,"13":"Toda esta desgraça nos veio tal qual está escrita na lei de Moisés, mas nós não procurámos agradar a Javé nosso Deus, arrependendo-nos dos nossos pecados e levando a sério a sua fidelidade."
,"14":"Javé encarregou-Se desta desgraça e fê-la chegar até nós, pois Javé nosso Deus trata-nos com justiça, porque não Lhe obedecemos."
,"15":"Agora, Senhor nosso Deus, Tu que tiraste o teu povo da terra do Egipto com mão forte, criando para Ti essa fama que dura até hoje, nós pecámos e praticámos a impiedade."
,"16":"Senhor, conforme a tua justiça, afasta de Jerusalém, a tua cidade, e do teu santo monte, a ira e a cólera. Por causa dos nossos erros, por causa dos pecados dos nossos antepassados, Jerusalém e o teu povo são desprezados pelos povos vizinhos."
,"17":"Agora, Deus nosso, ouve a oração e as súplicas do teu servo e, por causa da tua honra, faz brilhar a tua face sobre o teu Templo destruído."
,"18":"Meu Deus, inclina o teu ouvido e escuta-me; abre os olhos e vê a desolação e olha para a cidade sobre a qual foi invocado o teu Nome, porque não é confiando nos actos de justiça que Te pedimos misericórdia, mas em nome da tua imensa compaixão."
,"19":"Ouve, Senhor! Perdoa, Senhor! Atende, Senhor! E começa a agir sem demora, por causa da tua honra, meu Deus, pois o teu Nome foi invocado sobre esta cidade e sobre o teu povo»."
,"20":"Eu ainda falava, fazendo a minha prece, confessando o meu pecado e do meu povo Israel; eu estava a apresentar a minha súplica a Javé meu Deus em favor do seu monte santo;"
,"21":"eu ainda estava a fazer a minha súplica, quando Gabriel, o homem que eu tinha visto no começo da visão, veio em voo rápido para perto de mim. Era a hora em que se faz a oferta da tarde."
,"22":"Ele chegou e disse-me: «Daniel, eu vim dar-te uma explicação."
,"23":"Quando começaste a tua súplica, foi pronunciada uma sentença e eu vim contar-ta, porque és querido. Presta atenção à mensagem e procura compreender a visão:"
,"24":"setenta semanas foram determinadas para o teu povo e a tua cidade santa, para fazer cessar a transgressão, selar o pecado, expiar o crime, para trazer uma justiça perene, até se realizarem a visão e a profecia e ser ungido o lugar santíssimo."
,"25":"Fica a saber: desde que foi decretado o regresso para a reconstrução de Jerusalém, até ao príncipe ungido, sete semanas se passarão. Em sessenta e duas semanas, praças e muralhas serão reconstruídas, mas em tempos difíceis."
,"26":"Depois das sessenta e duas semanas, o Ungido inocente será eliminado, e a cidade e o Templo serão destruídos por um chefe invasor que virá. O seu fim será na inundação e, até ao fim, haverá guerra e destruição."
,"27":"Com muitos ele fará uma aliança que durará uma semana e, durante meia semana, fará cessar ofertas e sacrifícios. Colocará sobre a nave do Templo o ídolo abominável, até que chegue para o destruidor o fim decretado»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"No terceiro ano de Ciro, rei da Pérsia, certa mensagem foi revelada a Daniel, que era chamado Baltassar. Era uma mensagem autêntica e falava de uma grande luta. Ele compreendeu a mensagem, graças à visão."
,"2":"Nessa ocasião, eu, Daniel, fiquei de luto durante três semanas."
,"3":"Não comi nada que tivesse algum sabor, nem carne, nem vinho entraram na minha boca, nem usei nenhum tipo de perfume durante três semanas completas."
,"4":"No vigésimo quarto dia do primeiro mês do ano, estava eu à beira do grande rio, o Tigre,"
,"5":"quando, de repente, levantei os olhos e vi: era um homem vestido de linho e que tinha à cintura um cinturão de ouro puro;"
,"6":"o seu corpo era como uma pedra preciosa e o seu rosto como um relâmpago; os seus olhos eram como lâmpadas acesas, e os seus braços e pernas tinham o brilho do bronze polido; a sua voz parecia o clamor de grande multidão."
,"7":"Só eu, Daniel, vi a aparição. Os outros que estavam comigo não viram nada; mesmo assim, caiu sobre eles um medo tão grande que fugiram para se esconderem."
,"8":"Fiquei sozinho. Ao ver essa magnífica aparição, senti-me desfalecer, o meu rosto empalideceu e eu não conseguia controlar-me."
,"9":"Ouvi o som de palavras e, ao ouvi-lo, caí sem sentidos com o rosto por terra."
,"10":"A mão de alguém tocou-me e sacudiu-me, fazendo-me ficar de joelhos, com a palma das mãos no chão."
,"11":"Ele disse-me: «Daniel, homem querido, procura entender a mensagem que te vou transmitir. Fica de pé, pois foi Deus que me enviou a ti». Ele falou e eu levantei-me a tremer."
,"12":"Ele continuou: «Daniel, não tenhas medo, pois desde o primeiro dia em que começaste a meditar para entender e te humilhaste diante de Deus, as tuas palavras foram ouvidas, e é por causa delas que eu vim."
,"13":"Durante vinte e um dias o príncipe dos reis da Pérsia resistiu-me, porém Miguel, um dos príncipes supremos, veio em minha ajuda. Eu deixei-o lá a enfrentar os reis da Pérsia,"
,"14":"e vim explicar-te o que acontecerá ao teu povo nos últimos dias, pois ainda existe para esses dias uma visão»."
,"15":"Enquanto ele me dizia estas coisas, caí de bruços e fiquei sem fala."
,"16":"Alguém com aparência de um ser humano tocou os meus lábios. Abri a boca e disse àquele que estava à minha frente: «Meu senhor, a visão fez-me contorcer de dor e não consegui dominar-me."
,"17":"Como poderia falar o servo do meu senhor, se as minhas forças tinham desaparecido e eu até tinha perdido o fôlego?»"
,"18":"De novo, alguém semelhante a um homem tocou-me e deu-me forças."
,"19":"Ele disse-me: «Não tenhas medo, homem querido. Tem calma e sê forte». Enquanto ele falava comigo, eu senti-me mais forte e disse: «Fale então o meu senhor que me devolveu as forças»."
,"20":"Ele disse: «Muito bem! Sabes para que te vim procurar? Agora devo voltar para combater contra o príncipe da Pérsia. Quando terminar, o príncipe da Grécia chegará."
,"21":"Vou contar-te o que está escrito no livro da verdade. Ninguém me ajuda na luta contra eles, a não ser Miguel, o vosso príncipe,"
}`)
	CurrentBook.AddChapter(11, `{
"1":"assim como eu estive ao lado dele, dando-lhe força e ajudando-o no primeiro ano do reinado de Dario."
,"2":"Agora vou contar-te a verdade. Ainda surgirão três reis na Pérsia, mas o quarto rei que virá depois será o mais rico de todos e empregará toda a sua força e toda a sua riqueza contra os reis da Grécia."
,"3":"Depois aparecerá um rei guerreiro, que terá um grande império e poder absoluto."
,"4":"Logo, porém, que ele surgir, o seu império será dividido e repartido pelos quatro ventos da terra. Os seus descendentes não herdarão o seu império, nem será tão poderoso; o seu império cairá em mãos alheias."
,"5":"O rei do Sul será forte, mas um dos seus generais ficará mais forte do que ele e terá um império maior que o dele."
,"6":"Depois de alguns anos, os dois farão aliança e a filha do rei do Sul casar-se-á com o rei do Norte, para confirmar acordos. Mas ela não será capaz de sustentar a própria força nem a do seu filho, e acabará derrotada com a sua comitiva, com o seu filho e com o marido que ia dar-lhe força. A seu tempo, porém,"
,"7":"surgirá das suas raízes um rebento que ficará no lugar do seu marido. Ele irá com o exército até ao esconderijo do rei do Norte, e vai tratá-lo com dureza."
,"8":"Até os seus deuses, as suas estátuas com os seus objectos preciosos de ouro e prata, ele os levará como troféu para o Egipto. Depois, durante alguns anos, deixará em paz o rei do Norte."
,"9":"Este tentará invadir o reino do rei do Sul, mas será obrigado a voltar para a sua terra."
,"10":"Contudo os filhos do rei do Norte vão armar-se, reunindo grande e forte exército, e um deles avançará, passando como uma enchente; e voltará a lutar contra o rei do Sul na própria fortaleza deste."
,"11":"E, despeitado, o rei do Sul sairá para lutar contra ele. O rei do Norte procurará resistir com numeroso exército, mas toda essa multidão cairá em poder do rei do Sul."
,"12":"Depois de dominar tanta gente, ele ficará com ideias de grandeza. Mas, apesar de vencer tanta gente, ficará sem forças."
,"13":"O rei do Norte reunirá outro exército mais numeroso ainda, e no final de algum tempo, alguns anos, virá com imenso poderio e muitos recursos."
,"14":"Durante esse tempo, muitos quererão enfrentar o rei do Sul, até mesmo alguns indivíduos mais violentos do vosso povo. Vão querer revoltar-se, pensando estar a cumprir a profecia, mas fracassarão."
,"15":"Então virá o rei do Norte, fará um aterro e tomará a cidade cercada de muralhas. As forças do Sul não poderão resistir, nem as tropas escolhidas; faltarão forças para resistir."
,"16":"Depois da invasão, o rei do Norte fará o que bem quiser e ninguém será capaz de lhe opor resistência. Ele estabelecer-se-á na nossa Terra deliciosa, que será completamente sua."
,"17":"O rei do Norte terá em mente conquistar todo o reino do Sul. Fará um acordo com o rei do Sul e, para tentar arruiná-lo, dar-lhe-á a sua filha em casamento. Mas o projecto não terá êxito."
,"18":"Ele voltar-se-á, então, contra as cidades do litoral e conquistará muitas delas. Contudo, um chefe porá fim à sua arrogância, sem que ele seja capaz de responder."
,"19":"Então ele voltar-se-á para o lado das fortalezas do seu próprio país, mas tropeçará e desaparecerá."
,"20":"No seu lugar surgirá outro rei, que vai mandar um cobrador para requisitar o tesouro do Templo. Mas, depois de alguns dias, será derrotado sem ira e sem guerra."
,"21":"Em seu lugar, sucederá um miserável, a quem não se dariam as honras da realeza. Mas virá sorrateiramente e, com intrigas, tomará o poder."
,"22":"Varrerá exércitos inimigos, aniquilando-os, e vencendo também o príncipe da Aliança."
,"23":"Embora dispondo de pouca gente, com os seus cúmplices e à força de traições, pouco a pouco tornar-se-á forte."
,"24":"Sorrateiramente entrará nas regiões mais férteis da província, fazendo o que nem os seus pais nem os seus avós fizeram: entre os seus amigos repartirá os saques, despojos e riquezas e, com tramas, atacará as fortalezas. Mas isso vai durar pouco tempo."
,"25":"Em seguida, contando com grande exército, atacará o rei do Sul. Este preparar-se-á para a guerra com um exército muito grande e muito forte, mas não poderá resistir, porque cairá vítima de conspirações:"
,"26":"os mais íntimos, que comem com ele, é que o derrotarão. O seu exército será arrasado, e muitos morrerão."
,"27":"Os dois reis, com o pensamento voltado para a prática do mal, sentar-se-ão à mesa para dizerem mentiras; no entanto, não vão conseguir nada, porque o fim vai esperá-los no prazo marcado."
,"28":"Depois o rei do Norte voltará para a sua terra com muitas riquezas. O seu pensamento estará voltado contra a santa Aliança. Depois de fazer o que planeava, voltará para a sua terra."
,"29":"No prazo marcado ele invadirá novamente o Sul, mas desta vez não será como da primeira."
,"30":"Os navios de Cetim irão contra ele, ficará com medo e recuará para descarregar a sua cólera contra a santa Aliança. Ele favorecerá os que abandonaram a santa Aliança."
,"31":"As tropas enviadas por ele pôr-se-ão em guerra e profanarão o santuário da fortaleza. Abolirão o sacrifício quotidiano e instalarão um ídolo abominável."
,"32":"Com lisonjas, perverterá os que violam a Aliança, mas o povo dos que reconhecem o seu Deus agirá com firmeza."
,"33":"Os mais conscientes entre o povo esclarecerão muita gente, mas acabarão mortos pela espada, nas fogueiras, castigados com a prisão e o confisco dos seus bens, por um período bem longo."
,"34":"Quando caírem na desgraça, poucos serão os que virão ajudá-los, e muitos se juntarão a eles por adulação."
,"35":"A desgraça de algumas dessas pessoas esclarecidas servirá para purificar, lavar e branquear, até que chegue o fim, pois o prazo está marcado."
,"36":"Esse rei fará o que bem entender: ele engrandecer-se-á e exaltar-se-á acima de todos os deuses, e dirá coisas arrogantes até mesmo contra o Deus dos deuses. Terá sucesso até à hora da vingança, porque o que está marcado cumprir-se-á."
,"37":"Ele não respeitará o deus de seus pais, nem o deus favorito das mulheres, nem qualquer outro deus, pois julgar-se-á superior a todos eles."
,"38":"No lugar desses deuses, ele prestará culto ao deus das fortalezas. A esses deuses que os seus pais não conheceram, ele oferecerá ouro, prata, pedras preciosas e jóias."
,"39":"Para reforçar as suas fortalezas, estabelecerá o povo desse deus estrangeiro. A esses preferidos seus vai enriquecê-los muito, vai dar-lhes autoridade sobre muita gente e entre eles repartirá terras como recompensa."
,"40":"No tempo final, o rei do Sul pretenderá lutar contra o rei do Norte, mas o rei do Norte lançar-se-á contra ele com carros de guerra, cavalos e numerosos navios, invadindo as suas terras como uma enchente."
,"41":"Invadirá também a nossa Terra deliciosa, e muita gente vai morrer. Escaparão das suas mãos os edomitas, os moabitas e um resto dos amonitas."
,"42":"Ele deitará a mão a todos os países, e nem o Egipto lhe escapará."
,"43":"Passará a ser dono das riquezas em ouro e prata e de tudo o que houver de mais valioso no Egipto. Até os líbios e etíopes formarão a sua comitiva."
,"44":"Contudo, notícias chegadas do Oriente e do Norte virão assustá-lo. Ele pôr-se-á em marcha, cheio de fúria e raiva, para matar e liquidar muita gente."
,"45":"Armará as tendas da sua nobre residência entre o mar e a deliciosa montanha santa. Então chegará o fim, e ninguém o defenderá."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Naquele tempo surgirá Miguel, o grande príncipe que protege o povo ao qual pertences: será uma hora de grandes aflições, tais como jamais houve, desde que as nações começaram a existir até ao tempo actual. Então o teu povo será salvo, todos os que estiverem inscritos no livro."
,"2":"Muitos que dormem no pó despertarão: uns para a vida eterna, outros para a vergonha e a infâmia eternas."
,"3":"Os sábios brilharão como brilha o firmamento, e os que tiverem levado muitos aos caminhos da justiça brilharão para sempre como estrelas."
,"4":"Tu, Daniel, guarda em segredo esta mensagem, lacra este livro até ao tempo final. Muitos o examinarão, e o seu conhecimento aumentará»."
,"5":"Eu, Daniel, vi também outros dois homens de pé, à beira do rio, um do lado de cá e o outro do lado de lá."
,"6":"Um deles disse ao homem vestido de linho que estava sobre as águas do rio: «Quando se realizarão essas coisas maravilhosas?»"
,"7":"Ouvi o homem vestido de linho que estava sobre as águas do rio. Ele levantou as duas mãos e jurou por Aquele que vive eternamente: «Daqui a um ano e dois anos e meio. Quando acabar a opressão do povo santo, então é que se realizará tudo isto»."
,"8":"Eu ouvi, mas não entendi. E perguntei: «Meu senhor, como é que tudo isto vai terminar?»"
,"9":"Ele respondeu: «Vai, Daniel! Esta mensagem ficará guardada e lacrada até ao tempo final."
,"10":"Muitos ainda serão separados, limpos e expurgados, enquanto os ímpios continuarão a praticar a injustiça. Os ímpios não entenderão estas coisas, mas os sábios compreendê-las-ão."
,"11":"A partir do dia em que acabar o sacrifício quotidiano e for instalado no Templo o ídolo abominável, passarão mil duzentos e noventa dias."
,"12":"Feliz quem souber esperar com perseverança, alcançando mil trezentos e trinta e cinco dias."
,"13":"Quanto a ti, segue em frente até que chegue o teu fim e repouses: tu levantar-te-ás para receber a tua parte no final dos dias»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Havia um morador de Babilónia chamado Joaquim."
,"2":"Ele tinha casado com uma mulher de nome Susana, filha de Helcias, que era muito bonita e muito religiosa."
,"3":"Os seus pais eram gente recta e tinham instruído a filha na lei de Moisés."
,"4":"Joaquim era muito rico e tinha um grande jardim ao lado da sua casa. Os judeus costumavam reunir-se ali, porque Joaquim era o mais respeitado de todos eles."
,"5":"Nesse ano, tinham sido nomeados dois juízes, chefes de família conselheiros do povo, aos quais se aplicava a Palavra do Senhor: «A injustiça brotou na Babilónia, vinda dos velhos juízes que passam por guias do povo»."
,"6":"Eles frequentavam a casa de Joaquim e era aí que as pessoas iam procurá-los quando tinham alguma coisa para resolver."
,"7":"Depois de o povo se ter ido embora, por volta do meio-dia, Susana saía para passear no jardim do seu marido."
,"8":"Todos os dias, os dois anciãos viam Susana sair e dar o seu passeio. Foi assim que começaram a cobiçá-la."
,"9":"Eles procuraram desviar o próprio pensamento para não olhar o Céu nem se lembrarem dos seus justos julgamentos."
,"10":"Os dois estavam totalmente apaixonados por ela, mas um não contava ao outro a sua paixão,"
,"11":"pois tinham vergonha de falar dos seus próprios desejos de manter relações sexuais com ela."
,"12":"Todos os dias ficavam esperando ansiosamente a hora em que ela passeava."
,"13":"Um dia disseram um ao outro: «Vamos para casa, que já é hora do almoço». Saíram e cada um foi para seu lado."
,"14":"Mas, logo em seguida, deram meia-volta e encontraram-se de novo no mesmo lugar. Então foram obrigados a revelar um ao outro o motivo por que tinham voltado, e acabaram por confessar a sua paixão. A partir daí, combinaram procurar juntos uma boa oportunidade em que pudessem encontrar Susana sozinha."
,"15":"Ambos esperavam uma ocasião oportuna, quando um dia ela saiu só com duas empregadas, como nos outros dias, e teve vontade de tomar banho no jardim, porque fazia muito calor."
,"16":"Não havia mais ninguém, a não ser os dois anciãos que estavam escondidos, a observar Susana."
,"17":"Ela disse às empregadas: «Trazei-me óleo e perfume e fechai as portas do jardim, que eu vou tomar banho»."
,"18":"Fazendo o que a patroa tinha dito, as empregadas fecharam os portões do jardim e saíram por uma porta lateral, a fim de irem buscar o que lhes tinha sido mandado, sem verem os dois anciãos que estavam bem escondidos."
,"19":"Logo que as empregadas saíram, os dois homens deixaram o esconderijo, foram ao encontro de Susana e"
,"20":"disseram-lhe: «Os portões do jardim estão fechados e ninguém nos vê. Nós desejamos-te. Aceita e entrega-te a nós."
,"21":"Se não aceitares vamos acusar-te, dizendo que um jovem estava aqui contigo e que foi por isso que mandaste embora as empregadas»."
,"22":"Susana deu um suspiro e disse: «A coisa está complicada para mim de todos os lados: se eu fizer isso, estou condenada à morte; se o não fizer, sei que não conseguirei escapar das vossas mãos."
,"23":"Mas eu prefiro dizer 'Não!' e cair nas vossas mãos do que cometer um pecado contra Deus»."
,"24":"Em seguida, ela gritou bem forte, mas os dois anciãos também gritaram contra ela."
,"25":"Um deles correu a abrir os portões do jardim."
,"26":"As pessoas da casa, ao ouvirem os gritos no jardim, entraram a correr pela porta lateral, para ver o que tinha acontecido a Susana."
,"27":"Então os dois anciãos contaram a sua história. Os empregados coraram de vergonha, porque nunca se tinha ouvido dizer uma coisa dessas contra Susana."
,"28":"No outro dia, quando o povo se reuniu na casa de Joaquim, seu marido, os dois anciãos chegaram com a cabeça cheia de planos malvados contra Susana, a fim de a condenarem à morte."
,"29":"Na presença do povo, disseram: «Chamai Susana, a filha de Helcias, mulher de Joaquim». Foram buscá-la."
,"30":"Ela chegou, e com ela chegaram também os seus pais, os seus filhos e todos os seus parentes."
,"31":"Ela era mulher muito delicada e bonita."
,"32":"Aqueles malvados mandaram-lhe tirar o véu, pois Susana estava com o rosto coberto, só para poderem inebriar-se com a sua beleza."
,"33":"Toda a sua família e todos os que a viam começaram a chorar."
,"34":"Os dois anciãos levantaram-se no meio do povo e puseram as mãos sobre a cabeça de Susana."
,"35":"Chorando, ela olhava para o céu, pois o seu coração confiava no Senhor."
,"36":"Os dois anciãos disseram: «Nós andávamos a passear a sós pelo jardim, quando chegou Susana com duas empregadas. Depois, ela fechou os portões do jardim e mandou as empregadas embora."
,"37":"Então um jovem foi ao seu encontro e deitou-se com ela."
,"38":"Estávamos num canto do jardim e, ao ver essa imoralidade, corremos para junto deles."
,"39":"Vimos os dois agarrados um ao outro, mas não pudemos segurar o jovem, que era mais forte do que nós. Ele conseguiu abrir o portão e fugir."
,"40":"Segurámos Susana e perguntámos-lhe quem era o jovem,"
,"41":"mas ela não quis dizer-nos. É este o nosso depoimento». A assembleia acreditou neles, porque eram anciãos e juízes do povo, e condenou Susana à morte."
,"42":"Então Susana disse em alta voz: «Deus eterno, que conheces o que está escondido e tudo vês antes que aconteça,"
,"43":"Tu sabes muito bem que eles deram falso testemunho contra mim. Vou morrer sem ter feito nada daquilo de que me acusam»."
,"44":"O Senhor atendeu o seu clamor:"
,"45":"ao ser conduzida para a morte, o Senhor despertou o santo espírito de um jovem de nome Daniel."
,"46":"Ele gritou forte: «Eu não tenho nada a ver com a morte dessa mulher. Estou inocente»."
,"47":"Todo o povo se voltou para ele. E perguntaram-lhe: «O que é que queres dizer com isso?»"
,"48":"De pé, no meio deles, Daniel disse: «Como sois idiotas, israelitas! Sem julgamento e sem uma ideia clara, acabastes de condenar à morte uma israelita!"
,"49":"Voltai para o tribunal, porque foi falso o testemunho desses homens contra ela»."
,"50":"Todo o povo se apressou a voltar para trás. Os senhores do Conselho, chefes de família, disseram a Daniel: «Por favor! Senta-te aqui connosco para nos explicares melhor tudo isso, pois Deus já te deu maturidade»."
,"51":"Daniel disse: «Afastai-os um do outro, que eu vou interrogá-los»."
,"52":"Depois de os terem separado um do outro, Daniel disse a um deles: «Homem envelhecido em anos e crimes, agora os teus pecados vão aparecer e tudo o que cometeste outrora,"
,"53":"quando davas sentenças injustas, condenando os inocentes e deixando livres os culpados. O Senhor diz: 'Cuidado para não condenares à morte o inocente e o justo'."
,"54":"Se realmente os viste, diz-me: debaixo de que árvore os viste abraçados?» Ele respondeu: «Debaixo de um lentisco»."
,"55":"Daniel disse: «Muito bem! Já mentiste e pagarás com a tua própria cabeça. O anjo de Deus já recebeu ordem de te rachar ao meio»."
,"56":"Depois de o mandar embora, Daniel pediu para trazerem o outro. E disse-lhe: «Raça de Canaã, e não de Judá, a beleza da mulher fez-te perder o rumo, a paixão confundiu o teu coração."
,"57":"Vós fazíeis isto com as mulheres de Israel, e elas, por medo, entregavam-se a vós; mas esta filha de Judá resistiu à vossa imoralidade."
,"58":"Diz-me: debaixo de que árvore os viste abraçados?» Ele respondeu: «Debaixo de um carvalho»."
,"59":"Daniel disse: «Acabas de mentir e pagarás com a tua própria cabeça. Com a espada na mão, o anjo de Deus está pronto para te rachar ao meio e acabar contigo»."
,"60":"Toda a assembleia começou a aclamar, dando louvores a Deus que salva os que n'Ele confiam."
,"61":"Depois, todos se ergueram contra os dois anciãos, pois pelas suas próprias bocas Daniel tinha provado que eles estavam a mentir. Fizeram-lhes o mesmo que eles queriam fazer a Susana,"
,"62":"de acordo com a Lei de Moisés. E foi assim que, naquele dia, os condenaram à morte e salvaram uma pessoa inocente."
,"63":"Por causa da sua filha Susana, Helcias e a sua mulher, juntamente com Joaquim, seu marido, e todos os parentes, puseram-se a louvar a Deus, pois nada de indecente encontraram nela."
,"64":"E, desde esse dia, Daniel gozou de grande prestígio entre o povo."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Quando rei Astíages foi colocado no sepulcro da família, Ciro, o persa, sucedeu-lhe no trono."
,"2":"Daniel era companheiro do rei e o mais íntimo dos seus amigos."
,"3":"Os babilónios tinham um ídolo chamado Bel. Com ele, gastavam todos os dias doze sacas da melhor farinha de trigo, quarenta ovelhas e seis ânforas de vinho."
,"4":"O rei adorava esse ídolo e todos os dias lhe prestava culto. Daniel, ao contrário, só adorava o seu próprio Deus."
,"5":"Um dia o rei perguntou-lhe: «Porque é que não prestas culto a Bel?» Daniel respondeu: «Porque não adoro imagens fabricadas pelo homem, mas só ao Deus vivo que criou o Céu e a Terra e é Senhor de todo o ser vivo»."
,"6":"O rei disse: «E achas que Bel não é um deus vivo? Não vês quantas coisas ele come e bebe todos os dias?»"
,"7":"Daniel sorriu e disse: «Não vos deixeis enganar, Majestade! Por dentro Bel é de barro e por fora é de bronze; ele nunca comeu ou bebeu coisa alguma»."
,"8":"Furioso, o rei mandou chamar os sacerdotes de Bel e disse-lhes: «Se não me disserdes quem come toda essa comida, morrereis. Se me provardes que é Bel quem come tudo isso, então Daniel morrerá, por ter dito uma blasfémia contra o deus Bel»."
,"9":"Daniel disse ao rei: «Faremos o que Vossa Majestade diz». Eram setenta os sacerdotes de Bel, sem contar as mulheres e crianças."
,"10":"O rei foi com Daniel ao templo de Bel."
,"11":"Os sacerdotes de Bel disseram ao rei: «Nós retiramo-nos para fora do templo e Vossa Majestade deposita lá a comida e o vinho, e depois fecha a porta do templo, lacrando-a com o carimbo do seu anel. No dia seguinte, se ao voltar ao templo Vossa Majestade não encontrar tudo comido por Bel, estaremos prontos para morrer. De contrário, Daniel é que morrerá, por nos ter caluniado»."
,"12":"Eles estavam muito seguros, porque tinham feito uma entrada secreta por baixo da mesa, por onde eles entravam para comer os alimentos."
,"13":"Depois de eles terem saído, o rei colocou os alimentos diante do deus Bel."
,"14":"Daniel mandou aos seus empregados que trouxessem cinza e a espalhassem por todo o templo, à vista apenas do rei. Saíram, fecharam a porta, puseram o lacre com o carimbo do anel do rei e foram-se embora."
,"15":"À noite, como de costume, foram os sacerdotes com as suas mulheres e os filhos e comeram e beberam tudo."
,"16":"No outro dia, o rei e Daniel foram de madrugada à porta do templo."
,"17":"O rei perguntou a Daniel: «O lacre está intacto?» Daniel respondeu: «Está intacto, Majestade»."
,"18":"Logo que abriram as portas, o rei olhou para a mesa e exclamou: «Tu és grande, Bel! Em ti não existe nenhum engano»."
,"19":"Daniel apenas sorriu; deteve o rei para que não entrasse e disse-lhe: «Olhai para o pavimento e procurai descobrir de quem são estas pegadas»."
,"20":"O rei disse: «Vejo pegadas de homens, mulheres e crianças!»"
,"21":"Irado, o rei mandou trazer presos os sacerdotes com as mulheres e crianças, e eles tiveram que lhe mostrar a passagem secreta por onde entravam para comer o que estava sobre a mesa."
,"22":"Depois o rei mandou matá-los e entregou o ídolo a Daniel, que o destruiu juntamente com o seu templo."
,"23":"Havia um dragão enorme adorado pelos babilónios."
,"24":"O rei disse a Daniel: «Não podes dizer que é de bronze, porque está vivo, come e bebe. Não podes negar que seja um deus vivo. Então, adora-o também»."
,"25":"Daniel respondeu: «Só adoro ao Senhor meu Deus, porque Ele é o Deus vivo. Se Vossa Majestade permitir, eu mato este dragão sem es-pada e sem bastão»."
,"26":"O rei disse: «A licença está concedida»."
,"27":"Daniel pegou em pez, sebo e crinas, mandou co-zer tudo junto; com isso preparou bolos e atirou-os para a boca do dragão, o qual engoliu aquilo e rebentou. Então Daniel disse: «Aí está o que vós adorais!»"
,"28":"Quando os babilónios ouviram falar disso, ficaram muito indignados e revoltados contra o rei, e diziam: «O rei tornou-se judeu! Destruiu Bel, matou o dragão e assassinou os sacerdotes»."
,"29":"E foram dizer ao rei: «Entregai-nos Daniel, senão nós matamos Vossa Majestade com toda a sua família»."
,"30":"O rei sentiu que a pressão era muita e, forçado, entregou-lhes Daniel."
,"31":"Eles lançaram Daniel na cova dos leões, onde ficou seis dias."
,"32":"Nessa cova havia sete leões e, todos os dias, davam-lhes dois condenados e duas ovelhas. Nessa ocasião, não lhes deram nada, para que devorassem Daniel."
,"33":"Na Judeia vivia o profeta Habacuc. Ele preparou uma sopa, migou pão numa gamela e ia para o campo levá-la aos ceifeiros."
,"34":"O anjo do Senhor disse a Habacuc: «Esse almoço leva-o a Daniel, que está na Babilónia, na cova dos leões»."
,"35":"Habacuc disse: «Meu senhor, eu nunca vi Babilónia, nem conheço essa cova!»"
,"36":"O anjo do Senhor agarrou-o pelo alto da cabeça, levou-o pelos cabelos e, com a rapidez do vento, colocou-o à beira da cova."
,"37":"Habacuc gritou: «Daniel, Daniel! Toma o almoço que Deus te mandou»."
,"38":"Daniel disse: «Tu lembraste-Te de mim, ó Deus, e nunca abandonas aqueles que Te amam»."
,"39":"Então Daniel pegou no almoço e comeu. Imediatamente o anjo do Senhor levou Habacuc de novo para o mesmo lugar onde estava antes."
,"40":"No sétimo dia, o rei foi chorar a morte de Daniel. Chegou junto da cova e lá estava Daniel sentado tranquilamente."
,"41":"Então o rei exclamou em alta voz: «Tu és grande, ó Senhor, Deus de Daniel! Além de Ti não existe outro Deus»."
,"42":"O rei mandou retirar Daniel da cova e lançou nela aqueles que pretendiam matá-lo. Foram devorados num instante, na presença do rei."
}`)

}
func PT_BS_LoadVMEZChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No dia cinco do quarto mês do ano trinta, estando eu com os exilados à beira do rio Cobar, de repente abriram-se os céus e eu tive visões divinas."
,"2":"No dia cinco do mês, no ano cinco do exílio do rei Jeconias,"
,"3":"a palavra de Javé foi dirigida ao sacerdote Ezequiel, filho de Buzi, no país dos caldeus, nas margens do rio Cobar. Ali Javé colocou a mão sobre ele."
,"4":"Eu vi o seguinte: Do lado Norte soprava um forte vento. Foi então que vi uma grande nuvem e um turbilhão de fogo. Havia claridade em torno da nuvem e, no centro, um brilho faiscante, no meio do fogo."
,"5":"Do meio da nuvem surgiu algo parecido com quatro animais, e cada um lembrava também uma forma humana."
,"6":"Cada um tinha quatro rostos e quatro asas."
,"7":"As suas pernas eram direitas e os seus cascos pareciam cascos de boi, só que eram brilhantes como bronze polido."
,"8":"De baixo das asas saíam mãos humanas nos quatro lados. Os seus rostos e asas também estavam voltados para as quatro direcções."
,"9":"A asa de cada um encostava-se à asa do outro. Ao movimentarem-se, eles não se viravam, mas cada um ia em frente."
,"10":"O rosto deles era parecido com o rosto de um homem. Do lado direito tinham aparências de leão, e do lado esquerdo tinham aparência de touro. Os quatro tinham também aparência de águia."
,"11":"As asas abriam-se para cima. Duas chegavam a encostar-se à asa do outro, e duas cobriam o corpo."
,"12":"Todos caminhavam em frente, seguindo a direcção para a qual o vento os conduzia. Enquanto avançavam, nunca se voltavam para os lados."
,"13":"No meio dos animais havia uma coisa parecida com brasas acesas, ardendo como uma tocha. Esse fogo movia-se entre os quatro animais, era brilhante, e dele saíam relâmpagos."
,"14":"Os animais, no seu vaivém, pareciam relâmpagos."
,"15":"Observando, vi uma roda no chão, ao lado de cada um dos quatro animais."
,"16":"No aspecto e estrutura, as rodas tinham o brilho do topázio. O formato de uma era o formato das quatro; o seu aspecto e estrutura era como se uma roda estivesse no meio da outra."
,"17":"Rodavam para os quatro lados sem precisarem de se virar."
,"18":"O seu aro era muito grande e estava cheio de olhos em toda a volta. E isto nas quatro rodas."
,"19":"Quando os animais se moviam, as rodas moviam-se juntamente com eles; quando os animais se levantavam, as rodas também se levantavam."
,"20":"Na direcção para onde ia o vento, iam as rodas. Elas subiam juntamente com os animais, porque o espírito dos animais estava nas rodas."
,"21":"Quando os animais andavam, as rodas andavam também; quando os animais paravam, as rodas também paravam; quando eles se levantavam do chão, as rodas também se levantavam, porque o espírito dos animais estava nas rodas."
,"22":"Por cima da cabeça dos animais havia uma coisa parecida com uma cúpula de cristal brilhante, estendida por cima da cabeça dos animais."
,"23":"Sob a cúpula, as suas asas ficavam voltadas uma para a outra, e cada animal tinha as suas asas a cobrir-lhe o corpo."
,"24":"O barulho das suas asas, que eu ouvi, parecia o estrondo de águas torrenciais, como a voz do Todo-poderoso. Quando se moviam, ouvia-se um barulho como de tempestade, como de acampamento. E quando paravam, baixavam as asas."
,"25":"Ouviu-se um barulho."
,"26":"Por cima da cúpula que ficava sobre as cabeças dos animais havia algo parecido com uma pedra de safira, em forma de trono; e nele, lá no alto, algo parecido com um ser humano."
,"27":"Vi em volta dele uma coisa como brilho faiscante, semelhante a fogo, bem junto dele. Daquilo que parecia ser a cintura para cima, e também para baixo, havia algo brilhante como fogo, em toda a volta."
,"28":"Esse brilho em torno dele parecia o arco-íris, que aparece nas nuvens em dia de chuva. Era a aparência visível da glória de Javé. Quando o vi, caí imediatamente com o rosto no chão, e ouvi a voz de Alguém que falava comigo."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ele disse-me: «Criatura humana, põe-te de pé, que vou falar contigo»."
,"2":"Logo que Ele me falou assim, entrou em mim um espírito que me fez ficar de pé. Então pude ouvir Aquele que falava comigo."
,"3":"Ele disse-me: «Criatura humana, vou mandar-te a Israel, a esse povo rebelde, que se rebelou contra Mim. Eles e os seus antepassados revoltaram-se contra Mim até ao dia de hoje."
,"4":"Os filhos são arrogantes e têm coração de pedra. Eu envio-te a eles, e falar-lhes-ás da seguinte forma: Assim diz o Senhor Javé."
,"5":"Quer te escutem quer não, porque são uma casa de rebeldes, ficarão a saber que existe um profeta aqui no meio deles."
,"6":"Criatura humana, não tenhas medo deles, nem das suas palavras. Mesmo quando ficares rodeado de espinhos e te sentares em cima de escorpiões, não fiques com medo das suas palavras, nem te assustes com a cara deles, porque são uma casa de rebeldes."
,"7":"Quer te escutem quer não, continuarás a transmitir-lhes a minha palavra, porque são uma casa de rebeldes."
,"8":"Mas tu, criatura humana, obedece ao que te vou dizer. Não sejas rebelde como essa casa de rebeldes. Abre a boca e come o que te vou dar»."
,"9":"Então notei que certa mão se estendia para mim com um rolo de pergaminho."
,"10":"A mão desenrolou o pergaminho diante de mim: estava escrito por dentro e por fora, e o que nele estava escrito eram lamentações, gemidos e gritos de dor."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ele disse-me: «Criatura humana, come isto; come este rolo, e depois vai levar a mensagem à casa de Israel»."
,"2":"Então abri a boca e Ele deu-me o rolo a comer."
,"3":"E continuou: «Criatura humana, que o teu estômago e a tua barriga se saciem com este rolo escrito que agora te dou». Eu comi e pareceu doce como mel ao meu paladar."
,"4":"Depois Ele tornou a falar: «Criatura humana, vai procurar a casa de Israel e leva-lhe a minha mensagem."
,"5":"Não é a um povo de idioma estranho ou de língua difícil que és enviado, mas à casa de Israel."
,"6":"Não é também a povos numerosos de idioma estranho e língua difícil, cujas palavras não entenderias. Se fosse a eles que Eu te enviasse, certamente que te ouviriam,"
,"7":"mas a casa de Israel não te ouvirá, porque não Me querem ouvir. Têm a cabeça dura e o coração de pedra."
,"8":"Em compensação, eu farei com que o teu rosto fique duro como o deles, e a tua cabeça dura como a deles."
,"9":"Eu farei que a tua cabeça seja dura como diamante, que é mais duro do que a pedra, para não teres medo deles, nem te assustares com a cara deles, embora sejam uma casa de rebeldes»."
,"10":"Ele disse-me ainda: «Criatura humana, ouve atentamente todas as palavras que te vou dizer, e guarda-as na memória."
,"11":"Depois procura os exilados, a gente do teu povo, e diz-lhes: Assim diz o Senhor Javé, quer queirais ouvir quer não»."
,"12":"Depois o espírito ergueu-me, e ouvi atrás de mim o barulho de um estrondo muito grande, enquanto a glória de Javé deixava o lugar e subia para o alto."
,"13":"O barulho desse grande estrondo era provocado pelas asas dos animais, que batiam umas nas outras, e também pelas rodas que estavam junto deles. Era como o estrondo de um grande terremoto."
,"14":"O espírito ergueu-me e arrebatou-me. Eu fui, amargurado e irritado, pois a mão de Javé pesava sobre mim."
,"15":"Cheguei aonde estavam os exilados de Tel Abib, que moravam nas margens do rio Cobar. Fiquei ali sentado sete dias, atordoado no meio deles."
,"16":"Passados sete dias, recebi esta mensagem de Javé:"
,"17":"«Criatura humana, nomeei-te sentinela da casa de Israel. É da minha boca que ouvirás a mensagem. E o que aprenderes de Mim, irás ensinar-lho."
,"18":"Se digo ao injusto que ele deve morrer, e não o avisares nem lhe falares, ensinando-o a deixar o seu mau caminho para que possa continuar vivo, ele morrerá, mas pedir-te-ei contas da sua morte."
,"19":"Se, porém, avisares o injusto, mas ele não se emendar do seu mau caminho, ele morrerá por causa da sua própria injustiça, mas salvarás a tua vida."
,"20":"E se o justo se afastar da sua justiça e praticar a injustiça, colocarei uma armadilha diante dele, e morrerá. Porque se não o avisaste, ele morrerá no seu pecado e ninguém se lembrará do bem que praticou. Mas vou pedir-te contas da sua morte."
,"21":"Se, porém, chamaste a atenção do justo para que não pecasse, e ele não pecou, então ele conservará a própria vida, porque foi orientado; e tu também terás salva a tua vida»."
,"22":"A mão de Javé pousou sobre mim, e Ele disse-me: «Dirige-te para o vale, e lá te irei transmitir uma mensagem»."
,"23":"Fui para o vale, e lá estava a glória de Javé, tal como a tinha visto junto das margens do rio Cobar. Então caí com o rosto por terra,"
,"24":"mas o espírito entrou em mim, pôs-me de pé e começou a conversar comigo. Ele disse-me: «Vai e fecha-te na tua casa,"
,"25":"porque te vão prender com cordas, criatura humana, a fim de que não possas ir para o meio deles."
,"26":"Farei que a tua língua se cole ao céu da boca. Então ficarás mudo e não poderás repreendê-los, porque são uma casa de rebeldes."
,"27":"Quando Eu falar contigo e te abrir a boca, então lhes dirás: Assim diz o Senhor Javé. Quem quiser ouvir, ouça, e quem não quiser ouvir, não ouça; pois são uma casa de rebeldes»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"«Criatura humana, pega num tijolo, coloca-o na tua frente, e desenha nele uma cidade."
,"2":"Depois põe ao redor um cerco contra ela: constrói barricadas, abre trincheiras, põe um acampamento e aríetes ao redor dela."
,"3":"Em seguida, pega numa panela de ferro e põe-na como muralha de ferro entre ti e a cidade. Fixa o teu olhar sobre ela, e a cidade ficará cercada. De facto, tê-la-ás cercado. Isto será um sinal para a casa de Israel»."
,"4":"«Deita-te sobre o lado esquerdo, e Eu colocarei sobre ti a culpa da casa de Israel. Carregarás a culpa de Israel durante todos os dias em que estiveres assim deitado."
,"5":"Marcarei o número de dias, conforme o número de anos da sua culpa. Durante trezentos e noventa dias pagarás a culpa da casa de Israel."
,"6":"Depois disso, deitar-te-ás do lado direito e carregarás a culpa da casa de Judá durante quarenta dias, um dia por cada ano, conforme estabeleci."
,"7":"Fixa o teu olhar e estende o braço nu para o cerco de Jerusalém e profetiza contra ela."
,"8":"Eu mesmo te vou amarrar com cordas, e não te voltarás de um lado para o outro, enquanto não terminarem os dias em que deves ficar amarrado»."
,"9":"«Toma trigo, cevada, favas, lentilhas, milho e aveia. Coloca tudo numa vasilha e prepara com eles os teus alimentos, de acordo com o número de dias em que deverás ficar deitado de um lado, isto é, para trezentos e noventa dias."
,"10":"Por dia, e em várias vezes, comerás cerca de duzentos e cinquenta gramas."
,"11":"Beberás água medida: somando as várias vezes que beberes água, deverás beber cerca de um litro."
,"12":"As broas de cevada que comeres, serão cozidas sobre fezes humanas, à vista de todos»."
,"13":"E Javé completou: «É desta forma que a casa de Israel comerá alimento impuro no meio das nações por onde a espalhei»."
,"14":"Então eu disse: «Ah! Senhor Javé, eu nunca me contaminei! Desde pequeno, nunca comi carne de animal morto de morte natural ou despedaçado por alguma fera. Até agora, carne estragada nunca entrou na minha boca!»"
,"15":"Javé respondeu-me: «Está bem. Para cozeres o teu pão deixo que uses bosta de vaca em vez de fezes humanas»."
,"16":"Depois disse-me: «Criatura humana, em breve acabarei com os mantimentos em Jerusalém; então comerão com medo pão racionado, e assustados beberão água por medida."
,"17":"Com a falta de pão e de água, vão desmaiar uns por cima dos outros e morrerão por causa dos seus pecados»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"«Criatura humana, pega numa lâmina afiada, usa-a como navalha de barbeiro, e rapa o cabelo e a barba. Depois serve-te de uma balança para pesar o cabelo e a barba."
,"2":"Queima a terça parte deles no meio da cidade, quando terminar o cerco da cidade. Corta a outra terça parte com a espada, em redor da cidade. Espalha ao vento a última terça parte deles, e Eu os perseguirei de espada em punho."
,"3":"Recolhe um punhado que guardarás na barra do teu manto."
,"4":"Desse punhado, toma um pouco e lança-o ao fogo para queimar. Depois diz à casa de Israel:"
,"5":"Assim diz o Senhor Javé: Isto é Jerusalém, que coloquei entre as nações, com muitos países ao redor."
,"6":"Mas ela rebelou-se contra as minhas normas, de maneira ainda mais criminosa que as outras nações. Ela desobedeceu aos meus estatutos, pior que os outros países que estão à sua volta, pois desprezou as minhas normas e não andou de acordo com os meus estatutos."
,"7":"Por isso, assim diz o Senhor Javé: Dado que vos mostrastes mais rebeldes comigo do que as nações que estão à vossa volta, não andando conforme os meus estatutos e deixando de pôr em prática as minhas normas, nem cumprindo as normas das nações que estão ao vosso redor,"
,"8":"assim diz o Senhor Javé: Eu também me ponho contra ti. Vou executar os meus julgamentos no meio de ti, diante das nações."
,"9":"Far-te-ei o que nunca fiz e nunca mais farei, tudo por causa das tuas abominações."
,"10":"Por isso os pais, no meio de ti, vão devorar os próprios filhos, e os filhos devorarão os próprios pais. É assim que vou executar os meus julgamentos contra ti. E tudo o que restar de ti, vou espalhá-lo aos quatro ventos."
,"11":"Por isso, juro por Mim mesmo, oráculo do Senhor Javé: Por terdes profanado o meu Templo santo com os seus ídolos e abominações, também Eu vos rejeitarei: não terei compaixão, nem perdoarei."
,"12":"Deste modo, uma terça parte de ti, Jerusalém, morrerá de peste ou vai morrer de fome dentro da cidade; outra terça parte será morta pela espada ao seu redor; a última terça parte, espalhá-la-ei aos quatro ventos, perseguindo-os de espada em punho."
,"13":"Só assim derramarei a minha ira, vou satisfazer a minha indignação contra eles e Me darei por satisfeito. E quando tiver derramado a minha ira contra eles, então ficarão a saber que Eu, Javé, falei, porque sou ciumento."
,"14":"Transformar-te-ei em ruínas e motivo de desprezo para as nações vizinhas, diante de todos os que passam."
,"15":"Serás motivo de zombaria e insulto, advertência e espanto para as nações vizinhas, quando executar a minha sentença, com ira e indignação, e com castigos implacáveis. Fui eu, Javé quem falou."
,"16":"Quando atirar contra vós as setas malignas da fome - e é para vos destruir e acabar convosco que as atiro - então redobrarei o peso da fome sobre vós, cortando-vos os mantimentos."
,"17":"Enviarei fome e animais selvagens que acabarão com os vossos filhos; sobre ti passarão a peste e a mortandade, e farei vir a guerra contra ti. Fui eu, Javé, quem falou»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Recebi uma mensagem de Javé, que dizia:"
,"2":"«Criatura humana, olha para os montes de Israel e profetiza contra eles."
,"3":"Diz-lhes: Montes de Israel, escutai a palavra do Senhor Javé. O que o Senhor Javé diz às montanhas e serras, aos vales e ravinas, é o seguinte: Vou fazer vir contra vós a espada, para destruir os vossos lugares altos."
,"4":"Os vossos altares ficarão destruídos, os vossos altares de incenso serão demolidos. Eu farei com que os vossos habitantes, feridos pela espada, caiam diante dos vossos ídolos imundos."
,"5":"Porei os cadáveres dos israelitas diante desses ídolos, e espalharei os vossos ossos em volta dos vossos altares."
,"6":"Em todos os lugares onde morais, as cidades serão destruídas e os lugares altos serão arrasados, de maneira que os vossos altares serão derrubados e demolidos, os vossos ídolos imundos serão quebrados e destruídos, os vossos altares de incenso serão arrasados, tudo o que fizestes será eliminado."
,"7":"Quando no meio de vós começar a cair gente morta pela espada, ficareis a saber que Eu sou Javé."
,"8":"Deixarei que alguns escapem da espada, para viverem em outras nações, espalhados em diversos países."
,"9":"Quando lhes arrancar o coração de prostituta, que faz com que eles me atraiçoem, e também o seu olhar de prostituta que está sempre voltado para esses ídolos imundos, então os sobreviventes lembrar-se-ão de Mim, no meio das nações para onde foram levados como cativos. Aí terão nojo de si mesmos, por causa do mal que praticaram, com todas essas abominações."
,"10":"Então ficarão a saber que eu sou Javé, e que não foi por brincadeira que ameacei trazer-lhes essa desgraça."
,"11":"Assim diz o Senhor Javé: Bate palmas, pateia e lamenta todas as abominações da casa de Israel, pois tudo cairá pela espada, pela fome e pela peste."
,"12":"Aquele que está longe, morrerá pela peste; aquele que está perto, morrerá pela espada; aquele que sobreviver, morrerá de fome. Assim derramarei a minha ira contra eles."
,"13":"Então reconhecerão que Eu sou Javé, quando começarem a aparecer as vítimas da guerra no meio dos seus ídolos imundos, em volta dos altares de tais ídolos, sobre toda a colina elevada, no cume de todos os montes, debaixo das árvores frondosas e carvalhos viçosos, e nos lugares onde costumam oferecer incenso para apaziguarem os seus ídolos imundos."
,"14":"Estenderei a mão contra eles e transformarei o país, de ponta a ponta, em deserto vazio, desde o deserto até Rebla, lugar onde eles moram. E eles ficarão a saber que Eu sou Javé»."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Recebi esta mensagem de Javé:"
,"2":"«Criatura humana, diz: Assim diz o Senhor Javé à terra de Israel: Chegou o fim! O fim para os quatro cantos do país."
,"3":"É agora o teu fim! Vou derramar a minha ira contra ti, vou julgar-te de acordo com o teu comportamento e pedir-te contas de todas as tuas abominações."
,"4":"Não terei compaixão, nem te perdoarei. Pelo contrário, farei cair sobre ti o teu próprio comportamento e as tuas abominações estarão no meio. Então reconhecereis que Eu sou Javé."
,"5":"Assim diz o Senhor Javé: Vai chegar uma desgraça depois da outra."
,"6":"O fim chegou! Chegou o fim! Ele desperta contra ti, já está a chegar."
,"7":"A tua sorte foi lançada, habitante do país. Chegou a hora, o dia está próximo! Nos montes haverá ruínas, e não alegria."
,"8":"Num instante, vou derramar a minha ira e desafogar a minha cólera contra ti. Vou julgar-te de acordo com o teu comportamento, e pedir contas de todas as tuas abominações."
,"9":"Não terei compaixão, nem te perdoarei. Pelo contrário, farei cair sobre ti o teu próprio comportamento, e as tuas abominações estarão no meio de ti. Então sabereis que Eu sou Javé, Aquele que fere."
,"10":"O dia está próximo, já está a chegar! Chegou a tua vez! A injustiça floresce, amadurece a insolência"
,"11":"e triunfa a violência como vara do injusto! Sem demora e sem atraso,"
,"12":"chega o momento, aproxima-se o dia. Que o comprador não se alegre e o vendedor não fique triste, pois o furor atingirá a todos."
,"13":"O vendedor não vai recuperar o que vendeu e o comprador não reterá o que comprou, porque o furor atingirá a todos; cada um pagará pelo seu próprio crime, e ninguém poderá escapar."
,"14":"Tocam as trombetas, preparam as armas, mas ninguém vai para o combate porque a minha cólera atinge a todos."
,"15":"As armas estão nas ruas. Dentro de casa, a fome e a peste. Quem está no campo, morre pelas armas. Quem está na cidade, é devorado pela fome ou pela peste."
,"16":"Alguns sobreviventes escapam para os montes, como as pombas do vale, mas Eu fá-los-ei perecer, cada um pela sua falta."
,"17":"Todos estão de braços caídos e joelhos enfraquecidos."
,"18":"Estão todos vestidos de luto, cobertos de medo; estão com o rosto envergonhado e as cabeças rapadas."
,"19":"Deitarão fora a prata, e o seu ouro vai para o lixo. Prata e ouro não serão capazes de os livrar, no dia da ira de Javé; com eles não podem matar a fome, nem encher o estômago, porque prata e ouro foram a causa dos seus pecados."
,"20":"A beleza das suas jóias foi motivo de orgulho para eles. Foi com elas que fizeram os seus ídolos abomináveis. Por isso eu transformarei tudo em lixo."
,"21":"Farei que a sua riqueza seja tomada por estrangeiros e saqueada pelos piores indivíduos do país."
,"22":"Desviarei deles o meu olhar, para que possam violar o meu tesouro, para que os assaltantes lá possam entrar e profanar o que quiserem."
,"23":"Prepara correntes, porque o país está cheio de crimes, a cidade está cheia de violência."
,"24":"Vou trazer os pagãos mais violentos para se apossarem das casas. Acabarei com o orgulho dos valentes, e os seus santuários serão profanados."
,"25":"Quando chegar o desespero, eles procurarão a paz, mas não a encontrarão."
,"26":"Virão desgraças sobre desgraças, más notícias sobre más notícias. Pedirão ao profeta uma visão. O sacerdote não será capaz de dar instruções, e os anciãos de dar conselhos."
,"27":"O rei ficará de luto, o príncipe vestirá a decepção, e as mãos do povo da terra tremerão. Agirei com eles de acordo com o seu comportamento. Tal como eles costumam julgar, assim Eu vou julgá-los. Então ficarão a saber que Eu sou Javé»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"No dia cinco do sexto mês do ano seis, estava eu sentado em casa, com os anciãos de Judá sentados na minha presença, quando sobre mim pousou a mão do Senhor Javé."
,"2":"Tive nesse momento uma visão: era uma figura com aparência de homem. Daquilo que seria a sua cintura para baixo, parecia fogo; e da cintura para cima, algo que parecia um brilho faiscante."
,"3":"Ele estendeu uma espécie de mão e pegou-me pelos cabelos. O espírito transportou-me entre o céu e a terra e, em visões divinas, levou-me a Jerusalém, até ao lado de dentro da porta que dá para o Norte, lá onde estava a imagem que tanto provocava o ciúme."
,"4":"Eis que lá estava a glória do Deus de Israel, tal como eu tinha visto no vale."
,"5":"Ele disse-me: «Criatura humana, olha para o lado Norte». Olhei na direcção do Norte, e lá estava, ao Norte da porta, à entrada, o altar do ídolo que provoca ciúme."
,"6":"Então Javé disse-me: «Criatura humana, vês o que eles fazem? As abominações que cometem aqui para Me afastar do meu santuário? E ainda verás abominações mais monstruosas»."
,"7":"Depois levou-me até à porta de entrada, e eu vi que havia um furo na parede."
,"8":"Ele disse-me: «Criatura humana, abre um buraco na parede». Abri um buraco na parede e vi uma porta."
,"9":"Ele disse-me: «Entra para veres as abominações que eles aqui praticam»."
,"10":"Entrei e vi imagens de toda a espécie de répteis e animais nojentos, todos os ídolos imundos da casa de Israel gravados nas quatro paredes."
,"11":"Havia também setenta homens, anciãos da casa de Israel. Jezonias, filho de Safã, era um deles. Estavam todos de pé, de frente para aquelas coisas, cada um com o turíbulo na mão queimando incenso. Subia uma nuvem perfumada."
,"12":"Ele disse-me: «Estás a ver, criatura humana, o que os anciãos da casa de Israel fazem às escondidas? Cada um tem um oratório cheio de imagens, pois dizem: 'Javé não nos vê; Ele já abandonou o país'»."
,"13":"Então Ele falou mais uma vez comigo: «Irás vê-los fazer abominações ainda piores»."
,"14":"Depois levou-me até à entrada da porta do Templo de Javé, que dá para o Norte, onde estavam mulheres sentadas, a chorar pelo deus Tamuz."
,"15":"Ele disse-me: «Viste, criatura humana? Pois verás abominações piores que estas!»"
,"16":"Então levou-me para o lado de dentro do Templo de Javé, e junto à entrada do Templo de Javé, entre a entrada do santuário e o altar, estavam vinte e cinco homens, de costas para o Templo de Javé, virados para Nascente a adorar o Sol."
,"17":"Ele disse-me: «Estás a ver, criatura humana? E a casa de Judá acha pouco praticar todas estas abominações que aqui fazem! Eles ainda enchem o país de violência, provocando a minha ira. E aí estão eles a aproximar o raminho do nariz."
,"18":"Por isso Eu também vou agir com ira. Não terei compaixão nem pouparei ninguém. Então eles invocarão aos gritos, mas Eu não lhes darei ouvidos»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Então Javé gritou aos meus ouvidos com toda a força: «Aproximai-vos, carrascos da cidade, cada um com a sua arma mortal»."
,"2":"Então avançaram seis homens do lado da porta de cima, que dá para o Norte, cada qual com a sua arma na mão. Um deles estava vestido de linho, com o estojo de escrivão à cintura. Chegaram e ficaram de pé ao lado do altar de bronze."
,"3":"A glória do Deus de Israel saiu de cima do querubim, onde se encontrava, para o limiar da porta do Templo. Chamou o homem que estava vestido de linho e com o estojo de escrivão à cintura."
,"4":"Javé disse-lhe: «Percorre a cidade de Jerusalém e marca com uma cruz a testa dos indivíduos que estiverem a lamentar-se e a gemer por causa das abominações que se fazem no meio dela»."
,"5":"Ouvi quando dizia aos outros: «Percorrei a cidade atrás dele, para matar sem dó nem piedade"
,"6":"velhos, rapazes, raparigas, crianças e mulheres. Matai, acabai com eles. Só não mateis os indivíduos marcados com a cruz. Começai pelo meu Templo». E eles começaram pelos anciãos que estavam diante do Templo."
,"7":"Ele ainda disse: «Profanai o Templo, enchei de cadáveres o seu interior, e percorrei a cidade para matar»."
,"8":"Enquanto eles matavam, fiquei sozinho. Então caí com o rosto por terra, clamando: «Ah! Senhor Javé, vais destruir o resto de Israel, derramando o teu furor sobre Jerusalém?»"
,"9":"Ele respondeu-me: «É demasiado grande a injustiça da casa de Israel e de Judá! O país está cheio de violência e a cidade cheia de injustiça. E eles pensam: 'Javé abandonou o país e não vê nada!'"
,"10":"Por isso, não terei dó nem piedade, mas sobre eles farei cair as consequências do seu próprio comportamento»."
,"11":"Naquele momento, o homem vestido de linho e com o estojo de escrivão à cintura tomou a palavra e disse: «Acabei de fazer o que mandaste»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Na cúpula que estava sobre as cabeças dos querubins, vi uma espécie de safira com aparência de trono."
,"2":"Javé disse ao homem vestido de linho: «Vai ao meio das rodas que estão debaixo dos querubins e enche as mãos com brasas e espalha-as pela cidade». Eu vi-o ir até lá."
,"3":"Os querubins estavam de pé, do lado direito do Templo. Quando o homem entrou, uma nuvem enchia o interior do Templo."
,"4":"A glória de Javé saiu de cima dos querubins e foi até ao limiar da porta do Templo, que estava cheio pela nuvem, e o brilho da glória de Javé ocupava todo o recinto."
,"5":"O barulho das asas dos querubins chegava até ao pátio exterior. Era como a voz do Todo-poderoso quando fala."
,"6":"Logo que Javé lhe mandou ir buscar fogo entre as rodas no meio dos querubins, o homem vestido de linho colocou-se perto das rodas."
,"7":"O querubim levou a mão ao fogo que havia no meio deles, pegou nas brasas e encheu as mãos do homem vestido de linho. Este recebeu-as e saiu."
,"8":"Então, debaixo das asas dos querubins, apareceu algo parecido com uma mão humana."
,"9":"Olhando bem, notei quatro rodas junto dos querubins, cada uma junto de um deles. E as rodas pareciam ter o brilho do topázio."
,"10":"As quatro rodas tinham a mesma aparência. A sua estrutura era como se uma roda estivesse encaixada dentro da outra,"
,"11":"para que pudessem rodar nas quatro direcções, sem ter que girar, pois já estavam orientadas na direcção em que rodavam; enquanto avançavam, não se viravam."
,"12":"Todo o corpo dos querubins, costas, mãos, asas e também as rodas, tudo estava cheio de olhos por todo lado."
,"13":"Conforme ouvi, às rodas davam o nome de turbilhão."
,"14":"Os quatro querubins tinham quatro faces cada um: a primeira era de querubim; a segunda, de homem; a terceira, de leão; a quarta, de águia."
,"15":"Os querubins podiam elevar-se do chão. Eram os mesmos animais que eu tinha visto nas margens do rio Cobar."
,"16":"Quando os querubins se movimentavam, as rodas seguiam também ao lado deles. Quando batiam asas para se elevarem do chão, as rodas não saíam de junto deles."
,"17":"Quando paravam, as rodas também paravam; quando subiam, elas também subiam, porque o espírito do animal estava também nelas."
,"18":"Em seguida, a glória de Javé deixou o limiar da porta do Templo e foi pousar em cima dos querubins."
,"19":"Então os querubins abriram as asas e elevaram-se do chão, à minha vista. Quando saíram, as rodas acompanharam-nos. Pararam junto à porta oriental do Templo de Javé. E sobre eles pousou a glória do Deus de Israel."
,"20":"Estes eram os animais que eu tinha visto debaixo do Deus de Israel, nas margens do rio Cobar. E reconheci que eram querubins."
,"21":"Cada um tinha quatro faces e quatro asas. E debaixo das asas havia algo parecido com mãos humanas."
,"22":"A forma das suas faces era a mesma que eu tinha visto nas margens do rio Cobar. E cada um só ia em frente, na direcção para onde estava voltado."
}`)
	CurrentBook.AddChapter(11, `{
"1":"O espírito arrebatou-me e levou-me para a porta oriental do Templo de Javé, isto é, a porta que dá para Oriente. E eis que à entrada da porta estavam vinte e cinco indivíduos. Entre eles vi Jezonias, filho de Azur, e Feltias, filho de Banaías, chefes do povo."
,"2":"Então Javé disse-me: «Criatura humana, são estes os homens que tramam o crime e planeiam a desgraça nesta cidade."
,"3":"Eles dizem: 'Não deveremos em breve construir casas? Isto é uma panela, e nós somos a carne'."
,"4":"Por isso, profetiza contra eles. Profetiza, criatura humana»."
,"5":"Então sobre mim pousou o espírito de Javé e disse-me: «Diz: Assim diz Javé: É isto o que vós dizeis, casa de Israel! Eu conheço os vossos pensamentos."
,"6":"Vós fizestes um grande número de mortos na cidade, e enchestes as ruas de cadáveres."
,"7":"Por isso, assim diz o Senhor Javé: Estes mortos que pusestes no meio dela é que são a carne, enquanto a cidade é a panela, mas Eu vou fazer-vos sair de lá."
,"8":"Estais com medo da espada? Pois eu vou trazer a espada contra vós - oráculo do Senhor Javé."
,"9":"Vou tirar-vos dessa panela e entregar-vos nas mãos de estrangeiros. É assim que vou executar a minha sentença."
,"10":"Caireis atingidos pela espada dentro do território de Israel. Eu vos julgarei! E vós ficareis a saber que Eu sou Javé."
,"11":"Jerusalém não será para vós uma panela, nem sereis carne guardada dentro dela. É no território de Israel que vou julgar-vos."
,"12":"Então ficareis a saber que Eu sou Javé, cujos estatutos vós não seguistes e cujas normas não cumpristes. Pelo contrário, imitastes os costumes das nações vizinhas»."
,"13":"Mal acabei de profetizar, morreu Feltias, filho de Banaías. Então caí com o rosto por terra e gritei bem alto: «Ah! Senhor Javé, quereis acabar com o resto de Israel?»"
,"14":"Recebi então de Javé uma mensagem, que me dizia:"
,"15":"«Criatura humana, os moradores de Jerusalém dizem aos teus irmãos, aos teus parentes e a toda a casa de Israel: 'Vós estais longe de Javé. Foi a nós que Javé deu a Terra como propriedade'."
,"16":"Por isso, diz-lhes: Assim diz o Senhor Javé: Dado que os levei para longe, para o meio das nações pagãs, e por algum tempo os espalhei entre as nações, Eu mesmo serei para eles um santuário em qualquer país para onde tenham ido."
,"17":"Diz, portanto: Assim diz o Senhor Javé: Eu vou reunir-vos do meio dos povos, vou juntar-vos de todos os países para os quais fostes levados, e dar-vos-ei depois a Terra de Israel."
,"18":"Logo que lá chegardes eliminareis dela todos os ídolos e abominações."
,"19":"Dar-lhes-ei um coração íntegro, e colocarei no íntimo deles um espírito novo. Tirar-lhes-ei do peito o coração de pedra e dar-lhes-ei um coração de carne."
,"20":"Tudo isto para que sigam os meus estatutos e ponham em prática as minhas normas. Então eles serão o meu povo, e Eu serei o seu Deus."
,"21":"Mas, se o seu coração correr atrás dos seus ídolos e abominações, far-lhes-ei sofrer as consequências das suas acções - oráculo do Senhor Javé»."
,"22":"Então os querubins levantaram as asas juntamente com as rodas. E a glória do Deus de Israel estava sobre eles."
,"23":"A glória de Javé saiu de cima da cidade e foi pousar no monte que fica a Oriente da cidade."
,"24":"O espírito ergueu-me e levou-me novamente para a Caldeia, para junto dos exilados, numa visão inspirada pelo espírito de Deus. E a visão desapareceu."
,"25":"Depois contei aos exilados tudo o que Javé me havia revelado."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Recebi a seguinte mensagem de Javé:"
,"2":"«Criatura humana, estás a morar numa casa de rebeldes. Eles têm olhos para ver, mas não vêem; têm ouvidos para ouvir, mas não ouvem; são de facto uma casa de rebeldes."
,"3":"Pois bem, criatura humana, prepara a tua bagagem de exilado e vai para o exílio, em pleno dia, à vista deles. Caminha de um lugar para outro, à vista deles. Talvez eles percebam que são uma casa de rebeldes."
,"4":"Prepara a tua bagagem como se fosse bagagem de exilado, em pleno dia, à vista deles. À tarde, à vista deles, sai como quem caminha para o exílio."
,"5":"E, à vista deles, faz um buraco no muro e sai por lá."
,"6":"Ainda à vista deles, põe a bagagem aos ombros: parte à noite, e tapa os olhos para não veres o país. Farei de ti um sinal para a casa de Israel»."
,"7":"Então eu fiz tudo o que me fora mandado. Durante o dia, reuni a minha bagagem como se fosse bagagem de exilado. E à tarde, fiz um buraco no muro, sem ferramenta, e parti ao escurecer, levando a bagagem aos ombros, bem à vista deles."
,"8":"Na manhã seguinte, recebi de Javé esta mensagem:"
,"9":"«Criatura humana, a casa de Israel, essa casa de rebeldes, não perguntou: 'O que é que estás a fazer'?"
,"10":"Pois então diz-lhes: Assim diz o Senhor Javé: Este oráculo refere-se a Jerusalém e a toda a casa de Israel que nela vive."
,"11":"Diz também: Eu sou para vós um sinal. Conforme eu fiz, assim lhes acontecerá. Irão cativos para o exílio."
,"12":"Até o chefe que está no meio deles carregará as suas coisas aos ombros e sairá de noite pelo buraco que será feito no muro para poder sair, cobrirá o rosto para não ver o país."
,"13":"Vou lançar sobre ele a minha rede, vou apanhá-lo na minha armadilha e conduzi-lo para Babilónia, a terra dos caldeus. Mas ele não chegará a esse país, pois morrerá antes."
,"14":"Espalharei aos quatro ventos todo o seu séquito, a sua guarda e as suas tropas, e persegui-los-ei de espada em punho."
,"15":"Quando os dispersar entre as nações e espalhar por muitos países, eles ficarão a saber que Eu sou Javé."
,"16":"Pouparei um certo número dos que escaparem da espada, da fome e da peste, para que contem as suas abominações às nações, pelas quais se espalharem, e assim ficarão a saber que Eu sou Javé»."
,"17":"Recebi a seguinte mensagem de Javé:"
,"18":"«Criatura humana, toma o teu alimento com medo, bebe a tua água com preocupação e angústia."
,"19":"Depois diz ao povo da terra: Assim diz o Senhor Javé aos habitantes de Jerusalém que estão na terra de Israel: Comereis o vosso alimento angustiados e bebereis a vossa água apavorados, porque outros devastarão e despovoarão a vossa terra, por causa da violência dos seus habitantes."
,"20":"As cidades habitadas serão arrasadas e o país transformar-se-á num deserto. Então sabereis que Eu sou Javé»."
,"21":"Recebi esta mensagem de Javé:"
,"22":"«Criatura humana, que ditado é esse que corre pelo país de Israel? 'Os dias vão passando e a visão não se realiza'!"
,"23":"Pois bem! Diz-lhes: Assim diz o Senhor Javé: Acabarei com esse ditado, e ninguém mais vai repeti-lo em Israel. Diz-lhes este outro ditado: 'Os dias aproximam-se e a visão vai realizar-se'."
,"24":"Nunca mais haverá visão inútil ou previsão enganosa na casa de Israel."
,"25":"Pois Eu mesmo, Javé, falarei. E o que Eu disser, ficará dito e realizar-se-á sem demora. Será agora, no vosso tempo, casa de rebeldes, que Eu direi uma palavra e a cumprirei - oráculo do Senhor Javé»."
,"26":"Recebi esta mensagem de Javé:"
,"27":"«Criatura humana, vê o que a casa de Israel diz: 'A visão que este tem é para daqui a muitos anos. Ele profetiza para um tempo distante'."
,"28":"Pois bem! Diz-lhes: Assim diz o Senhor Javé: as minhas palavras não demorarão a realizar-se. E o que Eu disser, ficará dito e acontecerá - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Recebi esta mensagem de Javé:"
,"2":"«Criatura humana, profetiza contra os profetas de Israel. Protetiza, e diz aos que profetizam conforme os seus próprios interesses. Diz-lhes: Escutai a palavra de Javé!"
,"3":"Assim diz o Senhor Javé: Ai dos profetas estúpidos, que inventam profecias, coisas que nunca viram, seguindo a sua própria inspiração!"
,"4":"Os teus profetas, Israel, parecem raposas no meio de ruínas."
,"5":"Vós não tapastes as brechas da muralha, nem construístes muralhas para que a casa de Israel pudesse resistir na guerra, no dia de Javé."
,"6":"Têm visões inúteis e previsões enganosas, esses que andam dizendo: 'Oráculo de Javé', quando não foi Javé quem os mandou. E ainda esperais que se cumpra a palavra deles!"
,"7":"E não é que continuais a ter visões inúteis e a fazer previsões erradas? E ainda dizeis que é oráculo de Javé, quando Eu nada vos disse."
,"8":"Por isso, assim diz o Senhor Javé: Dado que continuais a dizer coisas à toa e a ter visões falsas, então Eu me colocarei contra vós - oráculo do Senhor Javé."
,"9":"A minha mão pesará sobre esses profetas que têm visões mentirosas e fazem previsões erradas: eles nunca tomarão parte no conselho do meu povo, nem serão registados no livro da casa de Israel, nem voltarão para a terra de Israel. Assim, ficareis a saber que Eu sou o Senhor Javé."
,"10":"Tudo isto porque eles desviaram o meu povo, falando de paz, quando não havia paz. Basta o povo levantar um muro, e lá estão eles a rebocá-lo com massa."
,"11":"Diz aos que rebocam com massa: 'Vai desabar uma tempestade, vai cair granizo e soprar uma forte ventania'."
,"12":"Quando o muro cair, irão perguntar-vos: 'Onde é que está o reboco com que o rebocastes?'"
,"13":"Por isso, assim diz o Senhor Javé: Na minha ira, mandarei um furacão, com o meu furor mandarei uma tempestade e, no auge da minha fúria, uma chuva de granizo."
,"14":"Assim derrubarei o muro que rebocastes com massa; vou fazê-lo cair ao chão. Porei à mostra os seus alicerces. Ele cairá, e morrereis debaixo dele. Então sabereis que Eu sou Javé."
,"15":"Derramarei a minha ira sobre o muro e sobre aqueles que o rebocaram com massa. Depois dir-vos-ei: Já não existe muro, já não há rebocadores,"
,"16":"os profetas de Israel, que profetizavam sobre Jerusalém, e tinham visões de paz, quando não existe paz - oráculo do Senhor Javé»."
,"17":"Criatura humana, enfrenta as mulheres do teu povo, que profetizam conforme os seus próprios interesses. Profetiza contra elas,"
,"18":"dizendo: Assim diz o Senhor Javé: Ai daquelas que cosem nos punhos fitas mágicas e preparam véus de todas as medidas para a cabeça das pessoas, para seduzir os outros! Pretendeis caçar as pessoas do meu povo e salvar-vos a vós mesmas?"
,"19":"Vós profanais-Me diante do meu povo por um punhado de cevada ou um pedaço de pão, destinando à morte quem não devia morrer, e destinando à vida quem não devia viver. Deste modo, enganais o meu povo que dá ouvidos à mentira."
,"20":"Por isso, assim diz o Senhor Javé: Aqui estou Eu contra as fitas com que caçais gente como pássaros. Eu vou arrancá-las dos vossos braços e soltar as pessoas que vós aprisionastes como se fossem pássaros."
,"21":"Arrancarei também os véus que vós preparastes e livrarei o meu povo das vossas mãos. Ele nunca mais ficará nas vossas mãos como se fosse caça. Então vós ficareis a saber que Eu sou Javé."
,"22":"Com as vossas mentiras, perturbastes a consciência do justo, quando Eu não queria perturbá-lo. Destes todo o apoio ao injusto, para ele não deixar os seus maus caminhos e poder viver."
,"23":"Por isso, nunca mais tereis visões falsas, nem fareis predições. Eu livrarei o meu povo das vossas mãos. Então sabereis que Eu sou Javé»."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Alguns anciãos de Israel foram procurar-me e sentaram-se à minha volta."
,"2":"Então recebi a seguinte mensagem de Javé:"
,"3":"«Criatura humana, esses homens puseram ídolos nos seus corações. Eles colocam diante de si o tropeço que os fará pecar. E achas que vou permitir que eles Me consultem?"
,"4":"Pelo contrário, diz-lhes: Assim diz o Senhor Javé: Qualquer israelita que põe os seus ídolos no seu coração, que coloca diante de si o tropeço que o fará pecar e, em seguida, vai ter com o profeta, Eu mesmo, Javé, lhe darei a resposta. Quando ele vier, Eu lhe responderei de acordo com a multidão dos seus ídolos."
,"5":"Deste modo, apropriar-Me-ei do coração dos israelitas que se distanciaram de Mim por causa de todos os seus ídolos."
,"6":"Diz, portanto, à casa de Israel: Assim diz o Senhor Javé: Convertei-vos, abandonai os vossos ídolos, voltai as costas a todas as vossas abominações."
,"7":"Eu mesmo, Javé, responderei a qualquer israelita ou imigrante que vive em Israel, que se distancia de Mim, que põe os seus ídolos no próprio coração e coloca diante de si o tropeço que o fará pecar e, em seguida, vai consultar o profeta."
,"8":"Vou enfrentar tal homem e fazer dele um exemplo proverbial. Vou eliminá-lo do meio do meu povo. E reconhecereis que Eu sou Javé."
,"9":"Se o profeta se deixa enganar e diz qualquer coisa, Eu, Javé, deixá-lo-ei no seu engano; estenderei a mão contra ele e eliminá-lo-ei de Israel, meu povo."
,"10":"São todos culpados. O castigo do profeta será igual ao daquele que o consulta."
,"11":"Assim, a casa de Israel não vai desviar-se de Mim, nem se manchará com os seus crimes. Então eles serão o meu povo e Eu serei o seu Deus - oráculo do Senhor Javé»."
,"12":"Recebi de Javé a seguinte mensagem:"
,"13":"«Criatura humana, se um país peca contra Mim, cometendo algum delito, estenderei a minha mão contra ele: vou tirar-lhe os mantimentos e mandar-lhe a fome; vou acabar com homens e animais."
,"14":"Se lá estiverem estes três homens, Noé, Danel e Job, por serem justos, conseguirão salvar a própria vida - oráculo do Senhor Javé."
,"15":"Se Eu soltasse animais ferozes pelo país, a fim de os deixar sem filhos, o lugar ficasse deserto, por ele ninguém passasse, com medo dos animais ferozes,"
,"16":"e esses três homens estivessem no país, juro por minha vida - oráculo do Senhor Javé - que eles não conseguiriam salvar os seus filhos e as suas filhas; o país inteiro transformar-se-ia num deserto, e só eles se salvariam."
,"17":"Se Eu enviasse a espada a esse país e dissesse: 'Espada, atravessa o país eliminando as pessoas e animais que nele houver';"
,"18":"e esses três homens lá estivessem, juro por minha vida - oráculo do Senhor Javé - que eles não conseguiriam salvar os seus filhos e as suas filhas; só eles se salvariam."
,"19":"Ou ainda, se Eu mandasse a peste a esse país e derramasse sobre ele a minha cólera com sangue, eliminando desse país pessoas e animais,"
,"20":"se Noé, Danel e Job lá estivessem, juro por minha vida - oráculo do Senhor Javé - que eles não conseguiriam salvar os seus filhos e filhas; só eles conseguiriam salvar-se por serem justos."
,"21":"Portanto, assim diz o Senhor Javé: Mesmo que Eu mande os meus quatro piores castigos: a espada, a fome, os animais ferozes e a peste, para acabar com as pessoas e animais que existem em Jerusalém,"
,"22":"haverá nela um resto de filhos e filhas que sairá da cidade e conseguirá escapar. Eles irão ter convosco e podereis ver o seu comportamento e o mal que praticam. Então sentir-vos-eis aliviados por toda a desgraça que fiz cair sobre Jerusalém, por tudo o que lhe fiz."
,"23":"Eles vos aliviarão, pois quando virdes o seu comportamento e o mal que praticam, compreendereis que não foi à toa que fiz tudo o que fiz contra Jerusalém - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, que existe de especial na parreira, que a torna diferente das plantas do bosque?"
,"3":"Porventura tira-se dela madeira para fazer algum objecto? Ou alguém tira dela um cabide, onde possa pendurar alguma coisa?"
,"4":"Eis que se atira ao fogo para queimar, e o fogo devora as duas extremidades, e o meio também fica consumido. Servirá ainda para alguma coisa?"
,"5":"Se quando estava inteira não servia para nada, quanto mais agora que o fogo a consumiu e ficou queimada!"
,"6":"Por isso, assim diz o Senhor Javé: Como aconteceu com a parreira silvestre que lancei ao fogo para ser queimada, assim tratarei os moradores de Jerusalém."
,"7":"Vou enfrentá-los. Escaparam ao fogo? Pois o fogo irá devorá-los. Então sabereis que Eu sou Javé, quando vos enfrentar."
,"8":"Vou fazer do vosso país um lugar deserto, porque só praticastes a maldade - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, faz com que Jerusalém tome consciência das suas abominações."
,"3":"Diz-lhe: Assim diz o Senhor Javé a Jerusalém: Pela origem e nascimento, és da terra de Canaã. O teu pai era amorreu e a tua mãe era heteia."
,"4":"Quando nasceste, quando vieste a este mundo, não te cortaram o cordão umbilical, nem te lavaram, nem esfregaram o teu corpo com sal, nem te enfaixaram."
,"5":"Ninguém teve compaixão de ti ou pensou em fazer alguma coisa, com pena de ti. Já no dia do nascimento te deitaram fora, ao desabrigo, tal era a repugnância que sentiam por ti."
,"6":"Depois Eu passei por lá e vi que te debatias no teu próprio sangue. Vendo-te ensanguentada, Eu disse-te: 'Continua a viver'."
,"7":"Então Eu fiz-te crescer como a erva do campo. Cresceste, fizeste-te grande e chegaste à flor da juventude, formaram-se os teus seios e chegaste à puberdade. Mas estavas nua e desprotegida."
,"8":"Passei perto de ti e vi-te. Notei que estavas na idade do amor. Então estendi a minha capa sobre os teus ombros, para cobrir a tua nudez. Fiz um juramento e comprometi-Me contigo em aliança - oráculo do Senhor Javé - de modo que passaste a ser minha."
,"9":"Em seguida, dei-te um banho, lavei o sangue que estava no teu corpo e ungi-te com óleo."
,"10":"Depois vesti-te com roupas bordadas, calcei-te com sapatos de couro fino, cingi-te com um laço de linho e cobri-te com um véu de seda."
,"11":"Enfeitei-te com ornamentos: coloquei pulseiras nos teus pulsos e colares ao teu pescoço;"
,"12":"coloquei um anel no teu nariz, brincos nas orelhas e uma coroa belíssima na cabeça."
,"13":"As tuas jóias eram de ouro e prata; vestias-te de linho, seda e bordados; a tua alimentação era farinha de primeira, mel e azeite. Tornavas-te cada dia mais bonita e ias tomando ares de rainha."
,"14":"A tua fama corria o mundo, pois a tua beleza era perfeita, com o esplendor daquilo que te recobria - oráculo do Senhor Javé»."
,"15":"«Tu, porém, confiaste demasiado na tua beleza. A tua fama tornou-te prostituta, e passaste a entregar-te ao prazer com qualquer transeunte."
,"16":"Tomaste as tuas roupas e com elas enfeitaste com várias cores os lugares altos, onde te prostituías."
,"17":"Tomaste também as jóias de ouro e prata que te dei, e com elas fizeste imagens de homens, com as quais te prostituíste."
,"18":"Depois tomaste os teus vestidos bordados para cobrir essas estátuas, e ofereceste-lhes o meu incenso e o meu azeite."
,"19":"O alimento que te dei, a farinha de primeira, o azeite e o mel, que te dei para comeres, ofereceste-o a essas estátuas, como perfume para as aplacar - orá-culo do Senhor Javé."
,"20":"Tomaste até os teus próprios filhos e filhas, que para Mim havias gerado, e sacrificaste-os, para que essas estátuas os devorassem. Como se as tuas prostituições não bastassem,"
,"21":"ainda mataste os meus filhos, e os entregaste para serem queimados em honra dessas estátuas."
,"22":"No meio de todas essas abominações e de todas as tuas prostituições, não te lembraste do teu tempo de criança, quando estavas nua e desprotegida e te debatias no teu próprio sangue."
,"23":"Mas, para cúmulo de todas as tuas maldades, ai de ti! - oráculo do Senhor Javé -"
,"24":"em toda a parte fizeste um nicho e um lugar alto;"
,"25":"construíste um lugar de pecado nas encruzilhadas, desonrando a tua beleza, entregando o teu corpo a qualquer transeunte e multiplicando assim os teus actos de prostituição."
,"26":"Também te entregaste aos egípcios, teus vizinhos corpulentos, só para aumentar as tuas prostituições e para Me insultar."
,"27":"Então Eu estendi a minha mão contra ti, reduzi os teus alimentos e entreguei-te nas mãos das tuas inimigas, as cidades dos filisteus. Até elas se envergonharam do teu comportamento indecente."
,"28":"Depois tornaste-te prostituta dos assírios, porque ainda não estavas satisfeita. Por mais que te entregasses à prostituição, não te saciavas."
,"29":"Com os caldeus aumentaste ainda mais a tua prostituição na terra de Canaã, mas nem com isso te davas por satisfeita."
,"30":"Que ódio Eu tinha de ti - oráculo do Senhor Javé - quando fazias tudo isto, prostituta descarada!"
,"31":"Quando construías lugares altos nas encruzilhadas, lugares de pecado nas praças, nem parecias uma prostituta que recebe pagamento,"
,"32":"mas mulher adúltera que recebe estranhos em lugar do seu marido."
,"33":"Às prostitutas costuma-se pagar. Tu, porém, é que pagavas a todos os teus amantes. Tu é que lhes pagavas para que eles, de todos os lados, fossem à tua casa procurar-te como prostituta."
,"34":"Fazias o contrário das outras prostitutas: ninguém te procurava; eras tu que pagavas, não eram eles que te pagavam. Eras mesmo diferente das outras!»"
,"35":"«Pois bem, prostituta, escuta a palavra de Javé:"
,"36":"Assim diz o Senhor Javé: Esbanjaste o teu dinheiro e, nas tuas prostituições, mostraste a tua nudez aos teus amantes e aos teus ídolos imundos. Além disso, ofereceste o sangue dos teus filhos."
,"37":"Pois bem! Vou reunir todos os teus amantes, com quem tiveste relações, tanto aqueles de quem gostavas como aqueles de quem não gostavas. De todas as partes vou reuni-los contra ti. Descobrirei a tua nudez, para que eles vejam as tuas partes íntimas."
,"38":"Condenei-te ao castigo das adúlteras e assassinas, descarregando sobre ti o meu furor e o meu ciúme."
,"39":"Vou entregar-te nas suas mãos. Vão destruir os teus lugares de pecado, derrubar os teus lugares altos, arrancar as tuas vestes, levar as tuas jóias e deixar-te completamente nua."
,"40":"Eles vão alvoroçar a multidão contra ti, para te apedrejarem e trespassarem com espadas."
,"41":"Incendiarão as tuas casas e castigar-te-ão na presença de muitas mulheres. Far-te-ei acabar com a prostituição, e nunca mais pagarás a ninguém."
,"42":"Só então aplacarei a minha ira contra ti, o meu ciúme desaparecerá, acalmar-Me-ei e a minha cólera cessará."
,"43":"Já que não quiseste lembrar-te do tempo de criança, e Me provocaste com todas estas coisas, far-te-ei sofrer as consequências do teu comportamento - oráculo do Senhor Javé. Não acrescentarás outras infâmias às tuas abominações»."
,"44":"«Falando de ti, toda a gente repetirá o refrão: 'Tal mãe, tal filha!'"
,"45":"Tu és bem a filha da tua mãe, que detestava o marido e os filhos. Tu és bem a irmã das tuas irmãs, que também detestavam os maridos e os filhos. A tua mãe era heteia e o teu pai era amorreu."
,"46":"À tua esquerda mora a tua irmã mais velha, Samaria, com as cidades que dela dependem. À tua direita, a tua irmã mais nova, que é Sodoma, com as cidades dependentes."
,"47":"Tu não seguiste apenas os seus caminhos e imitaste as suas abominações. Isso era pouco: ultrapassaste-as em depravação!"
,"48":"Juro pela minha vida - oráculo do Senhor Javé - que a tua irmã Sodoma, com as suas dependentes, nunca agiram como tu e as tuas próprias dependentes."
,"49":"O pecado da tua irmã Sodoma foi este: ela e as cidades dependentes estavam cheias de soberba, abundância e despreocupação, mas não estenderam a mão para socorrer o pobre e o indigente."
,"50":"Eram orgulhosas e faziam coisas abomináveis. Por isso, eliminei-as, como viste."
,"51":"Samaria não cometeu metade dos teus pecados; tu cometes mais abominações do que ela. Comparadas com todas as abominações que tu praticas, as tuas irmãs parecem santas."
,"52":"Então assume a responsabilidade pela tua falta de vergonha, porque, com os teus pecados, justificaste as tuas irmãs. Tu tornaste-te pior que elas; comparadas contigo, elas são inocentes. Cria vergonha, carrega o peso do teu descaramento, porque fizeste com que as tuas irmãs parecessem justas."
,"53":"Eu vou mudar-lhes o destino: o destino de Sodoma e das cidades que dela dependem, o destino de Samaria e das suas dependentes; e, no meio delas, também vou mudar o teu destino."
,"54":"Assim carregarás o peso do teu descaramento e envergonhar-te-ás de tudo o que fizeste; isso as consolará."
,"55":"Então a tua irmã Sodoma com as suas dependentes voltarão ao que eram no passado. Samaria e as suas dependentes também voltarão a ser o que eram antes. E até tu, com as tuas dependentes, voltarás a ser o que eras antigamente."
,"56":"A tua irmã Sodoma era alvo das tuas críticas, no tempo em que eras orgulhosa,"
,"57":"antes de as tuas próprias vergonhas serem desnudadas. Pois bem! Agora és objecto de escárnio das cidades de Edom e de todas as vizinhas cidades filisteias, que te insultam por todos os lados."
,"58":"Arcarás com as tuas próprias infâmias e abominações - oráculo do Senhor Javé»."
,"59":"«Assim diz o Senhor Javé: Vou agir contigo do mesmo modo como tu agiste: desprezaste o juramento e quebraste a aliança!"
,"60":"No entanto, Eu lembrar-Me-ei da aliança que fiz contigo, quando eras jovem, e farei contigo uma aliança eterna."
,"61":"Então lembrar-te-ás do teu comportamento e envergonhar-te-ás, quando acolheres as tuas irmãs mais velhas e mais novas, pois vou dar-tas como cidades dependentes, embora isso não faça parte da aliança que fiz contigo."
,"62":"Eu mesmo farei aliança contigo, e ficarás a saber que Eu sou Javé."
,"63":"Isto para que te lembres e te envergonhes e, humilhada, já nem queiras falar, quando Eu te perdoar tudo o que fizeste - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, propõe um enigma e conta uma parábola à casa de Israel,"
,"3":"dizendo: Assim diz o Senhor Javé: Uma grande águia de asas enormes, de corpo comprido, coberta de penas e plumagem colorida, chegou ao Líbano. Agarrando a copa de um cedro,"
,"4":"arrancou-lhe o ramo mais alto. Depois levou-o para a terra dos negociantes e depositou esse ramo na cidade dos comerciantes."
,"5":"Em seguida tomou um ramo do chão e colocou-o num terreno de plantio, onde havia muita água. Enterrou o ramo como se plantasse um salgueiro."
,"6":"Ele soltou rebentos e tornou-se igual a uma parreira que se espalha, pouco elevada. As pontas dos seus ramos voltaram-se para a águia e as suas raízes ficaram debaixo da águia. Tornou-se como parreira, soltou rebentos, formou ramos."
,"7":"Mas havia também outra grande águia, de grandes asas e farta plumagem. Logo essa parreira estendeu as suas raízes para o lado da águia e esticou para ela os seus ramos, do canteiro onde estava, para que a águia a regasse."
,"8":"Estava plantada numa terra boa, onde havia muita água, para formar ramos e produzir frutos, como uma parreira bem viçosa."
,"9":"Diz: Assim diz o Senhor Javé: Será que a parreira vai progredir? Ou será que a águia vai arrancar-lhe as raízes, apanhar-lhe os frutos e fazer-lhe secar os ramos mais tenros? Assim não será preciso muita força, nem grande multidão, para a arrancar pelas raízes."
,"10":"Acaso não irá murchar, quando soprar o vento Leste, no canteiro onde ela brotou?»"
,"11":"Então recebi de Javé a seguinte mensagem:"
,"12":"«Fala assim a essa casa de rebeldes: Será que não sabeis o que significam estas coisas? E responde: O rei de Babilónia foi a Jerusalém, tomou o rei e os chefes e levou-os para a Babilónia."
,"13":"Tomou alguém da família do rei, fez com ele um acordo, obrigando-o a fazer um juramento, e levou consigo os grandes do país."
,"14":"Assim o reino ficaria reprimido, sem que ninguém pudesse levantar a cabeça, obediente aos acordos que tinha estabelecido."
,"15":"Mas ele revoltou-se contra o rei da Babilónia e mandou mensageiros procurar o Egipto, para que o Egipto lhe fornecesse cavalos e batalhões. Será que ele vai conseguir? Será que vai escapar, quem faz uma coisa dessas? Quem rompe um acordo, será que ainda consegue escapar?"
,"16":"Juro por minha vida - oráculo do Senhor Javé - que morrerá na Babilónia, país do rei que lhe tinha dado um reino; porque não fez caso do juramento e rompeu o acordo."
,"17":"Não será com a ajuda de grande exército e numerosa tropa que o Faraó poderá agir em seu favor na hora do combate, na hora em que fizerem aterros e construírem torres de assalto para massacrar uma multidão de pessoas."
,"18":"Ele não fez caso do juramento, rompeu o acordo; assumiu um compromisso e voltou atrás. Não vai escapar!"
,"19":"Por isso, assim diz o Senhor Javé: Juro por minha vida que vou castigá-lo por ter desprezado o meu juramento e quebrado a minha aliança."
,"20":"Atirarei contra ele o meu laço, e ele ficará preso na minha rede. Vou levá-lo para Babilónia, e aí acertarei contas com ele, por causa de todas as suas traições."
,"21":"Até os mais escolhidos comandos do seu exército cairão mortos em combate. E aqueles que ficarem, irão espalhar-se pelos quatro ventos. Então sabereis que fui Eu quem vos falou, Eu, Javé."
,"22":"Assim diz o Senhor Javé: Eu mesmo vou tirar um rebento da copa daquele cedro; da ponta cortarei um ramo bem viçoso, e Eu mesmo vou plantá-lo no alto de um monte elevado."
,"23":"É nas alturas da montanha de Israel que vou plantá-lo. Vai deitar ramos, produzir frutos e transformar-se num cedro gigante. Os passarinhos farão nele os seus ninhos, e os pássaros abrigar-se-ão à sombra dos seus ramos."
,"24":"E todas as árvores do campo saberão que sou Eu, Javé, que rebaixo a árvore alta e elevo a árvore baixa, seco a árvore verde e faço brotar a árvore seca. Eu, Javé, digo e faço»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Recebi a seguinte mensagem de Javé:"
,"2":"«Que sentido tem para vós este ditado que se repete na terra de Israel: 'Os pais comeram uvas verdes, e os dentes dos filhos é que ficaram embotados'?"
,"3":"Juro pela minha vida - oráculo do Senhor Javé - que nunca mais ireis repetir esse ditado em Israel."
,"4":"Todas as vidas são minhas, tanto a vida do pai como a vida do filho. O indivíduo que pecar, esse é que deverá morrer."
,"5":"Se o indivíduo é justo e pratica o direito e a justiça;"
,"6":"se não come nos montes, não adora os ídolos imundos da casa de Israel; se não desonra a mulher do seu próximo, nem se aproxima de mulher menstruada;"
,"7":"se não explora ninguém, mas devolve o penhor de uma dívida; se não rouba ninguém, mas dá o seu pão a quem tem fome e veste quem não tem roupa;"
,"8":"se não empresta com usura, nem cobra juros; se evita praticar a injustiça e procura fazer um julgamento justo entre as pessoas;"
,"9":"o indivíduo que age de acordo com os meus estatutos, que guarda as minhas normas, praticando correctamente a verdade, esse indivíduo é justo, e certamente permanecerá vivo - oráculo do Senhor Javé."
,"10":"Contudo, se esse indivíduo tiver um filho violento e assassino ou que pratica alguma dessas coisas,"
,"11":"enquanto ele não fez nada disso; se o filho come sobre os montes; desonra a mulher do seu próximo;"
,"12":"explora o pobre e o indigente; rouba e não devolve o penhor; adora ídolos imundos e comete abominação;"
,"13":"empresta com usura e cobra juros, é claro que não permanecerá vivo por ter praticado todas essas abominações: ele certamente morrerá e será responsável pelos seus próprios crimes."
,"14":"Acontece, porém, que esse indivíduo tem um filho que viu todos os pecados cometidos pelo pai, mas não faz igual:"
,"15":"não come sobre os montes; não adora os ídolos imundos da casa de Israel; não desonra a mulher do próximo;"
,"16":"não explora ninguém; não exige penhor; não rouba, mas dá o seu pão a quem tem fome e veste quem está sem roupa;"
,"17":"evita praticar injustiça; não aceita usura nem cobra juros; observa as minhas normas e age segundo os meus estatutos, esse indivíduo não vai morrer por causa dos pecados de seu pai; pelo contrário, permanecerá vivo."
,"18":"O pai, que praticou a violência, que roubou e maltratou o seu povo, é que deverá morrer por causa do seu próprio pecado."
,"19":"Mas ainda perguntais: 'Porque é que o filho não é castigado pelo pecado do pai?' Ora, o filho praticou o direito e a justiça, guardou os meus estatutos e pô-los em prática. Por isso, ele permanecerá vivo."
,"20":"O indivíduo que peca, esse é que deve morrer. O filho nunca será responsável pelo pecado do pai, nem o pai será culpado pelo pecado do filho. O justo receberá a justiça que merece e o injusto pagará pela sua injustiça."
,"21":"Se o injusto se arrepende de todos os erros que praticou e passa a guardar os meus estatutos e a praticar o direito e a justiça, então permanecerá vivo, não morrerá."
,"22":"Todo o mal que ele praticou nunca mais será lembrado, e permanecerá vivo, por causa da justiça que praticou."
,"23":"Porventura sentirei prazer com a morte do injusto? - oráculo do Senhor Javé. O que Eu quero é que ele se converta dos seus maus caminhos, e viva."
,"24":"Contudo, se o justo renuncia à sua própria justiça e pratica o mal, seguindo todas as abominações que o injusto pratica, será que ele vai fazer isso e continuar vivo? Não! Toda a justiça que ele praticou vai ser esquecida. Ele morrerá por causa das injustiças que passou a praticar, pelos erros que cometeu."
,"25":"Mas se ainda disserdes: 'A maneira de agir do Senhor não é justa!' Escuta aqui, casa de Israel: Não é justa a minha maneira de agir, ou é a vossa maneira de agir que não é justa?"
,"26":"Se o justo deixa de ser justo e começa a praticar a injustiça, ele morrerá por causa disso, morrerá por causa da injustiça que praticou."
,"27":"Quando o injusto renuncia à sua injustiça e começa a praticar o direito e a justiça, está a salvar a própria vida."
,"28":"Se decidiu converter-se de todo o mal que cometeu, viverá e não morrerá."
,"29":"E, no entanto, a casa de Israel diz: 'A maneira do Senhor agir não é justa!' Eu pergunto: É a minha maneira de agir que não é justa, ó casa de Israel, ou é a vossa maneira de agir que não é justa?"
,"30":"Assim, casa de Israel, Eu vos julgarei a cada um de acordo com a própria maneira de viver - oráculo do Senhor Javé. Convertei-vos e abandonai toda a injustiça, e a injustiça nunca mais provocará a vossa ruína."
,"31":"Libertai-vos de todas as injustiças cometidas e formai um coração novo e um espírito novo. Por que motivo deveríeis morrer, casa de Israel?"
,"32":"Eu não sinto prazer com a morte de ninguém - oráculo do Senhor Javé. Convertei-vos e tereis a vida»."
}`)
	CurrentBook.AddChapter(19, `{
"1":"«Entoa uma lamentação sobre os chefes de Israel:"
,"2":"Quem era a tua mãe? Era uma leoa no meio de leões, deitada com os leõezinhos à sua volta, amamentando os seus filhos."
,"3":"Criou um dos seus filhos até ele se tornar leão adulto. Ele aprendeu a dilacerar a presa e começou a devorar pessoas."
,"4":"As nações uniram-se contra ele, e acabou por cair na sua armadilha. Preso com correntes foi levado para a terra do Egipto."
,"5":"A leoa, vendo que se tinham desfeito os seus planos, e que a sua esperança se perdera, tomou outro dos seus filhos e fez dele um leão adulto."
,"6":"Ele começou a andar no meio dos leões, e era realmente um animal adulto. Aprendeu a dilacerar a presa e começou a devorar pessoas,"
,"7":"a derrubar os seus palácios e a destruir as suas cidades. O país e a população toda ficavam apavorados com o seu rugido."
,"8":"Contra ele reuniram-se as nações, todas as regiões vizinhas. Armaram contra ele a sua rede, e ele caiu na sua armadilha."
,"9":"Depois meteram-no numa jaula com cadeias. Assim o levaram ao rei da Babilónia e o conduziram à prisão, para que ninguém ouvisse o seu rugido nos montes de Israel."
,"10":"A tua mãe era como parreira plantada à beira da água. Produzia bastante e ficava frondosa, porque havia boa humidade."
,"11":"Os seus ramos eram fortes, bons para se tornarem ceptros reais. A sua altura sobressaía por cima das copas, a sua imponência destacava-se pela quantidade de ramos."
,"12":"Ela, porém, foi arrancada com raiva e lançada por terra. O vento Leste secou-lhe os frutos. Ela partiu-se e os seus fortes ramos secaram e foram destruídos pelo fogo."
,"13":"Agora ela está plantada no deserto, em terreno duro e seco."
,"14":"O fogo sai do seu tronco e queima os seus ramos e frutos. Ela já não terá o seu ramo forte, um ceptro para governar». Isto é uma lamentação, e como lamentação se deve cantar."
}`)
	CurrentBook.AddChapter(20, `{
"1":"No dia dez do quinto mês do ano sete, alguns anciãos de Israel foram consultar Javé e sentaram-se diante de mim."
,"2":"Então recebi a seguinte mensagem de Javé:"
,"3":"«Criatura humana, vais falar da seguinte forma aos anciãos de Israel: Assim diz o Senhor Javé: Será que viestes mesmo para Me consultar? Juro por minha vida, não vou permitir que Me consulteis - oráculo do Senhor Javé:"
,"4":"Tu é que vais julgá-los, criatura humana. Denuncia as abominações dos seus antepassados."
,"5":"Diz-lhes: Assim diz o Senhor Javé: No dia em que escolhi Israel, quando ergui a minha mão para a descendência de Jacob, eu revelei-Me a eles na terra do Egipto. Ergui a mão em juramento, dizendo: 'Eu sou Javé, o vosso Deus'."
,"6":"Nesse dia, ergui a mão jurando tirá-los da terra do Egipto, a fim de os levar para outra terra que Eu mesmo explorei para eles, terra onde corre leite e mel e que é o encanto de todos os países."
,"7":"Eu havia-lhes dito: 'Deitai fora as coisas abomináveis que vos seduzem, e não vos contamineis com os ídolos do Egipto, porque Eu sou Javé, o vosso Deus'."
,"8":"Mas eles rebelaram-se contra Mim e não quiseram obedecer-Me. Não deitaram fora as coisas abomináveis que os seduziam, nem abandonaram os ídolos do Egipto. Pensei então em derramar a minha ira contra eles, desafogar neles o meu ódio, dentro mesmo da terra do Egipto."
,"9":"Mas tomei outra atitude, por causa do meu Nome, para que o meu Nome não fosse profanado diante das nações, no meio das quais eles estavam, e aos olhos das quais Eu Me revelara a eles, para os tirar da terra do Egipto."
,"10":"Então tirei-os da terra do Egipto e levei-os para o deserto."
,"11":"Aí dei-lhes os meus estatutos e comuniquei-lhes as minhas normas, que dão vida a quem os pratica."
,"12":"Dei-lhes também os meus sábados, para que fossem um sinal entre Mim e eles, um sinal para que o povo reconheça que Eu, Javé, é que santifico o povo."
,"13":"Mas a casa de Israel desobedeceu-Me no deserto: não andaram de acordo com os meus estatutos e desprezaram as minhas normas, que dão vida a quem os pratica, e profanaram os meus sábados. Pensei então em derramar a minha ira contra eles e acabar com eles no deserto."
,"14":"Mas agi de outro modo por causa do meu Nome, para que o meu Nome não fosse profanado diante das nações, sob cujo olhar Eu os havia tirado do Egipto."
,"15":"No deserto, também ergui a mão, jurando que não os deixaria entrar na Terra que Eu lhes tinha dado, terra do leite e do mel, encanto de todos os países."
,"16":"No entanto, eles desprezaram as minhas normas, não andaram de acordo com os meus estatutos e profanaram os meus sábados, porque o seu coração estava apegado aos ídolos."
,"17":"Mas Eu compadeci-Me deles e não os destruí, nem os exterminei no deserto."
,"18":"Aos seus filhos Eu disse, ainda no deserto: 'Não andeis de acordo com os estatutos dos vossos antepassados, não obedeçais às suas normas, nem vos contamineis com os seus ídolos."
,"19":"Eu é que sou Javé, o vosso Deus. É de acordo com os meus estatutos que deveis andar. Segui as minhas leis, observai os meus preceitos e cumpri-os."
,"20":"Guardai também os meus sábados, para que sejam um sinal entre Mim e vós, e aprendais que Eu sou Javé, o vosso Deus'."
,"21":"Esses filhos, porém, rebelaram-se, não andaram de acordo com os meus estatutos, não guardaram nem puseram em prática as minhas normas, que dão vida a quem os pratica, e ainda profanaram os meus sábados. Pensei em derramar a minha ira contra eles, em desafogar o meu ódio contra eles no deserto."
,"22":"Mas recolhi a minha mão e agi de outro modo, por causa do meu Nome, para que o meu Nome não fosse profanado diante das nações, sob cujo olhar Eu os havia tirado do Egipto."
,"23":"No deserto, ergui a mão, jurando-lhes que os haveria de espalhar entre as nações, de os dispersar por todos os países,"
,"24":"porque não praticaram as minhas normas e desprezaram os meus estatutos, profanaram os meus sábados e se tornaram admiradores dos ídolos dos seus antepassados."
,"25":"Porventura dei-lhes estatutos que não eram bons e normas que não lhes dariam vida?"
,"26":"Acaso os contaminei com as ofertas que faziam, quando imolavam os seus filhos mais velhos? Tê-los-ei amedrontado, para que reconhecessem que Eu sou Javé?"
,"27":"Por isso, criatura humana, diz à casa de Israel: Assim diz o Senhor Javé: Os vossos antepassados também Me insultaram revoltando-se contra Mim."
,"28":"Fi-los entrar na Terra que, de mão erguida, tinha prometido dar-lhes. Mas, quando viam qualquer monte elevado ou qualquer árvore frondosa, aí ofereciam sacrifícios e apresentavam as suas ofertas irritantes; aí colocavam perfumes agradáveis e derramavam vinho em honra dos ídolos."
,"29":"Então perguntei-lhes: 'Que lugar alto é esse para onde ides?' E daí nasceu o nome 'lugar alto', que ficou até ao dia de hoje."
,"30":"Por isso, diz à casa de Israel: Assim diz o Senhor Javé: Vós contaminais-vos como os vossos antepassados, e prostituís-vos com as vossas abominações;"
,"31":"trazeis as vossas ofertas, ofereceis os vossos filhos, queimando-os no fogo, e continuais até ao dia de hoje a contaminar-vos com os vossos ídolos. Eu ainda deveria atender-vos, casa de Israel? Juro por minha vida - oráculo do Senhor Javé - que, de maneira nenhuma, vos atenderei!"
,"32":"Não se realizará a ideia que vos vem ao pensamento, quando dizeis: 'Queremos ser iguais às outras nações, iguais à gente dos outros países, que prestam culto à madeira e à pedra'."
,"33":"Juro por minha vida - oráculo do Senhor Javé - que, com mão forte e braço estendido ou derramando a minha ira, Eu vou ser o vosso rei."
,"34":"Pois vou tirar-vos dentre os povos, vou reunir-vos do meio dos países por onde estais espalhados, com mão forte e braço estendido, ou derramando a minha ira."
,"35":"Depois levar-vos-ei para o deserto da Síria, onde acertarei contas convosco, frente a frente."
,"36":"Da mesma forma como acertei contas com os vossos antepassados no deserto do Egipto, assim agora acertarei contas convosco - oráculo do Senhor Javé."
,"37":"Far-vos-ei passar debaixo do cajado e conduzir-vos-ei ao respeito da aliança."
,"38":"Excluirei os rebeldes que se revoltam contra Mim. Fá-los-ei sair do país onde estão exilados, mas não entrarão na terra de Israel. Então ficareis a saber que Eu sou Javé."
,"39":"Quanto a vós, casa de Israel, assim diz o Senhor Javé: Cada um vá servir os seus ídolos, se não Me quiser obedecer, mas não continueis a profanar o meu Nome santo com as vossas ofertas e os vossos ídolos."
,"40":"Pois será na minha santa montanha, no mais alto monte de Israel - oráculo do Senhor Javé - será aí, na sua Terra, que toda a casa de Israel Me prestará culto. Lá vos aceitarei, lá pedirei as vossas ofertas e os melhores dons, juntamente com as vossas coisas santas."
,"41":"Aceitar-vos-ei como perfume agradável, depois de vos retirar do meio das nações e de vos reunir do meio dos países por onde fostes espalhados e, diante das nações, reconhecereis que Eu sou santo."
,"42":"Ficareis a saber que Eu sou Javé, quando vos fizer voltar para a Terra de Israel, Terra que jurei, com mão erguida, dar aos vossos antepassados."
,"43":"Lá recordareis todos os vossos caminhos e todas as más acções com que vos contaminastes e passareis a sentir nojo de vós mesmos, por todo o mal que praticastes."
,"44":"Então ficareis a saber que Eu sou Javé, quando fizer isto, não por causa dos vossos maus caminhos e nem pela baixeza das vossas faltas de respeito, mas só por causa do meu Nome, ó casa de Israel - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Recebi esta mensagem de Javé:"
,"2":"«Criatura humana, volta-te para a direita, fala voltado para o Sul, profetiza contra a floresta do Negueb."
,"3":"Assim dirás à floresta do Negueb: Ouve a palavra de Javé! Assim diz o Senhor Javé: Estou pronto para te deitar fogo, um fogo que queimará todas as árvores verdes e secas. Ninguém conseguirá apagar a labareda e todos os rostos se queimarão, desde o Negueb até ao Norte."
,"4":"Então todos verão que Eu, Javé, acendi esse fogo, e ele não se apagará»."
,"5":"Então eu disse: «Ah! Senhor Javé, eles dizem que eu sou um contador de fábulas!»"
,"6":"Então recebi uma nova mensagem de Javé, que dizia:"
,"7":"«Criatura humana, vira-te para Jerusalém, fala voltado para o santuário, profetizando contra a Terra de Israel."
,"8":"Dirás à Terra de Israel: Assim diz Javé: Agora estou contra ti. Vou tirar da bainha a minha espada para matar tanto o justo como o injusto."
,"9":"Já que vou matar tanto o justo como o injusto, então a minha espada sairá da bainha contra todos, de Norte a Sul."
,"10":"Assim todos ficarão a saber que fui Eu, Javé, que tirei a espada da bainha, e que ela não voltará atrás."
,"11":"Tu, criatura humana, gemerás encurvado, chorarás com toda a amargura, diante deles."
,"12":"Então eles irão perguntar-te: 'Porque é que estás a gemer?' Tu responderás: 'Porque quando chegar uma notícia, todos os corações se derreterão, todas as mãos desfalecerão, todos os ânimos vacilarão e todos os joelhos fraquejarão. A notícia está a chegar e vai cumprir-se - oráculo do Senhor Javé'»."
,"13":"Recebi de Javé a seguinte mensagem:"
,"14":"«Criatura humana, profetiza e diz-lhes: Assim diz Javé: Espada, espada afiada e polida!"
,"15":"Afiada para matar de verdade, e polida também para brilhar..."
,"16":"Ela foi bem polida, pronta para ser empunhada. Ele afiou e poliu a espada, para a colocar na mão de alguém disposto a matar."
,"17":"Clama e grita, criatura humana, porque ela vai contra o meu povo, contra todos os chefes de Israel. Eles foram entregues à espada juntamente com o meu povo. Deita as mãos à cabeça,"
,"18":"porque é uma provação... - oráculo do Senhor Javé."
,"19":"Criatura humana, profetiza e bate palmas. Que a espada se duplique e se triplique; é a espada que massacra, a grande espada do massacre que os mantém encurralados."
,"20":"Desta forma, o coração palpita e as vítimas multiplicam-se: em todas as portas coloquei a morte pela espada, espada feita para fulminar, afiada para matar."
,"21":"Golpeia à direita, golpeia à esquerda, vira o corte para onde for preciso."
,"22":"Eu também vou bater palmas e derramar o meu furor. Eu, Javé, falei»."
,"23":"Recebi a seguinte mensagem de Javé:"
,"24":"«Criatura humana, traça dois caminhos para a passagem da espada do rei da Babilónia. Os dois caminhos sairão do mesmo país. À entrada de cada caminho, coloca uma seta que indique o rumo para uma cidade."
,"25":"Traça um caminho para que a espada chegue a Rabá dos amonitas e também a Judá, que tem a sua fortaleza em Jerusalém."
,"26":"Isto porque o rei da Babilónia está na encruzilhada, para consultar os oráculos. Ele agita as flechas, consulta os ídolos domésticos e examina um fígado."
,"27":"Na sua mão direita tem a sorte lançada: Jerusalém. Por isso, ele prepara os aríetes, dá ordem de atacar, solta o grito de guerra, coloca os aríetes contra as portas da cidade, constrói aterros, ergue torres de assalto."
,"28":"Para os habitantes de Jerusalém, isso parece uma resposta falsa, pois fizeram juramento solene. O rei da Babilónia, porém, acusa-os de infidelidade e fá-los prisioneiros."
,"29":"Por isso, assim diz o Senhor Javé: Vós provocastes a lembrança do vosso crime, quando as vossas revoltas foram descobertas, quando os vossos pecados se tornaram visíveis em tudo o que fazíeis. Por isso, atraístes a atenção sobre vós mesmos e sereis capturados à força."
,"30":"Quanto a ti, chefe de Israel, ímpio e perverso, o teu dia chegou, chegou a hora do castigo final."
,"31":"Assim diz o Senhor Javé: Tirai-lhe o turbante, arrancai-lhe a coroa. Nada vai continuar como antes. O que é baixo será elevado e o que é alto será baixado."
,"32":"Ruína! Ruína! Transformo tudo em ruínas! Mas isto não acontecerá enquanto não chegar aquele que deverá realizar o julgamento. Foi a ele que Eu confiei tudo isto."
,"33":"Criatura humana, profetiza, dizendo: Assim diz o Senhor Javé contra os amonitas e seus insultos: Espada! Espada fora da bainha para matar! Espada polida para o massacre, polida para brilhar!"
,"34":"Para cortar a cabeça dos injustos, dos maus, cujo dia está a chegar, na hora do castigo final. Enquanto isso cultivas visões ilusórias e recebes adivinhações mentirosas."
,"35":"Coloca de novo a espada na bainha. Vou julgar-te no lugar em que foste criado, no país onde nasceste."
,"36":"Derramarei sobre ti o meu furor, soprarei sobre ti o fogo da minha ira. Vou entregar-te nas mãos de homens bárbaros, especialistas em destruir."
,"37":"Vais ser devorado pelo fogo, o teu sangue será espalhado pelo país, e ninguém mais se lembrará de ti. Eu, Javé, falei»."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Recebi deJavé a seguinte mensagem:"
,"2":"«Criatura humana, não vais julgar a cidade sanguinária? Denuncia todas as suas abominações,"
,"3":"dizendo: Assim diz o Senhor Javé: Ai da cidade que derrama sangue dentro de si mesma e faz chegar a sua própria hora! Que fabrica os seus ídolos, para com eles se contaminar!"
,"4":"O sangue que derramaste é a tua condenação. Ao fabricar ídolos, contaminaste-te e assim apressaste a tua hora e fizeste chegar o fim da tua existência. Por isso, far-te-ei passar vergonha entre as nações e ser objecto de escárnio entre os outros países."
,"5":"Tanto os de perto como os de longe, todos se rirão de ti, cidade mal-afamada e cheia de desordens."
,"6":"Todos os chefes de Israel usam o poder para derramar sangue."
,"7":"Dentro de ti são desprezados o pai e a mãe, o imigrante é oprimido, a viúva e o órfão são explorados."
,"8":"Desprezaste as coisas sagradas e profanaste os meus sábados."
,"9":"Em ti há gente que calunia para derramar sangue, há gente que come sobre os montes e pratica acções criminosas."
,"10":"Há quem tenha relações com a madrasta e violente a mulher menstruada."
,"11":"Um pratica imoralidade com a mulher do seu próximo, outro desonra a sua nora, outro violenta a própria irmã, a filha do seu pai."
,"12":"Há quem aceite suborno para derramar sangue. Cobras juros com usura, exploras o próximo com violência e esqueces-te de Mim - oráculo do Senhor Javé."
,"13":"Estou furioso com os lucros que conseguiste e com o sangue que foi derramado no meio de ti."
,"14":"Será que o teu coração irá aguentar, que as tuas mãos estarão firmes na hora em que Eu vier para acertar contas contigo? Eu sou Javé. Eu digo e faço."
,"15":"Vou espalhar-te entre as nações e dispersar-te entre os países, até ficares completamente limpa das tuas imundícies."
,"16":"Serás profanada diante das nações, mas ficarás a saber que Eu sou Javé»."
,"17":"Recebi também esta mensagem de Javé:"
,"18":"«Criatura humana, para Mim a casa de Israel transformou-se em sucata: todos eles são sucata de cobre, estanho, ferro e chumbo dentro de uma fornalha."
,"19":"Por isso, assim diz o Senhor Javé: Porque todos sois sucata, vou reunir-vos no meio de Jerusalém."
,"20":"Como se juntam prata, cobre, ferro, chumbo e estanho dentro da fornalha, para atear fogo e derreter tudo, assim também, com ira e furor, reunirei e destruirei."
,"21":"Juntar-vos-ei a todos e acenderei o fogo da minha indignação para vos derreter no meio da cidade."
,"22":"Tal como se derrete a prata na fornalha, assim também vós sereis derretidos no meio da cidade, e ficareis a saber que Eu, Javé, derramei o meu furor sobre vós»."
,"23":"Recebi ainda esta mensagem de Javé:"
,"24":"«Criatura humana, diz a Jerusalém: És uma terra que não foi purificada, nem recebeu chuva no dia da cólera."
,"25":"Os teus chefes parecem leões que, rugindo, despedaçam as suas presas: devoram as pessoas, apoderam-se de todas as riquezas, de tudo o que tem valor, e multiplicam o número de viúvas dentro da cidade."
,"26":"Os teus sacerdotes violam a minha lei e profanam os meus santuários. Não sabem distinguir entre coisas santas e coisas profanas, não sabem separar coisas impuras de coisas puras, não fazem caso dos meus sábados, e Eu mesmo sou profanado entre eles."
,"27":"As tuas autoridades parecem lobos que dilaceram a presa, fazendo correr sangue e destruindo vidas para enriquecerem."
,"28":"Os teus profetas encobrem tudo isto com visões falsas e adivinhações mentirosas, dizendo: 'Assim diz o Senhor Javé', quando de facto Javé não falou."
,"29":"Os latifundiários exploram e roubam, oprimem o pobre e o indigente e exploram o imigrante, violando os seus direitos."
,"30":"Procurei entre eles alguém que construísse muros, que ficasse firme na brecha junto de Mim para defender o país, para não deixar que fosse destruído, mas não encontrei ninguém."
,"31":"Por isso, lancei contra eles a minha cólera, para acabar com eles no fogo do meu furor, e fazer que sofram as consequências do seu comportamento - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Recebi esta mensagem de Javé:"
,"2":"«Criatura humana, havia duas mulheres, filhas da mesma mãe."
,"3":"Desde jovens, elas prostituíram-se no Egipto. Desde que caíram na prostituição, deixaram que estranhos lhes acariciassem os seios e lhes apalpassem os peitos de adolescente."
,"4":"A mais velha chamava-se Oola e a mais nova Ooliba. Elas eram minhas esposas e tiveram filhos e filhas. Oola é Samaria, e Ooliba é Jerusalém."
,"5":"Oola ainda estava comigo quando se prostituiu, deixando-se seduzir pelos seus amantes, os assírios, militares"
,"6":"vestidos de púrpura, chefes e governantes, todos jovens, sedutores, montados a cavalo."
,"7":"Ela entregou-se como prostituta a toda a classe alta dos assírios, a todos aqueles por quem se deixou seduzir, e acabou por se contaminar com os seus ídolos imundos."
,"8":"Ela não tinha esquecido o seu tempo de prostituta no Egipto. Quando, ainda criança, já dormiam com ela, apertavam os seus seios de adolescente e tinham relações com ela."
,"9":"Por isso, entreguei-a nas mãos dos seus amantes, os assírios, pelos quais ela se deixou seduzir."
,"10":"Eles puseram-lhe à mostra as partes íntimas, agarraram os seus filhos e filhas, e mataram-nas ao fio da espada. Ela tornou-se um caso famoso entre as mulheres, por causa do castigo que sofreu."
,"11":"A sua irmã Ooliba viu tudo. E as suas paixões foram ainda mais indecentes que as dela, e a sua prostituição foi mais desavergonhada."
,"12":"Também se deixou seduzir pelos assírios, chefes e governantes, militares impecavelmente vestidos, montados a cavalo, todos jovens e sedutores."
,"13":"Então Eu vi que o caminho de uma era tão imundo como o da outra."
,"14":"Mas Ooliba multiplicou as suas prostituições. Ela viu desenhadas na parede figuras de caldeus, pintadas de vermelho,"
,"15":"com cinturões e turbantes, com aparência de escudeiros, fiel retrato dos babilónios, naturais da Caldeia."
,"16":"Ela deixou-se seduzir pelas figuras que lhe causaram grande impressão, e mandou mensageiros à Caldeia."
,"17":"Então os babilónios vieram dormir com ela e contaminaram-na com as suas prostituições. Ela contaminou-se com eles e depois sentiu nojo deles."
,"18":"Revelou o seu temperamento de prostituta e mostrou a sua nudez. Então Eu tive nojo dela, como tinha sentido nojo da sua irmã."
,"19":"A partir daí, ela foi aumentando as suas prostituições, lembrando o tempo da sua juventude, quando era prostituta na terra do Egipto"
,"20":"e se entregava apaixonadamente a homens com pénis como o dos jumentos e sexo como os garanhões."
,"21":"Voltaste à tua juventude devassa no Egipto, quando apertavam o teu peito e apalpavam os teus seios de adolescente."
,"22":"Por isso, Ooliba, assim diz o Senhor Javé: Eis que vou levantar contra ti os amantes de quem tiveste nojo. Vou trazê-los de todos os lados:"
,"23":"os babilónios e todos os caldeus, as tribos de Facud, de Soa e de Coa, os assírios todos, jovens sedutores, chefes e governantes, capitães e oficiais, todos montados a cavalo."
,"24":"Do Norte virão contra ti carros e carruagens. Uma grande multidão de gente, com escudos grandes e pequenos e com capacetes, vai atacar-te de todos os lados. Então apresentar-lhes-ei a tua causa, e eles julgar-te-ão de acordo com as suas leis."
,"25":"Descarregarei o meu ciúme contra ti, e eles tratar-te-ão com cólera, cortando-te o nariz e as orelhas, e os sobreviventes morrerão ao fio da espada. Tomarão os teus filhos e filhas, e deitarão no fogo o que restar de ti."
,"26":"Arrancar-te-ão as vestes e apoderar-se-ão das tuas jóias."
,"27":"Assim, acabarei com a tua devassidão, com a tua vida de prostituta iniciada no Egipto. Nunca mais olharás para eles, nem te lembrarás mais do Egipto."
,"28":"Assim diz o Senhor Javé: Vou entregar-te nas mãos daqueles que odeias, nas mãos daqueles de que agora tens nojo."
,"29":"Eles tratar-te-ão com ódio. Apoderar-se-ão de tudo o que ganhaste com o teu trabalho, e abandonar-te-ão nua e sem roupa, ficando descoberta a indecência da tua vida de prostituta."
,"30":"A tua devassidão e prostituição provocaram tudo isto, porque te prostituíste com as nações e te contaminaste com os seus ídolos."
,"31":"Seguiste o mesmo caminho da tua irmã. Por isso, colocarei a taça dela na tua mão."
,"32":"Assim diz o Senhor Javé: Beberás a mesma taça da tua irmã, uma taça funda e larga. Vais tornar-te motivo de escárnio e zombaria, tão grande é a tua taça."
,"33":"Ficarás cheia de embriaguez e náusea. A taça da tua irmã Samaria é uma taça de pavor e destruição."
,"34":"Tu bebê-la-ás e esvaziá-la-ás até à última gota. Depois sugarás os cacos, rasgando o teu peito, porque assim Eu falei - oráculo do Senhor Javé."
,"35":"Por isso, assim diz o Senhor Javé: Dado que te esqueceste de Mim e Me voltaste as costas, agora carrega também a tua devassidão e as tuas prostituições»."
,"36":"Javé disse-me ainda: «Criatura humana, tu é que vais julgar Oola e Ooliba. Denuncia as suas abominações!"
,"37":"Elas cometeram adultério e têm sangue nas mãos. Cometeram adultério com os seus ídolos e ainda deitaram ao fogo, para os queimar em honra deles, os seus próprios filhos, que elas Me tinham gerado."
,"38":"E ainda Me fizeram isto, naquele dia: profanaram o meu santuário e violaram os meus sábados."
,"39":"Depois de terem imolado os seus próprios filhos em honra dos seus ídolos, ainda no mesmo dia entraram no meu santuário e profanaram-no. Foi isto que elas fizeram dentro da minha casa!"
,"40":"Além disso, mandaram vir homens de longe, convidados por um mensageiro, e eles vieram. Para eles tomaste banho, pintaste os olhos e adornaste-te com as tuas jóias."
,"41":"Depois reclinaste-te num sofá magnífico, tendo à frente uma bem preparada mesa e, sobre ela, o meu incenso e o meu azeite."
,"42":"Ouvia-se a vozearia de uma multidão despreocupada. A ela juntou-se grande número de homens, vindos de todos os pontos do deserto. Eles colocavam-lhe pulseiras nos braços, e na cabeça uma coroa preciosa."
,"43":"Então eu disse àquela que era usada pelos adúlteros: 'Agora ela entrega-se às suas prostituições!'"
,"44":"Foram ter com ela, como se vai a uma prostituta. Foi assim que procuraram Oola e Ooliba, essas duas mulheres depravadas."
,"45":"Mas homens justos é que as julgarão, e a sentença contra elas será a condenação que se dá a mulheres adúlteras e assassinas, porque cometeram adultério e estão com as mãos manchadas de sangue."
,"46":"Por isso, assim diz o Senhor Javé: Convocai uma assembleia contra elas, e sejam entregues ao terror e ao saque."
,"47":"Que a assembleia as apedreje e as mate à espada. Que os seus filhos e filhas sejam assassinados, e as suas casas sejam incendiadas."
,"48":"Assim, Eu acabarei com a devassidão deste país, e todas as mulheres receberão uma advertência e não imitarão as vossas devassidões."
,"49":"Vós as duas sofrereis as consequências da vossa devassidão. Ireis suportar o peso dos pecados de idolatria, e ficareis a saber que Eu sou o Senhor Javé»."
}`)
	CurrentBook.AddChapter(24, `{
"1":"No dia dez do décimo mês do ano nove, recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, anota com precisão o dia de hoje, porque foi exactamente hoje que o rei da Babilónia atacou Jerusalém."
,"3":"Conta uma parábola a essa casa de rebeldes, dizendo: Assim diz o Senhor Javé: Coloca a panela ao fogo e enche-a de água."
,"4":"Mete nela pedaços de carne, os melhores pedaços: coxa e lombo. Enche a panela com ossos escolhidos."
,"5":"Toma as melhores cabeças do rebanho. Coloca lenha debaixo da panela, cozinha os pedaços e ferve os ossos."
,"6":"Pois assim diz o Senhor Javé: Ai da cidade sanguinária! Ai da panela enferrujada: a sua ferrugem não sai! Tira dela os pedaços um a um, sem fazer nenhuma escolha."
,"7":"Pois o sangue que nela foi derramado, ela lançou-o sobre a pedra nua, não o derramou no chão, para que o pó o cobrisse."
,"8":"Então, para provocar a minha ira e para Me vingar, coloquei o sangue dela sobre a pedra nua e não o cobri."
,"9":"Por isso, assim diz o Senhor Javé: Ai da cidade sanguinária! Eu também vou fazer uma grande fogueira."
,"10":"Amontoa bastante lenha, acende o fogo, coze bem a carne, prepara os temperos e queima os ossos."
,"11":"Coloca a panela vazia em cima das brasas, para que aqueça até o ferro ficar vermelho, para que a imundície se derreta e a ferrugem desapareça."
,"12":"Por mais que alguém se esforce, nem com o fogo a ferrugem desaparece."
,"13":"A devassidão é a tua imundície; Eu quis purificar-te mas tu não deixaste. Por isso, não serás purificada da tua imundície enquanto não derramar sobre ti a minha ira."
,"14":"Eu, Javé, o digo, e vai cumprir-se a minha palavra. Não hesitarei, não Me compadeço, nem Me arrependo. Vou julgar-te conforme a tua conduta e as tuas más acções - oráculo do Senhor Javé»."
,"15":"Recebi esta mensagem de Javé:"
,"16":"«Criatura humana, vou tirar-te, de repente, aquela que é o encanto dos teus olhos. Não te vistas de luto, não te lamentes, nem derrames lágrimas."
,"17":"Geme em silêncio, e não sigas os costumes do luto. Usa turbante, calça sandálias, não cubras a barba e não aceites pão dos vizinhos»."
,"18":"Na parte da manhã, falei com o povo, e à tarde a minha mulher morreu. Na manhã seguinte, fiz como Javé me tinha ordenado."
,"19":"Então o povo perguntou-me: «Não nos vais explicar o que significa tudo isto?»"
,"20":"Eu respondi: «Recebi de Javé a seguinte mensagem:"
,"21":"Diz à casa de Israel: Assim diz o Senhor Javé: Vou profanar o meu santuário, que é o orgulho da vossa força, o encanto dos vossos olhos e a esperança da vossa vida. Os filhos e filhas que abandonastes serão mortos pela espada."
,"22":"Então fareis a mesma coisa que Eu fiz: não cobrireis a barba, nem aceitareis pão dos vizinhos;"
,"23":"usareis turbante, calçareis sandálias, não vos vestireis de luto, nem chorareis. Definhareis por causa das vossas iniquidades e lamentar-vos-eis uns com os outros."
,"24":"Ezequiel será para vós um sinal: fazei o mesmo que ele fez. E, quando isto acontecer, ficareis a saber que Eu sou o Senhor Javé»."
,"25":"«Criatura humana, no dia em que Eu lhes tirar a força, o prazer da glória, o encanto dos olhos e a delícia das suas vidas, isto é, os filhos e filhas,"
,"26":"nesse dia virá ter contigo um fugitivo para te dar uma notícia."
,"27":"Nesse dia, a tua boca abrir-se-á, poderás falar, e não continuarás mudo. Serás para eles um sinal, e eles ficarão a saber que Eu sou Javé»."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Recebi a seguinte mensagem de Javé:"
,"2":"«Criatura humana, vira-te para o lado dos amonitas e profetiza contra eles:"
,"3":"Diz aos amonitas: Escutai a palavra do Senhor Javé! Assim diz o Senhor Javé: Alegraste-te quando o meu santuário foi profanado, quando a terra de Israel foi devastada e quando a casa de Judá foi levada para o exílio."
,"4":"Pois bem! Vou entregar-te como propriedade aos orientais. Eles instalarão em ti as suas fortificações e montarão em ti o seu acampamento. Comerão os frutos e beberão o leite que tu produziste."
,"5":"Transformarei Rabá em pasto de camelos e as outras cidades amonitas em curral de ovelhas. Assim, ficareis a saber que Eu sou Javé."
,"6":"Pois assim diz o Senhor Javé: Bateste palmas e saltaste de alegria, cheio de desprezo pelo que estava acontecendo à terra de Israel."
,"7":"Pois bem! Vou estender a mão contra ti e entregar-te à pilhagem das outras nações. Vou eliminar-te do meio dos povos, apagar-te do meio dos países e destruir-te completamente. Assim, ficarás a saber que eu sou Javé»."
,"8":"Assim diz o Senhor Javé: Moab disse que a casa de Judá é igual a qualquer outra nação."
,"9":"Pois bem! Vou abrir os flancos de Moab, desde as suas cidades da fronteira até Bet-Jesimot, Baal-Meon e Cariataim, a jóia do país."
,"10":"Juntamente com Amon, vou dá-las aos orientais como propriedade, para que ninguém mais se lembre delas entre as nações."
,"11":"Farei justiça contra Moab, e eles ficarão a saber que Eu sou Javé»."
,"12":"«Assim diz o Senhor Javé: Edom foi sempre vingativo para com a casa de Judá e tornou-se criminoso ao vingar-se dela."
,"13":"Por isso, assim diz o Senhor Javé: Vou estender a mão contra Edom, eliminando homens e animais. Vou deixá-lo deserto, porque desde Temã até Dadã morrerão todos pela espada."
,"14":"Confiarei ao meu povo Israel a minha vingança contra Edom. Israel tratará Edom de acordo com a minha ira e a minha cólera, e os edomitas conhecerão a minha vingança - oráculo do Senhor Javé»."
,"15":"«Assim diz o Senhor Javé: Os filisteus são vingativos e vingaram-se com a alma cheia de ódio, destruindo por causa do antigo rancor."
,"16":"Por isso, assim diz o Senhor Javé: Vou estender a mão contra os filisteus, vou acabar com os cereteus e destruir o que sobrar da gente do litoral."
,"17":"Vou realizar uma vingança terrível contra eles, com violentos castigos, para que saibam que Eu sou Javé, quando Me vingar deles»."
}`)
	CurrentBook.AddChapter(26, `{
"1":"No primeiro dia do mês do ano onze, recebi a seguinte mensagem de Javé:"
,"2":"«Criatura humana, Tiro falou assim a respeito de Jerusalém: 'Viva! A porta dos povos foi arrombada e caiu em meu poder; a sua riqueza foi devastada!'"
,"3":"Por isso, assim diz o Senhor Javé: Eis que venho contra ti, cidade de Tiro. Levanto contra ti muitas nações, como o mar faz levantar as suas ondas."
,"4":"Elas rebentarão as muralhas de Tiro e derrubarão as suas torres. Varrerei dela o pó e transformá-la-ei em pedra nua."
,"5":"Ela ficará como secadouro de redes no meio do mar, porque Eu falei - oráculo do Senhor Javé. Tiro tornar-se-á presa fácil para outras nações."
,"6":"As cidades do interior serão liquidadas à espada. E assim eles ficarão a saber que Eu sou Javé."
,"7":"Assim diz o Senhor Javé: Do Norte, Eu mando contra Tiro a Nabucodonosor, o rei da Babilónia, o rei dos reis, com cavalos, carros, cavaleiros e numeroso exército."
,"8":"Ele matará pela espada as suas cidades do interior; construirá trincheiras contra ti, levantará terraços e armará um paredão de escudos."
,"9":"Golpeará as tuas muralhas com aríetes, com as suas máquinas de guerra."
,"10":"A multidão dos seus cavalos cobrir-te-á de pó. As tuas muralhas tremerão com o tropel dos cavalos e o barulho dos carros, que entrarão pelas tuas portas, como se entrassem na cidade por uma brecha da muralha."
,"11":"Ele calcará as tuas ruas com as patas dos cavalos. Matará o teu povo à espada e deitará por terra as tuas colunas protectoras."
,"12":"Saquearão as tuas riquezas, roubarão as tuas mercadorias, destruirão as tuas muralhas, demolirão os teus esplêndidos palácios e deitarão ao mar as tuas pedras, madeiras e escombros."
,"13":"Acabarei com o rumor dos teus cânticos, e nunca mais se ouvirá a música das tuas liras."
,"14":"Transformar-te-ei em pedra nua. Ficarás como um secadouro de redes, e nunca mais serás reconstruída, porque Eu, Javé, assim falei - oráculo do Senhor Javé."
,"15":"Assim diz o Senhor Javé a Tiro: As ilhas tremerão com o estrondo da tua queda, com o gemido dos teus feridos e a morte violenta dos que em ti cairão."
,"16":"Todos os príncipes do mar descerão dos seus tronos, tirarão os seus mantos e despojar-se-ão das suas vestes bordadas. Vão vestir-se de terror e sentar-se no chão, tremendo de susto, apavorados por tua causa."
,"17":"E, falando de ti, vão entoar esta lamentação: 'Como desapareceste dos mares, cidade famosa, poderosa sobre os mares! Ela e seus moradores espalhavam o terror sobre todo o continente!"
,"18":"Agora, no dia da tua queda, as ilhas tremem, as ilhas do mar apavoram-se com o teu fim!'"
,"19":"Assim diz o Senhor Javé: Quando fizer de ti uma cidade destruída, igual às cidades onde ninguém mora; quando fizer levantar contra ti o oceano, e quando as ondas enormes te cobrirem,"
,"20":"far-te-ei descer, como aqueles que descem à cova para se juntarem às gerações passadas. Far-te-ei morar no fundo da terra, nas ruínas perpétuas, como os que descem à cova. Assim, não voltarás a reinar nem a enfeitar a terra dos vivos."
,"21":"Farei de ti um objecto de espanto, e deixarás de existir. Vão procurar-te, mas nunca mais te encontrarão - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, entoa uma lamentação sobre Tiro."
,"3":"Diz a Tiro, que está situada à beira-mar e que faz comércio com povos e numerosas ilhas: Assim diz o Senhor Javé: Tiro, tu dizias: 'Eu sou um navio de beleza perfeita!'"
,"4":"O Coração do mar era o teu território e os teus construtores esmeraram-se na tua beleza."
,"5":"Fizeram com pinho de Sanir o teu madeiramento e com cedros do Líbano fizeram os teus mastros."
,"6":"Fabricaram os teus remos com carvalhos de Basã. O teu convés era de marfim, incrustado em madeira de cipreste trazida das ilhas de Cetim."
,"7":"As tuas velas eram de linho bordado do Egipto, formando a tua bandeira. A tua cobertura era de púrpura e escarlate das ilhas de Elisa."
,"8":"Cidadãos de Sidónia e Arvad eram os teus remadores. Os sábios de Tiro eram os teus pilotos."
,"9":"Os anciãos de Gebal e seus sábios lá estavam para reparar as tuas avarias. Todos os navios do mar e seus marinheiros faziam comércio contigo."
,"10":"Persas, lídios e líbios eram guerreiros do teu exército: penduravam os seus escudos e capacetes em ti, e davam-te força."
,"11":"Os de Arvad com o seu exército ficavam ao redor das tuas muralhas. Os gamadeus vigiavam-te as torres e penduravam os seus escudos ao longo das muralhas, dando-te grande beleza."
,"12":"Társis era teu freguês por causa das riquezas que possuías; trocavam prata, ferro, estanho e chumbo pelas tuas mercadorias."
,"13":"Javã, Tubal e Mosoc negociavam contigo, trocando escravos e objectos de bronze por mantimentos."
,"14":"De Bet-Togorma traziam cavalos, corcéis e jumentos."
,"15":"Os dadanitas negociavam contigo. Muitas ilhas eram tuas clientes, trazendo marfim e ébano como tributo."
,"16":"Edom era teu freguês por causa da variedade dos teus produtos; em troca, trazia turquesa, púrpura escarlate, linho, coral e rubis."
,"17":"Judá e o país de Israel também negociavam contigo, fornecendo trigo de Minit, perfumes, mel, azeite e bálsamo."
,"18":"Também Damasco era tua cliente, por causa da riqueza que possuías e pela variedade das tuas mercadorias; em troca, trazia vinho de Helbon e lã de Saar."
,"19":"Dã e Javã forneciam de Uzal ferro trabalhado, cássia e cana aromática, em troca das tuas mercadorias."
,"20":"Dadã negociava artigos de montaria."
,"21":"Também a Arábia e os xeques de Cedar eram teus clientes, negociando contigo cordeiros, carneiros e cabritos."
,"22":"Os comerciantes de Sabá e de Reema também negociavam contigo, fornecendo toda a espécie de perfumes, pedras preciosas e ouro, em troca das tuas mercadorias."
,"23":"Harã, Quene e Éden, os comerciantes de Sabá, da Assíria e de Quelmad, negociavam contigo."
,"24":"Nos teus mercados, vendiam tecidos caros: mantos de púrpura, bordados, tapetes coloridos e cordas retorcidas e fortes."
,"25":"Os navios de Társis transportavam as tuas mercadorias. Assim, tornaste-te rica e gloriosa no meio do mar."
,"26":"Os teus remadores levaram-te por vastos mares. Mas o vento oriental quebrou-te no meio do mar,"
,"27":"e as tuas riquezas, artigos e mercadorias, marinheiros e pilotos, oficiais de reparação e vendedores, todos os guerreiros e toda a tripulação de bordo serão engolidos pelo mar, no dia do teu naufrágio."
,"28":"As praias vão tremer com o grito dos marinheiros."
,"29":"Todos os remadores saltarão dos seus navios. Marinheiros e capitães ficarão em terra."
,"30":"Farão lamentações por ti e gritarão amargamente; deitarão cinza na cabeça e rolarão no pó."
,"31":"Por ti, raparão a cabeça e vestir-se-ão de luto. Por ti, chorarão amargurados, com tristeza de funeral."
,"32":"Por ti, entoarão uma lamentação e cantarão, dizendo: 'Quem era como Tiro, uma fortaleza no meio do mar?'"
,"33":"Trazendo mercadorias de além-mar, abastecias muitos povos. Com preciosidades e produtos enriquecias os reis da Terra."
,"34":"Agora, estás despedaçada no meio do mar, dentro das águas profundas; a tua carga e os teus tripulantes afundaram-se contigo."
,"35":"Todos os habitantes das ilhas ficam espantados, e os seus reis ficam com o rosto transtornado, com arrepios de pavor."
,"36":"Os mercadores de todas as nações assobiam assustados, porque te tornaste objecto de espanto, e nunca mais existirás»."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, diz ao príncipe de Tiro: Assim diz o Senhor Javé: O orgulho apoderou-se do teu coração e disseste: 'Eu sou um deus, sentado em trono divino, no coração do mar'. Mas és apenas homem e não deus. Julgavas ser igual aos deuses."
,"3":"De facto, és mais sábio que Danel, e nenhum mistério te é obscuro."
,"4":"Com a tua sabedoria e inteligência, adquiriste riqueza e acumulaste ouro e prata em teus tesouros."
,"5":"A tua esperteza no comércio é tão grande, que multiplicaste a tua fortuna e te elevaste com a força da riqueza."
,"6":"Por isso, assim diz o Senhor Javé: No teu coração igualaste-te a Deus."
,"7":"Pois bem! Vou trazer contra ti os mais ferozes povos estrangeiros: eles desembainharão a espada contra a tua bela sabedoria e profanarão o teu esplendor;"
,"8":"far-te-ão descer à cova e morrerás de morte violenta, no coração do mar."
,"9":"Ainda ousarás dizer diante dos teus carrascos: 'Sou um deus'? Mas tu és apenas homem e não deus, entregue ao poder de quem te matará."
,"10":"Terás a morte dos incircuncisos pela mão de estrangeiros, porque Eu falei - oráculo do Senhor Javé»."
,"11":"Então recebi a seguinte mensagem de Javé:"
,"12":"«Criatura humana, entoa uma lamentação contra o rei de Tiro, e diz: Assim diz o Senhor Javé: Eras um modelo de perfeição, cheio de sabedoria e beleza perfeita."
,"13":"Moravas no paraíso, no jardim de Deus, coberto de pedras preciosas de todas as espécies: rubi, topázio, diamante, crisólito, cornalina, jaspe, lápis-lazúli, turquesa e berilo; e de ouro eram os teus brincos e jóias. Todas estas coisas foram preparadas no dia em que foste criado."
,"14":"Fiz de ti um querubim protector de asas abertas. Estavas na alta montanha de Deus, passeavas entre pedras de fogo."
,"15":"Desde que foste criado, eras perfeito em todos os teus passos, até que se encontrou a maldade em ti."
,"16":"De tanto negociar, encheste-te de violência e pecados. Por isso te expulsei da montanha de Deus e te fiz perecer, ó querubim protector, no meio das pedras de fogo."
,"17":"O teu coração encheu-se de orgulho com a tua beleza, e a tua sabedoria corrompeu-se por causa do teu esplendor. Por isso atirei-te ao chão, fazendo de ti um espectáculo para os reis."
,"18":"Com a tua grande injustiça e comércio desonesto, profanaste o teu santuário. Por isso fiz brotar dentro de ti um fogo para te devorar. Eu reduzi-te a cinzas no chão, aos olhos dos que te admiravam."
,"19":"Todos os povos que te conheceram ficaram espantados diante de ti, porque te tornaste um objecto de espanto, e nunca mais existirás»."
,"20":"Recebi de Javé a seguinte mensagem:"
,"21":"«Criatura humana, olha agora para Sidónia e profetiza contra ela,"
,"22":"dizendo: Assim diz o Senhor Javé: Aqui estou Eu contra ti, Sidónia. Serei glorificado dentro de ti; todos reconhecerão que Eu sou Javé, quando fizer justiça contra ti, manifestando a minha santidade."
,"23":"Mandarei a peste contra ti, e o sangue escorrerá pelas tuas ruas. Dentro de ti, os feridos irão morrendo, cercados pela espada do inimigo. Então ficarão a saber que Eu sou Javé»."
,"24":"«Para a casa de Israel não haverá mais espinho que fira ou ferrão doloroso, entre todos os seus vizinhos que a desprezam. Então ficarão a saber que Eu sou Javé."
,"25":"Assim diz o Senhor Javé: Quando Eu reunir os israelitas do meio dos povos por onde se espalharam, vou mostrar entre os israelitas a minha santidade diante das nações. Então eles voltarão para a sua Terra, a Terra que dei ao meu servo Jacob."
,"26":"Nela habitarão com segurança, construirão casas e plantarão vinhas. Habitarão em segurança, quando eu executar a minha sentença contra os vizinhos que os ameaçam. Então eles ficarão a saber que Eu sou Javé, o seu Deus»."
}`)
	CurrentBook.AddChapter(29, `{
"1":"No dia doze do décimo mês do ano dez, recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, olha agora para o Faraó, rei do Egipto, e profetiza contra ele e contra todo o Egipto."
,"3":"Diz: Assim diz o Senhor Javé: Aqui estou Eu contra ti, Faraó, rei do Egipto, enorme dragão deitado no meio do rio Nilo. Tu afirmas: 'O Nilo é meu, fui eu que o fiz'."
,"4":"Pois bem! Cravarei arpões no teu queixo e prenderei os peixes do rio nas tuas escamas. Depois puxar-te-ei para fora do rio com todos os peixes colados às tuas escamas."
,"5":"Vou atirar-te para o deserto, com todos os peixes do teu rio. E cairás em pleno campo, e não serás recolhido nem sepultado. Transformar-te-ei em pasto para os animais do campo e para as aves do céu."
,"6":"Os habitantes do Egipto ficarão a saber que eu sou Javé, porque foram apenas um apoio de cana para a casa de Israel."
,"7":"Quando pegaram em ti partiste-te e feriste-lhes a mão. Quando em ti se apoiaram, quebraste e eles caíram."
,"8":"Por isso, assim diz o Senhor Javé: Eis que vou trazer contra ti a espada e eliminar homens e animais."
,"9":"A terra do Egipto ficará arrasada e em ruínas. Então eles ficarão a saber que Eu sou Javé. Tu disseste: 'O Nilo é meu, fui eu que o fiz'."
,"10":"Pois bem! Aqui estou Eu contra ti e contra o teu rio Nilo. Entregarei a terra do Egipto à ruína e à destruição, desde Magdol até Siene, na fronteira da Etiópia."
,"11":"Pelo Egipto não passará pé humano ou casco de animal, e ficará despovoado durante quarenta anos."
,"12":"Vou fazer do Egipto a mais desolada de todas as terras. Durante quarenta anos, as suas cidades ficarão mais devastadas do que todas as cidades em ruínas. Vou espalhar os egípcios no meio das nações e dispersá-los entre os países."
,"13":"Assim diz o Senhor Javé: Depois de quarenta anos, reunirei os egípcios do meio de todos os povos por onde foram espalhados."
,"14":"Mudarei a sorte do Egipto, fazendo voltar os seus cativos para a região de Patros, sua pátria, onde formarão um reino insignificante."
,"15":"Será o menor dos reinos, e nunca mais sobressairá entre as nações. Farei que seja reduzido, para nunca mais oprimir outros povos."
,"16":"O Egipto também nunca mais poderá servir de apoio à nação israelita. Pelo contrário, ele recordará as faltas que Israel cometia quando pedia ajuda ao Egipto. Então ficarão a saber que Eu sou Javé»."
,"17":"No dia primeiro do primeiro mês do ano vinte e sete, recebi a seguinte mensagem de Javé:"
,"18":"«Criatura humana, Nabucodonosor, o rei da Babilónia, impôs ao seu exército um trabalho muito difícil na guerra contra Tiro. Diante de Tiro, ficaram todos carecas e com os ombros esfolados, sem conseguirem nenhuma recompensa para o rei ou para o seu exército, apesar de todo o esforço com que lutaram contra essa cidade."
,"19":"Por isso, assim diz o Senhor Javé: Vou entregar a terra do Egipto a Nabucodonosor, rei da Babilónia. Ele pilhará as riquezas do Egipto, saqueará e roubará o que puder, para pagar ao próprio exército."
,"20":"Pelo trabalho que tiveram em Tiro, vou dar-lhes a terra do Egipto, pois trabalharam para Mim - oráculo do Senhor Javé."
,"21":"Nesse dia, farei brotar uma força em Israel e abrirei a tua boca no meio deles. E assim ficarão a saber que Eu sou Javé»."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, profetiza: Assim diz o Senhor Javé: Gritai: 'Ah! Que dia!'"
,"3":"Porque o dia aproxima-se, aproxima-se o dia de Javé; o tempo das nações será dia de nuvens escuras."
,"4":"A espada chegará ao Egipto. A agitação estará em Cuch, quando multidões de feridos começarem a tombar no Egipto, quando lhe levarem as riquezas, e os alicerces do Egipto ficarem arrasados."
,"5":"Cuch, Fut, Lud, a Arábia inteira, Lub e os filhos do país da aliança cairão com eles pela espada."
,"6":"Assim diz Javé: Os aliados do Egipto cairão, e a sua força presunçosa ruirá por terra. Desde Magdol até Siene, todos morrerão pela espada - oráculo do Senhor Javé."
,"7":"O Egipto será um deserto entre terras devastadas, e as suas cidades estarão entre cidades desoladas."
,"8":"Então ficarão a saber que Eu sou Javé, quando incendiar o Egipto, e quando todos os seus auxiliares forem esmagados."
,"9":"Nesse dia, alguns mensageiros, enviados por Mim, irão de navio, para perturbar a tranquilidade de Cuch. Eles tremerão no dia do Egipto, porque o dia aproxima-se."
,"10":"Assim diz o Senhor Javé: Pela mão de Nabucodonosor, o rei da Babilónia, vou acabar com a opulência do Egipto."
,"11":"Ele com o seu exército, o povo mais violento que existe, virão para arrasar o país. Puxarão da espada contra o Egipto, e deixarão o país coberto de cadáveres."
,"12":"Transformarei o rio Nilo em deserto. Venderei o país a criminosos. Pelas mãos de estrangeiros arrasarei a terra e seus produtos. Fui Eu, Javé, fui Eu que falei."
,"13":"Assim diz o Senhor Javé: Derrubarei os ídolos imundos e acabarei com os deuses de Mênfis, e nunca mais haverá chefes na terra do Egipto. Espalharei o terror,"
,"14":"arrasarei Patros, incendiarei Tânis e farei justiça contra Tebas."
,"15":"Derramarei o meu furor sobre Sin, a fortaleza do Egipto, e acabarei com a multidão de Tebas."
,"16":"Incendiarei o Egipto: Sin contorcer-se-á de dor, Tebas será arrombada e Mênfis será inundada."
,"17":"Os jovens de Heliópolis e Bubaste morrerão pela espada, e a população dessas cidades irá para o exílio."
,"18":"Em Táfnis haverá trevas ao meio-dia, quando Eu quebrar a opressão do Egipto. Acabarei com o orgulho da sua força: a capital será coberta por uma nuvem, e as cidades do interior serão levadas para o exílio."
,"19":"Ao executar a minha sentença contra o Egipto, eles ficarão a saber que Eu sou Javé»."
,"20":"No dia sete do primeiro mês do ano onze, recebi de Javé a seguinte mensagem:"
,"21":"«Criatura humana, eu quebrei o braço do Faraó, rei do Egipto. Mas ninguém lhe curou o braço: não lhe aplicaram remédio nem lhe puseram ligaduras, a fim de lhe dar força para empunhar a espada."
,"22":"Por isso, assim diz o Senhor Javé: Estou contra o Faraó, rei do Egipto. Vou quebrar-lhe os braços, tanto aquele que está são, como aquele que já está quebrado, e assim farei cair a espada da sua mão."
,"23":"Espalharei os egípcios entre as nações e dispersá-los-ei pelos países."
,"24":"Darei força ao braço do rei da Babilónia e colocarei a minha espada na sua mão. Quebrarei os braços do Faraó, e ele gemerá de dor, derrotado, aos pés do rei da Babilónia."
,"25":"Fortalecerei os braços do rei da Babilónia, e os braços do Faraó fraquejarão. Eles ficarão a saber que Eu sou Javé, quando colocar a minha espada na mão do rei da Babilónia e ele atacar com ela a terra do Egipto."
,"26":"Espalharei os egípcios entre as nações e dispersá-los-ei pelos países. Então eles ficarão a saber que Eu sou Javé»."
}`)
	CurrentBook.AddChapter(31, `{
"1":"No primeiro dia do terceiro mês do ano onze, recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, diz ao Faraó, rei do Egipto, e a todo o seu exército: Com quem te pareces na tua grandeza?"
,"3":"És como um cedro do Líbano, com bela ramagem, sombra espaçosa, de tronco alto, com a ponta entre as nuvens."
,"4":"A água faz crescer o cedro, o abismo fê-lo subir, enviando os seus rios para o solo onde ele estava plantado e mandando os seus riachos para todas as árvores do campo."
,"5":"Por isso, ele superou em altura todas as árvores do campo. Os seus rebentos multiplicaram-se e os seus ramos estenderam-se, por causa das águas que lhe deram crescimento."
,"6":"Entre os seus rebentos, as aves do céu fizeram os ninhos; debaixo dos seus ramos, as feras do campo tinham as suas crias, e à sua sombra sentaram-se as grandes nações."
,"7":"Era grande e bonito, com os ramos compridos, pois as suas raízes mergulhavam em águas abundantes."
,"8":"Nenhum cedro o igualava no jardim de Deus; nenhum cipreste se podia comparar com a sua ramagem; os pinheiros não se comparavam sequer a um dos seus ramos; nenhuma árvore no jardim de Deus se lhe comparava em beleza."
,"9":"Fui Eu que o fiz assim bonito e lhe multipliquei os ramos. Por isso o invejavam todas as árvores do paraíso, que estavam no jardim de Deus."
,"10":"Por isso, assim diz o Senhor Javé: Ele tornou-se tão alto, tocou com a sua ponta as nuvens e encheu-se de soberba, por causa da sua grandeza."
,"11":"Pois bem! Vou entregá-lo a uma nação mais poderosa, para que o trate de acordo com a sua injustiça."
,"12":"Os bárbaros mais ferozes cortaram-no e lançaram-no por terra: os seus ramos caíram pelos vales, os seus rebentos partidos espalhavam-se pelas ravinas do país. Os povos da terra fugiram da sua sombra e abandonaram-no."
,"13":"As aves do céu aninham-se nos seus restos e as feras selvagens abrigam-se debaixo dos seus ramos."
,"14":"Tudo isto para que nenhuma árvore bem regada fique muito alta, nem chegue até às nuvens, nem confie na sua altura a árvore bem irrigada; porque todas vão morrer e descer ao fundo da terra, juntamente com as criaturas humanas que descem à cova."
,"15":"Assim diz o Senhor Javé: Quando o cedro desceu à mansão dos mortos, por causa dele decretei luto às águas subterrâneas: fiz parar os rios, e as águas torrenciais estancaram. Por causa dele afligi o Líbano e todas as árvores do campo murcharam."
,"16":"Com o barulho da sua queda, fiz tremer as nações, quando o atirei para a mansão dos mortos, juntamente com os que descem à sepultura. Ficaram todos contentes no fundo da terra: as árvores do paraíso, o que há de mais belo no Líbano e todas as árvores bem regadas."
,"17":"Elas também desceram com ele para a mansão dos mortos, para junto daqueles que tombaram ao fio da espada; pereceram os que cobiçavam a sua sombra no meio das nações."
,"18":"Entre as árvores do paraíso qual delas te igualava em glória e grandeza? Também serás atirado, com as árvores do paraíso, para o fundo da terra, e ficarás entre os incircuncisos e aqueles que foram mortos pela espada. É isso que vai acontecer ao Faraó e a todo o seu exército - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(32, `{
"1":"No primeiro dia do décimo segundo mês do ano doze, recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, entoa uma lamentação sobre o Faraó, rei do Egipto, dizendo: Parecias um leão entre as nações, mas eras um crocodilo do rio Nilo, agitando os seus canais. Turvavas as águas com as patas e sujavas os rios."
,"3":"Por isso, assim diz o Senhor Javé: Lançarei a minha rede num ajuntamento de povos e eles apanhar-te-ão nas minhas malhas."
,"4":"Vou deitar-te ao chão e abandonar-te no solo. Farei pousar em ti todas as aves do céu, e saciarei com a tua carne todas as feras selvagens."
,"5":"Espalharei o teu cadáver pelos montes e encherei os vales com os teus restos."
,"6":"Regarei a terra com o teu sangue, que correrá pelos montes e inundará o leito dos riachos."
,"7":"Quando te apagar, cobrirei o céu, escurecerei as estrelas, taparei o Sol com as nuvens, e a Lua deixará de brilhar."
,"8":"Por tua causa, apagarei todos os astros do céu e deixarei o teu país em plena escuridão - oráculo do Senhor Javé."
,"9":"Quando Eu levar aos países desconhecidos a notícia da tua ruína no meio das nações, farei que muitos povos se entristeçam por tua causa."
,"10":"Farei que muitos povos se apavorem e os seus reis tremam com o que te irá acontecer, quando na frente deles puxar da minha espada. No dia da tua queda, eles tremerão assustados pela sua vida."
,"11":"Assim diz o Senhor Javé: A espada do rei da Babilónia alcançar-te-á."
,"12":"Matarei todo o teu povo com a espada dos soldados da mais violenta das nações. Eles abaterão o orgulho do Egipto, e todo o teu imenso exército será exterminado."
,"13":"Eliminarei todo o gado à beira do grande rio. A sua água jamais será turvada pelos pés de qualquer homem, nem nenhum casco de animal tornará a sujá-la."
,"14":"Então acalmarei as suas águas e farei correr os seus rios como azeite - oráculo do Senhor Javé."
,"15":"Quando Eu transformar o Egipto em deserto e deixar o país despovoado, quando matar todos os seus habitantes, eles ficarão a saber que Eu sou Javé."
,"16":"Esta é a lamentação que deverá ser cantada pelas capitais das nações. Elas cantá-la-ão sobre o Egipto e sobre todo o exército - oráculo do Senhor Javé»."
,"17":"No dia quinze do primeiro mês do ano doze, recebi de Javé a seguinte mensagem:"
,"18":"«Criatura humana, entoa uma lamentação sobre o exército do Egipto. Fá-lo descer, com as capitais das nações famosas, até ao fundo da terra, para junto daqueles que descem à sepultura."
,"19":"Em que coisa és diferente dos outros? Desce e deita-te com os incircuncisos."
,"20":"Cairão entre os mortos pela espada, ele e todo o seu exército."
,"21":"Na mansão dos mortos, os seus aliados, guerreiros valorosos, dir-lhe-ão: 'Desce e repousa com os teus aliados entre os incircuncisos mortos pela espada'."
,"22":"Lá está a Assíria com todo o seu exército à volta do seu sepulcro; todos caíram mortos pela espada."
,"23":"Porque os túmulos deles estão no fundo da cova e os seus exércitos ao redor do seu túmulo; todos eles foram mortos pela espada, por terem aterrorizado o mundo dos vivos."
,"24":"Lá está Elam com todo o seu exército à volta do seu sepulcro; todos caíram mortos pela espada, desceram incircuncisos para o fundo da terra, por terem aterrorizado o mundo dos vivos. Carregam a sua vergonha com os que baixam à cova."
,"25":"O sepulcro deles está entre os mortos pela espada e os seus exércitos ao redor do seu túmulo; todos incircuncisos, mortos pela espada, por terem aterrorizado o mundo dos vivos. Carregam a sua vergonha com os que baixam à cova entre os que morreram pela espada."
,"26":"Lá estão Mosoc e Tubal com todos os seus exércitos ao redor do seu sepulcro; todos incircuncisos, mortos pela espada, por terem aterrorizado o mundo dos vivos."
,"27":"Eles não repousam como os heróis, que morreram no passado e que desceram à mansão dos mortos com as armas de guerra, com a espada debaixo da cabeça e o escudo sobre o corpo, porque esses heróis eram um terror para o mundo dos vivos."
,"28":"Mas serás despedaçado no reino dos incircuncisos e com os mortos pela espada."
,"29":"Lá está Edom, com os seus reis e chefes. Apesar da sua valentia, foram colocados entre os mortos pela espada e descansam com os incircuncisos e com os que descem à cova."
,"30":"Por causa do terror provocado pela sua valentia, lá estão os comandantes do Norte e todos os sidónios que desceram com os mortos pela espada. Porque são incircuncisos, repousam envergonhados com os mortos pela espada, carregando a sua vergonha com os que descem à cova."
,"31":"Ao vê-los, o Faraó conformar-se-á com a perda do seu exército. O Faraó e todo o seu exército serão mortos pela espada - oráculo do Senhor Javé."
,"32":"O Faraó com todo o seu exército espalharam o terror pelo mundo dos vivos, e por isso terá que repousar no meio dos incircuncisos, com os mortos pela espada - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, diz ao teu povo: Quando Eu mando a espada contra um país, o povo desse país escolhe uma pessoa e coloca-a como vigia."
,"3":"Se o vigia vê chegar a espada, toca a trombeta para avisar o povo."
,"4":"Se alguém ouve a trombeta e não presta atenção, a espada virá e apanhá-lo-á. E ele será responsável pelo seu próprio sangue,"
,"5":"porque ouviu o toque da trombeta, mas não se preveniu, e terá que responder com o seu próprio sangue; se tivesse prestado atenção, teria salvado a própria vida."
,"6":"Se o vigia vê chegar a espada e não toca a trombeta, e o povo não foi avisado, a espada chega e surpreende alguns do povo; estes morrem por causa da sua própria culpa, mas é ao vigia que eu pedirei contas do sangue."
,"7":"Criatura humana, Eu coloquei-te como vigia da casa de Israel. Quando ouvires a minha mensagem, tens de os avisar."
,"8":"Se ao injusto Eu digo: 'Injusto, é certo que vais morrer', se tu não avisas o injusto para que mude de comportamento, o injusto morrerá por causa da sua própria culpa, mas é a ti que Eu pedirei contas do seu sangue."
,"9":"Mas se avisares o injusto para que mude de comportamento, e ele não mudar, ele morrerá por causa da sua própria culpa, mas tu terás salva a tua vida»."
,"10":"«Criatura humana, diz à casa de Israel: Vós dizeis: 'Nós já temos muitos crimes e pecados às costas. Por causa deles, estamos prestes a desaparecer. Como é que ainda poderemos sobreviver?'"
,"11":"Diz-lhes: Juro pela minha vida - oráculo do Senhor Javé: Não sinto nenhum prazer com a morte do injusto. O que Eu quero, é que ele mude de comportamento e viva. Convertei-vos, convertei-vos do vosso mau comportamento. Porque quereis morrer, israelitas?"
,"12":"Criatura humana, diz ao teu povo: Nem a justiça do justo o salvará no dia em que ele pecar, nem a injustiça do injusto o arruinará quando ele se converter da sua injustiça. Portanto, o justo não poderá viver pela sua justiça, no dia em que pecar."
,"13":"Se Eu disser que o justo vai sobreviver, e ele, confiando no bem que já fez, começar a praticar a injustiça, todo o bem que tiver feito nunca mais será lembrado; ele morrerá por causa da injustiça cometida."
,"14":"Se Eu disser ao injusto que ele vai morrer, e ele se converter do seu pecado e praticar o direito e a justiça,"
,"15":"devolvendo o penhor recebido, restituindo o que roubou, passando a viver conforme os preceitos que dão vida, de modo a não praticar a injustiça, sobreviverá e não morrerá."
,"16":"Ninguém lhe recordará os pecados que cometeu; se fez o que é justo e recto, continuará vivo."
,"17":"Os teus compatriotas retrucarão: 'Não é justa a maneira do Senhor agir!' Pelo contrário: a vossa maneira de agir é que não é justa."
,"18":"Quando aquele que era justo deixar de ser honesto e começa a praticar a injustiça, merece morrer, por causa da injustiça que passou a praticar."
,"19":"Quando aquele que é mau desiste das suas maldades e começa a praticar o que é justo e honesto, merece continuar vivo por causa disso."
,"20":"Mas vós continuais a dizer: 'A maneira de agir do Senhor não é justa!' Pois bem, casa de Israel! Eu vou julgar-vos de acordo com a maneira de viver de cada um»."
,"21":"No dia cinco do décimo mês do ano doze do nosso exílio, um fugitivo de Jerusalém veio procurar-me para me dizer que a cidade tinha sido destruída."
,"22":"Na tarde anterior, antes de o fugitivo me procurar, o poder de Javé tinha pousado sobre mim, e abriu a minha boca de manhã, quando me procurou. A minha boca abriu-se e não voltei a ficar mudo."
,"23":"Recebi de Javé a seguinte mensagem:"
,"24":"«Criatura humana, os habitantes das ruínas na terra de Israel dizem: 'Abraão era um só e foi dono desta terra. Pois nós agora somos muitos, e com maior razão recebemos esta terra como propriedade definitiva!»"
,"25":"Pois diz-lhes: Assim diz o Senhor Javé: Vós comeis no alto dos montes, levantais os olhos para os ídolos e derramais sangue. E ainda continuais donos da terra?"
,"26":"Apoiais-vos nas espadas, praticais abominações, cada um desrespeita a mulher do seu próximo. E ainda continuareis a ser donos da terra?"
,"27":"Pois diz-lhes: Assim diz o Senhor Javé: Juro pela minha vida que aqueles que estão entre as ruínas serão mortos pela espada, aqueles que estão no campo serão alimento para as feras, e aqueles que estão em grutas e cavernas vão morrer de peste."
,"28":"Farei do país um lugar arrasado e deserto. O orgulho da tua força vai acabar-se e os montes de Israel ficarão desertos, sem nenhum transeunte."
,"29":"Quando Eu fizer de Israel um lugar arrasado e deserto, por causa de todas as abominações que praticaram, eles ficarão a saber que Eu sou Javé»."
,"30":"«Criatura humana, a gente do teu povo critica-te ao longo das muralhas e às portas das casas. Vivem comentando entre si: 'Vamos ver qual é a palavra que Javé nos vai mandar!'"
,"31":"Depois, em bandos vêm procurar-te, sentam-se à tua frente e ouvem o que lhes dizes. Mas não praticam nada. Praticam as mentiras que eles mesmos dizem. E o seu coração só se preocupa com o lucro."
,"32":"Para eles, és uma canção de amor: voz bonita e acompanhamento agradável. Eles ouvem o que dizes mas não põem nada em prática."
,"33":"Mas quando se realizar o que dizes, e será em breve, vão ficar a saber que havia um profeta no meio deles»."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, profetiza contra os pastores de Israel, dizendo: Assim diz o Senhor Javé: Ai dos pastores de Israel que são pastores de si mesmos! Não é do rebanho que os pastores deveriam cuidar?"
,"3":"Vós bebeis o leite, vestis a lã, matais as ovelhas gordas, mas não cuidais do rebanho."
,"4":"Não procurais fortalecer as ovelhas fracas, não medicais as que estão doentes, não curais as que se feriram, não fazeis voltar as que se desgarraram e não procurais aquelas que se extraviaram. Pelo contrário, dominais com violência e opressão."
,"5":"Por falta de pastor, as minhas ovelhas espalharam-se e tornaram-se pasto das feras."
,"6":"As minhas ovelhas espalharam-se e vaguearam sem rumo pelos montes e vales. As minhas ovelhas espalharam-se por toda a terra, e ninguém as procura para cuidar delas."
,"7":"Por isso, vós, pastores, ouvi a palavra de Javé:"
,"8":"Juro por minha vida - oráculo do Senhor Javé: As minhas ovelhas tornaram-se presa fácil e servem de pasto às feras. Não têm pastor, porque os meus pastores não se preocupam com o meu rebanho: só cuidam de si mesmos, em vez de cuidarem do meu rebanho."
,"9":"Por isso, pastores, ouvi a palavra de Javé!"
,"10":"Assim diz o Senhor Javé: Vou pôr-Me contra os pastores. Vou pedir-lhes contas do meu rebanho, e não deixarei mais que eles cuidem do meu rebanho. Deste modo, os pastores não cuidarão de si mesmos. Arrancar-lhes-ei da boca as minhas ovelhas e estas deixarão de lhes servir de alimento»."
,"11":"«Assim diz o Senhor Javé: Eu mesmo vou procurar as minhas ovelhas."
,"12":"Como o pastor conta o seu rebanho, quando está no meio das suas ovelhas que se haviam dispersado, Eu também contarei as minhas ovelhas e reuni-las-ei de todos os lugares por onde se haviam dispersado, nos dias nebulosos e escuros."
,"13":"Eu retirá-las-ei do meio dos povos e reuni-las-ei de todas as regiões, e fá-las-ei voltar à sua terra. Eu próprio cuidarei delas como pastor, nos montes de Israel, nos vales e em todos os lugares habitados do país."
,"14":"Vou apascentá-las nas melhores pastagens, os seus redis serão nos altos montes de Israel. Poderão repousar num bom redil, e terão pastos abundantes sobre os montes de Israel."
,"15":"Eu mesmo conduzirei as minhas ovelhas para o pasto e fá-las-ei repousar - oráculo do Senhor Javé."
,"16":"Procurarei aquela que se perder, reconduzirei aquela que se desgarrar, curarei a que se ferir, fortalecerei a que estiver fraca. Quanto à ovelha gorda e forte, Eu destruí-la-ei, pois cuidarei do meu rebanho conforme o direito»."
,"17":"«Quanto a vós, minhas ovelhas, assim diz o Senhor Javé: Vou julgar entre ovelha e ovelha, entre carneiros e bodes."
,"18":"É pouco para vós pastardes no melhor pasto? Então porque é que calcais o resto do pasto? É pouco beberdes água límpida? Porque é que ainda sujais o resto com os pés?"
,"19":"Depois de tudo, as minhas ovelhas têm que pastar no que vós calcastes e beber a água que os vossos pés sujaram."
,"20":"Por isso, assim diz o Senhor Javé: Vou colocar-Me como juiz entre a ovelha gorda e a ovelha magra."
,"21":"Com as ancas e com as espáduas empurrastes as ovelhas mais fracas e ainda as feris com chifradas, até as expulsar para longe."
,"22":"Pois bem! Vou salvar as minhas ovelhas, e elas não serão mais presa fácil. Eu serei juiz entre ovelha e ovelha»."
,"23":"«Farei surgir um pastor para cuidar das minhas ovelhas. Será o meu servo David. Ele cuidará delas e será o seu pastor."
,"24":"Eu, Javé, serei o seu Deus, e o meu servo David será o seu chefe. Fui eu, Javé, que falei."
,"25":"Vou fazer com elas uma aliança de paz: acabarei com as feras, de modo que elas poderão deitar-se seguras no deserto e dormir tranquilas no meio dos bosques."
,"26":"Farei do país e da minha montanha uma bênção. Mandarei chuva no devido tempo, e será uma chuva abençoada."
,"27":"A árvore do campo dará o seu fruto, a terra produzirá e todos habitarão com segurança na própria terra. Quando Eu quebrar as correntes do seu jugo e os libertar do poder dos tiranos, eles ficarão a saber que Eu sou Javé."
,"28":"Eles não serão mais presa fácil das nações, e as feras nunca mais os irão devorar. Viverão tranquilamente, sem que ninguém os amedronte."
,"29":"Eu lhes darei uma lavoura farta, e não haverá mais mortos de fome no país, nem terão mais de se humilhar diante das outras nações."
,"30":"Então eles ficarão a saber que Eu, Javé, estou com eles, e que eles, a casa de Israel, são o meu povo - oráculo do Senhor Javé."
,"31":"Vós sois minhas ovelhas, ovelhas do meu rebanho. E Eu sou o vosso Deus - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, vira-te para o monte Seir e profetiza contra ele."
,"3":"Diz: Assim diz o Senhor Javé: Aqui estou eu contra ti, monte Seir. Vou estender a mão contra ti e tornar-te um deserto, um lugar desabitado."
,"4":"Transformar-te-ei num deserto, e às tuas cidades em ruínas. Então ficarás a saber que Eu sou Javé."
,"5":"Alimentaste um ódio eterno e entregaste os israelitas ao fio da espada, no tempo da desgraça, no dia em que chegou ao fim a sua culpa."
,"6":"Pois bem! Juro pela minha vida - oráculo do Senhor Javé: Eu cobrir-te-ei de sangue, e o sangue perseguir-te-á. Tu não gostas de sangue? Pois o sangue perseguir-te-á."
,"7":"Farei do monte Seir um deserto desabitado e eliminarei dele qualquer transeunte."
,"8":"Encherei os teus montes de feridos, e os mortos pela espada cairão nas tuas colinas, nos teus vales e em todas as ravinas."
,"9":"Transformar-te-ei em ruínas eternas, e as tuas cidades nunca mais serão habitadas. Deste modo, reconhecereis que Eu sou Javé."
,"10":"Tu disseste: 'Esses dois povos, esses dois países serão meus; apoderar-me-ei deles mesmo que Javé lá esteja'."
,"11":"Pois bem! Juro pela minha vida - oráculo do Senhor Javé: Agirei contra ti com a mesma ira e o mesmo ciúme com que os trataste no teu ódio contra eles. E pelo modo com que te vou julgar, eles reconhecer-Me-ão."
,"12":"Então ficarás a saber que Eu, Javé, ouvi todos os insultos que proferiste contra os montes de Israel, dizendo: 'Estão como um deserto! Eles foram-nos entregues para que os devoremos!'"
,"13":"Vós tivestes a ousadia de contra Mim levantar a voz, e contra Mim multiplicastes as vossas injúrias. Eu ouvi tudo."
,"14":"Pois bem! Assim diz o Senhor Javé: Para alegria da Terra inteira, vou fazer de ti um deserto."
,"15":"Alegraste-te quando a herança da casa de Israel ficou deserta. Pois bem! Vou fazer o mesmo contigo. O monte Seir ficará deserto, juntamente com todo o território de Edom. Então reconhecereis que Eu sou Javé»."
}`)
	CurrentBook.AddChapter(36, `{
"1":"«Criatura humana, profetiza aos montes de Israel, dizendo: Montes de Israel, ouvi a palavra de Javé:"
,"2":"Assim diz o Senhor Javé: Os vossos inimigos disseram contra vós: 'Viva! Estas montanhas eternas tornaram-se nossa propriedade'."
,"3":"Pois bem! Profetiza, dizendo: Assim diz o Senhor Javé: Vós fostes devastados e perseguidos pelos vizinhos que queriam tornar-vos propriedade das outras nações. Tornastes-vos motivo de boatos e calúnias dos povos."
,"4":"Pois bem, montes de Israel, ouvi a Palavra do Senhor Javé! Assim diz o Senhor Javé aos montes, colinas, precipícios, vales, ruínas desertas e cidades abandonadas, entregues ao saque e ao escárnio das nações vizinhas."
,"5":"Assim diz o Senhor Javé: Com ciúme ardente, Eu falo contra os outros povos e contra Edom. Eles com alegria no coração e desprezo na alma, tomaram posse de meu país para o saquearem."
,"6":"Por isso, profetiza à terra de Israel e diz aos montes, colinas, precipícios e vales: Assim diz o Senhor Javé: Eu falo com ciúme e furor: vós suportastes o insulto das nações."
,"7":"Por isso, assim diz o Senhor Javé: Levanto a minha mão e juro que as nações vizinhas terão de suportar a sua própria vergonha."
,"8":"Quanto a vós, montes de Israel, abri os ramos e produzi frutos para o meu povo Israel, pois ele está para voltar."
,"9":"Eu estou convosco, agindo em vosso favor: sereis lavrados e semeados."
,"10":"Multiplicarei os vossos habitantes, toda a casa de Israel. As cidades serão repovoadas e as ruínas serão reconstruídas."
,"11":"Multiplicarei o povo e os rebanhos. Eles crescerão e serão fecundos. Farei que sejais habitados como antes; dar-vos-ei mais bens do que antigamente. Deste modo, sabereis que Eu sou Javé."
,"12":"Farei com que as pessoas do meu povo Israel se apoderem de vós. Eles tomarão posse de vós, sereis para eles uma herança, e eles não voltarão a ficar sem filhos."
,"13":"Assim diz o Senhor Javé: Dizem que devoras as pessoas e deixaste a nação sem filhos."
,"14":"Pois bem! Não voltarás a devorar pessoas, nem deixarás a nação sem filhos - oráculo do Senhor Javé."
,"15":"Farei com que nunca mais ouças os insultos das nações, nem sofras a zombaria dos povos, nem voltes a deixar a nação sem filhos - oráculo do Senhor Javé»."
,"16":"Recebi de Javé a seguinte mensagem:"
,"17":"«Criatura humana, a casa de Israel, quando habitava no seu país, tornou-o impuro com o seu comportamento e as suas acções. O seu comportamento a meus olhos foi como a impureza da mulher na menstruação."
,"18":"Por isso, derramei a minha ira sobre eles, por causa do sangue que espalharam no país e por causa dos ídolos com que o contaminaram."
,"19":"Eu espalhei-os entre as nações, e eles foram dispersos em países estrangeiros. Julguei-os conforme a sua conduta e as suas acções."
,"20":"No meio das nações para onde foram, profanaram o meu Nome santo, pois os outros diziam: 'É o povo de Javé, e no entanto tiveram que sair do seu país!'"
,"21":"Então preocupei-Me com o meu Nome santo, que a casa de Israel profanou no meio das nações para onde foram."
,"22":"Por isso, diz à casa de Israel: Assim diz o Senhor Javé: Não é por causa de vós que estou a agir assim, ó casa de Israel, mas por causa do meu Nome santo, que profanastes no meio das nações aonde fostes parar."
,"23":"Vou santificar o meu Nome grandioso, que foi profanado entre as nações, porque o profanastes entre elas. Então as nações ficarão a saber que Eu sou Javé - oráculo do Senhor Javé - quando em vós, diante deles, mostrar a minha santidade."
,"24":"Vou retirar-vos do meio das nações, vou reunir-vos de todos os países e levar-vos para a vossa terra."
,"25":"Derramarei sobre vós uma água pura, e ficareis purificados. Vou purificar-vos de todas as vossas imundícies e de todos os vossos ídolos."
,"26":"Dar-vos-ei um coração novo e colocarei em vós um espírito novo. Tirar-vos-ei o coração de pedra, e dar-vos-ei um coração de carne."
,"27":"Colocarei dentro de vós o meu espírito, para que vivais de acordo com os meus estatutos, observeis e ponhais em prática as minhas normas."
,"28":"Então habitareis na Terra que dei aos vossos antepassados: vós sereis o meu povo, e Eu serei o vosso Deus."
,"29":"Livrar-vos-ei de todas as impurezas. Farei crescer o trigo e multiplicá-lo-ei. Nunca mais vos enviarei a fome."
,"30":"Multiplicarei os frutos das árvores e a produção dos campos para que não suporteis a vergonha da fome entre as nações."
,"31":"Então lembrar-vos-eis do vosso comportamento perverso e das vossas más acções, e sentireis nojo de vós próprios, por causa das vossas maldades e abominações."
,"32":"Sabei que não é por causa de vós que estou a fazer isto - oráculo do Senhor Javé. Tende vergonha e corai do vosso comportamento, ó casa de Israel."
,"33":"Assim diz o Senhor Javé: Quando Eu vos purificar dos vossos pecados, farei com que as vossas cidades sejam repovoadas e as ruínas reconstruídas."
,"34":"A terra devastada será de novo cultivada, quando antes era uma desolação aos olhos dos transeuntes."
,"35":"Quem por lá passar, dirá: 'Esta terra que estava deserta, agora parece o jardim do paraíso! As cidades que estavam destruídas, arruinadas e demolidas, estão agora habitadas como se fossem fortalezas!'"
,"36":"As nações que estiverem à vossa volta reconhecerão que Eu, Javé, reconstruo o que estava demolido e cultivo de novo o que estava deserto. Eu, Javé, digo e faço."
,"37":"Assim diz o Senhor Javé: Ainda farei isto por eles: Permitirei que a casa de Israel suplique a minha intervenção em seu favor. Multiplicarei os homens como um rebanho,"
,"38":"como um rebanho de ovelhas consagradas; como ovelhas em Jerusalém durante a festa, assim se encherão de gente as cidades arrasadas. Então ficarão a saber que Eu sou Javé»."
}`)
	CurrentBook.AddChapter(37, `{
"1":"A mão de Javé pousou sobre mim e o espírito de Javé levou-me e deixou-me num vale cheio de ossos."
,"2":"E o espírito fez-me circular em torno deles, por todos os lados. Notei que havia grande quantidade de ossos espalhados pelo vale e que estavam todos secos."
,"3":"Então Javé disse-me: «Criatura humana, será que estes ossos poderão reviver?» Eu respondi: «Meu Senhor Javé, Tu é que sabes»."
,"4":"Então Ele disse-me: «Profetiza, dizendo: Ossos secos, ouvi a palavra de Javé!"
,"5":"Assim diz o Senhor Javé a estes ossos: Vou infundir-vos o espírito, e revivereis."
,"6":"Vou cobrir-vos de nervos, fazer crescer a carne e revestir-vos de pele. Em seguida, infundirei o meu espírito, e revivereis. Então sabereis que Eu sou Javé»."
,"7":"Profetizei de acordo com a ordem que havia recebido. Enquanto eu profetizava, ouvi um barulho e vi um movimento entre os ossos, que começaram a aproximar-se uns dos outros, cada um com o seu correspondente."
,"8":"Observando bem, vi que apareciam nervos, que a carne crescia e que a pele os recobria; mas não havia espírito neles."
,"9":"Então Javé acrescentou: «Profetiza ao espírito, criatura humana, profetiza e diz: Assim diz o Senhor Javé: Espírito, vem dos quatro ventos e sopra sobre estes cadáveres, para que revivam»."
,"10":"Profetizei conforme Ele havia mandado. O espírito penetrou neles, e reviveram, colocando-se de pé. Era um exército imenso."
,"11":"Em seguida, Javé disse-me: «Criatura humana, esses ossos são toda a casa de Israel. Os israelitas diziam: 'Os nossos ossos estão secos e a nossa esperança desapareceu. Para nós tudo acabou'."
,"12":"Pois bem! Profetiza e diz: Assim diz o Senhor Javé: Vou abrir os vossos túmulos, tirar-vos dos vossos túmulos, ó meu povo, e vou levar-vos para a terra de Israel."
,"13":"Povo meu, ficareis a saber que Eu sou Javé, quando abrir os vossos túmulos e vos fizer sair deles."
,"14":"Colocarei em vós o meu espírito e revivereis. Estabelecer-vos-ei na vossa Terra, e ficareis a saber que Eu, Javé, digo e faço - oráculo de Javé»."
,"15":"Recebi de Javé a seguinte mensagem:"
,"16":"«Criatura humana, pega numa vara e escreve nela: 'Judá e os israelitas que estão com ele'. Depois pega noutra vara e escreve nela: 'José e os israelitas que estão com ele'."
,"17":"Em seguida, junta as duas, de modo que formem uma vara só e fiquem unidas na tua mão."
,"18":"Os teus conterrâneos vão perguntar: 'Não nos explicas o que isso significa?'"
,"19":"Então responder-lhes-ás: 'Assim diz o Senhor Javé: Tomarei a vara de José com as tribos de Israel que estão com ele, e juntá-la-ei com a vara de Judá, de modo que fiquem unidas na minha mão e formem uma vara só'."
,"20":"Pega nas varas escritas e, diante deles,"
,"21":"diz: Assim diz o Senhor Javé: Tirarei os israelitas do meio das nações para onde foram levados, reuni-los-ei de todos os povos e reconduzi-los-ei à sua Terra."
,"22":"Farei deles uma só nação na Terra, nos montes de Israel, e um só rei governará sobre todos eles. Não mais serão duas nações, nem dois reinos separados."
,"23":"Não mais se contaminarão com os seus ídolos, com as suas abominações e com os seus crimes. Vou libertá-los das suas rebeldias que os levaram a pecar. Vou purificá-los; eles serão o meu povo e Eu serei o seu Deus."
,"24":"O meu servo David reinará sobre eles, e haverá um só pastor para todos. Eles viverão segundo as minhas normas, observarão os meus estatutos e pô-los-ão em prática."
,"25":"Habitarão na Terra que dei ao meu servo Jacob, onde já moraram os seus antepassados. Lá, eles vão morar em definitivo, com seus filhos e netos, enquanto o meu servo David será o seu chefe para sempre."
,"26":"Farei com eles uma aliança de paz, que será uma aliança para sempre. Vou estabelecê-los e multiplicá-los, e colocarei o meu santuário no meio deles para sempre."
,"27":"Lá será a minha moradia. Serei o seu Deus, e eles serão o meu povo."
,"28":"Quando colocar o meu santuário no meio deles para sempre, as nações saberão que Eu sou Javé, Aquele que consagra Israel»."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Recebi de Javé a seguinte mensagem:"
,"2":"«Criatura humana, volta-te para o lado de Gog, na terra de Magog. Ele é o chefe e cabeça de Mosoc e Tubal. Profetiza contra ele,"
,"3":"dizendo: Assim diz o Senhor Javé: Eu estou contra ti, Gog, chefe e cabeça de Mosoc e Tubal."
,"4":"Vou arrastar-te para fora, colocar arpões no teu queixo e vou fazer-te sair com todo o teu exército: cavalos e cavaleiros, todos completamente armados, uma grande multidão com escudos grandes e pequenos, todos com a espada na mão."
,"5":"Com eles estão a Pérsia, Cuch e Fut, todos com escudo e capacete;"
,"6":"Gomer, com todas as suas tropas; Bet-Togorma, situada no extremo norte, e as numerosas tropas que estão contigo."
,"7":"Prepara-te e está atento com todo o exército que recrutaste e fica à minha disposição."
,"8":"Após muito tempo, receberás uma missão: daqui a muitos anos irás para um país cuja população escapou da espada e do meio dos povos foi reunida sobre os montes de Israel, após terem ficado muito tempo em ruínas. Foram tirados do meio dos povos e agora todos habitam em segurança."
,"9":"Tu, porém, com o teu exército e incontáveis tropas aliadas, levantar-te-ás como uma tempestade e avançarás como uma nuvem, e cobrirás todo o país."
,"10":"Assim diz o Senhor Javé: Nesse dia, terás pensamentos maus e conceberás planos perversos:"
,"11":"'Vou atacar esse país indefeso, invadir a casa de um povo despreocupado, gente que vive confiante, sem muralhas, sem trancas e sem portas."
,"12":"Vou saquear e roubar, vou lançar a mão sobre essas ruínas repovoadas, sobre esse povo que foi reunido do meio das outras nações, e que agora cria gado e bens, e mora no centro do mundo'."
,"13":"Sabá, Dadã, os negociantes de Társis e todos os seus traficantes perguntarão: 'Vieste para saquear? Foi para roubar que reuniste o teu exército? Foi para roubar prata e ouro, para tomar rebanhos e bens, para fazer um grande saque?'"
,"14":"Criatura humana, profetiza e diz a Gog: Assim diz o Senhor Javé: Exactamente no dia em que o meu povo Israel estiver a viver tranquilamente, pôr-te-ás a caminho."
,"15":"Virás da tua terra no extremo norte, com incontáveis tropas aliadas, todos montados em carros de guerra, formando um grande exército."
,"16":"Subirás contra o meu povo Israel e cobrirás como uma nuvem o país. No fim dos dias, far-te-ei entrar na minha Terra, para que as outras nações Me reconheçam quando, por meio de ti, Gog, manifestar aos seus olhos a minha santidade."
,"17":"Assim diz o Senhor Javé: Tu és aquele de quem falei, nos tempos antigos, pela boca dos meus servos, os profetas de Israel. Esses profetas, naqueles tempos e durante muitos anos, profetizaram que Eu te enviaria contra eles."
,"18":"Quando Gog atacar a terra de Israel - oráculo do Senhor Javé - a minha cólera vai transbordar. Na minha ira,"
,"19":"no meu ciúme e no ardor da minha indignação, Eu declaro: nesse dia, haverá um grande terremoto no país de Israel."
,"20":"Por medo de Mim, vão tremer os peixes do mar, as aves do céu, as feras selvagens, os répteis que se arrastam pelo chão e todo o ser humano que existe sobre a Terra. Os montes serão arrasados, os rochedos e as muralhas cairão por terra."
,"21":"Em todas as minhas montanhas, chamarei toda a espada contra Gog - oráculo do Senhor Javé. Cada um manejará a espada contra o seu irmão."
,"22":"Vou castigá-lo com a peste e o sangue. Mandarei tempestade, granizo, fogo e enxofre contra ele, contra os seus exércitos e as suas incontáveis tropas aliadas."
,"23":"Mostrarei a minha grandeza e a minha santidade, e revelar-Me-ei a muitas nações. E reconhecerão que Eu sou Javé."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Criatura humana, profetiza contra Gog: Assim diz o Senhor Javé: Eu estou contra ti, Gog, chefe e cabeça de Mosoc e Tubal."
,"2":"Vou fazer-te voltar e conduzir-te do extremo norte para os montes de Israel."
,"3":"Lá, vou quebrar o arco da tua mão esquerda e fazer cair as flechas da tua direita."
,"4":"Cairás sobre os montes de Israel, com o teu exército e as tuas incontáveis tropas aliadas. Entregar-te-ei como pasto a todas as aves de rapina e aos animais selvagens."
,"5":"Cairás em pleno campo de batalha, pois fui Eu quem falou - oráculo do Senhor Javé."
,"6":"Mandarei fogo contra Magog e contra os que tranquilos habitam nas ilhas, para que fiquem a saber que Eu sou Javé."
,"7":"Farei que o meu Nome santo seja conhecido no meio do meu povo Israel, e não permitirei que o meu santo Nome seja profanado. Então as outras nações ficarão a saber que Eu sou Javé, o Santo de Israel."
,"8":"Eis que vai chegar e se cumprirá - oráculo do Senhor Javé - o dia de que falei."
,"9":"Os habitantes das cidades de Israel sairão, queimarão armas, escudos grandes e pequenos, arcos, flechas e lanças. Terão com que acender fogo durante sete anos."
,"10":"Não precisarão de ir buscar lenha fora da cidade ou de a cortar na floresta, pois acenderão fogo com as armas ali deixadas. Eles saquearão aqueles que os saquearam e despojarão aqueles que os despojaram - oráculo do Senhor Javé."
,"11":"Naquele dia, sepultarei Gog num lugar famoso de Israel: no Vale dos Transeuntes, a Leste do mar, o vale que barra o caminho aos passantes. Aí serão sepultados Gog e todo o seu exército. E o vale chamar-se-á Vale do Exército de Gog."
,"12":"Os israelitas sepultarão o exército de Gog durante sete meses, para purificar o país."
,"13":"Todos os cidadãos do país ajudarão a sepultar, e isso vai ser uma honra para cada um, quando se manifestar a minha glória - oráculo do Senhor Javé."
,"14":"Será nomeada uma patrulha, que deverá percorrer o país e sepultar os que tiverem ficado sem sepultura, para purificar o país. Eles deverão começar a procurar cadáveres sem sepultura, quando tiverem passado sete meses."
,"15":"Quando um daqueles que devem percorrer o país descobrir uma ossada humana, deverá espetar junto dela uma estaca, para que os encarregados de sepultar a enterrem no vale do Exército de Gog,"
,"16":"a fim de purificar o país."
,"17":"Criatura humana: Assim diz o Senhor Javé: Diz a todas as espécies de aves e feras: Reuni-vos e vinde! Juntai-vos de todos os lados para o sacrifício que Eu vos preparei, um grande sacrifício sobre os montes de Israel. Comereis carne e bebereis sangue."
,"18":"Comereis carne de heróis e bebereis sangue de chefes da terra. São todos cordeiros, carneiros, cabritos e bois gordos de Basã."
,"19":"Comereis carnes gordas até ficardes satisfeitos, e bebereis sangue até ficardes embriagados, no sacrifício que vos ofereço."
,"20":"Saciar-vos-eis à minha mesa, com a carne de cavalos e cavaleiros, de soldados e de todos os guerreiros - oráculo do Senhor Javé."
,"21":"Vou manifestar a minha glória entre as nações, e todas as nações verão o julgamento que vou executar e a mão que colocarei sobre elas."
,"22":"Desde esse dia e para todo o sempre, a casa de Israel ficará a saber que Eu sou Javé, o seu Deus»."
,"23":"«As outras nações ficarão a saber que a casa de Israel foi para o exílio por causa do seu pecado. Eles foram infiéis comigo, e por isso afastei deles o meu rosto, entregando-os nas mãos dos seus inimigos. Foi assim que eles caíram mortos pela espada."
,"24":"Para castigar o seu descaramento e os seus crimes, afastei deles o meu rosto."
,"25":"No entanto, assim diz o Senhor Javé: Agora vou mudar o destino de Jacob, vou tratar com misericórdia a casa de Israel, porque sou ciumento do meu santo Nome."
,"26":"Quando os israelitas estiverem a morar tranquilamente na sua terra, sem ninguém os incomodar, envergonhar-se-ão de todas as revoltas que cometeram."
,"27":"Quando eu os fizer sair do meio dos outros povos e os reunir dos países de seus inimigos e manifestar neles a minha santidade aos olhos de muitas nações,"
,"28":"eles ficarão a saber que Eu sou Javé, o seu Deus. Eu exilei-os entre as nações, mas agora Eu reúno-os de novo na sua própria terra, sem deixar ninguém lá fora."
,"29":"Nunca mais lhes esconderei o meu rosto, porque vou derramar o meu espírito sobre a casa de Israel - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(40, `{
"1":"No dia dez do começo do ano vinte e cinco do nosso exílio, ou seja, catorze anos depois da tomada de Jerusalém, exactamente nesse dia, a mão de Javé pousou sobre mim, levando-me para Jerusalém."
,"2":"Através de um êxtase, Javé levou-me para a terra de Israel e fez-me pousar num monte muito alto, sobre o qual havia uma cidade construída do lado Sul."
,"3":"Ele fez-me entrar na cidade, e vi lá um homem que parecia de bronze. Tinha na mão um cordel de linho e uma vara de medir. O homem estava de pé junto ao pórtico."
,"4":"Ele disse-me: «Criatura humana, olha e ouve bem, presta atenção a tudo o que te vou mostrar, pois foste trazido aqui para que eu te mostrasse tudo. Depois contarás à casa de Israel tudo o que viste»."
,"5":"Havia uma muralha externa que cercava o Templo por todos os lados. O homem tinha na mão uma vara de medir de seis côvados (cada côvado tinha mais um palmo que o côvado normal). O homem mediu a muralha com a vara: tinha três metros de espessura e três metros de altura."
,"6":"O homem foi até ao pórtico, que está voltado para o Oriente. Subiu os degraus e mediu o limiar do pórtico: tinha três metros de profundidade."
,"7":"O cubículo tinha três metros de comprimento e três de largura; o pilar entre os cubículos tinha dois metros e meio; o limiar do pórtico, junto ao vestíbulo do pórtico, para o lado de dentro, tinha três metros."
,"8":"Mediu o vestíbulo do pórtico, do lado de dentro, e deu três metros."
,"9":"Em seguida, mediu o vestíbulo do pórtico: quatro metros; e o seu pilar: um metro. O vestíbulo do pórtico ficava do lado de dentro."
,"10":"Os cubículos do pórtico oriental eram três de um lado e três do outro, todos com a mesma medida. Os pilares também tinham a mesma medida, tanto de um lado como do outro."
,"11":"Depois o homem mediu a entrada do pórtico: tinha cinco metros de largura; o comprimento do pórtico media seis metros e meio."
,"12":"Diante dos cubículos havia um parapeito de meio metro, tanto de um lado como do outro; o cubículo tinha três metros de cada lado."
,"13":"Mediu também a largura do pórtico, do fundo de um cubículo até ao fundo do outro: era de doze metros e meio, com uma entrada em frente da outra."
,"14":"O vestíbulo que ele mediu tinha dez metros. O pátio rodeava o pórtico de todos os lados."
,"15":"Desde a fachada do pórtico, junto à entrada, até à frente do vestíbulo do pórtico interior, eram vinte e cinco metros."
,"16":"Nos aposentos havia janelas com grades sobre os seus pilares, do lado interior do pórtico; também havia janelas em volta do vestíbulo e palmeiras sobre os pilares."
,"17":"Depois o homem conduziu-me para o pátio externo, onde havia câmaras abertas e um pavimento em torno do pátio. Havia ao todo trinta câmaras."
,"18":"Ao lado dos pórticos ficava o pavimento, correspondendo à profundidade dos pórticos. Esse era o pavimento inferior."
,"19":"Em seguida, ele mediu a largura do pavimento, desde a fachada do pórtico inferior até à fachada do pátio interno, pelo lado de fora: eram cinquenta metros."
,"20":"Depois mediu o comprimento e a largura do pórtico voltado para o Norte, que se encontra no pátio exterior."
,"21":"Os seus cubículos eram três de cada lado. Os seus pilares e vestíbulos tinham a mesma medida que o primeiro pórtico, isto é, vinte e cinco metros de comprimento e doze metros e meio de largura."
,"22":"As suas janelas, o vestíbulo e as palmeiras tinham as mesmas dimensões que as do pórtico que olhava para o Oriente. Subia-se para lá por sete degraus, e o seu vestíbulo ficava voltado para dentro."
,"23":"O pátio interno tinha um pórtico fronteiro ao pórtico que olhava para o Norte e ao pórtico que olhava para o Oriente. Ele mediu a distância de um pórtico ao outro: era de cinquenta metros."
,"24":"O homem conduziu-me para o lado Sul, onde havia um pórtico voltado para o Sul. Ele mediu os seus cubículos, pilares e vestíbulos, que tinham a mesma dimensão."
,"25":"O pórtico e o vestíbulo tinham janelas ao redor com as mesmas medidas que as outras, isto é: vinte e cinco metros de comprimento e doze metros e meio de largura."
,"26":"A sua escada tinha sete degraus. O vestíbulo ficava para dentro, com uma palmeira de cada lado nos pilares."
,"27":"Havia um pórtico no pátio interno, voltado para o Sul. A distância dum pátio ao outro, na direcção Sul, era de cinquenta metros."
,"28":"Então o homem conduziu-me para o pátio interno, pelo pórtico do lado Sul. Ele mediu o pórtico, e tinha a mesma medida."
,"29":"Os cubículos, os pilares e o vestíbulo tinham também a mesma medida que os anteriores. Tanto o pórtico como os seus vestíbulos tinham janelas ao redor, com vinte e cinco metros de comprimento e doze metros e meio de largura."
,"30":"Os seus vestíbulos em toda a volta mediam doze metros e meio de comprimento e dois metros e meio de largura."
,"31":"O pátio externo tinha um vestíbulo com palmeiras sobre os pilares, e uma escada de oito degraus."
,"32":"Então o homem conduziu-me até ao pátio interno que dava para o Oriente. Ele mediu o pórtico, que tinha a mesma medida que os outros."
,"33":"Os cubículos, os pilares e o vestíbulo também apresentavam a mesma medida. O pórtico e o seu vestíbulo tinham janelas ao redor, medindo vinte e cinco metros de comprimento e doze metros e meio de largura."
,"34":"O seu vestíbulo dava para o pátio externo e tinha palmeiras nos seus pilares, de um lado e do outro e uma escada de oito degraus."
,"35":"Em seguida, o homem conduziu-me ao pórtico do lado Norte e mediu-o, obtendo as mesmas dimensões."
,"36":"Os cubículos, os pilares e o vestíbulo também tinham a mesma dimensão. O pórtico tinha janelas ao redor, medindo vinte e cinco metros de comprimento e doze metros e meio de largura."
,"37":"O seu vestíbulo dava para o pátio externo e tinha palmeiras nos seus pilares, de um lado e do outro, e a sua escada tinha oito degraus."
,"38":"Havia uma câmara com a entrada no vestíbulo do pórtico. Era ali que se lavavam os holocaustos."
,"39":"No vestíbulo do pórtico encontravam-se duas mesas de um lado e duas do outro, para a imolação do holocausto, do sacrifício pelo pecado e do sacrifício de expiação."
,"40":"Do lado de fora por onde se subia à entrada do pórtico, na direcção do Norte, estavam duas mesas, e do outro lado do vestíbulo também havia duas mesas."
,"41":"Havia assim quatro mesas de um lado e quatro do outro, junto ao pórtico, ou seja, ao todo oito mesas em que se fazia a imolação."
,"42":"Além disso, havia quatro mesas para o holocausto, feitas de pedras de cantaria, cujo comprimento era de setenta e cinco centímetros, a largura de setenta e cinco centímetros e a altura era de meio metro. Sobre essas mesas eram depositados os instrumentos com que se imolavam as vítimas para os holocaustos e para os outros sacrifícios."
,"43":"Pelo lado de dentro, ao redor, havia rebordos de um palmo de comprimento. Sobre as mesas ficava a carne da oblação."
,"44":"Depois o homem conduziu-me para o pátio interno, onde havia duas câmaras: uma, do lado do pórtico Norte, olhava para o Sul; a outra, do lado do pórtico Sul, olhava para o Norte."
,"45":"O homem disse-me: «Esta câmara, que olha para o Sul, é reservada aos sacerdotes que fazem o serviço do Templo."
,"46":"A câmara que olha para o Norte pertence aos sacerdotes que fazem o serviço do altar. São os filhos de Sadoc que, dentre os filhos de Levi, se aproximam de Javé para O servirem»."
,"47":"Ele mediu em seguida o pátio: era quadrado e tinha cinquenta metros de comprimento por cinquenta de largura. O altar ficava diante do Templo."
,"48":"Depois o homem conduziu-me para o vestíbulo do Templo, e mediu os pilares do vestíbulo. Tinha dois metros e meio de um lado e dois metros e meio do outro; a largura do pórtico tinha um metro e meio de um lado e do outro."
,"49":"O comprimento do vestíbulo era de dez metros, e a largura media seis metros. Havia dez degraus para se subir para lá. Junto aos pilares havia colunas, uma de cada lado."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Em seguida, o homem conduziu-me para o Santo, e mediu os pilares: três metros de largura de um lado e três metros do outro."
,"2":"A largura da entrada era de cinco metros, enquanto as ombreiras da entrada tinham dois metros e meio de ambos os lados. Mediu também o Santo: tinha vinte metros de comprimento e dez metros de largura."
,"3":"Ele conduziu-me para dentro do Santo dos santos e mediu: o pilar da entrada tinha um metro, a entrada três metros, e as ombreiras da entrada três metros e meio."
,"4":"Depois mediu o Santo dos santos: tanto o comprimento como a largura tinham dez metros, do lado do Santo. Ele comentou: «Este é o Santo dos santos»."
,"5":"Em seguida mediu a parede do Templo: tinha três metros. A largura da ala lateral era de dois metros, ao redor do Templo."
,"6":"As celas ficavam sobrepostas em três andares, com trinta celas cada um. As celas ajustavam-se à parede do Templo, isto é, as celas que ficavam em torno, serviam de suportes, mas não havia suportes nas paredes do Templo."
,"7":"A largura das celas ia aumentando de andar em andar, conforme o aumento que recebia sobre a muralha, de andar em andar, em torno do Templo."
,"8":"Vi que o Templo tinha uma rampa que o rodeava todo e que formava a base das celas laterais. A sua medida era de uma vara, isto é, três metros."
,"9":"A espessura da parede externa das celas laterais era de dois metros e meio. Havia uma passagem entre as celas do Templo"
,"10":"e as câmaras, com a largura de dez metros, em torno de todo o Templo."
,"11":"Como entrada das celas laterais, havia na passagem uma entrada para o lado Norte e outra para o lado Sul. A largura da entrada era de dois metros e meio."
,"12":"O edifício que do lado ocidental confinava com o pátio tinha trinta e cinco metros de largura, enquanto a parede do edifício que ficava em toda a volta tinha dois metros e meio de espessura e quarenta e cinco metros de comprimento."
,"13":"O homem mediu também o Templo: tinha cinquenta metros de comprimento; o pátio, o edifício e as suas paredes, também tinham cinquenta metros de comprimento."
,"14":"Depois mediu a largura da fachada do Templo e do pátio para o oriente: era de cinquenta metros."
,"15":"Por fim, mediu o comprimento do edifício junto ao pátio, por detrás, bem como a sua galeria de um lado e do outro, obtendo também cinquenta metros. O interior do Santo e os vestíbulos dos pátios, "
,"16":"os limiares, as janelas de grades e as galerias dos três lados, em frente do limiar, estavam revestidos de madeira em volta, desde o chão até às janelas, e as janelas estavam revestidas de grades."
,"17":"Desde a entrada até ao interior do Templo, bem como por fora, sobre toda a parede em volta, tanto por dentro como por fora,"
,"18":"estavam esculpidos querubins e palmeiras, uma palmeira entre dois querubins. Cada querubim tinha duas faces:"
,"19":"de um lado, uma face de homem voltada para a palmeira, e do outro lado uma face de leão voltada para a palmeira. Era assim em toda a volta do Templo."
,"20":"Os querubins e as palmeiras estavam esculpidos sobre as paredes, desde o chão até ao alto da entrada."
,"21":"As ombreiras da porta do Santo eram quadradas. Diante do santuário, havia algo com aspecto "
,"22":"de altar de madeira, e tinha um metro e meio de altura, um metro de comprimento e um metro de largura. Tinha cantos, base e lados, tudo de madeira. O homem disse-me: «Esta é a mesa que fica na presença de Javé»."
,"23":"O Santo tinha uma porta dupla; e o santuário"
,"24":"também tinha uma porta dupla. Ambas as portas eram de dois batentes: dois batentes pertenciam a uma das portas, e dois à outra."
,"25":"Sobre as portas do Santo estavam esculpidos querubins e palmeiras, como os que se encontravam sobre as paredes. Do lado de fora, na frente do vestíbulo, havia um guarda-vento,"
,"26":"bem como janelas com grades e palmeiras, de um lado e do outro, sobre os lados do vestíbulo, nas celas do Templo e nos guarda-ventos."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Então o homem levou-me para o pátio externo, para o lado Norte e para junto da câmara que fica na frente do pátio, na frente do edifício do lado Norte."
,"2":"A fachada da câmara media cinquenta metros de comprimento para o lado Norte e vinte e cinco metros de largura."
,"3":"Em frente dos vestíbulos do pátio interno e em frente do pavimento do pátio externo, havia uma galeria diante da tríplice galeria."
,"4":"Em frente da câmara havia uma passagem que tinha cinco metros de largura para dentro, e cinquenta metros de comprimento. As suas entradas davam para o Norte."
,"5":"As câmaras superiores eram menores do que as de baixo e do meio, porque as galerias ocupavam um espaço maior do que as de baixo e do meio."
,"6":"De facto, elas dividiam-se em três andares, e não tinham colunas como o pátio. Por isso, eram mais estreitas do que as debaixo e do meio, a partir do chão."
,"7":"A parede do lado de fora, junto das câmaras, voltadas para o pátio exterior, em frente das câmaras, tinha vinte e cinco metros de comprimento."
,"8":"Portanto, o comprimento das câmaras do pátio externo era de vinte e cinco metros, ao passo que o comprimento das que ficavam em frente do Santo era de cinquenta metros."
,"9":"Por baixo dessas câmaras estava a entrada do lado oriental, que dava acesso a quem vinha do pátio externo."
,"10":"Junto à largura da parede do pátio, do lado Sul, em frente ao pátio e ao edifício, havia câmaras."
,"11":"Diante delas ficava um caminho, como diante das câmaras que estavam do lado Norte. Tinham comprimento e largura idênticos, e também eram iguais as saídas, a disposição e as entradas."
,"12":"Por baixo das câmaras que ficavam para o lado Sul, havia uma entrada, no começo de cada caminho, em frente à parede correspondente, do lado do Oriente, junto à entrada."
,"13":"O homem disse-me: «As câmaras do Norte e as câmaras do Sul, que ficam em frente do pátio, são as câmaras do santuário, onde os sacerdotes que se aproximam de Javé comem as coisas santíssimas. Aí depositarão as coisas santíssimas, a oblação, a oferta pelo pecado e a oferta pela expiação, porque o lugar é santo."
,"14":"Depois de lá entrarem, os sacerdotes não sairão directamente do santuário para o pátio externo, mas primeiro depositarão lá as vestes com que tiverem exercido as suas funções litúrgicas, porque são santas. Colocarão outras vestes, e só então poderão dirigir-se ao local destinado ao povo»."
,"15":"Tendo acabado de medir o interior do Templo, o homem conduziu-me para fora, em direcção ao pórtico que dá para o Oriente. E mediu todo o pátio em redor."
,"16":"Mediu todo o lado do Oriente com a vara de medir: tinha duzentos e cinquenta metros."
,"17":"Em seguida, mediu o lado Norte: tinha duzentos e cinquenta metros em toda a volta."
,"18":"Depois mediu o lado Sul: também era de duzentos e cinquenta metros."
,"19":"Finalmente, mediu com a vara todo o lado ocidental: duzentos e cinquenta metros."
,"20":"Pelos quatro lados, mediu toda a parede em toda a volta. O seu comprimento era de duzentos e cinquenta metros, e a largura de duzentos e cinquenta metros, e servia de separação entre a parte sagrada e a profana."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Então o homem levou-me ao pórtico oriental."
,"2":"E vi que a glória do Deus de Israel vinha do Oriente. Fazia um barulho de águas torrenciais e a terra reflectia a sua glória."
,"3":"A visão que tive era como a visão que eu tinha contemplado, quando veio para destruir a cidade, e também como a visão que eu tivera nas margens do rio Cobar. Então caí com o rosto por terra."
,"4":"A glória de Javé entrou no Templo pelo pórtico oriental."
,"5":"Então o espírito arrebatou-me e levou-me para o pátio interno: a glória de Javé enchia o Templo."
,"6":"Enquanto o homem continuava a meu lado, ouvi alguém que me falava de dentro do Templo,"
,"7":"e me dizia: «Criatura humana, este é o lugar do meu trono e o lugar onde pousam os meus pés, onde habitarei para sempre no meio dos israelitas. A casa de Israel, o povo e seus reis, nunca mais profanarão o meu Nome santo com as suas prostituições e com os cadáveres e túmulos dos seus reis."
,"8":"Colocando a soleira dos seus túmulos junto da minha soleira, e os batentes das suas portas junto dos meus, deixando apenas uma parede entre Mim e eles, acabaram por profanar o meu Nome santo com as abominações que praticaram. Por isso, a minha ira os consumiu."
,"9":"Agora, porém, os israelitas afastarão para longe de Mim as suas prostituições e os cadáveres dos seus reis. E Eu habitarei para sempre no meio deles»."
,"10":"«Quan-to a ti, criatura humana, mostra à casa de Israel o projecto do Templo, e eles ficarão envergonhados das suas culpas. Ao medir o projecto,"
,"11":"ficarão envergonhados de tudo o que fizeram. Então ensina-lhes a forma do Templo, as suas dispo-sições, as suas entradas e saídas, as suas normas, regulamentos, regras e leis. Põe tudo isso por escrito à vista deles, para que observem todas essas normas e ponham em prática todos esses regulamentos."
,"12":"Esta é a lei do Templo, que está construído no alto do monte: todo o espaço que está ao redor é santíssimo. Esta é a lei do Templo»."
,"13":"São estas as medidas do altar em côvados iguais a um côvado e um palmo: a base tinha meio metro de altura e meio metro de largura; o espaço junto ao rego que contornava o altar era de um palmo. Essa era a base do altar."
,"14":"Da base até ao pedestal inferior, o altar tinha um metro, e a largura era de meio metro; do pedestal menor até ao pedestal maior, tinha dois metros por meio metro de largura."
,"15":"A lareira tinha dois metros, e acima da lareira havia quatro chifres."
,"16":"A lareira era quadrada, com seis metros de comprimento por seis metros de largura."
,"17":"O pedestal também era quadrado, com sete metros de comprimento por sete metros de largura. A borda em torno dele tinha vinte e cinco centímetros, e a medida da base em torno era de meio metro. Os degraus davam para o Oriente."
,"18":"Ele disse-me: «Criatura humana, assim diz o Senhor Javé: São estes os estatutos referentes ao altar, para o dia em que o construírem para sobre ele se oferecer o holocausto e se derramar o sangue."
,"19":"Darás aos sacerdotes levitas, aos da família de Sadoc, que se aproximam de Mim para Me servirem - oráculo do Senhor Javé - um novilho para o sacrifício pelo pecado."
,"20":"Então tomarás do sangue do novilho para o espalhares sobre os quatro chifres, sobre os quatro cantos do pedestal e sobre o rebordo que o rodeia. Com isto purificarás o altar e farás a expiação por ele."
,"21":"Em seguida, tomarás o novilho da oferta pelo pecado e queimá-lo-ás no lugar do Templo que foi destinado para isso, fora do santuário."
,"22":"No segundo dia, oferecerás um bode perfeito como oferta pelo pecado, e com ele o altar se purificará do pecado, tal como foi feita a purificação com o novilho."
,"23":"Acabando de fazer a purificação do pecado, oferecerás um novilho perfeito e um carneiro perfeito."
,"24":"Oferecê-los-ás diante de Javé, e os sacerdotes espalharão sal sobre eles, oferecendo-os em holocausto a Javé."
,"25":"Durante sete dias, diariamente, sacrificarás um bode pelo pecado e, além disso, sacrificareis também um novilho e um carneiro do rebanho, todos perfeitos,"
,"26":"durante sete dias. Assim, fareis a expiação pelo altar, o purificareis e consagrareis."
,"27":"No fim deste período, do oitavo dia em diante, os sacerdotes oferecerão sobre o altar os seus holocaustos e sacrifícios de comunhão, e Eu ser-vos-ei favorável - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Então ele conduziu-me ao pórtico exterior do santuário, que dava para o Oriente e que estava fechado."
,"2":"Javé disse-me: «Este pórtico ficará fechado. Não será aberto e ninguém entrará por ele, porque por ele entrará Javé, o Deus de Israel. Por isso, permanecerá fechado."
,"3":"Contudo, o príncipe poderá sentar-se aí para comer pão na presença de Javé. Ele entrará pelo lado do vestíbulo do pórtico e sairá pelo mesmo lado»."
,"4":"Depois o homem levou-me para o lado do pórtico do Norte, para a frente do Templo. Olhei, e eis que a glória de Javé enchia o Templo. Então prostrei-me com o rosto por terra."
,"5":"Javé disse-me: «Criatura humana, presta atenção, fixa os olhos e escuta bem tudo o que te vou dizer. Presta atenção a todos os estatutos do Templo de Javé, a todas as suas leis, às condições de admissão ao Templo e de exclusão do santuário."
,"6":"Diz a esses rebeldes, à casa de Israel: Assim diz o Senhor Javé: Chega de abominações, casa de Israel!"
,"7":"Tu introduziste estrangeiros, incircuncisos de coração e incircuncisos de corpo, permitindo que se instalassem no meu santuário e que profanassem o meu Templo, quando oferecestes o meu pão, a gordura e o sangue, rompendo a minha aliança com as vossas abominações."
,"8":"Em vez de exercerdes o ministério do santuário, encarregastes esses estrangeiros de exercer o ministério no meu santuário."
,"9":"Assim diz o Senhor Javé: Nenhum estrangeiro, incircunciso de coração e incircunciso de corpo, entrará no meu santuário, dentre os estrangeiros que vivem no meio dos israelitas»."
,"10":"«Levarão sobre si a culpa os levitas que se afastaram de Mim, quando Israel se desviou de Mim para correr atrás dos seus ídolos imundos."
,"11":"Eles vão continuar no meu santuário, encarregando-se dos serviços de guarda junto das portas do Templo; eles prestarão serviço no Templo. Matarão as vítimas para o holocausto e para o sacrifício pelo povo, e ficarão à disposição do povo para lhe prestar serviço."
,"12":"Contudo, visto que estiveram ao serviço do povo diante dos seus ídolos imundos, fazendo cair no pecado a casa de Israel, Eu jurei solenemente - oráculo do Senhor Javé - que eles levarão sobre si a culpa."
,"13":"De facto, não tornarão a aproximar-se de Mim para exercer o meu sacerdócio, nem tocarão em nenhuma das minhas coisas santas, nem nas coisas santíssimas: eles levarão sobre si a vergonha e as abominações que praticaram."
,"14":"Eu encarregá-los-ei da guarda do Templo e confiar-lhes-ei as tarefas que nele se executam»."
,"15":"«Os sacerdotes levitas, filhos de Sadoc, realizaram o serviço do meu santuário quando os israelitas se desviaram de Mim. Por isso, poderão aproximar-se de Mim para exercer o meu ministério e poderão estar de pé na minha presença, para Me oferecer a gordura e o sangue - oráculo do Senhor Javé."
,"16":"Eles entrarão no meu santuário e aproximar-se-ão da minha mesa para Me servir, exercendo o meu ministério."
,"17":"Sempre que entrarem pelas portas do pátio interno, usarão vestes de linho e não vestirão nada de lã, enquanto estiverem a exercer o seu ministério junto dos pórticos do pátio interno e no Templo."
,"18":"Usarão turbantes de linho na cabeça e calções de linho sobre os quadris, e não vestirão nada que faça transpirar."
,"19":"Antes de saírem para o pátio externo, para junto do povo, tirarão as vestes com que serviram e deixá-las-ão nas câmaras do santuário; colocarão outras vestes, para não transmitirem ao povo nenhuma influência sagrada."
,"20":"Não raparão a cabeça, nem deixarão o cabelo crescer à vontade, mas usarão o cabelo bem cortado."
,"21":"Nenhum sacerdote beberá vinho quando entrar no pátio interno."
,"22":"Os sacerdotes não se casarão com nenhuma viúva ou repudiada, mas somente com virgens da descendência de Israel. Contudo, poderão casar-se com a viúva de um sacerdote."
,"23":"Deverão ensinar o meu povo a distinguir entre sagrado e profano, e far-lhe-ão conhecer a diferença entre puro e impuro."
,"24":"Quando houver contenda, estarão presentes para julgar, julgando de acordo com o meu direito. Em todas as minhas assembleias solenes, observarão os meus estatutos e as minhas leis, e santificarão os meus sábados."
,"25":"Não se aproximarão de um morto, para não se tornarem impuros. Contudo, podem tornar-se impuros pelo pai, mãe, filho ou filha, irmão ou irmã, contanto que esta não seja casada."
,"26":"Depois de se purificarem da contaminação, deverão contar sete dias."
,"27":"Em seguida, no dia em que entrarem no santuário, no pátio interno, para servir, oferecerão o seu sacrifício pelo pecado - oráculo do Senhor Javé."
,"28":"Os sacerdotes não receberão herança, porque Eu serei a sua herança. Eles não terão herança em Israel: Eu é que serei a sua herança."
,"29":"Eles comerão a oblação, o sacrifício pelo pecado e o sacrifício de expiação. A eles pertence tudo o que se consagra como anátema em Israel."
,"30":"Será dos sacerdotes, também, a primeira porção de todas as primícias, bem como de todas as vossas ofertas, sejam elas quais forem. Dareis também ao sacerdote a primeira porção da massa de pão, para que a bênção repouse sobre a vossa casa."
,"31":"Os sacerdotes não comerão nenhum animal que tenha morrido por si ou tenha sido dilacerado por uma fera, tanto ave como qualquer outro animal»."
}`)
	CurrentBook.AddChapter(45, `{
"1":"«Quando distribuirdes ao povo a posse da terra por sorteio, oferecei a Javé uma parte sagrada da terra, que terá doze mil e quinhentos metros de comprimento por dez mil metros de largura. Essa parte será sagrada em toda a sua extensão."
,"2":"Desta parte, um quadrado de duzentos e cinquenta metros ficará reservado para o santuário, com terreno livre de vinte e cinco metros à volta, que será destinado à pastagem."
,"3":"Desta área, separa também doze mil e quinhentos metros de comprimento por cinco mil metros de largura, onde ficarão o santuário e o Santo dos Santos."
,"4":"Essa área será a porção sagrada da terra, que se reserva para os sacerdotes que ministram no santuário, que se aproximam de Javé para O servir. Ela destinar-se-á às suas casas e ao santuário."
,"5":"Outros doze mil e quinhentos metros de comprimento por cinco mil metros de largura pertencerão aos levitas, que são encarregados do serviço no Templo, juntamente com as cidades para nelas habitarem."
,"6":"Como património da cidade, deixai uma área de dois mil e quinhentos metros de largura por doze mil e quinhentos metros de comprimento, junto à parte reservada para o santuário. Essa parte pertencerá a toda a casa de Israel»."
,"7":"«De um lado e do outro da parte reservada ao santuário e do património da cidade, o príncipe terá uma área fronteira à parte reservada ao santuário e ao património da cidade, do lado ocidental e do lado oriental. Será uma área de comprimento igual a cada uma das partes, desde o limite ocidental até ao limite oriental"
,"8":"da terra. Tal será a propriedade do príncipe em Israel, para que os meus príncipes não voltem a explorar o meu povo, mas deixem a terra à casa de Israel e às suas tribos."
,"9":"Assim diz o Senhor Javé: Chega, príncipes de Israel! Afastai-vos do roubo e da exploração. Praticai a justiça e o direito. Acabai com as violências praticadas contra o meu povo - oráculo do Senhor Javé."
,"10":"Usai balanças justas, efá justo e bat justo."
,"11":"O efá e o bat terão a mesma medida, equivalendo o bat a um décimo de homer, e o efá a um décimo de homer. A medida de ambos será fixada a partir do homer."
,"12":"O siclo deverá equivaler a vinte geras: vinte siclos mais vinte e cinco siclos mais quinze siclos farão uma mina»."
,"13":"«Devereis apresentar a seguinte oferta: sete litros e meio por cada quatrocentos e cinquenta litros de trigo, e sete litros e meio por cada quatrocentos e cinquenta litros de cevada."
,"14":"A norma para o azeite é esta: quarenta e cinco litros de azeite por cada quatrocentos e cinquenta litros, porque quarenta e cinco litros são um décimo de quatrocentos e cinquenta litros."
,"15":"Um cordeiro por cada duzentos cordeiros do rebanho de Israel será destinado à oblação, ao holocausto e ao sacrifício de comunhão, para fazer a expiação por vós - oráculo do Senhor Javé."
,"16":"Todo o povo de Israel fica obrigado a esta oferta para o príncipe de Israel."
,"17":"O príncipe será o encarregado dos holocaustos, da oblação e da libação durante as festas, luas novas e sábados. Por ocasião de todas as assembleias solenes, ele fará o sacrifício pelo pecado, a oblação, o holocausto e os sacrifícios de comunhão, para fazer a expiação pela casa de Israel»."
,"18":"Assim diz o Senhor Javé: No primeiro mês, no primeiro dia do mês, toma um novilho perfeito para remover o pecado do santuário."
,"19":"O sacerdote tomará do sangue da vítima oferecida pelo pecado, e derramá-lo-á sobre a soleira da porta do Templo, os quatro cantos do pedestal do altar e as soleiras dos pórticos do pátio interno."
,"20":"Fará o mesmo no dia sete do mês, pelo homem que tiver pecado por inadvertência ou irreflexão. Desse modo, fareis a expiação pelo Templo."
,"21":"No dia catorze do primeiro mês, realizai a festa da Páscoa: durante sete dias comei pães sem fermento."
,"22":"Nesse dia, o príncipe oferecerá um novilho como sacrifício pelo pecado, por si e por todo o povo."
,"23":"E, durante os sete dias da festa, ele oferecerá diariamente sete novilhos e sete carneiros perfeitos como holocausto a Javé e também um bode como sacrifício pelo pecado."
,"24":"Ele oferecerá também como oblação quarenta e cinco litros de farinha por cada novilho, quarenta e cinco por cada carneiro e sete litros e meio de azeite por cada quarenta e cinco litros de farinha»."
,"25":"«No dia quinze do sétimo mês, por ocasião da festa, durante os sete dias, oferecerá o sacrifício pelo pecado, o holocausto, a oblação e o azeite»."
}`)
	CurrentBook.AddChapter(46, `{
"1":"«Assim diz o Senhor Javé: O pórtico do pátio interno, que dá para o Oriente, permanecerá fechado nos seis dias de trabalho, mas ficará aberto ao sábado e no dia da lua nova."
,"2":"Nesses dias, o príncipe entrará pelo vestíbulo do pórtico externo e ficará junto à soleira, enquanto os sacerdotes estiverem oferecendo o holocausto e os sacrifícios de comunhão. Depois ele prostrar-se-á na soleira do pórtico e sairá. Contudo, o pórtico permanecerá aberto até à tarde."
,"3":"Também o povo da terra se prostrará à entrada desse pórtico, diante de Javé, tanto nos sábados como nos dias de lua nova."
,"4":"O holocausto que o príncipe deve oferecer no dia de sábado consistirá em seis cordeiros e um carneiro, todos perfeitos."
,"5":"Oferecerá também uma oblação de quarenta e cinco litros de farinha por cada carneiro; uma oblação pelos cordeiros, de acordo com as suas possibilidades; e sete litros e meio de azeite por cada quarenta e cinco litros de farinha."
,"6":"No dia da lua nova, as ofertas deverão ser: um novilho perfeito, seis cordeiros e um carneiro, todos perfeitos."
,"7":"Como oblação, oferecerá quarenta e cinco litros de farinha pelo novilho e quarenta e cinco litros pelo carneiro. Quanto aos cordeiros, oferecerá o que for possível. A oblação do azeite será de sete litros e meio por cada quarenta e cinco litros."
,"8":"O príncipe deverá entrar pelo vestíbulo do pórtico e por ele deverá sair."
,"9":"O povo da terra entrará para comparecer na presença de Javé por ocasião das assembleias solenes. Aqueles que entraram pelo pórtico do Norte para se prostrarem, sairão pelo pórtico do Sul; aqueles que entraram pelo pórtico do Sul sairão pelo pórtico do Norte. Ninguém sairá pelo mesmo pórtico por onde tiver entrado; deverá sair pelo lado oposto."
,"10":"O príncipe estará no meio deles: entrará com eles e com eles sairá."
,"11":"Nos dias de festa e nas assembleias solenes, a oblação será de quarenta e cinco litros de farinha por cada novilho e quarenta e cinco litros por cada carneiro; a oblação pelos cordeiros será feita na medida do possível. Quanto ao azeite, será de sete litros e meio por cada quarenta e cinco litros de farinha."
,"12":"Sempre que o príncipe oferecer a Javé um holocausto voluntário ou um sacrifício de comunhão, ser-lhe-á aberta a porta que dá para o Oriente, e ele oferecerá aí o seu holocausto e o seu sacrifício de comunhão, conforme costuma fazer no dia de sábado. Em seguida sairá, e o pórtico será fechado."
,"13":"Diariamente, isto é, todas as manhãs, oferecerá em holocausto um cordeiro perfeito de um ano."
,"14":"Juntamente com o cordeiro, oferecerá em oblação sete litros e meio de farinha e dois litros e meio de azeite, para humedecer a farinha. Será uma oblação a Javé, de acordo com estatuto perpétuo, estatuto que durará para sempre."
,"15":"O cordeiro, a oblação e o azeite serão oferecidos todas as manhãs, para sempre."
,"16":"Assim diz o Senhor Javé: Se o príncipe der um presente tirado da sua herança a um dos seus filhos, o presente será propriedade do filho como herança."
,"17":"Mas se o príncipe der um presente a um dos seus servos, o presente pertencerá ao servo até ao ano da sua alforria, voltando para o príncipe nessa data. De facto, a sua herança pertencerá unicamente aos seus filhos."
,"18":"O príncipe não poderá tomar nada da herança do povo, tirando-lhe a posse do que lhe pertence; ele só poderá dar como herança aos seus filhos daquilo que é sua propriedade para que o meu povo não seja desapropriado daquilo que lhe pertence»."
,"19":"Depois o homem levou-me, pela entrada que fica junto do pórtico, às câmaras do Lugar Santo que pertencem aos sacerdotes e que dão para o Norte. Atrás dessas câmaras, havia um lugar que dava para o Ocidente."
,"20":"Ele disse-me: «Este é o lugar em que os sacerdotes cozerão as vítimas destinadas ao sacrifício de expiação e ao sacrifício pelo pecado. Aqui devem cozer a oblação, para evitar de a levar para o pátio externo, expondo o povo à contaminação do sagrado»."
,"21":"Em seguida, o homem levou-me para fora, para o pátio externo, fazendo-me passar pelos quatro cantos do pátio, onde havia outros pátios em cada canto,"
,"22":"isto é, quatro pátios menores nos quatro cantos do pátio principal. Esses pátios eram iguais e tinham vinte metros de comprimento por quinze metros de largura."
,"23":"Eram cercados por um muro de pedra, com fornos construídos ao pé do muro."
,"24":"Ele explicou-me: «Estes são os fornos onde os servidores do Templo cozem os sacrifícios do povo»."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Então o homem levou-me de novo para a entrada do Templo, onde eu vi água que escorria de debaixo da soleira do Templo para o lado do Oriente, pois a frente do Templo dava para o Oriente. A água escorria de debaixo do lado direito do Templo, ao Sul do altar."
,"2":"Depois o homem fez-me sair pelo pórtico do Norte e contornar por fora até ao pórtico externo que dá para o Oriente, onde a água escorria do lado direito."
,"3":"O homem dirigiu-se para o lado do Oriente com um cordel na mão, medindo quinhentos metros. Ele fez-me atravessar a água, que me chegava aos tornozelos."
,"4":"Tornou a medir quinhentos metros, e fez-me atravessar outra vez a água, que agora me chegava aos joelhos. Mediu de novo quinhentos metros, e fez-me atravessar novamente a água, que agora me chegava à cintura."
,"5":"Mediu outros quinhentos metros, e agora era uma torrente que eu já não podia atravessar a não ser nadando."
,"6":"Então o homem disse-me: «Viste, criatura humana?» E fez-me voltar para a margem da torrente."
,"7":"Quando voltei, havia nas margens, de um lado e de outro, árvores abundantes."
,"8":"Ele disse-me: «Esta água que corre para o lado oriental desce para a Arabá e entra no mar. Ao entrar no mar, a sua água torna-se potável."
,"9":"Por isso, em todo o lugar por onde passar a torrente, os seres vivos que o povoam terão vida. Haverá abundância de peixes, pois aonde quer que essa água chegue, ela levará vida, de modo que haverá vida em todo o lugar que a torrente atingir."
,"10":"Nas suas margens haverá pescadores, e desde Engadi até En-Eglaim haverá lugares para lançar as redes. Haverá muito peixe, das mesmas espécies dos peixes do mar Mediterrâneo."
,"11":"Contudo, os charcos e pântanos não serão de água potável; serão deixados como reservas de sal."
,"12":"Nas margens da torrente, de um lado e do outro, haverá toda a espécie de árvores com frutos comestíveis, cujas folhas e frutos não se esgotarão. Essas árvores produzirão novos frutos todos os meses, porque a água da torrente provém do santuário. Por isso, os frutos servirão de alimento e as folhas de remédio»."
,"13":"Assim diz o Senhor Javé: «São estes os limites da Terra que repartireis como herança entre as doze tribos de Israel, dando duas partes a José."
,"14":"Repartireis dando a todos uma parte igual da Terra que jurei solenemente dar aos vossos antepassados, de modo que ela chegasse a ser a vossa herança."
,"15":"Os limites da Terra são os seguintes: Do lado Norte, desde o mar Mediterrâneo: o caminho de Hetalon até à entrada de Emat, Sedada,"
,"16":"Berota, Sabarim, que fica na fronteira de Damasco e de Emat, e Haser-Ticon, junto à fronteira de Aurã."
,"17":"Os limites irão desde o mar até Haser-Enã, tendo ao Norte o território de Damasco e o território de Emat. Isto quanto à fronteira ao Norte."
,"18":"Do lado Leste, entre Aurã e Damasco, entre Galaad e a terra de Israel, o Jordão servirá de fronteira até ao mar oriental e até Tamar. Tal será a fronteira oriental."
,"19":"Do lado Sul, em direcção ao meio-dia, será desde Tamar até às águas de Meriba de Cades, seguindo a torrente até ao Mar Mediterrâneo. Será esta a fronteira ao Sul."
,"20":"Do lado Oeste, até em frente da entrada de Emat, o Mar Mediterrâneo servirá de fronteira. Tal será a fronteira ocidental."
,"21":"Esta é a Terra que repartireis entre as tribos de Israel."
,"22":"Devereis repartir a Terra como herança entre vós e entre os imigrantes que residem no meio de vós e que entre vós tiverem gerado filhos. Devereis tratá-los como a nativos da Terra, como a israelitas. Eles receberão por sorteio a própria herança, juntamente convosco, no meio das tribos de Israel."
,"23":"Na tribo onde o imigrante estiver a residir, lá lhe dareis a herança - oráculo do Senhor Javé»."
}`)
	CurrentBook.AddChapter(48, `{
"1":"«São estes os nomes das tribos. Dã receberá uma porção no extremo norte, em direcção a Hetalon, junto da entrada de Emat e Haser-Enã, tendo fronteiras com Damasco ao Norte, bem junto de Emat, desde o limite oriental até ao limite ocidental."
,"2":"Aser receberá uma porção junto do território de Dã, desde o limite oriental até ao limite ocidental."
,"3":"Neftali receberá uma porção junto do território de Aser, desde o limite oriental até ao limite ocidental."
,"4":"Manassés receberá uma porção junto do território de Neftali, desde o limite oriental até ao limite ocidental."
,"5":"Efraim receberá uma porção junto do território de Manassés, desde o limite oriental até ao limite ocidental."
,"6":"Rúben receberá uma porção junto do território de Efraim, desde o limite oriental até ao limite ocidental."
,"7":"Judá receberá uma porção junto do território de Rúben, desde o limite oriental até ao limite ocidental."
,"8":"Junto do território de Judá, desde o limite oriental até ao limite ocidental, ficará a porção que separareis como reserva, tendo doze mil e quinhentos metros de largura e de comprimento, isto é, a mesma dimensão que as outras porções, desde o limite oriental até ao limite ocidental. No meio desta reserva ficará o santuário."
,"9":"A reserva que separareis para Javé terá doze mil e quinhentos metros de comprimento por cinco mil metros de largura."
,"10":"A porção sagrada que pertencerá aos sacerdotes terá doze mil e quinhentos metros de extensão do lado Norte, medirá cinco mil metros de largura a Oeste e cinco mil metros de largura a Leste; o seu comprimento do lado Sul será de doze mil e quinhentos metros. No centro ficará o santuário de Javé."
,"11":"Essa porção pertencerá aos sacerdotes consagrados dentre os filhos de Sadoc, que guardaram fielmente o meu ministério, não se desviando com os israelitas, como os levitas fizeram."
,"12":"Caber-lhes-á uma parte da porção mais santa da terra, reservada junto do território dos levitas."
,"13":"O território dos levitas terá exactamente a mesma medida que o território dos sacerdotes: doze mil e quinhentos metros de comprimento por cinco mil metros de largura; o comprimento total será de doze mil e quinhentos metros, e a largura terá cinco mil metros."
,"14":"Deste território nada poderá ser vendido ou trocado, nem os primeiros frutos da terra poderão ser transferidos para outros, porque são consagrados a Javé."
,"15":"Os restantes dois mil e quinhentos metros de largura por doze mil e quinhentos metros de comprimento, será uma porção profana que se destina à cidade, servindo para moradias e pastagens. No centro dessa porção, ficará a cidade."
,"16":"As dimensões da cidade são as seguintes: dois mil e duzentos e cinquenta metros de cada lado, ao Norte, Sul, Leste e Oeste."
,"17":"Os arredores da cidade terão cento e vinte e cinco metros de cada lado, ao Norte, Sul, Leste e Oeste."
,"18":"Ao longo da parte sagrada, ficará uma extensão de cinco mil metros para Oriente, e cinco mil metros para Ocidente, e o produto dessa extensão servirá para o sustento dos trabalhadores da cidade."
,"19":"Este terreno será cultivado pelos trabalhadores da cidade, vindos de todas as tribos de Israel."
,"20":"Ao todo, a parte reservada será um quadrado de doze mil e quinhentos metros. Da parte sagrada, separai um quadrado que pertencerá à cidade."
,"21":"Ao príncipe pertencerá o que restar de um lado e do outro da porção sagrada e da propriedade reservada à cidade. Terá doze mil e quinhentos metros para Ocidente, até ao limite ocidental, e doze mil e quinhentos metros para o Oriente, até ao limite oriental. Esta parte, paralela às demais, pertencerá ao príncipe. No seu centro, estarão a reserva sagrada e o santuário do Templo."
,"22":"Assim, a porção do príncipe ficará entre a propriedade dos levitas e o terreno da cidade, que ficam no meio da porção pertencente ao príncipe, entre os limites de Judá e Benjamim."
,"23":"Porções das outras tribos, desde o limite oriental até ao limite ocidental. Benjamim terá uma porção."
,"24":"Simeão receberá uma porção junto do território de Benjamim, desde o limite oriental até ao limite ocidental."
,"25":"Issacar receberá uma porção junto do território de Simeão, desde o limite oriental até ao limite ocidental."
,"26":"Zabulon receberá uma porção junto do território de Issacar, desde o limite oriental até ao limite ocidental."
,"27":"Gad receberá uma porção junto do território de Zabulon, desde o limite oriental até ao limite ocidental."
,"28":"Junto do território de Gad, no extremo Sul, a fronteira irá de Tamar até às águas de Meriba de Cades, seguindo a torrente até ao Mar Mediterrâneo."
,"29":"Esta é a terra que repartireis em herança entre as tribos de Israel. E estas vão ser as suas porções - oráculo do Senhor Javé»."
,"30":"«As saídas da cidade são as seguintes: Do lado Norte, medi dois mil e duzentos e cinquenta metros."
,"31":"As portas da cidade terão o nome de cada tribo de Israel. Três portas ficarão a Norte: as portas de Rúben, Judá e Levi."
,"32":"Do lado Leste, a extensão será de dois mil e duzentos e cinquenta metros, com três portas: de José, Benjamim e Dã."
,"33":"Do lado Sul, medi a extensão de dois mil e duzentos e cinquenta metros, tendo três portas: de Simeão, Issacar e Zabulon."
,"34":"Do lado Oeste, a extensão será também de dois mil e duzentos e cinquenta metros, com três portas: de Gad, Aser e Neftali."
,"35":"O perímetro total da cidade medirá, portanto, nove mil metros. A partir desse dia, o nome da cidade será este: Javé está lá»."
}`)

}
func PT_BS_LoadVMIEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palavras de Jeremias, filho de Helcias, um dos sacerdotes de Anatot, no território de Benjamim."
,"2":"A palavra de Javé foi-lhe dirigida no décimo terceiro ano do reinado de Josias, filho de Amon, rei de Judá."
,"3":"E também no tempo de Joaquim, filho de Josias, rei de Judá, até ao final do décimo primeiro ano de Sedecias, filho de Josias, rei de Judá, ou seja, até à deportação de Jerusalém, que aconteceu no quinto mês."
,"4":"Recebi a palavra de Javé que me dizia:"
,"5":"«Antes de te formar no ventre de tua mãe, Eu te conheci; antes que fosses dado à luz, Eu te consagrei, para fazer de ti profeta das nações»."
,"6":"Mas eu respondi: «Ah, Senhor Javé, eu não sei falar, porque sou jovem»."
,"7":"Javé, porém, disse-me: «Não digas 'sou jovem', porque irás àqueles a quem Eu te mandar e anunciarás aquilo que Eu te ordenar."
,"8":"Não tenhas medo deles, pois Eu estou contigo para te proteger - oráculo de Javé»."
,"9":"Então Javé estendeu a mão, tocou na minha boca e disse-me: «Eis que ponho as minhas palavras na tua boca."
,"10":"Hoje estabeleço-te sobre as nações e reinos, para arrancares e arrasares, para demolires e destruíres, para construíres e plantares»."
,"11":"Javé dirigiu-me a palavra: «O que vês, Jeremias?» Respondi: «Vejo um ramo de amendoeira»."
,"12":"Javé continuou: «Viste bem, Jeremias, porque Eu vigiarei para cumprir a minha palavra»."
,"13":"De novo Javé me dirigiu a palavra: «O que vês?» Respondi: «Vejo uma panela a ferver, inclinada do Norte para cá»."
,"14":"Javé continuou: «Do lado Norte virá a desgraça sobre todos os moradores do país."
,"15":"Vou convocar todas as tribos dos reinos do Norte - oráculo de Javé -. Elas virão e cada qual colocará o seu trono diante das portas de Jerusalém, contra as suas muralhas e contra todas as cidades de Judá."
,"16":"Eu então pronunciarei as minhas sentenças contra eles, por causa de todas as maldades que cometeram, abandonando-Me para sacrificarem a outros deuses e adorarem o trabalho das suas próprias mãos."
,"17":"Quanto a ti, arregaça as mangas, levanta-te e diz-lhes tudo o que Eu te ordenar. Não tenhas medo; senão Eu é que te farei ter medo deles."
,"18":"Eu hoje faço de ti uma cidade fortificada, uma coluna de ferro e uma muralha de bronze contra o país inteiro: contra os reis de Judá e seus chefes, contra os sacerdotes e contra os proprietários de terras."
,"19":"Eles farão guerra contra ti, mas não te vencerão, pois Eu estou contigo para te proteger» - oráculo de Javé."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Javé dirigiu-me a palavra:"
,"2":"«Vai e grita aos ouvidos de Jerusalém: Assim diz Javé: Eu recordo-Me do teu afecto de jovem, do teu amor de noiva, quando me acompanhavas pelo deserto, numa terra não semeada."
,"3":"Israel era santo para Javé, era o primeiro fruto da sua colheita; aqueles que dele se alimentavam pecavam, e a desgraça caía sobre eles» - oráculo de Javé."
,"4":"Escutai a palavra de Javé, casa de Jacob e todas as tribos da casa de Israel:"
,"5":"Assim diz Javé: «Qual foi a injustiça que os vossos pais encontraram em Mim, para de Mim se afastarem? Correram atrás do vazio, e esvaziaram-se."
,"6":"Eles não perguntaram: 'Onde está Javé que nos fez sair da terra do Egipto e nos conduziu pelo deserto, por terra árida e barrancos, por uma terra seca e sombria, terra onde ninguém passa e onde ninguém mora?'"
,"7":"Depois, fiz-vos entrar numa terra de pomares, para que comêsseis os seus frutos. Mas entrastes e contaminastes a minha terra, transformastes a minha herança em abominação."
,"8":"Os sacerdotes não perguntaram: 'Onde está Javé?' Os doutores da Lei não Me reconheceram, os pastores rebelaram-se contra Mim, os profetas profetizaram em nome de Baal, seguindo deuses que não servem para nada."
,"9":"Por isso, vou novamente entrar em julgamento contra vós - oráculo de Javé - e vou entrar em processo contra os vossos netos."
,"10":"Atravessai o mar até às ilhas de Cetim, e vede. Mandai alguém a Cedar, e observai atentamente. Vede se já aconteceu alguma coisa semelhante:"
,"11":"Acaso já algum povo trocou os seus deuses? - e eles nem deuses são! Pois o meu povo trocou aquilo que era a sua glória por uma coisa que não vale nada."
,"12":"Que o próprio céu fique admirado com uma coisa destas, fique assustado e espantado - oráculo de Javé -"
,"13":"pois o meu povo praticou dois crimes: abandonaram-Me a Mim, fonte de água viva, e cavaram para si poços, poços rachados que não retêm a água."
,"14":"Porventura Israel é um escravo ou nasceu na escravidão? Como é então que se tornou presa"
,"15":"de leões, que rugiram contra ele com grandes urros? Arrasaram a sua terra, incendiaram as suas cidades, deixando-as desabitadas."
,"16":"Até os filhos de Mênfis e Táfnis chegaram a rapar-lhe a cabeça."
,"17":"Será que não foste tu que fizeste isto, quando abandonaste Javé, teu Deus?"
,"18":"Então de que te vale tomares o caminho do Egipto, para ires beber a água do Nilo? Que te vale correres para a Assíria, para beberes água do Eufrates?"
,"19":"Que sejas castigado pela tua própria maldade, sejas corrigido pela tua rebeldia. Que acabes por compreender como é mau e amargo abandonar Javé teu Deus, e não Me temer» - oráculo do Senhor Javé dos exércitos."
,"20":"Já há muito tempo que quebraste o teu jugo, rebentaste o teu cabresto e disseste: 'Não quero servir'. Deitavas-te e prostituías-te no alto de qualquer colina mais elevada ou debaixo de qualquer árvore frondosa."
,"21":"Eu tinha-te plantado como vinha escolhida com garfos de boa casta. E como é que te transformaste em ramos degenerados de vinha sem qualidade?"
,"22":"Mesmo que te esfregues com sabão e uses muito detergente, a mancha da tua culpa continua diante de Mim - orá-culo do Senhor Javé."
,"23":"Como te atreves a dizer que nunca te contaminaste, que nunca procuraste deuses estrangeiros? Olha o rasto que deixaste no vale, reconhece o que fizeste, camela leviana de caminhos extraviados,"
,"24":"jumenta selvagem, habituada ao deserto, farejando o vento no calor do cio: quem domará a tua paixão? Quem te for procurar não vai ter trabalho, pois vai encontrar-te sempre no mês do teu cio."
,"25":"Evita que os teus pés fiquem descalços e a tua garganta sedenta. No entanto, tu dizes: 'De modo nenhum! Eu gosto dos estrangeiros; é a eles que eu vou seguir!'"
,"26":"Como a vergonha de um ladrão apanhado em flagrante, assim será a vergonha da casa de Israel: dos seus reis, chefes, sacerdotes e profetas."
,"27":"Eles dizem a um pedaço de madeira: 'Tu és o nosso pai!' E a uma pedra: 'Tu geraste-nos!' Eles voltam para Mim as costas, e não o rosto. Mas, na hora da angústia, eles dizem-Me: 'Vem! Salva-nos!'"
,"28":"Onde estão os deuses que fabricaste? Que eles te venham salvar no dia da aflição, pois os teus deuses, Judá, são tantos como as tuas cidades."
,"29":"Porque vos insurgis contra Mim, quando todos vós contra Mim vos rebelastes? - oráculo de Javé."
,"30":"Em vão castiguei os vossos filhos, pois eles não aprenderam a lição. Como leão violento, a vossa espada acabou com os profetas."
,"31":"Vós desta geração, considerai a palavra de Javé: Acaso tenho sido para Israel um deserto, ou terra escura? Então, porque é que o meu povo diz: 'Nós emancipámo-nos e não voltaremos para Ti'?"
,"32":"Será que uma jovem esquece os seus enfeites ou uma noiva esquece o seu cinto? No entanto, o meu povo esqueceu-se de Mim durante inumeráveis dias."
,"33":"Como preparas bem os teus caminhos para procurar o amor! Até chegaste a ensinar os teus caminhos às mulheres perdidas!"
,"34":"Nas orlas das tuas vestes há sangue de pobres inocentes que não foram surpreendidos no acto de roubar. Apesar de tudo isto,"
,"35":"ainda dizes: 'Eu estou inocente! A ira de Deus nunca me alcançará'. Pois bem! Eu vou condenar-te, por teres dito que não pecaste."
,"36":"Com que facilidade mudas de rumo! O Egipto será uma decepção para ti, como a Assíria também o foi."
,"37":"Também de lá vais voltar, pondo as mãos na cabeça, pois Javé desprezou aqueles em quem confias, e com eles não terás êxito."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Se um homem dá o divórcio à sua mulher, e ela se separa dele e casa com outro, acaso o primeiro terá direito de voltar para ela? Acaso ela não está contaminada? Prostituíste-te com muitos amantes, e ousas voltar para Mim? - oráculo de Javé."
,"2":"Olha bem para os lugares altos e diz-me: Onde é que não foste desonrada? Como viajante no deserto, sentavas-te à beira dos caminhos, à disposição deles, profanando a terra com as tuas prostituições e maldades."
,"3":"Por isso faltaram as chuvas, e não caíram as chuvas da Primavera. No entanto, continuaste a tua vida de prostituta, e nem disso te envergonhaste."
,"4":"Agora invocas-Me, clamando: 'Meu Pai, Tu és o amigo da minha mocidade'."
,"5":"E dizes: 'Não guardes rancor eterno contra mim'. E continuas a praticar maldades»."
,"6":"No tempo do rei Josias, Javé disse-me: «Viste o que fez Israel, essa rebelde? Ela andou por todos os altos montes e prostituiu-se à sombra de toda a árvore frondosa."
,"7":"Eu pensava que ela, depois de ter feito tudo isso, voltaria para Mim. Mas não voltou. Então a sua irmã Judá, a infiel, viu tudo;"
,"8":"viu que Eu rejeitei a rebelde Israel exactamente por causa de todos os seus adultérios, entregando-lhe o documento de divórcio. Mas a infiel Judá, sua irmã, não teve medo: também ela caiu na prostituição."
,"9":"Com a sua prostituição fácil desonrou o país, cometendo adultério com os ídolos de pedra e de madeira."
,"10":"Apesar de tudo isso, a rebelde Judá, irmã de Israel, não voltou para Mim de todo o coração, mas apenas fingidamente» - oráculo de Javé."
,"11":"Então Javé disse-me: «A rebelde Israel é mais justa que a infiel Judá."
,"12":"Vai, pois, e grita lá do Norte esta mensagem: Volta, Israel rebelde - oráculo de Javé. Eu não te mostrarei uma face indignada, porque sou amoroso - oráculo de Javé - e não guardo rancor eterno."
,"13":"Vamos, reconhece a tua culpa, porque foste infiel a Javé teu Deus: prostituíste-te com estrangeiros à sombra de toda a árvore frondosa, e desobedeceste-Me - oráculo de Javé."
,"14":"Voltai, filhos rebeldes - oráculo de Javé - pois Eu sou o vosso Senhor e posso tomar um de cada cidade e dois de cada clã e levar-vos para Sião."
,"15":"Dar-vos-ei pastores de acordo com o meu coração, e eles guiar-vos-ão com ciência e sensatez."
,"16":"Quando crescerdes e vos multiplicardes no país - oráculo de Javé - então ninguém mais falará na Arca da Aliança de Javé; ninguém pensará nem se lembrará mais dela. Não sentirão falta dela e nem farão outra."
,"17":"Nesse tempo, Jerusalém será chamada 'Trono de Javé'. Nela todos os povos se reunirão em nome de Javé, e não seguirão mais a dureza do seu coração malvado."
,"18":"Nesse dia, a casa de Judá unir-se-á à casa de Israel, e juntas virão da região do Norte para o país que dei como herança aos vossos antepassados."
,"19":"Eu tinha pensado contar-te entre os meus filhos, dar-te uma terra invejável, a pérola das nações como herança, esperando que Me chamasses 'Meu Pai' e não te afastasses de Mim."
,"20":"Mas, semelhante à mulher que trai o seu marido, assim me traiu a casa de Israel - oráculo de Javé."
,"21":"Do alto dos montes vem um clamor: é o choro e os pedidos de piedade dos filhos de Israel que seguiram caminhos tortuosos, esquecidos de Javé, seu Deus."
,"22":"Voltai, filhos rebeldes, e Eu vos curarei da vossa rebeldia! 'Eis-nos aqui, voltamos para Ti, porque Tu, Javé, és o nosso Deus."
,"23":"De facto, são mentira as colinas e os barulhos dos montes. Só Javé nosso Deus é a salvação de Israel."
,"24":"Desde a juventude, a vergonha devorou o fruto do trabalho dos nossos pais: vacas e ovelhas, filhos e filhas."
,"25":"Vamos deitar-nos envergonhados, cobertos de humilhação, porque pecámos contra Javé nosso Deus, nós e os nossos antepassados, desde a juventude até ao dia de hoje, e desobedecemos a Javé nosso Deus'."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Se quiseres voltar, Israel, volta para Mim - oráculo de Javé. Se te afastares das tuas abominações, não andarás errante."
,"2":"O teu juramento será este: 'Pela vida de Javé', com fidelidade, direito e justiça. Então as nações se considerarão abençoadas por ti, e de ti se orgulharão»."
,"3":"Assim diz Javé aos homens de Judá e à cidade de Jerusalém: «Cultivai para vós um campo novo e não semeeis entre espinhos."
,"4":"Circuncidai-vos em honra de Javé, circuncidai o coração, homens de Judá e moradores de Jerusalém, para que a minha ira não se converta em fogo, vos queime, e ninguém possa apagá-la, por causa do mal que praticais."
,"5":"Levai a notícia a Judá, fazei que Jerusalém ouça, tocai a trombeta no país e gritai com toda a força: «Reuni-vos, vamos entrar nas fortalezas."
,"6":"Levantai a bandeira para o lado de Sião. Escondei-vos! Não fiqueis aí parados! Do Norte vou fazer vir uma desgraça, uma grande devastação."
,"7":"O leão sai da sua toca, o demolidor de nações levanta acampamento e sai da sua moradia. Vai fazer do seu país uma ruína, e as suas cidades ficarão destruídas e sem moradores."
,"8":"Por isso, vesti-vos de luto, batei no peito e gritai de dor, porque não conseguimos escapar do fogo da ira de Javé."
,"9":"Nesse dia - oráculo de Javé - o rei e os comandantes vão perder a coragem, os sacerdotes ficarão perturbados e os profetas abismados."
,"10":"Eu disse: 'Ah, Senhor Javé, Tu enganaste este povo e Jerusalém, dizendo-nos que haveria paz, quando a espada já estava na nossa garganta'»."
,"11":"Nesse tempo, vão dizer a este povo e a Jerusalém: «Um vento quente, que não serve para limpar o trigo nem para separar a palha, sopra das dunas do deserto em direcção à capital do meu povo."
,"12":"É um vento forte que vem trabalhar para Mim. Agora, vou pronunciar contra eles as sentenças."
,"13":"Ele avança como nuvens, os seus carros são como um furacão, os seus cavalos mais ligeiros que as águias. Ai de nós, estamos perdidos!"
,"14":"Jerusalém, lava a maldade do teu coração para que possas ser salva. Até quando guardarás no coração esses pensamentos malignos?"
,"15":"Porque um grito se levanta de Dã, e desde a montanha de Efraim anuncia a calamidade."
,"16":"Dizei às nações, anunciai contra Jerusalém: chegam inimigos de uma terra distante e lançam gritos de guerra contra as cidades de Judá."
,"17":"Como guardas de um campo eles a cercam, pois foi contra Mim que ela se revoltou - oráculo de Javé -."
,"18":"A tua conduta e as tuas acções é que provocaram contra ti tudo isto. Como é amarga a tua maldade! Ela penetra até ao teu coração."
,"19":"Ai, que dor de barriga! Que dor de barriga! Tenho que me contorcer! Ó paredes do meu peito! O meu coração pula aqui dentro! Não aguento ficar calado, pois já ouvi o som da trombeta e o grito de guerra."
,"20":"Anunciam derrota sobre derrota, o país está a ser destruído. Derrubaram num instante as minhas tendas e os meus abrigos num minuto."
,"21":"Até quando verei as bandeiras e ouvirei o som da trombeta?"
,"22":"«O meu povo está louco. Não Me conhecem, são pessoas sem bom-senso, que não entendem as coisas. São sábios para fazer o mal, mas não sabem praticar o bem»."
,"23":"Olhei para a Terra: estava sem forma e vazia. Olhei para o céu, e não havia luz."
,"24":"Olhei para as montanhas: elas tremiam, e todas as colinas se abalavam."
,"25":"Olhei: já não havia mais ninguém, e todas as aves do céu haviam fugido."
,"26":"Olhei: o Carmelo era um deserto, e todas as cidades tinham sido destruídas por Javé e pelo calor da sua ira."
,"27":"Porque assim diz Javé: «O país inteiro vai ser arrasado, mas não vou acabar com ele completamente."
,"28":"É por isso que o país fica de luto, e até o céu, lá em cima, se escurece; pois Eu falei, Eu decidi, e não vou arrepender-Me nem voltar atrás»."
,"29":"Com o grito dos cavaleiros e arqueiros, a cidade inteira fugiu; enfiaram-se no mato, subiram para os rochedos; a cidade inteira está abandonada e sem nenhum morador."
,"30":"E tu, Jerusalém, que fazes, vestida de vermelho, enfeitando-te com jóias de ouro, alargando os olhos com pinturas? Não adianta nada embelezares-te: os teus amantes desprezam-te e só atentam contra a tua vida."
,"31":"Ouço um grito como de mulher que dá à luz, numa aflição como aquela que dá à luz pela primeira vez; é o grito da capital de Sião, que geme e estende as mãos: «Ai de mim, vou desmaiar diante dos assassinos»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Percorrei as ruas de Jerusalém, olhai bem e procurai saber; procurai também nas praças, tentai achar alguém que esteja a praticar o direito e procure a verdade. Então, Eu perdoarei à cidade, diz Javé."
,"2":"Quando eles dizem: «Pela vida de Javé!», na verdade juram falso."
,"3":"Ó Javé, os teus olhos não estão voltados somente para a verdade? Tu feriste-los, e eles nem sentiram dor! Acabaste com eles, e não quiseram aprender a lição. O seu rosto ficou mais duro do que a pedra: não quiseram converter-se."
,"4":"Então eu pensava: «Pobre gente! Comportam-se como loucos, porque não conhecem o caminho de Javé, nem o direito do seu Deus."
,"5":"Vou procurar, então, os grandes, e com eles vou conversar, porque eles conhecem o caminho de Javé e o direito do seu Deus». No entanto, eles também quebraram o jugo e soltaram as amarras."
,"6":"Por isso, o leão da floresta ataca-os, o lobo do campo acaba com eles, e uma pantera espreita-os nas suas cidades. Quem quiser sair delas acabará estraçalhado; porque as suas transgressões multiplicaram-se e as suas revoltas não têm conta."
,"7":"Será que Eu te poderia perdoar? Os teus filhos deixaram-Me, e agora juram por deuses que não existem. Enquanto Eu lhes matava a fome, eles traíam-Me procurando as casas de prostitutas;"
,"8":"são como cavalos reprodutores, gordos e lascivos, cada qual relinchando pela mulher do seu próximo."
,"9":"E Eu não os deverei castigar por estas coisas? - oráculo de Javé. Não me vingarei de uma nação como esta?"
,"10":"Escalai os muros da sua vinha, e provocai a destruição, mas não acabeis com tudo: arrancai os sarmentos, porque não são de Javé."
,"11":"Quem Me traiu de verdade foi a casa de Israel e a casa de Judá - oráculo de Javé."
,"12":"Eles renegaram a Javé, dizendo: «Javé não existe! Nenhum mal nos atingirá: não veremos nem guerra nem fome!"
,"13":"Os profetas não passam de vento, as palavras que dizem não são de Javé»."
,"14":"Por isso, assim diz Javé, Deus dos exércitos: «Já que dissestes isto, vou fazer que a minha palavra seja um fogo na vossa boca, e este povo seja a lenha que o mesmo fogo vai devorar."
,"15":"Pois vou mandar contra vós, ó casa de Israel, uma nação distante - oráculo de Javé - uma nação invencível e antiga, uma nação que fala uma língua que não conheceis nem entendeis."
,"16":"A aljava deles é como uma sepultura aberta, e os seus homens são todos valentes."
,"17":"Ela vai devorar a vossa colheita e o vosso pão, vai devorar os vossos filhos e filhas, as ovelhas, o gado, parreiras e figueiras; vai destruir pela espada cidades fortificadas em que tanto confiais."
,"18":"Mas mesmo nessa ocasião - oráculo de Javé - não vos vou acabar totalmente."
,"19":"Quando alguém te perguntar: «Porque é que Javé nosso Deus nos tratou deste modo?» Responderás: «Da mesma forma como Me abandonastes para servir a deuses estrangeiros na vossa própria terra, assim agora trabalhais como escravos para estrangeiros numa terra que não é vossa»."
,"20":"Anunciai isto à casa de Jacob, fazei chegar a Judá esta mensagem:"
,"21":"«Ouvi isto, povo ignorante e insensato. Tendes olhos mas não vedes, tendes ouvidos mas não ouvis."
,"22":"Nem a Mim temeis? - oráculo de Javé. Não tremeis na minha presença? Fui Eu que pus a areia como limite ao mar, uma fronteira eterna que ele não ultrapassa; as suas ondas agitam-se, mas nada conseguem: elas rugem, mas não conseguem ultrapassá-la»."
,"23":"Este povo, porém, é duro e rebelde de coração: afastaram-se e foram-se embora."
,"24":"Não pensaram: «Vamos temer a Javé nosso Deus, que nos dá a chuva do Outono e da Primavera no tempo certo; e ainda estabeleceu as semanas certas para a colheita»."
,"25":"As vossas maldades transtornaram essas coisas, e os vossos erros afastaram todos esses bens;"
,"26":"porque há ímpios no meio do meu povo, espreitando, como se agacham os caçadores de passarinhos; preparam armadilhas para apanhar os homens."
,"27":"Como gaiola cheia de passarinhos, assim as suas casas estão cheias de coisas roubadas. Por isso, progrediram e tornaram-se ricos,"
,"28":"ficaram gordos e reluzentes. A sua maldade passa dos limites: não julgam conforme o direito, não defendem a causa do órfão, nem julgam a causa dos indigentes."
,"29":"E não hei-de castigar tais crimes? - oráculo de Javé. Será que não hei-de vingar-Me de uma nação como esta?"
,"30":"Coisas terríveis e abomináveis acontecem no país:"
,"31":"os profetas só dizem mentiras, os sacerdotes só querem dinheiro, e o meu povo gosta disso! Que ireis fazer quando chegar o fim?»"
}`)
	CurrentBook.AddChapter(6, `{
"1":"Benjaminitas, fugi do meio de Jerusalém! Tocai a trombeta em Técua, levantai um mastro em cima de Bet-Acarem, pois do Norte vem uma desgraça, uma enorme destruição."
,"2":"Vou destruir a bela e delicada capital de Sião."
,"3":"Para lá irão pastores, levando os seus rebanhos; ao seu redor armam as tendas, e cada um apascenta a sua parte."
,"4":"Declarai guerra santa contra Jerusalém! Vamos, atacai de dia! Ai de nós, pois o dia chega ao fim, e a noite vai estendendo as suas sombras."
,"5":"Vamos, atacai de noite! Vamos arrasar os seus palácios!"
,"6":"Pois assim diz Javé dos exércitos: «Cortai árvores e fazei plataformas de assédio contra Jerusalém. Ela é uma cidade condenada, pois dentro dela só existe opressão."
,"7":"De dentro dela só brota maldade, como brota água de um poço. Violência e opressão é o que se ouve nela; feridas e sofrimento estão sempre diante de Mim."
,"8":"Emenda-te, Jerusalém, para que não Me afaste de ti; para que não faça de ti um lugar de ruínas, uma região desabitada»."
,"9":"Assim diz Javé dos exércitos: «Rebuscai o que sobrar de Israel, como se rebusca uma vinha: repassai a mão pelos ramos, como faz o vindimador»."
,"10":"A quem irei falar e testemunhar, para que Me ouçam? Eles têm ouvidos de pagãos, e não são capazes de entender. Para eles a palavra de Javé é objecto de escárnio; não gostam dela."
,"11":"Estou cheio da indignação de Javé, já não aguento mais. «Então descarrega essa raiva sobre as crianças da rua, ou sobre os jovens. Tanto o homem como a mulher serão presos, tanto o ancião como o velho no fim da vida."
,"12":"As suas casas vão passar para estrangeiros, e também as suas terras e mulheres, pois vou estender a mão contra os habitantes deste país» - oráculo de Javé."
,"13":"Porque, desde o maior ao mais pequeno, são todos gananciosos; desde o profeta ao sacerdote, são todos contadores de mentiras."
,"14":"Sem responsabilidade, querem curar a ferida do meu povo, dizendo: «Paz! Paz!», quando não existe paz."
,"15":"Eles deviam envergonhar-se porque praticaram coisas abomináveis, mas não se envergonham, nem sabem o que é sentir vergonha. «Por isso, cairão entre os que tombam; no tempo em que os visitar, vão tropeçar» - disse Javé."
,"16":"Assim diz Javé: «Parai no caminho e vede, informai-vos sobre os caminhos do passado: qual era o caminho da felicidade? Andai por ele, e encontrareis descanso». Mas eles responderam: «Não caminharemos nele!»"
,"17":"«Coloquei sentinelas para vos guardar! Prestai atenção quando a trombeta tocar!» Mas eles responderam: «Não vamos prestar atenção!»"
,"18":"«Por isso escutai, nações; e tu, assembleia, conhece o que lhes vai acontecer."
,"19":"Ouve também tu, ó Terra: Enviarei uma desgraça contra este povo, fruto das suas más acções, porque não obedeceram às minhas palavras e desprezaram a minha Lei."
,"20":"Que Me importa o incenso que vem de Sabá, e a canela perfumada que vem de países distantes? Os vossos holocaustos não Me agradam, os vossos sacrifícios não são do meu gosto»."
,"21":"Por isso, assim diz Javé: «Vou colocar pedras no caminho deste povo, e eles vão tropeçar: pais e filhos, vizinhos e amigos morrerão todos juntos»."
,"22":"Assim diz Javé: «Virá um povo do Norte, uma grande nação se levantará dos limites da Terra;"
,"23":"eles são fortes no arco e na lança, são cruéis e sem compaixão. O estrondo que fazem parece o das ondas do mar; vêm todos montados em cavalos, em ordem de batalha, como se fossem um só homem. Vêm atacar-te, capital de Sião!»"
,"24":"Só de ouvir a sua fama as nossas mãos amoleceram, ficamos tomados pela angústia e pela dor, como a mulher que dá à luz."
,"25":"Não saiais para o campo, nem andeis pelas estradas, porque a espada inimiga espalha terror por todos os lados."
,"26":"Veste-te de luto, capital do meu povo, revolve-te nas cinzas, e a chorar como pela morte de um filho único; faz uma lamentação amarga, porque chegará de repente aquele que nos vai destruir."
,"27":"Eu nomeio-te examinador do meu povo, para que conheças e examines o seu comportamento."
,"28":"Todos são rebeldes e semeadores de calúnias. Parecem bronze ou ferro, e estão todos corrompidos."
,"29":"O fole sopra para atiçar o fogo e derreter o chumbo; mas o trabalho do fundidor é inútil, pois as impurezas não se desprendem."
,"30":"Prata de refugo é o seu nome, porque Javé os rejeitou."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Palavra de Javé, que foi dirigida a Jeremias:"
,"2":"«Coloca-te à porta do Templo e diz o seguinte: Escutai a palavra de Javé, vós todos povos de Judá que entrais por esta porta, para adorar a Javé."
,"3":"Assim diz Javé dos exércitos, o Deus de Israel: Endireitai os vossos caminhos e a vossa maneira de agir, e Eu morarei convosco neste lugar."
,"4":"Não vos iludais com palavras mentirosas, dizendo: 'Este é o Templo de Javé, Templo de Javé, Templo de Javé!'"
,"5":"Se endireitardes os vossos caminhos e a vossa maneira de agir; se cada um começar a praticar o direito com o seu próximo;"
,"6":"se não oprimirdes o estrangeiro, o órfão e a viúva; se não derramardes sangue inocente neste lugar e não correrdes atrás dos deuses estrangeiros que vos trazem a desgraça:"
,"7":"então Eu continuarei a morar convosco neste lugar, nesta Terra que dei aos vossos antepassados há muito tempo e para sempre."
,"8":"Vós iludis-vos com palavras mentirosas que não trazem proveito nenhum."
,"9":"Não é assim? Roubar, matar, cometer adultério, jurar falso, queimar incenso a Baal, seguir deuses estrangeiros que nunca conhecestes..."
,"10":"E depois apresentais-vos diante de Mim, neste Templo, onde o meu Nome é invocado, e dizeis: 'Estamos salvos!', para depois continuardes a praticar essas abominações."
,"11":"Este Templo, onde o meu Nome é invocado, será porventura esconderijo de ladrões? Ficai sabendo que Eu vi todas estas coisas - oráculo de Javé."
,"12":"Agora ide ao meu lugar em Silo, onde antes fiz habitar o meu Nome, e vede o que lá fiz por causa da maldade do meu povo de Israel."
,"13":"Mas agora, visto que fizestes tudo o que fizestes - oráculo de Javé - visto que Eu vos falei repetidas vezes e não Me destes atenção, chamei-vos e não Me respondestes,"
,"14":"vou tratar este Templo, onde é invocado o meu Nome, no qual tanto confiais, e também este lugar que dei a vós e aos vossos antepassados, vou tratá-lo do mesmo modo como tratei Silo."
,"15":"Vou expulsar-vos da minha presença, da mesma forma como expulsei todos os vossos irmãos e toda a descendência de Efraim."
,"16":"Quanto a ti, não rezes por este povo, não faças preces nem súplicas em favor deles. Não insistas comigo, porque não te vou atender."
,"17":"Não vês o que eles fazem nas cidades de Judá e nas ruas de Jerusalém?"
,"18":"Os filhos recolhem lenha, os pais acendem o fogo e as mulheres preparam a massa para fazer broas em honra da rainha do céu; depois derramam vinho em homenagem aos deuses estrangeiros, só para Me insultar."
,"19":"Mas será a Mim que eles ofendem? - oráculo de Javé. Não será a eles mesmos, para sua própria vergonha?»"
,"20":"Por isso, assim diz o Senhor Javé: «A minha ira ardente derramar-se-á sobre este lugar, sobre as pessoas e os animais, sobre as árvores do campo e os frutos da terra. A minha ira vai inflamar-se, e não se apagará»."
,"21":"Assim diz Javé dos exércitos, o Deus de Israel: «Juntai os vossos holocaustos aos vossos sacrifícios, e comei essas carnes."
,"22":"Pois quando tirei do Egipto os vossos antepassados, não disse nada nem dei ordem alguma sobre holocaustos e sacrifícios."
,"23":"A única coisa que lhes disse e ordenei foi isto: Obedecei-Me e serei o vosso Deus, e vós sereis o meu povo. Andai sempre no caminho que Eu vos indicar, para que sejais felizes."
,"24":"Eles, porém, não obedeceram nem deram ouvidos, e continuaram a proceder conforme a obstinação do seu coração perverso. E, em vez de se virarem para Mim, voltaram-Me as costas."
,"25":"Desde o dia em que os vossos antepassados saíram da terra do Egipto até hoje, todos os dias, enviei-vos sem cessar os meus servos, os profetas."
,"26":"Mas eles não lhes obedeceram, nem Me deram ouvidos; pelo contrário, endureceram ainda mais a cerviz e tornaram-se piores que os seus antepassados."
,"27":"Transmitir-lhes-ás estas coisas, mas eles não te obedecerão; chamá-los-ás, mas eles não responderão."
,"28":"Então dir-lhes-ás: Esta é uma nação que nunca obedeceu a Javé seu Deus nem aceita correcção. A sua fidelidade morreu: foi expulsa da sua boca."
,"29":"Jerusalém, corta os teus cabelos consagrados e deita-os fora; entoa uma lamentação lá no alto dos montes, porque Javé rejeitou e abandonou a geração que incendiou a sua ira."
,"30":"Sim, os filhos de Judá praticaram o que é mau aos meus olhos - oráculo de Javé. Cometeram sacrilégio, colocando essas abominações no Templo, onde o meu Nome é invocado."
,"31":"Depois construíram os lugares altos de Tofet, no vale de Ben-Enom, para queimar no fogo filhos e filhas, coisa que não mandei e que jamais passou pela minha mente."
,"32":"É por isso que chegarão dias - oráculo de Javé - em que não se chamará mais vale de Tofet ou de Ben-Enom, mas vale da Matança. Por falta de lugar, vão fazer de Tofet um cemitério,"
,"33":"pois os cadáveres deste povo servirão de comida às aves do céu e aos animais da terra. E ninguém os espantará."
,"34":"Nas cidades de Judá e nas ruas de Jerusalém, farei cessar o som da música e os gritos de alegria, a voz do noivo e da noiva, pois o país transformar-se-á numa ruína completa."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Naquele tempo - oráculo de Javé - serão retirados das suas sepulturas os ossos dos reis de Judá, dos seus chefes, dos sacerdotes, dos profetas e dos moradores de Jerusalém."
,"2":"Esses ossos ficarão expostos ao Sol, à Lua e às estrelas, aos quais amaram e serviram, seguiram, consultaram e adoraram. Ninguém recolherá nem sepultará novamente esses ossos; ficarão como esterco para o campo."
,"3":"O resto que sobrar dessa gente perversa achará bem melhor morrer do que ficar vivo, em qualquer lugar para onde Eu os dispersar - oráculo de Javé dos exércitos."
,"4":"«Diz-lhes isto: Assim fala Javé: Acaso quem cai não se levanta? Quem se desvia do caminho não volta atrás?"
,"5":"Então, porque é que este povo se revolta, e Jerusalém se revolta continuamente? Persistem na sua má fé e recusam converter-se."
,"6":"Prestei atenção e ouvi: eles não falam como deveriam. Ninguém se arrepende do mal cometido, pois dizem: 'O que é que eu fiz?' Cada um segue em frente sem voltar atrás: assemelha-se ao cavalo que se lança na batalha."
,"7":"Até a cegonha no céu conhece o seu tempo; a rola, a andorinha e o grou conhecem o tempo da sua migração. Mas o meu povo não compreende o direito de Javé»."
,"8":"Eles dizem: «Somos sábios, temos a Lei de Javé». Mas a caneta falsa do escriba transformou em mentira a Lei de Deus."
,"9":"Os sábios ficarão confusos, desnorteados, e cairão no laço, pois rejeitaram a palavra de Javé. Que sabedoria podem ter eles?"
,"10":"Por isso vou entregar as suas mulheres a estrangeiros, e as suas terras a conquistadores. Pois, do primeiro ao último, são todos ávidos de lucro; do profeta ao sacerdote, todos praticam a mentira."
,"11":"Sem responsabilidade, querem curar as feridas do meu povo, dizendo apenas: «Paz! Paz!», quando não existe paz."
,"12":"Eles deviam envergonhar-se, pois o que fizeram foi abominável. Mas não se envergonham, não sabem o que é sentir vergonha. Por isso cairão entre os que pereceram, vacilarão no dia da prestação de contas - diz Javé."
,"13":"Eu queria colher deles alguma coisa - oráculo de Javé - mas não há uvas na parreira nem figos na figueira, e até as suas folhas secaram. Eu entregá-los-ei à escravidão."
,"14":"Porque estamos aqui sentados? Reuni-vos! Entremos nas cidades fortificadas para morrermos dentro delas, porque Javé nosso Deus nos faz perecer. Ele faz-nos beber água envenenada, pois pecámos contra Ele."
,"15":"Esperávamos a paz, e nada de bom aconteceu; tempo de exultação e eis que só há terror."
,"16":"Desde Dã já se pode ouvir o resfolegar dos cavalos, e a terra estremece com o relinchar dos seus corcéis. Eles vieram para acabar com o país e tudo o que nele existe, para acabar com a cidade e os seus habitantes."
,"17":"Vou mandar contra vós serpentes venenosas, contra as quais não existe encantamento, e elas morder-vos-ão - oráculo de Javé."
,"18":"O sofrimento acabrunha-me e o meu coração desfalece,"
,"19":"pois ouço de longe os gritos da capital do meu povo: «Será que Javé não está em Sião? Não está nela o seu rei?» Por que razão provocaram a minha ira com os seus ídolos, com os seus deuses estrangeiros?"
,"20":"Passou a ceifa, terminou a colheita, e nós não fomos socorridos."
,"21":"Eu também sofro com as feridas da capital do meu povo; fiquei deprimido, e a solidão apoderou-se de mim."
,"22":"Será que não existe bálsamo em Galaad? Não há nenhum médico? Por que razão não cicatriza a ferida da capital do meu povo?"
,"23":"Quem fará da minha cabeça uma fonte de água, e dos meus olhos uma mina de lágrimas, para que possa chorar dia e noite os mortos da capital do meu povo?"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Quem me dará no deserto um abrigo de viajantes? Então deixaria o meu povo e iria para longe deles, pois todos eles são adúlteros, um bando de traidores."
,"2":"Retesam a língua como arco; o que manda no país é a mentira, e não a verdade. Pois eles saem de um crime para outro, e não Me conhecem - oráculo de Javé."
,"3":"Cada um guarde-se do seu próximo e não confie em nenhum dos irmãos, pois todo o irmão engana o seu irmão, e todo o amigo espalha calúnias."
,"4":"Cada um engana o próprio amigo e ninguém diz a verdade; treinam a língua a proferir mentiras, e praticam a injustiça até se cansarem."
,"5":"Vivem no meio da falsidade e, por causa da falsidade, recusam conhecer-Me - oráculo de Javé."
,"6":"Por isso, assim diz Javé dos exércitos: Eu os fundirei e provarei: que outra coisa poderia Eu fazer com a capital do meu povo?"
,"7":"A sua língua é uma flecha envenenada: em tudo o que dizem só há maldade. Cada um fala de paz ao próximo, mas, no íntimo, arma-lhe ciladas."
,"8":"Não deveria Eu puni-los por estas coisas? - oráculo de Javé. Não deveria Eu vingar-Me de um povo como este?"
,"9":"Sobre as montanhas desato a chorar e a gemer, sobre as pastagems do deserto solto o meu lamento, pois tudo está arrasado; por ali não passa mais ninguém, e já nem se ouve o barulho dos rebanhos; as aves do céu e até os animais, todos fugiram e desapareceram."
,"10":"Vou fazer de Jerusalém um montão de ruínas: ela tornar-se-á esconderijo de chacais; das outras cidades de Judá vou fazer um lugar desolado, onde ninguém habitará."
,"11":"Quem será sábio para entender tudo isto? A quem é que Javé falou, para que o explique? Por que motivo o país ficou destruído, desolado como deserto por onde não passa ninguém?"
,"12":"Javé responde: Foi porque eles abandonaram a Lei que Eu lhes tinha dado, desobedeceram à minha palavra e não a seguiram."
,"13":"Seguiram o seu coração obstinado, indo atrás dos deuses cananeus que os seus antepassados já haviam seguido."
,"14":"Por isso, assim diz Javé dos exércitos, o Deus de Israel: Farei com que este povo coma erva amarga e beba água envenenada;"
,"15":"vou espalhá-los no meio de nações que nem eles nem seus pais conheceram, e ainda mandarei a espada persegui-los até Eu os ter exterminado."
,"16":"Assim diz Javé dos exércitos: Atenção! Chamai as carpideiras, mandai vir as mais hábeis."
,"17":"Que elas se apressem e cantem sobre nós uma lamentação. Os nossos olhos derramem lágrimas e as nossas pálpebras vertam água,"
,"18":"porque um grito de dor vem de Sião: «Como fomos arrasados! A nossa vergonha é enorme, pois temos que abandonar o país e deixar as nossas casas»."
,"19":"Portanto, mulheres, escutai a palavra de Javé. Que os vossos ouvidos recebam a palavra da sua boca. Ensinai às vossas filhas esta lamentação, cada qual ensine à vizinha este canto fúnebre:"
,"20":"«A morte subiu pelas nossas janelas e entrou nos nossos palácios; matou as crianças nas ruas e os jovens nas praças;"
,"21":"os cadáveres humanos vão caindo como esterco que se espalha no chão e como feixes de trigo atrás do ceifeiro sem haver quem os recolha»."
,"22":"Assim diz Javé: Que o sábio não se glorie da sua sabedoria, o forte não se glorie da sua força, e o rico não se glorie da sua riqueza."
,"23":"Se alguém quer gloriar-se, que se glorie de conhecer e compreender que Eu sou Javé, que na Terra estabeleço o amor, o direito e a justiça, pois é disso que Eu gosto - oráculo de Javé."
,"24":"Eis que virão dias - oráculo de Javé - em que vou castigar todos aqueles que são circuncidados, e no entanto continuam pagãos:"
,"25":"os egípcios, os judeus, os edomitas, os amonitas, os moabitas, e também os de cabeça rapada que vivem no deserto; pois todos os povos são pagãos, e a casa de Israel é pagã de coração."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Escutai as palavras de advertência que Javé vos dirige, ó casa de Israel."
,"2":"Assim diz Javé: Não imiteis o comportamento dos outros povos e não fiqueis com medo dos sinais do céu, porque os outros povos costumam ter medo disso."
,"3":"Pois o que é terror para os povos não passa de um nada, é apenas um pedaço de madeira cortada na floresta, obra trabalhada pelo cinzel do artista."
,"4":"Com prata e ouro enfeitam o que fizeram, com pregos e martelo fixam-no num lugar, para que não se mova."
,"5":"Os ídolos são como espantalho num campo de pepinos: não sabem falar e precisam de ser transportados, porque não sabem andar. Não tenhais medo deles, pois nada de mal podem fazer, e não são capazes de fazer o bem."
,"6":"Eles não são como Tu, ó Javé: Tu és grande, e grande é o poder do teu Nome."
,"7":"Quem Te não temeria, ó Rei das nações? A Ti é devido tudo isto, pois ninguém é igual a Ti entre todos os sábios das nações e em todos os seus reinos."
,"8":"Eles são ignorantes e insensatos: o ensinamento dos ídolos é só madeira."
,"9":"Eles trazem de Társis prata batida e de Ofir trazem ouro, tudo trabalho de carpinteiro e de ourives; roxo e vermelho são as cores das suas roupas, tudo trabalho de mestres no ofício."
,"10":"No entanto, Javé é o Deus verdadeiro, Ele é o Deus vivo e Rei eterno. Diante da sua ira a terra estremece, e as nações não suportam o seu furor."
,"11":"É assim que lhes deveis responder: «Os deuses que não fizeram o Céu e a Terra desaparecerão da terra e de debaixo do céu»."
,"12":"Com o seu poder Javé fez a Terra; com a sua sabedoria firmou o mundo, e com a sua inteligência estendeu os céus."
,"13":"Ao barulho do seu trovão, as águas no céu agitam-se; Ele faz subir as nuvens do extremo da Terra, produz os raios para a chuva e faz sair o vento dos seus depósitos."
,"14":"Todo o homem se julga imbecil, sem entender, e todo o ourives se envergonha do ídolo que esculpiu, pois a sua estátua é mentira e não tem vida."
,"15":"Os ídolos são vazios, uma coisa ridícula; eles desaparecerão na hora do acerto de contas."
,"16":"A porção de Jacob não é como eles, porque Javé criou todas as coisas, e Israel é a tribo da sua herança. O seu nome é Javé dos exércitos."
,"17":"Levanta do chão a tua bagagem, tu que estás cercada pelo inimigo."
,"18":"Porque assim diz Javé: Desta vez vou expulsar os habitantes deste país; e vou atormentá-los, para que Me encontrem."
,"19":"«Ai de mim, por causa da minha ferida; a minha chaga é incurável. Apesar disso, eu dizia: É uma dor que posso suportar."
,"20":"A minha tenda foi derrubada e todas as cordas foram cortadas. Os meus filhos abandonaram-me, já não existem, não há ninguém para armar a minha tenda e estender a lona»."
,"21":"Os pastores perderam o bom-senso e deixaram de procurar Javé; por isso não tiveram sucesso, e o rebanho que conduziam dispersou-se."
,"22":"Ouvi o barulho que avança com grande estrondo lá do país do Norte; vem reduzir a ruínas as cidades de Judá, a covil de chacais."
,"23":"Javé, eu sei que o homem não é dono do próprio caminho; que não pertence ao caminhante dirigir os seus próprios passos."
,"24":"Javé, corrige-me, mas com justa medida, e não conforme a tua ira, para que não seja reduzido ao nada."
,"25":"Derrama o teu furor sobre as nações que não Te conhecem, e sobre os povos que não invocam o teu Nome. Porque eles devoraram Jacob, devoraram até acabar com ele, e devastaram os seus campos."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Palavra que Javé dirigiu a Jeremias:"
,"2":"«Escuta as palavras desta aliança, e comunica-as depois aos cidadãos de Judá e aos moradores de Jerusalém."
,"3":"Diz-lhes: Assim diz Javé, o Deus de Israel: Maldito o homem que não obedece às palavras desta aliança,"
,"4":"que Eu ordenei aos vossos antepassados, quando vos tirei da terra do Egipto, daquela fornalha de ferro, dizendo: Obedecei-Me e fazei tudo como vos ordenei; então sereis o meu povo e Eu serei o vosso Deus."
,"5":"Desta forma há-de cumprir-se o juramento que fiz aos vossos antepassados, de lhes dar uma terra onde corre leite e mel, como acontece hoje». E respondi: «Assim seja, Javé!»"
,"6":"Então Javé disse-me: «Proclama tudo isto nas cidades de Judá e nas ruas de Jerusalém, dizendo: Escutai as palavras desta aliança e ponde tudo em prática."
,"7":"Eu falei insistentemente aos vossos antepassados, quando os tirei do Egipto, até hoje, afirmando com toda a seriedade e firmeza: Obedecei-Me!"
,"8":"Eles, porém, não quiseram obedecer, nem se deram ao trabalho de prestar atenção. Pelo contrário, cada qual foi seguindo a maldade do seu coração obstinado. Foi então que Eu executei, para castigo deles, todas as maldições desta aliança, pois não fizeram o que Eu lhes ordenei»."
,"9":"Javé disse-me ainda: «Formou-se uma conspiração entre os cidadãos de Judá e os habitantes de Jerusalém:"
,"10":"eles voltaram aos pecados dos seus antepassados que não quiseram obedecer-Me, seguiram e serviram a deuses estrangeiros. As famílias de Israel e de Judá quebraram a aliança que Eu tinha feito com os seus antepassados."
,"11":"Por isso, assim diz Javé: Farei vir uma desgraça à qual não poderão escapar. Gritarão por Mim, e Eu não os ouvirei."
,"12":"Então as cidades de Judá e os habitantes de Jerusalém irão pedir socorro aos deuses aos quais costumam oferecer incenso, mas eles não serão capazes de os livrar do tempo da desgraça."
,"13":"O número dos teus deuses, ó Judá, é igual ao número das tuas cidades; igual ao número das tuas ruas, Jerusalém, é o número de altares, onde ofereces sacrifícios a Baal, essa coisa vergonhosa."
,"14":"Tu, porém, não intercedas por este povo. Não faças por ele nenhuma súplica ou prece. Quando clamarem por Mim na hora da desgraça, Eu não os ouvirei»."
,"15":"O que é que a minha amada procura no meu Templo, com o seu comportamento perverso? Acaso poderão as promessas e as carnes dos sacrifícios limpar-te da tua maldade, para que possas celebrar com gritos de alegria?"
,"16":"Javé chamou-te «oliveira verde de belos frutos», mas com grande barulho incendiou com furor as folhas, e os teus ramos queimaram-se."
,"17":"Javé dos exércitos, que te plantou, agora pronuncia uma desgraça contra ti por causa do mal que a casa de Judá e de Israel fez a si mesma quando queimou incenso a Baal, para Me irritar."
,"18":"Javé ensinou-me e fez-me compreender as intrigas que eles faziam."
,"19":"Como um cordeiro manso eu estava a ser levado para o matadouro. Eu não percebia que eles estavam a tramar contra mim, dizendo: «Vamos derrubar esta árvore enquanto está verde, vamos tirá-la da terra dos vivos, e que o seu nome nunca mais seja lembrado!»"
,"20":"Tu, porém, Javé dos exércitos, és um juiz justo. Tu sondas os rins e o coração. Que eu possa ver a tua vingança contra eles, pois a Ti confio a minha causa."
,"21":"Por isso, assim diz Javé aos homens de Anatot, que atentam contra a minha vida, dizendo: «Não profetizes em nome de Javé, senão vais morrer às nossas mãos»."
,"22":"Assim diz Javé dos exércitos: Aqui estou Eu para os castigar. Os jovens morrerão à espada, filhos e filhas morrerão de fome."
,"23":"Não escapará ninguém, pois mandarei a desgraça contra os homens de Anatot, no ano do seu castigo."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Tu és justo, ó Javé, para que possa discutir contigo. No entanto, gostaria de fazer-Te uma pergunta acerca do direito: Porque é que o caminho dos ímpios prospera e os traidores vivem todos em paz?"
,"2":"Tu plantaste-os e eles criaram raízes; e agora crescem e produzem frutos. Tu estás perto da sua boca, mas longe do seu coração."
,"3":"Mas tu, Javé, conheces-me e vês-me, e sabes que o meu coração está contigo. Arranca essa gente como ovelhas para o matadouro; separa-os para o dia da matança."
,"4":"Até quando o país ficará de luto, e estará seco tudo o que era verde nos campos? Pela maldade dos seus moradores, perecem as feras e os pássaros. Pois eles dizem: «Deus não vê os nossos passos»."
,"5":"Se correndo com os pedestres te cansas, como poderás competir com os cavalos? Se não te sentes seguro numa região pacífica, o que farás na floresta do Jordão?"
,"6":"Porque até os teus irmãos e a família do teu pai, até eles te traíram e caluniaram pelas costas. Não confies neles, mesmo quando te disserem palavras amigáveis."
,"7":"Eu abandonei a minha casa e rejeitei a minha herança; entreguei o amor da minha vida nas mãos dos seus inimigos,"
,"8":"porque a minha herança voltou-se contra Mim, rugindo como um leão feroz; por isso, comecei a odiá-la."
,"9":"A minha herança transformou-se em leopardo e as aves de rapina volteiam sobre ela: juntai-vos, feras selvagens, vinde devorá-la."
,"10":"Muitos pastores devastaram a minha vinha e pisaram a minha propriedade; transformaram a minha propriedade querida num deserto desolado;"
,"11":"fizeram dela um lugar devastado, e deixaram-na em estado deplorável; está desolada diante de Mim: o país inteiro foi devastado, e ninguém se preocupa com isso."
,"12":"Sobre todos os montes de areia do deserto chegam os devastadores, porque Javé empunha uma espada que devora de uma extremidade à outra do país, e não há paz para ninguém."
,"13":"Eles semearam trigo e colheram espinhos; cansaram-se sem proveito nenhum. Ficaram envergonhados com a colheita por causa da flamejante ira de Javé."
,"14":"Assim diz Javé a todos os meus vizinhos maus que puseram a mão na minha herança, que eu tinha dado como propriedade ao meu povo Israel: Arrancá-los-ei dos seus campos e também arrancarei do meio deles a casa de Judá."
,"15":"Depois de os arrancar, tornarei a compadecer-Me deles e farei que voltem, cada um para a sua propriedade, cada um para a sua herança."
,"16":"Se eles aprenderem de verdade os caminhos do meu povo e jurarem pelo meu Nome, dizendo: «Pela vida de Javé!» da mesma forma como acostumaram o meu povo a jurar por Baal, então poderão estabelecer-se no meio do meu povo."
,"17":"Mas arrancarei e destruirei a nação que não quiser obedecer - oráculo de Javé."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Javé ordenou-me: «Vai comprar um cinto de linho e põe-no à cintura, sem o molhares»."
,"2":"Comprei o cinto como Javé havia ordenado, e coloquei-o à cintura."
,"3":"Javé ordenou-me de novo:"
,"4":"«Toma o cinto que compraste e trazes à cintura, vai até ao rio Eufrates e esconde-o na fenda de uma rocha»."
,"5":"Eu fui e escondi o cinto na margem do Eufrates, conforme Javé me havia ordenado."
,"6":"Depois de muito tempo, Javé disse-me: «Vai até ao Eufrates e toma o cinto que lá te mandei esconder»."
,"7":"Fui ao rio Eufrates, escavei e tirei o cinto do lugar onde o tinha escondido. Mas o cinto estava podre, não servia para nada."
,"8":"Veio-me, então, a palavra de Javé, dizendo:"
,"9":"Assim fala Javé: É desta forma que vou acabar com o orgulho de Judá e com a vaidade desmedida de Jerusalém."
,"10":"Este povo é mau, não quer obedecer-Me, tem o coração obstinado e anda atrás dos deuses estrangeiros para lhes prestar culto e adorá-los. Este povo ficará imprestável como este cinto."
,"11":"Da mesma forma como o cinto fica preso à cintura de uma pessoa, assim também Eu quis prender a Mim a casa de Israel e a casa de Judá, para que fossem meu povo, minha fama, minha glória e minha honra - oráculo de Javé. Mas eles não Me obedeceram."
,"12":"Deverás dizer o seguinte a este povo: Assim fala Javé, o Deus de Israel: «As vasilhas enchem-se de vinho». Eles responderão: «Nós bem sabemos que as vasilhas se enchem de vinho!»"
,"13":"Então lhes dirás: Assim diz Javé: «Eu mesmo encherei de embriaguez todos os moradores deste país: os reis que se sentam no trono de David, os sacerdotes, os profetas e todos os habitantes de Jerusalém."
,"14":"Assim vou quebrá-los, uns contra os outros: os pais contra os filhos - oráculo de Javé. Nem a piedade, nem o perdão, nem a compaixão Me impedirão de destruí-los»."
,"15":"Escutai, prestai atenção! Não sejais orgulhosos, pois é Javé quem fala."
,"16":"Dai glória a Javé, vosso Deus, antes que escureça, antes que os vossos pés tropecem pelos montes, quando cair a noite. Vós esperais a luz, mas Ele a transformará em trevas e a mudará numa densa escuridão."
,"17":"Se não ouvirdes, eu chorarei em segredo diante da vossa soberba. Os meus olhos derreter-se-ão em lágrimas, porque o rebanho de Javé será exilado."
,"18":"Diz ao rei e à rainha-mãe: «Sentai-vos no chão, pois a coroa real caiu das vossas cabeças."
,"19":"As cidades do Negueb estão cercadas e não há ninguém capaz de romper o cerco. Judá inteiro foi levado para o exílio, numa deportação total»."
,"20":"Levantai os olhos para ver os que vêm do Norte. Onde foi parar o rebanho que te fora confiado e as ovelhas maravilhosas que possuías?"
,"21":"O que vais dizer, quando sobre ti forem colocados como chefes aqueles que te acostumaste a ter como amigos? E agora, não é que vai tomando conta de ti uma dor como da mulher que está para dar à luz?"
,"22":"Talvez penses: «Porque me acontece tudo isto?» Por causa do grande número dos pecados que cometeste é que levantaram a tua saia para te violentarem."
,"23":"Pode o negro mudar a cor da sua pele? Pode o leopardo mudar as suas pintas? E podeis vós, viciados no mal, vir um dia a praticar o bem?"
,"24":"Pois Eu vou espalhar-vos como palha soprada pelo vento do deserto."
,"25":"É esta a parte que te dou, na sua exacta medida - oráculo de Javé - porque te esqueceste de Mim para confiar na mentira."
,"26":"Agora sou Eu que te levanto a saia até à altura do teu rosto, para que os outros possam ver as tuas partes vergonhosas."
,"27":"Os adultérios que cometes, os teus gemidos de prazer, a vergonha da tua prostituição: Eu vi os teus horrores sobre as colinas e campos. Ai de ti, Jerusalém, se não te purificas! Até quando, afinal?"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Palavra que Javé dirigiu a Jeremias, por ocasião da seca:"
,"2":"Judá está de luto e as suas cidades desfalecem; elas inclinam-se sombrias, e Jerusalém lança gritos."
,"3":"Os ricos mandam os seus servos em busca de água. Eles vão até aos poços, mas não encontram água, e voltam com os baldes vazios. Envergonhados e frustrados, cobrem a cabeça."
,"4":"Por causa da terra que está gretada, pois não chove na região, os lavradores cobrem a cabeça envergonhados e frustrados."
,"5":"A corça no mato depois de ter dado à luz abandona a cria, pois não há erva."
,"6":"Os burros selvagens param no alto das colinas, em busca de ar puro, como chacais, porém os seus olhos apagam-se por falta de verdura."
,"7":"Se os nossos pecados depõem contra nós, toma providências, Javé, por causa do teu Nome. A nossa rebeldia é muito grande, nós pecámos contra Ti."
,"8":"Ó Esperança de Israel, Salvador na hora da aflição: porque queres ser como um forasteiro no país, ou como um viajante que só pára a fim de passar a noite?"
,"9":"Porque és como um homem surpreendido ou um guerreiro que não pode salvar? Tu, porém, Javé, estás entre nós, e sobre nós foi invocado o teu Nome. Não nos abandones!"
,"10":"Assim diz Javé a respeito deste povo: «Gostam de andar errantes e os seus pés não param. Por isso Javé não gosta deles, recorda as suas iniquidades e castiga os seus pecados»."
,"11":"Javé disse-me: «Não intercedas em favor do bem-estar deste povo."
,"12":"Ainda que façam jejum, não ouvirei a sua súplica. Se oferecerem holocaustos e sacrifícios, não terei prazer nenhum com isso. É com a espada, a fome e a peste que os exterminarei»."
,"13":"Então eu disse: «Ah! Senhor Javé, os falsos profetas dizem: 'Vós não vereis a espada, não sofrereis fome, pois vou conceder-vos uma paz perfeita neste lugar'»."
,"14":"Javé respondeu-me: «É mentira o que esses profetas vaticinam em meu nome. Eu não os enviei, não lhes dei ordem nenhuma, nem falei com eles. Eles anunciam-vos visões mentirosas, oráculos vazios e fantasias da sua imaginação."
,"15":"Por isso, assim diz Javé: Os profetas que pregam em meu nome sem que Eu os tenha enviado e afirmam: 'A espada e a fome não existirão no país', esses profetas cairão pela espada e pela fome."
,"16":"O povo a quem eles pregam será lançado nas ruas de Jerusalém, mortos pela fome e pela espada, e ninguém os sepultará, nem a eles, nem às suas mulheres, filhos e filhas. Farei voltar contra eles o próprio mal que cometeram»."
,"17":"Tu lhes dirás estas palavras: Que os meus olhos derramem lágrimas, noite e dia sem parar, pela terrível desgraça da capital do meu povo, pela sua ferida incurável."
,"18":"Se saio para o campo, lá estão os trespassados pela espada; se entro na cidade, lá está o horror da fome. Tanto o profeta como o sacerdote percorrem o país, e não sabem o que fazer."
,"19":"Javé, será que rejeitaste completamente Judá? Será que sentes nojo de Sião? Porque nos feriste, sem que haja quem nos cure? Esperávamos a paz, e nada de bom acontece; esperávamos o tempo da salvação, e só vemos angústia."
,"20":"Reconhecemos, Javé, a nossa culpa e a culpa dos nossos antepassados: nós pecámos contra Ti."
,"21":"Mas, por causa do teu Nome, não nos abandones, não humilhes o trono da tua glória. Lembra-Te! Não quebres a Aliança que fizeste connosco."
,"22":"Entre os ídolos vazios das nações, porventura existe algum que faça chover? Ou é o céu que nos dá sozinho os aguaceiros? Não és Tu que fazes isto, Javé nosso Deus? Em Ti nós esperamos, porque és Tu que fazes tudo isto."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Javé disse-me: Mesmo que Moisés e Samuel se apresentassem na minha frente, nem assim Me comoveria em favor deste povo. Afasta-o da minha presença, que se retire!"
,"2":"Se, por acaso, te perguntarem: «Para onde iremos?» responderás: «Assim diz Javé: Quem está destinado para a morte, vá para a morte; quem para a espada, vá para a espada; quem para a fome, vá para a fome; quem para o exílio, vá para o exílio»."
,"3":"Vou mandar contra eles quatro espécies de males - oráculo de Javé: a espada para os matar, os cães para os despedaçarem, as aves do céu e as feras para os devorarem e destruírem."
,"4":"Farei deste povo um objecto de espanto para todos os reinos da terra, por causa de Manassés, filho de Ezequias, rei de Judá, por aquilo que ele fez em Jerusalém."
,"5":"Quem terá pena de ti, Jerusalém, quem terá compaixão de ti? Quem se voltará para perguntar por ti?"
,"6":"Abandonaste-Me - oráculo de Javé - voltaste-Me as costas. Eu estendi a mão para te aniquilar. Estou cansado de ter piedade."
,"7":"Eu espalhei-os como a palha ao vento pelas cidades do país. Deixei-te sem filhos e destruí o meu povo, porque não se converteram da sua conduta."
,"8":"Para Mim, as suas viúvas são mais numerosas que a areia do mar. Em pleno meio-dia, mandei o invasor sobre as mães e sobre os jovens; num instante, fiz cair sobre eles o medo e o terror."
,"9":"Está abatida a mãe de sete filhos, e a sua alma desfalece. Ainda é dia, e o sol já se põe. Ela está envergonhada e confusa. Eu entregarei os seus sobreviventes à espada, como presa aos seus inimigos - orá-culo de Javé."
,"10":"Ai de mim, minha mãe, porque me puseste no mundo! Eu sou homem de litígios e discórdias em toda a Terra. Ninguém me deve, e eu também não devo nada; no entanto, todos me amaldiçoam."
,"11":"Javé, será que eu não Te servi do melhor modo possível? No perigo e na desgraça, intercedi em favor dos meus inimigos."
,"12":"(Poderá o ferro quebrar o ferro do Norte e o bronze?"
,"13":"Por causa de todos os pecados que cometeste por todo o país, Eu entregarei de graça à pilhagem as tuas riquezas e tesouros."
,"14":"Farei de ti um escravo dos teus inimigos, numa terra que não conheces. Pois o fogo da minha ira se acendeu e arderá contra vós)."
,"15":"Tu bem sabes! Javé, lembra-Te de mim, ajuda-me e vinga-me dos meus perseguidores. Tem paciência, não me deixes perecer! Olha como suporto insultos por tua causa."
,"16":"Quando recebi as tuas palavras, eu devorava-as. A tua palavra era festa e alegria para o meu coração, porque eu levava o teu Nome, ó Javé, Deus dos exércitos."
,"17":"Nunca me sentei numa roda alegre para me divertir. Forçado pela tua mão, sentava-me sozinho, pois encheste-me de cólera."
,"18":"Porque será que a minha dor não tem fim e a minha ferida é tão grave e sem remédio? Ou será que Te transformaste para mim num rio enganador de água inconstante?"
,"19":"Javé respondeu-me: «Se te reconciliares comigo receber-te-ei novamente ao meu serviço. Se separares o metal das impurezas, serás como a minha bo-ca. Que eles voltem para ti, e não tu para eles."
,"20":"Vou fazer de ti, diante deste povo, qual muralha de bronze invencível. Lutarão contra ti, e não te vencerão; porque Eu estou contigo para te livrar e salvar - oráculo de Javé."
,"21":"Vou livrar-te da mão dos malvados e do punho dos violentos»."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Javé enviou-me esta palavra:"
,"2":"Não te cases com mulher nenhuma, nem tenhas filhos ou filhas neste lugar."
,"3":"Porque assim diz Javé a respeito dos filhos e filhas que nascem neste lugar, das mães que os puseram no mundo e dos pais que geraram estas crianças neste país:"
,"4":"Morrerão com enfermidades graves, e não serão chorados nem sepultados, mas servirão de esterco para a terra. Morrerão pela espada ou pela fome, e os seus cadáveres servirão de comida para as aves do céu e para os animais da terra."
,"5":"Porque assim diz Javé: Não entres numa casa onde haja luto, não chores nem dês os pêsames, pois Eu decidi tirar deste povo a minha paz, o meu amor e compaixão - orá-culo de Javé."
,"6":"Morrerão tanto os grandes como os pequenos neste país, e ninguém vai sepultá-los ou chorar por eles, nem vai fazer incisões ou cortar o cabelo em sinal de luto."
,"7":"Ninguém repartirá o pão no banquete fúnebre, no meio de condolências; não haverá quem dê algo de beber aos que vão dar os pêsames pelo pai ou mãe de alguém."
,"8":"Também não entres numa casa onde há festa, para te sentares, comeres e beberes com eles,"
,"9":"porque assim diz Javé dos exércitos, o Deus de Israel: Diante dos vossos olhos e ainda nos vossos dias, expulsarei deste país o som da música e os gritos de alegria, a voz do noivo e da noiva."
,"10":"Quando anunciares esta mensagem a este povo, eles perguntar-te-ão: «Porque é que Javé nos ameaça com estas desgraças tão grandes? Quais foram os erros ou pecados que cometemos contra Javé, o nosso Deus?»"
,"11":"Então responder-lhes-ás: «É porque os vossos antepassados Me abandonaram - oráculo de Javé - e seguiram deuses estrangeiros, servindo-os e adorando-os. Abandonaram-Me e deixaram de cumprir a minha Lei."
,"12":"Vós, porém, fizestes pior que os vossos antepassados: cada um de vós seguiu a maldade do seu coração obstinado, sem nunca Me dar ouvidos."
,"13":"Por isso, vou expulsar-vos daqui para um país que nem vós nem os vossos antepassados conheceram. Lá, servireis dia e noite, a divindades estrangeiras, porque Eu não terei misericórdia de vós»."
,"14":"Virão dias - oráculo de Javé - em que ninguém dirá: «Pela vida de Javé, que tirou os filhos de Israel do Egipto!»"
,"15":"Mas dirão: «Pela vida de Javé, que fez sair os filhos de Israel do país do Norte e de todas as regiões onde os tinha espalhado!» Eu vou fazê-los regressar à Terra que Eu tinha dado aos seus antepassados."
,"16":"Enviarei numerosos pescadores para os pescar - oráculo de Javé. Depois disso, vou mandar numerosos caçadores, que os caçarão pelas montanhas, colinas e até nas fendas das rochas."
,"17":"Porque os meus olhos observam os caminhos dessa gente: eles não conseguem escondê-los de Mim, nem ocultar os seus pecados diante dos meus olhos."
,"18":"Castigarei duplamente os erros e pecados deste povo, pois profanaram a minha Terra com os cadáveres dos seus ídolos e encheram a minha herança com as suas abominações."
,"19":"Javé, minha força e defesa, meu refúgio na hora do perigo, as nações virão procurar-Te, virão das extremidades da Terra e exclamarão: «A herança de nossos pais é falsa, é coisa inútil e sem proveito»."
,"20":"Poderá o homem fabricar deuses? Então não são deuses."
,"21":"Por isso, desta vez vou fazer que conheçam; vou mostrar-lhes a minha mão e a minha força. E aprenderão que o meu Nome é Javé."
}`)
	CurrentBook.AddChapter(17, `{
"1":"O pecado de Judá está escrito com estilete de ferro, está gravado com ponta de diamante na pedra do seu coração e também nos ângulos dos seus altares."
,"2":"É para que os seus filhos se lembrem dos seus altares e dos postes sagrados debaixo das árvores verdes, sobre as colinas elevadas,"
,"3":"sobre os montes e em campo aberto. Por causa de todos os pecados que cometeste em todos os teus territórios, vou entregar à pilhagem todos os teus bens e tesouros."
,"4":"Terás que renunciar à herança que Eu te havia dado; tornar-te-ei escravo dos teus inimigos numa terra que não conheces, porque acendestes o fogo da minha ira, que arderá para sempre."
,"5":"Assim diz Javé: Maldito o homem que confia no homem e que busca apoio na carne, e cujo coração se afasta de Javé."
,"6":"Será como a árvore solitária no deserto, que não chega a ver a chuva: habitará no deserto abrasador, na terra salgada e inabitável."
,"7":"Bendito o homem que confia em Javé, e em Javé deposita a sua segurança."
,"8":"Ele será como a árvore plantada à beira da água que lança raízes em direcção ao rio. Não teme quando vem o calor, e as suas folhas estão sempre verdes; no ano da seca, não se perturba, e não cessa de dar frutos."
,"9":"O coração é mais enganador que qualquer outra coisa, e dificilmente se cura: quem de nós pode entendê-lo?"
,"10":"Eu, Javé, penetro o coração e sondo os pensamentos, para pagar a cada um conforme o seu comportamento e segundo o fruto das suas acções."
,"11":"Como a perdiz que choca ovos que não pôs, assim é aquele que acumula riquezas com o engano: no meio da sua vida, deverá deixá-las e no fim parecerá um idiota."
,"12":"O nosso Templo é um trono glorioso e altaneiro desde o princípio."
,"13":"Javé, Tu és a esperança de Israel! Todos aqueles que Te abandonam ficarão envergonhados; aqueles que se afastam de Ti terão os seus nomes inscritos na poeira, porque abandonaram Javé, a fonte de água viva."
,"14":"Cura-me, Javé, e eu ficarei curado; salva-me e eu serei salvo, porque Tu és o meu louvor."
,"15":"Eles dizem-me: «Onde está a Palavra de Javé? Que ela se cumpra!»"
,"16":"Eu nunca insisti contigo pedindo desgraças, nem desejei um dia de desastre, Tu bem o sabes; tudo o que saiu dos meus lábios está diante de Ti."
,"17":"Não sejas motivo de medo para mim, pois é em Ti que eu me refugio no dia da desgraça."
,"18":"Que fiquem envergonhados aqueles que me perseguem, e não eu; fiquem eles com medo, e não eu. Faz chegar para eles o dia da desgraça, esmaga-os com dupla destruição."
,"19":"Assim me disse Javé: Põe-te à porta de Benjamim, por onde entram e saem os reis de Judá; depois põe-te junto de todas as portas de Jerusalém."
,"20":"Diz então às pessoas: Escutai a palavra de Javé, reis de Judá, todo o povo de Judá e moradores de Jerusalém, vós todos que costumais passar por estas portas."
,"21":"Assim diz Javé: Por amor à vossa vida, evitai transportar cargas em dia de sábado e entrar com elas pelas portas de Jerusalém."
,"22":"Da mesma forma, não tireis nenhum peso de dentro das vossas casas em dia de sábado, e não façais nenhum trabalho. Pelo contrário, santificai o dia de sábado, conforme a ordem que dei aos vossos antepassados."
,"23":"Mas eles não atenderam, nem deram ouvidos, e ainda endureceram o pescoço para não Me obedecerem, nem aprenderem a lição."
,"24":"Se Me obedecerdes - oráculo de Javé - e não entrardes pelas portas desta cidade carregando pesos em dia de sábado, mas santificardes esse dia, e não fizerdes qualquer outro trabalho,"
,"25":"então pelas portas desta cidade entrarão reis e príncipes, que se sentarão no trono de David, montados em carros e cavalos, tanto os reis como os seus oficiais, assim como os cidadãos de Judá e os moradores de Jerusalém. E esta cidade será habitada para sempre."
,"26":"E então, virá gente das cidades de Judá, das redondezas de Jerusalém, da região de Benjamim, da planície, das montanhas e do Negueb, trazendo ao Templo de Javé holocaustos, sacrifícios, oferendas, incenso e oferendas de acção de graças."
,"27":"Porém, se não Me obedecerdes, e não santificardes o sábado, se em dia de sábado carregardes pesos ao entrar pelas portas de Jerusalém, então deitarei fogo a essas portas; ele queimará os palácios de Jerusalém e nunca mais se apagará."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Palavra que Javé dirigiu a Jeremias:"
,"2":"«Levanta-te e desce à casa do oleiro e lá te comunicarei a minha Palavra»."
,"3":"Desci à casa do oleiro e encontrei-o a fazer um objecto no torno."
,"4":"O objecto que ele estava a modelar deformou-se, mas ele aproveitou o barro e fez outro objecto, conforme lhe pareceu melhor."
,"5":"Então foi-me dirigida a palavra de Javé:"
,"6":"Não poderei fazer de vós, ó casa de Israel, o que faz este oleiro? - oráculo de Javé. Como barro nas mãos do oleiro, assim estais vós nas minhas mãos, ó casa de Israel."
,"7":"De repente, falo contra um povo e contra um reino, ameaçando arrancar, derrubar e destruir."
,"8":"Se esse povo, do qual falei, deixa a prática do mal, então eu também desisto do mal que pensei fazer-lhe."
,"9":"Outras vezes, falo a um povo e a um reino prometendo construir e plantar."
,"10":"Mas se eles praticam o mal diante de Mim e não obedecem à minha palavra, então Eu desisto de lhes fazer o bem que lhes prometi."
,"11":"Agora, diz ao cidadão de Judá e ao habitante de Jerusalém: «Assim diz Javé: Estou a preparar uma calamidade e a tramar um projecto contra vós. Cada um procure abandonar o seu mau caminho, melhorar os seus hábitos e as suas acções»."
,"12":"Mas eles responderão: «Não adianta! Nós continuaremos a seguir os nossos projectos». E cada um seguirá a maldade do seu coração obstinado."
,"13":"Por isso, assim diz Javé: Procurai interrogar as nações. Qual delas ouviu semelhante coisa? A capital de Israel praticou coisas horríveis."
,"14":"Será que a neve do Líbano se desvia das rochas escarpadas? Ou secam as águas que vêm de longe, frias e torrenciais?"
,"15":"No entanto, o meu povo esqueceu-se de Mim e queimou incenso a um ídolo vazio. Foi assim que tropeçaram nos seus caminhos, caminhos antigos, e foram andando por caminhos tortuosos, por uma estrada não aplanada."
,"16":"Fizeram do seu próprio país um lugar de ruínas, motivo de contínuo escárnio. Quem por lá passa fica espantado e abana a cabeça."
,"17":"Como vento oriental, vou fazer que eles se dispersem diante do inimigo; no dia da derrota, voltarei para eles as costas e não o rosto."
,"18":"Eles disseram: «Vamos tramar um plano contra Jeremias, pois o sacerdote não ficará sem a instrução, nem o sábio sem o conselho, nem o profeta sem a palavra. Vamos ferir Jeremias com a nossa língua, e não vamos fazer caso das suas palavras»."
,"19":"Escuta-me, Javé, e ouve o que dizem os meus adversários."
,"20":"Será que o bem deve ser pago com o mal? Pois eles abriram uma cova para me apanharem. Lembra-Te de que me apresentei diante de Ti para interceder por eles, para desviar deles a tua ira."
,"21":"Por isso, agora, entrega à fome os seus filhos, lança-os ao poder da espada; que as suas mulheres fiquem sem filhos e viúvas, que os seus maridos sejam mortos pela peste e os seus jovens atingidos pela espada no combate."
,"22":"Que se escutem gritos de socorro vindos das suas casas, quando de repente fizeres cair sobre eles bandos de salteadores. Pois eles abriram uma cova para me prenderem, armaram laços aos meus pés."
,"23":"Mas Tu, Javé, conheces muito bem todos os planos de morte que eles tramam contra mim. Não deixes impune a injustiça, nem tires da tua lembrança os seus pecados. Que eles tropecem na tua presença; executa-os no momento da tua ira."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Assim disse Javé a Jeremias: Vai comprar uma bilha de barro. Leva contigo alguns anciãos do povo e alguns sacerdotes,"
,"2":"e segue em direcção ao vale de Ben-Enom, que fica à entrada da porta dos Cacos. Aí anunciarás as palavras que te vou dizer."
,"3":"Dirás: Escutai a Palavra de Javé, ó reis de Judá e habitantes de Jerusalém! Assim fala Javé dos exércitos, o Deus de Israel: Vou mandar contra este lugar uma calamidade tão grande, que fará retinir os ouvidos de quem a ouvir."
,"4":"Porque eles Me abandonaram e profanaram este lugar, queimando incenso a outros deuses, que nem eles, nem os seus antepassados, nem os reis de Judá conheciam. Encheram este lugar com sangue de inocentes,"
,"5":"e construíram lugares altos para Baal, para queimar os seus filhos no fogo em holocausto a Baal. Eu nunca mandei fazer tal coisa, nem disse, nem me passou pelo pensamento."
,"6":"Por isso - oráculo de Javé - virão dias em que este lugar já não se chamará Tofet ou vale de Ben-Enom, mas vale da Matança."
,"7":"Esvaziarei neste lugar os planos de Judá e de Jerusalém. Vou fazê-los cair ao fio da espada diante do inimigo e por meio daqueles que querem matá-los. Vou entregar os seus cadáveres como alimento às aves do céu e às feras."
,"8":"Transformarei esta cidade em lugar deserto e motivo de zombaria, e todos os que por ela passarem ficarão assustados e começarão a assobiar por causa de todos os seus ferimentos."
,"9":"Farei que devorem a carne dos próprios filhos e filhas. Devorar-se-ão entre si por causa do cerco e da angústia que os inimigos lhes vão impor."
,"10":"Então quebrarás a bilha diante dos homens que te acompanharem."
,"11":"Depois dir-lhes-ás: Assim fala Javé dos exércitos: Vou quebrar este povo e esta cidade como objecto de barro que se quebra e não tem conserto. As pessoas serão enterradas no lugar chamado Tofet, pois não haverá outro lugar para sepultá-las."
,"12":"É assim que vou fazer contra este lugar - oráculo de Javé - e contra os seus habitantes: tornarei esta cidade como Tofet."
,"13":"Ficarão impuras como Tofet as casas de Jerusalém e as casas dos reis de Judá, todas as casas em cujos terraços queimaram incenso aos astros do céu e onde derramaram vinho em honra de deuses estrangeiros."
,"14":"Jeremias foi-se embora de Tofet, aonde Javé o tinha mandado para falar em seu nome, e colocou-se à entrada do Templo de Javé. Ali falou a todo o povo:"
,"15":"Assim diz Javé dos exércitos, o Deus de Israel: Vou mandar, contra esta cidade e contra todas as outras cidades do país, todos os males que anunciei, pois os seus habitantes endureceram o pescoço e não Me obedeceram."
}`)
	CurrentBook.AddChapter(20, `{
"1":"O sacerdote Fassur, filho de Emer, que era administrador-chefe do Templo de Javé, ouviu estas palavras de Jeremias."
,"2":"Fassur mandou bater no profeta Jeremias e colocá-lo na prisão que fica na porta superior de Benjamim e que dá para o Templo de Javé."
,"3":"No dia seguinte, Fassur mandou soltar Jeremias. Então Jeremias disse-lhe: «Para Javé já não te chamas Fassur, mas Terror-ao-redor»."
,"4":"Porque assim diz Javé: Vou transformar-te em terror para ti mesmo e para todos os que te são caros. Estes cairão mortos pela espada dos teus inimigos. Verás isto com os teus próprios olhos. Entregarei Judá inteiro nas mãos do rei da Babilónia; ele levar-vos-á cativos para a Babilónia e vos matará à espada."
,"5":"Toda a riqueza desta cidade, toda a sua produção, tudo o que ela tem de valor e também os tesouros dos reis de Judá, entregá-los-ei nas mãos dos teus inimigos. Eles vão saquear, apoderar-se de tudo e levá-lo para a Babilónia."
,"6":"Tu, porém, Fassur, terás de ir para o exílio na Babilónia com todos os que moram na tua casa. Ali morrerás e serás sepultado, tu e todos aqueles que te são caros, aos quais profetizavas mentiras."
,"7":"Tu me seduziste, Javé, e eu deixei-me seduzir. Foste mais forte do que eu e venceste. Sou objecto de zombaria o dia inteiro e todos escarnecem de mim."
,"8":"Quando falo, é aos gritos, clamando: «Violência! Opressão!» A palavra de Javé tornou-se para mim motivo de vergonha e escárnio o dia inteiro."
,"9":"A mim mesmo dizia: «Não pensarei mais n'Ele, não falarei mais no seu Nome!» Era como se houvesse no meu coração um fogo ardente, fechado nos meus ossos. Estou cansado de suportar, não aguento mais!»"
,"10":"Eu ouvia muita gente que dizia: «Terror ao redor. Denunciai, vamos denunciá-lo». Todos os meus amigos esperam que eu tropece: «Talvez ele se deixe seduzir! Então dominá-lo-emos e vingar-nos-emos dele»."
,"11":"Javé, porém, está ao meu lado como valente guerreiro. Por isso, aqueles que me perseguem tropeçarão e não conseguirão vencer; eles ficarão profundamente envergonhados, porque não terão êxito, e a sua ignomínia será eterna e inesquecível."
,"12":"Javé dos exércitos, Tu que examinas o justo e vês os rins e o coração, que eu possa ver a tua vingança contra eles, pois foi a Ti que confiei a minha causa."
,"13":"Cantai a Javé, louvai a Javé, pois Ele livrou a vida do pobre das mãos dos malvados."
,"14":"Maldito seja o dia em que nasci. Que jamais seja bendito o dia em que minha mãe me deu à luz!"
,"15":"Maldito o homem que levou a notícia a meu pai, dizendo: «Nasceu-te um filho varão!», enchendo-o de alegria."
,"16":"Que essa pessoa sofra como as cidades que Javé destruiu sem compaixão; ouça gritos pela manhã e rumores de guerra ao meio-dia."
,"17":"Porque não me fez morrer no ventre materno? A minha mãe teria sido a minha sepultura, e o seu ventre estaria grávido para sempre!"
,"18":"Porque saí do ventre materno? Só para ver tormentos e dores, e terminar os meus dias na vergonha?"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Palavra que Javé dirigiu a Jeremias quando o rei Sedecias lhe mandou Fassur, filho de Melquias, e o sacerdote Sofonias, filho de Maasias, para lhe dizer:"
,"2":"«Intercede junto de Javé por nós, porque Nabucodonosor, rei da Babilónia, está em guerra contra nós. Talvez Javé faça em nosso favor algum dos seus numerosos prodígios, e Nabucodonosor se afaste de nós»."
,"3":"Jeremias respondeu: Dizei a Sedecias:"
,"4":"Assim diz Javé, o Deus de Israel: As armas com as quais estais a combater, Eu entregá-las-ei ao rei da Babilónia e aos caldeus que vos cercam fora da muralha, e juntá-las-ei no meio desta cidade."
,"5":"Eu mesmo vou guerrear contra vós com mão forte e braço estendido, com ira, com ódio e com grande furor."
,"6":"Ferirei os moradores desta cidade, e as pessoas e animais morrerão numa grande epidemia."
,"7":"Depois disto - oráculo de Javé - tomarei Sedecias, rei de Judá, os funcionários, o povo, os que tiverem escapado da peste, da espada e da fome, e entregá-los-ei nas mãos de Nabucodonosor, rei da Babilónia, nas mãos dos seus inimigos, daqueles que procuram tirar-lhes a vida. Matá-los-ão ao fio da espada, não os pouparão, nem terão piedade ou compaixão."
,"8":"Ao povo, porém, dirás: Assim diz Javé: Vou colocar diante de vós o caminho da vida e o caminho da morte."
,"9":"Quem ficar na cidade morrerá pela espada, pela fome e pela peste; quem sair e se entregar aos caldeus, que vos cercam, continuará vivo. A sua vida ser-lhe-á deixada como despojo."
,"10":"Pois Eu voltei a minha face contra esta cidade, para sua desgraça e não para sua felicidade - oráculo de Javé. Ela será entregue nas mãos do rei da Babilónia, que a incendiará."
,"11":"Dirás à casa do rei de Judá: Ouve a Palavra de Javé."
,"12":"Casa de David, assim diz Javé: De manhã, administrai a justiça e libertai o oprimido da mão do opressor. Senão, a minha ira devorará como o fogo; ela se acenderá, e ninguém poderá apagá-la, por causa de todo o mal que praticais."
,"13":"Eis-me aqui, Moradora do vale, Rochedo da planície - oráculo de Javé. Vós dizeis: «Quem nos virá atacar? Quem entrará nas nossas casas?»"
,"14":"Castigar-vos-ei conforme o fruto das vossas acções - oráculo de Javé. Lançarei fogo à vossa floresta e ele devorará tudo em volta."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Assim diz Javé: Desce ao palácio do rei de Judá, e quando lá chegares diz o seguinte:"
,"2":"Rei de Judá, tu que estás sentado no trono de David, escuta a Palavra de Javé. Que os teus funcionários também escutem, como todo o povo que costuma entrar por estas portas."
,"3":"Assim diz Javé: Praticai o direito e a justiça. Libertai o oprimido da mão do opressor; não trateis com violência, nem oprimais o imigrante, o órfão e a viúva; e não derrameis sangue inocente neste lugar."
,"4":"Se obedecerdes a esta ordem, os reis que se sentam no trono de David, e também os seus funcionários e todo o seu povo, continuarão a entrar pelas portas deste palácio, montados em carros e cavalos."
,"5":"Mas se não obedecerdes a estas palavras, juro por Mim mesmo - oráculo de Javé - que este palácio se transformará em ruínas."
,"6":"Assim diz Javé ao palácio do rei de Judá: Eras para Mim como Galaad e o cume do Líbano; juro que te transformarei num deserto, numa cidade desabitada."
,"7":"Consagrarei os destruidores que virão contra ti, cada um com as suas armas: eles cortarão os melhores cedros que possuis e lançá-los-ão ao fogo."
,"8":"Muitas nações atravessarão esta cidade, e as pessoas perguntarão umas às outras: «Porque é que Javé tratou assim esta grande cidade?»"
,"9":"E responderão: «Foi porque eles abandonaram a aliança de Javé, seu Deus, e adoraram e serviram outros deuses»."
,"10":"Não choreis pelo morto e não façais lamentações por ele. Chorai por quem partiu, pois nunca mais voltará para rever a sua terra natal."
,"11":"Assim diz Javé a respeito de Selum, filho de Josias, rei de Judá, que começou a reinar no lugar de seu pai Josias, e saiu deste lugar: ele nunca mais voltará aqui."
,"12":"Morrerá no lugar para onde o exilaram, e nunca mais verá esta Terra."
,"13":"Ai daquele que constrói a sua casa sem justiça e os seus aposentos sem direito, que faz trabalhar o seu próximo gratuitamente, lhe recusa o salário,"
,"14":"e que diz: «Vou construir uma casa grande, com imensos aposentos». E faz janelas, recobre a casa com cedro e pinta-a de vermelho."
,"15":"Pensas que és rei porque tens mais cedro que os outros? O teu pai não comeu e não bebeu? Pois ele fez o que é justo e o que é direito, e no seu tempo tudo lhe correu bem."
,"16":"Ele julgava com justiça a causa do pobre e do indigente; e tudo lhe corria bem! Acaso não significa isto conhecer-Me? - oráculo de Javé."
,"17":"Mas tu não vês outra coisa e não pensas senão no lucro, em derramar sangue inocente e em praticar a opressão e a violência."
,"18":"Por isso, assim diz Javé a respeito de Joaquim, rei de Judá, filho de Josias: Ninguém vai chorar por ele, dizendo «Ai meu irmão, ai minha irmã!» Ninguém vai chorar por ele: «Ai meu senhor, ai majestade!»"
,"19":"Ele será sepultado como um jumento, será arrastado e lançado fora das portas de Jerusalém."
,"20":"Sobe ao Líbano e grita por socorro; em Basã faz ouvir a tua voz: grita por socorro desde Abarim, porque foram esmagados todos os teus amantes."
,"21":"Falei contigo quando estavas tranquila, mas respondeste-me: «Não Te quero ouvir». É este o teu caminho desde a mocidade: nunca Me obedeceste."
,"22":"Todos os teus pastores se tornarão pasto do vento; os teus amantes irão para o exílio. Nessa altura sentir-te-ás confusa e envergonhada por causa de toda a tua maldade."
,"23":"Moradora do Líbano, aninhada nos mais altos cedros, gemerás ao chegarem as tuas dores, as convulsões, semelhantes às da mulher no parto."
,"24":"Pela minha vida - oráculo de Javé: Conias, filho de Joaquim, rei de Judá, ainda que fosses um anel na minha mão direita, Eu arrancar-te-ia."
,"25":"Vou entregar-te nas mãos daqueles que te querem matar, daqueles que temes: Nabucodonosor, rei da Babilónia, e os caldeus."
,"26":"Enviar-te-ei, a ti e à tua mãe, aquela que te pôs no mundo, para um país onde não nascestes e onde morrereis."
,"27":"Mas à terra aonde desejam voltar, não voltarão."
,"28":"Será Conias uma vasilha imprestável, quebrada, ou um objecto que ninguém quer? Porque será que ele e a sua família foram expulsos e enviados para uma terra que não conheciam?"
,"29":"Terra, Terra, Terra! Ouve a Palavra de Javé."
,"30":"Assim diz Javé: Registai este homem como alguém que não tem filhos, indivíduo sem sucesso na vida, porque ninguém da sua família conseguirá sentar-se no trono de David, para governar novamente em Judá."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Ai dos pastores que dispersam e perdem as ovelhas do meu rebanho - oráculo de Javé."
,"2":"Por isso assim diz Javé, o Deus de Israel, contra os pastores encarregados de cuidar do meu povo: Dispersastes e perdestes as minhas ovelhas, e não vos preocupastes com elas. Pois agora sou Eu que vos vou pedir contas pelo mal que praticastes - oráculo de Javé."
,"3":"Eu mesmo vou reunir o que restou das minhas ovelhas de todas as regiões para onde Eu as tinha expulsado. Fá-las-ei voltar às suas pastagens, para que cresçam e se multipliquem."
,"4":"Vou dar-lhes pastores que cuidem delas, e elas nunca mais terão medo ou susto, nem se perderão - oráculo de Javé."
,"5":"Dias virão - oráculo de Javé - em que farei brotar para David um rebento justo. Ele reinará como verdadeiro rei e será sábio, pondo em prática o direito e a justiça no país."
,"6":"Nos seus dias, Judá estará a salvo e Israel viverá em paz. É este o nome com que será chamado: «Javé, Nossa Justiça»."
,"7":"Vão chegar dias - oráculo de Javé - em que já se não dirá: «Viva Javé, que tirou os israelitas do Egipto»."
,"8":"Em lugar disso, dirão: «Viva Javé, que tirou a descendência de Israel do país do Norte e de todos os países para onde os havia expulsado, reconduzindo-os de novo para a sua terra»."
,"9":"Sobre os profetas. O meu coração está despeda-çado dentro do peito, todos os meus ossos tremem. Pareço um bêbedo dominado pelo vinho; mas é por causa de Javé e das suas santas palavras."
,"10":"O país está cheio de adúlteros. Por causa da maldição, todo o país está de luto e os pastos dos campos ficaram secos. O seu caminho é a maldade, e a sua força é a injustiça."
,"11":"Até o profeta, até o sacerdote são ímpios, até na minha casa encontrei a sua maldade - oráculo de Javé."
,"12":"Por isso, o seu caminho tornar-se-á escorregadio, serão empurrados para as trevas e nelas cairão. Pois mandarei sobre eles a desgraça, no ano do seu castigo - oráculo de Javé."
,"13":"Entre os profetas da Samaria vi coisas absurdas: profetizam por Baal e extraviam o meu povo Israel."
,"14":"Entre os profetas de Jerusalém, o que Eu vi era horrível: cometem adultério e praticam a mentira, dão a mão aos malfeitores, para que ninguém se converta da sua maldade. Para Mim, todos eles são como Sodoma, e os habitantes de Jerusalém são como Gomorra."
,"15":"Por isso, assim diz Javé dos exércitos contra os profetas: Far-vos-ei comer absinto e beber água envenenada, porque dos profetas de Jerusalém se espalhou a impiedade para todo o país."
,"16":"Assim diz Javé dos exércitos: Não presteis atenção às palavras dos profetas que para vós profetizam. Eles enganam-vos, a visão que anunciam é fruto da imaginação, e nunca saiu da boca de Javé."
,"17":"Eles dizem aos que desprezam a Palavra de Javé: «Tereis paz». E aos que seguem o seu próprio coração obstinado, dizem: «O mal nunca vos atingirá»."
,"18":"Quem assistiu às deliberações de Javé? Quem viu e ouviu a sua Palavra? Quem ouviu a sua Palavra e obedeceu?"
,"19":"Eis a tempestade de Javé, o seu furor desencadeia-se, um furacão cairá sobre a cabeça dos ímpios."
,"20":"A ira de Javé não recuará, enquanto não realizar, enquanto não executar os projectos do seu coração. Nos últimos dias, compreendereis tudo."
,"21":"Eu não enviei nenhum desses profetas, mas eles vieram a correr; Eu não lhes falei, e no entanto eles profetizam."
,"22":"Se eles tivessem assistido às minhas deliberações e tivessem levado ao meu povo a minha mensagem, o povo teria desistido do seu mau caminho, teria deixado o mal que praticava."
,"23":"Será que Eu sou Deus só de perto? - oráculo de Javé. De longe não sou Deus?"
,"24":"Pode alguém esconder-se em algum lugar onde Eu não possa vê-lo? - oráculo de Javé. Porventura não encho o Céu e a Terra? - oráculo de Javé."
,"25":"Eu ouvi o que dizem os profetas que em meu Nome profetizam mentiras, dizendo: «Eu tive um sonho! Eu tive um sonho!»"
,"26":"Até quando os profetas continuarão a profetizar mentiras e fantasias da sua imaginação?"
,"27":"Eles pretendem fazer que o meu povo esqueça o meu Nome, usando os sonhos que contam uns aos outros, da mesma forma como os seus antepassados Me esqueceram por causa de Baal."
,"28":"O profeta que teve um sonho, que conte o seu sonho; aquele que recebeu uma palavra minha, que transmita essa palavra fielmente. O que é que a palha tem a ver com o grão? - orá-culo de Javé."
,"29":"A minha palavra não é como o fogo? - oráculo de Javé - ou como um martelo que tritura a pedra?"
,"30":"Por isso, estou contra os profetas - oráculo de Javé - que roubam as minhas palavras uns aos outros."
,"31":"Estou contra os profetas - oráculo de Javé - que abrem a boca para soltar oráculos."
,"32":"Estou contra os profetas - oráculo de Javé - que sonham mentiras, depois as contam aos outros, e com as suas mentiras e os seus enganos desorientam o meu povo. Eu não enviei nenhum deles, nem lhes dei ordem nenhuma, e eles não têm nenhuma utilidade para este povo - oráculo de Javé."
,"33":"Se alguém deste povo, seja um profeta ou um sacerdote, te perguntar: «Qual é o peso de Javé?», responder-lhe-ás: «Vós é que sois o peso de Javé, e Eu vos rejei-tarei» - oráculo de Javé."
,"34":"E o profeta, sacerdote ou gente do povo que disser mais uma vez: «Peso de Javé», Eu acertarei contas com essa pessoa e a sua família."
,"35":"Assim é que devereis dizer uns aos outros, irmão a irmão: «O que é que Javé respondeu? O que é que Javé disse?»"
,"36":"Nunca mais useis esta expressão: «Peso de Javé». Essa palavra será um peso para cada um, pois mudastes o sentido da Palavra do Deus vivo, de Javé dos exércitos, o nosso Deus."
,"37":"Tu perguntarás ao profeta: «O que é que Javé respondeu? O que é que Javé disse?»"
,"38":"Se disserdes: «Peso de Javé», então eis o que Javé diz: Visto que repetis «Peso de Javé», quando vos havia ordenado que nunca mais dissésseis «Peso de Javé»,"
,"39":"exactamente por isso Eu tornar-vos-ei como um peso e vos lançarei para longe da minha face, a vós e à cidade que dei a vós e aos vossos antepassados."
,"40":"Cobrir-vos-ei de vergonha eterna e confusão permanente, que nunca serão esquecidas."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Javé mostrou-me dois cestos de figos, colocados na frente do Templo. Isso aconteceu depois de Nabucodonosor, rei da Babilónia, ter deportado Jeconias, filho de Joaquim, rei de Judá, com os seus chefes, ferreiros e serralheiros, e os ter levado para a Babilónia."
,"2":"Um dos dois cestos tinha figos muito bons, como são os do princípio da colheita; o outro continha figos ruins, tão ruins que não se podiam comer."
,"3":"Javé disse-me: «O que vês, Jeremias?» Eu respondi: «Figos. Os figos bons são muito bons, os figos maus são muito maus, tão maus que não servem para comer»."
,"4":"Então foi-me dirigida esta palavra de Javé:"
,"5":"Assim diz Javé, o Deus de Israel: Eu considero bons, semelhantes a estes figos bons, os exilados de Judá, que expulsei deste lugar para o país dos caldeus."
,"6":"Lançarei o meu olhar sobre eles, para o bem deles; vou fazê-los regressar a este país, vou restabelecê-los para nunca mais os destruir, vou plantá-los para nunca mais os arrancar."
,"7":"Dar-lhes-ei um coração capaz de Me conhecer, pois Eu sou Javé. Eles serão o meu povo e Eu serei o seu Deus, se de todo o coração se converterem a Mim."
,"8":"À semelhança do que se faz aos figos estragados que não servem para comer - assim diz Javé - assim farei a Sedecias, rei de Judá, aos seus chefes, ao resto de Jerusalém, aos que ficaram no país e aos que foram morar no Egipto."
,"9":"Eu os tornarei motivo de espanto para todos os reinos do mundo, motivo de vergonha, de provérbio, de escárnio e de maldição em todos os lugares para onde os expulsar."
,"10":"Enviarei contra eles a espada, a fome e a peste, até desaparecerem da face da Terra que Eu lhes tinha dado, a eles e aos seus antepassados."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Palavra dirigida a Jeremias acerca de todo o povo de Judá, no quarto ano de Joaquim, filho de Josias, rei de Judá. Foi no primeiro ano do domínio de Nabucodonosor, rei da Babilónia."
,"2":"Palavra que o profeta Jeremias anunciou a todo o povo de Judá e aos habitantes de Jerusalém, dizendo:"
,"3":"Desde o décimo terceiro ano de Josias, filho de Amon, rei de Judá, até hoje, há vinte e três anos, foi-me dirigida a Palavra de Javé; eu tenho-vo-la transmitido constantemente, mas vós não escutastes."
,"4":"Javé enviou-vos muitas vezes os seus servos, os profetas, mas vós não quisestes escutar, nem prestar ouvidos para ouvir."
,"5":"Que cada um se converta dos seus maus caminhos e das maldades que costuma praticar, e continuareis a morar na terra que Javé vos deu a vós e aos vossos antepassados, desde os tempos antigos e para sempre."
,"6":"Não sigais os deuses estrangeiros, para os servir e adorar, não Me provoqueis com as obras das vossas mãos, e não vos farei mal."
,"7":"Mas vós não Me obedecestes - oráculo de Javé - e provocastes-Me com as obras das vossas mãos para vossa própria desgraça."
,"8":"Por isso, assim diz Javé dos exércitos: Já que não ouvistes as minhas palavras,"
,"9":"mandarei convocar todas as tribos do Norte - oráculo de Javé - e também o meu servo Nabucodonosor, rei da Babilónia, para virem contra este país, contra os seus habitantes e contra todas as nações vizinhas. Vou condená-los todos ao extermínio, e fazer deles um objecto de horror, de ludíbrio e de vergonha permanente."
,"10":"Eliminarei do meio deles o som da música, os gritos de alegria, a voz do noivo e da noiva, o barulho do moinho e a luz da lâmpada."
,"11":"O país inteiro será entregue à destruição e desolação, e o povo ficará escravo do rei da Babilónia durante setenta anos."
,"12":"Depois de completados os setenta anos, castigarei o rei da Babilónia e o seu povo - oráculo de Javé - isto é, o país dos caldeus, por causa dos seus crimes. Vou transformá-lo em desolação permanente."
,"13":"Farei executar sobre este país todas as ameaças que Eu proferi contra ele, tudo o que está escrito neste livro, e que Jeremias tinha predito contra todas as nações."
,"14":"Estas nações, por sua vez, servirão a muitas nações e a reis poderosos; Eu retribuir-lhes-ei segundo as suas acções e as obras das suas mãos."
,"15":"Assim me disse Javé, o Deus de Israel: «Toma da minha mão esta taça de vinho da minha ira e dá a beber dela a todas as nações às quais te envio."
,"16":"Elas beberão, ficarão embriagadas e perderão o juízo diante da espada que Eu mandarei para o meio delas.»"
,"17":"Eu tomei a taça da mão de Javé e fiz que bebessem dela todas as nações às quais Javé me enviou:"
,"18":"Jerusalém e as cidades de Judá com os seus reis e chefes, para os entregar à destruição, desolação, vergonha e maldição, como acontece ainda hoje;"
,"19":"o Faraó, rei do Egipto, com os seus ministros, os seus nobres e todo o seu povo;"
,"20":"gente de todas as raças e todos os reis da terra de Hus; todos os reis da região dos filisteus: Ascalon, Gaza, Acaron e os sobreviventes de Azoto;"
,"21":"Edom, Moab e o povo de Amon;"
,"22":"os reis de Tiro, de Sidónia e da ilha que está no além-mar;"
,"23":"Dadã, Tema e Buz, todos os de cabeça rapada,"
,"24":"os reis árabes que moram no deserto;"
,"25":"todos os reis de Zambri; os reis de Elam e os reis da Média;"
,"26":"por fim, todos os reis do Norte, tanto os mais próximos como os mais distantes. Um após outro, fiz com que todos os reinos que existem sobre a face da Terra bebessem. E o rei da Babilónia beberá depois deles."
,"27":"Dir-lhes-ás: «Assim diz Javé dos exércitos, o Deus de Israel: Bebei até ficardes tontos, até vomitardes e cairdes sem nunca mais vos poderdes levantar, diante da espada que envio para o meio de vós»."
,"28":"Se recusarem tomar a taça da tua mão para beber, dir-lhes-ás: «Assim diz Javé dos exércitos: É claro que bebereis!"
,"29":"Pois se começo a castigar precisamente a cidade sobre a qual é invocado o meu Nome, pretendeis vós ficar impunes? Não, vós não ficareis impunes, pois Eu convocarei a espada contra todos os habitantes da Terra - oráculo de Javé dos exércitos»."
,"30":"Tu, porém, anunciarás todas estas coisas e dir-lhes-ás: Javé ruge lá do alto, da sua santa morada Ele faz ouvir a sua voz; ruge contra a sua pastagem; como aquele que pisa a uva, Ele solta gritos de alegria contra todos os habitantes da Terra."
,"31":"O barulho chega até aos confins do mundo, porque Javé entra em processo contra as nações, Ele julga toda a criatura e abandona os ímpios à espada - oráculo de Javé."
,"32":"Assim diz Javé dos exércitos: A desgraça passa de nação para nação. Um grande furacão levanta-se das extremidades da Terra."
,"33":"Nesse dia, as vítimas de Javé cobrirão a Terra de ponta a ponta; ninguém as recolherá, nem as enterrará, nem fará luto por elas: ficarão como esterco sobre a terra."
,"34":"Gemei, pastores, gritai! Revolvei-vos no pó, chefes do rebanho! Pois chegou para vós o dia da matança, o dia de serdes expulsos um para cada lado; caireis como carneiros escolhidos."
,"35":"Não há escapatória para os pastores, nem saída para os chefes do rebanho."
,"36":"Ouvi os gritos dos pastores, o urro dos chefes do rebanho! Porque Javé destruiu-lhes as pastagens;"
,"37":"os prados tranquilos foram devastados, por causa da ardente ira de Javé."
,"38":"O leão abandona a toca, pois a sua terra transformou-se num deserto, por causa da espada devastadora, por causa da ardente ira de Javé."
}`)
	CurrentBook.AddChapter(26, `{
"1":"No começo do reinado de Joaquim, filho de Josias, rei de Judá, Javé dirigiu esta palavra a Jeremias:"
,"2":"Assim diz Javé: Vai para o átrio do Templo de Javé e diz a todos os cidadãos de Judá, que entram no Templo para adorar Javé, tudo o que te mando anunciar, sem omitir nada."
,"3":"Talvez se convertam da sua má conduta, e Eu Me arrependa do castigo que preparo contra eles por causa das suas más acções."
,"4":"Dirás o seguinte: Assim diz Javé: Se não Me obedecerdes, seguindo a Lei que vos dei,"
,"5":"e se não obedecerdes às palavras dos meus servos, os profetas, que sem cessar vos envio, se não os escutardes,"
,"6":"então, vou fazer deste Templo o que fiz ao santuário de Silo, e desta cidade farei um objecto de maldição para todos os povos da Terra."
,"7":"Os sacerdotes, os profetas e todo o povo ouviram Jeremias dizer isto no Templo de Javé."
,"8":"Depois de Jeremias ter acabado de dizer tudo o que Javé lhe ordenara dizer ao povo, os sacerdotes e os profetas prenderam-no, dizendo: «Tu deves morrer."
,"9":"Porque é que profetizaste em nome de Javé, dizendo que vai acontecer a este Templo o que aconteceu ao santuário de Silo, e que esta cidade será destruída e ficará sem moradores?» E todo o povo se aglomerou no Templo de Javé contra Jeremias."
,"10":"Ao ouvirem falar disto, os chefes de Judá foram do palácio do rei para o Templo de Javé, e sentaram-se no tribunal da Porta Nova do Templo de Javé."
,"11":"Então os sacerdotes e os profetas disseram aos chefes e a todo o povo: «Este homem deve ser condenado à morte, pois profetizou contra esta cidade, conforme vós mesmos ouvistes»."
,"12":"Jeremias respondeu aos chefes e a todo o povo: «Foi Javé quem me mandou profetizar, contra este Templo e contra esta cidade, tudo o que ouvistes."
,"13":"Agora, emendai a vossa conduta e acções; obedecei a Javé, vosso Deus, e Javé desistirá das ameaças que proferiu contra vós."
,"14":"Quanto a mim, estou nas vossas mãos. Fazei de mim o que achardes melhor."
,"15":"Mas ficai sabendo que, se me matardes, lançareis a culpa da morte de um inocente sobre vós mesmos, sobre esta cidade e seus habitantes, pois foi de facto Javé quem me enviou para vos transmitir estas palavras»."
,"16":"Os chefes e todo o povo disseram aos sacerdotes e profetas: «Este homem não deve ser condenado à morte, pois foi em nome de Javé, o nosso Deus, que ele nos falou»."
,"17":"Alguns anciãos do país tomaram então a palavra e, dirigindo-se a todo o povo reunido, disseram:"
,"18":"«Miqueias de Morasti foi um profeta no tempo de Ezequias, rei de Judá. Ele disse a todo o povo de Judá: 'Assim diz Javé dos exércitos: Sião será arada como um campo, Jerusalém tornar-se-á um montão de ruínas, e o monte do Templo será um bosque!'."
,"19":"Porventura, Ezequias, rei de Judá, ou o próprio povo de Judá mataram Miqueias? Não temeram a Javé e O acalmaram? E Javé não desistiu da ameaça que havia lançado contra eles? Nós, porém, estamos para cometer um grande crime contra nós mesmos»."
,"20":"Houve também outro profeta que profetizou em nome de Javé: Urias, filho de Semeías, natural de Cariat-Iarim. Ele profetizou contra a cidade e o país, da mesma forma que Jeremias."
,"21":"O rei Joaquim, os seus guardas e chefes ouviram-no e o rei procurou matá-lo. Mas, ao ouvir isto, Urias ficou com medo e fugiu para o Egipto."
,"22":"O rei Joaquim enviou ao Egipto Elnatã, filho de Acobor, com alguns homens."
,"23":"Eles trouxeram Urias do Egipto e levaram-no ao rei Joaquim. O rei mandou matá-lo a fio de espada e lançar o seu corpo na vala comum."
,"24":"Jeremias, porém, foi protegido por Aicam, filho de Safã, de modo que não foi entregue nas mãos do povo para ser morto."
}`)
	CurrentBook.AddChapter(27, `{
"1":"No começo do reinado de Sedecias, filho de Josias, rei de Judá, Javé dirigiu esta palavra a Jeremias:"
,"2":"Assim me disse Javé: Faz para ti cordas e um jugo e põe-nos ao pescoço."
,"3":"Depois, através dos emissários que vieram a Jerusalém para falarem com Sedecias, rei de Judá, manda uma mensagem aos reis de Edom, Moab, Amon, Tiro e Sidónia."
,"4":"Diz-lhes que informem os seus senhores: Assim diz Javé dos exércitos, o Deus de Israel: Dizei aos vossos senhores:"
,"5":"Eu criei a Terra, os homens e todos os animais sobre a face da terra, com a minha grande força e braço estendido, e dou-os a quem quero."
,"6":"Pois bem! Entrego todos estes territórios nas mãos do meu servo Nabucodonosor, rei da Babilónia. Eu colocarei até as feras ao seu serviço."
,"7":"Todas as nações ficarão submetidas a ele, a seu filho e a seu neto, até que chegue a vez de o seu país se tornar escravo de numerosas nações e reis poderosos."
,"8":"Se uma nação e o seu rei não se submeterem a Nabucodonosor, rei da Babilónia, e não colocarem o pescoço sob o jugo do rei da Babilónia, Eu castigarei essa nação com espada, fome e peste, até a entregar nas suas mãos - oráculo de Javé."
,"9":"Quanto a vós, não deis ouvidos aos vossos profetas e adivinhos, intérpretes de sonhos, feiticeiros e magos, que vos dizem: «Não ficareis submetidos ao rei da Babilónia»."
,"10":"Porque eles profetizam mentiras, para vos tirar da vossa Terra e para que Eu vos espalhe e destrua."
,"11":"A nação, porém, que dobrar o pescoço e se submeter ao rei da Babilónia, deixá-la-ei tranquila na sua terra, para que a cultive e habite nela - oráculo de Javé."
,"12":"Eu também disse palavras iguais a estas a Sedecias, rei de Judá: Colocai o pescoço sob o jugo do rei da Babilónia, submetei-vos a ele e ao seu povo, e vivereis."
,"13":"Por que motivo tu e o teu povo haveríeis de morrer pela espada, pela fome e pela peste, como Javé anunciou à nação que não se submeter ao rei da Babilónia?"
,"14":"Não escuteis os profetas que vos dizem: «Vós não ficareis submetidos ao rei da Babilónia», pois é mentira o que eles profetizam."
,"15":"Não fui Eu quem os enviou - oráculo de Javé. Eles profetizam mentiras em meu nome, para que Eu seja obrigado a expulsar-vos e a destruir-vos, a vós e aos profetas que vos profetizam."
,"16":"Aos sacerdotes e a todo o povo eu disse: Assim diz Javé: Não escuteis os profetas que vos profetizam, dizendo: «Eis que os objectos do Templo de Javé em breve voltarão da Babilónia». É mentira o que eles profetizam."
,"17":"Não os escuteis. Aceitai ser escravos do rei da Babilónia, e vivereis. Por que motivo esta cidade se transformará em ruínas?"
,"18":"Se eles são profetas e se a Palavra de Javé está com eles, então rezai a Javé dos exércitos para que o resto dos objectos que existem no Templo de Javé, no palácio do rei de Judá e em Jerusalém não sejam levados também para a Babilónia."
,"19":"Pois assim diz Javé dos exércitos a respeito das colunas, do mar de bronze e dos pedestais, de todos os outros objectos do Templo que ficaram nesta cidade,"
,"20":"que não foram levados por Nabucodonosor, rei da Babilónia, quando levou para o exílio Jeconias, filho de Joaquim, rei de Judá, transferindo-o de Jerusalém para a Babilónia, com toda a classe dirigente de Judá e de Jerusalém."
,"21":"Assim diz Javé dos exércitos, o Deus de Israel, a respeito dos objectos que ficaram no Templo de Javé, no palácio do rei de Judá e em Jerusalém:"
,"22":"Serão levados para a Babilónia e ali ficarão até ao dia em que Eu os for buscar de novo - oráculo de Javé. Então, Eu os trarei e os colocarei de novo neste lugar."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Naquele mesmo ano, ao começar o reinado de Sedecias em Judá, no quarto ano, no quinto mês, Hananias, filho de Azur, que era profeta em Gabaon, falou comigo no Templo de Javé, diante dos sacerdotes e de todo o povo, dizendo:"
,"2":"«Assim diz Javé dos exércitos, o Deus de Israel: Vou quebrar o jugo do rei da Babilónia."
,"3":"Dentro de dois anos farei voltar para este lugar todos os objectos do Templo de Javé que Nabucodonosor, rei da Babilónia, levou para a Babilónia."
,"4":"Também vou fazer voltar Jeconias, filho de Joaquim, rei de Judá, e todos os exilados de Judá levados para a Babilónia - oráculo de Javé - porque vou quebrar o jugo do rei da Babilónia»."
,"5":"Na presença dos sacerdotes e de todo o povo que estava no Templo de Javé, o profeta Jeremias respondeu ao profeta Hananias,"
,"6":"dizendo: «Assim seja! Que assim faça Javé. Que Javé confirme o que profetizaste, trazendo da Babilónia para cá os objectos do Templo de Javé e todos os exilados."
,"7":"Entretanto, escuta o que te vou dizer a ti e a todo o povo:"
,"8":"Os profetas que existiram antes de mim e antes de ti, desde os tempos antigos, profetizaram guerra, calamidade e peste para muitos países e reinos poderosos."
,"9":"E quanto ao profeta que prometia paz, só quando a sua profecia se realizar é que ele será reconhecido como profeta realmente enviado por Javé»."
,"10":"Então Hananias tomou o jugo que estava ao pescoço de Jeremias e quebrou-o."
,"11":"Em seguida, disse diante de todo o povo: «Assim diz Javé: Desta mesma forma, dentro de dois anos, eu quebrarei o jugo de Nabucodonosor, rei da Babilónia, que está no pescoço de todas as nações». E o profeta Jeremias retirou-se."
,"12":"Depois de Hananias ter quebrado o jugo que estava no pescoço de Jeremias, este recebeu uma palavra de Javé:"
,"13":"«Vai dizer a Hananias o seguinte: Assim diz Javé: Tu quebraste um jugo de madeira, e Eu vou substituí-lo por um jugo de ferro."
,"14":"Porque assim diz Javé dos exércitos, o Deus de Israel: É um jugo de ferro que Eu vou colocar no pescoço de todas as nações, para que estejam subjugadas a Nabucodonosor, rei da Babilónia»."
,"15":"Em seguida, o profeta Jeremias disse ao profeta Hananias: «Escuta-me, Hananias: não foi Javé que te mandou, e levaste este povo a acreditar numa mentira."
,"16":"Por isso, assim diz Javé: Vou retirar-te da face da terra; ainda este ano morrerás, porque pregaste a revolta contra Javé»."
,"17":"E Hananias morreu nesse mesmo ano, no sétimo mês."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Texto da carta que o profeta Jeremias enviou de Jerusalém aos exilados na Babilónia. Escreveu-a aos anciãos, sacerdotes, profetas e ao povo, levados por Nabucodonosor para o exílio."
,"2":"Ele enviou a carta depois de terem saído de Jerusalém o rei Jeconias com a rainha-mãe, a gente do palácio, os chefes de Judá e de Jerusalém, os ferreiros e os serralheiros."
,"3":"Enviou a carta por intermédio de Elasa, filho de Safã, e por intermédio de Gamarias, filho de Helcias, que Sedecias, rei de Judá, tinha enviado à Babilónia ao rei Nabucodonosor. A carta dizia o seguinte: "
,"4":"Assim diz Javé dos exércitos, o Deus de Israel, a todo o povo que levei de Jerusalém para o exílio na Babilónia:"
,"5":"Construí casas para morardes, plantai pomares e comei os seus frutos,"
,"6":"casai-vos, gerai filhos e filhas, arranjai esposas para os vossos filhos e maridos para as vossas filhas, e que eles também gerem filhos e filhas. Multiplicai-vos em vez de diminuir."
,"7":"Lutai pelo progresso da cidade para onde vos exilei e rezai a Deus por ela, pois o progresso desse lugar será também o vosso progresso."
,"8":"Assim diz Javé dos exércitos, o Deus de Israel: Não vos deixeis enganar pelos profetas que há no meio de vós, não escuteis os adivinhos nem os seus sonhos,"
,"9":"porque eles profetizam mentiras em meu Nome. Eu não enviei nenhum deles - oráculo de Javé."
,"10":"Assim diz Javé: Quando se completarem setenta anos na Babilónia, olharei para vós e cumprirei as minhas promessas, fazendo-vos voltar para este lugar."
,"11":"Conheço os meus projectos sobre vós - oráculo de Javé: são projectos de felicidade e não de sofrimento, para vos dar um futuro cheio de esperança."
,"12":"Invocar-Me-eis, vireis suplicar-me e Eu vos ouvirei."
,"13":"Procurar-Me-eis, e encontrar-Me-eis se Me buscardes de todo o coração;"
,"14":"Eu deixar-Me-ei encontrar e mudarei a vossa sorte - oráculo de Javé. Vou reunir-vos de todas as nações e lugares por onde vos espalhei, - oráculo de Javé - e far-vos-ei voltar ao lugar de onde vos exilei."
,"15":"Vós dizeis: «Javé suscitou-nos profetas na Babilónia»."
,"16":"Pois bem! Assim diz Javé a respeito dos vossos irmãos que não foram levados convosco para o exílio, isto é, o rei que está no trono de David e o povo todo que ainda mora nesta cidade:"
,"17":"Assim diz Javé dos exércitos: Vou enviar contra eles a espada, a fome e a peste, e fazer deles o que se faz aos figos estragados, tão maus que não servem para comer."
,"18":"Perseguirei esta gente com a espada, a fome e a peste; farei deles uma coisa horripilante para todos os reinos da terra, maldição e espanto, objecto de escárnio e de vergonha entre todos os povos para onde os expulsei;"
,"19":"isso porque não Me obedeceram - oráculo de Javé. Porque lhes enviei constantemente os meus servos, os profetas, mas não os ouviram - oráculo de Javé."
,"20":"Quanto a vós, que fostes exilados de Jerusalém para a Babilónia, ouvi a Palavra de Javé."
,"21":"Assim diz Javé dos exércitos, o Deus de Israel, contra Acab, filho de Colias, e contra Sedecias, filho de Maasias, que profetizam mentiras em meu nome: Vou entregá-los nas mãos de Nabucodonosor da Babilónia. Ele vai mandá-los matar na vossa presença."
,"22":"Depois surgirá uma nova espécie de maldição entre os exilados de Judá na Babilónia. Aí se dirá: «Que Javé te faça o que fez a Acab e a Sedecias, que o rei da Babilónia mandou assar no fogo!»"
,"23":"Pois eles fizeram coisas horríveis em Israel: praticaram adultério com as mulheres dos amigos e proferiram mentiras usando o meu Nome, sem que Eu lho tivesse ordenado. Eu sei e sou testemunha disso - oráculo de Javé."
,"24":"Mensagem que irás pronunciar contra Semeías de Naalam:"
,"25":"Assim diz Javé dos exércitos, o Deus de Israel: Mandaste cartas por tua conta, especialmente ao sacerdote Sofonias, filho de Maasias, e a todos os sacerdotes, dizendo:"
,"26":"«Javé colocou-te como sacerdote no lugar de Joiada, para te responsabilizares pelo Templo de Javé e para mandares prender no cepo ou no cárcere todo o indivíduo fanático que queira passar por profeta."
,"27":"Então porque não repreendeste Jeremias de Anatot, que se pôs a profetizar entre vós?"
,"28":"Ele mandou-nos uma carta para a Babilónia, dizendo: 'Vai demorar. Construí casas para morar e plantai pomares para comerdes frutas'»."
,"29":"O sacerdote Sofonias leu essa carta na presença de Jeremias."
,"30":"Então a Palavra de Javé foi dirigida a Jeremias:"
,"31":"Manda a todos os exilados a seguinte mensagem: Assim diz Javé a respeito de Semeías de Naalam: Já que Semeías vos profetizou - sem Eu o ter enviado - e vos levou a acreditar em mentiras,"
,"32":"então assim diz Javé: Castigarei Semeías e os seus filhos. Nenhum deles ficará a morar no meio deste povo, nem verá a felicidade que darei ao meu povo - oráculo de Javé - porque ele pregou a revolta contra Javé."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Palavra que Javé dirigiu a Jeremias:"
,"2":"Assim diz Javé, o Deus de Israel: Escreve num livro tudo o que te vou dizer,"
,"3":"pois virão dias - oráculo de Javé - em que mudarei a sorte do meu povo, Israel e Judá, diz Javé. Farei com que voltem ao país que dei aos seus antepassados e que tomem posse dele."
,"4":"São estas as palavras que Javé pronunciou para Israel e Judá:"
,"5":"Ouvimos um grito de pavor, de terror, sem paz."
,"6":"Informai-vos e observai se é possível um homem dar à luz! Como é, então, que vejo todos os homens de mãos nos quadris, como se fossem mulheres em trabalho de parto? Porque é que ficaram todos com o rosto tão pálido?"
,"7":"Ah! Esse dia é muito importante, e outro igual não existe. É uma hora de aflição para Jacob, mas ele salvar-se-á."
,"8":"Nesse dia - oráculo de Javé dos exércitos - quebrarei o jugo que está ao vosso pescoço e rebentarei as correntes que vos prendem, e já não sereis escravos de estrangeiros."
,"9":"Servireis a Javé, vosso Deus, e também a David, o rei que para vós suscitarei."
,"10":"Não tenhas medo, meu servo Jacob - oráculo de Javé - não te apavores, Israel, pois aqui estou Eu, para te tirar do país distante, libertando a tua descendência do país do exílio. Jacob voltará e viverá tranquilo e em paz, sem que o perturbem."
,"11":"Porque Eu estou contigo para te salvar - oráculo de Javé. Eu destruirei todas as nações por onde te havia espalhado, mas não te destruirei: Eu corrigir-te-ei com justiça, mas não te deixarei sem castigo."
,"12":"Assim diz Javé: A tua ferida é incurável, a tua chaga é muito grave."
,"13":"Não há remédio para a tua chaga, nem emplastro para fechar a tua ferida."
,"14":"Todos os teus amantes se esqueceram de ti e nunca mais te procuram. Pois Eu feri-te como se fosse teu inimigo, e dei-te um castigo terrível, porque eram muitos os teus erros e os teus pecados pesavam muito."
,"15":"Porque gritas por causa da tua ferida? A tua chaga é incurável. Foi porque os teus erros eram muitos e os teus pecados tão pesados que Eu te tratei assim."
,"16":"Mas todos os que te devoram serão devorados; todos os teus inimigos serão levados para o exílio; os que te saqueiam serão saqueados; os que te despojam serão despojados."
,"17":"Eu cicatrizarei a tua ferida e curarei as tuas chagas - oráculo de Javé. Porque te chamam «Rejeitada», «Sião, aquela por quem ninguém pergunta»."
,"18":"Mas assim diz Javé: Agora vou mudar a sorte das tendas de Jacob, terei compaixão das suas moradas. A cidade será reconstruída sobre as suas ruínas, e o palácio erguer-se-á de novo no seu lugar."
,"19":"Dali sairão acção de graças e gritos de alegria. Eu vou multiplicá-los, e eles nunca mais diminuirão; vou devolver-lhes a honra, e nunca mais serão humilhados."
,"20":"Os seus filhos serão como antigamente e a sua assembleia continuará firme diante dos meus olhos; mas castigarei todos os seus opressores."
,"21":"Dela surgirá o seu chefe, e do seu meio sairá o seu governante. Eu farei que ele se aproxime e chegue junto de Mim. Pois quem iria arriscar a vida, aproximando-se de Mim? - oráculo de Javé."
,"22":"Vós sereis o meu povo e eu serei o vosso Deus."
,"23":"Eis a tempestade de Javé, o seu furor desencadeia-se, um furacão gira sobre a cabeça dos ímpios."
,"24":"A ira ardente de Javé não recuará enquanto não realizar, enquanto não executar os projectos do seu coração. Nos últimos dias, compreendereis tudo."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Naquele tempo - oráculo de Javé - Eu serei o Deus de todas as tribos de Israel, e elas serão o meu povo."
,"2":"Assim diz Javé: O povo que escapa da espada encontra graça no deserto! Israel caminha para o seu repouso."
,"3":"Javé apareceu-lhe de longe: Eu amei-te com amor eterno; por isso, conservei o meu amor por ti."
,"4":"Eu vou reconstruir-te e ficarás construída, ó capital de Israel. Sairás novamente enfeitada e com pandeiros entre os grupos que dançam."
,"5":"De novo plantarás vinhedos sobre as colinas da Samaria: e os que plantarem, eles mesmos colherão."
,"6":"Chegará o dia em que os guardas gritarão na montanha de Efraim: «De pé! Vamos a Sião visitar Javé, o nosso Deus»."
,"7":"Porque assim diz Javé: Dai vivas por Jacob, aclamai a primeira das nações! Gritai, louvai e dizei: «Javé salvou o seu povo, o resto de Israel!»"
,"8":"Eu vou trazê-los do país do Norte, vou juntá-los das extremidades da Terra. No meio deles estarão o cego e o aleijado, a mulher grávida e a que deu à luz, todos juntos: será imensa a multidão que há-de voltar!"
,"9":"Eles partiram a chorar, e Eu fá-los-ei voltar em grande consolação. Conduzi-los-ei para as torrentes de água, por um caminho plano, onde não tropeçarão. Serei um pai para Israel, e Efraim será o meu primogénito."
,"10":"Nações, escutai a palavra de Javé. Anunciai-a às ilhas distantes: «Aquele que espalhou Israel, vai juntá-lo de novo e vai guardá-lo como um pastor guarda o seu rebanho»."
,"11":"Porque Javé resgatou Jacob, e libertou-o das mãos de um outro mais forte."
,"12":"Eles virão festejar na altura de Sião, afluirão aos bens de Javé: ao trigo, ao vinho, ao azeite e às crias das ovelhas e do gado. Serão uma horta bem irrigada: não tornarão a desfalecer."
,"13":"Então a jovem dançará com alegria, os velhos e os jovens alegrar-se-ão. Mudarei o seu luto em alegria, vou consolá-los e torná-los felizes, sem aflições."
,"14":"Vou alimentar os seus sacerdotes com gordura, e o meu povo fartar-se-á com os meus bens - oráculo de Javé."
,"15":"Assim diz Javé: Escutai! Ouvem-se gemidos e pranto amargo em Ramá: é Raquel que chora inconsolável os seus filhos que já não existem."
,"16":"Pois assim diz Javé: Cessa os soluços e enxuga as lágrimas, porque há uma recompensa para a tua dor - oráculo de Javé: eles voltarão do país inimigo;"
,"17":"existe esperança de um futuro - oráculo de Javé: os teus filhos voltarão para a pátria."
,"18":"Eu oiço Efraim que se lamenta: «Tu corrigiste-me e eu fui corrigido, como um novilho não amansado. Faz-me voltar, eu quero voltar, porque tu és Javé, meu Deus."
,"19":"Afastei-me, mas depois arrependi-me; e, ao entender, castiguei o meu corpo. Fracassei, fiquei confuso, pois carrego a vergonha da minha juventude»."
,"20":"Porventura Efraim não é o meu filho predilecto? Acaso não é um filho querido? Quanto mais o repreendo, mais Me lembro dele. Por isso, as minhas entranhas comovem-se, e Eu terei compaixão dele - oráculo de Javé."
,"21":"Coloca marcos na estrada, espeta estacas para tua orientação, presta atenção à estrada, ao caminho por onde passaste. Volta, ó virgem de Israel, volta para as tuas cidades."
,"22":"Até quando vagabundearás, filha rebelde? Porque Javé criou uma coisa nova no país: a mulher seduzirá o homem!"
,"23":"Assim diz Javé dos exércitos, o Deus de Israel: No país de Judá e nas suas cidades, quando Eu trouxer de volta os exilados, todos voltarão a dizer: «Javé te abençoe, morada da justiça, monte santo!»"
,"24":"Em Judá e nas suas cidades habitarão juntos os lavradores e os pastores,"
,"25":"pois saciarei as gargantas sedentas e satisfarei os famintos."
,"26":"Então acordei, e vi que o meu sonho era agradável."
,"27":"Eis que virão dias - oráculo de Javé - em que semearei em Israel e Judá semente de homens e semente de animais."
,"28":"Assim como os vigiei para arrancar e arrasar, para demolir, desfazer e maltratar, agora vou vigiar para construir e plantar - oráculo de Javé."
,"29":"Nesses dias, ninguém mais dirá: «Os pais comeram uvas verdes e os dentes dos filhos é que sofreram»."
,"30":"Mas cada um morrerá por causa do seu próprio pecado; quem comeu uvas verdes é que sofrerá a dor de dentes."
,"31":"Eis que chegarão dias - oráculo de Javé - em que Eu farei uma aliança nova com Israel e Judá:"
,"32":"Não será como a aliança que fiz com os seus antepassados, quando os tomei pela mão para os tirar da terra do Egipto; aliança que eles quebraram, embora Eu fosse o seu Deus - oráculo de Javé."
,"33":"A aliança que farei com Israel depois desses dias é a seguinte - oráculo de Javé: Colocarei a minha lei no seu peito e escrevê-la-ei no seu coração; serei o seu Deus, e eles serão o meu povo."
,"34":"Ninguém mais precisará de ensinar o seu próximo ou o seu irmão, dizendo: «Procura conhecer Javé». Porque todos, grandes e pequenos, Me conhecerão - oráculo de Javé. Pois Eu perdoo as suas culpas e esqueço os seus erros."
,"35":"Assim diz Javé, Aquele que estabelece o Sol para iluminar o dia e ordena à Lua e às estrelas para iluminarem a noite, Aquele que agita o mar e as ondas rugem, aquele cujo nome é Javé dos exércitos:"
,"36":"Quando essas leis falharem diante de Mim - oráculo de Javé - então o povo de Israel também deixará de ser diante de mim uma nação para sempre."
,"37":"Assim diz Javé: Só quando alguém puder medir o tamanho do céu nas alturas ou examinar com cuidado os profundos alicerces da Terra, rejeitarei o povo inteiro de Israel, por causa de tudo o que ele fez - oráculo de Javé."
,"38":"Eis que chegarão dias - oráculo de Javé - em que Jerusalém será reconstruída para Javé, desde a torre de Hananeel até à porta do Ângulo."
,"39":"A corda de medir será estendida até à colina do Gareb e, de lá, até Goa."
,"40":"Todo o vale dos Cadáveres e das Cinzas, até ao vale da torrente do Cedron, até ao ângulo da porta dos Cavalos, no lado do Oriente, toda essa área estará consagrada a Javé e nunca será arrasada ou destruída."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Palavra que Javé dirigiu a Jeremias no décimo ano de Sedecias, rei de Judá, que corresponde ao décimo oitavo ano de Nabucodonosor."
,"2":"Nessa ocasião, o exército do rei da Babilónia estava a cercar a cidade de Jerusalém e o profeta Jeremias estava preso no pátio da prisão que existia no palácio do rei de Judá."
,"3":"Sedecias, rei de Judá, tinha-o lançado na prisão, acusando-o: «Tu profetizaste: 'Assim diz Javé: Eu entregarei esta cidade nas mãos do rei da Babilónia e ele vai tomá-la;"
,"4":"Sedecias, rei de Judá, não escapará das mãos dos caldeus, mas será entregue ao rei da Babilónia e terá de falar pessoalmente com ele, olhando um para os olhos do outro;"
,"5":"Sedecias será levado para Babilónia e ali ficará até que Eu o visite - oráculo de Javé. Se lutardes contra os caldeus, não vencereis'. Porque é que profetizaste isto?»"
,"6":"Jeremias respondeu: «Eu recebi de Javé a seguinte palavra:"
,"7":"Hanameel, filho do teu tio Selum, virá dizer-te: 'Compra o terreno que tenho em Anatot, porque, por direito, tens a preferência para o comprar'."
,"8":"De acordo com a palavra de Javé, Hanameel, filho do meu tio Selum, foi procurar-me onde eu estava, no pátio da prisão, e disse-me: 'Vamos! Compra o meu terreno em Anatot, no território de Benjamim, pois o direito é teu por herança; tu é que deves ficar com ele. Compra-o, então'. Eu entendi que isso era uma palavra de Javé."
,"9":"Comprei o terreno que o meu primo Hanameel tinha em Anatot. Paguei por ele duzentos gramas de prata."
,"10":"Escrevi o contrato, selei-o, chamei as testemunhas, depois pesei a prata numa balança."
,"11":"Em seguida, tomei o contrato de compra fechado, conforme as normas legais, e também a cópia aberta."
,"12":"Entreguei o contrato a Baruc, filho de Nerias, neto de Maasias, na presença do meu primo Hanameel, das testemunhas que assinaram o documento e de todos os judeus que estavam no pátio da prisão."
,"13":"Diante de todos eles, dei a seguinte ordem a Baruc:"
,"14":"'Assim diz Javé dos exércitos, o Deus de Israel: Toma esses dois contratos, o contrato de compra que está fechado e também a cópia aberta, e mete-os num vaso de cerâmica, para que se conservem por muito tempo."
,"15":"Pois assim diz Javé dos exércitos, o Deus de Israel: Nesta terra ainda se comprarão casas, campos e vinhas'."
,"16":"Depois de entregar o contrato a Baruc, filho de Nerias, rezei a Javé:"
,"17":"'Senhor Javé! Tu fizeste o Céu e a Terra com o teu grande poder e com o teu braço estendido. Para Ti nada é impossível."
,"18":"Tu praticas o amor para com milhares, mas também castigas a maldade dos pais nas costas dos filhos que vêm depois deles. Deus grande e poderoso, o teu Nome é Javé dos exércitos."
,"19":"Grande em projectos e poderoso em acções, os teus olhos estão abertos sobre a conduta dos homens, para dar a cada um conforme a sua conduta e conforme o que merecem as suas acções."
,"20":"Tu fizeste sinais e prodígios no país do Egipto, e ainda hoje os fazes em Israel e entre os homens. Foi assim que ganhaste a fama que tens até hoje."
,"21":"Tiraste Israel, o teu povo, do país do Egipto com sinais e prodígios, com mão forte e braço estendido, espalhando grande terror."
,"22":"Deste-lhes esta Terra, que tinhas prometido com juramento aos seus antepassados, terra onde corre leite e mel."
,"23":"Eles chegaram aqui e tomaram posse da Terra, mas não Te obedeceram, não se comportaram conforme a tua Lei, não fizeram nada daquilo que lhes tinhas mandado fazer. Por isso, chamaste todas estas desgraças contra eles."
,"24":"As trincheiras dos inimigos já se aproximam da cidade, para a tomarem. Ela cairá nas mãos dos caldeus, que a atacam com espada, fome e peste. O que disseste, está a acontecer, e Tu vê-lo."
,"25":"Disseste-me, Senhor Javé, para comprar um terreno a peso de prata e chamar testemunhas, enquanto a cidade cai nas mãos dos caldeus'."
,"26":"A palavra de Javé foi dirigida a Jeremias:"
,"27":"Eu sou Javé, Deus de todas as criaturas. Existe alguma coisa impossível para Mim?"
,"28":"Por isso, assim diz Javé: Estou para entregar esta cidade nas mãos dos caldeus, nas mãos de Nabucodonosor, rei da Babilónia, e ele vai tomá-la."
,"29":"Os caldeus que estão a guerrear contra ela entrarão nesta cidade, incendiarão as casas onde nos terraços se queimava incenso a Baal e onde se derramava vinho aos deuses estrangeiros, para Me irritar."
,"30":"Pois, desde a juventude, israelitas e judeus só praticaram o que Eu considero errado, só Me irritaram com as obras das suas mãos - oráculo de Javé."
,"31":"Esta cidade sempre foi para Mim motivo de ira e de cólera, desde que a construíram até ao dia de hoje. Terei de a afastar da minha presença"
,"32":"por causa de todo o mal que os israelitas e judeus fazem para Me irritar, eles, os seus reis e autoridades, sacerdotes e profetas, cidadãos de Judá e habitantes de Jerusalém."
,"33":"Eles voltavam-Me as costas, e não o rosto. Eu admoestava-os continuamente, mas eles não escutaram os meus avisos."
,"34":"Eles colocaram os seus ídolos na Casa onde se invoca o meu Nome, profanando-a;"
,"35":"construíram lugares altos a Baal no vale de Ben-Enom, para lá queimar os seus filhos e filhas em honra de Moloc: coisa que Eu nunca mandei, nem jamais passou pelo meu pensamento cometer tais abominações, levando Judá a pecar."
,"36":"Agora, assim diz Javé, o Deus de Israel, sobre Jerusalém, cidade que foi entregue, conforme Eu disse, nas mãos do rei da Babilónia, pela força da espada, da fome e da peste:"
,"37":"Reuni-los-ei de todos os países por onde os espalhei na minha ira, na minha cólera e no meu grande furor. Reconduzi-los-ei a este lugar, para que nele habitem com segurança."
,"38":"Então eles serão o meu povo e Eu serei o seu Deus."
,"39":"Vou dar-lhes um só coração e um só modo de se comportar, para que Me temam a vida inteira, para felicidade deles e dos filhos que vierem depois."
,"40":"Farei com eles uma aliança eterna e nunca deixarei de lhes fazer o bem. Colocarei no seu coração o meu temor, para que não se afastem de Mim."
,"41":"O meu prazer será fazer que eles sejam felizes. Vou estabelecê-los de maneira estável nesta Terra, com todo o meu coração e com toda a minha alma."
,"42":"Pois assim diz Javé: Da mesma forma que fiz cair sobre este povo esta grande desgraça, também lhes enviarei toda a felicidade que lhes prometo."
,"43":"Comprarão campos neste país, que dizeis estar deserto, sem gente e sem animais, e entregue nas mãos dos caldeus."
,"44":"Comprarão campos a peso de prata, fazendo contratos, selando e chamando testemunhas. Tudo isto, no território de Benjamim e nos arredores de Jerusalém, nas cidades de Judá e nas cidades da Montanha, nas cidades da Planície e nas cidades do Negueb, porque lhes vou mudar a sorte - oráculo de Javé»."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Quando ainda estava detido na prisão, Jeremias recebeu novamente a Palavra de Javé:"
,"2":"Assim diz Javé, que fez a Terra e lhe deu forma, fazendo dela uma coisa firme; o seu Nome é Javé:"
,"3":"Chama por Mim que Eu te responderei, anunciando-te coisas grandiosas e sublimes que não conheces."
,"4":"Pois assim diz Javé, o Deus de Israel, sobre as casas desta cidade e os palácios dos reis de Judá, agora arrasados pelas trincheiras e pela espada:"
,"5":"Agora os caldeus vêm para batalhar contra a cidade e para a cobrirem de cadáveres, porque a feri com ira e cólera, e a esta cidade escondi o meu rosto, por causa de todas as suas maldades."
,"6":"Eu mesmo lhe vou trazer restabelecimento e cura, e lhe mostrarei uma abundância de paz e fidelidade."
,"7":"Mudarei a sorte de Judá e Israel, e farei que cresçam como antigamente."
,"8":"Vou purificá-los de toda a injustiça com que pecaram contra Mim, e vou perdoar todas as injustiças que cometeram contra Mim."
,"9":"Jerusalém será para Mim nome de alegria, louvor e honra, entre todas as nações da Terra que ouvirem falar de todo o bem que lhe fiz. Elas serão tomadas de temor e respeito diante de todo o bem e de toda a felicidade que vou dar a Jerusalém."
,"10":"Assim diz Javé: Vós dizeis que as cidades de Judá e as ruas desertas de Jerusalém são uma ruína, sem homens e sem animais. Pois bem, neste mesmo lugar ouvir-se-á novamente"
,"11":"o som da música, os gritos de alegria, a voz do noivo e da noiva, a voz dos que cantam trazendo sacrifícios de acção de graças ao Templo de Javé: «Agradecei a Javé dos exércitos, porque Ele é bom, porque o seu amor é para sempre». Pois mudarei a sorte deste país, fazendo-o voltar ao que era antes, diz Javé."
,"12":"Assim diz Javé dos exércitos: Neste lugar agora arruinado, sem homens e sem animais, e também em todas as suas cidades haverá pastagens, onde os pastores farão repousar as suas ovelhas."
,"13":"Nas cidades da Montanha e nas cida-des da Planície, nas cidades do Negueb e no território de Benjamim, nos arredores de Jerusalém e nas cidades de Judá, as ovelhas ainda vão desfilar ao alcance da mão de quem as conta, diz Javé."
,"14":"Eis que chegarão dias - oráculo de Javé - em que cumprirei as promessas que fiz à casa de Israel e à casa de Judá."
,"15":"Nesses dias e nesse tempo, farei brotar para David um rebento justo, que exercerá o direito e a justiça no país."
,"16":"Nesses dias, Judá será salvo e Jerusalém viverá tranquila e será chamada «Javé, Nossa Justiça»."
,"17":"Porque assim diz Javé: Não faltará um descendente de David para se sentar no trono da casa de Israel."
,"18":"Também não faltará um descendente dos sacerdotes e levitas para oferecer holocaustos na minha presença, incensar as ofertas e oferecer sacrifícios todos os dias."
,"19":"Javé dirigiu a palavra a Jeremias:"
,"20":"Assim diz Javé: Se puderdes romper a minha aliança com o dia e com a noi-te, de modo que já não haja mais dia e noite no tempo certo,"
,"21":"também será rompida a minha aliança com o meu servo David, de modo que lhe falte um descendente no trono, e a aliança com os levitas sacerdotes que Me servem."
,"22":"Multiplicarei a descendência do meu servo David e dos levitas que Me servem, como as estrelas do céu que não se podem contar, como a areia da praia que ninguém pode calcular."
,"23":"Javé dirigiu a palavra a Jeremias:"
,"24":"Não ouves o que esta gente diz? Eles dizem: «Javé rejeitou as duas famílias que havia escolhido». Assim desprezam o meu povo e não o consideram como nação."
,"25":"Assim diz Javé: Como é certo que criei o dia e a noite e estabeleci as leis do Céu e da Terra,"
,"26":"também é certo que não rejeitarei a descendência de Javé e do meu servo David, deixando de escolher entre os seus descendentes os chefes da descendência de Abraão, Isaac e Jacob. Porque farei voltar os seus exilados e terei compaixão deles."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Quando Nabucodonosor, rei da Babilónia, estava guerreando contra Jerusalém e as outras cidades que dela dependem, acompanhado não só do seu exército, mas também dos reis dos países que ele tinha dominado e dos seus exércitos, Javé dirigiu a palavra a Jeremias:"
,"2":"Assim diz Javé, o Deus de Israel: Fala com Sedecias, rei de Judá, e diz-lhe: Assim diz Javé: Eu estou para entregar esta cidade nas mãos do rei da Babilónia, para que a incendeie."
,"3":"Nem tu lhe poderás escapar. Serás preso e entregue nas suas mãos: os teus olhos verão os olhos do rei da Babilónia, falarás pessoalmente com ele, e depois serás levado para a Babilónia."
,"4":"Sedecias, rei de Judá, ouve a palavra de Javé: Assim diz Javé: Tu não morrerás pela espada;"
,"5":"morrerás em paz. Da mesma forma como se queimaram perfumes pelos antepassados, os reis que te precederam, também se queimarão perfumes por ti, e também te lamentarão cantando: «Ah, Majestade!» Sou Eu que o declaro - oráculo de Javé."
,"6":"O profeta Jeremias disse tudo isto ao rei Sedecias, rei de Judá em Jerusalém, enquanto"
,"7":"o exército do rei da Babilónia sitiava Jerusalém e as cidades de Judá, Laquis e Azeca, as duas últimas fortalezas que ainda resistiam."
,"8":"Palavra que Javé dirigiu a Jeremias depois de o rei Sedecias ter feito um acordo com todo o povo que havia em Jerusalém, para proclamar a liberdade dos escravos:"
,"9":"cada um deveria dar liberdade ao seu escravo ou escrava hebreu ou hebreia, para que nenhum judeu fosse escravo do seu irmão."
,"10":"Todas as autoridades e todo o povo respeitaram o acordo que tinham feito de cada um dar liberdade aos seus escravos e escravas, de modo a nunca mais se escravizarem uns aos outros. Obedeceram e puseram-nos em liberdade."
,"11":"Mas, depois disso, arrependeram-se e fizeram voltar de novo os seus escravos e escravas, que tinham libertado, e submeteram-nos de novo à escravidão."
,"12":"Então Javé dirigiu a palavra a Jeremias:"
,"13":"Assim diz Javé, o Deus de Israel: Eu mesmo fiz uma aliança com os vossos antepassados, quando os tirei da terra do Egipto, da casa da escravidão, dizendo:"
,"14":"Ao fim de cada sete anos, todos darão liberdade ao seu irmão hebreu, que haviam comprado e que já lhes havia servido durante seis anos. Devem dar-lhe então a liberdade. Mas os vossos antepassados não Me escutaram nem Me obedeceram."
,"15":"Hoje fizestes o que Eu aprovo: cada um proclamou a liberdade do seu próximo e fez uma aliança sobre isso na minha presença, no Templo em que o meu nome é invocado."
,"16":"Mas depois arrependestes-vos e profanastes o meu nome, ao fazerdes voltar os escravos e escravas que tínheis libertado, submetendo-os de novo à escravidão."
,"17":"Por isso, assim diz Javé: Já que não Me obedecestes quando ordenei que cada um desse liberdade ao seu irmão e ao seu próximo, então agora proclamarei a liberdade - oráculo de Javé - em relação à espada, à fome e à peste. Vou fazer de vós objecto de espanto entre os reinos da terra."
,"18":"Aqueles homens não respeitaram a minha aliança: não cumpriram a palavra da aliança que fizeram comigo. Vou fazer que tenham a sorte do novilho que cortaram ao meio e passando depois entre as duas metades."
,"19":"Quanto aos chefes de Judá e Jerusalém, aos funcionários, sacerdotes e pessoas do povo que passaram entre as metades do novilho,"
,"20":"vou entregá-los nas mãos dos seus inimigos, daqueles que querem a sua morte. Os seus cadáveres servirão de comida às aves do céu e às feras da terra."
,"21":"Quanto a Sedecias, rei de Judá, e aos seus chefes, também vou entregá-los nas mãos dos seus inimigos, dos que querem a sua morte: o exército do rei da Babilónia, que agora se afastou de vós."
,"22":"Eu vou dar ordens - oráculo de Javé - para que voltem contra esta cidade. Vão atacá-la, conquistá-la e incendiá-la. Também transformarei as cidades de Judá num deserto, sem habitante nenhum."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Palavra que Javé dirigiu a Jeremias no tempo de Joaquim, filho de Josias, rei de Judá:"
,"2":"«Vai aonde moram os recabitas, conversa com eles e leva-os a uma das salas do Templo de Javé, e dá-lhes vinho a beber»."
,"3":"Tomei então Jezonias, filho de Jeremias, neto de Habsanias, os seus irmãos e filhos, toda a família dos recabitas."
,"4":"Levei-os ao Templo de Javé, à sala de Ben-Joanã, filho de Jegdalias, o homem de Deus, ao lado da sala dos chefes, por cima da sala de Maasias, filho de Selum, o porteiro."
,"5":"Coloquei diante dos recabitas jarras cheias de vinho e cálices, dizendo: «Bebei vinho»."
,"6":"Eles responderam: «Não bebemos vinho, pois o nosso antepassado Jonadab, filho de Recab, deu-nos esta ordem: 'Não bebais vinho, nem vós nem os vossos filhos, para sempre."
,"7":"Também não construais casas, não semeeis nem planteis vinhas. Nada disto tereis, pois habitareis em tendas todos os dias da vida, para que assim vivais bastante sobre esta Terra, onde viveis como estrangeiros'."
,"8":"Nós obedecemos sempre ao que nos mandou o nosso antepassado Jonadab, filho de Recab: durante a vida toda jamais bebemos vinho, nem nós, nem as nossas esposas, nem os nossos filhos ou filhas;"
,"9":"não construímos casas para morar e não temos vinhas nem campos de sementeiras;"
,"10":"moramos em tendas, obedecemos e fazemos tudo conforme nos ordenou o nosso antepassado Jonadab."
,"11":"Agora, quando Nabucodonosor, rei da Babilónia, invadiu o país, dissemos: 'Vamos entrar em Jerusalém, para fugir do exército dos caldeus e dos arameus'. É por isso que viemos morar em Jerusalém»."
,"12":"Então Javé dirigiu a palavra a Jeremias:"
,"13":"Assim diz Javé dos exércitos, o Deus de Israel: Vai dizer aos cidadãos de Judá e aos habitantes de Jerusalém: Não recebereis vós a minha admoestação, nem obedecereis à minha palavra? - oráculo de Javé."
,"14":"Cumpre-se a ordem de Jonadab, filho de Recab, que proibiu os seus filhos de beberem vinho, e eles não bebem vinho até hoje, porque obedecem às ordens do seu antepassado. Mas a Mim que falei e voltei a falar convosco, não Me obedecestes."
,"15":"Eu tenho mandado continuamente os meus servos, os profetas, para vos dizer: «Cada um converta-se da sua má conduta e corrija as suas acções; não sigais nem sirvais os deuses estrangeiros; só assim continuareis a morar na terra que vos dei a vós e aos vossos antepassados». Mas vós não Me quisestes escutar, nem Me obedecestes."
,"16":"Os filhos de Jonadab, filho de Recab, observam as ordens do seu antepassado, mas este povo não Me ouviu."
,"17":"Por isso, assim diz Javé dos exércitos, o Deus de Israel: Farei cair sobre Judá e sobre os moradores de Jerusalém toda a desgraça com que os ameacei, porque falei com eles e não Me obedeceram: chamei-os e não me responderam."
,"18":"Então Jeremias disse à família dos recabitas: «Assim diz Javé dos exércitos, o Deus de Israel: Porque obedeceis às ordens do Jonadab, vosso antepassado, e observais tudo o que ele ordenou e fazeis tudo de acordo com as suas ordens,"
,"19":"assim diz Javé dos exércitos, o Deus de Israel: A Jonadab, filho de Recab, nunca faltará alguém que esteja sempre na minha presença»."
}`)
	CurrentBook.AddChapter(36, `{
"1":"No quarto ano de Joaquim, filho de Josias, rei de Judá, Javé dirigiu esta palavra a Jeremias:"
,"2":"Toma um pergaminho e escreve nele tudo o que Eu te disse sobre Israel, sobre Judá e todas as nações, desde o dia em que comecei a falar contigo, no tempo de Josias, até hoje."
,"3":"Quando a gente de Judá tomar conhecimento de todas as desgraças que estou a planear fazer contra eles, talvez cada um se converta da sua má conduta e Eu possa perdoar as suas faltas e pecados."
,"4":"Então Jeremias chamou Baruc, filho de Nerias, que escreveu num pergaminho tudo o que Javé tinha dito a Jeremias e que este ia ditando."
,"5":"Depois Jeremias disse a Baruc: «Estou preso e não posso ir ao Templo de Javé."
,"6":"Vai tu e lê neste pergaminho as palavras de Javé, que eu ditei e tu escreveste. Lê para que o povo possa ouvir, quando estiver no Templo de Javé no dia do jejum. Lê em voz alta também para todos os de Judá que vêm das suas cidades."
,"7":"Talvez eles se humilhem com súplicas diante de Javé, e cada um se converta da sua má conduta, pois é grande a ira e o furor que Javé demonstra contra este povo»."
,"8":"Baruc, filho de Nerias, fez como o profeta Jeremias lhe ordenara, e leu no Templo as palavras de Javé."
,"9":"No nono mês do quinto ano de Joaquim, filho de Josias, rei de Judá, foi convocado um jejum em honra de Javé a todo o povo de Jerusalém e a todos os que vinham das outras cidades de Judá para Jerusalém."
,"10":"Então Baruc leu, no Templo de Javé, para todo o povo ouvir, as palavras de Jeremias que ele tinha escrito no pergaminho. Baruc estava no compartimento de Gamarias, filho do escrivão Safã, no balcão de cima, à entrada da Porta Nova do Templo de Javé."
,"11":"Miqueias, filho de Gamarias e neto de Safã, ouviu as palavras de Javé lidas no pergaminho."
,"12":"Em seguida, desceu até ao palácio do rei e foi ao compartimento do escrivão. Aí encontrou todas as autoridades: o escrivão Elisama; Dalaías, filho de Semeías, Elnatã, filho de Acobor; Gamarias, filho de Safã; Sedecias, filho de Hananias; e outras autoridades."
,"13":"Miqueias contou-lhes tudo o que tinha ouvido, quando Baruc leu o pergaminho na presença do povo."
,"14":"Essas autoridades enviaram então Judi, filho de Natanias, e Selemias, filho de Cusi, para dizerem a Baruc que pegasse no pergaminho que tinha lido ao povo e fosse aonde eles estavam. Baruc, filho de Nerias, pegou no pergaminho e foi procurá-los."
,"15":"Eles disseram-lhe: «Agora senta-te aí e lê». Baruc leu para eles ouvirem."
,"16":"Quando acabaram de ouvir tudo, olharam assustados uns para os outros, e disseram a Baruc: «Temos que contar ao rei tudo o que aí está escrito!»"
,"17":"E perguntaram a Baruc: «Conta-nos: como foi que escreveste tudo isso?»"
,"18":"Baruc respondeu: «Jeremias foi-me ditando e eu fui escrevendo tudo no pergaminho»."
,"19":"Então as autoridades disseram a Baruc: «Vai e esconde-te com Jeremias. E que ninguém saiba onde vós estais»."
,"20":"Depois foram ter com o rei ao pátio do palácio. Deixaram o pergaminho no compartimento do escrivão Elisama, e contaram tudo ao rei."
,"21":"Imediatamente o rei mandou que Judi fosse buscar o pergaminho. Ele tomou o pergaminho na sala do escrivão Elisama e leu-o na presença do rei e das autoridades que estavam junto dele."
,"22":"O rei estava na ala de Inverno do palácio, pois era o nono mês; e havia um braseiro aceso diante do rei."
,"23":"Cada vez que Judi acabava de ler três ou quatro colunas do pergaminho, o rei cortava os pedaços com a faca do escrivão e atirava-os ao fogo do braseiro. Fez assim até que todo o pergaminho foi queimado no braseiro."
,"24":"Ninguém se impressionou, ninguém rasgou as vestes, nem o rei nem os seus ministros, ao ouvirem aquelas palavras."
,"25":"Somente Elnatã, Dalaías e Gamarias pediram ao rei para não queimar o pergaminho, mas ele não lhes deu ouvidos."
,"26":"Por fim, o rei mandou Jeremiel, oficial do palácio, Saraías, filho de Azriel, e Selemias, filho de Abdeel, que fossem prender o escrivão Baruc e o profeta Jeremias. Javé, porém, escondeu-os."
,"27":"Depois de o rei ter queimado o pergaminho que continha as palavras escritas por Baruc e ditadas por Jeremias, Javé dirigiu esta palavra a Jeremias:"
,"28":"Toma de novo outro pergaminho e escreve nele tudo o que estava escrito no primeiro pergaminho que Joaquim, rei de Judá, queimou."
,"29":"Deverás dizer o seguinte a Joaquim, rei de Judá: Assim diz Javé: Queimaste o pergaminho, dizendo: «Porque é que escreveste nele que o rei da Babilónia virá sem dúvida nenhuma destruir este país e dele fará desaparecer os homens e os rebanhos?»"
,"30":"Por isso, assim diz Javé contra Joaquim, rei de Judá: Ele não terá um descendente no trono de David. O seu cadáver ficará exposto ao calor do dia e ao frio da noite."
,"31":"Eu castigo nele, na sua família e nos seus ministros, os pecados que cometeram; farei chegar para eles, para os habitantes de Jerusalém e para os cidadãos de Judá, todas as desgraças de que falei e eles não quiseram ouvir."
,"32":"Jeremias tomou então outro pergaminho e entregou-o ao escrivão Baruc, filho de Nerias, que escreveu tudo o que estava no pergaminho que Joaquim, rei de Judá, havia queimado. Acrescentou ainda muitas outras palavras semelhantes."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Sedecias, filho de Josias, sucedeu no trono a Jeconias, filho de Joaquim. Sedecias foi nomeado rei de Judá por Nabucodonosor, rei da Babilónia."
,"2":"Mas nem Sedecias, nem os seus ministros, nem os proprietários de terra obedeceram ao que Javé tinha dito por meio do profeta Jeremias."
,"3":"O rei Sedecias mandou Jucal, filho de Selemias, e o sacerdote Sofonias, filho de Maasias, para levarem a Jeremias o seguinte recado: «Reza por nós a Javé, nosso Deus»."
,"4":"Jeremias podia andar livremente no meio do povo, pois eles ainda não o tinham posto na prisão."
,"5":"O exército do Faraó tinha saído do Egipto, e quando os caldeus, que estavam a cercar Jerusalém, ouviram a notícia, abandonaram o cerco da cidade."
,"6":"Então Javé dirigiu esta palavra a Jeremias:"
,"7":"«Assim diz Javé, o Deus de Israel: Ao rei de Judá, que Me mandou procurar, dirás: Fica sabendo que o exército do Faraó, que se pôs em marcha para vos vir ajudar, acaba de voltar para o seu país, o Egipto."
,"8":"Os caldeus voltarão para atacar esta cidade, vão ocupá-la e incendiá-la."
,"9":"Assim diz Javé: Não vos iludais pensando que os caldeus se retirarão, pois eles não se irão embora."
,"10":"E mesmo que vós arrasásseis todo o exército dos caldeus que está em guerra contra vós, e deles só ficassem alguns feridos, cada um deles se levantaria da sua tenda para incendiar esta cidade»."
,"11":"Quando o exército dos caldeus se afastou de Jerusalém, por medo do exército do Faraó,"
,"12":"Jeremias saiu de Jerusalém para ir ao território de Benjamim receber uma herança dos seus parentes."
,"13":"Quando ele se encontrava na porta de Benjamim, estava lá um chefe da guarda chamado Jerias, filho de Selemias, neto de Hananias, que o prendeu, dizendo: «Estás a passar-te para o lado dos caldeus!»"
,"14":"Jeremias respondeu: «É mentira! Claro que não estou a passar-me para o lado dos caldeus!» Jerias, porém, não acreditou e prendeu Jeremias, levando-o em seguida às autoridades."
,"15":"As autoridades ficaram indignadas com Jeremias. Depois de o açoitarem, prenderam-no na casa do escrivão Jónatas, que eles tinham transformado em cadeia."
,"16":"Jeremias foi levado para uma cela subterrânea, onde ficou preso durante vários dias."
,"17":"O rei Sedecias mandou buscar Jeremias. No seu palácio, secretamente, o rei perguntou-lhe: «Tens alguma palavra de Javé?» Jeremias respondeu: «Tenho: tu vais ser entregue nas mãos do rei da Babilónia»."
,"18":"Depois Jeremias disse ao rei Sedecias: «Que mal te fiz eu e aos teus ministros, ou a este povo, para me meterdes na prisão?"
,"19":"Onde é que estão os vossos profetas que diziam: 'O rei da Babilónia não virá contra vós, nem invadirá o país'?"
,"20":"Agora, por favor, que Vossa Majestade me atenda, e que a minha súplica chegue até ao rei: não me faças voltar para a casa do escrivão Jónatas, não me deixes morrer lá!»"
,"21":"O rei Sedecias mandou deixar Jeremias no pátio da prisão e dar-lhe todos os dias um pão vindo da rua dos padeiros, enquanto houvesse pão na cidade. Foi assim que Jeremias ficou no pátio da prisão."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Safatias, filho de Matã; Gedalias, filho de Fassur; Jucal, filho de Selemias; e Fassur, filho de Melquias, ouviram o que Jeremias disse a todo o povo:"
,"2":"«Assim diz Javé: quem ficar nesta cidade morrerá pela espada, pela fome e pela peste; quem passar para os caldeus, será tomado como despojo, mas conservará a vida."
,"3":"Assim diz Javé: Esta cidade será entregue nas mãos do exército do rei da Babilónia, para que a conquiste»."
,"4":"Então os altos funcionários disseram ao rei: «Manda matar esse homem, pois ele, falando assim, está a desencorajar os soldados que ainda restam nesta cidade e todo o povo. Esse homem não busca o bem do povo mas a desgraça!»"
,"5":"O rei Sedecias respondeu: «Ele está nas vossas mãos, pois o rei não tem força nenhuma contra vós»."
,"6":"Então eles tomaram Jeremias e, com uma corda, puseram-no dentro do poço do príncipe real Melquias, no pátio da prisão. Como no poço não havia água, mas só barro, Jeremias ficou atolado no barro."
,"7":"O etíope Ebed-Melec, que era eunuco e servia no palácio do rei, ouviu dizer que eles tinham colocado Jeremias no poço. Enquanto o rei estava sentado junto à porta de Benjamim,"
,"8":"Ebed-Melec saiu do palácio e disse ao rei:"
,"9":"«Majestade, aqueles homens agiram mal contra o profeta Jeremias, metendo-o no poço: ali ele vai morrer de fome, pois já não há pão na cidade»."
,"10":"Então o rei ordenou a Ebed-Melec, o etíope: «Leva contigo três homens e tirai o profeta Jeremias do poço, antes que ele morra»."
,"11":"Ebed-Melec levou os homens, entraram no palácio, foram até ao vestiário de onde tiraram uns panos velhos e uns trapos. Depois, deitaram esses trapos e a corda a Jeremias."
,"12":"Ebed-Melec, o etíope, disse a Jeremias: «Coloca esses trapos debaixo do braço, onde vai passar a corda». Assim fez Jeremias."
,"13":"Então puxaram Jeremias pela corda, tirando-o do poço. E Jeremias ficou no pátio da prisão."
,"14":"O rei Sedecias mandou que trouxessem o profeta Jeremias e o conduzissem à terceira entrada do Templo de Javé. O rei disse a Jeremias: «Vou perguntar-te uma coisa: não me escondas nada»."
,"15":"Jeremias respondeu: «Se te falar, certamente me matarás, e se te der um conselho, não me ouvirás»."
,"16":"O rei Sedecias jurou em segredo a Jeremias: «Pela vida de Javé, que nos deu a vida: não te matarei nem te entregarei nas mãos dos homens que te querem matar»."
,"17":"Então Jeremias disse ao rei Sedecias: «Assim diz Javé dos exércitos, o Deus de Israel: Se saíres da cidade para te entregares aos generais do rei da Babilónia, conservarás a vida, e esta cidade não será incendiada; tu e a tua família conservareis a vida."
,"18":"Se não te entregares aos generais do rei da Babilónia, esta cidade cairá nas mãos dos caldeus, que a incendiarão, e tu não escaparás»."
,"19":"O rei Sedecias disse: «Tenho medo dos judeus que passaram para o lado dos caldeus; temo que me entreguem nas mãos deles e me maltratem»."
,"20":"Jeremias disse: «Não te vão entregar. Presta atenção a esta palavra de Javé, que eu te transmiti: Tem confiança, e salvarás a tua vida."
,"21":"Se não estiveres disposto a entregar-te, eis o que Javé me comunicou:"
,"22":"Todas as mulheres que ficarem na corte do rei de Judá serão entregues aos generais do rei da Babilónia, e cantarão assim: 'Os teus bons amigos enganaram-te e venceram-te; afundaram os teus pés na lama e foram-se embora!'"
,"23":"As mulheres e os vossos filhos vão ser levados para os caldeus e nem tu escaparás das suas mãos, pelo contrário, vais ficar prisioneiro do rei da Babilónia e esta cidade será incendiada»."
,"24":"Sedecias disse a Jeremias: «Que ninguém fique a saber desta mensagem, senão morres."
,"25":"Se os chefes souberem que eu estive a conversar contigo e te disserem: 'Conta-nos o que foi que disseste ao rei e o que ele te disse; não escondas nada, se não matamos-te',"
,"26":"responderás: 'Eu fui pedir ao rei que não me fizesse voltar para a casa de Jónatas, para não morrer lá'»."
,"27":"Todos os chefes foram procurar Jeremias para lhe fazerem perguntas, mas ele respondeu tudo de acordo com o que o rei lhe tinha mandado dizer. Eles, então, deixaram-no tranquilo, pois a conversa não fora ouvida."
,"28":"Jeremias ficou no pátio da prisão até à tomada de Jerusalém."
}`)
	CurrentBook.AddChapter(39, `{
"1":"No décimo mês do nono ano de Sedecias, rei de Judá, chegou a Jerusalém Nabucodonosor, rei da Babilónia, com todo o seu exército, e cercou a cidade."
,"2":"Foi no nono dia do quarto mês do décimo primeiro ano de Sedecias que ele conseguiu abrir uma brecha para entrar na cidade."
,"3":"Por aí entraram os oficiais do rei da Babilónia, que se colocaram na porta do Meio. Eram eles: Nergalsareser, Samgar-Nabu, Sar-Saquim, chefe dos eunucos, Nergalsareser, grande mago, e todos os outros oficiais do rei da Babilónia."
,"4":"Sedecias, rei de Judá, e os seus soldados, quando viram tudo isso, tentaram fugir. Saíram da cidade à noite pelo jardim do rei, que vai dar à porta entre as duas muralhas, e dirigiram-se para o deserto."
,"5":"Mas o exército dos caldeus perseguiu-os, e alcançou Sedecias nas planícies de Jericó. Prenderam o rei Sedecias e levaram-no a Nabucodonosor, rei da Babilónia, que estava em Rebla, na região de Emat, e que ali mesmo decretou a sentença de Sedecias."
,"6":"O rei da Babilónia mandou matar os filhos de Sedecias ali mesmo em Rebla, diante dos olhos de Sedecias; e mandou matar também os nobres de Judá."
,"7":"Em seguida, furou os olhos de Sedecias e algemou-o, a fim de o levar para a Babilónia."
,"8":"Quanto ao palácio do rei e às casas particulares, os caldeus incendiaram tudo e derrubaram as muralhas de Jerusalém."
,"9":"Nabuzardã, chefe da guarda, mandou para a Babilónia o resto da população que ainda tinha ficado na cidade, os desertores que se entregaram e os artesãos profissionais que ainda havia."
,"10":"Os mais pobres do povo, os que não possuíam nada, Nabuzardã deixou-os na terra de Judá e deu-lhes vinhas e terra para cultivar."
,"11":"Quanto a Jeremias, Nabucodonosor, rei da Babilónia, deu a seguinte ordem a Nabuzardã, chefe da guarda:"
,"12":"«Tu mesmo vais buscá-lo e cuidar dele. Não lhe faças mal nenhum; pelo contrário, faz tudo conforme ele pedir»."
,"13":"Nabuzardã, chefe da guarda; o comandante Nabusezbã, oficial superior; Nergalsareser, grande mago; e os outros oficiais do rei da Babilónia"
,"14":"mandaram tirar Jeremias do pátio da prisão e entregaram-no a Godolias, filho de Aicam, neto de Safã, para que o levasse para casa. E Jeremias ficou livre, no meio do povo."
,"15":"Enquanto Jeremias estava preso no pátio da prisão, Javé dirigiu-lhe a seguinte palavra:"
,"16":"«Vai dizer ao etíope Ebed-Melec: Assim diz Javé dos exércitos, o Deus de Israel: Eis que vou cumprir contra esta cidade as minhas palavras, para desgraça e não para salvação. Nesses dias, tudo vai realizar-se diante de ti."
,"17":"No entanto, nesse dia Eu livrar-te-ei - oráculo de Javé. E tu não cairás nas mãos desses homens, dos quais tens medo."
,"18":"Farei com que escapes e não caias sob a espada. Terás a tua vida como despojo, porque confiaste em Mim - oráculo de Javé»."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Palavra que Javé dirigiu a Jeremias, depois de Nabuzardã, chefe da guarda, o ter feito regressar de Ramá, onde ele estava acorrentado juntamente com os presos de Judá e Jerusalém, que estavam a ser levados para o exílio na Babilónia."
,"2":"Ao tirá-lo do meio dos prisioneiros, o chefe da guarda disse-lhe: «Javé, teu Deus, predisse esta desgraça para este lugar,"
,"3":"e realizou-a. Javé fez conforme havia anunciado, pois pecastes contra Ele e não Lhe obedecestes. Foi por esse motivo que vos aconteceu tudo isto."
,"4":"Eu soltei as algemas dos teus pulsos. Se achas bom ir para a Babilónia comigo, vamos, que eu olharei por ti. Mas se não achas bom ir comigo para a Babilónia, podes ficar: o país inteiro está à tua frente, podes ir para onde achares melhor e mais correcto»."
,"5":"Antes de Jeremias tomar um rumo, o chefe da guarda continuou: «Podes ir para a casa de Godolias, filho de Aicam, neto de Safã, que o rei da Babilónia colocou como governador das cidades de Judá. Podes ficar com ele, no meio do povo. Ou então, podes ir para onde achares preferível». O chefe da guarda deu-lhe provisões e presentes, e deixou-o livre."
,"6":"Jeremias foi para a casa de Godolias, filho de Aicam, em Masfa, e ficou com ele, vivendo no meio do povo que ficara no país."
,"7":"Os comandantes das guarnições que estavam fora da cidade, juntamente com todos os seus homens, ficaram a saber que o rei da Babilónia tinha colocado Godolias, filho de Aicam, como governador, e que lhe tinha confiado os homens, mulheres e crianças, e os pobres do país que não tinham sido levados para o exílio na Babilónia."
,"8":"Ismael, filho de Natanias; Joanã e Jónatas, filhos de Carea; Saraías, filho de Taneumet; os filhos de Ofi de Netofa; e Jezonias, filho de Maacati, foram procurar Godolias em Masfa. Foram eles e as suas gentes."
,"9":"Godolias, filho de Aicam, neto de Safã, jurou-lhes a eles e aos seus homens: «Não tenhais medo de servir aos caldeus. Permanecei na Terra e servi o rei da Babilónia, e nada vos acontecerá."
,"10":"Quanto a mim, fiquei aqui em Masfa como responsável diante dos caldeus que vêm até nós. Fareis a colheita do vinho, das frutas e do azeite; enchei as vossas vasilhas e ficai nas cidades em que habitais»."
,"11":"Os judeus que estavam em Moab, entre os amonitas, em Edom e outras regiões, também ouviram dizer que o rei da Babilónia tinha deixado um resto em Judá e que havia colocado Godolias, filho de Aicam, neto de Safã, como seu governador."
,"12":"Então começaram a voltar judeus de todos os lugares por onde se haviam espalhado; vieram para a terra de Judá, para junto de Godolias, em Masfa, e fizeram uma colheita muito abundante de vinho e frutas."
,"13":"Joanã, filho de Carea, e os comandantes do exército que estavam no interior, foram procurar Godolias em Masfa."
,"14":"Disseram-lhe: «Tu sabes que Baalis, rei dos amonitas, encarregou Ismael, filho de Natanias, de te tirar a vida?» Mas Godolias, filho de Aicam, não acreditou neles."
,"15":"Mesmo assim, Joanã, filho de Carea, disse em particular a Godolias, em Masfa: «Eu vou matar Ismael, filho de Natanias, e ninguém o saberá. Porque haveria ele de te matar? Porque é que todos esses judeus que se reuniram à tua volta teriam de se espalhar? Por que motivo seria destruído o resto de Judá?»"
,"16":"Mas Godolias, filho de Aicam, respondeu a Joanã, filho de Carea: «Não faças isso, pois o que dizes de Ismael é falso»."
}`)
	CurrentBook.AddChapter(41, `{
"1":"No sétimo mês, Ismael, filho de Natanias, neto de Elisama, de estirpe real, foi com dez homens à procura de Godolias, filho de Aicam, em Masfa. E enquanto comiam juntos em Masfa,"
,"2":"Ismael, filho de Natanias, e os dez homens que estavam com ele atacaram à espada Godolias, filho de Aicam, neto de Safã. Foi assim que mataram aquele que o rei da Babilónia tinha colocado como governador no país."
,"3":"Ismael matou também todos os judeus que estavam com Godolias em Masfa, bem como os soldados caldeus que ali se encontravam."
,"4":"No dia seguinte ao assassinato de Godolias, ninguém ainda sabia."
,"5":"Chegaram, então, uns oitenta homens de Siquém, de Silo e de Samaria, com a barba rapada, vestes rasgadas e ferimentos no corpo; traziam ofertas e incenso para o Templo de Javé."
,"6":"Ismael, filho de Natanias, saiu de Masfa ao encontro deles, fora da cidade, banhado em lágrimas. Ao encontrá-los, disse: «Vinde até onde está Godolias, filho de Aicam»."
,"7":"Logo, porém, que eles chegaram ao centro da cidade, Ismael, filho de Natanias, juntamente com os seus homens, estrangulou-os e mandou lançar-lhes os corpos para dentro de uma cisterna."
,"8":"Houve, porém, dez desses homens que disseram a Ismael: «Não nos mates! Nós temos trigo, cevada, azeite e mel escondidos no campo». Então Ismael parou e não matou esses dez com os seus irmãos."
,"9":"A cisterna em que Ismael lançou os corpos dos homens que matou é aquela grande que o rei Asa fizera com medo de Baasa, rei de Israel. Foi essa cisterna que Ismael, filho de Natanias, encheu com os cadáveres dos homens que matou."
,"10":"Depois Ismael aprisionou todo o resto do povo que estava em Masfa: desde as filhas do rei até ao povo que ficou em Masfa e que Nabuzardã, chefe da guarda, tinha confiado a Godolias, filho de Aicam. Ismael, filho de Natanias, levou-os como prisioneiros e partiu para o país dos amonitas."
,"11":"Joanã, filho de Carea, e os outros comandantes das guarnições, seus companheiros, ouviram falar de todos os crimes que Ismael, filho de Natanias, havia praticado."
,"12":"Reuniram, então, todos os seus soldados e partiram para atacar Ismael, filho de Natanias. Alcançaram-no perto da represa grande de Gabaon."
,"13":"Todo o povo que estava com Ismael, quando viu Joanã, filho de Carea, e todos os comandantes das guarnições que estavam com ele, ficou muito contente."
,"14":"Então todo o povo que Ismael levava cativo desde Masfa, abandonou-o e passou para o lado de Joanã, filho de Carea."
,"15":"Ismael, filho de Natanias, ainda conseguiu escapar a Joanã, com mais oito homens, fugindo para o país dos amonitas."
,"16":"Então Joanã, filho de Carea, e todos os comandantes de guarnições que estavam com ele, reuniram todo o resto do povo que Ismael, filho de Natanias, tinha levado como prisioneiro desde Masfa, depois de ter assassinado Godolias, filho de Aicam. Eram homens guerreiros, mulheres, crianças e eunucos, que foram libertados em Gabaon."
,"17":"Partiram e fizeram uma paragem no refúgio de Camaã, perto de Belém, para depois seguirem a caminho do Egipto,"
,"18":"pois estavam com medo dos caldeus, porque Ismael, filho de Natanias, tinha matado Godolias, filho de Aicam, que o rei da Babilónia colocara como governador do país."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Os comandantes, juntamente com Joanã, filho de Carea, e Azarias, filho de Osaías, com todo o povo, grandes e pequenos, foram procurar Jeremias"
,"2":"e disseram-lhe: «Nós te suplicamos: intercede junto de Javé, teu Deus, por nós e por este resto, pois de muitos que éramos ficámos poucos, como tu mesmo podes ver."
,"3":"Que Javé, teu Deus, nos mostre o caminho que devemos seguir e o que devemos fazer»."
,"4":"O profeta Jeremias respondeu: «De acordo. Vou interceder junto de Javé, vosso Deus, conforme pedis. Então tudo o que Javé mandar responder-vos, eu vo-lo referirei, sem esconder coisa alguma»."
,"5":"Eles disseram a Jeremias: «Que o próprio Javé seja testemunha verdadeira e correcta contra nós, se não agirmos conforme a palavra que Javé, teu Deus, te mandar dizer-nos."
,"6":"Seja coisa favorável, seja coisa adversa, obedeceremos a Javé, nosso Deus, a quem te enviamos, para que tudo nos corra bem, pois queremos obedecer a Javé, nosso Deus»."
,"7":"Passados dez dias, a palavra de Javé foi dirigida a Jeremias."
,"8":"Então ele chamou Joanã, filho de Carea, os comandantes das guarnições que o acompanhavam e também todo o povo, pequenos e grandes,"
,"9":"e disse-lhes: Assim disse Javé, o Deus de Israel, a quem me mandastes implorar em vosso favor:"
,"10":"Se permanecerdes neste país, Eu vos construirei e não vos destruirei, vos plantarei e não vos arrancarei, pois estou arrependido do mal que vos fiz."
,"11":"Não receeis o rei da Babilónia, de quem agora tendes medo. Não tenhais medo - oráculo de Javé - pois Eu estou convosco para vos salvar e livrar das suas mãos."
,"12":"Eu obterei para vós a sua benevolência e ele terá compaixão de vós deixando-vos ficar na vossa terra."
,"13":"Mas se desobedecerdes à palavra de Javé, vosso Deus, dizendo: «Não vamos ficar neste país;"
,"14":"pelo contrário, vamos para o Egipto, onde não veremos guerra nem ouviremos o som da trombeta e ninguém passa fome; é lá que nós queremos habitar»;"
,"15":"nesse caso, resto de Judá, ouve a palavra de Javé: Assim disse Javé dos exércitos, o Deus de Israel: Se decidirdes ir para o Egipto e se nele entrardes para lá habitar,"
,"16":"a espada que vos amedronta aqui irá alcançar-vos na terra do Egipto; a fome que vos assusta aqui seguirá os vossos passos no Egipto."
,"17":"Todos os homens que decidirem partir para o Egipto e lá permanecer morrerão pela espada, pela fome e pela peste, sem que seja possível escapar ou fugir da desgraça que Eu farei vir sobre eles."
,"18":"Javé dos exércitos, o Deus de Israel, disse ainda: Da mesma forma como derramei a minha ira e o meu furor sobre os habitantes de Jerusalém, assim também derramarei o meu furor sobre vós, quando entrardes no Egipto. Sereis objecto de maldição e espanto, desprezo e zombaria, e não voltareis a este lugar."
,"19":"É assim que Javé vos falou, resto de Judá. Não entreis no Egipto; sabei que hoje vos advirto solenemente."
,"20":"Vós enganastes-vos a vós mesmos quando me mandastes a Javé, vosso Deus, dizendo: «Intercede junto de Javé, nosso Deus, por nós, e tudo o que Javé, nosso Deus, te disser, anuncia-no-lo e nós o faremos»."
,"21":"Pois eu vo-lo anuncio hoje, mas vós não obedecereis a Javé, vosso Deus, em nada do que Ele vos ordenou através de mim."
,"22":"E agora ficai sabendo: morrereis pela espada, de fome e de peste no lugar onde quisestes entrar e estabelecer-vos."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Quando Jeremias acabou de comunicar a todo o povo as palavras que Javé, seu Deus, lhe mandara transmitir,"
,"2":"então Azarias, filho de Osaías, Joanã, filho de Carea, e todos aqueles homens, cheios de petulância, disseram a Jeremias: «É mentira o que dizes! Javé, nosso Deus, não te enviou a dizer-nos: 'Não entreis no Egipto, para morardes lá'."
,"3":"Baruc, filho de Nerias, é que te incita contra nós, para nos entregar nas mãos dos caldeus, para eles nos matarem ou nos levarem para a Babilónia»."
,"4":"Foi assim que Joanã, filho de Carea, os comandantes e todo o povo não quiseram obedecer a Javé, que lhes ordenara que ficassem na terra de Judá."
,"5":"Joanã, filho de Carea, e os comandantes de guarnições juntaram o resto de Judá e os que tinham voltado das outras nações para onde tinham sido expulsos, a fim de morarem por uns tempos em Judá."
,"6":"Eram homens, mulheres, crianças, as filhas do rei, enfim todos as pessoas que o chefe da guarda, Nabuzardã, tinha deixado com vida juntamente com Godolias, filho de Aicam, neto de Safã. Levaram também o profeta Jeremias com Baruc, filho de Nerias."
,"7":"E, desobedecendo a Javé, foram para o Egipto e chegaram a Táfnis."
,"8":"Em Táfnis, a palavra de Javé foi dirigida a Jeremias:"
,"9":"Toma umas pedras grandes e, na presença dos judeus, enterra essas pedras com massa na praça que fica à entrada do palácio do Faraó, em Táfnis."
,"10":"Em seguida, diz-lhes: Assim diz Javé dos exércitos, o Deus de Israel: Mandarei buscar o meu servo Nabucodonosor, rei da Babilónia, e colocarei o seu trono sobre estas pedras que enterrei. Sobre elas, ele estenderá o seu pavilhão."
,"11":"Ele virá para atacar o Egipto: quem está destinado para a morte, morrerá; quem está destinado para o exílio, será exilado; quem está destinado para a espada, morrerá pela espada."
,"12":"Ele deitará fogo aos templos dos deuses do Egipto, queimá-los-á e levará os deuses para o exílio. Ele vai limpar tudo como o pastor tira os piolhos do seu manto, e sairá dali em paz."
,"13":"Quebrará os obeliscos do templo do Sol e incendiará os templos de todos os deuses do Egipto."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Palavra que Javé dirigiu a Jeremias a respeito dos judeus que moravam no Egipto, em Magdol, em Táfnis, em Mênfis e na região de Patros:"
,"2":"Assim diz Javé dos exércitos, o Deus de Israel: Vós mesmos vistes toda a desgraça que Eu fiz cair sobre Jerusalém e sobre as outras cidades de Judá. Hoje elas estão mortas, sem nenhum habitante."
,"3":"Isto aconteceu por causa de todo o mal que eles fizeram, irritando-Me, queimando incenso e prestando culto a deuses estrangeiros, que nem eles, nem vós, nem os vossos antepassados conheceram."
,"4":"Desde o princípio e sem cessar enviei-vos os meus servos, os profetas, para vos dizer: «Não façais essas abominações que Eu odeio»."
,"5":"Mas eles não ouviram e nem quiseram prestar atenção, para não terem que voltar atrás da sua maldade e para não deixarem de queimar incenso aos deuses estrangeiros."
,"6":"Então a minha ira e o meu furor alastraram como o fogo pelas cidades de Judá e pelas ruas de Jerusalém, e elas transformaram-se num deserto e numa desolação até ao dia de hoje."
,"7":"Agora, assim diz Javé dos exércitos, o Deus de Israel: porque cometeis tão grande mal contra vós mesmos? Vós fazeis acabar homens, mulheres, crianças e bebés em Judá. Deste modo não vai ficar nenhum sobrevivente entre vós,"
,"8":"porque Me provocais com a obra das vossas mãos, queimando incenso a deuses estrangeiros neste país do Egipto, onde morais. Assim, estais a trabalhar para o próprio extermínio e a transformar-vos em maldição e vergonha para todas as nações do mundo."
,"9":"Já vos esquecestes dos pecados dos vossos antepassados, dos reis de Judá, das vossas autoridades, dos vossos pecados e dos pecados das vossas mulheres? Vós cometestes esses pecados pelo país de Judá e pelas ruas de Jerusalém. Já vos esquecestes?"
,"10":"E, até hoje, ninguém baixou a cabeça, ninguém teve medo, ninguém começou a andar de acordo com a lei e os preceitos que vos dei a vós e aos vossos antepassados."
,"11":"Por isso, assim diz Javé dos exércitos, o Deus de Israel: Volto a minha face contra vós para a desgraça, para exterminar totalmente Judá."
,"12":"Tomarei o resto de Judá que se obstinou em ir morar no Egipto, e todos eles, pequenos e grandes, morrerão no Egipto, derrubados pela espada e consumidos pela fome. Morrerão pela espada e pela fome e tornar-se-ão uma coisa maldita, espantosa, desprezível e vergonhosa."
,"13":"Castigarei os que moram no Egipto, como castiguei Jerusalém: com a espada, a fome e a peste."
,"14":"Desse resto de Judá que foi para o Egipto, ninguém conseguirá sobreviver, ninguém escapará, ninguém conseguirá voltar para a terra de Judá, à qual anseiam voltar para lá viverem. Não voltarão, a não ser alguns fugitivos."
,"15":"Os homens que sabiam que as suas mulheres queimavam incenso a deuses estrangeiros e todas as mulheres que estavam presentes, uma grande multidão, e todo o povo que morava no país do Egipto e em Patros, disseram a Jeremias:"
,"16":"«Nenhum de nós vai obedecer ao que acabaste de nos dizer em nome de Javé."
,"17":"Nós faremos aquilo que prometemos: queimaremos incenso à rainha do céu e derramaremos vinho em sua honra como fazíamos nós e os nossos antepassados, os nossos reis e os nossos chefes nas cidades de Judá ou nas ruas de Jerusalém, quando nos fartávamos de pão, éramos felizes e não conhecíamos a desgraça."
,"18":"Pois quando deixámos de queimar incenso à rainha do céu e de derramar vinho em sua honra, começou a faltar tudo, e nós morremos pela espada e pela fome»."
,"19":"As mulheres disseram: «Quando queimamos incenso à rainha do céu e derramamos vinho em sua honra, é porventura sem o consentimento dos nossos maridos que fazemos bolos com a figura dela e derramamos vinho em sua honra?»"
,"20":"A todo o povo que lhe tinha respondido desta forma, homens ou mulheres, assim disse Jeremias:"
,"21":"«Será que Javé não Se lembra e não tem na mente todo o incenso que queimáveis nas cidades de Judá e nas ruas de Jerusalém, exactamente como faziam os vossos antepassados, reis, chefes e todo o povo?"
,"22":"Javé não pôde suportar mais tempo a maldade que fazíeis, as abominações que praticáveis. Por isso, o país converteu-se em ruína, espanto e maldição, sem nenhum habitante, até ao dia de hoje."
,"23":"Queimastes incenso e pecastes contra Javé, desobedecendo a Javé, não procedendo conforme a sua Lei, os seus preceitos e ordens; por isso é que vos aconteceu esta desgraça, que dura até ao dia de hoje»."
,"24":"Jeremias disse também a todo o povo, especialmente às mulheres: «Ouvi a palavra de Javé, todo o povo de Judá que está no Egipto:"
,"25":"Assim diz Javé dos exércitos, o Deus de Israel: Vós e as vossas mulheres não só falastes, mas também fizestes com as vossas próprias mãos o que dissestes: 'Nós cumpriremos os votos que fizemos de queimar incenso à rainha do céu e de derramar vinho em sua honra'. Mantende, pois, a promessa e cumpri o voto."
,"26":"Contudo, ouvi a palavra de Javé, judeus que morais no Egipto: Eu juro pelo meu Nome grandioso, diz Javé, que nenhum judeu, em todo o país do Egipto, voltará a invocar o meu Nome, dizendo: 'Pela vida do Senhor Javé'."
,"27":"Eu vigiá-los-ei para seu mal e não para seu bem; e todo o judeu que morar no Egipto vai morrer pela espada e pela fome, até acabarem todos."
,"28":"Um pequeno número que escapar da espada voltará do Egipto para o país de Judá. Então o resto de Judá que foi para o Egipto saberá qual é a palavra que se realizará, se a deles ou a minha."
,"29":"Para saberdes que as minhas palavras de ameaça contra vós prevalecerão e que vos castigarei neste país - oráculo de Javé - este será para vós o sinal:"
,"30":"Assim diz Javé: Eu entregarei o Faraó Hofra, rei do Egipto, nas mãos dos seus inimigos, daqueles que o querem matar, assim como entreguei Sedecias, rei de Judá, nas mãos de Nabucodonosor, rei da Babilónia, que era seu inimigo e o queria matar»."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Palavra que o profeta Jeremias disse a Baruc, filho de Nerias, quando este escrevia num pergaminho as palavras ditadas por Jeremias, no quarto ano de Joaquim, filho de Josias, rei de Judá:"
,"2":"Assim te diz Javé, o Deus de Israel, ó Baruc:"
,"3":"Tu disseste: «Pobre de mim! Javé acrescenta dor à minha dor! Estou cansado de gemer e não tenho descanso!»"
,"4":"Eis o que dirás a Baruc: Assim diz Javé: Eu derrubo o que Eu mesmo construí, arranco o que Eu mesmo plantei, e isto em toda a Terra."
,"5":"E pedes para ti grandes coisas? Não as peças, pois Eu vou enviar uma desgraça para toda a gente - oráculo de Javé. Quanto a ti, porém, dar-te-ei a vida como despojo, em qualquer lugar para onde fores."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Palavra de Javé dirigida ao profeta Jeremias sobre as nações."
,"2":"Contra o Egipto. Contra o exército do Faraó Necao, rei do Egipto, que esteve em Carquemis, nas margens do rio Eufrates, onde foi derrotado por Nabucodonosor, rei da Babilónia, no quarto ano de Joaquim, filho de Josias, rei de Judá:"
,"3":"Preparai o escudo pequeno e o grande, e avançai para a guerra."
,"4":"Cavaleiros, selai os cavalos e montai. Apresentai-vos com os capacetes, afiai as lanças, vesti a armadura."
,"5":"Por que razão os vi a todos apavorados e em fuga? Os seus guerreiros foram derrotados e fogem sem olhar para trás. O terror está em toda a parte - oráculo de Javé."
,"6":"O mais veloz não escapa, nem foge o mais valente. Foi lá no Norte, à beira do rio Eufrates, que eles tropeçaram e caíram."
,"7":"Quem é este que sobe como o rio Nilo e como um rio de águas agitadas?"
,"8":"É o Egipto que sobe como o Nilo e como um rio de águas agitadas. Ele diz: «Eu vou subir e cobrir a terra; vou arrasar cidades e os seus habitantes»."
,"9":"Vamos, cavalos; depressa com os carros; que partam os guerreiros; etíopes e líbios armados de escudo, e ludianos que retesam o arco."
,"10":"É hoje o dia do Senhor Javé dos exércitos: dia de vingança, para se vingar dos seus inimigos. A espada devora, fica saciada e embriaga-se de sangue, porque isto é um sacrifício para o Senhor Javé dos exércitos, no país do Norte, à beira do rio Eufrates."
,"11":"Vai a Galaad buscar bálsamo, jovem filho do Egipto; não adianta multiplicar remédios, não há cura para o teu mal."
,"12":"As nações souberam da tua desonra, os teus gritos de dor encheram o mundo. Um soldado tropeçou noutro soldado e ambos caíram."
,"13":"Palavra que Javé dirigiu ao profeta Jeremias quando Nabucodonosor, rei da Babilónia, veio para derrotar o país do Egipto."
,"14":"Anunciai no Egipto, levai a notícia a Magdol, contai tudo em Mênfis e Táfnis. Dizei: «Levanta-te e prepara-te, porque a espada está devorando tudo ao redor»."
,"15":"Porque é que Ápis fugiu e o teu touro sagrado não resiste? Foi porque Javé o derrubou."
,"16":"Ele multiplicou os que tropeçam, um cai por cima do outro. E gritam: «De pé! Voltemos para o nosso povo, para a nossa terra natal, longe da espada mortífera»."
,"17":"Será dado ao Faraó, rei do Egipto, o nome de Trovão-fora-de-hora."
,"18":"Eu juro por Mim mesmo - oráculo do Rei, que Se chama Javé dos exércitos: Alguém chegará, tão certo como o Tabor estar entre as montanhas e o monte Carmelo à beira-mar."
,"19":"Prepara a bagagem para o exílio, habitante do Egipto, porque Mênfis será transformada em deserto, será devastada e ficará sem moradores."
,"20":"O Egipto parecia uma novilha bonita, mas um moscardo veio do Norte e pousou sobre ela."
,"21":"Os seus soldados contratados pareciam novilhos de estábulo, mas também eles voltaram as costas e fugiram todos juntos, não resistiram, porque chegou para eles o dia da desgraça, a hora do seu castigo."
,"22":"A sua voz é como a da serpente que sibila, porque avançam em bloco; e avançam contra ela como lenhadores com machados."
,"23":"Cortam a sua floresta onde ninguém penetrava - oráculo de Javé. São mais numerosos que gafanhotos, ninguém os pode contar."
,"24":"Foi derrotada a capital do Egipto e entregue ao povo do Norte."
,"25":"Javé dos exércitos, o Deus de Israel, diz: Eu castigarei o deus Amon de Tebas, o Egipto com os seus deuses e reis, o Faraó e todos os que nele confiam."
,"26":"Vou entregá-los nas mãos daqueles que os querem matar, Nabucodonosor, rei da Babilónia, e os seus ministros. Depois disto, porém, o Egipto será habitado de novo, como nos tempos antigos - oráculo de Javé."
,"27":"Não tenhas medo, meu servo Jacob; não te apavores, Israel! Eu vou trazer-te são e salvo do país longínquo, e a tua descendência voltará do exílio. Jacob voltará e viverá tranquilo, em paz, sem que o perturbem."
,"28":"Não tenhas medo, meu servo Jacob - oráculo de Javé - porque Eu estou contigo: vou arrasar todas as nações por onde te espalhei. Não te vou aniquilar. Vou castigar-te com justiça, mas não te deixarei sem castigo."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Palavra de Javé ao profeta Jeremias contra os filisteus, antes de o Faraó ter atacado a cidade de Gaza."
,"2":"Assim diz Javé: Olha para as águas que se avolumam no Norte: elas tornam-se uma torrente que transborda, alagando o país e tudo o que nele existe, as cidades e seus habitantes. Todos gritam e a população do país geme,"
,"3":"ouvindo o tropel dos cavalos dos guerreiros mais valentes do inimigo, ouvindo o rumor dos seus carros, o barulho das suas rodas. Os pais, com as mãos fracas, já não cuidam dos seus filhos,"
,"4":"por causa do dia que chegou para destruir todos os filisteus, para cortar de Tiro e Sidónia todo o resto que os possa socorrer: Javé destrói os filisteus, o resto da ilha de Creta."
,"5":"Em Gaza rapam a cabeça e Ascalon emudece. E tu, resto dos enacim, até quando vais ferir o próprio corpo?"
,"6":"Espada de Javé, até quando estarás sem descanso? Recolhe-te na bainha, pára e acalma-te!"
,"7":"Como é que ela pode descansar, se Javé lhe deu uma ordem contra Ascalon e o litoral?"
}`)
	CurrentBook.AddChapter(48, `{
"1":"Contra Moab. Assim diz Javé dos exércitos, o Deus de Israel: Pobre do monte Nebo, que foi arrasado; Cariataim foi vergonhosamente destruída; a fortaleza vergonhosamente abatida!"
,"2":"Acabou a fama de Moab! Em Hesebon conspiraram contra ela: «Vamos eliminar esta cidade do meio das nações». Também tu, Madmena, serás reduzida ao silêncio: a espada persegue-te."
,"3":"De Oronaim ouve-se um grito: «Devastação! Um desastre imenso!»"
,"4":"Moab foi esmagada: as suas crianças fazem ouvir um grito."
,"5":"Chorando, sobe-se a ladeira de Luit, e na descida de Oronaim ouvem-se gritos de derrota."
,"6":"Fugi, salvai a vida, como o burro selvagem no deserto."
,"7":"Porque puseste a confiança nas tuas obras e tesouros, também tu irás presa, e Camos irá para o exílio juntamente com os seus sacerdotes e chefes."
,"8":"Virá um devastador contra todas as cidades, e nenhuma escapará. O vale será destruído e o planalto será arrasado, conforme diz Javé."
,"9":"Dai asas a Moab, para que possa voar. As suas cidades tornar-se-ão um deserto, porque ninguém habitará nelas."
,"10":"Maldito aquele que cumpre com negligência a missão que Javé lhe deu; maldito aquele que poupa a sua espada de derramar sangue."
,"11":"Desde a juventude, Moab viveu tranquilo, descansava como o vinho na borra, sem nunca ser mudado de uma vasilha para outra. Moab nunca foi levado para o exílio; por isso, conservava o seu sabor, e o seu perfume não mudava."
,"12":"Chegarão dias - oráculo de Javé - em que lhe enviarei gente para mudar Moab de vasilha. Esvaziarão as antigas vasilhas e quebrá-las-ão."
,"13":"Então Moab ficará decepcionado com o seu deus Camos, como a casa de Israel se decepcionou com Betel, na qual confiava."
,"14":"Como é que podeis dizer: «Nós somos valentes, prontos para a guerra»?"
,"15":"Moab será destruído, as suas cidades foram invadidas e a flor da sua juventude desceu ao matadouro - oráculo do Rei, que se chama Javé dos exércitos."
,"16":"Está próxima a ruína de Moab, a sua desgraça vem depressa."
,"17":"Chorem por ele todos os seus vizinhos, todos aqueles que o conhecem pelo nome. E digam: «Como pôde quebrar uma vara tão forte, um bastão tão glorioso?»"
,"18":"Desce da tua glória e senta-te no chão árido, povo que moras em Dibon, pois subiu contra ti aquele que devastou Moab, e destruirá as tuas fortalezas."
,"19":"Pára ao longo do caminho e observa, habitante de Aroer: a quem fugiu ou escapou, pergunta o que que aconteceu."
,"20":"Moab está envergonhado, porque foi destruído. Gritai e clamai, anunciai sobre o rio Arnon que Moab foi destruído."
,"21":"O julgamento veio contra a Planície, contra Helon, Jasa, Mefaat,"
,"22":"Dibon, Nebo, Bet-Deblataim,"
,"23":"Cariataim, Bet-Gamul, Maon,"
,"24":"Cariot, Bosra, contra todas as cidades do país de Moab, tanto as mais próximas como as mais distantes."
,"25":"Abateram a força de Moab, quebraram-lhe os braços - oráculo de Javé."
,"26":"Embriagai Moab, porque se levantou contra Javé. Moab cairá sobre o seu próprio vómito, tornando-se motivo de escárnio."
,"27":"Será que Israel também não foi motivo de escárnio para ti? Ou será que Israel foi encontrado no meio de ladrões, para que abanes a cabeça todas as vezes que falas dele?"
,"28":"Habitantes de Moab, abandonai as cidades, ide morar nos rochedos! Sede como a pomba que faz o ninho à beira dos precipícios."
,"29":"Ouvimos falar da soberba de Moab, do seu orgulho sem medida, da sua soberba, vaidade e arrogância, e da altivez do seu coração."
,"30":"Conheço a sua arrogância - oráculo de Javé - a inconsistência das suas tagarelices e o vazio das suas obras."
,"31":"Por isso, eu choro por Moab, grito de dor por Moab inteiro, gemo pelos habitantes de Quir-Hares."
,"32":"Choro por ti mais do que chorei por Jazer, ó vinha de Sábama. Os teus ramos atingiam o mar e chegavam até Jazer. O invasor caiu sobre a tua colheita e sobre as uvas que apanhaste."
,"33":"A alegria e a animação desapareceram dos pomares e do país de Moab. Acabei com o vinho dos tonéis, já não há mais ninguém que pise uvas, já se não ouve o canto de alegria."
,"34":"Os gritos de Hesebon e Eleale chegam até Jasa. O grito vai de Segor até Oronaim e Eglat-Salisia, pois até as águas de Nemrim se tornaram um deserto."
,"35":"Farei desaparecer em Moab - oráculo de Javé - quem sacrifica nos lugares altos e aquele que queima incenso aos seus deuses."
,"36":"Por isso o meu coração chora por Moab como flauta, chora como flauta pelos habitantes de Quir-Hares, pois foi destruído tudo o que ela acumulou."
,"37":"Sim, todas as cabeças foram rapadas e todas as barbas foram cortadas, todos feriram as próprias mãos, todos se vestiram de luto."
,"38":"Em todos os terraços de Moab e em todas as praças estão todos de luto, pois Eu quebrei Moab como se fosse uma vasilha inútil - oráculo de Javé."
,"39":"Como está arrasado! Chorai! Como Moab voltou vergonhosamente as costas! Como Moab se tornou motivo de zombaria e espanto para os vizinhos!"
,"40":"Assim diz Javé: O inimigo voa como a águia, estendendo as asas sobre Moab:"
,"41":"tomou as suas cidades, capturou as suas fortalezas. Nesse dia, o ânimo dos guerreiros de Moab será como o ânimo da mulher em dores de parto."
,"42":"Moab foi arrasado para não ser mais um povo, pois ele quis ser grande diante de Javé."
,"43":"Terror, armadilha e laço é tudo o que te espera, morador de Moab - oráculo de Javé."
,"44":"Quem fugir do terror, cairá na armadilha; se conseguir sair da armadilha, será apanhado pelo laço, pois Eu farei vir sobre Moab o ano do seu castigo - oráculo de Javé."
,"45":"Os fugitivos pararam perto de Hesebon, já sem forças, pois um fogo subia de Hesebon, labaredas saíam do palácio de Seon. Queimavam as têmporas de Moab e o crânio dos homens turbulentos."
,"46":"Ai de ti, Moab! Estás perdido, povo do deus Camos, pois os teus filhos foram levados para o cativeiro, e as tuas filhas para a escravidão."
,"47":"Mas nos últimos dias mudarei a sorte de Moab - oráculo de Javé. Aqui termina o julgamento de Moab."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Contra os amonitas. Assim diz Javé: Será que Israel não tem filhos, será que não tem herdeiros? Por que razão o deus Melcom se apossou das terras de Gad e instalou o seu povo nas cidades?"
,"2":"Chegarão dias - oráculo de Javé - em que farei ouvir gritos de guerra em Rabá, capital de Amon; a cidade tornar-se-á um montão de ruínas e os outros povoados serão destruídos pelo fogo. Então Israel despojará os que o despojaram, diz Javé."
,"3":"Geme, Hesebon, pois o devastador está a chegar. Gritai de dor, filhas de Rabá, vesti-vos de luto, batei no peito, caminhai sobre as ruínas, pois o deus Melcom irá para o exílio juntamente com os seus sacerdotes e chefes."
,"4":"Porque te orgulhas do teu vale, cidade rebelde? Confiada nos teus tesouros, dizias: «Quem virá contra mim?»"
,"5":"Vou mandar contra ti o terror - oráculo do Senhor Javé dos exércitos - o terror que virá de todos os lados: cada um fugirá para seu lado e ninguém reagrupará os fugitivos."
,"6":"Depois disto, porém, mudarei a sorte dos amonitas - oráculo de Javé."
,"7":"Contra Edom. Assim diz Javé dos exércitos: Será que já não existe sabedoria em Temã, será que desapareceu o conselho dos homens prudentes e deitaram fora a sabedoria?"
,"8":"Fugi, parti, escondei-vos, moradores de Dadã, porque eu trarei para Esaú a desgraça que lhe cabe, a hora do seu castigo."
,"9":"Se os vindimadores vierem ter contigo, não deixarão nenhum cacho; se os ladrões vierem de noite, saquearão à vontade."
,"10":"Porque Eu pretendo sondar Esaú e descobrir os seus esconderijos; e ele não poderá esconder-se. A sua raça acabou, os seus parentes e vizinhos já não existem."
,"11":"Abandona os teus órfãos, que Eu fá-los-ei viver; as tuas viúvas podem confiar em Mim."
,"12":"Porque assim diz Javé: Se aqueles que não mereciam beber este cálice acabaram por bebê-lo, será que tu escaparás a este castigo? Não! Tu não ficarás impune, mas também o beberás."
,"13":"Juro por Mim mesmo - oráculo de Javé - que a tua capital Bosra será objecto de espanto e zombaria; será ruína e maldição, e todas as tuas cidades se transformarão em ruína eterna."
,"14":"Eu ouvi uma mensagem de Javé, um mensageiro foi enviado às nações: «Reuni-vos e marchai contra Edom! Levantai-vos para a guerra»."
,"15":"Eu tornar-te-ei pequeno no meio das nações e desprezado entre os homens."
,"16":"O terror que provocas e a arrogância do teu coração enganaram-te: moras nos cumes da rocha e agarras-te aos picos da montanha! Mesmo que faças o teu ninho no alto como a águia, Eu precipitar-te-ei de lá de cima - oráculo de Javé."
,"17":"Edom tornar-se-á objecto de espanto: todos os que por lá passarem ficarão espantados e assobiarão ao verem as suas feridas."
,"18":"Será como na destruição de Sodoma e Gomorra e cidades vizinhas, diz Javé: «Ali ninguém mais vai morar, ali ninguém mais se vai hospedar»."
,"19":"Como leão que sobe do deserto do Jordão para os pastos verdes, assim, de repente, os expulsarei dali e, no seu lugar, colocarei quem Eu escolher. Quem é como Eu? Quem poderá desafiar-Me? Qual pastor Me poderá resistir? "
,"20":"Por isso, escutai a decisão de Javé, decisão que Ele tomou sobre Edom; ouvi o plano que Ele traçou contra os habitantes de Temã: As menores ovelhas serão arrastadas para longe e as pastagens desaparecerão diante delas!"
,"21":"Com o barulho da sua queda, a terra vai tremer, e o seu grito de dor será ouvido no Mar Vermelho."
,"22":"O inimigo voa como a águia, estendendo as suas asas sobre Bosra. Nesse dia, o ânimo dos guerreiros de Edom será como o ânimo da mulher em dores de parto."
,"23":"Contra Damasco. Emat e Arfad estão confusas, porque ouviram uma notícia terrível. Elas agitam-se de aflição como o mar, e não podem acalmar-se."
,"24":"Damasco desfalece e prepara a fuga; o medo apodera-se dela: está possuída de angústia e dores, como a mulher que dá à luz."
,"25":"Está abandonada a cidade famosa, a capital da alegria!"
,"26":"Nesse dia, os seus jovens cairão pelas praças e a morte calará os seus guerreiros - oráculo de Javé dos exércitos."
,"27":"Deitarei fogo às muralhas de Damasco, para incendiar os palácios de Ben-Adad."
,"28":"Contra Cedar e os reinos de Hasor, que Nabucodonosor, rei da Babilónia, derrotou. Assim diz Javé: Vamos! À luta contra Cedar! Vamos destruir os orientais."
,"29":"Tomai as suas tendas e rebanhos, lonas e objectos, carregai os seus camelos e gritai contra eles: «Terror de todos os lados!»"
,"30":"Fugi, correi velozmente, escondei-vos bem, moradores de Hasor - orá-culo de Javé - pois Nabucodonosor, rei da Babilónia, tomou uma decisão, traçou um plano contra vós:"
,"31":"«Vamos! À guerra contra essa nação tranquila, que vive tão segura. Eles não têm portas nem trancas e vivem isolados."
,"32":"Os seus camelos serão uma presa e os seus numerosos rebanhos um despojo». Espalharei por todos os ventos essas têmporas rapadas, e de todos os lados lhes vou levar a ruína - oráculo de Javé."
,"33":"Hasor tornar-se-á abrigo de chacais e deserto para sempre. Ali ninguém mais vai habitar, nenhum homem vai morar nela."
,"34":"Palavra de Javé contra Elam, dirigida ao profeta Jeremias no início do reinado de Sedecias, rei de Judá:"
,"35":"Assim diz Javé dos exércitos: Vê! Eu vou quebrar o arco de Elam e os melhores dos seus soldados."
,"36":"Vou trazer sobre Elam quatro ventos, dos quatro cantos do céu. Espalharei o seu povo na direcção desses ventos, e não haverá nação no mundo onde não se encontre alguém expulso de Elam."
,"37":"Farei que os elamitas tremam diante dos seus inimigos, diante daqueles que querem matá-los. Vou trazer a desgraça sobre eles, o furor da minha ira - oráculo de Javé. Mandarei a espada persegui-los até acabar com eles."
,"38":"Colocarei o meu trono em Elam e nela exterminarei reis e chefes - oráculo de Javé."
,"39":"Mas, nos últimos dias, mudarei a sorte de Elam - oráculo de Javé."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Palavra de Javé contra a Babilónia, terra dos caldeus, por meio do profeta Jeremias:"
,"2":"Anunciai entre as nações, fazei ouvir, levantai a bandeira, fazei ouvir, não vos caleis; dizei: «Babilónia foi tomada, o deus Bel fracassou, Merodac foi arrasado, os seus ídolos foram derrotados e as suas imagens destruídas»."
,"3":"Porque uma nação do Norte avança contra Babilónia e transformará o país num lugar arrasado, onde não mora ninguém. Homens e animais, todos fugirão e desaparecerão."
,"4":"Nesses dias e nesse tempo - oráculo de Javé - os filhos de Israel virão a chorar juntamente com os filhos de Judá, à procura de Javé, seu Deus."
,"5":"Perguntarão por Sião, e a face deles estará voltada para ela: «Vinde! Vamos fazer com Javé uma aliança eterna, que jamais será esquecida!»"
,"6":"O meu povo era um rebanho perdido, que os seus pastores deixavam extraviar pelos montes; iam dos montes para as colinas, e esqueceram o seu redil."
,"7":"E quem encontrava as minhas ovelhas, agarrava-as para as comer, dizendo: «Nós não somos culpados, foram eles que pecaram contra Javé, morada da Justiça, a esperança dos seus antepassados!»"
,"8":"Fugi da Babilónia, do país dos caldeus. Saí como cabritos, à frente do rebanho."
,"9":"Pois Eu farei levantar e vir contra Babilónia um grupo de nações poderosas, vindas do Norte, organizadas contra ela; e tomarão o país pelo Norte. As suas flechas são como de guerreiro bem treinado, que não volta de mãos vazias."
,"10":"Os caldeus tornar-se-ão objecto de saque, e os seus saqueadores fartar-se-ão - oráculo de Javé."
,"11":"Juntai-vos, triunfai, devastadores da minha herança! Pulai como novilhas no pasto, relinchai como garanhões."
,"12":"A vossa mãe ficará envergonhada, aquela que vos gerou está coberta de vergonha. Olhai! É a última das nações, é um lugar descampado, seco e deserto."
,"13":"Por causa do furor de Javé, nunca mais será habitada: o país inteiro será uma ruína. E quem passar por Babilónia, assobiará, assustado com tanta desgraça."
,"14":"Arqueiros todos, estai a postos para atacar Babilónia por todos os lados. Atirai contra ela, sem poupar as vossas flechas, pois ela pecou contra Javé."
,"15":"Gritai contra ela por todos os lados. Ela já ergueu as mãos: os seus pilares caíram, as suas muralhas foram derrubadas, porque esta é a vingança de Javé: vingai-vos dela. Fazei dela o mesmo que ela fez."
,"16":"Eliminai da Babilónia o lavrador que semeia e o que empunha a foice no tempo da ceifa. Diante da espada devastadora, cada um volte para o seu povo, cada qual fuja para a sua terra."
,"17":"Israel era uma ovelha desgarrada, que os leões afugentaram. Quem primeiro a devorou foi o rei da Assíria; depois, Nabucodonosor, rei da Babilónia, quebrou-lhe os ossos."
,"18":"Por isso, assim diz Javé dos exércitos, Deus de Israel: Olhai! Eu vou castigar o rei da Babilónia e o seu país, como castiguei o rei da Assíria."
,"19":"Farei voltar Israel para a sua pastagem, a fim de pastar no Carmelo e em Basã; ele ficará saciado na montanha de Efraim e em Galaad."
,"20":"Nesses dias e nesse tempo - oráculo de Javé - procurarão a culpa de Israel, mas ela já não existirá; procurarão os pecados de Judá, mas não serão encontrados; porque Eu perdoarei tudo aos que Eu mesmo tiver deixado como resto."
,"21":"Avançai contra o país de Merataim, subi contra ele e contra os habitantes de Facud. Massacrai-os, exterminai-os até ao último - oráculo de Javé. Fazei tudo conforme vos ordenei."
,"22":"Barulho de guerra no país. É uma grande derrota!"
,"23":"Como foi quebrado e destruído o martelo de toda a terra? Como é que Babilónia se tornou espanto entre as nações?"
,"24":"Preparei uma armadilha para ti, Babilónia, e ficarás presa sem te aperceberes. Foste surpreendida e dominada, porque te rebelaste contra Javé."
,"25":"Javé abriu o seu arsenal para dele tirar as armas da sua ira, pois há um serviço para o Senhor Javé dos exércitos na terra dos caldeus."
,"26":"Acorrei a ela de todas as partes, abri os celeiros, amontoai os seus feixes e destruí tudo, sem deixar nada."
,"27":"Matai todos os seus touros: sejam conduzidos ao matadouro. Ai deles! Chegou o dia e a hora do seu castigo."
,"28":"Ouvi os fugitivos que escaparam da Babilónia! Eles levam a Sião a notícia da vingança de Javé, nosso Deus, a vingança do seu Templo."
,"29":"Chamai à Babilónia os arqueiros, aqueles que sabem manejar o arco. Fechai o cerco: que ninguém escape. Castigai os seus actos; fazei com ela o mesmo que ela fez, porque foi arrogante contra Javé, contra o Deus santo de Israel."
,"30":"Por isso, nesse dia, os seus jovens ficarão caídos pelas praças, e a morte vai calar os seus guerreiros - oráculo de Javé."
,"31":"Aqui estou Eu contra ti, ó Arrogante, - oráculo de Javé dos exércitos - pois chegou o dia, a hora do teu castigo."
,"32":"A Arrogante tropeçará, cairá, e ninguém a levantará. Deitarei fogo às suas cidades para queimar tudo ao redor."
,"33":"Assim diz Javé dos exércitos: Os filhos de Israel e de Judá sofrem juntos a opressão, e aqueles que os levaram para o exílio retêm-nos e recusam-se a soltá-los."
,"34":"Mas o seu redentor é forte: Javé dos exércitos é o seu Nome. Ele cuidará da sua causa, tornará o país tranquilo, abalando os habitantes da Babilónia."
,"35":"Espada contra os caldeus - oráculo de Javé - contra os habitantes da Babilónia; contra os seus chefes e contra os seus sábios."
,"36":"Espada contra os seus adivinhos, para que enlouqueçam. Espada contra os seus valentes, para que se amedrontem."
,"37":"Espada contra os seus cavalos e carros, e contra toda a multidão que ali se encontra, para que fiquem como as mulheres. Espada contra os seus tesouros, para que sejam saqueados."
,"38":"Espada contra os seus canais, para que fiquem secos, porque é um país de ídolos, que se gloria dos seus espantalhos."
,"39":"Por isso, ali habitarão chacais, hienas e avestruzes; nunca mais será habitada nem povoada de geração em geração."
,"40":"Como quando Javé destruiu Sodoma e Gomorra e cidades vizinhas - oráculo de Javé - ninguém mais ali habitará, nem homem algum nela residirá."
,"41":"Olhai! Um povo vem do Norte, uma grande nação e reis numerosos surgem das extremidades da Terra:"
,"42":"armados de arcos e dardos, são violentos e sem compaixão. Os seus gritos ressoam como o mar, avançam a cavalo, formados em ordem de batalha, como se fossem um só homem, contra ti, Babilónia."
,"43":"Ao ouvir a sua fama, o rei da Babilónia acovarda-se; cada vez em maior aflição, sofre como se estivesse dando à luz."
,"44":"Como leão que sobe da planície do Jordão para pastos verdes, assim, de repente, Eu os ex-pulsarei da Babilónia; e, no seu lugar, colocarei quem Eu escolher. Quem é como Eu? Quem poderá desafiar-Me? Qual o pastor que Me resistirá?"
,"45":"Por isso, escutai a decisão de Javé, decisão que Ele tomou sobre a Babilónia; escutai o plano que Ele traçou contra a terra dos caldeus: As menores ovelhas serão arrastadas para longe, e as pastagens desaparecerão diante delas!"
,"46":"Com o barulho da sua queda, a terra vai tremer, e o seu grito de dor será ouvido pelas nações."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Assim diz Javé: Vou enviar contra a Babilónia e os caldeus um vento destruidor."
,"2":"Mandarei contra a Babilónia abanadores que a abanarão e esvaziarão o seu território, porque de todos os lados virão contra ela, no dia da desgraça."
,"3":"Que o arqueiro não deponha o arco nem tire a couraça. Não tenhais compaixão dos mais jovens; exterminai o seu exército."
,"4":"Feridos estarão caídos pelo país dos caldeus, espalhados pelas ruas da cidade,"
,"5":"porque Israel e Judá não são viúvas do seu Deus, Javé dos exércitos, enquanto o país dos caldeus está cheio de delitos contra o Santo de Israel."
,"6":"Fugi da Babilónia; salve-se quem puder! Não morrais pelo seu crime, porque é a hora da vingança de Javé, é o pagamento que a Babilónia merece."
,"7":"Nas mãos de Javé, a Babilónia era uma taça de ouro, que embriagava o mundo inteiro. As nações beberam do seu vinho e, por isso, enlouqueceram."
,"8":"De repente, a Babilónia caiu e quebrou-se. Chorai por ela, ponde bálsamo na sua ferida, para ver se sara."
,"9":"Nós tratámos Babilónia, mas ela não sara. Vamos deixá-la! Vamos cada um para a nossa terra, pois a sentença contra Babilónia chegou até ao céu e sobe até às nuvens."
,"10":"Javé fez brilhar os nossos direitos; vamos contar em Sião tudo o que fez Javé, nosso Deus."
,"11":"Afiai as flechas e enchei com elas as aljavas. Javé instigou os reis dos Medos, porque Ele quer destruir Babilónia: é a vingança de Javé, a vingança do seu Templo."
,"12":"Levantai a bandeira contra as muralhas da Babilónia, reforçai a guarda, colocai sentinelas, preparai armadilhas, porque, assim como planeou, Javé executará tudo o que disse contra os moradores da Babilónia."
,"13":"Moradora das margens dos grandes canais, rica em tesouros, chegou o teu fim, o limite da tua existência."
,"14":"Javé dos exércitos jura por sua própria vida: «Eu vou enchê-la de homens como gafanhotos, e eles cantarão vitória sobre ti»."
,"15":"Com o seu poder, Javé fez a Terra; com a sua sabedoria, firmou o mundo; e, com a sua inteligência, estendeu o céu."
,"16":"Ao barulho do seu trovão, as águas agitam-se no céu, no horizonte Ele faz subir as nuvens; produz raios para derramar a chuva e faz sair o vento dos seus reservatórios."
,"17":"Todo o homem se torna ignorante e não entende nada; o ourives fica desiludido com o seu ídolo: a sua estátua é de mentira, nela não existe vida."
,"18":"Os ídolos são vazios e ilusórios; na hora do acerto de contas serão destruídos."
,"19":"Não é assim a Herança de Jacob, pois Ele formou todas as coisas, e Israel é a tribo da sua herança. E o seu nome é Javé dos exércitos."
,"20":"Tu, Babilónia, foste o martelo, a minha arma de guerra: contigo martelei nações, contigo destruí reinos,"
,"21":"contigo martelei o cavalo e o cavaleiro, contigo martelei o carro e o cocheiro,"
,"22":"contigo martelei homens e mulheres, contigo martelei velhos e jovens, contigo martelei rapazes e raparigas,"
,"23":"contigo martelei pastores e rebanhos, contigo martelei lavradores e juntas de bois, contigo martelei governadores e prefeitos."
,"24":"Mas retribuirei à Babilónia e a todos os caldeus, bem diante dos vossos olhos, todo o mal que eles fizeram a Sião - oráculo de Javé."
,"25":"Aqui estou contra ti, montanha devastadora, que exterminaste a terra inteira - oráculo de Javé. Levantarei a minha mão contra ti, far-te-ei rolar da altura das rochas, e transformar-te-ei em montanha queimada."
,"26":"Nunca mais tirarão de ti uma pedra angular, nem pedra de alicerce, porque serás transformada em ruína eterna - oráculo de Javé."
,"27":"Erguei a bandeira no mundo, tocai a trombeta entre as nações, convocando os povos para a guerra santa. Convocai contra ela os reinos de Ararat, Meni e Asquenez; nomeai contra ela um general, que os cavalos avancem como gafanhotos espinhosos."
,"28":"Convocai as nações para a guerra santa: os reis da Média com os seus governadores, todos os seus prefeitos com os territórios que eles governam."
,"29":"A terra tremerá e retorcer-se-á quando se cumprir o plano de Javé contra a Babilónia, quando transformar Babilónia num deserto despovoado."
,"30":"Os guerreiros da Babilónia desistem de lutar: estão sentados dentro dos seus quartéis; acabou a valentia, tornaram-se mulheres. As casas da Babilónia foram incendiadas, as suas trancas foram rebentadas."
,"31":"Um correio corre ao encontro do outro, e um mensageiro ao encontro do outro, para levar ao rei da Babilónia a notícia de que a sua cidade foi tomada de todos os lados:"
,"32":"fecharam as passagens, deitaram fogo aos quartéis e os soldados ficaram cheios de pânico."
,"33":"Assim diz Javé dos exércitos, Deus de Israel: A capital da Babilónia é como uma eira no tempo em que é pisada: em breve chegará para ela o tempo da colheita."
,"34":"Nabucodonosor, rei da Babilónia, devorou-me, rapou tudo, deixou-me como um prato limpo; como dragão me engoliu, ficou de barriga cheia e vomitou-me."
,"35":"«Recaia sobre a Babilónia o meu sofrimento e a minha carne ferida», diz o morador de Sião. «Recaia o meu sangue sobre os caldeus», diz Jerusalém."
,"36":"Por isso, assim diz Javé: Aqui estou para defender a tua causa e executar a tua vingança. Secarei o mar da Babilónia e esgotarei as suas fontes,"
,"37":"e então Babilónia tornar-se-á um montão de ruínas, um esconderijo de chacais, motivo de espanto e zombaria, e sem habitantes."
,"38":"Como leões, rugirão em coro, rugirão como crias de leão."
,"39":"Quando estiverem bem quentes, farei com que bebam até se embriagarem e caírem no sono, um sono eterno, para nunca mais acordarem - oráculo de Javé."
,"40":"Farei com que desçam para o matadouro como cordeiros, como carneiros e bodes."
,"41":"Como foi conquistada Babilónia, capturado esse orgulho do mundo! Como a Babilónia se transformou num espanto para as nações!"
,"42":"Parece que o mar subiu até Babilónia, e foi coberta pelas ondas impetuosas."
,"43":"As suas cidades ficaram desoladas como terra seca e deserta, terra que ninguém habita, por onde nenhum mortal passa."
,"44":"Acertarei contas com o deus Bel na Babilónia; tirar-lhe-ei da boca tudo o que engoliu. Nunca mais as nações acorrerão a ela. Até as muralhas da Babilónia cairão."
,"45":"Sai dela, povo meu! Salva-te da ardente ira de Javé."
,"46":"Não desanimeis, nem tenhais medo por causa dos boatos que se ouvem no país. Num ano fez-se ouvir um boato e no ano seguinte outro. Haverá violência no país, um tirano contra outro."
,"47":"Porque chegarão dias em que acertarei contas com os ídolos da Babilónia: o país ficará confuso, e cadáveres ficarão caídos no meio dela."
,"48":"O céu e a terra e o que neles existe clamarão contra a Babilónia, quando do Norte vier sobre ela o destruidor - oráculo de Javé."
,"49":"Babilónia cairá pelas vítimas de Israel, como pela Babilónia caíram vítimas do mundo inteiro."
,"50":"Vós que escapastes à espada, parti, não fiqueis aí parados. Mesmo de longe, invocai a Javé, lembrando-vos de Jerusalém:"
,"51":"«Nós estamos envergonhados, pois ouvimos falar da injúria, e a desonra faz-nos cobrir o rosto, pois estrangeiros chegaram a entrar no lugar mais santo do santuário de Javé»."
,"52":"Por isso, dias virão - oráculo de Javé - em que acertarei contas com os seus ídolos: então em toda a Babilónia haverá feridos a gemer."
,"53":"Mesmo que a Babilónia suba até ao céu, mesmo que ponha a sua fortaleza fora do alcance, lá nas alturas, Eu mandar-lhe-ei destruidores - oráculo de Javé."
,"54":"De Babilónia saem gritos de socorro, uma grande derrota na terra dos caldeus,"
,"55":"porque Javé destrói Babilónia e põe fim aos seus gritos, por mais que as suas ondas retumbem como o oceano e ressoe o barulho das suas vozes."
,"56":"Sim, chegou a destruição para Babilónia: os seus guerreiros serão presos e os seus arcos serão quebrados, porque Javé é um Deus que retribui e lhes dará o seu pagamento."
,"57":"Embriagarei os seus ministros e conselheiros, governadores, prefeitos e militares; eles dormirão um sono eterno, e nunca mais acordarão - oráculo do Rei, cujo nome é Javé dos exércitos."
,"58":"Assim diz Javé dos exércitos: Os muros da imensa Babilónia serão arrancados pela base e as suas altas portas serão devoradas pelo fogo. Os povos trabalharam em vão, e as nações cansaram-se para o fogo."
,"59":"Ordem dada pelo profeta Jeremias a Saraías, filho de Nerias, neto de Maasias, quando Saraías partiu para a Babilónia com Sedecias, rei de Judá, no quarto ano do seu reinado. Saraías era o chefe dos camareiros."
,"60":"Jeremias escreveu num livro todas as desgraças que iriam acontecer a Babilónia, tudo o que foi escrito sobre Babilónia."
,"61":"Depois disse a Saraías: «Quando chegares a Babilónia, lê em voz alta todas estas palavras."
,"62":"Em seguida, dirás: 'Javé, Tu ameaçaste destruir este lugar até o deixares desabitado, sem pessoas nem animais, transformando-o em desolação perpétua'."
,"63":"Quando terminares de ler o livro, atar-lhe-ás uma pedra e lançá-lo-ás ao rio Eufrates,"
,"64":"dizendo: 'Assim se afundará Babilónia, por causa das desgraças que envio contra ela'». Aqui terminam as palavras de Jeremias."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Sedecias tinha vinte e um anos de idade quando começou a reinar. Foi rei em Jerusalém durante onze anos. sua mãe chamava-se Hamital e era filha de Jeremias de Lebna."
,"2":"Ele praticou o que é mau aos olhos de Javé, da mesma forma que o rei Joaquim."
,"3":"Isto aconteceu a Jerusalém e Judá por causa da ira de Javé, a ponto de Javé as expulsar da sua presença. Sedecias revoltou-se contra o rei da Babilónia. "
,"4":"No décimo dia do décimo mês do nono ano do reinado de Sedecias, Nabucodonosor, rei da Babilónia, chegou a Jerusalém com todo o seu exército, acampou perto da cidade e construiu torres de assalto em torno dela."
,"5":"A cidade ficou sitiada até ao décimo primeiro ano do reinado de Sedecias."
,"6":"No nono dia do quarto mês, a fome dominava a cidade e já não havia comida para o cidadão comum."
,"7":"Então foi aberta uma brecha na cidade. Todos os soldados fugiram de noite, pela porta que fica entre as duas muralhas junto ao jardim do rei. Havia caldeus a vigiar a cidade por todos os lados. E os soldados tomaram o caminho do deserto."
,"8":"Mas o exército dos caldeus perseguiu o rei e alcançou Sedecias nos campos de Jericó, enquanto as suas tropas se dispersaram, abandonando-o."
,"9":"Prenderam o rei e levaram-no ao rei de Babilónia, que estava em Rebla, no território de Emat, para que este decretasse a sentença contra ele."
,"10":"O rei de Babilónia matou os filhos de Sedecias diante dos seus olhos. Matou também em Rebla todas as autoridades de Judá."
,"11":"Depois furou os olhos de Sedecias, prendeu-o com algemas e mandou-o para Babilónia, onde o colocou na prisão até à morte."
,"12":"No décimo dia do quinto mês - que corresponde ao décimo nono ano do reinado de Nabucodonosor, rei de Babilónia - chegou a Jerusalém Nabuzardã, funcionário da corte do rei de Babilónia, chefe da guarda."
,"13":"Ele deitou fogo ao Templo de Javé, ao palácio do rei e às casas de Jerusalém, e incendiou todos os palácios."
,"14":"A guarnição do exército dos caldeus, que acompanhava o chefe da guarda, derrubou as muralhas que rodeavam Jerusalém."
,"15":"Nabuzardã, chefe da guarda, mandou para o exílio o que restara do povo na cidade, os que tinham passado para o lado do rei de Babilónia e o resto da multidão."
,"16":"Só deixou ficar uma parte dos pobres da terra como trabalhadores das vinhas e pequenos lavradores."
,"17":"Os caldeus quebraram as colunas de bronze, a bacia, os suportes, tudo o que havia de bronze no Templo de Javé, e levaram o bronze para Babilónia."
,"18":"Levaram também as panelas, pás, facas, aspersórios, e bandejas, enfim, todos os outros objectos de bronze utilizados no culto."
,"19":"O próprio chefe da guarda levou os copos, braseiros, aspersórios, panelas, castiçais, bandejas e cálices, que eram de ouro ou de prata."
,"20":"Não é possível calcular o peso do bronze que tinham esses objectos, que o rei Salomão mandara fazer para o Templo de Javé: as duas colunas de bronze, o mar de bronze com os doze bois que o sustentavam e que também eram de bronze."
,"21":"Cada coluna tinha cerca de oito metros de altura, mais de dois metros e meio de circunferência e oito centímetros de espessura, e era oca."
,"22":"Sobre ela havia um capitel de bronze de dois metros e meio de altura, enfeitado com trançados e romãs ao redor. A outra coluna era igual."
,"23":"Havia noventa e seis romãs nos quatro lados, perfazendo o total de cem romãs em volta do trançado."
,"24":"O chefe da guarda prendeu também o chefe dos sacerdotes, chamado Saraías, o segundo sacerdote, Sofonias, e três porteiros."
,"25":"Da cidade ele prendeu um funcionário do palácio que comandava alguns soldados, sete homens do serviço pessoal do rei, que ainda se achavam na cidade, o escrivão-chefe que alistava os cidadãos no exército, e ainda sessenta homens do povo da região que se encontravam dentro da cidade."
,"26":"Nabuzardã, chefe da guarda, levou-os ao rei da Babilónia que estava em Rebla."
,"27":"E o rei mandou matá-los ali em Rebla, na região de Emat. Assim, Judá foi exilado do seu país."
,"28":"Foi o seguinte o número das pessoas que Nabucodonosor levou para o cativeiro: no sétimo ano do seu reinado, três mil e vinte e três judeus;"
,"29":"no décimo oitavo ano, oitocentos e trinta e duas pessoas;"
,"30":"no vigésimo terceiro ano, o chefe da guarda Nabuzardã levou setecentos e quarenta e cinco judeus. Total: quatro mil e seiscentas pessoas."
,"31":"No trigésimo sétimo ano do exílio de Joaquin, rei de Judá, no vigésimo quinto dia do décimo segundo mês, Evil-Merodac, rei de Babilónia, no ano em que começava a reinar, amnistiou o rei Joaquin e tirou-o da prisão."
,"32":"Tratou-o com simpatia e colocou o seu assento acima de todos os outros reis que moravam com ele em Babilónia."
,"33":"Joaquin deixou as vestes de prisioneiro e passou a tomar refeições na presença do rei, permanentemente, até ao fim da vida."
,"34":"O rei da Babilónia garantiu-lhe o sustento, dia após dia, até ao fim da vida."
}`)

}
func PT_BS_LoadVMISChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Visão de Isaías, filho de Amós, sobre Judá e Jerusalém, no tempo de Ozias, Joatão e Ezequias, reis de Judá."
,"2":"Escutai, ó céus; ouve, ó Terra! É Javé que fala: Eu criei e eduquei filhos, mas eles revoltaram-se contra Mim."
,"3":"O boi conhece o seu proprietário, e o burro o estábulo do seu dono, mas Israel não conhece nada, o meu povo nada entende."
,"4":"Ai de vós, nação pecadora, povo carregado de crimes, raça de perversos, filhos renegados. Vós abandonastes Javé, desprezastes o Santo de Israel, e voltastes para trás."
,"5":"Se continuais na rebelião, em que parte ainda podeis levar pancadas? Toda a cabeça é uma chaga, o coração está enfermo."
,"6":"Da planta dos pés até ao alto da cabeça, nada está são: contusões, ferimentos, chagas vivas, não curadas nem ligadas, nem aliviadas com óleo."
,"7":"O vosso país está devastado, as cidades incendiadas; as terras são devoradas por estrangeiros, diante dos vossos olhos. A desolação é como devastação de estrangeiros."
,"8":"Sião, a capital, ficou isolada como cabana numa vinha, como choça num pepinal, como cidade cercada pelo inimigo."
,"9":"Se Javé dos exércitos não nos tivesse deixado um resto, seríamos como Sodoma, ficaríamos parecidos com Gomorra."
,"10":"Escutai a palavra de Javé, chefes de Sodoma; prestai atenção ao ensinamento do nosso Deus, ó povo de Gomorra:"
,"11":"Que Me interessa a quantidade dos teus sacrifícios? - diz Javé. Estou farto dos holocaustos de carneiros e da gordura de novilhos. Não gosto do sangue de bois, carneiros e cabritos."
,"12":"Quando vindes à minha presença e pisais os meus átrios, alguém vos exige alguma coisa?"
,"13":"Deixai de trazer ofertas inúteis. O incenso é coisa nojenta para Mim; luas novas, sábados, assembleias... não suporto injustiça juntamente com solenidade."
,"14":"Eu detesto as tuas luas novas e solenidades. Para Mim tornaram-se um peso que já não posso suportar."
,"15":"Quando para Mim ergueis as mãos, Eu desvio o meu olhar; ainda que multipliqueis as vossas orações, Eu não vos escutarei. As vossas mãos estão cheias de sangue."
,"16":"Lavai-vos e purificai-vos, tirai da frente dos meus olhos as maldades que praticais. Deixai de fazer o mal,"
,"17":"aprendei a fazer o bem: buscai o direito, socorrei o oprimido, fazei justiça ao órfão, defendei a causa da viúva."
,"18":"Então vinde e discutiremos - diz Javé. Ainda que os vossos pecados sejam vermelhos como a púrpura, ficarão brancos como a neve; ainda que sejam vermelhos como o escarlate, ficarão brancos como a lã."
,"19":"Se estiverdes dispostos a obedecer, comereis os frutos da terra;"
,"20":"mas, se recusardes e vos revoltardes, sereis devorados pela espada. Assim fala a boca de Javé."
,"21":"Como se transformou em prostituta a cidade fiel! Antes era cheia de direito, e nela morava a justiça; agora, está cheia de criminosos!"
,"22":"A sua prata tornou-se lixo, o seu vinho ficou aguado."
,"23":"Os seus chefes são bandidos, cúmplices de ladrões: todos eles gostam de suborno, correm atrás de presentes; não fazem justiça ao órfão, e a causa da viúva nem chega até eles."
,"24":"Pois bem! Ai de vós! - oráculo do Senhor Javé dos exércitos, o Poderoso de Israel. Eu vingar-Me-ei dos meus inimigos e pedirei satisfação aos meus adversários."
,"25":"Voltarei a minha mão contra ti, para te limpar com soda e tirar a tua impureza."
,"26":"Dar-te-ei juízes como os de outrora e conselheiros como os de antigamente. Então chamar-te-ás cidade da justiça, cidade fiel."
,"27":"Sião será resgatada com o direito, e os repatriados com a justiça."
,"28":"A ruína virá tanto para os rebeldes como para os pecadores; os que abandonam Javé perecerão."
,"29":"Então envergonhar-vos-eis das árvores sagradas que tanto apreciáveis; tereis remorsos dos jardins de que tanto gostáveis."
,"30":"Ficareis como carvalho de folhas secas, como jardim sem água."
,"31":"O valente tornar-se-á como estopa, e a sua obra como faísca: arderão juntos, e não haverá quem os apague."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Visão de Isaías, filho de Amós, sobre Judá e Jerusalém:"
,"2":"No final dos tempos, o Monte do Templo de Javé terá os seus fundamentos no mais alto dos montes, e dominará as colinas. Para lá correrão todas as nações."
,"3":"Para lá irão muitos povos, dizendo: «Vinde! Subamos à Montanha de Javé, vamos ao Templo do Deus de Jacob, para que Ele nos mostre os seus caminhos, e possamos caminhar nas suas veredas». Pois de Sião sairá a Lei, e de Jerusalém a Palavra de Javé."
,"4":"Então Ele julgará as nações e será o árbitro de povos numerosos. Das espadas fabricarão enxadas, e das lanças farão foices. Nenhuma nação pegará em armas contra outra, e ninguém mais vai treinar-se para a guerra."
,"5":"Vinde, casa de Jacob: vamos caminhar à luz de Javé."
,"6":"Rejeitaste o teu povo, a casa de Jacob, pois eles estão cheios de adivinhos orientais, de feiticeiros como os filisteus, e fizeram aliança com estrangeiros."
,"7":"O seu país está cheio de ouro e prata, os seus tesouros não têm fim; o seu país está cheio de cavalos, os seus carros de guerra não têm conta;"
,"8":"o seu país está cheio de ídolos: adoram a obra das suas próprias mãos, aquilo que os seus próprios dedos fabricaram."
,"9":"Por isso, o homem será humilhado e o mortal será rebaixado, pois Tu não lhes perdoarás."
,"10":"Foge para os rochedos e esconde-te no pó, diante do terror de Javé e do esplendor da sua majestade."
,"11":"Os olhos orgulhosos serão baixados, a arrogância humana será humilhada. Nesse dia, só Javé será exaltado."
,"12":"Pois haverá um dia de Javé dos exércitos contra todo o orgulhoso e arrogante, contra todo aquele que se eleva e se engrandece;"
,"13":"contra todos os altos cedros do Líbano, contra todos os carvalhos de Basã,"
,"14":"contra todos os altos montes, contra todas as colinas elevadas;"
,"15":"contra todas as torres altas, contra todas as muralhas invencíveis,"
,"16":"contra todos os navios de Társis, contra todos os barcos de luxo."
,"17":"O orgulho do homem será abatido, a arrogância humana será humilhada. Nesse dia, só Javé será exaltado."
,"18":"Os ídolos desaparecerão completamente."
,"19":"Escondei-vos nas grutas dos rochedos e nas fendas da terra, diante do terror de Javé e do esplendor da sua majestade, quando Ele Se levantar para aterrorizar a terra."
,"20":"Nesse dia, o homem atirará aos ratos e morcegos os seus ídolos de prata e ouro, que para si tinha feito para os adorar,"
,"21":"e esconder-se-á nos buracos dos rochedos e nas fendas dos penhascos, diante do terror de Javé e do esplendor da sua majestade, quando Ele Se levantar para aterrorizar a Terra."
,"22":"Deixai de confiar no homem, que tem o fôlego no nariz: o que é que ele pode valer?"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Eis que o Senhor Javé dos exércitos tira de Jerusalém e de Judá toda a reserva de pão e provisão de água,"
,"2":"tira o valente e o guerreiro, tira o juiz e o profeta, o adivinho e o ancião,"
,"3":"o comandante e o notável, o conselheiro, o mago e o perito em encantamentos."
,"4":"Colocarei adolescentes como vossos chefes, e meninos para vos governarem."
,"5":"O povo usará violência: um contra outro, indivíduo contra indivíduo; o jovem revoltar-se-á contra o ancião e o plebeu contra o nobre."
,"6":"Um indivíduo agarrará o seu irmão na casa do próprio pai, e dirá: «Pelo menos tens um manto. Sê nosso chefe, toma conta desta ruína»."
,"7":"Nesse dia, ele levantar-se-á para dizer: «Não sou médico. Na minha casa falta pão e vestuário. Não me façais chefe do povo»."
,"8":"Jerusalém está a desmoronar-se e Judá vai caindo, pois o que eles dizem e fazem a Javé, é um insulto à sua majestade."
,"9":"O seu ar insolente condena-os: como Sodoma, fazem propaganda do seu pecado e nem sequer o escondem. Desgraçados! Preparam o mal para si mesmos."
,"10":"Feliz o justo, porque tudo lhe correrá bem: comerá o fruto das suas acções."
,"11":"Ai do ímpio, porque tudo lhe correrá mal: será tratado como as suas acções o merecem."
,"12":"O meu povo é oprimido por crianças e governado por mulheres! Povo meu, os teus dirigentes desnorteiam-te, invertem a direcção do teu caminho."
,"13":"Javé levanta-Se para julgar, fica de pé para dar a sentença ao seu povo."
,"14":"Javé vem para fazer um julgamento contra os anciãos e contra os chefes do seu povo: «Vós devorais a vinha e tudo o que foi roubado aos pobres está na vossa casa."
,"15":"Que direito tendes de oprimir o meu povo e de esmagar a face dos pobres?» - oráculo do Senhor Javé dos exércitos."
,"16":"Diz Javé: Por causa do orgulho das mulheres de Jerusalém, que andam de cabeça erguida e olhos cobiçosos; que caminham com passo afectado, fazendo tilintar os anéis do tornozelo,"
,"17":"o Senhor cobrirá de tinha a cabeça das mulheres de Jerusalém; Javé desnudar-lhes-á a fronte."
,"18":"Nesse dia, Javé arrancar-lhes-á os enfeites: anéis de tornozelo, testeiras e lunetas;"
,"19":"brincos, braceletes e véus;"
,"20":"grinaldas, correntinhas dos pés e cintos; caixinhas de perfume e broches;"
,"21":"anéis e pingentes para o nariz;"
,"22":"vestidos de gala e mantas; xailes, bolsas,"
,"23":"espelhos, túnicas, chapéus e mantilhas."
,"24":"E então, em vez de perfume, terão podridão; em vez de cinto, terão uma corda; em vez de tranças, uma cabeça rapada; pano de saco em vez de roupas luxuosas; e marca de ferro em brasa em vez de beleza."
,"25":"Os teus homens vão cair, mortos à espada; todos os teus valentes morrerão em combate."
,"26":"Vão levantar-se lamentos e gemidos às tuas portas; e tu, desolada, sentar-te-ás no chão."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Naquele dia, sete mulheres agarrarão um só homem, dizendo: «Nós mesmas nos sustentaremos, nós mesmas compraremos as nossas roupas, só queremos que nos deixes usar o teu nome. Tira-nos desta situação vergonhosa»."
,"2":"Naquele dia, o que Javé fizer brotar será honra e glória, fruto da terra, motivo de orgulho e esplendor para os sobreviventes de Israel."
,"3":"Aqueles que tiverem ficado em Sião e os sobreviventes de Jerusalém serão chamados santos: todos os que estiverem marcados para permanecerem vivos em Jerusalém."
,"4":"Quando Javé tiver lavado as manchas das mulheres de Sião e limpado o sangue que foi derramado dentro de Jerusalém, com vento justiceiro e sopro abrasador,"
,"5":"então Javé criará, em toda a área do monte Sião e sobre toda a assembleia do povo, uma nuvem de dia, como fumo brilhante, e à noite um fogo chamejante. Pois a glória de Javé será semelhante a uma cobertura sobre todas as coisas,"
,"6":"será uma tenda a proteger contra o calor do dia, um abrigo contra os temporais e a chuva."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Cantarei em nome do meu amigo o canto do seu amor pela sua vinha. O meu amigo possuía uma vinha em fértil colina."
,"2":"Cavou-a, tirou-lhe as pedras e plantou nela videiras de uvas vermelhas. No meio, construiu uma guarita e fez um lagar. Esperava que produzisse uvas boas, mas produziu uvas azedas."
,"3":"E agora, moradores de Jerusalém e homens de Judá, peço-vos: julgai entre mim e a minha vinha."
,"4":"Que mais deveria eu fazer pela minha vinha, que não tenha feito? Porque é que esperei que desse uvas boas, e ela deu-me uvas azedas?"
,"5":"Pois, agora, vou dizer-vos o que vou fazer à minha vinha: vou arrancar-lhe a cerca para que sirva de pasto; vou derrubar-lhe o muro para que seja pisada."
,"6":"Vou fazer dela um matagal: não será podada nem cavada; só mato e espinhos crescerão nela; e às nuvens mandarei que não chovam sobre ela."
,"7":"A vinha de Javé dos exércitos é a casa de Israel, e a sua plantação preferida são os homens de Judá. Eu esperava deles o direito, e produziram injustiça; esperava justiça, e só se ouvem gritos de desespero!"
,"8":"Ai daqueles que juntam casa a casa e acrescentam campo a campo, até não haver mais terreno e serem os únicos a habitar no meio do país."
,"9":"Javé dos exércitos jurou ao meu ouvido: as suas muitas casas serão arrasadas, os seus palácios luxuosos ficarão desabitados;"
,"10":"dez jeiras de vinha produzirão apenas um barril, e dez medidas de semente não darão mais que um alqueire."
,"11":"Ai daqueles que madrugam procurando bebidas fortes e se aquecem com o vinho até ao anoitecer."
,"12":"Em seus banquetes, têm harpas e liras, tambores e flautas, e vinho para as suas bebedeiras; e ninguém presta atenção à actividade de Deus, ninguém vê o que a sua mão faz."
,"13":"Foi por falta de conhecimento que o meu povo foi exilado; os seus nobres morrem de fome e os seus plebeus ardem de sede."
,"14":"É por isso que a mansão dos mortos alarga a sua garganta e abre a sua boca desmedida: para lá descem os seus nobres e a sua plebe, o tumulto e a alegria da cidade."
,"15":"O ser humano será abatido, o homem será humilhado; os olhos dos soberbos serão abatidos."
,"16":"No julgamento, Javé dos exércitos será exaltado, o Deus santo mostrará a sua santidade através da justiça."
,"17":"Os cordeiros pastarão nos seus pastos e os cabritos comerão o resto dos pastos que os porcos devastaram."
,"18":"Ai dos que se apegam à iniquidade arrastando-a com cordas de bois, e o pecado com tirantes de uma carroça,"
,"19":"e dizem: «Que Ele ande depressa e faça sem demora a sua obra, para que a possamos ver; que apareça e se realize o plano do Santo de Israel, para que o conheçamos!»"
,"20":"Ai dos que dizem que o mal é bem, e o bem é mal, dos que transformam as trevas em luz e a luz em trevas, dos que mudam o amargo em doce e o doce em amargo!"
,"21":"Ai dos que são sábios a seus próprios olhos e inteligentes diante de si mesmos!"
,"22":"Ai dos que são fortes para beber vinho e valentes para misturar bebidas,"
,"23":"dos que absolvem o injusto a troco de suborno e negam fazer justiça ao justo!"
,"24":"Por isso, como a chama devora a palha, e o pasto seco se incendeia e se consome, assim a raiz dessa gente apodrecerá, e os seus rebentos voarão como poeira, pois rejeitaram a lei de Javé dos exércitos e desprezaram a Palavra do Santo de Israel."
,"25":"Por isso, a ira de Javé inflamou-se contra o seu povo, e Ele estendeu a mão para o castigar; as montanhas tremeram e os seus cadáveres jazem no meio das ruas como lixo. Apesar de tudo isto, a sua ira não se acalmou, e a sua mão continua estendida."
,"26":"Javé dará um sinal a um povo distante, assobiar-lhe-á do extremo da terra. Ei-lo que chega apressado e velozmente."
,"27":"No meio dele, ninguém se cansa, ninguém tropeça; ninguém tem sono, ninguém adormece; ninguém desata o cinturão, ninguém desamarra a correia das sandálias."
,"28":"As suas flechas estão afiadas e todos os arcos bem esticados; os cascos dos seus cavalos parecem de pedra, e as rodas de seus carros assemelham-se a um furacão."
,"29":"O seu rugido é como o da leoa, ruge como um leãozinho: ruge enquanto agarra a sua presa: leva-a, e ninguém lha tira."
,"30":"Nesse dia, vai rugir contra Judá, como o barulho das ondas do mar. Olha para a terra: tudo é escuridão e angústia, a luz transformou-se em trevas por causa das nuvens."
}`)
	CurrentBook.AddChapter(6, `{
"1":"No ano em que morreu o rei Ozias, vi o Senhor sentado num trono alto e elevado. A barra do seu manto enchia o Templo."
,"2":"De pé, acima d'Ele, estavam serafins, cada um com seis asas: com duas cobriam o rosto, com duas cobriam os pés, e com duas voavam."
,"3":"Eles clamavam uns para os outros: «Santo, Santo, Santo é Javé dos exércitos, a sua glória enche toda a Terra»."
,"4":"Com o barulho das aclamações, os batentes das portas tremeram e o Templo encheu-se de fumo."
,"5":"Então eu disse: «Ai de mim, estou perdido! Sou homem de lábios impuros e vivo no meio de um povo de lábios impuros, e os meus olhos viram o Rei, Javé dos exércitos»."
,"6":"Naquele momento, um dos serafins voou até onde eu estava, trazendo na mão uma brasa que havia tirado do altar com uma tenaz."
,"7":"Com a brasa tocou-me os lábios, e disse: «Olha, isto tocou os teus lábios: a tua culpa foi tirada, o teu pecado foi perdoado»."
,"8":"Ouvi, então, a voz do Senhor que dizia: «Quem é que vou enviar? Quem irá por Mim?» Eu respondi: «Aqui estou. Envia-me!»"
,"9":"Ele disse-me: «Vai, e diz a esse povo: Escutai com os ouvidos, mas não entendais; olhai com os olhos, mas não compreendais!"
,"10":"Torna insensível o coração desse povo, ensurdece-lhe os ouvidos, cega-lhe os olhos, para que não veja com os olhos nem ouça com os ouvidos, nem compreenda com o coração, nem se converta, para que Eu não lhe perdoe»."
,"11":"E eu perguntei: «Até quando, Senhor?» Ele respondeu: «Até que as cidades se desmoronem, despovoadas; até que as casas fiquem desabitadas e os campos devastados e desolados."
,"12":"Porque Javé expulsará os homens e o abandono crescerá no país."
,"13":"E se nele sobrar apenas uma décima parte, tornará a ser cortado como o carvalho e o terebinto: depois de cortados, resta apenas um tronco; esse tronco será uma semente santa»."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Acaz, filho de Joatão, filho de Ozias, era rei de Judá. Rason, rei de Aram, e Faceia, filho de Romelias, rei de Israel, subiram contra Jerusalém para a tomarem de assalto, mas não conseguiram atacá-la,"
,"2":"pois o governo de Judá foi avisado de que Aram tinha feito aliança com Efraim. Com isso, o rei e todo o povo ficaram agitados como árvores do bosque agitadas pelo vento."
,"3":"Então Javé disse a Isaías: «Vai ao encontro de Acaz, tu e o teu filho Sear Jasub. Acaz está no fim do canal do reservatório superior, no caminho que leva ao campo do Pisoeiro."
,"4":"Diz-lhe: Toma as tuas precauções, mas conserva a calma! Não tenhas medo nem vacile o teu coração por causa desses dois tições fumegantes, isto é, por causa da raiva de Rason de Aram e do filho de Romelias."
,"5":"Pois Aram, Efraim e o filho de Romelias tramaram fazer o mal contra ti, dizendo:"
,"6":"Vamos atacar Judá, vamos devastá-lo e ocupá-lo, vamos proclamar rei o filho de Tabeel."
,"7":"Assim fala o Senhor Javé: Isso não se realizará, isso não acontecerá."
,"8":"Pois a capital de Aram é Damasco, e o chefe de Damasco é Rason; dentro de cinco ou seis anos, Efraim será arrasado e deixará de ser povo."
,"9":"A capital de Efraim é Samaria, e o chefe de Samaria é o filho de Romelias. Mas, se não acreditardes, não vos mantereis firmes»."
,"10":"Javé falou de novo a Acaz, dizendo:"
,"11":"«Pede um sinal a Javé teu Deus, nas profundezas da mansão dos mortos ou na sublimidade das alturas»."
,"12":"Acaz respondeu: «Não vou pedir! Não vou tentar a Javé!»"
,"13":"Disse-lhe Javé: «Escuta, herdeiro de David, será que não vos basta a paciência dos homens? Precisais de cansar também a paciência do próprio Deus?"
,"14":"Pois ficai sabendo que Javé vos dará um sinal: A jovem concebeu e dará à luz um filho, e chamá-lo-á Emanuel."
,"15":"Ele vai comer coalhada e mel, até que aprenda a rejeitar o mal e escolher o bem."
,"16":"Mas, antes que o menino aprenda a rejeitar o mal e a escolher o bem, a terra desses dois reis que te causam medo será arrasada."
,"17":"Javé trará para ti, para o teu povo e para toda a família do teu pai, dias de felicidade como nunca houve desde o dia em que Efraim se separou de Judá»."
,"18":"Naquele dia, Javé assobiará às moscas da foz do rio do Egipto e às abelhas do país da Assíria."
,"19":"Elas virão todas e pousarão nas grutas dos morros e nas fendas das rochas, em todas as moitas de espinhos e em todos os bebedouros."
,"20":"Nesse dia, o Senhor lhes rapará, com uma navalha alugada no outro lado do rio Eufrates, a cabeça e o pêlo das pernas; até a barba lhes há-de fazer."
,"21":"Nesse dia, cada um criará uma novilha e duas ovelhas"
,"22":"e, como haverá fartura de leite, todos comerão coalhada; comerão coalhada com mel todos os que ficarem no país."
,"23":"Nesse dia, todo o lugar onde haja mil videiras no valor de mil moedas de prata se transformará em espinheiros e matagal."
,"24":"Ali entrarão os que estiverem armados de arco e flechas, pois o país inteiro se transformará em espinheiros e matagal;"
,"25":"e em todos os montes cultivados com a enxada, terás medo de entrar, por causa dos espinheiros e do matagal; servirão de pasto para os bois e serão pisados pelas ovelhas."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Javé disse-me: «Toma uma tábua grande e escreve nela com letra comum: 'Pronto-saque-rápida-pilhagem'»."
,"2":"Então tomei testemunhas de confiança: o sacerdote Urias com Zacarias, filho de Baraquias."
,"3":"Em seguida, eu uni-me à profetisa e ela concebeu e deu à luz um filho. Javé disse-me: «Dá-lhe o nome de 'Pronto-saque-rápida-pilhagem',"
,"4":"pois antes que o menino aprenda a dizer 'papá, mamã', as riquezas de Damasco e os despojos de Samaria serão levados ao rei da Assíria»."
,"5":"Javé continuou a falar comigo. Ele disse:"
,"6":"«Já que este povo desprezou a água de Siloé que corre mansa, e tremeu diante de Rason e do filho de Romelias,"
,"7":"o Senhor vai fazer cair sobre eles as águas torrenciais e impetuosas do rio Eufrates (o rei da Assíria com toda a sua força): elas enchem o leito, transbordam por todas as margens,"
,"8":"invadem Judá, inundam-no e sobem-lhe até ao pescoço». As tuas asas abrir-se-ão até cobrirem toda a extensão da tua Terra, ó Deus-connosco!"
,"9":"Povos, ficai sabendo que sereis derrotados. Atenção, países distantes: armai-vos quanto quiserdes, que sereis derrotados;"
,"10":"fazei planos à vontade, que fracassarão; fazei ameaças: elas não se cumprirão, porque Deus está connosco."
,"11":"Assim me disse Javé, enquanto me segurava pela mão e me proibia de seguir o caminho deste povo:"
,"12":"Não chameis conspiração a tudo o que esse povo chama conspiração; não temais o que ele teme e não vos apavoreis."
,"13":"Chamai Santo somente a Javé dos exércitos; só d'Ele tende temor e terror."
,"14":"Ele será uma armadilha, uma pedra de tropeço, um obstáculo que derruba para as duas casas de Israel; um laço e uma armadilha para os habitantes de Jerusalém."
,"15":"Muitos tropeçarão nela, cairão, serão despedaçados, serão presos e capturados."
,"16":"Fecha esta declaração e lacra esta instrução para os meus discípulos."
,"17":"Eu confio em Javé, que esconde a sua face à casa de Jacob, e n'Ele espero."
,"18":"Agora, eu e os filhos que Javé me deu, somos para Israel sinais e presságios de Javé dos exércitos, que mora no monte Sião."
,"19":"Quando vos disserem: «Consultai os espíritos e adivinhos, que sussurram e murmuram fórmulas; porventura, um povo não deve consultar os seus deuses e consultar os mortos em favor dos vivos?»,"
,"20":"comparai com a instrução e o testemunho: se o que disserem não estiver de acordo com o que lá está, então a aurora não nascerá para eles."
,"21":"Ele atravessará o país aflito e faminto e, enfurecido pela fome, amaldiçoará o seu rei e o seu Deus. Olhará para o alto e,"
,"22":"de novo, olhará para a terra: tudo é angústia e escuridão sem saída, angústia e densas trevas, sem aurora."
,"23":"Não haverá saída para a terra angustiada. No passado, humilhou Neftali; mas, no futuro, tornará glorioso o caminho do mar, o Além-Jordão e o território das nações. "
}`)
	CurrentBook.AddChapter(9, `{
"1":"O povo que andava nas trevas viu uma grande luz, e uma luz brilhou para os que habitavam um país tenebroso."
,"2":"Multiplicaste o povo, aumentaste o seu prazer. Vão alegrar-se diante de Ti, como na alegria da colheita, como no prazer dos que repartem despojos de guerra."
,"3":"Porque, como no dia de Madiã, quebraste o jugo que pesava sobre ele, a vara que lhe batia nas costas e o bastão do capataz de trabalhos forçados."
,"4":"Porque toda a bota que pisa o chão com barulho e toda a capa manchada de sangue serão queimadas, devoradas pelas chamas."
,"5":"Porque nasceu para nós um menino, um filho nos foi dado: sobre o seu ombro está o manto real, e chama-se «Conselheiro Maravilhoso», «Deus Forte», «Pai para sempre», «Príncipe da Paz»."
,"6":"Grande será o seu domínio, e a paz não terá fim sobre o trono de David e seu reino, firmado e reforçado com o direito e a justiça, desde agora e para sempre. O zelo de Javé dos exércitos é que realizará tudo isto."
,"7":"O Senhor enviou uma ameaça contra Jacob, e ela atingiu Israel."
,"8":"Todo o povo, Efraim e os moradores de Samaria, tiveram conhecimento dela. Cheios de soberba e presunção, dizem:"
,"9":"«Os tijolos caíram? Nós reconstruiremos com pedras. Derrubaram o madeiramento de sicômoro? Nós o substituiremos com cedro»."
,"10":"Javé, porém, fortalecerá contra esse povo o seu adversário Rason e incitará contra ele os seus inimigos:"
,"11":"os arameus pelo Oriente e os filisteus pelo Ocidente, e devorarão Israel. Apesar de tudo isto, a sua ira não se acalmará e a sua mão continuará estendida!"
,"12":"Mas o povo não se volta para quem o castiga, não procura Javé dos exércitos!"
,"13":"Javé cortará a cabeça e a cauda de Israel, a palma e o junco, num só dia."
,"14":"O ancião notável é a cabeça; e o profeta, mestre de mentiras, é a cauda."
,"15":"Os que dirigem este povo desencaminham-no, e os que se deixam guiar ficam aniquilados."
,"16":"Por isso, Javé não terá piedade dos jovens, nem se compadecerá dos órfãos e viúvas, pois são todos ímpios e malvados, toda a boca só diz loucuras. Apesar de tudo isto, a sua ira não se acalma, e a sua mão continua estendida."
,"17":"A impiedade arde como fogo, devorando espinheiros e matagais, incendiando a mata fechada, e fazendo subir colunas de fumo."
,"18":"Pela ira de Javé dos exércitos, a terra foi queimada e o povo tornou-se pasto do fogo: ninguém tem pena do próprio irmão."
,"19":"Morde à direita, e continua com fome; devora à esquerda, mas não fica saciado: cada um devora a carne do seu próximo."
,"20":"Manassés devora Efraim e Efraim devora Manassés, e os dois juntam-se contra Judá. Apesar de tudo isto, a ira de Javé não se acalma, e a sua mão continua estendida!"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Ai daqueles que fazem decretos iníquos e daqueles que escrevem apressadamente sentenças de opressão,"
,"2":"para negar a justiça ao fraco e defraudar o direito dos pobres do meu povo, para fazer das viúvas a sua presa e despojar os órfãos."
,"3":"O que fareis no dia do castigo, quando chegar a tempestade que vem de longe? A quem pedireis auxílio e onde deixareis as vossas riquezas,"
,"4":"para não sairdes encurvados juntamente com os prisioneiros e para não cairdes entre os cadáveres? Apesar de tudo isso, a ira de Javé não se acalma, e a sua mão continua estendida!"
,"5":"Ai de ti, Assíria, vara da minha ira, bastão do meu furor posto em tuas mãos."
,"6":"Eu enviei-te contra uma nação ímpia, Eu dei-te ordens contra o povo da minha cólera, para que o saqueies e o despojes, e o pises como se fosse lama da rua."
,"7":"Mas, ela não tinha essa intenção, e o seu coração não se apegou a esse plano. Pelo contrário, só pensava em exterminar e destruir um bom número de nações."
,"8":"De facto, ela dizia: «Porventura os meus príncipes não são todos reis?"
,"9":"Calane não teve a mesma sorte de Carquemis, Emat não teve a mesma sorte de Arfad, e Samaria não teve a mesma sorte de Damasco?"
,"10":"Ora, se a minha mão alcançou aqueles reinos de ídolos, cujas imagens eram mais numerosas que em Jerusalém e em Samaria,"
,"11":"não farei de Jerusalém e das suas imagens o mesmo que fiz da Samaria e dos seus ídolos?»"
,"12":"Pois bem! Quando o Senhor terminar tudo o que está a fazer no monte Sião e em Jerusalém, vai castigar o rei da Assíria, conforme a soberba dos seus pensamentos e a arrogância do seu olhar."
,"13":"Pois ele disse: «Foi com a força da minha mão que eu fiz o que fiz; agi com sabedoria porque sou inteligente. Mudei as fronteiras das nações e saqueei os seus tesouros; como herói dominei os seus habitantes."
,"14":"Como num ninho, a minha mão apanhou as riquezas dos povos: como se recolhem ovos abandonados, recolhi a terra inteira, e não houve quem batesse asas, ninguém que desse um pio»."
,"15":"Acaso o machado se gloria contra aquele que o segura? Ou a serra se levanta contra aquele que a maneja? Como se o bastão pudesse mover quem o ergueu, ou a vara pudesse levantar aquilo que não é madeira!"
,"16":"Por isso, o Senhor Javé dos exércitos vai mandar magreza à sua gordura; em lugar da sua glória, lavrará um incêndio, como incêndio provocado pelo fogo."
,"17":"A luz de Israel tornar-se-á um fogo, e o seu Santo uma labareda, que há-de devorar e consumir num só dia os seus espinheiros e matagais."
,"18":"Como se fosse um doente que definha, vai extinguir-se toda a beleza das suas matas e dos seus bosques."
,"19":"Ficarão tão poucas árvores na floresta, que até uma criança poderá contá-las."
,"20":"Nesse dia, o resto de Israel, os da casa de Jacob que escaparem, já não irão procurar apoio naquele que os fere; irão apoiar-se, com toda a fidelidade, em Javé, o Santo de Israel."
,"21":"O resto, o resto de Jacob voltará para o Deus forte."
,"22":"Israel, mesmo que o seu povo fosse tão numeroso como a areia do mar, a verdade é que de todo ele só um resto voltará, pois foi decretada a destruição: a justiça transborda."
,"23":"Sim, a destruição foi decretada: o Senhor Javé dos exércitos vai executá-la no meio de toda a Terra."
,"24":"Por isso, assim diz o Senhor Javé dos exércitos: Povo meu que moras em Sião, não tenhas medo da Assíria. Ela bate-te com um bastão, levanta contra ti a sua vara no caminho do Egipto."
,"25":"Só mais um pouco de tempo, e o meu furor chegará ao fim; a minha ira vai destruí-los."
,"26":"Javé dos exércitos levantará o açoite contra eles, como quando atacou Madiã perto da rocha de Oreb, ou como quando ergueu a sua vara contra o mar no caminho do Egipto."
,"27":"Naquele dia, será retirado o peso dos teus ombros e o jugo do teu pescoço. O destruidor vem de Rimon, "
,"28":"chega até Aiat, passa por Magron e deixa a sua bagagem em Macmas."
,"29":"Atravessam o desfiladeiro e acampam em Gaba. Ramá estremece, Gabaá de Saul põe-se em retirada."
,"30":"Levanta a voz, Bat-Galim! Está atenta, Laísa! Responde-lhe, Anatot!"
,"31":"Madmena fugiu e os moradores de Gabim procuraram esconderijo."
,"32":"Ainda hoje, parando em Nob, com a mão ameaçará o monte da filha de Sião, a colina de Jerusalém."
,"33":"Eis que o Senhor Javé dos exércitos vai podar a ramagem, com terrível violência: os galhos mais altos serão cortados, os ramos de cima serão abatidos;"
,"34":"o grosso da floresta será cortado com o ferro, e o Líbano majestoso cairá."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Do tronco de Jessé sairá um ramo, um rebento nascerá das suas raízes."
,"2":"Sobre ele pousará o espírito de Javé: espírito de sabedoria e inteligência, espírito de conselho e fortaleza, espírito de conhecimento e temor de Javé."
,"3":"A sua inspiração estará no temor de Javé. Ele não julgará pelas aparências, nem dará a sentença só pelo que ouvir dizer."
,"4":"Ele julgará os fracos com justiça, dará sentenças rectas aos pobres da Terra. Ele ferirá o violento com o ceptro da sua boca, e matará o ímpio com o sopro dos seus lábios."
,"5":"A justiça será o cinto da sua cintura, a fidelidade cingir-lhe-á os rins."
,"6":"O lobo será hóspede do cordeiro, a pantera deitar-se-á ao lado do cabrito; o bezerro e o leãozinho pastarão juntos, e um menino os guiará;"
,"7":"pastarão juntos o urso e a vaca, e as suas crias ficarão deitadas lado a lado, e o leão comerá feno como o boi."
,"8":"O bebé brincará no buraco da cobra venenosa, a criancinha enfiará a mão no esconderijo da serpente."
,"9":"Ninguém agirá mal nem provocará destruição no meu monte santo, pois a Terra estará cheia do conhecimento de Javé, tal como as águas enchem o mar."
,"10":"Naquele dia, a raiz de Jessé erguer-se-á como bandeira para os povos; para ela correrão as nações, e a sua moradia será gloriosa."
,"11":"Nesse dia, o Senhor tornará a estender a mão para resgatar o resto do seu povo, os sobreviventes da Assíria e do Egipto, em Patros, em Cuch e Elam, em Senaar, em Emat e nas ilhas do mar."
,"12":"Ele erguerá um estandarte para as nações, a fim de reunir os israelitas exilados, para juntar os judeus dispersos dos quatro cantos da Terra."
,"13":"O ciúme de Efraim vai acabar, e terminará o rancor de Judá: Efraim nunca mais terá ciúmes de Judá, nem Judá terá rancor de Efraim."
,"14":"Voarão sobre o litoral dos filisteus pelo lado do mar, e juntos saquearão do outro lado os povos do Oriente; porão as mãos em Edom e Moab, e aos filhos de Amon imporão obediência."
,"15":"Javé fará secar o golfo do mar do Egipto, e com a força do seu sopro estenderá a mão contra o rio Eufrates, reduzindo-o a sete braços que podem ser atravessados de sandálias."
,"16":"Haverá uma estrada para o resto do seu povo, para o que sobrar na Assíria, da mesma forma como houve uma estrada para Israel no dia em que saiu da terra do Egipto."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Naquele dia, dirás: «Eu Te agradeço, Javé, porque estavas irado contra mim, mas a tua ira acalmou-se e me consolaste."
,"2":"Sim, Deus é a minha salvação! Eu confio e nada tenho a temer, porque a minha força e o meu canto é Javé: Ele é a minha salvação."
,"3":"Com alegria todos podereis beber água nas fontes da salvação»."
,"4":"E naquele dia direis: «Agradecei a Javé, invocai o seu Nome, contai aos povos as façanhas que Ele fez, proclamai que o seu Nome é sublime;"
,"5":"cantai hinos a Javé, pois Ele fez proezas; que toda a terra as reconheça."
,"6":"Gritai de alegria e exultai, moradores de Sião, pois é grande no meio de ti o Santo de Israel»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Oráculo contra Babilónia, recebido em visão por Isaías, filho de Amós."
,"2":"Erguei uma bandeira sobre um monte escalvado, gritai-lhes, fazendo-lhes sinal com a mão, para que entrem pela Porta dos Nobres."
,"3":"Eu já dei ordem aos meus guerreiros escolhidos, e também já chamei os meus valentes ao serviço da minha ira, que gostam de louvar a minha grandeza."
,"4":"Um barulho nas montanhas, semelhante ao rumor de uma grande multidão; alvoroço de reinos, de nações reunidas: Javé dos exércitos passa revista ao seu exército para o combate."
,"5":"Vieram de terras longínquas, do horizonte mais distante. É Javé com os instrumentos da sua ira para acabar com o país inteiro."
,"6":"Gritai, porque o dia de Javé está a chegar; Ele vem com a violência do Omnipotente."
,"7":"Por isso, os braços desfalecem, e toda a coragem humana enfraquece."
,"8":"Estão apavorados, cheios de dores e aflições, contorcendo-se como a mulher ao dar à luz. Cada um olha espantado para o outro, com o rosto vermelho de vergonha."
,"9":"Eis que chega implacável o dia de Javé, com o furor e o calor da sua ira, para fazer do país um deserto, para exterminar os pecadores."
,"10":"As estrelas do céu e suas constelações deixarão de irradiar a sua luz, o Sol já nascerá escuro e a Lua não dará a sua claridade."
,"11":"Vou castigar a maldade do mundo inteiro, os crimes dos ímpios; porei um fim ao orgulho dos soberbos e rebaixarei a vaidade dos prepotentes;"
,"12":"farei com que os homens sejam mais raros que o ouro, mais difíceis de encontrar que o ouro de Ofir."
,"13":"É assim que sacudirei os céus, e a Terra vai tremer nas suas bases por causa da ira de Javé dos exércitos, no dia do calor da sua ira."
,"14":"Então, como gazela assustada ou como ovelha perdida, cada qual voltará para o seu povo, cada um vai esconder-se na sua própria terra."
,"15":"Quem for encontrado, será morto; quem for alcançado, morrerá ao fio da espada."
,"16":"As suas crianças serão despedaçadas diante dos seus olhos; as suas casas serão saqueadas e as suas mulheres serão violentadas."
,"17":"É assim que vou atirar contra eles o povo da Média, gente que não se interessa pela prata, nem se preocupa com o ouro."
,"18":"Com os seus arcos matam os jovens, não têm compaixão dos bebés; o seu olhar não se comove diante das crianças."
,"19":"Então, Babilónia, a pérola dos reinos, o enfeite e o orgulho dos caldeus, será transformada em ruínas, como aquelas que Deus provocou em Sodoma e Gomorra."
,"20":"Nunca mais será habitada; de geração em geração não será povoada; os árabes não armarão lá as suas tendas, nem os pastores irão lá descansar com os seus rebanhos."
,"21":"Lá se abrigarão os animais do deserto: as casas da cidade serão povoadas de corujas; nela irão dormir filhotes de avestruz, por ali os bodes saltarão;"
,"22":"hienas vão ulular nas suas torres, lobos uivarão nos edifícios luxuosos. A hora de Babilónia está a chegar, os seus dias não serão adiados."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Javé terá compaixão de Jacob, voltará a escolher Israel e restabelecê-lo-á no seu país. Os estrangeiros juntar-se-ão a eles e serão incorporados na casa de Jacob."
,"2":"Alguns povos virão buscá-los, a fim de os levarem para a sua terra; os israelitas, porém, apoderar-se-ão deles na Terra de Javé e farão deles escravos e escravas. Farão cativos aqueles que queriam pô-los em cativeiro; eles dominarão os seus opressores."
,"3":"Quando Javé te livrar do sofrimento, do desespero e da dura escravidão que te foi imposta,"
,"4":"deverás cantar esta canção contra o rei de Babilónia: Como terminou o opressor, como acabou a sua arrogância!"
,"5":"Javé quebrou a vara dos ímpios, o ceptro dos dominadores,"
,"6":"aquele que castigava os povos com furor, que feria com golpes sem fim, que dominava as nações com ira, com opressão implacável."
,"7":"Agora o mundo inteiro repousa tranquilo e dá gritos de alegria."
,"8":"Até os ciprestes e os cedros do Líbano riem de ti: «Depois que tu caíste, ninguém mais se levantou para nos derrubar."
,"9":"Nas profundezas, a mansão dos mortos agita-se por tua causa, prepara-te uma recepção; para ti, ela desperta os mortos, todos os dominadores da terra, e faz levantar todos os reis das nações dos seus tronos»."
,"10":"E todos eles tomam a palavra: «Também tu foste derrubado como nós, e ficaste igual a nós?»"
,"11":"O teu esplendor foi atirado à sepultura, juntamente com a música das tuas harpas. Debaixo de ti há um colchão de podridão, o teu cobertor é feito de vermes."
,"12":"Como é que caíste do céu, estrela da manhã, filho da aurora? Como é que foste derrubado, agressor das nações?"
,"13":"Tu que pensavas: «Vou subir até ao céu, vou colocar o meu trono acima das estrelas de Deus; vou sentar-me na montanha da Assembleia, no cume da montanha celeste."
,"14":"Subirei até às alturas das nuvens e tornar-me-ei igual ao Altíssimo»."
,"15":"E agora, aí estás precipitado na mansão dos mortos, nas profundezas do abismo."
,"16":"Quem te vê, pára para te olhar e observar: «Este homem abalou o mundo, fez tremer os reinos,"
,"17":"fez do mundo um deserto, destruía as suas cidades e não libertava os seus prisioneiros!»"
,"18":"Todos os reis das nações são sepultados com honras, cada qual no seu túmulo;"
,"19":"mas tu foste atirado para fora da tua sepultura como ramo nojento; estás rodeado por mortos trespassados pela espada e atirados sobre as pedras da cova, como cadáver espezinhado."
,"20":"Não te reunirás com eles numa sepultura, pois destruíste o teu país e assassinaste o teu povo. A descendência dos malfeitores jamais será nomeada. "
,"21":"Decretai a matança dos filhos, por causa dos pecados de seus pais. De contrário, eles voltam a levantar-se, tornam-se donos da terra e acabam por encher o mundo de ruínas."
,"22":"Levantar-me-ei contra eles - palavra de Javé dos exércitos - para eliminar da Babilónia o seu nome e os seus sobreviventes, a sua família e a sua geração - oráculo de Javé."
,"23":"Farei dela uma propriedade de ouriços e um pântano. Vou varrer Babilónia com a vassoura da destruição - oráculo de Javé dos exércitos."
,"24":"Assim jurou Javé dos exércitos: Como planeei, assim se cumprirá; aquilo que decidi, realizar-se-á:"
,"25":"liquidarei a Assíria dentro da minha Terra; no alto da minha montanha, espezinharei a sua cabeça. O jugo que a Assíria colocou sobre o meu povo, desaparecerá; a carga que ela te pôs sobre os ombros, será tirada."
,"26":"Este é o plano elaborado contra a Terra inteira; esta é a mão estendida contra todas as nações."
,"27":"Javé dos exércitos assim decidiu: quem O impedirá? Se Ele estendeu a sua mão, quem a afastará?"
,"28":"No ano em que morreu o rei Acaz, foi comunicado este oráculo:"
,"29":"Não te alegres, Filisteia inteira, por ter sido quebrada a vara que te feria, pois do corpo da serpente surgirá uma víbora, e o seu fruto será um dragão alado."
,"30":"Os fracos apascentar-se-ão nos meus campos, e os indigentes repousarão tranquilos, mas farei perecer de fome a tua raiz e matarei o resto."
,"31":"Geme, ó porta; grita, ó cidade! Treme, Filisteia inteira! Porque do Norte se levanta uma nuvem de fumo e ninguém abandona o seu posto."
,"32":"Que resposta darão aos mensageiros desta nação? Foi Javé quem fundou Sião; ali se abrigarão os mais pobres do seu povo."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Oráculo contra Moab. Numa só noite foi devastada, Ar-Moab foi destruída; numa só noite foi devastada, Quir-Moab foi destruída!"
,"2":"O povo de Dibon subiu aos lugares altos para chorar; nos montes de Nebo e Medaba, lamenta-se Moab. Raparam a cabeça e cortaram a barba."
,"3":"O povo anda pelas ruas vestido de pano de saco; nos terraços e nas praças todos se lamentam, desfeitos em pranto."
,"4":"Hesebon e Eleale gritam, e os seus gritos chegam até Jasa. Por isso, tremem as entranhas de Moab, e a sua alma estremece."
,"5":"O meu coração geme por Moab. Os seus fugitivos já estão em Segor e em Eglat-Selísia. Sobem, chorando, a ladeira de Luit; da estrada de Horonaim saem gritos de aflição."
,"6":"Esgotou-se a água de Nemrim, o pasto secou, a erva murchou, e de verde nada mais existe."
,"7":"Por isso, reuniram o que ainda conseguiram salvar dos seus bens e transportaram-no para além da torrente dos Salgueiros."
,"8":"O clamor espalhou-se por todo o território de Moab, e os seus gritos chegam até Eglaim e Beer-Elim,"
,"9":"pois a água de Dimon está cheia de sangue. Mas juntarei mais uma desgraça a Dimon: um leão para os que escaparem de Moab e para o resto do país."
}`)
	CurrentBook.AddChapter(16, `{
"1":"De Sela do deserto enviai ao monte da filha de Sião cordeiros para o soberano do país."
,"2":"Como pássaros espantados, como ninhada dispersa, tais são as filhas de Moab junto às passagens do Arnon."
,"3":"Reúne um conselho e toma uma decisão: estende a tua sombra como noite em pleno meio-dia, para esconder os refugiados, para manter em segredo os fugitivos."
,"4":"Recebe no teu país os refugiados moabitas, sê para eles um abrigo contra aqueles que os perseguem. Quando terminar a opressão, quando a destruição tiver chegado ao fim e desaparecer do país o opressor,"
,"5":"então haverá na tenda de David um trono fundado no amor e na fidelidade: nele se sentará um juiz zeloso do direito e solícito na justiça."
,"6":"Ouvimos falar do orgulho de Moab, da soberba desmedida da sua vaidade, arrogância e ira, e do vazio da sua ostentação."
,"7":"Por isso, os moabitas se lamentam por Moab, todos se lamentam. É por causa dos bolos de uvas passas de Quir-Hareset que gemeis tão tristes."
,"8":"Pois os campos de Hesebon estão a murchar, e também os vinhedos de Sábama, cujo vinho embriagava os senhores das nações. Os seus ramos estendiam-se até Jazer, espalhavam-se pelo deserto e estendiam-se livremente, e chegavam até ao mar."
,"9":"Por isso é que eu choro juntamente com Jazer, pelos vinhedos de Sábama. Inundo-vos com as minhas lágrimas, Hesebon e Eleale, pois os gritos de alegria desapareceram das vossas colheitas e ceifas."
,"10":"Alegria e contentamento desapareceram dos pomares; nas vinhas não há canções alegres nem gritos de júbilo; no tanque de esmagar uvas já ninguém trabalha; terminaram os gritos de alegria."
,"11":"Por isso as minhas entranhas vibram como cítara por Moab; por isso o meu coração palpita por Quir-Hares."
,"12":"Moab vai cansar-se de comparecer nos lugares altos, vai cansar-se de procurar santuários para rezar, mas nada vai conseguir."
,"13":"Esta é a mensagem que outrora Javé dirigiu a Moab."
,"14":"Mas, agora, Javé diz: Dentro de três anos, como anos de um assalariado, a glória de Moab será reduzida a nada, com toda a sua numerosa população. Apenas um resto pequeno e impotente vai permanecer."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Oráculo contra Damasco. Damasco deixará de ser cidade e transformar-se-á num montão de ruínas."
,"2":"Abandonadas para sempre, as cidades do país serão entregues a rebanhos que aí descansarão sem ser incomodados."
,"3":"Efraim perderá a sua fortaleza e Damasco perderá o seu poderio. O resto de Aram terá o mesmo destino que a nobreza de Israel - oráculo de Javé dos exércitos."
,"4":"Naquele dia, a nobreza de Jacob ficará pobre, e desaparecerá a gordura do seu corpo."
,"5":"Acontecerá como quando o ceifeiro colhe o trigo, como quando os seus braços apanham as espigas; acontecerá como quando alguém respiga no vale de Rafaim."
,"6":"Sobrará apenas um restolho, como quando se vareja uma oliveira: ficam apenas duas ou três azeitonas nos ramos mais altos, quatro ou cinco nos outros ramos - oráculo de Javé, Deus de Israel."
,"7":"Naquele dia, o homem voltar-se-á para o seu Criador, voltará os seus olhos para o Santo de Israel."
,"8":"Não se fixará nos altares construídos pelas suas mãos, trabalhados pelos seus dedos, e também não vai olhar para os postes sagrados, nem para os altares de incenso."
,"9":"Naquele dia, até as cidades de refúgio ficarão abandonadas, como as cidades dos heveus e amorreus, que ficaram abandonadas com a chegada dos filhos de Israel; tudo se tornará um deserto."
,"10":"Porque te esqueceste do Deus que te salva e não te recordaste da rocha que te protege. Tu plantas jardins de Adónis e enxertas plantas exóticas."
,"11":"Quando as plantas, vê-las crescer; e, na manhã seguinte, vê-las florescer, mas a colheita esvai-se num dia de doença e de dor incurável."
,"12":"Ah! O tumulto de povos numerosos, como barulho das ondas do mar, o alarido das nações ecoa como estrondo de águas tumultuosas."
,"13":"O alarido das nações ecoa como estrondo de muitas águas. No entanto, Javé ameaça-as e elas fogem para longe; voam sobre os montes como palhas dispersas pelo vento, como cisco no redemoinho."
,"14":"Ao anoitecer, provocam espanto, mas, ao amanhecer, já não existem. Tal é o destino dos que nos saqueiam, a sorte daqueles que nos despojam."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Ai da terra dos insectos zumbidores, que se acha entre os rios da Etiópia,"
,"2":"que manda embaixadores pelo mar, em barcos de papiro sobre as águas! «Parti, mensageiros velozes, para uma nação de gente alta e bronzeada, para um povo temido em toda a parte, para um povo forte e dominador, cuja terra é sulcada por rios»."
,"3":"Todos vós, habitantes do mundo e moradores da Terra, quando se levantar nas colinas uma bandeira, olhai para ela; quando tocar a trombeta, escutai-a."
,"4":"Pois Javé disse-me: «Eu fico quieto a observar, aqui da minha morada, como calor sufocante à luz do sol ou como nuvem de neblina ao calor da colheita»."
,"5":"Pois antes da vindima, passada a floração, quando as uvas começarem a amadurecer, os seus ramos serão cortados pela tesoura do podador e os seus rebentos serão arrancados."
,"6":"Tudo será abandonado aos abutres dos montes e às feras selvagens. No Verão, sobre eles estarão as aves de rapina, e sobre eles todas as feras selvagens passarão o Inverno."
,"7":"Naquele tempo, um povo alto e bronzeado trará oferendas a Javé dos exércitos, um povo temido por toda a parte, um povo forte e dominador, cuja terra é sulcada por rios; essas ofertas serão levadas ao lugar onde é invocado Javé dos exércitos, ao Monte Sião."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Oráculo contra o Egipto. Olhai Javé montado numa nuvem veloz, que entra no Egipto! Com a sua presença, os deuses do Egipto estremecem, e o coração dos egípcios derrete-se no peito."
,"2":"Atiçarei egípcios contra egípcios e, assim, cada um vai guerrear contra o seu irmão: um indivíduo contra o seu próximo, uma cidade contra outra, um reino contra outro."
,"3":"A inteligência dos egípcios se desfará no peito, e confundirei o seu conselho. Irão consultar os ídolos, pedir conselho aos magos, aos que invocam os mortos e adivinhos."
,"4":"Vou entregar o Egipto nas mãos de um ditador; um rei prepotente governará o país - oráculo de Javé dos exércitos."
,"5":"As águas do mar secarão, o rio ficará sem água e seco,"
,"6":"os canais de irrigação cheirarão mal, os braços do rio Nilo vão diminuir e secar, e as canas e juncos murcharão."
,"7":"Vai secar e desaparecer a erva das margens do Nilo, e tudo o que cresce junto ao Nilo será varrido pelo vento."
,"8":"Os pescadores gemerão, os que lançam o anzol no Nilo lamentar-se-ão, e os que lançam a rede à água ficarão desanimados."
,"9":"Aqueles que trabalham com o linho ficarão desiludidos, e os fiandeiros e tecelões empalidecerão."
,"10":"Aqueles que preparam bebidas ficarão abatidos, e todos os seus trabalhadores ficarão desconsolados."
,"11":"Como são loucos os chefes de Tânis, os sábios que dão conselhos estúpidos ao Faraó. Como ousais dizer ao Faraó: «Sou filho de sábios, filho de reis antigos»?"
,"12":"E, agora, onde estão os vossos sábios? Já que sabem tanto, que eles vos anunciem o que Javé dos exércitos planeia contra o Egipto."
,"13":"Os chefes de Tânis agiram como loucos, os chefes de Mênfis estão iludidos. Os chefes das tribos desorientam o Egipto."
,"14":"Javé espalhou entre eles um espírito de confusão: com todos os seus empreendimentos, desencaminham o Egipto, como se desencaminha um bêbado que vai vomitando."
,"15":"O Egipto não conseguirá ter sucesso em obra nenhuma: obra da cabeça ou da cauda, da palma ou do junco."
,"16":"Naquele dia, os egípcios tornar-se-ão como mulheres, cheios de pavor e medo diante da mão de Javé dos exércitos, a mão que se agita contra eles."
,"17":"A terra de Judá será um terror para os egípcios. Todas as vezes que alguém falar de Judá, elesvão entrar em pânico por causa daquilo que Javé dos exércitos planeia contra o Egipto."
,"18":"Naquele dia, haverá umas cinco cidades do Egipto que falarão a língua de Canaã, e que jurarão por Javé dos exércitos. Uma delas será chamada Cidade do Sol."
,"19":"Naquele dia, haverá um altar para Javé no meio do país do Egipto e, na fronteira, um obelisco em honra de Javé."
,"20":"Tudo isto será, no país do Egipto, um sinal e um testemunho para Javé dos exércitos. Então, quando clamarem por Ele diante de alguém que os oprime, Javé enviar-lhes-á um salvador e defensor que os liberte."
,"21":"Javé será conhecido no Egipto, e nesse dia os egípcios reconhecerão Javé. Oferecerão sacrifícios e oferendas, e até farão promessas a Javé, e hão-de cumpri-las."
,"22":"Javé ferirá os egípcios. Ele vai ferir, e depois curar. Os egípcios voltar-se-ão para Javé e, então, Ele os vai escutar e curar."
,"23":"Naquele dia, haverá uma estrada do Egipto para a Assíria. A Assíria poderá ir ao Egipto e o Egipto poderá ir à Assíria. O Egipto e a Assíria prestarão culto a Deus."
,"24":"Naquele dia, Israel será mediador entre o Egipto e a Assíria, e será uma bênção no meio da Terra,"
,"25":"porque Javé dos exércitos o abençoa, dizendo: «Bendito seja o Egipto, meu povo, e a Assíria, obra das minhas mãos, e Israel, a minha herança»."
}`)
	CurrentBook.AddChapter(20, `{
"1":"No ano em que o chefe do exército da Assíria, mandado pelo rei Sargon, chegou a Azoto, cercou e tomou a cidade."
,"2":"Então, Javé falou por intermédio de Isaías, filho de Amós, como já lhe havia dito antes: «Vai, despe esse pano de saco e tira as sandálias dos pés». Assim fez Isaías, que começou a andar nu e descalço."
,"3":"Depois Javé disse: Assim como Isaías, meu servo, andou nu e descalço durante três anos, esse facto será um sinal e um exemplo para o Egipto e a Etiópia."
,"4":"Pois é assim que o rei da Assíria vai levar os cativos do Egipto, os exilados da Etiópia, jovens ou velhos: estarão nus e descalços, com as nádegas descobertas (a vergonha do Egipto)."
,"5":"Estarão aterrorizados e envergonhados por causa da Etiópia, sua esperança; por causa do Egipto, seu orgulho."
,"6":"Os moradores do litoral dirão: «Vede como ficou a nossa esperança, aqueles em quem pensávamos encontrar protecção para nos livrarmos das ameaças do rei da Assíria! Quem nos vai livrar agora?»"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Oráculo contra o deserto do mar. Como os furacões que percorrem o Negueb, assim ele vem do deserto, de um país terrível. "
,"2":"Uma visão pavorosa me foi revelada: «O traidor foi traído e o devastador devastado. À luta, Elam! Ao cerco, Média! Eu lanço sem cessar toda a espécie de gemidos."
,"3":"Então todo o meu corpo começa a tremer, vou sentindo uma aflição como de mulher que está para dar à luz; uma tontura não me deixa ouvir, um tremor não me deixa ver!"
,"4":"A minha cabeça gira, o pavor toma conta de mim. E o entardecer tão esperado torna-se terror para mim."
,"5":"Preparai a mesa, estendei a toalha para comer e beber. De pé, comandantes: preparai os escudos»."
,"6":"Pois assim me falou Javé: «Vai, e põe uma sentinela para que conte tudo o que vê."
,"7":"Se vê gente montada, dois cavaleiros montados em jumentos ou camelos, que preste atenção, muita atenção»."
,"8":"E a sentinela gritou: «Meu senhor, estou de vigia o dia inteiro, de pé no meu posto de guarda; passo a noite como sentinela no lugar de onde estou vigiando."
,"9":"Atenção! Está chegando gente montada, um par de cavaleiros que anunciam: 'Caiu, caiu Babilónia; as estátuas dos seus deuses estão despedaçadas pelo chão'»."
,"10":"Povo meu, malhado na eira, eu anuncio-te o que ouvi a Javé dos exércitos, o Deus de Israel."
,"11":"Oráculo contra Duma. De Seir alguém me chama: «Guarda, quanto falta para acabar a noite? Guarda, quanto falta para acabar a noite?» "
,"12":"O guarda responde: «O amanhecer vai chegar, mas a outra noite também. Se quereis perguntar, perguntai. Voltai novamente»."
,"13":"Oráculo contra a Arábia. No matagal, na Arábia, passais a noite, caravanas de dadanitas."
,"14":"Levai água aos que passam sede. Moradores de Tema, levai pão aos fugitivos,"
,"15":"porque eles fogem da espada, da espada desembainhada, do arco esticado e da dureza da guerra."
,"16":"Eis o que me disse Javé: «Daqui a um ano, contado como um ano de assalariado, vai acabar todo o poderio de Cedar."
,"17":"O que sobrar dos numerosos atiradores de flechas do exército de Cedar, será muito pouco, pois quem o disse foi Javé, Deus de Israel»."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Oráculo sobre o Vale da Visão. Que vos aconteceu para subirdes todos aos terraços, "
,"2":"cheios de júbilo, cidade cheia de agitação, população em festa? Os teus mortos não foram mortos pela espada, nem morreram no combate."
,"3":"Os teus chefes fugiram todos juntos, e sem um disparo de arco caíram prisioneiros; todos os que foram encontrados foram feitos prisioneiros, quando se afastavam em fuga."
,"4":"É por isso que eu digo: Não olheis para mim, porque choro amargamente; e não queirais consolar-me da derrota sofrida pela filha do meu povo."
,"5":"Na verdade, Javé dos exércitos enviou um dia de luto, de angústia e tormento. No Vale da Visão, as muralhas eram derrubadas e ouviam-se gritos pelos montes. "
,"6":"Elam trazia a aljava de flechas; Aram montava cavalos e carros; Quir descobria o escudo."
,"7":"Os seus melhores vales estavam cheios de carros e os cavaleiros tomavam posição junto à porta."
,"8":"Foi assim que se abriu a defesa de Judá. Naquele dia, olhastes para as armas da Casa da Floresta. "
,"9":"Vistes que eram muitas as brechas na cidade de David. E então procurastes recolher as águas do reservatório inferior."
,"10":"Depois, contastes as casas de Jerusalém e demolistes casas para poderdes reforçar as muralhas da cidade."
,"11":"Entre as duas muralhas, fizestes um depósito para a água do antigo reservatório. Vós não olhastes para Aquele que fez tudo isto; não reparastes n'Aquele que, de longe, planeou tudo isto."
,"12":"Nesse dia, Javé dos exércitos tinha-vos convidado a chorar e bater no peito, a rapar a cabeça e vestir luto."
,"13":"Em vez disso, o que se viu foi divertimento e alegria, matança de bois e abate de ovelhas, gente a comer carne e a beber vinho: «Comamos e bebamos, que amanhã morreremos»."
,"14":"Javé dos exércitos disse ao meu ouvido: Juro que este pecado não será perdoado até que sejais mortos - disse Javé dos exércitos."
,"15":"Assim diz Javé, Deus dos exércitos: Vai procurar esse Sobna, ministro do palácio,"
,"16":"que está a fazer para si próprio um túmulo em lugar alto, que está a escavar uma sepultura na rocha. Diz-lhe: «O que estás aqui a fazer, e que parentes tens tu aqui para estares a preparar um túmulo?"
,"17":"Pois Javé vai atirar-te para longe e com força. Ele vai apanhar-te"
,"18":"e fazer-te rolar como uma bola em lugar espaçoso. Ali morrerás com os teus carros elegantes, como uma vergonha para a casa do teu patrão."
,"19":"Vou depor-te do teu cargo, vou afastar-te da tua função."
,"20":"Naquele dia, vou convocar o meu servo Eliacim, filho de Helcias."
,"21":"Vou vesti-lo com a tua túnica, vou cingi-lo com o teu cinturão; colocarei nas suas mãos o teu poder. E ele será como um pai para os habitantes de Jerusalém e para a casa de Judá."
,"22":"Colocarei a chave da casa de David sob a sua responsabilidade: quando ele abrir, ninguém poderá fechar; quando ele fechar, ninguém poderá abrir."
,"23":"Vou fixá-lo como prego em lugar firme, e o desempenho do seu cargo será de prestígio para a casa de seu pai."
,"24":"Dele estará pendente tudo o que há de importante na família de seu pai: filhos e netos, todos os objectos miúdos, desde as taças até aos jarros."
,"25":"Naquele dia - oráculo de Javé dos exércitos - o prego fixado em lugar firme vai ceder, sair do lugar e cair; então, tudo o que estava dependurado nele também cairá, porque Javé assim o disse»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Oráculo contra Tiro.Gemei, navios de Társis, pois o vosso refúgio foi destruído. A notícia chegou da terra de Cetim."
,"2":"Calai-vos, moradores do litoral, comerciantes de Sídon, cujos representantes atravessavam o mar,"
,"3":"as águas imensas. Os cereais do Delta, as colheitas do vale do Nilo eram a sua fonte de riqueza, e eles vendiam para o mundo inteiro."
,"4":"Sídon, fortaleza dos mares, envergonha-te, pois assim diz o mar: «Não tive dores de parto nem dei à luz ninguém; não criei meninos nem eduquei meninas»."
,"5":"Quando se ouvir falar disso no Egipto, eles sofrerão com as notícias de Tiro."
,"6":"Vós, moradores do litoral, ululai e regressai a Társis."
,"7":"Será essa a cidade feliz, que teve origem nos tempos antigos e cujos pés a levavam longe para lá fixar morada?"
,"8":"Quem foi que planeou isto contra Tiro, a distribuidora de coroas? Os seus comerciantes eram capitães, e os seus negociantes eram a aristocracia do país."
,"9":"Foi Javé dos exércitos quem assim planeou, para rebaixar todo o orgulho e esplendor, para humilhar a aristocracia do país."
,"10":"Agora, trata de lavrar a terra como a região do Nilo, ó filha de Társis, pois o teu porto já não existe."
,"11":"Javé estendeu a mão sobre o mar e fez tremer os reinos. Ele mandou destruir as fortalezas de Canaã."
,"12":"Ele disse: Não continues a exaltar-te, ó cidade arrasada, jovem filha de Sidónia. Levanta-te e vai para Cetim. Nem ali haverá paz para ti."
,"13":"Olha a terra dos caldeus, esse povo que não existia. Os assírios entregaram-na às feras, levantaram torres de vigia, destruíram os seus palácios e fizeram de tudo uma ruína."
,"14":"Uivai, navios de Társis, porque o vosso refúgio foi destruído."
,"15":"Naquele tempo, Tiro ficará esquecida durante setenta anos - a duração da vida de um rei - e no fim dos setenta anos, poderá ser aplicada a Tiro aquela canção da prostituta:"
,"16":"«Pega na cítara, percorre a cidade, prostituta esquecida. Toca com habilidade, canta muitas canções, para ver se alguém ainda se lembra de ti»."
,"17":"Então, passados setenta anos, Javé dará novamente atenção a Tiro. Ela voltará aos seus ganhos de prostituta e vender-se-á a todos os reinos da face da Terra."
,"18":"O seu lucro, o seu ganho de prostituta, será consagrado a Javé, de modo a não ajuntar dinheiro nem enriquecer, pois será tudo daqueles que moram na presença de Javé, para eles comerem, beberem e se vestirem com todo o luxo."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Javé vi arrasar a Terra e devastá-la; lançará confusão em toda a sua superfície e dispersará os seus habitantes."
,"2":"O mesmo acontecerá ao povo e ao sacerdote, ao escravo e ao patrão, à escrava e à sua senhora, ao comprador e ao vendedor, ao que empresta e a quem pede emprestado, ao devedor e ao credor."
,"3":"De facto, a Terra será devastada e despojada, porque foi Javé quem pronunciou esta sentença."
,"4":"A Terra está de luto, a perecer, o mundo vai definhando e morre, os grandes da Terra acabam."
,"5":"A Terra está profanada sob os pés dos seus moradores: eles transgrediram as leis, violaram os mandamentos e romperam a aliança eterna."
,"6":"Por isso, a maldição devorou a Terra, e os seus moradores recebem o castigo; por isso, a população da Terra desapareceu, e poucos são os que restam."
,"7":"O vinho novo enfraquece e a videira murcha; gemem todos os que estavam de coração alegre."
,"8":"Acabou o som festivo dos tambores, cessou a algazarra das pessoas em festa, cessou o som alegre das harpas."
,"9":"Já não se bebe vinho entre canções, as bebidas fortes sabem a amargo a quem as bebe."
,"10":"A Cidade da Desordem está arruinada: as casas estão fechadas, não entra mais ninguém."
,"11":"Gritam nas ruas: já não há vinho. O riso terminou, a alegria foi expulsa da Terra."
,"12":"Na cidade só restaram escombros, a porta ficou reduzida a ruínas."
,"13":"No meio da Terra e entre os povos sucederá o que acontece quando se vareja a oliveira ou quando se colhe o resto das uvas depois da vindima."
,"14":"Eles erguerão a voz, celebrando a glória de Javé. E gritam do lado do mar:"
,"15":"«Glorificai, portanto, a Javé; do lado do Oriente, das ilhas do mar, celebrai o nome de Javé, Deus de Israel."
,"16":"Do extremo da Terra, ouvimos o cântico: 'Glória ao Justo'». Mas eu digo: «Infeliz de mim! Infeliz de mim! Ai de mim!» Os traidores traíram, tramaram traições. "
,"17":"Terror, buraco e laço é o que te espera, morador da Terra."
,"18":"Quem fugir ao grito de terror, cairá no buraco; se conseguir sair do fundo do buraco, será apanhado no laço. Pois as comportas do céu abrir-se-ão e as bases da terra serão abaladas."
,"19":"A Terra será toda arrasada, a Terra será sacudida violentamente, a Terra será fortemente abalada."
,"20":"A Terra cambaleará como um bêbedo, balançará como uma tenda. A sua culpa pesará sobre ela. Cairá e nunca mais se levantará."
,"21":"Naquele dia, Javé julgará no Céu o exército do Céu; e, na Terra, os reis da Terra."
,"22":"Serão todos reunidos e presos na cadeia, ficarão fechados na prisão, e só depois de muito tempo é que serão julgados."
,"23":"A Lua ficará vermelha, o Sol empalidecerá, pois Javé dos exércitos reina no monte Sião e em Jerusalém, e será glorificado diante dos seus anciãos."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Javé, Tu és o meu Deus; eu Te exalto, e louvo o teu Nome, pois realizaste projectos maravilhosos, concebidos desde os tempos antigos com toda a fidelidade."
,"2":"Transformaste a cidade em monte de pedras, a cidade fortificada em ruínas, e a fortaleza na mão do estrangeiro já nem é cidade, e nunca mais será reconstruída."
,"3":"É por isso que um povo forte Te dá glória, a capital das nações tirânicas Te respeita."
,"4":"Porque Te tornaste uma protecção para o fraco, um apoio para o indigente na hora da sua aflição, um esconderijo no tempo das águas e uma sombra no sol forte. Porque o ímpeto dos tiranos é como a chuva de Inverno,"
,"5":"o tumulto dos estrangeiros como o calor de Verão. Tu alivias o sol forte com a sombra de uma nuvem e fazes calar o canto dos tiranos."
,"6":"Javé dos exércitos vai preparar no alto deste monte, para todos os povos do mundo, um banquete de carnes gordas, um banquete de vinhos finos, de carnes suculentas, de vinhos refinados."
,"7":"Neste monte, Javé arrancará o véu que cobre todos os povos, a cortina que esconde todas as nações."
,"8":"Ele destruirá para sempre a morte. O Senhor Javé enxugará as lágrimas de todas as faces, e eliminará da Terra inteira a vergonha do seu povo - foi Javé quem o disse."
,"9":"Dir-se-á naquele dia: «Eis o nosso Deus! Era n'Ele que esperávamos para que nos salvasse: celebremos e festejemos a sua salvação»."
,"10":"A mão de Javé pousará sobre este monte, enquanto Moab será pisado no chão, como se pisa a palha na estrumeira."
,"11":"Aí Moab estenderá as mãos, como faz o nadador ao nadar; mas o seu orgulho acabará por cair, apesar da agilidade das suas mãos."
,"12":"Javé vai abater e demolir a fortaleza altíssima dos seus muros e arrasá-la até ao chão."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Naquele dia cantar-se-á este cântico na Terra de Judá: «Nós temos uma cidade forte. Para a defender, Javé construiu muralhas e baluartes."
,"2":"Abri as portas para que entre um povo justo, que se mantém fiel."
,"3":"De modo firme, Tu garantirás a paz, porque ela confia em Ti."
,"4":"Confiai sempre em Javé, pois Javé é uma rocha para sempre."
,"5":"Ele rebaixou os moradores das alturas, a cidade inatingível. Abateu-a até ao solo, arrasou-a até ao pó."
,"6":"Ela será calcada pelos pobres e pisada pelos fracos»."
,"7":"A vereda do justo é recta, Tu aplanas o caminho do justo."
,"8":"Sim, Javé, na vereda das tuas sentenças esperamos em Ti, a nossa alma suspira pelo teu Nome e pela tua lembrança."
,"9":"Por Ti suspira a minha alma a noite toda, no meu íntimo o meu espírito procura por Ti, pois sempre que as tuas sentenças chegam à Terra, os habitantes do mundo aprendem a justiça."
,"10":"Se absolvemos o malvado, ele nunca aprende a justiça; sobre a terra ele distorce as coisas rectas e não vê a grandeza de Javé;"
,"11":"embora ergas a tua mão, Javé, eles não a vêem. Que vejam o teu ciúme por este povo, se envergonhem e sejam devorados pelo fogo preparado para os teus inimigos."
,"12":"Javé, Tu nos governarás na paz, pois és Tu que realizas tudo o que fazemos."
,"13":"Javé, nosso Deus, outros senhores nos dominaram; nós, porém, só invocamos o teu Nome."
,"14":"Os mortos não vão reviver, as sombras não se levantarão, porque Tu os castigaste, destruíste e fizeste com que nunca mais fossem lembrados."
,"15":"Fizeste crescer a nação, Javé, fizeste crescer a nação, e manifestaste a tua glória; alargaste as fronteiras do país."
,"16":"Javé, na angústia recorríamos a Ti e gritávamos a Ti no castigo com que nos corrigias."
,"17":"Como a mulher grávida na hora de dar à luz, contorcendo-se e gemendo nas dores de parto, assim nos encontrávamos, ó Javé, na tua presença."
,"18":"Nós engravidámos, sofremos dores do parto, mas o que demos à luz foi vento. Não demos a salvação ao país, não nasceram novos habitantes no mundo."
,"19":"Mas os teus mortos hão-de reviver e os seus cadáveres ressurgirão. Os que dormem no pó vão acordar e cantar, pois o teu orvalho é um orvalho de luz, e a terra das sombras dará à luz."
,"20":"Corre, meu povo, entra no teu quarto, fecha a porta por dentro e esconde-te durante algum tempo até que passe esta cólera."
,"21":"Porque Javé vai sair da sua casa para castigar os crimes dos habitantes da Terra. A terra devolverá o sangue derramado, não poderá mais esconder as suas vítimas."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Naquele dia, com a sua espada dura, grande e forte, Javé castigará Leviatã, serpente escorregadia, Leviatã, serpente tortuosa, e matará o dragão do mar."
,"2":"Naquele dia, cantareis a vinha formosa:"
,"3":"Eu, Javé, sou responsável por ela. Eu rego-a com frequência. Para que ninguém venha estragá-la, vigio-a dia e noite."
,"4":"Eu não estou encolerizado. Se nela crescessem espinhos e ervas daninhas, Eu lançar-me-ia contra eles para os queimar."
,"5":"Quem busca a minha protecção, fará as pazes comigo; sim, comigo fará as pazes."
,"6":"No futuro, Jacob criará raízes, Israel dará botões e flores, e os seus frutos cobrirão a terra."
,"7":"Porventura Javé feriu Jacob como feriu os seus perseguidores? Ou será que o matou, como matou os seus assassinos?"
,"8":"Javé castigou-os na medida certa, ao expulsá-los da sua Terra, ao levá-los para longe com vento forte, como em dia de vento oriental."
,"9":"Pois é assim que a culpa de Jacob será apagada; será esse o fruto por ele se ter afastado do seu pecado, quando reduzir todas as pedras do altar a pedras de cal que se transformam em pó, quando já se não erguerem postes sagrados e altares para o incenso."
,"10":"A fortaleza transformou-se em lugar de solidão, em casa desprezada, abandonada como o deserto: nela pastam bezerros, deitam-se e devoram os seus ramos."
,"11":"Os ramos secos quebram, vêm as mulheres e recolhem-nos para acender o fogo. Pois é um povo sem inteligência; por isso, o seu Criador não tem piedade dele, não se compadece dele o seu Criador."
,"12":"Naquele dia, Javé debulhará as espigas desde o grande rio até ao riacho do Egipto. E vós, israelitas, sereis recolhidos um a um."
,"13":"Naquele dia, soará a grande trombeta e hão-de vir os que estão espalhados na Assíria e os exilados no Egipto. E todos se ajoelharão diante de Javé, no monte santo, em Jerusalém."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Ai da coroa soberba dos bêbedos de Efraim, da flor murcha que usam como enfeite e que cresce no alto do vale fértil! Ai dos que estão encharcados de vinho!"
,"2":"Vede: um homem forte e robusto enviado pelo Senhor, como granizo, como furacão devastador, como chuva torrencial que alaga tudo: com a mão, ele deita ao chão"
,"3":"e pisa com os pés a coroa soberba dos bêbedos de Efraim"
,"4":"e a flor murcha que usam como enfeite e que cresce no alto do vale fértil. É como figo temporão: mal alguém o vê, colhe-o e come-o."
,"5":"Naquele dia, Javé dos exércitos será uma coroa esplêndida, uma grinalda majestosa para o resto do seu povo:"
,"6":"será um inspirador de justiça para aqueles que se sentam para julgar, e será força para os que repelem o ataque à porta da cidade."
,"7":"Também estes andam tontos de vinho, também eles cambaleiam pelo efeito da bebida forte. Sacerdotes e profetas estão confusos pela bebida, estão tomados pelo vinho, divagam sob o efeito da bebida, andam confusos nas suas visões, divagam nas suas sentenças."
,"8":"As mesas estão cheias de vómitos e sujeira: não há nenhum lugar limpo."
,"9":"A quem vai ele ensinar? A quem vai explicar a doutrina? A crianças desmamadas, que mal deixaram de mamar?"
,"10":"Ele diz: «çav laçav, çav laçav; cav lacav, cav lacav; zeer sham, zeer sham»."
,"11":"De facto, é com lábios balbuciantes e em língua estranha que se falará a este povo."
,"12":"Ele tinha-lhes dito: «Eis o descanso; deixai os cansados; este é um lugar tranquilo». Mas eles não quiseram ouvir."
,"13":"Então ser-lhes-á dita esta palavra de Javé: «çav laçav; çav laçav; cav lacav, cav lacav; zeer sham, zeer sham». Isso para que, ao andarem, caiam para trás, sejam derrotados, apanhados e presos."
,"14":"Escutai a Palavra de Javé, homens arrogantes, governantes desse povo que está na cidade de Jerusalém."
,"15":"Vós dizeis: «Fizemos aliança com a morte, com a morada dos mortos fizemos um acordo: quando o flagelo destruidor passar, não nos vai atingir, pois temos um abrigo na falsi-dade, escondemo-nos debaixo da mentira»."
,"16":"Por isso, assim diz o Senhor Javé: Eu vou assentar no monte Sião uma pedra, pedra escolhida, angular, preciosa e bem firmada; quem nela confiar, não será abalado."
,"17":"Vou estabelecer o direito como medida e a justiça como fio de prumo; o granizo arrasará o seu falso esconderijo e as chuvas torrenciais alagarão o seu abrigo."
,"18":"A sua aliança com a morte será quebrada, e cairá o seu acordo com a morada dos mortos; quando o flagelo destruidor passar, sereis esmagados."
,"19":"Cada vez que ele passar, vos rebentará; ele passará cada manhã, de dia e de noite. Então a angústia far-vos-á aprender a lição."
,"20":"E a cama vai ser muito curta para alguém dormir nela, e o cobertor estreito de mais para que possa cobrir alguém."
,"21":"Como aconteceu na montanha de Farasim, Javé vai levantar-Se; como aconteceu no vale de Gabaon, vai ficar enfurecido para completar o seu trabalho, um trabalho diferente; para acabar a sua tarefa, uma tarefa muito estranha."
,"22":"Deixai de zombar para que eles não apertem ainda mais as vossas algemas, pois ouvi falar da destruição que atingirá toda a Terra - é coisa decidida pelo Senhor Javé dos exércitos."
,"23":"Ouvi bem e escutai a minha voz, prestai atenção e aplicai os ouvidos às minhas palavras."
,"24":"Será que o lavrador fica todos os dias a lavrar o seu terreno para o plantio, abrindo sulcos e gradeando a sua terra?"
,"25":"Acaso, depois de aplanar a superfície, não espalha a semente de endro e não semeia o cominho? Depois, não semeia o trigo, a cevada, o milho e a aveia numa faixa lateral?"
,"26":"É o seu Deus que o instrui e lhe ensina as regras."
,"27":"Não é na debulhadeira que se bate o endro, nem se passam as rodas de uma carroça sobre o cominho, pois o endro debulha-se com vara e o cominho com bastão."
,"28":"Não se tritura o trigo, não se debulha continuamente, mas passa-se sobre ele a carroça que o debulha sem o triturar."
,"29":"Tudo isto vem de Javé dos exércitos; Ele é maravilhoso para dar conselhos e grandioso em sabedoria."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Ai de Ariel, Ariel, cidade onde David acampou! Juntai um ano a outro ano, até que o ciclo das festas se complete."
,"2":"E Eu, então, vou apertar Ariel, e só haverá choro e lágrimas. Tu serás para Mim como Ariel:"
,"3":"vou acampar contra ti, vou cercar-te com trincheiras e levantar torres de assédio contra ti."
,"4":"Humilhada, falarás do chão; a tua palavra sairá abafada pela poeira, e a tua voz subirá da terra como o sussurro de um fantasma que vem dum túmulo. A tua palavra será como um murmúrio que brota do chão."
,"5":"Pois a multidão dos teus inimigos será como a poeira mais fina; e a multidão dos teus agressores será como a palha que voa. Mas, de repente, sem avisar, "
,"6":"Javé dos exércitos virá em teu auxílio, com relâmpagos e trovões, ribombos colossais, temporais, furacões, e chamas de fogo devorador."
,"7":"Será como um sonho, uma visão nocturna, essa multidão de povos que atacam Ariel, que o atacam, agridem e apertam."
,"8":"Será como alguém que está com fome e sonha que está a comer: depois acorda e está de estômago vazio. Ou como aquele que está com sede e sonha que está a beber: quando acorda, está com a garganta cansada e seca. É o que vai acontecer a esta multidão de nações que atacam o monte Sião."
,"9":"Espantai-vos e ficai assombrados; ficai cegos, sem visão; ficai bêbedos, mas não de vinho; ficai tontos, mas não de bebidas fortes,"
,"10":"porque Javé derrama sobre vós um espírito embriagador que vos fecha os olhos e vos cobre a cabeça."
,"11":"Toda esta visão será para vós como palavras de um livro lacrado. Se alguém dá esse livro a uma pessoa que sabe ler e lhe diz: «Por favor, lê isto», ela responderá: «Não posso; está lacrado!»"
,"12":"Se derdes o livro a alguém que não sabe ler, dizendo-lhe: «Por favor, lê isto», ele responderá: «Eu não sei ler»."
,"13":"O Senhor disse: Este povo aproxima-se de Mim só com palavras, e só com os lábios Me glorifica, enquanto o seu coracção está longe de Mim. O culto que Me prestam é tradição humana e rotina."
,"14":"Por isso, continuarei a realizar maravilhas e prodígios; a sabedoria dos seus sábios fracassará e a inteligência dos seus inteligentes apagar-se-á."
,"15":"Ai daqueles que procuram esconder-se de Javé para ocultar os seus próprios projectos. Agem nas trevas, dizendo: «Quem nos vê? Quem nos conhece?»"
,"16":"Como sois perversos! O barro vai querer comparar-se com o oleiro? Poderá um trabalho qualquer dizer ao seu fabricante: «Não foste tu que me fizeste»? E o pote, será que pode dizer ao seu oleiro: «Tu não entendes nada disto»?"
,"17":"Muito em breve, não será o Líbano transformado em pomar, e o pomar não parecerá um bosque?"
,"18":"Nesse dia, os surdos ouvirão as palavras do livro; e os olhos do cego, libertos da escuridão e das trevas, tornarão a ver."
,"19":"Os pobres voltarão a alegrar-se com Javé, e os indigentes da Terra ficarão felizes com o Santo de Israel."
,"20":"Pois não haverá mais ditador, e aquele que zombava de todos desaparecerá; e todos os que tramam o mal serão eliminados:"
,"21":"os que acusam alguém no processo, os que no tribunal procuram enganar o juiz e, por um nada, arruínam o justo."
,"22":"Por isso, assim diz Javé, Deus da casa de Jacob, Ele que resgatou Abraão: Jacob não ficará envergonhado, o seu rosto não ficará pálido,"
,"23":"porque vendo o trabalho das minhas mãos no meio deles, santificará o meu Nome, santificará o Santo de Jacob e temerá o Deus de Israel."
,"24":"Aqueles que haviam perdido a cabeça compreenderão, e aqueles que protestavam hão-de aprender a lição."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Ai de vós, filhos rebeldes! - oráculo de Javé. Fazeis planos que não nascem de Mim, fazeis acordos sem a minha inspiração, de maneira que amontoais erros e mais erros."
,"2":"Desceis a caminho do Egipto sem perguntar a minha opinião; pedis a protecção do Faraó e quereis abrigar-vos à sombra do Egipto."
,"3":"No entanto, a protecção do Faraó será para vós um fracasso, e abrigar-vos à sombra do Egipto será uma decepção."
,"4":"Quando as vossas autoridades chegarem a Tânis, quando os embaixadores tiverem chegado a Anúsis,"
,"5":"todos serão enganados por um povo inútil, do qual não vem ajuda nem proveito, mas só fracasso e decepção."
,"6":"Oráculo contra as bestas do Sul. Através de uma região dura e difícil, de onde vêm leoas e leões rugidores, víboras e dragões voadores, levam a um povo inútil as suas riquezas sobre o dorso dos burros, e os seus tesouros em corcovas de camelos."
,"7":"O Egipto é vazio e inútil. Por isso, dei-lhe o nome de Monstro inofensivo."
,"8":"Agora, vai e escreve isto numa tabuinha; vai e regista tudo num livro, para que no futuro seja algo que esteja sempre a acusá-los."
,"9":"Pois esse povo é rebelde, é gente mentirosa, que não quer ouvir a lei de Javé."
,"10":"Eles dizem aos videntes: «Não tenhais visões«; dizem aos profetas: «Não profetizeis com sinceridade; dizei-nos só coisas agradáveis; profetizai ilusões;"
,"11":"afastai-vos do caminho, retirai-vos da vereda; deixai de colocar diante de nós o Santo de Israel»."
,"12":"Por isso diz o Santo de Israel: já que desprezastes esta mensagem e quereis apoiar-vos na opressão e na maldade, colocando nela a vossa esperança,"
,"13":"então esse pecado será para vós como uma fenda que provoca saliência numa parede alta, e esta, de repente, num segundo, desmorona,"
,"14":"como se quebra uma vasilha de barro, sem dó nem piedade, e dela não resta nem sequer um caco para tirar uma brasa do fogão ou um gole de água do poço."
,"15":"Pois assim diz o Senhor Javé, o Santo de Israel: Na conversão e na calma está a vossa salvação, e a vossa força consiste em confiar e ficar tranquilos. Mas vós não quisestes"
,"16":"e até chegastes a dizer: «Não! Vamos fugir a cavalo». Pois então, fugi. «Nós montaremos cavalos ligeiros». Pois os vossos perseguidores serão mais velozes."
,"17":"Mil fugirão diante da ameaça de um só; e diante da ameaça de cinco, todos vós fugireis, sem ficar ninguém para trás, como poste no topo de um monte ou mastro no alto de uma colina."
,"18":"Entretanto, Javé espera para vos perdoar, Ele toma a iniciativa de mostrar compaixão de vós, pois Javé é um Deus justo. Felizes todos os que n'Ele confiam."
,"19":"Povo de Sião que moras em Jerusalém, já não chorarás mais, pois Ele vai compadecer-Se do clamor da tua súplica. Quando a ouvir, responderá."
,"20":"Ainda que Javé vos tenha dado pão racionado e água sob medida, Aquele que te instrui não tornará a esconder-Se, e os vossos olhos verão o vosso Mestre."
,"21":"Se vos desviardes para um lado ou para outro, ouvireis uma voz atrás de vós: «O caminho é este; é por aqui que deveis ir»."
,"22":"Achareis impuras as vossas imagens de madeira revestidas de prata e os vossos ídolos recobertos de ouro. Deitá-los-eis fora como coisa impura, dizendo: «Fora daqui»."
,"23":"Deus enviará chuva para as sementes que semeardes nos campos, de modo que o alimento produzido pelos campos será abundante e saboroso. Naquele dia, o gado vai pastar em pastagens bem espaçosas."
,"24":"Os bois e os animais que aram a terra comerão ração salgada, limpa com pá e joeira."
,"25":"No topo de cada monte, no alto de cada colina haverá riachos e fontes, no dia da grande mortandade, quando as torres caírem."
,"26":"No dia em que Javé enfaixar as feridas do seu povo e lhe curar as chagas, a Lua vai brilhar como o Sol, e o brilho do Sol será sete vezes maior, como o brilho de sete dias juntos."
,"27":"Olhai: Javé em pessoa vem de longe! A sua ira é ardente e o seu furor é intolerável. Os seus lábios estão cheios de indignação e a sua língua é fogo abrasador."
,"28":"O seu sopro é como o rio na enchente, que sobe até ao pescoço. Ele vai sacudir as nações na peneira da calamidade e vai colocar na boca dos povos um freio que os desencaminhe."
,"29":"Vós, porém, estareis cantando como em noite de festa, tereis o coração alegre como quando se dança ao som da flauta, para ir ao monte de Javé, à rocha de Israel."
,"30":"Javé fará ouvir a sua voz majestosa e mostrará o seu braço que golpeia com ira ardente no meio de um fogo abrasador, de raios, de tempestade e de granizo."
,"31":"A Assíria ficará apavorada com a voz de Javé, pois Ele vai feri-la com o seu bastão."
,"32":"Cada vez que Javé a golpear com a vara do castigo, será acompanhado de tamborins e harpas; Javé combaterá contra a Assíria com guerra sagrada."
,"33":"Porque há já muito tempo que Tofet está preparado e pronto para o rei; profunda e larga é a fogueira, com fogo e lenha em abundância: como rio de enxofre, o sopro de Javé vai acendê-la."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Ai daqueles que vão até ao Egipto em busca de ajuda e confiam nos cavalos. Confiam nos carros porque são numerosos e nos cavaleiros porque são muito fortes, em vez de olharem para o Santo de Israel, em vez de consultarem a Javé."
,"2":"No entanto, Ele também é sábio, é capaz de trazer o mal; Ele não deixa de cumprir a sua palavra. Ele vai levantar-Se contra a casa dos maus, contra a ajuda dos malfeitores."
,"3":"O egípcio é um homem e não um deus; os seus cavalos são carne e não espírito. Javé estenderá a sua mão: o protector tropeçará, o protegido cairá e os dois perecerão."
,"4":"Pois foi isto o que Javé me disse: Assim como ruge o leão ou os seus filhotes sobre a sua presa, enquanto gritam contra eles um grupo de pastores, eles não se deixam intimidar pelos seus gritos, nem cedem ao seu tumulto, assim Javé dos exércitos descerá para combater sobre o monte Sião, sobre a sua colina."
,"5":"Como ave que abre as asas para proteger os seus filhotes, assim Javé dos exércitos protegerá Jerusalém. Ele a protegerá, e ela será salva; Ele a poupará, e ela será liberta."
,"6":"Filhos de Israel, convertei-vos Àquele contra o qual vos revoltastes!"
,"7":"Naquele dia, todos deitarão fora os ídolos de prata ou de ouro que as suas mãos pecaminosas fabricaram."
,"8":"A Assíria cairá ao fio de uma espada que não pertence a nenhum homem, será devorada por uma espada que não é de nenhum ser humano; e se os seus jovens escaparem da espada, cairão em trabalhos forçados."
,"9":"A sua protecção fugirá apavorada e os seus chefes abandonarão as bandeiras - oráculo de Javé que tem o seu fogo em Sião e a sua fornalha em Jerusalém."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Um rei reinará conforme a justiça, e os chefes governarão conforme o direito."
,"2":"Cada um deles será como um abrigo contra o vento, como um refúgio contra a tempestade. Será como um riacho em terra seca ou sombra de uma grande pedra no deserto."
,"3":"Os olhos daqueles que vêem não se fecharão, os ouvidos daqueles que escutam estarão atentos;"
,"4":"a mente precipitada aprenderá a discernir, e a língua dos gagos falará com facilidade e clareza."
,"5":"Já não se chamará nobre a um tolo, nem se dirá que o trapaceiro é ilustre,"
,"6":"pois o tolo diz tolices, e no seu coração planeia o crime; pratica a impiedade e afirma coisas erradas a respeito de Javé; deixa vazio o estômago do faminto e sem água o sedento."
,"7":"O trapaceiro arma ciladas e maquina intrigas; prejudica os pobres com mentiras e os indigentes que defendem o próprio direito."
,"8":"O nobre, ao invés, planeia coisas nobres e age sempre com nobreza."
,"9":"Mulheres despreocupadas, levantai-vos e escutai a minha voz. Senhoras tranquilas, prestai atenção ao que vou dizer."
,"10":"Daqui a um ano e alguns dias, vós que hoje vos sentis tão seguras, ficareis abaladas, porque a vindima estará perdida e a colheita frustrada."
,"11":"Despreocupadas começai a tremer, tranquilas estremecei, despi-vos até ficardes nuas, e colocai roupa de saco na cintura."
,"12":"Batei no peito por causa dos campos amenos, por causa das parreiras carregadas de cachos,"
,"13":"por causa das terras do meu povo, onde só crescerão espinhos e ervas daninhas, por causa das casas alegres e da cidade festiva."
,"14":"Porque o palácio do rei está vazio, a cidade populosa está deserta, o monte Ofel e a Torre de Vigia transformar-se-ão para sempre em campinas, alegria dos jumentos e pasto de rebanhos de cabras."
,"15":"Será derramado outra vez sobre nós um espírito que vem do alto. Então o deserto tornar-se-á um jardim, e o jardim converter-se-á em bosque."
,"16":"No deserto habitará o direito, e a justiça habitará no jardim."
,"17":"O fruto da justiça será a paz. De facto, o trabalho da justiça resultará em tranquilidade e segurança permanentes."
,"18":"O meu povo habitará num lugar pacífico, em residência segura, em habitação tranquila,"
,"19":"mesmo que o bosque seja cortado e a cidade seja arrasada."
,"20":"Felizes de vós que semeais à beira dos riachos e deixais o boi e o jumento em liberdade."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Ai de ti, devastador que ainda não foste devastado, ladrão que ainda não foste roubado. Pois quando acabares de destruir, tu é que serás destruído; quando tiveres acabado de roubar, então também tu serás roubado."
,"2":"Javé, tem piedade de nós, pois esperamos em Ti! Sê o nosso auxílio pela manhã e a nossa salvação no perigo."
,"3":"Os povos fogem do barulho que provocas; quando Te ergues, as nações dispersam-se."
,"4":"Amontoam os teus despojos como se amontoam os insectos, como bandos de gafanhotos."
,"5":"Javé é exaltado porque mora nas alturas e enche Sião de direito e justiça."
,"6":"A fidelidade será enfeite para Sião, a sabedoria e o conhecimento serão a sua provisão salvadora, e o temor de Javé será o seu tesouro."
,"7":"Escutai! Os arautos gemem nas ruas, os mensageiros da paz choram amargamente!"
,"8":"Os caminhos estão desertos e ninguém passa pelas estradas. A aliança foi quebrada, as testemunhas são desprezadas e ninguém é respeitado."
,"9":"O país está de luto, o Líbano perde a cor e seca, o Saron parece um deserto, caem as folhas de Basã e do Carmelo."
,"10":"Javé diz: Agora Eu Me levantarei, agora Eu Me erguerei, agora Eu Me glorificarei."
,"11":"Vós concebestes feno e dareis à luz palha. O meu sopro, como um fogo vos consumirá."
,"12":"Os povos serão queimados como cal, irão para o fogo como ramos de espinhos cortados."
,"13":"Vós que estais longe, ouvi o que Eu fiz. Vós que estais perto reconhecei o meu poder."
,"14":"Os pecadores em Sião ficam apavorados, um tremor tomou conta dos ímpios. Eles dizem: «Quem de nós poderá permanecer neste fogo devorador? Quem de nós resistirá a este braseiro que não se apaga?»"
,"15":"Quem age com justiça, quem fala com rectidão, quem recusa o lucro da opressão, quem retira a mão recusando o suborno, quem tapa os ouvidos a propostas sanguinárias, quem fecha os olhos para não ver o mal."
,"16":"Esse vai morar nas alturas: fortaleza sobre a rocha será o seu refúgio, com abundância de pão e reserva de água."
,"17":"E os teus olhos contemplarão o rei com todo o seu esplendor: contemplarás um país imenso."
,"18":"E o teu pensamento irá relembrar estes terrores passados: «Onde está o escriba, onde está o homem da balança, onde está o homem que contava as torres?»"
,"19":"Já não verás mais um povo arrogante, de língua complicada e incompreensível, de língua estranha que ninguém entende."
,"20":"Olha bem para Sião, a cidade das nossas festas: os teus olhos verão Jerusalém, a morada tranquila, tenda que não será removida, cujas estacas não serão arrancadas, e cujas cordas não se soltarão,"
,"21":"pois lá Javé é poderoso para nós, num lugar de rios e largos canais; por ali não passarão barcos a remo, nem atravessarão grandes navios."
,"22":"pois Javé é o nosso juiz, Javé é o nosso legislador, Javé é o nosso rei: Ele nos salvará."
,"23a":"As vossas cordas estão bambas e não conseguem firmar o mastro nem abrir a vela,"
,"23b":"Então serão tantas as conquistas a repartir que até os aleijados tomarão parte na pilhagem."
,"24":"Nenhum morador dirá: «Estou doente». O povo que mora em Jerusalém será perdoado das suas culpas."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Aproximai-vos, nações, para ouvir; povos, prestai atenção. Que a Terra escute e os que nela habitam, o mundo e tudo o que ele contém,"
,"2":"pois Javé está irado contra todas as nações e enfurecido contra todos os seus exércitos. Já os destinou a todos à eliminação total, já os entregou à matança."
,"3":"Os seus mortos são lançados fora, dos cadáveres exala mau cheiro, e os montes ensopam-se com o seu sangue;"
,"4":"o exército do céu desmancha-se, o céu enrola-se como um pergaminho, e os seus astros caem como as folhas da parreira, como as folhas da figueira,"
,"5":"pois a espada de Javé ficou embriagada no céu. Vede: ela precipita-se sobre Edom, um povo que destinei à destruição."
,"6":"A espada de Javé está a pingar sangue, está banhada de gordura, cheia do sangue de cordeiros e cabritos, da gordura do lombo dos carneiros, para que se ofereça um sacrifício a Javé em Bosra, uma enorme matança no país de Edom."
,"7":"Com eles morrem também búfalos, bezerros e touros. A sua terra empapa-se de sangue, o chão está banhado de gordura,"
,"8":"pois este é um dia de vingança para Javé, é um dia de acerto de contas em favor de Sião."
,"9":"Os seus ribeiros transformar-se-ão em pez, o pó da sua terra em enxofre e o seu chão ficará como pez a ferver."
,"10":"Passam dias e noites e o chão não arrefece, fica a deitar fumo para sempre. De geração em geração fica no abandono, e era após era ninguém mais por ali passa."
,"11":"Os seus herdeiros são o pelicano e o ouriço; a coruja e o milhafre fazem ali a sua morada. Javé estenderá ali o prumo do caos e o nível da confusão."
,"12":"Não haverá nobres para proclamar um rei, os seus chefes desaparecerão."
,"13":"Crescerão espinhos nos seus palácios e, nas suas fortalezas, ervas daninhas e urtigas; será morada do lobo, esconderijo dos filhotes de avestruz."
,"14":"Ali viverão o gato selvagem e a hiena, o cabrito montês chamará os seus companheiros; aí Lilit vai descansar e encontrar um lugar de repouso."
,"15":"Ali se aninhará a cobra, que porá, chocará os seus ovos e recolherá a sua ninhada à sua sombra; ali se reunirão as aves de rapina, cada qual com a sua companheira."
,"16":"Pesquisai o livro de Javé e lede: não faltará nenhum deles, nenhum estará sem o seu companheiro, porque assim ordenou a boca de Javé e o seu sopro os reuniu."
,"17":"Foi Ele mesmo que deitou as sortes, foi o próprio Deus que tomou a corda para medir as extremas de cada um. Serão eles os proprietários para sempre; de geração em geração eles ali vão morar."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Alegrem-se o deserto e a terra seca, o campo floresça de alegria;"
,"2":"como o narciso, cubra-se de flores transbordando de contentamento e alegria, pois ser-lhe-á dado o esplendor do Líbano, a beleza do Carmelo e do Saron. Todos verão a glória de Javé, a beleza do nosso Deus."
,"3":"Fortalecei as mãos cansadas, firmai os joelhos cambaleantes;"
,"4":"dizei aos corações desanimados: «Sede fortes! Não tenhais medo! Olhai para o vosso Deus: Ele vem para vingar, traz um prémio divino, vem para vos salvar»."
,"5":"Então, os olhos dos cegos vão abrir-se, e abrir-se-ão também os ouvidos dos surdos;"
,"6":"o coxo saltará como um veado, e a língua do mudo dará gritos de alegria, porque jorrarão águas no deserto e rios na terra seca."
,"7":"A terra seca converter-se-á em várzea, e o chão seco encher-se-á de fontes. E onde viviam os lobos, crescerão canas e juncos."
,"8":"Haverá ali uma estrada, um caminho, a que chamarão caminho santo. Nenhum impuro passará por ele, e os tolos não vão errar o caminho."
,"9":"Ali não haverá leões, nenhum animal selvagem poderá alcançar esse caminho. Por ele só andarão os que foram redimidos"
,"10":"e os que foram resgatados por Javé. Cantando, irão voltar e chegar a Sião: sentirão uma alegria sem fim e serão acompanhados de prazer e alegria; a tristeza e o pranto fugirão."
}`)
	CurrentBook.AddChapter(36, `{
"1":"No décimo quarto ano do rei Ezequias, Senaquerib, rei da Assíria, atacou todas as cidades fortificadas de Judá e apossou-se delas."
,"2":"De Láquis, o rei da Assíria mandou a Jerusalém, ao rei Ezequias, um alto funcionário acompanhado de poderoso séquito. O alto funcionário parou perto do canal que leva a água para o reservatório superior, no caminho do campo do Pisoeiro."
,"3":"Saíram ao encontro dele Eliacim, filho de Helcias, administrador do palácio, e o escrivão Sobna, além do secretário Joaé, filho de Asaf."
,"4":"O funcionário do rei da Assíria disse: «Ide referir o seguinte a Ezequias: Assim diz o grande rei, o rei da Assíria: Que confiança é essa em que te apoias?"
,"5":"Pensas que a estratégia e a valentia militares são palavras vãs? Em quem te apoias para me resistires?"
,"6":"Ah! Apoias-te no Egipto, cana rachada que fere as mãos e espeta lascas naquele que nela se apoia. O Faraó, rei do Egipto, é isso para quem nele confia."
,"7":"Ou dizes-me: 'É em Javé nosso Deus que nós confiamos!' No entanto, não eram dedicados a Ele os lugares altos e os altares que Ezequias eliminou, dizendo a Judá: 'É só aqui em Jerusalém, diante deste único altar, que deveis adorar a Deus'?"
,"8":"Faz, então, uma aposta com o meu senhor, o rei da Assíria: dar-te-ei dois mil cavalos, se fores capaz de encontrar cavaleiros para os montar a todos."
,"9":"Então, como é que serás capaz de derrotar o menor dos servos do meu senhor? Esperas que o Egipto te dê carros e cavaleiros?"
,"10":"Pensas que foi sem a vontade de Javé que eu subi para atacar este país, a fim de o destruir? Foi Javé quem me disse: 'Ataca e devasta esse país'»."
,"11":"Eliacim, Sobna e Joaé disseram ao funcionário assírio: «Fala com os teus servos em aramaico, pois nós entendemos. Não fales em hebraico, senão a gente que está em cima das muralhas vai entender»."
,"12":"O funcionário assírio respondeu: «Porventura foi somente ao vosso senhor ou só a vós que o meu senhor mandou trazer esta mensagem? Pois foi também para essa gente que está sentada na muralha, condenada juntamente convosco a comerem as próprias fezes e a beberem a própria urina»."
,"13":"Então, o funcionário assírio tomou posição e disse em voz alta em hebraico: «Escutai as palavras do grande rei, o rei da Assíria."
,"14":"Assim diz o rei: Não vos deixeis enganar por Ezequias, pois ele não é capaz de vos salvar."
,"15":"Que Ezequias não vos faça confiar em Javé, dizendo: 'Javé livrar-nos-á e não entregará esta cidade ao rei da Assíria'."
,"16":"Não deis ouvidos a Ezequias, porque assim diz o rei da Assíria: Rendei-vos e fazei a paz comigo; então, cada um poderá comer tranquilamente os frutos da própria parreira e da própria figueira, e beber a água do próprio poço."
,"17":"Isto, até que eu vos leve para uma terra igual à vossa, para um lugar onde também há trigo, vinho, pão, videiras."
,"18":"Não deixeis que Ezequias vos engane, dizendo: 'Javé livrar-nos-á'. Acaso, o deus de cada um desses países pôde livrá-los das mãos do rei da Assíria?"
,"19":"Onde estão os deuses de Emat e Arfad? Onde estão os deuses de Sefarvaim? Eles foram capazes de livrar a Samaria da minha mão?"
,"20":"Qual dos deuses de todas essas terras foi capaz de livrar o seu país das minhas mãos?»"
,"21":"Todos ficaram calados. Ninguém respondeu coisa alguma, pois o rei tinha-lhes ordenado que não respondessem."
,"22":"Eliacim, filho de Helcias, administrador do palácio, o escrivão Sobna e o secretário Joaé, filho de Asaf, depois de rasgarem as vestes, foram contar a Ezequias tudo o que o funcionário assírio tinha dito."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Ao acabar de ouvir tudo isto, o rei Ezequias rasgou as próprias vestes, vestiu-se de pano de saco e foi para o Templo de Javé."
,"2":"Mandou Eliacim, o administrador do palácio, o escrivão Sobna e os sacerdotes que eram os seus conselheiros, todos vestidos de pano de saco, procurar o profeta Isaías, filho de Amós."
,"3":"Disseram a Isaías: «Assim diz Ezequias: Hoje é dia de angústia, castigo e humilhação. Chega a hora da criança nascer, mas falta força para dar à luz."
,"4":"Oxalá Javé, teu Deus, tenha ouvido o que disse o funcionário que o rei da Assíria mandou para insultar o Deus vivo; e assim Javé, teu Deus, o castigue pelas palavras que tenha ouvido. Roga-Lhe em favor do resto que ainda vive»."
,"5":"Quando os funcionários do rei Ezequias chegaram aonde estava Isaías,"
,"6":"ele deu-lhes esta resposta: «Eis o que devereis dizer ao vosso senhor: Assim diz Javé: Não fiques com medo por causa das palavras com que os servos do rei da Assíria te injuriaram."
,"7":"Eu vou colocar nele um espírito de medo; ele voltará para a sua terra logo que ouvir um boato, e fá-lo-ei morrer à espada»."
,"8":"O funcionário do rei da Assíria voltou e encontrou o rei a lutar em Lebna, pois tinha ouvido dizer que o rei se havia afastado de Láquis."
,"9":"Pois o rei tinha recebido a notícia de que Taraca, rei da Etiópia, saíra em guerra contra ele. Senaquerib tornou a mandar mensageiros a Ezequias com este recado: "
,"10":"«Dizei a Ezequias, rei de Judá: Que o teu Deus, em quem confias, não te engane dizendo que não vai entregar Jerusalém nas mãos do rei da Assíria."
,"11":"Já ouviste falar da maneira como os reis da Assíria trataram todos os países, condenando-os à destruição total. E serás tu que vais escapar?"
,"12":"Acaso os deuses das nações, que os meus antepassados destruíram, puderam livrá-las? É o caso de Gozã, de Harã, de Resef e dos edenitas que povoavam Telbasar."
,"13":"Onde está o rei de Emat? E o rei de Arfad? E o de Lair? Onde estão os reis de Sefarvaim, de Ana e de Ava?»"
,"14":"Ezequias recebeu a carta da mão dos mensageiros, leu-a e foi para o Templo de Javé. Ali Ezequias abriu a carta na presença de Javé."
,"15":"Ezequias fez, então, a Javé esta prece:"
,"16":"«Javé dos exércitos, Deus de Israel, sentado sobre os querubins: Tu és o único Deus de todos os reinos do mundo. Tu fizeste o Céu e a Terra."
,"17":"Fique atento o teu ouvido, Javé, e escuta; abre os teus olhos, Javé, e vê. Ouve tudo o que Senaquerib manda dizer para insultar o Deus vivo."
,"18":"É verdade, Javé: os reis da Assíria eliminaram à espada todos os países e seus territórios."
,"19":"Ele queimou todos os seus deuses, porque não são deuses, mas coisa produzida pela mão do homem, objectos de madeira ou de pedra que puderam ser destruídos."
,"20":"Agora, Tu, Javé nosso Deus, livra-nos das suas mãos, para que todos os reinos do mundo saibam que Tu, Javé, és o único Deus»."
,"21":"Então Isaías, filho de Amós, mandou dizer a Ezequias: «Assim diz Javé, Deus de Israel: Já que Me dirigiste a tua prece por causa de Senaquerib, rei da Assíria,"
,"22":"aqui está a mensagem que Javé te manda: A jovem filha de Sião despreza-te, ela zomba de ti; atrás de ti a filha de Jerusalém abana a cabeça."
,"23":"A quem desafiaste e insultaste? Contra quem ergueste a voz e levantaste os olhos para o alto? Contra o Santo de Israel!"
,"24":"Por meio dos teus servos, insultaste o Senhor, dizendo: 'Com a multidão dos meus carros eu subi ao topo dos montes, até aos lugares inacessíveis do Líbano. Eu cortei-lhe os mais altos cedros e os mais belos ciprestes. Cheguei ao seu ponto mais alto, aos seus bosques mais fechados."
,"25":"Eu mesmo abri o poço, eu mesmo bebi a água, água estrangeira. Com a planta do meu pé sequei todos os rios do Egipto'."
,"26":"Acaso, nunca ouviste falar disto? Já há muito tempo que Eu o decidi; preparei-o nos tempos antigos e realizo-o agora. A tua parte era fazer das cidades fortificadas um montão de ruínas;"
,"27":"deixar os seus habitantes de mãos atadas, morrendo de medo e vergonha. Eram como erva dos campos, grama dos prados, erva no telhado, queimada pelo vento Leste."
,"28":"Eu sei quando te sentas e te levantas, quando entras e quando sais."
,"29":"Já que Me odeias e a tua arrogância chegou aos meus ouvidos, vou colocar uma argola no teu focinho e um freio na tua boca, para te levar pelo mesmo caminho por onde vieste até aqui."
,"30":"Isto te servirá de sinal, Ezequias: Este ano, comereis do que nascer sem plantar; no ano que vem, do que brotar sem semear; no terceiro ano, porém, ides semear e colher, plantareis vinhas e comereis os seus frutos."
,"31":"O resto que sobrar da casa de Judá criará raízes debaixo do chão e dará frutos por cima."
,"32":"Pois de Jerusalém deverá sair um resto, os sobreviventes do monte Sião. O zelo de Javé dos exércitos fará isso."
,"33":"Assim diz Javé acerca do rei da Assíria: Ele não vai entrar nesta cidade, nem atirar uma única flecha, nem armar-se de escudo e nem mesmo entrincheirar-se contra ela."
,"34":"Voltará pelo caminho por onde veio. Nesta cidade, ele não entrará - oráculo de Javé."
,"35":"Eu mesmo vou proteger esta cidade, a fim de a salvar; por minha causa e também por causa do meu servo David»."
,"36":"Naquela mesma noite, o Anjo de Javé feriu no acampamento dos assírios cento e oitenta e cinco mil homens. De manhã, ao acordar, só se viam cadáveres."
,"37":"Senaquerib, rei da Assíria, levantou acampamento, foi-se embora e voltou para Nínive, e ali permaneceu."
,"38":"E uma vez, quando ele estava de bruços fazendo a sua adoração no templo do seu deus Nesroc, os seus filhos Adramelec e Sarasar assassinaram-no à espada e, em seguida, fugiram para o país de Ararat. O outro seu filho, Asaradon, reinou em seu lugar."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Naquele tempo, Ezequias adoeceu de uma enfermidade mortal. O profeta Isaías, filho de Amós, foi visitá-lo e disse-lhe: «Assim diz Javé: Põe em ordem a tua casa porque vais morrer, não vais escapar»."
,"2":"Então Ezequias virou o rosto para a parede e fez esta prece a Javé: «Ah! Javé! Não Te esqueças: eu procurei sempre andar na tua presença com toda a fidelidade e de coração limpo, e procurei sempre fazer o que era bom aos teus olhos»."
,"3":"E Ezequias começou a chorar convulsivamente."
,"4":"Então, a palavra de Javé foi dirigida a Isaías com esta mensagem:"
,"5":"«Vai dizer a Ezequias: Assim diz Javé, o Deus do teu antepassado David: Ouvi a tua oração, e vi as tuas lágrimas. Vou acrescentar quinze anos à duração da tua vida."
,"6":"Vou também livrar-te a ti e a esta cidade, das mãos do rei da Assíria. Eu mesmo vou proteger esta cidade»."
,"21":"Isaías ordenou: «Trazei um emplastro de figos e colocai-o sobre a ferida, para que ele recupere a saúde»."
,"22":"Ezequias disse: «Qual é o sinal de que subirei ao Templo de Javé?»"
,"7":"Isaías respondeu: «O sinal de que Javé vai cumprir o que prometeu, é este:"
,"8":"No relógio de sol de Acaz farei com que a sombra volte para trás os dez degraus que avançou». E o sol voltou para trás,os dez degraus que já tinha avançado no relógio."
,"9":"Cântico de Ezequias, rei de Judá, por ocasião da sua doença e da cura que obteve."
,"10":"Eu pensei: «No meio dos meus dias, partirei; pelo resto dos meus anos, ficarei postado à porta da mansão dos mortos»."
,"11":"Eu pensei: «Não verei mais a Javé na terra dos vivos, nem verei mais ninguém entre os habitantes da Terra."
,"12":"Levantam e enrolam a minha morada como tenda de pastores. Como um tecelão, eu tecia a minha vida e cortaram-me os fios. Dia e noite foste acabando comigo."
,"13":"Clamo até ao amanhecer. Como leão, quebras todos os meus ossos; dia e noite tu me consumias."
,"14":"Pio como a andorinha, e arrulho como a pomba; os meus olhos estão cansados de olhar para o alto. Estou oprimido: ajuda-me, Senhor!"
,"15":"Que direi, que poderei dizer se foi Ele quem fez isto? Hei-de passar todos os anos da minha vida com a alma amargurada."
,"16":"Aqueles que Deus protege, vivem; e, entre eles, viverá o meu espírito: Tu curaste-me e fizeste-me reviver."
,"17":"A minha amargura transformou-se em paz, quando arrancaste a minha vida da tumba vazia e voltaste as costas a todos os meus pecados."
,"18":"De facto, a mansão dos mortos não Te louva; não é a morte que Te entoa hinos. Quem desce à sepultura não espera na tua fidelidade."
,"19":"Quem está vivo é que vai louvar-Te, como eu Te louvo agora. O pai ensina aos seus filhos a tua fidelidade."
,"20":"Salva-me, Javé, e tocaremos as nossas harpas todos os dias da nossa vida no Templo de Javé»."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Nessa ocasião, o rei da Babilónia, Merodac-Baladã, filho de Baladã, mandou cartas e um presente a Ezequias, pois tinha tido notícia da sua enfermidade e da sua convalescença."
,"2":"Ezequias ficou muito satisfeito com isso e mostrou aos embaixadores toda a sua riqueza: a prata, o ouro, os perfumes, o óleo fino, e toda a casa de armas; enfim, tudo o que havia nos seus depósitos. Ezequias não deixou nada por mostrar de tudo o que havia no seu palácio e nas suas dependências."
,"3":"O profeta Isaías foi procurar o rei Ezequias e perguntou-lhe: «O que disseram esses indivíduos? De onde vieram eles?» Ezequias respondeu: «Eles vieram de um país muito distante. Vieram da Babilónia»."
,"4":"Isaías perguntou: «O que é que eles viram no teu palácio?» Ezequias respondeu: «Eles viram tudo o que existe no meu palácio. Não há nada do meu tesouro que eu lhes não tenha mostrado»."
,"5":"Isaías disse, então, a Ezequias: «Escuta a palavra de Javé dos exércitos:"
,"6":"Chegará um dia em que a Babilónia levará tudo o que existe no teu palácio, tudo o que os teus pais foram juntando até aos dias de hoje. Não ficará nada - diz Javé."
,"7":"Alguns dos filhos que saíram de ti, que tu geraste, serão levados para que sirvam como eunucos no palácio do rei da Babilónia»."
,"8":"Ezequias disse a Isaías: «É de felicidade a palavra de Javé que me transmites». Pois ele pensava assim: «Pelo menos durante a minha vida haverá paz e segurança»."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Consolai, consolai o meu povo, diz o vosso Deus."
,"2":"Falai ao coração de Jerusalém, gritai-lhe que já se completou o tempo da sua escravidão, que o seu crime já foi perdoado, que já recebeu da mão de Javé o duplo castigo por todos os seus pecados."
,"3":"Uma voz grita: «Abri no deserto um caminho para Javé; na região da terra seca, aplanai uma estrada para o nosso Deus."
,"4":"Que todo o vale seja aterrado, e todo o monte e colina sejam nivelados; que o terreno acidentado se transforme em planície, e as elevações em lugar plano."
,"5":"Então se revelará a glória de Javé, e todos a verão, pois assim falou a boca de Javé»."
,"6":"Uma voz diz-me: «Grita!» Eu respondo: «Que devo gritar?» E a voz diz-me: «Todo o ser humano é como a erva e toda a sua beleza é como a flor do campo:"
,"7":"a erva seca, a flor murcha, quando sobre elas sopra o vento de Javé;"
,"8":"a erva seca, a flor murcha, mas a Palavra do nosso Deus realiza-se sempre."
,"9":"Sobe a um monte alto, mensageira de Sião; levanta bem alto a tua voz, mensageira de Jerusalém. Levanta-a, não tenhas medo. Diz às cidades de Judá: 'Aqui está o vosso Deus'!"
,"10":"Olhai: o Senhor Javé chega com poder, e com o seu braço detém o governo. Ele traz consigo o prémio, e os seus troféus O precedem."
,"11":"Como um pastor, Ele cuida do rebanho, e com seu braço o reúne; leva os cordeirinhos ao colo e guia mansamente as ovelhas que amamentam»."
,"12":"Quem mediu toda a água do mar com a concha da mão? Quem mediu a palmos o tamanho do céu? Quem mediu com o alqueire o pó da terra? Quem pesou as montanhas na báscula e as colinas na balança?"
,"13":"Quem dirigiu o espírito de Javé, quem Lhe sugeriu o seu projecto?"
,"14":"A quem pediu conselho para Se instruir, para Lhe ensinar o caminho do direito, para Lhe ensinar a ciência e Lhe indicar o caminho da inteligência?"
,"15":"Para Ele, as nações são como gotas num balde, e não valem mais que poeira num prato da balança. Olhai: as ilhas pesam como um grão de areia."
,"16":"O Líbano não bastaria para acender o fogo, e os seus animais não bastariam para o holocausto."
,"17":"Diante de Javé as nações são como se não existissem; para Ele, não contam mais que o nada e o vazio."
,"18":"Com quem podereis comparar Deus? Que figura podereis encontrar para O representar?"
,"19":"O escultor faz uma estátua; vem o ourives reveste-a de ouro e solda-lhe correntes de prata."
,"20":"Quem faz uma oferta pobre, escolhe madeira que não apodreça e procura um escultor hábil para fazer uma estátua que não se mova."
,"21":"Porventura não sabeis? Nunca ouvistes dizer? Não vos foi anunciado desde o começo? Não compreendestes os fundamentos da Terra?"
,"22":"Javé senta-Se sobre o círculo da Terra, e os seus habitantes diante d'Ele parecem um bando de gafanhotos. Ele desdobra o céu como um toldo, e estende-o como a tenda para habitar."
,"23":"Ele reduz a nada os poderosos e aniquila os governantes da Terra."
,"24":"Logo que são plantados, logo que são semeados, logo que o seu tronco tenha criado raízes na terra, Deus sopra sobre eles e eles secam, e a primeira ventania leva-os como a palha."
,"25":"Acaso podereis comparar-Me com alguém que se pareça comigo? - pergunta o Santo."
,"26":"Erguei os olhos para o céu e observai: quem criou todos estes astros? Aquele que organiza e põe em marcha o exército das estrelas, chamando cada uma pelo nome. Tão grande é o seu poder e tão firme é a sua força, que ninguém deixa de se apresentar."
,"27":"Jacob, porque andas afirmando, e tu, Israel, porque andas dizendo: «Javé desconhece o meu caminho e o meu Deus ignora a minha causa»?"
,"28":"Não o sabes? Não ouviste dizer? Javé é o Deus eterno; foi Ele quem criou os confins do mundo. Ele não Se cansa, nem Se fatiga, e a sua inteligência é insondável."
,"29":"Ele dá ânimo ao cansado e recupera as forças do enfraquecido."
,"30":"Até os jovens se fatigam e cansam, e os rapazes também tropeçam e caem,"
,"31":"mas os que esperam em Javé renovam as suas forças, criam asas, como águias, correm e não se fatigam, podem andar que não se cansam."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Ilhas, calai-vos diante de Mim, e que os povos se reanimem. Depois, então, vinde falar, compareçamos juntos para o julgamento."
,"2":"Quem despertou no Oriente aquele que a vitória segue a cada passo? Quem lhe entrega as nações e quem lhe põe os reis debaixo dos pés? Quem faz com que os outros reis sejam para a sua espada como o pó e, para o seu arco, como palha que voa?"
,"3":"Ele persegue-os e passa-lhes adiante tranquilamente, por uma vereda que os seus pés mal tocam."
,"4":"Quem fez e executou tudo isto? Aquele que desde o início chama as gerações. Eu, Javé, que sou o primeiro e estarei também com os últimos."
,"5":"Ilhas, vede isto e tremei, e os confins da Terra estremeçam."
,"6":"Cada um anima o seu companheiro, dizendo-lhe: «Coragem!»"
,"7":"O escultor anima o ourives, aquele que forja com martelo anima a quem bate na bigorna, falando da solda: «Está boa». Depois fixa a estátua com pregos para que não se mova."
,"8":"Mas tu, Israel, és o meu servo. Eu escolhi-te, Jacob, descendente do meu amigo Abraão."
,"9":"Desde os confins do mundo Eu tomei-te e chamei-te dos extremos da Terra. Eu disse-te: «Tu és meu servo; Eu escolhi-te e não te rejeitei»."
,"10":"Não tenhas medo, pois Eu estou contigo. Não precisas de olhar com desconfiança, pois Eu sou o teu Deus. Eu fortaleço-te, ajudo-te e sustento com a minha direita vitoriosa."
,"11":"Ficarão envergonhados e confundidos todos os que contra ti se enfurecem, serão reduzidos a nada e perecerão os que lutam contra ti."
,"12":"Procurarás mas não encontrarás aqueles que te combatem. Serão reduzidos a nada e deixarão de existir os que guerreiam contra ti,"
,"13":"porque Eu sou Javé, o teu Deus, que te seguro com a minha mão direita e te digo: «Não tenhas medo; Eu mesmo te ajudarei»."
,"14":"Não tenhas medo, vermezinho Jacob, bichinho Israel. Eu mesmo te ajudarei - oráculo de Javé. O teu redentor é o Santo de Israel."
,"15":"Vou fazer de ti uma debulhadora de trigo, bem afiada, nova e de muitas pontas. Vais debulhar as montanhas até as reduzires a pó, e converterás as colinas em palha."
,"16":"Tu as joeirarás, levá-las-á o vento e o vendaval as dispersará. Exultarás em Javé e alegrar-te-ás no Santo de Israel."
,"17":"Os pobres e os indigentes procuram água, mas não a encontram; estão com a língua seca de sede. Eu mesmo, Javé, lhes responderei; Eu, o Deus de Israel, não os abandonarei."
,"18":"Pois farei nascer torrentes em colinas secas, e fontes nos vales; transformarei o deserto num lago e a terra seca em riachos de água."
,"19":"No deserto plantarei o cedro, a acácia, o mirto e a oliveira; na terra seca plantarei ciprestes, ulmeiros e pinheiros,"
,"20":"para que todos vejam e saibam, reflitam e aprendam que foi a mão de Javé que fez estas coisas, que foi o Santo de Israel que as criou."
,"21":"Apresentai os vossos argumentos - diz Javé. Alegai as vossas razões - diz o Rei de Jacob."
,"22":"Apresentai-nos e anunciai-nos o que vai acontecer; contai-nos as vossas profecias do passado, e prestaremos atenção; anunciai-nos o futuro, para que comprovemos a sua realização."
,"23":"Contai o que vai acontecer no futuro, e saberemos que sois deuses. Fazei alguma coisa, boa ou má, para que a vejamos e vos respeitemos."
,"24":"Vós sois menos do que nada. E quem vos escolhe é abominável."
,"25":"Eu despertei-o no Norte, e ele veio; do Nascente chamei-o pelo nome. Ele pisará os governantes como se fossem lama como o oleiro que amassa o barro."
,"26":"Quem anunciou isto desde o começo, para que o soubéssemos? Quem anunciou isto antes de acontecer, para que disséssemos: «É isso mesmo«? Ninguém o anunciou, ninguém o proclamou, ninguém ouviu as vossas palavras."
,"27":"Eu fui o primeiro a anunciá-lo em Sião, e enviei a Jerusalém um mensageiro com boas notícias."
,"28":"Procurei, mas não encontrei ninguém; entre eles, ninguém era capaz de dar um conselho, ninguém a quem eu pudesse perguntar e me desse uma resposta."
,"29":"Todos eles nada valem; o que eles fazem é um nada, e os seus ídolos são vento e ilusão."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Eis o meu servo, a quem Eu amparo; o meu escolhido, nele a minha alma se compraz. Eu coloquei sobre ele o meu espírito, para que promova o direito entre as nações."
,"2":"Ele não gritará nem clamará, nem fará ouvir a sua voz nas praças."
,"3":"Não quebrará a cana que já está rachada, nem apagará o pavio que ainda fumega. Promoverá fielmente o direito;"
,"4":"não desanimará, nem se abaterá, até implantar o direito na Terra e a Lei que as ilhas esperam."
,"5":"Assim diz o Deus Javé, que criou e estendeu os céus; que firmou a Terra e tudo o que ela produz. Ele dá respiração ao povo que nela habita e o espírito aos que sobre ela caminham:"
,"6":"«Eu, Javé, chamei-te para a justiça, tomei-te pela mão, dei-te forma, e coloquei-te como aliança de um povo e luz para as nações."
,"7":"Para abrires os olhos dos cegos, para tirares os presos da cadeia, e do cárcere os que vivem nas trevas."
,"8":"Eu sou Javé: este é o meu Nome. Não vou dar a outro a minha glória, nem vou ceder a minha honra aos ídolos."
,"9":"As primeiras coisas já aconteceram; coisas novas é o que agora anuncio: antes que elas aconteçam eu dou-vo-las a conhecer»."
,"10":"Cantai a Javé um cântico novo! Que O louvem até aos confins da Terra; que O celebrem o mar e tudo o que nele existe, as ilhas com os seus habitantes."
,"11":"Que o deserto e as suas cidades se alegrem, exultem as aldeias habitadas por Cedar; que os moradores de Petra aclamem e gritem do alto das montanhas."
,"12":"Dai glória a Javé e anunciai o seu louvor nas ilhas."
,"13":"Javé avança como um herói, como guerreiro acende o seu ardor; solta gritos de guerra, mostrando-Se forte contra os seus inimigos."
,"14":"Há muito tempo que estou em silêncio, permaneci calado e contive-Me. Agora vou gritar como a mulher que dá à luz, vou gemer e suspirar."
,"15":"Vou acabar com as montanhas e as colinas, vou secar o que elas têm de verde; transformarei os rios em terra seca e secarei os lagos."
,"16":"Guiarei os cegos por um caminho que eles não conhecem; vou levá-los por estradas desconhecidas; diante deles, transformarei as trevas em luz, e os caminhos pedregosos em caminhos planos. Eu mesmo vou fazer tudo isto por eles e não os abandonarei."
,"17":"Recuarão cobertos de vergonha aqueles que confiam nos ídolos, que dizem às estátuas: «Vós sois os nossos deuses»."
,"18":"Surdos, escutai; cegos, olhai e vede!"
,"19":"Quem é cego, senão o meu servo? Quem é surdo, senão o mensageiro que Eu enviei?"
,"20":"Viste muitas coisas, e nada percebeste; abriste os ouvidos, e nada ouviste!"
,"21":"Por causa da sua justiça, Javé queria engrandecer e glorificar a sua Lei;"
,"22":"mas o seu povo é um povo espoliado e roubado, todos presos em cavernas, trancados em prisões. Era saqueado, e ninguém o libertava; despojado, e ninguém dizia: «Devolve isso»."
,"23":"Quem de vós vai ouvir tudo isto e prestar atenção para escutar daqui por diante?"
,"24":"Quem foi que entregou Jacob ao saque e Israel ao despojo? Não foi Javé, contra quem pecámos, não querendo andar nos seus caminhos nem seguir a sua Lei?"
,"25":"Então Javé despejou sobre eles todo o ardor da sua ira e o furor da guerra, cujas chamas os envolveram, mas eles não compreenderam; eram queimados, mas não fizeram caso."
}`)
	CurrentBook.AddChapter(43, `{
"1":"Agora, porém, assim diz Javé, Aquele que te criou, Jacob, Aquele que te formou, ó Israel: Não tenhas medo, porque te redimi e te chamei pelo nome; tu és meu."
,"2":"Quando atravessares a água, Eu estarei contigo e os rios não te afogarão; quando passares pelo fogo, não te queimarás e a chama não te alcançará,"
,"3":"pois Eu sou Javé teu Deus, o Santo de Israel, o teu Salvador. Para pagar a tua liberdade, dei o Egipto, a Etiópia e Sabá em troca de ti,"
,"4":"porque és precioso para Mim, tens valor e Eu amo-te; dou homens por ti e povos em troca da tua vida."
,"5":"Não tenhas medo, pois estou contigo. Do Oriente farei vir a tua descendência, e do Ocidente te reunirei."
,"6":"Direi ao Norte: «Entrega-os». E ao Sul: «Não os retenhas». Traz de longe os meus filhos, traz dos confins da Terra as minhas filhas,"
,"7":"e todos os que são chamados pelo meu Nome: para minha glória Eu os criei, Eu os formei, e são obra minha."
,"8":"Faz sair o povo cego, embora tenha olhos; faz sair o povo surdo, embora tenha ouvidos."
,"9":"Todas as nações se reúnam, e os povos se juntem. Qual deles anunciou isto e nos fez ouvir as coisas passadas? Que apresentem as suas testemunhas e se justifiquem, para que possamos ouvir e depois dizer: «É verdade!»"
,"10":"As minhas testemunhas sois vós - oráculo de Javé - vós sois os meus servos, aqueles que Eu escolhi, para que saibais e acrediteis em Mim, e compreendais que Eu sou: nenhum deus existiu antes de Mim, e depois de Mim nenhum outro existirá."
,"11":"Eu, Eu sou Javé, e fora de Mim não existe nenhum salvador."
,"12":"Anunciei e salvei; anunciei, e não havia nenhum deus estrangeiro entre vós. Vós sois as minhas testemunhas - oráculo de Javé - Eu sou Deus,"
,"13":"e sou-o desde toda a eternidade. Não há quem possa livrar-se da minha mão. E quem poderá desfazer o que Eu faço?"
,"14":"Assim diz Javé, o vosso redentor, o Santo de Israel: Em vosso favor mandei alguém à Babilónia, arranquei todas as trancas das suas prisões, e os cânticos dos caldeus vão mudar-se em gemidos."
,"15":"Eu sou Javé, o vosso Santo, o Criador de Israel, o vosso rei."
,"16":"Assim diz Javé, Aquele que abriu um caminho no mar, uma passagem entre as ondas violentas,"
,"17":"Aquele que fez sair carros e cavalos, e um exército poderoso. Eles caíram para nunca mais se levantar, apagaram-se como pavio que se extingue."
,"18":"Não vos lembreis do passado, não penseis nas coisas antigas;"
,"19":"eis que vou fazer uma obra nova: ela está a começar agora, e vós não a vedes? Abrirei um caminho no deserto, rios em lugar seco."
,"20":"Glorificar-Me-ão as feras, os lobos e as avestruzes, porque farei brotar água no deserto e rios na terra seca para matar a sede do meu povo, do meu escolhido,"
,"21":"o povo que formei para Mim, para que proclame o meu louvor."
,"22":"Mas tu não me invocavas, Jacob; cansaste-te de Mim, Israel:"
,"23":"não Me trazias cordeiros para o holocausto nem Me honravas com os teus sacrifícios. Eu nunca te molestei exigindo oferendas, e nunca te perturbei pedindo incenso."
,"24":"Não Me compraste canela com dinheiro, nem Me saciaste com a gordura dos teus sacrifícios, mas ofendeste-Me com os teus pecados e cansaste-Me com as tuas culpas."
,"25":"Era Eu mesmo que limpava as tuas transgressões e não Me lembrava mais dos teus pecados."
,"26":"Desperta a minha memória, vamos colocar o nosso caso em julgamento. Apresenta as tuas razões, para que te possas justificar."
,"27":"O teu primeiro pai pecou; os teus chefes revoltaram-se contra Mim;"
,"28":"os teus dirigentes profanaram o meu santuário. Por isso entreguei Jacob à destruição e Israel ao opróbrio."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Agora, escuta, Jacob, meu servo; presta atenção, Israel, meu escolhido."
,"2":"Assim diz Javé, que te fez, que te formou no ventre e te auxilia: Não tenhas medo, meu servo Jacob, meu querido, meu escolhido."
,"3":"Vou derramar água no chão seco e rios na terra árida; vou derramar o meu espírito sobre os teus filhos e a minha bênção sobre os teus descendentes."
,"4":"Crescerão como planta junto à fonte, como árvores na margem dos rios."
,"5":"Um vai dizer: «Eu pertenço a Javé». Outro chamar-se-á Jacob; outro ainda escreverá na palma da mão: «De Javé». E receberá o sobrenome de Israel."
,"6":"Assim diz Javé, o Rei de Israel, teu redentor, Javé dos exércitos: Eu sou o primeiro, e sou o último; fora de Mim não existe nenhum outro deus."
,"7":"Existe alguém como Eu? Que fale, que Mo explique e exponha. Quem de antemão anunciou o futuro, quem nos predisse o que vai acontecer?"
,"8":"Não tenhais medo, não tremais: porventura Eu não o predisse e anunciei já há muito tempo? Vós sois as minhas testemunhas: existe algum outro deus além de Mim? Que Eu saiba, não existe nenhuma outra Rocha."
,"9":"Os fabricantes de estátuas nada são e as suas coisas preferidas não têm valor. Os seus devotos nada vêem nem conhecem, por isso acabam por ser enganados."
,"10":"Quem formaria um deus ou fundiria uma imagem, senão para conseguir alguma vantagem?"
,"11":"Eis que todos os seus devotos são enganados, porque os escultores não são mais que homens. Que eles todos se reúnam e compareçam: ficarão apavorados e envergonhados."
,"12":"O ferreiro trabalha o ídolo com a fornalha e modela-o com o martelo. Forja-o com a força do seu braço; mas, em dado momento, fica com fome e perde a força, ou então tem sede e fica exausto."
,"13":"O carpinteiro mede a madeira, desenha a lápis uma figura, e trabalha-a com o formão e aplica-lhe o compasso. Faz a escultura com medidas do corpo humano e com rosto de homem, para que essa imagem possa estar num templo feito de cedro."
,"14":"Corta cedros, escolhe um cipreste ou carvalho, deixando-os crescer no meio das árvores da floresta; planta um pinheiro e a chuva fá-lo crescer."
,"15":"Tudo isto serve para queimar; o próprio escultor usa parte dessa madeira para se aquecer e cozer o seu pão; e também fabrica um deus e diante dele se ajoelha, esculpe uma imagem para se ajoelhar diante dela."
,"16":"Com uma parte acende o fogo, assa a carne nas brasas e mata a fome; também se aquece ao fogo, e diz: «Que coisa boa! Eu aqueço-me, enquanto olho as chamas!»"
,"17":"Depois, com a outra parte faz um deus, uma imagem esculpida. Em seguida, ajoelha-se diante dela e faz uma oração, dizendo: «Salva-me, porque és o meu deus»."
,"18":"Eles não sabem e não entendem, porque os seus olhos estão cobertos para não ver, e a sua inteligência não pode compreender."
,"19":"Nenhum deles cai em si, ninguém percebe nem compreende, para dizer: «Com uma parte acendi o fogo, cozi pão nas suas brasas, cozinhei um pedaço de carne e comi; e com a outra parte irei fazer uma coisa abominável, e ajoelhar-me diante de um pedaço de madeira»?"
,"20":"Este homem alimenta-se de cinza. A sua mente enganada iludiu-o, de modo que ele não consegue salvar a própria vida e nem é capaz de dizer: «Não será pura mentira o que tenho nas mãos?»"
,"21":"Jacob, lembra-te disto; Israel, lembra-te de que és o meu servo. Eu formei-te, e és o meu servo: não te vou esquecer, Israel."
,"22":"Limpei as tuas transgressões como se fossem névoa, e os teus pecados como se fossem uma nuvem. Volta para Mim, porque Eu sou o teu redentor."
,"23":"Céus, gritai de alegria, porque Javé agiu; exultai, profundezas da Terra; gritai de alegria, montanhas, e tu, floresta, com todas as tuas árvores, porque Javé redimiu Jacob e manifestou o seu poder em Israel."
,"24":"Assim diz Javé, o teu Redentor, que te formou desde o ventre de tua mãe: Eu sou Javé, que faço tudo: sozinho, Eu estendi o céu e firmei a Terra. Quem estava comigo?"
,"25":"Eu desfaço os presságios dos adivinhos e faço delirar os feiticeiros; faço voltar atrás os que são sábios e transformo o seu conhecimento em tolice."
,"26":"Mas confirmo a palavra do meu servo e executo o projecto dos meus mensageiros. Eu digo a Jerusalém: «Tu serás habitada»; e às cidades de Judá: «Vós sereis reconstruídas. Vou reerguer as vossas ruínas»."
,"27":"Eu digo ao oceano: «Esgota-te, porque vou fazer secar os teus rios»."
,"28":"Eu digo a Ciro: «Tu és o meu pastor, e realizarás tudo o que Eu quero». Eu digo a Jerusalém: «Tu serás reconstruída»; e ao Templo: «Tu serás reedificado desde os alicerces»."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Assim diz Javé a Ciro, o seu ungido, que Ele tomou pela mão: Dobrarei as nações diante dele e desarmarei os reis; abrirei diante dele as portas, e os batentes não se fecharão."
,"2":"Eu mesmo vou à tua frente, aplanando os lugares montanhosos; arrombo as portas de bronze e rebento as trancas de ferro."
,"3":"Vou entregar-te os tesouros escondidos e as riquezas encobertas, para que saibas que Eu sou Javé, o Deus de Israel, que te chama pelo nome."
,"4":"Por causa do meu servo Jacob, e de Israel, meu escolhido, chamei-te pelo nome e dei-te um sobrenome, embora não Me conheças."
,"5":"Eu sou Javé, e não existe outro; fora de Mim não existe nenhum outro deus. Eu armei-te quando Me não conhecias,"
,"6":"para que saibam desde o Nascente até ao Poente, que fora de Mim não existe nenhum outro. Eu sou Javé, e não existe outro:"
,"7":"Eu formo a luz e crio as trevas; sou o autor da paz e crio a desgraça. Eu, Javé, faço todas estas coisas."
,"8":"Céus, gotejai lá de cima, e as nuvens chovam a justiça; que a terra se abra e produza a salvação, e juntamente com ela brote a justiça. Eu, Javé, as criei."
,"9":"Ai daquele que, sendo apenas um vaso de barro, se atreve a discutir com o seu Criador! Porventura a argila vai dizer ao oleiro: «Que é que estás a fazer? Esta vasilha não tem asas»?"
,"10":"Ai daquele que diz a seu pai: «Que puseste no mundo?», ou a uma mulher: «O que deste à luz?»"
,"11":"Assim diz Javé, o Santo de Israel, Aquele que te formou: Acaso quereis saber as coisas futuras a respeito de meus filhos e dar ordens a respeito da obra das minhas mãos?"
,"12":"Eu fiz a Terra e criei nela o homem. As minhas mãos estenderam os céus e dei ordens a todo o exército dos astros."
,"13":"Na minha justiça, despertei Ciro, e vou tornar rectos os seus caminhos. Ele reconstruirá a minha cidade, libertará os meus exilados, não por preço nem por suborno - diz Javé dos exércitos."
,"14":"Assim diz Javé: Passarão para as tuas mãos e serão tua propriedade a riqueza do Egipto e as mercadorias da Etiópia, e também os sabeus, aqueles homens altos. Irão caminhando atrás de ti, acorrentados, ajoelhar-se-ão a teus pés e suplicarão, dizendo: «Deus só está contigo e não existe nenhum outro, não existem outros deuses»."
,"15":"De facto, Tu és o Deus escondido, o Deus de Israel, o Salvador."
,"16":"Todos eles ficarão envergonhados e confundidos, ficarão humilhados todos os que fabricam ídolos."
,"17":"Israel, porém, será salvo por Javé, e será uma salvação para sempre; nunca mais ficareis envergonhados ou confundidos."
,"18":"Porque assim diz Javé, que criou os céus, o único Deus, que formou a Terra, que a fez e a firmou nas suas bases; Ele não a fez para ser um caos, mas para ser habitada: Eu sou Javé, e não existe outro."
,"19":"Não falei em segredo, nem nalgum canto escuro da Terra. Eu não disse aos descendentes de Jacob: «Procurai-Me em vão!» Eu sou Javé, que proclamo a justiça e mostro o que é recto."
,"20":"Vós, que escapastes das nações, reuni-vos, vinde, aproximai-vos todos juntos. Os que transportam as suas imagens de madeira são ignorantes: dirigem as suas preces a um deus que não é capaz de salvar."
,"21":"Declarai, apresentai as vossas provas, consultai-vos uns aos outros. Quem proclamou isto desde os tempos antigos? Quem o anunciou desde aquele tempo? Não fui Eu, Javé? Fora de Mim não existe outro Deus. Não existe Deus justo e salvador, a não ser Eu."
,"22":"Voltai-vos para Mim e sereis salvas todas vós, extremidades da Terra, pois Eu sou Deus e não existe outro."
,"23":"Eu juro por Mim mesmo: o que sai da minha boca é justiça, uma palavra que não volta atrás. Diante de Mim se dobrará todo o joelho, e por Mim jurará toda a língua,"
,"24":"dizendo: «Só em Javé se encontra justiça e força». A Ele virão, envergonhados, todos os que se irritaram contra Ele."
,"25":"Mas todos os descendentes de Israel alcançarão a justiça em Javé, e n'Ele se gloriarão."
}`)
	CurrentBook.AddChapter(46, `{
"1":"O deus Bel cai, o deus Nebo é abatido, os seus ídolos são entregues às feras e às bestas de carga; a carga que leváveis aos ombros é um peso para bestas cansadas."
,"2":"Esses deuses caem e prostram-se, não conseguem salvar aqueles que os transportam, até eles próprios vão para o exílio."
,"3":"Ouvi-Me, casa de Jacob, resto da casa de Israel, que Eu carreguei desde que nascestes, que Eu sustentei desde o ventre materno."
,"4":"Até à vossa velhice Eu serei o mesmo, até que vos cubrais de cabelos brancos Eu continuarei a sustentar-vos. Já o fiz e continuarei a fazê-lo: Eu levar-vos-ei nos braços e salvar-vos-ei."
,"5":"A quem podereis assemelhar-Me? Com quem podereis comparar-Me? Com alguma coisa que se pareça comigo?"
,"6":"Alguns tiram o ouro da bolsa, pesam na balança certa quantidade de prata, contratam um ourives e mandam fazer um deus. Depois ajoelham-se e adoram-no."
,"7":"Põem o deus aos ombros, levam-no, colocam-no num suporte e fixam-no bem para que não caia do seu lugar. Por mais que alguém o invoque, ele nada responde e não livra ninguém das suas dificuldades."
,"8":"Lembrai-vos bem disto e sede prudentes. Tomai isto a sério, vós prevaricadores!"
,"9":"Lembrai-vos das coisas há muito tempo passadas, pois Eu sou Deus, e não há outro. Eu sou Deus, e não existe outro igual a Mim."
,"10":"Eu anunciei desde o início aquilo que aconteceria depois, desde o passado, aquilo que ainda não havia acontecido. Eu digo: o meu projecto cumprir-se-á; realizarei tudo o que desejo."
,"11":"Chamo do Oriente uma ave de rapina, de um país distante convoco o homem que está no meu projecto. Eu disse-o e vou cumpri-lo; tomei esse propósito e realizá-lo-ei."
,"12":"Escutai o que vos digo, homens de coração de pedra, que andais longe da justiça:"
,"13":"Eu faço chegar a minha justiça: ela não está longe; a minha salvação não tardará. Darei a Sião a salvação e a Israel a minha honra."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Desce e senta-te no pó, jovem Babilónia. Senta-te no chão, sem trono, capital dos caldeus, pois nunca mais te chamarão doce e delicada."
,"2":"Toma a mó e vai moer a farinha. Tira o véu, levanta a saia, mostra as pernas, atravessa os rios."
,"3":"Que o teu corpo fique descoberto e se vejam as tuas partes íntimas. «Eu vou vingar-Me e ninguém se oporá»,"
,"4":"diz o nosso Redentor, que Se chama Javé dos exércitos, o Santo de Israel:"
,"5":"Senta-te, calada, entra nas trevas, capital dos caldeus, pois nunca mais serás chamada senhora dos reinos."
,"6":"Eu estava irado contra o meu povo, reduzi a minha herança à humilhação, e então entreguei-os nas tuas mãos; mas não tiveste compaixão deles, e colocaste uma carga pesada nos ombros dos velhos."
,"7":"Tu pensavas: «Serei senhora para sempre». Mas não levaste em conta estes acontecimentos, nem pensaste qual seria o teu fim."
,"8":"Agora escuta, sensual, tu que reinavas tranquila e segura, pensando: «Nunca vou ficar viúva e nunca vou saber o que é perder filhos»."
,"9":"Pois bem, as duas coisas te acontecerão num só instante, no mesmo dia. Viuvez e perda de filhos chegarão a ti num só dia, apesar da multidão dos teus feitiços, apesar dos teus numerosos encantamentos."
,"10":"Estavas confiante na tua maldade, e dizias: «Ninguém me vê». A tua sabedoria e ciência desviaram-te. Apesar disso, pensavas: «Só eu, e ninguém mais além de mim»."
,"11":"Porém, chegará uma desgraça que não conseguirás conjurar; chegará uma calamidade que não poderás evitar; aparecerá de repente uma catástrofe que não previas."
,"12":"Fica, pois, com os teus encantamentos, com a multidão dos teus feitiços, pelos quais te fatigaste desde a juventude. Achas que irás tirar algum proveito? Achas que poderás amedrontar alguém?"
,"13":"Cansaste-te dos teus numerosos conselheiros: que se apresentem, então, e te salvem os astrólogos que observam as estrelas e todos os meses fazem prognósticos do que te vai acontecer."
,"14":"Eis que se tornaram como a palha: o fogo consome-os, e nenhum deles consegue livrar-se das chamas, pois não são brasas para aquecer, nem fogo para se estar sentado junto dele."
,"15":"É isso o que acontece aos teus adivinhos, com os quais te afadigaste desde a juventude: cada um vai para seu lado e ninguém te vem ajudar."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Escutai isto, casa de Jacob, vós que recebestes o nome de Israel, que brotastes da semente de Judá, que jurastes pelo nome de Javé e invocastes o Deus de Israel, mas sem fidelidade e sem justiça."
,"2":"Sois conhecidos pelo nome da Cidade Santa e apoiais-vos no Deus de Israel, cujo nome é Javé dos exércitos."
,"3":"Há muito tempo que Eu tinha anunciado as coisas passadas, coisas que saíram dos meus lábios, coisas que fiz ouvir; de repente, agi e elas aconteceram."
,"4":"Eu sabia que eras teimoso, que o teu pescoço era como uma barra de ferro e que a tua testa era de bronze;"
,"5":"por isso, eu predisse-te os acontecimentos com muita antecedência, avisei-te antes que acontecessem, para que não dissesses: «Isto foi feito pelo meu ídolo, foi a minha estátua ou imagem quem ordenou isto»."
,"6":"Ou-viste e viste tudo isto. Não o queres admitir?,Agora, revelo-te coisas novas, segredos que não conheces. "
,"7":"Foram criadas neste momento e não outrora; antes do dia de hoje nunca ouviste falar delas; de contrário, poderias dizer: «Eu já sabia disso tudo!»"
,"8":"Tu não ouviste falar, não sabias, e isto nunca chegou aos teus ouvidos, pois eu sei muito bem quanto és pérfido e que desde o ventre de tua mãe és chamado rebelde."
,"9":"Por causa do meu nome, retardo a minha ira; por causa da minha honra, contenho-Me para não te aniquilar."
,"10":"Eis que te purifiquei como a prata, e te provei na fornalha do sofrimento."
,"11":"Por minha causa, só por minha causa é que fiz isto, porque o meu Nome não será profanado, e a ninguém cederei a minha glória."
,"12":"Escuta-me, Jacob; presta atenção, Israel! Eu sou, Eu sou o primeiro, Eu sou o último."
,"13":"A minha mão firmou as bases da terra, a minha direita estendeu os céus; basta Eu chamá-los, e eles comparecem todos juntos."
,"14":"Que todos se reúnam e escutem: Qual dos ídolos anunciou estas coisas? O meu amigo cumprirá a minha vontade contra a Babilónia e contra o povo dos caldeus."
,"15":"Eu próprio é que lhe falei e o chamei; guiei-o e tornei feliz o seu caminho."
,"16":"Aproximai-vos de Mim e ouvi isto: Desde o começo, nunca falei às escondidas; quando as coisas iam acontecendo, Eu estava presente. - E agora, Javé Deus enviou-me com o seu Espírito. -"
,"17":"Assim diz Javé, o teu redentor, o Santo de Israel: Eu sou Javé, o teu Deus, que te ensino para o teu bem e te guio pelo caminho que deves seguir."
,"18":"Se tivesses obedecido aos meus mandamentos, a tua paz seria como um rio e a tua justiça como as ondas do mar;"
,"19":"os teus descendentes seriam como a areia, os teus filhos seriam numerosos como grãos de areia; o teu nome não seria eliminado nem destruído diante de Mim."
,"20":"Saí da Babilónia, fugi dos caldeus. Anunciai e proclamai isto com gritos de alegria, espalhai a notícia até aos confins da Terra. Dizei assim: «Javé redimiu o seu servo Jacob."
,"21":"Quando os levou pelo deserto, eles nunca passaram sede; fez brotar água da pedra, bateu na rocha, e a água correu»."
,"22":"(Javé diz: «Para os ímpios não existe paz»)."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Ilhas, escutai; prestai atenção, povos distantes. Eu ainda estava no ventre materno; Javé chamou-me quando eu ainda estava nas entranhas de minha mãe, e Ele pronunciou o meu nome."
,"2":"Fez da minha língua uma espada afiada e escondeu-me com a sombra da sua mão; transformou-me numa seta pontiaguda e guardou-me na sua aljava."
,"3":"Ele disse-me: «Israel, tu és o meu servo, por meio de ti mostrarei a minha glória»."
,"4":"Eu então respondi: «Cansei-me inutilmente, e em vão gastei as minhas forças à toa, para nada. Enquanto isso, quem defendia os meus direitos era Javé, a minha recompensa estava na mão de Deus»."
,"5":"Agora fala Javé, que desde o ventre materno me formou para ser o seu servo, para Lhe reconduzir e Lhe reunir Israel. (Serei glorificado aos olhos de Javé; Deus é a minha força)."
,"6":"Ele diz: «É muito pouco tornares-te meu servo, só para reerguer as tribos de Jacob, só para reconduzir os sobreviventes de Israel. Faço de ti uma luz para as nações, para que a minha salvação chegue até aos confins da Terra»."
,"7":"Assim diz Javé, o redentor e Santo de Israel, àqueles cuja vida não vale nada, que são desprezados pelas nações, que são escravos dos poderosos: «Os reis verão e levantar-se-ão, os chefes ajoelhar-se-ão, porque Javé é fiel, e o Santo de Israel te escolheu»."
,"8":"Assim diz Javé: Na ocasião favorável respondi-te, e no dia da salvação ajudei-te; preparei-te e designei-te para seres a aliança do povo, para reergueres o país, para repartires as propriedades arrasadas,"
,"9":"para dizeres aos cativos: «Saí!» E aos que estão nas trevas: «Vinde para fora!»,Como um rebanho, eles pastarão em todos os caminhos, em qualquer colina seca encontrarão pastagem. "
,"10":"Não passarão fome nem sede; não serão molestados pelo calor nem pelo sol, pois aquele que Se compadece deles os conduzirá e os guiará para onde há fontes de água."
,"11":"Transformarei os meus montes em caminhos, as minhas estradas serão niveladas."
,"12":"Eis que uns vêm de longe, outros do Norte e do Ocidente, e outros da terra de Siene."
,"13":"Céus, gritai de alegria! Terra, alegra-te! Montanhas, rompei em aclamações, pois Javé consola o seu povo e compadece-Se dos pobres."
,"14":"Sião dizia: «Javé abandonou-me, o Senhor esqueceu-me!»"
,"15":"Mas pode a mãe esquecer-se do seu filhinho, pode ela deixar de ter amor pelo filho das suas entranhas? Ainda que ela se esqueça, Eu não Me esquecerei de ti."
,"16":"Eis que Eu te gravei nas palmas das minhas mãos; as tuas muralhas estão sempre diante de Mim."
,"17":"Aqueles que te vão reconstruir apressam-se; os que te derrubaram e destruíram já se foram embora."
,"18":"Lança um olhar ao redor e vê: todos se reúnem para vir a ti. Juro por minha vida - oráculo de Javé -: todos eles serão para ti como veste preciosa, como cinto de noiva."
,"19":"Os teus lugares arrasados, as tuas ruínas, o país devastado serão demasiado estreitos para os seus habitantes, enquanto já vão longe aqueles que te devoravam."
,"20":"Os filhos que perdeste dirão ao teu ouvido: «O meu lugar é muito estreito, aumenta-o um pouco para que eu tenha onde morar»."
,"21":"Tu, então, ficarás a pensar: «Quem me gerou estes filhos? Pois eu perdi os meus filhos e sou estéril, estava no cativeiro e rejeitada; quem os criou? Deixaram-me sozinha; e estes, de onde vieram?»"
,"22":"Assim diz o Senhor Javé: «Eis que levantarei a minha mão para as nações, ergo a minha bandeira para os povos e, então, ao colo e aos ombros eles trarão os filhos e as filhas que te pertencem."
,"23":"Os reis serão para ti tutores, e as princesas serão amas-de-leite. Com o rosto por terra, prestar-te-ão homenagem, lamberão a poeira dos teus pés, e então saberás que Eu sou Javé, Aquele que nunca decepciona quem n'Ele confia."
,"24":"Pode alguém tirar a um valente aquilo que ele agarrou, ou livrar um prisioneiro da mão do vencedor?"
,"25":"Assim diz Javé: O prisioneiro será tirado da mão do homem valente e aquele que o violento agarrou, vai escapar-lhe. Pois Eu discutirei com os teus acusadores, Eu mesmo salvarei os teus filhos."
,"26":"Aos teus opressores farei comer a própria carne; e com o próprio sangue eles se embriagarão, como de vinho novo. Então todas as criaturas saberão que Eu sou Javé, teu salvador, e que o teu redentor é o Poderoso de Jacob."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Assim diz Javé: Onde está o papel do divórcio que prova que Me separei da vossa mãe? A qual dos meus credores vos vendi? Pois bem! Fostes vendidos por causa das vossas próprias culpas; a vossa mãe foi repudiada por causa dos crimes que vós cometestes."
,"2":"Porque é que quando venho, não encontro ninguém, e quando chamo, ninguém Me responde? Será que a minha mão ficou tão curta que não posso libertar? Ou será que já não tenho força para salvar? Olhai! Com uma simples ameaça seco o mar e transformo os rios em deserto; os seus peixes apodrecem por falta de água e acabam por morrer à sede."
,"3":"Eu visto o céu todo de preto, e dou-lhe um pano de saco como veste."
,"4":"O Senhor Javé deu-me a capacidade de falar como discípulo, para que eu saiba ajudar os desanimados com uma palavra de coragem. Cada manhã Ele desperta os meus ouvidos para que eu possa ouvir como discípulo."
,"5":"O Senhor Javé abriu os meus ouvidos e eu não fiz resistência nem recuei."
,"6":"Apresentei as costas àqueles que me queriam bater e ofereci o queixo aos que me queriam arrancar a barba, e nem escondi o meu rosto aos insultos e escarros."
,"7":"O Senhor Javé ajuda-me, por isso não me sinto humilhado; endureço o meu rosto como pedra, porque sei que não vou sentir-me fracassado."
,"8":"Ao meu lado está Aquele que me defende; quem vai contender comigo? Vamos juntos ao tribunal! Quem abriu um processo contra mim? Que venha enfrentar-me!"
,"9":"Vede! O Senhor Javé vem em meu auxílio, quem ousará condenar-me? Pois todos se desgastarão como roupa velha, roída pela traça."
,"10":"Quem de vós respeita Javé e escuta o que diz o seu servo? Aquele que anda nas trevas, sem uma luz que o alumie, confie no nome de Javé, ponha a confiança no seu Deus."
,"11":"Agora, todos vós que acendeis uma fogueira e soprais as suas brasas, caireis nas chamas da vossa fogueira e nas brasas que vós mesmos acendestes. A minha própria mão vos tratará assim, e sereis consumidos no sofrimento."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Escutai-me, vós que procurais justiça e buscais a Javé. Olhai bem para a pedreira de onde fostes tirados, reparai bem na rocha de onde fostes cortados:"
,"2":"olhai para Abraão, o vosso pai; reparai em Sara, que vos deu à luz. Quando o chamei, ele era um só; mas abençoei-o e multipliquei-o."
,"3":"Javé consola Sião, repara as suas ruínas: Ele transformará o seu deserto num paraíso, a secura num jardim de Javé. Ali haverá alegria e festa, acções de graças e hinos de louvor."
,"4":"Presta atenção, povo meu; dá-Me ouvidos, gente minha: de Mim vem a Lei, e o meu direito é luz para os povos."
,"5":"A minha justiça está perto, a minha salvação já brotou, o meu braço governará os povos: as ilhas esperam por Mim e depositam a sua esperança no meu braço."
,"6":"Levantai os olhos para o céu, volvei o vosso olhar para a terra: o céu desfaz-se como o fumo, a terra desgasta-se como roupa velha e os seus habitantes morrem como moscas; só a minha salvação é eterna, só a minha justiça não tem fim."
,"7":"Escutai o que Eu digo, vós que conheceis a justiça, gente que traz a minha Lei no coração: não tenhais medo dos insultos dos homens, nem vos deixeis abater pelos seus ultrajes,"
,"8":"pois eles serão roídos pela traça como roupa, serão comidos pela traça como pedaços de lã. Mas a minha justiça é eterna e a minha salvação permanece de geração em geração."
,"9":"Desperta! Desperta! Reveste-te de força, braço de Javé! Desperta como nos tempos passados, como nas épocas antigas. Não foste Tu que derrotaste o monstro e trespassaste o dragão?"
,"10":"Não foste Tu que secaste o mar, as águas do grande abismo, e fizeste um caminho pelo fundo do mar para que os redimidos pudessem atravessar?"
,"11":"Os resgatados de Javé voltarão! Estarão de volta a Sião, cantando e com a cabeça coroada de uma alegria sem fim; serão acompanhados de alegria e contentamento; dor e aflição ficarão para trás."
,"12":"Sou Eu, sou Eu Aquele que vos consola. Quem és tu para ter medo de um homem mortal, de uma criatura humana que acabará como a erva?"
,"13":"Esqueceste-te de Javé que te criou, que estendeu os céus e fez os alicerces da Terra. Vivias sempre apavorado diante da fúria do opressor, quando ele estava para te destruir. Onde está agora a fúria do teu opressor?"
,"14":"O prisioneiro em breve será libertado; não morrerá na cadeia, nem lhe faltará pão."
,"15":"Eu sou Javé teu Deus, que agito o mar e faço rugir as suas ondas. O meu nome é Javé dos exércitos."
,"16":"Coloquei a minha palavra na tua boca e escondi-te com a sombra da minha mão. Estendo o céu, coloco os alicerces da Terra e digo a Sião: «Tu és o meu povo!»"
,"17":"Desperta! Desperta! De pé, Jerusalém! Tu que bebeste da mão de Javé a taça cheia do seu furor, um cálice embriagador, que bebeste e esvaziaste."
,"18":"Ela, que gerou tantos filhos, não tem ninguém que a conduza; de todos os filhos que pôs no mundo, não há nenhum que lhe dê a mão."
,"19":"Duas desgraças te atingiram. Quem se compadece de ti? Destruição e ruína, fome e guerra. Quem te consola?"
,"20":"Os teus filhos estão caídos pelas esquinas, desfalecidos, tal como a caça que caiu na armadilha, cheios do furor de Javé e da ameaça do teu Deus."
,"21":"Por isso, escuta, ó infeliz, embriagada, mas não de vinho!"
,"22":"Assim diz o teu Senhor Javé, o teu Deus, o advogado do teu povo: Vou retirar da tua mão o cálice embriagador; nunca mais beberás a taça do meu furor."
,"23":"Vou passar esta taça para as mãos daqueles que te fizeram sofrer, daqueles que te diziam: «Curva-te para passarmos por cima de ti». E fazias das tuas costas uma estrada para que eles passassem por cima."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Desperta! Desperta! Reveste-te de força, Sião! Veste os trajes de festa, Jerusalém, cidade santa! Pois nunca mais entrarão em ti o não circuncidado e o impuro."
,"2":"Sacode o pó, levanta-te, Jerusalém escrava! Tira as correntes do pescoço, escrava filha de Sião,"
,"3":"porque assim diz Javé: Vós fostes vendidos de graça, e sem pagar vos resgatarei."
,"4":"Porque assim diz o Senhor Javé: No princípio, o meu povo foi para o Egipto onde residiu como estrangeiro; depois foi a Assíria que o oprimiu sem motivo."
,"5":"E agora, o que é que Eu faço? - oráculo de Javé. Pois o meu povo foi levado de graça e os seus opressores soltam gritos de alegria - oráculo de Javé - e o meu nome é insultado continuamente todos os dias."
,"6":"Por isso o meu povo reconhecerá o meu Nome; nesse dia compreenderá que Eu sou Aquele que diz: «Aqui estou»."
,"7":"Como são belos sobre os montes os pés do mensageiro que anuncia a paz, que traz a boa notícia, que anuncia a salvação, que diz a Sião: «O teu Deus reina»."
,"8":"Ouve! As tuas sentinelas levantam a voz, juntas cantam de alegria, pois vêem com os seus próprios olhos a Javé que volta para Sião."
,"9":"Rompei juntas em cantos de alegria, ruínas de Jerusalém, porque Javé Se compadece do seu povo e redime Jerusalém."
,"10":"Javé arregaçou a manga do seu braço santo diante de todas as nações; todos os confins da Terra verão a salvação do nosso Deus."
,"11":"Vamos, vamos, saí daí. Não toqueis nas coisas impuras. Saí da Babilónia, conservai-vos puros, vós que transportais os objectos sagrados."
,"12":"Ninguém sairá apressado, ninguém correrá como se estivesse a fugir, pois Javé caminha à tua frente. Atrás de vós vem o Deus de Israel."
,"13":"Olhai! O meu servo vai ter sucesso, subirá e crescerá muito."
,"14":"Assim como muitos ficam espantados por causa dele - pois já não parecia gente, tinha perdido toda a aparência humana -"
,"15":"assim também as nações numerosas ficarão atónitas. Diante dele os reis vão fechar a boca, pois verão uma coisa que nunca lhes tinha sido contada e compreenderão o que nunca tinham ouvido."
}`)
	CurrentBook.AddChapter(53, `{
"1":"Quem acreditou na nossa mensagem? A quem foi mostrado o braço de Javé?"
,"2":"Ele cresceu como um rebento na presença de Javé, como raiz em terra seca. Ele não tinha aparência nem beleza para atrair o nosso olhar, nem simpatia para que pudéssemos apreciá-lo."
,"3":"Desprezado e rejeitado pelos homens, homem do sofrimento e experimentado na dor; como indivíduo diante do qual se tapa o rosto, ele era desprezado e não fizemos caso dele."
,"4":"Todavia, eram as nossas doenças que ele carregava, eram as nossas dores que ele levava às costas. E nós achávamos que ele era um homem castigado, um homem ferido por Deus e humilhado."
,"5":"Mas ele estava a ser trespassado por causa das nossas revoltas, esmagado pelos nossos crimes. Caiu sobre ele o castigo que nos dá a paz; e pelas suas feridas é que fomos curados."
,"6":"Todos nós estávamos perdidos como ovelhas, cada qual seguia o seu caminho, e Javé fez cair sobre ele os crimes de todos nós."
,"7":"Foi oprimido e humilhado, mas não abriu a boca; tal como cordeiro, ele foi levado para o matadouro; como ovelha muda diante do tosquiador, ele não abriu a boca."
,"8":"Foi preso, julgado injustamente; e quem se preocupou com a vida dele? Pois foi suprimido da terra dos vivos e ferido de morte por causa da revolta do meu povo."
,"9":"A sua sepultura foi colocada junto da dos ímpios, e o seu túmulo junto do dos ricos, embora nunca tivesse cometido injustiça e nunca a mentira estivesse na sua boca."
,"10":"No entanto, Javé queria esmagá-lo com o sofrimento: se ele entrega a sua vida em reparação pelos pecados, então conhecerá os seus descendentes, prolongará a sua existência e, por meio dele, o projecto de Javé triunfará."
,"11":"Pelas amarguras suportadas, verá a luz e ficará saciado. Pelo seu conhecimento, o meu servo justo devolverá a muitos a verdadeira justiça, pois carregou os seus crimes."
,"12":"Por isso lhe darei multidões como propriedade, e com os poderosos repartirá os despojos: porque entregou o seu pescoço à morte, foi contado entre os pecadores, carregou os pecados de muitos e intercedeu pelos pecadores."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Canta de alegria, estéril que não davas à luz; exulta com alegre canto, tu que não tinhas dores de parto, porque a mulher abandonada terá mais filhos que a casada, diz Javé."
,"2":"Aumenta o espaço da tua tenda, estende depressa a lona, estica as cordas, fixa as estacas,"
,"3":"porque vais estender-te para a direita e para a esquerda, os teus filhos herdarão nações e povoarão cidades desabitadas."
,"4":"Não tenhas medo, pois não ficarás envergonhada. Não te envergonhes, pois não sofrerás humilhação; esquecerás a vergonha que passaste na juventude, e nunca mais te lembrarás da vergonha do teu tempo de viúva."
,"5":"Porque o teu marido é o teu Criador: o seu nome é Javé dos exércitos. Quem te redime é o Santo de Israel; Ele é chamado o Deus de toda a terra."
,"6":"Javé chama-te como a esposa abandonada e abatida, como a esposa da juventude, a repudiada: assim diz o teu Deus."
,"7":"Por um instante te abandonei, mas com imensa compaixão torno a chamar-te."
,"8":"Num ímpeto de ira, por um momento escondi de ti o meu rosto; agora, com amor eterno, volto a compadecer-Me de ti, diz Javé, teu Redentor."
,"9":"Como no tempo de Noé, agora faço a mesma coisa: jurei que as águas do dilúvio nunca mais iriam cobrir a Terra; da mesma forma, agora juro que não deixarei inflamar-se a minha ira contra ti e nunca mais te vou castigar."
,"10":"Mesmo que os montes se retirem e as colinas vacilem, o meu amor nunca se vai afastar de ti, a minha aliança de paz não vacilará, diz Javé, que Se compadece de ti."
,"11":"Pobrezinha, açoitada pela tempestade e sem consolo! Eis que assento os teus muros sobre pedras preciosas e faço de safira a base;"
,"12":"as muralhas faço-as de rubis, e as portas, de esmeraldas. Faço toda a muralha de pedras preciosas."
,"13":"Todos os teus filhos serão discípulos de Javé, será grande a paz dos teus filhos."
,"14":"Serás fundada sobre a justiça, longe da opressão, e nada terás a temer; ficarás longe do terror, que nunca mais se aproximará de ti."
,"15":"Se alguém te atacar, não será por minha ordem; quem te atacar, já está derrotado."
,"16":"Vê! Fui Eu que criei o ferreiro que sopra as brasas do fogo e produz ferramentas de trabalho. Mas também fui Eu que criei o exterminador para arrasar."
,"17":"Qualquer ferramenta forjada contra ti jamais terá sucesso; obterás pela justiça a condenação de toda a língua que te acusar no tribunal. Esta será a herança dos servos de Javé, a justiça que de Mim receberão - oráculo de Javé."
}`)
	CurrentBook.AddChapter(55, `{
"1":"Atenção! Todos vós que tendes sede, vinde buscar água. Vinde também vós que não tendes dinheiro: comprai e comei sem dinheiro e bebei vinho e leite sem pagar."
,"2":"Por que razão gastais o vosso dinheiro com coisas que não alimentam, e o salário com aquilo que não traz fartura? Ouvi-Me com atenção, e comereis coisas boas e saboreareis pratos suculentos."
,"3":"Dai-Me ouvidos, vinde a Mim, escutai-Me e vivereis. Farei convosco uma aliança definitiva, serei fiel à minha amizade com David."
,"4":"Fiz dele uma testemunha para os povos, um chefe que comanda os povos."
,"5":"Agora vais convocar um povo desconhecido; um povo que te não conhecia acorrerá a ti: tudo por causa de Javé teu Deus, por causa do Santo de Israel, porque Ele te glorificou."
,"6":"Procurai Javé enquanto Ele Se deixa encontrar; chamai por Ele enquanto está perto."
,"7":"Que o ímpio deixe o seu caminho e o homem maldoso mude os seus projectos. Cada um volte para Javé e Ele terá compaixão; volte para o nosso Deus, pois Ele perdoa com generosidade."
,"8":"Os meus projectos não são os vossos projectos, e os vossos caminhos não são os meus caminhos - oráculo de Javé."
,"9":"Tanto quanto o céu está acima da terra, assim os meus caminhos estão acima dos vossos caminhos, e os meus projectos estão acima dos vossos projectos."
,"10":"Da mesma forma como a chuva e a neve, que caem do céu e não voltam para lá sem antes molhar a terra, tornando-a fecunda e fazendo-a germinar, a fim de produzir semente para o semeador e alimento para quem precisa de comer,"
,"11":"assim acontece com a Palavra que sai da minha boca: ela não volta para Mim sem ter produzido o seu efeito, sem ter realizado o que Eu quero e sem ter cumprido com sucesso a missão para a qual Eu a mandei."
,"12":"Saireis com alegria e sereis reconduzidos em paz. Na vossa presença, colinas e montes explodirão de alegria, todas as árvores baterão palmas."
,"13":"Em vez de espinhos, crescerão ciprestes; no lugar de urtigas, crescerão murtas. Isso trará fama a Javé, será um monumento eterno, que nunca se apagará."
}`)
	CurrentBook.AddChapter(56, `{
"1":"Assim diz Javé: Observai o direito e praticai a justiça, porque a minha salvação está para chegar e a minha justiça vai manifestar-se."
,"2":"Feliz o homem que assim se comporta, feliz o homem que nisto persevera, quem observa o sábado sem o profanar e preserva a sua mão de fazer qualquer mal."
,"3":"O estrangeiro que aderiu a Javé não diga: «Com certeza Javé vai excluir-me do seu povo»; nem o eunuco diga: «Não passo de uma árvore seca»."
,"4":"Porque assim diz Javé: Aos eunucos que observam os meus sábados, que escolhem o que Me agrada e ficam firmes na minha aliança,"
,"5":"Eu dar-lhes-ei na minha casa, dentro das minhas muralhas, um lugar e um nome que valem mais do que filhos e filhas; dar-lhes-ei um nome eterno que nunca desaparecerá."
,"6":"Aos estrangeiros que aderiram a Javé para Lhe prestar culto, para amar a Javé e serem seus servos, que observam o sábado sem o profanar e ficam firmes na minha aliança,"
,"7":"Eu levá-los-ei para a minha montanha santa, vou fazê-los felizes na minha casa de oração; os seus holocaustos e sacrifícios serão aceites com agrado no meu altar, porque a minha casa será chamada casa de oração para todos os povos."
,"8":"Oráculo do Senhor Javé, que reúne os israelitas dispersos: Àqueles que já foram reunidos, Eu reunirei ainda outros."
,"9":"Feras selvagens, vinde comer, feras todas da selva:"
,"10":"os guardas estão cegos e nada vêem, são cães mudos incapazes de ladrar; sonham deitados e o seu prazer é dor-mir;"
,"11":"são cães com fome insaciável; são pastores que não percebem nada; cada um segue o seu caminho e procura os seus interesses, todos eles, sem excepção. Eles dizem:"
,"12":"«Vinde! Eu vou buscar vinho, vamos embriagar-nos com bebidas fortes. Amanhã faremos o mesmo e ainda mais, pois há grande abundância»."
}`)
	CurrentBook.AddChapter(57, `{
"1":"O justo perece, e ninguém se incomoda; os homens de bem são eliminados, e ninguém se importa. Porque o justo é levado por causa do mal,"
,"2":"para que entre na paz: aquele que procede com sinceridade descansa no seu leito."
,"3":"Aproximai-vos vós, filhos de feiticeira, descendência de adúltera e de prostituta."
,"4":"De quem escarneceis vós, contra quem fazeis caretas e mostrais a língua? Porventura não sois filhos ilegítimos, geração bastarda?"
,"5":"Não sois vós que buscais a ardência do sexo ao pé dos carvalhos ou debaixo de qualquer árvore frondosa? Sacrificais crianças à beira dos rios e nas fendas das rochas."
,"6":"As pedras lisas do rio serão a tua herança; serão elas a parte que te toca: em honra delas derramavas vinho em libação, e nelas oferecias sacrifícios."
,"7":"Colocaste a tua cama numa colina alta e elevada, e subiste para lá para oferecer sacrifícios. E ainda achas que Me agradas com essas coisas?"
,"8":"Atrás da porta e do portal puseste o teu emblema; afastando-te de Mim, despias-te, subias para o leito e alargava-lo para os adúlteros; tiravas partido dos teus amantes com os quais gostavas de ter relações; e olhando para o ídolo, multiplicavas as prostituições com eles."
,"9":"Depois corrias a Moloc com óleo, multiplicando os teus perfumes; enviavas os teus mensageiros para longe, fazia-los descer até às profundidades do sepulcro."
,"10":"Cansada de tanto andar, nunca dizias: «Chega!» Pelo contrário, achavas sempre um modo de reanimar as forças, e não te entregavas."
,"11":"De quem tinhas medo, quem é que te impunha tanto respeito, para mentires assim? De Mim, nem te lembravas, e nem te preocupavas comigo. O facto é que Eu me calava e fechava os olhos; por isso não Me temias."
,"12":"Mas Eu proclamarei o que valem a tua justiça e as tuas obras. Os teus ídolos de nada te servirão,"
,"13":"e nem te livrarão quando pedires socorro. Todos eles serão levados pelo vento, um simples sopro os arrebatará, mas aquele que busca a minha protecção herdará a Terra e possuirá o meu monte santo."
,"14":"Aplanai, aplanai! Abri um caminho! Tirai as pedras do caminho do meu povo!"
,"15":"Pois assim diz Aquele que está no alto, lá em cima, Aquele que mora na eternidade e que tem um Nome santo: Eu moro na altura santa, mas estou com os oprimidos e humilhados, para reanimar o espírito dos humilhados e reanimar o coração dos oprimidos."
,"16":"Eu não vou litigar eternamente, não vou irritar-Me sempre, senão a vida humana evaporaria na minha presença e seria destruído tudo aquilo que criei."
,"17":"Eu estava indignado com a injustiça das tuas ganâncias e, escondendo-Me, feri-te com todo o meu furor. Como um rebelde, seguiu o caminho que bem queria;"
,"18":"Eu vi o seu caminho, mas vou curá-lo, guiá-lo e oferecer-lhe consolação. E aos que fazem luto pelo meu povo,"
,"19":"farei brotar dos seus lábios este canto: «Paz e felicidade para quem está longe e para quem está perto: Eu curá-lo-ei, diz Javé»."
,"20":"Os ímpios, porém, são como um mar agitado que nunca pode acalmar-se, e as águas que eles agitam é lama e lodo."
,"21":"Para os ímpios não existe paz, diz o meu Deus."
}`)
	CurrentBook.AddChapter(58, `{
"1":"Grita a plenos pulmões, sem parar; levanta como trombeta o som da tua voz; mostra ao meu povo os seus crimes, e à casa de Jacob faz conhecer os seus pecados."
,"2":"Dia após dia, eles parecem procurar-Me, mostram desejo de conhecer os meus caminhos; parecem povo que pratica a justiça e que nunca se esquece do direito do seu Deus. Eles vêm pedir-Me as regras da justiça, querem estar perto de Deus."
,"3":"E dizem: «Porque jejuamos, e Tu não vês? Porque nos humilhamos totalmente, e nem tomas conhecimento?» Acontece que, mesmo quando jejuais, só cuidais dos vossos interesses e continuais a explorar quem trabalha para vós."
,"4":"Vede! Jejuais entre rixas e discussões, dando socos sem piedade. Não é jejuando desta forma que fareis chegar a vossa voz lá acima."
,"5":"Vede! É esse o jejum que Eu aprecio, no dia em que uma pessoa se mortifica? Curvar a cabeça como se fosse uma vara, deitar-se de luto na cinza... É a isto que chamais jejum e dia agradável a Javé?"
,"6":"O jejum que Eu quero é este: acabar com as prisões injustas, desfazer as correntes do jugo, pôr em liberdade os oprimidos e despedaçar qualquer jugo;"
,"7":"repartir o pão com quem passa fome, hospedar em casa os pobres sem abrigo, vestir aquele que se encontra nu, e não se fechar à sua própria gente."
,"8":"Se fizeres isto, a tua luz brilhará como a aurora, as tuas feridas vão sarar rapidamente, a justiça que praticas irá à tua frente e a glória de Javé acompanhar-te-á."
,"9":"Então clamarás, e Javé responderá; gritarás por socorro, e Javé responderá: «Estou aqui!» Isso, se tirares do meio de ti o jugo, o gesto que ameaça e a linguagem injuriosa;"
,"10":"se deres o teu pão ao faminto e matares a fome do oprimido. Então a tua luz brilhará nas trevas e a escuridão será para ti como a claridade do meio-dia;"
,"11":"Javé será sempre o teu guia e dar-te-á fartura mesmo em terra deserta; fortificarás os teus ossos e serás como jardim irrigado, como nascente onde nunca falta água;"
,"12":"as tuas ruínas antigas serão reconstruídas, levantarás paredes em cima dos alicerces de tempos passados. Chamar-te-ão reparador de brechas e restaurador de casas em ruínas, onde se possa morar."
,"13":"Se não desrespeitares o dia de sábado e não tratares de negócios no meu dia santo; se disseres que o sábado é um dia agradável e honrares o dia consagrado a Javé; se o respeitares, deixando de viajar, de buscar o teu próprio interesse e de tratar de negócios;"
,"14":"então Javé será a tua delícia, farei que sejas levado em triunfo sobre os lugares mais altos da Terra, e sustentar-te-ei com a herança de teu pai Jacob. Assim falou a boca de Javé."
}`)
	CurrentBook.AddChapter(59, `{
"1":"Eis que o braço de Javé não é curto para salvar, nem os seus ouvidos surdos para ouvir."
,"2":"Pelo contrário, as vossas culpas é que cavaram um abismo que vos separa do vosso Deus; por causa dos vossos erros, Javé escondeu o rosto, para não vos ouvir."
,"3":"Vós estais com as mãos sujas de sangue, com os dedos manchados de crimes, os vossos lábios só dizem mentiras e as vossas línguas sussurram maldade."
,"4":"Não há ninguém que acuse com justiça, não há quem faça um processo com honestidade. Todos confiam em coisas que não têm valor e só dizem o que não é verdade; concebem o crime e dão à luz a maldade."
,"5":"Chocam ovos de serpente e tecem teias de aranha: quem comer esses ovos morrerá; se a casca se quebrar, de dentro deles sairá uma serpente."
,"6":"As teias que tecem não servem para fazer roupa; eles não conseguem cobrir-se com o produto do seu trabalho. As suas obras são criminosas, e as suas mãos praticam a violência."
,"7":"Os seus passos levam para o mal, e correm para derramar sangue inocente; os seus planos são criminosos, a sua estrada é feita de ruína e destruição."
,"8":"Eles não conhecem os caminhos da paz; não existe o direito nos seus passos; fazem para si caminhos tortuosos: quem neles caminha não conhece a paz."
,"9":"É por isso que o direito está longe de nós e a justiça nunca chega ao nosso alcance. Esperávamos luz, e o que veio foram trevas; aguardávamos claridade e, no entanto, caminhamos na escuridão."
,"10":"Como cegos, caminhamos apalpando a parede, tacteando como alguém que não vê. Tropeçamos em pleno dia, como se já tivesse escurecido; em pleno vigor, estamos como mortos."
,"11":"Todos rugimos como ursos e gememos como pombas. Esperávamos o direito, e nada; esperávamos a salvação, e ela ficou longe."
,"12":"Sim, os nossos actos de rebeldia multiplicaram-se diante de Ti, Javé; os nossos pecados testemunham contra nós. Sim, os nossos actos de rebeldia acompanham-nos, reconhecemos as nossas culpas:"
,"13":"revoltar-nos, negar Javé, afastar-nos do nosso Deus, praticar violência e revolta, conceber e planear a mentira."
,"14":"Por isso, o direito retirou-se e a justiça manteve-se longe, porque a verdade tropeçou na praça e a sinceridade não encontra acesso;"
,"15":"assim a verdade desapareceu, e quem se desvia do mal acaba por ser roubado. Javé viu tudo isto e pareceu mal aos seus olhos, o facto de já não haver justiça."
,"16":"Viu que não havia ninguém, admirou-Se porque ninguém intervinha. Então o seu próprio braço Lhe trouxe a vitória, e a sua própria justiça O sustentou."
,"17":"Ele vestiu-Se de justiça como de couraça, e colocou na cabeça o capacete da salvação; revestiu-Se com a veste da vingança, cobriu-Se com o manto da indignação."
,"18":"Pagará a cada um de acordo com o que merece: ódio contra os seus adversários, castigo para os seus inimigos."
,"19":"Então, desde o Ocidente temer-se-á o nome de Javé, e desde o Oriente honrarão a sua glória, pois Ele virá como um rio impetuoso que é conduzido pelo espírito de Javé."
,"20":"Mas para Sião virá um redentor, a fim de afastar os crimes cometidos contra Jacob - oráculo de Javé."
,"21":"Da minha parte, esta é a minha aliança com eles, diz Javé: O meu espírito está sobre ti, e as minhas palavras, que Eu coloquei na tua boca, jamais se afastarão da tua boca, nem da boca dos teus filhos, nem da boca dos teus netos, desde agora e para sempre, diz Javé."
}`)
	CurrentBook.AddChapter(60, `{
"1":"Levanta-te, Jerusalém! Brilha, pois chegou a tua luz, a glória de Javé brilha sobre ti."
,"2":"Sim, as trevas cobrem a terra, névoas espessas envolvem os povos, mas sobre ti brilha Javé, e a sua glória ilumina-te."
,"3":"À tua luz caminharão os povos, e os reis andarão ao brilho do teu esplendor."
,"4":"Lança um olhar em volta e observa: todos se reuniram e vieram procurar-te. Os teus filhos vêm de longe, as tuas filhas são transportadas nos braços."
,"5":"Então verás e o teu rosto se iluminará, o teu coração parecerá explodir de emoção, porque a ti virão os tesouros de além-mar, a ti chegarão as riquezas das nações."
,"6":"Uma grande multidão de camelos te invade, camelos de Madiã e Efa; vêm todos de Sabá, trazendo ouro e incenso e anunciando os louvores de Javé."
,"7":"Vão juntar-se a ti todas as ovelhas de Cedar, os carneiros de Nabaiot estarão à tua disposição e tornar-se-ão um sacrifício agradável sobre o altar, e Eu honrarei o Templo da minha glória."
,"8":"Quem são estes que voam como as nuvens, como pombas em busca do pombal?"
,"9":"São navios que se dirigem para Mim, os barcos de Társis à frente, para trazer de longe os teus filhos com a sua prata e o seu ouro, para honrar o nome de Javé, teu Deus, pelo Santo de Israel que te cobre de glória."
,"10":"Os estrangeiros reconstruirão as tuas muralhas, e os seus reis te servirão, porque na minha ira te feri, mas na minha graça perdoei-te."
,"11":"As tuas portas ficarão sempre abertas, nem de dia nem de noite serão fechadas, para que te sejam trazidas as riquezas das nações guiadas pelos seus reis."
,"12":"Porque a nação e o rei que não se tornarem teus escravos serão destruídos e as nações serão mortas violentamente."
,"13":"Virá a ti a glória do Líbano; os pinheiros, olmeiros e ciprestes virão juntos para enfeitar a minha santa morada. Assim vou encher de glória o lugar onde apoio os meus pés."
,"14":"Os filhos daqueles que te oprimiam virão a ti, inclinando-se, vão prostrar-se a teus pés aqueles que se riram de ti, e proclamar-te-ão cidade de Javé, Sião do Santo de Israel."
,"15":"Depois de teres sido abandonada e amaldiçoada, sem alguém que passasse por ti, Eu transformar-te-ei em orgulho dos séculos, em alegria de todas as gerações."
,"16":"Tu sugarás o leite das nações, sugarás a riqueza dos reis. Então saberás que Eu sou Javé, que te salva, o teu Redentor, o Forte de Jacob."
,"17":"Em vez de bronze, vou trazer ouro; em vez de ferro, trarei prata; em vez de madeira, bronze e, em vez de pedra, trarei ferro. Vou dar-te como inspector a paz, e como capataz a justiça."
,"18":"Não se ouvirá mais falar de violência na tua terra, nem de opressão ou terror no teu território. Darás o nome de «Salvação» às tuas muralhas e de «Louvor» às tuas portas."
,"19":"O sol não será mais a luz do teu dia, e de noite não será a lua a iluminar-te; o próprio Javé será para ti uma luz permanente, e o teu Deus será o teu esplendor."
,"20":"O teu sol jamais vai pôr-se, e a tua lua não terá mais minguante, pois o próprio Javé será para ti uma luz permanente. Acabaram-se os dias de luto."
,"21":"O teu povo será todo formado de justos e serão proprietários da terra para sempre: será como uma vergôntea que Eu plantei, trabalho das minhas mãos, para minha glória."
,"22":"O pequeno crescerá até mil, e o menor tornar-se-á um povo numeroso: Eu sou Javé. No devido tempo realizarei isto prontamente."
}`)
	CurrentBook.AddChapter(61, `{
"1":"O Espírito do Senhor Javé está sobre mim, porque Javé me ungiu. Ele enviou-me para dar a boa notícia aos pobres, para curar os corações feridos, para proclamar a libertação dos escravos e pôr em liberdade os prisioneiros,"
,"2":"para promulgar o ano da graça de Javé, o dia da vingança do nosso Deus, e para consolar todos os aflitos, os aflitos de Sião,"
,"3":"para transformar a sua cinza em coroa, o seu luto em perfume de festa, o seu abatimento em roupa de gala. Eles serão chamados carvalhos da justiça, plantação de Javé para a sua glória. "
,"4":"Eles reconstruirão as ruínas antigas, erguerão novamente os velhos escombros. Renovarão as cidades arruinadas e os escombros de muitas gerações."
,"5":"Estrangeiros apresentar-se-ão para apascentar os vossos rebanhos; essa gente de fora é que trabalhará para vós, empunhando a enxada ou cuidando das vinhas."
,"6":"Sereis chamados sacerdotes de Javé, ministros do nosso Deus. Alimentar-vos-ei com os bens das nações e tomareis posse das suas riquezas."
,"7":"Em lugar da vergonha que sofrestes, recebereis porção dobrada; em lugar da humilhação, tereis gritos de júbilo como porção. É por isso que recebereis na vossa terra uma porção dupla e gozareis de uma alegria sem fim."
,"8":"De facto, Eu, Javé, que amo o direito e detesto o roubo e a injustiça, dar-lhes-ei a sua recompensa e estabelecerei com eles uma aliança eterna."
,"9":"A sua descendência será conhecida entre as nações e a sua geração entre os povos. Todos aqueles que os virem reconhecerão que são o povo que Javé abençoou."
,"10":"Transbordo de alegria em Javé, e regozijo-me com o meu Deus, porque Ele me vestiu com a salvação, cobriu-me com o manto da justiça, como o noivo que cinge a fronte com o diadema, e a noiva que se adorna com jóias."
,"11":"Assim como a terra faz brotar uma nova planta, e o jardim faz germinar as suas sementes, assim também o Senhor Javé faz brotar a justiça e o louvor na presença de todas as nações."
}`)
	CurrentBook.AddChapter(62, `{
"1":"Por causa de Sião não ficarei em silêncio, por causa de Jerusalém não ficarei quieto, enquanto a justiça não surgir para ela como a aurora e enquanto a sua salvação não brilhar como lâmpada."
,"2":"As nações verão a tua justiça e todos os reis verão a tua glória. Então serás chamada com um nome novo que a boca de Javé indicou."
,"3":"Serás uma coroa magnífica na mão de Javé, um diadema real na mão do teu Deus."
,"4":"Ninguém te chamará Abandonada, e a tua terra já não terá o nome de Desolada. Pelo contrário, serás chamada Minha Delícia e a tua terra terá por nome a Desposada, porque Javé vai amar-te, e a tua terra terá um esposo."
,"5":"Como o jovem se casa com uma donzela, o teu Criador casará contigo; como o esposo que se alegra com a esposa, o teu Deus contigo Se alegrará."
,"6":"Sobre as tuas muralhas, Jerusalém, eu coloquei guardas para te vigiarem e, dia e noite, eles jamais se calarão. Vós, que sempre recordais as promessas de Javé, não descanseis,"
,"7":"e não concedais descanso a Javé, até que Ele restabeleça Jerusalém e faça dela o orgulho da Terra."
,"8":"Javé jurou com a sua direita e com o seu braço poderoso: «Nunca mais darei o teu trigo como alimento aos inimigos; nunca mais os estrangeiros beberão o vinho que tanto trabalho te custou."
,"9":"Pelo contrário, quem colher o trigo também o comerá, louvando a Javé; quem colher as uvas também beberá o vinho nos átrios do meu santuário»."
,"10":"Passai, passai pelas portas, abri caminho ao povo. Aplanai, aplanai a estrada, retirai as pedras. Erguei uma bandeira para os povos."
,"11":"Javé envia esta mensagem até aos confins da Terra: «Dizei à capital de Sião: Olha, aí vem o teu salvador; com Ele vem a tua recompensa, a tua recompensa vem à frente d'Ele."
,"12":"Serão chamados Povo Santo, Redimidos de Javé. E tu serás chamada a Procurada, a Cidade Não Abandonada»."
}`)
	CurrentBook.AddChapter(63, `{
"1":"Quem é Este que vem de Edom, que vem de Bosra, com as roupas manchadas de vermelho? Quem é Este, assim vestido tão solenemente, e que avança cheio de força? «Sou Eu que falo com justiça e sou poderoso para salvar»."
,"2":"E de onde vem esse vermelho das tuas vestes? A tua túnica parece de alguém que andou a pisar uvas."
,"3":"«Entrei sozinho no tanque de pisar uvas, e ninguém do meu povo Me acompanhou. E pisei com toda a minha ira, esmaguei com todo o meu furor. Por isso espirrou sangue para a minha túnica e acabei por manchar toda a minha roupa."
,"4":"Pois chegou o dia da vingança que estava no meu coração, chegou o ano de promover a minha redenção."
,"5":"Mas olhei, e não havia quem Me ajudasse; observei admirado: não havia quem Me apoiasse. Quem Me valeu foi o meu próprio braço, o meu furor deu-Me força."
,"6":"Então pisei os povos com ira, amassei-os com o meu furor, derramando o seu sangue pelo chão»."
,"7":"Vou lembrar as graças e as glórias de Javé, tudo o que Ele fez em nosso favor. Ele é grande em bondade para com a casa de Israel. Ele tratou-nos conforme a sua compaixão e com a imensidão do seu amor."
,"8":"Ele disse: «De facto, eles são o meu povo, são filhos que jamais Me renegarão». Então tornou-Se o teu Salvador"
,"9":"em todas as tuas aflições. Quem os salvou não foi um enviado ou mensageiro, mas o próprio Javé: Ele resgatou-os com amor e compaixão, levantou-os e amparou-os em todos os dias do passado. "
,"10":"Mas eles revoltaram-se e aborreceram o seu santo espírito. Então tornou-Se inimigo deles e contra eles Se pôs em guerra."
,"11":"Mas depois eles lembraram-se dos tempos antigos, do seu servo Moisés. Onde está Aquele que fez sair das águas do Nilo o futuro pastor do seu rebanho? Onde está Aquele que colocou no seu povo o seu santo espírito?"
,"12":"Onde está Aquele que permaneceu à direita de Moisés, guiando-o com o seu braço glorioso? Onde está Aquele que abriu as águas diante do povo, adquirindo um Nome eterno?"
,"13":"Que fez andar o povo entre as ondas como um cavalo no campo? Eles não tropeçaram"
,"14":"como gado que desce para a planície: o espírito de Javé guiava-os para o repouso. Assim guiaste o teu povo, para ganhares um Nome glorioso."
,"15":"Olha do Céu e observa da tua morada santa e gloriosa: onde estão o teu ciúme e poder, o teu coração comovido e a tua compaixão? Não fiques insensível,"
,"16":"porque és o nosso Pai, pois Abraão já não nos reconhece e Israel não se lembra de nós. Javé, Tu és o nosso Pai. O teu Nome é, desde sempre, nosso Redentor."
,"17":"Javé, porque nos deixas desviar dos teus caminhos? Porque fazes endurecer o nosso coração e perder o teu temor? Volta atrás, por amor dos teus servos e das tribos que são a tua herança."
,"18":"Por um momento os nossos inimigos apoderaram-se do teu povo santo e espezinharam o teu santuário."
,"19":"Estamos como outrora, quando ainda não nos governavas, quando sobre nós o teu Nome nunca fora invocado. Quem dera rasgasses o céu e descesses! Diante de Ti as montanhas derreter-se-iam."
}`)
	CurrentBook.AddChapter(64, `{
"1":"Como quando o fogo queima os ramos secos e faz ferver a água, assim o fogo destrua os teus adversários, para que o teu Nome seja conhecido entre os teus inimigos. Diante de Ti tremiam os povos,"
,"2":"quando realizavas coisas terríveis que não esperávamos,"
,"3":"coisas de que nunca se ouviu falar desde os tempos antigos. O ouvido jamais ouviu e o olho jamais viu que um Deus além de Ti tenha feito tanto por aqueles que n'Ele confiam."
,"4":"Tu vais ao encontro daqueles que praticam a justiça e sempre se lembram dos teus caminhos. Acontece, porém, que ficaste irritado connosco, porque há muito tempo pecámos contra Ti e fomos rebeldes."
,"5":"Todos nós éramos como uma coisa imunda, a nossa justiça como roupa suja. Todos murchámos como folhas, e os nossos pecados como vento nos arrastaram."
,"6":"Ninguém invocava o teu Nome, nem se esforçava para se apoiar em Ti, pois nos escondeste a tua face e nos entregaste ao poder das nossas culpas."
,"7":"Mas agora, Javé, Tu és o nosso Pai; nós somos o barro, e Tu és o nosso oleiro; todos nós somos obra das tuas mãos."
,"8":"Não fiques irado para sempre, Javé, nem Te recordes sempre da nossa culpa. Olha que somos o teu povo."
,"9":"As tuas cidades santas tornaram-se um deserto, Sião tornou-se um lugar ermo, e Jerusalém um lugar abandonado."
,"10":"O nosso templo santo e maravilhoso, onde os nossos pais celebravam o teu louvor, está agora destruído pelo fogo; todas as nossas coisas preciosas foram destruídas."
,"11":"Depois de tudo isto, Javé, ainda permanecerás insensível? Será que vais ficar calado e aumentar ainda mais a nossa humilhação?"
}`)
	CurrentBook.AddChapter(65, `{
"1":"Eu apresentei-Me àqueles que não perguntavam por Mim; deixei que aqueles que não Me procuravam Me encontrassem. E ao povo que não invocava o meu Nome Eu dizia: «Aqui estou, aqui estou!»"
,"2":"Estendia constantemente a mão a um povo desobediente; eles andavam por um mau caminho, seguindo os seus próprios caprichos;"
,"3":"era um povo que Me provocava de frente e continuamente. Ofereciam sacrifícios em jardins, e queimavam incenso em cima de tijolos."
,"4":"Moravam em cemitérios, passavam a noite em esconderijos, nos seus pratos comiam carne de porco e alimentos impuros."
,"5":"Diziam: «Afasta-te de mim! Não me toques, porque para ti eu me tornei sagrado». Isto fez fumegar a minha ira como fogo que arde o dia inteiro."
,"6":"Isto tudo está escrito diante de Mim; Eu não Me calarei enquanto não tiver pago"
,"7":"as suas culpas e as dos seus pais, diz Javé. Eles queimaram incenso nos lugares altos e insultaram-Me no cimo das colinas; Eu calcularei o pagamento devido às suas obras antigas."
,"8":"Assim diz Javé: Quando alguém encontra sumo a escorrer num cacho de uvas, costuma dizer: «Não vou destruí-lo, porque é uma bênção!» Assim, a mesma coisa vou fazer por causa dos meus servos, para os não arrancar a todos."
,"9":"De Jacob farei brotar uma descendência, de Judá sairá o herdeiro das minhas montanhas. Os meus escolhidos herdá-las-ão, e os meus servos nelas habitarão."
,"10":"Para o meu povo que Me buscar, o monte Saron tornar-se-á pasto de ovelhas, e o vale de Acor, pastagem para o gado."
,"11":"Mas vós, que abandonastes Javé e vos esquecestes da sua montanha santa, vós que preparastes a mesa em honra da deusa Fortuna, vós que enchestes taças em honra do deus Destino,"
,"12":"Eu destinei-vos para morrerdes pela espada, sem que ninguém escape da matança, e todos vós vos curvareis para serdes degolados. Pois Eu chamei e ninguém respondeu, falei e ninguém Me obedeceu; praticastes o mal e escolhestes só o que Me desagradava."
,"13":"Por isso, assim diz o Senhor Javé: Os meus servos comerão, e vós passareis fome; os meus servos beberão, e vós passareis sede; os meus servos estarão contentes, e vós envergonhados;"
,"14":"os meus servos cantarão por terem o coração alegre, e vós gritareis com dor no coração, e uivareis pela angústia do espírito."
,"15":"Entre os meus escolhidos, deixareis o vosso nome como uma palavra amaldiçoada: «Que o Senhor Javé te faça morrer!» Mas os meus servos terão outro nome,"
,"16":"de tal modo que neste país, quem quiser ser abençoado, será abençoado pelo Deus verdadeiro; se alguém quiser jurar neste país, é pelo Deus verdadeiro que há-de jurar, pois aquelas angústias antigas serão esquecidas, e desaparecerão da minha vista."
,"17":"Olhai! Eu vou criar um novo céu e uma nova terra. As coisas antigas nunca mais serão lembradas, nunca mais voltarão ao pensamento."
,"18":"Por isso ficai para sempre alegres e contentes, por causa do que vou criar. Farei de Jerusalém uma alegria, e do seu povo um regozijo."
,"19":"Exultarei com Jerusalém e alegrar-Me-ei com o meu povo. Nela nunca mais se ouvirá choro ou clamor."
,"20":"Ali não haverá crianças que vivam alguns dias apenas, nem velhos que não cheguem a completar os seus dias, pois será ainda jovem quem morrer com cem anos, e quem não chegar aos cem anos será tido por amaldiçoado."
,"21":"Construirão casas e nelas habitarão, plantarão vinhas e comerão os seus frutos."
,"22":"Ninguém construirá para outro morar, ninguém plantará para outro comer, porque a vida do meu povo será longa como a das árvores, os meus escolhidos usufruirão do que as suas mãos fabricarem."
,"23":"Ninguém trabalhará inutilmente, ninguém gerará filhos para morrerem antes do tempo, porque todos serão a descendência dos abençoados de Javé, juntamente com os seus filhos."
,"24":"Antes que Me invo-quem, Eu responderei; quando começarem a falar, Eu já estarei a atendê-los."
,"25":"O lobo e o cordeiro pastarão juntos, o leão comerá feno juntamente com o boi, mas o alimento da cobra é o pó da terra. Em todo o meu monte santo ninguém causará danos ou estragos, diz Javé."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Assim diz Javé: O céu é o meu trono e a terra é o apoio para os meus pés. Que tipo de casa Me poderíeis construir? Que lugar poderia servir para meu descanso?"
,"2":"Tudo o que existe fui Eu que o fiz, tudo o que existe é meu - oráculo de Javé. Eu olho para os aflitos e para os de espírito abatido, e também para aqueles que estremecem diante das minhas palavras."
,"3":"Há quem sacrifica um boi, e depois mata um homem; há quem oferece um carneiro no altar, e depois degola um cão; há quem apresenta uma oferenda, e oferece também carne de porco; há quem faz uma invocação com incenso, e também venera os ídolos. Todos eles escolheram o seu próprio caminho e se alegram com as suas abominações."
,"4":"Por isso, Eu também escolherei os seus castigos e farei cair sobre eles exactamente o que eles mais temem. Pois chamei, e ninguém respondeu; falei, e ninguém obedeceu. Praticastes o mal e escolhestes o que Me desagradava."
,"5":"Ouvi a palavra de Javé, vós que venerais a sua palavra: os vossos irmãos que vos odeiam e, por minha causa vos rejeitam, dizem: «Que Javé mostre a sua glória, para que vejamos a vossa alegria»; pois eles é que ficarão confundidos."
,"6":"Um barulho vem da cidade, um rumor vem do templo: é a voz de Javé que dá o pagamento aos seus inimigos."
,"7":"Antes dos trabalhos de parto, ela deu à luz; antes de chegarem as dores, ela pôs no mundo um filho varão."
,"8":"Quem já ouviu tal coisa? Quem já viu coisa assim? Pode nascer um país inteiro num só dia? Pode alguém dar à luz uma nação inteira de uma só vez? Pois, ao sentir as dores, Sião deu à luz os seus filhos."
,"9":"«Será que Eu, Eu que faço abrir o útero, não deixarei nascer os filhos?» diz Javé. «Se sou Eu que faço gerar, iria Eu impedir de dar à luz?», diz o vosso Deus."
,"10":"Alegrai-vos com Jerusalém, exultai com ela, vós todos os que a amais. Participai da sua enorme alegria vós todos os que participastes do seu luto."
,"11":"Assim podereis amamentar-vos nela até ficardes satisfeitos com a consolação que ela tem; sugareis com satisfação a abundância do seu seio."
,"12":"Porque assim diz Javé: Farei correr para Jerusalém a prosperidade como um rio, e as riquezas das nações como torrentes que transbordam. Os seus bebés serão levados ao colo, e serão acariciados sobre os joelhos."
,"13":"Como a mãe consola o seu filho, assim Eu vou consolar-vos; em Jerusalém, sereis consolados."
,"14":"Ao verdes isto, o vosso coração alegrar-se-á. A mão de Javé manifestar-se-á aos seus servos, mas indignar-se-á contra os seus inimigos."
,"15":"Porque Javé vem com fogo, e os seus carros parecem um furacão, para desabafar a sua ira com ardor e a sua ameaça com chamas de fogo."
,"16":"É com fogo que Javé fará justiça sobre toda a terra, e com a sua espada ameaça o mundo inteiro; são muitas as vítimas que Ele faz."
,"17":"Os que se consagram e se purificam para celebrar ritos em jardins de culto, conduzidos por alguém que está no meio deles, e os que comem carne de porco, répteis e ratos, todos eles perecerão juntamente com as suas práticas e os seus projectos - oráculo de Javé."
,"18":"Eu virei para reunir todos os povos e todas as línguas. Todos virão para admirar a minha glória."
,"19":"Colocarei neles um sinal. E os que entre eles sobreviverem, enviá-los-ei para as nações de Társis, Fut, Lud, Mosoc, Tubal e Javã, para as distantes terras de além-mar, que nunca ouviram falar de Mim, que nunca viram a minha glória; eles anunciarão a minha glória entre as nações."
,"20":"De todas as nações trarão, como oferta para Javé, todos os vossos irmãos. Vou trazê-los a cavalo, em carroça, em liteiras, montados em mulas ou camelos, até Jerusalém, a minha santa montanha, diz Javé. Será como quando os israelitas levam até ao altar as suas ofertas em vasilhas consagradas do templo de Javé."
,"21":"Do meio deles escolherei também alguns como sacerdotes e levitas, diz Javé."
,"22":"Da mesma forma como durarão para sempre diante de Mim os novos céus e a nova terra, que criarei, - oráculo de Javé - assim também durarão a vossa descendência e o vosso nome."
,"23":"Em cada lua nova e em cada sábado, todo o mortal virá prostrar-se na minha presença, diz Javé."
,"24":"Ao sair, verão os cadáveres daqueles que se revoltaram contra Mim, por-que o verme que os corrói nunca morrerá e o fogo que os consome não se apagará. Eles serão um horror para o mundo inteiro."
}`)

}
func PT_BS_LoadVMLMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Ai! Como está solitária a capital do povo!,A primeira entre as nações está como viúva. Quem era grande entre os povos, agora paga tributo."
,"2":"Banhada em lágrimas a face, passa a noite a chorar. De todos os seus amantes, não há nenhum que a console. Todos os seus aliados a traíram, tornando-se seus inimigos."
,"3":"Judá foi para o exílio, humilhada e em dura escravidão; foi morar entre as nações, onde já não encontra repouso. Os seus perseguidores alcançaram-na em lugares sem saída."
,"4":"Estão de luto os caminhos de Sião: ninguém vem para as festas. Todas as suas portas estão desertas e os seus sacerdotes choram; as suas virgens estão aflitas e ela está cheia de amargura."
,"5":"Os seus opressores venceram-na, os seus inimigos estão felizes, porque Javé a castigou, pelas suas numerosas revoltas. Até as suas crianças são levadas como escravas à frente do opressor."
,"6":"A cidade de Sião perdeu toda a sua beleza!,Os seus chefes parecem animais que não encontram pastagem; caminham sem forças, empurrados pelas costas."
,"7":"Jerusalém recorda os dias de miséria e aflição, quando o seu povo caía nas mãos do inimigo e ninguém o socorria. Ao vê-la, os seus inimigos riam-se da sua queda."
,"8":"Jerusalém pecou gravemente e tornou-se impura. Os que antes a honravam, desprezam-na vendo-lhe a nudez. Até ela, gemendo, volta as costas."
,"9":"Leva as suas impurezas na veste, sem pensar no futuro. Caiu de modo espantoso e não há quem a console. «Javé, olha para o meu sofrimento e para o triunfo do meu inimigo!»"
,"10":"O inimigo lançou mão a todos os seus tesouros. Jerusalém viu pagãos a invadir o Templo sagrado, apesar de lhes teres proibido entrar na tua assembleia."
,"11":"Gemendo, o povo labuta em busca de pão; trocam as suas jóias por comida que os possa reanimar. «Olha, Javé, e presta atenção: como estou rebaixada!"
,"12":"Vós todos que passais pelo caminho, olhai e vede: haverá dor semelhante à minha dor? Como me maltrataram!,Javé castigou-me no dia do furor da sua ira."
,"13":"Do céu lançou um fogo que entrou até aos meus ossos. Armou um laço para me agarrar pelo pé e puxou-me para trás. De mim fez uma cidade desolada, deprimida para sempre."
,"14":"Javé fez um fardo com as minhas culpas e com a sua mão o amarrou; colocou-o aos meus ombros, abatendo a minha força. Javé entregou-me nas mãos deles, e eu não consigo levantar-me."
,"15":"Javé dispersou todos os meus guerreiros que estavam comigo. Convocou contra mim grande multidão, para matar os meus soldados. Como num tanque, Javé esmagou a donzela, a capital de Judá."
,"16":"Por isso, choro e meus olhos se derretem, pois não tenho perto alguém que me console, alguém que me reanime. Os meus filhos estão desolados, porque o inimigo venceu!»"
,"17":"Sião estende as mãos, e ninguém a consola. Javé ordenou que os vizinhos atacassem Jacob; Jerusalém ficou no meio deles como coisa imunda."
,"18":"«No entanto, Javé é justo, porque me revoltei contra a sua palavra. Prestai atenção, povos todos, vede a minha dor: as minhas jovens e os meus jovens foram levados como escravos."
,"19":"Chamei os meus amantes, e eles traíram-me. Os meus sacerdotes e anciãos morreram na cidade, enquanto procuravam comida para reanimar as forças."
,"20":"Vê, Javé, como estou angustiada: as minhas entranhas fervem; o meu coração transtorna-se dentro de mim, porque me revoltei. Lá fora, a espada tira-me os filhos, em casa é a morte."
,"21":"Escutai como estou gemendo, e não há quem me console. Os inimigos comemoram a minha derrota, que Tu mesmo causaste!,Traz, então, aquele dia que prometeste, em que eles passarão o que eu passei."
,"22":"Chegue a sua maldade à tua presença: trata-os como me trataste por causa das minhas revoltas, pois os meus gemidos não cessam e o meu coração desfalece». Segunda Lamentação: Javé arrasou sem piedade"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Na sua ira, Javé escureceu a cidade de Sião. Fez cair do céu o esplendor de Israel!,No dia da sua ira, esqueceu-Se do apoio dos seus pés."
,"2":"O Senhor arrasou sem piedade todas as moradas de Jacob; em seu furor, destruiu as fortalezas da capital de Judá; lançou por terra, desonrados, o reino e os chefes."
,"3":"No ardor da sua ira, quebrou o poder de Israel; cruzou os braços, quando o inimigo atacava; acendeu Jacob como tocha, queimando tudo em volta."
,"4":"Como inimigo, disparou as suas flechas, puxando com a direita; como invasor, destruiu a flor da juventude; nas tendas de Sião, atiçou o fogo da sua ira."
,"5":"O Senhor era como um inimigo, ao destruir Israel. Demoliu todos os seus palácios e derrubou as suas fortalezas; na capital de Judá multiplicou choros e gemidos."
,"6":"Como ladrão, invadiu-lhe a morada, arrasou o lugar da assembleia; Javé fez cair no esquecimento sábados e festas em Sião; indignado e furioso, rejeitou rei e sacerdote."
,"7":"O Senhor rejeitou o seu próprio altar, desprezou o seu santuário; pôs na mão do inimigo as muralhas dos seus palácios; no Templo de Javé, eles soltaram a voz, como em dia de festa."
,"8":"Javé decidiu arrasar as muralhas de Sião: esticou o fio de prumo e não retirou a sua mão destruidora. A muralha e a torre estão de luto: juntas, desmoronaram-se."
,"9":"Derrubou por terra as portas, quebrou as fechaduras; o seu rei e os seus chefes estavam entre os pagãos: não havia Lei, e os profetas já não recebiam visão de Javé."
,"10":"Os anciãos da cidade de Sião sentam-se no chão em silêncio, lançam cinza sobre a cabeça, vestidos de luto; as jovens de Jerusalém baixam a cabeça até ao chão."
,"11":"Em lágrimas, os meus olhos derretem-se, as minhas entranhas fervem; a minha bílis derrama-se pelo chão, por causa da ruína da capital do meu povo, enquanto crianças e bebés desfalecem pelas ruas da cidade."
,"12":"Perguntavam às suas mães: «Onde há pão e vinho?»,E desmaiavam, como feridos, pelas ruas da cidade, ou soltavam o último suspiro, no colo das mães."
,"13":"Quem pode igualar-se ou comparar-se a ti, cidade de Jerusalém?,A quem te compararei para te consolar, jovem capital de Sião?,A tua derrota é tão grande como o mar: quem poderá curar-te?"
,"14":"Os teus profetas falaram-te de visões falsas, mentirosas; para te mudar o destino, eles nunca te mostraram,os pecados que cometeste. Só te revelaram visões falsas, sedutoras."
,"15":"Passando pelo caminho, qualquer um te insulta, batendo palmas, assobiam e abanam a cabeça, zombando de Jerusalém: «É esta a cidade formosa, alegria de toda a terra?»"
,"16":"Todos os seus inimigos escarnecem de ti às gargalhadas; assobiam, rangem os dentes, e vão dizendo: «Acabámos com ela!,Este é o dia que esperávamos; conseguimos e já vimos»."
,"17":"Javé realizou o seu projecto, cumpriu a sua palavra, que dissera há muito tempo: destruiu sem compaixão, exaltou o adversário, dando ao inimigo o gozo da vitória."
,"18":"Grita de coração ao Senhor, ó muralha da capital de Sião; derrama rios de lágrimas, dia e noite; não deixes de chorar, nem descanses os teus olhos."
,"19":"Levanta-te e grita na noite, quando começam as trocas da guarda, derrama como água o teu coração diante do Senhor; pela vida de teus filhos, levanta para Ele as mãos. Eles estão a desmaiar de fome pelas esquinas da cidade."
,"20":"«Vê, Javé, e considera: a quem já trataste assim?,Quando é que as mulheres comeram os seus próprios filhos, os bebés que levam ao colo?,Quando é que assassinaram sacerdotes e profetas no Templo do Senhor?"
,"21":"Velhos e jovens estão prostrados no chão das ruas; os meus jovens e as minhas jovens caíram ao fio da espada. No dia da tua ira, mataste, assassinaste sem dó!"
,"22":"Convocaste, como para uma festa, os terrores que me cercam. Não houve quem fugisse ou escapasse, no dia da ira de Javé. Todos aqueles que eu amimei e criei, o meu inimigo os matou!»"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Eu sou alguém que provou a miséria, sob a vara da tua ira."
,"2":"Ele conduziu-me e fez-me andar nas trevas e não na luz."
,"3":"Ele dirige contra mim a sua mão, todos os dias, sem cessar."
,"4":"Consumiu a minha carne e a minha pele, e quebrou os meus ossos."
,"5":"À minha volta, armou um cerco de veneno e amargura,"
,"6":"fez-me morar nas trevas como os que morreram há muito tempo."
,"7":"Cercou-me qual muro sem saída, e acorrentado, me prendeu."
,"8":"Clamar ou gritar de nada vale, Ele está surdo à minha súplica."
,"9":"Com pedra cercou a minha estrada, distorceu o meu caminho."
,"10":"Ele foi para mim como um urso à espreita, um leão de emboscada."
,"11":"Desviou-me do caminho, despedaçou-me e deixou-me inerte."
,"12":"Disparou o seu arco, fez de mim o alvo das suas flechas."
,"13":"Em meus rins cravou as suas flechas, tiradas da sua aljava."
,"14":"Eu tornei-me a irrisão de todo o meu povo, a sua canção de todo o dia."
,"15":"Encheu o meu estômago de amargura, embriagou-me de fel."
,"16":"Fez-me dar com os dentes numa pedra, fez-me cair no pó."
,"17":"Fugiu a paz do meu espírito, a felicidade acabou."
,"18":"Eu digo: «Acabaram as minhas forças e a minha esperança em Javé»."
,"19":"Lembra-Te da minha miséria e sofrimento, o fel que me envenena."
,"20":"Guardo triste essa lembrança e sinto-me abatido."
,"21":"Mas há uma coisa que eu lembro e me dá esperança:"
,"22":"o amor de Javé nunca acaba e a sua compaixão não tem fim."
,"23":"Pelo contrário, renovam-se cada manhã: «Como é grande a tua fidelidade!»"
,"24":"Digo a mim mesmo: «Javé é a minha herança», por isso n'Ele espero."
,"25":"Javé é bom para os que n'Ele esperam e O procuram."
,"26":"É bom esperar em silêncio a salvação de Javé."
,"27":"É bom para o homem suportar o jugo desde a juventude."
,"28":"Que esteja sozinho e calado, quando cai sobre ele a desgraça;"
,"29":"que ponha a sua boca no pó: talvez haja esperança;"
,"30":"que entregue a face a quem o fere até se fartar de insultos,"
,"31":"porque o Senhor não rejeita para sempre."
,"32":"Embora castigue, compadecer-Se-á com grande amor,"
,"33":"porque é contra o seu desejo humilhar e castigar os homens,"
,"34":"esmagar sob os pés todos os prisioneiros da terra,"
,"35":"negar o direito do homem diante do Altíssimo,"
,"36":"lesar um homem no processo: o Senhor não aprova estas coisas."
,"37":"Quem fez acontecer as coisas senão o Senhor que as ordenou?"
,"38":"Não é da boca do Altíssimo que vêm o mal e o bem?"
,"39":"Porque se queixa um ser vivo, um homem, pelo castigo do seu pecado?"
,"40":"Observemos e olhemos o nosso caminho e voltemos para Javé."
,"41":"Levantemos, com as nossas mãos, o coração para o Deus do céu."
,"42":"Nós pecámos, fomos rebeldes, e não nos perdoaste."
,"43":"Envolto em ira, perseguiste-nos e mataste sem piedade."
,"44":"Envolveste-Te numa nuvem para que as nossas súplicas não Te alcancem."
,"45":"Fizeste de nós o desprezo e o lixo das nações."
,"46":"Todos os nossos inimigos riem de nós."
,"47":"Assaltam-nos terrores e espantos, desgraças e fracassos."
,"48":"Derramo rios de lágrimas pela destruição da capital do meu povo."
,"49":"Os meus olhos choram sem trégua nem descanso,"
,"50":"até que Javé apareça e me veja lá do Céu."
,"51":"Os meus olhos doem-me por tanto chorar as jovens da minha cidade."
,"52":"Caçaram-me como pássaro os que me odeiam sem motivo."
,"53":"Lançaram-me vivo para um fosso e puseram uma pedra em cima."
,"54":"Subiu a água até ao meu pescoço, e eu pensei: «Estou perdido!»"
,"55":"Do fundo do fosso invoquei o teu Nome, ó Javé."
,"56":"Ouve a minha voz, não feches o ouvido ao meu apelo."
,"57":"Tu vieste na hora em que eu chamei, e respondeste: «Não tenhas medo»."
,"58":"Tu Te encarregaste de defender a minha causa e resgatar a minha vida."
,"59":"Tu viste, Javé, que sofro injustiça: julga a minha causa."
,"60":"Viste a vingança que tramam contra mim;"
,"61":"ouviste, Javé, os insultos, o que tramam contra mim,"
,"62":"o que dizem e tramam contra mim continuamente."
,"63":"Vigia todos os seus movimentos: eu sou objecto das suas piadas."
,"64":"Tu lhes pagarás, Javé, como as suas obras merecem."
,"65":"Dá-lhes um coração endurecido e sobre eles caia a tua maldição."
,"66":"Persegue-os com ira e arrasa-os debaixo do céu."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ai! Como o ouro puro perdeu o brilho!,Espalharam-se as pedras sagradas pelas esquinas das ruas."
,"2":"Os nobres filhos de Sião, que valiam o seu peso em ouro, são agora tratados como vasos de barro, trabalho de oleiro."
,"3":"Até as lobas dão o peito para amamentar as crias; só esta cidade é mãe desalmada, como avestruz do deserto."
,"4":"De sede, a língua dos bebés cola-se ao céu da boca; as crianças pedem pão, e ninguém lho dá."
,"5":"Os que comiam coisas finas estão a cair de fome pelas ruas; quem cresceu vestido de púrpura está encolhido no lixo."
,"6":"O pecado desta cidade foi de certo maior que o de Sodoma, pois Sodoma foi destruída de uma vez, sem ninguém a agredir."
,"7":"Os seus jovens eram mais limpos que a neve, mais brancos que o leite; eram mais rosados que o coral, com veias de azul-safira."
,"8":"Hoje estão mais negros que o carvão, e na rua ninguém os reconhece; a pele enrugada sobre os ossos, seca como lenha."
,"9":"Mais felizes os que morreram pela espada do que os mortos pela fome; Aqueles foram apunhalados e perderam o sangue; estes caíram por falta de alimento."
,"10":"As mãos de mulheres, cheias de ternura, cozinham os seus próprios filhos; são eles o seu alimento na ruína da capital do meu povo."
,"11":"Javé libertou o seu ódio, derramou a sua ira, em Sião acendeu uma fogueira que devora até os alicerces."
,"12":"Mas nunca os reis da terra ou qualquer cidadão acreditariam,que um inimigo ou invasor pudesse entrar pelas portas de Jerusalém."
,"13":"Foi pelos erros dos profetas e pelos crimes dos sacerdotes,que derramaram sangue inocente dentro da cidade."
,"14":"Andavam errantes como cegos pelas ruas, cobertos de sangue: ninguém podia tocar nas suas vestes."
,"15":"«Para trás! - gritavam - estou impuro! Para trás! Não me toqueis». Iam errantes como fugitivos que não recebem asilo."
,"16":"Javé dispersou-os e já não cuida deles. Já não há respeito pelo sacerdote, nem compaixão pelos velhos."
,"17":"Os nossos olhos consomem-se, esperando em vão por socorro: esperamos, vigilantes, um povo incapaz de salvar."
,"18":"Espiavam continuamente os nossos passos, já nem andávamos pelas praças. Chegava o nosso fim, o termo dos nossos dias."
,"19":"Os nossos perseguidores eram mais velozes que as águias do céu; sobre os montes corriam atrás de nós e punham armadilhas no deserto."
,"20":"O ungido de Javé, nosso alento, caiu preso na armadilha; dele dizíamos: «À sua sombra viveremos entre os povos»."
,"21":"Vibra de alegria e faz festa, capital de Edom, que habitas em Hus, pois também terás o teu cálice: embriagada, desnudar-te-ás."
,"22":"Está cumprida a tua pena, capital de Sião; Deus nunca mais te exilará; Ele castigará a tua falta, capital de Edom, e o teu pecado aparecerá."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Lembra-te, Javé, do que aconteceu; olha bem, para ver a vergonha que passamos!"
,"2":"A nossa herança passou para estrangeiros, as nossas casas são agora de gente estranha."
,"3":"Agora somos todos órfãos, pois perdemos o nosso pai; as nossas mães ficaram viúvas."
,"4":"Temos que comprar a água que bebemos,e pagar a lenha que usamos."
,"5":"Com a canga no pescoço somos empurrados; estamos cansados, pois eles não nos dão descanso."
,"6":"Ao Egipto já estendemos as nossas mãos pedindo ajuda, já suplicámos à Assíria que nos desse de comer."
,"7":"Os nossos pais pecaram e já morreram, e nós é que pagamos pelas suas culpas."
,"8":"Quem manda em nós é gente que era escrava; não há quem possa libertar-nos da sua mão."
,"9":"Arriscamos a própria vida pelo pão, enfrentando em campo aberto a espada inimiga."
,"10":"A nossa pele queima como um forno, torturada pela fome."
,"11":"Violentaram as mulheres em Sião e as jovens nas cidades de Judá."
,"12":"Com as suas mãos esganaram os chefes e não respeitaram os anciãos."
,"13":"Forçaram os jovens a girar o moinho, os rapazes sucumbiram sob o peso da lenha."
,"14":"Os anciãos já não participam do Conselho,e os jovens deixaram os seus instrumentos de corda."
,"15":"Acabou a alegria que nos enchia o coração, a nossa dança mudou-se em luto."
,"16":"Caiu a coroa da nossa cabeça: Ai de nós, porque pecámos!"
,"17":"Por isso, o nosso coração está doente e os nossos olhos embaciados."
,"18":"Porque o monte Sião está desolado e por ele passeiam as raposas."
,"19":"Mas Tu, Javé, permaneces para sempre, o teu trono permanece de geração em geração."
,"20":"Então, porque haverias de esquecer-nos para sempre, e deixar-nos abandonados por tanto tempo?"
,"21":"Faz-nos voltar para Ti, Javé, e voltaremos; renova os tempos passados."
,"22":"Ou será que nos rejeitaste de uma vez; será que a tua cólera não tem limites?"
}`)

}
func PT_BS_LoadVNABChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Visão de Abdias. Assim diz o Senhor Javé a Edom: Ouvimos uma mensagem de Javé; Ele mandou um mensageiro a dizer às nações: Levantai-vos! Vamos combater contra ela."
,"2":"Faço de ti a menor das nações, e serás de todas a mais desprezada."
,"3":"Quem acabou contigo foi a soberba do teu coração! Tu escondes-te nas cavernas dos rochedos e pões-te à espreita nas alturas das montanhas, pensando que ninguém será capaz de te fazer descer à planície."
,"4":"Entretanto, mesmo que voes como a águia, ou faças o ninho entre as estrelas, far-te-ei descer de onde estiveres - oráculo de Javé."
,"5":"Quando os ladrões ou assaltantes da noite vêm ter contigo não roubam apenas o suficiente? E os que colhem, não deixam alguns cachos?"
,"6":"Como Esaú foi devastado! Até os seus esconderijos foram revistados!"
,"7":"Os aliados empurraram-te até à fronteira, os amigos enganaram-te e submeteram-te; aqueles que comem contigo, armaram-te ciladas: «Ele perdeu o juízo!»"
,"8":"E não é porventura nesse dia - oráculo de Javé - que vou acabar com os sábios de Edom, com a inteligência da montanha de Esaú?"
,"9":"Os teus heróis, ó Temã, acovardar-se-ão, de tal modo que todo o homem será eliminado da montanha de Esaú. Por causa do morticínio"
,"10":"e da violência praticada contra o teu irmão Jacob, a vergonha cobrir-te-á e serás eliminado para sempre."
,"11":"Nesse dia, tu estavas presente: quando os estrangeiros derrotaram o exército de Judá, quando os inimigos entraram pelas portas e repartiram Jerusalém no sorteio. Tu estavas presente, como um deles."
,"12":"«Não olhes com alegria para o dia do teu irmão, o dia da sua desgraça. Não te alegres à custa dos filhos de Judá, no dia da sua ruína. Não fales com insolência, no dia da sua humilhação."
,"13":"Não entres pela porta do meu povo, no dia da sua infelicidade. Não aproveites tu também da sua desgraça, no dia da sua ruína. Não deites a mão às suas riquezas, no dia da sua derrota."
,"14":"Não te escondas nas esquinas, para matar os fugitivos. Não aprisiones os seus fugitivos, no dia do desespero»."
,"15":"Pois o Dia de Javé está a chegar para todas as nações. Como tu fizeste aos outros, assim te será feito. Os actos que praticaste, cairão sobre a tua cabeça."
,"16":"Tal como vós os de Judá bebestes na minha montanha santa, assim também, por sua vez, beberão todas as nações. Vão beber e sorver até ao último gole, e vão desaparecer como se nunca tivessem existido."
,"17":"No monte Sião haverá sobreviventes. Eles serão santificados. E a casa de Jacob tornar-se-á proprietária dos seus antigos proprietários."
,"18":"A casa de Jacob será o fogo, a casa de José será a labareda, e a casa de Esaú será a palha. Vão incendiar e acabar com ela. Não vai escapar ninguém da casa de Esaú, porque assim diz Javé."
,"19":"Os moradores do Negueb serão donos da montanha de Esaú, e os da Planície serão donos da Filisteia. Ocuparão o território de Efraim e da Samaria; Benjamim ocupará o território de Galaad."
,"20":"Os exilados da casa de Israel ocuparão o que pertenceu aos cananeus até Sarepta; os exilados de Jerusalém, que estão em Safarad, vão ocupar as cidades do Negueb."
,"21":"Vitoriosos, subirão a montanha de Sião, para daí governarem a montanha de Esaú. E o reino pertencerá a Javé."
}`)

}
func PT_BS_LoadVNAGChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No primeiro dia do sexto mês do segundo ano do reinado de Dario, a palavra de Deus foi dirigida, por meio do profeta Ageu, ao governador da Judeia, Zorobabel, filho de Salatiel, e ao chefe dos sacerdotes, Josué, filho de Josedec."
,"2":"Assim diz Javé dos exércitos: Este povo diz que ainda não chegou a hora de reconstruir o Templo de Javé."
,"3":"E Javé dirigiu a palavra por meio do profeta Ageu:"
,"4":"Então vós achais que é tempo de habitardes tranquilos em casas confortáveis, enquanto o Templo está em ruínas?"
,"5":"Ora, assim diz Javé dos exércitos: Reflecti bem no vosso comportamento."
,"6":"Vós semeastes muito e colhestes pouco; comeis e não ficais satisfeitos; bebeis e não ficais embriagados; vestis roupa, mas não aqueceis o corpo; e o trabalhador guarda o seu salário num saco roto."
,"7":"Assim diz Javé dos exércitos: Reflecti bem no vosso comportamento."
,"8":"Subi à montanha, cortai madeira e construí o Templo. Eu vou gostar dele e nele manifestarei a minha glória - diz Javé."
,"9":"Vós esperáveis muito: era pouco o que vinha, e Eu ainda soprava para longe o que estáveis a recolher. E porquê? - oráculo de Javé dos exércitos. Porque o meu Templo está em ruínas, enquanto cada um de vós se preocupa com a sua própria casa."
,"10":"É por isso que o céu vos recusa o orvalho e a terra nega o seu fruto."
,"11":"Eu mandei vir uma seca sobre a terra e os montes, sobre o trigo e o vinho, sobre o azeite e tudo o que a terra produz, sobre homens e animais, sobre todo o produto das vossas mãos."
,"12":"Zorobabel, filho de Salatiel, com o chefe dos sacerdotes, Josué, filho de Josedec, e o resto do povo obedeceram à Palavra de Javé, seu Deus, porque o povo, ouvindo as palavras do profeta Ageu, teve medo de Javé."
,"13":"Ageu, mensageiro de Javé, disse ao povo, conforme a mensagem de Javé: Eu estou convosco - oráculo de Javé."
,"14":"Javé encorajou o governador da Judeia, Zorobabel, filho de Salatiel, o chefe dos sacerdotes, Josué, filho de Josedec, e o resto do povo. Então eles puseram mãos à obra na reconstrução do Templo de Javé dos exércitos, seu Deus."
,"15":"Era o dia vinte e quatro do sexto mês do segundo ano do reinado de Dario."
}`)
	CurrentBook.AddChapter(2, `{
"1":"No dia vinte e um do sétimo mês, a palavra de Javé fez-se ouvir por meio do profeta Ageu nestes termos:"
,"2":"Diz ao governador da Judeia, Zorobabel, filho de Salatiel, ao chefe dos sacerdotes, Josué, filho de Josedec, e ao resto do povo:"
,"3":"Entre vós há algum sobrevivente que tenha visto este Templo no seu antigo esplendor? Que achais dele agora? Em comparação com o antigo, não vos parece que este nem existe?"
,"4":"E agora, coragem, Zorobabel! - oráculo de Javé. Coragem, Josué, filho de Josedec, chefe dos sacerdotes! Coragem, povo todo da terra! É Javé que o diz. Mãos à obra, pois Eu estou convosco - oráculo de Javé dos exércitos -"
,"5":"conforme a palavra da Aliança que estabeleci convosco, quando saístes do Egipto. O meu espírito estará convosco. Não tenhais medo!"
,"6":"Porque assim diz Javé dos exércitos: Daqui a pouco tempo farei tremer os céus e a terra, o mar e a terra firme."
,"7":"Vou sacudir todas as nações e, então, as riquezas das nações hão-de vir para cá, e assim encherei este Templo com a minha glória, diz Javé dos exércitos."
,"8":"Toda a prata é minha, todo o ouro Me pertence!, diz Javé dos exércitos."
,"9":"A glória futura deste Templo será bem maior que a de antes, diz Javé dos exércitos. Neste lugar estabelecerei a paz, diz Javé dos exércitos."
,"10":"No dia vinte e quatro do nono mês do segundo ano do reinado de Dario, a palavra de Javé foi dirigida ao profeta Ageu nestes termos:"
,"11":"Assim diz Javé dos exércitos: Consulta os sacerdotes sobre o seguinte caso:"
,"12":"Se alguém, com a barra da veste, toca em alguma carne consagrada e depois com ela toca em pão, em comida, em vinho, em azeite ou em qualquer outro alimento, porventura essas coisas ficam consagradas? Os sacerdotes responderam que não."
,"13":"Ageu continuou: Se alguém, estando impuro pelo contacto dum cadáver, toca em uma dessas coisas, será que elas se tornam impuras? Os sacerdotes responderam que sim."
,"14":"Então Ageu disse: Pois a mesma coisa acontece com este povo e nação em relação a Mim - oráculo de Javé. É isso que acontece com o trabalho das suas mãos: tudo o que Me oferecem é impuro."
,"15":"Agora, pensai no dia de hoje e para o futuro. Antes de colocardes uma pedra em cima da outra para construir o Templo de Javé,"
,"16":"qual era a vossa situação? Uma pessoa ia a uma seara de trigo, esperando que desse vinte medidas, e dava apenas dez; ia a um tonel para tirar cinquenta barris, e achava apenas vinte."
,"17":"Com o carvão, a ferrugem do trigo e o granizo destruí todo o trabalho das vossas mãos, mas não voltastes para Mim - oráculo de Javé."
,"18":"Olhando para trás, prestai atenção daqui em diante, a partir do dia vinte e quatro do nono mês, dia em que foram lançados os alicerces do novo Templo de Javé:"
,"19":"Vede se vai faltar trigo na tulha e se a videira, a figueira, a romãzeira e a oliveira não produzirão frutos, pois a partir de hoje Eu dou-vos a minha bênção."
,"20":"No dia vinte e quatro, pela segunda vez, a palavra de Javé foi dirigida a Ageu nestes termos:"
,"21":"Fala a Zorobabel, governador da Judeia: Eu vou fazer tremer os céus e a terra."
,"22":"Vou derrubar os tronos dos reis, vou acabar com a força dos reinos das nações. Derrubarei o carro de guerra com o seu condutor; cavalos e cavaleiros cairão, cada um ferido pela espada de seu próprio companheiro."
,"23":"Naquele dia - oráculo de Javé dos exércitos - Eu te tomarei, ó Zorobabel, meu servo, filho de Salatiel - oráculo de Javé - e guardar-te-ei como um carimbo, pois és o meu escolhido - oráculo de Javé dos exércitos."
}`)

}
func PT_BS_LoadVNAMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palavras de Amós, um pastor de Técua, que teve visões a respeito de Israel, no tempo de Ozias, rei de Judá, e no tempo de Jeroboão, filho de Joás, rei de Israel, dois anos antes do terremoto."
,"2":"Ele disse: Javé ruge de Sião, de Jerusalém faz ouvir o seu grito; as pastagens dos pastores murcham, e até o cume do Carmelo seca."
,"3":"Assim diz Javé: Por três crimes de Damasco e pelo quarto, Eu não vou perdoar: porque despedaçaram Galaad com grade de ferro."
,"4":"Deitarei fogo à casa de Hazael e queimarei os palácios de Ben-Adad;"
,"5":"rebentarei os ferrolhos de Damasco; eliminarei os chefes de Biceat-Áven e o senhor do poder em Bet-Éden; e o povo de Aram irá cativo para Quir - diz Javé."
,"6":"Assim diz Javé: Por três crimes de Gaza e pelo quarto, Eu não vou perdoar: porque fizeram cativo um povo inteiro, para o entregarem a Edom."
,"7":"Deitarei fogo às muralhas de Gaza e queimarei os seus palácios;"
,"8":"eliminarei os chefes de Azoto e o senhor do poder em Ascalon; voltarei a minha mão contra Acaron, e o que sobrar dos filisteus será liquidado - diz Javé."
,"9":"Assim diz Javé: Por três crimes de Tiro e pelo quarto, Eu não vou perdoar: porque fizeram cativo um povo inteiro para o entregarem a Edom, sem respeitar o pacto de irmãos."
,"10":"Deitarei fogo às muralhas de Tiro e queimarei os seus palácios - diz Javé."
,"11":"Assim diz Javé: Por três crimes de Edom e pelo quarto, Eu não vou perdoar: porque perseguiram os seus irmãos com a espada, sem ouvir a voz do sangue fraterno, e porque acenderam a sua raiva para sempre, guardando ódio eterno."
,"12":"Deitarei fogo a Temã e queimarei os palácios de Bosra - diz Javé."
,"13":"Assim diz Javé: Por três crimes de Amon e pelo quarto, Eu não vou perdoar: porque rasgaram o ventre das mulheres grávidas de Galaad, só para alargarem as suas fronteiras."
,"14":"Deitarei fogo às muralhas de Rabá e queimarei os seus palácios, com gritos de guerra no dia da batalha, como um vendaval em dia de tempestade;"
,"15":"o seu rei irá para o cativeiro, juntamente com os seus chefes - diz Javé."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Assim diz Javé: Por três crimes de Moab e pelo quarto, Eu não vou perdoar: porque eles queimaram até os reduzir a cinzas os ossos do rei de Edom."
,"2":"Deitarei fogo a Moab e queimarei os palácios de Cariot; Moab vai morrer no meio do barulho, entre gritos de guerra e ao som da corneta;"
,"3":"eliminarei o seu juiz e trucidarei com ele as suas autoridades - diz Javé."
,"4":"Assim diz Javé: Por três crimes de Judá e pelo quarto, Eu não vou perdoar: porque desprezaram a lei de Javé e não guardaram os seus mandamentos, tomando o caminho dos falsos deuses que um dia seus pais já tinham seguido."
,"5":"Deitarei fogo a Judá e queimarei os palácios de Jerusalém."
,"6":"Assim diz Javé: Por três crimes de Israel e pelo quarto, Eu não vou perdoar: porque vendem o justo por dinheiro e o necessitado por um par de sandálias;"
,"7":"calcam aos pés os fracos e desviam os pobres do bom caminho! Pai e filho dormem com a mesma mulher, profanando assim o meu Nome santo."
,"8":"Diante de todos os altares eles deitam-se sobre roupas recebidas em penhor e no templo do seu deus bebem o vinho dos que foram multados."
,"9":"E no entanto, fui Eu que à frente deles derrotei os amorreus, altos como cedros do Líbano e fortes como carvalhos: cortei os seus frutos por cima, e as suas raízes por baixo."
,"10":"Fui Eu que vos tirei da terra do Egipto e, através do deserto, vos guiei durante quarenta anos, a fim de vos tornar proprietários da terra dos amorreus."
,"11":"Entre os vossos filhos escolhi profetas, e entre os vossos jovens escolhi homens consagrados. Não foi assim, ó filhos de Israel? - oráculo de Javé."
,"12":"No entanto, embriagastes os homens consagrados e tapastes a boca dos profetas."
,"13":"Pois Eu vou abrir o chão debaixo de vós, como abre o chão um carro carregado de feixes."
,"14":"O mais veloz não conseguirá fugir, a força do valente de nada lhe valerá; o forte não escapará da morte,"
,"15":"o arqueiro não ficará de pé, o homem de pés ligeiros não escapará, e nem sequer o cavaleiro salvará a própria vida;"
,"16":"o mais corajoso dos guerreiros fugirá nu nesse dia! - oráculo de Javé."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Escutai bem esta palavra que Javé diz a respeito de vós, filhos de Israel, e a respeito de todas as famílias que tirei da terra do Egipto:"
,"2":"De todas as famílias da terra, foste a única que Eu conheci; e é justamente por isso que te vou pedir contas de todos os teus pecados."
,"3":"Será que duas pessoas andam juntas, sem antes estarem de acordo?"
,"4":"Ruge o leão na floresta, sem que tenha uma presa? Solta o leãozinho o seu urro no esconderijo, sem que tenha a sua caça?"
,"5":"Cai o pássaro por terra, sem que haja armadilha? Levanta-se uma rede do chão, sem que tenha apanhado alguma coisa?"
,"6":"Soa a trombeta na cidade, sem que a população se alarme? Vem alguma desgraça sobre a cidade, sem que Deus a tenha mandado?"
,"7":"Do mesmo modo, o Senhor Javé não faz coisa alguma sem revelar os seus segredos aos profetas, seus servos."
,"8":"Ruge o leão: quem não temerá? Fala o Senhor Javé: quem não profetizará?"
,"9":"Proclamai nos palácios de Azoto e nos palácios da terra do Egipto. Dizei-lhes para se reunirem nas montanhas da Samaria, a fim de verem quantas desordens lá há e quantas violências se praticam dentro dela!"
,"10":"Não sabem viver com honestidade - orá-culo de Javé - aqueles que nos seus palácios acumulam violência e opres-são."
,"11":"Portanto, assim diz Javé: O ini-migo cercará o país, derrubará o seu poder e saqueará os seus palácios."
,"12":"Assim diz Javé: Como o pastor salva da boca do leão duas patas ou um pedaço de orelha, assim se salvarão os filhos de Israel, que moram em Samaria sobre uma tábua de cama ou sobre uma coberta de damasco."
,"13":"Escutai e testemunhai contra a casa de Jacob - oráculo do Senhor Javé, Deus dos exércitos."
,"14":"No dia em que Eu pedir contas dos seus crimes a Israel, pedirei contas pelo altar de Betel; as pontas do altar serão quebradas e cairão por terra."
,"15":"Vou derrubar a casa de Inverno e a casa de Verão. Serão destruídas as casas de marfim, desaparecerão os palácios de luxo - oráculo de Javé."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Escutai esta palavra, vacas de Basã, que morais no monte de Samaria: vós que oprimis os fracos, maltratais os necessitados, e dizeis aos vossos maridos: «Trazei alguma coisa para beber»."
,"2":"O Senhor Javé jurou pela sua santidade que para vós há-de chegar o dia em que sereis arrastadas com ganchos e os vossos filhos com arpões."
,"3":"Tereis que passar, uma atrás da outra, pela brecha da muralha, e sereis levadas para o Hermon - oráculo de Javé."
,"4":"Dirigi-vos a Betel, e pecai; ide a Guilgal, e pecai ainda mais! Oferecei de manhã os vossos sacrifícios e ao terceiro dia levai os vossos dízimos!"
,"5":"Oferecei pão fermentado como sacrifício de louvor e proclamai em alta voz as ofertas espontâneas! Pois é disso que gostais, filhos de Israel! - oráculo do Senhor Javé."
,"6":"Eu nada deixei ficar nos vossos dentes em todas as cidades, e de todos os lugares retirei o pão. Mas nem mesmo assim voltastes para Mim! - oráculo de Javé."
,"7":"Suspendi-vos a chuva, três meses antes da colheita; Eu mandava chover numa cidade e não fazia chover na outra; num campo Eu mandava chover, e outro, onde não chovia, secava."
,"8":"Duas ou três cidades iam cambaleando beber água a uma outra cidade, e não conseguiam matar a sede. Mas nem mesmo assim voltastes para Mim! - oráculo de Javé."
,"9":"Castiguei-vos com o carvão e a ferrugem do trigo; sequei as vossas hortas e vinhedos e os gafanhotos comeram as vossas figueiras e oliveiras. Mas nem mesmo assim voltastes para Mim! - oráculo de Javé."
,"10":"Mandei-vos uma peste igual às pragas do Egipto; matei os vossos guerreiros à espada, e os cavalos foram levados pelo inimigo. Fiz subir pelas vossas narinas o mau cheiro do acampamento. Mas nem mesmo assim voltastes para Mim! - oráculo de Javé."
,"11":"Revirei-vos de cabeça para baixo, como Deus fez a Sodoma e Gomorra, e ficastes como um tição tirado do fogo. Mas nem mesmo assim voltastes para Mim! - oráculo de Javé."
,"12":"Pois é assim que te tratarei, Israel. E porque vou tratar-te assim, prepara-te, Israel, para te encontrares com o teu Deus!"
,"13":"Eis que Ele forma os montes e cria os ventos; manifesta o seu pensamento ao homem; faz a aurora e o crepúsculo e caminha sobre as alturas da terra: o seu Nome é Javé, Deus dos exércitos."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Escutai esta palavra que vou pronunciar contra vós; é uma lamentação por ti, casa de Israel:"
,"2":"Caiu para nunca mais se levantar, a jovem Israel! Está prostrada por terra e não há quem a levante!"
,"3":"Pois assim diz o Senhor Javé à casa de Israel: A cidade que punha em campo mil guerreiros, ficará apenas com cem; aquela que saía com cem, ficará apenas com dez."
,"4":"Assim diz Javé à casa de Israel: Procurai-Me e vivereis."
,"5":"Não procureis Betel, não façais romarias a Guilgal, nem corrais para Bersabeia. Pois Guilgal irá toda para o exílio e Betel será reduzida a nada."
,"6":"Procurai Javé, e vivereis. Senão, Ele virá sobre a casa de José como um fogo que a queimará, e em Betel não haverá quem o apague."
,"7":"Ai dos que transformam o direi-to em veneno e atiram a justiça por terra."
,"8":"É Ele que faz as Plêiades e o Órion, é Ele que transforma as trevas em aurora, o dia em noite escura. Ele chama as águas do mar,para inundar a face da Terra. O seu nome é Javé."
,"9":"É Ele que determina a invasão da fortaleza,e comanda a destruição,da praça forte."
,"10":"Eles odeiam os que defendem o justo no tribunal e têm horror de quem diz a verdade."
,"11":"Porque esmagais o fraco, cobrando-lhe o imposto do trigo, podereis construir casas de pedras lavradas, mas nelas jamais ireis morar; podereis plantar vinhas de óptima qualidade, mas não bebereis do seu vinho."
,"12":"Pois Eu sei como são numerosos os vossos crimes e graves os vossos pecados: explorais o justo, aceitais subornos e enganais os necessitados no tribunal!"
,"13":"É por isso que neste tempo o prudente se cala, pois o tempo é de desgraça."
,"14":"Procurai o bem e não o mal; então vivereis. Talvez, assim - como vós dizeis - Javé, Deus dos exércitos, esteja convosco."
,"15":"Odiai o mal e amai o bem; restabelecei o direito no tribunal. Talvez, assim, Javé, Deus dos exércitos, tenha misericórdia do resto de José."
,"16":"Assim diz Javé, o Senhor Deus dos exércitos: Em todas as ruas haverá gemidos, em todas as vielas dirão: «Ai, ai!» Chamarão para o luto o lavrador, e para o choro aqueles que sabem lamentar."
,"17":"Em todas as vinhas haverá gemidos, porque Eu passarei no meio de ti - diz Javé."
,"18":"Ai dos que vivem suspirando pelo Dia de Javé! Como será para vós o Dia de Javé? Será trevas, e não luz."
,"19":"Será como o indivíduo que foge do leão e encontra um urso; ou como a pessoa que, entrando em casa, apoia a mão na parede e é mordido por uma serpente."
,"20":"Que será, pois, o Dia de Javé, senão trevas em vez de luz, escuridão sem claridade alguma?"
,"21":"Eu detesto e desprezo as vossas festas; não gosto das vossas reuniões."
,"22":"Ainda que Me ofereçais sacrifícios, as vossas ofertas não Me agradarão, nem olharei para as oferendas gordas."
,"23":"Longe de Mim o barulho dos vossos cânticos, nem quero ouvir a música das vossas liras."
,"24":"O que Eu quero é ver brotar o direito como a água e ver correr a justiça como riacho que não seca."
,"25":"Porventura fizestes-Me ofertas ou oferecestes-Me sacrifícios durante os quarenta anos de deserto, ó casa de Israel?"
,"26":"Tereis de levar o vosso rei Sacut, e o vosso ídolo Caivã, imagens de deuses que fabricastes."
,"27":"Porque Eu vou levar-vos para o exílio, para além de Damasco - diz Javé, que Se chama Deus dos exércitos."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Ai dos que vivem tranquilos em Sião e se sentem seguros no monte de Samaria! Ai dos nobres da primeira das nações, aos quais recorre a casa de Israel!"
,"2":"Ide a Calane para ver; daí, passai à grande cidade de Emat; depois descei a Gat dos filisteus. Porventura sois melhores que esses reinos? E o vosso território, será maior que o deles?"
,"3":"Julgais afastar o dia da desgraça mas aproximais o poder da violência."
,"4":"Deitam-se em camas de marfim; estendem-se em sofás, comendo cordeiros do rebanho e novilhos cevados em estábulos;"
,"5":"cantarolam ao som da lira, inventando, como David, instrumentos musicais;"
,"6":"bebem canecas de vinho, usam os mais caros perfumes, sem se importarem com a ruína de José!"
,"7":"Por isso irão acorrentados à frente dos exilados. Acabou-se a festa dos ociosos."
,"8":"Oráculo de Javé, Deus dos exércitos: Jura o Senhor Javé pela sua vida: Eu detesto o orgulho de Jacob, e odeio os seus palácios. Vou entregar a cidade inteira e tudo o que nela existe."
,"9":"Se numa casa ficarem dez homens, todos morrerão."
,"10":"Pouca gente ficará para tirar da casa os cadáveres. Alguém perguntará ao outro que está no fundo da casa: «Há aí mais alguém?» E o outro responderá: «Não!» E dirá: «Silêncio!» Porque não se deve mencionar o Nome de Javé."
,"11":"Aqui está o que Javé ordena: fará a casa grande em pedaços e a casa pequena em frangalhos."
,"12":"No meio de pedras, podem os cavalos correr? No meio do mar, os bois podem arar? No entanto, vós fizestes do direito um veneno, e do fruto da justiça um amargor!"
,"13":"Vós alegrais-vos por causa de Lo-Dabar, e dizeis: «Não foi com a nossa força que conquistámos Carnaim?»"
,"14":"Pois bem, ó casa de Israel: Eu vou levantar contra vós uma nação que vos esmagará desde a entrada de Emat até ao riacho da Arabá - oráculo de Javé, Deus dos exércitos."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Isto me mostrou o Senhor Javé: Apareceu uma nuvem de gafanhotos pouco antes da colheita do feno, depois de cortado o feno do rei."
,"2":"Quando iam acabar com todo o verde da terra, eu disse: «Por favor, Javé, perdoa! Jacob é tão pequeno! Como poderá resistir?»"
,"3":"Então Javé compadeceu-Se, e disse: «Isto não vai acontecer» - diz Javé."
,"4":"Isto me mostrou o Senhor Javé: O Senhor Javé chamava o fogo para fazer o julgamento. O fogo consumia o grande oceano e devorava os campos."
,"5":"E eu disse: «Por favor, pára, Senhor Javé! Jacob é tão pequeno! Como poderá resistir?»"
,"6":"Javé compadeceu-Se, e disse: «Nem isto acontecerá» - diz Javé."
,"7":"Isto me mostrou o Senhor Javé: Javé estava sobre um muro e, na mão, tinha um fio de prumo."
,"8":"E Javé disse-me: «O que vês tu, Amós?» Eu respondi: «Um fio de prumo». E ele disse-me: «Eis que vou pôr um fio de prumo entre o meu povo, Israel. Não lhe perdoarei mais."
,"9":"Serão arrasados os lugares altos de Isaac, os santuários de Israel serão destruídos, e Eu empunharei a espada contra a dinastia de Jeroboão»."
,"10":"Amasias, sacerdote de Betel, mandou dizer a Jeroboão, rei de Israel: «Amós conspira contra Vossa Majestade, dentro do reino de Israel. O país não pode tolerar mais as suas palavras,"
,"11":"pois Amós anda a dizer que Jeroboão deverá ser morto pela espada e que Israel deverá ir para o exílio, para longe do seu país»."
,"12":"Então Amasias disse a Amós: «Vidente, vai-te embora daqui. Retira-te para a terra de Judá. Vai ganhar lá a tua vida fazendo profecias."
,"13":"Não continues a fazer profecias em Betel, porque aqui é o santuário do rei, e templo do reino»."
,"14":"Amós respondeu a Amasias: «Eu não sou profeta, nem discípulo de profeta. Eu sou criador de gado e cultivador de sicômoros."
,"15":"Javé é que pegou em mim quando eu andava atrás do rebanho, e me ordenou: 'Vai profetizar ao meu povo Israel'."
,"16":"Pois bem, escuta agora a palavra de Javé! Tu dizes: 'Não profetizes contra Israel, não despejes as tuas palavras contra a casa de Isaac'."
,"17":"Pois bem, assim diz Javé: 'A tua mulher vai tornar-se a prostituta da cidade; os teus filhos e as tuas filhas vão morrer a golpes de espada; a tua terra será repartida a cordel, e tu mesmo irás morrer em terra estrangeira. E Israel será levado para o exílio, para longe da sua terra'»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Eis o que me mostrou o Senhor Javé: Vi uma cesta de frutos maduros."
,"2":"E Javé perguntou-me: «O que vês tu, Amós?» Eu respondi: «Uma cesta de frutos maduros». Ele disse-me: «Está maduro o fim para o meu povo Israel; não voltarei a perdoar-lhe."
,"3":"Nesse dia, as cantoras do palácio gemerão - oráculo do Senhor Javé. Haverá cadáveres atirados por toda a parte. Silêncio!»"
,"4":"Ouvi isto, exploradores do necessitado, opressores dos pobres do país!"
,"5":"Vós dizeis: «Quando vai passar a festa da lua nova, para podermos pôr à venda o nosso trigo? Quando vai passar o sábado, para abrirmos os armazéns, para diminuir as medidas, aumentar os pesos e viciar as balanças,"
,"6":"para comprar os fracos por dinheiro, os necessitados por um par de sandálias, e vender o refugo do trigo?»"
,"7":"Javé jura pelo orgulho de Jacob: Não Me esquecerei jamais de tudo o que esta gente faz."
,"8":"Não é por isso que a terra treme e todos os seus moradores se apavoram? Não é por isso que toda ela sobe como o rio Nilo e, como o rio do Egipto, baixa novamente?"
,"9":"Naquele dia - oráculo do Senhor Javé - farei com que o Sol se esconda ao meio-dia, e em pleno dia escurecerei a terra;"
,"10":"mudarei as vossas festas em funeral e os vossos cânticos em gemidos. A todos vestirei com roupas de luto e farei rapar a cabeça. Farei disso como o luto por um filho único, e o seu fim será como um dia de amargura."
,"11":"Dias virão - oráculo do Senhor Javé - em que vou mandar a fome sobre o país: não será fome de pão, nem sede de água, mas fome de ouvir a Palavra de Javé."
,"12":"Irão cambaleando de um mar a outro mar, irão sem rumo do Norte até ao Oriente, à procura da palavra de Javé, e não a encontrarão."
,"13":"Nesse dia, vão desmaiar de sede as jovens mais belas, e também os rapazes"
,"14":"que juram por Asima, deusa da Samaria, e que costumam dizer: «Viva o teu ídolo, Dã!» Ou: «Viva o teu Bem-Amado, Bersabeia!» E cairão para nunca mais se levantarem!"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Eu vi Javé perto do altar. Ele disse-me: «Bate no alto das colunas para fazer tremer os umbrais. Quebra a cabeça de todos, que o resto matá-los-ei pela espada. Ninguém conseguirá fugir, ninguém conseguirá escapar."
,"2":"Se eles se esconderem na mansão dos mortos, daí a minha mão os arrancará; se subirem ao mais alto do céu, de lá os farei descer;"
,"3":"se conseguirem esconder-se no cume do Carmelo, aí vou procurá-los e apanhá-los; se mergulharem até ao fundo do mar, lá mandarei o dragão para que os morda;"
,"4":"e se fugirem à frente do inimigo, darei ordem à espada para que os mate. Porei neles os meus olhos para o mal e não para o bem."
,"5":"Javé, Deus dos exércitos, fere a Terra, ela desmancha-se,e todos os seus habitantes,ficam de luto. Ela sobe como o rio Nilo, de novo baixa como o rio do Egipto."
,"6":"No Céu, Deus fez a sua alta morada,e, por cima da Terra, firmou a sua abóbada. Ele é que chama as águas do mar,para inundar a face da Terra. Javé é o seu Nome!"
,"7":"Acaso, israelitas, para Mim sois diferentes dos cuchitas? Não tirei Eu Israel da terra do Egipto? Não tirei também os filisteus de Cáftor? E não fiz sair de Quir os arameus?"
,"8":"Os olhos do Senhor Javé voltam-se para a nação pecadora; Eu vou eliminá-la da face da terra. Mas não vou arrasar completamente a casa de Jacob - oráculo de Javé."
,"9":"Pois darei ordens e sacudirei no meio de todos os povos a casa de Israel, como se abana o trigo na joeira, sem deixar que caia no chão um grãozinho sequer."
,"10":"Morrerão pela espada todos os pecadores do meu povo, aqueles que dizem: «A desgraça não se aproximará, nunca chegará até nós»."
,"11":"Nesse dia, vou armar de novo a tenda de David que caiu. Vou tapar os seus buracos, levantar as suas ruínas, até a reconstruir como era antes,"
,"12":"a fim de que possam conquistar o que ficar de Edom e de todas as nações, sobre as quais o meu Nome é invocado - oráculo de Javé, que realiza tudo isto."
,"13":"Dias virão - oráculo de Javé - nos quais aquele que estiver a lavrar vai encontrar-se com quem estiver a colher, e quem estiver a pisar as uvas com quem estiver a semear. As montanhas vão destilar vinho novo, que escorrerá pelas colinas."
,"14":"Farei voltar os exilados do meu povo Israel. Eles voltarão a construir as cidades que foram destruídas, e nelas vão morar. Plantarão vinhas e beberão o seu vinho; plantarão pomares e comerão a sua fruta."
,"15":"Eu vou plantá-los na sua Terra e jamais serão arrancados dessa Terra, que Eu mesmo lhes dei - diz Javé, vosso Deus."
}`)

}
func PT_BS_LoadVNHAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oráculo que o profeta Habacuc recebeu em visão."
,"2":"Até quando, Javé, vou pedir socorro, sem que me escutes? Até quando clamarei a Ti: «Violência!», sem que me tragas a salvação?"
,"3":"Porque me fazes ver o crime e contemplar a injustiça? Opressão e violência estão à minha frente; surgem processos e levantam-se contendas."
,"4":"Por isso, a lei perde a força e o direito nunca aparece. O ímpio cerca o justo e o direito aparece distorcido."
,"5":"Olhai as nações, observai bem! Vós ficareis admirados e espantados, pois ainda nestes dias vou fazer uma coisa que, se alguém vo-la contasse, não acreditaríeis."
,"6":"Farei com que se levantem os Caldeus, povo cruel e impetuoso que percorre a terra inteira, tomando posse de casas que não lhes pertencem."
,"7":"Ele é terrível e temível; com a sua sentença, impõe o seu direito e vontade."
,"8":"Os seus cavalos são mais velozes que panteras, mais ferozes que os lobos do deserto. Os seus cavalos galopam, os cavaleiros vêm de longe e voam como águia que mergulha sobre a presa."
,"9":"Eles avançam todos para fazer violência, rosto em frente, amontoam prisioneiros como areia."
,"10":"Ele faz troça dos reis, zomba dos chefes, ri das fortalezas, porque faz um aterro e toma-as de assalto."
,"11":"Depois, respira e continua; a força é o seu deus."
,"12":"Não és Tu, Javé, desde o princípio, o meu Deus, o meu Santo, Aquele que não morre? Javé, Tu o escolheste para exer-cer o direito; ó Rocha, Tu o constituíste para castigar."
,"13":"Os teus olhos são demasiado puros para ver o mal; Tu não podes contemplar a injustiça. Então, porque olhas para os traidores e Te calas quando um ímpio devora alguém mais justo do que ele?"
,"14":"Tratas os homens como peixes do mar ou como répteis que não têm chefe?"
,"15":"Ele pesca a todos com anzol, apanha-os na sua rede, recolhe-os na tarrafa, e ri satisfeito."
,"16":"Por isso, oferece um sacrifício à sua rede, incensa a tarrafa, pois fez com elas uma grande pescaria e o alimento veio com fartura."
,"17":"Continuará a esvaziar a sua rede sem parar, massacrando as nações sem dó nem piedade?"
}`)
	CurrentBook.AddChapter(2, `{
"1":"Vou ficarde guarda, de pé sobre a muralha; vou ficar atento para ouvir o que Javé me vai dizer, para ver como vai responder à queixa que Lhe fiz."
,"2":"Então Javé respondeu-me: «Escreve esta visão, grava-a com clareza em tabuinhas, para que se possa ler facilmente."
,"3":"É uma visão sobre um tempo determinado, fala de um prazo e não vai decepcionar. Se demorar, espera-a, pois certamente ela virá e não tardará."
,"4":"Quem não é recto vai morrer, enquanto o justo viverá pela sua fidelidade»."
,"5":"Na verdade, o vinho é falso: o homem arrogante não permanecerá, ele que escancara as suas fauces como o túmulo, que é insaciável como a morte. Junta para si todas as nações e apodera-se de todos os povos."
,"6":"Porventura não escarnecerão todos dele dirigindo-lhe piadas?,Dirão: Ai daquele que acumula o que não é seu e se carrega de penhores. "
,"7":"Não se levantarão, de repente, os teus credores e os teus cobradores não acordarão, para fazerem de ti a sua presa?"
,"8":"Já que saqueaste numerosas nações, o que resta dos povos irá saquear-te, por causa do sangue humano derramado, da violência feita ao país, à cidade e aos seus moradores."
,"9":"Ai de quem junta dinheiro injusto em sua casa, para colocar bem alto o seu ninho, tentando fugir às garras da desgraça!"
,"10":"Tu decretaste a vergonha para a tua casa; destruindo muitas nações, fizeste o mal contra ti mesmo."
,"11":"Pois agora as pedras das paredes gritarão vingança e as vigas do telhado te reprovarão."
,"12":"Ai de quem constrói com sangue uma cidade, e com o crime funda uma capital!"
,"13":"Não é, porventura, vontade de Javé dos exércitos que os povos trabalhem para o fogo e que as nações se afadiguem inutilmente?"
,"14":"Pois a Terra inteira estará repleta do conhecimento da glória de Javé, tal como as águas enchem o mar."
,"15":"Ai daquele que embriaga o seu próximo, misturando drogas no copo, para lhe contemplar a nudez!"
,"16":"Sacias-te de vergonha, e não de glória. Bebe também tu e mostra a tua incircuncisão. A taça que está na mão direita de Javé será derramada sobre ti, e em ti a vergonha há-de superar a glória."
,"17":"A matança que realizaste no Líbano vai cair sobre ti, a mortandade dos animais encher-te-á de pavor. Tudo por causa do sangue humano derramado, da violência feita ao país, à cidade e aos seus moradores."
,"19":"Ai de quem diz a um pedaço de madeira: 'Acorda!' E à pedra muda: 'Desperta!' Pode o ídolo ensinar? Eis que está coberto de ouro e prata, mas dentro dele não há nenhum sopro de vida."
,"18":"De que serve um ídolo, para que um artista se dê ao trabalho de o esculpir? De que serve uma imagem de metal, um mestre de mentiras, para que o artista nela confie e continue a fabricar ídolos mudos?"
,"20":"Javé, porém, mora no seu santo Templo: que a terra inteira fique em silêncio diante d'Ele!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Oração do profeta Habacuc, em tom de lamentação."
,"2":"Javé, ouvi falar de Ti; aprendi a respeitar a tua obra, Javé. No nosso tempo renova-a; manifesta-a no curso dos anos. Na ira, lembra-Te de ter compaixão."
,"3":"Deus vem de Temã, o Santo vem do monte Farã. A sua majestade cobre o Céu, e a terra enche-se com o seu louvor."
,"4":"O seu brilho é como o Sol, e a sua mão cintila, escondendo o seu poder."
,"5":"À frente d'Ele vai a peste, e a epidemia segue o seu rasto."
,"6":"Ele pára, e a terra treme; ele olha, e as nações estremecem. As montanhas eternas desmoronam-se,e as colinas antigas prostram-se: sempre foi assim o seu caminho."
,"7":"Vejo as tendas de Cusã apavoradas, e agitadas as tendas de Madiã. Javé, liberta o teu povo!"
,"8":"É contra os rios, Javé, é contra os rios,que a tua ira se inflama?,É contra o mar que arde o teu furor, quando montas nos teus cavalos,e sobes para os teus carros vitoriosos?"
,"9":"Levantas o teu arco,e alimentas de flechas a sua corda; rasgas a terra com torrentes."
,"10":"Ao ver-Te, as montanhas estremecem; uma tromba de água passa. O mar faz ouvir a sua voz, levantando os seus braços para o alto."
,"11":"O Sol e a Lua ficam em casa, diante da luz das tuas flechas que partem, diante do clarão dos raios da tua lança."
,"12":"Caminhas furioso pela Terra, com ira esmagas as nações."
,"13":"Tu sais para salvar o teu povo, para libertar o teu ungido,Destróis desde o telhado a casa do ímpio, descobres os seus alicerces até à rocha."
,"14":"Com os teus dardos trespassaste o chefe, enquanto as suas tropas se arremessavam,para nos dispersar com ferocidade, como se fossem devorar,uma vítima às escondidas."
,"15":"Atravessaste o mar com os teus cavalos, fazendo ferver as águas imensas. Nós confiamos em Ti!"
,"16":"Eu ouvi. As minhas entranhas tremeram; a esse ruído, os meus lábios estremeceram, um calafrio entrou-me pelos ossos,e as minhas pernas vacilaram. Espero tranquilo o dia de angústia,que virá contra este povo,que nos oprime."
,"17":"Ainda que a figueira não brote,e não haja fruto na parreira; ainda que a oliveira negue o seu fruto,e o campo não produza colheita; ainda que as ovelhas,desapareçam do redil,e não haja gado nos estábulos"
,"18":"eu alegrar-me-ei em Javé,e exultarei em Deus, meu salvador."
,"19":"O Senhor Javé é a minha força, Ele dá-me pés de gazela,e faz-me caminhar pelas alturas. Ao mestre de canto.Para instrumentos de corda."
}`)

}
func PT_BS_LoadVNILChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palavra de Javé dirigida a Joel, filho de Fatuel."
,"2":"Ouvi isto, chefes; prestai atenção, moradores do país! Já terá acontecido coisa igual no vosso tempo ou no tempo dos vossos antepassados?"
,"3":"Contai tudo isto aos vossos filhos; depois eles contarão aos filhos deles, que, por sua vez, irão contar à geração seguinte."
,"4":"Aquilo que o gafanhoto cortador deixou, foi comido pelo gafanhoto destruidor; aquilo que o destruidor deixou, foi devorado pelo gafanhoto saltador; aquilo que o saltador deixou, foi comido pelo gafanhoto descascador."
,"5":"Acordai, bêbedos, e chorai! Gemei, beberrões, porque vos tiraram o vinho da boca."
,"6":"Pois uma nação poderosa e inumerável invadiu o meu país; os seus dentes são como os do leão e as suas mandíbulas como as da leoa."
,"7":"Deixou a minha vinha arrasada e as figueiras reduzidas a ramos secos; até lhes comeu a casca e os ramos ficaram brancos."
,"8":"Suspira como jovem vestida de luto pelo noivo da sua juventude!"
,"9":"No Templo de Javé, deixou de haver ofertas e libações de vinho; os sacerdotes, ministros de Javé, estão todos de luto."
,"10":"Os campos foram devastados, a terra está de luto, o trigo foi destruído, o vinho perdeu-se, o azeite desapareceu."
,"11":"Ficai tristes, lavradores; gemei viticultores, por causa do trigo e da cevada, pois está perdida a colheita dos campos."
,"12":"A parreira secou, a figueira murchou. Romãzeira, tamareira, macieira, todas as árvores frutíferas secaram. E até a alegria dos homens desapareceu!"
,"13":"Vesti-vos de luto e chorai, sacerdotes! Gemei, ministros do altar! Vinde dormir em panos de saco, ministros de Deus! Pois do Templo de Deus desapareceram as ofertas e libações de vinho."
,"14":"Proclamai um jejum, convocai uma assembleia, reuni na casa de Javé, vosso Deus, os chefes com todos os moradores da região. E gritai a Javé."
,"15":"Ah! Que dia! De facto, o Dia de Javé está próximo e vem como devastação do Todo-poderoso."
,"16":"Porventura, o alimento não desapareceu da nossa vista, e a alegria e o contentamento da casa do nosso Deus?"
,"17":"A semente secou debaixo da terra, os silos estão vazios, as tulhas estão limpas, pois a colheita perdeu-se."
,"18":"O rebanho muge e as manadas de bois andam errantes, pois não há pastos, e as ovelhas morrem de fome."
,"19":"A ti, Javé, Eu invoco, pois o fogo devorou a verdura do deserto e a chama consumiu todas as árvores do campo."
,"20":"Até as feras suspiram por Ti, pois secou a água dos rios e o fogo devorou toda a verdura do deserto."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Tocai a trombeta em Sião; dai alarme no meu santo monte. Tremam todos os moradores do país, pois o Dia de Javé está a chegar e já está perto."
,"2":"Será dia de trevas e escuridão, dia de nuvens e de sombras. Como a luz da aurora, estende-se sobre os montes um povo numeroso e forte; nunca houve povo igual a este e nunca mais haverá durante muitas gerações."
,"3":"Diante dele vai um fogo que devora; atrás dele uma chama que incendeia. Diante dele a terra é um jardim do paraíso; atrás dele é um deserto arrasado. Nada se salva!"
,"4":"O seu aspecto é como de cavalos e como cavaleiros que correm."
,"5":"O seu ruído é como de carros que vêm saltando pelos cumes dos montes, estalando como chama que devora a palha, como poderoso exército em ordem de batalha."
,"6":"Os povos assustam-se na sua presença, ficam todos pálidos de medo."
,"7":"Avançam como soldados valentes, como guerreiros escalam a muralha; cada um segue o seu caminho, sem se desviar da rota."
,"8":"Uns não estorvam os outros: cada um segue o seu rumo; mesmo que as lanças caiam ao seu lado, eles não se detêm no caminho."
,"9":"Invadem a cidade, escalam a muralha, sobem às casas, entram pelas janelas como ladrões."
,"10":"Diante deles, a terra treme e o céu abala-se; o sol e a lua escurecem-se, e as estrelas perdem o brilho."
,"11":"Javé faz ouvir a sua voz à frente do seu exército. Os seus batalhões são os mais numerosos, são valentes os encarregados de executar a ordem de Deus. Grandioso e terrível é o Dia de Javé! Quem poderá suportá-lo?"
,"12":"Pois agora - oráculo de Javé - voltai para Mim de todo o coração, com jejuns, lágrimas e lamentações."
,"13":"Rasgai o coração, e não as vestes! Voltai para Javé, vosso Deus, pois Ele é piedade e compaixão, lento para a cólera, cheio de amor, e arrepende-Se das ameaças."
,"14":"Talvez Ele volte atrás e Se arrependa, e vos deixe alguma bênção, oferta e libação de vinho para Javé, vosso Deus."
,"15":"Tocai a trombeta em Sião, proclamai um jejum, convocai uma assembleia."
,"16":"Reuni o povo, organizai a comunidade, chamai os velhos, reuni os jovens e crianças de peito. O jovem esposo saia do quarto, a jovem esposa deixe o seu leito."
,"17":"Os sacerdotes, ministros de Javé, venham chorar entre o pórtico e o altar, e digam: «Javé, tem piedade do teu povo! Não entregues a tua herança à vergonha, à zombaria das nações». Porque diriam entre os povos: «Onde está o seu Deus?»"
,"18":"Javé teve ciúmes da sua terra e compadeceu-Se do seu povo."
,"19":"Javé respondeu ao seu povo: Eu mandar-vos-ei trigo, vinho e azeite em abundância, e nunca mais farei de vós a vergonha das nações."
,"20":"Mandarei para longe o invasor do Norte, para um lugar seco e deserto: a vanguarda para o mar do Oriente e a retaguarda para o mar do Ocidente. Aí, ele vai cheirar mal e feder, porque foi longe de mais."
,"21":"Terra, não temas; alegra-te e exulta, pois Javé fez coisas grandiosas."
,"22":"Não temais, feras, pois o verde voltou às pastagens dos campos. As árvores já estão carregadas de frutos, a figueira e a parreira produzirão abundantemente."
,"23":"Alegrai-vos, filhos de Sião, e rejubilai em Javé, vosso Deus. Pois Ele mandou no devido tempo as chuvas do Outono e fez cair chuvas abundantes: as chuvas do Outono e da Primavera, como antigamente."
,"24":"As eiras estão cheias de trigo, os tanques estão a transbordar de vinho e azeite novo."
,"25":"Estou a compensar os anos que foram devorados pelos gafanhotos, pelo saltador, pelo descascador, pelo cortador, o meu poderoso exército que mandei contra vós."
,"26":"Agora podereis comer com fartura e louvar o nome de Javé, vosso Deus, que fez maravilhas em vosso favor. O meu povo nunca mais passará vergonha."
,"27":"Ficareis a saber, então, que estou no meio de Israel, que sou Javé, vosso Deus, e não há outro. O meu povo nunca mais passará vergonha."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Depois disso, derramarei o meu espírito sobre todos os viventes, e os vossos filhos e filhas tornar-se-ão profetas; entre vós, os velhos terão sonhos e os jovens terão visões!"
,"2":"Nesses dias, até sobre os escravos e escravas derramarei o meu espírito!"
,"3":"Farei prodígios no Céu e na Terra: sangue, fogo e colunas de fumo."
,"4":"O Sol vai mudar-se em trevas, e a Lua em sangue; diante da chegada do Dia de Javé, grandioso e terrível!"
,"5":"Então, todo aquele que invocar o Nome de Javé será salvo, pois a salvação estará no monte Sião e em Jerusalém - como disse Javé - e entre os sobreviventes estarão aqueles que Javé tiver chamado."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Nesses dias, nesse tempo, vou mudar a sorte de Judá e Jerusalém;"
,"2":"vou reunir todas as nações do mundo e fazê-las descer ao vale de Josafá. Aí abrirei um processo contra elas, por causa de Israel, que é meu povo e minha propriedade. Pois elas espalharam Israel entre as nações e repartiram entre si a minha Terra."
,"3":"Lançaram sortes sobre o meu povo; trocaram meninos por prostitutas, e meninas a troco de vinho para se embriagarem."
,"4":"E vós, o que quereis de Mim, Tiro, Sidónia e distritos da Filisteia? Acaso quereis vingar-vos de Mim? Se pensardes nisso, faço recair essa vingança sobre as vossas cabeças."
,"5":"De facto, roubastes a minha prata e o meu ouro, levastes para os vossos templos os meus tesouros."
,"6":"Vendestes aos gregos os filhos de Judá e de Jerusalém, só para os afastardes da vossa terra."
,"7":"Pois agora Eu vou tirá-los do lugar para onde foram vendidos. Faço cair sobre vós aquilo que praticastes:"
,"8":"pela mão dos filhos de Judá, venderei os vossos filhos e filhas, e estes vendê-los-ão à distante nação dos sabeus. Assim disse Javé."
,"9":"Proclamai isto entre as nações: Preparai uma guerra santa, alistai soldados; venham, avancem todos os guerreiros!"
,"10":"Transformai os vossos arados em espadas, e as foices em lanças! Que o covarde diga: «Eu sou um soldado!»"
,"11":"Correi, vinde, todas as nações vizinhas e reuni-vos de toda a parte. Javé, faz descer os teus soldados lá do alto."
,"12":"Vinde, nações, e subi ao vale de Josafá, porque Eu Me sentarei ali para julgar todas as nações vizinhas."
,"13":"Lançai a foice, porque a seara está madura. Vinde pisar, pois o tanque está cheio e os barris a transbordar, porque é grande a maldade das nações."
,"14":"Multidões e multidões no Vale da Decisão, porque o Dia de Javé está próximo, no Vale da Decisão."
,"15":"O Sol e a Lua obscurecem-se, e as estrelas perdem o seu brilho."
,"16":"Javé ruge de Sião, de Jerusalém faz ouvir o seu grito: os céus e a terra começam a tremer! Javé, porém, é um esconderijo para o seu povo, é um abrigo para os filhos de Israel."
,"17":"Ficareis sabendo que Eu sou Javé, vosso Deus, que moro em Sião, meu santo monte. E Jerusalém será santa; os estrangeiros nunca mais passarão por ela."
,"18":"Nesse dia, as montanhas gotejarão vinho novo, das colinas escorrerá leite, e a água correrá em todos os riachos de Judá. Do templo de Javé brotará uma fonte que irrigará o Vale das Acácias."
,"19":"O Egipto será uma desolação e Edom será um deserto desolado, por causa da violência contra os filhos de Judá, por terem derramado sangue inocente na sua terra."
,"20":"Judá será habitado para sempre, e Jerusalém por todas as gerações."
,"21":"Vingarei o seu sangue, não o deixarei sem castigo. E Javé habitará em Sião."
}`)

}
func PT_BS_LoadVNINChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"A palavra de Javé foi dirigida a Jonas, filho de Amati, ordenando:"
,"2":"«Levanta-te e vai a Nínive, a grande cidade, e anuncia que a sua maldade chegou até junto de Mim»."
,"3":"Jonas partiu, então, com intenção de escapar da presença de Javé, fugindo para Társis. Desceu até Jope e aí encontrou um navio que saía para Társis. Pagou a passagem e embarcou, a fim de ir com eles até Társis, para fugir da presença de Javé."
,"4":"Javé, porém, mandou sobre o mar um vento forte, que provocou uma grande tempestade e ondas violentas. E o navio estava a ponto de naufragar."
,"5":"Os marinheiros começaram a ficar com medo e a rezar cada um ao seu deus. Deitaram ao mar a carga que estava no navio, a fim de lhe diminuir o peso. Jonas, porém, tinha descido ao porão do navio e, deitado, dormia a sono solto."
,"6":"O capitão, ao chegar onde ele estava, disse-lhe: «Que fazes aí a dormir? Levanta-te e invoca o teu Deus. Talvez Ele Se lembre de nós e não nos deixe morrer»."
,"7":"Depois disseram uns aos outros: «Vamos deitar as sortes para ver quem é o culpado desta desgraça que nos está a acontecer». Tiraram a sorte, e ela caiu em Jonas."
,"8":"Então perguntaram-lhe: «Conta-nos porque é que nos está a acontecer esta desgraça. Qual é a tua profissão? De onde vens? Qual é a tua terra? De que povo és tu?»"
,"9":"Jonas respondeu: «Eu sou hebreu. Adoro a Javé, Deus do céu, que fez o mar e a Terra»."
,"10":"Os marinheiros ficaram com medo, e perguntaram-lhe: «Que foi que fizeste?» Eles tinham compreendido que Jonas estava a fugir da presença de Javé, pois ele próprio lhes tinha contado tudo."
,"11":"E perguntaram: «Que te devemos fazer, para que o mar se acalme?» Pois o mar embravecia cada vez mais."
,"12":"Jonas respondeu: «É só pegardes em mim e atirardes-me ao mar, que ele se acalmará; eu sei que foi por minha causa que surgiu esta tempestade tão violenta»."
,"13":"Os homens tentavam remar, a fim de chegar mais perto da terra firme, mas não conseguiam, pois o mar ia ficando cada vez mais agitado, soprando contra eles."
,"14":"Então invocaram a Javé, dizendo: «Ah! Javé! Não queremos morrer por causa deste homem. Não lances contra nós a culpa de um sangue inocente. Tu és Javé e fazes tudo o que desejas»."
,"15":"Pegaram em Jonas e lançaram-no ao mar. Imediatamente o mar acalmou a sua fúria."
,"16":"Daí em diante aqueles homens começaram a temer muito a Javé, oferecendo-Lhe sacrifícios e fazendo-Lhe votos."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Javé enviou um peixe muito grande para que engolisse Jonas. E Jonas ficou no ventre do peixe três dias e três noites."
,"2":"E, do ventre do peixe, Jonas dirigiu a Javé, seu Deus, a seguinte oração:"
,"3":"«Na minha angústia invoquei a Javé, e Ele atendeu-me. Do fundo do abismo pedi a tua ajuda, e ouviste a minha voz."
,"4":"Lançaste-me nas profundezas, no coração do mar, e a torrente envolveu-me. Passaram sobre mim,as tuas ondas e vagas."
,"5":"Então pensei: 'Eu fui expulso,para longe dos teus olhos; nunca mais poderei admirar,a beleza do teu santo Templo?'"
,"6":"Eu estava cercado de água,até ao pescoço, o abismo rodeava-me, o lodo agarrava-se à minha cabeça."
,"7":"Desci até às raízes das montanhas, a terra fechava-se sobre mim para sempre. Mas Tu retiraste do sepulcro a minha vida, Javé, meu Deus!"
,"8":"Quando as minhas forças se acabavam, lembrei-me de Javé. E minha oração pôde chegar a Ti, ao teu santo Templo."
,"9":"Quem segue os ídolos, abandona o amor de Javé."
,"10":"Mas eu, entre cânticos de louvor, é a Ti que presto o meu culto,e com acção de graças cumpro,os meus votos. A salvação vem de Javé»."
,"11":"Então Javé ordenou ao peixe que vomitasse Jonas em terra firme."
}`)
	CurrentBook.AddChapter(3, `{
"1":"A Palavra de Javé foi dirigida a Jonas pela segunda vez, ordenando:"
,"2":"«Levanta-te e vai a Nínive, a grande cidade, e anuncia-lhe o que te vou dizer»."
,"3":"Jonas levantou-se e foi a Nínive, conforme Javé lhe tinha ordenado. Nínive era uma cidade fabulosamente grande: tinha o comprimento de uma caminhada de três dias."
,"4":"Jonas entrou na cidade e começou a percorrê-la, caminhando um dia inteiro. Ele dizia: «Dentro de quarenta dias, Nínive será destruída!»"
,"5":"Os moradores de Nínive começaram a acreditar em Deus, e marcaram um dia de penitência, vestindo-se todos de pano de saco, desde os maiores até aos menores."
,"6":"O facto chegou também ao conhecimento do rei de Nínive. Ele levantou-se do trono, tirou o manto, vestiu um pano de saco e sentou-se sobre a cinza."
,"7":"Mandou também publicar e anunciar aos ninivitas um decreto do rei e dos seus ministros, nestes termos: «Homens, animais, gado e ovelhas não poderão comer nada, nem pastar, nem beber água."
,"8":"Deverão vestir pano de saco, tanto homens como animais; e todos clamarão a Deus com toda a força. Cada um deverá converter-se da sua má conduta e deixar de lado toda a espécie de acções violentas."
,"9":"Talvez, assim, Deus volte atrás, Se compadeça de nós, apague o ardor da sua ira, e consigamos escapar»."
,"10":"Deus viu o que eles fizeram e como se converteram da sua má conduta; então, desistiu do mal com que os tinha ameaçado, e não o executou."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Jonas ficou muito desgostoso e despeitado."
,"2":"E rezou a Javé: «Ah! Javé! Não era precisamente isso que eu dizia quando estava na minha terra? Foi por isso que eu corri, tentando fugir para Társis, pois eu sabia que Tu és um Deus compassivo e clemente, lento para a ira e cheio de amor, e que voltas atrás nas ameaças feitas."
,"3":"Se é assim, Javé, tira-me a vida, pois eu acho melhor morrer do que ficar vivo»."
,"4":"Javé respondeu-lhe: «Achas que tens razão para te irritares assim?»"
,"5":"Jonas saiu da cidade e instalou-se no lado do nascer do sol. Ali fez uma cabana e sentou-se à sombra, para ver o que aconteceria à cidade."
,"6":"O Senhor Javé fez nascer um rícino, que cresceu de modo a fazer sombra sobre a cabeça de Jonas e livrá-lo de uma insolação. E Jonas ficou muito contente com aquele rícino."
,"7":"Então, na madrugada seguinte, Deus enviou um verme que roeu as raízes do rícino, e este secou."
,"8":"Quando o Sol nasceu, Javé mandou um vento quente e sufocante; e o Sol abrasava a cabeça de Jonas, a ponto de fazê-lo desmaiar. E Jonas tornou a pedir a morte, dizendo: «Prefiro morrer do que ficar vivo!»"
,"9":"Deus perguntou a Jonas: «Julgas ter razão para te irritares por causa do rícino?» Ele respondeu: «Sim, tenho razão para me irritar a ponto de pedir a morte»."
,"10":"Javé disse-lhe: «Sentes pena de um rícino, que não te deu trabalho, que não fizeste crescer, que brotou numa noite e na outra morreu?"
,"11":"E será que Eu não devo ter pena de Nínive, esta cidade enorme, onde moram mais de cento e vinte mil pessoas, que não sabem distinguir a mão direita da mão esquerda, além de tantos animais?»"
}`)

}
func PT_BS_LoadVNMIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palavra de Javé dirigidaa Miqueias de Morasti, no tempo em que Joatão, Acaz e Ezequias eram reis de Judá. Palavra que lhe foi dirigida em visão a respeito de Samaria e Jerusalém."
,"2":"Ouvi, povos todos! Prestai atenção, ó Terra e tudo o que a povoa! Do seu Templo santo o Senhor Javé seja testemunha contra vós."
,"3":"Olhai! Javé sai do seu lugar e desce, andando pelas alturas do país."
,"4":"Debaixo dos seus pés desfazem-se as montanhas, e os vales derretem-se como cera junto do fogo, como água que corre por uma encosta."
,"5":"Tudo isto por causa do crime de Jacob, por causa dos pecados da casa de Israel. Qual é o crime de Jacob? Não é Samaria? Quais são os lugares altos de Judá? Não é Jerusalém?"
,"6":"Pois Eu vou reduzir Samaria a uma ruína no meio do campo, num lugar para plantação de vinhas; farei rolar as suas pedras para o fundo do vale e porei os seus alicerces a descoberto."
,"7":"Todos os seus ídolos serão destruídos e as suas ofertas serão queimadas. Vou reduzir a pó as suas imagens: dado que foram ajuntadas como paga de prostituição, em paga de prostituição se vão transformar."
,"8":"É por isso que bato no peito e gemo, que ando descalço e nu: uivo como os lobos, gemo como as avestruzes,"
,"9":"pois a ferida de Judá não tem remédio, e chega até às portas do meu povo, até Jerusalém."
,"10":"Não o anuncieis em Gat; em Aco, não choreis; em Bet-Leafra, revolvei-vos no pó."
,"11":"Toca a trombeta, morador de Safir; os habitantes de Saanã não saiam da cidade; Bet-Esel perde a base, tiram-lhe os apoios."
,"12":"O habitante de Marot esperava o bem-estar; porque a desgraça desceu de Javé até às portas de Jerusalém."
,"13":"Atrela o cavalo ao carro, morador de Láquis. (Aqui começou o pecado da filha de Sião, porque em ti se encontram os crimes de Israel)."
,"14":"Por isso, pagas um dote para que Morasti-Gat seja devolvida. Bet-Aczib é uma decepção para os reis de Israel!"
,"15":"O conquistador procura novamente por ti, habitante de Maresa. A glória de Israel irá até Odolam!"
,"16":"Corta e rapa o cabelo, por causa dos filhos que eram a tua alegria; aumenta a tua calvície como o abutre, porque foram exilados para longe de ti."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Ai daqueles que, deitados na cama, planeiam a injustiça e tramam o mal! Executam-no mal amanhece o dia, porque têm o poder na sua mão."
,"2":"Cobiçam campos, e roubam-nos; querem uma casa, e apoderam-se dela. Assim oprimem o homem e a sua família, o proprietário e a sua herança."
,"3":"É por isso que assim diz Javé: Eis que planeio contra esta gente uma desgraça, da qual não podereis livrar o pescoço, nem podereis andar de cabeça erguida. Será um tempo de desgraça."
,"4":"Nesse dia, zombarão de vós, cantando esta lamentação: «Fomos completamente saqueados, a herança do meu povo foi dada a outro; quem irá devolvê-la? Os invasores é que sorteiam os nossos campos»."
,"5":"Por isso, não haverá quem sorteie os lotes na assembleia de Javé."
,"6":"Eles dizem: «Não profetizeis, não profetizeis essas coisas! A desgraça não cairá sobre nós."
,"7":"Acaso a casa de Jacob foi amaldiçoada? Acabou a paciência de Javé? É isso que Ele costuma fazer? Porventura, a sua promessa não é de bênção para quem vive com rectidão?»"
,"8":"Vós sois o inimigo do meu povo: tirais o manto ao pacífico; dos viandantes inocentes fazeis prisioneiros de guerra;"
,"9":"vós expulsais da felicidade dos seus lares as mulheres do meu povo, e tirais aos seus filhos a liberdade que Eu lhes tinha dado para sempre."
,"10":"Levantai-vos! Parti! Porque este não é já um lugar de repouso. Por um nada, exigis uma hipoteca insuportável."
,"11":"Se aparecesse um homem que inventasse esta mentira: «Eu anuncio-vos vinho e bebida forte», ele sim, seria um profeta para este povo!"
,"12":"Eu reunir-te-ei todo, ó Jacob; recolherei os teus restos, ó Israel! Vou colocar-vos juntos, como ovelhas num curral, como rebanho reunido no meio do pasto, fazendo barulho longe das pessoas."
,"13":"Na frente deles sobe aquele que abre o caminho. Abrem uma saída, atravessam a porta e saem por ela. O seu rei vai à frente, Javé é seu chefe."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ouvi bem, chefes de Jacob, governantes da casa de Israel! Acaso não é vossa obrigação conhecer o direito?"
,"2":"Inimigos do bem e amantes do mal, esfolais o povo e descarnais os seus ossos;"
,"3":"vós devorais a carne do meu povo e arrancais-lhe a pele; quebrais-lhe e despedaçais-lhe os ossos, como carne na panela, como um cozido no caldeirão."
,"4":"Depois invocareis Javé, mas Ele não responderá. Nesse tempo, Ele esconderá a sua face, por causa da maldade que praticastes."
,"5":"Assim diz Javé aos profetas que extraviam o meu povo, que anunciam a paz quando têm algo para mastigar, mas declaram guerra contra os que nada lhes põem na boca:"
,"6":"Por isso, tereis noite, em lugar de visões; escuridão, em vez de respostas. O sol pôr-se-á para esses profetas, a luz do dia obscurecer-se-á para eles."
,"7":"Os videntes ficarão envergonhados, os adivinhos ficarão confusos. Todos cobrirão o rosto, porque Deus não responderá."
,"8":"Eu, porém, estou cheio da força do espírito de Javé, do direito e da fortaleza, para anunciar a Jacob o seu crime e a Israel o seu pecado."
,"9":"Ouvi isto, chefes da casa de Ja-cob; prestai atenção, governantes de Israel, vós que tendes horror ao direito e entortais tudo o que é recto;"
,"10":"edificais Sião com sangue e Jerusalém com perversidade."
,"11":"Os vossos chefes proferem sentenças a troco de suborno; os vossos sacerdotes ensinam a troco de lucro, e os vossos profetas dão oráculos por dinheiro. E ainda ousam apoiar-se em Javé, dizendo: «Acaso Javé não está no meio de nós? Nada de mau nos poderá acontecer!»"
,"12":"Por isso, por vossa culpa, Sião será arada como um campo, Jerusalém tornar-se-á um montão de ruínas, e o monte do Templo será um matagal!"
}`)
	CurrentBook.AddChapter(4, `{
"1":"Nos últimos dias, acontecerá que o monte da casa de Javé ficará firme no topo das montanhas e se elevará acima das colinas. Para lá correrão os povos"
,"2":"e até lá irão numerosas nações, dizendo: «Vinde, subamos ao monte de Javé, ao Templo do Deus de Jacob; Ele ensinar-nos-á os seus caminhos e andaremos pelas suas veredas». Porque de Sião sairá a Lei, e de Jerusalém virá a Palavra de Javé!"
,"3":"Ele será juiz de numerosos povos, e árbitro de povos longínquos e poderosos. Das espadas vão fazer arados, e das lanças farão foices. Um povo não vai pegar em armas contra outro, nunca mais aprenderão a fazer guerra."
,"4":"Cada um poderá sentar-se debaixo da sua parreira ou da sua figueira, sem ser perturbado, pois assim disse a boca de Javé dos exércitos."
,"5":"Todos os povos caminham, cada qual em nome do seu deus; nós, porém, caminhamos em nome de Javé, nosso Deus para sempre!"
,"6":"Naquele dia - oráculo de Javé - juntarei as ovelhas estropiadas, reunirei as que foram dispersas, e aquelas que Eu mesmo castiguei."
,"7":"Farei das estropiadas um resto e, das dispersas, uma nação forte; e, no monte Sião, Javé reinará sobre elas, desde agora e para sempre."
,"8":"E tu, Torre do Rebanho, colina de Sião, a ti voltará a soberania de outrora, a realeza da filha de Jerusalém."
,"9":"Mas agora, porque gritas tanto? Porventura não tens um rei? Será que os teus conselheiros morreram, para que a tua dor seja assim tão forte como a da mulher que dá à luz?"
,"10":"Capital de Sião, contorce-te com dores e geme, como a mulher que dá à luz, pois agora vais sair da tua cidade para habitares nos campos. Irás para a Babilónia e lá serás libertada! Lá Javé resgatar-te-á da mão dos teus inimigos."
,"11":"Agora, numerosas nações reúnem-se contra ti, dizendo: «Seja profanada! Que os nossos olhos vejam a ruína de Sião!»"
,"12":"Mas acontece que eles não conhecem os pensamentos de Javé! Não entendem os seus planos, pois Ele ajunta-os como feixes na eira!"
,"13":"Levanta-te, capital de Sião! Debulha o trigo, pois Eu dou-te chifres de ferro e cascos de bronze, para que possas esmagar povos numerosos! Consagrarás a Javé as suas rapinas e as suas riquezas ao Senhor de toda a Terra!"
,"14":"Mas agora eles juntam as tropas e cercam-nos. Com uma vara batem na face do Juiz de Israel!"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Mas tu, Belém de Éfrata, tão pequena entre as principais cidades de Judá! É de ti que sairá para Mim Aquele que há-de ser o chefe de Israel! A sua origem é antiga, desde tempos remotos."
,"2":"Pois Deus entrega-os só até que a mãe dê à luz, e o resto dos irmãos volte aos israelitas."
,"3":"De pé, Ele governará com a própria força de Javé, com a majestade do nome de Javé, seu Deus. E habitarão tranquilos, pois Ele estenderá o seu poder até às extremidades da Terra."
,"4":"Ele próprio será a paz. Se a Assíria invadir o nosso território e quiser entrar nos nossos palácios, poremos em luta contra eles sete pastores e oito comandantes."
,"5":"Eles vão governar a Assíria com espada, e a terra de Nemrod com punhal. Ele nos livrará da Assíria, se ela invadir o nosso território e atravessar as nossas fronteiras."
,"6":"O resto de Jacob estará no meio de povos numerosos, como o orvalho que vem de Javé ou a chuva sobre a relva. Eles não põem a sua esperança no ser humano, nem dependem do homem."
,"7":"O resto de Jacob no meio de povos numerosos será como o leão entre feras selvagens, como leãozinho no meio de um rebanho de ovelhas, o qual, quando ataca, esmaga e despedaça a presa, e ninguém a pode salvar."
,"8":"Ergue a tua mão contra os teus adversários, e todos os teus inimigos serão destruídos."
,"9":"Nesse dia, acontecerá - oráculo de Javé - que destruirei do meio de ti os cavalos e farei desaparecer todos os teus carros de guerra."
,"10":"Destruirei as cidades fortificadas do país e eliminarei todos os quartéis."
,"11":"Arrancar-te-ei das mãos os objectos mágicos e em ti não mais haverá adivinhos."
,"12":"Eliminarei do meio de ti as imagens dos deuses e os monumentos pagãos. E nunca mais adorarás a obra das tuas mãos."
,"13":"Derrubarei do meio de ti os pilares sagrados e destruirei todos os teus bosques sagrados."
,"14":"Com ira e furor Me vingarei das nações que não Me obedeceram."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Ouvi o que diz Javé: Levanta-te! Abre um processo diante das montanhas, e que as colinas ouçam a tua voz."
,"2":"Escutai, montanhas, a acusação de Javé; prestai atenção, alicerces da terra: O processo de Javé é contra o seu povo; é contra Israel que Ele apresenta a sua queixa:"
,"3":"Meu povo, o que é que Eu fiz contra ti? Em que te maltratei? Responde-me!"
,"4":"Pois Eu tirei-te da terra do Egipto, resgatei-te da casa da escravidão e mandei à tua frente Moisés, Aarão e Maria."
,"5":"Povo meu, lembra-te bem do que planeava Balac, rei de Moab, e o que lhe respondeu Balaão, filho de Beor. Lembra-te do que aconteceu desde Setim até Guilgal, para que compreendas que Javé tem razão."
,"6":"Como me apresentarei a Javé? Como é que me vou ajoelhar diante do Deus das alturas? Irei à sua presença com holocaustos e bezerros de um ano?"
,"7":"Será que milhares de carneiros ou a oferta de rios de azeite agradarão a Javé? Ou devo sacrificar o meu filho mais velho para pagar os meus erros, sacrificar o fruto das minhas entranhas para cobrir o meu pecado?"
,"8":"Ó homem, já te foi explicado o que é bom e o que Javé exige de ti: praticar a justiça, amar a misericórdia, caminhar humildemente com o teu Deus."
,"9":"Escuta o que Javé grita à cidade: escuta, tribo e assembleia da cidade."
,"10":"Acaso posso tolerar a casa do ímpio com os seus tesouros ganhos injustamente, com as suas medidas falsificadas e detestáveis?"
,"11":"Acaso devo desculpar balanças viciadas, sacos cheios de pesos falsificados?"
,"12":"Os ricos prosperam com a exploração, os seus habitantes só proferem mentiras e têm na boca uma língua mentirosa."
,"13":"Pois comecei a ferir-te e a arrastar-te por causa dos teus pecados."
,"14":"Comerás, mas não matarás a fome; e a fome será a tua companheira. Guardarás os teus bens, mas não poderás conservá-los; os bens que salvares entregá-los-ei aos teus inimigos."
,"15":"Semearás, mas não colherás; moerás a azeitona, mas não te ungirás com azeite; pisarás uvas, mas não beberás vinho."
,"16":"Tu segues os usos de Amri, todas as práticas da família de Acab, e vives segundo os seus princípios. Por isso, entregar-te-ei à destruição, e os teus moradores serão objecto de escárnio, suportando a vergonha dos povos."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Pobre de mim! Estou na situação de alguém que recolhe no Verão, que colhe depois de acabada a colheita. Não há nenhum cacho de uva para eu chupar, nem sequer um figo temporão para me matar a vontade."
,"2":"Não há sequer um justo no nosso país, não ficou nenhum homem recto; andam todos à espreita, cada um persegue o seu irmão para o matar!"
,"3":"Essa gente tem mãos habilidosas para praticar o mal: o príncipe exige, o juiz deixa-se comprar, o grande mostra a sua ambição. E assim distorcem tudo."
,"4":"O melhor deles é como o espinheiro, o mais justo deles parece uma cerca de espinhos! O dia anunciado pela sentinela, o dia do castigo chegou: agora é a ruína deles."
,"5":"E vós, não acrediteis no amigo, não confieis no companheiro; conserva a boca fechada, mesmo ao lado daquela que dorme a teu lado."
,"6":"Pois o filho insulta o próprio pai, a filha revolta-se contra a mãe, a nora contra a sogra; e os inimigos são os da própria casa."
,"7":"Mas eu volto-me para Javé, espero em Deus, meu salvador, e o meu Deus ouvir-me-á."
,"8":"Não te alegres por minha causa, ó minha inimiga; pois eu caí, mas hei-de tornar a levantar-me; moro nas trevas, mas Javé é a minha luz."
,"9":"Devo suportar a cólera de Javé, porque pequei contra Ele, até que Ele julgue a minha causa e me faça justiça, até que me leve para a luz e eu contemple a sua justiça."
,"10":"A minha inimiga verá e ficará coberta de vergonha. Pois ela dizia-me: «Onde está o teu Deus Javé?» Os meus olhos estarão a olhar para ela, quando for pisada como a lama da estrada."
,"11":"No dia em que reconstruírem os teus muros, as tuas fronteiras serão mais amplas."
,"12":"Nesse dia, virão a ti, desde a Assíria até ao Egipto, desde o Nilo até ao Eufrates, de mar a mar, de monte a monte."
,"13":"A terra será devastada, por causa dos seus moradores, como fruto das suas más acções."
,"14":"Com a tua vara de pastor guia o teu povo, o rebanho que é tua propriedade, que está sozinho na floresta, no meio dos jardins. Faz com que eles possam pastar em Basã e Galaad, como nos tempos antigos."
,"15":"Como no dia em que nos tiraste do Egipto, mostra-nos agora as tuas maravilhas."
,"16":"Que ao ver as tuas maravilhas, os outros povos se envergonhem, apesar de toda a sua valentia; que ponham a mão na boca e tapem os ouvidos;"
,"17":"que fiquem lambendo o pó como serpentes, que saiam cambaleando de suas trincheiras em direcção a Javé, nosso Deus; que fiquem a tremer e cheios de medo diante de Ti."
,"18":"Qual deus é igual a Ti? Qual deus, como Tu, tira o pecado e absolve a culpa do resto da tua herança? Qual deus não guarda para sempre a sua ira e dá preferência ao amor?"
,"19":"Ele nos perdoará de novo: calcará a seus pés as nossas faltas e lançará para o fundo do mar todos os nossos pecados."
,"20":"Conservarás a fidelidade para com Jacob e o amor para com Abraão, conforme juraste a nossos pais, desde os tempos antigos."
}`)

}
func PT_BS_LoadVNMLChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oráculo. Palavra de Javé a Israel por intermédio de Malaquias."
,"2":"Javé diz: «Eu amo-vos». E vós perguntais: «De que modo nos amas?» Porventura Esaú não era irmão de Jacob? - oráculo de Javé. Pois Eu amei Jacob"
,"3":"e odiei Esaú. Eu fiz das montanhas de Esaú um deserto e da sua herança um refúgio de animais."
,"4":"Se Edom disser: «Fomos destruídos, mas vamos reconstruir o que foi derrubado», eis o que diz Javé dos exércitos: Eles podem construir, mas Eu destruo novamente. Edom vai chamar-se «Lugar condenado, Povo que Javé odiou para sempre»."
,"5":"Os vossos olhos vê-lo-ão, e direis: «Javé é de facto grande, para além das fronteiras de Israel»."
,"6":"Um filho honra o pai e um escravo honra o seu senhor. Se Eu sou Pai, onde está a honra que Me é devida? Se Eu sou Senhor, onde está o respeito que Me é devido?,Javé dos exércitos fala-vos a vós, sacerdotes que desprezais o seu Nome. Vós perguntais: «Como foi que desprezámos o teu Nome?» "
,"7":"Vós ofereceis sobre o meu altar alimentos impuros, e ainda perguntais: «Como foi que o profanámos?» Achais que a mesa de Javé é desprezível,"
,"8":"que trazer um animal cego para oferecer em sacrifício não é um mal, que trazer um animal coxo ou doente também não é um mal? Oferecei um desses animais ao vosso governador: achais que ele vai aceitar e ficar agradecido? - diz Javé dos exércitos."
,"9":"Agora suplicais a Deus para que Ele tenha pena de vós! Se fazeis tais coisas, deverá Ele ter consideração para convosco? - diz Javé dos exércitos."
,"10":"Quem entre vós fecha as portas do Templo, a fim de que não acendais inutilmente o fogo sobre o meu altar? Vós já não Me agradais - diz Javé dos exércitos. Eu não aceito a oferta das vossas mãos."
,"11":"Desde o Oriente até ao Ocidente, é grande o meu Nome entre as nações. E em todo o lugar se oferece incenso ao meu nome e uma oferta pura, pois grande é o meu Nome entre as nações - diz Javé dos exércitos."
,"12":"Vós profanais o meu Nome quando dizeis: «A mesa do Senhor está contaminada e a comida que está em cima dela não tem valor»."
,"13":"E ainda dizeis: «Que pena!» e desprezais-Me - diz Javé dos exércitos. Ofereceis animais roubados, coxos e doentes, e ainda quereis que Eu os receba das vossas mãos? - diz Javé dos exércitos."
,"14":"Maldito o fraudulento que, tendo no seu rebanho um animal macho, Me oferece em sacrifício um animal defeituoso. Pois Eu sou o grande rei - diz Javé dos exércitos - e o meu Nome é respeitado entre as nações."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Agora a vós, sacerdotes, dou a seguinte ordem:"
,"2":"Se não Me ouvirdes e não tiverdes no coração o desejo sincero de glorificar o meu Nome - diz Javé dos exércitos - mandarei contra vós a maldição, e amaldiçoarei as vossas bênçãos. E vou amaldiçoar-vos porque nenhum de vós as leva a sério."
,"3":"Vou arrancar o vosso braço e atirar-vos estrume à cara, o estrume das vítimas sacrificadas nas vossas festas; vou varrer-vos juntamente com esse estrume."
,"4":"Assim ficareis sabendo que fui Eu que vos dei esta ordem, para que permaneça a aliança que fiz com Levi - diz Javé dos exércitos."
,"5":"A minha aliança estava com Levi; significava vida e paz, e era isso o que Eu lhe dava; significava também respeito, e Ele respeitava-Me e honrava o meu Nome."
,"6":"Um ensinamento fiel estava na sua boca, e nada de errado se encontrava nos seus lábios; Levi caminhava comigo na paz e no direito, e fazia afastar muita gente do pecado."
,"7":"Porque os lábios do sacerdote guardam o conhecimento, e na sua boca se procura o ensinamento, pois ele é um mensageiro de Javé dos exércitos."
,"8":"Vós, porém, desviastes-vos do caminho e fizestes tropeçar muita gente com o vosso ensinamento. Vós quebrastes a aliança de Levi - diz Javé dos exércitos."
,"9":"Por isso, agora tornei-vos desprezíveis e abjectos aos olhos de todo o povo, porque não seguistes os meus caminhos e fostes parciais na aplicação da minha Lei."
,"10":"Porventura, não temos todos nós um único Pai? Não foi o mesmo Deus que nos criou? Então, por que razão nos enganamos uns aos outros, profanando assim a Aliança dos nossos pais?"
,"11":"Judá cometeu uma traição, uma coisa horrível aconteceu em Israel e Jerusalém; Judá profanou o santuário que Javé ama e casou-se com a filha de um deus estrangeiro."
,"12":"Que Javé elimine das tendas de Jacob todo aquele que assim procede, a testemunha e o defensor, e até mesmo aqueles que apresentam as ofertas a Javé dos exércitos."
,"13":"Há uma outra coisa que fazeis: cobris o altar de Javé com lágrimas, prantos e lamentos, porque Ele Se recusa a aceitar a vossa oferta, e não Lhe agrada o que Lhe apresentais com as vossas mãos."
,"14":"E vós ainda perguntais: «Porquê?» Porque Javé é testemunha entre ti e a mulher da tua juventude, à qual foste infiel, embora ela fosse a tua companheira, a esposa unida a ti por uma aliança."
,"15":"Acaso, Deus não fez dos dois um único ser, dotado de carne e espírito? E o que é que esse único ser procura? Uma descendência da parte de Deus! Portanto, controlai-vos para não serdes infiéis à esposa da vossa juventude."
,"16":"Eu odeio o divórcio - diz Javé, Deus de Israel, - e quem cobre de injustiças as suas vestes - diz Javé dos exércitos. Controlai-vos e não sejais infiéis."
,"17":"Vós cansais Javé com palavras. E depois dizeis: «Como é que nós O cansamos?» É quando dizeis: «Quem pratica o mal é que é bom aos olhos de Javé. É desses que Ele gosta». Ou ainda: «Onde é que está o Deus que faz justiça?«"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Eis que vou enviar o meu mensageiro para preparar o caminho à minha frente. De repente, vai chegar ao seu Templo o Senhor que procurais, o mensageiro da Aliança que desejais. Eis que está a chegar! - diz Javé dos exércitos."
,"2":"Quem poderá suportar o dia da sua vinda? Quem poderá ficar de pé quando Ele aparecer? Pois Ele é como o fogo do fundidor, é como o sabão das lavadeiras."
,"3":"Ele vai sentar-Se como aquele que refina a prata: vai refinar e purificar os filhos de Levi, como ouro e prata, para que possam apresentar a Javé uma oferta que seja de acordo com a justiça."
,"4":"Então, como nos tempos antigos, como nos anos passados, a oferta de Judá e de Jerusalém será agradável a Javé."
,"5":"Eu virei ter convosco para fazer um julgamento: serei uma testemunha atenta contra os feiticeiros e contra os adúlteros, contra todos os que juram falso, que roubam o salário do operário, contra os opressores da viúva e do órfão e contra os que violam o direito do estrangeiro sem Me temerem! - diz Javé dos exércitos."
,"6":"Eu sou Javé, e não mudo, mas vós, filhos de Jacob não vos definis."
,"7":"Desde o tempo dos vossos antepassados, afastais-vos dos meus estatutos e não guardais os meus decretos. Voltai para Mim, que Eu também voltarei para vós! - diz Javé dos exércitos. Mas vós perguntais: «Em que precisamos de voltar?"
,"8":"Porventura pode um homem enganar a Deus?» Sim, vós enganais-Me! Vós perguntais: «Em que Te enganamos?» No dízimo e na contribuição."
,"9":"Fostes ameaçados com a maldição, e mesmo assim enganais-Me, vós e a nação inteira!"
,"10":"Trazei o dízimo completo para o cofre do Templo, para que haja alimento no meu Templo. Fazei essa experiência comigo - diz Javé dos exércitos, e Eu vos abrirei as comportas do céu e derramarei sobre vós as minhas bênçãos de fartura."
,"11":"Acabarei com as pragas das plantações, para que não destruam os frutos da terra e tornem estéril a vinha no campo - diz Javé dos exércitos."
,"12":"Todas as nações vos chamarão felizes, pois sereis um país de delícias - diz Javé dos exércitos."
,"13":"Usastes palavras duras contra Mim - diz Javé. Vós perguntais: «O que é que dissemos contra Ti?»"
,"14":"Vós dissestes: «É inútil servir a Deus. Que proveito temos em guardar os seus mandamentos ou em andar vestidos de luto diante de Javé dos exércitos?"
,"15":"Vamos, então, felicitar os soberbos; eles progridem praticando o mal, desafiam a Deus e não são castigados»."
,"16":"E os que temem a Javé comentavam: «Javé ouviu com atenção, diante d'Ele foi escrito um livro para lembrar todas as coisas que são a favor dos que O temem e honram o seu Nome»."
,"17":"Esses, - diz Javé dos exércitos - quando Eu resolver agir, serão a minha propriedade particular. Terei compaixão deles como um pai tem compaixão do filho que o serve."
,"18":"Então vereis a diferença que existe entre o justo e o ímpio, entre um que serve a Deus, e outro que não O serve."
,"19":"Eis que vem o Dia, ardente como um forno. Então os soberbos e todos os que cometem injustiça serão como a palha. Quando chegar o Dia, eles serão incendiados - diz Javé dos exércitos. E deles nada ficará nem raízes nem ramos."
,"20":"Mas para vós que temeis a Javé brilhará o sol da justiça, que cura com os seus raios. E todos vós podereis sair e saltar como os bezerros quando saem do estábulo."
,"21":"Calcareis os maus como poeira debaixo da planta dos vossos pés, no Dia que Eu preparo - diz Javé dos exércitos."
,"22":"Lembrai-vos da Lei do meu servo Moisés, que Eu mesmo lhe dei no monte Horeb, estatutos e normas para todo o Israel."
,"23":"Eis que vou enviar-vos o profeta Elias, antes de chegar o grandioso e terrível Dia de Javé."
,"24":"Ele há-de fazer voltar o coração dos pais para os filhos e o coração dos filhos para os pais; e assim, quando Eu vier, não condenarei o país à destruição total."
}`)

}
func PT_BS_LoadVNNHChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Oráculo contra Nínive. Livro da visão de Naum de Elcós."
,"2":"Javé é um Deus ciumento e vingador!,Javé é vingador e sabe enfurecer-Se. Javé vinga-Se dos seus adversários,e é rancoroso com os seus inimigos."
,"3":"Javé é lento para a ira e muito poderoso, mas não deixa ninguém sem castigo. Borrasca e tempestade,fazem o caminho d'Ele; as nuvens são a poeira de seus passos."
,"4":"Ameaça o mar, e o mar seca; ele enxuga todos os rios. O Basã e o Carmelo secam, e murcham as floradas do Líbano."
,"5":"As montanhas estremecem diante d'Ele,e as colinas derretem-se. Frente a Ele a terra levanta-se, o mundo e todos os seus habitantes."
,"6":"Quem resistirá à sua cólera,e enfrentará o furor da sua ira?,O seu furor espalha-se como fogo, diante deles as rochas rebentam."
,"7":"Javé é bom!,Refúgio seguro nas horas de aperto: conhece aqueles que n'Ele confiam,"
,"8":"quando acontece uma inundação. Extermina quem se levanta contra Ele, persegue os inimigos até ao escurecer."
,"9":"O que é que tramais contra Javé? Ele reduz tudo a nada: o seu adversário não se levantará duas vezes."
,"10":"Aqueles que se embebedam em festas serão consumidos qual monte de espinhos ou montão de palha seca."
,"11":"De ti saiu o conselheiro iníquo, aquele que trama tudo o que é mau contra Javé."
,"12":"Assim diz Javé: Apesar de nada terem sofrido e serem numerosos, mesmo assim serão ceifados e desaparecerão. E, se um dia te fiz sofrer, nunca mais te afligirei."
,"13":"Agora vou quebrar o jugo que pesava sobre os teus ombros e rebentar com as tuas prisões."
,"14":"Mas este é o decreto de Javé contra ti: Nunca mais haverá descendência da tua raça; vou acabar com os ídolos, as imagens e estátuas do templo do teu deus. Vou fazer da tua sepultura um lugar amaldiçoado."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Vede sobre os montes os passos de um mensageiro que anuncia a paz: «Judá, celebra as tuas festas, cumpre os teus votos, porque o iníquo nunca mais passará pela tua terra, pois foi totalmente destruído»."
,"2":"Contra ti avança um destruidor! Guarda o quartel, vigia o caminho, aperta o cinto, reúne todas as tuas forças."
,"3":"Javé restaura a vinha de Jacob, e também a vinha de Israel, pois os ladrões tinham-na depredado e até os rebentos lhe haviam arrancado."
,"4":"O escudo dos guerreiros avermelha-se, os valentes vestem-se de escarlate, os carros brilham como o fogo e, na hora de montar, os cavaleiros tremem."
,"5":"Pelas ruas correm carros loucamente, passam a correr pelas praças, parecem tochas de fogo, a correr como relâmpagos."
,"6":"São convocados os mais corajosos, que tropeçam na corrida; eles lançam-se para a muralha, formando a cobertura de escudos."
,"7":"Rompem-se as barragens do rio e o palácio desaba."
,"8":"A deusa foi exilada, foi levada embora, e as suas sacerdotisas gemem como pombas e batem no peito."
,"9":"Nínive parece uma represa a vazar as suas águas. «Parai! Parai!» Mas ninguém volta atrás."
,"10":"«Saqueai a prata, saqueai o ouro». O tesouro não tem fim, um montão de objectos de valor."
,"11":"Ruína, vazio, solidão! O coração falha, os joelhos tremem, há um calafrio na espinha de todos, e todas as faces empalidecem."
,"12":"Onde está a toca dos leões? Onde está a caverna dos leõezinhos, para onde ia o leão com a leoa e as crias, sem que ninguém os incomodasse?"
,"13":"Para alimentar as crias o leão dilacerava, e para as suas leoas estrangulava, enchia a caverna de carnes, enchia a toca de caça."
,"14":"Pois Eu agora estou contra ti! - oráculo de Javé dos exércitos. Os teus carros arderão fumegando e a espada devorará os teus filhos. Farei desaparecer da terra as tuas caças, e a voz dos teus mensageiros nunca mais será ouvida."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ai da cidade sanguinária e traidora, cheia de rapina, insaciável de despojos!"
,"2":"Estalo de chicotes, ruído de rodas girando, cavalos a galope, carros que pulam,"
,"3":"cavalos que se empinam, espadas a luzir, lanças que faíscam! Multidões de feridos, montão de cadáveres, corpos sem conta, tropeça-se nos cadáveres."
,"4":"Isto por causa das muitas seduções dessa prostituta, formosa e hábil feiticeira, que enganava as nações com os seus atractivos e os povos com os seus encantamentos."
,"5":"Por isso, aqui estou Eu contra ti! - oráculo de Javé dos exércitos. Vou levantar a barra da tua saia até à altura do rosto; vou mostrar às nações a tua nudez, e aos reis as tuas partes vergonhosas."
,"6":"Lançarei sobre ti a desonra, vou fazer-te passar vergonha, farei do teu caso um exemplo."
,"7":"Então, quem quer que te veja fugirá, dizendo: «Nínive está arrasada! Quem terá compaixão dela? Onde encontrar quem a console?»"
,"8":"Porventura és melhor que Tebas, a cidade sentada entre os canais do Nilo, cercada de águas? A sua trincheira era o mar, e a sua muralha era de água."
,"9":"A sua força era a Etiópia e o Egipto, que não tinha limites; Fut e os líbios eram as suas tropas auxiliares."
,"10":"Pois eles também foram para o exílio como escravos; também as suas crianças foram despedaçadas em cada esquina das ruas; deitaram sortes sobre as suas autoridades, e todos os seus grandes foram acorrentados."
,"11":"Tu também te vais embriagar e esconder, procurando um lugar para onde possas escapar ao inimigo."
,"12":"As tuas fortalezas parecem figueiras com figos temporões: basta abaná-las, e eles caem na boca de quem os quiser comer."
,"13":"O teu exército não é de homens, mas de mulheres; as portas do teu país estão abertas, escancaradas para os teus inimigos, o fogo consumiu as tuas trancas."
,"14":"Tira água para quando estiveres cercada; reforça as tuas torres fortificadas; pisa o barro, amassa a argila, pega na forma dos tijolos."
,"15":"Mesmo assim o fogo vai devorar-te e a espada vai liquidar-te. Multiplica-te como os grilos, e torna-te numerosa como os gafanhotos!"
,"16":"Multi-plicaste, mais do que as estrelas do céu, o número dos teus comerciantes. O grilo pula e voa para longe."
,"17":"Os teus guardas parecem bandos de gafanhotos, e os teus funcionários um enxame de insectos que pousa no muro em dia de frio. Mas, quando o sol se levanta, vão-se embora, e ninguém mais sabe para onde foram."
,"18":"Ah! Rei da Assíria! Os teus pastores adormeceram, os teus comandantes dormiram; o teu povo espalhou-se pela montanha e ninguém consegue reuni-lo novamente."
,"19":"Não há cura para os teus ferimentos, a tua chaga é incurável. Quem ouve as tuas notícias alegra-se com a tua sorte. Com efeito, sobre quem não passou continuamente a tua maldade?"
}`)

}
func PT_BS_LoadVNOSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palavra de Javé dirigida a Oseias, filho de Beeri, na época de Ozias, Joatão, Acaz e Ezequias, reis de Judá, enquanto Jeroboão, filho de Joás, era rei de Israel."
,"2":"Começo das palavras de Javé por intermédio de Oseias. Javé disse a Oseias: «Vai, toma uma prostituta e gera filhos da prostituição, porque o país se prostituiu, afastando-se de Javé»."
,"3":"Então Oseias foi e tomou Gomer, filha de Deblaim. Ela ficou grávida e deu-lhe um filho."
,"4":"Javé disse a Oseias: «Dá-lhe o nome de Jezrael, pois dentro em breve pedirei contas à casa de Jeú pelo sangue de Jezrael, e destruirei o reino de Israel."
,"5":"Naquele dia, quebrarei o arco de Israel no vale de Jezrael»."
,"6":"A mulher ficou grávida de novo e deu à luz uma menina. Javé disse a Oseias: «Dá-lhe o nome de 'Não-Compadecida', pois não mais terei compaixão da casa de Israel e não lhe perdoarei."
,"7":"Compadecer-Me-ei, porém, da casa de Judá e salvá-la-ei, porque sou Javé, o seu Deus. Não lhes darei a salvação, nem pelo arco, nem pela espada ou guerra, nem pelos cavalos ou cavaleiros»."
,"8":"Depois de desmamar a 'Não-Compadecida', Gomer ficou grávida de novo e deu à luz outro menino."
,"9":"Javé disse a Oseias: «Dá-lhe o nome de 'Não-Meu-Povo', porque já não sois o meu povo, e Eu não existo para vós»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Os filhos de Israel serão tão numerosos como os grãos de areia do mar, grãos que ninguém pode medir nem contar. E, então, onde vos diziam: «Vós não sois o meu povo», nesse mesmo lugar sereis chamados «Filhos do Deus vivo»."
,"2":"Os filhos de Judá reunir-se-ão com os filhos de Israel, nomearão para si um único chefe e levantar-se-ão da terra, porque será grande o dia de Jezrael."
,"3":"Começai a chamar aos vossos irmãos «Povo-Meu» e às vossas irmãs «Compadecida»."
,"4":"Processai a vossa mãe, processai! Pois ela já não é minha esposa e Eu já não sou o seu marido. Que ela tire do rosto as suas prostituições e de entre os seios o seu adultério."
,"5":"Senão, Eu deixá-la-ei completamente nua, como no dia em que nasceu; farei dela um deserto, transformá-la-ei em terra seca, farei que morra de sede."
,"6":"Não terei compaixão dos seus filhos, pois são filhos da prostituição."
,"7":"A mãe deles prostituiu-se, desonrou-se aquela que os gerou. Ela dizia: «Eu vou com os meus amantes; eles dão-me o meu pão e a minha água, a minha lã e o meu linho, o meu vinho e o meu azeite»."
,"8":"Por isso, vou fechar com espinheiros o seu caminho, vou cercá-lo com uma barreira para que ela não encontre as suas veredas."
,"9":"Ela correrá atrás dos seus amantes mas não conseguirá alcançá-los; vai procurá-los, mas não os encontrará. Então dirá: «Voltarei para o meu primeiro marido; naquele tempo eu era bem mais feliz do que agora»."
,"10":"Ela não reconheceu que era Eu que lhe dava o trigo, o vinho e o azeite; que lhe multiplicava a prata e o ouro, que eram usados para fazer um ídolo."
,"11":"Por isso, retomarei o meu trigo e o meu vinho na época da safra; retomarei a minha lã e o meu linho que cobriam a sua nudez."
,"12":"Porei a nu a sua vergonha ante os olhares dos seus amantes. Desta vez ninguém vai arrancá-la das minhas mãos."
,"13":"Acabarei com a sua alegria, com as suas festas e seus dias santos, com os seus sábados e com as celebrações solenes."
,"14":"Arrasarei as suas videiras e as suas figueiras, das quais ela dizia: «Esta é a paga que recebi dos meus amantes». Vou transformá-las em matagal, e as feras devorá-las-ão."
,"15":"Pedirei contas de quando ela oferecia incenso aos ídolos, de quando se enfeitava com anel e colar para correr atrás dos seus amantes e se esquecia de Mim - oráculo de Javé."
,"16":"Agora, sou Eu que vou seduzi-la, vou levá-la ao deserto e conquistar o seu coração."
,"17":"Então restituir-lhe-ei as videiras, e o Vale da Desgraça transformar-se-á em Porta da Esperança. Lá ela Me responderá como nos dias da sua mocidade, como no dia em que saiu da terra do Egipto."
,"18":"Nesse dia - oráculo de Javé - chamar-Me-ás «Meu marido» e não mais «Meu ídolo»."
,"19":"Vou tirar dos teus lábios o nome dos ídolos, e esses nomes nunca mais serão lembrados."
,"20":"Nesse dia, farei em favor deles uma aliança com as feras, com as aves do céu e com os répteis da terra. Eliminarei da terra o arco, a espada e a guerra; e, então, vou fazê-los dormir em segurança."
,"21":"Casar-Me-ei contigo para sempre, casar-Me-ei contigo na justiça e no direito, no amor e na ternura."
,"22":"Casar-Me-ei contigo na fidelidade e conhecerás Javé."
,"23":"Nesse dia - oráculo de Javé - Eu responderei ao céu e o céu responderá à terra;"
,"24":"a terra responderá ao trigo, ao vinho e ao azeite e eles responderão a Jezrael."
,"25":"Eu semeá-la-ei na terra, terei compaixão da 'Não-Compadecida' e direi ao 'Não-Meu-Povo': «Tu és o Meu povo». E ele responderá: «Meu Deus»."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Javé disse-me: «Vai de novo e ama uma mulher que é amante de outro homem, que é adúltera, pois é assim que Javé ama os filhos de Israel, apesar de irem atrás de outros deuses e de gostarem de bolos de uvas passas»."
,"2":"Comprei-a por quinze moedas de prata e um omer e meio de cevada,"
,"3":"e disse-lhe: «Durante muitos dias esperarás em tua casa por mim, sem te prostituíres, sem te entregares a homem nenhum, e eu farei o mesmo para contigo»."
,"4":"Porque os filhos de Israel ficarão durante muito tempo sem rei e sem chefe, sem sacrifícios e sem monumentos sagrados, sem adivinhação e sem imagens de ídolos."
,"5":"Depois, eles voltarão para procurarem Javé, seu Deus, e David, seu rei. Tremendo, voltarão, nos dias futuros, para Javé e para os seus bens."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Ouvi a palavra de Javé, filhos de Israel! Javé abre um processo contra os moradores do país, pois já não há fidelidade, nem amor, nem conhecimento de Deus no país."
,"2":"Há juramento falso e mentira, assassínio e roubo, adultério e violência; sangue derramado junta-se a sangue derramado."
,"3":"Por isso, a terra geme e os seus moradores desfalecem; as feras, as aves do céu e até os peixes do mar estão a desaparecer."
,"4":"Embora ninguém acuse, ninguém conteste, eu acuso-te, sacerdote!"
,"5":"Tu tropeças de dia, o profeta tropeça contigo de noite e tu arruínas a tua mãe."
,"6":"O meu povo perde-se por falta de conhecimento. Porque rejeitas o conhecimento, Eu também te rejeitarei como meu sacerdote; tu esqueceste a Lei do teu Deus; Eu também esquecerei os teus filhos."
,"7":"Quanto mais se multiplicaram, mais pecaram contra Mim; trocarei a sua boa fama pela desonra."
,"8":"Esses sacerdotes vivem do pecado do meu povo e querem que o povo continue a pecar."
,"9":"Acontecerá a mesma coisa ao povo e ao sacerdote: vou castigar a cada um pelo seu mau procedimento, vou fazer pagar a cada um por todos os seus actos;"
,"10":"comerão sem ficar satisfeitos, vão prostituir-se sem tirarem nenhum proveito, pois abandonaram Javé para se entregarem à prostituição."
,"11":"O vinho e o licor tiram a razão."
,"12":"O meu povo consulta um pedaço de madeira, e o seu bastão dá-lhe uma resposta, porque um espírito de prostituição extravia-os e eles prostituem-se, afastando-se do seu Deus."
,"13":"Oferecem sacrifícios no alto dos montes, queimam incenso sobre as colinas ou debaixo de um carvalho, de um salgueiro ou de um terebinto, cuja sombra lhes agrade. Por isso, as vossas filhas prostituem-se e as vossas noras cometem adultério."
,"14":"Eu não vou castigar as vossas filhas por se prostituírem, nem as vossas noras por cometerem adultério, pois vós mesmos andais com prostitutas e sacrificais com as prostitutas sagradas. Um povo sem entendimento caminha para a perdição."
,"15":"Se tu te prostituis, ó Israel, que Judá não caia no mesmo pecado! Deixai de fazer romarias a Guilgal, não subais a Bet-Áven, não jureis pela vida de Javé."
,"16":"Se Israel é rebelde como uma novilha brava, como é que Javé irá guiá-lo como a um cordeiro em campo aberto?"
,"17":"Efraim aliou-se aos ídolos"
,"18":"e acompanhou os beberrões; entregaram-se à prostituição, preferiram a desonra à dignidade."
,"19":"Um furacão levará tudo nas suas asas e eles envergonhar-se-ão dos seus sacrifícios."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Ouvi isto, sacerdotes; presta atenção, casa de Israel; escuta, casa do rei! A sentença é contra vós. Tornastes-vos uma armadilha em Masfa, uma rede armada sobre o Tabor"
,"2":"e uma fossa profunda em Sitim; mas sou Eu quem castigo a todos."
,"3":"Conheço bem Efraim, e Israel não me é estranho! Efraim caiu na prostituição, e Israel contaminou-se."
,"4":"As suas acções não permitem que se convertam ao seu Deus. Um espírito de prostituição está dentro deles e, por isso, não conhecem a Javé."
,"5":"O orgulho de Israel condena-o; Israel e Efraim tropeçam na sua própria maldade; e também Judá acaba por tropeçar com eles."
,"6":"Irão procurar a Javé, levando carneiros e bezerros, mas não poderão encontrá-l'O, porque Se afastou deles."
,"7":"Eles enganaram Javé, gerando filhos bastardos: agora um conquistador devorá-los-á juntamente com os seus campos."
,"8":"Tocai a trombeta em Gabaá, tocai a corneta em Ramá, soai o alarme em Bet-Áven. Andam atrás de ti, Benjamim!"
,"9":"Efraim será uma ruína no dia do castigo. É uma coisa certa que Eu estou proclamando contra as tribos de Israel."
,"10":"Os chefes de Judá são como aqueles que roubam terras: sobre eles Eu derramo a água da minha ira."
,"11":"Efraim é um opressor, passa por cima do direito, corre atrás da mentira."
,"12":"Pois Eu vou ser uma traça para Efraim; como cárie, vou roer a casa de Judá."
,"13":"Efraim descobriu a sua doença, Judá viu a sua ferida. Efraim foi procurar a Assíria, Judá enviou mensageiros ao grande rei. Mas não é este que lhes dará saúde, não é ele que vai curar as vossas feridas."
,"14":"Pois Eu serei um leão para Efraim, um leãozinho para a casa de Judá. Dilacero tudo e vou-me embora, levo a minha presa e ninguém pode tirar-Ma."
,"15":"Vou-Me embora, volto para a minha casa, até que reconheçam a sua culpa e venham procurar a minha face. Na hora da angústia virão procurar-Me."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Vinde, voltemos para Javé: Ele despedaçou-nos, mas vai curar-nos; Ele feriu-nos, mas vai tratar a nossa ferida."
,"2":"Durante dois dias far-nos-á reviver, e no terceiro dia far-nos-á levantar, e passaremos a viver na sua presença."
,"3":"Esforcemo-nos por conhecer Javé; a sua chegada é certa como a aurora, Ele virá até nós como a chuva, como o aguaceiro que ensopa a terra."
,"4":"Que farei de ti, Efraim? Que farei de ti, Judá? O vosso amor é como a neblina da manhã, como o orvalho que num instante se evapora."
,"5":"Por isso castiguei-vos por meio dos profetas, matei-vos com as palavras da minha boca, e a minha sentença brotou como a luz."
,"6":"Pois quero amor e não sacrifícios, conhecimento de Deus mais do que holocaustos."
,"7":"Em Adam eles violaram a aliança e traíram-Me."
,"8":"Galaad é uma cidade de malfeitores, cheia de rastos de sangue."
,"9":"Como bandidos na emboscada, um bando de sacerdotes assassinam pelo caminho de Siquém e cometem horrores."
,"10":"Em Betel também vi coisas horríveis: foi aí que Efraim se prostituiu e Israel se contaminou."
,"11":"Também para ti, Judá, preparo uma colheita, quando Eu mudar a sorte do meu povo."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Quando Eu estou para curar Israel, aparece a culpa de Efraim e a maldade de Samaria, pois essa gente só pratica a mentira. O ladrão invade a casa, enquanto, do lado de fora, uma quadrilha assalta."
,"2":"E nem lhes passa pela cabeça que Eu Me vou lembrar de toda a sua maldade. Agora mesmo os rodeiam os seus crimes, que estão todos bem diante dos meus olhos."
,"3":"Com a sua maldade alegram o rei, e com as suas mentiras divertem os chefes."
,"4":"São todos adúlteros, ardem como forno aceso, quando o padeiro atiça o fogo, e depois de amassar o pão espera que ele cresça."
,"5":"Na festa do nosso rei, os chefes afogam-no no calor do vinho e ele compromete-se com os rebeldes."
,"6":"A cabeça deles está cheia de embustes: é como um forno. De noite, a sua ira dorme, de manhã incendeia-se como uma fogueira."
,"7":"Todos eles ficam acesos como um forno e acabam por queimar os seus próprios governantes. Foi assim que caíram todos os seus reis e não há ninguém que Me invoque."
,"8":"Efraim mistura-se com os povos. Efraim é um bolo que não foi virado."
,"9":"Os estrangeiros fazem-lhe perder a força, e ele nem se apercebe; os seus cabelos brancos vão aumentando, e ele não nota."
,"10":"O orgulho de Israel testemunha contra si mesmo, e nem assim se convertem a Javé, seu Deus; apesar de tudo, não O procuram."
,"11":"Efraim é uma pomba ingénua, sem inteligência: pedem ajuda ao Egipto, vão à Assíria."
,"12":"Enquanto forem, atirarei sobre eles a minha rede, e cairão nela como passarinhos, castigando-os pela sua maldade."
,"13":"Ai deles, fugiram de Mim! Infelizes, por se revoltarem contra Mim! Eu libertá-los-ia, mas eles dizem mentiras contra Mim."
,"14":"Eles não clamam por Mim de coração, quando gemem nos seus leitos. São devotos de Dagã e Tiros, e afastam-se de Mim."
,"15":"Fui Eu que lhes renovei as forças, mas eles tramam contra Mim."
,"16":"Não se voltam para o alto, são como arco frouxo. Os seus príncipes morrerão pela espada, por causa do veneno das suas línguas. E isso é motivo de zombaria na terra do Egipto."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Leva a trombeta à boca! A desgraça mergulha como uma águia sobre a casa de Javé. Eles quebraram a minha aliança, rejeitaram a minha lei."
,"2":"Eles gritam: «Deus de Israel, nós conhecemos-Te!»"
,"3":"No entanto, Israel recusou o bem, e o inimigo persegui-lo-á."
,"4":"Nomearam reis sem a minha aprovação, escolheram príncipes sem o meu conhecimento; com prata e ouro fizeram ídolos para a sua perdição."
,"5":"Eu odeio o teu bezerro, ó Samaria; a minha ira inflamou-se contra ele. Até quando sereis incapazes de inocência, ó filhos de Israel?"
,"6":"Esse bezerro foi fabricado por um escultor; ele não é Deus. O bezerro da Samaria será feito em pedaços."
,"7":"Semeiam ventos, colherão tempestades; caule sem espiga não pode dar farinha e, mesmo que desse, os estrangeiros é que a iriam comer."
,"8":"Israel foi devorado. Entre as nações é objecto sem valor."
,"9":"Quando foram pedir socorro à Assíria, então Efraim, jumento solitário, tentou contratar amantes para si."
,"10":"Mesmo que os contratem dentre as nações, Eu agora os reunirei, e eles tremerão sob o peso do rei soberano."
,"11":"Efraim multiplicou os seus altares para pecar; só para pecar lhe serviram."
,"12":"Dei-lhe muitas leis, mas foram consideradas como coisa estranha."
,"13":"Ainda que ofereçam sacrifícios e comam a carne, não agradarão a Javé. Ele lembrar-Se-á das suas culpas, castigará os seus pecados e fá-los-á voltar para o Egipto."
,"14":"Israel esqueceu-se de Deus, seu criador, e passou a construir palácios. Judá, por sua vez, construiu fortalezas. Pois Eu deitarei fogo às cidades fortificadas e queimarei todos os seus quartéis."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Não te alegres, Israel, não faças festa como os outros povos. Traindo o teu Deus, agiste como uma prostituta. Gostavas de receber a paga de prostituta em qualquer eira de trigo."
,"2":"Mas a eira e o lagar de pisar uvas já não lhes vão garantir o alimento e até o vinho lhes faltará."
,"3":"Eles já não habitarão na terra de Javé; pelo contrário, Efraim voltará para o Egipto ou comerão coisas impuras na Assíria."
,"4":"Não farão libações de vinho a Javé, nem Lhe oferecerão os seus sacrifícios. O seu pão será como um pão de luto: quem dele come é considerado impuro. O seu pão só servirá para matar a fome, não poderá ser oferecido no Templo de Javé."
,"5":"Que fareis nos dias da solenidade, nos dias da festa de Javé?"
,"6":"Pois, se escapardes à catástrofe, o Egipto recolher-vos-á e Mênfis sepultar-vos-á. O mato será dono dos teus tesouros de prata; os espinhos crescerão nas tuas tendas."
,"7":"Chegaram os dias do castigo, chegou a hora do acerto de contas! Que Israel o saiba! (O profeta é um louco, o homem inspirado é um tolo). Tudo por causa da grande falta que cometeste, e pela grave ofensa que fizeste."
,"8":"O profeta em união com o seu Deus é a sentinela de Efraim, mas encontra armadilhas em todos os seus caminhos e até na casa do seu Deus encontra hostilidade."
,"9":"Eles corromperam-se profundamente, como nos dias de Gabaá. Deus, porém, lembrar-Se-á das suas iniquidades e castigará os seus pecados."
,"10":"Encontrei Israel como cachos de uvas no deserto, descobri os seus pais como figos temporões, mas eles foram até Baal Fegor, consagraram-se à Vergonha e tornaram-se nojentos como as coisas de que gostavam."
,"11":"A honra de Efraim voará como um pássaro. Não haverá nascimento, nem gravidez, nem concepção."
,"12":"Ainda que criem filhos, deixá-los-ei sem descendência. Ai deles, quando Eu os abandonar!"
,"13":"Eu vi que Efraim cria os filhos para a caça em lugares verdejantes. Mas Efraim entregará os filhos ao carrasco."
,"14":"Dá-lhes, Javé. O que lhes darás? Dá-lhes ventres estéreis e peitos secos."
,"15":"Toda a maldade apareceu em Guilgal. Foi ali que comecei a detestá-los. Pela maldade que eles põem em tudo o que fazem, Eu expulsá-los-ei da minha casa. Não vou manifestar-lhes o meu carinho, pois os seus chefes são todos desobedientes."
,"16":"Efraim está ferido, as suas raízes já secaram; nunca mais dará mais frutos. E, mesmo que ainda venham a ter filhos, eu farei morrer o querido fruto do seu ventre."
,"17":"O meu Deus vai rejeitá-los, porque não Lhe obedeceram; andarão errantes entre as nações."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Israel era uma parreira exuberante que dava uvas com fartura. Quanto mais frutos produzia, mais multiplicava os seus altares; quanto mais rico se tornava o país, mais os monumentos pagãos enriqueciam."
,"2":"O seu coração está dividido. Mas, agora, vão pagar: o próprio Deus derrubará os seus altares e arrasará os seus monumentos pagãos."
,"3":"Então eles vão dizer: «Nós não temos um rei, porque não tememos Javé. Mesmo que tivéssemos um rei, o que poderia ele fazer por nós?»"
,"4":"Fazem discursos, falsas promessas, assinam acordos e, enquanto isso, crescem os processos como erva venenosa nos sulcos dos campos."
,"5":"Os moradores de Samaria tremem por causa do bezerro de Bet-Áven. O povo e o sacerdote fazem luto pelo seu deus; e lamentam-se porque a sua honra foi para o exílio."
,"6":"A sua honra será levada para a Assíria, como tributo ao grande rei. Efraim terá vergonha e Israel envergonhar-se-á do seu ídolo."
,"7":"Samaria desaparece com o seu rei, como um ramo arrastado pela água."
,"8":"Serão destruídos os lugares altos da idolatria, o pecado de Israel. Espinhos e mato crescerão sobre os seus altares. Então eles gritarão às montanhas: «Cobri-nos»; e às colinas: «Caí sobre nós»."
,"9":"Desde os dias de Gabaá tens pecado, ó Israel! Eles lá permaneceram. Pensas que a guerra contra os filhos da injustiça não os atingirá em Gabaá?"
,"10":"Eu mesmo vou castigá-los. Os povos unir-se-ão em guerra contra eles para os punirem pelo seu enorme pecado."
,"11":"Efraim é uma novilha mansa, que gosta de pisar o trigo na eira, mas Eu farei passar o jugo sobre o seu belo pescoço. Atrelarei Efraim para lavrar e Jacob para gradear a terra."
,"12":"Semeai sementes de justiça e colhei o fruto do amor. Cultivai um campo novo, porque é tempo de procurar Javé, até que Ele venha e faça chover sobre vós a justiça."
,"13":"Vós cultivastes a impiedade e por isso colhestes a injustiça e comestes o fruto da mentira. Porque confiaste nos teus carros e na multidão dos teus guerreiros,"
,"14":"um clamor de guerra levantar-se-á contra as tuas cidades, e as tuas fortalezas serão todas destruídas. Como Sálmana arrasou Bet-Arbel, no dia da guerra, em que a mãe foi esmagada sobre os seus filhos,"
,"15":"assim sereis tratados, casa de Israel, por causa da vossa imensa maldade. Ao amanhecer, o rei de Israel será totalmente destruído."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Quando Israel era menino, Eu amei-o. Do Egipto chamei o meu filho;"
,"2":"e no entanto, quanto mais Eu os chamava, mais eles se afastavam de Mim: ofereciam sacrifícios aos baals, queimavam incenso aos ídolos."
,"3":"E não há dúvida, fui Eu que ensinei Efraim a andar, segurando-o pela mão. Mas eles não perceberam que era Eu quem cuidava deles."
,"4":"Eu atraí-os com laços de bondade, com laços de amor. Fazia com eles como quem levanta até ao rosto uma criança; para lhes dar de comer, baixava-Me até eles."
,"5":"Voltarão para a terra do Egipto, a Assíria será o seu rei, porque não quiseram converter-se."
,"6":"A espada devastar-lhes-á as cidades, exterminará os seus filhos e demolirá as suas fortalezas."
,"7":"O meu povo é difícil de se converter: é chamado a olhar para o alto, mas ninguém levanta os olhos."
,"8":"Como poderia Eu abandonar-te, Efraim? Como poderia entregar-te a outros, Israel? Será que Eu poderia tratar-te como a Adama? Eu poderia tratar-te como a Seboim? O meu coração salta no meu peito, as minhas entranhas comovem-se dentro de Mim."
,"9":"Não Me deixarei levar pelo ardor da minha ira, não vou destruir Efraim. Eu sou Deus, e não um homem. Eu sou o Santo no meio de ti, e não um inimigo devastador."
,"10":"Eles seguirão a Javé. E Javé rugirá como um leão. E quando Ele rugir, os seus filhos virão do Ocidente,"
,"11":"lá do Egipto; eles virão voando como pássaros; como pombos, eles virão do país da Assíria. Então Eu fá-los-ei morar nas suas casas - oráculo de Javé."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Efraim cerca-Me de mentiras, a casa de Israel rodeia-Me de falsidades. (Mas Judá ainda está com Deus e é fiel ao Santo)."
,"2":"Efraim alimenta-se de vento: anda sempre a procurar os ventos do Oriente e só aumenta a mentira e a violência. Fazem aliança com a Assíria, levam azeite para o Egipto."
,"3":"Javé move processo contra Israel, tratará Jacob conforme a sua conduta, e castigá-lo-á conforme as suas acções."
,"4":"No ventre da mãe, Jacob superou o seu irmão e como adulto lutou com Deus;"
,"5":"lutou com o anjo e venceu-o; chorou e pediu piedade. Reencontrou Deus em Betel onde falou com Ele."
,"6":"Javé, Deus dos exércitos, o seu Nome é Javé."
,"7":"Quanto a ti, converte-te ao teu Deus. Observa o amor e o direito e confia sempre no teu Deus."
,"8":"Canaã tem nas mãos balanças falsas; gosta de enganar."
,"9":"Efraim disse: «Eu sou rico, juntei uma fortuna!» Mas nada restará de tudo o que ganhou, por causa da falta que cometeu."
,"10":"Eu sou Javé, teu Deus, desde a terra do Egipto. Eu far-te-ei morar novamente em tendas, como nos dias do Encontro."
,"11":"Falarei aos profetas, multiplicarei as visões e, pela boca dos profetas, falarei em parábolas."
,"12":"Se Galaad é iniquidade, eles são apenas mentira; em Guilgal sacrificaram touros e por isso os seus altares serão como montes de pedras nos sulcos dos campos."
,"13":"Jacob fugiu para os campos de Aram, Israel serviu por causa de uma mulher; para adquirir uma esposa, foi guardador de rebanhos."
,"14":"Por meio de um profeta, Javé tirou Israel do Egipto e protegeu-o."
,"15":"Efraim irritou Javé amargamente, e o seu Senhor descarregará sobre ele o sangue derramado e retribuir-lhe-á o ultraje."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Quando Efraim falava, era um terror, era o príncipe em Israel, mas depois começou a pecar com Baal e decaiu."
,"2":"E ainda agora, continuam a pecar: com a sua prata fazem estátuas fundidas, ídolos que eles inventam, todos obra de artesãos. Depois dizem: «Oferecei-lhes sacrifícios», e beijam bezerros."
,"3":"Por isso, tornar-se-ão como a neblina da manhã, como o orvalho que logo se evapora; ou como palha que o vento leva da eira ou fumo que sai pela janela."
,"4":"Eu sou Javé, o teu Deus, desde a terra do Egipto. Não deves conhecer outro Deus além de Mim e nem outro salvador além de Mim."
,"5":"Eu conheci-te no deserto, em lugares secos."
,"6":"Eu apascentei-os e eles saciaram-se; ficaram saciados, e o seu coração encheu-se de orgulho; e, por isso, esqueceram-se de Mim."
,"7":"Eu serei para eles como um leão, e como uma pantera os espiarei no caminho;"
,"8":"vou atacá-los como a ursa a quem roubaram as crias, e vou rasgar-lhes o peito, devorando-os como uma leoa, e as feras vão despedaçá-los."
,"9":"Eu te destruirei, Israel, e quem poderá socorrer-te?"
,"10":"Onde está agora o teu rei, para que te possa salvar e onde estão os juízes das tuas cidades? Tu pediste-Me: «Dá-me um rei e príncipes»."
,"11":"Na minha ira dei-te um rei e retiro-to no meu furor."
,"12":"A culpa de Efraim está guardada, o seu pecado está conservado."
,"13":"Chegam-lhe as dores do parto, mas o filho é um imbecil porque, ao chegar a hora de nascer, ele não sai do seio materno."
,"14":"Será que deveria resgatá-los das garras da mansão dos mortos? Deveria Eu livrá-los da morte? Onde está, ó morte, a tua praga? Onde está, ó mansão dos mortos, a tua peste? A compaixão foge do meu olhar."
,"15":"Mesmo que Efraim prospere entre os seus irmãos, um vento virá do Oriente, um vento de Javé subirá do deserto, para secar a sua mina de água e esgotar a sua fonte. Ele vem para levar o tesouro e todos os objectos de valor."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Samaria vai pagar, pois revoltou-se contra o seu Deus: cairão sob a espada, os seus filhos serão esmagados e as suas mulheres grávidas."
,"2":"Israel, volta para Javé, teu Deus, pois caíste por causa dos teus pecados."
,"3":"Preparai as palavras e convertei-vos a Javé dizendo-Lhe: «Perdoa toda a nossa culpa, aceita o que é bom e oferecer-Te-emos o fruto dos nossos lábios."
,"4":"Não é a Assíria que nos salvará, não montaremos cavalos, jamais chamaremos novamente nosso Deus a um objecto feito pelas nossas mãos, pois é em Ti, só junto de Ti, que o órfão encontra compaixão»."
,"5":"Eu vou curar a sua apostasia, vou amá-los de todo o coração, pois a minha ira apartou-se deles."
,"6":"Serei como o orvalho para Israel; ele florescerá como um lírio e estenderá raízes como o cedro do Líbano."
,"7":"Os seus ramos crescerão, o seu esplendor será como o da oliveira e o seu perfume será como o do cedro do Líbano."
,"8":"Voltarão a sentar-se à minha sombra, farão reviver o trigo, florescerão como videiras e serão famosos como o vinho do Líbano."
,"9":"Efraim, que tenho Eu ainda a ver com os ídolos? Sou Eu que tenho uma resposta e olho para ti. Sou como um cipreste frondoso: o teu fruto, é de Mim que ele nasce."
,"10":"Quem é sábio, entenda estas coisas; quem é inteligente que as compreenda, porque os caminhos de Javé são rectos; os justos caminham por eles e os maus neles tropeçam."
}`)

}
func PT_BS_LoadVNSOChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palavra de Javé que foi dirigida a Sofonias, filho de Cusi, filho de Godolias, filho de Amarias, filho de Ezequias, no tempo de Josias, filho de Amon, rei de Judá."
,"2":"Eu vou acabar com tudo o que existe sobre a face da Terra - oráculo de Javé."
,"3":"Acabarei com homens e animais, acabarei com as aves do céu e os peixes do mar; destruirei os ímpios. Eliminarei os homens da face da terra - oráculo de Javé."
,"4":"Estenderei a minha mão contra Judá e contra todos os habitantes de Jerusalém. Eliminarei desse lugar o que sobrou do deus Baal, e o nome dos seus sacerdotes e seus ajudantes."
,"5":"Eliminarei aqueles que se ajoelham nos terraços para adorar o exército do céu; aqueles que adoram Javé, mas juram pelo deus Melcom;"
,"6":"aqueles que se afastam de Javé e que não procuram Javé, nem O consultam."
,"7":"Silêncio diante do Senhor Javé, pois está próximo o Dia de Javé! Javé marcou um sacrifício e já santificou os seus convidados."
,"8":"No dia do sacrifício de Javé, pedirei contas aos nobres e príncipes e a todos os que se vestem à moda estrangeira."
,"9":"Nesse dia, pedirei contas a todos os que saltam a soleira da porta do Templo e enchem de violências e fraudes o Templo do seu Senhor."
,"10":"Naquele dia - oráculo de Javé - um clamor levantar-se-á da porta dos Peixes, gemidos da Cidade Nova, e das colinas um grande lamento."
,"11":"Gemei, moradores do bairro de Mactes, porque acabaram os mercadores e foram eliminados todos os cambistas."
,"12":"Naquele tempo, revistarei Jerusalém com lanternas para pedir contas àqueles que, encharcados de vinho, dizem nos seus corações: «Javé não pode fazer nem bem nem mal»."
,"13":"As suas riquezas serão saqueadas, as suas casas serão demolidas. Construíram casas, mas não habitarão nelas; plantaram videiras, mas não beberão o seu vinho."
,"14":"Está próximo o grandioso Dia de Javé. Está próximo e avança com grande rapidez. Ouve-se um grito: «É amargo o Dia de Javé!» Nesse dia, o valente grita de medo. "
,"15":"Será um dia de cólera, esse dia; um dia de angústia e aflição, dia de devastação e ruína, dia de trevas e escuridão, dia nublado e tenebroso,"
,"16":"dia da trombeta e do grito de guerra contra os castelos fortificados e contra as torres da muralha."
,"17":"Atormentarei os homens, de tal modo que caminharão como cegos, porque pecaram contra Javé; o seu sangue derramar-se-á como pó e as suas vísceras como esterco."
,"18":"Nem a sua prata nem o seu ouro serão capazes de os livrar. No dia da cólera de Javé, Ele incendiará a terra inteira no fogo da sua indignação. Sim, Ele acabará por exterminar todos os habitantes da Terra."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Reuni-vos e juntai-vos, nação sem vergonha,"
,"2":"antes que vos espalhem como palha que desaparece num dia, antes que caia sobre vós o fogo da ira de Javé, antes que caia sobre vós o dia da ira de Javé."
,"3":"Procurai Javé, todos os pobres da terra; vós que obedeceis aos seus mandamentos, procurai a justiça, procurai a pobreza. Talvez, assim, acheis refúgio no dia da ira de Javé."
,"4":"Gaza será abandonada, Ascalon devastada, Azoto será expulsa em pleno meio-dia e Acaron será exterminada."
,"5":"Ai dos moradores da beira-mar, a nação dos cereteus! É contra vós esta palavra de Javé: Canaã, terra dos filisteus, Eu vou destruir-te, a ponto de não deixar em ti um habitante sequer."
,"6":"Serás transformada em abrigo de pastores e redil de ovelhas."
,"7":"Esta região vai pertencer ao resto da casa de Judá. Por aí eles vão pastar e à tarde vão repousar nas casas de Ascalon, pois Javé, seu Deus, visitá-los-á e reconduzi-los-á do exílio."
,"8":"Ouvi as ofensas dos moabitas, os desafios dos filhos de Amon, quando insultaram o meu povo, contando grandezas da sua terra."
,"9":"Por isso, juro por minha própria vida - oráculo de Javé dos exércitos, Deus de Israel - Moab será outra Sodoma, e os filhos de Amon serão outra Gomorra; serão como um campo de urtigas ou um poço de sal, um deserto para sempre. O resto do meu povo saqueá-los-á, e os sobreviventes da minha gente serão os seus herdeiros."
,"10":"Esse será o castigo da sua soberba, pois insultaram e desprezaram o povo de Javé dos exércitos."
,"11":"Javé mostrar-Se-á terrível contra eles, quando acabar com todos os deuses da terra. Então, as nações de todos os continentes adorá-l'O-ão, cada qual no seu próprio território."
,"12":"Até vós, etíopes, sereis trespassados pela minha espada."
,"13":"Javé vai estender a sua mão contra o Norte e exterminará a Assíria. Fará de Nínive um lugar abandonado, uma terra árida como o deserto."
,"14":"Rebanhos e toda a espécie de animais passarão a dormir no centro da cidade; até o pelicano e o ouriço passarão a noite no topo das colunas. A coruja piará à janela e o corvo na porta porque o madeiramento de cedro foi arrancado."
,"15":"Essa é a cidade alegre, que vivia em segurança, que dizia para si mesma: «Eu, e ninguém mais!» Agora tornou-se um lugar abandonado, esconderijo de animais. Todos os que passam por ela, assobiam e agitam a mão."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Ai de Jerusalém, a rebelde, a contaminada, a cidade opressora!"
,"2":"Cidade que não ouviu o apelo e não aceitou o aviso. Ela não confiou em Javé, nem se aproximou do seu Deus."
,"3":"Os seus chefes são como leões que rugem; os seus juízes são como lobos à tarde, que não comeram nada desde a manhã;"
,"4":"os seus profetas são uns fanfarrões, mestres de traição; os seus sacerdotes profanam as coisas santas e violam a lei de Deus."
,"5":"Mas no meio dela está Javé, que é o justo, que não pratica a injustiça. Todas as manhãs Ele dá a sua sentença; não há uma só manhã em que Ele deixe de comparecer. O criminoso, porém, não toma vergonha."
,"6":"Eu destruí nações inteiras: as suas torres de vigia foram destruídas, tornei desertas as suas ruas, sem nenhum transeunte. As suas cidades ficaram devastadas, sem ninguém, sem nenhum habitante."
,"7":"Eu pensava: «Talvez agora ela Me tema, aprenda a lição, e a sua casa não pereça quando Eu lhe pedir contas». Mas eles apressaram-se em perverter as suas acções."
,"8":"Por isso - oráculo de Javé - esperai pelo dia em que Eu me levantarei como acusador! Pois Eu decidi reunir as nações e aliar os reinos para despejar contra vós o meu furor, todo o ardor da minha ira. A Terra inteira será consumida pelo fogo do meu ciúme."
,"9":"Vou purificar os lábios dos povos, para que todos possam invocar o nome de Javé e servi-l'O de comum acordo."
,"10":"Os meus adoradores virão trazer-Me ofertas do outro lado dos rios da Etiópia."
,"11":"Naquele dia, não te envergonharás das acções com que Me ofendeste, porque vou tirar do meio de ti os teus soberbos fanfarrões, e não continuarás a orgulhar-te no meu santo monte."
,"12":"Deixarei em ti um povo pobre e fraco, um resto de Israel que se refugiará no nome de Javé."
,"13":"Não mais praticarão a injustiça, nem proferirão mentiras; não mais se encontrará em suas bocas uma língua mentirosa. Eles poderão pastorear e repousar, e ninguém os incomodará."
,"14":"Grita de contentamento, filha de Sião! Alegra-te, Israel! Alegra-te e rejubila de todo o coração, filha de Jerusalém!"
,"15":"Javé mudou a sentença que tinha pronunciado contra ti, eliminou o teu inimigo. Javé, o rei de Israel, está no meio de ti. Nunca mais verás a desgraça."
,"16":"Naquele dia, será dito a Jerusalém: Não tenhas medo, Sião! Não te acovardes!"
,"17":"Javé, teu Deus, o valente libertador, está no meio de ti. Por tua causa, Ele está contente e alegre e renova o seu amor por ti; está dançando de alegria por tua causa,"
,"18":"como em dias de festa. Afastarei o mal, para que não pese mais sobre ti o opróbrio. "
,"19":"Nesse tempo, agirei contra todos aqueles que te oprimem; salvarei os coxos e reunirei os dispersos. Dar-lhes-ei glória e fama na terra em que agora são desprezados."
,"20":"Naquele tempo, vou guiar-vos; quando vos reunir novamente, vou dar-vos glória e fama entre todos os povos da Terra, quando, a vossos olhos, Eu fizer regressar os cativos, diz Javé."
}`)

}
func PT_BS_LoadVNZAChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No oitavo mês do segundo ano de Dario, a palavra de Javé foi dirigida ao profeta Zacarias, filho de Baraquias, filho de Ado, com esta mensagem:"
,"2":"Javé irou-Se profundamente contra os vossos antepassados."
,"3":"Então deverás dizer ao povo de hoje: Assim diz Javé dos exércitos: Voltai para Mim - oráculo de Javé dos exércitos - e Eu voltarei para vós, diz Javé dos exércitos."
,"4":"Não façais como os vossos antepassados. Os profetas antigos chamavam a atenção deles, dizendo: «Assim diz Javé dos exércitos: Convertei-vos dos vossos caminhos e das vossas más acções». Mas eles não Me escutaram, nem Me deram atenção - oráculo de Javé."
,"5":"Onde estão os vossos antepassados? E os profetas ainda vivem?"
,"6":"Mas as minhas palavras e as ordens que dei aos meus servos, os profetas, não chegaram, porventura, aos vossos pais? Então eles converteram-se e disseram: «Javé dos exércitos aplicou-nos o castigo que tinha decidido aplicar-nos, conforme os nossos caminhos e as nossas acções»."
,"7":"No dia vinte e quatro do décimo primeiro mês do segundo ano de Dario, a palavra de Javé foi dirigida ao profeta Zacarias, filho de Baraquias, filho de Ado, na seguinte forma:"
,"8":"Tive uma visão durante a noite. Vi um homem montado num cavalo castanho, parado entre as murtas de um profundo vale. Atrás dele estavam cavalos castanhos, alazões pretos e brancos."
,"9":"Então perguntei: «Quem são eles, meu Senhor?» (O anjo que falava comigo respondeu: «Vou mostrar-te quem são eles»)."
,"10":"O homem parado no meio das murtas respondeu: «Estes são os que Javé enviou para percorrer a Terra»."
,"11":"Eles trouxeram a resposta ao anjo de Javé, que estava parado entre as murtas: «Acabámos de percorrer a Terra, e eis que toda ela repousa e está tranquila»."
,"12":"E o anjo de Javé perguntou: «Javé dos exércitos, até quando ficarás sem ter compaixão de Jerusalém e das outras cidades de Judá, contra as quais estás irado há já setenta anos?»"
,"13":"Javé respondeu ao anjo que falava comigo com palavras boas e consoladoras."
,"14":"Então o anjo de Javé que falava comigo ordenou: «Proclama: Assim diz Javé dos exércitos: Tenho ciúmes de Jerusalém e de Sião, um ciúme muito grande."
,"15":"E também estou muito irado contra as nações que vivem confiantes, pois quando Eu estava apenas um pouco irado elas continuaram a colaborar com o mal."
,"16":"Por isso, assim diz Javé: Eu volto-Me de novo para Jerusalém cheio de compaixão: o meu Templo será construído - oráculo de Javé dos exércitos - e o cordel de medir será estendido sobre Jerusalém."
,"17":"Proclama ainda: Assim diz Javé dos exércitos: as minhas cidades transbordarão novamente de bens, Javé de novo consolará Sião, e mais uma vez Ele vai escolher a cidade de Jerusalém»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Levantei os olhos e vi quatro chifres."
,"2":"Perguntei ao anjo que falava comigo: «Que significam estes chifres?» Ele respondeu: «São os chifres que dispersaram Judá, Israel e Jerusalém»."
,"3":"Depois Javé mostrou-me quatro ferreiros."
,"4":"Perguntei: «O que vêm eles fazer?» Ele respondeu: «(Estes são os chifres que dispersaram Judá, de tal modo que ninguém podia levantar a cabeça). Os ferreiros vieram para vos aterrorizar, para abater os chifres das nações que investem contra o país de Judá, a fim de o espalhar pelo mundo»."
,"5":"Levantei os olhos e vi um homem com o cordel de medir."
,"6":"Perguntei: «Aonde vais?» Ele respondeu: «Vou medir Jerusalém, para ver qual é a sua largura e comprimento»."
,"7":"Então o anjo que falava comigo deu um passo em frente, e veio ao seu encontro outro anjo que lhe disse:"
,"8":"«Corre, vai dizer àquele jovem que Jerusalém deve ficar sem muros, por causa da multidão de homens e animais que ela deverá acolher."
,"9":"Mas Eu serei para ela - oráculo de Javé - muralha de fogo ao seu redor e, no meio dela, Eu serei a sua glória»."
,"10":"Vamos, vamos! Fugi da Babilónia - oráculo de Javé - pois Eu dispersei-vos pelos quatro ventos - oráculo de Javé."
,"11":"Ai, filhos de Sião que morais na Babilónia, fugi!"
,"12":"Porque assim diz Javé dos exércitos, cuja glória me enviou às nações que vos roubaram: Quem vos fere, fere a pupila dos meus olhos."
,"13":"Pois Eu agito a mão contra eles, e serão despojo daqueles que eram seus escravos. Assim sabereis que foi Javé dos exércitos que me mandou."
,"14":"Rejubila e alegra-te, filha de Sião, pois Eu venho para morar no meio de ti - oráculo de Javé."
,"15":"Naquele dia, numerosas nações vão aderir a Javé e passarão a ser o meu povo. Eu virei morar no meio de ti, e tu saberás que foi Javé dos exércitos que me enviou a ti."
,"16":"Javé tomará Judá como sua porção na Terra Santa e tornará a escolher Jerusalém."
,"17":"Silêncio diante de Javé, criaturas todas, pois Ele levanta-Se na sua santa morada."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Pois Javé mostrou-me Josué, o chefe dos sacerdotes, parado à frente do anjo de Javé. E Satanás estava de pé, à direita de Josué, para o acusar."
,"2":"E o anjo disse a Satanás: «Que Javé te segure, Satanás, que Javé te segure, pois Ele escolheu Jerusalém. Esse aí não é, porventura, um tição tirado do fogo?»"
,"3":"Josué estava vestido com roupas sujas e parado diante do anjo."
,"4":"Então, o anjo disse aos que estavam de pé, à sua frente: «Tirai-lhe as roupas sujas». E disse a Josué: «Vê, eu tirei de cima de ti a tua culpa e revesti-te com roupas limpas»."
,"5":"E acrescentou: «Colocai-lhe na cabeça um turbante limpo». Então puseram-lhe na cabeça um turbante limpo e vestiram-no com roupas limpas. O anjo de Javé estava de pé"
,"6":"e disse solenemente a Josué:"
,"7":"«Assim diz Javé dos exércitos: Se andares nos meus caminhos e guardares os meus mandamentos, governarás o meu Templo e guardarás os meus átrios, e Eu dar-te-ei estes que estão aqui de pé."
,"8":"Ouve, pois, Josué, chefe dos sacerdotes, tu e os teus companheiros que estão sentados diante de ti, porque eles são homens de presságio: Eu faço vir o meu servo Germe."
,"9":"Aqui está a pedra que coloquei diante de Josué: sobre esta pedra há sete olhos. Eu mesmo gravarei nela uma inscrição - oráculo de Javé dos exércitos - e num só dia tirarei a maldade desta terra."
,"10":"Naquele dia - oráculo de Javé dos exércitos - cada um de vós poderá convidar o seu vizinho para debaixo da sua parreira e da sua figueira»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"O anjo que conversava comigo voltou a despertar-me, como se estivesse a acordar alguém do sono."
,"2":"Ele perguntou: «Que vês tu?» Respondi: «Vejo um candelabro todo de ouro, que tem na ponta um reservatório de azeite e sete lâmpadas nos sete bicos que há na extremidade."
,"3":"E junto dele vejo também duas oliveiras, uma à direita e outra à esquerda»."
,"4":"Então perguntei ao anjo que falava comigo: «Que significam estas coisas, meu Senhor?»"
,"5":"O anjo que falava comigo respondeu: «Tu não sabes o que significam estas coisas?» Respondi: «Não, meu Senhor»."
,"6a":"Então ele explicou-me:"
,"10b":"«As sete lâmpadas são os olhos de Javé que percorrem toda a Terra»."
,"11":"Eu perguntei-lhe: «Que significam as duas oliveiras, uma à direita e outra à esquerda do candelabro?»"
,"12":"E tornei a perguntar: «Que significam esses dois ramos de oliveira que vertem azeite dourado por dois bicos de ouro?»"
,"13":"Ele respondeu-me: «Tu não sabes o que significam estas coisas?» Eu respondi: «Não, meu Senhor»."
,"14":"Ele explicou-me: «São os dois homens ungidos que estão de pé diante do Senhor de toda a terra»."
,"6b":"Esta é a mensagem de Javé a Zorobabel: Não será com o poder nem com a força, será com o meu espírito, diz Javé dos exércitos."
,"7":"Quem és tu, grande montanha? Diante de Zorobabel, não passas de uma planície, de onde ele tira a primeira pedra aos gritos: «Graças a ela! Graças a ela!»"
,"8":"A palavra de Javé foi-me dirigida para explicar:"
,"9":"«As mãos de Zorobabel lançaram os fundamentos deste Templo; as suas mãos irão terminá-lo. Assim sabereis que foi Javé dos exércitos que me enviou a vós."
,"10a":"Pois, quem desprezou o dia de pequenos acontecimentos? Que eles se alegrem ao verem a pedra escolhida na mão de Zorobabel»."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Levantei novamente os olhos e vi um livro a voar."
,"2":"O anjo que falava comigo perguntou: «O que é que vês?» Respondi: «Vejo um livro que voa; tem uns dez metros de comprimento por cinco de largura»."
,"3":"E ele disse-me: «É a maldição que se espalha sobre a superfície de todo o país. E, assim como o livro, todo o ladrão será expulso daqui; e todo aquele que jura falso em meu Nome, será expulso daqui, tal como o livro."
,"4":"Eu espalharei essa maldição - oráculo de Javé dos exércitos - para que entre na casa do ladrão e na casa daquele que jura falso em meu nome. Ela vai estabelecer-se dentro dessas casas e destruir-lhes-á a madeira e a pedra»."
,"5":"O anjo que falava comigo aproximou-se e disse: «Levanta os olhos e vê o que é esta coisa que se aproxima»."
,"6":"Eu perguntei: «O que é?» Ele respondeu: «É uma vasilha que avança». E acrescentou: «É a maldade que está no país todo»."
,"7":"Ergueu-se a tampa de chumbo e havia dentro da vasilha uma mulher sentada."
,"8":"O anjo disse: «Ela é a maldade». Empurrou-a novamente para dentro da vasilha e fechou-a com a tampa de chumbo."
,"9":"Olhei de novo e vi: surgiam duas mulheres com asas ao vento. Tinham asas iguais às da cegonha. Elas levantaram a vasilha entre a terra e o céu."
,"10":"Eu perguntei ao anjo que me falava: «Para onde é que elas levam a vasilha?»"
,"11":"Ele respondeu: «Para o templo que lhe vão construir na terra de Senaar; vão fazer-lhe um pedestal e colocá-la em cima»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Levantei os olhos novamente e vi quatro carros. Saíam do meio de duas montanhas, e as montanhas eram de bronze."
,"2":"O primeiro carro tinha cavalos vermelhos; o segundo carro, cavalos pretos;"
,"3":"o terceiro carro, cavalos brancos; e o quarto carro, cavalos malhados. Eram cavalos vigorosos."
,"4":"Então perguntei ao anjo que falava comigo: «Quem são eles, meu Senhor?»"
,"5":"O anjo respondeu-me: «São os quatro ventos do céu, que saem depois de ter estado diante do Senhor de toda da Terra."
,"6":"O carro de cavalos pretos vai para o lado do Norte, os cavalos brancos vão atrás deles, e os cavalos malhados vão para o Sul»."
,"7":"Fogosos, eles estavam impacientes por percorrer a Terra. E o anjo ordenou: «Ide percorrer a Terra». E eles percorreram a Terra."
,"8":"Ele chamou-me e disse: «Os que partiram para o Norte farão chegar o meu Espírito ao país do Norte»."
,"9":"A palavra de Javé foi-me dirigida nestes termos:"
,"10":"«Recebe ouro e prata de alguns exilados que pertencem às famílias de Heldai, de Tobias e de Idaías, e vai até à casa de Josias, filho de Sofonias, que chegou da Babilónia."
,"11":"Toma ouro e prata, faz uma coroa e coloca-a na cabeça de Josué, filho de Josedec, chefe dos sacerdotes."
,"12":"Depois, diz-lhe o seguinte: Assim diz Javé dos exércitos: Aqui está um homem; o teu nome é Germe, e debaixo dele algo vai germinar. Ele construirá o Templo de Javé."
,"13":"Sim, ele construirá o Templo de Javé; ele vai receber a glória, sentar-se-á no seu trono. Um sacerdote estará ao seu lado e, entre os dois, haverá um conselho de paz."
,"14":"Para Heldai, Tobias, Idaías e para o filho de Sofonias, essa coroa será uma lembrança no Templo de Javé»."
,"15":"Eles virão de longe e construirão o Templo de Javé; então, sabereis que foi Javé dos exércitos quem me enviou a vós. E isto acontecerá se obedecerdes a Javé, vosso Deus."
}`)
	CurrentBook.AddChapter(7, `{
"1":"No dia quatro do mês de Casleu, o nono mês, no ano quatro do rei Dario, a palavra de Javé foi dirigida a Zacarias."
,"2":"Betel enviou o alto funcionário do rei, Sarasar, com os seus homens, para suplicar a Javé"
,"3":"e perguntar aos sacerdotes do Templo de Javé dos exércitos e aos profetas: «Eu devo chorar no quinto mês e fazer jejum, como tenho feito há tantos anos?»"
,"4":"A palavra de Javé dos exércitos foi-me dirigida, dizendo:"
,"5":"«Diz a todo o povo da terra e também aos sacerdotes: Quando, durante setenta anos, jejuastes e batestes no peito no quinto e sétimo mês, acaso foi por Mim que jejuastes?"
,"6":"E quando comeis e bebeis, não é por vós mesmos que o fazeis?"
,"7":"E não foi isso que Javé disse pela boca dos seus profetas antigos, no tempo em que Jerusalém era habitada e vivia tranquila, ela e as outras cidades em volta, quando o Negueb e a Planície ainda eram habitadas?»"
,"8":"A palavra de Javé foi dirigida a Zacarias nestes termos:"
,"9":"«Assim diz Javé dos exércitos: Administrai fielmente a justiça, e cada qual trate com amor e compaixão o seu irmão."
,"10":"Não oprimais a viúva e o órfão, o estrangeiro e o pobre; e ninguém, no coração, trame o mal contra o seu irmão»."
,"11":"Eles, porém, não quiseram prestar atenção, voltaram-Me as costas e endureceram os ouvidos para não ouvir."
,"12":"Endureceram o coração para não ouvir a Lei e as palavras que Javé dos exércitos enviara pelo seu Espírito por intermédio dos profetas antigos. Tudo isto fez com que Javé dos exércitos ficasse com grande ira"
,"13":"e dissesse: «Visto que os chamei e eles não Me ouviram, agora também eles podem gritar que Eu não escutarei."
,"14":"Eu dispersei-os por todas as nações que não conheciam, e atrás deles a Terra ficou vazia, sem ninguém passar por ela. Eles transformaram num deserto uma terra deliciosa»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"A palavra de Javé dos exércitos foi-me dirigida nos seguintes termos:"
,"2":"«Assim diz Javé dos exércitos: Tenho muito ciúme de Sião; estou a ferver de ciúmes por sua causa."
,"3":"Assim diz Javé dos exércitos: Voltarei a Sião, habitarei no meio de ti, Jerusalém. Jerusalém será chamada Cidade Fiel, e a montanha de Javé dos exércitos terá o nome de Montanha Santa."
,"4":"Assim diz Javé dos exércitos: Velhos e velhas ainda se sentarão nas praças de Jerusalém, todos de bengala na mão por causa da sua muita idade."
,"5":"Mas em breve as praças da cidade ficarão cheias de meninos e meninas a brincar pelas ruas."
,"6":"Assim diz Javé dos exércitos: Se isto parece impossível aos olhos do resto deste povo, também Me será impossível a Mim naqueles dias? - oráculo de Javé dos exércitos."
,"7":"Assim diz Javé dos exércitos: Eu estou a libertar o meu povo dos países do Nascente e do Poente;"
,"8":"Eu vou fazê-los voltar e habitarão na cidade de Jerusalém. Então eles serão o meu povo e Eu serei o seu Deus, na fidelidade e na justiça."
,"9":"Assim diz Javé dos exércitos: Coragem!, vós que nestes dias ouvis estas palavras da boca dos profetas, no dia em que foram postos os alicerces para a construção do Templo de Javé dos exércitos."
,"10":"Antes destes dias, não havia pagamento nem pelo trabalho do homem nem pelo trabalho do animal; não se podia ir e vir tranquilamente, por causa do inimigo; Eu tinha-vos colocado todos uns contra os outros."
,"11":"Mas agora não vou ser para este resto do povo como fui nos tempos antigos - oráculo de Javé dos exércitos -"
,"12":"porque semeareis a paz: a vinha dará o seu fruto, a terra dará o seu produto, o céu dará o seu orvalho. Darei tudo isto como herança ao resto deste povo."
,"13":"Então, da mesma forma como fostes uma maldição entre as nações, casa de Judá e de Israel, agora Eu vos salvarei, e sereis uma bênção. Não tenhais medo. Coragem!"
,"14":"Assim diz Javé dos exércitos: Da mesma forma como planeei um castigo contra vós quando os vossos antepassados Me aborreceram - diz Javé dos exércitos - e Eu não Me arrependi,"
,"15":"assim também, nestes dias, Eu planearei a felicidade para Jerusalém e para a casa de Judá. Não tenhais medo!"
,"16":"Eis as coisas que deveis praticar: falai verdade uns aos outros; julgai com integridade nos vossos tribunais,"
,"17":"não trameis o mal contra o próximo; não ameis o falso testemunho. Pois Eu odeio todas estas coisas - oráculo de Javé»."
,"18":"A palavra de Javé dos exércitos foi-me dirigida, dizendo:"
,"19":"«Assim diz Javé dos exércitos: Os jejuns do quarto, quinto, sétimo e décimo mês converter-se-ão para a casa de Judá em contentamento e alegria, em felizes dias de festa. Mas amai a fidelidade e a paz."
,"20":"Assim diz Javé dos exércitos: «De novo virão povos e moradores das grandes cidades."
,"21":"Os moradores de uma cidade irão para outra, dizendo: 'Vamos aplacar a Javé; eu vou contigo visitar Javé dos exércitos'."
,"22":"Povos numerosos e nações poderosas virão à procura de Javé em Jerusalém, para aplacar Javé»."
,"23":"Assim diz Javé dos exércitos: Naqueles dias, dez homens de todas as línguas faladas pelas nações tomarão um judeu pela barra do manto, dizendo: 'Nós queremos ir convosco, pois ouvimos dizer que Deus está convosco'»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Oráculo. A palavra de Javé está na terra de Hadrac, e Damasco é a sua morada, porque a Javé pertencem a capital da Síria e todas as tribos de Israel;"
,"2":"e também Emat, que confina com ela, e (Tiro e) Sidónia, que tem muita sabedoria."
,"3":"Tiro construiu para si uma fortaleza e amontoou prata como areia e ouro como lama na rua."
,"4":"Apesar disso, Javé tomará a cidade, sepultará no mar a sua riqueza, e a cidade será devorada pelo fogo."
,"5":"Ascalon verá e ficará com medo. Gaza também tremerá bastante, e também Acaron, pois a sua confiança foi confundida. O rei de Gaza desaparecerá, e Ascalon ficará desabitada;"
,"6":"em Azoto habitará um bastardo; e Eu destruirei o orgulho dos filisteus."
,"7":"Tirar-lhe-ei o sangue da boca, arrancarei as abominações dentre os seus dentes. E eles também se tornarão um resto para o nosso Deus; e serão como uma família em Judá, e Acaron será tratado como um jebuseu."
,"8":"Armarei a minha tenda na linha da frente da minha casa contra aqueles que vão e vêm; o opressor não passará mais por lá, porque agora vi a sua miséria!"
,"9":"Dança de alegria, cidade de Sião; grita de alegria, cidade de Jerusalém! Eis que o teu Rei vem a ti: Ele é justo e vitorioso. Ele é pobre, vem montado num jumento, num jumentinho, filho de uma jumenta."
,"10":"Ele destruirá os carros de guerra de Efraim e os cavalos de Jerusalém; quebrará o arco de guerra. Anunciará paz a todas as nações, e o seu domínio irá de mar a mar, do rio Eufrates até aos confins da Terra."
,"11":"Quanto a ti, pelo sangue da tua aliança, libertarei os presos do poço sem água."
,"12":"Prisioneiros cheios de esperança, voltai para a fortaleza, pois hoje vos anuncio: «Eu te retribuirei o dobro»."
,"13":"Esticarei Judá como um arco, a flecha que Eu armo é Efraim; atiro os teus filhos, ó Sião, contra os filhos de Javã. Faço de ti uma espada valente."
,"14":"Javé aparecerá a lutar contra eles: as suas flechas voarão como raios. O Senhor Javé toca a sua trombeta e avança sobre as tempestades que vêm do Sul."
,"15":"Quem os protege é Javé dos exércitos. Eles devorarão, pisarão as pedras da funda, beberão o sangue dos inimigos como se fosse vinho; encher-se-ão como as bacias do sacrifício e ficarão ensopados como os cantos do altar."
,"16":"Naquele dia, Javé, seu Deus, salvará o seu povo como a um rebanho. E eles brilharão na sua terra como pedras de uma coroa."
,"17":"Que riqueza, que beleza! O trigo dará vigor aos jovens, e o vinho doce às donzelas."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Pedi a Javé as chuvas temporãs e tardias, pois é Javé que envia relâmpagos e chuva forte, dá o pão ao homem e a terra aos animais."
,"2":"Pois os instrumentos de adivinhação dão falsos oráculos, os videntes só vêem mentiras, contam sonhos sem fundamento e dão consolo sem valor: por isso, o povo anda errante, perdido, como ovelhas sem pastor."
,"3":"Contra os pastores se inflama a minha ira, e contra os bodes vou mandar o castigo. Javé dos exércitos visitará o seu rebanho, a casa de Judá, e vai fazer dela o seu valente cavalo de guerra."
,"4":"Ela será o seu ponto de apoio, dela vem o gancho que prende a tenda, e o arco de guerra; dela virão os capitães. Juntos,"
,"5":"serão como soldados que na batalha pisam a lama das estradas. Lutarão, porque Javé está com eles, mas aqueles que montam cavalos serão confundidos."
,"6":"Darei força à casa de Judá, darei vitória ao povo de José. Eu reconduzi-los-ei, porque tenho compaixão deles. E serão como se Eu não os tivesse rejeitado, porque sou Javé, o seu Deus, e responderei favoravelmente."
,"7":"Os de Efraim serão como um herói; alegres de coração, como tocados pelo vinho. Seus filhos verão tudo isto e ficarão contentes, e o seu coração dançará de alegria em Javé."
,"8":"Com simples assobio, vou reuni-los de novo, pois já os resgatei; e eles serão tão numerosos como antes."
,"9":"Vou semeá-los entre as nações, e de longe eles se lembrarão de Mim. Instruirão os seus filhos que voltarão depois."
,"10":"Fá-los-ei voltar da terra do Egipto, vou juntá-los novamente da Assíria; vou levá-los para a terra de Galaad e do Líbano, onde não haverá para eles lugar suficiente."
,"11":"Eles passarão pelo mar estreito (Javé ferirá as ondas do mar), e o leito do rio Nilo ficará seco. Então será derrubado o orgulho da Assíria e será afastado o ceptro do Egipto."
,"12":"Eu torná-los-ei heróis em Javé, e em seu Nome marcharão - oráculo de Javé."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Abre, ó Líbano, as tuas portas, para que o fogo devore os teus cedros."
,"2":"Chora, cipreste, porque o cedro caiu e as árvores majestosas foram abatidas. Chorai, carvalhos de Basã, porque a floresta fechada já foi cortada."
,"3":"Ouve-se o lamento dos pastores porque a sua riqueza foi destruída. Ouve-se o rugido dos leõezinhos porque foi abatido o orgulho do Jordão."
,"4":"Assim diz Javé, meu Deus: «Engorda as ovelhas destinadas para a matança."
,"5":"Aqueles que as compram matam-nas, e não são punidos; aqueles que as vendem, dizem: 'Javé seja louvado, pois fiquei rico'. E nenhum pastor fica com pena das ovelhas."
,"6":"Eu também já não perdoarei aos moradores desta terra - oráculo de Javé. Entregarei os homens uns nas mãos dos outros e nas mãos do seu rei. Eles acabarão com o país e Eu não livrarei ninguém das suas mãos»."
,"7":"Eu tornei-me pastor de um rebanho que vai para o matadouro - na realidade, os pobres do rebanho - e peguei em dois bastões. Dei a um o nome de Favor e ao outro chamei-o Laços. E continuei a ser pastor do rebanho."
,"8":"Depois, num mês, destruí três pastores. Perdi a paciência com as minhas ovelhas e também elas me detestaram."
,"9":"Então eu disse: «Não serei mais vosso pastor. A que estiver para morrer, que morra; a que estiver para desaparecer, que desapareça; e as que sobreviverem, que se devorem umas às outras»."
,"10":"Depois peguei no bastão chamado Favor e quebrei-o, para romper a aliança que eu tinha feito com os povos."
,"11":"A aliança foi rompida nesse dia, e assim os pobres do rebanho, que me serviam atentamente, reconheceram que nisso havia uma palavra de Javé."
,"12":"Então eu disse: «Se estais de acordo, dai-me o meu salário; se não, deixai». Então eles pesaram o dinheiro do meu salário: trinta siclos de prata."
,"13":"E Javé disse-me: «Envia ao fundidor este preço fabuloso com que fui avaliado por eles». Eu peguei nos trinta siclos de prata e mandei-os ao fundidor do Templo de Javé."
,"14":"Depois peguei no outro bastão, o Laços, e quebrei-o também, para acabar com a fraternidade entre Judá e Israel."
,"15":"Javé disse-me: Pega nos apetrechos de um pastor insensato,"
,"16":"pois farei aparecer neste país um pastor que não se preocupa com a ovelha desaparecida nem procura a que se extraviou, não trata da ovelha ferida nem sustenta a que está prenhe, come a carne das gordas e até lhes arranca as unhas."
,"17":"Ai do pastor que abandona o rebanho! Que a espada lhe fira o braço e fure o seu olho direito; que o seu braço fique totalmente seco, e o seu olho completamente cego."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Oráculo. Palavra de Javé a respeito de Israel - oráculo de Javé, que estende o céu, firma as bases da Terra e forma o espírito dentro do homem:"
,"2":"Eis que vou fazer de Jerusalém uma taça inebriante, para embriagar todos os povos dos arredores; e no cerco contra Jerusalém acontecerá o mesmo também a Judá."
,"3":"Então, nesse dia, farei de Jerusalém uma pedra pesada para todos os povos. Quem tentar levantá-la, ferir-se-á gravemente. Contra ela se reunirão todas as nações da Terra."
,"4":"Naquele dia - oráculo de Javé - encherei de confusão todos os cavalos e enlouquecerei os cavaleiros. Mas voltarei o meu olhar para a casa de Judá e cegarei toda a cavalaria dos exércitos dos povos."
,"5":"Então os chefes da casa de Judá pensarão: «A força dos habitantes de Jerusalém está em Javé dos exércitos, seu Deus»."
,"6":"Naquele dia, farei que os chefes de Judá sejam como um forno sobre a lenha ou como tocha acesa entre feixes de palha. Eles devorarão à direita e à esquerda todos os povos dos arredores. Jerusalém habitará novamente no seu lugar, isto é, em Jerusalém."
,"7":"Javé salvará primeiro as tendas de Judá, para que o orgulho da casa de David e o orgulho dos habitantes de Jerusalém não sejam maiores do que o orgulho do povo de Judá."
,"8":"Naquele dia, Javé estenderá o seu es-cudo para proteger os moradores de Jerusalém; nesse dia, o mais vacilante entre eles será como David; e a casa de David será como Deus, como anjo de Javé diante deles."
,"9":"Naquele dia, procurarei destruir todas as nações que vierem lutar contra Jerusalém."
,"10":"Derramarei um espírito de graça e súplica sobre a casa de David e sobre os moradores de Jerusalém, e eles olharão para Mim. Contemplarão aquele a quem trespassaram, chorarão por ele como se chora um filho único; vão chorá-lo amargamente, como se chora um primogénito."
,"11":"Naquele dia, a lamentação de Jerusalém será tão grande como a lamentação de Adad-Remon na planície de Meguidon."
,"12":"O país inteiro vai chorar, cada clã em separado. Assim: o clã da casa de David em separado, e separadamente as suas mulheres; o clã da casa de Natã à parte, e separadamente as suas mulheres;"
,"13":"o clã da casa de Levi à parte, e separadamente as suas mulheres; o clã da casa de Semei à parte, e separadamente as suas mulheres;"
,"14":"todos os outros clãs à parte, e as suas mulheres separadamente."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Naquele dia, estará à disposição da casa de David e dos habitantes de Jerusalém uma fonte para lavar o pecado e a impureza."
,"2":"Naquele dia - oráculo de Javé dos exércitos - eliminarei do país o nome dos ídolos, para que nunca mais sejam lembrados. Também expulsarei do país os profetas e o espírito de impureza."
,"3":"Se alguém profetizar novamente, o pai e a mãe que o geraram dir-lhe-ão: «Tu não ficarás vivo, porque proferiste mentiras em nome de Javé». O pai e a mãe que o geraram trespassá-lo-ão quando ele estiver a profetizar."
,"4":"Naquele dia, os profetas ficarão com vergonha das próprias visões e profecias, e não vestirão mais o manto de pêlos para mentirem."
,"5":"Dirão: «Eu não sou profeta; sou um trabalhador da terra, pois esta terra pertence-me desde a juventude»."
,"6":"E se lhe perguntarem: «E o que são essas cicatrizes no teu peito?», ele responderá: «São ferimentos que recebi na casa dos meus amigos!»"
,"7":"Espada, levanta-te contra o meu pastor e contra o homem da minha parentela - oráculo de Javé dos exércitos. Fere o pastor, para que as ovelhas se dispersem, pois estenderei a minha mão contra os pequenos."
,"8":"E acontecerá em toda a Terra - orá-culo de Javé - que dois terços serão eliminados e somente um terço restará."
,"9":"Farei essa terça parte passar pelo fogo, para a purificar como se purifica a prata, para a provar como se prova o ouro. Ela invocará o meu nome e Eu responderei. Eu direi: «Ela é o meu povo!» E ela responderá: «Javé é o meu Deus!»"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Eis que virá o dia de Javé, em que no meio de ti serão repartidos os teus despojos."
,"2":"Eu reunirei todas as nações para uma guerra contra Jerusalém. A cidade será tomada pelo inimigo; as casas serão saqueadas; as mulheres, violentadas; metade da cidade irá para o exílio, e apenas um resto do povo não será levado da cidade."
,"3":"Então Javé sairá para guerrear contra essas nações, como quando combate no dia da batalha."
,"4":"Nesse dia, os seus pés estarão no monte das Oliveiras, que fica em frente de Jerusalém, do lado do Nascente. O monte das Oliveiras vai rachar ao meio, formando um vale enorme no sentido do Nascente para o Poente. Metade do monte desviar-se-á para o Norte e a outra metade para o Sul."
,"5":"O vale de Hinom será enchido até Jasol; ele será obstruído como por ocasião do terremoto no tempo de Ozias, rei de Judá. Então virá Javé meu Deus acompanhado de todos os santos."
,"6":"Naquele dia, não haverá nem luz, nem frio, nem gelo."
,"7":"Será um dia único (que só Javé conhece). Não haverá dia e noite, mas ao entardecer a luz brilhará."
,"8":"Naquele dia, sairão águas vivas de Jerusalém. Metade correrá para o mar do lado Nascente e metade para o mar do lado Poente, tanto no Verão como no Inverno."
,"9":"Então Javé será o rei de toda a Terra. Naquele dia, Javé será único, e único será o seu Nome."
,"10":"Todo o país se transformará numa planície, desde Gaba até Remon do Negueb. Jerusalém será reconstruída e habitada embora ocupando o mesmo lugar, desde a porta de Benjamim até ao lugar da antiga porta, até à porta dos ângulos, desde a torre de Hananeel até aos lagares de vinho do rei."
,"11":"É aí que eles vão morar, e a cidade nunca mais será condenada à destruição; e assim, quem morar em Jerusalém estará sempre em segurança."
,"12":"Esta será a praga que Javé mandará contra os povos que combateram contra Jerusalém: enquanto estiverem vivos, Javé far-lhes-á apodrecer a carne; os seus olhos também apodrecerão dentro das órbitas e a língua apodrecerá dentro da boca."
,"15":"E essa mesma praga atingirá também os cavalos, potros, camelos, mulas e outros animais que estiverem no acampamento."
,"13":"Naquele dia, entre inimigos haverá um grande pânico provocado por Javé. Cada um vai segurar a mão do outro e a mão de um levantar-se-á contra a mão do outro."
,"14":"Judá, porém, lutará em Jerusalém. Juntar-se-ão os tesouros de todas as nações circunvizinhas: ouro, prata e roupas finas, tudo em grande quantidade."
,"16":"Os que restarem dessas nações, que tiverem marchado contra Jerusalém, deverão ir todos os anos adorar o Rei, Javé dos exércitos, e celebrar a festa das Tendas."
,"17":"As famílias da terra que não forem a Jerusalém adorar o Rei, Javé dos exércitos, ficarão sem chuva."
,"18":"Por exemplo: se a família do Egipto não quiser sair de casa e não vier, cairá sobre ele a praga com que Javé vai ferir as nações que não subirem para celebrar a festa das Tendas."
,"19":"Tal será o castigo para o pecado do Egipto e o castigo para todas as nações que não subirem para celebrar a festa das Tendas."
,"20":"Naquele dia, até nos guizos dos cavalos estará escrito: «Consagrado a Javé». As panelas do Templo de Javé serão como vasos de aspersão."
,"21":"Mais ainda: as panelas que houver em Jerusalém e em Judá serão consagradas a Javé dos exércitos; todos os que oferecem sacrifícios se servirão delas para cozinhar. Naquele dia não haverá mais comerciantes dentro do Templo de Javé dos exércitos."
}`)

}
func PT_BS_LoadVPDTChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palavra que Moisés dirigiu a todo o Israel, no outro lado do Jordão, isto é, no deserto ou na Arabá que está diante de Suf, entre Farã, Tofel, Labã, Haserot e Dizaab."
,"2":"São onze dias de marcha pelo caminho da serra de Seir, desde o Horeb até Cades Barne."
,"3":"No primeiro dia do décimo primeiro mês do ano quarenta, Moisés falou aos filhos de Israel, conforme tudo o que Javé lhe ordenara."
,"4":"Depois de ter vencido Seon, rei dos amorreus, que habitava em Hesebon, e Og, rei de Basã, que habitava em Astarot e Edrai,"
,"5":"no outro lado do Jordão, na terra de Moab, Moisés começou a expor esta lei, dizendo:"
,"6":"Javé nosso Deus disse-nos no Horeb: «Há já bastante tempo que estais nesta montanha."
,"7":"Começai a caminhar e ide até aos montes dos amorreus e até àqueles que habitam na Arabá, na região montanhosa, na Sefelá, no Negueb e no litoral. Ide para a terra dos cananeus e para o Líbano, até ao grande rio, o Eufrates."
,"8":"É esta a terra que Eu vos dei. Entrai para tomar posse da Terra que Javé prometeu dar aos vossos antepassados, a Abraão, Isaac e Jacob, e aos seus descendentes»."
,"9":"Naquele tempo falei-vos assim: «Eu sozinho não consigo tomar conta de vós."
,"10":"Javé vosso Deus multiplicou-vos, e hoje sois tão numerosos como as estrelas do céu."
,"11":"Que Javé, o Deus dos vossos antepassados, vos multiplique mil vezes mais, abençoando-vos como prometeu."
,"12":"Como poderia eu, sozinho, levar o peso, a carga e os vossos processos?"
,"13":"Escolhei homens sábios, inteligentes e competentes de cada uma das tribos, e eu constituí-los-ei vossos chefes»."
,"14":"Vós respondestes-me: «O que nos propões é bom»."
,"15":"Tomei, então, os chefes das vossas tribos, homens sábios e competentes, e constituí-os vossos chefes: para cada tribo constituí chefes de mil, de cem, de cinquenta e de dez, e também oficiais de justiça para as tribos."
,"16":"Ao mesmo tempo, ordenei aos vossos juízes: «Escutai os vossos irmãos e fazei justiça entre um homem e o seu irmão ou imigrante que mora com ele."
,"17":"Não façais acepção de pessoas no julgamento: escutai de maneira igual o pequeno e o grande. Não tenhais medo de ninguém, porque a sentença vem de Deus. Se a causa for muito difícil para vós, apresentai-ma, e eu a resolverei»."
,"18":"Naquela ocasião ordenei tudo o que devíeis fazer."
,"19":"Partimos do Horeb e caminhámos através de todo aquele deserto grande e terrível, que vós bem conheceis. Fomos em direcção à serra dos amorreus, como Javé nosso Deus nos havia ordenado, e chegámos a Cades Barne."
,"20":"Então eu disse-vos: «Chegastes à serra dos amorreus, que Javé nosso Deus nos dará."
,"21":"Vede! Javé, vosso Deus, entrega-vos esta Terra: subi para a possuir, como vos falou Javé, Deus dos vossos antepassados. Não tenhais medo nem vos acovardeis»."
,"22":"Mas viestes todos ter comigo e dissestes: «Vamos mandar homens à nossa frente, para que explorem a região e nos informem qual é o caminho que deveremos seguir e em que cidade poderemos entrar»."
,"23":"Gostei da proposta, de modo que tomei doze dos vossos homens, um de cada tribo."
,"24":"Eles partiram, subiram a serra, foram até ao vale do Cacho e exploraram-no."
,"25":"Tomaram amostras de frutas da região e trouxeram-nas, relatando o seguinte: «A Terra que Javé nosso Deus nos vai dar é boa»."
,"26":"Vós, porém, não quisestes subir e revoltastes-vos contra a ordem de Javé vosso Deus."
,"27":"Começastes a murmurar nas vossas tendas: «Javé odeia-nos. Ele fez-nos sair do Egipto, para nos entregar na mão dos amorreus e nos exterminar."
,"28":"Para onde iremos? Os nossos irmãos desencorajaram-nos dizendo: 'É um povo numeroso e de estatura mais alta do que a nossa! As cidades são grandes e fortificadas até ao céu! Vimos lá descendentes dos enacim'»."
,"29":"Eu dizia-vos: «Não fiqueis aterrorizados nem tenhais medo deles."
,"30":"Javé vosso Deus irá à vossa frente. Ele combaterá por vós, como já fez no Egipto diante dos vossos olhos»."
,"31":"No deserto, vistes também que Javé vosso Deus vos conduziu, como o homem conduz o seu filho, durante todo o caminho que percorrestes, até chegar a este lugar."
,"32":"Apesar disso, ninguém de vós confiava em Javé vosso Deus."
,"33":"Ele ia à vossa frente, procurando um lugar para o acampamento: durante a noite, por meio do fogo, para que pudésseis ver o caminho, e na nuvem durante o dia."
,"34":"Ouvindo o que dizíeis, Javé ficou furioso e jurou:"
,"35":"«Nenhum dos homens desta geração perversa verá a Terra boa que Eu jurei dar aos vossos antepassados,"
,"36":"excepto Caleb, filho de Jefoné. Ele vê-la-á, pois vou dar-lhe a terra por onde ele passou, e também a seus filhos, pois ele seguiu a Javé sem reservas»."
,"37":"Por causa de vós, Javé também ficou furioso contra mim, e disse: «Também tu não entrarás lá."
,"38":"Josué, filho de Nun, é que lá entrará. Encoraja-o, pois ele é que fará Israel tomar posse da terra."
,"39":"Os vossos filhos, porém, dos quais dizíeis que seriam tomados como presa, os vossos filhos que ainda não sabem distinguir entre o bem e o mal, esses é que lá vão entrar. Entregar-lhes-ei a Terra, e eles possuí-la-ão."
,"40":"Quanto a vós, voltai para trás, segui para o deserto, em direcção ao Mar Vermelho»."
,"41":"Vós, porém, respondestes-me: «Pecámos contra Javé nosso Deus. Vamos subir para lutar, como Javé nosso Deus nos ordenou». Cada um de vós pegou em armas de guerra, como se fosse coisa fácil subir a serra."
,"42":"Então Javé disse-me: «Diz-lhes que não subam nem lutem, porque Eu não estou com eles, e o inimigo derrotá-los-á»."
,"43":"Eu avisei-vos, mas vós não me ouvistes, revoltando-vos contra a ordem de Javé. E subistes temerariamente em direcção à serra."
,"44":"O povo amorreu, que habitava a serra, saiu ao vosso encontro, perseguiu-vos como abelhas, e derrotou-vos desde Seir até Horma."
,"45":"Vós voltastes a chorar até à presença de Javé. No entanto, Javé não ouviu o vosso clamor, nem vos deu atenção."
,"46":"Por isso tivestes que ficar muito tempo a viver em Cades."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Então demos a volta e partimos para o deserto a caminho do Mar Vermelho, como Javé me havia ordenado. Durante muitos dias, contornámos a serra de Seir."
,"2":"Então Javé disse-me:"
,"3":"«Há muito tempo que andais à volta desta região montanhosa. Dirigi-vos para o Norte."
,"4":"Ordena ao povo: 'Estais a atravessar a fronteira dos vossos irmãos, os filhos de Esaú, que habitam em Seir. Eles têm medo de vós e, por isso, tende muito cuidado:"
,"5":"não os ataqueis, porque não vos darei nada da sua terra, nem sequer um palmo do seu território: foi a Esaú que Eu dei a propriedade da serra de Seir."
,"6":"Comprar-lhes-eis alimento para comer e água para beber,"
,"7":"porque Javé teu Deus te abençoou em todos os trabalhos das tuas mãos. Ele acompanhou-te na caminhada por esse grande deserto. Durante quarenta anos Javé teu Deus esteve contigo e nada te faltou'."
,"8":"Cruzámos o território dos nossos irmãos, os filhos de Esaú, que habitam em Seir, e passámos pelo caminho da Arabá, de Elat e de Asiongaber. Depois voltámos, tomando o caminho do deserto de Moab."
,"9":"Javé, então, disse-me: «Não ataques Moab e não o provoques para a luta, pois nada te darei do seu território. Eu dei Ar como propriedade aos filhos de Lot."
,"10":"Antigamente os emim habitavam ali; eram um povo grande, numeroso e de alta estatura, como os enacim."
,"11":"Eram considerados como os rafaim, e como os enacim; os moabitas, porém, chamam-lhes emim."
,"12":"Em Seir habitavam outrora os horreus; os filhos de Esaú, porém, desalojaram-nos e exterminaram-nos, ocupando o seu lugar, tal como Israel fez para tomar posse da terra que Javé lhe havia dado."
,"13":"Agora levantai acampamento, e atravessai o rio Zared». Atravessámos, então, o rio Zared. "
,"14":"De Cades Barne até atravessar o rio Zared, caminhámos durante trinta e oito anos, até que desapareceu do acampamento toda a geração de guerreiros, como Javé lhes tinha jurado."
,"15":"A mão de Javé estava contra eles, fazendo-os desaparecer do acampamento até à sua completa extinção."
,"16":"Quando morreram todos os guerreiros do povo,"
,"17":"Javé disse-me:"
,"18":"«Hoje vais atravessar Ar, nas fronteiras de Moab,"
,"19":"e vais aproximar-te dos filhos de Amon: não os ataques e não os provoques, pois nada te darei da terra dos filhos de Amon. Foi aos filhos de Lot que Eu a dei como propriedade."
,"20":"Era considerada terra dos rafaim; antigamente os rafaim habitavam nela, e os amonitas chamavam-lhes zomzomim."
,"21":"Era um povo grande e numeroso, de estatura alta como os enacim. Javé, porém, aniquilou-os, e os amonitas desalojaram-nos e ocuparam o seu lugar."
,"22":"Javé tinha feito o mesmo pelos filhos de Esaú, que habitavam em Seir, porque perseguiram os horreus diante deles e expulsaram-nos, ocupando o seu lugar até ao dia de hoje."
,"23":"Quanto aos aveus, que habitavam nos campos até Gaza, os caftorim saíram de Cáftor e exterminaram-nos, habitando depois no seu lugar."
,"24":"Vamos! Levantai o acampamento e atravessai o rio Arnon. Vou entregar nas vossas mãos o amorreu Seon, rei de Hesebon, com o seu país. Começa a conquista, provoca-o para a luta."
,"25":"A partir de hoje Eu começo a espalhar o terror e o medo de ti entre os povos que existem debaixo do céu. Eles ouvirão a vossa fama, tremerão de medo diante de vós e desfalecerão»."
,"26":"Do deserto de Cademot enviei mensageiros a Seon, rei de Hesebon, com esta proposta de paz:"
,"27":"«Deixa-me passar pelo teu território. Seguirei pela estrada, sem me desviar para a direita nem para a esquerda."
,"28":"Pagar-te-emos a comida que nos deres e a água que bebermos. Deixa-nos atravessar a pé,"
,"29":"como nos fizeram os descendentes de Esaú que habitavam em Seir, e os moabitas que habitam em Ar, até que atravessemos o rio Jordão para entrar na terra que Javé nosso Deus nos vai dar»."
,"30":"Seon, rei de Hesebon, não permitiu que passássemos pelo seu território. Javé Deus tornou obstinado o seu espírito, e endureceu-lhe o coração, para o entregar nas vossas mãos, como de facto sucedeu."
,"31":"Javé disse-me: «Vê! Estou a começar a entregar-te Seon com o seu território. Começa a conquistar o seu território»."
,"32":"Seon veio ao nosso encontro em Jasa, com todas as suas tropas."
,"33":"Javé nosso Deus entregou-no-lo, e nós vencemo-lo, e também os seus filhos e todo o seu exército."
,"34":"Tomámos posse de todas as suas cidades e sacrificámos cada uma delas, como anátema: homens, mulheres e crianças, sem deixar nenhum sobrevivente."
,"35":"Tomámos apenas o gado como despojos, e também o saque das cidades que conquistámos."
,"36":"Desde Aroer, que fica na margem do vale do Arnon, com a cidade que está dentro do vale, até Galaad, e diante de nós não houve cidade que resistisse: Javé nosso Deus entregou-no-las todas."
,"37":"Só não te aproximaste da terra dos amonitas, isto é, de toda a região do vale do rio Jaboc, e das cidades da serra, como Javé nosso Deus havia ordenado."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Então voltámo-nos e subimos em direcção a Basã. Og, rei de Basã, saiu ao nosso encontro com o seu exército para nos combater em Edrai."
,"2":"Javé disse-me: «Não tenhas medo dele, pois Eu entreguei-to com todo o seu exército e território. Trata-o como trataste Seon, o rei dos amorreus que habitava em Hesebon»."
,"3":"Javé nosso Deus entregou-nos também Og, rei de Basã, com todo o seu exército. Nós combatemo-los, até não restar nenhum sobrevivente."
,"4":"Conquistámos, então, todas as suas cidades, sem deixar nenhuma: ao todo, sessenta cidades na região de Argob, que era o reino de Og, em Basã."
,"5":"Todas essas cidades eram fortificadas com altas muralhas e portas com trancas; sem contar grande número de cidades dos ferezeus."
,"6":"Sacrificámo-las ao anátema, tal como havíamos feito com Seon, rei de Hesebon: destruímos cada cidade, com homens, mulheres e crianças."
,"7":"Contudo, ficámos com todo o gado e os despojos das cidades."
,"8":"Deste modo, conquistámos o território dos dois reis amorreus, no outro lado do Jordão, desde o rio Arnon até ao monte Hermon."
,"9":"(Os sidónios dão a Hermon o nome de Sarion; os amorreus, porém, chamam-lhe Sanir)."
,"10":"Tomámos todas as cidades do planalto, todo o Galaad e todo o Basã até Selca e Edrai, domínios de Og, rei de Basã."
,"11":"Og, rei de Basã, era o único sobrevivente dos rafaim. A sua cama é a cama de ferro que está em Rabá dos amonitas: tem quatro metros e meio de comprimento e dois metros de largura, segundo o padrão normal."
,"12":"Ocupámos, então, todo o território desde Aroer, que está na margem do rio Arnon. Aos rubenitas e aos gaditas dei metade da região montanhosa de Galaad, com as suas cidades."
,"13":"À meia tribo de Manassés dei o resto de Galaad e todo o Basã, que era o reino de Og. (Toda a região do Argob, todo o Basã se chamava terra dos rafaim."
,"14":"Jair, filho de Manassés, tomou a região de Argob, até à fronteira dos gessuritas e dos maacatitas. Em vez de Basã, foi dado a esses lugares o nome de Aldeias de Jair, nome que permanece até ao dia de hoje)."
,"15":"A Maquir dei Galaad."
,"16":"Aos rubenitas e aos gaditas dei o território que vai de Galaad até ao rio Arnon - o rio serve de fronteira - e até ao rio Jaboc, que é fronteira dos amonitas."
,"17":"A Arabá e o rio Jordão servem de fronteira, desde Quineret até ao mar de Arabá, o Mar Morto, nas encostas orientais do Fasga."
,"18":"Então dei-vos esta instrução: «Javé vosso Deus entregou-vos esta terra como propriedade. Todos os vossos guerreiros marcharão à frente dos seus irmãos, os filhos de Israel."
,"19":"Somente as mulheres, as crianças e o gado (sei que tendes muito gado) ficarão nas cidades que vos dei,"
,"20":"até que Javé conceda repouso aos vossos irmãos, como a vós, e também eles tomem posse da terra que Javé vai dar-lhes no outro lado do Jordão. Depois cada um voltará para a propriedade que vos dei»."
,"21":"Na mesma ocasião, dei a Josué a seguinte instrução: «Viste com os teus próprios olhos tudo o que Javé vosso Deus fez a esses dois reis. Javé vai fazer o mesmo a todos os reinos onde vais entrar."
,"22":"Não tenhas medo deles, pois quem combate em vosso favor é Javé, vosso Deus»."
,"23":"Então eu implorei a Javé:"
,"24":"«Javé, meu Senhor! Começaste a mostrar ao teu servo a tua grandeza e a força da tua mão. Qual é o deus, no céu e na terra, que pode realizar obras e feitos tão poderosos como os teus?"
,"25":"Deixa-me passar. Deixa-me ver a boa terra que está do outro lado do Jordão, essa bela montanha e o Líbano»."
,"26":"Javé, porém, estava irritado comigo por causa de vós, e não me atendeu. Ele apenas me disse: «Chega! Não Me fales mais nada a respeito disso."
,"27":"Sobe até ao alto do Fasga, levanta os teus olhos para o Oeste, para o Norte, para o Sul e para o Leste, e contempla com os teus próprios olhos, porque não atravessarás o Jordão."
,"28":"Dá instruções a Josué. Encoraja-o, fortifica-o, pois é ele quem vai atravessar à frente deste povo, fazendo-o tomar posse da terra que agora contemplas»."
,"29":"Então permanecemos no vale, em frente de Bet-Fegor."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Agora, Israel, ouve os estatutos e normas que eu hoje vos ensino a praticar, a fim de que vivais e chegueis a possuir a terra que Javé, o Deus dos vossos antepassados, vos vai dar."
,"2":"Não acrescenteis nada ao que vos ordeno, nem retireis coisa nenhuma. Observai os mandamentos de Javé vosso Deus do modo como eu vos ordeno."
,"3":"Vistes com os próprios olhos o que Javé fez em Baal-Fegor: Javé vosso Deus exterminou do meio de vós todos os que seguiram o Baal de Fegor."
,"4":"Vós, porém, permanecestes apegados a Javé vosso Deus, e por isso hoje estais todos vivos."
,"5":"Vede! Ensino-vos estatutos e normas, como Javé meu Deus me ordenou, para que os ponhais em prática na terra em que ides entrar, a fim de tomardes posse dela."
,"6":"Portanto, ponde tudo em prática, pois isso vos tornará sábios e inteligentes diante dos povos. Ao ouvirem todos estes estatutos, os povos comentarão: 'Que povo é tão sábio e inteligente como esta grande nação?'"
,"7":"De facto, que grande nação tem um Deus tão próximo, como Javé nosso Deus, todas as vezes que O invocamos?"
,"8":"Que grande nação tem estatutos e normas tão justas como toda esta lei que vos proponho hoje?"
,"9":"Contudo, tem cuidado! Presta muita atenção na tua vida em não te esqueceres dos acontecimentos que os teus olhos viram e que eles nunca se apartem da tua memória, em nenhum dia da tua vida. Ensina-os aos teus filhos e aos teus netos."
,"10":"No dia em que estavas diante de Javé teu Deus no Horeb, Javé disse-me: 'Reúne o povo junto de Mim, para que lhes faça ouvir as minhas palavras e aprendam a temer-Me enquanto viverem sobre a terra, e as ensinem aos seus filhos'."
,"11":"Vós aproximastes-vos e ficastes ao pé da montanha. A montanha ardia em fogo até ao céu, no meio de trevas e nuvens escuras."
,"12":"Então Javé falou-vos do meio do fogo. Ouvistes o som das palavras, mas não vistes nenhuma figura: ouvia-se apenas uma voz."
,"13":"Ele comunicou-vos então a sua Aliança, para que a cumprísseis: as Dez Palavras, que escreveu em duas tábuas de pedra."
,"14":"Nessa mesma ocasião, Javé ordenou-me que vos ensinasse estatutos e normas, que deveríeis cumprir na Terra, para onde estais caminhando, a fim de tomardes posse dela."
,"15":"Tomai muito cuidado convosco! Não vistes nenhuma figura no dia em que Javé vos falou no Horeb, no meio do fogo."
,"16":"Portanto, não vos pervertais, fazendo para vós imagens esculpidas em forma de ídolo: imagem de homem ou de mulher,"
,"17":"imagem de animal terrestre, de pássaro que voa no céu,"
,"18":"de réptil que rasteja sobre a terra, ou imagem de peixe que vive nas águas que estão sob a terra."
,"19":"Levantando os olhos para o céu e vendo o sol, a lua, as estrelas e todo o exército do céu, não te deixes seduzir para os adorar e servir. São coisas que Javé teu Deus repartiu entre todos os povos que vivem debaixo do céu."
,"20":"Quanto a vós, porém, Javé tomou-vos e tirou-vos do Egipto, daquela fornalha de ferro, para que sejais o povo da sua herança, como sois hoje."
,"21":"Por vossa causa, Javé ficou furioso comigo e jurou que eu não atravessaria o Jordão e não entraria na boa terra que Javé vosso Deus vos dará como herança."
,"22":"Vede! Eu vou morrer nesta terra sem atravessar o Jordão. Vós, porém, ides atravessá-lo e tomar posse dessa Terra boa."
,"23":"Tende muito cuidado convosco! Não esqueçais a Aliança que Javé vosso Deus concluiu convosco, e não façais nenhuma imagem esculpida das coisas que Javé vosso Deus vos proibiu,"
,"24":"porque Javé vosso Deus é um fogo devorador. Ele é um Deus ciumento."
,"25":"Quando tiverdes gerado filhos e netos e envelhecerdes na Terra, se vos corromperdes fazendo alguma imagem esculpida, praticando assim o que Javé vosso Deus reprova e irritando-O,"
,"26":"eu tomo o Céu e a Terra como testemunhas contra vós. Sereis completamente exterminados da face da Terra, da qual ides tomar posse ao atravessar o Jordão. Não prolongareis os vossos dias sobre ela, pois sereis completamente aniquilados."
,"27":"Javé dispersar-vos-á entre os povos, e apenas um pequeno número de vós restará no meio das nações, para onde Javé vos tiver conduzido."
,"28":"Lá adorareis deuses feitos por mãos humanas, deuses de madeira e de pedra, que não podem ver nem ouvir, nem comer nem cheirar."
,"29":"De lá, então, recorrerás a Javé teu Deus e, se O procurares com todo o coração e com toda a alma, encontrá-l'O-ás."
,"30":"Com o passar dos anos, todas estas coisas te atingirão. Mas voltarás para Javé teu Deus e obedecerás à sua voz,"
,"31":"porque Javé teu Deus é um Deus misericordioso: Ele não te vai abandonar nem destruir, pois nunca Se esquecerá da aliança que concluiu com os teus antepassados por meio de juramento."
,"32":"Pergunta aos tempos passados, que vieram antes de ti, desde o dia em que Deus criou o homem sobre a terra. De uma ponta do céu até à outra já existiu coisa tão grande como esta? Já se ouviu algo semelhante?"
,"33":"Existe algum povo que tenha ouvido a voz do Deus vivo, falando do meio do fogo, como tu ouviste, sem perder a vida?"
,"34":"Ou existe algum Deus que tenha vindo para escolher uma nação do meio de outra nação, com provas, sinais, prodígios e combates, com mão forte e braço estendido, por meio de grandes terrores, como tudo o que Javé teu Deus realizou no Egipto diante dos vossos olhos?"
,"35":"Foi a ti que Ele mostrou tudo isto, para que soubesses que Javé é o único Deus e que não existe outro além d'Ele."
,"36":"Do céu, fez-te ouvir a sua voz para te instruir; fez-te ver o seu grande fogo sobre a terra. E tu ouviste as suas palavras vindas do meio do fogo."
,"37":"E porque amava os teus antepassados, e escolheu os seus descendentes depois deles, Ele próprio com a sua presença e a sua grande força te tirou do Egipto."
,"38":"Desalojou nações maiores e mais poderosas do que tu, para te introduzir nas suas terras e dar-tas em herança, como hoje vês."
,"39":"Portanto, reconhece hoje e medita no teu coração: Javé é o único Deus, tanto no alto do céu, como aqui em baixo, na terra. Não existe outro."
,"40":"Observa os seus estatutos e mandamentos, que hoje te ordeno. Assim tudo correrá bem para ti e para os filhos que vierem depois de ti, e para que os teus dias se prolonguem na terra que Javé teu Deus te dará para todo o sempre»."
,"41":"Moisés reservou três cidades no lado Leste do Jordão,"
,"42":"para que aí se pudesse refugiar o homicida que tivesse matado o próprio irmão sem premeditar, sem o ter odiado antes. Fugindo para uma dessas cidades, ele poderia salvar a própria vida."
,"43":"Para os rubenitas era Bosor, no deserto sobre o planalto. Para os gaditas, Ramot em Galaad. E para os manassitas, Golã em Basã."
,"44":"Esta é a Lei que Moisés promulgou para os filhos de Israel."
,"45":"São estes os testemunhos, estatutos e normas que Moisés comunicou aos filhos de Israel, quando saíram do Egipto."
,"46":"Ele comunicou-os no outro lado do Jordão, no vale próximo de Bet-Fegor, na terra de Seon, o rei dos amorreus que habitava em Hesebon. Moisés e os filhos de Israel venceram-no ao saírem do Egipto,"
,"47":"conquistando o seu território, assim como o território de Og, rei de Basã. Eram dois reis amorreus que viviam no lado oriental do Jordão."
,"48":"O território conquistado ia desde Aroer, que está nas encostas do vale do rio Arnon, até ao monte Sarion, isto é, o Hermon,"
,"49":"toda a região da Arabá no lado oriental do Jordão, até ao mar da Arabá, ao pé das encostas do Fasga."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Moisés convocou todo o Israel e disse: «Ouve, Israel, os estatutos e normas que hoje eu proclamo aos teus ouvidos, para que os aprendas e procures praticá-los:"
,"2":"Javé nosso Deus fez uma aliança connosco no Horeb."
,"3":"Javé não fez essa aliança com os nossos antepassados, mas connosco, que hoje estamos aqui, todos vivos."
,"4":"Javé falou convosco, face a face, sobre a montanha, do meio do fogo."
,"5":"Eu estava entre Javé e vós, para vos anunciar a palavra de Javé, pois vós ficastes com medo do fogo e não subistes à montanha. Javé então disse-me:"
,"6":"'Eu sou Javé teu Deus, que te tirou da terra do Egipto, da casa da escravidão."
,"7":"Não tenhas outros deuses diante de Mim."
,"8":"Não faças ídolos para ti, nenhuma representação do que existe no céu, na terra ou nas águas que estão debaixo da terra."
,"9":"Não te prostres diante desses deuses, nem os sirvas, porque Eu, Javé teu Deus, sou um Deus ciumento: quando Me odeiam, Eu castigo a culpa dos pais nos filhos, netos e bisnetos;"
,"10":"e trato com amor, por mil gerações, quando Me amam e guardam os meus mandamentos."
,"11":"Não pronuncies em vão o Nome de Javé teu Deus, porque Javé não deixará sem punição aquele que pronunciar o seu Nome em vão."
,"12":"Observa o dia de sábado, para o santificares, como ordenou Javé teu Deus."
,"13":"Trabalha durante seis dias e faz todas as tuas tarefas."
,"14":"O sétimo dia, porém, é o sábado de Javé teu Deus. Não faças trabalho nenhum, nem tu, nem o teu filho, nem a tua filha, nem o teu escravo, nem a tua escrava, nem o teu boi, nem o teu jumento, nem qualquer um dos teus animais, nem o imigrante que vive nas tuas cidades. Deste modo, o teu escravo e a tua escrava poderão repousar contigo."
,"15":"Lembra-te de que foste escravo na terra do Egipto, e Javé teu Deus te tirou de lá com mão forte e braço estendido. É por isso que Javé teu Deus te ordenou que guardasses o dia de sábado."
,"16":"Honra teu pai e tua mãe, como Javé teu Deus te ordenou, para que a tua vida se prolongue e tudo te corra bem na Terra que Javé teu Deus agora te dá."
,"17":"Não mates."
,"18":"Não cometas adultério."
,"19":"Não roubes."
,"20":"Não dês falso testemunho contra o teu próximo."
,"21":"Não cobices a mulher do teu próximo, nem desejes para ti a casa do teu próximo, nem o campo, nem o escravo, nem a escrava, nem o boi, nem o jumento, nem coisa alguma que pertença ao teu próximo'."
,"22":"Foram estas as palavras que Javé dirigiu em alta voz a toda a assembleia reunida no monte, do meio do fogo e das trevas, nuvens e escuridão. Sem mais nada acrescentar, Javé gravou-as sobre duas tábuas de pedra e entregou-mas."
,"23":"Quando ouvistes a voz que vinha do meio das trevas, enquanto a montanha ardia em fogo, todos vós, chefes das tribos e anciãos, aproximastes-vos de mim"
,"24":"e dissestes: 'Javé nosso Deus mostrou-nos a sua glória e grandeza, e nós ouvimos a sua voz do meio do fogo. Hoje vimos que Deus pode falar ao homem, sem que este morra."
,"25":"E agora, porque iríamos morrer? Esse fogo pode devorar-nos! Se continuarmos a ouvir a voz de Javé nosso Deus, vamos morrer."
,"26":"De facto, qual é o mortal capaz de ouvir como nós a voz do Deus vivo a falar do meio do fogo, e ainda continuar vivo?"
,"27":"Aproxima-te tu e ouve tudo o que Javé nosso Deus vai dizer. Depois comunicar-nos-ás tudo o que Javé nosso Deus te disse: nós ouviremos e pô-lo-emos em prática'."
,"28":"Javé ouviu as palavras que me dirigistes e disse-me: 'Escutei o que esse povo te disse. Ele tem razão."
,"29":"Oxalá conserve sempre esta atitude, para Me temer e observar continuamente todos os meus mandamentos, de modo que tudo lhe corra bem a ele e seus filhos para sempre."
,"30":"Vai e diz-lhes: Voltai para as vossas tendas."
,"31":"Quanto a ti, fica aqui comigo, para que te comunique todos os mandamentos, estatutos e normas que lhes ensinarás a fim de que os pratiquem na Terra cuja posse lhes darei'."
,"32":"Portanto, procurai agir de acordo com todas as coisas que Javé vosso Deus vos ordenou. Não vos desvieis nem para a direita nem para a esquerda."
,"33":"Segui o caminho que Javé vosso Deus vos indicou, para que vivais, sejais felizes e prolongueis a vida na Terra que ireis ocupar."
}`)
	CurrentBook.AddChapter(6, `{
"1":"São estes os mandamentos, estatutos e normas que Javé vosso Deus mandou que vos ensinasse, para que os ponhais em prática na Terra onde ides entrar a fim de tomardes posse dela."
,"2":"Teme a Javé teu Deus, e observa todos os seus estatutos e mandamentos que hoje ordeno a ti, ao teu filho e ao teu neto, durante todos os dias da tua vida, para que a tua vida se prolongue."
,"3":"Portanto, Israel, ouve e procura pôr em prática o que será bom para ti e que te multiplicará muito, como Javé, o Deus dos teus antepassados, te disse ao entregar-te uma Terra onde corre leite e mel."
,"4":"Ouve, Israel! Javé nosso Deus é o único Javé."
,"5":"Portanto, ama a Javé teu Deus com todo o teu coração, com toda a tua alma e com todas as tuas forças."
,"6":"Que estas palavras, que hoje eu te ordeno, estejam no teu coração."
,"7":"Ensiná-las-ás aos teus filhos, e delas falarás sentado em tua casa e indo de viagem, ao deitar-te e ao levantar-te."
,"8":"Atá-las-ás à tua mão como sinal, e usá-las-ás como filactérias entre os teus olhos."
,"9":"Escrevê-las-ás nos batentes da tua casa e nas portas da cidade."
,"10":"Quando Javé teu Deus te introduzir na Terra que jurou aos teus antepassados Abraão, Isaac e Jacob, que te daria, com cidades grandes e ricas que não construíste,"
,"11":"casas cheias de riquezas que não encheste, poços abertos que não abriste, vinhas e olivais que não plantaste; quando comeres e ficares satisfeito,"
,"12":"guarda-te de esqueceres Javé, que te tirou do Egipto, da casa da escravidão."
,"13":"É a Javé teu Deus que adorarás, só a Ele servirás, e só pelo seu nome jurarás."
,"14":"Não sigas deuses estrangeiros, deuses de povos vizinhos,"
,"15":"porque Javé teu Deus é um Deus ciumento que mora no meio de ti. A cólera de Javé teu Deus inflamar-se-ia contra ti, e exterminar-te-ia da face da Terra."
,"16":"Não tentes a Javé teu Deus, como O tentaste em Massa."
,"17":"Observa cuidadosamente os mandamentos de Javé teu Deus, e também os testemunhos e estatutos que Ele te ordenou."
,"18":"Faz o que é justo e bom aos olhos de Javé, para que tudo te corra bem, e chegues a tomar posse da Terra boa que Javé prometeu aos teus antepassados,"
,"19":"expulsando da tua frente todos os teus inimigos. Foi isso que Javé prometeu."
,"20":"Amanhã o teu filho vai perguntar-te: 'O que significam estes testemunhos, estatutos e normas que Javé nosso Deus ordenou?'"
,"21":"Então responderás a teu filho: 'Nós éramos escravos do Faraó no Egipto, mas Javé tirou-nos do Egipto com mão forte."
,"22":"Diante dos nossos olhos Javé realizou sinais e prodígios grandes e terríveis contra o Egipto, contra o Faraó e toda a sua corte."
,"23":"Quanto a nós, porém, Ele tirou-nos de lá para nos introduzir aqui e nos dar a terra que havia prometido aos nossos antepassados."
,"24":"Javé, então, ordenou-nos que cumpríssemos todos estes estatutos, que temêssemos a Javé nosso Deus, para que sempre tudo nos corresse bem e para nos dar a vida, como o fez até hoje."
,"25":"Seremos justos aos olhos do Senhor se pusermos em prática todos estes mandamentos, conforme Ele nos ordenou'."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Quando Javé teu Deus te introduzir na Terra onde estás a entrar para dela tomar posse; quando tiver expulsado nações mais numerosas que tu - os heteus, gergeseus, amorreus, cananeus, ferezeus, heveus e jebuseus - sete nações mais numerosas que tu;"
,"2":"quando Javé teu Deus tas entregar, vencê-las-ás e sacrificá-las-ás como anátema. Não faças aliança nenhuma com elas e não as trates com piedade."
,"3":"Não cries laços de parentesco com elas: não dês a tua filha a um dos seus filhos, nem tomes uma das suas filhas para o teu filho,"
,"4":"porque o teu filho se afastaria de Mim para servir outros deuses; então a cólera de Javé inflamar-se-ia contra ti e destruir-te-ia rapidamente."
,"5":"Deveis tratá-las da seguinte maneira: demolir os seus altares, destruir as suas estelas, arrancar os seus postes sagrados e queimar os seus ídolos."
,"6":"Pois és um povo consagrado a Javé teu Deus: foi a ti que Javé teu Deus escolheu para que Lhe pertenças como povo próprio, entre todos os povos da terra."
,"7":"Se Javé Se afeiçoou a vós e vos escolheu, não é por serdes o mais numeroso entre todos os outros povos; pelo contrário, vós sois o menor de todos os povos!"
,"8":"Foi por amor a vós e para manter a promessa que Ele jurou aos vossos antepassados. É por isso que Javé vos tirou com mão forte e vos resgatou da casa da escravidão, da mão do Faraó, rei do Egipto."
,"9":"Reconhece, portanto, que Javé teu Deus é o único Deus, o Deus fiel, que mantém a aliança e o amor por mil gerações, em favor dos que O amam e observam os seus mandamentos."
,"10":"Mas Ele também retribui directamente aos que O odeiam: faz perecer sem demora aquele que O odeia, retribuindo-lhe directamente."
,"11":"Observa, pois, os mandamentos, estatutos e normas que hoje te mando cumprir."
,"12":"Se ouvirdes estas normas e as puserdes em prática, Javé vosso Deus também manterá convosco a aliança e o amor que Ele jurou aos vossos antepassados."
,"13":"Ele amar-te-á, abençoar-te-á, multiplicar-te-á e abençoará o fruto do teu ventre e o fruto do teu solo; abençoará o teu trigo, o teu vinho novo, o teu azeite, a cria das tuas vacas e a prole das tuas ovelhas, na terra que te vai dar, conforme prometeu aos teus antepassados."
,"14":"Vais ser abençoado mais do que todos os outros povos: no meio de ti, nem o homem, nem a mulher, nem o teu gado serão estéreis."
,"15":"Javé afastará de ti qualquer doença e todas as graves enfermidades do Egipto, que conheces muito bem. Mandá-las-á não a ti, mas a todos os que te odeiam."
,"16":"Destrói, portanto, todos os povos que Javé teu Deus te entregar. Não os trates com piedade, nem sirvas os seus deuses. Isso seria para ti uma armadilha."
,"17":"Talvez penses: 'Estas nações são mais numerosas do que eu. Como poderia expulsá-las'?"
,"18":"Não tenhas medo delas. Lembra-te do que Javé teu Deus fez ao Faraó e a todo o Egipto;"
,"19":"as grandes provas que os teus olhos viram, os sinais e prodígios, a mão forte e o braço estendido com que Javé teu Deus te fez sair de lá. Javé teu Deus tratará do mesmo modo a todos os povos de que tens medo."
,"20":"Javé teu Deus, além disso, mandará vespas contra eles, de modo que perecerão até os que restarem e se esconderem de ti."
,"21":"Não tremas diante deles, porque Javé teu Deus, que habita no meio de ti, é Deus grande e terrível."
,"22":"Javé teu Deus irá expulsando pouco a pouco da tua frente essas nações. Não poderás exterminá-las rapidamente, porque as feras do campo multiplicar-se-iam à tua volta."
,"23":"É Javé teu Deus quem te vai entregar essas nações: elas ficarão perturbadas até serem completamente exterminadas."
,"24":"Javé entregar-te-á os seus reis e fará desaparecer o seu nome de debaixo do céu: ninguém te resistirá, até os teres destruído."
,"25":"Queima as imagens dos deuses; não cobices a prata e o ouro que os recobrem, nem fiques com eles, para não caíres numa armadilha, pois são coisa abominável a Javé teu Deus."
,"26":"Portanto, não introduzas uma coisa abominável na tua casa: tornar-te-ias anátema como ela. Considera essas coisas como imundas e abomináveis, pois são anátemas."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Observai todos os mandamentos que hoje vos mando cumprir, para que vivais e vos multipliqueis, entreis e tomeis posse da Terra que Javé prometeu com juramento aos vossos antepassados."
,"2":"Lembra-te, porém, de todo o caminho que Javé teu Deus te fez percorrer durante quarenta anos no deserto, a fim de te humilhar e te pôr à prova, para conhecer as tuas intenções e verificar se irias ou não observar os seus mandamentos."
,"3":"Ele humilhou-te, fez-te sentir fome e alimentou-te com o maná, que nem tu nem os teus antepassados conheciam, tudo para te mostrar que o homem não vive só de pão, mas que o homem vive de tudo aquilo que sai da boca de Javé."
,"4":"As roupas que usavas não se gastaram, nem os teus pés incharam durante esses quarenta anos."
,"5":"Portanto, reconhece no teu coração que Javé teu Deus te educava como o homem educa o próprio filho."
,"6":"Observa os mandamentos de Javé teu Deus andando nos seus caminhos e temendo-O."
,"7":"Javé teu Deus vai introduzir-te numa terra boa: terra cheia de torrentes de água e de fontes profundas que jorram no vale e na montanha;"
,"8":"terra de trigo e cevada, de vinhas, figueiras e romãzeiras, terra de oliveiras, de azeite e de mel;"
,"9":"terra onde comerás pão com abundância, pois nela nada te faltará; terra cujas pedras são de ferro, e de cujas montanhas extrairás o cobre."
,"10":"Quando comeres e ficares satisfeito, bendiz a Javé teu Deus pela boa terra que te deu."
,"11":"Contudo, guarda-te de esquecer Javé teu Deus e de deixar de cumprir os seus mandamentos, normas e estatutos, que hoje te ordeno."
,"12":"Não aconteça que, tendo comido e estando satisfeito, havendo construído casas boas e habitando nelas,"
,"13":"tendo-se multiplicado os teus bois e aumentado as tuas ovelhas, e multiplicando-se também a tua prata e o teu ouro e tudo o que possuis,"
,"14":"o teu coração fique cheio de orgulho, e te esqueças de Javé teu Deus, que te tirou do Egipto, da casa da escravidão;"
,"15":"que te conduziu através daquele grande e terrível deserto, cheio de serpentes venenosas, escorpiões e sede; que fez jorrar para ti água da mais dura pedra, onde não havia água;"
,"16":"que te sustentava no deserto com o maná, que os teus antepassados não conheceram: tudo isto para te humilhar e provar, a fim de no futuro te fazer feliz."
,"17":"Portanto, não vás pensar: 'Foi a minha força e o poder das minhas mãos que me conquistaram estas riquezas'."
,"18":"Lembra-te de Javé teu Deus, pois é Ele quem te dá força para enriqueceres, mantendo a aliança que jurou aos teus antepassados, como faz hoje."
,"19":"Todavia, se esqueceres completamente Javé teu Deus, seguindo, servindo e adorando outros deuses, hoje eu vos garanto que morrereis."
,"20":"Perecereis exactamente como as nações que Javé destruiu diante de vós, por não terdes obedecido a Javé vosso Deus."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Ouve, Israel: Hoje atravessarás o rio Jordão para conquistares nações maiores e mais poderosas do que tu, cidades grandes e fortificadas até ao céu."
,"2":"Os enacim são um povo forte e de grande estatura. Tu conhece-los, porque ouviste dizer: 'Quem poderia resistir aos filhos de Enac?'"
,"3":"Por isso hoje ficarás sabendo que Javé teu Deus vai atravessar à tua frente como um fogo devorador. Ele é que vai exterminá-los e submetê-los a ti, de modo que os desalojarás e rapidamente os destruirás, como Javé te prometeu."
,"4":"Quando Javé teu Deus os tiver expulsado da tua frente, não vás pensar: 'Foi por causa da minha justiça que Javé me fez entrar e tomar posse desta terra'. Não. É por causa da injustiça destas nações que Javé as expulsará da tua frente."
,"5":"Se vais conquistar estas terras, não é por causa da tua justiça e honradez, mas porque Javé teu Deus vai expulsá-las da tua frente por causa da injustiça delas, e também para cumprir a promessa que Ele havia jurado a teus antepassados Abraão, Isaac e Jacob."
,"6":"Sabe, portanto: não é por causa da tua justiça que Javé teu Deus te concede possuir esta terra boa, pois és um povo de cabeça dura."
,"7":"Lembra-te, e não te esqueças, de que no deserto irritaste Javé teu Deus. Não deixastes de ser rebeldes a Javé, desde o dia em que saístes do Egipto até chegardes a este lugar."
,"8":"Até mesmo no Horeb irritastes Javé. E Javé ficou furioso convosco e quis destruir-vos."
,"9":"Quando subi à montanha para receber as tábuas de pedra, as tábuas da aliança que Javé fez convosco, fiquei na montanha durante quarenta dias e quarenta noites, sem comer pão nem beber água."
,"10":"Então Javé entregou-me as duas tábuas de pedra, escritas pelo dedo de Deus. Nelas estavam todas as palavras que Javé vos tinha dito na montanha, do meio do fogo, no dia da assembleia."
,"11":"Depois de quarenta dias e quarenta noites, Javé entregou-me as duas tábuas de pedra, as tábuas da aliança,"
,"12":"e disse-me: 'Levanta-te e desce depressa, porque o teu povo, o povo que tiraste do Egipto, já se corrompeu. Já se desviaram do caminho que Eu lhes ordenei: fundiram para si um ídolo de metal'."
,"13":"E Javé acrescentou: 'Vejo que este povo é um povo de cabeça dura."
,"14":"Deixa-me destruí-lo e apagar o seu nome debaixo do céu. Eu farei de ti uma nação mais poderosa e numerosa do que esta'."
,"15":"Virei-me e comecei a descer da montanha, enquanto ela ardia em fogo. Eu trazia nas mãos as duas tábuas da aliança."
,"16":"Então olhei, e efectivamente tínheis pecado contra Javé vosso Deus. Tínheis feito um bezerro de metal derretido, afastando-vos bem depressa do caminho que Javé vos havia indicado."
,"17":"Peguei então nas duas tábuas, arremessei-as com as duas mãos, quebrando-as diante dos vossos olhos."
,"18":"Depois prostrei-me diante de Javé, como da primeira vez, durante quarenta dias e quarenta noites. Não comi pão nem bebi água, por causa do pecado que cometestes, fazendo o que era mau aos olhos de Javé, a ponto de provocar a sua cólera."
,"19":"Fiquei com medo da cólera e do furor que Javé estava dirigindo contra vós, a ponto de vos querer destruir. Javé, porém, ouviu-me ainda dessa vez."
,"20":"Javé também ficou furioso contra Aarão, e queria destruí-lo. E nesse dia eu supliquei também por Aarão."
,"21":"Depois peguei no pecado que tínheis cometido, o bezerro, e queimei-o. Em seguida, esmaguei-o, moendo-o completamente, até o transformar em pó, e deitei-o no riacho que desce da montanha."
,"22":"Também irritastes continuamente Javé em Tabera, em Massa e em Cemitério da Avidez."
,"23":"E quando Javé vos enviou de Cades Barne, disse: 'Subi e tomai posse da terra que vos dei'. Mas vós revoltastes-vos contra a ordem de Javé vosso Deus, e não Lhe destes crédito nem Lhe obedecestes."
,"24":"Tendes sido rebeldes a Javé desde o dia em que vos conheci."
,"25":"Prostrei-me então diante de Javé. E fiquei prostrado durante quarenta dias e quarenta noites, porque Javé ameaçava destruir-vos."
,"26":"Então supliquei a Javé: 'Javé, meu Senhor, não destruas o teu povo, a tua herança. Tu resgataste-o com a tua grandeza. Tu tiraste-o do Egipto com mão forte."
,"27":"Lembra-Te dos teus servos Abraão, Isaac e Jacob. Não olhes para a teimosia deste povo, para a sua maldade e o seu pecado,"
,"28":"para que não digam na terra de onde nos tiraste: Javé não foi capaz de os conduzir para a Terra que lhes tinha prometido! Ele fê-los sair por ódio, para os matar no deserto!"
,"29":"Apesar de tudo, eles são o teu povo e a tua herança. Tu fizeste-os sair com a tua grande força e com o teu braço esten-dido'."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Naquela ocasião, Javé disse-me: 'Talha duas tábuas de pedra, como as primeiras, e vem ter comigo à montanha. Faz também uma arca de madeira."
,"2":"Sobre as tábuas Eu vou escrever as palavras que estavam sobre aquelas primeiras tábuas que quebraste. E colocá-las-ás na arca'."
,"3":"Então eu fiz uma arca de madeira de acácia, talhei duas tábuas de pedra, como as primeiras, e subi à montanha com as duas tábuas na mão."
,"4":"Então Javé escreveu sobre as tábuas o mesmo texto que havia escrito antes, as Dez Palavras que Javé vos tinha dito na montanha, do meio do fogo, no dia da assembleia. Em seguida, Javé entregou-me as tábuas."
,"5":"Depois virei-me, desci da montanha e coloquei as duas tábuas na arca que eu havia preparado. Elas continuam lá, como Javé me ordenou."
,"6":"Os filhos de Israel partiram, então, dos poços de Bené-Jacã para Mosera. Foi ali que Aarão morreu e foi sepultado. O seu filho Eleazar sucedeu-lhe no sacerdócio."
,"7":"Daí partiram para Gadgad, e de Gadgad para Jetebata, uma terra cheia de torrentes de água."
,"8":"Foi nessa ocasião que Javé destacou a tribo de Levi para levar a arca da aliança de Javé e ficar à disposição de Javé, para O servir e abençoar em seu nome, até ao dia de hoje."
,"9":"É por isso que Levi não recebeu parte na herança dos seus irmãos: a sua herança é Javé, como Javé seu Deus lhe dissera."
,"10":"Fiquei na montanha durante quarenta dias e quarenta noites, como na primeira vez. Ainda desta vez Javé ouviu-me e não quis destruir-te."
,"11":"Javé então disse-me: 'Levanta-te e caminha à frente deste povo, para que tomem posse da terra que Eu lhes darei, conforme prometi aos seus antepassados'."
,"12":"E agora, Israel, o que é que Javé teu Deus te pede? Somente isto: que temas Javé teu Deus. Que andes nos seus caminhos e O ames. Que sirvas Javé teu Deus com todo o teu coração e com toda a tua alma."
,"13":"E que observes os mandamentos de Javé e os estatutos que hoje te ordeno, para teu bem."
,"14":"Vê! É a Javé teu Deus que pertencem o céu e o céu do céu, a terra e tudo o que nela existe."
,"15":"Apesar disso, foi somente com os vossos antepassados que Javé Se ligou para os amar. E depois deles, escolheu dentre todos os povos a descendência deles, que sois vós, como hoje se vê."
,"16":"Circuncidai portanto o coração, e nunca mais tenhais cabeça dura,"
,"17":"porque Javé vosso Deus é o Deus dos deuses e o Senhor dos senhores, o Deus grande, valente e terrível, que não faz diferença entre as pessoas e não aceita suborno."
,"18":"Ele faz justiça ao órfão e à viúva e ama o imigrante, dando-lhe pão e roupa."
,"19":"Portanto, amai o imigrante, porque fostes imigrantes no Egipto."
,"20":"Temei e servi a Javé vosso Deus, apegai-vos a Ele e jurai pelo seu nome."
,"21":"É a Ele que deves louvar, porque Ele é o teu Deus. Ele fez por ti estas coisas grandes e terríveis, que viste com os teus próprios olhos."
,"22":"Os teus antepassados, quando desceram para o Egipto, eram apenas setenta pessoas. Agora, porém, Javé teu Deus tornou-te numeroso como as estrelas do céu."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Ama Javé teu Deus e observa continuamente o que Ele ordena: os seus estatutos, normas e mandamentos."
,"2":"Fostes vós que fizestes a experiência, e não os vossos filhos. Eles não conheceram nem viram a educação dada por Javé seu Deus, nem a sua grandeza, a sua mão forte e o seu braço estendido,"
,"3":"os sinais e as obras que Ele realizou no Egipto contra o Faraó, rei do Egipto, e contra todo o seu país;"
,"4":"o que Ele fez contra o exército do Egipto, contra os seus cavalos e carros: fez cair as águas do Mar Vermelho por cima deles, quando vos perseguiam. Javé aniquilou-os até ao dia de hoje."
,"5":"E o que fez por vós no deserto, até chegardes a este lugar."
,"6":"E ainda o que fez a Datã e Abiram, filhos de Eliab, o rubenita: a terra abriu a boca e engoliu-os, juntamente com as suas famílias, tendas e tudo o que possuíam no meio de todo o Israel."
,"7":"Vistes com os vossos próprios olhos todas as grandes obras que Javé realizou."
,"8":"Observai, portanto, todos os mandamentos que hoje vos ordeno, para que sejais fortes, entreis e tomeis posse da Terra, para a qual caminhais, a fim de a conquistar."
,"9":"Deste modo prolongareis os vossos dias na Terra que Javé prometeu dar aos vossos antepassados e aos seus descendentes, uma terra onde corre leite e mel."
,"10":"A Terra, onde estás entrando para dela tomares posse, não é como a terra do Egipto, de onde saístes. Lá espalhavas a semente e regavas com a ajuda do teu pé, como se fosse uma horta."
,"11":"A Terra, para onde vos dirigis a fim de a conquistar, é uma Terra de montes e vales que bebem água da chuva do céu!"
,"12":"É a Terra da qual Javé vosso Deus cuida. Ele olha sempre por ela, desde o começo do ano até ao fim."
,"13":"Se obedecerdes aos mandamentos que hoje vos ordeno, amando a Javé vosso Deus e servindo-O com todo o vosso coração e com toda a vossa alma,"
,"14":"Eu dar-vos-ei chuva no seu tempo: chuvas de Outono e de Primavera. Deste modo, poderás recolher o teu trigo, o teu vinho novo e o teu azeite."
,"15":"Também farei crescer erva no campo para o teu rebanho, de modo que poderás comer e ficar saciado."
,"16":"Contudo, prestai atenção vós mesmos, para que o vosso coração não se deixe seduzir nem vos desvieis para servir a outros deuses, prostrando-vos diante deles."
,"17":"A cólera de Javé inflamar-se-ia contra vós, e Ele fecharia o céu: assim não haveria mais chuva, e a terra não daria o seu produto. Deste modo desapareceríeis rapidamente da Terra boa que Javé vai dar-vos."
,"18":"«Colocai estas minhas palavras no vosso coração e na vossa alma! Atai estas palavras à vossa mão como sinal. E que elas sejam para vós como faixa entre os olhos."
,"19":"Deveis ensiná-las aos vossos filhos, falando delas sentados em casa e andando pelo caminho, deitados e de pé."
,"20":"Deverás escrevê-las nos batentes da tua casa e nas portas da tua cidade,"
,"21":"para que os teus dias e os dias dos teus filhos se multipliquem sobre a Terra que Javé jurou dar aos teus antepassados, e sejam dias tão numerosos como os dias em que o céu permanecer sobre a terra."
,"22":"Se observardes fielmente todos os mandamentos que hoje vos ordeno, amando a Javé vosso Deus, seguindo os seus caminhos e apegando-vos a Ele,"
,"23":"Javé expulsará diante de vós todas as nações, a fim de que tomeis posse de nações maiores e mais poderosas do que vós."
,"24":"Todo o lugar que pisardes vos pertencerá: as suas fronteiras irão desde o deserto até ao Líbano, desde o rio Eufrates até ao mar ocidental."
,"25":"Ninguém poderá resistir-vos, porque Javé vosso Deus vai espalhar o medo e o terror em qualquer terra onde puserdes o pé, conforme vos afirmou."
,"26":"Vede! Hoje eu ponho diante de vós a bênção e a maldição."
,"27":"A bênção, se obedecerdes aos mandamentos de Javé vosso Deus, que hoje vos ordeno."
,"28":"A maldição, se não obedecerdes aos mandamentos de Javé vosso Deus, desviando-vos do caminho que hoje vos ordeno, para seguir outros deuses que não conhecestes."
,"29":"Quando Javé teu Deus te tiver introduzido na Terra para onde te diriges, a fim de tomares posse dela, deverás colocar a bênção sobre o monte Garizim e a maldição sobre o monte Ebal."
,"30":"Esses montes estão do outro lado do Jordão, a caminho do Poente, na terra dos cananeus que habitam na Arabá, em frente de Guilgal, perto do carvalhal de Moré."
,"31":"Estais para atravessar o Jordão e tomar posse da Terra que Javé vosso Deus vos vai dar. Quando tomardes posse dela e nela habitardes,"
,"32":"cuidai de pôr em prática todos os estatutos e normas que hoje vos proponho»."
}`)
	CurrentBook.AddChapter(12, `{
"1":"São estes os estatutos e normas que poreis em prática na Terra cuja posse Javé, o Deus dos vossos antepassados, vos dará durante todos os dias em que viverdes sobre a Terra."
,"2":"Destruireis completamente todos os lugares onde as nações, que ireis conquistar, serviam aos seus deuses, tanto sobre os altos montes como sobre as colinas e debaixo de qualquer árvore frondosa."
,"3":"Destruí os seus altares, despedaçai as suas estelas, queimai os seus postes sagrados e esmagai os ídolos dos seus deuses, fazendo assim que o seu nome desapareça daquela região."
,"4":"Não os imiteis ao prestardes culto a Javé, vosso Deus."
,"5":"Pelo contrário, só O buscareis no lugar que Javé vosso Deus tiver escolhido entre todas as tribos, para aí colocar o seu nome e a sua morada."
,"6":"Apresentai nesse lugar os vossos holocaustos e sacrifícios, dízimos e ofertas, sacrifícios votivos e sacrifícios espontâneos, os primogénitos das vacas e das ovelhas."
,"7":"E nesse lugar comereis, diante de Javé vosso Deus, festejando com as vossas famílias por tudo o que tiverdes realizado e que foi abençoado por Javé vosso Deus."
,"8":"Não procedais como estamos a proceder aqui hoje: cada um fazendo o que bem entende,"
,"9":"pois até agora ainda não entrastes no lugar do repouso e na herança que Javé vosso Deus vai dar-vos."
,"10":"Atravessareis o Jordão e habitareis na terra que Javé vosso Deus vos vai dar como herança. Ele vos protegerá de todos os inimigos vizinhos, para que vivais tranquilos."
,"11":"No lugar que Javé vosso Deus tiver escolhido para fazer habitar o seu nome, ali é que apresentareis tudo o que vos ordenei: holocaustos, sacrifícios, dízimos, donativos e todas as ofertas escolhidas que tiverdes prometido como voto a Javé."
,"12":"Fareis uma festa diante de Javé vosso Deus, com os vossos filhos e filhas, escravos e escravas, e com o levita que vive nas vossas cidades, porque ele não tem parte nem herança convosco."
,"13":"Guarda-te de oferecer os teus holocaustos em qualquer lugar que te pareça melhor,"
,"14":"pois é só no lugar que Javé tiver escolhido numa das suas tribos que deverás oferecer os teus holocaustos; é ali que deverás pôr em prática tudo o que te ordeno."
,"15":"Entretanto, quando quiseres, poderás imolar um animal e comer a sua carne em qualquer das tuas cidades, conforme a bênção que Javé te tiver dado. Poderás comer tanto o puro como o impuro, assim como se come a gazela e o veado."
,"16":"Mas não poderás comer o sangue: derrama-o no chão como água."
,"17":"Não poderás comer, nas tuas cidades, o dízimo do trigo, do vinho novo e do azeite, nem os primogénitos das tuas vacas e ovelhas, nem coisa alguma dos sacrifícios votivos que tiveres prometido, nem dos sacrifícios espontâneos, nem das ofertas voluntárias."
,"18":"Comê-los-ás diante de Javé teu Deus, somente no lugar que Javé teu Deus tiver escolhido, juntamente com o teu filho e a tua filha, o teu servo e a tua serva, e com o levita que vive na tua cidade. Por todo o sucesso das tuas tarefas, farás uma festa, diante de Javé teu Deus."
,"19":"Tem cuidado contigo: enquanto viveres na tua terra, nunca abandones o levita."
,"20":"Quando Javé teu Deus tiver alargado o teu território, conforme te prometeu, e disseres: 'Queria comer carne', porque estás com vontade de a comer, poderás comer quanta quiseres."
,"21":"Se estiveres muito longe do lugar escolhido por Javé teu Deus para lá colocar o seu Nome, poderás, como te ordenei, imolar vacas e ovelhas que Javé teu Deus te tiver dado. Poderás comer nas tuas cidades quanto quiseres."
,"22":"Comê-las-ás como se come a gazela e o veado: o puro juntamente com o impuro."
,"23":"Porém, de nenhum modo comas o sangue, pois o sangue é a vida. Portanto, não comas a vida com a carne."
,"24":"Não o comas nunca. Derrama-o no chão como água."
,"25":"Não o comas, e assim tudo correrá bem a ti e aos teus filhos que vierem depois de ti. Deste modo, estarás fazendo o que agrada a Javé."
,"26":"Todavia, daquelas coisas que te pertencem, toma o que tiveres consagrado, e também os teus sacrifícios votivos, e vai ao lugar que Javé tiver escolhido."
,"27":"Oferece ali os teus holocaustos, a carne e o sangue, sobre o altar de Javé teu Deus; o sangue dos sacrifícios de comunhão será derramado sobre o altar de Javé teu Deus, e poderás comer a carne."
,"28":"Ouve com atenção e põe em prática todas as coisas que agora te ordeno, para que tudo corra sempre bem a ti e aos teus filhos que vierem depois de ti, pois assim estarás a fazer o que é bom e agradável a Javé teu Deus."
,"29":"Quando Javé teu Deus eliminar da tua frente os povos, cujos territórios invadirás para os possuir, quando tiveres ocupado o seu país e nele morares,"
,"30":"presta atenção a ti mesmo! Não te deixes seduzir; não imites essas nações, depois de elas terem sido eliminadas diante de ti. Toma cuidado em não procurar os seus deuses, dizendo: 'Como é que estas nações adoravam os seus deuses? Vou fazer a mesma coisa'!"
,"31":"Não procedas dessa maneira para com Javé teu Deus, porque elas faziam aos seus deuses tudo o que é abominação para Javé, tudo o que Ele detesta. Essas nações chegaram até a queimar os próprios filhos e filhas aos seus deuses!"
}`)
	CurrentBook.AddChapter(13, `{
"1":"Cuidai de pôr em prática tudoo que vos ordeno, sem nada acrescentar ou tirar."
,"2":"Se no meio de ti aparecer algum profeta ou intérprete de sonhos e te apresentar um sinal ou prodígio -"
,"3":"se esse sinal ou prodígio que ele anunciou se realiza e te convida: 'Vamos seguir outros deuses (que não conheces) e vamos adorá-los' -"
,"4":"não dês ouvidos a esse profeta ou intérprete de sonhos. Trata-se de uma prova com que Javé vosso Deus vos experimenta, para saber se de facto amais a Javé vosso Deus com todo o coração e com todo o ser."
,"5":"Segui a Javé vosso Deus a quem deveis temer; observai os seus mandamentos e obedecei-Lhe; servi-O e apegai-vos a Ele."
,"6":"Quanto ao profeta ou intérprete de sonhos, deverá ser morto, porque propôs uma revolta contra Javé vosso Deus, que vos tirou do Egipto e vos resgatou da casa da escravidão, e porque procurou afastar-vos do caminho pelo qual Javé vosso Deus vos havia mandado seguir. Desse modo, eliminarás o mal do meio de ti."
,"7":"Se o teu irmão, filho de teu pai ou de tua mãe, ou o teu filho, a tua filha, ou a tua esposa que repousa nos teus braços, ou o teu amigo íntimo te quiser seduzir secretamente, convidando: 'Vamos servir outros deuses' (deuses que nem tu nem os teus antepassados conheceram,"
,"8":"deuses de povos vizinhos, próximos ou distantes de ti, de uma extremidade da terra à outra),"
,"9":"não faças caso, nem lhes dês ouvidos. Não tenhas piedade dele, não uses de compaixão, nem escondas o seu erro."
,"10":"Pelo contrário: deverás matá-lo. E para o matar, a tua mão será a primeira. Em seguida, a mão de todo o povo."
,"11":"Apedreja-o até que morra, pois tentou afastar-te de Javé teu Deus, que te tirou do Egipto, da casa da escravidão."
,"12":"E todo o Israel ouvirá, ficará com medo, e nunca mais se fará no meio de vós uma acção má como essa."
,"13":"Poderás ouvir alguém dizer que, numa das cidades que Javé teu Deus te dá para morar,"
,"14":"apareceram vagabundos no meio do povo e seduziram os habitantes da tua cidade, dizendo: 'Vamos servir a outros deuses' (que não conhecestes)."
,"15":"Então deverás investigar, fazendo pesquisa e interrogando cuidadosamente. Caso seja verdade e o facto seja verificado, se essa abominação tiver sido realmente praticada no meio de vós,"
,"16":"deverás passar a fio de espada os habitantes dessa cidade. Sacrifica-a como anátema, juntamente com tudo o que nela existe."
,"17":"Reúne todos os despojos no meio da praça e queima a cidade e os despojos para Javé teu Deus. Ela ficará em ruínas para sempre, e nunca mais será reconstruída."
,"18":"Na tua mão nada ficará do que for sacrificado como anátema. Deste modo, Javé aplacará a sua cólera, perdoar-te-á, terá piedade e multiplicar-te-á, como jurou aos teus antepassados."
,"19":"Assim acontecerá se obedeceres a Javé teu Deus, observando todos os seus mandamentos, que hoje te ordeno, e praticando o que Javé teu Deus aprova."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Sois filhos de Javé vosso Deus. Por isso, nunca vos marcareis com nenhum corte nem rapareis a cabeça por um morto."
,"2":"És um povo consagrado a Javé teu Deus: foi a ti que Javé escolheu, para que Lhe pertenças como povo próprio, entre todos os povos da terra."
,"3":"Não comas nada que seja abominável."
,"4":"São estes os animais que podereis comer: boi, carneiro, cabra,"
,"5":"veado, cabrito, gamo, cabrito montês, antílope, búfalo e cabra selvagem."
,"6":"Podereis comer também qualquer animal que tenha o casco fendido e que rumine."
,"7":"Porém, há ruminantes e animais com casco fendido que não podereis comer: o camelo, a lebre e o texugo, que ruminam, mas não têm casco fendido. Esses serão impuros para vós."
,"8":"Quanto ao porco, que tem casco fendido mas não rumina, considerá-lo-eis impuro: não comais a sua carne, nem toqueis no seu cadáver."
,"9":"Dos animais que vivem na água, podereis comer todos os que têm barbatanas e escamas."
,"10":"Não comais, porém, os que não tiverem barbatanas e escamas: serão impuros para vós."
,"11":"Podeis comer todas as aves puras,"
,"12":"mas não podeis comer o abutre, o gipaeto, o xofrango,"
,"13":"o milhafre negro, as diversas espécies de milhafre vermelho,"
,"14":"todas as espécies de corvo,"
,"15":"o avestruz, a coruja, a gaivota e as diversas espécies de gavião,"
,"16":"o mocho, o íbis, o grão-duque,"
,"17":"o pelicano, o abutre branco, o alcatraz,"
,"18":"a cegonha, as diversas espécies de garça, a poupa e o morcego."
,"19":"Considerai impuros todos os insectos que voam: não comais deles."
,"20":"Podeis comer todas as aves puras."
,"21":"Não comais nenhum animal que tenha morrido por si. Dá-lo-ás ao imigrante que vive na tua cidade, para que ele o coma, ou vendê-lo-ás a um estrangeiro, porque és um povo consagrado a Javé teu Deus. Não cozas o cabrito no leite da sua mãe."
,"22":"Todos os anos separarás o dízimo de qualquer produto dos teus campos"
,"23":"e comê-lo-ás diante de Javé teu Deus, no lugar que Ele tiver escolhido para ali fazer habitar o seu Nome; nesse lugar comerás o dízimo do trigo, do vinho novo e do azeite, e também os primogénitos das vacas e das ovelhas, para que aprendas continuamente a temer Javé teu Deus."
,"24":"Se o caminho for longo de mais e não puderes levar o dízimo, porque fica muito longe o lugar escolhido por Javé teu Deus para ali colocar o seu Nome, e Javé teu Deus te tiver abençoado,"
,"25":"então vende, toma o dinheiro e vai ao lugar que Javé teu Deus tiver escolhido."
,"26":"Ali trocarás o teu dinheiro pelas coisas que desejares: vacas, ovelhas, vinho, bebida embriagante, tudo o que quiseres. Comê-los-ás, diante de Javé teu Deus, e festejarás com a tua família."
,"27":"Mas não esqueças o levita que mora na tua cidade, pois ele não tem parte nem herança contigo."
,"28":"Cada três anos tomarás o dízimo da colheita do ano e colocá-lo-ás junto da porta da cidade."
,"29":"Então virá o levita que não recebeu uma parte na vossa herança, o imigrante, o órfão e a viúva que vivem nas tuas cidades, e comerão até ficarem saciados. Deste modo, Javé teu Deus abençoar-te-á em todos os trabalhos que realizares."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Cada sete anos, celebrarás o ano da remissão das dívidas."
,"2":"Isto quer dizer o seguinte: Todo o credor que tenha emprestado alguma coisa ao seu próximo, perdoará o que tiver emprestado. Não explorará o seu próximo, nem o seu irmão, porque terá sido proclamada a remissão em honra de Javé."
,"3":"Poderás explorar o estrangeiro, mas considerarás pago aquilo que tiveres emprestado ao teu irmão."
,"4":"É verdade que no meio de ti não haverá nenhum pobre, porque Javé te vai abençoar na Terra que Javé teu Deus te dará, para que a possuas como herança."
,"5":"Isto, porém, com a condição de que obedeças de facto a Javé teu Deus, procurando pôr em prática todos os mandamentos que hoje te ordeno."
,"6":"Quando Javé teu Deus te tiver abençoado, conforme prometeu, emprestarás a muitas nações e nunca pedirás emprestado; dominarás muitas nações, mas nunca serás dominado."
,"7":"Quando junto de ti houver um pobre, mesmo que seja um só dos teus irmãos, numa das tuas cidades, na terra que Javé teu Deus te dará, não endureças o coração, nem feches a mão a esse irmão pobre."
,"8":"Pelo contrário, abre a mão e empresta-lhe o que lhe falta, na medida das suas necessidades."
,"9":"Guarda-te de alimentar em teu coração este pensamento mesquinho: 'Já está a chegar o sétimo ano, o ano da remissão', tornando-te avarento com o teu irmão pobre, recusando-te a socorrê-lo. Ele clamaria a Javé contra ti, e em ti haveria um pecado."
,"10":"Quando lhe deres alguma coisa, não o faças de má vontade, porque, em resposta a esse gesto, Javé teu Deus te abençoará em todos os teus trabalhos e em todas as tuas iniciativas."
,"11":"Vê bem! Não faltam indigentes na Terra. É por isso que te ordeno: abre a mão em favor do teu irmão, do teu pobre e do teu indigente na tua terra."
,"12":"Quando um dos teus irmãos, hebreu ou hebreia, te for vendido como escravo, ele servir-te-á durante seis anos. No sétimo ano, deixá-lo-ás ir em liberdade."
,"13":"Contudo, quando o deixares ir em liberdade, não o despeças de mãos vazias:"
,"14":"carrega os seus ombros com o produto do teu rebanho, da tua colheita de cereais e de uva. Dá-lhe de acordo com a bênção que Javé teu Deus te tiver concedido."
,"15":"Lembra-te de que foste escravo no Egipto, e que Javé teu Deus te resgatou. É por isso que hoje te dou esta ordem."
,"16":"Mas se ele disser: 'Não me quero ir embora porque me afeiçoei a ti e à tua família', dado que se sente bem contigo,"
,"17":"pega numa sovela e fura-lhe a orelha contra a porta, e então ele será teu escravo para sempre. Faz o mesmo com a tua escrava."
,"18":"Não fiques contrariado em deixá-lo ir em liberdade: ele serviu-te durante seis anos por metade do salário de um mercenário. E Javé teu Deus abençoar-te-á em tudo o que fizeres."
,"19":"Todo o primogénito macho que nascer das tuas vacas ou ovelhas deverá ser consagrado a Javé teu Deus. Não trabalhes com o primogénito das tuas vacas, nem tosquies o primogénito das tuas ovelhas."
,"20":"Comê-lo-ás em cada ano diante de Javé teu Deus, juntamente com a tua família, no lugar que Javé tiver escolhido."
,"21":"Se o primogénito tiver algum defeito - se for coxo ou cego, ou tiver algum outro defeito grave -, não o sacrifiques a Javé teu Deus;"
,"22":"poderás comê-lo na tua própria cidade, o puro juntamente com o impuro, assim como se come a gazela ou o veado."
,"23":"Não comas, porém, o sangue: derrama-o no chão como se fosse água."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Respeita o mês de Abib, celebrando uma páscoa para Javé teu Deus, porque foi numa noite do mês de Abib que Javé teu Deus te tirou do Egipto."
,"2":"Sacrifica a Javé teu Deus uma páscoa, ovelhas e bois, no lugar que Javé teu Deus tiver escolhido para ali fazer habitar o seu Nome."
,"3":"Não comas pão fermentado com a páscoa. Durante sete dias comerás com ela pães sem fermento - um pão de miséria -, pois saíste do Egipto à pressa. Assim, durante todos os dias da tua vida, vais lembrar-te do dia em que saíste do Egipto."
,"4":"Durante sete dias não deverá haver fermento em todo o teu território, e não deverá sobrar para a manhã seguinte coisa nenhuma da carne que tiveres sacrificado na tarde do primeiro dia."
,"5":"Não poderás sacrificar a páscoa em qualquer cidade que Javé teu Deus te vai dar,"
,"6":"mas somente no lugar que Javé teu Deus tiver escolhido para lá fazer habitar o seu Nome. Sacrifica a páscoa à tarde, ao pôr do sol, hora em que saíste do Egipto."
,"7":"Cozê-la-ás e comê-la-ás no lugar que Javé teu Deus tiver escolhido. Na manhã seguinte, voltarás para as tuas tendas."
,"8":"Durante seis dias comerás pães sem fermento e, no sétimo dia, farás uma reunião solene em honra de Javé teu Deus. Não faças nenhum trabalho."
,"9":"Conta sete semanas. A partir do momento em que começares a ceifar as searas, conta sete semanas."
,"10":"Celebra então a festa das semanas em honra de Javé teu Deus. A oferta espontânea que fizeres deverá ser proporcional ao modo como Javé teu Deus te tiver abençoado."
,"11":"Farás uma festa diante de Javé teu Deus - juntamente com o teu filho e a tua filha, o teu escravo e a tua escrava, com o levita que vive na tua cidade e o imigrante, o órfão e a viúva que vivem junto de ti - no lugar que Javé teu Deus tiver escolhido para lá fazer habitar o seu Nome."
,"12":"Lembra-te de que foste escravo no Egipto, e procura pôr em prática esses estatutos."
,"13":"Celebra a festa das Tendas durante sete dias, depois de teres recolhido o produto da tua colheita de cereais e de uvas."
,"14":"Faz uma festa alegre com o teu filho e a tua filha, o teu escravo e a tua escrava, o levita e o imigrante, o órfão e a viúva que vivem nas tuas cidades."
,"15":"Durante sete dias festejarás em honra de Javé seu Deus, no lugar que Javé tiver escolhido, pois Javé teu Deus vai abençoar-te em todas as tuas colheitas e em todos os trabalhos das tuas mãos, para que fiques cheio de alegria."
,"16":"Por isso, três vezes por ano todo o homem deverá comparecer diante de Javé teu Deus, no lugar que Ele tiver escolhido: na festa dos Pães sem fermento, na festa das Semanas e na festa das Tendas. Que ninguém se apresente de mãos vazias diante de Javé:"
,"17":"cada um traga a sua oferta, conforme a bênção que Javé teu Deus lhe tiver concedido."
,"18":"Nomeia juízes e oficiais de justiça para cada uma das cidades que Javé teu Deus te vai dar, para cada uma das suas tribos, para que julguem o povo com sentenças justas."
,"19":"Não pervertas o direito, não faças diferença entre as pessoas, nem aceites suborno, pois o suborno cega os olhos dos sábios e falseia a causa dos justos."
,"20":"Procura somente a justiça, para que vivas e tomes posse da terra que Javé teu Deus te vai dar."
,"21":"Não plantes um poste sagrado ou árvore junto a um altar que tenhas feito para Javé teu Deus,"
,"22":"nem levantes uma estela, porque Javé teu Deus odeia-a."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Nunca sacrifiques a Javé teu Deus um boi ou uma ovelha com defeito grave: seria abominação para Javé teu Deus."
,"2":"Se em alguma das cidades, que Javé teu Deus te vai dar, for encontrado homem ou mulher que faça o que Javé teu Deus reprova, violando a sua aliança,"
,"3":"para servir a outros deuses e os adorar - o Sol, a Lua ou todo o exército do céu - fazendo o que eu proibi;"
,"4":"se isso te for denunciado, ou vieres a saber, faz primeiro uma cuidadosa investigação. Se for verdade e se se verificar que tal abominação foi cometida em Israel,"
,"5":"levarás às portas da cidade o homem ou mulher que tenha cometido essa má acção, e apedrejá-los-ás até que morram."
,"6":"Poderás condenar alguém à morte somente com o depoimento de duas ou três testemunhas; ninguém será morto pelo depoimento de uma só testemunha."
,"7":"E as primeiras pessoas a apedrejá-lo serão as testemunhas e, depois delas, todo o povo. Deste modo eliminarás o mal do meio de ti."
,"8":"Quando tiveres que julgar uma causa que pareça muito difícil - causas duvidosas de homicídio, contenda, lesões mortais, ou causas controversas na tua cidade - sobe ao lugar que Javé teu Deus tiver escolhido."
,"9":"Vai ter com os sacerdotes levitas e o juiz que estiver em função nesses dias. Eles investigarão e anunciar-te-ão a sentença."
,"10":"Faz tudo de acordo com a sentença que eles te anunciarem nesse lugar que Javé tiver escolhido. Procura agir conforme as instruções deles."
,"11":"Cumpre a decisão que eles derem e põe em prática a sentença, sem te desviares nem para a direita nem para a esquerda."
,"12":"Quem agir com presunção, sem obedecer ao sacerdote, que lá está para servir a Javé teu Deus, nem ao juiz, tal homem deverá ser morto. Deste modo eliminarás o mal do meio de Israel."
,"13":"Ao ouvir isto, todo o povo temerá e nunca mais agirá com presunção."
,"14":"Quando tiveres entrado na Terra que Javé teu Deus te vai dar, e tiveres tomado posse dela e nela viveres, e disseres: 'Quero ter sobre mim um rei como o têm todas as nações que me rodeiam',"
,"15":"então deverás nomear para ti um rei que tenha sido escolhido por Javé teu Deus. Um dos teus irmãos é que nomearás como teu rei. Não poderás nomear um estrangeiro, que não seja teu irmão."
,"16":"O rei não deverá multiplicar cavalos para si, nem fazer que o povo volte para o Egipto, para aumentar a sua cavalaria, pois Javé disse-vos: 'Nunca mais volteis por esse caminho'."
,"17":"Ele também não deverá multiplicar o número das suas mulheres, para que a sua mente não se desvie. E também não acumulará para si prata e ouro."
,"18":"Quando subir ao trono, mandará escrever num livro, para seu próprio uso, uma cópia desta lei, ditada pelos sacerdotes levitas."
,"19":"Ela ficará sempre com ele, que a lerá todos os dias da sua vida, para que aprenda a temer a Javé seu Deus, observando todas as palavras desta lei e pondo estes estatutos em prática."
,"20":"Deste modo, não se levantará orgulhosamente sobre os seus irmãos, nem se desviará destes mandamentos, nem para a direita nem para a esquerda. Assim, prolongará os dias do seu reinado, juntamente com os seus filhos, no meio de Israel."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Os sacerdotes levitas, a tribo inteira de Levi, não terão parte nem herança em Israel. Eles viverão da herança de Javé, comendo das oblações que Lhe são oferecidas."
,"2":"Esta tribo não terá parte na herança dos seus irmãos. Javé é a sua herança, conforme Ele próprio lhes disse."
,"3":"São estes os direitos que os sacerdotes têm sobre o povo, sobre aqueles que oferecem um sacrifício: do boi ou da ovelha, serão dados ao sacerdote o quarto dianteiro, as mandíbulas e o estômago."
,"4":"E tu, dá-lhe os primeiros frutos do teu trigo, do teu vinho novo e do teu azeite e também o primeiro produto da tosquia do teu rebanho."
,"5":"Pois foi a ele que Javé teu Deus escolheu dentre todas as tuas tribos, juntamente com seus filhos, para estar diante de Javé teu Deus, realizando o serviço divino e dando todos os dias a bênção em nome de Javé."
,"6":"Quando vier um levita de alguma das tuas cidades, onde quer que ele more em todo o Israel, e com todo o desejo do coração vier para o lugar que Javé tiver escolhido,"
,"7":"poderá oficiar em nome de Javé seu Deus, da mesma forma que todos os seus irmãos que ali permanecem ao serviço de Javé."
,"8":"Ele poderá comer uma parte igual à que lhes cabe, independente do produto da venda do seu património."
,"9":"Quando entrares na Terra que Javé teu Deus te vai dar, não imites as práticas abomináveis das nações que lá vivem."
,"10":"Não haja no meio de ti alguém que queime o próprio filho ou filha, que faça presságios, pratique astrologia, adivinhação ou magia,"
,"11":"que pratique encantamentos, consulte espíritos ou adivinhos, ou também que invoque os mortos."
,"12":"Pois quem pratica essas coisas é abominável para Javé, e é por causa dessas práticas abomináveis que Javé teu Deus vai desalojar essas nações."
,"13":"Tu pertencerás inteiramente a Javé teu Deus."
,"14":"As nações que vais conquistar ouvem astrólogos e adivinhos. Javé teu Deus, porém, não permite que faças isso."
,"15":"Javé teu Deus fará surgir, dentre os teus irmãos, um profeta como eu no meio de ti e ouvi-lo-ás."
,"16":"Foi o que pediste a Javé teu Deus, no Horeb, no dia da assembleia: 'Não quero continuar a ouvir a voz de Javé meu Deus, nem quero ver mais este fogo terrível, para não morrer'."
,"17":"Javé disse-me: 'Eles têm razão."
,"18":"Do meio dos seus irmãos, Eu farei surgir para eles um profeta como tu. Vou colocar as minhas palavras na tua boca, e ele dir-lhes-á tudo o que Eu lhe mandar."
,"19":"Se alguém não ouvir as minhas palavras, que esse profeta pronunciar em meu nome, Eu mesmo lhe pedirei contas."
,"20":"Contudo, se o profeta tiver a ousadia de dizer em meu nome alguma coisa que Eu não tenha mandado, ou se falar em nome de outros deuses, tal profeta deverá ser morto'."
,"21":"Talvez perguntes: 'Como vamos distinguir se uma palavra não é palavra de Javé'?"
,"22":"Se o profeta fala em nome de Javé, mas a palavra não se cumpre e não se realiza, trata-se então de uma palavra que Javé não disse. Tal profeta falou com presunção. Não tenhas medo dele."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Quando Javé teu Deus tiver eliminado as nações, cuja terra Javé teu Deus te vai dar, e quando as tiveres conquistado e morares nas suas cidades e casas,"
,"2":"deverás reservar três cidades na terra que Javé teu Deus te dará."
,"3":"Constrói estradas, mede as distâncias e divide em três partes o território que Javé teu Deus te dará como herança, para que qualquer homicida encontre refúgio na cidade."
,"4":"O homicida que ali se poderá refugiar é aquele que tiver matado o seu próximo involuntariamente, sem o ter odiado antes."
,"5":"Por exemplo: alguém vai ao bosque com o seu próximo para cortar lenha; impelindo com força o machado para cortar a árvore, o ferro escapa do cabo, atinge o companheiro e mata-o. Tal pessoa poderá, então, refugiar-se numa dessas cidades, ficando com a vida a salvo,"
,"6":"para que o vingador do sangue, enfurecido, não persiga o homicida e o alcance (porque o caminho é longo), matando-o sem motivo suficiente, pois antes ele não era inimigo do outro."
,"7":"É por isso que te ordeno: reserva três cidades."
,"8":"E quando Javé teu Deus fizer com que as tuas fronteiras se alarguem, como jurou aos teus antepassados, e te der toda a Terra que prometeu dar aos teus antepassados -"
,"9":"com a condição de pores em prática todos estes mandamentos que hoje eu te ordeno, amando a Javé teu Deus e andando continuamente nos seus caminhos - acrescentarás mais três cidades àquelas três primeiras,"
,"10":"para que não se derrame sangue inocente na terra que Javé teu Deus te dará como heran-ça, para que sobre ti não recaia um homicídio."
,"11":"Todavia, se alguém é inimigo do seu próximo e lhe arma uma cilada, atacando-o e ferindo-o mortalmente, e depois se refugia numa dessas cidades,"
,"12":"os anciãos da sua cidade mandarão pessoas para o tirarem de lá e o entregarem ao vingador do sangue, para que seja morto."
,"13":"Não tenhas piedade dele. Deste modo, eliminarás de Israel o derramamento de sangue inocente, e serás feliz."
,"14":"Não mudes os marcos do vizinho, colocados pelos antepassados no património que irás receber como herança na Terra que Javé teu Deus te dará como propriedade."
,"15":"Uma só testemunha não é suficiente contra alguém, seja qual for o seu crime ou pecado. Em todo o pecado que alguém tiver cometido, o processo será aberto pelo depoimento pessoal de duas ou três testemunhas."
,"16":"Quando uma falsa testemunha se levantar contra alguém, acusando-o de rebelião,"
,"17":"as duas partes em litígio apresentar-se-ão diante de Javé, aos sacerdotes e juízes que estiverem nesses dias em função."
,"18":"Os juízes deverão fazer uma cuidadosa investigação. Se a testemunha for falsa e tiver caluniado o seu irmão,"
,"19":"então tratá-la-eis do mesmo modo que ela própria maquinava tratar o seu próximo. Deste modo, eliminarás o mal do meio de ti."
,"20":"Os outros ouvirão, ficarão com medo, e nunca mais cometerão semelhante mal no meio de ti."
,"21":"Não tenhas piedade: vida por vida, olho por olho, dente por dente, mão por mão, pé por pé."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Quando saíres para a guerra contra os inimigos, ao ver cavalos, carros e tropas mais numerosas do que as tuas, não tenhas medo, pois contigo está Javé teu Deus, que te fez sair do Egipto."
,"2":"Quando estiverdes para começar o combate, o sacerdote aproximar-se-á para falar aos soldados,"
,"3":"e dirá: 'Escuta, Israel! Vós hoje estais prontos para guerrear contra os vossos inimigos. Não vos acobardeis, nem fiqueis com medo, não tremais nem vos apavoreis diante deles,"
,"4":"porque Javé vosso Deus marcha convosco, lutando por vós contra os inimigos, para vos dar a vitória'."
,"5":"Os chefes também falarão ao povo, dizendo: 'Quem construiu uma casa nova e ainda não a consagrou? Pode retirar-se e voltar para casa, a fim de que não morra na batalha e outro consagre a casa."
,"6":"Quem plantou uma vinha e ainda não colheu os seus primeiros frutos? Pode retirar-se e voltar para casa, a fim de que não morra na batalha e outro colha os primeiros frutos."
,"7":"Quem é noivo de uma mulher e ainda não se casou com ela? Pode retirar-se e voltar para casa, a fim de que não morra na batalha e outro se case com ela'."
,"8":"E os chefes continuarão a dizer aos soldados: 'Quem está com medo e se sente covarde? Pode retirar-se e voltar para casa, a fim de que a covardia não contagie os seus irmãos'."
,"9":"Quando acabarem de falar aos soldados, os chefes nomearão os comandantes para chefiar as tropas."
,"10":"Quando estiveres para atacar uma cidade, primeiro propõe-lhe a paz."
,"11":"Se ela aceitar a paz, te abrir as portas, todos os habitantes te servirão em trabalhos forçados."
,"12":"Todavia, se não aceitar a tua proposta de paz, mas declarar guerra, cercá-la-ás."
,"13":"Javé teu Deus entregar-ta-á e passarás a fio de espada todos os homens."
,"14":"Quanto às mulheres, crianças, animais e tudo o que houver na cidade, tomá-los-ás como despojo, e comerás o despojo dos inimigos que Javé teu Deus te entregou."
,"15":"Faz assim com todas as cidades que estiverem distantes e não pertencem a essas nações."
,"16":"Todavia, quanto às cidades dessas nações que Javé teu Deus te vai dar como herança, não deixes sobreviver nenhum ser vivo:"
,"17":"sacrifica como anátema os heteus, os amorreus, os cananeus, os ferezeus, os heveus e os jebuseus, conforme Javé teu Deus te ordenou,"
,"18":"para que não te ensinem a praticar nenhuma das práticas abomináveis que eles cometem com os seus deuses: pecaríeis contra Javé vosso Deus."
,"19":"Quando tiveres que cercar uma cidade durante muito tempo, antes de a atacar e tomar, não cortes as árvores a machado; alimenta-te delas sem as cortar: acaso a árvore do campo é um homem, para que a trates como inimigo?"
,"20":"Contudo, se sabes que tal árvore não é frutífera, então podes cortá-la e usá-la para fazer instrumentos de assalto contra a cidade que está em guerra contra ti, até que a tenhas conquistado."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Quando for encontrado um homem morto no campo, na terra que Javé teu Deus te vai dar como propriedade, e ninguém souber quem foi que o matou,"
,"2":"os anciãos e juízes sairão e medirão as distâncias até às cidades que estiverem ao redor do morto,"
,"3":"para determinar a cidade mais próxima. A seguir, os anciãos da cidade mais próxima tomarão uma novilha, com a qual não se tenha trabalhado e que ainda não tenha usado canga."
,"4":"Os anciãos dessa cidade levarão a novilha até a um riacho permanente, no lugar onde ninguém trabalha nem semeia. E ali, sobre o riacho, desnucarão a novilha."
,"5":"Depois aproximar-se-ão os sacerdotes levitas, pois foram eles que Javé teu Deus escolheu para o seu serviço e para abençoar em nome de Javé, cabendo também a eles resolver qualquer litígio ou crime."
,"6":"Os anciãos da cidade mais próxima do lugar do crime lavarão as mãos sobre a novilha desnucada,"
,"7":"fazendo a seguinte declaração: 'As nossas mãos não derramaram este sangue e os nossos olhos não viram nada."
,"8":"Perdoa ao teu povo Israel, que resgataste, ó Javé. Não permitas que o sangue inocente recaia sobre Israel, teu povo, e este sangue lhe será perdoado'."
,"9":"Deste modo, eliminarás do meio de ti o derramamento de sangue inocente e farás o que Javé aprova."
,"10":"Quando guerreares contra os teus inimigos, e Javé teu Deus os entregar em teu poder, e tiveres feito prisioneiros,"
,"11":"se encontrares entre eles uma mulher bonita e te enamorares dela, poderás tomá-la como esposa,"
,"12":"e levá-la para casa. Ela então rapará a cabeça, cortará as unhas,"
,"13":"tirará a roupa de prisioneira e ficará na casa onde moras. Durante um mês ela chorará seu pai e sua mãe. Depois do luto, unir-te-ás a ela e tornar-te-ás seu marido e ela será tua esposa."
,"14":"Mais tarde, caso não gostes mais dela, deixa-a ir em liberdade, mas não a vendas por dinheiro; não queiras obter lucro depois de a teres usado."
,"15":"Se alguém tiver duas mulheres e gostar de uma e não da outra, e as duas lhe tiverem dado filhos, se o primogénito é filho da mulher da qual ele não gosta,"
,"16":"esse homem, quando repartir a herança entre os filhos, não poderá tratar o filho da mulher que ama como se fosse o mais velho, prejudicando o filho da mulher da qual não gosta, mas que é o verdadeiro primogénito."
,"17":"Deverá reconhecer como primogénito o filho da mulher da qual ele não gosta, dando-lhe porção dupla de tudo quanto possui, pois esse filho é o primeiro fruto da sua virilidade. A ele pertence o direito de primogenitura."
,"18":"Se alguém tiver um filho rebelde e incorrigível, que não obedece ao pai e à mãe e não os ouve, nem quando o corrigem,"
,"19":"o pai e a mãe pegarão nele, levá-lo-ão aos anciãos da cidade para ser julgado."
,"20":"E dirão aos anciãos da cidade: 'Este nosso filho é rebelde e incorrigível: não nos obedece, é devasso e beberrão'."
,"21":"E todos os homens da cidade o apedrejarão até que morra. Deste modo, eliminarás o mal do meio de ti, e todo o Israel ouvirá e ficará com medo."
,"22":"Se um homem condenado à pena de morte for executado e suspenso de uma árvore,"
,"23":"o seu cadáver não poderá permanecer na árvore durante a noite. Deverás sepultá-lo no mesmo dia, pois quem é suspenso torna-se um maldito de Deus. Deste modo, não tornarás impuro o solo que Javé teu Deus te dará como herança."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Se vires extraviados o boi ou a ovelha do teu irmão, não fiques indiferente a eles: devolve-os ao teu irmão."
,"2":"Se o teu irmão não é teu vizinho ou se não o conheces, recolhe na tua propriedade o boi ou a ovelha e guarda-os até que o teu irmão os procure. Então devolvê-los-ás."
,"3":"Faz o mesmo com o jumento, com o manto e com qualquer objecto perdido pelo teu irmão e que tenhas encontrado. Não fiques indiferente a eles."
,"4":"Se vires o jumento ou o boi do teu irmão caídos no caminho, não fiques indiferente: ajuda-o a levantar o animal."
,"5":"A mulher não deverá usar roupas masculinas, nem o homem se vestirá com roupas de mulher, pois quem assim age é abominável para Javé teu Deus."
,"6":"Se pelo caminho, numa árvore ou no chão, encontrares um ninho de pássaros com filhotes ou ovos, e a mãe sobre os filhotes ou sobre os ovos, não apanhes a mãe que está sobre os filhotes;"
,"7":"deixa voar a mãe em liberdade, e só depois poderás ficar com os filhotes, para que tudo te corra bem e prolongues os teus dias."
,"8":"Quando construíres uma casa nova, faz um parapeito no terraço; deste modo, evitas que a tua casa seja responsável pela vingança do sangue, caso alguém caia do terraço."
,"9":"Não semeies na tua vinha duas espécies de sementes, para evitar que a vinha inteira fique consagrada, tanto a semente que semeares, como o fruto da vinha."
,"10":"Não lavres com boi e jumento atrelados juntos."
,"11":"Não vistas roupa mesclada de lã e linho."
,"12":"Faz borlas nas quatro pontas do manto com que te cobrires."
,"13":"Se um homem se casa com uma mulher e começa a detestá-la depois de ter tido relações com ela,"
,"14":"acusando-a de actos vergonhosos e difamando-a publicamente, dizendo: 'Casei-me com esta mulher mas, quando me aproximei dela, descobri que não era virgem',"
,"15":"o pai e a mãe da jovem tomarão a prova da virgindade dela e levarão a prova aos anciãos da cidade para que julguem o caso."
,"16":"Então o pai da jovem dirá aos anciãos: 'Dei a minha filha como esposa a este homem, mas ele detesta-a,"
,"17":"e acusa-a de actos vergonhosos, dizendo que a minha filha não era virgem. Mas aqui está a prova da virgindade da minha filha!' E estenderá o lençol diante dos anciãos da cidade."
,"18":"Os anciãos da cidade tomarão o homem, mandarão castigá-lo"
,"19":"e multá-lo-ão em cem moedas de prata, que serão entregues ao pai da jovem, por ter sido difamada publicamente uma virgem de Israel. Além disso, ela continuará a ser sua mulher, e o marido não poderá mandá-la embora durante toda a sua vida."
,"20":"Se a denúncia for verdadeira, isto é, se não acharem a prova da virgindade da donzela,"
,"21":"levarão a jovem até à porta da casa de seu pai, e os homens da cidade apedrejá-la-ão até que morra, pois ela cometeu uma infâmia em Israel, desonrando a casa de seu pai. Deste modo, eliminarás o mal do meio de ti."
,"22":"Se um homem for apanhado em flagrante a ter relações sexuais com uma mulher casada, ambos serão mortos, tanto o homem como a mulher. Deste modo, eliminarás esse mal de Israel."
,"23":"Se houver uma jovem prometida a um homem, e um outro tiver relações com ela na cidade,"
,"24":"levareis os dois à porta da cidade e apedrejá-los-eis até que morram: a jovem por não ter gritado por socorro na cidade, e o homem por ter violentado a mulher do seu próximo. Deste modo, eliminarás o mal do meio de ti."
,"25":"Contudo, se o homem encontrou a jovem no campo, a violentou e teve relações com ela, morrerá somente o homem que teve relações com ela;"
,"26":"não faças nada à jovem, porque ela não tem pecado que mereça a morte. É como o caso do homem que ataca o seu próximo e o mata:"
,"27":"ele encontrou-a no campo e a jovem pode ter gritado, mas não havia quem a socorresse."
,"28":"Se um homem encontra uma jovem que não está prometida em casamento e a agarra e tem relações com ela e é apanhado em flagrante,"
,"29":"o homem que teve relações com ela dará ao pai da jovem cinquenta moedas de prata, e ela tornar-se-á sua mulher. Uma vez que a violentou, não poderá mandá-la embora durante toda a sua vida."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Um homemnão tomará a mulher de seu pai, para não retirar dela o pano do manto de seu pai."
,"2":"O homem com testículos esmagados ou com o membro viril cortado não poderá entrar na assembleia de Javé."
,"3":"Nenhum bastardo poderá entrar na assembleia de Javé, e os seus descendentes até à décima geração não poderão entrar na assembleia de Javé."
,"4":"O amonita e o moabita não poderão entrar na assembleia de Javé, e também os seus descendentes nem na décima geração serão admitidos nela."
,"5":"Isso porque não foram ao vosso encontro com pão e água, quando caminháveis depois da saída do Egipto, e porque pagaram a Balaão, filho de Beor, de Petor em Aram Naaraim, para que vos amaldiçoasse."
,"6":"No entanto, Javé teu Deus não fez caso de Balaão, e Javé teu Deus transformou a maldição em bênção, porque Javé teu Deus te ama."
,"7":"Portanto, enquanto viveres, nunca favoreças a sua prosperidade e felicidade."
,"8":"Não consideres o edomita como abominável, pois é teu irmão. Não consideres o egípcio como abominável, porque foste um estrangeiro na sua terra."
,"9":"Na terceira geração, os seus descendentes terão acesso à assembleia de Javé."
,"10":"Quando estiveres acampado contra o inimigo, guarda-te de toda a espécie de mal."
,"11":"Se, no meio de vós, alguém ficar impuro por causa de uma polução nocturna, deverá sair para fora do acampamento, e não voltará."
,"12":"Ao entardecer, tomará banho, e ao pôr do sol poderá voltar ao acampamento."
,"13":"Providencia um lugar fora do acampamento para as tuas necessidades."
,"14":"Com o teu equipamento, terás sempre uma pá. Quando saíres para fazer as necessidades, abrirás uma cova com ela e, ao terminar, cobrirás as fezes."
,"15":"Porque Javé teu Deus anda pelo acampamento para te proteger e te entregar os teus inimigos. Por isso o acampamento deve ser santo, para que Javé não veja nada de inconveniente e não Se afaste de ti."
,"16":"Quando um escravo fugir do seu patrão e se refugiar junto de ti, não o devolvas ao patrão."
,"17":"Ele permanecerá contigo, entre os teus, no lugar que escolher, numa das tuas cidades, onde lhe pareça melhor. Não o explores."
,"18":"Entre as israelitas não haverá prostituta sagrada, nem prostituto sagrado entre os israelitas."
,"19":"Não leves à casa de Javé teu Deus, como cumprimento de um voto, o salário de uma prostituta sagrada, nem o pagamento de um prostituto sagrado, porque os dois são abomináveis para Javé teu Deus."
,"20":"Não emprestes ao teu irmão com juros, quer se trate de empréstimo em dinheiro, quer em alimentos ou qualquer outra coisa sobre a qual é costume cobrar juros."
,"21":"Poderás emprestar com juros ao estrangeiro. Mas ao teu irmão empresta sem cobrar juros, para que Javé teu Deus abençoe tudo o que fizeres na Terra em que vais entrar para dela tomar posse."
,"22":"Quando ofereceres um voto a Javé teu Deus, não tardes em cumpri-lo, porque Javé teu Deus te pediria contas disso e em ti haveria um pecado."
,"23":"Se não fizeres nenhum voto, não pecas."
,"24":"Mas terás de cumprir o voto que fizeste, uma vez que, com a tua própria boca, prometeste espontaneamente um voto a Javé teu Deus."
,"25":"Quando entrares na vinha do teu próximo, podes comer à vontade até ficares saciado, mas não leves nada no teu cesto."
,"26":"E quando entrares na plantação do teu próximo, podes arrancar as espigas com a mão, mas não meterás a foice na seara do teu próximo."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Quando um homem se casa com uma mulher e consuma o matrimónio, se depois deixa de gostar dela, por ter visto nela alguma coisa inconveniente, escreva-lhe um documento de divórcio e entregue-lho, deixando-a sair de casa em liberdade."
,"2":"Tendo saído da sua casa, se ela se casar com outro,"
,"3":"e também este se divorciar dela e lhe entregar nas mãos um documento de divórcio e a deixar ir embora em liberdade, ou se o segundo marido morrer,"
,"4":"então o primeiro marido, que se havia divorciado dela, não poderá casar-se outra vez com ela, pois estará contaminada: seria um acto abominável diante de Javé. Não deves tornar culpada de pecado a Terra que Javé teu Deus te vai dar como herança."
,"5":"Quando um homem for recém-casado, não ficará obrigado ao serviço militar nem a outros trabalhos públicos: terá um ano de licença em casa, alegrando a mulher com quem se casou."
,"6":"Não tomes como penhor as duas mós do moinho, nem mesmo a mó de cima, porque seria o mesmo que penhorar uma vida."
,"7":"Se alguém for apanhado em flagrante, a sequestrar um irmão israelita, para o explorar ou vender, tal sequestrador deverá ser morto. Deste modo, eliminarás o mal do meio de ti."
,"8":"Quando houver lepra, cumpre exactamente as instruções dadas pelos sacerdotes levitas. Ponde em prática tudo o que lhes ordenei."
,"9":"Lembra-te do que Javé teu Deus fez a Maria, no caminho, quando saístes do Egipto."
,"10":"Quando fizeres algum empréstimo ao teu próximo, não entres em sua casa para tomar alguma coisa como penhor."
,"11":"Fica do lado de fora, e o homem a quem fizeste o empréstimo, ele é que sairá para te levar o penhor."
,"12":"Se for pobre, não irás dor-mir sem lhe entregares o seu penhor;"
,"13":"ao pôr do sol deverás devolver-lhe sem falta o penhor, para que ele durma com o seu manto e te abençoe. Para ti isto será um acto de justiça diante de Javé teu Deus."
,"14":"Não explores um assalariado pobre e necessitado, quer seja um dos teus irmãos quer seja um imigrante que vive na tua terra, na tua cidade."
,"15":"Paga-lhe o salário todos os dias, antes que o sol se ponha, porque é pobre e a sua vida depende disso. Assim, não clamará a Javé contra ti, e em ti não haverá pecado."
,"16":"Os pais não serão mortos pela culpa dos filhos, nem os filhos pela culpa dos pais. Cada um será executado pelo seu próprio crime."
,"17":"Não distorças o direito do estrangeiro e do órfão, nem tomes como penhor o vestido da viúva."
,"18":"Lembra-te de que foste escravo no Egipto e que Javé teu Deus te libertou. É por isso que te ordeno para agires deste modo."
,"19":"Quando fizeres a ceifa do teu campo e esqueceres algum feixe, não voltes atrás para o levar. Deixa-o para o imigrante, o órfão e a viúva. Deste modo, Javé teu Deus te abençoará em todos os teus trabalhos."
,"20":"Quando colheres as azeitonas das tuas oliveiras, não voltes para colher algumas que ficaram nos ramos; o resto será para o imigrante, o órfão e a viúva."
,"21":"Quando colheres as uvas da tua vinha, não voltes para procurar o que ficou: o resto será para o imigrante, o órfão e a viúva."
,"22":"Lembra-te de que foste escravo no Egipto. É por isso que Eu te ordeno para agires deste modo."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Quando houver demanda entre dois homens e forem à justiça, eles serão julgados, absolvendo-se o inocente e condenando-se o culpado."
,"2":"Se o culpado merecer açoites, o juiz ordenará que se deite no chão e mandá-lo-á açoitar na sua presença, com número de açoites proporcional à culpa."
,"3":"Podem açoitá-lo até quarenta vezes, não mais; isso para não acontecer que a ferida se torne grave, caso seja açoitado mais vezes, e o teu irmão fique marcado diante de ti."
,"4":"Não açaimes o boi que debulha o grão."
,"5":"Quando dois irmãos moram juntos e um deles morre sem deixar filhos, a viúva não sairá de casa para se casar com um estranho; o seu cunhado casar-se-á com ela, cumprindo o dever de cunhado."
,"6":"O primogénito que nascer receberá o nome do irmão morto, para que o nome deste não se apague em Israel."
,"7":"Contudo, se o cunhado se nega a casar-se com a viúva, esta irá ter com os anciãos no tribunal, e dirá: 'O meu cunhado nega-se a transmitir o nome do seu irmão em Israel; não quer cumprir comigo o seu dever de cunhado'."
,"8":"Os anciãos da cidade convocá-lo-ão e procurarão convencê-lo. Se ele persiste e diz que não quer casar-se com ela,"
,"9":"então a viúva aproximar-se-á dele, diante dos anciãos, tirar-lhe-á a sandália do pé, cuspir-lhe-á no rosto, e fará esta declaração: 'Isto é o que se faz com um homem que não edifica a casa do seu irmão'."
,"10":"E em Israel esse homem ficará com o apelido de 'a família do descalçado'."
,"11":"Quando dois homens estiverem a lutar, um homem contra o seu irmão, e a mulher de um deles se aproximar para livrar o marido dos socos do outro e estender a mão, agarrando-o pelas partes vergonhosas,"
,"12":"corta-lhe a mão. Não tenhas piedade."
,"13":"Não tenhas na tua bolsa dois pesos desiguais, um mais pesado e outro mais leve."
,"14":"Não tenhas na tua casa duas medidas desiguais, uma maior e outra menor."
,"15":"Terás um peso exacto e justo e uma medida exacta e justa, para que os teus dias se prolonguem sobre a Terra que Javé teu Deus te vai dar."
,"16":"Porque Javé teu Deus abomina todos os que fazem tais coisas, todos os que cometem injustiça."
,"17":"Lembra-te do que Amalec fez no caminho, quando saíste do Egipto:"
,"18":"ele veio ao teu encontro, quando estavas cansado e sem forças e, sem temer a Deus, atacou pelas costas todos os desfalecidos que iam atrás."
,"19":"Quando Javé teu Deus puser fim às hostilidades com os inimigos que te cercam, na Terra que Javé teu Deus te dará como herança, deverás apagar de debaixo do céu a memória de Amalec. Não te esqueças disso."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Quando entrares na Terra que Javé teu Deus te vai dar como herança, quando tomares posse dela e nela habitares,"
,"2":"toma os primeiros frutos que recolheres da Terra que Javé teu Deus te vai dar, coloca-os num cesto e vai ao lugar que Javé teu Deus tiver escolhido para ali fazer habitar o seu Nome."
,"3":"Vai ter com o sacerdote em função nesses dias e diz-lhe: 'Hoje eu confesso a Javé meu Deus que entrei na Terra que Javé tinha jurado aos nossos antepassados'."
,"4":"O sacerdote receberá o cesto da tua mão, e colocá-lo-á diante do altar de Javé teu Deus."
,"5":"Então, tomando a palavra, dirás diante de Javé teu Deus: 'Meu pai era um arameu errante que desceu ao Egipto e ali residiu com poucas pessoas. Depois tornou-se uma nação grande, forte e numerosa."
,"6":"Os egípcios, porém, maltrataram-nos e humilharam-nos, impondo uma dura escravidão sobre nós."
,"7":"Clamámos então a Javé, Deus dos nossos antepassados, e Javé ouviu a nossa voz. Ele viu a nossa miséria, o nosso sofrimento e a nossa opressão."
,"8":"E Javé tirou-nos do Egipto com mão forte e braço estendido, no meio de grande terror, com sinais e prodígios."
,"9":"E trouxe-nos para este lugar, dando-nos esta terra: uma Terra onde corre leite e mel."
,"10":"Por isso, aqui estou, Javé, com os primeiros frutos da Terra que me deste'. Colocarás os primeiros frutos diante de Javé teu Deus e diante de Javé teu Deus te prostrarás."
,"11":"Então alegrar-te-ás com todas as coisas boas que Javé teu Deus te tiver dado a ti e à tua família. E também festejarão contigo o levita e o imigrante que moram junto de ti."
,"12":"Cada três anos, no ano dos dízimos, quando tiveres acabado de separar o dízimo da tua colheita e a tiveres dado ao levita, ao imigrante, ao órfão e à viúva, para que comam e fiquem saciados nas tuas cidades,"
,"13":"confessarás diante de Javé teu Deus: 'Eu tirei da minha casa o que estava consagrado e dei-o ao levita, ao imigrante, ao órfão e à viúva, conforme a ordem que me deste. Não violei nem esqueci os teus mandamentos."
,"14":"Não comi nada disso durante o meu luto, não tirei nada quando estava impuro, e nada ofereci a um morto. Obedeci a Javé meu Deus e agi conforme tudo o que me ordenaste."
,"15":"Inclina-Te da tua morada santa, aí do Céu, e abençoa o teu povo Israel e a Terra que nos deste, como juraste aos nossos antepassados, uma Terra onde corre leite e mel'."
,"16":"Javé, teu Deus, ordena-te hoje que cumpras estes estatutos e normas. Procura pô-los em prática com todo o teu coração e com toda a tua alma."
,"17":"Hoje fizeste declarar a Javé que Ele seria o teu Deus, com a condição de andares nos seus caminhos, observando os seus estatutos, mandamentos e normas, dando assim ouvidos à sua voz."
,"18":"E Javé hoje fez-te declarar que serias o seu povo, conforme Ele mesmo te prometeu, observando todos os mandamentos."
,"19":"Deste modo, Ele tornar-te-á superior, em honra, fama e glória, a todas as nações que Ele fez. E serás um povo consagrado a Javé teu Deus, conforme Ele prometeu»."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Moisés e os anciãos de Israel ordenaram ao povo: «Observai todos os mandamentos que hoje vos ordeno."
,"2":"No dia em que atravessardes o rio Jordão para entrar na terra que Javé vosso Deus vos dará, levanta grandes pedras e reveste-as de cal."
,"3":"Sobre elas deverás escrever todas as palavras desta Lei, quando atravessares para entrar na Terra que Javé teu Deus te dará, uma Terra onde corre leite e mel, conforme te prometeu Javé, Deus dos teus antepassados."
,"4":"Depois de atravessardes o Jordão, conforme hoje vos ordeno, levantareis sobre o monte Ebal pedras e revesti-las-eis de cal."
,"5":"Ali construirás um altar para Javé teu Deus, um altar com pedras não trabalhadas com ferro."
,"6":"Constrói o altar de Javé teu Deus com pedras brutas, e oferece sobre ele holocaustos a Javé teu Deus."
,"7":"Oferece sacrifícios de comunhão e come, festejando diante de Javé teu Deus."
,"8":"Escreve sobre essas pedras todas as palavras desta Lei, gravando-as bem»."
,"9":"Em seguida, Moisés e os sacerdotes levitas disseram a todo o Israel: «Guarda silêncio e escuta, Israel: Hoje tornaste-te o povo de Javé teu Deus."
,"10":"Obedece, portanto, a Javé teu Deus e põe em prática os mandamentos e estatutos que hoje te ordeno»."
,"11":"Nesse dia, Moisés ordenou ao povo:"
,"12":"«Quando atravessardes o Jordão, as tribos de Simeão, Levi, Judá, Issacar, José e Benjamim colocar-se-ão sobre o monte Garizim, para pronunciar a bênção sobre o povo."
,"13":"As tribos de Rúben, Gad, Aser, Zabulon, Dã e Neftali colocar-se-ão sobre o monte Ebal, para pronunciar a maldição."
,"14":"Os levitas entoarão em alta voz, dizendo a todos os homens de Israel:"
,"15":"'Maldito seja quem faz um ídolo esculpido ou derretido, abominação para Javé, obra de artesão, e o guarda em lugar escondido'. E todo o povo responderá: 'Ámen'."
,"16":"'Maldito seja quem despreza o seu pai e a sua mãe'. E todo o povo responderá: 'Ámen'."
,"17":"'Maldito seja quem desloca a cerca do seu vizinho'. E todo o povo responderá: 'Ámen'."
,"18":"'Maldito seja quem extravia um cego no caminho'. E todo o povo responderá: 'Ámen'."
,"19":"'Maldito seja quem distorce o direito do imigrante, do órfão e da viúva'. E todo o povo responderá: 'Ámen'."
,"20":"'Maldito seja quem se deita com a mulher de seu pai, pois retira dela o pano do manto de seu pai'. E todo o povo responderá: 'Ámen'."
,"21":"'Maldito seja quem se deita com um animal'. E todo o povo responderá: 'Ámen'."
,"22":"'Maldito seja quem se deita com a sua irmã, filha de seu pai ou filha de sua mãe'. E todo o povo responderá: 'Ámen'."
,"23":"'Maldito seja quem se deita com a sua sogra'. E todo o povo responderá: 'Ámen'."
,"24":"'Maldito seja quem mata o seu próximo às escondidas'. E todo o povo responderá: 'Ámen'."
,"25":"'Maldito seja quem se deixa subornar para matar um inocente'. E todo o povo responderá: 'Ámen'."
,"26":"'Maldito seja quem não mantém as ordens desta Lei, não as pondo em prática'. E todo o povo responderá: 'Ámen'."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Se obedeceres de facto a Javé teu Deus, procurando pôr em prática todos os mandamentos que hoje te ordeno, Javé teu Deus tornar-te-á superior a todas as nações da Terra."
,"2":"São estas as bênçãos que virão sobre ti e te acompanharão, se obedeceres a Javé teu Deus:"
,"3":"Serás abençoado na cidade e abençoado no campo."
,"4":"Será abençoado o fruto do teu ventre, o fruto do teu solo, o fruto dos teus animais, a cria das tuas vacas e a prole das tuas ovelhas."
,"5":"Será abençoado o teu cesto e a tua amassadeira."
,"6":"Serás abençoado ao entrar e abençoado ao sair."
,"7":"Javé entregar-te-á, já vencidos, os inimigos que se levantarem contra ti; eles virão contra ti por um caminho, e por sete caminhos fugirão."
,"8":"Javé mandará que a bênção fique contigo nos teus celeiros e em tudo o que fizeres. Abençoar-te-á na Terra que Javé teu Deus te dará."
,"9":"Javé fará de ti um povo a Ele consagrado, conforme prometeu, se observares os mandamentos de Javé teu Deus e andares pelos seus caminhos."
,"10":"Todos os povos da Terra verão que sobre ti foi invocado o nome de Javé, e ficarão com medo de ti."
,"11":"Javé conceder-te-á abundância de bens, com o fruto do teu ventre, dos teus animais e da tua Terra, essa Terra que Javé prometeu aos teus antepassados que te daria."
,"12":"Javé abrir-te-á o tesouro do céu, dando no devido tempo a chuva para a terra e abençoando todos os trabalhos que realizares. Deste modo, emprestarás a muitas nações, e nunca pedirás emprestado."
,"13":"Javé fará de ti a cabeça e não a cauda; estarás sempre por cima, e não por baixo. Isto, porém, com a condição de que obedeças aos mandamentos de Javé teu Deus, que hoje te mando observar e pôr em prática."
,"14":"Não te desvies nem para a direita nem para a esquerda, em tudo o que hoje te ordeno, indo atrás de outros deuses para os servir."
,"15":"Contudo, se não obedeceres a Javé teu Deus, não pondo em prática todos os seus mandamentos e estatutos que hoje te ordeno, virão sobre ti e atingir-te-ão todas estas maldições:"
,"16":"Serás maldito na cidade e maldito no campo."
,"17":"Maldito será o teu cesto e a tua amassadeira."
,"18":"Maldito será o fruto do teu ventre, o fruto da tua terra, a cria das tuas vacas e a prole das tuas ovelhas."
,"19":"Serás maldito ao entrar e maldito ao sair."
,"20":"Javé mandará contra ti a maldição, o pânico e a ameaça em tudo o que fizeres, até que sejas exterminado e pereças rapidamente por causa da maldade das tuas acções, pelas quais Me abandonaste."
,"21":"Javé enviar-te-á a peste até te eliminar da Terra em que estás a entrar para dela tomares posse."
,"22":"Javé ferir-te-á com tísica e febre, inflamação e delírio, secura, ferrugem e mofo, que te perseguirão até pereceres."
,"23":"O céu sobre a tua cabeça ficará como bronze, e a terra sob os teus pés ficará como ferro."
,"24":"Javé transformará a chuva em cinza e pó, que cairão sobre ti, até ficares em ruínas."
,"25":"Javé entregar-te-á, já vencido, aos teus inimigos: sairás ao encontro deles por um caminho, e por sete caminhos fugirás. Transformar-te-ás em objecto de espanto para todos os reinos da Terra."
,"26":"O teu cadáver será alimento de todas as aves do céu e animais da terra, e ninguém os espantará."
,"27":"Javé ferir-te-á com úlceras do Egipto, com tumores, crostas e sarnas, que não poderás curar."
,"28":"Javé ferir-te-á com a loucura, cegueira e demência."
,"29":"Ficarás tacteando ao meio-dia, como o cego que tacteia na escuridão, e nos teus caminhos nada será bem sucedido. Serás oprimido e explorado todos os dias, e ninguém te socorrerá: "
,"30":"casar-te-ás com uma mulher, e outro homem a possuirá; construirás uma casa, e não habitarás nela; plantarás uma vinha, e não colherás as uvas;"
,"31":"o teu boi será abatido diante dos teus olhos, e dele não comerás; o teu jumento será roubado na tua frente, e não o devolverão; as tuas ovelhas serão dadas aos inimigos, e não haverá quem te ajude;"
,"32":"os teus filhos e as tuas filhas serão entregues a outro povo: os teus olhos verão tudo isto e ficarão consumidos de saudade o dia inteiro, e nada poderás fazer;"
,"33":"o produto da tua terra e de todo o teu trabalho será comido por um povo que não conheces, e serás oprimido e maltratado todos os dias;"
,"34":"ficarás louco com o espectáculo que os teus olhos verão."
,"35":"Javé ferir-te-á com úlceras malignas nos joelhos e nas pernas, das quais não te curarás, desde a planta dos pés até ao alto da cabeça."
,"36":"Javé levar-te-á, a ti e ao rei que tiveres escolhido, para uma nação que nem tu nem os teus antepassados conheceram. E ali servirás a outros deuses, feitos de madeira e pedra."
,"37":"Tornar-te-ás motivo de assombro, de troça e de riso, entre todos os outros povos, para onde Javé te tiver conduzido."
,"38":"Lançarás muitas sementes no campo, mas colherás pouco porque os gafanhotos as comerão."
,"39":"Plantarás e cultivarás vinhas, mas não beberás vinho nem colherás nada, pois a praga as devorará."
,"40":"Terás oliveiras em todo o teu território, porém não te ungirás com o azeite, porque as azeitonas cairão."
,"41":"Gerarás filhos e filhas que não te pertencerão, pois irão para o exílio."
,"42":"Os insectos apoderar-se-ão de todas as tuas árvores frutíferas."
,"43":"O imigrante que vive no meio de ti elevar-se-á cada vez mais alto às tuas custas, enquanto tu descerás cada vez mais baixo."
,"44":"Ele poderá emprestar-te e tu nada lhe poderás emprestar: ele ficará como cabeça, e tu como cauda."
,"45":"Todas estas maldições cairão sobre ti, te perseguirão e te atingirão, até seres exterminado, porque não obedeceste a Javé teu Deus, não observando os seus mandamentos e estatutos que Ele te ordenou."
,"46":"Essas maldições serão para sempre um sinal e um prodígio contra a tua descendência."
,"47":"Uma vez que não serviste a Javé teu Deus com alegria e generosidade quando estavas na abundância,"
,"48":"então servirás, na fome e na sede, com nudez e privação total, ao inimigo que Javé enviará contra ti. O inimigo colocar-te-á no pescoço um jugo de ferro, até seres exterminado."
,"49":"Javé erguerá contra ti uma nação distante, dos confins da terra, como águia veloz, uma nação cuja língua não entendes,"
,"50":"nação de cara dura, que não respeita o ancião e não tem piedade do jovem."
,"51":"Ela comerá o fruto dos teus animais e o fruto da tua terra, até seres exterminado; não te deixará nem trigo, nem vinho novo, nem azeite, nem a cria das tuas vacas, nem a prole das tuas ovelhas, até ficares destruído."
,"52":"Ela cercar-te-á em todas as tuas cidades, até caírem, em toda a terra, os muros altos e fortificados em que punhas toda a tua segurança. Essa nação cercar-te-á em todas as tuas cidades, em toda a terra que Javé teu Deus te tiver dado."
,"53":"Então, na angústia do cerco com que o inimigo te apertar, irás comer o fruto do teu ventre: a carne dos filhos e filhas que Javé teu Deus te tiver dado."
,"54":"O mais delicado e refinado homem de Israel olhará com maldade para o seu irmão, para a mulher que ele estreitava ao seu peito e para os filhos que ainda tiver,"
,"55":"pois terá de repartir com algum deles a carne dos filhos que está para comer, pois nada mais te restará na angústia do cerco com que o inimigo te vai apertar em todas as tuas cidades."
,"56":"A mais delicada e refinada das mulheres entre vós, tão delicada e refinada que nunca pôs a planta dos pés no chão, olhará com maldade para o homem que ela estreitava ao seu seio e também para o seu filho e a sua filha,"
,"57":"e para a placenta que lhe sai por entre as pernas, e para o filho que acaba de dar à luz, porque, faltando tudo, ela os comerá às escondidas, por causa da angústia do cerco com que o inimigo te vai apertar em todas as tuas cidades."
,"58":"Se não puseres em prática todas as palavras desta Lei escritas neste livro, temendo o nome glorioso e terrível de Javé teu Deus,"
,"59":"Javé ferir-te-á a ti e à tua descendência com pragas espantosas, pragas tremendas e persistentes, doenças graves e incuráveis."
,"60":"Ele voltará contra ti as pragas do Egipto que te horrorizavam, e colar-se-ão a ti."
,"61":"E ainda mais: Javé lançará contra ti todas as doenças e pragas que não estão escritas neste livro da Lei, até que sejas exterminado."
,"62":"Restarão de vós poucos homens, vós que éreis tão numerosos como as estrelas do céu. Uma vez que não obedeceste a Javé teu Deus, "
,"63":"então do mesmo modo que Javé tinha prazer em vos fazer o bem e vos multiplicar, assim também terá prazer em vos destruir e exterminar: sereis arrancados da Terra em que estais a entrar para dela tomar posse."
,"64":"Javé espalhar-te-á por todos os povos, de um extremo ao outro da Terra, e ali servirás a outros deuses, que nem tu nem os teus pais conheceram, deuses feitos de madeira e pedra."
,"65":"No meio dessas nações, tu nunca terás tranquilidade, e a planta do teu pé não encontrará onde descansar. Ali Javé dar-te-á um coração inquieto, olhos mortiços e respiração fraca."
,"66":"A tua vida estará como que suspensa por um fio. Ficarás apavorado de noite e de dia e já não acreditarás na vida."
,"67":"Pela manhã, dirás: 'Quem me dera que já tivesse chegado a tarde!' E pela tarde dirás: 'Quem me dera que já tivesse chegado a manhã!' Tudo isto por causa do pavor que se apoderará do teu coração e pelo espectáculo que os teus olhos contemplarão."
,"68":"Javé far-vos-á voltar de barco ao Egipto, ou pelo caminho do qual eu vos tinha dito: 'Nunca mais o vereis!' Ali oferecer-vos-eis como escravos e escravas aos vossos inimigos, e ninguém vos quererá comprar»."
,"69":"Palavras conclusivas da aliança que Javé mandou fazer a Moisés com os israelitas, na terra de Moab, além da aliança que Ele já havia feito com eles no Horeb."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Moisés convocou todo o Israel, e disse: «Vós mesmos vistes tudo o que Javé fez na terra do Egipto contra o Faraó, contra os seus ministros e contra todo o seu país:"
,"2":"as grandes provas que os vossos olhos viram, aqueles sinais e prodígios grandiosos."
,"3":"Contudo, Javé não vos tinha dado, até ao dia de hoje, um coração para compreender, olhos para ver e ouvidos para ouvir."
,"4":"Eu fiz-vos caminhar quarenta anos pelo deserto, sem que as vossas vestes envelhecessem e as sandálias dos vossos pés se gastassem."
,"5":"Não tivestes pão para comer, nem bebida embriagante para beber, para que compreendêsseis que Eu sou Javé, o vosso Deus."
,"6":"Depois chegastes a este lugar. Seon, rei de Hesebon, e Og, rei de Basã, saíram ao nosso encontro para a guerra, mas nós derrotámo-los."
,"7":"Conquistámos os seus territórios e demo-los como herança a Rúben, Gad e à meia tribo de Manassés."
,"8":"Observai as palavras desta aliança e ponde-as em prática, para serdes bem sucedidos em tudo quanto fizerdes."
,"9":"Apresentastes-vos hoje diante de Javé vosso Deus, os chefes das vossas tribos, os anciãos, os oficiais e todos os homens de Israel,"
,"10":"com as crianças e mulheres, inclusive o imigrante que está no vosso acampamento, desde o rachador de lenha até ao distribuidor de água,"
,"11":"a fim de entrardes na aliança de Javé vosso Deus e aceitar o pacto sob condição, que Javé vosso Deus assume hoje convosco."
,"12":"Deste modo, Ele hoje vai fazer de vós o seu povo, e Ele mesmo Se tornará o vosso Deus, como jurou e prometeu aos vossos antepassados Abraão, Isaac e Jacob."
,"13":"Não é somente convosco que estou a concluir esta aliança e este pacto sob condição."
,"14":"Eu estou a concluir esta aliança com aqueles que estão aqui connosco, hoje, diante de Javé nosso Deus, e também com todos aqueles que hoje não estão aqui connosco."
,"15":"Sabeis que habitámos lá no Egipto e de que modo atravessámos aquelas nações."
,"16":"Vistes as suas abominações e ídolos, feitos de madeira, de pedra, de prata e de ouro."
,"17":"Que não haja entre vós homem ou mulher, clã ou tribo, cujo coração se desvie hoje de Javé nosso Deus, para servir os deuses daquelas nações. Que não haja entre vós raízes que produzam plantas venenosas ou amargas."
,"18":"Portanto, ouvindo as palavras deste pacto sob condição, alguém poderá felicitar-se a si próprio, dizendo: 'Vou ter paz, mesmo que ande conforme a dureza do meu coração, pois a abundância de água fará desaparecer a minha sede'."
,"19":"Neste caso, Javé jamais consentirá em perdoar-lhe. Pelo contrário, a sua ira e ciúme inflamar-se-ão contra esse homem, caindo sobre ele toda a maldição escrita neste livro. E Javé apagará o seu nome de debaixo do céu."
,"20":"Para sua perdição, Javé separá-lo-á de todas as tribos de Israel, conforme as maldições da aliança, escritas neste livro da Lei."
,"21":"A geração futura, os filhos que virão depois de vós e o estrangeiro vindo de uma terra distante, verão as pragas desta terra e as doenças com que Javé a castigará:"
,"22":"enxofre e sal, terra queimada onde não se semeia e nada brota nem cresce, catástrofe como a de Sodoma e Gomorra, Adama e Seboim, que Javé destruiu na sua ira e furor."
,"23":"Todas as nações perguntarão: 'Porque terá Javé agido assim com esta terra? O que significa o ardor de tão grande ira?'"
,"24":"E responderão: 'É porque eles abandonaram a aliança que Javé, Deus dos seus antepassados, tinha feito com eles, quando os tirou do Egipto."
,"25":"Eles foram servir a outros deuses e adoraram-nos, deuses que eles não conheciam e que Javé não lhes tinha dado."
,"26":"Então a ira de Javé inflamou-se contra esta terra, fazendo cair sobre ela todas as maldições escritas neste livro."
,"27":"Javé arrancou-os da própria terra, com ira, furor e grande indignação, e atirou-os para outra terra, como hoje se pode ver'."
,"28":"As coisas escondidas pertencem a Javé nosso Deus; as coisas reveladas, porém, pertencem-,-nos para sempre a nós e aos nossos filhos, para pormos em prática todas as palavras desta Lei."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Quando em ti se cumprirem todas estas palavras, isto é, a bênção e a maldição que te propus, e meditares nelas, vivendo no meio de todas as nações para onde Javé teu Deus te tiver expulsado,"
,"2":"então converter-te-ás, de todo o teu coração e de toda a tua alma, a Javé teu Deus; tu e os teus filhos obedecer-Lhe-eis, conforme te ordeno hoje."
,"3":"Então Javé teu Deus compadecer-Se-á de ti e mudará a tua sorte. Javé teu Deus voltará atrás e reunir-te-á de todos os povos, entre os quais te havia espalhado."
,"4":"Ainda que tivesses sido expulso para o fim do mundo, dali Javé teu Deus te reuniria e ali iria procurar-te"
,"5":"para te introduzir novamente na Terra que teus antepassados possuíram, a fim de que a possuas. Ele far-te-á feliz e te multiplicará ainda mais que os teus antepassados."
,"6":"Javé teu Deus circuncidará o teu coração e o coração dos teus descendentes, para que ames a Javé teu Deus com todo o coração e com toda a alma, e vivas."
,"7":"Javé teu Deus fará recair todas estas maldições sobre os inimigos, sobre os que te odiaram e perseguiram."
,"8":"Quanto a ti, volta a obedecer a Javé teu Deus, colocando em prática todos os seus mandamentos, que hoje te ordeno."
,"9":"Javé teu Deus fará prosperar as tuas iniciativas, o fruto do teu ventre, o fruto dos teus animais e o fruto do teu solo. Porque Javé voltará a ter prazer com a tua felicidade, assim como tinha prazer com a felicidade dos teus antepassados."
,"10":"A condição, porém, é que obedeças a Javé teu Deus, observando os seus mandamentos e os seus estatutos escritos neste livro da Lei, e que te convertas com todo o coração e com toda a alma a Javé teu Deus."
,"11":"Este mandamento que hoje te ordeno não é muito difícil, nem está fora do teu alcance."
,"12":"Ele não está no céu, para que perguntes: 'Quem subirá por nós até ao céu para no-lo trazer, a fim de que possamos ouvi-lo e pô-lo em prática'?"
,"13":"Também não está no além-mar, para que perguntes: 'Quem atravessará por nós o mar, para nos trazer esse mandamento, a fim de que possamos ouvi-lo e pô-lo em prática'?"
,"14":"Sim, essa Palavra está ao teu alcance: está na tua boca e no teu coração, para que a ponhas em prática."
,"15":"Eis que coloco hoje diante de ti a vida e a felicidade, a morte e a desgraça."
,"16":"Se obedeceres aos mandamentos de Javé teu Deus, que hoje te ordeno, amando a Javé teu Deus, andando nos seus caminhos e observando os seus mandamentos, estatutos e normas, viverás e multiplicar-te-ás. Javé teu Deus abençoar-te-á na Terra onde estás a entrar para tomares posse dela."
,"17":"Todavia, se o teu coração se desviar e não obedeceres, se te deixares seduzir e adorares e servires a outros deuses,"
,"18":"eu hoje te declaro: é certo que perecereis! Não prolongareis os vossos dias sobre a Terra, onde estais a entrar, ao atravessar o Jordão, para dela tomar posse."
,"19":"Hoje eu tomo o Céu e a Terra como testemunhas contra vós: eu propus-te a vida ou a morte, a bênção ou a maldição. Escolhe, portanto, a vida, para que tu e os teus descendentes possais viver,"
,"20":"amando a Javé teu Deus, obedecendo-Lhe e apegando-te a Ele, porque Ele é a tua vida e o prolongamento dos teus dias. Deste modo poderás habitar sobre a terra que Javé jurou dar aos teus antepassados Abraão, Isaac e Jacob»."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Moisés dirigiu estas palavras a todo o Israel."
,"2":"Depois acrescentou: «Hoje estou com cento e vinte anos. Já não posso ser chefe, e Javé disse-me...: 'Não atravessarás o rio Jordão'."
,"3":"Quem vai à tua frente é o próprio Javé teu Deus. Ele destruirá essas nações que estão à tua frente e conquistá-las-á. Josué irá à tua frente, conforme disse Javé."
,"4":"E Javé tratará essas nações como tratou Seon e Og, os reis amorreus e a sua terra, que Ele reduziu a ruínas."
,"5":"Javé entregar-vos-á essas nações, e tratá-las-eis conforme os mandamentos que vos ordenei."
,"6":"Sede fortes e corajosos! Não tenhais medo, nem fiqueis apavorados diante delas porque Javé teu Deus vai contigo. Ele não te deixará, e jamais te abandonará»."
,"7":"Então Moisés chamou Josué e, na presença de todo o Israel, disse-lhe: «Sê forte e corajoso! Pois tu é que vais entrar com todo este povo na Terra que Javé prometeu dar aos seus antepassados, e tu é que repartirás a herança entre eles."
,"8":"O próprio Javé irá à tua frente. Ele estará contigo; não te deixará, e jamais te abandonará. Não tenhas medo, nem te acovardes»."
,"9":"Então Moisés escreveu esta Lei e entregou-a aos sacerdotes levitas, que transportavam a arca da aliança de Javé, e também a todos os anciãos de Israel."
,"10":"E Moisés ordenou-lhes: «No fim de cada sete anos, no ano da remissão, durante a festa das Tendas,"
,"11":"quando todo o Israel vier apresentar-se diante de Javé teu Deus, no lugar que Ele tiver escolhido, proclamarás esta Lei a todo o Israel."
,"12":"Reúne o povo, homens e mulheres, as crianças e o imigrante que está nas tuas cidades, para que ouçam e aprendam a temer Javé, o vosso Deus, e ponde em prática todas as palavras desta Lei."
,"13":"E os seus filhos que ainda não tiverem conhecimento delas, ouvirão e aprenderão a temer Javé, o vosso Deus, todos os dias em que viverem na Terra, da qual tomareis posse ao atravessar o Jordão»."
,"14":"Então Javé disse a Moisés: «O dia da tua morte aproxima-se. Chama Josué e apresentai-vos na tenda da reunião, para que lhe dê as minhas ordens». Moisés e Josué foram à tenda da reunião."
,"15":"Javé apareceu na tenda numa coluna de nuvem, que se colocou à entrada da tenda."
,"16":"Javé disse a Moisés: «Vê! Tu vais descansar com os teus antepassados, e este povo vai prostituir-se com os deuses da terra estrangeira onde está para entrar. Ele vai abandonar-Me, rompendo a aliança que fiz com eles."
,"17":"Nesse dia, a minha cólera inflamar-se-á contra o povo, abandoná-lo-ei, e esconderei deles a minha face. Então ele será devorado, e muitos males e desgraças o atingirão. E nesse dia o povo dirá: 'Deus já não está comigo. É por isso que estas desgraças me atingiram'."
,"18":"Sim, nesse dia Eu esconderei a minha face, por causa de todo o mal que o povo terá feito ao voltar-se para outros deuses."
,"19":"Agora escrevei este cântico e ensinai-o aos israelitas. Colocai-o na sua boca, para que seja um testemunho a meu favor contra os israelitas."
,"20":"Quando Eu tiver introduzido o povo na Terra onde corre leite e mel, que prometi dar aos seus antepassados, comerá até ficar satisfeito, engordará e voltar-se-á para outros deuses e servir-los-á, desprezando-Me e rompendo a minha aliança."
,"21":"Por isso, quando muitos males e desgraças o tiverem atingido, este cântico deporá contra ele como testemunho, porque não será esquecido pelos seus descendentes. Conheço bem o projecto que ele está a fazer hoje, antes mesmo de Eu o introduzir na Terra que lhe prometi»."
,"22":"Nesse mesmo dia, Moisés escreveu este cântico e ensinou-o aos israelitas."
,"23":"Então Javé ordenou a Josué, filho de Nun: «Sê forte e corajoso! Pois tu é que introduzirás os israelitas na Terra que lhes prometi. Eu estarei sempre contigo»."
,"24":"Quando acabou de escrever num livro toda esta Lei,"
,"25":"Moisés ordenou aos levitas que transportavam a arca da aliança de Javé:"
,"26":"«Tomai este livro da Lei e colocai-o ao lado da arca da aliança de Javé vosso Deus. Ele ficará ali como testemunho contra vós,"
,"27":"porque eu conheço bem o vosso espírito rebelde e a vossa cabeça dura. Se vos revoltais contra Javé enquanto ainda estou vivo, o que acontecerá depois da minha morte?»"
,"28":"Moisés continuou: «Reuni junto de mim todos os anciãos das tribos e os oficiais, para que eu recite estas palavras na sua presença e tome o Céu e a Terra como testemunhas contra eles."
,"29":"Porque eu sei que depois da minha morte vos ireis corromper completamente, desviando-vos do caminho que vos ordenei. Então o mal vai acontecer-vos no futuro, porque tereis praticado o que Javé reprova, irritando-O com as vossas acções»."
,"30":"Então Moisés recitou até ao fim, na presença de toda a assembleia de Israel, o seguinte cântico:"
}`)
	CurrentBook.AddChapter(32, `{
"1":"Escuta, ó Céu, que eu falarei. Ouve, ó Terra, as palavras da minha boca."
,"2":"Desça como chuva,o meu ensinamento,e a minha palavra se espalhe,como orvalho; como chuvisco sobre a relva macia e aguaceiro sobre a erva verdejante."
,"3":"Vou proclamar o nome de Javé, e vós engrandecei o nosso Deus."
,"4":"Ele é a Rocha, e a sua obra é perfeita, porque toda a sua conduta é o Direito. É Deus fiel e sem injustiça: Ele é a Justiça e a Rectidão."
,"5":"Os filhos,degenerados pecaram contra Ele, são uma geração depravada,e pervertida."
,"6":"É isso que retribuís a Javé, povo idiota e sem sabedoria?,Ele não é o vosso Pai e Criador?,Ele próprio te fez e te sustentou."
,"7":"Recorda,os dias que se foram, repassa gerações e gerações. Pergunta a teu pai e ele te contará, interroga os anciãos e eles te dirão."
,"8":"Quando o Altíssimo repartia as nações,e quando espalhava os filhos de Adão, Ele marcou fronteiras para os povos, conforme o número dos filhos de Deus."
,"9":"Mas a parte de Javé foi o seu povo, o lote da sua herança foi Jacob."
,"10":"Ele encontrou-o numa terra árida, num deserto solitário e cheio de uivos. Cercou-o, cuidou dele e guardou-,ocom carinho, como se fosse a menina dos seus olhos."
,"11":"Como a águia que cuida do seu ninho,e revoa por cima dos filhotes, Ele tomou-te, estendendo as suas asas, e levou-te sobre as suas penas."
,"12":"O único a conduzir-te foi Javé. Nenhum deus estrangeiro,te acompanhou."
,"13":"Ele colocou-te sobre os montes,e alimentou-te com produtos do campo. Ele criou-te com mel silvestre, e com azeite de uma rocha pedregosa,"
,"14":"com coalhada de vaca e leite de ovelha, gordura de carneiros e cordeiros; com manadas de Basã e cabritos, com a flor da farinha de trigo,e o sumo da uva, que bebes fermentado."
,"15":"Jacob,comeu e ficou satisfeito, Jesurun engordou e revoltou-se,-ficou gordo, robusto e corpulento -,rejeitou o Deus que o fizera, desprezou a sua Rocha salvadora."
,"16":"Eles provocaram-Lhe o ciúme,com deuses estranhos,e irritaram-n'O,com as suas abominações."
,"17":"Sacrificaram a demónios, falsos deuses, a deuses que não haviam conhecido, deuses novos, recentemente chegados, que os seus antepassados não temiam."
,"18":"Desprezaste a Rocha que te gerou,e esqueceste o Deus que te deu a vida."
,"19":"Javé viu tudo, ficou enfurecido, e rejeitou os teus filhos e as tuas filhas."
,"20":"Ele disse: 'Vou esconder-lhes,o meu rosto,e ver qual será o seu futuro', porque são uma geração pervertida, são filhos que não têm fidelidade."
,"21":"Eles provocaram o meu ciúme,com um deus falso, e irritaram-Me,com os seus ídolos vazios. Por isso vou provocar o seu ciúme,com um povo falso, vou irritá-los com uma nação idiota."
,"22":"O fogo da minha ira está a arder,e vai queimar até à mansão dos mortos; vai devorar a terra e seus produtos, e abrasar o alicerce das montanhas."
,"23":"Vou acumular males sobre eles,e contra eles vou esgotar,as minhas flechas."
,"24":"Ficarão enfraquecidos pela fome, consumidos por febres,e pestes violentas. Mandarei contra eles os dentes das feras,com o veneno de serpentes do deserto."
,"25":"Fora, a espada levará seus filhos,e, dentro, o terror se instalará. Todos perecerão: o jovem e a donzela, a criança de peito,e o velho de cabelos brancos."
,"26":"Então,pensei: «Vou reduzi-los a pó, e apagar a sua memória,do meio dos homens»."
,"27":"Mas temi a arrogância dos inimigos, a má interpretação dos adversários. Eles diriam: «A nossa mão venceu, não foi Javé quem fez isso»."
,"28":"Porque é uma nação sem juízo,e sem inteligência."
,"29":"Se fossem sábios, entenderiam tudo isto,e saberiam discernir o seu futuro."
,"30":"Como pode um homem sozinho,perseguir mil, e dois pôr em fuga dez mil?,Não é porque a sua Rocha os vendeu,e porque Javé os entregou?"
,"31":"Sim, a rocha deles,não é como a nossa Rocha,e os nossos inimigos podem atestá-lo."
,"32":"Pois a sua vinha é vinha de Sodoma,e vem das plantações de Gomorra; as suas uvas são uvas venenosas,e os seus cachos são amargos."
,"33":"O seu vinho é veneno de serpente, violenta peçonha de cobras."
,"34":"Isto,não está guardado junto de Mim,e lacrado nos meus tesouros?"
,"35":"A Mim pertencem a vingança,e a represália,no dia em que o seu pé escorregar, porque o dia da sua ruína,já está a chegar, e o seu destino futuro aproxima-se."
,"36":"Sim, Javé fará justiça ao seu povo,e terá piedade dos seus servos. Ao ver que a sua mão vai fraquejando, e não há mais nem livre nem escravo,"
,"37":"Javé dirá: «Onde estarão os seus deuses, a rocha onde buscavam o seu refúgio?"
,"38":"Vós não comíeis a gordura,dos seus sacrifícios?,Não bebíeis o vinho das suas libações?,Que esses deuses se ponham em pé, vos socorram,e sejam a vossa protecção!"
,"39":"E agora, vede bem: Eu sou Eu,e fora de Mim não existe,nenhum outro Deus. Eu faço morrer e faço viver, sou Eu que firo e torno a curar, e ninguém se livra da minha mão."
,"40":"Sim, levanto a mão para o céu e juro: Tão verdade,como Eu vivo eternamente,"
,"41":"quando afiar,a minha espada fulgurante,e a minha mão agarrar o Direito, tomarei vingança do meu adversário,e retribuirei àqueles que Me odeiam."
,"42":"Embriagarei as minhas flechas,com sangue,e a minha espada devorará a carne, sangue dos mortos e cativos, da cabeça dos chefes inimigos»."
,"43":"Nações, aclamai todas a Javé,com o seu povo, porque Ele vinga o sangue,dos seus servos, tomando vingança,dos seus adversários. Ele purifica a sua terra e o seu povo."
,"44":"Moisés foi com Josué, filho de Nun, e recitou todo este cântico na presença do povo."
,"45":"Moisés acabou de dizer estas palavras a todo o Israel,"
,"46":"e acrescentou: «Ficai atentos a todas as palavras que hoje tomo como testemunho contra vós, e ordenareis aos vossos filhos que as observem, pondo em prática todas as palavras desta Lei."
,"47":"Não é uma palavra inútil, porque ela é a vossa vida, e é por meio desta palavra que prolongareis a vida na Terra, da qual ides tomar posse, depois de atravessar o rio Jordão»."
,"48":"Nesse mesmo dia, Javé disse a Moisés:"
,"49":"«Sobe à região montanhosa de Abarim, sobre o monte Nebo, na terra de Moab, em frente de Jericó, e contempla a terra de Canaã, que vou dar como propriedade aos filhos de Israel."
,"50":"Tu morrerás no monte ao qual tiveres subido e reunir-te-ás aos teus antepassados, como o teu irmão Aarão, que se reuniu ao seu povo no monte Hor."
,"51":"Porque Me fostes infiéis no meio dos israelitas, junto das águas de Meriba em Cades, no deserto de Sin, e não reconhecestes a minha santidade no meio dos israelitas."
,"52":"Por isso só a contemplarás de longe, mas não poderás entrar na Terra que vou dar aos israelitas»."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Esta é a bênção que Moisés, homem de Deus, antes de morrer pronunciou sobre os israelitas:"
,"2":"Javé veio do Sinai, amanheceu para eles de Seir, resplandeceu do monte Farã. Veio ter com eles,da assembleia de Cades, desde o Sul até às encostas."
,"3":"Na frente, vai o Favorito dos povos, à sua direita seguem os guerreiros,e com a esquerda dirige os seus santos. Eles prostram-se à sua passagem,e marcham sob as suas ordens."
,"4":"Moisés deu-nos uma lei, uma herança,para a assembleia de Jacob."
,"5":"Houve um rei em Jesurun, quando os chefes do povo se reuniram,e, ao mesmo tempo, as tribos de Israel."
,"6":"Viva Rúben e não morra, e sejam inumeráveis os seus homens."
,"7":"Eis o que ele diz sobre Judá: Ouve, Javé, a voz de Judá,e introdu-lo no teu povo. Que as tuas mãos o defendam: Tu o protegerás contra os inimigos."
,"8":"Sobre Levi ele diz: Entrega a Levi os teus Urim, e os teus Tumim ao homem que amas, que puseste à prova em Massa,e desafiaste junto às águas de Meriba."
,"9":"Ele diz de seu pai e de sua mãe: 'Nunca vos vi'. Ele já não reconhece os seus irmãos,e ignora os seus filhos. Sim, eles observam a tua palavra,e guardam a tua aliança."
,"10":"Eles ensinam as tuas normas a Jacob,e a tua lei a Israel. Eles oferecem incenso na tua presença,e holocaustos no teu altar."
,"11":"Abençoa a sua força, ó Javé, e aceita a obra das suas mãos. Fere os rins dos seus adversários, e que os seus inimigos não se levantem."
,"12":"Sobre Benjamim ele diz: O amado de Javé habita tranquilo,junto d'Aquele que o protege,todos os dias, e que repousa entre as suas colinas."
,"13":"Sobre José ele diz: A sua terra é abençoada por Javé: dele é o melhor orvalho do céu,e do abismo subterrâneo;"
,"14":"o melhor dos produtos anuais,e o melhor dos frutos mensais;"
,"15":"os primeiros frutos dos montes antigos,e o melhor das colinas de outrora;"
,"16":"o melhor da terra e da sua riqueza. Que o favor d'Aquele,que habita na sarça,desça sobre a cabeça de José, sobre a fronte do escolhido,entre os seus irmãos."
,"17":"Ele é seu touro primogénito,e a glória lhe pertence. Os seus chifres são chifres de búfalo: com eles investe contra os povos,até às extremidades da Terra. São estas as miríades de Efraim,e estes os milhares de Manassés."
,"18":"A Zabulon ele diz: Sê feliz nas tuas expedições, Zabulon, e tu, Issacar, nas tuas tendas."
,"19":"Sobre a montanha,onde os povos invocam, eles oferecem sacrifícios de justiça, pois exploram as riquezas do mar,e os tesouros escondidos na areia."
,"20":"Sobre Gad ele diz: Abençoado aquele que amplia Gad. Ele lança-se como leoa, destroçando braços e crânio."
,"21":"Ele escolheu para si os primeiros frutos, a parte reservada ao chefe. Tornou-se chefe do povo, executando a justiça de Javé,e as suas normas sobre Israel."
,"22":"Sobre Dã ele diz: Dã é um leãozinho, que salta de Basã."
,"23":"Sobre Neftali ele diz: Neftali é saciado de favores,e repleto das bênçãos de Javé: ele toma posse do mar e do Sul."
,"24":"Sobre Aser ele diz: Abençoado seja Aser entre os filhos, seja ele o favorito entre os irmãos, e banhe o seu pé no azeite."
,"25":"De ferro e bronze sejam as suas trancas, e a sua força dure como os seus dias."
,"26":"Ninguém é como o Deus de Jesurun: Ele cavalga o céu,para vir em seu auxílio,e as nuvens, com a sua majestade."
,"27":"O Deus de outrora é o seu refúgio; aqui em baixo, Ele é o braço eterno,que expulsa o inimigo da sua frente, e vai dizendo: 'Destrói!'"
,"28":"Israel repousa em segurança; a fonte de Jacob fica separada, numa terra de trigo e vinho, sob um céu que destila orvalho."
,"29":"Feliz de ti, Israel!,Quem é como tu, povo salvo por Javé?,Ele é o escudo que te protege,e a espada que te conduz à vitória. Os teus inimigos vão querer adular-te, mas calcar-lhes-ás as costas."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Então Moisés subiu das planícies de Moab ao monte Nebo, ao pico do Fasga, que fica em frente de Jericó. E Javé mostrou-lhe toda a Terra: desde Galaad até Dã,"
,"2":"todo o Neftali, a terra de Efraim e Manassés, toda a terra de Judá até ao Mar Mediterrâneo,"
,"3":"o Negueb, o distrito da planície de Jericó, cidade das palmeiras, até Segor."
,"4":"E Javé disse a Moisés: «É esta a Terra que prometi a Abraão, Isaac e Jacob, quando disse: 'Eu dá-la-ei à tua descendência'. Eu estou a mostrar-te esta Terra, mas não entrarás nela»."
,"5":"E Moisés, servo de Javé, morreu ali mesmo, na terra de Moab, conforme a palavra de Javé."
,"6":"Foi sepultado no vale, na terra de Moab, em frente de Bet-Fegor. Até hoje, ninguém sabe onde fica a sua sepultura."
,"7":"Moisés tinha cento e vinte anos quando morreu. A sua vista não tinha enfraquecido, nem se esgotara o seu vigor."
,"8":"Os israelitas choraram por Moisés, nas planícies de Moab, durante trinta dias, até que terminou o luto por Moisés."
,"9":"Josué, filho de Nun, estava repleto do espírito de sabedoria, pois Moisés havia imposto as mãos sobre ele. E os israelitas obedeceram a Josué, agindo conforme Javé tinha ordenado a Moisés."
,"10":"Em Israel nunca mais surgiu outro profeta como Moisés, a quem Javé conhecia face a face."
,"11":"Ninguém o igualou em todos os sinais e prodígios que Javé lhe mandou realizar no Egipto contra o Faraó, contra toda a sua corte e contra a sua terra."
,"12":"Ninguém se igualou a Moisés na mão forte e em todos os feitos grandiosos e terríveis que ele realizou na presença de todo o Israel."
}`)

}
func PT_BS_LoadVPEXChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Nomes dos filhos de Israel que foram para o Egipto com Jacob, cada qual com a sua família:"
,"2":"Rúben, Simeão, Levi e Judá;"
,"3":"Issacar, Zabulon e Benjamim;"
,"4":"Dã e Neftali; Gad e Aser."
,"5":"Os descendentes de Jacob eram ao todo setenta pessoas. José, porém, já estava no Egipto."
,"6":"Depois, morreu José, assim como os seus irmãos e toda essa geração."
,"7":"Os filhos de Israel tornavam-se fecundos e multiplicavam-se; tornaram-se cada vez mais numerosos e poderosos, a tal ponto que o país ficou repleto deles."
,"8":"Subiu ao trono do Egipto um novo rei que não tinha conhecido José."
,"9":"Ele disse ao seu povo: «Reparai: os filhos de Israel constituem um povo que está a tornar-se mais numeroso e poderoso do que nós."
,"10":"Vamos vencê-los com astúcia, para impedir que eles se multipliquem; de contrário, em caso de guerra, eles aliar-se-ão com o inimigo, atacar-nos-ão e depois sairão do país»."
,"11":"Então impuseram sobre Israel capatazes, que os exploravam em trabalhos forçados. E assim construíram para o Faraó as cidades-armazéns de Pitom e Ramsés."
,"12":"Contudo, quanto mais oprimiam o povo, mais ele crescia e se multiplicava. Os filhos de Israel começaram a tornar-se um pesadelo para os egípcios."
,"13":"Por isso, os egípcios impuseram sobre eles trabalhos duros,"
,"14":"e amargaram-lhes a vida com dura escravidão: preparação de argila, fabricação de tijolos, vários trabalhos nos campos; enfim, com dureza obrigaram-nos a todos esses trabalhos."
,"15":"O rei do Egipto ordenou às parteiras dos hebreus, que se chamavam Sefra e Fua:"
,"16":"«Quando ajudardes as hebreias a dar à luz, observai se é menino ou menina: se for menino, matai-o; se for menina, deixai-a viver»."
,"17":"As parteiras, porém, temeram a Deus e não fizeram o que o rei do Egipto lhes havia ordenado; e deixaram viver os meninos."
,"18":"Então o rei do Egipto chamou as parteiras, e disse-lhes: «Porque procedestes desse modo, deixando viver os meninos?»"
,"19":"Elas responderam ao Faraó: «As mulheres hebreias não são como as egípcias: são cheias de vida, e dão à luz antes que as parteiras cheguem»."
,"20":"Por isso, Deus favoreceu as parteiras. E o povo multiplicou-se e tornou-se muito poderoso."
,"21":"E como as parteiras temeram a Deus, Ele deu-lhes uma família numerosa."
,"22":"Então o Faraó ordenou a todo o seu povo: «Lançareis ao rio Nilo todo o menino que nascer e deixareis viver todas as meninas»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Um homem da tribo de Levi casou-se com uma mulher da mesma tribo:"
,"2":"ela concebeu e deu à luz um filho. Vendo que era bonito, escondeu-o durante três meses."
,"3":"Quando não pôde mais escondê-lo, pegou num cesto de papiro, vedou-o com betume e pez, colocou nele a criança, e depositou-a entre os juncos na margem do rio."
,"4":"A irmã da criança observava de longe para ver o que aconteceria."
,"5":"Naquele momento, a filha do Faraó desceu para tomar banho, no rio, enquanto as suas servas andavam pela margem. Ela viu o cesto entre os juncos e mandou a criada buscá-lo."
,"6":"Ao abrir o cesto, viu a criança: era um menino que chorava. Ela compadeceu-se e disse: «É uma criança dos hebreus!»"
,"7":"Então a irmã do menino disse à filha do Faraó: «A senhora quer que eu vá chamar uma hebreia para criar este menino?»"
,"8":"A filha do Faraó respondeu: «Vai».A menina foi e chamou a mãe da criança."
,"9":"Então a filha do Faraó disse à mulher: «Leva este menino, e cria-o, que eu te pagarei».A mulher recebeu o menino e criou-o."
,"10":"Quando o menino cresceu, a mulher entregou-o à filha do Faraó, que o adoptou e lhe deu o nome de Moisés, dizendo: «Eu tirei-o das águas»."
,"11":"Passaram os anos. Moisés cresceu e saiu para ver os seus irmãos. E notou que eram submetidos a trabalhos forçados. Viu também que um dos seus irmãos hebreus estava a ser maltratado por um egípcio."
,"12":"Olhou para um lado e para o outro, e vendo que não havia ninguém, matou o egípcio e enterrou-o na areia."
,"13":"No dia seguinte, Moisés saiu e encontrou dois hebreus a lutar. E disse ao agressor: «Porque bates no teu próximo?»"
,"14":"Ele respondeu: «E quem foi que te nomeou para seres chefe e juiz sobre nós? Queres matar-me, como mataste o egípcio ontem?» Moisés ficou cheio de medo e pensou: «Certamente o facto já é conhecido»."
,"15":"O Faraó ouviu falar do facto e procurou matar Moisés. Moisés, porém, fugiu do Faraó e refugiou-se no país de Madiã. Quando lá chegou, sentou-se junto a um poço."
,"16":"O sacerdote de Madiã tinha sete filhas. Elas foram tirar água para encher os bebedouros e dar de beber ao rebanho de seu pai."
,"17":"Nisto, chegaram uns pastores e tentavam expulsá-las. Então Moisés levantou-se para as defender e deu de beber ao rebanho delas."
,"18":"Elas voltaram para casa de seu pai Raguel, que lhes perguntou: «Porque chegastes hoje tão cedo?»"
,"19":"Elas responderam: «Um egípcio livrou-nos dos pastores, tirou água e deu de beber ao rebanho»."
,"20":"O pai perguntou: «Onde está ele? Porque o deixastes ir embora? Ide chamá-lo para que venha comer»."
,"21":"Moisés concordou em morar com ele. E ele deu a Moisés a sua filha Séfora."
,"22":"Ela deu à luz um menino, a quem Moisés pôs o nome de Gérson, dizendo: «Sou imigrante em terra estrangeira»."
,"23":"Muito tempo depois, o rei do Egipto morreu. Os filhos de Israel gemiam sob o peso da escravidão, e clamaram; e, do fundo da escravidão, o seu clamor chegou até Deus."
,"24":"Deus ouviu as suas queixas e lembrou-Se da aliança que fizera com Abraão, Isaac e Jacob."
,"25":"Deus viu a condição dos filhos de Israel e teve compaixão deles."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Moisés apascentava o rebanho de seu sogro Jetro, sacerdote de Madiã. Levou as ovelhas para além do deserto e chegou a Horeb, a montanha de Deus."
,"2":"O anjo de Javé apareceu a Moisés numa chama de fogo, do meio de uma sarça. Moisés prestou atenção: a sarça ardia no fogo, mas não se consumia."
,"3":"Então Moisés pensou: «Vou aproximar-me mais para ver esta coisa estranha: porque será que a sarça não se consome?»"
,"4":"Javé viu Moisés que se aproximava para olhar. E, do meio da sarça, Deus chamou-o: «Moisés, Moisés!» Ele respondeu: «Aqui estou»."
,"5":"Deus disse: «Não te aproximes. Tira as sandálias dos pés, porque o lugar onde estás é um lugar sagrado»."
,"6":"E continuou: «Eu sou o Deus dos teus antepassados, o Deus de Abraão, o Deus de Isaac, o Deus de Jacob».Então Moisés cobriu o rosto, pois tinha medo de olhar para Deus."
,"7":"Javé disse: «Eu vi muito bem a miséria do meu povo que está no Egipto. Ouvi o seu clamor contra os seus opressores, e conheço os seus sofrimentos."
,"8":"Por isso, desci para o libertar do poder dos egípcios e para o fazer sair desta terra para uma terra fértil e espaçosa, terra onde corre leite e mel, o território dos cananeus, heteus, amorreus, ferezeus, heveus e jebuseus."
,"9":"O clamor dos filhos de Israel chegou até Mim, e Eu vi a opressão com que os egípcios os atormentam."
,"10":"Por isso, vai. Eu envio-te ao Faraó, para tirares do Egipto o meu povo, os filhos de Israel»."
,"11":"Então Moisés disse a Deus: «Quem sou eu para ir ter com o Faraó e tirar os filhos de Israel do Egipto?»"
,"12":"Deus respondeu: «Eu estou contigo, e este é o sinal de que te envio: quando tiveres tirado do Egipto o meu povo, ireis servir a Deus nesta montanha»."
,"13":"Moisés replicou a Deus: «Quando eu for ter com os filhos de Israel, dir-lhes-ei: 'O Deus dos vossos antepassados enviou-me a vós'; e se eles me perguntarem: 'Qual é o nome d'Ele?', o que é que eu vou responder?»"
,"14":"Deus disse a Moisés: «Eu sou Aquele que sou».E continuou: «Dirás assim aos filhos de Israel: 'Eu Sou enviou-me a vós'»."
,"15":"Deus disse ainda a Moisés: «Dirás assim aos filhos de Israel: «Javé, o Deus dos vossos antepassados, o Deus de Abraão, o Deus de Isaac, o Deus de Jacob, é que me enviou a vós'. É este o meu nome para sempre, e assim Eu serei lembrado de geração em geração»."
,"16":"«Vai, reúne os anciãos de Israel e diz-lhes: 'Javé, o Deus dos vossos antepassados, o Deus de Abraão, o Deus de Isaac, o Deus de Jacob, apareceu-me e disse: Eu vim visitar-vos e ver como vos tratam aqui no Egipto."
,"17":"Por isso decidi libertar-vos da opressão egípcia e levar-vos para a terra dos cananeus, heteus, amorreus, ferezeus, heveus e jebuseus, para uma terra onde corre leite e mel'."
,"18":"Os anciãos de Israel escutar-te-ão. Irás, então, com os anciãos de Israel, ter com o rei do Egipto e dir-lhe-ás: 'Javé, o Deus dos hebreus, veio ao nosso encontro. Por isso deixa-nos agora fazer uma viagem de três dias no deserto, para oferecermos sacrifícios a Javé nosso Deus'."
,"19":"Entretanto, Eu sei que o rei do Egipto não vos deixará ir, se não for obrigado por mão forte."
,"20":"Portanto, vou estender a mão e ferir o Egipto com todas as maravilhas que farei no país. Então deixar-vos-á partir."
,"21":"Farei com que o povo conquiste a simpatia dos egípcios, de modo que, ao partir, não saiais de mãos vazias."
,"22":"As mulheres pedirão às vizinhas e às donas de casa, com quem estiverem alojadas, objectos de prata e ouro e roupas para vestir os seus filhos e filhas; assim, despojareis os egípcios»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Moisés replicou: «E se eles não acreditarem em mim, nem fizerem caso, dizendo: 'Javé não te apareceu'?»"
,"2":"Javé perguntou-lhe: «O que tens na mão?» Moisés respondeu: «Uma vara»."
,"3":"Então Javé disse-lhe: «Deita-a ao chão».Moisés deitou a vara ao chão e ela transformou-se numa serpente. Moisés, assustado, fugiu."
,"4":"Javé disse a Moisés: «Estende a mão e agarra-a pela cauda».Ele estendeu a mão, agarrou-a pela cauda e ela transformou-se numa vara."
,"5":"Então Javé disse: «Isto é para acreditarem que Javé, o Deus dos seus antepassados, o Deus de Abraão, o Deus de Isaac, o Deus de Jacob, te apareceu»."
,"6":"Javé disse-lhe ainda: «Coloca a mão no peito».Moisés colocou a mão no peito; ao retirá-la, a mão estava leprosa, branca como a neve."
,"7":"Javé disse-lhe: «Coloca de novo a mão no peito».Moisés colocou de novo a mão no peito e, ao retirá-la, estava normal como o resto do corpo."
,"8":"E Javé disse: «Se eles não acreditarem e não fizerem caso de ti com o primeiro sinal, acreditarão em ti com o segundo."
,"9":"Se não acreditarem nem fizerem caso de ti com nenhum dos dois sinais, vai buscar água ao rio Nilo e derrama-a na terra seca: a água que fores buscar ao rio transformar-se-á em sangue sobre a terra seca»."
,"10":"Moisés insistiu com Javé: «Meu Senhor, eu não tenho facilidade em falar, nem ontem, nem anteontem, nem depois de teres falado ao teu servo; a minha boca e a minha língua são pesadas»."
,"11":"Javé replicou: «Quem dá a boca ao homem? Quem o torna mudo ou surdo, capaz de ver ou cego? Não sou Eu, Javé?"
,"12":"Agora vai, e Eu estarei na tua boca e ensinar-te-ei o que hás-de dizer»."
,"13":"Moisés, porém, insistiu: «Não, meu Senhor, envia o intermediário que quiseres»."
,"14":"Javé ficou irritado com Moisés e disse-lhe: «Não tens o teu irmão Aarão, o levita? Sei que ele sabe falar bem. Ele está vindo ao teu encontro e, vendo-te, alegrar-se-á."
,"15":"Vais falar com ele e transmitir-lhe-ás as mensagens. Eu estarei na tua boca e na dele, e ensinar-vos-ei o que devereis fazer."
,"16":"Ele falará ao povo em teu lugar: ele será a tua boca, e tu serás um deus para ele."
,"17":"Leva esta vara na mão: é com ela que farás os sinais»."
,"18":"Moisés voltou para a casa do sogro, Jetro, e disse-lhe: «Vou voltar para o Egipto, para ver se os meus irmãos ainda vivem».Jetro respondeu: «Vai em paz»."
,"19":"Em Madiã, Javé disse a Moisés: «Volta para o Egipto, porque já morreram todos os que projectavam matar-te»."
,"20":"Então Moisés tomou a mulher e o filho, ajudou-os a montar num jumento, e voltou para a terra do Egipto. Moisés levava na mão a vara de Deus."
,"21":"E Javé disse a Moisés: «Quando voltares ao Egipto, procura fazer na presença do Faraó os prodígios que coloquei à tua disposição. Mas vou endurecer o coração do Faraó, e ele não deixará partir o povo."
,"22":"Então dirás ao Faraó: Assim diz Javé: Israel é o meu filho primogénito"
,"23":"e Eu ordeno-te que deixes sair o meu filho para que Me sirva. Se recusares deixá-lo partir, matarei o teu filho primogénito»."
,"24":"Durante a viagem, numa hospedaria, Javé foi ao encontro de Moisés e procurava matá-lo."
,"25":"Séfora pegou numa pedra aguda, cortou o prepúcio do seu filho, com ele tocou os órgãos sexuais de Moisés, e disse: «És para mim um esposo de sangue»."
,"26":"E Javé deixou-o quando ela disse: «esposo de sangue», por causa da circuncisão."
,"27":"Javé disse a Aarão: «Vai até ao deserto para te encontrares com Moisés».Ele foi, encontrou-o na montanha de Deus e beijou-o."
,"28":"Moisés contou a Aarão tudo o que Javé lhe havia dito quando lhe confiara a missão. E falou de todos os sinais que Javé lhe havia mandado realizar."
,"29":"Então Moisés e Aarão foram reunir todos os anciãos dos filhos de Israel."
,"30":"Aarão repetiu tudo o que Javé tinha dito a Moisés, e este realizou os sinais diante do povo."
,"31":"O povo acreditou. E, ouvindo que Javé Se ocupava dos filhos de Israel e vira a sua opressão, todos se ajoelharam e se prostraram."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Depois disto, Moisés e Aarão apresentaram-se diante do Faraó e disseram: «Assim diz Javé, o Deus de Israel: Deixa partir o meu povo para que celebre uma festa em minha honra no deserto»."
,"2":"O Faraó respondeu: «Quem é Javé, para que eu tenha de Lhe obedecer e deixar partir Israel? Não reconheço Javé, nem deixarei partir Israel»."
,"3":"Eles disseram: «O Deus dos hebreus veio ao nosso encontro. Deixa-nos fazer uma viagem de três dias pelo deserto para oferecermos sacrifícios a Javé nosso Deus; caso contrário, Ele nos ferirá com a peste ou com a espada»."
,"4":"Então o rei do Egipto disse-lhes: «Moisés e Aarão, porque desviais o povo do seu trabalho? Voltai já para o trabalho!»"
,"5":"E o Faraó acrescentou: «Eles já são mais numerosos que os nativos do país, e ainda quereis que deixem de trabalhar?»"
,"6":"Nesse mesmo dia, o Faraó deu ordem aos capatazes e inspectores, dizendo:"
,"7":"«Não forneçais ao povo palha para fazer tijolos, como antes. Eles é que a devem ir buscar."
,"8":"Exigir-lhes-eis a mesma quantidade de tijolos que faziam antes. Não diminuais nada, porque eles são preguiçosos e por isso andam a clamar: 'Vamos sacrificar ao nosso Deus'."
,"9":"Sobrecarregai esses homens com mais trabalho, para que fiquem ocupados e não dêem atenção a palavras mentirosas»."
,"10":"Os capatazes e inspectores saíram e falaram ao povo: «Assim disse o Faraó: 'Daqui para o futuro deixarei de vos fornecer a palha:"
,"11":"ide vós mesmos buscá-la onde a puderdes encontrar. E o trabalho não será diminuído em nada'»."
,"12":"Então o povo espalhou-se por todo o território egípcio para recolher palha."
,"13":"Os capatazes pressionavam-nos, dizendo: «Acabai o trabalho, a tarefa de cada dia, do mesmo modo como quando havia palha»."
,"14":"E os capatazes açoitavam os inspectores israelitas, que os mesmos capatazes do Faraó haviam colocado sobre eles. E diziam-lhes: «Porque não conseguistes, nem ontem nem hoje, a quantidade de tijolos que fazíeis antes?»"
,"15":"Os inspectores israelitas foram, então, reclamar diante do Faraó, dizendo: «Porque tratas assim os teus servos?"
,"16":"Exigem que façamos tijolos, mas não nos fornecem a palha. Os teus servos são açoitados, mas o culpado é o teu povo!»"
,"17":"O Faraó, porém, respondeu: «Vós sois muito preguiçosos! É por isso que dizeis: 'Vamos oferecer sacrifícios a Javé'."
,"18":"Pois agora, ide trabalhar. Não recebereis palha e tereis que produzir a mesma quantidade de tijolos»."
,"19":"Então os inspectores israelitas viram-se em apuros, pois fora-lhes dito que não deviam diminuir a produção diária de tijolos."
,"20":"Quando saíram da presença do Faraó, encontraram Moisés e Aarão que estavam à espera deles."
,"21":"Então disseram-lhes: «Que Javé vos examine e julgue, porque vós é que nos tornastes odiosos ao Faraó e à sua corte, e pusestes na mão deles uma espada para nos matar»."
,"22":"Então Moisés voltou-se para Javé e perguntou: «Senhor, porque maltratas este povo? Porque me enviaste?"
,"23":"Desde que me apresentei ao Faraó para falar em teu nome, o povo é maltratado, e Tu não libertaste o teu povo»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Javé respondeu a Moisés: «Agora verás o que vou fazer ao Faraó. É pela força que ele vos deixará partir, e até vos expulsará do seu país!»"
,"2":"Deus disse a Moisés: «Eu sou Javé."
,"3":"Apareci a Abraão, a Isaac e a Jacob como o Deus Todo-poderoso, mas não lhes dei a conhecer o meu nome: Javé."
,"4":"Também estabeleci a minha aliança com eles, para lhes dar a terra de Canaã, a terra em que residiam como imigrantes."
,"5":"Eu ouvi os gemidos dos filhos de Israel que os egípcios escravizaram, e lembrei-Me da minha aliança."
,"6":"Portanto, dizei aos filhos de Israel: «Eu sou Javé. Eu tirarei de cima de vós as cargas do Egipto, libertar-vos-ei da escravidão e vos resgatarei com mão estendida, fazendo justiça solene."
,"7":"Eu adoptar-vos-ei como meu povo e serei o vosso Deus, Aquele que tira de cima de vós as cargas do Egipto."
,"8":"Depois far-vos-ei entrar na terra que prometi, com juramento, a Abraão, a Isaac e a Jacob: Eu vo-la darei como propriedade. Eu sou Javé»."
,"9":"Moisés comunicou isto aos filhos de Israel, mas eles não fizeram caso, porque estavam no limite da resistência, por causa da dura escravidão."
,"10":"Javé disse a Moisés:"
,"11":"«Vai dizer ao Faraó, rei do Egipto, que deixe sair os fi-lhos de Israel do seu território»."
,"12":"Moisés, porém, disse a Javé: «Se nem os filhos de Israel me dão ouvidos, como é que o Faraó me vai ouvir, a mim que não tenho facilidade em falar?»"
,"13":"Javé falou a Moisés e Aarão e enviou-os ao Faraó, rei do Egipto, para tirarem do Egipto os filhos de Israel."
,"14":"Estes são os chefes das suas famílias: filhos de Rúben, primogénito de Israel: Henoc, Falu, Hesron e Carmi. São os clãs de Rúben."
,"15":"Filhos de Simeão: Jamuel, Jamin, Aod, Jaquin, Soar e Saul, filho da cananeia. São os clãs de Simeão."
,"16":"Nomes dos filhos de Levi, com os seus descendentes: Gérson, Caat e Merari. Levi viveu cento e trinta e sete anos."
,"17":"Filhos de Gérson: Libni e Semei, com os seus clãs."
,"18":"Filhos de Caat: Amram, Isaar, Hebron e Oziel. Caat viveu cento e trinta e três anos."
,"19":"Filhos de Merari: Mooli e Musi. São os clãs de Levi, com as suas descendências."
,"20":"Amram casou-se com sua tia Jocabed, e ela deu-lhe Aarão e Moisés. Amram viveu cento e trinta e sete anos."
,"21":"Filhos de Isaar: Coré, Nefeg e Zecri."
,"22":"Filhos de Oziel: Misael, Elisafã e Setri."
,"23":"Aarão casou-se com Isabel, filha de Aminadab, irmã de Naasson, e ela deu-lhe Nadab, Abiú, Eleazar e Itamar."
,"24":"Filhos de Coré: Asir, Elcana e Abiasaf. São os clãs dos coreítas."
,"25":"Eleazar, filho de Aarão, casou-se com uma das filhas de Futiel, que lhe gerou Fineias. São estes os chefes das famílias dos levitas, segundo os seus clãs."
,"26":"E estes são Aarão e Moisés; foi a eles que Javé disse: «Tirai do Egipto os filhos de Israel, segundo os seus exércitos»."
,"27":"Foram eles, Moisés e Aarão, que falaram ao Faraó, rei do Egipto, para que deixasse sair do Egipto os fi-lhos de Israel."
,"28":"Quando Javé falou a Moisés no Egipto,"
,"29":"Javé disse-lhe: «Eu sou Javé. Diz ao Faraó, rei do Egipto, tudo o que te estou a dizer»."
,"30":"Moisés respondeu a Javé: «Não sei falar com facilidade. Como é que o Faraó vai ouvir-me?»"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Javé disse a Moisés: «Vou fazer de ti um deus para o Faraó, e o teu irmão Aarão será o teu profeta."
,"2":"Dirás o que Eu te ordenar e o teu irmão Aarão falará ao Faraó, para que deixe partir os filhos de Israel da sua terra."
,"3":"Eu, porém, vou endurecer o coração do Faraó, e multiplicarei sinais e prodígios no país do Egipto."
,"4":"O Faraó não vai ouvir-vos; e então, Eu colocarei a minha mão sobre o Egipto e tirarei do Egipto os meus exércitos, o meu povo, os filhos de Israel, fazendo solene justiça."
,"5":"Deste modo, os egípcios saberão que Eu sou Javé, quando Eu estender a minha mão sobre o Egipto e fizer sair os filhos de Israel do meio deles»."
,"6":"Moisés e Aarão fizeram exactamente o que Javé tinha ordenado."
,"7":"Quando falaram ao Faraó, Moisés tinha oitenta anos, e Aarão oitenta e três."
,"8":"Javé disse a Moisés e Aarão:"
,"9":"«Se o Faraó pedir para fazerdes algum prodígio, dirás a Aarão que pegue na tua vara e a lance ao chão diante do Faraó e ela transformar-se-á numa serpente»."
,"10":"Moisés e Aarão apresentaram-se diante do Faraó e fizeram o que Javé lhes havia mandado. Aarão lançou a vara diante do Faraó e dos seus ministros, e ela transformou-se numa serpente."
,"11":"O Faraó, porém, mandou chamar os sábios e os encantadores de serpentes, e também eles, os magos do Egipto, fizeram o mesmo com as suas ciências ocultas:"
,"12":"cada um lançou a sua vara e elas transformaram-se em serpentes. No entanto, a vara de Aarão devorou as varas deles."
,"13":"Apesar disso, o coração do Faraó endureceu-se e ele não fez caso de Moisés e Aarão, exactamente como Javé havia predito."
,"14":"Javé disse a Moisés: «O coração do Faraó está endurecido, e ele recusa-se a deixar partir o povo."
,"15":"Vai ter com o Faraó amanhã de manhã. Ele vai sair para o rio e tu esperá-lo-ás na margem do Nilo. Leva contigo a vara que se transformou em serpente."
,"16":"Diz ao Faraó: 'Javé, o Deus dos hebreus, enviou-me a ti para te dizer: Deixa partir o meu povo para que Me sirva no deserto. Até agora não Me escutaste."
,"17":"Portanto, assim diz Javé: Com isto ficarás a saber que Eu sou Javé: com esta vara que tenho na mão, vou tocar nas águas do rio e elas transformar-se-ão em sangue:"
,"18":"os peixes do rio morrerão, o rio vai ficar a cheirar mal e os egípcios não poderão mais beber a água do rio'»."
,"19":"Javé disse a Moisés: «Diz a Aarão: 'Toma a vara e estende a mão sobre as águas do Egipto, sobre os rios, canais, lagoas e sobre todos os reservatórios, para que se convertam em sangue. Haverá sangue em toda a terra do Egipto, até nas vasilhas de madeira e de pedra'»."
,"20":"Moisés e Aarão fizeram como Javé tinha mandado. Aarão ergueu a vara, tocou a água do rio diante do Faraó e da sua corte; e toda a água do Nilo se transformou em sangue."
,"21":"Os peixes do rio morreram, o rio ficou poluído, e os egípcios não podiam beber a água do rio. E houve sangue por todo o país do Egipto."
,"22":"Os magos do Egipto, porém, fizeram o mesmo com as suas ciências ocultas. O coração do Faraó endureceu-se e ele não fez caso, exactamente como Javé havia predito."
,"23":"O Faraó voltou para o palácio, sem se preocupar com o caso."
,"24":"Os egípcios cavaram nos arredores do rio para encontrar água potável, pois não podiam beber a água do rio."
,"25":"Sete dias depois de ter tocado no Nilo,"
,"26":"Javé disse a Moisés: «Apresenta-te ao Faraó e diz-lhe: 'Assim diz Javé: Deixa partir o meu povo para que Me sirva."
,"27":"Se não o deixares partir, infestarei todo o teu território com rãs:"
,"28":"o Nilo fervilhará de rãs, que subirão e entrarão no teu palácio, nas casas e quartos e até na tua cama; o mesmo acontecerá na casa dos teus ministros e do teu povo, nos fornos e amassadeiras."
,"29":"As rãs assaltar-te-ão a ti, aos teus ministros e a todo o teu povo'»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Javé disse a Moisés: «Diz a Aarão: 'Estende a mão com a vara sobre os rios, canais e lagoas, e faz subir rãs sobre todo o território egípcio'»."
,"2":"Aarão estendeu a mão sobre as águas do Egipto, e fez subir rãs que infestaram todo o território egípcio."
,"3":"Os magos do Egipto, porém, usaram as suas ciências ocultas e fizeram o mesmo: fizeram subir rãs por todo o território egípcio."
,"4":"O Faraó mandou chamar Moisés e Aarão, e disse-lhes: «Rezai a Javé, para que afaste as rãs de mim e do meu povo. Então eu deixarei partir o povo para que ofereça sacrifícios a Javé»."
,"5":"Moisés disse ao Faraó: «Diz-me, por favor, quando é que eu devo rezar por ti, pelos teus ministros e pelo teu povo, a fim de que o Senhor afaste as rãs de ti e das tuas casas, de modo que as rãs fiquem somente no Nilo»."
,"6":"O Faraó respondeu: «Amanhã.» Moisés disse: «Será conforme pedes, para que saibas que não há ninguém como Javé nosso Deus."
,"7":"As rãs afastar-se-ão de ti, da tua casa, dos teus ministros e do teu povo. Ficarão somente no rio»."
,"8":"Moisés e Aarão saíram do palácio do Faraó. E Moisés suplicou a Javé por causa das rãs que ele havia mandado contra o Faraó."
,"9":"Javé cumpriu o que Moisés lhe pedia: morreram as rãs que estavam nas casas, pátios e campos:"
,"10":"foram reunidas em montes imensos, e a terra ficou poluída."
,"11":"Mas o Faraó viu que havia trégua, e seu coração ficou endurecido e não lhes deu ouvidos, exactamente como Javé tinha predito."
,"12":"Javé disse a Moisés: «Diz a Aarão: 'Estende a vara e toca no pó da terra, e ele transformar-se-á em mosquitos por todo o território egípcio'»."
,"13":"Aarão estendeu a mão com a vara e tocou no pó da terra, que se transformou em mosquitos, que atacavam homens e animais. E todo o pó da terra transformou-se em mosquitos por todo o país do Egipto."
,"14":"Os magos do Egipto tentaram fazer o mesmo, usando as suas ciências ocultas para produzir mosquitos, mas não conseguiram. Os mosquitos atacavam homens e animais."
,"15":"Então os magos disseram ao Faraó: «Há nisto o dedo de Deus».Mas o coração do Faraó endureceu-se e não os ouviu, exactamente como Javé tinha pre-dito."
,"16":"Javé disse a Moisés: «Levanta-te de madrugada, apresenta-te ao Faraó quando ele sair para o rio, e diz-lhe: 'Assim diz Javé: Deixa partir o meu povo para que Me sirva."
,"17":"Se não deixares partir o meu povo, mandarei moscas contra ti, contra os teus ministros, o teu povo e as tuas casas. As casas dos egípcios e até mesmo o solo que pisam ficarão cheios de moscas."
,"18":"Nesse dia, Eu tratarei de maneira diferente o território de Gessen, onde reside o meu povo, para que aí não haja moscas. Assim saberás que Eu sou Javé e estou no país."
,"19":"Farei uma distinção entre o meu povo e o teu povo. Este sinal acontecerá amanhã'»."
,"20":"Assim fez Javé: nuvens de moscas invadiram o palácio do Faraó e dos seus ministros e todo o território egípcio, de modo que toda a terra do Egipto ficou infestada de moscas."
,"21":"O Faraó mandou chamar Moisés e Aarão, e disse-lhes: «Ide oferecer sacrifícios ao vosso Deus dentro do meu território»."
,"22":"Moisés respondeu: «Não é oportuno fazer isso, porque os nossos sacrifícios a Javé nosso Deus são abomináveis para os egípcios. Se imolarmos diante deles o que eles abominam, certamente irão apedrejar-nos."
,"23":"Temos que viajar três dias pelo deserto, para oferecer sacrifícios a Javé nosso Deus, conforme Ele nos mandou»."
,"24":"O Faraó propôs: «Eu deixar-vos-ei fazer sacrifícios ao vossso Deus no deserto, com a condição de que não vos afasteis muito. Rezai por mim»."
,"25":"Moisés respondeu: «Logo que eu sair da tua presença, rezarei a Javé, para que amanhã mesmo Ele afaste as moscas do Faraó, dos seus ministros e do seu povo. Mas que o Faraó não torne a enganar-me, não permitindo que o povo vá fazer sacrifícios a Javé»."
,"26":"Moisés saiu da presença do Faraó e orou a Javé."
,"27":"E Javé fez o que Moisés pedia: afastou as moscas do Faraó, dos seus ministros e do seu povo, até não ficar nem sequer uma."
,"28":"Mas o Faraó endureceu o coração também desta vez e não deixou que o povo partisse."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Javé disse a Moisés: «Apresenta-te ao Faraó e diz-lhe: 'Assim diz Javé, o Deus dos hebreus: Deixa partir o meu povo para que Me sirva."
,"2":"Se não o deixares partir, e continuares a detê-lo à força,"
,"3":"a mão de Javé vai ferir, com uma peste maligna, os rebanhos do campo, os cavalos, jumentos, camelos, bois e ovelhas'."
,"4":"Javé, no entanto, fará distinção entre os rebanhos de Israel e os rebanhos dos egípcios, de modo que nada perecerá do que pertence aos filhos de Israel."
,"5":"Javé estabeleceu um prazo: amanhã Javé fará isto nesta terra»."
,"6":"Javé cumpriu a sua palavra no dia seguinte. E morreram todos os animais dos egípcios, mas não morreu nenhum dos animais dos filhos de Israel."
,"7":"O Faraó mandou averiguar e viu que do rebanho de Israel nenhum animal havia morrido. No entanto, o Faraó endureceu o coração e não deixou partir o povo."
,"8":"Javé disse a Moisés e Aarão: «Tomai do forno um punhado de cinza, e que Moisés o atire ao ar diante dos olhos do Faraó."
,"9":"A cinza transformar-se-á em pó sobre todo o território egípcio e cairá sobre homens e animais, produzindo úlceras e chagas em toda a terra do Egipto»."
,"10":"Eles tomaram cinza do forno, apresentaram-se ao Faraó, e Moisés deitou-a ao ar, e os homens e animais ficaram cobertos de tumores e chagas."
,"11":"Os magos, por causa dos tumores, não puderam ficar de pé diante de Moisés, porque havia tumores nos magos e em todos os egípcios."
,"12":"Javé, porém, endureceu o coração do Faraó e este não os ouviu, exactamente como Javé tinha predito a Moisés."
,"13":"Javé disse a Moisés: «Levanta-te de madrugada, apresenta-te ao Faraó, e diz-lhe: 'Assim diz Javé, o Deus dos hebreus: Deixa partir o meu povo para que Me sirva,"
,"14":"pois desta vez mandarei todas as minhas pragas contra ti, contra os teus ministros e contra o teu povo, para que saibas que não há ninguém como Eu em toda a Terra."
,"15":"De facto, se Eu já tivesse estendido a mão para te ferir a ti e ao teu povo com peste, já terias desaparecido da Terra."
,"16":"Entretanto, foi exactamente para isto que Eu te conservei de pé, para te mostrar a minha força e para que a minha fama se espalhe por toda a Terra."
,"17":"No entanto, continuas a reter o meu povo e não o deixas partir!"
,"18":"Vê bem! Amanhã, a esta mesma hora, farei cair uma pesada chuva de granizo, como nunca se viu no Egipto, desde o dia em que foi fundado até hoje."
,"19":"Agora, portanto, manda recolher os teus animais e tudo o que tens no campo, porque os homens e animais que estiverem no campo e não se refugiarem sob um tecto vão morrer por causa da chuva de granizo'»."
,"20":"Os ministros do Faraó que respeitavam a palavra de Javé apressaram-se em dar refúgio aos seus escravos e colocar o rebanho em estábulos."
,"21":"E aqueles que não deram importância à palavra de Javé deixaram os escravos e o rebanho no campo."
,"22":"Javé disse a Moisés: «Estende a mão para o céu, a fim de cair granizo em todo o território egípcio: sobre homens e animais e sobre toda a vegetação»."
,"23":"Então Moisés estendeu a vara para o céu e Javé mandou trovões e granizo, e caíram raios sobre a terra. E Javé fez cair granizo no território egípcio."
,"24":"Caiu granizo acompanhado de raios; era tão violento que nada houve de semelhante em toda a terra do Egipto, desde que começou a ser nação."
,"25":"O granizo destruiu tudo o que havia no território egípcio: feriu tudo o que se encontrava no campo, homens e animais, destruiu a vegetação campestre e quebrou todas as árvores do campo."
,"26":"Só não caiu granizo na terra de Gessen, onde viviam os filhos de Israel."
,"27":"Então o Faraó mandou chamar Moisés e Aarão, e disse-lhes: «Desta vez eu pequei. Javé é justo, e eu com o meu povo somos ímpios."
,"28":"Rezai a Javé, porque já chegam estes trovões e granizo! Eu deixar-vos-ei partir, e não tentarei reter-vos»."
,"29":"Moisés respondeu: «Quando eu sair da cidade, estenderei as mãos para Javé: os trovões cessarão e não haverá mais granizo, para que saibas que a terra pertence a Javé."
,"30":"Quanto a ti e aos teus ministros, porém, eu sei que ainda não temeis o Deus Javé»."
,"31":"O linho e a cevada perderam-se, pois a cevada já estava com espiga e o linho em flor;"
,"32":"o trigo e o centeio, porém, não se perderam, porque são tardios."
,"33":"Moisés saiu do palácio do Faraó e da cidade. E estendeu as mãos para Javé. Os trovões e o granizo cessaram, e deixou de chover sobre a terra."
,"34":"Ao ver que a chuva, o granizo e os trovões tinham cessado, o Faraó continuou a pecar, endurecendo o coração, tanto ele como os seus ministros."
,"35":"O coração do Faraó endureceu-se ainda mais. E não deixou partir os filhos de Israel, exactamente como Javé tinha predito a Moisés."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Javé disse a Moisés: «Apresenta-te ao Faraó, pois Eu endureci o seu coração e o dos seus ministros, para realizar entre eles os meus sinais,"
,"2":"a fim de que contes ao teu filho e ao teu neto o modo como Eu tratei os egípcios, e os sinais que realizei no meio deles. Assim, reconhecereis que Eu sou Javé»."
,"3":"Então Moisés e Aarão apresentaram-se ao Faraó e disseram-lhe: «Assim diz Javé, o Deus dos hebreus: ' Até quando recusarás humilhar-te diante de Mim? Deixa partir o meu povo para que Me sirva."
,"4":"Se não deixares partir o meu povo, amanhã mandarei gafanhotos sobre o teu território."
,"5":"Eles cobrirão a superfície da terra, de tal modo que não se poderá ver o chão. Comerão o resto das colheitas que escaparam ao granizo e todas as árvores que crescem no campo."
,"6":"Encherão as tuas casas, assim como as dos teus ministros e de todos os egípcios, como os teus pais e avós nunca viram, desde o dia em que vieram à terra até hoje».Moisés voltou-se e saiu da presença do Faraó."
,"7":"Então os ministros disseram ao Faraó: «Até quando esse homem será a causa da nossa desgraça? Deixa partir essa gente para que sirva o seu Deus Javé. Não vês que o Egipto está arruinado?»"
,"8":"Mandaram então Moisés e Aarão voltar à presença do Faraó, e este disse-lhes: «Ide prestar culto a Javé, vosso Deus. Mas dizei-me quem é que vai»."
,"9":"Moisés respondeu: «Temos que ir com jovens e velhos, com filhos e filhas, com os rebanhos e o gado, porque para nós é uma festa de Javé»."
,"10":"O Faraó replicou: «Que Javé esteja convosco, como é certo que vou deixar-vos partir com os vossos filhos. Vós tendes más intenções!"
,"11":"Não, não! Ide apenas vós, os homens, e oferecei sacrifícios a Javé, se é isso que quereis».E expulsaram-nos da presença do Faraó."
,"12":"Javé disse a Moisés: «Estende a mão sobre o Egipto, para que venham gafa-nhotos sobre o país, e devorem toda a ve-getação da terra e tudo o que se salvou do granizo»."
,"13":"Moisés estendeu a vara sobre a terra do Egipto. E Javé fez soprar sobre o país um vento oriental, durante todo o dia e toda a noite. Quando amanheceu, o vento oriental já havia trazido os gafanhotos."
,"14":"E os gafanhotos invadiram todo o território egípcio, e eram tão numerosos como nunca houve antes e nunca mais haverá."
,"15":"Cobriram toda a superfície do solo e devastaram a terra. Devoraram toda a vegetação do solo e todo o fruto que o granizo tinha deixado nas árvores. E em todo o território egípcio não ficou nada verde nas árvores, nem na vegetação do campo."
,"16":"O Faraó mandou imediatamente cha-mar Moisés e Aarão, e disse-lhes: «Pequei contra o vosso Deus Javé, e contra vós."
,"17":"Perdoai o meu pecado ainda esta vez, e rezai para que o vosso Deus Javé afaste de mim este castigo mortal»."
,"18":"Moisés saiu do palácio do Faraó e rezou a Javé."
,"19":"Então Javé fez soprar do Ocidente um forte vento, que arrastou os gafanhotos e os lançou no Mar Verme-lho: não ficou um só gafanhoto em todo o território egípcio."
,"20":"Javé, porém, endureceu o coração do Faraó, e este não deixou que os filhos de Israel partissem."
,"21":"Javé disse a Moi-sés: «Estende a mão para o céu. E sobre todo o território egípcio haverá uma escuridão que se poderá apalpar»."
,"22":"Moisés estendeu a mão para o céu. E uma densa treva cobriu o território egípcio durante três dias."
,"23":"Uma pessoa não via a outra, e durante três dias ninguém se levantou do lugar em que estava. Contudo, havia luz em toda a parte onde habitavam os filhos de Israel."
,"24":"O Faraó mandou chamar Moisés e Aarão, e disse-lhes: «Ide oferecer sacrifícios a Javé; que só fiquem aqui os vossos rebanhos e o vosso gado; as crianças poderão ir convosco»."
,"25":"Moisés respondeu: «Mesmo que nos desses as vítimas para os sacrifícios e holocaustos, a fim de as oferecermos a Javé nosso Deus,"
,"26":"ainda assim o nosso gado deveria ir connosco. Não ficará nenhum animal, pois precisamos deles para os oferecer a Javé nosso Deus. Nem nós mesmos sabemos quais são as vítimas que ofereceremos a Javé, enquanto não chegarmos lá»."
,"27":"Javé, porém, endureceu o coração do Faraó. E este não quis deixá-los partir."
,"28":"E o Faraó disse a Moisés: «Sai da minha casa e livra-te de tornares a aparecer na minha presença. Porque se eu te tornar a ver, morrerás imediatamente»."
,"29":"Moisés respondeu: «Seja como disseste: nunca mais voltarei à tua presença»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Javé disse a Moisés: «Enviarei mais uma praga contra o Faraó e contra o Egipto. Só então vos deixará partir daqui; melhor ainda, expulsar-vos-á daqui."
,"2":"Portanto, diz ao povo que cada homem peça objectos de prata e ouro ao seu vizinho, e cada mulher à sua vizinha»."
,"3":"E Javé fez com que o povo ganhasse a simpatia dos egípcios. Moisés também era muito estimado no Egipto pelos ministros do Faraó e pelo povo."
,"4":"Moisés disse: «Assim diz Javé: À meia-noite, Eu passarei pelo meio do Egipto,"
,"5":"e todos os primogénitos do Egipto morrerão, desde o primogénito do Faraó, herdeiro do seu trono, até ao primogénito da escrava que trabalha no moinho, e todos os primogénitos dos animais."
,"6":"Então na terra do Egipto haverá grande clamor, como nunca houve antes e nunca mais haverá."
,"7":"Mas, entre os filhos de Israel, desde os homens até aos animais, não se ouvirá nem o latido de um cão, para que saibais que Javé faz distinção entre o Egipto e Israel."
,"8":"Então todos os ministros do Faraó virão ter comigo e, prostrados diante de mim, dirão: 'Sai, tu e todo o povo que te acompanha'. Então eu sairei».E, ardendo em ira, Moisés saiu do palácio do Faraó."
,"9":"Javé disse a Moisés: «O Faraó não te escutará. Assim os meus prodígios multiplicar-se-ão no Egipto»."
,"10":"Moisés e Aarão fizeram todos estes prodígios diante do Faraó. Javé, porém, endureceu o coração do Faraó e ele não deixou que os filhos de Israel partissem do seu país."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Javé disse a Moisés e Aarão na terra do Egipto:"
,"2":"«Este mês será para vós o principal, o primeiro mês do ano."
,"3":"Falai assim a toda a assembleia de Israel: 'No dia dez deste mês, cada família tome um animal, um animal por cada casa."
,"4":"Se a família for pequena para um animal, então ela juntar-se-á com o vizinho mais próximo da sua casa. O animal será escolhido conforme o número de pessoas e conforme cada uma puder comer."
,"5":"O animal deve ser macho, sem defeito, e de um ano. Podereis escolhê-lo entre os cordeiros ou entre os cabritos,"
,"6":"e guardá-lo-eis até ao dia catorze deste mês, altura em que toda a assembleia de Israel o imolará ao entardecer."
,"7":"Recolhereis o seu sangue e aplicá-lo-eis sobre os dois batentes e sobre a travessa da porta, nas casas onde comerdes o animal."
,"8":"Nessa noite, comer-se-á a carne assada no fogo e acompanhada de pão sem fermento com ervas amargas."
,"9":"Não comereis a carne crua nem cozida na água, mas assada no fogo: inteiro, com cabeça, pernas e vísceras."
,"10":"Não deixareis restos para o dia seguinte; se sobrar alguma coisa, deveis queimá-la no fogo."
,"11":"Deveis comê-lo assim: com cintos na cintura, sandálias nos pés e cajado na mão; comê-lo-eis apressadamente, por-que é a Páscoa de Javé."
,"12":"Nessa noite, Eu passarei pela terra do Egipto, matarei todos os primogénitos egípcios, desde os homens até aos animais. E farei justiça contra todos os deuses do Egipto. Eu sou Javé."
,"13":"O sangue nas casas será um sinal de que estais dentro delas: ao ver o sangue, Eu passarei adiante. E o flagelo destruidor não vos atingirá, quando Eu ferir o Egipto."
,"14":"Esse dia será para vós um memorial, pois nele celebrareis uma festa de Javé. Celebrá-la-eis como um rito permanente, de geração em geração."
,"15":"Durante sete dias, comereis pães sem fermento. No primeiro dia, tirareis o fermento de dentro de casa, e será excluída de Israel qualquer pessoa que comer algo fermentado, desde o primeiro dia até ao sétimo."
,"16":"No primeiro dia fareis uma assembleia sagrada. E, no sétimo dia, outra assembleia sagrada. Nesses dias ninguém trabalhará, e preparareis apenas o que cada um deve comer."
,"17":"Observareis a festa dos Pães sem fermento, porque nesse mesmo dia Eu fiz sair os vossos exércitos do Egipto. Observareis esse dia como rito permanente, de geração em geração."
,"18":"No dia catorze do primeiro mês, à tarde, comereis pães sem fermento, até à tarde do dia vinte e um desse mês."
,"19":"Durante sete dias não se achará fermento na vossa casa, pois todo aquele que comer pão fermentado será eliminado da comunidade de Israel, tanto o imigrante como o natural do país."
,"20":"Não comereis pão fermentado; comereis pães sem fermento em todo o lugar em que morardes'»."
,"21":"Moisés convocou todos os anciãos de Israel e disse-lhes: «Escolhei, por família, um animal e imolai a Páscoa."
,"22":"Pegai em alguns ramos de hissopo, molhai-os no sangue que estiver na bacia, e com o sangue que estiver na bacia aspergireis a verga da porta e os seus batentes. Ninguém de vós saia de casa antes de amanhecer o dia seguinte,"
,"23":"porque Javé passará para ferir os egípcios. E quando notar o sangue sobre a verga da porta e sobre os dois batentes, Ele passará adiante dessa porta e não deixará que o exterminador entre nas vossas casas para vos ferir."
,"24":"Observai este preceito, como decreto perpétuo, para vós e para os vossos filhos."
,"25":"Quando tiverdes entrado na terra que Javé vos dará, conforme Ele disse, observareis este rito."
,"26":"Quando os vossos filhos vos perguntarem: 'Que rito é es-te?',"
,"27":"respondereis: 'É o sacrifício da Páscoa de Javé. Ele passou no Egipto junto às casas dos filhos de Israel, ferindo os egípcios, e protegeu as nossas casas'».Então o povo ajoelhou-se e prostrou-se."
,"28":"Os filhos de Israel foram e fizeram tudo isto, e fizeram-no como Javé tinha ordenado a Moisés e Aarão."
,"29":"À meia-noite, Javé feriu todos os primogénitos do Egipto: desde o primogénito do Faraó, que iria suceder-lhe no trono, até ao primogénito do prisioneiro que estava na cadeia e até aos primogénitos dos animais."
,"30":"No meio da noite, o Faraó levantou-se com todos os seus ministros e todos os egípcios. E houve um clamor imenso em todo o Egipto, pois não havia casa onde não houvesse um morto."
,"31":"De noite ainda, o Faraó chamou Moisés e Aarão, e disse-lhes: «Levantai-vos e saí do meio do meu povo, vós e os filhos de Israel. Ide servir a Javé, como pedistes."
,"32":"Levai também os vossos rebanhos e gado. Parti e abençoai-me»."
,"33":"Os egípcios pressionavam o povo para que saísse depressa do país, pois tinham medo de morrerem todos."
,"34":"E o povo levou aos ombros a farinha amassada antes que levedasse, e as amassadeiras, atadas em trouxas com os seus mantos."
,"35":"Os filhos de Israel fizeram também o que Moisés havia mandado: pediram aos egípcios objectos de prata e ouro e roupas."
,"36":"Javé fez com que eles ganhassem a simpatia dos egípcios, que lhes deram tudo o que pediam. E foi assim que despojaram os egípcios."
,"37":"Os filhos de Israel partiram de Ramsés, em direcção a Sucot: eram seiscentos mil homens a pé, sem contar as crianças."
,"38":"Subiu também com eles imensa multidão com ovelhas, gado e muitos animais."
,"39":"Cozeram pães sem fermento com a farinha que haviam levado do Egipto, pois a massa não estava levedada: é que, expulsos do Egipto, não puderam parar, nem preparar provisões para o caminho."
,"40":"A estada dos filhos de Israel no Egipto durou quatrocentos e trinta anos."
,"41":"Foi precisamente no mesmo dia em que terminaram os quatrocentos e trinta anos, que os exércitos de Javé saíram do Egipto."
,"42":"Essa noite foi uma vigília para Javé, quando Ele os tirou do Egipto. E assim deve ser para todos os filhos de Israel, uma vigília a Javé, em todas as gerações."
,"43":"Javé disse a Moisés e Aarão: «Assim será o ritual da Páscoa: nenhum estrangeiro comerá dela."
,"44":"Os escravos que tiveres comprado a dinheiro, poderão comer dela se forem circuncidados."
,"45":"Quem estiver de passagem e os mercenários não comerão dela."
,"46":"Cada cordeiro deverá ser comido dentro de uma casa; e nenhum pedaço de carne deverá ser levado para fora; e dele não se deverá quebrar nenhum osso."
,"47":"Toda a comunidade de Israel celebrará a Páscoa."
,"48":"Se algum imigrante que mora convosco quiser celebrar a Páscoa de Javé, todos os homens da sua casa deverão ser circuncidados; então, ele poderá celebrá-la e será como um nativo do país. Por isso, nenhum incircunciso poderá comer dela."
,"49":"A mesma lei vale tanto para o nativo como para o imigrante que mora no meio de vós»."
,"50":"Todos os filhos de Israel fizeram o que Javé tinha ordenado a Moisés e Aarão."
,"51":"Nesse dia, Javé tirou do Egipto os filhos de Israel, segundo os seus exércitos."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Javé disse a Moisés:"
,"2":"«Consagra-Me todos os primogénitos, todo aquele que, em primeiro lugar, sai do útero materno entre os filhos de Israel, tanto dos homens como dos animais: ele pertence-Me»."
,"3":"Moisés disse ao povo: «Lembrai-vos sempre do dia em que saístes do Egipto, da casa da escravidão, quando Javé vos tirou de lá com mão forte. Por isso, não comereis pão fermentado."
,"4":"Saís hoje, no mês de Abib."
,"5":"Quando Javé te tiver introduzido na terra dos cananeus, heteus, amorreus, heveus e jebuseus, terra que Ele jurou aos antepassados que te iria dar, uma terra onde corre leite e mel, então neste mês celebrarás o seguinte rito:"
,"6":"comerás pães sem fermento durante sete dias, e no sétimo dia haverá uma festa para Javé."
,"7":"Durante os sete dias comer-se-á pão sem fermento. Em todo o território, não haverá fermento nem qualquer coisa fermentada."
,"8":"Nesse dia, explicarás ao teu filho: 'Tudo isto é pelo que Javé fez por mim, quando eu saía do Egipto'."
,"9":"Isto servirá como sinal no braço e faixa na fronte, para que tenhas na tua boca a lei de Javé, que te tirou do Egipto com mão forte."
,"10":"Observarás esta lei todos os anos, na data marcada."
,"11":"Quando Javé te tiver introduzido na terra dos cananeus e ta tiver dado, como te jurou a ti e aos teus antepassados,"
,"12":"reservarás para Javé todos os primogénitos do útero materno; e a Javé pertencerá todo o primogénito de sexo masculino, mesmo dos animais que possuíres."
,"13":"O primogénito da jumenta, porém, resgatá-lo-ás, trocando-o por um cordeiro. Se não o resgatares, deverás quebrar-lhe a nuca. Os primogénitos humanos, porém, resgatá-los-ás sempre."
,"14":"Amanhã, quando o teu filho te perguntar: 'Que significa isto?' responder-lhe-ás: 'É que Javé nos tirou do Egipto, da casa da servidão, com a sua mão poderosa."
,"15":"O Faraó obstinou-se e não queria deixar-nos partir; por isso, Javé matou todos os primogénitos do Egipto, desde os primogénitos do homem até aos primogénitos dos animais. É por isso que eu sacrifico a Javé todos os primogénitos machos dos animais e resgato todo o primogénito dos meus filhos'."
,"16":"Isso servirá como sinal no braço e faixa na fronte, porque Javé nos tirou do Egipto com a sua mão poderosa»."
,"17":"Quando o Faraó deixou partir o povo, Deus não o guiou pelo caminho da Palestina, que é o mais curto, porque Deus achou que, diante dos ataques, o povo se arrependeria e voltaria para o Egipto."
,"18":"Então Deus fez com que o povo desse uma volta pelo deserto até ao Mar Vermelho. Os filhos de Israel saíram do Egipto bem armados."
,"19":"Moisés levou consigo os ossos de José, porque José fizera jurar solenemente os filhos de Israel, dizendo: «Quando Deus intervier em vosso favor, levareis daqui os meus ossos»."
,"20":"Partiram de Sucot e acamparam em Etam, à beira do deserto."
,"21":"Javé ia à frente deles: de dia, numa coluna de nuvem, para os guiar; de noite, numa coluna de fogo, para os iluminar. Deste modo, podiam caminhar de dia e de noite."
,"22":"De dia, a coluna de nuvem não se afastava do povo, nem de noite a coluna de fogo."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel que voltem e acampem em Piairot, entre Magdol e o mar, diante de Baal Sefon; aí acampareis, junto ao mar."
,"3":"O Faraó irá pensar que os filhos de Israel andam errantes pelo país e que o deserto os bloqueou."
,"4":"Eu endurecerei o coração do Faraó, que vos perseguirá. Então mostrarei a minha honra, derrotando o Faraó e todo o seu exército; e os egípcios saberão que Eu sou Javé».E os filhos de Israel assim fizeram."
,"5":"Quando comunicaram ao rei do Egipto que o povo tinha fugido, o Faraó e os seus ministros mudaram de opinião sobre o povo e disseram: «Que fizemos, deixando partir os nossos escravos israelitas?»"
,"6":"O Faraó mandou atrelar o seu carro e levou consigo as suas tropas:"
,"7":"seiscentos carros escolhidos e todos os carros do Egipto, com oficiais sobre todos eles."
,"8":"Javé endureceu o coração do Faraó, rei do Egipto, e este perseguiu os filhos de Israel, que saíram ostensivamente."
,"9":"Perseguindo-os com todos os cavalos e carros do Faraó, os cavaleiros e o exército alcançaram-nos quando estavam acampados junto ao mar, em Piairot, diante de Baal Sefon."
,"10":"Quando o Faraó se aproximou, os filhos de Israel levantaram os olhos e viram que os egípcios avançavam atrás deles. Cheios de medo, clamaram a Javé,"
,"11":"e disseram a Moisés: «Será que não havia sepulturas lá no Egipto? Trouxeste-nos para o deserto para morrermos! Que foi que nos fizeste, tirando-nos do Egipto?"
,"12":"Não te dizíamos lá no Egipto: 'Deixa-nos em paz, para servirmos os egípcios'? O que é melhor para nós? Servir os egípcios ou morrer no deserto?»"
,"13":"Moisés respondeu ao povo: «Não tenhais receio de nada. Permanecei firmes e vereis o que Javé vai fazer hoje para vos salvar. Os egípcios que hoje vedes nunca mais voltareis a vê-los."
,"14":"Javé combaterá por vós. Podeis ficar tranquilos»."
,"15":"Javé disse a Moisés: «Porque clamas por Mim? Diz aos filhos de Israel que avancem."
,"16":"Quanto a ti, ergue a tua vara, estende a mão sobre o mar e divide-o ao meio para que os filhos de Israel possam atravessá-lo a pé enxuto."
,"17":"Eu endureci o coração dos egípcios, para que vos persigam. Assim mostrarei a minha honra, derrotando o Faraó e o seu exército, com os seus carros e cavaleiros."
,"18":"Quando derrotar o Faraó, os seus carros e os seus cavaleiros, os egípcios ficarão a saber que Eu sou Javé»."
,"19":"O anjo de Deus, que ia à frente do exército de Israel, retirou-se para ficar na retaguarda. A coluna de nuvem também se retirou da frente deles e colocou-se atrás,"
,"20":"ficando entre o acampamento dos egípcios e o acampamento de Israel. A nuvem escureceu-se, e durante toda a noite a escuridão impediu que os exércitos se aproximassem um do outro."
,"21":"Moisés estendeu a mão sobre o mar, e Javé fez retirar o mar com um forte vento oriental, que soprou a noite inteira: o mar ficou seco e as águas dividiram-se em duas."
,"22":"Os filhos de Israel entraram pelo mar a pé enxuto, e as águas formavam duas muralhas, à direita e à esquerda."
,"23":"Na perseguição, os egípcios entraram atrás deles com todos os cavalos do Faraó, seus carros e cavaleiros, e foram até ao meio do mar."
,"24":"De madrugada, Javé olhou da coluna de fogo e da nuvem, viu o acampamento dos egípcios e provocou uma confusão no acampamento:"
,"25":"emperrou as rodas dos carros, fazendo-os andar com dificuldade. Então os egípcios disseram: «Vamos fugir de Israel, porque Javé combate a favor deles»."
,"26":"Javé disse a Moisés: «Estende a mão sobre o mar, e as águas voltar-se-ão contra os egípcios, seus carros e cavaleiros»."
,"27":"Moisés estendeu a mão sobre o mar. E, de manhã, o mar voltou para o seu leito. Os egípcios, ao fugir, foram ao encontro do mar, e Javé precipitou-os no meio do mar."
,"28":"As águas voltaram, cobrindo os carros e os cavaleiros de todo o exército do Faraó, que os haviam seguido no mar: nem um só deles escapou."
,"29":"Os filhos de Israel, porém, passaram pelo meio do mar a pé enxuto, enquanto as águas se erguiam em forma de muralhas, à direita e à esquerda."
,"30":"Nesse dia Javé salvou Israel das mãos dos egípcios, e Israel viu os cadáveres dos egípcios à beira-mar."
,"31":"Israel viu a mão forte com que Javé actuou contra o Egipto. Então o povo temeu a Javé e acreditou n'Ele e no seu servo Moisés."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Naquele ocasião, Moisés e os filhos de Israel entoaram este canto a Javé: «Vou cantar a Javé, pois a sua vitória é sublime: Ele precipitou no mar carros e cavalos"
,"2":"Javé é a minha força e o meu canto, Ele foi a minha salvação. Ele é o meu Deus: eu O louvarei; é o Deus de meu pai: eu O exaltarei."
,"3":"Javé é um guerreiro, seu nome é Javé."
,"4":"Ele precipitou no mar os carros,e o exército do Faraó, afogou no Mar Vermelho,o escol das tropas:"
,"5":"As ondas cobriram-nos, e eles afundaram-se como pedras."
,"6":"A tua direita, Javé, é terrível em poder, a tua direita, Javé, aniquila o inimigo;"
,"7":"Com sublime grandeza,abates os teus adversários, desencadeias a tua ira, e ela devora-os como palha."
,"8":"Ao sopro das tuas narinas,as águas amontoam-se, e as ondas levantam-se como represa; as vagas congelam-se no meio do mar."
,"9":"O inimigo dizia: 'Vou persegui-los e alcançá-los, vou repartir os despojos,e saciar-me com eles; vou tirar a minha espada, e a minha mão os agarrará'."
,"10":"O teu vento soprou, e o mar cobriu-os: caíram como chumbo,nas águas profundas."
,"11":"Qual Deus é como Tu, Javé?,Quem é santo como Tu, ó Magnífico, terrível em proezas, autor de maravilhas?"
,"12":"Estendeste a direita, e a terra os engoliu."
,"13":"Guiaste com amor,o povo que redimiste, e levaste-o com poder,para a tua morada santa."
,"14":"Os povos ouviram e tremeram, e o terror espalhou-se,entre os governantes filisteus,"
,"15":"e os chefes de Edom,ficaram com medo. O temor dominou os nobres de Moab; os governantes de Canaã,cambaleiam todos."
,"16":"Sobre todos eles cai,o tremor e o temor. A grandeza do teu braço,deixou-os petrificados,até o teu povo atravessar, ó Javé, até passar este povo que compraste."
,"17":"Tu o conduzes e o estabeleces,sobre o monte da tua herança, no lugar em que fizeste,o teu trono, ó Javé, no santuário,que as tuas mãos prepararam."
,"18":"Javé reina sempre e eternamente»."
,"19":"Quando a cavalaria do Faraó entrou no mar com os seus carros e cavaleiros, Javé fez voltar sobre eles as águas do mar, enquanto os filhos de Israel caminharam a pé enxuto pelo meio do mar."
,"20":"A profetisa Maria, irmã de Aarão, pegou num tamborim, e todas as mulheres a seguiram com tamborins, formando coros de dança."
,"21":"E Maria entoava: «Cantai a Javé, pois a sua vitória é sublime: Ele precipitou no mar,carros e cavalos»."
,"22":"Moisés fez partir Israel do Mar Vermelho, e eles dirigiram-se para o deserto de Sur. Caminharam três dias no deserto e não encontraram água."
,"23":"Quando chegaram a Mara, não puderam beber a água, porque era amarga; foi por isso que deram a esse lugar o nome de Mara."
,"24":"O povo murmurou contra Moisés, dizendo: «Que vamos beber?»"
,"25":"Moisés clamou a Javé, e Javé mostrou-lhe um tipo de planta. Então Moisés atirou-a à água, e a água tornou-se doce. Foi aí que Moisés estabeleceu um estatuto e um direito para o povo, colocando-o à prova "
,"26":"e dizendo: «Se obedeceres a Javé teu Deus, praticares o que Ele aprova, ouvires os seus mandamentos e observares todas as suas leis, não mandarei sobre ti nenhuma das enfermidades que mandei sobre os egípcios. Pois Eu sou Javé, Aquele que te cura»."
,"27":"Então chegaram a Elim, onde havia doze fontes de água e setenta palmeiras. E acamparam junto às águas."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Toda a comunidade de Israel partiu de Elim e chegou ao deserto de Sin, entre Elim e o Sinai, no dia quinze do segundo mês após a saída do Egipto."
,"2":"Toda a comunidade de Israel murmurou contra Moisés e Aarão no deserto,"
,"3":"dizendo: «Era melhor termos sido mortos pela mão de Javé na terra do Egipto, quando estávamos sentados junto à panela de carne, comendo pão com fartura. Trouxestes-nos para este deserto para fazer morrer à fome toda esta multidão!»"
,"4":"Javé disse a Moisés: «Farei chover para vós pão do céu: o povo sairá para recolher a porção de cada dia, para que Eu o experimente e veja se observa a minha lei, ou não."
,"5":"No sexto dia, porém, eles deverão preparar o que recolheram, e será o dobro do que recolhem nos outros dias»."
,"6":"Então Moisés e Aarão disseram a toda a comunidade de Israel: «Esta tarde sabereis que foi Javé quem vos tirou do Egipto."
,"7":"E, amanhã de manhã, vereis a glória de Javé, porque Javé ouviu as murmurações que fizestes contra Ele. Quem somos nós, para murmurardes contra nós?»"
,"8":"Moisés disse ainda: «Esta tarde, Javé dar-vos-á carne para comerdes e, pela manhã, pão com fartura, pois ouviu a murmuração que fizestes contra Ele. Quem somos nós? As vossas murmurações não são contra nós, mas sim contra Javé»."
,"9":"Moisés disse a Aarão: «Diz a toda a comunidade de Israel: 'Aproximai-vos de Javé; pois Ele ouviu as murmurações que fizestes'»."
,"10":"Enquanto Aarão falava a toda a comunidade de Israel, olharam para o deserto e viram que a glória de Javé aparecia numa nuvem."
,"11":"Javé disse a Moisés:"
,"12":"«Eu escutei as murmurações dos filhos de Israel. Diz-lhes que comerão carne à tarde e, de manhã, se fartarão de pão. Assim ficarão a saber que Eu sou Javé seu Deus»."
,"13":"À tarde, um bando de codornizes cobriu todo o acampamento e, de manhã, havia uma camada de orvalho ao redor do acampamento."
,"14":"Quando a camada de orvalho se evaporou, na superfície do deserto apareceram pequenos flocos, como cristais de gelo."
,"15":"Ao vê-los, os filhos de Israel perguntaram: «Que é isto?», pois não sabiam o que era."
,"16":"Moisés disse-lhes: «Isto é o pão que Javé vos dá para comerdes. E são estas as ordens de Javé: Cada um apanhe quanto lhe basta para comer: quatro litros e meio por pessoa, conforme o número de pessoas que vivam na mesma tenda»."
,"17":"Os filhos de Israel assim fizeram: uns apanharam mais, outros menos."
,"18":"Quando mediram as quantias, não sobrava para quem havia apanhado mais, nem faltava a quem havia apanhado menos. Cada um tinha apanhado o que podia comer."
,"19":"Moisés então disse-lhes: «Ninguém guarde nada para a manhã seguinte»."
,"20":"Mas eles não deram ouvidos a Moisés, e alguns guardaram uma porção para o dia seguinte. Porém, criou vermes e apodreceu. Por isso, Moisés ficou indignado contra eles."
,"21":"Todas as manhãs eles apanhavam a quantidade que cada um podia comer, porque o calor do sol o derretia."
,"22":"No sexto dia, apanhavam o dobro: nove litros para cada um. E todos os chefes da comunidade informaram Moisés."
,"23":"E Moisés disse: «Foi exactamente isso que Javé ordenou: amanhã é sábado, um descanso completo reservado a Javé. Cozinhai o que quiserdes cozinhar e fervei o que quiserdes ferver; separai o que sobrar e guardai-o para o dia seguinte»."
,"24":"Eles conservaram-no até ao dia seguinte, conforme Moisés tinha ordenado. E desta vez não apodreceu nem criou vermes."
,"25":"Então Moisés disse: «Comereis hoje, porque hoje é um sábado de Javé. Hoje não encontrareis alimento no campo."
,"26":"Apanhai-o durante seis dias, pois no sétimo, que é sábado, não o encontrareis»."
,"27":"No sétimo dia, alguns do povo saíram para o apanhar, mas não encontraram nada."
,"28":"Javé disse a Moisés: «Até quando vos recusareis a observar os meus mandamentos e leis?"
,"29":"É Javé quem vos dá o sábado, e é por isso que Ele, no sexto dia, vos dará pão para dois dias. Cada um fique onde está. Ninguém saia do seu lugar no sétimo dia»."
,"30":"E no sétimo dia o povo descansou."
,"31":"Os filhos de Israel deram a esse alimento o nome de maná: era branco como a semente de coentro, e o seu sabor era como bolo de mel."
,"32":"Moisés disse: «Esta é a ordem de Javé: conservai quatro litros e meio para que as gerações futuras possam ver o pão com que Eu vos alimentei no deserto, depois de vos ter tirado do Egipto»."
,"33":"Moisés disse a Aarão: «Pega numa vasilha, mete nela quatro litros e meio de maná, e coloca-a diante de Javé, a fim de o conservar para as gerações futuras»."
,"34":"Conforme Javé tinha ordenado a Moisés, Aarão colocou-o diante da arca do testemunho, para que fosse conservado."
,"35":"Os filhos de Israel comeram maná durante quarenta anos, até chegarem a uma terra habitada. Comeram maná até chegarem à fronteira de Canaã."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Toda a comunidade de Israel partiu do deserto de Sin para as etapas seguintes, conforme a ordem de Javé, e acamparam em Rafidim, onde o povo não encontrou água para beber."
,"2":"Então o povo discutiu com Moisés, dizendo: «Dá-nos água para beber». Moisés respondeu: «Porque discutis comigo e pondes Javé à prova?»"
,"3":"Mas o povo tinha sede e murmurou contra Moisés, dizendo: «Porque nos tiraste do Egipto? Foi para nos matar à sede a nós, aos nossos filhos e aos nossos animais?»"
,"4":"Então Moisés clamou a Javé, dizendo: «Que vou fazer com este povo? Estão prestes a apedrejar-me!»"
,"5":"Javé respondeu a Moisés: «Passa à frente do povo e leva contigo alguns anciãos de Israel; leva contigo a vara com que feriste o rio Nilo, e caminha."
,"6":"Eu vou esperar-te junto à rocha de Horeb. Baterás na rocha, e dela sairá água para o povo beber».Moisés assim fez na presença dos anciãos de Israel,"
,"7":"e deu a esse lugar o nome de Massa e Meriba, por causa da discussão dos filhos de Israel e porque puseram Javé à prova, dizendo: «Javé está no meio de nós, ou não?»"
,"8":"Os ama-lecitas foram e atacaram Israel em Rafidim."
,"9":"Então Moisés disse a Josué: «Escolhe um certo número de homens e sai amanhã para combater os amalecitas. Eu ficarei no alto da colina com a vara de Deus na mão»."
,"10":"Josué fez o que Moisés havia dito, e saiu para combater os amalecitas. Entretanto, Moisés, Aarão e Hur subiram ao topo da colina."
,"11":"Enquanto Moisés ficava com as mãos levantadas, Israel triunfava; quando ele baixava as mãos, Amalec vencia."
,"12":"Ora as mãos de Moisés já estavam pesadas; então eles pegaram numa pedra e colocaram-na debaixo dele para que se sentasse, enquanto Aarão e Hur lhe sustentavam os braços, um de cada lado. Deste modo, as mãos de Moisés ficaram firmes até ao pôr do sol."
,"13":"Josué derrotou Amalec e a sua tropa ao fio da espada."
,"14":"Então Javé disse a Moisés: «Escreve isto num livro como memória e diz a Josué que Eu vou apagar a memória de Amalec debaixo do céu»."
,"15":"Depois, Moisés construiu um altar e deu-lhe o nome de «Javé minha bandeira»,"
,"16":"dizendo: «Uma certa mão se levantou contra o trono de Javé: Javé estará em guerra contra Amalec de geração em geração»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Jetro, sacerdote de Madiã e sogro de Moisés, soube de tudo o que Javé havia feito por Moisés e pelo seu próprio povo Israel: como Javé havia retirado Israel do Egipto."
,"2":"Quando Moisés trouxe a sua mulher Séfora, Jetro, sogro de Moisés, recebeu-a"
,"3":"juntamente com os dois filhos. Um deles chamava-se Gérson, porque Moisés dissera: «Sou imigrante em terra estrangeira»."
,"4":"O outro chamava-se Eliezer, porque havia dito: «O Deus do meu pai é a minha ajuda e libertou-me da espada do Faraó»."
,"5":"Acompanhado da mulher e dos filhos de Moisés, Jetro foi ter com ele ao deserto onde estava acampado, junto à montanha de Deus."
,"6":"Mandaram dizer a Moisés: «A tua mulher e os teus dois filhos estão ali juntamente com o teu sogro Jetro»."
,"7":"Moisés saiu para receber o sogro, inclinou-se diante dele e abraçou-o. Os dois cumprimentaram-se e entraram na tenda."
,"8":"Moisés contou ao sogro tudo o que Javé tinha feito ao Faraó e aos egípcios, em favor dos israelitas. Contou também as dificuldades que tinham enfrentado pelo caminho e das quais Javé os havia libertado."
,"9":"Jetro regozijou-se por todos os benefícios que Javé tinha feito a Israel, libertando-o do poder egípcio."
,"10":"E disse: «Seja bendito Javé, que vos libertou do poder dos egípcios e do Faraó. Ele arrancou este povo do poder do Egipto."
,"11":"Agora eu sei que Javé é o maior de todos os deuses, pois quando eles vos tratavam com arrogância, Javé libertou o povo do domínio egípcio»."
,"12":"Depois, Jetro, sogro de Moisés, ofereceu a Deus um holocausto e sacrifícios. Aarão e todos os anciãos de Israel foram e comeram com ele na presença de Deus."
,"13":"No dia seguinte, Moisés sentou-se para resolver os assuntos do povo. Ora, o povo procurava por ele desde o amanhecer até à noite."
,"14":"O sogro de Moisés viu tudo o que ele fazia pelo povo, e disse-lhe: «O que é que estás a fazer com o povo? Porque estás sentado sozinho, enquanto todo o povo te procura de manhã até à noite?»"
,"15":"Moisés respondeu ao sogro: «O povo procura-me para que eu consulte a Deus."
,"16":"Quando eles têm alguma questão para resolver, procuram-me para que eu a resolva e para que explique os estatutos e as leis de Deus»."
,"17":"O sogro de Moisés replicou: «Não estás a proceder bem."
,"18":"Vais ficar extenuado e cansar o povo que te acompanha. É uma tarefa demasiado pesada para ti e não podes realizá-la sozinho."
,"19":"Aceita o meu conselho, para que Deus esteja contigo: representa o povo diante de Deus e apresenta-Lhe as suas questões."
,"20":"Ensina-lhes os estatutos e as leis; dá-lhes a conhecer o caminho a seguir e as acções que devem praticar."
,"21":"Escolhe entre o povo homens capazes e tementes a Deus, que sejam seguros e inimigos do suborno: estabelece-os como chefes de mil, de cem, de cinquenta e de dez."
,"22":"Eles administrarão regularmente a justiça ao povo: os assuntos graves, apresentá-los-ão a ti; os assuntos simples, eles próprios os resolverão. Deste modo, repartis a tarefa, e poderás realizar a tua parte."
,"23":"Se assim fizeres e Deus te der as instruções, poderás suportar a tarefa, e o povo voltará para casa em paz»."
,"24":"Moisés aceitou o conselho do sogro e fez o que ele havia dito."
,"25":"Escolheu em Israel homens capazes e colocou-os como chefes do povo: chefes de mil, de cem, de cinquenta e de dez."
,"26":"Eles administravam regularmente a justiça ao povo: os assuntos complicados, reservavam-nos para Moisés; os casos simples, eles próprios os resolviam."
,"27":"Depois, Moisés despediu-se do sogro, e Jetro voltou para a sua terra."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Três meses depois de sair do Egipto, os filhos de Israel chegaram ao deserto do Sinai:"
,"2":"partindo de Rafidim, chegaram ao deserto do Sinai e acamparam no deserto, diante da montanha."
,"3":"Então Moisés subiu à montanha de Deus, e Javé chamou-o, dizendo: «Diz à casa de Jacob e anuncia aos filhos de Israel o seguinte:"
,"4":"'Vistes o que fiz aos egípcios e como vos transportei sobre asas de águia e vos trouxe até Mim."
,"5":"Portanto, se Me obedecerdes e observardes a minha aliança, sereis minha propriedade especial entre todos os povos, porque a terra toda Me pertence."
,"6":"Vós sereis para Mim um reino de sacerdotes e uma nação santa'. É o que deverás dizer aos filhos de Israel»."
,"7":"Moisés voltou, convocou os anciãos do povo e expôs-lhes tudo o que Javé lhe havia mandado."
,"8":"Então todo o povo respondeu: «Faremos tudo o que Javé mandou».E Moisés transmitiu a Javé a resposta do povo."
,"9":"Javé disse a Moisés: «Vou aproximar-Me de ti numa nuvem espessa, para que o povo possa ouvir o que estou a falar contigo e acredite sempre em ti».E Moisés transmitiu a Javé tudo o que o povo tinha dito."
,"10":"Javé disse a Moisés: «Vai ter com o povo e purifica-o hoje e amanhã: que lavem as suas roupas,"
,"11":"e estejam preparados para depois de amanhã, porque Javé descerá depois de amanhã sobre a montanha do Sinai à vista de todo o povo."
,"12":"Deverás traçar um limite ao redor da montanha e dizer ao povo que não suba à montanha, nem se aproxime da encosta; quem tocar na montanha, será punido com a morte."
,"13":"Ninguém lhe porá a mão mas será apedrejado ou trespassado com flechas; tanto homem como animal, não ficará vivo. Só quando a trombeta soar, é que poderão subir à montanha»."
,"14":"Moisés desceu da montanha até ao lugar onde estava o povo; e fez com que se purificassem e lavassem as suas roupas."
,"15":"Depois disse ao povo: «Estai preparados para depois de amanhã, e não tenhais relações com as vossas mulheres»."
,"16":"Três dias depois, pela manhã, houve trovões e relâmpagos e uma nuvem espessa desceu sobre a montanha, enquanto o toque da trombeta soava fortemente. O povo que estava no acampamento começou a tremer."
,"17":"Então Moisés tirou o povo do acampamento para receber Deus. E eles colocaram-se ao pé da montanha."
,"18":"Toda a montanha do Sinai fumegava, porque Javé tinha descido sobre ela no fogo; o fumo subia, como o fumo de uma fornalha. E a montanha toda estremecia."
,"19":"O som da trombeta aumentava cada vez mais, enquanto Moisés falava e Deus lhe respondia com o trovão."
,"20":"Javé desceu ao cume da montanha do Sinai e chamou Moisés lá para o alto. Quando Moisés subiu,"
,"21":"Javé disse-lhe: «Desce e avisa o povo para que não ultrapasse os limites para ver a Javé. Caso contrário, muitos deles morreriam."
,"22":"Mesmo os sacerdotes que se aproximarem de Javé, devem purificar-se, para que Javé não Se volte contra eles»."
,"23":"Moisés disse a Javé: «O povo não poderá subir à montanha do Sinai, porque Tu mesmo nos mandaste traçar um limite para marcar a montanha sagrada»."
,"24":"Javé insistiu: «Vai, desce, e depois sobe com Aarão. Os sacerdotes e o povo, porém, não devem ultrapassar os limites, para subirem até onde está Javé, o qual Se voltaria contra eles»."
,"25":"Então Moisés desceu para junto do povo, e avisou-o."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Então Deus pronunciou todas estas palavras:"
,"2":"«Eu sou Javé teu Deus, que te fez sair da terra do Egipto, da casa da escravidão."
,"3":"Não tenhas outros deuses diante de Mim."
,"4":"Não faças para ti ídolos, nenhuma representação daquilo que existe no céu e na terra, ou nas águas que estão debaixo da terra."
,"5":"Não te prostres diante desses deuses, nem os sirvas, porque Eu, Javé teu Deus, sou um Deus ciumento: quando Me odeiam, castigo a culpa dos pais nos filhos, netos e bisnetos;"
,"6":"mas quando Me amam e guardam os meus mandamentos, trato-os com amor por mil gerações."
,"7":"Não pronuncies em vão o Nome de Javé teu Deus, porque Javé não deixará sem castigo aquele que pronunciar o seu Nome em vão."
,"8":"Lembra-te do dia de sábado, para o santificares."
,"9":"Trabalha durante seis dias e faz todas as tuas tarefas."
,"10":"O sétimo dia, porém, é o sábado de Javé teu Deus. Não faças nenhum trabalho, nem tu, nem o teu filho, nem a tua filha, nem o teu escravo, nem a tua escrava, nem o teu animal, nem o imigrante que vive nas tuas cidades."
,"11":"Porque em seis dias Javé fez o céu, a terra, o mar e tudo o que existe neles; e no sétimo dia Ele descansou. Por isso, Javé abençoou o dia de sábado e santificou-o."
,"12":"Honra o teu pai e a tua mãe: deste modo, prolongarás a tua vida, na terra que Javé teu Deus te dá."
,"13":"Não mates."
,"14":"Não cometas adultério."
,"15":"Não roubes."
,"16":"Não apresentes testemunho falso contra o teu próximo."
,"17":"Não cobices a casa do teu próximo, nem a mulher do próximo, nem o escravo, nem a escrava, nem o boi, nem o jumento, nem coisa alguma que pertença ao teu próximo»."
,"18":"Vendo os trovões e os relâmpagos, o som da trombeta e a montanha fumegante, todo o povo teve medo e manteve-se à distância."
,"19":"Então disseram a Moisés: «Fala-nos tu, que nós ouviremos; não nos fale Javé, senão morreremos»."
,"20":"Moisés disse ao povo: «Não tenhais medo! Deus veio para vos pôr à prova, a fim de que tenhais presente o temor a Ele e não pequeis»."
,"21":"O povo ficou à distância, e Moisés aproximou-se da nuvem escura, onde Deus estava."
,"22":"Javé disse a Moisés: «Diz aos filhos de Israel: Vistes que vos falei lá do Céu."
,"23":"Não Me coloqueis no meio de deuses de prata, nem façais para vós deuses de ouro."
,"24":"Far-Me-ás um altar de terra, sobre o qual Me oferecerás os holocaustos, sacrifícios de comunhão, ovelhas e bois. Nos lugares onde Eu quiser lembrar o meu Nome, irei ter contigo e te abençoarei."
,"25":"Se Me construíres um altar de pedra, não o faças com pedras lavradas, porque estarias a profanar a pedra com o cinzel."
,"26":"Não subas por degraus até ao meu altar, para que a tua nudez não apareça."
}`)
	CurrentBook.AddChapter(21, `{
"1":"São estas as normas que promulgarás para o povo:"
,"2":"Quando comprares um escravo hebreu, ele servir-te-á durante seis anos; mas, no sétimo ano, ele sairá livre, sem pagar nada."
,"3":"Se veio sozinho, sozinho sairá; se era casado, a esposa sairá com ele."
,"4":"Se o patrão lhe der uma esposa, e esta tiver filhos e filhas, a esposa e os filhos pertencerão ao patrão, e o escravo partirá sozinho."
,"5":"Se o escravo disser: Gosto do meu patrão, da minha mulher e dos meus filhos, não quero ficar livre:"
,"6":"então o patrão levá-lo-á diante de Deus, fará com que ele se encoste na porta ou nos batentes, e furar-lhe-á a orelha com uma sovela: então, ele tornar-se-á seu escravo para sempre."
,"7":"Se alguém vender a filha como escrava, esta não sairá como saem os escravos."
,"8":"Se ela desagradar ao patrão, a quem estava destinada, este deixará que a resgatem; não poderá vendê-la a estrangeiros, usando de fraude para com ela."
,"9":"Se o patrão destinar a escrava para um seu filho, este tratá-la-á conforme o direito das filhas."
,"10":"Se o patrão tomar uma nova mulher, não privará a primeira de comida, roupa e direitos conjugais."
,"11":"Se ele não lhe der estas três coisas, ela poderá ir-se embora sem pagar nada."
,"12":"Quem ferir uma pessoa e lhe causar a morte, torna-se réu de morte."
,"13":"Se não foi intencional, mas permissão de Deus que lhe caísse nas mãos, indicar-lhe-ei um lugar, onde possa refugiar-se."
,"14":"Mas se alguém, por maldade, atentar contra o seu próximo para o matar, então até mesmo do meu altar o arrancarás para que seja morto."
,"15":"Quem ferir o pai ou a mãe, torna-se réu de morte."
,"16":"Quem sequestrar um homem para o vender ou ficar com ele, torna-se réu de morte."
,"17":"Quem amaldiçoar o pai ou a mãe, torna-se réu de morte."
,"18":"Se houver uma discussão entre dois homens, e um ferir o outro com uma pedra ou murro e ele não morrer, mas ficar de cama;"
,"19":"e se ele se levantar e andar, ainda que apoiado na bengala, então aquele que o feriu será absolvido; pagará somente o tempo que o ferido tiver perdido e os gastos da convalescença."
,"20":"Se alguém ferir o escravo ou escrava à paulada, e o ferido lhe morrer nas mãos, será punido."
,"21":"Porém, se sobreviver um dia ou dois, não será punido, porque foi comprado a dinheiro."
,"22":"Numa briga entre homens, se um deles ferir uma mulher grávida e for causa de aborto sem maior dano, o culpado será obrigado a indemnizar aquilo que o marido dela exigir, e pagará o que os juízes decidirem."
,"23":"Contudo, se houver dano grave, então pagará vida por vida,"
,"24":"olho por olho, dente por dente, pé por pé,"
,"25":"queimadura por queimadura, ferida por ferida, golpe por golpe."
,"26":"Se alguém ferir num olho o escravo ou escrava, e o cegar, dará liberdade ao escravo em troca do olho."
,"27":"Se provocar a queda de um dente do escravo ou da escrava, dar-lhe-á a liberdade em troca do dente."
,"28":"Se um boi ferir um homem ou mulher e lhe causar a morte, o boi será apedrejado, e ninguém comerá da sua carne; o dono do boi será absolvido."
,"29":"Se o boi já antes era perigoso e o dono, tendo sido avisado, não o prendeu, o boi será apedrejado, e o dono será morto."
,"30":"Se lhe for exigido resgate, então pagará o que lhe exigirem em troca da sua vida."
,"31":"A mesma norma será aplicada quando o boi ferir um menino ou menina."
,"32":"Se o boi ferir um escravo ou escrava, o dono do escravo ou da escrava cobrará trezentos gramas de prata, e o boi será apedrejado."
,"33":"Se alguém deixar um poço aberto ou abrir um poço e não o tapar e nele cair um boi ou jumento,"
,"34":"o dono do poço pagará assim: restituirá em dinheiro ao dono do animal, e o animal morto será seu."
,"35":"Se o boi de alguém ferir o boi de outra pessoa, e o boi ferido morrer, venderão o boi vivo e repartirão o dinheiro; e dividirão entre si o boi morto."
,"36":"Contudo, se o dono já sabia que o boi era perigoso e não o prendeu, pagará boi por boi; mas o boi morto será seu."
,"37":"Se alguém roubar um boi ou uma ovelha e os abater ou vender, devolverá cinco bois por um boi, e quatro ovelhas por uma ovelha."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Se um ladrão for surpreendido a arrombar uma casa, for ferido e morrer, não existe homicídio culposo."
,"2":"Contudo, se o ferir à luz do dia, será caso de homicídio. O ladrão restituirá, e quando não tiver com que pagar, será vendido para compensar o que roubou."
,"3":"Se o boi, jumento ou ovelha roubados forem encontrados vivos nas mãos do ladrão, este deverá restituir o dobro."
,"4":"Se alguém estraga um campo ou vinha porque levou o seu rebanho a pastar no campo alheio, deverá restituir com o que de melhor produzir o seu campo ou vinha."
,"5":"Se um fogo se alastrar pelos silvados e queimar os molhos de trigo, a plantação ou o campo de outrem, o responsável pelo incêndio pagará todos os danos."
,"6":"Se alguém confiar ao seu próximo dinheiro ou objectos para guardar, e forem roubados da casa deste último, então, se o ladrão for descoberto, pagará o dobro."
,"7":"Se o ladrão não for encontrado, o dono da casa será levado diante de Deus para jurar que não se apossou do bem alheio."
,"8":"Em crimes contra a propriedade, quando estiver em jogo um boi, jumento, ovelha, roupa ou qualquer outro objecto perdido, do qual se diz: 'Isto é meu', a causa será levada diante de Deus: aquele que Deus declarar culpado, pagará o dobro ao outro."
,"9":"Se alguém confiar ao seu próximo um jumento, boi, ovelha ou qualquer outro animal, e o animal morrer, ficar aleijado ou fugir sem que ninguém veja,"
,"10":"então a questão resolver-se-á por meio de juramento a Javé, a fim de provar que o depositário não se apossou das coisas do outro; o dono aceitará o juramento, e não haverá restituição."
,"11":"Contudo, se o animal tiver sido roubado diante dos seus olhos, deverá indemnizar o dono."
,"12":"Se o animal tiver sido dilacerado por uma fera, o animal dilacerado será le-vado como prova, e não haverá restituição."
,"13":"Se alguém pedir emprestado ao seu próximo um animal, e este ficar aleijado ou morrer, não estando presente o dono, então deverá pagar."
,"14":"Mas se o dono estiver presente, não haverá restituição; se o animal tiver sido alugado, então pagar-se-á ao dono o preço do aluguer."
,"15":"Se alguém seduzir uma virgem solteira e se deitar com ela, pagará o dote e casar-se-á com ela."
,"16":"Se o pai dela não lha quiser dar, o sedutor pagará em dinheiro, conforme o dote das virgens."
,"17":"Não deixarás viver aquela que pratica a magia."
,"18":"Quem tiver relações sexuais com algum animal, será réu de morte."
,"19":"Quem sacrificar a outros deuses, além de Javé, será entregue ao anátema."
,"20":"Não explores o imigrante nem o oprimas, porque fostes imigrantes no Egipto."
,"21":"Não maltrates a viúva nem o órfão,"
,"22":"porque, se os maltratares e eles clamarem por Mim, Eu escutarei o seu clamor."
,"23":"A minha ira inflamar-se-á, e far-vos-ei perecer à espada: as vossas mulheres ficarão viúvas e os vossos filhos ficarão órfãos."
,"24":"Se emprestares dinheiro a alguém do meu povo, a um pobre que vive a teu lado, não te comportarás como agiota: não deveis cobrar juros."
,"25":"Se tomares como penhor o manto do teu próximo, deverás devolvê-lo antes do pôr do sol,"
,"26":"porque ele cobre-se com o manto, que é a veste do seu corpo; como iria cobrir-se ao dormir? Caso contrário, se ele clamar por Mim, ouvi-lo-ei, porque sou compassivo."
,"27":"Não blasfemes contra Deus, nem amaldiçoes um chefe do teu povo."
,"28":"Não tardes em oferecer-Me as primícias da tua eira e do teu lagar. Entrega-Me o teu filho primogénito;"
,"29":"faz o mesmo com os teus bois e ovelhas: a cria ficará com a sua mãe durante sete dias e, no oitavo dia, entregar-Ma-ás."
,"30":"Estais consagrados a Mim: não comereis carne de animal que tenha sido dilacerado no campo; dá-la-eis aos cães."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Não faças declarações falsas e não entres em acordo com o culpado para testemunhar em favor de uma injustiça."
,"2":"Não tomes o partido dos poderosos para fazer o mal. E, num processo, não prestes depoimento inclinando-te em favor dos poderosos, a fim de distorcer o direito;"
,"3":"nem favoreças o poderoso no seu processo."
,"4":"Se encontrares, extraviados, o boi ou o jumento do teu adversário, leva-os ao dono."
,"5":"Se encontrares o jumento do teu adversário caído debaixo da carga, não te desvies, mas ajuda-o a levantá-lo."
,"6":"Não distorças o direito do necessitado no seu processo."
,"7":"Afasta-te da acusação falsa: não faças morrer o inocente e o justo, nem absolvas o culpado."
,"8":"Não aceites suborno, porque o suborno cega quem tem os olhos abertos e perverte até as palavras dos justos."
,"9":"Não oprimas o imigrante: pois conheceis quanto sofre um imigrante, vós que fostes imigrantes no Egipto."
,"10":"Durante seis anos, semearás a terra e farás a colheita."
,"11":"No sétimo ano, porém, deixarás a terra em descanso e não a cultivarás e abandonarás os seus frutos, e os necessitados do povo e os animais do campo comerão o que sobrar. Faz o mesmo com a tua vinha e com o teu olival."
,"12":"Trabalharás durante seis dias e descansarás no sétimo dia, para que o teu boi e o teu jumento descansem, e o filho da tua escrava e o imigrante se refaçam."
,"13":"Prestai atenção a tudo o que vos tenho dito: não invoqueis o nome de outros deuses. Que não se ouça nem sequer o nome deles na vossa boca."
,"14":"Três vezes no ano celebrarás uma festa em minha honra."
,"15":"A primeira será a festa dos Pães sem fermento, que será celebrada assim: durante sete dias, conforme te ordenei, comerás pães sem fermento, no tempo marcado do mês de Abib, porque foi nesse mês que saístes do Egipto. Ninguém deve aparecer de mãos vazias diante de Mim."
,"16":"A segunda será na festa da Ceifa, a festa dos primeiros frutos dos teus trabalhos do que semeaste nos campos. E a terceira, a festa da Colheita, no fim do ano, quando recolheres o produto dos teus trabalhos no campo."
,"17":"Três vezes por ano, toda a população masculina se apresentará diante do Senhor Javé."
,"18":"Não ofereças o sangue da minha vítima com pão fermentado, nem deixes até ao dia seguinte a gordura da minha festa."
,"19":"Levarás os primeiros frutos da tua terra à casa de Javé teu Deus. Não cozerás o cabrito no leite de sua mãe."
,"20":"Vou enviar um anjo à tua frente, para que cuide de ti no caminho e te leve até ao lugar que preparei para ti."
,"21":"Respeita-o e obedece-lhe. Não te revoltes, porque ele leva consigo o meu nome, e não perdoará as tuas revoltas."
,"22":"Contudo, se lhe obedeceres fielmente e fizeres tudo o que Eu disser, ntão serei para ti inimigo dos teus inimigos e adversário dos teus adversários."
,"23":"O meu anjo irá à tua frente e introduzir-te-á na terra dos amorreus, heteus, ferezeus, cananeus, heveus e jebuseus, e Eu acabarei com eles."
,"24":"Não adores os seus deuses, nem os sirvas. Não faças o que eles fazem, mas destrói os seus deuses e quebra os seus monumentos sagrados."
,"25":"Servi a Javé, vosso Deus, e então Ele abençoará o vosso pão e a vossa água, e afastará a doença do meio de vós."
,"26":"Na vossa terra não haverá mulher que aborte ou seja estéril, e Eu far-te-ei chegar ao número completo dos teus dias."
,"27":"Enviarei diante de ti o meu terror, confundindo qualquer povo no meio do qual entrares, e farei com que todos os teus inimigos fujam de ti."
,"28":"Enviarei também vespas diante de ti, para que expulsem da tua frente os heveus, cananeus e heteus."
,"29":"Não os expulsarei da tua frente num ano só, para que a terra não fique deserta nem as feras se multipliquem."
,"30":"Expulsá-los-ei pouco a pouco, até que te multipliques e tomes posse da terra."
,"31":"Eu marcarei as fronteiras do teu país, desde o Mar Vermelho até ao mar dos filisteus, e desde o deserto até ao rio Eufrates. Entregarei nas tuas mãos os habitantes da terra, para que os expulses da tua frente."
,"32":"Não faças alianças com eles, nem com os seus deuses."
,"33":"Não os deixes habitar na tua terra, para que eles te não façam pecar contra Mim, adorando os seus deuses, que serão para ti uma cilada»."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Javé disse a Moisés: «Sobe até Mim com Aarão, Nadab, Abiú e setenta anciãos de Israel, e adorai de longe."
,"2":"Só Moisés se aproximará de Javé; os outros não se aproximarão, nem o povo subirá com ele»."
,"3":"Moisés desceu e contou ao povo tudo o que Javé lhe havia dito e todas as leis. O povo respondeu unânime: «Faremos tudo o que Javé disse»."
,"4":"Moisés escreveu todas as palavras de Javé. Depois levantou-se de manhã, construiu um altar ao pé da montanha e doze estelas para as doze tribos de Israel."
,"5":"Em seguida, mandou alguns jovens de Israel oferecer holocaustos e imolar novilhos a Javé como sacrifício de comunhão."
,"6":"Moisés tomou metade do sangue e colocou-o em bacias; a outra metade do sangue, derramou-a sobre o altar."
,"7":"Pegou no livro da aliança e leu-o ao povo. Eles disseram: «Faremos tudo o que Javé mandou e obedeceremos»."
,"8":"Moisés tomou o sangue e aspergiu com ele o povo, dizendo: «Este é o sangue da aliança que Javé faz convosco através de todas estas cláusulas»."
,"9":"Moisés, Aarão, Nadab, Abiú e os setenta anciãos subiram."
,"10":"Eles viram o Deus de Israel: sob os pés d'Ele havia uma espécie de pavimento de safira, tão pura como o próprio céu."
,"11":"E Deus não estendeu a mão contra os notáveis de Israel; eles contemplaram a Deus e depois comeram e beberam."
,"12":"Javé disse a Moisés: «Sobe até junto de Mim ao alto da montanha, pois Eu estarei lá para te dar as tábuas de pedra com a lei e os mandamentos que escrevi, para os instruíres»."
,"13":"Moisés levantou-se com o seu ajudante Josué. E subiram à montanha de Deus."
,"14":"Ele disse aos anciãos: «Esperai aqui até regressarmos. Aarão e Hur estão convosco: quem tiver alguma questão, dirija-se a eles»."
,"15":"Quando Moisés subiu à montanha, a nuvem cobriu a montanha."
,"16":"A glória de Javé pousou sobre o monte Sinai e a nuvem cobriu-o durante seis dias. No sétimo dia, Javé chamou Moisés do meio da nuvem."
,"17":"A glória de Javé aparecia aos olhos de Israel como fogo devastador no cume da montanha."
,"18":"Moisés entrou pelo meio da nuvem e subiu à montanha. E Moisés ficou na montanha quarenta dias e quarenta noites."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel que Me ofereçam um tributo; aceitareis a oferta de todos os que generosamente a oferecerem."
,"3":"Recebereis deles as seguintes ofertas: ouro, prata e bronze;"
,"4":"púrpura violeta, vermelha e escarlate; linho e pêlo de cabra;"
,"5":"peles de carneiro curtidas, couro fino e madeira de acácia;"
,"6":"azeite para a lâmpada, aromas para o óleo da unção e para o incenso aromático;"
,"7":"pedras de ónix e pedras de engaste para o efod e o peitoral."
,"8":"Construir-Me-ás um santuário e habitarei entre eles."
,"9":"Farás tudo conforme o modelo do santuário e dos utensílios que vou mostrar-te."
,"10":"Faz uma arca de madeira de acácia, com cento e vinte e cinco centímetros de comprimento, por setenta e cinco de largura e setenta e cinco de altura."
,"11":"Reveste a arca com ouro puro, por dentro e por fora; e, ao seu redor, aplica uma moldura de ouro."
,"12":"Fundirás para ela quatro argolas de ouro, para colocar nos quatro cantos inferiores da arca."
,"13":"Faz também varais de madeira de acácia e reveste-os de ouro,"
,"14":"e enfia os varais nas argolas de cada lado da arca, para se poder transportar."
,"15":"Os varais ficarão colocados nas argolas da arca e nunca serão tirados."
,"16":"Dentro da arca, coloca o documento da aliança que te darei."
,"17":"Faz também uma placa de ouro puro, com cento e vinte e cinco centímetros de comprimento, por setenta e cinco de largura."
,"18":"Nas duas extremidades da placa, faz dois querubins de ouro batido:"
,"19":"cada um sairá de uma extremidade da placa"
,"20":"cobrindo-a com as asas estendidas para cima. Estarão diante um do outro, olhando para o centro da placa."
,"21":"Cobre a arca com a placa, e dentro guarda o documento da aliança que te darei."
,"22":"É ali que Me encontrarei contigo; e, de cima da placa, do meio dos querubins que estão sobre a arca da aliança, dir-te-ei tudo o que deves ordenar aos filhos de Israel."
,"23":"Constrói uma mesa com madeira de acácia que terá cem centímetros de comprimento, por cinquenta de largura e setenta e cinco de altura."
,"24":"Reveste-a de ouro puro e aplica ao redor uma moldura de ouro."
,"25":"Faz ao redor dela um enquadramento com um palmo de largura e, ao redor do enquadramento, uma moldura de ouro."
,"26":"Faz também quatro argolas de ouro e coloca-as nos quatro cantos formados pelos quatro pés."
,"27":"Junto às molduras, ficarão as argolas por onde passarão os varais para se transportar a mesa."
,"28":"Faz os varais de madeira de acácia e reveste-os de ouro; servirão para transportar a mesa."
,"29":"Faz pratos, bandejas, jarras e copos para as libações: tudo de ouro puro."
,"30":"E coloca para sempre sobre a mesa, diante de Mim, os pães oferecidos a Deus."
,"31":"Faz um candelabro de ouro puro; todo cinzelado: pedestal, haste, cálices, botões e flores formarão com ele uma só peça."
,"32":"Dos seus lados sairão seis braços, três de cada lado."
,"33":"Cada braço terá três cálices, com formato de flor de amêndoa, com botão e flor; e três cálices com flor de amêndoa no outro lado, com botão e flor. Assim serão os seis braços que saem do candelabro."
,"34":"O candelabro terá quatro cálices com formato de flor de amêndoa, com botão e flor:"
,"35":"um botão sob os dois primeiros braços que saem do candelabro, um botão sob os dois braços seguintes, e um botão sob os dois últimos braços; assim se fará com os seis braços que saem do candelabro."
,"36":"Os botões e os braços formarão uma só peça com o candelabro. E tudo será feito com um bloco de ouro batido."
,"37":"Faz também sete lâmpadas, de modo que fiquem elevadas e iluminem a parte dianteira."
,"38":"Os seus acendedores e apagadores serão de ouro puro."
,"39":"Para fazer o candelabro e os seus acessórios usarás trinta quilos de ouro."
,"40":"Faz tudo de acordo com o modelo que te foi mostrado no alto da montanha."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Faz o santuário com dez cortinas de linho fino retorcido, de púrpura violeta, vermelha e escarlate. Fá-las-ás com querubins bordados."
,"2":"Cada cortina terá catorze metros de comprimento, por dois de largura: terão todas a mesma medida."
,"3":"Cinco cortinas estarão unidas umas às outras; e as outras cinco também estarão unidas umas às outras."
,"4":"Faz laços de púrpura violeta na franja da primeira cortina que está na extremidade do conjunto; e faz o mesmo na franja da cortina que está na extremidade do outro conjunto."
,"5":"Faz cinquenta laços na primeira cortina e cinquenta laços na extremidade da cortina que está no outro conjunto, de modo que os laços se correspondam mutuamente."
,"6":"Faz também cinquenta colchetes de ouro e junta as cortinas umas às outras por meio de colchetes, de modo que o santuário forme uma só unidade."
,"7":"Tece também onze peças de pêlo de cabra, para que sirvam de cobertura ao santuário."
,"8":"Cada peça medirá quinze metros de comprimento, por dois de largura; as onze peças terão a mesma medida."
,"9":"Junta cinco cortinas numa peça e seis cortinas noutra, e dobra a sexta cortina sobre a parte da frente da tenda."
,"10":"Faz cinquenta laços na franja da primeira cortina, na extremidade do primeiro conjunto, e outros cinquenta laços na franja da cortina do outro conjunto."
,"11":"Faz também cinquenta colchetes de bronze e introduz os colchetes em cada laço, para unir a tenda, que assim formará um todo."
,"12":"A parte que restar das cortinas da tenda, a metade da cortina que sobrar, penderá da parte posterior do santuário."
,"13":"E os cinquenta centímetros, que sobram de cada lado da tenda, penderão dos dois lados do santuário, cobrindo-os."
,"14":"Faz para a tenda uma cobertura de peles de carneiro curtidas, e uma cobertura de couro fino por cima."
,"15":"Faz para o santuário tábuas de madeira de acácia que serão colocadas verticalmente."
,"16":"Cada tábua terá cinco metros de comprimento, por setenta e cinco centímetros de largura."
,"17":"Cada tábua terá dois encaixes travados um com o outro; faz o mesmo com todas as tábuas do santuário."
,"18":"Coloca-as do seguinte modo: vinte tábuas para o lado do Negueb, para o Sul."
,"19":"E debaixo dessas vinte tábuas faz quarenta bases de prata: duas bases debaixo de cada tábua, para os seus dois encaixes."
,"20":"No outro lado do santuário, no lado do Norte, haverá vinte tábuas"
,"21":"com as suas quarenta bases de prata, duas bases para cada tábua."
,"22":"Faz seis tábuas para o fundo do santuário, do lado do mar,"
,"23":"e mais duas tábuas para os cantos do fundo do santuário."
,"24":"Ficarão unidas pela parte de baixo até à parte de cima, na altura da primeira argola: formarão assim os dois ângulos do santuário."
,"25":"Serão, portanto, oito tábuas com dezasseis bases de prata, duas para cada tábua."
,"26":"Faz também cinco travessas de madeira de acácia para as tábuas de cada lado,"
,"27":"e cinco para o lado do fundo, no lado do mar."
,"28":"A travessa central ficará ao meio das tábuas, atravessando-as de um extremo ao outro."
,"29":"Reveste as tábuas com ouro, e faz de ouro também as argolas, por onde vão passar as travessas; reveste de ouro também as travessas."
,"30":"Construirás o santuário conforme o modelo que te foi mostrado na montanha."
,"31":"Faz também um véu de púrpura violeta, vermelha e escarlate, e de linho fino retorcido. Nele serão bordadas figuras de querubins."
,"32":"Coloca-o sobre quatro colunas de madeira de acácia revestidas de ouro e providas de ganchos de ouro, assentadas sobre quatro bases de prata."
,"33":"Pendura o véu debaixo dos colchetes e coloca atrás dele a arca da aliança. O véu servirá de separação entre o Santo e o Santo dos Santos."
,"34":"Coloca a placa de ouro sobre a arca da aliança, no Santo dos Santos."
,"35":"Fora do véu, no lado Norte, coloca a mesa; e, no lado Sul, diante da mesa, coloca o candelabro."
,"36":"Para a entrada da tenda faz também uma cortina de púrpura violeta, vermelha e escarlate e de linho fino retorcido, artisticamente bordada."
,"37":"Para essa cortina, faz cinco colunas de madeira de acácia, recobertas de ouro, com ganchos também de ouro, fundindo para elas cinco bases de bronze."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Farás o altar de madeira de acácia: será quadrado e medirá dois metros e meio de lado, e um metro e meio de altura."
,"2":"Nos quatro cantos, faz saliências curvas, que formarão uma só peça com o altar. Reveste de bronze o altar."
,"3":"Faz também recipientes para recolher as cinzas, e também pás, bacias para a aspersão, garfos e braseiros, tudo de bronze."
,"4":"Faz também uma grelha de bronze, em forma de rede, com quatro argolas de bronze nos quatro cantos da grelha;"
,"5":"coloca-a em baixo sob a borda externa do altar, de modo que chegue até ao meio do altar."
,"6":"Faz também varais para o altar, com madeira de acácia revestida de bronze."
,"7":"Os varais serão enfiados nas argolas, de modo que fiquem dos dois lados do altar, quando este for transportado."
,"8":"Faz o altar de madeira, oco por dentro, conforme o modelo que te foi mostrado na montanha."
,"9":"Faz o átrio do santuário deste modo: no lado do Negueb, lado Sul, coloca cortinas de linho fino retorcido. O comprimento delas será de cinquenta metros."
,"10":"As suas vinte colunas, com as vinte bases, serão de bronze; os ganchos das colunas e as suas vergas serão de prata."
,"11":"Faz o mesmo no lado Norte: coloca cortinas com cinquenta metros de comprimento; as suas vinte colunas, com as vinte bases, serão de bronze; os ganchos das colunas e as suas vergas serão de prata."
,"12":"Na largura do átrio, do lado do mar, coloca cortinas com vinte e cinco metros de comprimento, com dez colunas e dez bases."
,"13":"A largura do átrio, no lado Leste, a Oriente, será de vinte e cinco metros;"
,"14":"sete metros e meio de cortinas de um lado da entrada, com três colunas e três bases,"
,"15":"e sete metros e meio de cortinas do outro lado da entrada, com três colunas e três bases."
,"16":"Na entrada do átrio haverá um véu artisticamente bordado, com dez metros de comprimento, feito de púrpura violeta, vermelha e escarlate, e de linho fino retorcido; terá qua-tro colunas e quatro bases."
,"17":"Todas as colunas em torno do átrio estarão unidas com vergas de prata; os seus ganchos serão de prata, e as suas bases, de bronze."
,"18":"O átrio terá cinquenta metros de comprimento, por vinte e cinco de largura e dois e meio de altura. Todas as cortinas serão de linho fino retorcido, e as bases de bronze."
,"19":"Serão de bronze todos os utensílios para o serviço do santuário, todas as suas estacas e todas as estacas do átrio."
,"20":"Ordenarás aos filhos de Israel que tragam azeite de oliveira puro e refinado, para alimentar continuamente a lâmpada."
,"21":"Aarão e os seus filhos colocarão essa lâmpada na tenda da reunião, fora do véu que está na frente do documento da aliança, para arder diante de Javé, desde a tarde até ao amanhecer. É uma lei perpétua para todas as gerações dos filhos de Israel."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Dentre os filhos de Israel, escolhe o teu irmão Aarão e os filhos dele: Nadab, Abiú, Eleazar e Itamar, para que sejam meus sacerdotes."
,"2":"Manda fazer para o teu irmão Aarão vestes sagradas, bem ricas e enfeitadas."
,"3":"Diz a todas as pessoas hábeis, a quem concedi espírito de sabedoria, que façam vestes para Aarão, a fim de o consagrar como meu sacerdote."
,"4":"São estas as vestes que farão: um peitoral, um efod, um manto, uma túnica bordada, um turbante e um cinto. Farão vestes sagradas para o teu irmão Aarão e para os seus filhos, a fim de que sejam meus sacerdotes."
,"5":"Empregarão ouro em púrpura violeta, vermelha, escarlate, e linho fino."
,"6":"Farão o efod bordado a ouro, em púrpura violeta, vermelha e escarlate, e em linho fino retorcido."
,"7":"Terá duas ombreiras unidas pelas extremidades."
,"8":"O cinto que está por cima para o segurar, formando uma só peça com ele, será da mesma confecção: ouro, púrpura violeta, vermelha e escarlate, e linho fino retorcido."
,"9":"Toma duas pedras de ónix e grava nelas o nome dos filhos de Israel:"
,"10":"seis nomes numa e seis nomes na ou-tra, por ordem de nascimento."
,"11":"Gravarão o nome das tribos de Israel da mesma forma que um ourives grava a pedra de um selo, e engastarão as duas pedras em filigrana de ouro."
,"12":"Coloca as duas pedras nas ombreiras do efod, como lembrança para os filhos de Israel. E Aarão levará os nomes deles sobre os ombros, como lembrança para Javé."
,"13":"Faz também engastes de ouro,"
,"14":"e duas correntes de ouro puro, trançadas como cordão, e fixa as correntes nos engastes."
,"15":"Faz o peitoral do julgamento, bordado como o efod: será de ouro, púrpura violeta, vermelha e escarlate, e linho fino retorcido."
,"16":"Será quadrado e duplo, com um palmo de comprimento e um de largura."
,"17":"Coloca nele engastes de pedra, dispostas em quatro filas: na primeira fila, uma sardónica, um topázio e uma esmeralda;"
,"18":"na segunda fila, um carbúnculo, uma safira e um diamante;"
,"19":"na terceira, um jacinto, uma ágata e uma ametista;"
,"20":"na quarta, um berilo, um ónix e um jaspe. Todas estas pedras serão guarnecidas de ouro nos seus engastes."
,"21":"As pedras corresponderão aos doze nomes dos filhos de Israel. Cada pedra será gravada como um selo, com o nome de uma das doze tribos."
,"22":"Faz também, para o peitoral, correntes de ouro puro, trançadas como cordões."
,"23":"E também duas argolas de ouro, para colocar nas extremidades do peitoral."
,"24":"Passa as duas correntes de ouro pelas duas argolas, nas extremidades do peitoral."
,"25":"Fixa as duas pontas das correntes nos dois engastes e coloca-as nas ombreiras do efod, na parte da frente."
,"26":"Faz duas argolas de ouro e coloca-as nas duas pontas inferiores do peitoral, junto ao efod."
,"27":"Faz também duas argolas de ouro e coloca-as nas duas ombreiras do efod, na parte inferior dianteira, perto da sua juntura, sobre o cinto do efod."
,"28":"Através das suas argolas, o peitoral ficará preso às argolas do efod com um cordão de púrpura violeta, para que fique por cima do cinto do efod e não se desprenda do efod."
,"29":"Deste modo, quando entrar no santuário, Aarão levará no peitoral do julgamento, sobre o coração, os nomes dos filhos de Israel, como lembrança perpétua diante de Javé."
,"30":"Coloca também no peitoral do julgamento os turim e os tumim, para que estejam sobre o coração de Aarão, quando ele entrar na presença de Javé. Aarão levará constantemente sobre o coração, na presença de Javé, o julgamento sobre os filhos de Israel."
,"31":"Faz o manto do efod de púrpura violeta."
,"32":"No meio do manto haverá uma abertura para a cabeça; essa abertura terá uma barra reforçada, como a abertura de um colete, para que não se rompa."
,"33":"Ao redor da barra inferior, coloca romãs de púrpura violeta, vermelha e escarlate, e de linho fino retorcido; entre elas, em toda a volta, coloca campainhas de ouro."
,"34":"Em toda a orla do manto haverá campainhas de ouro e romãs."
,"35":"Aarão vestirá o manto ao oficiar, para que se ouça o tilintar quando ele entrar no santuário de Javé ou quando sair, e assim não morra."
,"36":"Faz uma flor de ouro puro, e grava nela, como num selo: 'Consagrado a Javé'."
,"37":"Amarra-a com um cordão de púrpura violeta, de modo que fique sobre o turbante, na parte da frente."
,"38":"Ela ficará na fronte de Aarão, e ao fazer as suas ofertas sagradas ele carregará a culpa que os filhos de Israel tiverem cometido. Estará continuamente sobre a fronte de Aarão, para os reconciliar com Javé."
,"39":"A túnica e o turbante serão de linho fino, e o cinto será bordado."
,"40":"Para os filhos de Aarão, faz túnicas, cintos e gorros ricos e enfeitados."
,"41":"Com isto, vestirás o teu irmão Aarão e os filhos dele. Depois ungi-los-ás e investi-los-ás, consagrando-os como meus sacerdotes."
,"42":"Para eles faz também calções de linho que vão da cintura às coxas, para cobrir a nudez."
,"43":"Aarão e seus filhos vesti-los-ão quando entrarem na tenda da reunião ou quando se aproximarem do altar para ministrar no santuário, a fim de não cometerem pecado e não morrerem. Isto é uma lei perpétua para Aarão e seus descendentes."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Para os consagrares no meu sacerdócio, observa o seguinte rito: Toma um bezerro e dois carneiros sem defeito,"
,"2":"pães sem fermento, bolos sem fermento amassados com azeite, broas sem fermento untadas com azeite. Prepara-os com flor de farinha de trigo,"
,"3":"coloca-os numa cesta e trá-los; traz também o bezerro e os dois carneiros."
,"4":"Manda que Aarão e os seus filhos avancem até à entrada da tenda da reunião e lava-os com água."
,"5":"Toma as vestes e coloca em Aarão a túnica, o manto, o efod e o peitoral, e aperta o efod com o cinto."
,"6":"Coloca o turbante sobre a cabeça dele e, sobre o turbante, o sinal da santa consagração."
,"7":"Toma o óleo da unção e unge Aarão, derramando o óleo sobre a sua cabeça."
,"8":"Depois, manda aproximar os filhos, veste-lhes as túnicas,"
,"9":"e coloca neles o cinto e o gorro. Então o sacerdócio pertencer-lhes-á, como direito perpétuo. Assim consagrarás Aarão e os seus filhos."
,"10":"Leva o bezerro até à frente da tenda da reunião. Aí Aarão e os filhos colocarão a mão sobre a cabeça do bezerro."
,"11":"Imola o bezerro diante de Javé, à entrada da tenda da reunião."
,"12":"Toma uma parte do sangue do bezerro e, com o dedo, ungirás as pontas do altar, derramando o resto do sangue ao pé do altar."
,"13":"Toma toda a gordura que cobre as entranhas, a membrana gordurosa do fígado, os dois rins com a gordura que os envolve, e queima-os no altar."
,"14":"Queima fora do acampamento a carne do bezerro juntamente com a pele e os intestinos. É um sacrifício pelo pecado."
,"15":"Toma depois um dos carneiros, e Aarão e os filhos colocarão a mão sobre a cabeça do carneiro."
,"16":"Imola o carneiro, toma o seu sangue e derrama-o sobre todos os lados do altar."
,"17":"Divide o carneiro em pedaços, lava-lhe as entranhas e as pernas e coloca as duas coisas sobre os pedaços e sobre a cabeça."
,"18":"Queima assim todo o carneiro, fazendo subir o fumo dele sobre o altar. É um holocausto a Javé, é um perfume de suave odor, uma oferta queimada em honra de Javé."
,"19":"Toma depois o segundo carneiro. Aarão e os filhos colocarão a mão sobre a cabeça do carneiro."
,"20":"Imola o carneiro, toma um pouco do seu sangue e coloca-o sobre a ponta da orelha direita de Aarão e dos seus filhos, sobre o polegar da mão direita e do pé direito de cada um deles. Quanto ao resto do sangue, derrama-o sobre todos os lados do altar."
,"21":"Em seguida, toma do sangue que está sobre o altar e do óleo da unção, e espalha-os sobre Aarão e as suas vestes e sobre os filhos de Aarão e as suas vestes. Deste modo, ficarão consagrados Aarão com as suas vestes e os seus filhos com as suas vestes."
,"22":"Depois, toma do carneiro a gordura, a cauda, a gordura que cobre as entranhas, a membrana gordurosa do fígado, os dois rins com a gordura que os envolve, e a coxa direita, porque é o carneiro da consagração."
,"23":"Toma também um pão, um bolo untado em azeite e uma broa da cesta dos pães sem fermento que está diante de Javé."
,"24":"Coloca tudo nas mãos de Aarão e nas dos seus filhos, para que eles façam diante de Javé o gesto de apresentação."
,"25":"Em seguida, retoma todas estas coisas das mãos deles e queima-as no altar, sobre o holocausto, como suave odor a Javé. É uma oferta queimada em honra de Javé."
,"26":"Toma o peito do carneiro da consagração de Aarão, e faz diante de Javé o gesto de apresentação desse peito. Esta parte será a tua porção."
,"27":"Consagra o peito que foi apresentado e também a coxa da porção que foi tirada do carneiro da consagração e que pertence a Aarão e aos seus filhos."
,"28":"Isto tudo será uma porção perpétua que Aarão e os filhos dele receberão dos filhos de Israel; porque é o tributo tomado dos sacrifícios de comunhão, que os filhos de Israel oferecem a Javé."
,"29":"As vestes sagradas de Aarão serão herdadas pelos seus filhos, que as vestirão quando forem ungidos e consagrados."
,"30":"Durante sete dias, o filho que lhe tiver sucedido no sacerdócio vesti-las-á quando entrar na tenda da reunião, para servir no santuário."
,"31":"Depois toma o carneiro da consagração e cozinha a sua carne num lugar sagrado."
,"32":"Aarão e os seus filhos comerão da carne do carneiro e do pão que está na cesta, à entrada da tenda da reunião."
,"33":"Comerão a parte com que se fez a expiação por eles, quando foram investidos e consagrados. Nenhum estranho ao sacerdócio poderá comer disso, porque são coisas sagradas."
,"34":"Se uma parte da carne do sacrifício da consagração ou dos pães ficar para o dia seguinte, será queimada; não se comerá porque é coisa sagrada."
,"35":"É isto que farás com Aarão e os seus filhos, conforme tudo o que te ordenei. O rito da consagração deles durará sete dias."
,"36":"Cada dia, oferece também um bezerro como expiação pelo pecado. Faz o rito de expiação sobre o altar, oferecendo sobre ele um sacrifício pelo pecado. Depois, unge o altar para o consagrar."
,"37":"Faz a expiação pelo altar durante sete dias, e depois consagra-o; desse modo, o altar será santíssimo, e tudo o que nele tocar, será santificado."
,"38":"Eis o que deverás oferecer sobre o altar: dois cordeiros machos de um ano, diariamente e para sempre."
,"39":"Oferece um dos cordeiros de manhã e outro de tarde."
,"40":"Com o primeiro, oferece quatro litros e meio de flor de farinha, amassada com um litro e meio de azeite puro de oliveira, e uma libação de um litro e meio de vinho."
,"41":"Ao entardecer, oferece o segundo cordeiro, juntamente com uma oferta e uma libação, como as da manhã, uma oferta de suave odor queimada em honra de Javé."
,"42":"Este é o holocausto perpétuo por todas as gerações, na presença de Javé, junto à entrada da tenda da reunião, onde Me encontrarei convosco para falar."
,"43":"É nesse lugar que Me encontrarei com os filhos de Israel. E o lugar ficará consagrado com a minha glória."
,"44":"Consagrarei a tenda da reunião e o altar. Consagrarei também Aarão e os seus filhos, para que exerçam o meu sacerdócio."
,"45":"Habitarei no meio dos filhos de Israel e serei o seu Deus."
,"46":"E eles reconhecerão que Eu sou Javé, o seu Deus, que os tirou do Egipto para habitar no meio deles. Eu sou Javé, seu Deus."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Constrói também um altar de madeira de acácia para queimar incenso."
,"2":"Será quadrado e terá cinquenta centímetros de comprimento por cinquenta de largura, com um metro e meio de altura; os ângulos formarão uma só peça com ele."
,"3":"Revestirás de ouro puro a parte superior do altar, as paredes ao redor e os ângulos, e far-lhe-ás em volta uma moldura de ouro."
,"4":"Faz também duas argolas de ouro dos dois lados: nelas serão enfiados os varais, para transportar o altar."
,"5":"Os varais serão feitos de madeira de acácia e revestidos de ouro."
,"6":"Coloca o altar diante do véu que está na frente da arca da aliança e diante da placa que cobre a arca da aliança; nesse lugar é que Me encontrarei contigo."
,"7":"Aarão queimará sobre o altar o incenso aromático, de manhã, quando preparar as lâmpadas;"
,"8":"e quando, à tarde, acender as lâmpadas, fará o mesmo. Será um incenso perpétuo que as vossas gerações oferecerão diante de Javé."
,"9":"Não ofereçais sobre o altar incenso profano, nem holocausto, nem oblação, nem derrameis sobre ele nenhuma libação."
,"10":"Uma vez por ano, Aarão realizará o rito da expiação, untando os ângulos do altar com o sangue da vítima expiatória; isso será feito uma vez por ano, por todas as vossas gerações. O altar será consagrado a Javé»."
,"11":"Javé disse a Moisés:"
,"12":"«Quando fizeres o recenseamento dos filhos de Israel, cada um pagará a Javé um resgate pela sua própria pessoa, para que não haja entre eles nenhuma praga, quando fizeres o recenseamento."
,"13":"Cada um dará cinco gramas de prata, conforme o peso padrão do santuário: o tributo a Javé será de cinco gramas de prata."
,"14":"Cada um dos registados, de vinte anos para cima, pagará o tributo a Javé."
,"15":"Nem o rico pagará mais, nem o pobre pagará menos, quando derem o tributo a Javé como resgate por si mesmos."
,"16":"Toma o dinheiro do resgate dos filhos de Israel e entrega-o para o serviço da tenda da reunião: ele será a lembrança dos filhos de Israel diante de Javé, como resgate das suas pessoas»."
,"17":"Javé disse a Moisés:"
,"18":"«Faz uma bacia de bronze, com a base de bronze, para as abluções. Coloca-a entre a tenda da reunião e o altar; depois enche-a de água."
,"19":"Nela, Aarão e os filhos lavarão as mãos e os pés."
,"20":"Eles lavar-se-ão com água, quando entrarem na tenda da reunião, para que não morram; farão o mesmo quando se aproximarem do altar para oficiar, para queimar uma oferta a Javé."
,"21":"Lavarão as mãos e os pés, e assim não morrerão. Esta é uma lei perpétua para Aarão e seus descendentes, em todas as gerações»."
,"22":"Javé disse a Moisés:"
,"23":"«Providencia bálsamo de primeira qualidade: cinco quilos de mirra em grão, dois quilos e meio de cinamomo, dois quilos e meio de cana aromática,"
,"24":"cinco quilos de cássia, conforme o peso do santuário, e sete litros e meio de azeite de oliveira."
,"25":"Com estes ingredientes, faz o óleo para a unção sagrada, um perfume aromático, segundo a receita de perfumista. Este óleo servirá para a unção sagrada."
,"26":"Unge com esse óleo a tenda da reunião e a arca da aliança,"
,"27":"a mesa com os seus utensílios, o candelabro com os seus acessórios, o altar do incenso,"
,"28":"o altar dos holocaustos com os seus acessórios, e a bacia com a sua base."
,"29":"Consagra estas coisas e elas ficarão santíssimas: quem as tocar ficará santificado."
,"30":"Unge também Aarão e os filhos e consagra-os, para que exerçam o sacerdócio em minha honra."
,"31":"Diz aos filhos de Israel: 'Este será para vós, de geração em geração, o óleo para a unção sagrada."
,"32":"Não será derramado sobre o corpo de nenhum homem, e não copiareis a sua fórmula. É coisa sagrada e assim deveis tratá-lo."
,"33":"Quem fizer um óleo parecido e ungir um profano, será excluído do povo'»."
,"34":"Javé disse a Moisés: «Providencia essências aromáticas: resina, âmbar, bálsamo, aromas e incenso puro, em quantidades iguais."
,"35":"Com elas faz um incenso perfumado, composto segundo a arte da perfumaria, misturando-lhe sal; será puro e santo."
,"36":"Pulveriza uma parte dele, coloca-o diante da arca da aliança, na tenda da reunião, onde Me encontrarei contigo. Será para vós uma coisa santíssima."
,"37":"Não façais para vosso uso um incenso de fórmula semelhante; considerá-lo-eis como coisa santa e consagrada a Javé."
,"38":"Quem copiar a fórmula, para seu próprio uso, será excluído do seu povo»."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Javé disse a Moisés:"
,"2":"«Escolhi pessoalmente Beseleel, filho de Uri, filho de Hur, da tribo de Judá,"
,"3":"e enchi-o de dotes sobre-humanos e de sabedoria, de destreza e habilidade no seu ofício,"
,"4":"capaz de fazer projectos e de lavrar o ouro, a prata e o bronze,"
,"5":"de lapidar e engastar pedras, entalhar madeira e realizar toda a espécie de trabalhos."
,"6":"Eu dou-lhe, como ajudante, Ooliab, filho de Aquisamec, da tribo de Dã. A todos os artesãos dei habilidade, para que realizem tudo o que te ordenei:"
,"7":"a tenda da reunião, a arca da aliança, a placa que está sobre ela e toda a mobília da tenda,"
,"8":"a mesa com os seus utensílios, o candelabro de ouro com os seus acessórios, o altar do incenso,"
,"9":"o altar do holocausto com os seus acessórios, a bacia com a sua base,"
,"10":"as vestes ornamentais e sagradas dos sacerdotes Aarão e seus filhos, para o exercício do sacerdócio,"
,"11":"o óleo da unção e o incenso para o santuário. Eles farão tudo conforme te ordenei»."
,"12":"Javé disse a Moisés:"
,"13":"«Diz aos filhos de Israel: 'Observai os meus sábados, porque são um sinal entre Mim e vós, ao longo das vossas gerações, para que todos saibam que Eu sou Javé, Aquele que vos santifica."
,"14":"Observai, portanto, o sábado, porque é para vós uma coisa santa. Quem o profanar, será réu de morte. Quem realizar nele algum trabalho, será excluído do povo."
,"15":"Podeis trabalhar durante seis dias; o sétimo dia, porém, é para vós o dia de descanso solene em honra de Javé. Quem trabalhar no dia de sábado será réu de morte'."
,"16":"Os filhos de Israel observarão o sábado em todas as suas gerações, como aliança perpétua."
,"17":"Será um sinal perpétuo entre Mim e os filhos de Israel, porque em seis dias Javé fez o céu e a terra, mas no sétimo dia Ele parou para respirar»."
,"18":"Quando Javé acabou de falar com Moisés no monte Sinai, entregou-lhe as duas tábuas da aliança; eram tábuas de pedra, escritas pelo dedo de Deus."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Quando o povo notou que Moisés demorava a descer da montanha, reuniu-se em torno de Aarão, e disse-lhe: «Vamos! Faz-nos um deus que caminhe à nossa frente, porque não sabemos o que aconteceu com esse Moisés que nos tirou do Egipto»."
,"2":"Aarão respondeu-lhes: «Tirai os brincos de ouro das vossas mulheres, filhos e filhas, e trazei-mos»."
,"3":"Então todo o povo tirou os brincos e levou-os a Aarão."
,"4":"Este recebeu o ouro, fundiu-o num molde e fez a estátua de um bezerro. Então eles disseram: «Israel, é este o teu deus que te tirou do Egipto»."
,"5":"Quando Aarão viu isto, construiu um altar diante da estátua, e proclamou: «Amanhã será festa em honra de Javé»."
,"6":"No dia seguinte, levantaram-se bem cedo, ofereceram holocaustos e trouxeram sacrifícios de comunhão. O povo sentou-se para comer e beber, e depois levantou-se para se divertir."
,"7":"Javé disse a Moisés: «Vai, desce, porque o povo que tiraste do Egipto perverteu-se."
,"8":"Bem depressa se desviaram do caminho que Eu lhes havia ordenado. Fizeram para si um bezerro de metal fundido, e adoraram-no, oferecendo-lhe sacrifícios e dizendo: 'Israel, este é o teu deus que te tirou do Egipto'»."
,"9":"E Javé continuou: «Vejo que este povo é um povo de cabeça dura."
,"10":"Agora, portanto, deixa-Me, porque a minha ira vai acender-se contra eles, até os destruir. E de ti Eu farei uma grande nação»."
,"11":"Então Moisés suplicou a Javé, seu Deus, dizendo: «Javé, porque é que a tua ira se acende contra o teu povo, que tiraste do Egipto com grande poder e mão forte?"
,"12":"Os egípcios haveriam de dizer: 'Ele tirou-os com má intenção, para os matar entre as montanhas e exterminá-los da face da Terra'? Desiste do incêndio da tua ira e volta atrás com o castigo que pretendias impor ao teu povo."
,"13":"Lembra-Te dos teus servos Abraão, Isaac e Israel, aos quais juraste por Ti mesmo, dizendo: 'Eu multiplicarei a vossa descendência como as estrelas do céu, e toda a terra que vos prometi, dá-la-ei aos vossos filhos para que a possuam para sempre'»."
,"14":"Então Javé arrependeu-Se do castigo com o qual havia ameaçado o seu povo."
,"15":"Moisés desceu da montanha, com as duas tábuas da aliança na mão, tábuas escritas nos dois lados, na frente e no verso."
,"16":"As tábuas eram obra de Deus, e a escritura era feita por Deus, gravada nas tábuas."
,"17":"Josué ouviu o barulho do povo, que dava gritos, e disse a Moisés: «Há gritos de guerra no acampamento!»"
,"18":"Moisés respondeu: «Não são gritos de vitória, nem gritos de derrota: o que oiço são cantos alternados»."
,"19":"Quando se aproximou do acampamento e viu o bezerro e as danças, Moisés ficou enfurecido, atirou com as tábuas e quebrou-as ao pé da montanha."
,"20":"Pegou no bezerro que haviam feito, queimou-o e reduziu-o a pó. Depois espalhou o pó na água e deu-a a beber aos filhos de Israel."
,"21":"Moisés perguntou a Aarão: «O que foi que este povo te fez, para o arrastares a um pecado tão grande?»"
,"22":"Aarão respondeu: «Não fiques irritado, senhor. Sabes como este povo é inclinado para o mal."
,"23":"Eles pediram-me: 'Faz-nos um deus que caminhe à nossa frente, porque não sabemos o que aconteceu com esse Moisés que nos tirou do Egipto'."
,"24":"Eu disse então: 'Quem tiver ouro, que o traga'. Eles trouxeram-mo, lancei-o ao fogo e saiu este bezerro»."
,"25":"Moisés viu que o povo estava desenfreado, porque Aarão os havia abandonado à zombaria dos inimigos."
,"26":"Então Moisés ficou de pé no meio do acampamento, e gritou: «Quem estiver do lado de Javé, aproxime-se de mim».E todos os filhos de Levi se reuniram em torno dele."
,"27":"Moisés então disse-lhes: «Assim diz Javé, o Deus de Israel: 'Cada um coloque a espada à cintura. Passai e repassai o acampamento, de porta em porta, e cada um de vós mate até mesmo o seu irmão, companheiro e parente'»."
,"28":"Os filhos de Levi fizeram o que Moisés havia mandado. E nesse dia morreram uns três mil homens do povo."
,"29":"Então Moisés disse: «Hoje consagrastes-vos a Javé, às custas do filho ou do irmão, a fim de que Ele hoje vos conceda a bênção»."
,"30":"No dia seguinte, Moisés disse ao povo: «Cometestes um pecado gravíssimo, mas agora vou subir para junto de Javé, para ver se posso expiar o vosso pecado»."
,"31":"Então Moisés voltou para junto de Javé, e disse: «Este povo cometeu um pecado gravíssimo, fabricando um deus de ouro."
,"32":"Agora, porém, ou lhes perdoas este pecado ou me riscas do teu livro»."
,"33":"Javé respondeu a Moisés: «Riscarei do meu livro todo aquele que pecou contra Mim."
,"34":"Agora vai e conduz o povo para onde Eu te disse: o meu anjo irá à tua frente. Mas quando chegar o dia das contas, Eu punirei o pecado deles»."
,"35":"E Javé castigou o povo por adorar o bezerro que Aarão tinha feito."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Javé disse a Moisés: «Vamos! Parte daqui com o povo que tiraste do Egipto, e vai para a terra que prometi a Abraão, Isaac e Jacob, quando disse que a daria à sua descendência."
,"2":"Vou enviar à tua frente o meu anjo, para expulsar os cananeus, amorreus, heteus, ferezeus, heveus e jebuseus."
,"3":"Ide para essa terra onde corre leite e mel. Mas Eu não irei convosco porque sois um povo de cabeça dura, porque vos exterminaria no meio do caminho»."
,"4":"Ouvindo estas palavras tão duras, o povo começou a chorar, e ninguém se enfeitou com jóias."
,"5":"É que Javé tinha dito a Moisés: «Diz aos filhos de Israel: 'Sois um povo de cabeça dura. Se vos acompanhasse mesmo só um momento, exterminar-vos-ia. Por isso, tirai agora as jóias que usais e Eu verei depois o que vos devo fazer'»."
,"6":"Então os filhos de Israel deixaram os seus enfeites, a partir do monte Horeb."
,"7":"Moisés pegou na tenda e armou-a fora e longe do acampamento, e chamou-lhe tenda da reunião. Quem queria consultar Javé, devia ir até à tenda da reunião, que estava fora do acampamento."
,"8":"Quando Moisés se dirigia para a tenda, todo o povo se levantava e ficava à entrada da própria tenda, seguindo Moisés com o olhar, até ele entrar na tenda."
,"9":"Quando Moisés entrava na tenda, a coluna de nuvem descia e ficava à entrada da tenda, enquanto Javé falava com Moisés."
,"10":"Quando o povo via a coluna de nuvem parada à entrada da tenda, cada um levantava-se e prostrava-se à entrada da própria tenda."
,"11":"Javé falava com Moisés face a face, como um homem fala com o amigo. Depois Moisés voltava para o acampamento, mas o seu ajudante, o jovem Josué, filho de Num, não se afastava do interior da tenda."
,"12":"Moisés disse a Javé: «Tu disseste-me: 'Conduz este povo'. Mas não me indicaste ninguém para me ajudar na missão. No entanto, dizes que me tratas com intimidade e que gozo do teu favor."
,"13":"Agora, portanto, se gozo do teu favor, ensina-me o teu caminho, e assim ficarei a saber que gozo do teu favor. Além disso, leva em conta que esta nação é o teu povo»."
,"14":"Javé disse: «Eu irei e pessoalmente dar-te-ei descanso»."
,"15":"Moisés replicou: «Se não vieres pessoalmente, não nos obrigues a sair daqui."
,"16":"Como se poderá saber que eu e o teu povo gozamos do teu favor, se de facto não caminhares connosco? Deste modo, eu e o teu povo seremos diferentes de todos os povos da Terra»."
,"17":"Javé replicou a Moisés: «Eu vou conceder o que Me pedes, porque gozas do meu favor e te trato com intimidade»."
,"18":"Moisés pediu a Javé: «Mostra-me a tua glória»."
,"19":"Javé respondeu: «Farei passar diante de ti todo o meu esplendor, e pronunciarei diante de ti o meu nome Javé. Terei piedade de quem Eu quiser ter piedade, e terei compaixão de quem Eu quiser ter compaixão»."
,"20":"E acrescentou: «Mas tu não poderás ver o meu rosto, porque ninguém pode vê-lo e continuar com vida»."
,"21":"E Javé disse ainda: «Eis aqui um lugar junto a Mim: fica em cima da rocha."
,"22":"Quando a minha glória passar, colocar-te-ei na fenda da rocha e cobrir-te-ei com a palma da mão, até que Eu tenha passado."
,"23":"Depois tirarei a palma da mão e ver-Me-ás pelas costas. Mas não poderás ver a minha face»."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Javé disse a Moisés: «Talha duas tábuas de pedra, como as primeiras, sobe ao meu encontro na montanha, e Eu escreverei as mesmas palavras que estavam nas primeiras tábuas que quebraste."
,"2":"Prepara-te para amanhã; de madrugada, subirás à montanha do Sinai, e esperarás por Mim lá no alto da montanha."
,"3":"Ninguém subirá contigo, ninguém ficará na montanha; nem ovelhas nem bois pastarão diante da montanha»."
,"4":"Moisés talhou duas tábuas de pedra, como as primeiras, levantou-se de madrugada e subiu à montanha do Sinai, como Javé tinha ordenado, e levava nas mãos as duas tábuas de pedra."
,"5":"Javé desceu na nuvem e ficou com Moisés, que invocou o nome de Javé."
,"6":"Javé passou diante de Moisés, proclamando: «Javé, Javé! Deus de compaixão e piedade, lento para a cólera e cheio de amor e fidelidade."
,"7":"Ele conserva o seu amor por milhares de gerações, tolerando a falta, a transgressão e o pecado, mas não deixa ninguém impune: castiga a falta dos pais nos filhos, netos e bisnetos»."
,"8":"Moisés caiu de joelhos por terra e adorou."
,"9":"Depois disse: «Javé, se eu gozo do teu favor, continua no meio de nós, mesmo que este povo seja de cabeça dura. Perdoa as nossas faltas e pecados, e recebe-nos como tua herança»."
,"10":"Javé disse a Moisés: «Vou fazer uma aliança. Vou realizar diante do teu povo maravilhas como nunca foram feitas em nenhum país ou nação: todo o povo que te rodeia verá a obra impressionante que Javé vai realizar por teu intermédio."
,"11":"Fica atento para observar o que Eu ordeno hoje: vou expulsar diante de ti os amorreus, cananeus, heteus, ferezeus, heveus e jebuseus."
,"12":"Não faças aliança com os governantes do país, onde vais entrar, porque seria uma armadilha para ti."
,"13":"Pelo contrário, derrubai os seus altares, quebrai as suas estelas e monumentos sagrados."
,"14":"Não te prostres diante de outro deus, porque Javé chama-Se Ciumento: Ele é um Deus ciumento."
,"15":"Não faças aliança com os governantes do país, porque eles se prostituem com os seus deuses e convidar-te-ão para comeres das suas vítimas, quando oferecerem sacrifícios."
,"16":"Não tomes para os teus filhos mulheres dentre as suas filhas, porque elas, prostituindo-se com os seus deuses, arrastariam os vossos filhos a prostituírem-se àqueles deuses."
,"17":"Não faças para ti estátuas de deuses."
,"18":"Guarda a festa dos pães sem fermento: durante sete dias, comerás pães sem fermento, no tempo fixado do mês de Abib, como te ordenei, porque foi no mês de Abib que saíste do Egipto."
,"19":"Todos aqueles que, em primeiro lugar, saem do seio materno Me pertencem: todo o macho, todo o primogénito das tuas ovelhas e do teu gado."
,"20":"Contudo, o jumento que sair, em primeiro lugar, do seio materno, resgatá-lo-ás com um cordeiro; se não o resgatares, quebra-lhe a nuca. Resgata todos os primogénitos dos teus filhos. Não compareças de mãos vazias diante de Mim."
,"21":"Trabalha seis dias, mas descansa no sétimo, tanto na época da lavra como durante a ceifa."
,"22":"Celebra a festa das Semanas no começo da ceifa do trigo, e a festa da Colheita, no fim do ano."
,"23":"Três vezes por ano, todos os homens se apresentarão diante do Senhor Javé, o Deus de Israel."
,"24":"Quando Eu expulsar as nações diante de ti e alargar as tuas fronteiras, se subires três vezes por ano, para visitar Javé teu Deus, ninguém cobiçará a tua terra."
,"25":"Juntamente com o sangue das minhas vítimas, não ofereças nada fermentado. E da vítima da Páscoa, não ficará nada para o dia seguinte."
,"26":"Leva para a casa de Javé, teu Deus, o melhor dos primeiros frutos. Não cozas o cabrito no leite da sua própria mãe»."
,"27":"Javé disse ainda a Moisés: «Escreve estes mandamentos; porque é de acordo com eles que Eu faço aliança contigo e com Israel»."
,"28":"Moisés ficou ali com Javé durante quarenta dias e quarenta noites, sem comer pão nem beber água. Nas tábuas Ele escreveu as cláusulas da aliança, os dez mandamentos."
,"29":"Moisés desceu da montanha do Sinai, levando nas mãos as duas tábuas da aliança. Ele não sabia que o seu rosto estava resplandecente, por ter falado com Javé."
,"30":"Aarão e todos os filhos de Israel viram que Moisés estava com o rosto resplandecente, e ficaram com medo de se aproximar dele."
,"31":"Moisés, porém, chamou-os. Aarão e os chefes da comunidade aproximaram-se, e Moisés falou com eles."
,"32":"Depois, todos os filhos de Israel se aproximaram, e Moisés comunicou-lhes tudo o que Javé lhe havia dito no alto da montanha do Sinai."
,"33":"Quando Moisés acabou de falar, cobriu o rosto com um véu."
,"34":"Quando Moisés ia ter com Javé, para falar com Ele, retirava o véu até à hora de sair; e, ao sair, comunicava aos filhos de Israel o que Deus havia mandado."
,"35":"Os filhos de Israel viam que o rosto de Moisés estava resplandecente. Depois, Moisés cobria o rosto com o véu, até voltar a entrar para falar com Javé."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Moisés convocou toda a comunidade dos filhos de Israel, e disse-lhes: «Eis o que Javé vos manda fazer:"
,"2":"'Podeis trabalhar durante seis dias; o sétimo dia, porém, é para vós o dia de descanso solene em honra de Javé. Quem trabalhar no dia de sábado, será réu de morte'."
,"3":"No dia de sábado, não acendereis lume em nenhuma das vossas casas»."
,"4":"Moisés disse a toda a comunidade dos filhos de Israel: «Eis o que Javé ordenou:"
,"5":"'Fazei uma colecta para Javé. Quem tiver coração generoso, ofereça, como tributo a Javé, ouro, prata e bronze;"
,"6":"púrpura violeta, vermelha e escarlate; linho fino e pêlo de cabra;"
,"7":"peles de carneiro curtidas, couro fino e madeira de acácia;"
,"8":"azeite para a lâmpada, aromas para o óleo da unção e para o incenso aromático;"
,"9":"pedras de ónix e pedras de engaste para o efod e o peitoral'."
,"10":"Todos os que forem habilidosos venham executar o que Javé ordenou:"
,"11":"o santuário, a sua tenda e cobertura, os seus ganchos, tábuas, vergas, colunas e bases;"
,"12":"a arca e os seus varais, a placa de ouro e o véu;"
,"13":"a mesa com os seus varais, todos os seus acessórios, e os pães oferecidos a Deus;"
,"14":"o candelabro da iluminação com os seus acessórios; as lâmpadas e o azeite para a iluminação;"
,"15":"o altar do incenso com os seus varais, o óleo da unção, as essências aromáticas e a cortina da entrada para o santuário;"
,"16":"o altar dos holocaustos com a sua grelha de bronze, os seus varais com todos os acessórios, e a bacia com a sua base;"
,"17":"as cortinas do átrio com as suas colunas e bases, a cortina da porta do átrio;"
,"18":"as estacas do santuário e as estacas do átrio, com as suas cordas;"
,"19":"as vestes sagradas para oficiar no santuário, isto é, as vestes sagradas para o sacerdote Aarão e as vestes dos seus filhos, para o exercício do sacerdócio»."
,"20":"Então toda a comunidade dos filhos de Israel se retirou da presença de Moisés."
,"21":"Depois, todos os homens generosos, que se sentiam animados, levaram tributos a Javé, para as obras da tenda da reunião, para o seu culto e para as vestes sagradas."
,"22":"Chegaram homens e mulheres, e entregaram generosamente fivelas, brincos, anéis, pulseiras e toda a espécie de objectos de ouro, e cada um oferecia-os ritualmente diante de Javé."
,"23":"Aqueles que possuíam, levaram púrpura violeta, vermelha ou escarlate, linho fino, pêlo de cabra, peles de carneiro curtidas e couro fino."
,"24":"Os que desejavam oferecer tributo de prata e bronze, levaram-no a Javé; e quem possuía madeira de acácia levou-a para os diversos usos."
,"25":"As mulheres habilidosas levaram o que haviam fiado com as suas próprias mãos: púrpura violeta, vermelha e escarlate, e linho fino."
,"26":"Todas as mulheres, hábeis e dispostas a ajudar, teceram o pêlo de cabra."
,"27":"Os chefes levaram pedras de ónix e pedras de engaste para o efod e o peitoral,"
,"28":"os aromas e o azeite para a iluminação, para o óleo da unção e para o incenso aromático."
,"29":"Todos os homens e mulheres dos filhos de Israel, que sentiam generosidade para contribuir com as diversas tarefas que Javé, por intermédio de Moisés, havia mandado fazer, levaram espontaneamente a Javé a sua oferta."
,"30":"Moi-sés disse aos filhos de Israel: «Javé escolheu Beseleel, filho de Uri, filho de Hur, da tribo de Judá,"
,"31":"e encheu-o de dotes sobre-humanos, de sabedoria, de destreza e habilidade no seu ofício,"
,"32":"capaz de fazer projectos e de lavrar ouro, prata e bronze,"
,"33":"de lapidar e engastar pedras, entalhar madeira e realizar toda a espécie de trabalhos."
,"34":"Também lhe deu talento para ensinar outros, assim como a Ooliab, filho de Aquisamec, da tribo de Dã."
,"35":"Dotou-os de habilidade para projectar e realizar qualquer espécie de obras: bordar púrpura violeta, vermelha ou escarlate, em linho fino, e projectar e realizar toda a espécie de traba-lhos»."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Beseleel, Ooliab e todos os artesãos, a quem Javé tinha dado habilidade e destreza para executar os diversos trabalhos do santuário, realizaram o que Javé havia ordenado."
,"2":"Moisés convocou Beseleel, Ooliab e todos os artesãos, aos quais Javé havia dado habilidade e que estavam dispostos a colaborar na execução do projecto."
,"3":"Entregou-lhes pessoalmente todos os tributos levados pelos filhos de Israel para que executassem os diversos trabalhos do santuário. Os filhos de Israel, todas as manhãs, continuaram a levar espontaneamente as suas ofertas."
,"4":"Um dia, os artesãos que trabalhavam no santuário deixaram os seus trabalhos e foram"
,"5":"dizer a Moisés: «O povo traz muito mais do que é necessário para realizar os diversos trabalhos que Javé ordenou»."
,"6":"Então Moisés mandou dizer no acampamento: «Ninguém, nem homem nem mulher, levará mais tributos para o santuário».Então o povo deixou de levar coisas."
,"7":"O que haviam oferecido era mais do que suficiente para realizar as obras."
,"8":"Todos os artesãos que colaboravam fizeram o santuário com dez cortinas de linho fino retorcido, de púrpura violeta, vermelha e escarlate, com querubins bordados."
,"9":"Cada cortina tinha catorze metros de comprimento por dois de largura: todas tinham a mesma medida."
,"10":"Cinco cortinas estavam unidas umas às outras; e as outras cinco também estavam unidas entre si."
,"11":"Fizeram laços de púrpura violeta na franja da primeira cortina que estava na extremidade do conjunto; e fizeram o mesmo na franja da cortina que estava na extremidade do outro conjunto."
,"12":"Fizeram cinquenta laços na primeira cortina e cinquenta laços na extremidade da cortina que estava no outro conjunto, de modo que os laços se correspondiam entre si."
,"13":"Fizeram também cinquenta colchetes de ouro e uniram com eles as duas cortinas, de modo que o santuário formava uma unidade."
,"14":"Fizeram também onze peças de pêlo de cabra, para que servissem de cobertura ao santuário."
,"15":"Cada peça media quinze metros de comprimento por dois de largura; as onze peças tinham a mesma medida."
,"16":"Uniram cinco cortinas numa peça e seis cortinas noutra."
,"17":"Fizeram cinquenta laços na franja da primeira cortina, na extremidade do primeiro conjunto, e outros cinquenta laços na franja da cortina do outro conjunto."
,"18":"Fizeram também cinquenta colchetes de bronze para unir a tenda, formando assim um todo."
,"19":"Fizeram para a tenda uma cobertura de peles de carneiro curtidas, e uma cobertura de couro fino por cima."
,"20":"Fizeram para o santuário tábuas de madeira de acácia, para as colocar em posição vertical."
,"21":"Cada tábua tinha cinco metros de comprimento por setenta e cinco centímetros de largura."
,"22":"Cada tábua tinha dois encaixes travados um no outro; fizeram assim com todas as tábuas do santuário."
,"23":"Colocaram-nas do seguinte modo: vinte tábuas para o lado do Negueb, para o Sul;"
,"24":"e debaixo delas fizeram quarenta bases de prata: duas bases debaixo de cada tábua para os seus dois encaixes."
,"25":"No outro lado do santuário, no lado do Norte, ergueram vinte tábuas sobre quarenta bases de prata:"
,"26":"duas bases para cada tábua."
,"27":"Para o fundo do santuário, do lado Oeste, ergueram seis tábuas;"
,"28":"puseram também duas tábuas para os cantos do fundo do santuário."
,"29":"Ficaram unidas pela parte de baixo até à parte de cima, à altura da primeira argola: as duas tábuas formavam assim os ângulos do fundo do santuário."
,"30":"Havia, portanto, oito tábuas com as suas dezasseis bases de prata, duas para cada tábua."
,"31":"Fizeram também cinco travessas de madeira de acácia"
,"32":"para as tábuas de cada lado, e cinco para o lado do fundo, no lado do mar."
,"33":"A travessa central passava pelo centro das tábuas, atravessando-as de um extremo ao outro."
,"34":"Revestiram as tábuas com ouro, e fizeram de ouro também as argolas, por onde passavam as travessas; e cobriram também de ouro as travessas."
,"35":"Fizeram ainda um véu de púrpura violeta, vermelha e escarlate, e de linho fino retorcido. Fizeram nele um bordado com figuras de querubins,"
,"36":"e colocaram-no sobre quatro colunas de madeira de acácia cobertas de ouro e providas de ganchos de ouro, assentadas sobre quatro bases de prata."
,"37":"Fizeram também, para a entrada da tenda, uma cortina de púrpura violeta, vermelha e escarlate, e de linho fino retorcido,"
,"38":"com as suas cinco colunas e respectivos ganchos; revestiram de ouro os capitéis e as molduras; as cinco bases foram feitas de bronze."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Beseleel fez a arca de madeira de acácia, com cento e vinte e cinco centímetros de comprimento, por setenta e cinco de largura e setenta e cinco de altura."
,"2":"Revestiu a arca de ouro puro, por dentro e por fora; ao redor dela, aplicou uma moldura de ouro."
,"3":"Fundiu para a arca quatro argolas de ouro e colocou-as nos seus quatro cantos inferiores, duas de cada lado."
,"4":"Fez também varais de madeira de acácia e revestiu-os de ouro,"
,"5":"e enfiou os varais nas argolas em cada lado da arca, para a poder transportar."
,"6":"Fez também uma placa de ouro puro, com cento e vinte e cinco centímetros de comprimento por setenta e cinco de largura."
,"7":"Nas duas extremidades da placa fez dois querubins de ouro batido:"
,"8":"um em cada extremidade da placa,"
,"9":"cobrindo-a com as asas estendidas para cima. Eles estavam diante um do outro, olhando para o centro da placa."
,"10":"Fez a mesa de madeira de acácia com cem centímetros de comprimento, por cinquenta de largura e setenta e cinco de altura."
,"11":"Revestiu-a de ouro puro e aplicou ao redor uma moldura de ouro."
,"12":"Fez ao redor dela um enquadramento, com um palmo de largura; e, ao redor do enquadramento, uma moldura de ouro."
,"13":"Fez também quatro argolas de ouro e colocou-as nos quatro cantos formados pelos quatro pés."
,"14":"As argolas, por onde passavam os varais para se transportar a arca, ficavam junto às molduras."
,"15":"Fez os varais de madeira de acácia e revestiu-os de ouro, para se transportar a mesa."
,"16":"Fez também os utensílios para a mesa: os pratos e bandejas, as jarras e copos para as libações: tudo de ouro puro."
,"17":"Fez o candelabro de ouro puro; era todo de ouro batido: pedestal, haste, cálices, botões e flores formavam com ele uma só peça."
,"18":"Dos lados saíam seis braços, três de cada lado."
,"19":"Cada braço tinha três cálices com o formato de flor de amêndoa, com botão e flor; e três cálices com flor de amêndoa no outro lado, com botão e flor. Assim eram os seis braços que saíam do candelabro."
,"20":"O candelabro tinha quatro cálices com formato de flor de amêndoa, com botão e flor:"
,"21":"um botão sob os dois primeiros braços que saíam do candelabro, um botão sob os dois braços seguintes, e um botão sob os dois últimos braços; assim eram feitos os seis braços que saíam do candelabro."
,"22":"Os botões e os braços formavam uma só peça com o candelabro, e tudo era feito num só bloco de ouro batido."
,"23":"Fez também sete lâmpadas: e os seus acendedores e apagadores eram de ouro puro."
,"24":"Usou trinta quilos de ouro para fazer o candelabro com os seus acessórios."
,"25":"Fez também de madeira de acácia um altar para queimar incenso. Era quadrado e tinha cinquenta centímetros de comprimento por cinquenta de largura, com um metro de altura; as pontas formavam uma só peça com ele."
,"26":"Revestiu de ouro puro a parte superior, as paredes ao redor e as pontas, e fez ao redor uma moldura de ouro."
,"27":"Fez também duas argolas de ouro nos dois lados, e nelas se enfiavam os varais para transportar o altar."
,"28":"Os varais eram feitos de madeira e revestidos de ouro."
,"29":"Preparou também o óleo para a unção sagrada e o incenso perfumado, de acordo com a receita do perfumista."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Fez de madeira de acácia também o altar dos holocaustos: era quadrado e media dois metros e meio de lado e um metro e meio de altura."
,"2":"Nos quatro cantos, fez saliências curvas, que formavam uma só peça com o altar, e revestiu-as de bronze."
,"3":"Fez também todos os acessórios do altar: os recipientes para recolher cinzas, as pás, bacias, garfos e braseiros, tudo de bronze."
,"4":"Fez para o altar uma grelha de bronze em forma de rede, e colocou-a debaixo da borda externa do altar, de modo que a grelha chegava até ao meio do altar."
,"5":"Fundiu quatro argolas nos quatro cantos da grelha de bronze, a fim de que servissem de aberturas para os varais."
,"6":"Fez os varais de madeira de acácia e revestiu-os de bronze."
,"7":"Enfiou os varais nas argolas, que estavam dos lados do altar, para se poder transportar. Fez o altar de madeira, oco por dentro."
,"8":"Com os espelhos das mulheres que serviam à entrada da tenda da reunião, fez uma bacia de bronze, com a base de bronze."
,"9":"Fez assim o átrio do santuário: no lado do Negueb, lado Sul, fixou cortinas de linho fino retorcido, com cinquenta metros de comprimento."
,"10":"As suas vinte colunas, com as vinte bases, eram de bronze; os ganchos das colunas e as suas vergas eram de prata."
,"11":"No lado Norte, fixou cortinas com cinquenta metros de comprimento; as suas vinte colunas, com as vinte bases, eram de bronze; os ganchos das colunas e as suas vergas eram de prata."
,"12":"No lado do mar, com dez colunas e dez bases fixou cortinas com vinte e cinco metros de comprimento; os ganchos das colunas e as suas vergas eram de prata."
,"13":"No lado Leste, o átrio tinha uma largura de vinte e cinco metros:"
,"14":"de um lado da entrada do átrio, fixou cortinas com sete metros e meio, em três colunas e três bases."
,"15":"Do outro lado da entrada, fixou cortinas com sete metros e meio, em três colunas e três bases."
,"16":"Todas as cortinas, ao redor do átrio, eram de linho fino retorcido."
,"17":"As bases das colunas eram de bronze, e os ganchos das colunas e os seus varais eram de prata. O revestimento dos capitéis era de prata, e todas as colunas do átrio tinham vergas de prata."
,"18":"A cortina da entrada do átrio era bordada e feita de púrpura violeta, vermelha e escarlate, e de linho fino retorcido: tinha dez metros de comprimento por dois metros e meio de altura, como as cortinas do átrio."
,"19":"As suas quatro colunas e bases eram de bronze, e os seus ganchos eram de prata; o revestimento dos capitéis e vergas era de prata."
,"20":"Todas as estacas que rodeavam o átrio do santuário eram de bronze."
,"21":"São estes os gastos da construção do santuário da aliança, registados pelos levitas, por ordem de Moisés e sob a direcção de Itamar, filho do sacerdote Aarão."
,"22":"Beseleel, filho de Uri, filho de Hur, da tribo de Judá, fez tudo o que Javé tinha ordenado a Moisés."
,"23":"Foi ajudado por Ooliab, filho de Aquisamec, da tribo de Dã, que era artesão, desenhista, bordador em púrpura violeta, vermelha e escarlate, e em linho fino."
,"24":"O total de ouro empregado na construção do santuário, ouro que veio das ofertas, foi de oitocentos e setenta e oito quilos, conforme o peso que está no santuário."
,"25":"A prata recolhida dos recenseados foi de três mil e dezoito quilos, conforme o peso que está no santuário:"
,"26":"cinco gramas de prata, conforme o peso que está no santuário, por pessoa registada no recenseamento, de vinte anos para cima, isto é, seicentos e três mil e quinhentos e cinquenta homens."
,"27":"Foram empregados três mil quilos de prata na fundição das bases do santuário e da cortina, à razão de trinta quilos por base."
,"28":"Com os dezoito quilos restantes foram feitos os ganchos e capitéis das colunas, e também as vergas."
,"29":"O bronze das ofertas pesou dois mil cento e vinte e quatro quilos."
,"30":"Foi tudo empregado para fazer as bases da entrada da tenda da reunião, o altar de bronze com a grelha de bronze e todos os acessórios do altar,"
,"31":"as bases do átrio ao redor, as bases da entrada do átrio, e todas as estacas do recinto do átrio."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Fizeramos ornamentos sagrados para o serviço do santuário com púrpura violeta, vermelha e escarlate, e com linho fino retorcido. Do mesmo material fizeram as vestes sagradas para Aarão, conforme Javé tinha ordenado a Moisés."
,"2":"Fizeram o efod de ouro, de púrpura violeta, vermelha e escarlate, e de linho fino retorcido."
,"3":"Estenderam o ouro em lâminas finas e cortaram-nas em tiras para as entrelaçar com a púrpura violeta, vermelha e escarlate, e com o linho fino retorcido, num trabalho artístico."
,"4":"Tinha duas ombreiras unidas pelas extremidades."
,"5":"O cinto que estava por cima para o fixar, formando uma única peça com ele, era da mesma confecção: ouro, púrpura violeta, vermelha e escarlate, e linho fino retorcido, conforme Javé tinha ordenado a Moisés."
,"6":"Prepararam as pedras de ónix engastadas em ouro e gravaram nelas, como num selo, o nome dos filhos de Israel."
,"7":"E colocaram-nas sobre as ombreiras do efod, como símbolo dos filhos de Israel, conforme Javé tinha ordenado a Moisés."
,"8":"Fizeram artisticamente o peitoral, bordado como o efod: de ouro, de púrpura violeta, vermelha e escarlate, e de linho fino retorcido."
,"9":"Era quadrado e duplo, com um palmo de comprimento e um de largura."
,"10":"Colocaram nele engastes de pedras, dispostos em quatro filas: na primeira fila, uma sardónica, um topázio e uma esmeralda;"
,"11":"na segunda fila, um carbúnculo, uma safira e um diamante;"
,"12":"na terceira fila, um jacinto, uma ágata e uma ametista;"
,"13":"na quarta, um berilo, um ónix e um jaspe. As pedras eram guarnecidas de ouro nos seus engastes."
,"14":"Elas correspondiam aos doze nomes dos filhos de Israel. Cada pedra era gravada como um selo, com o nome de cada uma das doze tribos."
,"15":"Fizeram também, para o peitoral, correntes de ouro puro, trançadas como cordões,"
,"16":"e também dois engastes e duas argolas de ouro; e fixaram-nas nas extremidades do peitoral."
,"17":"Passaram as duas correntes de ouro pelas duas argolas, nas extremidades do peitoral."
,"18":"Nos dois engastes, fixaram as duas pontas das correntes, e colocaram-nas nas ombreiras do efod, na parte da frente."
,"19":"Fizeram duas argolas de ouro e colocaram-nas nas duas pontas inferiores do peitoral, junto ao efod."
,"20":"Fizeram também duas argolas de ouro e colocaram-nas nas duas ombreiras do efod, na parte inferior dianteira, perto da sua juntura, sobre o cinto do efod."
,"21":"Juntaram o peitoral, através das suas argolas, com as argolas do efod com um cordão de púrpura violeta, para que ficasse por cima do cinto do efod e não se desprendesse do efod, conforme Javé ti-nha ordenado a Moisés."
,"22":"Depois fizeram o manto do efod; era todo tecido de púrpura violeta."
,"23":"Havia uma abertura no meio do manto, como a abertura de um colete. A abertura tinha à sua volta uma barra que não se rasgava."
,"24":"Na parte inferior do manto colocaram romãs de púrpura violeta, vermelha e escarlate, e de linho fino retorcido."
,"25":"Fizeram também campainhas de ouro e colocaram-nas entre as romãs."
,"26":"Havia uma campainha entremeada com uma romã em toda a volta, na parte inferior do manto que se usava para o serviço religioso, conforme Javé tinha ordenado a Moisés."
,"27":"Para Aarão e seus filhos fizeram também túnicas tecidas de linho fino,"
,"28":"turbante e gorros com enfeites, e calções de linho fino retorcido."
,"29":"O cinto era de linho fino retorcido, púrpura violeta, vermelha e escarlate, conforme Javé tinha ordenado a Moisés."
,"30":"Em seguida, fizeram de ouro puro a flor, sinal da santa consagração, e nela gravaram como num selo: «Consagrado a Javé»."
,"31":"Prenderam a flor com um cordão de púrpura violeta, de modo que ficasse sobre o turbante, na parte da frente, conforme Javé tinha ordenado a Moisés."
,"32":"Deste modo, terminaram os trabalhos do santuário e da tenda da reunião. E os filhos de Israel fizeram tudo o que Javé tinha ordenado a Moisés."
,"33":"Apresentaram a Moisés o santuário, a tenda e todos os seus acessórios: argolas, tábuas, travessas, colunas e bases;"
,"34":"a cobertura de pele de carneiro curtida, a cobertura de couro fino e o véu protector;"
,"35":"a arca da aliança com os varais e a placa;"
,"36":"a mesa com os seus utensílios e com os pães oferecidos a Deus;"
,"37":"o candelabro de ouro puro com as lâmpadas em ordem, com os seus acessórios e com o azeite para as lâmpadas;"
,"38":"o altar de ouro, o óleo da unção, o incenso aromático e o véu para a entrada da tenda;"
,"39":"o altar de bronze com a grelha de bronze, os varais com todos os seus acessórios; a bacia com a sua base;"
,"40":"as cortinas do átrio com as suas colunas e bases; o véu para a entrada do átrio com as suas cordas e estacas, e com todos os utensílios para o serviço no santuário da tenda da reunião;"
,"41":"as vestes sagradas para oficiar no santuário e as vestes sagradas para o sacerdote Aarão e os seus filhos exercerem o sacerdócio."
,"42":"Os filhos de Israel fizeram todos os trabalhos conforme Javé tinha ordenado a Moisés."
,"43":"Moisés examinou todo o trabalho e viu que tinham feito conforme Javé tinha ordenado. E Moisés abençoou-os."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Javé disse a Moisés:"
,"2":"«No dia primeiro do primeiro mês, constrói o santuário da tenda da reunião."
,"3":"Coloca nele a arca da aliança e fecha-a com o véu."
,"4":"Coloca a mesa e põe nela os pães. Coloca o candelabro e acende as lâmpadas."
,"5":"Coloca o altar de ouro diante da arca da aliança, e instala o véu na entrada do santuário."
,"6":"Coloca o altar dos holocaustos diante da entrada do santuário da tenda da reunião."
,"7":"Coloca a bacia entre a tenda da reunião e o altar; depois enche-a com água."
,"8":"Coloca o átrio ao redor e a cortina na entrada do átrio."
,"9":"Toma o óleo da unção e unge o santuário e tudo o que está dentro dele; consagra o santuário e todos os seus utensílios, e ele ficará consagrado."
,"10":"Unge o altar dos holocaustos com os seus utensílios, e o altar ficará santíssimo."
,"11":"Unge a bacia e a sua base, consagrando-as."
,"12":"Depois, faz com que Aarão e seus filhos se aproximem da entrada da tenda da reunião. Lava-os com água"
,"13":"e reveste Aarão com as vestes sagradas. Unge-o e consagra-o, para que exerça o meu sacerdócio."
,"14":"Manda aproximar os seus filhos e reveste-os com as túnicas."
,"15":"Unge-os, como ungiste o pai, para que exerçam o meu sacerdócio. A unção conferir-lhes-á o sacerdócio perpétuo em todas as suas gerações»."
,"16":"Moisés fez tudo conforme Javé lhe tinha ordenado."
,"17":"No dia primeiro do primeiro mês do segundo ano, construíram o santuário."
,"18":"Moisés construiu o santuário, colocou as bases, fixou as tábuas com as travessas, e ergueu as colunas."
,"19":"Estendeu a tenda sobre o santuário e colocou por cima a cobertura da tenda, conforme Javé lhe tinha ordenado."
,"20":"Colocou o documento da aliança na arca; colocou os varais na arca e a placa de ouro em cima da arca."
,"21":"Introduziu a arca no santuário e colocou o véu para ocultar a arca da aliança, conforme Javé lhe tinha ordenado."
,"22":"Colocou a mesa na tenda da reunião, na parte Norte do santuário e do lado de fora do véu,"
,"23":"e colocou sobre ele os pães oferecidos a Deus, conforme Javé lhe tinha ordenado."
,"24":"Colocou o candelabro na tenda da reunião, na parte Sul do santuário, diante da mesa;"
,"25":"acendeu as lâmpadas na presença de Javé, conforme Javé lhe tinha ordenado."
,"26":"Colocou o altar de ouro na tenda da reunião, diante do véu,"
,"27":"e em cima dele queimou o incenso aromático, conforme Javé lhe tinha ordenado."
,"28":"Depois colocou o véu à entrada do santuário."
,"29":"Colocou o altar dos holocaustos à entrada do santuário da tenda da reunião, e sobre ele ofereceu o holocausto e a oferta, conforme Javé lhe tinha ordenado."
,"30":"Colocou a bacia entre a tenda da reunião e o altar, enchendo-a com água para as abluções."
,"31":"Moisés, Aarão e os filhos deste lavavam as mãos e os pés,"
,"32":"quando entravam na tenda da reunião ou quando se aproximavam do altar, conforme Javé tinha ordenado a Moisés."
,"33":"Ao redor do santuário e do altar, Moisés levantou o átrio; e colocou a cortina à entrada. Deste modo, Moisés terminou os trabalhos."
,"34":"Então a nuvem cobriu a tenda da reunião, e a glória de Javé encheu o santuário."
,"35":"Moisés não pôde entrar na tenda da reunião, porque a nuvem tinha pousado sobre ela e a glória de Javé enchia o santuário."
,"36":"Em todas as etapas da viagem, os fi-lhos de Israel punham-se em movimento sempre que a nuvem se elevava acima do santuário."
,"37":"Mas se a nuvem não se elevava, também eles não partiam, enquanto ela não se elevasse."
,"38":"De dia, a nuvem de Javé pousava sobre o santuário; e, de noite, dentro dele havia um fogo, que era visto por toda a casa de Israel, durante todo o tempo da sua viagem."
}`)

}
func PT_BS_LoadVPGNChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No princípio, Deus criou o céu e a terra."
,"2":"A terra estava sem forma e vazia; as trevas cobriam o abismo e um vento impetuoso soprava sobre as águas."
,"3":"Deus disse: «Que exista a luz!» E a luz começou a existir."
,"4":"Deus viu que a luz era boa. Deus separou a luz das trevas:"
,"5":"à luz Deus chamou «dia», e às trevas chamou «noite». Houve uma tarde e uma manhã: foi o primeiro dia."
,"6":"Deus disse: «Que exista um firmamento no meio das águas para separar águas de águas!»"
,"7":"Deus fez o firmamento para separar as águas que estão acima do firmamento das águas que estão abaixo do firmamento. E assim se fez."
,"8":"E Deus chamou ao firmamento «céu». Houve uma tarde e uma manhã: foi o segundo dia."
,"9":"Deus disse: «Que as águas que estão debaixo do céu se juntem num só lugar e apareça o chão seco». E assim se fez."
,"10":"Deus chamou ao chão seco «terra», e ao conjunto das águas «mar». E Deus viu que era bom."
,"11":"Deus disse: «Que a terra produza relva, ervas que produzam semente, e árvores que dêem frutos sobre a Terra, frutos que contenham semente, cada um segundo a sua espécie». E assim se fez."
,"12":"E a terra produziu relva, ervas que produzem semente, cada uma segundo a sua espécie, e árvores que dão fruto com a semente, cada uma segundo a sua espécie. E Deus viu que era bom."
,"13":"Houve uma tarde e uma manhã: foi o terceiro dia."
,"14":"Deus disse: «Que existam luzeiros no firmamento do céu, para separar o dia da noite e para marcar festas, dias e anos; e sirvam de luzeiros no firmamento do céu para iluminar a Terra». E assim se fez. "
,"16":"Deus fez os dois grandes luzeiros: o luzeiro maior para regular o dia, o luzeiro menor para regular a noite, e as estrelas."
,"17":"Deus colocou-os no firmamento do céu para iluminar a Terra,"
,"18":"para regular o dia e a noite e para separar a luz das trevas. E Deus viu que era bom."
,"19":"Houve uma tarde e uma manhã: foi o quarto dia."
,"20":"Deus disse: «Que as águas fiquem cheias de seres vivos e os pássaros voem sobre a Terra, sob o firmamento do céu»."
,"21":"Deus criou as baleias e os seres vivos que deslizam e vivem na água, conforme a espécie de cada um, e as aves de asas conforme a espécie de cada uma. E Deus viu que era bom."
,"22":"Deus abençoou-os e disse: «Sede fecundos, multiplicai-vos e enchei as águas do mar; e que as aves se multipliquem sobre a Terra»."
,"23":"Houve uma tarde e uma manhã: foi o quinto dia."
,"24":"Deus disse: «Que a Terra produza seres vivos conforme a espécie de cada um: animais domésticos, répteis e feras, cada um conforme a sua espécie». E assim se fez."
,"25":"Deus fez as feras da Terra, cada uma conforme a sua espécie; os animais domésticos, cada um conforme a sua espécie; e os répteis do solo, cada um conforme a sua espécie. E Deus viu que era bom."
,"26":"Então Deus disse: «Façamos o homem à nossa imagem e semelhança. Que ele domine os peixes do mar, as aves do céu, os animais domésticos, todas as feras e todos os répteis que rastejam sobre a terra»."
,"27":"Deus criou o homem à sua imagem; à imagem de Deus Ele o criou; e criou-os homem e mulher."
,"28":"Deus aben-çoou-os e disse-lhes: «Sede fecundos, multiplicai-vos, enchei e submetei a terra; dominai os peixes do mar, as aves do céu e todos os seres vivos que rastejam sobre a terra»."
,"29":"E Deus disse: «Vede! Entrego-vos todas as ervas que produzem semente e estão sobre toda a Terra, e todas as árvores em que há frutos que dão semente: tudo isso será alimento para vós."
,"30":"E a todas as feras, a todas as aves do céu e a todos os seres que rastejam sobre a terra e nos quais há respiração de vida, dou a relva como alimento». E assim se fez."
,"31":"Deus viu tudo o que havia feito, e tudo era muito bom. Houve uma tarde e uma manhã: foi o sexto dia."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Assim foram concluídos o Céu e a Terra com todo o seu exército."
,"2":"No sétimo dia, Deus terminou todo o seu trabalho; e no sétimo dia, Ele descansou de todo o seu trabalho."
,"3":"Deus então abençoou e santificou o sétimo dia, porque foi nesse dia que Deus descansou de todo o seu trabalho como criador."
,"4a":"Esta é a história da criação do Céu e da Terra."
,"4b":"Quando Javé Deus fez a Terra e o Céu,"
,"5":"ainda não havia na terra nenhuma planta do campo, pois no campo ainda não havia brotado nenhuma erva: Javé Deus não tinha feito chover sobre a terra e não havia homem que cultivasse o solo"
,"6":"e fizesse subir da terra a água para regar a superfície do solo."
,"7":"Então Javé Deus modelou o homem com a argila do solo, soprou-lhe nas narinas um sopro de vida, e o homem tornou-se um ser vivente."
,"8":"Javé Deus plantou um jardim no Éden, no Oriente, e aí colocou o homem que havia modelado."
,"9":"Javé Deus fez brotar do solo todas as espécies de árvores formosas de ver e boas para comer. Além disso, colocou a árvore da vida no meio do jardim, e também a árvore do conhecimento do bem e do mal."
,"10":"Um rio saía do Éden para regar o jardim, e de lá dividia-se em quatro braços."
,"11":"O primeiro chama-se Fison: é aquele que rodeia toda a terra de Hévila, onde existe ouro;"
,"12":"e o ouro dessa terra é puro, e nela encon-tram-se também o bdélio e a pedra de ónix."
,"13":"O segundo rio chama-se Geon: ele rodeia toda a terra de Cuch."
,"14":"O terceiro rio chama-se Tigre e corre pelo oriente da Assíria. O quarto rio é o Eufrates."
,"15":"Javé Deus tomou o homem e colocou-o no jardim do Éden, para que o cultivasse e guardasse."
,"16":"E Javé Deus ordenou ao homem: «Podes comer de todas as árvores do jardim."
,"17":"Mas não podes comer da árvore do conhecimento do bem e do mal, porque no dia em que dela comeres, com certeza morrerás»."
,"18":"Javé Deus disse: «Não é bom que o homem esteja sozinho. Vou fazer-lhe uma auxiliar que lhe seja semelhante»."
,"19":"Então Javé Deus formou do solo todas as feras e todas as aves do céu. E apresentou-as ao homem para ver com que nome ele as chamaria: cada ser vivo teria o nome que o homem lhe desse."
,"20":"O homem deu então um nome a todos os animais, às aves do céu e a todas as feras. Mas o homem não encontrou uma auxiliar que lhe fosse semelhante."
,"21":"Então Javé Deus fez cair um torpor sobre o homem, e ele adormeceu. Tomou então uma costela do homem e no lugar fez crescer carne."
,"22":"Depois, da costela que tinha tirado do homem, Javé Deus modelou uma mu-lher, e apresentou-a ao homem."
,"23":"Então o homem exclamou: «Esta, sim, é osso dos meus ossos e carne da minha carne! Ela será chamada mulher, porque foi tirada do homem!»"
,"24":"Por isso, um homem deixa seu pai e sua mãe, e une-se à sua mulher, e os dois tornam-se uma só carne."
,"25":"Ora, o homem e sua mulher estavam nus, mas não sentiam vergonha."
}`)
	CurrentBook.AddChapter(3, `{
"1":"A serpente era o mais astuto de todos os animais que Javé Deus havia feito. Ela disse à mulher: «É verdade que Deus disse que não deveis comer de nenhuma árvore do jardim?»"
,"2":"A mulher respondeu à serpente: «Nós podemos comer dos frutos das árvores do jardim."
,"3":"Mas do fruto da árvore que está no meio do jardim, Deus disse: 'Não comereis dele nem lhe tocareis, de contrário morrereis'»."
,"4":"Então a serpente disse à mulher: «Não, não morrereis."
,"5":"Mas Deus sabe que, no dia em que comerdes o fruto, os vossos olhos abrir-se-ão e tornar-vos-eis como deuses, conhecedores do bem e do mal»."
,"6":"Então a mulher viu que a árvore tentava o apetite, era uma delícia para os olhos e desejável para adquirir discernimento. Pegou no fruto e comeu-o; depois deu-o também ao marido que estava com ela, e também ele comeu."
,"7":"Então abriram-se os olhos aos dois, e eles perceberam que estavam nus. Entrelaçaram folhas de figueira e fizeram tangas."
,"8":"Em seguida, eles ouviram Javé Deus que passeava no jardim à brisa do dia. Então o homem e a mulher esconderam-se da presença de Javé Deus, entre as árvores do jardim."
,"9":"Javé Deus chamou o homem: «Onde estás?»"
,"10":"O homem res-pondeu: «Ouvi os teus passos no jardim: tive medo, porque estou nu, e escondi-me»."
,"11":"Javé Deus continuou: «E quem te disse que estavas nu? Acaso comeste da árvore da qual Eu te tinha proibido co-mer?»"
,"12":"O homem respondeu: «A mulher que me deste por companheira deu-me o fruto, e eu comi»."
,"13":"Javé Deus disse à mulher: «Que fizeste?» A mulher res-pondeu: «A serpente enganou-me, e eu comi»."
,"14":"Então Javé Deus disse à serpente: «Por teres feito isto, serás maldita entre todos os animais domésticos e entre todas as feras. Rastejarás sobre o ventre e comerás pó todos os dias da tua vida."
,"15":"Eu porei inimizade entre ti e a mulher, entre a tua descendência e os descendentes dela. Estes esmagar-te-ão a cabeça e tu ferirás o calcanhar deles»."
,"16":"Javé Deus disse então à mulher: «Vou fazer-te sofrer muito na tua gravidez: entre dores, darás à luz os teus filhos; a paixão vai arrastar-te para o marido, e ele te dominará»."
,"17":"Javé Deus disse ao homem: «Já que deste ouvidos à tua mulher e comeste da árvore cujo fruto Eu te tinha proibido comer, maldita seja a terra por tua causa. Enquanto viveres, dela te alimentarás com fadiga."
,"18":"A terra produzir-te-á espinhos e ervas daninhas, e comerás a erva dos campos."
,"19":"Comerás o teu pão com o suor do teu rosto, até que voltes para a terra, pois dela foste tirado. Tu és pó, e ao pó voltarás»."
,"20":"O homem deu à sua mulher o nome de Eva, por ser ela a mãe de todos os que vivem."
,"21":"Javé Deus fez túnicas de pele para o homem e sua mulher, e vestiu-os."
,"22":"Depois Javé Deus disse: «O homem tornou-se como um de Nós, conhecedor do bem e do mal. Que ele, agora, não estenda a mão e colha também da árvore da vida, e coma, e viva para sempre»."
,"23":"Então Javé Deus expulsou o homem do jardim do Éden para cultivar o solo de onde fora tirado."
,"24":"Ele expulsou o homem e colocou diante do jardim do Éden os querubins e a espada flamejante, para guardar o caminho da árvore da vida."
}`)
	CurrentBook.AddChapter(4, `{
"1":"O homem uniu-se a Eva, sua mulher, e ela concebeu e deu à luz Caim. E disse: «Adquiri um homem com a ajuda de Javé»."
,"2":"Depois ela também deu à luz Abel, irmão de Caim. Abel tornou-se pastor de ovelhas e Caim cultivava a terra."
,"3":"Depois de algum tempo, Caim apresentou produtos da terra como oferta a Javé."
,"4":"Abel, por sua vez, ofereceu os primogénitos e a gordura do seu rebanho. Javé gostou de Abel e da sua oferta,"
,"5":"e não gostou de Caim e da oferta dele. Caim ficou então muito enfurecido e andava de cabeça baixa."
,"6":"E Javé disse a Caim: «Porque estás enfurecido e andas de cabeça baixa?"
,"7":"Se agisses bem, andarias com a cabeça erguida; mas, se não ages bem, o pecado está junto à porta, como fera agachada, a espreitar-te. Acaso conseguirás tu dominá-la?»"
,"8":"Entretanto, Caim disse a seu irmão Abel: «Vamos sair». E quando estavam no campo, Caim lançou-se contra o seu irmão Abel e matou-o."
,"9":"Então Javé perguntou a Caim: «Onde está o teu irmão Abel?» Caim respondeu: «Não sei. Sou, porventura, o guarda do meu irmão?»"
,"10":"Javé disse: «Que fizeste? Ouço o sangue do teu irmão, clamando da terra por Mim."
,"11":"Por isso és amaldiçoado por essa terra que abriu a boca para receber das tuas mãos o sangue do teu irmão."
,"12":"Ainda que cultives a terra, ela não te dará o seu produto. Andarás errante e perdido pelo mundo»."
,"13":"Caim disse a Javé: «A minha culpa é grave e atormenta-me."
,"14":"Se hoje me expulsas do solo fértil, terei de esconder-me de Ti, andando errante e perdido pelo mundo; o primeiro que me encontrar, matar-me-á»."
,"15":"Javé respondeu-lhe: «Quem matar Caim será vingado sete vezes». E Javé colocou um sinal em Caim, a fim de que ele não fosse morto por quem o encontrasse."
,"16":"Caim saiu da presença de Javé e habitou na terra de Nod, a leste do Éden."
,"17":"Caim uniu-se à sua mulher, que concebeu e deu à luz Henoc. Caim construiu uma cidade, e deu à cidade o nome de seu filho Henoc."
,"18":"Henoc gerou Irad, e Irad gerou Maviael; Maviael gerou Matusael, e Matusael gerou Lamec."
,"19":"Lamec tomou para si duas mulheres: a primeira chamava-se Ada e a segunda chamava-se Sela."
,"20":"Ada deu à luz Jabel, que foi o antepassado dos pastores nómadas."
,"21":"Seu irmão chamava-se Jubal, que foi o antepassado de todos os tocadores de lira e flauta."
,"22":"Sela, por sua vez, deu à luz Tubalcaim, que foi o antepassado de todos os que forjam ferramentas de bronze e ferro. A irmã de Tubalcaim era Noema."
,"23":"Lamec disse às suas mulheres: «Ada e Sela, ouvi a minha voz; mulheres de Lamec, escutai a minha palavra: Por uma ferida, eu matarei um homem, e por uma cicatriz matarei um jovem."
,"24":"Se a vingança de Caim valia por sete, a de Lamec valerá por setenta e sete»."
,"25":"Adão uniu-se à sua mulher; ela deu então à luz um filho, e deu-lhe o nome de Set, dizendo: «Deus concedeu-me outro descendente no lugar de Abel, que Caim matou»."
,"26":"Set também teve um filho, a quem deu o nome de Enós. Este foi o primeiro a invocar o nome de Javé."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Lista dos descendentes de Adão: Quando Deus criou Adão, fê-lo à semelhança de Deus."
,"2":"Homem e mulher Ele os criou, abençoou-os e deu-lhes o nome de «Homem», no mesmo dia em que foram criados."
,"3":"Quando Adão completou cento e trinta anos, gerou um filho à sua semelhança e imagem, e deu-lhe o nome de Set."
,"4":"O tempo que Adão viveu, depois do nascimento de Set, foi de oitocentos anos, e gerou filhos e filhas."
,"5":"Ao todo, Adão viveu novecentos e trinta anos. E morreu."
,"6":"Quando Set completou cento e cinco anos, gerou Enós."
,"7":"Depois do nascimento de Enós, Set viveu oitocentos e sete anos, e gerou filhos e filhas."
,"8":"Ao todo, Set viveu novecentos e doze anos. E morreu."
,"9":"Quando Enós completou noventa anos, gerou Cainã."
,"10":"Depois do nascimento de Cainã, Enós viveu oitocentos e quinze anos, e gerou filhos e filhas."
,"11":"Ao todo, Enós viveu novecentos e cinco anos. E morreu."
,"12":"Quando Cainã completou setenta anos, gerou Malaleel."
,"13":"Depois do nascimento de Malaleel, Cainã viveu oitocentos e quarenta anos, e gerou filhos e filhas."
,"14":"Ao todo, Cainã viveu novecentos e dez anos. E morreu."
,"15":"Quando Malaleel completou sessenta e cinco anos, gerou Jared."
,"16":"Depois do nascimento de Jared, Malaleel viveu oitocentos e trinta anos, e gerou filhos e filhas."
,"17":"Ao todo, Malaleel viveu oitocentos e noventa e cinco anos. E morreu."
,"18":"Quando Jared completou cento e sessenta e dois anos, gerou Henoc."
,"19":"Depois do nascimento de Henoc, Jared viveu oitocentos anos, e gerou filhos e filhas."
,"20":"Ao todo, Jared viveu novecentos e sessenta e dois anos. E morreu."
,"21":"Quando Henoc completou sessenta e cinco anos, gerou Matusalém."
,"22":"Henoc andou com Deus. Depois do nascimento de Matusalém, Henoc viveu trezentos anos, e gerou filhos e filhas."
,"23":"Ao todo, Henoc viveu trezentos e sessenta e cinco anos."
,"24":"Henoc andou com Deus e desapareceu, porque Deus o arrebatou."
,"25":"Quando Matusalém completou cento e oitenta e sete anos, gerou Lamec."
,"26":"Depois do nascimento de Lamec, Matusalém viveu setecentos e oitenta e dois anos, e gerou filhos e filhas."
,"27":"Ao todo, Matusalém viveu novecentos e sessenta e nove anos. E morreu."
,"28":"Quando Lamec completou cento e oitenta e dois anos, gerou um filho."
,"29":"Deu-lhe o nome de Noé, dizendo: «Este nos consolará do trabalho e do cansaço das nossas mãos, causados pela terra que Javé amaldiçoou»."
,"30":"Depois do nascimento de Noé, Lamec viveu quinhentos e noventa e cinco anos, e gerou filhos e filhas."
,"31":"Ao todo, Lamec viveu setecentos e setenta e sete anos. E morreu."
,"32":"Quando Noé completou quinhentos anos, gerou Sem, Cam e Jafé."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Quando os homens se multiplicaram sobre a Terra e geraram filhas,"
,"2":"os filhos de Deus viram que as filhas dos homens eram belas, e escolheram como esposas todas aquelas que lhes agradaram."
,"3":"Javé disse: «O meu sopro de vida não permanecerá para sempre no homem, pois ele é carne, e não viverá mais do que cento e vinte anos»."
,"4":"Nesse tempo - isto é, quando os filhos de Deus se uniram com as filhas dos homens e geraram filhos - os gigantes habitavam a Terra. Estes foram os heróis famosos dos tempos antigos."
,"5":"Javé viu que a maldade do homem crescia na Terra e que todo o projecto do coração humano era sempre mau."
,"6":"Então Javé arrependeu-Se de ter feito o homem sobre a Terra, e o seu coração ficou magoado."
,"7":"E Javé disse: «Vou exterminar da face da Terra os homens que criei, juntamente com os animais, os répteis e as aves do céu, porque Me arrependo de os ter feito»."
,"8":"Noé, porém, encontrou graça aos olhos de Javé."
,"9":"Eis a his-tória de Noé. Noé era um homem justo, íntegro entre os seus contemporâneos, e andava com Deus."
,"10":"Noé gerou três filhos: Sem, Cam e Jafé."
,"11":"A Terra corrompera-se diante de Deus e estava cheia de violência."
,"12":"Deus viu a Terra corrom-pida, porque todo o homem da Terra se tinha corrompido no seu comportamento."
,"13":"Então Deus disse a Noé: «Para Mim, chegou o fim de todos os homens, porque a Terra está cheia de violência por causa deles. Vou destruí-los juntamente com a Terra."
,"14":"Constrói para ti uma arca de madeira resinosa; divide-a em compartimentos e calafeta-a com betume, por dentro e por fora."
,"15":"A arca deverá ter as seguintes dimensões: cento e cinquenta metros de comprimento, vinte e cinco de largura e quinze de altura."
,"16":"No alto da arca, faz uma clarabóia de meio metro, como arremate. Faz a entrada da arca pelo lado; e faz a arca em três andares sobrepostos."
,"17":"Eu vou mandar o dilúvio sobre a Terra, para exterminar todo o ser vivo que respira debaixo do céu: tudo o que há na Terra vai perecer."
,"18":"Mas contigo vou estabelecer a minha aliança, e entrarás na arca com a tua mulher, os teus filhos e as mulheres dos teus filhos."
,"19":"Toma um casal de cada ser vivo, isto é, macho e fêmea, e coloca-os na arca, para que conservem a vida juntamente contigo."
,"20":"De cada espécie de aves, de cada espécie de animais, de cada espécie de todos os répteis da Terra, toma contigo um casal, para os conservar vivos."
,"21":"Quanto a ti, junta e armazena todo o tipo de alimento; isso vai servir de alimento para ti e para eles»."
,"22":"E Noé fez tudo como Deus havia mandado."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Javé disse a Noé: «Entra na arca com toda a tua família, porque és o único justo que encontrei nesta geração."
,"2":"Toma sete pares, o macho e a fêmea, de todos os animais puros; toma um casal, o macho e a fêmea, dos animais que não são puros;"
,"3":"e toma também sete pares, macho e fêmea, das aves do céu, para perpetuarem a espécie sobre toda a Terra."
,"4":"Porque Eu, daqui a sete dias, farei chover sobre a Terra durante quarenta dias e quarenta noites, e eliminarei da face da Terra todos os seres que fiz»."
,"5":"E Noé fez tudo como Javé havia mandado."
,"6":"Noé tinha seiscentos anos quando o dilúvio veio sobre a Terra."
,"7":"Noé, com seus filhos, sua mulher e as mulheres de seus filhos, entrou na arca para escapar das águas do dilúvio."
,"8":"Dos animais puros e impuros, das aves e dos répteis,"
,"9":"entrou um casal, macho e fêmea, na arca de Noé, conforme Deus havia ordenado a Noé."
,"10":"Depois de sete dias, veio o dilúvio sobre a Terra."
,"11":"Noé tinha seiscentos anos quando se romperam as fontes do oceano e se abriram as comportas do céu. Era exactamente o décimo sétimo dia do segundo mês."
,"12":"E a chuva caiu sobre a Terra durante quarenta dias e quarenta noites."
,"13":"Nesse mesmo dia, entraram na arca Noé e seus filhos Sem, Cam e Jafé, com a mulher de Noé e as três mulheres de seus filhos;"
,"14":"e com eles, as feras de toda a espécie, animais domésticos de toda a espécie, répteis de toda a espécie, pássaros de toda a espécie, todas as aves, tudo o que tem asas."
,"15":"Com Noé entrou na arca um casal de todas as criaturas que têm sopro de vida;"
,"16":"e os que entraram eram um macho e uma fêmea de cada ser vivo, conforme Deus havia ordenado. E Javé fechou a porta por fora."
,"17":"Durante quarenta dias caiu o dilúvio sobre a Terra. As águas subiram e ergueram a arca, que ficou acima da terra."
,"18":"As águas subiram e cresceram muito sobre a terra. E a arca flutuava sobre as águas."
,"19":"As águas subiam cada vez mais sobre a terra, até cobrirem as montanhas mais altas que há debaixo do céu."
,"20":"A água alcançou a altura de sete metros e meio acima das montanhas."
,"21":"Pereceram todos os seres vivos que se movem sobre a terra: aves, animais domésticos, feras, tudo o que vive sobre a terra e todos os homens."
,"22":"Morreu então tudo o que tinha sopro de vida nas narinas, isto é, tudo o que estava em terra firme."
,"23":"Desapareceram todos os seres que estavam no solo, desde o homem até aos animais, os répteis e as aves do céu. Foram todos extintos da Terra. Ficou somente Noé e os que com ele estavam na arca."
,"24":"E a água cobriu a Terra durante cento e cinquenta dias."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Então Deus lembrou-Se de Noé e de todas as feras e animais domésticos que estavam com ele na arca. Deus fez soprar um vento sobre a terra, e as águas baixaram."
,"2":"As fontes do oceano e as comportas do céu fecharam-se, a chuva deixou de cair,"
,"3":"e as águas, pouco a pouco, retiraram-se da terra. As águas retiraram-se depois de cento e cinquenta dias."
,"4":"No décimo sétimo dia do sétimo mês, a arca encalhou sobre os montes de Ararat."
,"5":"E as águas foram diminuindo até ao décimo mês, e no primeiro dia do décimo mês apareceram os picos das montanhas."
,"6":"No fim de quarenta dias, Noé abriu a clarabóia que tinha feito na arca,"
,"7":"e soltou um corvo, que ia e vinha, esperando que as águas secassem sobre a terra."
,"8":"Então Noé soltou uma pomba que estava com ele, para ver se as águas tinham secado sobre a terra."
,"9":"Ora, a pomba, não encontrando lugar para pousar, voltou para Noé na arca, porque havia água sobre toda a superfície da Terra. Noé estendeu a mão, agarrou-a e meteu-a junto dele na arca."
,"10":"Esperou mais sete dias, e soltou de novo a pomba para fora da arca."
,"11":"Ao entardecer, a pomba voltou para junto de Noé, trazendo no bico um rebento novo de oliveira. Deste modo, Noé soube que as águas tinham escoado da superfície da Terra."
,"12":"Noé esperou mais sete dias; e soltou novamente a pomba, que não voltou mais."
,"13":"Foi no ano seiscentos e um da vida de Noé, no primeiro dia do primeiro mês, que as águas secaram sobre a terra. Noé abriu então a clarabóia da arca, olhou e viu que a superfície do solo estava seca."
,"14":"No vigésimo sétimo dia do segundo mês, a terra estava seca."
,"15":"Então Deus disse a Noé:"
,"16":"«Sai da arca com os teus filhos, a tua mulher e as mulheres de teus filhos."
,"17":"Todos os seres vivos que estão contigo, todos os animais, aves e répteis, fá-los sair contigo: que encham a Terra, sejam fecundos e se multipliquem na Terra»."
,"18":"Então Noé saiu com os seus filhos, a sua mulher e as mulheres de seus filhos;"
,"19":"e todas as feras, animais domésticos, aves e répteis saíram da arca."
,"20":"Noé construiu um altar a Javé, tomou animais e aves de toda a espécie pura e ofereceu holocaustos sobre o altar."
,"21":"Javé aspirou o perfume, e disse consigo: «Nunca mais amaldiçoarei a Terra por causa do homem, porque os projectos do coração do homem são maus desde a sua juventude. Nunca mais destruirei todos os seres vivos, como fiz."
,"22":"Enquanto durar a Terra, jamais faltarão sementeira e colheita, frio e calor, Verão e Inverno, dia e noite»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Deus abençoou Noé e os seus filhos, dizendo: «Sede fecundos, multiplicai-vos e enchei a Terra."
,"2":"Todos os animais da Terra vos temerão e respeitarão: as aves do céu, os répteis do solo e os peixes do mar estão sob o vosso poder."
,"3":"Tudo o que vive e se move servir-vos-á de alimento. Entrego-vos tudo, como já vos havia entregue os vegetais."
,"4":"Mas não comais carne com o sangue, que é a vida dela."
,"5":"Vou pedir contas do sangue, que é a vossa vida; vou pedir contas a qualquer animal; e ao homem vou pedir contas da vida do seu irmão."
,"6":"Quem derramar o sangue do homem, terá o seu próprio sangue derramado por outro homem. Porque o homem foi feito à imagem de Deus."
,"7":"Quanto a vós, sede fecundos e multiplicai-vos, povoai e dominai a Terra»."
,"8":"Deus disse a Noé e a seus filhos:"
,"9":"«Eu estabeleço a minha aliança convosco e com os vossos descendentes,"
,"10":"e com todos os animais que vos acompanham: aves, animais domésticos e feras, com todos os que saíram da arca e agora vivem sobre a Terra."
,"11":"Estabeleço a minha aliança convosco: de tudo o que existe, nada mais será destruído pelas águas do dilúvio, e nunca mais haverá dilúvio para devastar a Terra»."
,"12":"Deus disse: «Este é o sinal da aliança que coloco entre Mim e vós e todos os seres vivos que estão convosco, para todas as gerações futuras:"
,"13":"Colocarei o meu arco nas nuvens, e ele se tornará um sinal da minha aliança com a Terra."
,"14":"Quando Eu reunir as nuvens sobre a Terra e o arco-íris aparecer nas nuvens,"
,"15":"lembrar-Me-ei da minha aliança convosco e com todos os seres vivos. E o dilúvio não voltará a destruir os seres vivos."
,"16":"Quando o arco-íris estiver nas nuvens, Eu vê-lo-ei e lembrar-Me-ei da aliança eterna: aliança de Deus com todos os seres vivos, com tudo o que vive sobre a Terra»."
,"17":"E Deus disse a Noé: «Este é o sinal da aliança que estabeleço com tudo o que vive sobre a Terra»."
,"18":"Os filhos de Noé, que saíram da arca, foram estes: Sem, Cam e Jafé. Cam é o antepassado de Canaã."
,"19":"São estes os três filhos de Noé, e a partir deles foi povoada a Terra inteira."
,"20":"Noé, que era lavrador, plantou a primeira vinha."
,"21":"Tendo bebido o vinho, embriagou-se e ficou nu dentro da tenda."
,"22":"Cam, o antepassado de Canaã, viu o pai nu e saiu para contar aos dois irmãos."
,"23":"Sem e Jafé, porém, tomaram um manto, puseram-no sobre os seus próprios ombros e, andando de costas, cobriram a nudez do pai; como estavam de costas, não viram a nudez do pai."
,"24":"Quando Noé acordou da embriaguez, soube o que o seu filho mais novo tinha feito."
,"25":"E disse: «Maldito seja Canaã. Que ele seja o último dos escravos dos seus irmãos»."
,"26":"E continuou: «Seja bendito Javé, o Deus de Sem, e que Canaã seja escravo de Sem."
,"27":"Que Deus faça prosperar Jafé, que ele more nas tendas de Sem, e Canaã seja seu escravo»."
,"28":"Depois do dilúvio, Noé viveu trezentos e cinquenta anos."
,"29":"Ao todo, Noé viveu novecentos e cinquenta anos. E morreu."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Esta é a descendência dos filhos de Noé: Sem, Cam e Jafé, que tiveram filhos depois do dilúvio."
,"2":"Filhos de Jafé: Gomer, Magog, Madai, Javã, Tubal, Mosoc e Tiras."
,"3":"Filhos de Gomer: Asquenez, Rifat e Togorma."
,"4":"Filhos de Javã: Elisa, Társis, Cetim e Dodanim."
,"5":"Foi destes que se separaram as populações das ilhas, cada qual segundo o seu país, língua, família e nação."
,"6":"Filhos de Cam: Cuch, Mesraim, Fut e Canaã."
,"7":"Filhos de Cuch: Saba, Hévila, Sabata, Regma e Sabataca. Filhos de Regma: Sabá e Dadã."
,"8":"Cuch gerou Nemrod, que foi o primeiro valente na Terra."
,"9":"Foi um valente caçador diante de Javé, e é por isso que se diz: «Como Nemrod, valente caçador diante de Javé»."
,"10":"As capitais do seu reino foram Babel, Arac e Acad, cidades que estão todas na terra de Senaar."
,"11":"Dessa terra saiu Assur, que construiu Nínive, Reobot-Ir, Cale"
,"12":"e Resen, entre Nínive e Cale. Esta última é a maior."
,"13":"Mesraim gerou os de Lud, de Anam, de Laab, de Naftu,"
,"14":"de Patros, de Caslu e de Cáftor; deste último surgiram os filisteus."
,"15":"Canaã gerou Sídon, seu primogénito, depois Het,"
,"16":"e também o jebuseu, o amorreu, o gergeseu,"
,"17":"o heveu, o araceu, o sineu,"
,"18":"o arádio, o samareu e o emateu. Em seguida, as famílias dos cananeus dispersaram-se."
,"19":"A fronteira dos cananeus ia de Sidónia, em direcção a Gerara, até Gaza; depois, em direcção de Sodoma, Gomorra, Adama e Seboim, até Lesa."
,"20":"Foram estes os filhos de Cam, se-gundo as suas famílias e línguas, terras e nações."
,"21":"Sem, antepassado de todos os filhos de Héber e irmão mais velho de Jafé, também teve descendência."
,"22":"Filhos de Sem: Elam, Assur, Arfa-xad, Lud e Aram."
,"23":"Filhos de Aram: Hus, Hul, Geter e Mes."
,"24":"Arfaxad gerou Salé, e Salé gerou Héber."
,"25":"Héber teve dois filhos: o primeiro chamava-se Faleg, porque nos seus dias a terra foi dividida; o seu irmão chamava-se Jectã."
,"26":"Jectã gerou Elmodad, Salef, Asarmot, Jaré,"
,"27":"Aduram, Uzal, Decla,"
,"28":"Ebal, Abimael, Sabá,"
,"29":"Ofir, Hévila e Jobab; todos estes são filhos de Jectã."
,"30":"Eles habitavam desde Mesa até Sefar, a montanha do oriente."
,"31":"Foram estes os filhos de Sem, conforme as suas famílias e línguas, suas terras e nações."
,"32":"Foram estas as famílias dos descendentes de Noé, conforme as suas linhagens e nações. Foi a partir deles que as nações se dispersaram pela Terra depois do dilúvio."
}`)
	CurrentBook.AddChapter(11, `{
"1":"O mundo inteiro falava a mesma língua, com as mesmas palavras."
,"2":"Ao emigrar do Oriente, os homens encontraram uma planície no país de Senaar e aí se estabeleceram."
,"3":"E disseram uns aos outros: «Vamos fazer tijolos e cozê-los no fogo!» Utilizaram tijolos em vez de pedras, e betume em vez de argamassa."
,"4":"Disseram: «Vamos construir uma cidade e uma torre que chegue até ao céu, para ficarmos famosos e não nos dispersarmos pela superfície da Terra»."
,"5":"Então Javé desceu para ver a cidade e a torre que os homens estavam a construir."
,"6":"E Javé disse: «Eles são um único povo e falam uma só língua. Isto é apenas o começo dos seus empreendimentos. Agora, nenhum projecto será irrea-lizável para eles."
,"7":"Vamos descer e confundir a língua deles, para que um não entenda a língua do outro»."
,"8":"Javé dispersou-os dali para toda a superfície da Terra, e eles cessaram de construir a cidade."
,"9":"Por isso, a cidade recebeu o nome de Babel, pois foi lá que Javé confundiu a língua de todos os habitantes da Terra, e foi dali que Ele os espalhou por toda a superfície da Terra."
,"10":"Esta é a descendência de Sem: Quando Sem completou cem anos, gerou Arfa-xad, dois anos depois do dilúvio."
,"11":"Depois do nascimento de Arfaxad, Sem viveu quinhentos anos, e gerou filhos e filhas."
,"12":"Quando Arfaxad completou trinta e cinco anos, gerou Salé."
,"13":"Depois do nascimento de Salé, Arfaxad viveu quatrocentos e três anos, e gerou filhos e filhas."
,"14":"Quando Salé completou trinta anos, gerou Héber."
,"15":"Depois do nascimento de Héber, Salé viveu quatrocentos e três anos, e gerou filhos e filhas."
,"16":"Quando Héber completou trinta e quatro anos, gerou Faleg."
,"17":"Depois do nascimento de Faleg, Héber viveu quatrocentos e trinta anos, e gerou filhos e filhas."
,"18":"Quando Faleg completou trinta anos, gerou Reu."
,"19":"Depois do nascimento de Reu, Faleg viveu duzentos e nove anos, e gerou filhos e filhas."
,"20":"Quando Reu completou trinta e dois anos, gerou Sarug."
,"21":"Depois do nascimento de Sarug, Reu viveu duzentos e sete anos, e gerou filhos e filhas."
,"22":"Quando Sarug completou trinta anos, gerou Nacor."
,"23":"Depois do nascimento de Nacor, Sarug viveu duzentos anos, e gerou filhos e filhas."
,"24":"Quando Nacor completou vinte e nove anos, gerou Taré."
,"25":"Depois do nascimento de Taré, Nacor viveu cento e dezanove anos, e gerou filhos e filhas."
,"26":"Quando Taré completou setenta anos, gerou Abrão, Nacor e Arã."
,"27":"Esta é a descendência de Taré: Taré gerou Abrão, Nacor e Arã. Arã gerou Lot."
,"28":"Arã morreu em Ur dos caldeus, sua terra natal, quando seu pai Taré ainda estava vivo."
,"29":"Abrão e Nacor casaram-se: a mulher de Abrão chamava-se Sarai; a mulher de Nacor era Melca, filha de Arã, que era o pai de Melca e Jesca."
,"30":"Sarai era estéril e não tinha filhos."
,"31":"Taré tomou seu filho Abrão, seu neto Lot, filho de Arã, e sua nora Sarai, mulher de Abrão. Fê-los sair de Ur dos caldeus para a terra de Canaã; mas, quando chegaram a Harã, lá se estabeleceram."
,"32":"Ao todo, Taré viveu duzentos e cinco anos, e depois morreu em Harã."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Javé disse a Abrão: «Sai da tua terra, do meio dos teus parentes e da casa de teu pai, e vai para a terra que Eu te mostrar."
,"2":"Eu farei de ti um grande povo, e abençoar-te-ei; tornarei famoso o teu nome, de modo que se torne uma bênção."
,"3":"Abençoarei os que te abençoarem e amaldiçoarei aqueles que te amaldiçoarem. Em ti, todas as famílias da Terra serão abençoadas»."
,"4":"Abrão partiu conforme lhe dissera Javé. E Lot partiu com ele. Abrão tinha setenta e cinco anos quando saiu de Harã."
,"5":"Abrão levou consigo sua mulher Sarai, seu sobrinho Lot, todos os bens que possuíam e os escravos que haviam adquirido em Harã. Partiram para a terra de Canaã e chegaram lá."
,"6":"Abrão atravessou a terra até ao lugar santo de Siquém, até ao Carvalho de Moré. Naquele tempo, os cananeus habitavam naquela terra."
,"7":"Javé apareceu a Abrão e disse-lhe: «Darei esta terra à tua descendência». Abrão construiu ali um altar a Javé, que lhe havia aparecido."
,"8":"Dali, passou para a montanha, a oriente de Betel, e armou a sua tenda, com Betel a Oeste e Hai a Leste. E ali construiu também um altar a Javé e invocou o nome de Javé."
,"9":"Depois, de acampamento em acampamento, Abrão foi para o Negueb."
,"10":"Houve uma carestia no país e, como a fome apertava, Abrão desceu ao Egipto para lá morar."
,"11":"Quando estava quase a chegar ao Egipto, Abrão disse à sua mulher Sarai: «Olha! Eu sei que és uma mulher muito bonita."
,"12":"Quando os egípcios te virem, vão dizer: 'É a mulher dele'. Matar-me-ão e conservar-te-ão a vida."
,"13":"Diz, por favor, que és minha irmã, para que eles me tratem bem por tua causa, e assim, graças a ti, deixar-me-ão vivo»."
,"14":"De facto, quando Abrão chegou ao Egipto, os egípcios viram que a mulher dele era muito bonita."
,"15":"Os oficiais do Faraó viram Sarai e elogiaram-na muito diante dele; e Sarai foi levada para o palácio do Faraó."
,"16":"Este, por causa de Sarai, tratou bem Abrão: ele recebeu ovelhas, bois, jumentos, escravos, servas, jumentas e camelos."
,"17":"Javé, porém, feriu o Faraó e sua corte com graves doenças, por causa de Sarai, mulher de Abrão."
,"18":"Então o Faraó chamou Abrão, e disse-lhe: «Que é que me fizeste? Porque não me disseste que ela era tua mulher?"
,"19":"Porque me disseste que era tua irmã? Eu tomei-a por esposa! Olha bem! Se ela é tua mulher, toma-a e vai-te embora»."
,"20":"O Faraó confiou Abrão, juntamente com sua mulher e tudo o que possuía, a vários homens, que os levaram até à fronteira."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Abrão subiu do Egipto para o Negueb, com sua mulher, seus bens e com Lot."
,"2":"Abrão era muito rico em rebanhos, prata e ouro."
,"3":"Do Negueb ele transferiu-se, em etapas, para Betel, até ao lugar onde outrora havia acampado, entre Betel e Hai,"
,"4":"no lugar onde tinha construído um altar. E invocou aí o nome de Javé."
,"5":"Lot, que acompanhava Abrão, também possuía ovelhas, bois e tendas,"
,"6":"de modo que não podiam viver juntos na terra, porque as suas posses eram tão grandes que não podiam morar juntos."
,"7":"Por isso, houve discussões entre os pas-tores de Abrão e os de Lot. Nesse tempo, os cananeus e ferezeus habitavam essa terra."
,"8":"Abrão disse a Lot: «Não haja discussões entre nós, nem entre os nossos pastores, porque somos irmãos."
,"9":"A Terra inteira está diante de ti. Por isso peço-te que te separes de mim. Se fores para a esquerda, eu irei para a direita; se fores para a direita, eu irei para a esquerda»."
,"10":"Lot ergueu os olhos e viu que o vale do Jordão, até à entrada de Segor, era todo irrigado; isso antes que Javé destruísse Sodoma e Gomorra: parecia o jardim de Javé ou o Egipto."
,"11":"Lot escolheu para si todo o vale do Jordão e emigrou para o Oriente. E assim os dois irmãos separaram-se."
,"12":"Abrão morou em Canaã, e Lot nas cidades do vale, armando as suas tendas até Sodoma."
,"13":"Os habitantes de Sodoma eram grandes criminosos e pecavam contra Javé."
,"14":"Javé disse a Abrão, depois que Lot se separou dele: «Ergue os teus olhos e, do sítio onde estás, olha para o Norte e para o Sul, para o Oriente e para o Ocidente."
,"15":"Eu dar-te-ei toda a terra que estás vendo, a ti e à tua descendência, para sempre."
,"16":"Tornarei a tua descendência como o pó da terra: quem puder contar os grãos do pó da terra poderá contar os teus descendentes."
,"17":"Levanta-te, e percorre esta terra no seu comprimento e na sua largura, pois Eu ta darei»."
,"18":"Abrão levantou a tenda e foi estabelecer-se junto ao Carvalho de Mambré, que está em Hebron, e aí construiu um altar em honra de Javé."
}`)
	CurrentBook.AddChapter(14, `{
"1":"No tempo de Amrafel, rei de Senaar, e de Arioc, rei de Elasar, e de Codorlaomor, rei de Elam, e de Tadal, rei das nações,"
,"2":"todos estes fizeram guerra contra Bara, rei de Sodoma, contra Bersa, rei de Gomorra, contra Senaab, rei de Adama, contra Semeber, rei de Seboim, e contra o rei de Bela, que é Segor."
,"3":"Estes últimos reuniram-se no vale de Sidim, que é o Mar Morto."
,"4":"Durante doze anos eles tinham ficado submetidos a Codorlaomor, mas no décimo terceiro ano revoltaram-se."
,"5":"No décimo quarto ano, veio Codorlaomor com os reis seus aliados, e derrotou os rafaítas em Astarot Carnaim, os zuzim em Ham, os emim na planície de Cariataim,"
,"6":"e os horitas nas montanhas de Seir, até El-Farã, na margem do deserto."
,"7":"Depois, voltaram e foram à Fonte do Julgamento, que é Cades; conquistaram todo o território dos amalecitas e amorreus, que habitavam Asasontamar."
,"8":"Então os reis de Sodoma, de Gomorra, de Adama, de Seboim e de Bela, que é Segor, fizeram uma expedição e apresentaram-se no vale de Sidim para batalhar"
,"9":"contra Codorlaomor, rei de Elam, contra Tadal, rei das nações, contra Amrafel, rei de Senaar, e contra Arioc, rei de Elasar. Eram cinco reis contra quatro."
,"10":"Ora, o vale de Sidim estava cheio de poços de betume. Ao fugir, o rei de Sodoma e o rei de Gomorra caíram neles; os outros refugiaram-se na montanha."
,"11":"Os vencedores saquearam todos os bens de Sodoma e Gomorra, assim como todos os seus mantimentos, e foram-se embora."
,"12":"Levaram também Lot, sobrinho de Abrão, todos os seus bens, e partiram. Lot morava em Sodoma."
,"13":"Um fugitivo foi informar Abrão, o hebreu, que habitava no Carvalho do amorreu Mambré, irmão de Escol e de Aner, aliados de Abrão."
,"14":"Quando Abrão soube que o seu parente fora levado prisioneiro, reuniu os seus aliados e familiares, em número de trezentos e dezoito, e perseguiu os inimigos até Dã."
,"15":"Dividiu a tropa e atacou-os de noite, derrotando-os e perseguindo-os até Hoba, ao Norte de Damasco."
,"16":"Recuperou todos os bens e trouxe também seu irmão Lot, juntamente com os bens, as mulheres e o povo."
,"17":"Quando Abrão voltou, depois de ter derrotado Codorlaomor e os reis aliados, o rei de Sodoma foi ao seu encontro no vale de Save, que é o vale do rei."
,"18":"Melquisedec, rei de Salém e sacerdote do Deus Altíssimo, levou pão e vi-nho,"
,"19":"e abençoou Abrão, dizendo: «Bendito seja Abrão pelo Deus Altíssimo, que criou o Céu e a Terra;"
,"20":"e bendito seja o Deus Altíssimo, que entregou os inimigos nas tuas mãos». E Abrão deu-lhe a décima parte de tudo."
,"21":"O rei de Sodoma disse a Abrão: «Dá-me as pessoas e fica com os bens»."
,"22":"Mas Abrão respondeu ao rei de Sodoma: «Juro por Javé, o Deus Altíssimo, que criou o Céu e a Terra:"
,"23":"não aceitarei nem sequer um fio, ou correia de sandália, daquilo que te pertence, para que depois não digas que enriqueceste Abrão."
,"24":"Não quero nada para mim. Aceito apenas o que os meus servos comeram e a parte de Aner, Escol e Mambré, que me acompanharam; eles que levem a parte deles»."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Depois destes acontecimentos, Javé dirigiu a palavra a Abrão, através de uma visão: «Não tenhas medo, Abrão! Eu sou o teu escudo, e a tua recompensa será muito grande»."
,"2":"Abrão respondeu: «Senhor Javé, o que me darás? Continuo sem filhos, e Eliezer de Damasco será o herdeiro da minha casa!»"
,"3":"E acrescentou: «Como não me deste descendência, um dos servos da minha casa é que será o meu herdeiro!»"
,"4":"Então Javé dirigiu esta palavra a Abrão: «O teu herdeiro não será esse, mas alguém que sairá do teu sangue»."
,"5":"Depois Javé conduziu Abrão para fora, e disse-lhe: «Ergue os olhos ao céu e conta as estrelas, se puderes». E acrescentou: «Assim será a tua descendência»."
,"6":"Abrão acreditou em Javé, e isso foi-lhe creditado como justiça."
,"7":"Javé disse a Abrão: «Eu sou Javé, que te fez sair de Ur dos caldeus, para te dar esta Terra como herança»."
,"8":"Abrão respondeu: «Senhor Javé, como vou saber que irei possuí-la?»"
,"9":"Javé disse-lhe: «Traz-Me uma novilha de três anos, uma cabra de três anos, um cordeiro de três anos, uma rola e uma pombinha»."
,"10":"Abrão levou a Javé todos esses animais, partiu-os ao meio e colocou cada metade em frente uma da outra; mas não partiu as aves."
,"11":"As aves de rapina des-ciam sobre os cadáveres e Abrão afugentava-as."
,"12":"Quando o sol já se punha, um torpor caiu sobre Abrão, e ele sentiu muito medo."
,"13":"Javé disse a Abrão: «Fica a saber que os teus descendentes viverão como estrangeiros numa terra que não será a deles. Aí nessa terra eles ficarão como escravos e serão oprimidos durante quatrocentos anos."
,"14":"Mas Eu vou julgar a nação à qual eles vão servir, e depois eles sairão com muitos bens."
,"15":"Tu, porém, irás reunir-te em paz com os teus antepassados e serás sepultado após uma velhice feliz."
,"16":"É na quarta geração que os teus descendentes voltarão para cá, porque até lá o crime dos Amorreus terá chegado ao máximo»."
,"17":"Quando o sol se pôs e veio a noite, uma labareda fumegante e uma tocha de fogo passaram entre os animais divididos."
,"18":"Nesse dia, Javé estabeleceu uma aliança com Abrão nestes termos: «À tua descendência Eu darei esta Terra, desde o rio do Egipto até ao grande rio, o Eufrates:"
,"19":"os quenitas, cenezeus, cadmoneus,"
,"20":"heteus, ferezeus, rafaítas,"
,"21":"amorreus, cananeus, gergeseus e jebuseus»."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Sarai, mulher de Abrão, não lhe dava filhos; mas tinha uma escrava egípcia chamada Agar."
,"2":"Então Sarai disse a Abrão: «Javé não me deixa ter filhos: une-te à minha escrava para ver se ela me dá filhos». Abrão aceitou a proposta de Sarai."
,"3":"Dez anos depois de Abrão se ter estabelecido na terra de Canaã, sua mulher Sarai tomou a sua escrava, a egípcia Agar, e entregou-a como mulher a seu marido Abrão."
,"4":"Este uniu-se a Agar, que ficou grávida. Vendo que estava grávida, Agar perdeu o respeito para com Sarai."
,"5":"Então Sarai disse a Abrão: «Tu és o responsável por esta injustiça. Coloquei nos teus braços a minha escrava, e ela, vendo-se grávida, já me não respeita. Que Javé seja nosso Juiz»."
,"6":"Abrão disse a Sarai: «Muito bem. A tua escrava está nas tuas mãos. Trata-a como achares melhor». Sarai maltratou de tal modo Agar, que ela fugiu da sua presença."
,"7":"O anjo de Javé encontrou Agar junto a uma fonte no deserto, a fonte que está no caminho de Sur."
,"8":"E disse-lhe: «Agar, escrava de Sarai, de onde vens e para onde vais?» Agar respondeu: «Estou fugindo da minha patroa Sarai»."
,"9":"O anjo de Javé disse-lhe: «Volta para a tua patroa e submete-te a ela»."
,"10":"E o anjo de Javé acrescentou: «Eu farei a tua descendência tão numerosa que ninguém a poderá contar»."
,"11":"E o anjo de Javé concluiu: «Estás grávida e vais dar à luz um filho e dar-lhe-ás o nome de Ismael, porque Javé ouviu a tua aflição."
,"12":"Ele será um potro selvagem: estará contra todos, e todos estarão contra ele; e viverá separado dos seus irmãos»."
,"13":"Agar invocou o nome de Javé, que lhe havia falado, e disse: «Tu és o Deus-que-me-vê, pois eu vi Aquele-que-me-vê»."
,"14":"Por isso, aquele poço chama-se «Poço d'Aquele que vive e me vê», e encontra-se entre Cades e Barad."
,"15":"Agar deu à luz um filho a Abrão, e Abrão deu o nome de Ismael ao filho que Agar lhe dera."
,"16":"Abrão tinha oitenta e seis anos quando Agar deu à luz Ismael."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Quando Abrão completou noventa e nove anos, Javé apareceu-lhe e disse: «Eu sou o Deus todo-poderoso. Comporta-te de acordo comigo e sê íntegro."
,"2":"Vou fazer uma aliança entre Mim e ti, e multiplicar-te-ei sem medida»."
,"3":"Abrão caiu com o rosto por terra. Então Deus disse-lhe:"
,"4":"«Vê! A aliança que faço contigo é esta: serás pai de muitas nações."
,"5":"E já não te chamarás Abrão, mas o teu nome será Abraão, pois farei de ti o pai de muitas nações."
,"6":"Eu tornar-te-ei extremamente fecundo. De ti farei surgir nações, e de ti nascerão reis."
,"7":"Vou estabelecer para sempre a minha aliança entre Mim e ti, como aliança eterna. Serei o teu Deus e o Deus dos teus futuros descendentes."
,"8":"Dar-te-ei a ti, e aos teus futuros descendentes, a terra em que agora vives como imigrante, toda a terra de Canaã, como posse perpétua. E Eu serei o vosso Deus»."
,"9":"E Deus continuou a dizer a Abraão: «Quanto a ti, observa a aliança que faço contigo e com os teus futuros descendentes."
,"10":"E a aliança que faço contigo e com os teus futuros descendentes, e que deveis observar, é a seguinte: circuncidai todos os homens."
,"11":"Circuncidai a carne do prepúcio. Este será o sinal da aliança entre Mim e vós."
,"12":"Quando completarem oito dias, todos os meninos de cada geração serão circuncidados; também os escravos nascidos em casa ou comprados aos estrangeiros, que não sejam da vossa raça."
,"13":"Circuncidai os escravos nascidos em casa ou comprados. A minha aliança estará marcada na vossa carne como aliança perpétua."
,"14":"Todo o homem não circuncidado, cujo prepúcio não for circuncidado, será afastado do meio do teu povo, por ter violado a minha aliança»."
,"15":"Deus disse a Abraão: «A tua mulher Sarai já não se chamará Sarai, mas Sara."
,"16":"Eu abençoá-la-ei, dar-te-ei um filho dela, e abençoá-lo-ei. Dela nascerão nações e reis de povos»."
,"17":"Abraão caiu com o rosto por terra e começou a rir, pensando: «Será que um homem com cem anos vai ter um filho, e Sara, que tem noventa anos, vai dar à luz?»"
,"18":"Abraão disse a Deus: «Ficarei contente se conservares Ismael vivo»."
,"19":"Deus porém respondeu: «Não! É Sara quem vai dar-te um filho: dar-lhe-ás o nome de Isaac. Vou fazer a minha aliança com ele e com os descendentes dele, uma aliança perpétua."
,"20":"Quanto a Ismael, vou atender ao pedido que me fazes: vou abençoá-lo, torná-lo fecundo e fazê-lo multiplicar-se sem medida. Ele vai gerar doze príncipes, e dele farei uma grande nação."
,"21":"Mas a minha aliança vou fazê-la com Isaac, o filho que Sara vai dar à luz no próximo ano, nesta mesma época do ano»."
,"22":"Quando acabou de falar com Abraão, Deus retirou-Se."
,"23":"Então Abraão tomou o seu filho Ismael, os escravos nascidos em casa ou comprados, todos os homens da sua casa, e circuncidou-os nesse mesmo dia, conforme Deus lhe havia ordenado."
,"24":"Abraão tinha noventa e nove anos quando foi circuncidado."
,"25":"E seu filho Ismael tinha treze anos quando foi circuncidado."
,"26":"Nesse mesmo dia, foram circuncidados Abraão e seu filho Ismael."
,"27":"E com Abraão foram circuncidados todos os homens da casa, nascidos em casa ou comprados a estrangeiros."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Javé apareceu a Abraão junto ao Carvalho de Mambré, enquanto ele estava sentado à entrada da tenda, pois fazia muito calor."
,"2":"Levantando os olhos, Abraão viu na sua frente três Homens de pé. Ao vê-los, correu da entrada da tenda ao encontro d'Eles e prostrou-se por terra,"
,"3":"dizendo: «Senhor, se alcancei o teu favor, não passes junto ao teu servo sem parares em sua casa."
,"4":"Vou mandar que tragam água para lavardes os pés e descansardes debaixo da árvore."
,"5":"Vou trazer um pedaço de pão e podereis recuperar as forças antes de partir; foi para isso que passastes junto do vosso servo». Eles responderam: «Está bem. Faz como disseste»."
,"6":"Abraão entrou depressa na tenda onde estava Sara, e disse-lhe: «Depressa! Toma vinte e um litros de flor de farinha, amassa-os e faz um pão grande»."
,"7":"Depois Abraão correu ao rebanho, escolheu um vitelo novo e bom, e entregou-o ao empregado, que se apressou a prepará-lo."
,"8":"Pegou também em coalhada, leite e no vitelo que havia preparado, e colocou tudo diante d'Eles. E atendia-Os debaixo da árvore enquanto Eles comiam."
,"9":"Depois Eles perguntaram: «Onde está a tua mulher Sara?» Abraão respondeu: «Está na tenda»."
,"10":"O Hóspede disse: «No próximo ano virei ter contigo. Então a tua mulher já terá um filho». Sara estava na entrada da tenda, atrás de Abraão, e ouviu isto."
,"11":"Ora, Abraão e Sara eram velhos, de idade avançada, e Sara já não tinha regras."
,"12":"Sara riu-se consigo, pensando: «Agora que sou velha vou experimentar o prazer, e com um marido tão velho?»"
,"13":"Javé, porém, disse a Abraão: «Porque está Sara a rir e a dizer: 'Será que vou dar à luz agora que sou velha?'"
,"14":"Há, porventura, alguma coisa impossível para Javé? Neste mesmo tempo, no próximo ano, Eu virei ter contigo, e Sara já terá um filho»."
,"15":"Sara, que estava assustada, negou: «Eu não ri». Mas Ele tornou a dizer: «Não negues, tu riste-te»."
,"16":"Os Homens levantaram-Se e olharam em direcção a Sodoma; e Abraão foi acompanhá-Los para a despedida."
,"17":"Javé dizia: «Será que devo esconder de Abraão o que vou fazer,"
,"18":"uma vez que Abraão se tornará uma nação grande e poderosa, e que através dele serão abençoadas todas as nações da Terra?"
,"19":"Eu escolhi-o para que instrua os seus filhos, a sua casa e os seus sucessores, a fim de que se mantenham no caminho de Javé, praticando a justiça e o direito; deste modo, Javé realizará tudo o que prometeu a Abraão»."
,"20":"Então Javé disse: «O clamor contra Sodoma e Gomorra é mui-to grande e o pecado deles é muito grave."
,"21":"Vou descer para ver se, de facto, as acções deles correspondem ou não ao clamor que subiu até Mim contra eles. Então, sabê-lo-ei»."
,"22":"Os Homens partiram e foram para Sodoma, enquanto Javé permanecia com Abraão."
,"23":"Abraão aproximou-se e perguntou: «Destruirás o justo com o ímpio?"
,"24":"Talvez haja cinquenta justos na cidade! Destruirás e não perdoarás à cidade pelos cinquenta justos que estão no meio dela?"
,"25":"Longe de Ti fazeres tal coisa: matar o justo com o ímpio, de modo que o justo seja confundido com o ímpio! Longe de Ti! Será que o Juiz de toda a Terra não fará justiça?»"
,"26":"Javé respondeu: «Se Eu encontrar cinquenta justos na cidade de Sodoma, perdoarei à cidade inteira por causa deles»."
,"27":"Abraão continuou: «Atrevo-me a falar ao meu Senhor, embora eu seja pó e cinza."
,"28":"Mas talvez faltem cinco para os cinquenta justos: por causa de cinco, destruirás a cidade inteira?» Javé respondeu: «Não a destruirei, se nela encontrar quarenta e cinco justos»."
,"29":"Abraão insistiu: «Suponhamos que só existam quarenta!» Javé respondeu: «Por causa dos quarenta, não o farei»."
,"30":"Abraão continuou: «Que o meu Senhor não fique irritado se eu continuo a falar. E se houver trinta?» Javé respondeu: «Se houver trinta, não o farei»."
,"31":"Abraão insistiu: «Estou-me atrevendo a falar ao meu Senhor. Talvez haja vinte!» Javé respondeu: «Por causa dos vinte, não a destruirei»."
,"32":"Abraão continuou: «Que o meu Senhor não Se irrite se pergunto pela última vez: E se houver dez?» Javé respondeu: «Por causa dos dez, não a destruirei»."
,"33":"Quando acabou de falar com Abraão, Javé foi-Se embora. E Abraão voltou para a sua tenda."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Ao anoitecer, os dois anjos chegaram a Sodoma. Lot estava sentado à porta da cidade e, ao vê-los, levantou-se para os receber e prostrou-se com o rosto por terra."
,"2":"E disse-lhes: «Senhores, ficai hospedados em casa do vosso servo, lavai os pés e, pela manhã, continuareis o vosso caminho». Mas eles responderam: «Não! Nós vamos passar a noite na praça»."
,"3":"Lot insistiu tanto que eles foram para a casa dele e entraram. Lot preparou-lhes uma refeição, mandou cozer pães sem fermento, e eles comeram."
,"4":"Ainda eles não se tinham deitado, quando os homens da cidade rodearam a casa. Eram os homens de Sodoma, desde os jovens até aos velhos, o povo todo, sem excepção."
,"5":"Chamaram Lot e disseram-lhe: «Onde estão os homens que vieram para a tua casa esta noite? Trá-los para termos relações com eles»."
,"6":"Lot veio à porta e, fechando-a atrás de si,"
,"7":"disse-lhes: «Meus irmãos, peço-vos: não façais esse mal."
,"8":"Vede! Eu tenho duas filhas que ainda são virgens; eu vo-las trarei: fazei com elas o que achardes melhor. Mas não façais nada a estes homens, porque eles estão hospedados em minha casa»."
,"9":"Mas eles responderam: «Sai daí! Este indivíduo veio como imigrante e agora quer ser juiz! Pois bem! Nós vamos fazer-te pior do que a eles». E empurraram Lot, tentando arrombar a porta."
,"10":"Os visitantes, porém, estenderam os braços e puxaram Lot para dentro, fechando a porta."
,"11":"Quanto aos homens que estavam à porta, feriram-nos com a cegueira, do menor ao maior, de modo que não conseguiam encontrar a entrada."
,"12":"Os visitantes disseram a Lot: «Ainda tens mais alguém aqui? Faz sair deste lugar os teus filhos e filhas, e todos os teus parentes que estão na cidade,"
,"13":"porque nós vamos destruir este lugar, pois é grande o clamor que se ergueu contra eles diante de Javé. E Javé enviou-nos para os exterminar»."
,"14":"Lot foi falar com os seus futuros genros, que estavam para casar com suas filhas: «Vamos, saí deste lugar, porque Javé vai destruir a cidade». Mas os seus futuros genros acharam que Lot estava a brincar."
,"15":"Ao raiar da aurora, os anjos insistiram com Lot, dizendo: «Levanta-te, toma a tua mulher e as tuas duas filhas que aqui se encontram, para que não pereçam no castigo da cidade»."
,"16":"Como Lot não se decidisse, os visitantes agarraram-no pela mão, juntamente com a mulher e as duas filhas, pois Javé tinha compaixão dele. Fizeram-no sair e deixaram-no fora da cidade."
,"17":"Quando já estavam fora, um deles disse-lhe: «Procura salvar-te, e não olhes para trás. Não pares em lugar nenhum da planície; foge para a montanha, para não morreres»."
,"18":"Lot respondeu: «Não, meu Senhor."
,"19":"O teu servo encontrou graça a teus olhos, e mostraste grande misericórdia por mim, salvando-me a vida. Mas eu receio que não poderei salvar-me na montanha antes que a calamidade me atinja e eu morra."
,"20":"Vê! Aqui perto há uma pequena cidade, onde posso refugiar-me e escapar do perigo. Permite que eu vá para lá. Como a cidade é pequena, lá estarei a salvo»."
,"21":"Ele respondeu: «Concedo-te o que me estás a pedir: não destruirei a cidade a que te referes."
,"22":"Depressa, foge para lá, porque nada posso fazer enquanto não chegares lá». É por isso que se deu a essa cidade o nome de Segor."
,"23":"O Sol estava a nascer quando Lot chegou a Segor."
,"24":"Então Javé fez chover do céu enxofre e fogo sobre Sodoma e Gomorra;"
,"25":"destruiu essas cidades e toda a planície, com os habitantes das cidades e a vegetação da terra."
,"26":"A mulher de Lot olhou para trás e transformou-se numa estátua de sal."
,"27":"Abraão levantou-se de madrugada e foi ao lugar onde estivera com Javé."
,"28":"Olhou para Sodoma, para Gomorra e para toda a planície, e viu subir da terra um fumo semelhante ao fumo de uma fornalha."
,"29":"Foi assim que, ao destruir as cidades da planície, Deus Se lembrou de Abraão, e retirou Lot do meio da catástrofe, quando arrasou as cidades onde Lot habitava."
,"30":"Lot deixou Segor e estabeleceu-se na montanha com as duas filhas, porque estava com medo de viver em Segor. Por isso, instalou-se numa caverna com as duas fi-lhas."
,"31":"A mais velha disse à mais nova: «O nosso pai já está velho, e na terra não há nenhum homem para ter relações con-nosco, como se faz em todo o lugar."
,"32":"Vamos embriagar o nosso pai para ter relações com ele; assim daremos descendência ao nosso pai»."
,"33":"Nessa noite, elas embriagaram o pai, e a mais velha deitou-se com ele, que de nada se apercebeu nem quando ela se deitou, nem quando se levantou."
,"34":"No dia seguinte, a mais velha disse à mais nova: «Na noite passada dormi com o pai; esta noite, nós o embriagaremos de novo, e tu irás deitar-te com ele; assim daremos descendência ao nosso pai»."
,"35":"Também nessa noite, elas embriagaram o pai, e a mais nova deitou-se com ele, que de nada se apercebeu, nem quando ela se deitou, nem quando se levantou."
,"36":"E as duas filhas de Lot ficaram grávidas do próprio pai."
,"37":"A mais velha deu à luz um filho, e chamou-lhe Moab, que é o antepassado dos actuais moabitas."
,"38":"Também a mais nova deu à luz um filho, e chamou-lhe Ben-Ami, que é o antepassado dos actuais amonitas."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Abraão partiu dali e foi para a região do Negueb, estabelecendo-se entre Cades e Sur, e vivendo como imigrante em Gerara."
,"2":"Abraão dizia que Sara era sua irmã. Então Abimelec, rei de Gerara, mandou buscar Sara."
,"3":"Mas Deus visitou Abimelec em sonho durante a noite, e disse-lhe: «Vais morrer, porque essa mulher que tomaste é casada»."
,"4":"Abimelec, que ainda não tinha tido relações com ela, disse: «Meu Senhor, vais matar alguém inocente?"
,"5":"Ele próprio me disse que era sua irmã; e ela disse que ele era seu irmão. Fiz isso de boa fé e mãos limpas»."
,"6":"Deus respondeu-lhe no sonho: «Sei que fizeste isso de boa fé. Fui Eu quem te impediu que pecasses contra Mim, não permitindo que lhe tocasses."
,"7":"Agora, devolve a mulher a esse homem: ele é profeta e rezará para que tu continues vivo. Se não a devolveres, fica sabendo que morrerás com todos os teus»."
,"8":"Abimelec levantou-se bem cedo e chamou todos os servos. Contou-lhes tudo, e os homens ficaram muito assustados."
,"9":"Em seguida, Abimelec chamou Abraão e disse-lhe: «O que é que fizeste connosco? Que mal te fiz para atraíres tão grande pecado sobre mim e o meu reino? Fizeste para comigo uma coisa que não se deve fazer»."
,"10":"E Abimelec acrescentou: «O que pretendias ao fazer isto?»"
,"11":"Abraão respondeu: «Pensei que neste país não respeitavam a Deus e que me matariam por causa da minha mulher."
,"12":"Além do mais, ela é de facto minha irmã por parte do pai, mas não por parte da mãe, e tornou-se minha mulher."
,"13":"Quando Deus me fez andar errante, longe da minha família, eu pedi-lhe: 'Faz-me este favor: em qualquer lugar a que chegarmos, diz que sou teu irmão'»."
,"14":"Abimelec tomou ovelhas e bois, servos e servas, e deu-os a Abraão, devolvendo-lhe também a sua mulher Sara."
,"15":"Disse ainda: «A minha terra está aberta para ti; fica onde quiseres»."
,"16":"Depois disse a Sara: «Aqui estão mil moedas de prata para o teu irmão. Isto servirá de reparação diante de todos os teus, e ninguém pensará mal de ti»."
,"17":"Abraão intercedeu junto de Deus, e Deus curou Abimelec, sua mulher e seus servos, a fim de que pudessem ter filhos."
,"18":"Isto porque Javé tornara estéreis todas as mulheres na casa de Abimelec, por causa de Sara, mulher de Abraão."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Javé visitou Sara, como havia anunciado, e cumpriu a sua promessa."
,"2":"No tempo que Deus tinha marcado, Sara concebeu e deu à luz um filho a Abraão, que já era velho."
,"3":"Abraão deu o nome de Isaac ao filho que lhe nasceu, gerado por Sara."
,"4":"Conforme Deus lhe havia ordenado, Abraão circuncidou o seu filho Isaac, quando este completou oito dias."
,"5":"Abraão tinha cem anos quando o seu filho Isaac nasceu."
,"6":"E Sara disse: «Deus deu-me um motivo de riso, e todos os que souberem disto vão rir de mim»."
,"7":"E acrescentou: «Quem diria a Abraão que Sara iria amamentar filhos? Apesar de tudo, na sua velhice eu dei-lhe um filho»."
,"8":"O menino cresceu e foi desmamado. E no dia em que Isaac foi desmamado, Abraão deu uma grande festa."
,"9":"Ora, Sara viu que o filho que Abraão tinha tido da egípcia Agar zombava do seu filho Isaac."
,"10":"Então ela disse a Abraão: «Expulsa essa escrava e o filho dela, para que o filho dessa escrava não seja herdeiro com o meu filho Isaac»."
,"11":"Abraão ficou muito desgostoso com isto, porque Ismael era seu filho."
,"12":"Mas Deus disse-lhe: «Não te aflijas por causa do menino e da escrava. Atende o pedido de Sara, pois será através de Isaac que a tua des-cendência levará o nome que tu tens."
,"13":"Entretanto, também do filho da escrava Eu farei uma grande nação, pois ele é tua descendência»."
,"14":"Abraão levantou-se de manhã, tomou pão e um cantil de água e deu-os a Agar; colocou a criança sobre os ombros dela e depois mandou-a embora. Ela saiu e andava errante pelo deserto de Bersabeia. "
,"15":"Quando acabou a água do cantil, ela pôs a criança debaixo de um arbusto"
,"16":"e foi sentar-se mais adiante, à distância de um tiro de arco. Ela pensava: «Não quero ver a criança morrer!» E sentou-se à distância. O menino come-çou a chorar."
,"17":"Deus ouviu os gritos da criança, e o anjo de Deus, lá do Céu, cha-mou Agar, dizendo: «O que é que tens, Agar? Não tenhas medo, pois Deus ouviu os gritos do menino, que está além."
,"18":"Levanta-te, e pega no menino pela mão, porque Eu farei dele uma grande nação»."
,"19":"Deus abriu os olhos de Agar e ela viu um poço. Foi encher o cantil e deu de beber ao menino."
,"20":"Deus estava com o menino. Ele cresceu, morou no deserto e tornou-se um arqueiro."
,"21":"Morou no deserto de Farã, e sua mãe escolheu para ele uma mulher egípcia."
,"22":"Nesse tempo, Abimelec veio com Ficol, chefe do seu exército, e disse a Abraão: «Deus está contigo em tudo o que fazes."
,"23":"Portanto, jura por Deus, aqui mesmo, que não me enganarás, nem a mim, nem aos meus filhos e descendentes. E que me tratarás a mim e a esta terra, onde moras, com a mesma amizade com que eu te tratei»."
,"24":"Abraão respondeu: «Juro»."
,"25":"Abraão apresentou reclamações a Abimelec por causa do poço do qual os servos de Abimelec se haviam apoderado."
,"26":"Abimelec respondeu: «Não sei quem foi que fez isso. Nunca me disseste nada e só agora tenho conhecimento disso»."
,"27":"Abraão tomou ovelhas e bois e deu-os a Abimelec; e os dois fizeram uma aliança."
,"28":"Abraão separou sete ovelhas do rebanho,"
,"29":"e Abimelec perguntou-lhe: «Para que servem estas sete ovelhas que separaste?»"
,"30":"Abraão respondeu: «Estas sete ovelhas, que recebeste da minha mão, são a prova de que fui eu quem abriu este poço»."
,"31":"Por isso, o lugar recebeu o nome de Bersabeia, porque os dois fizeram ali um juramento."
,"32":"Depois que fizeram aliança em Bersabeia, Abimelec e Ficol, chefe do seu exército, voltaram para a terra dos filisteus."
,"33":"Abraão plantou uma árvore em Bersabeia e invocou aí o nome de Javé, o Deus eterno."
,"34":"Abraão morou muito tempo na terra dos filisteus."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Depois destes acontecimentos, Deus pôs Abraão à prova, e disse-lhe: «Abraão, Abraão!» Ele respondeu: «Estou aqui»."
,"2":"Deus disse: «Toma o teu filho, o teu único filho Isaac, a quem amas, vai à terra de Moriá e oferece-o lá em holocausto, sobre uma montanha que Eu te vou indicar»."
,"3":"Abraão levantou-se cedo, preparou o jumento e levou consigo dois servos e seu filho Isaac. Partiu a lenha do holocausto e foi para o lugar que Deus lhe havia indicado."
,"4":"No terceiro dia, Abraão levantou os olhos e viu de longe o lugar."
,"5":"Então disse aos servos: «Ficai aqui com o jumento; eu e o menino vamos até lá, adoraremos a Deus e depois voltaremos para junto de vós»."
,"6":"Abraão pegou na lenha do holocausto e colocou-a às costas do filho Isaac, levando ele próprio nas mãos o fogo e a faca. E seguiram os dois juntos."
,"7":"Isaac disse ao pai: «Pai!». Abraão respondeu: «Sim, meu filho!» Isaac continuou: «Aqui estão o fogo e a lenha. Mas onde está o cordeiro para o holocausto?»"
,"8":"Abraão respondeu: «Deus providenciará o cordeiro para o holocausto, meu filho!» E continuaram a caminhar juntos."
,"9":"Quando chegaram ao lugar que Deus lhe indicara, Abraão construiu o altar, colocou a lenha, depois amarrou o filho e colocou-o sobre o altar, em cima da lenha."
,"10":"Abraão estendeu a mão e pegou na faca para imolar o filho."
,"11":"Nesse momento, o Anjo de Javé chamou-o lá do céu e disse: «Abraão! Abraão!» Ele respondeu: «Aqui estou!»"
,"12":"O Anjo continuou: «Não estendas a mão contra o menino! Não lhe faças nenhum mal! Agora sei que temes a Deus, pois não Me recusaste o teu filho único»."
,"13":"Abraão ergueu os olhos e viu um cordeiro, preso pelos chifres num arbusto; pegou no cordeiro e ofereceu-o em holocausto em lugar do filho."
,"14":"E Abraão deu a esse lugar o nome de «Javé providenciará». Assim ainda hoje se costuma dizer: «Sobre a montanha, Javé providenciará»."
,"15":"O Anjo de Javé chamou lá do céu pela segunda vez a Abraão,"
,"16":"dizendo: «Juro por Mim mesmo, palavra de Javé: porque Me fizeste isso, porque não Me recusaste o teu filho único,"
,"17":"abençoar-te-ei e multiplicarei os teus descendentes como as estrelas do céu e a areia da praia. Os teus descendentes conquistarão as cidades dos teus inimigos."
,"18":"Por meio da tua descendência, todas as nações da Terra serão abençoadas, porque Me obedeceste»."
,"19":"Abraão voltou para junto dos ser-vos, e juntos regressaram a Bersabeia. E Abraão ficou a morar em Bersabeia."
,"20":"Depois des-tes acontecimentos, comunicaram a Abraão que também Melca dera filhos a seu irmão Nacor:"
,"21":"Hus, o primogénito; Buz, irmão deste; Camuel, pai de Aram;"
,"22":"Cased, Azau, Feldas, Jedlad, Batuel."
,"23":"E Batuel gerou Rebeca. São os oito filhos que Melca deu a Nacor, irmão de Abraão."
,"24":"Nacor tinha uma concubina, chamada Roma, que também teve filhos: Tabé, Gaam, Taás e Maaca."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Sara viveu cento e vinte e sete anos,"
,"2":"e morreu em Cariat Arbe, hoje Hebron, na terra de Canaã. Abraão foi fazer luto e chorar por sua mulher."
,"3":"Depois deixou a sua defunta e falou assim aos filhos de Het:"
,"4":"«Sou um imigrante que reside entre vós. Dai-me um túmulo como propriedade, para eu enterrar a minha defunta»."
,"5":"Os filhos de Het responderam a Abraão:"
,"6":"«Meu senhor, escuta-nos! Tu és um príncipe de Deus entre nós; enterra a tua defunta no melhor dos nossos sepulcros. Nenhum de nós vai recusar-te a própria sepultura para a tua defunta!»"
,"7":"Abraão levantou-se, fez uma inclinação diante dos proprietários, os filhos de Het,"
,"8":"e disse-lhes: «Se estais de acordo que eu enterre a minha defunta, ouvi-me: intercedei por mim junto de Efron, filho de Seor,"
,"9":"a fim de que ele me ceda a gruta de Macpela, que lhe pertence e está no extremo do seu campo. Que ele ma entregue pelo preço que vale, diante de vós, para que seja minha propriedade sepulcral»."
,"10":"Ora, Efron estava sentado entre os filhos de Het. Então Efron, o heteu, respondeu a Abraão, diante dos heteus e dos que assistiam ao conselho:"
,"11":"«Não, meu senhor, ouve-me! Eu dou-te o campo e também a gruta que está nele. Dou-tos na presença dos filhos do meu povo. Enterra a tua defunta»."
,"12":"Abraão inclinou-se diante dos proprietários"
,"13":"e disse a Efron, na presença dos proprietários: «Se concordas, ouve-me: eu pagarei o preço do campo. Aceita o pagamento, e eu enterrarei a minha defunta»."
,"14":"Efron respondeu a Abraão:"
,"15":"«Meu senhor, ouve-me: o terreno vale quatro quilos de prata. O que significa isso para mim ou para ti? Enterra a tua defunta»."
,"16":"Abraão concordou com Efron. Pesou para Efron o dinheiro de que falara diante dos heteus: quatro quilos de prata, em uso no mercado."
,"17":"Então, o campo de Efron, que está em Macpela, diante de Mambré, o campo e a gruta que aí existe, e todas as árvores que estão dentro e ao redor do campo,"
,"18":"tornaram-se propriedade de Abraão, sendo testemunhas os heteus e os que assistiam ao conselho."
,"19":"Depois Abraão enterrou Sara, sua mulher, na gruta do campo de Macpela, diante de Mambré, hoje Hebron, na terra de Canaã."
,"20":"Foi assim que o campo e a gruta passaram dos filhos de Het para Abraão, como propriedade sepulcral."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Abraão estava velho, de idade avançada, e Javé tinha-o abençoado em tudo."
,"2":"Abraão disse ao servo mais velho da sua casa, que administrava todas as suas propriedades: «Põe a tua mão debaixo da minha coxa,"
,"3":"e jura por Javé, Deus do Céu e da Terra, que quando buscares esposa para o meu filho, não a escolherás entre as filhas dos cananeus, no meio dos quais moro."
,"4":"Mas irás à minha terra natal e nela escolherás uma esposa para o meu filho Isaac»."
,"5":"O servo perguntou: «E se a mulher não quiser vir comigo para esta terra, deverei levar o teu filho para o lugar de onde saíste?»"
,"6":"Abraão respondeu-lhe: «De modo nenhum, não leves o meu filho para lá."
,"7":"Javé, o Deus do Céu e da Terra, que me tirou da casa paterna e da minha terra natal e que jurou dar esta terra à minha descendência, Ele enviará o seu anjo diante de ti e poderás trazer de lá uma esposa para o meu filho."
,"8":"Se a mulher não quiser vir contigo, então ficarás livre do juramento. Mas em nenhum caso levarás o meu filho para lá»."
,"9":"O servo colocou a mão sob a coxa de Abraão, seu patrão, e jurou que assim faria."
,"10":"O servo tomou dez camelos do seu senhor e, levando consigo de tudo o que o seu patrão tinha de bom, pôs-se a caminho de Aram Naaraim, para a cidade de Nacor."
,"11":"Fez ajoelhar os camelos fora da cidade, perto do poço, à tarde, na hora em que as mulheres saem para tirar água."
,"12":"Então o servo pediu: «Javé, Deus do meu senhor Abraão, concede que o dia de hoje me seja favorável, e trata com amor o meu senhor Abraão."
,"13":"Vou ficar junto à fonte, quando as jovens da cidade saírem para buscar água."
,"14":"Direi a uma das jovens: 'Por favor, inclina o balde para que eu possa beber'. Aquela que disser: 'Bebe, e também vou dar de beber aos teus camelos', será essa a que destinaste para o teu servo Isaac. Assim saberei que tratas o meu patrão com amor»."
,"15":"Ainda ele não tinha acabado de falar, quando chegou Rebeca, filha de Batuel, filho de Melca, mulher de Nacor, irmão de Abraão. Ela trazia um balde ao ombro."
,"16":"Era uma jovem muito bela e virgem; não tinha tido relações com nenhum homem. Ela desceu à fonte, encheu o balde e subiu."
,"17":"O servo correu para ela e disse: «Por favor, deixa-me beber um pouco da água do teu balde»."
,"18":"Ela respondeu: «Bebe, meu senhor». E abaixou depressa o balde sobre o braço, e deu-lhe de beber."
,"19":"Quando terminou, ela disse: «Vou dar de beber também aos teus camelos, até que fiquem saciados»."
,"20":"Em seguida, esvaziou o balde no bebedouro e correu até ao poço a fim de tirar água para todos os camelos."
,"21":"O servo observava-a em silêncio, para saber se Javé ia levar ou não a bom termo a sua missão."
,"22":"Quando os camelos acabaram de beber, o servo pegou num anel de ouro que pesava cinco gramas e colocou-o nas narinas dela. Depois, colocou nos braços dela dois braceletes de ouro, que pesavam dez gramas."
,"23":"E disse à jovem: «De quem és filha? Diz-me: será que na casa de teu pai haverá lugar para eu passar a noite?»"
,"24":"Ela respondeu: «Eu sou filha de Batuel, o filho que Melca gerou a Nacor»."
,"25":"E continuou: «Em nossa casa há muita palha e forragem, e também lugar para passar a noite»."
,"26":"Então o servo prostrou-se e adorou a Javé,"
,"27":"dizendo: «Bendito seja Javé, o Deus do meu senhor Abraão! Ele não esqueceu o seu amor e fidelidade para com o meu senhor. Javé guiou os meus passos até à casa do irmão do meu senhor»."
,"28":"A jovem correu para casa, a fim de contar à mãe o que lhe havia acontecido."
,"29":"Ora, Rebeca tinha um irmão chamado Labão, que correu para a fonte ao encontro do homem."
,"30":"De facto, quando Labão viu o anel e os braceletes que a irmã trazia, e quando ouviu o que ela contava, foi ao encontro do homem e encontrou-o ainda de pé junto aos camelos, perto da fonte."
,"31":"Então disse-lhe: «Vem, bendito de Javé. Porque estás aí fora, quando já preparei alojamento e lugar para os camelos?»"
,"32":"O homem entrou em casa, e Labão descarregou os camelos, deu palha e forragem aos camelos, e levou água para que o servo e seus acompanhantes lavassem os pés."
,"33":"Quando lhe ofereceram de comer, o servo disse: «Não vou comer enquanto não tratar do meu assunto». Labão respondeu: «Então fala»."
,"34":"O servo disse: «Eu sou servo de Abraão."
,"35":"Javé abençoou imensamente o meu senhor e tornou-o rico: deu-lhe ovelhas e vacas, prata e ouro, escravos e escravas, camelos e jumentos."
,"36":"Sara, a mulher do meu senhor, já velha, deu-lhe um filho, que é o herdeiro de tudo."
,"37":"O meu senhor fez-me prestar este juramento: 'Não tomarás para o meu filho uma esposa entre as filhas dos cananeus, em cuja terra moro."
,"38":"Irás à casa de meu pai e de meus parentes, e aí escolherás uma esposa para o meu filho'."
,"39":"Então eu disse ao meu senhor: 'E se a mulher não quiser vir comigo?'"
,"40":"Ele respondeu-me: 'Javé, a quem o meu comportamento agrada, vai enviar contigo o seu anjo; Ele fará que a tua missão tenha êxito, e encontrarás uma esposa para o meu filho na casa de meus pais e parentes."
,"41":"Ficarás livre do juramento quando chegares à casa dos meus parentes; sim, ficarás livre do juramento, se eles negarem a mulher'."
,"42":"Hoje eu cheguei à fonte e disse: 'Javé, Deus do meu senhor Abraão, peço-Te que me mostres se estás disposto a levar a bom termo a viagem que empreendi."
,"43":"Aqui estou junto à fonte, e vou dizer à jovem que vier buscar água: Dá-me de beber um pouco da água do teu balde."
,"44":"Se ela me disser: Bebe, e também vou tirar água para os teus camelos, então será essa a esposa que Javé destinou ao filho do meu senhor'."
,"45":"Ainda eu não tinha acabado de falar comigo mesmo, quando chegou Rebeca com o balde ao ombro. Ela desceu à fonte e tirou água. Eu pedi-lhe: 'Por favor, dá-me de beber'."
,"46":"Ela baixou logo o balde e disse: 'Bebe, e também vou dar de beber aos teus camelos'. Eu bebi, e ela deu de beber também aos meus camelos."
,"47":"Então eu perguntei-lhe: 'De quem és filha?' Ela respondeu: 'Sou filha de Batuel, o filho que Melca deu a Nacor'. Então eu pus-lhe este anel nas narinas e estes braceletes nos braços."
,"48":"Prostrei-me, adorei Javé, bendisse a Javé, Deus do meu senhor Abraão, que me guiou pelo caminho certo, para levar ao filho do meu senhor a filha do irmão dele."
,"49":"Portanto, dizei-me se quereis ou não mostrar amor e fidelidade ao meu senhor, para que eu possa agir em conformidade»."
,"50":"Labão e Batuel disseram: «Isto vem de Javé, e nós não podemos dizer nem sim, nem não."
,"51":"Aqui está Rebeca, toma-a e parte, e que ela seja a esposa do filho do teu senhor, conforme disse Javé»."
,"52":"Quando o servo de Abraão ouviu isto, prostrou-se por terra diante de Javé."
,"53":"Depois pegou em jóias de prata e ouro, e vestidos, e deu-os a Rebeca. Também deu ricos presentes ao irmão e à mãe dela."
,"54":"Então comeram e beberam, ele e os seus companheiros, e passaram a noite. De manhã, quando se levantaram, o servo disse: «Permite que regresse à casa do meu senhor»."
,"55":"Então o irmão e a mãe de Rebeca disseram: «Deixa que a jovem fique ainda dez dias connosco. Depois, ela irá»."
,"56":"Mas o servo replicou: «Não me detenhais, pois Javé deu êxito à minha viagem. Deixai-me voltar para o meu senhor»."
,"57":"Então eles disseram: «Vamos chamar a jovem e perguntar-lhe a sua opinião»."
,"58":"Chamaram Rebeca e perguntaram-lhe: «Queres partir com este homem?» Ela respondeu: «Quero»."
,"59":"Então eles deixaram partir a sua irmã Rebeca com a sua ama, o servo de Abraão e os seus homens."
,"60":"Eles abençoaram Rebeca, dizendo: «És nossa irmã: torna-te mãe de milhares de milhares, e que a tua descendência conquiste as cidades inimigas»."
,"61":"Rebeca e as suas servas levantaram-se, montaram nos camelos e acompanharam o homem. E foi assim que o servo de Abraão levou Rebeca."
,"62":"Isaac tinha voltado do poço de Laai-Roí e morava na terra de Negueb."
,"63":"Ao pôr do Sol, Isaac saiu para passear no campo e, erguendo os olhos, viu que chegavam camelos."
,"64":"Rebeca, erguendo os olhos, viu Isaac. Ela apeou-se do camelo,"
,"65":"e disse ao servo: «Quem é aquele homem lá no campo, que vem ao nosso encontro?» O servo respondeu: «É o meu senhor». Então ela pegou no véu e cobriu-se."
,"66":"O servo contou a Isaac tudo o que havia feito."
,"67":"Então Isaac introduziu Rebeca na sua tenda e recebeu-a por esposa. Isaac amou-a, consolando-se assim da morte de sua mãe."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Abraão tomou outra mulher chamada Cetura."
,"2":"Esta gerou-lhe Zamrã, Jecsã, Madã, Madia, Jesboc e Sué."
,"3":"Jecsã gerou Sabá e Dadã, e os filhos de Dadã foram os assurim, os latusim e os loomim."
,"4":"Os filhos de Madiã foram: Efa, Ofer, Henoc, Abida e Eldaá. Todos estes são descendentes de Cetura."
,"5":"Abraão deu todos os seus bens a Isaac."
,"6":"Quanto aos filhos das suas concubinas, Abraão deu-lhes presentes e, ainda em vida, mandou-os para longe do seu filho Isaac, para Leste, a região oriental."
,"7":"Abraão viveu cento e setenta e cinco anos."
,"8":"Depois Abraão expirou e morreu numa velhice feliz, idoso, e foi reunir-se aos seus parentes."
,"9":"Isaac e Ismael, seus filhos, sepultaram-no na gruta de Macpela, no campo de Efron, filho de Seor, o heteu, campo que está diante de Mambré."
,"10":"É o campo que Abraão tinha comprado aos filhos de Het; nele foram enterrados Abraão e sua mulher Sara."
,"11":"Depois da morte de Abraão, Deus abençoou o seu filho Isaac. E Isaac morou junto ao poço de Laai-Roí."
,"12":"São estes os descendentes de Ismael, filho de Abraão e Agar, a escrava egípcia de Sara."
,"13":"Nomes dos filhos de Ismael por ordem de nascimento: o primogénito Nabaiot, depois Cedar, Adbeel, Mabsam,"
,"14":"Masma, Duma, Massa,"
,"15":"Hadad, Tema, Jetur, Nafis e Cedma."
,"16":"São estes os filhos de Ismael e seus nomes por aldeias e acampamentos: doze chefes de tribos."
,"17":"Ismael viveu cento e trinta e sete anos. Depois expirou, morreu e foi reunir-se aos seus parentes."
,"18":"Habitou desde Hévila até Sur, que está a Leste do Egipto, na direcção da Assíria. Ele estabeleceu-se diante de todos os seus irmãos."
,"19":"História de Isaac, filho de Abraão. Abraão gerou Isaac."
,"20":"Isaac tinha quarenta anos quando se casou com Rebeca, filha de Batuel, o arameu de Padã-Aram, e irmã de Labão, o arameu."
,"21":"Isaac implorou a Javé por sua mulher, porque ela era estéril: Javé escutou-o e a sua mulher Rebeca ficou grávida."
,"22":"As crianças, porém, lutavam dentro dela. Então ela disse: «Se é assim, para quê viver?» Então foi consultar Javé."
,"23":"E Javé disse-lhe: «No teu ventre há duas nações, dois povos separam-se nas tuas entranhas. Um povo vencerá o outro, e o mais velho servirá ao mais novo»."
,"24":"Quando chegou o dia do parto, Rebeca teve gémeos."
,"25":"O primeiro saiu: era ruivo e peludo como um manto de pêlos, e deram-lhe o nome de Esaú."
,"26":"Em seguida, saiu seu irmão, segurando com a mão o calcanhar de Esaú, e deram-lhe o nome de Jacob. Isaac tinha sessenta anos quando eles nasceram."
,"27":"Os meninos cresceram. Esaú tornou-se hábil caçador, homem rude, enquanto Jacob era homem tranquilo, morando em tendas."
,"28":"Isaac apreciava a caça e preferia Esaú, enquanto Rebeca preferia Jacob."
,"29":"Certo dia, Jacob estava a preparar um guisado, quando Esaú voltou do campo, esgotado."
,"30":"Esaú pediu a Jacob: «Deixa-me comer dessa coisa vermelha, porque estou esgotado». É por isso que ele recebeu o nome de Edom."
,"31":"Jacob respondeu: «Vende-me primeiro o direito de primogenitura»."
,"32":"Esaú disse: «Estou quase a morrer de fome... Que me importa o direito de primogenitura?»"
,"33":"Jacob disse-lhe: «Primeiro, o juramento». Esaú jurou e vendeu o seu direito de primogenitura a Jacob."
,"34":"Então Jacob deu-lhe pão e o guisado de lentilhas. Esaú comeu e bebeu, levantou-se e partiu. E assim Esaú desprezou o direito de primogenitura."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Houve fome no país - além daquela que tinha havido no tempo de Abraão - e Isaac foi para Gerara, onde Abimelec era rei dos filisteus."
,"2":"Javé apareceu a Isaac e disse: «Não desças ao Egipto; fica na terra que Eu te indicar."
,"3":"Fica a morar neste país, e Eu estarei contigo e abençoar-te-ei, pois Eu darei todas estas terras a ti e aos teus descendentes, cumprindo o juramento que fiz a teu pai Abraão."
,"4":"Tornarei a tua descendência tão numerosa como as estrelas do céu, e darei aos teus descendentes todas estas terras. Por meio da tua descendência, serão abençoadas todas as nações da Terra,"
,"5":"porque Abraão me obedeceu, observou os meus preceitos e mandamentos, os meus estatutos e leis»."
,"6":"Então Isaac ficou em Gerara."
,"7":"Os homens do lugar fizeram perguntas a Isaac sobre Rebeca. Isaac respondeu: «É minha irmã». Ele ficou com medo de dizer que era sua mulher, pois pensava: «Os homens deste lugar poderão matar-me por causa de Rebeca, pois ela é muito bonita»."
,"8":"Já havia muito tempo que Isaac se encontrava ali, quando Abimelec, rei dos filisteus, olhou certo dia pela janela e viu Isaac acariciando a esposa Rebeca."
,"9":"Abimelec chamou Isaac e disse: «É claro que ela é tua mulher! Porque disseste que era tua irmã?» Isaac respondeu: «Porque pensei que me iam matar por causa dela»."
,"10":"Abimelec continuou: «Porque fizeste isso? Por pouco alguém do povo dormiria com a tua mulher, e tornar-nos-ia a todos culpados!»"
,"11":"Então Abimelec deu esta ordem a todo o povo: «Quem tocar neste homem ou na sua mulher, morrerá»."
,"12":"Isaac semeou aquela terra e, nesse ano, colheu o cêntuplo. Javé abençoou-o"
,"13":"e ele foi ganhando muito, até ficar muito rico."
,"14":"Tinha rebanhos de bois e ovelhas e numerosos servos. Por causa disso, os filisteus ficaram com inveja."
,"15":"Os filisteus haviam entulhado e coberto de terra todos os poços que os servos de Abraão, pai de Isaac, haviam aberto no tempo de Abraão."
,"16":"Abimelec disse a Isaac: «Vai-te embora daqui, porque ficaste mais poderoso do que nós»."
,"17":"Isaac foi-se embora dali, acampou no vale de Gerara, e ali se estabeleceu."
,"18":"Abriu de novo os poços que os servos de seu pai Abraão haviam aberto e que os filisteus tinham entulhado depois da morte de Abraão, e deu-lhes os mesmos nomes que seu pai lhes havia dado."
,"19":"Os servos de Isaac fizeram escava-ções no vale e encontraram uma nascente."
,"20":"Mas os pastores de Gerara altercaram com os pastores de Isaac, dizendo: «Esta água é nossa!» Isaac então deu a esse poço o nome de Desafio, pois altercavam por causa dele."
,"21":"Cavaram outro poço, e também altercaram por causa dele. A este, Isaac deu-lhe o nome de Rivalidade."
,"22":"Então partiu dali e abriu ou-tro poço; e, como não houve desavenças por causa deste, deu-lhe o nome de Campo Livre, dizendo: «Agora Javé deu-nos o campo livre para que prosperemos na terra»."
,"23":"Dali, Isaac subiu para Bersabeia."
,"24":"Nessa noite, Javé apareceu-lhe e disse-lhe: «Eu sou o Deus do teu pai Abraão. Não tenhas medo, pois estou contigo. Abençoar-te-ei e multiplicarei os teus descendentes, em atenção ao meu servo Abraão»."
,"25":"Isaac erigiu ali um altar, invocou o nome de Javé, e armou a sua tenda. E os seus servos começaram a abrir um poço."
,"26":"Abimelec, juntamente com Ocozat, seu conselheiro, e Ficol, chefe do seu exército, foi de Gerara para visitar Isaac."
,"27":"E Isaac disse-lhes: «Que viestes fazer aqui, vós que me odiais e me expulsastes?»"
,"28":"Eles responderam: «Vimos que Javé está contigo, e combinámos fazer um juramento e uma aliança entre nós e ti."
,"29":"Jura que não nos farás nenhum mal, assim como nós não te tratámos mal e te deixámos partir em paz. Agora és um abençoado de Javé»."
,"30":"Isaac preparou um banquete; comeram e beberam."
,"31":"Levantaram-se de madrugada e fizeram um juramento mútuo. Depois Isaac despediu-os, e eles deixaram-no em paz."
,"32":"Nesse dia, os servos de Isaac leva-ram-lhe notícias do poço que tinham aberto, e disseram: «Encontrámos água»."
,"33":"Isaac deu ao poço o nome de Seba, de onde vem o nome Bersabeia, até ao dia de hoje."
,"34":"Quando Esaú completou quarenta anos, tomou como esposas Judite, filha de Beeri, o heteu, e Basemat, filha de Elon, o heteu."
,"35":"Elas foram causa de amargura para Isaac e Rebeca."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Isaac ficou velho, e os seus olhos enfraqueceram-se, a tal ponto que já não via nada. Então chamou o seu filho mais velho, Esaú: «Meu filho!» Esaú respondeu: «Estou aqui»."
,"2":"Isaac continuou: «Como vês, estou velho e não sei quando vou morrer."
,"3":"Agora toma as tuas armas, as tuas flechas e o arco, vai ao campo e traz-me alguma caça."
,"4":"Prepara-me um bom guisado, como eu gosto, e traz-mo para eu comer, e antes de morrer te abençoe»."
,"5":"Rebeca ouviu tudo o que Isaac dizia a seu filho Esaú. E Esaú saiu para o campo a fim de caçar alguma coisa para seu pai."
,"6":"Rebeca disse a seu filho Jacob: «Ouvi teu pai dizer ao teu irmão Esaú:"
,"7":"'Traz-me alguma caça e faz-me um bom guisado, para eu comer e te abençoar diante de Javé, antes de morrer'."
,"8":"Agora, escuta-me e faz o que eu mandar."
,"9":"Vai ao rebanho e traz-me dois cabritos gordos. Vou preparar para teu pai um prato do modo que ele gosta."
,"10":"Depois levarás o prato a teu pai, para ele comer e te abençoar antes de morrer»."
,"11":"Jacob disse à mãe Rebeca: «Mas meu irmão Esaú é peludo e a minha pele é lisa!"
,"12":"Se meu pai me tocar, ele vai perceber que quis enganá-lo e, em vez de bênção, atrairei maldição sobre mim»."
,"13":"Mas a mãe respondeu-lhe: «Meu filho, que a maldição dele caia sobre mim. Obedece-me, vai e traz-me os cabritos»."
,"14":"Jacob foi buscar os cabritos e levou-os à sua mãe. Ela preparou um bom prato, do modo que Isaac gostava."
,"15":"Rebeca pegou nas melhores roupas que Esaú, o filho mais velho, tinha em casa, e com elas vestiu Jacob, seu filho mais novo."
,"16":"Então cobriu-lhe os braços e a parte lisa do pescoço com a pele dos cabritos."
,"17":"Depois colocou nas mãos do seu filho Jacob o pão e o prato que ela havia preparado."
,"18":"Então Jacob foi ter com o pai e disse-lhe: «Pai!» Isaac respondeu: «Aqui estou. Quem és tu, meu filho?»"
,"19":"Jacob respondeu ao pai: «Sou Esaú, o teu primogénito. Fiz o que me mandaste. Le-vanta-te, senta-te e come da minha caça. Depois, abençoar-me-ás»."
,"20":"Isaac disse a Jacob: «Como é que encontraste caça tão depressa, meu filho?» Jacob respondeu: «É que Javé, o teu Deus, colocou-a ao meu alcance»."
,"21":"Isaac disse a Jacob: «Aproxima-te, meu filho, para que eu te apalpe e veja se és ou não o meu filho Esaú»."
,"22":"Jacob aproximou-se do pai Isaac, que o apalpou e disse: «A voz é de Jacob, mas os braços são de Esaú»."
,"23":"Isaac não reconheceu Jacob, porque os braços dele estavam peludos como os do seu irmão Esaú. Então dispôs-se a abençoá-lo."
,"24":"Mas voltou a perguntar-lhe: «És, na verdade, o meu filho Esaú?» Jacob respondeu: «Sou»."
,"25":"Isaac continuou: «Serve-me a tua caça, meu filho, para que eu coma e depois te abençoe». Jacob ser-viu-o e Isaac comeu; apresentou-lhe vinho, e ele bebeu."
,"26":"Então seu pai Isaac disse-lhe: «Meu filho, aproxima-te e beija-me»."
,"27":"Jacob aproximou-se e beijou o pai, que lhe aspirou o perfume das roupas. E abençoou-o, dizendo: «Sim, o perfume do meu filho é como o perfume de um campo fértil que Javé abençoou."
,"28":"Que Deus te dê o orvalho do céu e a fertilidade da terra, trigo e vinho em abundância."
,"29":"Que os povos te sirvam e as nações se prostrem diante de ti. Sê o senhor dos teus irmãos, e os filhos de tua mãe prostrem-se diante de ti. Maldito seja quem te amaldiçoar, e bendito seja quem te abençoar»."
,"30":"Logo que Isaac acabou de abençoar Jacob e este saiu de junto do pai, o irmão Esaú voltou da caça."
,"31":"Também ele preparou um prato saboroso e levou-o ao pai, dizendo-lhe: «Meu pai, levanta-te e come da caça de teu filho, e depois abençoa-me»."
,"32":"Isaac, seu pai, perguntou-lhe: «Quem és tu?» Ele respondeu: «Sou Esaú, o teu filho primogénito!»"
,"33":"Então Isaac estremeceu emocionado, e disse: «Então, quem foi que veio e me trouxe a caça? Eu comi-a antes de tu chegares, abençoei-o, e abençoado ficará»."
,"34":"Quando Esaú ouviu as palavras do pai, deu um forte grito e, cheio de amargura, disse ao pai: «Abençoa-me também, meu pai!»"
,"35":"Mas Isaac respondeu: «O teu irmão veio com astúcia e recebeu a bênção que te cabia»."
,"36":"Esaú disse: «Com razão ele se chama Jacob: é a segunda vez que ele me engana! Apoderou-se do meu direito de primogenitura e agora roubou a minha bênção». E acrescentou: «Não reservaste nenhuma bênção para mim?»"
,"37":"Isaac respondeu a Esaú: «Eu fiz de Jacob o teu senhor, dei-lhe todos os seus irmãos como servos e garanti-lhe trigo e vinho. Que posso fazer por ti agora, meu filho?»"
,"38":"Esaú disse ao pai: «Tens só uma bênção, meu pai? Abençoa-me também a mim, meu pai!» Isaac ficou em silêncio e Esaú chorou em voz alta."
,"39":"Isaac então disse-lhe: «A tua morada será longe da terra fértil e sem o orvalho que desce do céu."
,"40":"Viverás da tua espada e servirás o teu irmão. Mas quando te revoltares, sacudirás o jugo do teu pescoço»."
,"41":"Esaú co-meçou a odiar Jacob, por causa da bênção que seu pai lhe dera. E dizia a si mesmo: «Quando chegar o luto por meu pai, vou matar o meu irmão Jacob»."
,"42":"Contaram a Rebeca o que o seu filho mais velho Esaú andava a dizer. Então ela mandou chamar Jacob, o filho mais novo, e disse-lhe: «O teu irmão Esaú quer matar-te para se vingar."
,"43":"Portanto, meu filho, ouve bem: foge para Harã, para junto do meu irmão Labão."
,"44":"Fica com ele algum tempo, até que passe a raiva do teu irmão,"
,"45":"até que a cólera do teu irmão se desvie de ti e esqueça o que lhe fizeste. Depois eu mandar-te-ei buscar. Não quero perder os meus dois filhos num só dia»."
,"46":"Rebeca disse a Isaac: «Estas mulheres heteias tornam-me a vida insuportável. Se também Jacob casar com mulheres heteias deste país, de que me adianta viver?»"
}`)
	CurrentBook.AddChapter(28, `{
"1":"Isaac chamou Jacob, abençoou-o e deu-lhe esta ordem: «Não te cases com mulher cananeia."
,"2":"Vai até Padã-Aram, à casa de Batuel, teu avô materno, e escolhe uma mulher de lá, entre as filhas de Labão, teu tio materno."
,"3":"Que o Deus Todo-poderoso te abençoe, te torne fecundo e te multiplique, a fim de que te tornes uma imensidade de povos."
,"4":"Que Ele te conceda e à tua descendência a bênção de Abraão, a fim de que possuas a terra onde vives e que Deus deu a Abraão»."
,"5":"Isaac despediu Jacob, e este partiu para Padã-Aram, para a casa de Labão, filho do arameu Batuel, e irmão de Rebeca, mãe de Jacob e de Esaú."
,"6":"Esaú viu que Isaac tinha abençoado Jacob e o tinha mandado a Padã-Aram, para lá encontrar uma esposa, e que o tinha abençoado, dando esta ordem: «Não te cases com uma cananeia»."
,"7":"E Jacob obedeceu a seu pai e a sua mãe, e partiu para Padã-Aram."
,"8":"Esaú soube que as cananeias eram malvistas por seu pai Isaac."
,"9":"Foi, então, à casa de Ismael e tomou como esposa, além das que possuía, Maelet, filha de Ismael, filho de Abraão, e irmã de Nabaiot."
,"10":"Jacob deixou Bersabeia e partiu para Harã."
,"11":"Che-gou a certo lugar e resolveu passar ali a noite, porque o Sol já se havia posto. Jacob pegou numa pedra do lugar, colocou-a sob a cabeça, e adormeceu."
,"12":"Teve então um sonho: Uma escada erguia-se da Terra e chegava até ao Céu, e os anjos de Deus subiam e desciam por ela."
,"13":"Javé estava de pé, no alto da escada, e disse a Jacob: «Eu sou Javé, o Deus de teu pai Abraão e o Deus de Isaac. A terra sobre a qual adormeceste, entrego-a a ti e à tua descendência."
,"14":"A tua descendência tornar-se-á numerosa como o pó da terra e tu ocuparás o Oriente e o Ocidente, o Norte e o Sul. E todas as nações da Terra serão abençoadas por meio de ti e da tua descendência."
,"15":"Eu estou contigo e proteger-te-ei para onde quer que vás. Depois reconduzir-te-ei a esta terra, pois nunca te abandonarei, até cumprir o que prometi»."
,"16":"Ao despertar, Jacob disse: «De facto, Javé está neste lugar e eu não o sabia»."
,"17":"Ficou com medo, e disse: «Este lugar é terrível. Não é nada menos que a Casa de Deus e a Porta do Céu»."
,"18":"Levantou-se de madrugada, pegou na pedra que lhe havia servido de travesseiro, ergueu-a como estela e derramou óleo sobre ela."
,"19":"E chamou a esse lugar Betel. Mas antes a cidade chamava-se Luza."
,"20":"Jacob fez, então, este voto: «Se Deus estiver comigo e me proteger no caminho por onde eu for, se me der pão para comer e roupa para vestir,"
,"21":"se eu voltar são e salvo para a casa do meu pai, então Javé será o meu Deus."
,"22":"E esta pedra que ergui como estela será uma casa de Deus, e eu dar-Te-ei a décima parte de tudo o que me deres»."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Jacob seguiu viagem e foi para a terra dos orientais."
,"2":"Em certo campo, viu um poço e, deitados perto dele, três rebanhos de ovelhas, pois os rebanhos costumavam beber nesse poço. A pedra que tapava o poço era grande,"
,"3":"de modo que só quando ali se reuniam todos os rebanhos é que os pastores tiravam a pedra da boca do poço, davam de beber aos rebanhos e tornavam a tapar o poço, colocando a pedra no lugar."
,"4":"Jacob perguntou aos pastores: «Irmãos, de onde sois?» Eles responderam: «Nós somos de Harã»."
,"5":"Jacob perguntou: «Conheceis Labão, filho de Nacor?» Eles responderam: «Conhecemos»."
,"6":"Jacob perguntou: «Co-mo é que ele está?» Eles responderam: «Ele está bem. Vê! Raquel, sua filha, está a chegar com o rebanho»."
,"7":"Jacob disse: «Ainda é pleno dia e não é hora de recolher o rebanho. Porque não dais de beber às ovelhas e as deixais pastar?»"
,"8":"Eles responderam: «Não podemos fazer isso antes que se reúnam todos os rebanhos. Só então é que tiramos a pedra, destapamos o poço e damos de beber às ovelhas»."
,"9":"Ainda estava Jacob a conversar com eles, quando Raquel chegou com o rebanho de seu pai, pois era pastora."
,"10":"Logo que Jacob viu Raquel, a filha de seu tio Labão, e as ovelhas de Labão, aproximou-se, tirou a pedra da boca do poço e deu de beber ao rebanho de seu tio."
,"11":"Jacob deu um beijo a Raquel e depois começou a chorar."
,"12":"Então contou a Raquel que ele era parente do pai dela e filho de Rebeca."
,"13":"Ao saber que se tratava do seu sobrinho Jacob, Labão correu ao encontro dele, abraçou-o, cobriu-o de beijos e levou-o para sua casa. Então Jacob contou a Labão tudo o que havia acontecido."
,"14":"E Labão disse-lhe: «É claro que tu és da minha carne e do meu sangue». E Jacob ficou um mês com ele."
,"15":"Labão disse a Jacob: «O facto de seres meu parente não é motivo para me servires de graça. Diz-me qual deve ser o teu salário»."
,"16":"Ora, Labão tinha duas filhas: a mais velha chamava-se Lia, e a mais nova Raquel."
,"17":"Os olhos de Lia eram meigos, porém Raquel tinha um belo porte e um rosto lindo."
,"18":"E Jacob amou Raquel. Então Jacob disse a Labão: «Servir-te-ei durante sete anos em troca da tua filha mais nova, Raquel»."
,"19":"Labão respondeu: «É melhor dá-la a ti do que a outro qualquer. Fica comigo»."
,"20":"Jacob serviu sete anos por Raquel, e estava tão apaixonado que os anos lhe pareceram dias."
,"21":"Depois Jacob disse a Labão: «Terminou o prazo: dá-me a mi-nha mulher, para que eu viva com ela»."
,"22":"Labão reuniu todos os homens do lugar, e ofereceu-lhes um banquete."
,"23":"À noite, pegou na filha Lia, e levou-a a Jacob. E Jacob dormiu com ela."
,"24":"Labão deu a sua serva Zelfa como serva à sua filha Lia."
,"25":"Na manhã seguinte, Jacob descobriu que era Lia, e disse a Labão: «O que fizeste comigo? Não foi por Raquel que eu te servi? Porque me enganaste?»"
,"26":"Labão respondeu: «Nesta terra não é costume que a mais nova se case antes da mais velha."
,"27":"Termina esta semana de núpcias, e eu te darei também a outra em troca do serviço que me farás durante outros sete anos»."
,"28":"Jacob aceitou. Terminou a semana de núpcias, e Labão deu-lhe sua filha Raquel como mulher."
,"29":"Labão deu sua serva Bala como serva à sua filha Raquel."
,"30":"Jacob uniu-se a Raquel, e amou Raquel mais do que a Lia. E serviu em casa de seu tio outros sete anos."
,"31":"Vendo que Lia era desprezada, Javé tornou-a fecunda, enquanto que Raquel permanecia estéril."
,"32":"Lia concebeu e deu à luz um fi-lho e deu-lhe o nome de Rúben, pois dizia: «Javé olhou para a minha aflição e agora o meu marido amar-me-á»."
,"33":"Tornou a conceber e deu à luz um filho, e disse: «Javé ouviu que eu não era amada e deu-me este outro». E chamou-lhe Simeão."
,"34":"Concebeu outra vez e deu à luz um filho, e disse: «Desta vez o meu marido sentir-se-á ligado a mim, porque lhe dei três filhos». E ela chamou-lhe Levi."
,"35":"Concebeu outra vez e deu à luz um filho, e disse: «Desta vez dou graças a Javé». E, por isso, chamou-lhe Judá. Depois deixou de ter filhos."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Vendo que não dava filhos a Jacob, Raquel ficou com inveja da sua irmã e disse a Jacob: «Ou me dás fi-lhos ou eu morro»."
,"2":"Jacob ficou irritado com Raquel, e disse: «Acaso sou eu Deus para te negar a maternidade?»"
,"3":"Raquel respondeu: «Aqui está a minha serva Bala. Une-te a ela, para que ela dê à luz sobre os meus joelhos. Assim terei filhos por meio dela»."
,"4":"Então Raquel deu-lhe a sua serva Bala como mulher, e Jacob uniu-se a Bala."
,"5":"Bala concebeu e deu à luz um filho a Jacob."
,"6":"Raquel disse: «Deus fez-me justiça; ouviu a minha voz e deu-me um filho». Por isso, chamou-lhe Dã."
,"7":"Bala, a serva de Raquel, concebeu outra vez e gerou um segundo filho a Jacob."
,"8":"Raquel disse: «Deus fez-me competir com minha irmã, e eu venci». E ela chamou-lhe Neftali."
,"9":"Lia, vendo que não tinha mais filhos, tomou a sua serva Zelfa, e deu-a por esposa a Jacob."
,"10":"Zelfa, a serva de Lia, gerou um filho a Jacob."
,"11":"Lia disse: «Que sorte!» E ela chamou-lhe Gad."
,"12":"Zelfa, a serva de Lia, gerou um segundo filho a Jacob."
,"13":"Lia disse: «Que felicidade! As mulheres felicitar-me-ão». E chamou-lhe Aser."
,"14":"Um dia, durante a ceifa do trigo, Rú-ben saiu para o campo, encontrou mandrágoras, e levou-as à sua mãe Lia. Raquel disse a Lia: «Dá-me parte das mandrágoras do teu filho»."
,"15":"Lia respondeu-lhe: «Achas pouco teres-me tirado o marido? Agora queres também as mandrágoras do meu filho?» Raquel respondeu: «Pois bem! Que ele durma esta noite contigo, em troca das mandrágoras do teu filho»."
,"16":"Quando, à tarde, Jacob voltou do campo, Lia foi ao seu encontro e disse-lhe: «Vem dormir comigo, pois com as mandrágoras do meu filho comprei o direito de dormir contigo». E Jacob dormiu com Lia nessa noite."
,"17":"Deus ouviu Lia: ela concebeu e gerou um quinto filho a Jacob."
,"18":"E Lia disse: «Deus pagou o meu salário, por ter dado a minha serva ao meu marido». E chamou-lhe Issacar."
,"19":"Lia concebeu mais uma vez e gerou um sexto filho a Jacob."
,"20":"E Lia disse: «Deus fez-me um grande presente! Agora dominarei o meu marido, pois lhe dei seis filhos». E chamou-lhe Zabulon."
,"21":"Em seguida, Lia deu à luz uma filha, e chamou-lhe Dina."
,"22":"Então Deus lembrou-se de Raquel. Deus ouviu-a e tornou-a fecunda."
,"23":"Raquel concebeu e deu à luz um filho. E disse: «Deus retirou a minha vergonha»."
,"24":"Ela chamou-lhe José, dizendo: «Que Javé me dê mais um»."
,"25":"Quando Ra-quel deu à luz José, Jacob disse a Labão: «Deixa-me partir para a minha casa e para meus pais."
,"26":"Dá-me as minhas mulheres, pelas quais te servi, e meus filhos, que eu ir-me-ei embora, pois tu sabes com quanto zelo te servi»."
,"27":"Labão disse-lhe: «Que pena! Vim a saber por um oráculo que Javé me abençoou por tua causa»."
,"28":"E acrescentou: «Diz agora que salário queres e eu pagarei»."
,"29":"Jacob respondeu: «Tu sabes como te servi e como os teus bens se multiplicaram comigo."
,"30":"O pouco que possuías antes de mim cresceu imensamente, porque Javé te abençoou por minha causa. Agora, já é tempo de eu fazer alguma coisa pela minha família»."
,"31":"Labão perguntou: «Quanto te devo pagar?» Jacob respondeu: «Não precisas de me pagar nada. Faz apenas o seguinte: eu voltarei a pasto-rear e guardar o teu rebanho."
,"32":"Hoje vou passar pelo meio do teu rebanho; separa todo o animal negro entre os cordeiros e o que é malhado ou pintado entre as cabras. Esse vai ser o meu salário,"
,"33":"e a minha honestidade testemunhará por mim no futuro: quando chegar o momento de me pagares, tudo o que não for pintado ou malhado entre as cabras ou negro entre os cordeiros, é porque eu os roubei»."
,"34":"Labão disse: «Está bem, seja como propões»."
,"35":"Nesse dia, Labão separou os bodes listrados e malhados, todas as cabras ma-lhadas ou com manchas brancas, e todos os cordeiros negros. Labão entregou-os a seus filhos,"
,"36":"e mandou-os levar a três dias de caminhada de onde Jacob estava. Entretanto Jacob ficou apascentando o resto do rebanho de Labão."
,"37":"Jacob tomou varas verdes de álamo, de amendoeira e de plátano, descascou-as em tiras brancas, deixando aparecer a parte branca das varas."
,"38":"Em seguida, colocou as varas assim descascadas nos bebe-douros diante do rebanho, onde as ove-lhas costumavam beber água, para que os machos cobrissem as fêmeas quando fossem beber água."
,"39":"Os animais acasalavam-se diante das varas e pariam crias listradas, pintadas e malhadas."
,"40":"Quanto aos cordeiros, Jacob separou-os e virou o rebanho para o lado dos listrados e de tudo o que era negro no rebanho de Labão. Deste modo, ele separou os seus rebanhos e não os juntou ao rebanho de Labão."
,"41":"Além disso, cada vez que os animais robustos se acasalavam, Jacob colocava as varas nos bebedouros diante dos animais, para que eles se acasalassem diante das varas."
,"42":"Quando os animais eram fracos, Jacob não colocava as varas, de modo que ficavam para Labão os cordeiros fracos, e os robustos ficavam para Jacob."
,"43":"Deste modo, Jacob enriqueceu muitíssimo, tinha muitos rebanhos, servos e servas, camelos e jumentos."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Jacob soube que os filhos de Labão diziam: «Jacob apoderou-se de tudo o que pertencia ao nosso pai, e foi às custas do nosso pai que enriqueceu»."
,"2":"Jacob observou o rosto de Labão e percebeu que ele já não o tratava como antes."
,"3":"Javé disse a Jacob: «Volta para a terra de teus pais, para a tua pátria, e Eu estarei contigo»."
,"4":"Jacob chamou então Raquel e Lia para que fossem ao campo onde ele estava com o rebanho."
,"5":"E disse-lhes: «Pelo rosto do vosso pai, vi que já não me trata como antes. Mas o Deus de meu pai está comigo."
,"6":"Sabeis que servi o vosso pai com todas as minhas forças."
,"7":"Mas ele enganou-me, mudando dez vezes o meu salário. Deus, porém, não permitiu que ele me prejudicasse."
,"8":"Cada vez que ele dizia: 'O que for pintado será o teu salário', todos os animais davam crias pintadas; e cada vez que me dizia: 'O que for listrado será o teu salário', todos os animais davam crias listradas."
,"9":"E assim Deus tirou-lhe o rebanho e deu-mo a mim."
,"10":"Aconteceu que, ao chegar o tempo em que os animais entram no cio, ergui os olhos e vi em sonho que todos os machos que cobriam as fêmeas eram listrados, malhados ou pintados."
,"11":"O anjo de Deus disse-me em sonho: 'Jacob'. E eu respondi: 'Aqui estou'."
,"12":"O anjo disse: 'Levanta os olhos e vê! Todos os machos que cobrem as fêmeas são listrados, malhados ou pintados. Eu vi o que Labão te fez."
,"13":"Eu sou o Deus que te apareceu em Betel, onde ergueste uma estela e me fizeste um voto. Agora levanta-te, sai deste país e volta para a terra onde nasceste'»."
,"14":"Raquel e Lia disseram a Jacob: «Nós teríamos direito a um dote e a uma herança na casa do nosso pai."
,"15":"No entanto, ele trata-nos como estrangeiras, porque nos vendeu e, ainda por cima, acabou com o nosso dinheiro."
,"16":"Sim, toda a riqueza que Deus tirou a nosso pai pertence-nos a nós e aos nossos filhos. Portanto, faz agora tudo o que Deus te disse»."
,"17":"Então Jacob levantou-se, mandou montar as suas mulheres e os seus filhos sobre os camelos"
,"18":"e, guiando todo o rebanho e todos os bens que tinha adquirido em Padã-Aram, partiu para a casa de seu pai Isaac, na terra de Canaã."
,"19":"Enquanto Labão foi tosquiar o rebanho, Raquel roubou os ídolos domésticos que pertenciam a seu pai."
,"20":"Jacob conseguiu iludir Labão, o arameu, e fugiu sem que ele suspeitasse."
,"21":"Fugiu levando tudo o que possuía. Atravessou o rio e foi para a região montanhosa de Galaad."
,"22":"Três dias depois, informaram Labão que Jacob havia fugido."
,"23":"Labão tomou consigo os seus irmãos e, perseguindo Jacob durante sete dias, alcançou-o na região montanhosa de Galaad."
,"24":"Deus visitou Labão, o arameu, numa visão nocturna, e disse-lhe: «Cuidado com o que vais dizer a Jacob»."
,"25":"Labão alcançou Jacob, que tinha armado a tenda na região montanhosa, e armou a sua tenda na região montanhosa de Galaad."
,"26":"Labão disse a Jacob: «Que fizeste? Porque me enganaste, levando as minhas filhas como se fossem prisioneiras de guerra?"
,"27":"Porque fugiste às escondidas, sem me dizeres nada? Eu ter-te-ia despedido com festas, cantos, tamborins e liras."
,"28":"Nem sequer me deixaste beijar as minhas filhas e netos. Foste muito insensato."
,"29":"Eu poderia causar-te dano, mas o Deus de teu pai, na noite passada, disse-me: 'Cuidado com o que vais dizer a Jacob'."
,"30":"E se partiste porque sentiste saudades da casa paterna, porque roubaste os meus deuses?»"
,"31":"Jacob respondeu a Labão: «Fiquei com medo que me tirasses as tuas filhas."
,"32":"Mas aquele com quem encontrares os teus deuses não ficará vivo. Diante da minha gente, se descobrires algo que te pertence, leva-o». De facto, Jacob não sabia que fora Raquel quem os havia roubado."
,"33":"Labão foi procurar na tenda de Jacob, depois na tenda de Lia, e por fim na tenda das duas servas, e nada encontrou. Enquanto saía da tenda de Lia para entrar na de Raquel,"
,"34":"Raquel pegou nos ídolos domésticos, colocou-os na sela do camelo e sentou-se em cima. Labão revirou toda a tenda e nada encontrou."
,"35":"Raquel disse a seu pai: «Que o meu senhor não se ofenda por eu não me levantar na sua presença: é que me veio o incómodo das mulheres». Labão procurou e não encontrou os ídolos."
,"36":"Jacob ficou furioso e começou a discutir com Labão: «Que crime cometi e qual é a minha falta para me perseguires?"
,"37":"Depois de revirares todas as minhas coisas, encontraste alguma coisa tua? Coloca-a aqui, diante da minha gente e da tua gente, e que eles julguem entre nós dois."
,"38":"Passei vinte anos contigo. As tuas ovelhas e cabras não abortaram e eu não comi os cordeiros do teu rebanho."
,"39":"Não te apresentei os animais despedaçados pelas feras, mas compensava-os com os meus. Pedias-me contas do que era roubado de dia e de noite."
,"40":"De dia, eu era devorado pelo calor, e de noite pelo frio, e não conseguia pegar no sono."
,"41":"Já estou há vinte anos em tua casa: servi-te catorze anos pelas tuas duas filhas, seis anos pelo teu rebanho, e dez vezes mudaste o meu salário."
,"42":"Se o Deus de meu pai, o Deus de Abraão, o Terrível Deus de Isaac, não estivesse comigo, ter-me-ias mandado embora de mãos vazias. Mas Deus viu a minha aflição e a minha fadiga, e na noite passada fez-me jus-tiça»."
,"43":"Labão respondeu a Jacob: «As filhas são minhas, estas crianças são minhas, o rebanho é meu e tudo o que tens me pertence. Que posso fazer hoje por estas mi-nhas filhas e pelos netos que elas deram à luz?"
,"44":"Vamos fazer uma aliança entre mim e ti, que sirva de garantia para nós dois»."
,"45":"Então Jacob tomou uma pedra e ergueu-a como estela."
,"46":"E Jacob disse à sua gente: «Ajuntai pedras». Eles pegaram em pedras e com elas fizeram um monte, e junto a ele tomaram uma refeição."
,"47":"Labão chamou-lhe monte Jegar-Saaduta, e Jacob chamou-lhe Galed."
,"48":"Labão disse: «Que este monte de pedras seja um testemunho entre nós». Por isso, chamou-lhe Galed"
,"49":"e Masfa, pois disse: «Javé nos vigiará a nós dois quando nos separarmos."
,"50":"Se maltratares as minhas filhas ou tomares outras mulheres além delas, ainda que ninguém o veja, Deus será nossa testemunha»."
,"51":"Labão disse a Jacob: «Vês este monte e esta estela que levantei entre nós dois?"
,"52":"Este monte e esta estela vão testemunhar que não devo passar deste monte e estela para o teu lado, e que não deves passar deste monte e desta estela para o meu lado, em atitude hostil."
,"53":"Que o Deus de Abraão e o Deus de Nacor sejam nossos juízes». E Jacob jurou pelo Deus Terrível de seu pai Isaac."
,"54":"Em seguida, Jacob ofereceu um sacrifício sobre a montanha e convidou a sua gente para a refeição. Comeram e passaram a noite sobre a montanha."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Labão levantou-se de madrugada, beijou os netos e as filhas e abençoou-os. Depois partiu e voltou para casa."
,"2":"Jacob continuou o seu caminho e encontrou-se com os anjos de Deus."
,"3":"Ao vê-los, Jacob exclamou: «Este é o acampamento de Deus». Por isso, deu àquele lugar o nome de Maanaim."
,"4":"Jacob enviou à sua frente mensageiros a seu irmão Esaú, no país de Seir, no campo de Edom."
,"5":"Deu-lhes esta ordem: «Falareis deste modo ao meu senhor Esaú: Assim fala o teu servo Jacob: Vivi com Labão e estive com ele até agora."
,"6":"Adquiri bois e jumentos, ovelhas, servos e servas. Envio esta mensagem ao meu senhor para alcançar o teu favor»."
,"7":"Os mensageiros voltaram a Jacob, di-zendo: «Fomos ter com o teu irmão Esaú e ele próprio vem ao teu encontro com quatrocentos homens»."
,"8":"Jacob ficou cheio de medo e angústia. Então dividiu em dois grupos os homens que estavam com ele, e também as ovelhas e bois,"
,"9":"calculando: «Se Esaú atacar um dos acampamentos, o outro poderá salvar-se»."
,"10":"Jacob rezou: «Javé, Deus de meu pai Abraão e Deus de meu pai Isaac, Tu ordenaste-me: 'Volta para o teu país e para a tua terra natal, e Eu proteger-te-ei'."
,"11":"Eu não mereço os favores nem a bondade com que trataste o teu servo. Quando atravessei o Jordão, eu tinha apenas um bastão, agora possuo duas caravanas."
,"12":"Livra-me da mão de meu irmão Esaú, pois tenho medo que ele venha e me mate juntamente com as mães e os filhos."
,"13":"Tu disseste-me: 'Eu dar-te-ei bens e tornarei a tua descendência tão numerosa como a areia do mar, que não se pode contar'»."
,"14":"E Jacob passou a noite naquele lugar. De tudo o que possuía, Jacob escolheu um presente para seu irmão Esaú:"
,"15":"duzentas cabras e vinte bodes, duzentas ovelhas e vinte cordeiros,"
,"16":"trinta camelas de leite, com suas crias, quarenta vacas e dez touros, vinte jumentas e dez jumentinhos."
,"17":"Entregou-os aos seus servos em rebanhos separados, e disse-lhes: «Ide à minha frente e deixai espaço entre os rebanhos»."
,"18":"E deu esta ordem ao primeiro: «Quando o meu irmão Esaú te encontrar e te perguntar: 'De quem és? Para onde vais? De quem é tudo isto que aqui levas?',"
,"19":"então responderás: 'É do vosso servo Jacob. É um presente que ele envia ao meu senhor Esaú, e ele próprio chegará depois de nós'»."
,"20":"Jacob deu a mesma ordem ao segundo e ao terceiro e a todos os que acompanhavam os rebanhos: «Quando encontrardes Esaú, dizei tudo isto."
,"21":"E acrescentai: 'O vosso servo Jacob vem atrás de nós'». Pois Jacob pensava: «Vou acalmar o meu irmão com os presentes que vão antes de mim. Depois eu comparecerei diante dele. Talvez assim ele me receba bem»."
,"22":"Os presentes foram à frente, e Jacob passou essa noite no acampamento."
,"23":"Nessa noite, Jacob levantou-se, tomou as suas duas mu-lheres, as duas servas, os onze filhos e atravessou o vau do Jaboc."
,"24":"Jacob ajudou-os a atravessar a torrente, com tudo o que possuía."
,"25":"E Jacob ficou sozinho. Um homem lutou com Jacob até ao romper da aurora."
,"26":"Vendo que não conseguia dominá-lo, o homem tocou-lhe na coxa, de modo que o tendão da coxa de Jacob se deslocou enquanto lutava com ele."
,"27":"Então o homem disse: «Solta-me, porque já está a romper a aurora». Jacob respondeu: «Não te soltarei, enquanto não me abençoares»."
,"28":"O homem perguntou-lhe: «Qual é o teu nome?» Ele respondeu: «Jacob»."
,"29":"O homem continuou: «Já não te chamarás Jacob, mas Israel, porque lutaste com Deus e com homens, e venceste»."
,"30":"Jacob perguntou-lhe: «Diz-me o teu nome». Mas ele respondeu: «Porque queres saber o meu nome?» E abençoou-o."
,"31":"Jacob deu àquele lugar o nome de Fanuel, dizendo: «Eu vi Deus face a face e continuei vivo»."
,"32":"Ao nascer do sol, Jacob atravessou Fanuel e coxeava por cau-sa da sua coxa."
,"33":"Por isso, até hoje os israelitas não comem o nervo ciático, que está na articulação da coxa: é porque aquele homem feriu Jacob na articulação da coxa, no nervo ciático."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Erguendo os olhos, Jacob viu que Esaú vinha ao seu encontro acompanhado por quatrocentos homens. Repartiu os filhos entre Lia, Raquel e as duas servas:"
,"2":"na frente, colocou as servas com os seus filhos, mais atrás Lia com seus filhos e, por último, Raquel com José."
,"3":"Então ele passou à frente de todos e prostrou-se por terra sete vezes antes de chegar junto do seu irmão."
,"4":"Esaú, porém, correu ao seu encontro, abraçou-o, beijou-o e apertou-o contra o peito. E ambos começaram a chorar."
,"5":"Esaú, erguendo os olhos, viu as mulheres e as crianças. E perguntou: «Quem são estes que estão contigo?» Jacob respondeu: «São os filhos com que Deus presenteou o teu servo»."
,"6":"As servas aproximaram-se com os filhos, e prostraram-se."
,"7":"Lia também se aproximou com os filhos e prostraram-se. Finalmente, aproximou-se Raquel com José, e prostraram-se."
,"8":"Esaú perguntou: «Que significam todos esses rebanhos que encontrei pelo caminho?» Jacob respondeu: «É para alcançar as graças do meu senhor»."
,"9":"Esaú replicou: «Caro irmão, eu tenho o suficiente. Fica com o que é teu»."
,"10":"Jacob insistiu: «De modo algum! Se alcancei o teu favor, aceita estes presentes da minha mão, pois vim à tua presença como se fosse à presença de Deus, e tu recebeste-me bem."
,"11":"Aceita, portanto, o presente que te ofereço, pois Deus favoreceu-me e tenho tudo o que preciso». Como Jacob insistisse, Esaú aceitou."
,"12":"Depois, Esaú disse: «Vamos continuar a viagem. Eu irei contigo»."
,"13":"Mas Jacob respondeu-lhe: «O meu senhor sabe que as crianças são delicadas e que devo pensar nas ovelhas e vacas de leite. Bastaria um dia de marcha forçada e todo o rebanho morreria."
,"14":"Que o meu senhor vá à frente do seu servo; eu irei devagar, ao passo das crianças e do rebanho que vai à minha frente. Alcançarei o meu senhor em Seir»."
,"15":"Então Esaú disse: «Deixarei contigo alguns dos meus homens como escolta». Mas Jacob recusou: «Para quê, se alcancei o favor do meu senhor?»"
,"16":"Nesse dia, Esaú voltou para Seir."
,"17":"Jacob, porém, partiu para Sucot, onde construiu uma casa e currais para o rebanho. É por isso que se deu ao lugar o nome de Sucot."
,"18":"Jacob chegou são e salvo à cidade de Siquém, na terra de Canaã, quando voltou de Padã-Aram, e acampou diante da cidade."
,"19":"O terreno, onde ergueu a sua tenda, comprou-o aos filhos de Hemor, pai de Siquém, por cem moedas de prata."
,"20":"Aí levantou um altar, a que chamou «El, o Deus de Israel»."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Dina, filha de Lia e Jacob, saiu para ver as mulheres do país."
,"2":"Siquém, o filho do heveu Hemor, príncipe do país, tendo-a visto, raptou-a, dormiu com ela e violentou-a."
,"3":"Contudo, sentiu-se atraído por Dina, filha de Jacob, apaixonou-se por ela e procurou cativá-la."
,"4":"Então Siquém falou a seu pai Hemor: «Consegue-me essa jovem para ser minha mulher»."
,"5":"Jacob soube que Siquém tinha desonrado sua filha Dina; mas, como os seus filhos estavam no campo com o rebanho, esperou em silêncio até que eles voltassem."
,"6":"Hemor, pai de Siquém, foi falar com Jacob."
,"7":"Quando os filhos de Jacob voltaram do campo e souberam da notícia, ficaram indignados e furiosos, pois era uma infâmia em Israel que Siquém tivesse dormido com a filha de Jacob, coisa que não se faz."
,"8":"Hemor disse-lhes: «O meu filho Siquém apaixonou-se pela vossa filha. Peço que lha deis como esposa."
,"9":"Assim nos tornaremos parentes: vós dar-nos-eis as vossas filhas e tomareis as nossas para vós,"
,"10":"e vivereis connosco. A terra está à vossa disposição: podeis morar nela, fazer comércio e adquirir propriedades»."
,"11":"Siquém disse ao pai e aos irmãos de Dina: «Fazei-me esse favor e dar-vos-ei o que me pedirdes."
,"12":"Podeis estabelecer um preço alto pela noiva: eu pagarei o que me pedirdes, contanto que ma deis para ser minha mulher»."
,"13":"Os filhos de Jacob responderam a Siquém e a seu pai He-mor com falsidade, porque a sua irmã Dina tinha sido desonrada:"
,"14":"«Não podemos fazer o que pedis, dando a nossa irmã a um homem que não é circuncidado, pois isso é uma desonra para nós."
,"15":"Só vamos concedê-la com uma condição: tendes de vos tornar como nós e circuncidar todos os homens."
,"16":"Então vos daremos as nossas filhas e tomaremos as vossas para nós; viveremos convosco e seremos um só povo."
,"17":"Mas, se não aceitardes a circuncisão, vamos tomar a nossa filha e partir»."
,"18":"As palavras deles agradaram a Hemor e a Siquém, filho de Hemor."
,"19":"O jovem não tardou em fazê-lo, pois queria a filha de Jacob, e era o mais considerado de toda a família."
,"20":"Então Hemor e seu filho Siquém foram ao Conselho da cidade e falaram a toda a população:"
,"21":"«Esta gente é de paz: que eles habitem a nossa terra entre nós, e nela façam comércio, pois a terra é espaçosa. Tomaremos as filhas deles como mulheres e dar-lhes-emos as nossas fi-lhas."
,"22":"Mas eles apresentaram uma condição para viver entre nós e formar um só povo: que todos os homens sejam circuncidados como eles."
,"23":"Os seus reba-nhos, os seus bens e animais serão nossos. Aceitemos, e eles viverão entre nós»."
,"24":"Os membros do Conselho aceitaram a proposta de Hemor e de seu filho Siquém, e circuncidaram todos os homens que tinham idade para frequentar o Conselho."
,"25":"No terceiro dia, quando os homens estavam a convalescer, Simeão e Levi, fi-lhos de Jacob e irmãos de Dina, tomaram cada um a sua espada, entraram sem oposição na cidade e mataram todos os homens."
,"26":"Passaram a fio de espada Hemor e seu filho Siquém, tomaram Dina da casa de Siquém, e partiram."
,"27":"Os filhos de Jacob atacaram os feridos e pilharam a cidade, porque haviam desonrado a sua irmã."
,"28":"E apoderaram-se das suas ovelhas, bois e jumentos, tudo o que havia na cidade e no campo."
,"29":"Roubaram-lhes todos os bens, todas as crianças, e pilharam o que havia nas casas."
,"30":"Jacob disse a Simeão e Levi: «Vós arruinastes-me, tornando-me odioso para os cananeus e ferezeus que habitam o país. Somos poucos: se eles se reunirem e nos atacarem, matar-me-ão e acabarão comigo e com a minha família»."
,"31":"Mas eles responderam: «Acaso a nossa irmã pode ser tratada como uma prostituta?»"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Deus disse a Jacob: «Levanta-te, sobe a Betel e vai morar lá. E constrói lá um altar ao Deus que te apareceu, quando fugias do teu irmão Esaú»."
,"2":"Então Jacob disse à sua família e a todos os que estavam com ele: «Deitai fora os deuses estrangeiros que estão no meio de vós, purificai-vos e mudai de roupa."
,"3":"Vamos subir a Betel, onde farei um altar ao Deus que me ouviu no perigo e me acompanhou na minha viagem»."
,"4":"Eles entregaram a Jacob todos os deuses estrangeiros que possuíam, e os brincos que traziam nas orelhas. E Jacob enterrou tudo debaixo do carvalho que está junto de Siquém."
,"5":"Levantaram acampamento, e o terror de Deus caía sobre as cidades vizinhas, de modo que os filhos de Jacob não foram perseguidos."
,"6":"Jacob chegou com toda a sua gente a Luza, que é Betel, na terra de Canaã."
,"7":"Ali construiu um altar e deu ao lugar o nome de El-Betel, porque foi ali que Deus lhe apareceu quando fugia do seu irmão."
,"8":"Nessa ocasião, morreu Débora, ama de Rebeca, e foi enterrada perto de Betel, debaixo do carvalho que se chama Carvalho-dos-Prantos."
,"9":"Ao voltar de Padã-Aram, Deus apareceu de novo a Jacob e abençoou-o,"
,"10":"dizendo: «O teu nome é Jacob, mas já não te chamarás Jacob: o teu nome será Israel». E deu-lhe o nome de Israel."
,"11":"Deus acrescentou: «Eu sou o Deus Todo-poderoso: sê fecundo e multiplica-te. De ti nascerá uma nação, uma multidão de nações, e das tuas entranhas sairão reis."
,"12":"Entrego-te a terra que dei a Abraão e Isaac; darei essa terra a vós e aos vossos descendentes»."
,"13":"Depois que Deus Se retirou de junto dele,"
,"14":"Jacob ergueu uma estela de pedra no lugar em que havia falado com Deus. Depois fez sobre ela uma libação e ungiu-a com óleo."
,"15":"E Jacob deu o nome de Betel ao lugar onde Deus lhe havia falado."
,"16":"Partiram de Betel. Quando ainda faltava um pouco de tempo para chegarem a Éfrata, Raquel deu à luz. O parto foi difícil"
,"17":"e, como desse à luz com dificuldade, a parteira disse-lhe: «Não tenhas medo, pois também este é um menino!»"
,"18":"Estando prestes a morrer, Raquel deu-lhe o nome de Benoni, mas o pai chamou-lhe Benjamim."
,"19":"Raquel morreu e foi enterrada no caminho de Éfrata, que hoje é Belém."
,"20":"Jacob ergueu uma estela sobre o seu túmulo; é a estela do túmulo de Raquel que existe até hoje."
,"21":"Israel partiu e acampou no outro lado da Torre do Rebanho."
,"22":"Enquanto Israel habitava nessa região, Rúben dormiu com Bala, concubina de seu pai, e Israel soube-o. Os filhos de Jacob foram doze: "
,"23":"Fi-lhos de Lia: Rúben, o primogénito de Jacob; depois, Simeão, Levi, Judá, Issacar e Zabulon."
,"24":"Filhos de Raquel: José e Benjamim."
,"25":"Filhos de Bala, serva de Raquel: Dã e Neftali."
,"26":"Filhos de Zelfa, serva de Lia: Gad e Aser. Estes são os filhos de Jacob que nasceram em Padã-Aram."
,"27":"Jacob voltou para a casa de Isaac, seu pai, em Mambré, em Cariat-Arbe, hoje Hebron, onde habitaram Abraão e Isaac."
,"28":"Isaac viveu cento e oitenta anos,"
,"29":"e morreu. Morreu e reuniu-se aos seus parentes, velho e com muitos anos. Seus filhos Esaú e Jacob enterraram-no."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Descendentes de Esaú, que é Edom."
,"2":"Esaú casou-se com mulheres cananeias: Ada, filha de Elon, o heteu; Oolibama, filha de Ana, filho de Sebeon, o heveu;"
,"3":"Basemat, filha de Ismael e irmã de Nabaiot."
,"4":"Ada gerou Elifaz a Esaú; Basemat gerou Rauel."
,"5":"Oolibama gerou Jeús, Jalam e Coré. São estes os filhos de Esaú, nascidos na terra de Canaã."
,"6":"Esaú tomou as suas mulheres, filhos e filhas, todas as pessoas da sua casa, o seu rebanho, todo o gado e tudo o que havia adquirido na terra de Canaã, e foi para a terra de Seir, longe do seu irmão Jacob."
,"7":"Eles tinham muitos bens e não podiam viver juntos, e a terra em que moravam não podia mantê-los a eles e aos seus rebanhos."
,"8":"Então Esaú estabeleceu-se na região montanhosa de Seir. Esaú é Edom."
,"9":"Descendentes de Esaú, antepassado dos edomitas, na região montanhosa de Seir."
,"10":"Lista dos filhos de Esaú: Elifaz, filho de Ada, mulher de Esaú; e Rauel, filho de Basemat, mulher de Esaú. "
,"11":"Filhos de Elifaz: Temã, Omar, Sefo, Gatam e Cenez."
,"12":"Elifaz, filho de Esaú, tinha uma concubina chamada Tamna, e ela gerou-lhe Amalec. São estes os netos de Ada, mulher de Esaú."
,"13":"Filhos de Rauel: Naat, Zara, Sama, Meza. São estes os netos de Basemat, mulher de Esaú."
,"14":"Filhos de Oolibama, filha de Ana, filho de Sebeon, mulher de Esaú: Jeús, Jalam e Coré."
,"15":"Chefes dos filhos de Esaú. Filhos de Elifaz, primogénito de Esaú: os chefes de Temã, Omar, Sefo, Cenez,"
,"16":"Coré, Gatam e Amalec. São estes os chefes de Elifaz na terra de Edom; são descendentes de Ada."
,"17":"Os seguintes são todos filhos de Rauel, filho de Esaú: os chefes de Naat, Zara, Sama e Meza. São estes os chefes de Rauel, na terra de Edom; são descendentes de Basemat, mulher de Esaú."
,"18":"Os seguintes são filhos de Oolibama, mu-lher de Esaú: os chefes de Jeús, Jalam e Coré. São estes os filhos de Oolibama, mulher de Esaú e filha de Ana."
,"19":"São estes os filhos e os chefes de Esaú, que é Edom."
,"20":"Filhos de Seir, o horreu, habitantes da terra: Lotã, Sobal, Sebeon, Ana,"
,"21":"Dison, Eser e Disã. São estes os chefes horreus, descendentes de Seir, na terra de Edom."
,"22":"Os filhos de Lotã foram Hori e Emam, e a irmã de Lotã era Tamna."
,"23":"Filhos de Sobal: Alvã, Manaat, Ebal, Sefo e Onam."
,"24":"Filhos de Sebeon: Aía e Ana. Foi este Ana que encontrou as águas quentes no deserto, enquanto apascentava os jumentos de seu pai Sebeon."
,"25":"Filhos de Ana: Dison e Oolibama, filha de Ana."
,"26":"Filhos de Dison: Hamdã, Esebã, Jetrã e Car."
,"27":"Filhos de Eser: Balaã, Zavã e Acã."
,"28":"Filhos de Disã: Hus e Arã."
,"29":"Chefes dos horreus: os chefes de Lotã, Sobal, Sebeon, Ana,"
,"30":"Dison, Eser e Disã. São esses os chefes dos horreus, segundo os seus clãs na terra de Seir."
,"31":"Reis que reinaram na terra de Edom, antes que os israelitas tivessem um rei."
,"32":"Em Edom reinou Bela, filho de Beor, e a sua cidade chamava-se Danaba."
,"33":"Bela morreu e em seu lugar reinou Jobab, fi-lho de Zara, de Bosra."
,"34":"Jobab morreu e em seu lugar reinou Husam, da terra dos temanitas."
,"35":"Husam morreu e em seu lugar reinou Adad, filho de Badad, que derrotou os madianitas nos campos de Moab; e a sua cidade chamava-se Avit."
,"36":"Adad morreu e em seu lugar reinou Semla de Masreca."
,"37":"Semla morreu e em seu lugar reinou Saul, de Reobot Naar."
,"38":"Saul morreu e em seu lugar reinou Baalanã, filho de Acobor."
,"39":"Baalanã, filho de Acobor, morreu e em seu lugar reinou Adad; a sua cidade chamava-se Fau; a sua mulher chamava-se Meetabel, filha de Matred, de Mezaab."
,"40":"Nomes dos chefes de Esaú por grupos, localidades e nomes: Tamna, Alva, Jetet,"
,"41":"Oolibama, Ela, Finon,"
,"42":"Cenez, Temã, Mabsar,"
,"43":"Magdiel e Iram. São estes os chefes de Edom, segundo as regiões onde habitavam. Esaú é o antepassado de Edom."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Jacob permaneceu em Canaã, a terra em que seu pai tinha morado."
,"2":"Esta é a história de Jacob. José tinha dezassete anos e pastoreava o rebanho com os seus irmãos. Ajudava os filhos de Bala e Zelfa, mulheres de seu pai. Certo dia, falou a seu pai da má fama que os seus irmãos tinham. "
,"3":"José era o preferido de Israel, porque era o filho da sua velhice e, por isso, mandou-lhe fa-zer uma túnica de mangas compridas."
,"4":"Os seus irmãos perceberam que o pai o preferia aos outros filhos. Por isso, ficaram com raiva, e não falavam amigavelmente com ele."
,"5":"Um dia, José teve um sonho e contou-o aos irmãos, que ficaram ainda com mais raiva dele."
,"6":"José disse aos irmãos: «Escutai o sonho que eu tive."
,"7":"Estávamos a atar feixes no campo; o meu feixe levantou-se e ficou de pé e os vossos fei-xes rodearam-no e prostraram-se diante dele»."
,"8":"Os irmãos perguntaram-lhe: «Será que queres ser nosso rei ou dominar-nos como senhor?» E eles ficaram com mais raiva ainda, por causa dos so-nhos que José lhes contava."
,"9":"E José teve mais um sonho que contou aos irmãos: «Tive outro sonho: o sol, a lua e onze estrelas prostravam-se diante de mim»."
,"10":"Ele contou o sonho a seu pai e aos irmãos. Então o pai repreendeu-o, dizendo: «Que sonho é esse que tiveste? Quer dizer que eu, a tua mãe e os teus irmãos, vamos prostrar-nos por terra diante de ti?»"
,"11":"Os irmãos ficaram com ciúmes de José, enquanto o pai meditava sobre o assunto."
,"12":"Os irmãos de José foram apascentar o rebanho de seu pai em Siquém."
,"13":"Israel disse a José: «Os teus irmãos devem estar com os rebanhos em Siquém. Vem cá! Vou mandar-te até onde eles estão». José respondeu: «Aqui estou»."
,"14":"O pai disse-lhe: «Então vai ver como estão os teus irmãos e o rebanho, e traz-me notícias». O pai mandou-o do vale de Hebron, e José chegou a Siquém."
,"15":"Um homem encontrou José que andava errante pelos campos e perguntou-lhe: «Que procuras?»"
,"16":"José respondeu: «Procuro os meus irmãos. Por favor, diz-me: onde é que eles estão a apascentar os rebanhos?»"
,"17":"O homem disse: «Eles partiram daqui, e eu ouvi-lhes dizer que iam para Dotain». Então José foi à pro-cura dos irmãos e encontrou-os em Dotain."
,"18":"Os irmãos viram-no de longe e, antes que se aproximasse, começaram a planear a morte dele."
,"19":"Disseram entre si: «Aí vem o sonhador!"
,"20":"Vamos matá-lo e atirá-lo para dentro dum poço. Diremos que um animal feroz o devorou. Veremos, então, para que servem os seus so-nhos»."
,"21":"Rúben ouviu isto e procurou salvar José das mãos deles. Rúben disse: «Não vamos matá-lo»."
,"22":"E continuou: «Não derrameis sangue. Atirai-o para o poço que está no deserto, mas não levanteis a mão contra ele». Rúben pretendia salvar José das mãos deles e restituí-lo ao pai."
,"23":"Quando José chegou ao lugar onde estavam os irmãos, eles arrancaram-lhe a túnica de mangas compridas,"
,"24":"agarraram-no e meteram-no num poço vazio, onde não havia água."
,"25":"Depois, sentaram-se para comer. Levantando os olhos, viram uma caravana de ismaelitas que vinha de Galaad. Os seus camelos estavam carregados de especiarias, bálsamo e resina, que leva-vam para o Egipto. "
,"26":"Então Judá disse aos irmãos: «Que vamos ganhar matando o nosso irmão e escondendo o crime?"
,"27":"Vamos vendê-lo aos ismaelitas, mas não levantemos a mão contra ele, pois afinal ele é nosso irmão, da mesma carne que nós». Os irmãos concordaram."
,"28":"Quando passaram alguns mercadores madianitas, retiraram José do poço, e depois venderam José aos ismaelitas por vinte moedas de prata, e estes levaram-no para o Egipto."
,"29":"Quando Rúben voltou ao poço, viu que José já lá não estava. Então rasgou as vestes"
,"30":"e, voltando para junto dos irmãos, disse: «O rapaz já lá não está. E eu, para onde irei?»"
,"31":"Então pegaram na túnica de José e, degolando um cabrito, molharam a túnica no sangue."
,"32":"Enviaram a túnica ao pai, dizendo: «Encontrámos isto; vê se é ou não é a túnica do teu filho»."
,"33":"O pai olhou e disse: «É a túnica do meu filho! Uma fera devorou-o: José foi despedaçado!»"
,"34":"Jacob rasgou as vestes, vestiu-se de luto e chorou a morte do filho por muito tempo."
,"35":"Todos os seus filhos e filhas procuraram consolá-lo, mas ele recusava consolo e dizia: «De luto por meu filho descerei ao túmulo». E seu pai conti-nuou a chorar por ele."
,"36":"Entretanto, os madianitas no Egipto venderam José a Putifar, ministro e chefe da guarda do Faraó."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Naquele tempo, Judá separou-se dos irmãos e foi viver na casa de um homem de Odolam, que se chamava Hira."
,"2":"Judá viu ali a filha de um cananeu chamado Sué, tomou-a por mulher e viveu com ela."
,"3":"A mulher concebeu e deu à luz um filho, a quem chamou Her."
,"4":"Ela concebeu de novo e deu à luz outro filho, a quem chamou Onã."
,"5":"Concebeu ainda outra vez e gerou mais um filho, a quem chamou Sela; quando o deu à luz, ela estava em Casib."
,"6":"Judá tomou uma esposa para o seu primogénito Her; a mulher chamava-se Tamar."
,"7":"No entanto, Her, primogénito de Judá, desagradou a Javé, que o feriu de morte."
,"8":"Então Judá disse a Onã: «Casa com a viúva do teu irmão; cumpre a tua obrigação de cunhado, e dá descendência ao teu irmão»."
,"9":"Onã, porém, sabia que a descendência não seria sua e, cada vez que se unia à mulher do seu irmão, derramava o sémen por terra, para não dar descendência ao irmão."
,"10":"O que ele fazia desagradava a Javé, que o fez morrer também."
,"11":"Então Judá disse à sua nora Tamar: «Vive como viúva na casa de teu pai e espera que cresça o meu filho Sela». Dizia isto, mas pensava: «Não convém que ele morra como os seus irmãos». Tamar, então, voltou para a casa do pai."
,"12":"Passou muito tempo e morreu a filha de Sué, mulher de Judá. Tendo passado o luto, Judá foi a Tamna, juntamente com Hira, seu amigo de Odolam, para tosquiar o rebanho."
,"13":"Comunicaram a Tamar: «O teu sogro vem a Tamna para tosquiar o rebanho»."
,"14":"Então Tamar tirou o traje de viúva, cobriu-se com véu e sentou-se na entrada de Enaim, que fica no caminho para Tamna. Ela viu que Sela já era adulto e não lhe fora dado como esposo."
,"15":"Vendo-a, Judá pensou que fosse uma prostituta, pois tinha o rosto coberto."
,"16":"Aproximou-se dela no caminho, e disse: «Deixa-me ir contigo». Judá não sabia que era a sua nora. Ela perguntou: «O que me darás para vires comigo?»"
,"17":"Judá respondeu: «Mandar-te-ei um cabrito do meu rebanho». Ela replicou: «Está bem; mas vais deixar uma garantia comigo até mandares o cabrito»."
,"18":"Judá perguntou: «Que garantia queres?» Ela respondeu: «O anel de selo, o teu cordão e o cajado que tens na mão». Judá entregou-os e foi com ela, deixando-a grávida."
,"19":"Tamar levantou-se, tirou o véu e vestiu novamente o traje de viúva."
,"20":"Judá mandou o cabrito por meio do seu amigo de Odolam, a fim de recupe-rar os objectos que havia deixado à mu-lher. Mas ele não a encontrou."
,"21":"Então perguntou aos homens do lugar: «Onde está aquela prostituta que costuma estar no caminho de Enaim?» Eles responde-ram: «Aqui nunca houve prostituta ne-nhuma!»"
,"22":"Então o homem voltou a Judá, e disse-lhe: «Não a encontrei, e os homens do lugar disseram que ali nunca houve prostituta nenhuma»."
,"23":"Judá replicou: «Que ela fique com tudo e não zombe de nós, pois eu mandei o cabrito, e tu não conseguiste encontrá-la»."
,"24":"Três meses depois, disseram a Judá: «A tua nora Tamar prostituiu-se e está grávida por causa da sua má conduta». Então Judá ordenou: «Trazei-ma e que seja queimada viva»."
,"25":"Quando a agarraram, ela mandou dizer ao sogro: «Estou grávida do homem a quem pertencem este anel de selo, este cordão e este cajado»."
,"26":"Judá reconheceu-os, e disse: «Ela é mais honesta do que eu, pois não lhe dei o meu filho Sela». E não teve mais relações com ela."
,"27":"Quando chegou o tempo do parto, Tamar teve gémeos."
,"28":"Durante o parto, um deles estendeu a mão, e a parteira pegou-lhe e amarrou nela uma fita verme-lha, dizendo: «Foi este que saiu primeiro»."
,"29":"Mas ele retirou a mão e foi seu irmão quem saiu. Então a parteira disse: «Com que violência vieste à luz!» E chamaram-lhe Farés."
,"30":"Em seguida, saiu o irmão, que tinha a fita vermelha na mão, e chamaram-lhe Zara."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Quando levaram José para o Egipto, o egípcio Putifar, ministro e chefe da guarda do Faraó, comprou-o aos ismaelitas, que o tinham levado para lá."
,"2":"Javé estava com José e deu-lhe sorte, de modo que o deixaram na casa do seu senhor egípcio."
,"3":"Vendo que Javé estava com José e que fazia prosperar tudo o que empreendia,"
,"4":"o seu senhor teve grande afeição por ele e colocou-o ao seu serviço pessoal: fez dele seu administrador, confiando-lhe tudo o que possuía."
,"5":"Desde que José foi colocado como administrador da casa e de tudo o que pertencia a Putifar, Javé abençoou a casa do egípcio em consideração a José: a bênção de Javé atingiu tudo o que o egípcio possuía, em casa e no campo."
,"6":"Putifar entregou tudo nas mãos de José, sem se preocupar com mais nada a não ser com o pão que comia. José era belo de porte e tinha um rosto bonito."
,"7":"Passado algum tempo, a mulher do seu senhor lançou os olhos sobre José e propôs-lhe: «Dorme comigo»."
,"8":"José recusou, e respondeu à mulher do seu senhor: «Sabes que o meu senhor não se ocupa com nada da casa e entregou nas minhas mãos tudo o que possui."
,"9":"Nesta casa, ele não é mais poderoso do que eu: ele não reservou nada para si, a não ser tu, porque és sua esposa. Como posso cometer semelhante crime, pecando contra Deus?»"
,"10":"Ela insistia todos os dias, mas José não acedeu aos seus desejos e não se entregou a ela."
,"11":"Certo dia, José foi para casa fazer o seu trabalho, e nenhum dos domésticos estava em casa."
,"12":"A mulher agarrou-o pelo manto, convidando: «Dorme comigo». José, porém, deixou o manto na mão dela e fugiu para fora."
,"13":"Vendo que José deixara o manto nas suas mãos e fugira,"
,"14":"a mulher chamou os domésticos e disse-lhes: «Vede! O meu marido trouxe um hebreu para abusar de nós. Ele aproximou-se para dormir comigo, mas eu dei um grande grito."
,"15":"Vendo que eu erguia a voz e gritava, ele deixou o manto e fugiu»."
,"16":"A mulher ficou com o manto de José até que o marido voltasse."
,"17":"Então contou-lhe a mesma história: «O escravo hebreu que trouxeste aproximou-se para abusar de mim."
,"18":"Eu levantei a voz e gritei; então ele deixou o manto e fugiu»."
,"19":"O marido ficou furioso quando ouviu o que a sua mulher contava: «Vê como o teu escravo agiu comigo»."
,"20":"Mandou, então, buscar José e lançou-o na prisão, onde estavam os prisioneiros do rei. Foi deste modo que José foi parar à prisão."
,"21":"No entanto, Javé estava com José e concedeu-lhe favores, atraindo para ele a simpatia do carcereiro-chefe."
,"22":"O carcereiro-chefe confiou a José todos os detidos que estavam na prisão. Era José quem organizava tudo o que aí se fazia."
,"23":"O carcereiro-chefe não se preocupava com nada do que lhe fora confiado, porque Javé estava com José e fazia prosperar tudo o que ele empreendia."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Passado algum tempo, o copeiro e o padeiro do rei do Egipto ofenderam o seu senhor, o rei do Egipto."
,"2":"O Faraó ficou irado contra esses dois ministros, o chefe dos copeiros e o chefe dos padeiros,"
,"3":"e mandou prendê-los na casa do chefe da guarda, na mesma prisão onde estava José."
,"4":"O chefe da guarda indicou José para os servir. Assim, eles ficaram na prisão por algum tempo."
,"5":"Certa noite, o copeiro e o padeiro do rei do Egipto, que estavam na prisão, tiveram um sonho, cada qual com o seu significado."
,"6":"Pela manhã, José foi aonde eles se encontravam e notou que estavam deprimidos."
,"7":"José perguntou, então, aos ministros do Faraó que estavam presos com ele na casa do seu amo: «Porque estais de rosto sombrio?»"
,"8":"Eles responderam: «É que tivemos um sonho e não há ninguém para o interpretar». José replicou: «Deus é que pode interpretar. Contai-me os sonhos»."
,"9":"O chefe dos copeiros contou o seu sonho a José: «Sonhei que estava uma videira diante de mim."
,"10":"Na videira havia três ramos: eles deram rebentos, floresceram e deram uvas maduras."
,"11":"Eu tinha na mão a taça do Faraó: peguei nos cachos de uvas, espremi-os na taça do Faraó, e coloquei a taça na mão do Faraó»."
,"12":"José disse ao chefe dos copeiros: «Esta é a interpretação: os três ramos representam três dias."
,"13":"Daqui a três dias, o Faraó lembrar-se-á de ti e devolver-te-á o cargo: colocarás a taça do Faraó na mão dele, como antes costumavas fazer, quando eras seu copeiro."
,"14":"Lembra-te de mim quando estiveres bem e faz-me este favor: menciona o meu nome ao Faraó para que ele me tire desta prisão."
,"15":"Eu fui sequestrado da terra dos hebreus e também aqui não fiz nada para me atirarem para esta prisão»."
,"16":"O chefe dos padeiros viu que José havia interpretado bem, e contou-lhe: «Eu também tive um sonho. Havia três cestas de bolos sobre a minha cabeça."
,"17":"Na cesta mais alta havia todos os tipos de doces que o Faraó come, porém as aves comiam-nos na cesta que eu levava à cabeça»."
,"18":"José respondeu: «Esta é a interpretação: as três cestas representam três dias."
,"19":"Daqui a três dias, o Faraó lembrar-se-á de ti, enforcar-te-á, e as aves comerão a carne do teu corpo»."
,"20":"Três dias depois, era o aniversário do Faraó. Então deu um banquete a todos os ministros, e libertou o chefe dos copeiros e o chefe dos padeiros."
,"21":"Devolveu o cargo ao chefe dos copeiros, e este colocou a taça na mão do Faraó."
,"22":"Quanto ao chefe dos padeiros, o Faraó mandou enforcá-lo, como José havia interpretado."
,"23":"O chefe dos copeiros, porém, não se lembrou de José, e esqueceu-se dele."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Dois anos depois, o Faraó teve um sonho: estava de pé, junto ao rio Nilo,"
,"2":"e viu subir do Nilo sete vacas bonitas e gordas, que pastavam nos juncais."
,"3":"Atrás delas, subiram do rio outras sete vacas, feias e magras, que se puseram ao lado das primeiras na margem do rio."
,"4":"Então as vacas feias e magras devoraram as sete vacas gordas e bonitas. Nisto, o Faraó acordou."
,"5":"O Faraó adormeceu de novo, e teve outro sonho: sete espigas brotavam da mesma haste, gradas e bonitas."
,"6":"E atrás delas nasceram sete espigas mirradas e ressequidas."
,"7":"As espigas mirradas devoraram as sete espigas gradas e cheias. Então o Faraó acordou: tivera um sonho."
,"8":"Pela manhã, o Faraó estava perturbado e chamou todos os magos e sábios do Egipto. Contou-lhes o sonho que tivera, mas ninguém foi capaz de o interpretar."
,"9":"Então o chefe dos copeiros disse ao Faraó: «Devo confessar hoje o meu pecado."
,"10":"O Faraó tinha-se irritado contra os seus servos e colocou-os na prisão na casa do chefe da guarda, tanto a mim como ao chefe dos padeiros."
,"11":"Na mesma noite, ele e eu tivemos um sonho, cada qual com significado diferente."
,"12":"Estava lá connosco um jovem hebreu, escravo do chefe da guarda. Nós contámos-lhe os sonhos e ele interpretou-os, dando o significado de cada um."
,"13":"E depois aconteceu exactamente como ele havia interpretado. Eu recuperei o meu cargo, e o outro foi enforcado»."
,"14":"Então o Faraó mandou chamar José e tiraram-no apressadamente da prisão; ele barbeou-se, mudou de roupa e apresentou-se ao Faraó."
,"15":"O Faraó disse a José: «Tive um sonho e ninguém sabe interpretá-lo. Ouvi dizer que sabes interpretar os sonhos»."
,"16":"José respondeu ao Faraó: «Quem sou eu? Deus é que dará uma resposta favorável ao Faraó»."
,"17":"Então o Faraó contou a José: «Sonhei que estava de pé na margem do rio Nilo."
,"18":"Do rio subiam sete vacas gordas e bonitas que pastavam nos juncais."
,"19":"Atrás delas subiram outras sete, cansadas, feias e magras, tão feias como nunca vi no Egipto."
,"20":"As vacas magras e feias devoraram as sete primeiras vacas, as gordas."
,"21":"Depois de as devorarem, não parecia que as tinham devorado, porque a aparência delas continuava tão feia como antes. Então acordei."
,"22":"Depois, tive outro sonho: sete espigas subiam da mesma haste, cheias e bonitas."
,"23":"Atrás delas nasceram sete espigas secas, mirradas e queimadas."
,"24":"E as espigas mirradas devoraram as sete espigas bonitas. Eu contei isto aos magos, e ninguém foi capaz de o interpretar»."
,"25":"José disse ao Faraó: «Trata-se de um sonho único. Deus anuncia ao Faraó o que vai realizar."
,"26":"As sete vacas gordas representam sete anos e as sete espigas bonitas representam sete anos. É o mesmo sonho."
,"27":"As sete vacas magras e feias, que sobem em segundo lugar, representam sete anos; e também as sete espigas mirradas e queimadas: é que haverá sete anos de fome."
,"28":"É como eu disse ao Faraó: Deus mostrou ao Faraó o que vai realizar."
,"29":"Virão sete anos em que haverá grande abundância em toda a terra do Egipto;"
,"30":"depois, virão sete anos de fome, que farão esquecer a abundância na terra do Egipto. A fome esgotará a Terra,"
,"31":"e ninguém mais saberá o que era a abundância na Terra, por causa da fome que virá depois, pois será duríssima."
,"32":"E se o sonho do Faraó se repetiu duas vezes é porque o facto está bem decidido por parte de Deus, e Deus depressa o realizará."
,"33":"Agora, portanto, que o Faraó escolha um homem inteligente e sábio, e o coloque à frente do Egipto."
,"34":"Que o Faraó nomeie funcionários no país, tome a quinta parte dos produtos da terra do Egipto, durante os sete anos de abundância."
,"35":"Que eles reúnam todos os víveres desses anos bons que virão, armazenem o trigo sob a autoridade do Faraó e guardem os víveres nas cidades."
,"36":"Esses víveres servirão de reserva para o país, quando chegarem os sete anos de fome. Deste modo, a terra do Egipto não será exterminada pela fome»."
,"37":"O conse-lho de José agradou ao Faraó e a todos os seus ministros."
,"38":"Então, o Faraó disse aos ministros: «Podemos nós encontrar um homem como este, em quem esteja o espírito de Deus?»"
,"39":"Então o Faraó disse a José: «Visto que Deus te revelou tudo isto, não há ninguém tão inteligente e sábio como tu."
,"40":"Serás o administrador do meu palácio, e todo o povo obedecerá às tuas ordens. Só pelo trono serei maior do que tu»."
,"41":"E o Faraó continuou: «Eis que te coloco à frente de todo o país»."
,"42":"Então o Faraó tirou da mão o anel de selo e colocou-o na mão de José: vestiu-o com roupas de linho fino e colocou-lhe no pescoço um colar de ouro."
,"43":"Depois mandou-o subir para o melhor carro que havia depois do seu, e proclamar à sua frente: «De joelhos!» E assim José foi colocado à frente de todo o Egipto."
,"44":"O Faraó disse a José: «Eu sou o Faraó mas, sem a tua permissão, ninguém erguerá mão ou pé em todo o Egipto»."
,"45":"E o Faraó deu a José o nome de Safanet-Fanec, e deu-lhe como mulher Asenet, filha de Putifar, sacerdote de On. E José saiu para percorrer o Egipto."
,"46":"José tinha trinta anos quando se apresentou diante do Faraó, rei do Egipto. José deixou a presença do Faraó e percorreu toda a terra do Egipto."
,"47":"Durante os sete anos de abundância, a terra produziu colheitas abundantes."
,"48":"E José reuniu todos os víveres dos sete anos de abundância na terra do Egipto e armazenou os víveres nas cidades, colocando em cada cidade os víveres dos campos da redondeza."
,"49":"José armazenou trigo como areia do mar: a quantidade era tal que deixaram de o medir, porque ultrapassava qualquer medida."
,"50":"Antes de chegar o primeiro ano da fome, José teve dois filhos de Asenet, fi-lha de Putifar, sacerdote de On."
,"51":"José deu ao mais velho o nome de Manassés, dizendo: «Deus fez-me esquecer as mi-nhas fadigas e a casa paterna»."
,"52":"Ao segundo, deu-lhe o nome de Efraim, dizendo: «Deus tornou-me fecundo na terra da minha aflição»."
,"53":"Acabaram os sete anos de abundância na terra do Egipto,"
,"54":"e chegaram os sete anos de fome, como José havia anunciado. Houve então fome por toda a parte, e só no Egipto havia pão."
,"55":"Depois chegou a fome a todo o Egipto; e o povo, com grandes gritos, pediu pão ao Faraó. Então o Faraó disse a todos os egípcios: «Ide ter com José, e fazei o que ele vos disser»."
,"56":"Quando a fome cobriu toda a Terra, José abriu os armazéns de trigo e vendeu mantimentos aos egípcios, enquanto no Egipto a fome alastrava."
,"57":"De todos os países ia muita gente ao Egipto para comprar mantimentos a José, porque a fome se agravou em toda a Terra."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Jacob soube que havia mantimentos no Egipto, e disse a seus filhos: «Porque esperais?»"
,"2":"Eu soube que no Egipto há mantimentos a vender. Ide lá comprar mantimentos para nós, a fim de continuarmos vivos e não morrermos»."
,"3":"Dez dos irmãos de José desceram, então, ao Egipto para comprar trigo."
,"4":"Jacob não deixou que Benjamim, irmão de José, fosse com os irmãos, pois temia que lhe acontecesse alguma desgraça."
,"5":"Os filhos de Israel foram com outros forasteiros comprar mantimentos, pois havia fome em Canaã."
,"6":"José tinha autoridade no país e era ele quem vendia os mantimentos a todo o povo. Os irmãos de José chegaram e prostraram-se diante dele com o rosto por terra."
,"7":"Ao ver os irmãos, José reconheceu-os, mas não se deu a conhecer, e falou-lhes duramente: «Donde vindes?» Eles responderam: «Da terra de Canaã, para comprar provisões»."
,"8":"José reconheceu os irmãos, mas eles não o reconheceram."
,"9":"José lembrou-se, então, dos sonhos que tivera a respeito deles, e disse-lhes: «Sois espiões. Viestes para observar os pontos fracos do país»."
,"10":"Eles protestaram: «Não, meu senhor! Os teus servos vieram para comprar provisões."
,"11":"Somos todos filhos do mesmo pai, e somos sinceros; os teus servos não são espiões»."
,"12":"José, porém, insistiu: «Não, viestes para observar os pontos fracos do país»."
,"13":"Eles responderam: «Éramos doze irmãos, filhos de um mesmo pai, na terra de Canaã: o mais novo está agora com o nosso pai e o outro desapareceu»."
,"14":"José reafirmou: «É como eu disse: sois espiões!"
,"15":"Vou pôr-vos à prova: pela vida do Faraó, não saireis daqui enquanto não me trouxerdes o vosso irmão mais novo."
,"16":"Mandai um de vós buscar o vosso irmão, enquanto os outros ficam presos. Assim provareis que as vossas palavras são verdadeiras. Caso contrário, pela vida do Faraó, comprovareis que sois espiões»."
,"17":"E José manteve-os presos durante três dias."
,"18":"Três dias depois, José disse-lhes: «Eu temo a Deus; por isso, fareis o seguinte para salvar a vida:"
,"19":"se sois sinceros, que um de vós fique aqui preso e os outros irão levar os mantimentos às suas famílias que passam fome."
,"20":"Depois trazei-me o vosso irmão mais novo: assim provareis que estais a dizer a verdade, e não morrereis». Eles aceitaram"
,"21":"e começaram a dizer entre si: «Estamos a pagar pelo que fizemos ao nosso irmão; nós vimos a sua aflição quando ele nos suplicava por piedade, e não fizemos caso. Por isso é que veio sobre nós esta desgraça»."
,"22":"Rúben interveio: «Eu não disse para não pecardes contra aquele menino? Mas não me ouvistes, e agora pedem-nos contas do seu sangue»."
,"23":"Eles não sabiam que José entendia o que eles diziam, pois entre José e eles havia um intérprete."
,"24":"Então José afastou-se deles e chorou. Depois voltou e conversou com eles. Então escolheu Simeão e mandou-o acorrentar na presença deles."
,"25":"José ordenou que lhes enchessem as sacas de trigo, lhes pusessem nas sacas o dinheiro que eles haviam pago, e lhes fornecessem provisões para o caminho. E assim foi feito."
,"26":"Eles carregaram as provisões sobre os jumentos e partiram."
,"27":"De noite, no acampamento, um deles abriu a saca de trigo para dar forragem ao seu jumento, e viu que o seu dinheiro estava na boca da saca de trigo."
,"28":"Então disse aos irmãos: «Devolveram-me o dinheiro! Está aqui na saca de trigo». Cheios de medo, eles entreolharam-se tremendo, e disseram: «Que é isto que Deus fez connosco?»"
,"29":"Chegando a casa de Jacob, na terra de Canaã, contaram ao pai tudo o que lhes havia acontecido:"
,"30":"«O senhor do país falou-nos com dureza e achou que éramos espiões no seu país."
,"31":"Nós dissemos-lhe: 'Somos sinceros, não somos espiões."
,"32":"Nós éramos doze irmãos, filhos do mesmo pai; um de nós desapareceu e o mais novo está agora com o nosso pai na terra de Canaã'."
,"33":"Mas o se-nhor do país disse-nos: 'Vou saber que sois sinceros do seguinte modo: deixai comigo um dos vossos irmãos, enquanto os outros levam os mantimentos para as suas famílias que passam fome."
,"34":"Depois trazei-me o vosso irmão mais novo e eu saberei assim se sois espiões ou não. Então devolver-vos-ei o vosso irmão e podereis circular pelo país'»."
,"35":"Quando eles foram esvaziar as sacas, cada qual encontrou na sua saca a bolsa de dinheiro. Vendo as bolsas de dinheiro, eles e o pai ficaram assustados."
,"36":"Então o pai Jacob disse-lhes: «Estais a deixar-me sozinho: José desapareceu, Simeão também, e agora quereis levar Benjamim! Tudo se volta contra mim!»"
,"37":"Mas Rúben disse ao pai: «Podes matar os meus dois filhos se eu não te devolver Benjamim. Entrega-mo, que eu o trarei de volta»."
,"38":"O pai respondeu: «O meu filho não descerá convosco. O irmão dele morreu e só me resta ele. Se lhe acontecer alguma desgraça na viagem que ides fazer, fareis que, de tanta dor, este velho de cabelos brancos desça ao túmulo»."
}`)
	CurrentBook.AddChapter(43, `{
"1":"A fome apertava no país."
,"2":"Quando acabaram as provisões que haviam trazido do Egipto, Jacob disse aos filhos: «Voltai lá e comprai-nos mantimentos»."
,"3":"Judá replicou: «Aquele homem declarou-nos severamente: 'Não vos apresenteis diante de mim sem me trazerdes o vosso irmão'."
,"4":"Se deixares que o nosso irmão vá connosco, então desceremos e iremos comprar-te mantimentos."
,"5":"Mas se o não deixares ir, não desceremos, pois aquele homem disse-nos: 'Não vos apresenteis diante de mim sem me trazerdes o vosso irmão'»."
,"6":"Israel disse-lhes: «Porque me destes este desgosto, contando àquele homem que tínheis ainda outro irmão?»"
,"7":"Eles responderam: «Aquele homem fez muitas perguntas sobre nós e a nossa família: 'O vosso pai ainda vive?' 'Tendes mais algum irmão?' E nós respondemos às perguntas dele. Como poderíamos imaginar que ele iria exigir que lhe levássemos o nosso irmão?»"
,"8":"Então Judá disse a seu pai Israel: «Deixa ir o menino comigo, porque indo poderemos salvar a nossa vida; de contrário, morreremos todos: nós, tu e os nossos filhos."
,"9":"Eu fico responsável por ele, e tu pedir-me-ás contas dele; se eu não o trouxer de volta e não o puser diante de ti, declarar-me-ei culpado para contigo durante toda a minha vida."
,"10":"Se não tivéssemos demorado tanto, já estaríamos de volta pela segunda vez»."
,"11":"Então o pai Jacob disse-lhes: «Se é necessário, então fazei assim. Metei nas vossas bagagens os melhores produtos do país e levai-os como presente a esse homem: um pouco de bálsamo, um pouco de mel, especiarias, resina, terebinto e amêndoas."
,"12":"Levai convosco o dobro do dinheiro para devolver o que foi posto nas sacas, pois talvez tenha sido um descuido."
,"13":"Tomai o vosso irmão e voltai a visitar aquele homem."
,"14":"Que o Todo-poderoso faça com que aquele homem tenha compaixão de vós, solte o vosso irmão e não prenda Benjamim. Quanto a mim, se tiver que ficar sem os meus filhos, paciência!»"
,"15":"Então eles tomaram consigo os presentes, o dobro do dinheiro e Benjamim, desceram ao Egipto e apresentaram-se a José."
,"16":"Quando José viu os irmãos com Benjamim, disse ao mordomo: «Leva esses homens para minha casa, manda abater um animal e prepara-o, porque esses homens vão almoçar comigo»."
,"17":"O mordomo fez o que José mandou, e levou-os para a casa de José."
,"18":"Os homens ficaram com medo, por os levarem para a casa de José, e disseram: «Levam-nos por causa do dinheiro que voltou nas nossas sacas de trigo na primeira vez: vão agarrar-nos, cair sobre nós e tomar-nos como escravos juntamente com os nossos jumentos»."
,"19":"Eles aproximaram-se do mordomo de José e disseram-lhe à entrada da casa:"
,"20":"«Vê, senhor! Nós descemos uma vez aqui para comprar mantimentos."
,"21":"Quando chegámos de noite ao acampamento, abrimos as nossas sacas de trigo e encontrámos na boca das sacas o dinheiro que havíamos pago, e trouxemo-lo de novo, juntamente"
,"22":"com outra quantia igual para comprar mantimentos. Não sabemos quem colocou o nosso dinheiro nas sacas de trigo»."
,"23":"O mordomo respondeu: «Ficai tranquilos e não tenhais medo. Foi o vosso Deus e o Deus do vosso pai que vos colocou um tesouro nas sacas de trigo. Eu recebi o vosso dinheiro». E trouxe Simeão para junto deles."
,"24":"O mordomo convidou-os a entrar na casa de José, levou água para que lavassem os pés e deu forragem aos seus jumentos."
,"25":"Eles prepararam o presente, esperando que José viesse ao meio-dia, porque souberam que iam almoçar lá."
,"26":"Quando José entrou em casa, eles ofereceram-lhe o presente que tinham consigo, e prostraram-se por terra."
,"27":"José, porém, saudou-os amigavelmente e perguntou: «Como está o vosso velho pai, de quem me falastes? Ele ainda vive?»"
,"28":"Eles responderam: «O teu servo, nosso pai, está bem. Ele ainda vive». E inclinaram-se e prostraram-se."
,"29":"Erguendo os olhos, José viu o irmão Benjamim, filho de sua mãe, e perguntou: «É este o irmão mais novo, de quem me falastes?» E disse a Benjamim: «Que Deus te conceda graça, meu filho»."
,"30":"Em seguida, José saiu depressa, porque ficou comovido com o irmão e as lágrimas vinham-lhe aos olhos. Entrou no quarto e chorou."
,"31":"Depois lavou o rosto, voltou e, contendo-se, ordenou: «Servi o almoço»."
,"32":"Serviram José à parte, os irmãos à parte, e de outro lado os egípcios que comiam com ele, pois os egípcios não podem comer com os hebreus: isso seria um sacrilégio."
,"33":"Os irmãos estavam colocados diante de José, cada qual em seu lugar, do mais velho ao mais novo: eles olhavam uns para os outros espantados."
,"34":"José mandava-lhes porções da sua mesa e a porção de Benjamim era cinco vezes maior. Beberam e alegraram-se na companhia de José."
}`)
	CurrentBook.AddChapter(44, `{
"1":"José deu esta ordem ao mordomo: «Coloca tudo o que puderes de mantimentos dentro das sacas destes homens e põe o dinheiro de cada um na boca das sacas."
,"2":"Na boca da saca do mais novo, juntamente com o dinheiro do trigo, coloca também a minha taça, a taça de prata». E o mordomo assim fez."
,"3":"Ao amanhecer, os homens despediram-se e partiram com os seus jumentos."
,"4":"Logo que eles saíram da cidade e ainda não iam longe, José disse ao mordomo: «Persegue aqueles homens e, quando os alcançares, diz-lhes: 'Porque pagastes o bem com o mal?"
,"5":"Porque roubastes a taça de prata que o meu senhor usa para beber e fazer adivinhações? Vós comportastes-vos mal'»."
,"6":"O mordomo alcançou-os e repetiu-lhes estas palavras."
,"7":"Mas eles responderam: «Porque nos falas deste modo? Nós, teus servos, nunca faríamos isso!"
,"8":"Pois que o dinheiro que encontrámos na boca das sacas de trigo, voltámos a trazê-lo da terra de Canaã. Porque iríamos roubar ouro ou prata na casa do teu senhor?"
,"9":"Se encontrares a taça com um dos teus servos, que ele morra e nós nos tornaremos escravos do teu senhor»."
,"10":"O mordomo respondeu: «De acordo. Aquele com quem for encontrada a taça será meu escravo, e os outros ficarão livres»."
,"11":"Cada um colocou depressa a sua saca de trigo no chão e abriu-a."
,"12":"O mordomo pôs-se a examiná-los, começando pelo mais velho e terminando no mais novo, e encontrou a taça na saca de Benjamim."
,"13":"Então eles rasgaram as roupas, carregaram de novo os jumentos e voltaram para a cidade."
,"14":"Judá e seus irmãos entraram na casa de José, que ainda lá estava, e prostraram-se por terra diante dele."
,"15":"José perguntou-lhes: «O que é que fizestes? Não sabíeis que uma pessoa como eu é capaz de adivinhar?»"
,"16":"Judá respondeu: «Que podemos responder ao nosso senhor? Como podemos provar a nossa inocência? Deus descobriu a falta dos teus servos. Aqui estamos: somos escravos do meu senhor, tanto nós como aquele nas mãos de quem foi encontrada a taça»."
,"17":"José, porém, disse: «Eu nunca faria isso! Aquele que estava com a taça será meu escravo. Quanto a vós, podeis voltar em paz para a casa do vosso pai»."
,"18":"Então Judá aproximou-se e disse: «Meu senhor, permite que o teu servo fale na tua presença com toda a franqueza, sem que a tua cólera se acenda contra o teu servo, pois tu és como o próprio Faraó."
,"19":"Tu tinhas perguntado aos teus servos: 'Tendes ainda pai ou algum irmão?'"
,"20":"Nós respondemos-te: 'Temos um pai já velho e um irmão mais novo, nascido na sua velhice; o irmão deste morreu e ele ficou a ser o único filho de sua mãe. O nosso pai ama-o muito!'"
,"21":"Então tu disseste aos teus servos: 'Trazei-mo para que eu o veja'."
,"22":"Nós respondemos-te: 'O menino não pode deixar o pai; se ele se separar do pai, este morrerá'."
,"23":"Mas tu insististe com os teus servos: 'Se o vosso irmão mais novo não vier convosco, não sereis recebidos por mim'."
,"24":"Quando voltámos para junto do nosso pai, teu servo, contámos-lhe tudo o que nos disseste."
,"25":"E o nosso pai disse-nos: 'Voltai e comprai-nos alguns mantimentos'."
,"26":"E nós respondemos: 'Não podemos descer, se o nosso irmão mais novo não for connosco; pois não seremos recebidos por aquele senhor, se o nosso irmão mais novo não for connosco'."
,"27":"Então o meu pai, teu servo, disse-nos: 'Vós bem sabeis que a minha mulher só me deu dois filhos."
,"28":"Um deixou-me e eu disse: Ele foi devorado! E nunca mais o vi até hoje."
,"29":"Se levardes também este de junto de mim e lhe acontecer alguma desgraça, de tanta dor, fareis com que este velho de cabelos brancos desça ao túmulo'."
,"30":"Agora, pois, se eu chegar à casa de meu pai, teu servo, sem levar comigo o menino, a quem ele ama com toda a sua alma,"
,"31":"logo que notar que o rapaz não está connosco, ele morrerá. E faremos com que o nosso pai, teu servo, de cabelos brancos, com tanta dor, desça ao túmulo."
,"32":"E este teu servo tornou-se responsável pelo rapaz junto de meu pai, nestes termos: 'Se eu não te trouxer o menino, serei culpado para com meu pai durante toda a minha vida'."
,"33":"Portanto, deixa que este teu servo fique teu escravo no lugar do rapaz, e que ele possa voltar com os seus irmãos."
,"34":"Como poderia eu voltar à casa de meu pai sem levar comigo o rapaz? Não quero ver a desgraça que cairia sobre o meu pai»."
}`)
	CurrentBook.AddChapter(45, `{
"1":"Nesse momento, José não pôde mais conter-se na presença da sua corte, e ordenou: «Saiam todos!» E não havia mais ninguém, quando José se deu a conhecer aos seus irmãos:"
,"2":"começou a chorar tão alto que todos os egípcios ouviram, e a notícia chegou à casa do Faraó."
,"3":"José disse aos irmãos: «Eu sou José! Meu pai ainda está vivo?» Os irmãos, espantados, ficaram sem resposta."
,"4":"Então José disse aos irmãos: «Aproximai-vos de mim!» Eles aproximaram-se. José continuou: «Eu sou José, o irmão que vendestes para o Egipto."
,"5":"Mas, agora, não fiqueis tristes nem vos aflijais por me terdes vendido para este país, pois foi para vos salvar a vida que Deus me enviou para aqui adiante de vós."
,"6":"De facto, há dois anos que a fome se instalou no país e ainda haverá cinco anos sem sementeira e sem colheita."
,"7":"Deus enviou-me adiante de vós, para que possais sobreviver neste país, salvando a vida para uma libertação maravilhosa."
,"8":"Portanto, não fostes vós que me mandastes para cá; foi Deus; Ele tornou-me ministro do Faraó, administrador de todo o palácio e governador de todo o Egipto."
,"9":"Voltai depressa para junto de meu pai e dizei-lhe: 'Assim fala o teu filho José: Deus tornou-me senhor de todo o Egipto. Desce sem demora para junto de mim;"
,"10":"habitarás na terra de Gessen e ficarás comigo: tu, teus filhos, netos, ovelhas, bois e tudo o que te pertence."
,"11":"Ali te sustentarei, a fim de que não falte nada, a ti, à tua família e a tudo o que possuis, pois a fome ainda vai durar cinco anos'."
,"12":"Vedes com os próprios olhos, assim como meu irmão Benjamim, que sou eu quem vos fala pessoalmente."
,"13":"Contai a meu pai todo o poder que tenho no Egipto e tudo o que vistes e apressai-vos em trazer o meu pai para cá»."
,"14":"Então José abraçou seu irmão Benjamim e chorou. Benjamim também chorou abraçado a ele."
,"15":"Em seguida, José cobriu de beijos todos os irmãos e, abraçando-os, chorava. Só então os irmãos começaram a conversar com ele."
,"16":"A notícia de que os irmãos de José estavam no país chegou até ao palácio do Faraó, e o Faraó e os seus ministros alegraram-se."
,"17":"O Faraó disse a José: «Diz aos teus irmãos que carreguem os burros e voltem para a terra de Canaã."
,"18":"Trazei o vosso pai e as vossas famílias e vinde para cá. Eu vos darei a melhor terra do Egipto, e podereis comer os melhores produtos do país."
,"19":"Manda que levem do Egipto carros para transportar as crianças, as mulheres e o teu pai, e que venham para cá."
,"20":"Não se preocupem com o que deixarem, pois tudo o que houver de melhor na terra do Egipto lhes pertencerá»."
,"21":"Assim fizeram os filhos de Israel. José deu-lhes carros, conforme as ordens do Faraó, e também provisões para a viagem."
,"22":"Além disso, deu mudas de roupa a cada um deles, mas a Benjamim deu trezentas moedas de prata e cinco mudas de roupa."
,"23":"Para seu pai, enviou dez jumentos carregados com os melhores produtos do Egipto e dez jumentos carregados de trigo, pão e provisões para a viagem do pai."
,"24":"Quando os irmãos se despediram para partir, José disse-lhes: «Não litigueis durante a viagem»."
,"25":"Então partiram do Egipto e chegaram à terra de Canaã, à casa de seu pai Jacob."
,"26":"E deram a notícia ao pai: «José está vivo e é o governador de toda a terra do Egipto». Mas o pai ficou perplexo, pois não queria acreditar."
,"27":"Entretanto, quando eles repetiram tudo o que José lhes dissera e quando ele viu os carros que José tinha mandado para o levar, o coração de Jacob, seu pai, reanimou-se."
,"28":"E Israel disse: «Agora chega! O meu filho José ainda está vivo. Vou vê-lo antes de morrer»."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Israel partiu levando tudo o que possuía. Chegando a Bersabeia, ofereceu sacrifícios ao Deus de seu pai Isaac."
,"2":"Ali, numa visão nocturna, Deus disse a Israel: «Jacob! Jacob!» Ele respondeu: «Aqui estou»."
,"3":"Deus continuou: «Eu sou El, o Deus de teu pai. Não tenhas medo de descer ao Egipto, porque lá farei de ti uma grande nação."
,"4":"Eu descerei contigo ao Egipto; Eu mesmo far-te-ei voltar de lá. E será José quem te fechará os olhos»."
,"5":"Jacob partiu de Bersabeia, e os filhos de Israel fizeram subir seu pai Jacob, seus netos e suas mulheres, para os carros que o Faraó mandara para os levar."
,"6":"Tomaram os seus rebanhos e tudo o que haviam adquirido na terra de Canaã, e foram para o Egipto,"
,"7":"Jacob e todos os seus descendentes com ele: filhos e netos, filhas e netas e todos os seus descendentes, acompanharam-no para o Egipto."
,"8":"Nomes dos filhos de Jacob que foram para o Egipto: Rúben, o primogénito de Jacob."
,"9":"Filhos de Rúben: Henoc, Falu, Hesron e Carmi."
,"10":"Filhos de Simeão: Jamuel, Jamin, Aod, Jaquin, Soar e Saul, o filho da cananeia."
,"11":"Filhos de Levi: Gérson, Caat e Merari."
,"12":"Filhos de Judá: Her, Onã, Sela, Farés e Zara; mas Her e Onã morreram na terra de Canaã. Filhos de Farés: Hesron e Hamul."
,"13":"Filhos de Issacar: Tola, Fua, Jasub e Semron."
,"14":"Filhos de Zabulon: Sared, Elon e Jaelel."
,"15":"Até aqui são os descendentes que Lia e Jacob tiveram em Padã-Aram; além destes, a sua filha Dina: ao todo, trinta e três pessoas, entre filhos e filhas."
,"16":"Filhos de Gad: Safon, Hagi, Suni, Esebon, Eri, Arodi e Areli."
,"17":"Filhos de Aser: Jamne, Jesua, Jessui, Beria, e a irmã Sara. Filhos de Beria: Héber e Melquiel."
,"18":"Estes são os filhos de Zelfa, a escrava que Labão deu à sua filha Lia. Ela gerou dezasseis pessoas a Jacob."
,"19":"Filhos de Raquel, mulher de Jacob: José e Benjamim."
,"20":"Asenet, filha de Putifar, sacerdote de On, deu a José dois filhos no Egipto: Manassés e Efraim."
,"21":"Fi-lhos de Benjamim: Bela, Bocor, Asbel, Gera, Naamã, Equi, Ros, Mofim, Ofim e Ared."
,"22":"Estes são os filhos de Raquel, ge-rados a Jacob: são ao todo catorze pessoas."
,"23":"Filho de Dã: Husim."
,"24":"Filhos de Neftali: Jasiel, Guni, Jeser e Selém."
,"25":"Estes são os filhos de Bala, a escrava que Labão deu à sua filha Raquel. Ela gerou a Jacob sete pessoas."
,"26":"Os descendentes que foram com Jacob para o Egipto, sem contar as noras, eram ao todo sessenta e seis pessoas."
,"27":"Acrescentando os dois filhos de José no Egipto, a família de Jacob que foi para o Egipto era no total setenta pessoas."
,"28":"Jacob enviou Judá à frente, para que ele se encontrasse com José e preparasse um lugar em Gessen. Quando eles estavam a chegar a Gessen,"
,"29":"José preparou o seu carro e foi ao encontro do pai Israel a Gessen. Ao vê-lo, abraçou-o e, ao beijá-lo, chorou."
,"30":"Israel disse a José: «Agora posso morrer, depois de te ter visto vivo em pessoa»."
,"31":"Então José disse aos seus irmãos e à família de seu pai: «Vou subir para dar ao Faraó esta notícia: 'Os meus irmãos e a família de meu pai, que viviam em Canaã, vieram para junto de mim."
,"32":"São pastores de ovelhas que cuidam de rebanhos; trouxeram as ovelhas, as vacas e tudo o que possuíam'."
,"33":"Assim, quando o Faraó vos chamar e perguntar: 'Qual é a vossa profissão?',"
,"34":"então respondei: 'Os teus servos são pastores desde a juventude até hoje, tanto nós como os nossos pais'. Deste modo, podereis ficar na terra de Gessen, pois os egípcios detestam todos os pastores»."
}`)
	CurrentBook.AddChapter(47, `{
"1":"José foi levar ao Faraó a notícia: «Meu pai e meus irmãos chegaram da terra de Canaã com as suas ovelhas, vacas e tudo o que possuem, e estão na terra de Gessen»."
,"2":"José escolheu cinco dos seus irmãos e apresentou-os ao Faraó."
,"3":"Este perguntou-lhes: «Qual é a vossa profissão?» Eles responderam: «Os teus servos são pastores de ovelhas, tanto nós como os nossos pais»."
,"4":"E acrescentaram: «Viemos morar neste país, porque já não há pastagem para os rebanhos dos teus servos: a fome está assolando a terra de Canaã. Permite que os teus servos fiquem na terra de Gessen»."
,"5a":"Então o Faraó disse a José:"
,"6b":"«Que eles morem na terra de Gessen. Se sabes que alguns deles são capazes, coloca-os como administradores dos meus reba-nhos»."
,"5b":"Quando Jacob e seus filhos chegaram ao Egipto, o Faraó, rei do Egipto, teve conhecimento disso e disse a José: «O teu pai e teus irmãos vieram ter contigo."
,"6a":"A terra do Egipto está à tua disposição: instala o teu pai e os teus irmãos na melhor região»."
,"7":"Então José fez vir seu pai Jacob, apresentou-o ao Faraó, e Jacob saudou o Faraó."
,"8":"O Faraó perguntou a Jacob: «Quantos anos tens?»"
,"9":"Jacob respondeu ao Faraó: «Cento e trinta são os anos das minhas andanças pela Terra. Os anos da minha vida foram poucos e infelizes, e não chegam aos anos que meus pais viveram nas suas andanças»."
,"10":"Então Jacob saudou o Faraó e despediu-se dele."
,"11":"A seguir, José instalou o pai e os irmãos e deu-lhes propriedades no Egipto, na melhor região do país, que é a de Ramsés, conforme o Faraó lhe havia mandado."
,"12":"E José providenciou pão para seu pai, para seus irmãos e para toda a família de seu pai, segundo o número dos seus filhos."
,"13":"Em todo o país faltava pão, pois a fome assolava e esgotava a terra do Egipto e de Canaã."
,"14":"José acumulou todo o dinheiro que havia na terra do Egipto e na terra de Canaã, em troca dos mantimentos que eles compravam, e entregou todo o dinheiro ao palácio do Faraó."
,"15":"Quando se acabou o dinheiro da terra do Egipto e da terra de Canaã, todos os egípcios foram ter com José, pedindo: «Dá-nos pão ou morreremos aqui mesmo, porque se acabou o nosso dinheiro»."
,"16":"Então José disse: «Se o vosso dinheiro acabou, trazei rebanhos, e eu vos darei pão em troca de rebanhos»."
,"17":"Eles então levaram os rebanhos a José, e este deu-lhes pão em troca de cavalos, ovelhas, bois e jumentos. E nesse ano José sustentou-os com pão em troca de rebanhos."
,"18":"Passado esse ano, eles voltaram a ir ter com José no ano seguinte, dizendo: «Não te podemos esconder isto: o nosso dinheiro, os rebanhos e os animais já te pertencem. Só nos resta oferecer-te os nossos corpos e os nossos campos."
,"19":"Porque havemos de perecer na tua presença, nós e os nossos terrenos? Compra-nos, portanto, a nós e aos nossos terrenos em troca de pão, e nós e os nossos terrenos seremos servos do Faraó. Dá-nos sementes a fim de continuarmos vivos e não morrermos, e que os nossos terrenos não fiquem desertos»."
,"20":"Então José comprou para o Faraó todos os terrenos do Egipto, pois os egípcios, forçados pela fome, venderam os terrenos. Deste modo, todo o país tornou-se propriedade do Faraó."
,"21":"Quanto aos homens, o Faraó tornou-os escravos de uma extremidade à outra do território do Egipto."
,"22":"Somente as terras dos sacerdotes não foram compradas, pois os sacerdotes recebiam uma renda do Faraó e viviam dessa renda que o Faraó lhes dava. Por isso, não precisaram de vender as terras."
,"23":"José disse ao povo: «Hoje eu comprei-vos a vós e aos vossos terrenos para o Faraó. Aqui estão as sementes para semear os terrenos."
,"24":"Quando chegar a colheita, devereis dar a quinta parte ao Faraó; as outras quatro partes servirão para semear e para alimentar as vossas famílias e filhos."
,"25":"Eles responderam: «Tu salvaste-nos a vida! Alcançámos o teu favor e tornar-nos-emos escravos do Faraó»."
,"26":"José fez disso uma lei, que ainda hoje vale para todos os terrenos do Egipto: um quinto da produção pertence ao Faraó. Somente as terras dos sacerdotes não se tornaram propriedade do Faraó."
,"27":"Israel estabeleceu-se na terra do Egipto, na região de Gessen. Ali adquiriu propriedades, multiplicou-se e tornou-se muito numeroso."
,"28":"Jacob viveu dezassete anos no Egipto, e a duração da sua vida foi de cento e quarenta e sete anos."
,"29":"Quando chegou para Israel a hora da morte, chamou o seu filho José e disse-lhe: «Se tenho o teu afecto, coloca a tua mão debaixo da minha coxa e promete tratar-me com amor e fidelidade: peço-te que não me enterres no Egipto."
,"30":"Quando eu descansar com os meus pais, leva-me do Egipto e enterra-me no túmulo deles». José respondeu: «Farei o que pedes»."
,"31":"O seu pai insistiu: «Jura-me!» E José jurou. Então Israel inclinou-se na cabeceira da cama."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Depois disto, disseram a José: «O teu pai está doente ». Então José tomou consigo os dois filhos, Manassés e Efraim."
,"2":"Disseram a Jacob: «Aqui está o teu filho José que veio visitar-te». Israel fez um esforço e sentou-se na cama."
,"3":"Então Jacob disse a José: «O Deus Todo-poderoso apareceu-me em Luza, na terra de Canaã. Ele abençoou-me,"
,"4":"e disse: 'Tornar-te-ei fecundo e multiplicar-te-ei, até que chegues a ser uma multidão de povos. E aos teus descendentes eu darei esta terra como posse perpétua'."
,"5":"Agora, os dois filhos que te nasceram no Egipto antes que eu viesse morar contigo, serão meus filhos. Efraim e Manassés serão para mim como Rúben e Simeão."
,"6":"Os que nascerem depois deles pertencer-te-ão, e receberão a herança em nome dos seus irmãos."
,"7":"Quando eu voltava de Padã-Aram, para minha infelicidade, a tua mãe Raquel morreu em viagem na terra de Canaã, quando estava a certa distância de Éfrata, e eu enterrei-a no caminho de Éfrata, que é Belém»."
,"8":"Israel viu os dois filhos de José, e perguntou: «Quem são estes?»"
,"9":"José res-pondeu: «São os filhos que Deus me deu aqui». Jacob disse: «Aproxima-os de mim para que eu os abençoe»."
,"10":"Israel estava com a vista fraca pela velhice e já quase não via. José mandou-os aproximar dele e Israel beijou-os e abraçou-os."
,"11":"E Israel disse a José: «Eu já não esperava ver-te, mas Deus permitiu que te visse a ti e aos teus descendentes»."
,"12":"Então José tirou os filhos do colo do pai e prostrou-se com o rosto por terra."
,"13":"José tomou os filhos, Efraim à direita e Manassés à esquerda, aproximou-se de Israel, para que Manassés ficasse à direita e Efraim à esquerda de Israel."
,"14":"Israel, porém, cruzou os braços, estendeu a mão direita e colocou-a sobre a cabeça de Efraim, que era o mais novo, e a mão esquerda sobre a cabeça de Manassés, embora Manassés fosse o mais velho."
,"15":"E abençoou-os, dizendo: «Que o Deus, diante do qual caminharam os meus pais Abraão e Isaac, que o Deus que foi meu pastor desde o meu nascimento até hoje,"
,"16":"que o Anjo que me salvou de todo o mal abençoe estas crianças. Que nelas sobrevivam o meu nome e o nome de meus pais Abraão e Isaac. Que elas cresçam e se multipliquem sobre a Terra»."
,"17":"José viu que seu pai tinha posto a mão direita sobre a cabeça de Efraim e não gostou. Pegou na mão do pai, retirou-a da cabeça de Efraim e colocou-a sobre a cabeça de Manassés,"
,"18":"explicando: «Não é assim, pai! O primogénito é este; coloca a mão direita sobre a cabeça dele»."
,"19":"Mas o pai recusou, dizendo: «Eu sei, meu filho, eu sei. Ele também se tornará um povo e crescerá, mas o teu filho mais novo será maior do que ele, e a sua descendência tornar-se-á uma multidão de nações»."
,"20":"Naquele dia, Jacob abençoou-os: «Israel mencionar-vos-á nas suas bênçãos, dizendo: 'Deus te faça como Efraim e Manassés'». E Jacob pôs assim Efraim antes de Manassés."
,"21":"Em seguida, Israel disse a José: «Estou para morrer, mas Deus estará convosco e levar-vos-á de novo para o país dos vossos antepassados."
,"22":"A ti, e não a teus irmãos, eu darei Siquém, que conquistei aos amorreus com a minha espada e arco»."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Jacob chamou os filhos e disse: «Reuni-vos, para que vos anuncie o que vos vai acontecer no futuro."
,"2":"Reuni-vos e escutai, filhos de Jacob, ouvi o vosso pai Israel:"
,"3":"Rúben, tu és o meu primogénito, a minha força e o primeiro fruto da minha virilidade, primeiro na fila e primeiro em poder,"
,"4":"impetuoso como as águas: não manterás a primazia, porque subiste à cama do teu pai e violaste o meu leito contra mim."
,"5":"Simeão e Levi são irmãos. As suas espadas são instrumentos de violência."
,"6":"Não quero assistir aos seus conselhos, não participarei na sua assembleia, pois na sua cólera mataram homens, e na sua exaltação derrubaram touros."
,"7":"Maldita seja a sua cólera porque foi maléfica, maldita a sua indignação, porque foi funesta. Eu dividi-los-ei em Jacob e dispersá-los-ei em Israel."
,"8":"A ti, Judá, teus irmãos prestarão homenagem. A tua mão fará dobrar o pescoço dos teus inimigos, e diante de ti se prostrarão os filhos de teu pai."
,"9":"Judá é um leãozinho. Voltaste da caçada, meu filho; agachas-te e deitas-te como leão e como leoa: quem se atreve a desafiá-lo?"
,"10":"O ceptro não se afastará de Judá, nem o bastão de comando do meio dos seus pés, até que o tributo lhe seja trazido e os povos lhe obedeçam."
,"11":"Ele prende o seu jumentinho junto à vinha, e a cria de jumenta perto da videira; lava a roupa no vinho e o manto no sangue das uvas."
,"12":"Os seus olhos são mais escuros que o vinho, e os seus dentes mais brancos que o leite."
,"13":"Zabulon reside à beira-mar: é um porto para os barcos, e a sua fronteira chegará até à Sidónia."
,"14":"Issacar é um jumento robusto, deitado entre dois muros."
,"15":"Viu que o estábulo era bom e que a terra era agradável: baixou o ombro sob a carga e sujeitou-se ao trabalho escravo."
,"16":"Dã julgará o seu povo, e também as outras tribos de Israel."
,"17":"Dã é uma serpente no caminho, uma víbora no atalho: morde o cavalo nos calcanhares, e o cavaleiro cai para trás."
,"18":"Na tua salvação eu espero, Javé!"
,"19":"Gad, os guerrilheiros atacá-lo-ão e ele atacá-los-á pelas costas."
,"20":"Aser, o teu pão é abundante e fornece as delícias dos reis."
,"21":"Neftali é gazela solta que tem crias formosas."
,"22":"José é potro selvagem, potro junto à fonte, burros selvagens junto ao muro."
,"23":"Os arqueiros irritam-nos, desafiam-nos e atacam-nos."
,"24":"Mas o seu arco fica intacto e os seus braços movem-se velozes, pelas mãos do Poderoso de Jacob, do Pastor e Pedra de Israel,"
,"25":"pelo Deus de seu pai que o socorre, pelo Todo-poderoso que o abençoa: as bênçãos que descem do céu e as bênçãos do oceano em baixo, bênçãos dos seios e das entranhas."
,"26":"As bênçãos de teu pai são superiores às bênçãos dos montes antigos e às atracções das colinas eternas. Que elas venham sobre a cabeça de José, sobre a fronte do eleito entre os irmãos."
,"27":"Benjamim é um lobo voraz: de ma-nhã devora a presa, e à tarde reparte os despojos»."
,"28":"São estes os que formam as doze tribos de Israel. E tudo isto foi o que lhes disse o pai ao abençoá-los; abençoou cada um com a bênção que convinha."
,"29":"Depois Jacob ordenou-lhes: «Quando eu me reunir aos meus, enterrai-me com os meus pais na gruta do campo de Efron, o heteu,"
,"30":"na gruta do campo de Macpela, diante de Mambré, na terra de Canaã, que Abraão comprou a Efron, o heteu, como propriedade sepulcral."
,"31":"Aí foram enterrados Abraão e sua mulher Sara; aí também foram enterrados Isaac e sua mulher Rebeca, e aí eu enterrei Lia."
,"32":"O campo e a gruta que nele está foram comprados aos filhos de Het»."
,"33":"Quando Jacob acabou de dar instruções aos filhos, recolheu os pés na cama, expirou e reuniu-se aos seus antepassados."
}`)
	CurrentBook.AddChapter(50, `{
"1":"José lançou-se sobre o rosto do pai, chorando e beijando-o."
,"2":"Em seguida, ordenou aos médicos que estavam ao seu serviço que embalsamassem seu pai; e os médicos embalsamaram Israel."
,"3":"Isto durou quarenta dias, que é o tempo que costuma demorar o embalsamamento. Os egípcios guardaram luto durante setenta dias."
,"4":"Quando terminou o tempo do luto, José disse aos cortesãos do Faraó: «Se sois meus amigos, dizei pessoalmente ao Faraó:"
,"5":"'O meu pai fez-me prestar este juramento: Quando eu morrer, enterra-me no túmulo que eu mandei abrir na terra de Canaã'. Portanto, deixa-me subir para enterrar meu pai; depois, eu voltarei»."
,"6":"O Faraó respondeu: «Sobe e enterra o teu pai conforme o juramento que fizeste»."
,"7":"José subiu para enterrar seu pai e com ele foram todos os oficiais do Faraó, os anciãos da corte e todos os dignitários da terra do Egipto,"
,"8":"bem como toda a família de José, seus irmãos e a família de seu pai. Deixaram na terra de Gessen somente as crianças, as ovelhas e os bois."
,"9":"Com José subiram também carros e cavaleiros; era um cortejo muito importante."
,"10":"Chegando a Goren-Atad, no outro lado do Jordão, fizeram um funeral grandioso e solene, e José guardou pelo pai um luto de sete dias."
,"11":"Os cananeus, que habitavam na região, viram o luto em Goren-Atad, e comentaram: «O funeral dos egípcios é solene!» Por isso, deram ao lugar o nome de Luto do Egipto, lugar esse que está no outro lado do Jordão."
,"12":"Os filhos de Jacob fizeram o que ele havia ordenado:"
,"13":"levaram-no para a terra de Canaã e enterraram-no na gruta do campo de Macpela, diante de Mambré, campo que Abraão havia comprado a Efron, o heteu, como propriedade sepulcral."
,"14":"Então José voltou para o Egipto juntamente com os seus irmãos e todos os que o acompanharam para enterrar seu pai."
,"15":"Vendo que o pai havia morrido, os irmãos de José disseram: «E se José guardou rancor contra nós e quer devolver-nos todo o mal que lhe fizemos?»"
,"16":"Então mandaram dizer a José: «Antes de morrer, o teu pai expressou esta vontade:"
,"17":"'Dizei a José: perdoa aos teus irmãos o crime e o pecado que cometeram, todo o mal que te fizeram'. Portanto, perdoa o crime dos servos do Deus de teu pai». Ao ouvir o que eles mandaram dizer, José chorou."
,"18":"Então chegaram os irmãos, prostraram-se diante de José e disseram: «Aqui estamos. Somos teus escravos»."
,"19":"José respondeu: «Não temais. Acaso estou eu no lugar de Deus?"
,"20":"Pretendíeis o mal contra mim, mas o projecto de Deus transformou-o em bem, a fim de cumprir o que se realiza hoje: salvar a vida de um povo numeroso."
,"21":"Portanto, nada receeis. Sustentar-vos-ei a vós e aos vossos filhos». José tranquilizou-os e falou-lhes afectuosamente."
,"22":"José viveu no Egipto com a família de seu pai, e chegou a cento e dez anos."
,"23":"Conheceu os filhos de Efraim até à terceira geração, e também os filhos de Maquir, filho de Manassés, e trouxe-os ao colo."
,"24":"Por fim, José disse aos irmãos: «Estou para morrer, mas Deus cuidará de vós e far-vos-á sair daqui para a Terra que Ele prometeu, com juramento, dar a Abraão, Isaac e Jacob»."
,"25":"E José fez jurar aos filhos de Israel: «Quando Deus intervier em vosso favor, levai os meus ossos daqui»."
,"26":"José morreu com cento e dez anos. Eles embalsamaram-no e colocaram-no num sarcófago no Egipto."
}`)

}
func PT_BS_LoadVPLVChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Javé chamou Moisés, e da tenda da reunião disse-lhe:"
,"2":"«Diz aos filhos de Israel: Quando alguém de vós apresentar uma oferta a Javé, ofereça um animal grande ou pequeno."
,"3":"Se for holocausto de animal grande, ofereça um macho sem defeito, e leve-o para a entrada da tenda da reunião, para que seja aceite por Javé."
,"4":"Coloque a mão sobre a cabeça da vítima, e ela será aceite como expiação."
,"5":"Em seguida, imole o bezerro diante de Javé. Os sacerdotes, filhos de Aarão, oferecerão o sangue e derramá-lo-ão por todos os lados do altar que está na entrada da tenda da reunião."
,"6":"Depois, esfole a vítima e esquarteje-a."
,"7":"Os sacerdotes, filhos de Aarão, acenderão o fogo sobre o altar, e sobre o fogo empilharão a lenha."
,"8":"Depois colocarão os pedaços de carne, com a cabeça e a gordura, em cima da lenha que está sobre o altar."
,"9":"Lavarão as entranhas e as patas. E o sacerdote queimará tudo sobre o altar. É um holocausto: oferta queimada, de suave odor para Javé."
,"10":"Se for holocausto de animal pequeno, cordeiro ou cabrito, ofereça um macho sem defeito;"
,"11":"imole-o no lado Norte do altar, diante de Javé. Os sacerdotes, filhos de Aarão, derramarão o sangue por todos os lados do altar."
,"12":"O sacerdote esquartejá-lo-á, e colocará as partes, juntamente com a cabeça e a gordura, em cima da lenha que está sobre o altar."
,"13":"Lavarão as entranhas e as patas. E o sacerdote queimará tudo sobre o altar. É um holocausto: oferta queimada, de suave odor para Javé."
,"14":"Se for holocausto de aves, a oferta será de uma rola ou de um pombinho."
,"15":"O sacerdote levá-la-á até ao altar e, destroncando-lhe o pescoço, queimá-la-á sobre o altar, depois de deixar escorrer o sangue sobre a parede do altar."
,"16":"Tirará o papo e as penas, atirando-os para o Leste do altar, para cima das cinzas."
,"17":"Dividirá a ave ao meio, uma asa de cada lado, mas sem separar as partes. Então o sacerdote queimará a ave no altar, em cima da lenha que está sobre o fogo. É um holocausto: oferta queimada, de suave odor para Javé."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Quando alguém fizer uma oblação a Javé, a sua oferta será de flor de farinha; sobre ela derramará azeite e colocará incenso."
,"2":"A pessoa levará a oferta aos sacerdotes, filhos de Aarão, e um deles tomará um punhado de flor de farinha, com o azeite e todo o incenso, e queimá-la-á sobre o altar como memorial. É uma oferta queimada, de suave odor para Javé."
,"3":"O resto ficará para Aarão e seus filhos. É a porção sagrada da oblação a Javé."
,"4":"Quando ofereceres uma oblação cozida no forno, será de roscas sem fermento, feitas de flor de farinha amassada com azeite; ou de bolinhos sem fermento, untados com azeite."
,"5":"Se a oblação for cozida na assadeira, será de flor de farinha sem fermento, amassada com azeite."
,"6":"Parti-la-ás em pedaços e deitar-lhe-ás azeite por cima. É uma oblação."
,"7":"Se a oblação for cozida na panela, a flor de farinha será preparada com azeite."
,"8":"Leva a oblação a Javé, entregando-a ao sacerdote, que a colocará junto do altar."
,"9":"O sacerdote tirará uma parte como memorial, e queimá-la-á sobre o altar. É uma oblação de suave odor para Javé."
,"10":"O resto da oblação será de Aarão e seus filhos. É a porção sagrada da oblação a Javé."
,"11":"Nenhuma oblação que fizerdes a Javé será preparada com fermento, porque nada que contenha fermento ou mel será queimado em oblação a Javé."
,"12":"Podereis oferecer essas coisas a Javé como primícias, mas não as colocareis sobre o altar como perfume de suave odor."
,"13":"Deitai sal em todas as oblações que oferecerdes. Não deixeis de colocar na oblação o sal da aliança do vosso Deus. Todas as oblações serão oferecidas com sal."
,"14":"Se fizeres uma oblação de primícias a Javé, deverá ser de grãos de espigas tostadas ao fogo ou de pão cozido com grãos moídos."
,"15":"Sobre ela, derramarás azeite e colocarás incenso, pois é uma oblação."
,"16":"O sacerdote queimará, como memorial, uma parte do pão com o azeite e todo o incenso. É uma oblação a Javé."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Se for sacrifício de comunhão, e se ofereceres a Javé um animal grande, macho ou fêmea, deverá ser sem defeito."
,"2":"Coloca a mão sobre a cabeça da vítima e imola-a à entrada da tenda da reunião. Em seguida os sacerdotes, filhos de Aarão, derramarão o sangue por todos os lados do altar."
,"3":"Do sacrifício de comunhão, oferece a Javé a gordura que cobre as entranhas e toda a gordura das entranhas,"
,"4":"os dois rins com a gordura, a gordura que envolve os lombos e a massa gordurosa tirada do fígado e dos rins."
,"5":"Os filhos de Aarão queimarão essa parte no altar, por cima do holocausto, em cima da lenha colocada sobre o fogo. É uma oferta queimada, de suave odor para Javé."
,"6":"Se alguém oferecer um animal pequeno como sacrifício de comunhão a Javé, deverá oferecer um macho ou uma fêmea sem defeito."
,"7":"Se oferecer um cordeiro, leve-o à presença de Javé."
,"8":"Coloque a mão sobre a cabeça da vítima e imole-a diante da tenda da reunião. Os sacerdotes, filhos de Aarão, derramarão o sangue por todos os lados do altar."
,"9":"Do sacrifício de comunhão, ofereçam a Javé a gordura: a cauda inteira, que será cortada rente à espinha dorsal, a gordura que cobre as entranhas e toda a gordura das entranhas,"
,"10":"os dois rins com a gordura, a gordura que envolve os lombos e a massa gordurosa tirada do fígado e dos rins."
,"11":"O sacerdote queimará essa parte sobre o altar como alimento, como oferta queimada para Javé."
,"12":"Se a oferta for uma cabra, leve-a diante de Javé."
,"13":"Coloque a mão sobre a cabeça da vítima e imole-a diante da tenda da reunião. Os filhos de Aarão derramarão o sangue por todos os lados do altar."
,"14":"Da vítima, ofereçam a Javé a gordura que cobre as entranhas, toda a gordura das entranhas,"
,"15":"os dois rins com a gordura, a gordura que envolve os lombos e a massa gordurosa tirada do fígado e dos rins."
,"16":"O sacerdote queimará sobre o altar esses pedaços como alimento, como oferta queimada, de suave odor. Toda a gordura pertence a Javé. "
,"17":"É uma lei perpétua para todos os vossos descendentes, onde quer que morem: não comais gordura nem sangue»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel: No caso de alguém transgredir sem querer algum dos mandamentos de Javé, fazendo uma coisa proibida:"
,"3":"Se foi o sacerdote consagrado quem cometeu a violação, comprometendo assim todo o povo, deverá oferecer a Javé, pela violação cometida, um bezerro, animal grande, sem defeito."
,"4":"Levará o bezerro diante de Javé, à entrada da tenda da reunião, colocará a mão sobre a cabeça do animal e o imolará diante de Javé."
,"5":"Depois o sacerdote consagrado tomará sangue do bezerro e levá-lo-á à tenda da reunião."
,"6":"Molhará o dedo no sangue e fará sete aspersões na frente do véu do santuário, diante de Javé."
,"7":"O sacerdote colocará então um pouco desse sangue sobre os cantos do altar do incenso que se queima diante de Javé na tenda da reunião, e derramará todo o sangue do bezerro na base do altar dos holocaustos, que se encontra à entrada da tenda da reunião."
,"8":"O sacerdote tirará toda a gordura do bezerro da expiação: a gordura que cobre as entranhas, toda a gordura das entranhas,"
,"9":"os dois rins e os lombos com a sua gordura, a massa gordurosa tirada do fígado e dos rins,"
,"10":"tudo conforme a parte reservada no sacrifício de comunhão. E o sacerdote queimará essas partes sobre o altar dos holocaustos."
,"11":"A pele do bezerro e toda a sua carne, com a cabeça, patas, entranhas e excrementos,"
,"12":"isto é, o bezerro todo será levado para fora do acampamento, para um lugar puro, onde se deitam as cinzas, e será queimado sobre a lenha. Deverá ser queimado no lugar em que se deitam as cinzas."
,"13":"Se foi a comunidade toda de Israel que, sem querer, violou alguma coisa proibida pelos mandamentos de Javé, tornando-se por isso culpada, mas sem tomar consciência do facto,"
,"14":"ao dar-se conta da violação cometida, a comunidade oferecerá, em sacrifício pelo pecado, um bezerro, animal grande e sem defeito. Ele será levado diante da tenda da reunião,"
,"15":"e, diante de Javé, os anciãos da comunidade colocarão as mãos sobre a cabeça do bezerro e imolá-lo-ão diante de Javé."
,"16":"Em seguida, o sacerdote consagrado levará um pouco do sangue do bezerro para a tenda da reunião."
,"17":"Molhará o dedo no sangue e fará sete aspersões na frente do véu, diante de Javé."
,"18":"Ungirá com sangue os cantos do altar, que se encontra diante de Javé na tenda da reunião, e depois derramará todo o sangue na base do altar dos holocaustos, que está à entrada da tenda da reunião."
,"19":"Depois tirará do animal toda a gordura e queimá-la-á no altar."
,"20":"Fará com esse bezerro como se faz com o do sacrifício pelo pecado. Assim o sacerdote fará o rito pelos membros da comunidade, e eles serão perdoados."
,"21":"Depois mandará levar o bezerro para fora do acampamento e queimá-lo-á, como fez com o bezerro anterior. Esse é o sacrifício pelo pecado da comunidade."
,"22":"Se foi um chefe quem, sem querer, violou alguma coisa proibida pelos mandamentos de Javé, seu Deus, tornando-se por isso culpado,"
,"23":"ao dar-se conta da violação cometida, levará como oferta um bode sem defeito."
,"24":"Colocará a mão sobre a cabeça do bode e imolá-lo-á diante de Javé, no lugar onde se imolam os holocaustos. É um sacrifício pelo pecado:"
,"25":"o sacerdote molhará o dedo no sangue da vítima e ungirá os cantos do altar dos holocaustos. Depois derramará o sangue na base do altar dos holocaustos"
,"26":"e queimará toda a gordura sobre o altar, como se faz com a gordura do sacrifício de comunhão. O sacerdote fará, assim, pela violação do chefe, e este ficará perdoado."
,"27":"Se foi um homem do povo da terra quem pecou sem querer, praticando alguma coisa proibida pelos mandamentos de Javé, tornando-se por isso culpado,"
,"28":"ao dar-se conta da violação cometida, levará uma cabra sem defeito, como oferta pelo pecado."
,"29":"Colocará a mão sobre a cabeça da vítima e imolá-la-á no lugar onde se imolam os holocaustos."
,"30":"O sacerdote molhará o dedo no sangue da vítima e ungirá os cantos do altar dos holocaustos. Depois derramará todo o sangue na base do altar."
,"31":"Em seguida tirará toda a gordura, como se faz pelo sacrifício de comunhão, e queimá-la-á sobre o altar, como suave odor a Javé. O sacerdote fará, assim, o rito pelo pecado desse homem, e este ficará perdoado."
,"32":"Se alguém oferecer uma ovelha como sacrifício pelo pecado, ela será sem defeito."
,"33":"Colocará a mão sobre a cabeça da vítima e imolá-la-á, em sacrifício pelo pecado, no lugar onde se imolam os holocaustos."
,"34":"O sacerdote molhará o dedo no sangue da vítima e ungirá os cantos do altar dos holocaustos. Depois derramará o sangue todo na base do altar."
,"35":"Em seguida tirará toda a gordura, como se faz com o cordeiro de um sacrifício de comunhão, e queimará essas partes no altar, em cima das ofertas queimadas para Javé. O sacerdote fará, assim, o rito pelo pecado desse homem, e este ficará perdoado."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Se alguém for intimado a depor em juízo, e não denunciar, mesmo sendo testemunha ocular ou informada, peca e incorre em culpa."
,"2":"Ou se alguém, sem se dar conta, tocar em alguma coisa impura, tanto o cadáver de uma fera impura, como o cadáver de um animal doméstico impuro, ou de um réptil impuro, incorre em culpa quando toma consciência do facto."
,"3":"Ou se alguém, sem se dar conta, tocar em pessoa impura, manchada com qualquer espécie de impureza, incorre em culpa quando toma consciência do facto."
,"4":"Ou se alguém, sem se dar conta, jura irresponsavelmente para o mal ou para o bem, como se costuma fazer, incorre em culpa quando toma consciência do facto."
,"5":"Se alguém se tornar culpado por alguma dessas coisas, deverá confessar o pecado cometido;"
,"6":"e, como penitência pelo pecado, oferecerá a Javé, pela violação, uma fêmea de gado pequeno, ovelha ou cabra. O sacerdote fará por essa pessoa o rito pelo pecado."
,"7":"Se a pessoa não tiver recursos para oferecer um animal pequeno, como sacrifício pelo pecado que cometeu, levará para Javé duas rolas ou dois pombinhos, um deles para o sacrifício pelo pecado e o outro para o holocausto."
,"8":"A pessoa levá-los-á ao sacerdote, que oferecerá em primeiro lugar o que for destinado em sacrifício pelo pecado. O sacerdote destroncará o pescoço da ave, sem arrancar a cabeça."
,"9":"Com o sangue da vítima aspergirá a parede do altar e, em seguida, espremerá o resto do sangue na base do altar. É um sacrifício pelo pecado."
,"10":"Quanto à outra ave, fará um holocausto conforme o ritual. O sacerdote fará, assim, o rito pelo pecado desse homem, e este ficará perdoado."
,"11":"Se a pessoa não tiver recursos para oferecer duas rolas ou dois pombinhos, levará quatro litros e meio de flor de farinha como oferta pelo pecado cometido. Não colocará nela nem azeite nem incenso, pois é um sacrifício pelo pecado."
,"12":"Depois levará a farinha ao sacerdote, que tomará um punhado como memorial, para ser queimado no altar, em cima das ofertas para Javé. É um sacrifício pelo pecado."
,"13":"O sacerdote fará, assim, o rito pelo pecado que um homem cometeu num desses casos, e o pecado ficará perdoado. O resto, tal como nas ofertas de flor de farinha, pertence ao sacerdote»."
,"14":"Javé disse a Moisés:"
,"15":"«Se alguém cometer uma falta, levando sem querer alguma coisa consagrada a Javé, oferecerá a Javé, como penitência, um cordeiro sem defeito, avaliado em vinte gramas de prata, conforme o peso-padrão que está no santuário."
,"16":"E, ao pagar, reparará o dano com o acréscimo de um quinto, e entregando tudo ao sacerdote. Este fará o rito com o cordeiro do sacrifício de reparação por ele, e ficará perdoado."
,"17":"Se alguém, sem se dar conta, praticar alguma coisa proibida pelos mandamentos de Javé, será responsável e carregará o peso da sua falta."
,"18":"Como sacrifício de reparação, levará ao sacerdote um cordeiro sem defeito, avaliado em proporção com a culpa. O sacerdote fará o rito pelo pecado cometido sem saber, e o pecador ficará perdoado."
,"19":"É um sacrifício de reparação, e esse homem é responsável diante de Javé»."
,"20":"Javé disse a Moisés:"
,"21":"«Se alguém cometer uma falta contra Javé, recusando devolver ao seu próximo um depósito recebido ou penhor a ele confiado ou alguma coisa roubada ou tirada à força com fraude;"
,"22":"ou, se encontrar uma coisa perdida e o negar, jurando falsamente sobre alguma das coisas pelas quais o homem pode pecar;"
,"23":"se houver pecado assim, tornando-se por isso culpado, devolverá a coisa roubada, ou tirada à força com fraude, ou o depósito a ele confiado, ou o objecto perdido que tenha encontrado,"
,"24":"ou qualquer coisa pela qual tenha jurado em falso. Fará a restituição integral, acrescentando um quinto, e devolvê-lo-á ao proprietário no mesmo dia em que oferecer o sacrifício de reparação."
,"25":"Como sacrifício de reparação em honra de Javé, levará ao sacerdote um cordeiro sem defeito, avaliado em proporção com a culpa."
,"26":"O sacerdote fará por ele o rito diante de Javé e receberá o perdão de qualquer falta que tenha cometido»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Javé disse a Moisés:"
,"2":"«Dá estas ordens a Aarão e seus filhos: O holocausto ficará a queimar sobre o fogo do altar durante a noite até à manhã seguinte, e o fogo do altar será mantido aceso. "
,"3":"O sacerdote vestirá a sua túnica de linho e um calção de linho. Depois retirará do altar a cinza deixada pelo fogo ao queimar o holocausto, e deixá-la-á junto do altar."
,"4":"Depois mudará de roupa, a fim de transportar essa cinza para um lugar puro, fora do acampamento."
,"5":"O fogo do altar nunca deverá ser apagado. Todas as manhãs o sacerdote lhe acrescentará mais lenha; colocará sobre ela o holocausto, e nela queimará as gorduras do sacrifício de comunhão."
,"6":"É um fogo perpétuo, que deverá arder sobre o altar, sem nunca se apagar."
,"7":"Os filhos de Aarão devem levar a oblação ao altar, diante de Javé."
,"8":"O sacerdote tomará um punhado de flor de farinha com azeite e com todo o incenso colocado sobre a oferta, e queimará tudo no altar, como memorial de suave odor para Javé."
,"9":"O resto da oblação será comido por Aarão e seus filhos; deverá ser comido sem fermento, em lugar santo, no átrio da tenda da reunião."
,"10":"Não cozinharão com fermento a porção que lhes dou das minhas ofertas queimadas. É uma porção sagrada, como no sacrifício pelo pecado e no sacrifício de reparação."
,"11":"Todos os homens dos filhos de Aarão poderão comer dessa porção das ofertas queimadas a Javé. É uma lei perpétua para todas as vossas gerações. Tudo o que entrar em contacto com essas coisas ficará consagrado»."
,"12":"Javé disse a Moisés:"
,"13":"«Esta é a oblação que Aarão e seus filhos farão a Javé no dia em que forem ungidos: quatro litros e meio de flor de farinha, como oblação perpétua, metade de manhã e metade à tarde."
,"14":"Será preparada na assadeira com azeite, e bem mexida. Será triturada em pedaços que serão oferecidos como perfume de suave odor a Javé."
,"15":"O sacerdote consagrado que te suceder fará o mesmo. É uma lei perpétua: a oblação será queimada completamente para Javé."
,"16":"Toda a oblação feita por um sacerdote deve ser totalmente queimada; ninguém comerá dela»."
,"17":"Javé disse a Moisés:"
,"18":"«Diz a Aarão e a seus filhos: A vítima pelo pecado será imolada diante de Javé, no mesmo lugar onde se imola o holocausto. É porção sagrada."
,"19":"O sacerdote que oferecer a vítima poderá comer dela. Deverá comê-la em lugar sagrado, no átrio da tenda da reunião."
,"20":"Tudo o que tocar a carne ficará consagrado. Se o sangue respingar sobre a roupa, a mancha será lavada em lugar sagrado."
,"21":"A vasilha de barro em que a carne foi cozida será quebrada. E se foi cozida numa vasilha de bronze, esta será esfregada e bem lavada com água."
,"22":"Todos os homens sacerdotes poderão comer dela. É porção sagrada."
,"23":"Mas não se comerá nenhuma das vítimas oferecidas pelo pecado, cujo sangue tenha sido levado para a tenda da reunião, para ser oferecida no santuário pelo pecado; elas deverão ser queimadas."
}`)
	CurrentBook.AddChapter(7, `{
"1":"O ritual do sacrifício de reparação é o seguinte: É uma porção sagrada."
,"2":"No lugar onde se imola o holocausto, deverá ser imolada a vítima do sacrifício de reparação, e o sacerdote espalhará o sangue dela por todos os lados do altar."
,"3":"Oferecerá toda a gordura: a cauda, a gordura que cobre as entranhas,"
,"4":"os dois rins com a sua gordura, a gordura que envolve os lombos, e a massa gordurosa tirada do fígado e dos rins."
,"5":"O sacerdote queimará no altar essas partes, como oblação a Javé. É um sacrifício de reparação:"
,"6":"qualquer sacerdote poderá comer dele. Será comido em lugar sagrado, pois é uma porção sagrada."
,"7":"O mesmo rito serve para o sacrifício pelo pecado e para o sacrifício de reparação. A oferta usada para o rito pelo pecado pertence ao sacerdote."
,"8":"A pele da vítima pertence ao sacerdote que oferece o holocausto."
,"9":"Toda a oblação cozida no forno, ou preparada em panela ou assadeira, pertence ao sacerdote celebrante."
,"10":"E toda a oblação, amassada com azeite, ou seca, pertence indistintamente aos filhos de Aarão."
,"11":"Esta é a lei para o sacrifício de comunhão que se oferecerá a Javé:"
,"12":"Se alguém oferece um sacrifício de acção de graças, oferecerá, juntamente com o sacrifício de comunhão, bolos sem fermento amassados com azeite, bolinhos sem fermento untados com azeite, e flor de farinha embebida em azeite."
,"13":"Além disso, ao sacrifício de comunhão e de acção de graças acrescentar-se-á pão fermentado."
,"14":"De cada uma dessas ofertas, uma parte será oferecida em honra de Javé e pertencerá ao sacerdote que tiver espalhado o sangue da vítima do sacrifício de comunhão."
,"15":"A carne do sacrifício de acção de graças deverá ser comida no mesmo dia em que o sacrifício for oferecido: não deverá sobrar nada para a manhã seguinte."
,"16":"Se a vítima for oferecida como sacrifício votivo ou voluntário, será comida no dia em que for oferecida, ou no dia seguinte."
,"17":"Mas o que sobrar da carne da vítima será queimado no terceiro dia."
,"18":"Se alguém comer no terceiro dia alguma coisa da carne oferecida em sacrifício de comunhão, aquele que a tiver oferecido não será aceite. O seu sacrifício não será tido em conta, pois é carne estragada, e a pessoa que dela comer sofrerá a pena da sua culpa."
,"19":"A carne que tiver tocado qualquer coisa impura não poderá ser comida; será lançada ao fogo. Quem estiver puro poderá comer a carne do sacrifício de comunhão. "
,"20":"Mas se alguém estiver impuro e comer a carne de um sacrifício de comunhão oferecido a Javé, será exterminado do meio do seu povo."
,"21":"Se alguém tocar em alguma coisa impura, seja de homem, animal, ou qualquer outra coisa impura, e em seguida comer a carne de um sacrifício de comunhão oferecido a Javé, será exterminado do meio do seu povo»."
,"22":"Javé disse a Moisés:"
,"23":"«Diz aos filhos de Israel: Não comais gordura de boi, de carneiro ou de cabra."
,"24":"A gordura de um animal morto ou dilacerado poderá servir para qualquer outro uso; mas de modo nenhum a comereis."
,"25":"Quem comer a gordura de animais oferecidos em sacrifício queimado em honra de Javé, será eliminado do meio do seu povo."
,"26":"Onde quer que habiteis, não comereis sangue de aves nem de animais domésticos."
,"27":"Quem comer qualquer espécie de sangue será eliminado do meio do seu povo»."
,"28":"Javé disse a Moisés:"
,"29":"«Diz aos filhos de Israel: Quem oferecer um sacrifício de comunhão a Javé, deverá levar uma parte do sacrifício como oferta a Javé."
,"30":"Levará com as próprias mãos as ofertas queimadas a Javé: levará a gordura e o peito, com os quais fará o gesto de apresentação diante de Javé."
,"31":"O sacerdote queimará a gordura no altar, e o peito pertencerá a Aarão e seus filhos."
,"32":"Como tributo dos sacrifícios de comunhão, dareis ao sacerdote a coxa direita."
,"33":"A coxa direita é a parte que caberá ao filho de Aarão que tiver oferecido o sangue e a gordura do sacrifício de comunhão;"
,"34":"porque, dos sacrifícios de comunhão dos filhos de Israel, Eu reservei para Mim o peito e a coxa do tributo, e dou-os ao sacerdote Aarão e a seus filhos: é uma lei perpétua para os filhos de Israel."
,"35":"Esta é a parte de Aarão e de seus filhos entre as ofertas queimadas para Javé, desde o dia em que foram apresentados a Javé para serem seus sacerdotes."
,"36":"Foi isto que Javé ordenou que os filhos de Israel lhes dessem desde o dia em que foram ungidos. É uma lei perpétua para todos os seus descendentes»."
,"37":"Este é o ritual do holocausto, da oblação, do sacrifício pelo pecado, do sacrifício de reparação, do sacrifício de consagração e do sacrifício de comunhão."
,"38":"Foi isto que Javé ordenou a Moisés no monte Sinai, no dia em que ordenou aos filhos de Israel que apresentassem as suas ofertas a Javé no deserto do Sinai."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Javé disse a Moisés:"
,"2":"«Toma Aarão e seus filhos, as vestes, o óleo da unção, o bezerro do sacrifício pelo pecado, os dois cordeiros e o cesto dos pães sem fermento."
,"3":"Em seguida convoca toda a comunidade junto à entrada da tenda da reunião»."
,"4":"Moisés fez conforme Javé lhe havia ordenado. E toda a comunidade se reuniu à entrada da tenda da reunião."
,"5":"Moisés disse-lhes: «Vede o que Javé mandou fazer»."
,"6":"Depois Moisés fez com que Aarão e seus filhos se aproximassem, e lavou-os com água."
,"7":"Revestiu Aarão com a túnica, colocou-lhe o cinto, vestiu-o com o manto e colocou nele o efod. Depois colocou a faixa do efod e fixou-a em Aarão."
,"8":"Colocou-lhe o peitoral com os urim e os tumim."
,"9":"Colocou-lhe o turbante na cabeça e, na frente do turbante, a flor de ouro: é o sinal da santa consagração, conforme Javé ordenou a Moisés."
,"10":"Então Moisés pegou no óleo da unção e ungiu o santuário e tudo o que nele havia, para os consagrar."
,"11":"Fez sete aspersões sobre o altar, e ungiu o altar e os seus acessórios, a bacia com a sua base, a fim de os consagrar."
,"12":"Depois derramou o óleo da unção sobre a cabeça de Aarão e ungiu-o, para o consagrar."
,"13":"A seguir, mandou que os filhos de Aarão se aproximassem, revestiu-os com túnicas, colocou neles o cinto e atou-lhes o barrete, conforme Javé ordenou a Moisés."
,"14":"Então Moisés mandou trazer o bezerro do sacrifício pelo pecado. Aarão e seus filhos colocaram a mão sobre a cabeça da vítima,"
,"15":"e Moisés imolou-a. Depois tomou o sangue e, com o dedo, ungiu os cantos do altar em todos os lados, para purificar o altar. A seguir, derramou o sangue na base do altar e consagrou-o, fazendo por ele o rito pelo pecado."
,"16":"Tomou ainda toda a gordura que envolve as entranhas, a massa gordurosa do fígado, os dois rins com a sua gordura, e queimou tudo sobre o altar."
,"17":"O resto do bezerro: pele, carne e intestinos, queimou-os fora do acampamento, conforme Javé ordenou a Moisés."
,"18":"Mandou, então, trazer o cordeiro do holocausto. Aarão e seus filhos colocaram a mão sobre a cabeça do cordeiro,"
,"19":"e Moisés imolou-o, derramando o sangue por todos os lados do altar."
,"20":"Depois esquartejou o cordeiro e queimou a cabeça e os pedaços com a gordura."
,"21":"Lavou com água as entranhas e as patas, e queimou todo o cordeiro no altar. Foi um holocausto de suave odor, uma oferta queimada para Javé, conforme Javé havia ordenado a Moisés."
,"22":"Mandou, então, trazer o segundo cordeiro, o cordeiro da consagração. Aarão e seus filhos colocaram a mão sobre a cabeça do cordeiro,"
,"23":"e Moisés imolou-o. Depois tomou o sangue e colocou-o no lóbulo da orelha direita de Aarão, no polegar da sua mão direita e no polegar do seu pé direito."
,"24":"Em seguida mandou aproximar os filhos de Aarão e colocou-lhes do mesmo sangue no lóbulo da orelha direita, no polegar da mão direita e no polegar do pé direito. Em seguida Moisés derramou o sangue por todos os lados do altar;"
,"25":"tomou as partes gordas, a cauda, toda a gordura das entranhas, a massa gordurosa do fígado, os dois rins com a sua gordura e a coxa direita."
,"26":"Depois tomou um pão sem fermento do cesto que estava diante de Javé, um bolo amassado com azeite e um bolinho, e juntou tudo com as gorduras e a coxa direita."
,"27":"Colocou tudo nas mãos de Aarão e de seus filhos, e fez o gesto de apresentação diante de Javé."
,"28":"Depois Moisés tomou tudo das mãos deles e queimou-o no altar, em cima do holocausto. Foi o sacrifício de consagração: oblação de suave odor, uma oferta queimada para Javé."
,"29":"Moisés tomou também o peito da vítima e fez o gesto de apresentação diante de Javé. Esta era a parte do cordeiro da consagração que pertencia a Moisés, conforme Javé ordenou a Moisés."
,"30":"Em seguida Moisés tomou um pouco do óleo da unção e do sangue que estava sobre o altar, e com isso aspergiu Aarão e suas vestes, e também os seus filhos com as suas vestes. Foi deste modo que Moisés consagrou Aarão e suas vestes, e também os filhos de Aarão com suas vestes."
,"31":"Moisés disse a Aarão e seus filhos: «Cozinhai a carne à entrada da tenda da reunião e comei a carne com o pão que está no cesto do sacrifício da consagração, conforme ordenei: devem comê-la Aarão e seus filhos."
,"32":"Queimai o que sobrar da carne e do pão."
,"33":"Durante sete dias não saireis pela porta da tenda da reunião, até que tenha terminado o tempo de consagração, porque são necessários sete dias para a vossa consagração."
,"34":"Javé mandou proceder como se fez hoje, a fim de realizar por vós o rito pelo pecado."
,"35":"Permanecereis sete dias e sete noites à entrada da tenda da reunião, e respeitareis as proibições de Javé, a fim de não morrerdes. Esta é a ordem que recebi»."
,"36":"Aarão e seus filhos fizeram tudo o que Javé havia mandado por meio de Moi-sés."
}`)
	CurrentBook.AddChapter(9, `{
"1":"No oitavo dia, Moisés chamou Aarão, os seus filhos e os anciãos de Israel,"
,"2":"e disse a Aarão: «Toma um bezerro para o sacrifício pelo pecado e um cordeiro para o holocausto, ambos sem defeito, e oferece-os diante de Javé."
,"3":"Em seguida diz aos filhos de Israel: 'Tomai um bode para o sacrifício pelo pecado, um bezerro e um carneiro, ambos de um ano, sem defeito, para o holocausto,"
,"4":"um touro e um cordeiro para o sacrifício de comunhão, todos para serem imolados diante de Javé, e também uma oblação amassada com azeite, porque Javé vai aparecer-vos hoje'»."
,"5":"Levaram para diante da tenda da reunião o que Moisés havia mandado, e toda a comunidade se aproximou e se apresentou diante de Javé."
,"6":"Moisés disse: «Cumpri tudo o que Javé vos ordenou. Então mostrar-vos-á a sua glória»."
,"7":"Depois disse a Aarão: «Aproxima-te do altar e oferece o teu sacrifício pelo pecado e o teu holocausto. Faz deste modo a expiação por ti e pela tua família. Apresenta depois a oferta do povo e faz por ele o sacrifício pelo pecado, conforme Javé ordenou»."
,"8":"Aarão aproximou-se do altar e imolou o bezerro do sacrifício pelo seu próprio pecado."
,"9":"Em seguida os filhos de Aarão apresentaram-lhe o sangue. Aarão molhou o dedo no sangue e ungiu os cantos do altar. Depois derramou o sangue na base do altar."
,"10":"Queimou sobre o altar a gordura do sacrifício pelo pecado, os rins e a massa gordurosa do fígado, conforme Javé havia ordenado a Moisés."
,"11":"Depois queimou a carne e a pele fora do acampamento."
,"12":"Em seguida imolou a vítima do holocausto. Os filhos de Aarão levaram-lhe o sangue, que ele derramou por todos os lados do altar."
,"13":"Também levaram a vítima dividida em quatro pedaços com a cabeça, e ele queimou-os no altar."
,"14":"Lavou as entranhas e as patas, e queimou-as no altar, em cima do holocausto."
,"15":"A seguir apresentou a oferta do po-vo: pegou no bode do sacrifício pelo pecado do povo, imolou-o e ofereceu-o em sacrifício pelo pecado, da mesma forma que fez com a primeira vítima."
,"16":"Mandou buscar também a vítima do holocausto, e ofereceu o holocausto, conforme o ritual."
,"17":"Em seguida mandou buscar a oblação, tomou dela um punhado, e queimou-o no altar, além do holocausto da manhã."
,"18":"Por fim, imolou o touro e o cordeiro em sacrifício de comunhão pelo povo. Os filhos de Aarão levaram-lhe o sangue, que ele derramou por todos os lados do altar."
,"19":"As gorduras desse touro e desse cordeiro, a cauda, a gordura que envolve as entranhas, os rins e a massa gordurosa do fígado,"
,"20":"ele colocou-os sobre o peito das vítimas e queimou tudo no altar."
,"21":"Aarão fez o gesto de apresentação diante de Javé com o peito e a coxa direita de cada vítima, conforme Javé havia ordenado a Moisés."
,"22":"Aarão levantou as mãos na direcção do povo e abençoou-o. Depois de oferecer o sacrifício pelo pecado, o holocausto e o sacrifício de comunhão, desceu"
,"23":"e entrou com Moisés na tenda da reunião. Em seguida os dois saíram para abençoar o povo. A glória de Javé apareceu a todo o povo:"
,"24":"uma chama brilhou diante de Javé e devorou o holocausto e as gorduras que estavam sobre o altar. Ao ver isto, o povo aclamou e prostrou-se com o rosto por terra."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Nadab e Abiú, filhos de Aarão, tomaram cada um o seu incensório. Puseram neles fogo e incenso, e apresentaram diante de Javé um fogo irregular, que não lhes havia sido autorizado."
,"2":"Então, da presença de Javé saiu um fogo que os devorou, e morreram na presença de Javé."
,"3":"Foi quando Moisés disse a Aarão: «É isto que Javé queria dizer, quando disse: 'Eu mostrarei a minha santidade nos meus ministros, e a minha glória diante de todo o povo'».Aarão ficou calado."
,"4":"Moisés chamou Misael e Elisafã, filhos de Oziel, tio de Aarão, e disse-lhes: «Retirai os vossos irmãos do santuário e levai-os para longe do acampamento»."
,"5":"Eles aproximaram-se e levaram-nos nas suas próprias túnicas para fora do acampamento, conforme Moisés havia mandado."
,"6":"Moisés disse a Aarão e a seus filhos Eleazar e Itamar: «Não desmancheis o cabelo nem rasgueis as roupas, para não morrerdes e para que Javé não fique irritado contra toda a comunidade. Os vossos irmãos e toda a casa de Israel deverão chorar por causa do incêndio que Javé provocou."
,"7":"Não deixeis a entrada da tenda da reunião para não morrerdes, porque fostes ungidos com o óleo de Javé».E eles fizeram como Moisés havia mandado."
,"8":"Javé disse a Aarão:"
,"9":"«Quando vieres à tenda da reunião, juntamente com os teus filhos, não bebais vinho, nem outra bebida fermentada, e assim não morrereis. É uma lei perpétua para todos os vossos descendentes."
,"10":"Isto para que possais distinguir entre o sagrado e o profano, e entre o impuro e o puro,"
,"11":"e possais ensinar aos filhos de Israel todas as leis que Javé vos deu por meio de Moisés»."
,"12":"Moisés disse a Aarão e a Eleazar e Itamar, seus filhos que sobreviveram: «Tomai a oblação que sobrou das ofertas queimadas para Javé, e comei-a sem fermento, junto do altar, porque é porção sagrada."
,"13":"Comê-la-eis no lugar sagrado, pois é a parte das ofertas queimadas a Javé que fica reservada para vós e vossos filhos. Assim é que me foi ordenado."
,"14":"O peito apresentado e a coxa do tributo comê-la-eis em lugar puro, juntamente com os vossos filhos e filhas: é a parte reservada para ti e teus filhos, que te é dada dos sacrifícios de comunhão dos filhos de Israel."
,"15":"A coxa do tributo e o peito apresentado, que acompanham as gorduras queimadas, depois de oferecidos com gesto de apresentação diante de Javé, pertencem a ti e a teus filhos, como porção perpétua. Assim Javé o ordenou»."
,"16":"Moisés perguntou pelo bode oferecido em sacrifício pelo pecado. No entanto ele já tinha sido queimado. Por isso Moisés irritou-se com Eleazar e Itamar, os filhos sobreviventes de Aarão, e perguntou-lhes:"
,"17":"«Porque não comestes a vítima no lugar sagrado? É uma porção sagrada, e Javé deu-vo-la para que tirásseis a culpa da comunidade, fazendo sobre essa porção o rito pelo pecado diante de Javé."
,"18":"Uma vez que o sangue da vítima não foi levado para dentro do santuário, deveríeis comê-la no santuário, conforme eu ordenei»."
,"19":"Aarão respondeu a Moisés: «Eles ofereceram hoje o seu sacrifício pelo pecado e o seu holocausto diante de Javé e o mesmo aconteceu comigo. Se eu tivesse comido hoje do sacrifício pelo pecado, seria isso agradável a Javé?»"
,"20":"E Moisés ficou satisfeito com a resposta."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Javé disse a Moisés e a Aarão:"
,"2":"«Dizei aos filhos de Israel: São estes os quadrúpedes que podereis comer dentre todos os animais terrestres."
,"3":"Podereis comer todo o animal que tem o casco fendido, partido em duas unhas, e que rumina."
,"4":"Dentre os que ruminam ou têm o casco fendido, não podereis comer as seguintes espécies: o camelo, pois, embora seja ruminante, não tem o casco fendido; ele deve ser considerado impuro."
,"5":"Considerai impuro o coelho, pois, embora seja ruminante, não tem o casco fendido."
,"6":"Considerai impura a lebre, pois, embora seja ruminante, não tem o casco fendido."
,"7":"Considerai impuro o porco, pois, apesar de ter o casco fendido, partido em duas unhas, não rumina."
,"8":"Não comais a carne desses animais, nem toqueis no seu cadáver, porque são impuros."
,"9":"De todos os animais aquáticos, podereis comer os que têm barbatanas e escamas, e vivem na água dos mares e rios."
,"10":"Mas todo aquele que não tem barbatanas e escamas e vive nos mares ou rios, todos os animais pequenos que povoam as águas, e todos os seres vivos que nelas se encontram, considerá-los-eis imundos."
,"11":"Eles são imundos; por isso, não comais a sua carne e considerai imundo o seu cadáver."
,"12":"Todo o ser aquático que não tem barbatanas e escamas será imundo para vós."
,"13":"Das aves, considerai imundas e não comais as seguintes, porque são imundas: o abutre, o gipaeto, o xofrango,"
,"14":"o milhafre negro, as diferentes espécies de milhafre vermelho,"
,"15":"todas as espécies de corvo,"
,"16":"o avestruz, a coruja, a gaivota e as diferentes espécies de gavião,"
,"17":"o mocho, o alcatraz, o íbis,"
,"18":"o grão-duque, o pelicano, o abutre branco,"
,"19":"a cegonha e as diferentes espécies de garça, a poupa e o morcego."
,"20":"Todos os animais alados, que caminham sobre quatro pés, serão imundos para vós."
,"21":"De todos os insectos alados, que caminham sobre quatro pés, só podereis comer aqueles que, para saltar no chão, têm as patas traseiras mais compridas que as dianteiras."
,"22":"Podeis comer os seguintes: as diferentes espécies de locustídeos, gafanhotos, acrídidas e grilos."
,"23":"Os outros insectos de quatro pés são imundos."
,"24":"Com esses animais, tornar-vos-eis impuros; quem tocar o seu cadáver ficará impuro até à tarde,"
,"25":"e quem lhes transportar o cadáver deverá lavar as roupas, e ficará impuro até à tarde."
,"26":"Considerareis impuros os animais que têm casco não dividido e que não ruminam: quem os tocar ficará impuro."
,"27":"Todos os animais de quatro patas, que caminham sobre a planta dos pés, serão considerados impuros; quem tocar o seu cadáver ficará impuro até à tarde,"
,"28":"e quem lhes transportar o cadáver deverá lavar as roupas, e ficará impuro até à tarde. Considerai impuros esses animais."
,"29":"Dos animais que rastejam pela terra, considerai impuros os seguintes: a toupeira, o rato e as diferentes espécies de lagarto,"
,"30":"a lagartixa, o crocodilo da terra, o lagarto, o lagarto da areia e o camaleão."
,"31":"De todos os répteis, são esses que considerareis impuros; quem os tocar depois de mortos ficará impuro até à tarde."
,"32":"E ficará impuro todo o objecto de madeira, pano, couro ou estopa, e qualquer outro utensílio sobre o qual um bicho desses cair depois de morto. Deverá ser lavado com água e ficará impuro até à tarde; depois ficará novamente puro."
,"33":"Toda a vasilha de barro, na qual um desses bichos cair, deverá ser quebrada, e o seu conteúdo ficará impuro;"
,"34":"a comida preparada com água dessa vasilha ficará impura, e também a bebida ficará impura, seja qual for o tipo de vasilha."
,"35":"Todo o objecto sobre o qual cair o cadáver desses bichos, ficará impuro: o forno e o fogão serão destruídos, porque ficaram impuros, e considerá-los-eis impuros."
,"36":"As fontes, poços e depósitos de água ficarão puros. Mas quem tocar o cadáver desses bichos ficará impuro."
,"37":"Se um desses cadáveres cai sobre uma semente, esta permanece pura;"
,"38":"mas se a semente estiver humedecida, e um desses cadáveres cair sobre ela, considerá-la-eis impura."
,"39":"Quando morrer um animal que serve de alimento, quem tocar o seu cadáver ficará impuro até à tarde;"
,"40":"quem comer a sua carne deverá lavar as roupas e ficará impuro até à tarde; quem transportar o cadáver dele deverá lavar as suas roupas e ficará impuro até à tarde."
,"41":"Todo o animal que rasteja no chão é imundo, e não será comido."
,"42":"Tudo o que se arrasta sobre o ventre ou que caminha sobre quatro ou mais patas, isto é, todos os répteis que rastejam pelo chão, nenhum deles é comestível, porque são imundos."
,"43":"Não vos torneis imundos com nenhum desses répteis que rastejam. Não vos contamineis com eles e não vos deixeis contaminar por eles."
,"44":"Eu sou Javé, o vosso Deus. Deveis santificar-vos e permanecer santos, porque Eu sou santo. Portanto, não vos torneis impuros com nenhum desses répteis que rastejam pelo chão."
,"45":"Eu sou Javé, que vos tirei do Egipto, para ser o vosso Deus: sede santos, porque Eu sou santo."
,"46":"Esta é a lei sobre os animais terrestres, as aves e todo o animal que se move na água ou rasteja sobre a terra."
,"47":"Esta lei ensina a separar o impuro do puro, os animais que se podem comer, dos que não se podem comer»."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel: Quando uma mulher conceber e der à luz um menino, ficará impura durante sete dias e também durante a sua menstruação."
,"3":"No oitavo dia, o prepúcio do menino será circuncidado;"
,"4":"e, durante trinta e três dias, ela ainda se deverá purificar do seu sangue. Não poderá tocar nenhuma coisa consagrada, nem ir ao santuário, enquanto não terminar o tempo da sua purificação."
,"5":"Se der à luz uma menina, ficará impura durante duas semanas, como durante a sua menstruação; e ficará mais sessenta e seis dias a purificar-se do seu sangue."
,"6":"Quando a mulher tiver terminado o período da sua purificação, seja por um menino, seja por uma menina, levará ao sacerdote, à entrada da tenda da reunião, um cordeiro de um ano para o holocausto, e um pombinho ou rola para o sacrifício pelo pecado."
,"7":"O sacerdote oferecê-los-á diante de Javé, realizará por ela o rito pelo pecado, e ela ficará purificada do seu fluxo de sangue. Esta é a lei sobre a mulher que dá à luz um menino ou menina."
,"8":"Se ela não tem meios para comprar um cordeiro, leve duas rolas ou dois pombinhos: um para o holocausto e outro para o sacrifício pelo pecado. O sacerdote fará por ela o rito pelo pecado, e ela ficará purificada»."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Javé disse a Moisés e Aarão:"
,"2":"«Quando alguém tiver na pele uma inflamação, um furúnculo ou qualquer mancha que produza suspeita de lepra, será levado diante do sacerdote Aarão ou de um dos seus filhos sacerdotes."
,"3":"O sacerdote examinará a parte afectada. Se no lugar doente o pêlo se tornou branco e a doença ficou mais profunda na pele, é caso de lepra. Depois de o examinar, o sacerdote declará-lo-á impuro."
,"4":"Mas se há sobre a pele uma mancha branca, sem depressão visível da pele, e o pêlo não se tornou branco, o sacerdote isolará o doente durante sete dias."
,"5":"No sétimo dia examinará de novo o doente: se observar que a doença permanece sem se espalhar pela pele, tornará a isolá-lo por mais sete dias;"
,"6":"no sétimo dia, examiná-lo-á novamente. Se então verificar que a mancha não ficou mais branca e não se espalhou pela pele, o sacerdote declarará puro o homem, pois trata-se de um furúnculo. A pessoa lavará a sua roupa e ficará pura."
,"7":"Mas se o furúnculo se alastrar sobre a pele depois de o enfermo ter sido examinado pelo sacerdote e declarado puro, ele deverá apresentar-se de novo ao sacerdote."
,"8":"O sacerdote examiná-lo-á; se observar que o furúnculo se alastrou sobre a pele, o sacerdote declará-lo-á impuro: trata-se de lepra."
,"9":"Quando alguém tiver uma infecção de pele, será levado ao sacerdote."
,"10":"O sacerdote examiná-lo-á. Se observar sobre a pele um tumor esbranquiçado, pêlos que se tornam brancos e o aparecimento de uma úlcera,"
,"11":"trata-se de lepra crónica de pele. O sacerdote declará-lo-á impuro e não o isolará, pois está impuro."
,"12":"Mas se a lepra se alastrar sobre a pele, até cobrir o doente dos pés à cabeça, até onde o sacerdote possa observar,"
,"13":"o sacerdote examinará o doente: verificando que a lepra cobre o corpo todo, declarará puro o doente, visto que tudo se tornou branco."
,"14":"Se aparecer nele a carne viva, ficará impuro."
,"15":"O sacerdote, vendo a carne viva, declará-lo-á impuro, pois a carne viva é impura: trata-se de lepra."
,"16":"Mas se a carne viva se torna branca de novo, a pessoa procurará o sacerdote."
,"17":"Este examiná-la-á e, vendo que a doença se tornou branca, declarará pura a pessoa doente: ela de facto está pura."
,"18":"Quando alguém tiver na pele um furúnculo, do qual já esteja curado,"
,"19":"e se formar no lugar do furúnculo uma inflamação esbranquiçada ou mancha vermelha clara, essa pessoa deverá apresentar-se ao sacerdote."
,"20":"O sacerdote examiná-la-á: se verificar que a pele afundou e o pêlo ficou branco, o sacerdote declará-la-á impura: é caso de lepra que se manifesta no furúnculo."
,"21":"Mas se o sacerdote, ao examiná-la, notar que na mancha não há pêlos brancos nem aprofundamento da pele, mas um embranquecimento, então isolará o enfermo durante sete dias."
,"22":"Se a mancha alastrar sobre a pele, o sacerdote declarará impura a pessoa: é caso de lepra."
,"23":"Mas se a mancha permanecer estacionária, sem alastrar, é a cicatriz do furúnculo, e o sacerdote declarará pura a pessoa."
,"24":"Quando alguém tiver uma queimadura na pele, e sobre a parte queimada se formar uma mancha esbranquiçada ou vermelha clara,"
,"25":"o sacerdote examiná-la-á. Se verificar que o pêlo ficou branco ou que houve aprofundamento da mancha na pele, é caso de lepra que se desenvolveu na queimadura. O sacerdote declarará impuro o homem: é caso de lepra."
,"26":"Mas se o sacerdote, ao examinar, não verificar pêlos brancos na mancha nem aprofundamento da pele, e notar que a mancha se tornou esbranquiçada, o sacerdote isolá-lo-á durante sete dias."
,"27":"No sétimo dia examiná-lo-á de novo. Se a doença se tiver propagado na pele, declarará impuro o homem: é caso de lepra."
,"28":"Se a mancha permanecer localizada, sem se propagar na pele e se tornar pálida, trata-se de inflamação da queimadura. O sacerdote declarará puro o homem, pois é cicatriz da queimadura."
,"29":"Se um homem ou mulher tiver uma chaga na cabeça, ou na barba,"
,"30":"o sacerdote examinará a chaga. Se observar que há uma depressão na pele e o pêlo se tornou amarelado e fino, declarará impuro o enfermo: é caso de sarna, isto é, lepra da cabeça ou da barba."
,"31":"Mas, examinando a sarna, se o sacerdote verificar que não há depressão na pele nem pêlo amarelado, então isolará o doente durante sete dias."
,"32":"No sétimo dia examinará a doença; se verificar que a sarna não se desenvolveu e que o pêlo não ficou amarelado e que não houve depressão na pele,"
,"33":"o doente rapará os pêlos, menos na parte que está com sarna. E o sacerdote isolá-lo-á durante mais sete dias."
,"34":"No sétimo dia examinará a doença; se verificar que não se alastrou sobre a pele e que não há depressão na pele, o sacerdote declará-lo-á puro. O doente lavará a roupa e ficará puro."
,"35":"Contudo, se depois da purificação a sarna se desenvolveu sobre a pele,"
,"36":"o sacerdote examiná-lo-á de novo: se verificar o alastramento da sarna, é porque o doente está impuro, e não precisará verificar se o pêlo está amarelado."
,"37":"Mas se a sarna estiver localizada e nela tiver crescido pêlo escuro, é porque a doença está curada: o doente está puro e o sacerdote declará-lo-á puro."
,"38":"Se aparecerem manchas sobre a pele de um homem ou mulher, e as manchas forem brancas,"
,"39":"o sacerdote examiná-las-á. Se verificar que as manchas na pele são de um branco embaçado, trata-se de erupção da pele: o enfermo está puro."
,"40":"Se um homem perde os cabelos da cabeça, trata-se de calvície da cabeça, e está puro."
,"41":"Se perde cabelos na parte da frente da cabeça, trata-se de calvície da fronte, e está puro."
,"42":"Mas, se na cabeça ou na parte da frente houver chagas de cor vermelha clara, trata-se de lepra que se desenvolveu na cabeça ou na fronte desse homem."
,"43":"O sacerdote examiná-lo-á. Se observar na calvície ou na fronte um tumor vermelho claro, com o mesmo aspecto da lepra da pele,"
,"44":"então o homem está leproso: é impuro. O sacerdote declará-lo-á impuro, pois está com lepra na cabeça."
,"45":"Quem for declarado leproso deverá andar com as roupas rasgadas e despenteado, com a barba coberta e gritar: 'Impuro! Impuro!'"
,"46":"Ficará impuro enquanto durar a sua doença. Viverá separado e morará fora do acampamento."
,"47":"Quando houver lepra numa roupa, tanto de lã como de linho,"
,"48":"num tecido ou coberta de lã, de linho, ou de couro, ou numa peça qualquer de couro,"
,"49":"e se a mancha da roupa, do couro, do tecido, da coberta, ou do objecto de couro, for esverdeada ou avermelhada, é caso de lepra e deve ser mostrada ao sacerdote."
,"50":"O sacerdote examinará a mancha e isolará o objecto durante sete dias."
,"51":"No sétimo dia, se observar que a mancha se espalhou sobre a roupa, o tecido, a coberta, o couro ou sobre o objecto feito de couro, trata-se de lepra contagiosa: o objecto está impuro."
,"52":"A roupa, o tecido, a coberta de lã ou de linho, ou o objecto de couro sobre o qual se apresentou a mancha, deverá ser queimado, pois é lepra contagiosa que deve ser destruída pelo fogo."
,"53":"Contudo, se o sacerdote, examinando, verificar que a mancha não se espalhou sobre a roupa, o tecido, a coberta ou o objecto de couro,"
,"54":"então mandará lavar a parte atingida e isolá-lo-á outra vez por mais sete dias."
,"55":"Depois da lavagem, examinará a mancha. E se verificar que não mudou de aspecto nem se desenvolveu, é porque o objecto está impuro. O sacerdote queimá-lo-á, porque está corroído no direito e no avesso."
,"56":"Contudo, se o sacerdote, examinando, verificar que depois da lavagem a mancha ficou embaçada, então arrancará a parte da roupa, de couro, do tecido ou da coberta."
,"57":"Todavia, se a mancha se espalhar sobre a roupa, a coberta ou o objecto de couro, é porque o mal continua vivo; então será queimado no fogo aquilo que estiver atacado pela mancha."
,"58":"A roupa, o tecido, a coberta e qualquer objecto de couro, do qual desapareceu a mancha depois da lavagem, ficará puro depois de lavado pela segunda vez»."
,"59":"Esta é a lei para o caso de lepra na roupa de lã ou de linho, no tecido, na coberta ou no objecto de couro, quando se trata de os declarar puros ou impuros."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Javé disse a Moisés:"
,"2":"«Esta é a lei que deve ser aplicada ao leproso, no dia da sua purificação: será conduzido ao sacerdote,"
,"3":"e o sacerdote levá-lo-á para fora do acampamento. Depois do exame, se verificar que o leproso está curado da lepra,"
,"4":"mandará trazer, para o leproso a ser purificado, duas aves vivas e puras, madeira de cedro, púrpura escarlate e hissopo."
,"5":"Em seguida, mandará imolar uma das aves num vaso de argila sobre água corrente."
,"6":"Tomará a ave viva, a madeira de cedro, a púrpura escarlate, o hissopo, e mergulhará tudo, juntamente com a ave viva, no sangue da ave imolada sobre a água corrente."
,"7":"Fará, então, sete aspersões sobre o homem que está a purificar-se da lepra e declará-lo-á puro. Depois deixará que a ave viva voe para o campo."
,"8":"Aquele que se purifica lavará as roupas, rapará todos os pêlos, lavar-se-á com água e ficará puro. Depois disto, poderá entrar no acampamento, mas ficará sete dias fora da sua tenda."
,"9":"No sétimo dia, rapará a cabeça, a barba, as sobrancelhas, bem como todos os pêlos. Depois lavará as roupas, tomará banho e ficará puro."
,"10":"No oitavo dia, tomará dois cordeiros sem defeito, uma ovelha sem defeito, doze litros de flor de farinha amassada com azeite para a oblação e um quarto de litro de azeite."
,"11":"O sacerdote que realiza a purificação colocará o homem, que está a purificar-se, juntamente com as suas ofertas, à entrada da tenda da reunião, diante de Javé."
,"12":"Depois tomará um dos cordeiros e oferecê-lo-á como sacrifício de reparação, juntamente com o quarto de litro de azeite, fazendo com eles o gesto de apresentação diante de Javé."
,"13":"Imolará o cordeiro no lugar santo, onde se imolam as vítimas do sacrifício pelo pecado e do holocausto. Esta vítima de reparação, assim como o sacrifício pelo pecado, pertence ao sacerdote: é porção sagrada."
,"14":"O sacerdote tomará sangue da vítima e pô-lo-á no lóbulo da orelha direita daquele que está a purificar-se, sobre o polegar da mão direita e sobre o polegar do pé direito."
,"15":"Depois tomará um pouco de azeite e derramá-lo-á na palma da sua própria mão esquerda."
,"16":"Molhará o dedo indicador da mão direita no azeite que está na palma da esquerda, e fará com esse dedo sete aspersões diante de Javé."
,"17":"Em seguida colocará um pouco do azeite, que lhe resta na palma da mão, no lóbulo da orelha direita daquele que se purifica, sobre o polegar da mão direita e sobre o polegar do pé direito, em cima do sangue do sacrifício de reparação."
,"18":"Depois, derramará o resto do azeite, que tem na palma da mão, sobre a cabeça daquele que se purifica. Deste modo, terá feito pelo homem o rito pelo pecado diante de Javé."
,"19":"A seguir, o sacerdote fará o sacrifício pelo pecado e realizará o sacrifício por aquele que está a purificar-se da impureza. Depois disto, imolará a vítima do holocausto"
,"20":"e oferecerá no altar o holocausto e a oblação. Deste modo, fará o sacrifício pelo pecado deste homem, que ficará puro."
,"21":"Se é um pobre que não tem recursos, tomará somente um cordeiro para o sacrifício de reparação e oferecê-lo-á com o gesto de apresentação, a fim de realizar pelo homem o rito pelo pecado. Tomará apenas quatro litros de flor de farinha amassada com azeite para a oblação, um quarto de litro de azeite,"
,"22":"duas rolas ou dois pombinhos, conforme as possibilidades, um dos quais será para o sacrifício pelo pecado e o outro para o holocausto."
,"23":"No oitavo dia, apresentá-los-á ao sacerdote à entrada da tenda da reunião, diante de Javé, para a sua purificação."
,"24":"O sacerdote tomará o cordeiro do sacrifício de reparação e o quarto de litro de azeite, e oferecê-los-á com o gesto de apresentação diante de Javé."
,"25":"Depois, imolará o cordeiro do sacrifício de reparação, tomará sangue da vítima e colocá-lo-á no lóbulo da orelha direita daquele que se purifica, sobre o polegar da mão direita e sobre o polegar do pé direito."
,"26":"A seguir, derramará um pouco de azeite na palma da sua própria mão esquerda,"
,"27":"e com o dedo indicador da mão direita fará, diante de Javé, sete aspersões com o azeite que tem na mão esquerda."
,"28":"Com o azeite que tem na mão, o sacerdote ungirá o lóbulo da orelha direita daquele que está a purificar-se, o polegar da mão direita e o polegar do pé direito, em cima do sangue do sacrifício de reparação."
,"29":"Depois colocará o resto do azeite, que tem na palma da mão, sobre a cabeça daquele que está a purificar-se, fazendo por ele, diante de Javé, o rito pelo pecado."
,"30":"Com uma das rolas ou um dos pombinhos, segundo as possibilidades, fará"
,"31":"um sacrifício pelo pecado; e, com o outro, um holocausto acompanhado de oblação. O sacerdote fará assim, diante de Javé, o rito pelo pecado, por aquele que está a purificar-se»."
,"32":"Esta é a lei para a purificação do leproso que não tem recursos."
,"33":"Javé disse a Moisés e Aarão:"
,"34":"«Quando tiverdes entrado na terra de Canaã, que vos vou dar, e Eu ferir de lepra uma casa da vossa terra,"
,"35":"o dono da casa avisará o sacerdote: 'Parece que na minha casa há uma mancha de lepra'."
,"36":"O sacerdote mandará desocupar a casa antes de ir examinar a mancha; deste modo, ninguém ficará impuro com aquilo que nela existe. Depois disso, o sacerdote irá examinar a casa,"
,"37":"e, depois de a ter examinado, se observar na parede da casa cavidades esverdeadas ou avermelhadas, formando depressão na parede,"
,"38":"sairá da casa e mandará fechá-la durante sete dias."
,"39":"Voltará no sétimo dia e examiná-la-á de novo. Se observar que a mancha se espalhou pela parede,"
,"40":"o sacerdote mandará tirar as pedras manchadas e deitá-las num lugar impuro, fora da cidade."
,"41":"Depois mandará raspar todas as paredes internas da casa e lançar o pó raspado para um lugar impuro, fora da cidade."
,"42":"Tomarão outras pedras para substituir as que foram tiradas e outro reboco para rebocar a casa."
,"43":"Depois de tiradas as pedras e depois de raspada e rebocada a casa, se a mancha reaparecer,"
,"44":"o sacerdote irá examiná-la. Se observar que a mancha se espalhou, trata-se de lepra contagiosa na casa, que está impura."
,"45":"Mandará demolir a casa, e as suas pedras, madeira e reboco serão levados para um lugar impuro, fora da cidade."
,"46":"Quem entrar na casa, enquanto estiver fechada, ficará impuro até à tarde."
,"47":"Quem nela dormir ou comer, deverá lavar a própria roupa."
,"48":"Mas se o sacerdote, quando for examinar a mancha, verificar que ela não se espalhou pela casa depois de rebocada, declarará pura a casa, pois a doença dela está curada."
,"49":"Então tomará duas aves, madeira de cedro, púrpura escarlate e hissopo, para fazer o sacrifício pelo pecado da casa."
,"50":"Imolará uma das aves num vaso de argila sobre água corrente."
,"51":"Depois tomará a madeira de cedro, o hissopo, a púrpura escarlate e a ave viva, e mergulhá-los-á no sangue da ave imolada em água corrente. Em seguida, aspergirá a casa sete vezes."
,"52":"Depois de fazer o sacrifício pelo pecado da casa, com o sangue da ave, a água corrente, a ave viva, a madeira de cedro, o hissopo e a púrpura escarlate,"
,"53":"soltará a ave viva no campo, fora da cidade. Fazendo assim o rito pelo pecado da casa, esta ficará pura»."
,"54":"Esta é a lei sobre todos os casos de lepra e sarna,"
,"55":"lepra das roupas e das casas,"
,"56":"inflamações, furúnculos e manchas."
,"57":"Ela estabelece o que é puro ou impuro. Esta é a lei sobre a lepra."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Javé disse a Moisés e Aarão:"
,"2":"«Dizei aos filhos de Israel: Quando um homem sofre de gonorreia, está impuro."
,"3":"Esta é a lei da impureza sobre a gonorreia: quer o corpo tenha deixado escorrer ou tenha retido o líquido, a impureza é a mesma."
,"4":"A cama em que o doente se deitar ficará impura, e todo o móvel onde se sentar ficará impuro."
,"5":"Quem tocar na cama dele deverá lavar as roupas e tomar banho; ficará impuro até à tarde."
,"6":"Quem se sentar num móvel onde se sentou o doente, deverá lavar as roupas, tomar banho e ficará impuro até à tarde."
,"7":"Quem tocar no doente deverá lavar as roupas e tomar banho; ficará impuro até à tarde."
,"8":"Se o doente cuspir numa pessoa pura, esta deverá lavar as roupas e tomar banho; ficará impura até à tarde."
,"9":"A sela sobre a qual esse homem viajar, ficará impura."
,"10":"Todos os que tocarem em qualquer objecto que tenha estado debaixo do doente, ficarão impuros até à tarde. Quem transportar tal objecto deverá lavar as roupas e tomar banho; ficará impuro até à tarde."
,"11":"Todos aqueles que forem tocados pelo doente, sem que este tenha lavado as mãos, deverão lavar as roupas e tomar banho; ficarão impuros até à tarde."
,"12":"Toda a vasilha de barro tocada por esse homem será quebrada. Se for de madeira, deverá ser lavada."
,"13":"Quando o doente estiver curado da gonorreia, contará sete dias para a sua purificação. Deverá lavar as roupas e tomar banho em água corrente, e ficará puro."
,"14":"No oitavo dia tomará duas rolas ou dois pombinhos e apresentar-se-á diante de Javé, à entrada da tenda da reunião, e entregá-los-á ao sacerdote."
,"15":"Com um deles fará um sacrifício pelo pecado, e com o outro um holocausto. Deste modo, o sacerdote fará por ele, diante de Javé, o rito de purificação da gonorreia."
,"16":"Quando um homem tiver polução, deverá tomar banho e ficará impuro até à tarde."
,"17":"Toda a roupa e todo o couro atingidos pelo sémen deverão ser lavados, e ficarão impuros até à tarde."
,"18":"Quando uma mulher teve relações com um homem, os dois deverão tomar banho, e ficarão impuros até à tarde."
,"19":"Quando uma mulher tiver a sua menstruação, ficará impura durante sete dias. Quem tocar nela ficará impuro até à tarde."
,"20":"O lugar em que ela se deitar ou sentar, enquanto está impura, ficará impuro."
,"21":"Quem tocar no leito dela deverá lavar as próprias roupas e tomar banho; ficará impuro até à tarde."
,"22":"Quem tocar no assento que ela usou, lavará as próprias roupas, tomará banho e ficará impuro até à tarde."
,"23":"Se o objecto tocado estiver sobre a cama ou sobre o assento que ela usou, ficará impuro até à tarde."
,"24":"Se um homem tiver relações com a mulher menstruada, a impureza dela atingi-lo-á, e ele ficará impuro durante sete dias. A cama em que ele se deitar ficará impura."
,"25":"Quando uma mulher tiver hemorragias frequentes, fora ou depois da menstruação, ficará impura como na menstruação, enquanto durarem as hemorragias."
,"26":"A cama em que ela se deitar, enquanto tiver as hemorragias, ficará impura, como na menstruação. O lugar em que ela se sentar ficará impuro, como na menstruação."
,"27":"Quem tocar nesses móveis ficará impuro: deverá lavar as roupas e tomar banho; ficará impuro até à tarde."
,"28":"Quando a mulher ficar curada das suas hemorragias contará sete dias, e então ficará pura."
,"29":"No oitavo dia, tomará duas rolas ou dois pombinhos e apresentá-los-á ao sacerdote à entrada da tenda da reunião."
,"30":"O sacerdote oferecerá um deles em sacrifício pelo pecado, e o outro como holocausto. Deste modo, o sacerdote, fará por ela, diante de Javé, o rito por causa da hemorragia que a tornou impura."
,"31":"Preveni os filhos de Israel sobre a impureza, para que não morram por causa delas, por terem contaminado a minha morada no meio deles»."
,"32":"Esta é a lei sobre a gonorreia e as poluções que tornam o homem impuro,"
,"33":"e sobre a menstruação e hemorragias da mulher. É válida para o homem, para a mulher e para o homem que se deita com uma mulher impura."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Javé falou a Moisés depois da morte dos dois filhos de Aarão, que morreram por se aproximarem de Javé."
,"2":"Javé disse a Moisés: «Diz ao teu irmão Aarão que nunca entre no santuário para além do véu, diante da placa de ouro que está sobre a arca. Ele poderá morrer, porque Eu apareço numa nuvem sobre a placa da arca."
,"3":"Aarão entrará no santuário com um bezerro para o sacrifício pelo pecado e um cordeiro para o holocausto."
,"4":"Vestirá uma túnica de linho sagrada, cobrir-se-á com calções de linho, amarrará a cintura com um cinto de linho e usará um turbante de linho. São vestes sagradas, e vesti-las-á depois de tomar banho."
,"5":"Receberá da comunidade dos filhos de Israel dois bodes para o sacrifício pelo pecado e um cordeiro para o holocausto."
,"6":"Depois de oferecer o bezerro como sacrifício pelo seu próprio pecado, e de ter feito a expiação por si mesmo e pela sua família,"
,"7":"Aarão tomará os dois bodes e apresentá-los-á diante de Javé, à entrada da tenda da reunião."
,"8":"Tirará a sorte sobre os dois bodes: um será de Javé e o outro de Azazel."
,"9":"Tomará o que foi sorteado para Javé e oferecê-lo-á como sacrifício pelo pecado."
,"10":"Quanto ao bode que foi sorteado para Azazel, será colocado vivo diante de Javé, para fazer a expiação, e depois será mandado para Azazel no deserto."
,"11":"Aarão oferecerá o bezerro do sacrifício pelo seu próprio pecado. Em seguida fará o rito de expiação por si mesmo e pela sua família, e imolará o bezerro."
,"12":"Então encherá um incensório com brasas tiradas do altar diante de Javé e tomará dois punhados de incenso aromático em pó. Levará tudo para trás do véu,"
,"13":"e colocará o incenso sobre o fogo, diante de Javé; uma nuvem de incenso cobrirá a placa que está sobre o documento da aliança; assim ele não morrerá."
,"14":"Depois tomará sangue do bezerro e aspergirá, com o dedo, o lado oriental da placa; depois, diante da placa fará com o dedo sete aspersões de sangue."
,"15":"A seguir imolará o bode do sacrifício pelo pecado do povo e levará o sangue para trás do véu. Com esse sangue, fará o mesmo que fez com o sangue do bezerro, aspergindo sobre a placa e diante dela."
,"16":"Fará deste modo o rito de expiação pelo santuário, pelas impurezas dos filhos de Israel, pelas transgressões e por todos os seus pecados. Fará o mesmo com a tenda da reunião, estabelecida entre eles no meio das suas impurezas."
,"17":"Enquanto Aarão estiver a fazer a expiação por si próprio, pela sua família e por toda a comunidade de Israel, ninguém deverá estar na tenda da reunião, desde que ele entrar até sair."
,"18":"Depois ele sairá, irá até ao altar que está diante de Javé e fará a expiação. Tomará sangue do bezerro e do bode e ungirá com ele os cantos do altar."
,"19":"Com o mesmo sangue fará com o dedo sete aspersões sobre o altar. Deste modo purificará o altar, separando-o das impurezas dos filhos de Israel."
,"20":"Depois de fazer a expiação do santuário, da tenda da reunião e do altar, Aarão mandará trazer o bode vivo."
,"21":"Colocará as duas mãos sobre a cabeça do bode e confessará sobre ele todas as culpas, transgressões e pecados dos filhos de Israel. Depois de colocar tudo sobre a cabeça do bode, mandará o animal para o deserto, conduzido por um homem para isso preparado."
,"22":"Assim, o bode levará sobre si, para uma região deserta, todas as culpas deles. Quando tiver soltado o bode no deserto,"
,"23":"Aarão entrará na tenda da reunião, tirará as roupas de linho que havia posto para entrar no santuário, e deixá-las-á ali."
,"24":"Tomará banho no lugar santo e vestirá as suas próprias roupas. Tornará a sair e oferecerá o holocausto, tanto o seu como o do povo. Fará a expiação por si próprio e pelo povo,"
,"25":"e deixará queimar sobre o altar a gordura do sacrifício pelo pecado."
,"26":"O encarregado de levar o bode a Azazel deverá lavar as roupas e tomar banho; depois disso poderá entrar no acampamento."
,"27":"O bezerro e o bode oferecidos em sacrifício pelo pecado, e cujo sangue foi levado ao santuário para fazer o rito de expiação, serão levados para fora do acampamento, onde se queimarão a pele, a carne e os intestinos."
,"28":"Quem os queimar deverá lavar as próprias roupas e tomar banho; depois poderá entrar no acampamento."
,"29":"Isto será para vós uma lei perpétua. No décimo dia do sétimo mês, fareis jejum. Nem o cidadão, nem o imigrante que mora entre vós farão algum trabalho, "
,"30":"pois nesse dia será feita a expiação por vós, para serdes purificados. Diante de Javé, ficareis puros de todos os pecados."
,"31":"Será para vós um sábado de repouso absoluto, e fareis penitência. É uma lei perpétua."
,"32":"O sacerdote que recebeu a unção e sucedeu a seu pai no exercício do sacerdócio, realizará a expiação; ele vestir-se-á com as vestes sagradas de linho,"
,"33":"e fará a expiação pelo santuário, pela tenda da reunião e pelo altar; fará a expiação pelos sacerdotes e por todo o povo da comunidade."
,"34":"Será para vós uma lei perpétua: uma vez por ano será feita a expiação por todos os pecados dos filhos de Israel».E tudo foi feito como Javé tinha ordenado a Moisés."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz a Aarão, aos seus filhos e aos filhos de Israel: Assim ordena Javé:"
,"3":"Todo o filho de Israel que imolar um boi, um cordeiro ou uma cabra, no acampamento ou fora dele,"
,"4":"e não os levar à entrada da tenda da reunião para os oferecer a Javé, diante da sua morada, será réu de sangue. Derramou sangue, e será excluído do seu povo."
,"5":"Deste modo os filhos de Israel deverão levar ao sacerdote as vítimas que matarem no campo, e oferecê-las-ão a Javé como sacrifício de comunhão à entrada da tenda da reunião."
,"6":"O sacerdote derramará o sangue sobre o altar de Javé, que se encontra à entrada da tenda da reunião, e queimará a gordura como perfume de suave odor para Javé."
,"7":"Nunca mais oferecerão sacrifícios a deuses falsos, com os quais se prostituem. Esta é uma lei perpétua para os filhos de Israel e seus descendentes."
,"8":"Diz-lhes também: Todo o homem, seja filho de Israel ou imigrante que reside no meio de vós, que oferecer um holocausto ou sacrifício,"
,"9":"e não os levar à entrada da tenda da reunião para os oferecer a Javé, será excluído do seu povo."
,"10":"Todo o homem, quer seja filho de Israel quer imigrante a residir no meio de vós, que comer qualquer espécie de sangue, Eu voltar-Me-ei contra ele e exterminá-,-lo-ei do meio do seu povo. "
,"11":"Porque o sangue é a vida da carne, e esse sangue Eu vo-lo dou para fazerdes o rito de expiação sobre o altar, pela vossa vida; pois é o sangue que faz a expiação pela vida."
,"12":"Foi por esse motivo que Eu disse aos filhos de Israel: Nem vós, nem o imigrante que reside no meio de vós, comereis sangue."
,"13":"Todo o filho de Israel ou imigrante que reside no meio de vós que caçar um animal ou ave que é permitido comer, deverá derramar o sangue do animal ou da ave e cobri-lo com terra."
,"14":"O sangue é a vida de todo o ser vivo; foi por isso que Eu disse aos filhos de Israel: 'Não comais o sangue de nenhuma espécie de ser vivo, pois o sangue é a vida de todo o ser vivo e quem o comer será exterminado'."
,"15":"Toda a pessoa, cidadão ou imigrante, que comer um animal morto ou dilacerado por uma fera, deverá lavar as próprias roupas e tomar banho; ficará impuro até à tarde; depois ficará puro."
,"16":"Se não lavar as roupas e não tomar banho, suportará o peso da sua culpa»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel: Eu sou Javé, o vosso Deus."
,"3":"Não vos comporteis como na terra do Egipto, onde habitastes, nem como costumam comportar-se na terra de Canaã, para onde vos levo; não sigais os seus estatutos,"
,"4":"mas praticai as minhas normas e guardai as minhas leis, deixando-vos guiar por elas. Eu sou Javé, vosso Deus."
,"5":"Guardai os meus estatutos e as minhas normas, que dão vida a quem os cumpre. Eu sou Javé."
,"6":"Ninguém de vós se aproximará de uma parenta próxima, para ter relações sexuais com ela. Eu sou Javé."
,"7":"Não tenhas relações sexuais com a tua mãe. Ela é de teu pai, e é tua mãe; não tenhas relações sexuais com ela."
,"8":"Não tenhas relações sexuais com a concubina de teu pai; pois ela pertence ao teu pai."
,"9":"Não tenhas relações sexuais com a tua irmã, seja por parte de pai ou de mãe, nascida em casa ou fora dela."
,"10":"Não tenhas relações sexuais com as tuas netas, pois elas são a tua própria carne."
,"11":"Não tenhas relações sexuais com a filha da concubina de teu pai, pois ela é tua irmã."
,"12":"Não tenhas relações sexuais com a tua tia paterna, pois ela é do sangue de teu pai."
,"13":"Não tenhas relações sexuais com a tua tia materna, pois ela é do sangue de tua mãe."
,"14":"Não ofendas o teu tio, irmão de teu pai, tendo relações sexuais com a mulher dele, pois ela é tua tia."
,"15":"Não tenhas relações sexuais com a tua nora, pois ela é a mulher de teu filho."
,"16":"Não tenhas relações sexuais com a tua cunhada, pois ela pertence ao teu irmão."
,"17":"Não tenhas relações sexuais com uma mulher e com a filha dela, nem com a neta dela. São parentes, e isso seria uma infâmia."
,"18":"Não cases com uma mulher e com a irmã dela, criando rivalidades, ao ter relações sexuais também com ela enquanto a outra vive."
,"19":"Não tenhas relações sexuais com uma mulher durante a menstruação."
,"20":"Não te deites com a mulher de alguém do teu povo: ficarias impuro."
,"21":"Não sacrifiques um filho teu a Moloc, profanando o nome do teu Deus. Eu sou Javé."
,"22":"Não te deites com um homem, como se fosse com uma mulher: é uma abominação."
,"23":"Não te deites com um animal, pois ficarias impuro. A mulher não se entregará a um animal, para ter relações sexuais com ele, pois seria uma depravação."
,"24":"Não vos torneis impuros com nenhuma destas coisas, pois assim fazem as nações que Eu vou expulsar da vossa frente."
,"25":"A terra está impura: vou pedir-lhe contas, e ela vomitará os seus próprios habitantes."
,"26":"Quanto a vós, guardai os meus estatutos e normas, e não cometais nenhuma destas abominações, nem o cidadão, nem o imigrante que reside entre vós."
,"27":"Porque todas estas abominações foram cometidas pelos habitantes que habitaram nesta terra antes de vós, e a terra ficou impura."
,"28":"Se tornardes impura esta terra, será que ela não vos irá vomitar como vomitou as nações que habitaram nela antes de vós?"
,"29":"Porque todo aquele que cometer uma destas abominações será excluído do seu povo."
,"30":"Portanto, respeitai as minhas proibições, não seguindo nenhuma dessas práticas abomináveis, que eram feitas antes de vós chegardes. Não vos torneis impuros com elas. Eu sou Javé, vosso Deus»."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz a toda a comunidade dos filhos de Israel: Sede santos, porque Eu, Javé, vosso Deus, sou santo."
,"3":"Cada um de vós respeite a sua mãe e o seu pai. Guardai os meus sábados. Eu sou Javé, vosso Deus."
,"4":"Não recorrais aos ídolos, nem façais deuses de metal derretido. Eu sou Javé, o vosso Deus."
,"5":"Quando oferecerdes sacrifícios de comunhão a Javé, fazei de tal modo que sejais aceites."
,"6":"A vítima será comida no mesmo dia do sacrifício ou no dia seguinte; o que sobrar será queimado no terceiro dia."
,"7":"Aquilo que for comido no terceiro dia será considerado comida estragada, e não será aceite."
,"8":"Quem comer, levará o peso da sua culpa, porque profanou a santidade de Javé: será então eliminado do seu povo."
,"9":"Quando fizerdes a colheita da lavoura nos vossos terrenos, não colhais até ao limite do campo; não volteis para colher o trigo que ficou para trás,"
,"10":"nem as uvas que ficaram nas videiras; também não recolhais as uvas caídas no chão: deixai tudo isso para o pobre e o imigrante. Eu sou Javé, vosso Deus."
,"11":"Ninguém de vós roube, nem use de falsidade, e não engane ninguém do seu povo."
,"12":"Não jureis falsamente em meu nome, porque estaríeis a profanar o nome do vosso Deus. Eu sou Javé."
,"13":"Não oprimas o teu próximo, nem o explores, e que o salário do operário não fique contigo até ao dia seguinte."
,"14":"Não amaldiçoes o mudo, nem coloques obstáculos diante do cego: teme o teu Deus. Eu sou Javé."
,"15":"Não cometais injustiças no julgamento. Não sejas parcial para favorecer o pobre ou para agradar ao rico: julga com justiça os teus concidadãos."
,"16":"Não espalhes boatos, nem levantes falsos testemunhos contra a vida do teu próximo. Eu sou Javé."
,"17":"Não guardes ódio contra o teu irmão. Repreende abertamente o teu concidadão, e assim não cairás em pecado por causa dele."
,"18":"Não sejas vingativo, nem guardes rancor contra os teus concidadãos. Ama o teu próximo como a ti mesmo. Eu sou Javé."
,"19":"Observai os meus estatutos. Não ajuntes no teu rebanho dois animais de espécies diferentes. Não semeies no teu campo duas espécies diferentes de sementes. Não uses roupa de duas espécies de tecido."
,"20":"O homem que se unir a uma mulher que é escrava concubina de outro homem, sem que ela tenha sido resgatada nem alforriada, pagará uma multa. Eles não serão mortos, pois a mulher não era livre."
,"21":"Oferecerá a Javé, à entrada da tenda da reunião, um cordeiro como sacrifício de reparação."
,"22":"Com o cordeiro do sacrifício de reparação, o sacerdote fará sobre o homem o rito de sacrifício pelo pecado, diante de Javé, e o pecado que ele cometeu ser-lhe-á perdoado."
,"23":"Quando tiverdes entrado na terra e tiverdes plantado árvores frutíferas, considerai os frutos como incircuncisos. Durante três anos considerai-os como coisa incircuncisa, e não os comais."
,"24":"No quarto ano, todos os frutos serão consagrados a Javé."
,"25":"E no quinto ano, podereis comer os frutos dessas árvores. Deste modo, elas continuarão a dar-vos frutos. Eu sou Javé, vosso Deus."
,"26":"Não comais nada com sangue. Não pratiqueis adivinhações nem magia."
,"27":"Não corteis as pontas dos cabelos em redondo e não apareis a barba."
,"28":"Não façais incisões no corpo por algum morto, nem façais tatuagens. Eu sou Javé."
,"29":"Não profanes a tua filha, fazendo com que ela se prostitua. Que o país não seja prostituído, nem se torne depravado."
,"30":"Guardai os meus sábados e respeitai o meu santuário. Eu sou Javé."
,"31":"Não recorrais aos necromantes, nem consulteis adivinhos, porque eles vos tornariam impuros. Eu sou Javé, vosso Deus."
,"32":"Levanta-te diante de uma pessoa de cabelos brancos e honra o ancião: teme o teu Deus. Eu sou Javé."
,"33":"Quando um imigrante habitar convosco no país, não o oprimais."
,"34":"O imigrante será para vós um concidadão: amá-lo-ás como a ti mesmo, porque fostes imigrantes na terra do Egipto. Eu sou Javé, vosso Deus."
,"35":"Não cometais injustiças no julgamento, nem cometais injustiças no peso e nas medidas."
,"36":"Tende balanças, pesos e medidas exactas. Eu sou Javé, vosso Deus, que vos tirei da terra do Egipto."
,"37":"Observai todos os meus estatutos e normas, praticando-os. Eu sou Javé»."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel: Todo o filho de Israel ou imigrante residente em Israel que entregar um dos seus filhos a Moloc, será réu de morte. O povo da terra apedrejá-lo-á,"
,"3":"e Eu Me voltarei contra esse homem e eliminá-lo-ei do seu povo, pois, entregando um dos seus filhos a Moloc, contaminou o meu santuário e profanou o meu santo Nome."
,"4":"Se o povo da terra fechar os olhos a respeito do homem que entregou um dos seus filhos a Moloc, e não o matar,"
,"5":"Eu mesmo me voltarei contra esse homem e contra a sua família. Eu os eliminarei do seu povo, tanto a ele como aos que com ele se prostituíram."
,"6":"Quem recorrer aos necromantes e adivinhos, para se prostituir com eles, eu Me voltarei contra esse homem e eliminá-lo-ei do seu povo."
,"7":"Quanto a vós, santificai-vos e sede santos, porque Eu sou Javé, o vosso Deus."
,"8":"Guardai e praticai os meus estatutos, porque Eu sou Javé, Aquele que vos santifica."
,"9":"Portanto: quem amaldiçoar o pai ou a mãe será réu de morte. Dado que amaldiçoou o pai ou a mãe, o sangue dele cairá sobre ele mesmo."
,"10":"O homem que cometer adultério com a mulher do seu próximo tornar-se-á réu de morte, tanto ele como a sua cúmplice."
,"11":"O homem que se deitar com a concubina de seu pai estará ofendendo o seu próprio pai: ambos serão réus de morte, e o sangue deles cairá sobre eles mesmos."
,"12":"O homem que se deitar com a sua nora será morto juntamente com ela. Estão contaminados, e o sangue deles cairá sobre eles mesmos."
,"13":"O homem que se deita com outro homem, como se fosse com uma mulher, comete uma abominação. Os dois serão réus de morte, e o sangue deles cairá sobre eles mesmos."
,"14":"O homem que toma por esposa, ao mesmo tempo, uma mulher e a mãe dela, comete coisa abominável. Os três serão queimados, para que não haja coisa abominável entre vós."
,"15":"O homem que tem relações sexuais com um animal torna-se réu de morte, e o animal também deve ser morto."
,"16":"Se uma mulher se oferece para ter relações sexuais com um animal, tanto ela como o animal devem ser mortos: são réus de morte, e o sangue deles cairá sobre eles mesmos."
,"17":"Se um homem tem relações sexuais com uma irmã por parte do pai ou da mãe, isso é uma infâmia. Serão publicamente eliminados do seu povo, e, por ter tido relações com sua irmã, carregará o peso da própria falta."
,"18":"Se um homem dormir com uma mulher durante a menstruação, e tiver relações sexuais, descobrindo a fonte do sangue, os dois serão eliminados do seu povo."
,"19":"Não terás relações sexuais com uma tia materna ou paterna. Por terdes tido relações sexuais com alguém do próprio sangue, carregareis o peso da vossa falta."
,"20":"Se alguém se deitar com a cunhada de seu pai, estará a ofender o próprio tio. Carregará o peso da sua falta, e morrerá sem filhos."
,"21":"Se alguém tomar como esposa a própria cunhada, estará a cometer uma torpeza. Estará a ofender o seu próprio irmão, e morrerá sem filhos."
,"22":"Guardai e colocai em prática todos os meus estatutos e normas. Deste modo, a terra para onde vos conduzo, a fim de nela habitardes, não vos vomitará."
,"23":"Não sigais os costumes das nações que vou expulsar por vossa causa, pois elas fazem coisas que são abomináveis para Mim."
,"24":"Já vos disse: 'Tomareis posse das suas terras que vos dou como propriedade, uma terra onde corre leite e mel'. Eu sou Javé, vosso Deus. Eu separei-vos desses povos."
,"25":"Separai também os animais puros dos impuros, as aves puras das impuras, e não vos contamineis com animais, aves ou répteis que separei como impuros."
,"26":"Sede santos para Mim, porque Eu, Javé, sou santo. Eu separei-vos de todos os povos, para que Me pertençais."
,"27":"O homem ou mulher que pratica a necromancia ou adivinhação é réu de morte. Será apedrejado, e o seu sangue cairá sobre ele»."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Javé disse a Moisés: «Diz aos sacerdotes, filhos de Aarão: O sacerdote não se contaminará com o cadáver de um parente,"
,"2":"a não ser que se trate de parente muito chegado: mãe, pai, filho, filha, irmão."
,"3":"Também por sua irmã solteira que vive com ele; por causa dela poderá expor-se à impureza."
,"4":"Não se inclui a parente casada, pois ele ficaria profanado."
,"5":"Os sacerdotes não raparão a cabeça, não apararão a barba, nem farão incisões no corpo."
,"6":"Serão consagrados ao seu Deus e não profanarão o nome do seu Deus, porque são eles que apresentam a Javé as ofertas queimadas, o alimento do seu Deus. Devem ser santos."
,"7":"Não se casarão com uma prostituta ou mulher desonrada, ou ainda com mulher que tenha sido repudiada pelo marido, porque o sacerdote está consagrado ao seu Deus."
,"8":"Tratarás o sacerdote como santo, porque ele é o encarregado de oferecer o alimento do teu Deus. Será santo para ti, porque Eu, Javé que vos santifico, sou santo."
,"9":"Se a filha de um sacerdote se desonra através da prostituição, desonra também a seu pai. Deve ser queimada."
,"10":"O sumo sacerdote, escolhido entre os seus irmãos, sobre cuja cabeça foi derramado o óleo da unção e foi consagrado com a investidura das vestes sagradas, não andará despenteado nem esfarrapado."
,"11":"Não se aproximará de nenhum cadáver, porque não deverá tornar-se impuro, nem mesmo pelo seu pai ou pela sua mãe;"
,"12":"não sairá do santuário e não profanará o santuário do seu Deus, porque está consagrado com o óleo da unção do seu Deus. Eu sou Javé."
,"13":"Ele tomará por esposa uma virgem;"
,"14":"não se casará com viúva ou com mulher repudiada, desonrada ou prostituta, mas casar-se-á com uma virgem do seu povo,"
,"15":"para não profanar os seus filhos no meio do povo, porque Eu sou Javé, que o santifico»."
,"16":"Javé disse a Moisés:"
,"17":"«Diz a Aarão: Nenhum dos teus descendentes, nas futuras gerações, se tiver algum defeito corporal, poderá oferecer o alimento do seu Deus."
,"18":"Não poderá apresentar-se ninguém defeituoso, que seja cego, coxo, atrofiado, deformado,"
,"19":"que tenha perna ou braço fracturado,"
,"20":"que seja corcunda, anão, que tenha defeito nos olhos ou cataratas, que tenha chagas, ou que seja eunuco."
,"21":"Nenhum dos descendentes do sacerdote Aarão se apresente, com algum defeito, para apresentar ofertas queimadas a Javé. Tem defeito e, por isso, não se apresentará para oferecer o alimento do seu Deus."
,"22":"Ele poderá comer das porções sagradas e santíssimas,"
,"23":"mas não ultrapassará o véu, nem se aproximará do altar: tem defeito corporal, e não deverá profanar as minhas coisas sagradas, porque Eu sou Javé, que as santifico»."
,"24":"Moisés disse tudo isto a Aarão, aos seus filhos e a todos os filhos de Israel."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Javédisse a Moisés:"
,"2":"«Diz a Aarão e a seus filhos que tratem com respeito as porções sagradas que os filhos de Israel Me consagraram, e assim não profanem o meu santo Nome. Eu sou Javé."
,"3":"Dir-lhes-ás: Nas gerações futuras, qualquer um da descendência de Aarão que, em estado de impureza, se aproximar das porções sagradas, que tenham sido consagradas a Javé pelos filhos de Israel, tal pessoa será eliminada da minha presença. Eu sou Javé."
,"4":"Nenhum homem da descendência de Aarão, que sofra de lepra ou gonorreia, poderá comer das porções sagradas, enquanto não for purificado. Toda a pessoa que tocar alguma coisa que um cadáver tornou impura, ou aquele que teve uma polução,"
,"5":"ou que tiver tocado em algum tipo de réptil ou em homem que possa contaminá-lo com qualquer espécie de impureza,"
,"6":"ficará impuro até à tarde e não poderá comer das porções sagradas, mas tomará banho, e ao pôr do sol ficará puro."
,"7":"Então, poderá comer da porção sagrada, porque é o seu alimento."
,"8":"Não comerá animal morto ou dilacerado por uma fera, pois ficaria impuro. Eu sou Javé."
,"9":"Todos observarão as minhas proibições, para não cometerem pecado que lhes traga a morte por se haverem profanado. Eu sou Javé, que os santifico."
,"10":"Nenhum estranho comerá das porções sagradas: nem o hóspede do sacerdote, nem aquele que está ao seu serviço."
,"11":"Mas se um sacerdote compra com o seu próprio dinheiro um escravo, este poderá comer, assim como também aqueles que nasceram na casa do sacerdote."
,"12":"Se a filha de um sacerdote se casar com um estranho, não poderá comer dos tributos sagrados."
,"13":"Mas se ela enviuvar ou for repudiada sem ter filhos, e voltar para a casa paterna, como no tempo da sua juventude, poderá então comer do alimento de seu pai. Mas nenhum estranho poderá comer desse alimento."
,"14":"Se um homem comer alguma porção sagrada sem saber, deverá restituí-la ao sacerdote com o acréscimo de vinte por cento."
,"15":"Os sacerdotes não profanarão a porção sagrada que os filhos de Israel tributam a Javé."
,"16":"Se a comessem, incorreriam em falta grave que exigiria reparação, pois sou Eu, Javé, quem os santifica»."
,"17":"Javé disse a Moisés:"
,"18":"«Diz a Aarão, aos seus filhos e a todos os filhos de Israel: Qualquer homem da casa de Israel ou qualquer imigrante residente em Israel que oferecer um holocausto a Javé, voluntário ou como cumprimento de um voto,"
,"19":"deverá oferecer um macho sem defeito para que a vítima seja aceite: bezerro, cordeiro ou cabrito."
,"20":"Não ofereçais animais com defeito, porque não seriam aceites."
,"21":"Se alguém oferecer a Javé um sacrifício de comunhão, voluntário ou como cumprimento de um voto, apresentará animal de gado graúdo ou miúdo, sem defeito, para que seja aceite."
,"22":"Não ofereçais a Javé um animal cego, estropiado, mutilado, com úlceras, furúnculos ou feridas. Não coloqueis nenhum animal com defeito sobre o altar, como oferta a Javé."
,"23":"Poderás oferecer, como dom voluntário, um animal anão ou disforme, de gado graúdo ou miúdo. Mas se for para cumprimento de um voto, não será aceite."
,"24":"Não ofereçais a Javé um animal que tenha os testículos pisados, moídos, arrancados ou cortados. Nunca façais isso na vossa terra,"
,"25":"nem os aceiteis de um estrangeiro, para oferecer como alimento ao vosso Deus. Essas vítimas são disformes e defeituosas, e não seriam aceites»."
,"26":"Javé disse a Moisés:"
,"27":"«Depois do nascimento, o bezerro, cordeiro ou cabrito ficarão sete dias com a mãe; do oitavo dia em diante poderão ser oferecidos como oferta a Javé."
,"28":"Não imoleis no mesmo dia uma vaca ou ovelha com a sua cria."
,"29":"Se oferecerdes a Javé um sacrifício de acção de graças, fazei de forma que seja aceite."
,"30":"Ele será comido no mesmo dia, sem deixar nada para o dia seguinte. Eu sou Javé."
,"31":"Cumpri e ponde em prática os meus mandamentos. Eu sou Javé."
,"32":"Não profaneis o meu santo Nome, para que Eu seja glorificado entre os filhos de Israel. Eu sou Javé, que vos santifico:"
,"33":"Eu tirei-vos da terra do Egipto, a fim de ser o vosso Deus. Eu sou Javé»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel: São estas as solenidades de Javé, que proclamareis como assembleias sagradas. São estas as minhas festas:"
,"3":"Durante seis dias trabalhareis, mas o sétimo é dia de repouso completo, dia de assembleia sagrada, no qual não fareis nenhum trabalho: é dia de descanso dedicado a Javé, em todos os lugares em que morardes."
,"4":"Estas são as festas de Javé, as assembleias sagradas para as quais convocareis os filhos de Israel, no tempo devido:"
,"5":"O dia catorze do primeiro mês, ao entardecer, é a Páscoa de Javé."
,"6":"O dia quinze do mesmo mês é a festa dos Pães sem fermento, dedicada a Javé: durante sete dias comereis pão sem fermento."
,"7":"No primeiro dia reunireis a assembleia sagrada e não fareis nenhum trabalho nem tarefa alguma."
,"8":"Durante sete dias apresentareis ofertas queimadas a Javé; no sétimo dia voltareis a reunir-vos em assembleia sagrada e não fareis nenhum trabalho nem tarefa alguma»."
,"9":"Javé disse a Moisés:"
,"10":"«Diz aos filhos de Israel: Quando tiverdes entrado na terra que vos dou e fizerdes nela a ceifa, trazei ao sacerdote o primeiro feixe da colheita."
,"11":"O sacerdote oferecerá esse feixe diante de Javé com o gesto de apresentação, para que seja aceite. Essa apresentação será feita no dia seguinte ao sábado."
,"12":"No mesmo dia, oferecei a Javé como holocausto um cordeiro de um ano e sem defeito."
,"13":"Como oblação, oferecei também oito litros de flor de farinha amassada com azeite: é oferta queimada para Javé como perfume de suave odor. Oferecei também a libação de um litro de vinho."
,"14":"Não comais pão nem grãos torrados até ao dia em que levardes a vossa oferta a Deus. É uma lei perpétua para todos os vossos descendentes, em qualquer lugar onde estiverem a morar."
,"15":"A partir do dia seguinte ao sábado, em que tiverdes trazido o feixe para a apresentação, contareis sete semanas completas."
,"16":"Contai cinquenta dias até ao dia seguinte ao sétimo sábado, e então oferecei a Javé uma nova oblação."
,"17":"Dos lugares onde estiverdes a morar trazei dois pães para oferecer com o gesto de apresentação; esses pães serão feitos com oito litros de flor de farinha cozida com fermento: são os primeiros frutos em honra de Javé."
,"18":"Além desses pães, oferecei, como holocausto a Javé, sete cordeiros de um ano, sem defeito, um bezerro e dois carneiros, os quais, juntamente com a oferta e a libação, formam uma oblação de suave odor para Javé."
,"19":"Fazei também um sacrifício pelo pecado com um bode, e um sacrifício de comunhão com dois cordeiros de um ano."
,"20":"O sacerdote deverá oferecê-los com o gesto de apresentação diante de Javé, juntamente com o pão dos primeiros frutos. Do mesmo modo, oferecerá os dois cordeiros, que são uma porção sagrada de Javé e pertencem ao sacerdote."
,"21":"Nesse mesmo dia, fazei a convocação da festa, e realizai a assembleia sagrada; não façais nenhum trabalho. É uma lei perpétua para todos os vossos descendentes, em qualquer lugar onde estiverdes a morar."
,"22":"Quando fizerdes a ceifa na vossa terra, não ceifeis até ao limite do campo, nem volteis atrás para apanhar as espigas que caíram: deixai tudo isso para o pobre e o imigrante. Eu sou Javé, o vosso Deus»."
,"23":"Javé disse a Moisés:"
,"24":"«Diz aos filhos de Israel: O primeiro dia do sétimo mês é dia de descanso e será anunciado ao som da trombeta. Reuni-vos em assembleia sagrada,"
,"25":"não façais nenhum trabalho e apresentai a Javé uma oferta queimada»."
,"26":"Javé disse a Moisés:"
,"27":"«O dia dez do sétimo mês é o dia da Expiação. Reuni-vos em assembleia sagrada, fazei penitência e oferecei um sacrifício a Javé."
,"28":"Não façais trabalho nenhum, pois é o dia da Expiação, dia em que se faz o rito de expiação por vós diante de Javé, vosso Deus."
,"29":"Quem não fizer penitência nesse dia será excluído do povo."
,"30":"E quem trabalhar nesse dia, eliminá-lo-ei do seu povo."
,"31":"Não façais nenhum trabalho. É uma lei perpétua para todos os vossos descendentes, em qualquer lugar onde estiverdes a morar."
,"32":"Será um dia de descanso solene, em que fareis penitência. Observai o descanso desde a tarde do dia nove até ao entardecer do dia dez»."
,"33":"Javé disse a Moisés:"
,"34":"«Diz aos filhos de Israel: No dia quinze do sétimo mês começa a festa das Tendas, dedicada a Javé, e dura sete dias."
,"35":"No primeiro dia, reuni-vos em assembleia sagrada e não façais nenhum trabalho."
,"36":"Durante sete dias oferecei sacrifícios a Javé. No oitavo dia, voltai a reunir-vos em assembleia sagrada e oferecei um sacrifício a Javé: é dia de reunião solene, e não fareis nenhum trabalho."
,"37":"São estas as festas de Javé, em que vos reunireis em assembleia sagrada, e oferecereis a Javé oblações, holocaustos e ofertas, sacrifícios de comunhão e libações, conforme o ritual de cada dia."
,"38":"Tudo isto será feito além dos sábados de Javé e além das dádivas, votos e ofertas voluntárias que fareis a Javé."
,"39":"Desde o dia quinze do sétimo mês, quando tiverdes feito a colheita, celebrareis a festa de Javé durante sete dias. O primeiro e oitavo serão dias de repouso."
,"40":"No primeiro dia, tomareis frutos das melhores árvores, cortareis ramos de árvores para enfeite, ramos de palmeiras, ramos de árvores frondosas e de salgueiros, e fareis festa durante sete dias na presença de Javé, vosso Deus."
,"41":"Celebrareis essa festa dedicada a Javé durante sete dias por ano. É uma lei perpétua para os vossos descendentes, e será celebrada no sétimo mês."
,"42":"Morareis em tendas durante sete dias; todos os naturais de Israel morarão em tendas,"
,"43":"para que os seus descendentes saibam que Eu fiz habitar os filhos de Israel em tendas quando os tirei do Egipto. Eu sou Javé, vosso Deus»."
,"44":"E Moisés comunicou aos filhos de Israel as festas de Javé."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Javé disse a Moisés:"
,"2":"«Ordena aos filhos de Israel que te tragam azeite de oliveira puro e refinado, para manter as lâmpadas sempre acesas."
,"3":"Na tenda da reunião, fora do véu que está na frente do documento da Aliança, Aarão preparará todos os dias a lâmpada. Ela ficará nesse lugar diante de Javé, a fim de arder continuamente, desde a tarde até de manhã. É uma lei perpétua para os vossos descendentes."
,"4":"Aarão preparará continuamente, na presença de Javé, as lâmpadas sobre o candelabro de ouro puro."
,"5":"Toma flor de farinha e coze com ela doze pães de oito litros cada um."
,"6":"Coloca-os, depois, em duas filas de seis, sobre a mesa de ouro puro, que está diante de Javé."
,"7":"Coloca incenso puro sobre cada fila. Isso será o alimento oferecido como memorial, como oferta queimada para Javé."
,"8":"Em cada sábado esses pães serão colocados permanentemente diante de Javé. Os filhos de Israel fornecerão os pães como aliança perpétua."
,"9":"Esses pães pertencerão a Aarão e a seus filhos, que os comerão no lugar sagrado, porque serão, para Aarão, porção sagrada e perpétua das ofertas queimadas a Javé»."
,"10":"Entre os filhos de Israel havia um filho, de mãe israelita e de pai egípcio. Ele saiu de casa e lutou com um filho de Israel no acampamento."
,"11":"O filho da israelita blasfemou e amaldiçoou o nome de Javé. Por isso, levaram-no à presença de Moisés. A mãe, que se chamava Salomit, era filha de Dabri, da tribo de Dã."
,"12":"O seu filho foi preso para que um oráculo de Javé decidisse a sorte dele."
,"13":"Javé disse a Moisés:"
,"14":"«Faz sair do acampamento o homem que blasfemou. Todos os que o ouviram coloquem as mãos sobre a cabeça dele. Depois, toda a comunidade o apedrejará."
,"15":"Em seguida, diz aos filhos de Israel: 'Todo aquele que amaldiçoar o seu Deus, carregará o peso do próprio pecado."
,"16":"Quem blasfemar contra o nome de Javé deverá morrer: será apedrejado por toda a comunidade. Seja imigrante, seja nativo, se blasfemar contra o nome de Javé, deverá morrer."
,"17":"Quem matar um homem, torna-se réu de morte."
,"18":"Quem matar um animal, deverá dar uma compensação: vida por vida."
,"19":"Se alguém ferir o seu próximo, ser-lhe-á feito aquilo que ele fez ao outro:"
,"20":"fractura por fractura, olho por olho, dente por dente. A pessoa sofrerá o mesmo dano que tiver causado a outro:"
,"21":"quem matar um animal, deverá dar uma compensação por ele; e quem matar um homem, deverá morrer."
,"22":"A sentença será sempre a mesma, quer se trate de nativo, quer de imigrante, pois Eu sou Javé, vosso Deus'»."
,"23":"Depois de Moisés ter repetido tudo isto aos filhos de Israel, tiraram do acampamento aquele que havia blasfemado e apedrejaram-no. Fizeram o que Javé ordenara a Moisés."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Javé disse a Moisés no Monte Sinai:"
,"2":"«Diz aos filhos de Israel: Quando entrardes na terra que vos dou, a terra deverá consagrar a Javé o seu sábado. "
,"3":"Durante seis anos semearás os campos e, durante seis anos, podarás as vinhas e recolherás as colheitas."
,"4":"Mas o sétimo ano será um solene descanso para a terra, o descanso de Javé: não semeareis o campo, nem podareis a vinha,"
,"5":"não ceifareis o que nascer dos grãos caídos durante a ceifa, nem colhereis as uvas das vinhas, que não foram podadas. Será um ano de descanso para a terra."
,"6":"O descanso da terra servirá de alimento para ti, para o teu escravo, a tua escrava, o teu empregado, o teu hóspede, e para todos aqueles que moram contigo."
,"7":"Todo o produto da terra servirá de pastagem para o teu gado e para os animais selvagens."
,"8":"Conta sete semanas de anos, isto é, sete vezes sete anos; tais semanas de anos darão um período de quarenta e nove anos."
,"9":"No dia dez do sétimo mês farás soar a trombeta. No dia da expiação fazei soar a trombeta no país inteiro."
,"10":"Declarai santo o quinquagésimo ano e proclamai a libertação para todos os moradores do país. Será para vós um ano de júbilo: cada um de vós recuperará a sua propriedade e voltará para a sua família."
,"11":"O quinquagésimo ano será para vós um ano de júbilo: não semeareis, nem ceifareis as espigas que tiverem nascido espontaneamente, nem colhereis uvas das videiras não podadas."
,"12":"O jubileu será uma coisa sagrada, e comereis o que o campo produzir."
,"13":"Nesse ano de júbilo cada um recuperará a sua propriedade."
,"14":"Quando fizerdes uma compra ou venda a alguém do vosso povo, não vos exploreis uns aos outros."
,"15":"O que comprardes a alguém do vosso povo será avaliado conforme o número de anos decorridos depois do jubileu. E aquele, por sua vez, cobrar-vos-á conforme o número dos anos de colheita:"
,"16":"quanto maior o número de anos, mais alto será o preço; quanto menor o número de anos, menor será o preço, porque te cobrará conforme o número de colheitas."
,"17":"Não vos exploreis uns aos outros, mas temei o vosso Deus, porque Eu sou Javé, vosso Deus."
,"18":"Cumpri os meus estatutos e normas, colocando-os em prática. Deste modo, vivereis tranquilos na terra."
,"19":"A terra dará o seu fruto, comereis até vos saciardes, e vivereis tranquilos."
,"20":"Podereis perguntar: 'Que vamos comer no sétimo ano, se não semearmos nem fizermos colheita?'"
,"21":"Eu vos mandarei a minha bênção no sexto ano, e a terra produzirá colheita para os três anos."
,"22":"Quando semeardes no oitavo ano, podereis ainda comer dos produtos antigos até ao nono ano. E enquanto não vierem os produtos do nono ano, comereis os produtos antigos."
,"23":"A terra não poderá ser vendida para sempre, porque a terra Me pertence, e vós sois para Mim imigrantes e hóspedes."
,"24":"Por isso, em qualquer terra que possuirdes, concedei o direito de resgatar a terra."
,"25":"Se um dos teus irmãos cai na miséria e precisa de vender algo do património próprio, o parente mais próximo dele, que tem o direito de resgate, irá ter com ele e resgatará aquilo que o irmão tiver vendido."
,"26":"Quem não tiver ninguém para exercer esse direito, e desde que haja encontrado recursos para fazer o resgate,"
,"27":"descontará os anos que passaram desde a venda e pagará ao comprador o que falta, recuperando assim a propriedade."
,"28":"Se não tiver meios para realizar o resgate, a propriedade vendida permanecerá até ao ano do jubileu em poder do comprador. No jubileu, o comprador liberará a propriedade, para que esta volte ao seu próprio dono."
,"29":"Quem vender uma casa de moradia numa cidade com muralhas, terá o direito de resgate até ao final do ano da venda. O seu direito de resgate durará um ano."
,"30":"Se o resgate não for feito no final de um ano, a casa na cidade com muralhas será propriedade daquele que a comprou e dos seus descendentes, para sempre: não serão liberadas no jubileu."
,"31":"As casas de aldeias sem muralhas serão consideradas como os campos. Essas casas terão direito de resgate, e o comprador deverá liberá-las no jubileu."
,"32":"Quanto às cidades de levitas, estes terão direito perpétuo de resgatar as casas das cidades que lhes pertençam."
,"33":"Se não forem resgatadas, ficarão liberadas no ano do jubileu, porque as casas das cidades de levitas pertencem-lhes entre os filhos de Israel."
,"34":"Os campos pertencentes a essas cidades não poderão ser vendidos, pois são propriedades dos levitas para sempre."
,"35":"Se um dos teus irmãos cai na miséria e não tem meios de se manter, sustentá-lo-ás, para que viva contigo como imigrante ou hóspede."
,"36":"Não lhe cobres juros nem lucro algum. Teme a Deus. E que o teu irmão viva contigo."
,"37":"Não lhe emprestes dinheiro a juros, nem lucres com o seu alimento."
,"38":"Eu sou Javé, vosso Deus, que vos tirei do Egipto para vos dar a terra de Canaã e ser o vosso Deus."
,"39":"Se o teu irmão cai na miséria e se vende a ti, não o faças trabalhar como escravo:"
,"40":"que ele viva contigo como assalariado ou hóspede. Trabalhará contigo até ao ano do jubileu,"
,"41":"e então ele e seus filhos ficarão livres para voltar à própria família e recuperar a propriedade paterna."
,"42":"Eles são meus servos, que Eu tirei do Egipto, e não podem ser vendidos como escravos."
,"43":"Não o trates com dureza. Teme o teu Deus."
,"44":"Os vossos escravos e escravas deverão ser comprados dentre as nações que estão ao redor; delas podereis adquirir escravos e escravas."
,"45":"Também podereis comprá-los entre os filhos de imigrantes que residem no meio de vós, entre as suas famílias que estão convosco, entre os filhos que eles tiverem no país. Serão propriedade vossa."
,"46":"Podereis deixá-los como herança aos filhos que vierem depois de vós; e podereis sempre servir-vos deles como escravos. Quanto aos vossos irmãos, os filhos de Israel, ninguém poderá exercer domínio sobre eles."
,"47":"Se o imigrante ou hóspede que vive contigo ficar rico, e o seu irmão, que vive junto dele, cair na miséria e se vender ao imigrante, hóspede ou descendente da família do imigrante,"
,"48":"mesmo depois de vendido terá direito a resgate. Será resgatado por um dos irmãos,"
,"49":"ou pelo seu tio paterno, pelo seu primo, por qualquer um dos membros da sua família, ou poderá resgatar-se a si mesmo, se conseguir recursos para isso."
,"50":"Calculará, com o comprador, os anos desde a venda até ao ano do jubileu, e o preço corresponderá ao número de anos, contando-se os dias como para um assalariado."
,"51":"Se faltarem ainda muitos anos, pagará o valor do seu resgate em razão desses anos e em proporção ao preço pelo qual foi comprado."
,"52":"Se faltarem poucos anos para chegar o jubileu, fará o cálculo com o seu comprador, e pagará o preço do seu resgate em razão desses anos."
,"53":"Permanecerá com o seu comprador como um assalariado contratado por ano, e o patrão não deverá tratá-lo com dureza."
,"54":"Se não for resgatado em nenhum desses modos, ele e seus filhos ficarão livres no ano do jubileu."
,"55":"Porque os filhos de Israel são meus servos: são servos meus que tirei do Egipto. Eu sou Javé, vosso Deus."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Não façais ídolos, nem levanteis imagens esculpidas ou estelas, e não coloqueis no vosso país pedras trabalhadas, para vos inclinardes diante delas. Porque Eu sou Javé, vosso Deus."
,"2":"Guardai os meus sábados e respeitai o meu santuário. Eu sou Javé."
,"3":"Se seguirdes os meus estatutos, guardardes os meus mandamentos e os puserdes em prática,"
,"4":"dar-vos-ei a chuva no devido tempo. Então a terra dará os seus produtos e as árvores do campo os seus frutos."
,"5":"A debulha estender-se-á até à vindima e a vindima até às sementeiras. Comereis até ficardes saciados e habitareis tranquilos no vosso país."
,"6":"Eu farei reinar a paz no vosso país e dormireis sem alarmes de guerra. Farei desaparecer do país as feras, e a espada não passará pelo país."
,"7":"Perseguireis os inimigos, e eles cairão diante de vós ao fio da espada."
,"8":"Cinco de vós perseguirão cem, e cem de vós perseguirão dez mil, e os inimigos cairão diante de vós ao fio da espada."
,"9":"Eu voltar-Me-ei para vós e far-vos-ei crescer e multiplicar, mantendo convosco a minha aliança."
,"10":"Comereis colheitas armazenadas e tereis de deitar fora a colheita antiga, para poder guardar a nova."
,"11":"Colocarei a minha morada no meio de vós e nunca mais vos rejeitarei."
,"12":"Eu caminharei convosco. Serei o vosso Deus, e vós sereis o meu povo."
,"13":"Eu sou Javé, o vosso Deus, que vos tirei do Egipto, para que não continuásseis a ser seus escravos. Quebrei os jugos da opressão, e fiz-vos andar de cabeça erguida."
,"14":"Mas se não Me obedecerdes e não puserdes em prática todos estes mandamentos;"
,"15":"se rejeitardes os meus estatutos e desprezardes as minhas normas, não pondo em prática os meus mandamentos e rompendo a minha aliança,"
,"16":"então tratar-vos-ei do seguinte modo: mandarei contra vós o terror, a fraqueza e a febre, que embaçam os olhos e consomem a vida. Espalhareis as sementes em vão, pois o vosso inimigo é que as comerá."
,"17":"Voltar-Me-ei contra vós, e sereis derrotados pelos inimigos. Os vossos adversários dominar-vos-ão e fugireis sem que ninguém vos persiga."
,"18":"E se nem mesmo assim Me obedecerdes, dar-vos-ei uma lição sete vezes maior, por causa dos vossos pecados."
,"19":"Quebrarei a vossa teimosia orgulhosa, fazendo com que o céu seja como o ferro, e a vossa terra como o bronze."
,"20":"Consumireis inutilmente as vossas energias, pois a terra não dará colheita, e as árvores do campo não produzirão frutos."
,"21":"Se ainda vos opuserdes a Mim e não Me obedecerdes, castigar-vos-ei sete vezes mais, por causa dos vossos pecados."
,"22":"Mandarei contra vós as feras do campo. Elas deixar-vos-ão sem filhos, reduzirão o vosso gado e dizimar-vos-ão, a ponto de deixarem desertos os vossos caminhos."
,"23":"E se, apesar desses castigos, ainda não vos corrigirdes e continuardes a opor-vos a Mim,"
,"24":"Eu também continuarei a ficar contra vós, e castigar-vos-ei sete vezes mais, por causa dos vossos pecados."
,"25":"Mandarei contra vós a espada vingadora da minha aliança. E quando vos refugiardes nas vossas cidades, mandarei a peste, e tereis de vos entregar aos inimigos."
,"26":"Quando Eu vos cortar os víveres, dez mulheres irão cozer o seu pão no mesmo forno, e dar-vos-ão o pão racionado; comereis, mas não ficareis saciados."
,"27":"E se, apesar disso tudo, ainda não Me derdes ouvidos e continuardes a opor-vos a Mim,"
,"28":"ficarei furioso contra vós, e castigar-vos-ei sete vezes mais, por causa dos vossos pecados."
,"29":"Comereis a carne dos vossos filhos e a carne das vossas filhas."
,"30":"Eu destruirei os vossos lugares altos, derrubarei os vossos altares de incenso, lançarei os vossos cadáveres sobre os cadáveres dos vossos ídolos e rejeitar-vos-ei."
,"31":"Devastarei as vossas cidades, destruirei os vossos santuários e não aspirarei mais o perfume do vosso incenso."
,"32":"Devastarei o vosso país, e os inimigos que o ocuparem ficarão horrorizados."
,"33":"Quanto a vós, espalhar-vos-ei entre as nações e perseguir-vos-ei com a espada desembainhada. Os vossos campos ficarão desertos e as vossas cidades em ruínas."
,"34":"Então a terra desfrutará os seus sábados, durante todos os dias em que estiver desolada, enquanto estiverdes na terra dos inimigos. Então a terra descansará e desfrutará os seus sábados."
,"35":"E durante todos os dias em que estiver desolada, ela descansará o descanso de sábado que não lhe destes enquanto nela habitáveis."
,"36":"Quanto aos vossos sobreviventes, farei com que se acovardem na terra dos inimigos; ficarão assustados com o barulho das folhas que voam, fugirão como se fosse da espada, e cairão sem que ninguém os persiga."
,"37":"Tropeçarão uns nos outros, como se estivessem diante da espada, sem que ninguém os persiga. Não podereis resistir aos inimigos,"
,"38":"perecereis entre as nações, e a terra dos vossos inimigos devorar-vos-á."
,"39":"Aqueles que dentre vós sobreviverem apodrecerão no país inimigo, por causa da sua própria culpa e da culpa dos seus pais."
,"40":"Confessarão a própria culpa e a culpa dos seus pais, a culpa de terem sido infiéis e de se oporem a Mim."
,"41":"Eu também Me oporei a eles e conduzi-los-ei ao país dos seus inimigos, para ver se lhes dobro o coração incircunciso, e para ver se eles fazem penitência da sua culpa."
,"42":"Então lembrar-Me-ei da minha aliança com Jacob, da aliança com Isaac, da aliança com Abraão, e lembrar-Me-ei do país."
,"43":"No entanto, eles terão que abandonar o país, e este poderá então desfrutar os seus sábados, enquanto permanecer desolado com a ausência deles. Farão penitência pela culpa de terem rejeitado os meus mandamentos e desprezado as minhas leis."
,"44":"Apesar de tudo, quando eles estiverem no país inimigo, não os rejeitarei, nem os desprezarei até ao ponto de os exterminar e de romper a minha aliança com eles. Eu sou Javé, seu Deus."
,"45":"Em favor deles, recordar-Me-ei da aliança com os seus antepassados, que tirei do Egipto diante das nações, para ser o seu Deus. Eu sou Javé»."
,"46":"São estes os estatutos, normas e leis que Javé estabeleceu entre Ele e os filhos de Israel, no monte Sinai, por meio de Moisés."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel: Quando alguém quiser cumprir um voto a Javé, em relação ao valor de uma pessoa, o valor será o seguinte:"
,"3":"Se for um homem entre vinte e sessenta anos, a taxa será de quinhentos gramas de prata, conforme o peso-padrão do santuário."
,"4":"Se for uma mulher, a taxa será de trezentos gramas."
,"5":"Se for um rapaz entre cinco e vinte anos, a taxa será de duzentos gramas. Se for uma jovem, a taxa será de cem gramas."
,"6":"Se for um menino entre um mês e cinco anos, a taxa será de cinquenta gramas. Se for uma menina, a taxa será de trinta gramas."
,"7":"Se for um homem de sessenta anos para cima, a taxa será de cento e cinquenta gramas. Se for uma mulher, será de cem gramas."
,"8":"Se aquele que fez o voto não tiver condições de pagar a taxa estabelecida, apresentará a pessoa ao sacerdote. Este fará a avaliação de acordo com as possibilidades de quem fez o voto."
,"9":"Tratando-se de animais que podem ser oferecidos a Javé, o animal inteiro oferecido a Javé torna-se coisa sagrada."
,"10":"Não poderá ser trocado ou substituído, seja um bom por um mau, seja um mau por um bom. Se o animal for substituído por outro, ambos se tornam coisa sagrada."
,"11":"Se for animal impuro, que não pode ser oferecido a Javé, seja ele qual for, será levado ao sacerdote."
,"12":"Este fará a avaliação do animal, dizendo se é bom ou mau; a avaliação que o sacerdote fizer será considerada válida."
,"13":"Contudo, se a pessoa quiser resgatar o animal, pagará vinte por cento a mais do valor calculado."
,"14":"Quando alguém consagrar a sua casa a Javé, o sacerdote fará a avaliação de acordo com o tipo da casa; e a avaliação que o sacerdote fizer será considerada válida."
,"15":"Contudo, se aquele que fez o voto da casa quiser resgatá-la, pagará vinte por cento a mais do que foi avaliada, e a casa será dele."
,"16":"Quando alguém consagrar a Javé parte das terras de sua propriedade hereditária, a avaliação será feita conforme a semeadura: quinhentos gramas de prata para cada duzentos e vinte litros de cevada."
,"17":"Se a consagração do campo tiver sido feita durante o ano do jubileu, a taxa será integral."
,"18":"Mas se a consagração tiver sido feita depois do jubileu, o sacerdote calculará a taxa conforme os anos que faltarem para o próximo ano do jubileu, fazendo o desconto correspondente."
,"19":"Se a pessoa quiser resgatar o campo, pagará vinte por cento a mais do que foi avaliado, e o campo será seu."
,"20":"Contudo, se a pessoa não resgatar o campo, mas o vender a alguém, tal campo nunca mais poderá ser resgatado:"
,"21":"no ano do jubileu, quem tiver comprado o campo deverá deixá-lo, e tal campo tornar-se-á coisa consagrada a Javé, como se fosse despojo de guerra. A propriedade hereditária do campo passa a ser do sacerdote."
,"22":"Quando alguém consagrar a Javé um campo que tenha adquirido e que não faz parte da sua propriedade hereditária,"
,"23":"o sacerdote avaliará o campo conforme o tempo que ainda faltar para o ano do jubileu. A pessoa que tiver consagrado o campo pagará a importância no mesmo dia, como coisa consagrada a Javé."
,"24":"No ano do jubileu, o campo voltará a ser daquele que o tiver vendido, isto é, daquele que tiver a posse hereditária."
,"25":"As avaliações serão feitas de acordo com o peso-padrão do santuário, cujo peso equivale a dez gramas."
,"26":"Ninguém poderá consagrar a primeira cria de um animal, pois esta já pertence a Javé: quer seja boi, quer seja ovelha, pertence a Javé."
,"27":"Mas se for animal impuro, poderá ser resgatado pelo preço avaliado, mais vinte por cento; se não for resgatado, será vendido pelo preço avaliado."
,"28":"Aquilo que alguém consagrou a Javé como anátema não pode ser vendido nem resgatado, quer sejam homens, quer sejam animais ou campos de sua propriedade hereditária. O que foi consagrado como anátema é coisa santíssima que pertence a Javé."
,"29":"Uma pessoa consagrada ao anátema não pode ser resgatada: deverá ser morta."
,"30":"Todos os dízimos do campo, quer sejam produto da terra, quer sejam fruto das árvores, pertencem a Javé: é coisa consagrada a Javé."
,"31":"Se alguém quiser resgatar parte do dízimo, pagará vinte por cento além do valor."
,"32":"Os dízimos de animais, boi ou ovelha, isto é, a décima parte de tudo o que passa sob o cajado do pastor, é coisa consagrada a Javé."
,"33":"Não se fará distinção entre os que são bons ou maus, nem serão substituídos; se isso for feito, tanto o animal consagrado como aquele que serviu para substituir, serão coisas consagradas, e não poderão ser resgatados»."
,"34":"São estes os mandamentos que Javé deu a Moisés, no monte Sinai, para os filhos de Israel."
}`)

}
func PT_BS_LoadVPNMChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"No primeiro dia do segundo mês do segundo ano da saída do Egipto, Javé disse a Moisés na tenda da reunião, no deserto do Sinai:"
,"2":"«Fazei um recenseamento completo da comunidade dos filhos de Israel: todos os homens, um a um, conforme os clãs e famílias, registando os seus nomes."
,"3":"Tu e Aarão registareis, por esquadrões, todos os homens maiores de vinte anos e capacitados para a guerra."
,"4":"Convosco estará um homem de cada tribo, chefes de famílias."
,"5":"São estes os nomes daqueles que vos ajudarão: De Rúben, Elisur, filho de Sedeur."
,"6":"De Simeão, Salamiel, filho de Surisadai."
,"7":"De Judá, Naasson, filho de Aminadab."
,"8":"De Issacar, Natanael, filho de Suar."
,"9":"De Zabulon, Eliab, filho de Helon."
,"10":"Dos filhos de José: de Efraim, Elisama, filho de Amiud; de Manassés, Gamaliel, filho de Fadassur."
,"11":"De Benjamim, Abidã, filho de Gedeão."
,"12":"De Dã, Aiezer, filho de Amisadai."
,"13":"De Aser, Fegiel, filho de Ocrã."
,"14":"De Gad, Eliasaf, filho de Reuel."
,"15":"De Neftali, Aíra, filho de Enã»."
,"16":"Foram estes os homens escolhidos na comunidade; eram chefes da tribo do seu antepassado e chefes dos clãs de Israel."
,"17":"Moisés e Aarão tomaram estes homens que haviam sido escolhidos pelo nome,"
,"18":"e convocaram toda a comunidade no primeiro dia do segundo mês. Todos os que tinham mais de vinte anos se inscreveram, um por um, conforme os clãs e famílias, registando os seus nomes."
,"19":"O recenseamento no deserto do Sinai foi feito conforme Javé havia mandado a Moisés."
,"20":"Foram recenseados os filhos e descendentes de Rúben, primogénito de Israel, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"21":"Total da tribo de Rúben: quarenta e seis mil e quinhentos."
,"22":"Foram recenseados os filhos e descendentes de Simeão, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"23":"Total da tribo de Simeão: cinquenta e nove mil e trezentos."
,"24":"Foram recenseados os filhos e descendentes de Gad, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"25":"Total da tribo de Gad: quarenta e cinco mil e seiscentos e cinquenta."
,"26":"Foram recenseados os filhos e descendentes de Judá, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"27":"Total da tribo de Judá: setenta e quatro mil e seiscentos."
,"28":"Foram recenseados os filhos e descendentes de Issacar, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"29":"Total da tribo de Issacar: cinquenta e quatro mil e quatrocentos."
,"30":"Foram recenseados os filhos e descendentes de Zabulon, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"31":"Total da tribo de Zabulon: cinquenta e sete mil e quatrocentos."
,"32":"Foram recenseados os filhos e descendentes de Efraim, filho de José, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"33":"Total da tribo de Efraim: quarenta mil e quinhentos."
,"34":"Foram recenseados os filhos e descendentes de Manassés, filho de José, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"35":"Total da tribo de Manassés: trinta e dois mil e duzentos."
,"36":"Foram recenseados os filhos e descendentes de Benjamim, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"37":"Total da tribo de Benjamim: trinta e cinco mil e quatrocentos."
,"38":"Foram recenseados os filhos e descendentes de Dã, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"39":"Total da tribo de Dã: sessenta e dois mil e setecentos."
,"40":"Foram recenseados os filhos e descendentes de Aser, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"41":"Total da tribo de Aser: quarenta e um mil e quinhentos."
,"42":"Foram recenseados os filhos e descendentes de Neftali, conforme os clãs e famílias, registando os nomes, um por um, dos homens com mais de vinte anos e capacitados para a guerra."
,"43":"Total da tribo de Neftali; cinquenta e três mil e quatrocentos."
,"44":"Este foi o recenseamento que Moisés fez com Aarão, ajudado pelos doze chefes de Israel: um de cada família."
,"45":"O total dos filhos de Israel, com mais de vinte anos e capacitados para a guerra,"
,"46":"foi de seiscentos e três mil e quinhentos e cinquenta."
,"47":"Os levitas não foram recenseados com os outros, conforme as famílias,"
,"48":"porque Javé tinha dito a Moisés:"
,"49":"«Não incluas os levitas no recenseamento e nos registos dos filhos de Israel."
,"50":"Encarrega-os da tenda da aliança, dos seus utensílios e de tudo o que lhes pertence. Eles transportarão a tenda, com todos os utensílios, estarão ao seu serviço e acamparão ao redor dela."
,"51":"Quando a tenda tiver que ser deslocada, os levitas desmontá-la-ão; ao acampar, os levitas montá-la-ão. Qualquer estranho que se aproximar dela será condenado à morte."
,"52":"Os filhos de Israel acamparão por esquadrões, cada um em seu acampamento, junto à sua bandeira."
,"53":"Os levitas, porém, acamparão ao redor da tenda da aliança, para que a Ira não se acenda contra a comunidade dos filhos de Israel. Os levitas cuidarão da tenda da aliança»."
,"54":"Os filhos de Israel acataram tudo o que Javé havia ordenado a Moisés, e assim fizeram."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Javé disse a Moisés e Aarão:"
,"2":"«Os filhos de Israel acamparão, cada um junto da sua bandeira, com o símbolo da sua família. Acamparão voltados para a tenda da reunião e ao redor dela."
,"3":"No lado Leste, em direcção ao nascer do sol, acamparão os da bandeira de Judá, com os seus esquadrões; o chefe dos filhos de Judá é Naasson, filho de Aminadab;"
,"4":"o seu exército conta com setenta e quatro mil e seiscentos alistados."
,"5":"Ao lado de Judá acampará a tribo de Issacar. O chefe dos filhos de Issacar é Natanael, filho de Suar."
,"6":"O seu exército conta com cinquenta e quatro mil e quatrocentos alistados."
,"7":"Do outro lado ficará a tribo de Zabulon. O chefe dos filhos de Zabulon é Eliab, filho de Elon."
,"8":"O seu exército conta com cinquenta e sete mil e quatrocentos alistados."
,"9":"No acampamento de Judá, os alistados por esquadrões são cento e oitenta e seis mil e quatrocentos. Estes serão os primeiros a pôr-se em marcha."
,"10":"No lado Sul, a bandeira de Rúben, com os seus esquadrões. O chefe dos filhos de Rúben é Elisur, filho de Sedeur."
,"11":"O seu exército conta com quarenta e seis mil e quinhentos alistados."
,"12":"Ao lado de Rúben acampará a tribo de Simeão. O chefe dos filhos de Simeão é Salamiel, filho de Surisadai."
,"13":"O seu exército conta com cinquenta e nove mil e trezentos alistados."
,"14":"Do outro lado ficará a tribo de Gad. O chefe dos filhos de Gad é Eliasaf, filho de Reuel."
,"15":"O seu exército conta com quarenta e cinco mil e seiscentos e cinquenta alistados."
,"16":"No acampamento de Rúben, os alistados por esquadrões são cento e cinquenta e um mil e quatrocentos e cinquenta. Estes serão os que levantarão o acampamento em segundo lugar."
,"17":"Depois, a tenda da reunião colocar-se-á em marcha juntamente com o acampamento dos levitas, no meio dos outros acampamentos. A ordem da marcha será a mesma do acampamento, cada um seguindo a sua bandeira."
,"18":"No lado Oeste estará a bandeira do acampamento de Efraim, com os seus esquadrões. O chefe dos filhos de Efraim é Elisama, filho de Amiud."
,"19":"O seu exército conta com quarenta mil e quinhentos alistados."
,"20":"Ao lado de Efraim acampará a tribo de Manassés. O chefe dos filhos de Manassés é Gamaliel, filho de Fadassur."
,"21":"O seu exército conta com trinta e dois mil e duzentos alistados."
,"22":"Do outro lado acampará a tribo de Benjamim. O chefe dos filhos de Benjamim é Abidã, filho de Gedeão."
,"23":"O seu exército conta com trinta e cinco mil e quatrocentos alistados."
,"24":"Os alistados do acampamento de Efraim, com os seus esquadrões, fazem o total de cento e oito mil e cem. Eles pôr-se-ão em marcha em terceiro lugar."
,"25":"No lado Norte estará a bandeira do acampamento de Dã, com os seus esquadrões. O chefe dos filhos de Dã é Aiezer, filho de Amisadai."
,"26":"O seu exército conta com sessenta e dois mil e setecentos alistados."
,"27":"Ao lado de Dã acampará a tribo de Aser. O chefe dos filhos de Aser é Fegiel, filho de Ocrã."
,"28":"O seu exército conta com quarenta e um mil e quinhentos alistados."
,"29":"Do outro lado ficará a tribo de Neftali. O chefe dos filhos de Neftali é Aíra, filho de Enã."
,"30":"O seu exército conta com cinquenta e três mil e quatrocentos alistados."
,"31":"Os alistados do acampamento de Dã fazem o total de cento e cinquenta e sete mil e seiscentos. Eles pôr-se-ão em marcha em último lugar, seguindo as suas bandeiras»."
,"32":"Este é o recenseamento dos filhos de Israel por famílias. Os que foram alistados nesses acampamentos, conforme os seus esquadrões, dão o total de seiscentos e três mil, quinhentos e cinquenta."
,"33":"De acordo com o que Javé havia ordenado a Moisés, os Levitas não foram incluídos no recenseamento dos filhos de Israel."
,"34":"Os filhos de Israel fizeram tudo o que Javé havia ordenado a Moisés: acampavam segundo as suas bandeiras e punham-se em marcha por clãs e famílias."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Esta é a história de Aarão e Moisés, quando Javé falou a Moisés no monte Sinai."
,"2":"São estes os nomes dos filhos de Aarão: Nadab, o primogénito, Abiú, Eleazar e Itamar."
,"3":"São estes os nomes dos filhos de Aarão, ungidos e consagrados como sacerdotes."
,"4":"Nadab e Abiú morreram diante de Javé, no deserto do Sinai, ao apresentarem um fogo irregular diante de Javé. Como não tinham filhos, Eleazar e Itamar exerceram o ofício de sacerdotes, quando o seu pai Aarão ainda vivia."
,"5":"Javé disse a Moisés:"
,"6":"«Manda aproximar a tribo de Levi e põe-na à disposição do sacerdote Aarão, para que esteja ao serviço dele."
,"7":"Eles cuidarão de todos os serviços de Aarão e de toda a comunidade, diante da tenda da reunião, e exercerão as tarefas do santuário."
,"8":"Cuidarão de todos os utensílios da tenda da reunião, montarão guarda em lugar dos filhos de Israel e prestarão serviço na tenda da reunião."
,"9":"Entrega os levitas como oblatos a Aarão e a seus filhos; entre os filhos de Israel, os levitas serão oblatos."
,"10":"Estabelece Aarão e seus filhos para exercerem as funções sacerdotais: qualquer estranho que se intrometa será réu de morte»."
,"11":"Javé disse a Moisés:"
,"12":"«Eu mesmo escolhi os levitas entre os filhos de Israel, para substituir os primogénitos, os filhos de Israel que abrem o seio materno. Portanto, os levitas são meus."
,"13":"De facto, todo o primogénito Me pertence, pois no dia em que matei os primogénitos na terra do Egipto, consagrei a Mim todos os primogénitos de Israel, tanto homens como animais. Eles pertencem-Me. Eu sou Javé»."
,"14":"Javé disse a Moisés no deserto do Sinai:"
,"15":"«Faz o recenseamento dos filhos de Levi conforme as suas famílias e clãs. Faz o recenseamento de todos os homens de um mês para cima»."
,"16":"Moisés fez o recenseamento conforme Javé havia ordenado."
,"17":"São estes os nomes dos filhos de Levi: Gérson, Caat e Merari."
,"18":"São estes os filhos de Gérson, conforme os seus clãs: Lobni e Semei."
,"19":"Os filhos de Caat, conforme os seus clãs, são: Amram, Isaar, Hebron e Oziel."
,"20":"Os filhos de Merari, conforme os seus clãs, são: Mooli e Musi. São estes os clãs de Levi, reunidos por famílias."
,"21":"Os clãs de Lobni e de Semei descendem de Gérson: são os clãs gersonitas."
,"22":"O total dos homens recenseados, de um mês para cima, foi de sete mil e quinhentos."
,"23":"Os clãs gersonitas acampavam no lado ocidental, atrás do santuário."
,"24":"O chefe da família de Gérson era Eliasaf, filho de Lael."
,"25":"Na tenda da reunião, os gersonitas eram encarregados de cuidar do santuário, da tenda e da sua cobertura, do véu da entrada da tenda da reunião,"
,"26":"das cortinas do átrio, do véu da entrada da tenda do átrio que dá para o santuário e que rodeia o altar, e também das cordas para a montagem."
,"27":"Os clãs de Amram, Isaar, Hebron e Oziel descendem de Caat: são os clãs caatitas."
,"28":"O total dos homens recenseados, de um mês para cima, foi de oito mil e seiscentos. Eles eram encarregados da conservação do santuário."
,"29":"Os clãs caatitas acampavam no lado Sul do santuário."
,"30":"O chefe da família para os clãs caatitas era Elisafã, filho de Oziel."
,"31":"Eles eram encarregados da arca, da mesa, do candelabro, dos altares, dos objectos sagrados de culto e do véu, com todos os apetrechos."
,"32":"O chefe supremo dos levitas era Eleazar, filho do sacerdote Aarão; ele era superintendente de todos os que cuidavam do santuário."
,"33":"Os clãs de Mooli e Musi descendem de Merari: são os clãs meraritas."
,"34":"O total dos homens recenseados, de um mês para cima, foi de seis mil e duzentos."
,"35":"O chefe da família para os clãs meraritas era Suriel, filho de Abiail. Eles acampavam no lado Norte do santuário."
,"36":"Os filhos de Merari eram encarregados das tábuas do santuário, das suas vigas, colunas e bases, com todos os acessórios e utensílios,"
,"37":"e também das colunas que rodeiam o átrio, das suas bases, estacas e cordas."
,"38":"No lado oriental, diante do santuário e da tenda da reunião, acampavam Moisés, Aarão e seus filhos, encarregados do santuário em nome dos filhos de Israel. Todo o estranho que se intrometesse era réu de morte."
,"39":"O total dos levitas com mais de um mês de idade, recenseados e enumerados por Moisés e Aarão, conforme os clãs, de acordo com o que Javé havia ordenado, foi de vinte e dois mil."
,"40":"Javé disse a Moisés: «Faz o recenseamento de todos os primogénitos homens dos filhos de Israel, de um mês para cima, registando os seus nomes."
,"41":"Em lugar dos primogénitos de Israel separa os levitas para Mim, e também o gado dos levitas, em lugar dos primogénitos do gado dos filhos de Israel»."
,"42":"Moisés fez o recenseamento dos primogénitos dos filhos de Israel, conforme Javé lhe havia ordenado."
,"43":"O total dos primogénitos homens, de um mês para cima, foi de vinte e dois mil, duzentos e setenta e três."
,"44":"Javé disse a Moisés:"
,"45":"«Em lugar dos primogénitos dos filhos de Israel separa os levitas, e o gado dos levitas em lugar do gado de Israel. Os levitas pertencer-Me-ão. Eu sou Javé."
,"46":"Para resgatar os duzentos e setenta e três primogénitos dos filhos de Israel, que ultrapassam o número dos levitas,"
,"47":"toma cinquenta gramas por pessoa, conforme o peso-padrão do santuário, que equivale a dez gramas."
,"48":"Entrega esse dinheiro a Aarão e seus filhos, como resgate daqueles que ultrapassam o número dos levitas»."
,"49":"Moisés pegou no dinheiro para o resgate daqueles que ultrapassavam o número dos levitas."
,"50":"Então, dos primogénitos dos filhos de Israel recebeu treze mil e seiscentos e cinquenta gramas, conforme o peso-padrão do santuário,"
,"51":"e entregou o dinheiro do resgate a Aarão e seus filhos, conforme as ordens que Javé tinha dado a Moisés."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Javé disse a Moisés e Aarão:"
,"2":"«Fazei, à parte dos outros levitas, o recenseamento dos filhos de Caat, conforme os seus clãs e famílias:"
,"3":"todos os homens de trinta a cinquenta anos, aptos para o serviço militar, que realizarão as suas funções na tenda da reunião."
,"4":"Os filhos de Caat dedicar-se-ão às coisas sagradas na tenda da reunião."
,"5":"Quando o acampamento se puser em marcha, Aarão e seus filhos entrarão, tirarão a cortina, e com ela cobrirão a arca da aliança."
,"6":"Por cima dela, colocarão uma cobertura de couro fino, sobre a qual estenderão um pano de púrpura violeta. Em seguida, colocarão os varais da arca."
,"7":"Sobre a mesa dos pães oferecidos a Deus estenderão um pano de púrpura violeta, e colocarão em cima os pratos, copos, taças e jarros para a libação. Por cima, estará o pão da oferta perpétua."
,"8":"Por cima deles estenderão um pano de púrpura escarlate, que será coberto com uma cobertura de couro fino. Em seguida colocarão os varais da mesa."
,"9":"Tomarão, então, um pano de púrpura violeta para cobrir o candelabro com as suas lâmpadas, os acendedores, apagadores e todas as vasilhas de azeite usadas no serviço do candelabro."
,"10":"Colocarão o candelabro com todos os seus utensílios sobre uma cobertura de couro fino e colocá-lo-ão por cima dos varais."
,"11":"Estenderão um pano de púrpura violeta sobre o altar de ouro e recobri-lo-ão com uma cobertura de couro fino. Em seguida ajustarão nele os varais."
,"12":"Depois tomarão todos os utensílios usados no serviço do santuário, colocá-los-ão num pano de púrpura violeta e recobri-lo-ão com uma cobertura de couro fino, e colocarão tudo sobre os varais."
,"13":"Tirarão a cinza do altar, estenderão sobre ele um pano de púrpura escarlate,"
,"14":"e sobre este colocarão todos os utensílios usados no culto: incensórios, garfos, pás, bacias e todos os utensílios do altar. Estenderão por cima uma cobertura de couro fino e colocarão os varais."
,"15":"Quando Aarão e seus filhos acabarem de cobrir o santuário com todos os seus utensílios, os filhos de Caat, no momento de levantar o acampamento, virão para o transportar, sem tocar naquilo que é consagrado; se o fizessem, morreriam. Esta é a carga da tenda da reunião, que os caatitas deverão transportar."
,"16":"Eleazar, filho do sacerdote Aarão, cuidará do azeite do candelabro, dos perfumes de ervas aromáticas, da oblação diária e do óleo da unção; cuidará também de todo o santuário e de tudo o que nele se encontra: os objectos sagrados e seus utensílios»."
,"17":"Javé disse a Moisés e Aarão:"
,"18":"«Não permitais que a tribo dos clãs caatitas desapareça da tribo de Levi."
,"19":"E fazei o seguinte, para que eles não morram: quando tiverem que se aproximar dos objectos sagrados, Aarão e seus filhos entrarão e indicarão a tarefa e o encargo de cada um."
,"20":"Deste modo, eles não entrarão para ver os objectos sagrados nem por um instante, senão morreriam»."
,"21":"Javé disse a Moisés:"
,"22":"«Faz também o recenseamento dos filhos de Gérson, conforme os clãs e famílias."
,"23":"Faz o recenseamento de todos os homens de trinta a cinquenta anos, aptos para o serviço militar, a fim de trabalharem na tenda da reunião."
,"24":"Esta é a tarefa dos clãs gersonitas, com suas funções e encargos:"
,"25":"transportarão as cortinas do santuário, a tenda da reunião com a sua cobertura e a cobertura de couro fino que a recobre, a cortina da entrada da tenda da reunião,"
,"26":"as cortinas do átrio, o véu da entrada na porta do átrio, as cortinas que estão em volta do santuário e do altar, as cordas e todos os utensílios necessários para a montagem dela. Farão todo o serviço que se refere a estas coisas."
,"27":"Os gersonitas cumprirão as suas funções sob as ordens de Aarão e seus filhos, que lhes indicarão os serviços de guarda e de transporte."
,"28":"São estas as tarefas dos clãs gersonitas na tenda da reunião. A supervisão deles estará a cargo de Itamar, filho do sacerdote Aarão."
,"29":"Faz também o recenseamento dos filhos de Merari, conforme os clãs e famílias."
,"30":"Faz o recenseamento de todos os homens de trinta a cinquenta anos, aptos para o serviço militar, a fim de trabalharem na tenda da reunião."
,"31":"Este é o serviço que deverão assumir e a função que lhes competirá na tenda da reunião: transportarão as tábuas do santuário, as vigas, colunas, bases,"
,"32":"as colunas que rodeiam o átrio com as suas bases, as estacas, cordas e todos os acessórios. Indica nominalmente os objectos que eles deverão guardar e transportar."
,"33":"Tal será o serviço dos clãs meraritas na tenda da reunião. A supervisão deles estará a cargo de Itamar, filho do sacerdote Aarão»."
,"34":"Moisés e Aarão, juntamente com os chefes da comunidade, fizeram o recenseamento dos caatitas, conforme os seus clãs e famílias:"
,"35":"todos os que tinham de trinta a cinquenta anos, aptos para o serviço militar, a fim de trabalharem na tenda da reunião."
,"36":"Foram contados, por clãs, dois mil setecentos e cinquenta homens."
,"37":"Este foi o total dos recenseamentos dos clãs caatitas, de todos os que deviam servir na tenda da reunião e que foram recenseados por Moisés e Aarão, conforme Javé havia ordenado."
,"38":"Foi feito também o recenseamento dos filhos de Gérson, conforme os seus clãs e famílias:"
,"39":"foram recenseados todos os homens de trinta a cinquenta anos, aptos para o serviço militar, a fim de trabalharem na tenda da reunião."
,"40":"Foram contados dois mil seiscentos e trinta, conforme os clãs e famílias."
,"41":"Este foi o total dos recenseados dos clãs dos gersonitas, que deviam trabalhar na tenda da reunião e que foram recenseados por Moisés e Aarão, conforme Javé havia ordenado."
,"42":"Foi feito também o recenseamento dos filhos de Merari, conforme os seus clãs e famílias:"
,"43":"foram recenseados todos os homens de trinta a cinquenta anos, aptos para o serviço militar, a fim de trabalharem na tenda da reunião."
,"44":"Foram contados, conforme os clãs, três mil e duzentos homens."
,"45":"Este foi o total dos clãs meraritas recenseados por Moisés e Aarão, conforme Javé havia ordenado."
,"46":"O número total dos levitas contados no recenseamento, que Moisés, Aarão e os chefes de Israel fizeram, por clãs e famílias,"
,"47":"dos homens de trinta a cinquenta anos, aptos para o serviço militar e para o serviço e o transporte da tenda da reunião,"
,"48":"chegou a oito mil quinhentos e oitenta homens."
,"49":"Moisés fez o recenseamento por ordem de Javé, indicando a cada um o serviço e a carga que deveria transportar. Assim foi feito o recenseamento, conforme Javé havia ordenado a Moisés."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Javé dissea Moisés:"
,"2":"«Ordena aos filhos de Israel que expulsem do acampamento os leprosos, os que têm gonorreia e os que se contaminaram com cadáveres."
,"3":"Homens ou mulheres, serão todos expulsos do acampamento, para que não fique contaminado o acampamento, no meio do qual Eu moro»."
,"4":"Os filhos de Israel fizeram isto e expulsaram-nos do acampamento. Os israelitas fizeram conforme Javé havia ordenado a Moisés."
,"5":"Javé disse a Moisés:"
,"6":"«Diz aos filhos de Israel: Quando um homem ou mulher comete um pecado que prejudica o próximo, ofendendo assim a Javé, tal pessoa é culpada:"
,"7":"confessará o seu pecado e restituirá, a quem for prejudicado, vinte por cento além do prejuízo causado."
,"8":"Contudo, se o homem prejudicado não tem parente nenhum ao qual se possa fazer a restituição, esta será feita a Javé através do sacerdote, além do cordeiro com que o sacerdote fará o rito de expiação pelo culpado."
,"9":"Tudo aquilo que os filhos de Israel consagrarem será levado ao sacerdote e a ele pertencerá."
,"10":"As coisas que uma pessoa consagrar serão dele; aquilo que alguém der ao sacerdote, ao sacerdote pertencerá»."
,"11":"Javé disse a Moisés:"
,"12":"«Diz aos filhos de Israel: Se alguém supõe que a sua mulher se desviou e se tornou infiel,"
,"13":"e que outro homem teve relações com ela, tornando-se impura em segredo, pois não havia testemunhas nem foi surpreendida em flagrante,"
,"14":"se o marido suspeitar e tiver ciúmes, quer a mulher esteja contaminada quer não,"
,"15":"ele deverá levar a sua mulher ao sacerdote. Levará uma oferta de quatro quilos e meio de farinha de cevada, sem misturar azeite ou incenso, pois é uma oferta de ciúme, para denunciar uma culpa."
,"16":"O sacerdote aproximar-se-á e colocará a mulher diante de Javé."
,"17":"Depois tomará água santa numa vasilha de barro e deitará pó do chão do santuário na água;"
,"18":"colocará a mulher diante de Javé, soltará os cabelos dela e colocar-lhe-á nas mãos a oferta pelo ciúme, enquanto o sacerdote terá na mão a água amarga da maldição."
,"19":"Em seguida o sacerdote dirá, fazendo a mulher jurar: 'Se não dormiste com um estranho e não te contaminaste enquanto estavas sob o domínio do teu marido, que esta água amarga da maldição não te faça mal."
,"20":"Mas, se enganaste o teu marido enquanto estavas sob o domínio dele e te contaminaste, deitando-te com outro homem...'"
,"21":"E o sacerdote dirá, fazendo que a mulher preste juramento: '...que Javé te entregue à maldição entre os teus, fazendo com que o teu sexo fique murcho e o teu ventre inchado."
,"22":"Que esta água da maldição entre nas tuas entranhas para inchar o teu ventre e murchar o teu sexo'. E a mulher responderá: 'Ámen! Ámen!'"
,"23":"Depois o sacerdote escreverá esta maldição num documento e lavá-lo-á na água amarga."
,"24":"Em seguida fará beber à mulher a água amarga da maldição, de modo que a água da maldição entre nela."
,"25":"Em seguida, o sacerdote tomará das mãos da mulher a oferta pelo ciúme, apresentá-la-á diante de Javé e colocá-la-á sobre o altar."
,"26":"Tomará um punhado da oferta pelo ciúme e queimá-lo-á sobre o altar, como memorial. Em seguida, fará beber à mulher a água da maldição."
,"27":"Se ela se contaminou e foi infiel a seu marido, logo que a água amarga da maldição entrar nela, o seu ventre ficará inchado, o seu sexo murchará, e a mulher ficará maldita entre os seus."
,"28":"Se a mulher não se contaminou, se estiver pura, não sofrerá dano e poderá conceber»."
,"29":"Este é o ritual para o caso de ciúme, quando uma mulher se desvia e se torna impura, enquanto está sob o poder do marido;"
,"30":"ou no caso em que um homem fica com ciúme da sua mulher. O marido levará a mulher diante de Javé e o sacerdote fará este ritual com ela."
,"31":"O marido estará livre de culpa, mas a mulher receberá a punição da própria culpa."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel: Quando um homem ou mulher quiser fazer um voto especial de consagração a Javé, o voto de nazareato,"
,"3":"deverá abster-se de vinho e de bebidas fermentadas, e não poderá beber vinagre de vinho ou de bebidas fermentadas; também não tomará suco de uvas, nem comerá uvas frescas ou secas."
,"4":"Enquanto durar o seu voto não provará nada que venha da videira, desde a semente até às cascas."
,"5":"Enquanto durar o seu voto de nazareato não rapará a cabeça com navalha; deixará crescer livremente os cabelos, até que acabe o tempo pelo qual se consagrou a Javé."
,"6":"Durante todo o tempo em que estiver consagrado a Javé não se aproximará de nenhum morto,"
,"7":"nem mesmo do seu pai ou da sua mãe, do seu irmão ou da sua irmã. Se estes morrerem, ele não deverá contaminar-se com eles, porque traz sobre a cabeça o sinal da sua consagração a Deus."
,"8":"Durante todo o tempo do seu nazareato ele está consagrado a Javé."
,"9":"Se uma pessoa morrer de repente ao lado de alguém consagrado, contaminando-lhe por isso a cabeça, ele deverá rapar a cabeça no dia da purificação, isto é, no sétimo dia."
,"10":"No oitavo dia levará ao sacerdote duas rolas ou dois pombinhos à entrada da tenda da reunião."
,"11":"E o sacerdote oferecerá um deles em sacrifício pelo pecado, e o outro em holocausto; em seguida fará o rito pelo pecado, por causa da contaminação com o morto. No mesmo dia, aquele que fez o voto consagrará a sua cabeça,"
,"12":"consagrar-se-á a Javé durante o tempo do seu nazareato, e levará um cordeiro de um ano como sacrifício de reparação. O tempo anterior não será contado, pois o seu nazareato foi contaminado."
,"13":"Esta é a lei para o nazarita no dia em que terminar o seu nazareato: ele será conduzido à entrada da tenda da reunião,"
,"14":"onde apresentará a sua oferta a Javé: um cordeiro de um ano e sem defeito, para o holocausto; uma ovelha de um ano e sem defeito, para o sacrifício pelo pecado; um carneiro sem defeito, para o sacrifício de comunhão;"
,"15":"uma cesta de bolos de flor de farinha, sem fermento, amassados com azeite, e tortas sem fermento untadas com azeite, acompanhados de ofertas e libações."
,"16":"Então o sacerdote, levando tudo diante de Javé, apresentará o sacrifício pelo pecado e o holocausto."
,"17":"Depois oferecerá um sacrifício de comunhão com o carneiro e com os bolos sem fermento da cesta; o sacerdote oferecerá também as ofertas e libações."
,"18":"Em seguida, o nazarita, junto à entrada da tenda da reunião rapará a cabeça consagrada, pegará nos cabelos da sua cabeça consagrada e colocá-los-á no fogo do sacrifício de comunhão."
,"19":"O sacerdote tomará a espádua assada do carneiro, um bolo sem fermento da cesta e uma torta sem fermento, colocando tudo na mão do nazarita, depois de ele ter rapado a cabeça."
,"20":"Então, com isto tudo, o sacerdote fará o gesto de apresentação diante de Javé: é a porção sagrada que pertence ao sacerdote, além do peito apresentado e da coxa reservada. Em seguida, o nazarita poderá beber vinho."
,"21":"Esta é a lei do nazarita; esta é a oferta a Javé pelo seu nazareato, além daquilo que as suas posses permitirem fazer. Cumprirá o que tiver prometido com voto, conforme a lei do nazareato»."
,"22":"Javé disse a Moisés:"
,"23":"«Diz a Aarão e a seus filhos: Abençoareis deste modo os filhos de Israel:"
,"24":"'Javé te abençoe e guarde!"
,"25":"Javé te mostre o seu rosto brilhante e tenha piedade de ti!"
,"26":"Javé te mostre o seu rosto e te conceda a paz!'"
,"27":"É assim que eles invocarão o meu nome sobre os filhos de Israel, e Eu os abençoarei»."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Quando acabou de construir o santuário, Moisés ungiu-o e consagrou-o com todos os utensílios, juntamente com o altar e todos os utensílios. Quando acabou de ungir e consagrar todas as coisas,"
,"2":"os chefes de Israel fizeram uma oferta. Eram os chefes de famílias e tribos, que tinham colaborado no recenseamento."
,"3":"Levaram a sua oferta diante de Javé: seis carros cobertos e doze bois, um carro por cada dois chefes e um boi por cada um deles. E apresentaram estas ofertas diante do santuário."
,"4":"Javé disse a Moisés:"
,"5":"«Recebe as ofertas deles para o serviço da tenda da reunião e entrega-as aos levitas, a cada um conforme a sua função»."
,"6":"Moisés recebeu os carros e bois e entregou-os aos levitas."
,"7":"Deu dois carros e quatro bois aos filhos de Gérson para as suas tarefas."
,"8":"Aos filhos de Merari deu quatro carros e oito bois para as tarefas que deviam realizar sob a direcção de Itamar, filho do sacerdote Aarão."
,"9":"Aos filhos de Caat, porém, não deu nada, pois eles deviam levar aos ombros os objectos sagrados."
,"10":"Os chefes apresentaram a oferta para a dedicação do altar, quando foi ungido, levando-a diante do altar."
,"11":"Então Javé disse a Moisés: «Cada dia, um chefe trará a sua oferta para a dedicação do altar»."
,"12":"No primeiro dia, Naasson, filho de Aminadab, da tribo de Judá, levou a sua oferta:"
,"13":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"14":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"15":"um bezerro, um carneiro, um cordeiro de um ano para o holocausto;"
,"16":"um bode para o sacrifício pelo pecado;"
,"17":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Naasson, filho de Aminadab."
,"18":"No segundo dia, Natanael, filho de Suar, chefe de Issacar, levou a sua oferta:"
,"19":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"20":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"21":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto,"
,"22":"um bode para o sacrifício pelo pecado;"
,"23":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Natanael, filho de Suar."
,"24":"No terceiro dia, Eliab, filho de Helon, chefe dos filhos de Zabulon, levou a sua oferta:"
,"25":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"26":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"27":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto,"
,"28":"um bode para o sacrifício pelo pecado;"
,"29":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Eliab, filho de Helon."
,"30":"No quarto dia, Elisur, filho de Sedeur, chefe dos filhos de Rúben, levou a sua oferta:"
,"31":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"32":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"33":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto,"
,"34":"um bode para o sacrifício pelo pecado;"
,"35":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Elisur, filho de Sedeur."
,"36":"No quinto dia, Salamiel, filho de Surisadai, chefe dos filhos de Simeão, levou a sua oferta:"
,"37":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"38":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"39":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto,"
,"40":"um bode para o sacrifício pelo pecado;"
,"41":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Salamiel, filho de Surisadai."
,"42":"No sexto dia, Eliasaf, filho de Reuel, chefe dos filhos de Gad, levou a sua oferta:"
,"43":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"44":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"45":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto;"
,"46":"um bode para o sacrifício pelo pecado;"
,"47":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Eliasaf, filho de Reuel."
,"48":"No sétimo dia, Elisama, filho de Amiud, chefe dos filhos de Efraim, levou a sua oferta:"
,"49":"uma bandeja de prata de mil e trezentos gramas; uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite, para a oferta."
,"50":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"51":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto;"
,"52":"um bode para o sacrifício pelo pecado;"
,"53":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Elisama, filho de Efraim."
,"54":"No oitavo dia, Gamaliel, filho de Fadassur, chefe dos filhos de Manassés, levou a sua oferta:"
,"55":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"56":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"57":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto;"
,"58":"um bode para o sacrifício pelo pecado;"
,"59":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Gamaliel, filho de Fadassur."
,"60":"No nono dia, Abidã, filho de Gedeão, chefe dos filhos de Benjamim, levou a sua oferta:"
,"61":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"62":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"63":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto;"
,"64":"um bode para o sacrifício pelo pecado;"
,"65":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Abidã, filho de Gedeão."
,"66":"No décimo dia, Aiezer, filho de Amisadai, chefe dos filhos de Dã, levou a sua oferta:"
,"67":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"68":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"69":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto;"
,"70":"um bode para o sacrifício pelo pecado;"
,"71":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Aiezer, filho de Amisadai."
,"72":"No décimo primeiro dia, Fegiel, filho de Ocrã, chefe dos filhos de Aser, levou a sua oferta:"
,"73":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"74":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"75":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto;"
,"76":"um bode para o sacrifício pelo pecado;"
,"77":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Fegiel, filho de Ocrã."
,"78":"No décimo segundo dia, Aíra, filho de Enã, chefe dos filhos de Neftali, levou a sua oferta:"
,"79":"uma bandeja de prata de mil e trezentos gramas, uma bacia de prata para aspersão, de setecentos gramas, conforme o peso-padrão do santuário, ambas cheias de flor de farinha amassada com azeite para a oferta."
,"80":"Levou também uma vasilha de ouro, de cem gramas, cheia de incenso;"
,"81":"um bezerro, um carneiro e um cordeiro de um ano para o holocausto;"
,"82":"um bode para o sacrifício pelo pecado;"
,"83":"e, para o sacrifício de comunhão, dois bois, cinco carneiros, cinco bodes e cinco cordeiros de um ano. Esta foi a oferta de Aíra, filho de Enã."
,"84":"Esta foi a oferta dos chefes de Israel para a dedicação do altar, no dia em que foi ungido: doze bandejas de prata, doze bacias de prata para aspersão, doze vasilhas de ouro."
,"85":"Cada bandeja de prata pesava mil e trezentos gramas, e cada bacia de aspersão setecentos gramas, sendo o total de vinte e quatro quilos de prata, conforme o peso-padrão do santuário."
,"86":"Doze vasilhas de ouro de cem gramas cada uma, conforme o peso-padrão do santuário, cheias de incenso, dando um total de mil e duzentos gramas de ouro."
,"87":"O total dos animais para o holocausto foi de doze bezerros, doze carneiros e doze cordeiros de um ano, com as ofertas que os acompanhavam, e doze bodes para o sacrifício pelo pecado."
,"88":"Para o sacrifício de comunhão, o total dos animais foi de vinte e quatro bois, sessenta carneiros, sessenta bodes e sessenta cordeiros de um ano. Esta foi a oferta para a dedicação do altar, quando foi ungido."
,"89":"Quando Moisés entrou na tenda da reunião para falar com Deus, ouviu a voz que lhe falava da placa de ouro que cobre a arca da aliança, entre os dois querubins. E Deus falava com Moisés."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz a Aarão: Quando acenderes as lâmpadas, faz de modo que elas iluminem a parte da frente do candelabro»."
,"3":"Aarão assim fez: colocou as lâmpadas de tal modo que iluminassem a parte da frente do candelabro, conforme Javé tinha ordenado a Moisés."
,"4":"O candelabro era de ouro cinzelado, desde o pedestal até às hastes, tendo sido feito de acordo com o modelo que Javé havia mostrado a Moisés."
,"5":"Javé disse a Moisés:"
,"6":"«Escolhe levitas entre os filhos de Israel e purifica-os"
,"7":"do seguinte modo: Faz sobre eles uma aspersão com água da expiação. Depois, passarão a navalha por todo o corpo, lavarão as roupas e purificar-se-ão."
,"8":"A seguir, tomarão um bezerro, com a correspondente oferta de flor de farinha amassada com azeite. Então tomarás outro bezerro para o sacrifício pelo pecado."
,"9":"Faz com que os levitas se aproximem da tenda da reunião e convoca toda a comunidade dos filhos de Israel."
,"10":"Quando os levitas estiverem diante de Javé, os filhos de Israel imporão as mãos sobre eles."
,"11":"Em seguida, Aarão, em nome dos filhos de Israel, apresentá-los-á a Javé com o gesto de apresentação, para que eles possam desempenhar as tarefas de Javé."
,"12":"Os levitas colocarão a mão sobre a cabeça dos bezerros, e tu oferecê-los-ás pelo pecado dos levitas: um como sacrifício pelo pecado e o outro em holocausto."
,"13":"Coloca, depois, os levitas diante de Aarão e seus filhos, e oferece-os a Javé com o gesto de apresentação."
,"14":"Deste modo, separa do meio dos filhos de Israel os levitas, para que Me pertençam."
,"15":"Então os levitas poderão começar a servir na tenda da reunião. Purifica-os e oferece-os com o gesto de apresentação,"
,"16":"porque os levitas Me foram dados pelos filhos de Israel, em troca dos seus primogénitos, e Eu reservo-os para Mim."
,"17":"Todos os primogénitos de Israel, homem ou animal, Me pertencem: Eu os consagrei a Mim mesmo, desde o dia em que matei todos os primogénitos do Egipto."
,"18":"Por isso, Eu reservo para Mim os levitas, em troca dos primogénitos dos filhos de Israel,"
,"19":"e entrego-os a Aarão e a seus filhos como doação dos filhos de Israel, para que façam o serviço dos filhos de Israel na tenda da reunião e para que realizem o rito pelo pecado em favor dos filhos de Israel. Deste modo, nenhuma desgraça atingirá os filhos de Israel quando se aproximarem do santuário»."
,"20":"Moisés, Aarão e toda a comunidade dos filhos de Israel fizeram com os levitas tudo o que Javé havia ordenado a Moisés."
,"21":"Os levitas purificaram-se dos seus pecados e lavaram as suas roupas. Aarão ofereceu-os a Javé com o gesto de apresentação, e para os purificar realizou com eles o rito pelo pecado."
,"22":"Os levitas foram, então, admitidos para cumprir a sua função na tenda da reunião, na presença de Aarão e seus filhos. Deste modo se cumpriu tudo o que Javé havia ordenado a Moisés a respeito dos levitas."
,"23":"Javé disse a Moisés:"
,"24":"«A partir dos vinte e cinco anos os levitas farão os trabalhos da tenda da reunião."
,"25":"Aos cinquenta anos aposentar-se-ão e não prestarão mais serviço."
,"26":"Poderão ajudar os seus irmãos montando guarda na tenda da reunião, mas não trabalharão. Tais são as disposições quanto às funções dos levitas»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Dois anos depois de os filhos de Israel terem saído do Egipto, no primeiro mês, Javé disse a Moisés no deserto do Sinai:"
,"2":"«Os filhos de Israel celebrarão a Páscoa na data marcada."
,"3":"No dia catorze do primeiro mês, ao entardecer, celebrarão a festa conforme todos os seus estatutos e normas»."
,"4":"Moisés mandou os filhos de Israel celebrar a Páscoa."
,"5":"E eles celebraram-na no dia catorze do primeiro mês, ao entardecer, no deserto do Sinai. Os filhos de Israel fizeram tudo de acordo com o que Javé tinha ordenado a Moisés."
,"6":"Alguns homens estavam impuros porque haviam tocado num cadáver, e nesse dia não puderam celebrar a Páscoa. Apresentaram-se no mesmo dia a Moisés e Aarão,"
,"7":"e disseram-lhes: «Estamos impuros porque tocámos num cadáver. Porque não nos deixas trazer a nossa oferta a Javé no tempo determinado, juntamente com os outros filhos de Israel?»"
,"8":"Moisés respondeu: «Esperai até que eu saiba o que Javé vai ordenar a vosso respeito»."
,"9":"Javé disse a Moisés:"
,"10":"«Diz aos filhos de Israel: Se alguém de vós ou dos vossos descendentes estiver impuro por ter tocado num cadáver, ou estiver numa longa viagem, deverá celebrar a Páscoa de Javé"
,"11":"no dia catorze do segundo mês, ao entardecer. Comereis a Páscoa com pães sem fermento e com ervas amargas;"
,"12":"não deverá sobrar nada para o dia seguinte, nem se quebrará osso nenhum do cordeiro. Devereis celebrar a Páscoa conforme o ritual."
,"13":"Quem estiver puro ou não estiver em viagem, e deixar de celebrar a Páscoa, será excluído do seu povo: porque não trouxe a oferta para Javé no devido tempo, deverá suportar a própria culpa."
,"14":"O imigrante que mora entre vós deverá celebrar a Páscoa de Javé conforme o ritual e os costumes da festa. O mesmo ritual vale tanto para o imigrante como para o nativo do país»."
,"15":"No dia em que foi montado o santuário, a nuvem cobria o santuário, isto é, a tenda da reunião, e desde o entardecer até ao amanhecer, ela ficava sobre o santuário com aspecto de fogo."
,"16":"Acontecia sempre o mesmo: de noite, a nuvem cobria o santuário, tomando aspecto de fogo até ao amanhecer."
,"17":"Quando a nuvem se elevava sobre a tenda, os filhos de Israel punham-se em marcha; quando ela parava, eles acampavam aí."
,"18":"Eles punham-se em marcha ou acampavam conforme a ordem de Javé. Permaneciam acampados durante todo o tempo em que a nuvem repousava sobre o santuário."
,"19":"Se a nuvem permanecia muitos dias sobre o santuário, os filhos de Israel observavam a ordem de Javé e não partiam."
,"20":"Às vezes, a nuvem ficava poucos dias sobre o santuário; então, permaneciam acampados ou partiam, de acordo com a ordem de Javé."
,"21":"Às vezes, a nuvem ficava desde o entardecer até ao amanhecer e, quando ela se levantava, ao amanhecer, eles punham-se em marcha. Outras vezes, ficava um dia e uma noite e, quando ela se levantava, eles partiam."
,"22":"Outras vezes ainda, a nuvem permanecia dois dias, um mês ou até um ano. Os filhos de Israel ficavam acampados e não partiam; quando a nuvem se levantava, então partiam."
,"23":"Eles acampavam ou partiam de acordo com a ordem de Javé. Respeitavam a ordem de Javé, comunicada por Moisés."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Javé disse a Moisés:"
,"2":"«Faz duas trombetas de prata lavrada, para convocar a comunidade e dar o toque de partida aos acampamentos."
,"3":"Ao toque das duas trombetas, toda a comunidade se reunirá contigo à entrada da tenda da reunião."
,"4":"Quando for tocada uma só trombeta, os chefes dos clãs reunir-se-ão contigo."
,"5":"Ao primeiro toque agudo, os que estiverem acampados a Leste pôr-se-ão em movimento."
,"6":"Ao segundo toque, partirão os que estiverem acampados no Sul: será dado um toque para que se ponham em marcha."
,"7":"Para convocar a assembleia dar-se-á um toque, mas não agudo."
,"8":"Os sacerdotes, filhos de Aarão, ficarão encarregados de tocar as trombetas. Esta é uma lei perpétua para vós e vossos descendentes."
,"9":"Quando estiverdes no vosso país e tiverdes que sair para lutar contra o inimigo, que vos esteja oprimindo, tocareis a trombeta para o combate. Então Javé, vosso Deus, lembrar-Se-á de vós e salvar-vos-á dos vossos inimigos."
,"10":"Também nos dias de festa, solenidades ou começo de mês, tocareis as trombetas para anunciar os holocaustos e sacrifícios de comunhão. Então o vosso Deus lembrar-Se-á de vós. Eu sou Javé, vosso Deus»."
,"11":"No dia vinte do segundo mês do segundo ano, a nuvem levantou-se sobre o santuário da aliança."
,"12":"Então os filhos de Israel partiram do deserto do Sinai, conforme a sua ordem de marcha. E a nuvem parou no deserto de Farã."
,"13":"São estes os que partiram em primeiro lugar, conforme a ordem de Javé, transmitida por Moisés."
,"14":"Em primeiro lugar partiu a bandeira do acampamento dos filhos de Judá, por esquadrões, sob as ordens de Naasson, filho de Aminadab."
,"15":"Judá estava acompanhado pelo esquadrão dos filhos de Issacar, chefiado por Natanael, filho de Suar,"
,"16":"e pelo esquadrão dos filhos de Zabulon, chefiado por Eliab, filho de Helon."
,"17":"Em seguida, o santuário foi desmontado, e partiram os filhos de Gérson e os filhos de Merari, encarregados de transportar o santuário."
,"18":"A seguir partiu a bandeira do acampamento dos filhos de Rúben, por esquadrões, sob as ordens de Elisur, filho de Sedeur."
,"19":"Rúben estava acompanhado pelo esquadrão dos filhos de Simeão, chefiado por Salamiel, filho de Surisadai,"
,"20":"e pelo esquadrão dos filhos de Gad, chefiado por Eliasaf, filho de Reuel."
,"21":"Partiram, então, os filhos de Caat, encarregados de transportar o santuário, de modo que o santuário já estaria montado quando eles chegassem."
,"22":"Partiu, depois, a bandeira do acampamento dos filhos de Efraim, por esquadrões, sob as ordens de Elisama, filho de Amiud."
,"23":"Efraim estava acompanhado pelo esquadrão dos filhos de Manassés, chefiado por Gamaliel, filho de Fadassur,"
,"24":"e pelo esquadrão dos filhos de Benjamim, chefiados por Abidã, filho de Gedeão."
,"25":"Por último, fechando a retaguarda, partiu a bandeira do acampamento dos filhos de Dã, por esquadrões, sob as ordens de Aiezer, filho de Amisadai."
,"26":"Dã estava acompanhado pelo esquadrão dos filhos de Aser, chefiado por Fegiel, filho de Ocrã,"
,"27":"e pelo esquadrão dos filhos de Neftali, chefiado por Aíra, filho de Enã."
,"28":"Foi esta a ordem de partida, por esquadrões, dos filhos de Israel, quando se puseram em marcha."
,"29":"Moisés disse ao seu sogro Hobab, filho de Raguel, o madianita: «Vamos partir para o lugar que Javé prometeu dar-nos. Vem connosco e tratar-te-emos bem, porque Javé prometeu coisas boas a Israel»."
,"30":"Hobab respondeu: «Não vou. Prefiro voltar para a minha terra natal»."
,"31":"Moisés insistiu: «Não nos abandones, porque conheces este deserto e os lugares onde podemos acampar. Podes ser o nosso guia."
,"32":"Se vieres connosco, repartiremos contigo as coisas boas que Javé nos der e tratar-te-emos bem»."
,"33":"Partiram, então, da montanha de Javé e andaram durante três dias. Durante todo o tempo, a arca da aliança de Javé ia à frente, providenciando um local onde pudessem descansar."
,"34":"Durante o dia a nuvem de Javé ficava sobre eles, quando partiam do acampamento."
,"35":"Quando a arca partia, Moisés dizia: «Levanta-Te, Javé! Que os teus inimigos se dispersem e os que Te odeiam fujam da tua presença»."
,"36":"Quando a arca estava em repouso, Moisés dizia: «Descansa, Javé, entre as multidões de Israel»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"O povo começou a queixar-se das suas desgraças a Javé. Ao ouvir a queixa, inflamou-se a sua ira e o fogo de Javé começou a devorar uma extremidade do acampamento."
,"2":"O povo gritou a Moisés. Este intercedeu junto de Javé em favor deles, e o incêndio apagou-se."
,"3":"Este local chamou-se Lugar do Incêndio, porque ali o fogo de Javé ardeu contra eles."
,"4":"A multidão que estava com eles ficou faminta. Então os filhos de Israel começaram a reclamar juntamente com eles, dizendo: «Quem nos dará carne para comer?"
,"5":"Temos saudade dos peixes que comíamos de graça no Egipto, dos pepinos, melões, verduras, cebolas e alhos!"
,"6":"Agora, perdemos até o apetite, porque não vemos outra coisa além deste maná!»"
,"7":"O maná era parecido com a semente de coentro e tinha aparência de resina."
,"8":"O povo dispersava-se para o recolher e esmagava-o no moinho ou moía-o no pilão; depois cozinhava-o numa panela e fazia bolos, com gosto de bolo amassado com azeite."
,"9":"À noite, quando caía orvalho sobre o acampamento, caía também o maná."
,"10":"Moisés ouviu o povo reclamar, cada família à entrada da própria tenda, provocando a ira de Javé. Moisés ficou desgostoso,"
,"11":"e disse a Javé: «Porque tratas tão mal o teu servo? Porque gozo tão pouco do teu favor, a ponto de me impores o peso de todo este povo?"
,"12":"Porventura, fui eu que concebi ou dei à luz este povo, para que me digas: 'Toma este povo nos braços, tal como a ama leva a criança ao colo, e leva-o para a terra que Eu jurei dar aos seus pais'?"
,"13":"Onde encontrarei carne para dar a todo este povo? Eles vêm ter comigo reclamando: 'Dá-nos carne para comer'."
,"14":"Eu sozinho não consigo levar este povo, pois supera as minhas forças!"
,"15":"Se é assim que me pretendes tratar, prefiro a morte! Concede-me este favor, e não terei que passar por esta desgraça!»"
,"16":"Javé respondeu a Moisés: «Reúne setenta anciãos de Israel, que conheças serem anciãos e magistrados do povo. Leva-os à tenda da reunião, para que lá se apresentem contigo."
,"17":"Eu descerei e falarei ali contigo. Separarei uma parte do espírito que possuis e passá-lo-ei para eles, a fim de que repartam contigo o peso do povo, e não tenhas mais que o levar sozinho."
,"18":"Então dirás ao povo: Santificai-vos para amanhã, e comereis carne, pois reclamastes a Javé, dizendo: 'Quem nos dará carne para comer? No Egipto estávamos melhor!' Pois bem! Javé dar-vos-á carne para comer,"
,"19":"e não comereis apenas durante um dia ou dois, cinco, dez ou vinte."
,"20":"Pelo contrário, comereis durante o mês inteiro, até ficardes enjoados e vomitardes, porque rejeitastes Javé que está no meio de vós, e reclamastes, dizendo: 'Porque saímos nós do Egipto?'»"
,"21":"Moisés disse: «O povo que está comigo compõe-se de seiscentas mil pessoas adultas, e Tu dizes que lhes darás carne para comerem durante o mês inteiro!"
,"22":"Ainda que matássemos as vacas e ovelhas, isso não seria suficiente e, ainda que reuníssemos todos os peixes do mar, nem assim lhes bastariam»."
,"23":"Javé respondeu a Moisés: «Será que o meu poder diminuiu? Verás se a minha palavra vai cumprir-se ou não»."
,"24":"Moisés saiu e comunicou as palavras de Javé ao povo. Depois reuniu setenta anciãos do povo e colocou-os ao redor da tenda da reunião."
,"25":"Então Javé desceu na nuvem, falou com Moisés, retirou uma parte do espírito que Moisés possuía, e colocou-a nos setenta anciãos. Quando o espírito pousou sobre eles, puseram-se a profetizar; mas, depois, nunca mais o fizeram."
,"26":"Dois homens do grupo tinham ficado no acampamento: um chamava-se Eldad e o outro Medad. Embora estivessem na lista, não tinham ido à tenda. Mas o espírito pousou sobre eles e começaram a profetizar no acampamento."
,"27":"Um jovem correu a informar Moisés: «Eldad e Medad estão a profetizar no acampamento!»"
,"28":"Josué, filho de Nun, que desde a juventude era ajudante de Moisés, interveio: «Moisés, meu Senhor, proíbe-os de fazer isso»."
,"29":"Moisés, porém, respondeu: «Estás com ciúme por mim? Oxalá todo o povo de Javé fosse profeta e recebesse o espírito de Javé!»"
,"30":"E Moisés voltou ao acampamento, juntamente com os anciãos de Israel."
,"31":"Javé levantou do mar um vento que arrastou bandos de codornizes, fazendo-as cair no acampamento. Então, no raio de um dia de viagem ao redor do acampamento, o chão ficou coberto delas, formando uma camada de quase um metro de altura."
,"32":"O povo passou o dia todo, a noite e o dia seguinte, a recolher codornizes; quem recolheu menos, chegou a juntar dez cargas de burro. E estenderam-nas ao redor do acampamento."
,"33":"Estavam ainda com a carne na boca, sem ter mastigado, quando a ira de Javé se inflamou contra o povo, ferindo-o com grande mortandade."
,"34":"O lugar ficou a chamar-se Cemitério da Avidez, porque aí o povo enterrou as vítimas da sua avidez."
,"35":"Daí partiram para Currais, onde acamparam."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Maria e Aarão falaram contra Moisés, por causa da mulher cuchita que ele havia tomado como esposa."
,"2":"Eles disseram a Moisés: «Será que Javé só falou a Moisés? Não nos falou também a nós?» E Javé ouviu-os."
,"3":"Moisés era o homem mais humilde entre todos os homens da terra."
,"4":"De repente, Javé disse a Moisés, a Aarão e a Maria: «Ide os três para a tenda da reunião». Os três foram"
,"5":"e Javé desceu numa coluna de nuvem, colocou-Se à entrada da tenda e chamou Aarão e Maria. Eles aproximaram-se,"
,"6":"e Javé disse: «Ouvi o que vos vou dizer: Quando entre vós há um profeta, Eu apresento-Me a ele em visão e falo com ele em sonhos."
,"7":"Não acontece assim com o meu servo Moisés, que é homem de confiança em toda a minha casa:"
,"8":"com ele Eu falo face a face, às claras e sem enigmas; e ele vê a figura de Javé. Porque vos atrevestes a falar contra o meu servo Moisés?»"
,"9":"A ira de Javé inflamou-se contra eles, e Javé retirou-Se."
,"10":"A nuvem afastou-se da tenda, e a pele de Maria ficou toda esbranquiçada, como a neve. Ao voltar-se para ela, Aarão viu-a com a pele esbranquiçada."
,"11":"Aarão disse a Moisés: «Por favor, meu senhor! Não peças contas da culpa pelos pecados que tivemos a loucura de cometer e da qual somos culpados."
,"12":"Não deixes que Maria permaneça como um aborto que já sai do ventre da mãe com a carne meio carcomida»."
,"13":"Moisés suplicou a Javé: «Por favor, concede-lhe a cura!»"
,"14":"Então Javé disse a Moisés: «Se o pai dela lhe tivesse cuspido na cara, ela ficaria difamada durante sete dias. Pois então, que ela fique isolada durante sete dias, fora do acampamento, e só depois seja admitida novamente»."
,"15":"Isolaram Maria durante sete dias fora do acampamento, e o povo não partiu enquanto ela não voltou."
,"16":"Depois partiram de Currais e foram acampar no deserto de Farã."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Javé disse a Moisés:"
,"2":"«Manda gente para explorar o país de Canaã, que vou dar aos filhos de Israel. Manda um de cada tribo, e que todos sejam chefes."
,"3":"Seguindo a ordem de Javé, Moisés enviou-os do deserto de Farã. Todos eram chefes dos filhos de Israel,"
,"4":"e os seus nomes são os seguintes: da tribo de Rúben, Samua, filho de Zacur;"
,"5":"da tribo de Simeão, Safat, filho de Huri;"
,"6":"da tribo de Judá, Caleb, filho de Jefoné;"
,"7":"da tribo de Issacar, Igal, filho de José;"
,"8":"da tribo de Efraim, Oseias, filho de Nun;"
,"9":"da tribo de Benjamim, Falti, filho de Rafu;"
,"10":"da tribo de Zabulon, Gediel, filho de Sodi;"
,"11":"da tribo de Manassés, filho de José, Gadi, filho de Susi;"
,"12":"da tribo de Dã, Amiel, filho de Gemali;"
,"13":"da tribo de Aser, Setur, filho de Miguel;"
,"14":"da tribo de Neftali, Naabi, filho de Vapsi;"
,"15":"da tribo de Gad, Guel, filho de Maqui."
,"16":"São estes os nomes dos homens que Moisés mandou a explorar o país. Quanto a Oseias, filho de Nun, Moisés deu-lhe o nome de Josué."
,"17":"Moisés mandou-lhes explorar o país de Canaã, e disse-lhes: «Subi pelo deserto do Negueb até chegar à montanha."
,"18":"Observai como é o país e os seus habitantes, se são fortes ou fracos, poucos ou numerosos."
,"19":"Vede se a terra é boa ou má; como é que são as cidades onde moram, se são abertas ou fortificadas."
,"20":"Vede se a terra é fértil ou estéril, se tem árvores ou não. Sede corajosos e trazei frutos da terra». Era o tempo em que as uvas começavam a amadurecer. "
,"21":"Eles subiram e exploraram o país desde o deserto de Sin até Roob, junto à entrada de Emat."
,"22":"Subiram pelo deserto e chegaram a Hebron, onde viviam Aimã, Sesai e Tolmai, filhos de Enac. Hebron tinha sido fundada sete anos antes de Tânis do Egipto."
,"23":"Chegando ao Vale do Cacho, cortaram um ramo de videira com um cacho de uvas, e penduraram-no numa vara transportada por dois homens; colheram também romãs e figos."
,"24":"Esse lugar ficou a chamar-se Vale do Cacho, por causa do cacho de uvas que os filhos de Israel ali cortaram."
,"25":"Quarenta dias depois, voltaram os exploradores"
,"26":"e apresentaram-se diante de Moisés, de Aarão e de toda a comunidade de Israel, no deserto de Farã, em Cades. Diante deles e da comunidade, fizeram o seu relatório e mostraram os frutos da terra."
,"27":"O relatório deles foi o seguinte: «Entrámos na terra aonde nos enviaste. É uma terra onde corre leite e mel, e aqui podeis ver os frutos dela."
,"28":"Mas o povo que mora no país é poderoso, e as cidades são grandes e fortificadas. Também lá vimos os filhos de Enac."
,"29":"Os amalecitas ocupam a região do Negueb; os heteus, amorreus e jebuseus vivem na montanha; os cananeus moram junto do mar e nas margens do Jordão»."
,"30":"Então Caleb mandou calar o povo reunido diante de Moisés, e disse: «Temos que subir e tomar posse dessa terra; nós podemos fazer isso»."
,"31":"Mas os homens que haviam acompanhado Caleb replicaram: «Não podemos atacar esse povo, porque é mais forte do que nós»."
,"32":"E, diante dos filhos de Israel, começaram a pôr defeitos na terra que haviam explorado: «A terra que fomos explorar é uma terra que devora os seus habitantes; o povo que vimos nela são homens de grande estatura."
,"33":"Lá também vimos gigantes, os filhos de Enac, que são mesmo gigantes. Tanto para nós próprios, como para eles, nós parecíamos gafanhotos»."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Então toda a comunidade de Israel começou a gritar e a berrar, e o povo queixou-se a noite inteira."
,"2":"Os filhos de Israel murmuravam contra Moisés e Aarão, e toda a comunidade dizia: «Seria melhor se tivéssemos morrido na terra do Egipto! É melhor morrer neste deserto!"
,"3":"Porque é que Javé nos trouxe para esta terra? Para morrermos à espada e para que as nossas mulheres e crianças se tornem escravas? Não seria melhor voltar para o Egipto?»"
,"4":"E diziam uns aos outros: «Vamos escolher um chefe e voltar para o Egipto»."
,"5":"Moisés e Aarão prostraram-se por terra diante de toda a comunidade reunida dos filhos de Israel."
,"6":"Dois daqueles que foram explorar a terra, Josué, filho de Nun, e Caleb, filho de Jefoné, rasgaram as roupas."
,"7":"Eles disseram a toda a comunidade dos filhos de Israel: «A terra que fomos explorar é boa, é uma terra excelente!"
,"8":"Se Javé estiver do nosso lado, Ele far-nos-á entrar nessa terra e dar-no-la-á: é uma terra onde corre leite e mel."
,"9":"Entretanto, não vos revolteis contra Javé, não tenhais medo do povo dessa terra. Nós devorá-los-emos como um pedaço de pão. Eles não estão mais protegidos do que nós, porque Javé está connosco. Não tenhais medo deles!»"
,"10":"Toda a comunidade, porém, falava em apedrejá-los. Nesse momento, a glória de Javé apareceu na tenda da reunião, diante de todos os filhos de Israel."
,"11":"Javé disse a Moisés: «Até quando este povo Me vai desprezar? Até quando se recusará a acreditar em Mim, apesar de todos os sinais que tenho feito entre vós?"
,"12":"Vou feri-lo com peste e deserdá-lo. Tirarei de ti um povo grande e mais numeroso do que eles»."
,"13":"Moisés respondeu a Javé: «Os egípcios sabem que foste Tu que tiraste este povo do meio deles com grande poder,"
,"14":"e dirão isso aos habitantes desta terra. Eles souberam, Javé, que estás no meio deste povo, que Te mostras a ele face a face, que a tua nuvem está sobre ele, e caminhas à sua frente de dia numa coluna de nuvem, e de noite numa coluna de fogo."
,"15":"Se agora fazes perecer este povo, como se fosse um só homem, as nações ouvirão a notícia e dirão:"
,"16":"'Javé não conseguiu levar esse povo à terra que lhes havia prometido; por isso matou-o no deserto'."
,"17":"Portanto, mostra a tua grande força, conforme prometeste."
,"18":"Javé, paciente e misericordioso, que perdoas a culpa e a transgressão, mas não nos deixas sem castigo; que castigas a culpa dos pais nos filhos, netos e bisnetos:"
,"19":"perdoa a culpa deste povo, conforme a tua grande misericórdia, já que o trouxeste do Egipto até aqui»."
,"20":"Javé disse: «Eu perdoo ao povo, conforme Me pedes."
,"21":"Mas, por minha vida e pela glória de Javé que enche a terra,"
,"22":"todos os homens, que viram a minha glória e os sinais que fiz no Egipto e no deserto, já Me puseram à prova dez vezes, e não Me obedeceram."
,"23":"Eles não verão a terra que jurei dar a seus pais. Nenhum daqueles que Me desprezaram verá essa terra."
,"24":"O meu servo Caleb, porém, animado de outro espírito, seguiu-Me fielmente. Por isso fá-lo-ei entrar na terra que ele explorou, e a descendência dele possuirá essa terra."
,"25":"Visto que os amalecitas e cananeus habitam no vale, amanhã devereis partir para o deserto, seguindo a rota do Mar Vermelho»."
,"26":"E Javé continuou a dizer a Moisés e Aarão:"
,"27":"«Até quando esta comunidade perversa continuará a murmurar contra Mim? Ouvi os filhos de Israel a queixarem-se contra Mim."
,"28":"Diz-lhes: Por minha vida - oráculo de Javé - Eu vos tratarei conforme o que ouvi de vós."
,"29":"Os vossos cadáveres cairão neste deserto. E todos os que foram recenseados, de vinte anos para cima, e que murmuraram contra Mim,"
,"30":"não entrarão na terra onde jurei estabelecer-vos. A única excepção será Josué, filho de Nun, e Caleb, filho de Jefoné."
,"31":"Quanto aos vossos filhos, de quem dizíeis que seriam levados como escravos, Eu fá-los-ei entrar para conhecerem a terra que vós desprezastes."
,"32":"Mas os vossos cadáveres cairão neste deserto,"
,"33":"e por este deserto os vossos filhos caminharão errantes durante quarenta anos, carregando a vossa infidelidade, até que os vossos cadáveres se desfaçam no deserto."
,"34":"Vós explorastes a terra durante quarenta dias. A cada dia corresponderá um ano. Pois bem! Suportareis o peso das vossas faltas durante quarenta anos, para que saibais o que significa abandonar-Me."
,"35":"Eu sou Javé, e juro que vou tratar deste modo a comunidade que se revoltou contra Mim: serão consumidos neste deserto e nele morrerão»."
,"36":"Os homens que Moisés enviou a explorar a terra e que colocaram a comunidade contra ele, fazendo pouco da terra,"
,"37":"esses homens que fizeram pouco da terra, morreram fulminados diante de Javé."
,"38":"De todos os que haviam explorado a terra, somente Josué, filho de Nun, e Caleb, filho de Jefoné, permaneceram vivos."
,"39":"Moisés comunicou estas palavras a todos os filhos de Israel. E o povo ficou muito perturbado."
,"40":"No dia seguinte, levantaram-se de madrugada e subiram até ao alto da montanha, dizendo: «Vamos subir ao lugar a respeito do qual Javé nos falou. Nós pecámos»."
,"41":"Moisés, porém, disse: «Porque transgredis a ordem de Javé? Isso não vai dar certo."
,"42":"Não subais, porque Javé não está convosco, e o inimigo derrotar-vos-á."
,"43":"De facto, os amalecitas e cananeus enfrentar-vos-ão, e caireis a golpes de espada. Afastastes-vos de Javé, e por isso Javé não está convosco»."
,"44":"Apesar disso, eles teimaram em subir ao topo do monte, enquanto Moisés e a arca da aliança de Javé permaneceram no acampamento."
,"45":"Os amalecitas e cananeus, que habitavam na montanha, desceram e derrotaram-nos, destroçando-os até Horma."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz aos filhos de Israel: Quando entrardes na terra que vou dar-vos, para nela habitardes,"
,"3":"ao oferecerdes a Javé uma oblação, de gado maior ou menor, uma oblação de perfume agradável a Javé, quer seja holocausto, quer seja sacrifício de comunhão voluntário, ou para cumprir um voto, ou por ocasião de uma festa,"
,"4":"aquele que fizer a sua oferta a Javé, apresentará o seguinte: uma oferta de quatro litros e meio de flor de farinha, amassada com dois litros de azeite."
,"5":"Juntamente com o holocausto ou com o sacrifício de comunhão, fará uma libação de dois litros de vinho por cada cordeiro."
,"6":"Tratando-se de um carneiro, farás uma oblação de nove litros de flor de farinha, amassada com dois litros e meio de azeite,"
,"7":"e uma libação de dois litros e meio de vinho, como perfume agradável a Javé."
,"8":"Se o holocausto ou o sacrifício de comunhão, para fazer um voto ou acção de graças a Javé, for de um bezerro,"
,"9":"deverás acrescentar uma oferta de treze litros e meio de flor de farinha, amassada com quatro litros de azeite,"
,"10":"e uma libação de quatro litros de vinho, oblação de perfume agradável a Javé."
,"11":"Isto é o que se deve oferecer com um bezerro, um carneiro, uma ovelha ou um cabrito."
,"12":"Aplicareis sempre esta proporção."
,"13":"Assim deverá fazer o nativo do país, quando apresentar uma oferta queimada, de perfume agradável a Javé."
,"14":"E no futuro, se algum imigrante, que residir convosco ou com os seus descendentes, quiser apresentar uma oblação de perfume agradável a Javé, fará o mesmo que vós."
,"15":"Haverá um só rito para toda a comunidade, tanto para vós como para o imigrante que mora no meio de vós. Será, diante de Javé, um rito perene a ser conservado de geração em geração, valendo tanto para vós como para o imigrante."
,"16":"Haverá a mesma lei e o mesmo rito para vós e para o imigrante que morar entre vós»."
,"17":"Javé disse a Moisés:"
,"18":"«Diz aos filhos de Israel: Quando tiverdes entrado na terra, para onde Eu vos conduzo,"
,"19":"e comerdes o pão nessa terra, devereis separar uma oferta para apresentar a Javé:"
,"20":"separareis um pão feito com a primeira farinha, como fazeis com o tributo da eira."
,"21":"Devereis dar a Javé um tributo da massa do pão: isto vale para todas as vossas gerações."
,"22":"Se errardes sem querer, deixando de observar algum dos mandamentos que Javé deu a Moisés,"
,"23":"de tudo o que Javé vos ordenou por meio de Moisés, desde o dia em que Javé ordenou estas coisas e daí por diante,"
,"24":"devereis fazer o seguinte: se o erro foi cometido pela comunidade sem querer, sem que a comunidade tenha percebido, a comunidade inteira oferecerá um bezerro como holocausto de perfume agradável a Javé, juntamente com a oblação e a libação, conforme o ritual. E oferecerá também um bode, como sacrifício pelo pecado."
,"25":"O sacerdote fará o sacrifício pelo pecado por toda a comunidade dos filhos de Israel, e o pecado ser-lhes-á perdoado, pois foi feito sem querer. Eles levarão a oferta para ser queimada diante de Javé, e apresentarão diante de Javé o sacrifício pelo pecado, a fim de reparar o erro cometido sem querer."
,"26":"Este será perdoado a toda a comunidade dos filhos de Israel, e também ao imigrante que mora entre eles, porque todo o povo pecou sem querer."
,"27":"Se apenas uma pessoa pecar sem querer, oferecerá um cabrito de um ano, como sacrifício pelo pecado."
,"28":"O sacerdote fará pela pessoa, diante de Javé, um sacrifício pelo pecado; e a pessoa ficará perdoada."
,"29":"A mesma norma vale, tanto para um filho de Israel como para um imigrante que mora no meio do povo, quando pecarem sem querer."
,"30":"Todavia, quem procede com plena consciência, quer seja nativo quer seja imigrante, comete ultraje contra Javé. Esse indivíduo deve ser excluído do meio do povo,"
,"31":"porque desprezou a palavra de Javé e violou o seu mandamento. Essa pessoa deve ser excluída, pois a culpa está nela mesma»."
,"32":"Enquanto os filhos de Israel estavam no deserto, surpreenderam um homem que recolhia lenha em dia de sábado."
,"33":"Levaram-no à presença de Moisés, de Aarão e de toda a comunidade,"
,"34":"mantendo-o preso enquanto se decidia o que deveria ser feito dele."
,"35":"Javé disse a Moisés: «Esse homem é réu de morte. Toda a comunidade deverá apedrejá-lo fora do acampamento»."
,"36":"A comunidade levou-o para fora do acampamento e apedrejou-o. E o homem morreu, conforme Javé tinha ordenado a Moisés."
,"37":"Javé disse a Moisés:"
,"38":"«Diz aos filhos de Israel: Por todas as gerações, fazei borlas e fixai-as com linha roxa na franja das vossas roupas."
,"39":"Vendo essas borlas, lembrar-vos-eis dos mandamentos de Javé. Elas ajudar-vos-ão a cumprir os mandamentos, sem ceder aos caprichos do coração e dos olhos, caprichos que vos poderiam levar à infidelidade."
,"40":"Deste modo lembrar-vos-eis de todos os meus mandamentos e pô-los-eis em prática, vivendo consagrados ao vosso Deus."
,"41":"Eu sou Javé, vosso Deus, que vos tirei da terra do Egipto para ser vosso Deus. Eu sou Javé, vosso Deus»."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Coré, filho de Isaar, filho de Caat, filho de Levi, juntamente com Datã e Abiram, filhos de Eliab, e On, filho de Felet, sendo Eliab e Felet filhos de Rúben,"
,"2":"revoltaram-se contra Moisés juntamente com duzentos e cinquenta homens, chefes da comunidade, membros do conselho e pessoas de fama."
,"3":"Eles reuniram-se contra Moisés e Aarão, dizendo: «Basta! Todos os membros da comunidade são consagrados, e Javé está no meio deles. Porque é que vós os dois vos colocais acima da comunidade de Javé?»"
,"4":"Quando ouviu isto, Moisés prostrou-se com o rosto no chão."
,"5":"Depois disse a Coré e aos outros que estavam com ele: «Amanhã cedo Javé mostrará quem é d'Ele e quem é o consagrado, e Ele mandá-lo-á aproximar-se. Fará aproximar de Si aquele que Ele tiver escolhido."
,"6":"Fazei o seguinte: Pegai nos incensórios, vós e todos os que vos seguem."
,"7":"Amanhã acendereis neles o fogo e colocareis incenso diante de Javé. Aquele que Javé escolher, esse será o consagrado. E, por agora, chega, filhos de Levi!»"
,"8":"Depois Moisés disse a Coré: «Agora, escutai, filhos de Levi!"
,"9":"O que é que quereis? O Deus de Israel separou-vos da comunidade de Israel, levando-vos para perto d'Ele, para servirdes no santuário de Javé e estardes à disposição para servir a comunidade."
,"10":"Javé fez com que tu e teus irmãos levitas vos aproximásseis d'Ele. Agora quereis também o sacerdócio?"
,"11":"Vós e os vossos seguidores revoltastes-vos contra Javé! Quem é Aarão, para protestardes contra ele?»"
,"12":"Então Moisés mandou chamar Datã e Abiram, filhos de Eliab. Estes responderam: «Não iremos."
,"13":"Acaso não basta teres-nos feito sair de uma terra onde corre leite e mel, para nos fazer morrer neste deserto? Ainda queres ser o nosso chefe?"
,"14":"Não nos levaste para uma terra onde corre leite e mel, nem nos deste como herança campos e vinhas! Pensas que somos cegos? Não iremos»."
,"15":"Então Moisés ficou furioso e disse a Javé: «Não aceites a oferta deles. Eu não lhes tirei nem sequer um burro, e não fiz mal a nenhum deles!»"
,"16":"Depois disse a Coré: «Amanhã, tu e os teus seguidores, e também Aarão devereis apresentar-vos a Javé."
,"17":"Cada um pegue no seu incensório, coloque nele o incenso e ofereça-o a Javé. Cada um dos duzentos e cinquenta pegue no próprio incensório, juntamente contigo e Aarão»."
,"18":"Cada um pegou no seu incensório, acendeu-o e colocou incenso nele. A seguir, ficaram à porta da tenda da reunião com Moisés e Aarão."
,"19":"Coré reuniu os seus seguidores à entrada da tenda da reunião. E a glória de Javé manifestou-se a toda a comunidade."
,"20":"Então Javé disse a Moisés e Aarão:"
,"21":"«Afastai-vos desse grupo, porque vou destruí-lo num instante»."
,"22":"Moisés e Aarão caíram com o rosto por terra e suplicaram: «Deus, Deus dos espíritos de todos os seres vivos! Foi só um que pecou, e Tu vais ficar irritado contra todos?»"
,"23":"Javé disse a Moisés:"
,"24":"«Diz às pessoas que se afastem das tendas de Coré, Datã e Abiram»."
,"25":"Moisés levantou-se e dirigiu-se aonde estavam Datã e Abiram. Os anciãos de Israel seguiram-no."
,"26":"Moisés disse à comunidade: «Afastai-vos das tendas destes homens ímpios e não toqueis em nada do que lhes pertence, para não vos comprometerdes com os pecados deles»."
,"27":"Eles afastaram-se das tendas de Coré, Datã e Abiram, enquanto Datã e Abiram saíam com as suas mulheres, filhos e crianças, para esperar à entrada da tenda."
,"28":"Então Moisés disse: «Agora ficareis a saber que foi Javé quem me enviou para agir assim, e que eu não fiz nada por mim mesmo:"
,"29":"se estes homens morrerem de morte natural, conforme o destino de todos os homens, é sinal de que Javé não me enviou."
,"30":"Mas se Javé fizer alguma coisa estranha, se a terra se abrir e os engolir com todos os seus, descendo eles vivos à mansão dos mortos, então ficareis a saber que estes homens desprezaram Javé»."
,"31":"Logo que Moisés acabou de falar, o chão rachou debaixo dos pés deles,"
,"32":"a terra abriu a boca e engoliu-os com as suas famílias, juntamente com os homens de Coré e todos os seus bens."
,"33":"Desceram vivos à mansão dos mortos, juntamente com todas as coisas que lhes pertenciam. A terra cobriu-os e eles desapareceram da comunidade."
,"34":"Quando eles gritaram, os filhos de Israel, que estavam ao redor, fugiram, pois pensavam que a terra os iria engolir também."
,"35":"Saiu um fogo da parte de Javé e devorou os duzentos e cinquenta homens que ofereciam o incenso."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Javé disse a Moisés:"
,"2":"«Diz a Eleazar, filho do sacerdote Aarão, para tirar os incensórios do meio do fogo e espalhar as brasas, porque são santas."
,"3":"Quanto aos incensórios desses homens, que pagaram o seu pecado com a própria vida, sejam transformados em chapas para revestir o altar, pois foram apresentados a Javé; por isso ficaram consagrados e vão servir de lição para os filhos de Israel»."
,"4":"O sacerdote Eleazar pegou nos incensórios de bronze trazidos pelos homens que o fogo havia destruído. Foram transformados em chapas para revestir o altar,"
,"5":"e assim lembrar aos filhos de Israel que nenhum estranho, que não seja da descendência de Aarão, deve apresentar-se para oferecer incenso a Javé, pois teria o mesmo destino de Coré e do seu grupo. Eleazar fez tudo conforme Javé lhe havia ordenado por meio de Moisés."
,"6":"No dia seguinte, toda a comunidade dos filhos de Israel protestou contra Moisés e Aarão, dizendo: «Estais a matar o povo de Javé»."
,"7":"E dado que a comunidade se estava a amotinar contra Moisés e Aarão, estes foram para a tenda da reunião. A nuvem cobriu a tenda e a glória de Javé manifestou-se."
,"8":"Moisés e Aarão entraram na tenda,"
,"9":"e Javé disse-lhes:"
,"10":"«Afastai-vos dessa comunidade, pois vou consumi-la num instante!» Os dois prostraram-se com o rosto por terra;"
,"11":"em seguida, Moisés disse a Aarão: «Pega no incensório, coloca nele brasas do altar, coloca incenso, e vai depressa fazer a expiação pela comunidade, porque a ira de Javé inflamou-se contra ela, e a praga já começou»."
,"12":"Aarão fez o que Moisés lhe ordenava, e correu para o meio da comunidade. Mas a praga já havia começado entre o povo. Então colocou o incenso, fez o rito de expiação pelo povo e,"
,"13":"ficando entre os mortos e os vivos, deteve a mortandade."
,"14":"Os que morreram por causa da praga foram catorze mil e setecentos, além dos que morreram por causa de Coré."
,"15":"Quando Aarão voltou para junto de Moisés, que estava na tenda da reunião, a mortandade já tinha acabado."
,"16":"Javé disse a Moisés:"
,"17":"«Diz aos filhos de Israel que tragam varas, uma por cada chefe de família, no total de doze, e cada um escreva nela o próprio nome."
,"18":"Na vara de Levi, deverás escrever o nome de Aarão, pois haverá uma vara para cada chefe de tribo."
,"19":"Coloca as varas na tenda da reunião, diante do documento da aliança que fiz com eles."
,"20":"A vara daquele que Eu escolher, florescerá. Deste modo acabarei com os protestos dos filhos de Israel contra vós»."
,"21":"Moisés pediu que os filhos de Israel lhe trouxessem doze varas, uma por cada chefe de tribo, e entre elas a vara de Aarão."
,"22":"Moisés colocou as varas diante de Javé, na tenda da aliança."
,"23":"No dia seguinte, Moisés entrou na tenda da aliança, e viu que havia florescido a vara de Aarão, representante da tribo de Levi: estava cheia de rebentos, tinha dado flores e produzido amêndoas."
,"24":"Moisés tirou as varas da presença de Javé e levou-as aos filhos de Israel. Eles verificaram o facto e cada um recolheu a sua vara."
,"25":"Javé disse a Moisés: «Coloca de novo a vara de Aarão diante do documento da aliança, para que seja conservada como advertência contra os rebeldes. Deste modo eles não murmurarão contra Mim, e não morrerão»."
,"26":"E Moisés fez exactamente conforme Javé tinha ordenado."
,"27":"Os filhos de Israel reclamaram a Moisés: «Nós vamos morrer, estamos todos perdidos."
,"28":"Quem se aproxima do santuário de Javé, morre. Será que todos nós vamos morrer?»"
}`)
	CurrentBook.AddChapter(18, `{
"1":"Javé disse a Aarão: «Tu com os teus filhos e a tua família sereis responsáveis pelas faltas cometidas contra o santuário. Tu e os teus filhos sereis responsáveis pelas faltas cometidas no exercício do sacerdócio."
,"2":"Reúne também contigo os teus irmãos da tribo de Levi, a tribo de teu pai. Pede-lhes que fiquem contigo para que te ajudem quando tu e os teus filhos estiverdes na tenda da aliança."
,"3":"Eles ficarão ao vosso serviço e de toda a tenda, mas não deverão aproximar-se dos objectos sagrados, nem do altar, para que não venham a morrer, nem eles nem vós."
,"4":"Serão teus ajudantes e responderão pela guarda da tenda da reunião e por todo o serviço da tenda, de modo que nenhum estranho se intrometa no meio de vós."
,"5":"Vós é que respondereis pela guarda do santuário e dos objectos sagrados, e assim nunca mais a Ira se inflamará contra os filhos de Israel."
,"6":"Eu mesmo escolhi os teus irmãos levitas, entre os filhos de Israel. Eles foram doados a Javé e entregues a vós como dom, para prestarem serviço na tenda da reunião."
,"7":"Tu e os teus filhos exercereis o sacerdócio naquilo que se refere ao altar e a tudo o que fica atrás do véu. Eu entrego-vos o exercício do sacerdócio como um dom. O estranho que se aproximar deverá ser morto»."
,"8":"Javé disse a Aarão: «Entrego-te o direito de usufruir dos tributos que Me foram doados; entrego-te a ti e aos teus filhos o que os filhos de Israel Me oferecem, como privilégio da unção sacerdotal. É um direito perpétuo."
,"9":"De tudo o que foi consagrado e das oblações que não são queimadas, pertence-te o seguinte: todas as ofertas, oblações, sacrifícios pelo pecado e sacrifícios de reparação, porque são coisas sagradas, que pertencerão a ti e aos teus filhos."
,"10":"Alimentar-vos-eis de coisas sagradas, e todos os do sexo masculino poderão comer delas. Tratá-las-ás como coisas sagradas."
,"11":"Além disso, dentre as ofertas dos filhos de Israel, pertencer-te-á a parte reservada de tudo aquilo que é erguido em gesto de apresentação. Eu dou-a a ti e a teus filhos e filhas, como direito perpétuo. Em tua casa, todos os que estiverem puros poderão comer dessas coisas."
,"12":"Entrego-te a melhor parte do azeite, do vinho novo e do trigo, oferecidos como primícias a Javé."
,"13":"Todos os primeiros produtos do teu país, que forem trazidos a Javé, pertencer-te-ão; e todos os que estiverem puros em tua casa poderão comer deles."
,"14":"Tudo aquilo que Israel dedica a Deus, pertencer-te-á."
,"15":"Todo o primogénito, de homem ou animal, que eles oferecerem a Javé, pertencer-te-á. Mas deixarás resgatar o primogénito do homem e também o primogénito do animal, quando for impuro."
,"16":"Deixá-los-ás resgatar quando tiverem um mês, cobrando cinquenta gramas de prata, conforme o peso-padrão do santuário, que corresponde a dez gramas."
,"17":"Os primogénitos da vaca, da ovelha e da cabra não poderão ser resgatados: são coisa consagrada. Derramarás o seu sangue sobre o altar e queimarás a gordura, como oferta de perfume agradável a Javé;"
,"18":"a carne deles pertencer-te-á, assim como o peito apresentado ritualmente, e também a coxa direita."
,"19":"Entrego a ti, aos teus filhos e filhas, todos os tributos sagrados dos filhos de Israel, como direito perpétuo. É uma aliança perpétua para ti e teus descendentes, uma aliança inviolável diante de Javé»."
,"20":"Javé disse a Aarão: «Não receberás nenhuma herança, nem parte na Terra. Para ti, Eu sou a tua parte e a tua herança no meio dos filhos de Israel."
,"21":"Aos filhos de Levi dou como herança todos os dízimos recolhidos em Israel, para pagar os serviços que Me prestam na tenda da reunião."
,"22":"Os filhos de Israel nunca mais se aproximarão da tenda da reunião, pois pecariam e morreriam."
,"23":"Os levitas desempenharão as tarefas da tenda da reunião e suportarão o peso da sua responsabilidade. É lei perpétua para os vossos descendentes, que não receberão herança no meio dos filhos de Israel."
,"24":"Por essa razão, dou aos levitas como herança os dízimos que os filhos de Israel reservam para Javé. Por isso é que Eu vos disse que não recebereis herança no meio dos filhos de Israel»."
,"25":"Javé disse a Moisés:"
,"26":"«Diz aos levitas: Quando receberdes dos filhos de Israel os dízimos que vos dou como herança, oferecei como tributo a Javé a décima parte dos dízimos."
,"27":"Isso será considerado como vosso tributo, como se fosse trigo tirado da eira ou vinho do tanque de pisar uvas."
,"28":"Vós também pagareis tributo a Javé por todos os dízimos que receberdes dos filhos de Israel. A parte que separastes para Javé, será entregue ao sacerdote Aarão."
,"29":"De todas as ofertas que recebestes, reservareis uma parte para Javé, e essa parte sagrada tirá-la-eis do melhor de todas as coisas."
,"30":"Diz-lhes também: Quando tiverdes separado o melhor, todos esses dons pertencerão aos levitas, como se fossem produto da eira e do tanque de pisar uvas."
,"31":"Vós podereis comer essas coisas em qualquer lugar com as vossas famílias, porque é o vosso salário pelo serviço na tenda da reunião."
,"32":"Se separardes a parte melhor, não estareis a cometer nenhum pecado, nem estareis a profanar as coisas consagradas pelos filhos de Israel, e por isso não morrereis»."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Javé disse a Moisés e a Aarão:"
,"2":"«Este é o estatuto legal que Javé ordena: Diz aos filhos de Israel que te tragam uma novilha vermelha, sem mancha e sem defeito, e que nunca tenha usado canga."
,"3":"Entregai-a ao sacerdote Eleazar, que a levará para fora do acampamento e a mandará imolar na presença dele."
,"4":"Eleazar molhará um dedo no sangue dela e salpicará sete vezes na direcção da tenda da reunião."
,"5":"Depois mandará queimar a novilha na sua presença: serão queimados a pele, a carne, o sangue e os intestinos."
,"6":"O sacerdote tomará, então, ramos de cedro, hissopo e púrpura escarlate, e lançará tudo isso ao fogo onde a novilha está a ser queimada."
,"7":"A seguir, o sacerdote lavará as suas roupas, tomará banho, e voltará para o acampamento. Ficará impuro até à tarde."
,"8":"Quem tiver queimado a novilha, também deverá lavar as suas roupas e tomar banho. E ficará impuro até à tarde."
,"9":"Um homem puro ficará encarregado de recolher as cinzas da novilha e de as colocar em lugar puro, fora do acampamento. A comunidade dos filhos de Israel conservará as cinzas para preparar a água purificadora: é um sacrifício pelo pecado."
,"10":"Quem tiver recolhido as cinzas da novilha deverá lavar as suas roupas e ficará impuro até à tarde. Esta é uma lei perpétua para os filhos de Israel e para os imigrantes que vivem no meio deles: "
,"11":"Quem tocar num cadáver humano, ficará impuro durante sete dias."
,"12":"Deverá ser purificado com a água da purificação no terceiro e no sétimo dia, e ficará puro. Se não fizer isto, não ficará puro."
,"13":"Quem tocar num cadáver, isto é, no corpo de uma pessoa morta, e não se purificar, profanará a morada de Javé, e será excluído de Israel. Uma vez que a água da purificação não foi derramada sobre ele, está impuro, e a impureza continua com ele."
,"14":"Lei para quando um homem morre dentro de uma tenda: Quem entrar na tenda e todo aquele que nela estiver, ficará impuro durante sete dias."
,"15":"Todo o recipiente que estiver aberto, sobre o qual não houver uma cobertura ou tampa, ficará impuro."
,"16":"Quem tocar, em campo aberto, o cadáver de um homem que tenha sido apunhalado, ou qualquer morto, ou ossos humanos, ou uma sepultura, ficará impuro durante sete dias."
,"17":"Para aquele que se tornou impuro, deve-se pegar nas cinzas da vítima queimada em sacrifício pelo pecado, e derramar água corrente sobre as cinzas, numa vasilha."
,"18":"Em seguida, um homem puro pegará num ramo de hissopo, molhá-lo-á na água e fará a aspersão sobre a tenda e sobre todos os utensílios e pessoas que ali estiverem, e também sobre o homem que tiver tocado num osso, num assassinado, num cadáver ou numa sepultura."
,"19":"O homem puro fará a aspersão sobre o impuro, no terceiro e no sétimo dia. No sétimo dia, ele ficará livre do seu pecado, lavará as roupas, tomará banho, e à tarde ficará puro."
,"20":"O homem impuro, que não se purificar, será excluído da comunidade, porque poderia contaminar o santuário de Javé. A água da purificação não foi derramada sobre ele; por isso, continua impuro."
,"21":"Isto é uma lei perpétua: quem tiver feito a aspersão com a água da purificação, deverá lavar as suas roupas; quem tocar na água da purificação ficará impuro até à tarde."
,"22":"Tudo aquilo em que o impuro tocar ficará impuro; a pessoa que tocar no impuro ficará impura até à tarde»."
}`)
	CurrentBook.AddChapter(20, `{
"1":"A comunidade inteira dos filhos de Israel chegou no primeiro mês ao deserto de Sin. E o povo acampou em Cades. Ali morreu Maria, e foi sepultada."
,"2":"Faltava água para a comunidade e as pessoas amotinaram-se contra Moisés e Aarão."
,"3":"O povo litigava com Moisés, dizendo: «Quem dera tivéssemos morrido quando os nossos irmãos morreram diante de Javé!"
,"4":"Porque trouxeste a comunidade de Javé a este deserto, para morrermos aqui juntamente com os nossos animais?"
,"5":"Porque nos fizeste sair do Egipto, trazendo-nos para este lugar deserto, onde não se pode semear, sem figueiras, vinhas e romãzeiras, e até sem água para beber?»"
,"6":"Moisés e Aarão afastaram-se da comunidade, foram para a entrada da tenda da reunião e prostraram-se diante dela, com o rosto por terra. Então a glória de Javé apareceu-lhes."
,"7":"E Javé disse a Moisés:"
,"8":"«Pega na vara e, juntamente com o teu irmão Aarão, reúne a comunidade. Em seguida, na presença deles, ordena que a rocha faça brotar água. Tirarás água da rocha para dar de beber à comunidade e aos animais»."
,"9":"Moisés pegou na vara que estava na presença de Javé, conforme Javé lhe havia ordenado."
,"10":"Moisés e a Aarão reuniram a comunidade diante da rocha. Então Moisés disse-lhes: «Ouvi, rebeldes! Acreditais que poderemos fazer brotar água desta rocha?»"
,"11":"Moisés levantou a mão e bateu na rocha duas vezes com a vara: a água jorrou em abundância, e a comunidade e os animais puderam beber."
,"12":"Então Javé disse a Moisés e Aarão: «Já que não acreditastes em Mim e não reconhecestes a minha santidade na presença dos filhos de Israel, não fareis entrar esta comunidade na Terra que lhes vou dar»."
,"13":"Esta é a fonte de Meriba, onde os filhos de Israel discutiram com Javé. E Ele manifestou-lhes a sua santidade."
,"14":"De Cades, Moisés mandou mensageiros ao rei de Edom, com esta mensagem: «Assim diz o teu irmão Israel: Sabes as dificuldades que temos passado."
,"15":"Os nossos antepassados desceram ao Egipto, onde morámos durante muito tempo. Os egípcios, porém, maltrataram-nos a nós e aos nossos antepassados."
,"16":"Então gritámos a Javé e Ele ouviu-nos e mandou um anjo para nos tirar do Egipto. Agora estamos em Cades, cidade que fica nos limites do teu território."
,"17":"Deixa-nos atravessar o teu país; não passaremos pelos campos, nem pelas vinhas, e não beberemos da água dos poços. Seguiremos pela estrada real, sem nos desviarmos nem para a direita nem para a esquerda, até atravessar o teu território»."
,"18":"Mas o rei de Edom respondeu: «Não passes pelo meu país; caso contrário, marcharei contra ti com a espada»."
,"19":"Os filhos de Israel insistiram: «Seguiremos pela estrada principal. Se nós ou os nossos animais bebermos da tua água, pagar-te-emos o justo preço. Deixa-nos atravessar a pé»."
,"20":"O rei de Edom respondeu: «Não atravessareis». E saiu ao encontro deles com muita gente, fortemente armada."
,"21":"Uma vez que Edom não quis deixar que os filhos de Israel atravessassem o seu território, tiveram que seguir noutra direcção."
,"22":"A comunidade dos filhos de Israel levantou acampamento em Cades e chegou ao monte Hor."
,"23":"Javé disse a Moisés e Aarão, perto do monte Hor, na fronteira da terra de Edom:"
,"24":"«Aarão vai reunir-se com os seus antepassados e não entrará na Terra que vou dar aos filhos de Israel, porque fostes rebeldes às minhas ordens na fonte de Meriba."
,"25":"Toma Aarão e seu filho Eleazar e manda-os subir ao monte Hor."
,"26":"Tira as vestes sacerdotais a Aarão e veste com elas o filho dele, Eleazar, pois Aarão reunir-se-á com os seus antepassados e aí morrerá»."
,"27":"Moisés fez conforme Javé havia ordenado, e subiram ao monte Hor, diante de toda a comunidade."
,"28":"Moisés tirou as vestes sacerdotais a Aarão, e com elas vestiu o filho dele, Eleazar. Aarão morreu ali, no alto do monte. Moisés e Eleazar desceram do monte,"
,"29":"e toda a comunidade viu que Aarão tinha morrido. E toda a casa de Israel chorou por Aarão durante trinta dias."
}`)
	CurrentBook.AddChapter(21, `{
"1":"O rei de Arad, o cananeu, que habitava o Negueb, soube que os filhos de Israel vinham pelo caminho de Atarim. Então atacou-os e capturou alguns como prisioneiros."
,"2":"Então Israel fez um voto a Javé: «Se entregares este povo em meu poder, eu consagrarei as suas cidades ao extermínio»."
,"3":"Javé atendeu a Israel e entregou-lhes os cananeus. Então os filhos de Israel consagraram-nos ao extermínio, juntamente com as suas cidades. E o lugar ficou a ser chamado Horma."
,"4":"Do monte Hor, eles tomaram o caminho para o Mar Vermelho, contornando o território de Edom. Mas o povo não suportou a viagem"
,"5":"e começou a murmurar contra Deus e contra Moisés, dizendo: «Porque nos tiraste do Egipto? Foi para morrermos neste deserto? Não temos nem pão nem água, e estamos enjoados deste pão de miséria»."
,"6":"Então Javé mandou contra o povo serpentes venenosas que os mordiam, e muita gente de Israel morreu."
,"7":"O povo disse a Moisés: «Pecámos, falando contra Javé e contra ti. Suplica a Javé que afaste de nós estas serpentes». Moisés suplicou a Javé pelo povo."
,"8":"E Javé respondeu-lhe: «Faz uma serpente venenosa e coloca-a sobre um poste: quem for mordido e olhar para ela, ficará curado»."
,"9":"Então Moisés fez uma serpente de bronze e colocou-a no alto de um poste. Quando alguém era mordido por uma serpente, olhava para a serpente de bronze e ficava curado."
,"10":"Os filhos de Israel partiram e acamparam em Obot."
,"11":"Depois, partiram de Obot e acamparam em Jeabarim, no deserto que faz limite com Moab, do lado onde nasce o sol."
,"12":"Dali partiram e acamparam junto à torrente de Zared."
,"13":"Dali seguiram e acamparam no outro lado do rio Arnon, no deserto que sai do território dos amorreus, pois o rio Arnon faz de fronteira entre Moab e os amorreus."
,"14":"Assim se diz no Livro das Guerras de Javé: «Vaeb, junto de Sufa e os afluentes do Arnon;"
,"15":"a ladeira das torrentes que correm na direcção da sede de Ar, e junto à fronteira dos territórios de Moab»."
,"16":"Dali partiram para Beer. Este é o poço onde Javé disse a Moisés: «Reúne o povo, e Eu dar-lhe-ei água»."
,"17":"Então Israel cantava esta canção: «Brota, poço! Aclamai-o!"
,"18":"Poço que príncipes cavaram e chefes do povo abriram com ceptros e bastões». Dali foram para Matana. "
,"19":"De Matana para Naaliel. De Naaliel para Bamot."
,"20":"E de Bamot para o vale do campo de Moab, em direcção às alturas do Fasga, que domina o deserto."
,"21":"Israel enviou mensageiros para dizer a Seon, rei dos amorreus:"
,"22":"«Quero atravessar a tua terra. Não nos desviaremos pelos campos ou vinhas, nem beberemos água dos poços; iremos pela estrada real, até atravessar o teu território»."
,"23":"Seon, porém, não permitiu que Israel lhe atravessasse o território. Reuniu todo o seu povo, saiu contra Israel no deserto e atacou-o em Jasa."
,"24":"Israel, porém, derrotou-o à espada e conquistou-lhe a terra, desde o Arnon até ao Jaboc, até ao país dos amonitas, pois Jazer encontrava-se na fronteira amonita."
,"25":"Israel conquistou-lhe todas as cidades, e estabeleceu-se em todas as cidades dos amorreus: Hesebon e os povoados do seu território."
,"26":"Hesebon era a capital de Seon, rei dos amorreus. Ele havia lutado contra o rei anterior de Moab, de quem havia tomado todo o território, desde o Jaboc até ao Arnon."
,"27":"Por isso, cantam os poetas: «Entrai em Hesebon. Que seja edificada, restaurada a capital de Seon!"
,"28":"Saiu fogo de Hesebon, e chamas da capital de Seon. Fogo que devorou Ar Moab e consumiu as alturas do Arnon."
,"29":"Ai de ti, Moab! Estás perdido, povo de Camos! Os teus filhos fugiram, e as tuas filhas ficaram escravas de Seon, rei dos amorreus."
,"30":"Nós crivámo-los a todos de flechas. Tudo ficou destruído, desde Hesebon até Dibon. Tudo devastámos até Nofe, tudo aquilo que se estende até Medaba»."
,"31":"Israel estabeleceu-se, então, na terra dos amorreus."
,"32":"Moisés enviou exploradores até Jazer, e Israel apoderou-se dela e dos povoados do seu território, expulsando os amorreus que aí dominavam."
,"33":"Depois mudaram de direcção e subiram pelo caminho de Basã. Então Og, rei de Basã, com todo o seu povo, saiu contra eles e atacou-os em Edrai."
,"34":"Javé disse a Moisés: «Não tenhas medo dele, porque vou entregá-lo em teu poder, a ele, a todo o seu povo e ao seu país. Trata-o como a Seon, rei dos amorreus, que habitava em Hesebon»."
,"35":"Os filhos de Israel derrotaram-no, assim como aos seus filhos e a todo o seu povo, sem deixar ninguém com vida. E tomaram posse do seu território."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Os filhos de Israel partiram e acamparam nas estepes de Moab, no outro lado do Jordão, em frente de Jericó."
,"2":"Balac, filho de Sefor, viu como Israel tinha tratado os amorreus."
,"3":"Então Moab ficou com medo deste povo numeroso. Moab ficou apavorado diante dos filhos de Israel,"
,"4":"e disse aos anciãos de Madiã: «Essa multidão vai devorar tudo ao nosso redor, como o boi devora a erva do campo». Naquele tempo, o rei de Moab era Balac, filho de Sefor. "
,"5":"Ele enviou mensageiros a Balaão, filho de Beor, em Petor, seu país de origem, nas margens do rio Eufrates. Mandou chamá-lo, dizendo: «Saiu do Egipto um povo que está cobrindo a superfície da terra e que parou diante de mim."
,"6":"Por favor, vem e amaldiçoa esse povo, pois é mais poderoso do que eu. Desse modo poderemos derrotá-lo e expulsá-lo desta região. Eu sei que fica abençoado quem abençoas, e aquele que amaldiçoas fica amaldiçoado»."
,"7":"Os anciãos de Moab e Madiã partiram, levando o pagamento para o adivinho. Chegaram onde estava Balaão e transmitiram-lhe a mensagem de Balac."
,"8":"Balaão respondeu: «Ficai aqui esta noite, e eu comunicar-vos-ei o que Javé me disser». E os chefes de Moab ficaram com Balaão."
,"9":"Deus manifestou-Se a Balaão e perguntou-lhe: «Quem são esses homens que estão em tua casa?»"
,"10":"Balaão respondeu a Deus: «Balac, filho de Sefor, rei de Moab, mandou-me esta mensagem:"
,"11":"'Um povo saiu do Egipto e está a cobrir a superfície da terra. Vem amaldiçoá-lo, para ver se consigo guerrear contra eles e expulsá-los'»."
,"12":"Deus disse a Balaão: «Não vás com eles e não amaldiçoes esse povo, pois ele é bendito»."
,"13":"Na manhã seguinte Balaão levantou-se e disse aos chefes enviados por Balac: «Voltai para a vossa terra, porque Javé não quer que eu vá convosco»."
,"14":"Os chefes de Moab levantaram-se, voltaram para junto de Balac e disseram-lhe: «Balaão não quis vir connosco»."
,"15":"Então Balac enviou outros chefes, mais numerosos e mais importantes que os primeiros."
,"16":"Eles chegaram onde estava Balaão e disseram-lhe: «Assim diz Balac, filho de Sefor: Não recuses vir ao meu encontro,"
,"17":"pois tornar-te-ei muito rico e farei tudo o que me disseres. Por favor, vem e amaldiçoa esse povo»."
,"18":"Balaão respondeu aos chefes enviados por Balac: «Ainda que Balac me desse o seu palácio cheio de ouro e prata, eu não poderia desobedecer à ordem de Javé, meu Deus, em coisa nenhuma, grande ou pequena."
,"19":"Ficai aqui esta noite até que eu saiba o que Javé me dirá desta vez»."
,"20":"Deus manifestou-Se a Balaão durante a noite e disse-lhe: «Já que esses homens vieram chamar-te, levanta-te e vai com eles, mas vais fazer o que Eu te disser»."
,"21":"Na manhã seguinte Balaão levantou-se, selou a sua jumenta e partiu com os chefes de Moab."
,"22":"Ao ver Balaão partir, a ira de Javé inflamou-se, e o Anjo de Javé parou na estrada para o impedir de passar. Balaão ia montado na sua jumenta e acompanhado pelos seus dois servos."
,"23":"A jumenta viu o Anjo de Javé parado na estrada e com a espada desembainhada na mão. Então desviou-se da estrada e dirigiu-se para o campo. Balaão começou então a espancar a jumenta, para a fazer voltar para a estrada."
,"24":"O Anjo de Javé colocou-se num caminho estreito, no meio das vinhas, com cerca dos dois lados."
,"25":"Vendo o Anjo de Javé, a jumenta encostou-se à cerca, apertando nela o pé de Balaão. Este tornou a espancá-la."
,"26":"O Anjo de Javé seguiu novamente em frente e parou numa passagem apertada, onde não era possível desviar-se nem para a direita nem para a esquerda."
,"27":"Vendo o Anjo de Javé, a jumenta deitou-se debaixo de Balaão. Este ficou furioso e começou a espancar a jumenta com o bastão."
,"28":"Então Javé abriu a boca da jumenta, e ela disse a Balaão: «O que foi que eu fiz, para me espancares três vezes?»"
,"29":"A esta pergunta Balaão respondeu: «É porque estás a troçar de mim. Se eu tivesse uma espada na mão, matar-te-ia agora mesmo»."
,"30":"A jumenta disse a Balaão: «Não sou eu a tua jumenta em que sempre montaste até hoje? Costumo fazer assim contigo?» Balaão respondeu: «Não»."
,"31":"Então Javé abriu os olhos de Balaão, e ele viu o Anjo de Javé parado na estrada, com a espada desembainhada na mão. Então Balaão prostrou-se com o rosto por terra."
,"32":"E o Anjo de Javé disse-lhe: «Porque estás a espancar a tua jumenta pela terceira vez? Eu vim para te impedir de passar, porque estás a seguir por um mau caminho."
,"33":"A jumenta viu-me e afastou-se de mim três vezes. Se ela não se tivesse desviado, eu já te teria matado, deixando-a viva»."
,"34":"Balaão respondeu ao Anjo de Javé: «Pequei, porque não sabia que estavas no caminho, diante de mim! Mas, se isso te desagrada, voltarei para casa»."
,"35":"O Anjo de Javé disse a Balaão: «Vai com esses homens, mas diz somente aquilo que eu te disser». E Balaão continuou a viagem com os chefes enviados por Balac."
,"36":"Quando Balac soube que Balaão estava a chegar, foi ao encontro dele em Ar Moab, que fica junto do Arnon, na fronteira do território."
,"37":"Balac disse a Balaão: «Não enviei mensageiros para te chamar? Porque não vieste logo? Será que não sou capaz de pagar o que mereces?»"
,"38":"Balaão respondeu a Balac: «Como vês, estou aqui. Mas que posso eu dizer? Só direi o que Javé me puser na boca»."
,"39":"Balaão foi com Balac e chegaram a Cariat-Husot."
,"40":"Balac imolou bois e ovelhas, e ofereceu carne a Balaão e aos chefes que o acompanhavam."
,"41":"Na manhã seguinte, Balac tomou consigo Balaão e subiu com ele a Bamot-Baal, de onde se podia ver até à extremidade do acampamento dos filhos de Israel."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Balaão disse a Balac: «Manda construir aqui sete altares e preparar-me sete bezerros e sete carneiros»."
,"2":"Balac fez conforme Balaão havia pedido, e os dois ofereceram em holocausto um bezerro e um carneiro sobre cada altar."
,"3":"Depois Balaão disse a Balac: «Fica de pé junto dos holocaustos que estás a oferecer, enquanto eu me afasto. Talvez Javé venha ao meu encontro. Comunicar-te-ei o que Ele me manifestar». E Balaão foi para uma colina sem vegetação."
,"4":"Deus foi ao encontro de Balaão, que Lhe disse: «Preparei sete altares e ofereci um bezerro e um carneiro sobre cada altar»."
,"5":"Então Javé colocou as palavras na boca de Balaão e disse-lhe: «Volta para junto de Balac e fala-lhe assim...»."
,"6":"Balaão voltou para junto de Balac e encontrou-o ainda perto do seu holocausto, com todos os chefes de Moab."
,"7":"Então Balaão pronunciou o seu poema: «Balac fez-me vir de Aram, o rei de Moab trouxe-me,das montanhas do Oriente: 'Vem amaldiçoar Jacob, vem e fulmina Israel'."
,"8":"Como amaldiçoarei, se Deus não amaldiçoa?,Como fulminarei, se Javé não fulmina?"
,"9":"Sim, eu vejo-o do alto do rochedo, eu contemplo-o do alto das colinas: este é um povo que vive à parte, e não é contado entre as nações."
,"10":"Quem poderia contar o pó de Jacob?,Quem poderia enumerar,o acampamento de Israel?,Oxalá eu morra,como morrem os justos, e o meu fim seja semelhante ao deles»."
,"11":"Então Balac disse a Balaão: «Que me fizeste? Eu trouxe-te para amaldiçoares os meus inimigos, e tu abençoa-los?»"
,"12":"Balaão respondeu: «Devo dizer apenas aquilo que Javé me põe na boca»."
,"13":"Balac disse a Balaão: «Vem comigo a outro lugar, de onde poderás ver o povo; daqui só podes ver uma parte, e não o povo todo. Amaldiçoa-o de lá»."
,"14":"Então Balac levou-o ao campo das Sentinelas, no cume do monte Fasga. Construiu sete altares e ofereceu em holocausto um bezerro e um carneiro sobre cada altar."
,"15":"Então Balaão disse a Balac: «Fica de pé junto dos holocaustos, enquanto eu vou ao encontro de Javé»."
,"16":"Javé foi ao encontro de Balaão, colocou-lhe na boca as suas palavras e disse-lhe: «Volta para junto de Balac e fala-lhe assim...»."
,"17":"Balaão voltou para junto de Balac e encontrou-o ainda perto do seu holocausto, com todos os chefes de Moab. Balac perguntou-lhe: «O que foi que Javé te disse?»"
,"18":"Então Balaão pronunciou o seu poema: «Levanta-te, Balac, e ouve: presta-me atenção, filho de Sefor."
,"19":"Deus não mente como o homem, nem Se arrepende como os humanos. Poderá Ele dizer e não cumprir?,Prometerá alguma coisa,que depois não cumpra?"
,"20":"Recebi ordem para abençoar: pois abençoarei e não voltarei atrás."
,"21":"Não se descobre maldade em Jacob, nem se encontra crime em Israel. Javé, o seu Deus, está com ele, e ele aclama-O como rei."
,"22":"Deus tirou-o do Egipto, e é para ele como chifres de búfalo."
,"23":"Não há presságio contra Jacob, nem magia contra Israel: no devido tempo,dirão a Jacob e a Israel,o que Deus realiza."
,"24":"Eis um povo que se levanta como leoa,e se ergue como leão; não se deita antes de devorar a presa, e de beber o sangue dos que matou»."
,"25":"Balac disse a Balaão: «Se não o amaldiçoas, pelo menos não o abençoes»."
,"26":"Balaão respondeu-lhe: «Não te disse já que só farei o que Javé me mandar?»"
,"27":"Balac insistiu com Balaão: «Vem comigo. Vou levar-te a outro lugar. Aí talvez Deus permita que amaldiçoes o povo»."
,"28":"Então Balac levou Balaão ao cume do monte Fegor, que está diante do deserto."
,"29":"Balaão pediu a Balac: «Constrói-me aqui sete altares, e prepara-me sete bezerros e sete carneiros»."
,"30":"Balac fez o que Balaão lhe pediu e ofereceu em holocausto um bezerro e um carneiro sobre cada altar."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Balaão viu que Javé tinha prazer em abençoar Israel. Por isso, não foi em busca de presságios, como antes, mas virou-se para o deserto,"
,"2":"levantou os olhos e viu Israel acampado por tribos. Então o espírito de Deus desceu sobre ele,"
,"3":"e ele pronunciou o seu poema: «Oráculo de Balaão, filho de Beor, oráculo do homem de olhos,penetrantes;"
,"4":"oráculo de quem ouve as palavras,de Deus,e conhece a ciência do Altíssimo. Ele vê aquilo,que o Todo-poderoso mostra, e entra em êxtase de olhos abertos:"
,"5":"Como são belas as tuas tendas, Jacob, e as tuas moradas, Israel!"
,"6":"São como vales que se estendem, como jardins nas margens de um rio, como árvores perfumadas,que Javé plantou, como cedros ao longo das águas!"
,"7":"A água transborda do seu cântaro, e com a água,a sua semente multiplica-se. O seu rei é mais alto que Agag, e o seu reino será celebrado."
,"8":"Deus tirou este povo do Egipto, e é para ele como chifres de búfalo. Ele devora o cadáver,das nações inimigas, quebra-lhes os ossos e atravessa-as,com as suas flechas."
,"9":"Ele agacha-se e deita-se como um leão, ou como uma leoa. Quem o desafiará?,Bendito seja aquele que te abençoar, e maldito seja quem te amaldiçoar»."
,"10":"Então Balac ficou irritado com Balaão, bateu palmas e disse-lhe: «Chamei-te para amaldiçoares o meu inimigo, e tu já o abençoaste três vezes."
,"11":"Pois agora foge para a tua pátria. Eu tinha-te prometido riquezas, porém Javé deixou-te sem elas»."
,"12":"Balaão respondeu: «Eu já havia dito aos mensageiros que me enviaste:"
,"13":"'Mesmo que Balac me dê o seu palácio cheio de ouro e prata, eu não poderei ir contra a ordem de Javé, fazendo o mal ou o bem por conta própria. Só direi o que Javé me mandar'»."
,"14":"Balaão continuou: «Agora volto para o meu povo, mas antes vou explicar-te o que no futuro este povo fará ao teu povo»."
,"15":"E Balaão pronunciou o seu poema: «Oráculo de Balaão, filho de Beor; oráculo do homem de olhos,penetrantes;"
,"16":"oráculo de quem ouve,as palavras de Deus,e conhece a ciência do Altíssimo. Ele vê aquilo,que o Todo-poderoso mostra, e entra em êxtase de olhos abertos:"
,"17":"Eu vejo-o, mas não é agora; eu contemplo-o, mas não de perto: uma estrela avança de Jacob, um ceptro levanta-se de Israel, e esmaga as têmporas de Moab,e o crânio dos filhos de Set."
,"18":"Edom tornar-se-á conquista, e o inimigo Seir será sua propriedade. Israel triunfará."
,"19":"Jacob dominará sobre os seus inimigos,e acabará,com os que ficarem na capital»."
,"20":"Depois Balaão viu Amalec, e pronunciou o seu poema: «Amalec é a primeira das nações, mas o seu futuro,será uma ruína eterna»."
,"21":"Depois viu os quenitas, e pronunciou o seu poema: «A tua morada é segura, Caim: colocaste o teu ninho na rocha,"
,"22":"mas serás destruído, quando Assur te levar para o exílio»."
,"23":"E Balaão continuou o seu poema: «Ai de quem sobreviver,depois de Deus assim agir!"
,"24":"Virão navios de Chipre,e oprimirão Assur e Héber, mas no fim perecerão»."
,"25":"Depois Balaão voltou para a sua pátria. E Balac continuou o seu cami-nho."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Israel fixou-se em Setim, e o povo começou a prostituir-se com as filhas de Moab."
,"2":"Estas convidaram o povo a comer dos sacrifícios aos seus deuses e a adorá-los."
,"3":"Israel, então, ligou-se com o Baal de Fegor, e a ira de Javé inflamou-se contra Israel."
,"4":"Javé disse a Moisés: «Toma os chefes do povo e pendura-os num poste ao sol, diante de Javé, para que a ira ardente de Javé se afaste de Israel»."
,"5":"Moisés disse, então, aos juízes de Israel: «Que cada um mate os parentes que se ligaram com o Baal de Fegor»."
,"6":"Um filho de Israel levou para junto dos irmãos uma madianita, à vista de Moisés e de toda a comunidade dos filhos de Israel, enquanto eles choravam à entrada da tenda da reunião."
,"7":"Vendo isto, Fineias, filho de Eleazar, filho do sacerdote Aarão, levantou-se no meio da comunidade, pegou numa lança,"
,"8":"seguiu o filho de Israel até à alcova e aí trespassou-o juntamente com a mulher. Então acabou-se a praga que feria os filhos de Israel."
,"9":"Dentre eles, morreram vinte e quatro mil por causa da praga."
,"10":"Javé disse a Moisés:"
,"11":"«Foi Fineias, filho de Eleazar, filho do sacerdote Aarão, quem fez cessar a minha ira contra os filhos de Israel, porque ele foi zeloso pelos meus direitos diante do povo, e o meu zelo não os consumiu."
,"12":"Por isso Eu prometo: ofereço-lhe a minha aliança de paz."
,"13":"O sacerdócio pertencerá a ele e aos seus descendentes, como pacto perpétuo, em recompensa do seu zelo por Deus e por ter feito a expiação pelos filhos de Israel»."
,"14":"O filho de Israel morto com a madia-nita chamava-se Zambri, filho de Salu, chefe de família na tribo de Simeão."
,"15":"A madianita morta chamava-se Cozbi, filha de Sur, chefe de família em Madiã."
,"16":"Javé ordenou a Moisés:"
,"17":"«Atacai e derrotai os madianitas,"
,"18":"pois eles atacaram-vos com as suas seduções, com os ritos de Fegor e com Cozbi, a filha de um chefe madianita, morta no dia da praga que surgiu por causa do problema de Fegor»."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Depois dessa praga, Javé disse a Moisés e Eleazar, filho do sacerdote Aarão:"
,"2":"«Fazei o recenseamento de toda a comunidade, registando por famílias todos os filhos de Israel maiores de vinte anos, aptos para o serviço militar»."
,"3":"Moisés e o sacerdote Eleazar fizeram o recenseamento dos filhos de Israel maiores de vinte anos, nas planícies de Moab, nas margens do rio Jordão, na altura de Jericó,"
,"4":"conforme Javé havia ordenado a Moisés. Registo dos filhos de Israel que saíram do Egipto:"
,"5":"Rúben, primogénito de Israel. Filhos de Rúben: Henoc e o clã dos henoquitas; Falu e o clã dos faluítas;"
,"6":"Hesron e o clã dos hesronitas; Carmi e o clã dos carmitas."
,"7":"Estes são os clãs rubenitas: o total dos registados foi de quarenta e três mil, setecentos e trinta."
,"8":"Filho de Falu: Eliab."
,"9":"Filhos de Eliab: Namuel, Datã e Abiram. Datã e Abiram eram homens de destaque no conselho, que se rebelaram contra Moisés e Aarão; estavam na companhia de Coré, quando este se revoltou contra Javé."
,"10":"A terra abriu a boca e engoliu-os, juntamente com Coré. Deste modo, todo o grupo morreu e o fogo devorou duzentos e cinquenta homens, como sinal para o povo."
,"11":"Os filhos de Coré, porém, não morreram."
,"12":"Filhos de Simeão por clãs: Namuel e o clã dos namuelitas; Jamin e o clã dos jaminitas; Jaquin e o clã dos jaquinitas;"
,"13":"Zara e o clã dos zaraítas; Saul e o clã dos saulitas."
,"14":"Estes são os clãs simeonitas. Formavam um total de vinte e dois mil e duzentos."
,"15":"Filhos de Gad por clãs: Sefon e o clã dos sefonitas; Agi e o clã dos agitas; Suni e o clã dos sunitas;"
,"16":"Ozni e o clã dos oznitas; Heri e o clã dos heritas;"
,"17":"Arod e o clã dos aroditas; Areli e o clã dos arelitas."
,"18":"Estes são os clãs gaditas. Formavam um total de quarenta mil e quinhentos."
,"19":"Filhos de Judá: Her e Onã. Her e Onã morreram na terra de Canaã."
,"20":"São estes os filhos de Judá e os respectivos clãs: Sela e o clã dos selaítas; Farés e o clã dos faresitas; Zaré e o clã dos zareítas."
,"21":"Filhos de Farés: Hesron e o clã dos hesronitas, Hamul e o clã dos hamulitas."
,"22":"São estes os clãs judaítas. Formavam um total de setenta e seis mil e quinhentos."
,"23":"Filhos de Issacar por clãs: Tola e o clã dos tolaítas; Fua e o clã dos fuaítas;"
,"24":"Jasub e o clã dos jasubitas; Semron e o clã dos semronitas."
,"25":"São estes os clãs issacaritas. Formavam um total de sessenta e quatro mil e trezentos."
,"26":"Filhos de Zabulon por clãs: Sared e o clã dos sareditas; Elon e o clã dos elonitas; Jalel e o clã dos jalelitas."
,"27":"São estes os clãs zabulonitas. Formavam um total de sessenta mil e quinhentos."
,"28":"Filhos de José por clãs: Manassés e Efraim."
,"29":"Filhos de Manassés: Maquir e o clã dos maquiritas; Maquir gerou Galaad, do qual surgiu o clã galaadita."
,"30":"Filhos de Galaad: Jezer e o clã dos jezeritas; Helec e o clã dos helequitas;"
,"31":"Asriel e o clã dos asrielitas; Siquém e o clã dos siquemitas;"
,"32":"Semida e o clã dos semidaítas; Héfer e o clã dos hefritas;"
,"33":"Salfaad, filho de Héfer, não teve filhos, mas somente filhas. As filhas de Salfaad são: Maala, Noa, Hegla, Melca e Tersa."
,"34":"São estes os clãs manassitas. Formavam um total de cinquenta e dois mil e setecentos."
,"35":"Filhos de Efraim por clãs: Sutala e o clã dos sutalaítas; Bequer e o clã dos bequeritas; Teen e o clã dos teenitas."
,"36":"Filhos de Sutala: Herã e o clã dos heranitas."
,"37":"São estes os clãs efraimitas. Formavam um total de trinta e dois mil e quinhentos. São estes os filhos de José por clãs."
,"38":"Filhos de Benjamim por clãs: Bela e o clã dos belaítas; Asbel e o clã dos asbelitas; Airam e o clã dos airamitas;"
,"39":"Sufam e o clã dos sufamitas; Hufam e o clã dos hufamitas."
,"40":"Filhos de Bela: Ared e Naamã. De Ared, o clã dos areditas; de Naamã, o clã dos naamanitas."
,"41":"São estes os filhos de Benjamim por clãs. Formavam um total de quarenta e cinco mil e seiscentos."
,"42":"Filhos de Dã por clãs: Suam e o clã dos suamitas. São estes os filhos de Dã por clãs."
,"43":"O total do clã suamita era de sessenta e quatro mil e quatrocentos."
,"44":"Filhos de Aser por clãs: Jemna e o clã dos jemnaítas; Jessui e o clã dos jessuítas; Beria e o clã dos beriaítas."
,"45":"Filhos de Beria: Héber e o clã dos heberitas; Melquiel e o clã dos melquielitas."
,"46":"Nome da filha de Aser: Sara."
,"47":"São estes os clãs aseritas. Formavam um total de cinquenta e três mil e quatrocentos."
,"48":"Filhos de Neftali por clãs: Jasiel e o clã dos jasielitas; Guni e o clã dos gunitas;"
,"49":"Jeser e o clã dos jeseritas; Selém e o clã dos selemitas."
,"50":"São estes os clãs neftalitas, conforme os seus clãs. Os neftalitas formavam um total de quarenta e cinco mil e quatrocentos."
,"51":"O total dos filhos de Israel era, portanto, seiscentos e um mil, setecentos e trinta."
,"52":"Javé disse a Moisés:"
,"53":"«A Terra será distribuída em herança a todos estes, de acordo com o número de inscritos."
,"54":"Darás uma propriedade maior àquele que é em maior número, e darás uma propriedade menor àquele que tem menor número. A herança será distribuída em proporção com o número dos recenseados."
,"55":"A divisão da Terra, porém, será feita através de sorteio. A herança será recebida de acordo com o número dos nomes das famílias,"
,"56":"e a herança de cada tribo será repartida por sorteio, tendo em conta o maior ou menor número»."
,"57":"Levitas recenseados por clãs: Gérson e o clã dos gersonitas; Caat e o clã dos caatitas; Merari e o clã dos meraritas."
,"58":"São estes os clãs levitas: o clã dos lobnitas, o clã dos hebronitas, o clã dos moolitas, o clã dos musitas e o clã dos coreítas. Caat gerou Amram. "
,"59":"A esposa de Amram chamava-se Jocabed, que era filha de Levi e nasceu no Egipto. Filhos que ela teve de Amram: Aarão, Moisés e a irmã deles, Maria."
,"60":"Filhos de Aarão: Nadab, Abiú, Eleazar e Itamar."
,"61":"Nadab e Abiú morreram quando ofereciam a Javé um fogo irregular."
,"62":"O total dos recenseados foi de vinte e três mil homens de um mês para cima. Não haviam sido recenseados com os outros filhos de Israel, pois não tinham recebido herança com eles."
,"63":"Este foi o recenseamento dos filhos de Israel que Moisés e o sacerdote Eleazar fizeram nas estepes de Moab, nas margens do rio Jordão, nas vizinhanças de Jericó."
,"64":"Entre os registados não havia nenhum dos que tinham sido registados no recenseamento que Moisés e o sacerdote Aarão haviam feito no deserto do Sinai."
,"65":"Javé tinha dito a respeito deles: «Morrerão todos no deserto e não ficará nenhum, além de Caleb, filho de Jefoné, e Josué, filho de Nun»."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Chegaram, então, as filhas de Salfaad. Este era filho de Héfer, filho de Galaad, filho de Maquir, filho de Manassés; pertencia ao clã de Manassés, filho de José. As suas filhas chamavam-se Maala, Noa, Hegla, Melca e Tersa."
,"2":"Elas apresentaram-se a Moisés, ao sacerdote Eleazar, aos chefes e a toda a comunidade, à entrada da tenda da reunião, e disseram:"
,"3":"«O nosso pai morreu no deserto. Não pertencia ao grupo de Coré, que se revoltou contra Javé. Ele morreu pelo seu próprio pecado e não deixou filhos."
,"4":"Porque é que o nome do nosso pai deveria desaparecer do seu clã? Só porque não teve filhos? Dêem-nos uma propriedade entre os irmãos do nosso pai»."
,"5":"Moisés apresentou a causa delas a Javé."
,"6":"Então Javé disse a Moisés:"
,"7":"«As filhas de Salfaad têm razão. Dá-lhes uma propriedade como herança entre os irmãos do pai delas. Transmite-lhes a herança do pai."
,"8":"Depois diz aos filhos de Israel: 'Se um homem morrer sem deixar filhos, passai a herança para a sua filha."
,"9":"Se não tiver uma filha, entregai a herança aos seus irmãos."
,"10":"Se não tiver irmãos, dai a herança aos irmãos do seu pai."
,"11":"Se o seu pai não tiver irmãos, dai a herança ao parente mais próximo dentro do clã: este receberá a herança'». Esta é a norma justa para os filhos de Israel, conforme Javé ordenou a Moisés."
,"12":"Javé disse a Moisés: «Sobe ao monte Abarim e contempla a terra que vou dar aos filhos de Israel."
,"13":"Depois de a contemplares, reunir-te-ás aos teus antepassados, como o teu irmão Aarão."
,"14":"Isto porque fostes rebeldes no deserto de Sin, quando a comunidade se revoltou contra Mim, e não demonstrastes a minha santidade junto à fonte». Trata-se da fonte de Meriba, em Cades, no deserto de Sin."
,"15":"Moisés disse a Javé:"
,"16":"«Então Javé, o Deus dos espíritos de todos os seres vivos, indique um chefe para a comunidade,"
,"17":"alguém que exerça a chefia, para que a comunidade de Javé não fique como rebanho sem pastor»."
,"18":"Javé respondeu a Moisés: «Toma Josué, filho de Nun, homem de grandes qualidades, e impõe a mão sobre ele."
,"19":"Depois apresenta-o ao sacerdote Eleazar e a toda a comunidade. Passa para Josué o cargo na presença deles,"
,"20":"e comunica-lhe uma parte da tua própria autoridade, para que a comunidade de Israel lhe obedeça."
,"21":"Então Josué apresentar-se-á ao sacerdote Eleazar, que consultará Javé por ele, tirando a sorte por meio dos urim. Toda a comunidade, tanto Josué como os filhos de Israel, agirá conforme o orá-culo»."
,"22":"Moisés fez o que Javé havia mandado: tomou Josué e apresentou-o ao sacerdote Eleazar e a toda a comunidade."
,"23":"Eleazar impôs sobre ele as mãos e transmitiu-lhe o cargo, conforme Javé dissera por meio de Moisés."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Javé disse a Moisés:"
,"2":"«Ordena aos filhos de Israel: Apresentai-Me no devido tempo as minhas ofertas, os meus alimentos e as ofertas queimadas de perfume agradável."
,"3":"Diz-lhes: São estas as ofertas queimadas que oferecereis a Javé: cada dia dois cordeiros de um ano, perfeitos, como holocausto perpétuo."
,"4":"Oferece o primeiro cordeiro em holocausto pela manhã e o segundo em holocausto à tarde,"
,"5":"juntamente com a oblação de quatro litros e meio de flor de farinha amassada com dois litros de azeite de oliveira refinado."
,"6":"É o holocausto perpétuo que se oferecia outrora no monte Sinai como perfume agradável, uma oferta queimada a Javé."
,"7":"A libação será de dois litros para cada cordeiro; no santuário será oferecida a Javé a libação de bebida fermentada."
,"8":"Com o segundo cordeiro farás o holocausto da tarde; fá-lo com a mesma oblação e a mesma libação da manhã, como oferta queimada de perfume agradável a Javé."
,"9":"No sábado, oferecei dois cordeiros de um ano, perfeitos, juntamente com a oblação de nove litros de flor de farinha amassada com azeite, com a sua libação."
,"10":"É o holocausto do sábado, a ser feito cada sábado, além do holocausto perpétuo e da respectiva libação."
,"11":"No primeiro dia de cada mês oferecei, como holocausto a Javé, dois bezerros, um carneiro e sete cordeiros de um ano, todos perfeitos."
,"12":"Para cada bezerro, juntai a oblação de treze litros e meio de flor de farinha amassada com azeite; para o carneiro, juntai a oblação de nove litros de flor de farinha amassada com azeite;"
,"13":"para cada cordeiro, juntai a oblação de quatro litros e meio de flor de farinha amassada com azeite. É o holocausto de perfume agradável, uma oferta queimada para Javé."
,"14":"As libações que o acompanham serão de quatro litros de vinho por bezerro, de dois litros e meio para o carneiro e de dois litros para cada cordeiro. Este é o holocausto mensal, para todos os meses do ano."
,"15":"Além do holocausto perpétuo com a sua respectiva libação, será oferecido a Javé um bode como sacrifício pelo pecado."
,"16":"No dia catorze do primeiro mês celebra-se a Páscoa de Javé,"
,"17":"e o dia quinze é dia de festa. Durante sete dias comer-se-ão pães sem fermento;"
,"18":"no primeiro dia o povo reunir-se-á em assembleia santa e não realizará nenhum trabalho."
,"19":"Oferecei a Javé ofertas queimadas em holocausto: dois bezerros, um carneiro e sete cordeiros de um ano, todos perfeitos."
,"20":"A oblação de flor de farinha amassada com azeite será de treze litros e meio por cada bezerro, nove litros pelo carneiro,"
,"21":"e quatro litros e meio por cada um dos sete cordeiros."
,"22":"Oferecei também um bode para fazer o sacrifício pelo vosso pecado."
,"23":"Fazei tudo isto além do holocausto da manhã, que é oferecido como holocausto perpétuo."
,"24":"Fazei o mesmo durante cada um dos sete dias: é alimento, oferta queimada de perfume agradável a Javé. Fazei tudo isto, além do holocausto perpétuo, com a sua correspondente libação."
,"25":"No sétimo dia fazei uma assembleia santa e não realizeis nenhum trabalho."
,"26":"No dia dos primeiros frutos, quando oferecerdes a Javé uma oblação de frutos novos na festa das Semanas, fazei uma assembleia santa e não realizeis nenhum trabalho."
,"27":"Oferecei um holocausto de perfume agradável a Javé: dois bezerros, um carneiro e sete cordeiros de um ano, todos perfeitos."
,"28":"A oblação de flor de farinha amassada com azeite será de treze litros e meio por cada bezerro, nove litros pelo carneiro,"
,"29":"e quatro litros e meio por cada um dos sete cordeiros."
,"30":"Oferecei também um bode como sacrifício pelo vosso pecado."
,"31":"Fazei tudo isto, além do holocausto perpétuo com a sua oblação e respectivas libações."
}`)
	CurrentBook.AddChapter(29, `{
"1":"No primeiro dia do sétimo mês fareis uma assembleia santa e não realizareis nenhum trabalho. Será para vós o dia da aclamação com as trombetas."
,"2":"Oferecei, em holocausto de perfume agradável a Javé, um bezerro, um carneiro e sete cordeiros de um ano, todos perfeitos."
,"3":"A oblação de flor de farinha amassada com azeite será de treze litros e meio pelo bezerro, nove litros pelo carneiro"
,"4":"e quatro litros e meio por cada um dos sete cordeiros."
,"5":"Oferecei também um bode como sacrifício pelo vosso pecado."
,"6":"Fazei tudo isto, além do holocausto mensal e da respectiva oblação, e além do holocausto perpétuo com a sua oblação e respectivas libações, conforme o ritual. É uma oferta queimada de perfume agradável a Javé."
,"7":"No décimo dia do sétimo mês fareis uma assembleia santa, jejuareis e não realizareis nenhum trabalho."
,"8":"Oferecei um holocausto de perfume agradável a Javé: um bezerro, um carneiro e sete cordeiros de um ano, que escolhereis entre aqueles que são perfeitos."
,"9":"A oblação de flor de farinha amassada com azeite será de treze litros e meio pelo bezerro, nove litros pelo carneiro,"
,"10":"e quatro litros e meio por cada um dos sete cordeiros."
,"11":"Oferecei também um bode como sacrifício pelo pecado, além do sacrifício pelo pecado na festa da Expiação, e além do holocausto perpétuo com a sua oblação e respectivas libações."
,"12":"No dia quinze do sétimo mês fareis uma assembleia santa: não realizareis nenhum trabalho, e durante sete dias celebrareis a festa em honra de Javé."
,"13":"Oferecei um holocausto, oferta queimada de perfume agradável a Javé: treze bezerros, dois carneiros e catorze cordeiros de um ano, todos perfeitos."
,"14":"A oblação de flor de farinha amassada com azeite será de treze litros e meio por cada um dos treze bezerros, nove litros por cada um dos dois carneiros,"
,"15":"e quatro litros e meio por cada um dos catorze cordeiros."
,"16":"Oferecei também um bode como sacrifício pelo pecado, além do holocausto perpétuo com a sua oblação e respectivas libações."
,"17":"No segundo dia oferecei doze bezerros, dois carneiros e catorze cordeiros de um ano, todos perfeitos,"
,"18":"com a oblação e a libação correspondentes, a serem feitas conforme o ritual, segundo o número dos bezerros, carneiros e cordeiros;"
,"19":"e também um bode para o sacrifício pelo pecado. Tudo isto, além do holocausto perpétuo com a sua oblação e respectivas libações."
,"20":"No terceiro dia oferecei onze bezerros, dois carneiros e catorze cordeiros de um ano, todos perfeitos,"
,"21":"com a oblação e as libações correspondentes, a serem feitas conforme o ritual, segundo o número dos bezerros, carneiros e cordeiros;"
,"22":"e também um bode para o sacrifício pelo pecado. Tudo isto, além do holocausto perpétuo com a sua oblação e libações."
,"23":"No quarto dia oferecei dez bezerros, dois carneiros e catorze cordeiros de um ano, todos perfeitos,"
,"24":"com a oblação e as libações correspondentes, a serem feitas conforme o ritual, segundo o número dos bezerros, carneiros e cordeiros;"
,"25":"e também um bode para o sacrifício pelo pecado. Tudo isto, além do holocausto perpétuo com a sua oblação e libações."
,"26":"No quinto dia oferecei nove bezerros, dois carneiros e catorze cordeiros de um ano, todos perfeitos,"
,"27":"com a oblação e as libações correspondentes, a serem feitas conforme o ritual, segundo o número dos bezerros, carneiros e cordeiros;"
,"28":"e também um bode para o sacrifício pelo pecado. Tudo isto, além do holocausto perpétuo com a sua oblação e libações."
,"29":"No sexto dia oferecei oito bezerros, dois carneiros e catorze cordeiros de um ano, todos perfeitos,"
,"30":"com a oblação e as libações correspondentes, a serem feitas conforme o ritual, segundo o número dos bezerros, carneiros e cordeiros;"
,"31":"e também um bode para o sacrifício pelo pecado. Tudo isto, além do holocausto perpétuo com a sua oblação e libações."
,"32":"No sétimo dia oferecei sete bezerros, dois carneiros e catorze cordeiros de um ano, todos perfeitos,"
,"33":"com a oblação e libações correspondentes, a serem feitas conforme o ritual, segundo o número dos bezerros, carneiros e cordeiros,"
,"34":"e também um bode para o sacrifício pelo pecado. Tudo isto, além do holocausto perpétuo com a sua oblação e libações."
,"35":"No oitavo dia fareis assembleia e não realizareis nenhum trabalho."
,"36":"Oferecei um holocausto de oferta queimada de perfume agradável a Javé: um bezerro, um carneiro e sete cordeiros de um ano, todos perfeitos,"
,"37":"com a oblação e as libações correspondentes, a serem feitas conforme o ritual, segundo o número dos bezerros, carneiros e cordeiros,"
,"38":"e também um bode para o sacrifício pelo pecado. Tudo isto, além do holocausto perpétuo com a sua oblação e libações."
,"39":"Estes são os sacrifícios que oferecereis a Javé nas solenidades que celebrardes, além das ofertas pelos vossos votos e sacrifícios voluntários, e além dos holocaustos, oblações, libações e sacrifícios de comunhão»."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Moisés comunicou aos filhos deIsrael tudo o que Javé lhe havia ordenado."
,"2":"Moisés disse aos chefes das tribos de Israel: «Assim ordena Javé:"
,"3":"Quando um homem fizer um voto a Javé ou se comprometer com alguma coisa sob juramento, não deverá faltar à palavra. Cumpra o que prometeu."
,"4":"Quando uma mulher, ainda solteira e morando com o pai, fizer um voto ou se obrigar a uma promessa,"
,"5":"se o pai, conhecendo o voto ou a promessa que ela fez, nada lhe disser, então os votos dela são válidos e a promessa ficará de pé."
,"6":"Contudo, se o pai, no dia em que tomou conhecimento, fez oposição à promessa, nenhum dos votos e promessas que ela fez serão válidos. Javé dispensa-a, porque o pai dela desaprovou."
,"7":"Se ela se casar comprometida pelo voto ou pela promessa que fez sem pensar,"
,"8":"e se o marido, ao tomar conhecimento, nada lhe disser no dia em que for informado, os votos e promessas que ela fez serão válidos."
,"9":"Contudo, no dia em que o marido tomar conhecimento, se ele fizer oposição, o voto que ela fez ficará nulo, e a promessa que fez sem pensar não terá efeito. Javé dispensá-los-á."
,"10":"O voto de uma viúva ou repudiada e todas as promessas que fizer serão válidos."
,"11":"Quando uma mulher faz um voto na casa do seu marido, ou se compromete com alguma coisa sob juramento,"
,"12":"se o marido, ao saber do facto, nada lhe diz e não lhe faz oposição, então os votos dela são válidos e a promessa que fez ficará de pé."
,"13":"Contudo, se o marido, ao ser informado, os anula, então os votos e promessas dela ficam inválidos. O seu marido desaprovou-os e Javé dispensa-a."
,"14":"O marido pode confirmar ou anular qualquer voto ou juramento de penitência feito pela sua mulher."
,"15":"Contudo, se o marido nada lhe diz até ao dia seguinte, então confirma todos os votos e promessas que a obrigam: ele confirma-os com o silêncio que guardou ao ser informado."
,"16":"Todavia, se foi informado e os anula mais tarde, ele próprio levará o peso da culpa da sua mulher»."
,"17":"São estas as ordens que Javé deu a Moisés para o marido e a mulher, e para o pai e a filha, quando esta ainda vive com o pai."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Javé disse a Moisés:"
,"2":"«Executa a vingança dos filhos de Israel contra os madianitas. Depois reunir-te-ás aos teus antepassados»."
,"3":"Moisés disse ao povo: «Escolhei homens entre vós, e armai-os para a guerra. Eles atacarão os madianitas para realizar contra eles a vingança de Javé."
,"4":"Mandai para a guerra mil homens de cada uma das tribos de Israel»."
,"5":"Deste modo, forneceram para a guerra doze mil homens, mil de cada uma das tribos de Israel."
,"6":"Moisés enviou-os para a guerra, mil de cada tribo, sob as ordens de Fineias, filho do sacerdote Eleazar, com as armas sagradas e as trombetas para o toque de combate."
,"7":"Guerrearam contra Madiã, conforme Javé ordenara a Moisés, e mataram todos os homens."
,"8":"Mataram também os reis de Madiã: Evi, Recém, Sur, Hur e Rebe, os cinco reis de Madiã; também passaram a fio de espada Balaão, filho de Beor."
,"9":"Os filhos de Israel levaram como prisioneiras as mulheres madianitas com as suas crianças, e saquearam todo o gado, rebanhos e bens."
,"10":"Incendiaram as cidades e todos os povoados."
,"11":"Em seguida, levaram todos os despojos, homens e animais."
,"12":"Levaram os prisioneiros, o saque e os despojos a Moisés, ao sacerdote Eleazar e a toda a comunidade de Israel, que estava acampada nas planícies de Moab, nas margens do rio Jordão, na altura de Jericó."
,"13":"Moisés, o sacerdote Eleazar e todos os chefes da comunidade saíram para os receber fora do acampamento."
,"14":"Moisés ficou furioso com os chefes do exército, generais e capitães que voltavam da guerra,"
,"15":"e disse-lhes: «Porque deixastes as mulheres com vida?"
,"16":"Foram elas que, instigadas por Balaão, fizeram que os filhos de Israel traíssem Javé no caso de Fegor: por causa delas houve uma praga sobre toda a comunidade de Javé."
,"17":"Agora, portanto, matai todas as crianças do sexo masculino e todas as mulheres que tiveram relações sexuais com homens."
,"18":"Deixai vivas apenas as meninas que não tiveram relações sexuais com homens, e elas pertencer-vos-ão."
,"19":"Quanto a vós, ficai sete dias fora do acampamento. Aqueles que tiverem matado alguém ou tocado em cadáver, deverão purificar-se, juntamente com os prisioneiros, no terceiro e no sétimo dia."
,"20":"Purificai também toda a roupa, objectos de couro ou de pêlo de cabra e todos os objectos de madeira»."
,"21":"O sacerdote Eleazar disse aos guerreiros que tinham voltado da guerra: «São estas as ordens que Javé deu a Moisés:"
,"22":"ouro, prata, bronze, ferro, estanho e chumbo,"
,"23":"tudo o que resiste ao fogo, deveis purificá-lo com o fogo e lavá-lo com a água da purificação, e deveis lavar com água tudo o que não resiste ao fogo."
,"24":"No sétimo dia lavareis as roupas e ficareis puros. Depois podereis entrar no acampamento»."
,"25":"Javé disse a Moisés:"
,"26":"«Reúne-te com o sacerdote Eleazar e os chefes de famílias da comunidade e faz a contagem dos despojos e prisioneiros, tanto pessoas como animais."
,"27":"Depois divide os despojos ao meio: uma parte para os guerreiros que foram à batalha, e outra para o resto da comunidade."
,"28":"Cobra aos soldados que foram para o combate um tributo para Javé: um sobre quinhentos, tanto de pessoas como de bois, jumentos e ovelhas."
,"29":"Tudo isto o tomarás da metade que pertence aos soldados e entregarás ao sacerdote Eleazar, como tributo para Javé."
,"30":"Da outra metade que couber aos filhos de Israel, cobra um por cinquenta, tanto de pessoas como de bois, jumentos, ovelhas e toda a espécie de animais, e entrega-os aos levitas que exercem funções no santuário de Javé»."
,"31":"Moisés e o sacerdote Eleazar fizeram o que Javé tinha ordenado a Moisés."
,"32":"Contagem dos despojos que os combatentes haviam capturado: seiscentas e setenta e cinco mil ovelhas,"
,"33":"setenta e dois mil bois,"
,"34":"sessenta e um mil jumentos,"
,"35":"e trinta e duas mil mulheres que não tinham tido relações sexuais."
,"36":"Porção que tocou aos que haviam lutado: trezentas e trinta e sete mil e quinhentas ovelhas,"
,"37":"das quais foi feito para Javé o tributo de seiscentas e setenta e cinco ovelhas;"
,"38":"trinta e seis mil bois, dos quais foi feito para Javé o tributo de setenta e dois bois;"
,"39":"trinta mil e quinhentos jumentos, dos quais foi feito para Javé o tributo de sessenta e um jumentos;"
,"40":"dezasseis mil pessoas, das quais foi feito para Javé o tributo de trinta e duas pessoas."
,"41":"Moisés entregou o tributo de Javé ao sacerdote Eleazar, conforme Javé lhe havia ordenado."
,"42":"Quanto à outra metade que Moisés tinha requisitado aos soldados para os filhos de Israel,"
,"43":"a conta foi a seguinte: trezentas e trinta e sete mil e quinhentas ovelhas,"
,"44":"trinta e seis mil bois,"
,"45":"trinta mil e quinhentos jumentos"
,"46":"e dezasseis mil pessoas."
,"47":"Desta metade que pertencia aos filhos de Israel, Moisés tomou um tributo de dois por cento de pessoas e animais e entregou-o aos levitas, que tinham funções no santuário de Javé, conforme Javé havia ordenado a Moisés."
,"48":"Os comandantes do exército, generais e capitães, aproximaram-se de Moisés,"
,"49":"e disseram: «Os teus servos fizeram o recenseamento dos soldados sob a tua ordem, e não falta nenhum."
,"50":"Por isso, como reconhecimento a Javé por nos ter salvo a vida, cada um de nós oferece a Javé daquilo que saqueou em objectos de ouro, braceletes, pulseiras, anéis, brincos e colares, para fazer uma expiação por nós diante de Javé»."
,"51":"Moisés e o sacerdote Eleazar receberam o ouro que eles ofereciam em artigos trabalhados."
,"52":"A oferta de ouro que fizeram a Javé deu um total de mil, seiscentos e setenta e cinco gramas, oferecidos pelos generais e capitães."
,"53":"Os soldados ficaram com todo o ouro que cada um saqueou."
,"54":"Moisés e o sacerdote Eleazar, porém, receberam o ouro dos generais e capitães, e levaram-no para a tenda da reunião, como memorial dos filhos de Israel diante de Javé."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Os filhos de Rúben e os filhos de Gad possuíam imensos rebanhos. Quando viram que as terras de Jazer e de Galaad eram boas para o rebanho,"
,"2":"foram ter com Moisés, com o sacerdote Eleazar e com os chefes da comunidade, e propuseram:"
,"3":"«Atarot, Dibon, Jazer, Nemra, Hesebon, Eleale, Sabama, Nebo e Meon,"
,"4":"o território dos povos, conquistado por Javé diante da comunidade de Israel, é uma terra boa para o rebanho, e nós teus servos possuímos rebanhos."
,"5":"Por favor, faz que essa terra seja entregue aos teus servos como propriedade, e não atravessaremos o Jordão»."
,"6":"Moisés respondeu aos filhos de Gad e Rúben: «Os vossos irmãos irão para a guerra. E vós? Ficareis aqui?"
,"7":"Ireis vós desencorajar os filhos de Israel, para que não se dirijam à Terra que Javé lhes deu?"
,"8":"Foi o que fizeram os vossos pais quando eu os enviei de Cades Barne para explorar o território!"
,"9":"Eles subiram até ao vale do Cacho, exploraram o território e desencorajaram os filhos de Israel a não irem para a Terra que Javé lhes havia dado."
,"10":"Nesse dia, a ira de Javé inflamou-se, e Ele jurou:"
,"11":"'Os homens de vinte anos para cima, que saíram do Egipto, não verão a terra que prometi dar a Abraão, Isaac e Jacob, porque não Me foram fiéis,"
,"12":"a não ser Caleb, filho do cenezeu Jefoné, e Josué, filho de Nun, porque foram fiéis a Javé'."
,"13":"A ira de Javé inflamou-se contra Israel, e Ele fê-los andar errantes pelo deserto durante quarenta anos, até que desaparecesse aquela geração que fez o que Javé reprova."
,"14":"Agora vós, corja de pecadores, estais a ocupar o lugar dos vossos pais para aumentar ainda mais o ardor da ira de Javé contra Israel!"
,"15":"Se vos afastardes de Javé, Ele aumentará ainda mais a vossa permanência no deserto, e causareis a ruína de todo este povo»."
,"16":"Então eles aproximaram-se de Moisés e disseram: «Queremos construir aqui currais para os rebanhos, e cidades para as nossas crianças."
,"17":"Nós, porém, iremos armados à frente dos filhos de Israel, até que eles cheguem ao lugar que lhes foi destinado. Enquanto isso, os nossos filhos ficarão nas cidades fortificadas, protegidos diante dos habitantes da terra."
,"18":"Não voltaremos para as nossas casas enquanto cada filho de Israel não tiver ocupado a sua herança."
,"19":"Não teremos herança com eles no outro lado do Jordão, pois a nossa herança será do lado de cá, a Oriente do Jordão»."
,"20":"Moisés respondeu: «Se fizerdes isso e vos armardes para combater diante de Javé;"
,"21":"se todos aqueles de vós, que estão armados, atravessarem o Jordão diante de Javé, até que Ele expulse, da vossa presença, todos os vossos inimigos;"
,"22":"se não voltardes antes de a Terra vos estar submetida diante de Javé, então sereis inocentes diante de Javé e diante de Israel, e esta Terra pertencer-vos-á como propriedade, por vontade de Javé."
,"23":"Todavia, se não agirdes assim, pecareis contra Javé. E sabei que o vosso pecado será castigado."
,"24":"Agora, portanto, podeis construir cidades para os vossos filhos, e currais para os vossos rebanhos, mas cumpri o que prometestes»."
,"25":"Os filhos de Gad e Rúben disseram a Moisés: «Os teus servos farão o que nos ordenas."
,"26":"As nossas crianças, as nossas mulheres, os nossos rebanhos e o nosso gado ficarão nas cidades de Galaad,"
,"27":"mas os teus servos, que estão armados para a guerra, irão combater diante de Javé, conforme ordenaste»."
,"28":"Então Moisés deu-lhes ordens, através do sacerdote Eleazar, de Josué, filho de Nun, e dos chefes de famílias e tribos de Israel."
,"29":"Moisés disse-lhes: «Se os filhos de Gad e Rúben atravessarem convosco o Jordão, todos armados para lutar diante de Javé, quando a Terra estiver submetida, dar-lhes-eis o território de Galaad como propriedade."
,"30":"Contudo, se eles não atravessarem armados convosco, receberão a sua propriedade na Terra de Canaã»."
,"31":"Os filhos de Gad e Rúben responderam: «Faremos o que Javé ordena aos teus servos."
,"32":"Atravessaremos armados diante de Javé para a terra de Canaã, mas a propriedade que nos caberá como herança será do lado de cá do Jordão»."
,"33":"Moisés deu aos filhos de Gad, aos filhos de Rúben e à meia tribo de Manassés, filho de José, o reino de Seon, rei dos amorreus, e o reino de Og, rei de Basã, com todas as cidades e povoados do território."
,"34":"Os filhos de Gad reconstruíram as cidades fortificadas de Dibon, Atarot, Aroer,"
,"35":"Atrot-Sofã, Jazer, Jegbaá,"
,"36":"Bet-Nemra e Bet-Arã, e construíram currais para os seus rebanhos."
,"37":"Os filhos de Rúben reconstruíram Hesebon, Eleale, Cariataim,"
,"38":"Nebo e Baal-Meon. Mudaram o nome dessas cidades, e também reconstruíram Sabama. De facto, eles deram nomes novos às cidades que reconstruíram."
,"39":"Os filhos de Maquir, filho de Manassés, invadiram e conquistaram o território de Galaad, expulsando os amorreus que lá moravam."
,"40":"Moisés, então, deu o território de Galaad à tribo de Maquir, filho de Manassés, que ali se estabeleceu."
,"41":"Jair, filho de Manassés, foi e conquistou aldeias, dando-lhes o nome de Aldeias de Jair."
,"42":"Nobe marchou sobre Canat e apoderou-se dela, assim como das cidades da vizinhança, dando-lhes o seu próprio nome: Nobe."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Etapas da viagem dos filhos de Israel, quando saíram do Egipto por esquadrões, sob a chefia de Moisés e Aarão."
,"2":"Moisés registou os pontos de partida, etapa por etapa, quando saíram sob as ordens de Javé. E as etapas, na ordem dos seus pontos de partida, são as seguintes:"
,"3":"No dia quinze do primeiro mês partiram de Ramsés. No dia seguinte ao da Páscoa, os filhos de Israel partiram de mão erguida, diante dos olhos de todos os egípcios,"
,"4":"enquanto os egípcios ainda estavam a sepultar os primogénitos que Javé tinha feito morrer, para fazer justiça contra os seus deuses."
,"5":"Os filhos de Israel partiram de Ramsés e acamparam em Sucot."
,"6":"Depois partiram de Sucot e acamparam em Etam, que está no limite do deserto."
,"7":"Saíram de Etam e voltaram em direcção a Piairot, diante de Baal-Sefon, e acamparam diante de Magdol."
,"8":"Saíram de Piairot e atravessaram o mar, alcançando o deserto. Depois de três dias de marcha pelo deserto de Etam, acamparam em Mara."
,"9":"Partiram de Mara e chegaram a Elim, onde havia doze fontes e setenta palmeiras; e ali acamparam."
,"10":"Partiram de Elim e acamparam junto do Mar Vermelho."
,"11":"Partiram do Mar Vermelho e acamparam no deserto de Sin."
,"12":"Partiram do deserto de Sin e acamparam em Dafca."
,"13":"Partiram de Dafca e acamparam em Alus."
,"14":"Partiram de Alus e acamparam em Rafidim; mas ali o povo não encontrou água para beber."
,"15":"Partiram de Rafidim e acamparam no deserto do Sinai."
,"16":"Partiram do deserto do Sinai e acamparam no Cemitério da Avidez."
,"17":"Partiram do Cemitério da Avidez e acamparam em Currais."
,"18":"Partiram de Currais e acamparam em Retma."
,"19":"Partiram de Retma e acamparam em Remon-Farés."
,"20":"Partiram de Remon-Farés e acamparam em Lebna."
,"21":"Partiram de Lebna e acamparam em Orvalho."
,"22":"Partiram de Orvalho e acamparam em Conselho."
,"23":"Partiram de Conselho e acamparam em Monte Claro."
,"24":"Partiram de Monte Claro e acamparam em Tremendeira."
,"25":"Partiram de Tremendeira e acamparam em Reunião."
,"26":"Partiram de Reunião e acamparam em Fundão."
,"27":"Partiram de Fundão e acamparam em Taré."
,"28":"Partiram de Taré e acamparam em Doçura."
,"29":"Partiram de Doçura e acamparam em Hesmona."
,"30":"Partiram de Hesmona e acamparam em Vínculos."
,"31":"Partiram de Vínculos e acamparam em Bené-Jacã."
,"32":"Partiram de Bené-Jacã e acamparam em Cova Rachada."
,"33":"Partiram de Cova Rachada e acamparam em Delícia."
,"34":"Partiram de Delícia e acamparam em Passagem."
,"35":"Partiram de Passagem e acamparam em Asiongaber."
,"36":"Partiram de Asiongaber e acamparam no deserto de Sin, em Cades."
,"37":"Partiram de Cades e acamparam no monte Hor, na fronteira do território de Edom."
,"38":"O sacerdote Aarão subiu ao monte Hor, segundo a ordem de Javé, e ali morreu, no primeiro dia do quinto mês, quarenta anos depois de os filhos de Israel terem saído do Egipto."
,"39":"Aarão morreu no monte Hor com cento e vinte e três anos."
,"40":"O rei cananeu de Arad, que habitava no Negueb, na terra de Canaã, foi informado da chegada dos filhos de Israel."
,"41":"Estes partiram do monte Hor e acamparam em Sombrio."
,"42":"Partiram de Sombrio e acamparam em Finon."
,"43":"Partiram de Finon e acamparam em Obot."
,"44":"Saíram de Obot e acamparam em Ruínas de Abarim, no território de Moab."
,"45":"Partiram de Ruínas de Abarim e acamparam em Dibon-Gad."
,"46":"Partiram de Dibon-Gad e acamparam em Elmon-Deblataim."
,"47":"Partiram de Elmon-Deblataim e acamparam nos montes Abarim, diante do monte Nebo."
,"48":"Partiram dos montes de Abarim e acamparam na planície de Moab, junto ao rio Jordão, na altura de Jericó."
,"49":"Na planície de Moab, acamparam nas margens do rio Jordão, desde Bet-Jesimot até ao Prado das Acácias."
,"50":"Na planície de Moab, nas margens do rio Jordão, defronte de Jericó, Javé falou a Moisés:"
,"51":"«Diz aos filhos de Israel: Quando atravessardes o rio Jordão e entrardes na terra de Canaã,"
,"52":"expulsai todos os seus governantes, destruí os seus ídolos e imagens, e arrasai os seus lugares altos."
,"53":"Tomai posse da Terra e habitai nela, pois Eu dei-vos essa terra, para que a possuais."
,"54":"Dividi a Terra, por sorteio, entre as vossas famílias. Dai como herança uma parte maior àquele que é mais numeroso, e uma parte menor àquele que é menos numeroso. A herança de cada um será onde cair o sorteio. Fazei a divisão entre as vossas tribos."
,"55":"Contudo, se vós não expulsardes os governantes da terra, aqueles que ficarem serão para vós espinhos nos olhos e ferrões nas costas; eles serão vossos inimigos na terra que habitardes."
,"56":"E Eu farei convosco aquilo que pensei fazer com eles»."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Javé disse a Moisés:"
,"2":"«Ordena aos filhos de Israel: Quando entrardes na terra de Canaã, estareis na terra que vos cabe como herança: a terra de Canaã com as suas fronteiras."
,"3":"A fronteira ao Sul será o deserto de Sin e Edom. O limite Sul começará na extremidade do Mar Morto, a Oriente."
,"4":"Depois voltará para o Sul em direcção à Subida dos Escorpiões, passará por Sin e chegará a Cades Barne, no Sul. Em seguida, irá em direcção a Hasar-Adar e passará por Asemona."
,"5":"De Asemona, a fronteira voltará em direcção ao rio do Egipto e terminará no mar."
,"6":"A fronteira marítima será o Mar Mediterrâneo. Será o vosso limite no lado Oeste."
,"7":"A fronteira Norte será marcada desde o Mar Mediterrâneo até ao monte Hor."
,"8":"Daí, traçareis uma linha até à entrada de Emat, e a fronteira terminará em Sedada."
,"9":"Continuará em direcção a Zefrona, e terminará em Hasar-Enon. Será essa a vossa fronteira do lado Norte."
,"10":"A fronteira do lado Leste irá de Hasar-Enon e Sefama."
,"11":"De Sefama, a fronteira descerá em direcção a Harbel, a Leste de Ain; descendo ainda, costeará a Leste o Mar de Quineret."
,"12":"Daí, a fronteira seguirá o rio Jordão e terminará no Mar Morto. Esta é a vossa Terra com os limites que a cercam»."
,"13":"Então Moisés ordenou aos filhos de Israel: «Esta é a Terra que repartireis por sorteio e que Javé ordenou dar às nove tribos e meia."
,"14":"Porque as tribos de Rúben, de Gad e a meia tribo de Manassés com as suas famílias já receberam a sua herança."
,"15":"Essas duas tribos e meia já receberam a sua herança no outro lado do Jordão, defronte de Jericó, a Oriente»."
,"16":"Javé disse a Moisés:"
,"17":"«Lista das pessoas que repartirão a Terra: O sacerdo-te Eleazar e Josué, filho de Nun."
,"18":"Além deles, escolhereis um chefe de cada tribo, a fim de repartir a terra."
,"19":"Esta é a lista dos chefes: da tribo de Judá, Caleb, filho de Jefoné;"
,"20":"da tribo de Simeão, Samuel, filho de Amiud;"
,"21":"da tribo de Benjamim, Elidad, filho de Caselon;"
,"22":"da tribo de Dã, o chefe Boci, filho de Jogli;"
,"23":"para os filhos de José: da tribo de Manassés, o chefe Haniel, filho de Efod;"
,"24":"e da tribo de Efraim, o chefe Camuel, filho de Seftã;"
,"25":"da tribo de Zabulon, o chefe Elisafã, filho de Farnac;"
,"26":"da tribo de Issacar, o chefe Faltiel, filho de Ozã;"
,"27":"da tribo de Aser, o chefe Aiud, filho de Salomi;"
,"28":"da tribo de Neftali, o chefe Fedael, filho de Amiud»."
,"29":"São estes os encarregados por Javé para repartir entre os filhos de Israel a herança na Terra de Canaã."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Na estepe de Moab, nas margens do rio Jordão, defronte de Jericó, Javé disse a Moisés:"
,"2":"«Ordena aos filhos de Israel que dêem aos levitas, da herança que possuem, algumas cidades para eles morarem, e pastagens ao redor dessas cidades. Dai essas cidades aos levitas."
,"3":"Eles habitarão nessas cidades, e as pastagens dos arredores servirão para os rebanhos, o gado e todos os seus animais."
,"4":"Ao redor das cidades dadas aos levitas, as pastagens estender-se-ão no raio de um quilómetro fora das muralhas da cidade."
,"5":"A partir da muralha, medi um quilómetro para o Leste, um quilómetro para o Sul, um quilómetro para o Oeste e um quilómetro para o Norte, ficando a cidade no centro: serão estas as pastagens das cidades dos levitas."
,"6":"Dai aos levitas aquelas seis cidades de refúgio, que reservastes para o homicida se refugiar. Além delas, dai aos levitas mais quarenta e duas cidades."
,"7":"No total, dareis aos levitas quarenta e oito cidades com as suas pastagens."
,"8":"Tais cidades que pertencerão aos filhos de Israel, serão tomadas em maior número daqueles que têm mais, e em menor número daqueles que têm menos. Cada tribo cederá essas cidades aos levitas na proporção da herança que tiver recebido»."
,"9":"Javé disse a Moisés:"
,"10":"«Diz aos filhos de Israel: Quando atravessardes o Jordão, entrando na Terra de Canaã,"
,"11":"escolhei cidades para servirem de refúgio ao homicida que tenha matado alguém sem querer."
,"12":"Tais cidades servir-vos-ão de refúgio contra o vingador do sangue, para que o homicida não seja morto sem ter comparecido diante da comunidade para ser julgado."
,"13":"Escolhei seis cidades de refúgio:"
,"14":"dai três cidades do lado de cá do Jordão, e outras três na terra de Canaã. Serão cidades de refúgio."
,"15":"Essas seis cidades servirão de refúgio, tanto para alguém dos filhos de Israel, como para o imigrante e para aquele que vive no meio de vós, que tenha matado alguém sem querer."
,"16":"Contudo, se essa pessoa feriu alguém com objecto de ferro, causando a morte, é homicida. E o homicida é réu de morte."
,"17":"Se alguém feriu com uma pedra capaz de causar a morte, e a pessoa morrer, é homicida. E o homicida é réu de morte."
,"18":"Se feriu com objecto de madeira capaz de causar a morte, e a pessoa morrer, é homicida. E o homicida é réu de morte."
,"19":"Cabe ao vingador do sangue matar o homicida. Quando o encontrar, matá-lo-á."
,"20":"Se o homicida empurrou a vítima com ódio ou atirou contra ela alguma coisa e a matou;"
,"21":"ou ainda, se por inimizade o golpeou de modo mortal, aquele que feriu a vítima deve morrer: é um homicida que o vingador do sangue matará quando o encontrar."
,"22":"Todavia, se empurrou a vítima sem querer, sem ódio, ou atirou contra ela alguma coisa sem intenção de a atingir;"
,"23":"ou se não viu a vítima e deixou cair sobre ela uma pedra e a matou, sem ter contra ela nenhum ódio ou intenção de causar-lhe mal,"
,"24":"então a comunidade julgará entre aquele que feriu e o vingador do sangue,"
,"25":"salvando o homicida da mão do vingador do sangue. A comunidade deixá-lo-á voltar para a cidade de refúgio, onde se havia asilado, e aí ficará até à morte do sumo sacerdote, que foi ungido com óleo santo."
,"26":"Se o homicida sair dos limites da cidade de refúgio, onde se havia asilado,"
,"27":"e se o vingador do sangue o encontrar fora dos limites da cidade de refúgio, poderá matá-lo, sem medo de represálias."
,"28":"Porque o homicida deve permanecer na cidade de refúgio até à morte do sumo sacerdote; só depois de o sumo sacerdote morrer, poderá voltar à terra da sua herança."
,"29":"São normas de direito para vós, válidas para todas as gerações, em qualquer lugar onde vós habitardes."
,"30":"Em casos de homicídio, o homicida será morto através do depoimento de testemunhas. Contudo, não basta uma testemunha para levar alguém à pena de morte."
,"31":"Não aceiteis resgate pela vida de um homicida condenado à morte, pois ele deverá morrer."
,"32":"Também não aceiteis resgate por alguém que se refugiou numa cidade de refúgio e quer voltar para a sua terra antes da morte do sumo sacerdote."
,"33":"Não profaneis a terra onde viveis: a terra fica profanada com o sangue, e pelo sangue derramado na terra não há expiação, a não ser pelo sangue daquele que o derramou."
,"34":"Portanto, não contamineis a terra onde viveis e na qual Eu habito, pois Eu, Javé, habito no meio dos filhos de Israel»."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Os chefes de família do clã dos filhos de Galaad, descendentes de Maquir, filho de Manassés, um dos clãs dos filhos de José, apresentaram-se a Moisés e aos principais chefes de família dos filhos de Israel,"
,"2":"e disseram: «Javé ordenou ao meu senhor que repartisse a terra entre os filhos de Israel por sorteio. O meu senhor recebeu de Javé a ordem de dar a parte da herança de Salfaad, nosso irmão, às filhas dele."
,"3":"Ora, se elas se casarem com alguém de outra tribo dos filhos de Israel, a parte que lhes pertence será tirada da parte dos nossos pais. Então a parte da tribo à qual elas vão pertencer ficará maior, e a parte que nos coube por sorteio ficará menor."
,"4":"Quando chegar o ano do jubileu para os filhos de Israel, a parte delas passará para a parte da tribo à qual vão pertencer, e será tirada da parte da nossa tribo»."
,"5":"Então Moisés comunicou aos filhos de Israel esta ordem de Javé: «A tribo dos filhos de José tem razão."
,"6":"Javé ordena às filhas de Salfaad: Casai-vos com quem quiserdes, mas sempre dentro de algum clã da tribo do vosso pai."
,"7":"A herança dos filhos de Israel não passará de uma tribo para outra; os filhos de Israel permanecerão ligados cada um à herança da sua tribo."
,"8":"As filhas que tiverem alguma herança em qualquer uma das tribos dos filhos de Israel, deverão casar-se com alguém de um clã da tribo de seu pai. Deste modo, os filhos de Israel conservarão cada um a herança do seu pai."
,"9":"Uma herança não poderá ser transferida de uma tribo para outra: cada uma das tribos dos filhos de Israel deverá conservar a sua herança»."
,"10":"As filhas de Salfaad fizeram o que Javé tinha ordenado a Moisés."
,"11":"Maala, Tersa, Hegla, Melca e Noa, filhas de Salfaad, casaram-se com os seus primos por parte do pai."
,"12":"Casaram-se dentro dos clãs dos filhos de Manassés, filho de José; por isso, a sua herança permaneceu na tribo do clã do seu pai."
,"13":"São estas as ordens e normas que Javé ordenou aos filhos de Israel por meio de Moisés, na planície de Moab, nas margens do rio Jordão, defronte de Jericó."
}`)

}
func PT_BS_LoadVSCCChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"O mais belo cântico de Salomão."
,"2":"A amada: Beija-me com os beijos da tua boca!,Os teus amores são melhores do que o vinho,"
,"3":"o odor dos teus perfumes é suave, o teu nome é como óleo perfumado a escorrer, e as donzelas enamoram-se de ti..."
,"4":"Arrasta-me contigo, corramos!,Leva-me, ó rei, aos teus aposentos, e exultemos! Alegremo-nos em ti!,Mais que ao vinho, celebremos os teus amores!,Com razão se enamoram de ti..."
,"5":"A amada: Sou morena, mas formosa, ó filhas de Jerusalém, como as tendas de Cedar,e os pavilhões de Salma."
,"6":"Não repareis na minha tez morena: foi o sol que me queimou. Os filhos da minha mãe,voltaram-se contra mim, obrigaram-me a guardar as vinhas, e a minha vinha, a minha... não a pude guardar."
,"7":"Avisa-me, amado da minha alma, onde apascentas e fazes descansar,o rebanho ao meio-dia, para que eu não ande vagueando perdida,entre os rebanhos dos teus companheiros."
,"8":"Coro: Se não o sabes, ó mais bela das mulheres, segue o rasto das ovelhas,e leva as cabras a pastar,junto das tendas dos pastores."
,"9":"O amado: Minha amada, eu comparo-te,à égua atrelada ao carro do Faraó!"
,"10":"Que beleza as tuas faces entre os brincos, o teu pescoço, com colares!"
,"11":"Faremos para ti brincos de ouro,cravejados de prata. Dueto:"
,"12":"-Enquanto o rei está no seu divã, o meu nardo difunde o seu perfume."
,"13":"Um saquinho de mirra,é para mim o meu amado, repousando entre os meus seios."
,"14":"O meu amado é para mim,um cacho de cipro florido,entre as vinhas de Engadi."
,"15":"-Como és bela, minha amada, como és bela!... Os teus olhos são pombas."
,"16":"-Como és belo, meu amado, e que doçura!,O nosso leito é todo relva."
,"17":"-As vigas da nossa casa são de cedro, e o seu tecto, de cipreste."
}`)
	CurrentBook.AddChapter(2, `{
"1":"-Sou um narciso de Saron, uma açucena dos vales."
,"2":"-Como açucena entre espinhos,é a minha amada entre as donzelas."
,"3":"-Macieira entre as árvores do bosque, é o meu amado entre os jovens; à sombra dele eu quis sentar-me, com o seu doce fruto na boca."
,"4":"Ele levou-me à adega, e contra mim desfralda,a sua bandeira de amor."
,"5":"Sustentai-me com bolos de passas, dai-me forças com maçãs, oh!,que estou doente de amor..."
,"6":"A sua mão esquerda,está sob a minha cabeça, e com a direita ele me abraça."
,"7":"-Filhas de Jerusalém, pelas corças e gazelas do campo, eu vos conjuro: não desperteis, não acordeis o amor, até que ele o queira!"
,"8":"A amada: A voz do meu amado!,Ei-lo que vem correndo pelos montes, saltitando pelas colinas!"
,"9":"O meu amado é como um gamo, um filhote de gazela. Ei-lo postando-se,atrás da nossa parede, espiando pelas grades, espreitando pela janela."
,"10":"O meu amado fala, e diz-me: «Levanta-te, minha amada, formosa minha, vem!"
,"11":"Eis que o Inverno já passou!,A chuva já se foi!"
,"12":"As flores florescem na terra, o tempo da poda está a chegar, e o canto da rola,já se ouve nos nossos campos."
,"13":"Despontam figos na figueira,e a vinha florida exala perfume. Levanta-te, minha amada, formosa minha, vem!"
,"14":"Pomba minha, que te aninhas nos vãos do rochedo, nas fendas dos barrancos... Deixa-me ver a tua face, deixa-me ouvir a tua voz, pois a tua face é tão formosa,e tão doce a tua voz!»"
,"15":"Agarrai as raposas, as raposas pequeninas,que devastam as nossas vinhas, as nossas vinhas já floridas!..."
,"16":"O meu amado é meu e eu sou dele, do pastor das açucenas!"
,"17":"Antes que a brisa sopre,e as sombras desapareçam, volta! Sê como um gamo, amado meu, um filhote de gazela,pelas montanhas de Beter."
}`)
	CurrentBook.AddChapter(3, `{
"1":"No meu leito, pela noite, procurei o amado da minha alma. Procurei e não o encontrei!"
,"2":"Vou levantar-me, vou rondar pela cidade, pelas ruas, pelas praças, procurando o amado da minha alma... Procurei e não o encontrei!..."
,"3":"Encontraram-me os guardas,que rondavam a cidade: «Vistes o amado da minha alma?»"
,"4":"Passando por eles, contudo, encontrei o amado da minha alma. Agarrei-o, e não vou soltá-lo, até o levar à casa da minha mãe, ao quarto daquela que me trouxe no seio."
,"5":"O amado: Filhas de Jerusalém, pelas corças e gazelas do campo, eu vos conjuro: não desperteis, não acordeis o amor, antes que ele o queira!,Dia do casamento"
,"6":"Coro: Que é isto que sobe do deserto, como colunas de fumo,perfumado com incenso e mirra, e perfumes dos mercadores?"
,"7":"É a liteira de Salomão!,Sessenta soldados a escoltam, soldados escolhidos de todo o Israel."
,"8":"São todos treinados na espada, provados em muitas batalhas. Vêm todos cingidos de espada, temendo surpresas nocturnas."
,"9":"O rei Salomão,fez para si uma liteira,com madeira do Líbano,"
,"10":"colunas de prata, encosto de ouro,e assento de púrpura, e o interior é embutido de ébano."
,"11":"Ó filhas de Sião, vinde ver,o rei Salomão, com a coroa que lhe pôs sua mãe,no dia do casamento, dia em que o seu coração,se enche de alegria."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Como és bela, minha amada, como és bela!... São pombas,os teus olhos escondidos sob o véu. O teu cabelo... um rebanho de cabras,ondulando nas encostas de Galaad."
,"2":"Os teus dentes... um rebanho tosquiado,subindo após o banho, cada ovelha com seus gémeos, nenhuma delas sem cria."
,"3":"Os teus lábios são fita vermelha, a tua fala melodiosa. Metades de romã são os teus seios,mergulhados sob o véu."
,"4":"O teu pescoço é a torre de David, construída com defesa: dela pendem mil escudos,e armaduras dos heróis."
,"5":"Os teus seios são dois filhotes, filhos gémeos de gazela, pastando entre açucenas."
,"6":"Antes que sopre a brisa,e as sombras desapareçam, vou ao monte da mirra, à colina do incenso."
,"7":"És bela, minha amada, e não tens um só defeito!"
,"8":"Vem do Líbano, noiva minha, vem do Líbano,e entra comigo. Desce do alto do Amaná, do cume do Sanir e do Hermon, esconderijo de leões, montes onde rondam as panteras."
,"9":"Roubaste o meu coração, minha irmã, noiva minha, roubaste o meu coração,com um só dos teus olhares, uma volta dos colares."
,"10":"Como os teus amores são belos, minha irmã, noiva minha. Os teus amores são melhores que o vinho, e mais fino que os outros aromas,é o odor dos teus perfumes."
,"11":"Os teus lábios são favo de mel a escorrer, ó noiva minha. Tens leite e mel sob a língua, e o perfume dos teus vestidos,é como a fragrância do Líbano."
,"12":"És um jardim fechado, minha irmã, noiva minha, um jardim fechado, uma fonte lacrada."
,"13":"Os teus rebentos são pomar de romãzeiras,com frutos preciosos:"
,"14":"nardo e açafrão, canela, cinamomo,e árvores todas de incenso, mirra e aloés, e os mais finos perfumes."
,"15":"A fonte do jardim,é poço de água viva,que jorra, descendo do Líbano!"
,"16":"A amada: Desperta, vento norte!,Aproxima-te, vento sul!,Soprai no meu jardim,para espalhar os vossos perfumes. Entre o meu amado no seu jardim,e coma dos seus frutos saborosos!"
}`)
	CurrentBook.AddChapter(5, `{
"1":"Já entrei no meu jardim, minha irmã, noiva minha, colhi a minha mirra e o meu bálsamo, comi o meu favo de mel, bebi o meu vinho e o meu leite. Comei e bebei, companheiros, embriagai-vos, meus caros amigos!"
,"2":"A amada: Eu dormia, mas o meu coração velava, e ouvi o meu amado que batia: «Abre, minha irmã, minha amada, pomba minha sem defeito!,Tenho a cabeça orvalhada, os meus cabelos gotejam orvalho!»"
,"3":"«Já despi a túnica, e vou vesti-la de novo?,Já lavei os meus pés, e vou sujá-los de novo?»"
,"4":"O meu amado mete a mão,na fenda da porta: as entranhas estremecem-me, a minha alma, ao ouvi-lo, desmaia."
,"5":"Ponho-me de pé,para abrir ao meu amado: as minhas mãos gotejam mirra, os meus dedos são mirra a escorrer,na maçaneta da fechadura."
,"6":"Abro a porta ao meu amado, mas o meu amado já se tinha ido... Procuro-o, mas não o encontro. Chamo-o, e não me responde..."
,"7":"Encontraram-me os guardas,que rondavam a cidade. Bateram-me, feriram-me,e tomaram-me o manto,as sentinelas das muralhas!"
,"8":"Filhas de Jerusalém, eu vos conjuro: se encontrardes o meu amado, que lhe direis?... Dizei-lhe,que estou doente de amor!"
,"9":"Coro: Que é que o teu amado é mais que os outros, ó mais bela das mulheres?,Que é que o teu amado é mais que os outros, para que assim nos conjures?"
,"10":"A amada: O meu amado é branco e rosado,e destaca-se entre dez mil."
,"11":"A sua cabeça é ouro puro, uma copa de palmeira os seus cabelos, negros como o corvo."
,"12":"Os seus olhos... são pombas,à beira de águas correntes: elas banham-se no leite,e repousam na margem."
,"13":"As suas faces são canteiros de bálsamo, colinas de ervas perfumadas. Os seus lábios são lírios,com mirra que flui,e se derrama."
,"14":"Os seus braços são torneados em ouro,incrustado com pedras de Társis. O seu ventre é um bloco de marfim,cravejado de safiras."
,"15":"As suas pernas, colunas de mármore,apoiadas em bases de ouro puro. O seu aspecto é o do Líbano,altaneiro, como um cedro."
,"16":"A sua boca é muito doce... Todo ele é uma delícia!,Assim é o meu amigo, assim o meu amado, ó filhas de Jerusalém."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Onde anda o teu amado, ó mais bela das mulheres?,Aonde foi o teu amado?,Nós vamos procurá-lo contigo!"
,"2":"A amada: O meu amado desceu ao seu jardim, aos terrenos dos balsameiros. Foi pastorear nos jardins,e colher açucenas."
,"3":"Eu sou do meu amado, e o meu amado é meu, o pastor das açucenas."
,"4":"O amado: És bonita, minha amiga, és como Tersa, formosa como Jerusalém. Tu és terrível como esquadrão,com bandeiras desfraldadas."
,"5":"Afasta de mim os teus olhos, que os teus olhos me perturbam!,O teu cabelo é um rebanho de cabras,ondulando nas encostas de Galaad."
,"6":"Os teus dentes... um rebanho tosquiado,subindo após o banho, cada ovelha com seus gémeos, nenhuma delas sem cria."
,"7":"Metades de romã são os teus seios,por detrás do véu."
,"8":"Sejam sessenta as rainhas, e oitenta as concubinas, e as donzelas... sem conta:"
,"9":"uma só é a minha pomba,sem defeito, uma só a preferida,pela mãe que a gerou. Vendo, as jovens felicitam-na, e rainhas e concubinas a louvam:"
,"10":"«Quem é esta que desponta,como a aurora, bela como a Lua, fulgurante como o Sol, terrível como esquadrão,com bandeiras desfraldadas?»"
,"11":"Desci ao jardim das nogueiras,para ver os rebentos dos vales, para ver se a videira florescia, se os botões das romãzeiras se abriam,"
,"12":"e, sem saber como, vi-me sentada,no carro, com o meu príncipe!"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Vira-te, vira-te, Sulamita, Vira-te, vira-te... queremos contemplar-te!,Sulamita: «Que vedes na Sulamita, quando ela baila entre dois coros?»"
,"2":"O amado: Os seus pés... como são belos nas sandálias, ó filhas de nobres!,As curvas dos seus quadris, que parecem colares, obras de um artista."
,"3":"O seu umbigo... essa taça redonda,onde o vinho nunca falta. O seu ventre, monte de trigo,rodeado de açucenas."
,"4":"Os seus seios, dois filhinhos, filhos gémeos de gazela."
,"5":"O seu pescoço, uma torre de marfim. Os seus olhos, as piscinas de Hesebon,junto às portas de Bat-Rabim. O seu nariz, como a torre do Líbano,voltada para Damasco. A sua cabeça que se alteia como o Carmelo, e os seus cabelos cor de púrpura, prendendo um rei nas tranças."
,"7":"Como és bela, como és formosa, que amor delicioso!"
,"8":"Tens o porte da palmeira, e os teus seios são os cachos."
,"9":"E eu pensei: «Vou subir à palmeira,para colher dos seus frutos!»,Sim, os teus seios são cachos de uva, e o sopro das tuas narinas perfuma,como o aroma das maçãs."
,"10":"A tua boca é um vinho delicioso,que se derrama na minha, molhando-me lábios e dentes."
,"11":"A amada: Eu sou do meu amado, o seu desejo trá-lo para mim."
,"12":"Vem, meu amado, vamos ao campo, vamos pernoitar debaixo dos cedros,"
,"13":"madrugar pelas vinhas. Vamos ver se a vinha floresce, se os botões se estão abrindo, se as romãzeiras estão a florir: aí darei o meu amor..."
,"14":"As mandrágoras exalam o seu perfume; à nossa porta há toda a espécie de frutos: frutos novos, frutos secos, que guardei para ti, meu amado."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quem me dera que fosses meu irmão, amamentado aos seios de minha mãe!,Encontrando-te lá fora, beijar-te-ia, sem ninguém me desprezar."
,"2":"Eu levar-te-ia e far-te-ia entrar,na casa de minha mãe, e tu me iniciarias. Dar-te-ia a beber vinho perfumado,e licor das minhas romãzeiras."
,"3":"A sua mão esquerda,está sob a minha cabeça, e a sua direita abraça-me."
,"4":"O amado: Filhas de Jerusalém, eu vos conjuro: não desperteis, não acordeis o amor, antes que ele o queira!"
,"5":"Quem é esta que sobe do deserto,apoiada no seu amado?,Eu te despertei debaixo da macieira, onde a tua mãe te concebeu, te concebeu e deu à luz."
,"6":"A amada: Grava-me,como selo no teu coração, como selo nos teus braços; pois o amor é forte, é como a morte!,Cruel como o abismo é a paixão. As suas chamas são chamas de fogo, uma faísca de Javé!"
,"7":"As águas da torrente jamais poderão,apagar o amor, nem os rios afogá-lo. Se alguém quisesse dar tudo o que tem,para comprar o amor... seria tratado com desprezo."
,"8":"A nossa irmã é pequenina,e ainda não tem seios. Que faremos à nossa irmãzinha, quando vierem pedi-la?"
,"9":"Se ela é muralha, nela faremos ameias de prata. Se ela é uma porta, nela poremos pranchas de cedro."
,"10":"Eu sou muralha,e os meus seios são torres; aos olhos dele, porém, sou,a mensageira da paz."
,"11":"Salomão tinha uma vinha,em Baal-Hamon: deu a vinha aos rendeiros,e do fruto dela cada um lhe traz,mil moedas de prata."
,"12":"A minha vinha é só minha. Sejam para ti, Salomão, as mil moedas, e duzentas para os que guardam o fruto dela."
,"13":"Ó tu que habitas nos jardins, os meus amigos te ouvem atentos: faz-me ouvir a tua voz!"
,"14":"Foge, meu amado, corre como o gamo, como um filhote de gazela,pelos montes perfumados..."
}`)

}
func PT_BS_LoadVSEEChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Palavras de Coélet, filho de David, rei de Jerusalém."
,"2":"Ó suprema fugacidade, diz coélet, ó suprema fugacidade! tudo é fugaz!"
,"3":"Que proveito tira o homem de todo o trabalho com que se afadiga debaixo do sol?"
,"4":"Geração vai, geração vem, e a Terra permanece sempre a mesma."
,"5":"O Sol levanta-se, o Sol põe-se, voltando depressa para o lugar de onde novamente se levantará."
,"6":"O vento sopra para o Sul, depois gira para o Norte e, girando e girando, vai dando as suas voltas."
,"7":"Todos os rios correm para o mar, e o mar nunca transborda; embora cheguem ao fim do seu percurso, os rios continuam sempre a correr."
,"8":"Toda a explicação fica a meio, pois o homem não consegue terminá-la. O olho não se farta de ver, nem o ouvido se farta de ouvir."
,"9":"O que aconteceu, de novo acontecerá; e o que se fez, de novo será feito: debaixo do Sol não há nenhuma novidade."
,"10":"Às vezes, ouvimos dizer: «Vede, aqui está uma coisa nova!» Mas ela já existiu em outros tempos, muito antes de nós."
,"11":"Ninguém se lembra dos antigos, e aqueles que existem não serão lembrados pelos que virão depois deles."
,"12":"Eu, Coélet, fui rei de Israel em Jerusalém."
,"13":"Resolvi pesquisar e investigar com sabedoria tudo o que acontece debaixo do céu. Esta é uma tarefa penosa que Deus entregou aos homens, para com ela ficarem ocupados."
,"14":"Então examinei as coisas que se fazem debaixo do Sol, e cheguei à conclusão de que tudo é fugaz, uma corrida atrás do vento:"
,"15":"o que é torto, não se pode endireitar; e o que falta não se consegue contar."
,"16":"Pensei e disse a mim mesmo: «Fiquei maior e mais sábio do que todos os que reinaram em Jerusalém antes de mim, e a minha mente adquiriu muita sabedoria e ciência!»"
,"17":"Decidi então conhe-cer a sabedoria e a ciência, assim como a tolice e a loucura. E compreendi que também isso é correr atrás do vento,"
,"18":"porque, onde há muita sabedoria, há também muita tristeza, e onde há mais conhecimento, há também mais sofrimento."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Então pensei:«Vamos! Vou fazer-te experimentar a alegria e conhecer o prazer!» Mas concluí que também isso é fugaz."
,"2":"Do riso, eu disse: «Tolice!» E da alegria: «Para que serve?»"
,"3":"Então decidi entregar-me à bebida, nessa minha busca da sabedoria, e entregar-me à insensatez, para descobrir o que convém ao homem fazer debaixo do céu, no curto tempo da vida."
,"4":"Realizei grandes obras: construí palácios para mim, plantei vinhas,"
,"5":"fiz jardins e pomares com toda a espécie de árvores,"
,"6":"e construí reservatórios de água para regar as árvores do pomar."
,"7":"Comprei escravos e escravas, e tive muitos criados nascidos na minha casa. Possuí muito gado, vacas e ovelhas, mais do que todos os que reinaram em Jerusalém antes de mim."
,"8":"Acumulei prata e ouro, e tesouros de reis e províncias. Arranjei cantores e cantoras e - delícia dos homens - princesas em grande número."
,"9":"Desta forma, fiquei maior e mais poderoso do que todos os que reinaram em Jerusalém antes de mim, conservando sempre a minha sabedoria."
,"10":"Não recusei nada do que os meus olhos pediam, e nunca privei o meu coração de nenhum prazer. Sabia desfrutar de todo o meu trabalho, e em todo o meu trabalho foi esta a minha porção."
,"11":"Então examinei todas as obras que havia feito e o trabalho que me tinham custado. E concluí que tudo é fugaz e uma corrida atrás do vento, e que não há nada de permanente debaixo do Sol."
,"12":"Depois examinei a sabedoria, a tolice e a insensatez, pensando: «Que fará o rei que virá depois de mim?» Fará o que já foi feito."
,"13":"Então percebi que a vantagem da sabedoria sobre a insensatez é a vantagem da luz sobre as trevas."
,"14":"O sábio tem os olhos abertos, e o insensato caminha na escuridão. Mas logo notei que ambos têm o mesmo destino."
,"15":"Então pensei: «Vou ter o mesmo destino que o insensato! Para que me tornei sábio?» E concluí que também isto é fugaz."
,"16":"De facto, a lembrança do sábio desaparece para sempre, como a do insensato. Bem depressa tudo ficará esquecido: o sábio morre da mesma forma que o insensato."
,"17":"Fiquei com ódio da vida, porque tudo o que se faz debaixo do sol me desagradou. Tudo é fugaz, uma corrida atrás do vento."
,"18":"Detesto todo o trabalho com que me afadigo debaixo do Sol, porque devo deixar tudo para o homem que virá depois de mim."
,"19":"E quem sabe se será sábio ou insensato? De qualquer modo, ele será dono de tudo o que eu fiz debaixo do Sol com a minha fadiga e sabedoria. Também isto é fugaz."
,"20":"Então fiquei com o coração desesperado por causa de todo o trabalho com que me afadiguei debaixo do Sol."
,"21":"De facto, há quem trabalhe com sabedoria, conhecimento e sucesso. E depois tem que deixar os seus bens para outro que com nada se afadigou. Também isto é coisa fugaz e grande mal."
,"22":"Então, que proveito resta ao homem de todo o trabalho e esforço mental com que se afadigou debaixo do Sol?"
,"23":"Sim, todos os seus dias são dolorosos, a sua tarefa é penosa, e nem de noite ele pode repousar. Também isso é fugaz!"
,"24":"Vede: a felicidade do homem está em comer e beber, desfrutando o produto do seu trabalho. Contudo, notei que também isto vem das mãos de Deus."
,"25":"De facto, quem pode comer e beber, sem que isto lhe venha de Deus?"
,"26":"A quem Lhe agrada, Deus concede sabedoria, conhecimento e alegria. Mas ao pecador Deus impõe a pena de juntar e acumular para quem agrada a Deus. Mas também isto é fugaz e uma corrida atrás do vento."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Debaixo do céu há momentos para tudo, e tempo certo para cada coisa:"
,"2":"Tempo para nascer e tempo para morrer. Tempo para plantar e tempo para arrancar as plantas."
,"3":"Tempo para matar e tempo para curar. Tempo para destruir e tempo para construir."
,"4":"Tempo para chorar e tempo para rir. Tempo para gemer e tempo para bailar."
,"5":"Tempo para atirar pedras e tempo para apanhar pedras. Tempo para abraçar e tempo para se separar."
,"6":"Tempo para ganhar e tempo para per-der. Tempo para guardar e tempo para deitar fora."
,"7":"Tempo para rasgar e tempo para coser. Tempo para calar e tempo para falar."
,"8":"Tempo para amar e tempo para odiar. Tempo para a guerra e tempo para a paz."
,"9":"Que tira o homem de toda a sua fadiga?"
,"10":"Observei a tarefa que Deus entregou aos homens, para com ela se ocuparem:"
,"11":"tudo o que Ele fez é apropriado para cada tempo. Também colocou o senso da eternidade no coração do homem, mas sem que o homem possa compreender a obra que Deus realiza desde o começo até ao fim."
,"12":"Então compreendi que não existe para o homem nada melhor do que alegrar-se e agir bem durante a vida."
,"13":"E compreendi também que é dom de Deus que o homem possa comer e beber, desfrutando do produto de todo o seu trabalho."
,"14":"Compreendi que tudo o que Deus fez dura para sempre. A isso nada se pode acrescentar, e disso nada se pode tirar. Deus fez assim para ser temido."
,"15":"O que existe, já existia; o que existirá, também já existiu. Deus faz voltar de novo aquilo que já passou."
,"16":"Observei outra coisa debaixo do Sol: Em lugar do direito, encontra-se a injustiça; e, em lugar do justo, encontra-se o injusto."
,"17":"E concluí que o justo e o injusto estão sob o julgamento de Deus, porque existe um tempo para cada coisa e um julgamento para cada acção."
,"18":"Quanto aos homens, penso assim: Deus põe-los à prova, para mostrar que, em si mesmos, são como animais."
,"19":"De facto, o destino do homem e do animal são idênticos: do mesmo modo que morrem estes, morrem também aqueles. Uns e outros têm o mesmo sopro vital, sem que o homem tenha vantagem nenhuma sobre o animal, porque tudo é fugaz."
,"20":"Uns e outros vão para o mesmo lugar: vêm do pó, e voltam para o pó."
,"21":"Quem pode saber se o sopro vital do homem sobe para o alto, e o do animal desce para debaixo da terra?"
,"22":"Percebo que não há nada melhor para o homem do que alegrar-se com as suas obras, porque esta é a porção que lhe cabe. De facto, ninguém lhe fará ver o que acontecerá depois dele."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Examinei também todas as opressões que se cometem debaixo do Sol. Há o choro dos oprimidos, e não há quem os console; ninguém os apoia contra a violência dos seus opressores."
,"2":"Então proclamei os mortos, os que já morreram, mais felizes do que os vivos, os que ainda vivem."
,"3":"Mais feliz que ambos é quem não nasceu ainda, pois não vê todo o mal que se pratica debaixo do Sol."
,"4":"Vi também que todo o trabalho e todo o empenho que o homem põe nas suas obras é fruto de competição recíproca. Isto também é fugaz e uma corrida atrás do vento."
,"5":"O insensato cruza os braços e consome-se."
,"6":"Mais vale uma só mão cheia com lazer, do que as duas mãos cheias com fadiga, correndo atrás do vento."
,"7":"Vi ainda outra coisa vazia debaixo do Sol:"
,"8":"um homem sozinho, que não tem ninguém, nem filhos, nem irmãos. Apesar disso, não deixa de se afadigar, nem de se fartar com riquezas. Para quem se afadiga ele e se priva da felicidade? Isto também é fugaz e trabalho inútil."
,"9":"Mais vale estar a dois do que estar sozinho, porque dois tirarão maior proveito do seu trabalho."
,"10":"De facto, se um cai, poderá ser levantado pelo companheiro. Azar, porém, de quem está sozinho: se cair, não terá ninguém para o levantar."
,"11":"Se dois se deitam juntos, um poderá aquecer o outro; mas como poderá alguém aquecer-se sozinho?"
,"12":"Se um deles for agredido, os dois poderão resistir, e uma corda tripla não rebenta facilmente."
,"13":"Mais vale um jovem pobre e sábio do que um rei velho e insensato, que já não aceita conselho,"
,"14":"mesmo que o jovem tenha saído da prisão para reinar, e ainda que tenha nascido mendigo no reino."
,"15":"Eu vi todos os que se movem debaixo do Sol ficarem com o jovem que sucedeu ao velho rei,"
,"16":"e que passou a chefiar imensa multidão. Contudo, aqueles que vierem depois não ficarão contentes com ele. Também isto é fugaz e uma corrida atrás do vento."
,"17":"Quando fores ao Templo, está bem atento a ti mesmo: é melhor ter ânimo disposto para obedecer, do que oferecer sacrifícios com os insensatos, que não percebem o mal que estão a fazer."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Quando falares com Deus, não sejas precipitado, e o teu coração não se apresse a falar, porque Deus está no Céu, e tu estás na Terra. Por isso, fala pouco."
,"2":"De facto, o sonho vem das muitas ocupações, e do muito falar nasce a voz do insensato."
,"3":"Por isso, quando fizeres uma promessa a Deus, não tardes em cumpri-la, porque Ele não é benévolo com os insensatos. Cumpre o que prometeste."
,"4":"É melhor não fazer uma promessa, do que fazê-la e não cumpri-la."
,"5":"Não deixes que a tua boca te leve ao pecado, nem digas ao representante de Deus que foi sem pensar. Deus ficaria irritado contra o que prometeste, e arruinaria o trabalho das tuas mãos."
,"6":"Quando se multiplicam sonhos e coisas passageiras, ali se multiplicam as palavras. Quanto a ti, teme a Deus."
,"7":"Se vês num Estado a opressão do pobre, o direito e a justiça violados, não te espantes com isso, pois quem está no alto tem sempre outro mais alto que o vigia. E, sobre os dois, há outros mais altos ainda."
,"8":"O interesse do país deve ser considerado no conjunto, e até o rei depende da agricultura."
,"9":"Quem gosta de dinheiro, nunca se sacia de dinheiro. Quem é apegado às riquezas, nunca se farta com o rendimento. Isto também é fugaz."
,"10":"Quando as riquezas aumentam, crescem também aqueles que as devoram. Que vantagem tem o proprietário, além de saber que é rico?"
,"11":"Coma muito ou coma pouco, o sono do trabalhador é agradável, enquanto a fartura do rico não o deixa dormir."
,"12":"Há outro mal doloroso que vejo debaixo do Sol: riquezas que o proprietário acumula para a sua própria desgraça."
,"13":"Num mau negócio, ele perde o património, e o seu filho fica de mãos vazias."
,"14":"Nu saiu do ventre de sua mãe, e assim voltará; e das suas fadigas não ganhará nada para levar consigo."
,"15":"Também isto é um mal doloroso. Ele vai-se embora da mesma forma que veio. Que proveito tirou em se ter afadigado por nada?"
,"16":"Ele consumiu os seus dias em trevas, entre aflições, abatimentos e irritações."
,"17":"Concluí que a felicidade para o homem é comer e beber, usufruindo de toda a fadiga que ele realiza debaixo do Sol, durante os dias de vida que Deus lhe concede. Essa é a sua porção."
,"18":"Todo o homem que recebe de Deus riquezas e bens para que possa sustentar-se, ter a sua porção e desfrutar do seu trabalho, considere isto um dom de Deus."
,"19":"Deste modo, o homem não se preo-cupa demasiado com a sua vida fugaz, porque Deus o mantém ocupado na alegria do coração."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Existe outro mal que observei debaixo do Sol, e é grave para o homem:"
,"2":"A um, Deus concede riquezas, recursos e honras, e nada lhe falta de tudo o que poderia desejar. Deus, porém, não lhe permite desfrutar essas coisas, porque um estrangeiro é que vai desfrutá-las. Isto é coisa fugaz e sofrimento cruel."
,"3":"Mesmo que tivesse tido cem filhos e vivido muitos anos, se não encontrou satisfação nos bens que possuía e nem sequer teve um túmulo, garanto que um aborto é mais feliz do que ele."
,"4":"De facto, o aborto veio inutilmente e foi-se para as trevas, e as trevas sepultaram o seu nome."
,"5":"Não viu o Sol nem o conheceu, mas a sua sorte é sempre melhor do que a do outro."
,"6":"E mesmo que o outro pudesse viver dois mil anos, mas sem poder usufruir dos bens, não iria para o mesmo lugar que o aborto?"
,"7":"Todo o trabalho do homem é para comer e, no entanto, o seu apetite nunca fica satisfeito."
,"8":"Que vantagem tem o sábio a mais que o insensato? Que vantagem tem o pobre em saber comportar-se bem na sociedade?"
,"9":"É melhor ver com os próprios olhos do que agitar-se em desejos. Isto também é fugaz e uma corrida atrás do vento."
,"10":"O que existe, já recebeu um nome há muito tempo, e sabemos o que é um homem: não pode lutar com quem é mais forte do que ele."
,"11":"Muitas palavras aumentam a desilusão. E que vantagem tira o homem disso?"
,"12":"Quem sabe o que convém ao homem durante a vida, nos breves dias da sua vida passageira, na qual ele passa como sombra? Quem poderá dizer ao homem o que vai acontecer depois dele debaixo do Sol?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Mais vale a honradez do que um bom perfume, e o dia da morte é melhor que o dia do nascimento."
,"2":"É melhor ir a uma casa onde há luto do que ir a uma casa onde se faz festa, pois aquele é o fim de todo o homem e faz, desse modo, reflectir os vivos."
,"3":"É melhor a tristeza do que o riso, porque, debaixo de um rosto triste, o coração pode estar alegre."
,"4":"O pensamento do sábio está na casa onde há luto, mas o pensamento do insensato está na casa onde se faz festa."
,"5":"É melhor ouvir a repreensão do sábio do que o elogio dos insensatos,"
,"6":"porque assim como crepita o fogo debaixo da caldeira, tal é o riso do insensato. Isto também é fugaz,"
,"7":"porque a extorsão torna insensato o sábio, e o suborno corrompe-lhe o discernimento."
,"8":"Mais vale o fim de uma coisa do que o seu começo, e a paciência é melhor do que a pretensão."
,"9":"Não te irrites facilmente, porque a irritação abriga-se no peito dos insensatos."
,"10":"Não digas: «Porque é que os tempos passados eram melhores que os de hoje?» Não é a sabedoria que te faz levantar essa questão."
,"11":"A sabedoria é boa como uma herança, e útil para aqueles que vêem o Sol,"
,"12":"pois vive-se à sombra da sabedoria como se vive à sombra do dinheiro. Mas a sabedoria é mais vantajosa, porque faz viver quem a possui."
,"13":"Procura compreender a obra de Deus, porque ninguém endireita o que Ele encurvou."
,"14":"Sê alegre no dia feliz, e no dia da desgraça procura reflectir, porque um e outro foram feitos por Deus, para que o homem nunca possa descobrir nada do seu próprio futuro."
,"15":"Já vi de tudo nos dias da minha existência fugaz. Vi o justo perecer apesar da sua justiça, e o injusto viver longamente apesar da sua injustiça."
,"16":"Não sejas demasiadamente justo, nem te tornes sábio de mais. Para quê arruinares-te?"
,"17":"Não sejas demasiadamente injusto, nem te tornes insensato. Para quê irias morrer antes do tempo?"
,"18":"É bom que te apegues a uma coisa, sem abandonar a outra: o importante é que temas a Deus, e sair-te-ás bem numa e noutra coisa."
,"19":"A sabedoria torna o sábio mais forte do que dez chefes numa cidade."
,"20":"Não existe na Terra homem tão justo que faça o bem sem nunca pecar."
,"21":"Além disso, não dês atenção a tudo o que se diz, e assim não ouvirás o teu servo falar mal de ti."
,"22":"De facto, a tua própria consciência sabe que muitas vezes também falaste mal dos outros."
,"23":"Examinei tudo isto com sabedoria, e pensei: «Vou tornar-me sábio». Mas a sabedoria estava longe de mim."
,"24":"A realidade está longe e é extremamente profunda. Quem poderá atingi-la?"
,"25":"Apliquei-me de novo a conhecer, a raciocinar e a pesquisar a sabedoria e a interpretação das coisas, fazendo experiência do mal, da insensatez, da tolice e da lou-cura."
,"26":"Então descobri que a mulher é mais amarga do que a morte, porque é uma armadilha, o seu coração é uma rede e os seus braços são cadeias. Quem agrada a Deus, conseguirá fugir dela, mas o pecador será apanhado por ela."
,"27":"Eis o que encontrei, diz Coélet, depois de ter comparado uma coisa com outra, até chegar a uma conclusão:"
,"28":"Pesquisei muito, e nada concluí. Entre mil, consegui encontrar um homem, mas entre as mulheres não encontrei nenhuma."
,"29":"E cheguei à seguinte conclusão: Deus fez o homem recto, mas o homem inventa muitas complicações."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Quem é como o sábio? Quem conhece a interpretação das coisas como ele? A sabedoria do homem alegra-lhe o rosto e abranda-lhe a dureza da face."
,"2":"Obedece às ordens do rei e, por causa do juramento feito a Deus,"
,"3":"não te apresses em te afastar dele, nem persistas no mal, porque o rei pode fazer o que quer."
,"4":"De facto, a palavra do rei é soberana, e ninguém lhe pode perguntar: «Que fazes tu?»"
,"5":"Quem obedece às ordens, não incorre em pena alguma. A mente do sábio conhece o tempo e o julgamento,"
,"6":"porque para cada coisa há um tempo e um julgamento. Sobre o homem pesa um grande mal:"
,"7":"ninguém sabe qual será o seu futuro. De facto, quem pode saber o que vai acontecer?"
,"8":"Ninguém é capaz de dominar a sua própria respiração: o dia da morte está fora do nosso domínio. Da luta na vida ninguém pode fugir; nem a maldade salva aquele que a comete."
,"9":"Vi tudo isto, e reflecti sobre todas as coisas que se fazem debaixo do Sol, num tempo em que um homem domina outro homem para o arruinar."
,"10":"Vi também os injustos receberem sepultura e entrarem no repouso, enquanto que os frequentadores do lugar santo ficavam esquecidos na cidade, onde tinham feito o bem. Isso também é fugaz."
,"11":"Por não se executar imediatamente a sentença contra quem praticou o mal, o coração dos homens está sempre inclinado a praticar o mal."
,"12":"O pecador sobrevive, mesmo que cometa cem vezes o mal. Mas eu sei também que a felicidade é para os que temem a Deus e se enchem de respeito na sua presença."
,"13":"Não haverá nenhuma felicidade para o injusto e ele não poderá alongar os dias como a sombra, porque não teme a Deus."
,"14":"Existe ainda outra desilusão: justos que são tratados como se fossem injustos, e injustos que são tratados como se fossem justos. Penso que também isto é coisa fugaz."
,"15":"Por isso eu exalto a alegria, porque não existe felicidade para o homem debaixo do sol, além do comer, beber e alegrar-se. Esta é a única coisa que lhe serve de companhia na fadiga, nos dias de vida que Deus lhe concede debaixo do Sol."
,"16":"Apliquei-me a conhecer a sabedoria e a considerar a fadiga que se realiza sobre a Terra, pois o homem não conhece repouso, nem de dia, nem de noite."
,"17":"Observei o conjunto da obra de Deus e percebi que o homem não consegue descobrir tudo o que acontece debaixo do Sol. Por mais que o homem se afadigue em pesquisar, não chega a compreendê-la. E mesmo que o sábio diga que a conhece, nem por isso é capaz de a entender."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Reflecti sobre tudo isto e compreendi que os justos, os sábios e suas acções estão nas mãos de Deus. O homem não conhece nem sequer o amor e o ódio, embora tudo isto se desenvolva diante dele."
,"2":"Todos têm o mesmo destino, tanto o justo como o injusto, o bom e o mau, o puro e o impuro, quem sacrifica e quem não sacrifica. O bom é tal qual o pecador, e quem jura é igual a quem evita o juramento."
,"3":"O mal que existe em tudo o que se faz debaixo do Sol é o facto de todos terem o mesmo destino. Além disso, o coração dos homens está cheio de maldade, e a insensatez abriga-se no seu coração durante todo o tempo que vivem. Depois vão para a habitação dos mortos."
,"4":"Enquanto alguém está vivo, ainda há esperança, porque é melhor um cão vivo do que um leão morto."
,"5":"Os vivos sabem que devem morrer, mas os mortos não sabem nada, nem terão recompensa, porque a sua lembrança cairá no esquecimento."
,"6":"O seu amor, ódio e ciúme desaparecem juntamente com eles e nunca mais participarão em nada do que se faz debaixo do Sol."
,"7":"Portanto, vai, come o teu pão com alegria e bebe o teu vinho com satisfação, porque com isso Deus já foi bondoso para contigo."
,"8":"Que as tuas vestes sejam sempre brancas, e nunca falte perfume na tua cabeça."
,"9":"Goza a vida com a esposa que amas, durante todos os dias da vida fugaz que Deus te concede debaixo do Sol. Esta é a porção que te cabe na vida e no trabalho com que te afadigas debaixo do Sol."
,"10":"Tudo o que puderes fazer, fá-lo enquanto tens forças, porque no mundo dos mortos, para onde vais, não existe acção, nem pensamento, nem ciência, nem sabedoria."
,"11":"Observei outra coisa debaixo do Sol: Não é o mais veloz que ganha a corrida, nem é o mais forte que vence na batalha. O pão não é para os mais sábios, nem as riquezas para os mais inteligentes, nem o favor para os mais cultos, porque tudo depende do tempo e do acaso."
,"12":"Além disso, o homem não conhece o dia da própria morte: ele é como os peixes, que são apanhados na rede, ou como os pássaros que caem na armadilha. Da mesma forma, o homem é surpreendido pela desgraça que cai sobre ele de improviso."
,"13":"Também vi debaixo do Sol este exemplo de sabedoria que me pareceu muito importante:"
,"14":"Havia uma pequena cidade com poucos habitantes. Um grande rei foi contra ela, cercou-a, e levantou contra ela máquinas de guerra."
,"15":"Nela encontrou-se um homem, de origem pobre, mas sábio. Com a sua sabedoria ele salvou a cidade. Contudo, ninguém mais se lembrou desse homem pobre."
,"16":"Por isso, concluo que a sabedoria vale mais do que a força, porém a sabedoria do pobre é desprezada, e ninguém dá ouvidos às suas palavras."
,"17":"As palavras calmas de sábios são mais ouvidas do que os gritos de um poderoso, que fala no meio dos insensatos."
,"18":"Mais vale a sabedoria do que os instrumentos de guerra, mas um só erro pode anular muita coisa boa."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Uma mosca morta estraga um frasco de perfume, e um pouco de insensatez pesa mais do que a sabedoria e a honra."
,"2":"O sábio orienta-se bem, mas o insensato perde-se."
,"3":"Quando o insensato anda pelo caminho, falta-lhe inteligência e pensa que os outros também são insensatos."
,"4":"Se a ira de um poderoso se levanta contra ti, não saias do lugar, porque a calma aplaca grandes erros."
,"5":"Vi outro mal debaixo do Sol, um erro cometido pelo soberano:"
,"6":"o insensato ocupa os mais altos cargos e os homens de valor estão colocados em postos inferiores."
,"7":"Vi escravos a cavalo, e príncipes andarem a pé, como se fossem escravos."
,"8":"Quem abre uma cova, nela cairá. Quem derruba um muro, uma cobra o morderá."
,"9":"Quem transporta pedras, com elas se magoará, e quem racha lenha, corre perigo."
,"10":"Se o machado está rombo e não for afiado, será preciso muita força; é mais vantajoso usar a sabedoria."
,"11":"Se a cobra não encantada morde o encantador, este não ganha nada."
,"12":"As palavras do sábio favorecem-no, mas as palavras do insensato provocam a sua própria ruína."
,"13":"Se o início das palavras do insensato já é insensatez, o fim do seu discurso será tolice perversa."
,"14":"O insensato multiplica as palavras, embora o homem não saiba o que vai suceder, porque ninguém lhe pode dizer o que vai acontecer no futuro."
,"15":"O trabalho do insensato causa-lhe fadiga, pois nem sabe ir à cidade."
,"16":"Ai de ti, país governado por um jovem, e cujos príncipes se banqueteiam desde o amanhecer."
,"17":"Feliz de ti, país governado por um rei nobre, e cujos príncipes comem à hora conveniente para se refazerem, e não para se banquetearem."
,"18":"Pela preguiça das mãos, o tecto desaba; e por causa de braços frouxos, chove em casa."
,"19":"Para se divertirem, fazem banquetes, e o vinho alegra a vida: o dinheiro providencia tudo."
,"20":"Não digas mal do rei, nem mesmo em pensamento, e não digas mal do poderoso, nem dentro do teu próprio quarto: um passarinho poderá ouvir, e um ser alado qualquer poderia contar o que disseste."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Atira o teu pão para a água, porque dias depois o encontrarás."
,"2":"Reparte com sete e até mesmo com oito, pois não sabes que desgraças te poderão acontecer na Terra."
,"3":"Quando as nuvens estão cheias, derramam chuva sobre a Terra. Se uma árvore cai, seja para o Sul, seja para o Norte, no lugar onde cair, aí ficará."
,"4":"Quem fica a olhar para o vento, nunca semeará; quem fica a olhar para as nuvens, jamais colherá."
,"5":"Assim como ignoras o caminho por onde o sopro de vida entra nos ossos, dentro do ventre da mulher grávida, assim também ignoras a obra de Deus, que fez todas as coisas."
,"6":"De manhã, semeia a tua semente, e de tarde não dês descanso à tua mão, porque não sabes qual das sementes irá brotar, se esta ou aquela, ou se ambas serão boas."
,"7":"Doce é a luz, e agradável para os olhos ver o sol."
,"8":"Se um homem viver muitos anos, procure desfrutar de todos eles; mas lembre-se dos dias sombrios, que serão muitos, pois tudo o que acontece é fugaz."
,"9":"Jovem, alegra-te na tua juventude e sê feliz nos dias da mocidade. Segue os impulsos do teu coração e os desejos dos olhos. Contudo, sabe que Deus te vai pedir contas de todas estas coisas."
,"10":"Expulsa a melancolia do teu coração e afasta do teu corpo a dor, porque a juventude e os cabelos negros são fugazes."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Lembra-te do teu Criador, nos dias da mocidade, antes que venham os dias tristes e cheguem os anos em que dirás: «Já não sinto prazer em nada»;"
,"2":"antes que se escureçam o Sol e a luz, a Lua e as estrelas, e antes que voltem as nuvens depois da chuva;"
,"3":"no dia em que os guardas da casa tremerem e os homens fortes se curvarem, quando as mulheres, uma a uma, deixarem de moer, e cair a escuridão sobre aquelas que olham pelas janelas;"
,"4":"quando se fechar a porta da rua e diminuir o barulho do moinho; quando se acordar com o canto dos passarinhos, e todas as canções emudecerem;"
,"5":"quando se ficar com medo das alturas, e se apanhar sustos pelo caminho. Quando a amendoeira estiver em flor, o gafanhoto ficar pesado, e o tempero perder o sabor: é porque o homem já está a caminho da sua morada eterna, e os que choram a sua morte já começam a percorrer as ruas."
,"6":"Antes que o fio de prata se rompa e a taça de ouro se parta, antes que a bilha se quebre na fonte e a roldana rebente no poço."
,"7":"Então o pó volta para a terra de onde veio, e o sopro vital retorna para Deus que o concedeu."
,"8":"Ó suprema fugacidade, diz Coélet, tudo é fugaz."
,"9":"Além de sábio, Coélet também ensinou a ciência ao povo. Ele ponderou, examinou e corrigiu muitos provérbios."
,"10":"Coélet procurou encontrar palavras agradáveis, e escrever com propriedade palavras verdadeiras."
,"11":"As palavras dos sábios são como ferrões, e as sentenças reunidas são como estacas fincadas. Umas e outras provêm do mesmo pastor."
,"12":"Além disso, meu filho, presta atenção: escrever livros é um trabalho sem fim, e muito estudo cansa o corpo."
,"13":"Fim do discurso. De tudo o que se ouviu o resumo é este: Teme a Deus e observa os seus mandamentos, porque esse é o dever de todo o homem."
,"14":"Deus julgará toda a obra, até mesmo a que estiver escondida, quer seja boa, quer seja má."
}`)

}
func PT_BS_LoadVSEIChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Toda a sabedoria vem do Senhor e está com Ele para sempre."
,"2":"Quem poderá contar a areia das praias, as gotas da chuva e os dias do mundo?"
,"3":"Quem poderá explorar a altura do céu, a extensão da terra e a profundidade do abismo?"
,"4":"A sabedoria foi criada antes de todas as coisas, e a inteligência prudente foi criada antes dos séculos."
,"5":"A quem foi revelada a raiz da sabedoria? Quem conhece os seus projectos?"
,"6":"Só um é sábio e sumamente terrível quando Se senta no seu trono:"
,"7":"é o Senhor, Ele que criou a sabedoria, a conheceu, a enumerou e a derramou sobre todas as suas obras."
,"8":"Ele repartiu-a entre os seres vivos, conforme a sua generosidade, e concedeu-a a todos aqueles que O amam."
,"9":"O temor do Senhor é glória e honra, alegria e coroa de júbilo."
,"10":"O temor do Senhor alegra o coração, dá contentamento, gozo e vida longa."
,"11":"Quem teme o Senhor acabará bem, e será abençoado no dia da morte."
,"12":"O princípio da sabedoria é temer ao Senhor, e os fiéis recebem-na já no seio materno."
,"13":"Ela firma-se entre os homens com alicerce perene, e permanece com os seus descendentes."
,"14":"A plenitude da sabedoria é temer o Senhor e, com os seus frutos, ela embriaga os homens."
,"15":"Ela enche a sua casa com tesouros, e os celeiros com os seus produtos."
,"16":"A coroa da sabedoria é o temer o Senhor, ela faz florescer a paz e a saúde."
,"17":"Deus viu e enumerou a sabedoria, fazendo chover a ciência e a inteligência, e exaltando a honra daqueles que a possuem."
,"18":"A raiz da sabedoria é temer o Senhor, os seus ramos são de vida longa."
,"19":"A irritação injusta não se poderá justificar, porque o ímpeto da paixão provoca ruína."
,"20":"O homem paciente resiste até ao momento oportuno, depois será recompensado com a alegria."
,"21":"Até ao momento certo, esconde o que pensa, e muitos elogiarão a sua inteligência."
,"22":"Os provérbios instrutivos são o tesouro da sabedoria, mas o pecador detesta a religião."
,"23":"Se desejas ter sabedoria, observa os mandamentos, e então o Senhor ta concederá."
,"24":"O temor do Senhor é sabedoria e educação, e compraz-se na fidelidade e na mansidão."
,"25":"Não sejas desobediente ao temor do Senhor, e não te aproximes d'Ele de coração fingido."
,"26":"Não sejas hipócrita no trato com os homens, e controla as tuas palavras."
,"27":"Não te eleves, para não caíres, atraindo a vergonha sobre ti mesmo,"
,"28":"porque o Senhor descobrirá o que escondes e humilhar-te-á no meio da assembleia,"
,"29":"porque não procuraste o temor do Senhor e mantiveste o coração cheio de falsidade."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Meu filho, se te apresentares para servir o Senhor, prepara-te para a provação."
,"2":"Procura ter um coração recto, sê constante e não te desvies no tempo da adversidade."
,"3":"Une-te ao Senhor e não te separes d'Ele, para que no último dia sejas exaltado."
,"4":"Aceita tudo o que te acontecer, e sê paciente nas situações dolorosas,"
,"5":"porque o ouro é provado no fogo e as pessoas escolhidas no forno da humilhação."
,"6":"Confia no Senhor, e Ele te ajudará; que seja recto o teu caminho, e espera no Senhor."
,"7":"Vós que temeis o Senhor, confiai na sua misericórdia, e não vos desvieis, para não cairdes."
,"8":"Vós que temeis o Senhor, confiai n'Ele, que não vos negará a vossa recompensa."
,"9":"Vós que temeis o Senhor, esperai d'Ele os benefícios, a felicidade eterna e a misericórdia."
,"10":"Examinai a História, e vereis. Quem confiou no Senhor, e ficou desiludido? Quem perseverou no seu temor, e foi abandonado? Quem O invocou, e não foi atendido?"
,"11":"Porque o Senhor é compassivo e misericordioso, perdoa os pecados e salva no tempo do perigo."
,"12":"Ai dos corações covardes e mãos preguiçosas, ai do pecador que vive na duplicidade!"
,"13":"Ai do coração preguiçoso que não confia, porque não será protegido!"
,"14":"Ai de vós que perdestes a paciência! Que fareis quando o Senhor vos pedir contas?"
,"15":"Os que temem o Senhor não desobedecem às suas palavras, e aqueles que O amam observam os seus caminhos."
,"16":"Os que temem o Senhor procuram agradar-Lhe, e aqueles que O amam cumprem a Lei."
,"17":"Os que temem o Senhor preparam os seus corações, e humilham-se na sua presença."
,"18":"Cada um de nós coloque-se nas mãos do Senhor, e não nas mãos dos homens, pois a sua misericórdia é como a sua grandeza."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Escutai-me, filhos, porque sou o vosso pai. Fazei o que vos digo, e sereis salvos."
,"2":"O Senhor quer que o pai seja honrado pelos filhos, e confirma a autoridade da mãe sobre os filhos."
,"3":"Quem honra o próprio pai alcança o perdão dos pecados,"
,"4":"e quem respeita a sua mãe é como quem junta um tesouro."
,"5":"Quem honra seu pai será respeitado pelos seus próprios filhos, e quando rezar será atendido."
,"6":"Quem honra seu pai terá vida longa, e quem obedece ao Senhor dará alegria a sua mãe."
,"7":"Quem teme o Senhor honra seus pais, e serve-os como se fossem seus patrões."
,"8":"Honra teu pai com acções e palavras, para que desça sobre ti a sua bênção."
,"9":"A bênção do pai consolida a casa dos filhos, mas a mal-dição da mãe arranca os alicerces."
,"10":"Não te vanglories com a desonra de teu pai, porque não conseguirás honra nenhuma com a desonra de teu pai."
,"11":"Pois a glória do homem está na honra de teu pai, e a desonra da mãe é vergonha para os filhos."
,"12":"Meu filho, cuida de teu pai na velhice, e não o abandones enquanto ele viver."
,"13":"Mesmo que fique caduco, sê compreensivo e não o desprezes, enquanto estás em pleno vigor,"
,"14":"pois a caridade feita ao pai não será esquecida, e valerá como reparação pelos pecados que tiveres cometido."
,"15":"No dia do perigo, o Senhor lembrar-Se-á de ti, e os teus pecados derreter-se-ão como a geada ao sol."
,"16":"Quem despreza seu pai é um blasfemador, e quem irrita sua mãe será amaldiçoado pelo Senhor."
,"17":"Meu filho, sê modesto na tua actividade, e serás mais estimado que um homem generoso."
,"18":"Quanto mais importante fores, mais humilde deverás ser, e encontrarás favor diante do Senhor."
,"19":"Pois, o poder do Senhor é grande,"
,"20":"mas Ele é glorificado pelos humildes."
,"21":"Não procures o que é demasiado difícil para ti, e não investigues coisas que superam as tuas forças."
,"22":"Empenha-te naquilo que te foi ordenado, e não te ocupes de coisas misteriosas."
,"23":"Não te apliques em coisas que superam a tua capacidade, porque já te foi mostrado mais do que a inteligência humana pode compreender."
,"24":"Muitos perderam-se devido às suas especulações e extraviaram-se por causa das suas ilusões perversas."
,"25":"Um coração obstinado acabará mal, e quem ama o perigo nele cairá."
,"26":"Um coração obstinado acumula sofrimentos, e o pecador vai amontoando pecado sobre pecado."
,"27":"A desgraça não cura o soberbo, porque a planta do mal criou raízes nele."
,"28":"A mente sábia medita a parábola, e o sábio deseja ter ouvido atento."
,"29":"A água apaga o fogo, e a esmola apaga os pecados."
,"30":"Quem retribui com o bem armazena para o futuro, e no tempo da sua queda encontrará apoio."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Meu filho, não recuses ajudar o pobre, e não sejas insensível ao olhar dos necessitados."
,"2":"Não faças sofrer aquele que tem fome, e não piores a situação de quem está em dificuldade."
,"3":"Não perturbes mais ainda quem já está desesperado, e não te negues a dar alguma coisa ao necessitado."
,"4":"Não rejeites a súplica de um pobre, e não desvies do indigente o teu olhar."
,"5":"Não desvies o olhar daquele que te pede alguma coisa, e não dês ocasião a que alguém te amaldiçoe,"
,"6":"porque se uma pessoa amaldiçoa com amargura, o Criador atenderá o seu pedido."
,"7":"Sê simpático para com a comunidade, e diante de um ancião baixa a cabeça."
,"8":"Inclina o ouvido ao pobre e responde com delicadeza à sua saudação."
,"9":"Arranca o oprimido do poder do opressor, e não sejas covarde em fazer justiça."
,"10":"Sê como um pai para os órfãos e como um marido para as viúvas. Deste modo, serás como um filho do Altíssimo, e o Altíssimo te amará mais do que a tua própria mãe."
,"11":"A sabedoria educa os seus filhos e cuida daqueles que a procuram."
,"12":"Quem lhe tem amor, ama a vida, e os que madrugam para a procurar, ficarão cheios de alegria."
,"13":"Quem a possui, terá como herança a honra, e aonde quer que vá, o Senhor o abençoará."
,"14":"Aqueles que a servem prestam culto ao Santo, e o Senhor ama aqueles que a amam."
,"15":"Quem a escuta, julga com justiça, e quem lhe dá atenção viverá tranquilo."
,"16":"Quem nela confia, recebê-la-á como herança, e os seus descendentes conservá-la-ão como propriedade."
,"17":"Primeiro, ela conduzi-lo-á por caminhos tortuosos, causando-lhe medo e tremor, e atormentá-lo-á com a sua disciplina, até que o homem confie nela e até que ela o tenha provado com as suas exigências."
,"18":"Depois, reconduzi-lo-á pelo caminho recto, alegrá-lo-á e manifestar-lhe-á os seus segredos."
,"19":"Se ele se desviar, ela abandoná-lo-á e entregá-lo-á ao sabor do próprio destino."
,"20":"Observa as circunstâncias, mas guarda-te do mal e não te envergonhes de ti mesmo."
,"21":"Há uma vergonha que conduz ao pecado, e há uma vergonha que traz honra e graça."
,"22":"Não sejas muito severo para contigo mesmo, e não te envergonhes do teu erro."
,"23":"Não deixes de falar no momento oportuno, e não escondas a tua sabedoria,"
,"24":"porque é pelo falar que se reconhece a sabedoria, e é pela palavra que se percebe a instrução."
,"25":"Não contradigas a verdade, mas envergonha-te da tua própria ignorância."
,"26":"Não te envergonhes de confessar os próprios pecados, e não te oponhas à corrente de um rio."
,"27":"Não te submetas a um insensato, e não sejas parcial em favor de um poderoso."
,"28":"Luta até à morte pela verdade, e o Senhor Deus combaterá por ti."
,"29":"Não sejas arrogante no falar, nem preguiçoso e covarde no agir."
,"30":"Não sejas um leão para a tua família, nem suspeites dos teus dependentes."
,"31":"Não tenhas a mão aberta para receber e fechada para dar."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Não confies nas tuas riquezas, nem digas: «Elas resolvem tudo»."
,"2":"Não sigas o teu instinto nem a tua força, para satisfazer os teus caprichos."
,"3":"Não digas: «Quem me poderá dominar?» Porque o Senhor castiga, e castigar-te-á."
,"4":"Não digas: «Pequei, e nada me aconteceu», pois o Senhor é paciente."
,"5":"Não fiques muito seguro do perdão, a ponto de amontoar pecados."
,"6":"Não digas: «A misericórdia de Deus é grande, e Ele perdoar-me-á todos os meus pecados». Porque Ele tem compaixão e cólera, e a sua ira cairá sobre os pecadores."
,"7":"Não tardes em te converter ao Senhor, e não fiques adiando de um dia para outro, porque a ira do Senhor virá de repente, e perecerás no dia do castigo."
,"8":"Não confies nas riquezas injustas, porque elas não te ajudarão no dia da desgraça."
,"9":"Não limpes o trigo com qualquer vento, nem sigas qualquer direcção."
,"10":"Sê constante no modo de pensar e coerente na maneira de falar."
,"11":"Sê atento para ouvir e lento para responder."
,"12":"Se fores capaz, responde ao teu próximo; se não fores, fica calado."
,"13":"Falar pode trazer honra ou desonra, e a língua do homem é a sua ruína."
,"14":"Não tenhas fama de caluniador, nem uses a língua para preparar armadilhas, porque para o ladrão existe a vergonha, e para o homem falso uma condenação severa."
,"15":"Evita erros grandes e pequenos, e de amigo não te transformes em inimigo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"A má fama atrai a vergonha e o desprezo, e esta é a sorte do pecador que não tem palavra."
,"2":"Não sejas vítima da tua própria paixão, para que ela não te despedace como touro furioso."
,"3":"Ela poderá devorar-te as folhas e fazer-te perder os frutos, deixando-te como árvore seca."
,"4":"A paixão violenta destrói quem a possui e transforma-o em zombaria diante dos inimigos."
,"5":"Palavras afáveis aumentam os amigos, e linguagem amável encontra acolhimento."
,"6":"Podes ter muitos conhecidos, mas um só confidente entre mil."
,"7":"Se quiseres um amigo, põe-no à prova, e não confies nele tão depressa."
,"8":"Porque há amigos de ocasião, que não serão fiéis quando estiveres em dificuldade."
,"9":"Há amigo que se transforma em inimigo, e te envergonhará, revelando as tuas fraquezas."
,"10":"Há amigo que é companheiro de mesa, mas que não será fiel quando estiveres na desgraça."
,"11":"Quando tudo correr bem, estará contigo, mas quando as coisas te correrem mal, afastar-se-á de ti."
,"12":"Se fores apanhado pela desgraça, volta-te as costas e esconder-se-á de ti."
,"13":"Afasta-te daqueles que são teus inimigos e sê cauteloso com os amigos."
,"14":"Amigo fiel é protecção poderosa, e quem o encontrar, terá encontrado um tesouro."
,"15":"Amigo fiel não tem preço, e o seu valor é incalculável."
,"16":"Amigo fiel é remédio que cura, e os que temem o Senhor encontrá-lo-ão."
,"17":"Quem teme ao Senhor tem amigos verdadeiros, pois tal e qual ele é, assim será o seu amigo."
,"18":"Meu filho, empenha-te na disciplina desde a juventude, e adquirirás sabedoria que durará até à velhice."
,"19":"Aproxima-te dela como quem lavra e semeia, e espera pelos seus frutos saborosos. Terás um pouco de trabalho para a cultivar, mas logo comerás dos seus frutos."
,"20":"Para os insensatos, ela é penosa, e quem não tem bom senso desistirá dela."
,"21":"Ele considera-a pesada como pedra, e logo se desfará dela."
,"22":"A sabedoria merece o nome que tem, pois não se manifesta a muitas pessoas."
,"23":"Escuta, meu filho, aceita a minha opinião e não rejeites o meu conselho."
,"24":"Coloca os pés nos seus grilhões e o pescoço debaixo do seu jugo."
,"25":"Inclina o ombro e carrega-a, sem te irritares com as suas amarras."
,"26":"Aproxima-te dela com alma aberta, e segue-lhe os caminhos com todas as forças."
,"27":"Procura as suas pegadas, e ela se te manifestará. Uma vez possuída, nunca mais a deixes."
,"28":"No fim, encontrarás nela o repouso, e ela transformar-se-á em alegria para ti."
,"29":"Os seus grilhões serão para ti uma poderosa protecção, e o seu jugo um enfeite precioso."
,"30":"O seu jugo será ornamento de ouro e os seus grilhões fitas de púrpura."
,"31":"Vesti-la-ás com um manto de glória, e cingi-la-ás como diadema de alegria."
,"32":"Se quiseres, meu filho, ficarás instruído e, se te empenhares, tornar-te-ás hábil."
,"33":"Se gostas de escutar, aprenderás; e se deres ouvidos, tornar-te-ás sábio."
,"34":"Frequenta a companhia dos anciãos e apega-te a quem for sábio."
,"35":"Escuta de boa vontade toda a palavra divina, e não te descuides das máximas sábias."
,"36":"Se encontrares um homem sábio, madruga para ir visitá-lo, e que os teus pés gastem a soleira da sua porta."
,"37":"Reflecte sobre os preceitos do Senhor e medita sem cessar nos seus mandamentos. Então Ele fortificará a tua inteligência, e o teu desejo de sabedoria ficará saciado."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Não pratiques o mal, e o mal não te acontecerá."
,"2":"Afasta-te da injustiça, e ela afastar-se-á de ti."
,"3":"Meu filho, não semeies nos sulcos da injustiça, e não a recolherás sete vezes mais."
,"4":"Não peças ao Senhor o poder, nem ao rei um lugar de honra."
,"5":"Não pretendas ser justo diante do Senhor, nem sábio diante do rei."
,"6":"Não procures tornar-te juiz, se não tiveres força para eliminar a injustiça. De contrário, terias medo diante de um poderoso e mancharias a tua própria integridade."
,"7":"Não ofendas a assembleia da cidade, para não te tornares inimigo do povo."
,"8":"Não repitas duas vezes o mesmo pecado, porque basta uma vez para te tornares culpado."
,"9":"Não digas: «Deus levará em conta as minhas numerosas ofertas, e quando eu as oferecer ao Deus Altíssimo, Ele as aceitará»."
,"10":"Não sejas vacilante na oração, nem deixes de dar esmola."
,"11":"Não zombes de um homem desesperado, porque existe Alguém que humilha e exalta."
,"12":"Não planeies mentiras contra o teu irmão, nem algo semelhante contra um amigo."
,"13":"Não queiras mentir de modo nenhum, porque as consequências nunca são boas."
,"14":"Não fales de mais na assembleia dos anciãos, e não repitas palavras na oração."
,"15":"Não desprezes o trabalho pesado, nem o trabalho rural, criado pelo Altíssimo."
,"16":"Não te juntes à multidão dos pecadores. Lembra-te: a cólera divina não tardará."
,"17":"Humilha-te profundamente, porque o castigo do injusto é fogo e vermes."
,"18":"Não troques um amigo por dinheiro, nem o irmão fiel pelo ouro mais precioso."
,"19":"Não desprezes uma esposa sábia e boa, porque a bondade dela vale mais que o ouro."
,"20":"Não maltrates o empregado que trabalha fielmente, nem o assalariado que se sacrifica."
,"21":"Ama como a ti mesmo o empregado inteligente, e não lhe recuses a liberdade."
,"22":"Possuis animais? Cuida deles. Se te são úteis, conserva-os."
,"23":"Tens filhos? Educa-os e ensina-os a obedecer desde a infância."
,"24":"Tens filhas? Cuida da integridade dos seus corpos, e não sejas indulgente com elas."
,"25":"Casa a tua filha, e terás realizado uma grande tarefa, dando-a a um homem sensato."
,"26":"Amas a tua esposa? Não te separes dela. Se não a amas, não confies nela."
,"27":"Honra teu pai de todo o coração, e não esqueças as dores da tua mãe."
,"28":"Lembra-te de que eles te geraram. O que lhes darás em troca de tudo o que eles te deram?"
,"29":"Teme ao Senhor de todo coração e respeita os seus sacerdotes."
,"30":"Ama com todas as forças Aquele que te criou, e não abandones os seus ministros."
,"31":"Teme ao Senhor e honra o sacerdote, dando-lhe a parte que lhe cabe, como te foi ordenado: os primeiros frutos, os sacrifícios pelo pecado, a oferta das espáduas, o sacrifício de santificação e os primeiros frutos das coisas consagradas."
,"32":"Estende a mão ao pobre, e serás plenamente abençoado."
,"33":"Que a tua generosidade se estenda a todos os seres vivos, e não negues a tua atenção aos mortos."
,"34":"Não evites aqueles que choram, e sofre com os que sofrem."
,"35":"Não tardes em visitar um doente, porque assim atrairás a sua amizade."
,"36":"Em tudo o que fazes, lembra-te do teu fim, e jamais pecarás."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Não processes nenhum homem poderoso, para não lhe caíres nas mãos."
,"2":"Não litigues com um homem rico, para que ele não ponha o peso do seu dinheiro contra ti, pois o ouro já corrompeu muita gente e perverteu a consciência dos reis."
,"3":"Não discutas com um homem falador, para não amontoares lenha na sua fogueira."
,"4":"Não brinques com um homem mal educado, para que ele não insulte os teus antepassados."
,"5":"Não repreendas o homem que se converteu do pecado. Lembra-te de que todos somos culpados."
,"6":"Não desprezes um ancião, porque também nós envelheceremos."
,"7":"Não te alegres com a morte de ninguém. Lembra-te de que todos nós morreremos."
,"8":"Não desprezes os ensinamentos dos sábios. Pelo contrário, medita sempre nas suas máximas, porque deles aprenderás a sabedoria e a arte de servir os poderosos."
,"9":"Não rejeites o ensinamento dos anciãos, porque eles também aprenderam dos próprios pais. É com eles que aprenderás a pensar e a responder no momento oportuno."
,"10":"Não atices as brasas do pecador, para não te queimares no fogo da sua chama."
,"11":"Nunca repliques ao insolente, para que ele não arme ciladas às tuas palavras."
,"12":"Não emprestes a quem é mais poderoso do que tu. E, se já lhe emprestaste, podes considerá-lo como coisa perdida."
,"13":"Não te tornes fiador além das tuas possibilidades. E, se já o fizeste, pensa no modo em que irás pagar."
,"14":"Não movas processo contra um juiz, porque decidirão a causa em seu favor."
,"15":"Não viajes com nenhum aventureiro, para que a situação não se torne insuportável: ele agirá conforme os próprios caprichos, e perder-te-ás com ele, por causa da sua imprudência."
,"16":"Não discutas com o violento, nem andes com ele por lugares desertos, porque o sangue para ele nada vale, e matar-te-á onde ninguém te pode socorrer."
,"17":"Não faças confidências a uma pessoa ingénua, porque ela não é capaz de manter segredo."
,"18":"Diante de um estranho, não faças nada que deva ficar em segredo, porque não sabes o que poderá acontecer."
,"19":"Não abras o teu coração a qualquer pessoa, para que ela não destrua a tua felicidade."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Não tenhas ciúmes da esposa que amas, para que ela não aprenda a maltratar-te."
,"2":"Não te entregues a uma mulher, para que ela não te domine."
,"3":"Não vás ao encontro da mulher fácil, para não caíres nas suas armadilhas."
,"4":"Não te entretenhas com uma tocadora de lira, para não ficares preso nas suas artimanhas."
,"5":"Não fixes o olhar numa virgem, para não seres castigado com ela."
,"6":"Não te entregues às prostitutas, para não perderes os teus bens."
,"7":"Não fiques a olhar pelas ruas da cidade, nem vagueies por recantos solitários."
,"8":"Desvia o teu olhar de uma mulher bonita e não fites uma beleza que não te pertence. Muitos já se perderam por causa de uma bela mulher, porque o amor por ela queima como fogo."
,"9":"Nunca te sentes à mesa ao lado de uma mulher casada, nem bebas com ela bebidas inebriantes, para que o teu coração não se enamore e a paixão te faça escorregar para a ruína."
,"10":"Não abandones um velho amigo, porque o novo não é como ele. Amigo novo é vinho novo: deixa-o envelhecer e depois bebe-o com prazer."
,"11":"Não invejes o sucesso do pecador, porque não sabes qual será o seu fim."
,"12":"Não sintas prazer com a felicidade dos injustos. Lembra-te: eles não chegarão impunes à mansão dos mortos."
,"13":"Afasta-te do homem que pode matar, e não te sentirás ameaçado de morte. Se te aproximas dele, procura não errar, para que ele não te tire a vida. Fica sabendo que caminhas entre armadilhas e andas em cima de muralhas."
,"14":"Responde como puderes ao teu próximo, e aconselha-te com os sábios."
,"15":"Conversa com homens de bom senso e escolhe sempre como assunto as leis do Altíssimo."
,"16":"Que os teus companheiros de mesa sejam homens justos, e seja teu orgulho temer o Senhor."
,"17":"O trabalho manual de um artesão sábio é elogiado, mas o chefe do povo deve ser sábio nas suas palavras."
,"18":"O homem falador é o terror da cidade; quem não sabe controlar a palavra será detestado."
}`)
	CurrentBook.AddChapter(10, `{
"1":"O governante sábio educa o seu povo, e a autoridade de um homem que tem bom senso é bem organizada."
,"2":"Tal é o governante do povo, tais são os ministros; tal é o chefe da cidade, tais são os habitantes."
,"3":"Um rei sem instrução arruína o seu povo, e uma cidade terá prosperidade com o bom senso dos seus chefes."
,"4":"O governo do mundo está nas mãos do Senhor, e no momento oportuno Ele faz aparecer o homem certo."
,"5":"O sucesso de um homem está nas mãos do Senhor, e é Ele que investe de autoridade o magistrado."
,"6":"Seja qual for a ofensa, não guardes ressentimento contra o próximo, e não faças nada levado pela raiva."
,"7":"A soberba é odiosa para o Senhor e para os homens, e ambos abominam a injustiça."
,"8":"O poder passa de uma nação para outra por causa da injustiça, da violência e das riquezas."
,"9":"Porque se orgulha quem é pó e cinza, se quando vivo já tem podridão nos intestinos?"
,"10":"Uma longa doença desafia o médico, e quem hoje é rei, amanhã morrerá."
,"11":"Quando o homem morre, recebe por herança insectos, larvas e vermes."
,"12":"A essência do orgulho humano é afastar-se do Senhor e manter o coração longe de quem o criou."
,"13":"O princípio de todo o pecado é o orgulho. Quem a ele se entrega espalha abominação. Por isso, o Senhor pune a pessoa com castigos incríveis, e destrói-a completamente."
,"14":"O Senhor derruba os tronos dos poderosos e faz sentar os humilhados no lugar deles."
,"15":"O Senhor arranca a raiz das nações, e no lugar delas planta os oprimidos."
,"16":"O Senhor destrói o território das nações e arrasa-o até aos alicerces."
,"17":"Ele arranca as nações e aniquila-as, e faz desaparecer da terra a sua lembrança."
,"18":"O orgulho não foi feito para os homens, nem a ira violenta para os nascidos da mulher."
,"19":"Qual é a raça digna de honra? A raça dos homens. Qual é a raça digna de honra? A dos que temem o Senhor."
,"20":"Qual é a raça digna de desprezo? A raça dos homens. Qual é a raça digna de desprezo? A dos que não obedecem aos mandamentos."
,"21":"Entre irmãos, presta-se honra ao mais velho, porém aos olhos do Senhor são honrados aqueles que temem ao Senhor."
,"22":"Quer seja rico, honrado ou pobre, a honra de alguém está em temer o Senhor."
,"23":"Não é justo desprezar um pobre que tenha bom senso, e não convém exaltar um homem pecador."
,"24":"O nobre, o juiz e o poderoso são respeitados, mas nenhum deles é maior do que alguém que teme o Senhor."
,"25":"Homens livres servem a um escravo sábio, e o homem sábio não se queixa disso."
,"26":"Não te consideres sábio ao realizares o teu trabalho, e não te glories no tempo da necessidade."
,"27":"É melhor uma pessoa que trabalha e tem tudo em abundância, do que alguém que se gloria e tem falta de alimento."
,"28":"Meu filho, conserva a tua honra com modéstia, e dá-lhe o valor que merece."
,"29":"Quem dará razão àquele que se prejudica a si mesmo? Quem estimará aquele que se menospreza a si próprio?"
,"30":"O pobre é honrado pelo seu saber, e o rico pelas suas riquezas."
,"31":"Quem é honrado na pobreza, mais ainda o será na riqueza. Quem é desprezado na riqueza, mais ainda o será na pobreza."
}`)
	CurrentBook.AddChapter(11, `{
"1":"A sabedoria do pobre fá-lo andar de cabeça erguida, e permite-lhe sentar-se entre os grandes."
,"2":"Não elogies um homem pela sua beleza, nem detestes uma pessoa pela sua aparência."
,"3":"A abelha é pequena entre os seres que voam, mas o que ela produz é o que há de mais doce."
,"4":"Não te envaideças com as roupas que usas, nem te ensoberbeças nos dias gloriosos, porque as obras do Senhor são admiráveis, mas permanecem ocultas aos homens."
,"5":"Muitos soberbos acabaram por sentar-se no chão, e um desconhecido recebeu a sua coroa."
,"6":"Muitos poderosos foram profundamente humilhados, e muitos homens ilustres caíram nas mãos de outros."
,"7":"Não critiques antes de verificar; examina primeiro, para depois julgares."
,"8":"Não respondas antes de teres ouvido, e não interrompas a conversa."
,"9":"Não brigues por alguma coisa que não te diz respeito, nem te metas em briga de pecadores."
,"10":"Meu filho, não te ocupes com demasiadas tarefas. Por mais que te esforces não as conseguirás realizar a todas e sair-te bem delas."
,"11":"Há pessoas que trabalham, se afadigam e se atropelam e, apesar de tudo, andam sempre atrasadas."
,"12":"Há pessoas fracas e necessitadas de ajuda, carentes de bens e ricas de miséria. O Senhor, porém, olha para elas com benevolência e levanta-as da miséria,"
,"13":"fazendo-as ficar de cabeça erguida, a tal ponto que muitos se admiram."
,"14":"Bem e mal, vida e morte, pobreza e riqueza, tudo provém do Senhor."
,"15":"Sabedoria, bom senso e conhecimento da Lei vêm do Senhor, e d'Ele procedem o amor e a prática das boas obras."
,"16":"O erro e as trevas foram criadas para os pecadores; e os que gostam do mal, no mal envelhecem."
,"17":"O dom do Senhor é reservado para os justos, e o seu favor sempre os conduz."
,"18":"Há quem enriqueça à custa de privações e economias, e eis qual é a sua recompensa:"
,"19":"Quando pensa que já pode descansar e aproveitar os seus bens, não sabe que vai chegar o tempo de morrer e deixar tudo para os outros."
,"20":"Persevera na tua tarefa, faz dela a tua vida, e envelhece no cumprimento do dever."
,"21":"Não admires o que o pecador faz. Confia no Senhor e persevera na fadiga, pois é fácil para o Senhor enriquecer um pobre de repente."
,"22":"A bênção do Senhor é a recompensa para quem é fiel, e a sua bênção floresce num instante."
,"23":"Não digas: «De que é que eu preciso? O que é que ainda me falta?»"
,"24":"Não digas: «Tenho tudo o que preciso. Que desgraça me pode acontecer?»"
,"25":"No tempo da prosperidade, a pessoa esquece-se da desgraça, e no tempo da desgraça nem se lembra da prosperidade."
,"26":"É fácil para o Senhor, na hora da morte, pagar ao homem conforme a conduta de cada um."
,"27":"A infelicidade de um momento faz esquecer o bem-estar, e é na hora da morte que as obras de um homem se manifestam."
,"28":"Não louves nenhuma pessoa antes da morte, pois é somente no fim que se conhece o homem."
,"29":"Não introduzas qualquer pessoa em tua casa, porque são muitas as ciladas do fraudulento."
,"30":"O coração do orgulhoso é como o pássaro que serve de isca na gaiola: como espião, ele espera que caias em ruína."
,"31":"Ele arma ciladas, transformando o bem em mal, e encontra defeitos até nas coisas mais puras."
,"32":"Como a faísca acende um grande braseiro, o homem perverso tem sede de sangue."
,"33":"Cuidado com o perverso, pois ele trama o mal: ele poderá sujar para sempre o teu nome."
,"34":"Hospeda o estrangeiro, e ele provocará desordens, transformando-te num estranho para os teus familiares."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Se fizeres o bem, sabe a quem, e assim terás recompensa pelos benefícios que fizeste."
,"2":"Faz bem ao justo, e serás recompensado, ou por ele ou pelo Altíssimo."
,"3":"Não existe recompensa para quem persevera no mal e se recusa a dar esmola."
,"4":"Ajuda o homem fiel, e nunca o pecador."
,"5":"Faz o bem ao pobre, mas não dês nada ao injusto. Recusa dar-lhe pão, e não o ajudes em nada, para que não se torne mais forte do que tu, pois encontrarás o dobro de males por todos os benefícios que lhe tiveres feito."
,"6":"O próprio Altíssimo detesta os pecadores e inflige aos injustos o castigo que eles merecem."
,"7":"Ajuda o homem bom, e não o pecador."
,"8":"O amigo não se revela na prosperidade, nem o inimigo se esconde no tempo da desgraça."
,"9":"Quando alguém prospera, os inimigos ficam tristes, mas quando alguém cai na desgraça, até o amigo se afasta."
,"10":"Nunca confies no inimigo, pois a sua maldade é metal que enferruja."
,"11":"Mesmo que se incline e faça muitos cumprimentos, toma cuidado e desconfia dele; comporta-te com ele como quem limpa o espelho, e verás que a sua ferrugem não resiste por muito tempo."
,"12":"Não o coloques ao teu lado, para que não te empurre e ocupe o teu lugar; não o coloques sentado à tua direita, para que não procure ocupar a tua cadeira. Caso contrário, tarde de mais verás que tenho razão, e arrepender-te-ás de não teres ouvido os meus conselhos."
,"13":"Quem vai ter dó de um encantador que é mordido pela serpente e de todos os que domam feras?"
,"14":"É o que acontece com quem se associa a um pecador e se envolve nos seus pecados."
,"15":"Ficará contigo enquanto permaneceres de pé, mas quando tropeçares não te apoiará."
,"16":"O inimigo tem lábios doces, mas no coração planeia o modo de te fazer cair no buraco. O inimigo tem lágrimas nos olhos, mas na primeira ocasião beber-te-á até o sangue."
,"17":"Se te acontecer uma desgraça, ele será o primeiro a chegar e, com a desculpa de ajudar, far-te-á tropeçar."
,"18":"Ele vai abanar a cabeça e agitar as mãos, mas logo depois murmura e volta-te as costas."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Quem toca no pez, acaba por se sujar, e quem frequenta o orgulhoso, torna-se como ele."
,"2":"Não levantes pesos demasiado pesados para ti, e não convivas com quem é mais forte ou mais rico do que tu. Acaso pode juntar-se a panela de barro com a panela de ferro? Quando chocarem, a primeira quebrar-se-á."
,"3":"O rico comete injustiça, e ainda ameaça; o pobre é maltratado, e ainda tem de pedir desculpa."
,"4":"Enquanto lhe fores útil, o rico servir-se-á de ti, mas quando já lhe não servires, abandonar-te-á."
,"5":"Se possuíres bens, viverá contigo e explorar-te-á sem remorso."
,"6":"Enquanto ele precisar, enganar-te-á, sorrir-te-á e dar-te-á esperanças. Dirá belas palavras e perguntará: «De que precisas?»"
,"7":"Enganar-te-á com os seus banquetes, até te despojar duas ou três vezes. Por fim, quando te vir, passará adiante e sacudirá a cabeça, escarnecendo de ti."
,"8":"Tem cuidado em não te deixares enganar, para não ficares humilhado pela tua falta de bom senso."
,"9":"Quando um poderoso te convidar, recusa com uma desculpa, e ele te convidará com maior insistência."
,"10":"Não te entusiasmes muito para depois não seres rejeitado, nem te mantenhas muito distante, para não seres esquecido."
,"11":"Não te dirijas a ele de igual para igual, nem acredites nas suas muitas palavras:"
,"12":"com o seu palavreado, ele põe-te à prova e, mesmo quando sorri, está a examinar-te."
,"13":"Ele não guardará os segredos que lhe confiares, e não te poupará maus tratos e correntes."
,"14":"Tem cuidado e presta atenção, porque estás a caminhar à beira do precipício."
,"15":"Todo o animal gosta do seu semelhante, e todo o homem gosta do seu próximo."
,"16":"Todo o animal se une com os da sua espécie, e todo o homem se associa com o seu semelhante."
,"17":"O que há de comum entre o lobo e o cordeiro? A mesma coisa acontece entre o pecador e o fiel."
,"18":"Que paz pode haver entre a hiena e o cão? E que paz pode haver entre o rico e o pobre?"
,"19":"Os leões caçam os burros selvagens, e os ricos caçam os pobres."
,"20":"Para o orgulhoso a humildade é humilhação, e para o rico o pobre é detestável."
,"21":"Quando o rico tropeça, os seus amigos sustentam-no; quando o pobre cai, os seus amigos rejeitam-no."
,"22":"Quando o rico comete um erro, muitos defendem-no; e se ele diz tolices, os outros aprovam-no. Quando o pobre erra, todos o condenam; e quando fala com bom senso, ninguém o escuta."
,"23":"Quando o rico fala, todos se calam e elevam até às nuvens o seu talento; quando o pobre fala, as pessoas perguntam: «Quem é este fulano?» E quando tropeça, ajudam-no a cair."
,"24":"A riqueza é boa quando nela não há pecado; mas a pobreza é má, na opinião do injusto."
,"25":"A consciência do homem modifica as feições do seu rosto, tanto para o bem como para o mal."
,"26":"Rosto alegre é sinal de bom coração, mas inventar provérbios é trabalho fatigante."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Feliz o homem que não pecou por palavras e não é atormentado pelo remorso dos pecados."
,"2":"Feliz quem não é acusado pela sua consciência e quem não perdeu a esperança."
,"3":"A riqueza não convém ao homem mesquinho, nem grandes bens ao homem invejoso."
,"4":"Quem se priva para acumular, junta para os outros. Serão outros que se regalarão com os seus bens."
,"5":"Quem é mau para si mesmo, com quem será bom? Nem sequer aproveita os seus próprios bens."
,"6":"Ninguém é pior do que aquele que se maltrata a si mesmo. Essa é a recompensa da sua própria maldade."
,"7":"Se faz o bem é por distracção, mas no fim mostrará a sua maldade."
,"8":"Mau é o homem de olhar invejoso, que vira o rosto e despreza a vida dos outros."
,"9":"O avarento não se satisfaz com uma parte apenas, pois a avidez insana resseca-lhe a alma."
,"10":"O avarento é cioso do seu pão e mesquinho na sua própria mesa."
,"11":"Meu filho, trata-te bem na medida do possível, e apresenta ao Senhor as ofertas que Lhe deves."
,"12":"Lembra-te: a morte não tarda, e não sabes a que horas ela vai chegar."
,"13":"Antes de morrer, faz o bem ao amigo e dá esmola ao pobre segundo as tuas posses."
,"14":"Não te prives de um dia feliz, nem deixes escapar um desejo legítimo."
,"15":"Acaso não vais deixar para outros o fruto das tuas fadigas, e não vai ficar para os herdeiros o fruto dos teus sacrifícios?"
,"16":"Dá e recebe, e diverte-te, porque no mundo dos mortos não existe alegria."
,"17":"Todo o corpo envelhece como a roupa, porque a morte é uma lei eterna."
,"18":"As folhas verdes em árvore frondosa caem ou rebentam. O mesmo acontece com as gerações humanas: uns morrem, outros nascem."
,"19":"Toda a obra perecível desaparece, e aquele que a fez morrerá com ela."
,"20":"Feliz o homem que se dedica à sabedoria, que reflecte com inteligência,"
,"21":"que medita no coração sobre os caminhos da sabedoria e com a mente penetra os seus segredos."
,"22":"Ele persegue-a como um caçador e põe-se à espreita nos seus caminhos."
,"23":"Ele inclina-se para olhar pelas suas janelas e escuta junto às suas portas."
,"24":"Ele pára perto da casa da sabedoria e fixa o prego nas suas paredes."
,"25":"Arma a sua tenda junto dela, e acampa na moradia da felicidade."
,"26":"Coloca os seus filhos sob a sua protecção e abriga-se debaixo dos seus ramos."
,"27":"Ela protege-o do calor, e ele habita à sombra da sua glória."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Assim age quem teme o Senhor, e quem é fiel à Lei alcançará a sabedoria."
,"2":"A lei irá ao seu encontro como mãe, e acolhê-lo-á como jovem esposa."
,"3":"Alimentá-lo-á com o pão da inteligência e saciá-lo-á com a água da sabedoria."
,"4":"Apoiar-se-á nela, e não vacilará. Nela confiará, e não será confundido."
,"5":"Ela o elevará acima dos seus companheiros e fá-lo-á falar no meio da assembleia."
,"6":"Ele ficará contente, terá uma coroa de alegria e alcançará fama duradoura."
,"7":"Os insensatos nunca alcançarão a sabedoria, e os pecadores jamais a contemplarão."
,"8":"Ela está longe do orgulhoso, e os mentirosos nem se lembram dela."
,"9":"O louvor destoa na boca dos pecadores, porque não lhes foi concedido pelo Senhor."
,"10":"Porque, de facto, é na sabedoria que se exprime o louvor, e é o Senhor quem o inspira."
,"11":"Não digas: «Foi por culpa do Senhor que me afastei». Porque Deus não faz aquilo que Ele próprio detesta."
,"12":"Não digas: «Foi Ele quem me fez desviar». Porque Deus não tem necessidade do pecador."
,"13":"O Senhor detesta toda a abominação, e nenhuma delas é desejada por quem teme o Senhor."
,"14":"Desde o princípio, Deus criou o homem e entregou-o ao poder das suas próprias decisões."
,"15":"Se quiseres, observarás os mandamentos, e ser-lhes fiel vai depender da boa vontade que tu mesmo tiveres."
,"16":"Ele pôs-te diante do fogo e da água, e poderás estender a mão para aquilo que quiseres."
,"17":"A vida e a morte estão diante dos homens, e a cada um será dado o que cada um escolher."
,"18":"De facto, a sabedoria do Senhor é grande, pois é todo-poderoso e tudo vê."
,"19":"Os seus olhos estão sobre aqueles que O temem, e Ele conhece cada acção que o homem realiza."
,"20":"Ele não deu ordem a ninguém para fazer o mal e a ninguém permissão de pecar."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Não desejes ter muitos filhos, para serem inúteis, nem te alegres com filhos injustos."
,"2":"Ainda que eles se multipliquem, não te alegres, se neles não houver o temor do Senhor."
,"3":"Não confies na sua longa vida, nem te apoies no seu grande número, porque é preferível ter apenas um, em vez de mil, e morrer sem filhos do que ter filhos injustos."
,"4":"A cidade poderá ser repovoada por meio de uma só pessoa de bom senso, enquanto que a raça dos injustos será destruída."
,"5":"Os meus olhos já viram muitos exemplos destes e os meus ouvidos já ouviram coisas mais espantosas ainda."
,"6":"Na assembleia dos pecadores acende-se um fogo, e a cólera de Deus acende-se contra um povo rebelde."
,"7":"Deus não perdoou aos gigantes de outrora, que se revoltaram, orgulhando-se das suas forças."
,"8":"Ele não poupou os concidadãos de Lot, mas detestou-os por causa do seu orgulho."
,"9":"Não teve compaixão de um povo que foi destinado à destruição, por causa do orgulho dos seus pecados."
,"10":"Foi assim que Ele tratou os seiscentos mil soldados que se uniram na própria arrogância."
,"11":"Mesmo que só houvesse um homem de dura cerviz, seria estranho se ficasse sem castigo."
,"12":"Pois a misericórdia e a ira pertencem ao Senhor, poderoso quando perdoa e quando espalha a ira."
,"13":"A sua misericórdia é tão grande como o seu castigo, e julga o homem conforme as obras de cada um."
,"14":"O pecador não fugirá com o roubo, e a paciência do fiel não ficará frustrada."
,"15":"Todo aquele que dá esmola terá uma recompensa, e cada um será tratado segundo as próprias acções."
,"16":"Não digas: «Vou esconder-me do Senhor. Lá de cima, quem se lembrará de mim?"
,"17":"No meio de tanta gente, quem me reconhecerá? Quem sou eu nesta imensa Criação?»"
,"18":"Vê bem! O céu, o mais alto do céu, o abismo e a terra, tudo isso treme quando Deus aparece."
,"19":"Os montes e os alicerces da Terra abalam-se de pavor quando Deus olha para eles."
,"20":"Mas ninguém reflecte sobre estas coisas. Quem faz caso do seu modo de agir?"
,"21":"Assim como ninguém vê a tempestade, a maior parte das obras de Deus fica escondida."
,"22":"«Quem anunciará as obras da justiça de Deus, ou quem esperará por elas? A aliança, de facto, está longe»."
,"23":"Assim pensa o homem de mente curta; o insensato que se transvia só pensa loucuras."
,"24":"Escuta-me, filho, e aprende a sabedoria. Aplica a tua mente aos meus conselhos."
,"25":"Vou apresentar a minha instrução de maneira precisa, e com exactidão anunciarei a ciência."
,"26":"No princípio, o Senhor criou as suas obras e, depois de as ter feito, colocou cada uma no seu lugar."
,"27":"Fixou uma ordem eterna para as suas obras, desde a sua origem até ao seu futuro longínquo. Elas não têm fome e nem se cansam, e nunca abandonam as suas actividades."
,"28":"Nenhuma delas jamais choca com a outra, e nunca desobedecem ao seu comando."
,"29":"Depois disto, o Senhor olhou para a Terra e encheu-a com os seus bens."
,"30":"Cobriu a superfície da Terra com toda a espécie de animais que à terra hão-de voltar."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Da terra o Senhor criou o homem, e para ela o faz voltar novamente."
,"2":"Concedeu aos homens dias contados e tempo medido, e deu-lhes poder sobre todas as coisas que existem na terra."
,"3":"Revestiu-os com a sua própria força e criou-os à sua imagem."
,"4":"Infundiu em todos os seres vivos o temor para com os homens, para que estes dominassem as feras e as aves."
,"5":"Deu-lhes discernimento, língua, olhos, ouvidos e mente para pensar."
,"6":"Encheu-os de ciência e inteligência, e também lhes mostrou o bem e o mal."
,"7":"Infundiu-lhes o seu temor na consciência, para lhes mostrar a grandeza das suas obras."
,"8":"Eles louvarão o seu Nome santo, cantando a grandeza das suas obras."
,"9":"Concedeu aos homens a ciência e entregou-lhes por herança a lei da vida."
,"10":"Fez com eles uma aliança eterna e deu-lhes a conhecer os seus decretos."
,"11":"Os olhos dos homens contemplaram a grandeza da glória de Deus, e os seus ouvidos ouviram a majestade da sua voz."
,"12":"E disse-lhes: «Cuidado, não cometais injustiça!» E ordenou que cada um se preocupasse com o próximo."
,"13":"Os caminhos dos homens estão sempre diante de Deus, e não ficam escondidos aos seus olhos."
,"14":"Para cada povo estabeleceu um chefe, mas Israel é a porção do Senhor."
,"15":"Todas as acções dos homens estão diante d'Ele como o Sol e os seus olhos observam continuamente a sua conduta."
,"16":"As injustiças que cometem não Lhe ficam escondidas, e todos os seus pecados estão diante do Senhor."
,"17":"A esmola que o homem dá é para ele como um selo, e conserva uma boa obra como a pupila do próprio olho."
,"18":"Por fim, Deus levantar-Se-á para lhes dar a recompensa, entregando a cada um o que cada um merece."
,"19":"A quem se arrepende, oferece a conversão, e reconforta os que perderam a esperança."
,"20":"Converte-te ao Senhor e abandona o pecado. Suplica diante d'Ele e reduz a ofensa que Lhe fizeste."
,"21":"Volta para o Altíssimo, vira as costas à injustiça e detesta profundamente aquilo que Ele abomina."
,"22":"Quem louvará o Altíssimo na mansão dos mortos, em lugar dos vivos e de todos os que O glorificam?"
,"23":"Os mortos já não existem e já não louvam; só louva o Senhor quem tem vida e saúde."
,"24":"Como é grande a misericórdia do Senhor, e o seu perdão para todos os que a Ele se convertem!"
,"25":"O homem não pode ter tudo, pois o ser humano não é imortal."
,"26":"Nada é mais luminoso que o sol. Todavia, também ele desaparece. O homem, que é carne e sangue, planeia o mal."
,"27":"Deus passa em revista o exército celeste, e os homens são apenas terra e cinza."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Aquele que vive para sempre criou o Universo inteiro."
,"2":"Só o Senhor é justo."
,"3":"A ninguém é possível anunciar as suas obras. E quem é capaz de Lhe investigar as grandezas?"
,"4":"Quem poderá medir o poder da sua majestade? Quem ousará contar os seus feitos de misericórdia?"
,"5":"Não há nada para tirar e nada para acrescentar. Ninguém é capaz de investigar as maravilhas do Senhor."
,"6":"Quando alguém julga ter chegado ao fim, está apenas a começar; e quando pára, então fica perplexo."
,"7":"O que é o homem, e para que serve? Qual é o seu bem e qual é o seu mal?"
,"8":"A duração da sua vida é de cem anos no máximo."
,"9":"Como uma gota de água no mar ou como um grão na areia, tais são os seus poucos anos frente a um dia da eternidade."
,"10":"É por isso que o Senhor tem paciência com os homens, e derrama sobre eles a sua misericórdia."
,"11":"Ele vê e reconhece que o seu fim é miserável, e por isso multiplica sobre eles o seu perdão."
,"12":"A misericórdia do homem é para o seu próximo, porém a misericórdia do Senhor é para todos os seres vivos."
,"13":"Ele repreende, corrige, ensina e dirige, como o pastor conduz o seu rebanho."
,"14":"Ele tem compaixão dos que aceitam a correcção, e dos que se esforçam por cumprir os seus mandamentos."
,"15":"Meu filho, quando fazes um favor, não repreendas, nem ofendas com palavras ao dares esmola."
,"16":"O orvalho abranda o calor, e a palavra é melhor que o presente."
,"17":"De facto, não vale mais a palavra que o presente? O homem generoso oferece as duas coisas."
,"18":"O insensato reprova com aspereza, e o presente dado de má vontade faz chorar."
,"19":"Antes de falar procura instruir-te; cuida de ti para não adoeceres."
,"20":"Examina-te a ti mesmo antes do julgamento e, no momento da sentença, encontrarás perdão."
,"21":"Humilha-te para não adoeceres, e quando pecares arrepende-te."
,"22":"Que nada te impeça de cumprir no devido tempo uma promessa; não esperes até à morte para a cumprir."
,"23":"Antes de fazeres uma promessa, dispõe-te a cumpri-la, para não seres como alguém que tenta o Senhor."
,"24":"Lembra-te da ira que virá nos últimos dias, no tempo da vingança, quando Deus desviar o rosto."
,"25":"No tempo da abundância, lembra-te da carestia; nos dias de riqueza, lembra-te da pobreza e da miséria."
,"26":"Entre o amanhecer e a tarde, o tempo muda, e tudo é passageiro diante do Senhor."
,"27":"O homem sábio age sempre com cautela, e evita o pecado quando surge a tentação."
,"28":"Todo o homem de bom senso conhece a sabedoria, e presta homenagem àquele que a encontrou."
,"29":"Os que sabem falar bem também procedem com sabedoria e derramam como chuva provérbios acertados."
,"30":"Não sigas as tuas paixões. Refreia os teus desejos."
,"31":"Se satisfazes a paixão, ela tornar-te-á motivo de zombaria para os teus inimigos."
,"32":"Não te entregues a uma vida de prazeres, para não empobreceres com os gastos."
,"33":"Não te empobreças em banquetes com dinheiro emprestado, quando não tens nada na algibeira."
}`)
	CurrentBook.AddChapter(19, `{
"1":"O trabalhador dado ao vinho nunca ficará rico, e quem despreza o pouco que tem, cairá na miséria."
,"2":"Vinhos e mulheres fazem perder o bom senso, e quem anda com prostitutas torna-se cada vez mais imprudente."
,"3":"Podridão e vermes tomarão conta dele, porque a imprudência provocará a sua ruína."
,"4":"Quem é demasiado crédulo, é porque não tem juízo; e quem peca, prejudica-se a si mesmo."
,"5":"Quem sente prazer na maldade, será condenado,"
,"6":"e quem detesta a tagarelice, escapa do mal."
,"7":"Nunca repitas um boato, e não perderás nada."
,"8":"Não contes nada ao teu amigo ou inimigo, a não ser que o silêncio te torne cúmplice."
,"9":"Caso contrário, quem ouvir nunca mais confiará em ti, e quando tiver oportunidade, há-de odiar-te."
,"10":"Ouviste alguma coisa? Que ela morra contigo. Aguenta, que não te fará explodir."
,"11":"O insensato sofre por causa de um segredo, como uma mulher grávida no momento de dar à luz uma criança."
,"12":"O segredo no peito do insensato é como flecha cravada na coxa."
,"13":"Pergunta ao teu amigo: talvez ele não tenha feito o que dizem dele; ou, se fez, não continuará a fazê-lo."
,"14":"Pergunta ao teu amigo: talvez ele não tenha dito o que dizem; ou, se falou, não voltará a repeti-lo."
,"15":"Pergunta ao amigo; porque muitas vezes se trata de calúnia. Não acredites em tudo o que se diz."
,"16":"Às vezes, a pessoa escorrega sem querer. Quem nunca pecou com a língua?"
,"17":"Pergunta ao teu próximo, antes de o ameaçares, e assim observarás a lei do Altíssimo."
,"18":"Toda a sabedoria consiste em temer o Senhor, e em toda a sabedoria existe a prática da Lei."
,"19":"Conhecer o mal não é sabedoria, e o conselho dos pecadores não é prudência."
,"20":"Há uma habilidade que é abominável, e quem não tem sabedoria é insensato."
,"21":"É melhor ter pouca inteligência com temor, do que ser muito inteligente, mas transgressor da Lei."
,"22":"Há uma astúcia hábil, no entanto injusta, e há quem use meios fraudulentos para aparentar rectidão."
,"23":"Há quem ande curvado pela tristeza, mas por dentro está cheio de falsidade:"
,"24":"abaixa a cabeça e faz de surdo, mas quando ninguém estiver a observá-lo atacar-te-á de surpresa."
,"25":"Se te não prejudica, é porque não tem força, mas quando tiver ocasião far-te-á mal."
,"26":"Pode-se conhecer o homem pelo semblante, e pelo aspecto do rosto se conhece a pessoa sensata."
,"27":"A roupa de um homem, o seu modo de sorrir e o seu modo de andar revelam aquilo que ele é."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Há repreensões inoportunas, e há quem se cala por prudência."
,"2":"É melhor repreender do que irritar-se,"
,"3":"mas quem admite a própria culpa evita o castigo."
,"4":"Como eunuco que tenta violar uma jovem, assim é aquele que quer fazer justiça com violência."
,"5":"Há quem se cala e é reconhecido como sábio, e há quem é odiado porque fala de mais."
,"6":"Há quem se cala por não saber o que responder, e há quem se cala porque sabe qual é o momento propício."
,"7":"O homem sábio fica em silêncio até uma hora oportuna, mas o falador e o insensato deixam-na passar."
,"8":"Quem fala de mais torna-se detestável, e quem procura impor-se acaba por ser odiado."
,"9":"Na desgraça, um homem pode encontrar a salvação, enquanto a fortuna pode provocar a ruína."
,"10":"Há presentes que não servem para nada, e há presentes que rendem o dobro."
,"11":"Há quem procure glória e encontra humilhação, e quem foi humilhado, mas levanta a cabeça."
,"12":"Há quem compre barato muitas coisas, e acaba por pagar sete vezes mais."
,"13":"Com as suas palavras o sábio torna-se amável, mas o insensato derrama as suas gentilezas inutilmente."
,"14":"O presente do insensato não te ajudará em nada, porque espera avidamente receber sete vezes mais."
,"15":"Ele dá pouco e reclama muito, gritando alto como leiloeiro; hoje faz um empréstimo, e amanhã já quer a restituição. Esse tipo de homem é sempre odioso."
,"16":"O insensato diz: «Não tenho amigos. Ninguém reconhece os benefícios que eu faço»."
,"17":"Até os que comem do seu pão falam mal dele, e quantos muitas vezes escarnecerão dele!"
,"18":"É melhor escorregar no chão do que no falar, pois a queda dos maus chega depressa."
,"19":"Do homem grosseiro saem palavras maliciosas, que se multiplicam na boca dos insensatos."
,"20":"Ninguém aceita um provérbio dito por um insensato, porque não sabe dizê-lo no momento oportuno."
,"21":"Há quem deixe de pecar, só por causa da pobreza, e ainda consegue descansar sem remorso."
,"22":"Há quem se destrói por causa do respeito humano, e há quem se perde por respeito ao insensato."
,"23":"Há quem por timidez faz promessas a um amigo, e sem necessidade o transforma em inimigo."
,"24":"A mentira é mancha infame para o homem, e está sempre na boca dos insensatos."
,"25":"Um ladrão vale mais do que um mentiroso incorrigível, mas ambos terão como herança a perdição."
,"26":"O vício do mentiroso é uma desonra, e a vergonha sempre o acompanha."
,"27":"O sábio promove-se com a palavra, e o homem de bom senso agrada aos poderosos."
,"28":"Quem cultiva a terra consegue boa colheita, e quem agrada aos poderosos consegue perdão para a injustiça."
,"29":"Favores e presentes cegam o sábio: são mordaça na boca, porque impedem a repreensão."
,"30":"Sabedoria escondida e tesouro oculto são coisas inúteis."
,"31":"É melhor um homem que esconde a sua loucura, do que um homem que esconde a própria sabedoria."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Meu filho, pecaste? Não tornes a pecar, e pede perdão das culpas passadas."
,"2":"Foge do pecado como de uma serpente, porque, se te aproximares, ele te morderá. Os seus dentes são como os do leão, capazes de destruir vidas humanas."
,"3":"Toda a desobediência é como uma espada de dois gumes, e a sua ferida não tem cura."
,"4":"Crueldade e arrogância destroem a riqueza, e por isso a casa do soberbo será devastada."
,"5":"A súplica do pobre sobe da sua boca até aos ouvidos de Deus, que lhe faz justiça imediatamente."
,"6":"Quem despreza a correcção segue o caminho do pecador, mas quem teme o Senhor arrepende-se sinceramente."
,"7":"De longe se conhece o falador, mas quem reflecte sabe reconhecer quando tropeça."
,"8":"Quem constrói a própria casa com dinheiro alheio, junta pedras para a sua própria sepultura."
,"9":"A reunião dos injustos é como um monte de estopa, que acabará em chamas de fogo."
,"10":"O caminho dos pecadores é bem pavimentado, mas desemboca nas profundezas da mansão dos mortos."
,"11":"Quem observa a Lei torna-se capaz de controlar o seu próprio pensamento, e a sabedoria é a perfeição do temor ao Senhor."
,"12":"Quem não tem capacidade nunca será instruído, mas há capacidade que aumenta a amargura."
,"13":"A ciência do sábio é vasta como a inundação, e o seu conselho é como fonte de vida."
,"14":"A mente do insensato é como vaso quebrado: não guarda nenhum conhecimento."
,"15":"Quando o inteligente ouve uma palavra sábia, recebe-a e enriquece-a. Quando o folgazão ouve uma palavra sábia, despreza-a e deita-a para trás das costas."
,"16":"A conversação do insensato é como fardo durante a viagem, mas a boca do inteligente está cheia de graça."
,"17":"A assembleia solicita o discurso do sensato, e reflecte seriamente nas suas palavras."
,"18":"Para o imbecil, a sabedoria é como uma casa em ruínas, e a sua ciência é um discurso que não se entende."
,"19":"Para o imbecil a instrução é como corrente nos pés e algema na mão direita."
,"20":"O insensato ri alto, fazendo barulho; o sábio sorri discretamente."
,"21":"Para o sábio, a instrução é uma jóia de ouro, um bracelete no braço direito."
,"22":"O imbecil entra numa casa apressadamente, mas o homem experiente mostra-se respeitoso."
,"23":"O imbecil espia da porta o que há dentro da casa, mas a pessoa educada fica do lado de fora."
,"24":"O mal-educado põe-se a escutar atrás da porta, mas o homem prudente envergonha-se de o fazer."
,"25":"Os palradores repetem o que os outros dizem, porém os sábios pesam as suas próprias palavras na balança."
,"26":"Os imbecis têm a mente na língua; os sábios têm a língua na mente."
,"27":"Quando o injusto amaldiçoa Satanás, está-se amaldiçoando a si próprio."
,"28":"O maldizente prejudica-se a si mesmo, e acaba por ser detestado pela vizinhança."
}`)
	CurrentBook.AddChapter(22, `{
"1":"O preguiçoso é como uma pedra cheia de lodo; todos zombam dele com desprezo."
,"2":"O preguiçoso é semelhante a um monte de esterco: quem lhe toca, logo sacode a mão."
,"3":"Filho mal educado é vergonha para o pai, e se for uma filha, a desgraça é ainda maior."
,"4":"Filha sensata arranja marido; filha sem vergonha é desgraça para os pais."
,"5":"Filha insolente envergonha o pai e o marido, e é desprezada por ambos."
,"6":"Advertência inoportuna é como música numa vigília fúnebre, mas castigo e disciplina é sabedoria em qualquer tempo."
,"7":"Ensinar o imbecil é como unir cacos de um vaso quebrado, ou acordar alguém de um sono profundo."
,"8":"Falar ao imbecil é como falar a quem está adormecido; no fim ele pergunta: «De que se trata?»"
,"9":"Chora pelo morto, porque perdeu a luz; chora pelo imbecil, porque perdeu o juízo."
,"10":"É menos triste chorar pelo morto que agora descansa, porque a vida do imbecil é pior que a morte."
,"11":"O luto pelo morto dura sete dias, mas pelo imbecil e pelo injusto dura a vida inteira."
,"12":"Não gastes palavras com o insensato, e evita andar com o estúpido."
,"13":"Afasta-te dele, para não te aborreceres e não te sujares lidando com ele. Afasta-te dele e ficarás tranquilo, e a sua insensatez não irritará."
,"14":"O que haverá mais pesado que o chumbo? Qual será o seu nome, senão o de «insensato?»"
,"15":"Areia, sal e barra de ferro são mais fáceis de carregar do que um insensato."
,"16":"Casas travadas com viga de madeira não virão abaixo por ocasião de um terremoto; da mesma forma, a mente que decide após muito reflectir não se deixará abalar no momento do perigo."
,"17":"Mente apoiada em reflexão prudente é como enfeite de estuque em muro polido."
,"18":"Cascalho no alto dum muro não resiste ao vento, e a mente que vacila diante de opiniões insensatas também não resiste diante de ameaças."
,"19":"Quem magoa os olhos faz cair lágrimas, e quem fere um coração revela os seus sentimentos."
,"20":"Quem atira pedras aos pássaros acaba por afugentá-los, e quem ofende um amigo perde a amizade."
,"21":"Embora já tenhas empunhado a espada contra o amigo, não desesperes, porque ainda há remédio."
,"22":"Mesmo que já tenhas aberto a boca contra o amigo, não te apavores, porque ainda pode haver reconciliação. Mas o ultraje, a arrogância, a violação de segredos e a traição são coisas que fazem fugir o amigo."
,"23":"Conserva-te fiel ao amigo quando está na pobreza, para te alegrares com ele quando estiver na prosperidade. Faz-lhe companhia quando ele estiver na dificuldade, para que possas ter parte na sua herança."
,"24":"Antes que o fogo se acenda, a chaminé solta fumo e vapor, e antes do sangue vêm os insultos."
,"25":"Não me envergonho de defender um amigo, e nem me escondo da sua presença;"
,"26":"mas, se algum mal me acontecer por causa dele, quem o souber desconfiará dele."
,"27":"Quem irá colocar um guarda na minha boca e um selo de prudência nos meus lábios, para me não fazerem cair, e a minha língua não me arruinar?"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Senhor, Pai e Soberano da minha vida, não me abandones ao capricho deles, e não permitas que me façam cair."
,"2":"Quem irá dar chicotadas aos meus pensamentos e disciplinar a minha mente com a sabedoria, para que os meus erros não sejam poupados e as minhas culpas não sejam toleradas?"
,"3":"Desta forma os meus erros não se multiplicarão, e os meus pecados não se avolumarão; não cairei diante dos meus adversários, e o meu inimigo não se alegrará às minhas custas."
,"4":"Senhor, Pai e Deus da minha vida, não permitas que o meu olhar seja altivo."
,"5":"Afasta de mim os maus desejos."
,"6":"Que a sensualidade e a luxúria não me dominem. Não me entregues ao desejo vergonhoso."
,"7":"Meus filhos, procurai disciplinar a boca. Quem assim fizer nunca será surpreendido."
,"8":"O pecador será apanhado pelos seus próprios lábios, e o maldizente e o orgulhoso cairão por causa deles."
,"9":"Não te acostumes a fazer juramentos, nem te habitues a proferir o Nome Santo."
,"10":"Assim como o escravo está sempre sob domínio, e não escapa de ficar marcado pelos golpes, assim o homem que jura e invoca o nome de Deus por qualquer coisa nunca ficará livre de pecar."
,"11":"O homem que faz muitos juramentos acaba por cometer muitos pecados, e o chicote não se afastará da sua casa. Se erra, cai em pecado. Se não cumpre o juramento, peca duas vezes. Se jura em falso, não será perdoado, e a sua casa ficará cheia de desgraças."
,"12":"Há um modo de falar que é comparável à morte, e que não deveria ser encontrado entre os descendentes de Jacob. Os homens fiéis afastam-se destas coisas, e assim não se afundam em pecados."
,"13":"Não te acostumes a dizer vulgaridades grosseiras, pois nelas há sempre motivo de pecado."
,"14":"Lembra-te de teu pai e de tua mãe, quando te sentares entre os grandes. Não esqueças os teus pais, quando estiveres diante dos grandes; tornar-te-ias tão imbecil no teu comportamento que desejarias não ter nascido, e amaldiçoarias o teu próprio nascimento."
,"15":"O homem acostumado à linguagem inconveniente ficará incorrigível até ao fim da vida."
,"16":"Há duas espécies de coisas que multiplicam os pecados, e uma terceira que provoca a ira:"
,"17":"a paixão que arde como fogo aceso e que não se apaga enquanto não se consumar; o homem entregue à sensualidade, que não cessa enquanto o fogo não o devorar; o homem sensual, para o qual todo o alimento é doce, e não se satisfaz enquanto não morrer;"
,"18":"o homem que trai o leito matrimonial, dizendo: «Quem me vê? As trevas envolvem-me e as paredes escondem-me. Ninguém me vê. Que tenho a temer? O Altíssimo não Se lembrará dos meus pecados»."
,"19":"Ele só tem medo do que os homens vêem, e não sabe que os olhos do Senhor são mil vezes mais luminosos que o Sol, porque vêem todos os caminhos dos homens e penetram os lugares mais escondidos."
,"20":"Deus conhecia as coisas, ainda antes de criar o Universo, e o mesmo acontece depois de as ter criado."
,"21":"Tal homem será castigado na praça da cidade e será apanhado onde não espera."
,"22":"O mesmo acontece com a mulher que abandona o marido e gera um herdeiro com outro homem."
,"23":"Em primeiro lugar, ela desobedece à lei do Altíssimo; em segundo lugar, ofende o seu marido; em terceiro lugar, prostitui-se com o adultério e gera filhos de um estranho."
,"24":"Será arrastada diante da assembleia, e sobre os seus filhos se fará uma pesquisa."
,"25":"Os seus filhos não criarão raízes e os seus ramos não darão frutos."
,"26":"A sua memória será amaldiçoada, e a sua infâmia nunca será apagada."
,"27":"Os sobreviventes saberão que nada é melhor do que o temor do Senhor, e nada é mais doce do que observar os seus mandamentos."
}`)
	CurrentBook.AddChapter(24, `{
"1":"A Sabedoria louva-se a si mesma e gloria-se no meio do seu povo."
,"2":"Abre a boca na assembleia do Altíssimo e glorifica-se diante do seu poder:"
,"3":"«Eu saí da boca do Altíssimo e cobri a Terra como a névoa."
,"4":"Armei a minha tenda nas alturas, e o meu trono ficava sobre uma coluna de nuvens."
,"5":"Percorri sozinha a abóbada do céu e passei pelas profundezas dos abismos."
,"6":"Estendi o meu poder sobre as ondas do mar, sobre a Terra inteira e sobre todos os povos e nações."
,"7":"Em todos eles procurei um lugar para repousar e uma propriedade onde me pudesse estabelecer."
,"8":"Então o Criador do Universo deu-me uma ordem. Aquele que me criou armou a minha tenda, e disse: 'Instala-te em Jacob e toma Israel como tua herança'."
,"9":"Ele criou-me desde o princípio, antes dos séculos, e eu nunca deixarei de existir."
,"10":"Oficiei na Tenda santa, na sua presença, e deste modo me estabeleci em Sião."
,"11":"Ele fez-me habitar na cidade amada, e em Jerusalém exerço o meu poder."
,"12":"Deitei raízes no meio de um povo glorioso, na porção do Senhor, seu património."
,"13":"Cresci como cedro no Líbano e como cipreste nos montes do Hermon."
,"14":"Cresci como palmeira de Engadi e como roseira em Jericó. Cresci como oliveira majestosa na planície, e fiquei alta como plátano."
,"15":"Espalhei o meu perfume como canela, bálsamo e mirra escolhida, como gálbano, ónix, estoraque e vapor de incenso na Tenda."
,"16":"Estendi os meus ramos como terebinto, e a minha ramagem é bela e frondosa."
,"17":"Como videira produzi rebentos graciosos, e as minhas flores e frutos são belos e abundantes."
,"18":"Vinde a mim todos os que me desejais, e ficai saciados com os meus frutos."
,"19":"Pensar em mim é mais doce do que o mel, e possuir-me é mais doce do que o favo de mel."
,"20":"Os que se alimentam de mim terão ainda mais fome, e os que me bebem terão ainda mais sede."
,"21":"Quem me obedece não ficará envergonhado, e os que trabalham comigo não pecarão»."
,"22":"Tudo isto é o livro da Aliança do Deus Altíssimo, a Lei que Moisés nos deu como herança para as comunidades de Jacob."
,"23":"A Lei transborda de Sabedoria como o Fison e como o rio Tigre no tempo dos primeiros frutos."
,"24":"Ela transborda de inteligência como o rio Eufrates e como o rio Jordão no tempo da colheita."
,"25":"Ela espalha instrução como o rio Nilo e como o Geon no tempo da vindima."
,"26":"O primeiro homem não esgota o seu conhecimento, e o último também não conseguirá investigá-la completamente."
,"27":"De facto, o seu pensamento é maior do que o mar, e o seu conselho é maior do que o oceano."
,"28":"Eu sou como o canal de um rio, um curso de água que rega o paraíso."
,"29":"Eu disse: «Vou regar o meu jardim e empapar os meus canteiros». Mas o meu canal tornou-se um rio, e o meu rio transformou-se em mar."
,"30":"Farei que a minha instrução resplandeça como aurora, para que ilumine os lugares mais distantes."
,"31":"Derramarei o ensinamento como profecia e transmiti-lo-ei às gerações futuras."
,"32":"Vede que não trabalhei apenas para mim, mas para todos os que procuram a Sabedoria."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Três coisas me satisfazem e agradam ao Senhor e aos homens: a concórdia entre irmãos, a amizade entre vizinhos e a boa harmonia entre marido e mulher."
,"2":"Há também três espécies de pessoas que eu detesto e cujo comportamento me irrita profundamente: o pobre orgulhoso, o rico mentiroso e o ancião adúltero e sem bom senso."
,"3":"Se não acumulaste na juventude, como poderás encontrar alguma coisa na velhice?"
,"4":"Como é belo para os cabelos brancos saber julgar, e para os anciãos saber dar conselhos!"
,"5":"Como fica bem a sabedoria nos anciãos e o discernimento sábio nas pessoas honradas!"
,"6":"A coroa dos anciãos é uma grande experiência, e o seu orgulho é temer o Senhor."
,"7":"Há nove coisas que, no meu íntimo, considero felizes, e a décima eu a proclamo com a minha boca: o homem que se alegra com os seus filhos; aquele que vive para ver a ruína dos seus inimigos;"
,"8":"feliz aquele que vive com uma mulher de bom senso; aquele que não faz trabalhar juntos o boi e o burro; aquele que não peca por palavras; aquele que não serve um patrão indigno;"
,"9":"feliz aquele que encontrou a prudência e aquele que fala a quem o escuta."
,"10":"Como é grande aquele que encontrou a sabedoria! Mas ninguém ultrapassa aquele que teme ao Senhor."
,"11":"O temor do Senhor ultrapassa tudo, e a quem será comparado aquele que o possui?"
,"12":"Nenhuma ferida é como a do coração, e maldade nenhuma é como a da mulher!"
,"13":"Nenhuma desgraça é como a causada pelos adversários, e nenhuma vingança é como a dos inimigos."
,"14":"Não há veneno pior do que o veneno da serpente, nem ira pior do que a do inimigo."
,"15":"Prefiro morar com um leão ou dragão do que morar com uma mulher maldosa."
,"16":"A maldade da mulher muda a sua fisionomia, e o seu rosto fica tenebroso como o de um urso."
,"17":"O seu marido vai sentar-se no meio dos vizinhos e, constrangido, suspira amargamente."
,"18":"Qualquer maldade é leve, comparada com a maldade da mulher: caia sobre ela a sorte dos pecadores!"
,"19":"Como ladeira de areia para os pés de um velho, assim é uma mulher linguareira para um marido pacífico."
,"20":"Não te deixes prender pela beleza de uma mulher, nem te apaixones por ela."
,"21":"Motivo de irritação, desprezo e grande vergonha é a mulher sustentar o marido."
,"22":"Coração abatido, rosto triste e coração ferido, é a obra da mulher má."
,"23":"Mãos inertes e joelhos vacilantes, é a mulher que não torna feliz o próprio marido."
,"24":"Foi pela mulher que começou o pecado, e é por culpa dela que todos morremos."
,"25":"Não deixes escapar a água, nem dês liberdade de falar à mulher má."
,"26":"Se não obedece às ordens que lhe dás, separa-te dela."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Feliz o marido que tem uma mulher virtuosa; a duração da sua vida será o dobro."
,"2":"Mulher forte é alegria para o marido, que viverá em paz durante toda a vida."
,"3":"Uma boa mulher é uma sorte grande, que será dada aos que temem o Senhor."
,"4":"Rico ou pobre, estará contente e terá sempre rosto alegre."
,"5":"O meu coração teme três coisas, e uma quarta me assusta: calúnia espalhada pela cidade, revolta do povo e acusação falsa. Tudo isto é pior que a morte."
,"6":"Mas a mulher ciumenta de uma rival causa grande dor e aflição. E a praga da língua é o ponto comum de todas estas coisas."
,"7":"Mulher má é como um jugo mal ajeitado, e querer dominá-la é como pegar num escorpião."
,"8":"Mulher embriagada provoca indignação, e não consegue esconder a sua inconveniência."
,"9":"A má conduta da mulher manifesta-se na excitação dos olhos, e reconhece-se pelas pálpebras."
,"10":"Reforça a vigilância sobre a filha impetuosa, para que ela não se aproveite da tua fraqueza."
,"11":"Cuidado com os seus olhos desavergonhados, e não estranhes que te ofenda."
,"12":"Como viajante sedento, ela abre a boca e bebe qualquer água que encontra; ela senta-se diante de qualquer estaca e abre a aljava a qualquer flecha."
,"13":"Mulher graciosa alegra o marido e fortalece-o com o seu bom proceder."
,"14":"Mulher discreta é dom do Senhor, e mulher bem educada não tem preço."
,"15":"Mulher modesta duplica o seu encanto, e não há valor que pague a mulher casta."
,"16":"Como o sol que se levanta sobre as montanhas do Senhor, assim é a beleza da mulher na sua casa bem arrumada."
,"17":"Como lâmpada que brilha no candelabro sagrado, tal é a beleza do rosto num corpo bem acabado."
,"18":"Colunas de ouro sobre bases de prata, assim são as belas pernas sobre sólidos pés."
,"19":"Duas coisas me entristecem e uma terceira me dá raiva: o soldado reduzido à miséria, homens sábios tratados com desprezo, e aquele que passa da justiça para o pecado: a este o Senhor o entregará à morte pela espada."
,"20":"Dificilmente um comerciante fica isento de culpa e um negociante fica livre de pecado."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Muitos pecam por amor ao lucro, e quem procura enriquecer age sem escrúpulos."
,"2":"Entre as junturas das pedras finca-se a estaca, e entre a compra e a venda o pecado se infiltra."
,"3":"Se a pessoa não se agarra com firmeza ao temor do Senhor, a sua casa em breve será destruída."
,"4":"Quando se agita a peneira, ficam os restos, e quando a pessoa discute aparecem os seus defeitos."
,"5":"O forno prova os vasos do oleiro, e a prova do homem está no seu raciocínio."
,"6":"O fruto da árvore mostra como ela foi cultivada, e a palavra revela o íntimo do homem."
,"7":"Nunca elogies um homem antes de o ouvires falar, porque o falar prova quem são as pessoas."
,"8":"Se procurares a justiça, certamente a encontrarás, e revestir-te-ás dela como de roupa de festa."
,"9":"Cada passarinho aninha-se com outros da mesma espécie, e a verdade volta para aqueles que a praticam."
,"10":"O leão espreita a presa, e o pecado espreita aqueles que praticam a injustiça."
,"11":"O homem fiel fala sempre com sabedoria, mas o insensato muda como a Lua."
,"12":"Mede o tempo quando estiveres entre os insensatos, mas demora-te quando estiveres entre os sábios."
,"13":"A conversa dos insensatos é detestável, e o seu riso é orgia de pecado."
,"14":"A conversa de quem faz frequentes juramentos faz eriçar os cabelos, e suas discussões obrigam a tapar os ouvidos."
,"15":"A contenda entre orgulhosos faz derramar sangue, e os seus insultos ofendem os ouvidos."
,"16":"Quem revela o segredo de um amigo destrói a confiança, e nunca mais encontrará um amigo íntimo."
,"17":"Ama o teu amigo e sê leal para com ele. Contudo, se revelaste os seus segredos, não voltes para junto dele."
,"18":"Porque, assim como se perde uma pessoa que morre, da mesma forma perdeste a amizade do teu próximo."
,"19":"Como alguém que deixa fugir o pássaro que tem na mão, assim deixaste escapar o teu amigo, e nunca mais conseguirás apanhá-lo."
,"20":"Não corras atrás dele, pois ele já foi para longe, fugindo como gazela que escapou da armadilha."
,"21":"Uma ferida pode ser curada, e pode-se perdoar um insulto, mas quem revelou segredos perdeu toda a esperança."
,"22":"Quem pisca um olho está a planear maldade, mas quem o conhece afasta-se dele."
,"23":"Diante de ti falará com delicadeza e elogia o que dizes, mas por detrás muda de linguagem e arma ciladas às tuas palavras."
,"24":"Eu detesto muitas coisas, e a esse muito mais, e também o Senhor o detesta."
,"25":"Atira uma pedra ao ar e ela cairá sobre a tua cabeça; assim a ofensa da traição também atingirá o traidor."
,"26":"Quem cava um buraco, nele cairá; quem prepara uma armadilha, ficará preso nela."
,"27":"O mal volta-se contra quem o pratica, sem que a pessoa saiba de onde ele vem."
,"28":"Sarcasmo e ultraje são próprios do soberbo, mas a vingança espreita-o como um leão."
,"29":"Os que se alegram com a queda dos fiéis serão apanhados na própria armadilha e, antes de morrer, a dor consumi-los-á."
,"30":"Rancor e cólera são coisas abomináveis, mas o pecador conserva-as no coração."
}`)
	CurrentBook.AddChapter(28, `{
"1":"Quem se vinga sofrerá a vingança do Senhor, que severamente lhe pedirá contas dos seus pecados."
,"2":"Perdoa ao teu próximo o mal que te fez e, quando o pedires na oração, Deus também te perdoará os pecados que tiveres cometido."
,"3":"Se um homem guarda rancor contra outro, como poderá pedir a Deus que o cure?"
,"4":"Se não usa de misericórdia para com o seu semelhante, como se atreve a pedir perdão dos seus próprios pecados?"
,"5":"Se ele, que é carne, guarda rancor, quem perdoará os seus pecados?"
,"6":"Lembra-te do teu fim, e deixa de odiar. Lembra-te da corrupção e da morte, e persevera nos mandamentos."
,"7":"Lembra-te dos mandamentos, e não guardes rancor contra o teu próximo. Lembra-te da aliança com o Altíssimo, e não leves em conta a ofensa que te fizeram."
,"8":"Fica longe das discussões, e evitarás o pecado, porque o homem raivoso atiça a briga."
,"9":"O homem pecador provoca discórdia entre os amigos e desavença entre os que vivem em paz."
,"10":"Quanto mais lenha, tanto mais arde o fogo, e quanto mais teimosia, tanto mais aumenta a briga. O furor de um homem depende da sua força, e a sua cólera é proporcional à sua riqueza."
,"11":"A luta repentina acende o fogo, e a briga violenta derrama sangue."
,"12":"Se sopras numa fagulha, ela inflama-se, e se lhe cospes em cima, ela apaga-se. Note bem que as duas coisas saem da mesma boca."
,"13":"Amaldiçoai o difamador e o homem falso, porque são a ruína de muitos que vivem em paz."
,"14":"A língua intrometida inquieta muitos, fazendo-os fugir de nação para nação; ela destrói cidades fortes e devasta as casas dos poderosos."
,"15":"A língua intrometida faz com que mulheres excelentes sejam repudiadas, privando-as do fruto dos seus trabalhos."
,"16":"Quem lhe dá ouvidos nunca mais encontra descanso nem tranquilidade em casa."
,"17":"A chicotada deixa marca, mas o golpe da língua quebra os ossos."
,"18":"Muitos já caíram ao fio da espada, mas não foram tantos como as vítimas da língua."
,"19":"Feliz de quem se protege dela e não se expõe ao seu furor. Feliz de quem se livrou do seu jugo e não se deixou enredar nas suas cadeias."
,"20":"De facto, o seu jugo é de ferro, e as suas cadeias são de bronze."
,"21":"A morte que ela provoca é terrível, e é preferível estar no túmulo."
,"22":"Ela, porém, não tem poder sobre os homens fiéis, os quais não serão devorados pelas suas chamas."
,"23":"Os que abandonam o Senhor nela cairão, e ela os consumirá sem se apagar; lançar-se-á contra eles como um leão, e como uma pantera os despedaçará."
,"24":"Atenção! Protege a tua propriedade com uma cerca de espinhos e guarda bem o teu ouro e prata."
,"25":"Pesa na balança as tuas palavras, e fecha a boca com porta de ferrolho."
,"26":"Toma cuidado em não tropeçares com a língua, para não caíres diante dos inimigos que te espreitam."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Quem é misericordioso faz empréstimos ao próximo, e quem lhe estende a mão cumpre os mandamentos."
,"2":"Empresta ao próximo quando ele tiver necessidade, e devolve ao próximo no tempo combinado."
,"3":"Mantém a palavra dada e sê fiel com o próximo, e em qualquer momento encontrarás o que precisas."
,"4":"Muitos consideram o empréstimo como se fosse coisa achada, e deixam os credores em dificuldade."
,"5":"Antes de receberem, beijam a mão do credor e amaciam a voz para conseguirem os bens do próximo. No momento da restituição, porém, adiam a data, respondem com palavras evasivas e culpam as circunstâncias."
,"6":"Mesmo quando podem pagar, com dificuldade o credor recupera metade, e pode considerar isso como um achado. Caso contrário, o credor ficará sem os bens que emprestou e, além disso, ganhará sem motivo um inimigo. Este pagar-lhe-á com maldições e injúrias e, em vez de agradecer, desprezá-lo-á."
,"7":"Muitos, por causa de tais maldades, recusam-se a fazer empréstimos, com medo de perder os bens sem mais nem menos."
,"8":"Todavia sê compreensivo para com o pobre, e não o faças esperar muito pela esmola."
,"9":"Por causa do mandamento, socorre o indigente conforme a sua necessidade. Não o despeças de mãos vazias."
,"10":"Perde o teu dinheiro com o irmão e o amigo, para que não enferruje inutilmente debaixo de uma pedra."
,"11":"Usa os teus bens segundo os mandamentos do Altíssimo, e ser-te-ão mais úteis do que o ouro."
,"12":"Dá esmola daquilo que tens nos celeiros, e ela te livrará de qualquer desgraça;"
,"13":"mais do que forte escudo e lança pesada, combaterá por ti contra o teu inimigo."
,"14":"O homem bom dispõe-se a ser fiador do seu próximo, mas aquele que perdeu a vergonha abandona-o."
,"15":"Não te esqueças do favor prestado pelo teu fiador, pois ele expôs-se por ti."
,"16":"O pecador aproveita-se dos bens do seu fiador, e o ingrato abandona propositadamente quem o ajudou."
,"17":"A fiança já arruinou muitos que prosperavam e agitou-os como ondas do mar."
,"18":"Ela deixou sem casa homens poderosos, que foram obrigados a peregrinar por terras estrangeiras."
,"19":"O pecador que se apressa em ser fiador em busca de lucro, acabará nos tribunais."
,"20":"Ajuda o teu próximo conforme as tuas posses, mas toma cuidado não te arruínes tu também."
,"21":"São coisas indispensáveis para a vida: água, pão, roupa e casa para preservar a própria intimidade."
,"22":"É melhor viver vida de pobre numa barraca, do que banquetear-se em casa alheia."
,"23":"Contenta-te com o pouco ou muito que tiveres, e não serás desprezado como imigrante."
,"24":"É vida dura andar de casa em casa, porque por onde andas és como um imigrante e não podes abrir a boca."
,"25":"Serás recebido como um estranho, beberás constrangido, e ainda ouvirás coisas desagradáveis:"
,"26":"«Vem, forasteiro, põe a mesa e, se houver alguma coisa, dá-me de comer»."
,"27":"Ou: «Sai, forasteiro! Dá o teu lugar a uma pessoa mais digna. Preciso da casa para hospedar o meu irmão»."
,"28":"Ser censurado pelo dono da casa e insultado pelo credor são coisas duras para um homem sensato."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Quem ama o próprio filho, castiga-o com frequência, para no fim se alegrar."
,"2":"Quem corrige o próprio filho, depois terá satisfação, e orgulhar-se-á dele na frente dos conhecidos."
,"3":"Quem educa o próprio filho faz inveja ao inimigo, e alegra-se diante dos amigos."
,"4":"O pai morre, mas é como se não tivesse morrido, porque deixa depois de si alguém semelhante a ele."
,"5":"Durante a vida, o pai alegra-se ao ver o filho, e não fica triste na hora da morte."
,"6":"Para os inimigos, deixa um vingador; para os amigos, deixa alguém que irá recompensá-los."
,"7":"Quem mima o próprio filho, depois terá que lhe curar as feridas, e, a cada grito dele, as suas entranhas estremecerão."
,"8":"O cavalo indomado torna-se intratável, e o filho entregue a si mesmo torna-se teimoso."
,"9":"Dá muito mimo a teu filho, e ele far-te-á surpresas desagradáveis; segue os seus caprichos, e ele te entristecerá."
,"10":"Não rias com ele, e com ele também não irás chorar, para que não acabes rangendo os dentes."
,"11":"Não lhe dês liberdade na juventude, nem feches os olhos aos seus defeitos."
,"12":"Obriga-o a curvar o pescoço enquanto é jovem, e bate-lhe nas costas enquanto é menino, para que não cresça teimoso, não te desobedeça e não te cause muito sofrimento."
,"13":"Corrige o teu filho e torna-o responsável, para que não te desonre com a sua insolência."
,"14":"É melhor um pobre robusto e sadio do que um rico cheio de doenças."
,"15":"Saúde e vigor valem mais do que todo o ouro, e é melhor um corpo robusto que uma enorme fortuna."
,"16":"Não há riqueza maior que a saúde do corpo, nem maior satisfação que um coração contente."
,"17":"É melhor a morte do que uma vida amargurada, e o descanso eterno vale mais do que uma doença crónica."
,"18":"Boa comida diante de boca fechada é como oferta de alimentos em cima de um túmulo."
,"19":"De que serve oferecer frutos ao ídolo? Ele não come nem tem olfacto. Assim é aquele que é perseguido pelo Senhor:"
,"20":"observa e suspira, como um eunuco abraçado a uma jovem."
,"21":"Não te deixes dominar pela tristeza, nem te aflijas com preocupações."
,"22":"A alegria do coração é vida para o homem, e a satisfação prolonga-lhe a vida."
,"23":"Anima-te, consola o coração e afasta a melancolia para longe. Pois a melancolia já arruinou muita gente, e não serve para nada."
,"24":"Inveja e ira encurtam os anos, e a preocupação faz envelhecer antes do tempo."
,"25":"Coração alegre favorece o bom apetite e faz sentir o gosto da comida."
}`)
	CurrentBook.AddChapter(31, `{
"1":"A insónia por causa da riqueza consome o corpo, e a preocupação que ela provoca afasta o sono."
,"2":"As preocupações do dia não deixam dormir, e são piores que doença grave para tirar o sono."
,"3":"O rico afadiga-se para acumular riquezas e, quando descansa, afoga-se em prazeres."
,"4":"O pobre afadiga-se, consumindo as suas forças e, quando descansa, cai na miséria."
,"5":"Quem ama o ouro não se conserva justo, e quem corre atrás do lucro, com ele se perderá."
,"6":"Muitos foram vítimas do ouro, e a sua ruína foi inevitável."
,"7":"É uma armadilha para os que com ele se entusiasmam, e todo o insensato é apanhado nela."
,"8":"Feliz o rico que se conserva íntegro e não corre atrás do ouro."
,"9":"Quem é esse homem? Nós o felicitaremos, porque realizou uma coisa maravilhosa no meio do seu povo."
,"10":"Quem sofreu essa prova e se revelou perfeito? Tal facto será para ele motivo de glória. Quem podia violar a lei e não a violou? E quem podia fazer o mal e não o fez?"
,"11":"A bondade dessa pessoa será confirmada, e a assembleia celebrará a sua generosidade."
,"12":"Estás sentado diante de uma farta mesa? Não escancares a boca diante dela, nem digas: «Quanta coisa!»"
,"13":"Lembra-te: olhar ávido é coisa má. Existe criatura pior que o olho? É por isso que o olho lacrimeja por qualquer motivo."
,"14":"Não estendas a mão para onde outro estiver olhando, nem te precipites com ele para o mesmo prato."
,"15":"Compreende o que o teu próximo quer, a partir do que tu mesmo queres. Pensa naquilo que te desagrada."
,"16":"Come educadamente o que te oferecerem e não mastigues de boca aberta, para não seres desagradável."
,"17":"Por educação sê o primeiro a acabar de comer e não sejas guloso, para que não te desprezem."
,"18":"Se estiveres sentado entre muitos convidados, não sejas o primeiro a estender a mão."
,"19":"O homem bem educado satisfaz-se com pouca coisa e, quando vai para a cama, não se sente sufocado."
,"20":"O sono saudável depende do estômago moderado: a gente levanta-se cedo e com boa disposição. O homem guloso é sempre acompanhado por mal-estar, insónia, náusea e cólicas."
,"21":"Porém, se foste forçado a comer muito, levanta-te, vai vomitar, e ficarás aliviado."
,"22":"Escuta-me, filho, não me desprezes, e compreenderás o que te estou a dizer. Sê moderado em tudo o que fizeres, e nenhuma doença te atingirá."
,"23":"Muitos farão elogios a quem é pródigo em dar banquetes, e o testemunho sobre a sua generosidade é verdadeiro."
,"24":"A cidade inteira critica quem é mesquinho ao dar banquete, e é verdadeiro o testemunho sobre a sua mesquinhez."
,"25":"Não te armes em valente com o vinho, porque ele já arruinou muita gente."
,"26":"A fornalha prova a têmpera do metal, e o vinho esquenta a briga dos arrogantes."
,"27":"O vinho dá vida aos homens, desde que seja bebido com moderação. Que vida existe quando falta vinho? Ele foi criado para alegrar as pessoas."
,"28":"Bebido na devida altura e na medida certa, o vinho traz gozo ao coração e alegria à alma."
,"29":"Todavia, bebido em excesso, por vício ou desafio, o vinho traz amargura à alma."
,"30":"A embriaguez aumenta a ira do insensato para sua própria ruína, diminuindo-lhe as forças e provocando ferimentos."
,"31":"Num banquete, não repreendas o próximo, nem zombes por ele estar alegre; não o reproves com palavras, nem o atormentes com reclamações."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Pediram-te para presidires a um banquete? Não te envaideças, mas comporta-te com os outros como se fosses um deles. Cuida de cada um, e depois senta-te."
,"2":"Tendo providenciado o que cada um necessita, acomoda-te para te alegrares com ele e receberes a coroa pelo teu bom desempenho."
,"3":"Fala, ó ancião, pois isso te convém, mas fala com discrição e não atrapalhes a música."
,"4":"Não fales durante o espectáculo, e não exibas a tua sabedoria fora de tempo."
,"5":"Como rubi em anel de ouro, assim é uma audição musical durante um banquete."
,"6":"Como esmeralda engastada em ouro, assim é uma ária musical unida ao vinho delicioso."
,"7":"Fala, ó jovem, se for necessário, mas apenas umas duas vezes, quando interrogado."
,"8":"Resume o que tens a dizer, e diz muito em poucas palavras. Procura ser como alguém que sabe, mas se cala."
,"9":"Não procures impor-te no meio dos grandes, nem fiques tagarelando enquanto outro fala."
,"10":"Antes do trovão vem o raio, e a graça precede o homem modesto."
,"11":"Quando chegar a hora levanta-te, e não te demores. Volta para casa, em vez de andares a vagabundear."
,"12":"Em casa poderás divertir-te e fazer o que desejares, mas não peques falando com insolência."
,"13":"Por tudo isto, agradece ao teu Criador, que te enche de benefícios."
,"14":"Quem teme o Senhor aceita a correcção, e aqueles que O buscam encontram o seu favor."
,"15":"Quem investiga a Lei, dela ficará saciado, mas para o hipócrita ela é motivo de queda."
,"16":"Os que temem o Senhor encontram a justiça, e as suas acções justas brilham como luz."
,"17":"O homem pecador não aceita a correcção, e encontra sempre desculpas para seguir os próprios caprichos."
,"18":"O homem de bom senso não deixa de reflectir, enquanto o estrangeiro e o orgulhoso não conhecem o temor."
,"19":"Não faças nada sem reflectir, e não mudes de ideia enquanto ages."
,"20":"Não andes por caminhos acidentados, e não tropeçarás nas pedras."
,"21":"Não confies no caminho que não tem obstáculos,"
,"22":"e sê cauteloso até com os teus filhos."
,"23":"Em tudo o que fazes, acredita em ti mesmo, porque também isso é observar os mandamentos."
,"24":"Quem acredita na Lei, observa os mandamentos; quem confia no Senhor, não ficará frustrado."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Quem teme o Senhor não sofre nenhum mal, e se passar por alguma tentação, ficará livre dela."
,"2":"O homem sábio não odeia a Lei, mas quem finge amá-la é como navio na tempestade."
,"3":"O homem de bom senso confia na Lei; para ele, a Lei é digna de confiança como a resposta de um oráculo."
,"4":"Prepara o teu discurso, e serás ouvido; concentra as tuas ideias e depois responde."
,"5":"As emoções do insensato são como roda de carro, e o seu raciocínio é como um eixo que gira."
,"6":"O amigo zombador é como o cavalo no cio: relincha sem-pre, qualquer que seja o cavaleiro que o monta."
,"7":"Porque é que um dia é mais importante do que o outro, se a luz de cada dia do ano vem sempre do Sol?"
,"8":"Eles foram separados no pensamento do Senhor, que diferenciou as estações do ano e as festas."
,"9":"Elevou e consagrou alguns deles, e deixou outros como dias comuns."
,"10":"Também os homens vêm todos do mesmo solo, e da terra é que Adão foi criado."
,"11":"Mas o Senhor, na sua grande sabedoria, distinguiu-os, e diversificou os seus caminhos."
,"12":"A uns, abençoou-os e exaltou-os, consagrando-os e aproximando-os de Si; a outros amaldiçoou-os e humilhou-os, derrubando-os das suas posições."
,"13":"Como argila na mão do oleiro, que ele molda conforme quer, assim são os homens nas mãos do seu Criador, que lhes retribuirá segundo o seu julgamento."
,"14":"Diante do mal está o bem, diante da morte está a vida, e diante do fiel está o pecador."
,"15":"Considera, portanto, todas as obras do Altíssimo que, duas a duas, estão todas uma em frente da outra."
,"16":"Quanto a mim, o último a chegar, vigiei como aquele que apanha o rebusco atrás dos vindimadores."
,"17":"Com a bênção do Senhor, atingi a meta, e como o vindimador, enchi o tanque de espremer uvas."
,"18":"Olhai que não me afadiguei só para mim, mas para todos aqueles que procuram a instrução."
,"19":"Escutai, chefes do povo, e ouvi-me, presidentes da assembleia."
,"20":"Enquanto viveres, não concedas autoridade sobre ti ao teu filho, mulher, irmão e amigo. Não dês os teus bens a outro, para depois não te arrependeres de voltar a pedir-lhos."
,"21":"Enquanto estiveres vivo e tiveres um sopro de vida, não te entregues ao poder de ninguém."
,"22":"É melhor que teus filhos te peçam, do que tu dependeres deles."
,"23":"Em tudo o que fazes, procura ser sempre senhor dos teus actos, e não deixes que se manche a tua boa fama."
,"24":"Quando chegar o fim dos dias da tua vida, no momento da morte, reparte a herança."
,"25":"Para o asno, forragem, chicote e carga; para o escravo, pão, correcção e trabalho."
,"26":"Faz trabalhar o teu escravo com disciplina, e encontrarás sossego. Deixa-o com as mãos livres, e ele procurará a liberdade."
,"27":"Jugo e rédea dobram o pescoço; torturas e interrogatório dobram o mau escravo."
,"28":"Manda-o trabalhar, para que não fique ocioso, porque a ociosidade ensina muitos males."
,"29":"Obriga-o ao trabalho que lhe compete; e, se não obedecer, prende-o com correntes."
,"30":"Entretanto, não cometas excessos com ninguém, e não pratiques nada contra a justiça."
,"31":"Se só tens um escravo, trata-o como a ti mesmo, pois compraste-o a preço de sangue."
,"32":"Se só tens um escravo, trata-o como irmão, porque precisas dele, como de ti mesmo."
,"33":"Se o maltratares, ele fugirá, e por qual caminho irás procurá-lo?"
}`)
	CurrentBook.AddChapter(34, `{
"1":"O insensato tem esperanças vãs e ilusórias, e os imbecis voam com os sonhos."
,"2":"Quem confia nos sonhos é como quem agarra as sombras ou persegue o vento."
,"3":"A visão dos sonhos é um simples reflexo, é como imagem do rosto diante do espelho."
,"4":"Do impuro, o que pode sair de puro? E que verdade se pode tirar da mentira?"
,"5":"Adivinhações, presságios e sonhos são coisas inúteis, como as imaginações da mulher em dores de parto."
,"6":"Se não forem enviados pelo Altíssimo numa das suas visitas, não lhes dês atenção."
,"7":"Os sonhos fizeram com que muitos se perdessem, e muitos que neles esperaram acabaram por cair."
,"8":"A perfeição da Lei está além dessas mentiras, e a sabedoria é perfeita para a boca do fiel."
,"9":"O homem que muito viajou conhece muitas coisas, e quem tem muita experiência fala com discernimento."
,"10":"Quem não foi provado conhece pouco, mas quem muito viaja é rico em experiência."
,"11":"Vi muitas coisas nas minhas viagens, e o meu conhecimento ultrapassa as minhas palavras."
,"12":"Muitas vezes estive em perigo de morte, mas fui salvo graças à minha experiência."
,"13":"O espírito daqueles que temem o Senhor viverá, porque a sua esperança está em alguém que pode salvá-los."
,"14":"Quem teme o Senhor não tem medo de nada e não se assusta, porque o Senhor é a sua esperança."
,"15":"Feliz aquele que teme o Senhor. Em quem se apoia? Quem é que o sustenta?"
,"16":"O Senhor cuida daqueles que O amam. Ele é escudo poderoso e sustentáculo forte, abrigo contra o vento sufocante e abrigo contra o ardor do meio-dia, protecção contra os obstáculos e socorro contra as quedas."
,"17":"O Senhor eleva a alma e ilumina os olhos, concedendo saúde, vida e bênção."
,"18":"Oferecer sacrifícios de bens mal adquiridos é fazer zombaria, e as ofertas dos infiéis não são agradáveis."
,"19":"O Altíssimo não gosta das ofertas dos injustos e não é pela abundância das vítimas que Ele perdoa os pecados."
,"20":"Como quem imola o filho na presença do próprio pai, assim é aquele que oferece sacrifícios com os bens dos pobres."
,"21":"O pão dos indigentes é a vida dos pobres, e quem tira a vida dos pobres é assassino."
,"22":"Mata o próximo quem lhe tira os meios de vida, e derrama sangue quem priva o operário do seu salário."
,"23":"Um constrói e outro derruba. Que proveito tiram disso, além da fadiga?"
,"24":"Um abençoa, outro amaldiçoa. Qual dos dois será ouvido pelo Senhor?"
,"25":"Um purifica-se do contacto com um cadáver, e depois toca-lhe de novo. Que proveito tira da sua purificação?"
,"26":"Assim é o homem que jejua pelos seus pecados, mas depois vai e comete-os de novo. Quem ouvirá a sua súplica? De que serviu a sua humilhação?"
}`)
	CurrentBook.AddChapter(35, `{
"1":"Observar a Lei vale mais do que oferecer sacrifícios, e observar os mandamentos é como oferecer sacrifício de comunhão."
,"2":"Retribuir um favor é como oferecer flor de farinha, e dar esmola é como oferecer sacrifício de louvor."
,"3":"O que agrada ao Senhor é afastar-se do mal, e o sacrifício pelo pecado é afastar-se da injustiça."
,"4":"Não te apresentes de mãos vazias diante do Senhor, pois tudo isto é exigido pelos mandamentos."
,"5":"A oferta do justo alegra o altar, e o seu perfume sobe até ao Altíssimo."
,"6":"O sacrifício do justo é aceite, e o seu memorial não ficará esquecido."
,"7":"Glorifica o Senhor com generosidade, e não sejas mesquinho nos primeiros frutos que ofereces."
,"8":"Quando ofereceres alguma coisa, apresenta um rosto alegre, e consagra o dízimo com boa vontade."
,"9":"Oferece ao Altíssimo conforme o dom que Ele te fez; dá com generosidade, segundo as tuas possibilidades."
,"10":"Porque o Senhor retribui a oferta e Ele, em troca, te dará sete vezes mais."
,"11":"Não tentes subornar a Deus, porque Ele não aceitará o suborno. Não confies num sacrifício injusto,"
,"12":"porque o Senhor é juiz que não faz diferença entre as pessoas."
,"13":"Ele não dá preferência a ninguém contra o pobre. Pelo contrário, atende a súplica do oprimido."
,"14":"Ele não despreza a súplica do órfão, nem a viúva que desafoga as suas queixas."
,"15":"Será que as lágrimas da viúva não lhe descem pela face, e o seu grito não se levanta contra quem a faz chorar?"
,"16":"Quem serve o Senhor será recebido com benevolência, e a sua súplica chegará até às nuvens."
,"17":"A súplica do pobre penetra as nuvens, e ele não sossega, enquanto ela lá não chegar."
,"18":"Ele não desiste, até que o Altíssimo intervenha para fazer justiça aos justos e realize o julgamento."
,"19":"O Senhor não tardará, nem terá paciência com os injustos,"
,"20":"enquanto não quebrar as costas dos cruéis e tomar vingança das nações;"
,"21":"enquanto não exterminar a multidão dos orgulhosos e quebrar o ceptro dos injustos,"
,"22":"enquanto não retribuir a cada um conforme as suas acções e julgar as acções humanas segundo as intenções de cada um;"
,"23":"enquanto não fizer justiça ao seu povo e o alegrar com a sua misericórdia."
,"24":"A misericórdia é bem-vinda no tempo da aflição, como as nuvens de chuva no tempo da seca."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Tem compaixão e olha por nós, Senhor Deus do universo. Infunde o teu temor em todas as nações."
,"2":"Levanta a tua mão contra as nações estrangeiras, para que vejam o teu poder."
,"3":"Castigando-nos, mostraste às nações a tua santidade. Agora, mostra-nos a tua grandeza, castigando as nações."
,"4":"Deste modo reconhecerão, como também nós reconhecemos, que não existe outro Deus além de Ti, Senhor."
,"5":"Renova os sinais e realiza outros prodígios. Glorifica a tua mão e o teu braço direito."
,"6":"Desperta o teu furor e derrama a tua ira, para destruir o adversário e abater o inimigo."
,"7":"Apressa o tempo e lembra-Te do juramento, e assim os teus grandes feitos serão proclamados."
,"8":"Que o sobrevivente seja devorado pela ira do fogo, e os que maltratam o teu povo encontrem a ruína."
,"9":"Esmaga a cabeça dos chefes inimigos, que dizem: «Não há ninguém como nós!»"
,"10":"Reúne todas as tribos de Jacob e dá-lhes a herança, como no princípio."
,"11":"Senhor, tem piedade do povo que é chamado com o teu nome. Tem pie-dade de Israel, que trataste como primogénito."
,"12":"Tem compaixão de Jerusalém, tua cidade santa e lugar do teu repouso."
,"13":"Enche Sião com o relato das tuas maravilhas, e o teu povo com a tua glória."
,"14":"Dá testemunho diante das tuas criaturas, que existem desde o princípio, e cumpre as profecias feitas em teu nome."
,"15":"Recompensa aqueles que esperam em Ti, e que os teus profetas sejam dignos de crédito."
,"16":"Senhor, ouve a oração dos teus servos, segundo a bênção de Aarão sobre o teu povo."
,"17":"E todos os que habitam a Terra reconheçam que és o Senhor, o Deus dos séculos."
,"18":"O estômago consome toda a espécie de alimentos, mas um alimento é melhor que outro."
,"19":"O paladar distingue o gosto da caça, e a mente sábia discerne as palavras mentirosas."
,"20":"Coração perverso causa tristeza, mas o homem experiente acalma-o."
,"21":"A mulher aceita qualquer marido, mas as mulheres não são todas iguais."
,"22":"A beleza da mulher alegra o rosto e supera todos os desejos do homem."
,"23":"Se nos seus lábios existe bondade e doçura, o seu marido é o mais feliz dos homens."
,"24":"Quem adquire esposa tem o começo da fortuna, pois ela é auxiliar semelhante a ele e coluna de apoio."
,"25":"Onde não há cerca, a propriedade é saqueada, e onde não há mulher, o homem vagueia gemendo."
,"26":"Quem confia em ladrão esperto que corre de cidade em cidade?"
,"27":"Assim é o homem que não tem ninho e se deita onde a noite o surpreende."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Todo o amigo declara amizade, mas há amigos que só o são de nome."
,"2":"Acaso não é tristeza mortal o companheiro ou amigo que se transforma em inimigo?"
,"3":"Ó inclinação perversa! De onde saíste para cobrir a terra com traição?"
,"4":"O companheiro alegra-se com o amigo na felicidade, mas no momento da desgraça torna-se hostil."
,"5":"O companheiro sofre com o amigo por interesse, mas no momento da contenda toma o escudo."
,"6":"No teu coração não te esqueças do amigo, e não te esqueças dele quando estiveres na prosperidade."
,"7":"Todo o conselheiro dá conselhos, mas há quem dá conselhos no seu próprio interesse."
,"8":"Sê cauteloso com o conselheiro, e procura saber quais são as suas necessidades. Pois ele pode aconselhar em benefício próprio e não lançar a sorte em teu favor,"
,"9":"dizendo: «Estás no bom caminho». Depois, afasta-se para ver o que te vai acontecer."
,"10":"Não peças conselhos a quem te olha com desconfiança, e esconde a tua intenção a todos os que têm inveja de ti."
,"11":"Nunca peças conselhos a uma mulher sobre a sua rival: nem a um covarde sobre a guerra; nem a um negociante sobre o comércio; nem a um comprador sobre a venda; nem a um invejoso sobre a gratidão; nem a um egoísta sobre a bondade; nem a um preguiçoso sobre o trabalho; nem a um empreiteiro sobre o fim da obra; nem a um empregado preguiçoso sobre um grande trabalho. Não procures nenhuma destas pessoas para lhes pedires algum conselho."
,"12":"Pelo contrário, frequenta sempre o homem fiel, a quem conheces como praticante dos mandamentos, que tenha uma disposição igual à tua e que, se tropeçares, sofrerá contigo."
,"13":"Segue o conselho do teu próprio coração, porque ninguém te será mais fiel do que ele."
,"14":"A alma do homem frequentemente o avisa melhor do que sete sentinelas colocadas em lugar alto."
,"15":"Além disto tudo, pede ao Altíssimo que dirija o teu comportamento conforme a verdade."
,"16":"A palavra é o princípio de qualquer obra, e, antes de agir, é preciso reflectir."
,"17":"A raiz dos pensamentos é a mente, e ela produz quatro ramos:"
,"18":"bem e mal, vida e morte. Mas os quatro são dominados pela língua."
,"19":"Há quem seja capaz de instruir muitas pessoas, mas é inútil para si mesmo."
,"20":"Há quem ostente sabedoria em palavras, mas é detestado e acaba por morrer à fome."
,"21":"Porque o Senhor não lhe concede a sua graça, ele fica desprovido de qualquer sabedoria."
,"22":"Há quem seja sábio só para si, e os frutos seguros da sua inteligência estão na sua própria boca."
,"23":"O homem sábio instrui o seu povo. Todos podem confiar nos frutos da sua inteligência."
,"24":"O homem sábio é cumulado de bênçãos, e é proclamado feliz por todos os que o vêem."
,"25":"A vida do homem tem os dias contados, porém os dias de Israel são incontáveis."
,"26":"O sábio gozará de confiança no meio do seu povo, e o seu nome viverá para sempre."
,"27":"Meu filho, prova-te a ti mesmo durante a tua vida. Vê o que é prejudicial, e não o concedas a ti próprio."
,"28":"Nem tudo convém a todos, nem todos gostam de tudo."
,"29":"Não sejas insaciável de prazeres, nem te precipites sobre os pratos e comida."
,"30":"Porque o abuso na comida provoca doenças, e a gula produz cólicas."
,"31":"Muitos morreram por causa da gula, e quem sabe controlar-se vive muito tempo."
}`)
	CurrentBook.AddChapter(38, `{
"1":"também o médico foi criado pelo Senhor."
,"2":"Do Altíssimo vem a cura, e o médico recebe do rei o pagamento."
,"3":"A ciência do médico fá-lo levantar a cabeça e ser admirado pelos grandes."
,"4":"Da terra, o Senhor criou os remédios, e o homem de bom senso não os despreza."
,"5":"Não foi para manifestar o poder do Senhor que as águas foram adoçadas com um pedaço de madeira?"
,"6":"O Senhor deu aos homens a ciência para que pudessem glorificá-l'O pelas suas maravilhas."
,"7":"Com elas, o médico cura e elimina a dor, e o farmacêutico prepara as fórmulas."
,"8":"Desta maneira, as obras de Deus não têm fim, e d'Ele vem o bem-estar para a terra."
,"9":"Meu filho, se adoeceres, não te descuides. Suplica ao Senhor, e Ele te curará."
,"10":"Evita as faltas, lava as mãos e purifica o coração de todo o pecado."
,"11":"Oferece incenso e um memorial de flor de farinha, e faz gordas ofertas, conforme as tuas possibilidades."
,"12":"Depois, consulta o médico, pois também ele foi criado pelo Senhor. Não o afastes, porque precisas dele."
,"13":"Há casos em que a cura depende só dele."
,"14":"Ele também suplica ao Senhor, a fim de que o ajude a aliviar a doença e curar os seus pacientes."
,"15":"Quem peca contra o seu Criador, que caia nas mãos do médico!"
,"16":"Meu filho, derrama lágrimas pelo morto, e faz luto como alguém que sofre profundamente. Depois enterra o cadáver segundo o costume, e não deixes de honrar o seu túmulo."
,"17":"Chora amargamente, bate no peito e observa o luto proporcional à dignidade do morto, durante um ou dois dias, para evitar os comentários do povo; e depois consola-te da tua tristeza."
,"18":"Porque a tristeza leva à morte, e qualquer aflição do coração consome as forças."
,"19":"Na desgraça a tristeza permanece, e uma vida triste é insuportável."
,"20":"Não entregues o teu coração à tristeza, mas afasta-a, pensando no fim que terás."
,"21":"Não te esqueças: da morte não há retorno. A tua tristeza em nada servirá ao morto, e acabarás por te prejudicar."
,"22":"Lembra-te: a sorte dele será também a tua. Eu ontem, e tu hoje."
,"23":"Quando o morto repousa, deixa de pensar nele. Consola-te, porque o espírito dele já partiu."
,"24":"A sabedoria do escriba é adquirida em horas de lazer. Aquele que está livre de actividades torna-se sábio."
,"25":"Como poderá tornar-se sábio aquele que maneja o arado e cuja glória consiste em manejar o ferrão? Como pode tornar-se sábio aquele que guia bois, não abandona o trabalho e só sabe falar de vitelos?"
,"26":"Só se preo-cupa com os sulcos que traça, e fica sem dormir, preocupado com a forragem das vacas."
,"27":"O mesmo acontece com todo o carpinteiro e construtor, e com qualquer pessoa que trabalha dia e noite: aqueles que fazem entalhes para os selos procuram pacientemente variar o desenho; eles tentam reproduzir o modelo e preocupam-se em terminar o trabalho."
,"28":"Da mesma forma, o ferreiro senta-se diante da bigorna e entrega-se a trabalhar o ferro: a chama de fogo seca-lhe a carne, e debate-se com o calor da forja; o barulho do martelo ensurdece-o e os seus olhos fixam-se no modelo do objecto. Ele esforça-se por acabar o trabalho e procura retocá-lo, até ficar perfeito."
,"29":"O oleiro senta-se para fazer o trabalho, girando a roda com os pés e dedicando total cuidado à sua obra. Todos os seus gestos são calculados:"
,"30":"com o braço modela a argila e com os pés quebra a sua resistência; preocupa-se em acabar o polimento e passa a noite a limpar o forno."
,"31":"Todos estes artesãos confiam nas suas próprias mãos, e cada um é hábil na sua profissão."
,"32":"Sem eles, seria impossível construir uma cidade, e ninguém poderia habitar ou andar nelas."
,"33":"Mas eles não são requisitados no conselho do povo, não têm lugar especial na assembleia, não se sentam na cadeira do juiz, nem conhecem as disposições legais."
,"34":"Não brilham pela cultura, nem pelo julgamento, e não entendem de provérbios. Entretanto, são eles que sustentam as necessidades básicas, e a sua oração consiste em realizar o próprio trabalho."
}`)
	CurrentBook.AddChapter(39, `{
"1":"Diferente é o caso de quem se aplica a meditar a Lei do Altíssimo. Ele investiga a sabedoria de todos os antigos e dedica-se ao estudo das profecias."
,"2":"Preserva as sentenças dos homens famosos e penetra a subtileza das parábolas."
,"3":"Busca o sentido oculto dos provérbios e ocupa-se com os enigmas das parábolas."
,"4":"Desempenha funções entre os grandes e marca presença nas reuniões dos chefes. Viaja entre povos estrangeiros, fazendo a experiência do bem e do mal entre os homens."
,"5":"De manhã cedinho, dirige o coração ao Senhor que o criou e reza diante do Altíssimo, abre a boca para orar e pede perdão dos seus pecados."
,"6":"Se for da vontade do supremo Senhor, ele ficará repleto do espírito de inteligência e fará chover palavras de sabedoria e agradecerá ao Senhor na oração."
,"7":"O Senhor dirigirá os seus conselhos e a sua ciência, e ele meditará nos mistérios divinos."
,"8":"Ele fará brilhar a instrução do seu ensinamento e orgulhar-se-á com a Lei da Aliança do Senhor."
,"9":"Muitos elogiarão a sua inteligência, e nunca será esquecido. Não desaparecerá a sua recordação, e a sua fama viverá de geração em geração."
,"10":"Os povos falarão da sua sabedoria e a assembleia proclamará os seus louvores."
,"11":"Se viver muito tempo, deixará um nome mais famoso que mil outros, e quando morrer, isso lhe bastará."
,"12":"Vou expor agora as minhas reflexões, pois estou repleto delas como a lua cheia."
,"13":"Escutai-me, filhos santos, e crescei como a roseira plantada à beira da água corrente."
,"14":"Espalhai bom perfume como incenso e florescei como o lírio. Espalhai perfume e entoai um cântico, bendizendo ao Senhor por todas as suas obras."
,"15":"Engrandecei o nome do Senhor e proclamai os seus louvores com cânticos e cítaras. Louvá-l'O-eis assim:"
,"16":"Como são magníficas todas as obras do Senhor! Todas as suas ordens são executadas pontualmente. Não é preciso dizer: «O que é isto? Porquê aquilo?» Todas as coisas serão esclarecidas a seu tempo."
,"17":"À sua ordem, a água parou e juntou-se e, à sua voz, formaram-se os reservatórios de água."
,"18":"Sob a sua ordem, tudo o que Ele deseja é realizado, e ninguém pode impedir a sua obra de salvação."
,"19":"Diante d'Ele estão todas as obras dos homens, e nada consegue esconder-se aos seus olhos."
,"20":"O seu olhar estende-se de eternidade em eternidade, e para Ele nada é extraordinário."
,"21":"Não é preciso dizer: «O que é isto? Porquê aquilo?» Pois todas as coisas foram criadas para uma finalidade."
,"22":"A sua bênção é como um rio que transborda, e como o dilúvio que inunda a Terra."
,"23":"Desta forma, as nações experimentam a sua ira, tal como transformou as águas em deserto salgado."
,"24":"Os seus caminhos são rectos para os homens santos, mas para os injustos estão cheios de obstáculos."
,"25":"Desde o princípio, as coisas boas foram criadas para os bons, assim como os males foram criados para os pecadores."
,"26":"Para a vida do homem, as coisas de primeira necessidade são as seguintes: água, fogo, ferro, sal, farinha de trigo, leite, mel, vinho, azeite e vestuário."
,"27":"Todas estas coisas são boas para os fiéis, mas para os pecadores tornam-se más."
,"28":"Há ventos que foram criados para castigar e que, enfurecendo, se tornam flagelo. Quando chegar o fim, eles desencadearão a sua violência e aplacarão o furor do seu Criador."
,"29":"Fogo e granizo, fome e morte foram criadas para castigar."
,"30":"Os dentes das feras, os escorpiões, as cobras e a espada vingadora existem para arruinar os injustos."
,"31":"A uma ordem do Senhor, estas coisas alegram-se e estão prontas na Terra para qualquer necessidade. No tempo oportuno, executarão fielmente as suas ordens."
,"32":"Por isso, desde o início tive a certeza e, depois de reflectir, escrevi:"
,"33":"«Todas as obras do Senhor são boas, e Ele prevê todas as necessidades no momento certo»."
,"34":"Não se pode dizer: «Isto é pior do que aquilo», porque a seu tempo todas as coisas serão reconhecidas como boas."
,"35":"Agora, cantai hinos com o coração e com a boca, e bendizei o nome do Senhor."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Sorte penosa foi criada para cada homem, e jugo pesado foi dado aos filhos de Adão, desde o dia em que saem do ventre materno até ao dia em que voltam para a terra, mãe de todos."
,"2":"O objecto das suas reflexões e o temor do seu coração exprimem a espera pelo dia da morte."
,"3":"Desde aquele que se senta num trono glorioso até ao mendigo sentado no chão e na cinza;"
,"4":"desde aquele que veste púrpura e coroa até ao que se veste com pano grosseiro, tudo é raiva, inveja, ansiedade, inquietação, medo da morte, ressentimento e brigas."
,"5":"Mesmo quando o homem repousa na cama, o sonho nocturno perturba-lhe os pensamentos."
,"6":"Ele repousa pouco, ou quase nada. Mas tanto no sono, como em pleno dia, fica perturbado pelos fantasmas da sua mente, como quem fugiu da linha de batalha."
,"7":"No momento em que está para se salvar, acorda, e fica maravilhado porque não havia nada a temer."
,"8":"Isto acontece a toda a criatura, desde o homem até ao animal, mas para o pecador é sete vezes pior:"
,"9":"morte, sangue, luta, espada, miséria, fome, destruição e flagelos."
,"10":"Tais males foram criados para os injustos, e foi por causa deles que aconteceu o dilúvio."
,"11":"Tudo o que vem da terra volta para a terra, e tudo o que vem da água volta para o mar."
,"12":"Todo o suborno e injustiça desaparecerão, mas a fidelidade permanecerá para sempre."
,"13":"A riqueza dos injustos desaparecerá como torrente, como trovão que ribomba no meio da tempestade."
,"14":"Assim como o injusto se alegrará abrindo as mãos, também os transgressores cairão na ruína."
,"15":"Os rebentos dos injustos não multiplicarão os seus ramos, porque são como raízes impuras sobre pedra dura."
,"16":"São como a vegetação na margem do rio, à beira da água, que é arrancada antes de qualquer outra erva."
,"17":"A bondade é como paraíso de bênçãos, e a misericórdia permanece para sempre."
,"18":"Doce é a vida de quem é autónomo e do trabalhador. No entanto, mais feliz ainda é aquele que encontra um tesouro."
,"19":"Os filhos e a fundação de uma cidade perpetuam o nome, porém acima deles está a mulher irrepreensível."
,"20":"Vinho e música alegram o coração; mas acima deles está o amor à sabedoria."
,"21":"Flauta e harpa tornam agradável o canto, mas superior a elas é a voz melodiosa."
,"22":"A graça e a beleza agradam aos olhos, mas acima deles está o verde dos campos."
,"23":"O amigo ajuda o seu amigo no momento oportuno, mas melhor do que isso é o encontro da mulher com o homem."
,"24":"Irmãos e ajuda são úteis no tempo da aflição, mas superior a eles é a esmola que liberta."
,"25":"Ouro e prata dão firmeza aos pés, mas o conselho supera um e outro."
,"26":"Riqueza e força engrandecem o coração, mas acima delas está o temor do Senhor. Com o temor do Senhor nada falta, e com ele não é preciso buscar outra ajuda."
,"27":"O temor do Senhor é como paraíso de bênçãos, e a sua protecção está acima de qualquer glória."
,"28":"Meu filho, não vivas a mendigar, porque é melhor morrer do que mendigar."
,"29":"A pessoa que fica a olhar para a mesa dos outros tem uma vida que nem se pode chamar vida. Alimenta-se com os manjares dos outros, mas o homem sábio e educado evita fazer isso."
,"30":"Na boca da pessoa que não tem vergonha, mendigar é agradável. Contudo, no seu ventre, isso queima como fogo."
}`)
	CurrentBook.AddChapter(41, `{
"1":"Ó morte, como é amarga a tua lembrança para o homem que vive tranquilo entre os seus bens, para o homem seguro e afortunado em tudo, e ainda com forças para experimentar o prazer!"
,"2":"Ó morte, a tua sentença é bem-vinda para o homem indigente e sem forças, para o velho em idade avançada e preocupado com tudo, para o rebelde que perdeu a paciência!"
,"3":"Tu, porém, não temas a sentença da morte. Lembra-te dos que vieram antes de ti e dos que virão depois."
,"4":"Esta é a sentença do Senhor para todo o ser vivo. Porquê revoltar-se contra a vontade do Altíssimo? Quer vivas dez, cem, ou mil anos, na mansão dos mortos ninguém discutirá sobre a vida."
,"5":"Os filhos dos pecadores tornam-se filhos abomináveis que frequentam a casa dos injustos."
,"6":"A herança dos filhos dos pecadores acabará em ruína, e a desonra ficará para sempre com a sua descendência."
,"7":"Os filhos censuram um pai injusto, porque é por sua causa que eles sofrem a desonra."
,"8":"Ai de vós, homens injustos, que abandonastes a Lei do Deus Altíssimo!"
,"9":"Vós nascestes, mas foi para a perdição. Na hora da morte, tereis por herança a perdição."
,"10":"Tudo o que vem da terra voltará para a terra, e os injustos irão da maldição para a ruína."
,"11":"Os homens fazem luto por um cadáver, mas o nome maldito dos pecadores será apagado."
,"12":"Cuida bem do teu próprio nome, pois ele te acompanhará mais do que mil tesouros preciosos."
,"13":"Nesmo a vida feliz tem os seus dias contados, mas o bom nome permanece para sempre."
,"14":"Meus filhos, conservai em paz as minhas instruções, pois a sabedoria escondida e o tesouro invisível não servem para nada."
,"15":"Mais vale o homem que esconde a sua insensatez do que o homem que esconde a sua sabedoria."
,"16":"Envergonhai-vos apenas nos casos que vou dizer, porque não é bom cultivar qualquer tipo de vergonha, nem tudo é igualmente apreciado por todos."
,"17":"Envergonhai-vos da prostituição diante dos pais, e da mentira diante de um chefe e de um poderoso."
,"18":"Envergonhai-vos de um crime diante do juiz e do magistrado, e da injustiça diante da assembleia e do povo."
,"19":"Envergonha-te da deslealdade diante do companheiro e do amigo, e do roubo diante da vizinhança onde moras."
,"20":"Envergonha-te diante da fidelidade de Deus e da sua aliança, por apoiares os cotovelos à mesa sobre os pães;"
,"21":"por seres desdenhoso ao receber ou dar alguma coisa; por ficares em silêncio diante de quem te cumprimenta;"
,"22":"por dirigires olhares para uma prostituta; por evitares o encontro com um parente;"
,"23":"por te apropriares de uma herança ou doação; por dirigires olhares cobiçosos para uma mulher casada;"
,"24":"por teres relações sexuais com uma escrava - não te aproximes do seu leito -"
,"25":"por dizeres palavras ofensivas aos amigos - não ofendas ninguém depois de lhe teres dado alguma coisa; -"
,"26":"por repetires uma palavra que ouviste; por revelares segredos."
,"27":"Desta forma, terás a verdadeira vergonha e serás estimado por todos."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Contudo, não sintas vergonha das coisas que te vou dizer, e não peques por respeito humano."
,"2":"Não te envergonhes da Lei do Altíssimo, nem da Aliança, nem do julgamento que condena os injustos."
,"3":"Não te envergonhes de fazer as contas com companheiros ou colegas de viagem, nem de partilhar a herança com outras pessoas."
,"4":"Não te envergonhes da exactidão da balança e dos pesos, nem de adquirir muito ou pouco."
,"5":"Não te envergonhes de discutir o preço com o comerciante, nem de corrigir os filhos com severidade, nem de ensanguentar as costas do escravo preguiçoso."
,"6":"Com a mulher curiosa é bom lacrar os documentos, e usa a chave onde houver muitas mãos."
,"7":"Conta e pesa bem tudo o que deixares em depósito, e anota por escrito tudo o que deres ou receberes."
,"8":"Não te envergonhes de corrigir o insensato, o imbecil e o velho decrépito que tenta competir com os jovens. Desta forma, mostrarás que és verdadeiramente instruído, e serás aprovado por todos."
,"9":"Uma filha é para o pai uma preocupação secreta, e o cuidado por ela tira-lhe o sono: quando jovem, receia que ela passe da flor da idade sem se casar e, quando casada, que seja repudiada;"
,"10":"se é virgem, receia que seja violada e fique grávida ainda na casa do pai; se tem marido, receia que erre e, quando casada, que seja estéril."
,"11":"Vigia bem a filha libertina, para que não faça de ti objecto da zombaria dos inimigos, assunto da cidade, ludíbrio do povo, envergonhando-te diante de todos."
,"12":"Não te detenhas na beleza de um ser humano, nem te sentes no meio das mulheres,"
,"13":"porque da roupa sai a traça, e da mulher a malícia feminina."
,"14":"É melhor a maldade do homem do que a bondade da mulher: a mulher causa vergonha e chega a expor ao insulto."
,"15":"Vou recordar agora as obras do Senhor e contar tudo o que vi. Foi com palavras que o Senhor fez as suas obras."
,"16":"O Sol brilha, iluminando todas as coisas, e a obra do Senhor está cheia da sua glória."
,"17":"Nem mesmo os santos do Senhor são capazes de contar todas as suas maravilhas, tudo aquilo que o Senhor todo-poderoso estabeleceu, para que o Universo se consolidasse na glória de Deus."
,"18":"Ele sonda o abismo e o coração, e penetra todos os seus segredos. O Altíssimo conhece toda a ciência e observa os sinais dos tempos,"
,"19":"anunciando as coisas passadas e futuras e revelando os vestígios das coisas escondidas."
,"20":"Nenhum pensamento Lhe escapa e nenhuma palavra Lhe fica escondida."
,"21":"Ele dispôs em ordem as maravilhas da sua sabedoria, porque só Ele existe desde sempre e para sempre. Nada Lhe pode ser acrescentado e nada Lhe pode ser tirado, e não precisa do conselho de ninguém."
,"22":"Como são agradáveis todas as suas obras, ainda que delas se veja apenas uma faísca!"
,"23":"Todas essas coisas vivem e permanecem para sempre em todas as necessidades, e todas Lhe obedecem."
,"24":"Todas as coisas existem aos pares, uma diante da outra, e Ele não fez nada incompleto."
,"25":"Uma coisa completa a bondade da outra, e ninguém se cansa de contemplar a glória de Deus."
}`)
	CurrentBook.AddChapter(43, `{
"1":"O orgulho das alturas é o firmamento límpido; o espectáculo do céu é uma visão de glória."
,"2":"Ao aparecer no horizonte, o Sol proclama: «Como a obra do Altíssimo é maravilhosa!»"
,"3":"Ao meio-dia seca a terra, e ninguém pode resistir ao seu calor."
,"4":"Nós atiçamos a fornalha para produzir calor, mas o sol queima as montanhas três vezes mais, exalando vapores quentes, dardejando os seus raios e deslumbrando os olhos."
,"5":"Grande é o Senhor que o fez, e a sua palavra apressa a sua marcha."
,"6":"Também a Lua é exacta nas suas fases, regulando as datas e marcando o tempo."
,"7":"Da Lua depende a indicação das festas, e vai diminuindo a claridade até desaparecer."
,"8":"É dela que o mês recebe o nome, enquanto ela cresce admiravelmente segundo as suas fases. É a bandeira dos exércitos celestes que brilha no firmamento do céu."
,"9":"Beleza do céu é o brilho dos astros, enfeite luminoso nas alturas do Senhor."
,"10":"Eles comportam-se conforme as ordens do Santo; jamais abandonam o seu posto de guarda."
,"11":"Contempla o arco-íris e bendiz Aquele que o fez. Ele é magnífico no seu esplendor."
,"12":"Cinge o céu com um círculo de glória, estendido pelas mãos do Altíssimo."
,"13":"Com uma ordem, o Senhor faz cair a neve e lança os raios do seu julgamento."
,"14":"Assim se abrem os seus depósitos, e as nuvens voam como pássaros."
,"15":"Com o seu poder condensa as nuvens, que se fragmentam em pedras de granizo."
,"16":"Quando aparece, abalam-se os montes, e por sua vontade sopra o vento do Sul."
,"17":"O estrondo do seu trovão faz tremer a terra, assim como o furacão do Norte e os ciclones."
,"18":"Faz descer a neve como pássaros que pousam, e a sua queda é como a dos gafanhotos. Os olhos admiram a beleza da sua brancura, e o coração extasia-se ao vê-la cair."
,"19":"Derrama sobre a terra a geada como sal, que gela formando pontas de espinhos."
,"20":"O vento frio do Norte sopra, e o gelo forma-se sobre a água, pousa sobre a água parada, e reveste-a como uma couraça."
,"21":"Este vento devora as montanhas e abrasa o deserto, consumindo como fogo o verde das plantas."
,"22":"A névoa húmida do orvalho, depois do Verão, traz alegria."
,"23":"Com a sua palavra, o Senhor domesticou o oceano, no meio do qual colocou as ilhas."
,"24":"Os navegantes falam dos perigos do mar, e nós ficamos espantados com o que ouvimos:"
,"25":"ali se encontram coisas estranhas e maravilhosas, animais de toda a espécie e monstros marinhos."
,"26":"Graças ao Senhor, o seu mensageiro chega a bom porto, e tudo se realiza segundo a sua palavra."
,"27":"Por mais coisas que disséssemos nunca teríamos acabado. Mas, para concluir, podemos dizer: «Ele é tudo»."
,"28":"Como poderíamos encontrar forças para O louvar? Ele é o Grande, e está acima de todas as suas obras."
,"29":"O Senhor é terrível e soberanamente imenso, e o seu poder é maravilhoso."
,"30":"Glorificai e exaltai o Senhor tanto quanto puderdes, porque Ele estará sempre mais alto. Ao exaltá-l'O, multiplicai todas as vossas forças, e não vos canseis, porque nunca chegareis ao fim."
,"31":"Quem O contemplou, para O poder descrever? Quem O louvará como Ele merece?"
,"32":"Ainda há muitos mistérios maiores que estes, pois contemplamos poucas coisas das suas obras."
,"33":"De facto, o Senhor criou todas as coisas, e aos seus fiéis deu a sabedoria."
}`)
	CurrentBook.AddChapter(44, `{
"1":"Louvemos os homens ilustres, nossos antepassados através das gerações."
,"2":"O Senhor deu-lhes imensa glória, pois mostrou a sua grandeza desde os tempos antigos."
,"3":"Alguns exerceram a autoridade real e ganharam fama com os seus feitos. Outros, pela sua inteligência, tornaram-se conselheiros, e fizeram revelações proféticas."
,"4":"Uns guiaram o povo com as suas decisões, compreendendo os costumes da sua gente e tendo palavras sábias para a instruir."
,"5":"Outros compuseram cânticos melodiosos e escreveram narrativas poéticas."
,"6":"Outros ainda foram ricos e cheios de poder, vivendo em paz nas suas casas."
,"7":"Todos, porém, foram honrados pelos seus contemporâneos e glorificados enquanto viviam."
,"8":"Alguns deixaram um nome, que ainda é lembrado com elogios."
,"9":"Outros não deixaram nenhuma lembrança e desapareceram como se não tivessem existido. Foram-se embora como se nunca cá tivessem estado, tanto eles como os filhos que tiveram."
,"10":"Mas aqueles que vamos lembrar foram homens de bem, cujos actos de justiça não foram esquecidos."
,"11":"Na sua descendência, eles têm uma rica herança, que é a sua posteridade."
,"12":"Os seus descendentes permanecem fiéis às alianças, e graças a eles também os seus netos."
,"13":"A sua descendência permanecerá para sempre, e a sua fama jamais se apagará."
,"14":"Os seus corpos foram sepultados em paz, e o seu nome viverá através das gerações."
,"15":"Os povos proclamarão a sua sabedoria, e a assembleia celebrará o seu louvor."
,"16":"Henoc agradou ao Senhor e foi arrebatado, tornando-se modelo de conversão para as gerações."
,"17":"Noé foi reconhecido como homem perfeito e justo, e no tempo da ira assegurou a reconciliação: por meio dele, um resto sobreviveu na Terra, quando veio o dilúvio."
,"18":"Alianças eternas foram firmadas com ele, para que os seres nunca mais fossem destruídos por um dilúvio."
,"19":"Abraão foi o grande pai de muitos povos, e ninguém teve fama semelhante à dele."
,"20":"Observou a Lei do Altíssimo e fez com Ele uma aliança. Estabeleceu essa aliança na sua própria carne e, quando provado, foi encontrado fiel."
,"21":"Por isso, Deus prometeu-lhe com juramento abençoar os povos que dele nasceriam, e multiplicá-lo como o pó da terra, exaltando a sua descendência como os astros. Prometeu dar-lhe como herança o país que se estende de um mar a outro, desde o rio Eufrates até às extremidades da Terra."
,"22":"Também a Isaac foi feita a mesma promessa, por causa de seu pai Abraão."
,"23":"Deus fez pousar sobre a cabeça de Jacob a bênção de todos os homens e a aliança. Deus confirmou-o com as suas bênçãos e deu-lhe o país em herança, e dividiu-o em várias partes, distribuindo-as entre as dozes tribos."
}`)
	CurrentBook.AddChapter(45, `{
"1":"De facto, Deus fez surgir de Jacob um homem de bem, que foi estimado por todos, amado por Deus e pelos homens: Moisés, cuja lembrança é uma bênção."
,"2":"Deus tornou-o glorioso como os santos e engrandeceu-o, provocando temor entre os inimigos."
,"3":"Pela palavra de Moisés fez cessar os prodígios e glorificou-o diante dos reis. Deu-lhe os mandamentos para o seu povo e mostrou-lhe uma parte da sua glória."
,"4":"Consagrou-o pela sua fidelidade e mansidão, e escolheu-o de entre todos os viventes."
,"5":"Fez-lhe ouvir a sua voz e introduziu-o dentro da nuvem escura. Deu-lhe pessoalmente os mandamentos, a lei da vida e da inteligência, para que ensinasse a sua aliança a Jacob e os seus decretos a Israel."
,"6":"O Senhor elevou Aarão, um santo semelhante a Moisés, seu irmão, da tribo de Levi."
,"7":"Estabeleceu com ele uma aliança eterna e entregou-lhe o sacerdócio do povo. Honrou-o com ornamentos esplêndidos e cobriu-o com vestes gloriosas."
,"8":"Revestiu-o com toda a magnificência e cingiu-o com ricos ornamentos, calções, túnicas e o efod."
,"9":"Rodeou as suas vestes com romãs e numerosas campainhas de ouro, para que tilintassem a cada passo, a fim de que o som fosse ouvido no santuário como aviso para os filhos do seu povo."
,"10":"Enfeitou-o com vestes sagradas, feitas de ouro, de púrpura violeta e escarlate, obra de artista. Confiou-lhe o peitoral do julgamento com as sortes da verdade, feito de carmesim retorcido, obra de tecelão."
,"11":"Nesse peitoral havia pedras preciosas gravadas em forma de selo e engastadas em ouro, obra de joalheiro, como memorial com as palavras gravadas, segundo o número das tribos de Israel."
,"12":"Sobre o turbante trazia uma coroa de ouro, na qual estava gravada a inscrição sagrada, uma insígnia de honra, obra magnífica, um enfeite que delicia os olhos."
,"13":"Antes dele, ninguém viu coisa parecida e nenhum estrangeiro jamais usou coisa igual; foi reservada apenas aos seus filhos e seus descendentes para sempre."
,"14":"Os sacrifícios oferecidos por ele consumam-se inteiramente duas vezes por dia, sem interrupção."
,"15":"Moisés consagrou-lhe as mãos e ungiu-o com o óleo santo. Isto tornou-se uma aliança eterna para ele e para os seus descendentes, enquanto o céu durar, para que presidam ao culto, exerçam o sacerdócio e abençoem o povo em nome do Senhor."
,"16":"O Senhor escolheu-o dentre todos os viventes, para que oferecesse a Deus sacrifícios, incenso e perfume, como memorial, e para que fizesse o sacrifício pelo pecado em favor do seu povo."
,"17":"Confiou-lhe os seus mandamentos e o poder sobre as disposições legais, para ensinar os seus testemunhos a Jacob, e iluminar Israel com a sua Lei."
,"18":"Os estrangeiros reuniram-se contra ele e invejaram-no no deserto: homens de Datã e de Abiram, e o odioso e violento bando de Coré."
,"19":"Ao ver isso o Senhor ficou indignado, e eles foram aniquilados pelo furor da sua ira. Realizou prodígios contra eles e consumiu-os com a chama do seu fogo."
,"20":"O Senhor aumentou a glória de Aarão e deu-lhe um património: destinou-lhe as ofertas dos primeiros frutos e principalmente pão em abundância."
,"21":"De facto, eles alimentam-se das vítimas oferecidas ao Senhor, que foram dadas a ele e aos seus descendentes."
,"22":"Todavia, não recebeu uma propriedade na Terra do povo, nem lhe foi dada uma parte no meio do povo, pois o Senhor é a sua parte e a sua herança."
,"23":"Fineias, filho de Eleazar, é o terceiro em glória. Mostrou-se zeloso no temor do Senhor, mantendo-se fiel quando o povo se revoltou. Ele interveio com generosa coragem e obteve o perdão para Israel."
,"24":"Por isso, foi estabelecida com ele uma aliança de paz, para que presidisse ao santuário e ao povo. A ele e aos seus descendentes foi reservada a dignidade do sacerdócio para sempre."
,"25":"Houve também uma aliança com David, filho de Jessé, da tribo de Judá: a sucessão do rei passava do pai para um dos seus filhos, mas a sucessão de Aarão passa para todos os seus descendentes."
,"26":"Que o Senhor infunda a sabedoria no vosso coração, a fim de que governeis o povo com justiça, os bens dos antepassados não desapareçam e a sua glória passe para os seus descendentes."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Valente na guerra foi Josué, filho de Nun, sucessor de Moisés na actividade profética. Conforme o significado do seu nome, ele foi grande para a salvação dos escolhidos do Senhor, castigando os inimigos revoltados e instalando Israel no seu território."
,"2":"Como era glorioso quando levantava os braços e manejava a espada contra as cidades!"
,"3":"Antes dele, quem foi assim tão firme? Ele chefiava as guerras do Senhor."
,"4":"Não foi por sua ordem que o Sol parou e um dia se transformou em dois?"
,"5":"Ele invocou o Altíssimo poderoso, quando os inimigos o apertavam de todos os lados. O grande Senhor atendeu-o, fazendo cair pedras de granizo com grande força."
,"6":"Ele caiu sobre a nação inimiga, e na encosta destruiu os adversários, para que as nações reconhecessem a força das suas armas e que a sua guerra era chefiada pelo Senhor."
,"7":"Josué permaneceu fiel ao Todo-poderoso e, no tempo de Moisés, agiu com fidelidade. Juntamente com Caleb, filho de Jefoné, resistiu à multidão, impediu que o povo pecasse e fez desaparecer a murmuração perversa."
,"8":"Só eles dois foram poupados entre seiscentos mil homens de infantaria, para introduzirem Israel na sua herança, na terra onde corre leite e mel."
,"9":"O Senhor concedeu a Caleb a força que permaneceu com ele até à velhice. Ele subiu às colinas do país, que a sua descendência conservou como herança,"
,"10":"a fim de que todos os filhos de Israel soubessem que é bom seguir o Senhor."
,"11":"Depois vêm os Juízes, cada um com o seu nome, homens que não se deixaram seduzir, nem se afastaram do Senhor. Bendita seja a sua memória!"
,"12":"Que os seus ossos refloresçam nos seus túmulos e o seu nome se perpetue nos filhos, porque eles já foram glorificados."
,"13":"Samuel foi amado pelo seu Senhor, do qual era profeta. Instituiu a monarquia e consagrou os chefes do seu povo."
,"14":"Governou a comunidade conforme a Lei do Senhor, e o Senhor visitou Jacob."
,"15":"Pela sua fidelidade, mostrou que era profeta, e pelas suas palavras foi reconhecido como verdadeiro vidente."
,"16":"Quando os inimigos o apertavam de todos os lados, invocou o Senhor todo-poderoso, oferecendo um cordeiro recém-nascido."
,"17":"Então, do céu o Senhor trovejou e, com forte estrondo, fez ouvir a sua voz,"
,"18":"aniquilando os chefes do inimigo e todos os príncipes dos filisteus."
,"19":"Antes de ir repousar para sempre, deu testemunho diante do Senhor e do seu ungido: «Nem dinheiro, nem sandálias recebi de quem quer que seja». E ninguém ousou acusá-lo."
,"20":"Mesmo depois da sua morte, profetizou, predizendo ao rei o seu fim. Mesmo do sepulcro, levantou a voz, numa profecia, para apagar a iniquidade do povo."
}`)
	CurrentBook.AddChapter(47, `{
"1":"Depois disto, surgiu Natã, que profetizou no tempo de David."
,"2":"Da mesma forma que se separa a gordura no sacrifício de comunhão, assim David foi separado dos filhos de Israel."
,"3":"Ele brincou entre leões como se estivesse no meio de cabritos, e divertiu-se com ursos como se fossem cordeiros."
,"4":"Ainda jovem, matou o gigante, e tirou a humilhação do seu povo, quando atirou a pedra com a funda e abateu a arrogância de Golias."
,"5":"Ele invocou o Senhor Altíssimo, que deu força à sua mão direita, para eliminar um guerreiro valente e reerguer a honra do seu povo."
,"6":"Então exaltaram-no pelos seus dez mil e louvaram-no pelas bênçãos do Senhor, oferecendo-lhe uma coroa de glória."
,"7":"Porque exterminou os inimigos vizinhos, aniquilou os filisteus inimigos e abateu para sempre o seu poder."
,"8":"Em todas as suas obras, glorificou o Santo Altíssimo com palavras de louvor. Cantou hinos de todo o coração e amou Aquele que o havia criado."
,"9":"Colocou diante do altar tocadores de harpa, para embelezar os cânticos com o som da música."
,"10":"Assim, deu esplendor às festas e embelezou com perfeição as solenidades, fazendo louvar o santo Nome do Senhor e enchendo de harmonia o santuário desde o amanhecer."
,"11":"O Senhor perdoou os pecados que ele cometeu e elevou o seu poder para sempre, concedendo-lhe, por sua aliança, a realeza e um trono glorioso em Israel."
,"12":"Depois de David, surgiu um filho sábio que, graças ao pai, teve um vasto reino."
,"13":"Salomão reinou em tempo de paz, e Deus concedeu-lhe tranquilidade nos arredores, a fim de que construísse uma casa para o Nome do Senhor e Lhe preparasse um santuário eterno."
,"14":"Como foste sábio na juventude e transbordaste de inteligência como um rio!"
,"15":"A tua fama recobriu a terra, e encheste-a de sentenças enigmáticas!"
,"16":"O teu nome chegou até às ilhas distantes, e foste amado na tua paz."
,"17":"Todo o mundo te admirou pelos teus cânticos, provérbios, sentenças e respostas."
,"18":"Em nome do Senhor Deus, que se chama Deus de Israel, acumulaste ouro como estanho e multiplicaste a prata como chumbo."
,"19":"Mas entregaste o teu corpo a mulheres, deixando que elas te dominassem."
,"20":"Assim, manchaste a tua glória e profanaste a tua descendência, a ponto de atrair sobre os teus filhos a ira divina, fazendo-os sofrer com a tua loucura."
,"21":"O reino foi dividido em dois, e instalou-se em Efraim um reino rebelde."
,"22":"Mas o Senhor não renunciou à sua misericórdia e não cancelou nenhuma das suas promessas. Não deixou perecer a posteridade do seu eleito, nem destruiu a descendência daquele que O amava. Deixou um resto a Jacob, e a David um rebento da sua linhagem."
,"23":"Salomão foi repousar com os seus antepassados e deixou um descendente. Foi Roboão, o mais louco do povo e sem bom senso que, com a sua decisão, incitou o povo a revoltar-se."
,"24":"Jeroboão, filho de Nabat, fez pecar Israel e ensinou a Efraim o caminho do pecado. Desta forma, os pecados de Efraim multiplicaram-se tanto, que foi exilado para longe do seu país."
,"25":"Cometeram toda a espécie de mal, até que o castigo caiu sobre eles."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Então surgiu o profeta Elias como um fogo, e a sua palavra queimava como um facho."
,"2":"Fez vir contra eles a fome e, por causa do seu zelo, reduziu-os a um pequeno número."
,"3":"Por ordem do Senhor, ele fechou o céu e, por três vezes, fez descer o fogo."
,"4":"Elias, como te tornaste famoso com os teus prodígios! Quem pode orgulhar-se de ser igual a ti?"
,"5":"Fizeste levantar um morto do sepulcro e sair do mundo dos mortos, por ordem do Altíssimo."
,"6":"Levaste reis à ruína e tiraste do leito homens ilustres."
,"7":"Ouviste censuras no Sinai e decretos de vingança no Horeb."
,"8":"Ungiste reis como vingadores, e profetas para te sucederem."
,"9":"Foste arrebatado num turbilhão de fogo, num carro puxado por cavalos de fogo."
,"10":"Nas ameaças para os tempos futuros, foste designado para apaziguar a ira antes do furor, a fim de reconduzir o coração dos pais aos filhos e restabelecer as tribos de Jacob."
,"11":"Felizes aqueles que te viram e os que adormeceram no amor, porque nós também possuiremos a vida."
,"12":"Quando Elias foi envolvido pelo turbilhão, Eliseu ficou repleto do seu espírito. Durante a vida, Eliseu não tremeu diante dos poderosos, e ninguém conseguiu dominá-lo."
,"13":"Nada era demasiado difícil para ele e, mesmo morto, ainda profetizou."
,"14":"Durante a vida realizou prodígios e, depois de morto, as suas obras foram maravilhosas."
,"15":"Apesar de tudo, o povo não se converteu, nem renunciou aos seus pecados, até que foi exilado da sua pátria e disperso por toda a terra."
,"16":"Restou apenas um povo pouco numeroso e um chefe da família de David. Alguns deles fizeram o que Deus aprova, mas outros multiplicaram os pecados."
,"17":"Ezequias fortificou a sua cidade e conduziu água para dentro dela. Abriu um canal na rocha e construiu reservatórios de água."
,"18":"No seu tempo, Senaquerib fez uma expedição de guerra e enviou Rabsaces. Este partiu e levantou a mão contra Sião, vangloriando-se no seu orgulho."
,"19":"Então os corações e mãos estremeceram e ficaram a sofrer como as mulheres com as dores de parto."
,"20":"Invocaram o Senhor misericordioso e estenderam para Ele as mãos. Do céu, o Santo escutou-os imediatamente e libertou-os por meio de Isaías."
,"21":"O Senhor feriu o acampamento dos assírios, e o seu anjo exterminou-os."
,"22":"Ezequias fez o que o Senhor aprova, e seguiu com firmeza os caminhos de seu pai David, conforme lhe ordenara Isaías, o profeta grande e verdadeiro nas suas visões."
,"23":"No seu tempo, o Sol recuou, e ele prolongou a vida do rei."
,"24":"Com grande inspiração, viu o fim dos tempos e consolou os aflitos de Sião."
,"25":"Revelou o que devia acontecer até ao fim dos tempos, e as coisas ocultas antes de acontecerem."
}`)
	CurrentBook.AddChapter(49, `{
"1":"A lembrança de Josias é mistura de incenso, preparada pela arte do perfumista; é como o mel, que é doce em todas as bocas, ou a música num banquete."
,"2":"Ele dedicou-se à conversão do povo e eliminou as abominações da injustiça."
,"3":"Dirigiu o seu coração para o Senhor e, em tempo de injustiça, fez prevalecer a fidelidade."
,"4":"Com excepção de David, Ezequias e Josias, todos os reis cometeram pecados. Os reis de Judá desapareceram porque abandonaram a Lei do Altíssimo."
,"5":"Entregaram o seu poder a outros e a sua riqueza a uma nação estrangeira."
,"6":"Os inimigos incendiaram a cidade santa escolhida e tornaram desertas as suas ruas."
,"7":"Isso aconteceu conforme a palavra de Jeremias, a quem eles maltrataram, embora tivesse sido consagrado profeta desde o seio materno, para arrancar, destruir e arruinar, mas também para construir e plantar."
,"8":"Ezequiel contemplou uma visão da Glória, que Deus lhe mostrou sobre o carro dos querubins."
,"9":"Deus lembrou-Se dos inimigos, mandando a tempestade, mas salvou aqueles que andam por caminhos rectos."
,"10":"Quanto aos doze profetas, que os seus ossos floresçam no sepulcro, porque eles consolaram Jacob e com a sua confiante esperança o resgataram."
,"11":"Como fazer o elogio de Zorobabel? Ele é como o sinete na mão direita."
,"12":"O mesmo se diga de Josué, filho de Josedec. Ambos, na sua época, reconstruíram o Templo e ergueram ao Senhor um templo santo, destinado a uma glória eterna."
,"13":"Também a memória de Neemias é grande. Ele reconstruiu-nos as muralhas que estavam em ruínas, instalou portas e ferrolhos, e reergueu as nossas casas."
,"14":"Ninguém na Terra foi criado igual a Henoc, pois ele foi arrebatado da Terra."
,"15":"Também não nasceu outro homem como José, que foi chefe dos irmãos e sustentáculo do povo. Até os seus ossos receberam honras."
,"16":"Sem e Set foram glorificados entre os homens, mas acima de qualquer outra criatura viva está Adão."
}`)
	CurrentBook.AddChapter(50, `{
"1":"Simão, filho de Onias, o sumo sacerdote, durante a vida restaurou o templo e, na sua época, fortificou o santuário."
,"2":"Ele mesmo colocou os alicerces do edifício duplo, o alto contraforte da muralha do templo."
,"3":"No seu tempo, foi cavado o reservatório de água, um tanque grande como o mar."
,"4":"Preocupado em evitar a ruína do seu povo, fortificou a cidade contra a possibilidade de um cerco."
,"5":"Como era majestoso, rodeado pelo povo, quando saía do santuário por detrás da cortina!"
,"6":"Ele era como a estrela da manhã entre as nuvens e como a lua cheia!"
,"7":"Era como o sol fulgurante sobre o templo do Altíssimo, como o arco-íris que brilha entre nuvens de glória!"
,"8":"Era como a rosa na Primavera, como lírio junto da água corrente, como ramo de árvore de incenso no Verão!"
,"9":"Era como fogo e incenso no turíbulo, como vaso de ouro maciço ornado com todo o tipo de pedras preciosas!"
,"10":"Era como oliveira carregada de azeitonas e como cipreste que se eleva até às nuvens!"
,"11":"Como era majestoso quando vestia os paramentos solenes e usava os seus enfeites mais belos! Quando subia ao altar sagrado e enchia de glória todo o santuário!"
,"12":"Como era majestoso ao receber das mãos dos sacerdotes as porções do sacrifício, de pé, junto ao braseiro do altar, rodeado por uma coroa de irmãos, como rebentos dos cedros do Líbano, que o rodeavam como troncos de palmeiras!"
,"13":"Todos os descendentes de Aarão, no seu esplendor, traziam nas mãos a oferta para o Senhor, e mantinham-se diante de toda a assembleia de Israel."
,"14":"Ao terminar a liturgia sobre os altares e para tornar mais bela a oferta ao Altíssimo Todo-poderoso,"
,"15":"Simão estendia a mão sobre a taça e fazia uma libação com vinho, derramando-o sobre as bases do altar, como perfume agradável ao Altíssimo, Rei do universo."
,"16":"Nesse momento, os descendentes de Aarão aclamavam, tocavam as trombetas de metal maciço, fazendo ouvir um grandioso som como memorial diante do Altíssimo."
,"17":"Então, imediatamente, todo o povo se prostrava juntamente com ele, com o rosto por terra, para adorar o Senhor, o Deus Todo-poderoso e Altíssimo."
,"18":"Os cantores entoavam cantos de louvor, e o seu canto era acompanhado por música melodiosa."
,"19":"O povo suplicava ao Senhor Altíssimo, dirigindo orações ao Misericordioso, até terminar o culto do Senhor e acabar a cerimónia."
,"20":"Nesse momento, Simão descia do altar e estendia as mãos sobre toda a assembleia de Israel, para dar a bênção do Senhor em alta voz e ter a honra de pronunciar o seu Nome."
,"21":"Então o povo prostrava-se novamente, para receber a bênção do Altíssimo."
,"22":"E agora, bendizei o Deus do Universo, que realiza por toda a parte coisas grandiosas. Ele exaltou os nossos dias desde o seio materno e age connosco segundo a sua misericórdia."
,"23":"Que Ele nos dê um coração alegre e conceda a paz aos nossos dias em Israel, para todo o sempre."
,"24":"Que a sua misericórdia permaneça fielmente connosco, e nos resgate enquanto vivermos."
,"25":"Há duas nações que eu detesto, e uma terceira que nem sequer é nação:"
,"26":"os habitantes da montanha de Seir, os filisteus e o povo idiota que habita em Siquém."
,"27":"Jesus, filho de Sirac, neto de Eleazar de Jerusalém, gravou neste livro uma instrução de sabedoria e ciência, derramando como chuva a sabedoria do seu coração."
,"28":"Feliz o homem que medita nestas coisas, pois quem as coloca no coração tornar-se-á sábio."
,"29":"Se as puser em prática, será forte em tudo, porque a luz do Senhor é o seu caminho."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Eu Te agradeço, Senhor Rei, e Te louvo, meu Deus Salvador, glorificando o teu Nome,"
,"2":"porque foste para mim um protector e socorro, e libertaste o meu corpo da perdição, do laço da língua caluniadora e dos lábios que produzem a mentira. Na presença dos meus adversários, foste o meu apoio e libertaste-me,"
,"3":"conforme a grandeza da tua misericórdia e do teu Nome, dos dentes daqueles que estavam prestes a devorar-me. Livraste-me das mãos dos que procuravam tirar-me a vida e de numerosas provações."
,"4":"Tu livraste-me do fogo que me rodeava, de um fogo que não acendi,"
,"5":"das profundas entranhas do mundo dos mortos, da língua impura, da palavra mentirosa."
,"6":"Uma calúnia de uma língua injusta tinha chegado ao rei. A minha alma esteve perto da morte e a minha vida chegou junto à porta do mundo dos mortos."
,"7":"Por todos os lados me rodeavam, e não havia quem me ajudasse. Procurei o socorro dos homens, mas foi inútil."
,"8":"Então lembrei-me da tua misericórdia, Senhor, e das tuas obras feitas desde a eternidade, porque libertas os que esperam em Ti e os salvas da mão dos inimigos."
,"9":"Fiz subir da terra a minha oração, e pedi para ser libertado da morte."
,"10":"Invoquei o Senhor, Pai do meu Senhor: «Não me abandones no dia da provação, no tempo do abandono causado pelos orgulhosos. Vou louvar para sempre o teu Nome e cantar-Te hinos de agradecimento»."
,"11":"A minha súplica foi atendida, e salvaste-me da ruína, livrando-me da aflição."
,"12":"Por isso, Te agradeço e Te louvo, bendizendo o nome do Senhor."
,"13":"Na minha juventude, antes de viajar, na minha oração procurei abertamente a Sabedoria."
,"14":"Pedi-a a Deus no Templo e vou procurá-la até ao fim."
,"15":"O meu coração alegrou-se nela quando floresceu como a videira. O meu pé andou pelo caminho recto, e segui as tuas pegadas desde a juventude."
,"16":"Inclinei um pouco o ouvido para a receber, e acabei por encontrar ensinamento abundante."
,"17":"Com ele, fiz progressos, e por isso vou agradecer a quem me concedeu a Sabedoria."
,"18":"Sim, resolvi pô-la em prática, e procurei ardentemente o bem, e não serei confundido."
,"19":"A minha alma lutou para possuir a Sabedoria e observei atentamente a Lei. Estendi as minhas mãos para o alto, deplorando a minha ignorância."
,"20":"Para ela dirigi o meu desejo, e encontrei-a na pureza. Com ela, desde o princípio, adquiri inteligência, e por isso não serei abandonado."
,"21":"As minhas entranhas comoveram-se quando a procurava, e por isso adquiri um bem precioso."
,"22":"Como recompensa, o Senhor deu-me língua e, com ela O louvarei."
,"23":"Aproximai-vos de mim, vós que não tendes instrução, e entrai na minha escola."
,"24":"Porque pretendeis privar-vos destas coisas, quando a vossa alma tem sede delas?"
,"25":"Abro a boca e proclamo: «Comprai a sabedoria sem dinheiro."
,"26":"Colocai o pescoço debaixo do seu jugo e acolhei a sua instrução. Ela está próxima, e pode ser encontrada."
,"27":"Vede com os vossos próprios olhos como trabalhei pouco, e acabei por encontrar um profundo repouso."
,"28":"Comprai instrução, mesmo que seja com muito dinheiro, pois com ela ganhareis ouro em abundância."
,"29":"Alegrai-vos com a misericórdia do Senhor, e não vos envergonheis de O louvar."
,"30":"Realizai o vosso trabalho antes do tempo fixado, e Ele vos dará a recompensa no devido tempo»."
}`)

}
func PT_BS_LoadVSIBChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Era uma vez um homem chamado Job, que vivia no país de Hus. Era um homem íntegro e recto, que temia a Deus e evitava o mal."
,"2":"Tinha sete filhos e três filhas."
,"3":"Possuía também sete mil ovelhas, três mil camelos, quinhentas juntas de bois, quinhentas mulas e grande número de empregados. Job era o mais rico dos homens do Oriente."
,"4":"Os filhos de Job costumavam fazer banquetes, um dia na casa de cada um, e convidavam as três irmãs para comer e beber com eles."
,"5":"Quando terminavam esses dias de festa, Job mandava-os chamar, para os purificar. Ele madrugava e oferecia um holocausto por cada um deles, pensando: «Talvez os meus filhos tenham pecado, ofendendo a Deus no seu coração». E Job fazia assim todas as vezes."
,"6":"Certo dia, os anjos apresentaram-se a Javé e, entre eles, foi também Satã."
,"7":"Então Javé perguntou a Satã: «De onde vens?» Satã respondeu: «Fui dar uma volta pela Terra»."
,"8":"Javé disse-lhe: «Reparaste no meu servo Job? Na Terra não existe nenhum outro como ele: é um homem íntegro e recto, que teme a Deus e evita o mal»."
,"9":"Satã respondeu a Javé: «E é a troco de nada que Job teme a Deus?"
,"10":"Tu mesmo puseste um muro de protecção ao redor dele, da sua casa e de todos os seus bens. Abençoaste os seus trabalhos, e os seus rebanhos cobrem toda a região."
,"11":"Estende, porém, a mão e mexe no que ele possui. Garanto-Te que ele Te amaldiçoará na face!»"
,"12":"Então Javé disse a Satã: «Pois bem! Faz o que quiseres ao que ele possui, mas não estendas a mão contra ele». E Satã saiu da presença de Javé."
,"13":"Certo dia, os filhos e filhas de Job comiam e bebiam na casa do irmão mais velho."
,"14":"Um mensageiro chegou à casa de Job e disse-lhe: «Os bois estavam a lavrar e as mulas pastavam perto deles."
,"15":"Os sabeus caíram sobre eles, mataram os empregados a fio de espada e levaram o rebanho. Só eu escapei para te contar o que aconteceu»."
,"16":"Mal acabara de falar, quando chegou outro e disse: «Caiu um raio do céu e queimou e consumiu as tuas ovelhas e pastores. Só eu escapei para te contar o que aconteceu»."
,"17":"Mal acabara de falar, quando chegou outro e disse: «Um bando de caldeus, dividido em três grupos, caiu sobre os camelos e levou-os embora, depois de matar os empregados a fio de espada. Só eu escapei para te contar o que aconteceu»."
,"18":"Mal acabara de falar, quando chegou outro e disse: «Os teus filhos e filhas estavam a comer e a beber na casa do irmão mais velho,"
,"19":"quando um furacão veio do deserto, atingindo a casa pelos quatro lados, e ela desabou sobre os jovens e matou-os. Só eu escapei para te contar o que aconteceu»."
,"20":"Então Job levantou-se, rasgou as vestes, rapou a cabeça, caiu por terra,"
,"21":"e disse: «Nu saí do ventre de minha mãe, e nu para ele voltarei. Javé tudo me deu e Javé tudo me tirou. Bendito seja o nome de Javé!»"
,"22":"E, apesar de tudo, Job não pecou e não acusou Deus de ter feito alguma coisa injusta."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Certo dia, os anjos apresentaram-se a Javé e, entre eles, foi também Satã."
,"2":"Então Javé perguntou a Satã: «De onde vens?» Satã respondeu: «Fui dar uma volta pela Terra»."
,"3":"Javé disse-lhe: «Reparaste no meu servo Job? Na Terra não existe nenhum outro como ele: é um homem íntegro e recto, que teme a Deus e evita o mal. Ele continua firme na sua integridade. E tu, a troco de nada, lançaste-Me contra ele para o aniquilar»."
,"4":"Satã respondeu a Javé: «Pele por pele! O homem dá tudo o que tem para manter a vida."
,"5":"Estende, porém, a mão e atinge-o na carne e nos ossos. Garanto-Te que ele Te amaldiçoará na cara!»"
,"6":"Então Javé disse a Satã: «Faz dele o que quiseres, mas poupa-lhe a vida»."
,"7":"E Satã saiu da presença de Javé. Satã feriu Job com feridas graves, desde a planta do pé até à cabeça. "
,"8":"Então Job pegou num caco de telha para se coçar, sentado no meio da cinza."
,"9":"A sua mulher disse-lhe: «E tu ainda continuas na tua integridade? Amaldiçoa a Deus e morre de uma vez!»"
,"10":"Job respondeu: «Tu estás a falar como louca! Se aceitamos de Deus os bens, não devemos também aceitar os males?»,E, apesar de tudo isso, Job não ofendeu a Deus com palavras."
,"11":"Nesse meio tempo, três amigos de Job ficaram a saber de todas as desgraças que o tinham atingido. Eram eles: Elifaz de Temã, Baldad de Suás e Sofar de Naamat. Cada um partiu da sua terra e encontraram-se para com-partilhar a dor de Job e consolá-lo."
,"12":"Quando o viram de longe, não o reconheceram, e começaram a chorar. Rasgaram as vestes e lançaram pó sobre a cabeça."
,"13":"Depois sentaram-se no chão ao lado dele, durante sete dias e sete noites. Vendo o enorme sofrimento de Job, não lhe disseram nenhuma palavra."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Então Job abriu a boca e amaldiçoou o dia do seu nascimento,"
,"2":"dizendo:"
,"3":"«Morra o dia em que nasci e a noite em que se disse: 'Um menino foi concebido'."
,"4":"Que esse dia se transforme em trevas; que Deus, do alto, não cuide dele e sobre ele não brilhe a luz."
,"5":"Que as trevas e as sombras o reclamem para si, que uma nuvem o cubra e um eclipse o torne pavoroso."
,"6":"Que a escuridão se apodere desse dia, que ele não se some aos dias do ano e não entre na conta dos meses."
,"7":"Que essa noite fique estéril e fechada aos gritos de alegria."
,"8":"Que a maldigam os que maldizem o dia, os que sabem despertar Leviatã."
,"9":"Que as estrelas da sua aurora escureçam, que espere a luz que não vem, e não veja as pálpebras da alvorada."
,"10":"Pois essa noite não fechou as portas do ventre para mim, e não escondeu da minha vista tanta miséria."
,"11":"Porque não morri ao sair do ventre de minha mãe, ou não pereci ao sair das suas entranhas?"
,"12":"Porque é que dois joelhos me receberam, e dois peitos me amamentaram?"
,"13":"Agora eu repousaria tranquilo e dormiria em paz,"
,"14":"juntamente com os reis e governantes da terra, que construíram túmulos sumptuosos para si,"
,"15":"ou com os nobres que possuíram ouro e encheram de prata os seus mausoléus."
,"16":"Agora eu seria um aborto enterrado, uma criatura que não chegou a ver a luz."
,"17":"Lá em baixo acaba o tumulto dos injustos, e aí repousam os que estão esgotados."
,"18":"Com eles descansam os prisioneiros, e já não ouvem a voz do capataz."
,"19":"Lá em baixo os pequenos confundem-se com os grandes, e o escravo fica liberto do seu patrão."
,"20":"Para quê dar luz a um infeliz, e vida a quem vai viver na amargura?"
,"21":"Para quê dar luz a quem anseia pela morte que não chega, e que a procura mais do que a um tesouro?"
,"22":"Para quê dar luz a quem se alegra diante de um túmulo e exulta diante da sepultura?"
,"23":"Para quê dar luz a um homem que não encontra caminho, porque Deus o cercou de todos os lados?"
,"24":"Os soluços são o meu alimento, e os meus gemidos transbordam como água."
,"25":"O que eu mais temia aconteceu-me, e o que mais me apavorava atingiu-me."
,"26":"Vivo sem paz, sem tranquilidade e sem descanso, em contínuo sobressalto»."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Elifaz de Temã tomou a palavra e disse:"
,"2":"«Não sei se tu te aguentarias se alguém falasse contigo. Contudo, quem poderia permanecer calado?"
,"3":"Vê! Ins-truíste pessoas e fortaleceste braços enfraquecidos."
,"4":"Com as tuas palavras, levantaste quem vacilava, e sustentaste joelhos que se dobravam."
,"5":"Pois bem! Hoje é a tua vez. Não aguentas? Perturbas-te hoje, quando tudo desaba sobre ti?"
,"6":"O temor de Deus não era a tua confiança, e a tua esperança não era um comportamento íntegro?"
,"7":"Lembra-te bem: Quando é que um inocente pereceu, e quando é que os homens rectos foram destruídos?"
,"8":"Pelo que eu sei, os que cultivam injustiça e semeiam miséria, são esses que as colhem."
,"9":"Deus sopra, e eles perecem; o sopro da sua ira os consome."
,"10":"Embora o leão ruja e o leopardo também, os dentes das crias são quebrados:"
,"11":"sem a presa, o leão acaba por morrer, e as crias da leoa debandam."
,"12":"Escutei uma palavra fugidia, o meu ouvido percebeu o seu leve sussurro:"
,"13":"numa visão nocturna de pesadelo, quando o torpor cai sobre os homens,"
,"14":"fui tomado por um calafrio de terror, e todos os meus ossos estremeceram."
,"15":"Um vento passou pelo meu rosto e provocou-me arrepios por todo o corpo."
,"16":"Eu estava de pé, mas não vi quem era. Uma figura apareceu diante de mim, houve um silêncio, e depois ouvi uma voz:"
,"17":"'Pode o homem ter razão diante de Deus? Ou pode um mortal ser puro diante do seu Criador?"
,"18":"Ele desconfia até dos seus servos, e mesmo nos seus anjos descobre defeitos."
,"19":"Quanto mais nesses que moram em casas de barro e que têm alicerces sobre a poeira! Serão esmagados mais depressa do que a traça,"
,"20":"aniquilados entre o amanhecer e a tarde. Eles perecem para sempre, pois ninguém os fará voltar."
,"21":"As cordas da sua tenda são arrancadas, e eles morrem sem ter aprendido a lição'."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Grita, para veres se alguém te responde. A que anjo vais recorrer?"
,"2":"Porque o despeito mata o insensato, e a inveja causa a morte do imbecil."
,"3":"Vi um insensato lançar raízes, e num momento a sua casa foi amaldiçoada."
,"4":"Os seus filhos estão longe de prosperar, são esmagados sem defesa no tribunal."
,"5":"O faminto devorou-lhe as colheitas, e o sedento sugou-lhe os bens."
,"6":"A miséria não nasce do pó, e a fadiga não brota da terra."
,"7":"E o homem gera o seu próprio sofrimento, como as faúlhas sobem para o alto."
,"8":"Em teu lugar, eu recorreria a Deus, e poria a minha causa nas suas mãos."
,"9":"Ele faz coisas grandiosas e incompreensíveis, e maravilhas sem conta:"
,"10":"dá chuva à terra, e rega os campos;"
,"11":"levanta os humildes, e concede prosperidade aos abatidos;"
,"12":"malogra os planos do astuto, para que as manobras deste fracassem;"
,"13":"apanha os espertos na astúcia deles, e desmonta as tramas do velhaco."
,"14":"Em pleno dia, todos esses caem nas trevas, e ao meio-dia tacteiam como se fosse noite."
,"15":"É assim que Deus salva da língua afiada o pobre, e da mão do poderoso o necessitado."
,"16":"Deste modo, o fraco tem esperança, e a injustiça fecha a boca."
,"17":"Feliz o homem a quem Deus corrige. Portanto, não desprezes a lição do Todo-poderoso."
,"18":"É Deus quem fere e cura a ferida, quem golpeia e cura com a sua própria mão."
,"19":"Ele é quem te liberta de seis perigos, e no sétimo o mal não mais te atingirá."
,"20":"Em tempo de fome, salvar-te-á da morte, e na guerra proteger-te-á do golpe da espada."
,"21":"Ficarás a salvo do flagelo da língua, e não temerás quando a ruína chegar."
,"22":"Rirás do desastre e da fome, e não temerás os animais selvagens."
,"23":"Farás aliança com os espíritos do campo, e viverás em paz com as feras."
,"24":"Terás prosperidade na tua tenda e, visitando a tua propriedade, verás que nada falta."
,"25":"Terás descendência numerosa, e teus filhos serão como a erva do campo."
,"26":"Descerás ao túmulo em avançada velhice, como feixe de trigo ceifado no devido tempo."
,"27":"Vê bem! Observamos tudo isso, e é coisa certa. Escuta bem, e bom proveito faças»."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Então Job respondeu:"
,"2":"«Se se pudesse pesar a minha aflição, e colocar na balança a minha desgraça,"
,"3":"seriam mais pesadas que a areia do mar! Por isso, as minhas palavras são confusas."
,"4":"Trago, cravadas em mim, as flechas do Todo-poderoso, e o meu espírito bebe o veneno delas; os terrores de Deus enfileiram-se contra mim."
,"5":"Acaso o asno selvagem relincha diante do feno? Ou muge o boi diante da forragem?"
,"6":"Alguém come sem sal algo que não tem gosto? Que sabor tem a clara do ovo?"
,"7":"O que antes me causava nojo ao tocar, agora tornou-se a minha comida repugnante."
,"8":"Oxalá se cumpra o que eu pedi, e Deus me conceda o que espero:"
,"9":"que Ele Se digne esmagar-me, e solte a sua mão para acabar comigo!"
,"10":"Para mim, seria um consolo e, mesmo torturado sem piedade, eu daria saltos de alegria, por não ter renegado os decretos do Santo!"
,"11":"Que forças me restam para aguentar? E aonde espero chegar, para continuar a viver?"
,"12":"Terei eu a firmeza da pedra? Porventura sou de ferro?"
,"13":"Já não encontro apoio em mim mesmo, e todos os recursos me abandonam."
,"14":"A pessoa desesperada tem direito à solidariedade do amigo, mesmo que tivesse abandonado o temor do Todo-poderoso."
,"15":"Mas os meus irmãos desiludiram-me como rios temporários, como ribeiros que desaparecem do seu leito:"
,"16":"no tempo do degelo, transbordam, e enchem-se quando a neve se dissolve;"
,"17":"mas no tempo do Verão evaporam-se e, chegando o calor, desaparecem de seus leitos."
,"18":"Por causa deles, as caravanas mudam a rota, entram pelo deserto e extraviam-se."
,"19":"As caravanas de Temã procuram-nos, e os mercadores de Sabá contam com eles."
,"20":"Mas a sua esperança é frustrada e, ao chegar a esse lugar, ficam desiludidos."
,"21":"Assim sois vós. Tornastes-vos um nada para mim, pois estais a ver algo terrível, e sentis medo."
,"22":"Acaso pedi que me désseis alguma coisa? Ou que oferecêsseis suborno do vosso bolso?"
,"23":"Ou que me livrásseis do meu adversário? Ou que me resgatásseis do poder de algum tirano?"
,"24":"Explicai-mo, e eu ficarei em silêncio. Fazei-me ver em que é que eu errei."
,"25":"Como seria bom ouvir palavras justas! Mas o que é que provam as vossas provas?"
,"26":"Pretendeis criticar as minhas palavras? As palavras do desesperado dirigem-se ao vento!"
,"27":"Vós seríeis capazes de sortear um órfão e de vender o vosso próprio amigo."
,"28":"Pois bem! Olhai atentamente para mim: juro que não vou mentir diante de vós."
,"29":"Voltai atrás e não sejais injustos. Voltai atrás, pois a minha inocência está em jogo."
,"30":"Acaso existe falsidade nos meus lábios? Ou a minha boca não distingue já a desgraça?"
}`)
	CurrentBook.AddChapter(7, `{
"1":"O homem vive na Terra cumprindo um serviço militar, e os seus dias são como os do assalariado:"
,"2":"tal e qual um escravo, ele suspira pela sombra e, como o assalariado, espera pelo seu salário."
,"3":"Assim, a minha herança são meses de ilusão, e couberam-me noites de fadiga."
,"4":"Ao deitar-me, fico pensando: 'Quando me levantarei?' A noite é muito longa, e canso-me de me voltar na cama até à aurora."
,"5":"A minha carne está cheia de vermes e feridas, e a minha pele rompe-se e supura."
,"6":"Os meus dias correm velozes como a lançadeira, e consomem-se sem qualquer esperança."
,"7":"Lembra-te! A minha vida é um sopro, e os meus olhos nunca mais verão a felicidade."
,"8":"Os olhos de quem me vê, nunca mais me verão. Os teus olhos procurar-me-ão, mas eu já não existirei."
,"9":"Como nuvem que passa e se desfaz, quem desce ao túmulo, nunca mais subirá;"
,"10":"nunca mais voltará à sua casa, e a sua morada nunca mais o reverá."
,"11":"Por isso, não ficarei calado; o meu espírito angustiado falará e a minha alma entristecida queixar-se-á."
,"12":"Porventura sou o Mar ou o Dragão, para me colocares mordaça?"
,"13":"Quando penso que o leito me aliviará e a minha cama abrandará os meus gemidos,"
,"14":"então espantas-me com sonhos e aterrorizas-me com pesadelos."
,"15":"Eu preferiria morrer sufocado. Antes a morte do que estas dores!"
,"16":"Eu não vou viver para sempre! Deixa-me, pois os meus dias são apenas um sopro."
,"17":"O que é o homem, para fazeres tanto caso dele, para fixares a tua atenção sobre ele,"
,"18":"a ponto de o examinares cada manhã e o testares a cada momento?"
,"19":"Porque não paras de me espiar, deixando-me ao menos engolir a saliva?"
,"20":"Caso eu tenha pecado, o que foi que eu Te fiz? Espião da humanidade, porque me tomaste como alvo, e me transformaste em peso para Ti?"
,"21":"Porque não perdoas o meu pecado, e não afastas de mim a minha culpa? Olha! Eu logo me deitarei no pó: Tu me procurarás tacteando, e eu já não existirei»."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Baldad de Suás tomou a palavra e disse:"
,"2":"«Até quando vais falar dessa maneira? As tuas palavras são como um furacão."
,"3":"Pode Deus torcer o direito? Pode o Todo-poderoso perverter a justiça?"
,"4":"Se os teus filhos pecaram contra Deus, Ele já os entregou ao poder dos próprios crimes."
,"5":"Mas, se procurares a Deus, se suplicares ao Todo-poderoso,"
,"6":"e te conservares puro e recto, Ele cuidará de ti e te restaurará na tua legítima prosperidade."
,"7":"A tua situação anterior parecerá coisa pequena em comparação com a grandeza do teu futuro."
,"8":"Consulta as gerações passadas e observa a experiência dos nossos antepassados."
,"9":"Nós nascemos ontem e não sabemos nada. Os nossos dias são como sombra que passa."
,"10":"Os nossos antepassados, no entanto, vão instruir-te e falar-te com palavras tiradas da sua experiência."
,"11":"Porventura brota o papiro fora do pântano? Ou pode o junco crescer sem água?"
,"12":"Ainda verde para ser colhido, ele seca antes de todas as ervas."
,"13":"Tal é o destino de quem se esquece de Deus, e assim desaparece a esperança do injusto."
,"14":"A confiança do injusto é um fio frágil, e a sua segurança é uma teia de aranha:"
,"15":"se alguém nela se apoia, ela não aguenta; se alguém a ela se agarra, ela não o sustenta."
,"16":"Cheia de seiva ao sol, a árvore estende os ramos por todo o jardim,"
,"17":"lança raízes entre as pedras e vive no meio das rochas,"
,"18":"mas se for arrancada do seu lugar, este renega-a, dizendo: 'Nunca te vi'."
,"19":"Assim termina a sua alegre história, e outras plantas brotam do mesmo chão."
,"20":"Nota bem: Deus não rejeita o homem íntegro, nem faz aliança com malfeitores."
,"21":"Ele encherá de novo a tua boca de sorrisos e os seus lábios com gritos de alegria."
,"22":"Os teus inimigos ficarão cobertos de vergonha, e a tenda dos injustos desaparecerá»."
}`)
	CurrentBook.AddChapter(9, `{
"1":"Então Job respondeu:"
,"2":"«Eu sei muito bem que é assim. Como pode um homem ter razão diante de Deus?"
,"3":"Se alguém quisesse disputar com Deus, não Lhe responderia sequer uma só vez entre mil."
,"4":"Qual o sábio ou forte que se Lhe opôs, e saiu ileso?"
,"5":"Ele desloca as montanhas sem que elas percebam e, na sua ira, arranca-as do lugar."
,"6":"Ele abala os alicerces da terra, e as suas colunas estremecem."
,"7":"Ordena ao Sol que se não levante e esconde as estrelas."
,"8":"Ele sozinho estende o céu, e caminha sobre as ondas do mar."
,"9":"Criou a Ursa e o Orion, as Plêiades e as constelações do Sul."
,"10":"Faz prodígios insondáveis e maravilhas sem conta."
,"11":"Passa junto a mim, e não O vejo. Roça em mim, e nem O sinto."
,"12":"Se apanha uma presa, quem Lha tirará? Quem poderá dizer-Lhe: 'Que fazes?'"
,"13":"Deus não reprime a sua própria ira, e debaixo d'Ele se curvam as legiões de Raab."
,"14":"Muito menos Lhe poderei responder, ou escolher argumentos contra Ele."
,"15":"Mesmo que eu tivesse razão, não receberia resposta, e teria que implorar misericórdia ao meu juiz."
,"16":"Mesmo que eu O chamasse e Ele me respondesse, não creio que me desse atenção."
,"17":"Pelo contrário: esmagar-me-ia no furacão, e sem motivo multiplicaria as minhas feridas;"
,"18":"nem sequer me deixaria tomar fôlego, e encher-me-ia de amargura."
,"19":"Recorrer à força? Ele é o mais forte! Recorrer ao tribunal? Quem O convocará?"
,"20":"Mesmo que eu fosse inocente, a sua boca condenar-me-ia; mesmo que eu fosse inocente, Ele declarar-me-ia culpado."
,"21":"Será que sou inocente? Já nem sei! Desprezo a vida."
,"22":"Garanto-vos que é tudo a mesma coisa: Ele extermina tanto o inocente como o injusto."
,"23":"Se uma catástrofe semeia morte repentina, Ele zomba da desgraça do inocente."
,"24":"Ele entrega o país na mão do injusto e fecha os olhos dos seus juízes: se não for Ele, quem é que o faz?"
,"25":"Os meus dias correm mais depressa que um atleta, e fogem sem ter provado a felicidade;"
,"26":"deslizam como barcas de papiro, como águia que cai em cima da presa."
,"27":"Se penso: 'Vou esquecer o meu sofrimento e ficar de rosto alegre',"
,"28":"fico com medo de toda a espécie de desgraça, pois eu sei que Ele não me absolverá."
,"29":"E se sou culpado, para quê cansar-me à toa?"
,"30":"Ainda que eu me esfregasse com sabão, e lavasse as minhas mãos com soda,"
,"31":"Tu me atirarias à lama, e as minhas vestes teriam nojo de mim."
,"32":"É que Deus não é um homem como eu, para que eu possa dizer-Lhe: 'Vamos comparecer juntos no tribunal'."
,"33":"Se houvesse entre nós um árbitro, que pusesse as mãos sobre nós dois!"
,"34":"Ele afastaria de mim a vara de Deus, para que eu não enlouquecesse com o seu terror."
,"35":"Então eu poderia falar sem medo; de contrário, não sou dono de mim mesmo."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Estou cansado da minha vida! Vou entregar-me às queixas, falando com toda a amargura do meu coração."
,"2":"Vou pedir a Deus: 'Não me condenes! Diz-me o que tens contra mim'."
,"3":"Será que Te divertes em me oprimir, desprezando a obra das tuas mãos para favorecer os projectos dos injustos?"
,"4":"Acaso tens olhos de carne, e vês apenas como o homem?"
,"5":"Porventura os teus dias são como os dias de um mortal, e os teus anos como os anos de um ser humano,"
,"6":"para sondares a minha culpa e investigares o meu pecado,"
,"7":"mesmo sabendo que não sou culpado, e que ninguém me pode livrar da tua mão?"
,"8":"As tuas mãos formaram e modelaram todo o meu ser. E agora voltas-Te contra mim, para me aniquilar?"
,"9":"Lembra-Te de que me fizeste do barro. Queres agora fazer-me voltar ao pó?"
,"10":"Não me derramaste como leite e me coalhaste como queijo?"
,"11":"Revestiste-me de pele e carne, e teceste-me de ossos e nervos."
,"12":"Concedeste-me vida e favor, e a tua providência conservou a minha respiração."
,"13":"Contudo, alguma coisa Tu guardavas escondida. Agora sei que tinhas esta intenção:"
,"14":"Se eu pecasse, Tu me surpreenderias em flagrante, e não deixarias a minha culpa sem castigo."
,"15":"Se fosse culpado, ai de mim! Se fosse inocente, não poderia levantar a cabeça, pois estou cheio de vergonha e embriagado de miséria."
,"16":"Se levanto a cabeça, Tu caças-me, altivo como leão, e multiplicas as tuas proezas contra mim."
,"17":"Repetes os teus assaltos contra mim, contra mim redobras a tua ira, contra mim lanças tropas descansadas."
,"18":"Porque me tiraste do ventre materno? Eu poderia ter morrido, e ninguém me teria visto."
,"19":"Eu seria como alguém que nunca existiu, levado do ventre para o túmulo."
,"20":"Como são poucos os dias da minha vida! Deixa-me, para que eu possa respirar um pouco,"
,"21":"antes que me vá para nunca mais voltar, para o país das trevas e das sombras da morte,"
,"22":"para o país onde a aurora é noite escura, onde a sombra da morte cobre a confusão, e onde a claridade é escuridão»."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Então Sofar de Naamat tomou a palavra e disse:"
,"2":"«Será que esse palavreado vai ficar sem resposta? O charlatão acabará por ter razão?"
,"3":"O teu palavreado vai calar os outros? Vais zombar, sem que ninguém te repreenda?"
,"4":"Tu disseste: 'O meu comportamento é limpo. Sou puro diante dos teus olhos'."
,"5":"Ah, se Deus quisesse falar, e abrir a boca contra ti!"
,"6":"Se te ensinasse os segredos da sabedoria, que são tão difíceis de entender, então saberias que Deus perdoa parte da tua culpa."
,"7":"Acaso pretendes sondar o íntimo de Deus, ou penetrar na perfeição do Todo-poderoso?"
,"8":"Ela é mais alta do que o céu. O que podes tu fazer? Ela é mais profunda que o abismo. O que podes tu saber?"
,"9":"Ela é maior que a Terra e maior que o mar."
,"10":"Se Ele vier para te prender e levar a tribunal, quem O poderá impedir?"
,"11":"Ele conhece as pessoas falsas, e sem fazer esforço descobre o crime."
,"12":"É mais fácil um asno selvagem ser domesticado, do que um idiota criar juízo."
,"13":"Se dirigires o teu coração para Deus, e para Ele estenderes as mãos;"
,"14":"se te afastares da maldade, e não hospedares a injustiça na tua tenda,"
,"15":"então poderás levantar o rosto sem mancha, e não terás medo nas dificuldades."
,"16":"Esquecerás as tuas desgraças, ou lembrar-te-ás delas como águas passadas."
,"17":"A tua vida brilhará como o sol do meio-dia e a escuridão será para ti como a aurora."
,"18":"Terás tranquilidade na esperança e, olhando ao redor, deitar-te-ás tranquilo."
,"19":"Dormirás sem sobressaltos, e muitos procurarão os teus favores."
,"20":"Quanto aos injustos, os seus olhos ficarão cegos, e não encontrarão escapatória. A sua esperança será o último suspiro»."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Então Job respondeu:"
,"2":"«Como sois importantes! A sabedoria vai morrer convosco!"
,"3":"Todavia, eu também tenho inteligência, e não sou inferior a vós. Quem é que não sabe tudo isso?"
,"4":"Eu tornei-me motivo de zombaria para os meus amigos, eu que gritava a Deus para ter uma resposta. Zombam de mim, que sou inocente e íntegro."
,"5":"Os que estão satisfeitos dizem: 'Desprezo para o infeliz, empurrão para quem está a escorregar'."
,"6":"No entanto há paz na tenda dos ladrões e aqueles que desafiam a Deus vivem tranquilos, pensando que O têm na palma da mão."
,"7":"Pergunta aos animais, que eles te instruirão. Pergunta às aves do céu, que elas te informarão."
,"8":"Pergunta aos répteis da terra, que eles te darão lições. Os peixes do mar dir-te-ão tudo isso."
,"9":"Entre todos esses seres, quem não sabe que foi a mão de Javé que fez tudo isso?"
,"10":"Nas suas mãos está a vida de todos os viventes e a respiração de todo o ser humano."
,"11":"Não é o ouvido que distingue as palavras, e o paladar que saboreia os alimentos?"
,"12":"Acaso os anciãos não estão destinados a ter sabedoria, e os velhos a ter prudência?"
,"13":"Em Deus estão a sabedoria e a força, a Ele pertencem a perspicácia e a inteligência."
,"14":"O que Ele destrói, ninguém o reconstrói; se Ele aprisiona, ninguém Lhe escapa."
,"15":"Se retém a chuva, tudo seca; se a manda, a terra inunda-se."
,"16":"Ele possui a força e a eficácia, e d'Ele dependem tanto o enganado como o enganador."
,"17":"Torna estúpidos os intelectuais, e enlouquece os juízes."
,"18":"Despoja os reis das suas insígnias, e amarra-os pela cintura com uma corda."
,"19":"Faz andar descalços os sacerdotes e transtorna os poderosos."
,"20":"Tira a palavra aos oradores, e priva de sensatez os anciãos."
,"21":"Espalha desprezo sobre os aristocratas, e afrouxa o cinturão dos militares."
,"22":"Arranca das trevas os segredos, e traz à luz as coisas obscuras."
,"23":"Engrandece as nações, e depois arruína-as; desenvolve as nações, e abandona-as."
,"24":"Torna loucos os Chefes de Estado, e extravia-os numa confusão sem saída."
,"25":"Eles caminham às apalpadelas numa escuridão lúgubre, cambaleando como bêbados."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Eu vi tudo isto com os meus próprios olhos, ouvi-o com os meus próprios ouvidos e compreendi:"
,"2":"o que vós sabeis, também eu o sei. Não sou inferior a vós."
,"3":"Contudo, eu quero acusar o Todo-poderoso, desejo discutir com Deus."
,"4":"Vós sois apenas manipuladores de mentiras, sois todos uns autênticos charlatães."
,"5":"Quem me dera ficásseis calados! Seria o melhor acto de sabedoria!"
,"6":"Ouvi agora a minha defesa, prestai atenção aos meus argumentos."
,"7":"Ou será que pretendeis defender Deus com mentiras e injustiças?"
,"8":"Quereis tomar o partido de Deus e tornar-vos seus advogados?"
,"9":"E se Ele vos examinasse? Será que O enganaríeis como se engana um homem?"
,"10":"Se secretamente fordes parciais, Ele reprovar-vos-á com severidade."
,"11":"A sua majestade não vos atemoriza? O seu terror não cai sobre vós?"
,"12":"As lições que aprendestes são como a cinza, e as vossas defesas são como o barro."
,"13":"Calai-vos, que agora sou eu que vou falar. Agora eu vou falar, aconteça o que acontecer."
,"14":"Vou arriscar tudo, vou arriscar a minha própria vida."
,"15":"Mesmo que Ele me queira matar, não me importo; diante d'Ele vou defender o meu comportamento."
,"16":"Para mim isso já seria uma vitória, porque nenhum hipócrita pode apresentar-se diante d'Ele."
,"17":"Escutai bem as minhas palavras, prestai atenção ao que vou declarar:"
,"18":"Eu preparei a minha defesa, e sei que sou inocente."
,"19":"Alguém quer discutir comigo? Calar-me agora, seria morrer."
,"20":"Ó Deus, assegura-me apenas duas coisas e não me esconderei da tua presença:"
,"21":"afasta de mim a tua mão e não me amedrontes com o teu terror."
,"22":"Depois podes acusar-me e eu Te responderei. Ou então falarei eu primeiro, e Tu responder-me-ás depois."
,"23":"Quantas são as minhas culpas e os meus pecados? Mostra-me as minhas transgressões e os meus pecados."
,"24":"Porque escondes o teu rosto, e me tratas como teu inimigo?"
,"25":"Porque assustas uma folha que o vento leva, e persegues uma palha seca?"
,"26":"Porque rediges contra mim sentenças amargas e me obrigas a assumir os erros da minha juventude?"
,"27":"Porque colocas os meus pés no cepo, vigias todos os meus passos e examinas todas as minhas pegadas?"
,"28":"Como odre e como veste roída pela traça, se desgasta"
}`)
	CurrentBook.AddChapter(14, `{
"1":"o homem nascido de mulher: tem vida curta e cheia de inquietação."
,"2":"Ele abre-se como flor, e logo murcha; foge como a sombra, sem parar."
,"3":"E é num tal ser que fixas os teus olhos e o chamas ao teu tribunal?"
,"4":"Mas quem pode tirar o puro do impuro? Ninguém."
,"5":"Se os dias do homem já estão contados e Tu sabes o número dos seus meses; se lhe fixaste um limite intransponível,"
,"6":"afasta dele o teu olhar e deixa-o em paz, de modo que ele possa usufruir do seu salário como um empregado."
,"7":"Uma árvore tem esperança: mesmo que a cortem, volta a rebentar e os seus ramos continuam a crescer."
,"8":"Mesmo que as suas raízes envelheçam na terra e o seu tronco esteja amortecido no solo,"
,"9":"ao cheiro da água ela rebenta e produz folhagem como uma planta nova."
,"10":"O homem, porém, morre e fica inerte. Para onde vai o homem quando expira?"
,"11":"As águas do mar podem acabar, os rios podem baixar e secar,"
,"12":"mas o homem que jaz, não se levantará. O céu passará, e o homem não vai despertar, nem acordar do seu sono."
,"13":"Oxalá me guardasses escondido no túmulo, até a tua ira passar e marcares um prazo para Te lembrares de mim!"
,"14":"Acaso voltará a viver um homem que já tenha morrido? Eu esperaria todos os dias do meu serviço, até que chegasse a hora da mudança de turno;"
,"15":"com saudade da obra das tuas mãos, Tu me chamarias e eu responderia."
,"16":"Então deixarias de controlar os meus passos e não vigiarias os meus pecados."
,"17":"Fecharias num saco os meus erros e apagarias as minhas culpas."
,"18":"A montanha inclina-se e cai, a rocha move-se do seu lugar,"
,"19":"a água corre e desgasta as pedras, a enxurrada arrasta as terras, e Tu destróis a esperança do homem!"
,"20":"Tu o abates e ele desaparece para sempre. Desfiguras-lhe o rosto e o expulsas."
,"21":"Ele não sabe se os seus filhos serão felizes; desconhece se os seus filhos se vão arruinar."
,"22":"Ele só sente o tormento da própria carne, sente o sofrimento da sua própria alma»."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Elifaz de Temã tomou a palavra e disse:"
,"2":"«Acaso um sábio responde com doutrinas falsas, ou se incha com o vento Leste,"
,"3":"argumentando com razões inconsistentes ou palavras sem sentido?"
,"4":"Tu estás a destruir a religião e a eliminar a oração!"
,"5":"As tuas culpas inspiram as tuas palavras, e usas a linguagem dos astutos."
,"6":"É a tua própria boca que te condena e não eu; as tuas palavras é que testemunham contra ti."
,"7":"Foste, porventura, o primeiro homem a nascer? Será que vieste ao mundo antes das colinas?"
,"8":"Acaso foste admitido no conselho secreto de Deus e te apropriaste da sabedoria?"
,"9":"O que é que tu sabes e nós não sabemos? O que é que tu entendes e nós não entendemos?"
,"10":"Entre nós há anciãos de cabelos brancos, e alguns de nós são mais velhos que o teu pai."
,"11":"Não estarás a fazer pouco caso das consolações divinas e das palavras equilibradas que te dirigimos?"
,"12":"Para onde te arrasta o teu coração e como cintilam os teus olhos"
,"13":"quando te encolerizas contra Deus e a tua boca solta tais protestos!"
,"14":"Como pode o homem ser puro, como pode ser inocente quem nasceu de mulher?"
,"15":"Deus não confia nem mesmo nos seus anjos, nem o céu é puro aos seus olhos."
,"16":"Quanto menos o homem detestável e corrompido, que bebe a injustiça como água!"
,"17":"Ou-ve-me, que vou instruir-te. Vou contar-te aquilo que vi,"
,"18":"aquilo que os sábios transmitiram sem nada ocultar, conforme o receberam dos seus antepassados,"
,"19":"a quem foi dado o país, sem que nenhum estrangeiro se instalasse no meio deles."
,"20":"O injusto vive em contínuo tormento, e poucos são os anos reservados ao tirano."
,"21":"Gritos de terror ressoam nos seus ouvidos e, quando está em paz, é assaltado pelo destruidor."
,"22":"Não tem esperança de voltar das trevas, porque está destinado ao fio da espada;"
,"23":"é deitado, como pasto, aos abutres, e sabe que a sua ruína é iminente. O dia tenebroso"
,"24":"apavora-o, a angústia e a inquietação assaltam-no, como um rei pronto para o ataque."
,"25":"Porque ele estendeu a mão contra Deus e desafiou o Todo-poderoso."
,"26":"Investiu contra Ele de cabeça baixa, protegido por um escudo blindado,"
,"27":"com o rosto untado de gordura e os músculos dos rins bem ungidos."
,"28":"Ele habitará cidades abandonadas, casas desabitadas que ameaçam ruir."
,"29":"Não enriquecerá, e a sua fortuna não vai durar, nem poderá levar os seus bens para o túmulo,"
,"30":"nem escapará às trevas. A chama queimará os seus ramos e o vento arrancará as suas flores."
,"31":"Que ele não confie na ilusão que engana, porque a ilusão será a sua recompensa."
,"32":"As suas folhas murcharão antes do tempo e os seus ramos nunca mais ficarão verdes."
,"33":"Será como videira que é despojada das suas uvas ainda verdes, como a oliveira deixará cair a sua flor."
,"34":"A descendência dos injustos é estéril, e o fogo devorará a tenda do homem enganador."
,"35":"Quem concebe a maldade, dá à luz a desgraça, e gera no ventre a desilusão»."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Então Job respondeu:"
,"2":"«Já ouvi mil discursos semelhantes. Vós sois consoladores importunos!"
,"3":"Vós dizeis-me: 'Será que não há limite para discursos vazios? O que é que te leva a responder assim?'"
,"4":"Eu também poderia falar como vós, se estivésseis no meu lugar. Eu afogar-vos-ia com palavras, meneando a cabeça contra vós."
,"5":"Confortar-vos-ia com a minha boca, ou os meus lábios exprimiriam a minha compaixão?"
,"6":"Mas ainda que fale, a minha dor não desaparece; ainda que me cale, ela não se afasta de mim."
,"7":"Agora, porém, Deus esgotou-me e destruiu toda a minha família."
,"8":"Ele levanta-Se como testemunha contra mim e o meu caluniador acusa-me directamente."
,"9":"A sua ira ataca-me e dilacera-me, range os dentes contra mim. Os meus inimigos cravam em mim os seus olhos hostis."
,"10":"Abrem a boca para me devorar e esbofeteiam-me para me ultrajar, todos em massa se revoltam contra mim."
,"11":"Deus entregou-me como presa aos perversos, e deixou-me à disposição dos malvados."
,"12":"Eu vivia tranquilo, e Ele esmagou-me. Agarrou-me pela nuca e triturou-me, fazendo de mim o seu alvo."
,"13":"Cercou-me com os seus archeiros, atravessou-me os rins sem piedade, e espalhou sobre a terra o meu fel."
,"14":"Abriu mil brechas na minha carne e como guerreiro me assaltou."
,"15":"Costurei um pano de saco, a fim de cobrir a minha pele, e mergulhei o meu rosto no pó."
,"16":"A minha face está vermelha de tanto chorar, e a sombra rodeia as minhas pálpebras,"
,"17":"embora não haja violência nas minhas mãos, e a minha oração seja sincera."
,"18":"Ó terra, não cubras o meu sangue, nem o meu clamor seja abafado."
,"19":"Desde agora tenho uma testemunha no céu, e o meu defensor está lá em cima."
,"20":"Ele interpretará as minhas queixas diante de Deus, enquanto diante de Deus os meus olhos derramam lágrimas."
,"21":"Que ele julgue entre o homem e Deus, como se costuma fazer entre as pessoas,"
,"22":"porque o número limitado dos meus anos passará, e farei a viagem que não tem retorno."
}`)
	CurrentBook.AddChapter(17, `{
"1":"A minha respiração perturba-se, os meus dias apagam-se, e o sepulcro espera-me."
,"2":"Estou cercado de zombarias e farto de provocações."
,"3":"Sê Tu o meu fiador diante de Ti mesmo, pois nenhum outro se empenharia em ser meu fiador."
,"4":"Tu fechaste-lhes a mente para o raciocínio e por isso não poderão triunfar."
,"5":"São como alguém que convida os amigos para um banquete, enquanto os seus próprios filhos morrem de fome."
,"6":"Eu tornei-me motivo de escárnio no meio dos povos, e os homens cospem-me no rosto."
,"7":"Os meus olhos são consumidos pela tristeza, e os meus membros definham como a sombra."
,"8":"Ao ver isto os justos espantam-se, e o inocente indigna-se contra o injusto."
,"9":"Mas o justo persiste no seu caminho, e quem tem mãos puras redobra a coragem."
,"10":"Voltai todos e vinde, pois entre vós não encontrarei nenhum sábio."
,"11":"Os meus dias passam, e fracassam os meus projectos e os desejos do meu coração."
,"12":"Transformam a noite em dia, e dizem que a luz está perto, quando já se aproximam as trevas."
,"13":"Não espero mais nada. O túmulo será a minha casa, e nas trevas farei a minha cama."
,"14":"Eu digo ao túmulo: 'Tu és meu pai'. E digo aos vermes: 'Vós sois a minha mãe e a minha irmã'."
,"15":"Onde está a minha esperança? Alguém viu por aí a minha esperança?"
,"16":"Ela descerá comigo ao túmulo, quando juntos nos afundarmos no pó»."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Baldad de Suás tomou a palavra e disse:"
,"2":"«Quando é que acabas com esse palavreado? Pensa bem, e depois conversaremos."
,"3":"Porque é que nos consideras como animais e pensas que somos idiotas?"
,"4":"Dilaceras-te com a tua própria raiva. Será que a Terra vai ficar desabitada por tua causa? Ou será que as rochas vão mudar de lugar?"
,"5":"A luz do injusto apagar-se-á, e o fogo do seu lar não brilhará mais."
,"6":"A luz da sua tenda escurecer-se-á, e a lâmpada que está sobre ele apagar-se-á."
,"7":"Os seus passos vigorosos ficarão curtos, e os seus próprios projectos derrubá-lo-ão."
,"8":"Com os seus próprios pés cai numa rede e caminha sobre uma armadilha."
,"9":"Um laço o prende pelo calcanhar, e o segura firme."
,"10":"A corda está escondida no chão, e a armadilha no seu caminho."
,"11":"Os terrores rodeiam-no e amedrontam-no, perseguindo-o a cada passo."
,"12":"A sua prosperidade transformar-se-á em carestia, e a desgraça estará de pé a seu lado."
,"13":"A doença devora a sua pele, e a peste rói os seus membros."
,"14":"Será arrancado da sua tenda na qual confiava e será arrastado à presença do rei dos terrores."
,"15":"Outros habitarão na tenda que já não lhe pertence, e cairá enxofre sobre a sua moradia."
,"16":"Em baixo, as suas raízes secarão e, no alto, os seus ramos serão cortados."
,"17":"A sua lembrança desaparecerá da Terra, e o seu nome será esquecido na vizinhança."
,"18":"Será expulso da luz para as trevas, e exilado para fora do mundo."
,"19":"Não terá família nem filhos entre o seu povo, e não deixará sobreviventes no seu território."
,"20":"O Ocidente espantar-se-á com o destino dele, e o Oriente ficará horrorizado."
,"21":"Este é o destino do injusto, a situação de quem não reconhece a Deus»."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Então Job respondeu:"
,"2":"«Até quando continuareis a afligir-me e a magoar-me com as vossas palavras?"
,"3":"Já dez vezes me insultastes, e não vos envergonhais de zombar de mim."
,"4":"Se eu tivesse errado, o erro seria problema meu."
,"5":"Quereis cantar vitória, lançando-me na cara a minha vergonha?"
,"6":"Ficai sabendo que foi Deus quem violou o meu direito e me envolveu em suas redes."
,"7":"Eu grito: 'Violência!' E ninguém me responde. Peço socorro, e não me fazem justiça."
,"8":"Deus cercou o meu caminho, e não tenho saída; Ele encheu de trevas a minha estrada."
,"9":"Despojou-me da minha honra, e tirou-me a coroa da cabeça."
,"10":"Destruiu tudo ao meu redor, e tenho de me ir embora; arrancou a árvore da minha esperança."
,"11":"A sua ira inflama-se contra mim, e Ele trata-me como a um seu inimigo."
,"12":"Os seus esquadrões chegam em massa, abrem caminho até mim, e fazem um cerco ao redor da minha tenda."
,"13":"Os meus irmãos abandonam-me, e os meus parentes tratam-me como a um estranho."
,"14":"Os vizinhos e conhecidos desapareceram, e os meus familiares esqueceram-me."
,"15":"As minhas empregadas tratam-me como a um estranho, como se eu fosse um desconhecido."
,"16":"Chamo o meu empregado, e ele não me responde, mesmo que eu lhe implore."
,"17":"A minha mulher tem nojo do meu hálito, e os meus irmãos têm nojo do meu cheiro."
,"18":"Até as crianças me desprezam e, quando tento levantar-me, elas cobrem-me de insultos."
,"19":"As pessoas mais íntimas têm horror de mim, e contra mim se voltam os amigos mais próximos."
,"20":"A minha carne apodrece por baixo da pele, e os meus ossos desnudam-se como dentes."
,"21":"Tende piedade, meus amigos, tende piedade de mim, porque a mão de Deus me feriu."
,"22":"Porque me perseguis como Deus, e não vos cansais de me torturar?"
,"23":"Oxalá escrevessem estas minhas palavras e as gravassem numa placa,"
,"24":"e com cinzel de ferro e estilete fossem escritas para sempre na rocha:"
,"25":"'Eu sei que o meu redentor está vivo e que no fim Se levantará acima do pó."
,"26":"Mesmo com a pele aos pedaços e em carne viva, eu verei a Deus."
,"27":"Eu mesmo O verei, e não outro; eu O verei com os meus próprios olhos'. As minhas entranhas queimam dentro de mim."
,"28":"E se vós disserdes: 'Como vamos persegui-lo? Que pretexto encontraremos para o acusarmos?',"
,"29":"temei a espada, pois a espada pune a injustiça, e vós reconhecereis que existe um juiz»."
}`)
	CurrentBook.AddChapter(20, `{
"1":"Sofar de Naamat tomou a palavra e disse:"
,"2":"«Os meus pensamentos obrigam-me a responder, pois me sinto inquieto."
,"3":"Acabo de ouvir uma lição insolente, e por isso a minha razão me leva a replicar."
,"4":"Tu não sabes que desde sempre, desde quando o homem foi colocado sobre a terra,"
,"5":"o triunfo dos injustos é passageiro e a alegria do perverso dura apenas um instante?"
,"6":"Embora a sua ambição se eleve até ao céu e toque com a sua cabeça as nuvens,"
,"7":"ele perecerá para sempre como esterco, e os que o viam agora perguntam: 'Onde está ele?'"
,"8":"Ele desfaz-se como um sonho, e não o encontram; ele desaparece como visão nocturna."
,"9":"Os olhos que o viam, não o verão mais, e a sua morada não mais o reconhecerá."
,"10":"Os seus filhos terão que indemnizar os pobres; as suas próprias mãos devolverão as suas riquezas."
,"11":"Os seus membros ainda cheios de juventude deitar-se-ão com ele no pó."
,"12":"O mal era doce na sua boca, e ele escondia-o debaixo da língua;"
,"13":"ele saboreava-o sem o engolir, segurando-o no céu da boca."
,"14":"Pois bem! Esse alimento apodrecerá no seu ventre e transformar-se-á em veneno de cobra."
,"15":"Vomitará as riquezas que engoliu, porque Deus lhas arranca do ventre."
,"16":"Sugará veneno de serpente, e as presas da víbora o matarão."
,"17":"Nunca mais verá as fontes de azeite, nem os rios de leite e mel."
,"18":"Terá que devolver, sem os usar, os frutos do seu trabalho, e não desfrutará o que ganhou no comércio."
,"19":"Porque explorou e desamparou os pobres, e roubou casas que não tinha construído."
,"20":"Porque não soube acalmar a sua cobiça, não salvará nenhum dos seus tesouros."
,"21":"Nada escapava da sua voracidade e, por isso, a sua prosperidade não durará."
,"22":"Da abundância cairá na miséria, e os golpes da desgraça cairão sobre ele."
,"23":"Para lhe encher o ventre, Deus enviar-lhe-á o incêndio da sua ira, e sobre ele fará chover as suas flechas."
,"24":"Caso escape das armas de ferro, uma flecha de bronze o atravessará;"
,"25":"a ponta da flecha sai brilhando das suas costas, depois de ter atravessado o fígado, enchendo-o de pavor."
,"26":"Todas as trevas serão reservadas para ele, e um fogo não aceso por homens devorá-lo-á, consumindo tudo o que resta da sua tenda."
,"27":"O céu revelará a injustiça dele e contra ele a terra se erguerá."
,"28":"Um dilúvio arrastará a sua casa, como as cataratas no dia da ira de Deus."
,"29":"Esta é a parte que Deus reserva para o injusto, esta é a herança que Deus lhe prepara»."
}`)
	CurrentBook.AddChapter(21, `{
"1":"Então Job respondeu:"
,"2":"«Escutai com atenção as minhas palavras. Dai-me pelo menos esse conforto."
,"3":"Tende paciência enquanto falo. E, quando eu terminar, podereis zombar de mim."
,"4":"Estou a queixar-me de algum homem? Estou a perder a paciência sem motivo?"
,"5":"Estai atentos, e ficareis espantados e colocareis a mão na boca."
,"6":"Só de pensar nisso, fico perturbado, e o meu corpo se enche de arrepios."
,"7":"Porque é que os injustos continuam vivos, e envelhecem cada vez mais ricos?"
,"8":"A sua descendência está segura na companhia deles, e eles vêem os seus filhos crescer."
,"9":"As suas casas são tranquilas e sem temor; o bastão de Deus não os atinge."
,"10":"Os seus touros reproduzem sem falhar, e as suas vacas geram crias sem abortar."
,"11":"Eles deixam correr as suas crianças como cabritos, e os seus pequenos saltam alegremente."
,"12":"Cantam ao som de cítaras e pandeiros, e divertem-se ao som da flauta."
,"13":"As suas vidas transcorrem docemente, e eles descem tranquilos à sepultura."
,"14":"Eles diziam a Deus: 'Passa longe de nós, pois não nos interessa conhecer os teus caminhos."
,"15":"Quem é o Todo-poderoso para que O sirvamos? O que é que ganhamos rezando-Lhe?'"
,"16":"Pois bem! Eles têm na mão a felicidade, e os projectos do injusto estão longe de Deus."
,"17":"Quantas vezes a lâmpada dos injustos se apaga, ou a desgraça cai sobre eles, ou a ira de Deus os castiga com sofrimentos?"
,"18":"Porventura, eles tornam-se como folha seca ao vento, ou como palha levada pelo furacão?"
,"19":"Dizem que Deus castiga os filhos do injusto! Ora, Ele que faça com que o injusto mesmo pague e aprenda:"
,"20":"que veja com os seus próprios olhos a desgraça, e beba a ira do Todo-poderoso."
,"21":"Pois, o que lhe importa a sua família depois de morto, quando o tempo da sua vida tiver chegado ao fim?"
,"22":"Acaso poder-se-á ensinar a ciência a Deus? Deus governa no céu."
,"23":"Uma pessoa chega à morte em pleno vigor, sempre tranquila e próspera,"
,"24":"com as ancas cobertas de gordura e com a medula dos ossos cheia de energia."
,"25":"Outra pessoa morre cheia de amargura, sem nunca ter provado a felicidade."
,"26":"Ambos se deitam juntos no pó, cobertos de vermes."
,"27":"Eu sei muito bem o que estais a pensar, e conheço os maus pensamentos que remoeis contra mim."
,"28":"Eu sei que vós dizeis: 'Onde está a casa do poderoso, onde está a moradia dos injustos?'"
,"29":"Porque é que não fazeis perguntas aos viajantes e não acreditais no que eles dizem?"
,"30":"O perverso é poupado no dia da catástrofe, e no dia da ira consegue escapar."
,"31":"Quem vai reprovar a sua conduta? Quem lhe vai pedir contas do que ele fez?"
,"32":"Ele será solenemente acompanhado à sepultura, montarão guarda ao seu túmulo,"
,"33":"e a terra será leve para ele. Todos os homens o acompanham e uma incontável multidão vai à frente dele."
,"34":"E vós quereis consolar-me com banalidades? As vossas respostas são pura dissimulação»."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Elifaz de Temã tomou a palavra e disse:"
,"2":"«Acaso pode o homem ser útil a Deus, uma vez que o sábio só pode no máximo ajudar-se a si próprio?"
,"3":"O que é que importa ao Todo-poderoso se tu és justo? O que é que Ele ganha, se és íntegro?"
,"4":"Será que é por causa da tua fidelidade que Ele te reprova, ou te convoca para o julgamento?"
,"5":"Não será antes pela tua grande maldade e pelas tuas incontáveis culpas?"
,"6":"De facto, tu penhoravas os bens dos teus irmãos e despojavas os outros até os deixares nus."
,"7":"Tu não oferecias água ao sedento, e negavas pão ao faminto."
,"8":"Entregavas a terra aos poderosos, e nela se instalavam os privilegiados."
,"9":"Despedias as viúvas de mãos vazias, e violavas o direito dos órfãos."
,"10":"É por isso que estás preso nos laços e perturbado por terrores fulminantes."
,"11":"A escuridão não te deixa ver; e tu estás coberto pela enchente das águas."
,"12":"Será que Deus não está no mais alto do céu? Vê bem como é alto o arco do céu estrelado!"
,"13":"E tu ainda dizes: 'O que é que Deus sabe? Será que Ele é capaz de distinguir através das nuvens escuras?"
,"14":"As nuvens são como véu e impedem-n'O de ver, enquanto Ele passeia pelo firmamento do céu'."
,"15":"Acaso queres seguir o antigo caminho por onde andaram os homens perversos,"
,"16":"arrastados antes do tempo, quando a enchente de um rio lhes desmoronou os alicerces?"
,"17":"Eles diziam a Deus: 'Afasta-Te de nós. Que pode o Todo-poderoso fazer contra nós?'"
,"18":"Deus tinha-lhes enchido a casa de riquezas, e eles excluíam-n'O dos seus projectos perversos."
,"19":"Os justos agora vêem e alegram-se, e os inocentes zombam deles:"
,"20":"'Acabaram-se as suas riquezas. O fogo devorou o que haviam ganhado!'"
,"21":"Vamos, reconcilia-te e faz as pazes com Deus. E serás novamente feliz."
,"22":"Aceita a instrução da boca de Deus e guarda no coração as suas palavras."
,"23":"Se voltares para o Todo-poderoso, Ele te restabelecerá. Afasta a injustiça da tua tenda,"
,"24":"lança o teu ouro ao pó, e o ouro de Ofir entre as pedras do rio."
,"25":"Então o Todo-poderoso será o teu ouro, e também prata aos montes."
,"26":"Então te alegrarás com o Todo-poderoso, e erguerás o rosto para Deus."
,"27":"Ele ouvirá as tuas súplicas, e cumprirás o que havias prometido."
,"28":"Farás um projecto, que se realizará, e a luz brilhará no teu caminho."
,"29":"Porque Ele humilha os arrogantes e salva os que se humilham."
,"30":"Ele liberta o homem inocente, e tu serás salvo pela pureza das tuas próprias mãos»."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Então Job respondeu:"
,"2":"«Ainda hoje me queixo e me revolto, porque a mão de Deus agrava os meus gemidos."
,"3":"Oxalá eu soubesse como encontrá-l'O, como chegar até ao seu tribunal!"
,"4":"Diante d'Ele eu apresentaria a minha causa, com a boca cheia de argumentos."
,"5":"Eu saberia finalmente com que palavras Ele me replica, e compreenderia o que Ele me diz."
,"6":"Será que Ele usaria de violência comigo? Não importa. Ele ao menos teria que me escutar."
,"7":"Então eu discutiria lealmente com Ele, e definitivamente ganharia a minha causa."
,"8":"Mas, se vou para o Oriente, Ele não está lá. Se vou para o Ocidente, não O distingo."
,"9":"Procuro no Norte, e não O descubro. Volto-me para o Sul, e não O vejo."
,"10":"Ele, porém, conhece o meu comportamento. Pode colocar-me à prova, e eu sairei puro como ouro."
,"11":"Os meus pés seguiram as suas pegadas, andei pelo seu caminho e não me desviei."
,"12":"Não me afastei dos seus mandamentos, e guardei as suas palavras no meu peito."
,"13":"Ele toma uma decisão e ninguém pode fazê-l'O mudar. Ele faz tudo o que quer."
,"14":"Ele executará a minha sentença, e outras coisas que tem na mente."
,"15":"Por isso, fico perturbado na sua presença, e sinto medo só de pensar,"
,"16":"porque Deus me intimidou, o Todo-poderoso aterrorizou-me."
,"17":"Oxalá eu desaparecesse nas trevas, e a escuridão cobrisse o meu rosto."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Porque é que o Todo-poderoso não marca tempos de julgamento, para que os seus fiéis possam presenciar as suas intervenções?"
,"2":"Os injustos mudam os marcos, roubam rebanhos e levam-nos a pastar."
,"3":"Apoderam-se do jumento que pertence ao órfão, e penhoram o boi que é da viúva."
,"4":"Empurram os indigentes para fora do caminho, e os pobres da terra têm que se esconder."
,"5":"Como asnos do deserto, saem para trabalhar: desde a madrugada vão em busca de alimentos, e até à tarde procuram o pão para seus filhos."
,"6":"Fazem colheita em campo alheio, e rebuscam os restos na vinha do injusto."
,"7":"Passam a noite nus, sem roupa para se protegerem do frio."
,"8":"Ensopados com as chuvas das montanhas, sem abrigo, eles apertam-se entre as rochas."
,"9":"Os injustos arrancam o órfão do peito materno, e penhoram a roupa do pobre."
,"10":"Estes andam nus por falta de roupa, e famintos carregam feixes."
,"11":"Espremem azeite no lagar e, sedentos, pisam a uva nos tanques."
,"12":"Na cidade, os moribundos gemem, e os feridos pedem socorro. E Deus não faz caso da súplica deles."
,"13":"Outros são rebeldes à luz, não conhecem os caminhos de Deus, nem frequentam as suas estradas."
,"14":"De madrugada, o assassino levanta-se para matar o pobre e o indigente. Durante a noite, o ladrão ronda, cobrindo o rosto com uma máscara."
,"15":"O olho do adúltero aguarda o anoitecer, pensando: 'Ninguém me verá'."
,"16":"Na escuridão, eles arrombam as casas, enquanto de dia se escondem aqueles que não querem nada com a luz."
,"17":"O amanhecer é escuro para eles, pois estão acostumados com o medo das trevas»."
,"18":"«Os injustos fogem da luz do dia. A sua propriedade na terra é amaldiçoada, e ninguém mais passa pela sua vinha."
,"19":"Como o calor do Verão suga a água da neve, também a morada dos mortos suga o pecador."
,"20":"O ventre materno esquece-se dele, e os vermes adoram-no. A sua memória acaba, e a injustiça é cortada como se corta uma árvore."
,"21":"Isto porque ele maltratou a estéril sem filhos e não socorreu a viúva."
,"22":"Mas Aquele que com a sua força derruba os tiranos, aparece e tira-lhe a certeza da vida."
,"23":"Deus deixava-o apoiar-se numa segurança falsa, porém os olhos de Deus observavam os seus caminhos."
,"24":"Exaltado por breve tempo, ele deixa de existir. Cai como a erva que se colhe, e murcha como as espigas."
,"25":"As coisas não são assim? Quem me poderá desmentir, ou reduzir a nada os meus argumentos?»"
}`)
	CurrentBook.AddChapter(25, `{
"1":"Baldadde Suás tomou a palavra e disse:"
,"2":"«Deus tem um poder terrível e mantém a paz no alto do céu."
,"3":"Poder-se-á contar o número das suas tropas? Sobre quem não se levanta a sua luz?"
,"4":"Pode o homem ter razão diante de Deus? Como pode ser puro quem nasceu de mulher?"
,"5":"Se nem sequer a lua é brilhante, nem as estrelas são puras, aos olhos d'Ele,"
,"6":"quanto menos o homem, esse verme; o ser humano, essa larva!»"
}`)
	CurrentBook.AddChapter(26, `{
"1":"Então Job respondeu:"
,"2":"«Como sabes sustentar o fraco e socorrer um braço sem força!"
,"3":"Como sabes aconselhar o ignorante e dar mostras de profundo conhecimento!"
,"4":"A quem dirigiste a palavra? De onde vem a inspiração que sai de ti?»"
,"5":"«Os mortos estremecem debaixo do mar e os seus habitantes."
,"6":"A morada dos mortos está nua aos seus olhos, e o reino da morte está sem véu."
,"7":"Deus estendeu o céu sobre o vazio e suspendeu a terra sobre o nada."
,"8":"Ele prende as águas nas nuvens, sem que estas se rasguem com o peso."
,"9":"Ele encobre a face da lua cheia, estendendo a sua nuvem sobre ela."
,"10":"Traçou um círculo sobre a superfície do mar, onde a luz faz fronteira com as trevas."
,"11":"As colunas do céu abalam-se, assustadas com a ameaça d'Ele."
,"12":"Com o seu poder, Ele acalmou o mar e, com a sua destreza, domou Raab."
,"13":"O seu sopro clareou os céus, e a sua mão trespassou a serpente fugitiva."
,"14":"Tudo isso não é mais do que a margem das suas obras! Delas, nós só percebemos um eco frágil! Quem poderia compreender o estrondo do seu poder?»"
}`)
	CurrentBook.AddChapter(27, `{
"1":"Job continuou a dizer:"
,"2":"«Pelo Deus vivo, que me nega justiça, pelo Todo-poderoso, que me enche de amargura,"
,"3":"enquanto eu puder respirar e o sopro de Deus estiver nas minhas narinas,"
,"4":"os meus lábios não dirão falsidades e a minha língua não pronunciará mentiras."
,"5":"Longe de mim dar-vos razão! Vou declarar-me inocente até ao meu último suspiro."
,"6":"Vou-me agarrar à minha justiça, e não vou ceder. A minha consciência não reprova nenhum dos meus dias."
,"7":"Que o meu inimigo seja tratado como injusto, e o meu adversário como malfeitor."
,"8":"Vós dizeis: Que esperança pode ter o injusto, se Deus lhe vai tirar a vida?"
,"9":"Será que Deus lhe vai ouvir o grito, quando sobre ele cair a desgraça?"
,"10":"Se ele se tivesse alegrado com o Todo-poderoso, será que poderia invocar a Deus a qualquer momento?"
,"11":"Vou explicar-vos o poder de Deus, e não vos esconderei os projectos do Todo-poderoso."
,"12":"Se vós todos já observastes, porque é que ainda vos perdeis em banalidades?»"
,"13":"«Esta é a sorte que Deus reserva ao injusto, a herança que os opressores recebem do Todo-,-poderoso: "
,"14":"se tiverem muitos filhos, todos morrerão pela espada, e os seus descendentes não terão que comer."
,"15":"Os sobreviventes serão sepultados pela peste, e as suas viúvas não chorarão por eles."
,"16":"O justo acumula prata como terra e amontoa roupas como barro."
,"17":"Pode amontoar! É o justo quem as vestirá, e a prata é o inocente quem a herdará."
,"18":"A casa por ele construída será como teia de aranha, como a choupana de um guarda."
,"19":"Ele deita-se rico, mas é pela última vez, pois ao abrir os olhos não terá mais nada."
,"20":"De dia, os terrores assaltam-no, e de noite, o furacão arrebata-o."
,"21":"O vento Leste arrasta-o para longe, arrancando-o da sua residência;"
,"22":"o vento arrasta-o sem piedade, e ele tenta fugir do seu poder."
,"23":"Todos aplaudem a sua ruína, e por onde ele passa todos assobiam»."
}`)
	CurrentBook.AddChapter(28, `{
"1":"A prata tem as suas minas, e o ouro tem o lugar onde é refinado."
,"2":"O ferro é extraído da terra, e ao fundir-se a pedra, dela sai o bronze."
,"3":"O homem põe limite às trevas, e explora até ao extremo limite as grutas mais sombrias."
,"4":"Abre poços em lugares inacessíveis, sem apoio para os pés, balançando suspenso longe dos homens."
,"5":"A terra que dá o pão, por baixo é devorada pelo fogo;"
,"6":"as suas pedras são incrustadas de safiras, e os seus torrões contêm pepitas de ouro."
,"7":"O abutre não conhece esse caminho, e o olho do falcão não consegue avistá-lo;"
,"8":"as feras não o trilham, nem o leão o atravessa."
,"9":"O homem estende a mão contra a rocha, e revira as montanhas pela raiz;"
,"10":"abre galerias na pedra, atento a tudo o que é preciso;"
,"11":"explora as nascentes dos rios, e traz à luz o que está escondido."
,"12":"A sabedoria, porém, de onde é tirada? Onde está a jazida da inteligência?"
,"13":"O homem não conhece o caminho para ela, pois ela não se encontra na terra dos vivos."
,"14":"O abismo diz: «Ela não está em mim». E o mar responde: «Ela não está comigo»."
,"15":"Ela não pode ser comprada com o ouro mais fino, nem adquirida a peso de prata;"
,"16":"não pode ser paga com ouro de Ofir, nem com ónix precioso ou safira."
,"17":"O ouro e o cristal não se igualam a ela, que não pode ser paga com vasos de ouro fino."
,"18":"Os corais e as pérolas, então, nem se fala; é melhor pescar a sabedoria do que as pérolas."
,"19":"O topázio de Cuch não se iguala a ela, nem pode ser comprada com o ouro mais puro."
,"20":"De onde vem a sabedoria? Onde está a jazida da inteligência?"
,"21":"Ela está oculta aos olhos dos seres vivos, e escondida às aves do céu."
,"22":"O abismo e a morte confessam: «A sua fama chegou aos nossos ouvidos»."
,"23":"Só Deus conhece o caminho para a sabedoria, só Ele sabe onde ela se encontra,"
,"24":"pois Ele contempla os confins do Universo e vê tudo o que existe debaixo do céu."
,"25":"Quando fixou um peso para o vento e definiu a medida das águas,"
,"26":"quando deu uma lei para a chuva e uma rota para o relâmpago e o trovão,"
,"27":"então Ele observou-a e avaliou-a, sondou-a e estabeleceu-a."
,"28":"E disse ao homem: «A sabedoria consiste em temer o Senhor, e a inteligência está em afastar-se do mal»."
}`)
	CurrentBook.AddChapter(29, `{
"1":"Job continuou a dizer:"
,"2":"«Quem me dera voltar aos tempos de outrora, aos dias em que Deus me protegia,"
,"3":"quando a sua lâmpada brilhava sobre a minha cabeça, e com a sua luz eu caminhava no meio das trevas!"
,"4":"Pudesse eu reviver os dias do meu Outono, quando Deus era íntimo na minha tenda,"
,"5":"quando o Todo-poderoso estava comigo, e os meus filhos me rodeavam!"
,"6":"Nesse tempo, eu banhava os pés no leite, e a rocha dava-me rios de azeite."
,"7":"Quando eu me dirigia à porta da cidade, e me sentava na praça."
,"8":"ao verem-me, os jovens escondiam-se, os anciãos levantavam-se e ficavam de pé,"
,"9":"os chefes deixavam de falar e tapavam a boca com a mão,"
,"10":"os políticos emudeciam, e a sua língua ficava colada ao céu da boca."
,"11":"Todos os que me ouviam elogiavam-me, e com os olhos aprovavam,"
,"12":"porque eu libertava o pobre que pedia socorro e o órfão indefeso."
,"13":"Eu recebia a bênção do moribundo, e alegrava o coração da viúva."
,"14":"Eu vestia a justiça como túnica, e o direito era o meu manto e o meu turbante."
,"15":"Eu era os olhos do cego e os pés do coxo."
,"16":"Eu era o pai dos pobres, e empenhava-me pela causa de um desconhecido."
,"17":"Eu quebrava o queixo do injusto e arrancava a presa dos seus dentes."
,"18":"Eu imaginava então: 'Morrerei dentro do meu ninho, e como a fénix multiplicarei os meus dias."
,"19":"As minhas raízes chegarão até à água, e o orvalho pousará nos meus ramos."
,"20":"A minha honra sempre se renovará, e o meu arco reforçar-se-á na minha mão'."
,"21":"Todos me ouviam com atenção e, em silêncio, esperavam os meus conselhos."
,"22":"Depois de eu falar, ninguém me replicava. As minhas palavras gotejavam sobre eles,"
,"23":"que esperavam por elas como chuvisco, e bebiam-nas como chuva da Primavera."
,"24":"Se eu brincava, não acreditavam, e não perdiam nenhuma expressão do meu rosto."
,"25":"Sentado como chefe, eu indicava-lhes o caminho, como rei entronizado no meio da sua escolta. Eu guiava-os, e eles deixavam-se conduzir."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Agora, porém, zombam de mim pessoas mais jovens que eu, cujos pais eu não deixaria entre os cães do meu rebanho."
,"2":"Para que me serviriam os seus braços, sem forças como estavam?"
,"3":"Consumidos pela fome e miséria, eles ruminavam as raízes do deserto, em sombria e desolada solidão."
,"4":"Apanhavam ervas amargas entre os arbustos, alimentando-se com raízes de plantas."
,"5":"Expulsos da sociedade aos gritos, como se fossem ladrões,"
,"6":"moravam em barrancos escarpados, em cavernas e grutas do rochedo,"
,"7":"rugindo entre as moitas, agachados debaixo dos espinheiros."
,"8":"Gente vil, homens sem nome, expulsos do país!"
,"9":"Pois bem! Agora eu tornei-me alvo das suas zombarias e tema das suas piadas!"
,"10":"Eles desprezam-me e afastam-se, e até se atrevem a cuspir-me no rosto."
,"11":"Deus soltou a corda do meu arco e humilhou-me e eles desenfreiam-se contra mim."
,"12":"À minha direita, os patifes levantam-se, observam se estou tranquilo e preparam-me o caminho da destruição."
,"13":"Desfazem o meu caminho, e trabalham juntos para a minha ruína, e ninguém os detém."
,"14":"Penetram por uma larga brecha e irrompem como tempestade."
,"15":"Os terrores caem sobre mim, a minha dignidade dissipa-se como o vento, e a minha felicidade desfaz-se como a nuvem."
,"16":"Agora quero desafogar-me. Os dias de tristeza oprimem-me."
,"17":"De noite, um mal penetra nos meus ossos, pois as chagas que me corroem não me deixam dormir."
,"18":"Deus agarra-me com violência pelas vestes e segura-me pela gola da túnica,"
,"19":"atira-me para o meio da lama, e eu fico misturado com o pó e a cinza."
,"20":"Clamo a Ti, e Tu não me respondes. Eu insisto, e Tu não Te importas comigo."
,"21":"Tu transformaste-Te em meu carrasco, e atacas-me com o teu braço musculoso."
,"22":"Tu levantas-me e fazes-me cavalgar o vento, sacudindo-me no furacão."
,"23":"Eu sei muito bem que Tu me conduzes para a morte, para o lugar onde todos os seres vivos se encontram."
,"24":"Quem não estende os braços quando se afunda? No desastre, quem não grita por socorro?"
,"25":"Não chorei com o oprimido? Não tive compaixão do indigente?"
,"26":"Eu esperava a felicidade, mas veio a desgraça; eu esperava a luz, mas veio a escuridão."
,"27":"As minhas entranhas fervem e não se acalmam, dias de aflição me assaltam."
,"28":"Eu caminho no luto, longe do sol, e levanto-me na assembleia para pedir auxílio."
,"29":"Tornei-me irmão dos chacais e companheiro dos avestruzes."
,"30":"A minha pele escurece e cai, os meus ossos são consumidos pela febre."
,"31":"A minha cítara acompanha o luto, e a minha flauta acompanha o pranto."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Eu tinha feito um pacto com os meus olhos: jamais fixar o olhar nas jovens."
,"2":"E, em troca, que sorte Deus me reserva lá do alto? Que herança o Todo-poderoso me destina lá do Céu?"
,"3":"Será que a desgraça não é para o criminoso, e o fracasso para o malfeitor?"
,"4":"Não vê Deus os meus caminhos e não conta todos os meus passos?"
,"5":"Acaso caminhei com a mentira? Será que os meus pés correram atrás da fraude?"
,"6":"Deus pode pesar-me na balança da justiça, e então reconhecerá a minha integridade."
,"7":"Se os meus passos se desviaram do caminho, se o meu coração seguiu o capricho dos olhos, e se qualquer mancha se apegou às minhas mãos,"
,"8":"então que outro coma o que semeei e arranquem tudo o que plantei."
,"9":"Se o meu coração se deixou seduzir por mulher e se espiei pela porta do meu vizinho,"
,"10":"que a minha mulher gire o moinho para um estranho e que outros se deitem com ela."
,"11":"Isso, de facto, seria um escândalo, um crime digno de castigo."
,"12":"Seria um fogo que devora e consome, destruindo todos os meus bens."
,"13":"Se violei o direito do meu empregado ou da minha empregada, quando moviam processo contra mim,"
,"14":"que farei, quando Deus Se levantar? Que responderei, quando Ele me interrogar?"
,"15":"Quem me formou no ventre materno, não os formou também a eles? Foi o mesmo Deus que nos formou no seio materno."
,"16":"Porventura neguei o que o fraco desejava, ou deixei a viúva consumir-se em pranto?"
,"17":"Comi sozinho o meu pedaço de pão, sem o repartir com o órfão? -"
,"18":"Desde a minha infância Ele me criou como pai, e desde o seio materno me guiou. -"
,"19":"Acaso vi um miserável sem roupa e algum indigente sem cobertor,"
,"20":"sem que as suas costas me agradecessem, aquecidas com a lã das minhas ovelhas?"
,"21":"Se levantei a mão contra o órfão, quando eu tinha influência no tribunal,"
,"22":"que o meu ombro se desprenda do corpo e o meu braço se quebre no cotovelo."
,"23":"Porque o terror de Deus cairia sobre mim, e eu não aguentaria diante da sua majestade."
,"24":"Coloquei a minha confiança no ouro, ou a minha segurança no metal precioso?"
,"25":"Alegrei-me com as minhas grandes riquezas ou com a fortuna acumulada pelas minhas mãos?"
,"26":"Ao ver o sol resplandecente e a lua clara caminhar,"
,"27":"o meu coração deixou-se secretamente seduzir e enviei-lhes um beijo com a mão?"
,"28":"Isso seria um crime digno de castigo, pois eu teria renegado o Deus do alto."
,"29":"Alegrei-me com a desgraça do meu inimigo e exultei com a sua infelicidade?"
,"30":"Ou permiti que a minha boca pecasse, desejando-lhe a morte com maldições?"
,"31":"As pessoas da minha tenda disseram: 'Quem não se fartou na mesa dele?'"
,"32":"O imigrante nunca teve que dormir na rua, porque eu abria as minhas portas ao viajante."
,"33":"Não ocultei o meu delito como fazem outros homens, nem escondi no peito a minha culpa,"
,"34":"por temor dos comentários da multidão ou por temer o desprezo dos parentes, a ponto de me manter calado e fechado dentro de casa."
,"35":"Oxalá houvesse alguém para me escutar! Esta é a minha última palavra. Que o Todo-poderoso me responda. Que o meu adversário escreva a acusação."
,"36":"Eu a levarei sobre os meus ombros e a usarei como se fosse coroa."
,"37":"Eu Lhe prestaria contas de todos os meus passos e me apresentaria a Ele como um príncipe."
,"38":"Se a minha terra gritou contra mim e os seus sulcos choraram com ela;"
,"39":"se comi o seu produto sem ter pago por ele, reduzindo à fome aqueles que a cultivaram,"
,"40":"que nasçam espinhos em vez de trigo e urtigas em vez de cevada». Fim do protesto de Job."
}`)
	CurrentBook.AddChapter(32, `{
"1":"Os três homens não disseram mais nada a Job, porque ele se considerava inocente."
,"2":"Todavia, Eliú, filho de Baraquel, natural de Buz, da família de Ram, ficou indignado contra Job, porque este pretendia ter razão contra Deus."
,"3":"Também se indignou contra os três amigos, porque não acharam resposta e deixaram Deus em situação de culpado."
,"4":"Eliú tinha ficado à espera, enquanto eles falavam com Job, porque eram mais velhos."
,"5":"Vendo, porém, que nenhum dos três tinha mais respostas, ficou indignado."
,"6":"Então Eliú, filho de Baraquel, natural de Buz, começou a falar: «Eu sou jovem, e vós sois anciãos. Por isso, eu estava intimidado e não me atrevia a expor-vos o meu conhecimento."
,"7":"Eu fiquei a pensar: 'Que falem os anos, e a idade madura ensine a sabedoria'."
,"8":"Mas quem dá inteligência é um espírito no homem, o sopro do Todo-poderoso."
,"9":"Não é a idade avançada que dá sabedoria, nem é a velhice que produz o discernimento do que é justo."
,"10":"Por isso, peço que me escuteis, e eu também vou mostrar o que sei."
,"11":"Enquanto vós faláveis, eu esperei, e enquanto conversáveis prestei atenção aos vossos argumentos."
,"12":"Contudo, por mais que eu prestasse atenção, percebi que nenhum de vós conseguiu refutar Job e responder aos seus argumentos."
,"13":"Não digais que encontrastes uma sabedoria que, além de Deus, ninguém pode refutar."
,"14":"Job ainda não discutiu comigo, e eu não vou responder-lhe com os vossos argumentos."
,"15":"Estão desconcertados e nada respondem, porque lhes faltam argumentos."
,"16":"Será que devo ficar à espera, já que eles não falam e não sabem o que responder?"
,"17":"Pois bem! Quero tomar parte na discussão. Também eu vou mostrar o que sei,"
,"18":"porque tenho muitas coisas a dizer, e elas pressionam-me por dentro."
,"19":"As minhas entranhas estão como barris novos que o vinho rebenta ao fermentar."
,"20":"Vou falar e desafogar-me, abrindo os lábios para responder."
,"21":"Não vou tomar partido, nem adular ninguém,"
,"22":"porque não sei adular e porque o meu Criador me eliminaria."
}`)
	CurrentBook.AddChapter(33, `{
"1":"E agora, Job, ouve as minhas palavras, presta atenção ao que vou dizer."
,"2":"Vou abrir a minha boca, e a minha língua formará palavras com o céu da boca."
,"3":"Falo de coração sincero, e os meus lábios falarão claramente."
,"4":"Foi o sopro de Deus que me criou, o alento do Todo-poderoso me deu vida."
,"5":"Se puderes, responde-me; prepara-te, e argumenta contra mim."
,"6":"Vê! Diante de Deus, eu sou igual a ti: também eu fui tirado do barro."
,"7":"Não tenhas medo de mim, pois a minha autoridade não inibirá."
,"8":"Disseste e repetiste aos meus ouvidos, e ainda escuto o som das tuas palavras:"
,"9":"'Eu sou puro, e não tenho culpa! Sou inocente e não cometi nenhum pecado!"
,"10":"Deus, porém, inventa pretextos contra mim e trata-me como inimigo."
,"11":"Ele coloca os meus pés no cepo e vigia todos os meus passos'."
,"12":"Nisso eu digo que tu não tens razão, pois Deus é maior do que o homem."
,"13":"Como é que te atreves a levantar um processo contra Ele, dizendo que Ele não responde a nenhuma das tuas acusações?"
,"14":"Deus fala, ora de um modo, ora de outro, mas as pessoas não prestam atenção."
,"15":"Ele fala em sonhos ou em visões nocturnas, quando o torpor cai sobre o homem adormecido no leito."
,"16":"Então abre o ouvido do ser humano, segredando-lhe as suas advertências,"
,"17":"para o afastar do mal e evitar que se encha de orgulho."
,"18":"Desta forma, impede que o homem desça ao túmulo e ultrapasse a fronteira da morte."
,"19":"Às vezes, Deus também corrige o homem com o sofrimento na cama, quando o corpo treme sem parar,"
,"20":"e a pessoa recusa comer, com nojo até do seu alimento preferido;"
,"21":"quando a pessoa emagrece a olhos vistos e os seus ossos começam a aparecer."
,"22":"Então ela aproxima-se do túmulo, e a sua vida é entregue à morada dos mortos."
,"23":"Contudo, se a pessoa encontra um anjo favorável, um intercessor, entre outros mil, que lhe mostre o seu dever,"
,"24":"que tenha compaixão dele e diga a Deus: 'Livra-o de baixar à sepultura, pois encontrei um resgate para ele',"
,"25":"então o seu corpo de novo se tornará jovem, e ele voltará aos dias da sua mocidade."
,"26":"Então suplicará a Deus, que o atenderá. Deus mostrar-lhe-á alegremente a sua face, fazendo com que o homem se torne justo."
,"27":"Esse homem contará aos outros: 'Eu pequei e violei a justiça, mas Deus não me castigou como eu merecia."
,"28":"Livrou-me de cair na sepultura, e agora a minha vida pode contemplar a luz'."
,"29":"Vede como Deus faz tudo isto duas e até três vezes em favor do homem,"
,"30":"a fim de o tirar vivo do túmulo e o iluminar com a luz da vida."
,"31":"Presta atenção, Job, escuta-me, fica em silêncio enquanto eu falo."
,"32":"Se tens algo a dizer, responde-me. Podes falar, estou disposto a dar-te razão."
,"33":"Se não tens nada para dizer, então escuta-me, cala-te, e ensinar-te-ei a sabedoria»."
}`)
	CurrentBook.AddChapter(34, `{
"1":"Eliú continuou, dizendo:"
,"2":"«Sábios, escutai as minhas palavras, e vós, doutores, prestai atenção."
,"3":"Assim como o ouvido distingue as palavras e o paladar saboreia os alimentos,"
,"4":"também nós podemos discernir o que é justo e reconhecer o que é bom."
,"5":"Job afirmou: 'Estou inocente, mas Deus nega-Se a fazer-me justiça."
,"6":"Embora esteja no meu direito, passo por mentiroso e, embora não tenha pecado, uma flecha me feriu mortalmente'."
,"7":"Quem é grande como Job? Ele bebe sarcasmo como água,"
,"8":"junta-se aos malfeitores e anda na companhia dos injustos."
,"9":"Ele afirma: 'O homem não ganha nada em satisfazer a Deus'."
,"10":"Escutai-me, homens sensatos. Longe de Deus praticar o mal, longe do Todo-poderoso praticar a injustiça!"
,"11":"Deus paga ao homem conforme as suas obras e retribui a cada um conforme a sua conduta."
,"12":"Deus, na verdade, não age de modo injusto. O Todo-poderoso nunca viola o direito."
,"13":"Quem Lhe confiou o governo da Terra? Quem Lhe entregou o mundo inteiro?"
,"14":"Se Ele pensasse apenas em Si mesmo e retirasse o seu espírito e o seu corpo,"
,"15":"todas as criaturas morreriam no mesmo instante, e o homem voltaria ao pó."
,"16":"Se és inteligente, escuta-me, presta atenção ao que vou dizer."
,"17":"Quem é inimigo do direito conseguiria governar? Atreves-te a condenar o Supremo Justo?"
,"18":"Ele é capaz de dizer a um rei: 'És um homem vil'. E a um príncipe: 'És um homem injusto'."
,"19":"Deus não é parcial a favor dos poderosos, nem favorece o rico contra o pobre, porque todos são obras das suas mãos."
,"20":"Eles morrem de repente no meio da noite, os grandes perecem e desaparecem, e o poderoso é derrubado sem esforço humano."
,"21":"Porque os olhos de Deus vêem a conduta do homem e vigiam todos os seus passos."
,"22":"Não há trevas nem sombras onde os malfeitores possam esconder-se."
,"23":"Não cabe ao homem marcar prazo para comparecer perante o tribunal de Deus."
,"24":"Ele aniquila os poderosos sem muitos inquéritos e, para o lugar deles, nomeia outros."
,"25":"Deus conhece a fundo as suas acções. Ele derruba-os numa noite, e são destruídos."
,"26":"Ele açoita-os como criminosos, e prende-os em público,"
,"27":"porque se afastaram d'Ele, e não seguiram os seus caminhos,"
,"28":"fazendo com que o clamor dos fracos chegasse até Deus, e Ele ouvisse o clamor dos pobres."
,"29":"Se Deus não intervém, quem poderá condená-l'O? Se Ele esconde o rosto, quem poderá vê-l'O? Todavia Ele cuida dos povos e das pessoas,"
,"30":"para que não reine o perverso nem alguém que engane o povo."
,"31":"Diz apenas isto a Deus: 'Enganei-me, nunca mais volto a fazer o mal."
,"32":"Ensina-me aquilo que eu não vejo. Se pratiquei o mal, não voltarei a fazê-lo'."
,"33":"Será que Ele deveria retribuir-te segundo as tuas ideias, uma vez que rejeitas o seu julgamento? Quem deve escolher és tu e não eu. Vamos, diz o que sabes."
,"34":"Os homens sensatos e os sábios que me escutam confessarão:"
,"35":"'Job não sabe o que diz. As suas palavras não têm sentido!'"
,"36":"Quero que Job seja examinado até ao fim por causa das suas respostas, dignas de um descrente,"
,"37":"porque ao pecado junta a revolta. Ele semeia a dúvida entre nós e multiplica os seus protestos contra Deus»."
}`)
	CurrentBook.AddChapter(35, `{
"1":"Eliú continuou, dizendo:"
,"2":"«Será que pretendes ter razão, quando dizes: 'Sou mais justo do que Deus?'"
,"3":"Ou quando dizes: 'De que me serviu, e o que é que eu ganhei em não pecar?'"
,"4":"Vou responder-te a ti e aos teus amigos."
,"5":"Olha atentamente para o céu e observa as nuvens que estão por cima de ti."
,"6":"Se pecares, que mal fazes a Deus? Se amontoas crimes, que danos Lhe causas?"
,"7":"E se és justo, o que é que Lhe estás a dar? O que é que Ele recebe da tua mão?"
,"8":"A tua maldade só pode afectar um homem igual a ti. A tua justiça só atinge um outro ser humano como tu."
,"9":"As pessoas gemem sob o peso da opressão, e pedem socorro contra os poderosos."
,"10":"Mas ninguém diz: 'Onde está o nosso Deus criador, que restaura as nossas forças durante a noite,"
,"11":"que nos instrui mais do que aos animais da terra e nos torna mais sábios do que as aves do céu?'"
,"12":"Alguns clamam, porém Deus não responde ao orgulho dos injustos."
,"13":"Deus não ouve a falsidade, e o Todo-poderoso não presta atenção a isso."
,"14":"E tu ainda te atreves a dizer que não O vês, que Lhe entregaste a tua causa, que Ele não intervém com a sua ira,"
,"15":"que Ele ignora o pecado."
,"16":"Job abriu a boca para dizer palavras sem sentido»."
}`)
	CurrentBook.AddChapter(36, `{
"1":"Eliú continuou, dizendo:"
,"2":"«Espera um pouco e eu te instruirei, porque ainda existem outros argumentos para a defesa de Deus."
,"3":"Irei longe para buscar a minha ciência, a fim de dar razão ao meu Criador."
,"4":"Os meus argumentos não são falsos; tens diante de ti um sábio consumado."
,"5":"Sim, Deus é poderoso e não despreza o coração sincero."
,"6":"Ele não deixa viver o ímpio e faz justiça aos pobres."
,"7":"Não afasta os seus olhos dos justos. Pelo contrário, fá-los sentar em tronos reais e exalta-os para sempre."
,"8":"Quando os prende com correntes e os amarra com os laços da aflição,"
,"9":"é porque Ele só quer denunciar-lhes as acções e pecados causados pelo orgulho."
,"10":"E assim, Deus abre-lhes os ouvidos para a correcção e aconselha-os a abandonarem a injustiça."
,"11":"Se eles Lhe derem atenção e se submeterem, terminarão os seus dias na prosperidade e os seus anos no bem-estar."
,"12":"Se não obedecerem, atravessarão a fronteira da morte e morrerão sem dar por isso."
,"13":"Os injustos, quando Deus os aflige, acumulam rancor em vez de pedirem auxílio."
,"14":"Perdem a vida em plena juventude e morrem entre os infames."
,"15":"Deus, porém, salva o pobre através da aflição e abre-lhe os ouvidos por meio do sofrimento."
,"16":"Ele também te quer arrancar da angústia e levar-te para um lugar espaçoso e aberto, para te servir com mesa farta."
,"17":"Tu, porém, não fazes justiça contra o injusto, nem defendes o direito do órfão."
,"18":"Não te deixes seduzir com presentes, nem perverter com ricos subornos."
,"19":"Porventura, no perigo, as tuas riquezas e posses valerão alguma coisa diante de Deus?"
,"20":"Não esmagues pessoas estranhas, para colocar os teus parentes no lugar delas."
,"21":"Não te voltes para a injustiça, porque foi por causa dela que foste provado através da aflição."
,"22":"Vê como Deus é sublime no seu poder! Que mestre pode comparar-se a Ele?"
,"23":"Quem é que Lhe ensina o caminho, ou pode acusá-l'O de injustiça?"
,"24":"Lembra-te de celebrar as suas obras, que a humanidade cantou."
,"25":"Todos os homens as contemplam, todos os mortais as admiram de longe."
,"26":"A grandeza de Deus supera todo o conhecimento, e o número dos seus anos é incalculável."
,"27":"Ele faz subir as gotas de água, e transforma os seus vapores em chuva."
,"28":"As nuvens destilam e derramam a chuva que cai abundante sobre a terra."
,"29":"Quem poderá calcular a extensão das nuvens e a altura da sua tenda celeste?"
,"30":"Ele espalha diante de Si a neblina que cobre a crista das montanhas."
,"31":"Com a chuva, alimenta os povos, dando-lhes comida abundante."
,"32":"Enche as mãos com raios e atira-os contra um alvo certo."
,"33":"O trovão anuncia a sua chegada, e a sua ira acende-se contra a injustiça."
}`)
	CurrentBook.AddChapter(37, `{
"1":"Ao ver tudo isto, o meu coração treme e enche-se de espanto."
,"2":"Atenção! Ouvi o trovão da sua voz e o estrondo que sai da sua boca."
,"3":"O seu relâmpago brilha no céu e atinge a extremidade da Terra."
,"4":"Depois dele ressoa o trovão. Troveja com o seu fragor e ninguém pode deter os seus raios, quando se ouve o seu trovão."
,"5":"Deus troveja com uma voz prodigiosa e realiza maravilhas que não compreendemos."
,"6":"Deus ordena à neve: 'Cai sobre a terra'. E à chuva torrencial: 'Desce com violência'."
,"7":"Ele interrompe a actividade dos homens, para que todos reconheçam a sua obra."
,"8":"As feras entram nos seus esconderijos e permanecem nas suas tocas."
,"9":"O furacão avança do Sul, e do Norte aproxima-se o frio."
,"10":"Ao sopro de Deus forma-se o gelo, e gela a superfície das águas."
,"11":"Ele enche as nuvens de raios e as nuvens espalham os seus relâmpagos."
,"12":"Estas, guiadas por Ele, giram e circulam, para cumprir todas as suas ordens no mundo inteiro."
,"13":"Ele envia-as aos povos da Terra para os castigar ou para os beneficiar."
,"14":"Ouve bem, Job. Pára, e considera as maravilhas de Deus!"
,"15":"Sabes como Deus dirige os relâmpagos e os faz brilhar no meio das nuvens?"
,"16":"Sabes como é que Ele equilibra as nuvens, maravilhas de sabedoria consumada?"
,"17":"Sabes porque se aquecem as tuas vestes, quando a terra desfalece por causa do vento sul?"
,"18":"Porventura saberás estender como Ele o firmamento e torná-lo sólido como espelho de metal fundido?"
,"19":"Ensina-nos o que devemos dizer a Deus, pois não podemos argumentar às escuras."
,"20":"Será preciso avisá-l'O de que pretendo falar? Será que Ele é informado quando um homem fala?"
,"21":"Agora, escurecida pelas nuvens, já se não vê a luz que resplandece no céu. No entanto, o vento soprará e varrerá as nuvens."
,"22":"Do Norte chega um clarão dourado, Deus envolve-Se de majestade terrível."
,"23":"Não podemos alcançar o Todo-poderoso. Ele é sublime em poder, rico de justiça, e não oprime ninguém."
,"24":"Por isso, todos os homens O temem, e Ele não leva em conta aqueles que se consideram sábios»."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Então Javé, do meio da tempestade, respondeu a Job e disse:"
,"2":"«Quem é aquele que obscurece o meu projecto com palavras sem sentido?"
,"3":"Se és homem, prepara-te: vou interrogar-te e tu responder-Me-ás."
,"4":"Onde é que tu estavas quando Eu lancei os fundamentos da Terra? Diz-mo, se é que tens inteligência para isso!"
,"5":"Sabes quem fixou as dimensões da Terra? Quem a mediu com a régua?"
,"6":"Onde se encaixam as suas bases, ou quem foi que assentou a sua pedra angular,"
,"7":"enquanto os astros da manhã aclamavam e todos os filhos de Deus aplaudiam?"
,"8":"Quem pôs diques ao mar, quando ele irrompeu, jorrando do seio materno,"
,"9":"quando lhe dava as nuvens como roupas e o enfaixava com espessas nuvens?"
,"10":"Quando lhe coloquei limites com portas e trancas,"
,"11":"e lhe disse: 'Vais chegar até aqui, e não passarás. Aqui se quebrará a soberba das tuas ondas'?"
,"12":"Alguma vez na tua vida deste ordens ao amanhecer, ou marcaste um lugar à aurora,"
,"13":"para ela agarrar as bordas da Terra e sacudir os injustos?"
,"14":"Acaso deste ordens à Terra para ela se moldar como a argila debaixo do sinete e tingir-se como um vestido,"
,"15":"recusando a luz aos injustos e quebrando o braço dos soberbos?"
,"16":"Já desceste às fontes do mar, ou passeaste pelas profundezas do oceano?"
,"17":"Já te mostraram as portas da morte, ou já viste os portais das sombras?"
,"18":"Já examinaste a extensão da Terra? Diz-me, se sabes tudo isso!"
,"19":"Por onde se vai à casa da luz, e onde é o lugar das trevas,"
,"20":"para que as leves para o seu território e lhes ensines o caminho para casa?"
,"21":"Certamente deverias saber tudo isto, pois já tinhas nascido e já viveste muitíssimos anos."
,"22":"Já entraste nos reservatórios da neve e observaste os depósitos do granizo,"
,"23":"que Eu reservo para os tempos de calamidade, para os dias de guerra e batalha?"
,"24":"Por onde se espalha o calor, e se difunde sobre a Terra o vento Leste?"
,"25":"Quem abriu o caminho aos aguaceiros, e as rotas aos relâmpagos e aos trovões,"
,"26":"para chover em terras despovoadas e no deserto, onde os homens não habitam,"
,"27":"para que as regiões desoladas se saciem, e façam germinar e brotar a erva?"
,"28":"Terá a chuva um pai? Quem gera as gotas do orvalho?"
,"29":"De que seio vem o gelo, e quem dá à luz a geada do céu?"
,"30":"As águas endurecem como pedra, e a superfície do lago congela-se."
,"31":"És tu que amarras os laços das Plêiades, ou desatas as ligações de Órion?"
,"32":"És tu que fazes aparecer as constelações do zodíaco na sua estação própria, ou guias a Ursa Maior com os seus filhos?"
,"33":"Conheces as leis do céu, ou determinas as suas funções sobre a Terra?"
,"34":"És capaz de levantar a voz até às nuvens, para que te cubram de abundantes águas?"
,"35":"Porventura a tua voz faz surgir os relâmpagos, que te respondem: 'Aqui estamos'?"
,"36":"Quem pôs a sabedoria nas nuvens ou quem deu inteligência aos meteoros?"
,"37":"Quem está em grau de contar exactamente as nuvens, e quem entorna os cântaros do céu,"
,"38":"quando o pó da terra se transforma em barro e os torrões se amontoam?"
,"39":"Acaso és tu que caças a presa para a leoa ou sacias a fome dos leõezinhos,"
,"40":"quando eles se recolhem nas tocas ou ficam de emboscada nas moitas?"
,"41":"És tu que dás alimento ao corvo, quando os seus filhotes gritam a Deus e se agitam por falta de comida?"
}`)
	CurrentBook.AddChapter(39, `{
"1":"Sabes quando é que as camurças têm cria? Já assististe ao parto das corças?"
,"2":"Contaste os meses da sua gravidez ou conheces o momento do parto?"
,"3":"Elas abaixam-se, dão à luz as suas crias e livram-se das dores."
,"4":"Os seus filhotes crescem e ficam fortes, crescem nos campos, afastam-se delas e nunca mais voltam."
,"5":"Quem solta as rédeas e dá liberdade ao burro selvagem,"
,"6":"ao qual dei o deserto como habitação e a planície salgada como moradia?"
,"7":"Ele ri-se do barulho da cidade e não dá atenção aos gritos de quem o arreia."
,"8":"Ele explora as montanhas em busca de pasto, à procura de lugares verdes."
,"9":"Será que o búfalo aceita servir-te e passar a noite no teu estábulo?"
,"10":"Poderás colocar nele uma canga, para que lavre a terra dos teus campos?"
,"11":"Ele é forte. Mas será que podes confiar nele para fazer o teu trabalho?"
,"12":"Podes contar com ele, para recolher o teu trigo e encher a tua eira?"
,"13":"A avestruz bate alegremente as asas, como se tivesse penas e plumas de cegonha."
,"14":"Deixa os ovos no chão, para os chocar na areia,"
,"15":"sem pensar que algum pé poderá quebrá-los ou serem pisados por alguma fera."
,"16":"É cruel com os filhotes, trata-os como se não fossem seus, e não se importa com a sua inútil fadiga,"
,"17":"porque Deus a privou de sabedoria e não lhe concedeu inteligência."
,"18":"Contudo, quando se levanta batendo os flancos, ri-se do cavalo e do seu cavaleiro."
,"19":"És tu que dás força ao cavalo e revestes de crina o seu pescoço?"
,"20":"És tu que o ensinas a saltar como um gafanhoto e a relinchar com majestade e terror?"
,"21":"Cheio de força, escava o chão com a pata e lança-se ao encontro das armas."
,"22":"Ele ri-se do medo, não se assusta e não recua diante da espada."
,"23":"Sobre ele ressoa o barulho do escudo, a lança faiscante e o dardo."
,"24":"Com ímpeto e estrondo, devora a distância e não pára, mesmo que soe o clarim."
,"25":"Ao toque da trombeta, ele relincha; fareja de longe a batalha, as ordens de comando e os gritos de guerra."
,"26":"Será pela tua sabedoria que o falcão levanta voo, estendendo as asas para o Sul?"
,"27":"Acaso é sob a tua ordem que a águia levanta voo e constrói o seu ninho nas alturas?"
,"28":"Ela mora nos rochedos, e ali pernoita numa fortaleza de rocha inatingível."
,"29":"Do alto ela espia a sua presa; os seus olhos descobrem-na de longe."
,"30":"Os seus filhotes chupam o sangue, e onde há cadáveres ela lá está»."
}`)
	CurrentBook.AddChapter(40, `{
"1":"Javé continuou a dirigir-se a Job, e perguntou:"
,"2":"«O adversário vai querer continuar a discutir com o Todo-poderoso? Quem critica a Deus irá responder?»"
,"3":"Então Job respondeu a Javé:"
,"4":"«Sinto-me arrasado. Que posso eu replicar? Vou tapar a boca com a mão."
,"5":"Falei uma vez e não insistirei; falei duas vezes, e não vou acrescentar mais nada»."
,"6":"Do meio da tempestade, Javé replicou a Job:"
,"7":"«Se és homem, prepara-te: vou interrogar-te e responder-me-ás."
,"8":"Atreves-te a anular a minha justiça e a condenar-Me, para te justificares a ti mesmo?"
,"9":"Tens um braço semelhante ao braço de Deus? A tua voz troveja como a voz de Deus?"
,"10":"Então reveste-te de majestade e grandeza, e cobre-te de esplendor e glória!"
,"11":"Espalha o ardor da tua ira e, com um só olhar, rebaixa todos os orgulhosos."
,"12":"Humilha com o teu olhar o arrogante, e esmaga os injustos onde quer que se encontrem."
,"13":"Enterra-os todos juntos debaixo da terra, e amarra-os todos juntos na prisão."
,"14":"Então também Eu te louvarei, porque conseguiste a vitória com a tua própria mão direita."
,"15":"Vê o hipopótamo que Eu criei como te criei a ti. Ele alimenta-se de erva como o boi."
,"16":"A sua força está nos seus rins, e o seu vigor nos músculos do ventre."
,"17":"Ergue a cauda como um cedro e entrelaça os tendões das coxas."
,"18":"Os seus ossos são como tubos de bronze, e a sua carcaça parece feita de barras de ferro."
,"19":"Ele é a obra-prima de Deus, e só o seu Criador o pode ameaçar com a espada."
,"20":"Deus proíbe-lhe a região das montanhas, onde as feras se divertem."
,"21":"Ele deita-se debaixo do lótus, e esconde-se entre os juncos do pântano."
,"22":"Cobre-o com a sombra o lótus, e envolvem-no os salgueiros da torrente."
,"23":"Ainda que o rio transborde, ele não se assusta. Pelo contrário, fica tranquilo, mesmo que o Jordão transborde até à sua boca."
,"24":"Quem poderá agarrá-lo pela frente ou perfurar-lhe as narinas para lhes aplicar argolas?"
,"25":"És capaz de pescar o Leviatã com anzol e amarrar-lhe a língua com uma corda?"
,"26":"És capaz de lhe furar as narinas com junco e de lhe perfurar a mandíbula com gancho?"
,"27":"Será que ele viria ter contigo com muitas súplicas ou te falaria com ternura?"
,"28":"Será que faria uma aliança contigo, para fazeres dele o teu criado perpétuo?"
,"29":"Brincarás com ele como se fosse um pássaro, ou amarrá-lo-ás para as tuas filhas?"
,"30":"Será que os pescadores o negociarão, ou os negociantes o dividirão entre si?"
,"31":"Poderás crivar a sua pele com dardos ou a cabeça com arpão de pesca?"
,"32":"Experimenta colocar a mão em cima dele: lembrar-te-ás da luta, e nunca mais repetirás isso!"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Vê! Diante dele, toda a segurança é apenas ilusão, pois basta alguém vê-lo para ficar com medo."
,"2":"Ninguém é tão corajoso que o provoque. Quem poderia enfrentá-lo cara a cara?"
,"3":"Quem se atreveu a desafiá-lo, e saiu ileso? Ninguém debaixo de todo o céu."
,"4":"Não deixarei de descrever os seus membros, e a sua força incomparável."
,"5":"Quem lhe abriu a couraça e penetrou pela sua dupla armadura?"
,"6":"Quem abriu as duas portas da sua boca, rodeadas de dentes terríveis?"
,"7":"As suas costas são fileiras de escudos, estreitamente ligados;"
,"8":"são tão unidos uns com os outros, que nem o ar passa entre eles;"
,"9":"cada um é tão ligado com o outro, que ficam travados e não se podem separar."
,"10":"Os seus espirros lançam faíscas, e os seus olhos são como a cor rosa da aurora."
,"11":"Da sua boca irrompem tochas acesas e saltam centelhas de fogo."
,"12":"Das suas narinas jorra fumo, como de caldeira que ferve ao fogo."
,"13":"O seu bafo queima como brasa, e a sua boca lança chamas."
,"14":"No seu pescoço reside a força, e diante dele dança o terror."
,"15":"Os músculos do seu corpo são compactos, sólidos e imóveis."
,"16":"O seu coração é duro como rocha e sólido como pedra de moinho."
,"17":"Quando ele se ergue, os heróis tremem e fogem apavorados."
,"18":"A espada que o atinge não penetra, nem a lança, nem o dardo, nem o arpão."
,"19":"Para ele o ferro é como palha, e o bronze como madeira podre."
,"20":"A flecha não o afugenta, e as pedras da funda transformam-se em palha para ele."
,"21":"A maça é para ele como estopa, e ele zomba dos dardos que assobiam."
,"22":"O seu ventre, coberto de escamas pontiagudas, é uma grade de ferro que se arrasta sobre o lodo."
,"23":"Ele faz ferver o fundo do mar como caldeira, e a água fumegar como vasilha quente cheia de unguentos."
,"24":"Atrás de si deixa uma esteira brilhante, e a água parece cabeleira branca."
,"25":"Na terra ninguém se iguala a ele, pois foi criado para não ter medo."
,"26":"Ele confronta-se com os seres mais altivos, e é o rei das feras soberbas»."
}`)
	CurrentBook.AddChapter(42, `{
"1":"Então Job respondeu a Javé:"
,"2":"«Eu reconheço que tudo podes e que nenhum dos teus projectos fica sem realização."
,"3":"Tu disseste: 'Quem é esse que escurece os meus projectos com palavras sem sentido?' Pois bem! Eu falei, sem entender, de maravilhas que superam a minha compreensão."
,"4":"Tu disseste: 'Escuta-Me, porque vou falar. Vou interrogar-te, e responder-Me-ás'."
,"5":"Eu conhecia-Te só por ouvir. Agora, porém, os meus olhos vêem-Te."
,"6":"Por isso, eu retrato-me e arrependo-me, sobre o pó e a cinza»."
,"7":"Javé acabou de falar com Job, e dirigiu-Se a Elifaz de Temã, dizendo: «Estou irritado contra ti e os teus dois companheiros, porque não falastes correctamente de Mim como falou o meu servo Job."
,"8":"Portanto, pegai em sete bezerros e sete carneiros, e ide ter com o meu servo Job. Oferecei os animais em holocausto, e o meu servo Job intercederá por vós. Em atenção a ele, não vos tratarei como a vossa insensatez merece, porque não falastes correctamente de Mim, como falou o meu servo Job»."
,"9":"Então, Elifaz de Temã, Baldad de Suás e Sofar de Naamat fizeram o que Javé lhes tinha ordenado. E Javé atendeu às orações de Job."
,"10":"Quando Job intercedeu pelos seus companheiros, Javé mudou-lhe a sorte e duplicou-lhe todas as posses."
,"11":"Os seus irmãos e irmãs e os antigos conhecidos foram visitá-lo. Almoçaram em sua casa, consolaram-no e confortaram-no pela desgraça que Javé lhe tinha enviado. Cada um ofereceu a Job uma soma de dinheiro e um anel de ouro."
,"12":"E Javé abençoou Job, mais ainda do que antes. Ele possuía agora catorze mil ovelhas, seis mil camelos, mil juntas de bois e mil jumentas."
,"13":"Teve sete filhos e três filhas:"
,"14":"a primeira chama-se Rola, a segunda Cássia e a terceira Azeviche."
,"15":"Em toda a terra não havia mulheres mais belas do que as filhas de Job. E o seu pai deu-lhes uma parte da herança entre os seus irmãos."
,"16":"Depois disto, Job viveu ainda cento e quarenta anos, e conheceu os seus filhos, netos e bisnetos."
,"17":"Depois Job morreu, velho em idade avançada."
}`)

}
func PT_BS_LoadVSPRChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Provérbios de Salomão, filho de David e rei de Israel,"
,"2":"para conhecer a sabedoria e a disciplina; para entender as sentenças profundas;"
,"3":"para adquirir disciplina e sensatez, justiça, direito e rectidão;"
,"4":"para ensinar sagacidade aos ingénuos, conhecimento e reflexão aos jovens."
,"5":"Que o sábio escute e assim aumentará o seu saber, habilidade,"
,"6":"para entender provérbios e metáforas, as sentenças dos sábios e seus enigmas."
,"7":"O temor de Javé é o princípio do saber, porém os insensatos desprezam a sabedoria e a disciplina."
,"8":"Meu filho, escuta a disciplina de teu pai, e não desprezes o ensinamento de tua mãe,"
,"9":"porque serão para ti uma coroa formosa na cabeça e um colar ao pescoço."
,"10":"Meu filho, se os pecadores te quiserem enganar, não te deixes arrastar."
,"11":"Eles costumam dizer: «Vem connosco, vamos fazer emboscadas para matar, vamos cercar impunemente o inocente;"
,"12":"nós os engoliremos vivos como faz a morte, inteiros, como aqueles que baixam à cova."
,"13":"Conseguiremos toda a espécie de riquezas e encheremos a nossa casa com as coisas roubadas."
,"14":"Participa do nosso grupo e faremos uma caixa comum»."
,"15":"Meu filho, não andes com essa espécie de gente, nem ponhas os pés nos seus caminhos,"
,"16":"porque os seus pés correm para o mal, e apressam-se para derramar sangue."
,"17":"Não adianta colocar armadilhas, quando o passarinho está a olhar."
,"18":"No fundo, as suas armadilhas serão mortais para eles próprios pois estão atentando contra si mesmos."
,"19":"Tal é o destino do ganancioso: a cobiça acaba com o cobiçoso."
,"20":"A Sabedoria grita pelas ruas e levanta a voz nas praças."
,"21":"Ela grita no burburinho da cidade e anuncia nas praças públicas:"
,"22":"«Até quando, ó ingénuos, amareis a ingenuidade? E vós, zombadores, até quando vos empenhareis na zombaria? E vós, insensatos, até quando odiareis o conhecimento?"
,"23":"Voltai-vos para ouvir o meu aviso: Eu vou derramar o meu espírito sobre vós, e comunicar-vos as minhas palavras."
,"24":"Contudo, eu chamei, e vós recusastes; estendi a mão, e ninguém prestou atenção."
,"25":"Recusastes os meus conselhos e não aceitastes o meu aviso."
,"26":"Por isso, eu também vou rir da vossa desgraça. Vou zombar, quando o terror vos assaltar."
,"27":"Quando o terror cair sobre vós como tempestade, a desgraça chegar como furacão, e a angústia e aflição vos alcançar,"
,"28":"então chamar-me-eis, mas eu não responderei. Ireis procurar-me, mas não me encontrareis."
,"29":"Recusastes o conhecimento e não escolhestes o temor de Javé."
,"30":"Não aceitastes o meu conselho e desprezastes o meu aviso."
,"31":"Pois bem! Comereis o fruto do vosso comportamento e ficareis fartos dos vossos conselhos."
,"32":"Sim, a revolta dos ingénuos acabará por levá-los à morte, e a despreocupação acabará com os insensatos."
,"33":"Todavia, quem me obedece viverá tranquilo. Estará seguro, e não temerá nenhum mal»."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Meu filho, se aceitares as minhas palavras e conservares os meus preceitos,"
,"2":"dando ouvidos à sabedoria e inclinando o coração para o entendimento;"
,"3":"se invocares a inteligência e chamares o entendimento;"
,"4":"se procurares a sabedoria como se procura o dinheiro e a buscares como um tesouro escondido,"
,"5":"então entenderás o temor de Javé e alcançarás o conhecimento de Deus."
,"6":"De facto, é Javé quem dá a sabedoria, e da sua boca vêm o conhecimento e o entendimento."
,"7":"Ele reserva a sensatez para os rectos. Ele é escudo para os que se comportam com integridade."
,"8":"Ele vigia as estradas do direito, e guarda o caminho dos seus fiéis."
,"9":"Então entenderás a justiça e o direito, a rectidão e todos os caminhos da felicidade."
,"10":"Porque a sabedoria penetrará no teu coração, e terás gosto no conhecimento."
,"11":"A reflexão guardar-te-á, e o entendimento proteger-te-á,"
,"12":"para te livrar do mau caminho e do homem que fala com perversidade;"
,"13":"dos que abandonam a estrada recta para seguir caminhos tenebrosos;"
,"14":"dos que se alegram com a prática do mal e se satisfazem com a perversidade;"
,"15":"dos que seguem veredas tortuosas e caminhos desviados."
,"16":"A sabedoria livrar-te-á da mulher estrangeira, a forasteira que seduz com palavras,"
,"17":"que abandonou o companheiro da sua juventude e esqueceu a aliança do seu Deus."
,"18":"A casa dela conduz à morte, os seus caminhos levam para o reino das sombras."
,"19":"Os que lá entram nunca mais voltam e não encontram as veredas da vida."
,"20":"Por isso, seguirás o caminho dos bons e observarás as veredas dos justos,"
,"21":"porque os rectos habitarão a Terra e os íntegros permanecerão nela."
,"22":"Os injustos, porém, serão expulsos da Terra, e os infiéis serão dela arrancados."
}`)
	CurrentBook.AddChapter(3, `{
"1":"Meu filho, não esqueças a minha instrução. Conserva na memória os meus preceitos,"
,"2":"porque eles te trarão longos dias e muitos anos, e também vida e prosperidade."
,"3":"Que o amor e a fidelidade não te abandonem. Amarra-os ao redor do teu pescoço e escreve-os na tábua do teu coração."
,"4":"Assim alcançarás favor e aceitação diante de Deus e dos homens."
,"5":"Confia em Javé com todo o teu coração, e não te fies na tua própria inteligência."
,"6":"Pensa n'Ele em todos os teus caminhos, e Ele aplainará as tuas veredas."
,"7":"Não te consideres sábio: teme a Javé e evita o mal."
,"8":"Isto trará saúde ao teu corpo e alívio aos teus ossos."
,"9":"Honra a Javé com as tuas riquezas e com os primeiros frutos de todas as tuas colheitas."
,"10":"Deste modo, os teus celeiros estarão cheios de trigo, e os teus tonéis transbordarão de vinho novo."
,"11":"Meu filho, não desprezes a correcção de Javé, nem te canses com as suas repreensões,"
,"12":"porque Javé corrige aqueles que ama, como o pai corrige o filho preferido."
,"13":"Feliz o homem que encontrou a sabedoria e alcançou o entendimento,"
,"14":"porque a sabedoria vale mais do que a prata, e dá mais lucro que o ouro."
,"15":"É mais valiosa do que as pérolas e não existe objecto precioso que se iguale a ela."
,"16":"Na mão direita ela tem vida longa, e na sua esquerda, riqueza e honra."
,"17":"Os seus caminhos são deliciosos e as suas veredas conduzem ao bem-estar."
,"18":"Ela é árvore de vida para os que a adquirem e são felizes aqueles que a conservam."
,"19":"Javé alicerçou a Terra com sabedoria, e firmou o céu com entendimento."
,"20":"Com o saber que ela tem, são abertos os abismos e as nuvens destilam o orvalho."
,"21":"Meu filho, não percas de vista a sensatez, conserva a reflexão:"
,"22":"elas serão vida para ti e enfeite para o teu pescoço."
,"23":"Seguirás tranquilo o teu caminho, e os teus pés não tropeçarão."
,"24":"Descansarás sem medo; e quando te deitares, o teu sono será tranquilo."
,"25":"Não te assustarás com o terror imprevisto, nem com a desgraça que cai sobre os injustos."
,"26":"Porque Javé ficará a teu lado e impedirá que o teu pé caia na armadilha."
,"27":"Se te for possível, não negues um favor a quem precisa."
,"28":"Não digas ao teu próximo: «Vai-te embora. Volta depois, que eu te darei amanhã», quando lhe podes dar imediatamente."
,"29":"Não planeies o mal contra o teu vizinho, pois ele mora ao teu lado e confia em ti."
,"30":"Não litigues sem motivo contra ninguém, se a pessoa não te fez nada de mal."
,"31":"Não tenhas inveja do homem violento, e não imites o seu comportamento,"
,"32":"porque Javé detesta o perverso, mas é amigo dos justos."
,"33":"Javé amaldiçoa a casa do injusto, mas abençoa a morada dos justos."
,"34":"Ele zomba dos zombadores, mas favorece os pobres."
,"35":"Os sábios possuirão a hon-ra, porém os insensatos receberão a igno-mínia."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Filhos, obedecei à disciplina paterna, e estai atentos para adquirir a inteligência."
,"2":"Eu dou-vos uma boa doutrina; não abandoneis a minha instrução."
,"3":"Eu também fui filho de meu pai e amado ternamente por minha mãe."
,"4":"Ele instruiu-me assim: «Conserva os meus conselhos na tua mente, observa os meus preceitos, e viverás."
,"5":"Adquire a sabedoria, adquire a inteligência e não te esqueças delas, nem te afastes dos meus conselhos."
,"6":"Não abandones a sabedoria, e ela guardar-te-á. Ama a sabedoria, e ela proteger-te-á."
,"7":"O princípio da sabedoria é adquirir a sabedoria. Adquire a inteligência usando tudo o que possuis."
,"8":"Conquista a sabedoria, e ela exaltar-te-á. Abraça-a, e ela honrar-te-á."
,"9":"Ela colocará na tua cabeça um belo diadema, e cingir-te-á com uma brilhante coroa»."
,"10":"Meu filho, escuta e recebe os meus conselhos, e eles multiplicarão os anos da tua vida."
,"11":"Vou mostrar-te o caminho da sabedoria e guiar-te pelas veredas da rectidão."
,"12":"Ao caminhares, os teus passos não serão dificultados e, ao correres, não tropeçarás."
,"13":"Agarra-te à disciplina, e não a deixes; pratica a disciplina, porque ela é a tua vida."
,"14":"Não andes pelas veredas dos injustos, nem vás pelo caminho dos maus."
,"15":"Evita esse caminho, e não passes por ele. Afasta-te dele, e segue em frente."
,"16":"Os injustos não dormem sem ter feito o mal; perdem o sono, enquanto não fazem alguém tropeçar."
,"17":"Comem a maldade como pão e bebem a violência como vinho."
,"18":"Mas a vereda dos justos brilha como a aurora, e vai clareando até nascer o dia."
,"19":"O caminho dos injustos é tenebroso, e eles não sabem onde irão tropeçar."
,"20":"Meu filho, está atento às minhas palavras e dá ouvidos aos meus conselhos."
,"21":"Nunca os percas de vista e guarda-os no teu coração."
,"22":"Pois eles são vida para quem os encontra e saúde para o teu corpo."
,"23":"Acima de tudo, guarda o teu coração, porque dele brota a vida."
,"24":"Preserva a tua boca da maledicência e afasta de ti a falsidade dos lábios falsos."
,"25":"Que os teus olhos olhem em frente e o teu olhar se dirija para diante."
,"26":"Fica atento ao caminho onde pões os pés, e que todos os teus caminhos sejam firmes."
,"27":"Não te desvies nem para a direita, nem para a esquerda, e afasta do mal os teus passos."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Meu filho, presta atenção à minha experiência, dá ouvidos ao meu entendimento."
,"2":"Assim conservarás a reflexão, e os teus lábios guardarão o conhecimento."
,"3":"Os lábios da estrangeira destilam mel e as suas palavras são mais suaves do que o azeite."
,"4":"No final, porém, ela é amarga como o fel e afiada como a espada de dois gumes."
,"5":"Os seus pés levam à morte, e os seus passos conduzem ao túmulo."
,"6":"Ela não segue o caminho da vida, e os seus passos extraviam-se sem que ela se aperceba."
,"7":"Portanto, meu filho, escuta-me, e não te afastes dos meus conselhos."
,"8":"Afasta-te do caminho da estrangeira, e não te aproximes da porta da sua casa."
,"9":"Não dês a estranhos a tua honra, nem os teus anos a gente cruel."
,"10":"Que os estranhos não se fartem com o teu vigor, e a casa do desconhecido com os teus suores."
,"11":"Caso contrário, vais lamentar a tua sorte, quando a carne do teu corpo se consumir."
,"12":"Então dirás: «Porque desprezei a disciplina e rejeitei a correcção?"
,"13":"Não dei atenção aos meus mestres, nem dei ouvidos aos meus educadores."
,"14":"Por pouco não cheguei ao cúmulo da desgraça no meio da comunidade e da assembleia»."
,"15":"Bebe a água da tua cisterna, a água que jorra do teu poço."
,"16":"Não derrames pela rua a água da tua fonte, nem pelas praças a água dos teus riachos."
,"17":"Sejam só para ti, sem as repartires com estrangeiros."
,"18":"Seja bendita a tua fonte, alegra-te com a esposa da tua juventude:"
,"19":"ela é uma corça querida, uma gazela formosa. Que as suas carícias te embriaguem sempre, e o seu amor te satisfaça continuamente."
,"20":"Meu filho, porque te deleitas com mulher estranha e abraças o peito de uma estrangeira?"
,"21":"Os olhos de Javé observam os caminhos do homem e vigiam-lhe todas as veredas."
,"22":"O injusto fica preso nas suas próprias culpas e é apanhado na armadilha do seu pecado;"
,"23":"ele morre por falta de correcção, e perece por causa da sua grande insensatez."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Meu filho, se foste fiador do teu próximo, e fizeste acordo com algum estrangeiro;"
,"2":"se te comprometeste, dando a tua palavra, e ficaste preso pelo que disseste,"
,"3":"caíste em poder do teu próximo. Para te livrares, faz o seguinte, meu filho:"
,"4":"Vai, insiste e incomoda o teu próximo. Não durmas, nem descanses."
,"5":"Liberta-te, como a gazela da armadilha ou o passarinho da aboiz."
,"6":"Vamos, preguiçoso, vê a formiga, observa os seus hábitos, e aprende."
,"7":"Ela não tem chefe, nem guia, nem governante."
,"8":"Apesar disso, no Verão ela acumula o grão e ajunta provisões durante a colheita."
,"9":"Até quando vais ficar a dormir, preguiçoso? Quando é que te vais levantar da cama?"
,"10":"Dormindo um pouco, dormitando outro pouco e mais um pouco ainda, cruzando os braços e descansando,"
,"11":"sobre ti cairá a pobreza do vagabundo e a indigência do mendigo."
,"12":"O homem falso e malfeitor emprega palavras enganadoras,"
,"13":"pisca o olho, balança os pés e faz sinal com os dedos;"
,"14":"pensa em desatinos, planeia maldades e está sempre a semear discórdia."
,"15":"Mas, de repente, virá sobre ele a perdição e, num instante, ficará arruinado sem remédio."
,"16":"Seis são as coisas que Javé detesta e sete as que Ele abomina:"
,"17":"olhos altivos, língua mentirosa, mãos que derramam sangue inocente,"
,"18":"coração que maquina planos perversos, pés que correm para a maldade,"
,"19":"testemunha falsa que profere mentiras, e aquele que semeia discórdia entre irmãos."
,"20":"Meu filho, guarda os preceitos de teu pai e não desprezes o ensinamento de tua mãe."
,"21":"Conserva-os sempre vivos na memória e prende-os ao pescoço."
,"22":"Deste modo, quando caminhares, eles te guiarão; quando descansares, eles te guardarão; e, quando acordares, eles falarão contigo."
,"23":"Porque o preceito é uma lâmpada, a instrução é uma luz e a repreensão que corrige é caminho de vida."
,"24":"Eles proteger-te-ão da mulher má e da língua suave da estrangeira."
,"25":"Que o teu coração não cobice a sua beleza, nem se deixe prender pelos seus olhares."
,"26":"A prostituta rouba um pedaço de pão, mas a mulher adúltera apodera-se de uma vida."
,"27":"Pode alguém levar fogo no peito sem queimar a própria roupa?"
,"28":"Pode alguém caminhar em cima de brasas sem queimar os pés?"
,"29":"O mesmo acontece com aquele que procura a mulher do próximo: quem lhe toca, não ficará sem castigo."
,"30":"O ladrão não fica difamado quando rouba para matar a fome;"
,"31":"se o prendem, ele deverá devolver sete vezes mais e entregar todos os bens da sua casa."
,"32":"Mas o adúltero não tem bom senso: só age assim quem se quer arruinar."
,"33":"Levará uma sova, passará vergonha, e a sua infâmia nunca desaparecerá."
,"34":"Porque o ciúme provocará a raiva do marido, que não terá piedade no dia da vingança:"
,"35":"de nenhum modo aceitará compensação, e recusará pagamento, mesmo que seja grande."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Meu filho, conserva as minhas palavras e guarda os meus preceitos."
,"2":"Observa os meus preceitos, e terás a vida. Guarda a minha instrução como a pupila dos teus olhos."
,"3":"Amarra-a nos dedos e escreve-a na tábua do coração."
,"4":"Diz à sabedoria: «Tu és minha irmã». Trata a inteligência como amiga,"
,"5":"para que ela te proteja da mulher estrangeira, e da estranha que seduz com a palavra."
,"6":"Eu estava à janela da minha casa e olhava por entre as grades."
,"7":"Vi alguns jovens ingénuos, e notei que um deles não tinha juízo."
,"8":"Ele passava pela rua, perto da esquina, e dirigia-se para a casa da estrangeira."
,"9":"Já caía a noite de lua nova."
,"10":"Uma mulher foi ao encontro dele, vestida como prostituta e cheia de malícia."
,"11":"Era ousada e insolente, e seus pés não paravam em casa:"
,"12":"ora estava na rua, ora na praça, espreitando em cada esquina."
,"13":"Então ela agarrou e beijou o rapaz. Depois falou-lhe descaradamente:"
,"14":"«Preparei um sacrifício de comunhão, porque hoje estou a cumprir uma promessa."
,"15":"Por isso saí para te encontrar. Estava ansiosa por te ver e acabei por te encontrar."
,"16":"Cobri a minha cama com colchas e coloquei nela lençóis do Egipto."
,"17":"Perfumei o quarto com mirra, aloés e cinamomo."
,"18":"Vem, vamos embriagar-nos com carícias até de manhã. Vamos saciar-nos com amores,"
,"19":"porque o meu marido partiu para uma longa viagem e não está em casa."
,"20":"Ele levou a bolsa com dinheiro, e não voltará até à lua cheia»."
,"21":"Com muitas palavras ela foi-o seduzindo e arrastou-o com lábios enganadores."
,"22":"O infeliz correu atrás dela, como boi para o matadouro, como animal preso no laço,"
,"23":"até uma flecha o atingir no lado. Foi como pássaro que voa para a armadilha, sem saber que vai perder a vida."
,"24":"Agora, meu filho, escuta. Presta atenção ao que vou dizer."
,"25":"Que o teu coração não se extravie para o caminho da estrangeira e que não te percas nas suas veredas."
,"26":"Ela já assassinou muita gente, e as suas vítimas foram numerosas."
,"27":"A sua casa é um caminho para o túmulo, uma descida para o reino da morte."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Ouvi: a Sabedoria não chama, e o Entendimento não faz ouvir a sua voz?"
,"2":"Nas elevações, ao longo do caminho, nas encruzilhadas das estradas,"
,"3":"junto às portas à entrada da cidade e nos portões de saída, ela apresenta-se, exclamando:"
,"4":"«Homens, eu dirijo-me a vós, dirijo-me aos filhos de Adão,"
,"5":"para que os ingénuos aprendam a sagacidade, e os insensatos adquiram bom senso."
,"6":"Escutai bem, porque vou dizer coisas importantes, e dos meus lábios vão sair palavras justas."
,"7":"A minha boca vai proclamar a verdade, e os meus lábios aborrecem a injustiça."
,"8":"Todas as palavras da minha boca são justas. Nenhuma delas é enganadora ou falsa."
,"9":"São verdadeiras para quem sabe discernir, e rectas para quem possui o conhecimento."
,"10":"Aceitai a minha disciplina mais que o dinheiro; preferi o conhecimento ao ouro fino,"
,"11":"porque a Sabedoria vale mais do que as pérolas, e nenhuma jóia se lhe pode comparar»."
,"12":"Eu, a Sabedoria, sou vizinha da sagacidade, e tenho o conhecimento e a reflexão."
,"13":"Temer a Javé é odiar o mal. Por isso, eu detesto o orgulho e a soberba, o mau comportamento e a boca falsa."
,"14":"Eu possuo o conselho e o bom senso; a inteligência e a fortaleza me pertencem."
,"15":"É através de mim que os reis governam e os príncipes decretam leis justas."
,"16":"Através de mim, os chefes governam e os nobres dão sentenças justas."
,"17":"Eu amo os que me amam, e os que me procuram encontrar-me-ão."
,"18":"Comigo estão a riqueza e a honra, a prosperidade e a justiça."
,"19":"O meu fruto vale mais do que ouro puro, e o meu lucro vale mais do que prata de lei."
,"20":"Eu caminho pelas veredas da justiça, e ando pelas sendas do direito,"
,"21":"para levar riquezas aos que me amam e encher os seus cofres."
,"22":"Javé criou-me como primeiro fruto da sua obra, no começo dos seus feitos mais antigos."
,"23":"Fui estabelecida desde a eternidade, desde o princípio, antes que a Terra começasse a existir."
,"24":"Fui gerada quando o oceano ainda não existia, e antes que existissem as fontes de água."
,"25":"Fui gerada antes que as montanhas e colinas fossem implantadas,"
,"26":"quando Javé ainda não tinha feito a terra e a erva, nem os primeiros elementos do mundo."
,"27":"Quando Ele fixava o céu e colocava a abóbada sobre o oceano, eu lá estava."
,"28":"Eu estava presente quando Ele condensava as nuvens no alto e fixava as fontes do oceano;"
,"29":"quando fixava um limite ao mar, de modo que as águas não ultrapassassem a praia; e também quando assentava os fundamentos da Terra."
,"30":"Eu estava com Ele, como mestre-de-obras. Eu era o seu encanto todos os dias, e brincava o tempo todo na sua presença;"
,"31":"brincava na superfície da Terra, e deliciava-me com a humanidade."
,"32":"Portanto, meus filhos, escutai-me: Felizes os que seguem os meus caminhos."
,"33":"Obedecei às minhas instruções e tornar-vos-eis sábios. Não as desprezeis."
,"34":"Feliz o homem que me obedece, vigiando todos os dias à minha porta, esperando à entrada da minha casa."
,"35":"Quem me encontra, encontra a vida, e goza do favor de Javé."
,"36":"Quem me perde, arruína-se a si mesmo, pois todos os que me odeiam amam a morte."
}`)
	CurrentBook.AddChapter(9, `{
"1":"A Sabedoria construiu a sua casa, talhando as suas sete colunas."
,"2":"Abateu os seus animais, preparou o vinho e pôs a mesa."
,"3":"Enviou as suas criadas para que anunciassem nos pontos mais altos da cidade:"
,"4":"«Os ingénuos venham até aqui. Quero falar aos que não têm juízo."
,"5":"Vinde comer do meu pão e beber do vinho que preparei para vós."
,"6":"Deixai de ser ingénuos, e vivereis; andai pelos caminhos da inteligência»."
,"7":"Quem corrige o zombador, atrai o seu desprezo; e quem repreende o injusto, atrai o insulto."
,"8":"Não repreendas o zombador, porque ele te odiará. Repreende o sábio, pois ele te agradecerá."
,"9":"Dá um conselho ao sábio, e ele tornar-se-á mais sábio ainda. Dá instrução ao justo, e ele aprenderá ainda mais."
,"10":"O princípio da sabedoria é o temor de Javé, e conhecer o Santo é inteligência."
,"11":"Por meio de mim, prolongarás os teus dias, e terás mais anos de vida."
,"12":"Se fores sensato, a vantagem será tua; se fores zombador, o azar será teu."
,"13":"A senhora Insensatez é irrequieta, é uma ingénua que não conhece nada."
,"14":"Ela fica sentada à porta de casa, num banco de onde domina a cidade."
,"15":"Daí, ela chama os que passam e seguem o seu caminho:"
,"16":"«Ó ingénuos, vinde cá. Quero falar aos que não têm juízo."
,"17":"A água roubada é mais doce, e o pão comido às escondidas é mais saboroso»."
,"18":"Eles não sabem que na casa dela estão os mortos, e que os seus convidados vão para o reino dos mortos."
}`)
	CurrentBook.AddChapter(10, `{
"1":"Provérbios de Salomão. O filho sábio alegra o pai; o filho insensato entristece a mãe."
,"2":"Tesouros mal adquiridos não trazem proveito, mas a justiça livra da morte."
,"3":"Javé não deixa que o justo passe fome, porém reprime a ambição dos injustos."
,"4":"A mão preguiçosa empobrece, mas o braço trabalhador enriquece."
,"5":"Quem armazena no Outono é prudente; quem dorme no tempo da colheita cobre-se de vergonha."
,"6":"As bênçãos descem sobre a cabeça do justo, mas a boca dos injustos esconde violência."
,"7":"A memória do justo é bendita, mas o nome dos injustos apodrece."
,"8":"O homem de bom senso aceita os mandamentos, mas o estúpido arruína-se pela boca."
,"9":"Quem se comporta com integridade vive em segurança; quem segue caminhos tortuosos acaba por ser desmascarado."
,"10":"Quem faz vista grossa causa dor; quem repreende abertamente, cura."
,"11":"A boca do justo é fonte de vida, mas a boca dos injustos esconde violência."
,"12":"O ódio provoca rixas, mas o amor cobre todas as ofensas."
,"13":"Na boca da pessoa prudente existe sabedoria, e a vara é para as costas do insensato."
,"14":"Os sábios entesouram o conhecimento, mas a boca do tolo é perigo iminente."
,"15":"A fortaleza do rico é a sua fortuna, mas a ruína dos fracos é a sua pobreza."
,"16":"O salário do justo conduz à vida, mas o ganho do injusto leva ao pecado."
,"17":"Quem aceita a disciplina caminha para a vida; quem despreza a correcção extravia-se."
,"18":"A boca sincera aplaca o ódio, mas quem espalha a calúnia é insensato."
,"19":"Quem muito fala acaba por ofender; a pessoa prudente põe freio na boca."
,"20":"A boca do justo é prata de lei; a mente dos injustos não vale nada."
,"21":"A boca do justo alimenta muita gente, mas os estultos morrem por falta de juízo."
,"22":"A bênção de Javé faz prosperar, e a nossa fadiga nada lhe acrescenta."
,"23":"O insensato diverte-se fazendo o mal; o inteligente diverte-se com a sabedoria."
,"24":"Ao injusto acontece-lhe o que ele teme; aos justos é dado o que eles desejam."
,"25":"Quando vem o furacão, o injusto desaparece; mas o justo permanece firme para sempre."
,"26":"Como vinagre nos dentes e fumo nos olhos, é o preguiçoso para quem o envia."
,"27":"O temor de Javé prolonga os dias, porém os anos dos injustos serão abreviados."
,"28":"A esperança dos justos acaba em alegria, mas a esperança dos injustos termina em fracasso."
,"29":"O caminho de Javé é refúgio para o íntegro, mas para os malfeitores é terror."
,"30":"O justo nunca vacilará, mas os injustos não habitarão na terra."
,"31":"A boca do justo diz coisas sábias, mas a língua perversa será cortada."
,"32":"As palavras do justo destilam bondade; a boca dos injustos destila perversidade."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Javé detesta balanças falsas e gosta de peso justo."
,"2":"Depois da soberba vem a desonra, mas a sabedoria está com os humildes."
,"3":"A integridade guia os rectos, mas a perversidade arruína os traidores."
,"4":"A riqueza é inútil no dia da ira, mas a justiça liberta da morte."
,"5":"A justiça aplana o caminho dos íntegros, mas o injusto cai pela sua injustiça."
,"6":"A justiça salva os rectos, mas os traidores são apanhados na própria cobiça."
,"7":"Quando o injusto morre, a sua esperança desaparece; e a esperança nas riquezas também desaparece."
,"8":"O justo escapa à angústia; o injusto cai nela, em lugar dele."
,"9":"O injusto arruína o próximo com a boca, mas os justos salvam-se pelo conhecimento que possuem."
,"10":"A cidade festeja o triunfo dos justos, e canta de alegria quando os injustos perecem."
,"11":"A cidade prospera com a bênção dos justos, mas destrói-se pela boca dos injustos."
,"12":"Quem despreza o próximo não tem bom senso; o homem prudente guarda silêncio."
,"13":"Quem fala de mais espalha segredos; o homem de confiança mantém a discrição."
,"14":"Sem governo, o povo arruína-se; e salva-se com muitos conselheiros."
,"15":"Quem serve de fiador a um estrangeiro acaba por se prejudicar; quem evita compromissos permanece tranquilo."
,"16":"A mulher formosa adquire honra; os violentos adquirem riqueza."
,"17":"O homem bondoso faz bem a si mesmo; o homem cruel destrói-se a si próprio."
,"18":"O injusto conquista lucros enganosos; quem semeia justiça tem salário seguro."
,"19":"Quem pratica a justiça busca a vida; quem segue o mal caminha para a morte."
,"20":"Javé detesta a mente tortuosa, mas aprecia o comportamento íntegro."
,"21":"Cedo ou tarde, o mau será punido, mas a descendência dos justos será salva."
,"22":"Anel de ouro em focinho de porco é a mulher bonita mas sem bom senso."
,"23":"O desejo dos justos realiza-se; as ilusões dos injustos não levam a nada."
,"24":"Quem dá generosamente, a sua riqueza aumenta ainda mais; quem acumula injustamente, acaba na miséria."
,"25":"Quem é generoso progride na vida, e quem dá de beber jamais passará sede."
,"26":"O povo amaldiçoa quem esconde alimentos, e abençoa quem os põe no mercado."
,"27":"Quem madruga para o bem alcançará favor, mas quem busca o mal será vítima do mal."
,"28":"Quem confia na própria riqueza murchará, mas os justos brotarão como a folhagem."
,"29":"Quem cria desordem em casa terá vento como herança; e quem não tem juízo será escravo de quem é sábio."
,"30":"O fruto do justo é árvore de vida, e o sábio cativa as pessoas."
,"31":"Se até o justo recebe a sua recompensa aqui na Terra, quanto mais o injusto e o pecador!"
}`)
	CurrentBook.AddChapter(12, `{
"1":"Quem ama a correcção ama o saber; quem detesta a correcção torna-se imbecil."
,"2":"Javé favorece o homem bom, mas condena o astuto."
,"3":"Ninguém se firma pela injustiça, mas a raiz dos justos não será abalada."
,"4":"Mulher forte é coroa para o seu marido; mulher de má fama é cárie nos ossos."
,"5":"Os projectos dos justos são rectos; as tácticas dos injustos são traiçoeiras."
,"6":"Os conselhos dos injustos são armadilhas mortais, mas a boca dos rectos salva do perigo."
,"7":"Os injustos são derrubados e desaparecem, mas a família dos justos permanece firme."
,"8":"O homem de bom senso é elogiado, mas o homem de coração perverso é desprezado."
,"9":"É melhor ser modesto e ter um só empregado, do que fazer de rico e passar fome."
,"10":"O justo sabe cuidar de tudo o que os animais precisam, mas os injustos não são capazes de se compadecer."
,"11":"Quem cultiva o seu campo ficará saciado de pão; quem corre atrás de ilusões não tem bom senso."
,"12":"A cobiça do injusto é uma rede de males, mas a raiz dos justos prospera."
,"13":"O mau fica preso na falsidade da própria boca, mas o justo livrar-se-á da aflição."
,"14":"Cada um satisfaz-se com aquilo que diz, mas receberá conforme aquilo que faz."
,"15":"O tolo fica satisfeito com a sua conduta, mas o sábio obedece aos conselhos."
,"16":"O tolo mostra logo a sua raiva, mas a pessoa esperta disfarça a ofensa."
,"17":"Quem diz a verdade proclama a justiça; a testemunha falsa proclama a mentira."
,"18":"Há quem use a língua como espada, mas a língua dos sábios cura as feridas."
,"19":"A língua sincera permanece para sempre, mas a língua mentirosa dura apenas um instante."
,"20":"A mente de quem planeia o mal é amarga; e quem aconselha a paz vive tranquilo."
,"21":"Ao justo nada de mal acontece, mas os injustos vivem cheios de desgraças."
,"22":"Javé detesta a boca mentirosa, mas o homem sincero conquista o seu favor."
,"23":"O homem esperto esconde o seu conhecimento, mas a mente dos insensatos proclama a sua própria estupidez."
,"24":"Mão trabalhadora mandará; mão preguiçosa servirá."
,"25":"A angústia deprime o coração, mas a boa palavra reanima."
,"26":"O justo mostra o caminho ao seu próximo, mas o caminho dos injustos faz que eles próprios se extraviem."
,"27":"O preguiçoso não ganha o seu sustento, mas o trabalhador torna-se rico."
,"28":"A vida encontra-se no caminho da justiça; o caminho da injustiça conduz à morte."
}`)
	CurrentBook.AddChapter(13, `{
"1":"O filho sensato aceita a correcção do pai; o filho insolente não escuta a repreensão."
,"2":"O homem alimenta-se com aquilo que diz, mas o ventre dos injustos alimenta-se de violência."
,"3":"Quem vigia a própria boca conserva a vida; quem solta a língua caminha para a ruína."
,"4":"O preguiçoso muito quer e nada tem, mas o trabalhador satisfaz o apetite."
,"5":"O justo detesta a mentira, mas o injusto calunia e difama."
,"6":"A justiça guarda o homem íntegro, mas o pecado arruína o injusto."
,"7":"Muitos fingem ser ricos e nada têm; outros parecem pobres e possuem muitos bens."
,"8":"O rico paga resgate pela sua vida, mas o pobre não sofre ameaças."
,"9":"A luz dos justos brilha, mas a lâmpada dos injustos apaga-se."
,"10":"A insolência só provoca brigas, mas a sabedoria acompanha os que se deixam aconselhar."
,"11":"Riqueza conseguida de repente, depressa desaparece; quem ajunta pouco a pouco, enriquece."
,"12":"Esperança que tarda deixa doente o coração; desejo que se realiza é árvore de vida."
,"13":"Quem despreza o conselho arruinar-se-á; quem respeita os mandamentos será salvo."
,"14":"O conselho do sábio é fonte de vida, para evitar os laços da morte."
,"15":"Bom senso alcança favor, mas o caminho dos traidores conduz à ruína."
,"16":"O homem esperto age com conhecimento de causa, mas o insensato manifesta a sua estupidez."
,"17":"O mau mensageiro provoca desgraça, mas o mensageiro fiel traz a cura."
,"18":"Miséria e vergonha para quem rejeita a correcção; honra para quem observa a repreensão."
,"19":"Desejo satisfeito é doçura para a alma, mas os insensatos detestam afastar-se do mal."
,"20":"Quem anda com os sábios torna-se sábio; quem se junta com os insensatos torna-se mau como eles."
,"21":"A desgraça persegue os pecadores; a paz e o bem são a recompensa dos justos."
,"22":"A herança do bom permanece na sua família, mas a riqueza do pecador está reservada para o justo."
,"23":"A lavoura do pobre dá rico sustento, mas pode perder-se por falta de justiça."
,"24":"Quem poupa a vara, odeia o seu filho; mas aquele que o ama aplica-lhe a correcção."
,"25":"O justo come e sacia-se, mas o ventre dos injustos passa necessidade."
}`)
	CurrentBook.AddChapter(14, `{
"1":"A mulher sábia constrói o seu lar; a insensata destrói-o com as próprias mãos."
,"2":"Quem se comporta correctamente teme a Javé; quem perverte a própria conduta despreza-O."
,"3":"Da boca do tolo brota a soberba; mas a boca dos sábios protege-os."
,"4":"Onde não há bois falta cereal, mas a força do touro traz grande colheita."
,"5":"A testemunha verdadeira não mente; a testemunha falsa respira mentiras."
,"6":"O zombador busca a sabedoria e não a encontra, mas o conhecimento é fácil para o inteligente."
,"7":"Deixa a companhia do homem insensato, porque junto dele não acharás conhecimento."
,"8":"A sabedoria do homem sagaz é discernir o seu próprio caminho, mas a estupidez do insensato é loucura."
,"9":"Os insensatos zombam da culpa, mas os homens rectos alcançam favor."
,"10":"O coração conhece a sua própria amargura, e o estranho não participa da sua alegria."
,"11":"A casa dos injustos arruína-se, mas a tenda dos homens rectos prospera."
,"12":"Às vezes um caminho parece recto para alguém, mas acaba por conduzir à morte."
,"13":"Mesmo entre risos o coração pode chorar, e a alegria terminar em tristeza."
,"14":"O extraviado ficará farto com a sua conduta, o homem bom saciar-se-á com as próprias obras."
,"15":"O ingénuo acredita em tudo o que lhe dizem, mas o homem esperto vê onde põe os pés."
,"16":"O sábio é precavido e afasta-se do mal; o insensato segue em frente sem pensar."
,"17":"O homem colérico comete estupidez, e o homem intrigante torna-se odiado."
,"18":"Os ingénuos enfeitam-se com estupidez, mas os espertos coroam-se de conhecimento."
,"19":"Os maus inclinar-se-ão diante dos bons, e os injustos diante da porta do justo."
,"20":"O pobre é desprezado até mesmo pelos parentes, mas o rico tem muitos amigos."
,"21":"Quem despreza o seu próximo fracassa, mas quem tem compaixão do pobre é feliz."
,"22":"Quem planeia o mal acaba por se extraviar, mas os que realizam o bem gozam de amor e fidelidade."
,"23":"Todo o trabalho traz o seu proveito, mas o muito falar só produz miséria."
,"24":"Os sábios são coroados de riquezas, e os insensatos, de estupidez."
,"25":"A testemunha verdadeira salva as vidas, mas quem diz mentiras é impostor."
,"26":"A confiança do forte é temer a Javé, que é um refúgio para os seus filhos."
,"27":"O temor de Javé é fonte de vida, para evitar os laços da morte."
,"28":"Povo numeroso é honra para o rei, mas a falta de gente é ruína para o príncipe."
,"29":"O homem paciente é cheio de inteligência, mas o impulsivo exalta a sua própria ignorância."
,"30":"Coração tranquilo é vida para o corpo, mas a inveja é cárie nos ossos."
,"31":"Quem oprime o fraco ofende a Deus, mas quem se compadece do indigente honra o Criador."
,"32":"O injusto tropeça na sua própria maldade, mas o justo refugia-se na sua própria integridade."
,"33":"No coração prudente mora a sabedoria, e ela manifesta-se até no meio dos insensatos."
,"34":"A justiça faz uma nação prosperar, mas o pecado empobrece os povos."
,"35":"O rei favorece o ministro hábil, mas descarrega a sua ira sobre o indigno."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Resposta calma aplaca a ira; palavra mordaz atiça a cólera."
,"2":"A língua dos sábios faz saborear o conhecimento, mas a boca dos insensatos vomita ignorância."
,"3":"Em todo o lugar os olhos de Javé vigiam os maus e os bons."
,"4":"Palavra reconfortante é árvore de vida; língua perversa fere o coração."
,"5":"O tolo despreza a correcção paterna, mas quem observa a repreensão é esperto."
,"6":"Na casa do justo existe abundância, mas o lucro do injusto só traz inquietação."
,"7":"A boca do sábio espalha conhecimento, mas a mente do insensato é insensata."
,"8":"Javé detesta o sacrifício dos injustos, mas aprecia a súplica dos homens rectos."
,"9":"Javé detesta o comportamento dos injustos, mas ama quem procura a justiça."
,"10":"Quem se desvia do caminho será duramente punido, e quem não gosta da repreensão morrerá."
,"11":"Morte e abismo são transparentes para Javé; quanto mais o coração hu-mano!"
,"12":"O insolente não gosta que o repreendam, e não anda com os sábios."
,"13":"Coração contente alegra o rosto, mas coração aflito deprime o espírito."
,"14":"Mente recta procura o conhecimento, mas a boca dos insensatos alimenta-se de ignorância."
,"15":"Para o pobre, todos os dias são maus, mas o coração alegre está sempre em festa."
,"16":"Mais vale o pouco com o temor de Javé, do que grandes tesouros com inquietação."
,"17":"Mais vale um prato de verdura com amor, do que um vitelo gordo com rancor."
,"18":"Homem colérico provoca disputas; homem paciente acalma as brigas."
,"19":"O caminho do preguiçoso é cercado de espinhos, mas o caminho dos justos é estrada plana."
,"20":"Filho sábio é alegria para o pai, mas filho insensato é desonra para a mãe."
,"21":"A ignorância alegra quem não tem senso, mas o homem prudente segue o caminho recto."
,"22":"Os projectos fracassam por falta de consulta, mas têm sucesso quando há muitos conselheiros."
,"23":"Que alegria saber dar uma resposta! Como é boa a palavra oportuna!"
,"24":"O prudente sobe por um caminho de vida, que o afasta do mundo dos mortos."
,"25":"Javé derruba a casa dos soberbos, e fixa os marcos do terreno da viúva."
,"26":"Javé detesta projectos perversos e gosta de palavras sinceras."
,"27":"Quem cobiça ganhos desonestos acaba por arruinar a sua própria casa, mas quem odeia o suborno viverá."
,"28":"O justo reflecte antes de responder, mas a boca dos injustos vomita maldades."
,"29":"Javé afasta-Se dos injustos, mas ouve a súplica dos justos."
,"30":"Olhar sereno alegra o coração, e boas notícias renovam as forças."
,"31":"Ouvido que escuta a repreensão sadia habita entre os sábios."
,"32":"Quem rejeita a correcção despreza-se a si mesmo, mas quem aceita a repreensão adquire bom senso."
,"33":"O temor de Javé é escola de sabedoria, e antes da honra está a humildade."
}`)
	CurrentBook.AddChapter(16, `{
"1":"O homem faz os seus projectos, mas a resposta vem de Javé."
,"2":"A pessoa pode achar que a sua conduta é certa, mas é Javé quem examina as consciências."
,"3":"Confia a Javé tudo o que fazes, e os teus projectos se realizarão."
,"4":"Javé faz tudo para uma finalidade, até o injusto para o dia da desgraça."
,"5":"Javé detesta o orgulhoso, que certamente não ficará sem castigo."
,"6":"Com amor e fidelidade apaga-se a culpa, e com o temor de Javé evita-se o mal."
,"7":"Quando aprova a conduta de alguém, Javé reconcilia com ele até mesmo os inimigos."
,"8":"Mais vale pouco com justiça, do que muitos ganhos violando o direito."
,"9":"O homem planeia o seu caminho, mas é Javé quem lhe dirige os passos."
,"10":"Há um oráculo nos lábios do rei, e a sua boca não erra na sentença."
,"11":"Os pratos da balança justa são de Javé, e todos os pesos são obra sua."
,"12":"Os reis detestam a prática do mal, porque é na justiça que o trono se firma."
,"13":"O rei aprova os lábios sinceros e ama a quem fala com rectidão."
,"14":"A ira do rei é arauto de morte, mas o homem sensato consegue aplacá-la."
,"15":"No rosto sereno do rei está a vida, e o seu favor é nuvem que traz chuva."
,"16":"Mais vale adquirir sabedoria do que ouro, e é melhor adquirir discernimento do que prata."
,"17":"O caminho dos homens rectos consiste em evitar o mal, e quem vigia o próprio caminho conserva a vida."
,"18":"Antes da ruína vem o orgulho, e antes da queda, a presunção."
,"19":"É melhor ser humilde com os pobres, do que repartir despojos com os soberbos."
,"20":"Quem mede as palavras tem sucesso, e quem confia em Javé é feliz."
,"21":"Quem tem mente sábia será chamado inteligente, e falar com suavidade convence muito mais."
,"22":"A sensatez é fonte de vida para quem a possui, mas a estupidez é a escola dos tolos."
,"23":"O sábio de mente possui boca discreta, e os seus lábios convencem muito mais."
,"24":"As palavras gentis são favo de mel: doce na garganta e saudável para o corpo."
,"25":"Há caminhos que parecem rectos, mas acabam por conduzir à morte."
,"26":"A fome do trabalhador obriga-o a trabalhar, porque a sua boca o empurra."
,"27":"O vagabundo causa desgraça, e leva nos lábios fogo abrasador."
,"28":"O homem perverso provoca contendas, e quem calunia separa os amigos."
,"29":"O homem violento seduz o próximo, e arrasta-o pelo mau caminho."
,"30":"Quem pisca o olho planeia fraudes; quem morde os lábios já praticou o mal."
,"31":"Cabelos brancos são coroa nobre, quando se encontram no caminho da justiça."
,"32":"Paciência vale mais que valentia, e dominar-se a si mesmo vale mais que conquistar uma cidade."
,"33":"Os homens lançam dados para tirar a sorte, mas a sentença vem de Javé."
}`)
	CurrentBook.AddChapter(17, `{
"1":"É melhor um pedaço de pão seco na tranquilidade, do que a casa cheia de banquetes e desavenças."
,"2":"O escravo sensato impor-se-á a um filho indigno e terá parte na herança com os irmãos."
,"3":"A fornalha prova a prata e o forno prova o ouro, mas é Javé quem prova as consciências."
,"4":"O malfeitor dá atenção aos lábios que maldizem, e o mentiroso dá ouvidos à língua perversa."
,"5":"Quem zomba do pobre insulta o Criador, e quem ri do infeliz não ficará sem castigo."
,"6":"Os netos são a coroa dos anciãos, e os pais são a honra dos filhos."
,"7":"Linguagem elevada não convém ao imbecil, e menos ainda a língua mentirosa a um príncipe."
,"8":"O suborno é talismã para quem o dá: com ele, consegue tudo o que quer."
,"9":"Quem busca amizade encobre as ofensas; quem as repete afasta o amigo."
,"10":"Mais vale uma repreensão para o inteligente do que cem golpes para o insensato."
,"11":"O rebelde busca o mal e será apanhado por um carrasco cruel."
,"12":"É melhor encontrar uma ursa, à qual roubaram as crias, do que um insensato dizendo idiotices."
,"13":"Quem paga o bem com o mal, terá sempre o mal em sua casa."
,"14":"Começo de briga é como rachadura na represa; é melhor desistir antes que se acenda a disputa."
,"15":"Absolver o culpado e condenar o inocente são duas coisas que Javé detesta."
,"16":"Não adianta o insensato ter dinheiro para comprar sabedoria, porque ele não aprende nada."
,"17":"Um amigo ama em qualquer tempo, é um irmão no dia do perigo."
,"18":"Não tem bom senso quem toma um compromisso como fiador do seu vizinho."
,"19":"Quem procura brigas é porque gosta de crime, e quem se gaba busca a ruína."
,"20":"O coração perverso não encontrará a felicidade, e a língua tortuosa cairá na desgraça."
,"21":"Quem gera um insensato acabará por sofrer, e o pai de um imbecil não terá alegria."
,"22":"Coração alegre ajuda a sarar, mas espírito abatido seca os ossos."
,"23":"O injusto aceita suborno às escondidas, para distorcer o curso da justiça."
,"24":"A sabedoria está sempre diante do homem inteligente, mas o insensato olha para os confins do mundo."
,"25":"Filho insensato é tormento para o pai e amargura para a mãe."
,"26":"Não é bom punir quem tem razão, e pior ainda é açoitar os inocentes."
,"27":"Quem fala pouco possui a ciência, e o homem inteligente mantém a calma."
,"28":"Quando calado, o insensato passa por sábio e, se fecha bem a boca, passa por inteligente."
}`)
	CurrentBook.AddChapter(18, `{
"1":"O solitário segue os seus caprichos e não faz caso de conselho nenhum."
,"2":"O insensato não gosta da discrição, só quer espalhar o que pensa."
,"3":"A injustiça provoca a infâmia, e a desonra provoca o insulto."
,"4":"As palavras de um homem são água profunda, torrente transbordante e fonte de sabedoria."
,"5":"Não é justo favorecer o culpado, deixando de fazer justiça ao inocente."
,"6":"Os lábios do insensato provocam contendas, e a sua boca atrai o castigo."
,"7":"A boca do insensato provoca a sua própria ruína, e os seus lábios são armadilha para a sua própria vida."
,"8":"As palavras do caluniador são guloseimas que descem até ao fundo do ventre."
,"9":"O relaxado no trabalho é irmão de quem desperdiça."
,"10":"O nome de Javé é torre fortificada; o justo corre para ela e fica protegido."
,"11":"A fortuna do rico é a sua fortaleza, e ele imagina-a como uma alta muralha."
,"12":"Antes da ruína, o coração exalta-se, mas antes da honra vem a humildade."
,"13":"Quem responde antes de ouvir mostra que é tolo e fica envergonhado."
,"14":"O bom ânimo sustenta na doença. Mas quem levantará o espírito abatido?"
,"15":"O inteligente adquire saber, e o ouvido sensato deseja aprender."
,"16":"Os presentes que um homem dá abrem-lhe as portas e dão-lhe acesso à presença dos grandes."
,"17":"O primeiro que se defende parece ter sempre razão, até que chegue outro e diga o contrário."
,"18":"Tirar a sorte acaba com as discussões e decide entre os poderosos."
,"19":"Irmão ofendido é pior que fortaleza, e as brigas são como portões de castelo."
,"20":"Com a boca, a pessoa sacia o estômago e sacia-se com o produtos dos seus lábios."
,"21":"Morte e vida dependem da língua; quem sabe usá-la, comerá do seu fruto."
,"22":"Quem encontra uma esposa, encontra a felicidade, e alcança o favor de Javé."
,"23":"O pobre fala suplicando, e o rico responde com dureza."
,"24":"Há amigos que levam à ruína, mas também há amigos mais dedicados que um irmão."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Mais vale um pobre de conduta íntegra, do que um rico de costumes perversos."
,"2":"Não adianta agir sem reflectir, pois quem apressa o passo acaba por tropeçar."
,"3":"A estupidez arruína o caminho do homem, e depois ele irrita-se contra Javé."
,"4":"A riqueza multiplica os amigos, mas o pobre é abandonado até pelo amigo."
,"5":"A testemunha falsa não ficará impune, e quem espalha mentiras não esca-pará."
,"6":"Muita gente adula o homem importante, e todos são amigos de quem dá presentes."
,"7":"Se o pobre é desprezado até pelos seus próprios irmãos, quanto mais os amigos se afastarão dele!"
,"8":"Quem adquire bom senso quer bem a si mesmo, e quem conserva o discernimento será feliz."
,"9":"A testemunha falsa não ficará impune, e quem espalha mentiras perecerá."
,"10":"Não convém que o insensato viva no luxo, e menos ainda que os escravos dominem os príncipes."
,"11":"O homem de bom senso reprime a ira, e tem como honra ignorar uma ofensa."
,"12":"A ira do rei é como rugido de leão, e o seu favor é como orvalho sobre a relva."
,"13":"Filho insensato é desgraça para o pai, e mulher queixosa é uma goteira contínua."
,"14":"Casa e património são herança dos pais, e mulher de bom senso é dom de Javé."
,"15":"A preguiça faz cair no sono, e o preguiçoso passará fome."
,"16":"Quem observa os mandamentos conserva a vida, mas quem descuida a própria conduta morrerá."
,"17":"Quem ajuda o pobre empresta a Javé, que lhe dará a recompensa devida."
,"18":"Corrige o teu filho enquanto é tempo, mas não exageres ao ponto de o matares."
,"19":"O violento deve ser punido; se o poupares, ele tornar-se-á pior."
,"20":"Escuta o conselho, aceita a correcção, e chegarás a ser sábio."
,"21":"O homem imagina muitos planos, mas o que permanece é o projecto de Javé."
,"22":"O que se deseja do homem é o amor; e vale mais um pobre do que um mentiroso."
,"23":"O temor de Javé conduz à vida, e a pessoa dorme tranquila e sem pesadelos."
,"24":"O preguiçoso mete a mão no prato, e não quer ter o trabalho de a levar à boca."
,"25":"Castiga o zombador, e o ingénuo ficará esperto; corrige o inteligente, e ele aumentará o seu saber."
,"26":"Quem maltrata o pai e expulsa a mãe é filho desonrado e infame."
,"27":"Meu filho, se não aceitares a correcção, perder-te-ás por falta de princípios."
,"28":"A testemunha depravada zomba do direito, e a boca do perverso engole a injustiça."
,"29":"As varas estão preparadas para as costas dos insensatos."
}`)
	CurrentBook.AddChapter(20, `{
"1":"O vinho provoca insolência, e o licor causa barulho: quem se embriaga com eles não chega a ser sábio."
,"2":"A cólera do rei é como um rugido de leão: quem o irrita arrisca a vida."
,"3":"É uma honra viver sem brigas, mas o tolo envolve-se em rixas."
,"4":"No Outono o preguiçoso não lavra, e na colheita vai procurar e nada encontra."
,"5":"Projecto na mente é como uma água profunda, e o homem inteligente sabe alcançá-lo."
,"6":"Muitos se proclamam homens fiéis. Mas quem encontrará um homem de confiança?"
,"7":"O justo comporta-se com integridade. Felizes os filhos que vierem depois dele."
,"8":"O rei sentado no tribunal, com o olhar dissipa todo o mal."
,"9":"Quem poderá dizer que tem consciência pura, livre de qualquer pecado?"
,"10":"Dois pesos e duas medidas são coisas que Javé detesta."
,"11":"Já nos seus brinquedos a criança demonstra o seu comportamento futuro, se vai ser pura e recta."
,"12":"Foi Javé quem fez o ouvido que escuta e o olho que vê."
,"13":"Não te apegues ao sono, porque ficarás pobre; abre os olhos, e terás pão à vontade."
,"14":"«Não presta, não presta», diz o comprador. Mas quando se vai embora gaba-se do que comprou."
,"15":"Existe ouro e muitas pérolas, mas a coisa mais preciosa são os lábios instruídos."
,"16":"Toma a roupa e exige garantias de quem se tornou fiador de um estrangeiro e de um desconhecido."
,"17":"É gostoso para o homem o pão ganho com fraude, mas depois a sua boca fica cheia de grãos de areia."
,"18":"Aconselha-te para preparares os teus planos e faz a guerra com táctica."
,"19":"Quem fala muito acaba por revelar segredos. Não te juntes com pessoas faladoras."
,"20":"Quem amaldiçoa pai e mãe verá a sua lâmpada apagar-se no meio das trevas."
,"21":"A posse antecipada de uma herança no final não será abençoada."
,"22":"Nunca digas: «Hás-de pagar-me o mal que me fizeste». Confia em Javé, e Ele te defenderá."
,"23":"Javé detesta dois pesos, e a balança falsa não é justa."
,"24":"É Javé quem dirige os passos do homem. Como poderia alguém discernir o próprio caminho?"
,"25":"É tentação fazer um voto sem pensar, e depois arrepender-se da promessa feita."
,"26":"O rei sábio peneira os injustos e faz passar a roda sobre eles."
,"27":"O espírito do homem é uma lâmpada de Javé, que sonda as profundezas do ser."
,"28":"Amor e fidelidade protegem o rei, e é no amor que o seu trono se firma."
,"29":"O orgulho do jovem é a força, e a honra do ancião está nos seus cabelos brancos."
,"30":"Feridas e chagas são remédio contra o mal, e os açoites purificam o íntimo do corpo."
}`)
	CurrentBook.AddChapter(21, `{
"1":"A mente do rei é um riacho na mão de Javé. Ele o dirigirá para onde quiser."
,"2":"O homem pensa que o seu caminho é sempre recto, mas é Javé quem pesa os corações."
,"3":"Praticar a justiça e o direito vale mais, para Javé, do que os sacrifícios."
,"4":"Orgulho e ambição são pecados que dirigem os injustos."
,"5":"Os projectos do trabalhador trazem lucro, os planos do apressado trazem miséria."
,"6":"Riqueza adquirida com mentiras é ilusão fugaz de gente que procura a morte."
,"7":"A violência dos injustos arrebata-os, porque eles se negam a praticar a justiça."
,"8":"O caminho do culpado é tortuoso, mas a estrada do inocente é recta."
,"9":"É melhor morar no fundo do quintal, que dentro de casa com mulher desordeira."
,"10":"A sede do injusto é desejar o mal, pois ele olha sem piedade para o seu próximo."
,"11":"Quando o zombador é castigado, o ingénuo torna-se sábio, enquanto o sensato aprende com a experiência."
,"12":"O justo observa como a casa do injusto arrasta os injustos para a ruína."
,"13":"Quem tapa os ouvidos quando o fraco suplica, não terá resposta quando clamar."
,"14":"Presente discreto aplaca a ira, e suborno disfarçado acalma o furor."
,"15":"Praticar a justiça é alegria para o justo e terror para os malfeitores."
,"16":"Quem se desvia do caminho do bom senso irá descansar na companhia dos mortos."
,"17":"Quem gosta de banquetes acabará mendigo; quem gosta de vinho e carne boa jamais ficará rico."
,"18":"O injusto servirá de resgate para o justo; e o traidor para os homens rectos."
,"19":"É melhor morar no deserto do que com uma mulher desordeira e mal humorada."
,"20":"Na casa do sábio há tesouros e perfumes, enquanto o insensato gasta tudo o que tem."
,"21":"Quem busca justiça e amor encontrará vida, justiça e honra."
,"22":"O sábio escala a cidade fortemente defendida, e destrói a fortaleza em que ela confiava."
,"23":"Quem guarda a boca e a língua evitará muitas angústias."
,"24":"Quem age com raiva e insolência tem fama de arrogante e presunçoso."
,"25":"Os desejos causam a morte do preguiçoso, porque as suas mãos se negam a trabalhar."
,"26":"O injusto está sempre a cobiçar, mas o justo distribui e nada retém."
,"27":"O sacrifício dos injustos é detestável, mais ainda quando feito com má intenção."
,"28":"A testemunha falsa perecerá, mas aquela que sabe escutar dirá a última palavra."
,"29":"O injusto assume ares de pessoa importante, mas o homem recto controla a sua própria conduta."
,"30":"Diante de Javé não há sabedoria, nem inteligência, nem conselho."
,"31":"O cavalo prepara-se para o dia da batalha, mas a vitória vem de Javé."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Boa fama é melhor que riqueza, e a simpatia vale mais do que ouro e prata."
,"2":"Rico e pobre encontram-se: foi Javé quem a ambos criou."
,"3":"O esperto vê o perigo e esconde-se; o ingénuo avança e sai-se mal."
,"4":"Os frutos da humildade são o temor de Javé, a riqueza, a honra e a vida."
,"5":"No caminho do perverso há espinhos e armadilhas; quem cuida de si fica longe dele."
,"6":"Educa o jovem no caminho a seguir, e até à velhice ele não se desviará."
,"7":"O rico domina os pobres, e o devedor é escravo do credor."
,"8":"Quem semeia a injustiça colhe desgraça; a vara do castigo acabará com ele."
,"9":"O generoso será abençoado, porque reparte o seu pão com o pobre."
,"10":"Expulsa o insolente, e acabará o desentendimento, cessarão as contendas e insultos."
,"11":"Quem é limpo de coração e educado no falar acabará por ser ministro do rei."
,"12":"Os olhos de Javé protegem o saber e fazem fracassar as palavras do traidor."
,"13":"O preguiçoso diz: «Lá fora anda um leão à solta; vai matar-me no meio da rua»."
,"14":"A boca das estrangeiras é cova profunda, e os inimigos de Javé nela cairão."
,"15":"A tolice é natural na mente da criança, mas dela se afastará pela vara da disciplina."
,"16":"Quem oprime o fraco para enriquecer, acaba por entregar tudo ao rico e empobrecer."
,"17":"Presta atenção, ouve as Palavras dos Sábios, e aplica a tua mente à minha instrução."
,"18":"Vais gostar de as guardar na memória e de as ter de cor na ponta da língua."
,"19":"Vou instruir-te hoje, para que em Javé esteja a tua confiança."
,"20":"Escrevi-te trinta máximas sobre conselhos e conhecimentos,"
,"21":"para que aprendas a observar e a falar correctamente, e para que possas informar fielmente quem te enviar."
,"22":"Não explores o fraco por ser fraco, nem oprimas o pobre no tribunal,"
,"23":"porque Javé defenderá a sua causa e tirará a vida àqueles que os tiverem oprimido."
,"24":"Não faças amizade com pessoa colérica, nem andes com gente violenta."
,"25":"Correrias o risco de te habituares aos seus costumes e preparares uma armadilha para ti mesmo."
,"26":"Não sejas como aqueles que se comprometem facilmente, tornando-se fiadores de dívidas."
,"27":"Se não tiveres com que pagar, eles levarão até a cama onde dormes."
,"28":"Não mudes os marcos das terras que os teus antepassados colocaram."
,"29":"Já viste um homem perito no seu trabalho? Ele será contratado para servir a reis, e não a pessoas sem importância."
}`)
	CurrentBook.AddChapter(23, `{
"1":"Quando estiveres a comer ao lado de um chefe, presta atenção à pessoa que está diante de ti."
,"2":"Se estiveres com fome, põe uma faca na garganta,"
,"3":"e não cobices as comidas, porque são alimentos enganadores."
,"4":"Não te empenhes em adquirir riquezas, nem gastes a tua inteligência com isso,"
,"5":"pois basta olhares e já não existem: baterão as asas como a águia e voarão pelo céu."
,"6":"Não comas na casa do invejoso, nem cobices as suas comidas,"
,"7":"pois ele só pensa em si mesmo. Ele diz: «Come e bebe!» Mas não é sincero contigo."
,"8":"Então vomitarás o bocado que comeste e desperdiçarás as tuas palavras amáveis."
,"9":"Não percas tempo a falar com nenhum insensato, porque ele vai desprezar as tuas palavras sábias."
,"10":"Não mudes os marcos das terras, nem invadas o campo dos órfãos,"
,"11":"porque o seu defensor é forte e defenderá a sua causa contra ti."
,"12":"Disciplina a tua mente e presta atenção aos conselhos da experiência."
,"13":"Não deixes de disciplinar o jovem. Se o corrigires com vara, ele não morrerá."
,"14":"Quanto a ti, corrige com vara o jovem, e livrá-lo-ás da morte."
,"15":"Meu filho, se te tornares sábio, eu alegrar-me-ei."
,"16":"Ficarei muito contente quando os teus lábios falarem com rectidão."
,"17":"Não tenhas inveja dos pecadores, mas permanece sempre no temor de Javé,"
,"18":"pois é certo que assim terás futuro, e a tua esperança não fracassará."
,"19":"Escuta, meu filho: torna-te sábio, e forma bem a tua mente."
,"20":"Não te juntes aos beberrões, nem andes com os comilões,"
,"21":"pois o beberrão e o comilão empobrecem, e o dorminhoco veste-se com trapos."
,"22":"Dá ouvidos a teu pai, porque ele te gerou, e não desprezes a velhice de tua mãe."
,"23":"Compra a verdade e não vendas a sabedoria, a disciplina e a inteligência."
,"24":"O pai justo ficará muito contente, e quem gera um filho sábio alegrar-se-á."
,"25":"Que teu pai e tua mãe se alegrem, e fique contente aquela que te gerou."
,"26":"Meu filho, presta-me atenção e aceita de boa vontade o meu exemplo,"
,"27":"pois a prostituta é cova profunda e a estrangeira é poço estreito."
,"28":"Ela fica de emboscada como ladrão e multiplica traições entre os homens."
,"29":"Para quem são os gemidos? Para quem os lamentos? Para quem as brigas? Para quem as queixas? Para quem os ferimentos sem motivo? Para quem os olhos vermelhos?"
,"30":"São para aqueles que bebem o dia inteiro e vivem procurando bebidas misturadas."
,"31":"Não fiques fascinado pelo vinho, vendo a sua cor e brilho, enquanto escorre suavemente no copo."
,"32":"No fim, morde como serpente e pica como víbora."
,"33":"Então os teus olhos verão coisas estranhas, e a tua mente imaginará coisas absurdas."
,"34":"Ficarás como quem está a dormir no mar alto ou sentado no topo de um mastro."
,"35":"«Bateram-me, e não senti nada! Deram-me uma sova e nem dei por isso! Quando me levantar, vou continuar a beber»."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Não tenhas inveja dos maus, nem desejes viver como eles,"
,"2":"porque o seu coração trama violência, e os seus lábios só proferem maldades."
,"3":"Com a sabedoria se constrói a casa, e com a prudência se consolida."
,"4":"Pelo conhecimento, os celeiros ficam cheios de bens preciosos e agradáveis."
,"5":"É melhor ser sábio que ser forte, e o conhecimento vale mais que a força."
,"6":"É com estratagemas que se faz a guerra, e a vitória depende do número de conselheiros."
,"7":"Para o tolo a sabedoria é coisa inacessível, e no tribunal não abrirá a boca."
,"8":"Quem planeia o mal será chamado homem de intrigas."
,"9":"O propósito do tolo é o pecado, e o zombador é detestado pelos homens."
,"10":"Se fraquejas no dia da desgraça, é sinal de que a tua força é bem pequena."
,"11":"Liberta os condenados à morte, e não abandones os que são arrastados ao suplício."
,"12":"Podes dizer que não tens nada com isso, mas Deus pesa os corações e tomará conhecimento. Aquele que vigia sobre a tua vida sabe de tudo, e pagará a cada um conforme as obras que tiver feito."
,"13":"Meu filho, come mel, porque faz bem; o favo de mel é saboroso na boca."
,"14":"Também a sabedoria é assim: se a encontrares, terás futuro, e a tua esperança não fracassará."
,"15":"Não conspires contra a casa do justo, nem lhe destruas a morada,"
,"16":"porque o justo pode cair sete vezes, mas levanta-se, enquanto que os ímpios se afundam na desgraça."
,"17":"Não te alegres quando o teu inimigo cai, e não rejubiles quando ele tropeça."
,"18":"Javé poderia ver isso, ficar descontente e retirar dele a sua ira."
,"19":"Não fiques irritado por causa dos maus, nem tenhas inveja dos injustos,"
,"20":"porque o mau não tem futuro, e a lâmpada dos injustos se apagará."
,"21":"Meu filho, teme Javé e o rei; e não te revoltes contra nenhum deles,"
,"22":"porque de repente eles se vingarão, e sabe-se lá com que furor."
,"23":"Também estas são palavras dos Sábios: Não é bom ser parcial no julgamento."
,"24":"O povo amaldiçoará quem absolver o culpado, e contra ele todos ficarão irritados."
,"25":"Os que fizerem justiça, porém, terão sucesso e serão abençoados."
,"26":"Resposta bem dada é um beijo nos lábios."
,"27":"Organiza os teus negócios na cidade e prepara tudo no campo, para depois construíres a tua casa."
,"28":"Não testemunhes sem motivo contra o teu próximo, e não o enganes com os lábios."
,"29":"Nunca digas: «Vou fazer-lhe o mesmo que ele me fez a mim. Vou pagar-lhe como ele merece!»"
,"30":"Passei pelo campo de um preguiçoso, e pela vinha de um homem sem juízo:"
,"31":"estava tudo cheio de urtigas, o terreno coberto de espinhos e o muro em ruínas."
,"32":"Vendo isto, comecei a reflectir e aprendi esta lição:"
,"33":"Dorme um pouco, dormita mais um pouco, depois cruza os braços para descansar ainda um pouco,"
,"34":"e a miséria do vagabundo cairá sobre ti, e a indigência atacar-te-á como um homem armado."
}`)
	CurrentBook.AddChapter(25, `{
"1":"Também estes são provérbios deSalomão, recolhidos e copiados pelos funcionários de Ezequias, rei de Judá."
,"2":"A glória de Deus é ocultar as coisas, e a glória dos reis é pesquisá-las."
,"3":"A altura do Céu, a profundidade da Terra e a mente dos reis são coisas insondáveis."
,"4":"Tira as escórias à prata e ficará completamente pura;"
,"5":"tira o injusto da presença do rei, e o seu trono se firmará na justiça."
,"6":"Não te vanglories na frente do rei, nem ocupes o lugar dos grandes."
,"7":"É melhor que te digam: «Sobe para aqui», do que seres humilhado na presença de uma autoridade."
,"8":"Não te apresses a usar no tribunal aquilo que acabaste de ver, pois, o que farás no fim, se o teu próximo te puser em apuros?"
,"9":"Discute a causa directamente com o teu próximo, mas não reveles o segredo de uma outra pessoa,"
,"10":"para que os ouvintes não te difamem e o teu descrédito se torne irreparável."
,"11":"Maçã de ouro em bandeja de prata, assim é a palavra dita na hora oportuna."
,"12":"Anel de ouro e colar de ouro puro, é a repreensão do sábio para ouvido atento."
,"13":"Neve fresca em tempo de colheita, assim é o mensageiro fiel para quem o envia."
,"14":"Nuvens e ventos e nada de chuva é aquele que promete mas não cumpre."
,"15":"Com paciência se dobra um magistrado, e a língua macia pode quebrar ossos."
,"16":"Se encontraste mel, come apenas o suficiente, para não ficares enjoado e o vomitares."
,"17":"Não frequentes demasiado a casa do teu próximo, para que ele não se canse e se aborreça de ti."
,"18":"Dardo, espada e flecha aguda tal é o homem que depõe falsamente contra o próximo."
,"19":"Dente solto e pé sem firmeza é confiar no traidor quando chega o perigo."
,"20":"Vinagre na ferida e nudez no frio é como entoar canções para um coração aflito."
,"21":"Se o teu inimigo tem fome, dá-lhe de comer; se tem sede, dá-lhe de beber."
,"22":"Deste modo, fá-lo-ás corar de vergonha e Javé te recompensará."
,"23":"O vento norte traz chuva, e os mexericos trazem ódio."
,"24":"É melhor morar no fundo do quintal, do que dentro de casa com mulher desordeira."
,"25":"Água fresca em garganta sedenta é como a boa notícia de uma terra distante."
,"26":"Fonte turva e nascente poluída é o justo que fraqueja diante do injusto."
,"27":"Comer muito mel não é bom, e procurar a própria honra não é honra."
,"28":"Cidade aberta e sem muralhas é o homem que não sabe controlar-se."
}`)
	CurrentBook.AddChapter(26, `{
"1":"Como a neve no Verão e chuva na ceifa, assim a honra não convém ao insensato."
,"2":"Como pássaro que foge e andorinha que voa, a maldição injusta não atinge a sua meta."
,"3":"O chicote é para o cavalo, o freio é para o jumento e a vara para as costas dos insensatos."
,"4":"Não respondas ao insensato conforme a sua insensatez, para que não te iguales a ele."
,"5":"Responde ao insensato conforme a sua insensatez, para que ele não se considere sábio."
,"6":"Corta os pés e bebe vinagre quem manda recados por meio de um insen-sato."
,"7":"Não têm força as pernas de um coxo, como as sentenças na boca dos insensatos."
,"8":"Prestar homenagem ao insensato é como colocar uma pedra na funda."
,"9":"Como um ramo de espinheiro na mão de um bêbado, assim é o provérbio na boca dos insensatos."
,"10":"Como archeiro que dispara contra os passantes, assim é aquele que dá emprego ao insensato e ao bêbado."
,"11":"Como cão que volta ao seu vómito, assim é o insensato que repete a sua estupidez."
,"12":"Já viste alguém que se considere sábio? Pode-se esperar mais do insensato do que dele."
,"13":"O preguiçoso diz: «Anda uma fera no caminho e um leão na rua»."
,"14":"Como a porta gira nos gonzos, assim o preguiçoso rola na cama."
,"15":"O preguiçoso mete a sua mão no prato, e acha cansativo levá-la até à boca."
,"16":"O preguiçoso considera-se mais sábio do que sete pessoas que respondem com prudência."
,"17":"Agarra um cão pelas orelhas quem se mete em briga alheia."
,"18":"Como alguém que se finge de louco e atira setas inflamadas, flechas e morte,"
,"19":"assim é o homem que mente ao seu próximo e depois diz: «Fiz isso só por brincadeira»."
,"20":"Sem lenha, o fogo apaga-se; sem difamador, acaba-se a briga."
,"21":"Carvão para as brasas e lenha para o fogo, é o brigão para atear uma contenda."
,"22":"As palavras do difamador são guloseimas que descem ao fundo do ventre."
,"23":"Verniz a recobrir argila são os lábios que elogiam com má intenção."
,"24":"Quem odeia disfarça com a boca, mas por dentro guarda a mentira."
,"25":"Se a sua voz é suave, não confies nele, pois no coração tem sete abominações."
,"26":"Embora cubra o ódio com máscara, a sua maldade será descoberta na assembleia."
,"27":"Quem abre um buraco, nele cairá; quem rola uma pedra, esta para cima dele voltará."
,"28":"A língua mentirosa odeia a quem ela mesma fere, e a boca que elogia conduz à ruína."
}`)
	CurrentBook.AddChapter(27, `{
"1":"Não te glories do amanhã, porque não sabes o que o dia de hoje vai trazer."
,"2":"Que um estranho te elogie e não a tua própria boca; que seja um desconhecido, e não os teus próprios lábios."
,"3":"A pedra é pesada e a areia é uma carga, mas a cólera do estúpido pesa mais que elllas"
,"4":"O furor é cruel e a ira é impetuosa, mas quem pode resistir diante do ciú-me?"
,"5":"É melhor uma repreensão franca do que uma amizade fingida."
,"6":"A bofetada do amigo é leal, mas o beijo do inimigo é mentiroso."
,"7":"Estômago cheio despreza o favo de mel; estômago faminto acha doce o fel."
,"8":"Como ave que anda longe do ninho, assim é o homem longe do lar."
,"9":"Óleo e perfume alegram o coração, e conselho de amigo acalma o ânimo."
,"10":"Não abandones o teu amigo, nem o amigo de teu pai: e, no dia difícil, não vás à casa do teu irmão: vale mais o vizinho perto do que o irmão longe."
,"11":"Meu filho, tem juízo e alegra o meu coração, e eu poderei responder a quem me ultraja."
,"12":"O esperto vê o perigo e esconde-se; o ingénuo avança e sai-se mal."
,"13":"Tira a veste a quem se tornou fiador de um desconhecido e ficou empenhado com um estrangeiro."
,"14":"Acordar o vizinho para lhe dizer «bom dia» é o mesmo que amaldiçoá-lo."
,"15":"Goteira a pingar em dia de chuva e mulher desordeira são coisas iguais."
,"16":"Querer segurá-la é como segurar o vento ou reter o azeite com a mão."
,"17":"O ferro afia-se com o ferro, e a pessoa afia-se com a presença do seu próximo."
,"18":"Quem cuida da sua figueira, comerá dos seus figos; e quem respeita o patrão, será honrado."
,"19":"O rosto reflecte-se na água, e o homem reflecte-se na sua consciência."
,"20":"Morte e abismo são insaciáveis, da mesma forma que a ambição humana."
,"21":"A prata é provada na fornalha, o ouro no forno, e o homem na boca de quem o elogia."
,"22":"Mesmo que pises o imbecil no pilão, a estupidez não se separa dele."
,"23":"Observa bem o aspecto das tuas ovelhas, e presta atenção aos teus rebanhos,"
,"24":"porque a riqueza não dura sempre, nem a fortuna passa de geração em geração."
,"25":"Corta a relva, e quando ela brotar, junta o feno dos montes."
,"26":"Desta forma, as ovelhas te darão roupa, e os cabritos darão para comprares um campo;"
,"27":"as cabras darão leite para te alimentares a ti, à tua família e às tuas empregadas."
}`)
	CurrentBook.AddChapter(28, `{
"1":"O injusto foge sem ser perseguido, mas o justo é intrépido como um leão."
,"2":"Quando no país reina a transgressão, os chefes multiplicam-se; mas com homem sensato e prudente firma-se a ordem."
,"3":"Pobre que explora os fracos é chuva devastadora que deixa sem pão."
,"4":"Os que abandonam a Lei elogiam o injusto; os que observam a Lei rompem com ele."
,"5":"Os homens maus não compreendem o direito, mas os que buscam a Javé compreendem tudo."
,"6":"É melhor um pobre de comportamento íntegro do que um rico de conduta perversa."
,"7":"Quem observa a Lei é filho inteligente, mas o amigo dos corruptos envergonha seu pai."
,"8":"Quem multiplica as suas riquezas com usura e juros, acumula para quem se compadece dos fracos."
,"9":"Quem fecha os ouvidos à Lei, até a sua oração se tornará detestada."
,"10":"Quem desvia os justos para o mau caminho cairá na sua própria armadilha."
,"11":"O rico considera-se sábio, mas o pobre inteligente desmascara-o."
,"12":"Quando os justos triunfam, a festa é grande; quando os injustos imperam, todos se escondem."
,"13":"Quem esconde as suas faltas, nunca terá sucesso; quem as confessa e abandona, alcança o perdão."
,"14":"Feliz o homem que está sempre alerta, pois o teimoso cai na desgraça."
,"15":"Leão a rugir e urso faminto, assim é o injusto que governa um povo fraco."
,"16":"O chefe insensato multiplica extorsões; quem odeia o lucro prolonga os seus dias."
,"17":"O homem culpado de assassínio fugirá até ao túmulo: que ninguém tente segurá-lo."
,"18":"Quem vive de modo íntegro, será salvo; quem segue dois caminhos, num deles cairá."
,"19":"Quem cultiva o seu campo, saciar-se-á de pão; quem busca ilusões, saciar-se-á de miséria."
,"20":"O homem leal receberá muitas bênçãos, mas quem quer enriquecer rapidamente não ficará impune."
,"21":"Não é bom ser parcial, mas por um pedaço de pão o homem comete um crime."
,"22":"O ambicioso corre atrás da riqueza, e não sabe que vai cair na miséria."
,"23":"Quem repreende alguém será mais estimado do que aquele que elogia."
,"24":"Quem rouba a seus pais, e diz que não é pecado, é cúmplice de bandidos."
,"25":"O ambicioso provoca disputas, mas quem confia em Javé prospera."
,"26":"Quem confia em si mesmo é insensato, mas quem procede com sensatez está a salvo."
,"27":"Quem dá ao pobre não passa necessidade; e quem desvia os olhos dele ficará coberto de maldições."
,"28":"Quando os injustos imperam, todos se escondem; quando desaparecem, os justos prosperam."
}`)
	CurrentBook.AddChapter(29, `{
"1":"O homem que não aceita repreensões fracassará de repente e sem remédio."
,"2":"Quando os justos governam, o povo alegra-se; quando o injusto governa, o povo reclama."
,"3":"Quem ama a sabedoria alegra seu pai, mas quem frequenta prostitutas desperdiça os seus bens."
,"4":"O rei que governa segundo a justiça mantém estável o país, mas o ávido de impostos arruína-o."
,"5":"O homem que adula o próximo arma uma rede aos seus pés."
,"6":"O crime do perverso é uma cilada, mas o justo canta de alegria."
,"7":"O justo atende à causa dos fracos, mas o injusto não se importa com ela."
,"8":"Os provocadores agitam a cidade, mas os sábios contêm a ira."
,"9":"Quando o sábio discute com o tolo, pode ficar zangado ou rir, mas nunca terá descanso."
,"10":"Os assassinos detestam o homem íntegro, mas os homens rectos procuram-no."
,"11":"O insensato desafoga todas as suas paixões, mas o sábio domina-as e acalma-as."
,"12":"Se um chefe presta atenção a palavras mentirosas, os seus ministros tornar-se-ão perversos."
,"13":"O pobre e o opressor encontram-se, mas é Javé quem dá os olhos a ambos."
,"14":"Quando o rei faz justiça aos fracos, o seu trono firmar-se-á para sempre."
,"15":"Vara e repreensão produzem sabedoria, mas o jovem abandonado a si mesmo envergonha sua mãe."
,"16":"Quando os injustos governam, multiplicam-se os crimes; mas os justos verão a ruína deles."
,"17":"Corrige o teu filho, e ele te deixará tranquilo e te trará alegrias."
,"18":"Quando não há profeta, o povo desagrega-se; mas quem observa a Lei é feliz."
,"19":"O escravo não se corrige com palavras, porque ouve mas não obedece."
,"20":"Já viste alguém falar sem pensar? Podes esperar mais de um insensato do que dele."
,"21":"Quem amimalha o seu criado desde criança, acabará por criar um preguiçoso."
,"22":"O homem irado provoca briga, e o homem enfurecido multiplica os crimes."
,"23":"O orgulho de um homem leva-o à humilhação, mas o humilde conserva a própria honra."
,"24":"O cúmplice do ladrão odeia-se a si mesmo: ele ouve a maldição, mas não o denuncia."
,"25":"Quem teme os homens cairá na armadilha, mas quem confia em Javé está em segurança."
,"26":"Muitos procuram o favor do chefe, mas a sentença vem de Javé."
,"27":"O injusto é desprezado pelos justos; o homem recto é desprezado pelos injustos."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Palavras de Agur, filho de Jaces, de Massa. Oráculo do homem: Ó Deus, estou cansado. Estou cansado, ó Deus, e desfaleço, "
,"2":"porque sou o mais ignorante dos homens, e não tenho inteligência humana."
,"3":"Não aprendi a sabedoria e não cheguei a conhecer a ciência do Santo."
,"4":"Quem subiu até ao céu e dele desceu? Quem reteve o vento na mão? Quem recolheu o mar no seu manto? Quem fixou os confins do mundo? Sabes qual é o seu nome e sobrenome?"
,"5":"Cada palavra de Deus é comprovada, e Ele é um escudo para quem n'Ele se abriga."
,"6":"Não acrescentes nada às suas palavras, porque Ele te questionaria, e a tua fraude seria descoberta."
,"7":"Eu Te peço duas coisas, ó Deus. Não me negues isto antes de eu morrer:"
,"8":"Afasta de mim a falsidade e a mentira. Não me dês riqueza, nem pobreza. Concede-me apenas o meu pedaço de pão,"
,"9":"para que, saciado, eu não Te renegue, dizendo: «Quem é Javé?» Ou então, reduzido à miséria, chegue a roubar e profanar o nome do meu Deus."
,"10":"Não calunies o escravo diante do seu patrão, pois o escravo amaldiçoar-te-ia, e tu é que serias castigado."
,"11":"Há gente que amaldiçoa o próprio pai e não abençoa a mãe,"
,"12":"gente que se considera pura e não se lava da sua imundície,"
,"13":"gente de olhos altivos e olhar soberbo,"
,"14":"gente que tem dentes como espadas e queixos como punhais, para eliminar da terra os pobres, e do meio do povo os indigentes!"
,"15":"A sanguessuga tem duas filhas: «Quero mais», «Quero mais». Há três coisas insaciáveis, e uma quarta que nunca diz «Chega»:"
,"16":"a mansão dos mortos, o útero estéril, a terra que não se farta de água, e o fogo que nunca diz «Chega»."
,"17":"Quem zomba de seu pai e não obedece a sua mãe, que as aves de rapina o devorem e os corvos lhe arranquem os olhos."
,"18":"Existem três coisas difíceis para mim, e uma quarta que não compreendo:"
,"19":"o caminho da águia no céu, o caminho da serpente nas pedras, o caminho do navio no alto mar e o caminho do homem com uma jovem."
,"20":"A adúltera comporta-se assim: come, limpa a boca e depois diz: «Não fiz nada de mal»."
,"21":"Existem três coisas que fazem tremer a terra, e uma quarta que ela não pode suportar:"
,"22":"um escravo que se torna rei, um idiota farto de pão,"
,"23":"uma mulher desprezada que encontra marido, e uma escrava que ocupa o lugar da sua senhora."
,"24":"No mundo existem quatro seres pequeninos que são mais sábios do que os sábios:"
,"25":"as formigas, povo fraco, mas que recolhe comida no Verão;"
,"26":"as ratazanas, povo sem força, mas que moram nas rochas;"
,"27":"os gafanhotos, que não têm rei, mas avançam todos em ordem;"
,"28":"as lagartixas, que se podem apanhar com a mão, mas penetram até em palácios de reis."
,"29":"Existem três seres com belo porte, e um quarto de andar imponente:"
,"30":"o leão, o mais valente dos animais, que não recua diante de ninguém;"
,"31":"o galo empinado diante das galinhas; o carneiro que vai à frente do rebanho; e o rei que chefia o seu exército."
,"32":"Se te exaltaste estupidamente e depois se arrependeste, põe a mão na boca,"
,"33":"porque, batendo o leite sai manteiga, apertando o nariz sai sangue, e apertando a ira sai contenda."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Palavras de Lamuel, rei de Massa, que lhe foram ensinadas por sua mãe."
,"2":"O que é isso, meu filho? O que é isso, filho das minhas entranhas? O que é isso, filho das minhas promessas?"
,"3":"Não gastes a tua força com mulheres, nem a tua energia com aquelas que corrompem os reis."
,"4":"Não convém aos reis, ó Lamuel, não convém aos reis beber vinho, nem aos governantes gostar de bebidas alcoólicas."
,"5":"Porque eles bebem, acabam por se esquecer da Lei e pervertem o direito dos pobres."
,"6":"Dá bebida ao moribundo e vinho aos amargurados,"
,"7":"pois bebendo eles esquecerão a miséria e não se lembrarão dos seus sofrimentos."
,"8":"Abre a boca em favor do mudo e em defesa dos desfavorecidos."
,"9":"Abre a boca e pronuncia sentenças justas, defendendo o pobre e o indigente."
,"10":"Quem poderá encontrar uma mulher forte? Ela vale muito mais do que as pérolas."
,"11":"O seu marido confia nela e não deixa de encontrar vantagens."
,"12":"Ela traz-lhe a felicidade e não a desgraça, em todos os dias da sua vida."
,"13":"Adquire lã e linho, e as suas mãos trabalham com prazer."
,"14":"É como navio mercante, que importa de longe as provisões."
,"15":"Ela levanta-se ainda de noite, para alimentar a família e dar ordens às empregadas."
,"16":"Examina um terreno e compra-o, e com o ganho do seu trabalho planta uma vinha."
,"17":"Prepara-se para o trabalho com disposição, e põe em acção a força dos seus braços."
,"18":"Sabe dar valor ao seu trabalho, e mesmo de noite a sua lâmpada não se apaga."
,"19":"Com a mão segura a roca e com os dedos faz girar o fuso."
,"20":"Abre as mãos ao pobre e estende os braços ao indigente."
,"21":"Quando cai neve, não teme pelos seus familiares, porque todos eles têm roupa a dobrar."
,"22":"Tece mantas e veste-se de linho e púrpura."
,"23":"O seu marido é respeitado no tribunal, quando se senta entre os juízes do povo."
,"24":"Ela fabrica tecidos para vender, e fornece cinturões aos comerciantes."
,"25":"Veste-se de força e dignidade, e sorri ao futuro."
,"26":"Abre a boca com sabedoria, e a sua língua ensina com bondade."
,"27":"Supervisiona o andamento da casa, e o seu alimento é fruto do seu trabalho."
,"28":"Os seus filhos levantam-se para a cumprimentarem, e o seu marido elogia-a:"
,"29":"«Muitas mulheres são fortes, mas tu superaste-as a todas!»"
,"30":"A graça é enganadora e a beleza é passageira, mas a mulher que teme a Javé merece louvor."
,"31":"Cantai o sucesso do seu trabalho, e que as suas obras a louvem na praça da cidade."
}`)

}
func PT_BS_LoadVSPSChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Feliz o homem que não vai ao conselho dos injustos, não pára no caminho dos pecadores, nem se senta na roda dos zombadores."
,"2":"Pelo contrário: o seu prazer está na lei de Javé, e medita a sua lei, dia e noite."
,"3":"Ele é como árvore,plantada junto da água corrente: dá fruto no tempo devido, e as suas folhas nunca murcham. Tudo o que ele faz é bem sucedido."
,"4":"Não são assim os,injustos! Não são assim!,Pelo contrário: são como palha que o vento arrebata..."
,"5":"Por isso os injustos não ficarão de pé no Julgamento, nem os pecadores na assembleia dos justos."
,"6":"Porque Javé conhece o caminho dos justos, enquanto o caminho dos injustos perece."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Por que motivo as nações se rebelam, e os povos planeiam em vão?"
,"2":"Os reis da terra revoltam-se,e, unidos, os príncipes conspiram,contra Javé e contra o seu Messias:"
,"3":"«Rebentemos os seus grilhões, sacudamos o seu jugo!»"
,"4":"Aquele que habita no céu ri-Se, Javé diverte-Se à custa deles."
,"5":"E depois fala-lhes com ira, confundindo-os com furor:"
,"6":"«Fui Eu que consagrei o meu rei,em Sião, minha sagrada montanha!»"
,"7":"Vou proclamar o decreto de Javé!,Ele disse-Me: «Tu és o meu filho, Eu hoje Te gerei."
,"8":"Pede-Me, e Eu Te darei as nações como herança, os confins da terra como propriedade."
,"9":"Tu as governarás com ceptro de ferro, e as quebrarás como vaso de oleiro»."
,"10":"E agora, ó reis, sede prudentes!,Deixai-vos corrigir, juízes da terra."
,"11":"Servi a Javé com temor,"
,"12":"prestai-Lhe homenagem tremendo, para que Ele não Se irrite, e vós pereçais no caminho, pois a sua ira inflama-se depressa. Felizes aqueles que n'Ele se abrigam!"
}`)
	CurrentBook.AddChapter(3, `{
"1":"Salmo. De David. Quando fugia de seu filho Absalão."
,"2":"Javé, como são numerosos os meus opressores, numerosos os que se levantam contra mim!"
,"3":"Numerosos aqueles que dizem a meu respeito: «Deus nunca vai salvá-lo»."
,"4":"Tu porém, Javé, és o escudo que me protege, és a minha honra, Aquele que me faz erguer a cabeça."
,"5":"Em alta voz eu grito por Javé, e Ele responde-me do seu monte santo."
,"6":"Posso deitar-me, dormir e despertar, pois é Javé quem me sustenta."
,"7":"Não temo essa multidão de gente,que em cerco se coloca contra mim."
,"8":"Levanta-Te, Javé! Salva-me, Deus meu!,Pois golpeias no queixo os meus inimigos todos, e quebras os dentes dos injustos."
,"9":"De Ti, Javé, vem a salvação,e a bênção para o teu povo."
}`)
	CurrentBook.AddChapter(4, `{
"1":"Do mestre de canto. Com instrumentos de corda. Salmo. De David."
,"2":"Quando Te invoco, responde-me, ó Deus, meu defensor!,Na angústia Tu me aliviaste: tem piedade de mim, ouve a minha prece!"
,"3":"Ó homens, até quando ultrajareis a minha honra, amando o nada e buscando a ilusão?"
,"4":"Sabei que Javé faz maravilhas pelo seu fiel: Javé ouve quando eu O invoco."
,"5":"Tremei e não pequeis. Reflecti,no silêncio do leito."
,"6":"Oferecei sacrifícios justos,e tende confiança em Javé."
,"7":"Muitos dizem: «Quem nos fará ver a felicidade?»,Javé, levanta sobre nós a luz da tua face!"
,"8":"Puseste em meu coração mais alegria,do que quando para eles transbordam o trigo e o vinho."
,"9":"Em paz me deito e logo adormeço, porque só Tu, Javé, me fazes viver tranquilo."
}`)
	CurrentBook.AddChapter(5, `{
"1":"Do mestre de canto. Para flautas. Salmo. De David."
,"2":"Javé, escuta as minhas palavras, leva em conta o meu gemido."
,"3":"Ouve atento o meu grito por socorro, meu Rei e meu Deus!,É a Ti que eu suplico, Javé!"
,"4":"Pela manhã ouves a minha voz; pela manhã Te apresento a minha causa, e fico à espera..."
,"5":"Tu não és um Deus que ame a injustiça. o malvado não é teu hóspede."
,"6":"Não, os arrogantes não se mantêm,na tua presença. Odeias todos os malfeitores"
,"7":"e destróis os mentirosos. Javé rejeita o homem sanguinário e traiçoeiro."
,"8":"Quanto a mim, pelo teu grande amor, eu entro em tua casa. Cheio de temor, eu me prostro,voltado para o teu sagrado santuário."
,"9":"Guia-me, Javé, com a tua justiça, por causa dos que me espreitam. Endireita na minha frente o teu caminho!"
,"10":"Pois eles não falam com sinceridade, e o seu íntimo está cheio de maquinações. A sua garganta é um túmulo aberto,e a sua língua é aduladora."
,"11":"Declara-os culpados, ó Deus. Que os seus planos fracassem!,Expulsa-os pelos seus crimes numerosos, porque se revoltam contra Ti."
,"12":"Fiquem alegres todos os que se abrigam em Ti, e rejubilem para sempre. Tu os proteges, e em Ti exultam,os que amam o teu nome."
,"13":"Pois Tu, Javé, abençoas o justo, o teu favor protege-o como escudo."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Do mestre de canto. Com instrumentos de corda. Sobre a oitava. Salmo. De David."
,"2":"Javé, não me castigues com a tua ira, não me corrijas com o teu furor!"
,"3":"Piedade, Javé, que eu desfaleço!,Javé, cura-me, pois os meus ossos tremem."
,"4":"Todo o meu ser estremece... E Tu, Javé, até quando?"
,"5":"Volta-Te, Javé! Liberta-me!,Salva-me, por teu amor!"
,"6":"Pois na morte ninguém se lembra de Ti, quem Te louvaria no túmulo?"
,"7":"Sinto-me esgotado de tanto gemer, e de noite choro na cama, banhando o meu leito com lágrimas."
,"8":"Os meus olhos derretem-se de dor, envelhecem de tantas contradições."
,"9":"Afastai-vos de mim, todos vós, malfeitores: Javé ouviu o meu soluço!"
,"10":"Javé ouviu o meu pedido, Javé acolheu a minha prece."
,"11":"Envergonhai-vos, todos os meus inimigos, retirai-vos depressa, cheios de vergonha!"
}`)
	CurrentBook.AddChapter(7, `{
"1":"Lamentação. De David. Cantou-a a Javé, a propósito de Cuch, o benjaminita."
,"2":"Javé, meu Deus, eu me abrigo em Ti!,Salva-me de todos os meus perseguidores!,Liberta-me!"
,"3":"Que não me apanhem, como um leão, e me estraçalhem, e ninguém me liberte!"
,"4":"Javé, meu Deus, se eu fiz alguma coisa... se cometi alguma injustiça,"
,"5":"se paguei com o mal a quem me fez o bem, se poupei sem razão a quem me oprimiu,"
,"6":"que o inimigo me persiga e alcance!,Que me pise vivo por terra,e aperte o meu ventre contra a poeira!"
,"7":"Levanta-te, Javé, com a tua ira!,Ergue-Te contra o abuso dos meus opressores!,Acorda, meu Deus!,Decreta um julgamento!"
,"8":"Que a assembleia dos povos Te cerque; senta-Te sobre ela, no mais alto."
,"9":"-Javé é o juiz dos povos. -,Julga-me, Javé, conforme a minha justiça,e segundo a minha inocência."
,"10":"Põe fim à maldade dos injustos,e apoia o justo, pois Tu sondas corações e rins, ó Deus justo!"
,"11":"Quem me protege é Deus, que salva os corações rectos."
,"12":"Deus é um justo juiz, Deus ameaça a cada dia."
,"13":"Se não se convertem, Ele afia a espada, estica o arco e aponta;"
,"14":"prepara as suas armas que matam, aponta as suas flechas de fogo."
,"15":"Vede: o injusto concebeu a injustiça, está prenhe de ganância,e dá à luz a mentira."
,"16":"Ele cava e aprofunda um buraco, e acaba por cair na cova que fez!"
,"17":"A sua ganância volta-se contra ele, a sua violência recai-lhe na cabeça!"
,"18":"Eu agradeço a Javé pela sua justiça, e canto ao nome de Javé Altíssimo."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Do mestre de canto. Sobre a harpa de Gat. Salmo. De David."
,"2":"Javé, Senhor nosso, como é poderoso o teu Nome,em toda a Terra!,Exaltaste a tua majestade acima do céu."
,"3":"Da boca de crianças e bebés,tiraste um louvor contra os teus adversários, para reprimir o inimigo e o vingador."
,"4":"Quando contemplo o céu, obra dos teus dedos, a Lua e as estrelas que fixaste..."
,"5":"O que é o homem, para dele te lembrares?,O ser humano, para que o visites?"
,"6":"Tu o fizeste pouco menos do que um deus, e o coroaste de glória e esplendor."
,"7":"Tu o fizeste reinar sobre as obras das tuas mãos, e sob os pés dele tudo colocaste:"
,"8":"ovelhas e bois, todos eles, e as feras do campo também;"
,"9":"as aves do céu e os peixes do oceano, que percorrem as sendas dos mares."
,"10":"Javé, Senhor nosso, como é poderoso o teu Nome,em toda a Terra!"
}`)
	CurrentBook.AddChapter(9, `{
"1":"Do mestre de canto. Para oboé e harpa. Salmo. De David."
,"2":"Javé, eu Te agradeço de todo o coração, proclamando todas as tuas maravilhas!"
,"3":"Eu me alegro e exulto em Ti, e toco ao teu Nome, ó Altíssimo!"
,"4":"Os meus inimigos voltam atrás, tropeçam e desaparecem da tua presença."
,"5":"Porque defendeste a minha causa e direito: sentaste-Te em teu trono como justo juiz."
,"6":"Ameaçaste as nações, destruíste o injusto, para todo o sempre apagaste o seu nome."
,"7":"O inimigo acabou, em ruínas para sempre, arrasaste as cidades, e a lembrança dele desapareceu."
,"8":"Eis que Javé Se sentou para sempre, firmou o seu trono para o julgamento."
,"9":"Ele julga o mundo com justiça,e governa os povos com rectidão."
,"10":"Que Javé seja fortaleza para o oprimido, fortaleza nos tempos de angústia."
,"11":"Em Ti confiam os que conhecem o teu Nome, pois não abandonas os que Te procuram, Javé."
,"12":"Tocai para Javé, que habita em Sião; contai entre os povos as suas façanhas:"
,"13":"Ele vinga o sangue derramado, Ele lembra-Se, e não Se esquece jamais do clamor dos pobres."
,"14":"Piedade, Javé! Olha a minha aflição!,Levanta-me das portas da morte,"
,"15":"para que eu proclame os teus louvores, e exulte com a tua salvação,junto às portas da capital de Sião!"
,"16":"Os povos caíram na cova que fizeram, no laço que ocultaram prenderam o pé."
,"17":"Javé apareceu a fazer justiça, apanhou o injusto na sua manobra."
,"18":"Que os injustos voltem ao túmulo, os povos todos que se esquecem de Deus!"
,"19":"Pois o indigente não será esquecido para sempre, e a esperança dos pobres jamais se frustrará."
,"20":"Levanta-Te, Javé, que o mortal não triunfe!,Que os povos sejam julgados na tua presença!"
,"21":"Infunde neles o medo, Javé: saibam os povos que são homens mortais!"
}`)
	CurrentBook.AddChapter(10, `{
"1":"Javé, porque ficas longe, e Te escondes no tempo da angústia?"
,"2":"A soberba do injusto persegue o infeliz. Fiquem presos nas tramas que planearam!"
,"3":"O injusto gloria-se da própria ambição, o avarento maldiz e despreza a Javé!"
,"4":"O injusto é soberbo, nunca investiga, -«Deus não existe!»- é tudo o que pensa."
,"5":"As suas empresas sempre têm sucesso. As tuas normas estão longe da sua mente, e ele desafia todos os adversários."
,"6":"E pensa: «Eu sou inabalável!,Jamais cairei na desgraça»."
,"7":"Fraude e astúcia enchem-lhe a boca, sob a sua língua existe maldade e opressão."
,"8":"Fica de emboscada entre os juncos, e massacra o inocente às escondidas. Com os olhos ele espreita o inocente."
,"9":"Arma ciladas às escondidas, como leão no covil, ele embosca-se para apanhar o pobre: agarra o pobre e arrasta-o na sua rede."
,"10":"Ele espreita, agacha-se, encurva-se, e o indefeso cai em seu poder."
,"11":"E pensa: «Deus esquece-Se, e cobre a face para não ver até ao fim!»"
,"12":"Levanta-Te, Javé! Ergue a tua mão!,Não Te esqueças dos pobres!"
,"13":"Por que motivo o injusto desprezaria a Deus, pensando que não investigas?"
,"14":"Mas Tu vês a fadiga e o sofrimento, e observas para os tomares na mão: a Ti se abandona o indefeso,para o órfão Tu és um socorro."
,"15":"Quebra o braço do injusto e do malvado,e procura a sua maldade: não a encontras!"
,"16":"Javé é rei para sempre e eternamente. Os pagãos desapareceram do país."
,"17":"Javé, Tu ouves o desejo dos pobres, fortaleces-lhes o coração e dás-lhes ouvidos,"
,"18":"fazendo justiça ao órfão e ao oprimido, para que o homem terreno,já não infunda terror."
}`)
	CurrentBook.AddChapter(11, `{
"1":"Do mestre de canto. De David. Eu abrigo-me em Javé. Porque vós dizeis-me: «Foge para os montes, passarinho,"
,"2":"porque os injustos retesam o arco, ajustando a flecha na corda, para atirar ocultamente contra os corações rectos."
,"3":"Quando os fundamentos se corrompem, que pode o justo fazer?»"
,"4":"Javé, porém, está no seu templo santo, Javé tem o seu trono no céu. Os seus olhos contemplam o mundo, as suas pupilas examinam os homens."
,"5":"Javé examina o justo e o injusto, Ele odeia quem ama a violência;"
,"6":"Fará chover, sobre os injustos, brasas e enxofre, e um furacão violento. É a parte que lhes cabe."
,"7":"Porque Javé é justo e ama a justiça, e os corações rectos contemplarão a sua face."
}`)
	CurrentBook.AddChapter(12, `{
"1":"Do mestre de canto. Para instrumentos de oito cordas. Salmo. De David."
,"2":"Socorro, Javé! O fiel está a desaparecer!,Desaparece a fidelidade entre os homens:"
,"3":"cada qual mente ao seu próximo,com lábios enganadores e segundas intenções."
,"4":"Que Javé corte todos os lábios enganadores, e a língua arrogante"
,"5":"dos que dizem: «A nossa força está na língua, as nossas armas são os nossos lábios,Quem poderá dominar-nos?»"
,"6":"Javé declara: «Agora levanto-Me para defender,os pobres oprimidos e os necessitados que gemem. Vou salvar quem quer ser salvo!»"
,"7":"As palavras de Javé são palavras sinceras, prata pura, sem nenhuma impureza, sete vezes refinada."
,"8":"Sim, Javé, Tu nos guardarás, livrando-nos para sempre dessa gente."
,"9":"Por toda a parte rondam os injustos, quando a corrupção é exaltada entre os homens."
}`)
	CurrentBook.AddChapter(13, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"Javé, até quando me esquecerás? Para sempre?,Até quando esconderás de mim a tua face?"
,"3":"Até quando terei sofrimento dentro de mim, e tristeza no coração, dia e noite?,Até quando o meu inimigo vai triunfar?"
,"4":"Atenção, Javé, meu Deus! Responde-me!,Ilumina os meus olhos, para que eu não adormeça na morte."
,"5":"Que o meu inimigo não diga: «Eu venci-o!»,E os meus opressores não exultem com o meu fracasso."
,"6":"Quanto a mim, eu confio no teu amor!,O meu coração exulta com a tua salvação. Vou cantar a Javé por todo o bem que Ele me fez!"
}`)
	CurrentBook.AddChapter(14, `{
"1":"Do mestre de canto. De David. O insensato diz no seu coração: «Deus não existe!»,Corromperam-se, praticando abominações: não há quem pratique o bem."
,"2":"Do céu Javé inclina-Se,sobre os filhos de Adão, para ver se restou alguém sensato, alguém que busque a Deus."
,"3":"Estão todos desviados,e obstinados também: não há quem faça o bem, não há nenhum sequer."
,"4":"Acaso esses malfeitores não percebem?,Eles devoram o meu povo, como se comessem pão, e não invocam a Javé."
,"5":"Eles vão tremer de medo, porque Deus está com os justos."
,"6":"Vós podeis confundir o plano do pobre, mas o seu abrigo é Javé."
,"7":"Oxalá venha de Sião,a salvação para Israel!,Quando Javé mudar a sorte do seu povo,Jacob exultará e Israel se alegrará."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Salmo. De David. Javé, quem poderá hospedar-se na tua tenda,e habitar no teu monte santo?"
,"2":"-Quem age na integridade,e pratica a justiça: quem diz sinceramente o que pensa"
,"3":"e não usa a língua para caluniar; quem não prejudica o seu próximo, e não difama o seu vizinho;"
,"4":"quem despreza o injusto, e honra os que temem a Javé; quem sustenta o que jurou, mesmo com seu prejuízo;"
,"5":"quem não empresta dinheiro com juros, nem aceita suborno contra o inocente. Quem age deste modo, jamais será abalado!"
}`)
	CurrentBook.AddChapter(16, `{
"1":"A meia-voz. De David. Guarda-me, ó Deus, pois eu me abrigo em Ti."
,"2":"Eu digo a Javé: «Tu és o meu bem!»"
,"3":"Os deuses e senhores da terra,não me satisfazem."
,"4":"Eles multiplicam as estátuas,de deuses estranhos. Nunca derramarei as suas libações de sangue, nem porei seus nomes em meus lábios."
,"5":"Javé, minha parte na herança e minha taça, o meu destino está em tuas mãos."
,"6":"O cordel mediu para mim um lugar delicioso, sim, a minha herança é a mais bela."
,"7":"Bendigo a Javé que me aconselha, e, mesmo durante a noite, internamente me instrui."
,"8":"Tenho Javé à minha frente sem cessar. Com Ele à minha direita, jamais vacilarei."
,"9":"Por isso o meu coração se alegra, as minhas entranhas exultam, e a minha carne repousa em segurança;"
,"10":"porque não me abandonarás no túmulo, nem deixarás o teu fiel ver a sepultura."
,"11":"Tu me ensinarás o caminho da vida, cheio de alegria na tua presença, e de delícias à tua direita, para sempre."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Prece. De David. Escuta, Javé, a minha apelação, atende ao meu clamor; dá ouvidos à minha súplica, que não sai de lábios mentirosos."
,"2":"Que a minha sentença provenha da tua face, os teus olhos vejam onde está a rectidão."
,"3":"Ainda que me sondes o coração, e de noite o examines; ainda que me proves com o fogo, malícia nenhuma encontrarás em mim. A minha boca não transgrediu"
,"4":"como costumam os homens. Conforme a palavra dos teus lábios, eu observei os caminhos prescritos:"
,"5":"os meus pés não vacilaram, os meus passos ficaram nas tuas pegadas."
,"6":"Eu clamo a Ti, porque me respondes, ó Deus!,Inclina para mim o teu ouvido, ouve a minha palavra,"
,"7":"manifesta a maravilha do teu amor, Tu que salvas dos agressores,os que se refugiam à tua direita."
,"8":"Guarda-me como a pupila dos olhos, esconde-me à sombra das tuas asas,"
,"9":"longe dos injustos que me oprimem, dos inimigos mortais que me cercam."
,"10":"Eles fecham o seu coração, a sua boca fala com arrogância;"
,"11":"os seus passos já me rodeiam, os seus olhos fitam-me para me lançarem ao chão."
,"12":"Parecem leão ávido de presa, um leãozinho agachado no covil."
,"13":"Levanta-Te, Javé! Enfrenta-os! Derruba-os!,Que a tua espada me liberte do injusto,"
,"14":"e a tua mão, Javé, os expulse da humanidade, para fora da humanidade e do mundo: seja essa a parte deles nesta vida!,Enche-lhes o ventre com o que tens de reserva: que os seus filhos fiquem saciados,e deixem as sobras para os seus pequeninos."
,"15":"Quanto a mim, com justiça verei a tua face; ao despertar, eu me saciarei com a tua imagem."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Do mestre de canto. De David, servo de Javé. Ele dirigiu a Javé as palavras deste cântico, quando Javé o libertou de todos os seus inimigos e da mão de Saul."
,"2":"Ele disse: Eu Te amo, Javé. Tu és a minha força!"
,"3":"Javé, meu rochedo, minha fortaleza, meu libertador; meu Deus, rocha minha, meu refúgio, meu escudo, força que me salva, meu baluarte!"
,"4":"Louvado sejas! Eu invoquei Javé, e fui salvo dos meus inimigos!"
,"5":"Ondas mortais me envolviam, torrentes destruidoras me aterravam,"
,"6":"cercavam-me laços mortais, as ciladas da morte me atingiam."
,"7":"Na minha aflição invoquei Javé, ao meu Deus lancei o meu grito. Do seu templo Ele ouviu a minha voz, o meu grito chegou-Lhe aos ouvidos."
,"8":"E a terra balançou e tremeu, as bases dos montes abalaram-se, estremeceram com o seu furor."
,"9":"Das suas narinas subiu o fumo,e da sua boca um fogo voraz: dela saíam brasas ardentes."
,"10":"Ele inclinou o céu e desceu, tendo aos pés uma nuvem escura;"
,"11":"Ele cavalgou um querubim, e voou, planando sobre as asas do vento."
,"12":"Das trevas fez o seu manto, águas escuras e nuvens espessas,O rodeavam como tenda."
,"13":"Com o fulgor da sua presença, as nuvens desfizeram-se em granizo e centelhas."
,"14":"Javé trovejou no céu, o Altíssimo fez ouvir a sua voz;"
,"15":"lançou as suas flechas e dispersou-os, e expulsou-os, lançando os seus raios."
,"16":"O leito do mar apareceu, as bases do mundo descobriram-se, por causa do teu estrondo, Javé, e do vento que soprava das tuas narinas."
,"17":"Do alto Ele me mandou buscar; tirou-me das águas torrenciais."
,"18":"Livrou-me de um poderoso inimigo, de adversários mais fortes do que eu."
,"19":"Atacaram-me no dia da derrota, porém Javé foi um apoio para mim."
,"20":"Ele fez-me sair para lugar espaçoso; libertou-me, porque Ele me ama."
,"21":"Javé tratou-me segundo a minha justiça, e retribuiu-me conforme a pureza das minhas mãos,"
,"22":"porque observei os caminhos de Javé, e não me rebelei contra o meu Deus."
,"23":"Os seus julgamentos estão todos à minha frente, nunca me apartei dos seus decretos;"
,"24":"Fui íntegro para com Ele,e guardei-me da injustiça."
,"25":"Javé retribuiu a minha justiça, a pureza das minhas mãos na sua presença."
,"26":"Com o fiel és fiel, com o íntegro Tu és íntegro,"
,"27":"com quem é puro Tu és puro, mas com o perverso Tu és astuto."
,"28":"Tu salvas o povo pobre,e rebaixas os olhos altivos."
,"29":"Javé, Tu és a minha lâmpada, meu Deus, Tu iluminas as minhas trevas."
,"30":"Sim, contigo eu corro ao ataque, com o meu Deus eu assalto a muralha."
,"31":"O caminho de Deus é perfeito, a palavra de Javé é comprovada. Ele é um escudo para os que n'Ele se abrigam."
,"32":"Quem é Deus, além de Javé?,E quem é rochedo, fora o nosso Deus?"
,"33":"Ele é o Deus que me cinge de força, e torna perfeito o meu caminho."
,"34":"Ele iguala os meus pés aos pés das corças,e sustenta-me firme nas alturas."
,"35":"Adestra as minhas mãos para a guerra, e o meu braço estica o arco de bronze."
,"36":"Tu me deste o teu escudo salvador, a tua direita me sustentou,e me atendeste sem parar."
,"37":"Alargaste os meus passos,e os meus tornozelos não fraquejaram."
,"38":"Persegui e alcancei os meus inimigos, e não voltei sem os ter derrotado."
,"39":"Eu derrotei-os, e não puderam levantar-se, eles caíram debaixo dos meus pés."
,"40":"Tu me cingiste com vigor para o combate,e curvaste sob mim os agressores."
,"41":"Tu entregaste-me a nuca dos inimigos, e eu exterminei os meus adversários."
,"42":"Eles gritaram, mas ninguém os socorreu. Gritaram a Javé, mas Ele não respondeu."
,"43":"Eu reduzi-os como a poeira ao vento, pisei-os como o barro das ruas."
,"44":"Tu me livraste das contendas do meu povo, e me puseste como chefe de nações; um povo desconhecido tornou-se meu vassalo."
,"45":"Os estrangeiros submetiam-se a mim, davam-me ouvidos e obedeciam-me."
,"46":"Os estrangeiros enfraqueciam-se,e saíam a tremer das suas fortalezas."
,"47":"Viva Javé! Bendito seja o meu rochedo!,Exaltado seja o meu Deus e salvador,"
,"48":"o Deus que me concedeu as vinganças,e me submeteu os povos;"
,"49":"que me livrou de inimigos furiosos, me exaltou sobre os meus agressores, e me salvou do homem cruel."
,"50":"Por isso Eu te louvo entre as nações, Javé, e toco em honra do teu Nome:"
,"51":"«Ele dá grandes vitórias ao seu rei, e age pelo seu ungido com amor, por David e sua descendência para sempre»."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"O céu manifesta a glória de Deus, e o firmamento proclama a obra das suas mãos."
,"3":"O dia passa a mensagem a outro dia, a noite sussurra-a à outra noite."
,"4":"Sem fala e sem palavras, sem que a sua voz seja ouvida,"
,"5":"a toda a Terra chega o seu eco, aos confins do mundo a sua linguagem. Lá Deus armou uma tenda para o Sol,"
,"6":"e este sai, qual esposo de seu quarto, como herói alegre, percorrendo o seu caminho."
,"7":"Ele sai de um extremo do céu, e o seu percurso vai até ao outro lado; nada escapa ao seu calor."
,"8":"A lei de Javé é perfeita, um descanso para a alma. O testemunho de Javé é firme, instrução para o ignorante."
,"9":"Os preceitos de Javé são rectos, alegria para o coração. O mandamento de Javé é transparente, é luz para os olhos."
,"10":"O temor de Javé é puro,e estável para sempre. As decisões de Javé são verdadeiras,e igualmente justas."
,"11":"São mais desejáveis do que o ouro, mais do que ouro refinado. São mais doces que o mel, que vai escorrendo dos favos."
,"12":"Com elas, também o teu servo se esclarece, e observá-las traz grande proveito."
,"13":"Quem pode discernir os próprios erros?,Purifica-me das faltas escondidas!"
,"14":"Preserva do orgulho o teu servo, para que ele nunca me domine: deste modo eu serei íntegro, inocente de uma grande transgressão."
,"15":"Que Te agradem as palavras da minha boca, e o meditar do meu coração,chegue à tua presença, Javé, minha rocha e redentor!"
}`)
	CurrentBook.AddChapter(20, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"Que Javé te responda no dia da angústia, que o nome do Deus de Jacob te proteja!"
,"3":"Que do santuário, Ele te mande socorro, e te apoie desde Sião!"
,"4":"Que Ele Se lembre de todas as tuas ofertas, e aprecie o teu holocausto!"
,"5":"Que te dê tudo o que o teu coração deseja, e realize todos os teus projectos!"
,"6":"Possamos alegrar-nos com a tua vitória, e hastear a bandeira em nome do nosso Deus!,Que Javé realize todos os teus pedidos!"
,"7":"Agora reconheço que Javé,dá a vitória ao seu ungido, e lhe responde do seu templo celeste,com os prodígios da sua mão vitoriosa."
,"8":"Uns confiam em carros, outros em cavalos; quanto a nós, invocamos o Nome,de Javé nosso Deus."
,"9":"Eles curvam-se e caem; nós mantemo-nos de pé."
,"10":"Javé, dá a vitória ao rei, e responde-nos, quando clamamos a Ti!"
}`)
	CurrentBook.AddChapter(21, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"Javé, o rei alegra-se com a tua força, e como exulta com a tua vitória!"
,"3":"Concedeste-lhe o desejo do seu coração, e não lhe negaste o pedido de seus lábios."
,"4":"Pois Tu o precedeste com grandes bênçãos, colocaste uma coroa de ouro na sua cabeça."
,"5":"Ele pediu-Te vida, e Tu lha concedeste, dias sem fim, para sempre e eternamente."
,"6":"A tua vitória engrandeceu a sua fama, tu o vestiste com honra e esplendor."
,"7":"Sim, Tu o estabeleces como bênção para sempre, e, com a tua presença, o enches de alegria."
,"8":"Sim, o rei confia em Javé, e jamais vacilará com o amor do Altíssimo."
,"9":"A tua mão alcançará todos os teus inimigos, a tua direita encontrará os teus adversários."
,"10":"Ateia-lhes o fogo como a um forno, no dia em que Te manifestares. Javé engoli-los-á com a sua ira, e um fogo os devorará."
,"11":"Extirparás da terra a sua posteridade, e a sua descendência dentre os homens."
,"12":"Ainda que pretendam o mal contra Ti,e façam planos, nada irão conseguir."
,"13":"Pois Tu os afugentarás, mirando a face deles com o teu arco."
,"14":"Levanta-te, Javé, com a tua força!,Nós vamos cantar e tocar ao teu poder."
}`)
	CurrentBook.AddChapter(22, `{
"1":"Do mestre de canto. Sobre «A corça da manhã». Salmo. De David."
,"2":"Meu Deus, meu Deus, porque me abandonaste?,Apesar dos meus gritos, a minha prece não Te alcança!"
,"3":"De dia eu grito, meu Deus, e não me respondes. Grito de noite, e não fazes caso de mim!"
,"4":"E Tu habitas no santuário, onde Israel Te louva!"
,"5":"Os nossos antepassados confiavam em Ti; confiavam, e Tu os salvavas;"
,"6":"gritavam por Ti, e ficavam livres, confiavam em Ti, e não ficaram desapontados."
,"7":"Quanto a mim, eu sou verme, e não homem, riso dos homens e desprezo do povo."
,"8":"Todos os que me vêem zombam de mim, abrem a boca e meneiam a cabeça:"
,"9":"«Ele recorreu a Javé... Pois que Javé o salve!,Que o liberte, se é que o ama de facto!»"
,"10":"És Tu quem me tirou do ventre,e me confiou aos peitos da minha mãe."
,"11":"Fui entregue a Ti desde o nascimento, desde o ventre materno Tu és o meu Deus."
,"12":"Não fiques longe de mim, que a angústia está perto, e não há ninguém para me socorrer."
,"13":"Cercam-me touros numerosos, touros fortes de Basã me rodeiam."
,"14":"Contra mim escancaram a boca,os leões que dilaceram e rugem."
,"15":"Estou como água derramada, e todos os meus ossos se desconjuntam. O meu coração está como cera, derretendo-se dentro de mim."
,"16":"A minha força secou como argila, e a minha língua colou-se ao maxilar. Tu me colocas na poeira da morte."
,"17":"Cães numerosos me rodeiam, e um bando de malfeitores me envolve, furando as minhas mãos e os meus pés."
,"18":"Posso contar todos os meus ossos. As pessoas observam-me e encaram-me,"
,"19":"entre si repartem as minhas vestes, e sorteiam a minha túnica."
,"20":"Tu, porém, Javé, não fiques longe!,Força minha, vem socorrer-me depressa!"
,"21":"Salva o meu pescoço da espada, e a minha pessoa, das patas do cão!"
,"22":"Arranca-me da goela do leão, faz-me triunfar dos chifres do búfalo!"
,"23":"Vou contar a tua fama aos meus irmãos, vou louvar-Te no meio da assembleia:"
,"24":"«Vós que temeis a Javé, louvai a Javé!,Glorifica-O, descendência toda de Jacob!,Teme-O, descendência toda de Israel!»"
,"25":"Sim, porque Ele não desprezou, não desdenhou a desgraça do pobre, nem lhe ocultou a sua face: quando gritou por socorro, Ele o escutou."
,"26":"De Ti vem o meu louvor na grande assembleia. Cumprirei os meus votos na presença dos que O temem."
,"27":"Os pobres comerão e ficarão saciados, louvarão a Javé aqueles que O buscam: «Que o vosso coração viva para sempre!»"
,"28":"Todos os confins da terra se lembrarão, e voltarão para Javé. Todas as famílias das nações,se prostrarão na sua presença."
,"29":"Pois a realeza pertence a Javé, é Ele quem governa as nações."
,"30":"Diante d'Ele se prostrarão as cinzas da tumba, diante d'Ele se curvarão os que descem ao pó."
,"31":"Javé far-me-á viver para Ele, a minha descendência O servirá, falará do Senhor à geração futura,"
,"32":"contará a sua justiça ao povo que vai nascer: é obra do Senhor!"
}`)
	CurrentBook.AddChapter(23, `{
"1":"Salmo. De David. Javé é o meu pastor. Nada me falta."
,"2":"Em verdes pastagens me faz repousar; para fontes tranquilas me conduz,"
,"3":"e restaura as minhas forças. Ele me guia por bons caminhos, por causa do seu nome."
,"4":"Embora eu caminhe por um vale tenebroso, nenhum mal temerei, pois estás junto a mim; o teu bastão e o teu cajado deixam-me tranquilo."
,"5":"Diante de mim preparas a mesa, à frente dos meus opressores; unges a minha cabeça com óleo, e a minha taça transborda."
,"6":"Sim, felicidade e amor me acompanham,todos os dias da minha vida. A minha morada é a casa de Javé, por dias sem fim."
}`)
	CurrentBook.AddChapter(24, `{
"1":"Salmo. De David. A Javé pertence a terra e tudo o que ela contém, o mundo e os que nele habitam."
,"2":"Ele próprio a fundou sobre os mares,e a firmou sobre os rios."
,"3":"-Quem pode subir à montanha de Javé?,Quem pode estar no seu lugar santo?"
,"4":"-Aquele que tem mãos inocentes,e coração puro, que não confia nos ídolos, nem faz juramento para enganar."
,"5":"Esse receberá a bênção de Javé, e do seu Deus salvador receberá a justiça."
,"6":"-Esta é a geração dos que procuram Javé, dos que buscam a tua face, ó Deus de Jacob."
,"7":"Portas, levantai os vossos frontões; elevai-vos, portais antigos, pois vai entrar o Rei da glória!"
,"8":"-Quem é esse Rei da glória?,-É Javé, o herói valoroso!,É Javé, o herói das guerras!"
,"9":"Portas, levantai os vossos frontões; elevai-vos, portais antigos, pois vai entrar o Rei da glória!"
,"10":"-Quem é esse Rei da glória?,-É Javé dos Exércitos!,Ele é o Rei da glória!"
}`)
	CurrentBook.AddChapter(25, `{
"1":"De David. A Ti, Javé, elevo a minha alma."
,"2":"Em Ti confio, meu Deus. Que eu não fique envergonhado, e os meus inimigos não triunfem sobre mim!"
,"3":"Os que em Ti esperam não ficam envergonhados; ficam envergonhados todos os traidores."
,"4":"Mostra-Me os teus caminhos, Javé, ensina-me as tuas veredas."
,"5":"Guia-me com a tua verdade. Ensina-me, pois Tu és o meu Deus salvador, e em Ti espero durante todo o dia."
,"6":"Javé, lembra-Te da tua compaixão,e do teu amor, que existem desde sempre."
,"7":"Não Te lembres dos meus desvios, nem dos pecados da minha juventude. Lembra-Te de mim, conforme o teu amor, por causa da tua bondade, Javé."
,"8":"Javé é bondade e rectidão, e aponta o caminho aos pecadores."
,"9":"Ele encaminha os pobres conforme o direito, e ensina aos pobres o seu caminho."
,"10":"As veredas de Javé são todas amor e verdade, para os que guardam a sua aliança e os seus preceitos."
,"11":"Javé, por causa do teu Nome, perdoa a minha falta, que é grande."
,"12":"Existe alguém que teme a Javé?,Javé instrui-o sobre o caminho a seguir:"
,"13":"Ele viverá feliz, e a sua descendência possuirá a Terra."
,"14":"O segredo de Javé revela-se aos que O temem, e dá-lhes a conhecer a sua aliança."
,"15":"Os meus olhos estão sempre voltados para Javé, pois Ele tira da armadilha os meus pés."
,"16":"Volta-Te para mim, tem piedade de mim, pois estou solitário e infeliz."
,"17":"Alivia as angústias do meu coração, tira-me das minhas aflições."
,"18":"Olha para a minha fadiga e miséria, e perdoa todos os meus pecados."
,"19":"Vê os meus inimigos que se multiplicam,e me detestam com ódio mortal."
,"20":"Guarda-me a vida! Liberta-me!,Que eu não fique envergonhado,por me abrigar em Ti!"
,"21":"Que a integridade e rectidão me preservem, pois em Ti espero, Javé!"
,"22":"Ó Deus, resgata Israel,de todas as suas angústias!"
}`)
	CurrentBook.AddChapter(26, `{
"1":"De David. Faz-me justiça, Javé, pois eu sou íntegro, e confio em Javé, sem fraquejar."
,"2":"Examina-me, Javé, e põe-me à prova, depura os meus rins e o meu coração:"
,"3":"eu tenho diante dos olhos o teu amor, e ando na tua fidelidade."
,"4":"Não me sento com impostores, nem caminho com hipócritas."
,"5":"Detesto a assembleia dos maus, e não me sento com injustos."
,"6":"Na inocência lavo as minhas mãos,e rodeio o teu altar, Javé,"
,"7":"proclamando acção de graças,e contando todas as tuas maravilhas."
,"8":"Javé, eu amo a beleza da tua casa,e o lugar onde reside a tua glória."
,"9":"Não me juntes aos pecadores, nem a minha vida aos assassinos:"
,"10":"eles têm a infâmia nas mãos, a sua direita está cheia de subornos."
,"11":"Quanto a mim, eu ando na integridade. Resgata-me, tem piedade de mim!"
,"12":"O meu pé está firme no caminho recto. Javé, eu Te bendigo nas assembleias."
}`)
	CurrentBook.AddChapter(27, `{
"1":"De David. Javé é a minha luz e salvação: de quem terei medo?,Javé é a fortaleza da minha vida: frente a quem tremerei?"
,"2":"Quando os malfeitores avançam contra mim,para devorar a minha carne, são eles, meus adversários e inimigos, que tropeçam e caem."
,"3":"Que um exército acampe contra mim!,O meu coração não tremerá!,Ainda que uma guerra se levante contra mim, mesmo assim estarei confiante!"
,"4":"Uma coisa peço a Javé, e só ela procuro: é habitar na casa de Javé,todos os dias da minha vida, para gozar a doçura de Javé,e contemplar o seu Templo."
,"5":"Pois Ele oculta-me na sua tenda, no dia da infelicidade; Ele esconde-me no segredo da sua tenda, e eleva-me sobre uma rocha."
,"6":"Agora a minha cabeça se levanta,sobre os inimigos que me cercam. Na tenda de Javé vou oferecer,sacrifícios de aclamação. vou cantar, vou tocar,em honra de Javé!"
,"7":"Javé, escuta o meu grito de apelo, tem piedade, responde-me!"
,"8":"Ouço no meu coração: «Procurai a minha face!»,-É a tua face que eu procuro, Javé."
,"9":"Não me escondas a tua face. Não afastes o teu servo com ira, pois Tu és o meu socorro!,Não me deixes, não me abandones, Deus meu salvador!"
,"10":"meu pai e minha mãe abandonaram-me. Javé, porém, acolhe-me!"
,"11":"Ensina-me o teu caminho, Javé!,Guia-me pela vereda plana, por causa daqueles que me espreitam."
,"12":"Não me entregues à vontade dos meus adversários, pois contra mim falsas testemunhas se levantam, respirando violência."
,"13":"Espero ver a bondade de Javé,na terra dos vivos."
,"14":"-Espera em Javé, sê firme!,Fortalece o teu coração, e confia em Javé!"
}`)
	CurrentBook.AddChapter(28, `{
"1":"De David. A Ti, Javé, eu clamo. Rocha minha, não sejas surdo para mim. Que o teu silêncio não me torne semelhante,aos que descem à cova."
,"2":"Ouve a minha voz suplicante,quando eu grito para Ti, quando eu levanto as mãos,para o teu santuário."
,"3":"Não me arrastes com os injustos, nem com os malfeitores. Eles falam de paz com o seu próximo, mas têm o mal no coração."
,"4":"Trata-os conforme as suas obras, segundo a malícia dos seus actos!,Dá-lhes conforme a obra das suas mãos, paga-lhes o salário devido!"
,"5":"Eles não entendem os actos de Javé, nem as obras das suas mãos. Que Ele os arrase e não os reconstrua!"
,"6":"Seja bendito Javé, pois Ele escutou,a minha voz suplicante!"
,"7":"Javé é minha força e meu escudo, n'Ele confia o meu coração. Eu fui socorrido, a minha carne refloresce, e de todo o coração eu Lhe agradeço."
,"8":"Javé é a força do seu povo, a fortaleza que salva o seu ungido."
,"9":"Salva o teu povo! Abençoa a tua herança!,Apascenta-os e condu-los para sempre!"
}`)
	CurrentBook.AddChapter(29, `{
"1":"Salmo. De David. Filhos de Deus, aclamai a Javé, aclamai a glória e o poder de Javé."
,"2":"Aclamai a glória do Nome de Javé, adorai a Javé no seu átrio sagrado!"
,"3":"A voz de Javé sobre as águas, o Deus da glória troveja, Javé sobre as águas torrenciais."
,"4":"A voz de Javé com poder, a voz de Javé no esplendor!"
,"5":"A voz de Javé despedaça os cedros, Javé despedaça os cedros do Líbano,"
,"6":"faz pular o Líbano como um bezerro,e o Sarion como um novilho."
,"7":"A voz de Javé lança línguas de fogo,"
,"8":"a voz de Javé sacode o deserto, Javé sacode o deserto de Cades!"
,"9":"A voz de Javé retorce os carvalhos,e descasca as florestas. E, no seu Templo, um só grito: «Glória!»"
,"10":"Javé senta-Se sobre o dilúvio, Javé sentou-Se. É rei para sempre!"
,"11":"Javé fortifica o seu povo, Javé abençoa o seu povo com paz."
}`)
	CurrentBook.AddChapter(30, `{
"1":"Salmo. Cântico para a dedicação da casa. De David."
,"2":"Eu Te exalto, Javé, porque me livraste, não deixaste que os inimigos se rissem de mim."
,"3":"Javé, meu Deus, eu gritei por Ti, e Tu me curaste."
,"4":"Javé, tiraste do túmulo a minha vida, fizeste-me reviver dentre os que baixam à cova."
,"5":"Tocai para Javé, vós os seus fiéis, celebrai a sua memória sagrada."
,"6":"A sua ira dura um momento, e o seu favor a vida inteira. Pela tarde vem o pranto, e, pela manhã, gritos de alegria."
,"7":"Quanto a mim, eu dizia tranquilo: «Nunca serei abalado!»"
,"8":"Javé, o teu favor me assegurava,honra e poder, mas escondeste a tua face, e eu fiquei abalado."
,"9":"Por Ti, Javé, eu gritei, ao meu Deus eu supliquei:"
,"10":"«Que ganhas Tu com a minha morte, com a minha descida à cova?,Acaso Te louva o pó, ou proclama a tua fidelidade?"
,"11":"Javé, escuta-me, e tem piedade de mim!,Sê o meu socorro, Javé!»"
,"12":"Transformaste o meu luto em dança, e as minhas vestes de luto em vestes de festa."
,"13":"Por isso, o meu ser canta para Ti, e jamais se calará. Javé, meu Deus, eu Te louvarei para sempre."
}`)
	CurrentBook.AddChapter(31, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"Javé, eu me abrigo em Ti: que eu nunca fique envergonhado. Salva-me, por tua justiça!"
,"3":"Inclina os teus ouvidos para mim!,Vem depressa libertar-me!,Sê para mim um rochedo forte, uma fortaleza que me salve;"
,"4":"pois o meu rochedo e muralha és Tu: guia-me pelo teu nome, conduz-me!"
,"5":"Tira-me da rede que me armaram, pois Tu és a minha fortaleza."
,"6":"Nas tuas mãos entrego o meu espírito. Resgata-me, Javé Deus!"
,"7":"Tu detestas os que adoram ídolos vazios. Quanto a mim, eu confio em Javé."
,"8":"Dançarei de alegria com o teu amor, pois viste a minha miséria, soubeste da opressão contra mim."
,"9":"Não me entregaste nas mãos do inimigo, firmaste os meus pés em lugar espaçoso."
,"10":"Tem piedade de mim, Javé, pois estou oprimido. A dor me consome os olhos, a garganta e as entranhas."
,"11":"Eis que a minha vida se consome em tristeza,e os meus anos em gemidos; o meu vigor enfraquece-se com a miséria, e os meus ossos consomem-se."
,"12":"Para todos os meus opressores,já me tornei um escândalo; um nojo, para os meus vizinhos, um terror, para os meus amigos. Os que me vêem na rua, fogem para longe de mim."
,"13":"Fui esquecido como um morto, e estou como um objecto perdido."
,"14":"Ouço as calúnias de muitos, e o pavor me envolve!,Eles conspiram juntos contra mim, e tramam tirar-me a vida."
,"15":"Quanto a mim, Javé, eu confio em Ti, e digo: «Tu és o meu Deus!»"
,"16":"Nas tuas mãos está o meu destino: liberta-me dos inimigos que me perseguem!"
,"17":"Faz brilhar a tua face sobre o teu servo. Salva-me, por teu amor!"
,"18":"Javé, que eu não me envergonhe de Te invocar; envergonhados fiquem os injustos, fiquem reduzidos ao silêncio do túmulo!"
,"19":"Emudeçam os lábios mentirosos,que proferem insolências contra o justo, com soberba e desprezo!"
,"20":"Como é grande a tua bondade, Javé!,Tu a reservas para os que Te temem, e a concedes aos que em Ti se abrigam, diante de todos os homens."
,"21":"Tu os escondes onde escondes a tua face, longe das intrigas humanas. Tu os ocultas na tua tenda, longe das línguas que discutem."
,"22":"Seja bendito Javé!,Ele fez por mim maravilhas de amor,na cidade fortificada."
,"23":"Quanto a mim, na minha ânsia eu dizia: «Fui excluído para longe dos teus olhos!»,Tu, porém, ouviste a minha voz suplicante, quando eu gritei por Ti."
,"24":"Amai a Javé, todos os seus fiéis!,Javé preserva os que são leais, mas retribui com juros,a quem age com soberba."
,"25":"Sede firmes, fortalecei o coração, todos vós que esperais em Javé!"
}`)
	CurrentBook.AddChapter(32, `{
"1":"De David. Poema. Feliz aquele cuja ofensa é absolvida, cujo pecado é coberto."
,"2":"Feliz o homem a quem Javé,não aponta nenhum delito."
,"3":"Enquanto me calei, os meus ossos consumiam-se, rugindo durante todo o dia,"
,"4":"porque dia e noite a tua mão,pesava sobre mim. O meu coração tornou-se como feixe de palha,em pleno calor de Verão."
,"5":"Confessei-Te o meu pecado, não Te encobri o meu delito. Eu disse: «Vou ter com Javé,e confessar a minha culpa!»,E Tu absolveste o meu delito, perdoaste o meu pecado."
,"6":"Por isso, que todo o fiel Te suplique,no tempo da angústia: se as águas caudalosas transbordarem, jamais te atingirão."
,"7":"Tu és o meu refúgio, Tu me libertas da angústia, e me envolves com cantos de libertação."
,"8":"-Vou instruir-te e indicar o caminho a seguir. Com os olhos sobre ti, Eu serei o teu conselheiro."
,"9":"Não sejas como o cavalo ou o jumento, que não compreendem nem rédea nem freio: deve-se avançar para os domar,sem que se aproximem de ti."
,"10":"Os injustos sofrem muitos tormentos, mas o amor envolve,quem confia em Javé."
,"11":"Alegrai-vos em Javé, ó justos, e exultai. Gritai de alegria, todos os de coração recto."
}`)
	CurrentBook.AddChapter(33, `{
"1":"Exultai em Javé, ó justos!,Aos rectos convém o louvor."
,"2":"Celebrai a Javé com cítara, tocai para Ele a harpa de dez cordas."
,"3":"Cantai-Lhe um cântico novo, tocai com arte na hora da ovação!"
,"4":"Pois a palavra de Javé é recta, e todas as suas obras são verdade."
,"5":"Ele ama a justiça e o direito, e o amor de Javé enche a terra."
,"6":"O céu foi feito com a palavra de Javé, e o seu exército com o sopro da sua boca."
,"7":"Ele represa num dique as águas do mar, coloca os oceanos em reservatórios."
,"8":"Que a terra inteira tema a Javé!,Que O temam todos os habitantes do mundo!"
,"9":"Porque Ele diz e a coisa acontece, Ele ordena e ela se afirma."
,"10":"Javé desfaz o plano das nações,e frustra os projectos dos povos."
,"11":"O plano de Javé permanece para sempre, os projectos do seu coração, de geração em geração."
,"12":"Feliz a nação cujo Deus é Javé, o povo que Ele escolheu como herança."
,"13":"Do céu Javé contempla,e vê todos os homens."
,"14":"Da sua morada Ele observa,todos os habitantes da terra:"
,"15":"Ele formou o coração de cada um, e discerne todos os seus actos."
,"16":"O rei não se salva pelo exército numeroso, o valente não se livra pela sua grande força."
,"17":"Para salvar, o cavalo é ilusão, todo o seu vigor não ajuda a escapar."
,"18":"Javé cuida daqueles que O temem, daqueles que esperam pelo seu amor,"
,"19":"para livrar da morte a sua vida, e no tempo da fome fazê-los viver."
,"20":"Quanto a nós, esperamos em Javé. Ele é o nosso auxílio e o nosso escudo."
,"21":"N'Ele se alegra o nosso coração, no seu Nome santo confiamos."
,"22":"Javé, esteja sobre nós o teu amor, como está em Ti a nossa esperança."
}`)
	CurrentBook.AddChapter(34, `{
"1":"De David. Quando se fingiu louco diante de Abimelec, foi perseguido por ele e fugiu."
,"2":"Vou bendizer a Javé em todo o tempo, o seu louvor estará sempre na minha boca."
,"3":"Eu orgulho-me por causa de Javé: que os pobres ouçam e se alegrem."
,"4":"Repeti comigo: Javé é grande!,Juntos exaltemos o seu Nome."
,"5":"Consultei a Javé, e Ele respondeu-me, e livrou-me de todos os temores."
,"6":"Olhai para Ele e sereis felizes, o vosso rosto não ficará envergonhado."
,"7":"Este pobre gritou, Javé ouviu-o, e salvou-o de todas as dificuldades."
,"8":"O anjo de Javé acampa,ao redor dos que O temem, e liberta-os."
,"9":"Provai e vede como Javé é bom: feliz o homem que n'Ele se abriga."
,"10":"Teme a Javé, povo a Ele consagrado, pois nada falta aos que O temem."
,"11":"Os ricos empobrecem e passam fome, mas nada falta aos que buscam Javé."
,"12":"Filhos, aproximai-vos e escutai-Me: vou ensinar-vos o temor de Javé."
,"13":"Qual de vós não deseja a vida?,Qual não quer vida longa para prosperar?"
,"14":"Então guardai a língua de falar mal,e os lábios de dizer mentiras."
,"15":"Evitai o mal e praticai o bem, e não cesseis de procurar a paz."
,"16":"Javé cuida sempre dos justos, e ouve atentamente os seus clamores."
,"17":"Javé enfrenta os malfeitores,e apaga da terra a sua lembrança."
,"18":"Os justos gritam, Javé escuta, e liberta-os de todas as aflições."
,"19":"Javé está perto dos corações feridos; e salva os que estão desanimados."
,"20":"O justo sofre muitas desgraças, mas de todas elas Javé o liberta;"
,"21":"Javé protege os ossos do justo: nenhum deles será quebrado."
,"22":"O mal causa a morte do injusto; os que odeiam o justo serão condenados."
,"23":"Javé resgata a vida dos seus servos, e os que n'Ele se abrigam não serão condenados."
}`)
	CurrentBook.AddChapter(35, `{
"1":"De David. Javé, acusa os meus acusadores, combate os que me combatem!"
,"2":"Toma a armadura e o escudo,e levanta-Te em meu socorro!"
,"3":"Maneja a espada e o machado,contra os meus perseguidores!,Diz à minha alma: «Eu sou a tua salvação!»"
,"4":"Fiquem envergonhados e arruinados,os que procuram tirar-me a vida!,Que voltem para trás e sejam confundidos,os que planeiam o mal contra mim!"
,"5":"Sejam como palha frente ao vento, quando o anjo de Javé os empurrar!"
,"6":"Que o seu caminho seja escuro e escorregadio, quando o anjo de Javé os perseguir!"
,"7":"Sem motivo estenderam a sua rede contra mim, e abriram para mim uma cova."
,"8":"Caia sobre eles um desastre imprevisto!,Sejam apanhados na rede que me estenderam, que eles caiam dentro da cova!"
,"9":"A minha alma exultará em Javé, e alegrar-se-á com a sua salvação."
,"10":"Todo o meu ser dirá: «Javé, quem é igual a Ti, para livrar o fraco do mais forte, e o pobre e indigente do seu explorador?»"
,"11":"Levantaram-se testemunhas falsas,e interrogaram-me sobre o que não sei."
,"12":"Pagaram o bem com o mal,e deixaram-me desamparado."
,"13":"Quanto a mim, quando eles estavam doentes,eu vestia-me com pano de saco, humilhava-me com jejum,e por dentro repetia a minha oração."
,"14":"Como por um amigo, um irmão, eu ia e vinha, cabisbaixo e triste, como de luto por minha mãe."
,"15":"E quando eu tropecei, eles alegraram-se, reuniram-se contra mim, e atacaram-me de surpresa. Dilaceravam-me sem parar,"
,"16":"zombavam cruelmente de mim, rangendo os dentes de ódio."
,"17":"Javé, quando verás isto?,Defende a minha vida diante dos que rugem; defende desses leõezinhos o meu único bem."
,"18":"Eu Te agradecerei na grande assembleia, eu Te louvarei entre a multidão do povo."
,"19":"Que não se alegrem à minha custa,os meus inimigos traidores. Que não pisquem os olhos,aqueles que me odeiam sem motivo!"
,"20":"Pois eles nunca falam de paz: contra os pacíficos da terra,eles planeiam calúnias."
,"21":"Escancaram contra mim a sua boca, dizendo com desprezo: «Nós vimo-lo com os nossos olhos!»"
,"22":"Viste isto, Javé! Não Te cales!,Javé, não Te afastes de mim!"
,"23":"Desperta! Levanta-te pelo meu direito, por minha causa, meu Senhor e meu Deus!"
,"24":"Julga-me segundo a tua justiça, Javé meu Deus. Que eles não se alegrem à minha custa!"
,"25":"Que não pensem: «Viva a nossa garganta!»,Que não digam: «Nós engolimo-lo!»"
,"26":"Fiquem envergonhados e frustrados,os que se alegram com a minha desgraça!,Fiquem cobertos de vergonha e confusão,os que se engrandecem à minha custa."
,"27":"Cantem e alegrem-se,os que desejam a minha justiça, e repitam sempre: «Javé é grande!,Ele deseja a paz para o seu servo!»"
,"28":"E a minha língua proclamará a tua justiça, e o teu louvor durante todo o dia!"
}`)
	CurrentBook.AddChapter(36, `{
"1":"Do mestre de canto. Do servidor de Javé. De David."
,"2":"O injusto ouve um oráculo pecaminoso,dentro do seu coração: «Não tenho medo de Deus, nem da sua presença!»"
,"3":"Ele vê-se com um olho tão enganador,que não descobre, nem detesta o seu pecado."
,"4":"As palavras da sua boca são maldade e mentira, ele renunciou ao bom senso de fazer o bem."
,"5":"No seu leito premedita a fraude, obstina-se no mau caminho,e nunca reprova o mal."
,"6":"Javé, o teu amor chega até ao céu, e a tua verdade chega até às nuvens."
,"7":"A tua justiça é como as altas montanhas, e os teus julgamentos como o grande oceano."
,"8":"Socorres homens e animais. Ó Deus, como é precioso o teu amor!,Os homens abrigam-se,à sombra das tuas asas."
,"9":"Fartam-se com a gordura da tua casa, e Tu os embriagas com um rio de delícias."
,"10":"Pois em Ti se encontra a fonte da vida,e com a tua luz nós vemos a luz."
,"11":"Conserva o teu amor pelos que Te conhecem, e a tua justiça para os corações rectos."
,"12":"Que me não calque o pé do soberbo, e a mão dos injustos não me expulse."
,"13":"Os malfeitores fracassaram, caíram, e já não podem levantar-se."
}`)
	CurrentBook.AddChapter(37, `{
"1":"De David. Não te irrites por causa dos maus, nem tenhas inveja dos injustos."
,"2":"Eles são como a erva: secam depressa, murcham logo como a relva."
,"3":"Confia em Javé e pratica o bem, habita na Terra e vive tranquilo."
,"4":"Coloca em Javé o teu prazer, e Ele te dará o que o teu coração deseja."
,"5":"Entrega o teu caminho a Javé, confia n'Ele, e Ele agirá."
,"6":"Ele manifestará a tua justiça,e o teu direito como o meio-dia."
,"7":"Descansa em Javé e n'Ele espera, não te irrites com os que triunfam, com o homem que usa de intrigas."
,"8":"Deixa a ira, abandona o furor, não te irrites: só farias o mal."
,"9":"Porque os maus vão ser excluídos, e os que esperam em Javé,possuirão a Terra."
,"10":"Mais um pouco, e não haverá nenhum injusto; caso o procures, não o encontrarás."
,"11":"Mas os pobres vão possuir a Terra,e deleitar-se com paz abundante."
,"12":"O injusto faz intrigas contra o justo, e contra ele range os dentes."
,"13":"Mas o Senhor ri às custas do injusto, pois vê que o seu dia está a chegar."
,"14":"Os injustos desembainham a espada,e retesam o arco para matar o pobre e o indigente, para assassinar o homem recto;"
,"15":"mas a espada atravessar-lhes-á o coração, e os seus arcos quebrar-se-ão."
,"16":"Vale mais o pouco do justo,que a riqueza de muitos injustos,"
,"17":"porque os braços do injusto serão quebrados, enquanto o apoio dos justos é Javé."
,"18":"Javé conhece os dias dos íntegros, e a sua herança permanece para sempre;"
,"19":"não se envergonharão nos dias da seca, e nos dias da fome ficarão saciados."
,"20":"Sim, os injustos vão perecer, os inimigos de Javé,vão murchar como a beleza dos prados, vão desfazer-se como fumo."
,"21":"O injusto pede emprestado e não devolve, mas o justo compadece-se e dá."
,"22":"Os que ele abençoar possuirão a Terra, e os que ele amaldiçoar serão excluídos."
,"23":"Javé garante os passos do homem, e compraz-Se com o seu caminho."
,"24":"Quando tropeça, não chega a cair, porque Javé o sustenta pela mão."
,"25":"Fui jovem e já estou velho, mas nunca vi um justo abandonado, nem a sua descendência mendigando pão."
,"26":"Durante todo o dia ele se compadece e empresta, e a sua descendência é uma bênção."
,"27":"Evita o mal e pratica o bem, e terás uma casa para sempre,"
,"28":"porque Javé ama o direito,e nunca abandona os seus fiéis. Os malfeitores serão para sempre destruídos, e a descendência dos injustos será eliminada."
,"29":"Os justos vão possuir a Terra, e nela habitarão para sempre."
,"30":"A boca do justo fala com sabedoria, e a sua língua explica o direito,"
,"31":"pois tem no coração a lei do seu Deus, e os seus passos nunca vacilam."
,"32":"O injusto espreita o justo,e procura levá-lo à morte."
,"33":"Javé porém, não o entrega nas mãos do injusto,e no julgamento não deixa que o condene."
,"34":"Espera em Javé e observa o seu caminho; Ele te exaltará, para que possuas a Terra, e verás os injustos eliminados."
,"35":"Eu vi um injusto cheio de poder, que prosperava como cedro frondoso."
,"36":"Voltei a passar, e já não existia; procurei-o, e não o pude encontrar."
,"37":"Observa o íntegro, vê o homem recto: há uma posteridade para o homem pacífico."
,"38":"Mas os transgressores serão todos destruídos, e a descendência dos injustos será cortada."
,"39":"A salvação dos justos vem de Javé, que é o seu refúgio no tempo da angústia."
,"40":"Javé ajuda-os e liberta-os; vai livrá-los dos injustos e salvá-los, porque os justos n'Ele se abrigam."
}`)
	CurrentBook.AddChapter(38, `{
"1":"Salmo. De David. Para comemorar."
,"2":"Javé, não me castigues com a tua cólera, não me corrijas com o teu furor."
,"3":"Em mim se cravaram as tuas flechas, sobre mim abateu-se a tua mão."
,"4":"Por causa da tua ira, nada no meu corpo está intacto; nada está inteiro nos meus ossos, por causa do meu pecado."
,"5":"As minhas culpas ultrapassaram a minha cabeça, e pesam sobre mim, como um fardo pesado;"
,"6":"as minhas chagas estão podres e supuram, por causa da minha insensatez."
,"7":"Estou encurvado e encolhido, e ando entristecido o dia inteiro."
,"8":"Os meus rins ardem de febre, não há nada intacto no meu corpo."
,"9":"Estou fraco e completamente esmagado. O meu coração rosna, eu solto rugidos."
,"10":"Senhor, todo o meu desejo está à tua frente, e o meu gemido não se esconde de Ti."
,"11":"O meu coração palpita, as forças me abandonam, e a luz dos meus olhos,já não mora comigo."
,"12":"Amigos e companheiros afastam-se da minha praga. e os meus vizinhos ficam à distância."
,"13":"Os que atentam contra mim preparam armadilhas, os que procuram a minha ruína falam de crimes, durante todo o dia planeiam traições."
,"14":"E eu, como surdo, não escuto, fico mudo e não abro a boca."
,"15":"Sou como alguém que não ouve, e que nada pode replicar."
,"16":"É por ti, Javé, que eu espero!,Senhor meu Deus, Tu me responderás!"
,"17":"Eu peço: «Que não se alegrem à minha custa, não triunfem sobre mim quando eu tropeço!»"
,"18":"Sim, já estou a ponto de cair, a minha dor está sempre à minha frente."
,"19":"Sim, eu confesso a minha culpa, e assusto-me com o meu pecado."
,"20":"Os meus inimigos mortais são poderosos, são muitos os que me odeiam sem motivo,"
,"21":"os que pagam o bem com o mal, e me acusam porque eu procuro o bem."
,"22":"Javé, não me abandones!,meu Deus, não fiques longe de mim!"
,"23":"Vem socorrer-me depressa, meu Senhor, minha salvação!"
}`)
	CurrentBook.AddChapter(39, `{
"1":"Do mestre de canto. De Iditun. Salmo. De David."
,"2":"Eu disse: «Vou vigiar a minha conduta, para não pecar com a língua; vou tapar com mordaça a minha boca, quando o injusto estiver presente»."
,"3":"Eu permaneci em silêncio. Contive-me para não falar, e a minha dor tornou-se intolerável."
,"4":"Por dentro, o coração queimava-me. Ao pensar nisto, o fogo inflamava-se. Então soltei a minha língua."
,"5":"«Mostra-me o meu fim, Javé, e qual é a medida dos meus dias, para eu saber quanto sou frágil."
,"6":"Olha: os dias que me deste são um palmo apenas, e a minha duração é um nada diante de Ti. Sim, todo o homem não passa de um vazio, todo o homem é apenas aparência."
,"7":"O homem vai e vem como sombra, e labuta por um nada: amontoa, e não sabe quem vai recolher»."
,"8":"E agora, Senhor, que posso esperar?,Em Ti se encontra a minha esperança."
,"9":"Livra-me de todas as minhas transgressões, não me deixes como ultraje para o insensato!"
,"10":"Eu calo-me e não abro a boca, pois quem vai agir és Tu!"
,"11":"Afasta de mim a tua praga, pois eu sucumbo ao ataque da tua mão!"
,"12":"Castigando o erro, Tu educas o homem, e como traça Tu róis os seus tesouros. Os homens todos são apenas um sopro!"
,"13":"Javé, ouve a minha prece!,Dá ouvido aos meus gritos!,Não fiques surdo ao meu pranto: porque sou teu hóspede, inquilino como os meus antepassados."
,"14":"Afasta de mim o teu olhar, e deixa-me respirar!,Antes que eu me vá, e deixe de existir!"
}`)
	CurrentBook.AddChapter(40, `{
"1":"Do mestre de canto. De David. Salmo."
,"2":"Esperei ansiosamente por Javé. Ele inclinou-Se para mim, e ouviu o meu grito."
,"3":"Fez-me subir da cova fatal, do pântano lodoso; colocou os meus pés sobre a rocha,e firmou os meus passos;"
,"4":"pôs na minha boca um cântico novo, um louvor ao nosso Deus. Vendo isto, muitos irão temer, e confiarão em Javé."
,"5":"Feliz é o homem,que confia em Javé!,Ele não Se volta para os soberbos, nem para os seguidores da mentira."
,"6":"Quantas maravilhas realizaste, Javé, meu Deus!,Quantos projectos em nosso favor!,Ninguém se compara a Ti!,Quero anunciá-los, falar deles, mas ultrapassam qualquer conta."
,"7":"Não queres sacrifícios, nem ofertas, mas abriste os meus ouvidos. Tu não pedes holocaustos pelo pecado."
,"8":"Então eu digo: «Aqui estou»,-como está escrito no livro -"
,"9":"«para fazer a tua vontade». meu Deus, eu quero ter a tua Lei,dentro das minhas entranhas."
,"10":"Anunciei a tua justiça,na grande assembleia, e não fechei os meus lábios: Javé, Tu bem o sabes."
,"11":"Não escondi a tua justiça dentro do coração, falei da tua fidelidade e da tua salvação; não ocultei o teu amor e a tua verdade,diante da grande assembleia."
,"12":"Quanto a Ti, Javé, não me negues,a tua compaixão; o teu amor e a tua verdade,sempre irão proteger-me."
,"13":"Porque me rodeiam desgraças,sem conta; as minhas culpas me atingem, e não posso fugir; são mais que os cabelos da minha cabeça, e o meu coração abandona-me."
,"14":"Javé, vem libertar-me, por favor!,Javé, vem depressa socorrer-me!"
,"15":"Fiquem envergonhados e confundidos,aqueles que buscam perder a minha vida!,Recuem e fiquem envergonhados,aqueles que tramam a minha desgraça!"
,"16":"Fiquem mudos de vergonha,aqueles que se riem de mim!"
,"17":"Exultem e alegrem-se contigo, todos aqueles que Te buscam!,Os que amam a tua salvação,repitam sempre: «Javé é grande!»"
,"18":"Quanto a mim, sou pobre e indigente, mas o Senhor cuida de mim. Tu és o meu auxílio e salvação. meu Deus, não demores!"
}`)
	CurrentBook.AddChapter(41, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"Feliz quem cuida do fraco e do indigente: Javé salva-o no dia infeliz."
,"3":"Javé guarda-o e mantém-no vivo, para que seja feliz na Terra, e não o entrega à vontade dos seus inimigos."
,"4":"Javé sustenta-o no leito de dor, afofa a cama em que ele definha."
,"5":"Eu dizia: «Javé, tem piedade de mim!,cura-me, porque pequei contra Ti!»"
,"6":"Os meus inimigos falam mal de mim: «Quando vai morrer e desaparecer o seu nome?»"
,"7":"Se alguém me visita, fala com fingimento, enche o coração de malícia,e, ao sair, é disso que fala."
,"8":"Os que me odeiam murmuram juntos contra mim, e, junto de mim, comentam a minha desgraça:"
,"9":"«Caiu sobre ele uma praga do inferno, está deitado e nunca mais se vai levantar!»"
,"10":"Até o meu amigo, em que eu confiava,e que comia do meu pão, foi o primeiro a trair-me."
,"11":"Tu, porém, Javé, tem piedade de mim!,Faz que eu possa levantar-me, para lhes dar o que eles merecem."
,"12":"Nisto reconhecerei que Tu me amas: se o inimigo não triunfar sobre mim."
,"13":"Quanto a mim, Tu me conservas íntegro, e me manténs para sempre na tua presença."
,"14":"Bendito sejas, Javé, Deus de Israel, desde agora e para sempre!,Ámen! Ámen!"
}`)
	CurrentBook.AddChapter(42, `{
"1":"Do mestre de canto. Poema. Dos filhos de Coré."
,"2":"Como a corça suspira pelas águas correntes, assim a minha alma anseia por Ti, ó meu Deus!"
,"3":"A minha alma tem sede de Deus, do Deus vivo: quando voltarei a ver a face de Deus?"
,"4":"As lágrimas são o meu pão, noite e dia, e durante todo o dia me perguntam: «Onde está o teu Deus?»"
,"5":"Começo a recordar as coisas,e a minha alma deterre-se dentro de mim: quando eu passava, à frente do grupo, em direcção à casa de Deus, em gritos de alegria e louvor, no barulho da festa."
,"6":"Porque te curvas, ó minha alma, gemendo dentro de mim?,Espera em Deus, eu ainda O hei-de louvar: «Salvação da minha face e meu Deus!»"
,"7":"A minha alma curva-se dentro de mim, e por isso eu me lembro de Ti, desde a terra do Jordão e do Hermon, de ti, ó pequena montanha."
,"8":"Grita um abismo a outro abismo,com o fragor das tuas cascatas; as tuas vagas todas e as tuas ondas,passaram sobre mim."
,"9":"De dia Javé envia o seu amor, e durante a noite,eu vou cantar uma prece,ao Deus da minha vida."
,"10":"Vou dizer a Deus: «Meu rochedo, porque Te esqueces de mim?,Porque devo andar pesaroso,sob a opressão do inimigo?»"
,"11":"Esmigalhando-me os ossos, os meus opressores insultam-me, perguntando durante todo o dia: «Onde está o teu Deus?»"
,"12":"Porque te curvas, ó minha alma, gemendo dentro de mim?,Espera em Deus, eu ainda O louvarei: «Salvação da minha face e meu Deus!»"
}`)
	CurrentBook.AddChapter(43, `{
"1":"Julga-me, ó Deus, defende a minha causa,contra uma nação sem piedade!,Liberta-me do homem injusto e traidor!"
,"2":"Sim, Tu és o meu Deus forte: porque me rejeitas?,Porque devo andar pesaroso,sob a opressão do inimigo?"
,"3":"Envia a tua luz e a tua verdade: elas me guiarão, e me levarão ao teu monte santo, para a tua moradia."
,"4":"Eu irei ao altar de Deus, ao Deus que me alegra. Vou exultar e celebrar-Te com a harpa, ó Deus, meu Deus!"
,"5":"Porque te curvas, ó minha alma, gemendo dentro de mim?,Espera em Deus, eu ainda O louvarei: «Salvação da minha face e meu Deus!»"
}`)
	CurrentBook.AddChapter(44, `{
"1":"Do mestre de canto. Dos filhos de Coré. Poema."
,"2":"Ó Deus, nós ouvimos com os nossos próprios ouvidos; os nossos pais nos contaram,a obra que realizaste em seus dias, nos dias de outrora."
,"3":"Tu mesmo, com a tua mão, expulsaste nações, para estabeleceres os nossos pais. Maltrataste povos, para fazer crescer os nossos pais."
,"4":"Não foi com espada que eles conquistaram a Terra, nem foi o braço deles que lhes trouxe a vitória; e sim a tua direita e o teu braço, e a luz da tua face, porque os amavas."
,"5":"Eras tu, ó meu Rei e meu Deus, que decidias a vitória de Jacob."
,"6":"Contigo agredimos os nossos opressores, pelo teu nome calcámos os nossos agressores."
,"7":"Não era no meu arco que eu confiava, nem era a minha espada que me trazia a vitória."
,"8":"Eras Tu que nos salvavas dos nossos opressores, e envergonhavas aqueles que nos odiavam."
,"9":"Em Deus nos orgulhávamos todo o dia, celebrando o teu Nome para sempre."
,"10":"Agora, porém, rejeitas-nos e envergonhas-nos, e já não acompanhas os nossos exércitos."
,"11":"Tu fazes-nos recuar frente ao opressor, e os nossos adversários saqueiam-nos à vontade."
,"12":"Tu entregas-nos como ovelhas para o matadouro, Tu dispersaste-nos entre as nações."
,"13":"Vendes o teu povo por um nada, e nada lucras com o seu preço."
,"14":"Fazes de nós o ultraje dos nossos vizinhos, divertimento e zombaria para aqueles que nos cercam."
,"15":"Fazes de nós o provérbio das nações, meneio de cabeça por entre os povos."
,"16":"A minha desonra está todo o dia à minha frente, e a vergonha cobre o meu rosto,"
,"17":"com os gritos de ultraje e de blasfémia,na presença do inimigo e vingador."
,"18":"Tudo isto nos aconteceu, e nem assim Te esquecemos, nem traímos a tua aliança."
,"19":"O nosso coração não voltou para trás, os nossos passos não se desviaram do teu caminho."
,"20":"E Tu esmagaste-nos onde vivem os chacais, e cobriste-nos com a sombra da morte."
,"21":"Se tivéssemos esquecido o nome do nosso Deus, e estendido as mãos a um deus estrangeiro,"
,"22":"será que Deus não o teria percebido, Ele que conhece os segredos do coração?"
,"23":"É por tua causa que nos matam todos os dias, e nos tratam como ovelhas para o matadouro."
,"24":"Desperta, Senhor! Porque dormes?,Acorda! Não nos rejeites mais!"
,"25":"Porque escondes a tua face, esquecendo a nossa opressão e miséria?"
,"26":"A nossa garganta afoga-se no pó!,o nosso ventre está colado ao chão!"
,"27":"Levanta-Te! Vem socorrer-nos!,Resgata-nos, pelo teu amor!"
}`)
	CurrentBook.AddChapter(45, `{
"1":"Do mestre de canto. Sobre a ária: «Os lírios...» Dos filhos de Coré. Poema. Canto de amor."
,"2":"O meu coração transborda em belo poema, eu dedico a minha obra a um rei. A minha língua é ágil pena de escritor."
,"3":"Tu és o mais belo dos homens,e a graça escorre dos teus lábios, porque Deus te abençoa para sempre."
,"4":"Prende a tua espada junto à coxa, ó valente, com majestade e esplendor."
,"5":"Cavalga vitorioso, pela causa da verdade e da justiça. Que a tua direita te ensine a fazer proezas."
,"6":"As tuas flechas são agudas, os povos rendem-se a ti, e os inimigos do rei perdem a coragem."
,"7":"O teu trono é de Deus, e permanece para sempre!,O ceptro do teu reino é ceptro de rectidão!"
,"8":"Tu amas a justiça e odeias a injustiça: por isso o Senhor teu Deus te ungiu,com perfume de festa, entre todos os teus companheiros."
,"9":"Mirra e aloés perfumam as tuas vestes, e o som das cordas te alegra,nos palácios de marfim."
,"10":"Filhas de reis saem ao teu encontro. De pé, à tua direita, está a rainha, ornada com ouro de Ofir."
,"11":"Ouve, filha, vê e inclina o teu ouvido: esquece o teu povo e a casa de teu pai,"
,"12":"pois o rei se apaixonou pela tua beleza. Prostra-te na frente dele, pois é o teu senhor!"
,"13":"A cidade de Tiro vem com os seus presentes, os povos mais ricos buscam o favor dele."
,"14":"Entra agora a princesa, belíssima, vestida com pérolas e brocados."
,"15":"Eles levam-na à presença do rei, com séquito de virgens, e as suas companheiras a seguem."
,"16":"Com júbilo e alegria a conduzem, e elas entram no palácio real."
,"17":"«Em lugar dos teus pais, virão os teus filhos, e tu os nomearás príncipes sobre toda a Terra»."
,"18":"Vou comemorar o teu nome,de geração em geração, e os povos te louvarão, para sempre e eternamente."
}`)
	CurrentBook.AddChapter(46, `{
"1":"Do mestre de canto. Dos filhos de Coré. Com oboé. Cântico."
,"2":"Deus é o nosso refúgio e a nossa força, defensor sempre alerta nos perigos."
,"3":"Por isso não tememos se a Terra vacila, se as montanhas se abalam no seio do mar;"
,"4":"se as águas do mar estrondeiam e fervem, e pela sua fúria estremecem os montes. Javé dos Exércitos está connosco, a nossa fortaleza é o Deus de Jacob!"
,"5":"O correr das águas alegra a cidade de Deus, o Altíssimo consagra a sua moradia."
,"6":"Deus está no meio dela: ela é inabalável. Deus socorre-a ao romper da manhã."
,"7":"Povos estrondeiam, reinos abalam-se, mas Ele ergue a sua voz, e a terra estremece."
,"8":"Javé dos Exércitos está connosco, a nossa fortaleza é o Deus de Jacob!"
,"9":"Vinde ver os actos de Javé, os assombros que Ele fez na Terra:"
,"10":"acaba com as guerras até aos confins do mundo, quebra os arcos, despedaça as lanças, e ateia fogo aos carros."
,"11":"«Rendei-vos e reconhecei: Eu sou Deus, mais alto que os povos, mais alto que a Terra!»"
,"12":"Javé dos Exércitos está connosco, a nossa fortaleza é o Deus de Jacob!"
}`)
	CurrentBook.AddChapter(47, `{
"1":"Do mestre de canto. Dos filhos de Coré. Salmo."
,"2":"Povos todos, batei palmas, aclamai a Deus com gritos de alegria!"
,"3":"Porque Javé Altíssimo é terrível, é o grande rei sobre toda a Terra."
,"4":"Ele submete as nações ao nosso poder, e coloca os povos debaixo dos nossos pés."
,"5":"Escolheu para nós uma herança, o orgulho de Jacob, seu amado."
,"6":"Deus sobe por entre ovações, Javé, ao toque da trombeta."
,"7":"Tocai para o nosso Deus, tocai!,Tocai para o nosso Rei, tocai!"
,"8":"Porque Deus é o rei de toda a terra: tocai com maestria!"
,"9":"Deus reina sobre as nações, Deus senta-Se no seu trono sagrado."
,"10":"Os príncipes dos povos aliam-se,com o povo do Deus de Abraão, porque os grandes da Terra pertencem a Deus, e Ele subiu ao lugar mais alto."
}`)
	CurrentBook.AddChapter(48, `{
"1":"Cântico. Salmo. Dos filhos de Coré."
,"2":"Javé é grande e muito louvável,na cidade do nosso Deus."
,"3":"O seu monte santo, belo em altura, alegria de toda a terra: o monte Sião, vértice do céu, cidade do grande rei."
,"4":"Entre os seus palácios, Deus mostrou-Se como fortaleza."
,"5":"Vede: os reis aliaram-se,para juntos a atacarem."
,"6":"Ao vê-la, porém, ficaram aterrados, e, apavorados, fugiram depressa;"
,"7":"Então apossou-se deles um tremor,como dores de parto,"
,"8":"como vento do deserto, que destroça,os navios de Társis."
,"9":"Conforme ouvimos, assim também o vimos,na cidade de Javé dos Exércitos, na cidade do nosso Deus: Deus estabeleceu-a para sempre!"
,"10":"Ó Deus, nós meditamos o teu amor,no meio do teu templo."
,"11":"Como o teu Nome, ó Deus, também o teu louvor,atinge os limites da Terra. A tua direita está cheia de justiça:"
,"12":"o monte Sião alegra-se,e as cidades de Judá exultam, por causa dos teus julgamentos."
,"13":"Rodeai e percorrei Sião, contando as suas torres."
,"14":"Admirai as suas muralhas,e observai os seus palácios; para o contar à geração futura:"
,"15":"«Este Deus é o nosso Deus». Ele nos conduzirá por todo o sempre."
}`)
	CurrentBook.AddChapter(49, `{
"1":"Do mestre de canto. Dos filhos de Coré. Salmo."
,"2":"Escutai isto, povos todos; prestai atenção, habitantes do mundo,"
,"3":"plebeus e nobres, ricos e pobres:"
,"4":"A minha boca falará com sabedoria, e as minhas reflexões serão inteligentes."
,"5":"Vou abrir o meu ouvido a um provérbio, ao som da lira proporei o meu enigma."
,"6":"Por que motivo hei-de temer os dias maus, quando os maus me cercam e espreitam,"
,"7":"eles que confiam na sua fortuna,e se gloriam da sua riqueza imensa?"
,"8":"O homem não pode comprar o seu próprio resgate, nem pagar a Deus o preço de si mesmo."
,"9":"É tão caro o resgate da vida, que nunca bastará"
,"10":"para ele viver perpetuamente, sem nunca ver a cova."
,"11":"Vede: os sábios morrem, perecem juntamente com o imbecil e o insensato, deixando a sua fortuna para outros."
,"12":"O túmulo é a sua morada perpétua,e a sua casa, de geração em geração, embora tenham dado o seu nome às terras!"
,"13":"O homem não permanece com o seu esplendor, é como animal que perece."
,"14":"Este é o caminho dos que confiam em si, o destino dos homens satisfeitos."
,"15":"São como rebanho destinado ao túmulo: a morte é o seu pastor, vão directamente para a sepultura; a sua figura desvanece-se, e o túmulo é a sua moradia."
,"16":"Quanto a mim, ó Deus, resgata a minha vida, tira-me das garras da morte, e toma-me contigo."
,"17":"Tu não Te preocupas quando alguém enriquece, quando o luxo da sua casa se multiplica."
,"18":"Quando ele morrer, nada levará, e o seu luxo não descerá com ele."
,"19":"Enquanto vivia, ele mesmo se felicitava: «Todos te aplaudem, pois tudo te corre bem!»"
,"20":"Ele vai juntar-se aos antepassados, que nunca mais verão a luz."
,"21":"O homem rico sem inteligência,é como animal que perece!"
}`)
	CurrentBook.AddChapter(50, `{
"1":"Salmo. De Asaf. Javé, o Deus dos deuses, fala, convocando a terra, do Nascente ao Poente."
,"2":"De Sião, a formosa, Deus resplandece:"
,"3":"o nosso Deus vem, e não vai calar-Se. À sua frente, vem um fogo devorador, e, ao seu redor, tempestade violenta."
,"4":"Do alto Ele convoca céu e terra,para julgar o seu povo:"
,"5":"«Reuni junto de Mim os meus fiéis, que selaram a minha aliança com sacrifício!»"
,"6":"Que o céu proclame a sua justiça, pois o próprio Deus vai julgar."
,"7":"-«Ouve, meu povo, que Eu vou falar-te, Israel, Eu vou testemunhar contra ti. Eu sou Deus, o teu Deus!"
,"8":"Não te acuso pelos teus sacrifícios, porque os teus holocaustos estão sempre diante de Mim."
,"9":"Porém, não vou tomar nenhum novilho da tua casa, e nem sequer um cabrito dos teus currais;"
,"10":"pois são minhas todas as feras da selva, e os animais das montanhas, aos milhares."
,"11":"Conheço todos os pássaros do céu, e os rebanhos dos campos Me pertencem."
,"12":"Se Eu tivesse fome, não to diria a ti, pois o mundo é meu, e tudo o que nele existe."
,"13":"Acaso Eu comeria carne de touros, ou beberia sangue de cabritos?"
,"14":"Oferece a Deus um sacrifício de confissão, e cumpre os teus votos ao Altíssimo."
,"15":"Invoca-Me no dia da angústia: Eu te livrarei, e tu Me glorificarás»."
,"16":"Ao injusto, porém, Deus declara: «De que adianta tu recitares os meus preceitos,e teres sempre na boca a minha aliança,"
,"17":"se detestas a disciplina,e rejeitas as minhas palavras?"
,"18":"Se vês um ladrão, tu acompanha-lo,e misturas-te com os adúlteros."
,"19":"Soltas a tua boca para o mal, e os teus lábios tramam a fraude."
,"20":"Sentas-te para falar contra o teu irmão, e desonras o filho de tua mãe."
,"21":"Comportas-te assim, e Eu devo calar-Me?,Imaginas que Eu seja como tu?,Eu te acuso e coloco tudo diante dos teus olhos!»"
,"22":"Considerai isto, vós que vos esqueceis de Deus. Senão, Eu vou dilacerar-vos, e ninguém vos libertará!"
,"23":"Quem Me oferece um sacrifício de confissão,glorifica-Me; e a quem segue o bom caminho, Eu mostrarei a salvação de Deus."
}`)
	CurrentBook.AddChapter(51, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"Quando o profeta Natã foi ter com ele, após ele ter estado com Betsabeia."
,"3":"Tem piedade de mim, ó Deus, pelo teu amor!,Pela tua grande compaixão, apaga a minha culpa!"
,"4":"Lava-me da minha injustiça,e purifica-me do meu pecado!"
,"5":"Porque eu reconheço a minha culpa, e o meu pecado está sempre na minha frente;"
,"6":"pequei contra Ti, somente contra Ti, praticando o que é mau aos teus olhos. Tu és justo, portanto, ao falar, e, no julgamento, serás o inocente."
,"7":"Eis que eu nasci na culpa, e minha mãe já me concebeu pecador."
,"8":"Tu amas o coração sincero, e, no íntimo, ensinas-me a sabedoria."
,"9":"Purifica-me com o hissopo, e ficarei puro. Lava-me, e ficarei mais branco do que a neve."
,"10":"Faz-me ouvir o júbilo e a alegria, e que se alegrem os ossos que esmagaste."
,"11":"Esconde dos meus pecados a tua face, e apaga toda a minha culpa."
,"12":"Ó Deus, cria em mim um coração puro, e renova no meu peito um espírito firme."
,"13":"Não me rejeites para longe da tua face, não retires de mim o teu santo espírito."
,"14":"Devolve-me o júbilo da tua salvação, e que um espírito generoso me sustente."
,"15":"Vou ensinar os teus caminhos aos culpados, e os pecadores voltarão para Ti."
,"16":"Livra-me do sangue, ó Deus, ó Deus, meu salvador!,E a minha língua cantará a tua justiça."
,"17":"Senhor, abre os meus lábios, e a minha boca anunciará o teu louvor."
,"18":"Pois Tu não queres sacrifício, e nenhum holocausto Te agrada."
,"19":"O meu sacrifício é um espírito contrito. Um coração contrito e esmagado,Tu não o desprezas."
,"20":"Favorece Sião, por tua bondade, reconstrói as muralhas de Jerusalém."
,"21":"Então aceitarás os sacrifícios rituais, ofertas totais e holocaustos, e no teu altar se imolarão novilhos."
}`)
	CurrentBook.AddChapter(52, `{
"1":"Do mestre de canto. Poema. De David."
,"2":"Quando Doeg, o edomita, foi avisar Saul, dizendo: «David entrou em casa de Abimelec»."
,"3":"Porque te glorias com o mal,e te gabas contra o fiel?"
,"4":"Passas o dia a planear ciladas; a tua língua é navalha afiada, autora de fraudes."
,"5":"Preferes o mal, e não o bem, a mentira, e não a franqueza."
,"6":"Gostas de palavras corrosivas, ó língua fraudulenta."
,"7":"Por isso Deus te destruirá para sempre, te abaterá e te varrerá da sua tenda; arrancará as tuas raízes,do solo fértil."
,"8":"Os justos vê-lo-ão e temerão, e rirão às custas dele, dizendo:"
,"9":"«Eis o homem que não colocou,Deus como sua fortaleza. Confiou na sua grande riqueza,e fortaleceu-se com ciladas!»"
,"10":"Quanto a mim, como oliveira verdejante,na casa de Deus, é no amor de Deus que eu confio, para sempre e eternamente."
,"11":"Vou celebrar-Te para sempre, porque agiste; e diante dos teus fiéis vou proclamar o teu Nome, porque ele é bom."
}`)
	CurrentBook.AddChapter(53, `{
"1":"Do mestre de canto. Para a doença. Poema. De David."
,"2":"Diz o insensato no seu coração: «Deus não existe!»,Corromperam-se, praticando abominações: não há nem um sequer que pratique o bem."
,"3":"Do céu Deus inclina-Se,sobre os filhos de Adão, para ver se existe alguém sensato, alguém que busque a Deus."
,"4":"Todos se desviaram,e ficaram obstinados: não há quem faça o bem, nem um sequer."
,"5":"Será que os malfeitores não percebem, eles que devoram o meu povo, como se comessem pão, e não invocam a Deus?"
,"6":"Eles vão tremer de medo, porque Deus espalha os ossos do agressor, e ficarão envergonhados,porque Deus os rejeita."
,"7":"Oxalá venha de Sião,a salvação para Israel!,Quando Javé mudar a sorte do seu povo,Jacob exultará e Israel se alegrará."
}`)
	CurrentBook.AddChapter(54, `{
"1":"Do mestre de canto. Com instrumentos de corda. Poema. De David."
,"2":"Quando os zifeus foram dizer a Saul: «David está escondido entre nós»."
,"3":"Salva-me, ó Deus, pelo teu Nome!,Pelo teu poder, faz-me justiça!"
,"4":"Ouve, ó Deus, a minha prece, dá ouvidos às palavras da minha boca!"
,"5":"Os soberbos levantam-se contra mim, e os violentos perseguem a minha vida: eles não colocam Deus à sua frente."
,"6":"Porém, Deus é o meu socorro, o Senhor é quem sustenta a minha vida."
,"7":"Cai o mal sobre aqueles que me espreitam!,Aniquila-os, Javé, pela tua fidelidade!"
,"8":"Eu Te oferecerei um sacrifício espontâneo, e agradecerei ao teu Nome, porque ele é bom;"
,"9":"porque me livrou de todas as angústias, e eu contemplei a derrota dos meus inimigos."
}`)
	CurrentBook.AddChapter(55, `{
"1":"Do mestre de canto. Com instrumentos de corda. Poema. De David."
,"2":"Dá ouvidos à minha prece, ó Deus, não Te furtes à minha súplica!"
,"3":"Presta atenção e responde-me, porque as ansiedades me agitam!"
,"4":"Estremeço ante a voz do inimigo, diante dos gritos do injusto. Eles fazem recair sobre mim calamidades, e acusam-me com raiva."
,"5":"O meu coração contorce-se dentro de mim, e sobre mim caem terrores mortais;"
,"6":"medo e tremor me invadem, e um calafrio me envolve."
,"7":"Então eu penso: «Quem me dera ter asas de pomba,para poder voar e pousar..."
,"8":"Sim, eu fugiria para longe,e pernoitaria no deserto."
,"9":"Encontraria logo um refúgio,contra o vento da calúnia,"
,"10":"contra o furacão que devora, Senhor, contra a torrente da língua deles». Vejo violência e discórdia na cidade:"
,"11":"dia e noite elas rondam,por cima das suas muralhas. Dentro dela há crime e injustiça."
,"12":"Dentro dela há calamidades, e a opressão e a fraude,nunca se afastam da sua praça."
,"13":"Se um inimigo me insultasse, eu poderia suportá-lo; se o meu adversário se erguesse contra mim, eu esconder-me-ia dele."
,"14":"Mas és tu, homem igual a mim, meu amigo, meu confidente,"
,"15":"a quem me unia uma doce intimidade; andávamos juntos, no meio do barulho, na casa de Deus."
,"16":"Caia sobre eles a morte, desçam vivos ao túmulo, pois o mal se aninha entre eles!"
,"17":"Eu, porém, invoco a Deus, e Javé salva-me."
,"18":"De tarde, pela manhã e ao meio-dia,eu me queixo, gemendo. E Deus ouve o meu grito."
,"19":"Na paz Ele resgata a minha vida,da guerra que me fazem, pois são muitos contra mim."
,"20":"Deus ouve-me e humilha-os, Ele que reina desde sempre. Porque não querem emendar-se, nem temem a Deus."
,"21":"Levantam as mãos contra os seus próprios aliados, violando a aliança que fizeram."
,"22":"A sua boca é mais macia que a manteiga, mas a guerra está no seu coração. As suas palavras parecem suaves como azeite, porém são espadas desembainhadas."
,"23":"Descarrega o teu fardo em Javé, e Ele cuidará de ti. Ele jamais permitirá,que o justo venha a tropeçar."
,"24":"E Tu, ó Deus, Tu os farás descer,ao fundo do poço!,Esses homens sanguinários e impostores,não chegarão à metade dos seus dias!,Quanto a mim, eu confio em Ti!"
}`)
	CurrentBook.AddChapter(56, `{
"1":"Do mestre de canto. Sobre: «A opressão dos príncipes longínquos». De David. A meia-voz. Quando os filisteus o prenderam em Gat."
,"2":"Tem piedade de mim, ó Deus, porque me atormentam, o dia todo me atacam e perseguem;"
,"3":"o dia todo me espreitam e atormentam, são muitos os que do alto me combatem."
,"4":"Levanta-me no dia terrível, pois eu confio em Ti."
,"5":"Em Deus, cuja promessa eu louvo, nesse Deus eu confio, e não temerei!,O que pode um mortal fazer contra mim?"
,"6":"Todos os dias eles discutem e planeiam, maquinando o mal contra mim;"
,"7":"eles reúnem-se, escondem-se e observam os meus passos, espreitando com avidez a minha vida."
,"8":"Rejeita-os, por causa da sua injustiça!,Ó Deus, derruba com a tua ira os povos!"
,"9":"Anota no teu livro a minha vida errante, recolhe as minhas lágrimas no teu odre!"
,"10":"Os meus inimigos recuarão quando eu Te invocar, e assim eu saberei que Tu és o meu Deus."
,"11":"Em Deus, cuja promessa eu louvo, em Javé, cuja promessa eu louvo,"
,"12":"nesse Deus eu confio, e não temerei!,Que pode um homem fazer contra mim?"
,"13":"Eu mantenho os votos que Te fiz, ó Deus, eu os cumprirei com acção de graças,"
,"14":"porque livraste da morte a minha vida, e os meus pés de uma queda; para que eu ande na presença de Deus, na luz dos vivos."
}`)
	CurrentBook.AddChapter(57, `{
"1":"Do mestre de canto. «Não destruas». De David. A meia-voz. Quando ele fugia de Saul na caverna."
,"2":"Piedade, ó Deus, tem piedade de mim, pois eu me abrigo em Ti; eu me abrigo à sombra das tuas asas, até que passe a desgraça."
,"3":"Eu clamo ao Deus Altíssimo, ao Deus que faz tudo por mim."
,"4":"Do céu Ele me enviará a salvação, confundindo os que me atormentam!,Deus enviará o seu amor e a sua fidelidade!"
,"5":"Estou deitado no meio de leões,que devoram os homens; os seus dentes são lanças e flechas, a sua língua é espada afiada."
,"6":"Eleva-Te sobre o céu, ó Deus, e a tua glória domine a Terra inteira!"
,"7":"Eles armaram uma rede aos meus pés, e eu baixei a cabeça; cavaram diante de mim um buraco, e foram eles que nele caíram."
,"8":"O meu coração está firme, ó Deus, o meu coração está firme. Vou cantar e tocar!"
,"9":"Desperta, glória minha!,Despertai, cítara e harpa, que eu vou despertar a aurora!"
,"10":"Vou louvar-Te entre os povos, Senhor, vou tocar para Ti no meio das nações,"
,"11":"pois o teu amor é maior do que o céu, e a tua fidelidade alcança as nuvens."
,"12":"Eleva-Te sobre o céu, ó Deus, e a tua glória domine a Terra inteira!"
}`)
	CurrentBook.AddChapter(58, `{
"1":"Do mestre de canto. «Não destruas». De David. A meia-voz."
,"2":"Poderosos, é verdade que dais sentenças justas?,Será que julgais os homens com rectidão?"
,"3":"Pelo contrário! No coração, vós planeais a injustiça, e, na Terra, a vossa mão inclina a balança,em favor do violento."
,"4":"Desde o seio materno os injustos se extraviam, desde o ventre já dizem mentiras."
,"5":"Eles têm veneno como o veneno de serpente, são como víbora surda, que tapa os ouvidos"
,"6":"para não ouvir a voz do encantador, nem do mais hábil em praticar encantamentos."
,"7":"Ó Deus, quebra-lhes os dentes na boca!,Javé, arranca as presas desses leõezinhos!"
,"8":"Que se diluam como água a escorrer, que murchem como a erva pisada,"
,"9":"sejam como lesma, que se derrete ao caminhar, como aborto, que não chega a ver o sol!"
,"10":"Antes que brotem, como espinhos no espinheiro, verdes ou secos, que o furacão os leve!"
,"11":"Que o justo se alegre ao ver a vingança, e lave os seus pés no sangue do injusto."
,"12":"E os homens comentem: «Sim! Existe uma recompensa para o justo, porque existe um Deus,que faz justiça sobre a terra!»"
}`)
	CurrentBook.AddChapter(59, `{
"1":"Do mestre de canto. «Não destruas». De David. A meia-voz. Quando Saul mandou vigiar a sua casa, para o matar."
,"2":"Meu Deus, livra-me dos meus inimigos, protege-me dos meus agressores."
,"3":"Livra-me dos malfeitores, salva-me dos homens sanguinários!"
,"4":"Pois eles espreitam a minha vida, os poderosos reúnem-se contra mim. Sem que eu tenha pecado ou faltado, Javé,"
,"5":"sem eu ter culpa, eles avançam para me atacar. Desperta! Vem ao meu encontro e olha!"
,"6":"Tu, Javé, Deus dos Exércitos, Deus de Israel!,Levanta-Te e castiga todas as nações, não tenhas piedade desses traidores!"
,"7":"Eles voltam à tarde, ladrando como cães, e rondam pela cidade."
,"8":"Vê: eles vangloriam-se com a boca, há espadas nos seus lábios: «Alguém está a ouvir?»"
,"9":"E Tu, Javé, Tu ris à custa deles, e divertes-Te com todas as nações!"
,"10":"Ó força minha, eu olho para Ti!,Pois Tu, ó Deus, Tu és a minha fortaleza."
,"11":"Que o teu amor vá à frente, ó Deus, e me faça ver a derrota dos que me espreitam."
,"12":"Não os mates agora, para que o meu povo não se esqueça. Torna-os errantes e derruba-os, com o teu poder, ó Senhor, nosso escudo!"
,"13":"Cada palavra dos seus lábios,é um pecado da sua boca. Fiquem presos no seu orgulho, na mentira e maldição que proferem."
,"14":"Que a tua cólera os destrua, os destrua e deixem de existir, para que se saiba que Deus governa, desde Jacob até aos confins da terra."
,"15":"Eles voltam à tarde, ladrando como cães, e rondam pela cidade."
,"16":"Aí estão eles, a caçar para comer, e, se não se fartam, rondam durante a noite."
,"17":"Quanto a mim, vou cantar em louvor da tua força, vou aclamar o teu amor pela manhã, porque Tu foste a minha fortaleza, um refúgio no dia da angústia."
,"18":"Ó força minha, vou tocar para Ti, porque Tu foste, ó Deus, a minha fortaleza!"
}`)
	CurrentBook.AddChapter(60, `{
"1":"Do mestre de canto. Sobre: «O lírio é o preceito». A meiavoz. De David. Para ensinar."
,"2":"Quando ele lutou contra os arameus da Mesopotâmia e os arameus de Soba, e quando Joab voltou e derrotou Edom, cerca de doze mil homens, no Vale do Sal."
,"3":"Ó Deus, Tu nos rejeitaste e dispersaste. Estavas irritado. Restaura-nos!"
,"4":"Fizeste tremer a terra e a fendeste. Repara as suas fendas, pois ela vacila!"
,"5":"Mostraste duras coisas ao teu povo, e nos fizeste beber um vinho estonteante."
,"6":"Deste aos teus fiéis o sinal de retirada, para que fugissem diante dos arcos."
,"7":"Para que os teus amados sejam libertos, que a tua mão salvadora nos responda!"
,"8":"Deus falou no seu santuário: «Triunfante ocuparei Siquém, e repartirei o vale de Sucot."
,"9":"Meu é Galaad, meu é Manassés, Efraim é o elmo da minha cabeça, Judá, o meu ceptro de comando."
,"10":"Moab é a bacia onde Me lavo. Sobre Edom atiro a minha sandália, e sobre a Filisteia canto vitória»."
,"11":"Quem me levará a uma cidade-forte, quem me conduzirá até Edom,"
,"12":"se Tu, ó Deus, nos rejeitaste, e já não acompanhas as nossas tropas?"
,"13":"Concede-nos socorro na opressão, pois o auxílio humano é inútil!"
,"14":"Com Deus nós faremos proezas!,Ele vai pisar os nossos opressores!"
}`)
	CurrentBook.AddChapter(61, `{
"1":"Do mestre de canto. Com instrumentos de corda. De David."
,"2":"Ó Deus, ouve o meu grito, atende à minha prece!"
,"3":"Desde os confins da Terra eu Te invoco,de coração abatido. Eleva-me sobre a rocha! Conduz-me!"
,"4":"Porque Tu és o meu refúgio, a minha torre forte diante do inimigo."
,"5":"Vou habitar para sempre na tua tenda, vou abrigar-me no amparo das tuas asas."
,"6":"Porque Tu, ó Deus, ouvirás os meus votos, e me darás a herança,dos que temem o teu nome."
,"7":"Acrescenta dias aos dias do rei, que os seus anos alcancem várias gerações."
,"8":"Que ele reine para sempre na presença de Deus, e o teu amor e fidelidade o protejam."
,"9":"Então eu tocarei ao teu nome sem cessar, dia a dia cumprindo os meus votos."
}`)
	CurrentBook.AddChapter(62, `{
"1":"Do mestre de canto... Iditun. Salmo. De David."
,"2":"Só em Deus a minha alma repousa, porque d'Ele vem a minha salvação."
,"3":"Só Ele é a minha rocha e a minha salvação, a minha fortaleza: jamais serei abalado!"
,"4":"Até quando avançareis contra um homem, todos juntos, para o derrubardes, como se fosse parede inclinada, ou muro que está para cair?"
,"5":"Eles só pensam em me derrubar da minha posição, e sentem prazer em mentir: com a boca elogiam, mas por dentro amaldiçoam."
,"6":"Só em Deus repousa, ó minha alma, porque d'Ele vem a minha esperança."
,"7":"Só Ele é a minha rocha e a minha salvação, a minha fortaleza: jamais serei abalado!"
,"8":"De Deus depende a minha salvação e a minha fama, Deus é o meu forte rochedo. Deus é o meu refúgio."
,"9":"Povo de Deus, confia n'Ele em qualquer situação, desafoga o coração na sua presença, porque Deus é o nosso refúgio."
,"10":"Não passam de um sopro os homens comuns,e são apenas mentira os homens importantes: se os colocassem no prato da balança, juntos seriam menos que um sopro."
,"11":"Não confieis na opressão, nem vos iludais com o roubo. Se a vossa riqueza aumenta, não depositeis nela o coração!"
,"12":"Deus falou uma vez, e duas vezes eu ouvi: «A Deus pertence o poder,"
,"13":"e a Ti, Senhor, pertence o amor, porque Tu pagas a cada um,conforme as suas obras»."
}`)
	CurrentBook.AddChapter(63, `{
"1":"Salmo. De David. Quando estava no deserto de Judá."
,"2":"Ó Deus, Tu és o meu Deus, por Ti madrugo. A minha alma tem sede de Ti, a minha carne deseja-Te com ardor, como terra seca, esgotada e sem água."
,"3":"Sim, eu contemplava-Te no santuário, vendo o teu poder e a tua glória."
,"4":"O teu amor vale mais do que a vida: os meus lábios Te louvarão."
,"5":"Vou bendizer-Te durante toda a minha vida, e ao teu Nome levantar as minhas mãos."
,"6":"Vou saciar-me de azeite e gordura, e, com sorrisos, a minha boca Te louvará."
,"7":"Quando me lembro de Ti, no meu leito, passo vigílias a meditar em Ti,"
,"8":"pois Tu foste um socorro para mim, e, à sombra das tuas asas, eu grito de alegria."
,"9":"A minha alma está ligada a Ti, e a tua direita me sustenta."
,"10":"Quanto aos que me querem destruir, irão todos para as profundezas da terra."
,"11":"Serão entregues à espada, e vão tornar-se pasto de chacais."
,"12":"O rei, porém, alegrar-se-á com Deus, os que juram pelo seu Nome felicitar-se-ão, quando a boca dos mentirosos for tapada."
}`)
	CurrentBook.AddChapter(64, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"Ouve, ó Deus, a voz do meu lamento!,Protege a minha vida do terrível inimigo,"
,"3":"esconde-me da conspiração dos maus,e do motim dos malfeitores."
,"4":"Eles afiam a língua como espada, e atiram, como flecha, a palavra venenosa,"
,"5":"para ferir o inocente às escondidas, para o ferirem de surpresa e sem risco."
,"6":"Fortalecem-se com o seu projecto maligno, calculam como esconder armadilhas, pensando: «Quem o irá descobrir?»"
,"7":"Inventam crimes e ocultam os seus intentos, porque a sua mente e coração não têm fundo."
,"8":"Deus, porém, atira flechas contra eles, e ficam feridos de surpresa;"
,"9":"a sua própria língua os leva à ruína, e quem os vê meneia a cabeça."
,"10":"Então todo o homem se atemoriza, proclama o acto de Deus, e medita nas suas obras."
,"11":"O justo alegra-se com Javé,e n'Ele se abriga. E os rectos de coração felicitam-se."
}`)
	CurrentBook.AddChapter(65, `{
"1":"Do mestre de canto. Salmo. De David. Cântico."
,"2":"Ó Deus, Tu mereces um hino em Sião. Nós viemos aqui pagar as promessas,"
,"3":"porque ouves as súplicas. Todas as pessoas vêm a Ti"
,"4":"por causa dos seus pecados. As nossas faltas nos esmagam, mas Tu perdoas as nossas culpas."
,"5":"Feliz quem Tu escolhes e aproximas de Ti,para morar no Templo; nós estamos saciados com os bens da tua casa, com os dons sagrados do teu Templo."
,"6":"Com prodígios de justiça nos respondes, ó Deus, nosso Salvador. Tu és a esperança dos confins da Terra,e dos mares distantes;"
,"7":"firmas as montanhas com a tua força, repleto de poder."
,"8":"Acalmas o estrondo do mar, o ribombar das suas ondas, e o tumulto das nações."
,"9":"Os habitantes de terras longínquas,temem diante dos teus sinais. Tu fazes gritar de alegria,as portas da aurora e do poente."
,"10":"Cuidas da terra e a regas, e sem medida a enriqueces. Enches a transbordar de água os teus rios, e preparas assim os trigais:"
,"11":"regas os sulcos, aplanas os torrões, com a chuva amoleces a terra, abençoas as sementeiras."
,"12":"Coroas o ano com os teus bens, e os teus caminhos gotejam fartura."
,"13":"As pastagens do deserto gotejam, e as colinas enfeitam-se de alegria."
,"14":"Os campos cobrem-se de rebanhos,e os vales vestem-se de espigas; lançam gritos de alegria e cantam."
}`)
	CurrentBook.AddChapter(66, `{
"1":"Do mestre de canto. Cântico. Salmo. Aclama a Deus, Terra inteira,"
,"2":"toca em honra do seu Nome, canta hinos à sua glória."
,"3":"Dizei a Deus: «Como são terríveis as tuas obras!,Pelo teu imenso poder, os teus inimigos Te adulam»."
,"4":"Que toda a terra se prostre na tua presença!,Cantem em tua honra, salmodiem ao teu nome."
,"5":"Vinde ver as obras de Deus, as suas acções terríveis em favor dos homens:"
,"6":"Ele transformou o mar em terra firme, e atravessaram o rio a pé enxuto. Exultemos de alegria com Deus,"
,"7":"que governa com o seu poder para sempre. Os seus olhos vigiam as nações, para que os rebeldes não se revoltem."
,"8":"Povos, bendizei o nosso Deus, fazei ressoar o seu louvor."
,"9":"É Ele que nos mantém vivos, e não deixa que os nossos pés tropecem."
,"10":"Sim, ó Deus, Tu nos provaste, e nos purificaste como se purifica a prata."
,"11":"Tu nos fizeste cair na rede, puseste um peso sobre os nossos ombros:"
,"12":"deixaste que os homens cavalgassem o nosso pescoço. Nós passámos pelo fogo e pela água, mas por fim deste-nos alívio."
,"13":"Eu entro em tua casa com holocaustos, cumpro as minhas promessas,"
,"14":"as promessas que os meus lábios pronunciaram,e que a minha boca, na angústia, prometeu."
,"15":"Vou oferecer-Te gordos holocaustos,com o fumo de carneiros; vou imolar bois e cabritos."
,"16":"Todos vós que temeis a Deus, vinde escutar. Vou contar-vos o que Ele fez por mim."
,"17":"A minha boca gritou para Deus, e a minha língua exaltou-O."
,"18":"Se eu tivesse más intenções, o Senhor não me teria atendido."
,"19":"No entanto, Deus escutou-me, e atendeu ao meu grito suplicante."
,"20":"Bendito seja Deus, que não rejeitou a minha súplica, nem me retirou o seu amor."
}`)
	CurrentBook.AddChapter(67, `{
"1":"Do mestre de canto. Com instrumentos de corda. Salmo. Cântico."
,"2":"Deus tenha piedade de nós e nos abençoe, fazendo brilhar a sua face sobre nós,"
,"3":"para que na terra se conheçam os teus caminhos, e em todas as nações a tua salvação."
,"4":"Que os povos Te louvem, ó Deus, Que todos os povos Te celebrem."
,"5":"Que as nações se alegrem e exultem, porque julgas o mundo com justiça, julgas os povos com rectidão, e governas as nações da Terra."
,"6":"Que os povos Te louvem, ó Deus. Que todos os povos Te celebrem."
,"7":"A terra produziu o seu fruto: é o Senhor nosso Deus que nos abençoa."
,"8":"Que Deus nos abençoe, e todos os confins da terra O temerão!"
}`)
	CurrentBook.AddChapter(68, `{
"1":"Do mestre de canto. De David. Salmo. Cântico."
,"2":"Levanta-Se o Senhor, os seus inimigos debandam, os seus adversários fogem diante d'Ele."
,"3":"Tu os dissipas como se dissipa o fumo; tal como a cera se derrete diante do fogo, assim perecem os injustos diante de Deus."
,"4":"Os justos, pelo contrário, alegram-se, exultam na presença de Deus,e dançam de alegria."
,"5":"Cantai a Deus, tocai ao seu Nome, abri caminho,Àquele que avança pelo deserto. O seu Nome é Javé: alegrai-vos na sua presença."
,"6":"Pai dos órfãos, protector das viúvas, assim é Deus na sua morada santa."
,"7":"Deus dá aos marginalizados uma casa, liberta e enriquece os cativos. Somente os rebeldes,permanecem na terra seca."
,"8":"Ó Deus, quando saías à frente do teu povo, e avançavas pelo deserto,"
,"9":"a terra tremeu e o céu dissolveu-se,diante de Deus, o Deus do Sinai; diante de Javé, o Deus de Israel."
,"10":"Derramaste sobre a tua herança, ó Deus, uma chuva abundante, aliviando a terra esgotada,"
,"11":"e o teu povo habitou na Terra,que a tua bondade, ó Deus, preparou para o pobre."
,"12":"O Senhor deu uma ordem, o anúncio de um exército numeroso:"
,"13":"«Reis e exércitos fogem em debandada, e as mulheres repartem os despojos."
,"14":"Enquanto vós repousáveis no acampamento, as pombas batiam as suas asas prateadas,destilando ouro das suas plumas."
,"15":"Enquanto o Todo-poderoso dispersava os reis, a neve caía sobre o monte Sombrio»."
,"16":"As montanhas de Basã são altíssimas, as montanhas de Basã são escarpadas."
,"17":"Ó montanhas escarpadas, porque invejais,a montanha que Deus escolheu para habitar, a moradia perpétua de Javé?"
,"18":"Milhares e milhares são os carros de Deus. O Senhor marcha do Sinai para o santuário."
,"19":"Subiste ao topo, levando cativos, e deram-Te homens como tributo, até mesmo os que resistiam, para que Javé Deus tivesse uma residência."
,"20":"Bendito seja o Senhor dia após dia!,Deus cuida de nós: Ele é o nosso salvador!"
,"21":"O nosso Deus é um Deus que liberta, ao Senhor Javé pertencem as portas da morte."
,"22":"Sim, Deus esmaga a cabeça dos seus inimigos, e o crânio cabeludo dos que caminham na maldade."
,"23":"O Senhor disse: «Eu vos farei voltar de Basã, far-vos-ei voltar do fundo do mar."
,"24":"Tu banharás os teus pés no sangue do inimigo, sangue que os cães lamberão com a língua»."
,"25":"O teu cortejo aparece, ó Deus, o cortejo do meu Deus, do meu rei, a caminho do santuário."
,"26":"À frente marcham os cantores, atrás os tocadores de harpa, no meio as jovens, tocando tamborins."
,"27":"«Bendizei a Deus nas assembleias,bendizei a Javé na comunidade de Israel»."
,"28":"Na frente vai Benjamim, o mais novo; os príncipes de Judá, com vestes coloridas; os príncipes de Zabulon, os príncipes de Neftali."
,"29":"Desfralda, ó Deus, o teu poder, o teu poder, ó Deus, que age em nosso favor."
,"30":"Que os reis tragam o seu tributo,ao teu Templo de Jerusalém."
,"31":"Reprime a Fera dos canaviais,a manada dos Búfalos,e os Touros dos povos. Que se rendam a Ti trazendo barras de prata. Dispersa os povos que gostam de guerras!"
,"32":"Do Egipto venham os grandes, e a Etiópia estenda as mãos para Deus."
,"33":"Cantai a Deus, reis da Terra, tocai para o Senhor,"
,"34":"que avança pelos céus, os céus antigos. Ele ergue a sua voz, voz poderosa:"
,"35":"«Reconhecei a força de Deus!»,A sua majestade resplandece sobre Israel, e por sobre as nuvens o seu poder."
,"36":"Desde o santuário Deus impõe reverência: Ele é o Deus de Israel, que dá força e poder ao seu povo. Bendito seja Deus!"
}`)
	CurrentBook.AddChapter(69, `{
"1":"Do mestre de canto. Sobre a ária: «Os lírios...» De David."
,"2":"Salva-me, ó Deus, pois a água,já me chega ao pescoço."
,"3":"Estou a afundar-me no lodo profundo, sem nada que me segure; vou-me afundando no mais fundo das águas, e a corrente vai-me arrastando..."
,"4":"Esgotei-me de tanto gritar, a minha garganta arde,e os meus olhos consomem-se, esperando pelo meu Deus."
,"5":"Mais que os cabelos da minha cabeça, são os que me odeiam sem motivo. Mais duros que os meus ossos, são os que injustamente me atacam. Deveria eu devolver,aquilo que não roubei?"
,"6":"Ó Deus, Tu conheces a minha ignorância, os meus crimes não são ocultos para Ti."
,"7":"Que por minha causa não fiquem envergonhados,aqueles que esperam em Ti, Javé dos Exércitos. Que por minha causa não fiquem confundidos,aqueles que Te procuram, ó Deus de Israel."
,"8":"É por tua causa que eu suporto afrontas, e a confusão cobre o meu rosto."
,"9":"Tornei-me estrangeiro para os meus irmãos, um estranho para os filhos de minha mãe."
,"10":"Porque o zelo pela tua casa me devora, e as afrontas com que Te afrontam,recaem sobre mim."
,"11":"Se me aflijo com jejum, zombam de mim."
,"12":"Se me visto com pano de saco, riem-se de mim."
,"13":"Sentam-se à porta, a cochichar, bebendo vinho e dizendo piadas."
,"14":"Quanto a mim, dirijo a minha prece a Ti!,Javé, no tempo favorável,responde-me, pelo teu grande amor, e ajuda-me com a tua fidelidade."
,"15":"Arranca-me da lama, para que eu não me afunde. Liberta-me dos que me odeiam,e das águas sem fundo."
,"16":"Que a corrente não me arraste, nem o lodo profundo me engula, e que o poço não feche sobre mim a sua boca."
,"17":"Responde-me, Javé, com a bondade do teu amor!,Volta-Te para mim, com a tua grande compaixão!"
,"18":"Não escondas a face ao teu servo: estou oprimido, responde-me depressa!"
,"19":"Aproxima-Te de mim, resgata-me!,Liberta-me dos meus inimigos!"
,"20":"Tu conheces a afronta que sofro, e a minha vergonha e confusão. Os meus opressores estão todos diante de Ti."
,"21":"A sua afronta partiu-me o coração, e estou a desfalecer. Espero compaixão, e nada!,Espero consoladores, e não os encontro!"
,"22":"Como alimento deram-me fel, e na minha sede deram-me vinagre."
,"23":"Que a sua mesa seja armadilha para eles, e a sua abundância uma cilada."
,"24":"Que os seus olhos fiquem turvos e não vejam, que as suas costas fraquejem sempre!"
,"25":"Derrama sobre eles o teu furor, e o ardor da tua ira os atinja."
,"26":"Que o seu acampamento fique deserto, e ninguém mais habite nas suas tendas;"
,"27":"porque eles perseguem a quem Tu feriste, e contam as chagas da tua vítima."
,"28":"Acusa-os, crime por crime, não os declares inocentes."
,"29":"Risca-os do livro dos vivos, e não sejam inscritos entre os justos!!"
,"30":"Quanto a mim, pobre e ferido, que a tua salvação, ó Deus, me proteja!"
,"31":"Louvarei o nome de Deus com um cântico, e engrandecê-lo-ei com acção de graças."
,"32":"Isso é mais agradável a Javé do que um touro, mais que um novilho com chifres e cascos."
,"33":"Que os pobres vejam e se alegrem. Buscai a Deus, e tereis coragem!"
,"34":"Porque Javé ouve os indigentes, e nunca rejeita os seus cativos."
,"35":"Que o Céu e a Terra O louvem, o mar e tudo o que nele se move!"
,"36":"Sim, Deus vai salvar Sião, vai reconstruir as cidades de Judá!,Nela habitarão e a possuirão!"
,"37":"A descendência dos seus servos a herdaram,e nela viverão aqueles que amam o nome de Deus!"
}`)
	CurrentBook.AddChapter(70, `{
"1":"Do mestre de canto. De David. Para comemoração."
,"2":"Ó Deus, por favor, liberta-me!,Javé, vem depressa socorrer-me."
,"3":"Fiquem envergonhados e confundidos,aqueles que buscam perder a minha vida!,Recuem e fiquem envergonhados, os que tramam a minha desgraça!"
,"4":"Retirem-se, cheios de vergonha, os que se riem de mim."
,"5":"Exultem e alegrem-se contigo,todos os que Te buscam. Os que amam a tua salvação,repitam sempre: «Deus é grande!»"
,"6":"Quanto a mim, sou pobre e indigente. Ó Deus, vem depressa!,Tu és o meu auxílio e salvação. Javé, não demores!"
}`)
	CurrentBook.AddChapter(71, `{
"1":"Javé, eu me abrigo em Ti: que eu nunca fique envergonhado!"
,"2":"Salva-me, por tua justiça! Liberta-me!,Inclina depressa o teu ouvido para mim!"
,"3":"Sê Tu a minha rocha de refúgio, a fortaleza onde eu me salve, pois o meu rochedo e fortaleza és Tu!"
,"4":"Meu Deus, liberta-me da mão do injusto, do punho do criminoso e do violento;"
,"5":"pois Tu, Senhor, és a minha esperança,e a minha confiança, desde a minha juventude."
,"6":"Já no ventre materno eu me apoiava em Ti, e no seio materno Tu me sustentavas. Eu sempre confiei em Ti."
,"7":"Muitos olhavam para mim como para um prodígio, porque eras Tu o meu abrigo seguro."
,"8":"A minha boca está cheia do teu louvor,e do teu esplendor o dia todo."
,"9":"Não me rejeites agora que estou na velhice, não me abandones quando me faltam as forças;"
,"10":"porque os meus inimigos falam de mim, juntos planeiam os que espreitam a minha vida:"
,"11":"«Deus abandonou-o. Podeis persegui-lo,e agarrá-lo, que ninguém o salvará!»"
,"12":"Ó Deus, não fiques longe de mim!,meu Deus, vem depressa socorrer-me."
,"13":"Fiquem envergonhados e arruinados,aqueles que perseguem a minha vida. Fiquem cobertos de ultraje e desonra,os que buscam o mal contra mim."
,"14":"Quanto a mim, fico à espera, continuando o teu louvor."
,"15":"A minha boca vai contar a tua justiça, e o dia todo a tua salvação."
,"16":"Contarei as tuas proezas, Senhor Javé, vou narrar a tua vitória, toda tua!"
,"17":"Ó Deus, Tu me instruíste desde a minha juventude, e até hoje eu anuncio as tuas maravilhas."
,"18":"Agora que estou velho e de cabelos brancos, não me abandones, ó Deus, até que eu descreva o teu braço à geração futura,"
,"19":"as tuas proezas e as tuas sublimes vitórias, as façanhas que realizaste. Ó Deus, quem é igual a Ti?"
,"20":"Tu me fizeste passar por angústias,profundas e numerosas. Agora voltarás para me dar a vida, e far-me-ás subir da terra profunda."
,"21":"Aumentarás a minha grandeza, e de novo me consolarás."
,"22":"Quanto a mim, vou celebrar-Te com a harpa, pela tua fidelidade, meu Deus!,Vou tocar cítara em tua honra, ó Santo de Israel."
,"23":"Os meus lábios Te aclamarão, e também a minha alma, que resgataste."
,"24":"A minha língua repetirá,o dia inteiro a tua justiça, pois ficaram envergonhados e confundidos,aqueles que buscavam o mal contra mim!"
}`)
	CurrentBook.AddChapter(72, `{
"1":"De Salomão. Ó Deus, confia o teu julgamento ao rei,e a tua justiça ao filho do rei."
,"2":"Que ele governe o teu povo com justiça, e os teus pobres conforme o direito."
,"3":"Que os montes tragam a paz, e as colinas a justiça."
,"4":"Que ele defenda os pobres do povo, salve os filhos do indigente,e esmague os seus opressores."
,"5":"Que ele dure como o Sol e a Lua, de geração em geração."
,"6":"Que ele desça como chuva sobre a erva, como chuvisco que irriga a terra."
,"7":"Que em seus dias floresça a justiça,e muita paz até ao fim das luas,"
,"8":"que ele domine de mar a mar, do Grande Rio até aos confins da Terra."
,"9":"Que os seus rivais se inclinem diante dele, e os seus inimigos lambam o pó."
,"10":"Que os reis de Társis e das ilhas,lhe paguem tributos. Que os reis de Sabá e Seba,lhe ofereçam os seus dons."
,"11":"Que todos os reis se prostrem diante dele, e as nações todas o sirvam!"
,"12":"Porque ele liberta o indigente que clama,e o pobre que não tem protector."
,"13":"Ele tem compaixão do fraco e do indigente, e salva a vida dos indigentes."
,"14":"Ele os redime da astúcia e da violência, porque o sangue deles é precioso aos seus olhos."
,"15":"Que ele viva, e lhe tragam o ouro de Sabá!,Que por ele orem continuamente, e todos os dias o bendigam!"
,"16":"Haja abundância de trigo pelos campos, tremulando no topo das montanhas. Dêem fruto como o Líbano, e as espigas brotem como a grama do campo."
,"17":"Que o seu nome permaneça para sempre, e a sua fama dure como o Sol: que ele seja a bênção para todos os povos, e todas as raças da terra o proclamem feliz!"
,"18":"Seja bendito Javé, o Deus de Israel, porque só Ele realiza maravilhas!"
,"19":"Para sempre seja bendito o seu Nome glorioso!,Que toda a Terra se encha da sua glória!,Ámen! Ámen!"
,"20":"(Fim das orações de David, filho de Jessé)."
}`)
	CurrentBook.AddChapter(73, `{
"1":"Salmo. De Asaf. Na verdade, «Deus é bom para Israel, para os puros de coração»."
,"2":"Mas por pouco os meus pés não tropeçavam, por um nada os meus passos escorregavam,"
,"3":"porque invejei os arrogantes, vendo a prosperidade dos injustos."
,"4":"Vede! Para eles não há tormentos, e o seu corpo é sadio e robusto."
,"5":"A fadiga dos mortais não os atinge, eles não são molestados como os outros."
,"6":"Daí a soberba, que eles usam como colar, e a violência que os envolve como veste."
,"7":"O pecado brota-lhes da gordura, e o seu coração transborda em maus projectos."
,"8":"Zombam e falam maliciosamente, falam alto, oprimindo."
,"9":"No céu colocam a boca, e a sua língua percorre a terra."
,"10":"Deste modo saciam-se a si próprios, sugando para si as águas de todo o mar."
,"11":"E dizem: «Como pode Deus saber?,Existe conhecimento no Altíssimo?»"
,"12":"Aí está! Os injustos são assim,e, sempre tranquilos, acumulam riquezas!"
,"13":"De facto, foi inútil conservar puro o meu coração, e lavar na inocência as minhas mãos!"
,"14":"Sim, eu sou molestado o dia inteiro, e castigado cada manhã..."
,"15":"Se eu dissesse: «Vou falar como eles!», já renegaria a assembleia dos teus filhos."
,"16":"Então reflecti para compreender, mas que fadiga era isso para os meus olhos!"
,"17":"Até que fui penetrando no mistério de Deus, e então compreendi o destino deles."
,"18":"De facto, Tu coloca-los em ladeiras, tu faze-los cair, em ruínas."
,"19":"Vede: num instante são reduzidos ao terror, deixam de existir e perecem, presas do pavor!"
,"20":"Como um sonho ao despertar, ó Senhor, ao acordar, Tu desprezas a imagem deles."
,"21":"Se o meu coração se azedava,e eu espicaçava os meus rins,"
,"22":"é porque eu era imbecil e nada entendia. Eu era um animal junto a Ti."
,"23":"Eu, porém, estou sempre contigo. Tu me agarraste pela mão direita."
,"24":"Tu me guias com o teu conselho,e com glória me conduzes."
,"25":"Contigo, de quem necessitarei no Céu?,Contigo, nada mais me satisfaz na Terra."
,"26":"A minha carne e o meu coração podem consumir-se: a minha rocha e porção é Deus para sempre!"
,"27":"Sim, os que se afastam de Ti perdem-se, Tu rejeitas todos os teus adúlteros."
,"28":"Eu, porém, estou feliz por estar com Deus, e em Deus colocar o meu abrigo, para contar todas as tuas obras"
}`)
	CurrentBook.AddChapter(74, `{
"1":"Poema. De Asaf. Porquê, ó Deus, rejeitares-nos até ao fim?,Porquê arderes em ira contra as ovelhas,do teu rebanho?"
,"2":"Lembra-Te da comunidade,que adquiriste desde a origem, da tribo que redimiste como tua herança; do monte Sião, onde puseste a tua moradia."
,"3":"Dirige os teus passos para estas ruínas sem fim: o inimigo arrasou completamente o santuário."
,"4":"Os opressores rugiram no lugar das tuas assembleias, e puseram as suas insígnias no frontão da entrada,"
,"5":"insígnias que não eram conhecidas. Como quem brande o machado no bosque,"
,"6":"eles destroçaram as esculturas, golpeando com machado e com martelo."
,"7":"Atearam fogo ao teu santuário, profanaram até ao chão,a moradia do teu Nome."
,"8":"Eles pensavam: «Vamos arrasá-los de vez!»,E incendiaram todos os templos da terra."
,"9":"Já não vemos os nossos sinais, já não existem profetas, e ninguém de nós sabe até quando."
,"10":"Até quando, ó Deus, o opressor vai blasfemar?,O inimigo irá desprezar,o teu Nome até ao fim?"
,"11":"Porque retiras a tua mão esquerda,e manténs a direita escondida no peito?"
,"12":"Tu, porém, ó Deus, és rei desde a origem, e operas libertações por toda a terra."
,"13":"Tu dividiste o mar com o teu poder, quebraste a cabeça do monstro do mar."
,"14":"Tu esmagaste as cabeças do Leviatã, dando-o como alimento às feras do mar."
,"15":"Tu abriste fontes e torrentes,e secaste rios inesgotáveis."
,"16":"O dia pertence-Te, e tua é a noite. Tu firmaste a Lua e o Sol,"
,"17":"estabeleceste os limites da Terra, e formaste o Verão e o Inverno."
,"18":"Lembra-Te, Javé, do inimigo que blasfema, do povo insensato que ultraja o teu Nome."
,"19":"Não entregues à fera a vida da tua rola. Não esqueças até ao fim a vida dos teus pobres."
,"20":"Olha para a tua aliança, pois os recantos da terra,estão cheios de violência."
,"21":"Que o oprimido não volte coberto de confusão, e o pobre e o indigente louvem o teu Nome."
,"22":"Levanta-Te, ó Deus! Defende a tua causa!,Lembra-Te do insensato que Te ultraja o dia todo!"
,"23":"Não Te esqueças do rumor dos teus opressores, do tumulto crescente dos que se rebelam contra Ti."
}`)
	CurrentBook.AddChapter(75, `{
"1":"Do mestre de canto. «Não destruas». Salmo. De Asaf. Cântico."
,"2":"Nós Te celebramos, ó Deus, nós Te celebramos, invocando o teu Nome,e contando as tuas maravilhas."
,"3":"«No momento que Eu tiver decidido, Eu mesmo vou julgar com rectidão."
,"4":"Trema a Terra com os seus habitantes todos, Eu mesmo firmei as suas colunas»."
,"5":"Eu digo aos arrogantes: Não sejais arrogantes!,E aos injustos: Não levanteis a fronte!"
,"6":"Não ergais altivamente a fronte, não digais insolências contra a Rocha!"
,"7":"Não é do Nascente, nem do Poente, nem do deserto, nem das montanhas,"
,"8":"que Deus vem como juiz: a um ele abaixa, a outro eleva."
,"9":"Na mão de Javé existe uma taça, com vinho a espumar, cheio de mistura. Ele derrama-o, e eles sugá-lo-ão até ao fim, todos os injustos da terra o beberão."
,"10":"Quanto a mim, vou proclamar sempre a sua grandeza, e tocarei para o Deus de Jacob."
,"11":"Ele quebrará o poder de todos os injustos, e o poder dos justos se levantará."
}`)
	CurrentBook.AddChapter(76, `{
"1":"Do mestre de canto. Com instrumentos de corda. Salmo. De Asaf. Cântico."
,"2":"Deus manifesta-Se em Judá, a sua fama é grande em Israel."
,"3":"A sua tenda está em Jerusalém, e em Sião a sua moradia."
,"4":"Aí quebrou os relâmpagos do arco, o escudo, a espada e a guerra."
,"5":"Tu és luminoso e célebre, com montes de despojos conquistados."
,"6":"Os valentes dormem o seu sono, e os braços falham a todos os guerreiros."
,"7":"Com a tua ameaça, ó Deus de Jacob, carro e cavalo ficaram parados."
,"8":"Tu és terrível! Quem pode resistir,à tua frente, quando ficas irado?"
,"9":"Do Céu proclamas a sentença: a Terra paralisa de medo,"
,"10":"quando Deus Se levanta para julgar,e salvar todos os pobres da Terra."
,"11":"Atingido pela tua ira, o homem louva-Te, e os que escapam ao castigo Te rodearão."
,"12":"Fazei votos a Javé vosso Deus, e cumpri-os, e que os vassalos paguem tributo ao Terrível."
,"13":"Ele deixa os príncipes sem alento, Ele é terrível para os reis da Terra!"
}`)
	CurrentBook.AddChapter(77, `{
"1":"Do mestre de canto... Iditun. De Asaf. Salmo."
,"2":"A Deus levanto a minha voz, e grito!,A Deus ergo a minha voz, e Ele ouve-me!"
,"3":"No dia da angústia eu procuro pelo Senhor. À noite estendo a mão, sem descanso, e a minha alma recusa consolo."
,"4":"Lembro-me de Deus e fico a gemer, medito e sinto-me desfalecer."
,"5":"Tu me seguras as pálpebras dos olhos, fico agitado e nem posso falar."
,"6":"Penso nos dias de outrora, recordo os anos longínquos."
,"7":"De noite reflicto no meu coração, fico a meditar, e pergunto-me:"
,"8":"O Senhor vai rejeitar-nos para sempre?,Nunca mais nos será favorável?"
,"9":"A sua misericórdia já se esgotou?,A sua promessa acabou para sempre?"
,"10":"Será que Deus Se esqueceu da sua bondade, ou fechou as entranhas com ira?"
,"11":"E eu digo: «Este é o meu mal: a direita do Altíssimo mudou!»"
,"12":"Lembro-me das proezas de Javé, recordo as tuas maravilhas de outrora,"
,"13":"medito as tuas obras todas, e considero as tuas façanhas."
,"14":"Ó Deus, o teu caminho é santo!,Que deus é grande como o nosso Deus?"
,"15":"Tu és o Deus que opera maravilhas, mostrando às nações a tua força."
,"16":"Com o teu braço resgataste o teu povo, os filhos de Jacob e de José."
,"17":"O mar viu-Te, ó Deus, o mar viu-Te e tremeu, e as ondas estremeceram."
,"18":"As nuvens derramaram as suas águas, as nuvens pesadas trovejaram, e as tuas flechas ziguezagueavam."
,"19":"O estrondo do teu trovão ribombava, os teus relâmpagos iluminavam o mundo, e a terra agitou-se, estremecida."
,"20":"Abriste um caminho entre as águas, uma senda nas águas torrenciais, sem deixar rasto dos teus passos."
,"21":"Guiaste o teu povo como a um rebanho, pela mão de Moisés e de Aarão."
}`)
	CurrentBook.AddChapter(78, `{
"1":"Poema. De Asaf. Povo meu, escuta a minha instrução, dá ouvidos às palavras da minha boca."
,"2":"Vou abrir a minha boca em parábolas, vou expor enigmas do passado."
,"3":"O que nós ouvimos e aprendemos, o que nos contaram os nossos pais,"
,"4":"não o esconderemos aos seus filhos, nós o contaremos à geração futura: os louvores de Javé, o seu poder,e as maravilhas que realizou."
,"5":"Porque Ele estabeleceu uma norma para Jacob,e deu uma lei a Israel: ordenou aos nossos pais,que as transmitissem a seus filhos,"
,"6":"para que a geração seguinte as conhecesse, e os filhos que iriam nascer. Que se levantem e as contem aos seus filhos,"
,"7":"para que ponham em Deus a sua confiança, não se esqueçam dos feitos de Deus,e observem os seus mandamentos."
,"8":"Para que não sejam como seus pais, uma geração desobediente e rebelde, geração de coração inconstante, que não tem espírito fiel a Deus."
,"9":"Os filhos de Efraim, arqueiros equipados, voltaram as costas no dia da batalha,"
,"10":"não guardaram a aliança de Deus, recusaram seguir a sua lei."
,"11":"Esqueceram os seus grandes feitos,e as maravilhas que lhes mostrara,"
,"12":"quando realizou a maravilha diante de seus pais, na terra do Egipto, no campo de Tânis:"
,"13":"Ele dividiu o mar e fê-los atravessar, barrando as águas como num dique."
,"14":"De dia guiou-os com a nuvem, e de noite com a luz de um fogo."
,"15":"Fendeu a rocha no deserto,e deu-lhes a beber águas abundantes."
,"16":"Da pedra fez brotar torrentes, e as águas desceram como rios."
,"17":"Mas continuaram a pecar contra Ele, rebelando-se contra o Altíssimo no deserto."
,"18":"Tentaram a Deus nos seus corações, pedindo comida conforme o seu próprio gosto."
,"19":"E murmuraram contra Deus, dizendo: «Poderá Deus,preparar uma mesa no deserto?»"
,"20":"Então Ele feriu a rocha, a água brotou, e as torrentes transbordaram. «Acaso poderá também dar-nos pão,ou fornecer carne ao seu povo?»"
,"21":"Ouvindo isso, Javé enfureceu-Se; um fogo acendeu-se contra Jacob,e a ira ergueu-se contra Israel."
,"22":"Porque eles não tinham fé em Deus, nem confiavam no seu auxílio."
,"23":"Entretanto, Ele ordenou às altas nuvens,e abriu as comportas do céu:"
,"24":"fez chover sobre eles o maná, deu-lhes um trigo do céu."
,"25":"O homem comeu pão dos anjos, Deus mandou-lhes provisões com fartura."
,"26":"Fez soprar no céu o vento Leste, e com o seu poder trouxe o vento Sul:"
,"27":"sobre eles fez chover carne como pó, aves numerosas como areia do mar,"
,"28":"fazendo-as cair no meio do acampamento, ao redor de suas tendas."
,"29":"Eles comeram e ficaram saciados, pois Ele os atendeu conforme queriam."
,"30":"Mas não haviam satisfeito o apetite, tinham ainda a comida na boca,"
,"31":"quando a ira de Deus contra eles se ergueu: ele massacrou os mais fortes, e prostrou a juventude de Israel."
,"32":"Apesar disso, continuaram a pecar, e não tinham fé nas suas maravilhas."
,"33":"Consumiu-lhes os dias num sopro,e os seus anos num momento."
,"34":"Quando os matava, então buscavam-n'O, madrugando para voltarem para Deus."
,"35":"Recordavam que Deus era a sua rocha, que o Deus Altíssimo era o seu redentor."
,"36":"Eles adulavam-n'O com a boca, mas enganavam-n'O com a língua."
,"37":"Os seus corações não eram sinceros com Deus, não eram fiéis à sua aliança."
,"38":"Ele, porém, compassivo, perdoava as faltas e não os destruía. Reprimia a sua ira muitas vezes, e não despertava todo o seu furor."
,"39":"Lembrava-se de que eles eram apenas carne, um vento que se vai, para nunca mais voltar."
,"40":"Quantas vezes O afrontaram no deserto,e O ofenderam em lugares solitários!"
,"41":"Voltaram a tentar a Deus, a irritar o Santo de Israel."
,"42":"Não se lembravam da sua mão, que um dia os resgatou da opressão:"
,"43":"quando operou os seus sinais no Egipto, e os seus prodígios no campo de Tânis."
,"44":"Quando transformou em sangue os seus canais,e as suas torrentes, privando-os de beber."
,"45":"Quando lhes mandou moscas que os devoravam, e rãs que os devastavam."
,"46":"Quando entregou às larvas as suas colheitas, e o seu trabalho aos gafanhotos."
,"47":"Quando destruiu a sua vinha com granizo, e os seus sicômoros com geada."
,"48":"Quando abandonou o seu gado à saraiva, e aos relâmpagos o seu rebanho."
,"49":"Quando lançou contra eles o fogo da sua ira: cólera, furor e aflição, anjos portadores de desgraças,"
,"50":"e deu livre curso à sua ira, não os preservou da morte, mas entregou à peste as suas vidas."
,"51":"Quando feriu todo o primogénito no Egipto, as primícias da raça nas tendas de Cam."
,"52":"Fez partir o seu povo como rebanho, e como ovelhas os conduziu pelo deserto."
,"53":"Guiou-os com segurança, sem alarme, enquanto o mar cobria os seus inimigos."
,"54":"Introduziu-os pelas fronteiras santas, até à montanha que a sua direita conquistara."
,"55":"Expulsou da frente deles as nações, e distribuiu-lhes as terras em herança, colocando nas suas tendas as tribos de Israel."
,"56":"Ainda assim tentavam e afrontavam o Deus Altíssimo, recusando guardar os seus preceitos."
,"57":"Desviaram-se, traíam como os seus pais, voltavam atrás como arco infiel."
,"58":"Com os seus lugares altos indignavam-n'O, e enciumavam-n'O com os seus ídolos."
,"59":"Deus ouviu e ficou enfurecido, e rejeitou Israel completamente."
,"60":"Abandonou a sua moradia em Silo, a tenda onde habitava entre os homens."
,"61":"Entregou os seus valentes ao cativeiro, e o seu esplendor à mão do opressor."
,"62":"Abandonou o seu povo à espada, e enfureceu-Se contra a sua herança."
,"63":"Os seus jovens foram devorados pelo fogo, e as suas virgens não tiveram canto de núpcias."
,"64":"Os seus sacerdotes caíram sob a espada, e as suas viúvas não entoaram lamentações."
,"65":"E o Senhor acordou como alguém que dormia, como valente embriagado pelo vinho."
,"66":"Feriu os seus opressores pelas costas,e para sempre os entregou à vergonha."
,"67":"Rejeitou a tenda de José, e não elegeu a tribo de Efraim."
,"68":"Escolheu a tribo de Judá, e o monte Sião, seu preferido."
,"69":"Construiu o seu santuário como o Céu, e firmou-o para sempre, como a Terra."
,"70":"Escolheu David, seu servo, e tirou-o do aprisco das ovelhas."
,"71":"Da companhia das ovelhas o tirou,para apascentar Jacob, seu povo, e Israel, sua herança."
,"72":"Ele os apascentou de coração íntegro, e os conduziu com mão inteligente."
}`)
	CurrentBook.AddChapter(79, `{
"1":"Salmo. De Asaf. Ó Deus, as nações invadiram a tua herança, profanaram o teu Templo santo, reduziram Jerusalém a ruínas."
,"2":"Deram os cadáveres dos teus servos,como alimento às aves do céu, e a carne dos teus fiéis,às feras da terra."
,"3":"Derramaram o seu sangue como água,ao redor de Jerusalém, e ninguém o enterrava."
,"4":"Nós tornámo-nos ultraje para os nossos vizinhos, divertimento e zombaria para aqueles que nos cercam."
,"5":"Até quando, Javé?,Ficarás irado até ao fim?,O teu ciúme vai arder como fogo?"
,"6":"Derrama o teu furor,sobre essas nações que não Te reconhecem, sobre esses reinos que não invocam o teu Nome."
,"7":"Eles devoraram Jacob,e devastaram a sua moradia."
,"8":"Não recordes contra nós,as faltas dos nossos antepassados. Que a tua compaixão venha depressa até nós, pois estamos muito enfraquecidos."
,"9":"Socorre-nos, ó Deus salvador nosso, pela honra do teu Nome!,Liberta e perdoa os nossos pecados,por causa do teu Nome!"
,"10":"Porque diriam as nações: «Onde está o seu Deus?»,Que diante dos nossos olhos as nações reconheçam a vingança,do sangue derramado dos teus servos."
,"11":"Chegue à tua presença o gemido do cativo: com o teu braço poderoso,salva os condenados à morte,"
,"12":"e aos nossos vizinhos devolve sete vezes,a afronta com que Te afrontaram, Senhor!"
,"13":"Quanto a nós, teu povo, ovelhas do teu rebanho, nós Te celebramos para sempre, e de geração em geração,vamos proclamar o teu louvor!"
}`)
	CurrentBook.AddChapter(80, `{
"1":"Do mestre de canto. Sobre a ária: «Os lírios são os preceitos». De Asaf. Salmo."
,"2":"Pastor de Israel, dá ouvidos, Tu que diriges a José como a um rebanho; Tu que Te sentas sobre os querubins, resplandece"
,"3":"perante Efraim, Benjamim e Manassés!,Desperta o teu poder e vem socorrer-nos."
,"4":"Restaura-nos, ó Deus, Faz brilhar a tua face, e seremos salvos!"
,"5":"Javé Deus dos Exércitos, até quando ficarás irado,enquanto o teu povo suplica?"
,"6":"Tu deste-lhe pranto a comer,e abundantes lágrimas a beber."
,"7":"Tu fizeste de nós a disputa dos nossos vizinhos, e os nossos inimigos zombam de nós."
,"8":"Restaura-nos, Deus dos Exércitos!,Faz brilhar a tua face, e seremos salvos!"
,"9":"Tiraste uma videira do Egipto, expulsaste nações, e a transplantaste."
,"10":"Preparaste o terreno e, lançando raízes, ela encheu a Terra."
,"11":"A sua sombra cobria as montanhas, e os seus ramos, os cedros de Deus."
,"12":"Ela estendia os ramos até ao mar, e até ao rio os seus rebentos."
,"13":"Porque lhe derrubaste as cercas?,Para que os viandantes a saqueiem,"
,"14":"e os javalis da floresta a devastem, e as feras do campo a devorem?"
,"15":"Volta atrás, ó Deus dos Exércitos!,Olha do céu e vê!,Vem visitar a tua vinha,"
,"16":"a cepa que a tua direita plantou, e que tornaste vigorosa."
,"17":"Eles queimavam-na como lixo, mas vão perecer com a ameaça da tua face."
,"18":"Que a tua mão proteja o teu escolhido, o homem que Tu confirmaste."
,"19":"Nunca mais nos afastaremos de Ti. Faz-nos viver, para invocarmos o teu Nome."
,"20":"Restaura-nos, Javé, Deus dos Exércitos!,Faz brilhar a tua face, e seremos salvos!"
}`)
	CurrentBook.AddChapter(81, `{
"1":"Do mestre de canto. Sobre a harpa de Gat. De Asaf."
,"2":"Aclamai a Deus, nossa força, aclamai ao Deus de Jacob."
,"3":"Acompanhai, tocai os pandeiros, a harpa melodiosa e a cítara."
,"4":"Tocai a trombeta pelo novo mês, na lua cheia, dia da nossa festa."
,"5":"Porque é uma lei para Israel, um preceito do Deus de Jacob,"
,"6":"uma norma estabelecida para José, quando ele saiu da terra do Egipto. Ouço uma linguagem desconhecida:"
,"7":"«Tirei a carga de cima dos teus ombros, e as tuas mãos largaram o cesto."
,"8":"Clamaste na opressão, e Eu libertei-te. Escondido no trovão, Eu respondi-te, e provei-te nas águas de Meriba»."
,"9":"Escuta, povo meu, Eu vou testemunhar contra ti. Oxalá Me ouvisses, Israel!"
,"10":"«Nunca haja no meio de ti um deus estranho, nunca adores um deus estrangeiro."
,"11":"Eu sou Javé, teu Deus, que te tirei da terra do Egipto. Abre a tua boca, e Eu enchê-la-ei»."
,"12":"E o meu povo não escutou a minha voz, Israel não quis obedecer-Me."
,"13":"Então Eu entreguei-os ao seu coração endurecido: que sigam os seus próprios caminhos!"
,"14":"Ah! Se o meu povo Me escutasse, se Israel andasse nos meus caminhos..."
,"15":"Eu derrotaria os seus inimigos num instante, e contra os seus opressores voltaria a minha mão."
,"16":"Os que odeiam Javé adulá-l'O-iam, e o tempo deles teria passado para sempre."
,"17":"Eu alimentar-te-ia com a flor do trigo,e saciar-te-ia com o mel do rochedo."
}`)
	CurrentBook.AddChapter(82, `{
"1":"Salmo. De Asaf. Deus levanta-Se no conselho divino, no meio dos deuses Ele julga:"
,"2":"«Até quando julgareis injustamente, sustentando a causa dos injustos?"
,"3":"Protegei o fraco e o órfão, fazei justiça ao pobre e ao necessitado,"
,"4":"libertai o fraco e o indigente, e livrai-o da mão dos injustos!»"
,"5":"Eles não sabem, não entendem, vagueiam nas trevas: todos os fundamentos da Terra se abalam."
,"6":"Eu declaro: «Embora vós sejais deuses, e todos filhos do Altíssimo,"
,"7":"morrereis como qualquer homem. Vós, príncipes, caireis como qualquer outro»."
,"8":"Levanta-Te, ó Deus, e julga a Terra, pois as nações todas Te pertencem!"
}`)
	CurrentBook.AddChapter(83, `{
"1":"Salmo. Cântico. De Asaf."
,"2":"Ó Deus, não Te cales, não fiques mudo e imóvel, ó Deus!"
,"3":"Eis que os teus inimigos se agitam, os que Te odeiam levantam a cabeça."
,"4":"Eles tramam um plano contra o teu povo, conspiram contra os teus protegidos:"
,"5":"«Vinde, vamos eliminá-los do meio das nações, e o nome de Israel nunca mais será lembrado!»"
,"6":"Todos de acordo conspiram,e fazem aliança contra Ti:"
,"7":"os beduínos edomitas e os ismaelitas, moabitas e agarenos,"
,"8":"Gebal, Amon e Amalec, os filisteus com os habitantes de Tiro;"
,"9":"também os assírios a eles se aliaram, dando reforço aos filhos de Lot."
,"10":"Faz-lhes o mesmo que fizeste a Madiã e Sísara, e a Jabin na torrente Quison."
,"11":"Foram aniquilados em Endor, tornaram-se esterco para a terra."
,"12":"Trata os seus príncipes como Oreb e Zeb, como Zebá e Sálmana, todos os seus chefes."
,"13":"Eles diziam: «Tomemos posse,dos territórios de Deus!»"
,"14":"Meu Deus, trata-os como folhas que voam, como a palha diante do vento;"
,"15":"como o fogo que devora uma floresta, e a chama que abrasa as montanhas."
,"16":"Persegue-os com a tua tempestade, aterroriza-os com o teu furacão."
,"17":"Cobre-lhes a face de infâmia, para que busquem o teu Nome, ó Javé!"
,"18":"Fiquem envergonhados e perturbados para sempre, sejam confundidos e arruinados."
,"19":"Saberão assim que só Tu tens o nome de Javé, o Altíssimo sobre toda a Terra!"
}`)
	CurrentBook.AddChapter(84, `{
"1":"Do mestre do coro. Sobre a harpa de Gat. Dos filhos de Coré. Salmo."
,"2":"Como são desejáveis as tuas moradas, Javé dos Exércitos!"
,"3":"A minha alma suspira e desfalece,pelos átrios de Javé. O meu coração e a minha carne,exultam pelo Deus vivo."
,"4":"Até o pássaro encontrou uma casa, e a andorinha, um ninho, onde põe os seus filhotes: junto dos teus altares, Javé dos Exércitos, meu rei e meu Deus!"
,"5":"Felizes os que habitam na tua casa: eles louvam-Te sem cessar."
,"6":"Felizes os que encontram em Ti a sua força,ao preparar a sua peregrinação:"
,"7":"quando atravessam vales áridos, eles transformam-nos em oásis, como se a primeira chuva,os cobrisse de bênçãos."
,"8":"Eles caminham de fortaleza em fortaleza,até verem Deus em Sião."
,"9":"Javé, Deus dos Exércitos, ouve a minha súplica, dá-me ouvidos, ó Deus de Jacob."
,"10":"Vê o nosso escudo, ó Deus, olha a face do teu ungido."
,"11":"Sim, mais vale um dia em teus átrios, do que milhares em minha casa. Prefiro o umbral da casa de Deus,do que habitar na tenda dos injustos."
,"12":"Porque Javé é sol e escudo, Deus concede graça e glória. Javé não recusa nenhum bem,aos que andam na integridade."
,"13":"Javé dos Exércitos, feliz o homem,que confia em Ti!"
}`)
	CurrentBook.AddChapter(85, `{
"1":"Do mestre de canto. Dos filhos de Coré. Salmo."
,"2":"Favoreceste, Javé, a tua Terra, restauraste os cativos de Jacob."
,"3":"Perdoaste a culpa do teu povo, encobriste todo o seu pecado."
,"4":"Reprimiste todo o teu furor, refreaste o ardor da tua ira."
,"5":"Restaura-nos, ó Deus, nosso salvador, renuncia ao teu rancor contra nós!"
,"6":"Ficarás irado connosco para sempre, prolongando de geração em geração a tua ira?"
,"7":"Não nos irás devolver a vida, para que o teu povo se alegre contigo?"
,"8":"Javé, mostra-nos o teu amor, concede-nos a tua salvação."
,"9":"Vou escutar o que diz Javé: «Deus anuncia a paz,ao seu povo e aos seus fiéis, e aos que se convertem de coração»."
,"10":"A salvação está próxima dos que O temem, e a glória habitará na nossa Terra."
,"11":"Amor e fidelidade encontram-se, a Justiça e a Paz abraçam-se."
,"12":"A Fidelidade brotará da terra, e a Justiça inclinar-se-á do céu."
,"13":"Javé dar-nos-á a chuva, e a nossa terra dará o seu fruto."
,"14":"A Justiça caminhará à sua frente, a salvação seguirá os seus passos."
}`)
	CurrentBook.AddChapter(86, `{
"1":"Oração. De David. Inclina o teu ouvido, Javé, responde-me, porque sou pobre e indigente!"
,"2":"Guarda-me, porque sou fiel, salva o teu servo que em Ti confia!"
,"3":"Tu és o meu Deus, tem piedade de mim, Senhor, pois é a Ti que eu invoco o dia todo!"
,"4":"Alegra a alma do teu servo, pois a Ti elevo a minha alma!"
,"5":"Tu és bom, ó Senhor, e perdoas. Tu és cheio de amor para todos os que Te invocam."
,"6":"Atende a minha prece, Javé, considera a minha voz suplicante."
,"7":"No dia da angústia eu grito por Ti, pois Tu me respondes, Senhor."
,"8":"Entre os deuses não há outro igual a Ti, nada que se iguale às tuas obras!"
,"9":"Todas as nações virão,para se prostrar na tua presença, Senhor, e bendizer o teu nome:"
,"10":"«Tu és grande, e fazes maravilhas. Tu és o único Deus»."
,"11":"Ensina-me o teu caminho, Javé, e caminharei segundo a tua verdade. Conserva íntegro o meu coração,no temor do teu Nome."
,"12":"Eu Te agradeço de todo o coração, meu Deus, vou dar glória ao teu Nome para sempre,"
,"13":"pois é grande o teu amor para comigo: Tu me tiraste das profundezas da morte."
,"14":"Ó Deus, os soberbos levantam-se contra mim, um bando de violentos persegue a minha vida, e não Te têm diante dos olhos."
,"15":"Tu, porém, Senhor, Deus de piedade e compaixão, lento para a cólera, cheio de amor e fidelidade,"
,"16":"volta-Te para mim, tem piedade de mim. Dá força ao teu servo, salva o filho da tua serva."
,"17":"Realiza para mim um sinal de bondade: os meus inimigos verão e ficarão envergonhados, porque Tu, Javé, me socorres e consolas."
}`)
	CurrentBook.AddChapter(87, `{
"1":"Dos filhos de Coré. Salmo. Cântico. Sião foi construída sobre o monte santo,"
,"2":"e Javé prefere as suas portas,a todas as moradas de Jacob."
,"3":"Que anúncio glorioso para ti, ó cidade de Deus!"
,"4":"«Contarei o Egipto e a Babilónia,entre os meus fiéis. Filisteus, tírios e etíopes,lá nasceram»."
,"5":"E de Sião dir-se-á: «Todo o homem lá nasceu. Ela foi fundada pelo Altíssimo em pessoa»."
,"6":"Javé inscreve os povos no registo: «Este homem nasceu lá»."
,"7":"E enquanto dançam, cantarão: «Em ti se encontram todas as minhas fontes»."
}`)
	CurrentBook.AddChapter(88, `{
"1":"Cântico. Salmo. Dos filhos de Coré. Do mestre de canto. Para a doença. Para a aflição. Poema. De Emã, o ezraíta."
,"2":"Javé, meu Deus, de dia Te peço auxílio, e de noite grito na tua presença."
,"3":"Que a minha prece chegue a Ti, inclina o teu ouvido ao meu clamor."
,"4":"Porque a minha alma está cheia de males, e a minha vida está à beira do túmulo."
,"5":"Sou visto como quem desce à sepultura, tornei-me homem sem forças,"
,"6":"tenho a minha cama entre os mortos, como as vítimas que jazem no sepulcro, das quais já não Te lembras, porque foram arrancadas da tua mão."
,"7":"Lançaste-me no fundo da cova, no meio das trevas do abismo."
,"8":"A tua cólera pesa sobre mim, derramas sobre mim todas as tuas ondas."
,"9":"Afastaste de mim os meus conhecidos, e tornaste-me repugnante para eles: estou fechado, não posso sair,"
,"10":"e os meus olhos turvam-se de tristeza. Eu Te invoco todo o dia, estendendo as mãos para Ti:"
,"11":"«Farás maravilhas pelos mortos?,As sombras vão levantar-se para Te louvar?"
,"12":"Falarão do teu amor nas sepulturas, e da tua fidelidade no reino da morte?"
,"13":"Conhecem as tuas maravilhas nas trevas, e a tua justiça na terra do esquecimento?»"
,"14":"Mas eu grito para Ti, Javé, a minha prece chega a Ti pela manhã."
,"15":"Javé, porque me rejeitas,e me escondes a tua face?"
,"16":"Fui infeliz e moribundo desde a infância, sofri os teus horrores, estou esgotado."
,"17":"Os teus furores passaram sobre mim, os teus terrores deixaram-me consumido."
,"18":"Eles cercam-me como água todo o dia, e assaltam-me todos juntos."
,"19":"Tu afastas de mim os meus parentes e amigos, e as trevas são a minha companhia."
}`)
	CurrentBook.AddChapter(89, `{
"1":"Poema. De Etã, o ezraíta."
,"2":"Cantarei para sempre o amor de Javé, anunciarei de geração em geração a tua fidelidade."
,"3":"Pois eu disse: «O teu amor é um edifício eterno. Tu firmaste a tua fidelidade mais que o céu»."
,"4":"Selei uma aliança com o meu eleito, jurando ao meu servo David:"
,"5":"«Vou estabelecer a tua descendência para sempre, e de geração em geração,vou construir um trono para ti»."
,"6":"O céu proclama as tuas maravilhas, Javé, e a tua fidelidade na assembleia dos anjos."
,"7":"Sobre as nuvens, quem é como Javé?,Dentre os seres divinos, quem é como Javé?"
,"8":"Deus é terrível no conselho dos anjos, grande e terrível com toda a sua corte."
,"9":"Javé dos Exércitos, quem é igual a Ti?,O poder e a fidelidade envolvem-Te."
,"10":"Tu dominas o orgulho do mar,e amansas as ondas que se elevam."
,"11":"Tu esmagaste Raab como a um cadáver, o teu braço poderoso dispersou os teus inimigos."
,"12":"Teu é o Céu, e a Terra Te pertence, Tu fundaste o mundo, e tudo o que nele existe."
,"13":"O Norte e o Sul, Tu os criaste. O Tabor e o Hermon aclamam o teu Nome."
,"14":"O teu braço é poderoso, a tua esquerda é forte, e a tua direita elevada."
,"15":"A Justiça e o Direito sustentam o teu trono. O Amor e a Fidelidade precedem a tua face."
,"16":"Feliz o povo que sabe aclamar-Te: ele caminhará, ó Javé, à luz da tua face."
,"17":"O teu Nome é o seu prazer em cada dia, e a tua justiça é o seu orgulho."
,"18":"Sim, Tu és a sua honra e força, e com o teu favor levantas a nossa fronte."
,"19":"Porque Javé é o nosso escudo, o nosso rei é o Santo de Israel."
,"20":"Outrora falaste numa visão aos teus fiéis: «Prestei auxílio a um bravo, exaltei um eleito dentre o povo:"
,"21":"encontrei o meu servo David, e ungi-o com o meu óleo santo,"
,"22":"para que a minha mão esteja sempre com ele, e o meu braço o torne valoroso."
,"23":"O inimigo não poderá enganá-lo, nem o perverso humilhá-lo."
,"24":"Diante dele esmagarei os seus opressores,e ferirei os seus inimigos."
,"25":"A minha fidelidade e amor estarão com ele, e pelo meu Nome o seu poder crescerá:"
,"26":"estenderei a sua esquerda até ao mar, e a sua direita até aos rios."
,"27":"Ele invocar-me-á: 'Tu és o meu pai, o meu Deus e o meu rochedo salvador!'"
,"28":"E Eu o tornarei meu primogénito, o altíssimo sobre os reis da Terra."
,"29":"Para sempre vou manter com ele o meu amor, e a minha aliança com ele será firme."
,"30":"Vou dar-lhe uma descendência para sempre, e um trono duradouro como o céu."
,"31":"Se os seus filhos abandonarem a minha lei,e não seguirem as minhas normas;"
,"32":"se profanarem os meus estatutos,e não guardarem os meus mandamentos,"
,"33":"punirei a sua transgressão com vara, e as suas culpas com açoites."
,"34":"Mas nunca vou tirar-lhes o meu amor, nem desmentir a minha fidelidade."
,"35":"Jamais violarei a minha aliança, nem mudarei as minhas promessas."
,"36":"Pela minha santidade, Eu jurei uma vez: Jamais mentirei a David."
,"37":"A sua descendência será perpétua, o seu trono como o Sol à minha frente,"
,"38":"como a Lua, firmada para sempre: o seu trono será mais firme que o céu»."
,"39":"Tu, porém, rejeitaste-o e desprezaste-o, ficaste indignado com o teu ungido."
,"40":"Quebraste a aliança com o teu servo, até ao chão profanaste a sua coroa."
,"41":"Derrubaste as suas muralhas,e arruinaste as suas fortalezas."
,"42":"Todos os passantes o saqueiam, e ele tornou-se zombaria dos vizinhos."
,"43":"Exaltaste a direita dos seus opressores, alegraste todos os seus inimigos."
,"44":"Embotaste o corte da sua espada, e não o sustentaste na batalha."
,"45":"Quebraste o seu ceptro glorioso, e derrubaste o seu trono por terra."
,"46":"Encurtaste os dias da sua juventude, e cobriste-o de vergonha."
,"47":"Javé, até quando Te esconderás?,Até quando arderá o fogo da tua cólera?"
,"48":"Lembra-Te, Senhor, de como é breve a minha vida, como passam despressa os homens que criaste!"
,"49":"Quem viverá sem ver a morte?,Quem tirará a sua vida das garras do túmulo?"
,"50":"Onde está, Senhor, o antigo amor, que, pela tua fidelidade, juraste a David?"
,"51":"Lembra-Te, Senhor, da desonra dos teus servos: eu trago no meu peito todas as afrontas dos povos."
,"52":"Lembra-te de como os teus inimigos ultrajaram, ó Javé, de como ultrajaram as pegadas do teu ungido!"
,"53":"Seja bendito Javé para sempre!,Ámen! Ámen!"
}`)
	CurrentBook.AddChapter(90, `{
"1":"Súplica. De Moisés, homem de Deus. Senhor, Tu foste o nosso refúgio,de geração em geração."
,"2":"Antes que os montes nascessem,e a terra e o mundo fossem gerados, desde sempre e para sempre Tu és Deus."
,"3":"Tu reduzes o homem ao pó, dizendo: «Voltai, filhos de Adão!»"
,"4":"Mil anos são aos teus olhos,como o dia de ontem, que passou, uma vigília dentro da noite."
,"5":"Tu os mergulhas no sono, como erva que se renova:"
,"6":"de manhã ela germina e brota, de tarde cortam-na, e seca."
,"7":"Sim, a tua ira consumiu-nos, e o teu furor transtornou-nos."
,"8":"Colocaste as nossas faltas à tua frente, os nossos segredos sob a luz da tua face."
,"9":"Os nossos dias passaram sob a tua cólera, e como um suspiro os nossos anos se acabaram."
,"10":"Setenta anos é o tempo da nossa vida, oitenta anos, se ela for vigorosa. E a maior parte deles é fadiga inútil, pois passam depressa, e nós voamos."
,"11":"Quem conhece a força da tua ira, e quem sentiu o peso do teu furor?"
,"12":"Ensina-nos a contar os nossos anos, para que tenhamos coração sensato!"
,"13":"Volta-Te, Javé! Até quando?,Tem compaixão dos teus servos!"
,"14":"Sacia-nos com o teu amor pela manhã, e a nossa vida será júbilo e alegria."
,"15":"Alegra-nos, pelos dias em que nos castigaste, pelos anos em que sofremos desgraças."
,"16":"Que os teus servos vejam a tua obra, e seus filhos o teu esplendor."
,"17":"Que a bondade do Senhor venha sobre nós,e confirme a obra das nossas mãos."
}`)
	CurrentBook.AddChapter(91, `{
"1":"Tu que habitas ao amparo do Altíssimo, e vives à sombra do Omnipotente,"
,"2":"diz a Javé: «Meu refúgio, minha fortaleza, meu Deus, eu confio em Ti!»"
,"3":"Ele te livrará do laço do caçador, e da peste destruidora."
,"4":"Ele te cobrirá com as suas penas, e debaixo das suas asas te refugiarás. O seu braço é escudo e armadura."
,"5":"Não temerás o terror da noite, nem a flecha que voa de dia,"
,"6":"nem a epidemia que caminha nas trevas, nem a peste que devasta ao meio-dia."
,"7":"Podem cair mil a teu lado,e dez mil à tua direita, a ti nada te atingirá."
,"8":"Basta que olhes com os teus próprios olhos, para veres o salário dos injustos,"
,"9":"porque fizeste de Javé o teu refúgio,e tomaste o Altíssimo como defensor."
,"10":"A desgraça jamais te atingirá, e nenhuma praga vai chegar à tua tenda,"
,"11":"pois Ele ordenou aos seus anjos,que te guardem nos teus caminhos."
,"12":"Eles levar-te-ão nas mãos, para que o teu pé não tropece em nenhuma pedra."
,"13":"Caminharás sobre cobras e víboras, e pisarás leões e dragões."
,"14":"«Livrá-lo-ei, porque a Mim se apegou. Protegê-lo-ei, pois conhece o meu Nome. Ele invocar-Me-á, e Eu responderei."
,"15":"Na angústia estarei com ele. Hei-de livrá-lo e glorificá-lo."
,"16":"Vou saciá-lo com longos dias,e far-lhe-ei ver a minha salvação»."
}`)
	CurrentBook.AddChapter(92, `{
"1":"Salmo. Cântico. Para o dia de sábado."
,"2":"É bom agradecer a Javé, e tocar ao teu Nome, ó Altíssimo;"
,"3":"anunciar pela manhã o teu amor,e a tua fidelidade pela noite,"
,"4":"com a lira de dez cordas, com a cítara, e as vibrações da harpa:"
,"5":"porque os teus actos, Javé, são a minha alegria, e as obras das tuas mãos o meu júbilo."
,"6":"Como são grandes as tuas obras, Javé, e os teus projectos, como são profundos!"
,"7":"O imbecil não os compreende, o idiota não entende nada disso."
,"8":"Ainda que os injustos brotem como a erva, e todos os malfeitores floresçam, eles serão destruídos para sempre."
,"9":"Porém Tu, Javé, Tu és elevado para sempre!"
,"10":"Eis que os teus inimigos perecem, e os malfeitores todos se dispersam."
,"11":"Tu dás-me o vigor de um touro,e unges-me com óleo novo."
,"12":"Os meus olhos vêem aqueles que me espreitam, os meus ouvidos escutam os malfeitores."
,"13":"O justo brota como a palmeira, cresce como o cedro do Líbano:"
,"14":"plantado na casa de Javé, brota nos átrios do nosso Deus."
,"15":"Mesmo na velhice dará fruto, estará viçoso e frondoso,"
,"16":"para anunciar que Javé é recto, e que na minha Rocha não há injustiça."
}`)
	CurrentBook.AddChapter(93, `{
"1":"Javé é Rei, vestido de majestade, Javé está vestido e envolto em poder: o mundo está firme e jamais tremerá."
,"2":"O teu trono está firme desde a origem, e desde sempre Tu existes."
,"3":"Levantam os rios, ó Javé, os rios levantam a sua voz, os rios levantam o seu rumor."
,"4":"Porém, mais que o estrondo das águas torrenciais, mais poderoso que a ressaca do mar, é Javé majestoso nas alturas."
,"5":"Os teus testemunhos são firmes de facto, a santidade é o adorno da tua casa, durante dias sem fim, ó Javé!"
}`)
	CurrentBook.AddChapter(94, `{
"1":"Javé, Deus das vinganças!,Aparece, ó Deus das vinganças!"
,"2":"Levanta-Te, ó juiz da terra, devolve o merecido aos soberbos!"
,"3":"Até quando os injustos, ó Javé, até quando os injustos irão triunfar?"
,"4":"Eles transbordam em palavras insolentes, todos os malfeitores se gabam."
,"5":"Eles massacram o teu povo, Javé, eles humilham a tua herança;"
,"6":"matam a viúva e o estrangeiro,e assassinam os órfãos."
,"7":"E comentam: «Javé nada vê, o Deus de Jacob não Se dá conta»."
,"8":"Percebei vós, imbecis consumados. Idiotas, quando ireis entender?"
,"9":"Quem formou o ouvido, não ouvirá?,Quem formou o olho, não verá?"
,"10":"Quem educa as nações, não punirá?,Quem ensina o homem, não saberá?"
,"11":"Javé sabe que os pensamentos do homem,são apenas um sopro."
,"12":"Feliz o homem a quem educas, Javé, a quem ensinas com a tua Lei,"
,"13":"dando-lhe descanso nos dias maus, enquanto para o injusto se abre uma cova."
,"14":"Porque Javé não rejeita o seu povo, jamais abandona a sua herança;"
,"15":"o justo alcançará o seu direito, e os corações rectos terão futuro."
,"16":"Quem se levanta a meu favor contra os maus?,Quem se coloca ao meu lado,contra os malfeitores?"
,"17":"Se Javé não viesse em meu socorro, eu já estaria a habitar no silêncio."
,"18":"Quando me parece que vou tropeçar, o teu amor me sustenta, Javé."
,"19":"Quando as minhas preocupações se multiplicam,as tuas consolações alegram-me."
,"20":"Poderá acaso aliar-se a Ti um tribunal criminoso,que dita injustiças em nome da lei?"
,"21":"Embora atentem contra a vida do justo, e condenem à morte o inocente,"
,"22":"Javé será a minha fortaleza, Deus será a rocha onde me abrigo."
,"23":"Ele é quem lhes pagará pela sua injustiça, e destruí-los-á pela maldade que praticam. Javé nosso Deus destruí-los-á!"
}`)
	CurrentBook.AddChapter(95, `{
"1":"Vinde, exultemos em Javé, aclamemos o Rochedo que nos salva."
,"2":"Entremos com louvor na sua presença, vamos aclamá-l'O com instrumentos."
,"3":"Porque Javé é um Deus grande, o soberano de todos os deuses."
,"4":"Ele tem nas mãos as profundezas da Terra, e é d'Ele o cimo das montanhas."
,"5":"D'Ele é o mar, pois foi Ele quem o fez, e a terra firme, que as suas mãos modelaram."
,"6":"Entrai, prostrai-vos e inclinai-vos, bendizendo a Javé que nos fez."
,"7":"Porque Ele é o nosso Deus, e nós somos o seu povo, o rebanho que Ele conduz. Oxalá escuteis hoje o que Ele diz:"
,"8":"«Não endureçais os vossos corações como aconteceu em Meriba, como no dia de Massa, no deserto,"
,"9":"quando os vossos antepassados Me provocaram,e tentaram, mesmo vendo as minhas obras»."
,"10":"Durante quarenta anos,aquela geração Me desgostou. Então Eu disse: «É um povo de coração transviado, que não reconhece os meus caminhos..."
,"11":"Por isso Eu jurei na minha ira: Jamais entrarão no meu repouso»."
}`)
	CurrentBook.AddChapter(96, `{
"1":"Cantai a Javé um cântico novo!,Terra inteira, canta a Javé!"
,"2":"Cantai a Javé, bendizei o seu Nome!,Proclamai a sua vitória dia após dia,"
,"3":"anunciai a sua glória por entre as nações, as suas maravilhas a todos os povos!"
,"4":"Porque Javé é grande e digno de louvor, mais terrível que todos os deuses!"
,"5":"Sim, os deuses dos povos são aparência, enquanto Javé fez o céu."
,"6":"Majestade e esplendor O precedem, poder e beleza estão no seu Templo."
,"7":"Famílias dos povos, aclamai a Javé!,Aclamai a glória e o poder de Javé!"
,"8":"Aclamai a glória do Nome de Javé, entrai no seu átrio, trazendo-Lhe ofertas."
,"9":"Adorai a Javé no seu átrio sagrado. Terra inteira, treme na presença de Javé!"
,"10":"Dizei às nações: Javé é Rei!,Ele firmou o mundo, que jamais tremerá. Ele governa os povos com rectidão."
,"11":"Que o céu se alegre e a Terra exulte, estrondeie o mar, e tudo o que ele contém."
,"12":"Que o campo festeje, e tudo o que nele existe, e as árvores da selva gritem de alegria,"
,"13":"diante de Javé, pois Ele vem. Ele vem para governar a Terra: governará o mundo com justiça, e as nações com fidelidade."
}`)
	CurrentBook.AddChapter(97, `{
"1":"Javé é Rei! A terra exulta, e as ilhas numerosas ficam alegres!"
,"2":"Trevas e nuvens O envolvem, Justiça e Direito sustentam o seu trono."
,"3":"À frente d'Ele avança um fogo, devorando os seus inimigos ao redor."
,"4":"Os seus relâmpagos deslumbram o mundo, e, ao vê-los, a Terra estremece."
,"5":"Os montes derretem-se como cera,diante do Senhor de toda a Terra."
,"6":"O céu anuncia a sua justiça, e todos os povos contemplam a sua glória."
,"7":"Envergonhar-se-ão os que adoram estátuas, todos os que se orgulham dos ídolos. Porque diante d'Ele todos os deuses se prostram."
,"8":"Sião ouve e alegra-se, e as cidades de Judá exultam,por causa das tuas sentenças, ó Javé."
,"9":"Sim, porque Tu és, ó Javé, o Altíssimo sobre a Terra inteira, mais elevado que todos os deuses."
,"10":"Javé ama quem detesta o mal, Ele protege a vida dos seus fiéis,e liberta-os da mão dos injustos."
,"11":"A luz levanta-se para o justo, e a alegria para os corações rectos."
,"12":"Justos, alegrai-vos com Javé, e celebrai a sua memória santa!"
}`)
	CurrentBook.AddChapter(98, `{
"1":"Salmo. Cantai a Javé um cântico novo, pois Ele fez maravilhas: a sua direita e o seu braço santo,Lhe deram a vitória."
,"2":"Javé fez conhecer a sua vitória, revelou a sua justiça às nações."
,"3":"Lembrou-Se do seu amor e fidelidade,em favor da casa de Israel. Os confins da Terra contemplaram,a vitória do nosso Deus."
,"4":"Terra inteira, aclama a Javé, e dá gritos de alegria!"
,"5":"Tocai para Javé com a harpa,e o som dos instrumentos."
,"6":"Com trombetas e o som da corneta, aclamai o rei Javé!"
,"7":"Estrondeie o mar e o que ele contém, o mundo e os seus habitantes."
,"8":"Batam palmas os rios todos, e as montanhas gritem de alegria,"
,"9":"diante de Javé, pois Ele vem,para governar a Terra. Ele governará o mundo com justiça,e os povos com rectidão."
}`)
	CurrentBook.AddChapter(99, `{
"1":"Javé é Rei: os povos estremecem!,Sentado sobre querubins: a Terra agita-se!"
,"2":"Javé é grande em Sião, elevado sobre todos os povos."
,"3":"Reconheçam o teu Nome, grande e terrível: «Ele é Santo!»"
,"4":"Reinas com poder e amas a justiça. Tu estabeleceste a rectidão. Administras a justiça e o direito, Tu ages em Jacob."
,"5":"Exaltai a Javé nosso Deus,e prostrai-vos à frente do seu pedestal: «Ele é Santo!»"
,"6":"Moisés e Aarão, com os seus sacerdotes, e Samuel, com os que invocam o Nome de Javé, clamavam a Javé, e Ele respondia."
,"7":"Deus falava-lhes da coluna de nuvem, e guardavam os seus preceitos, e a Lei que lhes dera."
,"8":"Javé, nosso Deus, Tu respondias-lhes, eras para eles um Deus de perdão, e um Deus vingador das suas maldades."
,"9":"Exaltai a Javé nosso Deus, e prostrai-vos perante o seu monte santo: «Javé, nosso Deus, é Santo!»"
}`)
	CurrentBook.AddChapter(100, `{
"1":"Salmo. Para acção de graças. Terra inteira, aclama a Javé!"
,"2":"Serve a Javé com alegria, e vai até Ele com gritos jubilosos!"
,"3":"Sabei que somente Javé é Deus: Ele nos fez e a Ele pertencemos, somos o seu povo e ovelhas do seu rebanho."
,"4":"Entrai pelas suas portas dando graças, com cantos de louvor em seus átrios, celebrai-O e bendizei o seu Nome:"
,"5":"«Sim, Javé é bom: o seu amor é para sempre, e a sua fidelidade de geração em geração»."
}`)
	CurrentBook.AddChapter(101, `{
"1":"De David. Salmo. Vou cantar o amor e a justiça. Para Ti, Javé, eu quero tocar."
,"2":"Vou andar na integridade: quando virás ao meu encontro?,Andarei de coração íntegro,dentro da minha casa."
,"3":"Não colocarei uma coisa infame,diante dos meus olhos. Eu odeio quem pratica o mal; esse nunca se juntará a mim."
,"4":"Longe de mim o coração pervertido. Eu ignoro o perverso."
,"5":"Quem difama o seu próximo em segredo, eu o farei calar. Olhar altivo e coração orgulhoso, eu não os suportarei."
,"6":"Os meus olhos estão nos leais da Terra, para que habitem comigo. Quem anda no caminho dos íntegros, esse será o meu ministro."
,"7":"Em minha casa não habitará,quem pratica fraudes. E quem diz mentiras não permanecerá,diante dos meus olhos."
,"8":"Em cada manhã eu farei calar,todos os injustos da Terra, para extirpar da cidade de Javé,todos os malfeitores."
}`)
	CurrentBook.AddChapter(102, `{
"1":"Prece de um infeliz que, desfalecido, faz a sua lamentação diante de Javé."
,"2":"Javé, ouve a minha prece, que o meu grito chegue a Ti!"
,"3":"Não me escondas a tua face, no dia da minha angústia. Inclina o teu ouvido para mim, e no dia em que eu Te invoco, responde-me depressa!"
,"4":"Porque os meus dias esvaem-se como o fumo, e os meus ossos ardem como braseiro."
,"5":"Pisado como relva, o meu coração seca, e até me esqueço de comer o meu pão."
,"6":"Por causa da violência do meu grito, os ossos já se colam à minha pele."
,"7":"Estou como o pelicano do deserto, como o mocho das ruínas."
,"8":"Fico acordado, gemendo, como ave solitária no telhado."
,"9":"Os meus inimigos ultrajam-me todo o dia,e amaldiçoam-me, furiosos contra mim."
,"10":"Eu como cinza em vez de pão, e com a minha bebida misturo lágrimas,"
,"11":"por causa da tua cólera e do teu furor, pois me elevaste e me lançaste ao chão."
,"12":"Os meus dias são como a sombra que se expande, e eu vou secando como a relva."
,"13":"Tu, porém, Javé, permaneces para sempre, e a tua lembrança passa de geração em geração!"
,"14":"Levanta-Te, tem pena de Sião, pois é tempo de teres piedade dela. Sim, chegou a hora,"
,"15":"porque os teus servos amam as suas pedras, compadecidos da sua ruína."
,"16":"As nações temerão o teu Nome, e os reis da Terra a tua glória."
,"17":"Quando Javé reconstruir Sião, e aparecer com a sua glória;"
,"18":"quando Se voltar para a prece do indefeso, e não desprezar a sua prece,"
,"19":"fique isto escrito para as gerações futuras, e um povo recriado louvará a Deus:"
,"20":"Javé inclinou-Se do seu alto santuário,e do Céu contemplou a Terra,"
,"21":"para ouvir o gemido dos prisioneiros,e libertar os condenados à morte;"
,"22":"para proclamar em Sião o nome de Javé, e em Jerusalém o seu louvor,"
,"23":"quando se reunirem povos e reinos,para servir a Javé."
,"24":"Ele esgotou a minha força no caminho, encurtou os meus dias."
,"25":"Então eu disse: «Meu Deus, não me arrebates,na metade dos meus dias». Os teus anos duram gerações e gerações."
,"26":"No princípio, Tu firmaste a Terra, e o Céu é obra das tuas mãos."
,"27":"Eles perecerão, mas Tu permaneces. Ficarão gastos como roupa, serão como veste que se muda."
,"28":"Tu, porém, és sempre o mesmo, e os teus anos jamais se acabarão."
,"29":"Os filhos dos teus servos viverão seguros, e a sua descendência manter-se-á na tua presença."
}`)
	CurrentBook.AddChapter(103, `{
"1":"De David. Bendiz a Javé, ó minha alma, e todo o meu ser ao seu Nome santo!"
,"2":"Bendiz a Javé, ó minha alma, e não esqueças nenhum dos seus benefícios."
,"3":"Ele perdoa todas as tuas culpas, e cura todos os teus males."
,"4":"Ele livra da cova a tua vida, e coroa-a de amor e compaixão."
,"5":"Ele sacia os teus anos de bens,e a tua juventude renova-se, como a da águia."
,"6":"Javé faz justiça,e defende todos os oprimidos."
,"7":"Revelou os seus caminhos a Moisés, e as suas façanhas aos filhos de Israel."
,"8":"Javé é compaixão e piedade, lento para a cólera e cheio de amor."
,"9":"Ele não vai disputar perpetuamente, e o seu rancor não dura para sempre."
,"10":"Nunca nos trata conforme os nossos erros, nem nos castiga segundo as nossas culpas."
,"11":"Como o Céu se ergue por sobre a Terra, o seu amor se ergue sobre aqueles que O temem."
,"12":"Como o Oriente está longe do Ocidente, assim Ele afasta de nós as nossas transgressões."
,"13":"Como um pai é compassivo com os seus filhos, Javé é compassivo com aqueles que O temem:"
,"14":"Porque Ele conhece a nossa estrutura, Ele lembra-Se do pó que nós somos."
,"15":"Os dias do homem são como a relva, ele floresce como a flor do campo."
,"16":"Passa por ele um vento, e já não existe, e ninguém mais reconhece o seu lugar."
,"17":"Mas o amor de Javé existe desde sempre, e para sempre existirá para aqueles que O temem. A sua justiça é para os filhos dos filhos,"
,"18":"para os que observam a sua aliança,e se lembram de cumprir as suas ordens."
,"19":"Javé pôs no Céu o seu trono, e a sua realeza governa o Universo."
,"20":"Bendizei a Javé, todos os seus anjos, executores poderosos das suas ordens, obedientes ao som da sua palavra."
,"21":"Bendizei a Javé, todos os seus exércitos, ministros que cumprem a sua vontade."
,"22":"Bendizei a Javé, todas as suas obras, em todos os lugares, onde Ele governa. Bendiz a Javé, ó minha alma!"
}`)
	CurrentBook.AddChapter(104, `{
"1":"Bendiz a Javé, ó minha alma!,Javé, meu Deus, como és grande!,Vestido de esplendor e majestade,"
,"2":"envolto em luz como num manto, estendes os céus como tenda,"
,"3":"e constróis a tua morada sobre as águas. Tomando as nuvens como teu carro, caminhas sobre as asas do vento."
,"4":"Tu fazes dos ventos os teus mensageiros, e das chamas de fogo os teus ministros!"
,"5":"Assentaste a terra sobre as suas bases, inabalável para sempre e eternamente."
,"6":"Cobriste a Terra com o manto do oceano, e as águas pousaram por cima das montanhas."
,"7":"Diante da tua ameaça, porém, elas fugiram, precipitaram-se, ao fragor do teu trovão."
,"8":"Subiram pelos montes, desceram nos vales, para o lugar que lhes tinhas fixado."
,"9":"Marcaste um limite que elas não podem transpor, e não voltarão a cobrir a Terra."
,"10":"Tu fazes brotar fontes de água nos vales, e elas correm por entre as montanhas."
,"11":"Dão de beber a todas as feras do campo, e os asnos selvagens aí matam a sede."
,"12":"Junto a elas se abrigam as aves do céu, soltando o seu canto por entre a folhagem."
,"13":"Das tuas altas moradas regas os montes, e a terra sacia-se com a tua obra fecunda."
,"14":"Tu fazes brotar relva para o rebanho, e plantas úteis para o homem. Dos campos ele tira o pão,"
,"15":"e o vinho que alegra o seu coração; o azeite, que dá brilho ao seu rosto, e o alimento, que lhe dá forças."
,"16":"As árvores de Javé saciam-se, os cedros do Líbano que Ele plantou."
,"17":"Neles fazem ninho as aves do céu, no seu topo a cegonha tem a sua casa."
,"18":"As altas montanhas são para as cabras, e os rochedos um refúgio para as ratazanas."
,"19":"Tu fizeste a Lua para marcar os tempos, o Sol conhece o seu próprio ocaso."
,"20":"Mandas as trevas e vem a noite, e nela rondam as feras da selva;"
,"21":"rugem os leõezinhos em busca da presa, pedindo a Deus o sustento."
,"22":"Ao nascer do sol retiram-se,e abrigam-se nos seus covis."
,"23":"O homem sai para a sua faina, e para o seu trabalho até à tarde."
,"24":"Como são numerosas as tuas obras, Javé!,Fizeste-as todas com sabedoria. A Terra está repleta das tuas criaturas."
,"25":"Eis o vasto mar, com braços imensos, onde se movem, inumeráveis, animais pequenos e grandes."
,"26":"Nele circulam os navios, e o Leviatã, que formaste para com ele brincares."
,"27":"Todos eles esperam de Ti,que a seu tempo lhes atires o alimento:"
,"28":"Tu atiras-lho e eles recolhem-no, abres a tua mão, e saciam-se de bens."
,"29":"Escondes a tua face e eles apavoram-se, retiras-lhes a respiração, e expiram, voltando a ser pó."
,"30":"Envias o teu sopro e eles são criados, e assim renovas a face da Terra."
,"31":"Que a glória de Javé seja para sempre; que Ele Se alegre com as suas obras!"
,"32":"Ele olha a terra e ela estremece, toca as montanhas e elas fumegam."
,"33":"Vou cantar para Javé, enquanto eu viver, louvarei o meu Deus, enquanto existir."
,"34":"Que o meu poema Lhe seja agradável, e eu me alegrarei com Javé."
,"35":"Que os pecadores desapareçam da Terra, e os injustos nunca mais existam. Bendiz a Javé, ó minha alma!,Aleluia!"
}`)
	CurrentBook.AddChapter(105, `{
"1":"Celebrai a Javé, invocai o seu Nome, anunciai entre os povos as suas façanhas!"
,"2":"Cantai-Lhe, ao som de instrumentos, recitai todas as suas maravilhas!"
,"3":"Gloriai-vos do seu Nome santo, alegre-se o coração dos que buscam Javé!"
,"4":"Procurai Javé e a sua força, buscai sempre a sua face."
,"5":"Recordai as maravilhas que Ele fez, os prodígios e as sentenças da sua boca."
,"6":"Descendência de Abraão, seu servo, filhos de Jacob, seu escolhido!"
,"7":"O nosso Deus é Javé, e Ele governa a Terra inteira."
,"8":"Ele lembra-Se para sempre da sua aliança, da palavra empenhada por mil gerações."
,"9":"Da aliança que selou com Abraão, do juramento feito a Isaac,"
,"10":"confirmado como lei para Jacob, como aliança eterna para Israel:"
,"11":"«Dar-te-ei a terra de Canaã, como tua parte na herança»."
,"12":"Quando era possível contá-los, eram pouco numerosos, estrangeiros na Terra:"
,"13":"iam e vinham, de nação em nação, de um reino para um povo diferente."
,"14":"Ele não deixou que ninguém os oprimisse, e, por causa deles, até reis castigou:"
,"15":"«Não toqueis nos meus ungidos, não maltrateis os meus profetas!»"
,"16":"Ele chamou a fome sobre a Terra,e cortou o sustento de pão."
,"17":"Tinha mandado um homem à sua frente: José, vendido como escravo."
,"18":"Com grilhões lhe afligiram os pés,e puseram-lhe ferros no pescoço,"
,"19":"até que se cumpriu a sua predição, e a palavra de Javé lhe deu crédito."
,"20":"O rei mandou soltá-lo, e o senhor dos povos o livrou."
,"21":"E constituiu-o senhor da sua casa, administrador de todos os seus bens,"
,"22":"para instruir a seu gosto os príncipes, e ensinar sabedoria aos anciãos."
,"23":"Então Israel entrou no Egipto, e Jacob residiu na terra de Cam."
,"24":"Deus fez crescer muito o seu povo, e tornou-o mais poderoso que os seus opressores."
,"25":"Mudou-lhes o coração, para que odiassem o seu povo, e usassem de astúcia com os seus servos."
,"26":"Então Ele enviou Moisés, seu servo, e Aarão, a quem escolhera."
,"27":"Contra aqueles fizeram os seus sinais, e os seus prodígios na terra de Cam."
,"28":"Ele mandou-lhes as trevas e tudo escureceu, mas eles opuseram-se às suas ordens."
,"29":"Transformou as suas águas em sangue, fazendo perecer os seus peixes."
,"30":"A sua terra pululou de rãs, até nos aposentos reais."
,"31":"Ordenou que viessem insectos, mosquitos sobre todo o território."
,"32":"Em lugar de chuvas, deu-lhes granizo, chamas de fogo na sua terra."
,"33":"Feriu as suas vinhas e figueiras, e quebrou as árvores do seu território."
,"34":"Ordenou e vieram os gafanhotos, inumeráveis saltadores,"
,"35":"que comeram toda a erva da sua terra, e devoraram o fruto do seu campo."
,"36":"Feriu todos os primogénitos da sua terra, os primeiros frutos da sua raça."
,"37":"Fez sair o seu povo carregado de ouro e prata, e entre as suas tribos ninguém tropeçava."
,"38":"O Egipto alegrou-se quando saíram, porque sobre ele haviam infundido o seu terror."
,"39":"Ele estendeu uma nuvem para os cobrir, e um fogo para iluminar a noite."
,"40":"Pediram, e Ele fez vir codornizes, e saciou-os com o pão do céu."
,"41":"Fendeu a rocha e brotaram águas, correndo no deserto como um rio."
,"42":"Porque Se lembrou da sua palavra sagrada, que dera ao seu servo Abraão:"
,"43":"fez sair o seu povo com alegria, e os seus eleitos com gritos jubilosos."
,"44":"Deu-lhes as terras das nações, e apossaram-se do trabalho dos povos:"
,"45":"para guardarem os seus estatutos,e observarem as suas leis. Aleluia!"
}`)
	CurrentBook.AddChapter(106, `{
"1":"Aleluia!,Agradecei a Javé, porque Ele é bom, porque o seu amor é para sempre!"
,"2":"Quem poderá contar as proezas de Javé,e proclamar todo o seu louvor?"
,"3":"Feliz quem observa o direito,e pratica a justiça em todo o tempo!"
,"4":"Lembra-Te de mim, Javé, por amor do teu povo, visita-me com a tua salvação,"
,"5":"para que eu experimente a felicidade dos teus eleitos, me alegre com a alegria do teu povo, e me glorie com a tua herança!"
,"6":"Nós pecámos como os nossos antepassados, cometemos maldades e injustiças."
,"7":"Os nossos antepassados no Egipto,não compreenderam as tuas maravilhas. Não se lembraram do teu grande amor, e rebelaram-se contra o Altíssimo, junto ao Mar Vermelho."
,"8":"Deus, porém, salvou-os por causa do seu nome, para manifestar o seu poder."
,"9":"Ameaçou o Mar Vermelho, e ele secou, guiou-os pelo abismo, como em terra firme."
,"10":"Salvou-os da mão do adversário, redimiu-os da mão do inimigo."
,"11":"As águas cobriram os seus opressores, e nenhum deles pôde escapar."
,"12":"Então acreditaram nas suas palavras,e cantaram o seu louvor."
,"13":"Bem depressa se esqueceram das suas obras, e não confiaram no seu projecto:"
,"14":"ardiam de ambição no deserto,e tentaram a Deus em lugares solitários."
,"15":"Ele concedeu-lhes o que pediam, mas enviou-lhes uma doença para a sua gula."
,"16":"Causaram ciúmes a Moisés no acampamento, e a Aarão, o consagrado a Javé:"
,"17":"a terra abriu-se e engoliu Datã, e recobriu o grupo de Abiram."
,"18":"Um fogo abrasou o seu grupo, uma chama devorou os injustos."
,"19":"Em Horeb fabricaram um novilho, adoraram um ídolo de metal."
,"20":"Eles trocaram a sua Glória pela imagem,de um touro, comedor de erva."
,"21":"Esqueceram o Deus que os salvou, realizando prodígios no Egipto,"
,"22":"maravilhas na terra de Cam, coisas terríveis junto ao Mar Vermelho."
,"23":"Então Ele decidiu exterminá-los, se não fosse por Moisés, seu escolhido, que intercedeu diante d'Ele,para desviar o seu furor em destruí-los."
,"24":"Desprezaram uma terra de delícias, não tiveram fé na sua palavra."
,"25":"Murmuravam dentro das suas tendas, não obedeceram à voz de Javé."
,"26":"Ele ergueu a mão e jurou,que os faria morrer no deserto,"
,"27":"que dispersaria a sua descendência entre as nações, e os espalharia entre as terras."
,"28":"Ligaram-se depois ao Baal de Fegor, e comeram sacrifícios feitos a deuses mortos."
,"29":"Provocaram a Deus com as suas perversões, e um flagelo irrompeu contra eles."
,"30":"Porém Fineias levantou-se e fez justiça, e o flagelo foi contido."
,"31":"Seja-lhe isto considerado como justiça, de geração em geração, para sempre."
,"32":"Eles irritaram-n'O junto às águas de Meriba,e por sua causa sobreveio o mal a Moisés:"
,"33":"haviam irritado o seu espírito, e Moisés falou sem reflectir."
,"34":"Eles não exterminaram os povos, de quem Javé lhes falara."
,"35":"Misturaram-se com as nações,e aprenderam os seus costumes."
,"36":"Adoraram os seus ídolos, que se tornaram cilada para eles."
,"37":"Sacrificaram aos demónios,os seus filhos e as suas filhas."
,"38":"Derramaram o sangue inocente, e profanaram a terra com sangue."
,"39":"Sujaram-se com as suas próprias obras, e prostituíram-se com as suas acções."
,"40":"Javé inflamou-Se contra o seu povo, e rejeitou a sua herança."
,"41":"Entregou-os na mão das nações, e os seus adversários dominaram-nos."
,"42":"Os seus inimigos tiranizaram-nos,e sob a sua mão ficaram curvados."
,"43":"Quantas vezes Ele os livrou!,Mas eles, obstinados na revolta, pereciam por causa da sua própria injustiça."
,"44":"Ele, porém, viu a sua angústia,e ouviu os seus gritos."
,"45":"Lembrou-Se da sua aliança com eles,e moveu-Se pelo seu grande amor."
,"46":"Concedeu-lhes que se movessem de compaixão,todos aqueles que os mantinham cativos."
,"47":"Salva-nos, Javé nosso Deus!,Congrega-nos dentre as nações, para que celebremos o teu Nome santo, felicitando-nos com o teu louvor!"
,"48":"Seja bendito Javé, Deus de Israel, desde agora e para sempre!,E todo o povo diga: Ámen! Aleluia!"
}`)
	CurrentBook.AddChapter(107, `{
"1":"Agradecei a Javé, porque Ele é bom, porque o seu amor é para sempre!"
,"2":"Repitam-no os redimidos por Javé, que Ele redimiu da mão do opressor,"
,"3":"que Ele reuniu do meio das trevas, do Oriente e do Ocidente, do Norte e do Sul."
,"4":"Eles erravam por um deserto solitário, sem achar o caminho para uma cidade habitada."
,"5":"Estavam famintos e sedentos, e a vida já os abandonava."
,"6":"Na sua aflição clamaram a Javé, e Ele libertou-os das suas angústias."
,"7":"Ele guiou-os pelo caminho certo, para que chegassem a uma cidade habitada."
,"8":"Que eles agradeçam a Javé o seu amor, as maravilhas que faz pelos homens."
,"9":"Ele saciou a garganta sedenta,e encheu de bens a garganta faminta."
,"10":"Eles habitavam nas sombras e nas trevas, prisioneiros de ferros e miséria,"
,"11":"por se revoltarem contra as ordens de Deus, desprezando o projecto do Altíssimo."
,"12":"Ele humilhou-lhes o coração com fadigas: sucumbiam, e ninguém os socorria."
,"13":"Na sua aflição, clamaram a Javé,e Ele libertou-os das suas angústias."
,"14":"Ele tirou-os das sombras e das trevas, e rompeu os seus grilhões."
,"15":"Que eles agradeçam a Javé o seu amor, as maravilhas que faz pelos homens."
,"16":"Ele quebrou as portas de bronze, despedaçou as trancas de ferro."
,"17":"Insensatos, no caminho da transgressão, eram afligidos pelas suas próprias injustiças;"
,"18":"rejeitavam qualquer alimento,e já batiam às portas da morte."
,"19":"Na sua aflição, clamaram a Javé,e Ele libertou-os das suas angústias."
,"20":"Ele enviou a sua palavra para os curar, e para os salvar da perdição."
,"21":"Que eles agradeçam a Javé o seu amor, as maravilhas que faz pelos homens."
,"22":"Ofereçam sacrifícios de louvor, proclamem as suas obras com gritos de alegria."
,"23":"Desciam de navio pelo mar, comerciando na imensidão das águas."
,"24":"Eles viram as obras de Javé, as suas maravilhas no alto mar."
,"25":"Ele falou, levantando um vento impetuoso, que elevou as ondas do mar."
,"26":"Eles subiam até ao céu e baixavam até ao abismo, a sua vida agitava-se na desgraça."
,"27":"Rodavam, balançando como bêbados, e de nada adiantou a sua perícia."
,"28":"Na sua aflição, clamaram a Javé,e Ele libertou-os das suas angústias."
,"29":"Ele transformou a tempestade em leve brisa,e as ondas emudeceram."
,"30":"Ficaram alegres com a bonança, e Ele guiou-os ao porto desejado."
,"31":"Que eles agradeçam a Javé o seu amor, as maravilhas que faz pelos homens."
,"32":"Que O exaltem na assembleia do povo, e O louvem no conselho dos anciãos!"
,"33":"Ele transforma rios em deserto, nascentes em terra sedenta,"
,"34":"terra fértil em salinas, por causa do mal dos seus habitantes."
,"35":"Transforma o deserto em lençóis de água, terra seca em nascentes;"
,"36":"e lá faz morar os famintos, que fundam uma cidade habitada."
,"37":"Eles semearam campos e plantaram vinhas, e colheram frutos em abundância."
,"38":"Ele abençoa-os e cada vez mais se multiplicam, e não deixa diminuir os seus rebanhos."
,"39":"Depois diminuem e vão minguando,pela opressão do mal e sofrimento."
,"40":"Ele espalha o desprezo contra os poderosos, fazendo-os vaguear na confusão sem saída."
,"41":"Mas tira o indigente da miséria,e multiplica famílias como rebanhos."
,"42":"Os corações rectos admiram-se e ficam alegres, e toda a injustiça fecha a boca."
,"43":"Quem é sábio? Observe estas coisas, e saiba discernir o amor de Javé!"
}`)
	CurrentBook.AddChapter(108, `{
"1":"Cântico. Salmo. De David."
,"2":"O meu coração está firme, ó Deus. A Ti cantarei, e tocarei, ó glória minha."
,"3":"Despertai, cítara e harpa, que eu vou despertar a aurora."
,"4":"Vou louvar-Te entre os povos, Javé, vou tocar para Ti no meio das nações;"
,"5":"pois o teu amor é maior que o céu, e a tua fidelidade chega até às nuvens."
,"6":"Eleva-Te acima do céu, ó Deus, e a tua glória domine a Terra inteira,"
,"7":"para que os teus amados sejam libertos, e a tua mão salvadora nos responda."
,"8":"Deus falou no seu santuário: «Triunfante ocuparei Siquém, e repartirei o vale de Sucot."
,"9":"Meu é Galaad, meu é Manassés. Efraim é o elmo da minha cabeça, e Judá o meu ceptro de comando."
,"10":"Moab é a bacia onde Me lavo, sobre Edom lanço a minha sandália, e sobre a Filisteia canto vitória»."
,"11":"Quem me levará a uma cidade-forte, quem me conduzirá até Edom,"
,"12":"se Tu, ó Deus, nos rejeitaste, e já não sais com as nossas tropas?"
,"13":"Concede-nos socorro na opressão, porque o auxílio humano é inútil!"
,"14":"Com Deus nós faremos proezas: Ele calcará os nossos opressores!"
}`)
	CurrentBook.AddChapter(109, `{
"1":"Do mestre de canto. De David. Salmo. Deus do meu louvor, não Te cales,"
,"2":"pois uma boca maldosa e traiçoeira,abriu-se contra mim. Com língua mentirosa me falam,"
,"3":"rodeiam-me com palavras de ódio, e combatem-me sem motivo."
,"4":"Em troca da minha amizade, acusam-me, e eu fico a suplicar."
,"5":"Pagam-me o bem com o mal, e a amizade com o ódio."
,"6":"Nomeia contra ele um injusto, um acusador que esteja à direita dele."
,"7":"Saia condenado do julgamento, e a sua apelação resulte em culpa!"
,"8":"Que os seus dias sejam abreviados, e outro ocupe o seu emprego."
,"9":"Que os seus filhos fiquem órfãos, e a sua mulher se torne viúva."
,"10":"Que os seus filhos andem vagueando a mendigar, e sejam expulsos das ruínas."
,"11":"Que o usurário roube o que ele possui,e estrangeiros pilhem os seus bens."
,"12":"Que ninguém lhe mostre clemência, e ninguém se compadeça dos seus órfãos."
,"13":"Que a sua descendência seja cortada, e o seu nome se extinga numa só geração."
,"14":"Que Javé Se lembre da culpa de seus pais, e o pecado de sua mãe nunca seja apagado."
,"15":"Que Javé os tenha sempre na sua frente, e arranque da terra a sua lembrança!"
,"16":"Porque ele não se lembrou de agir com clemência, porque perseguiu o pobre e o indigente, e até à morte o coração contrito."
,"17":"Ele amou a maldição: que esta recaia sobre ele. Ele não buscou a bênção: que ela o abandone."
,"18":"Vestia-se de maldição como de um manto: que ela penetre as suas entranhas como água, e como óleo em seus ossos."
,"19":"Seja para ele como roupa a cobri-lo, como cinto que o aperte sempre!"
,"20":"Que Javé pague assim os que me acusam, os que proferem o mal contra mim!"
,"21":"Tu, porém, Javé, trata-me bem, pelo teu Nome, liberta-me, pela ternura do teu amor,"
,"22":"porque eu sou um pobre indigente, e, dentro de mim, o meu coração está ferido."
,"23":"Vou passando, como sombra que se expande, sou atirado para longe, como gafanhoto."
,"24":"Jejuei tanto, que os meus joelhos se dobram, e sem óleo a minha carne emagrece."
,"25":"Tornei-me para eles um ultraje, e os que me vêem meneiam a cabeça."
,"26":"Javé, meu Deus, vem socorrer-me!,Salva-me, por teu amor!"
,"27":"Reconheçam que tudo isto vem da tua mão, que foste Tu, Javé, quem o fez!"
,"28":"Que eles maldigam... Bendiz-me Tu!,Que os meus inimigos fracassem, enquanto o teu servo se alegra."
,"29":"Cubram-se de infâmia os que me acusam, e a vergonha os envolva como um manto."
,"30":"Agradecerei a Javé em alta voz, e louvá-l'O-ei no meio da multidão,"
,"31":"pois Ele colocou-Se à direita do pobre, para lhe salvar a vida da mão dos juízes."
}`)
	CurrentBook.AddChapter(110, `{
"1":"De David. Salmo. Oráculo de Javé ao meu senhor: «Senta-te à minha direita, e Eu farei dos teus inimigos,o estrado de teus pés»."
,"2":"De Sião, Javé estenderá,o poder do seu ceptro: submete na batalha os teus inimigos."
,"3":"«Tu és príncipe desde o dia do teu nascimento, entre esplendores sagrados. Eu mesmo te gerei, como orvalho, antes da aurora»."
,"4":"Javé jurou e jamais desmentirá: «Tu és sacerdote para sempre, segundo a ordem de Melquisedec»."
,"5":"O Senhor está à tua direita,e esmagará os reis no dia da sua ira."
,"6":"Pronunciará a sentença contra as nações, amontoará cadáveres, e esmagará cabeças,por toda a imensidão da terra."
,"7":"No teu caminho beberás da torrente, e por isso levantarás a cabeça."
}`)
	CurrentBook.AddChapter(111, `{
"1":"Aleluia!,Eu celebro a Javé de todo o coração, na companhia dos rectos, no conselho."
,"2":"São grandes as obras de Javé, dignas de estudo para quem as ama."
,"3":"A sua obra é esplendor e majestade, a sua generosidade permanece para sempre."
,"4":"Ele fez maravilhas memoráveis, Javé é piedade e compaixão:"
,"5":"dá alimento aos que O temem, lembrando-Se sempre da sua aliança."
,"6":"Ao seu povo mostrou a força do seu agir, entregando-lhe a herança das nações."
,"7":"Justiça e Verdade são as obras das suas mãos, todos os seus preceitos merecem confiança."
,"8":"São estáveis para sempre e eternamente, vão cumprir-se com verdade e rectidão."
,"9":"Enviou a libertação ao seu povo, confirmando a sua aliança para sempre. O seu Nome é santo e terrível."
,"10":"O princípio da sabedoria é o temor de Javé. Todos quantos o praticam têm bom senso. O louvor a Javé permanece para sempre."
}`)
	CurrentBook.AddChapter(112, `{
"1":"Aleluia!,Feliz o homem que teme a Javé,e se compraz com os seus mandamentos!"
,"2":"A sua descendência será poderosa na terra, a descendência dos rectos será abençoada."
,"3":"Na sua casa há abundância e riqueza. A sua justiça permanece para sempre."
,"4":"Ele brilha nas trevas como luz para os rectos, Ele é piedade, compaixão e justiça."
,"5":"Feliz quem tem piedade e empresta, e conduz os seus negócios com rectidão."
,"6":"Eis que ele jamais vacilará. A memória do justo é para sempre."
,"7":"Ele nunca teme as notícias más: o seu coração está firme em Javé."
,"8":"O seu coração está seguro e nada teme, até ver os seus opressores derrotados."
,"9":"Ele dá esmola aos indigentes. A sua justiça permanece para sempre, e ele ergue a fronte com dignidade."
,"10":"O injusto olha e desgosta-se, range os dentes e definha. A ambição dos injustos fracassará."
}`)
	CurrentBook.AddChapter(113, `{
"1":"Aleluia!,Louvai, servos de Javé, louvai o Nome de Javé!"
,"2":"Seja bendito o Nome de Javé, desde agora e para sempre."
,"3":"Desde o nascer até ao pôr do sol, louvado seja o Nome de Javé!"
,"4":"Javé eleva-Se sobre todos os povos, a sua glória está acima do céu!"
,"5":"Quem é igual a Javé, nosso Deus, que Se eleva no seu trono,"
,"6":"e Se abaixa para olhar,pelo céu e pela terra?"
,"7":"Ele ergue da poeira o fraco,e tira do lixo o indigente,"
,"8":"fazendo-o sentar-se com os príncipes, ao lado dos príncipes do seu povo."
,"9":"Ele faz a estéril sentar-se em sua casa, como alegre mãe de filhos. Aleluia!"
}`)
	CurrentBook.AddChapter(114, `{
"1":"Quando Israel saiu do Egipto, e a casa de Jacob de um povo estrangeiro,"
,"2":"Judá tornou-se o seu santuário, e Israel o seu domínio."
,"3":"Ao vê-los, o mar fugiu, o Jordão voltou atrás."
,"4":"Os montes saltaram como carneiros, e as colinas como cordeiros."
,"5":"Mar, que tens tu para fugires assim?,E tu, Jordão, para voltares atrás?"
,"6":"E as montanhas, para saltarem como carneiros?,E as colinas, para saltarem como cordeiros?"
,"7":"A terra estremece diante do Senhor, ante a presença do Deus de Jacob:"
,"8":"Ele transforma as rochas em lago,e a rocha em fonte de água."
}`)
	CurrentBook.AddChapter(115, `{
"1":"Não a nós, Javé, não a nós!,Honra, sim, o teu próprio Nome, por teu amor e fidelidade."
,"2":"Porque diriam as nações: «Onde está o Deus deles?»"
,"3":"O nosso Deus está no Céu, e faz tudo o que deseja."
,"4":"Os ídolos deles são prata e ouro, obras de mãos humanas:"
,"5":"têm boca e não falam, têm olhos e não vêem;"
,"6":"têm ouvidos e não ouvem, têm nariz e não cheiram;"
,"7":"têm mãos e não tocam, têm pés e não andam, a sua garganta não tem voz."
,"8":"Fiquem como eles os que os fazem,e todos os que neles confiam!"
,"9":"A casa de Israel confia em Javé: Ele é o seu auxílio e o seu escudo!"
,"10":"A casa de Aarão confia em Javé: Ele é o seu auxílio e o seu escudo!"
,"11":"Os que temem a Javé confiam em Javé: Ele é o seu auxílio e o seu escudo!"
,"12":"Que Javé Se lembre de nós e nos abençoe: -abençoe a casa de Israel, -abençoe a casa de Aarão,"
,"13":"-abençoe os que temem a Javé, pequenos e grandes."
,"14":"Que Javé vos multiplique, a vós e aos vossos filhos!"
,"15":"Sede abençoados por Javé, que fez o Céu e a Terra."
,"16":"O Céu pertence a Javé, mas a Terra, Ele deu-a aos homens."
,"17":"Os mortos já não louvam a Javé, nem os que descem ao lugar do silêncio."
,"18":"Nós, os vivos, nós bendizemos a Javé, desde agora e para sempre!,Aleluia!"
}`)
	CurrentBook.AddChapter(116, `{
"1":"Eu amo Javé, porque Ele ouve,a minha voz suplicante,"
,"2":"porque inclina o seu ouvido para mim, no dia em que eu O invoco."
,"3":"Laços de morte me cercavam, eram redes mortais, e eu caí na angústia e aflição."
,"4":"Então eu invoquei o nome de Javé: «Javé, salva a minha vida!»"
,"5":"Javé é justo e clemente, o nosso Deus é compassivo."
,"6":"Javé protege os simples: eu fraquejava, e Ele salvou-me."
,"7":"Volta ao repouso, ó minha vida, porque Javé foi bondoso contigo."
,"8":"Libertou a minha vida da morte, os meus olhos das lágrimas,e os meus pés de uma queda."
,"9":"Caminharei na presença de Javé, na terra dos vivos."
,"10":"Eu tinha fé, mesmo ao dizer: «A minha aflição é deveras grande!»"
,"11":"Na minha angústia eu dizia: «Os homens são todos mentirosos!»"
,"12":"Como retribuirei a Javé,todo o bem que Ele me fez?"
,"13":"Erguerei o cálice da salvação, invocando o nome de Javé."
,"14":"Cumprirei os meus votos a Javé, na presença de todo o seu povo!"
,"15":"É valiosa aos olhos de Javé,a morte dos seus fiéis."
,"16":"Eu sou teu servo, Javé, teu servo e filho da tua serva. Tu rompeste os meus grilhões."
,"17":"Vou oferecer-Te um sacrifício de louvor, invocando o nome de Javé."
,"18":"Cumprirei os meus votos a Javé, na presença de todo o seu povo,"
,"19":"nos átrios da casa de Javé, no meio de ti, ó Jerusalém!,Aleluia!"
}`)
	CurrentBook.AddChapter(117, `{
"1":"Louvai Javé, todas as nações, glorificai-O todos os povos!"
,"2":"Pois o seu amor por nós é firme, e a sua fidelidade é para sempre!,Aleluia!"
}`)
	CurrentBook.AddChapter(118, `{
"1":"Agradecei a Javé, porque Ele é bom, porque o seu amor é para sempre!"
,"2":"A casa de Israel repita: o seu amor é para sempre!"
,"3":"A casa de Aarão repita: o seu amor é para sempre!"
,"4":"Os que temem a Javé repitam: o seu amor é para sempre!"
,"5":"Na minha angústia, eu gritei a Javé: Ele ouviu-me e aliviou-me."
,"6":"Javé está comigo: jamais temerei!,Que poderão os homens fazer-me?"
,"7":"Javé está comigo, Ele ajuda-me: eu verei a derrota dos meus inimigos!"
,"8":"É melhor refugiar-se em Javé,do que depositar confiança no homem."
,"9":"É melhor refugiar-se em Javé,do que depositar confiança nos chefes."
,"10":"As nações todas me cercaram: em nome de Javé, eu as repeli!"
,"11":"Cercaram-me, fecharam o cerco: em nome de Javé, eu as repeli!"
,"12":"Cercaram-me como vespas, ardendo como fogo em silvas: em nome de Javé, eu as repeli!"
,"13":"Iam-me empurrando para me derrubar, Javé porém socorreu-me."
,"14":"Javé é minha força e energia, Ele é a minha salvação."
,"15":"Há gritos de júbilo e vitória,nas tendas dos justos: «A direita de Javé é poderosa!"
,"16":"A direita de Javé é sublime!,A direita de Javé é poderosa!»"
,"17":"Não vou morrer. Eu viverei,para contar as obras de Javé."
,"18":"Javé castigou-me duramente, mas não me entregou à morte!"
,"19":"Abri-me as portas do triunfo: vou entrar agradecendo a Javé."
,"20":"Esta é a porta de Javé: os vencedores entrarão por ela."
,"21":"-Eu Te agradeço, porque me ouviste, e foste a minha salvação!"
,"22":"A pedra que os construtores rejeitaram,tornou-se a pedra angular."
,"23":"Isto vem de Javé, e é maravilha aos nossos olhos."
,"24":"Este é o dia em que Javé agiu: exultemos e alegremo-nos com Ele."
,"25":"Javé, dá-nos a salvação!,Dá-nos a prosperidade, Javé!"
,"26":"-Bendito o que vem em nome de Javé!,Da casa de Javé nós vos abençoamos."
,"27":"Javé é Deus: Ele ilumina-nos!,-Formai procissão com ramos,até aos ângulos do altar."
,"28":"Tu és o meu Deus, eu Te agradeço. meu Deus, eu Te exalto!"
,"29":"Agradecei a Javé, porque Ele é bom, porque o seu amor é para sempre!"
}`)
	CurrentBook.AddChapter(119, `{
"1":"Felizes os íntegros no seu caminho, os que andam conforme a vontade de Javé."
,"2":"Felizes os que guardam os seus preceitos, procurando-O de todo o coração,"
,"3":"aqueles que andam no seu caminho, sem praticar a injustiça!"
,"4":"Tu promulgaste os teus mandamentos,para serem observados à risca."
,"5":"Que os meus caminhos sejam firmes, para que eu observe os teus estatutos."
,"6":"Então eu não sentirei vergonha, ao considerar todos os teus mandamentos."
,"7":"Eu Te celebrarei de coração recto, aprendendo as tuas justas normas."
,"8":"Vou observar os teus estatutos, não me abandones nunca."
,"9":"Como poderá um jovem conservar puro o seu caminho?,Observando a tua Palavra."
,"10":"Eu Te busco de todo o coração, não me deixes afastar dos teus mandamentos."
,"11":"Conservei as tuas promessas no meu coração, para não pecar contra Ti."
,"12":"Sê bendito, Javé!,Ensina-me os teus estatutos."
,"13":"Com meus lábios eu enumero,todas as normas da tua boca."
,"14":"Eu me alegro com o caminho dos teus testemunhos, mais do que com todas as riquezas."
,"15":"Vou meditar os teus preceitos,e considerar os teus caminhos."
,"16":"Eu me delicio com a tua vontade,e não me esqueço da tua Palavra."
,"17":"Faz o bem ao teu servo, e eu viverei,observando a tua Palavra."
,"18":"Abre os meus olhos, para eu contemplar,as maravilhas da tua vontade."
,"19":"Eu sou estrangeiro na Terra, não me escondas os teus mandamentos."
,"20":"A minha alma consome-se, desejando,as tuas normas."
,"21":"Tu ameaças os soberbos, os malditos,que se desviam dos teus mandamentos."
,"22":"Retira de mim o ultraje e o desprezo, pois eu guardo os teus testemunhos."
,"23":"Os príncipes podem reunir-se e falar contra mim, o teu servo medita os teus estatutos."
,"24":"Os teus testemunhos são as minhas delícias, os teus estatutos são meus conselheiros."
,"25":"A minha garganta está pegada ao pó, dá-me vida, pela tua Palavra."
,"26":"Eu enumero os meus caminhos, Tu respondes-me: ensina-me os teus estatutos."
,"27":"Faz-me entender o caminho dos teus preceitos, e eu meditarei sobre as tuas maravilhas."
,"28":"A minha alma desfaz-se de tristeza; põe-me de pé, conforme a tua Palavra."
,"29":"Afasta-me do caminho da mentira, e dá-me a graça da tua vontade."
,"30":"Eu escolhi o caminho da verdade, e conformo-me com as tuas normas."
,"31":"Eu apego-me aos teus testemunhos. Javé, não me deixes envergonhado."
,"32":"Correrei pelo caminho dos teus mandamentos, quando alargares o meu coração."
,"33":"Javé, mostra-me o caminho dos teus estatutos, eu quero guardá-los como recompensa."
,"34":"Ensina-me a cumprir a tua vontade, para a observar de todo o coração."
,"35":"Guia-me pelo caminho dos teus mandamentos, pois nele está o meu prazer."
,"36":"Inclina o meu coração para os teus testemunhos, e não para o interesse."
,"37":"Evita que os meus olhos vejam o que é inútil, dá-me vida, pela tua Palavra."
,"38":"Confirma ao teu servo a promessa,que fizeste aos teus fiéis."
,"39":"Desvia de mim o ultraje que eu temo, pois as tuas normas são boas."
,"40":"Eis que eu desejo os teus preceitos, dá-me vida, pela tua justiça."
,"41":"Javé, que o teu amor venha até mim, e a tua salvação, conforme a tua promessa!"
,"42":"Aos que me ultrajam, eu responderei,que confio na tua Palavra."
,"43":"Não me tires da boca a palavra sincera, pois eu espero nas tuas normas."
,"44":"Cumprirei a tua vontade sem cessar, para sempre e eternamente."
,"45":"Andarei por caminho largo, procurando os teus preceitos."
,"46":"Vou falar dos teus testemunhos diante dos reis, sem ficar envergonhado."
,"47":"As minhas delícias são os teus mandamentos, que eu tanto amo."
,"48":"Levanto para Ti as minhas mãos, recitando os teus estatutos."
,"49":"Lembra-Te da tua palavra ao teu servo, na qual Tu me fazes esperar."
,"50":"Esta é a minha consolação na miséria: a tua promessa traz-me vida."
,"51":"Os soberbos zombam de mim à vontade, mas eu não me desvio da tua lei."
,"52":"Javé, recordo as tuas normas de outrora, e me consolo."
,"53":"Fiquei enfurecido diante dos injustos,que abandonam a tua vontade."
,"54":"Os teus estatutos são cânticos para mim, na minha casa de peregrino."
,"55":"Javé, eu lembro-me do teu Nome durante a noite, e observo a tua Lei."
,"56":"Esta é a parte que me cabe: observar os teus preceitos."
,"57":"A minha porção, Javé, eu o digo, é observar as tuas palavras."
,"58":"De todo o coração busco acalmar a tua face: tem piedade de mim, conforme a tua promessa!"
,"59":"Reflicto nos meus caminhos, voltando os meus passos para os teus testemunhos."
,"60":"Apresso-me, e não me atraso, a observar os teus mandamentos."
,"61":"Os laços dos injustos me envolvem, eu não me esqueço da tua vontade."
,"62":"À meia noite levanto-me para Te agradecer,pelas tuas normas justas."
,"63":"Eu associo-me a todos os que Te temem,e observam as tuas normas."
,"64":"A terra, Javé, está cheia do teu amor; ensina-me os teus estatutos."
,"65":"Javé, agiste bem com o teu servo, segundo a tua Palavra."
,"66":"Ensina-me o bom senso e o saber, pois eu creio nos teus mandamentos."
,"67":"Antes de sofrer, eu andava errando; agora observo a tua promessa."
,"68":"Tu és bom e benfeitor: ensina-me os teus estatutos."
,"69":"Os soberbos lançam calúnias contra mim, mas de todo o coração eu guardo os teus preceitos."
,"70":"O seu coração é espesso como gordura, mas eu delicio-me com a tua vontade."
,"71":"Para mim é bom sofrer, pois aprendo os teus estatutos."
,"72":"A lei da tua boca é um bem para mim, mais que milhões de ouro e prata."
,"73":"As tuas mãos me fizeram e formaram: ensina-me, para que eu aprenda os teus mandamentos."
,"74":"Que os que Te temem me olhem com alegria, pois eu espero na tua Palavra."
,"75":"Javé, eu sei que as tuas normas são justas, e que por fidelidade me fazes sofrer."
,"76":"Que o teu amor seja a minha consolação, conforme a tua promessa ao teu servo!"
,"77":"Que a tua misericórdia venha até mim, e eu viverei, pois a tua vontade é a minha delícia."
,"78":"Que se envergonhem os soberbos, que lançam calúnias contra mim!,Eu medito nos teus preceitos."
,"79":"Voltem-se para mim os que Te temem, os que conhecem os teus testemunhos."
,"80":"Que o meu coração seja íntegro nos teus estatutos, para que eu não fique envergonhado."
,"81":"Eu me consumo pela tua salvação, esperando pela tua Palavra."
,"82":"Os meus olhos consomem-se pela tua promessa: quando me consolarás?"
,"83":"Estou como odre exposto ao fumo; nunca me esqueço dos teus estatutos."
,"84":"Quantos serão os dias do teu servo?,Quando me farás justiça contra os meus perseguidores?"
,"85":"Os soberbos abriram covas para mim; eles não andam conforme a tua vontade."
,"86":"Os teus mandamentos todos são verdadeiros; eles perseguem-me sem razão: ajuda-me!"
,"87":"Por pouco não me derrubavam por terra, mas eu não abandono os teus preceitos."
,"88":"Faz-me viver, por teu amor, e eu observarei o testemunho da tua boca."
,"89":"Javé, a tua Palavra é para sempre, mais estável do que o céu."
,"90":"A tua fidelidade continua, de geração em geração, como a terra que fixaste, e ela permanece."
,"91":"Tudo existe até hoje conforme as tuas normas, pois todas as coisas Te servem a Ti."
,"92":"Se a tua vontade não fosse o meu prazer, eu já teria perecido na miséria."
,"93":"Jamais vou esquecer os teus preceitos, pois é com eles que Tu me fazes viver."
,"94":"Eu pertenço-Te: salva-me, pois eu busco os teus preceitos."
,"95":"Que os injustos esperem a minha ruína: eu sei discernir os teus testemunhos."
,"96":"Eu vi o limite de toda a perfeição: o teu mandamento dilata-se sem fim."
,"97":"Quanto eu amo a tua vontade!,Eu medito nela o dia todo."
,"98":"O teu mandamento torna-me mais sábio que os meus inimigos,porque ele me pertence para sempre."
,"99":"Sou mais sábio que todos os meus mestres, porque medito nos teus testemunhos."
,"100":"Sou mais sagaz que os idosos, porque observo os teus preceitos."
,"101":"Eu desvio os meus pés de qualquer caminho mau, para observar a tua palavra."
,"102":"Jamais me desvio das tuas normas, porque és Tu quem me ensina."
,"103":"Doces são ao meu paladar as tuas promessas, mais do que o mel na minha boca!"
,"104":"Com os teus preceitos, sou capaz de discernir,e detestar qualquer caminho mau."
,"105":"A tua palavra é lâmpada para os meus pés, e luz para o meu caminho."
,"106":"Eu jurei, e confirmo: hei-de observar as tuas justas normas."
,"107":"Estou profundamente humilhado, Javé, faz-me viver, conforme a tua Palavra."
,"108":"Javé, aceita os votos que pronuncio. e ensina-me as tuas normas."
,"109":"A minha vida está sempre em perigo, porém não me esqueço da tua vontade."
,"110":"Os injustos armam-me um laço, porém não me desvio dos teus preceitos."
,"111":"Os teus testemunhos são a minha herança para sempre, a alegria do meu coração."
,"112":"Aplico o meu coração a praticar os teus estatutos; esta é a minha recompensa para sempre."
,"113":"Eu detesto os corações divididos,e amo a tua vontade."
,"114":"Tu és o meu refúgio e o meu escudo, eu espero pela tua Palavra."
,"115":"Afastai-vos de mim, perversos, que eu vou guardar os mandamentos do meu Deus."
,"116":"Sustenta-me, conforme a tua promessa, e eu viverei; não deixes que a minha esperança me envergonhe."
,"117":"Apoia-me, e serei salvo,e estarei sempre atento aos teus estatutos."
,"118":"Tu desprezas todos os que se desviam dos teus estatutos, pois o seu cálculo é mentira."
,"119":"Tens como escória todos os injustos da Terra, por isso eu amo os teus testemunhos."
,"120":"A minha carne arrepia-se com temor de Ti, e eu temo, por causa das tuas normas."
,"121":"Pratiquei o direito e a justiça; não me entregues aos meus opressores."
,"122":"Sê fiador do teu servo para o bem, e que os soberbos não me oprimam."
,"123":"Os meus olhos consomem-se pela tua salvação, e pela promessa da tua justiça."
,"124":"Age com o teu servo conforme o teu amor, e ensina-me os teus estatutos."
,"125":"Eu sou teu servo, faz-me discernir, e compreenderei os teus testemunhos."
,"126":"Javé, é tempo de agir: eles violaram a tua vontade."
,"127":"É por isso que amo os teus mandamentos, mais que o ouro refinado."
,"128":"É por isso que aprecio os teus preceitos,e odeio o caminho da mentira."
,"129":"Os teus testemunhos são maravilhas, por isso eu os guardo."
,"130":"A descoberta das tuas palavras ilumina, e dá discernimento aos simples."
,"131":"Abro a boca e aspiro, ansiando pelos teus mandamentos."
,"132":"Volta-Te para mim, tem piedade de mim: como fazes para os que amam o teu Nome."
,"133":"Firma os meus passos com a tua promessa,e não deixes que mal nenhum me domine."
,"134":"Resgata-me da opressão do homem, e observarei os teus preceitos."
,"135":"Ilumina a tua face para o teu servo, e ensina-me os teus estatutos."
,"136":"Torrentes de lágrimas me descem dos olhos, porque não cumprem a tua vontade."
,"137":"Javé, Tu és justo, e as tuas normas são rectas."
,"138":"Com justiça, ordenaste os teus testemunhos, com verdade suprema."
,"139":"O meu zelo me consome, pois os meus adversários esquecem as tuas palavras."
,"140":"A tua promessa é puríssima,e o teu servo ama-a."
,"141":"Sou pequeno e desprezado, porém não esqueço os teus preceitos."
,"142":"A tua justiça é justiça para sempre, e a tua vontade é verdadeira."
,"143":"Angústia e opressão me atingiram, os teus mandamentos são as minhas delícias."
,"144":"Os teus testemunhos são justiça para sempre, dá-me discernimento, e eu viverei."
,"145":"Eu clamo de todo o coração. Javé, responde-me!,Eu observarei os teus estatutos."
,"146":"Eu grito por Ti: salva-me!,Eu guardarei os teus testemunhos."
,"147":"Antecipo a aurora e imploro, esperando pelas tuas palavras."
,"148":"Os meus olhos antecipam as vigílias, para meditar a tua promessa."
,"149":"Javé, ouve a minha voz, pelo teu amor, faz-me reviver, conforme as tuas normas."
,"150":"Perseguidores infames aproximam-se, estão longe da tua vontade."
,"151":"Tu estás bem perto, Javé, e os teus mandamentos são todos estáveis."
,"152":"Conheço os teus mandamentos há muito tempo, porque os firmaste para sempre."
,"153":"Olha a minha miséria e liberta-me, pois não me esqueço da tua vontade."
,"154":"Redime a minha causa e defende-me, e pela tua promessa faz-me reviver."
,"155":"A salvação está longe dos injustos, pois eles não procuram os teus estatutos."
,"156":"Javé, a tua compaixão é grande: faz-me reviver, conforme as tuas normas."
,"157":"Os meus perseguidores e opressores são numerosos, porém não me afastei dos teus testemunhos."
,"158":"Vi os traidores e fiquei desgostoso: eles não observam a tua promessa."
,"159":"Vê como eu amo os teus preceitos, Javé, faz-me reviver, conforme o teu amor."
,"160":"O compêndio da tua palavra é a verdade, e as tuas normas são justiça para sempre."
,"161":"Príncipes me perseguem sem motivo, porém o meu coração teme as tuas palavras."
,"162":"Alegro-me com a tua promessa, como quem acha um rico despojo."
,"163":"Detesto e abomino a mentira, e amo a tua vontade."
,"164":"Sete vezes por dia eu Te louvo, por causa das tuas justas normas."
,"165":"É grande a paz dos que amam a tua Lei: para eles não existe tropeço."
,"166":"Eu aguardo a tua salvação, Javé, e pratico os teus mandamentos."
,"167":"Observo os teus testemunhos; eu amo-os intensamente."
,"168":"Observo os teus preceitos e testemunhos, e os meus caminhos estão todos à tua frente."
,"169":"Que o meu clamor chegue à tua presença, Javé!,Dá-me discernimento, conforme a tua palavra!"
,"170":"Que a minha súplica chegue à tua presença!,Liberta-me, conforme a tua promessa!"
,"171":"Que os meus lábios publiquem o louvor, pois Tu me ensinas os teus estatutos."
,"172":"Que a minha língua cante a tua promessa, pois todos os teus mandamentos são justos."
,"173":"Que a tua mão venha socorrer-me, porque escolhi os teus preceitos."
,"174":"Eu desejo a tua salvação, Javé, e a tua vontade é a minha delícia."
,"175":"Que eu possa viver para Te louvar, e as tuas normas me auxiliem."
,"176":"Eu extraviei-me como ovelha perdida: vem procurar o teu servo, pois eu não esqueço os teus mandamentos."
}`)
	CurrentBook.AddChapter(120, `{
"1":"Cântico das subidas. Na minha angústia eu gritei a Javé, e Ele respondeu-me."
,"2":"Javé, livra-me dos lábios mentirosos,e da língua traidora!"
,"3":"Que te dará Deus ou mandará, ó língua traidora?"
,"4":"Flechas de guerreiro, afiadas,com brasas de giesta."
,"5":"Ai de mim, exilado em Mosoc, acampado nas tendas de Cedar!"
,"6":"Já há muito que eu moro,com os que odeiam a paz."
,"7":"Quando eu digo: «Paz», eles dizem: «Guerra»."
}`)
	CurrentBook.AddChapter(121, `{
"1":"Cântico para as subidas. Ergo os olhos para os montes: de onde virá o meu socorro?"
,"2":"O meu socorro vem de Javé, que fez o Céu e a Terra."
,"3":"Ele não deixará que o teu pé tropece, o teu guarda jamais dormirá!"
,"4":"Sim, não dorme nem adormece,o guarda de Israel."
,"5":"Javé guarda-te sob a sua sombra, Ele está à tua direita."
,"6":"De dia o Sol não te ferirá, nem a Lua de noite."
,"7":"Javé guarda-te de todo o mal, Ele guarda a tua vida."
,"8":"Javé guarda as tuas chegadas e partidas, desde agora e para sempre."
}`)
	CurrentBook.AddChapter(122, `{
"1":"Cântico das subidas. De David. Alegrei-me quando me disseram: «Vamos à casa de Javé!»"
,"2":"Os nossos passos já se detêm,junto das tuas portas, Jerusalém!"
,"3":"Jerusalém é fundada,como cidade bem compacta."
,"4":"Para ela sobem as tribos, as tribos de Javé, segundo o costume de Israel, para celebrar o nome de Javé."
,"5":"Ali estão os tribunais da justiça, no palácio de David."
,"6":"Desejai a paz para Jerusalém: «Vivam seguros os que te amam,"
,"7":"haja paz dentro dos teus muros,e segurança nos teus palácios!»"
,"8":"Pelos meus irmãos e meus amigos, eu digo: «A paz esteja contigo!»"
,"9":"Pela casa de Javé nosso Deus, desejo-te todo o bem."
}`)
	CurrentBook.AddChapter(123, `{
"1":"Cântico das subidas. Para Ti eu levanto os meus olhos, para Ti, que habitas no céu."
,"2":"Como os olhos dos escravos, fixos nas mãos do seu senhor, e como os olhos da escrava, fixos nas mãos da sua senhora, assim estão os nossos olhos,fixos em Javé nosso Deus, até que Se compadeça de nós."
,"3":"Compaixão, Javé! Tem compaixão de nós, porque estamos fartos de desprezo!"
,"4":"A nossa vida está deveras farta,do sarcasmo dos satisfeitos,e do desprezo dos soberbos."
}`)
	CurrentBook.AddChapter(124, `{
"1":"Cântico das subidas. De David. Se Javé não estivesse do nosso lado,-Israel que o diga -"
,"2":"se Javé não estivesse do nosso lado, quando os homens nos assaltaram..."
,"3":"ter-nos-iam engolido vivos, tal era o fogo da sua ira!"
,"4":"As águas ter-nos-iam inundado, a torrente teria chegado ao pescoço;"
,"5":"as águas espumejantes,chegariam ao nosso pescoço!"
,"6":"Seja bendito Javé! Ele não nos entregou,como presas para os seus dentes."
,"7":"Fugimos vivos, como o pássaro foge,da rede do caçador: a rede rompeu-se, e nós escapámos."
,"8":"O nosso auxílio é o Nome de Javé, que fez o Céu e a Terra!"
}`)
	CurrentBook.AddChapter(125, `{
"1":"Cântico das subidas. Aqueles que confiam em Javé são como o monte Sião: nunca treme, está firme para sempre."
,"2":"Jerusalém é rodeada de montanhas, e Javé envolve o seu povo, desde agora e para sempre."
,"3":"O ceptro do injusto não pesará,sobre a parte dos justos, para que a mão dos justos,não se estenda para o crime."
,"4":"Javé, faz o bem aos bons, aos corações rectos."
,"5":"E os que se desviam por caminhos tortuosos, que Javé os rejeite com os malfeitores. Paz sobre Israel!"
}`)
	CurrentBook.AddChapter(126, `{
"1":"Cântico das subidas. Quando Javé mudou a sorte de Sião, parecia-nos sonhar:"
,"2":"a nossa boca encheu-se de riso, e a nossa língua de canções. Até entre as nações se comentava: «Javé foi grande com eles!»"
,"3":"Sim, Javé foi grande connosco, e por isso estamos alegres."
,"4":"Que Javé mude a nossa sorte, como as torrentes do Negueb."
,"5":"Os que semeiam com lágrimas, ceifam no meio de canções."
,"6":"Vão andando e chorando,ao levar a semente. Ao regressar, voltam cantando, trazendo os seus feixes."
}`)
	CurrentBook.AddChapter(127, `{
"1":"Cântico das subidas. De Salomão. Se Javé não constrói a casa, em vão labutam os seus construtores. Se Javé não guarda a cidade, em vão vigiam os guardas."
,"2":"É inútil que madrugueis,e vos atraseis ao deitar, para comer o pão com duros trabalhos: aos seus amigos, Ele dá-o enquanto dormem!"
,"3":"A herança que Javé concede são os filhos, o seu salário é o fruto do ventre:"
,"4":"os filhos da juventude,são flechas na mão de um guerreiro."
,"5":"Feliz o homem que enche,a sua aljava com elas: não será derrotado às portas da cidade,quando litigar com os seus inimigos."
}`)
	CurrentBook.AddChapter(128, `{
"1":"Cântico das subidas. Feliz quem teme a Javé,e anda nos seus caminhos!"
,"2":"Comerás do trabalho das tuas próprias mãos, tranquilo e feliz."
,"3":"A tua esposa será como vinha fecunda, na intimidade do teu lar. Os teus filhos, rebentos de oliveira, ao redor da tua mesa."
,"4":"Esta é a bênção para o homem,que teme a Javé."
,"5":"Que Javé te abençoe de Sião, e vejas a prosperidade de Jerusalém,todos os dias da tua vida."
,"6":"Que vejas os filhos dos teus filhos. Paz sobre Israel!"
}`)
	CurrentBook.AddChapter(129, `{
"1":"Cântico das subidas. Quanto me oprimiram desde a juventude, -Israel que o diga -"
,"2":"quanto me oprimiram desde a juventude!,Mas nunca me conseguiram vencer!"
,"3":"Os lavradores lavraram as minhas costas,e alongaram os seus sulcos."
,"4":"Mas Javé é justo: Ele cortou,os chicotes dos injustos."
,"5":"Voltem para trás, envergonhados, os que odeiam Sião."
,"6":"Sejam como a erva do telhado, que seca, e ninguém a corta,"
,"7":"que não enche a mão do ceifeiro, nem a braçada daquele que ata os feixes."
,"8":"E que os passantes não digam: «Javé vos abençoe!»,Nós vos abençoamos em nome de Javé."
}`)
	CurrentBook.AddChapter(130, `{
"1":"Cântico das subidas. Das profundezas eu clamo a Ti, Javé:"
,"2":"Senhor, ouve o meu grito!,Que os teus ouvidos estejam atentos,à voz da minha súplica!"
,"3":"Javé, se levas em conta as culpas, quem poderá resistir?"
,"4":"Mas de Ti vem o perdão, e assim infundes respeito."
,"5":"A minha alma espera em Javé, espera na sua Palavra."
,"6":"A minha alma aguarda o Senhor, mais que os guardas pela aurora. Mais que os guardas pela aurora,"
,"7":"aguarde Israel a Javé. Pois de Javé vêm a graça,e a redenção em abundância."
,"8":"Ele vai redimir Israel,de todas as suas culpas."
}`)
	CurrentBook.AddChapter(131, `{
"1":"Cântico das subidas. De David. Javé, o meu coração não é ambicioso, nem os meus olhos altaneiros. Não ando atrás de grandezas, nem de maravilhas que me ultrapassam."
,"2":"Não! Eu fiz calar e repousar os meus desejos, como criança desmamada no colo de sua mãe."
,"3":"Israel, coloca a tua esperança em Javé, desde agora e para sempre!"
}`)
	CurrentBook.AddChapter(132, `{
"1":"Cântico das subidas. Javé, lembra-Te de David, de todas as suas fadigas:"
,"2":"como ele jurou a Javé,e fez voto ao Poderoso de Jacob:"
,"3":"«Não entrarei na tenda, na minha casa, nem subirei à cama em que repouso,"
,"4":"não darei sono aos meus olhos, nem descanso às minhas pálpebras,"
,"5":"enquanto não encontrar um lugar para Javé, moradia para o Poderoso de Jacob»."
,"6":"Ouvimos dizer que ela estava em Éfrata, e encontrámo-la nos Campos de Jaar."
,"7":"Entremos na sua moradia, e prostremo-nos diante do seu pedestal."
,"8":"Levanta-Te, Javé, vem para a tua mansão, vem com a arca da tua força."
,"9":"Que os teus sacerdotes se vistam de gala, e os teus fiéis exultem de alegria."
,"10":"Por causa de David, teu servo, não rejeites a face do teu messias."
,"11":"Javé jurou a David,uma promessa que jamais retractará: «É um fruto do teu ventre,que Eu vou colocar no teu trono."
,"12":"Se os teus filhos guardarem a minha aliança,e o testemunho que lhes ensinei, também os filhos deles, para sempre, irão sentar-se no teu trono»."
,"13":"Porque Javé escolheu Sião, e desejou-a como sua residência própria:"
,"14":"«Ela é a minha mansão para sempre, aqui vou habitar, porque a desejei."
,"15":"Vou abençoar as suas provisões com largueza,e saciar os seus indigentes de pão."
,"16":"De gala vestirei os seus sacerdotes, e os seus fiéis exultarão de alegria."
,"17":"Farei brotar o vigor de David, acenderei uma lâmpada para o meu messias."
,"18":"Vestirei de vergonha os seus inimigos, e sobre ele vai brilhar a minha coroa»."
}`)
	CurrentBook.AddChapter(133, `{
"1":"Cântico das subidas. De David. Vede como é bom, como é agradável,os irmãos viverem unidos."
,"2":"É como óleo fino sobre a cabeça, descendo pela barba, a barba de Aarão; descendo,sobre a gola das suas vestes."
,"3":"É como o orvalho do Hermon, descendo,sobre os montes de Sião. Porque é ali que Javé manda a sua bênção,e a vida para sempre."
}`)
	CurrentBook.AddChapter(134, `{
"1":"Cântico das subidas. E agora, bendizei a Javé, servos todos de Javé, que passais a noite,na casa de Javé."
,"2":"Levantai as mãos para o santuário,e bendizei a Javé!"
,"3":"Que, de Sião, Javé te abençoe,Ele que fez o Céu e a Terra."
}`)
	CurrentBook.AddChapter(135, `{
"1":"Aleluia!,Louvai o nome de Javé, louvai-O, servos de Javé,"
,"2":"Vós que servis na casa de Javé, nos átrios da casa do nosso Deus."
,"3":"Louvai a Javé, porque Ele é bom. Tocai ao seu Nome, porque é agradável."
,"4":"Pois Ele escolheu Jacob para Si, fez de Israel a sua propriedade."
,"5":"Sim, eu sei que Javé é grande, que o nosso Deus supera os deuses todos."
,"6":"Javé faz tudo o que deseja,no Céu e na Terra, nos mares e oceanos."
,"7":"Faz subir as nuvens do horizonte, desata a chuva com os relâmpagos, solta o vento dos seus reservatórios."
,"8":"Ele feriu os primogénitos do Egipto, desde os homens até aos animais."
,"9":"Enviou sinais e prodígios, no meio de ti, ó Egipto, contra o Faraó e os seus ministros."
,"10":"Ele feriu povos numerosos,e destruiu poderosos reis:"
,"11":"Seon, rei dos amorreus, Og, rei de Basã, e todos os reis de Canaã."
,"12":"Deu a terra deles como herança, herança para o seu povo Israel."
,"13":"Javé, o teu Nome é para sempre!,Javé, a tua lembrança passa,de geração em geração."
,"14":"Javé governa o seu povo,e compadece-Se dos seus servos."
,"15":"Os ídolos das nações são prata e ouro, obras de mãos humanas:"
,"16":"têm boca e não falam, têm olhos e não vêem"
,"17":"têm ouvidos e não ouvem, não há um sopro sequer na sua boca."
,"18":"Sejam como eles aqueles que os fazem, e todos os que neles confiam!"
,"19":"Casa de Israel, bendiz a Javé!,Casa de Aarão, bendiz a Javé!"
,"20":"Casa de Levi, bendiz a Javé!,Fiéis de Javé, bendizei a Javé!"
,"21":"Javé seja bendito em Sião, Ele que habita em Jerusalém. Aleluia!"
}`)
	CurrentBook.AddChapter(136, `{
"1":"Celebrai Javé, porque Ele é bom, porque o seu amor é para sempre!"
,"2":"Celebrai o Deus dos deuses, porque o seu amor é para sempre!"
,"3":"Celebrai o Senhor dos senhores, porque o seu amor é para sempre!"
,"4":"Só Ele fez grandes maravilhas, porque o seu amor é para sempre!"
,"5":"Ele fez os céus com inteligência, porque o seu amor é para sempre!"
,"6":"Ele firmou a Terra sobre as águas, porque o seu amor é para sempre!"
,"7":"Ele fez os grandes luminares, porque o seu amor é para sempre!"
,"8":"O Sol para governar o dia, porque o seu amor é para sempre!"
,"9":"A Lua para governar a noite, porque o seu amor é para sempre!"
,"10":"Ele feriu o Egipto nos seus primogénitos, porque o seu amor é para sempre!"
,"11":"Ele tirou Israel do meio deles, porque o seu amor é para sempre!"
,"12":"Com mão forte e braço estendido, porque o seu amor é para sempre!"
,"13":"Ele dividiu o Mar Vermelho em duas partes, porque o seu amor é para sempre!"
,"14":"E por entre elas fez passar Israel, porque o seu amor é para sempre!"
,"15":"Mas nele lançou o Faraó e o seu exército, porque o seu amor é para sempre!"
,"16":"Ele guiou o seu povo pelo deserto, porque o seu amor é para sempre!"
,"17":"Feriu reis famosos, porque o seu amor é para sempre!"
,"18":"Ele matou reis poderosos, porque o seu amor é para sempre!"
,"19":"Seon, rei dos amorreus, porque o seu amor é para sempre!"
,"20":"Og, rei de Basã, porque o seu amor é para sempre!"
,"21":"Ele deu a terra deles como herança, porque o seu amor é para sempre!"
,"22":"Como herança ao seu servo Israel, porque o seu amor é para sempre!"
,"23":"Ele lembrou-Se de nós em nossa humilhação, porque o seu amor é para sempre!"
,"24":"Ele livrou-nos dos nossos opressores, porque o seu amor é para sempre!"
,"25":"Ele dá o pão a todo ser vivo, porque o seu amor é para sempre!"
,"26":"Celebrai o Deus dos céus, porque o seu amor é para sempre!"
}`)
	CurrentBook.AddChapter(137, `{
"1":"Junto dos canais de Babilónia,nos sentámos e chorámos, com saudades de Sião."
,"2":"Nos salgueiros das suas margens,pendurámos as nossas harpas."
,"3":"Lá, os que nos exilaram,pediam canções, os nossos raptores queriam diversão: «Cantai-nos um canto de Sião!»"
,"4":"Como cantar um canto de Javé,em terra estrangeira?"
,"5":"Se eu me esquecer de ti, Jerusalém, que seque a minha mão direita."
,"6":"Que a minha língua se cole ao paladar, se eu não me lembrar de ti, e se eu não elevar Jerusalém,acima de todas as minhas alegrias!"
,"7":"Javé, pede contas aos filhos de Edom,no dia de Jerusalém, quando diziam: «Arrasai a cidade!,Arrasai-a até aos alicerces!»"
,"8":"Ó devastadora capital de Babilónia, feliz quem te retribuir,o mal que nos fizeste!"
,"9":"Feliz quem agarrar e esmagar,os teus bebés contra o rochedo!"
}`)
	CurrentBook.AddChapter(138, `{
"1":"De David. Eu Te agradeço, Javé, de todo o meu coração. Na presença dos anjos eu canto para Ti."
,"2":"Eu me prostro em direcção ao teu santuário, e agradeço ao teu Nome, pelo teu amor e fidelidade, pois a tua promessa supera a tua fama."
,"3":"Quando eu gritei, Tu me ouviste, e aumentaste a força na minha alma."
,"4":"Todos os reis da terra Te agradeçam, Javé, pois eles ouvem as promessas da tua boca."
,"5":"Cantai os caminhos de Javé, porque a glória de Javé é grande!"
,"6":"Javé é sublime, mas olha para o humilde, e conhece de longe o soberbo."
,"7":"Quando eu caminho entre perigos, Tu me conservas a vida. Estendes o braço contra a ira do meu inimigo, e a tua direita me salva."
,"8":"Javé fará tudo por mim. Javé, o teu amor é para sempre!,Não abandones a obra das tuas mãos!"
}`)
	CurrentBook.AddChapter(139, `{
"1":"Do mestre de canto. De David. Salmo. Javé, Tu me sondas e me conheces."
,"2":"Tu conheces o meu sentar e o meu levantar, de longe penetras o meu pensamento."
,"3":"Examinas o meu andar e o meu deitar, todos os meus caminhos Te são familiares."
,"4":"A palavra ainda não me chegou à língua, e Tu, Javé, conhece-la perfeitamente."
,"5":"Tu me envolves por detrás e pela frente, e sobre mim colocas a tua mão."
,"6":"É um saber maravilhoso que me ultrapassa, é alto de mais: não posso atingi-lo!"
,"7":"Para onde irei, longe do teu sopro?,Para onde fugirei, longe da tua presença?"
,"8":"Se subo ao céu, Tu lá estás. Se desço ao abismo, lá Te encontro."
,"9":"Se levanto voo para as margens da aurora, se emigro para os confins do mar,"
,"10":"aí me alcançará a tua esquerda, e a tua direita me sustentará."
,"11":"Se eu digo: «Ao menos as trevas me cubram, e a luz se transforme em noite ao meu redor»,"
,"12":"mesmo as trevas não são trevas para Ti, e a noite é clara como o dia."
,"13":"Sim! Pois Tu formaste os meus rins, Tu me teceste no seio materno."
,"14":"Eu Te agradeço por tão grande prodígio, e maravilho-me com as tuas maravilhas!,Conhecias até o fundo da minha alma,"
,"15":"e os meus ossos não Te eram escondidos. Quando eu era formado, em segredo, tecido na terra mais profunda,"
,"16":"os teus olhos viam as minhas acções,e eram todas escritas no teu livro. Os meus dias já estavam calculados, antes mesmo que chegasse o primeiro."
,"17":"Mas, para mim, são difíceis os teus projectos!,meu Deus, como é grande a soma deles!"
,"18":"Se os conto... são mais numerosos que a areia!,E, ao despertar, ainda estou contigo!"
,"19":"Ah! meu Deus, se matasses o injusto!,Se os assassinos se apartassem de mim!"
,"20":"Eles falam de Ti com ironia, e em vão se rebelam contra Ti!"
,"21":"Não odiaria eu aqueles que Te odeiam?,Não detestaria eu aqueles que se rebelam contra Ti?"
,"22":"Eu odeio-os com ódio implacável!,Eu tenho-os por meus inimigos!"
,"23":"Sonda-me, ó Deus, e conhece o meu coração!,Prova-me, e conhece os meus sentimentos!"
,"24":"Vê se ando por um caminho errado, e conduz-me pelo caminho eterno."
}`)
	CurrentBook.AddChapter(140, `{
"1":"Do mestre de canto. Salmo. De David."
,"2":"Javé, salva-me do homem perverso, defende-me do homem violento."
,"3":"Eles planeiam o mal no seu coração,e a cada dia provocam discórdias."
,"4":"Afiam a língua como serpentes, e sob os seus lábios existe veneno de víbora."
,"5":"Javé, defende-me das mãos do injusto, guarda-me do homem violento. Eles planeiam tropeços para os meus passos."
,"6":"Os soberbos preparam-me armadilhas, os perversos estendem-me uma rede,e colocam ciladas no meu caminho."
,"7":"Mas eu digo a Javé: «Tu és o meu Deus». Javé, ouve a minha voz suplicante!"
,"8":"Senhor Javé, meu forte salvador, Tu me cobres a cabeça no dia da batalha!"
,"9":"Javé, não aproves os desejos dos injustos, não favoreças os seus planos!,Que os que me cercam não levantem a cabeça."
,"10":"Que a maldade dos seus próprios lábios os recubra!"
,"11":"Chovam sobre eles brasas acesas. Caiam em abismos e não consigam levantar-se!"
,"12":"Que o caluniador não se afirme sobre a terra, e que o mal persiga o violento até à morte!"
,"13":"Eu sei que Javé faz justiça ao pobre,e defende o direito dos indigentes."
,"14":"Os justos louvarão o teu Nome, e os rectos viverão na tua presença."
}`)
	CurrentBook.AddChapter(141, `{
"1":"Salmo. De David. Javé, eu chamo por Ti, socorre-me depressa!,Ouve a minha voz quando eu clamo a Ti!"
,"2":"Suba a minha prece como incenso à tua presença, as minhas mãos erguidas como oferta vespertina!"
,"3":"Javé, coloca na minha boca um guarda, uma sentinela à porta dos meus lábios."
,"4":"Impede o meu coração de se inclinar para o mal, de cometer crimes juntamente com os malfeitores. Não vou participar dos seus banquetes!"
,"5":"Que o justo me bata, que o bom me corrija. Que o óleo do injusto não me perfume a cabeça, pois eu iria comprometer-me com as suas maldades."
,"6":"Os seus chefes caíram, despenhando-se, embora ouvissem as minhas palavras amáveis."
,"7":"Como mó de moinho, rebentada por terra, os nossos ossos estão espalhados,junto à boca do túmulo."
,"8":"Para Ti, Javé, eu elevo os meus olhos, eu me refugio em Ti, não me deixes indefeso."
,"9":"Guarda-me das armadilhas que prepararam para mim, e das ciladas dos malfeitores."
,"10":"Caiam os injustos nas suas próprias redes, enquanto eu escapo, em liberdade!"
}`)
	CurrentBook.AddChapter(142, `{
"1":"Poema. De David. Quando estava na caverna. Prece."
,"2":"Gritando por Javé, eu imploro!,Gritando pora Javé, eu suplico!"
,"3":"Derramo à frente d'Ele o meu lamento, diante d'Ele exponho a minha angústia,"
,"4":"enquanto o meu alento desfalece. Tu, porém, conheces o meu caminho, e foi no caminho por onde eu ando,que eles me prepararam uma armadilha."
,"5":"Olho para a direita e vejo: já ninguém me reconhece, nenhum lugar de refúgio, ninguém que olhe por mim!"
,"6":"Eu grito por Ti, Javé, e digo: «Tu és o meu refúgio, a minha parte na terra da vida»."
,"7":"Presta atenção ao meu clamor, pois já estou esgotado. Livra-me dos meus perseguidores, pois são mais fortes do que eu!"
,"8":"Faz-me sair da minha prisão, para que eu agradeça ao teu Nome!,Os justos juntar-se-ão ao meu redor, por causa do bem que Tu me fizeste."
}`)
	CurrentBook.AddChapter(143, `{
"1":"Salmo. De David. Javé, ouve a minha prece!,Tu és fiel, atende as minhas súplicas!,Tu és justo, responde-me!"
,"2":"Não entres em julgamento contra o teu servo, pois, diante de Ti, nenhum vivente é justo!"
,"3":"O inimigo persegue-me, esmaga por terra a minha vida, e faz-me habitar nas trevas, como aqueles que estão mortos para sempre."
,"4":"O meu alento já vai desfalecendo, e dentro de mim o meu coração assusta-se."
,"5":"Recordo os dias de outrora, medito em todas as tuas acções, reflectindo sobre a obra das tuas mãos."
,"6":"Para Ti estendo os meus braços, a minha vida é terra sedenta de Ti."
,"7":"Javé, responde-me depressa, pois o meu alento se extingue!,Não me escondas a tua face: eu ficaria como os que descem à cova."
,"8":"Faz-me ouvir o teu amor pela manhã, pois é em Ti que eu confio. Indica-me o caminho a seguir. pois a Ti elevo a minha alma."
,"9":"Livra-me dos meus inimigos, Javé, pois eu me refugio junto a Ti."
,"10":"Ensina-me a cumprir a tua vontade, pois Tu és o meu Deus. Que o teu bom espírito me conduza,por uma terra plana."
,"11":"Javé, pelo teu Nome, conserva-me vivo, e pela tua justiça tira-me da angústia."
,"12":"Pelo teu amor, aniquila os meus inimigos,e destrói todos os meus adversários, porque eu sou o teu servo."
}`)
	CurrentBook.AddChapter(144, `{
"1":"De David. Bendito seja Javé, o meu rochedo, que adestra as minhas mãos para a batalha,e os meus dedos para a guerra."
,"2":"O meu benfeitor, a minha fortaleza, a minha torre forte e o meu libertador, o meu escudo e o meu refúgio, que me submete os povos."
,"3":"Javé, o que é o homem para que o conheças, o filho de um mortal, para que o leves em conta?"
,"4":"O homem é como um sopro, e os seus dias como a sombra que passa."
,"5":"Javé, inclina o teu céu e desce, toca os montes, e eles fumegarão."
,"6":"Envia um raio, e dispersa-os, lança as tuas flechas, e afugenta-os!"
,"7":"Do alto estende a tua mão, salva-me, livra-me das águas torrenciais, da mão dos estrangeiros."
,"8":"A sua boca diz mentiras, e a sua direita jura falso."
,"9":"Ó Deus, eu cantar-Te-ei um cântico novo, tocarei para Ti a harpa de dez cordas:"
,"10":"És tu que dás a vitória aos reis,e salvas David, teu servo. Defende-me da espada cruel,"
,"11":"livra-me da mão dos estrangeiros. A sua boca diz mentiras, e a sua direita jura falso."
,"12":"Sejam os nossos filhos como plantas, bem crescidos desde a adolescência. As nossas filhas sejam colunas talhadas, estruturas de um templo."
,"13":"Os nossos celeiros estejam repletos,de frutos de toda a espécie. Os nossos rebanhos, aos milhares, multipliquem-se nos nossos campos,"
,"14":"e os nossos bois andem carregados. Não haja brecha nem fuga, nem grito de alarme nas nossas praças."
,"15":"Feliz o povo onde isso acontece. Feliz o povo cujo Deus é Javé!"
}`)
	CurrentBook.AddChapter(145, `{
"1":"Louvor. De David. Eu Te exalto, meu Deus, meu Rei, e bendigo o teu Nome para sempre e eternamente."
,"2":"Vou bendizer-Te todos os dias,e louvar o teu Nome para sempre e eternamente."
,"3":"Grande é Javé! Ele merece todo o louvor. É incalculável a sua grandeza."
,"4":"Uma geração apregoa as tuas obras à outra, proclamando as tuas façanhas."
,"5":"A tua fama é esplendor de glória: eu cantarei o relato das tuas maravilhas."
,"6":"Falarão do poder dos teus terrores, e eu cantarei a tua grandeza."
,"7":"Difundirão a lembrança da tua bondade imensa, e aclamarão a tua justiça."
,"8":"Javé é piedade e compaixão, lento para a cólera e cheio de amor."
,"9":"Javé é bom para com todos, compassivo com todas as suas obras."
,"10":"Que todas as tuas obras Te agradeçam, Javé, e os teus fiéis Te bendigam."
,"11":"Proclamem a glória do teu reino,e falem das tuas façanhas,"
,"12":"para anunciar as tuas façanhas aos homens, e a majestade gloriosa do teu reino."
,"13":"O teu reino é reino para todos os séculos, e o teu governo para gerações e gerações. Javé é fiel às suas palavras, amoroso em todas as suas obras."
,"14":"Javé ampara todos os que caem,e endireita todos os encurvados."
,"15":"Em Ti esperam os olhos de todos, e no devido tempo Tu lhes dás o alimento."
,"16":"Abres a mão, e sacias à vontade todo o ser vivo."
,"17":"Javé é justo em todos os seus caminhos, e fiel em todas as suas obras."
,"18":"Ele está perto de todos aqueles que O invocam, de todos os que O invocam sinceramente."
,"19":"Ele realiza o desejo dos que O temem, ouve os seus gritos e salva-os."
,"20":"Javé guarda todos os que O amam, mas vai destruir todos os injustos."
,"21":"A minha boca pronuncie o louvor de Javé, e todo o ser vivo bendiga o seu Nome santo, para sempre e eternamente!"
}`)
	CurrentBook.AddChapter(146, `{
"1":"Aleluia!,Louva Javé, ó minha alma!"
,"2":"Vou louvar Javé, enquanto eu viver. Vou tocar para o meu Deus, enquanto existir!"
,"3":"Não coloqueis a segurança nos poderosos, num homem que não pode salvar!"
,"4":"Exalam o espírito e voltam ao pó, e no mesmo dia perecem os seus planos!"
,"5":"Feliz quem se apoia no Deus de Jacob, quem coloca a sua esperança em Javé seu Deus."
,"6":"Foi Ele quem fez o Céu e a Terra, o mar e tudo o que nele existe. Ele mantém a sua fidelidade para sempre,"
,"7":"fazendo justiça aos oprimidos, e dando pão aos famintos. Javé liberta os prisioneiros."
,"8":"Javé abre os olhos dos cegos. Javé endireita os encurvados. Javé ama os justos."
,"9":"Javé protege os estrangeiros, sustenta o órfão e a viúva, mas desvia o caminho dos injustos."
,"10":"Javé reina para sempre. O teu Deus, ó Sião, reina de geração em geração!,Aleluia!"
}`)
	CurrentBook.AddChapter(147, `{
"1":"Aleluia!,Louvai a Javé, pois é bom cantar. O nosso Deus merece harmonioso louvor."
,"2":"Javé reconstrói Jerusalém, reúne os exilados de Israel."
,"3":"Cura os corações despedaçados,e cuida dos seus ferimentos."
,"4":"Ele conta o número das estrelas, e chama cada uma pelo nome."
,"5":"O nosso Senhor é grande e poderoso, e a sua sabedoria é sem medida."
,"6":"Javé sustenta os pobres,e rebaixa os injustos até ao chão."
,"7":"Entoai o agradecimento a Javé, cantai ao nosso Deus com a harpa."
,"8":"Ele cobre o céu com nuvens, preparando a chuva para a terra. Faz brotar erva sobre os montes,e plantas úteis ao homem."
,"9":"Fornece alimento ao rebanho, e aos filhotes do corvo, que grasnam."
,"10":"Ele não Se compraz com o vigor do cavalo, nem aprecia os músculos do homem."
,"11":"Javé aprecia aqueles que O temem, aqueles que esperam pelo seu amor."
,"12":"Glorifica Javé, Jerusalém, louva o teu Deus, ó Sião."
,"13":"Ele reforçou as trancas das tuas portas, abençoou os teus filhos no teu seio."
,"14":"Colocou paz nas tuas fronteiras, saciou-te com a flor do trigo."
,"15":"Ele envia as suas ordens à Terra, e a sua Palavra corre velozmente."
,"16":"Faz cair a neve como lã, e espalha a geada como cinza."
,"17":"Ele atira o seu gelo em migalhas,e congela as águas com o frio."
,"18":"Ele envia a sua Palavra e derrete-as, sopra o seu vento e as águas correm."
,"19":"Ele anuncia a sua Palavra a Jacob, os seus estatutos e normas a Israel."
,"20":"Com nação nenhuma agiu deste modo, e nenhuma conheceu as suas normas. Aleluia!"
}`)
	CurrentBook.AddChapter(148, `{
"1":"Aleluia!,Louvai a Javé no céu, louvai a Javé nas alturas."
,"2":"Louvai a Javé, todos os anjos, louvem-n'O todos os seus exércitos!"
,"3":"Louvai a Javé, Sol e Lua, louvai-O, astros de luz!"
,"4":"Louvai a Javé, céus dos céus, e águas acima dos céus!"
,"5":"Louvai o Nome de Javé, pois Ele mandou e foram criados."
,"6":"Fixou-os eternamente, para sempre, deu-lhes uma lei que jamais passará."
,"7":"Louvai a Javé na Terra, monstros marinhos e todos os abismos,"
,"8":"raios e granizo, neve e nevoeiro, e o furacão cumpridor da sua Palavra."
,"9":"Montes e todas as colinas, árvores frutíferas e todos os cedros,"
,"10":"feras e animais domésticos, répteis e pássaros que voam."
,"11":"Reis da Terra e todos os povos, príncipes e juízes da Terra,"
,"12":"jovens e também as donzelas, os velhos e as crianças!"
,"13":"Louvai o nome de Javé: o único nome sublime!,A sua majestade está além da Terra e do Céu,"
,"14":"e Ele reforça o vigor do seu povo!,Louvor de todos os seus fiéis, dos filhos de Israel, seu povo íntimo. Aleluia!"
}`)
	CurrentBook.AddChapter(149, `{
"1":"Aleluia!,Cantai a Javé um cântico novo!,Cantai o seu louvor na assembleia dos fiéis!"
,"2":"Alegre-se Israel com o seu Criador, os filhos de Sião festejem o seu Rei!"
,"3":"Louvem o seu nome com danças, toquem para Ele cítara e tambor!"
,"4":"Sim! Porque Javé ama o seu povo, e enfeita os pobres com a vitória!"
,"5":"Que os fiéis festejem a sua glória, e, em filas, cantem jubilosos."
,"6":"Com exaltações para Deus na garganta, e nas mãos espadas de dois gumes,"
,"7":"para tomar vingança dos povos, e aplicar o castigo às nações,"
,"8":"para prender os seus reis com algemas, e os seus nobres com grilhões de ferro."
,"9":"Cumprir neles a sentença prescrita,é uma honra para todos os seus fiéis!,Aleluia!"
}`)
	CurrentBook.AddChapter(150, `{
"1":"Aleluia!,Louvai a Deus no seu templo, louvai-O no seu poderoso firmamento!"
,"2":"Louvai a Deus, pelas suas façanhas, louvai-O pela sua imensa grandeza!"
,"3":"Louvai a Deus tocando trombetas, louvai-O com cítara e harpa!"
,"4":"Louvai a Deus com danças e tambores, louvai-O com cordas e flauta!"
,"5":"Louvai a Deus com címbalos sonoros, louvai-O com címbalos vibrantes!"
,"6":"Todo o ser que respira louve a Javé!,Aleluia!"
}`)

}
func PT_BS_LoadVSSPChapters(CurrentBook *Book) {
	CurrentBook.AddChapter(1, `{
"1":"Amai a justiça, vós que governais a Terra. Pensai correctamente no Senhor e procurai-O de coração sincero."
,"2":"Pois Ele deixa-Se encontrar por aqueles que não O tentam, e manifesta-Se àqueles que não recusam acreditar n'Ele."
,"3":"Os pensamentos tortuosos separam de Deus, e o seu poder, posto à prova, confunde os insensatos."
,"4":"A sabedoria não entra na alma que pratica o mal, nem habita num corpo que é escravo do pecado."
,"5":"O espírito santo, que educa, foge da fraude, afasta-se dos pensamentos insensatos, e é expulso quando sobrevém a injustiça."
,"6":"A sabedoria é um espírito amigo dos homens, mas não deixa impune quem blasfema com os lábios, porque Deus é testemunha dos seus sentimentos, observa de facto a sua consciência e ouve as palavras da sua boca."
,"7":"O espírito do Senhor enche o Universo, dá consistência a todas as coisas e tem conhecimento de tudo o que se diz."
,"8":"Por esse motivo, quem diz coisas injustas não Lhe escapará, e a justiça vingadora não o poupará."
,"9":"Haverá investigação sobre os projectos do injusto, e o rumor das suas palavras chegará até ao Senhor, e seus crimes ficarão comprovados."
,"10":"Um ouvido atento tudo escuta: nem mesmo o sussurro das murmurações lhe escapa."
,"11":"Portanto, tomai cuidado com a murmuração inútil, e evitai a maledicência. Mesmo secreta, a palavra não fica sem consequências, e a boca mentirosa mata a alma."
,"12":"Não procureis a morte, desviando a vossa própria vida, nem provoqueis a ruína com as obras que praticais,"
,"13":"pois Deus não fez a morte, nem Se alegra com a perdição dos seres vivos."
,"14":"Ele criou tudo para a existência, e as criaturas do mundo são sadias: nelas não há veneno de morte, nem o mundo dos mortos reina sobre a terra,"
,"15":"porque a justiça é imortal."
,"16":"Com gestos e palavras, os injustos invocam a morte para si mesmos. eles pensam que a morte é amiga e desejam-na ardentemente, chegando a fazer aliança com ela. São realmente dignos de pertencer à morte."
}`)
	CurrentBook.AddChapter(2, `{
"1":"Raciocinando de forma errada, eles comentam entre si: «A nossa vida é curta e triste: quando chega o fim, não há remédio, e não se conhece ninguém que tenha voltado do mundo dos mortos."
,"2":"Nascemos por acaso, e depois seremos como se nunca tivéssemos existido. A nossa respiração é fumo, e o pensamento é uma faísca produzida pelo pulsar do coração."
,"3":"Quando a faísca se apaga, o corpo transforma-se em cinza e o espírito espalha-se como ar sem consistência."
,"4":"Com o tempo, o nosso nome fica esquecido, e ninguém mais se lembra do que fizemos. A nossa vida passa como rasto de nuvem, e dissipa-se como neblina expulsa pelos raios do sol e dissolvida pelo seu calor."
,"5":"A nossa vida é uma sombra que passa, e depois de morrer não voltaremos. Colocado o lacre, já ninguém poderá voltar."
,"6":"Sendo assim, vamos gozar os bens presentes e gozar das criaturas com o ardor da juventude."
,"7":"Vamos embriagar-nos com os melhores vinhos e perfumes, e não deixar que a flor da Primavera nos escape."
,"8":"Vamos coroar-nos com botões de rosa, antes que murchem."
,"9":"Que nenhum de nós falte às nossas orgias. Vamos deixar por toda a parte sinais da nossa alegria, porque essa é a nossa sorte e o nosso destino."
,"10":"Vamos oprimir o justo pobre e não vamos poupar as viúvas, nem respeitar os cabelos brancos do ancião."
,"11":"A nossa força será a regra da justiça, porque o fraco é claramente coisa inútil."
,"12":"Vamos armar ciladas ao justo, porque ele nos incomoda e se opõe às nossas acções. O justo reprova as transgressões que cometemos contra a Lei, e acusa-nos de faltas contra a educação que recebemos."
,"13":"Declara ter o conhecimento de Deus, e diz-se filho do Senhor."
,"14":"Ele tornou-se uma condenação para os nossos pensamentos, e até só o vê-lo já nos é insuportável."
,"15":"A sua vida não se parece com a dos outros, e os seus caminhos são todos diferentes."
,"16":"Ele considera-nos moeda falsa e afasta-se dos nossos caminhos para não se contaminar. Proclama feliz o destino dos justos e gaba-se de ter Deus como pai."
,"17":"Vejamos se é verdadeiro o que ele diz, e comprovemos o que lhe vai acontecer no fim."
,"18":"Se o justo é filho de Deus, Deus cuidará dele e o livrará da mão dos seus adversários."
,"19":"Vamos prová-lo com insultos e torturas, para verificar a sua serenidade e examinar a sua resistência."
,"20":"Vamos condená-lo a sofrer morte vergonhosa, porque ele mesmo diz que não lhe faltará socorro»."
,"21":"Eles pensam assim, mas estão enganados, porque a sua maldade os cega."
,"22":"Não conhecem os segredos de Deus, não esperam o pagamento pela santidade, nem acreditam no prémio das almas puras."
,"23":"Sim, Deus criou o homem para ser incorruptível e fê-lo à imagem da sua própria natureza."
,"24":"Mas, pela inveja do diabo, entrou no mundo a morte, que é experimentada por aqueles que lhe pertencem."
}`)
	CurrentBook.AddChapter(3, `{
"1":"As almas dos justos, pelo contrário, estão nas mãos de Deus, e nenhum tormento os atingirá."
,"2":"Aos olhos dos insensatos pareciam ter morrido, e o seu fim foi considerado uma desgraça."
,"3":"Os insensatos pensavam que a morte dos justos fosse um aniquilamento, mas agora estão em paz."
,"4":"As pessoas pensavam que os justos estavam a cumprir uma pena, mas esperavam a imortalidade."
,"5":"Por uma breve pena receberão grandes benefícios, porque Deus os provou e os encontrou dignos de Si."
,"6":"Deus examinou-os como ouro no crisol, e aceitou-os como holocausto perfeito."
,"7":"No dia do julgamento, eles resplandecerão, correndo como fagulhas no meio da palha."
,"8":"Eles governarão as nações, submeterão os povos, e o Senhor reinará para sempre sobre eles."
,"9":"Os que n'Ele confiam compreenderão a verdade, e os que Lhe são fiéis viverão junto d'Ele no amor, pois a graça e a misericórdia estão reservadas para os seus escolhidos."
,"10":"Os injustos, porém, serão castigados pela sua maneira de pensar, porque desprezaram o justo e se afastaram do Senhor."
,"11":"É infeliz quem despreza a sabedoria e a disciplina. A sua esperança é vã, as suas fadigas não produzem fruto, e as suas obras são inúteis."
,"12":"As suas mulheres são insensatas, os seus filhos depravados, e a sua descendência é maldita."
,"13":"Feliz a mulher estéril que permanece irrepreensível e desconhece qualquer união pecaminosa, porque receberá o seu fruto no julgamento das almas."
,"14":"Feliz também o eunuco, que não cometeu injustiça, nem pensou coisas más contra o Senhor. Ele, pela sua fidelidade, receberá uma graça especial e uma recompensa invejável no templo do Senhor."
,"15":"Pois o fruto das boas obras é glorioso e a raiz da sabedoria é imperecível."
,"16":"Os filhos dos adúlteros não chegarão à maturidade, e a descendência de uma união ilegítima desaparecerá."
,"17":"Mesmo que tenham vida longa, ninguém fará caso deles, e a sua velhice no fim será sem honra."
,"18":"Se morrerem cedo, não terão esperança nenhuma, nem consolação no dia do julgamento,"
,"19":"porque é terrível o fim de uma geração perversa."
}`)
	CurrentBook.AddChapter(4, `{
"1":"É melhor não ter filhos e possuir a virtude, porque a memória da virtude é imortal, e tanto Deus como os homens a conhecem."
,"2":"Quando está presente, todos a imitam. Se está ausente, todos a desejam. E, por fim, ela triunfa na eternidade, coroada e vitoriosa, por ter vencido com limpidez no campo de combate."
,"3":"A descendência numerosa dos injustos não servirá para nada; nascida de ramos bastardos, não lançará raízes profundas, nem terá base firme."
,"4":"Mesmo que por algum tempo os seus ramos estejam verdes, ela está mal fixada no solo, será abalada pelo vento e arrancada pela violência do furacão."
,"5":"Os seus frágeis ramos serão quebrados, o seu fruto será inútil e intragável, e ela não servirá para nada."
,"6":"De facto, os filhos nascidos de uniões ilegais testemunharão a perversidade dos seus pais, quando estes forem julgados."
,"7":"Mesmo que morra prematuramente, o justo encontrará repouso."
,"8":"A velhice honrada não consiste em ter vida longa, nem é medida pelo número de anos."
,"9":"Os cabelos brancos do homem valem pela sua sabedoria, e a velhice pela sua vida sem manchas."
,"10":"O justo agradou a Deus, e Deus amou-o. Deus transferiu-o, visto que ele vivia entre os pecadores."
,"11":"Foi arrebatado, para que a malícia não lhe pervertesse os sentimentos, ou para que o engano não o seduzisse."
,"12":"De facto, o fascínio do vício obscurece os verdadeiros valores, e a força da paixão perverte a mente que não tem malícia."
,"13":"Amadurecido em pouco tempo, o justo atingiu a plenitude de uma vida longa."
,"14":"A sua alma era agradável ao Senhor, e por isso Ele apressou-se a tirá-lo do meio da maldade. Muita gente vê isto mas não compreende nada; não reflecte"
,"15":"que a graça e a misericórdia de Deus são para os seus escolhidos, e a sua protecção é para os seus santos."
,"16":"Quando morre, o justo condena os injustos que continuam a viver, e a juventude que chegou rapidamente à perfeição condena a longa velhice do injusto."
,"17":"Muita gente verá o fim do sábio, mas não compreenderá o que Deus queria dele, nem por-que o colocou em segurança."
,"18":"Tais pessoas verão e mostrarão o seu desprezo, mas o Senhor rir-Se-á delas."
,"19":"Essas pessoas, porém, tornar-se-ão para sempre cadáveres desonrados e objecto de zombaria entre os mortos. De facto, Deus vai atirá-las de cabeça para baixo, sem que possam dizer uma palavra sequer, e arrancá-las-á dos seus alicerces. Ficarão completamente arruinadas, viverão na aflição, e a sua memória desapare-cerá."
,"20":"Os injustos, quando forem prestar conta dos seus pecados, chegarão cheios de terror, e serão acusados pelos seus crimes."
}`)
	CurrentBook.AddChapter(5, `{
"1":"O justo, porém, ficará de pé, sem temor, diante dos que o oprimiram e desprezaram os seus sofrimentos."
,"2":"Ao verem o justo, os maus ficarão tomados de terrível pavor, espantados diante da salvação inesperada."
,"3":"Arrependidos, dirão entre si, entre soluços e gemidos de angústia:"
,"4":"«Este é aquele de quem antes nós ríamos. Nós tomávamo-lo como objecto de zombaria. Insensatos que fomos! Considerámos a sua vida uma loucura e a sua morte uma vergonha!"
,"5":"Porque é que ele agora é considerado entre os filhos de Deus e participa da herança dos santos?"
,"6":"Nós portanto desviámo-nos do caminho da verdade. A luz da justiça não brilhou para nós, nem o sol para nós se levantou."
,"7":"Nós fartámo-nos nos caminhos da injustiça e da perdição. Percorremos desertos intransitáveis, e não conhecemos o caminho do Senhor."
,"8":"De que adiantou o nosso orgulho? Que vantagem tirámos da nossa riqueza arrogante?"
,"9":"Tudo desapareceu como sombra e como notícia fugaz."
,"10":"Desapareceu como navio que corta as águas agitadas, sem que se possa encontrar vestígios da sua passagem, nem o sulco do seu casco nas ondas."
,"11":"Desapareceu como pássaro que voa pelos ares, sem deixar qualquer sinal da sua rota: o ar leve, ferido pelo toque das penas e dividido pelo ímpeto vigoroso, é atravessado pelas asas em movimento, mas depois não fica sinal nenhum da sua passagem."
,"12":"Tudo desapareceu como flecha disparada contra o alvo: o ar cortado volta imediatamente sobre si mesmo, e já não se sabe qual foi a sua trajectória."
,"13":"O mesmo acontece connosco: mal nascemos e já desaparecemos, sem termos mostrado algum sinal de virtude, porque nos consumámos na nossa maldade!»"
,"14":"Sim, a esperança do injusto é como palha arrebatada pelo vento, como leve espuma que a tempestade levanta. Esperança que se desfaz como fumo espalhado pelo vento, e é fugaz como a lembrança do hóspede que fica apenas um dia."
,"15":"Os justos, porém, vivem para sempre, recebem do Senhor a recompensa, e o Altíssimo cuida deles."
,"16":"Por isso, receberão das mãos do Senhor a gloriosa coroa real e o diadema do esplendor, porque Ele os protegerá com a mão direita e os cobrirá com o seu braço, como escudo."
,"17":"Tomará o seu próprio zelo como armadura e armará a criação para castigar os inimigos."
,"18":"Vestirá a couraça da justiça e colocará o capacete do julgamento que não admite suborno."
,"19":"Tomará como escudo a santidade invencível,"
,"20":"afiará a espada da sua ira implacável, e o universo combaterá ao seu lado contra os insensatos."
,"21":"Os raios partirão das nuvens como flechas bem apontadas e voarão para o alvo como de um arco bem retesado."
,"22":"A sua funda lançará furiosa saraivada, a água do mar enfurecer-se-á contra eles, e os rios sem piedade afogá-los-ão."
,"23":"O sopro do poder divino levantar-se-á contra eles e dispersá-los-á como um furacão. É assim que a injustiça devastará a Terra toda, e a maldade derrubará o trono dos poderosos."
}`)
	CurrentBook.AddChapter(6, `{
"1":"Escutai, reis, e procurai compreender. Aprendei, governantes de toda a Terra."
,"2":"Prestai atenção, vós que dominais os povos e vos orgulhais com o grande número de súbditos."
,"3":"O vosso poder vem do Senhor, e o domínio vem do Altíssimo. Ele examinará as obras que praticardes e sondará as vossas intenções."
,"4":"No entanto, apesar de serdes ministros do seu reino, não julgastes com rectidão, não observastes a lei, nem procedestes conforme a vontade de Deus."
,"5":"Por isso, Ele cairá sobre vós de modo repentino e terrível, porque um julgamento implacável se realizará contra aqueles que ocupam altos cargos."
,"6":"Os pequenos serão perdoados com misericórdia, mas os poderosos serão examinados com rigor."
,"7":"O Senhor de todos não recua diante de ninguém, nem se impressiona com a grandeza, porque Ele criou tanto o pequeno como o grande, e a sua providência é igual para todos."
,"8":"Mas um exame severo aguarda os poderosos."
,"9":"É a vós, soberanos, que eu dirijo as minhas palavras, para que aprendais a sabedoria e não resvaleis."
,"10":"Os que observam santamente a sua santa vontade serão declarados santos. E aqueles que a aprendem encontrarão quem os defenda."
,"11":"Desejai, portanto, ouvir as minhas palavras, ansiai por elas, e sereis instruídos."
,"12":"A sabedoria é resplandecente, não murcha, mostra-se facilmente àqueles que a amam. Ela deixa-se encontrar por aqueles que a buscam."
,"13":"Ela antecipa-se, revelando-se espontaneamente aos que a desejam."
,"14":"Quem por ela madruga não terá grande trabalho, pois encontrá-la-á sentada junto à porta da sua casa."
,"15":"Reflectir sobre ela é a perfeição da inteligência, e quem cuida dela depressa ficará sem preocupações."
,"16":"Ela mesma vai por toda a parte procurar os que são dignos dela: aparece-lhes bondosamente pelos caminhos, e vai-lhes ao encontro em cada um dos seus pensamentos."
,"17":"O princípio da Sabedoria é o desejo autêntico de instruir, e desejar instruir-se é já amá-la."
,"18":"Amá-la é observar as leis da Sabedoria. Por sua vez, a observância das leis é garantia de imortalidade."
,"19":"E a imortalidade faz com que a pessoa fique perto de Deus."
,"20":"Portanto, o desejo da sabedoria conduz ao reino."
,"21":"Chefes dos povos, se gostais de tronos e ceptros, honrai a sabedoria, e reinareis para sempre."
,"22":"Vou dizer-vos o que é a sabedoria, e qual a sua origem. Não esconderei os seus mistérios. Investigarei as suas manifestações desde o princípio da Criação, colocarei a descoberto o seu conhecimento, sem me desviar da verdade."
,"23":"Não vou caminhar com os que se consomem de inveja, pois esta nada tem em comum com a sabedoria."
,"24":"O grande número de sábios é que salva o mundo, e um rei sábio traz prosperidade ao povo."
,"25":"Deixai, portanto, que as minhas palavras vos instruam, e delas tirareis proveito."
}`)
	CurrentBook.AddChapter(7, `{
"1":"Eu também sou mortal como todos os outros, descendente do primeiro ser que foi formado da terra. Fui formado de carne no seio de minha mãe,"
,"2":"e durante dez meses me solidifiquei no sangue, fruto do sémen de um homem e do prazer que acompanha o sono."
,"3":"Quando nasci também respirei o ar comum. Caí sobre a terra que recebe a todos igualmente e, como todos os outros, estreei a minha voz chorando."
,"4":"Fui envolto em fraldas e rodeado de cuidados,"
,"5":"porque nenhum rei começou a viver de outra forma."
,"6":"A entrada e a saída da vida é igual para todos."
,"7":"Por isso, supliquei e a inteligência foi-me dada. Invoquei, e veio a mim o espírito da sabedoria."
,"8":"Preferi-a aos ceptros e tronos e, em comparação com ela, considerei a riqueza como um nada."
,"9":"Não a comparei com a pedra mais preciosa, porque todo o ouro, ao lado dela, é como um punhado de areia. E a prata, comparada com ela, vale o mesmo que um punhado de barro."
,"10":"Amei a sabedoria mais do que a saúde e a beleza, e resolvi tê-la como luz, porque o seu brilho nunca se apaga."
,"11":"Com ela me vieram todos os bens, e nas suas mãos há riquezas incalculáveis."
,"12":"Gozei de todos esses bens, por-que é a sabedoria que os traz, mas eu ignorava que fosse ela a mãe de todos eles."
,"13":"Sem malícia, aprendi a sabedoria, e agora distribuo-a sem inveja nenhuma. Não vou esconder a sua riqueza,"
,"14":"porque ela é um tesouro inesgotável para os homens. Aqueles que a adquirem atraem a amizade de Deus, porque são recomendados pelos dons da sua instrução."
,"15":"Deus me conceda falar com proprie-dade e pensar de forma correspondente aos dons que me foram dados, porque Ele é o guia da sabedoria e o orientador dos sábios."
,"16":"Em seu poder estamos nós, as nossas palavras, a nossa inteligência e as nossas habilidades."
,"17":"Ele concedeu-me o conhecimento exacto de tudo o que existe, para eu compreender a estrutura do mundo e a propriedade dos elementos,"
,"18":"o começo, o meio e o fim dos tempos, a alternância dos solstícios e as mudanças das estações,"
,"19":"os ciclos do ano e a posição dos astros,"
,"20":"a natureza dos animais e o instinto das feras, o poder dos espíritos e o raciocínio dos homens, a variedade das plantas e a propriedade das raízes."
,"21":"Aprendi tudo o que está oculto e tudo o que se pode ver, porque a sabedoria, que criou tudo, mo ensinou."
,"22":"Na sabedoria há um espírito inteligente, santo, único, múltiplo, subtil, móvel, penetrante, imaculado, lúcido, invulnerável, amigo do bem, agudo,"
,"23":"livre, benéfico, amigo dos homens, estável, seguro, sereno, que tudo pode e tudo abrange, que penetra todos os espíritos inteligentes, puros e subtilíssimos."
,"24":"A sabedoria é mais ágil que qualquer movimento, atravessa e penetra tudo graças à sua pureza."
,"25":"A sabedoria é exalação do poder de Deus, emanação puríssima da glória do Omnipotente e, por isso, nada de contaminado nela se infiltra."
,"26":"Ela é reflexo da luz eterna, espelho nítido da actividade de Deus e imagem da sua bondade."
,"27":"Embora seja única, tudo pode. Permanece sempre a mesma, mas renova tudo, e entrando nas almas santas, através das gerações, forma os amigos de Deus e os profetas."
,"28":"De facto, Deus ama somente aqueles que convivem com a sabedoria."
,"29":"Ela é mais bela que o sol e supera todas as constelações dos astros. Comparada à luz do dia, ela vence,"
,"30":"pois a luz cede lugar à noite, mas o mal nada pode contra a sabedoria."
}`)
	CurrentBook.AddChapter(8, `{
"1":"Ela estende-se vigorosamente de um extremo ao outro, e governa rectamente o Universo."
,"2":"Amei a sabedoria, busquei-a desde a minha juventude e procurei tomá-la por esposa, pois fiquei enamorado da sua formosura."
,"3":"A união com Deus manifesta a sua nobre origem, porque o Senhor do universo a amou."
,"4":"De facto, ela é iniciada na ciência de Deus e selecciona as suas obras."
,"5":"Se na vida a riqueza é um bem desejável, que riqueza é maior do que a sabedoria, que tudo produz?"
,"6":"E se é a inteligência que opera, quem mais do que ela é artífice do que existe?"
,"7":"Se alguém ama a justiça, as virtudes são os seus frutos, pois é ela que ensina a temperança e a prudência, a justiça e a fortaleza, que são na vida os bens mais úteis aos homens."
,"8":"Se alguém deseja uma rica experiência, ela conhece as coisas passadas e entrevê as futuras, conhece as subtilezas oratórias e a solução dos enigmas. Prevê sinais,e prodígios, e o desenrolar das épocas e tempos. "
,"9":"Decidi, portanto, tomá-la por companheira da minha vida, sabendo que ela será boa conselheira e me trará conforto nas preocupações e no sofrimento."
,"10":"Por causa dela, serei elogiado pelas assembleias e, ainda jovem, os anciãos me honrarão."
,"11":"No julgamento, terei agudeza e serei admirado pelos poderosos."
,"12":"Se me calar, ficarão na expectativa; se falar, prestar-me-ão atenção; se prolongar o discurso, todos colocarão a mão na boca."
,"13":"Por meio dela alcançarei a imortalidade, e deixarei aos meus sucessores uma lembrança eterna."
,"14":"Governarei os povos e dominarei as nações."
,"15":"Tiranos terríveis ficarão assustados quando me ouvirem, mas serei bom para o povo e corajoso no momento da guerra."
,"16":"Ao voltar para casa, repousarei ao lado dela, porque a sua companhia não provoca amargura, e a convivência com ela não traz nenhuma dor, mas contentamento e alegria."
,"17":"Reflecti sobre estas coisas e meditei no meu íntimo: a imortalidade está na união com a sabedoria,"
,"18":"e na sua amizade existe alegria perfeita; na obra das suas mãos existe uma riqueza inesgotável, na relação assídua com ela adquire-se a prudência, e na comunicação das suas sentenças encontra-se a fama. Assim sendo, eu ia por toda a parte procurando o modo de a conquistar para mim."
,"19":"Eu era um jovem de boas qualidades e tive a sorte de ter uma boa alma,"
,"20":"ou melhor, sendo bom, entrei num corpo sem mancha."
,"21":"Sabendo que jamais teria conquistado a sabedoria, se Deus não ma tivesse concedido - e já era sinal de inteligência saber de quem vinha o dom - voltei-me então para o Senhor e supliquei-lhe, dizendo com todo o meu coração:"
}`)
	CurrentBook.AddChapter(9, `{
"1":"«Deus dos nossos pais e Senhor de misericórdia, tudo criaste com a tua palavra!"
,"2":"Com a tua sabedoria formaste o homem para dominar as criaturas que fizeste,"
,"3":"para governar o mundo com santidade e justiça, e exercer o julgamento com rectidão de alma."
,"4":"Concede-me a sabedoria, que está entronizada ao teu lado, e não me excluas do número dos teus filhos."
,"5":"Eu sou teu servo, filho da tua serva, homem fraco e de vida breve, incapaz de compreender a justiça e as leis."
,"6":"Mesmo que alguém fosse o mais perfeito dos homens, se lhe faltasse a Sabedoria que provém de Ti, não seria nada."
,"7":"Tu me escolheste como rei do teu povo e juiz dos teus filhos e filhas."
,"8":"Tu me mandaste construir um templo sobre o teu santo monte, um altar na cidade onde fixaste a tua tenda, cópia da tenda santa que tinhas preparado desde o princípio."
,"9":"Contigo está a sabedoria, que conhece as tuas obras e que estava presente quando criaste o mundo. Ela sabe o que é agradável aos teus olhos e o que é conforme aos teus mandamentos."
,"10":"Manda dos teus santos céus a sabedoria e envia-a do teu trono glorioso, para que ela me assista nos meus trabalhos e me ensine o que Te é agradável."
,"11":"Porque ela tudo sabe e tudo compreende. Ela me guiará prudentemente nas minhas acções e me protegerá com a sua glória."
,"12":"Assim, as minhas obras ser-Te-ão agradáveis, poderei governar com justiça o teu povo, e serei digno do trono de meu pai."
,"13":"Quem pode conhecer a vontade de Deus? Quem pode imaginar o que o Senhor deseja?"
,"14":"Os pensamentos dos mortais são tímidos e os nossos raciocínios são falíveis,"
,"15":"porque um corpo corruptível torna pesada a alma, e a morada terrestre oprime a mente pensativa."
,"16":"Com muito custo, podemos conhecer o que está na Terra e com dificuldade encontramos o que está ao alcance da mão. Mas quem poderá investigar o que está no céu?"
,"17":"Quem poderá conhecer o teu projecto, se não lhe deres sabedoria, enviando do alto o teu espírito santo?"
,"18":"Somente assim foram endireitados todos os caminhos de quem vive sobre a Terra. Somente assim os homens aprenderam aquilo que Te agrada. Eles foram salvos por meio da sabedoria»."
}`)
	CurrentBook.AddChapter(10, `{
"1":"A sabedoria protegeu o pai do mundo, o primeiro homem formado por Deus quando foi criado sozinho. Ela libertou-o da sua própria queda,"
,"2":"e deu-lhe força para dominar todas as coisas,"
,"3":"mas um injusto afastou-se dela com a sua cólera e pereceu na sua própria ira fratricida."
,"4":"Por causa dele, a terra foi inundada, mas a sabedoria de novo o salvou, conduzindo o justo numa frágil embarcação."
,"5":"Quando as nações aderiram à maldade e foram confundidas, ela reconheceu o justo e conservou-o sem mancha diante de Deus e manteve-o forte, apesar da sua ternura pelo filho."
,"6":"E enquanto os ímpios pereciam, ela salvou um justo em fuga diante do fogo que caía sobre cinco cidades."
,"7":"Como testemunho dessa gente perversa, resta ainda uma terra deserta e fumegante, com árvores de frutos que não amadurecem, e a estátua de sal que se ergue como lembrança de uma alma incrédula."
,"8":"Porque, desprezando a sabedoria, não só se prejudicaram ignorando o bem, mas deixaram aos insensatos uma lembrança da sua insensatez, para que as suas faltas não ficassem escondidas."
,"9":"A sabedoria, porém, libertou dos sofrimentos os seus fiéis."
,"10":"Por caminhos planos, ela guiou o justo, que fugia da ira do irmão, mostrou-lhe o reino de Deus e revelou-lhe as coisas santas. Deu-lhe sucesso nas suas fadigas e multiplicou os frutos do seu trabalho."
,"11":"Ela protegeu-o contra a cobiça dos seus adversários e tornou-o rico."
,"12":"Ela guardou-o dos seus inimigos e defendeu-o de todos os que lhe armavam ciladas. Deu-lhe a vitória numa dura luta, para lhe mostrar que a piedade é mais forte do que tudo."
,"13":"A sabedoria não abandonou o justo que tinha sido vendido, e preservou-o do pecado."
,"14":"Ela desceu com ele à cisterna, e não o abandonou na prisão, até conseguir para ele o ceptro real e o poder sobre os seus adversários. Desmascarou os que o caluniavam e deu-lhe fama perene."
,"15":"A sabedoria libertou de uma nação de opressores um povo santo, uma raça irrepreensível."
,"16":"Entrou na alma de um servo do Senhor e, com prodígios e sinais, enfrentou reis temíveis."
,"17":"Deu aos santos a recompensa pelos sofrimentos que tinham passado, e guiou-os por um caminho maravilhoso. Tornou-se para eles abrigo durante o dia e esplendor de estrelas durante a noite."
,"18":"Fê-los atravessar o Mar Vermelho e guiou-os através de águas impetuosas."
,"19":"Fez com que os seus inimigos se afogassem, e depois vomitou-os das profundezas do mar."
,"20":"Deste modo, os justos despojaram os injustos, e celebraram o teu santo Nome, Senhor, louvando juntos o teu braço protector."
,"21":"Porque a sabedoria abriu a boca dos mudos e soltou a língua dos pequeninos."
}`)
	CurrentBook.AddChapter(11, `{
"1":"A sabedoria levou a bom termo os empreendimentos do povo por meio de um santo profeta."
,"2":"Eles atravessaram um deserto desabitado, armaram as tendas em lugares inacessíveis,"
,"3":"resistiram aos adversários e repeliram os inimigos."
,"4":"Quando tiveram sede, eles invocaram-Te, e uma rocha escarpada deu-lhes água, uma pedra dura matou-lhes a sede."
,"5":"Aquilo que tinha servido como castigo para os seus inimigos, tornou-se para eles benefício na necessidade."
,"6":"Em lugar da água corrente de um rio, turvado de sangue podre,"
,"7":"como castigo pelo decreto infanticida, Tu deste-lhes inesperadamente água abundante."
,"8":"Pela sede que estavam sentindo, Tu mostraste-lhes como havias castigado os seus inimigos."
,"9":"De facto, quando sentiam provações, embora fossem corrigidos com misericórdia, compreendiam os tormentos dos injustos, que eram julgados com ira."
,"10":"Porque Tu provaste-os como pai que corrige, e castigaste os outros como rei severo que condena."
,"11":"Longe ou perto, foram atingidos do mesmo modo,"
,"12":"porque dupla aflição os oprimiu. E choraram, lembrando-se do que lhes acontecera."
,"13":"De facto, quando souberam que o castigo era fonte de benefício para os outros, sentiram a presença do Senhor."
,"14":"Pois aquele que outrora fora rejeitado, exposto e desprezado com zombarias, no fim dos acontecimentos foi admirado por eles, quando sofreram uma sede diferente da sede dos justos."
,"15":"Por causa dos raciocínios insensatos da sua injustiça, erraram e adoraram répteis privados de razão e animais desprezíveis. Como castigo, enviaste-lhes multidões de animais irracionais,"
,"16":"para aprenderem que cada um é castigado através daquilo com que peca."
,"17":"Para a tua mão omnipotente, que da matéria informe criou o mundo, não teria sido difícil mandar contra eles uma multidão de ursos e leões ferozes,"
,"18":"ou feras desconhecidas e recém-criadas, cheias de furor, espirando hálito de fogo e expelindo turbilhões de vapor pestilento, e lançando pelos olhos relâmpagos terríveis."
,"19":"Animais que não só poderiam exterminá-los com o seu furor, mas aniquilá-los somente com o seu aspecto apavorante."
,"20":"Mesmo sem nada disso, poderiam sucumbir com um sopro apenas, perseguidos pela justiça e espalhados pelo sopro do teu poder. Mas tudo dispuseste com medida, número e peso."
,"21":"Prevalecer com a força é sempre possível para Ti. Quem poderia opor-se ao poder do teu braço?"
,"22":"O mundo inteiro diante de Ti é como um grão de areia na balança, como gota de orvalho matutino a cair sobre a terra."
,"23":"Todavia, Tu tens compaixão de todos, porque podes tudo, e não levas em conta os pecados dos homens, para que eles se arrependam."
,"24":"Tu amas tudo o que existe, e não desprezas nada do que criaste. Se odiasses alguma coisa, não a terias criado."
,"25":"De que modo poderia alguma coisa subsistir, se a não quisesses? Como se poderia conservar alguma coisa se a não tivesses chamado à existência?"
,"26":"Tu, porém, poupas todas as coisas, porque todas Te pertencem, Senhor, que amas a vida."
}`)
	CurrentBook.AddChapter(12, `{
"1":"O teu espírito incorruptível está em todas as coisas,"
,"2":"Por isso, castigas com brandura os que erram. Tu os admoestas, fazendo-lhes lembrar os pecados que cometeram, para que, afastando-se da maldade, acreditem em Ti, Senhor."
,"3":"Tu odiavas os antigos habitantes da tua Terra santa,"
,"4":"porque faziam coisas detestáveis, praticavam magia e ritos sacrílegos."
,"5":"Assassinavam impiedosamente os seus próprios filhos, realizavam banquetes em que devoravam entranhas, carne humana e sangue. A esses iniciados em orgias,"
,"6":"pais assassinos de seres indefesos, Tu os quiseste destruir pela mão dos nossos antepassados."
,"7":"Tudo isto, para que esta Terra, mais estimada por Ti do que qualquer outra, recebesse uma população digna, formada por filhos de Deus."
,"8":"Mas porque também eles eram homens, Tu os trataste com indulgência, mandando vespas contra eles, como precursores do teu exército, a fim de os destruir pouco a pouco."
,"9":"Tu bem podias ter entregue os injustos na mão dos justos durante uma batalha, ou destruí-los com animais ferozes, ou ainda com uma ordem inexorável."
,"10":"Mas Tu castigaste-os pouco a pouco, dando-lhes oportunidade de se arrependerem, embora não ignorasses que vinham de uma raça perversa, que a sua maldade era inata e que nunca mudariam de mentalidade,"
,"11":"porque desde a origem vinham de uma raça mal-dita. Certamente não era por medo de ninguém que Tu não castigaste as suas culpas. "
,"12":"De facto, quem poderia perguntar-Te: «Que foi que fizeste?» Quem ousaria opor-se à tua decisão? Quem Te acusaria por destruíres nações que criaste? Quem se apresentaria contra Ti para defender homens injustos?"
,"13":"Por outro lado, além de Ti, não há outro Deus que cuide de todas as coisas, e diante de quem devas defender-Te da acusação de seres juiz injusto."
,"14":"Nenhum rei ou soberano pode confrontar-se contigo para defender aqueles que castigaste."
,"15":"Tu, porém, és justo, e governas todas as coisas com justiça. Consideras incompatível com o teu poder condenar alguém que não mereça castigo."
,"16":"De facto, a tua força é princípio de justiça, e o teu domínio universal faz que sejas indulgente para com todos."
,"17":"Mostras a tua força a quem não acredita na perfeição do teu poder, e confundes a insolência daqueles que o conhecem."
,"18":"Apesar de tudo, dominas a tua força e julgas com brandura. Tu governas-nos com muita indulgência, porque podes exercer o poder quando queres."
,"19":"Com tal modo de agir, ensinaste ao teu povo que o justo deve amar os homens, e infundiste nos teus filhos a esperança, porque concedes aos homens a possibilidade de se converterem depois de pecar."
,"20":"Puniste os inimigos dos teus filhos com grande brandura e indulgência, dando-lhes tempo e ocasião para se converterem da sua maldade, quando na verdade eram réus de morte."
,"21":"Com quanto maior cuidado julgas os teus filhos, a cujos pais concedeste com juramento a tua aliança, garantia de tão boas promessas!"
,"22":"Assim, para nos educar, castigas os nossos inimigos com moderação, para que quando julgarmos, lembremos sempre a tua bondade; e, quando formos julgados, contemos sempre com a tua misericórdia."
,"23":"Atormentaste os insensatos que viveram vida injusta, castigando-os com as suas próprias abominações."
,"24":"Eles tinham-se extraviado demasiado pelo caminho do erro, considerando como deuses os mais desprezíveis e repugnantes animais, deixando-se enganar como crianças que não têm o uso da razão."
,"25":"Por isso, como crianças que ainda não reflectem, submeteste-os a um julgamento de zombaria."
,"26":"Os que não se corrigissem com o julgamento de zombaria teriam que sofrer um castigo digno, mandado por Deus."
,"27":"De facto, ficaram exasperados com os sofrimentos causados por esses animais, porque foram castigados pelos mesmos seres que consideravam como deuses. Então viram claramente e reconheceram o Deus verdadeiro, que antes recusavam reconhecer. Por isso sobre eles recaiu a maior das condenações."
}`)
	CurrentBook.AddChapter(13, `{
"1":"São naturalmente insensatos todos os homens que ignoram a Deus e que, através dos bens visíveis, não chegam a reconhecer Aquele que existe. Consideram as obras, mas não reconhecem o seu Artífice."
,"2":"E acabam por considerar como deuses e governadores do mundo, o fogo, ou o vento, ou a brisa fugaz, ou o firmamento estrelado, ou a água impetuosa, ou ainda os luzeiros do céu."
,"3":"Se ficam fascinados com a beleza dessas coisas, a ponto de as tomarem por deuses, reconheçam quanto está acima delas o Senhor, pois foi o autor da beleza quem a criou."
,"4":"Se ficam maravilhados com o poder e actividade dessas coisas, pensem então quanto mais poderoso é Aquele que as formou."
,"5":"Sim, porque a grandeza e a beleza das criaturas fazem, por comparação, chegar ao conhecimento do seu Autor."
,"6":"Esses, porém, merecem repreensão menor, porque talvez se tenham extraviado procurando a Deus e querendo encontrá-l'O."
,"7":"Vivendo no meio das suas obras, procuram pesquisá-las, e a aparência delas fascina-os, tanta é a beleza do que se vê."
,"8":"Contudo, mesmo esses não têm desculpa,"
,"9":"porque, se foram capazes de conhecer tanto, a ponto de pesquisar o Universo, por que motivo não encontraram mais depressa o Senhor do Universo?"
,"10":"Infelizes também são aqueles que depositam a sua esperança em coisas mortas, e que invocam como deuses as obras de mãos humanas: coisas de ouro e prata, trabalhadas com arte, figuras de animais, ou uma pedra sem valor, obra de mão antiga."
,"11":"Um carpinteiro, por exemplo, serra uma árvore fácil de manejar. Depois tira-lhe cuidadosamente toda a casca, trabalha a madeira com habilidade e fabrica um móvel, útil para as necessidades da vida."
,"12":"Terminado o trabalho, recolhe as sobras da madeira, emprega-as para cozinhar a comida com que fica saciado."
,"13":"Das sobras de tudo, que não servem para nada, madeira retorcida e cheia de nós, vai-a esculpindo nos momentos de lazer. Para se distrair, modela a madeira com arte, e dá-lhe a forma de um homem,"
,"14":"ou então o aspecto de algum animal desprezível. Depois pinta o ídolo de vermelho e cobre de massa todos os seus defeitos."
,"15":"A seguir, prepara-lhe um nicho digno dele, e fixa-o na parede com um prego."
,"16":"Toma esses cuidados para que não caia, sabendo que o ídolo não pode cuidar de si mesmo: é apenas uma imagem, e precisa de ajuda."
,"17":"Entretanto, logo em seguida dirige-lhe orações pelos seus bens, casamento e filhos, sem se envergonhar de falar com uma coisa sem vida. Para a saúde, invoca o que é frágil."
,"18":"Para a vida, faz súplicas àquilo que é morto. Para um auxílio, pede ajuda àquilo que não tem experiência. Para uma viagem, dirige-se a quem não pode dar um passo."
,"19":"Para os seus negócios, trabalhos e sucesso nos empreendimentos, pede forças a quem não tem força nenhuma nas mãos."
}`)
	CurrentBook.AddChapter(14, `{
"1":"Outro, lançando-se ao mar para navegar sobre ondas encrespadas, invoca um ídolo de madeira, mais frágil do que o barco que o transporta."
,"2":"Ora, o barco foi criado pela ânsia de lucro, e foi a perícia técnica que o construiu."
,"3":"Mas é a tua providência, ó Pai, que o pilota, pois também no mar abriste um caminho, uma rota segura entre as ondas."
,"4":"Fizeste isto para mostrar que podes salvar do perigo, e assim, mesmo sem experiência, qualquer pessoa possa embarcar."
,"5":"Não queres que as obras da tua sabedoria não sirvam para nada. Por isso os homens confiam as suas próprias vidas a um pequeno pedaço de madeira, atravessam as ondas numa frágil embarcação, e chegam salvos ao destino."
,"6":"De facto, no princípio, quando pereciam os orgulhosos gigantes de outrora, a esperança do mundo refugiou-se num pequeno barco que, pilotado pela tua mão, transmitiu ao mundo a semente da vida."
,"7":"Bendita seja a madeira pela qual vem a justiça!"
,"8":"Contudo, maldito seja o ídolo feito por mãos humanas e aquele que o fabricou. Este, por tê-lo feito, e o ídolo, porque, sendo corruptível, foi considerado deus."
,"9":"Sim, porque Deus odeia tanto o idólatra como a idolatria."
,"10":"A obra receberá o mesmo castigo que o seu autor."
,"11":"Por isso, o julgamento atingirá também os ídolos das nações. Porque, entre as criaturas de Deus, eles tornaram-se abomináveis, escândalo para as almas dos homens, e armadilha para os pés dos insensatos."
,"12":"A invenção dos ídolos foi o começo da prostituição e a sua descoberta introduziu a corrupção na vida."
,"13":"Eles não existiam no princípio, e não existirão para sempre."
,"14":"Entraram no mundo por causa da vaidade dos homens, e por isso o seu fim rápido já está decretado."
,"15":"Um pai, atormentado por um luto prematuro, manda fazer uma imagem do filho que tão cedo lhe foi arrebatado. Agora honra como deus aquele que antes era apenas um homem morto, e transmite às pessoas da sua casa ritos secretos e cerimónias."
,"16":"Com o tempo, este costume ímpio foi-se arraigando, e depois foi observado como lei."
,"17":"Era ainda por ordem dos soberanos que se prestava culto às estátuas. Como os súbditos que viviam longe não podiam honrá-los pessoalmente, reproduziram a sua figura distante, fazendo uma imagem visível do rei que veneravam. Deste modo, adulavam o ausente, como se estivesse presente."
,"18":"A ambição do artista promoveu esse culto, mesmo entre aqueles que não conheciam o soberano."
,"19":"De facto, querendo talvez agradar ao soberano, o artista esmerou a sua arte, para torná-lo ainda mais atraente do que na realidade era."
,"20":"A multidão, atraída pelo encanto da obra, considera agora objecto de adoração aquele a quem antes honravam apenas como homem."
,"21":"Isto tornou-se uma cilada para o mundo: homens, escravizados pela desgraça ou pelo poder, impuseram à pedra e à medida o Nome incomunicável."
,"22":"Não bastou a esses homens errar no conhecimento de Deus. Eles vivem também na grande guerra da ignorância, e dão ainda a esses males o nome de paz."
,"23":"Celebram ritos onde matam crianças ou realizam mistérios ocultos, ou fazem banquetes orgiásticos com rituais estranhos."
,"24":"Não conservam pura nem a vida, nem o casamento, e cada um elimina o outro por traição ou aflige-o com o adultério."
,"25":"Por toda a parte há uma grande confusão, sangue e crime, roubo e fraude, corrupção e deslealdade, revolta e perjúrio,"
,"26":"perseguição contra os bons e esquecimento da gratidão, impureza das almas e perversão sexual, desordens no casamento, adultério e libertinagem."
,"27":"A adoração de ídolos sem nome é o princípio, a causa e o fim de todo o mal."
,"28":"De facto, os idólatras entregam-se a divertimentos até ao delírio, ou profetizam a mentira, ou vivem na injustiça, ou perjuram com facilidade."
,"29":"Pondo a sua confiança em ídolos sem vida, não esperam castigo nenhum por terem jurado falso."
,"30":"A sentença, porém, atingi-los-á por dois motivos: porque, seguindo os ídolos, tiveram falsa concepção de Deus, e porque, desprezando a santidade, juraram falso."
,"31":"De facto, o que persegue sempre a transgressão dos injustos não é o poder daqueles por quem se jura, mas o próprio castigo que é reservado aos pecadores."
}`)
	CurrentBook.AddChapter(15, `{
"1":"Tu, porém, nosso Deus, és bom e fiel, és paciente e governas tudo com misericórdia."
,"2":"Mesmo pecando, nós somos teus e conhecemos o teu poder. Sabendo que Te pertencemos, não pecaremos mais."
,"3":"A justiça perfeita está em conhecer-Te e conhecer que o teu poder é a raiz da imortalidade."
,"4":"Não nos extraviamos com a invenção humana de uma arte pervertida, nem com o trabalho estéril dos pintores, que pintam as suas imagens com várias cores."
,"5":"Elas despertam a paixão dos insensatos, que ficam entusiasmados com a forma inerte de uma imagem morta."
,"6":"Aqueles que fazem, desejam e adoram os ídolos, são amantes do mal e dignos da esperança que os ídolos trazem."
,"7":"Amassando com fadiga a terra mole, o oleiro modela para nosso uso todo o tipo de vasos. Com o mesmo barro, modela tanto os vasos que servem para uso nobre, como os destinados para outros fins. O oleiro determina qual deverá ser o uso de cada um deles."
,"8":"Depois, dando-se a um esforço mal empregado, com o mesmo barro modela uma divindade falsa. O oleiro tinha pouco antes nascido da terra, e logo voltará para a terra de onde foi tirado. E então Deus lhe pedirá contas da vida que lhe tinha sido emprestada."
,"9":"Mas ele não se preocupa, com o facto de ter vida breve e depois morrer. Pelo contrário, compete com os que moldam em ouro e prata, imita os que trabalham com bronze, e vangloria-se de fabricar coisas falsas."
,"10":"A sua mente é pura cinza, a sua esperança é mais desprezível que a terra, e a sua vida vale menos do que o barro,"
,"11":"porque não reconhece Aquele que o modelou, lhe infundiu alma activa e lhe inspirou sopro vital."
,"12":"O oleiro considera a nossa vida como um jogo, e a existência como um negócio lucrativo. Ele diz: «É preciso tirar proveito de tudo, até mesmo do mal»."
,"13":"Sim, mais do que todos os outros, esse homem sabe que peca: fabrica de matéria terrestre vasos frágeis e estátuas de ídolos."
,"14":"Mas os inimigos que oprimiram o teu povo são muito mais insensatos e infelizes que a alma de uma criança."
,"15":"De facto, consideraram como deuses todos os ídolos dos pagãos. Os olhos desses ídolos não os ajudam a ver, nem o nariz a respirar o ar, nem os ouvidos a ouvir, nem os dedos das mãos a apalpar, e os seus pés são incapazes de caminhar."
,"16":"Porque foi um homem quem os fez. Quem os modelou foi um ser que recebeu a respiração por empréstimo. Nenhum homem pode plasmar um deus que lhe seja semelhante,"
,"17":"pois, sendo mortal, suas mãos ímpias só podem produzir coisas mortas. O homem é melhor do que os objectos que adora. O homem, pelo menos, tem vida; mas os ídolos jamais a terão."
,"18":"Eles adoram até os mais repugnantes animais que, comparados com outros, são mais estúpidos."
,"19":"Esses animais não têm nenhuma beleza que os torne atraentes, como acontece com os outros animais, e não tiveram o elogio e a bênção de Deus."
}`)
	CurrentBook.AddChapter(16, `{
"1":"Por isso, os egípcios foram justamente castigados com seres semelhantes e atormentados por numerosos animaizinhos."
,"2":"Em vez de tal castigo, beneficiaste o teu povo e, para lhe satisfazer o intenso apetite, deste-lhe codornizes, alimento extraordinário."
,"3":"Deste modo, enquanto os egípcios ficavam famintos e perdiam o apetite natural, enojados com os bichos que lhes tinhas enviado, as pessoas do teu povo, depois de passarem um pouco de necessidade, repartiam entre si um alimento extraordinário."
,"4":"De facto, era preciso que os opressores sofressem carestia inevitável. Ao teu povo, porém, bastava que lhe fosse mostrado como os inimigos eram atormentados."
,"5":"Quando caiu sobre eles a fúria terrível das feras, e morriam mordidos por serpentes tortuosas, a tua cólera não durou até ao fim."
,"6":"Foram assustados por pouco tempo e como correcção, mas receberam um sinal de salvação, para lhes recordar os mandamentos da tua Lei."
,"7":"Quem se voltava para o sinal era salvo, não pelo que via, mas graças a Ti, o Salvador de todos."
,"8":"Deste modo, convenceste os nossos inimigos de que és Tu que livras de todo o mal."
,"9":"Porque eles morreram com as picadas de gafanhotos e moscas, e não houve remédio que os salvasse, pois mereciam ser assim castigados."
,"10":"Quanto aos teus filhos, nem os dentes das serpentes venenosas conseguiram vencê-los, porque a tua misericórdia interveio e os salvou."
,"11":"Para que se lembrassem das tuas palavras, eram mordidos e logo depois curados, para não caírem no profundo esquecimento e serem excluídos dos teus benefícios."
,"12":"Não foi erva nem unguento que os curou, mas a tua Palavra, Senhor, que cura todas as coisas."
,"13":"Sim, porque Tu tens poder sobre a vida e a morte, e fazes descer às portas do reino dos mortos, e de lá subir."
,"14":"O homem, na sua maldade, pode matar, mas não é capaz de fazer voltar o espírito depois de ter saído, nem libertar a alma que entrou no reino dos mortos."
,"15":"É impossível escapar da tua mão."
,"16":"Os injustos recusavam reconhecer-Te, e açoitaste-os com a força do teu braço: foram perseguidos com chuvas estranhas, granizo, tempestades violentas, e devorados pelo fogo."
,"17":"O mais surpreendente foi que, na água que apaga tudo, o fogo ainda ardia mais. É que o universo é aliado dos justos."
,"18":"Às vezes, a chama abrandava para não queimar os animais enviados contra os injustos. Deste modo, eles podiam ver e compreender que estavam a ser perseguidos pelo julgamento de Deus."
,"19":"Outras vezes, mesmo dentro da água, a chama ardia mais forte do que o fogo, para destruir os produtos de uma terra injusta."
,"20":"Ao teu povo acontecia o contrário: Tu alimentava-lo com alimento de anjos, oferecendo-lhe do céu o pão já preparado, que proporcionava todos os sabores e satisfazia o gosto de todos."
,"21":"Esse alimento mostrava a tua doçura para com os teus filhos. Ele adaptava-se ao gosto de quem o comia e transformava-se naquilo que cada um desejava."
,"22":"A neve e o gelo resistiam ao fogo, sem se derreterem. Deste modo, tornou-se claro que o fogo, ardendo no meio do granizo e relampejando no meio da chuva, destruía os frutos dos inimigos."
,"23":"O mesmo fogo, porém, noutra ocasião, esquecia a própria força, para que os justos se pudessem alimentar."
,"24":"De facto, a Criação obedecendo a Ti, seu Criador, inflama-se para punir os injustos, e abranda para beneficiar os que em Ti confiam."
,"25":"Ela também se revestia de todas as formas, colocando-se ao serviço da tua bondade, que a todos alimenta, conforme o desejo de quem está em necessidade."
,"26":"Desta forma, Senhor, os teus filhos queridos aprenderam que não é a produção de frutos que alimenta o homem, mas é a tua Palavra que sustenta os que acreditam em Ti."
,"27":"Pois aquilo que o fogo não devorava, logo se derretia ao calor de um raio de sol."
,"28":"Deste modo, eles aprenderam que é preciso levantar-se antes do nascer do Sol para Te agradecer, e invocar-Te desde o raiar do dia."
,"29":"Também aprenderam que a esperança do ingrato se derrete como a geada do Inverno, e que se espalha como água que não é utilizada."
}`)
	CurrentBook.AddChapter(17, `{
"1":"Os teus julgamentos são grandes e difíceis de compreender. Foi por isso que as almas sem instrução se extraviaram."
,"2":"Os injustos, imaginando que podiam oprimir uma nação santa, ficaram presos pelas trevas, prisioneiros de uma longa noite, fechados nas suas casas e excluídos da providência eterna."
,"3":"Pensavam ficar ocultos com os seus pecados secretos, debaixo do véu sombrio do esquecimento. Mas foram dispersos, mergulhados em horrível medo e aterrorizados por alucinações."
,"4":"Pois nem o esconderijo em que se abrigavam os preservou do medo: ao redor deles, ribombavam ruídos assustadores e apareciam-lhes fantasmas tétricos de rostos sinistros."
,"5":"Nenhum fogo, por mais intenso que fosse, conseguia iluminá-los, nem as luzes brilhantes dos astros conseguiam aclarar aquela noite tenebrosa."
,"6":"Só lhes aparecia uma chama, que se acendia por si mesma, espalhando terror. Quando essa visão desaparecia da frente deles, ficavam aterrorizados e julgavam ainda pior o que tinham acabado de ver."
,"7":"Os artifícios da magia fracassaram completamente, e o seu alarde de ciência ficou vergonhosamente confundido."
,"8":"De facto, aqueles que prometiam expulsar das almas enfermas os terrores e inquietações, caíam eles próprios vítimas de pânico grotesco."
,"9":"Mesmo que nada de inquietante os amedrontasse, ficavam assustados com a passagem de pequenos animais e silvos de cobras. Caíam a tremer e até recusavam contemplar o ar, coisa impossível de ser evitada."
,"10":"Com efeito, a maldade é medrosa e condena-se por seu próprio testemunho. Pressionada pela consciência, imagina sempre o pior."
,"11":"Porque o medo é apenas a falta do socorro que vem da reflexão:"
,"12":"quanto menos reflexão interior tivermos, mais alarmante parecerá ser a causa oculta do tormento."
,"13":"Durante aquela noite de facto impotente, saída das profundezas do impotente reino dos mortos, e todos entregues ao mesmo sono,"
,"14":"eles eram, ora perseguidos por fantasmas monstruosos, ora ficavam paralisados pelo abatimento da alma, invadidos pelo terror inesperado e repentino que caía sobre eles."
,"15":"Assim, todo aquele que caísse, quem quer que fosse, ficava preso e trancado numa prisão sem trancas."
,"16":"Quer fosse agricultor ou pastor, ou operário a trabalhar em lugares desertos, quando surpreendido, caía na fatalidade inevitável, porque todos estavam acorrentados pela mesma corrente de trevas."
,"17":"O assobiar do vento, o canto melodioso de pássaros na ramagem frondosa, o murmúrio da impetuosa água corrente, o ruído surdo de rochas caindo em avalanches,"
,"18":"a correria invisível de animais saltitantes, o rosnar das feras mais selvagens, o eco retumbante das cavernas das montanhas, tudo isso os paralisava e os enchia de terror."
,"19":"Enquanto o mundo inteiro, iluminado por uma luz radiante, se entregava aos seus trabalhos,"
,"20":"somente sobre eles se estendia uma densa noite, imagem das trevas que os deviam receber. Contudo, eles mesmos eram para si próprios mais pesados do que as trevas."
}`)
	CurrentBook.AddChapter(18, `{
"1":"Para os teus santos, porém, havia plena luz. Os outros, que lhes ouviam as vozes mas não lhes viam a figura, julgavam-nos felizes por não sofrerem os mesmos tormentos."
,"2":"Também lhes agradeciam por não se vingarem, apesar de maltratados, e pediam-lhes por favor que se fossem embora."
,"3":"Em vez de trevas, deste aos teus uma coluna de fogo, para os guiar no caminho desconhecido, como sol inofensivo que iluminava a sua gloriosa migração."
,"4":"Os outros mereciam ficar sem luz e aprisionados pelas trevas, porque haviam aprisionado os teus filhos, que iriam transmitir ao mundo a luz incorruptível da tua Lei."
,"5":"Eles decidiram matar os filhos dos santos, e um só menino, abandonado, se salvou. Como castigo, eliminaste a multidão dos seus filhos e fizeste-os morrer a todos nas águas impetuosas."
,"6":"Aquela noite já fora anunciada aos nossos antepassados, para que tivessem ânimo, sabendo com certeza em que promessas haviam acreditado."
,"7":"O teu povo esperava a salvação dos justos e a ruína dos inimigos."
,"8":"E, de facto, enquanto punias os adversários, cobrias-nos de glória, chamando-nos para Ti."
,"9":"Os filhos santos dos justos ofereciam sacrifícios às escondidas e, de comum acordo, estabeleceram esta lei divina: os santos participariam solidariamente dos mesmos bens e perigos. E fariam isso entoando os cânticos dos antepassados."
,"10":"Serviam de eco os gritos confusos dos inimigos, e ressoavam as lamentações dos que choravam os seus filhos."
,"11":"O mesmo castigo atingiu o escravo e o patrão, e o homem comum sofreu a mesma pena que o rei."
,"12":"Todos tinham inúmeros mortos, vítimas do mesmo tipo de morte, e os vivos eram insuficientes para os enterrarem. Num só instante morreu o melhor da sua geração."
,"13":"Embora desacreditassem de tudo por causa da sua magia, quando os seus primogénitos morreram reconheceram que aquele povo era filho de Deus."
,"14":"Enquanto um silêncio profundo envolvia todas as coisas e a noite estava no meio do seu curso,"
,"15":"a tua Palavra todo-poderosa veio do alto do céu, do teu trono real, como guerreiro implacável, e atirou-se sobre uma terra condenada ao extermínio. Trazia, como espada afiada, a tua ordem sem apelação."
,"16":"Parou e encheu tudo de morte: tocava o céu e caminhava sobre a terra."
,"17":"Então, subitamente, fantasmas de sonhos terríveis os abalaram, e terrores inesperados se apoderaram deles."
,"18":"Caíam semimortos por toda a parte, mostrando a causa da sua morte."
,"19":"De facto, sonhos pavorosos já os tinham avisado sobre o acontecimento, para não morrerem sem saber o motivo do seu sofrimento."
,"20":"Também os justos foram atingidos pela provação da morte, e no deserto foi abatido um grupo numeroso. Mas a ira não durou muito tempo,"
,"21":"porque um homem irrepreensível se apressou em defendê-los. Manejando as armas do seu ministério sacerdotal, a oração e o incenso pelos pecados, enfrentou a ira divina e pôs fim à desgraça, mostrando que era teu servo."
,"22":"Venceu a ira divina, não com a força do corpo, nem com o poder das armas. Ele venceu com a palavra que aplacou Aquele que castigava, recordando-Lhe as promessas e as alianças feitas com os antepassados."
,"23":"Os mortos tinham caído aos montes, uns sobre os outros. Ele, porém, colocou-se no meio deles, deteve a ira e barrou-lhe o caminho, para que não atingisse os sobreviventes."
,"24":"Sobre a sua longa veste estava o mundo inteiro: em quatro fileiras de pedras preciosas estavam inscritos os nomes gloriosos dos antepassados, e sobre a coroa da sua cabeça estava a tua majestade."
,"25":"Diante disso tudo, o exterminador recuou com medo. A simples experiência da ira já fora suficiente."
}`)
	CurrentBook.AddChapter(19, `{
"1":"Contra os injustos, porém, a ira divina foi implacável até ao fim. Porque Deus sabia de antemão o que iriam fazer."
,"2":"Eles iriam permitir que os justos saíssem, e até insistiriam para que partissem quanto antes. Depois, mudariam de opinião e persegui-los-iam."
,"3":"De facto, ainda estavam de luto, a chorar junto dos túmulos de seus mortos, quando tomaram uma decisão insensata: perseguiram como fugitivos aqueles a quem antes tinham dito para partirem."
,"4":"O destino merecido arrastava-os para esse desfecho, e fazia-lhes esquecer o que já lhes havia acontecido. Deste modo, estavam acrescentando aos seus sofrimentos o castigo que faltava."
,"5":"Enquanto o teu povo faria a experiência de uma viagem maravilhosa, eles encontrariam morte nunca vista."
,"6":"Porque a Criação inteira, obedecendo às tuas ordens, tomava novas formas segundo o seu género, para que os teus filhos fossem preservados, sãos e salvos."
,"7":"Apareceu a nuvem, que cobriu de sombra o acampamento, e a terra firme surgiu, onde antes era água. O Mar Vermelho transformou-se em caminho livre, e as ondas violentas tornaram-se planície verdejante."
,"8":"Através dele passou todo o teu povo, protegido pela tua mão e contemplando prodígios admiráveis."
,"9":"Como cavalos conduzidos ao pasto e como ovelhas saltitantes, todos cantavam hinos a Ti, Senhor, seu libertador."
,"10":"Lembravam-se ainda do que acontecera durante o exílio: em lugar de animais, a terra produziu moscas; em vez de peixes, o rio vomitou uma multidão de rãs."
,"11":"Mais tarde, viram também uma nova espécie de aves quando, levados pelo desejo, pediram alimentos delicados."
,"12":"Para os satisfazer, do mar subiram codornizes."
,"13":"Sobre os pecadores caíram castigos, antecipados pelo aviso prévio de raios estrondosos. Eles sofreram justamente, por causa da sua própria perversidade, por terem odiado cruelmente os estrangeiros."
,"14":"Outros povos não acolheram visitantes desconhecidos. Os egípcios, porém, escravizaram estrangeiros benfeitores."
,"15":"E mais ainda: é certo que para os outros povos haverá um castigo por terem recebido hostilmente os estrangeiros."
,"16":"Os egípcios, porém, depois de receberem os estrangeiros com festas e de os fazer participar nos seus direitos, acabaram por atormentar esses estrangeiros com trabalhos duríssimos."
,"17":"Por isso, foram feridos de cegueira, como tinha acontecido com aqueles junto à porta do justo, quando, cercados de trevas profundas, cada um procurava, tacteando, a direcção da sua própria casa."
,"18":"Os elementos da natureza trocavam as suas propriedades entre si, da mesma forma que na harpa as notas modificam o desenvolvimento da música, mas conservando sempre o mesmo tom. É o que se pode ver claramente quando se considera o que aconteceu:"
,"19":"os seres terrestres transformavam-se em aquáticos, e os que nadam saltavam para a terra."
,"20":"Na água, o fogo aumentava mais ainda a sua força, e a água esquecia-se do poder que tem de o apagar."
,"21":"Por outro lado, as chamas não queimavam a carne dos animais que andavam entre elas, e também não derretiam aquele alimento celeste, parecido com gelo e fácil de derreter."
,"22":"Sim, ó Senhor! De todos os modos engrandeceste e tornaste glorioso o teu povo. Nunca, em nenhum lugar, deixaste de olhar por ele e de o socorrer."
}`)

}
